-- MySQL dump 10.13  Distrib 5.1.49, for debian-linux-gnu (x86_64)
--
-- Host: localhost    Database: 
-- ------------------------------------------------------
-- Server version	5.1.49-3

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Current Database: `mercury`
--

CREATE DATABASE /*!32312 IF NOT EXISTS*/ `mercury` /*!40100 DEFAULT CHARACTER SET latin1 */;

USE `mercury`;

--
-- Table structure for table `actions`
--

DROP TABLE IF EXISTS `actions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `actions` (
  `aid` varchar(255) NOT NULL DEFAULT '0' COMMENT 'Primary Key: Unique actions ID.',
  `type` varchar(32) NOT NULL DEFAULT '' COMMENT 'The object that that action acts on (node, user, comment, system or custom types.)',
  `callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'The callback function that executes when the action runs.',
  `parameters` longblob NOT NULL COMMENT 'Parameters to be passed to the callback function.',
  `label` varchar(255) NOT NULL DEFAULT '0' COMMENT 'Label of the action.',
  PRIMARY KEY (`aid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores action information.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `actions`
--

LOCK TABLES `actions` WRITE;
/*!40000 ALTER TABLE `actions` DISABLE KEYS */;
INSERT INTO `actions` VALUES ('comment_publish_action','comment','comment_publish_action','','Publish comment'),('comment_save_action','comment','comment_save_action','','Save comment'),('comment_unpublish_action','comment','comment_unpublish_action','','Unpublish comment'),('node_make_sticky_action','node','node_make_sticky_action','','Make content sticky'),('node_make_unsticky_action','node','node_make_unsticky_action','','Make content unsticky'),('node_promote_action','node','node_promote_action','','Promote content to front page'),('node_publish_action','node','node_publish_action','','Publish content'),('node_save_action','node','node_save_action','','Save content'),('node_unpromote_action','node','node_unpromote_action','','Remove content from front page'),('node_unpublish_action','node','node_unpublish_action','','Unpublish content'),('pathauto_node_update_action','node','pathauto_node_update_action','','Update node alias'),('pathauto_taxonomy_term_update_action','taxonomy_term','pathauto_taxonomy_term_update_action','','Update taxonomy term alias'),('pathauto_user_update_action','user','pathauto_user_update_action','','Update user alias'),('system_block_ip_action','user','system_block_ip_action','','Ban IP address of current user'),('user_block_user_action','user','user_block_user_action','','Block current user');
/*!40000 ALTER TABLE `actions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `authmap`
--

DROP TABLE IF EXISTS `authmap`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `authmap` (
  `aid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique authmap ID.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'User’s users.uid.',
  `authname` varchar(128) NOT NULL DEFAULT '' COMMENT 'Unique authentication name.',
  `module` varchar(128) NOT NULL DEFAULT '' COMMENT 'Module which is controlling the authentication.',
  PRIMARY KEY (`aid`),
  UNIQUE KEY `authname` (`authname`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores distributed authentication mapping.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `authmap`
--

LOCK TABLES `authmap` WRITE;
/*!40000 ALTER TABLE `authmap` DISABLE KEYS */;
/*!40000 ALTER TABLE `authmap` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `batch`
--

DROP TABLE IF EXISTS `batch`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `batch` (
  `bid` int(10) unsigned NOT NULL COMMENT 'Primary Key: Unique batch ID.',
  `token` varchar(64) NOT NULL COMMENT 'A string token generated against the current user’s session id and the batch id, used to ensure that only the user who submitted the batch can effectively access it.',
  `timestamp` int(11) NOT NULL COMMENT 'A Unix timestamp indicating when this batch was submitted for processing. Stale batches are purged at cron time.',
  `batch` longblob COMMENT 'A serialized array containing the processing data for the batch.',
  PRIMARY KEY (`bid`),
  KEY `token` (`token`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores details about batches (processes that run in...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `batch`
--

LOCK TABLES `batch` WRITE;
/*!40000 ALTER TABLE `batch` DISABLE KEYS */;
/*!40000 ALTER TABLE `batch` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `block`
--

DROP TABLE IF EXISTS `block`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block` (
  `bid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique block ID.',
  `module` varchar(64) NOT NULL DEFAULT '' COMMENT 'The module from which the block originates; for example, ’user’ for the Who’s Online block, and ’block’ for any custom blocks.',
  `delta` varchar(32) NOT NULL DEFAULT '0' COMMENT 'Unique ID for block within a module.',
  `theme` varchar(64) NOT NULL DEFAULT '' COMMENT 'The theme under which the block settings apply.',
  `status` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Block enabled status. (1 = enabled, 0 = disabled)',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Block weight within region.',
  `region` varchar(64) NOT NULL DEFAULT '' COMMENT 'Theme region within which the block is set.',
  `custom` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Flag to indicate how users may control visibility of the block. (0 = Users cannot control, 1 = On by default, but can be hidden, 2 = Hidden by default, but can be shown)',
  `visibility` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Flag to indicate how to show blocks on pages. (0 = Show on all pages except listed pages, 1 = Show only on listed pages, 2 = Use custom PHP code to determine visibility)',
  `pages` text NOT NULL COMMENT 'Contents of the "Pages" block; contains either a list of paths on which to include/exclude the block or PHP code, depending on "visibility" setting.',
  `title` varchar(64) NOT NULL DEFAULT '' COMMENT 'Custom title for the block. (Empty string will use block default title, <none> will remove the title, text will cause block to use specified title.)',
  `cache` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'Binary flag to indicate block cache mode. (-2: Custom cache, -1: Do not cache, 1: Cache per role, 2: Cache per user, 4: Cache per page, 8: Block cache global) See DRUPAL_CACHE_* constants in ../includes/common.inc for more detailed information.',
  PRIMARY KEY (`bid`),
  UNIQUE KEY `tmd` (`theme`,`module`,`delta`),
  KEY `list` (`theme`,`status`,`region`,`weight`,`module`)
) ENGINE=MyISAM AUTO_INCREMENT=130 DEFAULT CHARSET=utf8 COMMENT='Stores block settings, such as region and visibility...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block`
--

LOCK TABLES `block` WRITE;
/*!40000 ALTER TABLE `block` DISABLE KEYS */;
INSERT INTO `block` VALUES (1,'system','main','bartik',1,0,'content',0,0,'','',-1),(2,'search','form','bartik',0,-1,'-1',0,0,'','',-1),(3,'node','recent','seven',1,10,'dashboard_main',0,0,'','',-1),(4,'user','login','bartik',1,0,'sidebar_first',0,0,'','',-1),(5,'system','navigation','bartik',1,0,'sidebar_first',0,0,'','',-1),(6,'system','powered-by','bartik',1,10,'footer',0,0,'','',-1),(7,'system','help','bartik',1,0,'help',0,0,'','',-1),(8,'system','main','seven',1,0,'content',0,0,'','',-1),(9,'system','help','seven',1,0,'help',0,0,'','',-1),(10,'user','login','seven',1,10,'content',0,0,'','',-1),(11,'user','new','seven',1,0,'dashboard_sidebar',0,0,'','',-1),(12,'search','form','seven',1,-10,'dashboard_sidebar',0,0,'','',-1),(13,'comment','recent','bartik',0,0,'-1',0,0,'','',1),(14,'node','syndicate','bartik',0,0,'-1',0,0,'','',-1),(15,'node','recent','bartik',0,0,'-1',0,0,'','',1),(16,'shortcut','shortcuts','bartik',0,0,'-1',0,0,'','',-1),(17,'system','management','bartik',0,0,'-1',0,0,'','',-1),(18,'system','user-menu','bartik',0,0,'-1',0,0,'','',-1),(19,'system','main-menu','bartik',0,0,'-1',0,0,'','',-1),(20,'user','new','bartik',0,0,'-1',0,0,'','',1),(21,'user','online','bartik',0,0,'-1',0,0,'','',-1),(22,'comment','recent','seven',1,0,'dashboard_inactive',0,0,'','',1),(23,'node','syndicate','seven',0,0,'-1',0,0,'','',-1),(24,'shortcut','shortcuts','seven',0,0,'-1',0,0,'','',-1),(25,'system','powered-by','seven',0,10,'-1',0,0,'','',-1),(26,'system','navigation','seven',0,0,'-1',0,0,'','',-1),(27,'system','management','seven',0,0,'-1',0,0,'','',-1),(28,'system','user-menu','seven',0,0,'-1',0,0,'','',-1),(29,'system','main-menu','seven',0,0,'-1',0,0,'','',-1),(30,'user','online','seven',1,0,'dashboard_inactive',0,0,'','',-1),(31,'comment','recent','mercury',0,0,'-1',0,0,'','',1),(32,'node','recent','mercury',0,0,'-1',0,0,'','',1),(33,'node','syndicate','mercury',0,0,'-1',0,0,'','',-1),(34,'search','form','mercury',0,-17,'-1',0,0,'','',-1),(35,'shortcut','shortcuts','mercury',0,0,'-1',0,0,'','',-1),(36,'system','help','mercury',1,0,'help',0,0,'','',-1),(37,'system','main','mercury',1,-13,'content',0,0,'','',-1),(38,'system','main-menu','mercury',0,0,'-1',0,0,'','',-1),(39,'system','management','mercury',0,0,'-1',0,0,'','',-1),(40,'system','navigation','mercury',0,-9,'-1',0,0,'','',-1),(41,'system','powered-by','mercury',0,-8,'-1',0,0,'','',-1),(42,'system','user-menu','mercury',0,0,'-1',0,0,'','',-1),(43,'user','login','mercury',0,0,'-1',0,0,'','',-1),(44,'user','new','mercury',0,0,'-1',0,0,'','',1),(45,'user','online','mercury',0,0,'-1',0,0,'','',-1),(46,'block','1','bartik',0,0,'-1',0,0,'','',-1),(47,'block','1','mercury',0,0,'-1',0,0,'','',-1),(48,'block','1','seven',0,0,'-1',0,0,'','',-1),(49,'block','2','bartik',0,0,'-1',0,0,'','',-1),(50,'block','2','mercury',0,0,'-1',0,0,'','',-1),(51,'block','2','seven',0,0,'-1',0,0,'','',-1),(52,'block','3','bartik',0,0,'-1',0,0,'test','',-1),(53,'block','3','mercury',1,0,'header_top_right',0,0,'test','',-1),(54,'block','3','seven',0,0,'-1',0,0,'test','',-1),(55,'zaloni_utilities','form','bartik',0,0,'-1',0,0,'','',-1),(56,'zaloni_utilities','form','mercury',0,0,'-1',0,0,'','',-1),(57,'zaloni_utilities','form','seven',1,0,'dashboard_inactive',0,0,'','',-1),(58,'mercury_utilities','form','bartik',0,0,'-1',0,0,'','',-1),(59,'mercury_utilities','form','mercury',0,0,'-1',0,0,'','',-1),(60,'mercury_utilities','form','seven',1,0,'dashboard_inactive',0,0,'','',-1),(61,'menu','menu-mercury-navigation','mercury',1,-14,'sidebar_first',0,0,'','',-1),(62,'menu','menu-selector-tool','mercury',0,-19,'-1',0,1,'<front>','',-1),(63,'menu','menu-bulk-action-tool','mercury',0,-11,'-1',0,1,'test','',-1),(64,'menu','menu-bulk-action-tool','bartik',0,0,'-1',0,1,'test','',-1),(65,'menu','menu-mercury-navigation','bartik',0,0,'-1',0,0,'','',-1),(66,'menu','menu-selector-tool','bartik',0,0,'-1',0,1,'<front>','',-1),(67,'menu','menu-bulk-action-tool','seven',0,0,'-1',0,1,'test','',-1),(68,'menu','menu-mercury-navigation','seven',0,0,'-1',0,0,'','',-1),(69,'menu','menu-selector-tool','seven',0,0,'-1',0,1,'<front>','',-1),(70,'logintoboggan','logintoboggan_logged_in','bartik',0,0,'-1',0,0,'','',-1),(71,'logintoboggan','logintoboggan_logged_in','mercury',0,0,'-1',0,0,'','',-1),(72,'logintoboggan','logintoboggan_logged_in','seven',0,0,'-1',0,0,'','',-1),(73,'views','devices-block','mercury',1,-12,'content',0,1,'host/*','',-1),(74,'views','devices-block','bartik',0,0,'-1',0,1,'host/*','',-1),(75,'views','devices-block','seven',0,0,'-1',0,1,'host/*','',-1),(76,'views','all_host-block','bartik',0,0,'-1',0,0,'','',-1),(77,'views','all_host-block','mercury',0,0,'-1',0,0,'','',-1),(78,'views','all_host-block','seven',0,0,'-1',0,0,'','',-1),(79,'views','all_vm-block','bartik',0,0,'-1',0,0,'','',-1),(80,'views','all_vm-block','mercury',0,0,'-1',0,0,'','',-1),(81,'views','all_vm-block','seven',0,0,'-1',0,0,'','',-1),(82,'menu','menu-refine','mercury',0,-18,'-1',0,1,'<front>','',-1),(83,'menu','menu-refine','bartik',0,0,'-1',0,1,'<front>','',-1),(84,'menu','menu-refine','seven',0,0,'-1',0,1,'<front>','',-1),(85,'block','4','bartik',0,0,'-1',0,0,'','',-1),(86,'block','4','mercury',1,-14,'title_right',0,0,'','',-1),(87,'block','4','seven',0,0,'-1',0,0,'','',-1),(88,'views','vm_metric_per_host-block','bartik',0,0,'-1',0,0,'','',-1),(89,'views','vm_metric_per_host-block','mercury',0,0,'-1',0,0,'','',-1),(90,'views','vm_metric_per_host-block','seven',0,0,'-1',0,0,'','',-1),(91,'block','5','bartik',0,0,'-1',0,1,'virtual-machine/*\r\nvirtual_machine/*/historical_performance\r\nvirtual_machine/*/vm_disks\r\nnode/*','Show me',-1),(92,'block','5','mercury',1,-13,'sidebar_first',0,1,'virtual-machine/*\r\nvirtual_machine/*/historical_performance\r\nvirtual_machine/*/vm_disks\r\nnode/*','Show me',-1),(93,'block','5','seven',0,0,'-1',0,1,'virtual-machine/*\r\nvirtual_machine/*/historical_performance\r\nvirtual_machine/*/vm_disks\r\nnode/*','Show me',-1),(94,'block','6','bartik',0,0,'-1',0,1,'virtual_machine/*/historical_performance','',-1),(95,'block','6','mercury',1,0,'title_right',0,1,'virtual_machine/*/historical_performance','',-1),(96,'block','6','seven',0,0,'-1',0,1,'virtual_machine/*/historical_performance','',-1),(97,'block','7','bartik',0,0,'-1',0,0,'','',-1),(98,'block','7','mercury',1,0,'title_right',0,0,'','',-1),(99,'block','7','seven',0,0,'-1',0,0,'','',-1),(100,'mercury_utilities','home_page_block','bartik',0,0,'-1',0,0,'','',-1),(101,'mercury_utilities','bulk_actions_block','bartik',0,0,'-1',0,1,'home\r\n<front>','',-1),(102,'mercury_utilities','home_page_block','mercury',0,0,'-1',0,0,'','',-1),(103,'mercury_utilities','bulk_actions_block','mercury',0,-15,'-1',0,1,'home\r\n<front>','',-1),(104,'mercury_utilities','home_page_block','seven',1,0,'dashboard_inactive',0,0,'','',-1),(105,'mercury_utilities','bulk_actions_block','seven',1,0,'dashboard_inactive',0,1,'home\r\n<front>','',-1),(106,'mercury_utilities','ongoing_processes_block','bartik',0,0,'-1',0,0,'','',-1),(107,'mercury_utilities','ongoing_processes_block','mercury',0,0,'-1',0,0,'','',-1),(108,'mercury_utilities','ongoing_processes_block','seven',1,0,'dashboard_inactive',0,0,'','',-1),(109,'search_api_page','search','bartik',0,0,'-1',0,0,'','',1),(110,'search_api_page','search','mercury',0,-18,'-1',0,0,'','',1),(111,'search_api_page','search','seven',0,0,'-1',0,0,'','',1),(112,'mercury_utilities','select_vm_block','bartik',0,0,'-1',0,1,'<front>\r\nvm-inventory\r\nvm-inventory/*','',-1),(113,'mercury_utilities','select_host_block','bartik',0,0,'-1',0,1,'host-inventory\r\nhost-inventory/*','',-1),(114,'mercury_utilities','select_vm_block','mercury',1,-20,'sidebar_first',0,1,'<front>\r\nvm-inventory\r\nvm-inventory/*','',-1),(115,'mercury_utilities','select_host_block','mercury',1,-18,'sidebar_first',0,1,'host-inventory\r\nhost-inventory/*','',-1),(116,'mercury_utilities','select_vm_block','seven',1,0,'dashboard_inactive',0,1,'<front>\r\nvm-inventory\r\nvm-inventory/*','',-1),(117,'mercury_utilities','select_host_block','seven',1,0,'dashboard_inactive',0,1,'host-inventory\r\nhost-inventory/*','',-1),(118,'mercury_utilities','bulk_actions_vm_block','bartik',0,0,'-1',0,1,'<front>\r\nvm-inventory\r\nvm-inventory/*','',-1),(119,'mercury_utilities','bulk_actions_host_block','bartik',0,0,'-1',0,1,'host-inventory\r\nhost-inventory/*','',-1),(120,'mercury_utilities','bulk_actions_vm_block','mercury',1,-19,'sidebar_first',0,1,'<front>\r\nvm-inventory\r\nvm-inventory/*','',-1),(121,'mercury_utilities','bulk_actions_host_block','mercury',1,-17,'sidebar_first',0,1,'host-inventory\r\nhost-inventory/*','',-1),(122,'mercury_utilities','bulk_actions_vm_block','seven',1,0,'dashboard_inactive',0,1,'<front>\r\nvm-inventory\r\nvm-inventory/*','',-1),(123,'mercury_utilities','bulk_actions_host_block','seven',1,0,'dashboard_inactive',0,1,'host-inventory\r\nhost-inventory/*','',-1),(124,'mercury_utilities','select_disk_block','mercury',1,-16,'sidebar_first',0,1,'virtual_machine/*/vm_disks','',-1),(125,'mercury_utilities','select_disk_block','bartik',0,0,'-1',0,1,'virtual_machine/*/vm_disks','',-1),(126,'mercury_utilities','select_disk_block','seven',1,0,'dashboard_inactive',0,1,'virtual_machine/*/vm_disks','',-1),(127,'mercury_utilities','bulk_actions_vdisk_block','bartik',0,0,'-1',0,1,'virtual_machine/*/vm_disks','',-1),(128,'mercury_utilities','bulk_actions_vdisk_block','mercury',1,-15,'sidebar_first',0,1,'virtual_machine/*/vm_disks','',-1),(129,'mercury_utilities','bulk_actions_vdisk_block','seven',1,0,'dashboard_inactive',0,1,'virtual_machine/*/vm_disks','',-1);
/*!40000 ALTER TABLE `block` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `block_class`
--

DROP TABLE IF EXISTS `block_class`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block_class` (
  `module` varchar(64) NOT NULL DEFAULT '' COMMENT 'The module to which the block belongs.',
  `delta` varchar(32) NOT NULL DEFAULT '' COMMENT 'The ID of the module’s block.',
  `css_class` varchar(255) NOT NULL DEFAULT '' COMMENT 'String containing the classes for the block.',
  PRIMARY KEY (`module`,`delta`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block_class`
--

LOCK TABLES `block_class` WRITE;
/*!40000 ALTER TABLE `block_class` DISABLE KEYS */;
INSERT INTO `block_class` VALUES ('block','4','vm-node-edit-refresh'),('menu','menu-selector-tool','selector-tool');
/*!40000 ALTER TABLE `block_class` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `block_custom`
--

DROP TABLE IF EXISTS `block_custom`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block_custom` (
  `bid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The block’s block.bid.',
  `body` longtext COMMENT 'Block contents.',
  `info` varchar(128) NOT NULL DEFAULT '' COMMENT 'Block description.',
  `format` varchar(255) DEFAULT NULL COMMENT 'The filter_format.format of the block body.',
  PRIMARY KEY (`bid`),
  UNIQUE KEY `info` (`info`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8 COMMENT='Stores contents of custom-made blocks.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block_custom`
--

LOCK TABLES `block_custom` WRITE;
/*!40000 ALTER TABLE `block_custom` DISABLE KEYS */;
INSERT INTO `block_custom` VALUES (1,'<span style=\"float: left\">\r\n<?php \r\n$versionStr = exec(\'dpkg -l | grep fmc\', $result);\r\n$versionArr = explode (\" \", $versionStr);\r\n//print_r($versionArr);\r\nprint  $versionArr[31] ;\r\n?>\r\n</span>\r\n<span style=\"float: right\">\r\n<!--<?php print  \"<a href=\'\" . base_path() . \"user/logout\'>Logout</a>\"?>-->\r\n<?php print date(\'m/d/Y H:i\'); ?>\r\n</span>','footer-logo','php_code'),(2,'<?php $result = mercury_utilities_total_node_counter(); \r\n          $total_host = $result[\'total_host\'];\r\n          $total_vm = $result[\'total_vm\'];\r\n          $total_vdisk = $result[\'total_vdisk\'];\r\n          $total_flash_device = $result[\'total_flash_device\'];\r\n          $total_flash_vm = $result[\'total_flash_vm\'];\r\n$last_discovery = variable_get(\'time_from_last_discovery\', \'\');\r\n$cur_time = strtotime(\'now\');\r\n$time_diff= $cur_time-$last_discovery;\r\nif ($time_diff > 86400){\r\n$rediscovery_time = date_calc_diff($last_discovery, $cur_time, false, false, true, false, false, false);\r\n\r\n}else{\r\n$rediscovery_time = date_calc_diff($last_discovery, $cur_time, false, false, false, true, true, false);\r\n\r\n}\r\n?>\r\n<div class=\"header-menu-item host\"><?php print \'Hosts: \' . $total_host;?></td></tr></table></div>\r\n<div class=\"header-menu-item flash-accel\"><?php print  \" Flash Accel Hosts: \" . $total_flash_device;?></div>\r\n<div class=\"header-menu-item vm\"><?php print \"VMs: \" . $total_vm;?></div>\r\n<div class=\"header-menu-item v-center\"><?php print \'Flash Accel VMs: \' .  $total_flash_vm;?></div>\r\n<?php if($last_discovery == \'\' || $rediscovery_time == 0) { ?>\r\n<div class=\"header-menu-item last-discovery\">0 Hours 0 Minutes Since Last Discovery</div>\r\n<?php } else { ?>\r\n<div class=\"header-menu-item last-discovery\"><?php print $rediscovery_time . \' Since Last Discovery\';?></div>\r\n<?php } \r\n$rediscover_image = \'<img src=\"\' .base_path(). path_to_theme() . \'/images/rediscover.png\" alt=\"logo\" title=\"logo\"/>\';\r\nif (filter_xss(arg(3))==\"cron_job\") {\r\n?>\r\n<div class=\"header-menu-item rediscover\"><?php print  ctools_popups_mmc_rediscover_link($rediscover_image, \'\', \'\',\'Rediscover\') ?></div>\r\n<?php\r\n}\r\n?>','header-menu','php_code'),(3,'<?php\r\n  mercury_fmcdb_header_stats_block();\r\n ?>','jump-to-header-right-block','php_code'),(4,'<?php\r\nmercury_fmcdb_vm_node_links();\r\n?>','VM node edit/refresh links','php_code'),(5,'<?php\r\n  mercury_fmcdb_vm_show_me();\r\n?>\r\n','VM page links','php_code'),(6,'<?php\r\nmercury_fmcdb_vm_performance_link();\r\n?>','VM historical performance edit link','php_code'),(7,'<?php\r\nmercury_fmcdb_host_node_links();\r\n?>','Host node edit/refresh links','php_code');
/*!40000 ALTER TABLE `block_custom` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `block_node_type`
--

DROP TABLE IF EXISTS `block_node_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block_node_type` (
  `module` varchar(64) NOT NULL COMMENT 'The block’s origin module, from block.module.',
  `delta` varchar(32) NOT NULL COMMENT 'The block’s unique delta within module, from block.delta.',
  `type` varchar(32) NOT NULL COMMENT 'The machine-readable name of this type from node_type.type.',
  PRIMARY KEY (`module`,`delta`,`type`),
  KEY `type` (`type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Sets up display criteria for blocks based on content types';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block_node_type`
--

LOCK TABLES `block_node_type` WRITE;
/*!40000 ALTER TABLE `block_node_type` DISABLE KEYS */;
INSERT INTO `block_node_type` VALUES ('block','4','virtual_machine'),('block','7','host');
/*!40000 ALTER TABLE `block_node_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `block_role`
--

DROP TABLE IF EXISTS `block_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block_role` (
  `module` varchar(64) NOT NULL COMMENT 'The block’s origin module, from block.module.',
  `delta` varchar(32) NOT NULL COMMENT 'The block’s unique delta within module, from block.delta.',
  `rid` int(10) unsigned NOT NULL COMMENT 'The user’s role ID from users_roles.rid.',
  PRIMARY KEY (`module`,`delta`,`rid`),
  KEY `rid` (`rid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Sets up access permissions for blocks based on user roles';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block_role`
--

LOCK TABLES `block_role` WRITE;
/*!40000 ALTER TABLE `block_role` DISABLE KEYS */;
INSERT INTO `block_role` VALUES ('block','2',2),('block','3',2),('menu','menu-bulk-action-tool',2),('menu','menu-mercury-navigation',2),('menu','menu-refine',2),('menu','menu-refine',3),('menu','menu-selector-tool',2),('mercury_utilities','select_disk_block',2),('mercury_utilities','select_host_block',2),('mercury_utilities','select_vm_block',2),('search','form',2),('search_api_page','search',2);
/*!40000 ALTER TABLE `block_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `blocked_ips`
--

DROP TABLE IF EXISTS `blocked_ips`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `blocked_ips` (
  `iid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: unique ID for IP addresses.',
  `ip` varchar(40) NOT NULL DEFAULT '' COMMENT 'IP address',
  PRIMARY KEY (`iid`),
  KEY `blocked_ip` (`ip`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores blocked IP addresses.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `blocked_ips`
--

LOCK TABLES `blocked_ips` WRITE;
/*!40000 ALTER TABLE `blocked_ips` DISABLE KEYS */;
/*!40000 ALTER TABLE `blocked_ips` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache`
--

DROP TABLE IF EXISTS `cache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Generic cache table for caching things not separated out...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache`
--

LOCK TABLES `cache` WRITE;
/*!40000 ALTER TABLE `cache` DISABLE KEYS */;
INSERT INTO `cache` VALUES ('node_types:en','O:8:\"stdClass\":2:{s:5:\"types\";a:12:{s:5:\"panel\";O:8:\"stdClass\":16:{s:4:\"name\";s:5:\"Panel\";s:4:\"base\";s:16:\"panels_node_hook\";s:10:\"body_label\";s:6:\"Teaser\";s:11:\"description\";s:47:\"A panel layout broken up into rows and columns.\";s:4:\"type\";s:5:\"panel\";s:4:\"help\";s:0:\"\";s:6:\"custom\";i:0;s:8:\"modified\";i:0;s:6:\"locked\";i:1;s:8:\"disabled\";b:0;s:6:\"is_new\";i:1;s:9:\"has_title\";i:1;s:11:\"title_label\";s:5:\"Title\";s:6:\"module\";s:11:\"panels_node\";s:9:\"orig_type\";s:5:\"panel\";s:16:\"disabled_changed\";b:0;}s:7:\"article\";O:8:\"stdClass\":14:{s:4:\"type\";s:7:\"article\";s:4:\"name\";s:7:\"Article\";s:4:\"base\";s:12:\"node_content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:89:\"Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.\";s:4:\"help\";s:0:\"\";s:9:\"has_title\";s:1:\"1\";s:11:\"title_label\";s:5:\"Title\";s:6:\"custom\";s:1:\"1\";s:8:\"modified\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:8:\"disabled\";s:1:\"0\";s:9:\"orig_type\";s:7:\"article\";s:16:\"disabled_changed\";b:0;}s:11:\"data_center\";O:8:\"stdClass\":14:{s:4:\"type\";s:11:\"data_center\";s:4:\"name\";s:11:\"Data Center\";s:4:\"base\";s:12:\"node_content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:0:\"\";s:4:\"help\";s:0:\"\";s:9:\"has_title\";s:1:\"1\";s:11:\"title_label\";s:16:\"Data Center Name\";s:6:\"custom\";s:1:\"1\";s:8:\"modified\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:8:\"disabled\";s:1:\"0\";s:9:\"orig_type\";s:11:\"data_center\";s:16:\"disabled_changed\";b:0;}s:6:\"device\";O:8:\"stdClass\":14:{s:4:\"type\";s:6:\"device\";s:4:\"name\";s:6:\"Device\";s:4:\"base\";s:12:\"node_content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:42:\"A physical hard drive available to a host.\";s:4:\"help\";s:0:\"\";s:9:\"has_title\";s:1:\"1\";s:11:\"title_label\";s:11:\"Device Name\";s:6:\"custom\";s:1:\"1\";s:8:\"modified\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:8:\"disabled\";s:1:\"0\";s:9:\"orig_type\";s:6:\"device\";s:16:\"disabled_changed\";b:0;}s:4:\"host\";O:8:\"stdClass\":14:{s:4:\"type\";s:4:\"host\";s:4:\"name\";s:4:\"Host\";s:4:\"base\";s:12:\"node_content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:29:\"An ESXi 5.0 host on a vCenter\";s:4:\"help\";s:0:\"\";s:9:\"has_title\";s:1:\"1\";s:11:\"title_label\";s:5:\"Title\";s:6:\"custom\";s:1:\"1\";s:8:\"modified\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:8:\"disabled\";s:1:\"0\";s:9:\"orig_type\";s:4:\"host\";s:16:\"disabled_changed\";b:0;}s:4:\"page\";O:8:\"stdClass\":14:{s:4:\"type\";s:4:\"page\";s:4:\"name\";s:10:\"Basic page\";s:4:\"base\";s:12:\"node_content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:77:\"Use <em>basic pages</em> for your static content, such as an \'About us\' page.\";s:4:\"help\";s:0:\"\";s:9:\"has_title\";s:1:\"1\";s:11:\"title_label\";s:5:\"Title\";s:6:\"custom\";s:1:\"1\";s:8:\"modified\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:8:\"disabled\";s:1:\"0\";s:9:\"orig_type\";s:4:\"page\";s:16:\"disabled_changed\";b:0;}s:7:\"vcenter\";O:8:\"stdClass\":14:{s:4:\"type\";s:7:\"vcenter\";s:4:\"name\";s:7:\"vCenter\";s:4:\"base\";s:12:\"node_content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:15:\"Add new vCenter\";s:4:\"help\";s:0:\"\";s:9:\"has_title\";s:1:\"1\";s:11:\"title_label\";s:9:\"Host Name\";s:6:\"custom\";s:1:\"1\";s:8:\"modified\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:8:\"disabled\";s:1:\"0\";s:9:\"orig_type\";s:7:\"vcenter\";s:16:\"disabled_changed\";b:0;}s:5:\"vdisk\";O:8:\"stdClass\":14:{s:4:\"type\";s:5:\"vdisk\";s:4:\"name\";s:5:\"vDisk\";s:4:\"base\";s:12:\"node_content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:38:\"A virtual disk that is located on a VM\";s:4:\"help\";s:0:\"\";s:9:\"has_title\";s:1:\"1\";s:11:\"title_label\";s:5:\"Title\";s:6:\"custom\";s:1:\"1\";s:8:\"modified\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:8:\"disabled\";s:1:\"0\";s:9:\"orig_type\";s:5:\"vdisk\";s:16:\"disabled_changed\";b:0;}s:13:\"vdisk_metrics\";O:8:\"stdClass\":14:{s:4:\"type\";s:13:\"vdisk_metrics\";s:4:\"name\";s:13:\"vDisk metrics\";s:4:\"base\";s:12:\"node_content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:28:\"The metrics from the vDisks.\";s:4:\"help\";s:0:\"\";s:9:\"has_title\";s:1:\"1\";s:11:\"title_label\";s:9:\"Metric Id\";s:6:\"custom\";s:1:\"1\";s:8:\"modified\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:8:\"disabled\";s:1:\"0\";s:9:\"orig_type\";s:13:\"vdisk_metrics\";s:16:\"disabled_changed\";b:0;}s:15:\"virtual_machine\";O:8:\"stdClass\":14:{s:4:\"type\";s:15:\"virtual_machine\";s:4:\"name\";s:15:\"Virtual Machine\";s:4:\"base\";s:12:\"node_content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:0:\"\";s:4:\"help\";s:0:\"\";s:9:\"has_title\";s:1:\"1\";s:11:\"title_label\";s:7:\"VM Name\";s:6:\"custom\";s:1:\"1\";s:8:\"modified\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:8:\"disabled\";s:1:\"0\";s:9:\"orig_type\";s:15:\"virtual_machine\";s:16:\"disabled_changed\";b:0;}s:14:\"vm_cache_space\";O:8:\"stdClass\":14:{s:4:\"type\";s:14:\"vm_cache_space\";s:4:\"name\";s:14:\"VM Cache Space\";s:4:\"base\";s:12:\"node_content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:56:\"Stores all the details related to Cache Space for any VM\";s:4:\"help\";s:0:\"\";s:9:\"has_title\";s:1:\"1\";s:11:\"title_label\";s:14:\"Cache Space ID\";s:6:\"custom\";s:1:\"1\";s:8:\"modified\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:8:\"disabled\";s:1:\"0\";s:9:\"orig_type\";s:14:\"vm_cache_space\";s:16:\"disabled_changed\";b:0;}s:10:\"vm_metrics\";O:8:\"stdClass\":14:{s:4:\"type\";s:10:\"vm_metrics\";s:4:\"name\";s:10:\"VM metrics\";s:4:\"base\";s:12:\"node_content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:31:\"Stores the metrics data of VMs.\";s:4:\"help\";s:0:\"\";s:9:\"has_title\";s:1:\"1\";s:11:\"title_label\";s:9:\"Metric Id\";s:6:\"custom\";s:1:\"1\";s:8:\"modified\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:8:\"disabled\";s:1:\"0\";s:9:\"orig_type\";s:10:\"vm_metrics\";s:16:\"disabled_changed\";b:0;}}s:5:\"names\";a:12:{s:7:\"article\";s:7:\"Article\";s:4:\"page\";s:10:\"Basic page\";s:11:\"data_center\";s:11:\"Data Center\";s:6:\"device\";s:6:\"Device\";s:4:\"host\";s:4:\"Host\";s:5:\"panel\";s:5:\"Panel\";s:14:\"vm_cache_space\";s:14:\"VM Cache Space\";s:10:\"vm_metrics\";s:10:\"VM metrics\";s:15:\"virtual_machine\";s:15:\"Virtual Machine\";s:7:\"vcenter\";s:7:\"vCenter\";s:5:\"vdisk\";s:5:\"vDisk\";s:13:\"vdisk_metrics\";s:13:\"vDisk metrics\";}}',0,1371656313,1),('schema','a:376:{s:5:\"block\";a:6:{s:6:\"fields\";a:12:{s:3:\"bid\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:1:\"0\";}s:5:\"theme\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"region\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"custom\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:10:\"visibility\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:5:\"pages\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;}s:5:\"title\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:5:\"cache\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;s:4:\"size\";s:4:\"tiny\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"bid\";}s:11:\"unique keys\";a:1:{s:3:\"tmd\";a:3:{i:0;s:5:\"theme\";i:1;s:6:\"module\";i:2;s:5:\"delta\";}}s:7:\"indexes\";a:1:{s:4:\"list\";a:5:{i:0;s:5:\"theme\";i:1;s:6:\"status\";i:2;s:6:\"region\";i:3;s:6:\"weight\";i:4;s:6:\"module\";}}s:6:\"module\";s:5:\"block\";s:4:\"name\";s:5:\"block\";}s:10:\"block_role\";a:5:{s:6:\"fields\";a:3:{s:6:\"module\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;}s:5:\"delta\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}s:3:\"rid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:3:{i:0;s:6:\"module\";i:1;s:5:\"delta\";i:2;s:3:\"rid\";}s:7:\"indexes\";a:1:{s:3:\"rid\";a:1:{i:0;s:3:\"rid\";}}s:6:\"module\";s:5:\"block\";s:4:\"name\";s:10:\"block_role\";}s:12:\"block_custom\";a:5:{s:6:\"fields\";a:4:{s:3:\"bid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:4:\"body\";a:4:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:12:\"translatable\";b:1;}s:4:\"info\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"unique keys\";a:1:{s:4:\"info\";a:1:{i:0;s:4:\"info\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"bid\";}s:6:\"module\";s:5:\"block\";s:4:\"name\";s:12:\"block_custom\";}s:11:\"cache_block\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:5:\"block\";s:4:\"name\";s:11:\"cache_block\";}s:11:\"block_class\";a:4:{s:6:\"fields\";a:3:{s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:9:\"css_class\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:11:\"primary key\";a:2:{i:0;s:6:\"module\";i:1;s:5:\"delta\";}s:6:\"module\";s:11:\"block_class\";s:4:\"name\";s:11:\"block_class\";}s:11:\"cache_coder\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:12:\"coder_review\";s:4:\"name\";s:11:\"cache_coder\";}s:7:\"comment\";a:6:{s:6:\"fields\";a:14:{s:3:\"cid\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:3:\"pid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"nid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"subject\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"hostname\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"changed\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:1;s:4:\"size\";s:4:\"tiny\";}s:6:\"thread\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:4:\"name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:60;s:8:\"not null\";b:0;}s:4:\"mail\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:0;}s:8:\"homepage\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:7:\"indexes\";a:5:{s:18:\"comment_status_pid\";a:2:{i:0;s:3:\"pid\";i:1;s:6:\"status\";}s:15:\"comment_num_new\";a:5:{i:0;s:3:\"nid\";i:1;s:6:\"status\";i:2;s:7:\"created\";i:3;s:3:\"cid\";i:4;s:6:\"thread\";}s:11:\"comment_uid\";a:1:{i:0;s:3:\"uid\";}s:20:\"comment_nid_language\";a:2:{i:0;s:3:\"nid\";i:1;s:8:\"language\";}s:15:\"comment_created\";a:1:{i:0;s:7:\"created\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:12:\"foreign keys\";a:2:{s:12:\"comment_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:3:\"nid\";s:3:\"nid\";}}s:14:\"comment_author\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:6:\"module\";s:7:\"comment\";s:4:\"name\";s:7:\"comment\";}s:23:\"node_comment_statistics\";a:6:{s:6:\"fields\";a:6:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"cid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:22:\"last_comment_timestamp\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:17:\"last_comment_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:60;s:8:\"not null\";b:0;}s:16:\"last_comment_uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:13:\"comment_count\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:3:\"nid\";}s:7:\"indexes\";a:3:{s:22:\"node_comment_timestamp\";a:1:{i:0;s:22:\"last_comment_timestamp\";}s:13:\"comment_count\";a:1:{i:0;s:13:\"comment_count\";}s:16:\"last_comment_uid\";a:1:{i:0;s:16:\"last_comment_uid\";}}s:12:\"foreign keys\";a:2:{s:15:\"statistics_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:3:\"nid\";s:3:\"nid\";}}s:19:\"last_comment_author\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:16:\"last_comment_uid\";s:3:\"uid\";}}}s:6:\"module\";s:7:\"comment\";s:4:\"name\";s:23:\"node_comment_statistics\";}s:19:\"ctools_object_cache\";a:5:{s:6:\"fields\";a:5:{s:3:\"sid\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"64\";s:8:\"not null\";b:1;}s:4:\"name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;}s:3:\"obj\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"32\";s:8:\"not null\";b:1;}s:7:\"updated\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:11:\"primary key\";a:3:{i:0;s:3:\"sid\";i:1;s:3:\"obj\";i:2;s:4:\"name\";}s:7:\"indexes\";a:1:{s:7:\"updated\";a:1:{i:0;s:7:\"updated\";}}s:6:\"module\";s:6:\"ctools\";s:4:\"name\";s:19:\"ctools_object_cache\";}s:16:\"ctools_css_cache\";a:4:{s:6:\"fields\";a:4:{s:3:\"cid\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"128\";s:8:\"not null\";b:1;}s:8:\"filename\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:3:\"css\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}s:6:\"filter\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:6:\"ctools\";s:4:\"name\";s:16:\"ctools_css_cache\";}s:21:\"ctools_custom_content\";a:5:{s:6:\"export\";a:5:{s:10:\"identifier\";s:7:\"content\";s:11:\"bulk export\";b:1;s:11:\"primary key\";s:3:\"cid\";s:3:\"api\";a:4:{s:5:\"owner\";s:21:\"ctools_custom_content\";s:3:\"api\";s:14:\"ctools_content\";s:15:\"minimum_version\";i:1;s:15:\"current_version\";i:1;}s:15:\"create callback\";s:23:\"ctools_content_type_new\";}s:6:\"fields\";a:6:{s:3:\"cid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;s:9:\"no export\";b:1;}s:4:\"name\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:11:\"admin_title\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:17:\"admin_description\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:14:\"object default\";s:0:\"\";}s:8:\"category\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:8:\"settings\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:21:\"ctools_custom_content\";s:4:\"name\";s:21:\"ctools_custom_content\";}s:8:\"watchdog\";a:5:{s:6:\"fields\";a:11:{s:3:\"wid\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"message\";a:3:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;s:4:\"size\";s:3:\"big\";}s:9:\"variables\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:1;s:4:\"size\";s:3:\"big\";}s:8:\"severity\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:4:\"link\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;s:7:\"default\";s:0:\"\";}s:8:\"location\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;}s:7:\"referer\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;}s:8:\"hostname\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:9:\"timestamp\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:3:\"wid\";}s:7:\"indexes\";a:2:{s:4:\"type\";a:1:{i:0;s:4:\"type\";}s:3:\"uid\";a:1:{i:0;s:3:\"uid\";}}s:6:\"module\";s:5:\"dblog\";s:4:\"name\";s:8:\"watchdog\";}s:12:\"famc_metrics\";a:4:{s:6:\"fields\";a:3:{s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;s:8:\"unsigned\";b:1;}s:9:\"timestamp\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;s:8:\"unsigned\";b:1;}s:4:\"data\";a:2:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:6:\"normal\";}}s:11:\"primary key\";a:2:{i:0;s:9:\"entity_id\";i:1;s:9:\"timestamp\";}s:6:\"module\";s:14:\"famc_analytics\";s:4:\"name\";s:12:\"famc_metrics\";}s:12:\"field_config\";a:5:{s:6:\"fields\";a:13:{s:2:\"id\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:10:\"field_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}s:4:\"type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;}s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"active\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:12:\"storage_type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;}s:14:\"storage_module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:14:\"storage_active\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"locked\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"data\";a:4:{s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;}s:11:\"cardinality\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:12:\"translatable\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:7:\"indexes\";a:8:{s:10:\"field_name\";a:1:{i:0;s:10:\"field_name\";}s:6:\"active\";a:1:{i:0;s:6:\"active\";}s:14:\"storage_active\";a:1:{i:0;s:14:\"storage_active\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:6:\"module\";a:1:{i:0;s:6:\"module\";}s:14:\"storage_module\";a:1:{i:0;s:14:\"storage_module\";}s:4:\"type\";a:1:{i:0;s:4:\"type\";}s:12:\"storage_type\";a:1:{i:0;s:12:\"storage_type\";}}s:6:\"module\";s:5:\"field\";s:4:\"name\";s:12:\"field_config\";}s:21:\"field_config_instance\";a:5:{s:6:\"fields\";a:7:{s:2:\"id\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:8:\"field_id\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;}s:10:\"field_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:4:{s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:7:\"indexes\";a:2:{s:17:\"field_name_bundle\";a:3:{i:0;s:10:\"field_name\";i:1;s:11:\"entity_type\";i:2;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}}s:6:\"module\";s:5:\"field\";s:4:\"name\";s:21:\"field_config_instance\";}s:11:\"cache_field\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:5:\"field\";s:4:\"name\";s:11:\"cache_field\";}s:23:\"field_data_comment_body\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:18:\"comment_body_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:19:\"comment_body_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:19:\"comment_body_format\";a:1:{i:0;s:19:\"comment_body_format\";}}s:12:\"foreign keys\";a:1:{s:19:\"comment_body_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:19:\"comment_body_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:23:\"field_data_comment_body\";}s:27:\"field_revision_comment_body\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:18:\"comment_body_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:19:\"comment_body_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:19:\"comment_body_format\";a:1:{i:0;s:19:\"comment_body_format\";}}s:12:\"foreign keys\";a:1:{s:19:\"comment_body_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:19:\"comment_body_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:27:\"field_revision_comment_body\";}s:15:\"field_data_body\";a:6:{s:6:\"fields\";a:10:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:10:\"body_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:12:\"body_summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:11:\"body_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:11:\"body_format\";a:1:{i:0;s:11:\"body_format\";}}s:12:\"foreign keys\";a:1:{s:11:\"body_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:11:\"body_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:15:\"field_data_body\";}s:19:\"field_revision_body\";a:6:{s:6:\"fields\";a:10:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:10:\"body_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:12:\"body_summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:11:\"body_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:11:\"body_format\";a:1:{i:0;s:11:\"body_format\";}}s:12:\"foreign keys\";a:1:{s:11:\"body_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:11:\"body_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:19:\"field_revision_body\";}s:21:\"field_data_field_tags\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:14:\"field_tags_tid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:14:\"field_tags_tid\";a:1:{i:0;s:14:\"field_tags_tid\";}}s:12:\"foreign keys\";a:1:{s:14:\"field_tags_tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:14:\"field_tags_tid\";s:3:\"tid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:21:\"field_data_field_tags\";}s:25:\"field_revision_field_tags\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:14:\"field_tags_tid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:14:\"field_tags_tid\";a:1:{i:0;s:14:\"field_tags_tid\";}}s:12:\"foreign keys\";a:1:{s:14:\"field_tags_tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:14:\"field_tags_tid\";s:3:\"tid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:25:\"field_revision_field_tags\";}s:27:\"field_data_field_ip_address\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_ip_address_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:23:\"field_ip_address_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:23:\"field_ip_address_format\";a:1:{i:0;s:23:\"field_ip_address_format\";}}s:12:\"foreign keys\";a:1:{s:23:\"field_ip_address_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:23:\"field_ip_address_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:27:\"field_data_field_ip_address\";}s:31:\"field_revision_field_ip_address\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_ip_address_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:23:\"field_ip_address_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:23:\"field_ip_address_format\";a:1:{i:0;s:23:\"field_ip_address_format\";}}s:12:\"foreign keys\";a:1:{s:23:\"field_ip_address_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:23:\"field_ip_address_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:31:\"field_revision_field_ip_address\";}s:25:\"field_data_field_username\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_username_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:21:\"field_username_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_username_format\";a:1:{i:0;s:21:\"field_username_format\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_username_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:21:\"field_username_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:25:\"field_data_field_username\";}s:29:\"field_revision_field_username\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_username_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:21:\"field_username_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_username_format\";a:1:{i:0;s:21:\"field_username_format\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_username_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:21:\"field_username_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:29:\"field_revision_field_username\";}s:25:\"field_data_field_password\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_password_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:21:\"field_password_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_password_format\";a:1:{i:0;s:21:\"field_password_format\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_password_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:21:\"field_password_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:25:\"field_data_field_password\";}s:29:\"field_revision_field_password\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_password_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:21:\"field_password_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_password_format\";a:1:{i:0;s:21:\"field_password_format\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_password_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:21:\"field_password_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:29:\"field_revision_field_password\";}s:30:\"field_data_field_vm_ip_address\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_vm_ip_address_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:26:\"field_vm_ip_address_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_vm_ip_address_format\";a:1:{i:0;s:26:\"field_vm_ip_address_format\";}}s:12:\"foreign keys\";a:1:{s:26:\"field_vm_ip_address_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:26:\"field_vm_ip_address_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:30:\"field_data_field_vm_ip_address\";}s:34:\"field_revision_field_vm_ip_address\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_vm_ip_address_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:26:\"field_vm_ip_address_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_vm_ip_address_format\";a:1:{i:0;s:26:\"field_vm_ip_address_format\";}}s:12:\"foreign keys\";a:1:{s:26:\"field_vm_ip_address_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:26:\"field_vm_ip_address_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:34:\"field_revision_field_vm_ip_address\";}s:28:\"field_data_field_memory_size\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_memory_size_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:24:\"field_memory_size_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_memory_size_format\";a:1:{i:0;s:24:\"field_memory_size_format\";}}s:12:\"foreign keys\";a:1:{s:24:\"field_memory_size_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:24:\"field_memory_size_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:28:\"field_data_field_memory_size\";}s:32:\"field_revision_field_memory_size\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_memory_size_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:24:\"field_memory_size_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_memory_size_format\";a:1:{i:0;s:24:\"field_memory_size_format\";}}s:12:\"foreign keys\";a:1:{s:24:\"field_memory_size_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:24:\"field_memory_size_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:32:\"field_revision_field_memory_size\";}s:25:\"field_data_field_template\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_template_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:21:\"field_template_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_template_format\";a:1:{i:0;s:21:\"field_template_format\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_template_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:21:\"field_template_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:25:\"field_data_field_template\";}s:29:\"field_revision_field_template\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_template_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:21:\"field_template_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_template_format\";a:1:{i:0;s:21:\"field_template_format\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_template_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:21:\"field_template_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:29:\"field_revision_field_template\";}s:29:\"field_data_field_vm_path_name\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:24:\"field_vm_path_name_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:25:\"field_vm_path_name_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:25:\"field_vm_path_name_format\";a:1:{i:0;s:25:\"field_vm_path_name_format\";}}s:12:\"foreign keys\";a:1:{s:25:\"field_vm_path_name_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:25:\"field_vm_path_name_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:29:\"field_data_field_vm_path_name\";}s:33:\"field_revision_field_vm_path_name\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:24:\"field_vm_path_name_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:25:\"field_vm_path_name_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:25:\"field_vm_path_name_format\";a:1:{i:0;s:25:\"field_vm_path_name_format\";}}s:12:\"foreign keys\";a:1:{s:25:\"field_vm_path_name_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:25:\"field_vm_path_name_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:33:\"field_revision_field_vm_path_name\";}s:25:\"field_data_field_guest_os\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_guest_os_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:21:\"field_guest_os_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_guest_os_format\";a:1:{i:0;s:21:\"field_guest_os_format\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_guest_os_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:21:\"field_guest_os_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:25:\"field_data_field_guest_os\";}s:29:\"field_revision_field_guest_os\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_guest_os_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:21:\"field_guest_os_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_guest_os_format\";a:1:{i:0;s:21:\"field_guest_os_format\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_guest_os_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:21:\"field_guest_os_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:29:\"field_revision_field_guest_os\";}s:25:\"field_data_field_guest_id\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_guest_id_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:21:\"field_guest_id_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_guest_id_format\";a:1:{i:0;s:21:\"field_guest_id_format\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_guest_id_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:21:\"field_guest_id_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:25:\"field_data_field_guest_id\";}s:29:\"field_revision_field_guest_id\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_guest_id_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:21:\"field_guest_id_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_guest_id_format\";a:1:{i:0;s:21:\"field_guest_id_format\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_guest_id_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:21:\"field_guest_id_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:29:\"field_revision_field_guest_id\";}s:26:\"field_data_field_cpu_usage\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:21:\"field_cpu_usage_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:22:\"field_cpu_usage_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:22:\"field_cpu_usage_format\";a:1:{i:0;s:22:\"field_cpu_usage_format\";}}s:12:\"foreign keys\";a:1:{s:22:\"field_cpu_usage_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:22:\"field_cpu_usage_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:26:\"field_data_field_cpu_usage\";}s:30:\"field_revision_field_cpu_usage\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:21:\"field_cpu_usage_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:22:\"field_cpu_usage_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:22:\"field_cpu_usage_format\";a:1:{i:0;s:22:\"field_cpu_usage_format\";}}s:12:\"foreign keys\";a:1:{s:22:\"field_cpu_usage_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:22:\"field_cpu_usage_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:30:\"field_revision_field_cpu_usage\";}s:34:\"field_data_field_host_memory_usage\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:29:\"field_host_memory_usage_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:30:\"field_host_memory_usage_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:30:\"field_host_memory_usage_format\";a:1:{i:0;s:30:\"field_host_memory_usage_format\";}}s:12:\"foreign keys\";a:1:{s:30:\"field_host_memory_usage_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:30:\"field_host_memory_usage_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:34:\"field_data_field_host_memory_usage\";}s:38:\"field_revision_field_host_memory_usage\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:29:\"field_host_memory_usage_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:30:\"field_host_memory_usage_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:30:\"field_host_memory_usage_format\";a:1:{i:0;s:30:\"field_host_memory_usage_format\";}}s:12:\"foreign keys\";a:1:{s:30:\"field_host_memory_usage_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:30:\"field_host_memory_usage_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:38:\"field_revision_field_host_memory_usage\";}s:35:\"field_data_field_guest_memory_usage\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:30:\"field_guest_memory_usage_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:31:\"field_guest_memory_usage_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:31:\"field_guest_memory_usage_format\";a:1:{i:0;s:31:\"field_guest_memory_usage_format\";}}s:12:\"foreign keys\";a:1:{s:31:\"field_guest_memory_usage_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:31:\"field_guest_memory_usage_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:35:\"field_data_field_guest_memory_usage\";}s:39:\"field_revision_field_guest_memory_usage\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:30:\"field_guest_memory_usage_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:31:\"field_guest_memory_usage_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:31:\"field_guest_memory_usage_format\";a:1:{i:0;s:31:\"field_guest_memory_usage_format\";}}s:12:\"foreign keys\";a:1:{s:31:\"field_guest_memory_usage_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:31:\"field_guest_memory_usage_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:39:\"field_revision_field_guest_memory_usage\";}s:26:\"field_data_field_cpu_model\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:21:\"field_cpu_model_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:22:\"field_cpu_model_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:22:\"field_cpu_model_format\";a:1:{i:0;s:22:\"field_cpu_model_format\";}}s:12:\"foreign keys\";a:1:{s:22:\"field_cpu_model_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:22:\"field_cpu_model_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:26:\"field_data_field_cpu_model\";}s:30:\"field_revision_field_cpu_model\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:21:\"field_cpu_model_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:22:\"field_cpu_model_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:22:\"field_cpu_model_format\";a:1:{i:0;s:22:\"field_cpu_model_format\";}}s:12:\"foreign keys\";a:1:{s:22:\"field_cpu_model_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:22:\"field_cpu_model_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:30:\"field_revision_field_cpu_model\";}s:25:\"field_data_field_boottime\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_boottime_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:21:\"field_boottime_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_boottime_format\";a:1:{i:0;s:21:\"field_boottime_format\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_boottime_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:21:\"field_boottime_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:25:\"field_data_field_boottime\";}s:29:\"field_revision_field_boottime\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_boottime_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:21:\"field_boottime_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_boottime_format\";a:1:{i:0;s:21:\"field_boottime_format\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_boottime_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:21:\"field_boottime_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:29:\"field_revision_field_boottime\";}s:28:\"field_data_field_host_status\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_host_status_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:24:\"field_host_status_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_host_status_format\";a:1:{i:0;s:24:\"field_host_status_format\";}}s:12:\"foreign keys\";a:1:{s:24:\"field_host_status_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:24:\"field_host_status_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:28:\"field_data_field_host_status\";}s:32:\"field_revision_field_host_status\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_host_status_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:24:\"field_host_status_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_host_status_format\";a:1:{i:0;s:24:\"field_host_status_format\";}}s:12:\"foreign keys\";a:1:{s:24:\"field_host_status_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:24:\"field_host_status_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:32:\"field_revision_field_host_status\";}s:33:\"field_data_field_maintenance_mode\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_maintenance_mode_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:33:\"field_data_field_maintenance_mode\";}s:37:\"field_revision_field_maintenance_mode\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_maintenance_mode_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:37:\"field_revision_field_maintenance_mode\";}s:32:\"field_data_field_physical_memory\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:27:\"field_physical_memory_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:28:\"field_physical_memory_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:28:\"field_physical_memory_format\";a:1:{i:0;s:28:\"field_physical_memory_format\";}}s:12:\"foreign keys\";a:1:{s:28:\"field_physical_memory_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:28:\"field_physical_memory_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:32:\"field_data_field_physical_memory\";}s:36:\"field_revision_field_physical_memory\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:27:\"field_physical_memory_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:28:\"field_physical_memory_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:28:\"field_physical_memory_format\";a:1:{i:0;s:28:\"field_physical_memory_format\";}}s:12:\"foreign keys\";a:1:{s:28:\"field_physical_memory_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:28:\"field_physical_memory_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:36:\"field_revision_field_physical_memory\";}s:24:\"field_data_field_vmotion\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:19:\"field_vmotion_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:24:\"field_data_field_vmotion\";}s:28:\"field_revision_field_vmotion\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:19:\"field_vmotion_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:28:\"field_revision_field_vmotion\";}s:32:\"field_data_field_reboot_required\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:27:\"field_reboot_required_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:32:\"field_data_field_reboot_required\";}s:36:\"field_revision_field_reboot_required\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:27:\"field_reboot_required_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:36:\"field_revision_field_reboot_required\";}s:26:\"field_data_field_serial_no\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:21:\"field_serial_no_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:22:\"field_serial_no_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:22:\"field_serial_no_format\";a:1:{i:0;s:22:\"field_serial_no_format\";}}s:12:\"foreign keys\";a:1:{s:22:\"field_serial_no_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:22:\"field_serial_no_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:26:\"field_data_field_serial_no\";}s:30:\"field_revision_field_serial_no\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:21:\"field_serial_no_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:22:\"field_serial_no_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:22:\"field_serial_no_format\";a:1:{i:0;s:22:\"field_serial_no_format\";}}s:12:\"foreign keys\";a:1:{s:22:\"field_serial_no_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:22:\"field_serial_no_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:30:\"field_revision_field_serial_no\";}s:21:\"field_data_field_size\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:16:\"field_size_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:17:\"field_size_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:17:\"field_size_format\";a:1:{i:0;s:17:\"field_size_format\";}}s:12:\"foreign keys\";a:1:{s:17:\"field_size_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:17:\"field_size_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:21:\"field_data_field_size\";}s:25:\"field_revision_field_size\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:16:\"field_size_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:17:\"field_size_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:17:\"field_size_format\";a:1:{i:0;s:17:\"field_size_format\";}}s:12:\"foreign keys\";a:1:{s:17:\"field_size_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:17:\"field_size_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:25:\"field_revision_field_size\";}s:28:\"field_data_field_device_type\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_device_type_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:24:\"field_device_type_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_device_type_format\";a:1:{i:0;s:24:\"field_device_type_format\";}}s:12:\"foreign keys\";a:1:{s:24:\"field_device_type_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:24:\"field_device_type_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:28:\"field_data_field_device_type\";}s:32:\"field_revision_field_device_type\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_device_type_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:24:\"field_device_type_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_device_type_format\";a:1:{i:0;s:24:\"field_device_type_format\";}}s:12:\"foreign keys\";a:1:{s:24:\"field_device_type_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:24:\"field_device_type_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:32:\"field_revision_field_device_type\";}s:33:\"field_data_field_multipath_plugin\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_multipath_plugin_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:29:\"field_multipath_plugin_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:29:\"field_multipath_plugin_format\";a:1:{i:0;s:29:\"field_multipath_plugin_format\";}}s:12:\"foreign keys\";a:1:{s:29:\"field_multipath_plugin_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:29:\"field_multipath_plugin_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:33:\"field_data_field_multipath_plugin\";}s:37:\"field_revision_field_multipath_plugin\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_multipath_plugin_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:29:\"field_multipath_plugin_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:29:\"field_multipath_plugin_format\";a:1:{i:0;s:29:\"field_multipath_plugin_format\";}}s:12:\"foreign keys\";a:1:{s:29:\"field_multipath_plugin_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:29:\"field_multipath_plugin_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:37:\"field_revision_field_multipath_plugin\";}s:27:\"field_data_field_devfs_path\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_devfs_path_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:23:\"field_devfs_path_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:23:\"field_devfs_path_format\";a:1:{i:0;s:23:\"field_devfs_path_format\";}}s:12:\"foreign keys\";a:1:{s:23:\"field_devfs_path_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:23:\"field_devfs_path_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:27:\"field_data_field_devfs_path\";}s:31:\"field_revision_field_devfs_path\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_devfs_path_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:23:\"field_devfs_path_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:23:\"field_devfs_path_format\";a:1:{i:0;s:23:\"field_devfs_path_format\";}}s:12:\"foreign keys\";a:1:{s:23:\"field_devfs_path_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:23:\"field_devfs_path_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:31:\"field_revision_field_devfs_path\";}s:23:\"field_data_field_vendor\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:18:\"field_vendor_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:19:\"field_vendor_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:19:\"field_vendor_format\";a:1:{i:0;s:19:\"field_vendor_format\";}}s:12:\"foreign keys\";a:1:{s:19:\"field_vendor_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:19:\"field_vendor_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:23:\"field_data_field_vendor\";}s:27:\"field_revision_field_vendor\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:18:\"field_vendor_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:19:\"field_vendor_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:19:\"field_vendor_format\";a:1:{i:0;s:19:\"field_vendor_format\";}}s:12:\"foreign keys\";a:1:{s:19:\"field_vendor_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:19:\"field_vendor_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:27:\"field_revision_field_vendor\";}s:22:\"field_data_field_model\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:17:\"field_model_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:18:\"field_model_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:18:\"field_model_format\";a:1:{i:0;s:18:\"field_model_format\";}}s:12:\"foreign keys\";a:1:{s:18:\"field_model_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:18:\"field_model_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:22:\"field_data_field_model\";}s:26:\"field_revision_field_model\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:17:\"field_model_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:18:\"field_model_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:18:\"field_model_format\";a:1:{i:0;s:18:\"field_model_format\";}}s:12:\"foreign keys\";a:1:{s:18:\"field_model_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:18:\"field_model_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:26:\"field_revision_field_model\";}s:25:\"field_data_field_revision\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_revision_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:21:\"field_revision_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_revision_format\";a:1:{i:0;s:21:\"field_revision_format\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_revision_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:21:\"field_revision_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:25:\"field_data_field_revision\";}s:29:\"field_revision_field_revision\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_revision_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:21:\"field_revision_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_revision_format\";a:1:{i:0;s:21:\"field_revision_format\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_revision_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:21:\"field_revision_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:29:\"field_revision_field_revision\";}s:27:\"field_data_field_scsi_level\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_scsi_level_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:23:\"field_scsi_level_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:23:\"field_scsi_level_format\";a:1:{i:0;s:23:\"field_scsi_level_format\";}}s:12:\"foreign keys\";a:1:{s:23:\"field_scsi_level_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:23:\"field_scsi_level_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:27:\"field_data_field_scsi_level\";}s:31:\"field_revision_field_scsi_level\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_scsi_level_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:23:\"field_scsi_level_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:23:\"field_scsi_level_format\";a:1:{i:0;s:23:\"field_scsi_level_format\";}}s:12:\"foreign keys\";a:1:{s:23:\"field_scsi_level_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:23:\"field_scsi_level_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:31:\"field_revision_field_scsi_level\";}s:26:\"field_data_field_is_pseudo\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:21:\"field_is_pseudo_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_is_pseudo_value\";a:1:{i:0;s:21:\"field_is_pseudo_value\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:26:\"field_data_field_is_pseudo\";}s:30:\"field_revision_field_is_pseudo\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:21:\"field_is_pseudo_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_is_pseudo_value\";a:1:{i:0;s:21:\"field_is_pseudo_value\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:30:\"field_revision_field_is_pseudo\";}s:23:\"field_data_field_status\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:18:\"field_status_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:18:\"field_status_value\";a:1:{i:0;s:18:\"field_status_value\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:23:\"field_data_field_status\";}s:27:\"field_revision_field_status\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:18:\"field_status_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:18:\"field_status_value\";a:1:{i:0;s:18:\"field_status_value\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:27:\"field_revision_field_status\";}s:31:\"field_data_field_is_rdm_capable\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:26:\"field_is_rdm_capable_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_is_rdm_capable_value\";a:1:{i:0;s:26:\"field_is_rdm_capable_value\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:31:\"field_data_field_is_rdm_capable\";}s:35:\"field_revision_field_is_rdm_capable\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:26:\"field_is_rdm_capable_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_is_rdm_capable_value\";a:1:{i:0;s:26:\"field_is_rdm_capable_value\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:35:\"field_revision_field_is_rdm_capable\";}s:25:\"field_data_field_is_local\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_is_local_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:20:\"field_is_local_value\";a:1:{i:0;s:20:\"field_is_local_value\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:25:\"field_data_field_is_local\";}s:29:\"field_revision_field_is_local\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_is_local_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:20:\"field_is_local_value\";a:1:{i:0;s:20:\"field_is_local_value\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:29:\"field_revision_field_is_local\";}s:29:\"field_data_field_is_removable\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:24:\"field_is_removable_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_is_removable_value\";a:1:{i:0;s:24:\"field_is_removable_value\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:29:\"field_data_field_is_removable\";}s:33:\"field_revision_field_is_removable\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:24:\"field_is_removable_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_is_removable_value\";a:1:{i:0;s:24:\"field_is_removable_value\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:33:\"field_revision_field_is_removable\";}s:23:\"field_data_field_is_ssd\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:18:\"field_is_ssd_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:18:\"field_is_ssd_value\";a:1:{i:0;s:18:\"field_is_ssd_value\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:23:\"field_data_field_is_ssd\";}s:27:\"field_revision_field_is_ssd\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:18:\"field_is_ssd_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:18:\"field_is_ssd_value\";a:1:{i:0;s:18:\"field_is_ssd_value\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:27:\"field_revision_field_is_ssd\";}s:27:\"field_data_field_is_offline\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_is_offline_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:22:\"field_is_offline_value\";a:1:{i:0;s:22:\"field_is_offline_value\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:27:\"field_data_field_is_offline\";}s:31:\"field_revision_field_is_offline\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_is_offline_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:22:\"field_is_offline_value\";a:1:{i:0;s:22:\"field_is_offline_value\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:31:\"field_revision_field_is_offline\";}s:40:\"field_data_field_is_perennially_reserved\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:35:\"field_is_perennially_reserved_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:35:\"field_is_perennially_reserved_value\";a:1:{i:0;s:35:\"field_is_perennially_reserved_value\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:40:\"field_data_field_is_perennially_reserved\";}s:44:\"field_revision_field_is_perennially_reserved\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:35:\"field_is_perennially_reserved_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:35:\"field_is_perennially_reserved_value\";a:1:{i:0;s:35:\"field_is_perennially_reserved_value\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:44:\"field_revision_field_is_perennially_reserved\";}s:41:\"field_data_field_thin_provisioning_status\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:36:\"field_thin_provisioning_status_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:37:\"field_thin_provisioning_status_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:37:\"field_thin_provisioning_status_format\";a:1:{i:0;s:37:\"field_thin_provisioning_status_format\";}}s:12:\"foreign keys\";a:1:{s:37:\"field_thin_provisioning_status_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:37:\"field_thin_provisioning_status_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:41:\"field_data_field_thin_provisioning_status\";}s:45:\"field_revision_field_thin_provisioning_status\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:36:\"field_thin_provisioning_status_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:37:\"field_thin_provisioning_status_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:37:\"field_thin_provisioning_status_format\";a:1:{i:0;s:37:\"field_thin_provisioning_status_format\";}}s:12:\"foreign keys\";a:1:{s:37:\"field_thin_provisioning_status_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:37:\"field_thin_provisioning_status_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:45:\"field_revision_field_thin_provisioning_status\";}s:33:\"field_data_field_attached_filters\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_attached_filters_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:29:\"field_attached_filters_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:29:\"field_attached_filters_format\";a:1:{i:0;s:29:\"field_attached_filters_format\";}}s:12:\"foreign keys\";a:1:{s:29:\"field_attached_filters_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:29:\"field_attached_filters_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:33:\"field_data_field_attached_filters\";}s:37:\"field_revision_field_attached_filters\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_attached_filters_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:29:\"field_attached_filters_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:29:\"field_attached_filters_format\";a:1:{i:0;s:29:\"field_attached_filters_format\";}}s:12:\"foreign keys\";a:1:{s:29:\"field_attached_filters_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:29:\"field_attached_filters_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:37:\"field_revision_field_attached_filters\";}s:28:\"field_data_field_vaai_status\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_vaai_status_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:24:\"field_vaai_status_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_vaai_status_format\";a:1:{i:0;s:24:\"field_vaai_status_format\";}}s:12:\"foreign keys\";a:1:{s:24:\"field_vaai_status_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:24:\"field_vaai_status_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:28:\"field_data_field_vaai_status\";}s:32:\"field_revision_field_vaai_status\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_vaai_status_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:24:\"field_vaai_status_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_vaai_status_format\";a:1:{i:0;s:24:\"field_vaai_status_format\";}}s:12:\"foreign keys\";a:1:{s:24:\"field_vaai_status_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:24:\"field_vaai_status_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:32:\"field_revision_field_vaai_status\";}s:27:\"field_data_field_other_uids\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_other_uids_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:23:\"field_other_uids_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:23:\"field_other_uids_format\";a:1:{i:0;s:23:\"field_other_uids_format\";}}s:12:\"foreign keys\";a:1:{s:23:\"field_other_uids_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:23:\"field_other_uids_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:27:\"field_data_field_other_uids\";}s:31:\"field_revision_field_other_uids\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_other_uids_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:23:\"field_other_uids_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:23:\"field_other_uids_format\";a:1:{i:0;s:23:\"field_other_uids_format\";}}s:12:\"foreign keys\";a:1:{s:23:\"field_other_uids_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:23:\"field_other_uids_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:31:\"field_revision_field_other_uids\";}s:29:\"field_data_field_display_name\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:24:\"field_display_name_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:25:\"field_display_name_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:25:\"field_display_name_format\";a:1:{i:0;s:25:\"field_display_name_format\";}}s:12:\"foreign keys\";a:1:{s:25:\"field_display_name_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:25:\"field_display_name_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:29:\"field_data_field_display_name\";}s:33:\"field_revision_field_display_name\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:24:\"field_display_name_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:25:\"field_display_name_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:25:\"field_display_name_format\";a:1:{i:0;s:25:\"field_display_name_format\";}}s:12:\"foreign keys\";a:1:{s:25:\"field_display_name_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:25:\"field_display_name_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:33:\"field_revision_field_display_name\";}s:25:\"field_data_field_capacity\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_capacity_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:21:\"field_capacity_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_capacity_format\";a:1:{i:0;s:21:\"field_capacity_format\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_capacity_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:21:\"field_capacity_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:25:\"field_data_field_capacity\";}s:29:\"field_revision_field_capacity\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_capacity_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:21:\"field_capacity_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_capacity_format\";a:1:{i:0;s:21:\"field_capacity_format\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_capacity_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:21:\"field_capacity_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:29:\"field_revision_field_capacity\";}s:21:\"field_data_field_path\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:16:\"field_path_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:17:\"field_path_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:17:\"field_path_format\";a:1:{i:0;s:17:\"field_path_format\";}}s:12:\"foreign keys\";a:1:{s:17:\"field_path_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:17:\"field_path_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:21:\"field_data_field_path\";}s:25:\"field_revision_field_path\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:16:\"field_path_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:17:\"field_path_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:17:\"field_path_format\";a:1:{i:0;s:17:\"field_path_format\";}}s:12:\"foreign keys\";a:1:{s:17:\"field_path_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:17:\"field_path_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:25:\"field_revision_field_path\";}s:26:\"field_data_field_freespace\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:21:\"field_freespace_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:22:\"field_freespace_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:22:\"field_freespace_format\";a:1:{i:0;s:22:\"field_freespace_format\";}}s:12:\"foreign keys\";a:1:{s:22:\"field_freespace_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:22:\"field_freespace_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:26:\"field_data_field_freespace\";}s:30:\"field_revision_field_freespace\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:21:\"field_freespace_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:22:\"field_freespace_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:22:\"field_freespace_format\";a:1:{i:0;s:22:\"field_freespace_format\";}}s:12:\"foreign keys\";a:1:{s:22:\"field_freespace_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:22:\"field_freespace_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:30:\"field_revision_field_freespace\";}s:28:\"field_data_field_vm_username\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_vm_username_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:24:\"field_vm_username_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_vm_username_format\";a:1:{i:0;s:24:\"field_vm_username_format\";}}s:12:\"foreign keys\";a:1:{s:24:\"field_vm_username_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:24:\"field_vm_username_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:28:\"field_data_field_vm_username\";}s:32:\"field_revision_field_vm_username\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_vm_username_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:24:\"field_vm_username_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_vm_username_format\";a:1:{i:0;s:24:\"field_vm_username_format\";}}s:12:\"foreign keys\";a:1:{s:24:\"field_vm_username_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:24:\"field_vm_username_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:32:\"field_revision_field_vm_username\";}s:28:\"field_data_field_vm_password\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_vm_password_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:24:\"field_vm_password_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_vm_password_format\";a:1:{i:0;s:24:\"field_vm_password_format\";}}s:12:\"foreign keys\";a:1:{s:24:\"field_vm_password_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:24:\"field_vm_password_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:28:\"field_data_field_vm_password\";}s:32:\"field_revision_field_vm_password\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_vm_password_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:24:\"field_vm_password_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_vm_password_format\";a:1:{i:0;s:24:\"field_vm_password_format\";}}s:12:\"foreign keys\";a:1:{s:24:\"field_vm_password_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:24:\"field_vm_password_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:32:\"field_revision_field_vm_password\";}s:30:\"field_data_field_host_username\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_host_username_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:26:\"field_host_username_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_host_username_format\";a:1:{i:0;s:26:\"field_host_username_format\";}}s:12:\"foreign keys\";a:1:{s:26:\"field_host_username_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:26:\"field_host_username_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:30:\"field_data_field_host_username\";}s:34:\"field_revision_field_host_username\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_host_username_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:26:\"field_host_username_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_host_username_format\";a:1:{i:0;s:26:\"field_host_username_format\";}}s:12:\"foreign keys\";a:1:{s:26:\"field_host_username_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:26:\"field_host_username_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:34:\"field_revision_field_host_username\";}s:30:\"field_data_field_host_password\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_host_password_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:26:\"field_host_password_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_host_password_format\";a:1:{i:0;s:26:\"field_host_password_format\";}}s:12:\"foreign keys\";a:1:{s:26:\"field_host_password_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:26:\"field_host_password_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:30:\"field_data_field_host_password\";}s:34:\"field_revision_field_host_password\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_host_password_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:26:\"field_host_password_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_host_password_format\";a:1:{i:0;s:26:\"field_host_password_format\";}}s:12:\"foreign keys\";a:1:{s:26:\"field_host_password_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:26:\"field_host_password_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:34:\"field_revision_field_host_password\";}s:30:\"field_data_field_driver_status\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_driver_status_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:26:\"field_driver_status_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_driver_status_format\";a:1:{i:0;s:26:\"field_driver_status_format\";}}s:12:\"foreign keys\";a:1:{s:26:\"field_driver_status_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:26:\"field_driver_status_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:30:\"field_data_field_driver_status\";}s:34:\"field_revision_field_driver_status\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_driver_status_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:26:\"field_driver_status_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_driver_status_format\";a:1:{i:0;s:26:\"field_driver_status_format\";}}s:12:\"foreign keys\";a:1:{s:26:\"field_driver_status_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:26:\"field_driver_status_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:34:\"field_revision_field_driver_status\";}s:30:\"field_data_field_bundle_status\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_bundle_status_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:26:\"field_bundle_status_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_bundle_status_format\";a:1:{i:0;s:26:\"field_bundle_status_format\";}}s:12:\"foreign keys\";a:1:{s:26:\"field_bundle_status_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:26:\"field_bundle_status_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:30:\"field_data_field_bundle_status\";}s:34:\"field_revision_field_bundle_status\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_bundle_status_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:26:\"field_bundle_status_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_bundle_status_format\";a:1:{i:0;s:26:\"field_bundle_status_format\";}}s:12:\"foreign keys\";a:1:{s:26:\"field_bundle_status_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:26:\"field_bundle_status_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:34:\"field_revision_field_bundle_status\";}s:32:\"field_data_field_related_vcenter\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:31:\"field_related_vcenter_target_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:31:\"field_related_vcenter_target_id\";a:1:{i:0;s:31:\"field_related_vcenter_target_id\";}}s:12:\"foreign keys\";a:1:{s:26:\"field_related_vcenter_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:31:\"field_related_vcenter_target_id\";s:3:\"nid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:32:\"field_data_field_related_vcenter\";}s:36:\"field_revision_field_related_vcenter\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:31:\"field_related_vcenter_target_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:31:\"field_related_vcenter_target_id\";a:1:{i:0;s:31:\"field_related_vcenter_target_id\";}}s:12:\"foreign keys\";a:1:{s:26:\"field_related_vcenter_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:31:\"field_related_vcenter_target_id\";s:3:\"nid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:36:\"field_revision_field_related_vcenter\";}s:32:\"field_data_field_virtual_machine\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:31:\"field_virtual_machine_target_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:31:\"field_virtual_machine_target_id\";a:1:{i:0;s:31:\"field_virtual_machine_target_id\";}}s:12:\"foreign keys\";a:1:{s:26:\"field_virtual_machine_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:31:\"field_virtual_machine_target_id\";s:3:\"nid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:32:\"field_data_field_virtual_machine\";}s:36:\"field_revision_field_virtual_machine\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:31:\"field_virtual_machine_target_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:31:\"field_virtual_machine_target_id\";a:1:{i:0;s:31:\"field_virtual_machine_target_id\";}}s:12:\"foreign keys\";a:1:{s:26:\"field_virtual_machine_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:31:\"field_virtual_machine_target_id\";s:3:\"nid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:36:\"field_revision_field_virtual_machine\";}s:29:\"field_data_field_related_host\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_related_host_target_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:28:\"field_related_host_target_id\";a:1:{i:0;s:28:\"field_related_host_target_id\";}}s:12:\"foreign keys\";a:1:{s:23:\"field_related_host_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:28:\"field_related_host_target_id\";s:3:\"nid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:29:\"field_data_field_related_host\";}s:33:\"field_revision_field_related_host\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_related_host_target_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:28:\"field_related_host_target_id\";a:1:{i:0;s:28:\"field_related_host_target_id\";}}s:12:\"foreign keys\";a:1:{s:23:\"field_related_host_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:28:\"field_related_host_target_id\";s:3:\"nid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:33:\"field_revision_field_related_host\";}s:27:\"field_data_field_datacenter\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:26:\"field_datacenter_target_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_datacenter_target_id\";a:1:{i:0;s:26:\"field_datacenter_target_id\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_datacenter_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:26:\"field_datacenter_target_id\";s:3:\"nid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:27:\"field_data_field_datacenter\";}s:31:\"field_revision_field_datacenter\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:26:\"field_datacenter_target_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_datacenter_target_id\";a:1:{i:0;s:26:\"field_datacenter_target_id\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_datacenter_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:26:\"field_datacenter_target_id\";s:3:\"nid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:31:\"field_revision_field_datacenter\";}s:21:\"field_data_field_host\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_host_target_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:20:\"field_host_target_id\";a:1:{i:0;s:20:\"field_host_target_id\";}}s:12:\"foreign keys\";a:1:{s:15:\"field_host_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:20:\"field_host_target_id\";s:3:\"nid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:21:\"field_data_field_host\";}s:25:\"field_revision_field_host\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_host_target_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:20:\"field_host_target_id\";a:1:{i:0;s:20:\"field_host_target_id\";}}s:12:\"foreign keys\";a:1:{s:15:\"field_host_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:20:\"field_host_target_id\";s:3:\"nid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:25:\"field_revision_field_host\";}s:29:\"field_data_field_vmware_tools\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:24:\"field_vmware_tools_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:25:\"field_vmware_tools_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:25:\"field_vmware_tools_format\";a:1:{i:0;s:25:\"field_vmware_tools_format\";}}s:12:\"foreign keys\";a:1:{s:25:\"field_vmware_tools_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:25:\"field_vmware_tools_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:29:\"field_data_field_vmware_tools\";}s:33:\"field_revision_field_vmware_tools\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:24:\"field_vmware_tools_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:25:\"field_vmware_tools_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:25:\"field_vmware_tools_format\";a:1:{i:0;s:25:\"field_vmware_tools_format\";}}s:12:\"foreign keys\";a:1:{s:25:\"field_vmware_tools_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:25:\"field_vmware_tools_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:33:\"field_revision_field_vmware_tools\";}s:33:\"field_data_field_software_on_host\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_software_on_host_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:29:\"field_software_on_host_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:29:\"field_software_on_host_format\";a:1:{i:0;s:29:\"field_software_on_host_format\";}}s:12:\"foreign keys\";a:1:{s:29:\"field_software_on_host_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:29:\"field_software_on_host_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:33:\"field_data_field_software_on_host\";}s:37:\"field_revision_field_software_on_host\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_software_on_host_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:29:\"field_software_on_host_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:29:\"field_software_on_host_format\";a:1:{i:0;s:29:\"field_software_on_host_format\";}}s:12:\"foreign keys\";a:1:{s:29:\"field_software_on_host_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:29:\"field_software_on_host_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:37:\"field_revision_field_software_on_host\";}s:19:\"field_data_field_vm\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:18:\"field_vm_target_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:18:\"field_vm_target_id\";a:1:{i:0;s:18:\"field_vm_target_id\";}}s:12:\"foreign keys\";a:1:{s:13:\"field_vm_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:18:\"field_vm_target_id\";s:3:\"nid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:19:\"field_data_field_vm\";}s:23:\"field_revision_field_vm\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:18:\"field_vm_target_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:18:\"field_vm_target_id\";a:1:{i:0;s:18:\"field_vm_target_id\";}}s:12:\"foreign keys\";a:1:{s:13:\"field_vm_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:18:\"field_vm_target_id\";s:3:\"nid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:23:\"field_revision_field_vm\";}s:35:\"field_data_field_allocated_segments\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:30:\"field_allocated_segments_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:35:\"field_data_field_allocated_segments\";}s:39:\"field_revision_field_allocated_segments\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:30:\"field_allocated_segments_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:39:\"field_revision_field_allocated_segments\";}s:29:\"field_data_field_segment_size\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:24:\"field_segment_size_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:29:\"field_data_field_segment_size\";}s:33:\"field_revision_field_segment_size\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:24:\"field_segment_size_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:33:\"field_revision_field_segment_size\";}s:37:\"field_data_field_max_virtual_machines\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:32:\"field_max_virtual_machines_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:37:\"field_data_field_max_virtual_machines\";}s:41:\"field_revision_field_max_virtual_machines\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:32:\"field_max_virtual_machines_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:41:\"field_revision_field_max_virtual_machines\";}s:37:\"field_data_field_max_physical_devices\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:32:\"field_max_physical_devices_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:37:\"field_data_field_max_physical_devices\";}s:41:\"field_revision_field_max_physical_devices\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:32:\"field_max_physical_devices_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:41:\"field_revision_field_max_physical_devices\";}s:41:\"field_data_field_claimed_physical_devices\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:36:\"field_claimed_physical_devices_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:41:\"field_data_field_claimed_physical_devices\";}s:45:\"field_revision_field_claimed_physical_devices\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:36:\"field_claimed_physical_devices_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:45:\"field_revision_field_claimed_physical_devices\";}s:28:\"field_data_field_cache_state\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_cache_state_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:28:\"field_data_field_cache_state\";}s:32:\"field_revision_field_cache_state\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_cache_state_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:32:\"field_revision_field_cache_state\";}s:31:\"field_data_field_total_segments\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:26:\"field_total_segments_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:31:\"field_data_field_total_segments\";}s:35:\"field_revision_field_total_segments\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:26:\"field_total_segments_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:35:\"field_revision_field_total_segments\";}s:43:\"field_data_field_allocated_virtual_machines\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:38:\"field_allocated_virtual_machines_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:43:\"field_data_field_allocated_virtual_machines\";}s:47:\"field_revision_field_allocated_virtual_machines\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:38:\"field_allocated_virtual_machines_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:47:\"field_revision_field_allocated_virtual_machines\";}s:28:\"field_data_field_vib_version\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_vib_version_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:24:\"field_vib_version_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_vib_version_format\";a:1:{i:0;s:24:\"field_vib_version_format\";}}s:12:\"foreign keys\";a:1:{s:24:\"field_vib_version_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:24:\"field_vib_version_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:28:\"field_data_field_vib_version\";}s:32:\"field_revision_field_vib_version\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_vib_version_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:24:\"field_vib_version_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_vib_version_format\";a:1:{i:0;s:24:\"field_vib_version_format\";}}s:12:\"foreign keys\";a:1:{s:24:\"field_vib_version_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:24:\"field_vib_version_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:32:\"field_revision_field_vib_version\";}s:27:\"field_data_field_total_size\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_total_size_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:23:\"field_total_size_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:23:\"field_total_size_format\";a:1:{i:0;s:23:\"field_total_size_format\";}}s:12:\"foreign keys\";a:1:{s:23:\"field_total_size_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:23:\"field_total_size_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:27:\"field_data_field_total_size\";}s:31:\"field_revision_field_total_size\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_total_size_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:23:\"field_total_size_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:23:\"field_total_size_format\";a:1:{i:0;s:23:\"field_total_size_format\";}}s:12:\"foreign keys\";a:1:{s:23:\"field_total_size_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:23:\"field_total_size_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:31:\"field_revision_field_total_size\";}s:31:\"field_data_field_naa_identifier\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:26:\"field_naa_identifier_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:27:\"field_naa_identifier_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:27:\"field_naa_identifier_format\";a:1:{i:0;s:27:\"field_naa_identifier_format\";}}s:12:\"foreign keys\";a:1:{s:27:\"field_naa_identifier_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:27:\"field_naa_identifier_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:31:\"field_data_field_naa_identifier\";}s:35:\"field_revision_field_naa_identifier\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:26:\"field_naa_identifier_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:27:\"field_naa_identifier_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:27:\"field_naa_identifier_format\";a:1:{i:0;s:27:\"field_naa_identifier_format\";}}s:12:\"foreign keys\";a:1:{s:27:\"field_naa_identifier_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:27:\"field_naa_identifier_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:35:\"field_revision_field_naa_identifier\";}s:31:\"field_data_field_allocated_size\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:26:\"field_allocated_size_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:27:\"field_allocated_size_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:27:\"field_allocated_size_format\";a:1:{i:0;s:27:\"field_allocated_size_format\";}}s:12:\"foreign keys\";a:1:{s:27:\"field_allocated_size_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:27:\"field_allocated_size_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:31:\"field_data_field_allocated_size\";}s:35:\"field_revision_field_allocated_size\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:26:\"field_allocated_size_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:27:\"field_allocated_size_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:27:\"field_allocated_size_format\";a:1:{i:0;s:27:\"field_allocated_size_format\";}}s:12:\"foreign keys\";a:1:{s:27:\"field_allocated_size_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:27:\"field_allocated_size_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:35:\"field_revision_field_allocated_size\";}s:29:\"field_data_field_device_state\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:24:\"field_device_state_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:29:\"field_data_field_device_state\";}s:33:\"field_revision_field_device_state\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:24:\"field_device_state_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:33:\"field_revision_field_device_state\";}s:26:\"field_data_field_no_of_cpu\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:21:\"field_no_of_cpu_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:22:\"field_no_of_cpu_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:22:\"field_no_of_cpu_format\";a:1:{i:0;s:22:\"field_no_of_cpu_format\";}}s:12:\"foreign keys\";a:1:{s:22:\"field_no_of_cpu_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:22:\"field_no_of_cpu_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:26:\"field_data_field_no_of_cpu\";}s:30:\"field_revision_field_no_of_cpu\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:21:\"field_no_of_cpu_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:22:\"field_no_of_cpu_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:22:\"field_no_of_cpu_format\";a:1:{i:0;s:22:\"field_no_of_cpu_format\";}}s:12:\"foreign keys\";a:1:{s:22:\"field_no_of_cpu_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:22:\"field_no_of_cpu_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:30:\"field_revision_field_no_of_cpu\";}s:30:\"field_data_field_virtual_disks\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_virtual_disks_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:26:\"field_virtual_disks_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_virtual_disks_format\";a:1:{i:0;s:26:\"field_virtual_disks_format\";}}s:12:\"foreign keys\";a:1:{s:26:\"field_virtual_disks_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:26:\"field_virtual_disks_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:30:\"field_data_field_virtual_disks\";}s:34:\"field_revision_field_virtual_disks\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_virtual_disks_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:26:\"field_virtual_disks_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_virtual_disks_format\";a:1:{i:0;s:26:\"field_virtual_disks_format\";}}s:12:\"foreign keys\";a:1:{s:26:\"field_virtual_disks_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:26:\"field_virtual_disks_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:34:\"field_revision_field_virtual_disks\";}s:33:\"field_data_field_fa_build_version\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_fa_build_version_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:29:\"field_fa_build_version_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:29:\"field_fa_build_version_format\";a:1:{i:0;s:29:\"field_fa_build_version_format\";}}s:12:\"foreign keys\";a:1:{s:29:\"field_fa_build_version_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:29:\"field_fa_build_version_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:33:\"field_data_field_fa_build_version\";}s:37:\"field_revision_field_fa_build_version\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_fa_build_version_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:29:\"field_fa_build_version_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:29:\"field_fa_build_version_format\";a:1:{i:0;s:29:\"field_fa_build_version_format\";}}s:12:\"foreign keys\";a:1:{s:29:\"field_fa_build_version_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:29:\"field_fa_build_version_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:37:\"field_revision_field_fa_build_version\";}s:30:\"field_data_field_fa_cache_mode\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_fa_cache_mode_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:26:\"field_fa_cache_mode_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_fa_cache_mode_format\";a:1:{i:0;s:26:\"field_fa_cache_mode_format\";}}s:12:\"foreign keys\";a:1:{s:26:\"field_fa_cache_mode_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:26:\"field_fa_cache_mode_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:30:\"field_data_field_fa_cache_mode\";}s:34:\"field_revision_field_fa_cache_mode\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_fa_cache_mode_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:26:\"field_fa_cache_mode_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_fa_cache_mode_format\";a:1:{i:0;s:26:\"field_fa_cache_mode_format\";}}s:12:\"foreign keys\";a:1:{s:26:\"field_fa_cache_mode_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:26:\"field_fa_cache_mode_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:34:\"field_revision_field_fa_cache_mode\";}s:40:\"field_data_field_fa_administration_state\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:35:\"field_fa_administration_state_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:36:\"field_fa_administration_state_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:36:\"field_fa_administration_state_format\";a:1:{i:0;s:36:\"field_fa_administration_state_format\";}}s:12:\"foreign keys\";a:1:{s:36:\"field_fa_administration_state_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:36:\"field_fa_administration_state_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:40:\"field_data_field_fa_administration_state\";}s:44:\"field_revision_field_fa_administration_state\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:35:\"field_fa_administration_state_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:36:\"field_fa_administration_state_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:36:\"field_fa_administration_state_format\";a:1:{i:0;s:36:\"field_fa_administration_state_format\";}}s:12:\"foreign keys\";a:1:{s:36:\"field_fa_administration_state_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:36:\"field_fa_administration_state_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:44:\"field_revision_field_fa_administration_state\";}s:30:\"field_data_field_fa_cache_size\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_fa_cache_size_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:26:\"field_fa_cache_size_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_fa_cache_size_format\";a:1:{i:0;s:26:\"field_fa_cache_size_format\";}}s:12:\"foreign keys\";a:1:{s:26:\"field_fa_cache_size_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:26:\"field_fa_cache_size_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:30:\"field_data_field_fa_cache_size\";}s:34:\"field_revision_field_fa_cache_size\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_fa_cache_size_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:26:\"field_fa_cache_size_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_fa_cache_size_format\";a:1:{i:0;s:26:\"field_fa_cache_size_format\";}}s:12:\"foreign keys\";a:1:{s:26:\"field_fa_cache_size_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:26:\"field_fa_cache_size_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:34:\"field_revision_field_fa_cache_size\";}s:37:\"field_data_field_fa_operational_state\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:32:\"field_fa_operational_state_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:33:\"field_fa_operational_state_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:33:\"field_fa_operational_state_format\";a:1:{i:0;s:33:\"field_fa_operational_state_format\";}}s:12:\"foreign keys\";a:1:{s:33:\"field_fa_operational_state_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:33:\"field_fa_operational_state_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:37:\"field_data_field_fa_operational_state\";}s:41:\"field_revision_field_fa_operational_state\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:32:\"field_fa_operational_state_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:33:\"field_fa_operational_state_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:33:\"field_fa_operational_state_format\";a:1:{i:0;s:33:\"field_fa_operational_state_format\";}}s:12:\"foreign keys\";a:1:{s:33:\"field_fa_operational_state_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:33:\"field_fa_operational_state_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:41:\"field_revision_field_fa_operational_state\";}s:39:\"field_data_field_fa_operational_message\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:34:\"field_fa_operational_message_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:35:\"field_fa_operational_message_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:35:\"field_fa_operational_message_format\";a:1:{i:0;s:35:\"field_fa_operational_message_format\";}}s:12:\"foreign keys\";a:1:{s:35:\"field_fa_operational_message_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:35:\"field_fa_operational_message_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:39:\"field_data_field_fa_operational_message\";}s:43:\"field_revision_field_fa_operational_message\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:34:\"field_fa_operational_message_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:35:\"field_fa_operational_message_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:35:\"field_fa_operational_message_format\";a:1:{i:0;s:35:\"field_fa_operational_message_format\";}}s:12:\"foreign keys\";a:1:{s:35:\"field_fa_operational_message_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:35:\"field_fa_operational_message_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:43:\"field_revision_field_fa_operational_message\";}s:37:\"field_data_field_fa_performance_state\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:32:\"field_fa_performance_state_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:33:\"field_fa_performance_state_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:33:\"field_fa_performance_state_format\";a:1:{i:0;s:33:\"field_fa_performance_state_format\";}}s:12:\"foreign keys\";a:1:{s:33:\"field_fa_performance_state_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:33:\"field_fa_performance_state_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:37:\"field_data_field_fa_performance_state\";}s:41:\"field_revision_field_fa_performance_state\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:32:\"field_fa_performance_state_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:33:\"field_fa_performance_state_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:33:\"field_fa_performance_state_format\";a:1:{i:0;s:33:\"field_fa_performance_state_format\";}}s:12:\"foreign keys\";a:1:{s:33:\"field_fa_performance_state_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:33:\"field_fa_performance_state_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:41:\"field_revision_field_fa_performance_state\";}s:33:\"field_data_field_fa_generation_id\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_fa_generation_id_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:29:\"field_fa_generation_id_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:29:\"field_fa_generation_id_format\";a:1:{i:0;s:29:\"field_fa_generation_id_format\";}}s:12:\"foreign keys\";a:1:{s:29:\"field_fa_generation_id_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:29:\"field_fa_generation_id_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:33:\"field_data_field_fa_generation_id\";}s:37:\"field_revision_field_fa_generation_id\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_fa_generation_id_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:29:\"field_fa_generation_id_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:29:\"field_fa_generation_id_format\";a:1:{i:0;s:29:\"field_fa_generation_id_format\";}}s:12:\"foreign keys\";a:1:{s:29:\"field_fa_generation_id_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:29:\"field_fa_generation_id_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:37:\"field_revision_field_fa_generation_id\";}s:32:\"field_data_field_vm_read_latency\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:27:\"field_vm_read_latency_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:32:\"field_data_field_vm_read_latency\";}s:36:\"field_revision_field_vm_read_latency\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:27:\"field_vm_read_latency_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:36:\"field_revision_field_vm_read_latency\";}s:33:\"field_data_field_vm_write_latency\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_vm_write_latency_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:33:\"field_data_field_vm_write_latency\";}s:37:\"field_revision_field_vm_write_latency\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_vm_write_latency_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:37:\"field_revision_field_vm_write_latency\";}s:28:\"field_data_field_vm_read_ops\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_vm_read_ops_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:28:\"field_data_field_vm_read_ops\";}s:32:\"field_revision_field_vm_read_ops\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_vm_read_ops_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:32:\"field_revision_field_vm_read_ops\";}s:29:\"field_data_field_vm_write_ops\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:24:\"field_vm_write_ops_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:29:\"field_data_field_vm_write_ops\";}s:33:\"field_revision_field_vm_write_ops\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:24:\"field_vm_write_ops_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:33:\"field_revision_field_vm_write_ops\";}s:24:\"field_data_field_vm_hits\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:19:\"field_vm_hits_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:24:\"field_data_field_vm_hits\";}s:28:\"field_revision_field_vm_hits\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:19:\"field_vm_hits_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:28:\"field_revision_field_vm_hits\";}s:31:\"field_data_field_vm_read_blocks\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:26:\"field_vm_read_blocks_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:31:\"field_data_field_vm_read_blocks\";}s:35:\"field_revision_field_vm_read_blocks\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:26:\"field_vm_read_blocks_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:35:\"field_revision_field_vm_read_blocks\";}s:33:\"field_data_field_vm_cache_latency\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_vm_cache_latency_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:33:\"field_data_field_vm_cache_latency\";}s:37:\"field_revision_field_vm_cache_latency\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_vm_cache_latency_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:37:\"field_revision_field_vm_cache_latency\";}s:30:\"field_data_field_vm_population\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_vm_population_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:30:\"field_data_field_vm_population\";}s:34:\"field_revision_field_vm_population\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_vm_population_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:34:\"field_revision_field_vm_population\";}s:33:\"field_data_field_vm_usable_blocks\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_vm_usable_blocks_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:33:\"field_data_field_vm_usable_blocks\";}s:37:\"field_revision_field_vm_usable_blocks\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_vm_usable_blocks_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:37:\"field_revision_field_vm_usable_blocks\";}s:32:\"field_data_field_vm_write_blocks\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:27:\"field_vm_write_blocks_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:32:\"field_data_field_vm_write_blocks\";}s:36:\"field_revision_field_vm_write_blocks\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:27:\"field_vm_write_blocks_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:36:\"field_revision_field_vm_write_blocks\";}s:30:\"field_data_field_vm_insertions\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_vm_insertions_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:30:\"field_data_field_vm_insertions\";}s:34:\"field_revision_field_vm_insertions\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_vm_insertions_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:34:\"field_revision_field_vm_insertions\";}s:33:\"field_data_field_vm_population_pc\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_vm_population_pc_value\";a:5:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";i:0;s:7:\"default\";s:1:\"0\";}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:33:\"field_data_field_vm_population_pc\";}s:37:\"field_revision_field_vm_population_pc\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_vm_population_pc_value\";a:5:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";i:0;s:7:\"default\";s:1:\"0\";}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:37:\"field_revision_field_vm_population_pc\";}s:37:\"field_data_field_vm_insertion_rate_pc\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:32:\"field_vm_insertion_rate_pc_value\";a:5:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";i:0;s:7:\"default\";s:1:\"0\";}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:37:\"field_data_field_vm_insertion_rate_pc\";}s:41:\"field_revision_field_vm_insertion_rate_pc\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:32:\"field_vm_insertion_rate_pc_value\";a:5:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";i:0;s:7:\"default\";s:1:\"0\";}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:41:\"field_revision_field_vm_insertion_rate_pc\";}s:22:\"field_data_field_vdisk\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:21:\"field_vdisk_target_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_vdisk_target_id\";a:1:{i:0;s:21:\"field_vdisk_target_id\";}}s:12:\"foreign keys\";a:1:{s:16:\"field_vdisk_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:21:\"field_vdisk_target_id\";s:3:\"nid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:22:\"field_data_field_vdisk\";}s:26:\"field_revision_field_vdisk\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:21:\"field_vdisk_target_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_vdisk_target_id\";a:1:{i:0;s:21:\"field_vdisk_target_id\";}}s:12:\"foreign keys\";a:1:{s:16:\"field_vdisk_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:21:\"field_vdisk_target_id\";s:3:\"nid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:26:\"field_revision_field_vdisk\";}s:35:\"field_data_field_vdisk_read_latency\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:30:\"field_vdisk_read_latency_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:35:\"field_data_field_vdisk_read_latency\";}s:39:\"field_revision_field_vdisk_read_latency\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:30:\"field_vdisk_read_latency_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:39:\"field_revision_field_vdisk_read_latency\";}s:36:\"field_data_field_vdisk_write_latency\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:31:\"field_vdisk_write_latency_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:36:\"field_data_field_vdisk_write_latency\";}s:40:\"field_revision_field_vdisk_write_latency\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:31:\"field_vdisk_write_latency_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:40:\"field_revision_field_vdisk_write_latency\";}s:31:\"field_data_field_vdisk_read_ops\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:26:\"field_vdisk_read_ops_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:31:\"field_data_field_vdisk_read_ops\";}s:35:\"field_revision_field_vdisk_read_ops\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:26:\"field_vdisk_read_ops_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:35:\"field_revision_field_vdisk_read_ops\";}s:32:\"field_data_field_vdisk_write_ops\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:27:\"field_vdisk_write_ops_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:32:\"field_data_field_vdisk_write_ops\";}s:36:\"field_revision_field_vdisk_write_ops\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:27:\"field_vdisk_write_ops_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:36:\"field_revision_field_vdisk_write_ops\";}s:27:\"field_data_field_vdisk_hits\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_vdisk_hits_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:27:\"field_data_field_vdisk_hits\";}s:31:\"field_revision_field_vdisk_hits\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_vdisk_hits_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:31:\"field_revision_field_vdisk_hits\";}s:34:\"field_data_field_vdisk_read_blocks\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:29:\"field_vdisk_read_blocks_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:34:\"field_data_field_vdisk_read_blocks\";}s:38:\"field_revision_field_vdisk_read_blocks\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:29:\"field_vdisk_read_blocks_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:38:\"field_revision_field_vdisk_read_blocks\";}s:36:\"field_data_field_vdisk_cache_latency\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:31:\"field_vdisk_cache_latency_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:36:\"field_data_field_vdisk_cache_latency\";}s:40:\"field_revision_field_vdisk_cache_latency\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:31:\"field_vdisk_cache_latency_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:40:\"field_revision_field_vdisk_cache_latency\";}s:33:\"field_data_field_vdisk_population\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_vdisk_population_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:33:\"field_data_field_vdisk_population\";}s:37:\"field_revision_field_vdisk_population\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_vdisk_population_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:37:\"field_revision_field_vdisk_population\";}s:36:\"field_data_field_vdisk_usable_blocks\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:31:\"field_vdisk_usable_blocks_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:36:\"field_data_field_vdisk_usable_blocks\";}s:40:\"field_revision_field_vdisk_usable_blocks\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:31:\"field_vdisk_usable_blocks_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:40:\"field_revision_field_vdisk_usable_blocks\";}s:33:\"field_data_field_vdisk_insertions\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_vdisk_insertions_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:33:\"field_data_field_vdisk_insertions\";}s:37:\"field_revision_field_vdisk_insertions\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_vdisk_insertions_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:37:\"field_revision_field_vdisk_insertions\";}s:35:\"field_data_field_vdisk_write_blocks\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:30:\"field_vdisk_write_blocks_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:35:\"field_data_field_vdisk_write_blocks\";}s:39:\"field_revision_field_vdisk_write_blocks\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:30:\"field_vdisk_write_blocks_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:39:\"field_revision_field_vdisk_write_blocks\";}s:26:\"field_data_field_timestamp\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:21:\"field_timestamp_value\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;s:8:\"sortable\";b:1;s:5:\"views\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:26:\"field_data_field_timestamp\";}s:30:\"field_revision_field_timestamp\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:21:\"field_timestamp_value\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;s:8:\"sortable\";b:1;s:5:\"views\";b:1;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:30:\"field_revision_field_timestamp\";}s:36:\"field_data_field_vdisk_population_pc\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:31:\"field_vdisk_population_pc_value\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"32\";s:8:\"not null\";i:0;s:7:\"default\";s:1:\"0\";}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:36:\"field_data_field_vdisk_population_pc\";}s:40:\"field_revision_field_vdisk_population_pc\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:31:\"field_vdisk_population_pc_value\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"32\";s:8:\"not null\";i:0;s:7:\"default\";s:1:\"0\";}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:40:\"field_revision_field_vdisk_population_pc\";}s:40:\"field_data_field_vdisk_insertion_rate_pc\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:35:\"field_vdisk_insertion_rate_pc_value\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"32\";s:8:\"not null\";i:0;s:7:\"default\";s:1:\"0\";}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:40:\"field_data_field_vdisk_insertion_rate_pc\";}s:44:\"field_revision_field_vdisk_insertion_rate_pc\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:35:\"field_vdisk_insertion_rate_pc_value\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"32\";s:8:\"not null\";i:0;s:7:\"default\";s:1:\"0\";}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:44:\"field_revision_field_vdisk_insertion_rate_pc\";}s:27:\"field_data_field_disk_index\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_disk_index_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:27:\"field_data_field_disk_index\";}s:31:\"field_revision_field_disk_index\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_disk_index_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:31:\"field_revision_field_disk_index\";}s:27:\"field_data_field_cachespace\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_cachespace_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:23:\"field_cachespace_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:23:\"field_cachespace_format\";a:1:{i:0;s:23:\"field_cachespace_format\";}}s:12:\"foreign keys\";a:1:{s:23:\"field_cachespace_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:23:\"field_cachespace_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:27:\"field_data_field_cachespace\";}s:31:\"field_revision_field_cachespace\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_cachespace_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:23:\"field_cachespace_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:23:\"field_cachespace_format\";a:1:{i:0;s:23:\"field_cachespace_format\";}}s:12:\"foreign keys\";a:1:{s:23:\"field_cachespace_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:23:\"field_cachespace_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:31:\"field_revision_field_cachespace\";}s:33:\"field_data_field_vdisk_identifier\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_vdisk_identifier_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:29:\"field_vdisk_identifier_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:29:\"field_vdisk_identifier_format\";a:1:{i:0;s:29:\"field_vdisk_identifier_format\";}}s:12:\"foreign keys\";a:1:{s:29:\"field_vdisk_identifier_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:29:\"field_vdisk_identifier_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:33:\"field_data_field_vdisk_identifier\";}s:37:\"field_revision_field_vdisk_identifier\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_vdisk_identifier_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:29:\"field_vdisk_identifier_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:29:\"field_vdisk_identifier_format\";a:1:{i:0;s:29:\"field_vdisk_identifier_format\";}}s:12:\"foreign keys\";a:1:{s:29:\"field_vdisk_identifier_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:29:\"field_vdisk_identifier_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:37:\"field_revision_field_vdisk_identifier\";}s:30:\"field_data_field_vm_cache_size\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_vm_cache_size_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:26:\"field_vm_cache_size_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_vm_cache_size_format\";a:1:{i:0;s:26:\"field_vm_cache_size_format\";}}s:12:\"foreign keys\";a:1:{s:26:\"field_vm_cache_size_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:26:\"field_vm_cache_size_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:30:\"field_data_field_vm_cache_size\";}s:34:\"field_revision_field_vm_cache_size\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_vm_cache_size_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:26:\"field_vm_cache_size_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_vm_cache_size_format\";a:1:{i:0;s:26:\"field_vm_cache_size_format\";}}s:12:\"foreign keys\";a:1:{s:26:\"field_vm_cache_size_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:26:\"field_vm_cache_size_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:34:\"field_revision_field_vm_cache_size\";}s:41:\"field_data_field_cache_assigned_from_host\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:34:\"field_cache_assigned_from_host_nid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:34:\"field_cache_assigned_from_host_nid\";a:1:{i:0;s:34:\"field_cache_assigned_from_host_nid\";}}s:12:\"foreign keys\";a:1:{s:34:\"field_cache_assigned_from_host_nid\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:34:\"field_cache_assigned_from_host_nid\";s:3:\"nid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:41:\"field_data_field_cache_assigned_from_host\";}s:45:\"field_revision_field_cache_assigned_from_host\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:34:\"field_cache_assigned_from_host_nid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:34:\"field_cache_assigned_from_host_nid\";a:1:{i:0;s:34:\"field_cache_assigned_from_host_nid\";}}s:12:\"foreign keys\";a:1:{s:34:\"field_cache_assigned_from_host_nid\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:34:\"field_cache_assigned_from_host_nid\";s:3:\"nid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:45:\"field_revision_field_cache_assigned_from_host\";}s:38:\"field_data_field_cache_allocated_to_vm\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:31:\"field_cache_allocated_to_vm_nid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:31:\"field_cache_allocated_to_vm_nid\";a:1:{i:0;s:31:\"field_cache_allocated_to_vm_nid\";}}s:12:\"foreign keys\";a:1:{s:31:\"field_cache_allocated_to_vm_nid\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:31:\"field_cache_allocated_to_vm_nid\";s:3:\"nid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:38:\"field_data_field_cache_allocated_to_vm\";}s:42:\"field_revision_field_cache_allocated_to_vm\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:31:\"field_cache_allocated_to_vm_nid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:31:\"field_cache_allocated_to_vm_nid\";a:1:{i:0;s:31:\"field_cache_allocated_to_vm_nid\";}}s:12:\"foreign keys\";a:1:{s:31:\"field_cache_allocated_to_vm_nid\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:31:\"field_cache_allocated_to_vm_nid\";s:3:\"nid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:42:\"field_revision_field_cache_allocated_to_vm\";}s:29:\"field_data_field_install_port\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:24:\"field_install_port_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:29:\"field_data_field_install_port\";}s:33:\"field_revision_field_install_port\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:24:\"field_install_port_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:33:\"field_revision_field_install_port\";}s:27:\"field_data_field_host_model\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_host_model_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:23:\"field_host_model_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:23:\"field_host_model_format\";a:1:{i:0;s:23:\"field_host_model_format\";}}s:12:\"foreign keys\";a:1:{s:23:\"field_host_model_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:23:\"field_host_model_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:27:\"field_data_field_host_model\";}s:31:\"field_revision_field_host_model\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_host_model_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:23:\"field_host_model_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:23:\"field_host_model_format\";a:1:{i:0;s:23:\"field_host_model_format\";}}s:12:\"foreign keys\";a:1:{s:23:\"field_host_model_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:23:\"field_host_model_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:31:\"field_revision_field_host_model\";}s:28:\"field_data_field_host_vendor\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_host_vendor_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:24:\"field_host_vendor_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_host_vendor_format\";a:1:{i:0;s:24:\"field_host_vendor_format\";}}s:12:\"foreign keys\";a:1:{s:24:\"field_host_vendor_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:24:\"field_host_vendor_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:28:\"field_data_field_host_vendor\";}s:32:\"field_revision_field_host_vendor\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_host_vendor_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:24:\"field_host_vendor_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_host_vendor_format\";a:1:{i:0;s:24:\"field_host_vendor_format\";}}s:12:\"foreign keys\";a:1:{s:24:\"field_host_vendor_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:24:\"field_host_vendor_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:32:\"field_revision_field_host_vendor\";}s:31:\"field_data_field_vm_vmotionable\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:26:\"field_vm_vmotionable_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_vm_vmotionable_value\";a:1:{i:0;s:26:\"field_vm_vmotionable_value\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:31:\"field_data_field_vm_vmotionable\";}s:35:\"field_revision_field_vm_vmotionable\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:26:\"field_vm_vmotionable_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:26:\"field_vm_vmotionable_value\";a:1:{i:0;s:26:\"field_vm_vmotionable_value\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:35:\"field_revision_field_vm_vmotionable\";}s:21:\"field_data_field_hbtl\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:16:\"field_hbtl_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:17:\"field_hbtl_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:17:\"field_hbtl_format\";a:1:{i:0;s:17:\"field_hbtl_format\";}}s:12:\"foreign keys\";a:1:{s:17:\"field_hbtl_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:17:\"field_hbtl_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:21:\"field_data_field_hbtl\";}s:25:\"field_revision_field_hbtl\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:16:\"field_hbtl_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:17:\"field_hbtl_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:17:\"field_hbtl_format\";a:1:{i:0;s:17:\"field_hbtl_format\";}}s:12:\"foreign keys\";a:1:{s:17:\"field_hbtl_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:17:\"field_hbtl_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:25:\"field_revision_field_hbtl\";}s:24:\"field_data_field_is_vmfs\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:19:\"field_is_vmfs_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"10\";s:8:\"not null\";b:0;}s:20:\"field_is_vmfs_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:20:\"field_is_vmfs_format\";a:1:{i:0;s:20:\"field_is_vmfs_format\";}}s:12:\"foreign keys\";a:1:{s:20:\"field_is_vmfs_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:20:\"field_is_vmfs_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:24:\"field_data_field_is_vmfs\";}s:28:\"field_revision_field_is_vmfs\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:19:\"field_is_vmfs_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"10\";s:8:\"not null\";b:0;}s:20:\"field_is_vmfs_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:20:\"field_is_vmfs_format\";a:1:{i:0;s:20:\"field_is_vmfs_format\";}}s:12:\"foreign keys\";a:1:{s:20:\"field_is_vmfs_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:20:\"field_is_vmfs_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:28:\"field_revision_field_is_vmfs\";}s:33:\"field_data_field_fa_usable_blocks\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_fa_usable_blocks_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:29:\"field_fa_usable_blocks_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:29:\"field_fa_usable_blocks_format\";a:1:{i:0;s:29:\"field_fa_usable_blocks_format\";}}s:12:\"foreign keys\";a:1:{s:29:\"field_fa_usable_blocks_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:29:\"field_fa_usable_blocks_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:33:\"field_data_field_fa_usable_blocks\";}s:37:\"field_revision_field_fa_usable_blocks\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:28:\"field_fa_usable_blocks_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:29:\"field_fa_usable_blocks_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:29:\"field_fa_usable_blocks_format\";a:1:{i:0;s:29:\"field_fa_usable_blocks_format\";}}s:12:\"foreign keys\";a:1:{s:29:\"field_fa_usable_blocks_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:29:\"field_fa_usable_blocks_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:37:\"field_revision_field_fa_usable_blocks\";}s:27:\"field_data_field_vdisk_name\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_vdisk_name_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:23:\"field_vdisk_name_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:23:\"field_vdisk_name_format\";a:1:{i:0;s:23:\"field_vdisk_name_format\";}}s:12:\"foreign keys\";a:1:{s:23:\"field_vdisk_name_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:23:\"field_vdisk_name_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:27:\"field_data_field_vdisk_name\";}s:31:\"field_revision_field_vdisk_name\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_vdisk_name_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:23:\"field_vdisk_name_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:23:\"field_vdisk_name_format\";a:1:{i:0;s:23:\"field_vdisk_name_format\";}}s:12:\"foreign keys\";a:1:{s:23:\"field_vdisk_name_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:23:\"field_vdisk_name_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:31:\"field_revision_field_vdisk_name\";}s:27:\"field_data_field_vdisk_type\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_vdisk_type_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:23:\"field_vdisk_type_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:23:\"field_vdisk_type_format\";a:1:{i:0;s:23:\"field_vdisk_type_format\";}}s:12:\"foreign keys\";a:1:{s:23:\"field_vdisk_type_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:23:\"field_vdisk_type_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:27:\"field_data_field_vdisk_type\";}s:31:\"field_revision_field_vdisk_type\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:22:\"field_vdisk_type_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:23:\"field_vdisk_type_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:23:\"field_vdisk_type_format\";a:1:{i:0;s:23:\"field_vdisk_type_format\";}}s:12:\"foreign keys\";a:1:{s:23:\"field_vdisk_type_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:23:\"field_vdisk_type_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:31:\"field_revision_field_vdisk_type\";}s:25:\"field_data_field_vdisk_id\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_vdisk_id_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:21:\"field_vdisk_id_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_vdisk_id_format\";a:1:{i:0;s:21:\"field_vdisk_id_format\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_vdisk_id_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:21:\"field_vdisk_id_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:25:\"field_data_field_vdisk_id\";}s:29:\"field_revision_field_vdisk_id\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_vdisk_id_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:21:\"field_vdisk_id_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_vdisk_id_format\";a:1:{i:0;s:21:\"field_vdisk_id_format\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_vdisk_id_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:21:\"field_vdisk_id_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:29:\"field_revision_field_vdisk_id\";}s:24:\"field_data_field_host_ip\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:19:\"field_host_ip_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:20:\"field_host_ip_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:20:\"field_host_ip_format\";a:1:{i:0;s:20:\"field_host_ip_format\";}}s:12:\"foreign keys\";a:1:{s:20:\"field_host_ip_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:20:\"field_host_ip_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:24:\"field_data_field_host_ip\";}s:28:\"field_revision_field_host_ip\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:19:\"field_host_ip_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:20:\"field_host_ip_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:20:\"field_host_ip_format\";a:1:{i:0;s:20:\"field_host_ip_format\";}}s:12:\"foreign keys\";a:1:{s:20:\"field_host_ip_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:20:\"field_host_ip_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:28:\"field_revision_field_host_ip\";}s:24:\"field_data_field_hit_ops\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:19:\"field_hit_ops_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:24:\"field_data_field_hit_ops\";}s:28:\"field_revision_field_hit_ops\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:19:\"field_hit_ops_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:28:\"field_revision_field_hit_ops\";}s:31:\"field_data_field_fa_sector_size\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:26:\"field_fa_sector_size_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"10\";s:8:\"not null\";b:0;}s:27:\"field_fa_sector_size_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:27:\"field_fa_sector_size_format\";a:1:{i:0;s:27:\"field_fa_sector_size_format\";}}s:12:\"foreign keys\";a:1:{s:27:\"field_fa_sector_size_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:27:\"field_fa_sector_size_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:31:\"field_data_field_fa_sector_size\";}s:35:\"field_revision_field_fa_sector_size\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:26:\"field_fa_sector_size_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"10\";s:8:\"not null\";b:0;}s:27:\"field_fa_sector_size_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:27:\"field_fa_sector_size_format\";a:1:{i:0;s:27:\"field_fa_sector_size_format\";}}s:12:\"foreign keys\";a:1:{s:27:\"field_fa_sector_size_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:27:\"field_fa_sector_size_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:35:\"field_revision_field_fa_sector_size\";}s:34:\"field_data_field_rediscover_status\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:29:\"field_rediscover_status_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:30:\"field_rediscover_status_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:30:\"field_rediscover_status_format\";a:1:{i:0;s:30:\"field_rediscover_status_format\";}}s:12:\"foreign keys\";a:1:{s:30:\"field_rediscover_status_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:30:\"field_rediscover_status_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:34:\"field_data_field_rediscover_status\";}s:38:\"field_revision_field_rediscover_status\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:29:\"field_rediscover_status_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:30:\"field_rediscover_status_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:30:\"field_rediscover_status_format\";a:1:{i:0;s:30:\"field_rediscover_status_format\";}}s:12:\"foreign keys\";a:1:{s:30:\"field_rediscover_status_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:30:\"field_rediscover_status_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:38:\"field_revision_field_rediscover_status\";}s:25:\"field_data_field_hostname\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_hostname_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:21:\"field_hostname_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_hostname_format\";a:1:{i:0;s:21:\"field_hostname_format\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_hostname_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:21:\"field_hostname_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:25:\"field_data_field_hostname\";}s:29:\"field_revision_field_hostname\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_hostname_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:21:\"field_hostname_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_hostname_format\";a:1:{i:0;s:21:\"field_hostname_format\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_hostname_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:21:\"field_hostname_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:29:\"field_revision_field_hostname\";}s:28:\"field_data_field_vm_hostname\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_vm_hostname_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:24:\"field_vm_hostname_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_vm_hostname_format\";a:1:{i:0;s:24:\"field_vm_hostname_format\";}}s:12:\"foreign keys\";a:1:{s:24:\"field_vm_hostname_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:24:\"field_vm_hostname_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:28:\"field_data_field_vm_hostname\";}s:32:\"field_revision_field_vm_hostname\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_vm_hostname_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:24:\"field_vm_hostname_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_vm_hostname_format\";a:1:{i:0;s:24:\"field_vm_hostname_format\";}}s:12:\"foreign keys\";a:1:{s:24:\"field_vm_hostname_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:24:\"field_vm_hostname_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:32:\"field_revision_field_vm_hostname\";}s:42:\"field_data_field_fa_metrics_reset_interval\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:37:\"field_fa_metrics_reset_interval_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:38:\"field_fa_metrics_reset_interval_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:38:\"field_fa_metrics_reset_interval_format\";a:1:{i:0;s:38:\"field_fa_metrics_reset_interval_format\";}}s:12:\"foreign keys\";a:1:{s:38:\"field_fa_metrics_reset_interval_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:38:\"field_fa_metrics_reset_interval_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:42:\"field_data_field_fa_metrics_reset_interval\";}s:46:\"field_revision_field_fa_metrics_reset_interval\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:37:\"field_fa_metrics_reset_interval_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:38:\"field_fa_metrics_reset_interval_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:38:\"field_fa_metrics_reset_interval_format\";a:1:{i:0;s:38:\"field_fa_metrics_reset_interval_format\";}}s:12:\"foreign keys\";a:1:{s:38:\"field_fa_metrics_reset_interval_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:38:\"field_fa_metrics_reset_interval_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:46:\"field_revision_field_fa_metrics_reset_interval\";}s:25:\"field_data_field_fmc_uuid\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_fmc_uuid_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:21:\"field_fmc_uuid_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_fmc_uuid_format\";a:1:{i:0;s:21:\"field_fmc_uuid_format\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_fmc_uuid_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:21:\"field_fmc_uuid_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:25:\"field_data_field_fmc_uuid\";}s:29:\"field_revision_field_fmc_uuid\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:20:\"field_fmc_uuid_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:21:\"field_fmc_uuid_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_fmc_uuid_format\";a:1:{i:0;s:21:\"field_fmc_uuid_format\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_fmc_uuid_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:21:\"field_fmc_uuid_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:29:\"field_revision_field_fmc_uuid\";}s:31:\"field_data_field_vm_hit_rate_pc\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:26:\"field_vm_hit_rate_pc_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"32\";s:8:\"not null\";i:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:31:\"field_data_field_vm_hit_rate_pc\";}s:35:\"field_revision_field_vm_hit_rate_pc\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:26:\"field_vm_hit_rate_pc_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"32\";s:8:\"not null\";i:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:35:\"field_revision_field_vm_hit_rate_pc\";}s:34:\"field_data_field_vm_vmotion_policy\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:29:\"field_vm_vmotion_policy_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:30:\"field_vm_vmotion_policy_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:30:\"field_vm_vmotion_policy_format\";a:1:{i:0;s:30:\"field_vm_vmotion_policy_format\";}}s:12:\"foreign keys\";a:1:{s:30:\"field_vm_vmotion_policy_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:30:\"field_vm_vmotion_policy_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:34:\"field_data_field_vm_vmotion_policy\";}s:38:\"field_revision_field_vm_vmotion_policy\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:29:\"field_vm_vmotion_policy_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:30:\"field_vm_vmotion_policy_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:30:\"field_vm_vmotion_policy_format\";a:1:{i:0;s:30:\"field_vm_vmotion_policy_format\";}}s:12:\"foreign keys\";a:1:{s:30:\"field_vm_vmotion_policy_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:30:\"field_vm_vmotion_policy_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:38:\"field_revision_field_vm_vmotion_policy\";}s:36:\"field_data_field_vm_vmotion_hostlist\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:31:\"field_vm_vmotion_hostlist_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:4:\"1000\";s:8:\"not null\";b:0;}s:32:\"field_vm_vmotion_hostlist_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:32:\"field_vm_vmotion_hostlist_format\";a:1:{i:0;s:32:\"field_vm_vmotion_hostlist_format\";}}s:12:\"foreign keys\";a:1:{s:32:\"field_vm_vmotion_hostlist_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:32:\"field_vm_vmotion_hostlist_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:36:\"field_data_field_vm_vmotion_hostlist\";}s:40:\"field_revision_field_vm_vmotion_hostlist\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:31:\"field_vm_vmotion_hostlist_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:4:\"1000\";s:8:\"not null\";b:0;}s:32:\"field_vm_vmotion_hostlist_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:32:\"field_vm_vmotion_hostlist_format\";a:1:{i:0;s:32:\"field_vm_vmotion_hostlist_format\";}}s:12:\"foreign keys\";a:1:{s:32:\"field_vm_vmotion_hostlist_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:32:\"field_vm_vmotion_hostlist_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:40:\"field_revision_field_vm_vmotion_hostlist\";}s:20:\"field_data_field_drs\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:15:\"field_drs_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:20:\"field_data_field_drs\";}s:24:\"field_revision_field_drs\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:15:\"field_drs_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:24:\"field_revision_field_drs\";}s:19:\"field_data_field_ha\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:14:\"field_ha_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:19:\"field_data_field_ha\";}s:23:\"field_revision_field_ha\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:14:\"field_ha_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:23:\"field_revision_field_ha\";}s:34:\"field_data_field_vdisk_hit_rate_pc\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:29:\"field_vdisk_hit_rate_pc_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"32\";s:8:\"not null\";i:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:34:\"field_data_field_vdisk_hit_rate_pc\";}s:38:\"field_revision_field_vdisk_hit_rate_pc\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:29:\"field_vdisk_hit_rate_pc_value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"32\";s:8:\"not null\";i:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:38:\"field_revision_field_vdisk_hit_rate_pc\";}s:6:\"filter\";a:5:{s:6:\"fields\";a:6:{s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:8:\"settings\";a:4:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:11:\"primary key\";a:2:{i:0;s:6:\"format\";i:1;s:4:\"name\";}s:7:\"indexes\";a:1:{s:4:\"list\";a:3:{i:0;s:6:\"weight\";i:1;s:6:\"module\";i:2;s:4:\"name\";}}s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:6:\"filter\";}s:13:\"filter_format\";a:6:{s:6:\"fields\";a:5:{s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:4:\"name\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:5:\"cache\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:6:\"status\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:1;s:4:\"size\";s:4:\"tiny\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:6:\"format\";}s:11:\"unique keys\";a:1:{s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:7:\"indexes\";a:1:{s:13:\"status_weight\";a:2:{i:0;s:6:\"status\";i:1;s:6:\"weight\";}}s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:13:\"filter_format\";}s:12:\"cache_filter\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:12:\"cache_filter\";}s:17:\"login_destination\";a:5:{s:6:\"fields\";a:8:{s:2:\"id\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"triggers\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;}s:5:\"roles\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;}s:10:\"pages_type\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:5:\"pages\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;}s:16:\"destination_type\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:11:\"destination\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:7:\"indexes\";a:1:{s:4:\"list\";a:1:{i:0;s:6:\"weight\";}}s:6:\"module\";s:17:\"login_destination\";s:4:\"name\";s:17:\"login_destination\";}s:11:\"menu_custom\";a:4:{s:6:\"fields\";a:3:{s:9:\"menu_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"title\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:11:\"description\";a:3:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;s:12:\"translatable\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:9:\"menu_name\";}s:6:\"module\";s:4:\"menu\";s:4:\"name\";s:11:\"menu_custom\";}s:42:\"mercury_utilities_import_saved_credentials\";a:5:{s:6:\"fields\";a:6:{s:2:\"id\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:4:\"type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}s:5:\"title\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:8:\"username\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:8:\"password\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:12:\"install_port\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:10;}}s:11:\"unique keys\";a:1:{s:10:\"title_type\";a:2:{i:0;s:5:\"title\";i:1;s:4:\"type\";}}s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:6:\"module\";s:17:\"mercury_utilities\";s:4:\"name\";s:42:\"mercury_utilities_import_saved_credentials\";}s:4:\"node\";a:7:{s:6:\"fields\";a:14:{s:3:\"nid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"vid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;s:7:\"default\";N;}s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"changed\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"comment\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"promote\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"sticky\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"tnid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"translate\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:9:{s:12:\"node_changed\";a:1:{i:0;s:7:\"changed\";}s:12:\"node_created\";a:1:{i:0;s:7:\"created\";}s:14:\"node_frontpage\";a:4:{i:0;s:7:\"promote\";i:1;s:6:\"status\";i:2;s:6:\"sticky\";i:3;s:7:\"created\";}s:16:\"node_status_type\";a:3:{i:0;s:6:\"status\";i:1;s:4:\"type\";i:2;s:3:\"nid\";}s:15:\"node_title_type\";a:2:{i:0;s:5:\"title\";i:1;a:2:{i:0;s:4:\"type\";i:1;i:4;}}s:9:\"node_type\";a:1:{i:0;a:2:{i:0;s:4:\"type\";i:1;i:4;}}s:3:\"uid\";a:1:{i:0;s:3:\"uid\";}s:4:\"tnid\";a:1:{i:0;s:4:\"tnid\";}s:9:\"translate\";a:1:{i:0;s:9:\"translate\";}}s:11:\"unique keys\";a:1:{s:3:\"vid\";a:1:{i:0;s:3:\"vid\";}}s:12:\"foreign keys\";a:2:{s:13:\"node_revision\";a:2:{s:5:\"table\";s:13:\"node_revision\";s:7:\"columns\";a:1:{s:3:\"vid\";s:3:\"vid\";}}s:11:\"node_author\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:11:\"primary key\";a:1:{i:0;s:3:\"nid\";}s:6:\"module\";s:4:\"node\";s:4:\"name\";s:4:\"node\";}s:11:\"node_access\";a:5:{s:6:\"fields\";a:6:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"gid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"realm\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:10:\"grant_view\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:12:\"grant_update\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:12:\"grant_delete\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}}s:11:\"primary key\";a:3:{i:0;s:3:\"nid\";i:1;s:3:\"gid\";i:2;s:5:\"realm\";}s:12:\"foreign keys\";a:1:{s:13:\"affected_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:3:\"nid\";s:3:\"nid\";}}}s:6:\"module\";s:4:\"node\";s:4:\"name\";s:11:\"node_access\";}s:13:\"node_revision\";a:6:{s:6:\"fields\";a:10:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"vid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"log\";a:3:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;s:4:\"size\";s:3:\"big\";}s:9:\"timestamp\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}s:7:\"comment\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"promote\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"sticky\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:2:{s:3:\"nid\";a:1:{i:0;s:3:\"nid\";}s:3:\"uid\";a:1:{i:0;s:3:\"uid\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"vid\";}s:12:\"foreign keys\";a:2:{s:14:\"versioned_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:3:\"nid\";s:3:\"nid\";}}s:14:\"version_author\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:6:\"module\";s:4:\"node\";s:4:\"name\";s:13:\"node_revision\";}s:9:\"node_type\";a:4:{s:6:\"fields\";a:13:{s:4:\"type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}s:4:\"name\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:4:\"base\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:6:\"module\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:11:\"description\";a:4:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;s:4:\"size\";s:6:\"medium\";s:12:\"translatable\";b:1;}s:4:\"help\";a:4:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;s:4:\"size\";s:6:\"medium\";s:12:\"translatable\";b:1;}s:9:\"has_title\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:4:\"size\";s:4:\"tiny\";}s:11:\"title_label\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:6:\"custom\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:8:\"modified\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:6:\"locked\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:8:\"disabled\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:9:\"orig_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:11:\"primary key\";a:1:{i:0;s:4:\"type\";}s:6:\"module\";s:4:\"node\";s:4:\"name\";s:9:\"node_type\";}s:15:\"block_node_type\";a:5:{s:6:\"fields\";a:3:{s:6:\"module\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;}s:5:\"delta\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}s:4:\"type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:3:{i:0;s:6:\"module\";i:1;s:5:\"delta\";i:2;s:4:\"type\";}s:7:\"indexes\";a:1:{s:4:\"type\";a:1:{i:0;s:4:\"type\";}}s:6:\"module\";s:4:\"node\";s:4:\"name\";s:15:\"block_node_type\";}s:7:\"history\";a:5:{s:6:\"fields\";a:3:{s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"nid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"timestamp\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:2:{i:0;s:3:\"uid\";i:1;s:3:\"nid\";}s:7:\"indexes\";a:1:{s:3:\"nid\";a:1:{i:0;s:3:\"nid\";}}s:6:\"module\";s:4:\"node\";s:4:\"name\";s:7:\"history\";}s:14:\"panels_display\";a:5:{s:6:\"export\";a:5:{s:6:\"object\";s:14:\"panels_display\";s:11:\"bulk export\";b:0;s:15:\"export callback\";s:21:\"panels_export_display\";s:11:\"can disable\";b:0;s:10:\"identifier\";s:7:\"display\";}s:6:\"fields\";a:8:{s:3:\"did\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;s:9:\"no export\";b:1;}s:6:\"layout\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:7:\"default\";s:0:\"\";}s:15:\"layout_settings\";a:5:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}s:7:\"initial\";a:0:{}}s:14:\"panel_settings\";a:5:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}s:7:\"initial\";a:0:{}}s:5:\"cache\";a:4:{s:4:\"type\";s:4:\"text\";s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}s:7:\"initial\";a:0:{}}s:5:\"title\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:7:\"default\";s:0:\"\";}s:10:\"hide_title\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:7:\"default\";i:0;s:9:\"no export\";b:1;}s:10:\"title_pane\";a:3:{s:4:\"type\";s:3:\"int\";s:7:\"default\";i:0;s:9:\"no export\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:3:\"did\";}s:6:\"module\";s:6:\"panels\";s:4:\"name\";s:14:\"panels_display\";}s:11:\"panels_pane\";a:6:{s:6:\"export\";a:3:{s:11:\"can disable\";b:0;s:10:\"identifier\";s:4:\"pane\";s:11:\"bulk export\";b:0;}s:6:\"fields\";a:14:{s:3:\"pid\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:3:\"did\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:9:\"no export\";b:1;}s:5:\"panel\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"32\";s:7:\"default\";s:0:\"\";}s:4:\"type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"32\";s:7:\"default\";s:0:\"\";}s:7:\"subtype\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"64\";s:7:\"default\";s:0:\"\";}s:5:\"shown\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:7:\"default\";i:1;}s:6:\"access\";a:5:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}s:7:\"initial\";a:0:{}}s:13:\"configuration\";a:5:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}s:7:\"initial\";a:0:{}}s:5:\"cache\";a:5:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}s:7:\"initial\";a:0:{}}s:5:\"style\";a:5:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}s:7:\"initial\";a:0:{}}s:3:\"css\";a:5:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}s:7:\"initial\";a:0:{}}s:6:\"extras\";a:5:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}s:7:\"initial\";a:0:{}}s:8:\"position\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:7:\"default\";i:0;}s:5:\"locks\";a:5:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}s:7:\"initial\";a:0:{}}}s:11:\"primary key\";a:1:{i:0;s:3:\"pid\";}s:7:\"indexes\";a:1:{s:7:\"did_idx\";a:1:{i:0;s:3:\"did\";}}s:6:\"module\";s:6:\"panels\";s:4:\"name\";s:11:\"panels_pane\";}s:24:\"panels_renderer_pipeline\";a:5:{s:6:\"export\";a:4:{s:10:\"identifier\";s:8:\"pipeline\";s:11:\"bulk export\";b:1;s:11:\"primary key\";s:4:\"rpid\";s:3:\"api\";a:4:{s:5:\"owner\";s:6:\"panels\";s:3:\"api\";s:9:\"pipelines\";s:15:\"minimum_version\";i:1;s:15:\"current_version\";i:1;}}s:6:\"fields\";a:6:{s:4:\"rpid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;s:9:\"no export\";b:1;}s:4:\"name\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:11:\"admin_title\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:17:\"admin_description\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:14:\"object default\";s:0:\"\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:7:\"default\";i:0;}s:8:\"settings\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}}}s:11:\"primary key\";a:1:{i:0;s:4:\"rpid\";}s:6:\"module\";s:6:\"panels\";s:4:\"name\";s:24:\"panels_renderer_pipeline\";}s:13:\"panels_layout\";a:5:{s:6:\"export\";a:4:{s:10:\"identifier\";s:6:\"layout\";s:11:\"bulk export\";b:1;s:11:\"primary key\";s:3:\"lid\";s:3:\"api\";a:4:{s:5:\"owner\";s:6:\"panels\";s:3:\"api\";s:7:\"layouts\";s:15:\"minimum_version\";i:1;s:15:\"current_version\";i:1;}}s:6:\"fields\";a:7:{s:3:\"lid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;s:9:\"no export\";b:1;}s:4:\"name\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:11:\"admin_title\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:17:\"admin_description\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:14:\"object default\";s:0:\"\";}s:8:\"category\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:6:\"plugin\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:8:\"settings\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}}}s:11:\"primary key\";a:1:{i:0;s:3:\"lid\";}s:6:\"module\";s:6:\"panels\";s:4:\"name\";s:13:\"panels_layout\";}s:11:\"panels_mini\";a:6:{s:6:\"export\";a:7:{s:10:\"identifier\";s:4:\"mini\";s:13:\"load callback\";s:16:\"panels_mini_load\";s:17:\"load all callback\";s:20:\"panels_mini_load_all\";s:13:\"save callback\";s:16:\"panels_mini_save\";s:15:\"delete callback\";s:18:\"panels_mini_delete\";s:15:\"export callback\";s:18:\"panels_mini_export\";s:3:\"api\";a:4:{s:5:\"owner\";s:11:\"panels_mini\";s:3:\"api\";s:14:\"panels_default\";s:15:\"minimum_version\";i:1;s:15:\"current_version\";i:1;}}s:6:\"fields\";a:9:{s:3:\"pid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;s:9:\"no export\";b:1;}s:4:\"name\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:8:\"category\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"64\";}s:3:\"did\";a:2:{s:4:\"type\";s:3:\"int\";s:9:\"no export\";b:1;}s:11:\"admin_title\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"128\";}s:17:\"admin_description\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:14:\"object default\";s:0:\"\";}s:16:\"requiredcontexts\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}}s:8:\"contexts\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}}s:13:\"relationships\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}}}s:11:\"primary key\";a:1:{i:0;s:3:\"pid\";}s:11:\"unique keys\";a:1:{s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:6:\"module\";s:11:\"panels_mini\";s:4:\"name\";s:11:\"panels_mini\";}s:11:\"rdf_mapping\";a:4:{s:6:\"fields\";a:3:{s:4:\"type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;}s:6:\"bundle\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;}s:7:\"mapping\";a:4:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:11:\"primary key\";a:2:{i:0;s:4:\"type\";i:1;s:6:\"bundle\";}s:6:\"module\";s:3:\"rdf\";s:4:\"name\";s:11:\"rdf_mapping\";}s:14:\"search_dataset\";a:4:{s:6:\"fields\";a:4:{s:3:\"sid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:16;s:8:\"not null\";b:1;}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;s:4:\"size\";s:3:\"big\";}s:7:\"reindex\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:2:{i:0;s:3:\"sid\";i:1;s:4:\"type\";}s:6:\"module\";s:6:\"search\";s:4:\"name\";s:14:\"search_dataset\";}s:12:\"search_index\";a:6:{s:6:\"fields\";a:4:{s:4:\"word\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"sid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:16;s:8:\"not null\";b:1;}s:5:\"score\";a:2:{s:4:\"type\";s:5:\"float\";s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:8:\"sid_type\";a:2:{i:0;s:3:\"sid\";i:1;s:4:\"type\";}}s:12:\"foreign keys\";a:1:{s:14:\"search_dataset\";a:2:{s:5:\"table\";s:14:\"search_dataset\";s:7:\"columns\";a:2:{s:3:\"sid\";s:3:\"sid\";s:4:\"type\";s:4:\"type\";}}}s:11:\"primary key\";a:3:{i:0;s:4:\"word\";i:1;s:3:\"sid\";i:2;s:4:\"type\";}s:6:\"module\";s:6:\"search\";s:4:\"name\";s:12:\"search_index\";}s:12:\"search_total\";a:4:{s:6:\"fields\";a:2:{s:4:\"word\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"count\";a:2:{s:4:\"type\";s:5:\"float\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:1:{i:0;s:4:\"word\";}s:6:\"module\";s:6:\"search\";s:4:\"name\";s:12:\"search_total\";}s:17:\"search_node_links\";a:5:{s:6:\"fields\";a:4:{s:3:\"sid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:16;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"caption\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:3:{i:0;s:3:\"sid\";i:1;s:4:\"type\";i:2;s:3:\"nid\";}s:7:\"indexes\";a:1:{s:3:\"nid\";a:1:{i:0;s:3:\"nid\";}}s:6:\"module\";s:6:\"search\";s:4:\"name\";s:17:\"search_node_links\";}s:17:\"search_api_server\";a:6:{s:6:\"fields\";a:9:{s:2:\"id\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:4:\"name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;}s:12:\"machine_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;}s:11:\"description\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;}s:5:\"class\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;}s:7:\"options\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:6:\"medium\";s:9:\"serialize\";b:1;s:8:\"not null\";b:1;}s:7:\"enabled\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;s:4:\"size\";s:4:\"tiny\";}s:6:\"module\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:7:\"enabled\";a:1:{i:0;s:7:\"enabled\";}}s:11:\"unique keys\";a:1:{s:12:\"machine_name\";a:1:{i:0;s:12:\"machine_name\";}}s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:6:\"module\";s:10:\"search_api\";s:4:\"name\";s:17:\"search_api_server\";}s:16:\"search_api_index\";a:6:{s:6:\"fields\";a:11:{s:2:\"id\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:4:\"name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;}s:12:\"machine_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;}s:11:\"description\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;}s:6:\"server\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:0;}s:9:\"item_type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;}s:7:\"options\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:6:\"medium\";s:9:\"serialize\";b:1;s:8:\"not null\";b:1;}s:7:\"enabled\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}s:9:\"read_only\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;s:4:\"size\";s:4:\"tiny\";}s:6:\"module\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:3:{s:9:\"item_type\";a:1:{i:0;s:9:\"item_type\";}s:6:\"server\";a:1:{i:0;s:6:\"server\";}s:7:\"enabled\";a:1:{i:0;s:7:\"enabled\";}}s:11:\"unique keys\";a:1:{s:12:\"machine_name\";a:1:{i:0;s:12:\"machine_name\";}}s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:6:\"module\";s:10:\"search_api\";s:4:\"name\";s:16:\"search_api_index\";}s:15:\"search_api_item\";a:5:{s:6:\"fields\";a:3:{s:7:\"item_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"index_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:7:\"changed\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}}s:7:\"indexes\";a:1:{s:8:\"indexing\";a:2:{i:0;s:8:\"index_id\";i:1;s:7:\"changed\";}}s:11:\"primary key\";a:2:{i:0;s:7:\"item_id\";i:1;s:8:\"index_id\";}s:6:\"module\";s:10:\"search_api\";s:4:\"name\";s:15:\"search_api_item\";}s:15:\"search_api_page\";a:6:{s:6:\"fields\";a:10:{s:2:\"id\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"index_id\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;}s:4:\"path\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;}s:4:\"name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;}s:12:\"machine_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;}s:11:\"description\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;}s:7:\"options\";a:3:{s:4:\"type\";s:4:\"text\";s:9:\"serialize\";b:1;s:8:\"not null\";b:1;}s:7:\"enabled\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;s:4:\"size\";s:4:\"tiny\";}s:6:\"module\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:2:{s:7:\"enabled\";a:1:{i:0;s:7:\"enabled\";}s:8:\"index_id\";a:1:{i:0;s:8:\"index_id\";}}s:6:\"unique\";a:2:{s:4:\"path\";a:1:{i:0;s:4:\"path\";}s:12:\"machine_name\";a:1:{i:0;s:12:\"machine_name\";}}s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:6:\"module\";s:15:\"search_api_page\";s:4:\"name\";s:15:\"search_api_page\";}s:12:\"shortcut_set\";a:5:{s:6:\"fields\";a:2:{s:8:\"set_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:11:\"primary key\";a:1:{i:0;s:8:\"set_name\";}s:12:\"foreign keys\";a:1:{s:9:\"menu_name\";a:2:{s:5:\"table\";s:10:\"menu_links\";s:7:\"columns\";a:1:{s:8:\"set_name\";s:9:\"menu_name\";}}}s:6:\"module\";s:8:\"shortcut\";s:4:\"name\";s:12:\"shortcut_set\";}s:18:\"shortcut_set_users\";a:6:{s:6:\"fields\";a:2:{s:3:\"uid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:8:\"set_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"uid\";}s:7:\"indexes\";a:1:{s:8:\"set_name\";a:1:{i:0;s:8:\"set_name\";}}s:12:\"foreign keys\";a:2:{s:8:\"set_user\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}s:8:\"set_name\";a:2:{s:5:\"table\";s:12:\"shortcut_set\";s:7:\"columns\";a:1:{s:8:\"set_name\";s:8:\"set_name\";}}}s:6:\"module\";s:8:\"shortcut\";s:4:\"name\";s:18:\"shortcut_set_users\";}s:8:\"variable\";a:4:{s:6:\"fields\";a:2:{s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"value\";a:4:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:1;s:4:\"size\";s:3:\"big\";s:12:\"translatable\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:4:\"name\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:8:\"variable\";}s:7:\"actions\";a:4:{s:6:\"fields\";a:5:{s:3:\"aid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:1:\"0\";}s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"callback\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:10:\"parameters\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:1;s:4:\"size\";s:3:\"big\";}s:5:\"label\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:1:\"0\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"aid\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:7:\"actions\";}s:5:\"batch\";a:5:{s:6:\"fields\";a:4:{s:3:\"bid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:5:\"token\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;}s:9:\"timestamp\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;}s:5:\"batch\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"bid\";}s:7:\"indexes\";a:1:{s:5:\"token\";a:1:{i:0;s:5:\"token\";}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:5:\"batch\";}s:11:\"blocked_ips\";a:5:{s:6:\"fields\";a:2:{s:3:\"iid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:2:\"ip\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:40;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:7:\"indexes\";a:1:{s:10:\"blocked_ip\";a:1:{i:0;s:2:\"ip\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"iid\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:11:\"blocked_ips\";}s:5:\"cache\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:5:\"cache\";}s:15:\"cache_bootstrap\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:15:\"cache_bootstrap\";}s:10:\"cache_form\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:10:\"cache_form\";}s:10:\"cache_page\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:10:\"cache_page\";}s:10:\"cache_menu\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:10:\"cache_menu\";}s:10:\"cache_path\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:10:\"cache_path\";}s:16:\"date_format_type\";a:5:{s:6:\"fields\";a:3:{s:4:\"type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;}s:5:\"title\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:6:\"locked\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:7:\"default\";i:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:4:\"type\";}s:7:\"indexes\";a:1:{s:5:\"title\";a:1:{i:0;s:5:\"title\";}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:16:\"date_format_type\";}s:12:\"date_formats\";a:5:{s:6:\"fields\";a:4:{s:4:\"dfid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;s:8:\"unsigned\";b:1;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:100;s:8:\"not null\";b:1;}s:4:\"type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;}s:6:\"locked\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:7:\"default\";i:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:4:\"dfid\";}s:11:\"unique keys\";a:1:{s:7:\"formats\";a:2:{i:0;s:6:\"format\";i:1;s:4:\"type\";}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:12:\"date_formats\";}s:18:\"date_format_locale\";a:4:{s:6:\"fields\";a:3:{s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:100;s:8:\"not null\";b:1;}s:4:\"type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;}s:8:\"language\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:2:{i:0;s:4:\"type\";i:1;s:8:\"language\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:18:\"date_format_locale\";}s:12:\"file_managed\";a:7:{s:6:\"fields\";a:8:{s:3:\"fid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"uid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:8:\"filename\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:6:\"binary\";b:1;}s:3:\"uri\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:6:\"binary\";b:1;}s:8:\"filemime\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"filesize\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:9:\"timestamp\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:3:{s:3:\"uid\";a:1:{i:0;s:3:\"uid\";}s:6:\"status\";a:1:{i:0;s:6:\"status\";}s:9:\"timestamp\";a:1:{i:0;s:9:\"timestamp\";}}s:11:\"unique keys\";a:1:{s:3:\"uri\";a:1:{i:0;s:3:\"uri\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"fid\";}s:12:\"foreign keys\";a:1:{s:10:\"file_owner\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:12:\"file_managed\";}s:10:\"file_usage\";a:5:{s:6:\"fields\";a:5:{s:3:\"fid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"count\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:4:{i:0;s:3:\"fid\";i:1;s:4:\"type\";i:2;s:2:\"id\";i:3;s:6:\"module\";}s:7:\"indexes\";a:3:{s:7:\"type_id\";a:2:{i:0;s:4:\"type\";i:1;s:2:\"id\";}s:9:\"fid_count\";a:2:{i:0;s:3:\"fid\";i:1;s:5:\"count\";}s:10:\"fid_module\";a:2:{i:0;s:3:\"fid\";i:1;s:6:\"module\";}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:10:\"file_usage\";}s:5:\"flood\";a:5:{s:6:\"fields\";a:5:{s:3:\"fid\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:5:\"event\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:10:\"identifier\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:9:\"timestamp\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"expiration\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:3:\"fid\";}s:7:\"indexes\";a:2:{s:5:\"allow\";a:3:{i:0;s:5:\"event\";i:1;s:10:\"identifier\";i:2;s:9:\"timestamp\";}s:5:\"purge\";a:1:{i:0;s:10:\"expiration\";}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:5:\"flood\";}s:11:\"menu_router\";a:5:{s:6:\"fields\";a:23:{s:4:\"path\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:14:\"load_functions\";a:2:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:1;}s:16:\"to_arg_functions\";a:2:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:1;}s:15:\"access_callback\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:16:\"access_arguments\";a:2:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;}s:13:\"page_callback\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:14:\"page_arguments\";a:2:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;}s:17:\"delivery_callback\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"fit\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:12:\"number_parts\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:7:\"context\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"tab_parent\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"tab_root\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:14:\"title_callback\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:15:\"title_arguments\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:14:\"theme_callback\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:15:\"theme_arguments\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"type\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:11:\"description\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;}s:8:\"position\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:12:\"include_file\";a:2:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:6:\"medium\";}}s:7:\"indexes\";a:3:{s:3:\"fit\";a:1:{i:0;s:3:\"fit\";}s:10:\"tab_parent\";a:3:{i:0;a:2:{i:0;s:10:\"tab_parent\";i:1;i:64;}i:1;s:6:\"weight\";i:2;s:5:\"title\";}s:21:\"tab_root_weight_title\";a:3:{i:0;a:2:{i:0;s:8:\"tab_root\";i:1;i:64;}i:1;s:6:\"weight\";i:2;s:5:\"title\";}}s:11:\"primary key\";a:1:{i:0;s:4:\"path\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:11:\"menu_router\";}s:10:\"menu_links\";a:5:{s:6:\"fields\";a:25:{s:9:\"menu_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"mlid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:4:\"plid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"link_path\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:11:\"router_path\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:10:\"link_title\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:7:\"options\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:12:\"translatable\";b:1;}s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:6:\"system\";}s:6:\"hidden\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:8:\"external\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:12:\"has_children\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:8:\"expanded\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"depth\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:10:\"customized\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:2:\"p1\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p2\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p3\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p4\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p5\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p6\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p7\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p8\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p9\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"updated\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}}s:7:\"indexes\";a:4:{s:9:\"path_menu\";a:2:{i:0;a:2:{i:0;s:9:\"link_path\";i:1;i:128;}i:1;s:9:\"menu_name\";}s:22:\"menu_plid_expand_child\";a:4:{i:0;s:9:\"menu_name\";i:1;s:4:\"plid\";i:2;s:8:\"expanded\";i:3;s:12:\"has_children\";}s:12:\"menu_parents\";a:10:{i:0;s:9:\"menu_name\";i:1;s:2:\"p1\";i:2;s:2:\"p2\";i:3;s:2:\"p3\";i:4;s:2:\"p4\";i:5;s:2:\"p5\";i:6;s:2:\"p6\";i:7;s:2:\"p7\";i:8;s:2:\"p8\";i:9;s:2:\"p9\";}s:11:\"router_path\";a:1:{i:0;a:2:{i:0;s:11:\"router_path\";i:1;i:128;}}}s:11:\"primary key\";a:1:{i:0;s:4:\"mlid\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:10:\"menu_links\";}s:5:\"queue\";a:5:{s:6:\"fields\";a:5:{s:7:\"item_id\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:4:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:7:\"item_id\";}s:7:\"indexes\";a:2:{s:12:\"name_created\";a:2:{i:0;s:4:\"name\";i:1;s:7:\"created\";}s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:5:\"queue\";}s:8:\"registry\";a:5:{s:6:\"fields\";a:5:{s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:9;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"filename\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:2:{i:0;s:4:\"name\";i:1;s:4:\"type\";}s:7:\"indexes\";a:1:{s:4:\"hook\";a:3:{i:0;s:4:\"type\";i:1;s:6:\"weight\";i:2;s:6:\"module\";}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:8:\"registry\";}s:13:\"registry_file\";a:4:{s:6:\"fields\";a:2:{s:8:\"filename\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:4:\"hash\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:8:\"filename\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:13:\"registry_file\";}s:9:\"semaphore\";a:5:{s:6:\"fields\";a:3:{s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"value\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"expire\";a:3:{s:4:\"type\";s:5:\"float\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;}}s:7:\"indexes\";a:2:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:4:\"name\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:9:\"semaphore\";}s:9:\"sequences\";a:4:{s:6:\"fields\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:5:\"value\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:9:\"sequences\";}s:8:\"sessions\";a:6:{s:6:\"fields\";a:7:{s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"sid\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;}s:4:\"ssid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"hostname\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:9:\"timestamp\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"cache\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"session\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}}s:11:\"primary key\";a:2:{i:0;s:3:\"sid\";i:1;s:4:\"ssid\";}s:7:\"indexes\";a:3:{s:9:\"timestamp\";a:1:{i:0;s:9:\"timestamp\";}s:3:\"uid\";a:1:{i:0;s:3:\"uid\";}s:4:\"ssid\";a:1:{i:0;s:4:\"ssid\";}}s:12:\"foreign keys\";a:1:{s:12:\"session_user\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:8:\"sessions\";}s:6:\"system\";a:5:{s:6:\"fields\";a:9:{s:8:\"filename\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"owner\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"bootstrap\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:14:\"schema_version\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:-1;s:4:\"size\";s:5:\"small\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"info\";a:2:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:1:{i:0;s:8:\"filename\";}s:7:\"indexes\";a:2:{s:11:\"system_list\";a:5:{i:0;s:6:\"status\";i:1;s:9:\"bootstrap\";i:2;s:4:\"type\";i:3;s:6:\"weight\";i:4;s:4:\"name\";}s:9:\"type_name\";a:2:{i:0;s:4:\"type\";i:1;s:4:\"name\";}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:6:\"system\";}s:9:\"url_alias\";a:5:{s:6:\"fields\";a:4:{s:3:\"pid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:6:\"source\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"alias\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"pid\";}s:7:\"indexes\";a:2:{s:18:\"alias_language_pid\";a:3:{i:0;s:5:\"alias\";i:1;s:8:\"language\";i:2;s:3:\"pid\";}s:19:\"source_language_pid\";a:3:{i:0;s:6:\"source\";i:1;s:8:\"language\";i:2;s:3:\"pid\";}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:9:\"url_alias\";}s:18:\"taxonomy_term_data\";a:6:{s:6:\"fields\";a:6:{s:3:\"tid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"vid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"name\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:11:\"description\";a:4:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:12:\"translatable\";b:1;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:3:\"tid\";}s:12:\"foreign keys\";a:1:{s:10:\"vocabulary\";a:2:{s:5:\"table\";s:19:\"taxonomy_vocabulary\";s:7:\"columns\";a:1:{s:3:\"vid\";s:3:\"vid\";}}}s:7:\"indexes\";a:3:{s:13:\"taxonomy_tree\";a:3:{i:0;s:3:\"vid\";i:1;s:6:\"weight\";i:2;s:4:\"name\";}s:8:\"vid_name\";a:2:{i:0;s:3:\"vid\";i:1;s:4:\"name\";}s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:6:\"module\";s:8:\"taxonomy\";s:4:\"name\";s:18:\"taxonomy_term_data\";}s:23:\"taxonomy_term_hierarchy\";a:6:{s:6:\"fields\";a:2:{s:3:\"tid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"parent\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"parent\";a:1:{i:0;s:6:\"parent\";}}s:12:\"foreign keys\";a:1:{s:18:\"taxonomy_term_data\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:11:\"primary key\";a:2:{i:0;s:3:\"tid\";i:1;s:6:\"parent\";}s:6:\"module\";s:8:\"taxonomy\";s:4:\"name\";s:23:\"taxonomy_term_hierarchy\";}s:19:\"taxonomy_vocabulary\";a:6:{s:6:\"fields\";a:7:{s:3:\"vid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:4:\"name\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:12:\"machine_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:11:\"description\";a:4:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:12:\"translatable\";b:1;}s:9:\"hierarchy\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:3:\"vid\";}s:7:\"indexes\";a:1:{s:4:\"list\";a:2:{i:0;s:6:\"weight\";i:1;s:4:\"name\";}}s:11:\"unique keys\";a:1:{s:12:\"machine_name\";a:1:{i:0;s:12:\"machine_name\";}}s:6:\"module\";s:8:\"taxonomy\";s:4:\"name\";s:19:\"taxonomy_vocabulary\";}s:14:\"taxonomy_index\";a:5:{s:6:\"fields\";a:4:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"tid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"sticky\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:2:{s:9:\"term_node\";a:3:{i:0;s:3:\"tid\";i:1;s:6:\"sticky\";i:2;s:7:\"created\";}s:3:\"nid\";a:1:{i:0;s:3:\"nid\";}}s:12:\"foreign keys\";a:2:{s:12:\"tracked_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:3:\"nid\";s:3:\"nid\";}}s:4:\"term\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:6:\"module\";s:8:\"taxonomy\";s:4:\"name\";s:14:\"taxonomy_index\";}s:11:\"cache_token\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:5:\"token\";s:4:\"name\";s:11:\"cache_token\";}s:7:\"authmap\";a:6:{s:6:\"fields\";a:4:{s:3:\"aid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:8:\"authname\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:11:\"unique keys\";a:1:{s:8:\"authname\";a:1:{i:0;s:8:\"authname\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"aid\";}s:12:\"foreign keys\";a:1:{s:4:\"user\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:6:\"module\";s:4:\"user\";s:4:\"name\";s:7:\"authmap\";}s:15:\"role_permission\";a:6:{s:6:\"fields\";a:3:{s:3:\"rid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:10:\"permission\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:11:\"primary key\";a:2:{i:0;s:3:\"rid\";i:1;s:10:\"permission\";}s:7:\"indexes\";a:1:{s:10:\"permission\";a:1:{i:0;s:10:\"permission\";}}s:12:\"foreign keys\";a:1:{s:4:\"role\";a:2:{s:5:\"table\";s:5:\"roles\";s:7:\"columns\";a:1:{s:3:\"rid\";s:3:\"rid\";}}}s:6:\"module\";s:4:\"user\";s:4:\"name\";s:15:\"role_permission\";}s:4:\"role\";a:6:{s:6:\"fields\";a:3:{s:3:\"rid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:4:\"name\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"unique keys\";a:1:{s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"rid\";}s:7:\"indexes\";a:1:{s:11:\"name_weight\";a:2:{i:0;s:4:\"name\";i:1;s:6:\"weight\";}}s:6:\"module\";s:4:\"user\";s:4:\"name\";s:4:\"role\";}s:5:\"users\";a:7:{s:6:\"fields\";a:16:{s:3:\"uid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:60;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"pass\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"mail\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;s:8:\"not null\";b:0;s:7:\"default\";s:0:\"\";}s:5:\"theme\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:9:\"signature\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:16:\"signature_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"access\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"login\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:8:\"timezone\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"picture\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"init\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;s:8:\"not null\";b:0;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:4:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:7:\"indexes\";a:4:{s:6:\"access\";a:1:{i:0;s:6:\"access\";}s:7:\"created\";a:1:{i:0;s:7:\"created\";}s:4:\"mail\";a:1:{i:0;s:4:\"mail\";}s:7:\"picture\";a:1:{i:0;s:7:\"picture\";}}s:11:\"unique keys\";a:1:{s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"uid\";}s:12:\"foreign keys\";a:1:{s:16:\"signature_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:16:\"signature_format\";s:6:\"format\";}}}s:6:\"module\";s:4:\"user\";s:4:\"name\";s:5:\"users\";}s:11:\"users_roles\";a:6:{s:6:\"fields\";a:2:{s:3:\"uid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"rid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:2:{i:0;s:3:\"uid\";i:1;s:3:\"rid\";}s:7:\"indexes\";a:1:{s:3:\"rid\";a:1:{i:0;s:3:\"rid\";}}s:12:\"foreign keys\";a:2:{s:4:\"user\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}s:4:\"role\";a:2:{s:5:\"table\";s:5:\"roles\";s:7:\"columns\";a:1:{s:3:\"rid\";s:3:\"rid\";}}}s:6:\"module\";s:4:\"user\";s:4:\"name\";s:11:\"users_roles\";}s:17:\"views_data_export\";a:4:{s:6:\"fields\";a:7:{s:3:\"eid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:9:\"view_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"32\";s:7:\"default\";s:0:\"\";s:8:\"not null\";b:1;}s:15:\"view_display_id\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"32\";s:7:\"default\";s:0:\"\";s:8:\"not null\";b:1;}s:10:\"time_stamp\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"fid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"batch_state\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"32\";s:7:\"default\";s:4:\"init\";s:8:\"not null\";b:1;}s:7:\"sandbox\";a:4:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:3:\"eid\";}s:6:\"module\";s:17:\"views_data_export\";s:4:\"name\";s:17:\"views_data_export\";}s:30:\"views_data_export_object_cache\";a:4:{s:6:\"fields\";a:3:{s:3:\"eid\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"64\";}s:7:\"updated\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:7:\"indexes\";a:2:{s:3:\"eid\";a:1:{i:0;s:3:\"eid\";}s:7:\"updated\";a:1:{i:0;s:7:\"updated\";}}s:6:\"module\";s:17:\"views_data_export\";s:4:\"name\";s:30:\"views_data_export_object_cache\";}s:11:\"field_group\";a:7:{s:6:\"export\";a:7:{s:3:\"key\";s:10:\"identifier\";s:10:\"identifier\";s:11:\"field_group\";s:12:\"default hook\";s:16:\"field_group_info\";s:13:\"save callback\";s:22:\"field_group_group_save\";s:15:\"delete callback\";s:31:\"field_group_group_export_delete\";s:11:\"can disable\";b:1;s:3:\"api\";a:4:{s:5:\"owner\";s:11:\"field_group\";s:3:\"api\";s:11:\"field_group\";s:15:\"minimum_version\";i:1;s:15:\"current_version\";i:1;}}s:6:\"fields\";a:8:{s:2:\"id\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;s:9:\"no export\";b:1;}s:10:\"identifier\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:10:\"group_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"mode\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:11:\"parent_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:4:{s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:7:\"indexes\";a:1:{s:10:\"group_name\";a:1:{i:0;s:10:\"group_name\";}}s:11:\"unique keys\";a:1:{s:10:\"identifier\";a:1:{i:0;s:10:\"identifier\";}}s:6:\"module\";s:11:\"field_group\";s:4:\"name\";s:11:\"field_group\";}s:10:\"views_view\";a:6:{s:6:\"export\";a:17:{s:10:\"identifier\";s:4:\"view\";s:11:\"bulk export\";b:1;s:11:\"primary key\";s:3:\"vid\";s:12:\"default hook\";s:19:\"views_default_views\";s:11:\"admin_title\";s:10:\"human_name\";s:17:\"admin_description\";s:11:\"description\";s:3:\"api\";a:4:{s:5:\"owner\";s:5:\"views\";s:3:\"api\";s:13:\"views_default\";s:15:\"minimum_version\";s:1:\"2\";s:15:\"current_version\";s:3:\"3.0\";}s:6:\"object\";s:4:\"view\";s:19:\"subrecords callback\";s:26:\"views_load_display_records\";s:6:\"status\";s:14:\"views_defaults\";s:15:\"create callback\";s:14:\"views_new_view\";s:13:\"save callback\";s:15:\"views_save_view\";s:15:\"delete callback\";s:17:\"views_delete_view\";s:15:\"export callback\";s:17:\"views_export_view\";s:15:\"status callback\";s:19:\"views_export_status\";s:14:\"cache defaults\";b:1;s:17:\"default cache bin\";s:11:\"cache_views\";}s:6:\"fields\";a:7:{s:3:\"vid\";a:4:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:9:\"no export\";b:1;}s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:7:\"default\";s:0:\"\";s:8:\"not null\";b:1;}s:11:\"description\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:7:\"default\";s:0:\"\";}s:3:\"tag\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:7:\"default\";s:0:\"\";}s:10:\"base_table\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:7:\"default\";s:0:\"\";s:8:\"not null\";b:1;}s:10:\"human_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:7:\"default\";s:0:\"\";}s:4:\"core\";a:2:{s:4:\"type\";s:3:\"int\";s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:3:\"vid\";}s:11:\"unique keys\";a:1:{s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:6:\"module\";s:5:\"views\";s:4:\"name\";s:10:\"views_view\";}s:13:\"views_display\";a:5:{s:6:\"fields\";a:6:{s:3:\"vid\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;s:9:\"no export\";b:1;}s:2:\"id\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"64\";s:7:\"default\";s:0:\"\";s:8:\"not null\";b:1;}s:13:\"display_title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"64\";s:7:\"default\";s:0:\"\";s:8:\"not null\";b:1;}s:14:\"display_plugin\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"64\";s:7:\"default\";s:0:\"\";s:8:\"not null\";b:1;}s:8:\"position\";a:2:{s:4:\"type\";s:3:\"int\";s:7:\"default\";i:0;}s:15:\"display_options\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:18:\"serialized default\";s:6:\"a:0:{}\";}}s:7:\"indexes\";a:1:{s:3:\"vid\";a:2:{i:0;s:3:\"vid\";i:1;s:8:\"position\";}}s:11:\"primary key\";a:2:{i:0;s:3:\"vid\";i:1;s:2:\"id\";}s:6:\"module\";s:5:\"views\";s:4:\"name\";s:13:\"views_display\";}s:11:\"cache_views\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:5:\"views\";s:4:\"name\";s:11:\"cache_views\";}s:16:\"cache_views_data\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:5:\"views\";s:4:\"name\";s:16:\"cache_views_data\";}s:11:\"panels_node\";a:4:{s:6:\"fields\";a:4:{s:3:\"nid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"css_id\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:3:\"did\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;}s:8:\"pipeline\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"did\";}s:6:\"module\";s:11:\"panels_node\";s:4:\"name\";s:11:\"panels_node\";}s:21:\"page_manager_handlers\";a:7:{s:6:\"export\";a:7:{s:10:\"identifier\";s:7:\"handler\";s:11:\"bulk export\";b:1;s:15:\"export callback\";s:32:\"page_manager_export_task_handler\";s:13:\"load callback\";s:37:\"page_manager_export_task_handler_load\";s:15:\"delete callback\";s:32:\"page_manager_delete_task_handler\";s:11:\"primary key\";s:3:\"did\";s:3:\"api\";a:4:{s:5:\"owner\";s:12:\"page_manager\";s:3:\"api\";s:13:\"pages_default\";s:15:\"minimum_version\";i:1;s:15:\"current_version\";i:1;}}s:6:\"fields\";a:7:{s:3:\"did\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;s:9:\"no export\";b:1;}s:4:\"name\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:4:\"task\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"64\";}s:7:\"subtask\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"64\";s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"handler\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"64\";}s:6:\"weight\";a:1:{s:4:\"type\";s:3:\"int\";}s:4:\"conf\";a:5:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}}}s:11:\"primary key\";a:1:{i:0;s:3:\"did\";}s:11:\"unique keys\";a:1:{s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:7:\"indexes\";a:1:{s:8:\"fulltask\";a:3:{i:0;s:4:\"task\";i:1;s:7:\"subtask\";i:2;s:6:\"weight\";}}s:6:\"module\";s:12:\"page_manager\";s:4:\"name\";s:21:\"page_manager_handlers\";}s:20:\"page_manager_weights\";a:5:{s:6:\"fields\";a:2:{s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"weight\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"primary key\";a:1:{i:0;s:4:\"name\";}s:7:\"indexes\";a:1:{s:7:\"weights\";a:2:{i:0;s:4:\"name\";i:1;s:6:\"weight\";}}s:6:\"module\";s:12:\"page_manager\";s:4:\"name\";s:20:\"page_manager_weights\";}s:18:\"page_manager_pages\";a:7:{s:6:\"export\";a:4:{s:10:\"identifier\";s:4:\"page\";s:11:\"bulk export\";b:1;s:15:\"export callback\";s:24:\"page_manager_page_export\";s:3:\"api\";a:4:{s:5:\"owner\";s:12:\"page_manager\";s:3:\"api\";s:13:\"pages_default\";s:15:\"minimum_version\";i:1;s:15:\"current_version\";i:1;}}s:6:\"fields\";a:10:{s:3:\"pid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;s:9:\"no export\";b:1;}s:4:\"name\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:4:\"task\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"64\";s:7:\"default\";s:4:\"page\";}s:11:\"admin_title\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:17:\"admin_description\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:14:\"object default\";s:0:\"\";}s:4:\"path\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:6:\"access\";a:5:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}}s:4:\"menu\";a:5:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}}s:9:\"arguments\";a:5:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}}s:4:\"conf\";a:5:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}}}s:11:\"primary key\";a:1:{i:0;s:3:\"pid\";}s:11:\"unique keys\";a:1:{s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:7:\"indexes\";a:1:{s:4:\"task\";a:1:{i:0;s:4:\"task\";}}s:6:\"module\";s:12:\"page_manager\";s:4:\"name\";s:18:\"page_manager_pages\";}s:16:\"cache_admin_menu\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:10:\"admin_menu\";s:4:\"name\";s:16:\"cache_admin_menu\";}}',0,1371656313,1),('entity_info:en','a:9:{s:7:\"comment\";a:23:{s:5:\"label\";s:7:\"Comment\";s:10:\"base table\";s:7:\"comment\";s:12:\"uri callback\";s:11:\"comment_uri\";s:9:\"fieldable\";b:1;s:16:\"controller class\";s:17:\"CommentController\";s:11:\"entity keys\";a:5:{s:2:\"id\";s:3:\"cid\";s:6:\"bundle\";s:9:\"node_type\";s:5:\"label\";s:7:\"subject\";s:8:\"language\";s:8:\"language\";s:8:\"revision\";s:0:\"\";}s:7:\"bundles\";a:12:{s:20:\"comment_node_article\";a:4:{s:5:\"label\";s:15:\"Article comment\";s:11:\"node bundle\";s:7:\"article\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:44:\"admin/structure/types/manage/article/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:8:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Post\";i:1;s:13:\"sioct:Comment\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:12:\"comment_body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"pid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:13:\"sioc:reply_of\";}s:4:\"type\";s:3:\"rel\";}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}}}s:17:\"comment_node_page\";a:4:{s:5:\"label\";s:18:\"Basic page comment\";s:11:\"node bundle\";s:4:\"page\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:41:\"admin/structure/types/manage/page/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:8:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Post\";i:1;s:13:\"sioct:Comment\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:12:\"comment_body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"pid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:13:\"sioc:reply_of\";}s:4:\"type\";s:3:\"rel\";}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}}}s:24:\"comment_node_data_center\";a:4:{s:5:\"label\";s:19:\"Data Center comment\";s:11:\"node bundle\";s:11:\"data_center\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:48:\"admin/structure/types/manage/data-center/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:8:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Post\";i:1;s:13:\"sioct:Comment\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:12:\"comment_body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"pid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:13:\"sioc:reply_of\";}s:4:\"type\";s:3:\"rel\";}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}}}s:19:\"comment_node_device\";a:4:{s:5:\"label\";s:14:\"Device comment\";s:11:\"node bundle\";s:6:\"device\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:43:\"admin/structure/types/manage/device/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:8:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Post\";i:1;s:13:\"sioct:Comment\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:12:\"comment_body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"pid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:13:\"sioc:reply_of\";}s:4:\"type\";s:3:\"rel\";}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}}}s:17:\"comment_node_host\";a:4:{s:5:\"label\";s:12:\"Host comment\";s:11:\"node bundle\";s:4:\"host\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:41:\"admin/structure/types/manage/host/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:8:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Post\";i:1;s:13:\"sioct:Comment\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:12:\"comment_body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"pid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:13:\"sioc:reply_of\";}s:4:\"type\";s:3:\"rel\";}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}}}s:18:\"comment_node_panel\";a:4:{s:5:\"label\";s:13:\"Panel comment\";s:11:\"node bundle\";s:5:\"panel\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:42:\"admin/structure/types/manage/panel/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:8:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Post\";i:1;s:13:\"sioct:Comment\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:12:\"comment_body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"pid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:13:\"sioc:reply_of\";}s:4:\"type\";s:3:\"rel\";}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}}}s:27:\"comment_node_vm_cache_space\";a:4:{s:5:\"label\";s:22:\"VM Cache Space comment\";s:11:\"node bundle\";s:14:\"vm_cache_space\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:51:\"admin/structure/types/manage/vm-cache-space/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:8:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Post\";i:1;s:13:\"sioct:Comment\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:12:\"comment_body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"pid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:13:\"sioc:reply_of\";}s:4:\"type\";s:3:\"rel\";}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}}}s:23:\"comment_node_vm_metrics\";a:4:{s:5:\"label\";s:18:\"VM metrics comment\";s:11:\"node bundle\";s:10:\"vm_metrics\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:47:\"admin/structure/types/manage/vm-metrics/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:8:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Post\";i:1;s:13:\"sioct:Comment\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:12:\"comment_body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"pid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:13:\"sioc:reply_of\";}s:4:\"type\";s:3:\"rel\";}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}}}s:28:\"comment_node_virtual_machine\";a:4:{s:5:\"label\";s:23:\"Virtual Machine comment\";s:11:\"node bundle\";s:15:\"virtual_machine\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:52:\"admin/structure/types/manage/virtual-machine/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:8:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Post\";i:1;s:13:\"sioct:Comment\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:12:\"comment_body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"pid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:13:\"sioc:reply_of\";}s:4:\"type\";s:3:\"rel\";}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}}}s:20:\"comment_node_vcenter\";a:4:{s:5:\"label\";s:15:\"vCenter comment\";s:11:\"node bundle\";s:7:\"vcenter\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:44:\"admin/structure/types/manage/vcenter/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:8:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Post\";i:1;s:13:\"sioct:Comment\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:12:\"comment_body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"pid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:13:\"sioc:reply_of\";}s:4:\"type\";s:3:\"rel\";}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}}}s:18:\"comment_node_vdisk\";a:4:{s:5:\"label\";s:13:\"vDisk comment\";s:11:\"node bundle\";s:5:\"vdisk\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:42:\"admin/structure/types/manage/vdisk/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:8:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Post\";i:1;s:13:\"sioct:Comment\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:12:\"comment_body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"pid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:13:\"sioc:reply_of\";}s:4:\"type\";s:3:\"rel\";}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}}}s:26:\"comment_node_vdisk_metrics\";a:4:{s:5:\"label\";s:21:\"vDisk metrics comment\";s:11:\"node bundle\";s:13:\"vdisk_metrics\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:50:\"admin/structure/types/manage/vdisk-metrics/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:8:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Post\";i:1;s:13:\"sioct:Comment\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:12:\"comment_body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"pid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:13:\"sioc:reply_of\";}s:4:\"type\";s:3:\"rel\";}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}}}}s:10:\"view modes\";a:2:{s:4:\"full\";a:2:{s:5:\"label\";s:12:\"Full comment\";s:15:\"custom settings\";b:0;}s:5:\"token\";a:2:{s:5:\"label\";s:6:\"Tokens\";s:15:\"custom settings\";b:0;}}s:12:\"static cache\";b:0;s:11:\"field cache\";b:1;s:9:\"load hook\";s:12:\"comment_load\";s:11:\"translation\";a:0:{}s:17:\"schema_fields_sql\";a:1:{s:10:\"base table\";a:14:{i:0;s:3:\"cid\";i:1;s:3:\"pid\";i:2;s:3:\"nid\";i:3;s:3:\"uid\";i:4;s:7:\"subject\";i:5;s:8:\"hostname\";i:6;s:7:\"created\";i:7;s:7:\"changed\";i:8;s:6:\"status\";i:9;s:6:\"thread\";i:10;s:4:\"name\";i:11;s:4:\"mail\";i:12;s:8:\"homepage\";i:13;s:8:\"language\";}}s:10:\"token type\";s:7:\"comment\";s:12:\"plural label\";s:8:\"Comments\";s:11:\"description\";s:37:\"Remark or note that refers to a node.\";s:15:\"access callback\";s:30:\"entity_metadata_comment_access\";s:17:\"creation callback\";s:30:\"entity_metadata_create_comment\";s:13:\"save callback\";s:12:\"comment_save\";s:17:\"deletion callback\";s:14:\"comment_delete\";s:13:\"view callback\";s:28:\"entity_metadata_view_comment\";s:13:\"form callback\";s:28:\"entity_metadata_form_comment\";s:13:\"configuration\";b:0;}s:4:\"node\";a:25:{s:5:\"label\";s:4:\"Node\";s:16:\"controller class\";s:14:\"NodeController\";s:10:\"base table\";s:4:\"node\";s:14:\"revision table\";s:13:\"node_revision\";s:12:\"uri callback\";s:8:\"node_uri\";s:9:\"fieldable\";b:1;s:11:\"entity keys\";a:5:{s:2:\"id\";s:3:\"nid\";s:8:\"revision\";s:3:\"vid\";s:6:\"bundle\";s:4:\"type\";s:5:\"label\";s:5:\"title\";s:8:\"language\";s:8:\"language\";}s:11:\"bundle keys\";a:1:{s:6:\"bundle\";s:4:\"type\";}s:7:\"bundles\";a:12:{s:7:\"article\";a:3:{s:5:\"label\";s:7:\"Article\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:36:\"admin/structure/types/manage/article\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:11:{s:11:\"field_image\";a:2:{s:10:\"predicates\";a:2:{i:0;s:8:\"og:image\";i:1;s:12:\"rdfs:seeAlso\";}s:4:\"type\";s:3:\"rel\";}s:10:\"field_tags\";a:2:{s:10:\"predicates\";a:1:{i:0;s:10:\"dc:subject\";}s:4:\"type\";s:3:\"rel\";}s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Item\";i:1;s:13:\"foaf:Document\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:4:\"body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}s:13:\"comment_count\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:num_replies\";}s:8:\"datatype\";s:11:\"xsd:integer\";}s:13:\"last_activity\";a:3:{s:10:\"predicates\";a:1:{i:0;s:23:\"sioc:last_activity_date\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}}}s:4:\"page\";a:3:{s:5:\"label\";s:10:\"Basic page\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:33:\"admin/structure/types/manage/page\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:9:{s:7:\"rdftype\";a:1:{i:0;s:13:\"foaf:Document\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:4:\"body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}s:13:\"comment_count\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:num_replies\";}s:8:\"datatype\";s:11:\"xsd:integer\";}s:13:\"last_activity\";a:3:{s:10:\"predicates\";a:1:{i:0;s:23:\"sioc:last_activity_date\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}}}s:11:\"data_center\";a:3:{s:5:\"label\";s:11:\"Data Center\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:40:\"admin/structure/types/manage/data-center\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:9:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Item\";i:1;s:13:\"foaf:Document\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:4:\"body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}s:13:\"comment_count\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:num_replies\";}s:8:\"datatype\";s:11:\"xsd:integer\";}s:13:\"last_activity\";a:3:{s:10:\"predicates\";a:1:{i:0;s:23:\"sioc:last_activity_date\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}}}s:6:\"device\";a:3:{s:5:\"label\";s:6:\"Device\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:35:\"admin/structure/types/manage/device\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:9:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Item\";i:1;s:13:\"foaf:Document\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:4:\"body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}s:13:\"comment_count\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:num_replies\";}s:8:\"datatype\";s:11:\"xsd:integer\";}s:13:\"last_activity\";a:3:{s:10:\"predicates\";a:1:{i:0;s:23:\"sioc:last_activity_date\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}}}s:4:\"host\";a:3:{s:5:\"label\";s:4:\"Host\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:33:\"admin/structure/types/manage/host\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:9:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Item\";i:1;s:13:\"foaf:Document\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:4:\"body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}s:13:\"comment_count\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:num_replies\";}s:8:\"datatype\";s:11:\"xsd:integer\";}s:13:\"last_activity\";a:3:{s:10:\"predicates\";a:1:{i:0;s:23:\"sioc:last_activity_date\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}}}s:5:\"panel\";a:3:{s:5:\"label\";s:5:\"Panel\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:34:\"admin/structure/types/manage/panel\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:9:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Item\";i:1;s:13:\"foaf:Document\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:4:\"body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}s:13:\"comment_count\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:num_replies\";}s:8:\"datatype\";s:11:\"xsd:integer\";}s:13:\"last_activity\";a:3:{s:10:\"predicates\";a:1:{i:0;s:23:\"sioc:last_activity_date\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}}}s:14:\"vm_cache_space\";a:3:{s:5:\"label\";s:14:\"VM Cache Space\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:43:\"admin/structure/types/manage/vm-cache-space\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:9:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Item\";i:1;s:13:\"foaf:Document\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:4:\"body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}s:13:\"comment_count\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:num_replies\";}s:8:\"datatype\";s:11:\"xsd:integer\";}s:13:\"last_activity\";a:3:{s:10:\"predicates\";a:1:{i:0;s:23:\"sioc:last_activity_date\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}}}s:10:\"vm_metrics\";a:3:{s:5:\"label\";s:10:\"VM metrics\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:39:\"admin/structure/types/manage/vm-metrics\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:9:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Item\";i:1;s:13:\"foaf:Document\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:4:\"body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}s:13:\"comment_count\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:num_replies\";}s:8:\"datatype\";s:11:\"xsd:integer\";}s:13:\"last_activity\";a:3:{s:10:\"predicates\";a:1:{i:0;s:23:\"sioc:last_activity_date\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}}}s:15:\"virtual_machine\";a:3:{s:5:\"label\";s:15:\"Virtual Machine\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:44:\"admin/structure/types/manage/virtual-machine\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:9:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Item\";i:1;s:13:\"foaf:Document\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:4:\"body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}s:13:\"comment_count\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:num_replies\";}s:8:\"datatype\";s:11:\"xsd:integer\";}s:13:\"last_activity\";a:3:{s:10:\"predicates\";a:1:{i:0;s:23:\"sioc:last_activity_date\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}}}s:7:\"vcenter\";a:3:{s:5:\"label\";s:7:\"vCenter\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:36:\"admin/structure/types/manage/vcenter\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:9:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Item\";i:1;s:13:\"foaf:Document\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:4:\"body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}s:13:\"comment_count\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:num_replies\";}s:8:\"datatype\";s:11:\"xsd:integer\";}s:13:\"last_activity\";a:3:{s:10:\"predicates\";a:1:{i:0;s:23:\"sioc:last_activity_date\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}}}s:5:\"vdisk\";a:3:{s:5:\"label\";s:5:\"vDisk\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:34:\"admin/structure/types/manage/vdisk\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:9:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Item\";i:1;s:13:\"foaf:Document\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:4:\"body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}s:13:\"comment_count\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:num_replies\";}s:8:\"datatype\";s:11:\"xsd:integer\";}s:13:\"last_activity\";a:3:{s:10:\"predicates\";a:1:{i:0;s:23:\"sioc:last_activity_date\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}}}s:13:\"vdisk_metrics\";a:3:{s:5:\"label\";s:13:\"vDisk metrics\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:42:\"admin/structure/types/manage/vdisk-metrics\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:9:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Item\";i:1;s:13:\"foaf:Document\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:4:\"body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}s:13:\"comment_count\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:num_replies\";}s:8:\"datatype\";s:11:\"xsd:integer\";}s:13:\"last_activity\";a:3:{s:10:\"predicates\";a:1:{i:0;s:23:\"sioc:last_activity_date\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}}}}s:10:\"view modes\";a:6:{s:4:\"full\";a:2:{s:5:\"label\";s:12:\"Full content\";s:15:\"custom settings\";b:0;}s:6:\"teaser\";a:2:{s:5:\"label\";s:6:\"Teaser\";s:15:\"custom settings\";b:1;}s:3:\"rss\";a:2:{s:5:\"label\";s:3:\"RSS\";s:15:\"custom settings\";b:0;}s:12:\"search_index\";a:2:{s:5:\"label\";s:12:\"Search index\";s:15:\"custom settings\";b:0;}s:13:\"search_result\";a:2:{s:5:\"label\";s:13:\"Search result\";s:15:\"custom settings\";b:0;}s:5:\"token\";a:2:{s:5:\"label\";s:6:\"Tokens\";s:15:\"custom settings\";b:0;}}s:12:\"static cache\";b:1;s:11:\"field cache\";b:1;s:9:\"load hook\";s:9:\"node_load\";s:11:\"translation\";a:0:{}s:17:\"schema_fields_sql\";a:2:{s:10:\"base table\";a:14:{i:0;s:3:\"nid\";i:1;s:3:\"vid\";i:2;s:4:\"type\";i:3;s:8:\"language\";i:4;s:5:\"title\";i:5;s:3:\"uid\";i:6;s:6:\"status\";i:7;s:7:\"created\";i:8;s:7:\"changed\";i:9;s:7:\"comment\";i:10;s:7:\"promote\";i:11;s:6:\"sticky\";i:12;s:4:\"tnid\";i:13;s:9:\"translate\";}s:14:\"revision table\";a:10:{i:0;s:3:\"nid\";i:1;s:3:\"vid\";i:2;s:3:\"uid\";i:3;s:5:\"title\";i:4;s:3:\"log\";i:5;s:9:\"timestamp\";i:6;s:6:\"status\";i:7;s:7:\"comment\";i:8;s:7:\"promote\";i:9;s:6:\"sticky\";}}s:10:\"token type\";s:4:\"node\";s:12:\"plural label\";s:5:\"Nodes\";s:11:\"description\";s:44:\"Nodes represent the main site content items.\";s:15:\"access callback\";s:35:\"entity_metadata_no_hook_node_access\";s:17:\"creation callback\";s:27:\"entity_metadata_create_node\";s:13:\"save callback\";s:9:\"node_save\";s:17:\"deletion callback\";s:11:\"node_delete\";s:13:\"form callback\";s:25:\"entity_metadata_form_node\";s:13:\"view callback\";s:25:\"entity_metadata_view_node\";s:13:\"configuration\";b:0;}s:17:\"search_api_server\";a:19:{s:5:\"label\";s:13:\"Search server\";s:16:\"controller class\";s:29:\"EntityAPIControllerExportable\";s:25:\"metadata controller class\";b:0;s:12:\"entity class\";s:15:\"SearchApiServer\";s:10:\"base table\";s:17:\"search_api_server\";s:12:\"uri callback\";s:21:\"search_api_server_url\";s:6:\"module\";s:10:\"search_api\";s:10:\"exportable\";b:1;s:11:\"entity keys\";a:5:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:4:\"name\";s:4:\"name\";s:12:\"machine_name\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";}s:9:\"fieldable\";b:0;s:12:\"static cache\";b:1;s:11:\"field cache\";b:1;s:9:\"load hook\";s:22:\"search_api_server_load\";s:7:\"bundles\";a:1:{s:17:\"search_api_server\";a:2:{s:5:\"label\";s:13:\"Search server\";s:11:\"rdf_mapping\";a:0:{}}}s:10:\"view modes\";a:0:{}s:11:\"translation\";a:0:{}s:17:\"schema_fields_sql\";a:1:{s:10:\"base table\";a:9:{i:0;s:2:\"id\";i:1;s:4:\"name\";i:2;s:12:\"machine_name\";i:3;s:11:\"description\";i:4;s:5:\"class\";i:5;s:7:\"options\";i:6;s:7:\"enabled\";i:7;s:6:\"status\";i:8;s:6:\"module\";}}s:10:\"token type\";s:17:\"search_api_server\";s:13:\"configuration\";b:1;}s:16:\"search_api_index\";a:19:{s:5:\"label\";s:12:\"Search index\";s:16:\"controller class\";s:29:\"EntityAPIControllerExportable\";s:25:\"metadata controller class\";b:0;s:12:\"entity class\";s:14:\"SearchApiIndex\";s:10:\"base table\";s:16:\"search_api_index\";s:12:\"uri callback\";s:20:\"search_api_index_url\";s:6:\"module\";s:10:\"search_api\";s:10:\"exportable\";b:1;s:11:\"entity keys\";a:5:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:4:\"name\";s:4:\"name\";s:12:\"machine_name\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";}s:9:\"fieldable\";b:0;s:12:\"static cache\";b:1;s:11:\"field cache\";b:1;s:9:\"load hook\";s:21:\"search_api_index_load\";s:7:\"bundles\";a:1:{s:16:\"search_api_index\";a:2:{s:5:\"label\";s:12:\"Search index\";s:11:\"rdf_mapping\";a:0:{}}}s:10:\"view modes\";a:0:{}s:11:\"translation\";a:0:{}s:17:\"schema_fields_sql\";a:1:{s:10:\"base table\";a:11:{i:0;s:2:\"id\";i:1;s:4:\"name\";i:2;s:12:\"machine_name\";i:3;s:11:\"description\";i:4;s:6:\"server\";i:5;s:9:\"item_type\";i:6;s:7:\"options\";i:7;s:7:\"enabled\";i:8;s:9:\"read_only\";i:9;s:6:\"status\";i:10;s:6:\"module\";}}s:10:\"token type\";s:16:\"search_api_index\";s:13:\"configuration\";b:1;}s:15:\"search_api_page\";a:19:{s:5:\"label\";s:11:\"Search page\";s:16:\"controller class\";s:29:\"EntityAPIControllerExportable\";s:25:\"metadata controller class\";b:0;s:12:\"entity class\";s:6:\"Entity\";s:10:\"base table\";s:15:\"search_api_page\";s:12:\"uri callback\";s:19:\"search_api_page_url\";s:6:\"module\";s:15:\"search_api_page\";s:10:\"exportable\";b:1;s:11:\"entity keys\";a:5:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:4:\"name\";s:4:\"name\";s:12:\"machine_name\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";}s:9:\"fieldable\";b:0;s:12:\"static cache\";b:1;s:11:\"field cache\";b:1;s:9:\"load hook\";s:20:\"search_api_page_load\";s:7:\"bundles\";a:1:{s:15:\"search_api_page\";a:2:{s:5:\"label\";s:11:\"Search page\";s:11:\"rdf_mapping\";a:0:{}}}s:10:\"view modes\";a:0:{}s:11:\"translation\";a:0:{}s:17:\"schema_fields_sql\";a:1:{s:10:\"base table\";a:10:{i:0;s:2:\"id\";i:1;s:8:\"index_id\";i:2;s:4:\"path\";i:3;s:4:\"name\";i:4;s:12:\"machine_name\";i:5;s:11:\"description\";i:6;s:7:\"options\";i:7;s:7:\"enabled\";i:8;s:6:\"status\";i:9;s:6:\"module\";}}s:10:\"token type\";s:15:\"search_api_page\";s:13:\"configuration\";b:1;}s:4:\"file\";a:18:{s:5:\"label\";s:4:\"File\";s:10:\"base table\";s:12:\"file_managed\";s:11:\"entity keys\";a:4:{s:2:\"id\";s:3:\"fid\";s:5:\"label\";s:8:\"filename\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";}s:12:\"static cache\";b:0;s:9:\"fieldable\";b:0;s:16:\"controller class\";s:29:\"DrupalDefaultEntityController\";s:11:\"field cache\";b:1;s:9:\"load hook\";s:9:\"file_load\";s:7:\"bundles\";a:1:{s:4:\"file\";a:2:{s:5:\"label\";s:4:\"File\";s:11:\"rdf_mapping\";a:0:{}}}s:10:\"view modes\";a:0:{}s:11:\"translation\";a:0:{}s:17:\"schema_fields_sql\";a:1:{s:10:\"base table\";a:8:{i:0;s:3:\"fid\";i:1;s:3:\"uid\";i:2;s:8:\"filename\";i:3;s:3:\"uri\";i:4;s:8:\"filemime\";i:5;s:8:\"filesize\";i:6;s:6:\"status\";i:7;s:9:\"timestamp\";}}s:10:\"token type\";s:4:\"file\";s:12:\"plural label\";s:5:\"Files\";s:11:\"description\";s:14:\"Uploaded file.\";s:13:\"save callback\";s:9:\"file_save\";s:17:\"deletion callback\";s:27:\"entity_metadata_delete_file\";s:13:\"configuration\";b:0;}s:13:\"taxonomy_term\";a:24:{s:5:\"label\";s:13:\"Taxonomy term\";s:16:\"controller class\";s:22:\"TaxonomyTermController\";s:10:\"base table\";s:18:\"taxonomy_term_data\";s:12:\"uri callback\";s:17:\"taxonomy_term_uri\";s:9:\"fieldable\";b:1;s:11:\"entity keys\";a:4:{s:2:\"id\";s:3:\"tid\";s:6:\"bundle\";s:23:\"vocabulary_machine_name\";s:5:\"label\";s:4:\"name\";s:8:\"revision\";s:0:\"\";}s:11:\"bundle keys\";a:1:{s:6:\"bundle\";s:12:\"machine_name\";}s:7:\"bundles\";a:1:{s:4:\"tags\";a:3:{s:5:\"label\";s:4:\"Tags\";s:5:\"admin\";a:4:{s:4:\"path\";s:58:\"admin/structure/taxonomy/%taxonomy_vocabulary_machine_name\";s:9:\"real path\";s:29:\"admin/structure/taxonomy/tags\";s:15:\"bundle argument\";i:3;s:16:\"access arguments\";a:1:{i:0;s:19:\"administer taxonomy\";}}s:11:\"rdf_mapping\";a:5:{s:7:\"rdftype\";a:1:{i:0;s:12:\"skos:Concept\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:2:{i:0;s:10:\"rdfs:label\";i:1;s:14:\"skos:prefLabel\";}}s:11:\"description\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"skos:definition\";}}s:3:\"vid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:13:\"skos:inScheme\";}s:4:\"type\";s:3:\"rel\";}s:6:\"parent\";a:2:{s:10:\"predicates\";a:1:{i:0;s:12:\"skos:broader\";}s:4:\"type\";s:3:\"rel\";}}}}s:10:\"view modes\";a:2:{s:4:\"full\";a:2:{s:5:\"label\";s:18:\"Taxonomy term page\";s:15:\"custom settings\";b:0;}s:5:\"token\";a:2:{s:5:\"label\";s:6:\"Tokens\";s:15:\"custom settings\";b:0;}}s:12:\"static cache\";b:1;s:11:\"field cache\";b:1;s:9:\"load hook\";s:18:\"taxonomy_term_load\";s:11:\"translation\";a:0:{}s:17:\"schema_fields_sql\";a:1:{s:10:\"base table\";a:6:{i:0;s:3:\"tid\";i:1;s:3:\"vid\";i:2;s:4:\"name\";i:3;s:11:\"description\";i:4;s:6:\"format\";i:5;s:6:\"weight\";}}s:10:\"token type\";s:4:\"term\";s:12:\"plural label\";s:14:\"Taxonomy terms\";s:11:\"description\";s:48:\"Taxonomy terms are used for classifying content.\";s:15:\"access callback\";s:31:\"entity_metadata_taxonomy_access\";s:17:\"creation callback\";s:29:\"entity_metadata_create_object\";s:13:\"save callback\";s:18:\"taxonomy_term_save\";s:17:\"deletion callback\";s:20:\"taxonomy_term_delete\";s:13:\"view callback\";s:27:\"entity_metadata_view_single\";s:13:\"form callback\";s:34:\"entity_metadata_form_taxonomy_term\";s:13:\"configuration\";b:0;}s:19:\"taxonomy_vocabulary\";a:21:{s:5:\"label\";s:19:\"Taxonomy vocabulary\";s:16:\"controller class\";s:28:\"TaxonomyVocabularyController\";s:10:\"base table\";s:19:\"taxonomy_vocabulary\";s:11:\"entity keys\";a:4:{s:2:\"id\";s:3:\"vid\";s:5:\"label\";s:4:\"name\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";}s:9:\"fieldable\";b:0;s:12:\"static cache\";b:1;s:11:\"field cache\";b:1;s:9:\"load hook\";s:24:\"taxonomy_vocabulary_load\";s:7:\"bundles\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:5:\"label\";s:19:\"Taxonomy vocabulary\";s:11:\"rdf_mapping\";a:3:{s:7:\"rdftype\";a:1:{i:0;s:18:\"skos:ConceptScheme\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:11:\"description\";a:1:{s:10:\"predicates\";a:1:{i:0;s:12:\"rdfs:comment\";}}}}}s:10:\"view modes\";a:0:{}s:11:\"translation\";a:0:{}s:17:\"schema_fields_sql\";a:1:{s:10:\"base table\";a:7:{i:0;s:3:\"vid\";i:1;s:4:\"name\";i:2;s:12:\"machine_name\";i:3;s:11:\"description\";i:4;s:9:\"hierarchy\";i:5;s:6:\"module\";i:6;s:6:\"weight\";}}s:10:\"token type\";s:10:\"vocabulary\";s:12:\"plural label\";s:21:\"Taxonomy vocabularies\";s:11:\"description\";s:84:\"Vocabularies contain related taxonomy terms, which are used for classifying content.\";s:15:\"access callback\";s:31:\"entity_metadata_taxonomy_access\";s:17:\"creation callback\";s:29:\"entity_metadata_create_object\";s:13:\"save callback\";s:24:\"taxonomy_vocabulary_save\";s:17:\"deletion callback\";s:26:\"taxonomy_vocabulary_delete\";s:13:\"form callback\";s:40:\"entity_metadata_form_taxonomy_vocabulary\";s:13:\"configuration\";b:0;}s:4:\"user\";a:24:{s:5:\"label\";s:4:\"User\";s:16:\"controller class\";s:14:\"UserController\";s:10:\"base table\";s:5:\"users\";s:12:\"uri callback\";s:8:\"user_uri\";s:14:\"label callback\";s:15:\"format_username\";s:9:\"fieldable\";b:1;s:11:\"entity keys\";a:3:{s:2:\"id\";s:3:\"uid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";}s:7:\"bundles\";a:1:{s:4:\"user\";a:3:{s:5:\"label\";s:4:\"User\";s:5:\"admin\";a:2:{s:4:\"path\";s:28:\"admin/config/people/accounts\";s:16:\"access arguments\";a:1:{i:0;s:16:\"administer users\";}}s:11:\"rdf_mapping\";a:3:{s:7:\"rdftype\";a:1:{i:0;s:16:\"sioc:UserAccount\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}s:8:\"homepage\";a:2:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:page\";}s:4:\"type\";s:3:\"rel\";}}}}s:10:\"view modes\";a:2:{s:4:\"full\";a:2:{s:5:\"label\";s:12:\"User account\";s:15:\"custom settings\";b:0;}s:5:\"token\";a:2:{s:5:\"label\";s:6:\"Tokens\";s:15:\"custom settings\";b:0;}}s:12:\"static cache\";b:1;s:11:\"field cache\";b:1;s:9:\"load hook\";s:9:\"user_load\";s:11:\"translation\";a:0:{}s:17:\"schema_fields_sql\";a:1:{s:10:\"base table\";a:16:{i:0;s:3:\"uid\";i:1;s:4:\"name\";i:2;s:4:\"pass\";i:3;s:4:\"mail\";i:4;s:5:\"theme\";i:5;s:9:\"signature\";i:6;s:16:\"signature_format\";i:7;s:7:\"created\";i:8;s:6:\"access\";i:9;s:5:\"login\";i:10;s:6:\"status\";i:11;s:8:\"timezone\";i:12;s:8:\"language\";i:13;s:7:\"picture\";i:14;s:4:\"init\";i:15;s:4:\"data\";}}s:10:\"token type\";s:4:\"user\";s:12:\"plural label\";s:5:\"Users\";s:11:\"description\";s:45:\"Users who have created accounts on your site.\";s:15:\"access callback\";s:27:\"entity_metadata_user_access\";s:17:\"creation callback\";s:29:\"entity_metadata_create_object\";s:13:\"save callback\";s:25:\"entity_metadata_user_save\";s:17:\"deletion callback\";s:11:\"user_delete\";s:13:\"form callback\";s:25:\"entity_metadata_form_user\";s:13:\"view callback\";s:27:\"entity_metadata_view_single\";s:13:\"configuration\";b:0;}}',0,1371656313,1),('entity_property_info:en','a:10:{s:7:\"comment\";a:2:{s:10:\"properties\";a:14:{s:3:\"cid\";a:4:{s:5:\"label\";s:10:\"Comment ID\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:29:\"The unique ID of the comment.\";s:12:\"schema field\";s:3:\"cid\";}s:8:\"hostname\";a:3:{s:5:\"label\";s:10:\"IP Address\";s:11:\"description\";s:59:\"The IP address of the computer the comment was posted from.\";s:12:\"schema field\";s:8:\"hostname\";}s:4:\"name\";a:7:{s:5:\"label\";s:4:\"Name\";s:11:\"description\";s:36:\"The name left by the comment author.\";s:15:\"getter callback\";s:38:\"entity_metadata_comment_get_properties\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:19:\"administer comments\";s:8:\"sanitize\";s:10:\"filter_xss\";s:12:\"schema field\";s:4:\"name\";}s:4:\"mail\";a:7:{s:5:\"label\";s:13:\"Email address\";s:11:\"description\";s:45:\"The email address left by the comment author.\";s:15:\"getter callback\";s:38:\"entity_metadata_comment_get_properties\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:19:\"administer comments\";s:19:\"validation callback\";s:19:\"valid_email_address\";s:12:\"schema field\";s:4:\"mail\";}s:8:\"homepage\";a:6:{s:5:\"label\";s:9:\"Home page\";s:11:\"description\";s:45:\"The home page URL left by the comment author.\";s:8:\"sanitize\";s:23:\"filter_xss_bad_protocol\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:19:\"administer comments\";s:12:\"schema field\";s:8:\"homepage\";}s:7:\"subject\";a:7:{s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:27:\"The subject of the comment.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:19:\"administer comments\";s:8:\"sanitize\";s:10:\"filter_xss\";s:8:\"required\";b:1;s:12:\"schema field\";s:7:\"subject\";}s:3:\"url\";a:5:{s:5:\"label\";s:3:\"URL\";s:11:\"description\";s:23:\"The URL of the comment.\";s:15:\"getter callback\";s:37:\"entity_metadata_entity_get_properties\";s:4:\"type\";s:3:\"uri\";s:8:\"computed\";b:1;}s:8:\"edit_url\";a:5:{s:5:\"label\";s:8:\"Edit URL\";s:11:\"description\";s:35:\"The URL of the comment\'s edit page.\";s:15:\"getter callback\";s:38:\"entity_metadata_comment_get_properties\";s:4:\"type\";s:3:\"uri\";s:8:\"computed\";b:1;}s:7:\"created\";a:6:{s:5:\"label\";s:12:\"Date created\";s:11:\"description\";s:32:\"The date the comment was posted.\";s:4:\"type\";s:4:\"date\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:19:\"administer comments\";s:12:\"schema field\";s:7:\"created\";}s:6:\"parent\";a:5:{s:5:\"label\";s:6:\"Parent\";s:11:\"description\";s:53:\"The comment\'s parent, if comment threading is active.\";s:4:\"type\";s:7:\"comment\";s:15:\"getter callback\";s:38:\"entity_metadata_comment_get_properties\";s:12:\"schema field\";s:3:\"pid\";}s:4:\"node\";a:7:{s:5:\"label\";s:4:\"Node\";s:11:\"description\";s:35:\"The node the comment was posted to.\";s:4:\"type\";s:4:\"node\";s:15:\"setter callback\";s:30:\"entity_metadata_comment_setter\";s:17:\"setter permission\";s:19:\"administer comments\";s:8:\"required\";b:1;s:12:\"schema field\";s:3:\"nid\";}s:6:\"author\";a:7:{s:5:\"label\";s:6:\"Author\";s:11:\"description\";s:26:\"The author of the comment.\";s:4:\"type\";s:4:\"user\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:19:\"administer comments\";s:8:\"required\";b:1;s:12:\"schema field\";s:3:\"uid\";}s:6:\"status\";a:7:{s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:48:\"Whether the comment is published or unpublished.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:4:\"type\";s:7:\"integer\";s:12:\"options list\";s:35:\"entity_metadata_status_options_list\";s:17:\"setter permission\";s:19:\"administer comments\";s:12:\"schema field\";s:6:\"status\";}s:12:\"comment_body\";a:7:{s:4:\"type\";s:14:\"text_formatted\";s:5:\"label\";s:18:\"The main body text\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:4:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}s:5:\"field\";b:1;s:8:\"required\";b:1;}}s:7:\"bundles\";a:12:{s:17:\"comment_node_page\";a:1:{s:10:\"properties\";a:1:{s:12:\"comment_body\";a:11:{s:5:\"label\";s:7:\"Comment\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:21:\"Field \"comment_body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:4:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}s:20:\"comment_node_article\";a:1:{s:10:\"properties\";a:1:{s:12:\"comment_body\";a:11:{s:5:\"label\";s:7:\"Comment\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:21:\"Field \"comment_body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:4:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}s:20:\"comment_node_vcenter\";a:1:{s:10:\"properties\";a:1:{s:12:\"comment_body\";a:11:{s:5:\"label\";s:7:\"Comment\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:21:\"Field \"comment_body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:4:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}s:24:\"comment_node_data_center\";a:1:{s:10:\"properties\";a:1:{s:12:\"comment_body\";a:11:{s:5:\"label\";s:7:\"Comment\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:21:\"Field \"comment_body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:4:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}s:28:\"comment_node_virtual_machine\";a:1:{s:10:\"properties\";a:1:{s:12:\"comment_body\";a:11:{s:5:\"label\";s:7:\"Comment\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:21:\"Field \"comment_body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:4:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}s:17:\"comment_node_host\";a:1:{s:10:\"properties\";a:1:{s:12:\"comment_body\";a:11:{s:5:\"label\";s:7:\"Comment\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:21:\"Field \"comment_body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:4:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}s:19:\"comment_node_device\";a:1:{s:10:\"properties\";a:1:{s:12:\"comment_body\";a:11:{s:5:\"label\";s:7:\"Comment\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:21:\"Field \"comment_body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:4:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}s:18:\"comment_node_vdisk\";a:1:{s:10:\"properties\";a:1:{s:12:\"comment_body\";a:11:{s:5:\"label\";s:7:\"Comment\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:21:\"Field \"comment_body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:4:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}s:18:\"comment_node_panel\";a:1:{s:10:\"properties\";a:1:{s:12:\"comment_body\";a:11:{s:5:\"label\";s:7:\"Comment\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:21:\"Field \"comment_body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:4:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}s:23:\"comment_node_vm_metrics\";a:1:{s:10:\"properties\";a:1:{s:12:\"comment_body\";a:11:{s:5:\"label\";s:7:\"Comment\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:21:\"Field \"comment_body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:4:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}s:26:\"comment_node_vdisk_metrics\";a:1:{s:10:\"properties\";a:1:{s:12:\"comment_body\";a:11:{s:5:\"label\";s:7:\"Comment\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:21:\"Field \"comment_body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:4:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}s:27:\"comment_node_vm_cache_space\";a:1:{s:10:\"properties\";a:1:{s:12:\"comment_body\";a:11:{s:5:\"label\";s:7:\"Comment\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:21:\"Field \"comment_body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:4:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}}}s:4:\"node\";a:2:{s:7:\"bundles\";a:11:{s:4:\"page\";a:1:{s:10:\"properties\";a:1:{s:4:\"body\";a:11:{s:5:\"label\";s:4:\"Body\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:13:\"Field \"body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"property info\";a:3:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:7:\"summary\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:7:\"Summary\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:4:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}s:7:\"article\";a:1:{s:10:\"properties\";a:2:{s:4:\"body\";a:11:{s:5:\"label\";s:4:\"Body\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:13:\"Field \"body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"property info\";a:3:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:7:\"summary\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:7:\"Summary\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:4:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}s:10:\"field_tags\";a:11:{s:5:\"label\";s:4:\"Tags\";s:4:\"type\";s:19:\"list<taxonomy_term>\";s:11:\"description\";s:19:\"Field \"field_tags\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:6:\"bundle\";s:4:\"tags\";}}}s:7:\"vcenter\";a:1:{s:10:\"properties\";a:7:{s:4:\"body\";a:11:{s:5:\"label\";s:11:\"Description\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:13:\"Field \"body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"property info\";a:3:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:7:\"summary\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:7:\"Summary\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:4:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}s:16:\"field_ip_address\";a:10:{s:5:\"label\";s:10:\"IP Address\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:25:\"Field \"field_ip_address\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:14:\"field_username\";a:10:{s:5:\"label\";s:8:\"Username\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:23:\"Field \"field_username\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:14:\"field_password\";a:10:{s:5:\"label\";s:8:\"Password\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:23:\"Field \"field_password\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:23:\"field_rediscover_status\";a:10:{s:5:\"label\";s:17:\"Rediscover Status\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:32:\"Field \"field_rediscover_status\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:14:\"field_hostname\";a:10:{s:5:\"label\";s:8:\"Hostname\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:23:\"Field \"field_hostname\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:14:\"field_fmc_uuid\";a:10:{s:5:\"label\";s:8:\"FMC UUID\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:23:\"Field \"field_fmc_uuid\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}}}s:11:\"data_center\";a:1:{s:10:\"properties\";a:2:{s:4:\"body\";a:11:{s:5:\"label\";s:11:\"Description\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:13:\"Field \"body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"property info\";a:3:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:7:\"summary\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:7:\"Summary\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:4:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}s:21:\"field_related_vcenter\";a:10:{s:5:\"label\";s:15:\"Related vCenter\";s:4:\"type\";s:4:\"node\";s:11:\"description\";s:30:\"Field \"field_related_vcenter\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}}}s:15:\"virtual_machine\";a:1:{s:10:\"properties\";a:33:{s:19:\"field_vm_ip_address\";a:10:{s:5:\"label\";s:10:\"IP Address\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:28:\"Field \"field_vm_ip_address\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:17:\"field_memory_size\";a:10:{s:5:\"label\";s:11:\"Memory Size\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:26:\"Field \"field_memory_size\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:14:\"field_template\";a:10:{s:5:\"label\";s:8:\"Template\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:23:\"Field \"field_template\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:18:\"field_vm_path_name\";a:10:{s:5:\"label\";s:12:\"VM Path Name\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:27:\"Field \"field_vm_path_name\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:14:\"field_guest_os\";a:10:{s:5:\"label\";s:8:\"Guest OS\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:23:\"Field \"field_guest_os\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:14:\"field_guest_id\";a:10:{s:5:\"label\";s:8:\"Guest ID\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:23:\"Field \"field_guest_id\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:15:\"field_cpu_usage\";a:10:{s:5:\"label\";s:9:\"CPU Usage\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:24:\"Field \"field_cpu_usage\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:23:\"field_host_memory_usage\";a:10:{s:5:\"label\";s:17:\"Host Memory Usage\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:32:\"Field \"field_host_memory_usage\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:24:\"field_guest_memory_usage\";a:10:{s:5:\"label\";s:18:\"Guest Memory Usage\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:33:\"Field \"field_guest_memory_usage\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:17:\"field_vm_username\";a:10:{s:5:\"label\";s:8:\"Username\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:26:\"Field \"field_vm_username\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:17:\"field_vm_password\";a:10:{s:5:\"label\";s:8:\"Password\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:26:\"Field \"field_vm_password\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:19:\"field_driver_status\";a:10:{s:5:\"label\";s:13:\"Driver Status\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:28:\"Field \"field_driver_status\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:10:\"field_host\";a:10:{s:5:\"label\";s:4:\"Host\";s:4:\"type\";s:4:\"node\";s:11:\"description\";s:19:\"Field \"field_host\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:18:\"field_vmware_tools\";a:10:{s:5:\"label\";s:12:\"VMware Tools\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:27:\"Field \"field_vmware_tools\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:15:\"field_no_of_cpu\";a:10:{s:5:\"label\";s:9:\"no_of_cpu\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:24:\"Field \"field_no_of_cpu\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:19:\"field_virtual_disks\";a:10:{s:5:\"label\";s:13:\"virtual_disks\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:28:\"Field \"field_virtual_disks\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:22:\"field_fa_build_version\";a:10:{s:5:\"label\";s:13:\"Build Version\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:31:\"Field \"field_fa_build_version\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:19:\"field_fa_cache_mode\";a:10:{s:5:\"label\";s:10:\"Cache Mode\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:28:\"Field \"field_fa_cache_mode\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:29:\"field_fa_administration_state\";a:10:{s:5:\"label\";s:20:\"Administration State\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:38:\"Field \"field_fa_administration_state\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:19:\"field_fa_cache_size\";a:10:{s:5:\"label\";s:10:\"Cache Size\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:28:\"Field \"field_fa_cache_size\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:26:\"field_fa_operational_state\";a:10:{s:5:\"label\";s:17:\"Operational State\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:35:\"Field \"field_fa_operational_state\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:28:\"field_fa_operational_message\";a:10:{s:5:\"label\";s:19:\"Operational Message\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:37:\"Field \"field_fa_operational_message\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:26:\"field_fa_performance_state\";a:10:{s:5:\"label\";s:17:\"Performance State\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:35:\"Field \"field_fa_performance_state\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:22:\"field_fa_generation_id\";a:10:{s:5:\"label\";s:13:\"Generation ID\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:31:\"Field \"field_fa_generation_id\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:16:\"field_cachespace\";a:10:{s:5:\"label\";s:10:\"Cachespace\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:25:\"Field \"field_cachespace\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:18:\"field_install_port\";a:10:{s:5:\"label\";s:12:\"Install Port\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:27:\"Field \"field_install_port\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:20:\"field_vm_vmotionable\";a:11:{s:5:\"label\";s:12:\"V Motionable\";s:4:\"type\";s:7:\"boolean\";s:11:\"description\";s:29:\"Field \"field_vm_vmotionable\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:12:\"options list\";s:34:\"entity_metadata_field_options_list\";}s:22:\"field_fa_usable_blocks\";a:10:{s:5:\"label\";s:13:\"Usable Blocks\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:31:\"Field \"field_fa_usable_blocks\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:20:\"field_fa_sector_size\";a:10:{s:5:\"label\";s:11:\"Sector Size\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:29:\"Field \"field_fa_sector_size\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:17:\"field_vm_hostname\";a:10:{s:5:\"label\";s:8:\"Hostname\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:26:\"Field \"field_vm_hostname\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:31:\"field_fa_metrics_reset_interval\";a:10:{s:5:\"label\";s:22:\"Metrics Reset Interval\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:40:\"Field \"field_fa_metrics_reset_interval\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:23:\"field_vm_vmotion_policy\";a:10:{s:5:\"label\";s:17:\"VM vMotion Policy\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:32:\"Field \"field_vm_vmotion_policy\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:25:\"field_vm_vmotion_hostlist\";a:10:{s:5:\"label\";s:19:\"VM vMotion Hostlist\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:34:\"Field \"field_vm_vmotion_hostlist\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}}}s:4:\"host\";a:1:{s:10:\"properties\";a:32:{s:15:\"field_cpu_usage\";a:10:{s:5:\"label\";s:9:\"CPU Usage\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:24:\"Field \"field_cpu_usage\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:15:\"field_cpu_model\";a:10:{s:5:\"label\";s:9:\"Cpu Model\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:24:\"Field \"field_cpu_model\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:14:\"field_boottime\";a:10:{s:5:\"label\";s:8:\"BootTime\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:23:\"Field \"field_boottime\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:17:\"field_host_status\";a:10:{s:5:\"label\";s:11:\"Host Status\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:26:\"Field \"field_host_status\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:22:\"field_maintenance_mode\";a:10:{s:5:\"label\";s:16:\"Maintenance mode\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:31:\"Field \"field_maintenance_mode\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:21:\"field_physical_memory\";a:10:{s:5:\"label\";s:15:\"Physical Memory\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:30:\"Field \"field_physical_memory\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:13:\"field_vmotion\";a:10:{s:5:\"label\";s:7:\"VMotion\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:22:\"Field \"field_vmotion\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:21:\"field_reboot_required\";a:10:{s:5:\"label\";s:15:\"Reboot Required\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:30:\"Field \"field_reboot_required\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:19:\"field_host_username\";a:10:{s:5:\"label\";s:8:\"Username\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:28:\"Field \"field_host_username\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:19:\"field_host_password\";a:10:{s:5:\"label\";s:8:\"Password\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:28:\"Field \"field_host_password\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:19:\"field_bundle_status\";a:10:{s:5:\"label\";s:13:\"Bundle Status\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:28:\"Field \"field_bundle_status\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:16:\"field_datacenter\";a:10:{s:5:\"label\";s:10:\"Datacenter\";s:4:\"type\";s:4:\"node\";s:11:\"description\";s:25:\"Field \"field_datacenter\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:22:\"field_software_on_host\";a:10:{s:5:\"label\";s:16:\"Software on host\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:31:\"Field \"field_software_on_host\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:24:\"field_allocated_segments\";a:10:{s:5:\"label\";s:18:\"Allocated Segments\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:33:\"Field \"field_allocated_segments\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:18:\"field_segment_size\";a:10:{s:5:\"label\";s:12:\"Segment Size\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:27:\"Field \"field_segment_size\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:26:\"field_max_virtual_machines\";a:10:{s:5:\"label\";s:20:\"Max Virtual Machines\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:35:\"Field \"field_max_virtual_machines\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:26:\"field_max_physical_devices\";a:10:{s:5:\"label\";s:20:\"Max Physical Devices\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:35:\"Field \"field_max_physical_devices\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:30:\"field_claimed_physical_devices\";a:10:{s:5:\"label\";s:24:\"Claimed Physical Devices\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:39:\"Field \"field_claimed_physical_devices\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:17:\"field_cache_state\";a:10:{s:5:\"label\";s:11:\"Cache State\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:26:\"Field \"field_cache_state\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:20:\"field_total_segments\";a:10:{s:5:\"label\";s:14:\"Total Segments\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:29:\"Field \"field_total_segments\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:32:\"field_allocated_virtual_machines\";a:10:{s:5:\"label\";s:26:\"Allocated Virtual Machines\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:41:\"Field \"field_allocated_virtual_machines\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:17:\"field_vib_version\";a:10:{s:5:\"label\";s:11:\"VIB Version\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:26:\"Field \"field_vib_version\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:16:\"field_total_size\";a:10:{s:5:\"label\";s:10:\"Total Size\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:25:\"Field \"field_total_size\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:20:\"field_naa_identifier\";a:10:{s:5:\"label\";s:14:\"NAA Identifier\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:29:\"Field \"field_naa_identifier\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:20:\"field_allocated_size\";a:10:{s:5:\"label\";s:14:\"Allocated Size\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:29:\"Field \"field_allocated_size\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:18:\"field_device_state\";a:10:{s:5:\"label\";s:12:\"Device State\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:27:\"Field \"field_device_state\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:16:\"field_host_model\";a:10:{s:5:\"label\";s:10:\"Host Model\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:25:\"Field \"field_host_model\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:17:\"field_host_vendor\";a:10:{s:5:\"label\";s:11:\"Host Vendor\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:26:\"Field \"field_host_vendor\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:10:\"field_hbtl\";a:10:{s:5:\"label\";s:4:\"HBTL\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:19:\"Field \"field_hbtl\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:13:\"field_host_ip\";a:10:{s:5:\"label\";s:2:\"IP\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:22:\"Field \"field_host_ip\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:9:\"field_drs\";a:10:{s:5:\"label\";s:3:\"drs\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:18:\"Field \"field_drs\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:8:\"field_ha\";a:10:{s:5:\"label\";s:2:\"HA\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:17:\"Field \"field_ha\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}}}s:6:\"device\";a:1:{s:10:\"properties\";a:24:{s:15:\"field_serial_no\";a:10:{s:5:\"label\";s:9:\"Serial No\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:24:\"Field \"field_serial_no\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:10:\"field_size\";a:10:{s:5:\"label\";s:4:\"Size\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:19:\"Field \"field_size\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:17:\"field_device_type\";a:10:{s:5:\"label\";s:11:\"Device Type\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:26:\"Field \"field_device_type\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:22:\"field_multipath_plugin\";a:10:{s:5:\"label\";s:16:\"Multipath Plugin\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:31:\"Field \"field_multipath_plugin\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:16:\"field_devfs_path\";a:10:{s:5:\"label\";s:10:\"Devfs Path\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:25:\"Field \"field_devfs_path\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:12:\"field_vendor\";a:10:{s:5:\"label\";s:6:\"Vendor\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:21:\"Field \"field_vendor\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:11:\"field_model\";a:10:{s:5:\"label\";s:5:\"Model\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:20:\"Field \"field_model\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:14:\"field_revision\";a:10:{s:5:\"label\";s:8:\"Revision\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:23:\"Field \"field_revision\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:16:\"field_scsi_level\";a:10:{s:5:\"label\";s:10:\"SCSI Level\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:25:\"Field \"field_scsi_level\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:15:\"field_is_pseudo\";a:11:{s:5:\"label\";s:9:\"Is Pseudo\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:24:\"Field \"field_is_pseudo\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:12:\"options list\";s:34:\"entity_metadata_field_options_list\";}s:12:\"field_status\";a:11:{s:5:\"label\";s:6:\"Status\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:21:\"Field \"field_status\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:12:\"options list\";s:34:\"entity_metadata_field_options_list\";}s:20:\"field_is_rdm_capable\";a:11:{s:5:\"label\";s:14:\"Is RDM Capable\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:29:\"Field \"field_is_rdm_capable\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:12:\"options list\";s:34:\"entity_metadata_field_options_list\";}s:14:\"field_is_local\";a:11:{s:5:\"label\";s:8:\"Is Local\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:23:\"Field \"field_is_local\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:12:\"options list\";s:34:\"entity_metadata_field_options_list\";}s:18:\"field_is_removable\";a:11:{s:5:\"label\";s:12:\"Is Removable\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:27:\"Field \"field_is_removable\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:12:\"options list\";s:34:\"entity_metadata_field_options_list\";}s:12:\"field_is_ssd\";a:11:{s:5:\"label\";s:6:\"Is SSD\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:21:\"Field \"field_is_ssd\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:12:\"options list\";s:34:\"entity_metadata_field_options_list\";}s:16:\"field_is_offline\";a:11:{s:5:\"label\";s:10:\"Is Offline\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:25:\"Field \"field_is_offline\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:12:\"options list\";s:34:\"entity_metadata_field_options_list\";}s:29:\"field_is_perennially_reserved\";a:11:{s:5:\"label\";s:23:\"Is Perennially Reserved\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:38:\"Field \"field_is_perennially_reserved\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:12:\"options list\";s:34:\"entity_metadata_field_options_list\";}s:30:\"field_thin_provisioning_status\";a:10:{s:5:\"label\";s:24:\"Thin Provisioning Status\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:39:\"Field \"field_thin_provisioning_status\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:22:\"field_attached_filters\";a:10:{s:5:\"label\";s:16:\"Attached Filters\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:31:\"Field \"field_attached_filters\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:17:\"field_vaai_status\";a:10:{s:5:\"label\";s:11:\"VAAI Status\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:26:\"Field \"field_vaai_status\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:16:\"field_other_uids\";a:10:{s:5:\"label\";s:10:\"Other UIDs\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:25:\"Field \"field_other_uids\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:18:\"field_display_name\";a:10:{s:5:\"label\";s:12:\"Display Name\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:27:\"Field \"field_display_name\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:18:\"field_related_host\";a:10:{s:5:\"label\";s:12:\"Related Host\";s:4:\"type\";s:4:\"node\";s:11:\"description\";s:27:\"Field \"field_related_host\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:13:\"field_is_vmfs\";a:10:{s:5:\"label\";s:7:\"Is VMFS\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:22:\"Field \"field_is_vmfs\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}}}s:5:\"vdisk\";a:1:{s:10:\"properties\";a:14:{s:14:\"field_capacity\";a:10:{s:5:\"label\";s:8:\"Capacity\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:23:\"Field \"field_capacity\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:10:\"field_path\";a:10:{s:5:\"label\";s:4:\"Path\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:19:\"Field \"field_path\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:15:\"field_freespace\";a:10:{s:5:\"label\";s:9:\"Freespace\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:24:\"Field \"field_freespace\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:21:\"field_virtual_machine\";a:10:{s:5:\"label\";s:15:\"Virtual Machine\";s:4:\"type\";s:4:\"node\";s:11:\"description\";s:30:\"Field \"field_virtual_machine\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:19:\"field_fa_cache_mode\";a:10:{s:5:\"label\";s:10:\"Cache Mode\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:28:\"Field \"field_fa_cache_mode\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:29:\"field_fa_administration_state\";a:10:{s:5:\"label\";s:20:\"Administration State\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:38:\"Field \"field_fa_administration_state\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:26:\"field_fa_operational_state\";a:10:{s:5:\"label\";s:17:\"Operational State\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:35:\"Field \"field_fa_operational_state\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:28:\"field_fa_operational_message\";a:10:{s:5:\"label\";s:19:\"Operational Message\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:37:\"Field \"field_fa_operational_message\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:26:\"field_fa_performance_state\";a:10:{s:5:\"label\";s:17:\"Performance State\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:35:\"Field \"field_fa_performance_state\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:16:\"field_disk_index\";a:10:{s:5:\"label\";s:10:\"Disk Index\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:25:\"Field \"field_disk_index\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:22:\"field_vdisk_identifier\";a:10:{s:5:\"label\";s:10:\"Identifier\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:31:\"Field \"field_vdisk_identifier\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:16:\"field_vdisk_name\";a:10:{s:5:\"label\";s:10:\"vDisk Name\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:25:\"Field \"field_vdisk_name\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:16:\"field_vdisk_type\";a:10:{s:5:\"label\";s:10:\"vDisk Type\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:25:\"Field \"field_vdisk_type\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:14:\"field_vdisk_id\";a:10:{s:5:\"label\";s:8:\"vDisk Id\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:23:\"Field \"field_vdisk_id\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}}}s:10:\"vm_metrics\";a:1:{s:10:\"properties\";a:16:{s:8:\"field_vm\";a:10:{s:5:\"label\";s:2:\"VM\";s:4:\"type\";s:4:\"node\";s:11:\"description\";s:17:\"Field \"field_vm\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:21:\"field_vm_read_latency\";a:10:{s:5:\"label\";s:12:\"Read latency\";s:4:\"type\";s:7:\"decimal\";s:11:\"description\";s:30:\"Field \"field_vm_read_latency\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:22:\"field_vm_write_latency\";a:10:{s:5:\"label\";s:13:\"Write latency\";s:4:\"type\";s:7:\"decimal\";s:11:\"description\";s:31:\"Field \"field_vm_write_latency\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:17:\"field_vm_read_ops\";a:10:{s:5:\"label\";s:8:\"Read ops\";s:4:\"type\";s:7:\"decimal\";s:11:\"description\";s:26:\"Field \"field_vm_read_ops\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:18:\"field_vm_write_ops\";a:10:{s:5:\"label\";s:9:\"Write ops\";s:4:\"type\";s:7:\"decimal\";s:11:\"description\";s:27:\"Field \"field_vm_write_ops\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:13:\"field_vm_hits\";a:10:{s:5:\"label\";s:4:\"Hits\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:22:\"Field \"field_vm_hits\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:20:\"field_vm_read_blocks\";a:10:{s:5:\"label\";s:11:\"Read blocks\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:29:\"Field \"field_vm_read_blocks\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:22:\"field_vm_cache_latency\";a:10:{s:5:\"label\";s:13:\"Cache latency\";s:4:\"type\";s:7:\"decimal\";s:11:\"description\";s:31:\"Field \"field_vm_cache_latency\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:19:\"field_vm_population\";a:10:{s:5:\"label\";s:10:\"Population\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:28:\"Field \"field_vm_population\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:22:\"field_vm_usable_blocks\";a:10:{s:5:\"label\";s:13:\"Usable blocks\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:31:\"Field \"field_vm_usable_blocks\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:21:\"field_vm_write_blocks\";a:10:{s:5:\"label\";s:12:\"Write blocks\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:30:\"Field \"field_vm_write_blocks\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:19:\"field_vm_insertions\";a:10:{s:5:\"label\";s:10:\"Insertions\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:28:\"Field \"field_vm_insertions\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:22:\"field_vm_population_pc\";a:9:{s:5:\"label\";s:12:\"Population %\";s:4:\"type\";s:7:\"decimal\";s:11:\"description\";s:31:\"Field \"field_vm_population_pc\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:26:\"field_vm_insertion_rate_pc\";a:9:{s:5:\"label\";s:16:\"Insertion rate %\";s:4:\"type\";s:7:\"decimal\";s:11:\"description\";s:35:\"Field \"field_vm_insertion_rate_pc\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:15:\"field_timestamp\";a:9:{s:5:\"label\";s:9:\"Timestamp\";s:4:\"type\";s:4:\"date\";s:11:\"description\";s:24:\"Field \"field_timestamp\".\";s:15:\"getter callback\";s:33:\"date_entity_metadata_field_getter\";s:15:\"setter callback\";s:33:\"date_entity_metadata_field_setter\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:20:\"field_vm_hit_rate_pc\";a:9:{s:5:\"label\";s:10:\"Hit Rate %\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:29:\"Field \"field_vm_hit_rate_pc\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}}}s:13:\"vdisk_metrics\";a:1:{s:10:\"properties\";a:17:{s:11:\"field_vdisk\";a:10:{s:5:\"label\";s:5:\"vDisk\";s:4:\"type\";s:4:\"node\";s:11:\"description\";s:20:\"Field \"field_vdisk\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:24:\"field_vdisk_read_latency\";a:10:{s:5:\"label\";s:12:\"Read latency\";s:4:\"type\";s:7:\"decimal\";s:11:\"description\";s:33:\"Field \"field_vdisk_read_latency\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:25:\"field_vdisk_write_latency\";a:10:{s:5:\"label\";s:13:\"Write latency\";s:4:\"type\";s:7:\"decimal\";s:11:\"description\";s:34:\"Field \"field_vdisk_write_latency\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:20:\"field_vdisk_read_ops\";a:10:{s:5:\"label\";s:8:\"Read ops\";s:4:\"type\";s:7:\"decimal\";s:11:\"description\";s:29:\"Field \"field_vdisk_read_ops\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:21:\"field_vdisk_write_ops\";a:10:{s:5:\"label\";s:9:\"Write ops\";s:4:\"type\";s:7:\"decimal\";s:11:\"description\";s:30:\"Field \"field_vdisk_write_ops\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:16:\"field_vdisk_hits\";a:10:{s:5:\"label\";s:4:\"Hits\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:25:\"Field \"field_vdisk_hits\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:23:\"field_vdisk_read_blocks\";a:10:{s:5:\"label\";s:11:\"Read blocks\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:32:\"Field \"field_vdisk_read_blocks\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:25:\"field_vdisk_cache_latency\";a:10:{s:5:\"label\";s:13:\"Cache latency\";s:4:\"type\";s:7:\"decimal\";s:11:\"description\";s:34:\"Field \"field_vdisk_cache_latency\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:22:\"field_vdisk_population\";a:10:{s:5:\"label\";s:10:\"Population\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:31:\"Field \"field_vdisk_population\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:25:\"field_vdisk_usable_blocks\";a:10:{s:5:\"label\";s:13:\"Usable blocks\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:34:\"Field \"field_vdisk_usable_blocks\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:22:\"field_vdisk_insertions\";a:10:{s:5:\"label\";s:10:\"Insertions\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:31:\"Field \"field_vdisk_insertions\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:24:\"field_vdisk_write_blocks\";a:10:{s:5:\"label\";s:12:\"Write blocks\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:33:\"Field \"field_vdisk_write_blocks\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:15:\"field_timestamp\";a:9:{s:5:\"label\";s:9:\"Timestamp\";s:4:\"type\";s:4:\"date\";s:11:\"description\";s:24:\"Field \"field_timestamp\".\";s:15:\"getter callback\";s:33:\"date_entity_metadata_field_getter\";s:15:\"setter callback\";s:33:\"date_entity_metadata_field_setter\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:25:\"field_vdisk_population_pc\";a:9:{s:5:\"label\";s:12:\"Population %\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:34:\"Field \"field_vdisk_population_pc\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:29:\"field_vdisk_insertion_rate_pc\";a:9:{s:5:\"label\";s:16:\"Insertion rate %\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:38:\"Field \"field_vdisk_insertion_rate_pc\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:13:\"field_hit_ops\";a:10:{s:5:\"label\";s:7:\"Hit Ops\";s:4:\"type\";s:7:\"decimal\";s:11:\"description\";s:22:\"Field \"field_hit_ops\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:23:\"field_vdisk_hit_rate_pc\";a:9:{s:5:\"label\";s:10:\"Hit Rate %\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:32:\"Field \"field_vdisk_hit_rate_pc\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}}}s:14:\"vm_cache_space\";a:1:{s:10:\"properties\";a:3:{s:19:\"field_vm_cache_size\";a:10:{s:5:\"label\";s:10:\"Cache Size\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:28:\"Field \"field_vm_cache_size\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:30:\"field_cache_assigned_from_host\";a:10:{s:5:\"label\";s:18:\"Assigned from Host\";s:4:\"type\";s:4:\"node\";s:11:\"description\";s:39:\"Field \"field_cache_assigned_from_host\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}s:27:\"field_cache_allocated_to_vm\";a:10:{s:5:\"label\";s:28:\"Allocated to Virtual Machine\";s:4:\"type\";s:4:\"node\";s:11:\"description\";s:36:\"Field \"field_cache_allocated_to_vm\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}}}}s:10:\"properties\";a:21:{s:3:\"nid\";a:4:{s:5:\"label\";s:7:\"Node ID\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:26:\"The unique ID of the node.\";s:12:\"schema field\";s:3:\"nid\";}s:3:\"vid\";a:4:{s:5:\"label\";s:11:\"Revision ID\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:37:\"The unique ID of the node\'s revision.\";s:12:\"schema field\";s:3:\"vid\";}s:6:\"is_new\";a:4:{s:5:\"label\";s:6:\"Is new\";s:4:\"type\";s:7:\"boolean\";s:11:\"description\";s:58:\"Whether the node is new and not saved to the database yet.\";s:15:\"getter callback\";s:35:\"entity_metadata_node_get_properties\";}s:4:\"type\";a:8:{s:5:\"label\";s:12:\"Content type\";s:4:\"type\";s:5:\"token\";s:11:\"description\";s:21:\"The type of the node.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:12:\"options list\";s:19:\"node_type_get_names\";s:8:\"required\";b:1;s:12:\"schema field\";s:4:\"type\";}s:5:\"title\";a:5:{s:5:\"label\";s:5:\"Title\";s:11:\"description\";s:22:\"The title of the node.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:12:\"schema field\";s:5:\"title\";s:8:\"required\";b:1;}s:8:\"language\";a:7:{s:5:\"label\";s:8:\"Language\";s:4:\"type\";s:5:\"token\";s:11:\"description\";s:36:\"The language the node is written in.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:12:\"options list\";s:29:\"entity_metadata_language_list\";s:12:\"schema field\";s:8:\"language\";s:17:\"setter permission\";s:16:\"administer nodes\";}s:3:\"url\";a:5:{s:5:\"label\";s:3:\"URL\";s:11:\"description\";s:20:\"The URL of the node.\";s:15:\"getter callback\";s:37:\"entity_metadata_entity_get_properties\";s:4:\"type\";s:3:\"uri\";s:8:\"computed\";b:1;}s:8:\"edit_url\";a:5:{s:5:\"label\";s:8:\"Edit URL\";s:11:\"description\";s:32:\"The URL of the node\'s edit page.\";s:15:\"getter callback\";s:35:\"entity_metadata_node_get_properties\";s:4:\"type\";s:3:\"uri\";s:8:\"computed\";b:1;}s:6:\"status\";a:7:{s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:45:\"Whether the node is published or unpublished.\";s:4:\"type\";s:7:\"integer\";s:12:\"options list\";s:35:\"entity_metadata_status_options_list\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:12:\"schema field\";s:6:\"status\";}s:7:\"promote\";a:6:{s:5:\"label\";s:21:\"Promoted to frontpage\";s:11:\"description\";s:46:\"Whether the node is promoted to the frontpage.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:12:\"schema field\";s:7:\"promote\";s:4:\"type\";s:7:\"boolean\";}s:6:\"sticky\";a:6:{s:5:\"label\";s:15:\"Sticky in lists\";s:11:\"description\";s:70:\"Whether the node is displayed at the top of lists in which it appears.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:12:\"schema field\";s:6:\"sticky\";s:4:\"type\";s:7:\"boolean\";}s:7:\"created\";a:6:{s:5:\"label\";s:12:\"Date created\";s:4:\"type\";s:4:\"date\";s:11:\"description\";s:29:\"The date the node was posted.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:12:\"schema field\";s:7:\"created\";}s:7:\"changed\";a:4:{s:5:\"label\";s:12:\"Date changed\";s:4:\"type\";s:4:\"date\";s:12:\"schema field\";s:7:\"changed\";s:11:\"description\";s:44:\"The date the node was most recently updated.\";}s:6:\"author\";a:7:{s:5:\"label\";s:6:\"Author\";s:4:\"type\";s:4:\"user\";s:11:\"description\";s:23:\"The author of the node.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:8:\"required\";b:1;s:12:\"schema field\";s:3:\"uid\";}s:6:\"source\";a:4:{s:5:\"label\";s:23:\"Translation source node\";s:4:\"type\";s:4:\"node\";s:11:\"description\";s:58:\"The original-language version of this node, if one exists.\";s:15:\"getter callback\";s:35:\"entity_metadata_node_get_properties\";}s:3:\"log\";a:5:{s:5:\"label\";s:20:\"Revision log message\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:93:\"In case a new revision is to be saved, the log entry explaining the changes for this version.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:15:\"access callback\";s:36:\"entity_metadata_node_revision_access\";}s:8:\"revision\";a:5:{s:5:\"label\";s:16:\"Creates revision\";s:4:\"type\";s:7:\"boolean\";s:11:\"description\";s:48:\"Whether saving this node creates a new revision.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:15:\"access callback\";s:36:\"entity_metadata_node_revision_access\";}s:7:\"comment\";a:5:{s:5:\"label\";s:16:\"Comments allowed\";s:11:\"description\";s:97:\"Whether comments are allowed on this node: 0 = no, 1 = closed (read only), 2 = open (read/write).\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:19:\"administer comments\";s:4:\"type\";s:7:\"integer\";}s:13:\"comment_count\";a:4:{s:5:\"label\";s:13:\"Comment count\";s:11:\"description\";s:40:\"The number of comments posted on a node.\";s:15:\"getter callback\";s:43:\"entity_metadata_comment_get_node_properties\";s:4:\"type\";s:7:\"integer\";}s:17:\"comment_count_new\";a:4:{s:5:\"label\";s:17:\"New comment count\";s:11:\"description\";s:72:\"The number of comments posted on a node since the reader last viewed it.\";s:15:\"getter callback\";s:43:\"entity_metadata_comment_get_node_properties\";s:4:\"type\";s:7:\"integer\";}s:4:\"body\";a:7:{s:4:\"type\";s:14:\"text_formatted\";s:5:\"label\";s:18:\"The main body text\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:13:\"property info\";a:3:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:7:\"summary\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:7:\"Summary\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:4:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";s:5:\"field\";b:1;}}}s:13:\"taxonomy_term\";a:1:{s:10:\"properties\";a:9:{s:3:\"tid\";a:4:{s:5:\"label\";s:7:\"Term ID\";s:11:\"description\";s:35:\"The unique ID of the taxonomy term.\";s:4:\"type\";s:7:\"integer\";s:12:\"schema field\";s:3:\"tid\";}s:4:\"name\";a:5:{s:5:\"label\";s:4:\"Name\";s:11:\"description\";s:30:\"The name of the taxonomy term.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:8:\"required\";b:1;s:12:\"schema field\";s:4:\"name\";}s:11:\"description\";a:7:{s:5:\"label\";s:11:\"Description\";s:11:\"description\";s:46:\"The optional description of the taxonomy term.\";s:9:\"sanitized\";b:1;s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"getter callback\";s:44:\"entity_metadata_taxonomy_term_get_properties\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:12:\"schema field\";s:11:\"description\";}s:6:\"weight\";a:5:{s:5:\"label\";s:6:\"Weight\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:72:\"The weight of the term, which is used for ordering terms during display.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:12:\"schema field\";s:6:\"weight\";}s:10:\"node_count\";a:5:{s:5:\"label\";s:10:\"Node count\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:50:\"The number of nodes tagged with the taxonomy term.\";s:15:\"getter callback\";s:44:\"entity_metadata_taxonomy_term_get_properties\";s:8:\"computed\";b:1;}s:3:\"url\";a:5:{s:5:\"label\";s:3:\"URL\";s:11:\"description\";s:29:\"The URL of the taxonomy term.\";s:15:\"getter callback\";s:37:\"entity_metadata_entity_get_properties\";s:4:\"type\";s:3:\"uri\";s:8:\"computed\";b:1;}s:10:\"vocabulary\";a:6:{s:5:\"label\";s:10:\"Vocabulary\";s:11:\"description\";s:44:\"The vocabulary the taxonomy term belongs to.\";s:15:\"setter callback\";s:36:\"entity_metadata_taxonomy_term_setter\";s:4:\"type\";s:19:\"taxonomy_vocabulary\";s:8:\"required\";b:1;s:12:\"schema field\";s:3:\"vid\";}s:6:\"parent\";a:5:{s:5:\"label\";s:12:\"Parent terms\";s:11:\"description\";s:38:\"The parent terms of the taxonomy term.\";s:15:\"getter callback\";s:44:\"entity_metadata_taxonomy_term_get_properties\";s:15:\"setter callback\";s:36:\"entity_metadata_taxonomy_term_setter\";s:4:\"type\";s:19:\"list<taxonomy_term>\";}s:11:\"parents_all\";a:5:{s:5:\"label\";s:16:\"All parent terms\";s:11:\"description\";s:65:\"Ancestors of the term, i.e. parent of all above hierarchy levels.\";s:15:\"getter callback\";s:44:\"entity_metadata_taxonomy_term_get_properties\";s:4:\"type\";s:19:\"list<taxonomy_term>\";s:8:\"computed\";b:1;}}}s:19:\"taxonomy_vocabulary\";a:1:{s:10:\"properties\";a:5:{s:3:\"vid\";a:4:{s:5:\"label\";s:13:\"Vocabulary ID\";s:11:\"description\";s:41:\"The unique ID of the taxonomy vocabulary.\";s:4:\"type\";s:7:\"integer\";s:12:\"schema field\";s:3:\"vid\";}s:4:\"name\";a:5:{s:5:\"label\";s:4:\"Name\";s:11:\"description\";s:36:\"The name of the taxonomy vocabulary.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:8:\"required\";b:1;s:12:\"schema field\";s:4:\"name\";}s:12:\"machine_name\";a:6:{s:5:\"label\";s:12:\"Machine name\";s:4:\"type\";s:5:\"token\";s:11:\"description\";s:44:\"The machine name of the taxonomy vocabulary.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:8:\"required\";b:1;s:12:\"schema field\";s:12:\"machine_name\";}s:11:\"description\";a:5:{s:5:\"label\";s:11:\"Description\";s:11:\"description\";s:52:\"The optional description of the taxonomy vocabulary.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:8:\"sanitize\";s:10:\"filter_xss\";s:12:\"schema field\";s:11:\"description\";}s:10:\"term_count\";a:5:{s:5:\"label\";s:10:\"Term count\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:57:\"The number of terms belonging to the taxonomy vocabulary.\";s:15:\"getter callback\";s:50:\"entity_metadata_taxonomy_vocabulary_get_properties\";s:8:\"computed\";b:1;}}}s:4:\"user\";a:1:{s:10:\"properties\";a:11:{s:3:\"uid\";a:4:{s:5:\"label\";s:7:\"User ID\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:34:\"The unique ID of the user account.\";s:12:\"schema field\";s:3:\"uid\";}s:4:\"name\";a:8:{s:5:\"label\";s:4:\"Name\";s:11:\"description\";s:35:\"The login name of the user account.\";s:15:\"getter callback\";s:35:\"entity_metadata_user_get_properties\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:8:\"sanitize\";s:10:\"filter_xss\";s:8:\"required\";b:1;s:15:\"access callback\";s:38:\"entity_metadata_user_properties_access\";s:12:\"schema field\";s:4:\"name\";}s:4:\"mail\";a:7:{s:5:\"label\";s:5:\"Email\";s:11:\"description\";s:38:\"The email address of the user account.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:19:\"validation callback\";s:19:\"valid_email_address\";s:8:\"required\";b:1;s:15:\"access callback\";s:38:\"entity_metadata_user_properties_access\";s:12:\"schema field\";s:4:\"mail\";}s:3:\"url\";a:5:{s:5:\"label\";s:3:\"URL\";s:11:\"description\";s:36:\"The URL of the account profile page.\";s:15:\"getter callback\";s:35:\"entity_metadata_user_get_properties\";s:4:\"type\";s:3:\"uri\";s:8:\"computed\";b:1;}s:8:\"edit_url\";a:5:{s:5:\"label\";s:8:\"Edit URL\";s:11:\"description\";s:33:\"The url of the account edit page.\";s:15:\"getter callback\";s:35:\"entity_metadata_user_get_properties\";s:4:\"type\";s:3:\"uri\";s:8:\"computed\";b:1;}s:11:\"last_access\";a:5:{s:5:\"label\";s:11:\"Last access\";s:11:\"description\";s:41:\"The date the user last accessed the site.\";s:15:\"getter callback\";s:35:\"entity_metadata_user_get_properties\";s:4:\"type\";s:4:\"date\";s:12:\"schema field\";s:6:\"access\";}s:10:\"last_login\";a:5:{s:5:\"label\";s:10:\"Last login\";s:11:\"description\";s:45:\"The date the user last logged in to the site.\";s:15:\"getter callback\";s:35:\"entity_metadata_user_get_properties\";s:4:\"type\";s:4:\"date\";s:12:\"schema field\";s:5:\"login\";}s:7:\"created\";a:4:{s:5:\"label\";s:7:\"Created\";s:11:\"description\";s:38:\"The date the user account was created.\";s:4:\"type\";s:4:\"date\";s:12:\"schema field\";s:7:\"created\";}s:5:\"roles\";a:8:{s:5:\"label\";s:10:\"User roles\";s:11:\"description\";s:22:\"The roles of the user.\";s:4:\"type\";s:13:\"list<integer>\";s:15:\"getter callback\";s:35:\"entity_metadata_user_get_properties\";s:15:\"setter callback\";s:35:\"entity_metadata_user_set_properties\";s:17:\"setter permission\";s:16:\"administer users\";s:12:\"options list\";s:26:\"entity_metadata_user_roles\";s:15:\"access callback\";s:38:\"entity_metadata_user_properties_access\";}s:6:\"status\";a:7:{s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:38:\"Whether the user is active or blocked.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:4:\"type\";s:7:\"integer\";s:12:\"options list\";s:40:\"entity_metadata_user_status_options_list\";s:17:\"setter permission\";s:16:\"administer users\";s:12:\"schema field\";s:6:\"status\";}s:5:\"theme\";a:6:{s:5:\"label\";s:13:\"Default theme\";s:11:\"description\";s:25:\"The user\'s default theme.\";s:15:\"getter callback\";s:35:\"entity_metadata_user_get_properties\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:15:\"access callback\";s:38:\"entity_metadata_user_properties_access\";s:12:\"schema field\";s:5:\"theme\";}}}s:4:\"site\";a:1:{s:10:\"properties\";a:8:{s:4:\"name\";a:4:{s:5:\"label\";s:4:\"Name\";s:11:\"description\";s:21:\"The name of the site.\";s:15:\"getter callback\";s:37:\"entity_metadata_system_get_properties\";s:8:\"sanitize\";s:11:\"check_plain\";}s:6:\"slogan\";a:4:{s:5:\"label\";s:6:\"Slogan\";s:11:\"description\";s:23:\"The slogan of the site.\";s:15:\"getter callback\";s:37:\"entity_metadata_system_get_properties\";s:8:\"sanitize\";s:11:\"check_plain\";}s:4:\"mail\";a:3:{s:5:\"label\";s:5:\"Email\";s:11:\"description\";s:46:\"The administrative email address for the site.\";s:15:\"getter callback\";s:37:\"entity_metadata_system_get_properties\";}s:3:\"url\";a:4:{s:5:\"label\";s:3:\"URL\";s:11:\"description\";s:33:\"The URL of the site\'s front page.\";s:15:\"getter callback\";s:37:\"entity_metadata_system_get_properties\";s:4:\"type\";s:3:\"uri\";}s:9:\"login_url\";a:4:{s:5:\"label\";s:10:\"Login page\";s:11:\"description\";s:33:\"The URL of the site\'s login page.\";s:15:\"getter callback\";s:37:\"entity_metadata_system_get_properties\";s:4:\"type\";s:3:\"uri\";}s:12:\"current_user\";a:4:{s:5:\"label\";s:14:\"Logged in user\";s:11:\"description\";s:29:\"The currently logged in user.\";s:15:\"getter callback\";s:37:\"entity_metadata_system_get_properties\";s:4:\"type\";s:4:\"user\";}s:12:\"current_date\";a:4:{s:5:\"label\";s:12:\"Current date\";s:11:\"description\";s:26:\"The current date and time.\";s:15:\"getter callback\";s:37:\"entity_metadata_system_get_properties\";s:4:\"type\";s:4:\"date\";}s:12:\"current_page\";a:5:{s:5:\"label\";s:12:\"Current page\";s:11:\"description\";s:48:\"Information related to the current page request.\";s:15:\"getter callback\";s:37:\"entity_metadata_system_get_properties\";s:4:\"type\";s:6:\"struct\";s:13:\"property info\";a:2:{s:4:\"path\";a:4:{s:5:\"label\";s:4:\"Path\";s:11:\"description\";s:53:\"The internal Drupal path of the current page request.\";s:15:\"getter callback\";s:12:\"current_path\";s:4:\"type\";s:4:\"text\";}s:3:\"url\";a:4:{s:5:\"label\";s:3:\"URL\";s:11:\"description\";s:41:\"The full URL of the current page request.\";s:15:\"getter callback\";s:42:\"entity_metadata_system_get_page_properties\";s:4:\"type\";s:3:\"uri\";}}}}}s:4:\"file\";a:1:{s:10:\"properties\";a:7:{s:3:\"fid\";a:5:{s:5:\"label\";s:7:\"File ID\";s:11:\"description\";s:35:\"The unique ID of the uploaded file.\";s:4:\"type\";s:7:\"integer\";s:19:\"validation callback\";s:41:\"entity_metadata_validate_integer_positive\";s:12:\"schema field\";s:3:\"fid\";}s:4:\"name\";a:4:{s:5:\"label\";s:9:\"File name\";s:11:\"description\";s:29:\"The name of the file on disk.\";s:15:\"getter callback\";s:42:\"entity_metadata_system_get_file_properties\";s:12:\"schema field\";s:8:\"filename\";}s:4:\"mime\";a:5:{s:5:\"label\";s:9:\"MIME type\";s:11:\"description\";s:26:\"The MIME type of the file.\";s:15:\"getter callback\";s:42:\"entity_metadata_system_get_file_properties\";s:8:\"sanitize\";s:10:\"filter_xss\";s:12:\"schema field\";s:8:\"filemime\";}s:4:\"size\";a:5:{s:5:\"label\";s:9:\"File size\";s:11:\"description\";s:35:\"The size of the file, in kilobytes.\";s:15:\"getter callback\";s:42:\"entity_metadata_system_get_file_properties\";s:4:\"type\";s:7:\"integer\";s:12:\"schema field\";s:8:\"filesize\";}s:3:\"url\";a:3:{s:5:\"label\";s:3:\"URL\";s:11:\"description\";s:36:\"The web-accessible URL for the file.\";s:15:\"getter callback\";s:42:\"entity_metadata_system_get_file_properties\";}s:9:\"timestamp\";a:4:{s:5:\"label\";s:9:\"Timestamp\";s:11:\"description\";s:44:\"The date the file was most recently changed.\";s:4:\"type\";s:4:\"date\";s:12:\"schema field\";s:9:\"timestamp\";}s:5:\"owner\";a:5:{s:5:\"label\";s:5:\"Owner\";s:11:\"description\";s:42:\"The user who originally uploaded the file.\";s:4:\"type\";s:4:\"user\";s:15:\"getter callback\";s:42:\"entity_metadata_system_get_file_properties\";s:12:\"schema field\";s:3:\"uid\";}}}s:17:\"search_api_server\";a:1:{s:10:\"properties\";a:6:{s:2:\"id\";a:5:{s:5:\"label\";s:2:\"ID\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:36:\"The primary identifier for a server.\";s:12:\"schema field\";s:2:\"id\";s:19:\"validation callback\";s:41:\"entity_metadata_validate_integer_positive\";}s:4:\"name\";a:5:{s:5:\"label\";s:4:\"Name\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:32:\"The displayed name for a server.\";s:12:\"schema field\";s:4:\"name\";s:8:\"required\";b:1;}s:12:\"machine_name\";a:5:{s:5:\"label\";s:12:\"Machine name\";s:4:\"type\";s:5:\"token\";s:11:\"description\";s:46:\"The internally used machine name for a server.\";s:12:\"schema field\";s:12:\"machine_name\";s:8:\"required\";b:1;}s:11:\"description\";a:5:{s:5:\"label\";s:11:\"Description\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:39:\"The displayed description for a server.\";s:12:\"schema field\";s:11:\"description\";s:8:\"sanitize\";s:10:\"filter_xss\";}s:5:\"class\";a:5:{s:5:\"label\";s:13:\"Service class\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:51:\"The ID of the service class to use for this server.\";s:12:\"schema field\";s:5:\"class\";s:8:\"required\";b:1;}s:7:\"enabled\";a:4:{s:5:\"label\";s:7:\"Enabled\";s:4:\"type\";s:7:\"boolean\";s:11:\"description\";s:48:\"A flag indicating whether the server is enabled.\";s:12:\"schema field\";s:7:\"enabled\";}}}s:16:\"search_api_index\";a:1:{s:10:\"properties\";a:9:{s:2:\"id\";a:5:{s:5:\"label\";s:2:\"ID\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:33:\"An integer identifying the index.\";s:12:\"schema field\";s:2:\"id\";s:19:\"validation callback\";s:41:\"entity_metadata_validate_integer_positive\";}s:4:\"name\";a:5:{s:5:\"label\";s:4:\"Name\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:37:\"A name to be displayed for the index.\";s:12:\"schema field\";s:4:\"name\";s:8:\"required\";b:1;}s:12:\"machine_name\";a:5:{s:5:\"label\";s:12:\"Machine name\";s:4:\"type\";s:5:\"token\";s:11:\"description\";s:46:\"The internally used machine name for an index.\";s:12:\"schema field\";s:12:\"machine_name\";s:8:\"required\";b:1;}s:11:\"description\";a:5:{s:5:\"label\";s:11:\"Description\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:44:\"A string describing the index\' use to users.\";s:12:\"schema field\";s:11:\"description\";s:8:\"sanitize\";s:10:\"filter_xss\";}s:6:\"server\";a:4:{s:5:\"label\";s:9:\"Server ID\";s:4:\"type\";s:5:\"token\";s:11:\"description\";s:76:\"The machine name of the search_api_server with which data should be indexed.\";s:12:\"schema field\";s:6:\"server\";}s:13:\"server_entity\";a:4:{s:5:\"label\";s:6:\"Server\";s:4:\"type\";s:17:\"search_api_server\";s:11:\"description\";s:56:\"The search_api_server with which data should be indexed.\";s:15:\"getter callback\";s:27:\"search_api_index_get_server\";}s:9:\"item_type\";a:5:{s:5:\"label\";s:9:\"Item type\";s:4:\"type\";s:5:\"token\";s:11:\"description\";s:39:\"The type of items stored in this index.\";s:12:\"schema field\";s:9:\"item_type\";s:8:\"required\";b:1;}s:7:\"enabled\";a:4:{s:5:\"label\";s:7:\"Enabled\";s:4:\"type\";s:7:\"boolean\";s:11:\"description\";s:47:\"A flag indicating whether the index is enabled.\";s:12:\"schema field\";s:7:\"enabled\";}s:9:\"read_only\";a:4:{s:5:\"label\";s:9:\"Read only\";s:4:\"type\";s:7:\"boolean\";s:11:\"description\";s:49:\"A flag indicating whether the index is read-only.\";s:12:\"schema field\";s:9:\"read_only\";}}}s:15:\"search_api_page\";a:1:{s:10:\"properties\";a:7:{s:2:\"id\";a:5:{s:5:\"label\";s:2:\"ID\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:41:\"The primary identifier for a search page.\";s:12:\"schema field\";s:2:\"id\";s:19:\"validation callback\";s:41:\"entity_metadata_validate_integer_positive\";}s:8:\"index_id\";a:4:{s:5:\"label\";s:8:\"Index ID\";s:4:\"type\";s:5:\"token\";s:11:\"description\";s:52:\"The machine name of the index this search page uses.\";s:12:\"schema field\";s:8:\"index_id\";}s:5:\"index\";a:4:{s:5:\"label\";s:5:\"Index\";s:4:\"type\";s:16:\"search_api_index\";s:11:\"description\";s:32:\"The index this search page uses.\";s:15:\"getter callback\";s:25:\"search_api_page_get_index\";}s:4:\"name\";a:5:{s:5:\"label\";s:4:\"Name\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:37:\"The displayed name for a search page.\";s:12:\"schema field\";s:4:\"name\";s:8:\"required\";b:1;}s:12:\"machine_name\";a:5:{s:5:\"label\";s:12:\"Machine name\";s:4:\"type\";s:5:\"token\";s:11:\"description\";s:51:\"The internally used machine name for a search page.\";s:12:\"schema field\";s:12:\"machine_name\";s:8:\"required\";b:1;}s:11:\"description\";a:5:{s:5:\"label\";s:11:\"Description\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:44:\"The displayed description for a search page.\";s:12:\"schema field\";s:11:\"description\";s:8:\"sanitize\";s:10:\"filter_xss\";}s:7:\"enabled\";a:4:{s:5:\"label\";s:7:\"Enabled\";s:4:\"type\";s:7:\"boolean\";s:11:\"description\";s:53:\"A flag indicating whether the search page is enabled.\";s:12:\"schema field\";s:7:\"enabled\";}}}}',0,1371656313,1),('ctools_plugin_type_info','a:5:{s:6:\"ctools\";a:7:{s:5:\"cache\";a:13:{s:6:\"module\";s:6:\"ctools\";s:4:\"type\";s:5:\"cache\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:7:\"classes\";a:0:{}s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:7:\"process\";s:0:\"\";s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:12:\"ctools_cache\";s:11:\"load themes\";b:0;}s:13:\"content_types\";a:13:{s:5:\"cache\";b:0;s:7:\"process\";a:3:{s:8:\"function\";s:22:\"ctools_content_process\";s:4:\"file\";s:13:\"export-ui.inc\";s:4:\"path\";s:41:\"sites/all/modules/contrib/ctools/includes\";}s:6:\"module\";s:6:\"ctools\";s:4:\"type\";s:13:\"content_types\";s:11:\"cache table\";s:5:\"cache\";s:7:\"classes\";a:0:{}s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:20:\"ctools_content_types\";s:11:\"load themes\";b:0;}s:8:\"contexts\";a:14:{s:13:\"child plugins\";b:1;s:6:\"module\";s:6:\"ctools\";s:4:\"type\";s:8:\"contexts\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:7:\"classes\";a:0:{}s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:7:\"process\";s:0:\"\";s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:15:\"ctools_contexts\";s:11:\"load themes\";b:0;}s:9:\"arguments\";a:14:{s:13:\"child plugins\";b:1;s:6:\"module\";s:6:\"ctools\";s:4:\"type\";s:9:\"arguments\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:7:\"classes\";a:0:{}s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:7:\"process\";s:0:\"\";s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:16:\"ctools_arguments\";s:11:\"load themes\";b:0;}s:13:\"relationships\";a:14:{s:13:\"child plugins\";b:1;s:6:\"module\";s:6:\"ctools\";s:4:\"type\";s:13:\"relationships\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:7:\"classes\";a:0:{}s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:7:\"process\";s:0:\"\";s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:20:\"ctools_relationships\";s:11:\"load themes\";b:0;}s:6:\"access\";a:14:{s:13:\"child plugins\";b:1;s:6:\"module\";s:6:\"ctools\";s:4:\"type\";s:6:\"access\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:7:\"classes\";a:0:{}s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:7:\"process\";s:0:\"\";s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:13:\"ctools_access\";s:11:\"load themes\";b:0;}s:9:\"export_ui\";a:13:{s:7:\"process\";a:3:{s:8:\"function\";s:24:\"ctools_export_ui_process\";s:4:\"file\";s:13:\"export-ui.inc\";s:4:\"path\";s:41:\"sites/all/modules/contrib/ctools/includes\";}s:7:\"classes\";a:1:{i:0;s:7:\"handler\";}s:6:\"module\";s:6:\"ctools\";s:4:\"type\";s:9:\"export_ui\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:16:\"ctools_export_ui\";s:11:\"load themes\";b:0;}}s:15:\"entityreference\";a:2:{s:9:\"selection\";a:13:{s:7:\"classes\";a:1:{i:0;s:5:\"class\";}s:6:\"module\";s:15:\"entityreference\";s:4:\"type\";s:9:\"selection\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:7:\"process\";s:0:\"\";s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:25:\"entityreference_selection\";s:11:\"load themes\";b:0;}s:8:\"behavior\";a:13:{s:7:\"classes\";a:1:{i:0;s:5:\"class\";}s:7:\"process\";s:39:\"entityreference_behavior_plugin_process\";s:6:\"module\";s:15:\"entityreference\";s:4:\"type\";s:8:\"behavior\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:24:\"entityreference_behavior\";s:11:\"load themes\";b:0;}}s:6:\"panels\";a:4:{s:7:\"layouts\";a:14:{s:11:\"load themes\";b:1;s:7:\"process\";s:21:\"panels_layout_process\";s:13:\"child plugins\";b:1;s:6:\"module\";s:6:\"panels\";s:4:\"type\";s:7:\"layouts\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:7:\"classes\";a:0:{}s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:14:\"panels_layouts\";}s:6:\"styles\";a:14:{s:11:\"load themes\";b:1;s:7:\"process\";s:28:\"panels_plugin_styles_process\";s:13:\"child plugins\";b:1;s:6:\"module\";s:6:\"panels\";s:4:\"type\";s:6:\"styles\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:7:\"classes\";a:0:{}s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:13:\"panels_styles\";}s:5:\"cache\";a:13:{s:6:\"module\";s:6:\"panels\";s:4:\"type\";s:5:\"cache\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:7:\"classes\";a:0:{}s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:7:\"process\";s:0:\"\";s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:12:\"panels_cache\";s:11:\"load themes\";b:0;}s:17:\"display_renderers\";a:13:{s:7:\"classes\";a:1:{i:0;s:8:\"renderer\";}s:6:\"module\";s:6:\"panels\";s:4:\"type\";s:17:\"display_renderers\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:7:\"process\";s:0:\"\";s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:24:\"panels_display_renderers\";s:11:\"load themes\";b:0;}}s:8:\"views_ui\";a:1:{s:12:\"views_wizard\";a:14:{s:13:\"child plugins\";b:1;s:7:\"classes\";a:1:{i:0;s:17:\"form_wizard_class\";}s:8:\"defaults\";a:6:{s:12:\"get children\";N;s:9:\"get child\";N;s:5:\"title\";s:0:\"\";s:10:\"base_table\";N;s:12:\"get_instance\";s:33:\"views_ui_get_form_wizard_instance\";s:17:\"form_wizard_class\";a:2:{s:4:\"file\";s:26:\"views_ui_base_views_wizard\";s:5:\"class\";s:22:\"ViewsUiBaseViewsWizard\";}}s:6:\"module\";s:8:\"views_ui\";s:4:\"type\";s:12:\"views_wizard\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:9:\"use hooks\";b:0;s:7:\"process\";s:0:\"\";s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:21:\"views_ui_views_wizard\";s:11:\"load themes\";b:0;}}s:12:\"page_manager\";a:3:{s:5:\"tasks\";a:13:{s:6:\"module\";s:12:\"page_manager\";s:4:\"type\";s:5:\"tasks\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:7:\"classes\";a:0:{}s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:7:\"process\";s:0:\"\";s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:18:\"page_manager_tasks\";s:11:\"load themes\";b:0;}s:13:\"task_handlers\";a:13:{s:6:\"module\";s:12:\"page_manager\";s:4:\"type\";s:13:\"task_handlers\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:7:\"classes\";a:0:{}s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:7:\"process\";s:0:\"\";s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:26:\"page_manager_task_handlers\";s:11:\"load themes\";b:0;}s:12:\"page_wizards\";a:13:{s:6:\"module\";s:12:\"page_manager\";s:4:\"type\";s:12:\"page_wizards\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:7:\"classes\";a:0:{}s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:7:\"process\";s:0:\"\";s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:25:\"page_manager_page_wizards\";s:11:\"load themes\";b:0;}}}',0,1371656313,1),('ctools_plugin_files:ctools:content_types','a:5:{s:6:\"ctools\";a:55:{s:4:\"node\";O:8:\"stdClass\":3:{s:3:\"uri\";s:68:\"sites/all/modules/contrib/ctools/plugins/content_types/node/node.inc\";s:8:\"filename\";s:8:\"node.inc\";s:4:\"name\";s:4:\"node\";}s:4:\"form\";O:8:\"stdClass\":3:{s:3:\"uri\";s:68:\"sites/all/modules/contrib/ctools/plugins/content_types/form/form.inc\";s:8:\"filename\";s:8:\"form.inc\";s:4:\"name\";s:4:\"form\";}s:17:\"entity_form_field\";O:8:\"stdClass\":3:{s:3:\"uri\";s:81:\"sites/all/modules/contrib/ctools/plugins/content_types/form/entity_form_field.inc\";s:8:\"filename\";s:21:\"entity_form_field.inc\";s:4:\"name\";s:17:\"entity_form_field\";}s:18:\"page_primary_links\";O:8:\"stdClass\":3:{s:3:\"uri\";s:82:\"sites/all/modules/contrib/ctools/plugins/content_types/page/page_primary_links.inc\";s:8:\"filename\";s:22:\"page_primary_links.inc\";s:4:\"name\";s:18:\"page_primary_links\";}s:10:\"page_title\";O:8:\"stdClass\":3:{s:3:\"uri\";s:74:\"sites/all/modules/contrib/ctools/plugins/content_types/page/page_title.inc\";s:8:\"filename\";s:14:\"page_title.inc\";s:4:\"name\";s:10:\"page_title\";}s:12:\"page_actions\";O:8:\"stdClass\":3:{s:3:\"uri\";s:76:\"sites/all/modules/contrib/ctools/plugins/content_types/page/page_actions.inc\";s:8:\"filename\";s:16:\"page_actions.inc\";s:4:\"name\";s:12:\"page_actions\";}s:9:\"page_logo\";O:8:\"stdClass\":3:{s:3:\"uri\";s:73:\"sites/all/modules/contrib/ctools/plugins/content_types/page/page_logo.inc\";s:8:\"filename\";s:13:\"page_logo.inc\";s:4:\"name\";s:9:\"page_logo\";}s:15:\"page_feed_icons\";O:8:\"stdClass\":3:{s:3:\"uri\";s:79:\"sites/all/modules/contrib/ctools/plugins/content_types/page/page_feed_icons.inc\";s:8:\"filename\";s:19:\"page_feed_icons.inc\";s:4:\"name\";s:15:\"page_feed_icons\";}s:14:\"page_site_name\";O:8:\"stdClass\":3:{s:3:\"uri\";s:78:\"sites/all/modules/contrib/ctools/plugins/content_types/page/page_site_name.inc\";s:8:\"filename\";s:18:\"page_site_name.inc\";s:4:\"name\";s:14:\"page_site_name\";}s:9:\"page_help\";O:8:\"stdClass\":3:{s:3:\"uri\";s:73:\"sites/all/modules/contrib/ctools/plugins/content_types/page/page_help.inc\";s:8:\"filename\";s:13:\"page_help.inc\";s:4:\"name\";s:9:\"page_help\";}s:20:\"page_secondary_links\";O:8:\"stdClass\":3:{s:3:\"uri\";s:84:\"sites/all/modules/contrib/ctools/plugins/content_types/page/page_secondary_links.inc\";s:8:\"filename\";s:24:\"page_secondary_links.inc\";s:4:\"name\";s:20:\"page_secondary_links\";}s:11:\"page_slogan\";O:8:\"stdClass\":3:{s:3:\"uri\";s:75:\"sites/all/modules/contrib/ctools/plugins/content_types/page/page_slogan.inc\";s:8:\"filename\";s:15:\"page_slogan.inc\";s:4:\"name\";s:11:\"page_slogan\";}s:15:\"page_breadcrumb\";O:8:\"stdClass\":3:{s:3:\"uri\";s:79:\"sites/all/modules/contrib/ctools/plugins/content_types/page/page_breadcrumb.inc\";s:8:\"filename\";s:19:\"page_breadcrumb.inc\";s:4:\"name\";s:15:\"page_breadcrumb\";}s:9:\"page_tabs\";O:8:\"stdClass\":3:{s:3:\"uri\";s:73:\"sites/all/modules/contrib/ctools/plugins/content_types/page/page_tabs.inc\";s:8:\"filename\";s:13:\"page_tabs.inc\";s:4:\"name\";s:9:\"page_tabs\";}s:13:\"page_messages\";O:8:\"stdClass\":3:{s:3:\"uri\";s:77:\"sites/all/modules/contrib/ctools/plugins/content_types/page/page_messages.inc\";s:8:\"filename\";s:17:\"page_messages.inc\";s:4:\"name\";s:13:\"page_messages\";}s:6:\"custom\";O:8:\"stdClass\":3:{s:3:\"uri\";s:72:\"sites/all/modules/contrib/ctools/plugins/content_types/custom/custom.inc\";s:8:\"filename\";s:10:\"custom.inc\";s:4:\"name\";s:6:\"custom\";}s:16:\"term_description\";O:8:\"stdClass\":3:{s:3:\"uri\";s:88:\"sites/all/modules/contrib/ctools/plugins/content_types/term_context/term_description.inc\";s:8:\"filename\";s:20:\"term_description.inc\";s:4:\"name\";s:16:\"term_description\";}s:9:\"term_list\";O:8:\"stdClass\":3:{s:3:\"uri\";s:81:\"sites/all/modules/contrib/ctools/plugins/content_types/term_context/term_list.inc\";s:8:\"filename\";s:13:\"term_list.inc\";s:4:\"name\";s:9:\"term_list\";}s:5:\"token\";O:8:\"stdClass\":3:{s:3:\"uri\";s:70:\"sites/all/modules/contrib/ctools/plugins/content_types/token/token.inc\";s:8:\"filename\";s:9:\"token.inc\";s:4:\"name\";s:5:\"token\";}s:5:\"block\";O:8:\"stdClass\":3:{s:3:\"uri\";s:70:\"sites/all/modules/contrib/ctools/plugins/content_types/block/block.inc\";s:8:\"filename\";s:9:\"block.inc\";s:4:\"name\";s:5:\"block\";}s:12:\"user_contact\";O:8:\"stdClass\":3:{s:3:\"uri\";s:79:\"sites/all/modules/contrib/ctools/plugins/content_types/contact/user_contact.inc\";s:8:\"filename\";s:16:\"user_contact.inc\";s:4:\"name\";s:12:\"user_contact\";}s:7:\"contact\";O:8:\"stdClass\":3:{s:3:\"uri\";s:74:\"sites/all/modules/contrib/ctools/plugins/content_types/contact/contact.inc\";s:8:\"filename\";s:11:\"contact.inc\";s:4:\"name\";s:7:\"contact\";}s:13:\"node_form_log\";O:8:\"stdClass\":3:{s:3:\"uri\";s:82:\"sites/all/modules/contrib/ctools/plugins/content_types/node_form/node_form_log.inc\";s:8:\"filename\";s:17:\"node_form_log.inc\";s:4:\"name\";s:13:\"node_form_log\";}s:14:\"node_form_path\";O:8:\"stdClass\":3:{s:3:\"uri\";s:83:\"sites/all/modules/contrib/ctools/plugins/content_types/node_form/node_form_path.inc\";s:8:\"filename\";s:18:\"node_form_path.inc\";s:4:\"name\";s:14:\"node_form_path\";}s:14:\"node_form_book\";O:8:\"stdClass\":3:{s:3:\"uri\";s:83:\"sites/all/modules/contrib/ctools/plugins/content_types/node_form/node_form_book.inc\";s:8:\"filename\";s:18:\"node_form_book.inc\";s:4:\"name\";s:14:\"node_form_book\";}s:17:\"node_form_comment\";O:8:\"stdClass\":3:{s:3:\"uri\";s:86:\"sites/all/modules/contrib/ctools/plugins/content_types/node_form/node_form_comment.inc\";s:8:\"filename\";s:21:\"node_form_comment.inc\";s:4:\"name\";s:17:\"node_form_comment\";}s:15:\"node_form_title\";O:8:\"stdClass\":3:{s:3:\"uri\";s:84:\"sites/all/modules/contrib/ctools/plugins/content_types/node_form/node_form_title.inc\";s:8:\"filename\";s:19:\"node_form_title.inc\";s:4:\"name\";s:15:\"node_form_title\";}s:14:\"node_form_menu\";O:8:\"stdClass\":3:{s:3:\"uri\";s:83:\"sites/all/modules/contrib/ctools/plugins/content_types/node_form/node_form_menu.inc\";s:8:\"filename\";s:18:\"node_form_menu.inc\";s:4:\"name\";s:14:\"node_form_menu\";}s:16:\"node_form_author\";O:8:\"stdClass\":3:{s:3:\"uri\";s:85:\"sites/all/modules/contrib/ctools/plugins/content_types/node_form/node_form_author.inc\";s:8:\"filename\";s:20:\"node_form_author.inc\";s:4:\"name\";s:16:\"node_form_author\";}s:21:\"node_form_attachments\";O:8:\"stdClass\":3:{s:3:\"uri\";s:90:\"sites/all/modules/contrib/ctools/plugins/content_types/node_form/node_form_attachments.inc\";s:8:\"filename\";s:25:\"node_form_attachments.inc\";s:4:\"name\";s:21:\"node_form_attachments\";}s:17:\"node_form_buttons\";O:8:\"stdClass\":3:{s:3:\"uri\";s:86:\"sites/all/modules/contrib/ctools/plugins/content_types/node_form/node_form_buttons.inc\";s:8:\"filename\";s:21:\"node_form_buttons.inc\";s:4:\"name\";s:17:\"node_form_buttons\";}s:20:\"node_form_publishing\";O:8:\"stdClass\":3:{s:3:\"uri\";s:89:\"sites/all/modules/contrib/ctools/plugins/content_types/node_form/node_form_publishing.inc\";s:8:\"filename\";s:24:\"node_form_publishing.inc\";s:4:\"name\";s:20:\"node_form_publishing\";}s:10:\"node_title\";O:8:\"stdClass\":3:{s:3:\"uri\";s:82:\"sites/all/modules/contrib/ctools/plugins/content_types/node_context/node_title.inc\";s:8:\"filename\";s:14:\"node_title.inc\";s:4:\"name\";s:10:\"node_title\";}s:9:\"node_body\";O:8:\"stdClass\":3:{s:3:\"uri\";s:81:\"sites/all/modules/contrib/ctools/plugins/content_types/node_context/node_body.inc\";s:8:\"filename\";s:13:\"node_body.inc\";s:4:\"name\";s:9:\"node_body\";}s:13:\"node_book_nav\";O:8:\"stdClass\":3:{s:3:\"uri\";s:85:\"sites/all/modules/contrib/ctools/plugins/content_types/node_context/node_book_nav.inc\";s:8:\"filename\";s:17:\"node_book_nav.inc\";s:4:\"name\";s:13:\"node_book_nav\";}s:12:\"node_updated\";O:8:\"stdClass\":3:{s:3:\"uri\";s:84:\"sites/all/modules/contrib/ctools/plugins/content_types/node_context/node_updated.inc\";s:8:\"filename\";s:16:\"node_updated.inc\";s:4:\"name\";s:12:\"node_updated\";}s:14:\"node_type_desc\";O:8:\"stdClass\":3:{s:3:\"uri\";s:86:\"sites/all/modules/contrib/ctools/plugins/content_types/node_context/node_type_desc.inc\";s:8:\"filename\";s:18:\"node_type_desc.inc\";s:4:\"name\";s:14:\"node_type_desc\";}s:18:\"node_book_children\";O:8:\"stdClass\":3:{s:3:\"uri\";s:90:\"sites/all/modules/contrib/ctools/plugins/content_types/node_context/node_book_children.inc\";s:8:\"filename\";s:22:\"node_book_children.inc\";s:4:\"name\";s:18:\"node_book_children\";}s:13:\"node_comments\";O:8:\"stdClass\":3:{s:3:\"uri\";s:85:\"sites/all/modules/contrib/ctools/plugins/content_types/node_context/node_comments.inc\";s:8:\"filename\";s:17:\"node_comments.inc\";s:4:\"name\";s:13:\"node_comments\";}s:11:\"node_author\";O:8:\"stdClass\":3:{s:3:\"uri\";s:83:\"sites/all/modules/contrib/ctools/plugins/content_types/node_context/node_author.inc\";s:8:\"filename\";s:15:\"node_author.inc\";s:4:\"name\";s:11:\"node_author\";}s:16:\"node_attachments\";O:8:\"stdClass\":3:{s:3:\"uri\";s:88:\"sites/all/modules/contrib/ctools/plugins/content_types/node_context/node_attachments.inc\";s:8:\"filename\";s:20:\"node_attachments.inc\";s:4:\"name\";s:16:\"node_attachments\";}s:10:\"node_terms\";O:8:\"stdClass\":3:{s:3:\"uri\";s:82:\"sites/all/modules/contrib/ctools/plugins/content_types/node_context/node_terms.inc\";s:8:\"filename\";s:14:\"node_terms.inc\";s:4:\"name\";s:10:\"node_terms\";}s:12:\"node_created\";O:8:\"stdClass\":3:{s:3:\"uri\";s:84:\"sites/all/modules/contrib/ctools/plugins/content_types/node_context/node_created.inc\";s:8:\"filename\";s:16:\"node_created.inc\";s:4:\"name\";s:12:\"node_created\";}s:17:\"node_comment_form\";O:8:\"stdClass\":3:{s:3:\"uri\";s:89:\"sites/all/modules/contrib/ctools/plugins/content_types/node_context/node_comment_form.inc\";s:8:\"filename\";s:21:\"node_comment_form.inc\";s:4:\"name\";s:17:\"node_comment_form\";}s:10:\"node_links\";O:8:\"stdClass\":3:{s:3:\"uri\";s:82:\"sites/all/modules/contrib/ctools/plugins/content_types/node_context/node_links.inc\";s:8:\"filename\";s:14:\"node_links.inc\";s:4:\"name\";s:10:\"node_links\";}s:12:\"node_content\";O:8:\"stdClass\":3:{s:3:\"uri\";s:84:\"sites/all/modules/contrib/ctools/plugins/content_types/node_context/node_content.inc\";s:8:\"filename\";s:16:\"node_content.inc\";s:4:\"name\";s:12:\"node_content\";}s:11:\"search_form\";O:8:\"stdClass\":3:{s:3:\"uri\";s:77:\"sites/all/modules/contrib/ctools/plugins/content_types/search/search_form.inc\";s:8:\"filename\";s:15:\"search_form.inc\";s:4:\"name\";s:11:\"search_form\";}s:13:\"search_result\";O:8:\"stdClass\":3:{s:3:\"uri\";s:79:\"sites/all/modules/contrib/ctools/plugins/content_types/search/search_result.inc\";s:8:\"filename\";s:17:\"search_result.inc\";s:4:\"name\";s:13:\"search_result\";}s:16:\"vocabulary_terms\";O:8:\"stdClass\":3:{s:3:\"uri\";s:94:\"sites/all/modules/contrib/ctools/plugins/content_types/vocabulary_context/vocabulary_terms.inc\";s:8:\"filename\";s:20:\"vocabulary_terms.inc\";s:4:\"name\";s:16:\"vocabulary_terms\";}s:18:\"entity_field_extra\";O:8:\"stdClass\":3:{s:3:\"uri\";s:92:\"sites/all/modules/contrib/ctools/plugins/content_types/entity_context/entity_field_extra.inc\";s:8:\"filename\";s:22:\"entity_field_extra.inc\";s:4:\"name\";s:18:\"entity_field_extra\";}s:12:\"entity_field\";O:8:\"stdClass\":3:{s:3:\"uri\";s:86:\"sites/all/modules/contrib/ctools/plugins/content_types/entity_context/entity_field.inc\";s:8:\"filename\";s:16:\"entity_field.inc\";s:4:\"name\";s:12:\"entity_field\";}s:14:\"profile_fields\";O:8:\"stdClass\":3:{s:3:\"uri\";s:86:\"sites/all/modules/contrib/ctools/plugins/content_types/user_context/profile_fields.inc\";s:8:\"filename\";s:18:\"profile_fields.inc\";s:4:\"name\";s:14:\"profile_fields\";}s:12:\"user_profile\";O:8:\"stdClass\":3:{s:3:\"uri\";s:84:\"sites/all/modules/contrib/ctools/plugins/content_types/user_context/user_profile.inc\";s:8:\"filename\";s:16:\"user_profile.inc\";s:4:\"name\";s:12:\"user_profile\";}s:12:\"user_picture\";O:8:\"stdClass\":3:{s:3:\"uri\";s:84:\"sites/all/modules/contrib/ctools/plugins/content_types/user_context/user_picture.inc\";s:8:\"filename\";s:16:\"user_picture.inc\";s:4:\"name\";s:12:\"user_picture\";}s:14:\"user_signature\";O:8:\"stdClass\":3:{s:3:\"uri\";s:86:\"sites/all/modules/contrib/ctools/plugins/content_types/user_context/user_signature.inc\";s:8:\"filename\";s:18:\"user_signature.inc\";s:4:\"name\";s:14:\"user_signature\";}}s:6:\"entity\";a:1:{s:11:\"entity_view\";O:8:\"stdClass\":3:{s:3:\"uri\";s:69:\"sites/all/modules/contrib/entity/ctools/content_types/entity_view.inc\";s:8:\"filename\";s:15:\"entity_view.inc\";s:4:\"name\";s:11:\"entity_view\";}}s:6:\"panels\";a:0:{}s:11:\"panels_mini\";a:1:{s:11:\"panels_mini\";O:8:\"stdClass\":3:{s:3:\"uri\";s:82:\"sites/all/modules/contrib/panels/panels_mini/plugins/content_types/panels_mini.inc\";s:8:\"filename\";s:15:\"panels_mini.inc\";s:4:\"name\";s:11:\"panels_mini\";}}s:13:\"views_content\";a:11:{s:17:\"views_attachments\";O:8:\"stdClass\":3:{s:3:\"uri\";s:90:\"sites/all/modules/contrib/ctools/views_content/plugins/content_types/views_attachments.inc\";s:8:\"filename\";s:21:\"views_attachments.inc\";s:4:\"name\";s:17:\"views_attachments\";}s:5:\"views\";O:8:\"stdClass\":3:{s:3:\"uri\";s:78:\"sites/all/modules/contrib/ctools/views_content/plugins/content_types/views.inc\";s:8:\"filename\";s:9:\"views.inc\";s:4:\"name\";s:5:\"views\";}s:11:\"views_panes\";O:8:\"stdClass\":3:{s:3:\"uri\";s:84:\"sites/all/modules/contrib/ctools/views_content/plugins/content_types/views_panes.inc\";s:8:\"filename\";s:15:\"views_panes.inc\";s:4:\"name\";s:11:\"views_panes\";}s:9:\"views_row\";O:8:\"stdClass\":3:{s:3:\"uri\";s:82:\"sites/all/modules/contrib/ctools/views_content/plugins/content_types/views_row.inc\";s:8:\"filename\";s:13:\"views_row.inc\";s:4:\"name\";s:9:\"views_row\";}s:11:\"views_empty\";O:8:\"stdClass\":3:{s:3:\"uri\";s:84:\"sites/all/modules/contrib/ctools/views_content/plugins/content_types/views_empty.inc\";s:8:\"filename\";s:15:\"views_empty.inc\";s:4:\"name\";s:11:\"views_empty\";}s:11:\"views_pager\";O:8:\"stdClass\":3:{s:3:\"uri\";s:84:\"sites/all/modules/contrib/ctools/views_content/plugins/content_types/views_pager.inc\";s:8:\"filename\";s:15:\"views_pager.inc\";s:4:\"name\";s:11:\"views_pager\";}s:12:\"views_footer\";O:8:\"stdClass\":3:{s:3:\"uri\";s:85:\"sites/all/modules/contrib/ctools/views_content/plugins/content_types/views_footer.inc\";s:8:\"filename\";s:16:\"views_footer.inc\";s:4:\"name\";s:12:\"views_footer\";}s:12:\"views_header\";O:8:\"stdClass\":3:{s:3:\"uri\";s:85:\"sites/all/modules/contrib/ctools/views_content/plugins/content_types/views_header.inc\";s:8:\"filename\";s:16:\"views_header.inc\";s:4:\"name\";s:12:\"views_header\";}s:10:\"views_view\";O:8:\"stdClass\":3:{s:3:\"uri\";s:83:\"sites/all/modules/contrib/ctools/views_content/plugins/content_types/views_view.inc\";s:8:\"filename\";s:14:\"views_view.inc\";s:4:\"name\";s:10:\"views_view\";}s:13:\"views_exposed\";O:8:\"stdClass\":3:{s:3:\"uri\";s:86:\"sites/all/modules/contrib/ctools/views_content/plugins/content_types/views_exposed.inc\";s:8:\"filename\";s:17:\"views_exposed.inc\";s:4:\"name\";s:13:\"views_exposed\";}s:10:\"views_feed\";O:8:\"stdClass\":3:{s:3:\"uri\";s:83:\"sites/all/modules/contrib/ctools/views_content/plugins/content_types/views_feed.inc\";s:8:\"filename\";s:14:\"views_feed.inc\";s:4:\"name\";s:10:\"views_feed\";}}}',0,1371656313,1),('filter_formats:en','a:4:{s:13:\"filtered_html\";O:8:\"stdClass\":5:{s:6:\"format\";s:13:\"filtered_html\";s:4:\"name\";s:13:\"Filtered HTML\";s:5:\"cache\";s:1:\"1\";s:6:\"status\";s:1:\"1\";s:6:\"weight\";s:1:\"0\";}s:9:\"full_html\";O:8:\"stdClass\":5:{s:6:\"format\";s:9:\"full_html\";s:4:\"name\";s:9:\"Full HTML\";s:5:\"cache\";s:1:\"1\";s:6:\"status\";s:1:\"1\";s:6:\"weight\";s:1:\"1\";}s:10:\"plain_text\";O:8:\"stdClass\":5:{s:6:\"format\";s:10:\"plain_text\";s:4:\"name\";s:10:\"Plain text\";s:5:\"cache\";s:1:\"1\";s:6:\"status\";s:1:\"1\";s:6:\"weight\";s:2:\"10\";}s:8:\"php_code\";O:8:\"stdClass\":5:{s:6:\"format\";s:8:\"php_code\";s:4:\"name\";s:8:\"PHP code\";s:5:\"cache\";s:1:\"0\";s:6:\"status\";s:1:\"1\";s:6:\"weight\";s:2:\"11\";}}',0,1371656313,1),('ctools_plugin_files:panels:layouts','a:1:{s:6:\"panels\";a:9:{s:17:\"threecol_33_34_33\";O:8:\"stdClass\":3:{s:3:\"uri\";s:88:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_33_34_33/threecol_33_34_33.inc\";s:8:\"filename\";s:21:\"threecol_33_34_33.inc\";s:4:\"name\";s:17:\"threecol_33_34_33\";}s:6:\"onecol\";O:8:\"stdClass\":3:{s:3:\"uri\";s:66:\"sites/all/modules/contrib/panels/plugins/layouts/onecol/onecol.inc\";s:8:\"filename\";s:10:\"onecol.inc\";s:4:\"name\";s:6:\"onecol\";}s:17:\"threecol_25_50_25\";O:8:\"stdClass\":3:{s:3:\"uri\";s:88:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_25_50_25/threecol_25_50_25.inc\";s:8:\"filename\";s:21:\"threecol_25_50_25.inc\";s:4:\"name\";s:17:\"threecol_25_50_25\";}s:25:\"threecol_25_50_25_stacked\";O:8:\"stdClass\":3:{s:3:\"uri\";s:104:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_25_50_25_stacked/threecol_25_50_25_stacked.inc\";s:8:\"filename\";s:29:\"threecol_25_50_25_stacked.inc\";s:4:\"name\";s:25:\"threecol_25_50_25_stacked\";}s:13:\"twocol_bricks\";O:8:\"stdClass\":3:{s:3:\"uri\";s:80:\"sites/all/modules/contrib/panels/plugins/layouts/twocol_bricks/twocol_bricks.inc\";s:8:\"filename\";s:17:\"twocol_bricks.inc\";s:4:\"name\";s:13:\"twocol_bricks\";}s:25:\"threecol_33_34_33_stacked\";O:8:\"stdClass\":3:{s:3:\"uri\";s:104:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_33_34_33_stacked/threecol_33_34_33_stacked.inc\";s:8:\"filename\";s:29:\"threecol_33_34_33_stacked.inc\";s:4:\"name\";s:25:\"threecol_33_34_33_stacked\";}s:14:\"twocol_stacked\";O:8:\"stdClass\":3:{s:3:\"uri\";s:82:\"sites/all/modules/contrib/panels/plugins/layouts/twocol_stacked/twocol_stacked.inc\";s:8:\"filename\";s:18:\"twocol_stacked.inc\";s:4:\"name\";s:14:\"twocol_stacked\";}s:8:\"flexible\";O:8:\"stdClass\":3:{s:3:\"uri\";s:70:\"sites/all/modules/contrib/panels/plugins/layouts/flexible/flexible.inc\";s:8:\"filename\";s:12:\"flexible.inc\";s:4:\"name\";s:8:\"flexible\";}s:6:\"twocol\";O:8:\"stdClass\":3:{s:3:\"uri\";s:66:\"sites/all/modules/contrib/panels/plugins/layouts/twocol/twocol.inc\";s:8:\"filename\";s:10:\"twocol.inc\";s:4:\"name\";s:6:\"twocol\";}}}',0,1371656313,1),('ctools_plugin_files:panels:styles','a:1:{s:6:\"panels\";a:6:{s:15:\"rounded_corners\";O:8:\"stdClass\":3:{s:3:\"uri\";s:75:\"sites/all/modules/contrib/panels/plugins/styles/corners/rounded_corners.inc\";s:8:\"filename\";s:19:\"rounded_corners.inc\";s:4:\"name\";s:15:\"rounded_corners\";}s:5:\"block\";O:8:\"stdClass\":3:{s:3:\"uri\";s:57:\"sites/all/modules/contrib/panels/plugins/styles/block.inc\";s:8:\"filename\";s:9:\"block.inc\";s:4:\"name\";s:5:\"block\";}s:8:\"stylizer\";O:8:\"stdClass\":3:{s:3:\"uri\";s:60:\"sites/all/modules/contrib/panels/plugins/styles/stylizer.inc\";s:8:\"filename\";s:12:\"stylizer.inc\";s:4:\"name\";s:8:\"stylizer\";}s:7:\"default\";O:8:\"stdClass\":3:{s:3:\"uri\";s:59:\"sites/all/modules/contrib/panels/plugins/styles/default.inc\";s:8:\"filename\";s:11:\"default.inc\";s:4:\"name\";s:7:\"default\";}s:5:\"naked\";O:8:\"stdClass\":3:{s:3:\"uri\";s:57:\"sites/all/modules/contrib/panels/plugins/styles/naked.inc\";s:8:\"filename\";s:9:\"naked.inc\";s:4:\"name\";s:5:\"naked\";}s:4:\"list\";O:8:\"stdClass\":3:{s:3:\"uri\";s:56:\"sites/all/modules/contrib/panels/plugins/styles/list.inc\";s:8:\"filename\";s:8:\"list.inc\";s:4:\"name\";s:4:\"list\";}}}',0,1371656313,1),('ctools_plugin_files:page_manager:tasks','a:2:{s:6:\"panels\";a:0:{}s:12:\"page_manager\";a:13:{s:9:\"user_view\";O:8:\"stdClass\":3:{s:3:\"uri\";s:73:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks/user_view.inc\";s:8:\"filename\";s:13:\"user_view.inc\";s:4:\"name\";s:9:\"user_view\";}s:4:\"page\";O:8:\"stdClass\":3:{s:3:\"uri\";s:68:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.inc\";s:8:\"filename\";s:8:\"page.inc\";s:4:\"name\";s:4:\"page\";}s:9:\"user_edit\";O:8:\"stdClass\":3:{s:3:\"uri\";s:73:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks/user_edit.inc\";s:8:\"filename\";s:13:\"user_edit.inc\";s:4:\"name\";s:9:\"user_edit\";}s:9:\"node_edit\";O:8:\"stdClass\":3:{s:3:\"uri\";s:73:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks/node_edit.inc\";s:8:\"filename\";s:13:\"node_edit.inc\";s:4:\"name\";s:9:\"node_edit\";}s:4:\"poll\";O:8:\"stdClass\":3:{s:3:\"uri\";s:68:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks/poll.inc\";s:8:\"filename\";s:8:\"poll.inc\";s:4:\"name\";s:4:\"poll\";}s:12:\"contact_user\";O:8:\"stdClass\":3:{s:3:\"uri\";s:76:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks/contact_user.inc\";s:8:\"filename\";s:16:\"contact_user.inc\";s:4:\"name\";s:12:\"contact_user\";}s:9:\"term_view\";O:8:\"stdClass\":3:{s:3:\"uri\";s:73:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks/term_view.inc\";s:8:\"filename\";s:13:\"term_view.inc\";s:4:\"name\";s:9:\"term_view\";}s:9:\"node_view\";O:8:\"stdClass\":3:{s:3:\"uri\";s:73:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks/node_view.inc\";s:8:\"filename\";s:13:\"node_view.inc\";s:4:\"name\";s:9:\"node_view\";}s:10:\"page.admin\";O:8:\"stdClass\":3:{s:3:\"uri\";s:74:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.admin.inc\";s:8:\"filename\";s:14:\"page.admin.inc\";s:4:\"name\";s:10:\"page.admin\";}s:6:\"search\";O:8:\"stdClass\":3:{s:3:\"uri\";s:70:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks/search.inc\";s:8:\"filename\";s:10:\"search.inc\";s:4:\"name\";s:6:\"search\";}s:9:\"blog_user\";O:8:\"stdClass\":3:{s:3:\"uri\";s:73:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks/blog_user.inc\";s:8:\"filename\";s:13:\"blog_user.inc\";s:4:\"name\";s:9:\"blog_user\";}s:12:\"contact_site\";O:8:\"stdClass\":3:{s:3:\"uri\";s:76:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks/contact_site.inc\";s:8:\"filename\";s:16:\"contact_site.inc\";s:4:\"name\";s:12:\"contact_site\";}s:4:\"blog\";O:8:\"stdClass\":3:{s:3:\"uri\";s:68:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks/blog.inc\";s:8:\"filename\";s:8:\"blog.inc\";s:4:\"name\";s:4:\"blog\";}}}',0,1371656313,1),('theme_registry:build:modules','a:308:{s:16:\"admin_menu_links\";a:6:{s:14:\"render element\";s:8:\"elements\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:36:\"sites/all/modules/contrib/admin_menu\";s:8:\"function\";s:22:\"theme_admin_menu_links\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:15:\"admin_menu_icon\";a:8:{s:9:\"variables\";a:2:{s:3:\"src\";N;s:3:\"alt\";N;}s:4:\"file\";s:14:\"admin_menu.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:36:\"sites/all/modules/contrib/admin_menu\";s:8:\"function\";s:21:\"theme_admin_menu_icon\";s:8:\"includes\";a:1:{i:0;s:51:\"sites/all/modules/contrib/admin_menu/admin_menu.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:35:\"template_preprocess_admin_menu_icon\";}s:17:\"process functions\";a:0:{}}s:30:\"page_manager_handler_rearrange\";a:9:{s:14:\"render element\";s:4:\"form\";s:4:\"path\";s:51:\"sites/all/modules/contrib/ctools/page_manager/theme\";s:4:\"file\";s:22:\"page_manager.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:45:\"sites/all/modules/contrib/ctools/page_manager\";s:8:\"function\";s:36:\"theme_page_manager_handler_rearrange\";s:8:\"includes\";a:1:{i:0;s:74:\"sites/all/modules/contrib/ctools/page_manager/theme/page_manager.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:22:\"page_manager_edit_page\";a:9:{s:8:\"template\";s:22:\"page-manager-edit-page\";s:9:\"variables\";a:4:{s:4:\"page\";N;s:4:\"save\";N;s:10:\"operations\";a:0:{}s:7:\"content\";a:0:{}}s:4:\"path\";s:51:\"sites/all/modules/contrib/ctools/page_manager/theme\";s:4:\"file\";s:22:\"page_manager.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:45:\"sites/all/modules/contrib/ctools/page_manager\";s:8:\"includes\";a:1:{i:0;s:74:\"sites/all/modules/contrib/ctools/page_manager/theme/page_manager.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:42:\"template_preprocess_page_manager_edit_page\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:17:\"page_manager_lock\";a:9:{s:9:\"variables\";a:1:{s:4:\"page\";a:0:{}}s:4:\"path\";s:51:\"sites/all/modules/contrib/ctools/page_manager/theme\";s:4:\"file\";s:22:\"page_manager.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:45:\"sites/all/modules/contrib/ctools/page_manager\";s:8:\"function\";s:23:\"theme_page_manager_lock\";s:8:\"includes\";a:1:{i:0;s:74:\"sites/all/modules/contrib/ctools/page_manager/theme/page_manager.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"page_manager_changed\";a:9:{s:9:\"variables\";a:2:{s:4:\"text\";N;s:11:\"description\";N;}s:4:\"path\";s:51:\"sites/all/modules/contrib/ctools/page_manager/theme\";s:4:\"file\";s:22:\"page_manager.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:45:\"sites/all/modules/contrib/ctools/page_manager\";s:8:\"function\";s:26:\"theme_page_manager_changed\";s:8:\"includes\";a:1:{i:0;s:74:\"sites/all/modules/contrib/ctools/page_manager/theme/page_manager.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:37:\"page_manager_page_form_argument_table\";a:9:{s:4:\"file\";s:14:\"page.admin.inc\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:45:\"sites/all/modules/contrib/ctools/page_manager\";s:8:\"function\";s:43:\"theme_page_manager_page_form_argument_table\";s:8:\"includes\";a:1:{i:0;s:74:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:22:\"page_manager_page_lock\";a:9:{s:4:\"file\";s:14:\"page.admin.inc\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks\";s:9:\"variables\";a:2:{s:4:\"lock\";a:0:{}s:9:\"task_name\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:45:\"sites/all/modules/contrib/ctools/page_manager\";s:8:\"function\";s:28:\"theme_page_manager_page_lock\";s:8:\"includes\";a:1:{i:0;s:74:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:25:\"page_manager_page_changed\";a:9:{s:4:\"file\";s:14:\"page.admin.inc\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks\";s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:45:\"sites/all/modules/contrib/ctools/page_manager\";s:8:\"function\";s:31:\"theme_page_manager_page_changed\";s:8:\"includes\";a:1:{i:0;s:74:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"views_mini_pager\";a:10:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"tags\";a:0:{}s:8:\"quantity\";i:10;s:7:\"element\";i:0;s:10:\"parameters\";a:0:{}}s:7:\"pattern\";s:18:\"views_mini_pager__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:22:\"theme_views_mini_pager\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"views_view_field\";a:10:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:7:\"pattern\";s:18:\"views_view_field__\";s:9:\"variables\";a:3:{s:4:\"view\";N;s:5:\"field\";N;s:3:\"row\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:22:\"theme_views_view_field\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:36:\"template_preprocess_views_view_field\";}s:17:\"process functions\";a:0:{}}s:19:\"views_view_grouping\";a:10:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:7:\"pattern\";s:21:\"views_view_grouping__\";s:9:\"variables\";a:5:{s:4:\"view\";N;s:8:\"grouping\";N;s:14:\"grouping_level\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:25:\"theme_views_view_grouping\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:39:\"template_preprocess_views_view_grouping\";}s:17:\"process functions\";a:0:{}}s:10:\"views_view\";a:10:{s:7:\"pattern\";s:12:\"views_view__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:2:{s:10:\"view_array\";a:0:{}s:4:\"view\";N;}s:8:\"template\";s:10:\"views-view\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:30:\"template_preprocess_views_view\";i:2;s:32:\"date_views_preprocess_views_view\";i:3;s:30:\"views_ui_preprocess_views_view\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:27:\"template_process_views_view\";i:2;s:11:\"rdf_process\";}}s:23:\"eva_display_entity_view\";a:10:{s:7:\"pattern\";s:25:\"eva_display_entity_view__\";s:4:\"file\";s:13:\"eva.views.inc\";s:4:\"path\";s:29:\"sites/all/modules/contrib/eva\";s:9:\"variables\";a:2:{s:10:\"view_array\";a:0:{}s:4:\"view\";N;}s:8:\"template\";s:23:\"eva-display-entity-view\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:43:\"sites/all/modules/contrib/eva/eva.views.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:43:\"template_preprocess_eva_display_entity_view\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:40:\"template_process_eva_display_entity_view\";i:2;s:11:\"rdf_process\";}}s:15:\"date_navigation\";a:10:{s:7:\"pattern\";s:17:\"date_navigation__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:47:\"sites/all/modules/contrib/date/date_views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:15:\"date-navigation\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/date/date_views/theme/theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:22:\"views_view_unformatted\";a:10:{s:7:\"pattern\";s:24:\"views_view_unformatted__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:22:\"views-view-unformatted\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:42:\"template_preprocess_views_view_unformatted\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:17:\"views_data_export\";a:10:{s:7:\"pattern\";s:19:\"views_data_export__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:17:\"views-data-export\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:37:\"template_preprocess_views_data_export\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_csv_header\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_csv_header__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-csv-header\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_views_data_export_csv_header\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:26:\"views_data_export_csv_body\";a:10:{s:7:\"pattern\";s:28:\"views_data_export_csv_body__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:26:\"views-data-export-csv-body\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:46:\"template_preprocess_views_data_export_csv_body\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_csv_footer\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_csv_footer__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-csv-footer\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_doc_header\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_doc_header__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-doc-header\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_views_data_export_doc_header\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:26:\"views_data_export_doc_body\";a:10:{s:7:\"pattern\";s:28:\"views_data_export_doc_body__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:26:\"views-data-export-doc-body\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:46:\"template_preprocess_views_data_export_doc_body\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_doc_footer\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_doc_footer__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-doc-footer\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_txt_header\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_txt_header__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-txt-header\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:26:\"views_data_export_txt_body\";a:10:{s:7:\"pattern\";s:28:\"views_data_export_txt_body__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:26:\"views-data-export-txt-body\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:46:\"template_preprocess_views_data_export_txt_body\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_txt_footer\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_txt_footer__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-txt-footer\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_xls_header\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_xls_header__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-xls-header\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_views_data_export_xls_header\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:26:\"views_data_export_xls_body\";a:10:{s:7:\"pattern\";s:28:\"views_data_export_xls_body__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:26:\"views-data-export-xls-body\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:46:\"template_preprocess_views_data_export_xls_body\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_xls_footer\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_xls_footer__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-xls-footer\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_xml_header\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_xml_header__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-xml-header\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_views_data_export_xml_header\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:26:\"views_data_export_xml_body\";a:10:{s:7:\"pattern\";s:28:\"views_data_export_xml_body__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:26:\"views-data-export-xml-body\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:46:\"template_preprocess_views_data_export_xml_body\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_xml_footer\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_xml_footer__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-xml-footer\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_views_data_export_xml_footer\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:25:\"views_view_watchdog_table\";a:10:{s:7:\"pattern\";s:27:\"views_view_watchdog_table__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:52:\"sites/all/modules/contrib/views_watchdog/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:25:\"views-view-watchdog-table\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:62:\"sites/all/modules/contrib/views_watchdog/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:45:\"template_preprocess_views_view_watchdog_table\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:15:\"views_view_list\";a:10:{s:7:\"pattern\";s:17:\"views_view_list__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:15:\"views-view-list\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:35:\"template_preprocess_views_view_list\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:15:\"views_view_grid\";a:10:{s:7:\"pattern\";s:17:\"views_view_grid__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:15:\"views-view-grid\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:35:\"template_preprocess_views_view_grid\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:16:\"views_view_table\";a:10:{s:7:\"pattern\";s:18:\"views_view_table__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:16:\"views-view-table\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_views_view_table\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:18:\"views_view_summary\";a:10:{s:7:\"pattern\";s:20:\"views_view_summary__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:18:\"views-view-summary\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:38:\"template_preprocess_views_view_summary\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:30:\"views_view_summary_unformatted\";a:10:{s:7:\"pattern\";s:32:\"views_view_summary_unformatted__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:30:\"views-view-summary-unformatted\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:50:\"template_preprocess_views_view_summary_unformatted\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:14:\"views_view_rss\";a:10:{s:7:\"pattern\";s:16:\"views_view_rss__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:14:\"views-view-rss\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:34:\"template_preprocess_views_view_rss\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_view_summary_jump_menu\";a:10:{s:7:\"pattern\";s:30:\"views_view_summary_jump_menu__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-view-summary-jump-menu\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:20:\"views_view_jump_menu\";a:10:{s:7:\"pattern\";s:22:\"views_view_jump_menu__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:20:\"views-view-jump-menu\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:22:\"views_view_row_comment\";a:10:{s:7:\"pattern\";s:24:\"views_view_row_comment__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:3:\"row\";N;s:11:\"field_alias\";N;}s:8:\"template\";s:22:\"views-view-row-comment\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:42:\"template_preprocess_views_view_row_comment\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:18:\"views_view_row_rss\";a:10:{s:7:\"pattern\";s:20:\"views_view_row_rss__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:3:\"row\";N;s:11:\"field_alias\";N;}s:8:\"template\";s:18:\"views-view-row-rss\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:38:\"template_preprocess_views_view_row_rss\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:17:\"views_view_fields\";a:10:{s:7:\"pattern\";s:19:\"views_view_fields__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:3:\"row\";N;s:11:\"field_alias\";N;}s:8:\"template\";s:17:\"views-view-fields\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:37:\"template_preprocess_views_view_fields\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:21:\"views_form_views_form\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:27:\"theme_views_form_views_form\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"views_exposed_form\";a:10:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:8:\"template\";s:18:\"views-exposed-form\";s:7:\"pattern\";s:20:\"views_exposed_form__\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:38:\"template_preprocess_views_exposed_form\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:10:\"views_more\";a:10:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:8:\"template\";s:10:\"views-more\";s:7:\"pattern\";s:12:\"views_more__\";s:9:\"variables\";a:3:{s:8:\"more_url\";N;s:9:\"link_text\";s:4:\"more\";s:4:\"view\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:15:\"horizontal_tabs\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/field_group\";s:8:\"function\";s:21:\"theme_horizontal_tabs\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"multipage\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/field_group\";s:8:\"function\";s:15:\"theme_multipage\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:14:\"multipage_pane\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/field_group\";s:8:\"function\";s:20:\"theme_multipage_pane\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:28:\"views_ui_display_tab_setting\";a:7:{s:9:\"variables\";a:7:{s:11:\"description\";s:0:\"\";s:4:\"link\";s:0:\"\";s:14:\"settings_links\";a:0:{}s:10:\"overridden\";b:0;s:9:\"defaulted\";b:0;s:21:\"description_separator\";b:1;s:5:\"class\";a:0:{}}s:8:\"template\";s:28:\"views-ui-display-tab-setting\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_views_ui_display_tab_setting\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:27:\"views_ui_display_tab_bucket\";a:7:{s:14:\"render element\";s:7:\"element\";s:8:\"template\";s:27:\"views-ui-display-tab-bucket\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:47:\"template_preprocess_views_ui_display_tab_bucket\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:18:\"views_ui_edit_item\";a:7:{s:9:\"variables\";a:4:{s:4:\"type\";N;s:4:\"view\";N;s:7:\"display\";N;s:9:\"no_fields\";b:0;}s:8:\"template\";s:18:\"views-ui-edit-item\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:23:\"views_ui_rearrange_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:29:\"theme_views_ui_rearrange_form\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:30:\"views_ui_rearrange_filter_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:36:\"theme_views_ui_rearrange_filter_form\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/contrib/views/includes/admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:27:\"views_ui_expose_filter_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:33:\"theme_views_ui_expose_filter_form\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/contrib/views/includes/admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"views_ui_view_info\";a:8:{s:9:\"variables\";a:2:{s:4:\"view\";N;s:4:\"base\";N;}s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:24:\"theme_views_ui_view_info\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/contrib/views/includes/admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:32:\"views_ui_build_group_filter_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:38:\"theme_views_ui_build_group_filter_form\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/contrib/views/includes/admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"views_tabset\";a:6:{s:9:\"variables\";a:1:{s:4:\"tabs\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:18:\"theme_views_tabset\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"views_tab\";a:6:{s:9:\"variables\";a:1:{s:4:\"body\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:15:\"theme_views_tab\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:30:\"views_ui_reorder_displays_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:36:\"theme_views_ui_reorder_displays_form\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/contrib/views/includes/admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:27:\"views_ui_style_plugin_table\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:33:\"theme_views_ui_style_plugin_table\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:29:\"views_ui_view_preview_section\";a:6:{s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"section\";N;s:7:\"content\";N;s:5:\"links\";s:0:\"\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:35:\"theme_views_ui_view_preview_section\";s:20:\"preprocess functions\";a:1:{i:0;s:49:\"template_preprocess_views_ui_view_preview_section\";}s:17:\"process functions\";a:0:{}}s:15:\"views_container\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:15:\"theme/theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:21:\"theme_views_container\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:27:\"views_data_export_feed_icon\";a:9:{s:7:\"pattern\";s:29:\"views_data_export_feed_icon__\";s:9:\"variables\";a:4:{s:10:\"image_path\";N;s:3:\"url\";N;s:5:\"query\";s:0:\"\";s:4:\"text\";s:0:\"\";}s:4:\"file\";s:33:\"theme/views_data_export.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/views_data_export\";s:8:\"function\";s:33:\"theme_views_data_export_feed_icon\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:31:\"views_data_export_complete_page\";a:8:{s:9:\"variables\";a:3:{s:4:\"file\";s:0:\"\";s:6:\"errors\";a:0:{}s:10:\"return_url\";s:0:\"\";}s:4:\"file\";s:33:\"theme/views_data_export.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/views_data_export\";s:8:\"function\";s:37:\"theme_views_data_export_complete_page\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:25:\"views_data_export_message\";a:8:{s:9:\"variables\";a:2:{s:7:\"message\";s:0:\"\";s:4:\"type\";s:4:\"info\";}s:4:\"file\";s:33:\"theme/views_data_export.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/views_data_export\";s:8:\"function\";s:31:\"theme_views_data_export_message\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"user_picture\";a:6:{s:9:\"variables\";a:1:{s:7:\"account\";N;}s:8:\"template\";s:25:\"modules/user/user-picture\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:32:\"template_preprocess_user_picture\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:12:\"user_profile\";a:8:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:25:\"modules/user/user-profile\";s:4:\"file\";s:14:\"user.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.pages.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:32:\"template_preprocess_user_profile\";i:2;s:27:\"rdf_preprocess_user_profile\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:21:\"user_profile_category\";a:8:{s:14:\"render element\";s:7:\"element\";s:8:\"template\";s:34:\"modules/user/user-profile-category\";s:4:\"file\";s:14:\"user.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.pages.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:41:\"template_preprocess_user_profile_category\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:17:\"user_profile_item\";a:8:{s:14:\"render element\";s:7:\"element\";s:8:\"template\";s:30:\"modules/user/user-profile-item\";s:4:\"file\";s:14:\"user.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.pages.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:37:\"template_preprocess_user_profile_item\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:9:\"user_list\";a:6:{s:9:\"variables\";a:2:{s:5:\"users\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:15:\"theme_user_list\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:22:\"user_admin_permissions\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:14:\"user.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:28:\"theme_user_admin_permissions\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"user_admin_roles\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:14:\"user.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:22:\"theme_user_admin_roles\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:27:\"user_permission_description\";a:8:{s:9:\"variables\";a:2:{s:15:\"permission_item\";N;s:4:\"hide\";N;}s:4:\"file\";s:14:\"user.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:33:\"theme_user_permission_description\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:14:\"user_signature\";a:6:{s:9:\"variables\";a:1:{s:9:\"signature\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:20:\"theme_user_signature\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:10:\"tree_table\";a:8:{s:9:\"variables\";a:5:{s:6:\"header\";a:0:{}s:4:\"rows\";a:0:{}s:10:\"attributes\";a:0:{}s:5:\"empty\";s:0:\"\";s:7:\"caption\";s:0:\"\";}s:4:\"file\";s:15:\"token.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/token\";s:8:\"function\";s:16:\"theme_tree_table\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/token/token.pages.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:10:\"token_tree\";a:8:{s:9:\"variables\";a:6:{s:11:\"token_types\";a:0:{}s:12:\"global_types\";b:1;s:12:\"click_insert\";b:1;s:15:\"show_restricted\";b:0;s:15:\"recursion_limit\";i:3;s:6:\"dialog\";b:0;}s:4:\"file\";s:15:\"token.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/token\";s:8:\"function\";s:16:\"theme_token_tree\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/token/token.pages.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:15:\"token_tree_link\";a:8:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:7:\"options\";a:0:{}s:6:\"dialog\";b:1;}s:4:\"file\";s:15:\"token.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/token\";s:8:\"function\";s:21:\"theme_token_tree_link\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/token/token.pages.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:30:\"taxonomy_overview_vocabularies\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/taxonomy\";s:8:\"function\";s:36:\"theme_taxonomy_overview_vocabularies\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"taxonomy_overview_terms\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/taxonomy\";s:8:\"function\";s:29:\"theme_taxonomy_overview_terms\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:13:\"taxonomy_term\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:30:\"modules/taxonomy/taxonomy-term\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/taxonomy\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:33:\"template_preprocess_taxonomy_term\";i:2;s:28:\"rdf_preprocess_taxonomy_term\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:4:\"html\";a:6:{s:14:\"render element\";s:4:\"page\";s:8:\"template\";s:19:\"modules/system/html\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:24:\"template_preprocess_html\";i:2;s:22:\"panels_preprocess_html\";i:3;s:21:\"views_preprocess_html\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:21:\"template_process_html\";i:2;s:11:\"rdf_process\";}}s:4:\"page\";a:6:{s:14:\"render element\";s:4:\"page\";s:8:\"template\";s:19:\"modules/system/page\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:24:\"template_preprocess_page\";i:2;s:24:\"shortcut_preprocess_page\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:21:\"template_process_page\";i:2;s:11:\"rdf_process\";}}s:6:\"region\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:21:\"modules/system/region\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:26:\"template_preprocess_region\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:15:\"status_messages\";a:6:{s:9:\"variables\";a:1:{s:7:\"display\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:21:\"theme_status_messages\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:4:\"link\";a:6:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:4:\"path\";N;s:7:\"options\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_link\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:5:\"links\";a:6:{s:9:\"variables\";a:3:{s:5:\"links\";N;s:10:\"attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:5:\"links\";}}s:7:\"heading\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_links\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:5:\"image\";a:6:{s:9:\"variables\";a:6:{s:4:\"path\";N;s:5:\"width\";N;s:6:\"height\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";N;s:10:\"attributes\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_image\";s:20:\"preprocess functions\";a:1:{i:0;s:20:\"rdf_preprocess_image\";}s:17:\"process functions\";a:0:{}}s:10:\"breadcrumb\";a:6:{s:9:\"variables\";a:1:{s:10:\"breadcrumb\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_breadcrumb\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:4:\"help\";a:6:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_help\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:5:\"table\";a:6:{s:9:\"variables\";a:7:{s:6:\"header\";N;s:4:\"rows\";N;s:10:\"attributes\";a:0:{}s:7:\"caption\";N;s:9:\"colgroups\";a:0:{}s:6:\"sticky\";b:1;s:5:\"empty\";s:0:\"\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_table\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"tablesort_indicator\";a:6:{s:9:\"variables\";a:1:{s:5:\"style\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:25:\"theme_tablesort_indicator\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:4:\"mark\";a:6:{s:9:\"variables\";a:1:{s:4:\"type\";i:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_mark\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"item_list\";a:6:{s:9:\"variables\";a:4:{s:5:\"items\";a:0:{}s:5:\"title\";N;s:4:\"type\";s:2:\"ul\";s:10:\"attributes\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_item_list\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:14:\"more_help_link\";a:6:{s:9:\"variables\";a:1:{s:3:\"url\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:20:\"theme_more_help_link\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"feed_icon\";a:6:{s:9:\"variables\";a:2:{s:3:\"url\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_feed_icon\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"more_link\";a:6:{s:9:\"variables\";a:2:{s:3:\"url\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_more_link\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:8:\"username\";a:6:{s:9:\"variables\";a:1:{s:7:\"account\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_username\";s:20:\"preprocess functions\";a:2:{i:0;s:28:\"template_preprocess_username\";i:1;s:23:\"rdf_preprocess_username\";}s:17:\"process functions\";a:1:{i:0;s:25:\"template_process_username\";}}s:12:\"progress_bar\";a:6:{s:9:\"variables\";a:2:{s:7:\"percent\";N;s:7:\"message\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_progress_bar\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:11:\"indentation\";a:6:{s:9:\"variables\";a:1:{s:4:\"size\";i:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_indentation\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:8:\"html_tag\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_html_tag\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"maintenance_page\";a:6:{s:9:\"variables\";a:2:{s:7:\"content\";N;s:13:\"show_messages\";b:1;}s:8:\"template\";s:31:\"modules/system/maintenance-page\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_maintenance_page\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:33:\"template_process_maintenance_page\";i:2;s:11:\"rdf_process\";}}s:11:\"update_page\";a:6:{s:9:\"variables\";a:2:{s:7:\"content\";N;s:13:\"show_messages\";b:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_update_page\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"install_page\";a:6:{s:9:\"variables\";a:1:{s:7:\"content\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_install_page\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"task_list\";a:6:{s:9:\"variables\";a:2:{s:5:\"items\";N;s:6:\"active\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_task_list\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"authorize_message\";a:6:{s:9:\"variables\";a:2:{s:7:\"message\";N;s:7:\"success\";b:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:23:\"theme_authorize_message\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"authorize_report\";a:6:{s:9:\"variables\";a:1:{s:8:\"messages\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:22:\"theme_authorize_report\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:5:\"pager\";a:6:{s:9:\"variables\";a:4:{s:4:\"tags\";a:0:{}s:7:\"element\";i:0;s:10:\"parameters\";a:0:{}s:8:\"quantity\";i:9;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_pager\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:11:\"pager_first\";a:6:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:7:\"element\";i:0;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_pager_first\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:14:\"pager_previous\";a:6:{s:9:\"variables\";a:4:{s:4:\"text\";N;s:7:\"element\";i:0;s:8:\"interval\";i:1;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:20:\"theme_pager_previous\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:10:\"pager_next\";a:6:{s:9:\"variables\";a:4:{s:4:\"text\";N;s:7:\"element\";i:0;s:8:\"interval\";i:1;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_pager_next\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:10:\"pager_last\";a:6:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:7:\"element\";i:0;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_pager_last\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:10:\"pager_link\";a:6:{s:9:\"variables\";a:5:{s:4:\"text\";N;s:8:\"page_new\";N;s:7:\"element\";N;s:10:\"parameters\";a:0:{}s:10:\"attributes\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_pager_link\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"menu_link\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_menu_link\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"menu_tree\";a:6:{s:14:\"render element\";s:4:\"tree\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_menu_tree\";s:20:\"preprocess functions\";a:1:{i:0;s:29:\"template_preprocess_menu_tree\";}s:17:\"process functions\";a:0:{}}s:15:\"menu_local_task\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:21:\"theme_menu_local_task\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"menu_local_action\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:23:\"theme_menu_local_action\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"menu_local_tasks\";a:6:{s:9:\"variables\";a:2:{s:7:\"primary\";a:0:{}s:9:\"secondary\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:22:\"theme_menu_local_tasks\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:6:\"select\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_select\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:8:\"fieldset\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_fieldset\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:5:\"radio\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_radio\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:6:\"radios\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_radios\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:4:\"date\";a:7:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_date\";s:8:\"includes\";a:1:{i:0;s:41:\"sites/all/modules/contrib/date/date.theme\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:15:\"exposed_filters\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:21:\"theme_exposed_filters\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:8:\"checkbox\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_checkbox\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:10:\"checkboxes\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_checkboxes\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:6:\"button\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_button\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"image_button\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_image_button\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:6:\"hidden\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_hidden\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"textfield\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_textfield\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:4:\"form\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_form\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:8:\"textarea\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_textarea\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:8:\"password\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_password\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:4:\"file\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_file\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:11:\"tableselect\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_tableselect\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"form_element\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_form_element\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"form_required_marker\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:26:\"theme_form_required_marker\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"form_element_label\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:24:\"theme_form_element_label\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:13:\"vertical_tabs\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:19:\"theme_vertical_tabs\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"container\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_container\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"system_themes_page\";a:8:{s:9:\"variables\";a:1:{s:12:\"theme_groups\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:24:\"theme_system_themes_page\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"system_settings_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:26:\"theme_system_settings_form\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"confirm_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_confirm_form\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"system_modules_fieldset\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:29:\"theme_system_modules_fieldset\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:27:\"system_modules_incompatible\";a:8:{s:9:\"variables\";a:1:{s:7:\"message\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:33:\"theme_system_modules_incompatible\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:24:\"system_modules_uninstall\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:30:\"theme_system_modules_uninstall\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:13:\"status_report\";a:8:{s:14:\"render element\";s:12:\"requirements\";s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:19:\"theme_status_report\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:10:\"admin_page\";a:8:{s:9:\"variables\";a:1:{s:6:\"blocks\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_admin_page\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:11:\"admin_block\";a:8:{s:9:\"variables\";a:1:{s:5:\"block\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_admin_block\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"admin_block_content\";a:8:{s:9:\"variables\";a:1:{s:7:\"content\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:25:\"theme_admin_block_content\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"system_admin_index\";a:8:{s:9:\"variables\";a:1:{s:10:\"menu_items\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:24:\"theme_system_admin_index\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"system_powered_by\";a:6:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:23:\"theme_system_powered_by\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"system_compact_link\";a:6:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:25:\"theme_system_compact_link\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:25:\"system_date_time_settings\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:31:\"theme_system_date_time_settings\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:22:\"shortcut_set_customize\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"shortcut.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/shortcut\";s:8:\"function\";s:28:\"theme_shortcut_set_customize\";s:8:\"includes\";a:1:{i:0;s:35:\"modules/shortcut/shortcut.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"search_api_page_results\";a:8:{s:9:\"variables\";a:5:{s:5:\"index\";N;s:7:\"results\";a:1:{s:12:\"result count\";i:0;}s:5:\"items\";a:0:{}s:9:\"view_mode\";s:22:\"search_api_page_result\";s:4:\"keys\";s:0:\"\";}s:4:\"file\";s:25:\"search_api_page.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:41:\"sites/all/modules/contrib/search_api_page\";s:8:\"function\";s:29:\"theme_search_api_page_results\";s:8:\"includes\";a:1:{i:0;s:67:\"sites/all/modules/contrib/search_api_page/search_api_page.pages.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:43:\"template_preprocess_search_api_page_results\";}s:17:\"process functions\";a:0:{}}s:22:\"search_api_page_result\";a:8:{s:9:\"variables\";a:4:{s:5:\"index\";N;s:6:\"result\";N;s:4:\"item\";N;s:4:\"keys\";s:0:\"\";}s:4:\"file\";s:25:\"search_api_page.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:41:\"sites/all/modules/contrib/search_api_page\";s:8:\"function\";s:28:\"theme_search_api_page_result\";s:8:\"includes\";a:1:{i:0;s:67:\"sites/all/modules/contrib/search_api_page/search_api_page.pages.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"search_api_server\";a:8:{s:9:\"variables\";a:9:{s:2:\"id\";N;s:4:\"name\";s:0:\"\";s:12:\"machine_name\";s:0:\"\";s:11:\"description\";N;s:7:\"enabled\";N;s:10:\"class_name\";N;s:17:\"class_description\";N;s:7:\"options\";a:0:{}s:6:\"status\";i:1;}s:4:\"file\";s:20:\"search_api.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:36:\"sites/all/modules/contrib/search_api\";s:8:\"function\";s:23:\"theme_search_api_server\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/search_api/search_api.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"search_api_index\";a:8:{s:9:\"variables\";a:13:{s:2:\"id\";N;s:4:\"name\";s:0:\"\";s:12:\"machine_name\";s:0:\"\";s:11:\"description\";N;s:9:\"item_type\";N;s:7:\"enabled\";N;s:6:\"server\";N;s:7:\"options\";a:0:{}s:6:\"fields\";a:0:{}s:13:\"indexed_items\";i:0;s:11:\"total_items\";i:0;s:6:\"status\";i:1;s:9:\"read_only\";i:0;}s:4:\"file\";s:20:\"search_api.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:36:\"sites/all/modules/contrib/search_api\";s:8:\"function\";s:22:\"theme_search_api_index\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/search_api/search_api.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:27:\"search_api_admin_item_order\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:20:\"search_api.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:36:\"sites/all/modules/contrib/search_api\";s:8:\"function\";s:33:\"theme_search_api_admin_item_order\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/search_api/search_api.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:29:\"search_api_admin_fields_table\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:20:\"search_api.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:36:\"sites/all/modules/contrib/search_api\";s:8:\"function\";s:35:\"theme_search_api_admin_fields_table\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/search_api/search_api.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"search_block_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:8:\"template\";s:32:\"modules/search/search-block-form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/search\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:37:\"template_preprocess_search_block_form\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:13:\"search_result\";a:8:{s:9:\"variables\";a:2:{s:6:\"result\";N;s:6:\"module\";N;}s:4:\"file\";s:16:\"search.pages.inc\";s:8:\"template\";s:28:\"modules/search/search-result\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/search\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/search/search.pages.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:33:\"template_preprocess_search_result\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:14:\"search_results\";a:8:{s:9:\"variables\";a:2:{s:7:\"results\";N;s:6:\"module\";N;}s:4:\"file\";s:16:\"search.pages.inc\";s:8:\"template\";s:29:\"modules/search/search-results\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/search\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/search/search.pages.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:34:\"template_preprocess_search_results\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:29:\"rdf_template_variable_wrapper\";a:6:{s:9:\"variables\";a:4:{s:7:\"content\";N;s:10:\"attributes\";a:0:{}s:7:\"context\";a:0:{}s:6:\"inline\";b:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:11:\"modules/rdf\";s:8:\"function\";s:35:\"theme_rdf_template_variable_wrapper\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"rdf_metadata\";a:6:{s:9:\"variables\";a:1:{s:8:\"metadata\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:11:\"modules/rdf\";s:8:\"function\";s:18:\"theme_rdf_metadata\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"r4032login_denied\";a:6:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:36:\"sites/all/modules/contrib/r4032login\";s:8:\"function\";s:23:\"theme_r4032login_denied\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"panels_ipe_pane_wrapper\";a:6:{s:9:\"variables\";a:4:{s:6:\"output\";N;s:4:\"pane\";N;s:7:\"display\";N;s:8:\"renderer\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/panels/panels_ipe\";s:8:\"function\";s:29:\"theme_panels_ipe_pane_wrapper\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:25:\"panels_ipe_region_wrapper\";a:6:{s:9:\"variables\";a:5:{s:6:\"output\";N;s:9:\"region_id\";N;s:7:\"display\";N;s:8:\"controls\";N;s:8:\"renderer\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/panels/panels_ipe\";s:8:\"function\";s:31:\"theme_panels_ipe_region_wrapper\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:26:\"panels_ipe_add_pane_button\";a:6:{s:9:\"variables\";a:3:{s:9:\"region_id\";N;s:7:\"display\";N;s:8:\"renderer\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/panels/panels_ipe\";s:8:\"function\";s:32:\"theme_panels_ipe_add_pane_button\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:27:\"panels_ipe_placeholder_pane\";a:6:{s:9:\"variables\";a:2:{s:9:\"region_id\";N;s:12:\"region_title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/panels/panels_ipe\";s:8:\"function\";s:33:\"theme_panels_ipe_placeholder_pane\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:29:\"panels_ipe_dnd_form_container\";a:6:{s:9:\"variables\";a:3:{s:4:\"link\";N;s:9:\"cache_key\";N;s:7:\"display\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/panels/panels_ipe\";s:8:\"function\";s:35:\"theme_panels_ipe_dnd_form_container\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"panels_ipe_toolbar\";a:6:{s:9:\"variables\";a:1:{s:7:\"buttons\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/panels/panels_ipe\";s:8:\"function\";s:24:\"theme_panels_ipe_toolbar\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"panels_layout_link\";a:6:{s:9:\"variables\";a:5:{s:5:\"title\";N;s:2:\"id\";N;s:5:\"image\";N;s:4:\"link\";N;s:5:\"class\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:24:\"theme_panels_layout_link\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"panels_layout_icon\";a:6:{s:9:\"variables\";a:3:{s:2:\"id\";N;s:5:\"image\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:24:\"theme_panels_layout_icon\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:11:\"panels_pane\";a:7:{s:9:\"variables\";a:3:{s:6:\"output\";a:0:{}s:4:\"pane\";a:0:{}s:7:\"display\";a:0:{}}s:4:\"path\";s:42:\"sites/all/modules/contrib/panels/templates\";s:8:\"template\";s:11:\"panels-pane\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:31:\"template_preprocess_panels_pane\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:26:\"panels_common_content_list\";a:8:{s:9:\"variables\";a:1:{s:7:\"display\";N;}s:4:\"file\";s:19:\"includes/common.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:32:\"theme_panels_common_content_list\";s:8:\"includes\";a:1:{i:0;s:52:\"sites/all/modules/contrib/panels/includes/common.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:26:\"panels_render_display_form\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:32:\"theme_panels_render_display_form\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"panels_dashboard\";a:9:{s:9:\"variables\";a:0:{}s:4:\"path\";s:42:\"sites/all/modules/contrib/panels/templates\";s:4:\"file\";s:25:\"../includes/callbacks.inc\";s:8:\"template\";s:16:\"panels-dashboard\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:68:\"sites/all/modules/contrib/panels/templates/../includes/callbacks.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_panels_dashboard\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:21:\"panels_dashboard_link\";a:9:{s:9:\"variables\";a:1:{s:4:\"link\";a:0:{}}s:4:\"path\";s:42:\"sites/all/modules/contrib/panels/templates\";s:4:\"file\";s:25:\"../includes/callbacks.inc\";s:8:\"template\";s:21:\"panels-dashboard-link\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:68:\"sites/all/modules/contrib/panels/templates/../includes/callbacks.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:22:\"panels_dashboard_block\";a:9:{s:9:\"variables\";a:1:{s:5:\"block\";a:0:{}}s:4:\"path\";s:42:\"sites/all/modules/contrib/panels/templates\";s:4:\"file\";s:25:\"../includes/callbacks.inc\";s:8:\"template\";s:22:\"panels-dashboard-block\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:68:\"sites/all/modules/contrib/panels/templates/../includes/callbacks.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:24:\"panels_add_content_modal\";a:9:{s:9:\"variables\";a:5:{s:8:\"renderer\";N;s:10:\"categories\";a:0:{}s:6:\"region\";N;s:8:\"category\";N;s:12:\"column_count\";i:2;}s:4:\"path\";s:42:\"sites/all/modules/contrib/panels/templates\";s:4:\"file\";s:27:\"../includes/add-content.inc\";s:8:\"template\";s:24:\"panels-add-content-modal\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:70:\"sites/all/modules/contrib/panels/templates/../includes/add-content.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:44:\"template_preprocess_panels_add_content_modal\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:41:\"template_process_panels_add_content_modal\";i:2;s:11:\"rdf_process\";}}s:23:\"panels_add_content_link\";a:9:{s:9:\"variables\";a:3:{s:8:\"renderer\";N;s:6:\"region\";N;s:12:\"content_type\";N;}s:4:\"path\";s:42:\"sites/all/modules/contrib/panels/templates\";s:4:\"file\";s:27:\"../includes/add-content.inc\";s:8:\"template\";s:23:\"panels-add-content-link\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:70:\"sites/all/modules/contrib/panels/templates/../includes/add-content.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:43:\"template_preprocess_panels_add_content_link\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:15:\"panels_flexible\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:57:\"sites/all/modules/contrib/panels/plugins/layouts/flexible\";s:4:\"file\";s:12:\"flexible.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:21:\"theme_panels_flexible\";s:8:\"includes\";a:1:{i:0;s:70:\"sites/all/modules/contrib/panels/plugins/layouts/flexible/flexible.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:21:\"panels_flexible_admin\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:57:\"sites/all/modules/contrib/panels/plugins/layouts/flexible\";s:4:\"file\";s:12:\"flexible.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:27:\"theme_panels_flexible_admin\";s:8:\"includes\";a:1:{i:0;s:70:\"sites/all/modules/contrib/panels/plugins/layouts/flexible/flexible.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:24:\"panels_threecol_33_34_33\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:66:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_33_34_33\";s:4:\"file\";s:21:\"threecol_33_34_33.inc\";s:8:\"template\";s:24:\"panels-threecol-33-34-33\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:88:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_33_34_33/threecol_33_34_33.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:13:\"panels_onecol\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:55:\"sites/all/modules/contrib/panels/plugins/layouts/onecol\";s:4:\"file\";s:10:\"onecol.inc\";s:8:\"template\";s:13:\"panels-onecol\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:66:\"sites/all/modules/contrib/panels/plugins/layouts/onecol/onecol.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:24:\"panels_threecol_25_50_25\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:66:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_25_50_25\";s:4:\"file\";s:21:\"threecol_25_50_25.inc\";s:8:\"template\";s:24:\"panels-threecol-25-50-25\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:88:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_25_50_25/threecol_25_50_25.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:32:\"panels_threecol_25_50_25_stacked\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:74:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_25_50_25_stacked\";s:4:\"file\";s:29:\"threecol_25_50_25_stacked.inc\";s:8:\"template\";s:32:\"panels-threecol-25-50-25-stacked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:104:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_25_50_25_stacked/threecol_25_50_25_stacked.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:20:\"panels_twocol_bricks\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:62:\"sites/all/modules/contrib/panels/plugins/layouts/twocol_bricks\";s:4:\"file\";s:17:\"twocol_bricks.inc\";s:8:\"template\";s:20:\"panels-twocol-bricks\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:80:\"sites/all/modules/contrib/panels/plugins/layouts/twocol_bricks/twocol_bricks.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:32:\"panels_threecol_33_34_33_stacked\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:74:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_33_34_33_stacked\";s:4:\"file\";s:29:\"threecol_33_34_33_stacked.inc\";s:8:\"template\";s:32:\"panels-threecol-33-34-33-stacked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:104:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_33_34_33_stacked/threecol_33_34_33_stacked.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:21:\"panels_twocol_stacked\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:63:\"sites/all/modules/contrib/panels/plugins/layouts/twocol_stacked\";s:4:\"file\";s:18:\"twocol_stacked.inc\";s:8:\"template\";s:21:\"panels-twocol-stacked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:82:\"sites/all/modules/contrib/panels/plugins/layouts/twocol_stacked/twocol_stacked.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:13:\"panels_twocol\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:55:\"sites/all/modules/contrib/panels/plugins/layouts/twocol\";s:4:\"file\";s:10:\"twocol.inc\";s:8:\"template\";s:13:\"panels-twocol\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:66:\"sites/all/modules/contrib/panels/plugins/layouts/twocol/twocol.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:40:\"panels_rounded_corners_style_render_pane\";a:9:{s:9:\"variables\";a:5:{s:7:\"content\";N;s:4:\"pane\";N;s:7:\"display\";N;s:5:\"style\";N;s:8:\"settings\";N;}s:4:\"path\";s:55:\"sites/all/modules/contrib/panels/plugins/styles/corners\";s:4:\"file\";s:19:\"rounded_corners.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:46:\"theme_panels_rounded_corners_style_render_pane\";s:8:\"includes\";a:1:{i:0;s:75:\"sites/all/modules/contrib/panels/plugins/styles/corners/rounded_corners.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:42:\"panels_rounded_corners_style_render_region\";a:9:{s:9:\"variables\";a:6:{s:7:\"display\";N;s:8:\"owner_id\";N;s:5:\"panes\";N;s:8:\"settings\";N;s:9:\"region_id\";N;s:5:\"style\";N;}s:4:\"path\";s:55:\"sites/all/modules/contrib/panels/plugins/styles/corners\";s:4:\"file\";s:19:\"rounded_corners.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:48:\"theme_panels_rounded_corners_style_render_region\";s:8:\"includes\";a:1:{i:0;s:75:\"sites/all/modules/contrib/panels/plugins/styles/corners/rounded_corners.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:26:\"panels_rounded_corners_box\";a:7:{s:9:\"variables\";a:1:{s:7:\"content\";N;}s:4:\"path\";s:55:\"sites/all/modules/contrib/panels/plugins/styles/corners\";s:8:\"template\";s:26:\"panels-rounded-corners-box\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:30:\"panels_block_style_render_pane\";a:9:{s:9:\"variables\";a:5:{s:7:\"content\";N;s:4:\"pane\";N;s:7:\"display\";N;s:5:\"style\";N;s:8:\"settings\";N;}s:4:\"path\";s:47:\"sites/all/modules/contrib/panels/plugins/styles\";s:4:\"file\";s:9:\"block.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:36:\"theme_panels_block_style_render_pane\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/panels/plugins/styles/block.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:34:\"panels_default_style_render_region\";a:9:{s:9:\"variables\";a:6:{s:7:\"display\";N;s:8:\"owner_id\";N;s:5:\"panes\";N;s:8:\"settings\";N;s:9:\"region_id\";N;s:5:\"style\";N;}s:4:\"path\";s:47:\"sites/all/modules/contrib/panels/plugins/styles\";s:4:\"file\";s:11:\"default.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:40:\"theme_panels_default_style_render_region\";s:8:\"includes\";a:1:{i:0;s:59:\"sites/all/modules/contrib/panels/plugins/styles/default.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:30:\"panels_naked_style_render_pane\";a:9:{s:9:\"variables\";a:5:{s:7:\"content\";N;s:4:\"pane\";N;s:7:\"display\";N;s:5:\"style\";N;s:8:\"settings\";N;}s:4:\"path\";s:47:\"sites/all/modules/contrib/panels/plugins/styles\";s:4:\"file\";s:9:\"naked.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:36:\"theme_panels_naked_style_render_pane\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/panels/plugins/styles/naked.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:32:\"panels_naked_style_render_region\";a:9:{s:9:\"variables\";a:6:{s:7:\"display\";N;s:8:\"owner_id\";N;s:5:\"panes\";N;s:8:\"settings\";N;s:9:\"region_id\";N;s:5:\"style\";N;}s:4:\"path\";s:47:\"sites/all/modules/contrib/panels/plugins/styles\";s:4:\"file\";s:9:\"naked.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:38:\"theme_panels_naked_style_render_region\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/panels/plugins/styles/naked.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:31:\"panels_list_style_render_region\";a:9:{s:9:\"variables\";a:6:{s:7:\"display\";N;s:8:\"owner_id\";N;s:5:\"panes\";N;s:8:\"settings\";N;s:9:\"region_id\";N;s:5:\"style\";N;}s:4:\"path\";s:47:\"sites/all/modules/contrib/panels/plugins/styles\";s:4:\"file\";s:8:\"list.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:37:\"theme_panels_list_style_render_region\";s:8:\"includes\";a:1:{i:0;s:56:\"sites/all/modules/contrib/panels/plugins/styles/list.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"options_none\";a:6:{s:9:\"variables\";a:2:{s:8:\"instance\";N;s:6:\"option\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:29:\"modules/field/modules/options\";s:8:\"function\";s:18:\"theme_options_none\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:4:\"node\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:17:\"modules/node/node\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:20:\"preprocess functions\";a:6:{i:0;s:19:\"template_preprocess\";i:1;s:24:\"template_preprocess_node\";i:2;s:22:\"ctools_preprocess_node\";i:3;s:30:\"node_reference_preprocess_node\";i:4;s:19:\"rdf_preprocess_node\";i:5;s:21:\"views_preprocess_node\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:17:\"node_search_admin\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:23:\"theme_node_search_admin\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:13:\"node_add_list\";a:8:{s:9:\"variables\";a:1:{s:7:\"content\";N;}s:4:\"file\";s:14:\"node.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:19:\"theme_node_add_list\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/node/node.pages.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"node_preview\";a:8:{s:9:\"variables\";a:1:{s:4:\"node\";N;}s:4:\"file\";s:14:\"node.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:18:\"theme_node_preview\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/node/node.pages.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"node_admin_overview\";a:6:{s:9:\"variables\";a:2:{s:4:\"name\";N;s:4:\"type\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:25:\"theme_node_admin_overview\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"node_recent_block\";a:6:{s:9:\"variables\";a:1:{s:5:\"nodes\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:23:\"theme_node_recent_block\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"node_recent_content\";a:6:{s:9:\"variables\";a:1:{s:4:\"node\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:25:\"theme_node_recent_content\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:28:\"module_filter_system_modules\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:23:\"module_filter.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/module_filter\";s:8:\"function\";s:34:\"theme_module_filter_system_modules\";s:8:\"includes\";a:1:{i:0;s:63:\"sites/all/modules/contrib/module_filter/module_filter.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:27:\"module_filter_modules_table\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:23:\"module_filter.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/module_filter\";s:8:\"function\";s:33:\"theme_module_filter_modules_table\";s:8:\"includes\";a:1:{i:0;s:63:\"sites/all/modules/contrib/module_filter/module_filter.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:33:\"module_filter_system_modules_tabs\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:23:\"module_filter.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/module_filter\";s:8:\"function\";s:39:\"theme_module_filter_system_modules_tabs\";s:8:\"includes\";a:1:{i:0;s:63:\"sites/all/modules/contrib/module_filter/module_filter.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"menu_overview_form\";a:8:{s:4:\"file\";s:14:\"menu.admin.inc\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/menu\";s:8:\"function\";s:24:\"theme_menu_overview_form\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/menu/menu.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"menu_admin_overview\";a:8:{s:4:\"file\";s:14:\"menu.admin.inc\";s:9:\"variables\";a:3:{s:5:\"title\";N;s:4:\"name\";N;s:11:\"description\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/menu\";s:8:\"function\";s:25:\"theme_menu_admin_overview\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/menu/menu.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:29:\"login_destination_destination\";a:8:{s:9:\"variables\";a:1:{s:11:\"destination\";N;}s:4:\"file\";s:27:\"login_destination.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/login_destination\";s:8:\"function\";s:35:\"theme_login_destination_destination\";s:8:\"includes\";a:1:{i:0;s:71:\"sites/all/modules/contrib/login_destination/login_destination.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"login_destination_pages\";a:8:{s:9:\"variables\";a:2:{s:5:\"pages\";N;s:10:\"pages_type\";i:0;}s:4:\"file\";s:27:\"login_destination.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/login_destination\";s:8:\"function\";s:29:\"theme_login_destination_pages\";s:8:\"includes\";a:1:{i:0;s:71:\"sites/all/modules/contrib/login_destination/login_destination.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:26:\"login_destination_triggers\";a:8:{s:9:\"variables\";a:1:{s:5:\"items\";N;}s:4:\"file\";s:27:\"login_destination.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/login_destination\";s:8:\"function\";s:32:\"theme_login_destination_triggers\";s:8:\"includes\";a:1:{i:0;s:71:\"sites/all/modules/contrib/login_destination/login_destination.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"login_destination_roles\";a:8:{s:9:\"variables\";a:1:{s:5:\"items\";N;}s:4:\"file\";s:27:\"login_destination.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/login_destination\";s:8:\"function\";s:29:\"theme_login_destination_roles\";s:8:\"includes\";a:1:{i:0;s:71:\"sites/all/modules/contrib/login_destination/login_destination.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"lt_username_title\";a:6:{s:9:\"variables\";a:1:{s:7:\"form_id\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:23:\"theme_lt_username_title\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"lt_username_description\";a:6:{s:9:\"variables\";a:1:{s:7:\"form_id\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:29:\"theme_lt_username_description\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"lt_password_title\";a:6:{s:9:\"variables\";a:1:{s:7:\"form_id\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:23:\"theme_lt_password_title\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"lt_password_description\";a:6:{s:9:\"variables\";a:1:{s:7:\"form_id\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:29:\"theme_lt_password_description\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"lt_access_denied\";a:6:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:22:\"theme_lt_access_denied\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"lt_loggedinblock\";a:6:{s:9:\"variables\";a:1:{s:7:\"account\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:22:\"theme_lt_loggedinblock\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:13:\"lt_login_link\";a:6:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:19:\"theme_lt_login_link\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:27:\"lt_login_successful_message\";a:6:{s:9:\"variables\";a:1:{s:7:\"account\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:33:\"theme_lt_login_successful_message\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:21:\"lt_unified_login_page\";a:6:{s:9:\"variables\";a:3:{s:10:\"login_form\";N;s:13:\"register_form\";N;s:11:\"active_form\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:27:\"theme_lt_unified_login_page\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:15:\"transfer_slider\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:42:\"sites/all/modules/contrib/jslider_form_api\";s:8:\"function\";s:21:\"theme_transfer_slider\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:21:\"filter_admin_overview\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:16:\"filter.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:27:\"theme_filter_admin_overview\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/filter/filter.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:32:\"filter_admin_format_filter_order\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:16:\"filter.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:38:\"theme_filter_admin_format_filter_order\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/filter/filter.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:11:\"filter_tips\";a:8:{s:9:\"variables\";a:2:{s:4:\"tips\";N;s:4:\"long\";b:0;}s:4:\"file\";s:16:\"filter.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:17:\"theme_filter_tips\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/filter/filter.pages.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"text_format_wrapper\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:25:\"theme_text_format_wrapper\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:21:\"filter_tips_more_info\";a:6:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:27:\"theme_filter_tips_more_info\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"filter_guidelines\";a:6:{s:9:\"variables\";a:1:{s:6:\"format\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:23:\"theme_filter_guidelines\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:14:\"field_ui_table\";a:6:{s:14:\"render element\";s:8:\"elements\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/field_ui\";s:8:\"function\";s:20:\"theme_field_ui_table\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:5:\"field\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/field\";s:8:\"function\";s:11:\"theme_field\";s:20:\"preprocess functions\";a:2:{i:0;s:25:\"template_preprocess_field\";i:1;s:20:\"rdf_preprocess_field\";}s:17:\"process functions\";a:1:{i:0;s:22:\"template_process_field\";}}s:25:\"field_multiple_value_form\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/field\";s:8:\"function\";s:31:\"theme_field_multiple_value_form\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:38:\"famc_analytics_vm_historical_perf_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/custom/famc_analytics\";s:8:\"function\";s:44:\"theme_famc_analytics_vm_historical_perf_form\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:29:\"famc_analytics_analytics_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/custom/famc_analytics\";s:8:\"function\";s:35:\"theme_famc_analytics_analytics_form\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:34:\"famc_analytics_analytics_view_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/custom/famc_analytics\";s:8:\"function\";s:40:\"theme_famc_analytics_analytics_view_form\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:13:\"entity_status\";a:6:{s:9:\"variables\";a:2:{s:6:\"status\";N;s:4:\"html\";b:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/entity\";s:8:\"function\";s:19:\"theme_entity_status\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:6:\"entity\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:39:\"sites/all/modules/contrib/entity/entity\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/entity\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:26:\"template_preprocess_entity\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:23:\"entity_ui_overview_item\";a:8:{s:9:\"variables\";a:4:{s:5:\"label\";N;s:11:\"entity_type\";N;s:3:\"url\";b:0;s:4:\"name\";b:0;}s:4:\"file\";s:22:\"includes/entity.ui.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/entity\";s:8:\"function\";s:29:\"theme_entity_ui_overview_item\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/entity/includes/entity.ui.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:13:\"dblog_message\";a:8:{s:9:\"variables\";a:2:{s:5:\"event\";N;s:4:\"link\";b:0;}s:4:\"file\";s:15:\"dblog.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/dblog\";s:8:\"function\";s:19:\"theme_dblog_message\";s:8:\"includes\";a:1:{i:0;s:29:\"modules/dblog/dblog.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:14:\"date_nav_title\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:47:\"sites/all/modules/contrib/date/date_views/theme\";s:9:\"variables\";a:4:{s:11:\"granularity\";N;s:4:\"view\";N;s:4:\"link\";N;s:6:\"format\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:41:\"sites/all/modules/contrib/date/date_views\";s:8:\"function\";s:20:\"theme_date_nav_title\";s:8:\"includes\";a:2:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";i:1;s:57:\"sites/all/modules/contrib/date/date_views/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:22:\"date_views_filter_form\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:47:\"sites/all/modules/contrib/date/date_views/theme\";s:8:\"template\";s:22:\"date-views-filter-form\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:41:\"sites/all/modules/contrib/date/date_views\";s:8:\"includes\";a:2:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";i:1;s:57:\"sites/all/modules/contrib/date/date_views/theme/theme.inc\";}s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:42:\"template_preprocess_date_views_filter_form\";i:2;s:19:\"template_preprocess\";i:3;s:42:\"template_preprocess_date_views_filter_form\";}s:17:\"process functions\";a:4:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";i:2;s:16:\"template_process\";i:3;s:11:\"rdf_process\";}}s:17:\"date_calendar_day\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:47:\"sites/all/modules/contrib/date/date_views/theme\";s:9:\"variables\";a:1:{s:4:\"date\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:41:\"sites/all/modules/contrib/date/date_views\";s:8:\"function\";s:23:\"theme_date_calendar_day\";s:8:\"includes\";a:2:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";i:1;s:57:\"sites/all/modules/contrib/date/date_views/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"date_views_pager\";a:10:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:47:\"sites/all/modules/contrib/date/date_views/theme\";s:9:\"variables\";a:2:{s:6:\"plugin\";N;s:5:\"input\";N;}s:7:\"pattern\";s:18:\"date_views_pager__\";s:8:\"template\";s:16:\"date-views-pager\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:41:\"sites/all/modules/contrib/date/date_views\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/date/date_views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_date_views_pager\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:10:\"date_popup\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:41:\"sites/all/modules/contrib/date/date_popup\";s:8:\"function\";s:16:\"theme_date_popup\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:13:\"date_timezone\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:19:\"theme_date_timezone\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:11:\"date_select\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:17:\"theme_date_select\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"date_text\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:15:\"theme_date_text\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"date_select_element\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:25:\"theme_date_select_element\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:22:\"date_textfield_element\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:28:\"theme_date_textfield_element\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:21:\"date_part_hour_prefix\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:27:\"theme_date_part_hour_prefix\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"date_part_minsec_prefix\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:29:\"theme_date_part_minsec_prefix\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"date_part_label_year\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_year\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:21:\"date_part_label_month\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:27:\"theme_date_part_label_month\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"date_part_label_day\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:25:\"theme_date_part_label_day\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"date_part_label_hour\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_hour\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:22:\"date_part_label_minute\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:28:\"theme_date_part_label_minute\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:22:\"date_part_label_second\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:28:\"theme_date_part_label_second\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"date_part_label_ampm\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_ampm\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:24:\"date_part_label_timezone\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:30:\"theme_date_part_label_timezone\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"date_part_label_date\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_date\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"date_part_label_time\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_time\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:13:\"date_time_ago\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:3:{s:10:\"start_date\";N;s:8:\"end_date\";N;s:8:\"interval\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:19:\"theme_date_time_ago\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:10:\"date_combo\";a:9:{s:4:\"file\";s:10:\"date.theme\";s:4:\"path\";s:30:\"sites/all/modules/contrib/date\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:30:\"sites/all/modules/contrib/date\";s:8:\"function\";s:16:\"theme_date_combo\";s:8:\"includes\";a:1:{i:0;s:41:\"sites/all/modules/contrib/date/date.theme\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:15:\"date_text_parts\";a:9:{s:4:\"file\";s:10:\"date.theme\";s:4:\"path\";s:30:\"sites/all/modules/contrib/date\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:30:\"sites/all/modules/contrib/date\";s:8:\"function\";s:21:\"theme_date_text_parts\";s:8:\"includes\";a:1:{i:0;s:41:\"sites/all/modules/contrib/date/date.theme\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"date_display_single\";a:9:{s:4:\"file\";s:10:\"date.theme\";s:4:\"path\";s:30:\"sites/all/modules/contrib/date\";s:9:\"variables\";a:6:{s:4:\"date\";N;s:8:\"timezone\";N;s:5:\"dates\";N;s:10:\"attributes\";a:0:{}s:11:\"rdf_mapping\";N;s:7:\"add_rdf\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:30:\"sites/all/modules/contrib/date\";s:8:\"function\";s:25:\"theme_date_display_single\";s:8:\"includes\";a:1:{i:0;s:41:\"sites/all/modules/contrib/date/date.theme\";}s:20:\"preprocess functions\";a:1:{i:0;s:39:\"template_preprocess_date_display_single\";}s:17:\"process functions\";a:0:{}}s:18:\"date_display_range\";a:9:{s:4:\"file\";s:10:\"date.theme\";s:4:\"path\";s:30:\"sites/all/modules/contrib/date\";s:9:\"variables\";a:9:{s:5:\"date1\";N;s:5:\"date2\";N;s:8:\"timezone\";N;s:5:\"dates\";N;s:10:\"attributes\";a:0:{}s:16:\"attributes_start\";a:0:{}s:14:\"attributes_end\";a:0:{}s:11:\"rdf_mapping\";N;s:7:\"add_rdf\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:30:\"sites/all/modules/contrib/date\";s:8:\"function\";s:24:\"theme_date_display_range\";s:8:\"includes\";a:1:{i:0;s:41:\"sites/all/modules/contrib/date/date.theme\";}s:20:\"preprocess functions\";a:1:{i:0;s:38:\"template_preprocess_date_display_range\";}s:17:\"process functions\";a:0:{}}s:24:\"date_display_combination\";a:9:{s:4:\"file\";s:10:\"date.theme\";s:4:\"path\";s:30:\"sites/all/modules/contrib/date\";s:9:\"variables\";a:12:{s:11:\"entity_type\";N;s:6:\"entity\";N;s:5:\"field\";N;s:8:\"instance\";N;s:8:\"langcode\";N;s:4:\"item\";N;s:5:\"delta\";N;s:7:\"display\";N;s:5:\"dates\";N;s:10:\"attributes\";a:0:{}s:11:\"rdf_mapping\";N;s:7:\"add_rdf\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:30:\"sites/all/modules/contrib/date\";s:8:\"function\";s:30:\"theme_date_display_combination\";s:8:\"includes\";a:1:{i:0;s:41:\"sites/all/modules/contrib/date/date.theme\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:21:\"date_display_interval\";a:9:{s:4:\"file\";s:10:\"date.theme\";s:4:\"path\";s:30:\"sites/all/modules/contrib/date\";s:9:\"variables\";a:12:{s:11:\"entity_type\";N;s:6:\"entity\";N;s:5:\"field\";N;s:8:\"instance\";N;s:8:\"langcode\";N;s:4:\"item\";N;s:5:\"delta\";N;s:7:\"display\";N;s:5:\"dates\";N;s:10:\"attributes\";a:0:{}s:11:\"rdf_mapping\";N;s:7:\"add_rdf\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:30:\"sites/all/modules/contrib/date\";s:8:\"function\";s:27:\"theme_date_display_interval\";s:8:\"includes\";a:1:{i:0;s:41:\"sites/all/modules/contrib/date/date.theme\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"dashboard\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:15:\"theme_dashboard\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:15:\"dashboard_admin\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:21:\"theme_dashboard_admin\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"dashboard_region\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:22:\"theme_dashboard_region\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:25:\"dashboard_disabled_blocks\";a:6:{s:9:\"variables\";a:1:{s:6:\"blocks\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:31:\"theme_dashboard_disabled_blocks\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:24:\"dashboard_disabled_block\";a:6:{s:9:\"variables\";a:1:{s:5:\"block\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:30:\"theme_dashboard_disabled_block\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:28:\"dashboard_admin_display_form\";a:9:{s:8:\"template\";s:24:\"block-admin-display-form\";s:4:\"path\";s:13:\"modules/block\";s:4:\"file\";s:15:\"block.admin.inc\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"includes\";a:1:{i:0;s:29:\"modules/block/block.admin.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_dashboard_admin_display_form\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"ctools_ajax_sample_container\";a:6:{s:9:\"arguments\";a:1:{s:7:\"content\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:51:\"sites/all/modules/contrib/ctools/ctools_ajax_sample\";s:8:\"function\";s:34:\"theme_ctools_ajax_sample_container\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"ctools_context_list\";a:8:{s:9:\"variables\";a:1:{s:6:\"object\";N;}s:4:\"file\";s:26:\"includes/context.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:25:\"theme_ctools_context_list\";s:8:\"includes\";a:1:{i:0;s:59:\"sites/all/modules/contrib/ctools/includes/context.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:28:\"ctools_context_list_no_table\";a:8:{s:9:\"variables\";a:1:{s:6:\"object\";N;}s:4:\"file\";s:26:\"includes/context.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:34:\"theme_ctools_context_list_no_table\";s:8:\"includes\";a:1:{i:0;s:59:\"sites/all/modules/contrib/ctools/includes/context.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:24:\"ctools_context_item_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:26:\"includes/context.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:30:\"theme_ctools_context_item_form\";s:8:\"includes\";a:1:{i:0;s:59:\"sites/all/modules/contrib/ctools/includes/context.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"ctools_context_item_row\";a:8:{s:9:\"variables\";a:5:{s:4:\"type\";N;s:4:\"form\";N;s:8:\"position\";N;s:5:\"count\";N;s:7:\"with_tr\";b:1;}s:4:\"file\";s:26:\"includes/context.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:29:\"theme_ctools_context_item_row\";s:8:\"includes\";a:1:{i:0;s:59:\"sites/all/modules/contrib/ctools/includes/context.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"ctools_access_admin_add\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:33:\"includes/context-access-admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:29:\"theme_ctools_access_admin_add\";s:8:\"includes\";a:1:{i:0;s:66:\"sites/all/modules/contrib/ctools/includes/context-access-admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:24:\"links__ctools_dropbutton\";a:8:{s:9:\"variables\";a:4:{s:5:\"title\";N;s:5:\"links\";N;s:5:\"image\";b:0;s:5:\"class\";N;}s:4:\"file\";s:29:\"includes/dropbutton.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:30:\"theme_links__ctools_dropbutton\";s:8:\"includes\";a:1:{i:0;s:62:\"sites/all/modules/contrib/ctools/includes/dropbutton.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:33:\"ctools_stylizer_color_scheme_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:21:\"includes/stylizer.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:39:\"theme_ctools_stylizer_color_scheme_form\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/contrib/ctools/includes/stylizer.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:28:\"ctools_stylizer_preview_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:21:\"includes/stylizer.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:34:\"theme_ctools_stylizer_preview_form\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/contrib/ctools/includes/stylizer.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"ctools_style_icon\";a:8:{s:9:\"variables\";a:2:{s:5:\"image\";N;s:5:\"title\";N;}s:4:\"file\";s:21:\"includes/stylizer.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:23:\"theme_ctools_style_icon\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/contrib/ctools/includes/stylizer.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"ctools_wizard_trail\";a:8:{s:9:\"variables\";a:1:{s:5:\"trail\";N;}s:4:\"file\";s:25:\"includes/wizard.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:25:\"theme_ctools_wizard_trail\";s:8:\"includes\";a:1:{i:0;s:58:\"sites/all/modules/contrib/ctools/includes/wizard.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"ctools_collapsible\";a:8:{s:9:\"variables\";a:3:{s:6:\"handle\";N;s:7:\"content\";N;s:9:\"collapsed\";b:0;}s:4:\"file\";s:30:\"includes/collapsible.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:24:\"theme_ctools_collapsible\";s:8:\"includes\";a:1:{i:0;s:63:\"sites/all/modules/contrib/ctools/includes/collapsible.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:29:\"ctools_collapsible_remembered\";a:8:{s:9:\"variables\";a:4:{s:2:\"id\";N;s:6:\"handle\";N;s:7:\"content\";N;s:9:\"collapsed\";b:0;}s:4:\"file\";s:30:\"includes/collapsible.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:35:\"theme_ctools_collapsible_remembered\";s:8:\"includes\";a:1:{i:0;s:63:\"sites/all/modules/contrib/ctools/includes/collapsible.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:15:\"ctools_dropdown\";a:8:{s:9:\"variables\";a:4:{s:5:\"title\";N;s:5:\"links\";N;s:5:\"image\";b:0;s:5:\"class\";s:0:\"\";}s:4:\"file\";s:27:\"includes/dropdown.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:21:\"theme_ctools_dropdown\";s:8:\"includes\";a:1:{i:0;s:60:\"sites/all/modules/contrib/ctools/includes/dropdown.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:13:\"comment_block\";a:6:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/comment\";s:8:\"function\";s:19:\"theme_comment_block\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:15:\"comment_preview\";a:6:{s:9:\"variables\";a:1:{s:7:\"comment\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/comment\";s:8:\"function\";s:21:\"theme_comment_preview\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:7:\"comment\";a:6:{s:8:\"template\";s:23:\"modules/comment/comment\";s:14:\"render element\";s:8:\"elements\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/comment\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:27:\"template_preprocess_comment\";i:2;s:22:\"rdf_preprocess_comment\";i:3;s:24:\"views_preprocess_comment\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:22:\"comment_post_forbidden\";a:6:{s:9:\"variables\";a:1:{s:4:\"node\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/comment\";s:8:\"function\";s:28:\"theme_comment_post_forbidden\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:15:\"comment_wrapper\";a:6:{s:8:\"template\";s:31:\"modules/comment/comment-wrapper\";s:14:\"render element\";s:7:\"content\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/comment\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:35:\"template_preprocess_comment_wrapper\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:17:\"color_scheme_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/color\";s:8:\"function\";s:23:\"theme_color_scheme_form\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"coder_review\";a:6:{s:9:\"variables\";a:3:{s:4:\"name\";N;s:8:\"filename\";N;s:7:\"results\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:44:\"sites/all/modules/contrib/coder/coder_review\";s:8:\"function\";s:18:\"theme_coder_review\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"coder_review_warning\";a:6:{s:9:\"variables\";a:4:{s:7:\"warning\";N;s:13:\"severity_name\";N;s:6:\"lineno\";N;s:4:\"line\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:44:\"sites/all/modules/contrib/coder/coder_review\";s:8:\"function\";s:26:\"theme_coder_review_warning\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:24:\"coder_review_warning_msg\";a:6:{s:9:\"variables\";a:1:{s:5:\"error\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:44:\"sites/all/modules/contrib/coder/coder_review\";s:8:\"function\";s:30:\"theme_coder_review_warning_msg\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"coder_review_table_cols\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:44:\"sites/all/modules/contrib/coder/coder_review\";s:8:\"function\";s:29:\"theme_coder_review_table_cols\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"drupalapi\";a:6:{s:9:\"variables\";a:2:{s:8:\"function\";N;s:7:\"version\";s:1:\"7\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:44:\"sites/all/modules/contrib/coder/coder_review\";s:8:\"function\";s:15:\"theme_drupalapi\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:6:\"phpapi\";a:6:{s:9:\"variables\";a:1:{s:8:\"function\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:44:\"sites/all/modules/contrib/coder/coder_review\";s:8:\"function\";s:12:\"theme_phpapi\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:5:\"block\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:19:\"modules/block/block\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/block\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:25:\"template_preprocess_block\";i:2;s:28:\"block_class_preprocess_block\";i:3;s:23:\"system_preprocess_block\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:24:\"block_admin_display_form\";a:8:{s:8:\"template\";s:38:\"modules/block/block-admin-display-form\";s:4:\"file\";s:15:\"block.admin.inc\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/block\";s:8:\"includes\";a:1:{i:0;s:29:\"modules/block/block.admin.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:44:\"template_preprocess_block_admin_display_form\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}}',0,1371656313,1),('theme_registry:seven','a:308:{s:19:\"tablesort_indicator\";a:4:{s:8:\"function\";s:25:\"seven_tablesort_indicator\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:12:\"themes/seven\";s:9:\"variables\";a:1:{s:5:\"style\";N;}}s:19:\"admin_block_content\";a:5:{s:8:\"function\";s:25:\"seven_admin_block_content\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:12:\"themes/seven\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}s:9:\"variables\";a:1:{s:7:\"content\";N;}}s:13:\"node_add_list\";a:5:{s:8:\"function\";s:19:\"seven_node_add_list\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:12:\"themes/seven\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/node/node.pages.inc\";}s:9:\"variables\";a:1:{s:7:\"content\";N;}}s:4:\"page\";a:7:{s:8:\"template\";s:4:\"page\";s:4:\"path\";s:12:\"themes/seven\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:12:\"themes/seven\";s:14:\"render element\";s:4:\"page\";s:20:\"preprocess functions\";a:5:{i:0;s:19:\"template_preprocess\";i:1;s:24:\"template_preprocess_page\";i:2;s:24:\"shortcut_preprocess_page\";i:3;s:21:\"seven_preprocess_page\";i:5;s:22:\"ctools_preprocess_page\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:21:\"template_process_page\";i:2;s:11:\"rdf_process\";}}s:16:\"maintenance_page\";a:7:{s:8:\"template\";s:16:\"maintenance-page\";s:4:\"path\";s:12:\"themes/seven\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:12:\"themes/seven\";s:9:\"variables\";a:2:{s:7:\"content\";N;s:13:\"show_messages\";b:1;}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_maintenance_page\";i:2;s:33:\"seven_preprocess_maintenance_page\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:33:\"template_process_maintenance_page\";i:2;s:11:\"rdf_process\";}}s:16:\"admin_menu_links\";a:4:{s:14:\"render element\";s:8:\"elements\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:36:\"sites/all/modules/contrib/admin_menu\";s:8:\"function\";s:22:\"theme_admin_menu_links\";}s:15:\"admin_menu_icon\";a:7:{s:9:\"variables\";a:2:{s:3:\"src\";N;s:3:\"alt\";N;}s:4:\"file\";s:14:\"admin_menu.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:36:\"sites/all/modules/contrib/admin_menu\";s:8:\"function\";s:21:\"theme_admin_menu_icon\";s:8:\"includes\";a:1:{i:0;s:51:\"sites/all/modules/contrib/admin_menu/admin_menu.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:35:\"template_preprocess_admin_menu_icon\";}}s:30:\"page_manager_handler_rearrange\";a:7:{s:14:\"render element\";s:4:\"form\";s:4:\"path\";s:51:\"sites/all/modules/contrib/ctools/page_manager/theme\";s:4:\"file\";s:22:\"page_manager.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:45:\"sites/all/modules/contrib/ctools/page_manager\";s:8:\"function\";s:36:\"theme_page_manager_handler_rearrange\";s:8:\"includes\";a:1:{i:0;s:74:\"sites/all/modules/contrib/ctools/page_manager/theme/page_manager.theme.inc\";}}s:22:\"page_manager_edit_page\";a:9:{s:8:\"template\";s:22:\"page-manager-edit-page\";s:9:\"variables\";a:4:{s:4:\"page\";N;s:4:\"save\";N;s:10:\"operations\";a:0:{}s:7:\"content\";a:0:{}}s:4:\"path\";s:51:\"sites/all/modules/contrib/ctools/page_manager/theme\";s:4:\"file\";s:22:\"page_manager.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:45:\"sites/all/modules/contrib/ctools/page_manager\";s:8:\"includes\";a:1:{i:0;s:74:\"sites/all/modules/contrib/ctools/page_manager/theme/page_manager.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:42:\"template_preprocess_page_manager_edit_page\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:17:\"page_manager_lock\";a:7:{s:9:\"variables\";a:1:{s:4:\"page\";a:0:{}}s:4:\"path\";s:51:\"sites/all/modules/contrib/ctools/page_manager/theme\";s:4:\"file\";s:22:\"page_manager.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:45:\"sites/all/modules/contrib/ctools/page_manager\";s:8:\"function\";s:23:\"theme_page_manager_lock\";s:8:\"includes\";a:1:{i:0;s:74:\"sites/all/modules/contrib/ctools/page_manager/theme/page_manager.theme.inc\";}}s:20:\"page_manager_changed\";a:7:{s:9:\"variables\";a:2:{s:4:\"text\";N;s:11:\"description\";N;}s:4:\"path\";s:51:\"sites/all/modules/contrib/ctools/page_manager/theme\";s:4:\"file\";s:22:\"page_manager.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:45:\"sites/all/modules/contrib/ctools/page_manager\";s:8:\"function\";s:26:\"theme_page_manager_changed\";s:8:\"includes\";a:1:{i:0;s:74:\"sites/all/modules/contrib/ctools/page_manager/theme/page_manager.theme.inc\";}}s:37:\"page_manager_page_form_argument_table\";a:7:{s:4:\"file\";s:14:\"page.admin.inc\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:45:\"sites/all/modules/contrib/ctools/page_manager\";s:8:\"function\";s:43:\"theme_page_manager_page_form_argument_table\";s:8:\"includes\";a:1:{i:0;s:74:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.admin.inc\";}}s:22:\"page_manager_page_lock\";a:7:{s:4:\"file\";s:14:\"page.admin.inc\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks\";s:9:\"variables\";a:2:{s:4:\"lock\";a:0:{}s:9:\"task_name\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:45:\"sites/all/modules/contrib/ctools/page_manager\";s:8:\"function\";s:28:\"theme_page_manager_page_lock\";s:8:\"includes\";a:1:{i:0;s:74:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.admin.inc\";}}s:25:\"page_manager_page_changed\";a:7:{s:4:\"file\";s:14:\"page.admin.inc\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks\";s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:45:\"sites/all/modules/contrib/ctools/page_manager\";s:8:\"function\";s:31:\"theme_page_manager_page_changed\";s:8:\"includes\";a:1:{i:0;s:74:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.admin.inc\";}}s:16:\"views_mini_pager\";a:8:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"tags\";a:0:{}s:8:\"quantity\";i:10;s:7:\"element\";i:0;s:10:\"parameters\";a:0:{}}s:7:\"pattern\";s:18:\"views_mini_pager__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:22:\"theme_views_mini_pager\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}}s:16:\"views_view_field\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:7:\"pattern\";s:18:\"views_view_field__\";s:9:\"variables\";a:3:{s:4:\"view\";N;s:5:\"field\";N;s:3:\"row\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:22:\"theme_views_view_field\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:36:\"template_preprocess_views_view_field\";}}s:19:\"views_view_grouping\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:7:\"pattern\";s:21:\"views_view_grouping__\";s:9:\"variables\";a:5:{s:4:\"view\";N;s:8:\"grouping\";N;s:14:\"grouping_level\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:25:\"theme_views_view_grouping\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:39:\"template_preprocess_views_view_grouping\";}}s:10:\"views_view\";a:10:{s:7:\"pattern\";s:12:\"views_view__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:2:{s:10:\"view_array\";a:0:{}s:4:\"view\";N;}s:8:\"template\";s:10:\"views-view\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:30:\"template_preprocess_views_view\";i:2;s:32:\"date_views_preprocess_views_view\";i:3;s:30:\"views_ui_preprocess_views_view\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:27:\"template_process_views_view\";i:2;s:11:\"rdf_process\";}}s:23:\"eva_display_entity_view\";a:10:{s:7:\"pattern\";s:25:\"eva_display_entity_view__\";s:4:\"file\";s:13:\"eva.views.inc\";s:4:\"path\";s:29:\"sites/all/modules/contrib/eva\";s:9:\"variables\";a:2:{s:10:\"view_array\";a:0:{}s:4:\"view\";N;}s:8:\"template\";s:23:\"eva-display-entity-view\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:43:\"sites/all/modules/contrib/eva/eva.views.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:43:\"template_preprocess_eva_display_entity_view\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:40:\"template_process_eva_display_entity_view\";i:2;s:11:\"rdf_process\";}}s:15:\"date_navigation\";a:10:{s:7:\"pattern\";s:17:\"date_navigation__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:47:\"sites/all/modules/contrib/date/date_views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:15:\"date-navigation\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/date/date_views/theme/theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:22:\"views_view_unformatted\";a:10:{s:7:\"pattern\";s:24:\"views_view_unformatted__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:22:\"views-view-unformatted\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:42:\"template_preprocess_views_view_unformatted\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:17:\"views_data_export\";a:10:{s:7:\"pattern\";s:19:\"views_data_export__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:17:\"views-data-export\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:37:\"template_preprocess_views_data_export\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_csv_header\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_csv_header__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-csv-header\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_views_data_export_csv_header\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:26:\"views_data_export_csv_body\";a:10:{s:7:\"pattern\";s:28:\"views_data_export_csv_body__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:26:\"views-data-export-csv-body\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:46:\"template_preprocess_views_data_export_csv_body\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_csv_footer\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_csv_footer__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-csv-footer\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_doc_header\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_doc_header__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-doc-header\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_views_data_export_doc_header\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:26:\"views_data_export_doc_body\";a:10:{s:7:\"pattern\";s:28:\"views_data_export_doc_body__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:26:\"views-data-export-doc-body\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:46:\"template_preprocess_views_data_export_doc_body\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_doc_footer\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_doc_footer__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-doc-footer\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_txt_header\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_txt_header__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-txt-header\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:26:\"views_data_export_txt_body\";a:10:{s:7:\"pattern\";s:28:\"views_data_export_txt_body__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:26:\"views-data-export-txt-body\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:46:\"template_preprocess_views_data_export_txt_body\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_txt_footer\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_txt_footer__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-txt-footer\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_xls_header\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_xls_header__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-xls-header\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_views_data_export_xls_header\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:26:\"views_data_export_xls_body\";a:10:{s:7:\"pattern\";s:28:\"views_data_export_xls_body__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:26:\"views-data-export-xls-body\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:46:\"template_preprocess_views_data_export_xls_body\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_xls_footer\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_xls_footer__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-xls-footer\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_xml_header\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_xml_header__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-xml-header\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_views_data_export_xml_header\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:26:\"views_data_export_xml_body\";a:10:{s:7:\"pattern\";s:28:\"views_data_export_xml_body__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:26:\"views-data-export-xml-body\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:46:\"template_preprocess_views_data_export_xml_body\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_xml_footer\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_xml_footer__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-xml-footer\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_views_data_export_xml_footer\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:25:\"views_view_watchdog_table\";a:10:{s:7:\"pattern\";s:27:\"views_view_watchdog_table__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:52:\"sites/all/modules/contrib/views_watchdog/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:25:\"views-view-watchdog-table\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:62:\"sites/all/modules/contrib/views_watchdog/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:45:\"template_preprocess_views_view_watchdog_table\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:15:\"views_view_list\";a:10:{s:7:\"pattern\";s:17:\"views_view_list__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:15:\"views-view-list\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:35:\"template_preprocess_views_view_list\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:15:\"views_view_grid\";a:10:{s:7:\"pattern\";s:17:\"views_view_grid__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:15:\"views-view-grid\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:35:\"template_preprocess_views_view_grid\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:16:\"views_view_table\";a:10:{s:7:\"pattern\";s:18:\"views_view_table__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:16:\"views-view-table\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_views_view_table\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:18:\"views_view_summary\";a:10:{s:7:\"pattern\";s:20:\"views_view_summary__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:18:\"views-view-summary\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:38:\"template_preprocess_views_view_summary\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:30:\"views_view_summary_unformatted\";a:10:{s:7:\"pattern\";s:32:\"views_view_summary_unformatted__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:30:\"views-view-summary-unformatted\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:50:\"template_preprocess_views_view_summary_unformatted\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:14:\"views_view_rss\";a:10:{s:7:\"pattern\";s:16:\"views_view_rss__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:14:\"views-view-rss\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:34:\"template_preprocess_views_view_rss\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_view_summary_jump_menu\";a:10:{s:7:\"pattern\";s:30:\"views_view_summary_jump_menu__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-view-summary-jump-menu\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:20:\"views_view_jump_menu\";a:10:{s:7:\"pattern\";s:22:\"views_view_jump_menu__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:20:\"views-view-jump-menu\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:22:\"views_view_row_comment\";a:10:{s:7:\"pattern\";s:24:\"views_view_row_comment__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:3:\"row\";N;s:11:\"field_alias\";N;}s:8:\"template\";s:22:\"views-view-row-comment\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:42:\"template_preprocess_views_view_row_comment\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:18:\"views_view_row_rss\";a:10:{s:7:\"pattern\";s:20:\"views_view_row_rss__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:3:\"row\";N;s:11:\"field_alias\";N;}s:8:\"template\";s:18:\"views-view-row-rss\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:38:\"template_preprocess_views_view_row_rss\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:17:\"views_view_fields\";a:10:{s:7:\"pattern\";s:19:\"views_view_fields__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:3:\"row\";N;s:11:\"field_alias\";N;}s:8:\"template\";s:17:\"views-view-fields\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:37:\"template_preprocess_views_view_fields\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:21:\"views_form_views_form\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:27:\"theme_views_form_views_form\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}}s:18:\"views_exposed_form\";a:10:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:8:\"template\";s:18:\"views-exposed-form\";s:7:\"pattern\";s:20:\"views_exposed_form__\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:38:\"template_preprocess_views_exposed_form\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:10:\"views_more\";a:10:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:8:\"template\";s:10:\"views-more\";s:7:\"pattern\";s:12:\"views_more__\";s:9:\"variables\";a:3:{s:8:\"more_url\";N;s:9:\"link_text\";s:4:\"more\";s:4:\"view\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:15:\"horizontal_tabs\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/field_group\";s:8:\"function\";s:21:\"theme_horizontal_tabs\";}s:9:\"multipage\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/field_group\";s:8:\"function\";s:15:\"theme_multipage\";}s:14:\"multipage_pane\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/field_group\";s:8:\"function\";s:20:\"theme_multipage_pane\";}s:28:\"views_ui_display_tab_setting\";a:7:{s:9:\"variables\";a:7:{s:11:\"description\";s:0:\"\";s:4:\"link\";s:0:\"\";s:14:\"settings_links\";a:0:{}s:10:\"overridden\";b:0;s:9:\"defaulted\";b:0;s:21:\"description_separator\";b:1;s:5:\"class\";a:0:{}}s:8:\"template\";s:28:\"views-ui-display-tab-setting\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_views_ui_display_tab_setting\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:27:\"views_ui_display_tab_bucket\";a:7:{s:14:\"render element\";s:7:\"element\";s:8:\"template\";s:27:\"views-ui-display-tab-bucket\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:47:\"template_preprocess_views_ui_display_tab_bucket\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:18:\"views_ui_edit_item\";a:7:{s:9:\"variables\";a:4:{s:4:\"type\";N;s:4:\"view\";N;s:7:\"display\";N;s:9:\"no_fields\";b:0;}s:8:\"template\";s:18:\"views-ui-edit-item\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:23:\"views_ui_rearrange_form\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:29:\"theme_views_ui_rearrange_form\";}s:30:\"views_ui_rearrange_filter_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:36:\"theme_views_ui_rearrange_filter_form\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/contrib/views/includes/admin.inc\";}}s:27:\"views_ui_expose_filter_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:33:\"theme_views_ui_expose_filter_form\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/contrib/views/includes/admin.inc\";}}s:18:\"views_ui_view_info\";a:6:{s:9:\"variables\";a:2:{s:4:\"view\";N;s:4:\"base\";N;}s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:24:\"theme_views_ui_view_info\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/contrib/views/includes/admin.inc\";}}s:32:\"views_ui_build_group_filter_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:38:\"theme_views_ui_build_group_filter_form\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/contrib/views/includes/admin.inc\";}}s:12:\"views_tabset\";a:4:{s:9:\"variables\";a:1:{s:4:\"tabs\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:18:\"theme_views_tabset\";}s:9:\"views_tab\";a:4:{s:9:\"variables\";a:1:{s:4:\"body\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:15:\"theme_views_tab\";}s:30:\"views_ui_reorder_displays_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:36:\"theme_views_ui_reorder_displays_form\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/contrib/views/includes/admin.inc\";}}s:27:\"views_ui_style_plugin_table\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:33:\"theme_views_ui_style_plugin_table\";}s:29:\"views_ui_view_preview_section\";a:5:{s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"section\";N;s:7:\"content\";N;s:5:\"links\";s:0:\"\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:35:\"theme_views_ui_view_preview_section\";s:20:\"preprocess functions\";a:1:{i:0;s:49:\"template_preprocess_views_ui_view_preview_section\";}}s:15:\"views_container\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:15:\"theme/theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:21:\"theme_views_container\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}}s:27:\"views_data_export_feed_icon\";a:7:{s:7:\"pattern\";s:29:\"views_data_export_feed_icon__\";s:9:\"variables\";a:4:{s:10:\"image_path\";N;s:3:\"url\";N;s:5:\"query\";s:0:\"\";s:4:\"text\";s:0:\"\";}s:4:\"file\";s:33:\"theme/views_data_export.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/views_data_export\";s:8:\"function\";s:33:\"theme_views_data_export_feed_icon\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}}s:31:\"views_data_export_complete_page\";a:6:{s:9:\"variables\";a:3:{s:4:\"file\";s:0:\"\";s:6:\"errors\";a:0:{}s:10:\"return_url\";s:0:\"\";}s:4:\"file\";s:33:\"theme/views_data_export.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/views_data_export\";s:8:\"function\";s:37:\"theme_views_data_export_complete_page\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}}s:25:\"views_data_export_message\";a:6:{s:9:\"variables\";a:2:{s:7:\"message\";s:0:\"\";s:4:\"type\";s:4:\"info\";}s:4:\"file\";s:33:\"theme/views_data_export.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/views_data_export\";s:8:\"function\";s:31:\"theme_views_data_export_message\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}}s:12:\"user_picture\";a:6:{s:9:\"variables\";a:1:{s:7:\"account\";N;}s:8:\"template\";s:25:\"modules/user/user-picture\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:32:\"template_preprocess_user_picture\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:12:\"user_profile\";a:8:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:25:\"modules/user/user-profile\";s:4:\"file\";s:14:\"user.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.pages.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:32:\"template_preprocess_user_profile\";i:2;s:27:\"rdf_preprocess_user_profile\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:21:\"user_profile_category\";a:8:{s:14:\"render element\";s:7:\"element\";s:8:\"template\";s:34:\"modules/user/user-profile-category\";s:4:\"file\";s:14:\"user.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.pages.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:41:\"template_preprocess_user_profile_category\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:17:\"user_profile_item\";a:8:{s:14:\"render element\";s:7:\"element\";s:8:\"template\";s:30:\"modules/user/user-profile-item\";s:4:\"file\";s:14:\"user.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.pages.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:37:\"template_preprocess_user_profile_item\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:9:\"user_list\";a:4:{s:9:\"variables\";a:2:{s:5:\"users\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:15:\"theme_user_list\";}s:22:\"user_admin_permissions\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:14:\"user.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:28:\"theme_user_admin_permissions\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.admin.inc\";}}s:16:\"user_admin_roles\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:14:\"user.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:22:\"theme_user_admin_roles\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.admin.inc\";}}s:27:\"user_permission_description\";a:6:{s:9:\"variables\";a:2:{s:15:\"permission_item\";N;s:4:\"hide\";N;}s:4:\"file\";s:14:\"user.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:33:\"theme_user_permission_description\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.admin.inc\";}}s:14:\"user_signature\";a:4:{s:9:\"variables\";a:1:{s:9:\"signature\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:20:\"theme_user_signature\";}s:10:\"tree_table\";a:6:{s:9:\"variables\";a:5:{s:6:\"header\";a:0:{}s:4:\"rows\";a:0:{}s:10:\"attributes\";a:0:{}s:5:\"empty\";s:0:\"\";s:7:\"caption\";s:0:\"\";}s:4:\"file\";s:15:\"token.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/token\";s:8:\"function\";s:16:\"theme_tree_table\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/token/token.pages.inc\";}}s:10:\"token_tree\";a:6:{s:9:\"variables\";a:6:{s:11:\"token_types\";a:0:{}s:12:\"global_types\";b:1;s:12:\"click_insert\";b:1;s:15:\"show_restricted\";b:0;s:15:\"recursion_limit\";i:3;s:6:\"dialog\";b:0;}s:4:\"file\";s:15:\"token.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/token\";s:8:\"function\";s:16:\"theme_token_tree\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/token/token.pages.inc\";}}s:15:\"token_tree_link\";a:6:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:7:\"options\";a:0:{}s:6:\"dialog\";b:1;}s:4:\"file\";s:15:\"token.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/token\";s:8:\"function\";s:21:\"theme_token_tree_link\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/token/token.pages.inc\";}}s:30:\"taxonomy_overview_vocabularies\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/taxonomy\";s:8:\"function\";s:36:\"theme_taxonomy_overview_vocabularies\";}s:23:\"taxonomy_overview_terms\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/taxonomy\";s:8:\"function\";s:29:\"theme_taxonomy_overview_terms\";}s:13:\"taxonomy_term\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:30:\"modules/taxonomy/taxonomy-term\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/taxonomy\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:33:\"template_preprocess_taxonomy_term\";i:2;s:28:\"rdf_preprocess_taxonomy_term\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:4:\"html\";a:6:{s:14:\"render element\";s:4:\"page\";s:8:\"template\";s:19:\"modules/system/html\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"themes/seven\";s:20:\"preprocess functions\";a:5:{i:0;s:19:\"template_preprocess\";i:1;s:24:\"template_preprocess_html\";i:2;s:22:\"panels_preprocess_html\";i:3;s:21:\"views_preprocess_html\";i:4;s:21:\"seven_preprocess_html\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:21:\"template_process_html\";i:2;s:11:\"rdf_process\";}}s:6:\"region\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:21:\"modules/system/region\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:26:\"template_preprocess_region\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:15:\"status_messages\";a:4:{s:9:\"variables\";a:1:{s:7:\"display\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:21:\"theme_status_messages\";}s:4:\"link\";a:4:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:4:\"path\";N;s:7:\"options\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_link\";}s:5:\"links\";a:4:{s:9:\"variables\";a:3:{s:5:\"links\";N;s:10:\"attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:5:\"links\";}}s:7:\"heading\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_links\";}s:5:\"image\";a:5:{s:9:\"variables\";a:6:{s:4:\"path\";N;s:5:\"width\";N;s:6:\"height\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";N;s:10:\"attributes\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_image\";s:20:\"preprocess functions\";a:1:{i:0;s:20:\"rdf_preprocess_image\";}}s:10:\"breadcrumb\";a:4:{s:9:\"variables\";a:1:{s:10:\"breadcrumb\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_breadcrumb\";}s:4:\"help\";a:4:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_help\";}s:5:\"table\";a:4:{s:9:\"variables\";a:7:{s:6:\"header\";N;s:4:\"rows\";N;s:10:\"attributes\";a:0:{}s:7:\"caption\";N;s:9:\"colgroups\";a:0:{}s:6:\"sticky\";b:1;s:5:\"empty\";s:0:\"\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_table\";}s:4:\"mark\";a:4:{s:9:\"variables\";a:1:{s:4:\"type\";i:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_mark\";}s:9:\"item_list\";a:4:{s:9:\"variables\";a:4:{s:5:\"items\";a:0:{}s:5:\"title\";N;s:4:\"type\";s:2:\"ul\";s:10:\"attributes\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_item_list\";}s:14:\"more_help_link\";a:4:{s:9:\"variables\";a:1:{s:3:\"url\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:20:\"theme_more_help_link\";}s:9:\"feed_icon\";a:4:{s:9:\"variables\";a:2:{s:3:\"url\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_feed_icon\";}s:9:\"more_link\";a:4:{s:9:\"variables\";a:2:{s:3:\"url\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_more_link\";}s:8:\"username\";a:6:{s:9:\"variables\";a:1:{s:7:\"account\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_username\";s:20:\"preprocess functions\";a:2:{i:0;s:28:\"template_preprocess_username\";i:1;s:23:\"rdf_preprocess_username\";}s:17:\"process functions\";a:1:{i:0;s:25:\"template_process_username\";}}s:12:\"progress_bar\";a:4:{s:9:\"variables\";a:2:{s:7:\"percent\";N;s:7:\"message\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_progress_bar\";}s:11:\"indentation\";a:4:{s:9:\"variables\";a:1:{s:4:\"size\";i:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_indentation\";}s:8:\"html_tag\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_html_tag\";}s:11:\"update_page\";a:4:{s:9:\"variables\";a:2:{s:7:\"content\";N;s:13:\"show_messages\";b:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_update_page\";}s:12:\"install_page\";a:4:{s:9:\"variables\";a:1:{s:7:\"content\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_install_page\";}s:9:\"task_list\";a:4:{s:9:\"variables\";a:2:{s:5:\"items\";N;s:6:\"active\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_task_list\";}s:17:\"authorize_message\";a:4:{s:9:\"variables\";a:2:{s:7:\"message\";N;s:7:\"success\";b:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:23:\"theme_authorize_message\";}s:16:\"authorize_report\";a:4:{s:9:\"variables\";a:1:{s:8:\"messages\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:22:\"theme_authorize_report\";}s:5:\"pager\";a:4:{s:9:\"variables\";a:4:{s:4:\"tags\";a:0:{}s:7:\"element\";i:0;s:10:\"parameters\";a:0:{}s:8:\"quantity\";i:9;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_pager\";}s:11:\"pager_first\";a:4:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:7:\"element\";i:0;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_pager_first\";}s:14:\"pager_previous\";a:4:{s:9:\"variables\";a:4:{s:4:\"text\";N;s:7:\"element\";i:0;s:8:\"interval\";i:1;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:20:\"theme_pager_previous\";}s:10:\"pager_next\";a:4:{s:9:\"variables\";a:4:{s:4:\"text\";N;s:7:\"element\";i:0;s:8:\"interval\";i:1;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_pager_next\";}s:10:\"pager_last\";a:4:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:7:\"element\";i:0;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_pager_last\";}s:10:\"pager_link\";a:4:{s:9:\"variables\";a:5:{s:4:\"text\";N;s:8:\"page_new\";N;s:7:\"element\";N;s:10:\"parameters\";a:0:{}s:10:\"attributes\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_pager_link\";}s:9:\"menu_link\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_menu_link\";}s:9:\"menu_tree\";a:5:{s:14:\"render element\";s:4:\"tree\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_menu_tree\";s:20:\"preprocess functions\";a:1:{i:0;s:29:\"template_preprocess_menu_tree\";}}s:15:\"menu_local_task\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:21:\"theme_menu_local_task\";}s:17:\"menu_local_action\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:23:\"theme_menu_local_action\";}s:16:\"menu_local_tasks\";a:4:{s:9:\"variables\";a:2:{s:7:\"primary\";a:0:{}s:9:\"secondary\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:22:\"theme_menu_local_tasks\";}s:6:\"select\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_select\";}s:8:\"fieldset\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_fieldset\";}s:5:\"radio\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_radio\";}s:6:\"radios\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_radios\";}s:4:\"date\";a:5:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_date\";s:8:\"includes\";a:1:{i:0;s:41:\"sites/all/modules/contrib/date/date.theme\";}}s:15:\"exposed_filters\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:21:\"theme_exposed_filters\";}s:8:\"checkbox\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_checkbox\";}s:10:\"checkboxes\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_checkboxes\";}s:6:\"button\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_button\";}s:12:\"image_button\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_image_button\";}s:6:\"hidden\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_hidden\";}s:9:\"textfield\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_textfield\";}s:4:\"form\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_form\";}s:8:\"textarea\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_textarea\";}s:8:\"password\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_password\";}s:4:\"file\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_file\";}s:11:\"tableselect\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_tableselect\";}s:12:\"form_element\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_form_element\";}s:20:\"form_required_marker\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:26:\"theme_form_required_marker\";}s:18:\"form_element_label\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:24:\"theme_form_element_label\";}s:13:\"vertical_tabs\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:19:\"theme_vertical_tabs\";}s:9:\"container\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_container\";}s:18:\"system_themes_page\";a:6:{s:9:\"variables\";a:1:{s:12:\"theme_groups\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:24:\"theme_system_themes_page\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:20:\"system_settings_form\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:26:\"theme_system_settings_form\";}s:12:\"confirm_form\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_confirm_form\";}s:23:\"system_modules_fieldset\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:29:\"theme_system_modules_fieldset\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:27:\"system_modules_incompatible\";a:6:{s:9:\"variables\";a:1:{s:7:\"message\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:33:\"theme_system_modules_incompatible\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:24:\"system_modules_uninstall\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:30:\"theme_system_modules_uninstall\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:13:\"status_report\";a:6:{s:14:\"render element\";s:12:\"requirements\";s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:19:\"theme_status_report\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:10:\"admin_page\";a:6:{s:9:\"variables\";a:1:{s:6:\"blocks\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_admin_page\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:11:\"admin_block\";a:6:{s:9:\"variables\";a:1:{s:5:\"block\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_admin_block\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:18:\"system_admin_index\";a:6:{s:9:\"variables\";a:1:{s:10:\"menu_items\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:24:\"theme_system_admin_index\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:17:\"system_powered_by\";a:4:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:23:\"theme_system_powered_by\";}s:19:\"system_compact_link\";a:4:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:25:\"theme_system_compact_link\";}s:25:\"system_date_time_settings\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:31:\"theme_system_date_time_settings\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:22:\"shortcut_set_customize\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"shortcut.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/shortcut\";s:8:\"function\";s:28:\"theme_shortcut_set_customize\";s:8:\"includes\";a:1:{i:0;s:35:\"modules/shortcut/shortcut.admin.inc\";}}s:23:\"search_api_page_results\";a:7:{s:9:\"variables\";a:5:{s:5:\"index\";N;s:7:\"results\";a:1:{s:12:\"result count\";i:0;}s:5:\"items\";a:0:{}s:9:\"view_mode\";s:22:\"search_api_page_result\";s:4:\"keys\";s:0:\"\";}s:4:\"file\";s:25:\"search_api_page.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:41:\"sites/all/modules/contrib/search_api_page\";s:8:\"function\";s:29:\"theme_search_api_page_results\";s:8:\"includes\";a:1:{i:0;s:67:\"sites/all/modules/contrib/search_api_page/search_api_page.pages.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:43:\"template_preprocess_search_api_page_results\";}}s:22:\"search_api_page_result\";a:6:{s:9:\"variables\";a:4:{s:5:\"index\";N;s:6:\"result\";N;s:4:\"item\";N;s:4:\"keys\";s:0:\"\";}s:4:\"file\";s:25:\"search_api_page.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:41:\"sites/all/modules/contrib/search_api_page\";s:8:\"function\";s:28:\"theme_search_api_page_result\";s:8:\"includes\";a:1:{i:0;s:67:\"sites/all/modules/contrib/search_api_page/search_api_page.pages.inc\";}}s:17:\"search_api_server\";a:6:{s:9:\"variables\";a:9:{s:2:\"id\";N;s:4:\"name\";s:0:\"\";s:12:\"machine_name\";s:0:\"\";s:11:\"description\";N;s:7:\"enabled\";N;s:10:\"class_name\";N;s:17:\"class_description\";N;s:7:\"options\";a:0:{}s:6:\"status\";i:1;}s:4:\"file\";s:20:\"search_api.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:36:\"sites/all/modules/contrib/search_api\";s:8:\"function\";s:23:\"theme_search_api_server\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/search_api/search_api.admin.inc\";}}s:16:\"search_api_index\";a:6:{s:9:\"variables\";a:13:{s:2:\"id\";N;s:4:\"name\";s:0:\"\";s:12:\"machine_name\";s:0:\"\";s:11:\"description\";N;s:9:\"item_type\";N;s:7:\"enabled\";N;s:6:\"server\";N;s:7:\"options\";a:0:{}s:6:\"fields\";a:0:{}s:13:\"indexed_items\";i:0;s:11:\"total_items\";i:0;s:6:\"status\";i:1;s:9:\"read_only\";i:0;}s:4:\"file\";s:20:\"search_api.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:36:\"sites/all/modules/contrib/search_api\";s:8:\"function\";s:22:\"theme_search_api_index\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/search_api/search_api.admin.inc\";}}s:27:\"search_api_admin_item_order\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:20:\"search_api.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:36:\"sites/all/modules/contrib/search_api\";s:8:\"function\";s:33:\"theme_search_api_admin_item_order\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/search_api/search_api.admin.inc\";}}s:29:\"search_api_admin_fields_table\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:20:\"search_api.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:36:\"sites/all/modules/contrib/search_api\";s:8:\"function\";s:35:\"theme_search_api_admin_fields_table\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/search_api/search_api.admin.inc\";}}s:17:\"search_block_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:8:\"template\";s:32:\"modules/search/search-block-form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/search\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:37:\"template_preprocess_search_block_form\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:13:\"search_result\";a:8:{s:9:\"variables\";a:2:{s:6:\"result\";N;s:6:\"module\";N;}s:4:\"file\";s:16:\"search.pages.inc\";s:8:\"template\";s:28:\"modules/search/search-result\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/search\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/search/search.pages.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:33:\"template_preprocess_search_result\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:14:\"search_results\";a:8:{s:9:\"variables\";a:2:{s:7:\"results\";N;s:6:\"module\";N;}s:4:\"file\";s:16:\"search.pages.inc\";s:8:\"template\";s:29:\"modules/search/search-results\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/search\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/search/search.pages.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:34:\"template_preprocess_search_results\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:29:\"rdf_template_variable_wrapper\";a:4:{s:9:\"variables\";a:4:{s:7:\"content\";N;s:10:\"attributes\";a:0:{}s:7:\"context\";a:0:{}s:6:\"inline\";b:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:11:\"modules/rdf\";s:8:\"function\";s:35:\"theme_rdf_template_variable_wrapper\";}s:12:\"rdf_metadata\";a:4:{s:9:\"variables\";a:1:{s:8:\"metadata\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:11:\"modules/rdf\";s:8:\"function\";s:18:\"theme_rdf_metadata\";}s:17:\"r4032login_denied\";a:4:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:36:\"sites/all/modules/contrib/r4032login\";s:8:\"function\";s:23:\"theme_r4032login_denied\";}s:23:\"panels_ipe_pane_wrapper\";a:4:{s:9:\"variables\";a:4:{s:6:\"output\";N;s:4:\"pane\";N;s:7:\"display\";N;s:8:\"renderer\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/panels/panels_ipe\";s:8:\"function\";s:29:\"theme_panels_ipe_pane_wrapper\";}s:25:\"panels_ipe_region_wrapper\";a:4:{s:9:\"variables\";a:5:{s:6:\"output\";N;s:9:\"region_id\";N;s:7:\"display\";N;s:8:\"controls\";N;s:8:\"renderer\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/panels/panels_ipe\";s:8:\"function\";s:31:\"theme_panels_ipe_region_wrapper\";}s:26:\"panels_ipe_add_pane_button\";a:4:{s:9:\"variables\";a:3:{s:9:\"region_id\";N;s:7:\"display\";N;s:8:\"renderer\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/panels/panels_ipe\";s:8:\"function\";s:32:\"theme_panels_ipe_add_pane_button\";}s:27:\"panels_ipe_placeholder_pane\";a:4:{s:9:\"variables\";a:2:{s:9:\"region_id\";N;s:12:\"region_title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/panels/panels_ipe\";s:8:\"function\";s:33:\"theme_panels_ipe_placeholder_pane\";}s:29:\"panels_ipe_dnd_form_container\";a:4:{s:9:\"variables\";a:3:{s:4:\"link\";N;s:9:\"cache_key\";N;s:7:\"display\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/panels/panels_ipe\";s:8:\"function\";s:35:\"theme_panels_ipe_dnd_form_container\";}s:18:\"panels_ipe_toolbar\";a:4:{s:9:\"variables\";a:1:{s:7:\"buttons\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/panels/panels_ipe\";s:8:\"function\";s:24:\"theme_panels_ipe_toolbar\";}s:18:\"panels_layout_link\";a:4:{s:9:\"variables\";a:5:{s:5:\"title\";N;s:2:\"id\";N;s:5:\"image\";N;s:4:\"link\";N;s:5:\"class\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:24:\"theme_panels_layout_link\";}s:18:\"panels_layout_icon\";a:4:{s:9:\"variables\";a:3:{s:2:\"id\";N;s:5:\"image\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:24:\"theme_panels_layout_icon\";}s:11:\"panels_pane\";a:7:{s:9:\"variables\";a:3:{s:6:\"output\";a:0:{}s:4:\"pane\";a:0:{}s:7:\"display\";a:0:{}}s:4:\"path\";s:42:\"sites/all/modules/contrib/panels/templates\";s:8:\"template\";s:11:\"panels-pane\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:31:\"template_preprocess_panels_pane\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:26:\"panels_common_content_list\";a:6:{s:9:\"variables\";a:1:{s:7:\"display\";N;}s:4:\"file\";s:19:\"includes/common.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:32:\"theme_panels_common_content_list\";s:8:\"includes\";a:1:{i:0;s:52:\"sites/all/modules/contrib/panels/includes/common.inc\";}}s:26:\"panels_render_display_form\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:32:\"theme_panels_render_display_form\";}s:16:\"panels_dashboard\";a:9:{s:9:\"variables\";a:0:{}s:4:\"path\";s:42:\"sites/all/modules/contrib/panels/templates\";s:4:\"file\";s:25:\"../includes/callbacks.inc\";s:8:\"template\";s:16:\"panels-dashboard\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:68:\"sites/all/modules/contrib/panels/templates/../includes/callbacks.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_panels_dashboard\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:21:\"panels_dashboard_link\";a:9:{s:9:\"variables\";a:1:{s:4:\"link\";a:0:{}}s:4:\"path\";s:42:\"sites/all/modules/contrib/panels/templates\";s:4:\"file\";s:25:\"../includes/callbacks.inc\";s:8:\"template\";s:21:\"panels-dashboard-link\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:68:\"sites/all/modules/contrib/panels/templates/../includes/callbacks.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:22:\"panels_dashboard_block\";a:9:{s:9:\"variables\";a:1:{s:5:\"block\";a:0:{}}s:4:\"path\";s:42:\"sites/all/modules/contrib/panels/templates\";s:4:\"file\";s:25:\"../includes/callbacks.inc\";s:8:\"template\";s:22:\"panels-dashboard-block\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:68:\"sites/all/modules/contrib/panels/templates/../includes/callbacks.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:24:\"panels_add_content_modal\";a:9:{s:9:\"variables\";a:5:{s:8:\"renderer\";N;s:10:\"categories\";a:0:{}s:6:\"region\";N;s:8:\"category\";N;s:12:\"column_count\";i:2;}s:4:\"path\";s:42:\"sites/all/modules/contrib/panels/templates\";s:4:\"file\";s:27:\"../includes/add-content.inc\";s:8:\"template\";s:24:\"panels-add-content-modal\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:70:\"sites/all/modules/contrib/panels/templates/../includes/add-content.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:44:\"template_preprocess_panels_add_content_modal\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:41:\"template_process_panels_add_content_modal\";i:2;s:11:\"rdf_process\";}}s:23:\"panels_add_content_link\";a:9:{s:9:\"variables\";a:3:{s:8:\"renderer\";N;s:6:\"region\";N;s:12:\"content_type\";N;}s:4:\"path\";s:42:\"sites/all/modules/contrib/panels/templates\";s:4:\"file\";s:27:\"../includes/add-content.inc\";s:8:\"template\";s:23:\"panels-add-content-link\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:70:\"sites/all/modules/contrib/panels/templates/../includes/add-content.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:43:\"template_preprocess_panels_add_content_link\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:15:\"panels_flexible\";a:7:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:57:\"sites/all/modules/contrib/panels/plugins/layouts/flexible\";s:4:\"file\";s:12:\"flexible.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:21:\"theme_panels_flexible\";s:8:\"includes\";a:1:{i:0;s:70:\"sites/all/modules/contrib/panels/plugins/layouts/flexible/flexible.inc\";}}s:21:\"panels_flexible_admin\";a:7:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:57:\"sites/all/modules/contrib/panels/plugins/layouts/flexible\";s:4:\"file\";s:12:\"flexible.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:27:\"theme_panels_flexible_admin\";s:8:\"includes\";a:1:{i:0;s:70:\"sites/all/modules/contrib/panels/plugins/layouts/flexible/flexible.inc\";}}s:24:\"panels_threecol_33_34_33\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:66:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_33_34_33\";s:4:\"file\";s:21:\"threecol_33_34_33.inc\";s:8:\"template\";s:24:\"panels-threecol-33-34-33\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:88:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_33_34_33/threecol_33_34_33.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:13:\"panels_onecol\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:55:\"sites/all/modules/contrib/panels/plugins/layouts/onecol\";s:4:\"file\";s:10:\"onecol.inc\";s:8:\"template\";s:13:\"panels-onecol\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:66:\"sites/all/modules/contrib/panels/plugins/layouts/onecol/onecol.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:24:\"panels_threecol_25_50_25\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:66:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_25_50_25\";s:4:\"file\";s:21:\"threecol_25_50_25.inc\";s:8:\"template\";s:24:\"panels-threecol-25-50-25\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:88:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_25_50_25/threecol_25_50_25.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:32:\"panels_threecol_25_50_25_stacked\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:74:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_25_50_25_stacked\";s:4:\"file\";s:29:\"threecol_25_50_25_stacked.inc\";s:8:\"template\";s:32:\"panels-threecol-25-50-25-stacked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:104:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_25_50_25_stacked/threecol_25_50_25_stacked.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:20:\"panels_twocol_bricks\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:62:\"sites/all/modules/contrib/panels/plugins/layouts/twocol_bricks\";s:4:\"file\";s:17:\"twocol_bricks.inc\";s:8:\"template\";s:20:\"panels-twocol-bricks\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:80:\"sites/all/modules/contrib/panels/plugins/layouts/twocol_bricks/twocol_bricks.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:32:\"panels_threecol_33_34_33_stacked\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:74:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_33_34_33_stacked\";s:4:\"file\";s:29:\"threecol_33_34_33_stacked.inc\";s:8:\"template\";s:32:\"panels-threecol-33-34-33-stacked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:104:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_33_34_33_stacked/threecol_33_34_33_stacked.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:21:\"panels_twocol_stacked\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:63:\"sites/all/modules/contrib/panels/plugins/layouts/twocol_stacked\";s:4:\"file\";s:18:\"twocol_stacked.inc\";s:8:\"template\";s:21:\"panels-twocol-stacked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:82:\"sites/all/modules/contrib/panels/plugins/layouts/twocol_stacked/twocol_stacked.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:13:\"panels_twocol\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:55:\"sites/all/modules/contrib/panels/plugins/layouts/twocol\";s:4:\"file\";s:10:\"twocol.inc\";s:8:\"template\";s:13:\"panels-twocol\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:66:\"sites/all/modules/contrib/panels/plugins/layouts/twocol/twocol.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:40:\"panels_rounded_corners_style_render_pane\";a:7:{s:9:\"variables\";a:5:{s:7:\"content\";N;s:4:\"pane\";N;s:7:\"display\";N;s:5:\"style\";N;s:8:\"settings\";N;}s:4:\"path\";s:55:\"sites/all/modules/contrib/panels/plugins/styles/corners\";s:4:\"file\";s:19:\"rounded_corners.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:46:\"theme_panels_rounded_corners_style_render_pane\";s:8:\"includes\";a:1:{i:0;s:75:\"sites/all/modules/contrib/panels/plugins/styles/corners/rounded_corners.inc\";}}s:42:\"panels_rounded_corners_style_render_region\";a:7:{s:9:\"variables\";a:6:{s:7:\"display\";N;s:8:\"owner_id\";N;s:5:\"panes\";N;s:8:\"settings\";N;s:9:\"region_id\";N;s:5:\"style\";N;}s:4:\"path\";s:55:\"sites/all/modules/contrib/panels/plugins/styles/corners\";s:4:\"file\";s:19:\"rounded_corners.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:48:\"theme_panels_rounded_corners_style_render_region\";s:8:\"includes\";a:1:{i:0;s:75:\"sites/all/modules/contrib/panels/plugins/styles/corners/rounded_corners.inc\";}}s:26:\"panels_rounded_corners_box\";a:7:{s:9:\"variables\";a:1:{s:7:\"content\";N;}s:4:\"path\";s:55:\"sites/all/modules/contrib/panels/plugins/styles/corners\";s:8:\"template\";s:26:\"panels-rounded-corners-box\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:30:\"panels_block_style_render_pane\";a:7:{s:9:\"variables\";a:5:{s:7:\"content\";N;s:4:\"pane\";N;s:7:\"display\";N;s:5:\"style\";N;s:8:\"settings\";N;}s:4:\"path\";s:47:\"sites/all/modules/contrib/panels/plugins/styles\";s:4:\"file\";s:9:\"block.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:36:\"theme_panels_block_style_render_pane\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/panels/plugins/styles/block.inc\";}}s:34:\"panels_default_style_render_region\";a:7:{s:9:\"variables\";a:6:{s:7:\"display\";N;s:8:\"owner_id\";N;s:5:\"panes\";N;s:8:\"settings\";N;s:9:\"region_id\";N;s:5:\"style\";N;}s:4:\"path\";s:47:\"sites/all/modules/contrib/panels/plugins/styles\";s:4:\"file\";s:11:\"default.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:40:\"theme_panels_default_style_render_region\";s:8:\"includes\";a:1:{i:0;s:59:\"sites/all/modules/contrib/panels/plugins/styles/default.inc\";}}s:30:\"panels_naked_style_render_pane\";a:7:{s:9:\"variables\";a:5:{s:7:\"content\";N;s:4:\"pane\";N;s:7:\"display\";N;s:5:\"style\";N;s:8:\"settings\";N;}s:4:\"path\";s:47:\"sites/all/modules/contrib/panels/plugins/styles\";s:4:\"file\";s:9:\"naked.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:36:\"theme_panels_naked_style_render_pane\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/panels/plugins/styles/naked.inc\";}}s:32:\"panels_naked_style_render_region\";a:7:{s:9:\"variables\";a:6:{s:7:\"display\";N;s:8:\"owner_id\";N;s:5:\"panes\";N;s:8:\"settings\";N;s:9:\"region_id\";N;s:5:\"style\";N;}s:4:\"path\";s:47:\"sites/all/modules/contrib/panels/plugins/styles\";s:4:\"file\";s:9:\"naked.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:38:\"theme_panels_naked_style_render_region\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/panels/plugins/styles/naked.inc\";}}s:31:\"panels_list_style_render_region\";a:7:{s:9:\"variables\";a:6:{s:7:\"display\";N;s:8:\"owner_id\";N;s:5:\"panes\";N;s:8:\"settings\";N;s:9:\"region_id\";N;s:5:\"style\";N;}s:4:\"path\";s:47:\"sites/all/modules/contrib/panels/plugins/styles\";s:4:\"file\";s:8:\"list.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:37:\"theme_panels_list_style_render_region\";s:8:\"includes\";a:1:{i:0;s:56:\"sites/all/modules/contrib/panels/plugins/styles/list.inc\";}}s:12:\"options_none\";a:4:{s:9:\"variables\";a:2:{s:8:\"instance\";N;s:6:\"option\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:29:\"modules/field/modules/options\";s:8:\"function\";s:18:\"theme_options_none\";}s:4:\"node\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:17:\"modules/node/node\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:20:\"preprocess functions\";a:6:{i:0;s:19:\"template_preprocess\";i:1;s:24:\"template_preprocess_node\";i:2;s:22:\"ctools_preprocess_node\";i:3;s:30:\"node_reference_preprocess_node\";i:4;s:19:\"rdf_preprocess_node\";i:5;s:21:\"views_preprocess_node\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:17:\"node_search_admin\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:23:\"theme_node_search_admin\";}s:12:\"node_preview\";a:6:{s:9:\"variables\";a:1:{s:4:\"node\";N;}s:4:\"file\";s:14:\"node.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:18:\"theme_node_preview\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/node/node.pages.inc\";}}s:19:\"node_admin_overview\";a:4:{s:9:\"variables\";a:2:{s:4:\"name\";N;s:4:\"type\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:25:\"theme_node_admin_overview\";}s:17:\"node_recent_block\";a:4:{s:9:\"variables\";a:1:{s:5:\"nodes\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:23:\"theme_node_recent_block\";}s:19:\"node_recent_content\";a:4:{s:9:\"variables\";a:1:{s:4:\"node\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:25:\"theme_node_recent_content\";}s:28:\"module_filter_system_modules\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:23:\"module_filter.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/module_filter\";s:8:\"function\";s:34:\"theme_module_filter_system_modules\";s:8:\"includes\";a:1:{i:0;s:63:\"sites/all/modules/contrib/module_filter/module_filter.theme.inc\";}}s:27:\"module_filter_modules_table\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:23:\"module_filter.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/module_filter\";s:8:\"function\";s:33:\"theme_module_filter_modules_table\";s:8:\"includes\";a:1:{i:0;s:63:\"sites/all/modules/contrib/module_filter/module_filter.theme.inc\";}}s:33:\"module_filter_system_modules_tabs\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:23:\"module_filter.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/module_filter\";s:8:\"function\";s:39:\"theme_module_filter_system_modules_tabs\";s:8:\"includes\";a:1:{i:0;s:63:\"sites/all/modules/contrib/module_filter/module_filter.theme.inc\";}}s:18:\"menu_overview_form\";a:6:{s:4:\"file\";s:14:\"menu.admin.inc\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/menu\";s:8:\"function\";s:24:\"theme_menu_overview_form\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/menu/menu.admin.inc\";}}s:19:\"menu_admin_overview\";a:6:{s:4:\"file\";s:14:\"menu.admin.inc\";s:9:\"variables\";a:3:{s:5:\"title\";N;s:4:\"name\";N;s:11:\"description\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/menu\";s:8:\"function\";s:25:\"theme_menu_admin_overview\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/menu/menu.admin.inc\";}}s:29:\"login_destination_destination\";a:6:{s:9:\"variables\";a:1:{s:11:\"destination\";N;}s:4:\"file\";s:27:\"login_destination.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/login_destination\";s:8:\"function\";s:35:\"theme_login_destination_destination\";s:8:\"includes\";a:1:{i:0;s:71:\"sites/all/modules/contrib/login_destination/login_destination.admin.inc\";}}s:23:\"login_destination_pages\";a:6:{s:9:\"variables\";a:2:{s:5:\"pages\";N;s:10:\"pages_type\";i:0;}s:4:\"file\";s:27:\"login_destination.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/login_destination\";s:8:\"function\";s:29:\"theme_login_destination_pages\";s:8:\"includes\";a:1:{i:0;s:71:\"sites/all/modules/contrib/login_destination/login_destination.admin.inc\";}}s:26:\"login_destination_triggers\";a:6:{s:9:\"variables\";a:1:{s:5:\"items\";N;}s:4:\"file\";s:27:\"login_destination.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/login_destination\";s:8:\"function\";s:32:\"theme_login_destination_triggers\";s:8:\"includes\";a:1:{i:0;s:71:\"sites/all/modules/contrib/login_destination/login_destination.admin.inc\";}}s:23:\"login_destination_roles\";a:6:{s:9:\"variables\";a:1:{s:5:\"items\";N;}s:4:\"file\";s:27:\"login_destination.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/login_destination\";s:8:\"function\";s:29:\"theme_login_destination_roles\";s:8:\"includes\";a:1:{i:0;s:71:\"sites/all/modules/contrib/login_destination/login_destination.admin.inc\";}}s:17:\"lt_username_title\";a:4:{s:9:\"variables\";a:1:{s:7:\"form_id\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:23:\"theme_lt_username_title\";}s:23:\"lt_username_description\";a:4:{s:9:\"variables\";a:1:{s:7:\"form_id\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:29:\"theme_lt_username_description\";}s:17:\"lt_password_title\";a:4:{s:9:\"variables\";a:1:{s:7:\"form_id\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:23:\"theme_lt_password_title\";}s:23:\"lt_password_description\";a:4:{s:9:\"variables\";a:1:{s:7:\"form_id\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:29:\"theme_lt_password_description\";}s:16:\"lt_access_denied\";a:4:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:22:\"theme_lt_access_denied\";}s:16:\"lt_loggedinblock\";a:4:{s:9:\"variables\";a:1:{s:7:\"account\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:22:\"theme_lt_loggedinblock\";}s:13:\"lt_login_link\";a:4:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:19:\"theme_lt_login_link\";}s:27:\"lt_login_successful_message\";a:4:{s:9:\"variables\";a:1:{s:7:\"account\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:33:\"theme_lt_login_successful_message\";}s:21:\"lt_unified_login_page\";a:4:{s:9:\"variables\";a:3:{s:10:\"login_form\";N;s:13:\"register_form\";N;s:11:\"active_form\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:27:\"theme_lt_unified_login_page\";}s:15:\"transfer_slider\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:42:\"sites/all/modules/contrib/jslider_form_api\";s:8:\"function\";s:21:\"theme_transfer_slider\";}s:21:\"filter_admin_overview\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:16:\"filter.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:27:\"theme_filter_admin_overview\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/filter/filter.admin.inc\";}}s:32:\"filter_admin_format_filter_order\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:16:\"filter.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:38:\"theme_filter_admin_format_filter_order\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/filter/filter.admin.inc\";}}s:11:\"filter_tips\";a:6:{s:9:\"variables\";a:2:{s:4:\"tips\";N;s:4:\"long\";b:0;}s:4:\"file\";s:16:\"filter.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:17:\"theme_filter_tips\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/filter/filter.pages.inc\";}}s:19:\"text_format_wrapper\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:25:\"theme_text_format_wrapper\";}s:21:\"filter_tips_more_info\";a:4:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:27:\"theme_filter_tips_more_info\";}s:17:\"filter_guidelines\";a:4:{s:9:\"variables\";a:1:{s:6:\"format\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:23:\"theme_filter_guidelines\";}s:14:\"field_ui_table\";a:4:{s:14:\"render element\";s:8:\"elements\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/field_ui\";s:8:\"function\";s:20:\"theme_field_ui_table\";}s:5:\"field\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/field\";s:8:\"function\";s:11:\"theme_field\";s:20:\"preprocess functions\";a:2:{i:0;s:25:\"template_preprocess_field\";i:1;s:20:\"rdf_preprocess_field\";}s:17:\"process functions\";a:1:{i:0;s:22:\"template_process_field\";}}s:25:\"field_multiple_value_form\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/field\";s:8:\"function\";s:31:\"theme_field_multiple_value_form\";}s:38:\"famc_analytics_vm_historical_perf_form\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/custom/famc_analytics\";s:8:\"function\";s:44:\"theme_famc_analytics_vm_historical_perf_form\";}s:29:\"famc_analytics_analytics_form\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/custom/famc_analytics\";s:8:\"function\";s:35:\"theme_famc_analytics_analytics_form\";}s:34:\"famc_analytics_analytics_view_form\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/custom/famc_analytics\";s:8:\"function\";s:40:\"theme_famc_analytics_analytics_view_form\";}s:13:\"entity_status\";a:4:{s:9:\"variables\";a:2:{s:6:\"status\";N;s:4:\"html\";b:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/entity\";s:8:\"function\";s:19:\"theme_entity_status\";}s:6:\"entity\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:39:\"sites/all/modules/contrib/entity/entity\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/entity\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:26:\"template_preprocess_entity\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:23:\"entity_ui_overview_item\";a:6:{s:9:\"variables\";a:4:{s:5:\"label\";N;s:11:\"entity_type\";N;s:3:\"url\";b:0;s:4:\"name\";b:0;}s:4:\"file\";s:22:\"includes/entity.ui.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/entity\";s:8:\"function\";s:29:\"theme_entity_ui_overview_item\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/entity/includes/entity.ui.inc\";}}s:13:\"dblog_message\";a:6:{s:9:\"variables\";a:2:{s:5:\"event\";N;s:4:\"link\";b:0;}s:4:\"file\";s:15:\"dblog.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/dblog\";s:8:\"function\";s:19:\"theme_dblog_message\";s:8:\"includes\";a:1:{i:0;s:29:\"modules/dblog/dblog.admin.inc\";}}s:14:\"date_nav_title\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:47:\"sites/all/modules/contrib/date/date_views/theme\";s:9:\"variables\";a:4:{s:11:\"granularity\";N;s:4:\"view\";N;s:4:\"link\";N;s:6:\"format\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:41:\"sites/all/modules/contrib/date/date_views\";s:8:\"function\";s:20:\"theme_date_nav_title\";s:8:\"includes\";a:2:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";i:1;s:57:\"sites/all/modules/contrib/date/date_views/theme/theme.inc\";}}s:22:\"date_views_filter_form\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:47:\"sites/all/modules/contrib/date/date_views/theme\";s:8:\"template\";s:22:\"date-views-filter-form\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:41:\"sites/all/modules/contrib/date/date_views\";s:8:\"includes\";a:2:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";i:1;s:57:\"sites/all/modules/contrib/date/date_views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:42:\"template_preprocess_date_views_filter_form\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:17:\"date_calendar_day\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:47:\"sites/all/modules/contrib/date/date_views/theme\";s:9:\"variables\";a:1:{s:4:\"date\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:41:\"sites/all/modules/contrib/date/date_views\";s:8:\"function\";s:23:\"theme_date_calendar_day\";s:8:\"includes\";a:2:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";i:1;s:57:\"sites/all/modules/contrib/date/date_views/theme/theme.inc\";}}s:16:\"date_views_pager\";a:10:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:47:\"sites/all/modules/contrib/date/date_views/theme\";s:9:\"variables\";a:2:{s:6:\"plugin\";N;s:5:\"input\";N;}s:7:\"pattern\";s:18:\"date_views_pager__\";s:8:\"template\";s:16:\"date-views-pager\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:41:\"sites/all/modules/contrib/date/date_views\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/date/date_views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_date_views_pager\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:10:\"date_popup\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:41:\"sites/all/modules/contrib/date/date_popup\";s:8:\"function\";s:16:\"theme_date_popup\";}s:13:\"date_timezone\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:19:\"theme_date_timezone\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:11:\"date_select\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:17:\"theme_date_select\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:9:\"date_text\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:15:\"theme_date_text\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:19:\"date_select_element\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:25:\"theme_date_select_element\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:22:\"date_textfield_element\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:28:\"theme_date_textfield_element\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:21:\"date_part_hour_prefix\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:27:\"theme_date_part_hour_prefix\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:23:\"date_part_minsec_prefix\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:29:\"theme_date_part_minsec_prefix\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:20:\"date_part_label_year\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_year\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:21:\"date_part_label_month\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:27:\"theme_date_part_label_month\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:19:\"date_part_label_day\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:25:\"theme_date_part_label_day\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:20:\"date_part_label_hour\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_hour\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:22:\"date_part_label_minute\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:28:\"theme_date_part_label_minute\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:22:\"date_part_label_second\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:28:\"theme_date_part_label_second\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:20:\"date_part_label_ampm\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_ampm\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:24:\"date_part_label_timezone\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:30:\"theme_date_part_label_timezone\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:20:\"date_part_label_date\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_date\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:20:\"date_part_label_time\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_time\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:13:\"date_time_ago\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:3:{s:10:\"start_date\";N;s:8:\"end_date\";N;s:8:\"interval\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:19:\"theme_date_time_ago\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:10:\"date_combo\";a:7:{s:4:\"file\";s:10:\"date.theme\";s:4:\"path\";s:30:\"sites/all/modules/contrib/date\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:30:\"sites/all/modules/contrib/date\";s:8:\"function\";s:16:\"theme_date_combo\";s:8:\"includes\";a:1:{i:0;s:41:\"sites/all/modules/contrib/date/date.theme\";}}s:15:\"date_text_parts\";a:7:{s:4:\"file\";s:10:\"date.theme\";s:4:\"path\";s:30:\"sites/all/modules/contrib/date\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:30:\"sites/all/modules/contrib/date\";s:8:\"function\";s:21:\"theme_date_text_parts\";s:8:\"includes\";a:1:{i:0;s:41:\"sites/all/modules/contrib/date/date.theme\";}}s:19:\"date_display_single\";a:8:{s:4:\"file\";s:10:\"date.theme\";s:4:\"path\";s:30:\"sites/all/modules/contrib/date\";s:9:\"variables\";a:6:{s:4:\"date\";N;s:8:\"timezone\";N;s:5:\"dates\";N;s:10:\"attributes\";a:0:{}s:11:\"rdf_mapping\";N;s:7:\"add_rdf\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:30:\"sites/all/modules/contrib/date\";s:8:\"function\";s:25:\"theme_date_display_single\";s:8:\"includes\";a:1:{i:0;s:41:\"sites/all/modules/contrib/date/date.theme\";}s:20:\"preprocess functions\";a:1:{i:0;s:39:\"template_preprocess_date_display_single\";}}s:18:\"date_display_range\";a:8:{s:4:\"file\";s:10:\"date.theme\";s:4:\"path\";s:30:\"sites/all/modules/contrib/date\";s:9:\"variables\";a:9:{s:5:\"date1\";N;s:5:\"date2\";N;s:8:\"timezone\";N;s:5:\"dates\";N;s:10:\"attributes\";a:0:{}s:16:\"attributes_start\";a:0:{}s:14:\"attributes_end\";a:0:{}s:11:\"rdf_mapping\";N;s:7:\"add_rdf\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:30:\"sites/all/modules/contrib/date\";s:8:\"function\";s:24:\"theme_date_display_range\";s:8:\"includes\";a:1:{i:0;s:41:\"sites/all/modules/contrib/date/date.theme\";}s:20:\"preprocess functions\";a:1:{i:0;s:38:\"template_preprocess_date_display_range\";}}s:24:\"date_display_combination\";a:7:{s:4:\"file\";s:10:\"date.theme\";s:4:\"path\";s:30:\"sites/all/modules/contrib/date\";s:9:\"variables\";a:12:{s:11:\"entity_type\";N;s:6:\"entity\";N;s:5:\"field\";N;s:8:\"instance\";N;s:8:\"langcode\";N;s:4:\"item\";N;s:5:\"delta\";N;s:7:\"display\";N;s:5:\"dates\";N;s:10:\"attributes\";a:0:{}s:11:\"rdf_mapping\";N;s:7:\"add_rdf\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:30:\"sites/all/modules/contrib/date\";s:8:\"function\";s:30:\"theme_date_display_combination\";s:8:\"includes\";a:1:{i:0;s:41:\"sites/all/modules/contrib/date/date.theme\";}}s:21:\"date_display_interval\";a:7:{s:4:\"file\";s:10:\"date.theme\";s:4:\"path\";s:30:\"sites/all/modules/contrib/date\";s:9:\"variables\";a:12:{s:11:\"entity_type\";N;s:6:\"entity\";N;s:5:\"field\";N;s:8:\"instance\";N;s:8:\"langcode\";N;s:4:\"item\";N;s:5:\"delta\";N;s:7:\"display\";N;s:5:\"dates\";N;s:10:\"attributes\";a:0:{}s:11:\"rdf_mapping\";N;s:7:\"add_rdf\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:30:\"sites/all/modules/contrib/date\";s:8:\"function\";s:27:\"theme_date_display_interval\";s:8:\"includes\";a:1:{i:0;s:41:\"sites/all/modules/contrib/date/date.theme\";}}s:9:\"dashboard\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:15:\"theme_dashboard\";}s:15:\"dashboard_admin\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:21:\"theme_dashboard_admin\";}s:16:\"dashboard_region\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:22:\"theme_dashboard_region\";}s:25:\"dashboard_disabled_blocks\";a:4:{s:9:\"variables\";a:1:{s:6:\"blocks\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:31:\"theme_dashboard_disabled_blocks\";}s:24:\"dashboard_disabled_block\";a:4:{s:9:\"variables\";a:1:{s:5:\"block\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:30:\"theme_dashboard_disabled_block\";}s:28:\"dashboard_admin_display_form\";a:9:{s:8:\"template\";s:24:\"block-admin-display-form\";s:4:\"path\";s:13:\"modules/block\";s:4:\"file\";s:15:\"block.admin.inc\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"includes\";a:1:{i:0;s:29:\"modules/block/block.admin.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_dashboard_admin_display_form\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"ctools_ajax_sample_container\";a:4:{s:9:\"arguments\";a:1:{s:7:\"content\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:51:\"sites/all/modules/contrib/ctools/ctools_ajax_sample\";s:8:\"function\";s:34:\"theme_ctools_ajax_sample_container\";}s:19:\"ctools_context_list\";a:6:{s:9:\"variables\";a:1:{s:6:\"object\";N;}s:4:\"file\";s:26:\"includes/context.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:25:\"theme_ctools_context_list\";s:8:\"includes\";a:1:{i:0;s:59:\"sites/all/modules/contrib/ctools/includes/context.theme.inc\";}}s:28:\"ctools_context_list_no_table\";a:6:{s:9:\"variables\";a:1:{s:6:\"object\";N;}s:4:\"file\";s:26:\"includes/context.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:34:\"theme_ctools_context_list_no_table\";s:8:\"includes\";a:1:{i:0;s:59:\"sites/all/modules/contrib/ctools/includes/context.theme.inc\";}}s:24:\"ctools_context_item_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:26:\"includes/context.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:30:\"theme_ctools_context_item_form\";s:8:\"includes\";a:1:{i:0;s:59:\"sites/all/modules/contrib/ctools/includes/context.theme.inc\";}}s:23:\"ctools_context_item_row\";a:6:{s:9:\"variables\";a:5:{s:4:\"type\";N;s:4:\"form\";N;s:8:\"position\";N;s:5:\"count\";N;s:7:\"with_tr\";b:1;}s:4:\"file\";s:26:\"includes/context.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:29:\"theme_ctools_context_item_row\";s:8:\"includes\";a:1:{i:0;s:59:\"sites/all/modules/contrib/ctools/includes/context.theme.inc\";}}s:23:\"ctools_access_admin_add\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:33:\"includes/context-access-admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:29:\"theme_ctools_access_admin_add\";s:8:\"includes\";a:1:{i:0;s:66:\"sites/all/modules/contrib/ctools/includes/context-access-admin.inc\";}}s:24:\"links__ctools_dropbutton\";a:6:{s:9:\"variables\";a:4:{s:5:\"title\";N;s:5:\"links\";N;s:5:\"image\";b:0;s:5:\"class\";N;}s:4:\"file\";s:29:\"includes/dropbutton.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:30:\"theme_links__ctools_dropbutton\";s:8:\"includes\";a:1:{i:0;s:62:\"sites/all/modules/contrib/ctools/includes/dropbutton.theme.inc\";}}s:33:\"ctools_stylizer_color_scheme_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:21:\"includes/stylizer.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:39:\"theme_ctools_stylizer_color_scheme_form\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/contrib/ctools/includes/stylizer.inc\";}}s:28:\"ctools_stylizer_preview_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:21:\"includes/stylizer.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:34:\"theme_ctools_stylizer_preview_form\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/contrib/ctools/includes/stylizer.inc\";}}s:17:\"ctools_style_icon\";a:6:{s:9:\"variables\";a:2:{s:5:\"image\";N;s:5:\"title\";N;}s:4:\"file\";s:21:\"includes/stylizer.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:23:\"theme_ctools_style_icon\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/contrib/ctools/includes/stylizer.inc\";}}s:19:\"ctools_wizard_trail\";a:6:{s:9:\"variables\";a:1:{s:5:\"trail\";N;}s:4:\"file\";s:25:\"includes/wizard.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:25:\"theme_ctools_wizard_trail\";s:8:\"includes\";a:1:{i:0;s:58:\"sites/all/modules/contrib/ctools/includes/wizard.theme.inc\";}}s:18:\"ctools_collapsible\";a:6:{s:9:\"variables\";a:3:{s:6:\"handle\";N;s:7:\"content\";N;s:9:\"collapsed\";b:0;}s:4:\"file\";s:30:\"includes/collapsible.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:24:\"theme_ctools_collapsible\";s:8:\"includes\";a:1:{i:0;s:63:\"sites/all/modules/contrib/ctools/includes/collapsible.theme.inc\";}}s:29:\"ctools_collapsible_remembered\";a:6:{s:9:\"variables\";a:4:{s:2:\"id\";N;s:6:\"handle\";N;s:7:\"content\";N;s:9:\"collapsed\";b:0;}s:4:\"file\";s:30:\"includes/collapsible.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:35:\"theme_ctools_collapsible_remembered\";s:8:\"includes\";a:1:{i:0;s:63:\"sites/all/modules/contrib/ctools/includes/collapsible.theme.inc\";}}s:15:\"ctools_dropdown\";a:6:{s:9:\"variables\";a:4:{s:5:\"title\";N;s:5:\"links\";N;s:5:\"image\";b:0;s:5:\"class\";s:0:\"\";}s:4:\"file\";s:27:\"includes/dropdown.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:21:\"theme_ctools_dropdown\";s:8:\"includes\";a:1:{i:0;s:60:\"sites/all/modules/contrib/ctools/includes/dropdown.theme.inc\";}}s:13:\"comment_block\";a:4:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/comment\";s:8:\"function\";s:19:\"theme_comment_block\";}s:15:\"comment_preview\";a:4:{s:9:\"variables\";a:1:{s:7:\"comment\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/comment\";s:8:\"function\";s:21:\"theme_comment_preview\";}s:7:\"comment\";a:6:{s:8:\"template\";s:23:\"modules/comment/comment\";s:14:\"render element\";s:8:\"elements\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/comment\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:27:\"template_preprocess_comment\";i:2;s:22:\"rdf_preprocess_comment\";i:3;s:24:\"views_preprocess_comment\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:22:\"comment_post_forbidden\";a:4:{s:9:\"variables\";a:1:{s:4:\"node\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/comment\";s:8:\"function\";s:28:\"theme_comment_post_forbidden\";}s:15:\"comment_wrapper\";a:6:{s:8:\"template\";s:31:\"modules/comment/comment-wrapper\";s:14:\"render element\";s:7:\"content\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/comment\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:35:\"template_preprocess_comment_wrapper\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:17:\"color_scheme_form\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/color\";s:8:\"function\";s:23:\"theme_color_scheme_form\";}s:12:\"coder_review\";a:4:{s:9:\"variables\";a:3:{s:4:\"name\";N;s:8:\"filename\";N;s:7:\"results\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:44:\"sites/all/modules/contrib/coder/coder_review\";s:8:\"function\";s:18:\"theme_coder_review\";}s:20:\"coder_review_warning\";a:4:{s:9:\"variables\";a:4:{s:7:\"warning\";N;s:13:\"severity_name\";N;s:6:\"lineno\";N;s:4:\"line\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:44:\"sites/all/modules/contrib/coder/coder_review\";s:8:\"function\";s:26:\"theme_coder_review_warning\";}s:24:\"coder_review_warning_msg\";a:4:{s:9:\"variables\";a:1:{s:5:\"error\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:44:\"sites/all/modules/contrib/coder/coder_review\";s:8:\"function\";s:30:\"theme_coder_review_warning_msg\";}s:23:\"coder_review_table_cols\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:44:\"sites/all/modules/contrib/coder/coder_review\";s:8:\"function\";s:29:\"theme_coder_review_table_cols\";}s:9:\"drupalapi\";a:4:{s:9:\"variables\";a:2:{s:8:\"function\";N;s:7:\"version\";s:1:\"7\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:44:\"sites/all/modules/contrib/coder/coder_review\";s:8:\"function\";s:15:\"theme_drupalapi\";}s:6:\"phpapi\";a:4:{s:9:\"variables\";a:1:{s:8:\"function\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:44:\"sites/all/modules/contrib/coder/coder_review\";s:8:\"function\";s:12:\"theme_phpapi\";}s:5:\"block\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:19:\"modules/block/block\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/block\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:25:\"template_preprocess_block\";i:2;s:28:\"block_class_preprocess_block\";i:3;s:23:\"system_preprocess_block\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:24:\"block_admin_display_form\";a:8:{s:8:\"template\";s:38:\"modules/block/block-admin-display-form\";s:4:\"file\";s:15:\"block.admin.inc\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/block\";s:8:\"includes\";a:1:{i:0;s:29:\"modules/block/block.admin.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:44:\"template_preprocess_block_admin_display_form\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}}',0,1371656313,1),('theme_registry:runtime:seven','a:308:{s:19:\"tablesort_indicator\";a:4:{s:8:\"function\";s:25:\"seven_tablesort_indicator\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:12:\"themes/seven\";s:9:\"variables\";a:1:{s:5:\"style\";N;}}s:19:\"admin_block_content\";N;s:13:\"node_add_list\";N;s:4:\"page\";a:7:{s:8:\"template\";s:4:\"page\";s:4:\"path\";s:12:\"themes/seven\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:12:\"themes/seven\";s:14:\"render element\";s:4:\"page\";s:20:\"preprocess functions\";a:5:{i:0;s:19:\"template_preprocess\";i:1;s:24:\"template_preprocess_page\";i:2;s:24:\"shortcut_preprocess_page\";i:3;s:21:\"seven_preprocess_page\";i:5;s:22:\"ctools_preprocess_page\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:21:\"template_process_page\";i:2;s:11:\"rdf_process\";}}s:16:\"maintenance_page\";N;s:16:\"admin_menu_links\";a:4:{s:14:\"render element\";s:8:\"elements\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:36:\"sites/all/modules/contrib/admin_menu\";s:8:\"function\";s:22:\"theme_admin_menu_links\";}s:15:\"admin_menu_icon\";a:7:{s:9:\"variables\";a:2:{s:3:\"src\";N;s:3:\"alt\";N;}s:4:\"file\";s:14:\"admin_menu.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:36:\"sites/all/modules/contrib/admin_menu\";s:8:\"function\";s:21:\"theme_admin_menu_icon\";s:8:\"includes\";a:1:{i:0;s:51:\"sites/all/modules/contrib/admin_menu/admin_menu.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:35:\"template_preprocess_admin_menu_icon\";}}s:30:\"page_manager_handler_rearrange\";N;s:22:\"page_manager_edit_page\";N;s:17:\"page_manager_lock\";N;s:20:\"page_manager_changed\";N;s:37:\"page_manager_page_form_argument_table\";N;s:22:\"page_manager_page_lock\";N;s:25:\"page_manager_page_changed\";N;s:16:\"views_mini_pager\";N;s:16:\"views_view_field\";N;s:19:\"views_view_grouping\";N;s:10:\"views_view\";N;s:23:\"eva_display_entity_view\";N;s:15:\"date_navigation\";N;s:22:\"views_view_unformatted\";N;s:17:\"views_data_export\";N;s:28:\"views_data_export_csv_header\";N;s:26:\"views_data_export_csv_body\";N;s:28:\"views_data_export_csv_footer\";N;s:28:\"views_data_export_doc_header\";N;s:26:\"views_data_export_doc_body\";N;s:28:\"views_data_export_doc_footer\";N;s:28:\"views_data_export_txt_header\";N;s:26:\"views_data_export_txt_body\";N;s:28:\"views_data_export_txt_footer\";N;s:28:\"views_data_export_xls_header\";N;s:26:\"views_data_export_xls_body\";N;s:28:\"views_data_export_xls_footer\";N;s:28:\"views_data_export_xml_header\";N;s:26:\"views_data_export_xml_body\";N;s:28:\"views_data_export_xml_footer\";N;s:25:\"views_view_watchdog_table\";N;s:15:\"views_view_list\";N;s:15:\"views_view_grid\";N;s:16:\"views_view_table\";N;s:18:\"views_view_summary\";N;s:30:\"views_view_summary_unformatted\";N;s:14:\"views_view_rss\";N;s:28:\"views_view_summary_jump_menu\";N;s:20:\"views_view_jump_menu\";N;s:22:\"views_view_row_comment\";N;s:18:\"views_view_row_rss\";N;s:17:\"views_view_fields\";N;s:21:\"views_form_views_form\";N;s:18:\"views_exposed_form\";N;s:10:\"views_more\";N;s:15:\"horizontal_tabs\";N;s:9:\"multipage\";N;s:14:\"multipage_pane\";N;s:28:\"views_ui_display_tab_setting\";N;s:27:\"views_ui_display_tab_bucket\";N;s:18:\"views_ui_edit_item\";N;s:23:\"views_ui_rearrange_form\";N;s:30:\"views_ui_rearrange_filter_form\";N;s:27:\"views_ui_expose_filter_form\";N;s:18:\"views_ui_view_info\";N;s:32:\"views_ui_build_group_filter_form\";N;s:12:\"views_tabset\";N;s:9:\"views_tab\";N;s:30:\"views_ui_reorder_displays_form\";N;s:27:\"views_ui_style_plugin_table\";N;s:29:\"views_ui_view_preview_section\";N;s:15:\"views_container\";N;s:27:\"views_data_export_feed_icon\";N;s:31:\"views_data_export_complete_page\";N;s:25:\"views_data_export_message\";N;s:12:\"user_picture\";N;s:12:\"user_profile\";N;s:21:\"user_profile_category\";N;s:17:\"user_profile_item\";N;s:9:\"user_list\";N;s:22:\"user_admin_permissions\";N;s:16:\"user_admin_roles\";N;s:27:\"user_permission_description\";N;s:14:\"user_signature\";N;s:10:\"tree_table\";N;s:10:\"token_tree\";N;s:15:\"token_tree_link\";N;s:30:\"taxonomy_overview_vocabularies\";N;s:23:\"taxonomy_overview_terms\";N;s:13:\"taxonomy_term\";N;s:4:\"html\";a:6:{s:14:\"render element\";s:4:\"page\";s:8:\"template\";s:19:\"modules/system/html\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"themes/seven\";s:20:\"preprocess functions\";a:5:{i:0;s:19:\"template_preprocess\";i:1;s:24:\"template_preprocess_html\";i:2;s:22:\"panels_preprocess_html\";i:3;s:21:\"views_preprocess_html\";i:4;s:21:\"seven_preprocess_html\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:21:\"template_process_html\";i:2;s:11:\"rdf_process\";}}s:6:\"region\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:21:\"modules/system/region\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:26:\"template_preprocess_region\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:15:\"status_messages\";a:4:{s:9:\"variables\";a:1:{s:7:\"display\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:21:\"theme_status_messages\";}s:4:\"link\";a:4:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:4:\"path\";N;s:7:\"options\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_link\";}s:5:\"links\";N;s:5:\"image\";a:5:{s:9:\"variables\";a:6:{s:4:\"path\";N;s:5:\"width\";N;s:6:\"height\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";N;s:10:\"attributes\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_image\";s:20:\"preprocess functions\";a:1:{i:0;s:20:\"rdf_preprocess_image\";}}s:10:\"breadcrumb\";a:4:{s:9:\"variables\";a:1:{s:10:\"breadcrumb\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_breadcrumb\";}s:4:\"help\";N;s:5:\"table\";a:4:{s:9:\"variables\";a:7:{s:6:\"header\";N;s:4:\"rows\";N;s:10:\"attributes\";a:0:{}s:7:\"caption\";N;s:9:\"colgroups\";a:0:{}s:6:\"sticky\";b:1;s:5:\"empty\";s:0:\"\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_table\";}s:4:\"mark\";N;s:9:\"item_list\";N;s:14:\"more_help_link\";N;s:9:\"feed_icon\";N;s:9:\"more_link\";N;s:8:\"username\";N;s:12:\"progress_bar\";N;s:11:\"indentation\";N;s:8:\"html_tag\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_html_tag\";}s:11:\"update_page\";N;s:12:\"install_page\";N;s:9:\"task_list\";N;s:17:\"authorize_message\";N;s:16:\"authorize_report\";N;s:5:\"pager\";a:4:{s:9:\"variables\";a:4:{s:4:\"tags\";a:0:{}s:7:\"element\";i:0;s:10:\"parameters\";a:0:{}s:8:\"quantity\";i:9;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_pager\";}s:11:\"pager_first\";a:4:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:7:\"element\";i:0;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_pager_first\";}s:14:\"pager_previous\";a:4:{s:9:\"variables\";a:4:{s:4:\"text\";N;s:7:\"element\";i:0;s:8:\"interval\";i:1;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:20:\"theme_pager_previous\";}s:10:\"pager_next\";a:4:{s:9:\"variables\";a:4:{s:4:\"text\";N;s:7:\"element\";i:0;s:8:\"interval\";i:1;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_pager_next\";}s:10:\"pager_last\";a:4:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:7:\"element\";i:0;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_pager_last\";}s:10:\"pager_link\";N;s:9:\"menu_link\";N;s:9:\"menu_tree\";N;s:15:\"menu_local_task\";N;s:17:\"menu_local_action\";N;s:16:\"menu_local_tasks\";a:4:{s:9:\"variables\";a:2:{s:7:\"primary\";a:0:{}s:9:\"secondary\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:22:\"theme_menu_local_tasks\";}s:6:\"select\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_select\";}s:8:\"fieldset\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_fieldset\";}s:5:\"radio\";N;s:6:\"radios\";N;s:4:\"date\";N;s:15:\"exposed_filters\";N;s:8:\"checkbox\";N;s:10:\"checkboxes\";N;s:6:\"button\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_button\";}s:12:\"image_button\";N;s:6:\"hidden\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_hidden\";}s:9:\"textfield\";N;s:4:\"form\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_form\";}s:8:\"textarea\";N;s:8:\"password\";N;s:4:\"file\";N;s:11:\"tableselect\";N;s:12:\"form_element\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_form_element\";}s:20:\"form_required_marker\";N;s:18:\"form_element_label\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:24:\"theme_form_element_label\";}s:13:\"vertical_tabs\";N;s:9:\"container\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_container\";}s:18:\"system_themes_page\";N;s:20:\"system_settings_form\";N;s:12:\"confirm_form\";N;s:23:\"system_modules_fieldset\";N;s:27:\"system_modules_incompatible\";N;s:24:\"system_modules_uninstall\";N;s:13:\"status_report\";N;s:10:\"admin_page\";N;s:11:\"admin_block\";N;s:18:\"system_admin_index\";N;s:17:\"system_powered_by\";N;s:19:\"system_compact_link\";N;s:25:\"system_date_time_settings\";N;s:22:\"shortcut_set_customize\";N;s:23:\"search_api_page_results\";N;s:22:\"search_api_page_result\";N;s:17:\"search_api_server\";N;s:16:\"search_api_index\";N;s:27:\"search_api_admin_item_order\";N;s:29:\"search_api_admin_fields_table\";N;s:17:\"search_block_form\";N;s:13:\"search_result\";N;s:14:\"search_results\";N;s:29:\"rdf_template_variable_wrapper\";N;s:12:\"rdf_metadata\";N;s:17:\"r4032login_denied\";N;s:23:\"panels_ipe_pane_wrapper\";N;s:25:\"panels_ipe_region_wrapper\";N;s:26:\"panels_ipe_add_pane_button\";N;s:27:\"panels_ipe_placeholder_pane\";N;s:29:\"panels_ipe_dnd_form_container\";N;s:18:\"panels_ipe_toolbar\";N;s:18:\"panels_layout_link\";N;s:18:\"panels_layout_icon\";N;s:11:\"panels_pane\";N;s:26:\"panels_common_content_list\";N;s:26:\"panels_render_display_form\";N;s:16:\"panels_dashboard\";N;s:21:\"panels_dashboard_link\";N;s:22:\"panels_dashboard_block\";N;s:24:\"panels_add_content_modal\";N;s:23:\"panels_add_content_link\";N;s:15:\"panels_flexible\";N;s:21:\"panels_flexible_admin\";N;s:24:\"panels_threecol_33_34_33\";N;s:13:\"panels_onecol\";N;s:24:\"panels_threecol_25_50_25\";N;s:32:\"panels_threecol_25_50_25_stacked\";N;s:20:\"panels_twocol_bricks\";N;s:32:\"panels_threecol_33_34_33_stacked\";N;s:21:\"panels_twocol_stacked\";N;s:13:\"panels_twocol\";N;s:40:\"panels_rounded_corners_style_render_pane\";N;s:42:\"panels_rounded_corners_style_render_region\";N;s:26:\"panels_rounded_corners_box\";N;s:30:\"panels_block_style_render_pane\";N;s:34:\"panels_default_style_render_region\";N;s:30:\"panels_naked_style_render_pane\";N;s:32:\"panels_naked_style_render_region\";N;s:31:\"panels_list_style_render_region\";N;s:12:\"options_none\";N;s:4:\"node\";N;s:17:\"node_search_admin\";N;s:12:\"node_preview\";N;s:19:\"node_admin_overview\";N;s:17:\"node_recent_block\";N;s:19:\"node_recent_content\";N;s:28:\"module_filter_system_modules\";N;s:27:\"module_filter_modules_table\";N;s:33:\"module_filter_system_modules_tabs\";N;s:18:\"menu_overview_form\";N;s:19:\"menu_admin_overview\";N;s:29:\"login_destination_destination\";N;s:23:\"login_destination_pages\";N;s:26:\"login_destination_triggers\";N;s:23:\"login_destination_roles\";N;s:17:\"lt_username_title\";N;s:23:\"lt_username_description\";N;s:17:\"lt_password_title\";N;s:23:\"lt_password_description\";N;s:16:\"lt_access_denied\";N;s:16:\"lt_loggedinblock\";N;s:13:\"lt_login_link\";N;s:27:\"lt_login_successful_message\";N;s:21:\"lt_unified_login_page\";N;s:15:\"transfer_slider\";N;s:21:\"filter_admin_overview\";N;s:32:\"filter_admin_format_filter_order\";N;s:11:\"filter_tips\";N;s:19:\"text_format_wrapper\";N;s:21:\"filter_tips_more_info\";N;s:17:\"filter_guidelines\";N;s:14:\"field_ui_table\";N;s:5:\"field\";N;s:25:\"field_multiple_value_form\";N;s:38:\"famc_analytics_vm_historical_perf_form\";N;s:29:\"famc_analytics_analytics_form\";N;s:34:\"famc_analytics_analytics_view_form\";N;s:13:\"entity_status\";N;s:6:\"entity\";N;s:23:\"entity_ui_overview_item\";N;s:13:\"dblog_message\";N;s:14:\"date_nav_title\";N;s:22:\"date_views_filter_form\";N;s:17:\"date_calendar_day\";N;s:16:\"date_views_pager\";N;s:10:\"date_popup\";N;s:13:\"date_timezone\";N;s:11:\"date_select\";N;s:9:\"date_text\";N;s:19:\"date_select_element\";N;s:22:\"date_textfield_element\";N;s:21:\"date_part_hour_prefix\";N;s:23:\"date_part_minsec_prefix\";N;s:20:\"date_part_label_year\";N;s:21:\"date_part_label_month\";N;s:19:\"date_part_label_day\";N;s:20:\"date_part_label_hour\";N;s:22:\"date_part_label_minute\";N;s:22:\"date_part_label_second\";N;s:20:\"date_part_label_ampm\";N;s:24:\"date_part_label_timezone\";N;s:20:\"date_part_label_date\";N;s:20:\"date_part_label_time\";N;s:13:\"date_time_ago\";N;s:10:\"date_combo\";N;s:15:\"date_text_parts\";N;s:19:\"date_display_single\";N;s:18:\"date_display_range\";N;s:24:\"date_display_combination\";N;s:21:\"date_display_interval\";N;s:9:\"dashboard\";N;s:15:\"dashboard_admin\";N;s:16:\"dashboard_region\";N;s:25:\"dashboard_disabled_blocks\";N;s:24:\"dashboard_disabled_block\";N;s:28:\"dashboard_admin_display_form\";N;s:28:\"ctools_ajax_sample_container\";N;s:19:\"ctools_context_list\";N;s:28:\"ctools_context_list_no_table\";N;s:24:\"ctools_context_item_form\";N;s:23:\"ctools_context_item_row\";N;s:23:\"ctools_access_admin_add\";N;s:24:\"links__ctools_dropbutton\";N;s:33:\"ctools_stylizer_color_scheme_form\";N;s:28:\"ctools_stylizer_preview_form\";N;s:17:\"ctools_style_icon\";N;s:19:\"ctools_wizard_trail\";N;s:18:\"ctools_collapsible\";N;s:29:\"ctools_collapsible_remembered\";N;s:15:\"ctools_dropdown\";N;s:13:\"comment_block\";N;s:15:\"comment_preview\";N;s:7:\"comment\";N;s:22:\"comment_post_forbidden\";N;s:15:\"comment_wrapper\";N;s:17:\"color_scheme_form\";N;s:12:\"coder_review\";N;s:20:\"coder_review_warning\";N;s:24:\"coder_review_warning_msg\";N;s:23:\"coder_review_table_cols\";N;s:9:\"drupalapi\";N;s:6:\"phpapi\";N;s:5:\"block\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:19:\"modules/block/block\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/block\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:25:\"template_preprocess_block\";i:2;s:28:\"block_class_preprocess_block\";i:3;s:23:\"system_preprocess_block\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:24:\"block_admin_display_form\";N;}',0,1371656313,1),('pathauto:punctuation:en','a:32:{s:13:\"double_quotes\";a:2:{s:5:\"value\";s:1:\"\"\";s:4:\"name\";s:22:\"Double quotation marks\";}s:6:\"quotes\";a:2:{s:5:\"value\";s:1:\"\'\";s:4:\"name\";s:35:\"Single quotation marks (apostrophe)\";}s:8:\"backtick\";a:2:{s:5:\"value\";s:1:\"`\";s:4:\"name\";s:9:\"Back tick\";}s:5:\"comma\";a:2:{s:5:\"value\";s:1:\",\";s:4:\"name\";s:5:\"Comma\";}s:6:\"period\";a:2:{s:5:\"value\";s:1:\".\";s:4:\"name\";s:6:\"Period\";}s:6:\"hyphen\";a:2:{s:5:\"value\";s:1:\"-\";s:4:\"name\";s:6:\"Hyphen\";}s:10:\"underscore\";a:2:{s:5:\"value\";s:1:\"_\";s:4:\"name\";s:10:\"Underscore\";}s:5:\"colon\";a:2:{s:5:\"value\";s:1:\":\";s:4:\"name\";s:5:\"Colon\";}s:9:\"semicolon\";a:2:{s:5:\"value\";s:1:\";\";s:4:\"name\";s:9:\"Semicolon\";}s:4:\"pipe\";a:2:{s:5:\"value\";s:1:\"|\";s:4:\"name\";s:19:\"Vertical bar (pipe)\";}s:10:\"left_curly\";a:2:{s:5:\"value\";s:1:\"{\";s:4:\"name\";s:18:\"Left curly bracket\";}s:11:\"left_square\";a:2:{s:5:\"value\";s:1:\"[\";s:4:\"name\";s:19:\"Left square bracket\";}s:11:\"right_curly\";a:2:{s:5:\"value\";s:1:\"}\";s:4:\"name\";s:19:\"Right curly bracket\";}s:12:\"right_square\";a:2:{s:5:\"value\";s:1:\"]\";s:4:\"name\";s:20:\"Right square bracket\";}s:4:\"plus\";a:2:{s:5:\"value\";s:1:\"+\";s:4:\"name\";s:9:\"Plus sign\";}s:5:\"equal\";a:2:{s:5:\"value\";s:1:\"=\";s:4:\"name\";s:10:\"Equal sign\";}s:8:\"asterisk\";a:2:{s:5:\"value\";s:1:\"*\";s:4:\"name\";s:8:\"Asterisk\";}s:9:\"ampersand\";a:2:{s:5:\"value\";s:1:\"&\";s:4:\"name\";s:9:\"Ampersand\";}s:7:\"percent\";a:2:{s:5:\"value\";s:1:\"%\";s:4:\"name\";s:12:\"Percent sign\";}s:5:\"caret\";a:2:{s:5:\"value\";s:1:\"^\";s:4:\"name\";s:5:\"Caret\";}s:6:\"dollar\";a:2:{s:5:\"value\";s:1:\"$\";s:4:\"name\";s:11:\"Dollar sign\";}s:4:\"hash\";a:2:{s:5:\"value\";s:1:\"#\";s:4:\"name\";s:30:\"Number sign (pound sign, hash)\";}s:2:\"at\";a:2:{s:5:\"value\";s:1:\"@\";s:4:\"name\";s:7:\"At sign\";}s:11:\"exclamation\";a:2:{s:5:\"value\";s:1:\"!\";s:4:\"name\";s:16:\"Exclamation mark\";}s:5:\"tilde\";a:2:{s:5:\"value\";s:1:\"~\";s:4:\"name\";s:5:\"Tilde\";}s:16:\"left_parenthesis\";a:2:{s:5:\"value\";s:1:\"(\";s:4:\"name\";s:16:\"Left parenthesis\";}s:17:\"right_parenthesis\";a:2:{s:5:\"value\";s:1:\")\";s:4:\"name\";s:17:\"Right parenthesis\";}s:13:\"question_mark\";a:2:{s:5:\"value\";s:1:\"?\";s:4:\"name\";s:13:\"Question mark\";}s:9:\"less_than\";a:2:{s:5:\"value\";s:1:\"<\";s:4:\"name\";s:14:\"Less-than sign\";}s:12:\"greater_than\";a:2:{s:5:\"value\";s:1:\">\";s:4:\"name\";s:17:\"Greater-than sign\";}s:5:\"slash\";a:2:{s:5:\"value\";s:1:\"/\";s:4:\"name\";s:5:\"Slash\";}s:10:\"back_slash\";a:2:{s:5:\"value\";s:1:\"\\\";s:4:\"name\";s:9:\"Backslash\";}}',0,1371656313,1),('ctools_plugin_files:ctools:export_ui','a:6:{s:6:\"ctools\";a:1:{s:16:\"ctools_export_ui\";O:8:\"stdClass\":3:{s:3:\"uri\";s:71:\"sites/all/modules/contrib/ctools/plugins/export_ui/ctools_export_ui.inc\";s:8:\"filename\";s:20:\"ctools_export_ui.inc\";s:4:\"name\";s:16:\"ctools_export_ui\";}}s:21:\"ctools_custom_content\";a:1:{s:21:\"ctools_custom_content\";O:8:\"stdClass\":3:{s:3:\"uri\";s:98:\"sites/all/modules/contrib/ctools/ctools_custom_content/plugins/export_ui/ctools_custom_content.inc\";s:8:\"filename\";s:25:\"ctools_custom_content.inc\";s:4:\"name\";s:21:\"ctools_custom_content\";}}s:6:\"panels\";a:1:{s:14:\"panels_layouts\";O:8:\"stdClass\":3:{s:3:\"uri\";s:69:\"sites/all/modules/contrib/panels/plugins/export_ui/panels_layouts.inc\";s:8:\"filename\";s:18:\"panels_layouts.inc\";s:4:\"name\";s:14:\"panels_layouts\";}}s:11:\"panels_mini\";a:1:{s:11:\"panels_mini\";O:8:\"stdClass\":3:{s:3:\"uri\";s:78:\"sites/all/modules/contrib/panels/panels_mini/plugins/export_ui/panels_mini.inc\";s:8:\"filename\";s:15:\"panels_mini.inc\";s:4:\"name\";s:11:\"panels_mini\";}}s:13:\"views_content\";a:0:{}s:8:\"views_ui\";a:1:{s:8:\"views_ui\";O:8:\"stdClass\":3:{s:3:\"uri\";s:62:\"sites/all/modules/contrib/views/plugins/export_ui/views_ui.inc\";s:8:\"filename\";s:12:\"views_ui.inc\";s:4:\"name\";s:8:\"views_ui\";}}}',0,1371656313,1);
INSERT INTO `cache` VALUES ('schema:runtime:1','a:18:{s:7:\"comment\";a:6:{s:6:\"fields\";a:14:{s:3:\"cid\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:3:\"pid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"nid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"subject\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"hostname\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"changed\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:1;s:4:\"size\";s:4:\"tiny\";}s:6:\"thread\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:4:\"name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:60;s:8:\"not null\";b:0;}s:4:\"mail\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:0;}s:8:\"homepage\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:7:\"indexes\";a:5:{s:18:\"comment_status_pid\";a:2:{i:0;s:3:\"pid\";i:1;s:6:\"status\";}s:15:\"comment_num_new\";a:5:{i:0;s:3:\"nid\";i:1;s:6:\"status\";i:2;s:7:\"created\";i:3;s:3:\"cid\";i:4;s:6:\"thread\";}s:11:\"comment_uid\";a:1:{i:0;s:3:\"uid\";}s:20:\"comment_nid_language\";a:2:{i:0;s:3:\"nid\";i:1;s:8:\"language\";}s:15:\"comment_created\";a:1:{i:0;s:7:\"created\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:12:\"foreign keys\";a:2:{s:12:\"comment_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:3:\"nid\";s:3:\"nid\";}}s:14:\"comment_author\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:6:\"module\";s:7:\"comment\";s:4:\"name\";s:7:\"comment\";}s:4:\"node\";a:7:{s:6:\"fields\";a:14:{s:3:\"nid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"vid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;s:7:\"default\";N;}s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"changed\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"comment\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"promote\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"sticky\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"tnid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"translate\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:9:{s:12:\"node_changed\";a:1:{i:0;s:7:\"changed\";}s:12:\"node_created\";a:1:{i:0;s:7:\"created\";}s:14:\"node_frontpage\";a:4:{i:0;s:7:\"promote\";i:1;s:6:\"status\";i:2;s:6:\"sticky\";i:3;s:7:\"created\";}s:16:\"node_status_type\";a:3:{i:0;s:6:\"status\";i:1;s:4:\"type\";i:2;s:3:\"nid\";}s:15:\"node_title_type\";a:2:{i:0;s:5:\"title\";i:1;a:2:{i:0;s:4:\"type\";i:1;i:4;}}s:9:\"node_type\";a:1:{i:0;a:2:{i:0;s:4:\"type\";i:1;i:4;}}s:3:\"uid\";a:1:{i:0;s:3:\"uid\";}s:4:\"tnid\";a:1:{i:0;s:4:\"tnid\";}s:9:\"translate\";a:1:{i:0;s:9:\"translate\";}}s:11:\"unique keys\";a:1:{s:3:\"vid\";a:1:{i:0;s:3:\"vid\";}}s:12:\"foreign keys\";a:2:{s:13:\"node_revision\";a:2:{s:5:\"table\";s:13:\"node_revision\";s:7:\"columns\";a:1:{s:3:\"vid\";s:3:\"vid\";}}s:11:\"node_author\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:11:\"primary key\";a:1:{i:0;s:3:\"nid\";}s:6:\"module\";s:4:\"node\";s:4:\"name\";s:4:\"node\";}s:13:\"node_revision\";a:6:{s:6:\"fields\";a:10:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"vid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"log\";a:3:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;s:4:\"size\";s:3:\"big\";}s:9:\"timestamp\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}s:7:\"comment\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"promote\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"sticky\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:2:{s:3:\"nid\";a:1:{i:0;s:3:\"nid\";}s:3:\"uid\";a:1:{i:0;s:3:\"uid\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"vid\";}s:12:\"foreign keys\";a:2:{s:14:\"versioned_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:3:\"nid\";s:3:\"nid\";}}s:14:\"version_author\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:6:\"module\";s:4:\"node\";s:4:\"name\";s:13:\"node_revision\";}s:17:\"search_api_server\";a:6:{s:6:\"fields\";a:9:{s:2:\"id\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:4:\"name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;}s:12:\"machine_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;}s:11:\"description\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;}s:5:\"class\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;}s:7:\"options\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:6:\"medium\";s:9:\"serialize\";b:1;s:8:\"not null\";b:1;}s:7:\"enabled\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;s:4:\"size\";s:4:\"tiny\";}s:6:\"module\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:7:\"enabled\";a:1:{i:0;s:7:\"enabled\";}}s:11:\"unique keys\";a:1:{s:12:\"machine_name\";a:1:{i:0;s:12:\"machine_name\";}}s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:6:\"module\";s:10:\"search_api\";s:4:\"name\";s:17:\"search_api_server\";}s:16:\"search_api_index\";a:6:{s:6:\"fields\";a:11:{s:2:\"id\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:4:\"name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;}s:12:\"machine_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;}s:11:\"description\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;}s:6:\"server\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:0;}s:9:\"item_type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;}s:7:\"options\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:6:\"medium\";s:9:\"serialize\";b:1;s:8:\"not null\";b:1;}s:7:\"enabled\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}s:9:\"read_only\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;s:4:\"size\";s:4:\"tiny\";}s:6:\"module\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:3:{s:9:\"item_type\";a:1:{i:0;s:9:\"item_type\";}s:6:\"server\";a:1:{i:0;s:6:\"server\";}s:7:\"enabled\";a:1:{i:0;s:7:\"enabled\";}}s:11:\"unique keys\";a:1:{s:12:\"machine_name\";a:1:{i:0;s:12:\"machine_name\";}}s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:6:\"module\";s:10:\"search_api\";s:4:\"name\";s:16:\"search_api_index\";}s:15:\"search_api_page\";a:6:{s:6:\"fields\";a:10:{s:2:\"id\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"index_id\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;}s:4:\"path\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;}s:4:\"name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;}s:12:\"machine_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;}s:11:\"description\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;}s:7:\"options\";a:3:{s:4:\"type\";s:4:\"text\";s:9:\"serialize\";b:1;s:8:\"not null\";b:1;}s:7:\"enabled\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;s:4:\"size\";s:4:\"tiny\";}s:6:\"module\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:2:{s:7:\"enabled\";a:1:{i:0;s:7:\"enabled\";}s:8:\"index_id\";a:1:{i:0;s:8:\"index_id\";}}s:6:\"unique\";a:2:{s:4:\"path\";a:1:{i:0;s:4:\"path\";}s:12:\"machine_name\";a:1:{i:0;s:12:\"machine_name\";}}s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:6:\"module\";s:15:\"search_api_page\";s:4:\"name\";s:15:\"search_api_page\";}s:12:\"file_managed\";a:7:{s:6:\"fields\";a:8:{s:3:\"fid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"uid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:8:\"filename\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:6:\"binary\";b:1;}s:3:\"uri\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:6:\"binary\";b:1;}s:8:\"filemime\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"filesize\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:9:\"timestamp\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:3:{s:3:\"uid\";a:1:{i:0;s:3:\"uid\";}s:6:\"status\";a:1:{i:0;s:6:\"status\";}s:9:\"timestamp\";a:1:{i:0;s:9:\"timestamp\";}}s:11:\"unique keys\";a:1:{s:3:\"uri\";a:1:{i:0;s:3:\"uri\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"fid\";}s:12:\"foreign keys\";a:1:{s:10:\"file_owner\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:12:\"file_managed\";}s:18:\"taxonomy_term_data\";a:6:{s:6:\"fields\";a:6:{s:3:\"tid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"vid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"name\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:11:\"description\";a:4:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:12:\"translatable\";b:1;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:3:\"tid\";}s:12:\"foreign keys\";a:1:{s:10:\"vocabulary\";a:2:{s:5:\"table\";s:19:\"taxonomy_vocabulary\";s:7:\"columns\";a:1:{s:3:\"vid\";s:3:\"vid\";}}}s:7:\"indexes\";a:3:{s:13:\"taxonomy_tree\";a:3:{i:0;s:3:\"vid\";i:1;s:6:\"weight\";i:2;s:4:\"name\";}s:8:\"vid_name\";a:2:{i:0;s:3:\"vid\";i:1;s:4:\"name\";}s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:6:\"module\";s:8:\"taxonomy\";s:4:\"name\";s:18:\"taxonomy_term_data\";}s:19:\"taxonomy_vocabulary\";a:6:{s:6:\"fields\";a:7:{s:3:\"vid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:4:\"name\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:12:\"machine_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:11:\"description\";a:4:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:12:\"translatable\";b:1;}s:9:\"hierarchy\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:3:\"vid\";}s:7:\"indexes\";a:1:{s:4:\"list\";a:2:{i:0;s:6:\"weight\";i:1;s:4:\"name\";}}s:11:\"unique keys\";a:1:{s:12:\"machine_name\";a:1:{i:0;s:12:\"machine_name\";}}s:6:\"module\";s:8:\"taxonomy\";s:4:\"name\";s:19:\"taxonomy_vocabulary\";}s:5:\"users\";a:7:{s:6:\"fields\";a:16:{s:3:\"uid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:60;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"pass\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"mail\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;s:8:\"not null\";b:0;s:7:\"default\";s:0:\"\";}s:5:\"theme\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:9:\"signature\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:16:\"signature_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"access\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"login\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:8:\"timezone\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"picture\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"init\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;s:8:\"not null\";b:0;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:4:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:7:\"indexes\";a:4:{s:6:\"access\";a:1:{i:0;s:6:\"access\";}s:7:\"created\";a:1:{i:0;s:7:\"created\";}s:4:\"mail\";a:1:{i:0;s:4:\"mail\";}s:7:\"picture\";a:1:{i:0;s:7:\"picture\";}}s:11:\"unique keys\";a:1:{s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"uid\";}s:12:\"foreign keys\";a:1:{s:16:\"signature_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:16:\"signature_format\";s:6:\"format\";}}}s:6:\"module\";s:4:\"user\";s:4:\"name\";s:5:\"users\";}s:10:\"views_view\";a:6:{s:6:\"export\";a:17:{s:10:\"identifier\";s:4:\"view\";s:11:\"bulk export\";b:1;s:11:\"primary key\";s:3:\"vid\";s:12:\"default hook\";s:19:\"views_default_views\";s:11:\"admin_title\";s:10:\"human_name\";s:17:\"admin_description\";s:11:\"description\";s:3:\"api\";a:4:{s:5:\"owner\";s:5:\"views\";s:3:\"api\";s:13:\"views_default\";s:15:\"minimum_version\";s:1:\"2\";s:15:\"current_version\";s:3:\"3.0\";}s:6:\"object\";s:4:\"view\";s:19:\"subrecords callback\";s:26:\"views_load_display_records\";s:6:\"status\";s:14:\"views_defaults\";s:15:\"create callback\";s:14:\"views_new_view\";s:13:\"save callback\";s:15:\"views_save_view\";s:15:\"delete callback\";s:17:\"views_delete_view\";s:15:\"export callback\";s:17:\"views_export_view\";s:15:\"status callback\";s:19:\"views_export_status\";s:14:\"cache defaults\";b:1;s:17:\"default cache bin\";s:11:\"cache_views\";}s:6:\"fields\";a:7:{s:3:\"vid\";a:4:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:9:\"no export\";b:1;}s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:7:\"default\";s:0:\"\";s:8:\"not null\";b:1;}s:11:\"description\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:7:\"default\";s:0:\"\";}s:3:\"tag\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:7:\"default\";s:0:\"\";}s:10:\"base_table\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:7:\"default\";s:0:\"\";s:8:\"not null\";b:1;}s:10:\"human_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:7:\"default\";s:0:\"\";}s:4:\"core\";a:2:{s:4:\"type\";s:3:\"int\";s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:3:\"vid\";}s:11:\"unique keys\";a:1:{s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:6:\"module\";s:5:\"views\";s:4:\"name\";s:10:\"views_view\";}s:13:\"views_display\";a:5:{s:6:\"fields\";a:6:{s:3:\"vid\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;s:9:\"no export\";b:1;}s:2:\"id\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"64\";s:7:\"default\";s:0:\"\";s:8:\"not null\";b:1;}s:13:\"display_title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"64\";s:7:\"default\";s:0:\"\";s:8:\"not null\";b:1;}s:14:\"display_plugin\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"64\";s:7:\"default\";s:0:\"\";s:8:\"not null\";b:1;}s:8:\"position\";a:2:{s:4:\"type\";s:3:\"int\";s:7:\"default\";i:0;}s:15:\"display_options\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:18:\"serialized default\";s:6:\"a:0:{}\";}}s:7:\"indexes\";a:1:{s:3:\"vid\";a:2:{i:0;s:3:\"vid\";i:1;s:8:\"position\";}}s:11:\"primary key\";a:2:{i:0;s:3:\"vid\";i:1;s:2:\"id\";}s:6:\"module\";s:5:\"views\";s:4:\"name\";s:13:\"views_display\";}s:13:\"panels_layout\";a:5:{s:6:\"export\";a:4:{s:10:\"identifier\";s:6:\"layout\";s:11:\"bulk export\";b:1;s:11:\"primary key\";s:3:\"lid\";s:3:\"api\";a:4:{s:5:\"owner\";s:6:\"panels\";s:3:\"api\";s:7:\"layouts\";s:15:\"minimum_version\";i:1;s:15:\"current_version\";i:1;}}s:6:\"fields\";a:7:{s:3:\"lid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;s:9:\"no export\";b:1;}s:4:\"name\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:11:\"admin_title\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:17:\"admin_description\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:14:\"object default\";s:0:\"\";}s:8:\"category\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:6:\"plugin\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:8:\"settings\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}}}s:11:\"primary key\";a:1:{i:0;s:3:\"lid\";}s:6:\"module\";s:6:\"panels\";s:4:\"name\";s:13:\"panels_layout\";}s:9:\"url_alias\";a:5:{s:6:\"fields\";a:4:{s:3:\"pid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:6:\"source\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"alias\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"pid\";}s:7:\"indexes\";a:2:{s:18:\"alias_language_pid\";a:3:{i:0;s:5:\"alias\";i:1;s:8:\"language\";i:2;s:3:\"pid\";}s:19:\"source_language_pid\";a:3:{i:0;s:6:\"source\";i:1;s:8:\"language\";i:2;s:3:\"pid\";}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:9:\"url_alias\";}s:11:\"menu_router\";a:5:{s:6:\"fields\";a:23:{s:4:\"path\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:14:\"load_functions\";a:2:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:1;}s:16:\"to_arg_functions\";a:2:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:1;}s:15:\"access_callback\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:16:\"access_arguments\";a:2:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;}s:13:\"page_callback\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:14:\"page_arguments\";a:2:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;}s:17:\"delivery_callback\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"fit\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:12:\"number_parts\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:7:\"context\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"tab_parent\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"tab_root\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:14:\"title_callback\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:15:\"title_arguments\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:14:\"theme_callback\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:15:\"theme_arguments\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"type\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:11:\"description\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;}s:8:\"position\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:12:\"include_file\";a:2:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:6:\"medium\";}}s:7:\"indexes\";a:3:{s:3:\"fit\";a:1:{i:0;s:3:\"fit\";}s:10:\"tab_parent\";a:3:{i:0;a:2:{i:0;s:10:\"tab_parent\";i:1;i:64;}i:1;s:6:\"weight\";i:2;s:5:\"title\";}s:21:\"tab_root_weight_title\";a:3:{i:0;a:2:{i:0;s:8:\"tab_root\";i:1;i:64;}i:1;s:6:\"weight\";i:2;s:5:\"title\";}}s:11:\"primary key\";a:1:{i:0;s:4:\"path\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:11:\"menu_router\";}s:10:\"menu_links\";a:5:{s:6:\"fields\";a:25:{s:9:\"menu_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"mlid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:4:\"plid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"link_path\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:11:\"router_path\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:10:\"link_title\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:7:\"options\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:12:\"translatable\";b:1;}s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:6:\"system\";}s:6:\"hidden\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:8:\"external\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:12:\"has_children\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:8:\"expanded\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"depth\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:10:\"customized\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:2:\"p1\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p2\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p3\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p4\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p5\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p6\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p7\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p8\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p9\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"updated\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}}s:7:\"indexes\";a:4:{s:9:\"path_menu\";a:2:{i:0;a:2:{i:0;s:9:\"link_path\";i:1;i:128;}i:1;s:9:\"menu_name\";}s:22:\"menu_plid_expand_child\";a:4:{i:0;s:9:\"menu_name\";i:1;s:4:\"plid\";i:2;s:8:\"expanded\";i:3;s:12:\"has_children\";}s:12:\"menu_parents\";a:10:{i:0;s:9:\"menu_name\";i:1;s:2:\"p1\";i:2;s:2:\"p2\";i:3;s:2:\"p3\";i:4;s:2:\"p4\";i:5;s:2:\"p5\";i:6;s:2:\"p6\";i:7;s:2:\"p7\";i:8;s:2:\"p8\";i:9;s:2:\"p9\";}s:11:\"router_path\";a:1:{i:0;a:2:{i:0;s:11:\"router_path\";i:1;i:128;}}}s:11:\"primary key\";a:1:{i:0;s:4:\"mlid\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:10:\"menu_links\";}s:21:\"ctools_custom_content\";a:5:{s:6:\"export\";a:5:{s:10:\"identifier\";s:7:\"content\";s:11:\"bulk export\";b:1;s:11:\"primary key\";s:3:\"cid\";s:3:\"api\";a:4:{s:5:\"owner\";s:21:\"ctools_custom_content\";s:3:\"api\";s:14:\"ctools_content\";s:15:\"minimum_version\";i:1;s:15:\"current_version\";i:1;}s:15:\"create callback\";s:23:\"ctools_content_type_new\";}s:6:\"fields\";a:6:{s:3:\"cid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;s:9:\"no export\";b:1;}s:4:\"name\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:11:\"admin_title\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:17:\"admin_description\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:14:\"object default\";s:0:\"\";}s:8:\"category\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:8:\"settings\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:21:\"ctools_custom_content\";s:4:\"name\";s:21:\"ctools_custom_content\";}s:11:\"panels_mini\";a:6:{s:6:\"export\";a:7:{s:10:\"identifier\";s:4:\"mini\";s:13:\"load callback\";s:16:\"panels_mini_load\";s:17:\"load all callback\";s:20:\"panels_mini_load_all\";s:13:\"save callback\";s:16:\"panels_mini_save\";s:15:\"delete callback\";s:18:\"panels_mini_delete\";s:15:\"export callback\";s:18:\"panels_mini_export\";s:3:\"api\";a:4:{s:5:\"owner\";s:11:\"panels_mini\";s:3:\"api\";s:14:\"panels_default\";s:15:\"minimum_version\";i:1;s:15:\"current_version\";i:1;}}s:6:\"fields\";a:9:{s:3:\"pid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;s:9:\"no export\";b:1;}s:4:\"name\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:8:\"category\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"64\";}s:3:\"did\";a:2:{s:4:\"type\";s:3:\"int\";s:9:\"no export\";b:1;}s:11:\"admin_title\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"128\";}s:17:\"admin_description\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:14:\"object default\";s:0:\"\";}s:16:\"requiredcontexts\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}}s:8:\"contexts\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}}s:13:\"relationships\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}}}s:11:\"primary key\";a:1:{i:0;s:3:\"pid\";}s:11:\"unique keys\";a:1:{s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:6:\"module\";s:11:\"panels_mini\";s:4:\"name\";s:11:\"panels_mini\";}}',0,1371656313,1),('schema:runtime:','a:3:{s:4:\"node\";a:7:{s:6:\"fields\";a:14:{s:3:\"nid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"vid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;s:7:\"default\";N;}s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"changed\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"comment\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"promote\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"sticky\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"tnid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"translate\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:9:{s:12:\"node_changed\";a:1:{i:0;s:7:\"changed\";}s:12:\"node_created\";a:1:{i:0;s:7:\"created\";}s:14:\"node_frontpage\";a:4:{i:0;s:7:\"promote\";i:1;s:6:\"status\";i:2;s:6:\"sticky\";i:3;s:7:\"created\";}s:16:\"node_status_type\";a:3:{i:0;s:6:\"status\";i:1;s:4:\"type\";i:2;s:3:\"nid\";}s:15:\"node_title_type\";a:2:{i:0;s:5:\"title\";i:1;a:2:{i:0;s:4:\"type\";i:1;i:4;}}s:9:\"node_type\";a:1:{i:0;a:2:{i:0;s:4:\"type\";i:1;i:4;}}s:3:\"uid\";a:1:{i:0;s:3:\"uid\";}s:4:\"tnid\";a:1:{i:0;s:4:\"tnid\";}s:9:\"translate\";a:1:{i:0;s:9:\"translate\";}}s:11:\"unique keys\";a:1:{s:3:\"vid\";a:1:{i:0;s:3:\"vid\";}}s:12:\"foreign keys\";a:2:{s:13:\"node_revision\";a:2:{s:5:\"table\";s:13:\"node_revision\";s:7:\"columns\";a:1:{s:3:\"vid\";s:3:\"vid\";}}s:11:\"node_author\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:11:\"primary key\";a:1:{i:0;s:3:\"nid\";}s:6:\"module\";s:4:\"node\";s:4:\"name\";s:4:\"node\";}s:13:\"node_revision\";a:6:{s:6:\"fields\";a:10:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"vid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"log\";a:3:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;s:4:\"size\";s:3:\"big\";}s:9:\"timestamp\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}s:7:\"comment\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"promote\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"sticky\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:2:{s:3:\"nid\";a:1:{i:0;s:3:\"nid\";}s:3:\"uid\";a:1:{i:0;s:3:\"uid\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"vid\";}s:12:\"foreign keys\";a:2:{s:14:\"versioned_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:3:\"nid\";s:3:\"nid\";}}s:14:\"version_author\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:6:\"module\";s:4:\"node\";s:4:\"name\";s:13:\"node_revision\";}s:9:\"url_alias\";a:5:{s:6:\"fields\";a:4:{s:3:\"pid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:6:\"source\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"alias\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"pid\";}s:7:\"indexes\";a:2:{s:18:\"alias_language_pid\";a:3:{i:0;s:5:\"alias\";i:1;s:8:\"language\";i:2;s:3:\"pid\";}s:19:\"source_language_pid\";a:3:{i:0;s:6:\"source\";i:1;s:8:\"language\";i:2;s:3:\"pid\";}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:9:\"url_alias\";}}',0,1371656319,1),('ctools_plugin_files:ctools:contexts','a:3:{s:6:\"ctools\";a:11:{s:14:\"node_edit_form\";O:8:\"stdClass\":3:{s:3:\"uri\";s:68:\"sites/all/modules/contrib/ctools/plugins/contexts/node_edit_form.inc\";s:8:\"filename\";s:18:\"node_edit_form.inc\";s:4:\"name\";s:14:\"node_edit_form\";}s:14:\"user_edit_form\";O:8:\"stdClass\":3:{s:3:\"uri\";s:68:\"sites/all/modules/contrib/ctools/plugins/contexts/user_edit_form.inc\";s:8:\"filename\";s:18:\"user_edit_form.inc\";s:4:\"name\";s:14:\"user_edit_form\";}s:13:\"node_add_form\";O:8:\"stdClass\":3:{s:3:\"uri\";s:67:\"sites/all/modules/contrib/ctools/plugins/contexts/node_add_form.inc\";s:8:\"filename\";s:17:\"node_add_form.inc\";s:4:\"name\";s:13:\"node_add_form\";}s:4:\"term\";O:8:\"stdClass\":3:{s:3:\"uri\";s:58:\"sites/all/modules/contrib/ctools/plugins/contexts/term.inc\";s:8:\"filename\";s:8:\"term.inc\";s:4:\"name\";s:4:\"term\";}s:5:\"terms\";O:8:\"stdClass\":3:{s:3:\"uri\";s:59:\"sites/all/modules/contrib/ctools/plugins/contexts/terms.inc\";s:8:\"filename\";s:9:\"terms.inc\";s:4:\"name\";s:5:\"terms\";}s:4:\"node\";O:8:\"stdClass\":3:{s:3:\"uri\";s:58:\"sites/all/modules/contrib/ctools/plugins/contexts/node.inc\";s:8:\"filename\";s:8:\"node.inc\";s:4:\"name\";s:4:\"node\";}s:5:\"token\";O:8:\"stdClass\":3:{s:3:\"uri\";s:59:\"sites/all/modules/contrib/ctools/plugins/contexts/token.inc\";s:8:\"filename\";s:9:\"token.inc\";s:4:\"name\";s:5:\"token\";}s:6:\"entity\";O:8:\"stdClass\":3:{s:3:\"uri\";s:60:\"sites/all/modules/contrib/ctools/plugins/contexts/entity.inc\";s:8:\"filename\";s:10:\"entity.inc\";s:4:\"name\";s:6:\"entity\";}s:10:\"vocabulary\";O:8:\"stdClass\":3:{s:3:\"uri\";s:64:\"sites/all/modules/contrib/ctools/plugins/contexts/vocabulary.inc\";s:8:\"filename\";s:14:\"vocabulary.inc\";s:4:\"name\";s:10:\"vocabulary\";}s:6:\"string\";O:8:\"stdClass\":3:{s:3:\"uri\";s:60:\"sites/all/modules/contrib/ctools/plugins/contexts/string.inc\";s:8:\"filename\";s:10:\"string.inc\";s:4:\"name\";s:6:\"string\";}s:4:\"user\";O:8:\"stdClass\":3:{s:3:\"uri\";s:58:\"sites/all/modules/contrib/ctools/plugins/contexts/user.inc\";s:8:\"filename\";s:8:\"user.inc\";s:4:\"name\";s:4:\"user\";}}s:6:\"panels\";a:0:{}s:13:\"views_content\";a:1:{s:4:\"view\";O:8:\"stdClass\":3:{s:3:\"uri\";s:72:\"sites/all/modules/contrib/ctools/views_content/plugins/contexts/view.inc\";s:8:\"filename\";s:8:\"view.inc\";s:4:\"name\";s:4:\"view\";}}}',0,1371656327,1),('ctools_plugin_files:ctools:access','a:3:{s:6:\"ctools\";a:22:{s:13:\"site_language\";O:8:\"stdClass\":3:{s:3:\"uri\";s:65:\"sites/all/modules/contrib/ctools/plugins/access/site_language.inc\";s:8:\"filename\";s:17:\"site_language.inc\";s:4:\"name\";s:13:\"site_language\";}s:5:\"theme\";O:8:\"stdClass\":3:{s:3:\"uri\";s:57:\"sites/all/modules/contrib/ctools/plugins/access/theme.inc\";s:8:\"filename\";s:9:\"theme.inc\";s:4:\"name\";s:5:\"theme\";}s:9:\"node_type\";O:8:\"stdClass\":3:{s:3:\"uri\";s:61:\"sites/all/modules/contrib/ctools/plugins/access/node_type.inc\";s:8:\"filename\";s:13:\"node_type.inc\";s:4:\"name\";s:9:\"node_type\";}s:13:\"entity_bundle\";O:8:\"stdClass\":3:{s:3:\"uri\";s:65:\"sites/all/modules/contrib/ctools/plugins/access/entity_bundle.inc\";s:8:\"filename\";s:17:\"entity_bundle.inc\";s:4:\"name\";s:13:\"entity_bundle\";}s:4:\"perm\";O:8:\"stdClass\":3:{s:3:\"uri\";s:56:\"sites/all/modules/contrib/ctools/plugins/access/perm.inc\";s:8:\"filename\";s:8:\"perm.inc\";s:4:\"name\";s:4:\"perm\";}s:11:\"node_access\";O:8:\"stdClass\":3:{s:3:\"uri\";s:63:\"sites/all/modules/contrib/ctools/plugins/access/node_access.inc\";s:8:\"filename\";s:15:\"node_access.inc\";s:4:\"name\";s:11:\"node_access\";}s:15:\"path_visibility\";O:8:\"stdClass\":3:{s:3:\"uri\";s:67:\"sites/all/modules/contrib/ctools/plugins/access/path_visibility.inc\";s:8:\"filename\";s:19:\"path_visibility.inc\";s:4:\"name\";s:15:\"path_visibility\";}s:14:\"context_exists\";O:8:\"stdClass\":3:{s:3:\"uri\";s:66:\"sites/all/modules/contrib/ctools/plugins/access/context_exists.inc\";s:8:\"filename\";s:18:\"context_exists.inc\";s:4:\"name\";s:14:\"context_exists\";}s:4:\"term\";O:8:\"stdClass\":3:{s:3:\"uri\";s:56:\"sites/all/modules/contrib/ctools/plugins/access/term.inc\";s:8:\"filename\";s:8:\"term.inc\";s:4:\"name\";s:4:\"term\";}s:15:\"term_has_parent\";O:8:\"stdClass\":3:{s:3:\"uri\";s:67:\"sites/all/modules/contrib/ctools/plugins/access/term_has_parent.inc\";s:8:\"filename\";s:19:\"term_has_parent.inc\";s:4:\"name\";s:15:\"term_has_parent\";}s:13:\"compare_users\";O:8:\"stdClass\":3:{s:3:\"uri\";s:65:\"sites/all/modules/contrib/ctools/plugins/access/compare_users.inc\";s:8:\"filename\";s:17:\"compare_users.inc\";s:4:\"name\";s:13:\"compare_users\";}s:11:\"term_parent\";O:8:\"stdClass\":3:{s:3:\"uri\";s:63:\"sites/all/modules/contrib/ctools/plugins/access/term_parent.inc\";s:8:\"filename\";s:15:\"term_parent.inc\";s:4:\"name\";s:11:\"term_parent\";}s:5:\"front\";O:8:\"stdClass\":3:{s:3:\"uri\";s:57:\"sites/all/modules/contrib/ctools/plugins/access/front.inc\";s:8:\"filename\";s:9:\"front.inc\";s:4:\"name\";s:5:\"front\";}s:3:\"php\";O:8:\"stdClass\":3:{s:3:\"uri\";s:55:\"sites/all/modules/contrib/ctools/plugins/access/php.inc\";s:8:\"filename\";s:7:\"php.inc\";s:4:\"name\";s:3:\"php\";}s:18:\"entity_field_value\";O:8:\"stdClass\":3:{s:3:\"uri\";s:70:\"sites/all/modules/contrib/ctools/plugins/access/entity_field_value.inc\";s:8:\"filename\";s:22:\"entity_field_value.inc\";s:4:\"name\";s:18:\"entity_field_value\";}s:15:\"term_vocabulary\";O:8:\"stdClass\":3:{s:3:\"uri\";s:67:\"sites/all/modules/contrib/ctools/plugins/access/term_vocabulary.inc\";s:8:\"filename\";s:19:\"term_vocabulary.inc\";s:4:\"name\";s:15:\"term_vocabulary\";}s:4:\"node\";O:8:\"stdClass\":3:{s:3:\"uri\";s:56:\"sites/all/modules/contrib/ctools/plugins/access/node.inc\";s:8:\"filename\";s:8:\"node.inc\";s:4:\"name\";s:4:\"node\";}s:11:\"node_status\";O:8:\"stdClass\":3:{s:3:\"uri\";s:63:\"sites/all/modules/contrib/ctools/plugins/access/node_status.inc\";s:8:\"filename\";s:15:\"node_status.inc\";s:4:\"name\";s:11:\"node_status\";}s:12:\"string_equal\";O:8:\"stdClass\":3:{s:3:\"uri\";s:64:\"sites/all/modules/contrib/ctools/plugins/access/string_equal.inc\";s:8:\"filename\";s:16:\"string_equal.inc\";s:4:\"name\";s:12:\"string_equal\";}s:4:\"role\";O:8:\"stdClass\":3:{s:3:\"uri\";s:56:\"sites/all/modules/contrib/ctools/plugins/access/role.inc\";s:8:\"filename\";s:8:\"role.inc\";s:4:\"name\";s:4:\"role\";}s:13:\"string_length\";O:8:\"stdClass\":3:{s:3:\"uri\";s:65:\"sites/all/modules/contrib/ctools/plugins/access/string_length.inc\";s:8:\"filename\";s:17:\"string_length.inc\";s:4:\"name\";s:13:\"string_length\";}s:13:\"node_language\";O:8:\"stdClass\":3:{s:3:\"uri\";s:65:\"sites/all/modules/contrib/ctools/plugins/access/node_language.inc\";s:8:\"filename\";s:17:\"node_language.inc\";s:4:\"name\";s:13:\"node_language\";}}s:6:\"panels\";a:0:{}s:13:\"views_content\";a:0:{}}',0,1371656327,1),('filter_list_format','a:4:{s:9:\"full_html\";a:5:{s:11:\"filter_html\";O:8:\"stdClass\":6:{s:6:\"format\";s:9:\"full_html\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:11:\"filter_html\";s:6:\"weight\";s:3:\"-10\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:168:\"a:3:{s:12:\"allowed_html\";s:74:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}\";}s:18:\"filter_html_escape\";O:8:\"stdClass\":6:{s:6:\"format\";s:9:\"full_html\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:18:\"filter_html_escape\";s:6:\"weight\";s:3:\"-10\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:6:\"a:0:{}\";}s:10:\"filter_url\";O:8:\"stdClass\":6:{s:6:\"format\";s:9:\"full_html\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:10:\"filter_url\";s:6:\"weight\";s:1:\"0\";s:6:\"status\";s:1:\"1\";s:8:\"settings\";s:36:\"a:1:{s:17:\"filter_url_length\";i:72;}\";}s:12:\"filter_autop\";O:8:\"stdClass\":6:{s:6:\"format\";s:9:\"full_html\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:12:\"filter_autop\";s:6:\"weight\";s:1:\"1\";s:6:\"status\";s:1:\"1\";s:8:\"settings\";s:6:\"a:0:{}\";}s:20:\"filter_htmlcorrector\";O:8:\"stdClass\":6:{s:6:\"format\";s:9:\"full_html\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:20:\"filter_htmlcorrector\";s:6:\"weight\";s:2:\"10\";s:6:\"status\";s:1:\"1\";s:8:\"settings\";s:6:\"a:0:{}\";}}s:8:\"php_code\";a:6:{s:11:\"filter_html\";O:8:\"stdClass\":6:{s:6:\"format\";s:8:\"php_code\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:11:\"filter_html\";s:6:\"weight\";s:3:\"-10\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:168:\"a:3:{s:12:\"allowed_html\";s:74:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}\";}s:18:\"filter_html_escape\";O:8:\"stdClass\":6:{s:6:\"format\";s:8:\"php_code\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:18:\"filter_html_escape\";s:6:\"weight\";s:3:\"-10\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:6:\"a:0:{}\";}s:12:\"filter_autop\";O:8:\"stdClass\":6:{s:6:\"format\";s:8:\"php_code\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:12:\"filter_autop\";s:6:\"weight\";s:1:\"0\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:6:\"a:0:{}\";}s:10:\"filter_url\";O:8:\"stdClass\":6:{s:6:\"format\";s:8:\"php_code\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:10:\"filter_url\";s:6:\"weight\";s:1:\"0\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:36:\"a:1:{s:17:\"filter_url_length\";i:72;}\";}s:8:\"php_code\";O:8:\"stdClass\":6:{s:6:\"format\";s:8:\"php_code\";s:6:\"module\";s:3:\"php\";s:4:\"name\";s:8:\"php_code\";s:6:\"weight\";s:1:\"0\";s:6:\"status\";s:1:\"1\";s:8:\"settings\";s:6:\"a:0:{}\";}s:20:\"filter_htmlcorrector\";O:8:\"stdClass\":6:{s:6:\"format\";s:8:\"php_code\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:20:\"filter_htmlcorrector\";s:6:\"weight\";s:2:\"10\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:6:\"a:0:{}\";}}s:10:\"plain_text\";a:5:{s:11:\"filter_html\";O:8:\"stdClass\":6:{s:6:\"format\";s:10:\"plain_text\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:11:\"filter_html\";s:6:\"weight\";s:3:\"-10\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:168:\"a:3:{s:12:\"allowed_html\";s:74:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}\";}s:18:\"filter_html_escape\";O:8:\"stdClass\":6:{s:6:\"format\";s:10:\"plain_text\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:18:\"filter_html_escape\";s:6:\"weight\";s:1:\"0\";s:6:\"status\";s:1:\"1\";s:8:\"settings\";s:6:\"a:0:{}\";}s:10:\"filter_url\";O:8:\"stdClass\":6:{s:6:\"format\";s:10:\"plain_text\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:10:\"filter_url\";s:6:\"weight\";s:1:\"1\";s:6:\"status\";s:1:\"1\";s:8:\"settings\";s:36:\"a:1:{s:17:\"filter_url_length\";i:72;}\";}s:12:\"filter_autop\";O:8:\"stdClass\":6:{s:6:\"format\";s:10:\"plain_text\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:12:\"filter_autop\";s:6:\"weight\";s:1:\"2\";s:6:\"status\";s:1:\"1\";s:8:\"settings\";s:6:\"a:0:{}\";}s:20:\"filter_htmlcorrector\";O:8:\"stdClass\":6:{s:6:\"format\";s:10:\"plain_text\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:20:\"filter_htmlcorrector\";s:6:\"weight\";s:2:\"10\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:6:\"a:0:{}\";}}s:13:\"filtered_html\";a:5:{s:18:\"filter_html_escape\";O:8:\"stdClass\":6:{s:6:\"format\";s:13:\"filtered_html\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:18:\"filter_html_escape\";s:6:\"weight\";s:3:\"-10\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:6:\"a:0:{}\";}s:10:\"filter_url\";O:8:\"stdClass\":6:{s:6:\"format\";s:13:\"filtered_html\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:10:\"filter_url\";s:6:\"weight\";s:1:\"0\";s:6:\"status\";s:1:\"1\";s:8:\"settings\";s:36:\"a:1:{s:17:\"filter_url_length\";i:72;}\";}s:11:\"filter_html\";O:8:\"stdClass\":6:{s:6:\"format\";s:13:\"filtered_html\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:11:\"filter_html\";s:6:\"weight\";s:1:\"1\";s:6:\"status\";s:1:\"1\";s:8:\"settings\";s:168:\"a:3:{s:12:\"allowed_html\";s:74:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}\";}s:12:\"filter_autop\";O:8:\"stdClass\":6:{s:6:\"format\";s:13:\"filtered_html\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:12:\"filter_autop\";s:6:\"weight\";s:1:\"2\";s:6:\"status\";s:1:\"1\";s:8:\"settings\";s:6:\"a:0:{}\";}s:20:\"filter_htmlcorrector\";O:8:\"stdClass\":6:{s:6:\"format\";s:13:\"filtered_html\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:20:\"filter_htmlcorrector\";s:6:\"weight\";s:2:\"10\";s:6:\"status\";s:1:\"1\";s:8:\"settings\";s:6:\"a:0:{}\";}}}',0,1371656328,1),('theme_registry:mercury','a:317:{s:10:\"breadcrumb\";a:4:{s:8:\"function\";s:18:\"mercury_breadcrumb\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";s:9:\"variables\";a:1:{s:10:\"breadcrumb\";N;}}s:9:\"menu_link\";a:4:{s:8:\"function\";s:17:\"mercury_menu_link\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";s:14:\"render element\";s:7:\"element\";}s:16:\"menu_local_tasks\";a:4:{s:8:\"function\";s:24:\"mercury_menu_local_tasks\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";s:9:\"variables\";a:2:{s:7:\"primary\";a:0:{}s:9:\"secondary\";a:0:{}}}s:7:\"comment\";a:7:{s:8:\"template\";s:7:\"comment\";s:4:\"path\";s:34:\"sites/all/themes/mercury/templates\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";s:14:\"render element\";s:8:\"elements\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:27:\"template_preprocess_comment\";i:2;s:22:\"rdf_preprocess_comment\";i:3;s:24:\"views_preprocess_comment\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:4:\"page\";a:7:{s:8:\"template\";s:4:\"page\";s:4:\"path\";s:34:\"sites/all/themes/mercury/templates\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";s:14:\"render element\";s:4:\"page\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:24:\"template_preprocess_page\";i:2;s:24:\"shortcut_preprocess_page\";i:3;s:23:\"mercury_preprocess_page\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:21:\"template_process_page\";i:2;s:11:\"rdf_process\";}}s:4:\"node\";a:7:{s:8:\"template\";s:4:\"node\";s:4:\"path\";s:34:\"sites/all/themes/mercury/templates\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";s:14:\"render element\";s:8:\"elements\";s:20:\"preprocess functions\";a:7:{i:0;s:19:\"template_preprocess\";i:1;s:24:\"template_preprocess_node\";i:2;s:22:\"ctools_preprocess_node\";i:3;s:30:\"node_reference_preprocess_node\";i:4;s:19:\"rdf_preprocess_node\";i:5;s:21:\"views_preprocess_node\";i:6;s:23:\"mercury_preprocess_node\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:5:\"block\";a:7:{s:8:\"template\";s:5:\"block\";s:4:\"path\";s:34:\"sites/all/themes/mercury/templates\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";s:14:\"render element\";s:8:\"elements\";s:20:\"preprocess functions\";a:5:{i:0;s:19:\"template_preprocess\";i:1;s:25:\"template_preprocess_block\";i:2;s:28:\"block_class_preprocess_block\";i:3;s:23:\"system_preprocess_block\";i:4;s:24:\"mercury_preprocess_block\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:4:\"html\";a:7:{s:8:\"template\";s:4:\"html\";s:4:\"path\";s:34:\"sites/all/themes/mercury/templates\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";s:14:\"render element\";s:4:\"page\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:24:\"template_preprocess_html\";i:2;s:22:\"panels_preprocess_html\";i:3;s:21:\"views_preprocess_html\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:21:\"template_process_html\";i:2;s:11:\"rdf_process\";}}s:47:\"views_view_field__field_fa_administration_state\";a:6:{s:8:\"template\";s:47:\"views-view-field--field-fa-administration-state\";s:4:\"path\";s:34:\"sites/all/themes/mercury/templates\";s:9:\"variables\";a:3:{s:4:\"view\";N;s:5:\"field\";N;s:3:\"row\";N;}s:9:\"base hook\";s:16:\"views_view_field\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";}s:44:\"views_view_field__field_fa_operational_state\";a:6:{s:8:\"template\";s:44:\"views-view-field--field-fa-operational-state\";s:4:\"path\";s:34:\"sites/all/themes/mercury/templates\";s:9:\"variables\";a:3:{s:4:\"view\";N;s:5:\"field\";N;s:3:\"row\";N;}s:9:\"base hook\";s:16:\"views_view_field\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";}s:47:\"views_view_field__all_vm__field_driver_status_1\";a:6:{s:8:\"template\";s:47:\"views-view-field--all-vm--field-driver-status-1\";s:4:\"path\";s:34:\"sites/all/themes/mercury/templates\";s:9:\"variables\";a:3:{s:4:\"view\";N;s:5:\"field\";N;s:3:\"row\";N;}s:9:\"base hook\";s:16:\"views_view_field\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";}s:47:\"views_view_field__all_host__field_bundle_status\";a:6:{s:8:\"template\";s:47:\"views-view-field--all-host--field-bundle-status\";s:4:\"path\";s:34:\"sites/all/themes/mercury/templates\";s:9:\"variables\";a:3:{s:4:\"view\";N;s:5:\"field\";N;s:3:\"row\";N;}s:9:\"base hook\";s:16:\"views_view_field\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";}s:58:\"views_view_unformatted__vdisk_metric_per_vm__entity_view_1\";a:6:{s:8:\"template\";s:58:\"views-view-unformatted--vdisk-metric-per-vm--entity-view-1\";s:4:\"path\";s:34:\"sites/all/themes/mercury/templates\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:9:\"base hook\";s:22:\"views_view_unformatted\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";}s:49:\"views_view_unformatted__vm_metrics__entity_view_1\";a:6:{s:8:\"template\";s:49:\"views-view-unformatted--vm-metrics--entity-view-1\";s:4:\"path\";s:34:\"sites/all/themes/mercury/templates\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:9:\"base hook\";s:22:\"views_view_unformatted\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";}s:58:\"views_view_unformatted__vdisk_metric_per_vm__entity_view_2\";a:6:{s:8:\"template\";s:58:\"views-view-unformatted--vdisk-metric-per-vm--entity-view-2\";s:4:\"path\";s:34:\"sites/all/themes/mercury/templates\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:9:\"base hook\";s:22:\"views_view_unformatted\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";}s:10:\"node__host\";a:6:{s:8:\"template\";s:10:\"node--host\";s:4:\"path\";s:34:\"sites/all/themes/mercury/templates\";s:14:\"render element\";s:8:\"elements\";s:9:\"base hook\";s:4:\"node\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";}s:21:\"node__virtual_machine\";a:6:{s:8:\"template\";s:21:\"node--virtual_machine\";s:4:\"path\";s:34:\"sites/all/themes/mercury/templates\";s:14:\"render element\";s:8:\"elements\";s:9:\"base hook\";s:4:\"node\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";}s:16:\"admin_menu_links\";a:4:{s:14:\"render element\";s:8:\"elements\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:36:\"sites/all/modules/contrib/admin_menu\";s:8:\"function\";s:22:\"theme_admin_menu_links\";}s:15:\"admin_menu_icon\";a:7:{s:9:\"variables\";a:2:{s:3:\"src\";N;s:3:\"alt\";N;}s:4:\"file\";s:14:\"admin_menu.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:36:\"sites/all/modules/contrib/admin_menu\";s:8:\"function\";s:21:\"theme_admin_menu_icon\";s:8:\"includes\";a:1:{i:0;s:51:\"sites/all/modules/contrib/admin_menu/admin_menu.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:35:\"template_preprocess_admin_menu_icon\";}}s:30:\"page_manager_handler_rearrange\";a:7:{s:14:\"render element\";s:4:\"form\";s:4:\"path\";s:51:\"sites/all/modules/contrib/ctools/page_manager/theme\";s:4:\"file\";s:22:\"page_manager.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:45:\"sites/all/modules/contrib/ctools/page_manager\";s:8:\"function\";s:36:\"theme_page_manager_handler_rearrange\";s:8:\"includes\";a:1:{i:0;s:74:\"sites/all/modules/contrib/ctools/page_manager/theme/page_manager.theme.inc\";}}s:22:\"page_manager_edit_page\";a:9:{s:8:\"template\";s:22:\"page-manager-edit-page\";s:9:\"variables\";a:4:{s:4:\"page\";N;s:4:\"save\";N;s:10:\"operations\";a:0:{}s:7:\"content\";a:0:{}}s:4:\"path\";s:51:\"sites/all/modules/contrib/ctools/page_manager/theme\";s:4:\"file\";s:22:\"page_manager.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:45:\"sites/all/modules/contrib/ctools/page_manager\";s:8:\"includes\";a:1:{i:0;s:74:\"sites/all/modules/contrib/ctools/page_manager/theme/page_manager.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:42:\"template_preprocess_page_manager_edit_page\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:17:\"page_manager_lock\";a:7:{s:9:\"variables\";a:1:{s:4:\"page\";a:0:{}}s:4:\"path\";s:51:\"sites/all/modules/contrib/ctools/page_manager/theme\";s:4:\"file\";s:22:\"page_manager.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:45:\"sites/all/modules/contrib/ctools/page_manager\";s:8:\"function\";s:23:\"theme_page_manager_lock\";s:8:\"includes\";a:1:{i:0;s:74:\"sites/all/modules/contrib/ctools/page_manager/theme/page_manager.theme.inc\";}}s:20:\"page_manager_changed\";a:7:{s:9:\"variables\";a:2:{s:4:\"text\";N;s:11:\"description\";N;}s:4:\"path\";s:51:\"sites/all/modules/contrib/ctools/page_manager/theme\";s:4:\"file\";s:22:\"page_manager.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:45:\"sites/all/modules/contrib/ctools/page_manager\";s:8:\"function\";s:26:\"theme_page_manager_changed\";s:8:\"includes\";a:1:{i:0;s:74:\"sites/all/modules/contrib/ctools/page_manager/theme/page_manager.theme.inc\";}}s:37:\"page_manager_page_form_argument_table\";a:7:{s:4:\"file\";s:14:\"page.admin.inc\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:45:\"sites/all/modules/contrib/ctools/page_manager\";s:8:\"function\";s:43:\"theme_page_manager_page_form_argument_table\";s:8:\"includes\";a:1:{i:0;s:74:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.admin.inc\";}}s:22:\"page_manager_page_lock\";a:7:{s:4:\"file\";s:14:\"page.admin.inc\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks\";s:9:\"variables\";a:2:{s:4:\"lock\";a:0:{}s:9:\"task_name\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:45:\"sites/all/modules/contrib/ctools/page_manager\";s:8:\"function\";s:28:\"theme_page_manager_page_lock\";s:8:\"includes\";a:1:{i:0;s:74:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.admin.inc\";}}s:25:\"page_manager_page_changed\";a:7:{s:4:\"file\";s:14:\"page.admin.inc\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks\";s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:45:\"sites/all/modules/contrib/ctools/page_manager\";s:8:\"function\";s:31:\"theme_page_manager_page_changed\";s:8:\"includes\";a:1:{i:0;s:74:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.admin.inc\";}}s:16:\"views_mini_pager\";a:8:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"tags\";a:0:{}s:8:\"quantity\";i:10;s:7:\"element\";i:0;s:10:\"parameters\";a:0:{}}s:7:\"pattern\";s:18:\"views_mini_pager__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:22:\"theme_views_mini_pager\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}}s:16:\"views_view_field\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:7:\"pattern\";s:18:\"views_view_field__\";s:9:\"variables\";a:3:{s:4:\"view\";N;s:5:\"field\";N;s:3:\"row\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:22:\"theme_views_view_field\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:36:\"template_preprocess_views_view_field\";}}s:19:\"views_view_grouping\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:7:\"pattern\";s:21:\"views_view_grouping__\";s:9:\"variables\";a:5:{s:4:\"view\";N;s:8:\"grouping\";N;s:14:\"grouping_level\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:25:\"theme_views_view_grouping\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:39:\"template_preprocess_views_view_grouping\";}}s:10:\"views_view\";a:10:{s:7:\"pattern\";s:12:\"views_view__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:2:{s:10:\"view_array\";a:0:{}s:4:\"view\";N;}s:8:\"template\";s:10:\"views-view\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:30:\"template_preprocess_views_view\";i:2;s:32:\"date_views_preprocess_views_view\";i:3;s:30:\"views_ui_preprocess_views_view\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:27:\"template_process_views_view\";i:2;s:11:\"rdf_process\";}}s:23:\"eva_display_entity_view\";a:10:{s:7:\"pattern\";s:25:\"eva_display_entity_view__\";s:4:\"file\";s:13:\"eva.views.inc\";s:4:\"path\";s:29:\"sites/all/modules/contrib/eva\";s:9:\"variables\";a:2:{s:10:\"view_array\";a:0:{}s:4:\"view\";N;}s:8:\"template\";s:23:\"eva-display-entity-view\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:43:\"sites/all/modules/contrib/eva/eva.views.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:43:\"template_preprocess_eva_display_entity_view\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:40:\"template_process_eva_display_entity_view\";i:2;s:11:\"rdf_process\";}}s:15:\"date_navigation\";a:10:{s:7:\"pattern\";s:17:\"date_navigation__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:47:\"sites/all/modules/contrib/date/date_views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:15:\"date-navigation\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/date/date_views/theme/theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:22:\"views_view_unformatted\";a:10:{s:7:\"pattern\";s:24:\"views_view_unformatted__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:22:\"views-view-unformatted\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:42:\"template_preprocess_views_view_unformatted\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:17:\"views_data_export\";a:10:{s:7:\"pattern\";s:19:\"views_data_export__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:17:\"views-data-export\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:37:\"template_preprocess_views_data_export\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_csv_header\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_csv_header__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-csv-header\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_views_data_export_csv_header\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:26:\"views_data_export_csv_body\";a:10:{s:7:\"pattern\";s:28:\"views_data_export_csv_body__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:26:\"views-data-export-csv-body\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:46:\"template_preprocess_views_data_export_csv_body\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_csv_footer\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_csv_footer__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-csv-footer\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_doc_header\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_doc_header__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-doc-header\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_views_data_export_doc_header\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:26:\"views_data_export_doc_body\";a:10:{s:7:\"pattern\";s:28:\"views_data_export_doc_body__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:26:\"views-data-export-doc-body\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:46:\"template_preprocess_views_data_export_doc_body\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_doc_footer\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_doc_footer__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-doc-footer\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_txt_header\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_txt_header__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-txt-header\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:26:\"views_data_export_txt_body\";a:10:{s:7:\"pattern\";s:28:\"views_data_export_txt_body__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:26:\"views-data-export-txt-body\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:46:\"template_preprocess_views_data_export_txt_body\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_txt_footer\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_txt_footer__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-txt-footer\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_xls_header\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_xls_header__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-xls-header\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_views_data_export_xls_header\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:26:\"views_data_export_xls_body\";a:10:{s:7:\"pattern\";s:28:\"views_data_export_xls_body__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:26:\"views-data-export-xls-body\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:46:\"template_preprocess_views_data_export_xls_body\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_xls_footer\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_xls_footer__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-xls-footer\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_xml_header\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_xml_header__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-xml-header\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_views_data_export_xml_header\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:26:\"views_data_export_xml_body\";a:10:{s:7:\"pattern\";s:28:\"views_data_export_xml_body__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:26:\"views-data-export-xml-body\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:46:\"template_preprocess_views_data_export_xml_body\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_data_export_xml_footer\";a:10:{s:7:\"pattern\";s:30:\"views_data_export_xml_footer__\";s:4:\"file\";s:27:\"views_data_export.theme.inc\";s:4:\"path\";s:49:\"sites/all/modules/contrib/views_data_export/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-data-export-xml-footer\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_views_data_export_xml_footer\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:25:\"views_view_watchdog_table\";a:10:{s:7:\"pattern\";s:27:\"views_view_watchdog_table__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:52:\"sites/all/modules/contrib/views_watchdog/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:25:\"views-view-watchdog-table\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:62:\"sites/all/modules/contrib/views_watchdog/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:45:\"template_preprocess_views_view_watchdog_table\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:15:\"views_view_list\";a:10:{s:7:\"pattern\";s:17:\"views_view_list__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:15:\"views-view-list\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:35:\"template_preprocess_views_view_list\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:15:\"views_view_grid\";a:10:{s:7:\"pattern\";s:17:\"views_view_grid__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:15:\"views-view-grid\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:35:\"template_preprocess_views_view_grid\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:16:\"views_view_table\";a:10:{s:7:\"pattern\";s:18:\"views_view_table__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:16:\"views-view-table\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_views_view_table\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:18:\"views_view_summary\";a:10:{s:7:\"pattern\";s:20:\"views_view_summary__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:18:\"views-view-summary\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:38:\"template_preprocess_views_view_summary\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:30:\"views_view_summary_unformatted\";a:10:{s:7:\"pattern\";s:32:\"views_view_summary_unformatted__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:30:\"views-view-summary-unformatted\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:50:\"template_preprocess_views_view_summary_unformatted\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:14:\"views_view_rss\";a:10:{s:7:\"pattern\";s:16:\"views_view_rss__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:14:\"views-view-rss\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:34:\"template_preprocess_views_view_rss\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"views_view_summary_jump_menu\";a:10:{s:7:\"pattern\";s:30:\"views_view_summary_jump_menu__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-view-summary-jump-menu\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:20:\"views_view_jump_menu\";a:10:{s:7:\"pattern\";s:22:\"views_view_jump_menu__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:20:\"views-view-jump-menu\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:22:\"views_view_row_comment\";a:10:{s:7:\"pattern\";s:24:\"views_view_row_comment__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:3:\"row\";N;s:11:\"field_alias\";N;}s:8:\"template\";s:22:\"views-view-row-comment\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:42:\"template_preprocess_views_view_row_comment\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:18:\"views_view_row_rss\";a:10:{s:7:\"pattern\";s:20:\"views_view_row_rss__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:3:\"row\";N;s:11:\"field_alias\";N;}s:8:\"template\";s:18:\"views-view-row-rss\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:38:\"template_preprocess_views_view_row_rss\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:17:\"views_view_fields\";a:10:{s:7:\"pattern\";s:19:\"views_view_fields__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:3:\"row\";N;s:11:\"field_alias\";N;}s:8:\"template\";s:17:\"views-view-fields\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:37:\"template_preprocess_views_view_fields\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:21:\"views_form_views_form\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:27:\"theme_views_form_views_form\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}}s:18:\"views_exposed_form\";a:10:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:8:\"template\";s:18:\"views-exposed-form\";s:7:\"pattern\";s:20:\"views_exposed_form__\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:38:\"template_preprocess_views_exposed_form\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:10:\"views_more\";a:10:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:8:\"template\";s:10:\"views-more\";s:7:\"pattern\";s:12:\"views_more__\";s:9:\"variables\";a:3:{s:8:\"more_url\";N;s:9:\"link_text\";s:4:\"more\";s:4:\"view\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:15:\"horizontal_tabs\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/field_group\";s:8:\"function\";s:21:\"theme_horizontal_tabs\";}s:9:\"multipage\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/field_group\";s:8:\"function\";s:15:\"theme_multipage\";}s:14:\"multipage_pane\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/field_group\";s:8:\"function\";s:20:\"theme_multipage_pane\";}s:28:\"views_ui_display_tab_setting\";a:7:{s:9:\"variables\";a:7:{s:11:\"description\";s:0:\"\";s:4:\"link\";s:0:\"\";s:14:\"settings_links\";a:0:{}s:10:\"overridden\";b:0;s:9:\"defaulted\";b:0;s:21:\"description_separator\";b:1;s:5:\"class\";a:0:{}}s:8:\"template\";s:28:\"views-ui-display-tab-setting\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_views_ui_display_tab_setting\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:27:\"views_ui_display_tab_bucket\";a:7:{s:14:\"render element\";s:7:\"element\";s:8:\"template\";s:27:\"views-ui-display-tab-bucket\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:47:\"template_preprocess_views_ui_display_tab_bucket\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:18:\"views_ui_edit_item\";a:7:{s:9:\"variables\";a:4:{s:4:\"type\";N;s:4:\"view\";N;s:7:\"display\";N;s:9:\"no_fields\";b:0;}s:8:\"template\";s:18:\"views-ui-edit-item\";s:4:\"path\";s:37:\"sites/all/modules/contrib/views/theme\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:23:\"views_ui_rearrange_form\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:29:\"theme_views_ui_rearrange_form\";}s:30:\"views_ui_rearrange_filter_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:36:\"theme_views_ui_rearrange_filter_form\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/contrib/views/includes/admin.inc\";}}s:27:\"views_ui_expose_filter_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:33:\"theme_views_ui_expose_filter_form\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/contrib/views/includes/admin.inc\";}}s:18:\"views_ui_view_info\";a:6:{s:9:\"variables\";a:2:{s:4:\"view\";N;s:4:\"base\";N;}s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:24:\"theme_views_ui_view_info\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/contrib/views/includes/admin.inc\";}}s:32:\"views_ui_build_group_filter_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:38:\"theme_views_ui_build_group_filter_form\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/contrib/views/includes/admin.inc\";}}s:12:\"views_tabset\";a:4:{s:9:\"variables\";a:1:{s:4:\"tabs\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:18:\"theme_views_tabset\";}s:9:\"views_tab\";a:4:{s:9:\"variables\";a:1:{s:4:\"body\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:15:\"theme_views_tab\";}s:30:\"views_ui_reorder_displays_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:36:\"theme_views_ui_reorder_displays_form\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/contrib/views/includes/admin.inc\";}}s:27:\"views_ui_style_plugin_table\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:33:\"theme_views_ui_style_plugin_table\";}s:29:\"views_ui_view_preview_section\";a:5:{s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"section\";N;s:7:\"content\";N;s:5:\"links\";s:0:\"\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:35:\"theme_views_ui_view_preview_section\";s:20:\"preprocess functions\";a:1:{i:0;s:49:\"template_preprocess_views_ui_view_preview_section\";}}s:15:\"views_container\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:15:\"theme/theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/views\";s:8:\"function\";s:21:\"theme_views_container\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/views/theme/theme.inc\";}}s:27:\"views_data_export_feed_icon\";a:7:{s:7:\"pattern\";s:29:\"views_data_export_feed_icon__\";s:9:\"variables\";a:4:{s:10:\"image_path\";N;s:3:\"url\";N;s:5:\"query\";s:0:\"\";s:4:\"text\";s:0:\"\";}s:4:\"file\";s:33:\"theme/views_data_export.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/views_data_export\";s:8:\"function\";s:33:\"theme_views_data_export_feed_icon\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}}s:31:\"views_data_export_complete_page\";a:6:{s:9:\"variables\";a:3:{s:4:\"file\";s:0:\"\";s:6:\"errors\";a:0:{}s:10:\"return_url\";s:0:\"\";}s:4:\"file\";s:33:\"theme/views_data_export.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/views_data_export\";s:8:\"function\";s:37:\"theme_views_data_export_complete_page\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}}s:25:\"views_data_export_message\";a:6:{s:9:\"variables\";a:2:{s:7:\"message\";s:0:\"\";s:4:\"type\";s:4:\"info\";}s:4:\"file\";s:33:\"theme/views_data_export.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/views_data_export\";s:8:\"function\";s:31:\"theme_views_data_export_message\";s:8:\"includes\";a:1:{i:0;s:77:\"sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc\";}}s:12:\"user_picture\";a:6:{s:9:\"variables\";a:1:{s:7:\"account\";N;}s:8:\"template\";s:25:\"modules/user/user-picture\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:32:\"template_preprocess_user_picture\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:12:\"user_profile\";a:8:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:25:\"modules/user/user-profile\";s:4:\"file\";s:14:\"user.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.pages.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:32:\"template_preprocess_user_profile\";i:2;s:27:\"rdf_preprocess_user_profile\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:21:\"user_profile_category\";a:8:{s:14:\"render element\";s:7:\"element\";s:8:\"template\";s:34:\"modules/user/user-profile-category\";s:4:\"file\";s:14:\"user.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.pages.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:41:\"template_preprocess_user_profile_category\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:17:\"user_profile_item\";a:8:{s:14:\"render element\";s:7:\"element\";s:8:\"template\";s:30:\"modules/user/user-profile-item\";s:4:\"file\";s:14:\"user.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.pages.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:37:\"template_preprocess_user_profile_item\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:9:\"user_list\";a:4:{s:9:\"variables\";a:2:{s:5:\"users\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:15:\"theme_user_list\";}s:22:\"user_admin_permissions\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:14:\"user.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:28:\"theme_user_admin_permissions\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.admin.inc\";}}s:16:\"user_admin_roles\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:14:\"user.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:22:\"theme_user_admin_roles\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.admin.inc\";}}s:27:\"user_permission_description\";a:6:{s:9:\"variables\";a:2:{s:15:\"permission_item\";N;s:4:\"hide\";N;}s:4:\"file\";s:14:\"user.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:33:\"theme_user_permission_description\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.admin.inc\";}}s:14:\"user_signature\";a:4:{s:9:\"variables\";a:1:{s:9:\"signature\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:20:\"theme_user_signature\";}s:10:\"tree_table\";a:6:{s:9:\"variables\";a:5:{s:6:\"header\";a:0:{}s:4:\"rows\";a:0:{}s:10:\"attributes\";a:0:{}s:5:\"empty\";s:0:\"\";s:7:\"caption\";s:0:\"\";}s:4:\"file\";s:15:\"token.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/token\";s:8:\"function\";s:16:\"theme_tree_table\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/token/token.pages.inc\";}}s:10:\"token_tree\";a:6:{s:9:\"variables\";a:6:{s:11:\"token_types\";a:0:{}s:12:\"global_types\";b:1;s:12:\"click_insert\";b:1;s:15:\"show_restricted\";b:0;s:15:\"recursion_limit\";i:3;s:6:\"dialog\";b:0;}s:4:\"file\";s:15:\"token.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/token\";s:8:\"function\";s:16:\"theme_token_tree\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/token/token.pages.inc\";}}s:15:\"token_tree_link\";a:6:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:7:\"options\";a:0:{}s:6:\"dialog\";b:1;}s:4:\"file\";s:15:\"token.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/contrib/token\";s:8:\"function\";s:21:\"theme_token_tree_link\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/contrib/token/token.pages.inc\";}}s:30:\"taxonomy_overview_vocabularies\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/taxonomy\";s:8:\"function\";s:36:\"theme_taxonomy_overview_vocabularies\";}s:23:\"taxonomy_overview_terms\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/taxonomy\";s:8:\"function\";s:29:\"theme_taxonomy_overview_terms\";}s:13:\"taxonomy_term\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:30:\"modules/taxonomy/taxonomy-term\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/taxonomy\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:33:\"template_preprocess_taxonomy_term\";i:2;s:28:\"rdf_preprocess_taxonomy_term\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:6:\"region\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:21:\"modules/system/region\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:26:\"template_preprocess_region\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:15:\"status_messages\";a:4:{s:9:\"variables\";a:1:{s:7:\"display\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:21:\"theme_status_messages\";}s:4:\"link\";a:4:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:4:\"path\";N;s:7:\"options\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_link\";}s:5:\"links\";a:4:{s:9:\"variables\";a:3:{s:5:\"links\";N;s:10:\"attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:5:\"links\";}}s:7:\"heading\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_links\";}s:5:\"image\";a:5:{s:9:\"variables\";a:6:{s:4:\"path\";N;s:5:\"width\";N;s:6:\"height\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";N;s:10:\"attributes\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_image\";s:20:\"preprocess functions\";a:1:{i:0;s:20:\"rdf_preprocess_image\";}}s:4:\"help\";a:4:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_help\";}s:5:\"table\";a:4:{s:9:\"variables\";a:7:{s:6:\"header\";N;s:4:\"rows\";N;s:10:\"attributes\";a:0:{}s:7:\"caption\";N;s:9:\"colgroups\";a:0:{}s:6:\"sticky\";b:1;s:5:\"empty\";s:0:\"\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_table\";}s:19:\"tablesort_indicator\";a:4:{s:9:\"variables\";a:1:{s:5:\"style\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:25:\"theme_tablesort_indicator\";}s:4:\"mark\";a:4:{s:9:\"variables\";a:1:{s:4:\"type\";i:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_mark\";}s:9:\"item_list\";a:4:{s:9:\"variables\";a:4:{s:5:\"items\";a:0:{}s:5:\"title\";N;s:4:\"type\";s:2:\"ul\";s:10:\"attributes\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_item_list\";}s:14:\"more_help_link\";a:4:{s:9:\"variables\";a:1:{s:3:\"url\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:20:\"theme_more_help_link\";}s:9:\"feed_icon\";a:4:{s:9:\"variables\";a:2:{s:3:\"url\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_feed_icon\";}s:9:\"more_link\";a:4:{s:9:\"variables\";a:2:{s:3:\"url\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_more_link\";}s:8:\"username\";a:6:{s:9:\"variables\";a:1:{s:7:\"account\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_username\";s:20:\"preprocess functions\";a:2:{i:0;s:28:\"template_preprocess_username\";i:1;s:23:\"rdf_preprocess_username\";}s:17:\"process functions\";a:1:{i:0;s:25:\"template_process_username\";}}s:12:\"progress_bar\";a:4:{s:9:\"variables\";a:2:{s:7:\"percent\";N;s:7:\"message\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_progress_bar\";}s:11:\"indentation\";a:4:{s:9:\"variables\";a:1:{s:4:\"size\";i:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_indentation\";}s:8:\"html_tag\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_html_tag\";}s:16:\"maintenance_page\";a:6:{s:9:\"variables\";a:2:{s:7:\"content\";N;s:13:\"show_messages\";b:1;}s:8:\"template\";s:31:\"modules/system/maintenance-page\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_maintenance_page\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:33:\"template_process_maintenance_page\";i:2;s:11:\"rdf_process\";}}s:11:\"update_page\";a:4:{s:9:\"variables\";a:2:{s:7:\"content\";N;s:13:\"show_messages\";b:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_update_page\";}s:12:\"install_page\";a:4:{s:9:\"variables\";a:1:{s:7:\"content\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_install_page\";}s:9:\"task_list\";a:4:{s:9:\"variables\";a:2:{s:5:\"items\";N;s:6:\"active\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_task_list\";}s:17:\"authorize_message\";a:4:{s:9:\"variables\";a:2:{s:7:\"message\";N;s:7:\"success\";b:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:23:\"theme_authorize_message\";}s:16:\"authorize_report\";a:4:{s:9:\"variables\";a:1:{s:8:\"messages\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:22:\"theme_authorize_report\";}s:5:\"pager\";a:4:{s:9:\"variables\";a:4:{s:4:\"tags\";a:0:{}s:7:\"element\";i:0;s:10:\"parameters\";a:0:{}s:8:\"quantity\";i:9;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_pager\";}s:11:\"pager_first\";a:4:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:7:\"element\";i:0;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_pager_first\";}s:14:\"pager_previous\";a:4:{s:9:\"variables\";a:4:{s:4:\"text\";N;s:7:\"element\";i:0;s:8:\"interval\";i:1;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:20:\"theme_pager_previous\";}s:10:\"pager_next\";a:4:{s:9:\"variables\";a:4:{s:4:\"text\";N;s:7:\"element\";i:0;s:8:\"interval\";i:1;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_pager_next\";}s:10:\"pager_last\";a:4:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:7:\"element\";i:0;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_pager_last\";}s:10:\"pager_link\";a:4:{s:9:\"variables\";a:5:{s:4:\"text\";N;s:8:\"page_new\";N;s:7:\"element\";N;s:10:\"parameters\";a:0:{}s:10:\"attributes\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_pager_link\";}s:9:\"menu_tree\";a:5:{s:14:\"render element\";s:4:\"tree\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_menu_tree\";s:20:\"preprocess functions\";a:1:{i:0;s:29:\"template_preprocess_menu_tree\";}}s:15:\"menu_local_task\";a:5:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";s:8:\"function\";s:21:\"theme_menu_local_task\";s:20:\"preprocess functions\";a:1:{i:0;s:34:\"mercury_preprocess_menu_local_task\";}}s:17:\"menu_local_action\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:23:\"theme_menu_local_action\";}s:6:\"select\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_select\";}s:8:\"fieldset\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_fieldset\";}s:5:\"radio\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_radio\";}s:6:\"radios\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_radios\";}s:4:\"date\";a:5:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_date\";s:8:\"includes\";a:1:{i:0;s:41:\"sites/all/modules/contrib/date/date.theme\";}}s:15:\"exposed_filters\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:21:\"theme_exposed_filters\";}s:8:\"checkbox\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_checkbox\";}s:10:\"checkboxes\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_checkboxes\";}s:6:\"button\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_button\";}s:12:\"image_button\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_image_button\";}s:6:\"hidden\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_hidden\";}s:9:\"textfield\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_textfield\";}s:4:\"form\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_form\";}s:8:\"textarea\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_textarea\";}s:8:\"password\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_password\";}s:4:\"file\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_file\";}s:11:\"tableselect\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_tableselect\";}s:12:\"form_element\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_form_element\";}s:20:\"form_required_marker\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:26:\"theme_form_required_marker\";}s:18:\"form_element_label\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:24:\"theme_form_element_label\";}s:13:\"vertical_tabs\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:19:\"theme_vertical_tabs\";}s:9:\"container\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_container\";}s:18:\"system_themes_page\";a:6:{s:9:\"variables\";a:1:{s:12:\"theme_groups\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:24:\"theme_system_themes_page\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:20:\"system_settings_form\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:26:\"theme_system_settings_form\";}s:12:\"confirm_form\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_confirm_form\";}s:23:\"system_modules_fieldset\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:29:\"theme_system_modules_fieldset\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:27:\"system_modules_incompatible\";a:6:{s:9:\"variables\";a:1:{s:7:\"message\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:33:\"theme_system_modules_incompatible\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:24:\"system_modules_uninstall\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:30:\"theme_system_modules_uninstall\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:13:\"status_report\";a:6:{s:14:\"render element\";s:12:\"requirements\";s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:19:\"theme_status_report\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:10:\"admin_page\";a:6:{s:9:\"variables\";a:1:{s:6:\"blocks\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_admin_page\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:11:\"admin_block\";a:6:{s:9:\"variables\";a:1:{s:5:\"block\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_admin_block\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:19:\"admin_block_content\";a:6:{s:9:\"variables\";a:1:{s:7:\"content\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:25:\"theme_admin_block_content\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:18:\"system_admin_index\";a:6:{s:9:\"variables\";a:1:{s:10:\"menu_items\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:24:\"theme_system_admin_index\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:17:\"system_powered_by\";a:4:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:23:\"theme_system_powered_by\";}s:19:\"system_compact_link\";a:4:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:25:\"theme_system_compact_link\";}s:25:\"system_date_time_settings\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:31:\"theme_system_date_time_settings\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:22:\"shortcut_set_customize\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"shortcut.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/shortcut\";s:8:\"function\";s:28:\"theme_shortcut_set_customize\";s:8:\"includes\";a:1:{i:0;s:35:\"modules/shortcut/shortcut.admin.inc\";}}s:23:\"search_api_page_results\";a:7:{s:9:\"variables\";a:5:{s:5:\"index\";N;s:7:\"results\";a:1:{s:12:\"result count\";i:0;}s:5:\"items\";a:0:{}s:9:\"view_mode\";s:22:\"search_api_page_result\";s:4:\"keys\";s:0:\"\";}s:4:\"file\";s:25:\"search_api_page.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:41:\"sites/all/modules/contrib/search_api_page\";s:8:\"function\";s:29:\"theme_search_api_page_results\";s:8:\"includes\";a:1:{i:0;s:67:\"sites/all/modules/contrib/search_api_page/search_api_page.pages.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:43:\"template_preprocess_search_api_page_results\";}}s:22:\"search_api_page_result\";a:6:{s:9:\"variables\";a:4:{s:5:\"index\";N;s:6:\"result\";N;s:4:\"item\";N;s:4:\"keys\";s:0:\"\";}s:4:\"file\";s:25:\"search_api_page.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:41:\"sites/all/modules/contrib/search_api_page\";s:8:\"function\";s:28:\"theme_search_api_page_result\";s:8:\"includes\";a:1:{i:0;s:67:\"sites/all/modules/contrib/search_api_page/search_api_page.pages.inc\";}}s:17:\"search_api_server\";a:6:{s:9:\"variables\";a:9:{s:2:\"id\";N;s:4:\"name\";s:0:\"\";s:12:\"machine_name\";s:0:\"\";s:11:\"description\";N;s:7:\"enabled\";N;s:10:\"class_name\";N;s:17:\"class_description\";N;s:7:\"options\";a:0:{}s:6:\"status\";i:1;}s:4:\"file\";s:20:\"search_api.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:36:\"sites/all/modules/contrib/search_api\";s:8:\"function\";s:23:\"theme_search_api_server\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/search_api/search_api.admin.inc\";}}s:16:\"search_api_index\";a:6:{s:9:\"variables\";a:13:{s:2:\"id\";N;s:4:\"name\";s:0:\"\";s:12:\"machine_name\";s:0:\"\";s:11:\"description\";N;s:9:\"item_type\";N;s:7:\"enabled\";N;s:6:\"server\";N;s:7:\"options\";a:0:{}s:6:\"fields\";a:0:{}s:13:\"indexed_items\";i:0;s:11:\"total_items\";i:0;s:6:\"status\";i:1;s:9:\"read_only\";i:0;}s:4:\"file\";s:20:\"search_api.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:36:\"sites/all/modules/contrib/search_api\";s:8:\"function\";s:22:\"theme_search_api_index\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/search_api/search_api.admin.inc\";}}s:27:\"search_api_admin_item_order\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:20:\"search_api.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:36:\"sites/all/modules/contrib/search_api\";s:8:\"function\";s:33:\"theme_search_api_admin_item_order\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/search_api/search_api.admin.inc\";}}s:29:\"search_api_admin_fields_table\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:20:\"search_api.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:36:\"sites/all/modules/contrib/search_api\";s:8:\"function\";s:35:\"theme_search_api_admin_fields_table\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/search_api/search_api.admin.inc\";}}s:17:\"search_block_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:8:\"template\";s:32:\"modules/search/search-block-form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/search\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:37:\"template_preprocess_search_block_form\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:13:\"search_result\";a:8:{s:9:\"variables\";a:2:{s:6:\"result\";N;s:6:\"module\";N;}s:4:\"file\";s:16:\"search.pages.inc\";s:8:\"template\";s:28:\"modules/search/search-result\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/search\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/search/search.pages.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:33:\"template_preprocess_search_result\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:14:\"search_results\";a:8:{s:9:\"variables\";a:2:{s:7:\"results\";N;s:6:\"module\";N;}s:4:\"file\";s:16:\"search.pages.inc\";s:8:\"template\";s:29:\"modules/search/search-results\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/search\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/search/search.pages.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:34:\"template_preprocess_search_results\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:29:\"rdf_template_variable_wrapper\";a:4:{s:9:\"variables\";a:4:{s:7:\"content\";N;s:10:\"attributes\";a:0:{}s:7:\"context\";a:0:{}s:6:\"inline\";b:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:11:\"modules/rdf\";s:8:\"function\";s:35:\"theme_rdf_template_variable_wrapper\";}s:12:\"rdf_metadata\";a:4:{s:9:\"variables\";a:1:{s:8:\"metadata\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:11:\"modules/rdf\";s:8:\"function\";s:18:\"theme_rdf_metadata\";}s:17:\"r4032login_denied\";a:4:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:36:\"sites/all/modules/contrib/r4032login\";s:8:\"function\";s:23:\"theme_r4032login_denied\";}s:23:\"panels_ipe_pane_wrapper\";a:4:{s:9:\"variables\";a:4:{s:6:\"output\";N;s:4:\"pane\";N;s:7:\"display\";N;s:8:\"renderer\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/panels/panels_ipe\";s:8:\"function\";s:29:\"theme_panels_ipe_pane_wrapper\";}s:25:\"panels_ipe_region_wrapper\";a:4:{s:9:\"variables\";a:5:{s:6:\"output\";N;s:9:\"region_id\";N;s:7:\"display\";N;s:8:\"controls\";N;s:8:\"renderer\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/panels/panels_ipe\";s:8:\"function\";s:31:\"theme_panels_ipe_region_wrapper\";}s:26:\"panels_ipe_add_pane_button\";a:4:{s:9:\"variables\";a:3:{s:9:\"region_id\";N;s:7:\"display\";N;s:8:\"renderer\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/panels/panels_ipe\";s:8:\"function\";s:32:\"theme_panels_ipe_add_pane_button\";}s:27:\"panels_ipe_placeholder_pane\";a:4:{s:9:\"variables\";a:2:{s:9:\"region_id\";N;s:12:\"region_title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/panels/panels_ipe\";s:8:\"function\";s:33:\"theme_panels_ipe_placeholder_pane\";}s:29:\"panels_ipe_dnd_form_container\";a:4:{s:9:\"variables\";a:3:{s:4:\"link\";N;s:9:\"cache_key\";N;s:7:\"display\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/panels/panels_ipe\";s:8:\"function\";s:35:\"theme_panels_ipe_dnd_form_container\";}s:18:\"panels_ipe_toolbar\";a:4:{s:9:\"variables\";a:1:{s:7:\"buttons\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/panels/panels_ipe\";s:8:\"function\";s:24:\"theme_panels_ipe_toolbar\";}s:18:\"panels_layout_link\";a:4:{s:9:\"variables\";a:5:{s:5:\"title\";N;s:2:\"id\";N;s:5:\"image\";N;s:4:\"link\";N;s:5:\"class\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:24:\"theme_panels_layout_link\";}s:18:\"panels_layout_icon\";a:4:{s:9:\"variables\";a:3:{s:2:\"id\";N;s:5:\"image\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:24:\"theme_panels_layout_icon\";}s:11:\"panels_pane\";a:7:{s:9:\"variables\";a:3:{s:6:\"output\";a:0:{}s:4:\"pane\";a:0:{}s:7:\"display\";a:0:{}}s:4:\"path\";s:42:\"sites/all/modules/contrib/panels/templates\";s:8:\"template\";s:11:\"panels-pane\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:31:\"template_preprocess_panels_pane\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:26:\"panels_common_content_list\";a:6:{s:9:\"variables\";a:1:{s:7:\"display\";N;}s:4:\"file\";s:19:\"includes/common.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:32:\"theme_panels_common_content_list\";s:8:\"includes\";a:1:{i:0;s:52:\"sites/all/modules/contrib/panels/includes/common.inc\";}}s:26:\"panels_render_display_form\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:32:\"theme_panels_render_display_form\";}s:16:\"panels_dashboard\";a:9:{s:9:\"variables\";a:0:{}s:4:\"path\";s:42:\"sites/all/modules/contrib/panels/templates\";s:4:\"file\";s:25:\"../includes/callbacks.inc\";s:8:\"template\";s:16:\"panels-dashboard\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:68:\"sites/all/modules/contrib/panels/templates/../includes/callbacks.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_panels_dashboard\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:21:\"panels_dashboard_link\";a:9:{s:9:\"variables\";a:1:{s:4:\"link\";a:0:{}}s:4:\"path\";s:42:\"sites/all/modules/contrib/panels/templates\";s:4:\"file\";s:25:\"../includes/callbacks.inc\";s:8:\"template\";s:21:\"panels-dashboard-link\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:68:\"sites/all/modules/contrib/panels/templates/../includes/callbacks.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:22:\"panels_dashboard_block\";a:9:{s:9:\"variables\";a:1:{s:5:\"block\";a:0:{}}s:4:\"path\";s:42:\"sites/all/modules/contrib/panels/templates\";s:4:\"file\";s:25:\"../includes/callbacks.inc\";s:8:\"template\";s:22:\"panels-dashboard-block\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:68:\"sites/all/modules/contrib/panels/templates/../includes/callbacks.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:24:\"panels_add_content_modal\";a:9:{s:9:\"variables\";a:5:{s:8:\"renderer\";N;s:10:\"categories\";a:0:{}s:6:\"region\";N;s:8:\"category\";N;s:12:\"column_count\";i:2;}s:4:\"path\";s:42:\"sites/all/modules/contrib/panels/templates\";s:4:\"file\";s:27:\"../includes/add-content.inc\";s:8:\"template\";s:24:\"panels-add-content-modal\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:70:\"sites/all/modules/contrib/panels/templates/../includes/add-content.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:44:\"template_preprocess_panels_add_content_modal\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:41:\"template_process_panels_add_content_modal\";i:2;s:11:\"rdf_process\";}}s:23:\"panels_add_content_link\";a:9:{s:9:\"variables\";a:3:{s:8:\"renderer\";N;s:6:\"region\";N;s:12:\"content_type\";N;}s:4:\"path\";s:42:\"sites/all/modules/contrib/panels/templates\";s:4:\"file\";s:27:\"../includes/add-content.inc\";s:8:\"template\";s:23:\"panels-add-content-link\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:70:\"sites/all/modules/contrib/panels/templates/../includes/add-content.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:43:\"template_preprocess_panels_add_content_link\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:15:\"panels_flexible\";a:7:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:57:\"sites/all/modules/contrib/panels/plugins/layouts/flexible\";s:4:\"file\";s:12:\"flexible.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:21:\"theme_panels_flexible\";s:8:\"includes\";a:1:{i:0;s:70:\"sites/all/modules/contrib/panels/plugins/layouts/flexible/flexible.inc\";}}s:21:\"panels_flexible_admin\";a:7:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:57:\"sites/all/modules/contrib/panels/plugins/layouts/flexible\";s:4:\"file\";s:12:\"flexible.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:27:\"theme_panels_flexible_admin\";s:8:\"includes\";a:1:{i:0;s:70:\"sites/all/modules/contrib/panels/plugins/layouts/flexible/flexible.inc\";}}s:24:\"panels_threecol_33_34_33\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:66:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_33_34_33\";s:4:\"file\";s:21:\"threecol_33_34_33.inc\";s:8:\"template\";s:24:\"panels-threecol-33-34-33\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:88:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_33_34_33/threecol_33_34_33.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:13:\"panels_onecol\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:55:\"sites/all/modules/contrib/panels/plugins/layouts/onecol\";s:4:\"file\";s:10:\"onecol.inc\";s:8:\"template\";s:13:\"panels-onecol\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:66:\"sites/all/modules/contrib/panels/plugins/layouts/onecol/onecol.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:24:\"panels_threecol_25_50_25\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:66:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_25_50_25\";s:4:\"file\";s:21:\"threecol_25_50_25.inc\";s:8:\"template\";s:24:\"panels-threecol-25-50-25\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:88:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_25_50_25/threecol_25_50_25.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:32:\"panels_threecol_25_50_25_stacked\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:74:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_25_50_25_stacked\";s:4:\"file\";s:29:\"threecol_25_50_25_stacked.inc\";s:8:\"template\";s:32:\"panels-threecol-25-50-25-stacked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:104:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_25_50_25_stacked/threecol_25_50_25_stacked.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:20:\"panels_twocol_bricks\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:62:\"sites/all/modules/contrib/panels/plugins/layouts/twocol_bricks\";s:4:\"file\";s:17:\"twocol_bricks.inc\";s:8:\"template\";s:20:\"panels-twocol-bricks\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:80:\"sites/all/modules/contrib/panels/plugins/layouts/twocol_bricks/twocol_bricks.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:32:\"panels_threecol_33_34_33_stacked\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:74:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_33_34_33_stacked\";s:4:\"file\";s:29:\"threecol_33_34_33_stacked.inc\";s:8:\"template\";s:32:\"panels-threecol-33-34-33-stacked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:104:\"sites/all/modules/contrib/panels/plugins/layouts/threecol_33_34_33_stacked/threecol_33_34_33_stacked.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:21:\"panels_twocol_stacked\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:63:\"sites/all/modules/contrib/panels/plugins/layouts/twocol_stacked\";s:4:\"file\";s:18:\"twocol_stacked.inc\";s:8:\"template\";s:21:\"panels-twocol-stacked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:82:\"sites/all/modules/contrib/panels/plugins/layouts/twocol_stacked/twocol_stacked.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:13:\"panels_twocol\";a:9:{s:9:\"variables\";a:6:{s:6:\"css_id\";N;s:7:\"content\";N;s:8:\"settings\";N;s:7:\"display\";N;s:6:\"layout\";N;s:8:\"renderer\";N;}s:4:\"path\";s:55:\"sites/all/modules/contrib/panels/plugins/layouts/twocol\";s:4:\"file\";s:10:\"twocol.inc\";s:8:\"template\";s:13:\"panels-twocol\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"includes\";a:1:{i:0;s:66:\"sites/all/modules/contrib/panels/plugins/layouts/twocol/twocol.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:40:\"panels_rounded_corners_style_render_pane\";a:7:{s:9:\"variables\";a:5:{s:7:\"content\";N;s:4:\"pane\";N;s:7:\"display\";N;s:5:\"style\";N;s:8:\"settings\";N;}s:4:\"path\";s:55:\"sites/all/modules/contrib/panels/plugins/styles/corners\";s:4:\"file\";s:19:\"rounded_corners.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:46:\"theme_panels_rounded_corners_style_render_pane\";s:8:\"includes\";a:1:{i:0;s:75:\"sites/all/modules/contrib/panels/plugins/styles/corners/rounded_corners.inc\";}}s:42:\"panels_rounded_corners_style_render_region\";a:7:{s:9:\"variables\";a:6:{s:7:\"display\";N;s:8:\"owner_id\";N;s:5:\"panes\";N;s:8:\"settings\";N;s:9:\"region_id\";N;s:5:\"style\";N;}s:4:\"path\";s:55:\"sites/all/modules/contrib/panels/plugins/styles/corners\";s:4:\"file\";s:19:\"rounded_corners.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:48:\"theme_panels_rounded_corners_style_render_region\";s:8:\"includes\";a:1:{i:0;s:75:\"sites/all/modules/contrib/panels/plugins/styles/corners/rounded_corners.inc\";}}s:26:\"panels_rounded_corners_box\";a:7:{s:9:\"variables\";a:1:{s:7:\"content\";N;}s:4:\"path\";s:55:\"sites/all/modules/contrib/panels/plugins/styles/corners\";s:8:\"template\";s:26:\"panels-rounded-corners-box\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:20:\"preprocess functions\";a:1:{i:0;s:19:\"template_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:30:\"panels_block_style_render_pane\";a:7:{s:9:\"variables\";a:5:{s:7:\"content\";N;s:4:\"pane\";N;s:7:\"display\";N;s:5:\"style\";N;s:8:\"settings\";N;}s:4:\"path\";s:47:\"sites/all/modules/contrib/panels/plugins/styles\";s:4:\"file\";s:9:\"block.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:36:\"theme_panels_block_style_render_pane\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/panels/plugins/styles/block.inc\";}}s:34:\"panels_default_style_render_region\";a:7:{s:9:\"variables\";a:6:{s:7:\"display\";N;s:8:\"owner_id\";N;s:5:\"panes\";N;s:8:\"settings\";N;s:9:\"region_id\";N;s:5:\"style\";N;}s:4:\"path\";s:47:\"sites/all/modules/contrib/panels/plugins/styles\";s:4:\"file\";s:11:\"default.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:40:\"theme_panels_default_style_render_region\";s:8:\"includes\";a:1:{i:0;s:59:\"sites/all/modules/contrib/panels/plugins/styles/default.inc\";}}s:30:\"panels_naked_style_render_pane\";a:7:{s:9:\"variables\";a:5:{s:7:\"content\";N;s:4:\"pane\";N;s:7:\"display\";N;s:5:\"style\";N;s:8:\"settings\";N;}s:4:\"path\";s:47:\"sites/all/modules/contrib/panels/plugins/styles\";s:4:\"file\";s:9:\"naked.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:36:\"theme_panels_naked_style_render_pane\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/panels/plugins/styles/naked.inc\";}}s:32:\"panels_naked_style_render_region\";a:7:{s:9:\"variables\";a:6:{s:7:\"display\";N;s:8:\"owner_id\";N;s:5:\"panes\";N;s:8:\"settings\";N;s:9:\"region_id\";N;s:5:\"style\";N;}s:4:\"path\";s:47:\"sites/all/modules/contrib/panels/plugins/styles\";s:4:\"file\";s:9:\"naked.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:38:\"theme_panels_naked_style_render_region\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/panels/plugins/styles/naked.inc\";}}s:31:\"panels_list_style_render_region\";a:7:{s:9:\"variables\";a:6:{s:7:\"display\";N;s:8:\"owner_id\";N;s:5:\"panes\";N;s:8:\"settings\";N;s:9:\"region_id\";N;s:5:\"style\";N;}s:4:\"path\";s:47:\"sites/all/modules/contrib/panels/plugins/styles\";s:4:\"file\";s:8:\"list.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/panels\";s:8:\"function\";s:37:\"theme_panels_list_style_render_region\";s:8:\"includes\";a:1:{i:0;s:56:\"sites/all/modules/contrib/panels/plugins/styles/list.inc\";}}s:12:\"options_none\";a:4:{s:9:\"variables\";a:2:{s:8:\"instance\";N;s:6:\"option\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:29:\"modules/field/modules/options\";s:8:\"function\";s:18:\"theme_options_none\";}s:17:\"node_search_admin\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:23:\"theme_node_search_admin\";}s:13:\"node_add_list\";a:6:{s:9:\"variables\";a:1:{s:7:\"content\";N;}s:4:\"file\";s:14:\"node.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:19:\"theme_node_add_list\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/node/node.pages.inc\";}}s:12:\"node_preview\";a:6:{s:9:\"variables\";a:1:{s:4:\"node\";N;}s:4:\"file\";s:14:\"node.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:18:\"theme_node_preview\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/node/node.pages.inc\";}}s:19:\"node_admin_overview\";a:4:{s:9:\"variables\";a:2:{s:4:\"name\";N;s:4:\"type\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:25:\"theme_node_admin_overview\";}s:17:\"node_recent_block\";a:4:{s:9:\"variables\";a:1:{s:5:\"nodes\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:23:\"theme_node_recent_block\";}s:19:\"node_recent_content\";a:4:{s:9:\"variables\";a:1:{s:4:\"node\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:25:\"theme_node_recent_content\";}s:28:\"module_filter_system_modules\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:23:\"module_filter.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/module_filter\";s:8:\"function\";s:34:\"theme_module_filter_system_modules\";s:8:\"includes\";a:1:{i:0;s:63:\"sites/all/modules/contrib/module_filter/module_filter.theme.inc\";}}s:27:\"module_filter_modules_table\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:23:\"module_filter.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/module_filter\";s:8:\"function\";s:33:\"theme_module_filter_modules_table\";s:8:\"includes\";a:1:{i:0;s:63:\"sites/all/modules/contrib/module_filter/module_filter.theme.inc\";}}s:33:\"module_filter_system_modules_tabs\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:23:\"module_filter.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/module_filter\";s:8:\"function\";s:39:\"theme_module_filter_system_modules_tabs\";s:8:\"includes\";a:1:{i:0;s:63:\"sites/all/modules/contrib/module_filter/module_filter.theme.inc\";}}s:18:\"menu_overview_form\";a:6:{s:4:\"file\";s:14:\"menu.admin.inc\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/menu\";s:8:\"function\";s:24:\"theme_menu_overview_form\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/menu/menu.admin.inc\";}}s:19:\"menu_admin_overview\";a:6:{s:4:\"file\";s:14:\"menu.admin.inc\";s:9:\"variables\";a:3:{s:5:\"title\";N;s:4:\"name\";N;s:11:\"description\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/menu\";s:8:\"function\";s:25:\"theme_menu_admin_overview\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/menu/menu.admin.inc\";}}s:29:\"login_destination_destination\";a:6:{s:9:\"variables\";a:1:{s:11:\"destination\";N;}s:4:\"file\";s:27:\"login_destination.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/login_destination\";s:8:\"function\";s:35:\"theme_login_destination_destination\";s:8:\"includes\";a:1:{i:0;s:71:\"sites/all/modules/contrib/login_destination/login_destination.admin.inc\";}}s:23:\"login_destination_pages\";a:6:{s:9:\"variables\";a:2:{s:5:\"pages\";N;s:10:\"pages_type\";i:0;}s:4:\"file\";s:27:\"login_destination.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/login_destination\";s:8:\"function\";s:29:\"theme_login_destination_pages\";s:8:\"includes\";a:1:{i:0;s:71:\"sites/all/modules/contrib/login_destination/login_destination.admin.inc\";}}s:26:\"login_destination_triggers\";a:6:{s:9:\"variables\";a:1:{s:5:\"items\";N;}s:4:\"file\";s:27:\"login_destination.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/login_destination\";s:8:\"function\";s:32:\"theme_login_destination_triggers\";s:8:\"includes\";a:1:{i:0;s:71:\"sites/all/modules/contrib/login_destination/login_destination.admin.inc\";}}s:23:\"login_destination_roles\";a:6:{s:9:\"variables\";a:1:{s:5:\"items\";N;}s:4:\"file\";s:27:\"login_destination.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/contrib/login_destination\";s:8:\"function\";s:29:\"theme_login_destination_roles\";s:8:\"includes\";a:1:{i:0;s:71:\"sites/all/modules/contrib/login_destination/login_destination.admin.inc\";}}s:17:\"lt_username_title\";a:4:{s:9:\"variables\";a:1:{s:7:\"form_id\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:23:\"theme_lt_username_title\";}s:23:\"lt_username_description\";a:4:{s:9:\"variables\";a:1:{s:7:\"form_id\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:29:\"theme_lt_username_description\";}s:17:\"lt_password_title\";a:4:{s:9:\"variables\";a:1:{s:7:\"form_id\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:23:\"theme_lt_password_title\";}s:23:\"lt_password_description\";a:4:{s:9:\"variables\";a:1:{s:7:\"form_id\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:29:\"theme_lt_password_description\";}s:16:\"lt_access_denied\";a:4:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:22:\"theme_lt_access_denied\";}s:16:\"lt_loggedinblock\";a:4:{s:9:\"variables\";a:1:{s:7:\"account\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:22:\"theme_lt_loggedinblock\";}s:13:\"lt_login_link\";a:4:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:19:\"theme_lt_login_link\";}s:27:\"lt_login_successful_message\";a:4:{s:9:\"variables\";a:1:{s:7:\"account\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:33:\"theme_lt_login_successful_message\";}s:21:\"lt_unified_login_page\";a:4:{s:9:\"variables\";a:3:{s:10:\"login_form\";N;s:13:\"register_form\";N;s:11:\"active_form\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/logintoboggan\";s:8:\"function\";s:27:\"theme_lt_unified_login_page\";}s:15:\"transfer_slider\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:42:\"sites/all/modules/contrib/jslider_form_api\";s:8:\"function\";s:21:\"theme_transfer_slider\";}s:21:\"filter_admin_overview\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:16:\"filter.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:27:\"theme_filter_admin_overview\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/filter/filter.admin.inc\";}}s:32:\"filter_admin_format_filter_order\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:16:\"filter.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:38:\"theme_filter_admin_format_filter_order\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/filter/filter.admin.inc\";}}s:11:\"filter_tips\";a:6:{s:9:\"variables\";a:2:{s:4:\"tips\";N;s:4:\"long\";b:0;}s:4:\"file\";s:16:\"filter.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:17:\"theme_filter_tips\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/filter/filter.pages.inc\";}}s:19:\"text_format_wrapper\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:25:\"theme_text_format_wrapper\";}s:21:\"filter_tips_more_info\";a:4:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:27:\"theme_filter_tips_more_info\";}s:17:\"filter_guidelines\";a:4:{s:9:\"variables\";a:1:{s:6:\"format\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:23:\"theme_filter_guidelines\";}s:14:\"field_ui_table\";a:4:{s:14:\"render element\";s:8:\"elements\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/field_ui\";s:8:\"function\";s:20:\"theme_field_ui_table\";}s:5:\"field\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/field\";s:8:\"function\";s:11:\"theme_field\";s:20:\"preprocess functions\";a:2:{i:0;s:25:\"template_preprocess_field\";i:1;s:20:\"rdf_preprocess_field\";}s:17:\"process functions\";a:1:{i:0;s:22:\"template_process_field\";}}s:25:\"field_multiple_value_form\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/field\";s:8:\"function\";s:31:\"theme_field_multiple_value_form\";}s:38:\"famc_analytics_vm_historical_perf_form\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/custom/famc_analytics\";s:8:\"function\";s:44:\"theme_famc_analytics_vm_historical_perf_form\";}s:29:\"famc_analytics_analytics_form\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/custom/famc_analytics\";s:8:\"function\";s:35:\"theme_famc_analytics_analytics_form\";}s:34:\"famc_analytics_analytics_view_form\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/custom/famc_analytics\";s:8:\"function\";s:40:\"theme_famc_analytics_analytics_view_form\";}s:13:\"entity_status\";a:4:{s:9:\"variables\";a:2:{s:6:\"status\";N;s:4:\"html\";b:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/entity\";s:8:\"function\";s:19:\"theme_entity_status\";}s:6:\"entity\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:39:\"sites/all/modules/contrib/entity/entity\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/entity\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:26:\"template_preprocess_entity\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:23:\"entity_ui_overview_item\";a:6:{s:9:\"variables\";a:4:{s:5:\"label\";N;s:11:\"entity_type\";N;s:3:\"url\";b:0;s:4:\"name\";b:0;}s:4:\"file\";s:22:\"includes/entity.ui.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/entity\";s:8:\"function\";s:29:\"theme_entity_ui_overview_item\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/entity/includes/entity.ui.inc\";}}s:13:\"dblog_message\";a:6:{s:9:\"variables\";a:2:{s:5:\"event\";N;s:4:\"link\";b:0;}s:4:\"file\";s:15:\"dblog.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/dblog\";s:8:\"function\";s:19:\"theme_dblog_message\";s:8:\"includes\";a:1:{i:0;s:29:\"modules/dblog/dblog.admin.inc\";}}s:14:\"date_nav_title\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:47:\"sites/all/modules/contrib/date/date_views/theme\";s:9:\"variables\";a:4:{s:11:\"granularity\";N;s:4:\"view\";N;s:4:\"link\";N;s:6:\"format\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:41:\"sites/all/modules/contrib/date/date_views\";s:8:\"function\";s:20:\"theme_date_nav_title\";s:8:\"includes\";a:2:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";i:1;s:57:\"sites/all/modules/contrib/date/date_views/theme/theme.inc\";}}s:22:\"date_views_filter_form\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:47:\"sites/all/modules/contrib/date/date_views/theme\";s:8:\"template\";s:22:\"date-views-filter-form\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:41:\"sites/all/modules/contrib/date/date_views\";s:8:\"includes\";a:2:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";i:1;s:57:\"sites/all/modules/contrib/date/date_views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:42:\"template_preprocess_date_views_filter_form\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:17:\"date_calendar_day\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:47:\"sites/all/modules/contrib/date/date_views/theme\";s:9:\"variables\";a:1:{s:4:\"date\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:41:\"sites/all/modules/contrib/date/date_views\";s:8:\"function\";s:23:\"theme_date_calendar_day\";s:8:\"includes\";a:2:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";i:1;s:57:\"sites/all/modules/contrib/date/date_views/theme/theme.inc\";}}s:16:\"date_views_pager\";a:10:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:47:\"sites/all/modules/contrib/date/date_views/theme\";s:9:\"variables\";a:2:{s:6:\"plugin\";N;s:5:\"input\";N;}s:7:\"pattern\";s:18:\"date_views_pager__\";s:8:\"template\";s:16:\"date-views-pager\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:41:\"sites/all/modules/contrib/date/date_views\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/contrib/date/date_views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_date_views_pager\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:10:\"date_popup\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:41:\"sites/all/modules/contrib/date/date_popup\";s:8:\"function\";s:16:\"theme_date_popup\";}s:13:\"date_timezone\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:19:\"theme_date_timezone\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:11:\"date_select\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:17:\"theme_date_select\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:9:\"date_text\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:15:\"theme_date_text\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:19:\"date_select_element\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:25:\"theme_date_select_element\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:22:\"date_textfield_element\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:28:\"theme_date_textfield_element\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:21:\"date_part_hour_prefix\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:27:\"theme_date_part_hour_prefix\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:23:\"date_part_minsec_prefix\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:29:\"theme_date_part_minsec_prefix\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:20:\"date_part_label_year\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_year\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:21:\"date_part_label_month\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:27:\"theme_date_part_label_month\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:19:\"date_part_label_day\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:25:\"theme_date_part_label_day\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:20:\"date_part_label_hour\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_hour\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:22:\"date_part_label_minute\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:28:\"theme_date_part_label_minute\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:22:\"date_part_label_second\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:28:\"theme_date_part_label_second\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:20:\"date_part_label_ampm\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_ampm\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:24:\"date_part_label_timezone\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:30:\"theme_date_part_label_timezone\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:20:\"date_part_label_date\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_date\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:20:\"date_part_label_time\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_time\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:13:\"date_time_ago\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:45:\"sites/all/modules/contrib/date/date_api/theme\";s:9:\"variables\";a:3:{s:10:\"start_date\";N;s:8:\"end_date\";N;s:8:\"interval\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:39:\"sites/all/modules/contrib/date/date_api\";s:8:\"function\";s:19:\"theme_date_time_ago\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/contrib/date/date_api/theme/theme.inc\";}}s:10:\"date_combo\";a:7:{s:4:\"file\";s:10:\"date.theme\";s:4:\"path\";s:30:\"sites/all/modules/contrib/date\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:30:\"sites/all/modules/contrib/date\";s:8:\"function\";s:16:\"theme_date_combo\";s:8:\"includes\";a:1:{i:0;s:41:\"sites/all/modules/contrib/date/date.theme\";}}s:15:\"date_text_parts\";a:7:{s:4:\"file\";s:10:\"date.theme\";s:4:\"path\";s:30:\"sites/all/modules/contrib/date\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:30:\"sites/all/modules/contrib/date\";s:8:\"function\";s:21:\"theme_date_text_parts\";s:8:\"includes\";a:1:{i:0;s:41:\"sites/all/modules/contrib/date/date.theme\";}}s:19:\"date_display_single\";a:8:{s:4:\"file\";s:10:\"date.theme\";s:4:\"path\";s:30:\"sites/all/modules/contrib/date\";s:9:\"variables\";a:6:{s:4:\"date\";N;s:8:\"timezone\";N;s:5:\"dates\";N;s:10:\"attributes\";a:0:{}s:11:\"rdf_mapping\";N;s:7:\"add_rdf\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:30:\"sites/all/modules/contrib/date\";s:8:\"function\";s:25:\"theme_date_display_single\";s:8:\"includes\";a:1:{i:0;s:41:\"sites/all/modules/contrib/date/date.theme\";}s:20:\"preprocess functions\";a:1:{i:0;s:39:\"template_preprocess_date_display_single\";}}s:18:\"date_display_range\";a:8:{s:4:\"file\";s:10:\"date.theme\";s:4:\"path\";s:30:\"sites/all/modules/contrib/date\";s:9:\"variables\";a:9:{s:5:\"date1\";N;s:5:\"date2\";N;s:8:\"timezone\";N;s:5:\"dates\";N;s:10:\"attributes\";a:0:{}s:16:\"attributes_start\";a:0:{}s:14:\"attributes_end\";a:0:{}s:11:\"rdf_mapping\";N;s:7:\"add_rdf\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:30:\"sites/all/modules/contrib/date\";s:8:\"function\";s:24:\"theme_date_display_range\";s:8:\"includes\";a:1:{i:0;s:41:\"sites/all/modules/contrib/date/date.theme\";}s:20:\"preprocess functions\";a:1:{i:0;s:38:\"template_preprocess_date_display_range\";}}s:24:\"date_display_combination\";a:7:{s:4:\"file\";s:10:\"date.theme\";s:4:\"path\";s:30:\"sites/all/modules/contrib/date\";s:9:\"variables\";a:12:{s:11:\"entity_type\";N;s:6:\"entity\";N;s:5:\"field\";N;s:8:\"instance\";N;s:8:\"langcode\";N;s:4:\"item\";N;s:5:\"delta\";N;s:7:\"display\";N;s:5:\"dates\";N;s:10:\"attributes\";a:0:{}s:11:\"rdf_mapping\";N;s:7:\"add_rdf\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:30:\"sites/all/modules/contrib/date\";s:8:\"function\";s:30:\"theme_date_display_combination\";s:8:\"includes\";a:1:{i:0;s:41:\"sites/all/modules/contrib/date/date.theme\";}}s:21:\"date_display_interval\";a:7:{s:4:\"file\";s:10:\"date.theme\";s:4:\"path\";s:30:\"sites/all/modules/contrib/date\";s:9:\"variables\";a:12:{s:11:\"entity_type\";N;s:6:\"entity\";N;s:5:\"field\";N;s:8:\"instance\";N;s:8:\"langcode\";N;s:4:\"item\";N;s:5:\"delta\";N;s:7:\"display\";N;s:5:\"dates\";N;s:10:\"attributes\";a:0:{}s:11:\"rdf_mapping\";N;s:7:\"add_rdf\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:30:\"sites/all/modules/contrib/date\";s:8:\"function\";s:27:\"theme_date_display_interval\";s:8:\"includes\";a:1:{i:0;s:41:\"sites/all/modules/contrib/date/date.theme\";}}s:9:\"dashboard\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:15:\"theme_dashboard\";}s:15:\"dashboard_admin\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:21:\"theme_dashboard_admin\";}s:16:\"dashboard_region\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:22:\"theme_dashboard_region\";}s:25:\"dashboard_disabled_blocks\";a:4:{s:9:\"variables\";a:1:{s:6:\"blocks\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:31:\"theme_dashboard_disabled_blocks\";}s:24:\"dashboard_disabled_block\";a:4:{s:9:\"variables\";a:1:{s:5:\"block\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:30:\"theme_dashboard_disabled_block\";}s:28:\"dashboard_admin_display_form\";a:9:{s:8:\"template\";s:24:\"block-admin-display-form\";s:4:\"path\";s:13:\"modules/block\";s:4:\"file\";s:15:\"block.admin.inc\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"includes\";a:1:{i:0;s:29:\"modules/block/block.admin.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_dashboard_admin_display_form\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:28:\"ctools_ajax_sample_container\";a:4:{s:9:\"arguments\";a:1:{s:7:\"content\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:51:\"sites/all/modules/contrib/ctools/ctools_ajax_sample\";s:8:\"function\";s:34:\"theme_ctools_ajax_sample_container\";}s:19:\"ctools_context_list\";a:6:{s:9:\"variables\";a:1:{s:6:\"object\";N;}s:4:\"file\";s:26:\"includes/context.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:25:\"theme_ctools_context_list\";s:8:\"includes\";a:1:{i:0;s:59:\"sites/all/modules/contrib/ctools/includes/context.theme.inc\";}}s:28:\"ctools_context_list_no_table\";a:6:{s:9:\"variables\";a:1:{s:6:\"object\";N;}s:4:\"file\";s:26:\"includes/context.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:34:\"theme_ctools_context_list_no_table\";s:8:\"includes\";a:1:{i:0;s:59:\"sites/all/modules/contrib/ctools/includes/context.theme.inc\";}}s:24:\"ctools_context_item_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:26:\"includes/context.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:30:\"theme_ctools_context_item_form\";s:8:\"includes\";a:1:{i:0;s:59:\"sites/all/modules/contrib/ctools/includes/context.theme.inc\";}}s:23:\"ctools_context_item_row\";a:6:{s:9:\"variables\";a:5:{s:4:\"type\";N;s:4:\"form\";N;s:8:\"position\";N;s:5:\"count\";N;s:7:\"with_tr\";b:1;}s:4:\"file\";s:26:\"includes/context.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:29:\"theme_ctools_context_item_row\";s:8:\"includes\";a:1:{i:0;s:59:\"sites/all/modules/contrib/ctools/includes/context.theme.inc\";}}s:23:\"ctools_access_admin_add\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:33:\"includes/context-access-admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:29:\"theme_ctools_access_admin_add\";s:8:\"includes\";a:1:{i:0;s:66:\"sites/all/modules/contrib/ctools/includes/context-access-admin.inc\";}}s:24:\"links__ctools_dropbutton\";a:6:{s:9:\"variables\";a:4:{s:5:\"title\";N;s:5:\"links\";N;s:5:\"image\";b:0;s:5:\"class\";N;}s:4:\"file\";s:29:\"includes/dropbutton.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:30:\"theme_links__ctools_dropbutton\";s:8:\"includes\";a:1:{i:0;s:62:\"sites/all/modules/contrib/ctools/includes/dropbutton.theme.inc\";}}s:33:\"ctools_stylizer_color_scheme_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:21:\"includes/stylizer.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:39:\"theme_ctools_stylizer_color_scheme_form\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/contrib/ctools/includes/stylizer.inc\";}}s:28:\"ctools_stylizer_preview_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:21:\"includes/stylizer.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:34:\"theme_ctools_stylizer_preview_form\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/contrib/ctools/includes/stylizer.inc\";}}s:17:\"ctools_style_icon\";a:6:{s:9:\"variables\";a:2:{s:5:\"image\";N;s:5:\"title\";N;}s:4:\"file\";s:21:\"includes/stylizer.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:23:\"theme_ctools_style_icon\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/contrib/ctools/includes/stylizer.inc\";}}s:19:\"ctools_wizard_trail\";a:6:{s:9:\"variables\";a:1:{s:5:\"trail\";N;}s:4:\"file\";s:25:\"includes/wizard.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:25:\"theme_ctools_wizard_trail\";s:8:\"includes\";a:1:{i:0;s:58:\"sites/all/modules/contrib/ctools/includes/wizard.theme.inc\";}}s:18:\"ctools_collapsible\";a:6:{s:9:\"variables\";a:3:{s:6:\"handle\";N;s:7:\"content\";N;s:9:\"collapsed\";b:0;}s:4:\"file\";s:30:\"includes/collapsible.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:24:\"theme_ctools_collapsible\";s:8:\"includes\";a:1:{i:0;s:63:\"sites/all/modules/contrib/ctools/includes/collapsible.theme.inc\";}}s:29:\"ctools_collapsible_remembered\";a:6:{s:9:\"variables\";a:4:{s:2:\"id\";N;s:6:\"handle\";N;s:7:\"content\";N;s:9:\"collapsed\";b:0;}s:4:\"file\";s:30:\"includes/collapsible.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:35:\"theme_ctools_collapsible_remembered\";s:8:\"includes\";a:1:{i:0;s:63:\"sites/all/modules/contrib/ctools/includes/collapsible.theme.inc\";}}s:15:\"ctools_dropdown\";a:6:{s:9:\"variables\";a:4:{s:5:\"title\";N;s:5:\"links\";N;s:5:\"image\";b:0;s:5:\"class\";s:0:\"\";}s:4:\"file\";s:27:\"includes/dropdown.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/contrib/ctools\";s:8:\"function\";s:21:\"theme_ctools_dropdown\";s:8:\"includes\";a:1:{i:0;s:60:\"sites/all/modules/contrib/ctools/includes/dropdown.theme.inc\";}}s:13:\"comment_block\";a:4:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/comment\";s:8:\"function\";s:19:\"theme_comment_block\";}s:15:\"comment_preview\";a:4:{s:9:\"variables\";a:1:{s:7:\"comment\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/comment\";s:8:\"function\";s:21:\"theme_comment_preview\";}s:22:\"comment_post_forbidden\";a:4:{s:9:\"variables\";a:1:{s:4:\"node\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/comment\";s:8:\"function\";s:28:\"theme_comment_post_forbidden\";}s:15:\"comment_wrapper\";a:6:{s:8:\"template\";s:31:\"modules/comment/comment-wrapper\";s:14:\"render element\";s:7:\"content\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/comment\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:35:\"template_preprocess_comment_wrapper\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:17:\"color_scheme_form\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/color\";s:8:\"function\";s:23:\"theme_color_scheme_form\";}s:12:\"coder_review\";a:4:{s:9:\"variables\";a:3:{s:4:\"name\";N;s:8:\"filename\";N;s:7:\"results\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:44:\"sites/all/modules/contrib/coder/coder_review\";s:8:\"function\";s:18:\"theme_coder_review\";}s:20:\"coder_review_warning\";a:4:{s:9:\"variables\";a:4:{s:7:\"warning\";N;s:13:\"severity_name\";N;s:6:\"lineno\";N;s:4:\"line\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:44:\"sites/all/modules/contrib/coder/coder_review\";s:8:\"function\";s:26:\"theme_coder_review_warning\";}s:24:\"coder_review_warning_msg\";a:4:{s:9:\"variables\";a:1:{s:5:\"error\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:44:\"sites/all/modules/contrib/coder/coder_review\";s:8:\"function\";s:30:\"theme_coder_review_warning_msg\";}s:23:\"coder_review_table_cols\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:44:\"sites/all/modules/contrib/coder/coder_review\";s:8:\"function\";s:29:\"theme_coder_review_table_cols\";}s:9:\"drupalapi\";a:4:{s:9:\"variables\";a:2:{s:8:\"function\";N;s:7:\"version\";s:1:\"7\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:44:\"sites/all/modules/contrib/coder/coder_review\";s:8:\"function\";s:15:\"theme_drupalapi\";}s:6:\"phpapi\";a:4:{s:9:\"variables\";a:1:{s:8:\"function\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:44:\"sites/all/modules/contrib/coder/coder_review\";s:8:\"function\";s:12:\"theme_phpapi\";}s:24:\"block_admin_display_form\";a:8:{s:8:\"template\";s:38:\"modules/block/block-admin-display-form\";s:4:\"file\";s:15:\"block.admin.inc\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/block\";s:8:\"includes\";a:1:{i:0;s:29:\"modules/block/block.admin.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:44:\"template_preprocess_block_admin_display_form\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}}',0,1371656328,1),('theme_registry:runtime:mercury','a:317:{s:10:\"breadcrumb\";a:4:{s:8:\"function\";s:18:\"mercury_breadcrumb\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";s:9:\"variables\";a:1:{s:10:\"breadcrumb\";N;}}s:9:\"menu_link\";a:4:{s:8:\"function\";s:17:\"mercury_menu_link\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";s:14:\"render element\";s:7:\"element\";}s:16:\"menu_local_tasks\";a:4:{s:8:\"function\";s:24:\"mercury_menu_local_tasks\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";s:9:\"variables\";a:2:{s:7:\"primary\";a:0:{}s:9:\"secondary\";a:0:{}}}s:7:\"comment\";N;s:4:\"page\";a:7:{s:8:\"template\";s:4:\"page\";s:4:\"path\";s:34:\"sites/all/themes/mercury/templates\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";s:14:\"render element\";s:4:\"page\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:24:\"template_preprocess_page\";i:2;s:24:\"shortcut_preprocess_page\";i:3;s:23:\"mercury_preprocess_page\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:21:\"template_process_page\";i:2;s:11:\"rdf_process\";}}s:4:\"node\";N;s:5:\"block\";a:7:{s:8:\"template\";s:5:\"block\";s:4:\"path\";s:34:\"sites/all/themes/mercury/templates\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";s:14:\"render element\";s:8:\"elements\";s:20:\"preprocess functions\";a:5:{i:0;s:19:\"template_preprocess\";i:1;s:25:\"template_preprocess_block\";i:2;s:28:\"block_class_preprocess_block\";i:3;s:23:\"system_preprocess_block\";i:4;s:24:\"mercury_preprocess_block\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:4:\"html\";a:7:{s:8:\"template\";s:4:\"html\";s:4:\"path\";s:34:\"sites/all/themes/mercury/templates\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";s:14:\"render element\";s:4:\"page\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:24:\"template_preprocess_html\";i:2;s:22:\"panels_preprocess_html\";i:3;s:21:\"views_preprocess_html\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:21:\"template_process_html\";i:2;s:11:\"rdf_process\";}}s:47:\"views_view_field__field_fa_administration_state\";N;s:44:\"views_view_field__field_fa_operational_state\";N;s:47:\"views_view_field__all_vm__field_driver_status_1\";N;s:47:\"views_view_field__all_host__field_bundle_status\";N;s:58:\"views_view_unformatted__vdisk_metric_per_vm__entity_view_1\";N;s:49:\"views_view_unformatted__vm_metrics__entity_view_1\";N;s:58:\"views_view_unformatted__vdisk_metric_per_vm__entity_view_2\";N;s:10:\"node__host\";N;s:21:\"node__virtual_machine\";N;s:16:\"admin_menu_links\";N;s:15:\"admin_menu_icon\";N;s:30:\"page_manager_handler_rearrange\";N;s:22:\"page_manager_edit_page\";N;s:17:\"page_manager_lock\";N;s:20:\"page_manager_changed\";N;s:37:\"page_manager_page_form_argument_table\";N;s:22:\"page_manager_page_lock\";N;s:25:\"page_manager_page_changed\";N;s:16:\"views_mini_pager\";N;s:16:\"views_view_field\";N;s:19:\"views_view_grouping\";N;s:10:\"views_view\";N;s:23:\"eva_display_entity_view\";N;s:15:\"date_navigation\";N;s:22:\"views_view_unformatted\";N;s:17:\"views_data_export\";N;s:28:\"views_data_export_csv_header\";N;s:26:\"views_data_export_csv_body\";N;s:28:\"views_data_export_csv_footer\";N;s:28:\"views_data_export_doc_header\";N;s:26:\"views_data_export_doc_body\";N;s:28:\"views_data_export_doc_footer\";N;s:28:\"views_data_export_txt_header\";N;s:26:\"views_data_export_txt_body\";N;s:28:\"views_data_export_txt_footer\";N;s:28:\"views_data_export_xls_header\";N;s:26:\"views_data_export_xls_body\";N;s:28:\"views_data_export_xls_footer\";N;s:28:\"views_data_export_xml_header\";N;s:26:\"views_data_export_xml_body\";N;s:28:\"views_data_export_xml_footer\";N;s:25:\"views_view_watchdog_table\";N;s:15:\"views_view_list\";N;s:15:\"views_view_grid\";N;s:16:\"views_view_table\";N;s:18:\"views_view_summary\";N;s:30:\"views_view_summary_unformatted\";N;s:14:\"views_view_rss\";N;s:28:\"views_view_summary_jump_menu\";N;s:20:\"views_view_jump_menu\";N;s:22:\"views_view_row_comment\";N;s:18:\"views_view_row_rss\";N;s:17:\"views_view_fields\";N;s:21:\"views_form_views_form\";N;s:18:\"views_exposed_form\";N;s:10:\"views_more\";N;s:15:\"horizontal_tabs\";N;s:9:\"multipage\";N;s:14:\"multipage_pane\";N;s:28:\"views_ui_display_tab_setting\";N;s:27:\"views_ui_display_tab_bucket\";N;s:18:\"views_ui_edit_item\";N;s:23:\"views_ui_rearrange_form\";N;s:30:\"views_ui_rearrange_filter_form\";N;s:27:\"views_ui_expose_filter_form\";N;s:18:\"views_ui_view_info\";N;s:32:\"views_ui_build_group_filter_form\";N;s:12:\"views_tabset\";N;s:9:\"views_tab\";N;s:30:\"views_ui_reorder_displays_form\";N;s:27:\"views_ui_style_plugin_table\";N;s:29:\"views_ui_view_preview_section\";N;s:15:\"views_container\";N;s:27:\"views_data_export_feed_icon\";N;s:31:\"views_data_export_complete_page\";N;s:25:\"views_data_export_message\";N;s:12:\"user_picture\";N;s:12:\"user_profile\";N;s:21:\"user_profile_category\";N;s:17:\"user_profile_item\";N;s:9:\"user_list\";N;s:22:\"user_admin_permissions\";N;s:16:\"user_admin_roles\";N;s:27:\"user_permission_description\";N;s:14:\"user_signature\";N;s:10:\"tree_table\";N;s:10:\"token_tree\";N;s:15:\"token_tree_link\";N;s:30:\"taxonomy_overview_vocabularies\";N;s:23:\"taxonomy_overview_terms\";N;s:13:\"taxonomy_term\";N;s:6:\"region\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:21:\"modules/system/region\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:26:\"template_preprocess_region\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:11:\"rdf_process\";}}s:15:\"status_messages\";a:4:{s:9:\"variables\";a:1:{s:7:\"display\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:21:\"theme_status_messages\";}s:4:\"link\";a:4:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:4:\"path\";N;s:7:\"options\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_link\";}s:5:\"links\";N;s:5:\"image\";a:5:{s:9:\"variables\";a:6:{s:4:\"path\";N;s:5:\"width\";N;s:6:\"height\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";N;s:10:\"attributes\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_image\";s:20:\"preprocess functions\";a:1:{i:0;s:20:\"rdf_preprocess_image\";}}s:4:\"help\";N;s:5:\"table\";N;s:19:\"tablesort_indicator\";N;s:4:\"mark\";N;s:9:\"item_list\";N;s:14:\"more_help_link\";N;s:9:\"feed_icon\";N;s:9:\"more_link\";N;s:8:\"username\";N;s:12:\"progress_bar\";N;s:11:\"indentation\";N;s:8:\"html_tag\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_html_tag\";}s:16:\"maintenance_page\";N;s:11:\"update_page\";N;s:12:\"install_page\";N;s:9:\"task_list\";N;s:17:\"authorize_message\";N;s:16:\"authorize_report\";N;s:5:\"pager\";N;s:11:\"pager_first\";N;s:14:\"pager_previous\";N;s:10:\"pager_next\";N;s:10:\"pager_last\";N;s:10:\"pager_link\";N;s:9:\"menu_tree\";a:5:{s:14:\"render element\";s:4:\"tree\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_menu_tree\";s:20:\"preprocess functions\";a:1:{i:0;s:29:\"template_preprocess_menu_tree\";}}s:15:\"menu_local_task\";a:5:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/themes/mercury\";s:8:\"function\";s:21:\"theme_menu_local_task\";s:20:\"preprocess functions\";a:1:{i:0;s:34:\"mercury_preprocess_menu_local_task\";}}s:17:\"menu_local_action\";N;s:6:\"select\";N;s:8:\"fieldset\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_fieldset\";}s:5:\"radio\";N;s:6:\"radios\";N;s:4:\"date\";N;s:15:\"exposed_filters\";N;s:8:\"checkbox\";N;s:10:\"checkboxes\";N;s:6:\"button\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_button\";}s:12:\"image_button\";N;s:6:\"hidden\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_hidden\";}s:9:\"textfield\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_textfield\";}s:4:\"form\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_form\";}s:8:\"textarea\";N;s:8:\"password\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_password\";}s:4:\"file\";N;s:11:\"tableselect\";N;s:12:\"form_element\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_form_element\";}s:20:\"form_required_marker\";N;s:18:\"form_element_label\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:24:\"theme_form_element_label\";}s:13:\"vertical_tabs\";N;s:9:\"container\";N;s:18:\"system_themes_page\";N;s:20:\"system_settings_form\";N;s:12:\"confirm_form\";N;s:23:\"system_modules_fieldset\";N;s:27:\"system_modules_incompatible\";N;s:24:\"system_modules_uninstall\";N;s:13:\"status_report\";N;s:10:\"admin_page\";N;s:11:\"admin_block\";N;s:19:\"admin_block_content\";N;s:18:\"system_admin_index\";N;s:17:\"system_powered_by\";N;s:19:\"system_compact_link\";N;s:25:\"system_date_time_settings\";N;s:22:\"shortcut_set_customize\";N;s:23:\"search_api_page_results\";N;s:22:\"search_api_page_result\";N;s:17:\"search_api_server\";N;s:16:\"search_api_index\";N;s:27:\"search_api_admin_item_order\";N;s:29:\"search_api_admin_fields_table\";N;s:17:\"search_block_form\";N;s:13:\"search_result\";N;s:14:\"search_results\";N;s:29:\"rdf_template_variable_wrapper\";N;s:12:\"rdf_metadata\";N;s:17:\"r4032login_denied\";N;s:23:\"panels_ipe_pane_wrapper\";N;s:25:\"panels_ipe_region_wrapper\";N;s:26:\"panels_ipe_add_pane_button\";N;s:27:\"panels_ipe_placeholder_pane\";N;s:29:\"panels_ipe_dnd_form_container\";N;s:18:\"panels_ipe_toolbar\";N;s:18:\"panels_layout_link\";N;s:18:\"panels_layout_icon\";N;s:11:\"panels_pane\";N;s:26:\"panels_common_content_list\";N;s:26:\"panels_render_display_form\";N;s:16:\"panels_dashboard\";N;s:21:\"panels_dashboard_link\";N;s:22:\"panels_dashboard_block\";N;s:24:\"panels_add_content_modal\";N;s:23:\"panels_add_content_link\";N;s:15:\"panels_flexible\";N;s:21:\"panels_flexible_admin\";N;s:24:\"panels_threecol_33_34_33\";N;s:13:\"panels_onecol\";N;s:24:\"panels_threecol_25_50_25\";N;s:32:\"panels_threecol_25_50_25_stacked\";N;s:20:\"panels_twocol_bricks\";N;s:32:\"panels_threecol_33_34_33_stacked\";N;s:21:\"panels_twocol_stacked\";N;s:13:\"panels_twocol\";N;s:40:\"panels_rounded_corners_style_render_pane\";N;s:42:\"panels_rounded_corners_style_render_region\";N;s:26:\"panels_rounded_corners_box\";N;s:30:\"panels_block_style_render_pane\";N;s:34:\"panels_default_style_render_region\";N;s:30:\"panels_naked_style_render_pane\";N;s:32:\"panels_naked_style_render_region\";N;s:31:\"panels_list_style_render_region\";N;s:12:\"options_none\";N;s:17:\"node_search_admin\";N;s:13:\"node_add_list\";N;s:12:\"node_preview\";N;s:19:\"node_admin_overview\";N;s:17:\"node_recent_block\";N;s:19:\"node_recent_content\";N;s:28:\"module_filter_system_modules\";N;s:27:\"module_filter_modules_table\";N;s:33:\"module_filter_system_modules_tabs\";N;s:18:\"menu_overview_form\";N;s:19:\"menu_admin_overview\";N;s:29:\"login_destination_destination\";N;s:23:\"login_destination_pages\";N;s:26:\"login_destination_triggers\";N;s:23:\"login_destination_roles\";N;s:17:\"lt_username_title\";N;s:23:\"lt_username_description\";N;s:17:\"lt_password_title\";N;s:23:\"lt_password_description\";N;s:16:\"lt_access_denied\";N;s:16:\"lt_loggedinblock\";N;s:13:\"lt_login_link\";N;s:27:\"lt_login_successful_message\";N;s:21:\"lt_unified_login_page\";N;s:15:\"transfer_slider\";N;s:21:\"filter_admin_overview\";N;s:32:\"filter_admin_format_filter_order\";N;s:11:\"filter_tips\";N;s:19:\"text_format_wrapper\";N;s:21:\"filter_tips_more_info\";N;s:17:\"filter_guidelines\";N;s:14:\"field_ui_table\";N;s:5:\"field\";N;s:25:\"field_multiple_value_form\";N;s:38:\"famc_analytics_vm_historical_perf_form\";N;s:29:\"famc_analytics_analytics_form\";N;s:34:\"famc_analytics_analytics_view_form\";N;s:13:\"entity_status\";N;s:6:\"entity\";N;s:23:\"entity_ui_overview_item\";N;s:13:\"dblog_message\";N;s:14:\"date_nav_title\";N;s:22:\"date_views_filter_form\";N;s:17:\"date_calendar_day\";N;s:16:\"date_views_pager\";N;s:10:\"date_popup\";N;s:13:\"date_timezone\";N;s:11:\"date_select\";N;s:9:\"date_text\";N;s:19:\"date_select_element\";N;s:22:\"date_textfield_element\";N;s:21:\"date_part_hour_prefix\";N;s:23:\"date_part_minsec_prefix\";N;s:20:\"date_part_label_year\";N;s:21:\"date_part_label_month\";N;s:19:\"date_part_label_day\";N;s:20:\"date_part_label_hour\";N;s:22:\"date_part_label_minute\";N;s:22:\"date_part_label_second\";N;s:20:\"date_part_label_ampm\";N;s:24:\"date_part_label_timezone\";N;s:20:\"date_part_label_date\";N;s:20:\"date_part_label_time\";N;s:13:\"date_time_ago\";N;s:10:\"date_combo\";N;s:15:\"date_text_parts\";N;s:19:\"date_display_single\";N;s:18:\"date_display_range\";N;s:24:\"date_display_combination\";N;s:21:\"date_display_interval\";N;s:9:\"dashboard\";N;s:15:\"dashboard_admin\";N;s:16:\"dashboard_region\";N;s:25:\"dashboard_disabled_blocks\";N;s:24:\"dashboard_disabled_block\";N;s:28:\"dashboard_admin_display_form\";N;s:28:\"ctools_ajax_sample_container\";N;s:19:\"ctools_context_list\";N;s:28:\"ctools_context_list_no_table\";N;s:24:\"ctools_context_item_form\";N;s:23:\"ctools_context_item_row\";N;s:23:\"ctools_access_admin_add\";N;s:24:\"links__ctools_dropbutton\";N;s:33:\"ctools_stylizer_color_scheme_form\";N;s:28:\"ctools_stylizer_preview_form\";N;s:17:\"ctools_style_icon\";N;s:19:\"ctools_wizard_trail\";N;s:18:\"ctools_collapsible\";N;s:29:\"ctools_collapsible_remembered\";N;s:15:\"ctools_dropdown\";N;s:13:\"comment_block\";N;s:15:\"comment_preview\";N;s:22:\"comment_post_forbidden\";N;s:15:\"comment_wrapper\";N;s:17:\"color_scheme_form\";N;s:12:\"coder_review\";N;s:20:\"coder_review_warning\";N;s:24:\"coder_review_warning_msg\";N;s:23:\"coder_review_table_cols\";N;s:9:\"drupalapi\";N;s:6:\"phpapi\";N;s:24:\"block_admin_display_form\";N;}',0,1371656328,1);
/*!40000 ALTER TABLE `cache` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_admin_menu`
--

DROP TABLE IF EXISTS `cache_admin_menu`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_admin_menu` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Cache table for Administration menu to store client-side...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_admin_menu`
--

LOCK TABLES `cache_admin_menu` WRITE;
/*!40000 ALTER TABLE `cache_admin_menu` DISABLE KEYS */;
/*!40000 ALTER TABLE `cache_admin_menu` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_block`
--

DROP TABLE IF EXISTS `cache_block`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_block` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Cache table for the Block module to store already built...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_block`
--

LOCK TABLES `cache_block` WRITE;
/*!40000 ALTER TABLE `cache_block` DISABLE KEYS */;
/*!40000 ALTER TABLE `cache_block` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_bootstrap`
--

DROP TABLE IF EXISTS `cache_bootstrap`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_bootstrap` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Cache table for data required to bootstrap Drupal, may be...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_bootstrap`
--

LOCK TABLES `cache_bootstrap` WRITE;
/*!40000 ALTER TABLE `cache_bootstrap` DISABLE KEYS */;
INSERT INTO `cache_bootstrap` VALUES ('lookup_cache','a:41:{s:30:\"cDrupalDefaultEntityController\";s:19:\"includes/entity.inc\";s:5:\"cview\";s:49:\"sites/all/modules/contrib/views/includes/view.inc\";s:30:\"cEntityAPIControllerExportable\";s:63:\"sites/all/modules/contrib/entity/includes/entity.controller.inc\";s:25:\"cEntityFieldHandlerHelper\";s:85:\"sites/all/modules/contrib/entity/views/handlers/entity_views_field_handler_helper.inc\";s:29:\"cviews_plugin_display_default\";s:72:\"sites/all/modules/contrib/views/plugins/views_plugin_display_default.inc\";s:21:\"cviews_plugin_display\";s:64:\"sites/all/modules/contrib/views/plugins/views_plugin_display.inc\";s:31:\"cviews_plugin_localization_none\";s:74:\"sites/all/modules/contrib/views/plugins/views_plugin_localization_none.inc\";s:26:\"cviews_plugin_localization\";s:69:\"sites/all/modules/contrib/views/plugins/views_plugin_localization.inc\";s:26:\"cviews_plugin_display_page\";s:69:\"sites/all/modules/contrib/views/plugins/views_plugin_display_page.inc\";s:27:\"cviews_plugin_display_block\";s:70:\"sites/all/modules/contrib/views/plugins/views_plugin_display_block.inc\";s:26:\"cviews_plugin_display_feed\";s:69:\"sites/all/modules/contrib/views/plugins/views_plugin_display_feed.inc\";s:32:\"cviews_plugin_display_attachment\";s:75:\"sites/all/modules/contrib/views/plugins/views_plugin_display_attachment.inc\";s:26:\"ceva_plugin_display_entity\";s:59:\"sites/all/modules/contrib/eva/eva_plugin_display_entity.inc\";s:26:\"cviews_handler_field_field\";s:75:\"sites/all/modules/contrib/views/modules/field/views_handler_field_field.inc\";s:20:\"cviews_handler_field\";s:64:\"sites/all/modules/contrib/views/handlers/views_handler_field.inc\";s:31:\"cviews_handler_argument_numeric\";s:75:\"sites/all/modules/contrib/views/handlers/views_handler_argument_numeric.inc\";s:23:\"cviews_handler_argument\";s:67:\"sites/all/modules/contrib/views/handlers/views_handler_argument.inc\";s:19:\"cviews_handler_sort\";s:63:\"sites/all/modules/contrib/views/handlers/views_handler_sort.inc\";s:38:\"cviews_handler_filter_boolean_operator\";s:82:\"sites/all/modules/contrib/views/handlers/views_handler_filter_boolean_operator.inc\";s:21:\"cviews_handler_filter\";s:65:\"sites/all/modules/contrib/views/handlers/views_handler_filter.inc\";s:31:\"cviews_handler_filter_node_type\";s:79:\"sites/all/modules/contrib/views/modules/node/views_handler_filter_node_type.inc\";s:33:\"cviews_handler_filter_in_operator\";s:77:\"sites/all/modules/contrib/views/handlers/views_handler_filter_in_operator.inc\";s:24:\"cviews_handler_area_text\";s:68:\"sites/all/modules/contrib/views/handlers/views_handler_area_text.inc\";s:19:\"cviews_handler_area\";s:63:\"sites/all/modules/contrib/views/handlers/views_handler_area.inc\";s:24:\"cviews_plugin_pager_some\";s:67:\"sites/all/modules/contrib/views/plugins/views_plugin_pager_some.inc\";s:19:\"cviews_plugin_pager\";s:62:\"sites/all/modules/contrib/views/plugins/views_plugin_pager.inc\";s:25:\"cviews_handler_field_node\";s:73:\"sites/all/modules/contrib/views/modules/node/views_handler_field_node.inc\";s:28:\"cviews_handler_filter_string\";s:72:\"sites/all/modules/contrib/views/handlers/views_handler_filter_string.inc\";s:24:\"cviews_plugin_pager_full\";s:67:\"sites/all/modules/contrib/views/plugins/views_plugin_pager_full.inc\";s:15:\"cSearchApiIndex\";s:62:\"sites/all/modules/contrib/search_api/includes/index_entity.inc\";s:7:\"cEntity\";s:52:\"sites/all/modules/contrib/entity/includes/entity.inc\";s:19:\"cPagerDefault_mysql\";b:0;s:19:\"iPagerDefault_mysql\";b:0;s:16:\"cTableSort_mysql\";b:0;s:16:\"iTableSort_mysql\";b:0;s:9:\"cviews_ui\";s:68:\"sites/all/modules/contrib/views/plugins/export_ui/views_ui.class.php\";s:17:\"cctools_export_ui\";s:77:\"sites/all/modules/contrib/ctools/plugins/export_ui/ctools_export_ui.class.php\";s:25:\"cctools_custom_content_ui\";s:107:\"sites/all/modules/contrib/ctools/ctools_custom_content/plugins/export_ui/ctools_custom_content_ui.class.php\";s:15:\"cpanels_mini_ui\";s:87:\"sites/all/modules/contrib/panels/panels_mini/plugins/export_ui/panels_mini_ui.class.php\";s:18:\"cpanels_layouts_ui\";s:78:\"sites/all/modules/contrib/panels/plugins/export_ui/panels_layouts_ui.class.php\";s:20:\"cSelectQueryExtender\";s:28:\"includes/database/select.inc\";}',0,1371656320,1),('module_implements','a:125:{s:15:\"stream_wrappers\";a:1:{s:6:\"system\";b:0;}s:23:\"module_implements_alter\";a:3:{s:6:\"entity\";b:0;s:5:\"token\";b:0;s:8:\"pathauto\";b:0;}s:21:\"stream_wrappers_alter\";a:0:{}s:17:\"url_inbound_alter\";a:0:{}s:12:\"custom_theme\";a:2:{s:6:\"system\";b:0;s:8:\"views_ui\";b:0;}s:11:\"admin_paths\";a:7:{s:5:\"block\";b:0;s:4:\"node\";b:0;s:8:\"shortcut\";b:0;s:6:\"system\";b:0;s:8:\"taxonomy\";b:0;s:4:\"user\";b:0;s:12:\"page_manager\";b:0;}s:17:\"admin_paths_alter\";a:0:{}s:19:\"menu_get_item_alter\";a:1:{s:13:\"logintoboggan\";b:0;}s:18:\"url_outbound_alter\";a:0:{}s:13:\"library_alter\";a:1:{s:8:\"views_ui\";b:0;}s:4:\"init\";a:10:{s:6:\"ctools\";b:0;s:5:\"dblog\";b:0;s:15:\"entityreference\";b:0;s:14:\"famc_analytics\";b:0;s:18:\"mercury_management\";b:0;s:17:\"mercury_utilities\";b:0;s:6:\"panels\";b:0;s:10:\"references\";b:0;s:6:\"system\";b:0;s:17:\"views_data_export\";b:0;}s:11:\"entity_info\";a:7:{s:7:\"comment\";b:0;s:4:\"node\";b:0;s:10:\"search_api\";b:0;s:15:\"search_api_page\";b:0;s:6:\"system\";b:0;s:8:\"taxonomy\";b:0;s:4:\"user\";b:0;}s:9:\"node_info\";a:1:{s:11:\"panels_node\";b:0;}s:11:\"query_alter\";a:0:{}s:24:\"query_translatable_alter\";a:0:{}s:28:\"query_node_type_access_alter\";a:0:{}s:6:\"schema\";a:32:{s:5:\"block\";b:0;s:11:\"block_class\";b:0;s:12:\"coder_review\";b:0;s:7:\"comment\";b:0;s:6:\"ctools\";b:0;s:21:\"ctools_custom_content\";b:0;s:5:\"dblog\";b:0;s:14:\"famc_analytics\";b:0;s:5:\"field\";b:0;s:17:\"field_sql_storage\";b:0;s:6:\"filter\";b:0;s:17:\"login_destination\";b:0;s:4:\"menu\";b:0;s:17:\"mercury_utilities\";b:0;s:4:\"node\";b:0;s:6:\"panels\";b:0;s:11:\"panels_mini\";b:0;s:3:\"rdf\";b:0;s:6:\"search\";b:0;s:10:\"search_api\";b:0;s:15:\"search_api_page\";b:0;s:8:\"shortcut\";b:0;s:6:\"system\";b:0;s:8:\"taxonomy\";b:0;s:5:\"token\";b:0;s:4:\"user\";b:0;s:17:\"views_data_export\";b:0;s:11:\"field_group\";b:0;s:5:\"views\";b:0;s:11:\"panels_node\";b:0;s:12:\"page_manager\";b:0;s:10:\"admin_menu\";b:0;}s:16:\"field_read_field\";a:0:{}s:12:\"schema_alter\";a:0:{}s:17:\"entity_info_alter\";a:3:{s:3:\"rdf\";b:0;s:5:\"token\";b:0;s:6:\"entity\";b:0;}s:11:\"rdf_mapping\";a:4:{s:7:\"comment\";b:0;s:4:\"node\";b:0;s:8:\"taxonomy\";b:0;s:4:\"user\";b:0;}s:30:\"query_node_load_multiple_alter\";a:0:{}s:19:\"field_read_instance\";a:0:{}s:10:\"field_info\";a:10:{s:14:\"computed_field\";b:0;s:4:\"date\";b:0;s:15:\"entityreference\";b:0;s:4:\"list\";b:0;s:14:\"node_reference\";b:0;s:6:\"number\";b:0;s:14:\"password_field\";b:0;s:8:\"taxonomy\";b:0;s:4:\"text\";b:0;s:14:\"user_reference\";b:0;}s:16:\"field_info_alter\";a:3:{s:6:\"entity\";b:0;s:5:\"token\";b:0;s:4:\"user\";b:0;}s:17:\"field_widget_info\";a:10:{s:14:\"computed_field\";b:0;s:4:\"date\";b:0;s:15:\"entityreference\";b:0;s:14:\"node_reference\";b:0;s:6:\"number\";b:0;s:7:\"options\";b:0;s:14:\"password_field\";b:0;s:8:\"taxonomy\";b:0;s:4:\"text\";b:0;s:14:\"user_reference\";b:0;}s:23:\"field_widget_info_alter\";a:5:{s:15:\"entityreference\";b:0;s:4:\"list\";b:0;s:14:\"node_reference\";b:0;s:8:\"taxonomy\";b:0;s:14:\"user_reference\";b:0;}s:20:\"field_formatter_info\";a:10:{s:14:\"computed_field\";b:0;s:4:\"date\";b:0;s:15:\"entityreference\";b:0;s:4:\"list\";b:0;s:14:\"node_reference\";b:0;s:6:\"number\";b:0;s:14:\"password_field\";b:0;s:8:\"taxonomy\";b:0;s:4:\"text\";b:0;s:14:\"user_reference\";b:0;}s:26:\"field_formatter_info_alter\";a:0:{}s:18:\"field_storage_info\";a:1:{s:17:\"field_sql_storage\";b:0;}s:24:\"field_storage_info_alter\";a:0:{}s:27:\"field_storage_details_alter\";a:0:{}s:18:\"field_extra_fields\";a:7:{s:7:\"comment\";b:0;s:3:\"eva\";b:0;s:4:\"node\";b:0;s:4:\"path\";b:0;s:8:\"taxonomy\";b:0;s:4:\"user\";b:0;s:11:\"field_group\";b:0;}s:9:\"views_api\";a:19:{s:7:\"comment\";b:0;s:10:\"date_views\";b:0;s:6:\"entity\";b:0;s:15:\"entityreference\";b:0;s:3:\"eva\";b:0;s:5:\"field\";b:0;s:6:\"filter\";b:0;s:4:\"node\";b:0;s:6:\"panels\";b:0;s:10:\"references\";b:0;s:6:\"search\";b:0;s:6:\"system\";b:0;s:8:\"taxonomy\";b:0;s:4:\"user\";b:0;s:13:\"views_content\";b:0;s:17:\"views_data_export\";b:0;s:9:\"views_php\";b:0;s:14:\"views_watchdog\";b:0;s:5:\"views\";b:0;}s:15:\"views_api_alter\";a:0:{}s:13:\"views_plugins\";a:16:{s:7:\"comment\";b:0;s:10:\"date_views\";b:0;s:6:\"entity\";b:0;s:15:\"entityreference\";b:0;s:3:\"eva\";b:0;s:4:\"node\";b:0;s:6:\"panels\";b:0;s:10:\"references\";b:0;s:6:\"search\";b:0;s:8:\"taxonomy\";b:0;s:4:\"user\";b:0;s:13:\"views_content\";b:0;s:17:\"views_data_export\";b:0;s:9:\"views_php\";b:0;s:14:\"views_watchdog\";b:0;s:5:\"views\";b:0;}s:10:\"views_data\";a:13:{s:7:\"comment\";b:0;s:10:\"date_views\";b:0;s:6:\"entity\";b:0;s:5:\"field\";b:0;s:6:\"filter\";b:0;s:4:\"node\";b:0;s:6:\"search\";b:0;s:6:\"system\";b:0;s:8:\"taxonomy\";b:0;s:4:\"user\";b:0;s:9:\"views_php\";b:0;s:14:\"views_watchdog\";b:0;s:5:\"views\";b:0;}s:23:\"date_views_extra_tables\";a:1:{s:10:\"date_views\";b:0;}s:20:\"entity_property_info\";a:3:{s:6:\"entity\";s:4:\"info\";s:10:\"search_api\";b:0;s:15:\"search_api_page\";b:0;}s:26:\"entity_property_info_alter\";a:1:{s:6:\"entity\";s:4:\"info\";}s:33:\"entity_views_field_handlers_alter\";a:0:{}s:22:\"field_views_data_alter\";a:1:{s:10:\"date_views\";b:0;}s:16:\"views_data_alter\";a:4:{s:7:\"comment\";b:0;s:10:\"date_views\";b:0;s:5:\"field\";b:0;s:8:\"taxonomy\";b:0;}s:19:\"views_plugins_alter\";a:1:{s:8:\"views_ui\";b:0;}s:25:\"views_default_views_alter\";a:0:{}s:12:\"field_access\";a:0:{}s:45:\"query_taxonomy_vocabulary_load_multiple_alter\";a:0:{}s:11:\"entity_load\";a:1:{s:3:\"rdf\";b:0;}s:24:\"taxonomy_vocabulary_load\";a:0:{}s:24:\"field_extra_fields_alter\";a:0:{}s:22:\"field_storage_pre_load\";a:0:{}s:17:\"field_attach_load\";a:0:{}s:9:\"node_load\";a:2:{s:7:\"comment\";b:0;s:4:\"user\";b:0;}s:20:\"field_attach_presave\";a:0:{}s:12:\"node_presave\";a:0:{}s:14:\"entity_presave\";a:1:{s:8:\"pathauto\";b:0;}s:24:\"field_storage_pre_update\";a:0:{}s:19:\"field_attach_update\";a:1:{s:15:\"entityreference\";b:0;}s:11:\"node_update\";a:5:{s:4:\"menu\";b:0;s:4:\"path\";b:0;s:6:\"search\";b:0;s:8:\"taxonomy\";b:0;s:8:\"pathauto\";b:0;}s:6:\"tokens\";a:14:{s:5:\"token\";s:6:\"tokens\";s:7:\"comment\";s:6:\"tokens\";s:14:\"computed_field\";b:0;s:4:\"date\";s:6:\"tokens\";s:12:\"entity_token\";s:6:\"tokens\";s:5:\"field\";b:0;s:13:\"logintoboggan\";s:6:\"tokens\";s:4:\"menu\";b:0;s:4:\"node\";s:6:\"tokens\";s:6:\"system\";s:6:\"tokens\";s:8:\"taxonomy\";s:6:\"tokens\";s:4:\"user\";s:6:\"tokens\";s:8:\"pathauto\";s:6:\"tokens\";s:5:\"views\";s:6:\"tokens\";}s:12:\"tokens_alter\";a:1:{s:5:\"token\";s:6:\"tokens\";}s:10:\"token_info\";a:12:{s:5:\"token\";s:6:\"tokens\";s:7:\"comment\";s:6:\"tokens\";s:14:\"computed_field\";b:0;s:4:\"date\";s:6:\"tokens\";s:13:\"logintoboggan\";s:6:\"tokens\";s:4:\"menu\";b:0;s:4:\"node\";s:6:\"tokens\";s:6:\"system\";s:6:\"tokens\";s:8:\"taxonomy\";s:6:\"tokens\";s:4:\"user\";s:6:\"tokens\";s:8:\"pathauto\";s:6:\"tokens\";s:5:\"views\";s:6:\"tokens\";}s:5:\"theme\";a:42:{s:5:\"block\";b:0;s:12:\"coder_review\";b:0;s:5:\"color\";b:0;s:7:\"comment\";b:0;s:6:\"ctools\";b:0;s:18:\"ctools_ajax_sample\";b:0;s:9:\"dashboard\";b:0;s:4:\"date\";b:0;s:8:\"date_api\";b:0;s:10:\"date_popup\";b:0;s:10:\"date_views\";b:0;s:5:\"dblog\";b:0;s:6:\"entity\";b:0;s:14:\"famc_analytics\";b:0;s:5:\"field\";b:0;s:8:\"field_ui\";b:0;s:6:\"filter\";b:0;s:16:\"jslider_form_api\";b:0;s:13:\"logintoboggan\";b:0;s:17:\"login_destination\";b:0;s:4:\"menu\";b:0;s:13:\"module_filter\";b:0;s:4:\"node\";b:0;s:7:\"options\";b:0;s:6:\"panels\";b:0;s:10:\"panels_ipe\";b:0;s:10:\"r4032login\";b:0;s:3:\"rdf\";b:0;s:6:\"search\";b:0;s:10:\"search_api\";b:0;s:15:\"search_api_page\";b:0;s:8:\"shortcut\";b:0;s:6:\"system\";b:0;s:8:\"taxonomy\";b:0;s:5:\"token\";b:0;s:4:\"user\";b:0;s:17:\"views_data_export\";b:0;s:8:\"views_ui\";b:0;s:11:\"field_group\";b:0;s:5:\"views\";b:0;s:12:\"page_manager\";b:0;s:10:\"admin_menu\";b:0;}s:18:\"ctools_plugin_type\";a:5:{s:6:\"ctools\";b:0;s:15:\"entityreference\";b:0;s:6:\"panels\";b:0;s:8:\"views_ui\";b:0;s:12:\"page_manager\";b:0;}s:23:\"ctools_plugin_directory\";a:10:{s:6:\"ctools\";b:0;s:21:\"ctools_custom_content\";b:0;s:6:\"entity\";b:0;s:15:\"entityreference\";b:0;s:6:\"panels\";b:0;s:10:\"panels_ipe\";b:0;s:11:\"panels_mini\";b:0;s:13:\"views_content\";b:0;s:8:\"views_ui\";b:0;s:12:\"page_manager\";b:0;}s:23:\"ctools_plugin_pre_alter\";a:0:{}s:24:\"ctools_plugin_post_alter\";a:0:{}s:17:\"ctools_plugin_api\";a:3:{s:6:\"panels\";b:0;s:10:\"panels_ipe\";b:0;s:11:\"field_group\";b:0;}s:23:\"ctools_plugin_api_alter\";a:0:{}s:27:\"default_panels_layout_alter\";a:0:{}s:20:\"theme_registry_alter\";a:0:{}s:16:\"token_info_alter\";a:3:{s:5:\"token\";s:6:\"tokens\";s:12:\"entity_token\";s:6:\"tokens\";s:5:\"field\";b:0;}s:17:\"date_format_types\";a:1:{s:6:\"system\";b:0;}s:23:\"date_format_types_alter\";a:0:{}s:22:\"token_field_info_alter\";a:0:{}s:32:\"pathauto_punctuation_chars_alter\";a:0:{}s:20:\"pathauto_alias_alter\";a:0:{}s:13:\"entity_update\";a:2:{s:15:\"entityreference\";b:0;s:10:\"search_api\";b:0;}s:42:\"query_search_api_index_load_multiple_alter\";a:0:{}s:19:\"node_access_records\";a:0:{}s:25:\"node_access_records_alter\";a:0:{}s:11:\"node_grants\";a:0:{}s:22:\"menu_site_status_alter\";a:1:{s:4:\"user\";b:0;}s:12:\"element_info\";a:9:{s:4:\"date\";b:0;s:8:\"date_api\";b:0;s:10:\"date_popup\";b:0;s:8:\"field_ui\";b:0;s:6:\"filter\";b:0;s:16:\"jslider_form_api\";b:0;s:6:\"system\";b:0;s:4:\"user\";b:0;s:11:\"field_group\";b:0;}s:18:\"element_info_alter\";a:1:{s:6:\"ctools\";b:0;}s:10:\"form_alter\";a:9:{s:11:\"block_class\";b:0;s:12:\"coder_review\";b:0;s:13:\"logintoboggan\";b:0;s:17:\"login_destination\";b:0;s:18:\"mercury_management\";b:0;s:17:\"mercury_utilities\";b:0;s:5:\"token\";b:0;s:12:\"unique_field\";b:0;s:10:\"admin_menu\";b:0;}s:28:\"form_dblog_filter_form_alter\";a:0:{}s:31:\"form_dblog_clear_log_form_alter\";a:0:{}s:17:\"query_pager_alter\";a:0:{}s:21:\"query_tablesort_alter\";a:0:{}s:28:\"page_delivery_callback_alter\";a:0:{}s:10:\"page_build\";a:3:{s:5:\"block\";b:0;s:9:\"dashboard\";b:0;s:10:\"admin_menu\";b:0;}s:22:\"query_block_load_alter\";a:0:{}s:16:\"block_list_alter\";a:5:{s:5:\"block\";b:0;s:6:\"ctools\";b:0;s:9:\"dashboard\";b:0;s:4:\"node\";b:0;s:11:\"panels_mini\";b:0;}s:17:\"dashboard_regions\";a:1:{s:9:\"dashboard\";b:0;}s:23:\"dashboard_regions_alter\";a:0:{}s:16:\"block_view_alter\";a:2:{s:4:\"menu\";b:0;s:5:\"token\";b:0;}s:28:\"block_view_system_main_alter\";a:0:{}s:27:\"block_view_user_login_alter\";a:0:{}s:22:\"menu_local_tasks_alter\";a:2:{s:6:\"ctools\";b:0;s:4:\"node\";b:0;}s:4:\"help\";a:35:{s:5:\"block\";b:0;s:12:\"coder_review\";b:0;s:5:\"color\";b:0;s:7:\"comment\";b:0;s:9:\"dashboard\";b:0;s:4:\"date\";b:0;s:5:\"dblog\";b:0;s:9:\"famc_asup\";b:0;s:5:\"field\";b:0;s:17:\"field_sql_storage\";b:0;s:8:\"field_ui\";b:0;s:6:\"filter\";b:0;s:4:\"help\";b:0;s:4:\"list\";b:0;s:13:\"logintoboggan\";b:0;s:17:\"login_destination\";b:0;s:4:\"menu\";b:0;s:4:\"node\";b:0;s:6:\"number\";b:0;s:7:\"options\";b:0;s:4:\"path\";b:0;s:3:\"php\";b:0;s:3:\"rdf\";b:0;s:6:\"search\";b:0;s:8:\"shortcut\";b:0;s:6:\"syslog\";b:0;s:6:\"system\";b:0;s:8:\"taxonomy\";b:0;s:4:\"text\";b:0;s:5:\"token\";b:0;s:12:\"unique_field\";b:0;s:4:\"user\";b:0;s:14:\"views_watchdog\";b:0;s:8:\"pathauto\";b:0;s:10:\"admin_menu\";b:0;}s:28:\"block_view_system_help_alter\";a:0:{}s:14:\"admin_menu_map\";a:6:{s:8:\"field_ui\";b:0;s:6:\"filter\";b:0;s:4:\"menu\";b:0;s:4:\"node\";b:0;s:8:\"taxonomy\";b:0;s:8:\"views_ui\";b:0;}s:20:\"admin_menu_map_alter\";a:0:{}s:14:\"file_url_alter\";a:0:{}s:21:\"admin_menu_cache_info\";a:2:{s:6:\"system\";b:0;s:10:\"admin_menu\";b:0;}s:23:\"admin_menu_output_build\";a:1:{s:10:\"admin_menu\";b:0;}s:23:\"admin_menu_output_alter\";a:2:{s:5:\"token\";b:0;s:10:\"admin_menu\";b:0;}s:23:\"admin_menu_replacements\";a:1:{s:10:\"admin_menu\";b:0;}s:10:\"page_alter\";a:7:{s:6:\"ctools\";b:0;s:13:\"logintoboggan\";b:0;s:17:\"login_destination\";b:0;s:10:\"panels_ipe\";b:0;s:8:\"shortcut\";b:0;s:6:\"system\";b:0;s:5:\"views\";b:0;}s:26:\"translated_menu_link_alter\";a:3:{s:17:\"login_destination\";b:0;s:4:\"user\";b:0;s:10:\"admin_menu\";b:0;}s:20:\"shortcut_default_set\";a:0:{}s:21:\"menu_breadcrumb_alter\";a:0:{}s:14:\"rdf_namespaces\";a:1:{s:3:\"rdf\";b:0;}s:8:\"js_alter\";a:1:{s:13:\"logintoboggan\";b:0;}s:15:\"html_head_alter\";a:0:{}s:9:\"css_alter\";a:0:{}s:4:\"exit\";a:0:{}s:50:\"form_mercury_utilities_vcenter_settings_form_alter\";a:0:{}s:11:\"filter_info\";a:2:{s:6:\"filter\";b:0;s:3:\"php\";b:0;}s:17:\"filter_info_alter\";a:0:{}s:24:\"block_view_block_3_alter\";a:0:{}s:27:\"ctools_entity_context_alter\";a:1:{s:6:\"ctools\";b:0;}s:28:\"ctools_entity_contexts_alter\";a:0:{}s:45:\"block_view_menu_menu-mercury-navigation_alter\";a:0:{}}',0,1371656328,1),('bootstrap_modules','a:2:{s:5:\"dblog\";O:8:\"stdClass\":2:{s:4:\"name\";s:5:\"dblog\";s:8:\"filename\";s:26:\"modules/dblog/dblog.module\";}s:6:\"syslog\";O:8:\"stdClass\":2:{s:4:\"name\";s:6:\"syslog\";s:8:\"filename\";s:28:\"modules/syslog/syslog.module\";}}',0,1371656313,1),('system_list','a:3:{s:14:\"module_enabled\";a:76:{s:5:\"block\";O:8:\"stdClass\":9:{s:8:\"filename\";s:26:\"modules/block/block.module\";s:4:\"name\";s:5:\"block\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7008\";s:6:\"weight\";s:2:\"-5\";s:4:\"info\";a:12:{s:4:\"name\";s:5:\"Block\";s:11:\"description\";s:140:\"Controls the visual building blocks a page is constructed with. Blocks are boxes of content rendered into an area, or region, of a web page.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"block.test\";}s:9:\"configure\";s:21:\"admin/structure/block\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:11:\"block_class\";O:8:\"stdClass\":9:{s:8:\"filename\";s:56:\"sites/all/modules/contrib/block_class/block_class.module\";s:4:\"name\";s:11:\"block_class\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7101\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:11:\"Block Class\";s:11:\"description\";s:39:\"Allows assigning CSS classes to blocks.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:19:\"block_class.install\";i:1;s:18:\"block_class.module\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:11:\"block_class\";s:9:\"datestamp\";s:10:\"1349301967\";s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:5:\"coder\";O:8:\"stdClass\":9:{s:8:\"filename\";s:44:\"sites/all/modules/contrib/coder/coder.module\";s:4:\"name\";s:5:\"coder\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:5:\"Coder\";s:11:\"description\";s:66:\"Developer Module that assists with code review and version upgrade\";s:7:\"package\";s:11:\"Development\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:12:\"coder.module\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:5:\"coder\";s:9:\"datestamp\";s:10:\"1352602857\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:12:\"coder_review\";O:8:\"stdClass\":9:{s:8:\"filename\";s:64:\"sites/all/modules/contrib/coder/coder_review/coder_review.module\";s:4:\"name\";s:12:\"coder_review\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"3\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:12:\"Coder Review\";s:11:\"description\";s:117:\"Developer module which reviews your code identifying coding style problems and where updates to the API are required.\";s:7:\"package\";s:11:\"Development\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"coder\";}s:5:\"files\";a:8:{i:0;s:33:\"tests/coder_review_test_case.tinc\";i:1;s:26:\"tests/coder_review_6x.test\";i:2;s:26:\"tests/coder_review_7x.test\";i:3;s:31:\"tests/coder_review_comment.test\";i:4;s:28:\"tests/coder_review_i18n.test\";i:5;s:32:\"tests/coder_review_security.test\";i:6;s:27:\"tests/coder_review_sql.test\";i:7;s:29:\"tests/coder_review_style.test\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:5:\"coder\";s:9:\"datestamp\";s:10:\"1352602857\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:5:\"color\";O:8:\"stdClass\":9:{s:8:\"filename\";s:26:\"modules/color/color.module\";s:4:\"name\";s:5:\"color\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7001\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:5:\"Color\";s:11:\"description\";s:70:\"Allows administrators to change the color scheme of compatible themes.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"color.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:7:\"comment\";O:8:\"stdClass\":9:{s:8:\"filename\";s:30:\"modules/comment/comment.module\";s:4:\"name\";s:7:\"comment\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7009\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:7:\"Comment\";s:11:\"description\";s:57:\"Allows users to comment on and discuss published content.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:4:\"text\";}s:5:\"files\";a:2:{i:0;s:14:\"comment.module\";i:1;s:12:\"comment.test\";}s:9:\"configure\";s:21:\"admin/content/comment\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:11:\"comment.css\";s:27:\"modules/comment/comment.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:14:\"computed_field\";O:8:\"stdClass\":9:{s:8:\"filename\";s:62:\"sites/all/modules/contrib/computed_field/computed_field.module\";s:4:\"name\";s:14:\"computed_field\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:14:\"Computed Field\";s:11:\"description\";s:70:\"Defines a field type that allows values to be \"computed\" via PHP code.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:7:\"package\";s:6:\"Fields\";s:5:\"files\";a:2:{i:0;s:22:\"computed_field.install\";i:1;s:21:\"computed_field.module\";}s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:7:\"project\";s:14:\"computed_field\";s:9:\"datestamp\";s:10:\"1328217338\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:73:\"Field type(s) in use - see <a href=\"/admin/reports/fields\">Field list</a>\";}}s:6:\"ctools\";O:8:\"stdClass\":9:{s:8:\"filename\";s:46:\"sites/all/modules/contrib/ctools/ctools.module\";s:4:\"name\";s:6:\"ctools\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"6007\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:11:\"Chaos tools\";s:11:\"description\";s:46:\"A library of helpful tools by Merlin of Chaos.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:5:\"files\";a:3:{i:0;s:20:\"includes/context.inc\";i:1;s:22:\"includes/math-expr.inc\";i:2;s:21:\"includes/stylizer.inc\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:18:\"ctools_ajax_sample\";O:8:\"stdClass\":9:{s:8:\"filename\";s:77:\"sites/all/modules/contrib/ctools/ctools_ajax_sample/ctools_ajax_sample.module\";s:4:\"name\";s:18:\"ctools_ajax_sample\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:33:\"Chaos Tools (CTools) AJAX Example\";s:11:\"description\";s:41:\"Shows how to use the power of Chaos AJAX.\";s:7:\"package\";s:16:\"Chaos tool suite\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:21:\"ctools_custom_content\";O:8:\"stdClass\":9:{s:8:\"filename\";s:83:\"sites/all/modules/contrib/ctools/ctools_custom_content/ctools_custom_content.module\";s:4:\"name\";s:21:\"ctools_custom_content\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:20:\"Custom content panes\";s:11:\"description\";s:79:\"Create custom, exportable, reusable content panes for applications like Panels.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:13:\"ctools_popups\";O:8:\"stdClass\":9:{s:8:\"filename\";s:59:\"sites/all/modules/custom/ctools_popups/ctools_popups.module\";s:4:\"name\";s:13:\"ctools_popups\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:9:{s:4:\"name\";s:13:\"CTools Popups\";s:11:\"description\";s:32:\"Show content using ctools popups\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:11:\"7.x-1.0-dev\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:9:\"dashboard\";O:8:\"stdClass\":9:{s:8:\"filename\";s:34:\"modules/dashboard/dashboard.module\";s:4:\"name\";s:9:\"dashboard\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:9:\"Dashboard\";s:11:\"description\";s:136:\"Provides a dashboard page in the administrative interface for organizing administrative tasks and tracking information within your site.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:5:\"files\";a:1:{i:0;s:14:\"dashboard.test\";}s:12:\"dependencies\";a:1:{i:0;s:5:\"block\";}s:9:\"configure\";s:25:\"admin/dashboard/customize\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:4:\"date\";O:8:\"stdClass\":9:{s:8:\"filename\";s:42:\"sites/all/modules/contrib/date/date.module\";s:4:\"name\";s:4:\"date\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7004\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:4:\"Date\";s:11:\"description\";s:33:\"Makes date/time fields available.\";s:12:\"dependencies\";a:1:{i:0;s:8:\"date_api\";}s:7:\"package\";s:9:\"Date/Time\";s:4:\"core\";s:3:\"7.x\";s:3:\"php\";s:3:\"5.2\";s:5:\"files\";a:5:{i:0;s:19:\"tests/date_api.test\";i:1;s:15:\"tests/date.test\";i:2;s:21:\"tests/date_field.test\";i:3;s:26:\"tests/date_validation.test\";i:4;s:24:\"tests/date_timezone.test\";}s:7:\"version\";s:7:\"7.x-2.6\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1344850024\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:73:\"Field type(s) in use - see <a href=\"/admin/reports/fields\">Field list</a>\";}}s:8:\"date_api\";O:8:\"stdClass\":9:{s:8:\"filename\";s:55:\"sites/all/modules/contrib/date/date_api/date_api.module\";s:4:\"name\";s:8:\"date_api\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7001\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:8:\"Date API\";s:11:\"description\";s:45:\"A Date API that can be used by other modules.\";s:7:\"package\";s:9:\"Date/Time\";s:4:\"core\";s:3:\"7.x\";s:3:\"php\";s:3:\"5.2\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"date.css\";s:48:\"sites/all/modules/contrib/date/date_api/date.css\";}}s:5:\"files\";a:2:{i:0;s:15:\"date_api.module\";i:1;s:16:\"date_api_sql.inc\";}s:7:\"version\";s:7:\"7.x-2.6\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1344850024\";s:12:\"dependencies\";a:0:{}s:9:\"bootstrap\";i:0;}}s:10:\"date_popup\";O:8:\"stdClass\":9:{s:8:\"filename\";s:59:\"sites/all/modules/contrib/date/date_popup/date_popup.module\";s:4:\"name\";s:10:\"date_popup\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:10:\"Date Popup\";s:11:\"description\";s:84:\"Enables jquery popup calendars and time entry widgets for selecting dates and times.\";s:12:\"dependencies\";a:1:{i:0;s:8:\"date_api\";}s:7:\"package\";s:9:\"Date/Time\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:28:\"admin/config/date/date_popup\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:25:\"themes/datepicker.1.7.css\";s:67:\"sites/all/modules/contrib/date/date_popup/themes/datepicker.1.7.css\";}}s:7:\"version\";s:7:\"7.x-2.6\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1344850024\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:10:\"date_views\";O:8:\"stdClass\":9:{s:8:\"filename\";s:59:\"sites/all/modules/contrib/date/date_views/date_views.module\";s:4:\"name\";s:10:\"date_views\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:10:\"Date Views\";s:11:\"description\";s:57:\"Views integration for date fields and date functionality.\";s:7:\"package\";s:9:\"Date/Time\";s:12:\"dependencies\";a:2:{i:0;s:8:\"date_api\";i:1;s:5:\"views\";}s:4:\"core\";s:3:\"7.x\";s:3:\"php\";s:3:\"5.2\";s:5:\"files\";a:7:{i:0;s:40:\"includes/date_views_argument_handler.inc\";i:1;s:47:\"includes/date_views_argument_handler_simple.inc\";i:2;s:38:\"includes/date_views_filter_handler.inc\";i:3;s:45:\"includes/date_views_filter_handler_simple.inc\";i:4;s:37:\"includes/date_views.views_default.inc\";i:5;s:29:\"includes/date_views.views.inc\";i:6;s:36:\"includes/date_views_plugin_pager.inc\";}s:7:\"version\";s:7:\"7.x-2.6\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1344850024\";s:9:\"bootstrap\";i:0;}}s:5:\"dblog\";O:8:\"stdClass\":9:{s:8:\"filename\";s:26:\"modules/dblog/dblog.module\";s:4:\"name\";s:5:\"dblog\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"1\";s:14:\"schema_version\";s:4:\"7001\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:16:\"Database logging\";s:11:\"description\";s:47:\"Logs and records system events to the database.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"dblog.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:6:\"entity\";O:8:\"stdClass\":9:{s:8:\"filename\";s:46:\"sites/all/modules/contrib/entity/entity.module\";s:4:\"name\";s:6:\"entity\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7002\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:10:\"Entity API\";s:11:\"description\";s:69:\"Enables modules to work with any entity type and to provide entities.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:24:{i:0;s:19:\"entity.features.inc\";i:1;s:15:\"entity.i18n.inc\";i:2;s:15:\"entity.info.inc\";i:3;s:16:\"entity.rules.inc\";i:4;s:11:\"entity.test\";i:5;s:19:\"includes/entity.inc\";i:6;s:30:\"includes/entity.controller.inc\";i:7;s:22:\"includes/entity.ui.inc\";i:8;s:27:\"includes/entity.wrapper.inc\";i:9;s:22:\"views/entity.views.inc\";i:10;s:52:\"views/handlers/entity_views_field_handler_helper.inc\";i:11;s:51:\"views/handlers/entity_views_handler_area_entity.inc\";i:12;s:53:\"views/handlers/entity_views_handler_field_boolean.inc\";i:13;s:50:\"views/handlers/entity_views_handler_field_date.inc\";i:14;s:54:\"views/handlers/entity_views_handler_field_duration.inc\";i:15;s:52:\"views/handlers/entity_views_handler_field_entity.inc\";i:16;s:51:\"views/handlers/entity_views_handler_field_field.inc\";i:17;s:53:\"views/handlers/entity_views_handler_field_numeric.inc\";i:18;s:53:\"views/handlers/entity_views_handler_field_options.inc\";i:19;s:50:\"views/handlers/entity_views_handler_field_text.inc\";i:20;s:49:\"views/handlers/entity_views_handler_field_uri.inc\";i:21;s:62:\"views/handlers/entity_views_handler_relationship_by_bundle.inc\";i:22;s:52:\"views/handlers/entity_views_handler_relationship.inc\";i:23;s:53:\"views/plugins/entity_views_plugin_row_entity_view.inc\";}s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";s:10:\"1337981155\";s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:15:\"entityreference\";O:8:\"stdClass\":9:{s:8:\"filename\";s:64:\"sites/all/modules/contrib/entityreference/entityreference.module\";s:4:\"name\";s:15:\"entityreference\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7002\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:16:\"Entity Reference\";s:11:\"description\";s:51:\"Provides a field that can reference other entities.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Fields\";s:12:\"dependencies\";a:2:{i:0;s:6:\"entity\";i:1;s:6:\"ctools\";}s:5:\"files\";a:10:{i:0;s:27:\"entityreference.migrate.inc\";i:1;s:30:\"plugins/selection/abstract.inc\";i:2;s:27:\"plugins/selection/views.inc\";i:3;s:29:\"plugins/behavior/abstract.inc\";i:4;s:40:\"views/entityreference_plugin_display.inc\";i:5;s:38:\"views/entityreference_plugin_style.inc\";i:6;s:43:\"views/entityreference_plugin_row_fields.inc\";i:7;s:35:\"tests/entityreference.handlers.test\";i:8;s:35:\"tests/entityreference.taxonomy.test\";i:9;s:32:\"tests/entityreference.admin.test\";}s:7:\"version\";s:7:\"7.x-1.0\";s:7:\"project\";s:15:\"entityreference\";s:9:\"datestamp\";s:10:\"1353230808\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:73:\"Field type(s) in use - see <a href=\"/admin/reports/fields\">Field list</a>\";}}s:12:\"entity_token\";O:8:\"stdClass\":9:{s:8:\"filename\";s:52:\"sites/all/modules/contrib/entity/entity_token.module\";s:4:\"name\";s:12:\"entity_token\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:13:\"Entity tokens\";s:11:\"description\";s:99:\"Provides token replacements for all properties that have no tokens and are known to the entity API.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:23:\"entity_token.tokens.inc\";i:1;s:19:\"entity_token.module\";}s:12:\"dependencies\";a:1:{i:0;s:6:\"entity\";}s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";s:10:\"1337981155\";s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:3:\"eva\";O:8:\"stdClass\":9:{s:8:\"filename\";s:40:\"sites/all/modules/contrib/eva/eva.module\";s:4:\"name\";s:3:\"eva\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:3:\"Eva\";s:11:\"description\";s:63:\"Provides a Views display type that can be attached to entities.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:7:\"package\";s:5:\"Views\";s:5:\"files\";a:1:{i:0;s:29:\"eva_plugin_display_entity.inc\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:3:\"eva\";s:9:\"datestamp\";s:10:\"1343701935\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:14:\"famc_analytics\";O:8:\"stdClass\":9:{s:8:\"filename\";s:61:\"sites/all/modules/custom/famc_analytics/famc_analytics.module\";s:4:\"name\";s:14:\"famc_analytics\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:10:{s:4:\"name\";s:42:\"Flash accel management console - analytics\";s:11:\"description\";s:81:\"Provides monitoring and analytics features to the Flash Accel Management Console.\";s:12:\"dependencies\";a:2:{i:0;s:18:\"mercury_management\";i:1;s:6:\"ctools\";}s:7:\"version\";s:3:\"7.1\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:30:\"Flash accel management console\";s:3:\"php\";s:91:\"5.3 #Drupal 7 does not have an explicit PHP 5.3 requirement, but we use stuff like closures\";s:7:\"scripts\";a:1:{s:20:\"js/famc_analytics.js\";s:60:\"sites/all/modules/custom/famc_analytics/js/famc_analytics.js\";}s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:9:\"famc_asup\";O:8:\"stdClass\":9:{s:8:\"filename\";s:51:\"sites/all/modules/custom/famc_asup/famc_asup.module\";s:4:\"name\";s:9:\"famc_asup\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:9:{s:4:\"name\";s:25:\"Flash accel - AutoSupport\";s:11:\"description\";s:32:\"Adds AutoSupport to Flash Accel.\";s:12:\"dependencies\";a:2:{i:0;s:18:\"mercury_management\";i:1;s:6:\"ctools\";}s:7:\"version\";s:3:\"7.1\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:30:\"Flash accel management console\";s:3:\"php\";s:91:\"5.3 #Drupal 7 does not have an explicit PHP 5.3 requirement, but we use stuff like closures\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:10:\"famc_drush\";O:8:\"stdClass\":9:{s:8:\"filename\";s:53:\"sites/all/modules/custom/famc_drush/famc_drush.module\";s:4:\"name\";s:10:\"famc_drush\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:9:{s:4:\"name\";s:47:\"Flash accel management console - Drush commands\";s:11:\"description\";s:71:\"Provides drush commands for running FAMC tasks from the command prompt.\";s:7:\"version\";s:3:\"7.1\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:30:\"Flash accel management console\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:5:\"field\";O:8:\"stdClass\":9:{s:8:\"filename\";s:26:\"modules/field/field.module\";s:4:\"name\";s:5:\"field\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7002\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:5:\"Field\";s:11:\"description\";s:57:\"Field API to add fields to entities like nodes and users.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:12:\"field.module\";i:1;s:16:\"field.attach.inc\";i:2;s:16:\"tests/field.test\";}s:12:\"dependencies\";a:1:{i:0;s:17:\"field_sql_storage\";}s:8:\"required\";b:1;s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:15:\"theme/field.css\";s:29:\"modules/field/theme/field.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:17:\"field_sql_storage\";O:8:\"stdClass\":9:{s:8:\"filename\";s:64:\"modules/field/modules/field_sql_storage/field_sql_storage.module\";s:4:\"name\";s:17:\"field_sql_storage\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7002\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:17:\"Field SQL storage\";s:11:\"description\";s:37:\"Stores field data in an SQL database.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:22:\"field_sql_storage.test\";}s:8:\"required\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:8:\"field_ui\";O:8:\"stdClass\":9:{s:8:\"filename\";s:32:\"modules/field_ui/field_ui.module\";s:4:\"name\";s:8:\"field_ui\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:8:\"Field UI\";s:11:\"description\";s:33:\"User interface for the Field API.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:13:\"field_ui.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:6:\"filter\";O:8:\"stdClass\":9:{s:8:\"filename\";s:28:\"modules/filter/filter.module\";s:4:\"name\";s:6:\"filter\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7010\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:6:\"Filter\";s:11:\"description\";s:43:\"Filters content in preparation for display.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"filter.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:28:\"admin/config/content/formats\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:4:\"help\";O:8:\"stdClass\":9:{s:8:\"filename\";s:24:\"modules/help/help.module\";s:4:\"name\";s:4:\"help\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:4:\"Help\";s:11:\"description\";s:35:\"Manages the display of online help.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"help.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:16:\"jslider_form_api\";O:8:\"stdClass\":9:{s:8:\"filename\";s:66:\"sites/all/modules/contrib/jslider_form_api/jslider_form_api.module\";s:4:\"name\";s:16:\"jslider_form_api\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:22:\"jQuery Slider Form API\";s:11:\"description\";s:123:\"Integrates form element with two numeric textfields and slider to transfer numeric amounts from left to right and backwards\";s:7:\"package\";s:14:\"User interface\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:16:\"jslider_form_api\";s:9:\"datestamp\";s:10:\"1326099649\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:4:\"list\";O:8:\"stdClass\":9:{s:8:\"filename\";s:38:\"modules/field/modules/list/list.module\";s:4:\"name\";s:4:\"list\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7002\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:4:\"List\";s:11:\"description\";s:69:\"Defines list field types. Use with Options to create selection lists.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:5:\"field\";i:1;s:7:\"options\";}s:5:\"files\";a:1:{i:0;s:15:\"tests/list.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:73:\"Field type(s) in use - see <a href=\"/admin/reports/fields\">Field list</a>\";}}s:13:\"logintoboggan\";O:8:\"stdClass\":9:{s:8:\"filename\";s:60:\"sites/all/modules/contrib/logintoboggan/logintoboggan.module\";s:4:\"name\";s:13:\"logintoboggan\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7000\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:13:\"LoginToboggan\";s:11:\"description\";s:31:\"Improves Drupal\'s login system.\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:33:\"admin/config/system/logintoboggan\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:17:\"logintoboggan.css\";s:57:\"sites/all/modules/contrib/logintoboggan/logintoboggan.css\";}}s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:13:\"logintoboggan\";s:9:\"datestamp\";s:10:\"1320873335\";s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:17:\"login_destination\";O:8:\"stdClass\":9:{s:8:\"filename\";s:68:\"sites/all/modules/contrib/login_destination/login_destination.module\";s:4:\"name\";s:17:\"login_destination\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7000\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:17:\"Login Destination\";s:11:\"description\";s:69:\"Customize the destination that the user is redirected to after login.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:24:\"login_destination.module\";i:1;s:27:\"login_destination.admin.inc\";}s:9:\"configure\";s:37:\"admin/config/people/login-destination\";s:7:\"version\";s:7:\"7.x-1.0\";s:7:\"project\";s:17:\"login_destination\";s:9:\"datestamp\";s:10:\"1313172120\";s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:4:\"menu\";O:8:\"stdClass\":9:{s:8:\"filename\";s:24:\"modules/menu/menu.module\";s:4:\"name\";s:4:\"menu\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7003\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:4:\"Menu\";s:11:\"description\";s:60:\"Allows administrators to customize the site navigation menu.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"menu.test\";}s:9:\"configure\";s:20:\"admin/structure/menu\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:13:\"mercury_fmcdb\";O:8:\"stdClass\":9:{s:8:\"filename\";s:59:\"sites/all/modules/custom/mercury_fmcdb/mercury_fmcdb.module\";s:4:\"name\";s:13:\"mercury_fmcdb\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:10:{s:4:\"name\";s:20:\"Flash Accel DB Calls\";s:11:\"description\";s:65:\"Contains functions called in blocks and views in the fmc database\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:11:\"7.x-1.0-dev\";s:14:\"//dependencies\";a:1:{i:0;s:6:\"ctools\";}s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:18:\"mercury_management\";O:8:\"stdClass\":9:{s:8:\"filename\";s:69:\"sites/all/modules/custom/mercury_management/mercury_management.module\";s:4:\"name\";s:18:\"mercury_management\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:9:{s:4:\"name\";s:25:\"Mercury Management Module\";s:11:\"description\";s:28:\"Mercury management utilities\";s:7:\"package\";s:25:\"NetApp Mercury Management\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:0:{}s:7:\"version\";N;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:17:\"mercury_utilities\";O:8:\"stdClass\":9:{s:8:\"filename\";s:67:\"sites/all/modules/custom/mercury_utilities/mercury_utilities.module\";s:4:\"name\";s:17:\"mercury_utilities\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:17:\"Mercury utilities\";s:11:\"description\";s:18:\"Mercury  utilities\";s:7:\"package\";s:25:\"NetApp Mercury Management\";s:12:\"dependencies\";a:1:{i:0;s:18:\"mercury_management\";}s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:20:\"css/progress-bar.css\";s:63:\"sites/all/modules/custom/mercury_utilities/css/progress-bar.css\";}}s:7:\"scripts\";a:3:{s:23:\"js/mercury_utilities.js\";s:66:\"sites/all/modules/custom/mercury_utilities/js/mercury_utilities.js\";s:36:\"js/mercury_utilities_ajax_handler.js\";s:79:\"sites/all/modules/custom/mercury_utilities/js/mercury_utilities_ajax_handler.js\";s:33:\"js/mercury_utilities_discovery.js\";s:76:\"sites/all/modules/custom/mercury_utilities/js/mercury_utilities_discovery.js\";}s:7:\"version\";N;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:13:\"module_filter\";O:8:\"stdClass\":9:{s:8:\"filename\";s:60:\"sites/all/modules/contrib/module_filter/module_filter.module\";s:4:\"name\";s:13:\"module_filter\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7100\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:13:\"Module filter\";s:11:\"description\";s:24:\"Filter the modules list.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:9:{i:0;s:21:\"module_filter.install\";i:1;s:16:\"module_filter.js\";i:2;s:20:\"module_filter.module\";i:3;s:23:\"module_filter.admin.inc\";i:4;s:23:\"module_filter.theme.inc\";i:5;s:21:\"css/module_filter.css\";i:6;s:25:\"css/module_filter_tab.css\";i:7;s:19:\"js/module_filter.js\";i:8;s:23:\"js/module_filter_tab.js\";}s:9:\"configure\";s:40:\"admin/config/user-interface/modulefilter\";s:7:\"version\";s:7:\"7.x-1.7\";s:7:\"project\";s:13:\"module_filter\";s:9:\"datestamp\";s:10:\"1341518501\";s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:4:\"node\";O:8:\"stdClass\":9:{s:8:\"filename\";s:24:\"modules/node/node.module\";s:4:\"name\";s:4:\"node\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7013\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:14:{s:4:\"name\";s:4:\"Node\";s:11:\"description\";s:66:\"Allows content to be submitted to the site and displayed on pages.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:11:\"node.module\";i:1;s:9:\"node.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:21:\"admin/structure/types\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"node.css\";s:21:\"modules/node/node.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:14:\"node_reference\";O:8:\"stdClass\":9:{s:8:\"filename\";s:73:\"sites/all/modules/contrib/references/node_reference/node_reference.module\";s:4:\"name\";s:14:\"node_reference\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:14:\"Node Reference\";s:11:\"description\";s:59:\"Defines a field type for referencing one node from another.\";s:7:\"package\";s:6:\"Fields\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:3:{i:0;s:5:\"field\";i:1;s:10:\"references\";i:2;s:7:\"options\";}s:5:\"files\";a:1:{i:0;s:19:\"node_reference.test\";}s:7:\"version\";s:7:\"7.x-2.0\";s:7:\"project\";s:10:\"references\";s:9:\"datestamp\";s:10:\"1324596643\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:73:\"Field type(s) in use - see <a href=\"/admin/reports/fields\">Field list</a>\";}}s:6:\"number\";O:8:\"stdClass\":9:{s:8:\"filename\";s:42:\"modules/field/modules/number/number.module\";s:4:\"name\";s:6:\"number\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:6:\"Number\";s:11:\"description\";s:28:\"Defines numeric field types.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:11:\"number.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:73:\"Field type(s) in use - see <a href=\"/admin/reports/fields\">Field list</a>\";}}s:7:\"options\";O:8:\"stdClass\":9:{s:8:\"filename\";s:44:\"modules/field/modules/options/options.module\";s:4:\"name\";s:7:\"options\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:7:\"Options\";s:11:\"description\";s:82:\"Defines selection, check box and radio button widgets for text and numeric fields.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:12:\"options.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:6:\"panels\";O:8:\"stdClass\":9:{s:8:\"filename\";s:46:\"sites/all/modules/contrib/panels/panels.module\";s:4:\"name\";s:6:\"panels\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7301\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:6:\"Panels\";s:11:\"description\";s:107:\"Core Panels display functions; provides no external UI, at least one other Panels module should be enabled.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Panels\";s:9:\"configure\";s:22:\"admin/structure/panels\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:5:\"files\";a:5:{i:0;s:13:\"panels.module\";i:1;s:19:\"includes/common.inc\";i:2;s:19:\"includes/legacy.inc\";i:3;s:20:\"includes/plugins.inc\";i:4;s:48:\"plugins/views/panels_views_plugin_row_fields.inc\";}s:7:\"version\";s:7:\"7.x-3.3\";s:7:\"project\";s:6:\"panels\";s:9:\"datestamp\";s:10:\"1345319572\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:10:\"panels_ipe\";O:8:\"stdClass\":9:{s:8:\"filename\";s:61:\"sites/all/modules/contrib/panels/panels_ipe/panels_ipe.module\";s:4:\"name\";s:10:\"panels_ipe\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:22:\"Panels In-Place Editor\";s:11:\"description\";s:101:\"Provide a UI for managing some Panels directly on the frontend, instead of having to use the backend.\";s:7:\"package\";s:6:\"Panels\";s:12:\"dependencies\";a:1:{i:0;s:6:\"panels\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:22:\"admin/structure/panels\";s:5:\"files\";a:1:{i:0;s:17:\"panels_ipe.module\";}s:7:\"version\";s:7:\"7.x-3.3\";s:7:\"project\";s:6:\"panels\";s:9:\"datestamp\";s:10:\"1345319572\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:11:\"panels_mini\";O:8:\"stdClass\":9:{s:8:\"filename\";s:63:\"sites/all/modules/contrib/panels/panels_mini/panels_mini.module\";s:4:\"name\";s:11:\"panels_mini\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:11:\"Mini panels\";s:11:\"description\";s:89:\"Create mini panels that can be used as blocks by Drupal and panes by other panel modules.\";s:7:\"package\";s:6:\"Panels\";s:12:\"dependencies\";a:1:{i:0;s:6:\"panels\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:42:\"plugins/export_ui/panels_mini_ui.class.php\";}s:7:\"version\";s:7:\"7.x-3.3\";s:7:\"project\";s:6:\"panels\";s:9:\"datestamp\";s:10:\"1345319572\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:14:\"password_field\";O:8:\"stdClass\":9:{s:8:\"filename\";s:62:\"sites/all/modules/contrib/password_field/password_field.module\";s:4:\"name\";s:14:\"password_field\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:14:\"Password Field\";s:11:\"description\";s:35:\"A basic password field for Drupal 7\";s:7:\"package\";s:6:\"Fields\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:5:\"field\";i:1;s:17:\"field_sql_storage\";}s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:7:\"project\";s:14:\"password_field\";s:9:\"datestamp\";s:10:\"1347577689\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:4:\"path\";O:8:\"stdClass\":9:{s:8:\"filename\";s:24:\"modules/path/path.module\";s:4:\"name\";s:4:\"path\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:4:\"Path\";s:11:\"description\";s:28:\"Allows users to rename URLs.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"path.test\";}s:9:\"configure\";s:24:\"admin/config/search/path\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:3:\"php\";O:8:\"stdClass\":9:{s:8:\"filename\";s:22:\"modules/php/php.module\";s:4:\"name\";s:3:\"php\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:10:\"PHP filter\";s:11:\"description\";s:50:\"Allows embedded PHP code/snippets to be evaluated.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:8:\"php.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:10:\"r4032login\";O:8:\"stdClass\":9:{s:8:\"filename\";s:54:\"sites/all/modules/contrib/r4032login/r4032login.module\";s:4:\"name\";s:10:\"r4032login\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7000\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:26:\"Redirect 403 to User Login\";s:11:\"description\";s:78:\"Redirect anonymous users from 403 Access Denied pages to the /user/login page.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:18:\"r4032login.install\";i:1;s:17:\"r4032login.module\";}s:9:\"configure\";s:36:\"admin/config/system/site-information\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:10:\"r4032login\";s:9:\"datestamp\";s:10:\"1326460543\";s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:3:\"rdf\";O:8:\"stdClass\":9:{s:8:\"filename\";s:22:\"modules/rdf/rdf.module\";s:4:\"name\";s:3:\"rdf\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:3:\"RDF\";s:11:\"description\";s:148:\"Enriches your content with metadata to let other applications (e.g. search engines, aggregators) better understand its relationships and attributes.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:8:\"rdf.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:10:\"references\";O:8:\"stdClass\":9:{s:8:\"filename\";s:54:\"sites/all/modules/contrib/references/references.module\";s:4:\"name\";s:10:\"references\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:10:\"References\";s:11:\"description\";s:67:\"Defines common base features for the various reference field types.\";s:7:\"package\";s:6:\"Fields\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:5:\"field\";i:1;s:7:\"options\";}s:5:\"files\";a:5:{i:0;s:41:\"views/references_handler_relationship.inc\";i:1;s:37:\"views/references_handler_argument.inc\";i:2;s:35:\"views/references_plugin_display.inc\";i:3;s:33:\"views/references_plugin_style.inc\";i:4;s:38:\"views/references_plugin_row_fields.inc\";}s:7:\"version\";s:7:\"7.x-2.0\";s:7:\"project\";s:10:\"references\";s:9:\"datestamp\";s:10:\"1324596643\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:6:\"search\";O:8:\"stdClass\":9:{s:8:\"filename\";s:28:\"modules/search/search.module\";s:4:\"name\";s:6:\"search\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7000\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:6:\"Search\";s:11:\"description\";s:36:\"Enables site-wide keyword searching.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:19:\"search.extender.inc\";i:1;s:11:\"search.test\";}s:9:\"configure\";s:28:\"admin/config/search/settings\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"search.css\";s:25:\"modules/search/search.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:10:\"search_api\";O:8:\"stdClass\":9:{s:8:\"filename\";s:54:\"sites/all/modules/contrib/search_api/search_api.module\";s:4:\"name\";s:10:\"search_api\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7114\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:10:\"Search API\";s:11:\"description\";s:63:\"Provides a generic API for modules offering search capabilites.\";s:12:\"dependencies\";a:1:{i:0;s:6:\"entity\";}s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Search\";s:5:\"files\";a:23:{i:0;s:15:\"search_api.test\";i:1;s:21:\"includes/callback.inc\";i:2;s:37:\"includes/callback_add_aggregation.inc\";i:3;s:35:\"includes/callback_add_hierarchy.inc\";i:4;s:29:\"includes/callback_add_url.inc\";i:5;s:39:\"includes/callback_add_viewed_entity.inc\";i:6;s:35:\"includes/callback_bundle_filter.inc\";i:7;s:38:\"includes/callback_language_control.inc\";i:8;s:33:\"includes/callback_node_access.inc\";i:9;s:33:\"includes/callback_node_status.inc\";i:10;s:23:\"includes/datasource.inc\";i:11;s:30:\"includes/datasource_entity.inc\";i:12;s:32:\"includes/datasource_external.inc\";i:13;s:22:\"includes/exception.inc\";i:14;s:25:\"includes/index_entity.inc\";i:15;s:22:\"includes/processor.inc\";i:16;s:34:\"includes/processor_html_filter.inc\";i:17;s:34:\"includes/processor_ignore_case.inc\";i:18;s:32:\"includes/processor_stopwords.inc\";i:19;s:32:\"includes/processor_tokenizer.inc\";i:20;s:18:\"includes/query.inc\";i:21;s:26:\"includes/server_entity.inc\";i:22;s:20:\"includes/service.inc\";}s:9:\"configure\";s:30:\"admin/config/search/search_api\";s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:10:\"search_api\";s:9:\"datestamp\";s:10:\"1350461221\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:15:\"search_api_page\";O:8:\"stdClass\":9:{s:8:\"filename\";s:64:\"sites/all/modules/contrib/search_api_page/search_api_page.module\";s:4:\"name\";s:15:\"search_api_page\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7102\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:12:\"Search pages\";s:11:\"description\";s:45:\"Create search pages using Search API indexes.\";s:12:\"dependencies\";a:1:{i:0;s:10:\"search_api\";}s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Search\";s:9:\"configure\";s:35:\"admin/config/search/search_api/page\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:7:\"project\";s:15:\"search_api_page\";s:9:\"datestamp\";s:10:\"1320944736\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:8:\"shortcut\";O:8:\"stdClass\":9:{s:8:\"filename\";s:32:\"modules/shortcut/shortcut.module\";s:4:\"name\";s:8:\"shortcut\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:8:\"Shortcut\";s:11:\"description\";s:60:\"Allows users to manage customizable lists of shortcut links.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:13:\"shortcut.test\";}s:9:\"configure\";s:36:\"admin/config/user-interface/shortcut\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:6:\"syslog\";O:8:\"stdClass\":9:{s:8:\"filename\";s:28:\"modules/syslog/syslog.module\";s:4:\"name\";s:6:\"syslog\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"1\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:6:\"Syslog\";s:11:\"description\";s:41:\"Logs and records system events to syslog.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"syslog.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:6:\"system\";O:8:\"stdClass\":9:{s:8:\"filename\";s:28:\"modules/system/system.module\";s:4:\"name\";s:6:\"system\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7077\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:6:\"System\";s:11:\"description\";s:54:\"Handles general site configuration for administrators.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:6:{i:0;s:19:\"system.archiver.inc\";i:1;s:15:\"system.mail.inc\";i:2;s:16:\"system.queue.inc\";i:3;s:14:\"system.tar.inc\";i:4;s:18:\"system.updater.inc\";i:5;s:11:\"system.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:19:\"admin/config/system\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:8:\"taxonomy\";O:8:\"stdClass\":9:{s:8:\"filename\";s:32:\"modules/taxonomy/taxonomy.module\";s:4:\"name\";s:8:\"taxonomy\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7010\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:14:{s:4:\"name\";s:8:\"Taxonomy\";s:11:\"description\";s:38:\"Enables the categorization of content.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:7:\"options\";}s:5:\"files\";a:2:{i:0;s:15:\"taxonomy.module\";i:1;s:13:\"taxonomy.test\";}s:9:\"configure\";s:24:\"admin/structure/taxonomy\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:73:\"Field type(s) in use - see <a href=\"/admin/reports/fields\">Field list</a>\";}}s:4:\"text\";O:8:\"stdClass\":9:{s:8:\"filename\";s:38:\"modules/field/modules/text/text.module\";s:4:\"name\";s:4:\"text\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7000\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:4:\"Text\";s:11:\"description\";s:32:\"Defines simple text field types.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:9:\"text.test\";}s:8:\"required\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:11:\"explanation\";s:73:\"Field type(s) in use - see <a href=\"/admin/reports/fields\">Field list</a>\";}}s:5:\"token\";O:8:\"stdClass\":9:{s:8:\"filename\";s:44:\"sites/all/modules/contrib/token/token.module\";s:4:\"name\";s:5:\"token\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7001\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:5:\"Token\";s:11:\"description\";s:73:\"Provides a user interface for the Token API and some missing core tokens.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:5:{i:0;s:12:\"token.module\";i:1;s:13:\"token.install\";i:2;s:16:\"token.tokens.inc\";i:3;s:15:\"token.pages.inc\";i:4;s:10:\"token.test\";}s:7:\"version\";s:7:\"7.x-1.4\";s:7:\"project\";s:5:\"token\";s:9:\"datestamp\";s:10:\"1348497279\";s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:12:\"unique_field\";O:8:\"stdClass\":9:{s:8:\"filename\";s:58:\"sites/all/modules/contrib/unique_field/unique_field.module\";s:4:\"name\";s:12:\"unique_field\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:12:\"Unique Field\";s:11:\"description\";s:115:\"Provides content validation requirement that a node\'s author, language, taxonomy terms, or other fields are unique.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:5:{i:0;s:19:\"unique_field.module\";i:1;s:20:\"unique_field.install\";i:2;s:15:\"tests/core.test\";i:3;s:15:\"tests/date.test\";i:4;s:21:\"tests/references.test\";}s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:7:\"project\";s:12:\"unique_field\";s:9:\"datestamp\";s:10:\"1311648120\";s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:4:\"user\";O:8:\"stdClass\":9:{s:8:\"filename\";s:24:\"modules/user/user.module\";s:4:\"name\";s:4:\"user\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7018\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:14:{s:4:\"name\";s:4:\"User\";s:11:\"description\";s:47:\"Manages the user registration and login system.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:11:\"user.module\";i:1;s:9:\"user.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:19:\"admin/config/people\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"user.css\";s:21:\"modules/user/user.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:14:\"user_reference\";O:8:\"stdClass\":9:{s:8:\"filename\";s:73:\"sites/all/modules/contrib/references/user_reference/user_reference.module\";s:4:\"name\";s:14:\"user_reference\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:14:\"User Reference\";s:11:\"description\";s:56:\"Defines a field type for referencing a user from a node.\";s:7:\"package\";s:6:\"Fields\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:3:{i:0;s:5:\"field\";i:1;s:10:\"references\";i:2;s:7:\"options\";}s:7:\"version\";s:7:\"7.x-2.0\";s:7:\"project\";s:10:\"references\";s:9:\"datestamp\";s:10:\"1324596643\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:13:\"views_content\";O:8:\"stdClass\":9:{s:8:\"filename\";s:67:\"sites/all/modules/contrib/ctools/views_content/views_content.module\";s:4:\"name\";s:13:\"views_content\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:19:\"Views content panes\";s:11:\"description\";s:104:\"Allows Views content to be used in Panels, Dashboard and other modules which use the CTools Content API.\";s:7:\"package\";s:16:\"Chaos tool suite\";s:12:\"dependencies\";a:2:{i:0;s:6:\"ctools\";i:1;s:5:\"views\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:61:\"plugins/views/views_content_plugin_display_ctools_context.inc\";i:1;s:57:\"plugins/views/views_content_plugin_display_panel_pane.inc\";i:2;s:59:\"plugins/views/views_content_plugin_style_ctools_context.inc\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:17:\"views_data_export\";O:8:\"stdClass\":9:{s:8:\"filename\";s:68:\"sites/all/modules/contrib/views_data_export/views_data_export.module\";s:4:\"name\";s:17:\"views_data_export\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7100\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:17:\"Views Data Export\";s:11:\"description\";s:53:\"Plugin to export views data into various file formats\";s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:25:{i:0;s:24:\"views_data_export.module\";i:1;s:51:\"plugins/views_data_export_plugin_display_export.inc\";i:2;s:49:\"plugins/views_data_export_plugin_style_export.inc\";i:3;s:53:\"plugins/views_data_export_plugin_style_export_csv.inc\";i:4;s:53:\"plugins/views_data_export_plugin_style_export_doc.inc\";i:5;s:53:\"plugins/views_data_export_plugin_style_export_txt.inc\";i:6;s:53:\"plugins/views_data_export_plugin_style_export_xls.inc\";i:7;s:53:\"plugins/views_data_export_plugin_style_export_xml.inc\";i:8;s:33:\"theme/views_data_export.theme.inc\";i:9;s:40:\"theme/views-data-export-csv-body.tpl.php\";i:10;s:42:\"theme/views-data-export-csv-footer.tpl.php\";i:11;s:42:\"theme/views-data-export-csv-header.tpl.php\";i:12;s:40:\"theme/views-data-export-doc-body.tpl.php\";i:13;s:42:\"theme/views-data-export-doc-footer.tpl.php\";i:14;s:42:\"theme/views-data-export-doc-header.tpl.php\";i:15;s:40:\"theme/views-data-export-txt-body.tpl.php\";i:16;s:42:\"theme/views-data-export-txt-footer.tpl.php\";i:17;s:42:\"theme/views-data-export-txt-header.tpl.php\";i:18;s:40:\"theme/views-data-export-xls-body.tpl.php\";i:19;s:42:\"theme/views-data-export-xls-footer.tpl.php\";i:20;s:42:\"theme/views-data-export-xls-header.tpl.php\";i:21;s:40:\"theme/views-data-export-xml-body.tpl.php\";i:22;s:42:\"theme/views-data-export-xml-footer.tpl.php\";i:23;s:42:\"theme/views-data-export-xml-header.tpl.php\";i:24;s:31:\"theme/views-data-export.tpl.php\";}s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:7:\"version\";s:13:\"7.x-3.0-beta6\";s:7:\"project\";s:17:\"views_data_export\";s:9:\"datestamp\";s:10:\"1336632688\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:9:\"views_php\";O:8:\"stdClass\":9:{s:8:\"filename\";s:52:\"sites/all/modules/contrib/views_php/views_php.module\";s:4:\"name\";s:9:\"views_php\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:9:\"Views PHP\";s:11:\"description\";s:44:\"Allows the usage of PHP to construct a view.\";s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:5:\"files\";a:9:{i:0;s:40:\"plugins/views/views_php_handler_area.inc\";i:1;s:41:\"plugins/views/views_php_handler_field.inc\";i:2;s:42:\"plugins/views/views_php_handler_filter.inc\";i:3;s:40:\"plugins/views/views_php_handler_sort.inc\";i:4;s:41:\"plugins/views/views_php_plugin_access.inc\";i:5;s:40:\"plugins/views/views_php_plugin_cache.inc\";i:6;s:40:\"plugins/views/views_php_plugin_pager.inc\";i:7;s:40:\"plugins/views/views_php_plugin_query.inc\";i:8;s:42:\"plugins/views/views_php_plugin_wrapper.inc\";}s:7:\"version\";s:11:\"7.x-1.x-dev\";s:7:\"project\";s:9:\"views_php\";s:9:\"datestamp\";s:10:\"1329828512\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:8:\"views_ui\";O:8:\"stdClass\":9:{s:8:\"filename\";s:47:\"sites/all/modules/contrib/views/views_ui.module\";s:4:\"name\";s:8:\"views_ui\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:8:\"Views UI\";s:11:\"description\";s:93:\"Administrative interface to views. Without this module, you cannot create or edit your views.\";s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:21:\"admin/structure/views\";s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:5:\"files\";a:2:{i:0;s:15:\"views_ui.module\";i:1;s:57:\"plugins/views_wizard/views_ui_base_views_wizard.class.php\";}s:7:\"version\";s:7:\"7.x-3.5\";s:7:\"project\";s:5:\"views\";s:9:\"datestamp\";s:10:\"1345829394\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:14:\"views_watchdog\";O:8:\"stdClass\":9:{s:8:\"filename\";s:62:\"sites/all/modules/contrib/views_watchdog/views_watchdog.module\";s:4:\"name\";s:14:\"views_watchdog\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:14:\"Views Watchdog\";s:11:\"description\";s:77:\"Allows to create customized lists (pages, blocks, feeds) of watchdog entries.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Views\";s:9:\"configure\";s:21:\"admin/structure/views\";s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:5:\"files\";a:9:{i:0;s:55:\"views/handlers/views_handler_field_watchdog_message.inc\";i:1;s:56:\"views/handlers/views_handler_field_watchdog_severity.inc\";i:2;s:56:\"views/handlers/views_handler_filter_watchdog_message.inc\";i:3;s:57:\"views/handlers/views_handler_filter_watchdog_severity.inc\";i:4;s:53:\"views/handlers/views_handler_filter_watchdog_type.inc\";i:5;s:47:\"views/plugins/views_plugin_row_watchdog_rss.inc\";i:6;s:51:\"views/plugins/views_plugin_style_watchdog_table.inc\";i:7;s:21:\"views/theme/theme.inc\";i:8;s:45:\"views/theme/views-view-watchdog-table.tpl.php\";}s:7:\"version\";s:7:\"7.x-3.3\";s:7:\"project\";s:14:\"views_watchdog\";s:9:\"datestamp\";s:10:\"1322311852\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:11:\"field_group\";O:8:\"stdClass\":9:{s:8:\"filename\";s:56:\"sites/all/modules/contrib/field_group/field_group.module\";s:4:\"name\";s:11:\"field_group\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7003\";s:6:\"weight\";s:1:\"1\";s:4:\"info\";a:11:{s:4:\"name\";s:10:\"Fieldgroup\";s:11:\"description\";s:10:\"Fieldgroup\";s:7:\"package\";s:6:\"Fields\";s:12:\"dependencies\";a:2:{i:0;s:5:\"field\";i:1;s:6:\"ctools\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:6:{i:0;s:19:\"field_group.install\";i:1;s:18:\"field_group.module\";i:2;s:24:\"field_group.field_ui.inc\";i:3;s:20:\"field_group.form.inc\";i:4;s:24:\"field_group.features.inc\";i:5;s:16:\"field_group.test\";}s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:11:\"field_group\";s:9:\"datestamp\";s:10:\"1319051133\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:8:\"pathauto\";O:8:\"stdClass\":9:{s:8:\"filename\";s:50:\"sites/all/modules/contrib/pathauto/pathauto.module\";s:4:\"name\";s:8:\"pathauto\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7005\";s:6:\"weight\";s:1:\"1\";s:4:\"info\";a:13:{s:4:\"name\";s:8:\"Pathauto\";s:11:\"description\";s:95:\"Provides a mechanism for modules to automatically generate aliases for the content they manage.\";s:12:\"dependencies\";a:2:{i:0;s:4:\"path\";i:1;s:5:\"token\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:13:\"pathauto.test\";}s:9:\"configure\";s:33:\"admin/config/search/path/patterns\";s:10:\"recommends\";a:1:{i:0;s:8:\"redirect\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:8:\"pathauto\";s:9:\"datestamp\";s:10:\"1344525185\";s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:15:\"menu_attributes\";O:8:\"stdClass\":9:{s:8:\"filename\";s:64:\"sites/all/modules/contrib/menu_attributes/menu_attributes.module\";s:4:\"name\";s:15:\"menu_attributes\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7001\";s:6:\"weight\";s:2:\"10\";s:4:\"info\";a:12:{s:4:\"name\";s:15:\"Menu attributes\";s:11:\"description\";s:66:\"Allows administrators to specify custom attributes for menu items.\";s:12:\"dependencies\";a:1:{i:0;s:4:\"menu\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:29:\"admin/structure/menu/settings\";s:5:\"files\";a:1:{i:0;s:20:\"menu_attributes.test\";}s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:7:\"project\";s:15:\"menu_attributes\";s:9:\"datestamp\";s:10:\"1338541556\";s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:5:\"views\";O:8:\"stdClass\":9:{s:8:\"filename\";s:44:\"sites/all/modules/contrib/views/views.module\";s:4:\"name\";s:5:\"views\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7301\";s:6:\"weight\";s:2:\"10\";s:4:\"info\";a:12:{s:4:\"name\";s:5:\"Views\";s:11:\"description\";s:55:\"Create customized lists and queries from your database.\";s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:3:\"php\";s:3:\"5.2\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:13:\"css/views.css\";s:45:\"sites/all/modules/contrib/views/css/views.css\";}}s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:5:\"files\";a:289:{i:0;s:31:\"handlers/views_handler_area.inc\";i:1;s:38:\"handlers/views_handler_area_result.inc\";i:2;s:36:\"handlers/views_handler_area_text.inc\";i:3;s:43:\"handlers/views_handler_area_text_custom.inc\";i:4;s:36:\"handlers/views_handler_area_view.inc\";i:5;s:35:\"handlers/views_handler_argument.inc\";i:6;s:40:\"handlers/views_handler_argument_date.inc\";i:7;s:43:\"handlers/views_handler_argument_formula.inc\";i:8;s:47:\"handlers/views_handler_argument_many_to_one.inc\";i:9;s:40:\"handlers/views_handler_argument_null.inc\";i:10;s:43:\"handlers/views_handler_argument_numeric.inc\";i:11;s:42:\"handlers/views_handler_argument_string.inc\";i:12;s:52:\"handlers/views_handler_argument_group_by_numeric.inc\";i:13;s:32:\"handlers/views_handler_field.inc\";i:14;s:40:\"handlers/views_handler_field_counter.inc\";i:15;s:40:\"handlers/views_handler_field_boolean.inc\";i:16;s:49:\"handlers/views_handler_field_contextual_links.inc\";i:17;s:39:\"handlers/views_handler_field_custom.inc\";i:18;s:37:\"handlers/views_handler_field_date.inc\";i:19;s:39:\"handlers/views_handler_field_entity.inc\";i:20;s:39:\"handlers/views_handler_field_markup.inc\";i:21;s:37:\"handlers/views_handler_field_math.inc\";i:22;s:40:\"handlers/views_handler_field_numeric.inc\";i:23;s:47:\"handlers/views_handler_field_prerender_list.inc\";i:24;s:46:\"handlers/views_handler_field_time_interval.inc\";i:25;s:43:\"handlers/views_handler_field_serialized.inc\";i:26;s:45:\"handlers/views_handler_field_machine_name.inc\";i:27;s:36:\"handlers/views_handler_field_url.inc\";i:28;s:33:\"handlers/views_handler_filter.inc\";i:29;s:50:\"handlers/views_handler_filter_boolean_operator.inc\";i:30;s:57:\"handlers/views_handler_filter_boolean_operator_string.inc\";i:31;s:41:\"handlers/views_handler_filter_combine.inc\";i:32;s:38:\"handlers/views_handler_filter_date.inc\";i:33;s:42:\"handlers/views_handler_filter_equality.inc\";i:34;s:47:\"handlers/views_handler_filter_entity_bundle.inc\";i:35;s:50:\"handlers/views_handler_filter_group_by_numeric.inc\";i:36;s:45:\"handlers/views_handler_filter_in_operator.inc\";i:37;s:45:\"handlers/views_handler_filter_many_to_one.inc\";i:38;s:41:\"handlers/views_handler_filter_numeric.inc\";i:39;s:40:\"handlers/views_handler_filter_string.inc\";i:40;s:39:\"handlers/views_handler_relationship.inc\";i:41;s:53:\"handlers/views_handler_relationship_groupwise_max.inc\";i:42;s:31:\"handlers/views_handler_sort.inc\";i:43;s:36:\"handlers/views_handler_sort_date.inc\";i:44;s:39:\"handlers/views_handler_sort_formula.inc\";i:45;s:48:\"handlers/views_handler_sort_group_by_numeric.inc\";i:46;s:46:\"handlers/views_handler_sort_menu_hierarchy.inc\";i:47;s:38:\"handlers/views_handler_sort_random.inc\";i:48;s:17:\"includes/base.inc\";i:49;s:21:\"includes/handlers.inc\";i:50;s:20:\"includes/plugins.inc\";i:51;s:17:\"includes/view.inc\";i:52;s:60:\"modules/aggregator/views_handler_argument_aggregator_fid.inc\";i:53;s:60:\"modules/aggregator/views_handler_argument_aggregator_iid.inc\";i:54;s:69:\"modules/aggregator/views_handler_argument_aggregator_category_cid.inc\";i:55;s:64:\"modules/aggregator/views_handler_field_aggregator_title_link.inc\";i:56;s:62:\"modules/aggregator/views_handler_field_aggregator_category.inc\";i:57;s:70:\"modules/aggregator/views_handler_field_aggregator_item_description.inc\";i:58;s:57:\"modules/aggregator/views_handler_field_aggregator_xss.inc\";i:59;s:67:\"modules/aggregator/views_handler_filter_aggregator_category_cid.inc\";i:60;s:54:\"modules/aggregator/views_plugin_row_aggregator_rss.inc\";i:61;s:56:\"modules/book/views_plugin_argument_default_book_root.inc\";i:62;s:59:\"modules/comment/views_handler_argument_comment_user_uid.inc\";i:63;s:47:\"modules/comment/views_handler_field_comment.inc\";i:64;s:53:\"modules/comment/views_handler_field_comment_depth.inc\";i:65;s:52:\"modules/comment/views_handler_field_comment_link.inc\";i:66;s:60:\"modules/comment/views_handler_field_comment_link_approve.inc\";i:67;s:59:\"modules/comment/views_handler_field_comment_link_delete.inc\";i:68;s:57:\"modules/comment/views_handler_field_comment_link_edit.inc\";i:69;s:58:\"modules/comment/views_handler_field_comment_link_reply.inc\";i:70;s:57:\"modules/comment/views_handler_field_comment_node_link.inc\";i:71;s:56:\"modules/comment/views_handler_field_comment_username.inc\";i:72;s:61:\"modules/comment/views_handler_field_ncs_last_comment_name.inc\";i:73;s:56:\"modules/comment/views_handler_field_ncs_last_updated.inc\";i:74;s:52:\"modules/comment/views_handler_field_node_comment.inc\";i:75;s:57:\"modules/comment/views_handler_field_node_new_comments.inc\";i:76;s:62:\"modules/comment/views_handler_field_last_comment_timestamp.inc\";i:77;s:57:\"modules/comment/views_handler_filter_comment_user_uid.inc\";i:78;s:57:\"modules/comment/views_handler_filter_ncs_last_updated.inc\";i:79;s:53:\"modules/comment/views_handler_filter_node_comment.inc\";i:80;s:53:\"modules/comment/views_handler_sort_comment_thread.inc\";i:81;s:60:\"modules/comment/views_handler_sort_ncs_last_comment_name.inc\";i:82;s:55:\"modules/comment/views_handler_sort_ncs_last_updated.inc\";i:83;s:48:\"modules/comment/views_plugin_row_comment_rss.inc\";i:84;s:49:\"modules/comment/views_plugin_row_comment_view.inc\";i:85;s:52:\"modules/contact/views_handler_field_contact_link.inc\";i:86;s:43:\"modules/field/views_handler_field_field.inc\";i:87;s:59:\"modules/field/views_handler_relationship_entity_reverse.inc\";i:88;s:51:\"modules/field/views_handler_argument_field_list.inc\";i:89;s:58:\"modules/field/views_handler_argument_field_list_string.inc\";i:90;s:49:\"modules/field/views_handler_filter_field_list.inc\";i:91;s:57:\"modules/filter/views_handler_field_filter_format_name.inc\";i:92;s:52:\"modules/locale/views_handler_field_node_language.inc\";i:93;s:53:\"modules/locale/views_handler_filter_node_language.inc\";i:94;s:54:\"modules/locale/views_handler_argument_locale_group.inc\";i:95;s:57:\"modules/locale/views_handler_argument_locale_language.inc\";i:96;s:51:\"modules/locale/views_handler_field_locale_group.inc\";i:97;s:54:\"modules/locale/views_handler_field_locale_language.inc\";i:98;s:55:\"modules/locale/views_handler_field_locale_link_edit.inc\";i:99;s:52:\"modules/locale/views_handler_filter_locale_group.inc\";i:100;s:55:\"modules/locale/views_handler_filter_locale_language.inc\";i:101;s:54:\"modules/locale/views_handler_filter_locale_version.inc\";i:102;s:53:\"modules/node/views_handler_argument_dates_various.inc\";i:103;s:53:\"modules/node/views_handler_argument_node_language.inc\";i:104;s:48:\"modules/node/views_handler_argument_node_nid.inc\";i:105;s:49:\"modules/node/views_handler_argument_node_type.inc\";i:106;s:48:\"modules/node/views_handler_argument_node_vid.inc\";i:107;s:57:\"modules/node/views_handler_argument_node_uid_revision.inc\";i:108;s:59:\"modules/node/views_handler_field_history_user_timestamp.inc\";i:109;s:41:\"modules/node/views_handler_field_node.inc\";i:110;s:46:\"modules/node/views_handler_field_node_link.inc\";i:111;s:53:\"modules/node/views_handler_field_node_link_delete.inc\";i:112;s:51:\"modules/node/views_handler_field_node_link_edit.inc\";i:113;s:50:\"modules/node/views_handler_field_node_revision.inc\";i:114;s:55:\"modules/node/views_handler_field_node_revision_link.inc\";i:115;s:62:\"modules/node/views_handler_field_node_revision_link_delete.inc\";i:116;s:62:\"modules/node/views_handler_field_node_revision_link_revert.inc\";i:117;s:46:\"modules/node/views_handler_field_node_path.inc\";i:118;s:46:\"modules/node/views_handler_field_node_type.inc\";i:119;s:60:\"modules/node/views_handler_filter_history_user_timestamp.inc\";i:120;s:49:\"modules/node/views_handler_filter_node_access.inc\";i:121;s:49:\"modules/node/views_handler_filter_node_status.inc\";i:122;s:47:\"modules/node/views_handler_filter_node_type.inc\";i:123;s:55:\"modules/node/views_handler_filter_node_uid_revision.inc\";i:124;s:51:\"modules/node/views_plugin_argument_default_node.inc\";i:125;s:52:\"modules/node/views_plugin_argument_validate_node.inc\";i:126;s:42:\"modules/node/views_plugin_row_node_rss.inc\";i:127;s:43:\"modules/node/views_plugin_row_node_view.inc\";i:128;s:52:\"modules/profile/views_handler_field_profile_date.inc\";i:129;s:52:\"modules/profile/views_handler_field_profile_list.inc\";i:130;s:58:\"modules/profile/views_handler_filter_profile_selection.inc\";i:131;s:48:\"modules/search/views_handler_argument_search.inc\";i:132;s:51:\"modules/search/views_handler_field_search_score.inc\";i:133;s:46:\"modules/search/views_handler_filter_search.inc\";i:134;s:50:\"modules/search/views_handler_sort_search_score.inc\";i:135;s:47:\"modules/search/views_plugin_row_search_view.inc\";i:136;s:57:\"modules/statistics/views_handler_field_accesslog_path.inc\";i:137;s:50:\"modules/system/views_handler_argument_file_fid.inc\";i:138;s:43:\"modules/system/views_handler_field_file.inc\";i:139;s:53:\"modules/system/views_handler_field_file_extension.inc\";i:140;s:52:\"modules/system/views_handler_field_file_filemime.inc\";i:141;s:47:\"modules/system/views_handler_field_file_uri.inc\";i:142;s:50:\"modules/system/views_handler_field_file_status.inc\";i:143;s:51:\"modules/system/views_handler_filter_file_status.inc\";i:144;s:52:\"modules/taxonomy/views_handler_argument_taxonomy.inc\";i:145;s:57:\"modules/taxonomy/views_handler_argument_term_node_tid.inc\";i:146;s:63:\"modules/taxonomy/views_handler_argument_term_node_tid_depth.inc\";i:147;s:72:\"modules/taxonomy/views_handler_argument_term_node_tid_depth_modifier.inc\";i:148;s:58:\"modules/taxonomy/views_handler_argument_vocabulary_vid.inc\";i:149;s:67:\"modules/taxonomy/views_handler_argument_vocabulary_machine_name.inc\";i:150;s:49:\"modules/taxonomy/views_handler_field_taxonomy.inc\";i:151;s:54:\"modules/taxonomy/views_handler_field_term_node_tid.inc\";i:152;s:55:\"modules/taxonomy/views_handler_field_term_link_edit.inc\";i:153;s:55:\"modules/taxonomy/views_handler_filter_term_node_tid.inc\";i:154;s:61:\"modules/taxonomy/views_handler_filter_term_node_tid_depth.inc\";i:155;s:56:\"modules/taxonomy/views_handler_filter_vocabulary_vid.inc\";i:156;s:65:\"modules/taxonomy/views_handler_filter_vocabulary_machine_name.inc\";i:157;s:62:\"modules/taxonomy/views_handler_relationship_node_term_data.inc\";i:158;s:65:\"modules/taxonomy/views_plugin_argument_validate_taxonomy_term.inc\";i:159;s:63:\"modules/taxonomy/views_plugin_argument_default_taxonomy_tid.inc\";i:160;s:51:\"modules/system/views_handler_filter_system_type.inc\";i:161;s:56:\"modules/translation/views_handler_argument_node_tnid.inc\";i:162;s:63:\"modules/translation/views_handler_field_node_link_translate.inc\";i:163;s:65:\"modules/translation/views_handler_field_node_translation_link.inc\";i:164;s:54:\"modules/translation/views_handler_filter_node_tnid.inc\";i:165;s:60:\"modules/translation/views_handler_filter_node_tnid_child.inc\";i:166;s:62:\"modules/translation/views_handler_relationship_translation.inc\";i:167;s:48:\"modules/user/views_handler_argument_user_uid.inc\";i:168;s:55:\"modules/user/views_handler_argument_users_roles_rid.inc\";i:169;s:41:\"modules/user/views_handler_field_user.inc\";i:170;s:50:\"modules/user/views_handler_field_user_language.inc\";i:171;s:46:\"modules/user/views_handler_field_user_link.inc\";i:172;s:53:\"modules/user/views_handler_field_user_link_cancel.inc\";i:173;s:51:\"modules/user/views_handler_field_user_link_edit.inc\";i:174;s:46:\"modules/user/views_handler_field_user_mail.inc\";i:175;s:46:\"modules/user/views_handler_field_user_name.inc\";i:176;s:53:\"modules/user/views_handler_field_user_permissions.inc\";i:177;s:49:\"modules/user/views_handler_field_user_picture.inc\";i:178;s:47:\"modules/user/views_handler_field_user_roles.inc\";i:179;s:50:\"modules/user/views_handler_filter_user_current.inc\";i:180;s:47:\"modules/user/views_handler_filter_user_name.inc\";i:181;s:54:\"modules/user/views_handler_filter_user_permissions.inc\";i:182;s:48:\"modules/user/views_handler_filter_user_roles.inc\";i:183;s:59:\"modules/user/views_plugin_argument_default_current_user.inc\";i:184;s:51:\"modules/user/views_plugin_argument_default_user.inc\";i:185;s:52:\"modules/user/views_plugin_argument_validate_user.inc\";i:186;s:43:\"modules/user/views_plugin_row_user_view.inc\";i:187;s:31:\"plugins/views_plugin_access.inc\";i:188;s:36:\"plugins/views_plugin_access_none.inc\";i:189;s:36:\"plugins/views_plugin_access_perm.inc\";i:190;s:36:\"plugins/views_plugin_access_role.inc\";i:191;s:41:\"plugins/views_plugin_argument_default.inc\";i:192;s:45:\"plugins/views_plugin_argument_default_php.inc\";i:193;s:47:\"plugins/views_plugin_argument_default_fixed.inc\";i:194;s:45:\"plugins/views_plugin_argument_default_raw.inc\";i:195;s:42:\"plugins/views_plugin_argument_validate.inc\";i:196;s:50:\"plugins/views_plugin_argument_validate_numeric.inc\";i:197;s:46:\"plugins/views_plugin_argument_validate_php.inc\";i:198;s:30:\"plugins/views_plugin_cache.inc\";i:199;s:35:\"plugins/views_plugin_cache_none.inc\";i:200;s:35:\"plugins/views_plugin_cache_time.inc\";i:201;s:32:\"plugins/views_plugin_display.inc\";i:202;s:43:\"plugins/views_plugin_display_attachment.inc\";i:203;s:38:\"plugins/views_plugin_display_block.inc\";i:204;s:40:\"plugins/views_plugin_display_default.inc\";i:205;s:38:\"plugins/views_plugin_display_embed.inc\";i:206;s:41:\"plugins/views_plugin_display_extender.inc\";i:207;s:37:\"plugins/views_plugin_display_feed.inc\";i:208;s:37:\"plugins/views_plugin_display_page.inc\";i:209;s:43:\"plugins/views_plugin_exposed_form_basic.inc\";i:210;s:37:\"plugins/views_plugin_exposed_form.inc\";i:211;s:52:\"plugins/views_plugin_exposed_form_input_required.inc\";i:212;s:42:\"plugins/views_plugin_localization_core.inc\";i:213;s:37:\"plugins/views_plugin_localization.inc\";i:214;s:42:\"plugins/views_plugin_localization_none.inc\";i:215;s:30:\"plugins/views_plugin_pager.inc\";i:216;s:35:\"plugins/views_plugin_pager_full.inc\";i:217;s:35:\"plugins/views_plugin_pager_mini.inc\";i:218;s:35:\"plugins/views_plugin_pager_none.inc\";i:219;s:35:\"plugins/views_plugin_pager_some.inc\";i:220;s:30:\"plugins/views_plugin_query.inc\";i:221;s:38:\"plugins/views_plugin_query_default.inc\";i:222;s:28:\"plugins/views_plugin_row.inc\";i:223;s:35:\"plugins/views_plugin_row_fields.inc\";i:224;s:39:\"plugins/views_plugin_row_rss_fields.inc\";i:225;s:30:\"plugins/views_plugin_style.inc\";i:226;s:38:\"plugins/views_plugin_style_default.inc\";i:227;s:35:\"plugins/views_plugin_style_grid.inc\";i:228;s:35:\"plugins/views_plugin_style_list.inc\";i:229;s:40:\"plugins/views_plugin_style_jump_menu.inc\";i:230;s:34:\"plugins/views_plugin_style_rss.inc\";i:231;s:38:\"plugins/views_plugin_style_summary.inc\";i:232;s:48:\"plugins/views_plugin_style_summary_jump_menu.inc\";i:233;s:50:\"plugins/views_plugin_style_summary_unformatted.inc\";i:234;s:36:\"plugins/views_plugin_style_table.inc\";i:235;s:43:\"tests/handlers/views_handler_area_text.test\";i:236;s:47:\"tests/handlers/views_handler_argument_null.test\";i:237;s:49:\"tests/handlers/views_handler_argument_string.test\";i:238;s:39:\"tests/handlers/views_handler_field.test\";i:239;s:47:\"tests/handlers/views_handler_field_boolean.test\";i:240;s:46:\"tests/handlers/views_handler_field_custom.test\";i:241;s:47:\"tests/handlers/views_handler_field_counter.test\";i:242;s:44:\"tests/handlers/views_handler_field_date.test\";i:243;s:49:\"tests/handlers/views_handler_field_file_size.test\";i:244;s:44:\"tests/handlers/views_handler_field_math.test\";i:245;s:43:\"tests/handlers/views_handler_field_url.test\";i:246;s:43:\"tests/handlers/views_handler_field_xss.test\";i:247;s:48:\"tests/handlers/views_handler_filter_combine.test\";i:248;s:45:\"tests/handlers/views_handler_filter_date.test\";i:249;s:49:\"tests/handlers/views_handler_filter_equality.test\";i:250;s:52:\"tests/handlers/views_handler_filter_in_operator.test\";i:251;s:48:\"tests/handlers/views_handler_filter_numeric.test\";i:252;s:47:\"tests/handlers/views_handler_filter_string.test\";i:253;s:45:\"tests/handlers/views_handler_sort_random.test\";i:254;s:43:\"tests/handlers/views_handler_sort_date.test\";i:255;s:38:\"tests/handlers/views_handler_sort.test\";i:256;s:60:\"tests/test_plugins/views_test_plugin_access_test_dynamic.inc\";i:257;s:59:\"tests/test_plugins/views_test_plugin_access_test_static.inc\";i:258;s:39:\"tests/plugins/views_plugin_display.test\";i:259;s:46:\"tests/styles/views_plugin_style_jump_menu.test\";i:260;s:36:\"tests/styles/views_plugin_style.test\";i:261;s:48:\"tests/styles/views_plugin_style_unformatted.test\";i:262;s:23:\"tests/views_access.test\";i:263;s:24:\"tests/views_analyze.test\";i:264;s:22:\"tests/views_basic.test\";i:265;s:33:\"tests/views_argument_default.test\";i:266;s:35:\"tests/views_argument_validator.test\";i:267;s:29:\"tests/views_exposed_form.test\";i:268;s:31:\"tests/field/views_fieldapi.test\";i:269;s:25:\"tests/views_glossary.test\";i:270;s:24:\"tests/views_groupby.test\";i:271;s:25:\"tests/views_handlers.test\";i:272;s:23:\"tests/views_module.test\";i:273;s:22:\"tests/views_pager.test\";i:274;s:40:\"tests/views_plugin_localization_test.inc\";i:275;s:29:\"tests/views_translatable.test\";i:276;s:22:\"tests/views_query.test\";i:277;s:24:\"tests/views_upgrade.test\";i:278;s:34:\"tests/views_test.views_default.inc\";i:279;s:58:\"tests/comment/views_handler_argument_comment_user_uid.test\";i:280;s:56:\"tests/comment/views_handler_filter_comment_user_uid.test\";i:281;s:61:\"tests/taxonomy/views_handler_relationship_node_term_data.test\";i:282;s:45:\"tests/user/views_handler_field_user_name.test\";i:283;s:43:\"tests/user/views_user_argument_default.test\";i:284;s:44:\"tests/user/views_user_argument_validate.test\";i:285;s:26:\"tests/user/views_user.test\";i:286;s:22:\"tests/views_cache.test\";i:287;s:21:\"tests/views_view.test\";i:288;s:19:\"tests/views_ui.test\";}s:7:\"version\";s:7:\"7.x-3.5\";s:7:\"project\";s:5:\"views\";s:9:\"datestamp\";s:10:\"1345829394\";s:9:\"bootstrap\";i:0;}}s:11:\"panels_node\";O:8:\"stdClass\":9:{s:8:\"filename\";s:63:\"sites/all/modules/contrib/panels/panels_node/panels_node.module\";s:4:\"name\";s:11:\"panels_node\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"6001\";s:6:\"weight\";s:2:\"11\";s:4:\"info\";a:12:{s:4:\"name\";s:11:\"Panel nodes\";s:11:\"description\";s:65:\"Create nodes that are divided into areas with selectable content.\";s:7:\"package\";s:6:\"Panels\";s:12:\"dependencies\";a:1:{i:0;s:6:\"panels\";}s:9:\"configure\";s:22:\"admin/structure/panels\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:18:\"panels_node.module\";}s:7:\"version\";s:7:\"7.x-3.3\";s:7:\"project\";s:6:\"panels\";s:9:\"datestamp\";s:10:\"1345319572\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:12:\"page_manager\";O:8:\"stdClass\":9:{s:8:\"filename\";s:65:\"sites/all/modules/contrib/ctools/page_manager/page_manager.module\";s:4:\"name\";s:12:\"page_manager\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:2:\"99\";s:4:\"info\";a:11:{s:4:\"name\";s:12:\"Page manager\";s:11:\"description\";s:54:\"Provides a UI and API to manage pages within the site.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:10:\"admin_menu\";O:8:\"stdClass\":9:{s:8:\"filename\";s:54:\"sites/all/modules/contrib/admin_menu/admin_menu.module\";s:4:\"name\";s:10:\"admin_menu\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7304\";s:6:\"weight\";s:3:\"100\";s:4:\"info\";a:12:{s:4:\"name\";s:19:\"Administration menu\";s:11:\"description\";s:123:\"Provides a dropdown menu to most administrative tasks and other common destinations (to users with the proper permissions).\";s:7:\"package\";s:14:\"Administration\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:38:\"admin/config/administration/admin_menu\";s:12:\"dependencies\";a:1:{i:0;s:14:\"system (>7.10)\";}s:5:\"files\";a:1:{i:0;s:21:\"tests/admin_menu.test\";}s:7:\"version\";s:11:\"7.x-3.0-rc3\";s:7:\"project\";s:10:\"admin_menu\";s:9:\"datestamp\";s:10:\"1337292349\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:8:\"standard\";O:8:\"stdClass\":9:{s:8:\"filename\";s:34:\"profiles/standard/standard.profile\";s:4:\"name\";s:8:\"standard\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:4:\"1000\";s:4:\"info\";a:14:{s:4:\"name\";s:8:\"Standard\";s:11:\"description\";s:51:\"Install with commonly used features pre-configured.\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:21:{i:0;s:5:\"block\";i:1;s:5:\"color\";i:2;s:7:\"comment\";i:3;s:10:\"contextual\";i:4;s:9:\"dashboard\";i:5;s:4:\"help\";i:6;s:5:\"image\";i:7;s:4:\"list\";i:8;s:4:\"menu\";i:9;s:6:\"number\";i:10;s:7:\"options\";i:11;s:4:\"path\";i:12;s:8:\"taxonomy\";i:13;s:5:\"dblog\";i:14;s:6:\"search\";i:15;s:8:\"shortcut\";i:16;s:7:\"toolbar\";i:17;s:7:\"overlay\";i:18;s:8:\"field_ui\";i:19;s:4:\"file\";i:20;s:3:\"rdf\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;s:6:\"hidden\";b:1;s:8:\"required\";b:1;s:17:\"distribution_name\";s:6:\"Drupal\";}}}s:5:\"theme\";a:5:{s:6:\"bartik\";O:8:\"stdClass\":10:{s:8:\"filename\";s:25:\"themes/bartik/bartik.info\";s:4:\"name\";s:6:\"bartik\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:6:\"Bartik\";s:11:\"description\";s:48:\"A flexible, recolorable theme with many regions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:7:\"regions\";a:20:{s:6:\"header\";s:6:\"Header\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"triptych_first\";s:14:\"Triptych first\";s:15:\"triptych_middle\";s:15:\"Triptych middle\";s:13:\"triptych_last\";s:13:\"Triptych last\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"0\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:28:\"themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";}s:7:\"garland\";O:8:\"stdClass\":10:{s:8:\"filename\";s:27:\"themes/garland/garland.info\";s:4:\"name\";s:7:\"garland\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:7:\"Garland\";s:11:\"description\";s:111:\"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:8:\"settings\";a:1:{s:13:\"garland_width\";s:5:\"fluid\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:29:\"themes/garland/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";}s:7:\"mercury\";O:8:\"stdClass\":10:{s:8:\"filename\";s:37:\"sites/all/themes/mercury/mercury.info\";s:4:\"name\";s:7:\"mercury\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:7:\"Mercury\";s:11:\"description\";s:26:\"Mercury theme for Drupal 7\";s:10:\"screenshot\";s:46:\"sites/all/themes/mercury/images/screenshot.gif\";s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:7:\"mercury\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:14:{s:8:\"page_top\";s:8:\"Page top\";s:16:\"header_top_right\";s:16:\"Header top right\";s:6:\"header\";s:6:\"Header\";s:9:\"highlight\";s:9:\"Highlight\";s:4:\"help\";s:4:\"Help\";s:11:\"title_right\";s:11:\"Title Right\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"sidebar_second\";s:14:\"Second sidebar\";s:6:\"footer\";s:6:\"Footer\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:6:\"search\";i:6;s:7:\"favicon\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:11:\"stylesheets\";a:2:{s:3:\"all\";a:5:{s:15:\"css/default.css\";s:40:\"sites/all/themes/mercury/css/default.css\";s:14:\"css/layout.css\";s:39:\"sites/all/themes/mercury/css/layout.css\";s:13:\"css/style.css\";s:38:\"sites/all/themes/mercury/css/style.css\";s:17:\"css/node-view.css\";s:42:\"sites/all/themes/mercury/css/node-view.css\";s:17:\"css/analytics.css\";s:42:\"sites/all/themes/mercury/css/analytics.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:38:\"sites/all/themes/mercury/css/print.css\";}}s:7:\"scripts\";a:6:{s:19:\"js/jquery-ui.min.js\";s:44:\"sites/all/themes/mercury/js/jquery-ui.min.js\";s:29:\"js/jquery.mCustomScrollbar.js\";s:54:\"sites/all/themes/mercury/js/jquery.mCustomScrollbar.js\";s:27:\"js/jquery.mousewheel.min.js\";s:52:\"sites/all/themes/mercury/js/jquery.mousewheel.min.js\";s:24:\"js/jquery.tablesorter.js\";s:49:\"sites/all/themes/mercury/js/jquery.tablesorter.js\";s:32:\"js/jquery.tablesorter.widgets.js\";s:57:\"sites/all/themes/mercury/js/jquery.tablesorter.widgets.js\";s:14:\"js/function.js\";s:39:\"sites/all/themes/mercury/js/function.js\";}s:7:\"compass\";a:3:{s:6:\"status\";s:1:\"1\";s:8:\"sass_dir\";s:4:\"sass\";s:7:\"css_dir\";s:3:\"css\";}s:8:\"settings\";a:4:{s:12:\"mercury_tabs\";s:1:\"1\";s:28:\"mercury_breadcrumb_separator\";s:2:\"»\";s:14:\"wireframe_mode\";s:1:\"0\";s:14:\"clear_registry\";s:1:\"0\";}s:7:\"version\";s:7:\"7.x-2.1\";s:9:\"datestamp\";s:10:\"1334122542\";s:3:\"php\";s:5:\"5.2.4\";s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";}s:5:\"seven\";O:8:\"stdClass\":10:{s:8:\"filename\";s:23:\"themes/seven/seven.info\";s:4:\"name\";s:5:\"seven\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:5:\"Seven\";s:11:\"description\";s:65:\"A simple one-column, tableless, fluid width administration theme.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"1\";}s:7:\"regions\";a:8:{s:7:\"content\";s:7:\"Content\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";}s:5:\"stark\";O:8:\"stdClass\":10:{s:8:\"filename\";s:23:\"themes/stark/stark.info\";s:4:\"name\";s:5:\"stark\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:17:{s:4:\"name\";s:5:\"Stark\";s:11:\"description\";s:208:\"This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/stark/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";}}s:9:\"filepaths\";a:79:{i:0;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:5:\"block\";s:8:\"filepath\";s:26:\"modules/block/block.module\";}i:1;a:3:{s:4:\"type\";s:5:\"theme\";s:4:\"name\";s:6:\"bartik\";s:8:\"filepath\";s:25:\"themes/bartik/bartik.info\";}i:2;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:11:\"block_class\";s:8:\"filepath\";s:56:\"sites/all/modules/contrib/block_class/block_class.module\";}i:3;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:5:\"coder\";s:8:\"filepath\";s:44:\"sites/all/modules/contrib/coder/coder.module\";}i:4;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:12:\"coder_review\";s:8:\"filepath\";s:64:\"sites/all/modules/contrib/coder/coder_review/coder_review.module\";}i:5;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:5:\"color\";s:8:\"filepath\";s:26:\"modules/color/color.module\";}i:6;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:7:\"comment\";s:8:\"filepath\";s:30:\"modules/comment/comment.module\";}i:7;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:14:\"computed_field\";s:8:\"filepath\";s:62:\"sites/all/modules/contrib/computed_field/computed_field.module\";}i:8;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"ctools\";s:8:\"filepath\";s:46:\"sites/all/modules/contrib/ctools/ctools.module\";}i:9;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:18:\"ctools_ajax_sample\";s:8:\"filepath\";s:77:\"sites/all/modules/contrib/ctools/ctools_ajax_sample/ctools_ajax_sample.module\";}i:10;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:21:\"ctools_custom_content\";s:8:\"filepath\";s:83:\"sites/all/modules/contrib/ctools/ctools_custom_content/ctools_custom_content.module\";}i:11;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:13:\"ctools_popups\";s:8:\"filepath\";s:59:\"sites/all/modules/custom/ctools_popups/ctools_popups.module\";}i:12;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:9:\"dashboard\";s:8:\"filepath\";s:34:\"modules/dashboard/dashboard.module\";}i:13;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"date\";s:8:\"filepath\";s:42:\"sites/all/modules/contrib/date/date.module\";}i:14;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"date_api\";s:8:\"filepath\";s:55:\"sites/all/modules/contrib/date/date_api/date_api.module\";}i:15;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:10:\"date_popup\";s:8:\"filepath\";s:59:\"sites/all/modules/contrib/date/date_popup/date_popup.module\";}i:16;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:10:\"date_views\";s:8:\"filepath\";s:59:\"sites/all/modules/contrib/date/date_views/date_views.module\";}i:17;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:5:\"dblog\";s:8:\"filepath\";s:26:\"modules/dblog/dblog.module\";}i:18;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"entity\";s:8:\"filepath\";s:46:\"sites/all/modules/contrib/entity/entity.module\";}i:19;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:15:\"entityreference\";s:8:\"filepath\";s:64:\"sites/all/modules/contrib/entityreference/entityreference.module\";}i:20;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:12:\"entity_token\";s:8:\"filepath\";s:52:\"sites/all/modules/contrib/entity/entity_token.module\";}i:21;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:3:\"eva\";s:8:\"filepath\";s:40:\"sites/all/modules/contrib/eva/eva.module\";}i:22;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:14:\"famc_analytics\";s:8:\"filepath\";s:61:\"sites/all/modules/custom/famc_analytics/famc_analytics.module\";}i:23;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:9:\"famc_asup\";s:8:\"filepath\";s:51:\"sites/all/modules/custom/famc_asup/famc_asup.module\";}i:24;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:10:\"famc_drush\";s:8:\"filepath\";s:53:\"sites/all/modules/custom/famc_drush/famc_drush.module\";}i:25;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:5:\"field\";s:8:\"filepath\";s:26:\"modules/field/field.module\";}i:26;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:17:\"field_sql_storage\";s:8:\"filepath\";s:64:\"modules/field/modules/field_sql_storage/field_sql_storage.module\";}i:27;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"field_ui\";s:8:\"filepath\";s:32:\"modules/field_ui/field_ui.module\";}i:28;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"filter\";s:8:\"filepath\";s:28:\"modules/filter/filter.module\";}i:29;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"help\";s:8:\"filepath\";s:24:\"modules/help/help.module\";}i:30;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:16:\"jslider_form_api\";s:8:\"filepath\";s:66:\"sites/all/modules/contrib/jslider_form_api/jslider_form_api.module\";}i:31;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"list\";s:8:\"filepath\";s:38:\"modules/field/modules/list/list.module\";}i:32;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:13:\"logintoboggan\";s:8:\"filepath\";s:60:\"sites/all/modules/contrib/logintoboggan/logintoboggan.module\";}i:33;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:17:\"login_destination\";s:8:\"filepath\";s:68:\"sites/all/modules/contrib/login_destination/login_destination.module\";}i:34;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"menu\";s:8:\"filepath\";s:24:\"modules/menu/menu.module\";}i:35;a:3:{s:4:\"type\";s:5:\"theme\";s:4:\"name\";s:7:\"mercury\";s:8:\"filepath\";s:37:\"sites/all/themes/mercury/mercury.info\";}i:36;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:13:\"mercury_fmcdb\";s:8:\"filepath\";s:59:\"sites/all/modules/custom/mercury_fmcdb/mercury_fmcdb.module\";}i:37;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:18:\"mercury_management\";s:8:\"filepath\";s:69:\"sites/all/modules/custom/mercury_management/mercury_management.module\";}i:38;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:17:\"mercury_utilities\";s:8:\"filepath\";s:67:\"sites/all/modules/custom/mercury_utilities/mercury_utilities.module\";}i:39;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:13:\"module_filter\";s:8:\"filepath\";s:60:\"sites/all/modules/contrib/module_filter/module_filter.module\";}i:40;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"node\";s:8:\"filepath\";s:24:\"modules/node/node.module\";}i:41;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:14:\"node_reference\";s:8:\"filepath\";s:73:\"sites/all/modules/contrib/references/node_reference/node_reference.module\";}i:42;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"number\";s:8:\"filepath\";s:42:\"modules/field/modules/number/number.module\";}i:43;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:7:\"options\";s:8:\"filepath\";s:44:\"modules/field/modules/options/options.module\";}i:44;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"panels\";s:8:\"filepath\";s:46:\"sites/all/modules/contrib/panels/panels.module\";}i:45;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:10:\"panels_ipe\";s:8:\"filepath\";s:61:\"sites/all/modules/contrib/panels/panels_ipe/panels_ipe.module\";}i:46;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:11:\"panels_mini\";s:8:\"filepath\";s:63:\"sites/all/modules/contrib/panels/panels_mini/panels_mini.module\";}i:47;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:14:\"password_field\";s:8:\"filepath\";s:62:\"sites/all/modules/contrib/password_field/password_field.module\";}i:48;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"path\";s:8:\"filepath\";s:24:\"modules/path/path.module\";}i:49;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:3:\"php\";s:8:\"filepath\";s:22:\"modules/php/php.module\";}i:50;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:10:\"r4032login\";s:8:\"filepath\";s:54:\"sites/all/modules/contrib/r4032login/r4032login.module\";}i:51;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:3:\"rdf\";s:8:\"filepath\";s:22:\"modules/rdf/rdf.module\";}i:52;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:10:\"references\";s:8:\"filepath\";s:54:\"sites/all/modules/contrib/references/references.module\";}i:53;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"search\";s:8:\"filepath\";s:28:\"modules/search/search.module\";}i:54;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:10:\"search_api\";s:8:\"filepath\";s:54:\"sites/all/modules/contrib/search_api/search_api.module\";}i:55;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:15:\"search_api_page\";s:8:\"filepath\";s:64:\"sites/all/modules/contrib/search_api_page/search_api_page.module\";}i:56;a:3:{s:4:\"type\";s:5:\"theme\";s:4:\"name\";s:5:\"seven\";s:8:\"filepath\";s:23:\"themes/seven/seven.info\";}i:57;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"shortcut\";s:8:\"filepath\";s:32:\"modules/shortcut/shortcut.module\";}i:58;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"syslog\";s:8:\"filepath\";s:28:\"modules/syslog/syslog.module\";}i:59;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"system\";s:8:\"filepath\";s:28:\"modules/system/system.module\";}i:60;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"taxonomy\";s:8:\"filepath\";s:32:\"modules/taxonomy/taxonomy.module\";}i:61;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"text\";s:8:\"filepath\";s:38:\"modules/field/modules/text/text.module\";}i:62;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:5:\"token\";s:8:\"filepath\";s:44:\"sites/all/modules/contrib/token/token.module\";}i:63;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:12:\"unique_field\";s:8:\"filepath\";s:58:\"sites/all/modules/contrib/unique_field/unique_field.module\";}i:64;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"user\";s:8:\"filepath\";s:24:\"modules/user/user.module\";}i:65;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:14:\"user_reference\";s:8:\"filepath\";s:73:\"sites/all/modules/contrib/references/user_reference/user_reference.module\";}i:66;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:13:\"views_content\";s:8:\"filepath\";s:67:\"sites/all/modules/contrib/ctools/views_content/views_content.module\";}i:67;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:17:\"views_data_export\";s:8:\"filepath\";s:68:\"sites/all/modules/contrib/views_data_export/views_data_export.module\";}i:68;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:9:\"views_php\";s:8:\"filepath\";s:52:\"sites/all/modules/contrib/views_php/views_php.module\";}i:69;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"views_ui\";s:8:\"filepath\";s:47:\"sites/all/modules/contrib/views/views_ui.module\";}i:70;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:14:\"views_watchdog\";s:8:\"filepath\";s:62:\"sites/all/modules/contrib/views_watchdog/views_watchdog.module\";}i:71;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:11:\"field_group\";s:8:\"filepath\";s:56:\"sites/all/modules/contrib/field_group/field_group.module\";}i:72;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"pathauto\";s:8:\"filepath\";s:50:\"sites/all/modules/contrib/pathauto/pathauto.module\";}i:73;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:15:\"menu_attributes\";s:8:\"filepath\";s:64:\"sites/all/modules/contrib/menu_attributes/menu_attributes.module\";}i:74;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:5:\"views\";s:8:\"filepath\";s:44:\"sites/all/modules/contrib/views/views.module\";}i:75;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:11:\"panels_node\";s:8:\"filepath\";s:63:\"sites/all/modules/contrib/panels/panels_node/panels_node.module\";}i:76;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:12:\"page_manager\";s:8:\"filepath\";s:65:\"sites/all/modules/contrib/ctools/page_manager/page_manager.module\";}i:77;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:10:\"admin_menu\";s:8:\"filepath\";s:54:\"sites/all/modules/contrib/admin_menu/admin_menu.module\";}i:78;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"standard\";s:8:\"filepath\";s:34:\"profiles/standard/standard.profile\";}}}',0,1371656313,1),('hook_info','a:8:{s:20:\"entity_property_info\";a:1:{s:5:\"group\";s:4:\"info\";}s:26:\"entity_property_info_alter\";a:1:{s:5:\"group\";s:4:\"info\";}s:10:\"token_info\";a:1:{s:5:\"group\";s:6:\"tokens\";}s:16:\"token_info_alter\";a:1:{s:5:\"group\";s:6:\"tokens\";}s:6:\"tokens\";a:1:{s:5:\"group\";s:6:\"tokens\";}s:12:\"tokens_alter\";a:1:{s:5:\"group\";s:6:\"tokens\";}s:8:\"pathauto\";a:1:{s:5:\"group\";s:8:\"pathauto\";}s:16:\"path_alias_types\";a:1:{s:5:\"group\";s:8:\"pathauto\";}}',0,1371656313,1);
/*!40000 ALTER TABLE `cache_bootstrap` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_coder`
--

DROP TABLE IF EXISTS `cache_coder`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_coder` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Coder cache table for improving display of result sets...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_coder`
--

LOCK TABLES `cache_coder` WRITE;
/*!40000 ALTER TABLE `cache_coder` DISABLE KEYS */;
/*!40000 ALTER TABLE `cache_coder` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_field`
--

DROP TABLE IF EXISTS `cache_field`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_field` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Generic cache table for caching things not separated out...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_field`
--

LOCK TABLES `cache_field` WRITE;
/*!40000 ALTER TABLE `cache_field` DISABLE KEYS */;
INSERT INTO `cache_field` VALUES ('field_info_types:en','a:4:{s:11:\"field types\";a:19:{s:8:\"computed\";a:8:{s:5:\"label\";s:8:\"Computed\";s:11:\"description\";s:31:\"Create field data via PHP code.\";s:8:\"settings\";a:4:{s:4:\"code\";s:31:\"$entity_field[0][\'value\'] = \"\";\";s:14:\"display_format\";s:46:\"$display_output = $entity_field_item[\'value\'];\";s:5:\"store\";i:1;s:8:\"database\";a:8:{s:9:\"data_type\";s:7:\"varchar\";s:11:\"data_length\";i:32;s:9:\"data_size\";s:6:\"normal\";s:14:\"data_precision\";i:10;s:10:\"data_scale\";i:2;s:13:\"data_not_NULL\";b:0;s:12:\"data_default\";N;s:10:\"data_index\";b:0;}}s:14:\"default_widget\";s:8:\"computed\";s:17:\"default_formatter\";s:20:\"computed_field_plain\";s:18:\"property_callbacks\";a:1:{i:0;s:39:\"computed_field_entity_property_callback\";}s:17:\"instance_settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"module\";s:14:\"computed_field\";}s:8:\"datetime\";a:10:{s:5:\"label\";s:4:\"Date\";s:11:\"description\";s:125:\"Store a date in the database as a datetime field, recommended for complete dates and times that may need timezone conversion.\";s:14:\"default_widget\";s:11:\"date_select\";s:17:\"default_formatter\";s:12:\"date_default\";s:23:\"default_token_formatter\";s:10:\"date_plain\";s:8:\"settings\";a:4:{s:6:\"todate\";s:0:\"\";s:11:\"granularity\";a:5:{s:4:\"year\";s:4:\"year\";s:5:\"month\";s:5:\"month\";s:3:\"day\";s:3:\"day\";s:4:\"hour\";s:4:\"hour\";s:6:\"minute\";s:6:\"minute\";}s:11:\"tz_handling\";s:4:\"site\";s:11:\"timezone_db\";s:3:\"UTC\";}s:17:\"instance_settings\";a:5:{s:13:\"default_value\";s:3:\"now\";s:18:\"default_value_code\";s:0:\"\";s:14:\"default_value2\";s:4:\"same\";s:19:\"default_value_code2\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:13:\"property_type\";s:4:\"date\";s:18:\"property_callbacks\";a:1:{i:0;s:40:\"date_entity_metadata_property_info_alter\";}s:6:\"module\";s:4:\"date\";}s:4:\"date\";a:10:{s:5:\"label\";s:17:\"Date (ISO format)\";s:11:\"description\";s:89:\"Store a date in the database as an ISO date, recommended for historical or partial dates.\";s:14:\"default_widget\";s:11:\"date_select\";s:17:\"default_formatter\";s:12:\"date_default\";s:23:\"default_token_formatter\";s:10:\"date_plain\";s:8:\"settings\";a:4:{s:6:\"todate\";s:0:\"\";s:11:\"granularity\";a:5:{s:4:\"year\";s:4:\"year\";s:5:\"month\";s:5:\"month\";s:3:\"day\";s:3:\"day\";s:4:\"hour\";s:4:\"hour\";s:6:\"minute\";s:6:\"minute\";}s:11:\"tz_handling\";s:4:\"site\";s:11:\"timezone_db\";s:3:\"UTC\";}s:17:\"instance_settings\";a:5:{s:13:\"default_value\";s:3:\"now\";s:18:\"default_value_code\";s:0:\"\";s:14:\"default_value2\";s:4:\"same\";s:19:\"default_value_code2\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:13:\"property_type\";s:4:\"date\";s:18:\"property_callbacks\";a:1:{i:0;s:40:\"date_entity_metadata_property_info_alter\";}s:6:\"module\";s:4:\"date\";}s:9:\"datestamp\";a:10:{s:5:\"label\";s:21:\"Date (Unix timestamp)\";s:11:\"description\";s:86:\"Store a date in the database as a timestamp, deprecated format to support legacy data.\";s:14:\"default_widget\";s:11:\"date_select\";s:17:\"default_formatter\";s:12:\"date_default\";s:23:\"default_token_formatter\";s:10:\"date_plain\";s:8:\"settings\";a:4:{s:6:\"todate\";s:0:\"\";s:11:\"granularity\";a:5:{s:4:\"year\";s:4:\"year\";s:5:\"month\";s:5:\"month\";s:3:\"day\";s:3:\"day\";s:4:\"hour\";s:4:\"hour\";s:6:\"minute\";s:6:\"minute\";}s:11:\"tz_handling\";s:4:\"site\";s:11:\"timezone_db\";s:3:\"UTC\";}s:17:\"instance_settings\";a:5:{s:13:\"default_value\";s:3:\"now\";s:18:\"default_value_code\";s:0:\"\";s:14:\"default_value2\";s:4:\"same\";s:19:\"default_value_code2\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:13:\"property_type\";s:4:\"date\";s:18:\"property_callbacks\";a:1:{i:0;s:40:\"date_entity_metadata_property_info_alter\";}s:6:\"module\";s:4:\"date\";}s:15:\"entityreference\";a:8:{s:5:\"label\";s:16:\"Entity Reference\";s:11:\"description\";s:36:\"This field reference another entity.\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:0:{}}s:17:\"instance_settings\";a:1:{s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:28:\"entityreference_autocomplete\";s:17:\"default_formatter\";s:21:\"entityreference_label\";s:18:\"property_callbacks\";a:1:{i:0;s:39:\"entityreference_field_property_callback\";}s:6:\"module\";s:15:\"entityreference\";}s:12:\"list_integer\";a:9:{s:5:\"label\";s:14:\"List (integer)\";s:11:\"description\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:0:{}s:23:\"allowed_values_function\";s:0:\"\";}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:17:\"instance_settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"module\";s:4:\"list\";s:13:\"property_type\";s:7:\"integer\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:10:\"list_float\";a:9:{s:5:\"label\";s:12:\"List (float)\";s:11:\"description\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:0:{}s:23:\"allowed_values_function\";s:0:\"\";}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:17:\"instance_settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"module\";s:4:\"list\";s:13:\"property_type\";s:7:\"decimal\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:9:\"list_text\";a:9:{s:5:\"label\";s:11:\"List (text)\";s:11:\"description\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:0:{}s:23:\"allowed_values_function\";s:0:\"\";}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:17:\"instance_settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"module\";s:4:\"list\";s:13:\"property_type\";s:4:\"text\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_boolean\";a:9:{s:5:\"label\";s:7:\"Boolean\";s:11:\"description\";s:50:\"This field stores simple on/off or yes/no options.\";s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:0:{}s:23:\"allowed_values_function\";s:0:\"\";}s:14:\"default_widget\";s:15:\"options_buttons\";s:17:\"default_formatter\";s:12:\"list_default\";s:17:\"instance_settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"module\";s:4:\"list\";s:13:\"property_type\";s:7:\"boolean\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:14:\"node_reference\";a:9:{s:5:\"label\";s:14:\"Node reference\";s:11:\"description\";s:63:\"This field stores the ID of a related node as an integer value.\";s:8:\"settings\";a:2:{s:19:\"referenceable_types\";a:0:{}s:4:\"view\";a:3:{s:9:\"view_name\";s:0:\"\";s:12:\"display_name\";s:0:\"\";s:4:\"args\";a:0:{}}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:22:\"node_reference_default\";s:13:\"property_type\";s:4:\"node\";s:23:\"default_token_formatter\";s:20:\"node_reference_plain\";s:17:\"instance_settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"module\";s:14:\"node_reference\";}s:14:\"number_integer\";a:9:{s:5:\"label\";s:7:\"Integer\";s:11:\"description\";s:57:\"This field stores a number in the database as an integer.\";s:17:\"instance_settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:8:\"settings\";a:0:{}s:6:\"module\";s:6:\"number\";s:13:\"property_type\";s:7:\"integer\";s:23:\"default_token_formatter\";s:18:\"number_unformatted\";}s:14:\"number_decimal\";a:9:{s:5:\"label\";s:7:\"Decimal\";s:11:\"description\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:8:\"settings\";a:3:{s:9:\"precision\";i:10;s:5:\"scale\";i:2;s:17:\"decimal_separator\";s:1:\".\";}s:17:\"instance_settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:6:\"module\";s:6:\"number\";s:13:\"property_type\";s:7:\"decimal\";s:23:\"default_token_formatter\";s:18:\"number_unformatted\";}s:12:\"number_float\";a:9:{s:5:\"label\";s:5:\"Float\";s:11:\"description\";s:70:\"This field stores a number in the database in a floating point format.\";s:8:\"settings\";a:1:{s:17:\"decimal_separator\";s:1:\".\";}s:17:\"instance_settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:6:\"module\";s:6:\"number\";s:13:\"property_type\";s:7:\"decimal\";s:23:\"default_token_formatter\";s:18:\"number_unformatted\";}s:14:\"password_field\";a:7:{s:5:\"label\";s:8:\"Password\";s:11:\"description\";s:10:\"A password\";s:14:\"default_widget\";s:21:\"password_field_widget\";s:17:\"default_formatter\";s:24:\"password_field_formatter\";s:8:\"settings\";a:0:{}s:17:\"instance_settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"module\";s:14:\"password_field\";}s:23:\"taxonomy_term_reference\";a:10:{s:5:\"label\";s:14:\"Term reference\";s:11:\"description\";s:49:\"This field stores a reference to a taxonomy term.\";s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:28:\"taxonomy_term_reference_link\";s:8:\"settings\";a:1:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:0:\"\";s:6:\"parent\";s:1:\"0\";}}}s:17:\"instance_settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"module\";s:8:\"taxonomy\";s:13:\"property_type\";s:13:\"taxonomy_term\";s:18:\"property_callbacks\";a:1:{i:0;s:45:\"entity_metadata_field_term_reference_callback\";}s:23:\"default_token_formatter\";s:29:\"taxonomy_term_reference_plain\";}s:4:\"text\";a:10:{s:5:\"label\";s:4:\"Text\";s:11:\"description\";s:47:\"This field stores varchar text in the database.\";s:8:\"settings\";a:1:{s:10:\"max_length\";i:255;}s:17:\"instance_settings\";a:2:{s:15:\"text_processing\";i:0;s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:6:\"module\";s:4:\"text\";s:13:\"property_type\";s:4:\"text\";s:18:\"property_callbacks\";a:1:{i:0;s:44:\"entity_metadata_field_text_property_callback\";}s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:10:{s:5:\"label\";s:9:\"Long text\";s:11:\"description\";s:44:\"This field stores long text in the database.\";s:17:\"instance_settings\";a:2:{s:15:\"text_processing\";i:0;s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:13:\"property_type\";s:4:\"text\";s:18:\"property_callbacks\";a:1:{i:0;s:44:\"entity_metadata_field_text_property_callback\";}s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:10:{s:5:\"label\";s:21:\"Long text and summary\";s:11:\"description\";s:77:\"This field stores long text in the database along with optional summary text.\";s:17:\"instance_settings\";a:3:{s:15:\"text_processing\";i:1;s:15:\"display_summary\";i:0;s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:13:\"property_type\";s:22:\"field_item_textsummary\";s:18:\"property_callbacks\";a:1:{i:0;s:44:\"entity_metadata_field_text_property_callback\";}s:23:\"default_token_formatter\";s:12:\"text_default\";}s:14:\"user_reference\";a:9:{s:5:\"label\";s:14:\"User reference\";s:11:\"description\";s:63:\"This field stores the ID of a related user as an integer value.\";s:8:\"settings\";a:3:{s:19:\"referenceable_roles\";a:0:{}s:20:\"referenceable_status\";a:0:{}s:4:\"view\";a:3:{s:9:\"view_name\";s:0:\"\";s:12:\"display_name\";s:0:\"\";s:4:\"args\";a:0:{}}}s:14:\"default_widget\";s:27:\"user_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"user_reference_default\";s:13:\"property_type\";s:4:\"user\";s:23:\"default_token_formatter\";s:20:\"user_reference_plain\";s:17:\"instance_settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"module\";s:14:\"user_reference\";}}s:12:\"widget types\";a:17:{s:8:\"computed\";a:5:{s:5:\"label\";s:8:\"Computed\";s:11:\"field types\";a:1:{i:0;s:8:\"computed\";}s:9:\"behaviors\";a:2:{s:15:\"multiple values\";i:4;s:13:\"default value\";i:1;}s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"computed_field\";}s:11:\"date_select\";a:5:{s:5:\"label\";s:11:\"Select list\";s:11:\"field types\";a:3:{i:0;s:4:\"date\";i:1;s:9:\"datestamp\";i:2;s:8:\"datetime\";}s:8:\"settings\";a:6:{s:12:\"input_format\";s:13:\"m/d/Y - H:i:s\";s:19:\"input_format_custom\";s:0:\"\";s:9:\"increment\";i:15;s:10:\"text_parts\";a:0:{}s:10:\"year_range\";s:5:\"-3:+3\";s:14:\"label_position\";s:5:\"above\";}s:9:\"behaviors\";a:2:{s:15:\"multiple values\";i:2;s:13:\"default value\";i:1;}s:6:\"module\";s:4:\"date\";}s:9:\"date_text\";a:6:{s:5:\"label\";s:10:\"Text field\";s:11:\"field types\";a:3:{i:0;s:4:\"date\";i:1;s:9:\"datestamp\";i:2;s:8:\"datetime\";}s:8:\"settings\";a:6:{s:12:\"input_format\";s:13:\"m/d/Y - H:i:s\";s:19:\"input_format_custom\";s:0:\"\";s:9:\"increment\";i:15;s:10:\"text_parts\";a:0:{}s:10:\"year_range\";s:5:\"-3:+3\";s:14:\"label_position\";s:5:\"above\";}s:9:\"behaviors\";a:2:{s:15:\"multiple values\";i:2;s:13:\"default value\";i:1;}s:9:\"increment\";i:1;s:6:\"module\";s:4:\"date\";}s:10:\"date_popup\";a:5:{s:5:\"label\";s:15:\"Pop-up calendar\";s:11:\"field types\";a:3:{i:0;s:4:\"date\";i:1;s:9:\"datestamp\";i:2;s:8:\"datetime\";}s:8:\"settings\";a:6:{s:12:\"input_format\";s:13:\"m/d/Y - H:i:s\";s:19:\"input_format_custom\";s:0:\"\";s:9:\"increment\";i:15;s:10:\"text_parts\";a:0:{}s:10:\"year_range\";s:5:\"-3:+3\";s:14:\"label_position\";s:5:\"above\";}s:9:\"behaviors\";a:2:{s:15:\"multiple values\";i:2;s:13:\"default value\";i:1;}s:6:\"module\";s:4:\"date\";}s:28:\"entityreference_autocomplete\";a:5:{s:5:\"label\";s:12:\"Autocomplete\";s:11:\"description\";s:27:\"An autocomplete text field.\";s:11:\"field types\";a:1:{i:0;s:15:\"entityreference\";}s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:4:\"path\";s:0:\"\";}s:6:\"module\";s:15:\"entityreference\";}s:33:\"entityreference_autocomplete_tags\";a:6:{s:5:\"label\";s:25:\"Autocomplete (Tags style)\";s:11:\"description\";s:27:\"An autocomplete text field.\";s:11:\"field types\";a:1:{i:0;s:15:\"entityreference\";}s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:4:\"path\";s:0:\"\";}s:9:\"behaviors\";a:1:{s:15:\"multiple values\";i:4;}s:6:\"module\";s:15:\"entityreference\";}s:27:\"node_reference_autocomplete\";a:5:{s:5:\"label\";s:23:\"Autocomplete text field\";s:11:\"description\";s:83:\"Display the list of referenceable nodes as a textfield with autocomplete behaviour.\";s:11:\"field types\";a:1:{i:0;s:14:\"node_reference\";}s:8:\"settings\";a:3:{s:18:\"autocomplete_match\";s:8:\"contains\";s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:27:\"node_reference/autocomplete\";}s:6:\"module\";s:14:\"node_reference\";}s:6:\"number\";a:4:{s:5:\"label\";s:10:\"Text field\";s:11:\"field types\";a:3:{i:0;s:14:\"number_integer\";i:1;s:14:\"number_decimal\";i:2;s:12:\"number_float\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:6:\"number\";}s:14:\"options_select\";a:5:{s:5:\"label\";s:11:\"Select list\";s:11:\"field types\";a:7:{i:0;s:15:\"entityreference\";i:1;s:12:\"list_integer\";i:2;s:10:\"list_float\";i:3;s:9:\"list_text\";i:4;s:14:\"node_reference\";i:5;s:23:\"taxonomy_term_reference\";i:6;s:14:\"user_reference\";}s:9:\"behaviors\";a:1:{s:15:\"multiple values\";i:4;}s:8:\"settings\";a:0:{}s:6:\"module\";s:7:\"options\";}s:15:\"options_buttons\";a:5:{s:5:\"label\";s:25:\"Check boxes/radio buttons\";s:11:\"field types\";a:8:{i:0;s:15:\"entityreference\";i:1;s:12:\"list_integer\";i:2;s:10:\"list_float\";i:3;s:9:\"list_text\";i:4;s:12:\"list_boolean\";i:5;s:14:\"node_reference\";i:6;s:23:\"taxonomy_term_reference\";i:7;s:14:\"user_reference\";}s:9:\"behaviors\";a:1:{s:15:\"multiple values\";i:4;}s:8:\"settings\";a:0:{}s:6:\"module\";s:7:\"options\";}s:13:\"options_onoff\";a:5:{s:5:\"label\";s:22:\"Single on/off checkbox\";s:11:\"field types\";a:1:{i:0;s:12:\"list_boolean\";}s:9:\"behaviors\";a:1:{s:15:\"multiple values\";i:4;}s:8:\"settings\";a:1:{s:13:\"display_label\";i:0;}s:6:\"module\";s:7:\"options\";}s:14:\"password_field\";a:4:{s:5:\"label\";s:8:\"Password\";s:11:\"field types\";a:1:{i:0;s:14:\"password_field\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"password_field\";}s:21:\"taxonomy_autocomplete\";a:5:{s:5:\"label\";s:34:\"Autocomplete term widget (tagging)\";s:11:\"field types\";a:1:{i:0;s:23:\"taxonomy_term_reference\";}s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:21:\"taxonomy/autocomplete\";}s:9:\"behaviors\";a:1:{s:15:\"multiple values\";i:4;}s:6:\"module\";s:8:\"taxonomy\";}s:14:\"text_textfield\";a:4:{s:5:\"label\";s:10:\"Text field\";s:11:\"field types\";a:1:{i:0;s:4:\"text\";}s:8:\"settings\";a:1:{s:4:\"size\";i:60;}s:6:\"module\";s:4:\"text\";}s:13:\"text_textarea\";a:4:{s:5:\"label\";s:25:\"Text area (multiple rows)\";s:11:\"field types\";a:1:{i:0;s:9:\"text_long\";}s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"module\";s:4:\"text\";}s:26:\"text_textarea_with_summary\";a:4:{s:5:\"label\";s:24:\"Text area with a summary\";s:11:\"field types\";a:1:{i:0;s:17:\"text_with_summary\";}s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"module\";s:4:\"text\";}s:27:\"user_reference_autocomplete\";a:5:{s:5:\"label\";s:23:\"Autocomplete text field\";s:11:\"description\";s:83:\"Display the list of referenceable users as a textfield with autocomplete behaviour.\";s:11:\"field types\";a:1:{i:0;s:14:\"user_reference\";}s:8:\"settings\";a:3:{s:18:\"autocomplete_match\";s:8:\"contains\";s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:27:\"user_reference/autocomplete\";}s:6:\"module\";s:14:\"user_reference\";}}s:15:\"formatter types\";a:33:{s:26:\"computed_field_unsanitized\";a:4:{s:5:\"label\";s:11:\"Unsanitized\";s:11:\"field types\";a:1:{i:0;s:8:\"computed\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"computed_field\";}s:20:\"computed_field_plain\";a:4:{s:5:\"label\";s:10:\"Plain text\";s:11:\"field types\";a:1:{i:0;s:8:\"computed\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"computed_field\";}s:21:\"computed_field_markup\";a:4:{s:5:\"label\";s:15:\"Filtered markup\";s:11:\"field types\";a:1:{i:0;s:8:\"computed\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"computed_field\";}s:29:\"computed_field_computed_value\";a:4:{s:5:\"label\";s:26:\"Raw value, no display code\";s:11:\"field types\";a:1:{i:0;s:8:\"computed\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"computed_field\";}s:12:\"date_default\";a:4:{s:5:\"label\";s:13:\"Date and time\";s:11:\"field types\";a:3:{i:0;s:4:\"date\";i:1;s:9:\"datestamp\";i:2;s:8:\"datetime\";}s:8:\"settings\";a:5:{s:11:\"format_type\";s:4:\"long\";s:15:\"multiple_number\";s:0:\"\";s:13:\"multiple_from\";s:0:\"\";s:11:\"multiple_to\";s:0:\"\";s:6:\"fromto\";s:4:\"both\";}s:6:\"module\";s:4:\"date\";}s:15:\"format_interval\";a:4:{s:5:\"label\";s:8:\"Time ago\";s:11:\"field types\";a:3:{i:0;s:4:\"date\";i:1;s:9:\"datestamp\";i:2;s:8:\"datetime\";}s:8:\"settings\";a:2:{s:8:\"interval\";i:2;s:16:\"interval_display\";s:8:\"time ago\";}s:6:\"module\";s:4:\"date\";}s:10:\"date_plain\";a:4:{s:5:\"label\";s:5:\"Plain\";s:11:\"field types\";a:3:{i:0;s:4:\"date\";i:1;s:9:\"datestamp\";i:2;s:8:\"datetime\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"date\";}s:21:\"entityreference_label\";a:5:{s:5:\"label\";s:5:\"Label\";s:11:\"description\";s:45:\"Display the label of the referenced entities.\";s:11:\"field types\";a:1:{i:0;s:15:\"entityreference\";}s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:6:\"module\";s:15:\"entityreference\";}s:25:\"entityreference_entity_id\";a:5:{s:5:\"label\";s:9:\"Entity id\";s:11:\"description\";s:42:\"Display the id of the referenced entities.\";s:11:\"field types\";a:1:{i:0;s:15:\"entityreference\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:15:\"entityreference\";}s:27:\"entityreference_entity_view\";a:5:{s:5:\"label\";s:15:\"Rendered entity\";s:11:\"description\";s:58:\"Display the referenced entities rendered by entity_view().\";s:11:\"field types\";a:1:{i:0;s:15:\"entityreference\";}s:8:\"settings\";a:2:{s:9:\"view_mode\";s:0:\"\";s:5:\"links\";b:1;}s:6:\"module\";s:15:\"entityreference\";}s:12:\"list_default\";a:4:{s:5:\"label\";s:7:\"Default\";s:11:\"field types\";a:4:{i:0;s:12:\"list_integer\";i:1;s:10:\"list_float\";i:2;s:9:\"list_text\";i:3;s:12:\"list_boolean\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";}s:8:\"list_key\";a:4:{s:5:\"label\";s:3:\"Key\";s:11:\"field types\";a:4:{i:0;s:12:\"list_integer\";i:1;s:10:\"list_float\";i:2;s:9:\"list_text\";i:3;s:12:\"list_boolean\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";}s:22:\"node_reference_default\";a:5:{s:5:\"label\";s:12:\"Title (link)\";s:11:\"description\";s:68:\"Display the title of the referenced node as a link to the node page.\";s:11:\"field types\";a:1:{i:0;s:14:\"node_reference\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"node_reference\";}s:20:\"node_reference_plain\";a:5:{s:5:\"label\";s:15:\"Title (no link)\";s:11:\"description\";s:55:\"Display the title of the referenced node as plain text.\";s:11:\"field types\";a:1:{i:0;s:14:\"node_reference\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"node_reference\";}s:19:\"node_reference_node\";a:5:{s:5:\"label\";s:13:\"Rendered node\";s:11:\"description\";s:51:\"Display the referenced node in a specific view mode\";s:11:\"field types\";a:1:{i:0;s:14:\"node_reference\";}s:8:\"settings\";a:1:{s:24:\"node_reference_view_mode\";s:4:\"full\";}s:6:\"module\";s:14:\"node_reference\";}s:18:\"node_reference_nid\";a:5:{s:5:\"label\";s:7:\"Node ID\";s:11:\"description\";s:30:\"Display the referenced node ID\";s:11:\"field types\";a:1:{i:0;s:14:\"node_reference\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"node_reference\";}s:19:\"node_reference_path\";a:5:{s:5:\"label\";s:17:\"URL as plain text\";s:11:\"description\";s:38:\"Display the URL of the referenced node\";s:11:\"field types\";a:1:{i:0;s:14:\"node_reference\";}s:8:\"settings\";a:2:{s:5:\"alias\";b:1;s:8:\"absolute\";b:0;}s:6:\"module\";s:14:\"node_reference\";}s:14:\"number_integer\";a:4:{s:5:\"label\";s:7:\"Default\";s:11:\"field types\";a:1:{i:0;s:14:\"number_integer\";}s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}s:14:\"number_decimal\";a:4:{s:5:\"label\";s:7:\"Default\";s:11:\"field types\";a:2:{i:0;s:14:\"number_decimal\";i:1;s:12:\"number_float\";}s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}s:18:\"number_unformatted\";a:4:{s:5:\"label\";s:11:\"Unformatted\";s:11:\"field types\";a:3:{i:0;s:14:\"number_integer\";i:1;s:14:\"number_decimal\";i:2;s:12:\"number_float\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:6:\"number\";}s:24:\"password_field_formatter\";a:4:{s:5:\"label\";s:24:\"Password field formatter\";s:11:\"field types\";a:1:{i:0;s:14:\"password_field\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"password_field\";}s:28:\"taxonomy_term_reference_link\";a:4:{s:5:\"label\";s:4:\"Link\";s:11:\"field types\";a:1:{i:0;s:23:\"taxonomy_term_reference\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}s:29:\"taxonomy_term_reference_plain\";a:4:{s:5:\"label\";s:10:\"Plain text\";s:11:\"field types\";a:1:{i:0;s:23:\"taxonomy_term_reference\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}s:36:\"taxonomy_term_reference_rss_category\";a:4:{s:5:\"label\";s:12:\"RSS category\";s:11:\"field types\";a:1:{i:0;s:23:\"taxonomy_term_reference\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}s:12:\"text_default\";a:4:{s:5:\"label\";s:7:\"Default\";s:11:\"field types\";a:3:{i:0;s:4:\"text\";i:1;s:9:\"text_long\";i:2;s:17:\"text_with_summary\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:10:\"text_plain\";a:4:{s:5:\"label\";s:10:\"Plain text\";s:11:\"field types\";a:3:{i:0;s:4:\"text\";i:1;s:9:\"text_long\";i:2;s:17:\"text_with_summary\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:12:\"text_trimmed\";a:4:{s:5:\"label\";s:7:\"Trimmed\";s:11:\"field types\";a:3:{i:0;s:4:\"text\";i:1;s:9:\"text_long\";i:2;s:17:\"text_with_summary\";}s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";}s:23:\"text_summary_or_trimmed\";a:4:{s:5:\"label\";s:18:\"Summary or trimmed\";s:11:\"field types\";a:1:{i:0;s:17:\"text_with_summary\";}s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";}s:22:\"user_reference_default\";a:5:{s:5:\"label\";s:7:\"Default\";s:11:\"description\";s:77:\"Display the name of the referenced user as a link to the user\'s profile page.\";s:11:\"field types\";a:1:{i:0;s:14:\"user_reference\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"user_reference\";}s:20:\"user_reference_plain\";a:5:{s:5:\"label\";s:10:\"Plain text\";s:11:\"description\";s:54:\"Display the name of the referenced user as plain text.\";s:11:\"field types\";a:1:{i:0;s:14:\"user_reference\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"user_reference\";}s:19:\"user_reference_user\";a:5:{s:5:\"label\";s:13:\"Rendered user\";s:11:\"description\";s:51:\"Display the referenced user in a specific view mode\";s:11:\"field types\";a:1:{i:0;s:14:\"user_reference\";}s:8:\"settings\";a:1:{s:24:\"user_reference_view_mode\";s:4:\"full\";}s:6:\"module\";s:14:\"user_reference\";}s:18:\"user_reference_uid\";a:5:{s:5:\"label\";s:7:\"User ID\";s:11:\"description\";s:30:\"Display the referenced user ID\";s:11:\"field types\";a:1:{i:0;s:14:\"user_reference\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"user_reference\";}s:19:\"user_reference_path\";a:5:{s:5:\"label\";s:17:\"URL as plain text\";s:11:\"description\";s:38:\"Display the URL of the referenced user\";s:11:\"field types\";a:1:{i:0;s:14:\"user_reference\";}s:8:\"settings\";a:2:{s:5:\"alias\";b:1;s:8:\"absolute\";b:0;}s:6:\"module\";s:14:\"user_reference\";}}s:13:\"storage types\";a:1:{s:17:\"field_sql_storage\";a:4:{s:5:\"label\";s:19:\"Default SQL storage\";s:11:\"description\";s:64:\"Stores fields in the local SQL database, using per-field tables.\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";}}}',0,1371656313,1),('field_info_fields','a:4:{s:6:\"fields\";a:142:{i:1;a:17:{s:12:\"entity_types\";a:1:{i:0;s:7:\"comment\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:23:\"field_data_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:27:\"field_revision_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"1\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:12:\"comment_body\";s:4:\"type\";s:9:\"text_long\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:7:\"comment\";a:12:{i:0;s:17:\"comment_node_page\";i:1;s:20:\"comment_node_article\";i:2;s:20:\"comment_node_vcenter\";i:3;s:24:\"comment_node_data_center\";i:4;s:28:\"comment_node_virtual_machine\";i:5;s:17:\"comment_node_host\";i:6;s:19:\"comment_node_device\";i:7;s:18:\"comment_node_vdisk\";i:8;s:18:\"comment_node_panel\";i:9;s:23:\"comment_node_vm_metrics\";i:10;s:26:\"comment_node_vdisk_metrics\";i:11;s:27:\"comment_node_vm_cache_space\";}}}i:2;a:17:{s:12:\"entity_types\";a:1:{i:0;s:4:\"node\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:15:\"field_data_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:19:\"field_revision_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"2\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:4:\"body\";s:4:\"type\";s:17:\"text_with_summary\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:3:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:7:\"summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:4:{i:0;s:4:\"page\";i:1;s:7:\"article\";i:2;s:7:\"vcenter\";i:3;s:11:\"data_center\";}}}i:3;a:17:{s:8:\"settings\";a:1:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:4:\"tags\";s:6:\"parent\";i:0;}}}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_tags\";a:1:{s:3:\"tid\";s:14:\"field_tags_tid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_tags\";a:1:{s:3:\"tid\";s:14:\"field_tags_tid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:2:\"id\";s:1:\"3\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:10:\"field_tags\";s:4:\"type\";s:23:\"taxonomy_term_reference\";s:6:\"module\";s:8:\"taxonomy\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:2:\"-1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:3:\"tid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:7:\"article\";}}}i:5;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_ip_address\";a:2:{s:5:\"value\";s:22:\"field_ip_address_value\";s:6:\"format\";s:23:\"field_ip_address_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_ip_address\";a:2:{s:5:\"value\";s:22:\"field_ip_address_value\";s:6:\"format\";s:23:\"field_ip_address_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"5\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:16:\"field_ip_address\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:7:\"vcenter\";}}}i:6;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_username\";a:2:{s:5:\"value\";s:20:\"field_username_value\";s:6:\"format\";s:21:\"field_username_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_username\";a:2:{s:5:\"value\";s:20:\"field_username_value\";s:6:\"format\";s:21:\"field_username_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"6\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:14:\"field_username\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:7:\"vcenter\";}}}i:7;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_password\";a:2:{s:5:\"value\";s:20:\"field_password_value\";s:6:\"format\";s:21:\"field_password_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_password\";a:2:{s:5:\"value\";s:20:\"field_password_value\";s:6:\"format\";s:21:\"field_password_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"7\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:14:\"field_password\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:7:\"vcenter\";}}}i:9;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_vm_ip_address\";a:2:{s:5:\"value\";s:25:\"field_vm_ip_address_value\";s:6:\"format\";s:26:\"field_vm_ip_address_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_vm_ip_address\";a:2:{s:5:\"value\";s:25:\"field_vm_ip_address_value\";s:6:\"format\";s:26:\"field_vm_ip_address_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"9\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:19:\"field_vm_ip_address\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:11;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_memory_size\";a:2:{s:5:\"value\";s:23:\"field_memory_size_value\";s:6:\"format\";s:24:\"field_memory_size_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_memory_size\";a:2:{s:5:\"value\";s:23:\"field_memory_size_value\";s:6:\"format\";s:24:\"field_memory_size_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"11\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:17:\"field_memory_size\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:13;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_template\";a:2:{s:5:\"value\";s:20:\"field_template_value\";s:6:\"format\";s:21:\"field_template_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_template\";a:2:{s:5:\"value\";s:20:\"field_template_value\";s:6:\"format\";s:21:\"field_template_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"13\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:14:\"field_template\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:14;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:29:\"field_data_field_vm_path_name\";a:2:{s:5:\"value\";s:24:\"field_vm_path_name_value\";s:6:\"format\";s:25:\"field_vm_path_name_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:33:\"field_revision_field_vm_path_name\";a:2:{s:5:\"value\";s:24:\"field_vm_path_name_value\";s:6:\"format\";s:25:\"field_vm_path_name_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"14\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:18:\"field_vm_path_name\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:15;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_guest_os\";a:2:{s:5:\"value\";s:20:\"field_guest_os_value\";s:6:\"format\";s:21:\"field_guest_os_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_guest_os\";a:2:{s:5:\"value\";s:20:\"field_guest_os_value\";s:6:\"format\";s:21:\"field_guest_os_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"15\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:14:\"field_guest_os\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:16;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_guest_id\";a:2:{s:5:\"value\";s:20:\"field_guest_id_value\";s:6:\"format\";s:21:\"field_guest_id_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_guest_id\";a:2:{s:5:\"value\";s:20:\"field_guest_id_value\";s:6:\"format\";s:21:\"field_guest_id_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"16\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:14:\"field_guest_id\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:18;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:26:\"field_data_field_cpu_usage\";a:2:{s:5:\"value\";s:21:\"field_cpu_usage_value\";s:6:\"format\";s:22:\"field_cpu_usage_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:30:\"field_revision_field_cpu_usage\";a:2:{s:5:\"value\";s:21:\"field_cpu_usage_value\";s:6:\"format\";s:22:\"field_cpu_usage_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"18\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:15:\"field_cpu_usage\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:2:{i:0;s:15:\"virtual_machine\";i:1;s:4:\"host\";}}}i:19;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:34:\"field_data_field_host_memory_usage\";a:2:{s:5:\"value\";s:29:\"field_host_memory_usage_value\";s:6:\"format\";s:30:\"field_host_memory_usage_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:38:\"field_revision_field_host_memory_usage\";a:2:{s:5:\"value\";s:29:\"field_host_memory_usage_value\";s:6:\"format\";s:30:\"field_host_memory_usage_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"19\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:23:\"field_host_memory_usage\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:20;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:35:\"field_data_field_guest_memory_usage\";a:2:{s:5:\"value\";s:30:\"field_guest_memory_usage_value\";s:6:\"format\";s:31:\"field_guest_memory_usage_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:39:\"field_revision_field_guest_memory_usage\";a:2:{s:5:\"value\";s:30:\"field_guest_memory_usage_value\";s:6:\"format\";s:31:\"field_guest_memory_usage_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"20\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:24:\"field_guest_memory_usage\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:21;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:26:\"field_data_field_cpu_model\";a:2:{s:5:\"value\";s:21:\"field_cpu_model_value\";s:6:\"format\";s:22:\"field_cpu_model_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:30:\"field_revision_field_cpu_model\";a:2:{s:5:\"value\";s:21:\"field_cpu_model_value\";s:6:\"format\";s:22:\"field_cpu_model_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"21\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:15:\"field_cpu_model\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:22;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_boottime\";a:2:{s:5:\"value\";s:20:\"field_boottime_value\";s:6:\"format\";s:21:\"field_boottime_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_boottime\";a:2:{s:5:\"value\";s:20:\"field_boottime_value\";s:6:\"format\";s:21:\"field_boottime_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"22\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:14:\"field_boottime\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:23;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_host_status\";a:2:{s:5:\"value\";s:23:\"field_host_status_value\";s:6:\"format\";s:24:\"field_host_status_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_host_status\";a:2:{s:5:\"value\";s:23:\"field_host_status_value\";s:6:\"format\";s:24:\"field_host_status_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"23\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:17:\"field_host_status\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:24;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_maintenance_mode\";a:1:{s:5:\"value\";s:28:\"field_maintenance_mode_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_maintenance_mode\";a:1:{s:5:\"value\";s:28:\"field_maintenance_mode_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"24\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:22:\"field_maintenance_mode\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:25;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:32:\"field_data_field_physical_memory\";a:2:{s:5:\"value\";s:27:\"field_physical_memory_value\";s:6:\"format\";s:28:\"field_physical_memory_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:36:\"field_revision_field_physical_memory\";a:2:{s:5:\"value\";s:27:\"field_physical_memory_value\";s:6:\"format\";s:28:\"field_physical_memory_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"25\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:21:\"field_physical_memory\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:26;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:24:\"field_data_field_vmotion\";a:1:{s:5:\"value\";s:19:\"field_vmotion_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:28:\"field_revision_field_vmotion\";a:1:{s:5:\"value\";s:19:\"field_vmotion_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"26\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:13:\"field_vmotion\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:27;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:32:\"field_data_field_reboot_required\";a:1:{s:5:\"value\";s:27:\"field_reboot_required_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:36:\"field_revision_field_reboot_required\";a:1:{s:5:\"value\";s:27:\"field_reboot_required_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"27\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:21:\"field_reboot_required\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:31;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:26:\"field_data_field_serial_no\";a:2:{s:5:\"value\";s:21:\"field_serial_no_value\";s:6:\"format\";s:22:\"field_serial_no_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:30:\"field_revision_field_serial_no\";a:2:{s:5:\"value\";s:21:\"field_serial_no_value\";s:6:\"format\";s:22:\"field_serial_no_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"31\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:15:\"field_serial_no\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:32;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_size\";a:2:{s:5:\"value\";s:16:\"field_size_value\";s:6:\"format\";s:17:\"field_size_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_size\";a:2:{s:5:\"value\";s:16:\"field_size_value\";s:6:\"format\";s:17:\"field_size_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"32\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:10:\"field_size\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:33;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_device_type\";a:2:{s:5:\"value\";s:23:\"field_device_type_value\";s:6:\"format\";s:24:\"field_device_type_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_device_type\";a:2:{s:5:\"value\";s:23:\"field_device_type_value\";s:6:\"format\";s:24:\"field_device_type_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"33\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:17:\"field_device_type\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:34;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_multipath_plugin\";a:2:{s:5:\"value\";s:28:\"field_multipath_plugin_value\";s:6:\"format\";s:29:\"field_multipath_plugin_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_multipath_plugin\";a:2:{s:5:\"value\";s:28:\"field_multipath_plugin_value\";s:6:\"format\";s:29:\"field_multipath_plugin_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"34\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:22:\"field_multipath_plugin\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:35;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_devfs_path\";a:2:{s:5:\"value\";s:22:\"field_devfs_path_value\";s:6:\"format\";s:23:\"field_devfs_path_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_devfs_path\";a:2:{s:5:\"value\";s:22:\"field_devfs_path_value\";s:6:\"format\";s:23:\"field_devfs_path_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"35\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:16:\"field_devfs_path\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:36;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:23:\"field_data_field_vendor\";a:2:{s:5:\"value\";s:18:\"field_vendor_value\";s:6:\"format\";s:19:\"field_vendor_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:27:\"field_revision_field_vendor\";a:2:{s:5:\"value\";s:18:\"field_vendor_value\";s:6:\"format\";s:19:\"field_vendor_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"36\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:12:\"field_vendor\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:37;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:22:\"field_data_field_model\";a:2:{s:5:\"value\";s:17:\"field_model_value\";s:6:\"format\";s:18:\"field_model_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:26:\"field_revision_field_model\";a:2:{s:5:\"value\";s:17:\"field_model_value\";s:6:\"format\";s:18:\"field_model_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"37\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:11:\"field_model\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:38;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_revision\";a:2:{s:5:\"value\";s:20:\"field_revision_value\";s:6:\"format\";s:21:\"field_revision_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_revision\";a:2:{s:5:\"value\";s:20:\"field_revision_value\";s:6:\"format\";s:21:\"field_revision_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"38\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:14:\"field_revision\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:39;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_scsi_level\";a:2:{s:5:\"value\";s:22:\"field_scsi_level_value\";s:6:\"format\";s:23:\"field_scsi_level_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_scsi_level\";a:2:{s:5:\"value\";s:22:\"field_scsi_level_value\";s:6:\"format\";s:23:\"field_scsi_level_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"39\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:16:\"field_scsi_level\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:40;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{s:4:\"true\";s:4:\"True\";s:5:\"false\";s:5:\"False\";}s:23:\"allowed_values_function\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:26:\"field_data_field_is_pseudo\";a:1:{s:5:\"value\";s:21:\"field_is_pseudo_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:30:\"field_revision_field_is_pseudo\";a:1:{s:5:\"value\";s:21:\"field_is_pseudo_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:2:\"id\";s:2:\"40\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:15:\"field_is_pseudo\";s:4:\"type\";s:9:\"list_text\";s:6:\"module\";s:4:\"list\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:41;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:3:{s:2:\"on\";s:2:\"On\";s:3:\"off\";s:3:\"Off\";s:8:\"degraded\";s:8:\"Degraded\";}s:23:\"allowed_values_function\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:23:\"field_data_field_status\";a:1:{s:5:\"value\";s:18:\"field_status_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:27:\"field_revision_field_status\";a:1:{s:5:\"value\";s:18:\"field_status_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:2:\"id\";s:2:\"41\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:12:\"field_status\";s:4:\"type\";s:9:\"list_text\";s:6:\"module\";s:4:\"list\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:42;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{s:4:\"true\";s:4:\"True\";s:5:\"false\";s:5:\"False\";}s:23:\"allowed_values_function\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:31:\"field_data_field_is_rdm_capable\";a:1:{s:5:\"value\";s:26:\"field_is_rdm_capable_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:35:\"field_revision_field_is_rdm_capable\";a:1:{s:5:\"value\";s:26:\"field_is_rdm_capable_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:2:\"id\";s:2:\"42\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:20:\"field_is_rdm_capable\";s:4:\"type\";s:9:\"list_text\";s:6:\"module\";s:4:\"list\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:43;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{s:4:\"true\";s:4:\"True\";s:5:\"false\";s:5:\"False\";}s:23:\"allowed_values_function\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_is_local\";a:1:{s:5:\"value\";s:20:\"field_is_local_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_is_local\";a:1:{s:5:\"value\";s:20:\"field_is_local_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:2:\"id\";s:2:\"43\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:14:\"field_is_local\";s:4:\"type\";s:9:\"list_text\";s:6:\"module\";s:4:\"list\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:44;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{s:4:\"true\";s:4:\"True\";s:5:\"false\";s:5:\"False\";}s:23:\"allowed_values_function\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:29:\"field_data_field_is_removable\";a:1:{s:5:\"value\";s:24:\"field_is_removable_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:33:\"field_revision_field_is_removable\";a:1:{s:5:\"value\";s:24:\"field_is_removable_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:2:\"id\";s:2:\"44\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:18:\"field_is_removable\";s:4:\"type\";s:9:\"list_text\";s:6:\"module\";s:4:\"list\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:45;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{s:4:\"true\";s:4:\"True\";s:5:\"false\";s:5:\"False\";}s:23:\"allowed_values_function\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:23:\"field_data_field_is_ssd\";a:1:{s:5:\"value\";s:18:\"field_is_ssd_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:27:\"field_revision_field_is_ssd\";a:1:{s:5:\"value\";s:18:\"field_is_ssd_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:2:\"id\";s:2:\"45\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:12:\"field_is_ssd\";s:4:\"type\";s:9:\"list_text\";s:6:\"module\";s:4:\"list\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:46;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{s:4:\"true\";s:4:\"True\";s:5:\"false\";s:5:\"False\";}s:23:\"allowed_values_function\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_is_offline\";a:1:{s:5:\"value\";s:22:\"field_is_offline_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_is_offline\";a:1:{s:5:\"value\";s:22:\"field_is_offline_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:2:\"id\";s:2:\"46\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:16:\"field_is_offline\";s:4:\"type\";s:9:\"list_text\";s:6:\"module\";s:4:\"list\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:47;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{s:4:\"true\";s:4:\"True\";s:5:\"false\";s:5:\"False\";}s:23:\"allowed_values_function\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:40:\"field_data_field_is_perennially_reserved\";a:1:{s:5:\"value\";s:35:\"field_is_perennially_reserved_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:44:\"field_revision_field_is_perennially_reserved\";a:1:{s:5:\"value\";s:35:\"field_is_perennially_reserved_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:2:\"id\";s:2:\"47\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:29:\"field_is_perennially_reserved\";s:4:\"type\";s:9:\"list_text\";s:6:\"module\";s:4:\"list\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:48;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:41:\"field_data_field_thin_provisioning_status\";a:2:{s:5:\"value\";s:36:\"field_thin_provisioning_status_value\";s:6:\"format\";s:37:\"field_thin_provisioning_status_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:45:\"field_revision_field_thin_provisioning_status\";a:2:{s:5:\"value\";s:36:\"field_thin_provisioning_status_value\";s:6:\"format\";s:37:\"field_thin_provisioning_status_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"48\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:30:\"field_thin_provisioning_status\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:49;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_attached_filters\";a:2:{s:5:\"value\";s:28:\"field_attached_filters_value\";s:6:\"format\";s:29:\"field_attached_filters_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_attached_filters\";a:2:{s:5:\"value\";s:28:\"field_attached_filters_value\";s:6:\"format\";s:29:\"field_attached_filters_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"49\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:22:\"field_attached_filters\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:50;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_vaai_status\";a:2:{s:5:\"value\";s:23:\"field_vaai_status_value\";s:6:\"format\";s:24:\"field_vaai_status_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_vaai_status\";a:2:{s:5:\"value\";s:23:\"field_vaai_status_value\";s:6:\"format\";s:24:\"field_vaai_status_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"50\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:17:\"field_vaai_status\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:51;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_other_uids\";a:2:{s:5:\"value\";s:22:\"field_other_uids_value\";s:6:\"format\";s:23:\"field_other_uids_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_other_uids\";a:2:{s:5:\"value\";s:22:\"field_other_uids_value\";s:6:\"format\";s:23:\"field_other_uids_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"51\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:16:\"field_other_uids\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:52;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:29:\"field_data_field_display_name\";a:2:{s:5:\"value\";s:24:\"field_display_name_value\";s:6:\"format\";s:25:\"field_display_name_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:33:\"field_revision_field_display_name\";a:2:{s:5:\"value\";s:24:\"field_display_name_value\";s:6:\"format\";s:25:\"field_display_name_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"52\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:18:\"field_display_name\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:53;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_capacity\";a:2:{s:5:\"value\";s:20:\"field_capacity_value\";s:6:\"format\";s:21:\"field_capacity_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_capacity\";a:2:{s:5:\"value\";s:20:\"field_capacity_value\";s:6:\"format\";s:21:\"field_capacity_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"53\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:14:\"field_capacity\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:5:\"vdisk\";}}}i:54;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_path\";a:2:{s:5:\"value\";s:16:\"field_path_value\";s:6:\"format\";s:17:\"field_path_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_path\";a:2:{s:5:\"value\";s:16:\"field_path_value\";s:6:\"format\";s:17:\"field_path_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"54\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:10:\"field_path\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:5:\"vdisk\";}}}i:55;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:26:\"field_data_field_freespace\";a:2:{s:5:\"value\";s:21:\"field_freespace_value\";s:6:\"format\";s:22:\"field_freespace_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:30:\"field_revision_field_freespace\";a:2:{s:5:\"value\";s:21:\"field_freespace_value\";s:6:\"format\";s:22:\"field_freespace_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"55\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:15:\"field_freespace\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:5:\"vdisk\";}}}i:56;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_vm_username\";a:2:{s:5:\"value\";s:23:\"field_vm_username_value\";s:6:\"format\";s:24:\"field_vm_username_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_vm_username\";a:2:{s:5:\"value\";s:23:\"field_vm_username_value\";s:6:\"format\";s:24:\"field_vm_username_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"56\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:17:\"field_vm_username\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:57;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_vm_password\";a:2:{s:5:\"value\";s:23:\"field_vm_password_value\";s:6:\"format\";s:24:\"field_vm_password_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_vm_password\";a:2:{s:5:\"value\";s:23:\"field_vm_password_value\";s:6:\"format\";s:24:\"field_vm_password_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"57\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:17:\"field_vm_password\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:58;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_host_username\";a:2:{s:5:\"value\";s:25:\"field_host_username_value\";s:6:\"format\";s:26:\"field_host_username_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_host_username\";a:2:{s:5:\"value\";s:25:\"field_host_username_value\";s:6:\"format\";s:26:\"field_host_username_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"58\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:19:\"field_host_username\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:59;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_host_password\";a:2:{s:5:\"value\";s:25:\"field_host_password_value\";s:6:\"format\";s:26:\"field_host_password_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_host_password\";a:2:{s:5:\"value\";s:25:\"field_host_password_value\";s:6:\"format\";s:26:\"field_host_password_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"59\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:19:\"field_host_password\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:60;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_driver_status\";a:2:{s:5:\"value\";s:25:\"field_driver_status_value\";s:6:\"format\";s:26:\"field_driver_status_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_driver_status\";a:2:{s:5:\"value\";s:25:\"field_driver_status_value\";s:6:\"format\";s:26:\"field_driver_status_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"60\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:19:\"field_driver_status\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:61;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_bundle_status\";a:2:{s:5:\"value\";s:25:\"field_bundle_status_value\";s:6:\"format\";s:26:\"field_bundle_status_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_bundle_status\";a:2:{s:5:\"value\";s:25:\"field_bundle_status_value\";s:6:\"format\";s:26:\"field_bundle_status_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"61\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:19:\"field_bundle_status\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:62;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:7:\"vcenter\";s:7:\"vcenter\";}s:4:\"sort\";a:3:{s:4:\"type\";s:8:\"property\";s:8:\"property\";s:5:\"title\";s:9:\"direction\";s:3:\"ASC\";}s:9:\"behaviors\";a:1:{s:17:\"views-select-list\";a:1:{s:6:\"status\";i:0;}}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:32:\"field_data_field_related_vcenter\";a:1:{s:9:\"target_id\";s:31:\"field_related_vcenter_target_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:36:\"field_revision_field_related_vcenter\";a:1:{s:9:\"target_id\";s:31:\"field_related_vcenter_target_id\";}}}}}s:12:\"foreign keys\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:9:\"target_id\";s:3:\"nid\";}}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:2:\"id\";s:2:\"62\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:21:\"field_related_vcenter\";s:4:\"type\";s:15:\"entityreference\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:9:\"target_id\";a:4:{s:11:\"description\";s:28:\"The id of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:11:\"data_center\";}}}i:63;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:15:\"virtual_machine\";s:15:\"virtual_machine\";}s:4:\"sort\";a:1:{s:4:\"type\";s:4:\"none\";}s:9:\"behaviors\";a:1:{s:17:\"views-select-list\";a:1:{s:6:\"status\";i:0;}}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:32:\"field_data_field_virtual_machine\";a:1:{s:9:\"target_id\";s:31:\"field_virtual_machine_target_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:36:\"field_revision_field_virtual_machine\";a:1:{s:9:\"target_id\";s:31:\"field_virtual_machine_target_id\";}}}}}s:12:\"foreign keys\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:9:\"target_id\";s:3:\"nid\";}}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:2:\"id\";s:2:\"63\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:21:\"field_virtual_machine\";s:4:\"type\";s:15:\"entityreference\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:9:\"target_id\";a:4:{s:11:\"description\";s:28:\"The id of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:5:\"vdisk\";}}}i:64;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:4:\"host\";s:4:\"host\";}s:4:\"sort\";a:1:{s:4:\"type\";s:4:\"none\";}s:9:\"behaviors\";a:1:{s:17:\"views-select-list\";a:1:{s:6:\"status\";i:0;}}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:29:\"field_data_field_related_host\";a:1:{s:9:\"target_id\";s:28:\"field_related_host_target_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:33:\"field_revision_field_related_host\";a:1:{s:9:\"target_id\";s:28:\"field_related_host_target_id\";}}}}}s:12:\"foreign keys\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:9:\"target_id\";s:3:\"nid\";}}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:2:\"id\";s:2:\"64\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:18:\"field_related_host\";s:4:\"type\";s:15:\"entityreference\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:9:\"target_id\";a:4:{s:11:\"description\";s:28:\"The id of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:65;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:11:\"data_center\";s:11:\"data_center\";}s:4:\"sort\";a:1:{s:4:\"type\";s:4:\"none\";}s:9:\"behaviors\";a:1:{s:17:\"views-select-list\";a:1:{s:6:\"status\";i:0;}}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_datacenter\";a:1:{s:9:\"target_id\";s:26:\"field_datacenter_target_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_datacenter\";a:1:{s:9:\"target_id\";s:26:\"field_datacenter_target_id\";}}}}}s:12:\"foreign keys\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:9:\"target_id\";s:3:\"nid\";}}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:2:\"id\";s:2:\"65\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:16:\"field_datacenter\";s:4:\"type\";s:15:\"entityreference\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:9:\"target_id\";a:4:{s:11:\"description\";s:28:\"The id of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:66;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:4:\"host\";s:4:\"host\";}s:4:\"sort\";a:1:{s:4:\"type\";s:4:\"none\";}s:9:\"behaviors\";a:1:{s:17:\"views-select-list\";a:1:{s:6:\"status\";i:0;}}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_host\";a:1:{s:9:\"target_id\";s:20:\"field_host_target_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_host\";a:1:{s:9:\"target_id\";s:20:\"field_host_target_id\";}}}}}s:12:\"foreign keys\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:9:\"target_id\";s:3:\"nid\";}}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:2:\"id\";s:2:\"66\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:10:\"field_host\";s:4:\"type\";s:15:\"entityreference\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:9:\"target_id\";a:4:{s:11:\"description\";s:28:\"The id of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:67;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:29:\"field_data_field_vmware_tools\";a:2:{s:5:\"value\";s:24:\"field_vmware_tools_value\";s:6:\"format\";s:25:\"field_vmware_tools_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:33:\"field_revision_field_vmware_tools\";a:2:{s:5:\"value\";s:24:\"field_vmware_tools_value\";s:6:\"format\";s:25:\"field_vmware_tools_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"67\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:18:\"field_vmware_tools\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:68;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_software_on_host\";a:2:{s:5:\"value\";s:28:\"field_software_on_host_value\";s:6:\"format\";s:29:\"field_software_on_host_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_software_on_host\";a:2:{s:5:\"value\";s:28:\"field_software_on_host_value\";s:6:\"format\";s:29:\"field_software_on_host_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"68\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:22:\"field_software_on_host\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:69;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:15:\"virtual_machine\";s:15:\"virtual_machine\";}s:4:\"sort\";a:1:{s:4:\"type\";s:4:\"none\";}s:9:\"behaviors\";a:1:{s:17:\"views-select-list\";a:1:{s:6:\"status\";i:0;}}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:19:\"field_data_field_vm\";a:1:{s:9:\"target_id\";s:18:\"field_vm_target_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:23:\"field_revision_field_vm\";a:1:{s:9:\"target_id\";s:18:\"field_vm_target_id\";}}}}}s:12:\"foreign keys\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:9:\"target_id\";s:3:\"nid\";}}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:2:\"id\";s:2:\"69\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:8:\"field_vm\";s:4:\"type\";s:15:\"entityreference\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:9:\"target_id\";a:4:{s:11:\"description\";s:28:\"The id of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:10:\"vm_metrics\";}}}i:70;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:35:\"field_data_field_allocated_segments\";a:1:{s:5:\"value\";s:30:\"field_allocated_segments_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:39:\"field_revision_field_allocated_segments\";a:1:{s:5:\"value\";s:30:\"field_allocated_segments_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"70\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:24:\"field_allocated_segments\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:71;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:29:\"field_data_field_segment_size\";a:1:{s:5:\"value\";s:24:\"field_segment_size_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:33:\"field_revision_field_segment_size\";a:1:{s:5:\"value\";s:24:\"field_segment_size_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"71\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:18:\"field_segment_size\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:72;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:37:\"field_data_field_max_virtual_machines\";a:1:{s:5:\"value\";s:32:\"field_max_virtual_machines_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:41:\"field_revision_field_max_virtual_machines\";a:1:{s:5:\"value\";s:32:\"field_max_virtual_machines_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"72\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:26:\"field_max_virtual_machines\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:73;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:37:\"field_data_field_max_physical_devices\";a:1:{s:5:\"value\";s:32:\"field_max_physical_devices_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:41:\"field_revision_field_max_physical_devices\";a:1:{s:5:\"value\";s:32:\"field_max_physical_devices_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"73\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:26:\"field_max_physical_devices\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:74;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:41:\"field_data_field_claimed_physical_devices\";a:1:{s:5:\"value\";s:36:\"field_claimed_physical_devices_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:45:\"field_revision_field_claimed_physical_devices\";a:1:{s:5:\"value\";s:36:\"field_claimed_physical_devices_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"74\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:30:\"field_claimed_physical_devices\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:75;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_cache_state\";a:1:{s:5:\"value\";s:23:\"field_cache_state_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_cache_state\";a:1:{s:5:\"value\";s:23:\"field_cache_state_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"75\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:17:\"field_cache_state\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:76;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:31:\"field_data_field_total_segments\";a:1:{s:5:\"value\";s:26:\"field_total_segments_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:35:\"field_revision_field_total_segments\";a:1:{s:5:\"value\";s:26:\"field_total_segments_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"76\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:20:\"field_total_segments\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:77;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:43:\"field_data_field_allocated_virtual_machines\";a:1:{s:5:\"value\";s:38:\"field_allocated_virtual_machines_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:47:\"field_revision_field_allocated_virtual_machines\";a:1:{s:5:\"value\";s:38:\"field_allocated_virtual_machines_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"77\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:32:\"field_allocated_virtual_machines\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:78;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_vib_version\";a:2:{s:5:\"value\";s:23:\"field_vib_version_value\";s:6:\"format\";s:24:\"field_vib_version_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_vib_version\";a:2:{s:5:\"value\";s:23:\"field_vib_version_value\";s:6:\"format\";s:24:\"field_vib_version_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"78\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:17:\"field_vib_version\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:79;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_total_size\";a:2:{s:5:\"value\";s:22:\"field_total_size_value\";s:6:\"format\";s:23:\"field_total_size_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_total_size\";a:2:{s:5:\"value\";s:22:\"field_total_size_value\";s:6:\"format\";s:23:\"field_total_size_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"79\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:16:\"field_total_size\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:80;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:31:\"field_data_field_naa_identifier\";a:2:{s:5:\"value\";s:26:\"field_naa_identifier_value\";s:6:\"format\";s:27:\"field_naa_identifier_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:35:\"field_revision_field_naa_identifier\";a:2:{s:5:\"value\";s:26:\"field_naa_identifier_value\";s:6:\"format\";s:27:\"field_naa_identifier_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"80\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:20:\"field_naa_identifier\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:81;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:31:\"field_data_field_allocated_size\";a:2:{s:5:\"value\";s:26:\"field_allocated_size_value\";s:6:\"format\";s:27:\"field_allocated_size_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:35:\"field_revision_field_allocated_size\";a:2:{s:5:\"value\";s:26:\"field_allocated_size_value\";s:6:\"format\";s:27:\"field_allocated_size_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"81\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:20:\"field_allocated_size\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:82;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:29:\"field_data_field_device_state\";a:1:{s:5:\"value\";s:24:\"field_device_state_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:33:\"field_revision_field_device_state\";a:1:{s:5:\"value\";s:24:\"field_device_state_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"82\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:18:\"field_device_state\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:83;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:26:\"field_data_field_no_of_cpu\";a:2:{s:5:\"value\";s:21:\"field_no_of_cpu_value\";s:6:\"format\";s:22:\"field_no_of_cpu_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:30:\"field_revision_field_no_of_cpu\";a:2:{s:5:\"value\";s:21:\"field_no_of_cpu_value\";s:6:\"format\";s:22:\"field_no_of_cpu_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"83\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:15:\"field_no_of_cpu\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:84;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_virtual_disks\";a:2:{s:5:\"value\";s:25:\"field_virtual_disks_value\";s:6:\"format\";s:26:\"field_virtual_disks_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_virtual_disks\";a:2:{s:5:\"value\";s:25:\"field_virtual_disks_value\";s:6:\"format\";s:26:\"field_virtual_disks_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"84\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:19:\"field_virtual_disks\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:86;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_fa_build_version\";a:2:{s:5:\"value\";s:28:\"field_fa_build_version_value\";s:6:\"format\";s:29:\"field_fa_build_version_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_fa_build_version\";a:2:{s:5:\"value\";s:28:\"field_fa_build_version_value\";s:6:\"format\";s:29:\"field_fa_build_version_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"86\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:22:\"field_fa_build_version\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:87;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_fa_cache_mode\";a:2:{s:5:\"value\";s:25:\"field_fa_cache_mode_value\";s:6:\"format\";s:26:\"field_fa_cache_mode_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_fa_cache_mode\";a:2:{s:5:\"value\";s:25:\"field_fa_cache_mode_value\";s:6:\"format\";s:26:\"field_fa_cache_mode_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"87\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:19:\"field_fa_cache_mode\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:2:{i:0;s:15:\"virtual_machine\";i:1;s:5:\"vdisk\";}}}i:88;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:40:\"field_data_field_fa_administration_state\";a:2:{s:5:\"value\";s:35:\"field_fa_administration_state_value\";s:6:\"format\";s:36:\"field_fa_administration_state_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:44:\"field_revision_field_fa_administration_state\";a:2:{s:5:\"value\";s:35:\"field_fa_administration_state_value\";s:6:\"format\";s:36:\"field_fa_administration_state_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"88\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:29:\"field_fa_administration_state\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:2:{i:0;s:15:\"virtual_machine\";i:1;s:5:\"vdisk\";}}}i:89;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_fa_cache_size\";a:2:{s:5:\"value\";s:25:\"field_fa_cache_size_value\";s:6:\"format\";s:26:\"field_fa_cache_size_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_fa_cache_size\";a:2:{s:5:\"value\";s:25:\"field_fa_cache_size_value\";s:6:\"format\";s:26:\"field_fa_cache_size_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"89\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:19:\"field_fa_cache_size\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:90;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:37:\"field_data_field_fa_operational_state\";a:2:{s:5:\"value\";s:32:\"field_fa_operational_state_value\";s:6:\"format\";s:33:\"field_fa_operational_state_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:41:\"field_revision_field_fa_operational_state\";a:2:{s:5:\"value\";s:32:\"field_fa_operational_state_value\";s:6:\"format\";s:33:\"field_fa_operational_state_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"90\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:26:\"field_fa_operational_state\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:2:{i:0;s:15:\"virtual_machine\";i:1;s:5:\"vdisk\";}}}i:91;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:39:\"field_data_field_fa_operational_message\";a:2:{s:5:\"value\";s:34:\"field_fa_operational_message_value\";s:6:\"format\";s:35:\"field_fa_operational_message_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:43:\"field_revision_field_fa_operational_message\";a:2:{s:5:\"value\";s:34:\"field_fa_operational_message_value\";s:6:\"format\";s:35:\"field_fa_operational_message_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"91\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:28:\"field_fa_operational_message\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:2:{i:0;s:15:\"virtual_machine\";i:1;s:5:\"vdisk\";}}}i:92;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:37:\"field_data_field_fa_performance_state\";a:2:{s:5:\"value\";s:32:\"field_fa_performance_state_value\";s:6:\"format\";s:33:\"field_fa_performance_state_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:41:\"field_revision_field_fa_performance_state\";a:2:{s:5:\"value\";s:32:\"field_fa_performance_state_value\";s:6:\"format\";s:33:\"field_fa_performance_state_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"92\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:26:\"field_fa_performance_state\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:2:{i:0;s:15:\"virtual_machine\";i:1;s:5:\"vdisk\";}}}i:93;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_fa_generation_id\";a:2:{s:5:\"value\";s:28:\"field_fa_generation_id_value\";s:6:\"format\";s:29:\"field_fa_generation_id_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_fa_generation_id\";a:2:{s:5:\"value\";s:28:\"field_fa_generation_id_value\";s:6:\"format\";s:29:\"field_fa_generation_id_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"93\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:22:\"field_fa_generation_id\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:94;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:32:\"field_data_field_vm_read_latency\";a:1:{s:5:\"value\";s:27:\"field_vm_read_latency_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:36:\"field_revision_field_vm_read_latency\";a:1:{s:5:\"value\";s:27:\"field_vm_read_latency_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"94\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:21:\"field_vm_read_latency\";s:4:\"type\";s:14:\"number_decimal\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:10:\"vm_metrics\";}}}i:95;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_vm_write_latency\";a:1:{s:5:\"value\";s:28:\"field_vm_write_latency_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_vm_write_latency\";a:1:{s:5:\"value\";s:28:\"field_vm_write_latency_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"95\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:22:\"field_vm_write_latency\";s:4:\"type\";s:14:\"number_decimal\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:10:\"vm_metrics\";}}}i:96;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_vm_read_ops\";a:1:{s:5:\"value\";s:23:\"field_vm_read_ops_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_vm_read_ops\";a:1:{s:5:\"value\";s:23:\"field_vm_read_ops_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"96\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:17:\"field_vm_read_ops\";s:4:\"type\";s:14:\"number_decimal\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:10:\"vm_metrics\";}}}i:97;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:29:\"field_data_field_vm_write_ops\";a:1:{s:5:\"value\";s:24:\"field_vm_write_ops_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:33:\"field_revision_field_vm_write_ops\";a:1:{s:5:\"value\";s:24:\"field_vm_write_ops_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"97\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:18:\"field_vm_write_ops\";s:4:\"type\";s:14:\"number_decimal\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:10:\"vm_metrics\";}}}i:98;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:24:\"field_data_field_vm_hits\";a:1:{s:5:\"value\";s:19:\"field_vm_hits_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:28:\"field_revision_field_vm_hits\";a:1:{s:5:\"value\";s:19:\"field_vm_hits_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"98\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:13:\"field_vm_hits\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:10:\"vm_metrics\";}}}i:99;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:31:\"field_data_field_vm_read_blocks\";a:1:{s:5:\"value\";s:26:\"field_vm_read_blocks_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:35:\"field_revision_field_vm_read_blocks\";a:1:{s:5:\"value\";s:26:\"field_vm_read_blocks_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"99\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:20:\"field_vm_read_blocks\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:10:\"vm_metrics\";}}}i:100;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_vm_cache_latency\";a:1:{s:5:\"value\";s:28:\"field_vm_cache_latency_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_vm_cache_latency\";a:1:{s:5:\"value\";s:28:\"field_vm_cache_latency_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"100\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:22:\"field_vm_cache_latency\";s:4:\"type\";s:14:\"number_decimal\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:10:\"vm_metrics\";}}}i:101;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_vm_population\";a:1:{s:5:\"value\";s:25:\"field_vm_population_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_vm_population\";a:1:{s:5:\"value\";s:25:\"field_vm_population_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"101\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:19:\"field_vm_population\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:10:\"vm_metrics\";}}}i:102;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_vm_usable_blocks\";a:1:{s:5:\"value\";s:28:\"field_vm_usable_blocks_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_vm_usable_blocks\";a:1:{s:5:\"value\";s:28:\"field_vm_usable_blocks_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"102\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:22:\"field_vm_usable_blocks\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:10:\"vm_metrics\";}}}i:103;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:32:\"field_data_field_vm_write_blocks\";a:1:{s:5:\"value\";s:27:\"field_vm_write_blocks_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:36:\"field_revision_field_vm_write_blocks\";a:1:{s:5:\"value\";s:27:\"field_vm_write_blocks_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"103\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:21:\"field_vm_write_blocks\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:10:\"vm_metrics\";}}}i:104;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_vm_insertions\";a:1:{s:5:\"value\";s:25:\"field_vm_insertions_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_vm_insertions\";a:1:{s:5:\"value\";s:25:\"field_vm_insertions_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"104\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:19:\"field_vm_insertions\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:10:\"vm_metrics\";}}}i:107;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:4:{s:4:\"code\";s:443:\"$entity_field[0][\'value\'] = 0;\r\n\r\n$population = (int) array_pop(array_pop(field_get_items($entity_type, $entity, \'field_vm_population\')));\r\n$usable_blocks = (int) array_pop(array_pop(field_get_items($entity_type, $entity, \'field_vm_usable_blocks\')));\r\n\r\nif (is_numeric($population) && is_numeric($usable_blocks) && $population !== 0 && $usable_blocks !== 0) {\r\n  $entity_field[0][\'value\'] = round( ($population * 100) / $usable_blocks, 2 );\r\n}\";s:14:\"display_format\";s:64:\"$display_output = number_format($entity_field_item[\'value\'], 2);\";s:5:\"store\";i:1;s:8:\"database\";a:8:{s:9:\"data_type\";s:7:\"numeric\";s:11:\"data_length\";s:2:\"32\";s:9:\"data_size\";s:6:\"normal\";s:14:\"data_precision\";s:2:\"10\";s:10:\"data_scale\";s:1:\"2\";s:12:\"data_default\";s:1:\"0\";s:13:\"data_not_NULL\";i:0;s:10:\"data_index\";i:0;}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_vm_population_pc\";a:1:{s:5:\"value\";s:28:\"field_vm_population_pc_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_vm_population_pc\";a:1:{s:5:\"value\";s:28:\"field_vm_population_pc_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"107\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:22:\"field_vm_population_pc\";s:4:\"type\";s:8:\"computed\";s:6:\"module\";s:14:\"computed_field\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:5:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";i:0;s:7:\"default\";s:1:\"0\";}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:10:\"vm_metrics\";}}}i:108;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:4:{s:4:\"code\";s:608:\"$entity_field[0][\'value\'] = 0;\r\n\r\n$insertions = (int) array_pop(array_pop(field_get_items($entity_type, $entity, \'field_vm_insertions\')));\r\n$read_blocks = (int) array_pop(array_pop(field_get_items($entity_type, $entity, \'field_vm_read_blocks\')));\r\n$write_blocks = (int) array_pop(array_pop(field_get_items($entity_type, $entity, \'field_vm_write_blocks\')));\r\n\r\nif (is_numeric($insertions) && is_numeric($read_blocks) && is_numeric($write_blocks) && $insertions !== 0 && ($read_blocks + $write_blocks) !== 0) {\r\n  $entity_field[0][\'value\'] = round( ($insertions * 100) / ($read_blocks + $write_blocks), 2 );\r\n}\";s:14:\"display_format\";s:64:\"$display_output = number_format($entity_field_item[\'value\'], 2);\";s:5:\"store\";i:1;s:8:\"database\";a:8:{s:9:\"data_type\";s:7:\"numeric\";s:11:\"data_length\";s:2:\"32\";s:9:\"data_size\";s:6:\"normal\";s:14:\"data_precision\";s:2:\"10\";s:10:\"data_scale\";s:1:\"2\";s:12:\"data_default\";s:1:\"0\";s:13:\"data_not_NULL\";i:0;s:10:\"data_index\";i:0;}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:37:\"field_data_field_vm_insertion_rate_pc\";a:1:{s:5:\"value\";s:32:\"field_vm_insertion_rate_pc_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:41:\"field_revision_field_vm_insertion_rate_pc\";a:1:{s:5:\"value\";s:32:\"field_vm_insertion_rate_pc_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"108\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:26:\"field_vm_insertion_rate_pc\";s:4:\"type\";s:8:\"computed\";s:6:\"module\";s:14:\"computed_field\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:5:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";i:0;s:7:\"default\";s:1:\"0\";}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:10:\"vm_metrics\";}}}i:109;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:5:\"vdisk\";s:5:\"vdisk\";}s:4:\"sort\";a:1:{s:4:\"type\";s:4:\"none\";}s:9:\"behaviors\";a:1:{s:17:\"views-select-list\";a:1:{s:6:\"status\";i:0;}}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:22:\"field_data_field_vdisk\";a:1:{s:9:\"target_id\";s:21:\"field_vdisk_target_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:26:\"field_revision_field_vdisk\";a:1:{s:9:\"target_id\";s:21:\"field_vdisk_target_id\";}}}}}s:12:\"foreign keys\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:9:\"target_id\";s:3:\"nid\";}}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:2:\"id\";s:3:\"109\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:11:\"field_vdisk\";s:4:\"type\";s:15:\"entityreference\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:9:\"target_id\";a:4:{s:11:\"description\";s:28:\"The id of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:13:\"vdisk_metrics\";}}}i:110;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:35:\"field_data_field_vdisk_read_latency\";a:1:{s:5:\"value\";s:30:\"field_vdisk_read_latency_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:39:\"field_revision_field_vdisk_read_latency\";a:1:{s:5:\"value\";s:30:\"field_vdisk_read_latency_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"110\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:24:\"field_vdisk_read_latency\";s:4:\"type\";s:14:\"number_decimal\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:13:\"vdisk_metrics\";}}}i:111;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:36:\"field_data_field_vdisk_write_latency\";a:1:{s:5:\"value\";s:31:\"field_vdisk_write_latency_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:40:\"field_revision_field_vdisk_write_latency\";a:1:{s:5:\"value\";s:31:\"field_vdisk_write_latency_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"111\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:25:\"field_vdisk_write_latency\";s:4:\"type\";s:14:\"number_decimal\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:13:\"vdisk_metrics\";}}}i:112;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:31:\"field_data_field_vdisk_read_ops\";a:1:{s:5:\"value\";s:26:\"field_vdisk_read_ops_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:35:\"field_revision_field_vdisk_read_ops\";a:1:{s:5:\"value\";s:26:\"field_vdisk_read_ops_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"112\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:20:\"field_vdisk_read_ops\";s:4:\"type\";s:14:\"number_decimal\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:13:\"vdisk_metrics\";}}}i:113;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:32:\"field_data_field_vdisk_write_ops\";a:1:{s:5:\"value\";s:27:\"field_vdisk_write_ops_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:36:\"field_revision_field_vdisk_write_ops\";a:1:{s:5:\"value\";s:27:\"field_vdisk_write_ops_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"113\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:21:\"field_vdisk_write_ops\";s:4:\"type\";s:14:\"number_decimal\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:13:\"vdisk_metrics\";}}}i:114;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_vdisk_hits\";a:1:{s:5:\"value\";s:22:\"field_vdisk_hits_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_vdisk_hits\";a:1:{s:5:\"value\";s:22:\"field_vdisk_hits_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"114\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:16:\"field_vdisk_hits\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:13:\"vdisk_metrics\";}}}i:115;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:34:\"field_data_field_vdisk_read_blocks\";a:1:{s:5:\"value\";s:29:\"field_vdisk_read_blocks_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:38:\"field_revision_field_vdisk_read_blocks\";a:1:{s:5:\"value\";s:29:\"field_vdisk_read_blocks_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"115\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:23:\"field_vdisk_read_blocks\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:13:\"vdisk_metrics\";}}}i:116;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:36:\"field_data_field_vdisk_cache_latency\";a:1:{s:5:\"value\";s:31:\"field_vdisk_cache_latency_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:40:\"field_revision_field_vdisk_cache_latency\";a:1:{s:5:\"value\";s:31:\"field_vdisk_cache_latency_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"116\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:25:\"field_vdisk_cache_latency\";s:4:\"type\";s:14:\"number_decimal\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:13:\"vdisk_metrics\";}}}i:117;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_vdisk_population\";a:1:{s:5:\"value\";s:28:\"field_vdisk_population_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_vdisk_population\";a:1:{s:5:\"value\";s:28:\"field_vdisk_population_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"117\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:22:\"field_vdisk_population\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:13:\"vdisk_metrics\";}}}i:118;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:36:\"field_data_field_vdisk_usable_blocks\";a:1:{s:5:\"value\";s:31:\"field_vdisk_usable_blocks_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:40:\"field_revision_field_vdisk_usable_blocks\";a:1:{s:5:\"value\";s:31:\"field_vdisk_usable_blocks_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"118\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:25:\"field_vdisk_usable_blocks\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:13:\"vdisk_metrics\";}}}i:119;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_vdisk_insertions\";a:1:{s:5:\"value\";s:28:\"field_vdisk_insertions_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_vdisk_insertions\";a:1:{s:5:\"value\";s:28:\"field_vdisk_insertions_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"119\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:22:\"field_vdisk_insertions\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:13:\"vdisk_metrics\";}}}i:120;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:35:\"field_data_field_vdisk_write_blocks\";a:1:{s:5:\"value\";s:30:\"field_vdisk_write_blocks_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:39:\"field_revision_field_vdisk_write_blocks\";a:1:{s:5:\"value\";s:30:\"field_vdisk_write_blocks_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"120\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:24:\"field_vdisk_write_blocks\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:13:\"vdisk_metrics\";}}}i:122;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:6:{s:11:\"granularity\";a:6:{s:5:\"month\";s:5:\"month\";s:3:\"day\";s:3:\"day\";s:4:\"hour\";s:4:\"hour\";s:6:\"minute\";s:6:\"minute\";s:6:\"second\";s:6:\"second\";s:4:\"year\";s:4:\"year\";}s:11:\"tz_handling\";s:4:\"none\";s:11:\"timezone_db\";s:0:\"\";s:13:\"cache_enabled\";i:0;s:11:\"cache_count\";s:1:\"4\";s:6:\"todate\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:26:\"field_data_field_timestamp\";a:1:{s:5:\"value\";s:21:\"field_timestamp_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:30:\"field_revision_field_timestamp\";a:1:{s:5:\"value\";s:21:\"field_timestamp_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"122\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:15:\"field_timestamp\";s:4:\"type\";s:9:\"datestamp\";s:6:\"module\";s:4:\"date\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;s:8:\"sortable\";b:1;s:5:\"views\";b:1;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:2:{i:0;s:13:\"vdisk_metrics\";i:1;s:10:\"vm_metrics\";}}}i:124;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:4:{s:4:\"code\";s:437:\"$entity_field[0][\'value\'] = 0;\r\n\r\n$population = array_pop(array_pop(field_get_items($entity_type, $entity, \'field_vdisk_population\')));\r\n$usable_blocks = array_pop(array_pop(field_get_items($entity_type, $entity, \'field_vdisk_usable_blocks\')));\r\n\r\nif (is_numeric($population) && is_numeric($usable_blocks) && $population !== 0 && $usable_blocks !== 0) {\r\n  $entity_field[0][\'value\'] = round( ($population * 100) / $usable_blocks, 2 );\r\n}\";s:14:\"display_format\";s:64:\"$display_output = number_format($entity_field_item[\'value\'], 2);\";s:5:\"store\";i:1;s:8:\"database\";a:8:{s:9:\"data_type\";s:7:\"varchar\";s:11:\"data_length\";s:2:\"32\";s:9:\"data_size\";s:6:\"normal\";s:14:\"data_precision\";s:2:\"10\";s:10:\"data_scale\";s:1:\"2\";s:12:\"data_default\";s:1:\"0\";s:13:\"data_not_NULL\";i:0;s:10:\"data_index\";i:0;}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:36:\"field_data_field_vdisk_population_pc\";a:1:{s:5:\"value\";s:31:\"field_vdisk_population_pc_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:40:\"field_revision_field_vdisk_population_pc\";a:1:{s:5:\"value\";s:31:\"field_vdisk_population_pc_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"124\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:25:\"field_vdisk_population_pc\";s:4:\"type\";s:8:\"computed\";s:6:\"module\";s:14:\"computed_field\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"32\";s:8:\"not null\";i:0;s:7:\"default\";s:1:\"0\";}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:13:\"vdisk_metrics\";}}}i:125;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:4:{s:4:\"code\";s:599:\"$entity_field[0][\'value\'] = 0;\r\n\r\n$insertions = array_pop(array_pop(field_get_items($entity_type, $entity, \'field_vdisk_insertions\')));\r\n$read_blocks = array_pop(array_pop(field_get_items($entity_type, $entity, \'field_vdisk_read_blocks\')));\r\n$write_blocks = array_pop(array_pop(field_get_items($entity_type, $entity, \'field_vdisk_write_blocks\')));\r\n\r\nif (is_numeric($insertions) && is_numeric($read_blocks) && is_numeric($write_blocks) && $insertions !== 0 && ($read_blocks + $write_blocks) !== 0) {\r\n  $entity_field[0][\'value\'] = round( ($insertions * 100) / ($read_blocks + $write_blocks), 2 );\r\n}\";s:14:\"display_format\";s:64:\"$display_output = number_format($entity_field_item[\'value\'], 2);\";s:5:\"store\";i:1;s:8:\"database\";a:8:{s:9:\"data_type\";s:7:\"varchar\";s:11:\"data_length\";s:2:\"32\";s:9:\"data_size\";s:6:\"normal\";s:14:\"data_precision\";s:2:\"10\";s:10:\"data_scale\";s:1:\"2\";s:12:\"data_default\";s:1:\"0\";s:13:\"data_not_NULL\";i:0;s:10:\"data_index\";i:0;}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:40:\"field_data_field_vdisk_insertion_rate_pc\";a:1:{s:5:\"value\";s:35:\"field_vdisk_insertion_rate_pc_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:44:\"field_revision_field_vdisk_insertion_rate_pc\";a:1:{s:5:\"value\";s:35:\"field_vdisk_insertion_rate_pc_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"125\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:29:\"field_vdisk_insertion_rate_pc\";s:4:\"type\";s:8:\"computed\";s:6:\"module\";s:14:\"computed_field\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"32\";s:8:\"not null\";i:0;s:7:\"default\";s:1:\"0\";}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:13:\"vdisk_metrics\";}}}i:126;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_disk_index\";a:1:{s:5:\"value\";s:22:\"field_disk_index_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_disk_index\";a:1:{s:5:\"value\";s:22:\"field_disk_index_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"126\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:16:\"field_disk_index\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:5:\"vdisk\";}}}i:127;a:17:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_cachespace\";a:2:{s:5:\"value\";s:22:\"field_cachespace_value\";s:6:\"format\";s:23:\"field_cachespace_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_cachespace\";a:2:{s:5:\"value\";s:22:\"field_cachespace_value\";s:6:\"format\";s:23:\"field_cachespace_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"127\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}s:10:\"field_name\";s:16:\"field_cachespace\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:128;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_vdisk_identifier\";a:2:{s:5:\"value\";s:28:\"field_vdisk_identifier_value\";s:6:\"format\";s:29:\"field_vdisk_identifier_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_vdisk_identifier\";a:2:{s:5:\"value\";s:28:\"field_vdisk_identifier_value\";s:6:\"format\";s:29:\"field_vdisk_identifier_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"128\";s:10:\"field_name\";s:22:\"field_vdisk_identifier\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:5:\"vdisk\";}}}i:132;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_vm_cache_size\";a:2:{s:5:\"value\";s:25:\"field_vm_cache_size_value\";s:6:\"format\";s:26:\"field_vm_cache_size_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_vm_cache_size\";a:2:{s:5:\"value\";s:25:\"field_vm_cache_size_value\";s:6:\"format\";s:26:\"field_vm_cache_size_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"132\";s:10:\"field_name\";s:19:\"field_vm_cache_size\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:14:\"vm_cache_space\";}}}i:140;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:19:\"referenceable_types\";a:12:{s:4:\"host\";s:4:\"host\";s:7:\"article\";i:0;s:4:\"page\";i:0;s:11:\"data_center\";i:0;s:6:\"device\";i:0;s:5:\"panel\";i:0;s:14:\"vm_cache_space\";i:0;s:10:\"vm_metrics\";i:0;s:15:\"virtual_machine\";i:0;s:7:\"vcenter\";i:0;s:5:\"vdisk\";i:0;s:13:\"vdisk_metrics\";i:0;}s:4:\"view\";a:3:{s:9:\"view_name\";s:0:\"\";s:12:\"display_name\";s:0:\"\";s:4:\"args\";a:0:{}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:41:\"field_data_field_cache_assigned_from_host\";a:1:{s:3:\"nid\";s:34:\"field_cache_assigned_from_host_nid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:45:\"field_revision_field_cache_assigned_from_host\";a:1:{s:3:\"nid\";s:34:\"field_cache_assigned_from_host_nid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"nid\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:3:\"nid\";s:3:\"nid\";}}}s:7:\"indexes\";a:1:{s:3:\"nid\";a:1:{i:0;s:3:\"nid\";}}s:2:\"id\";s:3:\"140\";s:10:\"field_name\";s:30:\"field_cache_assigned_from_host\";s:4:\"type\";s:14:\"node_reference\";s:6:\"module\";s:14:\"node_reference\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:3:\"nid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:14:\"vm_cache_space\";}}}i:141;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:19:\"referenceable_types\";a:12:{s:15:\"virtual_machine\";s:15:\"virtual_machine\";s:7:\"article\";i:0;s:4:\"page\";i:0;s:11:\"data_center\";i:0;s:6:\"device\";i:0;s:4:\"host\";i:0;s:5:\"panel\";i:0;s:14:\"vm_cache_space\";i:0;s:10:\"vm_metrics\";i:0;s:7:\"vcenter\";i:0;s:5:\"vdisk\";i:0;s:13:\"vdisk_metrics\";i:0;}s:4:\"view\";a:3:{s:9:\"view_name\";s:0:\"\";s:12:\"display_name\";s:0:\"\";s:4:\"args\";a:0:{}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:38:\"field_data_field_cache_allocated_to_vm\";a:1:{s:3:\"nid\";s:31:\"field_cache_allocated_to_vm_nid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:42:\"field_revision_field_cache_allocated_to_vm\";a:1:{s:3:\"nid\";s:31:\"field_cache_allocated_to_vm_nid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"nid\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:3:\"nid\";s:3:\"nid\";}}}s:7:\"indexes\";a:1:{s:3:\"nid\";a:1:{i:0;s:3:\"nid\";}}s:2:\"id\";s:3:\"141\";s:10:\"field_name\";s:27:\"field_cache_allocated_to_vm\";s:4:\"type\";s:14:\"node_reference\";s:6:\"module\";s:14:\"node_reference\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:3:\"nid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:14:\"vm_cache_space\";}}}i:142;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:29:\"field_data_field_install_port\";a:1:{s:5:\"value\";s:24:\"field_install_port_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:33:\"field_revision_field_install_port\";a:1:{s:5:\"value\";s:24:\"field_install_port_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"142\";s:10:\"field_name\";s:18:\"field_install_port\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:143;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_host_model\";a:2:{s:5:\"value\";s:22:\"field_host_model_value\";s:6:\"format\";s:23:\"field_host_model_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_host_model\";a:2:{s:5:\"value\";s:22:\"field_host_model_value\";s:6:\"format\";s:23:\"field_host_model_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"143\";s:10:\"field_name\";s:16:\"field_host_model\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:144;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_host_vendor\";a:2:{s:5:\"value\";s:23:\"field_host_vendor_value\";s:6:\"format\";s:24:\"field_host_vendor_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_host_vendor\";a:2:{s:5:\"value\";s:23:\"field_host_vendor_value\";s:6:\"format\";s:24:\"field_host_vendor_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"144\";s:10:\"field_name\";s:17:\"field_host_vendor\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:145;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{i:0;s:1:\"0\";i:1;s:1:\"1\";}s:23:\"allowed_values_function\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:31:\"field_data_field_vm_vmotionable\";a:1:{s:5:\"value\";s:26:\"field_vm_vmotionable_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:35:\"field_revision_field_vm_vmotionable\";a:1:{s:5:\"value\";s:26:\"field_vm_vmotionable_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:2:\"id\";s:3:\"145\";s:10:\"field_name\";s:20:\"field_vm_vmotionable\";s:4:\"type\";s:12:\"list_boolean\";s:6:\"module\";s:4:\"list\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:147;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_hbtl\";a:2:{s:5:\"value\";s:16:\"field_hbtl_value\";s:6:\"format\";s:17:\"field_hbtl_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_hbtl\";a:2:{s:5:\"value\";s:16:\"field_hbtl_value\";s:6:\"format\";s:17:\"field_hbtl_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"147\";s:10:\"field_name\";s:10:\"field_hbtl\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:148;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:2:\"10\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:24:\"field_data_field_is_vmfs\";a:2:{s:5:\"value\";s:19:\"field_is_vmfs_value\";s:6:\"format\";s:20:\"field_is_vmfs_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:28:\"field_revision_field_is_vmfs\";a:2:{s:5:\"value\";s:19:\"field_is_vmfs_value\";s:6:\"format\";s:20:\"field_is_vmfs_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"148\";s:10:\"field_name\";s:13:\"field_is_vmfs\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"10\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:6:\"device\";}}}i:149;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_fa_usable_blocks\";a:2:{s:5:\"value\";s:28:\"field_fa_usable_blocks_value\";s:6:\"format\";s:29:\"field_fa_usable_blocks_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_fa_usable_blocks\";a:2:{s:5:\"value\";s:28:\"field_fa_usable_blocks_value\";s:6:\"format\";s:29:\"field_fa_usable_blocks_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"149\";s:10:\"field_name\";s:22:\"field_fa_usable_blocks\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:150;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_vdisk_name\";a:2:{s:5:\"value\";s:22:\"field_vdisk_name_value\";s:6:\"format\";s:23:\"field_vdisk_name_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_vdisk_name\";a:2:{s:5:\"value\";s:22:\"field_vdisk_name_value\";s:6:\"format\";s:23:\"field_vdisk_name_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"150\";s:10:\"field_name\";s:16:\"field_vdisk_name\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:5:\"vdisk\";}}}i:151;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_vdisk_type\";a:2:{s:5:\"value\";s:22:\"field_vdisk_type_value\";s:6:\"format\";s:23:\"field_vdisk_type_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_vdisk_type\";a:2:{s:5:\"value\";s:22:\"field_vdisk_type_value\";s:6:\"format\";s:23:\"field_vdisk_type_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"151\";s:10:\"field_name\";s:16:\"field_vdisk_type\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:5:\"vdisk\";}}}i:152;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_vdisk_id\";a:2:{s:5:\"value\";s:20:\"field_vdisk_id_value\";s:6:\"format\";s:21:\"field_vdisk_id_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_vdisk_id\";a:2:{s:5:\"value\";s:20:\"field_vdisk_id_value\";s:6:\"format\";s:21:\"field_vdisk_id_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"152\";s:10:\"field_name\";s:14:\"field_vdisk_id\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:5:\"vdisk\";}}}i:154;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:24:\"field_data_field_host_ip\";a:2:{s:5:\"value\";s:19:\"field_host_ip_value\";s:6:\"format\";s:20:\"field_host_ip_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:28:\"field_revision_field_host_ip\";a:2:{s:5:\"value\";s:19:\"field_host_ip_value\";s:6:\"format\";s:20:\"field_host_ip_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"154\";s:10:\"field_name\";s:13:\"field_host_ip\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:155;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:24:\"field_data_field_hit_ops\";a:1:{s:5:\"value\";s:19:\"field_hit_ops_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:28:\"field_revision_field_hit_ops\";a:1:{s:5:\"value\";s:19:\"field_hit_ops_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"155\";s:10:\"field_name\";s:13:\"field_hit_ops\";s:4:\"type\";s:14:\"number_decimal\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:13:\"vdisk_metrics\";}}}i:156;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:2:\"10\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:31:\"field_data_field_fa_sector_size\";a:2:{s:5:\"value\";s:26:\"field_fa_sector_size_value\";s:6:\"format\";s:27:\"field_fa_sector_size_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:35:\"field_revision_field_fa_sector_size\";a:2:{s:5:\"value\";s:26:\"field_fa_sector_size_value\";s:6:\"format\";s:27:\"field_fa_sector_size_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"156\";s:10:\"field_name\";s:20:\"field_fa_sector_size\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"10\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:157;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:34:\"field_data_field_rediscover_status\";a:2:{s:5:\"value\";s:29:\"field_rediscover_status_value\";s:6:\"format\";s:30:\"field_rediscover_status_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:38:\"field_revision_field_rediscover_status\";a:2:{s:5:\"value\";s:29:\"field_rediscover_status_value\";s:6:\"format\";s:30:\"field_rediscover_status_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"157\";s:10:\"field_name\";s:23:\"field_rediscover_status\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:7:\"vcenter\";}}}i:158;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_hostname\";a:2:{s:5:\"value\";s:20:\"field_hostname_value\";s:6:\"format\";s:21:\"field_hostname_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_hostname\";a:2:{s:5:\"value\";s:20:\"field_hostname_value\";s:6:\"format\";s:21:\"field_hostname_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"158\";s:10:\"field_name\";s:14:\"field_hostname\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:7:\"vcenter\";}}}i:159;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_vm_hostname\";a:2:{s:5:\"value\";s:23:\"field_vm_hostname_value\";s:6:\"format\";s:24:\"field_vm_hostname_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_vm_hostname\";a:2:{s:5:\"value\";s:23:\"field_vm_hostname_value\";s:6:\"format\";s:24:\"field_vm_hostname_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"159\";s:10:\"field_name\";s:17:\"field_vm_hostname\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:160;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:42:\"field_data_field_fa_metrics_reset_interval\";a:2:{s:5:\"value\";s:37:\"field_fa_metrics_reset_interval_value\";s:6:\"format\";s:38:\"field_fa_metrics_reset_interval_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:46:\"field_revision_field_fa_metrics_reset_interval\";a:2:{s:5:\"value\";s:37:\"field_fa_metrics_reset_interval_value\";s:6:\"format\";s:38:\"field_fa_metrics_reset_interval_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"160\";s:10:\"field_name\";s:31:\"field_fa_metrics_reset_interval\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:168;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_fmc_uuid\";a:2:{s:5:\"value\";s:20:\"field_fmc_uuid_value\";s:6:\"format\";s:21:\"field_fmc_uuid_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_fmc_uuid\";a:2:{s:5:\"value\";s:20:\"field_fmc_uuid_value\";s:6:\"format\";s:21:\"field_fmc_uuid_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"168\";s:10:\"field_name\";s:14:\"field_fmc_uuid\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:7:\"vcenter\";}}}i:172;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:4:{s:4:\"code\";s:31:\"$entity_field[0][\'value\'] = \"\";\";s:14:\"display_format\";s:46:\"$display_output = $entity_field_item[\'value\'];\";s:5:\"store\";i:1;s:8:\"database\";a:8:{s:9:\"data_type\";s:7:\"varchar\";s:11:\"data_length\";s:2:\"32\";s:9:\"data_size\";s:6:\"normal\";s:14:\"data_precision\";s:2:\"10\";s:10:\"data_scale\";s:1:\"2\";s:12:\"data_default\";s:0:\"\";s:13:\"data_not_NULL\";i:0;s:10:\"data_index\";i:0;}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:31:\"field_data_field_vm_hit_rate_pc\";a:1:{s:5:\"value\";s:26:\"field_vm_hit_rate_pc_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:35:\"field_revision_field_vm_hit_rate_pc\";a:1:{s:5:\"value\";s:26:\"field_vm_hit_rate_pc_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"172\";s:10:\"field_name\";s:20:\"field_vm_hit_rate_pc\";s:4:\"type\";s:8:\"computed\";s:6:\"module\";s:14:\"computed_field\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"32\";s:8:\"not null\";i:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:10:\"vm_metrics\";}}}i:170;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:34:\"field_data_field_vm_vmotion_policy\";a:2:{s:5:\"value\";s:29:\"field_vm_vmotion_policy_value\";s:6:\"format\";s:30:\"field_vm_vmotion_policy_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:38:\"field_revision_field_vm_vmotion_policy\";a:2:{s:5:\"value\";s:29:\"field_vm_vmotion_policy_value\";s:6:\"format\";s:30:\"field_vm_vmotion_policy_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"170\";s:10:\"field_name\";s:23:\"field_vm_vmotion_policy\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:171;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:4:\"1000\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:36:\"field_data_field_vm_vmotion_hostlist\";a:2:{s:5:\"value\";s:31:\"field_vm_vmotion_hostlist_value\";s:6:\"format\";s:32:\"field_vm_vmotion_hostlist_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:40:\"field_revision_field_vm_vmotion_hostlist\";a:2:{s:5:\"value\";s:31:\"field_vm_vmotion_hostlist_value\";s:6:\"format\";s:32:\"field_vm_vmotion_hostlist_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"171\";s:10:\"field_name\";s:25:\"field_vm_vmotion_hostlist\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:4:\"1000\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:15:\"virtual_machine\";}}}i:173;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:20:\"field_data_field_drs\";a:1:{s:5:\"value\";s:15:\"field_drs_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:24:\"field_revision_field_drs\";a:1:{s:5:\"value\";s:15:\"field_drs_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"173\";s:10:\"field_name\";s:9:\"field_drs\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:174;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:19:\"field_data_field_ha\";a:1:{s:5:\"value\";s:14:\"field_ha_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:23:\"field_revision_field_ha\";a:1:{s:5:\"value\";s:14:\"field_ha_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"174\";s:10:\"field_name\";s:8:\"field_ha\";s:4:\"type\";s:14:\"number_integer\";s:6:\"module\";s:6:\"number\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:4:\"host\";}}}i:175;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:4:{s:4:\"code\";s:31:\"$entity_field[0][\'value\'] = \"\";\";s:14:\"display_format\";s:46:\"$display_output = $entity_field_item[\'value\'];\";s:5:\"store\";i:1;s:8:\"database\";a:8:{s:9:\"data_type\";s:7:\"varchar\";s:11:\"data_length\";s:2:\"32\";s:9:\"data_size\";s:6:\"normal\";s:14:\"data_precision\";s:2:\"10\";s:10:\"data_scale\";s:1:\"2\";s:12:\"data_default\";s:0:\"\";s:13:\"data_not_NULL\";i:0;s:10:\"data_index\";i:0;}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:34:\"field_data_field_vdisk_hit_rate_pc\";a:1:{s:5:\"value\";s:29:\"field_vdisk_hit_rate_pc_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:38:\"field_revision_field_vdisk_hit_rate_pc\";a:1:{s:5:\"value\";s:29:\"field_vdisk_hit_rate_pc_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"175\";s:10:\"field_name\";s:23:\"field_vdisk_hit_rate_pc\";s:4:\"type\";s:8:\"computed\";s:6:\"module\";s:14:\"computed_field\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"32\";s:8:\"not null\";i:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:13:\"vdisk_metrics\";}}}}s:9:\"field_ids\";a:142:{s:12:\"comment_body\";i:1;s:4:\"body\";i:2;s:10:\"field_tags\";i:3;s:16:\"field_ip_address\";i:5;s:14:\"field_username\";i:6;s:14:\"field_password\";i:7;s:19:\"field_vm_ip_address\";i:9;s:17:\"field_memory_size\";i:11;s:14:\"field_template\";i:13;s:18:\"field_vm_path_name\";i:14;s:14:\"field_guest_os\";i:15;s:14:\"field_guest_id\";i:16;s:15:\"field_cpu_usage\";i:18;s:23:\"field_host_memory_usage\";i:19;s:24:\"field_guest_memory_usage\";i:20;s:15:\"field_cpu_model\";i:21;s:14:\"field_boottime\";i:22;s:17:\"field_host_status\";i:23;s:22:\"field_maintenance_mode\";i:24;s:21:\"field_physical_memory\";i:25;s:13:\"field_vmotion\";i:26;s:21:\"field_reboot_required\";i:27;s:15:\"field_serial_no\";i:31;s:10:\"field_size\";i:32;s:17:\"field_device_type\";i:33;s:22:\"field_multipath_plugin\";i:34;s:16:\"field_devfs_path\";i:35;s:12:\"field_vendor\";i:36;s:11:\"field_model\";i:37;s:14:\"field_revision\";i:38;s:16:\"field_scsi_level\";i:39;s:15:\"field_is_pseudo\";i:40;s:12:\"field_status\";i:41;s:20:\"field_is_rdm_capable\";i:42;s:14:\"field_is_local\";i:43;s:18:\"field_is_removable\";i:44;s:12:\"field_is_ssd\";i:45;s:16:\"field_is_offline\";i:46;s:29:\"field_is_perennially_reserved\";i:47;s:30:\"field_thin_provisioning_status\";i:48;s:22:\"field_attached_filters\";i:49;s:17:\"field_vaai_status\";i:50;s:16:\"field_other_uids\";i:51;s:18:\"field_display_name\";i:52;s:14:\"field_capacity\";i:53;s:10:\"field_path\";i:54;s:15:\"field_freespace\";i:55;s:17:\"field_vm_username\";i:56;s:17:\"field_vm_password\";i:57;s:19:\"field_host_username\";i:58;s:19:\"field_host_password\";i:59;s:19:\"field_driver_status\";i:60;s:19:\"field_bundle_status\";i:61;s:21:\"field_related_vcenter\";i:62;s:21:\"field_virtual_machine\";i:63;s:18:\"field_related_host\";i:64;s:16:\"field_datacenter\";i:65;s:10:\"field_host\";i:66;s:18:\"field_vmware_tools\";i:67;s:22:\"field_software_on_host\";i:68;s:8:\"field_vm\";i:69;s:24:\"field_allocated_segments\";i:70;s:18:\"field_segment_size\";i:71;s:26:\"field_max_virtual_machines\";i:72;s:26:\"field_max_physical_devices\";i:73;s:30:\"field_claimed_physical_devices\";i:74;s:17:\"field_cache_state\";i:75;s:20:\"field_total_segments\";i:76;s:32:\"field_allocated_virtual_machines\";i:77;s:17:\"field_vib_version\";i:78;s:16:\"field_total_size\";i:79;s:20:\"field_naa_identifier\";i:80;s:20:\"field_allocated_size\";i:81;s:18:\"field_device_state\";i:82;s:15:\"field_no_of_cpu\";i:83;s:19:\"field_virtual_disks\";i:84;s:22:\"field_fa_build_version\";i:86;s:19:\"field_fa_cache_mode\";i:87;s:29:\"field_fa_administration_state\";i:88;s:19:\"field_fa_cache_size\";i:89;s:26:\"field_fa_operational_state\";i:90;s:28:\"field_fa_operational_message\";i:91;s:26:\"field_fa_performance_state\";i:92;s:22:\"field_fa_generation_id\";i:93;s:21:\"field_vm_read_latency\";i:94;s:22:\"field_vm_write_latency\";i:95;s:17:\"field_vm_read_ops\";i:96;s:18:\"field_vm_write_ops\";i:97;s:13:\"field_vm_hits\";i:98;s:20:\"field_vm_read_blocks\";i:99;s:22:\"field_vm_cache_latency\";i:100;s:19:\"field_vm_population\";i:101;s:22:\"field_vm_usable_blocks\";i:102;s:21:\"field_vm_write_blocks\";i:103;s:19:\"field_vm_insertions\";i:104;s:22:\"field_vm_population_pc\";i:107;s:26:\"field_vm_insertion_rate_pc\";i:108;s:11:\"field_vdisk\";i:109;s:24:\"field_vdisk_read_latency\";i:110;s:25:\"field_vdisk_write_latency\";i:111;s:20:\"field_vdisk_read_ops\";i:112;s:21:\"field_vdisk_write_ops\";i:113;s:16:\"field_vdisk_hits\";i:114;s:23:\"field_vdisk_read_blocks\";i:115;s:25:\"field_vdisk_cache_latency\";i:116;s:22:\"field_vdisk_population\";i:117;s:25:\"field_vdisk_usable_blocks\";i:118;s:22:\"field_vdisk_insertions\";i:119;s:24:\"field_vdisk_write_blocks\";i:120;s:15:\"field_timestamp\";i:122;s:25:\"field_vdisk_population_pc\";i:124;s:29:\"field_vdisk_insertion_rate_pc\";i:125;s:16:\"field_disk_index\";i:126;s:16:\"field_cachespace\";i:127;s:22:\"field_vdisk_identifier\";i:128;s:19:\"field_vm_cache_size\";i:132;s:30:\"field_cache_assigned_from_host\";i:140;s:27:\"field_cache_allocated_to_vm\";i:141;s:18:\"field_install_port\";i:142;s:16:\"field_host_model\";i:143;s:17:\"field_host_vendor\";i:144;s:20:\"field_vm_vmotionable\";i:145;s:10:\"field_hbtl\";i:147;s:13:\"field_is_vmfs\";i:148;s:22:\"field_fa_usable_blocks\";i:149;s:16:\"field_vdisk_name\";i:150;s:16:\"field_vdisk_type\";i:151;s:14:\"field_vdisk_id\";i:152;s:13:\"field_host_ip\";i:154;s:13:\"field_hit_ops\";i:155;s:20:\"field_fa_sector_size\";i:156;s:23:\"field_rediscover_status\";i:157;s:14:\"field_hostname\";i:158;s:17:\"field_vm_hostname\";i:159;s:31:\"field_fa_metrics_reset_interval\";i:160;s:14:\"field_fmc_uuid\";i:168;s:20:\"field_vm_hit_rate_pc\";i:172;s:23:\"field_vm_vmotion_policy\";i:170;s:25:\"field_vm_vmotion_hostlist\";i:171;s:9:\"field_drs\";i:173;s:8:\"field_ha\";i:174;s:23:\"field_vdisk_hit_rate_pc\";i:175;}s:9:\"instances\";a:9:{s:7:\"comment\";a:12:{s:20:\"comment_node_article\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"1\";s:18:\"user_register_form\";b:0;}s:8:\"required\";i:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:5:{s:6:\"weight\";i:0;s:4:\"type\";s:13:\"text_textarea\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"rows\";s:1:\"5\";}}s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:1:\"3\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:20:\"comment_node_article\";s:7:\"deleted\";s:1:\"0\";}}s:17:\"comment_node_page\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"1\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:17:\"comment_node_page\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:24:\"comment_node_data_center\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"12\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:24:\"comment_node_data_center\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:19:\"comment_node_device\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"31\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:19:\"comment_node_device\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:17:\"comment_node_host\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"29\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:17:\"comment_node_host\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:18:\"comment_node_panel\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"78\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:18:\"comment_node_panel\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:27:\"comment_node_vm_cache_space\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:3:\"157\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:27:\"comment_node_vm_cache_space\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:23:\"comment_node_vm_metrics\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"86\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:23:\"comment_node_vm_metrics\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:28:\"comment_node_virtual_machine\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"15\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:28:\"comment_node_virtual_machine\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:20:\"comment_node_vcenter\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"7\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:20:\"comment_node_vcenter\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:18:\"comment_node_vdisk\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"33\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:18:\"comment_node_vdisk\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:26:\"comment_node_vdisk_metrics\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:3:\"127\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:26:\"comment_node_vdisk_metrics\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}}s:4:\"node\";a:12:{s:7:\"article\";a:2:{s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";i:-4;s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"4\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:10:\"field_tags\";a:13:{s:5:\"label\";s:4:\"Tags\";s:11:\"description\";s:63:\"Enter a comma-separated list of words to describe your content.\";s:6:\"widget\";a:5:{s:6:\"weight\";i:-4;s:4:\"type\";s:21:\"taxonomy_autocomplete\";s:6:\"module\";s:8:\"taxonomy\";s:6:\"active\";i:0;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:21:\"taxonomy/autocomplete\";}}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";i:10;s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}s:6:\"teaser\";a:5:{s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";i:10;s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:8:\"required\";i:0;s:13:\"default_value\";N;s:2:\"id\";s:1:\"5\";s:8:\"field_id\";s:1:\"3\";s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:7:\"deleted\";s:1:\"0\";}}s:4:\"page\";a:1:{s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";i:-4;s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"2\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"page\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:11:\"data_center\";a:2:{s:4:\"body\";a:13:{s:5:\"label\";s:11:\"Description\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"-4\";s:4:\"type\";s:26:\"text_textarea_with_summary\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:4:\"rows\";s:2:\"10\";s:12:\"summary_rows\";i:5;}}s:8:\"settings\";a:3:{s:15:\"text_processing\";s:1:\"1\";s:15:\"display_summary\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"13\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:11:\"data_center\";s:7:\"deleted\";s:1:\"0\";}s:21:\"field_related_vcenter\";a:13:{s:5:\"label\";s:15:\"Related vCenter\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"-3\";s:4:\"type\";s:14:\"options_select\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:21:\"entityreference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:6:\"module\";s:15:\"entityreference\";s:6:\"weight\";i:1;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"79\";s:8:\"field_id\";s:2:\"62\";s:10:\"field_name\";s:21:\"field_related_vcenter\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:11:\"data_center\";s:7:\"deleted\";s:1:\"0\";}}s:6:\"device\";a:24:{s:15:\"field_serial_no\";a:13:{s:5:\"label\";s:9:\"Serial No\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:2;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"47\";s:8:\"field_id\";s:2:\"31\";s:10:\"field_name\";s:15:\"field_serial_no\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}s:10:\"field_size\";a:13:{s:5:\"label\";s:4:\"Size\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:3;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"48\";s:8:\"field_id\";s:2:\"32\";s:10:\"field_name\";s:10:\"field_size\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}s:17:\"field_device_type\";a:13:{s:5:\"label\";s:11:\"Device Type\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"5\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:4;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"49\";s:8:\"field_id\";s:2:\"33\";s:10:\"field_name\";s:17:\"field_device_type\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}s:22:\"field_multipath_plugin\";a:13:{s:5:\"label\";s:16:\"Multipath Plugin\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"6\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:5;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"50\";s:8:\"field_id\";s:2:\"34\";s:10:\"field_name\";s:22:\"field_multipath_plugin\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}s:16:\"field_devfs_path\";a:13:{s:5:\"label\";s:10:\"Devfs Path\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"7\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:6;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"51\";s:8:\"field_id\";s:2:\"35\";s:10:\"field_name\";s:16:\"field_devfs_path\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}s:12:\"field_vendor\";a:13:{s:5:\"label\";s:6:\"Vendor\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"8\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:7;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"52\";s:8:\"field_id\";s:2:\"36\";s:10:\"field_name\";s:12:\"field_vendor\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}s:11:\"field_model\";a:13:{s:5:\"label\";s:5:\"Model\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"9\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:8;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"53\";s:8:\"field_id\";s:2:\"37\";s:10:\"field_name\";s:11:\"field_model\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}s:14:\"field_revision\";a:13:{s:5:\"label\";s:8:\"Revision\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"10\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:9;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"54\";s:8:\"field_id\";s:2:\"38\";s:10:\"field_name\";s:14:\"field_revision\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}s:16:\"field_scsi_level\";a:13:{s:5:\"label\";s:10:\"SCSI Level\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"11\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:10;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"55\";s:8:\"field_id\";s:2:\"39\";s:10:\"field_name\";s:16:\"field_scsi_level\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}s:15:\"field_is_pseudo\";a:13:{s:5:\"label\";s:9:\"Is Pseudo\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"12\";s:4:\"type\";s:15:\"options_buttons\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"list_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";s:6:\"weight\";i:11;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"56\";s:8:\"field_id\";s:2:\"40\";s:10:\"field_name\";s:15:\"field_is_pseudo\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}s:12:\"field_status\";a:13:{s:5:\"label\";s:6:\"Status\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"13\";s:4:\"type\";s:15:\"options_buttons\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"list_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";s:6:\"weight\";i:12;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"57\";s:8:\"field_id\";s:2:\"41\";s:10:\"field_name\";s:12:\"field_status\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}s:20:\"field_is_rdm_capable\";a:13:{s:5:\"label\";s:14:\"Is RDM Capable\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"14\";s:4:\"type\";s:15:\"options_buttons\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"list_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";s:6:\"weight\";i:13;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"58\";s:8:\"field_id\";s:2:\"42\";s:10:\"field_name\";s:20:\"field_is_rdm_capable\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}s:14:\"field_is_local\";a:13:{s:5:\"label\";s:8:\"Is Local\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"15\";s:4:\"type\";s:15:\"options_buttons\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"list_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";s:6:\"weight\";i:14;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"59\";s:8:\"field_id\";s:2:\"43\";s:10:\"field_name\";s:14:\"field_is_local\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}s:18:\"field_is_removable\";a:13:{s:5:\"label\";s:12:\"Is Removable\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"16\";s:4:\"type\";s:15:\"options_buttons\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"list_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";s:6:\"weight\";i:15;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"60\";s:8:\"field_id\";s:2:\"44\";s:10:\"field_name\";s:18:\"field_is_removable\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}s:12:\"field_is_ssd\";a:13:{s:5:\"label\";s:6:\"Is SSD\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"17\";s:4:\"type\";s:15:\"options_buttons\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"list_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";s:6:\"weight\";i:16;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"61\";s:8:\"field_id\";s:2:\"45\";s:10:\"field_name\";s:12:\"field_is_ssd\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}s:16:\"field_is_offline\";a:13:{s:5:\"label\";s:10:\"Is Offline\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"18\";s:4:\"type\";s:15:\"options_buttons\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"list_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";s:6:\"weight\";i:17;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"62\";s:8:\"field_id\";s:2:\"46\";s:10:\"field_name\";s:16:\"field_is_offline\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}s:29:\"field_is_perennially_reserved\";a:13:{s:5:\"label\";s:23:\"Is Perennially Reserved\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"19\";s:4:\"type\";s:15:\"options_buttons\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"list_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";s:6:\"weight\";i:18;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"63\";s:8:\"field_id\";s:2:\"47\";s:10:\"field_name\";s:29:\"field_is_perennially_reserved\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}s:30:\"field_thin_provisioning_status\";a:13:{s:5:\"label\";s:24:\"Thin Provisioning Status\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"20\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:19;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"64\";s:8:\"field_id\";s:2:\"48\";s:10:\"field_name\";s:30:\"field_thin_provisioning_status\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}s:22:\"field_attached_filters\";a:13:{s:5:\"label\";s:16:\"Attached Filters\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"21\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:20;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"65\";s:8:\"field_id\";s:2:\"49\";s:10:\"field_name\";s:22:\"field_attached_filters\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}s:17:\"field_vaai_status\";a:13:{s:5:\"label\";s:11:\"VAAI Status\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"22\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:21;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"66\";s:8:\"field_id\";s:2:\"50\";s:10:\"field_name\";s:17:\"field_vaai_status\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}s:16:\"field_other_uids\";a:13:{s:5:\"label\";s:10:\"Other UIDs\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"23\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:22;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"67\";s:8:\"field_id\";s:2:\"51\";s:10:\"field_name\";s:16:\"field_other_uids\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}s:18:\"field_display_name\";a:13:{s:5:\"label\";s:12:\"Display Name\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"1\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:23;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"68\";s:8:\"field_id\";s:2:\"52\";s:10:\"field_name\";s:18:\"field_display_name\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}s:18:\"field_related_host\";a:13:{s:5:\"label\";s:12:\"Related Host\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:28:\"entityreference_autocomplete\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";i:1;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";s:2:\"60\";s:4:\"path\";s:0:\"\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:21:\"entityreference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:6:\"module\";s:15:\"entityreference\";s:6:\"weight\";i:24;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"81\";s:8:\"field_id\";s:2:\"64\";s:10:\"field_name\";s:18:\"field_related_host\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}s:13:\"field_is_vmfs\";a:13:{s:5:\"label\";s:7:\"Is VMFS\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"31\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:25;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"177\";s:8:\"field_id\";s:3:\"148\";s:10:\"field_name\";s:13:\"field_is_vmfs\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:6:\"device\";s:7:\"deleted\";s:1:\"0\";}}s:4:\"host\";a:32:{s:15:\"field_cpu_model\";a:13:{s:5:\"label\";s:9:\"Cpu Model\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:1;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"35\";s:8:\"field_id\";s:2:\"21\";s:10:\"field_name\";s:15:\"field_cpu_model\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:15:\"field_cpu_usage\";a:13:{s:5:\"label\";s:9:\"CPU Usage\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:2;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"36\";s:8:\"field_id\";s:2:\"18\";s:10:\"field_name\";s:15:\"field_cpu_usage\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:14:\"field_boottime\";a:13:{s:5:\"label\";s:8:\"BootTime\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"5\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:3;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"37\";s:8:\"field_id\";s:2:\"22\";s:10:\"field_name\";s:14:\"field_boottime\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:17:\"field_host_status\";a:13:{s:5:\"label\";s:11:\"Host Status\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"6\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:4;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"38\";s:8:\"field_id\";s:2:\"23\";s:10:\"field_name\";s:17:\"field_host_status\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:22:\"field_maintenance_mode\";a:13:{s:5:\"label\";s:16:\"Maintenance mode\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"7\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:5;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"39\";s:8:\"field_id\";s:2:\"24\";s:10:\"field_name\";s:22:\"field_maintenance_mode\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:21:\"field_physical_memory\";a:13:{s:5:\"label\";s:15:\"Physical Memory\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"8\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:6;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"40\";s:8:\"field_id\";s:2:\"25\";s:10:\"field_name\";s:21:\"field_physical_memory\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:13:\"field_vmotion\";a:13:{s:5:\"label\";s:7:\"VMotion\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"9\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:7;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"41\";s:8:\"field_id\";s:2:\"26\";s:10:\"field_name\";s:13:\"field_vmotion\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:21:\"field_reboot_required\";a:13:{s:5:\"label\";s:15:\"Reboot Required\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"10\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:8;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"42\";s:8:\"field_id\";s:2:\"27\";s:10:\"field_name\";s:21:\"field_reboot_required\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:19:\"field_host_username\";a:13:{s:5:\"label\";s:8:\"Username\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"11\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:10;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"74\";s:8:\"field_id\";s:2:\"58\";s:10:\"field_name\";s:19:\"field_host_username\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:19:\"field_host_password\";a:13:{s:5:\"label\";s:8:\"Password\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"12\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:11;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"75\";s:8:\"field_id\";s:2:\"59\";s:10:\"field_name\";s:19:\"field_host_password\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:19:\"field_bundle_status\";a:13:{s:5:\"label\";s:13:\"Bundle Status\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"13\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:12;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"77\";s:8:\"field_id\";s:2:\"61\";s:10:\"field_name\";s:19:\"field_bundle_status\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:16:\"field_datacenter\";a:13:{s:5:\"label\";s:10:\"Datacenter\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:28:\"entityreference_autocomplete\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";i:1;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";s:2:\"60\";s:4:\"path\";s:0:\"\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:21:\"entityreference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:6:\"module\";s:15:\"entityreference\";s:6:\"weight\";i:13;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"82\";s:8:\"field_id\";s:2:\"65\";s:10:\"field_name\";s:16:\"field_datacenter\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:22:\"field_software_on_host\";a:13:{s:5:\"label\";s:16:\"Software on host\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"14\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:14;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"85\";s:8:\"field_id\";s:2:\"68\";s:10:\"field_name\";s:22:\"field_software_on_host\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:24:\"field_allocated_segments\";a:13:{s:5:\"label\";s:18:\"Allocated Segments\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"31\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:15;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"89\";s:8:\"field_id\";s:2:\"70\";s:10:\"field_name\";s:24:\"field_allocated_segments\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:18:\"field_segment_size\";a:13:{s:5:\"label\";s:12:\"Segment Size\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"32\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:16;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"90\";s:8:\"field_id\";s:2:\"71\";s:10:\"field_name\";s:18:\"field_segment_size\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:26:\"field_max_virtual_machines\";a:13:{s:5:\"label\";s:20:\"Max Virtual Machines\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"33\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:17;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"91\";s:8:\"field_id\";s:2:\"72\";s:10:\"field_name\";s:26:\"field_max_virtual_machines\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:26:\"field_max_physical_devices\";a:13:{s:5:\"label\";s:20:\"Max Physical Devices\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"34\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:18;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"92\";s:8:\"field_id\";s:2:\"73\";s:10:\"field_name\";s:26:\"field_max_physical_devices\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:30:\"field_claimed_physical_devices\";a:13:{s:5:\"label\";s:24:\"Claimed Physical Devices\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"35\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:19;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"93\";s:8:\"field_id\";s:2:\"74\";s:10:\"field_name\";s:30:\"field_claimed_physical_devices\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:17:\"field_cache_state\";a:13:{s:5:\"label\";s:11:\"Cache State\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"36\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:20;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"94\";s:8:\"field_id\";s:2:\"75\";s:10:\"field_name\";s:17:\"field_cache_state\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:20:\"field_total_segments\";a:13:{s:5:\"label\";s:14:\"Total Segments\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"37\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:21;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"95\";s:8:\"field_id\";s:2:\"76\";s:10:\"field_name\";s:20:\"field_total_segments\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:32:\"field_allocated_virtual_machines\";a:13:{s:5:\"label\";s:26:\"Allocated Virtual Machines\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"38\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:22;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"96\";s:8:\"field_id\";s:2:\"77\";s:10:\"field_name\";s:32:\"field_allocated_virtual_machines\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:17:\"field_vib_version\";a:13:{s:5:\"label\";s:11:\"VIB Version\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"39\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:23;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"97\";s:8:\"field_id\";s:2:\"78\";s:10:\"field_name\";s:17:\"field_vib_version\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:16:\"field_total_size\";a:13:{s:5:\"label\";s:10:\"Total Size\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"43\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:24;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"98\";s:8:\"field_id\";s:2:\"79\";s:10:\"field_name\";s:16:\"field_total_size\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:20:\"field_naa_identifier\";a:13:{s:5:\"label\";s:14:\"NAA Identifier\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"41\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:25;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"99\";s:8:\"field_id\";s:2:\"80\";s:10:\"field_name\";s:20:\"field_naa_identifier\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:20:\"field_allocated_size\";a:13:{s:5:\"label\";s:14:\"Allocated Size\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"42\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:26;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"100\";s:8:\"field_id\";s:2:\"81\";s:10:\"field_name\";s:20:\"field_allocated_size\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:18:\"field_device_state\";a:13:{s:5:\"label\";s:12:\"Device State\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"44\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:27;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"101\";s:8:\"field_id\";s:2:\"82\";s:10:\"field_name\";s:18:\"field_device_state\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:16:\"field_host_model\";a:13:{s:5:\"label\";s:10:\"Host Model\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"45\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:28;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"172\";s:8:\"field_id\";s:3:\"143\";s:10:\"field_name\";s:16:\"field_host_model\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:17:\"field_host_vendor\";a:13:{s:5:\"label\";s:11:\"Host Vendor\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"46\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:29;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"173\";s:8:\"field_id\";s:3:\"144\";s:10:\"field_name\";s:17:\"field_host_vendor\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:10:\"field_hbtl\";a:13:{s:5:\"label\";s:4:\"HBTL\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"45\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:30;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"176\";s:8:\"field_id\";s:3:\"147\";s:10:\"field_name\";s:10:\"field_hbtl\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:13:\"field_host_ip\";a:13:{s:5:\"label\";s:2:\"IP\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"47\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:31;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"183\";s:8:\"field_id\";s:3:\"154\";s:10:\"field_name\";s:13:\"field_host_ip\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:9:\"field_drs\";a:13:{s:5:\"label\";s:3:\"drs\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"48\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:32;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"197\";s:8:\"field_id\";s:3:\"173\";s:10:\"field_name\";s:9:\"field_drs\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}s:8:\"field_ha\";a:13:{s:5:\"label\";s:2:\"HA\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"49\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:33;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"198\";s:8:\"field_id\";s:3:\"174\";s:10:\"field_name\";s:8:\"field_ha\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"host\";s:7:\"deleted\";s:1:\"0\";}}s:5:\"panel\";a:0:{}s:14:\"vm_cache_space\";a:3:{s:19:\"field_vm_cache_size\";a:13:{s:5:\"label\";s:10:\"Cache Size\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:3;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"161\";s:8:\"field_id\";s:3:\"132\";s:10:\"field_name\";s:19:\"field_vm_cache_size\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:14:\"vm_cache_space\";s:7:\"deleted\";s:1:\"0\";}s:30:\"field_cache_assigned_from_host\";a:13:{s:5:\"label\";s:18:\"Assigned from Host\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"11\";s:4:\"type\";s:27:\"node_reference_autocomplete\";s:6:\"module\";s:14:\"node_reference\";s:6:\"active\";i:1;s:8:\"settings\";a:3:{s:18:\"autocomplete_match\";s:8:\"contains\";s:4:\"size\";s:2:\"60\";s:17:\"autocomplete_path\";s:27:\"node_reference/autocomplete\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:22:\"node_reference_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"node_reference\";s:6:\"weight\";i:10;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"169\";s:8:\"field_id\";s:3:\"140\";s:10:\"field_name\";s:30:\"field_cache_assigned_from_host\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:14:\"vm_cache_space\";s:7:\"deleted\";s:1:\"0\";}s:27:\"field_cache_allocated_to_vm\";a:13:{s:5:\"label\";s:28:\"Allocated to Virtual Machine\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"10\";s:4:\"type\";s:27:\"node_reference_autocomplete\";s:6:\"module\";s:14:\"node_reference\";s:6:\"active\";i:1;s:8:\"settings\";a:3:{s:18:\"autocomplete_match\";s:8:\"contains\";s:4:\"size\";s:2:\"60\";s:17:\"autocomplete_path\";s:27:\"node_reference/autocomplete\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:22:\"node_reference_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"node_reference\";s:6:\"weight\";i:11;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"170\";s:8:\"field_id\";s:3:\"141\";s:10:\"field_name\";s:27:\"field_cache_allocated_to_vm\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:14:\"vm_cache_space\";s:7:\"deleted\";s:1:\"0\";}}s:10:\"vm_metrics\";a:16:{s:8:\"field_vm\";a:13:{s:5:\"label\";s:2:\"VM\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:28:\"entityreference_autocomplete\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";i:1;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";s:2:\"60\";s:4:\"path\";s:0:\"\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:21:\"entityreference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:6:\"module\";s:15:\"entityreference\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:32:\"The VM that this metrics are for\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"88\";s:8:\"field_id\";s:2:\"69\";s:10:\"field_name\";s:8:\"field_vm\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:10:\"vm_metrics\";s:7:\"deleted\";s:1:\"0\";}s:21:\"field_vm_read_latency\";a:13:{s:5:\"label\";s:12:\"Read latency\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"32\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:1;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:2:\"id\";s:3:\"112\";s:8:\"field_id\";s:2:\"94\";s:10:\"field_name\";s:21:\"field_vm_read_latency\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:10:\"vm_metrics\";s:7:\"deleted\";s:1:\"0\";}s:22:\"field_vm_write_latency\";a:13:{s:5:\"label\";s:13:\"Write latency\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"33\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:2;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:2:\"id\";s:3:\"113\";s:8:\"field_id\";s:2:\"95\";s:10:\"field_name\";s:22:\"field_vm_write_latency\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:10:\"vm_metrics\";s:7:\"deleted\";s:1:\"0\";}s:17:\"field_vm_read_ops\";a:13:{s:5:\"label\";s:8:\"Read ops\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"34\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:3;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:2:\"id\";s:3:\"114\";s:8:\"field_id\";s:2:\"96\";s:10:\"field_name\";s:17:\"field_vm_read_ops\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:10:\"vm_metrics\";s:7:\"deleted\";s:1:\"0\";}s:18:\"field_vm_write_ops\";a:13:{s:5:\"label\";s:9:\"Write ops\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"35\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:4;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:2:\"id\";s:3:\"115\";s:8:\"field_id\";s:2:\"97\";s:10:\"field_name\";s:18:\"field_vm_write_ops\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:10:\"vm_metrics\";s:7:\"deleted\";s:1:\"0\";}s:13:\"field_vm_hits\";a:13:{s:5:\"label\";s:4:\"Hits\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"36\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:5;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:2:\"id\";s:3:\"116\";s:8:\"field_id\";s:2:\"98\";s:10:\"field_name\";s:13:\"field_vm_hits\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:10:\"vm_metrics\";s:7:\"deleted\";s:1:\"0\";}s:20:\"field_vm_read_blocks\";a:13:{s:5:\"label\";s:11:\"Read blocks\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"37\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:6;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:2:\"id\";s:3:\"117\";s:8:\"field_id\";s:2:\"99\";s:10:\"field_name\";s:20:\"field_vm_read_blocks\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:10:\"vm_metrics\";s:7:\"deleted\";s:1:\"0\";}s:22:\"field_vm_cache_latency\";a:13:{s:5:\"label\";s:13:\"Cache latency\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"40\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:7;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:2:\"id\";s:3:\"118\";s:8:\"field_id\";s:3:\"100\";s:10:\"field_name\";s:22:\"field_vm_cache_latency\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:10:\"vm_metrics\";s:7:\"deleted\";s:1:\"0\";}s:19:\"field_vm_population\";a:13:{s:5:\"label\";s:10:\"Population\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"41\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:8;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:2:\"id\";s:3:\"119\";s:8:\"field_id\";s:3:\"101\";s:10:\"field_name\";s:19:\"field_vm_population\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:10:\"vm_metrics\";s:7:\"deleted\";s:1:\"0\";}s:22:\"field_vm_usable_blocks\";a:13:{s:5:\"label\";s:13:\"Usable blocks\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"39\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:9;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:2:\"id\";s:3:\"120\";s:8:\"field_id\";s:3:\"102\";s:10:\"field_name\";s:22:\"field_vm_usable_blocks\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:10:\"vm_metrics\";s:7:\"deleted\";s:1:\"0\";}s:21:\"field_vm_write_blocks\";a:13:{s:5:\"label\";s:12:\"Write blocks\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"38\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:10;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:2:\"id\";s:3:\"121\";s:8:\"field_id\";s:3:\"103\";s:10:\"field_name\";s:21:\"field_vm_write_blocks\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:10:\"vm_metrics\";s:7:\"deleted\";s:1:\"0\";}s:19:\"field_vm_insertions\";a:13:{s:5:\"label\";s:10:\"Insertions\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"42\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:11;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:2:\"id\";s:3:\"122\";s:8:\"field_id\";s:3:\"104\";s:10:\"field_name\";s:19:\"field_vm_insertions\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:10:\"vm_metrics\";s:7:\"deleted\";s:1:\"0\";}s:22:\"field_vm_population_pc\";a:12:{s:5:\"label\";s:12:\"Population %\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"43\";s:4:\"type\";s:8:\"computed\";s:6:\"module\";s:14:\"computed_field\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:20:\"computed_field_plain\";s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"computed_field\";s:6:\"weight\";i:13;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:43:\"Population % = (Population / Usable Blocks)\";s:2:\"id\";s:3:\"125\";s:8:\"field_id\";s:3:\"107\";s:10:\"field_name\";s:22:\"field_vm_population_pc\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:10:\"vm_metrics\";s:7:\"deleted\";s:1:\"0\";}s:26:\"field_vm_insertion_rate_pc\";a:12:{s:5:\"label\";s:16:\"Insertion rate %\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"44\";s:4:\"type\";s:8:\"computed\";s:6:\"module\";s:14:\"computed_field\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:20:\"computed_field_plain\";s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"computed_field\";s:6:\"weight\";i:14;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:64:\"Insertion rate % = ( Insertions / ( ReadBlocks + WriteBlocks ) )\";s:2:\"id\";s:3:\"126\";s:8:\"field_id\";s:3:\"108\";s:10:\"field_name\";s:26:\"field_vm_insertion_rate_pc\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:10:\"vm_metrics\";s:7:\"deleted\";s:1:\"0\";}s:15:\"field_timestamp\";a:12:{s:5:\"label\";s:9:\"Timestamp\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:10:\"date_popup\";s:6:\"module\";s:4:\"date\";s:6:\"active\";i:1;s:8:\"settings\";a:6:{s:12:\"input_format\";s:13:\"m/d/Y - H:i:s\";s:19:\"input_format_custom\";s:0:\"\";s:10:\"year_range\";s:5:\"-3:+3\";s:9:\"increment\";s:2:\"15\";s:14:\"label_position\";s:5:\"above\";s:10:\"text_parts\";a:0:{}}}s:8:\"settings\";a:5:{s:13:\"default_value\";s:3:\"now\";s:18:\"default_value_code\";s:0:\"\";s:14:\"default_value2\";s:4:\"same\";s:19:\"default_value_code2\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"date_default\";s:8:\"settings\";a:5:{s:11:\"format_type\";s:4:\"long\";s:15:\"multiple_number\";s:0:\"\";s:13:\"multiple_from\";s:0:\"\";s:11:\"multiple_to\";s:0:\"\";s:6:\"fromto\";s:4:\"both\";}s:6:\"module\";s:4:\"date\";s:6:\"weight\";i:15;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:2:\"id\";s:3:\"147\";s:8:\"field_id\";s:3:\"122\";s:10:\"field_name\";s:15:\"field_timestamp\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:10:\"vm_metrics\";s:7:\"deleted\";s:1:\"0\";}s:20:\"field_vm_hit_rate_pc\";a:12:{s:5:\"label\";s:10:\"Hit Rate %\";s:6:\"widget\";a:4:{s:4:\"type\";s:8:\"computed\";s:6:\"weight\";s:2:\"45\";s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"computed_field\";}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:20:\"computed_field_plain\";s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"computed_field\";s:6:\"weight\";i:16;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:3:\"196\";s:8:\"field_id\";s:3:\"172\";s:10:\"field_name\";s:20:\"field_vm_hit_rate_pc\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:10:\"vm_metrics\";s:7:\"deleted\";s:1:\"0\";}}s:15:\"virtual_machine\";a:33:{s:19:\"field_vm_ip_address\";a:13:{s:5:\"label\";s:10:\"IP Address\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"17\";s:8:\"field_id\";s:1:\"9\";s:10:\"field_name\";s:19:\"field_vm_ip_address\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:17:\"field_memory_size\";a:13:{s:5:\"label\";s:11:\"Memory Size\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"6\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"19\";s:8:\"field_id\";s:2:\"11\";s:10:\"field_name\";s:17:\"field_memory_size\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:14:\"field_template\";a:13:{s:5:\"label\";s:8:\"Template\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"7\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"21\";s:8:\"field_id\";s:2:\"13\";s:10:\"field_name\";s:14:\"field_template\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:18:\"field_vm_path_name\";a:13:{s:5:\"label\";s:12:\"VM Path Name\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"8\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"22\";s:8:\"field_id\";s:2:\"14\";s:10:\"field_name\";s:18:\"field_vm_path_name\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:14:\"field_guest_os\";a:13:{s:5:\"label\";s:8:\"Guest OS\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"9\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"23\";s:8:\"field_id\";s:2:\"15\";s:10:\"field_name\";s:14:\"field_guest_os\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:14:\"field_guest_id\";a:13:{s:5:\"label\";s:8:\"Guest ID\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"10\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"5\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"24\";s:8:\"field_id\";s:2:\"16\";s:10:\"field_name\";s:14:\"field_guest_id\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:15:\"field_cpu_usage\";a:13:{s:5:\"label\";s:9:\"CPU Usage\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"11\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"7\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"26\";s:8:\"field_id\";s:2:\"18\";s:10:\"field_name\";s:15:\"field_cpu_usage\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:23:\"field_host_memory_usage\";a:13:{s:5:\"label\";s:17:\"Host Memory Usage\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"12\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"10\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"27\";s:8:\"field_id\";s:2:\"19\";s:10:\"field_name\";s:23:\"field_host_memory_usage\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:24:\"field_guest_memory_usage\";a:13:{s:5:\"label\";s:18:\"Guest Memory Usage\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"13\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"11\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"28\";s:8:\"field_id\";s:2:\"20\";s:10:\"field_name\";s:24:\"field_guest_memory_usage\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:17:\"field_vm_username\";a:13:{s:5:\"label\";s:8:\"Username\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"12\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"72\";s:8:\"field_id\";s:2:\"56\";s:10:\"field_name\";s:17:\"field_vm_username\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:17:\"field_vm_password\";a:13:{s:5:\"label\";s:8:\"Password\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"13\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"73\";s:8:\"field_id\";s:2:\"57\";s:10:\"field_name\";s:17:\"field_vm_password\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:19:\"field_driver_status\";a:13:{s:5:\"label\";s:13:\"Driver Status\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"14\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"14\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"76\";s:8:\"field_id\";s:2:\"60\";s:10:\"field_name\";s:19:\"field_driver_status\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:10:\"field_host\";a:13:{s:5:\"label\";s:4:\"Host\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"5\";s:4:\"type\";s:28:\"entityreference_autocomplete\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";i:1;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";s:2:\"60\";s:4:\"path\";s:0:\"\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:21:\"entityreference_label\";s:6:\"weight\";s:2:\"15\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:6:\"module\";s:15:\"entityreference\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"83\";s:8:\"field_id\";s:2:\"66\";s:10:\"field_name\";s:10:\"field_host\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:18:\"field_vmware_tools\";a:13:{s:5:\"label\";s:12:\"VMware Tools\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"15\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"16\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"84\";s:8:\"field_id\";s:2:\"67\";s:10:\"field_name\";s:18:\"field_vmware_tools\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:15:\"field_no_of_cpu\";a:13:{s:5:\"label\";s:9:\"no_of_cpu\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"17\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"17\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"102\";s:8:\"field_id\";s:2:\"83\";s:10:\"field_name\";s:15:\"field_no_of_cpu\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:19:\"field_virtual_disks\";a:13:{s:5:\"label\";s:13:\"virtual_disks\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"18\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"18\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"103\";s:8:\"field_id\";s:2:\"84\";s:10:\"field_name\";s:19:\"field_virtual_disks\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:22:\"field_fa_build_version\";a:13:{s:5:\"label\";s:13:\"Build Version\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"33\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"19\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}s:2:\"id\";s:3:\"104\";s:8:\"field_id\";s:2:\"86\";s:10:\"field_name\";s:22:\"field_fa_build_version\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:19:\"field_fa_cache_mode\";a:13:{s:5:\"label\";s:10:\"Cache Mode\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"34\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"20\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}s:2:\"id\";s:3:\"105\";s:8:\"field_id\";s:2:\"87\";s:10:\"field_name\";s:19:\"field_fa_cache_mode\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:29:\"field_fa_administration_state\";a:13:{s:5:\"label\";s:20:\"Administration State\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"35\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"21\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}s:2:\"id\";s:3:\"106\";s:8:\"field_id\";s:2:\"88\";s:10:\"field_name\";s:29:\"field_fa_administration_state\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:19:\"field_fa_cache_size\";a:13:{s:5:\"label\";s:10:\"Cache Size\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"36\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"22\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:2:\"id\";s:3:\"107\";s:8:\"field_id\";s:2:\"89\";s:10:\"field_name\";s:19:\"field_fa_cache_size\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:26:\"field_fa_operational_state\";a:13:{s:5:\"label\";s:17:\"Operational State\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"37\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"23\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}s:2:\"id\";s:3:\"108\";s:8:\"field_id\";s:2:\"90\";s:10:\"field_name\";s:26:\"field_fa_operational_state\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:28:\"field_fa_operational_message\";a:13:{s:5:\"label\";s:19:\"Operational Message\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"38\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"24\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}s:2:\"id\";s:3:\"109\";s:8:\"field_id\";s:2:\"91\";s:10:\"field_name\";s:28:\"field_fa_operational_message\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:26:\"field_fa_performance_state\";a:13:{s:5:\"label\";s:17:\"Performance State\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"39\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"25\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}s:2:\"id\";s:3:\"110\";s:8:\"field_id\";s:2:\"92\";s:10:\"field_name\";s:26:\"field_fa_performance_state\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:22:\"field_fa_generation_id\";a:13:{s:5:\"label\";s:13:\"Generation ID\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"40\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"26\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}s:2:\"id\";s:3:\"111\";s:8:\"field_id\";s:2:\"93\";s:10:\"field_name\";s:22:\"field_fa_generation_id\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:16:\"field_cachespace\";a:13:{s:5:\"label\";s:10:\"Cachespace\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"41\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"27\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"149\";s:8:\"field_id\";s:3:\"127\";s:10:\"field_name\";s:16:\"field_cachespace\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:18:\"field_install_port\";a:13:{s:5:\"label\";s:12:\"Install Port\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"19\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:28;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"7010\";}}s:2:\"id\";s:3:\"171\";s:8:\"field_id\";s:3:\"142\";s:10:\"field_name\";s:18:\"field_install_port\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:20:\"field_vm_vmotionable\";a:13:{s:5:\"label\";s:12:\"V Motionable\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"21\";s:4:\"type\";s:13:\"options_onoff\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:13:\"display_label\";i:1;}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"list_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";s:6:\"weight\";i:29;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:2:\"id\";s:3:\"174\";s:8:\"field_id\";s:3:\"145\";s:10:\"field_name\";s:20:\"field_vm_vmotionable\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:22:\"field_fa_usable_blocks\";a:13:{s:5:\"label\";s:13:\"Usable Blocks\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"42\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:30;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"178\";s:8:\"field_id\";s:3:\"149\";s:10:\"field_name\";s:22:\"field_fa_usable_blocks\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:20:\"field_fa_sector_size\";a:13:{s:5:\"label\";s:11:\"Sector Size\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"43\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:31;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"185\";s:8:\"field_id\";s:3:\"156\";s:10:\"field_name\";s:20:\"field_fa_sector_size\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:17:\"field_vm_hostname\";a:13:{s:5:\"label\";s:8:\"Hostname\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"1\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:32;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"188\";s:8:\"field_id\";s:3:\"159\";s:10:\"field_name\";s:17:\"field_vm_hostname\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:31:\"field_fa_metrics_reset_interval\";a:13:{s:5:\"label\";s:22:\"Metrics Reset Interval\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"44\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:33;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"189\";s:8:\"field_id\";s:3:\"160\";s:10:\"field_name\";s:31:\"field_fa_metrics_reset_interval\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:23:\"field_vm_vmotion_policy\";a:13:{s:5:\"label\";s:17:\"VM vMotion Policy\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"24\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:35;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"194\";s:8:\"field_id\";s:3:\"170\";s:10:\"field_name\";s:23:\"field_vm_vmotion_policy\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}s:25:\"field_vm_vmotion_hostlist\";a:13:{s:5:\"label\";s:19:\"VM vMotion Hostlist\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"22\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";i:0;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:36;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"195\";s:8:\"field_id\";s:3:\"171\";s:10:\"field_name\";s:25:\"field_vm_vmotion_hostlist\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:15:\"virtual_machine\";s:7:\"deleted\";s:1:\"0\";}}s:7:\"vcenter\";a:7:{s:4:\"body\";a:13:{s:5:\"label\";s:11:\"Description\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"5\";s:4:\"type\";s:26:\"text_textarea_with_summary\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:4:\"rows\";s:2:\"10\";s:12:\"summary_rows\";i:5;}}s:8:\"settings\";a:3:{s:15:\"text_processing\";s:1:\"1\";s:15:\"display_summary\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:1:\"8\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"vcenter\";s:7:\"deleted\";s:1:\"0\";}s:16:\"field_ip_address\";a:13:{s:5:\"label\";s:10:\"IP Address\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:1;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:27:\"Please enter the IP Address\";s:13:\"default_value\";N;s:2:\"id\";s:1:\"9\";s:8:\"field_id\";s:1:\"5\";s:10:\"field_name\";s:16:\"field_ip_address\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"vcenter\";s:7:\"deleted\";s:1:\"0\";}s:14:\"field_username\";a:13:{s:5:\"label\";s:8:\"Username\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:2;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:27:\"Please provide the username\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"10\";s:8:\"field_id\";s:1:\"6\";s:10:\"field_name\";s:14:\"field_username\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"vcenter\";s:7:\"deleted\";s:1:\"0\";}s:14:\"field_password\";a:13:{s:5:\"label\";s:8:\"Password\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:3;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:27:\"Please provide the password\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"11\";s:8:\"field_id\";s:1:\"7\";s:10:\"field_name\";s:14:\"field_password\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"vcenter\";s:7:\"deleted\";s:1:\"0\";}s:23:\"field_rediscover_status\";a:13:{s:5:\"label\";s:17:\"Rediscover Status\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"7\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:4;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"186\";s:8:\"field_id\";s:3:\"157\";s:10:\"field_name\";s:23:\"field_rediscover_status\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"vcenter\";s:7:\"deleted\";s:1:\"0\";}s:14:\"field_hostname\";a:13:{s:5:\"label\";s:8:\"Hostname\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"1\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:5;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"187\";s:8:\"field_id\";s:3:\"158\";s:10:\"field_name\";s:14:\"field_hostname\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"vcenter\";s:7:\"deleted\";s:1:\"0\";}s:14:\"field_fmc_uuid\";a:13:{s:5:\"label\";s:8:\"FMC UUID\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"8\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:6;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"192\";s:8:\"field_id\";s:3:\"168\";s:10:\"field_name\";s:14:\"field_fmc_uuid\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"vcenter\";s:7:\"deleted\";s:1:\"0\";}}s:5:\"vdisk\";a:14:{s:14:\"field_capacity\";a:13:{s:5:\"label\";s:8:\"Capacity\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:2;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"69\";s:8:\"field_id\";s:2:\"53\";s:10:\"field_name\";s:14:\"field_capacity\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"vdisk\";s:7:\"deleted\";s:1:\"0\";}s:10:\"field_path\";a:13:{s:5:\"label\";s:4:\"Path\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:3;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"70\";s:8:\"field_id\";s:2:\"54\";s:10:\"field_name\";s:10:\"field_path\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"vdisk\";s:7:\"deleted\";s:1:\"0\";}s:15:\"field_freespace\";a:13:{s:5:\"label\";s:9:\"Freespace\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"5\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:4;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"71\";s:8:\"field_id\";s:2:\"55\";s:10:\"field_name\";s:15:\"field_freespace\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"vdisk\";s:7:\"deleted\";s:1:\"0\";}s:21:\"field_virtual_machine\";a:13:{s:5:\"label\";s:15:\"Virtual Machine\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"7\";s:4:\"type\";s:28:\"entityreference_autocomplete\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";i:1;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";s:2:\"60\";s:4:\"path\";s:0:\"\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:21:\"entityreference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:6:\"module\";s:15:\"entityreference\";s:6:\"weight\";i:5;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"80\";s:8:\"field_id\";s:2:\"63\";s:10:\"field_name\";s:21:\"field_virtual_machine\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"vdisk\";s:7:\"deleted\";s:1:\"0\";}s:16:\"field_disk_index\";a:13:{s:5:\"label\";s:10:\"Disk Index\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"9\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:6;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"148\";s:8:\"field_id\";s:3:\"126\";s:10:\"field_name\";s:16:\"field_disk_index\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"vdisk\";s:7:\"deleted\";s:1:\"0\";}s:29:\"field_fa_administration_state\";a:13:{s:5:\"label\";s:20:\"Administration State\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"10\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:7;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}s:2:\"id\";s:3:\"151\";s:8:\"field_id\";s:2:\"88\";s:10:\"field_name\";s:29:\"field_fa_administration_state\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"vdisk\";s:7:\"deleted\";s:1:\"0\";}s:19:\"field_fa_cache_mode\";a:13:{s:5:\"label\";s:10:\"Cache Mode\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"9\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:8;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}s:2:\"id\";s:3:\"152\";s:8:\"field_id\";s:2:\"87\";s:10:\"field_name\";s:19:\"field_fa_cache_mode\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"vdisk\";s:7:\"deleted\";s:1:\"0\";}s:26:\"field_fa_operational_state\";a:13:{s:5:\"label\";s:17:\"Operational State\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"11\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:9;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}s:2:\"id\";s:3:\"153\";s:8:\"field_id\";s:2:\"90\";s:10:\"field_name\";s:26:\"field_fa_operational_state\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"vdisk\";s:7:\"deleted\";s:1:\"0\";}s:28:\"field_fa_operational_message\";a:13:{s:5:\"label\";s:19:\"Operational Message\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"12\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:10;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}s:2:\"id\";s:3:\"154\";s:8:\"field_id\";s:2:\"91\";s:10:\"field_name\";s:28:\"field_fa_operational_message\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"vdisk\";s:7:\"deleted\";s:1:\"0\";}s:26:\"field_fa_performance_state\";a:13:{s:5:\"label\";s:17:\"Performance State\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"13\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:11;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}s:2:\"id\";s:3:\"155\";s:8:\"field_id\";s:2:\"92\";s:10:\"field_name\";s:26:\"field_fa_performance_state\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"vdisk\";s:7:\"deleted\";s:1:\"0\";}s:22:\"field_vdisk_identifier\";a:13:{s:5:\"label\";s:10:\"Identifier\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"14\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:12;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"156\";s:8:\"field_id\";s:3:\"128\";s:10:\"field_name\";s:22:\"field_vdisk_identifier\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"vdisk\";s:7:\"deleted\";s:1:\"0\";}s:16:\"field_vdisk_name\";a:13:{s:5:\"label\";s:10:\"vDisk Name\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"1\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:13;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"179\";s:8:\"field_id\";s:3:\"150\";s:10:\"field_name\";s:16:\"field_vdisk_name\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"vdisk\";s:7:\"deleted\";s:1:\"0\";}s:16:\"field_vdisk_type\";a:13:{s:5:\"label\";s:10:\"vDisk Type\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:14;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"180\";s:8:\"field_id\";s:3:\"151\";s:10:\"field_name\";s:16:\"field_vdisk_type\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"vdisk\";s:7:\"deleted\";s:1:\"0\";}s:14:\"field_vdisk_id\";a:13:{s:5:\"label\";s:8:\"vDisk Id\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"6\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:15;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"181\";s:8:\"field_id\";s:3:\"152\";s:10:\"field_name\";s:14:\"field_vdisk_id\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"vdisk\";s:7:\"deleted\";s:1:\"0\";}}s:13:\"vdisk_metrics\";a:17:{s:11:\"field_vdisk\";a:13:{s:5:\"label\";s:5:\"vDisk\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:28:\"entityreference_autocomplete\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";i:1;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";s:2:\"60\";s:4:\"path\";s:0:\"\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:21:\"entityreference_label\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:6:\"module\";s:15:\"entityreference\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"129\";s:8:\"field_id\";s:3:\"109\";s:10:\"field_name\";s:11:\"field_vdisk\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:13:\"vdisk_metrics\";s:7:\"deleted\";s:1:\"0\";}s:24:\"field_vdisk_read_latency\";a:13:{s:5:\"label\";s:12:\"Read latency\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_decimal\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";s:1:\"2\";s:13:\"prefix_suffix\";i:1;}s:6:\"module\";s:6:\"number\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:2:\"id\";s:3:\"130\";s:8:\"field_id\";s:3:\"110\";s:10:\"field_name\";s:24:\"field_vdisk_read_latency\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:13:\"vdisk_metrics\";s:7:\"deleted\";s:1:\"0\";}s:25:\"field_vdisk_write_latency\";a:13:{s:5:\"label\";s:13:\"Write latency\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"5\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_decimal\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:2:\"id\";s:3:\"131\";s:8:\"field_id\";s:3:\"111\";s:10:\"field_name\";s:25:\"field_vdisk_write_latency\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:13:\"vdisk_metrics\";s:7:\"deleted\";s:1:\"0\";}s:20:\"field_vdisk_read_ops\";a:13:{s:5:\"label\";s:8:\"Read ops\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"6\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_decimal\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:2:\"id\";s:3:\"132\";s:8:\"field_id\";s:3:\"112\";s:10:\"field_name\";s:20:\"field_vdisk_read_ops\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:13:\"vdisk_metrics\";s:7:\"deleted\";s:1:\"0\";}s:21:\"field_vdisk_write_ops\";a:13:{s:5:\"label\";s:9:\"Write ops\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"7\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_decimal\";s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:2:\"id\";s:3:\"133\";s:8:\"field_id\";s:3:\"113\";s:10:\"field_name\";s:21:\"field_vdisk_write_ops\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:13:\"vdisk_metrics\";s:7:\"deleted\";s:1:\"0\";}s:16:\"field_vdisk_hits\";a:13:{s:5:\"label\";s:4:\"Hits\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"9\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:6:\"weight\";s:1:\"5\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:2:\"id\";s:3:\"134\";s:8:\"field_id\";s:3:\"114\";s:10:\"field_name\";s:16:\"field_vdisk_hits\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:13:\"vdisk_metrics\";s:7:\"deleted\";s:1:\"0\";}s:23:\"field_vdisk_read_blocks\";a:13:{s:5:\"label\";s:11:\"Read blocks\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"10\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:6:\"weight\";s:1:\"6\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:2:\"id\";s:3:\"135\";s:8:\"field_id\";s:3:\"115\";s:10:\"field_name\";s:23:\"field_vdisk_read_blocks\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:13:\"vdisk_metrics\";s:7:\"deleted\";s:1:\"0\";}s:25:\"field_vdisk_cache_latency\";a:13:{s:5:\"label\";s:13:\"Cache latency\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"12\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_decimal\";s:6:\"weight\";s:1:\"7\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:2:\"id\";s:3:\"136\";s:8:\"field_id\";s:3:\"116\";s:10:\"field_name\";s:25:\"field_vdisk_cache_latency\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:13:\"vdisk_metrics\";s:7:\"deleted\";s:1:\"0\";}s:22:\"field_vdisk_population\";a:13:{s:5:\"label\";s:10:\"Population\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"13\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:6:\"weight\";s:1:\"8\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:2:\"id\";s:3:\"137\";s:8:\"field_id\";s:3:\"117\";s:10:\"field_name\";s:22:\"field_vdisk_population\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:13:\"vdisk_metrics\";s:7:\"deleted\";s:1:\"0\";}s:25:\"field_vdisk_usable_blocks\";a:13:{s:5:\"label\";s:13:\"Usable blocks\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"14\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:6:\"weight\";s:1:\"9\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:2:\"id\";s:3:\"138\";s:8:\"field_id\";s:3:\"118\";s:10:\"field_name\";s:25:\"field_vdisk_usable_blocks\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:13:\"vdisk_metrics\";s:7:\"deleted\";s:1:\"0\";}s:22:\"field_vdisk_insertions\";a:13:{s:5:\"label\";s:10:\"Insertions\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"15\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:6:\"weight\";s:2:\"10\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:2:\"id\";s:3:\"139\";s:8:\"field_id\";s:3:\"119\";s:10:\"field_name\";s:22:\"field_vdisk_insertions\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:13:\"vdisk_metrics\";s:7:\"deleted\";s:1:\"0\";}s:24:\"field_vdisk_write_blocks\";a:13:{s:5:\"label\";s:12:\"Write blocks\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"11\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:6:\"weight\";s:2:\"11\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}s:2:\"id\";s:3:\"140\";s:8:\"field_id\";s:3:\"120\";s:10:\"field_name\";s:24:\"field_vdisk_write_blocks\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:13:\"vdisk_metrics\";s:7:\"deleted\";s:1:\"0\";}s:15:\"field_timestamp\";a:12:{s:5:\"label\";s:9:\"Timestamp\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:10:\"date_popup\";s:6:\"module\";s:4:\"date\";s:6:\"active\";i:1;s:8:\"settings\";a:6:{s:12:\"input_format\";s:13:\"m/d/Y - H:i:s\";s:19:\"input_format_custom\";s:0:\"\";s:10:\"year_range\";s:5:\"-3:+3\";s:9:\"increment\";s:2:\"15\";s:14:\"label_position\";s:5:\"above\";s:10:\"text_parts\";a:0:{}}}s:8:\"settings\";a:5:{s:13:\"default_value\";s:3:\"now\";s:18:\"default_value_code\";s:0:\"\";s:14:\"default_value2\";s:4:\"same\";s:19:\"default_value_code2\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"date_default\";s:6:\"weight\";s:2:\"12\";s:8:\"settings\";a:5:{s:11:\"format_type\";s:4:\"long\";s:15:\"multiple_number\";s:0:\"\";s:13:\"multiple_from\";s:0:\"\";s:11:\"multiple_to\";s:0:\"\";s:6:\"fromto\";s:4:\"both\";}s:6:\"module\";s:4:\"date\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:3:\"143\";s:8:\"field_id\";s:3:\"122\";s:10:\"field_name\";s:15:\"field_timestamp\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:13:\"vdisk_metrics\";s:7:\"deleted\";s:1:\"0\";}s:25:\"field_vdisk_population_pc\";a:12:{s:5:\"label\";s:12:\"Population %\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"16\";s:4:\"type\";s:8:\"computed\";s:6:\"module\";s:14:\"computed_field\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:20:\"computed_field_plain\";s:6:\"weight\";s:2:\"14\";s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"computed_field\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:43:\"Population % = (Population / Usable Blocks)\";s:2:\"id\";s:3:\"145\";s:8:\"field_id\";s:3:\"124\";s:10:\"field_name\";s:25:\"field_vdisk_population_pc\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:13:\"vdisk_metrics\";s:7:\"deleted\";s:1:\"0\";}s:29:\"field_vdisk_insertion_rate_pc\";a:12:{s:5:\"label\";s:16:\"Insertion rate %\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"17\";s:4:\"type\";s:8:\"computed\";s:6:\"module\";s:14:\"computed_field\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:20:\"computed_field_plain\";s:6:\"weight\";s:2:\"15\";s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"computed_field\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:64:\"Insertion rate % = ( Insertions / ( ReadBlocks + WriteBlocks ) )\";s:2:\"id\";s:3:\"146\";s:8:\"field_id\";s:3:\"125\";s:10:\"field_name\";s:29:\"field_vdisk_insertion_rate_pc\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:13:\"vdisk_metrics\";s:7:\"deleted\";s:1:\"0\";}s:13:\"field_hit_ops\";a:13:{s:5:\"label\";s:7:\"Hit Ops\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"8\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:16;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:3:\"184\";s:8:\"field_id\";s:3:\"155\";s:10:\"field_name\";s:13:\"field_hit_ops\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:13:\"vdisk_metrics\";s:7:\"deleted\";s:1:\"0\";}s:23:\"field_vdisk_hit_rate_pc\";a:12:{s:5:\"label\";s:10:\"Hit Rate %\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"18\";s:4:\"type\";s:8:\"computed\";s:6:\"module\";s:14:\"computed_field\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:20:\"computed_field_plain\";s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"computed_field\";s:6:\"weight\";i:17;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:3:\"199\";s:8:\"field_id\";s:3:\"175\";s:10:\"field_name\";s:23:\"field_vdisk_hit_rate_pc\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:13:\"vdisk_metrics\";s:7:\"deleted\";s:1:\"0\";}}}s:17:\"search_api_server\";a:1:{s:17:\"search_api_server\";a:0:{}}s:16:\"search_api_index\";a:1:{s:16:\"search_api_index\";a:0:{}}s:15:\"search_api_page\";a:1:{s:15:\"search_api_page\";a:0:{}}s:4:\"file\";a:1:{s:4:\"file\";a:0:{}}s:13:\"taxonomy_term\";a:1:{s:4:\"tags\";a:0:{}}s:19:\"taxonomy_vocabulary\";a:1:{s:19:\"taxonomy_vocabulary\";a:0:{}}s:4:\"user\";a:1:{s:4:\"user\";a:0:{}}}s:12:\"extra_fields\";a:4:{s:7:\"comment\";a:12:{s:18:\"comment_node_panel\";a:1:{s:4:\"form\";a:2:{s:6:\"author\";a:3:{s:5:\"label\";s:6:\"Author\";s:11:\"description\";s:16:\"Author textfield\";s:6:\"weight\";i:-2;}s:7:\"subject\";a:3:{s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:17:\"Subject textfield\";s:6:\"weight\";i:-1;}}}s:20:\"comment_node_article\";a:1:{s:4:\"form\";a:2:{s:6:\"author\";a:3:{s:5:\"label\";s:6:\"Author\";s:11:\"description\";s:16:\"Author textfield\";s:6:\"weight\";i:-2;}s:7:\"subject\";a:3:{s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:17:\"Subject textfield\";s:6:\"weight\";i:-1;}}}s:24:\"comment_node_data_center\";a:1:{s:4:\"form\";a:2:{s:6:\"author\";a:3:{s:5:\"label\";s:6:\"Author\";s:11:\"description\";s:16:\"Author textfield\";s:6:\"weight\";i:-2;}s:7:\"subject\";a:3:{s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:17:\"Subject textfield\";s:6:\"weight\";i:-1;}}}s:19:\"comment_node_device\";a:1:{s:4:\"form\";a:2:{s:6:\"author\";a:3:{s:5:\"label\";s:6:\"Author\";s:11:\"description\";s:16:\"Author textfield\";s:6:\"weight\";i:-2;}s:7:\"subject\";a:3:{s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:17:\"Subject textfield\";s:6:\"weight\";i:-1;}}}s:17:\"comment_node_host\";a:1:{s:4:\"form\";a:2:{s:6:\"author\";a:3:{s:5:\"label\";s:6:\"Author\";s:11:\"description\";s:16:\"Author textfield\";s:6:\"weight\";i:-2;}s:7:\"subject\";a:3:{s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:17:\"Subject textfield\";s:6:\"weight\";i:-1;}}}s:17:\"comment_node_page\";a:1:{s:4:\"form\";a:2:{s:6:\"author\";a:3:{s:5:\"label\";s:6:\"Author\";s:11:\"description\";s:16:\"Author textfield\";s:6:\"weight\";i:-2;}s:7:\"subject\";a:3:{s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:17:\"Subject textfield\";s:6:\"weight\";i:-1;}}}s:20:\"comment_node_vcenter\";a:1:{s:4:\"form\";a:2:{s:6:\"author\";a:3:{s:5:\"label\";s:6:\"Author\";s:11:\"description\";s:16:\"Author textfield\";s:6:\"weight\";i:-2;}s:7:\"subject\";a:3:{s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:17:\"Subject textfield\";s:6:\"weight\";i:-1;}}}s:18:\"comment_node_vdisk\";a:1:{s:4:\"form\";a:2:{s:6:\"author\";a:3:{s:5:\"label\";s:6:\"Author\";s:11:\"description\";s:16:\"Author textfield\";s:6:\"weight\";i:-2;}s:7:\"subject\";a:3:{s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:17:\"Subject textfield\";s:6:\"weight\";i:-1;}}}s:26:\"comment_node_vdisk_metrics\";a:1:{s:4:\"form\";a:2:{s:6:\"author\";a:3:{s:5:\"label\";s:6:\"Author\";s:11:\"description\";s:16:\"Author textfield\";s:6:\"weight\";i:-2;}s:7:\"subject\";a:3:{s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:17:\"Subject textfield\";s:6:\"weight\";i:-1;}}}s:28:\"comment_node_virtual_machine\";a:1:{s:4:\"form\";a:2:{s:6:\"author\";a:3:{s:5:\"label\";s:6:\"Author\";s:11:\"description\";s:16:\"Author textfield\";s:6:\"weight\";i:-2;}s:7:\"subject\";a:3:{s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:17:\"Subject textfield\";s:6:\"weight\";i:-1;}}}s:27:\"comment_node_vm_cache_space\";a:1:{s:4:\"form\";a:2:{s:6:\"author\";a:3:{s:5:\"label\";s:6:\"Author\";s:11:\"description\";s:16:\"Author textfield\";s:6:\"weight\";i:-2;}s:7:\"subject\";a:3:{s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:17:\"Subject textfield\";s:6:\"weight\";i:-1;}}}s:23:\"comment_node_vm_metrics\";a:1:{s:4:\"form\";a:2:{s:6:\"author\";a:3:{s:5:\"label\";s:6:\"Author\";s:11:\"description\";s:16:\"Author textfield\";s:6:\"weight\";i:-2;}s:7:\"subject\";a:3:{s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:17:\"Subject textfield\";s:6:\"weight\";i:-1;}}}}s:4:\"node\";a:12:{s:15:\"virtual_machine\";a:2:{s:4:\"form\";a:2:{s:5:\"title\";a:3:{s:5:\"label\";s:7:\"VM Name\";s:11:\"description\";s:19:\"Node module element\";s:6:\"weight\";s:1:\"0\";}s:4:\"path\";a:3:{s:5:\"label\";s:17:\"URL path settings\";s:11:\"description\";s:25:\"Path module form elements\";s:6:\"weight\";s:2:\"16\";}}s:7:\"display\";a:2:{s:24:\"vm_metrics_entity_view_1\";a:3:{s:5:\"label\";s:27:\"EVA: VM metrics - EVA Field\";s:11:\"description\";s:27:\"EVA: VM metrics - EVA Field\";s:7:\"display\";a:7:{s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"9\";s:7:\"visible\";b:1;}s:4:\"full\";a:2:{s:6:\"weight\";i:10;s:7:\"visible\";b:1;}s:6:\"teaser\";a:2:{s:6:\"weight\";i:10;s:7:\"visible\";b:1;}s:3:\"rss\";a:2:{s:6:\"weight\";i:10;s:7:\"visible\";b:1;}s:12:\"search_index\";a:2:{s:6:\"weight\";i:10;s:7:\"visible\";b:1;}s:13:\"search_result\";a:2:{s:6:\"weight\";i:10;s:7:\"visible\";b:1;}s:5:\"token\";a:2:{s:6:\"weight\";i:10;s:7:\"visible\";b:1;}}}s:33:\"vdisk_metric_per_vm_entity_view_1\";a:3:{s:5:\"label\";s:36:\"EVA: vDisk metric per VM - EVA Field\";s:11:\"description\";s:36:\"EVA: vDisk metric per VM - EVA Field\";s:7:\"display\";a:7:{s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"8\";s:7:\"visible\";b:1;}s:4:\"full\";a:2:{s:6:\"weight\";i:10;s:7:\"visible\";b:1;}s:6:\"teaser\";a:2:{s:6:\"weight\";i:10;s:7:\"visible\";b:1;}s:3:\"rss\";a:2:{s:6:\"weight\";i:10;s:7:\"visible\";b:1;}s:12:\"search_index\";a:2:{s:6:\"weight\";i:10;s:7:\"visible\";b:1;}s:13:\"search_result\";a:2:{s:6:\"weight\";i:10;s:7:\"visible\";b:1;}s:5:\"token\";a:2:{s:6:\"weight\";i:10;s:7:\"visible\";b:1;}}}}}s:4:\"host\";a:2:{s:4:\"form\";a:2:{s:5:\"title\";a:3:{s:5:\"label\";s:5:\"Title\";s:11:\"description\";s:19:\"Node module element\";s:6:\"weight\";s:1:\"0\";}s:4:\"path\";a:3:{s:5:\"label\";s:17:\"URL path settings\";s:11:\"description\";s:25:\"Path module form elements\";s:6:\"weight\";s:2:\"30\";}}s:7:\"display\";a:1:{s:33:\"vdisk_metric_per_vm_entity_view_2\";a:3:{s:5:\"label\";s:38:\"EVA: vDisk metric per VM - EVA Field 2\";s:11:\"description\";s:38:\"EVA: vDisk metric per VM - EVA Field 2\";s:7:\"display\";a:7:{s:7:\"default\";a:2:{s:6:\"weight\";i:10;s:7:\"visible\";b:1;}s:4:\"full\";a:2:{s:6:\"weight\";i:10;s:7:\"visible\";b:1;}s:6:\"teaser\";a:2:{s:6:\"weight\";i:10;s:7:\"visible\";b:1;}s:3:\"rss\";a:2:{s:6:\"weight\";i:10;s:7:\"visible\";b:1;}s:12:\"search_index\";a:2:{s:6:\"weight\";i:10;s:7:\"visible\";b:1;}s:13:\"search_result\";a:2:{s:6:\"weight\";i:10;s:7:\"visible\";b:1;}s:5:\"token\";a:2:{s:6:\"weight\";i:10;s:7:\"visible\";b:1;}}}}}s:5:\"panel\";a:1:{s:4:\"form\";a:2:{s:5:\"title\";a:3:{s:5:\"label\";s:5:\"Title\";s:11:\"description\";s:19:\"Node module element\";s:6:\"weight\";i:-5;}s:4:\"path\";a:3:{s:5:\"label\";s:17:\"URL path settings\";s:11:\"description\";s:25:\"Path module form elements\";s:6:\"weight\";i:30;}}}s:7:\"article\";a:1:{s:4:\"form\";a:2:{s:5:\"title\";a:3:{s:5:\"label\";s:5:\"Title\";s:11:\"description\";s:19:\"Node module element\";s:6:\"weight\";i:-5;}s:4:\"path\";a:3:{s:5:\"label\";s:17:\"URL path settings\";s:11:\"description\";s:25:\"Path module form elements\";s:6:\"weight\";i:30;}}}s:11:\"data_center\";a:1:{s:4:\"form\";a:2:{s:5:\"title\";a:3:{s:5:\"label\";s:16:\"Data Center Name\";s:11:\"description\";s:19:\"Node module element\";s:6:\"weight\";s:2:\"-5\";}s:4:\"path\";a:3:{s:5:\"label\";s:17:\"URL path settings\";s:11:\"description\";s:25:\"Path module form elements\";s:6:\"weight\";i:30;}}}s:6:\"device\";a:1:{s:4:\"form\";a:2:{s:5:\"title\";a:3:{s:5:\"label\";s:11:\"Device Name\";s:11:\"description\";s:19:\"Node module element\";s:6:\"weight\";s:1:\"0\";}s:4:\"path\";a:3:{s:5:\"label\";s:17:\"URL path settings\";s:11:\"description\";s:25:\"Path module form elements\";s:6:\"weight\";s:2:\"30\";}}}s:4:\"page\";a:1:{s:4:\"form\";a:2:{s:5:\"title\";a:3:{s:5:\"label\";s:5:\"Title\";s:11:\"description\";s:19:\"Node module element\";s:6:\"weight\";i:-5;}s:4:\"path\";a:3:{s:5:\"label\";s:17:\"URL path settings\";s:11:\"description\";s:25:\"Path module form elements\";s:6:\"weight\";i:30;}}}s:7:\"vcenter\";a:1:{s:4:\"form\";a:2:{s:5:\"title\";a:3:{s:5:\"label\";s:9:\"Host Name\";s:11:\"description\";s:19:\"Node module element\";s:6:\"weight\";s:1:\"0\";}s:4:\"path\";a:3:{s:5:\"label\";s:17:\"URL path settings\";s:11:\"description\";s:25:\"Path module form elements\";s:6:\"weight\";s:1:\"6\";}}}s:5:\"vdisk\";a:1:{s:4:\"form\";a:2:{s:5:\"title\";a:3:{s:5:\"label\";s:5:\"Title\";s:11:\"description\";s:19:\"Node module element\";s:6:\"weight\";s:1:\"0\";}s:4:\"path\";a:3:{s:5:\"label\";s:17:\"URL path settings\";s:11:\"description\";s:25:\"Path module form elements\";s:6:\"weight\";s:1:\"8\";}}}s:13:\"vdisk_metrics\";a:1:{s:4:\"form\";a:2:{s:5:\"title\";a:3:{s:5:\"label\";s:9:\"Metric Id\";s:11:\"description\";s:19:\"Node module element\";s:6:\"weight\";s:1:\"0\";}s:4:\"path\";a:3:{s:5:\"label\";s:17:\"URL path settings\";s:11:\"description\";s:25:\"Path module form elements\";s:6:\"weight\";s:1:\"1\";}}}s:14:\"vm_cache_space\";a:1:{s:4:\"form\";a:2:{s:5:\"title\";a:3:{s:5:\"label\";s:14:\"Cache Space ID\";s:11:\"description\";s:19:\"Node module element\";s:6:\"weight\";s:1:\"0\";}s:4:\"path\";a:3:{s:5:\"label\";s:17:\"URL path settings\";s:11:\"description\";s:25:\"Path module form elements\";s:6:\"weight\";s:1:\"1\";}}}s:10:\"vm_metrics\";a:1:{s:4:\"form\";a:2:{s:5:\"title\";a:3:{s:5:\"label\";s:9:\"Metric Id\";s:11:\"description\";s:19:\"Node module element\";s:6:\"weight\";s:1:\"0\";}s:4:\"path\";a:3:{s:5:\"label\";s:17:\"URL path settings\";s:11:\"description\";s:25:\"Path module form elements\";s:6:\"weight\";s:1:\"1\";}}}}s:13:\"taxonomy_term\";a:1:{s:4:\"tags\";a:2:{s:4:\"form\";a:3:{s:4:\"path\";a:3:{s:5:\"label\";s:17:\"URL path settings\";s:11:\"description\";s:25:\"Path module form elements\";s:6:\"weight\";i:30;}s:4:\"name\";a:3:{s:5:\"label\";s:4:\"Name\";s:11:\"description\";s:19:\"Term name textfield\";s:6:\"weight\";i:-5;}s:11:\"description\";a:3:{s:5:\"label\";s:11:\"Description\";s:11:\"description\";s:25:\"Term description textarea\";s:6:\"weight\";i:0;}}s:7:\"display\";a:1:{s:11:\"description\";a:3:{s:5:\"label\";s:11:\"Description\";s:11:\"description\";s:16:\"Term description\";s:7:\"display\";a:3:{s:7:\"default\";a:2:{s:6:\"weight\";i:0;s:7:\"visible\";b:1;}s:4:\"full\";a:2:{s:6:\"weight\";i:0;s:7:\"visible\";b:1;}s:5:\"token\";a:2:{s:6:\"weight\";i:0;s:7:\"visible\";b:1;}}}}}}s:4:\"user\";a:1:{s:4:\"user\";a:2:{s:4:\"form\";a:3:{s:7:\"account\";a:3:{s:5:\"label\";s:22:\"User name and password\";s:11:\"description\";s:34:\"User module account form elements.\";s:6:\"weight\";i:-10;}s:8:\"timezone\";a:3:{s:5:\"label\";s:8:\"Timezone\";s:11:\"description\";s:34:\"User module timezone form element.\";s:6:\"weight\";i:6;}s:7:\"picture\";a:3:{s:5:\"label\";s:7:\"Picture\";s:11:\"description\";s:12:\"User picture\";s:6:\"weight\";i:5;}}s:7:\"display\";a:1:{s:7:\"summary\";a:3:{s:5:\"label\";s:7:\"History\";s:11:\"description\";s:33:\"User module history view element.\";s:7:\"display\";a:3:{s:7:\"default\";a:2:{s:6:\"weight\";i:5;s:7:\"visible\";b:1;}s:4:\"full\";a:2:{s:6:\"weight\";i:5;s:7:\"visible\";b:1;}s:5:\"token\";a:2:{s:6:\"weight\";i:5;s:7:\"visible\";b:1;}}}}}}}}',0,1371656313,1),('field:node:1','a:7:{s:4:\"body\";a:0:{}s:16:\"field_ip_address\";a:0:{}s:14:\"field_username\";a:1:{s:3:\"und\";a:1:{i:0;a:3:{s:5:\"value\";s:0:\"\";s:6:\"format\";N;s:10:\"safe_value\";s:0:\"\";}}}s:14:\"field_password\";a:1:{s:3:\"und\";a:1:{i:0;a:3:{s:5:\"value\";s:0:\"\";s:6:\"format\";N;s:10:\"safe_value\";s:0:\"\";}}}s:23:\"field_rediscover_status\";a:1:{s:3:\"und\";a:1:{i:0;a:3:{s:5:\"value\";s:0:\"\";s:6:\"format\";N;s:10:\"safe_value\";s:0:\"\";}}}s:14:\"field_hostname\";a:1:{s:3:\"und\";a:1:{i:0;a:3:{s:5:\"value\";s:0:\"\";s:6:\"format\";N;s:10:\"safe_value\";s:0:\"\";}}}s:14:\"field_fmc_uuid\";a:1:{s:3:\"und\";a:1:{i:0;a:3:{s:5:\"value\";s:0:\"\";s:6:\"format\";N;s:10:\"safe_value\";s:0:\"\";}}}}',0,1371656328,1);
/*!40000 ALTER TABLE `cache_field` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_filter`
--

DROP TABLE IF EXISTS `cache_filter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_filter` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Cache table for the Filter module to store already...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_filter`
--

LOCK TABLES `cache_filter` WRITE;
/*!40000 ALTER TABLE `cache_filter` DISABLE KEYS */;
/*!40000 ALTER TABLE `cache_filter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_form`
--

DROP TABLE IF EXISTS `cache_form`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_form` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Cache table for the form system to store recently built...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_form`
--

LOCK TABLES `cache_form` WRITE;
/*!40000 ALTER TABLE `cache_form` DISABLE KEYS */;
INSERT INTO `cache_form` VALUES ('form_state_form-_9vvr7NAlUaYrZVmBNIc-QTT8fDQHdXwIBeQlqXYZy0','a:5:{s:10:\"build_info\";a:3:{s:4:\"args\";a:0:{}s:7:\"form_id\";s:18:\"node_admin_content\";s:5:\"files\";a:1:{s:4:\"menu\";s:27:\"modules/node/node.admin.inc\";}}s:10:\"programmed\";b:0;s:5:\"cache\";b:0;s:14:\"admin_menu_uid\";N;s:13:\"process_input\";b:1;}',1371676731,1371655131,1),('form_form-_9vvr7NAlUaYrZVmBNIc-QTT8fDQHdXwIBeQlqXYZy0','a:23:{s:5:\"nodes\";a:53:{s:7:\"#prefix\";s:4:\"<ul>\";s:7:\"#suffix\";s:5:\"</ul>\";s:5:\"#tree\";b:1;i:177800;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177800;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595323</li>\n\";}i:177801;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177801;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595323</li>\n\";}i:177802;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177802;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595324</li>\n\";}i:177803;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177803;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595324</li>\n\";}i:177804;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177804;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595324</li>\n\";}i:177805;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177805;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595324</li>\n\";}i:177806;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177806;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595324</li>\n\";}i:177807;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177807;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595324</li>\n\";}i:177808;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177808;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595324</li>\n\";}i:177809;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177809;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595324</li>\n\";}i:177810;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177810;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595324</li>\n\";}i:177811;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177811;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595324</li>\n\";}i:177812;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177812;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595324</li>\n\";}i:177813;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177813;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595325</li>\n\";}i:177814;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177814;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595325</li>\n\";}i:177815;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177815;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595325</li>\n\";}i:177816;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177816;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595325</li>\n\";}i:177817;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177817;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595325</li>\n\";}i:177818;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177818;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595325</li>\n\";}i:177819;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177819;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595325</li>\n\";}i:177820;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177820;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595325</li>\n\";}i:177821;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177821;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595325</li>\n\";}i:177822;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177822;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595325</li>\n\";}i:177761;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177761;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595262</li>\n\";}i:177762;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177762;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595263</li>\n\";}i:177763;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177763;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595263</li>\n\";}i:177764;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177764;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595263</li>\n\";}i:177765;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177765;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595263</li>\n\";}i:177766;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177766;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595263</li>\n\";}i:177767;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177767;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595263</li>\n\";}i:177768;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177768;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595263</li>\n\";}i:177769;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177769;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595263</li>\n\";}i:177770;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177770;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595263</li>\n\";}i:177771;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177771;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595264</li>\n\";}i:177772;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177772;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595264</li>\n\";}i:177773;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177773;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595264</li>\n\";}i:177774;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177774;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595264</li>\n\";}i:177775;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177775;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595264</li>\n\";}i:177776;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177776;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595264</li>\n\";}i:177777;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177777;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595264</li>\n\";}i:177778;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177778;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595264</li>\n\";}i:177779;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177779;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595264</li>\n\";}i:177780;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177780;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595264</li>\n\";}i:177781;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177781;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595264</li>\n\";}i:177782;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177782;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595264</li>\n\";}i:177783;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177783;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595264</li>\n\";}i:177784;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177784;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595264</li>\n\";}i:177785;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177785;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595264</li>\n\";}i:177786;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177786;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595265</li>\n\";}i:177787;a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:177787;s:7:\"#prefix\";s:4:\"<li>\";s:7:\"#suffix\";s:16:\"1371595265</li>\n\";}}s:9:\"operation\";a:2:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:6:\"delete\";}s:7:\"#submit\";a:1:{i:0;s:35:\"node_multiple_delete_confirm_submit\";}s:11:\"#attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:12:\"confirmation\";}}s:11:\"description\";a:1:{s:7:\"#markup\";s:29:\"This action cannot be undone.\";}s:7:\"confirm\";a:2:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";i:1;}s:7:\"actions\";a:3:{s:5:\"#type\";s:7:\"actions\";s:6:\"submit\";a:2:{s:5:\"#type\";s:6:\"submit\";s:6:\"#value\";s:6:\"Delete\";}s:6:\"cancel\";a:4:{s:5:\"#type\";s:4:\"link\";s:6:\"#title\";s:6:\"Cancel\";s:5:\"#href\";s:13:\"admin/content\";s:8:\"#options\";a:1:{s:4:\"path\";s:13:\"admin/content\";}}}s:6:\"#theme\";s:12:\"confirm_form\";s:8:\"#form_id\";s:18:\"node_admin_content\";s:9:\"#build_id\";s:48:\"form-_9vvr7NAlUaYrZVmBNIc-QTT8fDQHdXwIBeQlqXYZy0\";s:5:\"#type\";s:4:\"form\";s:13:\"form_build_id\";a:5:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:48:\"form-_9vvr7NAlUaYrZVmBNIc-QTT8fDQHdXwIBeQlqXYZy0\";s:3:\"#id\";s:48:\"form-_9vvr7NAlUaYrZVmBNIc-QTT8fDQHdXwIBeQlqXYZy0\";s:5:\"#name\";s:13:\"form_build_id\";s:8:\"#parents\";a:1:{i:0;s:13:\"form_build_id\";}}s:6:\"#token\";s:18:\"node_admin_content\";s:10:\"form_token\";a:4:{s:3:\"#id\";s:34:\"edit-node-admin-content-form-token\";s:5:\"#type\";s:5:\"token\";s:14:\"#default_value\";s:43:\"3TrH3B7th7kTumcTVywkSWbLyVHKdwJgfray9fah6ow\";s:8:\"#parents\";a:1:{i:0;s:10:\"form_token\";}}s:7:\"form_id\";a:4:{s:5:\"#type\";s:6:\"hidden\";s:6:\"#value\";s:18:\"node_admin_content\";s:3:\"#id\";s:23:\"edit-node-admin-content\";s:8:\"#parents\";a:1:{i:0;s:7:\"form_id\";}}s:3:\"#id\";s:18:\"node-admin-content\";s:7:\"#method\";s:4:\"post\";s:7:\"#action\";s:23:\"/admin/content?page=472\";s:15:\"#theme_wrappers\";a:1:{i:0;s:4:\"form\";}s:5:\"#tree\";b:0;s:8:\"#parents\";a:0:{}s:9:\"#validate\";a:0:{}s:12:\"#cache_token\";s:43:\"VapTOlliH_XJtx8zUe_57eNmZZDkSWXF4pw1qKnoZLo\";}',1371676731,1371655131,1);
/*!40000 ALTER TABLE `cache_form` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_image`
--

DROP TABLE IF EXISTS `cache_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_image` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Cache table used to store information about image...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_image`
--

LOCK TABLES `cache_image` WRITE;
/*!40000 ALTER TABLE `cache_image` DISABLE KEYS */;
/*!40000 ALTER TABLE `cache_image` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_menu`
--

DROP TABLE IF EXISTS `cache_menu`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_menu` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Cache table for the menu system to store router...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_menu`
--

LOCK TABLES `cache_menu` WRITE;
/*!40000 ALTER TABLE `cache_menu` DISABLE KEYS */;
INSERT INTO `cache_menu` VALUES ('menu_custom','a:8:{s:9:\"main-menu\";a:3:{s:9:\"menu_name\";s:9:\"main-menu\";s:5:\"title\";s:9:\"Main menu\";s:11:\"description\";s:115:\"The <em>Main</em> menu is used on many sites to show the major sections of the site, often in a top navigation bar.\";}s:10:\"management\";a:3:{s:9:\"menu_name\";s:10:\"management\";s:5:\"title\";s:10:\"Management\";s:11:\"description\";s:69:\"The <em>Management</em> menu contains links for administrative tasks.\";}s:21:\"menu-bulk-action-tool\";a:3:{s:9:\"menu_name\";s:21:\"menu-bulk-action-tool\";s:5:\"title\";s:16:\"Bulk Action Tool\";s:11:\"description\";s:34:\"This block is for bulk operations.\";}s:23:\"menu-mercury-navigation\";a:3:{s:9:\"menu_name\";s:23:\"menu-mercury-navigation\";s:5:\"title\";s:10:\"Navigation\";s:11:\"description\";s:61:\"This block is to be used as the main navigation for the site.\";}s:11:\"menu-refine\";a:3:{s:9:\"menu_name\";s:11:\"menu-refine\";s:5:\"title\";s:6:\"Refine\";s:11:\"description\";s:0:\"\";}s:18:\"menu-selector-tool\";a:3:{s:9:\"menu_name\";s:18:\"menu-selector-tool\";s:5:\"title\";s:13:\"Selector Tool\";s:11:\"description\";s:112:\"This block is used to list host, virtual machine and virtual disk with a flash accel installed refine capability\";}s:10:\"navigation\";a:3:{s:9:\"menu_name\";s:10:\"navigation\";s:5:\"title\";s:10:\"Navigation\";s:11:\"description\";s:150:\"The <em>Navigation</em> menu contains links intended for site visitors. Links are added to the <em>Navigation</em> menu automatically by some modules.\";}s:9:\"user-menu\";a:3:{s:9:\"menu_name\";s:9:\"user-menu\";s:5:\"title\";s:9:\"User menu\";s:11:\"description\";s:99:\"The <em>User</em> menu contains links related to the user\'s account, as well as the \'Log out\' link.\";}}',0,1371656311,1),('links:management:all:0:en:0','a:2:{s:9:\"min_depth\";i:1;s:9:\"max_depth\";N;}',0,1371656313,1),('links:management:tree-data:en:ec99d3452fef1ede622e66c68ba908b1dad455aa71f5e68648aeec6488b89c88','a:2:{s:4:\"tree\";a:1:{i:1;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:1:\"1\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:5:\"admin\";s:11:\"router_path\";s:5:\"admin\";s:10:\"link_title\";s:14:\"Administration\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"9\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:5:\"admin\";s:5:\"title\";s:14:\"Administration\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:11:{i:7;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:1:\"7\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:16:\"admin/appearance\";s:11:\"router_path\";s:16:\"admin/appearance\";s:10:\"link_title\";s:10:\"Appearance\";s:7:\"options\";s:83:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Select and configure your themes.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-6\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"7\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer themes\";}\";s:13:\"page_callback\";s:18:\"system_themes_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:16:\"admin/appearance\";s:5:\"title\";s:10:\"Appearance\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:33:\"Select and configure your themes.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:43;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"43\";s:4:\"plid\";s:1:\"7\";s:9:\"link_path\";s:21:\"admin/appearance/list\";s:11:\"router_path\";s:21:\"admin/appearance/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:81:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"Select and configure your theme\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-1\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"7\";s:2:\"p3\";s:2:\"43\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer themes\";}\";s:13:\"page_callback\";s:18:\"system_themes_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:16:\"admin/appearance\";s:8:\"tab_root\";s:16:\"admin/appearance\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:31:\"Select and configure your theme\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:54;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"54\";s:4:\"plid\";s:1:\"7\";s:9:\"link_path\";s:25:\"admin/appearance/settings\";s:11:\"router_path\";s:25:\"admin/appearance/settings\";s:10:\"link_title\";s:8:\"Settings\";s:7:\"options\";s:96:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:46:\"Configure default and theme specific settings.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"20\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"7\";s:2:\"p3\";s:2:\"54\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer themes\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:39:\"a:1:{i:0;s:21:\"system_theme_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:16:\"admin/appearance\";s:8:\"tab_root\";s:16:\"admin/appearance\";s:5:\"title\";s:8:\"Settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:46:\"Configure default and theme specific settings.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:6:{i:95;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"95\";s:4:\"plid\";s:2:\"54\";s:9:\"link_path\";s:32:\"admin/appearance/settings/bartik\";s:11:\"router_path\";s:32:\"admin/appearance/settings/bartik\";s:10:\"link_title\";s:6:\"Bartik\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"7\";s:2:\"p3\";s:2:\"54\";s:2:\"p4\";s:2:\"95\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"_system_themes_access\";s:16:\"access_arguments\";s:2683:\"a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:25:\"themes/bartik/bartik.info\";s:4:\"name\";s:6:\"bartik\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:6:\"Bartik\";s:11:\"description\";s:48:\"A flexible, recolorable theme with many regions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:7:\"regions\";a:20:{s:6:\"header\";s:6:\"Header\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"triptych_first\";s:14:\"Triptych first\";s:15:\"triptych_middle\";s:15:\"Triptych middle\";s:13:\"triptych_last\";s:13:\"Triptych last\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"0\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:28:\"themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:56:\"a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:6:\"bartik\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:25:\"admin/appearance/settings\";s:8:\"tab_root\";s:16:\"admin/appearance\";s:5:\"title\";s:6:\"Bartik\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:101;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"101\";s:4:\"plid\";s:2:\"54\";s:9:\"link_path\";s:33:\"admin/appearance/settings/garland\";s:11:\"router_path\";s:33:\"admin/appearance/settings/garland\";s:10:\"link_title\";s:7:\"Garland\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"7\";s:2:\"p3\";s:2:\"54\";s:2:\"p4\";s:3:\"101\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"_system_themes_access\";s:16:\"access_arguments\";s:2105:\"a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:27:\"themes/garland/garland.info\";s:4:\"name\";s:7:\"garland\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:7:\"Garland\";s:11:\"description\";s:111:\"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:8:\"settings\";a:1:{s:13:\"garland_width\";s:5:\"fluid\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:29:\"themes/garland/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:57:\"a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:7:\"garland\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:25:\"admin/appearance/settings\";s:8:\"tab_root\";s:16:\"admin/appearance\";s:5:\"title\";s:7:\"Garland\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:102;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"102\";s:4:\"plid\";s:2:\"54\";s:9:\"link_path\";s:32:\"admin/appearance/settings/global\";s:11:\"router_path\";s:32:\"admin/appearance/settings/global\";s:10:\"link_title\";s:15:\"Global settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-1\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"7\";s:2:\"p3\";s:2:\"54\";s:2:\"p4\";s:3:\"102\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer themes\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:39:\"a:1:{i:0;s:21:\"system_theme_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:25:\"admin/appearance/settings\";s:8:\"tab_root\";s:16:\"admin/appearance\";s:5:\"title\";s:15:\"Global settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:119;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"119\";s:4:\"plid\";s:2:\"54\";s:9:\"link_path\";s:31:\"admin/appearance/settings/seven\";s:11:\"router_path\";s:31:\"admin/appearance/settings/seven\";s:10:\"link_title\";s:5:\"Seven\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"7\";s:2:\"p3\";s:2:\"54\";s:2:\"p4\";s:3:\"119\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"_system_themes_access\";s:16:\"access_arguments\";s:1905:\"a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/seven/seven.info\";s:4:\"name\";s:5:\"seven\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:5:\"Seven\";s:11:\"description\";s:65:\"A simple one-column, tableless, fluid width administration theme.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"1\";}s:7:\"regions\";a:8:{s:7:\"content\";s:7:\"Content\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:55:\"a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:5:\"seven\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:25:\"admin/appearance/settings\";s:8:\"tab_root\";s:16:\"admin/appearance\";s:5:\"title\";s:5:\"Seven\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:121;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"121\";s:4:\"plid\";s:2:\"54\";s:9:\"link_path\";s:31:\"admin/appearance/settings/stark\";s:11:\"router_path\";s:31:\"admin/appearance/settings/stark\";s:10:\"link_title\";s:5:\"Stark\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"7\";s:2:\"p3\";s:2:\"54\";s:2:\"p4\";s:3:\"121\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"_system_themes_access\";s:16:\"access_arguments\";s:2008:\"a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/stark/stark.info\";s:4:\"name\";s:5:\"stark\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:17:{s:4:\"name\";s:5:\"Stark\";s:11:\"description\";s:208:\"This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/stark/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:55:\"a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:5:\"stark\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:25:\"admin/appearance/settings\";s:8:\"tab_root\";s:16:\"admin/appearance\";s:5:\"title\";s:5:\"Stark\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:362;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"362\";s:4:\"plid\";s:2:\"54\";s:9:\"link_path\";s:33:\"admin/appearance/settings/mercury\";s:11:\"router_path\";s:33:\"admin/appearance/settings/mercury\";s:10:\"link_title\";s:7:\"Mercury\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"7\";s:2:\"p3\";s:2:\"54\";s:2:\"p4\";s:3:\"362\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"_system_themes_access\";s:16:\"access_arguments\";s:4026:\"a:1:{i:0;O:8:\"stdClass\":13:{s:8:\"filename\";s:37:\"sites/all/themes/mercury/mercury.info\";s:4:\"name\";s:7:\"mercury\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:7:\"Mercury\";s:11:\"description\";s:26:\"Mercury theme for Drupal 7\";s:10:\"screenshot\";s:46:\"sites/all/themes/mercury/images/screenshot.gif\";s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:7:\"mercury\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:14:{s:8:\"page_top\";s:8:\"Page top\";s:16:\"header_top_right\";s:16:\"Header top right\";s:6:\"header\";s:6:\"Header\";s:9:\"highlight\";s:9:\"Highlight\";s:4:\"help\";s:4:\"Help\";s:11:\"title_right\";s:11:\"Title Right\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"sidebar_second\";s:14:\"Second sidebar\";s:6:\"footer\";s:6:\"Footer\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:6:\"search\";i:6;s:7:\"favicon\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:11:\"stylesheets\";a:2:{s:3:\"all\";a:5:{s:15:\"css/default.css\";s:40:\"sites/all/themes/mercury/css/default.css\";s:14:\"css/layout.css\";s:39:\"sites/all/themes/mercury/css/layout.css\";s:13:\"css/style.css\";s:38:\"sites/all/themes/mercury/css/style.css\";s:17:\"css/node-view.css\";s:42:\"sites/all/themes/mercury/css/node-view.css\";s:17:\"css/analytics.css\";s:42:\"sites/all/themes/mercury/css/analytics.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:38:\"sites/all/themes/mercury/css/print.css\";}}s:7:\"scripts\";a:6:{s:19:\"js/jquery-ui.min.js\";s:44:\"sites/all/themes/mercury/js/jquery-ui.min.js\";s:29:\"js/jquery.mCustomScrollbar.js\";s:54:\"sites/all/themes/mercury/js/jquery.mCustomScrollbar.js\";s:27:\"js/jquery.mousewheel.min.js\";s:52:\"sites/all/themes/mercury/js/jquery.mousewheel.min.js\";s:24:\"js/jquery.tablesorter.js\";s:49:\"sites/all/themes/mercury/js/jquery.tablesorter.js\";s:32:\"js/jquery.tablesorter.widgets.js\";s:57:\"sites/all/themes/mercury/js/jquery.tablesorter.widgets.js\";s:14:\"js/function.js\";s:39:\"sites/all/themes/mercury/js/function.js\";}s:7:\"compass\";a:3:{s:6:\"status\";s:1:\"1\";s:8:\"sass_dir\";s:4:\"sass\";s:7:\"css_dir\";s:3:\"css\";}s:8:\"settings\";a:4:{s:12:\"mercury_tabs\";s:1:\"1\";s:28:\"mercury_breadcrumb_separator\";s:2:\"»\";s:14:\"wireframe_mode\";s:1:\"0\";s:14:\"clear_registry\";s:1:\"0\";}s:7:\"version\";s:7:\"7.x-2.1\";s:9:\"datestamp\";s:10:\"1334122542\";s:3:\"php\";s:5:\"5.2.4\";s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:5:{s:15:\"css/default.css\";s:40:\"sites/all/themes/mercury/css/default.css\";s:14:\"css/layout.css\";s:39:\"sites/all/themes/mercury/css/layout.css\";s:13:\"css/style.css\";s:38:\"sites/all/themes/mercury/css/style.css\";s:17:\"css/node-view.css\";s:42:\"sites/all/themes/mercury/css/node-view.css\";s:17:\"css/analytics.css\";s:42:\"sites/all/themes/mercury/css/analytics.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:38:\"sites/all/themes/mercury/css/print.css\";}}s:7:\"scripts\";a:6:{s:19:\"js/jquery-ui.min.js\";s:44:\"sites/all/themes/mercury/js/jquery-ui.min.js\";s:29:\"js/jquery.mCustomScrollbar.js\";s:54:\"sites/all/themes/mercury/js/jquery.mCustomScrollbar.js\";s:27:\"js/jquery.mousewheel.min.js\";s:52:\"sites/all/themes/mercury/js/jquery.mousewheel.min.js\";s:24:\"js/jquery.tablesorter.js\";s:49:\"sites/all/themes/mercury/js/jquery.tablesorter.js\";s:32:\"js/jquery.tablesorter.widgets.js\";s:57:\"sites/all/themes/mercury/js/jquery.tablesorter.widgets.js\";s:14:\"js/function.js\";s:39:\"sites/all/themes/mercury/js/function.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:57:\"a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:7:\"mercury\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:25:\"admin/appearance/settings\";s:8:\"tab_root\";s:16:\"admin/appearance\";s:5:\"title\";s:7:\"Mercury\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}i:8;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:1:\"8\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:12:\"admin/config\";s:11:\"router_path\";s:12:\"admin/config\";s:10:\"link_title\";s:13:\"Configuration\";s:7:\"options\";s:70:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"Administer settings.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:24:\"system_admin_config_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:12:\"admin/config\";s:5:\"title\";s:13:\"Configuration\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:20:\"Administer settings.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:14:{i:35;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"35\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:20:\"admin/config/content\";s:11:\"router_path\";s:20:\"admin/config/content\";s:10:\"link_title\";s:17:\"Content authoring\";s:7:\"options\";s:103:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:53:\"Settings related to formatting and authoring content.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-15\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"35\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:20:\"admin/config/content\";s:5:\"title\";s:17:\"Content authoring\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:53:\"Settings related to formatting and authoring content.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:122;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"122\";s:4:\"plid\";s:2:\"35\";s:9:\"link_path\";s:28:\"admin/config/content/formats\";s:11:\"router_path\";s:28:\"admin/config/content/formats\";s:10:\"link_title\";s:12:\"Text formats\";s:7:\"options\";s:178:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:127:\"Configure how content input by users is filtered, including allowed HTML tags. Also allows enabling of module-provided filters.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"35\";s:2:\"p4\";s:3:\"122\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer filters\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:39:\"a:1:{i:0;s:21:\"filter_admin_overview\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:28:\"admin/config/content/formats\";s:5:\"title\";s:12:\"Text formats\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:127:\"Configure how content input by users is filtered, including allowed HTML tags. Also allows enabling of module-provided filters.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:127;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"127\";s:4:\"plid\";s:3:\"122\";s:9:\"link_path\";s:30:\"admin/config/content/formats/%\";s:11:\"router_path\";s:30:\"admin/config/content/formats/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"35\";s:2:\"p4\";s:3:\"122\";s:2:\"p5\";s:3:\"127\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:36:\"a:1:{i:4;s:18:\"filter_format_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer filters\";}\";s:13:\"page_callback\";s:24:\"filter_admin_format_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:30:\"admin/config/content/formats/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:25:\"filter_admin_format_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:163;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"163\";s:4:\"plid\";s:3:\"127\";s:9:\"link_path\";s:38:\"admin/config/content/formats/%/disable\";s:11:\"router_path\";s:38:\"admin/config/content/formats/%/disable\";s:10:\"link_title\";s:19:\"Disable text format\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"35\";s:2:\"p4\";s:3:\"122\";s:2:\"p5\";s:3:\"127\";s:2:\"p6\";s:3:\"163\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:36:\"a:1:{i:4;s:18:\"filter_format_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:29:\"_filter_disable_format_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:46:\"a:2:{i:0;s:20:\"filter_admin_disable\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:38:\"admin/config/content/formats/%/disable\";s:5:\"title\";s:19:\"Disable text format\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:130;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"130\";s:4:\"plid\";s:3:\"122\";s:9:\"link_path\";s:32:\"admin/config/content/formats/add\";s:11:\"router_path\";s:32:\"admin/config/content/formats/add\";s:10:\"link_title\";s:15:\"Add text format\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"35\";s:2:\"p4\";s:3:\"122\";s:2:\"p5\";s:3:\"130\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer filters\";}\";s:13:\"page_callback\";s:24:\"filter_admin_format_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:28:\"admin/config/content/formats\";s:8:\"tab_root\";s:28:\"admin/config/content/formats\";s:5:\"title\";s:15:\"Add text format\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:139;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"139\";s:4:\"plid\";s:3:\"122\";s:9:\"link_path\";s:33:\"admin/config/content/formats/list\";s:11:\"router_path\";s:33:\"admin/config/content/formats/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"35\";s:2:\"p4\";s:3:\"122\";s:2:\"p5\";s:3:\"139\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer filters\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:39:\"a:1:{i:0;s:21:\"filter_admin_overview\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:28:\"admin/config/content/formats\";s:8:\"tab_root\";s:28:\"admin/config/content/formats\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}i:39;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"39\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:24:\"admin/config/development\";s:11:\"router_path\";s:24:\"admin/config/development\";s:10:\"link_title\";s:11:\"Development\";s:7:\"options\";s:68:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:18:\"Development tools.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"39\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:24:\"admin/config/development\";s:5:\"title\";s:11:\"Development\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:18:\"Development tools.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:110;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"110\";s:4:\"plid\";s:2:\"39\";s:9:\"link_path\";s:32:\"admin/config/development/logging\";s:11:\"router_path\";s:32:\"admin/config/development/logging\";s:10:\"link_title\";s:18:\"Logging and errors\";s:7:\"options\";s:205:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:154:\"Settings for logging and alerts modules. Various modules can route Drupal\'s system events to different destinations, such as syslog, database, email, etc.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-15\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"39\";s:2:\"p4\";s:3:\"110\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:41:\"a:1:{i:0;s:23:\"system_logging_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:32:\"admin/config/development/logging\";s:5:\"title\";s:18:\"Logging and errors\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:154:\"Settings for logging and alerts modules. Various modules can route Drupal\'s system events to different destinations, such as syslog, database, email, etc.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:111;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"111\";s:4:\"plid\";s:2:\"39\";s:9:\"link_path\";s:36:\"admin/config/development/maintenance\";s:11:\"router_path\";s:36:\"admin/config/development/maintenance\";s:10:\"link_title\";s:16:\"Maintenance mode\";s:7:\"options\";s:112:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:62:\"Take the site offline for maintenance or bring it back online.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"39\";s:2:\"p4\";s:3:\"111\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:46:\"a:1:{i:0;s:28:\"system_site_maintenance_mode\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:36:\"admin/config/development/maintenance\";s:5:\"title\";s:16:\"Maintenance mode\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:62:\"Take the site offline for maintenance or bring it back online.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:112;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"112\";s:4:\"plid\";s:2:\"39\";s:9:\"link_path\";s:36:\"admin/config/development/performance\";s:11:\"router_path\";s:36:\"admin/config/development/performance\";s:10:\"link_title\";s:11:\"Performance\";s:7:\"options\";s:152:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:101:\"Enable or disable page caching for anonymous users and set CSS and JS bandwidth optimization options.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-20\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"39\";s:2:\"p4\";s:3:\"112\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:45:\"a:1:{i:0;s:27:\"system_performance_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:36:\"admin/config/development/performance\";s:5:\"title\";s:11:\"Performance\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:101:\"Enable or disable page caching for anonymous users and set CSS and JS bandwidth optimization options.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:425;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"425\";s:4:\"plid\";s:2:\"39\";s:9:\"link_path\";s:30:\"admin/config/development/coder\";s:11:\"router_path\";s:30:\"admin/config/development/coder\";s:10:\"link_title\";s:5:\"Coder\";s:7:\"options\";s:108:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:58:\"Select code review plugins and modules, and upgrade files.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"39\";s:2:\"p4\";s:3:\"425\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:17:\"coder_review_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:30:\"admin/config/development/coder\";s:5:\"title\";s:5:\"Coder\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:58:\"Select code review plugins and modules, and upgrade files.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:843;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"843\";s:4:\"plid\";s:3:\"425\";s:9:\"link_path\";s:37:\"admin/config/development/coder/review\";s:11:\"router_path\";s:37:\"admin/config/development/coder/review\";s:10:\"link_title\";s:6:\"Review\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-2\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"39\";s:2:\"p4\";s:3:\"425\";s:2:\"p5\";s:3:\"843\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"view code review\";}\";s:13:\"page_callback\";s:17:\"coder_review_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/config/development/coder\";s:8:\"tab_root\";s:30:\"admin/config/development/coder\";s:5:\"title\";s:6:\"Review\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:8:{i:844;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"844\";s:4:\"plid\";s:3:\"843\";s:9:\"link_path\";s:44:\"admin/config/development/coder/review/active\";s:11:\"router_path\";s:44:\"admin/config/development/coder/review/active\";s:10:\"link_title\";s:6:\"Active\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"39\";s:2:\"p4\";s:3:\"425\";s:2:\"p5\";s:3:\"843\";s:2:\"p6\";s:3:\"844\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"view code review\";}\";s:13:\"page_callback\";s:17:\"coder_review_page\";s:14:\"page_arguments\";s:23:\"a:1:{i:0;s:6:\"active\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/config/development/coder/review\";s:8:\"tab_root\";s:30:\"admin/config/development/coder\";s:5:\"title\";s:6:\"Active\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:845;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"845\";s:4:\"plid\";s:3:\"843\";s:9:\"link_path\";s:41:\"admin/config/development/coder/review/all\";s:11:\"router_path\";s:41:\"admin/config/development/coder/review/all\";s:10:\"link_title\";s:3:\"All\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"39\";s:2:\"p4\";s:3:\"425\";s:2:\"p5\";s:3:\"843\";s:2:\"p6\";s:3:\"845\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"view code review all\";}\";s:13:\"page_callback\";s:17:\"coder_review_page\";s:14:\"page_arguments\";s:20:\"a:1:{i:0;s:3:\"all\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/config/development/coder/review\";s:8:\"tab_root\";s:30:\"admin/config/development/coder\";s:5:\"title\";s:3:\"All\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:846;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"846\";s:4:\"plid\";s:3:\"843\";s:9:\"link_path\";s:42:\"admin/config/development/coder/review/core\";s:11:\"router_path\";s:42:\"admin/config/development/coder/review/core\";s:10:\"link_title\";s:4:\"Core\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"39\";s:2:\"p4\";s:3:\"425\";s:2:\"p5\";s:3:\"843\";s:2:\"p6\";s:3:\"846\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"view code review\";}\";s:13:\"page_callback\";s:17:\"coder_review_page\";s:14:\"page_arguments\";s:21:\"a:1:{i:0;s:4:\"core\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/config/development/coder/review\";s:8:\"tab_root\";s:30:\"admin/config/development/coder\";s:5:\"title\";s:4:\"Core\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:847;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"847\";s:4:\"plid\";s:3:\"843\";s:9:\"link_path\";s:45:\"admin/config/development/coder/review/default\";s:11:\"router_path\";s:45:\"admin/config/development/coder/review/default\";s:10:\"link_title\";s:7:\"Default\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-1\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"39\";s:2:\"p4\";s:3:\"425\";s:2:\"p5\";s:3:\"843\";s:2:\"p6\";s:3:\"847\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"view code review\";}\";s:13:\"page_callback\";s:17:\"coder_review_page\";s:14:\"page_arguments\";s:24:\"a:1:{i:0;s:7:\"default\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/config/development/coder/review\";s:8:\"tab_root\";s:30:\"admin/config/development/coder\";s:5:\"title\";s:7:\"Default\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:848;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"848\";s:4:\"plid\";s:3:\"843\";s:9:\"link_path\";s:43:\"admin/config/development/coder/review/files\";s:11:\"router_path\";s:43:\"admin/config/development/coder/review/files\";s:10:\"link_title\";s:5:\"Files\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"2\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"39\";s:2:\"p4\";s:3:\"425\";s:2:\"p5\";s:3:\"843\";s:2:\"p6\";s:3:\"848\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"view code review\";}\";s:13:\"page_callback\";s:17:\"coder_review_page\";s:14:\"page_arguments\";s:22:\"a:1:{i:0;s:5:\"files\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/config/development/coder/review\";s:8:\"tab_root\";s:30:\"admin/config/development/coder\";s:5:\"title\";s:5:\"Files\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:849;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"849\";s:4:\"plid\";s:3:\"843\";s:9:\"link_path\";s:45:\"admin/config/development/coder/review/patches\";s:11:\"router_path\";s:45:\"admin/config/development/coder/review/patches\";s:10:\"link_title\";s:7:\"Patches\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"3\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"39\";s:2:\"p4\";s:3:\"425\";s:2:\"p5\";s:3:\"843\";s:2:\"p6\";s:3:\"849\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"view code review\";}\";s:13:\"page_callback\";s:17:\"coder_review_page\";s:14:\"page_arguments\";s:24:\"a:1:{i:0;s:7:\"patches\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/config/development/coder/review\";s:8:\"tab_root\";s:30:\"admin/config/development/coder\";s:5:\"title\";s:7:\"Patches\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:850;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"850\";s:4:\"plid\";s:3:\"843\";s:9:\"link_path\";s:44:\"admin/config/development/coder/review/select\";s:11:\"router_path\";s:44:\"admin/config/development/coder/review/select\";s:10:\"link_title\";s:6:\"Select\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-2\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"39\";s:2:\"p4\";s:3:\"425\";s:2:\"p5\";s:3:\"843\";s:2:\"p6\";s:3:\"850\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"view code review\";}\";s:13:\"page_callback\";s:17:\"coder_review_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/config/development/coder/review\";s:8:\"tab_root\";s:30:\"admin/config/development/coder\";s:5:\"title\";s:6:\"Select\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:851;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"851\";s:4:\"plid\";s:3:\"843\";s:9:\"link_path\";s:46:\"admin/config/development/coder/review/settings\";s:11:\"router_path\";s:46:\"admin/config/development/coder/review/settings\";s:10:\"link_title\";s:8:\"Settings\";s:7:\"options\";s:88:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Select code review plugins and modules\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"3\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"39\";s:2:\"p4\";s:3:\"425\";s:2:\"p5\";s:3:\"843\";s:2:\"p6\";s:3:\"851\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:45:\"a:1:{i:0;s:27:\"coder_review_admin_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/config/development/coder/review\";s:8:\"tab_root\";s:30:\"admin/config/development/coder\";s:5:\"title\";s:8:\"Settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:38:\"Select code review plugins and modules\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}}}i:46;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"46\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:18:\"admin/config/media\";s:11:\"router_path\";s:18:\"admin/config/media\";s:10:\"link_title\";s:5:\"Media\";s:7:\"options\";s:62:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:12:\"Media tools.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"46\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:18:\"admin/config/media\";s:5:\"title\";s:5:\"Media\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:12:\"Media tools.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:100;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"100\";s:4:\"plid\";s:2:\"46\";s:9:\"link_path\";s:30:\"admin/config/media/file-system\";s:11:\"router_path\";s:30:\"admin/config/media/file-system\";s:10:\"link_title\";s:11:\"File system\";s:7:\"options\";s:118:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:68:\"Tell Drupal where to store uploaded files and how they are accessed.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"46\";s:2:\"p4\";s:3:\"100\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:45:\"a:1:{i:0;s:27:\"system_file_system_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:30:\"admin/config/media/file-system\";s:5:\"title\";s:11:\"File system\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:68:\"Tell Drupal where to store uploaded files and how they are accessed.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:105;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"105\";s:4:\"plid\";s:2:\"46\";s:9:\"link_path\";s:32:\"admin/config/media/image-toolkit\";s:11:\"router_path\";s:32:\"admin/config/media/image-toolkit\";s:10:\"link_title\";s:13:\"Image toolkit\";s:7:\"options\";s:124:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:74:\"Choose which image toolkit to use if you have installed optional toolkits.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"20\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"46\";s:2:\"p4\";s:3:\"105\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:47:\"a:1:{i:0;s:29:\"system_image_toolkit_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:32:\"admin/config/media/image-toolkit\";s:5:\"title\";s:13:\"Image toolkit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:74:\"Choose which image toolkit to use if you have installed optional toolkits.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:48;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"48\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:19:\"admin/config/people\";s:11:\"router_path\";s:19:\"admin/config/people\";s:10:\"link_title\";s:6:\"People\";s:7:\"options\";s:74:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:24:\"Configure user accounts.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-20\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"48\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"admin/config/people\";s:5:\"title\";s:6:\"People\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:24:\"Configure user accounts.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:89;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"89\";s:4:\"plid\";s:2:\"48\";s:9:\"link_path\";s:28:\"admin/config/people/accounts\";s:11:\"router_path\";s:28:\"admin/config/people/accounts\";s:10:\"link_title\";s:16:\"Account settings\";s:7:\"options\";s:160:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:109:\"Configure default behavior of users, including registration requirements, e-mails, fields, and user pictures.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"48\";s:2:\"p4\";s:2:\"89\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer users\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:37:\"a:1:{i:0;s:19:\"user_admin_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:28:\"admin/config/people/accounts\";s:5:\"title\";s:16:\"Account settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:109:\"Configure default behavior of users, including registration requirements, e-mails, fields, and user pictures.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:142;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"142\";s:4:\"plid\";s:2:\"89\";s:9:\"link_path\";s:37:\"admin/config/people/accounts/settings\";s:11:\"router_path\";s:37:\"admin/config/people/accounts/settings\";s:10:\"link_title\";s:8:\"Settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"48\";s:2:\"p4\";s:2:\"89\";s:2:\"p5\";s:3:\"142\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer users\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:37:\"a:1:{i:0;s:19:\"user_admin_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:28:\"admin/config/people/accounts\";s:8:\"tab_root\";s:28:\"admin/config/people/accounts\";s:5:\"title\";s:8:\"Settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:783;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"783\";s:4:\"plid\";s:2:\"89\";s:9:\"link_path\";s:36:\"admin/config/people/accounts/display\";s:11:\"router_path\";s:36:\"admin/config/people/accounts/display\";s:10:\"link_title\";s:14:\"Manage display\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"2\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"48\";s:2:\"p4\";s:2:\"89\";s:2:\"p5\";s:3:\"783\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer users\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:96:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:7:\"default\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:28:\"admin/config/people/accounts\";s:8:\"tab_root\";s:28:\"admin/config/people/accounts\";s:5:\"title\";s:14:\"Manage display\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:787;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"787\";s:4:\"plid\";s:3:\"783\";s:9:\"link_path\";s:44:\"admin/config/people/accounts/display/default\";s:11:\"router_path\";s:44:\"admin/config/people/accounts/display/default\";s:10:\"link_title\";s:7:\"Default\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"48\";s:2:\"p4\";s:2:\"89\";s:2:\"p5\";s:3:\"783\";s:2:\"p6\";s:3:\"787\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:105:\"a:5:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:7:\"default\";i:3;s:11:\"user_access\";i:4;s:16:\"administer users\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:96:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:7:\"default\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:36:\"admin/config/people/accounts/display\";s:8:\"tab_root\";s:28:\"admin/config/people/accounts\";s:5:\"title\";s:7:\"Default\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:792;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"792\";s:4:\"plid\";s:3:\"783\";s:9:\"link_path\";s:42:\"admin/config/people/accounts/display/token\";s:11:\"router_path\";s:42:\"admin/config/people/accounts/display/token\";s:10:\"link_title\";s:6:\"Tokens\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"48\";s:2:\"p4\";s:2:\"89\";s:2:\"p5\";s:3:\"783\";s:2:\"p6\";s:3:\"792\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:103:\"a:5:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:5:\"token\";i:3;s:11:\"user_access\";i:4;s:16:\"administer users\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:94:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:5:\"token\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:36:\"admin/config/people/accounts/display\";s:8:\"tab_root\";s:28:\"admin/config/people/accounts\";s:5:\"title\";s:6:\"Tokens\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:793;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"793\";s:4:\"plid\";s:3:\"783\";s:9:\"link_path\";s:41:\"admin/config/people/accounts/display/full\";s:11:\"router_path\";s:41:\"admin/config/people/accounts/display/full\";s:10:\"link_title\";s:12:\"User account\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"48\";s:2:\"p4\";s:2:\"89\";s:2:\"p5\";s:3:\"783\";s:2:\"p6\";s:3:\"793\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:102:\"a:5:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:4:\"full\";i:3;s:11:\"user_access\";i:4;s:16:\"administer users\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:93:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:4:\"full\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:36:\"admin/config/people/accounts/display\";s:8:\"tab_root\";s:28:\"admin/config/people/accounts\";s:5:\"title\";s:12:\"User account\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:785;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"785\";s:4:\"plid\";s:2:\"89\";s:9:\"link_path\";s:35:\"admin/config/people/accounts/fields\";s:11:\"router_path\";s:35:\"admin/config/people/accounts/fields\";s:10:\"link_title\";s:13:\"Manage fields\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"48\";s:2:\"p4\";s:2:\"89\";s:2:\"p5\";s:3:\"785\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer users\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:76:\"a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:28:\"admin/config/people/accounts\";s:8:\"tab_root\";s:28:\"admin/config/people/accounts\";s:5:\"title\";s:13:\"Manage fields\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:795;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"795\";s:4:\"plid\";s:3:\"785\";s:9:\"link_path\";s:37:\"admin/config/people/accounts/fields/%\";s:11:\"router_path\";s:37:\"admin/config/people/accounts/fields/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"48\";s:2:\"p4\";s:2:\"89\";s:2:\"p5\";s:3:\"785\";s:2:\"p6\";s:3:\"795\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:105:\"a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer users\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:37:\"admin/config/people/accounts/fields/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:19:\"field_ui_menu_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:808;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"808\";s:4:\"plid\";s:3:\"795\";s:9:\"link_path\";s:44:\"admin/config/people/accounts/fields/%/delete\";s:11:\"router_path\";s:44:\"admin/config/people/accounts/fields/%/delete\";s:10:\"link_title\";s:6:\"Delete\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"48\";s:2:\"p4\";s:2:\"89\";s:2:\"p5\";s:3:\"785\";s:2:\"p6\";s:3:\"795\";s:2:\"p7\";s:3:\"808\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:105:\"a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer users\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:52:\"a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/config/people/accounts/fields/%\";s:8:\"tab_root\";s:37:\"admin/config/people/accounts/fields/%\";s:5:\"title\";s:6:\"Delete\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:809;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"809\";s:4:\"plid\";s:3:\"795\";s:9:\"link_path\";s:42:\"admin/config/people/accounts/fields/%/edit\";s:11:\"router_path\";s:42:\"admin/config/people/accounts/fields/%/edit\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"48\";s:2:\"p4\";s:2:\"89\";s:2:\"p5\";s:3:\"785\";s:2:\"p6\";s:3:\"795\";s:2:\"p7\";s:3:\"809\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:105:\"a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer users\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/config/people/accounts/fields/%\";s:8:\"tab_root\";s:37:\"admin/config/people/accounts/fields/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:810;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"810\";s:4:\"plid\";s:3:\"795\";s:9:\"link_path\";s:52:\"admin/config/people/accounts/fields/%/field-settings\";s:11:\"router_path\";s:52:\"admin/config/people/accounts/fields/%/field-settings\";s:10:\"link_title\";s:14:\"Field settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"48\";s:2:\"p4\";s:2:\"89\";s:2:\"p5\";s:3:\"785\";s:2:\"p6\";s:3:\"795\";s:2:\"p7\";s:3:\"810\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:105:\"a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer users\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:54:\"a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/config/people/accounts/fields/%\";s:8:\"tab_root\";s:37:\"admin/config/people/accounts/fields/%\";s:5:\"title\";s:14:\"Field settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:811;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"811\";s:4:\"plid\";s:3:\"795\";s:9:\"link_path\";s:49:\"admin/config/people/accounts/fields/%/widget-type\";s:11:\"router_path\";s:49:\"admin/config/people/accounts/fields/%/widget-type\";s:10:\"link_title\";s:11:\"Widget type\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"48\";s:2:\"p4\";s:2:\"89\";s:2:\"p5\";s:3:\"785\";s:2:\"p6\";s:3:\"795\";s:2:\"p7\";s:3:\"811\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:105:\"a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer users\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:51:\"a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/config/people/accounts/fields/%\";s:8:\"tab_root\";s:37:\"admin/config/people/accounts/fields/%\";s:5:\"title\";s:11:\"Widget type\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}}}i:103;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"103\";s:4:\"plid\";s:2:\"48\";s:9:\"link_path\";s:31:\"admin/config/people/ip-blocking\";s:11:\"router_path\";s:31:\"admin/config/people/ip-blocking\";s:10:\"link_title\";s:19:\"IP address blocking\";s:7:\"options\";s:78:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:28:\"Manage blocked IP addresses.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"48\";s:2:\"p4\";s:3:\"103\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"block IP addresses\";}\";s:13:\"page_callback\";s:18:\"system_ip_blocking\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:31:\"admin/config/people/ip-blocking\";s:5:\"title\";s:19:\"IP address blocking\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:28:\"Manage blocked IP addresses.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:158;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"158\";s:4:\"plid\";s:3:\"103\";s:9:\"link_path\";s:40:\"admin/config/people/ip-blocking/delete/%\";s:11:\"router_path\";s:40:\"admin/config/people/ip-blocking/delete/%\";s:10:\"link_title\";s:17:\"Delete IP address\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"48\";s:2:\"p4\";s:3:\"103\";s:2:\"p5\";s:3:\"158\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:33:\"a:1:{i:5;s:15:\"blocked_ip_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"block IP addresses\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:51:\"a:2:{i:0;s:25:\"system_ip_blocking_delete\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:40:\"admin/config/people/ip-blocking/delete/%\";s:5:\"title\";s:17:\"Delete IP address\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:492;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"492\";s:4:\"plid\";s:2:\"48\";s:9:\"link_path\";s:37:\"admin/config/people/login-destination\";s:11:\"router_path\";s:37:\"admin/config/people/login-destination\";s:10:\"link_title\";s:18:\"Login destinations\";s:7:\"options\";s:119:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:69:\"Customize the destination that the user is redirected to after login.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"48\";s:2:\"p4\";s:3:\"492\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer users\";}\";s:13:\"page_callback\";s:26:\"login_destination_overview\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:37:\"admin/config/people/login-destination\";s:5:\"title\";s:18:\"Login destinations\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:69:\"Customize the destination that the user is redirected to after login.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:5:{i:493;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"493\";s:4:\"plid\";s:3:\"492\";s:9:\"link_path\";s:41:\"admin/config/people/login-destination/add\";s:11:\"router_path\";s:41:\"admin/config/people/login-destination/add\";s:10:\"link_title\";s:26:\"Add login destination rule\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"48\";s:2:\"p4\";s:3:\"492\";s:2:\"p5\";s:3:\"493\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer users\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:45:\"a:1:{i:0;s:27:\"login_destination_edit_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/config/people/login-destination\";s:8:\"tab_root\";s:37:\"admin/config/people/login-destination\";s:5:\"title\";s:26:\"Add login destination rule\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:494;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"494\";s:4:\"plid\";s:3:\"492\";s:9:\"link_path\";s:42:\"admin/config/people/login-destination/list\";s:11:\"router_path\";s:42:\"admin/config/people/login-destination/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"48\";s:2:\"p4\";s:3:\"492\";s:2:\"p5\";s:3:\"494\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer users\";}\";s:13:\"page_callback\";s:26:\"login_destination_overview\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/config/people/login-destination\";s:8:\"tab_root\";s:37:\"admin/config/people/login-destination\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:495;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"495\";s:4:\"plid\";s:3:\"492\";s:9:\"link_path\";s:46:\"admin/config/people/login-destination/settings\";s:11:\"router_path\";s:46:\"admin/config/people/login-destination/settings\";s:10:\"link_title\";s:8:\"Settings\";s:7:\"options\";s:84:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"Change Login Destination settings.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"48\";s:2:\"p4\";s:3:\"492\";s:2:\"p5\";s:3:\"495\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer users\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:1:{i:0;s:26:\"login_destination_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/config/people/login-destination\";s:8:\"tab_root\";s:37:\"admin/config/people/login-destination\";s:5:\"title\";s:8:\"Settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:34:\"Change Login Destination settings.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:496;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"496\";s:4:\"plid\";s:3:\"492\";s:9:\"link_path\";s:46:\"admin/config/people/login-destination/delete/%\";s:11:\"router_path\";s:46:\"admin/config/people/login-destination/delete/%\";s:10:\"link_title\";s:29:\"Delete login destination rule\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"48\";s:2:\"p4\";s:3:\"492\";s:2:\"p5\";s:3:\"496\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:40:\"a:1:{i:5;s:22:\"login_destination_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer userson\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:55:\"a:2:{i:0;s:29:\"login_destination_delete_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:46:\"admin/config/people/login-destination/delete/%\";s:5:\"title\";s:29:\"Delete login destination rule\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:497;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"497\";s:4:\"plid\";s:3:\"492\";s:9:\"link_path\";s:44:\"admin/config/people/login-destination/edit/%\";s:11:\"router_path\";s:44:\"admin/config/people/login-destination/edit/%\";s:10:\"link_title\";s:27:\"Edit login destination rule\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"48\";s:2:\"p4\";s:3:\"492\";s:2:\"p5\";s:3:\"497\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:40:\"a:1:{i:5;s:22:\"login_destination_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer users\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:53:\"a:2:{i:0;s:27:\"login_destination_edit_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:44:\"admin/config/people/login-destination/edit/%\";s:5:\"title\";s:27:\"Edit login destination rule\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}i:51;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"51\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:21:\"admin/config/regional\";s:11:\"router_path\";s:21:\"admin/config/regional\";s:10:\"link_title\";s:21:\"Regional and language\";s:7:\"options\";s:98:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:48:\"Regional settings, localization and translation.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-5\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/config/regional\";s:5:\"title\";s:21:\"Regional and language\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:48:\"Regional settings, localization and translation.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:98;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"98\";s:4:\"plid\";s:2:\"51\";s:9:\"link_path\";s:31:\"admin/config/regional/date-time\";s:11:\"router_path\";s:31:\"admin/config/regional/date-time\";s:10:\"link_title\";s:13:\"Date and time\";s:7:\"options\";s:94:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:44:\"Configure display formats for date and time.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-15\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:2:\"98\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:43:\"a:1:{i:0;s:25:\"system_date_time_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:31:\"admin/config/regional/date-time\";s:5:\"title\";s:13:\"Date and time\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:44:\"Configure display formats for date and time.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:136;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"136\";s:4:\"plid\";s:2:\"98\";s:9:\"link_path\";s:39:\"admin/config/regional/date-time/formats\";s:11:\"router_path\";s:39:\"admin/config/regional/date-time/formats\";s:10:\"link_title\";s:7:\"Formats\";s:7:\"options\";s:101:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:51:\"Configure display format strings for date and time.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-9\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:2:\"98\";s:2:\"p5\";s:3:\"136\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:24:\"system_date_time_formats\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/config/regional/date-time\";s:8:\"tab_root\";s:31:\"admin/config/regional/date-time\";s:5:\"title\";s:7:\"Formats\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:51:\"Configure display format strings for date and time.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:153;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"153\";s:4:\"plid\";s:3:\"136\";s:9:\"link_path\";s:43:\"admin/config/regional/date-time/formats/add\";s:11:\"router_path\";s:43:\"admin/config/regional/date-time/formats/add\";s:10:\"link_title\";s:10:\"Add format\";s:7:\"options\";s:93:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Allow users to add additional date formats.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:2:\"98\";s:2:\"p5\";s:3:\"136\";s:2:\"p6\";s:3:\"153\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:52:\"a:1:{i:0;s:34:\"system_configure_date_formats_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:39:\"admin/config/regional/date-time/formats\";s:8:\"tab_root\";s:31:\"admin/config/regional/date-time\";s:5:\"title\";s:10:\"Add format\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:43:\"Allow users to add additional date formats.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:177;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"177\";s:4:\"plid\";s:3:\"136\";s:9:\"link_path\";s:48:\"admin/config/regional/date-time/formats/%/delete\";s:11:\"router_path\";s:48:\"admin/config/regional/date-time/formats/%/delete\";s:10:\"link_title\";s:18:\"Delete date format\";s:7:\"options\";s:97:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:47:\"Allow users to delete a configured date format.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:2:\"98\";s:2:\"p5\";s:3:\"136\";s:2:\"p6\";s:3:\"177\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:12:\"a:1:{i:5;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:56:\"a:2:{i:0;s:30:\"system_date_delete_format_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:48:\"admin/config/regional/date-time/formats/%/delete\";s:5:\"title\";s:18:\"Delete date format\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:47:\"Allow users to delete a configured date format.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:179;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"179\";s:4:\"plid\";s:3:\"136\";s:9:\"link_path\";s:46:\"admin/config/regional/date-time/formats/%/edit\";s:11:\"router_path\";s:46:\"admin/config/regional/date-time/formats/%/edit\";s:10:\"link_title\";s:16:\"Edit date format\";s:7:\"options\";s:95:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Allow users to edit a configured date format.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:2:\"98\";s:2:\"p5\";s:3:\"136\";s:2:\"p6\";s:3:\"179\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:12:\"a:1:{i:5;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:60:\"a:2:{i:0;s:34:\"system_configure_date_formats_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:46:\"admin/config/regional/date-time/formats/%/edit\";s:5:\"title\";s:16:\"Edit date format\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:45:\"Allow users to edit a configured date format.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:145;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"145\";s:4:\"plid\";s:2:\"98\";s:9:\"link_path\";s:37:\"admin/config/regional/date-time/types\";s:11:\"router_path\";s:37:\"admin/config/regional/date-time/types\";s:10:\"link_title\";s:5:\"Types\";s:7:\"options\";s:94:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:44:\"Configure display formats for date and time.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:2:\"98\";s:2:\"p5\";s:3:\"145\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:43:\"a:1:{i:0;s:25:\"system_date_time_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/config/regional/date-time\";s:8:\"tab_root\";s:31:\"admin/config/regional/date-time\";s:5:\"title\";s:5:\"Types\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:44:\"Configure display formats for date and time.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:152;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"152\";s:4:\"plid\";s:3:\"145\";s:9:\"link_path\";s:41:\"admin/config/regional/date-time/types/add\";s:11:\"router_path\";s:41:\"admin/config/regional/date-time/types/add\";s:10:\"link_title\";s:13:\"Add date type\";s:7:\"options\";s:68:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:18:\"Add new date type.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:2:\"98\";s:2:\"p5\";s:3:\"145\";s:2:\"p6\";s:3:\"152\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:1:{i:0;s:32:\"system_add_date_format_type_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/config/regional/date-time/types\";s:8:\"tab_root\";s:31:\"admin/config/regional/date-time\";s:5:\"title\";s:13:\"Add date type\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:18:\"Add new date type.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:178;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"178\";s:4:\"plid\";s:3:\"145\";s:9:\"link_path\";s:46:\"admin/config/regional/date-time/types/%/delete\";s:11:\"router_path\";s:46:\"admin/config/regional/date-time/types/%/delete\";s:10:\"link_title\";s:16:\"Delete date type\";s:7:\"options\";s:95:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Allow users to delete a configured date type.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:2:\"98\";s:2:\"p5\";s:3:\"145\";s:2:\"p6\";s:3:\"178\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:12:\"a:1:{i:5;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:61:\"a:2:{i:0;s:35:\"system_delete_date_format_type_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:46:\"admin/config/regional/date-time/types/%/delete\";s:5:\"title\";s:16:\"Delete date type\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:45:\"Allow users to delete a configured date type.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}i:116;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"116\";s:4:\"plid\";s:2:\"51\";s:9:\"link_path\";s:30:\"admin/config/regional/settings\";s:11:\"router_path\";s:30:\"admin/config/regional/settings\";s:10:\"link_title\";s:17:\"Regional settings\";s:7:\"options\";s:104:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:54:\"Settings for the site\'s default time zone and country.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-20\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:3:\"116\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:42:\"a:1:{i:0;s:24:\"system_regional_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:30:\"admin/config/regional/settings\";s:5:\"title\";s:17:\"Regional settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:54:\"Settings for the site\'s default time zone and country.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:53;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"53\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:19:\"admin/config/search\";s:11:\"router_path\";s:19:\"admin/config/search\";s:10:\"link_title\";s:19:\"Search and metadata\";s:7:\"options\";s:86:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:36:\"Local site search, metadata and SEO.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"admin/config/search\";s:5:\"title\";s:19:\"Search and metadata\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:36:\"Local site search, metadata and SEO.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:96;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"96\";s:4:\"plid\";s:2:\"53\";s:9:\"link_path\";s:30:\"admin/config/search/clean-urls\";s:11:\"router_path\";s:30:\"admin/config/search/clean-urls\";s:10:\"link_title\";s:10:\"Clean URLs\";s:7:\"options\";s:93:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Enable or disable clean URLs for your site.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"5\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:2:\"96\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:43:\"a:1:{i:0;s:25:\"system_clean_url_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:30:\"admin/config/search/clean-urls\";s:5:\"title\";s:10:\"Clean URLs\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:43:\"Enable or disable clean URLs for your site.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:200;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"200\";s:4:\"plid\";s:2:\"53\";s:9:\"link_path\";s:28:\"admin/config/search/settings\";s:11:\"router_path\";s:28:\"admin/config/search/settings\";s:10:\"link_title\";s:15:\"Search settings\";s:7:\"options\";s:117:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:67:\"Configure relevance settings for search and other indexing options.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"200\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer search\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:39:\"a:1:{i:0;s:21:\"search_admin_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:28:\"admin/config/search/settings\";s:5:\"title\";s:15:\"Search settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:67:\"Configure relevance settings for search and other indexing options.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:205;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"205\";s:4:\"plid\";s:3:\"200\";s:9:\"link_path\";s:36:\"admin/config/search/settings/reindex\";s:11:\"router_path\";s:36:\"admin/config/search/settings/reindex\";s:10:\"link_title\";s:11:\"Clear index\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"200\";s:2:\"p5\";s:3:\"205\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer search\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:40:\"a:1:{i:0;s:22:\"search_reindex_confirm\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:36:\"admin/config/search/settings/reindex\";s:5:\"title\";s:11:\"Clear index\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:202;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"202\";s:4:\"plid\";s:2:\"53\";s:9:\"link_path\";s:24:\"admin/config/search/path\";s:11:\"router_path\";s:24:\"admin/config/search/path\";s:10:\"link_title\";s:11:\"URL aliases\";s:7:\"options\";s:96:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:46:\"Change your site\'s URL paths by aliasing them.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-5\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"202\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:40:\"a:1:{i:0;s:22:\"administer url aliases\";}\";s:13:\"page_callback\";s:19:\"path_admin_overview\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:24:\"admin/config/search/path\";s:5:\"title\";s:11:\"URL aliases\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:46:\"Change your site\'s URL paths by aliasing them.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:8:{i:203;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"203\";s:4:\"plid\";s:3:\"202\";s:9:\"link_path\";s:28:\"admin/config/search/path/add\";s:11:\"router_path\";s:28:\"admin/config/search/path/add\";s:10:\"link_title\";s:9:\"Add alias\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"202\";s:2:\"p5\";s:3:\"203\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:40:\"a:1:{i:0;s:22:\"administer url aliases\";}\";s:13:\"page_callback\";s:15:\"path_admin_edit\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/config/search/path\";s:8:\"tab_root\";s:24:\"admin/config/search/path\";s:5:\"title\";s:9:\"Add alias\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:207;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"207\";s:4:\"plid\";s:3:\"202\";s:9:\"link_path\";s:29:\"admin/config/search/path/list\";s:11:\"router_path\";s:29:\"admin/config/search/path/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"202\";s:2:\"p5\";s:3:\"207\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:40:\"a:1:{i:0;s:22:\"administer url aliases\";}\";s:13:\"page_callback\";s:19:\"path_admin_overview\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/config/search/path\";s:8:\"tab_root\";s:24:\"admin/config/search/path\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:209;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"209\";s:4:\"plid\";s:3:\"202\";s:9:\"link_path\";s:33:\"admin/config/search/path/delete/%\";s:11:\"router_path\";s:33:\"admin/config/search/path/delete/%\";s:10:\"link_title\";s:12:\"Delete alias\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"202\";s:2:\"p5\";s:3:\"209\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:5;s:9:\"path_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:40:\"a:1:{i:0;s:22:\"administer url aliases\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:51:\"a:2:{i:0;s:25:\"path_admin_delete_confirm\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:33:\"admin/config/search/path/delete/%\";s:5:\"title\";s:12:\"Delete alias\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:211;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"211\";s:4:\"plid\";s:3:\"202\";s:9:\"link_path\";s:31:\"admin/config/search/path/edit/%\";s:11:\"router_path\";s:31:\"admin/config/search/path/edit/%\";s:10:\"link_title\";s:10:\"Edit alias\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"202\";s:2:\"p5\";s:3:\"211\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:5;s:9:\"path_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:40:\"a:1:{i:0;s:22:\"administer url aliases\";}\";s:13:\"page_callback\";s:15:\"path_admin_edit\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:31:\"admin/config/search/path/edit/%\";s:5:\"title\";s:10:\"Edit alias\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:479;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"479\";s:4:\"plid\";s:3:\"202\";s:9:\"link_path\";s:36:\"admin/config/search/path/update_bulk\";s:11:\"router_path\";s:36:\"admin/config/search/path/update_bulk\";s:10:\"link_title\";s:11:\"Bulk update\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"30\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"202\";s:2:\"p5\";s:3:\"479\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:40:\"a:1:{i:0;s:22:\"administer url aliases\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:43:\"a:1:{i:0;s:25:\"pathauto_bulk_update_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/config/search/path\";s:8:\"tab_root\";s:24:\"admin/config/search/path\";s:5:\"title\";s:11:\"Bulk update\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:480;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"480\";s:4:\"plid\";s:3:\"202\";s:9:\"link_path\";s:36:\"admin/config/search/path/delete_bulk\";s:11:\"router_path\";s:36:\"admin/config/search/path/delete_bulk\";s:10:\"link_title\";s:14:\"Delete aliases\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"40\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"202\";s:2:\"p5\";s:3:\"480\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:40:\"a:1:{i:0;s:22:\"administer url aliases\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:39:\"a:1:{i:0;s:21:\"pathauto_admin_delete\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/config/search/path\";s:8:\"tab_root\";s:24:\"admin/config/search/path\";s:5:\"title\";s:14:\"Delete aliases\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:481;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"481\";s:4:\"plid\";s:3:\"202\";s:9:\"link_path\";s:33:\"admin/config/search/path/patterns\";s:11:\"router_path\";s:33:\"admin/config/search/path/patterns\";s:10:\"link_title\";s:8:\"Patterns\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"202\";s:2:\"p5\";s:3:\"481\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer pathauto\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:40:\"a:1:{i:0;s:22:\"pathauto_patterns_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/config/search/path\";s:8:\"tab_root\";s:24:\"admin/config/search/path\";s:5:\"title\";s:8:\"Patterns\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:482;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"482\";s:4:\"plid\";s:3:\"202\";s:9:\"link_path\";s:33:\"admin/config/search/path/settings\";s:11:\"router_path\";s:33:\"admin/config/search/path/settings\";s:10:\"link_title\";s:8:\"Settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"20\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"202\";s:2:\"p5\";s:3:\"482\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer pathauto\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:40:\"a:1:{i:0;s:22:\"pathauto_settings_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/config/search/path\";s:8:\"tab_root\";s:24:\"admin/config/search/path\";s:5:\"title\";s:8:\"Settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:761;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"761\";s:4:\"plid\";s:2:\"53\";s:9:\"link_path\";s:30:\"admin/config/search/search_api\";s:11:\"router_path\";s:30:\"admin/config/search/search_api\";s:10:\"link_title\";s:10:\"Search API\";s:7:\"options\";s:86:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:36:\"Create and configure search engines.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"761\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:39:\"a:1:{i:0;s:21:\"administer search_api\";}\";s:13:\"page_callback\";s:25:\"search_api_admin_overview\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:30:\"admin/config/search/search_api\";s:5:\"title\";s:10:\"Search API\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:36:\"Create and configure search engines.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:6:{i:762;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"762\";s:4:\"plid\";s:3:\"761\";s:9:\"link_path\";s:40:\"admin/config/search/search_api/add_index\";s:11:\"router_path\";s:40:\"admin/config/search/search_api/add_index\";s:10:\"link_title\";s:9:\"Add index\";s:7:\"options\";s:76:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:26:\"Create a new search index.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"761\";s:2:\"p5\";s:3:\"762\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:39:\"a:1:{i:0;s:21:\"administer search_api\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:1:{i:0;s:26:\"search_api_admin_add_index\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/config/search/search_api\";s:8:\"tab_root\";s:30:\"admin/config/search/search_api\";s:5:\"title\";s:9:\"Add index\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:26:\"Create a new search index.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:763;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"763\";s:4:\"plid\";s:3:\"761\";s:9:\"link_path\";s:41:\"admin/config/search/search_api/add_server\";s:11:\"router_path\";s:41:\"admin/config/search/search_api/add_server\";s:10:\"link_title\";s:10:\"Add server\";s:7:\"options\";s:77:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:27:\"Create a new search server.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-1\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"761\";s:2:\"p5\";s:3:\"763\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:39:\"a:1:{i:0;s:21:\"administer search_api\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:45:\"a:1:{i:0;s:27:\"search_api_admin_add_server\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/config/search/search_api\";s:8:\"tab_root\";s:30:\"admin/config/search/search_api\";s:5:\"title\";s:10:\"Add server\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:27:\"Create a new search server.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:764;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"764\";s:4:\"plid\";s:3:\"761\";s:9:\"link_path\";s:39:\"admin/config/search/search_api/overview\";s:11:\"router_path\";s:39:\"admin/config/search/search_api/overview\";s:10:\"link_title\";s:8:\"Overview\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"761\";s:2:\"p5\";s:3:\"764\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:39:\"a:1:{i:0;s:21:\"administer search_api\";}\";s:13:\"page_callback\";s:25:\"search_api_admin_overview\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/config/search/search_api\";s:8:\"tab_root\";s:30:\"admin/config/search/search_api\";s:5:\"title\";s:8:\"Overview\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:765;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"765\";s:4:\"plid\";s:3:\"761\";s:9:\"link_path\";s:38:\"admin/config/search/search_api/index/%\";s:11:\"router_path\";s:38:\"admin/config/search/search_api/index/%\";s:10:\"link_title\";s:10:\"View index\";s:7:\"options\";s:69:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:19:\"View index details.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"761\";s:2:\"p5\";s:3:\"765\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:39:\"a:1:{i:5;s:21:\"search_api_index_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:39:\"a:1:{i:0;s:21:\"administer search_api\";}\";s:13:\"page_callback\";s:27:\"search_api_admin_index_view\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:38:\"admin/config/search/search_api/index/%\";s:5:\"title\";s:10:\"View index\";s:14:\"title_callback\";s:27:\"search_api_admin_item_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:19:\"View index details.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:6:{i:767;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"767\";s:4:\"plid\";s:3:\"765\";s:9:\"link_path\";s:45:\"admin/config/search/search_api/index/%/delete\";s:11:\"router_path\";s:45:\"admin/config/search/search_api/index/%/delete\";s:10:\"link_title\";s:6:\"Delete\";s:7:\"options\";s:63:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:13:\"Delete index.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"761\";s:2:\"p5\";s:3:\"765\";s:2:\"p6\";s:3:\"767\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:39:\"a:1:{i:5;s:21:\"search_api_index_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:29:\"search_api_access_delete_page\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:83:\"a:4:{i:0;s:24:\"search_api_admin_confirm\";i:1;s:5:\"index\";i:2;s:6:\"delete\";i:3;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/config/search/search_api/index/%\";s:8:\"tab_root\";s:38:\"admin/config/search/search_api/index/%\";s:5:\"title\";s:6:\"Delete\";s:14:\"title_callback\";s:28:\"search_api_title_delete_page\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:13:\"Delete index.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:770;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"770\";s:4:\"plid\";s:3:\"765\";s:9:\"link_path\";s:45:\"admin/config/search/search_api/index/%/fields\";s:11:\"router_path\";s:45:\"admin/config/search/search_api/index/%/fields\";s:10:\"link_title\";s:6:\"Fields\";s:7:\"options\";s:72:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:22:\"Select indexed fields.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-4\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"761\";s:2:\"p5\";s:3:\"765\";s:2:\"p6\";s:3:\"770\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:39:\"a:1:{i:5;s:21:\"search_api_index_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:39:\"a:1:{i:0;s:21:\"administer search_api\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:55:\"a:2:{i:0;s:29:\"search_api_admin_index_fields\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/config/search/search_api/index/%\";s:8:\"tab_root\";s:38:\"admin/config/search/search_api/index/%\";s:5:\"title\";s:6:\"Fields\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:22:\"Select indexed fields.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:771;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"771\";s:4:\"plid\";s:3:\"765\";s:9:\"link_path\";s:43:\"admin/config/search/search_api/index/%/edit\";s:11:\"router_path\";s:43:\"admin/config/search/search_api/index/%/edit\";s:10:\"link_title\";s:8:\"Settings\";s:7:\"options\";s:70:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"Edit index settings.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-6\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"761\";s:2:\"p5\";s:3:\"765\";s:2:\"p6\";s:3:\"771\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:39:\"a:1:{i:5;s:21:\"search_api_index_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:39:\"a:1:{i:0;s:21:\"administer search_api\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:53:\"a:2:{i:0;s:27:\"search_api_admin_index_edit\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/config/search/search_api/index/%\";s:8:\"tab_root\";s:38:\"admin/config/search/search_api/index/%\";s:5:\"title\";s:8:\"Settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:20:\"Edit index settings.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:772;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"772\";s:4:\"plid\";s:3:\"765\";s:9:\"link_path\";s:45:\"admin/config/search/search_api/index/%/status\";s:11:\"router_path\";s:45:\"admin/config/search/search_api/index/%/status\";s:10:\"link_title\";s:6:\"Status\";s:7:\"options\";s:83:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Display and work on index status.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-8\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"761\";s:2:\"p5\";s:3:\"765\";s:2:\"p6\";s:3:\"772\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:39:\"a:1:{i:5;s:21:\"search_api_index_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:39:\"a:1:{i:0;s:21:\"administer search_api\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:60:\"a:2:{i:0;s:34:\"search_api_admin_index_status_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/config/search/search_api/index/%\";s:8:\"tab_root\";s:38:\"admin/config/search/search_api/index/%\";s:5:\"title\";s:6:\"Status\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:33:\"Display and work on index status.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:773;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"773\";s:4:\"plid\";s:3:\"765\";s:9:\"link_path\";s:43:\"admin/config/search/search_api/index/%/view\";s:11:\"router_path\";s:43:\"admin/config/search/search_api/index/%/view\";s:10:\"link_title\";s:4:\"View\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"761\";s:2:\"p5\";s:3:\"765\";s:2:\"p6\";s:3:\"773\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:39:\"a:1:{i:5;s:21:\"search_api_index_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:39:\"a:1:{i:0;s:21:\"administer search_api\";}\";s:13:\"page_callback\";s:27:\"search_api_admin_index_view\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/config/search/search_api/index/%\";s:8:\"tab_root\";s:38:\"admin/config/search/search_api/index/%\";s:5:\"title\";s:4:\"View\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:775;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"775\";s:4:\"plid\";s:3:\"765\";s:9:\"link_path\";s:47:\"admin/config/search/search_api/index/%/workflow\";s:11:\"router_path\";s:47:\"admin/config/search/search_api/index/%/workflow\";s:10:\"link_title\";s:8:\"Workflow\";s:7:\"options\";s:70:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"Edit index workflow.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-2\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"761\";s:2:\"p5\";s:3:\"765\";s:2:\"p6\";s:3:\"775\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:39:\"a:1:{i:5;s:21:\"search_api_index_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:39:\"a:1:{i:0;s:21:\"administer search_api\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:57:\"a:2:{i:0;s:31:\"search_api_admin_index_workflow\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/config/search/search_api/index/%\";s:8:\"tab_root\";s:38:\"admin/config/search/search_api/index/%\";s:5:\"title\";s:8:\"Workflow\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:20:\"Edit index workflow.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:766;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"766\";s:4:\"plid\";s:3:\"761\";s:9:\"link_path\";s:39:\"admin/config/search/search_api/server/%\";s:11:\"router_path\";s:39:\"admin/config/search/search_api/server/%\";s:10:\"link_title\";s:11:\"View server\";s:7:\"options\";s:70:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"View server details.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"761\";s:2:\"p5\";s:3:\"766\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:40:\"a:1:{i:5;s:22:\"search_api_server_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:39:\"a:1:{i:0;s:21:\"administer search_api\";}\";s:13:\"page_callback\";s:28:\"search_api_admin_server_view\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:39:\"admin/config/search/search_api/server/%\";s:5:\"title\";s:11:\"View server\";s:14:\"title_callback\";s:27:\"search_api_admin_item_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:20:\"View server details.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:768;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"768\";s:4:\"plid\";s:3:\"766\";s:9:\"link_path\";s:46:\"admin/config/search/search_api/server/%/delete\";s:11:\"router_path\";s:46:\"admin/config/search/search_api/server/%/delete\";s:10:\"link_title\";s:6:\"Delete\";s:7:\"options\";s:64:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:14:\"Delete server.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"761\";s:2:\"p5\";s:3:\"766\";s:2:\"p6\";s:3:\"768\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:40:\"a:1:{i:5;s:22:\"search_api_server_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:29:\"search_api_access_delete_page\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:84:\"a:4:{i:0;s:24:\"search_api_admin_confirm\";i:1;s:6:\"server\";i:2;s:6:\"delete\";i:3;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:39:\"admin/config/search/search_api/server/%\";s:8:\"tab_root\";s:39:\"admin/config/search/search_api/server/%\";s:5:\"title\";s:6:\"Delete\";s:14:\"title_callback\";s:28:\"search_api_title_delete_page\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:14:\"Delete server.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:769;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"769\";s:4:\"plid\";s:3:\"766\";s:9:\"link_path\";s:44:\"admin/config/search/search_api/server/%/edit\";s:11:\"router_path\";s:44:\"admin/config/search/search_api/server/%/edit\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:70:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"Edit server details.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-1\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"761\";s:2:\"p5\";s:3:\"766\";s:2:\"p6\";s:3:\"769\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:40:\"a:1:{i:5;s:22:\"search_api_server_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:39:\"a:1:{i:0;s:21:\"administer search_api\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:54:\"a:2:{i:0;s:28:\"search_api_admin_server_edit\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:39:\"admin/config/search/search_api/server/%\";s:8:\"tab_root\";s:39:\"admin/config/search/search_api/server/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:20:\"Edit server details.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:774;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"774\";s:4:\"plid\";s:3:\"766\";s:9:\"link_path\";s:44:\"admin/config/search/search_api/server/%/view\";s:11:\"router_path\";s:44:\"admin/config/search/search_api/server/%/view\";s:10:\"link_title\";s:4:\"View\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"761\";s:2:\"p5\";s:3:\"766\";s:2:\"p6\";s:3:\"774\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:40:\"a:1:{i:5;s:22:\"search_api_server_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:39:\"a:1:{i:0;s:21:\"administer search_api\";}\";s:13:\"page_callback\";s:28:\"search_api_admin_server_view\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:39:\"admin/config/search/search_api/server/%\";s:8:\"tab_root\";s:39:\"admin/config/search/search_api/server/%\";s:5:\"title\";s:4:\"View\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:776;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"776\";s:4:\"plid\";s:3:\"761\";s:9:\"link_path\";s:35:\"admin/config/search/search_api/page\";s:11:\"router_path\";s:35:\"admin/config/search/search_api/page\";s:10:\"link_title\";s:12:\"Search pages\";s:7:\"options\";s:84:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"Create and configure search pages.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"761\";s:2:\"p5\";s:3:\"776\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:39:\"a:1:{i:0;s:21:\"administer search_api\";}\";s:13:\"page_callback\";s:30:\"search_api_page_admin_overview\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/config/search/search_api\";s:8:\"tab_root\";s:30:\"admin/config/search/search_api\";s:5:\"title\";s:12:\"Search pages\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:34:\"Create and configure search pages.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:777;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"777\";s:4:\"plid\";s:3:\"776\";s:9:\"link_path\";s:39:\"admin/config/search/search_api/page/add\";s:11:\"router_path\";s:39:\"admin/config/search/search_api/page/add\";s:10:\"link_title\";s:15:\"Add search page\";s:7:\"options\";s:72:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:22:\"Add a new search page.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"761\";s:2:\"p5\";s:3:\"776\";s:2:\"p6\";s:3:\"777\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:39:\"a:1:{i:0;s:21:\"administer search_api\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:43:\"a:1:{i:0;s:25:\"search_api_page_admin_add\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:35:\"admin/config/search/search_api/page\";s:8:\"tab_root\";s:30:\"admin/config/search/search_api\";s:5:\"title\";s:15:\"Add search page\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:22:\"Add a new search page.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:778;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"778\";s:4:\"plid\";s:3:\"776\";s:9:\"link_path\";s:37:\"admin/config/search/search_api/page/%\";s:11:\"router_path\";s:37:\"admin/config/search/search_api/page/%\";s:10:\"link_title\";s:16:\"Edit search page\";s:7:\"options\";s:84:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"Configure or delete a search page.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:3:\"761\";s:2:\"p5\";s:3:\"776\";s:2:\"p6\";s:3:\"778\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:38:\"a:1:{i:5;s:20:\"search_api_page_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:39:\"a:1:{i:0;s:21:\"administer search_api\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:52:\"a:2:{i:0;s:26:\"search_api_page_admin_edit\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:37:\"admin/config/search/search_api/page/%\";s:5:\"title\";s:16:\"Edit search page\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:34:\"Configure or delete a search page.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}}}i:56;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"56\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:19:\"admin/config/system\";s:11:\"router_path\";s:19:\"admin/config/system\";s:10:\"link_title\";s:6:\"System\";s:7:\"options\";s:87:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"General system related configuration.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-20\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"56\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"admin/config/system\";s:5:\"title\";s:6:\"System\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:37:\"General system related configuration.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:90;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"90\";s:4:\"plid\";s:2:\"56\";s:9:\"link_path\";s:27:\"admin/config/system/actions\";s:11:\"router_path\";s:27:\"admin/config/system/actions\";s:10:\"link_title\";s:7:\"Actions\";s:7:\"options\";s:91:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:41:\"Manage the actions defined for your site.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"56\";s:2:\"p4\";s:2:\"90\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer actions\";}\";s:13:\"page_callback\";s:21:\"system_actions_manage\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:27:\"admin/config/system/actions\";s:5:\"title\";s:7:\"Actions\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:41:\"Manage the actions defined for your site.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:132;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"132\";s:4:\"plid\";s:2:\"90\";s:9:\"link_path\";s:37:\"admin/config/system/actions/configure\";s:11:\"router_path\";s:37:\"admin/config/system/actions/configure\";s:10:\"link_title\";s:28:\"Configure an advanced action\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"56\";s:2:\"p4\";s:2:\"90\";s:2:\"p5\";s:3:\"132\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer actions\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:42:\"a:1:{i:0;s:24:\"system_actions_configure\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:37:\"admin/config/system/actions/configure\";s:5:\"title\";s:28:\"Configure an advanced action\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:141;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"141\";s:4:\"plid\";s:2:\"90\";s:9:\"link_path\";s:34:\"admin/config/system/actions/manage\";s:11:\"router_path\";s:34:\"admin/config/system/actions/manage\";s:10:\"link_title\";s:14:\"Manage actions\";s:7:\"options\";s:91:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:41:\"Manage the actions defined for your site.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-2\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"56\";s:2:\"p4\";s:2:\"90\";s:2:\"p5\";s:3:\"141\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer actions\";}\";s:13:\"page_callback\";s:21:\"system_actions_manage\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:27:\"admin/config/system/actions\";s:8:\"tab_root\";s:27:\"admin/config/system/actions\";s:5:\"title\";s:14:\"Manage actions\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:41:\"Manage the actions defined for your site.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:159;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"159\";s:4:\"plid\";s:2:\"90\";s:9:\"link_path\";s:36:\"admin/config/system/actions/delete/%\";s:11:\"router_path\";s:36:\"admin/config/system/actions/delete/%\";s:10:\"link_title\";s:13:\"Delete action\";s:7:\"options\";s:67:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:17:\"Delete an action.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"56\";s:2:\"p4\";s:2:\"90\";s:2:\"p5\";s:3:\"159\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:30:\"a:1:{i:5;s:12:\"actions_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer actions\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:52:\"a:2:{i:0;s:26:\"system_actions_delete_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:36:\"admin/config/system/actions/delete/%\";s:5:\"title\";s:13:\"Delete action\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:17:\"Delete an action.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:97;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"97\";s:4:\"plid\";s:2:\"56\";s:9:\"link_path\";s:24:\"admin/config/system/cron\";s:11:\"router_path\";s:24:\"admin/config/system/cron\";s:10:\"link_title\";s:4:\"Cron\";s:7:\"options\";s:90:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:40:\"Manage automatic site maintenance tasks.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"20\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"56\";s:2:\"p4\";s:2:\"97\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:38:\"a:1:{i:0;s:20:\"system_cron_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:24:\"admin/config/system/cron\";s:5:\"title\";s:4:\"Cron\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:40:\"Manage automatic site maintenance tasks.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:120;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"120\";s:4:\"plid\";s:2:\"56\";s:9:\"link_path\";s:36:\"admin/config/system/site-information\";s:11:\"router_path\";s:36:\"admin/config/system/site-information\";s:10:\"link_title\";s:16:\"Site information\";s:7:\"options\";s:155:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:104:\"Change site name, e-mail address, slogan, default front page, and number of posts per page, error pages.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-20\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"56\";s:2:\"p4\";s:3:\"120\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:1:{i:0;s:32:\"system_site_information_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:36:\"admin/config/system/site-information\";s:5:\"title\";s:16:\"Site information\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:104:\"Change site name, e-mail address, slogan, default front page, and number of posts per page, error pages.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:474;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"474\";s:4:\"plid\";s:2:\"56\";s:9:\"link_path\";s:33:\"admin/config/system/logintoboggan\";s:11:\"router_path\";s:33:\"admin/config/system/logintoboggan\";s:10:\"link_title\";s:13:\"LoginToboggan\";s:7:\"options\";s:153:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:102:\"Set up custom login options like instant login, login redirects, pre-authorized validation roles, etc.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"56\";s:2:\"p4\";s:3:\"474\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:45:\"a:1:{i:0;s:27:\"logintoboggan_main_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:33:\"admin/config/system/logintoboggan\";s:5:\"title\";s:13:\"LoginToboggan\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:102:\"Set up custom login options like instant login, login redirects, pre-authorized validation roles, etc.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:61;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"61\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:27:\"admin/config/user-interface\";s:11:\"router_path\";s:27:\"admin/config/user-interface\";s:10:\"link_title\";s:14:\"User interface\";s:7:\"options\";s:88:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Tools that enhance the user interface.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-15\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"61\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:27:\"admin/config/user-interface\";s:5:\"title\";s:14:\"User interface\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:38:\"Tools that enhance the user interface.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:201;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"201\";s:4:\"plid\";s:2:\"61\";s:9:\"link_path\";s:36:\"admin/config/user-interface/shortcut\";s:11:\"router_path\";s:36:\"admin/config/user-interface/shortcut\";s:10:\"link_title\";s:9:\"Shortcuts\";s:7:\"options\";s:79:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:29:\"Add and modify shortcut sets.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"61\";s:2:\"p4\";s:3:\"201\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"administer shortcuts\";}\";s:13:\"page_callback\";s:18:\"shortcut_set_admin\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:36:\"admin/config/user-interface/shortcut\";s:5:\"title\";s:9:\"Shortcuts\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:29:\"Add and modify shortcut sets.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:204;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"204\";s:4:\"plid\";s:3:\"201\";s:9:\"link_path\";s:44:\"admin/config/user-interface/shortcut/add-set\";s:11:\"router_path\";s:44:\"admin/config/user-interface/shortcut/add-set\";s:10:\"link_title\";s:16:\"Add shortcut set\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"61\";s:2:\"p4\";s:3:\"201\";s:2:\"p5\";s:3:\"204\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"administer shortcuts\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:39:\"a:1:{i:0;s:21:\"shortcut_set_add_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:36:\"admin/config/user-interface/shortcut\";s:8:\"tab_root\";s:36:\"admin/config/user-interface/shortcut\";s:5:\"title\";s:16:\"Add shortcut set\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:206;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"206\";s:4:\"plid\";s:3:\"201\";s:9:\"link_path\";s:38:\"admin/config/user-interface/shortcut/%\";s:11:\"router_path\";s:38:\"admin/config/user-interface/shortcut/%\";s:10:\"link_title\";s:14:\"Edit shortcuts\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"61\";s:2:\"p4\";s:3:\"201\";s:2:\"p5\";s:3:\"206\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:35:\"a:1:{i:4;s:17:\"shortcut_set_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:24:\"shortcut_set_edit_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:48:\"a:2:{i:0;s:22:\"shortcut_set_customize\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:38:\"admin/config/user-interface/shortcut/%\";s:5:\"title\";s:14:\"Edit shortcuts\";s:14:\"title_callback\";s:18:\"shortcut_set_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:208;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"208\";s:4:\"plid\";s:3:\"206\";s:9:\"link_path\";s:47:\"admin/config/user-interface/shortcut/%/add-link\";s:11:\"router_path\";s:47:\"admin/config/user-interface/shortcut/%/add-link\";s:10:\"link_title\";s:12:\"Add shortcut\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"61\";s:2:\"p4\";s:3:\"201\";s:2:\"p5\";s:3:\"206\";s:2:\"p6\";s:3:\"208\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:35:\"a:1:{i:4;s:17:\"shortcut_set_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:24:\"shortcut_set_edit_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:43:\"a:2:{i:0;s:17:\"shortcut_link_add\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/config/user-interface/shortcut/%\";s:8:\"tab_root\";s:38:\"admin/config/user-interface/shortcut/%\";s:5:\"title\";s:12:\"Add shortcut\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:210;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"210\";s:4:\"plid\";s:3:\"206\";s:9:\"link_path\";s:45:\"admin/config/user-interface/shortcut/%/delete\";s:11:\"router_path\";s:45:\"admin/config/user-interface/shortcut/%/delete\";s:10:\"link_title\";s:19:\"Delete shortcut set\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"61\";s:2:\"p4\";s:3:\"201\";s:2:\"p5\";s:3:\"206\";s:2:\"p6\";s:3:\"210\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:35:\"a:1:{i:4;s:17:\"shortcut_set_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:26:\"shortcut_set_delete_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"shortcut_set_delete_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:45:\"admin/config/user-interface/shortcut/%/delete\";s:5:\"title\";s:19:\"Delete shortcut set\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:212;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"212\";s:4:\"plid\";s:3:\"206\";s:9:\"link_path\";s:43:\"admin/config/user-interface/shortcut/%/edit\";s:11:\"router_path\";s:43:\"admin/config/user-interface/shortcut/%/edit\";s:10:\"link_title\";s:13:\"Edit set name\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"61\";s:2:\"p4\";s:3:\"201\";s:2:\"p5\";s:3:\"206\";s:2:\"p6\";s:3:\"212\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:35:\"a:1:{i:4;s:17:\"shortcut_set_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:24:\"shortcut_set_edit_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:48:\"a:2:{i:0;s:22:\"shortcut_set_edit_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/config/user-interface/shortcut/%\";s:8:\"tab_root\";s:38:\"admin/config/user-interface/shortcut/%\";s:5:\"title\";s:13:\"Edit set name\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:214;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"214\";s:4:\"plid\";s:3:\"206\";s:9:\"link_path\";s:44:\"admin/config/user-interface/shortcut/%/links\";s:11:\"router_path\";s:44:\"admin/config/user-interface/shortcut/%/links\";s:10:\"link_title\";s:10:\"List links\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"61\";s:2:\"p4\";s:3:\"201\";s:2:\"p5\";s:3:\"206\";s:2:\"p6\";s:3:\"214\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:35:\"a:1:{i:4;s:17:\"shortcut_set_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:24:\"shortcut_set_edit_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:48:\"a:2:{i:0;s:22:\"shortcut_set_customize\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/config/user-interface/shortcut/%\";s:8:\"tab_root\";s:38:\"admin/config/user-interface/shortcut/%\";s:5:\"title\";s:10:\"List links\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:213;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"213\";s:4:\"plid\";s:3:\"201\";s:9:\"link_path\";s:43:\"admin/config/user-interface/shortcut/link/%\";s:11:\"router_path\";s:43:\"admin/config/user-interface/shortcut/link/%\";s:10:\"link_title\";s:13:\"Edit shortcut\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"61\";s:2:\"p4\";s:3:\"201\";s:2:\"p5\";s:3:\"213\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:5;s:14:\"menu_link_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:20:\"shortcut_link_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:18:\"shortcut_link_edit\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:43:\"admin/config/user-interface/shortcut/link/%\";s:5:\"title\";s:13:\"Edit shortcut\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:215;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"215\";s:4:\"plid\";s:3:\"213\";s:9:\"link_path\";s:50:\"admin/config/user-interface/shortcut/link/%/delete\";s:11:\"router_path\";s:50:\"admin/config/user-interface/shortcut/link/%/delete\";s:10:\"link_title\";s:15:\"Delete shortcut\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"61\";s:2:\"p4\";s:3:\"201\";s:2:\"p5\";s:3:\"213\";s:2:\"p6\";s:3:\"215\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:5;s:14:\"menu_link_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:20:\"shortcut_link_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:46:\"a:2:{i:0;s:20:\"shortcut_link_delete\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:50:\"admin/config/user-interface/shortcut/link/%/delete\";s:5:\"title\";s:15:\"Delete shortcut\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}i:314;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"314\";s:4:\"plid\";s:2:\"61\";s:9:\"link_path\";s:40:\"admin/config/user-interface/modulefilter\";s:11:\"router_path\";s:40:\"admin/config/user-interface/modulefilter\";s:10:\"link_title\";s:13:\"Module filter\";s:7:\"options\";s:87:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"Configure settings for Module Filter.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"61\";s:2:\"p4\";s:3:\"314\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer module filter\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:40:\"a:1:{i:0;s:22:\"module_filter_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:40:\"admin/config/user-interface/modulefilter\";s:5:\"title\";s:13:\"Module filter\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:37:\"Configure settings for Module Filter.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:64;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"64\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:21:\"admin/config/services\";s:11:\"router_path\";s:21:\"admin/config/services\";s:10:\"link_title\";s:12:\"Web services\";s:7:\"options\";s:80:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:30:\"Tools related to web services.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"64\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/config/services\";s:5:\"title\";s:12:\"Web services\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:30:\"Tools related to web services.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:115;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"115\";s:4:\"plid\";s:2:\"64\";s:9:\"link_path\";s:36:\"admin/config/services/rss-publishing\";s:11:\"router_path\";s:36:\"admin/config/services/rss-publishing\";s:10:\"link_title\";s:14:\"RSS publishing\";s:7:\"options\";s:165:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:114:\"Configure the site description, the number of items per feed and whether feeds should be titles/teasers/full-text.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"64\";s:2:\"p4\";s:3:\"115\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:43:\"a:1:{i:0;s:25:\"system_rss_feeds_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:36:\"admin/config/services/rss-publishing\";s:5:\"title\";s:14:\"RSS publishing\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:114:\"Configure the site description, the number of items per feed and whether feeds should be titles/teasers/full-text.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:65;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"65\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:21:\"admin/config/workflow\";s:11:\"router_path\";s:21:\"admin/config/workflow\";s:10:\"link_title\";s:8:\"Workflow\";s:7:\"options\";s:93:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Content workflow, editorial workflow tools.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"5\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"65\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/config/workflow\";s:5:\"title\";s:8:\"Workflow\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:43:\"Content workflow, editorial workflow tools.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:308;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"308\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:27:\"admin/config/administration\";s:11:\"router_path\";s:27:\"admin/config/administration\";s:10:\"link_title\";s:14:\"Administration\";s:7:\"options\";s:71:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:21:\"Administration tools.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:3:\"308\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:27:\"admin/config/administration\";s:5:\"title\";s:14:\"Administration\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:21:\"Administration tools.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:311;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"311\";s:4:\"plid\";s:3:\"308\";s:9:\"link_path\";s:38:\"admin/config/administration/admin_menu\";s:11:\"router_path\";s:38:\"admin/config/administration/admin_menu\";s:10:\"link_title\";s:19:\"Administration menu\";s:7:\"options\";s:86:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:36:\"Adjust administration menu settings.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:3:\"308\";s:2:\"p4\";s:3:\"311\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:43:\"a:1:{i:0;s:25:\"admin_menu_theme_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:38:\"admin/config/administration/admin_menu\";s:5:\"title\";s:19:\"Administration menu\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:36:\"Adjust administration menu settings.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:519;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"519\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:17:\"admin/config/date\";s:11:\"router_path\";s:17:\"admin/config/date\";s:10:\"link_title\";s:8:\"Date API\";s:7:\"options\";s:92:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:42:\"Settings for modules the use the Date API.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:3:\"519\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:17:\"admin/config/date\";s:5:\"title\";s:8:\"Date API\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:42:\"Settings for modules the use the Date API.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:521;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"521\";s:4:\"plid\";s:3:\"519\";s:9:\"link_path\";s:28:\"admin/config/date/date_popup\";s:11:\"router_path\";s:28:\"admin/config/date/date_popup\";s:10:\"link_title\";s:10:\"Date Popup\";s:7:\"options\";s:84:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"Configure the Date Popup settings.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:3:\"519\";s:2:\"p4\";s:3:\"521\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:37:\"a:1:{i:0;s:19:\"date_popup_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:28:\"admin/config/date/date_popup\";s:5:\"title\";s:10:\"Date Popup\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:34:\"Configure the Date Popup settings.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:714;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"714\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:41:\"admin/config/famc_analytics/clear_metrics\";s:11:\"router_path\";s:41:\"admin/config/famc_analytics/clear_metrics\";s:10:\"link_title\";s:25:\"Clear Flash Accel metrics\";s:7:\"options\";s:73:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:23:\"Clears all metric data.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:3:\"714\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:32:\"a:1:{i:0;s:14:\"access content\";}\";s:13:\"page_callback\";s:28:\"famc_analytics_clear_metrics\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:41:\"admin/config/famc_analytics/clear_metrics\";s:5:\"title\";s:25:\"Clear Flash Accel metrics\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:23:\"Clears all metric data.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:780;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"780\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:28:\"admin/config/clear_variables\";s:11:\"router_path\";s:28:\"admin/config/clear_variables\";s:10:\"link_title\";s:23:\"Clear Console Variables\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:3:\"780\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:43:\"a:1:{i:0;s:25:\"access mercury_management\";}\";s:13:\"page_callback\";s:41:\"mercury_management_clear_drupal_variables\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:28:\"admin/config/clear_variables\";s:5:\"title\";s:23:\"Clear Console Variables\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:9;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:1:\"9\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:13:\"admin/content\";s:11:\"router_path\";s:13:\"admin/content\";s:10:\"link_title\";s:7:\"Content\";s:7:\"options\";s:82:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:32:\"Administer content and comments.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"9\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:41:\"a:1:{i:0;s:23:\"access content overview\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:36:\"a:1:{i:0;s:18:\"node_admin_content\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:13:\"admin/content\";s:5:\"title\";s:7:\"Content\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:32:\"Administer content and comments.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:32;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"32\";s:4:\"plid\";s:1:\"9\";s:9:\"link_path\";s:21:\"admin/content/comment\";s:11:\"router_path\";s:21:\"admin/content/comment\";s:10:\"link_title\";s:8:\"Comments\";s:7:\"options\";s:109:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:59:\"List and edit site comments and the comment approval queue.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"9\";s:2:\"p3\";s:2:\"32\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer comments\";}\";s:13:\"page_callback\";s:13:\"comment_admin\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:13:\"admin/content\";s:8:\"tab_root\";s:13:\"admin/content\";s:5:\"title\";s:8:\"Comments\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"134\";s:11:\"description\";s:59:\"List and edit site comments and the comment approval queue.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:114;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"114\";s:4:\"plid\";s:2:\"32\";s:9:\"link_path\";s:25:\"admin/content/comment/new\";s:11:\"router_path\";s:25:\"admin/content/comment/new\";s:10:\"link_title\";s:18:\"Published comments\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"9\";s:2:\"p3\";s:2:\"32\";s:2:\"p4\";s:3:\"114\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer comments\";}\";s:13:\"page_callback\";s:13:\"comment_admin\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/content/comment\";s:8:\"tab_root\";s:13:\"admin/content\";s:5:\"title\";s:18:\"Published comments\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:125;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"125\";s:4:\"plid\";s:2:\"32\";s:9:\"link_path\";s:30:\"admin/content/comment/approval\";s:11:\"router_path\";s:30:\"admin/content/comment/approval\";s:10:\"link_title\";s:19:\"Unapproved comments\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"9\";s:2:\"p3\";s:2:\"32\";s:2:\"p4\";s:3:\"125\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer comments\";}\";s:13:\"page_callback\";s:13:\"comment_admin\";s:14:\"page_arguments\";s:25:\"a:1:{i:0;s:8:\"approval\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/content/comment\";s:8:\"tab_root\";s:13:\"admin/content\";s:5:\"title\";s:19:\"Unapproved comments\";s:14:\"title_callback\";s:25:\"comment_count_unpublished\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:34;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"34\";s:4:\"plid\";s:1:\"9\";s:9:\"link_path\";s:18:\"admin/content/node\";s:11:\"router_path\";s:18:\"admin/content/node\";s:10:\"link_title\";s:7:\"Content\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"9\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:41:\"a:1:{i:0;s:23:\"access content overview\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:36:\"a:1:{i:0;s:18:\"node_admin_content\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:13:\"admin/content\";s:8:\"tab_root\";s:13:\"admin/content\";s:5:\"title\";s:7:\"Content\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:11;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"11\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:15:\"admin/dashboard\";s:11:\"router_path\";s:15:\"admin/dashboard\";s:10:\"link_title\";s:9:\"Dashboard\";s:7:\"options\";s:84:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"View and customize your dashboard.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-15\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"11\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"access dashboard\";}\";s:13:\"page_callback\";s:15:\"dashboard_admin\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/dashboard\";s:5:\"title\";s:9:\"Dashboard\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:34:\"View and customize your dashboard.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:33;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"33\";s:4:\"plid\";s:2:\"11\";s:9:\"link_path\";s:25:\"admin/dashboard/configure\";s:11:\"router_path\";s:25:\"admin/dashboard/configure\";s:10:\"link_title\";s:36:\"Configure available dashboard blocks\";s:7:\"options\";s:103:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:53:\"Configure which blocks can be shown on the dashboard.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"11\";s:2:\"p3\";s:2:\"33\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer blocks\";}\";s:13:\"page_callback\";s:22:\"dashboard_admin_blocks\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:25:\"admin/dashboard/configure\";s:5:\"title\";s:36:\"Configure available dashboard blocks\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:53:\"Configure which blocks can be shown on the dashboard.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:37;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"37\";s:4:\"plid\";s:2:\"11\";s:9:\"link_path\";s:25:\"admin/dashboard/customize\";s:11:\"router_path\";s:25:\"admin/dashboard/customize\";s:10:\"link_title\";s:19:\"Customize dashboard\";s:7:\"options\";s:75:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:25:\"Customize your dashboard.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"11\";s:2:\"p3\";s:2:\"37\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"access dashboard\";}\";s:13:\"page_callback\";s:15:\"dashboard_admin\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;b:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:25:\"admin/dashboard/customize\";s:5:\"title\";s:19:\"Customize dashboard\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:25:\"Customize your dashboard.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:12;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"12\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:10:\"admin/help\";s:11:\"router_path\";s:10:\"admin/help\";s:10:\"link_title\";s:4:\"Help\";s:7:\"options\";s:98:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:48:\"Reference for usage, configuration, and modules.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"9\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_main\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:10:\"admin/help\";s:5:\"title\";s:4:\"Help\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:48:\"Reference for usage, configuration, and modules.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:35:{i:66;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"66\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:16:\"admin/help/block\";s:11:\"router_path\";s:16:\"admin/help/block\";s:10:\"link_title\";s:5:\"block\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:2:\"66\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:16:\"admin/help/block\";s:5:\"title\";s:5:\"block\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:67;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"67\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:16:\"admin/help/color\";s:11:\"router_path\";s:16:\"admin/help/color\";s:10:\"link_title\";s:5:\"color\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:2:\"67\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:16:\"admin/help/color\";s:5:\"title\";s:5:\"color\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:68;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"68\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:18:\"admin/help/comment\";s:11:\"router_path\";s:18:\"admin/help/comment\";s:10:\"link_title\";s:7:\"comment\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:2:\"68\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:18:\"admin/help/comment\";s:5:\"title\";s:7:\"comment\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:70;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"70\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:20:\"admin/help/dashboard\";s:11:\"router_path\";s:20:\"admin/help/dashboard\";s:10:\"link_title\";s:9:\"dashboard\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:2:\"70\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:20:\"admin/help/dashboard\";s:5:\"title\";s:9:\"dashboard\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:71;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"71\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:16:\"admin/help/dblog\";s:11:\"router_path\";s:16:\"admin/help/dblog\";s:10:\"link_title\";s:5:\"dblog\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:2:\"71\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:16:\"admin/help/dblog\";s:5:\"title\";s:5:\"dblog\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:72;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"72\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:16:\"admin/help/field\";s:11:\"router_path\";s:16:\"admin/help/field\";s:10:\"link_title\";s:5:\"field\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:2:\"72\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:16:\"admin/help/field\";s:5:\"title\";s:5:\"field\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:73;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"73\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:28:\"admin/help/field_sql_storage\";s:11:\"router_path\";s:28:\"admin/help/field_sql_storage\";s:10:\"link_title\";s:17:\"field_sql_storage\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:2:\"73\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:28:\"admin/help/field_sql_storage\";s:5:\"title\";s:17:\"field_sql_storage\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:74;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"74\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:19:\"admin/help/field_ui\";s:11:\"router_path\";s:19:\"admin/help/field_ui\";s:10:\"link_title\";s:8:\"field_ui\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:2:\"74\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"admin/help/field_ui\";s:5:\"title\";s:8:\"field_ui\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:76;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"76\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:17:\"admin/help/filter\";s:11:\"router_path\";s:17:\"admin/help/filter\";s:10:\"link_title\";s:6:\"filter\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:2:\"76\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:17:\"admin/help/filter\";s:5:\"title\";s:6:\"filter\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:77;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"77\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:15:\"admin/help/help\";s:11:\"router_path\";s:15:\"admin/help/help\";s:10:\"link_title\";s:4:\"help\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:2:\"77\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/help/help\";s:5:\"title\";s:4:\"help\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:79;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"79\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:15:\"admin/help/list\";s:11:\"router_path\";s:15:\"admin/help/list\";s:10:\"link_title\";s:4:\"list\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:2:\"79\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/help/list\";s:5:\"title\";s:4:\"list\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:80;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"80\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:15:\"admin/help/menu\";s:11:\"router_path\";s:15:\"admin/help/menu\";s:10:\"link_title\";s:4:\"menu\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:2:\"80\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/help/menu\";s:5:\"title\";s:4:\"menu\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:81;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"81\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:15:\"admin/help/node\";s:11:\"router_path\";s:15:\"admin/help/node\";s:10:\"link_title\";s:4:\"node\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:2:\"81\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/help/node\";s:5:\"title\";s:4:\"node\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:82;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"82\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:18:\"admin/help/options\";s:11:\"router_path\";s:18:\"admin/help/options\";s:10:\"link_title\";s:7:\"options\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:2:\"82\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:18:\"admin/help/options\";s:5:\"title\";s:7:\"options\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:83;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"83\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:17:\"admin/help/system\";s:11:\"router_path\";s:17:\"admin/help/system\";s:10:\"link_title\";s:6:\"system\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:2:\"83\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:17:\"admin/help/system\";s:5:\"title\";s:6:\"system\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:84;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"84\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:19:\"admin/help/taxonomy\";s:11:\"router_path\";s:19:\"admin/help/taxonomy\";s:10:\"link_title\";s:8:\"taxonomy\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:2:\"84\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"admin/help/taxonomy\";s:5:\"title\";s:8:\"taxonomy\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:85;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"85\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:15:\"admin/help/text\";s:11:\"router_path\";s:15:\"admin/help/text\";s:10:\"link_title\";s:4:\"text\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:2:\"85\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/help/text\";s:5:\"title\";s:4:\"text\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:86;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"86\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:15:\"admin/help/user\";s:11:\"router_path\";s:15:\"admin/help/user\";s:10:\"link_title\";s:4:\"user\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:2:\"86\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/help/user\";s:5:\"title\";s:4:\"user\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:194;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"194\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:17:\"admin/help/number\";s:11:\"router_path\";s:17:\"admin/help/number\";s:10:\"link_title\";s:6:\"number\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:3:\"194\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:17:\"admin/help/number\";s:5:\"title\";s:6:\"number\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:196;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"196\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:15:\"admin/help/path\";s:11:\"router_path\";s:15:\"admin/help/path\";s:10:\"link_title\";s:4:\"path\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:3:\"196\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/help/path\";s:5:\"title\";s:4:\"path\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:197;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"197\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:14:\"admin/help/rdf\";s:11:\"router_path\";s:14:\"admin/help/rdf\";s:10:\"link_title\";s:3:\"rdf\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:3:\"197\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:14:\"admin/help/rdf\";s:5:\"title\";s:3:\"rdf\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:198;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"198\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:17:\"admin/help/search\";s:11:\"router_path\";s:17:\"admin/help/search\";s:10:\"link_title\";s:6:\"search\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:3:\"198\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:17:\"admin/help/search\";s:5:\"title\";s:6:\"search\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:199;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"199\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:19:\"admin/help/shortcut\";s:11:\"router_path\";s:19:\"admin/help/shortcut\";s:10:\"link_title\";s:8:\"shortcut\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:3:\"199\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"admin/help/shortcut\";s:5:\"title\";s:8:\"shortcut\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:309;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"309\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:21:\"admin/help/admin_menu\";s:11:\"router_path\";s:21:\"admin/help/admin_menu\";s:10:\"link_title\";s:10:\"admin_menu\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:3:\"309\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/help/admin_menu\";s:5:\"title\";s:10:\"admin_menu\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:310;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"310\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:17:\"admin/help/syslog\";s:11:\"router_path\";s:17:\"admin/help/syslog\";s:10:\"link_title\";s:6:\"syslog\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:3:\"310\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:17:\"admin/help/syslog\";s:5:\"title\";s:6:\"syslog\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:361;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"361\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:23:\"admin/help/unique_field\";s:11:\"router_path\";s:23:\"admin/help/unique_field\";s:10:\"link_title\";s:12:\"unique_field\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:3:\"361\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:23:\"admin/help/unique_field\";s:5:\"title\";s:12:\"unique_field\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:366;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"366\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:14:\"admin/help/php\";s:11:\"router_path\";s:14:\"admin/help/php\";s:10:\"link_title\";s:3:\"php\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:3:\"366\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:14:\"admin/help/php\";s:5:\"title\";s:3:\"php\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:473;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"473\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:24:\"admin/help/logintoboggan\";s:11:\"router_path\";s:24:\"admin/help/logintoboggan\";s:10:\"link_title\";s:13:\"logintoboggan\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:3:\"473\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:24:\"admin/help/logintoboggan\";s:5:\"title\";s:13:\"logintoboggan\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:477;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"477\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:19:\"admin/help/pathauto\";s:11:\"router_path\";s:19:\"admin/help/pathauto\";s:10:\"link_title\";s:8:\"pathauto\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:3:\"477\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"admin/help/pathauto\";s:5:\"title\";s:8:\"pathauto\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:478;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"478\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:16:\"admin/help/token\";s:11:\"router_path\";s:16:\"admin/help/token\";s:10:\"link_title\";s:5:\"token\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:3:\"478\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:16:\"admin/help/token\";s:5:\"title\";s:5:\"token\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:491;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"491\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:28:\"admin/help/login_destination\";s:11:\"router_path\";s:28:\"admin/help/login_destination\";s:10:\"link_title\";s:17:\"login_destination\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:3:\"491\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:28:\"admin/help/login_destination\";s:5:\"title\";s:17:\"login_destination\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:520;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"520\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:15:\"admin/help/date\";s:11:\"router_path\";s:15:\"admin/help/date\";s:10:\"link_title\";s:4:\"date\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:3:\"520\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/help/date\";s:5:\"title\";s:4:\"date\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:706;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"706\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:25:\"admin/help/views_watchdog\";s:11:\"router_path\";s:25:\"admin/help/views_watchdog\";s:10:\"link_title\";s:14:\"views_watchdog\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:3:\"706\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:25:\"admin/help/views_watchdog\";s:5:\"title\";s:14:\"views_watchdog\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:842;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"842\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:23:\"admin/help/coder_review\";s:11:\"router_path\";s:23:\"admin/help/coder_review\";s:10:\"link_title\";s:12:\"coder_review\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:3:\"842\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:23:\"admin/help/coder_review\";s:5:\"title\";s:12:\"coder_review\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:880;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"880\";s:4:\"plid\";s:2:\"12\";s:9:\"link_path\";s:20:\"admin/help/famc_asup\";s:11:\"router_path\";s:20:\"admin/help/famc_asup\";s:10:\"link_title\";s:9:\"famc_asup\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:3:\"880\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:20:\"admin/help/famc_asup\";s:5:\"title\";s:9:\"famc_asup\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:13;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"13\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:11:\"admin/index\";s:11:\"router_path\";s:11:\"admin/index\";s:10:\"link_title\";s:5:\"Index\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-18\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"13\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:18:\"system_admin_index\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:5:\"admin\";s:8:\"tab_root\";s:5:\"admin\";s:5:\"title\";s:5:\"Index\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:16;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"16\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:13:\"admin/modules\";s:11:\"router_path\";s:13:\"admin/modules\";s:10:\"link_title\";s:7:\"Modules\";s:7:\"options\";s:76:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:26:\"Extend site functionality.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-2\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"16\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer modules\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:32:\"a:1:{i:0;s:14:\"system_modules\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:13:\"admin/modules\";s:5:\"title\";s:7:\"Modules\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:26:\"Extend site functionality.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:44;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"44\";s:4:\"plid\";s:2:\"16\";s:9:\"link_path\";s:18:\"admin/modules/list\";s:11:\"router_path\";s:18:\"admin/modules/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"16\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer modules\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:32:\"a:1:{i:0;s:14:\"system_modules\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:13:\"admin/modules\";s:8:\"tab_root\";s:13:\"admin/modules\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:107;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"107\";s:4:\"plid\";s:2:\"44\";s:9:\"link_path\";s:26:\"admin/modules/list/confirm\";s:11:\"router_path\";s:26:\"admin/modules/list/confirm\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"16\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:3:\"107\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer modules\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:32:\"a:1:{i:0;s:14:\"system_modules\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:26:\"admin/modules/list/confirm\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:60;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"60\";s:4:\"plid\";s:2:\"16\";s:9:\"link_path\";s:23:\"admin/modules/uninstall\";s:11:\"router_path\";s:23:\"admin/modules/uninstall\";s:10:\"link_title\";s:9:\"Uninstall\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"20\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"16\";s:2:\"p3\";s:2:\"60\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer modules\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:42:\"a:1:{i:0;s:24:\"system_modules_uninstall\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:13:\"admin/modules\";s:8:\"tab_root\";s:13:\"admin/modules\";s:5:\"title\";s:9:\"Uninstall\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:123;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"123\";s:4:\"plid\";s:2:\"60\";s:9:\"link_path\";s:31:\"admin/modules/uninstall/confirm\";s:11:\"router_path\";s:31:\"admin/modules/uninstall/confirm\";s:10:\"link_title\";s:9:\"Uninstall\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"16\";s:2:\"p3\";s:2:\"60\";s:2:\"p4\";s:3:\"123\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer modules\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:42:\"a:1:{i:0;s:24:\"system_modules_uninstall\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:31:\"admin/modules/uninstall/confirm\";s:5:\"title\";s:9:\"Uninstall\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}i:18;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"18\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:12:\"admin/people\";s:11:\"router_path\";s:12:\"admin/people\";s:10:\"link_title\";s:6:\"People\";s:7:\"options\";s:95:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Manage user accounts, roles, and permissions.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-4\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer users\";}\";s:13:\"page_callback\";s:10:\"user_admin\";s:14:\"page_arguments\";s:21:\"a:1:{i:0;s:4:\"list\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:12:\"admin/people\";s:5:\"title\";s:6:\"People\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:45:\"Manage user accounts, roles, and permissions.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:29;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"29\";s:4:\"plid\";s:2:\"18\";s:9:\"link_path\";s:19:\"admin/people/create\";s:11:\"router_path\";s:19:\"admin/people/create\";s:10:\"link_title\";s:8:\"Add user\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:2:\"29\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer users\";}\";s:13:\"page_callback\";s:10:\"user_admin\";s:14:\"page_arguments\";s:23:\"a:1:{i:0;s:6:\"create\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:12:\"admin/people\";s:8:\"tab_root\";s:12:\"admin/people\";s:5:\"title\";s:8:\"Add user\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:45;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"45\";s:4:\"plid\";s:2:\"18\";s:9:\"link_path\";s:19:\"admin/people/people\";s:11:\"router_path\";s:19:\"admin/people/people\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:100:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:50:\"Find and manage people interacting with your site.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:2:\"45\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer users\";}\";s:13:\"page_callback\";s:10:\"user_admin\";s:14:\"page_arguments\";s:21:\"a:1:{i:0;s:4:\"list\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:12:\"admin/people\";s:8:\"tab_root\";s:12:\"admin/people\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:50:\"Find and manage people interacting with your site.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:49;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"49\";s:4:\"plid\";s:2:\"18\";s:9:\"link_path\";s:24:\"admin/people/permissions\";s:11:\"router_path\";s:24:\"admin/people/permissions\";s:10:\"link_title\";s:11:\"Permissions\";s:7:\"options\";s:114:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:64:\"Determine access to features by selecting permissions for roles.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:40:\"a:1:{i:0;s:22:\"administer permissions\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:40:\"a:1:{i:0;s:22:\"user_admin_permissions\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:12:\"admin/people\";s:8:\"tab_root\";s:12:\"admin/people\";s:5:\"title\";s:11:\"Permissions\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:64:\"Determine access to features by selecting permissions for roles.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:113;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"113\";s:4:\"plid\";s:2:\"49\";s:9:\"link_path\";s:29:\"admin/people/permissions/list\";s:11:\"router_path\";s:29:\"admin/people/permissions/list\";s:10:\"link_title\";s:11:\"Permissions\";s:7:\"options\";s:114:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:64:\"Determine access to features by selecting permissions for roles.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-8\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"113\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:40:\"a:1:{i:0;s:22:\"administer permissions\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:40:\"a:1:{i:0;s:22:\"user_admin_permissions\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/people/permissions\";s:8:\"tab_root\";s:12:\"admin/people\";s:5:\"title\";s:11:\"Permissions\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:64:\"Determine access to features by selecting permissions for roles.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:117;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"117\";s:4:\"plid\";s:2:\"49\";s:9:\"link_path\";s:30:\"admin/people/permissions/roles\";s:11:\"router_path\";s:30:\"admin/people/permissions/roles\";s:10:\"link_title\";s:5:\"Roles\";s:7:\"options\";s:80:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:30:\"List, edit, or add user roles.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-5\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"117\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:40:\"a:1:{i:0;s:22:\"administer permissions\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:34:\"a:1:{i:0;s:16:\"user_admin_roles\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/people/permissions\";s:8:\"tab_root\";s:12:\"admin/people\";s:5:\"title\";s:5:\"Roles\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:30:\"List, edit, or add user roles.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:162;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"162\";s:4:\"plid\";s:3:\"117\";s:9:\"link_path\";s:39:\"admin/people/permissions/roles/delete/%\";s:11:\"router_path\";s:39:\"admin/people/permissions/roles/delete/%\";s:10:\"link_title\";s:11:\"Delete role\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"117\";s:2:\"p5\";s:3:\"162\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:5;s:14:\"user_role_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"user_role_edit_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:56:\"a:2:{i:0;s:30:\"user_admin_role_delete_confirm\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:39:\"admin/people/permissions/roles/delete/%\";s:5:\"title\";s:11:\"Delete role\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:167;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"167\";s:4:\"plid\";s:3:\"117\";s:9:\"link_path\";s:37:\"admin/people/permissions/roles/edit/%\";s:11:\"router_path\";s:37:\"admin/people/permissions/roles/edit/%\";s:10:\"link_title\";s:9:\"Edit role\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"117\";s:2:\"p5\";s:3:\"167\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:5;s:14:\"user_role_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"user_role_edit_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:41:\"a:2:{i:0;s:15:\"user_admin_role\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:37:\"admin/people/permissions/roles/edit/%\";s:5:\"title\";s:9:\"Edit role\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}}}i:19;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"19\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:13:\"admin/reports\";s:11:\"router_path\";s:13:\"admin/reports\";s:10:\"link_title\";s:7:\"Reports\";s:7:\"options\";s:84:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"View reports, updates, and errors.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"5\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"19\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"access site reports\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:13:\"admin/reports\";s:5:\"title\";s:7:\"Reports\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:34:\"View reports, updates, and errors.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:8:{i:42;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"42\";s:4:\"plid\";s:2:\"19\";s:9:\"link_path\";s:20:\"admin/reports/fields\";s:11:\"router_path\";s:20:\"admin/reports/fields\";s:10:\"link_title\";s:10:\"Field list\";s:7:\"options\";s:89:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:39:\"Overview of fields on all entity types.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"19\";s:2:\"p3\";s:2:\"42\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:20:\"field_ui_fields_list\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:20:\"admin/reports/fields\";s:5:\"title\";s:10:\"Field list\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:39:\"Overview of fields on all entity types.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:343;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"343\";s:4:\"plid\";s:2:\"42\";s:9:\"link_path\";s:25:\"admin/reports/fields/list\";s:11:\"router_path\";s:25:\"admin/reports/fields/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"19\";s:2:\"p3\";s:2:\"42\";s:2:\"p4\";s:3:\"343\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:20:\"field_ui_fields_list\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:20:\"admin/reports/fields\";s:8:\"tab_root\";s:20:\"admin/reports/fields\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:344;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"344\";s:4:\"plid\";s:2:\"42\";s:9:\"link_path\";s:33:\"admin/reports/fields/views-fields\";s:11:\"router_path\";s:33:\"admin/reports/fields/views-fields\";s:10:\"link_title\";s:13:\"Used in views\";s:7:\"options\";s:87:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"Overview of fields used in all views.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"19\";s:2:\"p3\";s:2:\"42\";s:2:\"p4\";s:3:\"344\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:19:\"views_ui_field_list\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:20:\"admin/reports/fields\";s:8:\"tab_root\";s:20:\"admin/reports/fields\";s:5:\"title\";s:13:\"Used in views\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:37:\"Overview of fields used in all views.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:50;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"50\";s:4:\"plid\";s:2:\"19\";s:9:\"link_path\";s:19:\"admin/reports/dblog\";s:11:\"router_path\";s:19:\"admin/reports/dblog\";s:10:\"link_title\";s:19:\"Recent log messages\";s:7:\"options\";s:93:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"View events that have recently been logged.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-1\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"19\";s:2:\"p3\";s:2:\"50\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"access site reports\";}\";s:13:\"page_callback\";s:14:\"dblog_overview\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"admin/reports/dblog\";s:5:\"title\";s:19:\"Recent log messages\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:43:\"View events that have recently been logged.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:55;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"55\";s:4:\"plid\";s:2:\"19\";s:9:\"link_path\";s:20:\"admin/reports/status\";s:11:\"router_path\";s:20:\"admin/reports/status\";s:10:\"link_title\";s:13:\"Status report\";s:7:\"options\";s:124:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:74:\"Get a status report about your site\'s operation and any detected problems.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-60\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"19\";s:2:\"p3\";s:2:\"55\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:13:\"system_status\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:20:\"admin/reports/status\";s:5:\"title\";s:13:\"Status report\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:74:\"Get a status report about your site\'s operation and any detected problems.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:58;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"58\";s:4:\"plid\";s:2:\"19\";s:9:\"link_path\";s:27:\"admin/reports/access-denied\";s:11:\"router_path\";s:27:\"admin/reports/access-denied\";s:10:\"link_title\";s:26:\"Top \'access denied\' errors\";s:7:\"options\";s:85:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:35:\"View \'access denied\' errors (403s).\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"19\";s:2:\"p3\";s:2:\"58\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"access site reports\";}\";s:13:\"page_callback\";s:9:\"dblog_top\";s:14:\"page_arguments\";s:31:\"a:1:{i:0;s:13:\"access denied\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:27:\"admin/reports/access-denied\";s:5:\"title\";s:26:\"Top \'access denied\' errors\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:35:\"View \'access denied\' errors (403s).\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:59;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"59\";s:4:\"plid\";s:2:\"19\";s:9:\"link_path\";s:28:\"admin/reports/page-not-found\";s:11:\"router_path\";s:28:\"admin/reports/page-not-found\";s:10:\"link_title\";s:27:\"Top \'page not found\' errors\";s:7:\"options\";s:86:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:36:\"View \'page not found\' errors (404s).\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"19\";s:2:\"p3\";s:2:\"59\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"access site reports\";}\";s:13:\"page_callback\";s:9:\"dblog_top\";s:14:\"page_arguments\";s:32:\"a:1:{i:0;s:14:\"page not found\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:28:\"admin/reports/page-not-found\";s:5:\"title\";s:27:\"Top \'page not found\' errors\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:36:\"View \'page not found\' errors (404s).\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:99;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"99\";s:4:\"plid\";s:2:\"19\";s:9:\"link_path\";s:21:\"admin/reports/event/%\";s:11:\"router_path\";s:21:\"admin/reports/event/%\";s:10:\"link_title\";s:7:\"Details\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"19\";s:2:\"p3\";s:2:\"99\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:12:\"a:1:{i:3;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"access site reports\";}\";s:13:\"page_callback\";s:11:\"dblog_event\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:3;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/reports/event/%\";s:5:\"title\";s:7:\"Details\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:192;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"192\";s:4:\"plid\";s:2:\"19\";s:9:\"link_path\";s:20:\"admin/reports/search\";s:11:\"router_path\";s:20:\"admin/reports/search\";s:10:\"link_title\";s:18:\"Top search phrases\";s:7:\"options\";s:83:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"View most popular search phrases.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"19\";s:2:\"p3\";s:3:\"192\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"access site reports\";}\";s:13:\"page_callback\";s:9:\"dblog_top\";s:14:\"page_arguments\";s:23:\"a:1:{i:0;s:6:\"search\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:20:\"admin/reports/search\";s:5:\"title\";s:18:\"Top search phrases\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:33:\"View most popular search phrases.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:337;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"337\";s:4:\"plid\";s:2:\"19\";s:9:\"link_path\";s:27:\"admin/reports/views-plugins\";s:11:\"router_path\";s:27:\"admin/reports/views-plugins\";s:10:\"link_title\";s:13:\"Views plugins\";s:7:\"options\";s:88:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Overview of plugins used in all views.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"19\";s:2:\"p3\";s:3:\"337\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:20:\"views_ui_plugin_list\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:27:\"admin/reports/views-plugins\";s:5:\"title\";s:13:\"Views plugins\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:38:\"Overview of plugins used in all views.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:21;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"21\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:15:\"admin/structure\";s:11:\"router_path\";s:15:\"admin/structure\";s:10:\"link_title\";s:9:\"Structure\";s:7:\"options\";s:95:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Administer blocks, content types, menus, etc.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-8\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/structure\";s:5:\"title\";s:9:\"Structure\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:45:\"Administer blocks, content types, menus, etc.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:9:{i:30;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"30\";s:4:\"plid\";s:2:\"21\";s:9:\"link_path\";s:21:\"admin/structure/block\";s:11:\"router_path\";s:21:\"admin/structure/block\";s:10:\"link_title\";s:6:\"Blocks\";s:7:\"options\";s:129:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:79:\"Configure what block content appears in your site\'s sidebars and other regions.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"30\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer blocks\";}\";s:13:\"page_callback\";s:19:\"block_admin_display\";s:14:\"page_arguments\";s:24:\"a:1:{i:0;s:7:\"mercury\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:6:\"Blocks\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:79:\"Configure what block content appears in your site\'s sidebars and other regions.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:7:{i:91;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"91\";s:4:\"plid\";s:2:\"30\";s:9:\"link_path\";s:25:\"admin/structure/block/add\";s:11:\"router_path\";s:25:\"admin/structure/block/add\";s:10:\"link_title\";s:9:\"Add block\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"30\";s:2:\"p4\";s:2:\"91\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer blocks\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:38:\"a:1:{i:0;s:20:\"block_add_block_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/block\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:9:\"Add block\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:131;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"131\";s:4:\"plid\";s:2:\"30\";s:9:\"link_path\";s:33:\"admin/structure/block/list/bartik\";s:11:\"router_path\";s:33:\"admin/structure/block/list/bartik\";s:10:\"link_title\";s:6:\"Bartik\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"30\";s:2:\"p4\";s:3:\"131\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:20:\"_block_themes_access\";s:16:\"access_arguments\";s:2683:\"a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:25:\"themes/bartik/bartik.info\";s:4:\"name\";s:6:\"bartik\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:6:\"Bartik\";s:11:\"description\";s:48:\"A flexible, recolorable theme with many regions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:7:\"regions\";a:20:{s:6:\"header\";s:6:\"Header\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"triptych_first\";s:14:\"Triptych first\";s:15:\"triptych_middle\";s:15:\"Triptych middle\";s:13:\"triptych_last\";s:13:\"Triptych last\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"0\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:28:\"themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:19:\"block_admin_display\";s:14:\"page_arguments\";s:23:\"a:1:{i:0;s:6:\"bartik\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/block\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:6:\"Bartik\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:365;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"365\";s:4:\"plid\";s:3:\"131\";s:9:\"link_path\";s:37:\"admin/structure/block/list/bartik/add\";s:11:\"router_path\";s:37:\"admin/structure/block/list/bartik/add\";s:10:\"link_title\";s:9:\"Add block\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"30\";s:2:\"p4\";s:3:\"131\";s:2:\"p5\";s:3:\"365\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer blocks\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:38:\"a:1:{i:0;s:20:\"block_add_block_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:33:\"admin/structure/block/list/bartik\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:9:\"Add block\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:137;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"137\";s:4:\"plid\";s:2:\"30\";s:9:\"link_path\";s:34:\"admin/structure/block/list/garland\";s:11:\"router_path\";s:34:\"admin/structure/block/list/garland\";s:10:\"link_title\";s:7:\"Garland\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"30\";s:2:\"p4\";s:3:\"137\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:20:\"_block_themes_access\";s:16:\"access_arguments\";s:2105:\"a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:27:\"themes/garland/garland.info\";s:4:\"name\";s:7:\"garland\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:7:\"Garland\";s:11:\"description\";s:111:\"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:8:\"settings\";a:1:{s:13:\"garland_width\";s:5:\"fluid\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:29:\"themes/garland/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:19:\"block_admin_display\";s:14:\"page_arguments\";s:24:\"a:1:{i:0;s:7:\"garland\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/block\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:7:\"Garland\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:149;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"149\";s:4:\"plid\";s:3:\"137\";s:9:\"link_path\";s:38:\"admin/structure/block/list/garland/add\";s:11:\"router_path\";s:38:\"admin/structure/block/list/garland/add\";s:10:\"link_title\";s:9:\"Add block\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"30\";s:2:\"p4\";s:3:\"137\";s:2:\"p5\";s:3:\"149\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer blocks\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:38:\"a:1:{i:0;s:20:\"block_add_block_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:34:\"admin/structure/block/list/garland\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:9:\"Add block\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:143;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"143\";s:4:\"plid\";s:2:\"30\";s:9:\"link_path\";s:32:\"admin/structure/block/list/seven\";s:11:\"router_path\";s:32:\"admin/structure/block/list/seven\";s:10:\"link_title\";s:5:\"Seven\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"30\";s:2:\"p4\";s:3:\"143\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:20:\"_block_themes_access\";s:16:\"access_arguments\";s:1905:\"a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/seven/seven.info\";s:4:\"name\";s:5:\"seven\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:5:\"Seven\";s:11:\"description\";s:65:\"A simple one-column, tableless, fluid width administration theme.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"1\";}s:7:\"regions\";a:8:{s:7:\"content\";s:7:\"Content\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:19:\"block_admin_display\";s:14:\"page_arguments\";s:22:\"a:1:{i:0;s:5:\"seven\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/block\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:5:\"Seven\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:150;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"150\";s:4:\"plid\";s:3:\"143\";s:9:\"link_path\";s:36:\"admin/structure/block/list/seven/add\";s:11:\"router_path\";s:36:\"admin/structure/block/list/seven/add\";s:10:\"link_title\";s:9:\"Add block\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"30\";s:2:\"p4\";s:3:\"143\";s:2:\"p5\";s:3:\"150\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer blocks\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:38:\"a:1:{i:0;s:20:\"block_add_block_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:32:\"admin/structure/block/list/seven\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:9:\"Add block\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:144;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"144\";s:4:\"plid\";s:2:\"30\";s:9:\"link_path\";s:32:\"admin/structure/block/list/stark\";s:11:\"router_path\";s:32:\"admin/structure/block/list/stark\";s:10:\"link_title\";s:5:\"Stark\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"30\";s:2:\"p4\";s:3:\"144\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:20:\"_block_themes_access\";s:16:\"access_arguments\";s:2008:\"a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/stark/stark.info\";s:4:\"name\";s:5:\"stark\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:17:{s:4:\"name\";s:5:\"Stark\";s:11:\"description\";s:208:\"This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/stark/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:19:\"block_admin_display\";s:14:\"page_arguments\";s:22:\"a:1:{i:0;s:5:\"stark\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/block\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:5:\"Stark\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:151;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"151\";s:4:\"plid\";s:3:\"144\";s:9:\"link_path\";s:36:\"admin/structure/block/list/stark/add\";s:11:\"router_path\";s:36:\"admin/structure/block/list/stark/add\";s:10:\"link_title\";s:9:\"Add block\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"30\";s:2:\"p4\";s:3:\"144\";s:2:\"p5\";s:3:\"151\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer blocks\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:38:\"a:1:{i:0;s:20:\"block_add_block_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:32:\"admin/structure/block/list/stark\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:9:\"Add block\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:155;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"155\";s:4:\"plid\";s:2:\"30\";s:9:\"link_path\";s:32:\"admin/structure/block/manage/%/%\";s:11:\"router_path\";s:32:\"admin/structure/block/manage/%/%\";s:10:\"link_title\";s:15:\"Configure block\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"30\";s:2:\"p4\";s:3:\"155\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:18:\"a:2:{i:4;N;i:5;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer blocks\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:55:\"a:3:{i:0;s:21:\"block_admin_configure\";i:1;i:4;i:2;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:32:\"admin/structure/block/manage/%/%\";s:5:\"title\";s:15:\"Configure block\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:175;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"175\";s:4:\"plid\";s:3:\"155\";s:9:\"link_path\";s:42:\"admin/structure/block/manage/%/%/configure\";s:11:\"router_path\";s:42:\"admin/structure/block/manage/%/%/configure\";s:10:\"link_title\";s:15:\"Configure block\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"30\";s:2:\"p4\";s:3:\"155\";s:2:\"p5\";s:3:\"175\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:18:\"a:2:{i:4;N;i:5;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer blocks\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:55:\"a:3:{i:0;s:21:\"block_admin_configure\";i:1;i:4;i:2;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:32:\"admin/structure/block/manage/%/%\";s:8:\"tab_root\";s:32:\"admin/structure/block/manage/%/%\";s:5:\"title\";s:15:\"Configure block\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:176;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"176\";s:4:\"plid\";s:3:\"155\";s:9:\"link_path\";s:39:\"admin/structure/block/manage/%/%/delete\";s:11:\"router_path\";s:39:\"admin/structure/block/manage/%/%/delete\";s:10:\"link_title\";s:12:\"Delete block\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"30\";s:2:\"p4\";s:3:\"155\";s:2:\"p5\";s:3:\"176\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:18:\"a:2:{i:4;N;i:5;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer blocks\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:59:\"a:3:{i:0;s:25:\"block_custom_block_delete\";i:1;i:4;i:2;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:32:\"admin/structure/block/manage/%/%\";s:8:\"tab_root\";s:32:\"admin/structure/block/manage/%/%\";s:5:\"title\";s:12:\"Delete block\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:363;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"363\";s:4:\"plid\";s:2:\"30\";s:9:\"link_path\";s:34:\"admin/structure/block/list/mercury\";s:11:\"router_path\";s:34:\"admin/structure/block/list/mercury\";s:10:\"link_title\";s:7:\"Mercury\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"30\";s:2:\"p4\";s:3:\"363\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:20:\"_block_themes_access\";s:16:\"access_arguments\";s:4026:\"a:1:{i:0;O:8:\"stdClass\":13:{s:8:\"filename\";s:37:\"sites/all/themes/mercury/mercury.info\";s:4:\"name\";s:7:\"mercury\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:7:\"Mercury\";s:11:\"description\";s:26:\"Mercury theme for Drupal 7\";s:10:\"screenshot\";s:46:\"sites/all/themes/mercury/images/screenshot.gif\";s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:7:\"mercury\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:14:{s:8:\"page_top\";s:8:\"Page top\";s:16:\"header_top_right\";s:16:\"Header top right\";s:6:\"header\";s:6:\"Header\";s:9:\"highlight\";s:9:\"Highlight\";s:4:\"help\";s:4:\"Help\";s:11:\"title_right\";s:11:\"Title Right\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"sidebar_second\";s:14:\"Second sidebar\";s:6:\"footer\";s:6:\"Footer\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:6:\"search\";i:6;s:7:\"favicon\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:11:\"stylesheets\";a:2:{s:3:\"all\";a:5:{s:15:\"css/default.css\";s:40:\"sites/all/themes/mercury/css/default.css\";s:14:\"css/layout.css\";s:39:\"sites/all/themes/mercury/css/layout.css\";s:13:\"css/style.css\";s:38:\"sites/all/themes/mercury/css/style.css\";s:17:\"css/node-view.css\";s:42:\"sites/all/themes/mercury/css/node-view.css\";s:17:\"css/analytics.css\";s:42:\"sites/all/themes/mercury/css/analytics.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:38:\"sites/all/themes/mercury/css/print.css\";}}s:7:\"scripts\";a:6:{s:19:\"js/jquery-ui.min.js\";s:44:\"sites/all/themes/mercury/js/jquery-ui.min.js\";s:29:\"js/jquery.mCustomScrollbar.js\";s:54:\"sites/all/themes/mercury/js/jquery.mCustomScrollbar.js\";s:27:\"js/jquery.mousewheel.min.js\";s:52:\"sites/all/themes/mercury/js/jquery.mousewheel.min.js\";s:24:\"js/jquery.tablesorter.js\";s:49:\"sites/all/themes/mercury/js/jquery.tablesorter.js\";s:32:\"js/jquery.tablesorter.widgets.js\";s:57:\"sites/all/themes/mercury/js/jquery.tablesorter.widgets.js\";s:14:\"js/function.js\";s:39:\"sites/all/themes/mercury/js/function.js\";}s:7:\"compass\";a:3:{s:6:\"status\";s:1:\"1\";s:8:\"sass_dir\";s:4:\"sass\";s:7:\"css_dir\";s:3:\"css\";}s:8:\"settings\";a:4:{s:12:\"mercury_tabs\";s:1:\"1\";s:28:\"mercury_breadcrumb_separator\";s:2:\"»\";s:14:\"wireframe_mode\";s:1:\"0\";s:14:\"clear_registry\";s:1:\"0\";}s:7:\"version\";s:7:\"7.x-2.1\";s:9:\"datestamp\";s:10:\"1334122542\";s:3:\"php\";s:5:\"5.2.4\";s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:5:{s:15:\"css/default.css\";s:40:\"sites/all/themes/mercury/css/default.css\";s:14:\"css/layout.css\";s:39:\"sites/all/themes/mercury/css/layout.css\";s:13:\"css/style.css\";s:38:\"sites/all/themes/mercury/css/style.css\";s:17:\"css/node-view.css\";s:42:\"sites/all/themes/mercury/css/node-view.css\";s:17:\"css/analytics.css\";s:42:\"sites/all/themes/mercury/css/analytics.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:38:\"sites/all/themes/mercury/css/print.css\";}}s:7:\"scripts\";a:6:{s:19:\"js/jquery-ui.min.js\";s:44:\"sites/all/themes/mercury/js/jquery-ui.min.js\";s:29:\"js/jquery.mCustomScrollbar.js\";s:54:\"sites/all/themes/mercury/js/jquery.mCustomScrollbar.js\";s:27:\"js/jquery.mousewheel.min.js\";s:52:\"sites/all/themes/mercury/js/jquery.mousewheel.min.js\";s:24:\"js/jquery.tablesorter.js\";s:49:\"sites/all/themes/mercury/js/jquery.tablesorter.js\";s:32:\"js/jquery.tablesorter.widgets.js\";s:57:\"sites/all/themes/mercury/js/jquery.tablesorter.widgets.js\";s:14:\"js/function.js\";s:39:\"sites/all/themes/mercury/js/function.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:19:\"block_admin_display\";s:14:\"page_arguments\";s:24:\"a:1:{i:0;s:7:\"mercury\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/block\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:7:\"Mercury\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:36;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"36\";s:4:\"plid\";s:2:\"21\";s:9:\"link_path\";s:21:\"admin/structure/types\";s:11:\"router_path\";s:21:\"admin/structure/types\";s:10:\"link_title\";s:13:\"Content types\";s:7:\"options\";s:142:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:92:\"Manage content types, including default status, front page promotion, comment settings, etc.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:19:\"node_overview_types\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/structure/types\";s:5:\"title\";s:13:\"Content types\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:92:\"Manage content types, including default status, front page promotion, comment settings, etc.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:92;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"92\";s:4:\"plid\";s:2:\"36\";s:9:\"link_path\";s:25:\"admin/structure/types/add\";s:11:\"router_path\";s:25:\"admin/structure/types/add\";s:10:\"link_title\";s:16:\"Add content type\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:2:\"92\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:32:\"a:1:{i:0;s:14:\"node_type_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/types\";s:8:\"tab_root\";s:21:\"admin/structure/types\";s:5:\"title\";s:16:\"Add content type\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:106;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"106\";s:4:\"plid\";s:2:\"36\";s:9:\"link_path\";s:26:\"admin/structure/types/list\";s:11:\"router_path\";s:26:\"admin/structure/types/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"106\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:19:\"node_overview_types\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/types\";s:8:\"tab_root\";s:21:\"admin/structure/types\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:135;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"135\";s:4:\"plid\";s:2:\"36\";s:9:\"link_path\";s:30:\"admin/structure/types/manage/%\";s:11:\"router_path\";s:30:\"admin/structure/types/manage/%\";s:10:\"link_title\";s:17:\"Edit content type\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:40:\"a:2:{i:0;s:14:\"node_type_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:17:\"Edit content type\";s:14:\"title_callback\";s:20:\"node_type_page_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:6:{i:157;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"157\";s:4:\"plid\";s:3:\"135\";s:9:\"link_path\";s:37:\"admin/structure/types/manage/%/delete\";s:11:\"router_path\";s:37:\"admin/structure/types/manage/%/delete\";s:10:\"link_title\";s:6:\"Delete\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"157\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"node_type_delete_confirm\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:37:\"admin/structure/types/manage/%/delete\";s:5:\"title\";s:6:\"Delete\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:164;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"164\";s:4:\"plid\";s:3:\"135\";s:9:\"link_path\";s:35:\"admin/structure/types/manage/%/edit\";s:11:\"router_path\";s:35:\"admin/structure/types/manage/%/edit\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"164\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:40:\"a:2:{i:0;s:14:\"node_type_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/structure/types/manage/%\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:173;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"173\";s:4:\"plid\";s:3:\"135\";s:9:\"link_path\";s:46:\"admin/structure/types/manage/%/comment/display\";s:11:\"router_path\";s:46:\"admin/structure/types/manage/%/comment/display\";s:10:\"link_title\";s:15:\"Comment display\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"4\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"173\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:40:\"a:1:{i:4;s:22:\"comment_node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:92:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:7:\"default\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/structure/types/manage/%\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:15:\"Comment display\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:812;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"812\";s:4:\"plid\";s:3:\"173\";s:9:\"link_path\";s:54:\"admin/structure/types/manage/%/comment/display/default\";s:11:\"router_path\";s:54:\"admin/structure/types/manage/%/comment/display/default\";s:10:\"link_title\";s:7:\"Default\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"173\";s:2:\"p6\";s:3:\"812\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:40:\"a:1:{i:4;s:22:\"comment_node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:109:\"a:5:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:7:\"default\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:92:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:7:\"default\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:46:\"admin/structure/types/manage/%/comment/display\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:7:\"Default\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:813;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"813\";s:4:\"plid\";s:3:\"173\";s:9:\"link_path\";s:51:\"admin/structure/types/manage/%/comment/display/full\";s:11:\"router_path\";s:51:\"admin/structure/types/manage/%/comment/display/full\";s:10:\"link_title\";s:12:\"Full comment\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"173\";s:2:\"p6\";s:3:\"813\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:40:\"a:1:{i:4;s:22:\"comment_node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:106:\"a:5:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:4:\"full\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:89:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:4:\"full\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:46:\"admin/structure/types/manage/%/comment/display\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:12:\"Full comment\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:814;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"814\";s:4:\"plid\";s:3:\"173\";s:9:\"link_path\";s:52:\"admin/structure/types/manage/%/comment/display/token\";s:11:\"router_path\";s:52:\"admin/structure/types/manage/%/comment/display/token\";s:10:\"link_title\";s:6:\"Tokens\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"173\";s:2:\"p6\";s:3:\"814\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:40:\"a:1:{i:4;s:22:\"comment_node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:107:\"a:5:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:5:\"token\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:90:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:5:\"token\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:46:\"admin/structure/types/manage/%/comment/display\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:6:\"Tokens\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:174;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"174\";s:4:\"plid\";s:3:\"135\";s:9:\"link_path\";s:45:\"admin/structure/types/manage/%/comment/fields\";s:11:\"router_path\";s:45:\"admin/structure/types/manage/%/comment/fields\";s:10:\"link_title\";s:14:\"Comment fields\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"3\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"174\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:40:\"a:1:{i:4;s:22:\"comment_node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:72:\"a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:7:\"comment\";i:2;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/structure/types/manage/%\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:14:\"Comment fields\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:815;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"815\";s:4:\"plid\";s:3:\"174\";s:9:\"link_path\";s:47:\"admin/structure/types/manage/%/comment/fields/%\";s:11:\"router_path\";s:47:\"admin/structure/types/manage/%/comment/fields/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"174\";s:2:\"p6\";s:3:\"815\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:200:\"a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:47:\"admin/structure/types/manage/%/comment/fields/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:19:\"field_ui_menu_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:7;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:820;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"820\";s:4:\"plid\";s:3:\"815\";s:9:\"link_path\";s:54:\"admin/structure/types/manage/%/comment/fields/%/delete\";s:11:\"router_path\";s:54:\"admin/structure/types/manage/%/comment/fields/%/delete\";s:10:\"link_title\";s:6:\"Delete\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"174\";s:2:\"p6\";s:3:\"815\";s:2:\"p7\";s:3:\"820\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:200:\"a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:52:\"a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:7;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:47:\"admin/structure/types/manage/%/comment/fields/%\";s:8:\"tab_root\";s:47:\"admin/structure/types/manage/%/comment/fields/%\";s:5:\"title\";s:6:\"Delete\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:821;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"821\";s:4:\"plid\";s:3:\"815\";s:9:\"link_path\";s:52:\"admin/structure/types/manage/%/comment/fields/%/edit\";s:11:\"router_path\";s:52:\"admin/structure/types/manage/%/comment/fields/%/edit\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"174\";s:2:\"p6\";s:3:\"815\";s:2:\"p7\";s:3:\"821\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:200:\"a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:47:\"admin/structure/types/manage/%/comment/fields/%\";s:8:\"tab_root\";s:47:\"admin/structure/types/manage/%/comment/fields/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:822;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"822\";s:4:\"plid\";s:3:\"815\";s:9:\"link_path\";s:62:\"admin/structure/types/manage/%/comment/fields/%/field-settings\";s:11:\"router_path\";s:62:\"admin/structure/types/manage/%/comment/fields/%/field-settings\";s:10:\"link_title\";s:14:\"Field settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"174\";s:2:\"p6\";s:3:\"815\";s:2:\"p7\";s:3:\"822\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:200:\"a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:54:\"a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:7;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:47:\"admin/structure/types/manage/%/comment/fields/%\";s:8:\"tab_root\";s:47:\"admin/structure/types/manage/%/comment/fields/%\";s:5:\"title\";s:14:\"Field settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:823;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"823\";s:4:\"plid\";s:3:\"815\";s:9:\"link_path\";s:59:\"admin/structure/types/manage/%/comment/fields/%/widget-type\";s:11:\"router_path\";s:59:\"admin/structure/types/manage/%/comment/fields/%/widget-type\";s:10:\"link_title\";s:11:\"Widget type\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"174\";s:2:\"p6\";s:3:\"815\";s:2:\"p7\";s:3:\"823\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:200:\"a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:51:\"a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:7;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:47:\"admin/structure/types/manage/%/comment/fields/%\";s:8:\"tab_root\";s:47:\"admin/structure/types/manage/%/comment/fields/%\";s:5:\"title\";s:11:\"Widget type\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}i:788;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"788\";s:4:\"plid\";s:3:\"135\";s:9:\"link_path\";s:38:\"admin/structure/types/manage/%/display\";s:11:\"router_path\";s:38:\"admin/structure/types/manage/%/display\";s:10:\"link_title\";s:14:\"Manage display\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"2\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"788\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:89:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:7:\"default\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/structure/types/manage/%\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:14:\"Manage display\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:7:{i:796;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"796\";s:4:\"plid\";s:3:\"788\";s:9:\"link_path\";s:46:\"admin/structure/types/manage/%/display/default\";s:11:\"router_path\";s:46:\"admin/structure/types/manage/%/display/default\";s:10:\"link_title\";s:7:\"Default\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"788\";s:2:\"p6\";s:3:\"796\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:106:\"a:5:{i:0;s:4:\"node\";i:1;i:4;i:2;s:7:\"default\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:89:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:7:\"default\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/structure/types/manage/%/display\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:7:\"Default\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:797;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"797\";s:4:\"plid\";s:3:\"788\";s:9:\"link_path\";s:42:\"admin/structure/types/manage/%/display/rss\";s:11:\"router_path\";s:42:\"admin/structure/types/manage/%/display/rss\";s:10:\"link_title\";s:3:\"RSS\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"2\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"788\";s:2:\"p6\";s:3:\"797\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:102:\"a:5:{i:0;s:4:\"node\";i:1;i:4;i:2;s:3:\"rss\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:85:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:3:\"rss\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/structure/types/manage/%/display\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:3:\"RSS\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:798;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"798\";s:4:\"plid\";s:3:\"788\";s:9:\"link_path\";s:51:\"admin/structure/types/manage/%/display/search_index\";s:11:\"router_path\";s:51:\"admin/structure/types/manage/%/display/search_index\";s:10:\"link_title\";s:12:\"Search index\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"3\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"788\";s:2:\"p6\";s:3:\"798\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:112:\"a:5:{i:0;s:4:\"node\";i:1;i:4;i:2;s:12:\"search_index\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:95:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:12:\"search_index\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/structure/types/manage/%/display\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:12:\"Search index\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:799;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"799\";s:4:\"plid\";s:3:\"788\";s:9:\"link_path\";s:52:\"admin/structure/types/manage/%/display/search_result\";s:11:\"router_path\";s:52:\"admin/structure/types/manage/%/display/search_result\";s:10:\"link_title\";s:13:\"Search result\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"4\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"788\";s:2:\"p6\";s:3:\"799\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:113:\"a:5:{i:0;s:4:\"node\";i:1;i:4;i:2;s:13:\"search_result\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:96:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:13:\"search_result\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/structure/types/manage/%/display\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:13:\"Search result\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:800;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"800\";s:4:\"plid\";s:3:\"788\";s:9:\"link_path\";s:45:\"admin/structure/types/manage/%/display/teaser\";s:11:\"router_path\";s:45:\"admin/structure/types/manage/%/display/teaser\";s:10:\"link_title\";s:6:\"Teaser\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"788\";s:2:\"p6\";s:3:\"800\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:105:\"a:5:{i:0;s:4:\"node\";i:1;i:4;i:2;s:6:\"teaser\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:88:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:6:\"teaser\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/structure/types/manage/%/display\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:6:\"Teaser\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:801;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"801\";s:4:\"plid\";s:3:\"788\";s:9:\"link_path\";s:43:\"admin/structure/types/manage/%/display/full\";s:11:\"router_path\";s:43:\"admin/structure/types/manage/%/display/full\";s:10:\"link_title\";s:12:\"Full content\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"788\";s:2:\"p6\";s:3:\"801\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:103:\"a:5:{i:0;s:4:\"node\";i:1;i:4;i:2;s:4:\"full\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:86:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:4:\"full\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/structure/types/manage/%/display\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:12:\"Full content\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:802;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"802\";s:4:\"plid\";s:3:\"788\";s:9:\"link_path\";s:44:\"admin/structure/types/manage/%/display/token\";s:11:\"router_path\";s:44:\"admin/structure/types/manage/%/display/token\";s:10:\"link_title\";s:6:\"Tokens\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"5\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"788\";s:2:\"p6\";s:3:\"802\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:104:\"a:5:{i:0;s:4:\"node\";i:1;i:4;i:2;s:5:\"token\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:87:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:5:\"token\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/structure/types/manage/%/display\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:6:\"Tokens\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:789;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"789\";s:4:\"plid\";s:3:\"135\";s:9:\"link_path\";s:37:\"admin/structure/types/manage/%/fields\";s:11:\"router_path\";s:37:\"admin/structure/types/manage/%/fields\";s:10:\"link_title\";s:13:\"Manage fields\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"789\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:69:\"a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:4:\"node\";i:2;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/structure/types/manage/%\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:13:\"Manage fields\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:803;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"803\";s:4:\"plid\";s:3:\"789\";s:9:\"link_path\";s:39:\"admin/structure/types/manage/%/fields/%\";s:11:\"router_path\";s:39:\"admin/structure/types/manage/%/fields/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"789\";s:2:\"p6\";s:3:\"803\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:186:\"a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:39:\"admin/structure/types/manage/%/fields/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:19:\"field_ui_menu_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:6;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:816;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"816\";s:4:\"plid\";s:3:\"803\";s:9:\"link_path\";s:46:\"admin/structure/types/manage/%/fields/%/delete\";s:11:\"router_path\";s:46:\"admin/structure/types/manage/%/fields/%/delete\";s:10:\"link_title\";s:6:\"Delete\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"789\";s:2:\"p6\";s:3:\"803\";s:2:\"p7\";s:3:\"816\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:186:\"a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:52:\"a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:6;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:39:\"admin/structure/types/manage/%/fields/%\";s:8:\"tab_root\";s:39:\"admin/structure/types/manage/%/fields/%\";s:5:\"title\";s:6:\"Delete\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:817;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"817\";s:4:\"plid\";s:3:\"803\";s:9:\"link_path\";s:44:\"admin/structure/types/manage/%/fields/%/edit\";s:11:\"router_path\";s:44:\"admin/structure/types/manage/%/fields/%/edit\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"789\";s:2:\"p6\";s:3:\"803\";s:2:\"p7\";s:3:\"817\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:186:\"a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:39:\"admin/structure/types/manage/%/fields/%\";s:8:\"tab_root\";s:39:\"admin/structure/types/manage/%/fields/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:818;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"818\";s:4:\"plid\";s:3:\"803\";s:9:\"link_path\";s:54:\"admin/structure/types/manage/%/fields/%/field-settings\";s:11:\"router_path\";s:54:\"admin/structure/types/manage/%/fields/%/field-settings\";s:10:\"link_title\";s:14:\"Field settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"789\";s:2:\"p6\";s:3:\"803\";s:2:\"p7\";s:3:\"818\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:186:\"a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:54:\"a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:6;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:39:\"admin/structure/types/manage/%/fields/%\";s:8:\"tab_root\";s:39:\"admin/structure/types/manage/%/fields/%\";s:5:\"title\";s:14:\"Field settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:819;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"819\";s:4:\"plid\";s:3:\"803\";s:9:\"link_path\";s:51:\"admin/structure/types/manage/%/fields/%/widget-type\";s:11:\"router_path\";s:51:\"admin/structure/types/manage/%/fields/%/widget-type\";s:10:\"link_title\";s:11:\"Widget type\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"36\";s:2:\"p4\";s:3:\"135\";s:2:\"p5\";s:3:\"789\";s:2:\"p6\";s:3:\"803\";s:2:\"p7\";s:3:\"819\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:186:\"a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:51:\"a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:6;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:39:\"admin/structure/types/manage/%/fields/%\";s:8:\"tab_root\";s:39:\"admin/structure/types/manage/%/fields/%\";s:5:\"title\";s:11:\"Widget type\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}}}}}i:47;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"47\";s:4:\"plid\";s:2:\"21\";s:9:\"link_path\";s:20:\"admin/structure/menu\";s:11:\"router_path\";s:20:\"admin/structure/menu\";s:10:\"link_title\";s:5:\"Menus\";s:7:\"options\";s:136:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:86:\"Add new menus to your site, edit existing menus, and rename and reorganize menu links.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:18:\"menu_overview_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:20:\"admin/structure/menu\";s:5:\"title\";s:5:\"Menus\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:86:\"Add new menus to your site, edit existing menus, and rename and reorganize menu links.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:15:{i:93;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"93\";s:4:\"plid\";s:2:\"47\";s:9:\"link_path\";s:24:\"admin/structure/menu/add\";s:11:\"router_path\";s:24:\"admin/structure/menu/add\";s:10:\"link_title\";s:8:\"Add menu\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:2:\"93\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:46:\"a:2:{i:0;s:14:\"menu_edit_menu\";i:1;s:3:\"add\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:20:\"admin/structure/menu\";s:8:\"tab_root\";s:20:\"admin/structure/menu\";s:5:\"title\";s:8:\"Add menu\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:109;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"109\";s:4:\"plid\";s:2:\"47\";s:9:\"link_path\";s:25:\"admin/structure/menu/list\";s:11:\"router_path\";s:25:\"admin/structure/menu/list\";s:10:\"link_title\";s:10:\"List menus\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:3:\"109\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:18:\"menu_overview_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:20:\"admin/structure/menu\";s:8:\"tab_root\";s:20:\"admin/structure/menu\";s:5:\"title\";s:10:\"List menus\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:118;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"118\";s:4:\"plid\";s:2:\"47\";s:9:\"link_path\";s:29:\"admin/structure/menu/settings\";s:11:\"router_path\";s:29:\"admin/structure/menu/settings\";s:10:\"link_title\";s:8:\"Settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"5\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:3:\"118\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:32:\"a:1:{i:0;s:14:\"menu_configure\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:20:\"admin/structure/menu\";s:8:\"tab_root\";s:20:\"admin/structure/menu\";s:5:\"title\";s:8:\"Settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:133;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"133\";s:4:\"plid\";s:2:\"47\";s:9:\"link_path\";s:29:\"admin/structure/menu/manage/%\";s:11:\"router_path\";s:29:\"admin/structure/menu/manage/%\";s:10:\"link_title\";s:14:\"Customize menu\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:3:\"133\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:14:\"Customize menu\";s:14:\"title_callback\";s:19:\"menu_overview_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:154;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"154\";s:4:\"plid\";s:3:\"133\";s:9:\"link_path\";s:33:\"admin/structure/menu/manage/%/add\";s:11:\"router_path\";s:33:\"admin/structure/menu/manage/%/add\";s:10:\"link_title\";s:8:\"Add link\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:3:\"133\";s:2:\"p5\";s:3:\"154\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:60:\"a:4:{i:0;s:14:\"menu_edit_item\";i:1;s:3:\"add\";i:2;N;i:3;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:29:\"admin/structure/menu/manage/%\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:8:\"Add link\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:160;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"160\";s:4:\"plid\";s:3:\"133\";s:9:\"link_path\";s:36:\"admin/structure/menu/manage/%/delete\";s:11:\"router_path\";s:36:\"admin/structure/menu/manage/%/delete\";s:10:\"link_title\";s:11:\"Delete menu\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:3:\"133\";s:2:\"p5\";s:3:\"160\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:21:\"menu_delete_menu_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:36:\"admin/structure/menu/manage/%/delete\";s:5:\"title\";s:11:\"Delete menu\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:165;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"165\";s:4:\"plid\";s:3:\"133\";s:9:\"link_path\";s:34:\"admin/structure/menu/manage/%/edit\";s:11:\"router_path\";s:34:\"admin/structure/menu/manage/%/edit\";s:10:\"link_title\";s:9:\"Edit menu\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:3:\"133\";s:2:\"p5\";s:3:\"165\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:55:\"a:3:{i:0;s:14:\"menu_edit_menu\";i:1;s:4:\"edit\";i:2;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:29:\"admin/structure/menu/manage/%\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:9:\"Edit menu\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:169;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"169\";s:4:\"plid\";s:3:\"133\";s:9:\"link_path\";s:34:\"admin/structure/menu/manage/%/list\";s:11:\"router_path\";s:34:\"admin/structure/menu/manage/%/list\";s:10:\"link_title\";s:10:\"List links\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:3:\"133\";s:2:\"p5\";s:3:\"169\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:29:\"admin/structure/menu/manage/%\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:10:\"List links\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:161;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"161\";s:4:\"plid\";s:2:\"47\";s:9:\"link_path\";s:34:\"admin/structure/menu/item/%/delete\";s:11:\"router_path\";s:34:\"admin/structure/menu/item/%/delete\";s:10:\"link_title\";s:16:\"Delete menu link\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:3:\"161\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"menu_link_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:21:\"menu_item_delete_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:34:\"admin/structure/menu/item/%/delete\";s:5:\"title\";s:16:\"Delete menu link\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:166;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"166\";s:4:\"plid\";s:2:\"47\";s:9:\"link_path\";s:32:\"admin/structure/menu/item/%/edit\";s:11:\"router_path\";s:32:\"admin/structure/menu/item/%/edit\";s:10:\"link_title\";s:14:\"Edit menu link\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:3:\"166\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"menu_link_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:61:\"a:4:{i:0;s:14:\"menu_edit_item\";i:1;s:4:\"edit\";i:2;i:4;i:3;N;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:32:\"admin/structure/menu/item/%/edit\";s:5:\"title\";s:14:\"Edit menu link\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:170;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"170\";s:4:\"plid\";s:2:\"47\";s:9:\"link_path\";s:33:\"admin/structure/menu/item/%/reset\";s:11:\"router_path\";s:33:\"admin/structure/menu/item/%/reset\";s:10:\"link_title\";s:15:\"Reset menu link\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:3:\"170\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"menu_link_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:49:\"a:2:{i:0;s:23:\"menu_reset_item_confirm\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:33:\"admin/structure/menu/item/%/reset\";s:5:\"title\";s:15:\"Reset menu link\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:183;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"183\";s:4:\"plid\";s:2:\"47\";s:9:\"link_path\";s:37:\"admin/structure/menu/manage/main-menu\";s:11:\"router_path\";s:29:\"admin/structure/menu/manage/%\";s:10:\"link_title\";s:9:\"Main menu\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:3:\"183\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:14:\"Customize menu\";s:14:\"title_callback\";s:19:\"menu_overview_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:184;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"184\";s:4:\"plid\";s:2:\"47\";s:9:\"link_path\";s:38:\"admin/structure/menu/manage/management\";s:11:\"router_path\";s:29:\"admin/structure/menu/manage/%\";s:10:\"link_title\";s:10:\"Management\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:3:\"184\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:14:\"Customize menu\";s:14:\"title_callback\";s:19:\"menu_overview_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:185;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"185\";s:4:\"plid\";s:2:\"47\";s:9:\"link_path\";s:38:\"admin/structure/menu/manage/navigation\";s:11:\"router_path\";s:29:\"admin/structure/menu/manage/%\";s:10:\"link_title\";s:10:\"Navigation\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:3:\"185\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:14:\"Customize menu\";s:14:\"title_callback\";s:19:\"menu_overview_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:186;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"186\";s:4:\"plid\";s:2:\"47\";s:9:\"link_path\";s:37:\"admin/structure/menu/manage/user-menu\";s:11:\"router_path\";s:29:\"admin/structure/menu/manage/%\";s:10:\"link_title\";s:9:\"User menu\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:3:\"186\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:14:\"Customize menu\";s:14:\"title_callback\";s:19:\"menu_overview_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:408;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"408\";s:4:\"plid\";s:2:\"47\";s:9:\"link_path\";s:51:\"admin/structure/menu/manage/menu-mercury-navigation\";s:11:\"router_path\";s:29:\"admin/structure/menu/manage/%\";s:10:\"link_title\";s:10:\"Navigation\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:3:\"408\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:14:\"Customize menu\";s:14:\"title_callback\";s:19:\"menu_overview_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:414;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"414\";s:4:\"plid\";s:2:\"47\";s:9:\"link_path\";s:46:\"admin/structure/menu/manage/menu-selector-tool\";s:11:\"router_path\";s:29:\"admin/structure/menu/manage/%\";s:10:\"link_title\";s:13:\"Selector Tool\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:3:\"414\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:14:\"Customize menu\";s:14:\"title_callback\";s:19:\"menu_overview_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:418;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"418\";s:4:\"plid\";s:2:\"47\";s:9:\"link_path\";s:49:\"admin/structure/menu/manage/menu-bulk-action-tool\";s:11:\"router_path\";s:29:\"admin/structure/menu/manage/%\";s:10:\"link_title\";s:16:\"Bulk Action Tool\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:3:\"418\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:14:\"Customize menu\";s:14:\"title_callback\";s:19:\"menu_overview_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:499;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"499\";s:4:\"plid\";s:2:\"47\";s:9:\"link_path\";s:39:\"admin/structure/menu/manage/menu-refine\";s:11:\"router_path\";s:29:\"admin/structure/menu/manage/%\";s:10:\"link_title\";s:6:\"Refine\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:3:\"499\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:14:\"Customize menu\";s:14:\"title_callback\";s:19:\"menu_overview_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:57;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"57\";s:4:\"plid\";s:2:\"21\";s:9:\"link_path\";s:24:\"admin/structure/taxonomy\";s:11:\"router_path\";s:24:\"admin/structure/taxonomy\";s:10:\"link_title\";s:8:\"Taxonomy\";s:7:\"options\";s:117:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:67:\"Manage tagging, categorization, and classification of your content.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"57\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:48:\"a:1:{i:0;s:30:\"taxonomy_overview_vocabularies\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:24:\"admin/structure/taxonomy\";s:5:\"title\";s:8:\"Taxonomy\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:67:\"Manage tagging, categorization, and classification of your content.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:94;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"94\";s:4:\"plid\";s:2:\"57\";s:9:\"link_path\";s:28:\"admin/structure/taxonomy/add\";s:11:\"router_path\";s:28:\"admin/structure/taxonomy/add\";s:10:\"link_title\";s:14:\"Add vocabulary\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"57\";s:2:\"p4\";s:2:\"94\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:42:\"a:1:{i:0;s:24:\"taxonomy_form_vocabulary\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/structure/taxonomy\";s:8:\"tab_root\";s:24:\"admin/structure/taxonomy\";s:5:\"title\";s:14:\"Add vocabulary\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:108;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"108\";s:4:\"plid\";s:2:\"57\";s:9:\"link_path\";s:29:\"admin/structure/taxonomy/list\";s:11:\"router_path\";s:29:\"admin/structure/taxonomy/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"57\";s:2:\"p4\";s:3:\"108\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:48:\"a:1:{i:0;s:30:\"taxonomy_overview_vocabularies\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/structure/taxonomy\";s:8:\"tab_root\";s:24:\"admin/structure/taxonomy\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:124;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"124\";s:4:\"plid\";s:2:\"57\";s:9:\"link_path\";s:26:\"admin/structure/taxonomy/%\";s:11:\"router_path\";s:26:\"admin/structure/taxonomy/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"57\";s:2:\"p4\";s:3:\"124\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:55:\"a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:49:\"a:2:{i:0;s:23:\"taxonomy_overview_terms\";i:1;i:3;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:26:\"admin/structure/taxonomy/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:40:\"taxonomy_admin_vocabulary_title_callback\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:3;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:5:{i:129;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"129\";s:4:\"plid\";s:3:\"124\";s:9:\"link_path\";s:30:\"admin/structure/taxonomy/%/add\";s:11:\"router_path\";s:30:\"admin/structure/taxonomy/%/add\";s:10:\"link_title\";s:8:\"Add term\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"57\";s:2:\"p4\";s:3:\"124\";s:2:\"p5\";s:3:\"129\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:55:\"a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:54:\"a:3:{i:0;s:18:\"taxonomy_form_term\";i:1;a:0:{}i:2;i:3;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:26:\"admin/structure/taxonomy/%\";s:8:\"tab_root\";s:26:\"admin/structure/taxonomy/%\";s:5:\"title\";s:8:\"Add term\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:134;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"134\";s:4:\"plid\";s:3:\"124\";s:9:\"link_path\";s:31:\"admin/structure/taxonomy/%/edit\";s:11:\"router_path\";s:31:\"admin/structure/taxonomy/%/edit\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"57\";s:2:\"p4\";s:3:\"124\";s:2:\"p5\";s:3:\"134\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:55:\"a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"taxonomy_form_vocabulary\";i:1;i:3;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:26:\"admin/structure/taxonomy/%\";s:8:\"tab_root\";s:26:\"admin/structure/taxonomy/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:138;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"138\";s:4:\"plid\";s:3:\"124\";s:9:\"link_path\";s:31:\"admin/structure/taxonomy/%/list\";s:11:\"router_path\";s:31:\"admin/structure/taxonomy/%/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-20\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"57\";s:2:\"p4\";s:3:\"124\";s:2:\"p5\";s:3:\"138\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:55:\"a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:49:\"a:2:{i:0;s:23:\"taxonomy_overview_terms\";i:1;i:3;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:26:\"admin/structure/taxonomy/%\";s:8:\"tab_root\";s:26:\"admin/structure/taxonomy/%\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:782;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"782\";s:4:\"plid\";s:3:\"124\";s:9:\"link_path\";s:34:\"admin/structure/taxonomy/%/display\";s:11:\"router_path\";s:34:\"admin/structure/taxonomy/%/display\";s:10:\"link_title\";s:14:\"Manage display\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"2\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"57\";s:2:\"p4\";s:3:\"124\";s:2:\"p5\";s:3:\"782\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:55:\"a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:99:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:7:\"default\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:26:\"admin/structure/taxonomy/%\";s:8:\"tab_root\";s:26:\"admin/structure/taxonomy/%\";s:5:\"title\";s:14:\"Manage display\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:786;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"786\";s:4:\"plid\";s:3:\"782\";s:9:\"link_path\";s:42:\"admin/structure/taxonomy/%/display/default\";s:11:\"router_path\";s:42:\"admin/structure/taxonomy/%/display/default\";s:10:\"link_title\";s:7:\"Default\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"57\";s:2:\"p4\";s:3:\"124\";s:2:\"p5\";s:3:\"782\";s:2:\"p6\";s:3:\"786\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:55:\"a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:111:\"a:5:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:7:\"default\";i:3;s:11:\"user_access\";i:4;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:99:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:7:\"default\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:34:\"admin/structure/taxonomy/%/display\";s:8:\"tab_root\";s:26:\"admin/structure/taxonomy/%\";s:5:\"title\";s:7:\"Default\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:790;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"790\";s:4:\"plid\";s:3:\"782\";s:9:\"link_path\";s:39:\"admin/structure/taxonomy/%/display/full\";s:11:\"router_path\";s:39:\"admin/structure/taxonomy/%/display/full\";s:10:\"link_title\";s:18:\"Taxonomy term page\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"57\";s:2:\"p4\";s:3:\"124\";s:2:\"p5\";s:3:\"782\";s:2:\"p6\";s:3:\"790\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:55:\"a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:108:\"a:5:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:4:\"full\";i:3;s:11:\"user_access\";i:4;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:96:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:4:\"full\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:34:\"admin/structure/taxonomy/%/display\";s:8:\"tab_root\";s:26:\"admin/structure/taxonomy/%\";s:5:\"title\";s:18:\"Taxonomy term page\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:791;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"791\";s:4:\"plid\";s:3:\"782\";s:9:\"link_path\";s:40:\"admin/structure/taxonomy/%/display/token\";s:11:\"router_path\";s:40:\"admin/structure/taxonomy/%/display/token\";s:10:\"link_title\";s:6:\"Tokens\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"57\";s:2:\"p4\";s:3:\"124\";s:2:\"p5\";s:3:\"782\";s:2:\"p6\";s:3:\"791\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:55:\"a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:109:\"a:5:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:5:\"token\";i:3;s:11:\"user_access\";i:4;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:97:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:5:\"token\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:34:\"admin/structure/taxonomy/%/display\";s:8:\"tab_root\";s:26:\"admin/structure/taxonomy/%\";s:5:\"title\";s:6:\"Tokens\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:784;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"784\";s:4:\"plid\";s:3:\"124\";s:9:\"link_path\";s:33:\"admin/structure/taxonomy/%/fields\";s:11:\"router_path\";s:33:\"admin/structure/taxonomy/%/fields\";s:10:\"link_title\";s:13:\"Manage fields\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"57\";s:2:\"p4\";s:3:\"124\";s:2:\"p5\";s:3:\"784\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:55:\"a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:79:\"a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:26:\"admin/structure/taxonomy/%\";s:8:\"tab_root\";s:26:\"admin/structure/taxonomy/%\";s:5:\"title\";s:13:\"Manage fields\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:794;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"794\";s:4:\"plid\";s:3:\"784\";s:9:\"link_path\";s:35:\"admin/structure/taxonomy/%/fields/%\";s:11:\"router_path\";s:35:\"admin/structure/taxonomy/%/fields/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"57\";s:2:\"p4\";s:3:\"124\";s:2:\"p5\";s:3:\"784\";s:2:\"p6\";s:3:\"794\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:229:\"a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:35:\"admin/structure/taxonomy/%/fields/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:19:\"field_ui_menu_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:804;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"804\";s:4:\"plid\";s:3:\"794\";s:9:\"link_path\";s:42:\"admin/structure/taxonomy/%/fields/%/delete\";s:11:\"router_path\";s:42:\"admin/structure/taxonomy/%/fields/%/delete\";s:10:\"link_title\";s:6:\"Delete\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"57\";s:2:\"p4\";s:3:\"124\";s:2:\"p5\";s:3:\"784\";s:2:\"p6\";s:3:\"794\";s:2:\"p7\";s:3:\"804\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:229:\"a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:52:\"a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:35:\"admin/structure/taxonomy/%/fields/%\";s:8:\"tab_root\";s:35:\"admin/structure/taxonomy/%/fields/%\";s:5:\"title\";s:6:\"Delete\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:805;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"805\";s:4:\"plid\";s:3:\"794\";s:9:\"link_path\";s:40:\"admin/structure/taxonomy/%/fields/%/edit\";s:11:\"router_path\";s:40:\"admin/structure/taxonomy/%/fields/%/edit\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"57\";s:2:\"p4\";s:3:\"124\";s:2:\"p5\";s:3:\"784\";s:2:\"p6\";s:3:\"794\";s:2:\"p7\";s:3:\"805\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:229:\"a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:35:\"admin/structure/taxonomy/%/fields/%\";s:8:\"tab_root\";s:35:\"admin/structure/taxonomy/%/fields/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:806;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"806\";s:4:\"plid\";s:3:\"794\";s:9:\"link_path\";s:50:\"admin/structure/taxonomy/%/fields/%/field-settings\";s:11:\"router_path\";s:50:\"admin/structure/taxonomy/%/fields/%/field-settings\";s:10:\"link_title\";s:14:\"Field settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"57\";s:2:\"p4\";s:3:\"124\";s:2:\"p5\";s:3:\"784\";s:2:\"p6\";s:3:\"794\";s:2:\"p7\";s:3:\"806\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:229:\"a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:54:\"a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:35:\"admin/structure/taxonomy/%/fields/%\";s:8:\"tab_root\";s:35:\"admin/structure/taxonomy/%/fields/%\";s:5:\"title\";s:14:\"Field settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:807;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"807\";s:4:\"plid\";s:3:\"794\";s:9:\"link_path\";s:47:\"admin/structure/taxonomy/%/fields/%/widget-type\";s:11:\"router_path\";s:47:\"admin/structure/taxonomy/%/fields/%/widget-type\";s:10:\"link_title\";s:11:\"Widget type\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:2:\"57\";s:2:\"p4\";s:3:\"124\";s:2:\"p5\";s:3:\"784\";s:2:\"p6\";s:3:\"794\";s:2:\"p7\";s:3:\"807\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:229:\"a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:51:\"a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:35:\"admin/structure/taxonomy/%/fields/%\";s:8:\"tab_root\";s:35:\"admin/structure/taxonomy/%/fields/%\";s:5:\"title\";s:11:\"Widget type\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}}}}}i:336;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"336\";s:4:\"plid\";s:2:\"21\";s:9:\"link_path\";s:21:\"admin/structure/views\";s:11:\"router_path\";s:21:\"admin/structure/views\";s:10:\"link_title\";s:5:\"Views\";s:7:\"options\";s:85:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:35:\"Manage customized lists of content.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"336\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:40:\"a:2:{i:0;s:8:\"views_ui\";i:1;s:4:\"list\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:40:\"a:2:{i:0;s:8:\"views_ui\";i:1;s:4:\"list\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/structure/views\";s:5:\"title\";s:5:\"Views\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:35:\"Manage customized lists of content.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:8:{i:338;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"338\";s:4:\"plid\";s:3:\"336\";s:9:\"link_path\";s:28:\"admin/structure/views/import\";s:11:\"router_path\";s:28:\"admin/structure/views/import\";s:10:\"link_title\";s:6:\"Import\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"336\";s:2:\"p4\";s:3:\"338\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:19:\"views_import_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:38:\"a:1:{i:0;s:20:\"views_ui_import_page\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/views\";s:8:\"tab_root\";s:21:\"admin/structure/views\";s:5:\"title\";s:6:\"Import\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:339;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"339\";s:4:\"plid\";s:3:\"336\";s:9:\"link_path\";s:26:\"admin/structure/views/list\";s:11:\"router_path\";s:26:\"admin/structure/views/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"336\";s:2:\"p4\";s:3:\"339\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:40:\"a:2:{i:0;s:8:\"views_ui\";i:1;s:4:\"list\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:40:\"a:2:{i:0;s:8:\"views_ui\";i:1;s:4:\"list\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/views\";s:8:\"tab_root\";s:21:\"admin/structure/views\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:340;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"340\";s:4:\"plid\";s:3:\"336\";s:9:\"link_path\";s:30:\"admin/structure/views/settings\";s:11:\"router_path\";s:30:\"admin/structure/views/settings\";s:10:\"link_title\";s:8:\"Settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"336\";s:2:\"p4\";s:3:\"340\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:47:\"a:1:{i:0;s:29:\"views_ui_admin_settings_basic\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/views\";s:8:\"tab_root\";s:21:\"admin/structure/views\";s:5:\"title\";s:8:\"Settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:345;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"345\";s:4:\"plid\";s:3:\"340\";s:9:\"link_path\";s:39:\"admin/structure/views/settings/advanced\";s:11:\"router_path\";s:39:\"admin/structure/views/settings/advanced\";s:10:\"link_title\";s:8:\"Advanced\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"336\";s:2:\"p4\";s:3:\"340\";s:2:\"p5\";s:3:\"345\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:1:{i:0;s:32:\"views_ui_admin_settings_advanced\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/structure/views/settings\";s:8:\"tab_root\";s:21:\"admin/structure/views\";s:5:\"title\";s:8:\"Advanced\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:346;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"346\";s:4:\"plid\";s:3:\"340\";s:9:\"link_path\";s:36:\"admin/structure/views/settings/basic\";s:11:\"router_path\";s:36:\"admin/structure/views/settings/basic\";s:10:\"link_title\";s:5:\"Basic\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"336\";s:2:\"p4\";s:3:\"340\";s:2:\"p5\";s:3:\"346\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:47:\"a:1:{i:0;s:29:\"views_ui_admin_settings_basic\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/structure/views/settings\";s:8:\"tab_root\";s:21:\"admin/structure/views\";s:5:\"title\";s:5:\"Basic\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:341;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"341\";s:4:\"plid\";s:3:\"336\";s:9:\"link_path\";s:25:\"admin/structure/views/add\";s:11:\"router_path\";s:25:\"admin/structure/views/add\";s:10:\"link_title\";s:12:\"Add new view\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"336\";s:2:\"p4\";s:3:\"341\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:17:\"views_ui_add_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/views\";s:8:\"tab_root\";s:21:\"admin/structure/views\";s:5:\"title\";s:12:\"Add new view\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:342;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"342\";s:4:\"plid\";s:3:\"336\";s:9:\"link_path\";s:34:\"admin/structure/views/add-template\";s:11:\"router_path\";s:34:\"admin/structure/views/add-template\";s:10:\"link_title\";s:22:\"Add view from template\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"336\";s:2:\"p4\";s:3:\"342\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:26:\"views_ui_add_template_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/views\";s:8:\"tab_root\";s:21:\"admin/structure/views\";s:5:\"title\";s:22:\"Add view from template\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:347;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"347\";s:4:\"plid\";s:3:\"336\";s:9:\"link_path\";s:28:\"admin/structure/views/view/%\";s:11:\"router_path\";s:28:\"admin/structure/views/view/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"336\";s:2:\"p4\";s:3:\"347\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:37:\"a:1:{i:4;s:19:\"views_ui_cache_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:18:\"views_ui_edit_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:28:\"admin/structure/views/view/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:24:\"views_ui_edit_page_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:7:{i:348;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"348\";s:4:\"plid\";s:3:\"347\";s:9:\"link_path\";s:39:\"admin/structure/views/view/%/break-lock\";s:11:\"router_path\";s:39:\"admin/structure/views/view/%/break-lock\";s:10:\"link_title\";s:10:\"Break lock\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"336\";s:2:\"p4\";s:3:\"347\";s:2:\"p5\";s:3:\"348\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:37:\"a:1:{i:4;s:19:\"views_ui_cache_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:53:\"a:2:{i:0;s:27:\"views_ui_break_lock_confirm\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:39:\"admin/structure/views/view/%/break-lock\";s:5:\"title\";s:10:\"Break lock\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:349;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"349\";s:4:\"plid\";s:3:\"347\";s:9:\"link_path\";s:33:\"admin/structure/views/view/%/edit\";s:11:\"router_path\";s:33:\"admin/structure/views/view/%/edit\";s:10:\"link_title\";s:9:\"Edit view\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"336\";s:2:\"p4\";s:3:\"347\";s:2:\"p5\";s:3:\"349\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:37:\"a:1:{i:4;s:19:\"views_ui_cache_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:18:\"views_ui_edit_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:28:\"admin/structure/views/view/%\";s:8:\"tab_root\";s:28:\"admin/structure/views/view/%\";s:5:\"title\";s:9:\"Edit view\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:20:\"ajax_base_page_theme\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:350;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"350\";s:4:\"plid\";s:3:\"347\";s:9:\"link_path\";s:34:\"admin/structure/views/view/%/clone\";s:11:\"router_path\";s:34:\"admin/structure/views/view/%/clone\";s:10:\"link_title\";s:5:\"Clone\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"336\";s:2:\"p4\";s:3:\"347\";s:2:\"p5\";s:3:\"350\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:70:\"a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:49:\"a:3:{i:0;s:8:\"views_ui\";i:1;s:5:\"clone\";i:2;i:4;}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:49:\"a:3:{i:0;s:8:\"views_ui\";i:1;s:5:\"clone\";i:2;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:34:\"admin/structure/views/view/%/clone\";s:5:\"title\";s:5:\"Clone\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:351;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"351\";s:4:\"plid\";s:3:\"347\";s:9:\"link_path\";s:35:\"admin/structure/views/view/%/delete\";s:11:\"router_path\";s:35:\"admin/structure/views/view/%/delete\";s:10:\"link_title\";s:6:\"Delete\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"336\";s:2:\"p4\";s:3:\"347\";s:2:\"p5\";s:3:\"351\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:70:\"a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:50:\"a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"delete\";i:2;i:4;}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:50:\"a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"delete\";i:2;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:35:\"admin/structure/views/view/%/delete\";s:5:\"title\";s:6:\"Delete\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:352;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"352\";s:4:\"plid\";s:3:\"347\";s:9:\"link_path\";s:35:\"admin/structure/views/view/%/export\";s:11:\"router_path\";s:35:\"admin/structure/views/view/%/export\";s:10:\"link_title\";s:6:\"Export\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"336\";s:2:\"p4\";s:3:\"347\";s:2:\"p5\";s:3:\"352\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:70:\"a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:50:\"a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"export\";i:2;i:4;}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:50:\"a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"export\";i:2;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:35:\"admin/structure/views/view/%/export\";s:5:\"title\";s:6:\"Export\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:353;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"353\";s:4:\"plid\";s:3:\"347\";s:9:\"link_path\";s:35:\"admin/structure/views/view/%/revert\";s:11:\"router_path\";s:35:\"admin/structure/views/view/%/revert\";s:10:\"link_title\";s:6:\"Revert\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"336\";s:2:\"p4\";s:3:\"347\";s:2:\"p5\";s:3:\"353\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:70:\"a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:50:\"a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"revert\";i:2;i:4;}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:50:\"a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"delete\";i:2;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:35:\"admin/structure/views/view/%/revert\";s:5:\"title\";s:6:\"Revert\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:355;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"355\";s:4:\"plid\";s:3:\"347\";s:9:\"link_path\";s:38:\"admin/structure/views/view/%/preview/%\";s:11:\"router_path\";s:38:\"admin/structure/views/view/%/preview/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"336\";s:2:\"p4\";s:3:\"347\";s:2:\"p5\";s:3:\"355\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:43:\"a:2:{i:4;s:19:\"views_ui_cache_load\";i:6;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:22:\"views_ui_build_preview\";s:14:\"page_arguments\";s:22:\"a:2:{i:0;i:4;i:1;i:6;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:38:\"admin/structure/views/view/%/preview/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:354;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"354\";s:4:\"plid\";s:3:\"336\";s:9:\"link_path\";s:38:\"admin/structure/views/nojs/preview/%/%\";s:11:\"router_path\";s:38:\"admin/structure/views/nojs/preview/%/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"336\";s:2:\"p4\";s:3:\"354\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:43:\"a:2:{i:5;s:19:\"views_ui_cache_load\";i:6;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:16:\"views_ui_preview\";s:14:\"page_arguments\";s:22:\"a:2:{i:0;i:5;i:1;i:6;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:38:\"admin/structure/views/nojs/preview/%/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:356;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"356\";s:4:\"plid\";s:3:\"336\";s:9:\"link_path\";s:38:\"admin/structure/views/ajax/preview/%/%\";s:11:\"router_path\";s:38:\"admin/structure/views/ajax/preview/%/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"336\";s:2:\"p4\";s:3:\"356\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:43:\"a:2:{i:5;s:19:\"views_ui_cache_load\";i:6;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:16:\"views_ui_preview\";s:14:\"page_arguments\";s:22:\"a:2:{i:0;i:5;i:1;i:6;}\";s:17:\"delivery_callback\";s:12:\"ajax_deliver\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:38:\"admin/structure/views/ajax/preview/%/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:372;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"372\";s:4:\"plid\";s:2:\"21\";s:9:\"link_path\";s:30:\"admin/structure/ctools-content\";s:11:\"router_path\";s:30:\"admin/structure/ctools-content\";s:10:\"link_title\";s:20:\"Custom content panes\";s:7:\"options\";s:91:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:41:\"Add, edit or delete custom content panes.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"372\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:54:\"a:2:{i:0;s:21:\"ctools_custom_content\";i:1;s:4:\"list\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:54:\"a:2:{i:0;s:21:\"ctools_custom_content\";i:1;s:4:\"list\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:30:\"admin/structure/ctools-content\";s:5:\"title\";s:20:\"Custom content panes\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:41:\"Add, edit or delete custom content panes.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:378;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"378\";s:4:\"plid\";s:3:\"372\";s:9:\"link_path\";s:34:\"admin/structure/ctools-content/add\";s:11:\"router_path\";s:34:\"admin/structure/ctools-content/add\";s:10:\"link_title\";s:3:\"Add\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"372\";s:2:\"p4\";s:3:\"378\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:53:\"a:2:{i:0;s:21:\"ctools_custom_content\";i:1;s:3:\"add\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:53:\"a:2:{i:0;s:21:\"ctools_custom_content\";i:1;s:3:\"add\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/structure/ctools-content\";s:8:\"tab_root\";s:30:\"admin/structure/ctools-content\";s:5:\"title\";s:3:\"Add\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:381;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"381\";s:4:\"plid\";s:3:\"372\";s:9:\"link_path\";s:37:\"admin/structure/ctools-content/import\";s:11:\"router_path\";s:37:\"admin/structure/ctools-content/import\";s:10:\"link_title\";s:6:\"Import\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"372\";s:2:\"p4\";s:3:\"381\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:56:\"a:2:{i:0;s:21:\"ctools_custom_content\";i:1;s:6:\"import\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:56:\"a:2:{i:0;s:21:\"ctools_custom_content\";i:1;s:6:\"import\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/structure/ctools-content\";s:8:\"tab_root\";s:30:\"admin/structure/ctools-content\";s:5:\"title\";s:6:\"Import\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:384;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"384\";s:4:\"plid\";s:3:\"372\";s:9:\"link_path\";s:35:\"admin/structure/ctools-content/list\";s:11:\"router_path\";s:35:\"admin/structure/ctools-content/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"372\";s:2:\"p4\";s:3:\"384\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:54:\"a:2:{i:0;s:21:\"ctools_custom_content\";i:1;s:4:\"list\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:54:\"a:2:{i:0;s:21:\"ctools_custom_content\";i:1;s:4:\"list\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/structure/ctools-content\";s:8:\"tab_root\";s:30:\"admin/structure/ctools-content\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:394;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"394\";s:4:\"plid\";s:3:\"384\";s:9:\"link_path\";s:42:\"admin/structure/ctools-content/list/%/edit\";s:11:\"router_path\";s:42:\"admin/structure/ctools-content/list/%/edit\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"372\";s:2:\"p4\";s:3:\"384\";s:2:\"p5\";s:3:\"394\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:84:\"a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:21:\"ctools_custom_content\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:62:\"a:3:{i:0;s:21:\"ctools_custom_content\";i:1;s:4:\"edit\";i:2;i:4;}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:62:\"a:3:{i:0;s:21:\"ctools_custom_content\";i:1;s:4:\"edit\";i:2;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/structure/ctools-content/list/%\";s:8:\"tab_root\";s:37:\"admin/structure/ctools-content/list/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:396;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"396\";s:4:\"plid\";s:3:\"384\";s:9:\"link_path\";s:44:\"admin/structure/ctools-content/list/%/export\";s:11:\"router_path\";s:44:\"admin/structure/ctools-content/list/%/export\";s:10:\"link_title\";s:6:\"Export\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"372\";s:2:\"p4\";s:3:\"384\";s:2:\"p5\";s:3:\"396\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:84:\"a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:21:\"ctools_custom_content\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:64:\"a:3:{i:0;s:21:\"ctools_custom_content\";i:1;s:6:\"export\";i:2;i:4;}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:64:\"a:3:{i:0;s:21:\"ctools_custom_content\";i:1;s:6:\"export\";i:2;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/structure/ctools-content/list/%\";s:8:\"tab_root\";s:37:\"admin/structure/ctools-content/list/%\";s:5:\"title\";s:6:\"Export\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}i:373;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"373\";s:4:\"plid\";s:2:\"21\";s:9:\"link_path\";s:27:\"admin/structure/mini-panels\";s:11:\"router_path\";s:27:\"admin/structure/mini-panels\";s:10:\"link_title\";s:11:\"Mini panels\";s:7:\"options\";s:144:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:94:\"Add, edit or delete mini panels, which can be used as blocks or content panes in other panels.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"373\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:44:\"a:2:{i:0;s:11:\"panels_mini\";i:1;s:4:\"list\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:11:\"panels_mini\";i:1;s:4:\"list\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:27:\"admin/structure/mini-panels\";s:5:\"title\";s:11:\"Mini panels\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:94:\"Add, edit or delete mini panels, which can be used as blocks or content panes in other panels.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:379;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"379\";s:4:\"plid\";s:3:\"373\";s:9:\"link_path\";s:31:\"admin/structure/mini-panels/add\";s:11:\"router_path\";s:31:\"admin/structure/mini-panels/add\";s:10:\"link_title\";s:3:\"Add\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"373\";s:2:\"p4\";s:3:\"379\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:43:\"a:2:{i:0;s:11:\"panels_mini\";i:1;s:3:\"add\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:43:\"a:2:{i:0;s:11:\"panels_mini\";i:1;s:3:\"add\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:27:\"admin/structure/mini-panels\";s:8:\"tab_root\";s:27:\"admin/structure/mini-panels\";s:5:\"title\";s:3:\"Add\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:382;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"382\";s:4:\"plid\";s:3:\"373\";s:9:\"link_path\";s:34:\"admin/structure/mini-panels/import\";s:11:\"router_path\";s:34:\"admin/structure/mini-panels/import\";s:10:\"link_title\";s:6:\"Import\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"373\";s:2:\"p4\";s:3:\"382\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:46:\"a:2:{i:0;s:11:\"panels_mini\";i:1;s:6:\"import\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:46:\"a:2:{i:0;s:11:\"panels_mini\";i:1;s:6:\"import\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:27:\"admin/structure/mini-panels\";s:8:\"tab_root\";s:27:\"admin/structure/mini-panels\";s:5:\"title\";s:6:\"Import\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:385;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"385\";s:4:\"plid\";s:3:\"373\";s:9:\"link_path\";s:32:\"admin/structure/mini-panels/list\";s:11:\"router_path\";s:32:\"admin/structure/mini-panels/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"373\";s:2:\"p4\";s:3:\"385\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:44:\"a:2:{i:0;s:11:\"panels_mini\";i:1;s:4:\"list\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:11:\"panels_mini\";i:1;s:4:\"list\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:27:\"admin/structure/mini-panels\";s:8:\"tab_root\";s:27:\"admin/structure/mini-panels\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:395;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"395\";s:4:\"plid\";s:3:\"385\";s:9:\"link_path\";s:39:\"admin/structure/mini-panels/list/%/edit\";s:11:\"router_path\";s:39:\"admin/structure/mini-panels/list/%/edit\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"373\";s:2:\"p4\";s:3:\"385\";s:2:\"p5\";s:3:\"395\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:74:\"a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:11:\"panels_mini\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:52:\"a:3:{i:0;s:11:\"panels_mini\";i:1;s:4:\"edit\";i:2;i:4;}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:52:\"a:3:{i:0;s:11:\"panels_mini\";i:1;s:4:\"edit\";i:2;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:34:\"admin/structure/mini-panels/list/%\";s:8:\"tab_root\";s:34:\"admin/structure/mini-panels/list/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:397;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"397\";s:4:\"plid\";s:3:\"385\";s:9:\"link_path\";s:41:\"admin/structure/mini-panels/list/%/export\";s:11:\"router_path\";s:41:\"admin/structure/mini-panels/list/%/export\";s:10:\"link_title\";s:6:\"Export\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"373\";s:2:\"p4\";s:3:\"385\";s:2:\"p5\";s:3:\"397\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:74:\"a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:11:\"panels_mini\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:54:\"a:3:{i:0;s:11:\"panels_mini\";i:1;s:6:\"export\";i:2;i:4;}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:54:\"a:3:{i:0;s:11:\"panels_mini\";i:1;s:6:\"export\";i:2;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:34:\"admin/structure/mini-panels/list/%\";s:8:\"tab_root\";s:34:\"admin/structure/mini-panels/list/%\";s:5:\"title\";s:6:\"Export\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:387;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"387\";s:4:\"plid\";s:3:\"373\";s:9:\"link_path\";s:36:\"admin/structure/mini-panels/settings\";s:11:\"router_path\";s:36:\"admin/structure/mini-panels/settings\";s:10:\"link_title\";s:8:\"Settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"373\";s:2:\"p4\";s:3:\"387\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"create mini panels\";}\";s:13:\"page_callback\";s:20:\"panels_mini_settings\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:27:\"admin/structure/mini-panels\";s:8:\"tab_root\";s:27:\"admin/structure/mini-panels\";s:5:\"title\";s:8:\"Settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:377;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"377\";s:4:\"plid\";s:2:\"21\";s:9:\"link_path\";s:22:\"admin/structure/panels\";s:11:\"router_path\";s:22:\"admin/structure/panels\";s:10:\"link_title\";s:6:\"Panels\";s:7:\"options\";s:99:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:49:\"Get a bird\'s eye view of items related to Panels.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"377\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"use panels dashboard\";}\";s:13:\"page_callback\";s:17:\"panels_admin_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:22:\"admin/structure/panels\";s:5:\"title\";s:6:\"Panels\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:49:\"Get a bird\'s eye view of items related to Panels.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:380;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"380\";s:4:\"plid\";s:3:\"377\";s:9:\"link_path\";s:32:\"admin/structure/panels/dashboard\";s:11:\"router_path\";s:32:\"admin/structure/panels/dashboard\";s:10:\"link_title\";s:9:\"Dashboard\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"377\";s:2:\"p4\";s:3:\"380\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"use panels dashboard\";}\";s:13:\"page_callback\";s:17:\"panels_admin_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:22:\"admin/structure/panels\";s:8:\"tab_root\";s:22:\"admin/structure/panels\";s:5:\"title\";s:9:\"Dashboard\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:386;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"386\";s:4:\"plid\";s:3:\"377\";s:9:\"link_path\";s:31:\"admin/structure/panels/settings\";s:11:\"router_path\";s:31:\"admin/structure/panels/settings\";s:10:\"link_title\";s:8:\"Settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"377\";s:2:\"p4\";s:3:\"386\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"use panels dashboard\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:1:{i:0;s:26:\"panels_admin_settings_page\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:22:\"admin/structure/panels\";s:8:\"tab_root\";s:22:\"admin/structure/panels\";s:5:\"title\";s:8:\"Settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:389;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"389\";s:4:\"plid\";s:3:\"386\";s:9:\"link_path\";s:39:\"admin/structure/panels/settings/general\";s:11:\"router_path\";s:39:\"admin/structure/panels/settings/general\";s:10:\"link_title\";s:7:\"General\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"377\";s:2:\"p4\";s:3:\"386\";s:2:\"p5\";s:3:\"389\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:41:\"a:1:{i:0;s:23:\"administer page manager\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:1:{i:0;s:26:\"panels_admin_settings_page\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/structure/panels/settings\";s:8:\"tab_root\";s:22:\"admin/structure/panels\";s:5:\"title\";s:7:\"General\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:392;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"392\";s:4:\"plid\";s:3:\"386\";s:9:\"link_path\";s:43:\"admin/structure/panels/settings/panels-mini\";s:11:\"router_path\";s:43:\"admin/structure/panels/settings/panels-mini\";s:10:\"link_title\";s:11:\"Mini panels\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"377\";s:2:\"p4\";s:3:\"386\";s:2:\"p5\";s:3:\"392\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"create mini panels\";}\";s:13:\"page_callback\";s:20:\"panels_mini_settings\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/structure/panels/settings\";s:8:\"tab_root\";s:22:\"admin/structure/panels\";s:5:\"title\";s:11:\"Mini panels\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:393;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"393\";s:4:\"plid\";s:3:\"386\";s:9:\"link_path\";s:42:\"admin/structure/panels/settings/panel-node\";s:11:\"router_path\";s:42:\"admin/structure/panels/settings/panel-node\";s:10:\"link_title\";s:11:\"Panel nodes\";s:7:\"options\";s:117:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:67:\"Configure which content is available to add to panel node displays.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"377\";s:2:\"p4\";s:3:\"386\";s:2:\"p5\";s:3:\"393\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:40:\"a:1:{i:0;s:22:\"administer panel-nodes\";}\";s:13:\"page_callback\";s:20:\"panels_node_settings\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/structure/panels/settings\";s:8:\"tab_root\";s:22:\"admin/structure/panels\";s:5:\"title\";s:11:\"Panel nodes\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:67:\"Configure which content is available to add to panel node displays.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:406;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"406\";s:4:\"plid\";s:3:\"386\";s:9:\"link_path\";s:42:\"admin/structure/panels/settings/panel-page\";s:11:\"router_path\";s:42:\"admin/structure/panels/settings/panel-page\";s:10:\"link_title\";s:11:\"Panel pages\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"377\";s:2:\"p4\";s:3:\"386\";s:2:\"p5\";s:3:\"406\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"use panels dashboard\";}\";s:13:\"page_callback\";s:31:\"panels_admin_panel_context_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/structure/panels/settings\";s:8:\"tab_root\";s:22:\"admin/structure/panels\";s:5:\"title\";s:11:\"Panel pages\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:862;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"862\";s:4:\"plid\";s:3:\"377\";s:9:\"link_path\";s:30:\"admin/structure/panels/layouts\";s:11:\"router_path\";s:30:\"admin/structure/panels/layouts\";s:10:\"link_title\";s:7:\"Layouts\";s:7:\"options\";s:93:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Add, edit or delete custom content layouts.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"377\";s:2:\"p4\";s:3:\"862\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:47:\"a:2:{i:0;s:14:\"panels_layouts\";i:1;s:4:\"list\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:47:\"a:2:{i:0;s:14:\"panels_layouts\";i:1;s:4:\"list\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:22:\"admin/structure/panels\";s:8:\"tab_root\";s:22:\"admin/structure/panels\";s:5:\"title\";s:7:\"Layouts\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:43:\"Add, edit or delete custom content layouts.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:863;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"863\";s:4:\"plid\";s:3:\"862\";s:9:\"link_path\";s:43:\"admin/structure/panels/layouts/add-flexible\";s:11:\"router_path\";s:43:\"admin/structure/panels/layouts/add-flexible\";s:10:\"link_title\";s:19:\"Add flexible layout\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"377\";s:2:\"p4\";s:3:\"862\";s:2:\"p5\";s:3:\"863\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:46:\"a:2:{i:0;s:14:\"panels_layouts\";i:1;s:3:\"add\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:65:\"a:3:{i:0;s:14:\"panels_layouts\";i:1;s:3:\"add\";i:2;s:8:\"flexible\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/structure/panels/layouts\";s:8:\"tab_root\";s:22:\"admin/structure/panels\";s:5:\"title\";s:19:\"Add flexible layout\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:864;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"864\";s:4:\"plid\";s:3:\"862\";s:9:\"link_path\";s:37:\"admin/structure/panels/layouts/import\";s:11:\"router_path\";s:37:\"admin/structure/panels/layouts/import\";s:10:\"link_title\";s:6:\"Import\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"377\";s:2:\"p4\";s:3:\"862\";s:2:\"p5\";s:3:\"864\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:49:\"a:2:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"import\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:49:\"a:2:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"import\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/structure/panels/layouts\";s:8:\"tab_root\";s:22:\"admin/structure/panels\";s:5:\"title\";s:6:\"Import\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:865;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"865\";s:4:\"plid\";s:3:\"862\";s:9:\"link_path\";s:35:\"admin/structure/panels/layouts/list\";s:11:\"router_path\";s:35:\"admin/structure/panels/layouts/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"377\";s:2:\"p4\";s:3:\"862\";s:2:\"p5\";s:3:\"865\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:47:\"a:2:{i:0;s:14:\"panels_layouts\";i:1;s:4:\"list\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:47:\"a:2:{i:0;s:14:\"panels_layouts\";i:1;s:4:\"list\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/structure/panels/layouts\";s:8:\"tab_root\";s:22:\"admin/structure/panels\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:866;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"866\";s:4:\"plid\";s:3:\"865\";s:9:\"link_path\";s:42:\"admin/structure/panels/layouts/list/%/edit\";s:11:\"router_path\";s:42:\"admin/structure/panels/layouts/list/%/edit\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"377\";s:2:\"p4\";s:3:\"862\";s:2:\"p5\";s:3:\"865\";s:2:\"p6\";s:3:\"866\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:77:\"a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:14:\"panels_layouts\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:55:\"a:3:{i:0;s:14:\"panels_layouts\";i:1;s:4:\"edit\";i:2;i:5;}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:55:\"a:3:{i:0;s:14:\"panels_layouts\";i:1;s:4:\"edit\";i:2;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/structure/panels/layouts/list/%\";s:8:\"tab_root\";s:37:\"admin/structure/panels/layouts/list/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:867;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"867\";s:4:\"plid\";s:3:\"865\";s:9:\"link_path\";s:44:\"admin/structure/panels/layouts/list/%/export\";s:11:\"router_path\";s:44:\"admin/structure/panels/layouts/list/%/export\";s:10:\"link_title\";s:6:\"Export\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"377\";s:2:\"p4\";s:3:\"862\";s:2:\"p5\";s:3:\"865\";s:2:\"p6\";s:3:\"867\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:77:\"a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:14:\"panels_layouts\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:57:\"a:3:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"export\";i:2;i:5;}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:57:\"a:3:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"export\";i:2;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/structure/panels/layouts/list/%\";s:8:\"tab_root\";s:37:\"admin/structure/panels/layouts/list/%\";s:5:\"title\";s:6:\"Export\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}}}i:400;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"400\";s:4:\"plid\";s:2:\"21\";s:9:\"link_path\";s:21:\"admin/structure/pages\";s:11:\"router_path\";s:21:\"admin/structure/pages\";s:10:\"link_title\";s:5:\"Pages\";s:7:\"options\";s:134:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:84:\"Add, edit and remove overridden system pages and user defined pages from the system.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"400\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"use page manager\";}\";s:13:\"page_callback\";s:22:\"page_manager_list_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/structure/pages\";s:5:\"title\";s:5:\"Pages\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:20:\"ajax_base_page_theme\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:84:\"Add, edit and remove overridden system pages and user defined pages from the system.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:6:{i:401;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"401\";s:4:\"plid\";s:3:\"400\";s:9:\"link_path\";s:25:\"admin/structure/pages/add\";s:11:\"router_path\";s:25:\"admin/structure/pages/add\";s:10:\"link_title\";s:15:\"Add custom page\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"400\";s:2:\"p4\";s:3:\"401\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:41:\"a:1:{i:0;s:23:\"administer page manager\";}\";s:13:\"page_callback\";s:29:\"page_manager_page_add_subtask\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/pages\";s:8:\"tab_root\";s:21:\"admin/structure/pages\";s:5:\"title\";s:15:\"Add custom page\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:20:\"ajax_base_page_theme\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:402;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"402\";s:4:\"plid\";s:3:\"400\";s:9:\"link_path\";s:28:\"admin/structure/pages/import\";s:11:\"router_path\";s:28:\"admin/structure/pages/import\";s:10:\"link_title\";s:11:\"Import page\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"400\";s:2:\"p4\";s:3:\"402\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:23:\"ctools_access_multiperm\";s:16:\"access_arguments\";s:73:\"a:2:{i:0;s:23:\"administer page manager\";i:1;s:20:\"use PHP for settings\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:65:\"a:2:{i:0;s:32:\"page_manager_page_import_subtask\";i:1;s:4:\"page\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/pages\";s:8:\"tab_root\";s:21:\"admin/structure/pages\";s:5:\"title\";s:11:\"Import page\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:20:\"ajax_base_page_theme\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:403;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"403\";s:4:\"plid\";s:3:\"400\";s:9:\"link_path\";s:26:\"admin/structure/pages/list\";s:11:\"router_path\";s:26:\"admin/structure/pages/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"400\";s:2:\"p4\";s:3:\"403\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"use page manager\";}\";s:13:\"page_callback\";s:22:\"page_manager_list_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/pages\";s:8:\"tab_root\";s:21:\"admin/structure/pages\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:20:\"ajax_base_page_theme\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:404;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"404\";s:4:\"plid\";s:3:\"400\";s:9:\"link_path\";s:28:\"admin/structure/pages/wizard\";s:11:\"router_path\";s:28:\"admin/structure/pages/wizard\";s:10:\"link_title\";s:7:\"Wizards\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-5\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"400\";s:2:\"p4\";s:3:\"404\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"use page manager\";}\";s:13:\"page_callback\";s:29:\"page_manager_page_wizard_list\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/pages\";s:8:\"tab_root\";s:21:\"admin/structure/pages\";s:5:\"title\";s:7:\"Wizards\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:20:\"ajax_base_page_theme\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:405;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"405\";s:4:\"plid\";s:3:\"400\";s:9:\"link_path\";s:28:\"admin/structure/pages/edit/%\";s:11:\"router_path\";s:28:\"admin/structure/pages/edit/%\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"400\";s:2:\"p4\";s:3:\"405\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:41:\"a:1:{i:4;s:23:\"page_manager_cache_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"use page manager\";}\";s:13:\"page_callback\";s:22:\"page_manager_edit_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:28:\"admin/structure/pages/edit/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:20:\"ajax_base_page_theme\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:407;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"407\";s:4:\"plid\";s:3:\"400\";s:9:\"link_path\";s:35:\"admin/structure/pages/%/operation/%\";s:11:\"router_path\";s:35:\"admin/structure/pages/%/operation/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:3:\"400\";s:2:\"p4\";s:3:\"407\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:67:\"a:2:{i:3;s:14:\"ctools_js_load\";i:5;s:23:\"page_manager_cache_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"use page manager\";}\";s:13:\"page_callback\";s:32:\"page_manager_edit_page_operation\";s:14:\"page_arguments\";s:22:\"a:2:{i:0;i:3;i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:35:\"admin/structure/pages/%/operation/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:20:\"ajax_base_page_theme\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}i:22;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"22\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:11:\"admin/tasks\";s:11:\"router_path\";s:11:\"admin/tasks\";s:10:\"link_title\";s:5:\"Tasks\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-20\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"22\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:5:\"admin\";s:8:\"tab_root\";s:5:\"admin\";s:5:\"title\";s:5:\"Tasks\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}s:10:\"node_links\";a:0:{}}',0,1371656313,1),('links:navigation:tree-data:en:7495eb1e79a64d19a9c75b78fd39b8b17c02b3073c84e89a5069ca6b9c76749c','a:2:{s:4:\"tree\";a:1:{i:6;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:1:\"6\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:8:\"node/add\";s:11:\"router_path\";s:8:\"node/add\";s:10:\"link_title\";s:11:\"Add content\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:16:\"_node_add_access\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:13:\"node_add_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:8:\"node/add\";s:5:\"title\";s:11:\"Add content\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:12:{i:219;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"219\";s:4:\"plid\";s:1:\"6\";s:9:\"link_path\";s:16:\"node/add/article\";s:11:\"router_path\";s:16:\"node/add/article\";s:10:\"link_title\";s:7:\"Article\";s:7:\"options\";s:139:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:89:\"Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:3:\"219\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:41:\"a:2:{i:0;s:6:\"create\";i:1;s:7:\"article\";}\";s:13:\"page_callback\";s:8:\"node_add\";s:14:\"page_arguments\";s:24:\"a:1:{i:0;s:7:\"article\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:16:\"node/add/article\";s:5:\"title\";s:7:\"Article\";s:14:\"title_callback\";s:11:\"check_plain\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:89:\"Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:220;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"220\";s:4:\"plid\";s:1:\"6\";s:9:\"link_path\";s:13:\"node/add/page\";s:11:\"router_path\";s:13:\"node/add/page\";s:10:\"link_title\";s:10:\"Basic page\";s:7:\"options\";s:127:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:77:\"Use <em>basic pages</em> for your static content, such as an \'About us\' page.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:3:\"220\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:38:\"a:2:{i:0;s:6:\"create\";i:1;s:4:\"page\";}\";s:13:\"page_callback\";s:8:\"node_add\";s:14:\"page_arguments\";s:21:\"a:1:{i:0;s:4:\"page\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:13:\"node/add/page\";s:5:\"title\";s:10:\"Basic page\";s:14:\"title_callback\";s:11:\"check_plain\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:77:\"Use <em>basic pages</em> for your static content, such as an \'About us\' page.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:358;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"358\";s:4:\"plid\";s:1:\"6\";s:9:\"link_path\";s:16:\"node/add/vcenter\";s:11:\"router_path\";s:16:\"node/add/vcenter\";s:10:\"link_title\";s:7:\"vCenter\";s:7:\"options\";s:65:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:15:\"Add new vCenter\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:3:\"358\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:41:\"a:2:{i:0;s:6:\"create\";i:1;s:7:\"vcenter\";}\";s:13:\"page_callback\";s:8:\"node_add\";s:14:\"page_arguments\";s:24:\"a:1:{i:0;s:7:\"vcenter\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:16:\"node/add/vcenter\";s:5:\"title\";s:7:\"vCenter\";s:14:\"title_callback\";s:11:\"check_plain\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:15:\"Add new vCenter\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:359;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"359\";s:4:\"plid\";s:1:\"6\";s:9:\"link_path\";s:20:\"node/add/data-center\";s:11:\"router_path\";s:20:\"node/add/data-center\";s:10:\"link_title\";s:11:\"Data Center\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:3:\"359\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:46:\"a:2:{i:0;s:6:\"create\";i:1;s:11:\"data_center\";}\";s:13:\"page_callback\";s:8:\"node_add\";s:14:\"page_arguments\";s:29:\"a:1:{i:0;s:11:\"data_center\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:20:\"node/add/data-center\";s:5:\"title\";s:11:\"Data Center\";s:14:\"title_callback\";s:11:\"check_plain\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:360;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"360\";s:4:\"plid\";s:1:\"6\";s:9:\"link_path\";s:24:\"node/add/virtual-machine\";s:11:\"router_path\";s:24:\"node/add/virtual-machine\";s:10:\"link_title\";s:15:\"Virtual Machine\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:3:\"360\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:50:\"a:2:{i:0;s:6:\"create\";i:1;s:15:\"virtual_machine\";}\";s:13:\"page_callback\";s:8:\"node_add\";s:14:\"page_arguments\";s:33:\"a:1:{i:0;s:15:\"virtual_machine\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:24:\"node/add/virtual-machine\";s:5:\"title\";s:15:\"Virtual Machine\";s:14:\"title_callback\";s:11:\"check_plain\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:367;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"367\";s:4:\"plid\";s:1:\"6\";s:9:\"link_path\";s:13:\"node/add/host\";s:11:\"router_path\";s:13:\"node/add/host\";s:10:\"link_title\";s:4:\"Host\";s:7:\"options\";s:79:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:29:\"An ESXi 5.0 host on a vCenter\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:3:\"367\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:38:\"a:2:{i:0;s:6:\"create\";i:1;s:4:\"host\";}\";s:13:\"page_callback\";s:8:\"node_add\";s:14:\"page_arguments\";s:21:\"a:1:{i:0;s:4:\"host\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:13:\"node/add/host\";s:5:\"title\";s:4:\"Host\";s:14:\"title_callback\";s:11:\"check_plain\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:29:\"An ESXi 5.0 host on a vCenter\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:368;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"368\";s:4:\"plid\";s:1:\"6\";s:9:\"link_path\";s:15:\"node/add/device\";s:11:\"router_path\";s:15:\"node/add/device\";s:10:\"link_title\";s:6:\"Device\";s:7:\"options\";s:92:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:42:\"A physical hard drive available to a host.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:3:\"368\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:40:\"a:2:{i:0;s:6:\"create\";i:1;s:6:\"device\";}\";s:13:\"page_callback\";s:8:\"node_add\";s:14:\"page_arguments\";s:23:\"a:1:{i:0;s:6:\"device\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"node/add/device\";s:5:\"title\";s:6:\"Device\";s:14:\"title_callback\";s:11:\"check_plain\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:42:\"A physical hard drive available to a host.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:369;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"369\";s:4:\"plid\";s:1:\"6\";s:9:\"link_path\";s:14:\"node/add/vdisk\";s:11:\"router_path\";s:14:\"node/add/vdisk\";s:10:\"link_title\";s:5:\"vDisk\";s:7:\"options\";s:88:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"A virtual disk that is located on a VM\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:3:\"369\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:39:\"a:2:{i:0;s:6:\"create\";i:1;s:5:\"vdisk\";}\";s:13:\"page_callback\";s:8:\"node_add\";s:14:\"page_arguments\";s:22:\"a:1:{i:0;s:5:\"vdisk\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:14:\"node/add/vdisk\";s:5:\"title\";s:5:\"vDisk\";s:14:\"title_callback\";s:11:\"check_plain\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:38:\"A virtual disk that is located on a VM\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:374;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"374\";s:4:\"plid\";s:1:\"6\";s:9:\"link_path\";s:14:\"node/add/panel\";s:11:\"router_path\";s:14:\"node/add/panel\";s:10:\"link_title\";s:5:\"Panel\";s:7:\"options\";s:97:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:47:\"A panel layout broken up into rows and columns.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:3:\"374\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:39:\"a:2:{i:0;s:6:\"create\";i:1;s:5:\"panel\";}\";s:13:\"page_callback\";s:8:\"node_add\";s:14:\"page_arguments\";s:22:\"a:1:{i:0;s:5:\"panel\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:14:\"node/add/panel\";s:5:\"title\";s:5:\"Panel\";s:14:\"title_callback\";s:11:\"check_plain\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:47:\"A panel layout broken up into rows and columns.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:498;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"498\";s:4:\"plid\";s:1:\"6\";s:9:\"link_path\";s:19:\"node/add/vm-metrics\";s:11:\"router_path\";s:19:\"node/add/vm-metrics\";s:10:\"link_title\";s:10:\"VM metrics\";s:7:\"options\";s:81:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"Stores the metrics data of VMs.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:3:\"498\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:45:\"a:2:{i:0;s:6:\"create\";i:1;s:10:\"vm_metrics\";}\";s:13:\"page_callback\";s:8:\"node_add\";s:14:\"page_arguments\";s:28:\"a:1:{i:0;s:10:\"vm_metrics\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"node/add/vm-metrics\";s:5:\"title\";s:10:\"VM metrics\";s:14:\"title_callback\";s:11:\"check_plain\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:31:\"Stores the metrics data of VMs.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:514;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"514\";s:4:\"plid\";s:1:\"6\";s:9:\"link_path\";s:22:\"node/add/vdisk-metrics\";s:11:\"router_path\";s:22:\"node/add/vdisk-metrics\";s:10:\"link_title\";s:13:\"vDisk metrics\";s:7:\"options\";s:78:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:28:\"The metrics from the vDisks.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:3:\"514\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:48:\"a:2:{i:0;s:6:\"create\";i:1;s:13:\"vdisk_metrics\";}\";s:13:\"page_callback\";s:8:\"node_add\";s:14:\"page_arguments\";s:31:\"a:1:{i:0;s:13:\"vdisk_metrics\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:22:\"node/add/vdisk-metrics\";s:5:\"title\";s:13:\"vDisk metrics\";s:14:\"title_callback\";s:11:\"check_plain\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:28:\"The metrics from the vDisks.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:711;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"711\";s:4:\"plid\";s:1:\"6\";s:9:\"link_path\";s:23:\"node/add/vm-cache-space\";s:11:\"router_path\";s:23:\"node/add/vm-cache-space\";s:10:\"link_title\";s:14:\"VM Cache Space\";s:7:\"options\";s:106:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:56:\"Stores all the details related to Cache Space for any VM\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:3:\"711\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:49:\"a:2:{i:0;s:6:\"create\";i:1;s:14:\"vm_cache_space\";}\";s:13:\"page_callback\";s:8:\"node_add\";s:14:\"page_arguments\";s:32:\"a:1:{i:0;s:14:\"vm_cache_space\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:23:\"node/add/vm-cache-space\";s:5:\"title\";s:14:\"VM Cache Space\";s:14:\"title_callback\";s:11:\"check_plain\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:56:\"Stores all the details related to Cache Space for any VM\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}s:10:\"node_links\";a:0:{}}',0,1371656313,1),('admin_menu:1:5pYLL8mkRNiIqNkxJfrKEPQA6Jel5pYSgS7v4iTebQs:en','<div id=\"admin-menu\" class=\"admin-menu-site-10-226-147-55\"><div id=\"admin-menu-wrapper\">\n<ul class=\"dropdown\"><li class=\"admin-menu-icon expandable\"><a href=\"/\"><img class=\"admin-menu-icon\" src=\"//10.226.147.55/sites/all/themes/mercury/images/netapp_favicon.png\" width=\"16\" height=\"16\" alt=\"Home\" /></a>\n<ul class=\"dropdown\"><li><a href=\"/admin/index\">Index</a></li><li class=\"expandable\"><a href=\"/admin_menu/flush-cache?token=cT9Ca-0o3mj7J29mEeDTIvIrt1zfFxiAYX-vJrjX3SE\" class=\"admin-menu-destination\">Flush all caches</a>\n<ul class=\"dropdown\"><li><a href=\"/admin_menu/flush-cache/admin_menu?token=j035r7CDvuwUd3SXm1xmf9e2ZhAcMrJBBW645A7cRKQ\" class=\"admin-menu-destination\">Administration menu</a></li><li><a href=\"/admin_menu/flush-cache/registry?token=q88uIZj7e5M_mXdL92RLAL8jH0_cNAj8ie3OsGEcyXY\" class=\"admin-menu-destination\">Class registry</a></li><li><a href=\"/admin_menu/flush-cache/assets?token=sdJEbK2IDLl4QRPLJlPcWomY6BQScNkqN_Uw6QO7ojo\" class=\"admin-menu-destination\">CSS and JavaScript</a></li><li><a href=\"/admin_menu/flush-cache/menu?token=K4K9R9WMnigAlIyVO55tB8tDscyd6yxb32rYQJ22Wy8\" class=\"admin-menu-destination\">Menu</a></li><li><a href=\"/admin_menu/flush-cache/cache?token=oEyEFcgTCxsafwlbROt1WdkRtNGhZvjqP4jpURK1i9o\" class=\"admin-menu-destination\">Page and else</a></li><li><a href=\"/admin_menu/flush-cache/theme?token=QtQ36_ZbEAWzY6nvHEzxcTT8ymu_0-CWOEmcrvzOjOI\" class=\"admin-menu-destination\">Theme registry</a></li><li><a href=\"/token/flush-cache?token=UxDY4VpeEaXPU235ESgb9kmCooHX-hM6CflSE3yDCjs\" class=\"admin-menu-destination\">Token registry</a></li></ul></li><li><a href=\"/admin/reports/status/run-cron\">Run cron</a></li><li><a href=\"/update.php\">Run updates</a></li><li><a href=\"/admin_menu/toggle-modules?token=sEBhw0XJvx8SGfIzDp4IHdqiUdLNcvrkhuCh9aa-jqI\" class=\"admin-menu-destination\">Disable developer modules</a></li><li class=\"expandable\"><a href=\"http://drupal.org\">Drupal.org</a>\n<ul class=\"dropdown\"><li><a href=\"http://drupal.org/project/issues/drupal?version=7.x\">Block issue queue</a></li><li><a href=\"http://drupal.org/project/issues/admin_menu?version=7.x\">Administration menu issue queue</a></li><li><a href=\"http://drupal.org/project/issues/block_class?version=7.x\">Block Class issue queue</a></li><li><a href=\"http://drupal.org/project/issues/ctools?version=7.x\">Chaos tools issue queue</a></li><li><a href=\"http://drupal.org/project/issues/coder?version=7.x\">Coder issue queue</a></li><li><a href=\"http://drupal.org/project/issues/computed_field?version=7.x\">Computed Field issue queue</a></li><li><a href=\"http://drupal.org/project/issues/date?version=7.x\">Date issue queue</a></li><li><a href=\"http://drupal.org/project/issues/entity?version=7.x\">Entity API issue queue</a></li><li><a href=\"http://drupal.org/project/issues/entityreference?version=7.x\">Entity Reference issue queue</a></li><li><a href=\"http://drupal.org/project/issues/eva?version=7.x\">Eva issue queue</a></li><li><a href=\"http://drupal.org/project/issues/field_group?version=7.x\">Fieldgroup issue queue</a></li><li><a href=\"http://drupal.org/project/issues/jslider_form_api?version=7.x\">jQuery Slider Form API issue queue</a></li><li><a href=\"http://drupal.org/project/issues/login_destination?version=7.x\">Login Destination issue queue</a></li><li><a href=\"http://drupal.org/project/issues/logintoboggan?version=7.x\">LoginToboggan issue queue</a></li><li><a href=\"http://drupal.org/project/issues/menu_attributes?version=7.x\">Menu attributes issue queue</a></li><li><a href=\"http://drupal.org/project/issues/module_filter?version=7.x\">Module filter issue queue</a></li><li><a href=\"http://drupal.org/project/issues/references?version=7.x\">Node Reference issue queue</a></li><li><a href=\"http://drupal.org/project/issues/panels?version=7.x\">Panels issue queue</a></li><li><a href=\"http://drupal.org/project/issues/password_field?version=7.x\">Password Field issue queue</a></li><li><a href=\"http://drupal.org/project/issues/pathauto?version=7.x\">Pathauto issue queue</a></li><li><a href=\"http://drupal.org/project/issues/r4032login?version=7.x\">Redirect 403 to User Login issue queue</a></li><li><a href=\"http://drupal.org/project/issues/search_api?version=7.x\">Search API issue queue</a></li><li><a href=\"http://drupal.org/project/issues/search_api_page?version=7.x\">Search pages issue queue</a></li><li><a href=\"http://drupal.org/project/issues/token?version=7.x\">Token issue queue</a></li><li><a href=\"http://drupal.org/project/issues/unique_field?version=7.x\">Unique Field issue queue</a></li><li><a href=\"http://drupal.org/project/issues/views_data_export?version=7.x\">Views Data Export issue queue</a></li><li><a href=\"http://drupal.org/project/issues/views_php?version=7.x\">Views PHP issue queue</a></li><li><a href=\"http://drupal.org/project/issues/views?version=7.x\">Views UI issue queue</a></li><li><a href=\"http://drupal.org/project/issues/views_watchdog?version=7.x\">Views Watchdog issue queue</a></li></ul></li></ul></li></ul>\n<ul class=\"dropdown\"><li><a href=\"/admin/dashboard\">Dashboard</a></li><li class=\"expandable\"><a href=\"/admin/content\">Content</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/node/add\">Add content</a>\n<ul class=\"dropdown\"><li><a href=\"/node/add/article\">Article</a></li><li><a href=\"/node/add/page\">Basic page</a></li><li><a href=\"/node/add/data-center\">Data Center</a></li><li><a href=\"/node/add/device\">Device</a></li><li><a href=\"/node/add/host\">Host</a></li><li><a href=\"/node/add/panel\">Panel</a></li><li><a href=\"/node/add/vcenter\">vCenter</a></li><li><a href=\"/node/add/vdisk\">vDisk</a></li><li><a href=\"/node/add/vdisk-metrics\">vDisk metrics</a></li><li><a href=\"/node/add/virtual-machine\">Virtual Machine</a></li><li><a href=\"/node/add/vm-cache-space\">VM Cache Space</a></li><li><a href=\"/node/add/vm-metrics\">VM metrics</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/content/comment\">Comments</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/content/comment/approval\">Unapproved comments (0)</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure\">Structure</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/admin/structure/block\">Blocks</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/block/add\">Add block</a></li><li class=\"expandable\"><a href=\"/admin/structure/block/list/bartik\">Bartik</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/block/list/bartik/add\">Add block</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/block/list/seven\">Seven</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/block/list/seven/add\">Add block</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types\">Content types</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/add\">Add content type</a></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/article\">Article</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/article/delete\">Delete</a></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/article/fields\">Manage fields</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/admin/structure/types/manage/article/fields/body\">Body</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/article/fields/body/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/article/fields/body/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/article/fields/body/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/article/fields/field_tags\">Tags</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/article/fields/field_tags/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/article/fields/field_tags/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/article/fields/field_tags/delete\">Delete</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/article/display\">Manage display</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/article/display/teaser\">Teaser</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/page\">Basic page</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/page/delete\">Delete</a></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/page/fields\">Manage fields</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/admin/structure/types/manage/page/fields/body\">Body</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/page/fields/body/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/page/fields/body/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/page/fields/body/delete\">Delete</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/page/display\">Manage display</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/page/display/teaser\">Teaser</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/data_center\">Data Center</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/data_center/delete\">Delete</a></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/data_center/fields\">Manage fields</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/admin/structure/types/manage/data_center/fields/body\">Description</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/data_center/fields/body/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/data_center/fields/body/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/data_center/fields/body/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/data_center/fields/field_related_vcenter\">Related vCenter</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/data_center/fields/field_related_vcenter/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/data_center/fields/field_related_vcenter/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/data_center/fields/field_related_vcenter/delete\">Delete</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/data_center/display\">Manage display</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/data_center/display/teaser\">Teaser</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device\">Device</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/delete\">Delete</a></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields\">Manage fields</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_attached_filters\">Attached Filters</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_attached_filters/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_attached_filters/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_attached_filters/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_devfs_path\">Devfs Path</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_devfs_path/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_devfs_path/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_devfs_path/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_device_type\">Device Type</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_device_type/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_device_type/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_device_type/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_display_name\">Display Name</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_display_name/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_display_name/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_display_name/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_is_local\">Is Local</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_is_local/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_is_local/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_is_local/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_is_offline\">Is Offline</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_is_offline/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_is_offline/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_is_offline/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_is_perennially_reserved\">Is Perennially Reserved</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_is_perennially_reserved/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_is_perennially_reserved/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_is_perennially_reserved/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_is_pseudo\">Is Pseudo</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_is_pseudo/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_is_pseudo/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_is_pseudo/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_is_rdm_capable\">Is RDM Capable</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_is_rdm_capable/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_is_rdm_capable/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_is_rdm_capable/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_is_removable\">Is Removable</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_is_removable/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_is_removable/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_is_removable/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_is_ssd\">Is SSD</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_is_ssd/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_is_ssd/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_is_ssd/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_is_vmfs\">Is VMFS</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_is_vmfs/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_is_vmfs/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_is_vmfs/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_model\">Model</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_model/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_model/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_model/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_multipath_plugin\">Multipath Plugin</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_multipath_plugin/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_multipath_plugin/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_multipath_plugin/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_other_uids\">Other UIDs</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_other_uids/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_other_uids/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_other_uids/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_related_host\">Related Host</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_related_host/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_related_host/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_related_host/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_revision\">Revision</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_revision/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_revision/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_revision/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_scsi_level\">SCSI Level</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_scsi_level/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_scsi_level/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_scsi_level/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_serial_no\">Serial No</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_serial_no/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_serial_no/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_serial_no/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_size\">Size</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_size/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_size/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_size/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_status\">Status</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_status/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_status/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_status/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_thin_provisioning_status\">Thin Provisioning Status</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_thin_provisioning_status/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_thin_provisioning_status/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_thin_provisioning_status/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_vaai_status\">VAAI Status</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_vaai_status/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_vaai_status/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_vaai_status/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/fields/field_vendor\">Vendor</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/fields/field_vendor/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_vendor/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/device/fields/field_vendor/delete\">Delete</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/device/display\">Manage display</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/device/display/teaser\">Teaser</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host\">Host</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/delete\">Delete</a></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields\">Manage fields</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_allocated_segments\">Allocated Segments</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_allocated_segments/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_allocated_segments/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_allocated_segments/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_allocated_size\">Allocated Size</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_allocated_size/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_allocated_size/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_allocated_size/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_allocated_virtual_machines\">Allocated Virtual Machines</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_allocated_virtual_machines/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_allocated_virtual_machines/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_allocated_virtual_machines/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_boottime\">BootTime</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_boottime/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_boottime/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_boottime/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_bundle_status\">Bundle Status</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_bundle_status/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_bundle_status/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_bundle_status/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_cache_state\">Cache State</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_cache_state/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_cache_state/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_cache_state/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_claimed_physical_devices\">Claimed Physical Devices</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_claimed_physical_devices/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_claimed_physical_devices/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_claimed_physical_devices/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_cpu_model\">Cpu Model</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_cpu_model/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_cpu_model/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_cpu_model/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_cpu_usage\">CPU Usage</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_cpu_usage/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_cpu_usage/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_cpu_usage/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_datacenter\">Datacenter</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_datacenter/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_datacenter/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_datacenter/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_device_state\">Device State</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_device_state/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_device_state/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_device_state/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_drs\">drs</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_drs/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_drs/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_drs/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_ha\">HA</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_ha/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_ha/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_ha/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_hbtl\">HBTL</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_hbtl/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_hbtl/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_hbtl/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_host_model\">Host Model</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_host_model/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_host_model/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_host_model/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_host_status\">Host Status</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_host_status/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_host_status/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_host_status/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_host_vendor\">Host Vendor</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_host_vendor/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_host_vendor/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_host_vendor/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_host_ip\">IP</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_host_ip/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_host_ip/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_host_ip/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_maintenance_mode\">Maintenance mode</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_maintenance_mode/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_maintenance_mode/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_maintenance_mode/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_max_physical_devices\">Max Physical Devices</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_max_physical_devices/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_max_physical_devices/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_max_physical_devices/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_max_virtual_machines\">Max Virtual Machines</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_max_virtual_machines/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_max_virtual_machines/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_max_virtual_machines/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_naa_identifier\">NAA Identifier</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_naa_identifier/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_naa_identifier/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_naa_identifier/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_host_password\">Password</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_host_password/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_host_password/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_host_password/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_physical_memory\">Physical Memory</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_physical_memory/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_physical_memory/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_physical_memory/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_reboot_required\">Reboot Required</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_reboot_required/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_reboot_required/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_reboot_required/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_segment_size\">Segment Size</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_segment_size/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_segment_size/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_segment_size/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_software_on_host\">Software on host</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_software_on_host/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_software_on_host/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_software_on_host/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_total_segments\">Total Segments</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_total_segments/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_total_segments/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_total_segments/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_total_size\">Total Size</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_total_size/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_total_size/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_total_size/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_host_username\">Username</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_host_username/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_host_username/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_host_username/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_vib_version\">VIB Version</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_vib_version/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_vib_version/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_vib_version/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/fields/field_vmotion\">VMotion</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/fields/field_vmotion/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_vmotion/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/host/fields/field_vmotion/delete\">Delete</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/host/display\">Manage display</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/host/display/teaser\">Teaser</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/panel\">Panel</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/panel/delete\">Delete</a></li><li><a href=\"/admin/structure/types/manage/panel/fields\">Manage fields</a></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/panel/display\">Manage display</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/panel/display/teaser\">Teaser</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vcenter\">vCenter</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vcenter/delete\">Delete</a></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vcenter/fields\">Manage fields</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vcenter/fields/body\">Description</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vcenter/fields/body/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vcenter/fields/body/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vcenter/fields/body/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vcenter/fields/field_fmc_uuid\">FMC UUID</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vcenter/fields/field_fmc_uuid/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vcenter/fields/field_fmc_uuid/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vcenter/fields/field_fmc_uuid/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vcenter/fields/field_hostname\">Hostname</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vcenter/fields/field_hostname/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vcenter/fields/field_hostname/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vcenter/fields/field_hostname/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vcenter/fields/field_ip_address\">IP Address</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vcenter/fields/field_ip_address/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vcenter/fields/field_ip_address/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vcenter/fields/field_ip_address/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vcenter/fields/field_password\">Password</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vcenter/fields/field_password/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vcenter/fields/field_password/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vcenter/fields/field_password/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vcenter/fields/field_rediscover_status\">Rediscover Status</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vcenter/fields/field_rediscover_status/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vcenter/fields/field_rediscover_status/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vcenter/fields/field_rediscover_status/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vcenter/fields/field_username\">Username</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vcenter/fields/field_username/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vcenter/fields/field_username/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vcenter/fields/field_username/delete\">Delete</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vcenter/display\">Manage display</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vcenter/display/teaser\">Teaser</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk\">vDisk</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk/delete\">Delete</a></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk/fields\">Manage fields</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk/fields/field_fa_administration_state\">Administration State</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_fa_administration_state/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_fa_administration_state/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_fa_administration_state/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk/fields/field_fa_cache_mode\">Cache Mode</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_fa_cache_mode/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_fa_cache_mode/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_fa_cache_mode/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk/fields/field_capacity\">Capacity</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_capacity/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_capacity/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_capacity/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk/fields/field_disk_index\">Disk Index</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_disk_index/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_disk_index/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_disk_index/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk/fields/field_freespace\">Freespace</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_freespace/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_freespace/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_freespace/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk/fields/field_vdisk_identifier\">Identifier</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_vdisk_identifier/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_vdisk_identifier/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_vdisk_identifier/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk/fields/field_fa_operational_message\">Operational Message</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_fa_operational_message/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_fa_operational_message/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_fa_operational_message/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk/fields/field_fa_operational_state\">Operational State</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_fa_operational_state/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_fa_operational_state/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_fa_operational_state/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk/fields/field_path\">Path</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_path/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_path/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_path/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk/fields/field_fa_performance_state\">Performance State</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_fa_performance_state/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_fa_performance_state/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_fa_performance_state/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk/fields/field_vdisk_id\">vDisk Id</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_vdisk_id/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_vdisk_id/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_vdisk_id/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk/fields/field_vdisk_name\">vDisk Name</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_vdisk_name/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_vdisk_name/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_vdisk_name/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk/fields/field_vdisk_type\">vDisk Type</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_vdisk_type/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_vdisk_type/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_vdisk_type/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk/fields/field_virtual_machine\">Virtual Machine</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_virtual_machine/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_virtual_machine/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk/fields/field_virtual_machine/delete\">Delete</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk/display\">Manage display</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk/display/teaser\">Teaser</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk_metrics\">vDisk metrics</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk_metrics/delete\">Delete</a></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk_metrics/fields\">Manage fields</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_cache_latency\">Cache latency</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_cache_latency/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_cache_latency/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_cache_latency/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_hit_ops\">Hit Ops</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_hit_ops/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_hit_ops/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_hit_ops/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_hit_rate_pc\">Hit Rate %</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_hit_rate_pc/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_hit_rate_pc/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_hit_rate_pc/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_hits\">Hits</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_hits/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_hits/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_hits/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_insertion_rate_pc\">Insertion rate %</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_insertion_rate_pc/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_insertion_rate_pc/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_insertion_rate_pc/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_insertions\">Insertions</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_insertions/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_insertions/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_insertions/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_population\">Population</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_population/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_population/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_population/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_population_pc\">Population %</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_population_pc/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_population_pc/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_population_pc/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_read_blocks\">Read blocks</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_read_blocks/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_read_blocks/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_read_blocks/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_read_latency\">Read latency</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_read_latency/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_read_latency/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_read_latency/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_read_ops\">Read ops</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_read_ops/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_read_ops/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_read_ops/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_timestamp\">Timestamp</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_timestamp/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_timestamp/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_timestamp/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_usable_blocks\">Usable blocks</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_usable_blocks/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_usable_blocks/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_usable_blocks/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk\">vDisk</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_write_blocks\">Write blocks</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_write_blocks/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_write_blocks/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_write_blocks/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_write_latency\">Write latency</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_write_latency/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_write_latency/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_write_latency/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_write_ops\">Write ops</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_write_ops/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_write_ops/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vdisk_metrics/fields/field_vdisk_write_ops/delete\">Delete</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vdisk_metrics/display\">Manage display</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vdisk_metrics/display/teaser\">Teaser</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine\">Virtual Machine</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/delete\">Delete</a></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields\">Manage fields</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_administration_state\">Administration State</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_administration_state/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_administration_state/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_administration_state/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_build_version\">Build Version</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_build_version/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_build_version/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_build_version/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_cache_mode\">Cache Mode</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_cache_mode/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_cache_mode/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_cache_mode/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_cache_size\">Cache Size</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_cache_size/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_cache_size/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_cache_size/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_cachespace\">Cachespace</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_cachespace/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_cachespace/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_cachespace/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_cpu_usage\">CPU Usage</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_cpu_usage/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_cpu_usage/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_cpu_usage/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_driver_status\">Driver Status</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_driver_status/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_driver_status/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_driver_status/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_generation_id\">Generation ID</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_generation_id/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_generation_id/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_generation_id/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_guest_id\">Guest ID</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_guest_id/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_guest_id/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_guest_id/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_guest_memory_usage\">Guest Memory Usage</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_guest_memory_usage/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_guest_memory_usage/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_guest_memory_usage/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_guest_os\">Guest OS</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_guest_os/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_guest_os/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_guest_os/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_host\">Host</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_host/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_host/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_host/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_host_memory_usage\">Host Memory Usage</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_host_memory_usage/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_host_memory_usage/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_host_memory_usage/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_hostname\">Hostname</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_hostname/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_hostname/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_hostname/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_install_port\">Install Port</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_install_port/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_install_port/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_install_port/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_ip_address\">IP Address</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_ip_address/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_ip_address/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_ip_address/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_memory_size\">Memory Size</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_memory_size/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_memory_size/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_memory_size/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_metrics_reset_interval\">Metrics Reset Interval</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_metrics_reset_interval/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_metrics_reset_interval/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_metrics_reset_interval/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_no_of_cpu\">no_of_cpu</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_no_of_cpu/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_no_of_cpu/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_no_of_cpu/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_operational_message\">Operational Message</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_operational_message/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_operational_message/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_operational_message/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_operational_state\">Operational State</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_operational_state/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_operational_state/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_operational_state/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_password\">Password</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_password/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_password/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_password/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_performance_state\">Performance State</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_performance_state/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_performance_state/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_performance_state/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_sector_size\">Sector Size</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_sector_size/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_sector_size/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_sector_size/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_template\">Template</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_template/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_template/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_template/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_usable_blocks\">Usable Blocks</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_usable_blocks/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_usable_blocks/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_fa_usable_blocks/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_username\">Username</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_username/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_username/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_username/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_virtual_disks\">virtual_disks</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_virtual_disks/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_virtual_disks/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_virtual_disks/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_vmotionable\">V Motionable</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_vmotionable/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_vmotionable/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_vmotionable/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_path_name\">VM Path Name</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_path_name/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_path_name/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_path_name/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_vmotion_hostlist\">VM vMotion Hostlist</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_vmotion_hostlist/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_vmotion_hostlist/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_vmotion_hostlist/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_vmotion_policy\">VM vMotion Policy</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_vmotion_policy/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_vmotion_policy/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vm_vmotion_policy/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vmware_tools\">VMware Tools</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vmware_tools/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vmware_tools/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/virtual_machine/fields/field_vmware_tools/delete\">Delete</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/virtual_machine/display\">Manage display</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/virtual_machine/display/teaser\">Teaser</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_cache_space\">VM Cache Space</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vm_cache_space/delete\">Delete</a></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_cache_space/fields\">Manage fields</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_cache_space/fields/field_cache_allocated_to_vm\">Allocated to Virtual Machine</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vm_cache_space/fields/field_cache_allocated_to_vm/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vm_cache_space/fields/field_cache_allocated_to_vm/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vm_cache_space/fields/field_cache_allocated_to_vm/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_cache_space/fields/field_cache_assigned_from_host\">Assigned from Host</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vm_cache_space/fields/field_cache_assigned_from_host/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vm_cache_space/fields/field_cache_assigned_from_host/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vm_cache_space/fields/field_cache_assigned_from_host/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_cache_space/fields/field_vm_cache_size\">Cache Size</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vm_cache_space/fields/field_vm_cache_size/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vm_cache_space/fields/field_vm_cache_size/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vm_cache_space/fields/field_vm_cache_size/delete\">Delete</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_cache_space/display\">Manage display</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vm_cache_space/display/teaser\">Teaser</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_metrics\">VM metrics</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vm_metrics/delete\">Delete</a></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_metrics/fields\">Manage fields</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_cache_latency\">Cache latency</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_cache_latency/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_cache_latency/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_cache_latency/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_hit_rate_pc\">Hit Rate %</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_hit_rate_pc/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_hit_rate_pc/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_hit_rate_pc/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_hits\">Hits</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_hits/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_hits/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_hits/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_insertion_rate_pc\">Insertion rate %</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_insertion_rate_pc/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_insertion_rate_pc/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_insertion_rate_pc/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_insertions\">Insertions</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_insertions/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_insertions/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_insertions/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_population\">Population</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_population/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_population/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_population/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_population_pc\">Population %</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_population_pc/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_population_pc/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_population_pc/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_read_blocks\">Read blocks</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_read_blocks/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_read_blocks/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_read_blocks/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_read_latency\">Read latency</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_read_latency/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_read_latency/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_read_latency/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_read_ops\">Read ops</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_read_ops/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_read_ops/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_read_ops/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_timestamp\">Timestamp</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_timestamp/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_timestamp/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_timestamp/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_usable_blocks\">Usable blocks</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_usable_blocks/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_usable_blocks/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_usable_blocks/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm\">VM</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_write_blocks\">Write blocks</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_write_blocks/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_write_blocks/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_write_blocks/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_write_latency\">Write latency</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_write_latency/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_write_latency/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_write_latency/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_write_ops\">Write ops</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_write_ops/field-settings\">Field settings</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_write_ops/widget-type\">Widget type</a></li><li><a href=\"/admin/structure/types/manage/vm_metrics/fields/field_vm_write_ops/delete\">Delete</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/types/manage/vm_metrics/display\">Manage display</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/types/manage/vm_metrics/display/teaser\">Teaser</a></li></ul></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/ctools-content\">Custom content panes</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/ctools-content/add\">Add</a></li><li><a href=\"/admin/structure/ctools-content/import\">Import</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/menu\">Menus</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/menu/add\">Add menu</a></li><li class=\"expandable\"><a href=\"/admin/structure/menu/manage/menu-bulk-action-tool\">Bulk Action Tool</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/menu/manage/menu-bulk-action-tool/add\">Add link</a></li><li><a href=\"/admin/structure/menu/manage/menu-bulk-action-tool/delete\">Delete menu</a></li><li><a href=\"/admin/structure/menu/manage/menu-bulk-action-tool/edit\">Edit menu</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/menu/manage/main-menu\">Main menu</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/menu/manage/main-menu/add\">Add link</a></li><li><a href=\"/admin/structure/menu/manage/main-menu/delete\">Delete menu</a></li><li><a href=\"/admin/structure/menu/manage/main-menu/edit\">Edit menu</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/menu/manage/management\">Management</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/menu/manage/management/add\">Add link</a></li><li><a href=\"/admin/structure/menu/manage/management/delete\">Delete menu</a></li><li><a href=\"/admin/structure/menu/manage/management/edit\">Edit menu</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/menu/manage/navigation\">Navigation</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/menu/manage/navigation/add\">Add link</a></li><li><a href=\"/admin/structure/menu/manage/navigation/delete\">Delete menu</a></li><li><a href=\"/admin/structure/menu/manage/navigation/edit\">Edit menu</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/menu/manage/menu-mercury-navigation\">Navigation</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/menu/manage/menu-mercury-navigation/add\">Add link</a></li><li><a href=\"/admin/structure/menu/manage/menu-mercury-navigation/delete\">Delete menu</a></li><li><a href=\"/admin/structure/menu/manage/menu-mercury-navigation/edit\">Edit menu</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/menu/manage/menu-refine\">Refine</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/menu/manage/menu-refine/add\">Add link</a></li><li><a href=\"/admin/structure/menu/manage/menu-refine/delete\">Delete menu</a></li><li><a href=\"/admin/structure/menu/manage/menu-refine/edit\">Edit menu</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/menu/manage/menu-selector-tool\">Selector Tool</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/menu/manage/menu-selector-tool/add\">Add link</a></li><li><a href=\"/admin/structure/menu/manage/menu-selector-tool/delete\">Delete menu</a></li><li><a href=\"/admin/structure/menu/manage/menu-selector-tool/edit\">Edit menu</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/menu/manage/user-menu\">User menu</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/menu/manage/user-menu/add\">Add link</a></li><li><a href=\"/admin/structure/menu/manage/user-menu/delete\">Delete menu</a></li><li><a href=\"/admin/structure/menu/manage/user-menu/edit\">Edit menu</a></li></ul></li><li><a href=\"/admin/structure/menu/settings\">Settings</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/mini-panels\">Mini panels</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/mini-panels/add\">Add</a></li><li><a href=\"/admin/structure/mini-panels/import\">Import</a></li><li><a href=\"/admin/structure/mini-panels/settings\">Settings</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/pages\">Pages</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/pages/add\">Add custom page</a></li><li><a href=\"/admin/structure/pages/import\">Import page</a></li><li><a href=\"/admin/structure/pages/wizard\">Wizards</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/panels\">Panels</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/admin/structure/panels/layouts\">Layouts</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/panels/layouts/add-flexible\">Add flexible layout</a></li><li><a href=\"/admin/structure/panels/layouts/import\">Import</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/panels/settings\">Settings</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/panels/settings/panel-page\">Panel pages</a></li><li><a href=\"/admin/structure/panels/settings/panels-mini\">Mini panels</a></li><li><a href=\"/admin/structure/panels/settings/panel-node\">Panel nodes</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/taxonomy\">Taxonomy</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/taxonomy/add\">Add vocabulary</a></li><li class=\"expandable\"><a href=\"/admin/structure/taxonomy/tags\">Tags</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/taxonomy/tags/add\">Add term</a></li><li><a href=\"/admin/structure/taxonomy/tags/edit\">Edit</a></li><li><a href=\"/admin/structure/taxonomy/tags/fields\">Manage fields</a></li><li><a href=\"/admin/structure/taxonomy/tags/display\">Manage display</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/structure/views\">Views</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/views/add\">Add new view</a></li><li><a href=\"/admin/structure/views/add-template\">Add view from template</a></li><li><a href=\"/admin/structure/views/import\">Import</a></li><li><a href=\"/admin/structure/views/view/all_host\">all_host (Content)</a></li><li><a href=\"/admin/structure/views/view/all_vm\">all_vm (Content)</a></li><li><a href=\"/admin/structure/views/view/console_log_reports\">Console Logs Report (Watchdog entry)</a></li><li><a href=\"/admin/structure/views/view/devices\">Devices (Content)</a></li><li><a href=\"/admin/structure/views/view/ongoing_processes\">Ongoing Processes (Content)</a></li><li class=\"expandable\"><a href=\"/admin/structure/views/settings\">Settings</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/structure/views/settings/advanced\">Advanced</a></li></ul></li><li><a href=\"/admin/structure/views/view/vdisk_metric_per_vm\">vDisk metric per VM (Content)</a></li><li><a href=\"/admin/structure/views/view/vm_metric_per_host\">VM metric per Host (Content)</a></li><li><a href=\"/admin/structure/views/view/vm_metrics\">VM metrics (Content)</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/appearance\">Appearance</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/admin/appearance/settings\">Settings</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/appearance/settings/bartik\">Bartik</a></li><li><a href=\"/admin/appearance/settings/mercury\">Mercury</a></li><li><a href=\"/admin/appearance/settings/seven\">Seven</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/people\">People</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/people/create\">Add user</a></li><li class=\"expandable\"><a href=\"/admin/people/permissions\">Permissions</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/people/permissions/roles\">Roles</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/modules\">Modules</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/modules/uninstall\">Uninstall</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/config\">Configuration</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/admin/config/administration\">Administration</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/config/administration/admin_menu\">Administration menu</a></li></ul></li><li><a href=\"/admin/config/clear_variables\">Clear Console Variables</a></li><li><a href=\"/admin/config/famc_analytics/clear_metrics\">Clear Flash Accel metrics</a></li><li class=\"expandable\"><a href=\"/admin/config/content\">Content authoring</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/admin/config/content/formats\">Text formats</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/config/content/formats/add\">Add text format</a></li><li class=\"expandable\"><a href=\"/admin/config/content/formats/filtered_html\">Filtered HTML</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/config/content/formats/filtered_html/disable\">Disable text format</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/config/content/formats/full_html\">Full HTML</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/config/content/formats/full_html/disable\">Disable text format</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/config/content/formats/php_code\">PHP code</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/config/content/formats/php_code/disable\">Disable text format</a></li></ul></li><li><a href=\"/admin/config/content/formats/plain_text\">Plain text</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/config/date\">Date API</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/config/date/date_popup\">Date Popup</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/config/development\">Development</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/config/development/performance\">Performance</a></li><li><a href=\"/admin/config/development/logging\">Logging and errors</a></li><li><a href=\"/admin/config/development/maintenance\">Maintenance mode</a></li><li><a href=\"/admin/config/development/coder\">Coder</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/config/media\">Media</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/config/media/file-system\">File system</a></li><li><a href=\"/admin/config/media/image-toolkit\">Image toolkit</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/config/people\">People</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/admin/config/people/accounts\">Account settings</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/config/people/accounts/fields\">Manage fields</a></li><li><a href=\"/admin/config/people/accounts/display\">Manage display</a></li></ul></li><li><a href=\"/admin/config/people/ip-blocking\">IP address blocking</a></li><li class=\"expandable\"><a href=\"/admin/config/people/login-destination\">Login destinations</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/config/people/login-destination/add\">Add login destination rule</a></li><li><a href=\"/admin/config/people/login-destination/settings\">Settings</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/config/regional\">Regional and language</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/config/regional/settings\">Regional settings</a></li><li class=\"expandable\"><a href=\"/admin/config/regional/date-time\">Date and time</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/admin/config/regional/date-time/formats\">Formats</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/config/regional/date-time/formats/add\">Add format</a></li></ul></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/config/search\">Search and metadata</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/config/search/settings\">Search settings</a></li><li class=\"expandable\"><a href=\"/admin/config/search/path\">URL aliases</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/config/search/path/add\">Add alias</a></li><li><a href=\"/admin/config/search/path/patterns\">Patterns</a></li><li><a href=\"/admin/config/search/path/settings\">Settings</a></li><li><a href=\"/admin/config/search/path/update_bulk\">Bulk update</a></li><li><a href=\"/admin/config/search/path/delete_bulk\">Delete aliases</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/config/search/search_api\">Search API</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/config/search/search_api/add_server\">Add server</a></li><li><a href=\"/admin/config/search/search_api/add_index\">Add index</a></li><li class=\"expandable\"><a href=\"/admin/config/search/search_api/page\">Search pages</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/config/search/search_api/page/add\">Add search page</a></li></ul></li></ul></li><li><a href=\"/admin/config/search/clean-urls\">Clean URLs</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/config/system\">System</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/config/system/site-information\">Site information</a></li><li><a href=\"/admin/config/system/actions\">Actions</a></li><li><a href=\"/admin/config/system/logintoboggan\">LoginToboggan</a></li><li><a href=\"/admin/config/system/cron\">Cron</a></li></ul></li><li class=\"expandable\"><a href=\"/admin/config/user-interface\">User interface</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/config/user-interface/modulefilter\">Module filter</a></li><li class=\"expandable\"><a href=\"/admin/config/user-interface/shortcut\">Shortcuts</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/config/user-interface/shortcut/add-set\">Add shortcut set</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/config/services\">Web services</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/config/services/rss-publishing\">RSS publishing</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/admin/reports\">Reports</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/reports/status\">Status report</a></li><li><a href=\"/admin/reports/dblog\" class=\"active\">Recent log messages</a></li><li class=\"expandable\"><a href=\"/admin/reports/fields\">Field list</a>\n<ul class=\"dropdown\"><li><a href=\"/admin/reports/fields/views-fields\">Used in views</a></li></ul></li><li><a href=\"/admin/reports/access-denied\">Top &#039;access denied&#039; errors</a></li><li><a href=\"/admin/reports/page-not-found\">Top &#039;page not found&#039; errors</a></li><li><a href=\"/admin/reports/search\">Top search phrases</a></li><li><a href=\"/admin/reports/views-plugins\">Views plugins</a></li></ul></li><li><a href=\"/admin/help\">Help</a></li></ul>\n<ul class=\"dropdown\"><li class=\"admin-menu-action\"><a href=\"/user/logout\">Log out</a></li><li class=\"admin-menu-action admin-menu-account\"><a href=\"/users/fmcadmin\">fmcadmin</a></li><li class=\"admin-menu-action admin-menu-users\"><a href=\"/admin/people/people\">0 / 1</a></li></ul></div></div>',0,1371656313,0),('links:main-menu:page:admin/reports/dblog:en:1:1','a:4:{s:9:\"min_depth\";i:1;s:9:\"max_depth\";i:1;s:8:\"expanded\";a:1:{i:0;i:0;}s:12:\"active_trail\";a:1:{i:0;i:0;}}',0,1371656313,1),('links:main-menu:tree-data:en:9ec01ec58bf82a695e4acd636af283e0585fe8cd8a6e54eb140188a3e284ab1c','a:2:{s:4:\"tree\";a:1:{i:218;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"218\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:7:\"<front>\";s:11:\"router_path\";s:0:\"\";s:10:\"link_title\";s:4:\"Home\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"1\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:3:\"218\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";N;s:16:\"to_arg_functions\";N;s:15:\"access_callback\";N;s:16:\"access_arguments\";N;s:13:\"page_callback\";N;s:14:\"page_arguments\";N;s:17:\"delivery_callback\";N;s:10:\"tab_parent\";N;s:8:\"tab_root\";N;s:5:\"title\";N;s:14:\"title_callback\";N;s:15:\"title_arguments\";N;s:14:\"theme_callback\";N;s:15:\"theme_arguments\";N;s:4:\"type\";N;s:11:\"description\";N;s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}s:10:\"node_links\";a:0:{}}',0,1371656313,1),('links:user-menu:page:admin/reports/dblog:en:1:1','a:4:{s:9:\"min_depth\";i:1;s:9:\"max_depth\";i:1;s:8:\"expanded\";a:1:{i:0;i:0;}s:12:\"active_trail\";a:1:{i:0;i:0;}}',0,1371656313,1),('links:user-menu:tree-data:en:9ec01ec58bf82a695e4acd636af283e0585fe8cd8a6e54eb140188a3e284ab1c','a:2:{s:4:\"tree\";a:2:{i:2;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"user-menu\";s:4:\"mlid\";s:1:\"2\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:4:\"user\";s:11:\"router_path\";s:4:\"user\";s:10:\"link_title\";s:12:\"User account\";s:7:\"options\";s:22:\"a:1:{s:5:\"alter\";b:1;}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"2\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:35:\"mercury_utilities_user_access_check\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:9:\"user_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:4:\"user\";s:5:\"title\";s:12:\"User account\";s:14:\"title_callback\";s:15:\"user_menu_title\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:15;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"user-menu\";s:4:\"mlid\";s:2:\"15\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:11:\"user/logout\";s:11:\"router_path\";s:11:\"user/logout\";s:10:\"link_title\";s:7:\"Log out\";s:7:\"options\";s:22:\"a:1:{s:5:\"alter\";b:1;}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:2:\"15\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:17:\"user_is_logged_in\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:11:\"user_logout\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:11:\"user/logout\";s:5:\"title\";s:7:\"Log out\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}s:10:\"node_links\";a:0:{}}',0,1371656313,1),('links:management:page:admin/reports/dblog:en:1:0:trail','a:5:{s:9:\"min_depth\";i:1;s:9:\"max_depth\";N;s:17:\"only_active_trail\";b:1;s:8:\"expanded\";a:4:{i:0;i:0;i:1;s:1:\"1\";i:19;s:2:\"19\";i:50;s:2:\"50\";}s:12:\"active_trail\";a:4:{i:0;i:0;i:1;s:1:\"1\";i:19;s:2:\"19\";i:50;s:2:\"50\";}}',0,1371656313,1),('links:management:tree-data:en:1748fbf3089600807f4bc7ab9e40005e2ac8c10e1d4c16c14a254c1df02e73fe','a:2:{s:4:\"tree\";a:1:{i:1;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:1:\"1\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:5:\"admin\";s:11:\"router_path\";s:5:\"admin\";s:10:\"link_title\";s:14:\"Administration\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"9\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:5:\"admin\";s:5:\"title\";s:14:\"Administration\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:1;}s:5:\"below\";a:11:{i:7;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:1:\"7\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:16:\"admin/appearance\";s:11:\"router_path\";s:16:\"admin/appearance\";s:10:\"link_title\";s:10:\"Appearance\";s:7:\"options\";s:83:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Select and configure your themes.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-6\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"7\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer themes\";}\";s:13:\"page_callback\";s:18:\"system_themes_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:16:\"admin/appearance\";s:5:\"title\";s:10:\"Appearance\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:33:\"Select and configure your themes.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:8;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:1:\"8\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:12:\"admin/config\";s:11:\"router_path\";s:12:\"admin/config\";s:10:\"link_title\";s:13:\"Configuration\";s:7:\"options\";s:70:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"Administer settings.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:24:\"system_admin_config_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:12:\"admin/config\";s:5:\"title\";s:13:\"Configuration\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:20:\"Administer settings.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:9;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:1:\"9\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:13:\"admin/content\";s:11:\"router_path\";s:13:\"admin/content\";s:10:\"link_title\";s:7:\"Content\";s:7:\"options\";s:82:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:32:\"Administer content and comments.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"9\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:41:\"a:1:{i:0;s:23:\"access content overview\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:36:\"a:1:{i:0;s:18:\"node_admin_content\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:13:\"admin/content\";s:5:\"title\";s:7:\"Content\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:32:\"Administer content and comments.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:11;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"11\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:15:\"admin/dashboard\";s:11:\"router_path\";s:15:\"admin/dashboard\";s:10:\"link_title\";s:9:\"Dashboard\";s:7:\"options\";s:84:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"View and customize your dashboard.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-15\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"11\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"access dashboard\";}\";s:13:\"page_callback\";s:15:\"dashboard_admin\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/dashboard\";s:5:\"title\";s:9:\"Dashboard\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:34:\"View and customize your dashboard.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:12;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"12\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:10:\"admin/help\";s:11:\"router_path\";s:10:\"admin/help\";s:10:\"link_title\";s:4:\"Help\";s:7:\"options\";s:98:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:48:\"Reference for usage, configuration, and modules.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"9\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_main\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:10:\"admin/help\";s:5:\"title\";s:4:\"Help\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:48:\"Reference for usage, configuration, and modules.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:13;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"13\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:11:\"admin/index\";s:11:\"router_path\";s:11:\"admin/index\";s:10:\"link_title\";s:5:\"Index\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-18\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"13\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:18:\"system_admin_index\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:5:\"admin\";s:8:\"tab_root\";s:5:\"admin\";s:5:\"title\";s:5:\"Index\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:16;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"16\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:13:\"admin/modules\";s:11:\"router_path\";s:13:\"admin/modules\";s:10:\"link_title\";s:7:\"Modules\";s:7:\"options\";s:76:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:26:\"Extend site functionality.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-2\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"16\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer modules\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:32:\"a:1:{i:0;s:14:\"system_modules\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:13:\"admin/modules\";s:5:\"title\";s:7:\"Modules\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:26:\"Extend site functionality.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:18;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"18\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:12:\"admin/people\";s:11:\"router_path\";s:12:\"admin/people\";s:10:\"link_title\";s:6:\"People\";s:7:\"options\";s:95:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Manage user accounts, roles, and permissions.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-4\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer users\";}\";s:13:\"page_callback\";s:10:\"user_admin\";s:14:\"page_arguments\";s:21:\"a:1:{i:0;s:4:\"list\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:12:\"admin/people\";s:5:\"title\";s:6:\"People\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:45:\"Manage user accounts, roles, and permissions.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:19;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"19\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:13:\"admin/reports\";s:11:\"router_path\";s:13:\"admin/reports\";s:10:\"link_title\";s:7:\"Reports\";s:7:\"options\";s:84:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"View reports, updates, and errors.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"5\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"19\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"access site reports\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:13:\"admin/reports\";s:5:\"title\";s:7:\"Reports\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:34:\"View reports, updates, and errors.\";s:15:\"in_active_trail\";b:1;}s:5:\"below\";a:8:{i:42;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"42\";s:4:\"plid\";s:2:\"19\";s:9:\"link_path\";s:20:\"admin/reports/fields\";s:11:\"router_path\";s:20:\"admin/reports/fields\";s:10:\"link_title\";s:10:\"Field list\";s:7:\"options\";s:89:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:39:\"Overview of fields on all entity types.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"19\";s:2:\"p3\";s:2:\"42\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:20:\"field_ui_fields_list\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:20:\"admin/reports/fields\";s:5:\"title\";s:10:\"Field list\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:39:\"Overview of fields on all entity types.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:50;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"50\";s:4:\"plid\";s:2:\"19\";s:9:\"link_path\";s:19:\"admin/reports/dblog\";s:11:\"router_path\";s:19:\"admin/reports/dblog\";s:10:\"link_title\";s:19:\"Recent log messages\";s:7:\"options\";s:93:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"View events that have recently been logged.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-1\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"19\";s:2:\"p3\";s:2:\"50\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"access site reports\";}\";s:13:\"page_callback\";s:14:\"dblog_overview\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"admin/reports/dblog\";s:5:\"title\";s:19:\"Recent log messages\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:43:\"View events that have recently been logged.\";s:15:\"in_active_trail\";b:1;}s:5:\"below\";a:0:{}}i:55;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"55\";s:4:\"plid\";s:2:\"19\";s:9:\"link_path\";s:20:\"admin/reports/status\";s:11:\"router_path\";s:20:\"admin/reports/status\";s:10:\"link_title\";s:13:\"Status report\";s:7:\"options\";s:124:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:74:\"Get a status report about your site\'s operation and any detected problems.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-60\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"19\";s:2:\"p3\";s:2:\"55\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:13:\"system_status\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:20:\"admin/reports/status\";s:5:\"title\";s:13:\"Status report\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:74:\"Get a status report about your site\'s operation and any detected problems.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:58;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"58\";s:4:\"plid\";s:2:\"19\";s:9:\"link_path\";s:27:\"admin/reports/access-denied\";s:11:\"router_path\";s:27:\"admin/reports/access-denied\";s:10:\"link_title\";s:26:\"Top \'access denied\' errors\";s:7:\"options\";s:85:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:35:\"View \'access denied\' errors (403s).\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"19\";s:2:\"p3\";s:2:\"58\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"access site reports\";}\";s:13:\"page_callback\";s:9:\"dblog_top\";s:14:\"page_arguments\";s:31:\"a:1:{i:0;s:13:\"access denied\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:27:\"admin/reports/access-denied\";s:5:\"title\";s:26:\"Top \'access denied\' errors\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:35:\"View \'access denied\' errors (403s).\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:59;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"59\";s:4:\"plid\";s:2:\"19\";s:9:\"link_path\";s:28:\"admin/reports/page-not-found\";s:11:\"router_path\";s:28:\"admin/reports/page-not-found\";s:10:\"link_title\";s:27:\"Top \'page not found\' errors\";s:7:\"options\";s:86:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:36:\"View \'page not found\' errors (404s).\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"19\";s:2:\"p3\";s:2:\"59\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"access site reports\";}\";s:13:\"page_callback\";s:9:\"dblog_top\";s:14:\"page_arguments\";s:32:\"a:1:{i:0;s:14:\"page not found\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:28:\"admin/reports/page-not-found\";s:5:\"title\";s:27:\"Top \'page not found\' errors\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:36:\"View \'page not found\' errors (404s).\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:99;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"99\";s:4:\"plid\";s:2:\"19\";s:9:\"link_path\";s:21:\"admin/reports/event/%\";s:11:\"router_path\";s:21:\"admin/reports/event/%\";s:10:\"link_title\";s:7:\"Details\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"19\";s:2:\"p3\";s:2:\"99\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:12:\"a:1:{i:3;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"access site reports\";}\";s:13:\"page_callback\";s:11:\"dblog_event\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:3;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/reports/event/%\";s:5:\"title\";s:7:\"Details\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:192;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"192\";s:4:\"plid\";s:2:\"19\";s:9:\"link_path\";s:20:\"admin/reports/search\";s:11:\"router_path\";s:20:\"admin/reports/search\";s:10:\"link_title\";s:18:\"Top search phrases\";s:7:\"options\";s:83:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"View most popular search phrases.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"19\";s:2:\"p3\";s:3:\"192\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"access site reports\";}\";s:13:\"page_callback\";s:9:\"dblog_top\";s:14:\"page_arguments\";s:23:\"a:1:{i:0;s:6:\"search\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:20:\"admin/reports/search\";s:5:\"title\";s:18:\"Top search phrases\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:33:\"View most popular search phrases.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:337;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"337\";s:4:\"plid\";s:2:\"19\";s:9:\"link_path\";s:27:\"admin/reports/views-plugins\";s:11:\"router_path\";s:27:\"admin/reports/views-plugins\";s:10:\"link_title\";s:13:\"Views plugins\";s:7:\"options\";s:88:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Overview of plugins used in all views.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"19\";s:2:\"p3\";s:3:\"337\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:20:\"views_ui_plugin_list\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:27:\"admin/reports/views-plugins\";s:5:\"title\";s:13:\"Views plugins\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:38:\"Overview of plugins used in all views.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:21;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"21\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:15:\"admin/structure\";s:11:\"router_path\";s:15:\"admin/structure\";s:10:\"link_title\";s:9:\"Structure\";s:7:\"options\";s:95:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Administer blocks, content types, menus, etc.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-8\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/structure\";s:5:\"title\";s:9:\"Structure\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:45:\"Administer blocks, content types, menus, etc.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:22;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"22\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:11:\"admin/tasks\";s:11:\"router_path\";s:11:\"admin/tasks\";s:10:\"link_title\";s:5:\"Tasks\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-20\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"22\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:5:\"admin\";s:8:\"tab_root\";s:5:\"admin\";s:5:\"title\";s:5:\"Tasks\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}s:10:\"node_links\";a:0:{}}',0,1371656313,1),('links:menu-mercury-navigation:page:config/fmc/settings:en:1:0','a:4:{s:9:\"min_depth\";i:1;s:9:\"max_depth\";N;s:8:\"expanded\";a:2:{i:0;i:0;i:861;s:3:\"861\";}s:12:\"active_trail\";a:2:{i:0;i:0;i:861;s:3:\"861\";}}',0,1371656328,1),('links:menu-mercury-navigation:tree-data:en:5f7b8094def324146ae69923f07a1c74834ae127a6313f832a5cabb89fb411d0','a:2:{s:4:\"tree\";a:10:{i:409;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:23:\"menu-mercury-navigation\";s:4:\"mlid\";s:3:\"409\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:7:\"<front>\";s:11:\"router_path\";s:0:\"\";s:10:\"link_title\";s:9:\"Home Page\";s:7:\"options\";s:89:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:39:\"This links to the home page of the site\";}}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"1\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-50\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"409\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";N;s:16:\"to_arg_functions\";N;s:15:\"access_callback\";N;s:16:\"access_arguments\";N;s:13:\"page_callback\";N;s:14:\"page_arguments\";N;s:17:\"delivery_callback\";N;s:10:\"tab_parent\";N;s:8:\"tab_root\";N;s:5:\"title\";N;s:14:\"title_callback\";N;s:15:\"title_arguments\";N;s:14:\"theme_callback\";N;s:15:\"theme_arguments\";N;s:4:\"type\";N;s:11:\"description\";N;s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:410;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:23:\"menu-mercury-navigation\";s:4:\"mlid\";s:3:\"410\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:12:\"vm-inventory\";s:11:\"router_path\";s:12:\"vm-inventory\";s:10:\"link_title\";s:12:\"VM Inventory\";s:7:\"options\";s:30:\"a:1:{s:10:\"attributes\";a:0:{}}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-48\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"410\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:18:\"ctools_access_menu\";s:16:\"access_arguments\";s:233:\"a:1:{i:0;a:4:{s:5:\"logic\";s:3:\"and\";s:7:\"plugins\";a:1:{i:0;a:4:{s:4:\"name\";s:4:\"role\";s:8:\"settings\";a:1:{s:4:\"rids\";a:2:{i:0;i:2;i:1;i:3;}}s:7:\"context\";s:14:\"logged-in-user\";s:3:\"not\";b:0;}}s:4:\"type\";s:4:\"none\";s:8:\"settings\";N;}}\";s:13:\"page_callback\";s:25:\"page_manager_page_execute\";s:14:\"page_arguments\";s:20:\"a:1:{i:0;s:3:\"all\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:12:\"vm-inventory\";s:5:\"title\";s:2:\"VM\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:411;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:23:\"menu-mercury-navigation\";s:4:\"mlid\";s:3:\"411\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:23:\"config/mercury/settings\";s:11:\"router_path\";s:23:\"config/mercury/settings\";s:10:\"link_title\";s:16:\"Console Settings\";s:7:\"options\";s:30:\"a:1:{s:10:\"attributes\";a:0:{}}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-44\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"411\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";N;s:16:\"to_arg_functions\";N;s:15:\"access_callback\";N;s:16:\"access_arguments\";N;s:13:\"page_callback\";N;s:14:\"page_arguments\";N;s:17:\"delivery_callback\";N;s:10:\"tab_parent\";N;s:8:\"tab_root\";N;s:5:\"title\";N;s:14:\"title_callback\";N;s:15:\"title_arguments\";N;s:14:\"theme_callback\";N;s:15:\"theme_arguments\";N;s:4:\"type\";N;s:11:\"description\";N;s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:412;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:23:\"menu-mercury-navigation\";s:4:\"mlid\";s:3:\"412\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:14:\"host-directory\";s:11:\"router_path\";s:14:\"host-directory\";s:10:\"link_title\";s:14:\"Host Inventory\";s:7:\"options\";s:30:\"a:1:{s:10:\"attributes\";a:0:{}}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-49\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"412\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";N;s:16:\"to_arg_functions\";N;s:15:\"access_callback\";N;s:16:\"access_arguments\";N;s:13:\"page_callback\";N;s:14:\"page_arguments\";N;s:17:\"delivery_callback\";N;s:10:\"tab_parent\";N;s:8:\"tab_root\";N;s:5:\"title\";N;s:14:\"title_callback\";N;s:15:\"title_arguments\";N;s:14:\"theme_callback\";N;s:15:\"theme_arguments\";N;s:4:\"type\";N;s:11:\"description\";N;s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:413;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:23:\"menu-mercury-navigation\";s:4:\"mlid\";s:3:\"413\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:9:\"analytics\";s:11:\"router_path\";s:9:\"analytics\";s:10:\"link_title\";s:9:\"Analytics\";s:7:\"options\";s:30:\"a:1:{s:10:\"attributes\";a:0:{}}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-47\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"413\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:32:\"a:1:{i:0;s:14:\"access content\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:47:\"a:1:{i:0;s:29:\"famc_analytics_analytics_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:9:\"analytics\";s:5:\"title\";s:9:\"Analytics\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:56:\"Form for viewing performance analytics of VMs and Hosts.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:515;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:23:\"menu-mercury-navigation\";s:4:\"mlid\";s:3:\"515\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:17:\"ongoing-processes\";s:11:\"router_path\";s:17:\"ongoing-processes\";s:10:\"link_title\";s:17:\"Ongoing Processes\";s:7:\"options\";s:30:\"a:1:{s:10:\"attributes\";a:0:{}}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-46\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"515\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:18:\"ctools_access_menu\";s:16:\"access_arguments\";s:77:\"a:1:{i:0;a:3:{s:5:\"logic\";s:3:\"and\";s:4:\"type\";s:4:\"none\";s:8:\"settings\";N;}}\";s:13:\"page_callback\";s:25:\"page_manager_page_execute\";s:14:\"page_arguments\";s:35:\"a:1:{i:0;s:17:\"ongoing_processes\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:17:\"ongoing-processes\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"0\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:708;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:23:\"menu-mercury-navigation\";s:4:\"mlid\";s:3:\"708\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:19:\"console-logs-report\";s:11:\"router_path\";s:19:\"console-logs-report\";s:10:\"link_title\";s:12:\"Console Logs\";s:7:\"options\";s:69:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:19:\"Console Logs Report\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-44\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"708\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:12:\"views_access\";s:16:\"access_arguments\";s:89:\"a:1:{i:0;a:2:{i:0;s:17:\"views_check_roles\";i:1;a:1:{i:0;a:2:{i:3;s:1:\"3\";i:2;s:1:\"2\";}}}}\";s:13:\"page_callback\";s:10:\"views_page\";s:14:\"page_arguments\";s:52:\"a:2:{i:0;s:19:\"console_log_reports\";i:1;s:4:\"page\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"console-logs-report\";s:5:\"title\";s:12:\"Console Logs\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:19:\"Console Logs Report\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:824;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:23:\"menu-mercury-navigation\";s:4:\"mlid\";s:3:\"824\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:13:\"http:/fa_help\";s:11:\"router_path\";s:0:\"\";s:10:\"link_title\";s:16:\"Flash Accel Help\";s:7:\"options\";s:56:\"a:1:{s:10:\"attributes\";a:1:{s:6:\"target\";s:6:\"_blank\";}}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"1\";s:8:\"external\";s:1:\"1\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-43\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"824\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";N;s:16:\"to_arg_functions\";N;s:15:\"access_callback\";N;s:16:\"access_arguments\";N;s:13:\"page_callback\";N;s:14:\"page_arguments\";N;s:17:\"delivery_callback\";N;s:10:\"tab_parent\";N;s:8:\"tab_root\";N;s:5:\"title\";N;s:14:\"title_callback\";N;s:15:\"title_arguments\";N;s:14:\"theme_callback\";N;s:15:\"theme_arguments\";N;s:4:\"type\";N;s:11:\"description\";N;s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:836;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:23:\"menu-mercury-navigation\";s:4:\"mlid\";s:3:\"836\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:14:\"host-inventory\";s:11:\"router_path\";s:14:\"host-inventory\";s:10:\"link_title\";s:14:\"Host Inventory\";s:7:\"options\";s:30:\"a:1:{s:10:\"attributes\";a:0:{}}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-49\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"836\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:18:\"ctools_access_menu\";s:16:\"access_arguments\";s:233:\"a:1:{i:0;a:4:{s:5:\"logic\";s:3:\"and\";s:7:\"plugins\";a:1:{i:0;a:4:{s:4:\"name\";s:4:\"role\";s:8:\"settings\";a:1:{s:4:\"rids\";a:2:{i:0;i:2;i:1;i:3;}}s:7:\"context\";s:14:\"logged-in-user\";s:3:\"not\";b:0;}}s:4:\"type\";s:4:\"none\";s:8:\"settings\";N;}}\";s:13:\"page_callback\";s:25:\"page_manager_page_execute\";s:14:\"page_arguments\";s:30:\"a:1:{i:0;s:12:\"mercury_host\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:14:\"host-inventory\";s:5:\"title\";s:4:\"Host\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:861;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:23:\"menu-mercury-navigation\";s:4:\"mlid\";s:3:\"861\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:19:\"config/fmc/settings\";s:11:\"router_path\";s:19:\"config/fmc/settings\";s:10:\"link_title\";s:16:\"Console Settings\";s:7:\"options\";s:30:\"a:1:{s:10:\"attributes\";a:0:{}}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-45\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"861\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"access mercury_utilities\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:57:\"a:1:{i:0;s:39:\"mercury_utilities_vcenter_settings_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"config/fmc/settings\";s:5:\"title\";s:16:\"Console Settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:16:\"Console Settings\";s:15:\"in_active_trail\";b:1;}s:5:\"below\";a:0:{}}}s:10:\"node_links\";a:0:{}}',0,1371656328,1);
/*!40000 ALTER TABLE `cache_menu` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_page`
--

DROP TABLE IF EXISTS `cache_page`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_page` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Cache table used to store compressed pages for anonymous...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_page`
--

LOCK TABLES `cache_page` WRITE;
/*!40000 ALTER TABLE `cache_page` DISABLE KEYS */;
/*!40000 ALTER TABLE `cache_page` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_path`
--

DROP TABLE IF EXISTS `cache_path`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_path` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Cache table for path alias lookup.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_path`
--

LOCK TABLES `cache_path` WRITE;
/*!40000 ALTER TABLE `cache_path` DISABLE KEYS */;
INSERT INTO `cache_path` VALUES ('admin/reports/dblog','a:2:{i:0;s:11:\"user/logout\";i:1;s:6:\"user/1\";}',1371742713,1371656313,1);
/*!40000 ALTER TABLE `cache_path` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_token`
--

DROP TABLE IF EXISTS `cache_token`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_token` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Cache table for token information.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_token`
--

LOCK TABLES `cache_token` WRITE;
/*!40000 ALTER TABLE `cache_token` DISABLE KEYS */;
INSERT INTO `cache_token` VALUES ('field:info','a:142:{s:12:\"comment_body\";a:5:{s:11:\"token types\";a:1:{i:0;s:7:\"comment\";}s:6:\"labels\";a:12:{i:0;s:7:\"Comment\";i:1;s:7:\"Comment\";i:2;s:7:\"Comment\";i:3;s:7:\"Comment\";i:4;s:7:\"Comment\";i:5;s:7:\"Comment\";i:6;s:7:\"Comment\";i:7;s:7:\"Comment\";i:8;s:7:\"Comment\";i:9;s:7:\"Comment\";i:10;s:7:\"Comment\";i:11;s:7:\"Comment\";}s:7:\"bundles\";a:1:{s:7:\"comment\";a:12:{s:17:\"comment_node_page\";s:18:\"Basic page comment\";s:20:\"comment_node_article\";s:15:\"Article comment\";s:20:\"comment_node_vcenter\";s:15:\"vCenter comment\";s:24:\"comment_node_data_center\";s:19:\"Data Center comment\";s:28:\"comment_node_virtual_machine\";s:23:\"Virtual Machine comment\";s:17:\"comment_node_host\";s:12:\"Host comment\";s:19:\"comment_node_device\";s:14:\"Device comment\";s:18:\"comment_node_vdisk\";s:13:\"vDisk comment\";s:18:\"comment_node_panel\";s:13:\"Panel comment\";s:23:\"comment_node_vm_metrics\";s:18:\"VM metrics comment\";s:26:\"comment_node_vdisk_metrics\";s:21:\"vDisk metrics comment\";s:27:\"comment_node_vm_cache_space\";s:22:\"VM Cache Space comment\";}}s:5:\"label\";s:7:\"Comment\";s:11:\"description\";s:16:\"Long text field.\";}s:4:\"body\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:4:{i:0;s:4:\"Body\";i:1;s:4:\"Body\";i:2;s:11:\"Description\";i:3;s:11:\"Description\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:4:{s:4:\"page\";s:10:\"Basic page\";s:7:\"article\";s:7:\"Article\";s:7:\"vcenter\";s:7:\"vCenter\";s:11:\"data_center\";s:11:\"Data Center\";}}s:5:\"label\";s:11:\"Description\";s:11:\"description\";s:77:\"Long text and summary field. Also known as <em class=\"placeholder\">Body</em>.\";}s:10:\"field_tags\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:4:\"Tags\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:7:\"article\";s:7:\"Article\";}}s:5:\"label\";s:4:\"Tags\";s:11:\"description\";s:21:\"Term reference field.\";}s:16:\"field_ip_address\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:10:\"IP Address\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:7:\"vcenter\";s:7:\"vCenter\";}}s:5:\"label\";s:10:\"IP Address\";s:11:\"description\";s:11:\"Text field.\";}s:14:\"field_username\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:8:\"Username\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:7:\"vcenter\";s:7:\"vCenter\";}}s:5:\"label\";s:8:\"Username\";s:11:\"description\";s:11:\"Text field.\";}s:14:\"field_password\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:8:\"Password\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:7:\"vcenter\";s:7:\"vCenter\";}}s:5:\"label\";s:8:\"Password\";s:11:\"description\";s:11:\"Text field.\";}s:19:\"field_vm_ip_address\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:10:\"IP Address\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:10:\"IP Address\";s:11:\"description\";s:11:\"Text field.\";}s:17:\"field_memory_size\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:11:\"Memory Size\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:11:\"Memory Size\";s:11:\"description\";s:11:\"Text field.\";}s:14:\"field_template\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:8:\"Template\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:8:\"Template\";s:11:\"description\";s:11:\"Text field.\";}s:18:\"field_vm_path_name\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:12:\"VM Path Name\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:12:\"VM Path Name\";s:11:\"description\";s:11:\"Text field.\";}s:14:\"field_guest_os\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:8:\"Guest OS\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:8:\"Guest OS\";s:11:\"description\";s:11:\"Text field.\";}s:14:\"field_guest_id\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:8:\"Guest ID\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:8:\"Guest ID\";s:11:\"description\";s:11:\"Text field.\";}s:15:\"field_cpu_usage\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:2:{i:0;s:9:\"CPU Usage\";i:1;s:9:\"CPU Usage\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:2:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:9:\"CPU Usage\";s:11:\"description\";s:11:\"Text field.\";}s:23:\"field_host_memory_usage\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:17:\"Host Memory Usage\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:17:\"Host Memory Usage\";s:11:\"description\";s:11:\"Text field.\";}s:24:\"field_guest_memory_usage\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:18:\"Guest Memory Usage\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:18:\"Guest Memory Usage\";s:11:\"description\";s:11:\"Text field.\";}s:15:\"field_cpu_model\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:9:\"Cpu Model\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:9:\"Cpu Model\";s:11:\"description\";s:11:\"Text field.\";}s:14:\"field_boottime\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:8:\"BootTime\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:8:\"BootTime\";s:11:\"description\";s:11:\"Text field.\";}s:17:\"field_host_status\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:11:\"Host Status\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:11:\"Host Status\";s:11:\"description\";s:11:\"Text field.\";}s:22:\"field_maintenance_mode\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:16:\"Maintenance mode\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:16:\"Maintenance mode\";s:11:\"description\";s:14:\"Integer field.\";}s:21:\"field_physical_memory\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:15:\"Physical Memory\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:15:\"Physical Memory\";s:11:\"description\";s:11:\"Text field.\";}s:13:\"field_vmotion\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:7:\"VMotion\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:7:\"VMotion\";s:11:\"description\";s:14:\"Integer field.\";}s:21:\"field_reboot_required\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:15:\"Reboot Required\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:15:\"Reboot Required\";s:11:\"description\";s:14:\"Integer field.\";}s:15:\"field_serial_no\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:9:\"Serial No\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:9:\"Serial No\";s:11:\"description\";s:11:\"Text field.\";}s:10:\"field_size\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:4:\"Size\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:4:\"Size\";s:11:\"description\";s:11:\"Text field.\";}s:17:\"field_device_type\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:11:\"Device Type\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:11:\"Device Type\";s:11:\"description\";s:11:\"Text field.\";}s:22:\"field_multipath_plugin\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:16:\"Multipath Plugin\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:16:\"Multipath Plugin\";s:11:\"description\";s:11:\"Text field.\";}s:16:\"field_devfs_path\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:10:\"Devfs Path\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:10:\"Devfs Path\";s:11:\"description\";s:11:\"Text field.\";}s:12:\"field_vendor\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:6:\"Vendor\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:6:\"Vendor\";s:11:\"description\";s:11:\"Text field.\";}s:11:\"field_model\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:5:\"Model\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:5:\"Model\";s:11:\"description\";s:11:\"Text field.\";}s:14:\"field_revision\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:8:\"Revision\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:8:\"Revision\";s:11:\"description\";s:11:\"Text field.\";}s:16:\"field_scsi_level\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:10:\"SCSI Level\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:10:\"SCSI Level\";s:11:\"description\";s:11:\"Text field.\";}s:15:\"field_is_pseudo\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:9:\"Is Pseudo\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:9:\"Is Pseudo\";s:11:\"description\";s:18:\"List (text) field.\";}s:12:\"field_status\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:6:\"Status\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:18:\"List (text) field.\";}s:20:\"field_is_rdm_capable\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:14:\"Is RDM Capable\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:14:\"Is RDM Capable\";s:11:\"description\";s:18:\"List (text) field.\";}s:14:\"field_is_local\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:8:\"Is Local\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:8:\"Is Local\";s:11:\"description\";s:18:\"List (text) field.\";}s:18:\"field_is_removable\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:12:\"Is Removable\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:12:\"Is Removable\";s:11:\"description\";s:18:\"List (text) field.\";}s:12:\"field_is_ssd\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:6:\"Is SSD\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:6:\"Is SSD\";s:11:\"description\";s:18:\"List (text) field.\";}s:16:\"field_is_offline\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:10:\"Is Offline\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:10:\"Is Offline\";s:11:\"description\";s:18:\"List (text) field.\";}s:29:\"field_is_perennially_reserved\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:23:\"Is Perennially Reserved\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:23:\"Is Perennially Reserved\";s:11:\"description\";s:18:\"List (text) field.\";}s:30:\"field_thin_provisioning_status\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:24:\"Thin Provisioning Status\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:24:\"Thin Provisioning Status\";s:11:\"description\";s:11:\"Text field.\";}s:22:\"field_attached_filters\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:16:\"Attached Filters\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:16:\"Attached Filters\";s:11:\"description\";s:11:\"Text field.\";}s:17:\"field_vaai_status\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:11:\"VAAI Status\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:11:\"VAAI Status\";s:11:\"description\";s:11:\"Text field.\";}s:16:\"field_other_uids\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:10:\"Other UIDs\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:10:\"Other UIDs\";s:11:\"description\";s:11:\"Text field.\";}s:18:\"field_display_name\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:12:\"Display Name\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:12:\"Display Name\";s:11:\"description\";s:11:\"Text field.\";}s:14:\"field_capacity\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:8:\"Capacity\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:5:\"vdisk\";s:5:\"vDisk\";}}s:5:\"label\";s:8:\"Capacity\";s:11:\"description\";s:11:\"Text field.\";}s:10:\"field_path\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:4:\"Path\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:5:\"vdisk\";s:5:\"vDisk\";}}s:5:\"label\";s:4:\"Path\";s:11:\"description\";s:11:\"Text field.\";}s:15:\"field_freespace\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:9:\"Freespace\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:5:\"vdisk\";s:5:\"vDisk\";}}s:5:\"label\";s:9:\"Freespace\";s:11:\"description\";s:11:\"Text field.\";}s:17:\"field_vm_username\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:8:\"Username\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:8:\"Username\";s:11:\"description\";s:11:\"Text field.\";}s:17:\"field_vm_password\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:8:\"Password\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:8:\"Password\";s:11:\"description\";s:11:\"Text field.\";}s:19:\"field_host_username\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:8:\"Username\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:8:\"Username\";s:11:\"description\";s:11:\"Text field.\";}s:19:\"field_host_password\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:8:\"Password\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:8:\"Password\";s:11:\"description\";s:11:\"Text field.\";}s:19:\"field_driver_status\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:13:\"Driver Status\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:13:\"Driver Status\";s:11:\"description\";s:11:\"Text field.\";}s:19:\"field_bundle_status\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:13:\"Bundle Status\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:13:\"Bundle Status\";s:11:\"description\";s:11:\"Text field.\";}s:21:\"field_related_vcenter\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:15:\"Related vCenter\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:11:\"data_center\";s:11:\"Data Center\";}}s:5:\"label\";s:15:\"Related vCenter\";s:11:\"description\";s:23:\"Entity Reference field.\";}s:21:\"field_virtual_machine\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:15:\"Virtual Machine\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:5:\"vdisk\";s:5:\"vDisk\";}}s:5:\"label\";s:15:\"Virtual Machine\";s:11:\"description\";s:23:\"Entity Reference field.\";}s:18:\"field_related_host\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:12:\"Related Host\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:12:\"Related Host\";s:11:\"description\";s:23:\"Entity Reference field.\";}s:16:\"field_datacenter\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:10:\"Datacenter\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:10:\"Datacenter\";s:11:\"description\";s:23:\"Entity Reference field.\";}s:10:\"field_host\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:4:\"Host\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:4:\"Host\";s:11:\"description\";s:23:\"Entity Reference field.\";}s:18:\"field_vmware_tools\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:12:\"VMware Tools\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:12:\"VMware Tools\";s:11:\"description\";s:11:\"Text field.\";}s:22:\"field_software_on_host\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:16:\"Software on host\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:16:\"Software on host\";s:11:\"description\";s:11:\"Text field.\";}s:8:\"field_vm\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:2:\"VM\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:10:\"vm_metrics\";s:10:\"VM metrics\";}}s:5:\"label\";s:2:\"VM\";s:11:\"description\";s:23:\"Entity Reference field.\";}s:24:\"field_allocated_segments\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:18:\"Allocated Segments\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:18:\"Allocated Segments\";s:11:\"description\";s:14:\"Integer field.\";}s:18:\"field_segment_size\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:12:\"Segment Size\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:12:\"Segment Size\";s:11:\"description\";s:14:\"Integer field.\";}s:26:\"field_max_virtual_machines\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:20:\"Max Virtual Machines\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:20:\"Max Virtual Machines\";s:11:\"description\";s:14:\"Integer field.\";}s:26:\"field_max_physical_devices\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:20:\"Max Physical Devices\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:20:\"Max Physical Devices\";s:11:\"description\";s:14:\"Integer field.\";}s:30:\"field_claimed_physical_devices\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:24:\"Claimed Physical Devices\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:24:\"Claimed Physical Devices\";s:11:\"description\";s:14:\"Integer field.\";}s:17:\"field_cache_state\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:11:\"Cache State\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:11:\"Cache State\";s:11:\"description\";s:14:\"Integer field.\";}s:20:\"field_total_segments\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:14:\"Total Segments\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:14:\"Total Segments\";s:11:\"description\";s:14:\"Integer field.\";}s:32:\"field_allocated_virtual_machines\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:26:\"Allocated Virtual Machines\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:26:\"Allocated Virtual Machines\";s:11:\"description\";s:14:\"Integer field.\";}s:17:\"field_vib_version\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:11:\"VIB Version\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:11:\"VIB Version\";s:11:\"description\";s:11:\"Text field.\";}s:16:\"field_total_size\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:10:\"Total Size\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:10:\"Total Size\";s:11:\"description\";s:11:\"Text field.\";}s:20:\"field_naa_identifier\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:14:\"NAA Identifier\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:14:\"NAA Identifier\";s:11:\"description\";s:11:\"Text field.\";}s:20:\"field_allocated_size\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:14:\"Allocated Size\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:14:\"Allocated Size\";s:11:\"description\";s:11:\"Text field.\";}s:18:\"field_device_state\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:12:\"Device State\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:12:\"Device State\";s:11:\"description\";s:14:\"Integer field.\";}s:15:\"field_no_of_cpu\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:9:\"no_of_cpu\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:9:\"no_of_cpu\";s:11:\"description\";s:11:\"Text field.\";}s:19:\"field_virtual_disks\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:13:\"virtual_disks\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:13:\"virtual_disks\";s:11:\"description\";s:11:\"Text field.\";}s:22:\"field_fa_build_version\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:13:\"Build Version\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:13:\"Build Version\";s:11:\"description\";s:11:\"Text field.\";}s:19:\"field_fa_cache_mode\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:2:{i:0;s:10:\"Cache Mode\";i:1;s:10:\"Cache Mode\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:2:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";s:5:\"vdisk\";s:5:\"vDisk\";}}s:5:\"label\";s:10:\"Cache Mode\";s:11:\"description\";s:11:\"Text field.\";}s:29:\"field_fa_administration_state\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:2:{i:0;s:20:\"Administration State\";i:1;s:20:\"Administration State\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:2:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";s:5:\"vdisk\";s:5:\"vDisk\";}}s:5:\"label\";s:20:\"Administration State\";s:11:\"description\";s:11:\"Text field.\";}s:19:\"field_fa_cache_size\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:10:\"Cache Size\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:10:\"Cache Size\";s:11:\"description\";s:11:\"Text field.\";}s:26:\"field_fa_operational_state\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:2:{i:0;s:17:\"Operational State\";i:1;s:17:\"Operational State\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:2:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";s:5:\"vdisk\";s:5:\"vDisk\";}}s:5:\"label\";s:17:\"Operational State\";s:11:\"description\";s:11:\"Text field.\";}s:28:\"field_fa_operational_message\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:2:{i:0;s:19:\"Operational Message\";i:1;s:19:\"Operational Message\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:2:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";s:5:\"vdisk\";s:5:\"vDisk\";}}s:5:\"label\";s:19:\"Operational Message\";s:11:\"description\";s:11:\"Text field.\";}s:26:\"field_fa_performance_state\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:2:{i:0;s:17:\"Performance State\";i:1;s:17:\"Performance State\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:2:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";s:5:\"vdisk\";s:5:\"vDisk\";}}s:5:\"label\";s:17:\"Performance State\";s:11:\"description\";s:11:\"Text field.\";}s:22:\"field_fa_generation_id\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:13:\"Generation ID\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:13:\"Generation ID\";s:11:\"description\";s:11:\"Text field.\";}s:21:\"field_vm_read_latency\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:12:\"Read latency\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:10:\"vm_metrics\";s:10:\"VM metrics\";}}s:5:\"label\";s:12:\"Read latency\";s:11:\"description\";s:14:\"Decimal field.\";}s:22:\"field_vm_write_latency\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:13:\"Write latency\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:10:\"vm_metrics\";s:10:\"VM metrics\";}}s:5:\"label\";s:13:\"Write latency\";s:11:\"description\";s:14:\"Decimal field.\";}s:17:\"field_vm_read_ops\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:8:\"Read ops\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:10:\"vm_metrics\";s:10:\"VM metrics\";}}s:5:\"label\";s:8:\"Read ops\";s:11:\"description\";s:14:\"Decimal field.\";}s:18:\"field_vm_write_ops\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:9:\"Write ops\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:10:\"vm_metrics\";s:10:\"VM metrics\";}}s:5:\"label\";s:9:\"Write ops\";s:11:\"description\";s:14:\"Decimal field.\";}s:13:\"field_vm_hits\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:4:\"Hits\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:10:\"vm_metrics\";s:10:\"VM metrics\";}}s:5:\"label\";s:4:\"Hits\";s:11:\"description\";s:14:\"Integer field.\";}s:20:\"field_vm_read_blocks\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:11:\"Read blocks\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:10:\"vm_metrics\";s:10:\"VM metrics\";}}s:5:\"label\";s:11:\"Read blocks\";s:11:\"description\";s:14:\"Integer field.\";}s:22:\"field_vm_cache_latency\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:13:\"Cache latency\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:10:\"vm_metrics\";s:10:\"VM metrics\";}}s:5:\"label\";s:13:\"Cache latency\";s:11:\"description\";s:14:\"Decimal field.\";}s:19:\"field_vm_population\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:10:\"Population\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:10:\"vm_metrics\";s:10:\"VM metrics\";}}s:5:\"label\";s:10:\"Population\";s:11:\"description\";s:14:\"Integer field.\";}s:22:\"field_vm_usable_blocks\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:13:\"Usable blocks\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:10:\"vm_metrics\";s:10:\"VM metrics\";}}s:5:\"label\";s:13:\"Usable blocks\";s:11:\"description\";s:14:\"Integer field.\";}s:21:\"field_vm_write_blocks\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:12:\"Write blocks\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:10:\"vm_metrics\";s:10:\"VM metrics\";}}s:5:\"label\";s:12:\"Write blocks\";s:11:\"description\";s:14:\"Integer field.\";}s:19:\"field_vm_insertions\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:10:\"Insertions\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:10:\"vm_metrics\";s:10:\"VM metrics\";}}s:5:\"label\";s:10:\"Insertions\";s:11:\"description\";s:14:\"Integer field.\";}s:22:\"field_vm_population_pc\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:12:\"Population %\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:10:\"vm_metrics\";s:10:\"VM metrics\";}}s:5:\"label\";s:12:\"Population %\";s:11:\"description\";s:15:\"Computed field.\";}s:26:\"field_vm_insertion_rate_pc\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:16:\"Insertion rate %\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:10:\"vm_metrics\";s:10:\"VM metrics\";}}s:5:\"label\";s:16:\"Insertion rate %\";s:11:\"description\";s:15:\"Computed field.\";}s:11:\"field_vdisk\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:5:\"vDisk\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:13:\"vdisk_metrics\";s:13:\"vDisk metrics\";}}s:5:\"label\";s:5:\"vDisk\";s:11:\"description\";s:23:\"Entity Reference field.\";}s:24:\"field_vdisk_read_latency\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:12:\"Read latency\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:13:\"vdisk_metrics\";s:13:\"vDisk metrics\";}}s:5:\"label\";s:12:\"Read latency\";s:11:\"description\";s:14:\"Decimal field.\";}s:25:\"field_vdisk_write_latency\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:13:\"Write latency\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:13:\"vdisk_metrics\";s:13:\"vDisk metrics\";}}s:5:\"label\";s:13:\"Write latency\";s:11:\"description\";s:14:\"Decimal field.\";}s:20:\"field_vdisk_read_ops\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:8:\"Read ops\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:13:\"vdisk_metrics\";s:13:\"vDisk metrics\";}}s:5:\"label\";s:8:\"Read ops\";s:11:\"description\";s:14:\"Decimal field.\";}s:21:\"field_vdisk_write_ops\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:9:\"Write ops\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:13:\"vdisk_metrics\";s:13:\"vDisk metrics\";}}s:5:\"label\";s:9:\"Write ops\";s:11:\"description\";s:14:\"Decimal field.\";}s:16:\"field_vdisk_hits\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:4:\"Hits\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:13:\"vdisk_metrics\";s:13:\"vDisk metrics\";}}s:5:\"label\";s:4:\"Hits\";s:11:\"description\";s:14:\"Integer field.\";}s:23:\"field_vdisk_read_blocks\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:11:\"Read blocks\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:13:\"vdisk_metrics\";s:13:\"vDisk metrics\";}}s:5:\"label\";s:11:\"Read blocks\";s:11:\"description\";s:14:\"Integer field.\";}s:25:\"field_vdisk_cache_latency\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:13:\"Cache latency\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:13:\"vdisk_metrics\";s:13:\"vDisk metrics\";}}s:5:\"label\";s:13:\"Cache latency\";s:11:\"description\";s:14:\"Decimal field.\";}s:22:\"field_vdisk_population\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:10:\"Population\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:13:\"vdisk_metrics\";s:13:\"vDisk metrics\";}}s:5:\"label\";s:10:\"Population\";s:11:\"description\";s:14:\"Integer field.\";}s:25:\"field_vdisk_usable_blocks\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:13:\"Usable blocks\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:13:\"vdisk_metrics\";s:13:\"vDisk metrics\";}}s:5:\"label\";s:13:\"Usable blocks\";s:11:\"description\";s:14:\"Integer field.\";}s:22:\"field_vdisk_insertions\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:10:\"Insertions\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:13:\"vdisk_metrics\";s:13:\"vDisk metrics\";}}s:5:\"label\";s:10:\"Insertions\";s:11:\"description\";s:14:\"Integer field.\";}s:24:\"field_vdisk_write_blocks\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:12:\"Write blocks\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:13:\"vdisk_metrics\";s:13:\"vDisk metrics\";}}s:5:\"label\";s:12:\"Write blocks\";s:11:\"description\";s:14:\"Integer field.\";}s:15:\"field_timestamp\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:2:{i:0;s:9:\"Timestamp\";i:1;s:9:\"Timestamp\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:2:{s:13:\"vdisk_metrics\";s:13:\"vDisk metrics\";s:10:\"vm_metrics\";s:10:\"VM metrics\";}}s:5:\"label\";s:9:\"Timestamp\";s:11:\"description\";s:28:\"Date (Unix timestamp) field.\";}s:25:\"field_vdisk_population_pc\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:12:\"Population %\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:13:\"vdisk_metrics\";s:13:\"vDisk metrics\";}}s:5:\"label\";s:12:\"Population %\";s:11:\"description\";s:15:\"Computed field.\";}s:29:\"field_vdisk_insertion_rate_pc\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:16:\"Insertion rate %\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:13:\"vdisk_metrics\";s:13:\"vDisk metrics\";}}s:5:\"label\";s:16:\"Insertion rate %\";s:11:\"description\";s:15:\"Computed field.\";}s:16:\"field_disk_index\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:10:\"Disk Index\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:5:\"vdisk\";s:5:\"vDisk\";}}s:5:\"label\";s:10:\"Disk Index\";s:11:\"description\";s:14:\"Integer field.\";}s:16:\"field_cachespace\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:10:\"Cachespace\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:10:\"Cachespace\";s:11:\"description\";s:11:\"Text field.\";}s:22:\"field_vdisk_identifier\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:10:\"Identifier\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:5:\"vdisk\";s:5:\"vDisk\";}}s:5:\"label\";s:10:\"Identifier\";s:11:\"description\";s:11:\"Text field.\";}s:19:\"field_vm_cache_size\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:10:\"Cache Size\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:14:\"vm_cache_space\";s:14:\"VM Cache Space\";}}s:5:\"label\";s:10:\"Cache Size\";s:11:\"description\";s:11:\"Text field.\";}s:30:\"field_cache_assigned_from_host\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:18:\"Assigned from Host\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:14:\"vm_cache_space\";s:14:\"VM Cache Space\";}}s:5:\"label\";s:18:\"Assigned from Host\";s:11:\"description\";s:21:\"Node reference field.\";}s:27:\"field_cache_allocated_to_vm\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:28:\"Allocated to Virtual Machine\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:14:\"vm_cache_space\";s:14:\"VM Cache Space\";}}s:5:\"label\";s:28:\"Allocated to Virtual Machine\";s:11:\"description\";s:21:\"Node reference field.\";}s:18:\"field_install_port\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:12:\"Install Port\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:12:\"Install Port\";s:11:\"description\";s:14:\"Integer field.\";}s:16:\"field_host_model\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:10:\"Host Model\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:10:\"Host Model\";s:11:\"description\";s:11:\"Text field.\";}s:17:\"field_host_vendor\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:11:\"Host Vendor\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:11:\"Host Vendor\";s:11:\"description\";s:11:\"Text field.\";}s:20:\"field_vm_vmotionable\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:12:\"V Motionable\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:12:\"V Motionable\";s:11:\"description\";s:14:\"Boolean field.\";}s:10:\"field_hbtl\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:4:\"HBTL\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:4:\"HBTL\";s:11:\"description\";s:11:\"Text field.\";}s:13:\"field_is_vmfs\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:7:\"Is VMFS\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:6:\"device\";s:6:\"Device\";}}s:5:\"label\";s:7:\"Is VMFS\";s:11:\"description\";s:11:\"Text field.\";}s:22:\"field_fa_usable_blocks\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:13:\"Usable Blocks\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:13:\"Usable Blocks\";s:11:\"description\";s:11:\"Text field.\";}s:16:\"field_vdisk_name\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:10:\"vDisk Name\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:5:\"vdisk\";s:5:\"vDisk\";}}s:5:\"label\";s:10:\"vDisk Name\";s:11:\"description\";s:11:\"Text field.\";}s:16:\"field_vdisk_type\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:10:\"vDisk Type\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:5:\"vdisk\";s:5:\"vDisk\";}}s:5:\"label\";s:10:\"vDisk Type\";s:11:\"description\";s:11:\"Text field.\";}s:14:\"field_vdisk_id\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:8:\"vDisk Id\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:5:\"vdisk\";s:5:\"vDisk\";}}s:5:\"label\";s:8:\"vDisk Id\";s:11:\"description\";s:11:\"Text field.\";}s:13:\"field_host_ip\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:2:\"IP\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:2:\"IP\";s:11:\"description\";s:11:\"Text field.\";}s:13:\"field_hit_ops\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:7:\"Hit Ops\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:13:\"vdisk_metrics\";s:13:\"vDisk metrics\";}}s:5:\"label\";s:7:\"Hit Ops\";s:11:\"description\";s:14:\"Decimal field.\";}s:20:\"field_fa_sector_size\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:11:\"Sector Size\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:11:\"Sector Size\";s:11:\"description\";s:11:\"Text field.\";}s:23:\"field_rediscover_status\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:17:\"Rediscover Status\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:7:\"vcenter\";s:7:\"vCenter\";}}s:5:\"label\";s:17:\"Rediscover Status\";s:11:\"description\";s:11:\"Text field.\";}s:14:\"field_hostname\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:8:\"Hostname\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:7:\"vcenter\";s:7:\"vCenter\";}}s:5:\"label\";s:8:\"Hostname\";s:11:\"description\";s:11:\"Text field.\";}s:17:\"field_vm_hostname\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:8:\"Hostname\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:8:\"Hostname\";s:11:\"description\";s:11:\"Text field.\";}s:31:\"field_fa_metrics_reset_interval\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:22:\"Metrics Reset Interval\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:22:\"Metrics Reset Interval\";s:11:\"description\";s:11:\"Text field.\";}s:14:\"field_fmc_uuid\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:8:\"FMC UUID\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:7:\"vcenter\";s:7:\"vCenter\";}}s:5:\"label\";s:8:\"FMC UUID\";s:11:\"description\";s:11:\"Text field.\";}s:20:\"field_vm_hit_rate_pc\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:10:\"Hit Rate %\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:10:\"vm_metrics\";s:10:\"VM metrics\";}}s:5:\"label\";s:10:\"Hit Rate %\";s:11:\"description\";s:15:\"Computed field.\";}s:23:\"field_vm_vmotion_policy\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:17:\"VM vMotion Policy\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:17:\"VM vMotion Policy\";s:11:\"description\";s:11:\"Text field.\";}s:25:\"field_vm_vmotion_hostlist\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:19:\"VM vMotion Hostlist\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:15:\"virtual_machine\";s:15:\"Virtual Machine\";}}s:5:\"label\";s:19:\"VM vMotion Hostlist\";s:11:\"description\";s:11:\"Text field.\";}s:9:\"field_drs\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:3:\"drs\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:3:\"drs\";s:11:\"description\";s:14:\"Integer field.\";}s:8:\"field_ha\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:2:\"HA\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:4:\"host\";s:4:\"Host\";}}s:5:\"label\";s:2:\"HA\";s:11:\"description\";s:14:\"Integer field.\";}s:23:\"field_vdisk_hit_rate_pc\";a:5:{s:11:\"token types\";a:1:{i:0;s:4:\"node\";}s:6:\"labels\";a:1:{i:0;s:10:\"Hit Rate %\";}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{s:13:\"vdisk_metrics\";s:13:\"vDisk metrics\";}}s:5:\"label\";s:10:\"Hit Rate %\";s:11:\"description\";s:15:\"Computed field.\";}}',0,1371656313,1),('info:en','a:2:{s:6:\"tokens\";a:33:{s:4:\"node\";a:304:{s:29:\"field_fa_administration_state\";a:3:{s:4:\"name\";s:20:\"Administration State\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:29:\"field-fa-administration-state\";a:4:{s:4:\"name\";s:20:\"Administration State\";s:11:\"description\";s:38:\"Field \"field_fa_administration_state\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:24:\"field-allocated-segments\";a:4:{s:4:\"name\";s:18:\"Allocated Segments\";s:11:\"description\";s:33:\"Field \"field_allocated_segments\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:24:\"field_allocated_segments\";a:3:{s:4:\"name\";s:18:\"Allocated Segments\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:20:\"field-allocated-size\";a:4:{s:4:\"name\";s:14:\"Allocated Size\";s:11:\"description\";s:29:\"Field \"field_allocated_size\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:20:\"field_allocated_size\";a:3:{s:4:\"name\";s:14:\"Allocated Size\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:32:\"field_allocated_virtual_machines\";a:3:{s:4:\"name\";s:26:\"Allocated Virtual Machines\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:32:\"field-allocated-virtual-machines\";a:4:{s:4:\"name\";s:26:\"Allocated Virtual Machines\";s:11:\"description\";s:41:\"Field \"field_allocated_virtual_machines\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:27:\"field-cache-allocated-to-vm\";a:4:{s:4:\"name\";s:28:\"Allocated to Virtual Machine\";s:11:\"description\";s:36:\"Field \"field_cache_allocated_to_vm\".\";s:4:\"type\";s:4:\"node\";s:12:\"entity-token\";b:1;}s:27:\"field_cache_allocated_to_vm\";a:3:{s:4:\"name\";s:28:\"Allocated to Virtual Machine\";s:11:\"description\";s:21:\"Node reference field.\";s:6:\"module\";s:5:\"token\";}s:30:\"field_cache_assigned_from_host\";a:3:{s:4:\"name\";s:18:\"Assigned from Host\";s:11:\"description\";s:21:\"Node reference field.\";s:6:\"module\";s:5:\"token\";}s:30:\"field-cache-assigned-from-host\";a:4:{s:4:\"name\";s:18:\"Assigned from Host\";s:11:\"description\";s:39:\"Field \"field_cache_assigned_from_host\".\";s:4:\"type\";s:4:\"node\";s:12:\"entity-token\";b:1;}s:22:\"field-attached-filters\";a:4:{s:4:\"name\";s:16:\"Attached Filters\";s:11:\"description\";s:31:\"Field \"field_attached_filters\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:22:\"field_attached_filters\";a:3:{s:4:\"name\";s:16:\"Attached Filters\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:6:\"author\";a:3:{s:4:\"name\";s:6:\"Author\";s:11:\"description\";s:23:\"The author of the node.\";s:4:\"type\";s:4:\"user\";}s:4:\"body\";a:3:{s:4:\"name\";s:4:\"Body\";s:11:\"description\";s:140:\"The main body text of the node. The following properties may be appended to the token: value (Text), summary (Summary), format (Text format)\";s:7:\"dynamic\";b:1;}s:14:\"field-boottime\";a:4:{s:4:\"name\";s:8:\"BootTime\";s:11:\"description\";s:23:\"Field \"field_boottime\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:14:\"field_boottime\";a:3:{s:4:\"name\";s:8:\"BootTime\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:22:\"field-fa-build-version\";a:4:{s:4:\"name\";s:13:\"Build Version\";s:11:\"description\";s:31:\"Field \"field_fa_build_version\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:22:\"field_fa_build_version\";a:3:{s:4:\"name\";s:13:\"Build Version\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:19:\"field_bundle_status\";a:3:{s:4:\"name\";s:13:\"Bundle Status\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:19:\"field-bundle-status\";a:4:{s:4:\"name\";s:13:\"Bundle Status\";s:11:\"description\";s:28:\"Field \"field_bundle_status\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:15:\"field-cpu-usage\";a:4:{s:4:\"name\";s:9:\"CPU Usage\";s:11:\"description\";s:24:\"Field \"field_cpu_usage\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:15:\"field_cpu_usage\";a:3:{s:4:\"name\";s:9:\"CPU Usage\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:19:\"field-fa-cache-mode\";a:4:{s:4:\"name\";s:10:\"Cache Mode\";s:11:\"description\";s:28:\"Field \"field_fa_cache_mode\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:19:\"field_fa_cache_mode\";a:3:{s:4:\"name\";s:10:\"Cache Mode\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:19:\"field_fa_cache_size\";a:3:{s:4:\"name\";s:10:\"Cache Size\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:19:\"field_vm_cache_size\";a:3:{s:4:\"name\";s:10:\"Cache Size\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:19:\"field-vm-cache-size\";a:4:{s:4:\"name\";s:10:\"Cache Size\";s:11:\"description\";s:28:\"Field \"field_vm_cache_size\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:19:\"field-fa-cache-size\";a:4:{s:4:\"name\";s:10:\"Cache Size\";s:11:\"description\";s:28:\"Field \"field_fa_cache_size\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:17:\"field-cache-state\";a:4:{s:4:\"name\";s:11:\"Cache State\";s:11:\"description\";s:26:\"Field \"field_cache_state\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:17:\"field_cache_state\";a:3:{s:4:\"name\";s:11:\"Cache State\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:22:\"field_vm_cache_latency\";a:3:{s:4:\"name\";s:13:\"Cache latency\";s:11:\"description\";s:14:\"Decimal field.\";s:6:\"module\";s:5:\"token\";}s:25:\"field-vdisk-cache-latency\";a:4:{s:4:\"name\";s:13:\"Cache latency\";s:11:\"description\";s:34:\"Field \"field_vdisk_cache_latency\".\";s:4:\"type\";s:7:\"decimal\";s:12:\"entity-token\";b:1;}s:25:\"field_vdisk_cache_latency\";a:3:{s:4:\"name\";s:13:\"Cache latency\";s:11:\"description\";s:14:\"Decimal field.\";s:6:\"module\";s:5:\"token\";}s:22:\"field-vm-cache-latency\";a:4:{s:4:\"name\";s:13:\"Cache latency\";s:11:\"description\";s:31:\"Field \"field_vm_cache_latency\".\";s:4:\"type\";s:7:\"decimal\";s:12:\"entity-token\";b:1;}s:16:\"field-cachespace\";a:4:{s:4:\"name\";s:10:\"Cachespace\";s:11:\"description\";s:25:\"Field \"field_cachespace\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:16:\"field_cachespace\";a:3:{s:4:\"name\";s:10:\"Cachespace\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:14:\"field_capacity\";a:3:{s:4:\"name\";s:8:\"Capacity\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:14:\"field-capacity\";a:4:{s:4:\"name\";s:8:\"Capacity\";s:11:\"description\";s:23:\"Field \"field_capacity\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:30:\"field-claimed-physical-devices\";a:4:{s:4:\"name\";s:24:\"Claimed Physical Devices\";s:11:\"description\";s:39:\"Field \"field_claimed_physical_devices\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:30:\"field_claimed_physical_devices\";a:3:{s:4:\"name\";s:24:\"Claimed Physical Devices\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:13:\"comment-count\";a:2:{s:4:\"name\";s:13:\"Comment count\";s:11:\"description\";s:40:\"The number of comments posted on a node.\";}s:7:\"comment\";a:4:{s:4:\"name\";s:16:\"Comments allowed\";s:11:\"description\";s:97:\"Whether comments are allowed on this node: 0 = no, 1 = closed (read only), 2 = open (read/write).\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:23:\"field-vdisk-hit-rate-pc\";a:3:{s:4:\"name\";s:62:\"Computed: <em class=\"placeholder\">field_vdisk_hit_rate_pc</em>\";s:11:\"description\";s:74:\"Computed field <em class=\"placeholder\">field_vdisk_hit_rate_pc</em> value.\";s:4:\"type\";s:8:\"computed\";}s:29:\"field-vdisk-insertion-rate-pc\";a:3:{s:4:\"name\";s:68:\"Computed: <em class=\"placeholder\">field_vdisk_insertion_rate_pc</em>\";s:11:\"description\";s:80:\"Computed field <em class=\"placeholder\">field_vdisk_insertion_rate_pc</em> value.\";s:4:\"type\";s:8:\"computed\";}s:25:\"field-vdisk-population-pc\";a:3:{s:4:\"name\";s:64:\"Computed: <em class=\"placeholder\">field_vdisk_population_pc</em>\";s:11:\"description\";s:76:\"Computed field <em class=\"placeholder\">field_vdisk_population_pc</em> value.\";s:4:\"type\";s:8:\"computed\";}s:20:\"field-vm-hit-rate-pc\";a:3:{s:4:\"name\";s:59:\"Computed: <em class=\"placeholder\">field_vm_hit_rate_pc</em>\";s:11:\"description\";s:71:\"Computed field <em class=\"placeholder\">field_vm_hit_rate_pc</em> value.\";s:4:\"type\";s:8:\"computed\";}s:26:\"field-vm-insertion-rate-pc\";a:3:{s:4:\"name\";s:65:\"Computed: <em class=\"placeholder\">field_vm_insertion_rate_pc</em>\";s:11:\"description\";s:77:\"Computed field <em class=\"placeholder\">field_vm_insertion_rate_pc</em> value.\";s:4:\"type\";s:8:\"computed\";}s:22:\"field-vm-population-pc\";a:3:{s:4:\"name\";s:61:\"Computed: <em class=\"placeholder\">field_vm_population_pc</em>\";s:11:\"description\";s:73:\"Computed field <em class=\"placeholder\">field_vm_population_pc</em> value.\";s:4:\"type\";s:8:\"computed\";}s:3:\"nid\";a:2:{s:4:\"name\";s:10:\"Content ID\";s:11:\"description\";s:45:\"The unique ID of the content item, or \"node\".\";}s:12:\"content-type\";a:3:{s:4:\"name\";s:12:\"Content type\";s:11:\"description\";s:29:\"The content type of the node.\";s:4:\"type\";s:12:\"content-type\";}s:15:\"field-cpu-model\";a:4:{s:4:\"name\";s:9:\"Cpu Model\";s:11:\"description\";s:24:\"Field \"field_cpu_model\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:15:\"field_cpu_model\";a:3:{s:4:\"name\";s:9:\"Cpu Model\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:8:\"revision\";a:4:{s:4:\"name\";s:16:\"Creates revision\";s:11:\"description\";s:48:\"Whether saving this node creates a new revision.\";s:4:\"type\";s:7:\"boolean\";s:12:\"entity-token\";b:1;}s:16:\"field-datacenter\";a:4:{s:4:\"name\";s:10:\"Datacenter\";s:11:\"description\";s:25:\"Field \"field_datacenter\".\";s:4:\"type\";s:4:\"node\";s:12:\"entity-token\";b:1;}s:16:\"field_datacenter\";a:3:{s:4:\"name\";s:10:\"Datacenter\";s:11:\"description\";s:23:\"Entity Reference field.\";s:6:\"module\";s:5:\"token\";}s:7:\"changed\";a:3:{s:4:\"name\";s:12:\"Date changed\";s:11:\"description\";s:44:\"The date the node was most recently updated.\";s:4:\"type\";s:4:\"date\";}s:7:\"created\";a:3:{s:4:\"name\";s:12:\"Date created\";s:11:\"description\";s:29:\"The date the node was posted.\";s:4:\"type\";s:4:\"date\";}s:16:\"field-devfs-path\";a:4:{s:4:\"name\";s:10:\"Devfs Path\";s:11:\"description\";s:25:\"Field \"field_devfs_path\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:16:\"field_devfs_path\";a:3:{s:4:\"name\";s:10:\"Devfs Path\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:18:\"field-device-state\";a:4:{s:4:\"name\";s:12:\"Device State\";s:11:\"description\";s:27:\"Field \"field_device_state\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:18:\"field_device_state\";a:3:{s:4:\"name\";s:12:\"Device State\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:17:\"field-device-type\";a:4:{s:4:\"name\";s:11:\"Device Type\";s:11:\"description\";s:26:\"Field \"field_device_type\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:17:\"field_device_type\";a:3:{s:4:\"name\";s:11:\"Device Type\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:16:\"field-disk-index\";a:4:{s:4:\"name\";s:10:\"Disk Index\";s:11:\"description\";s:25:\"Field \"field_disk_index\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:16:\"field_disk_index\";a:3:{s:4:\"name\";s:10:\"Disk Index\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:18:\"field-display-name\";a:4:{s:4:\"name\";s:12:\"Display Name\";s:11:\"description\";s:27:\"Field \"field_display_name\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:18:\"field_display_name\";a:3:{s:4:\"name\";s:12:\"Display Name\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:19:\"field-driver-status\";a:4:{s:4:\"name\";s:13:\"Driver Status\";s:11:\"description\";s:28:\"Field \"field_driver_status\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:19:\"field_driver_status\";a:3:{s:4:\"name\";s:13:\"Driver Status\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:8:\"edit-url\";a:2:{s:4:\"name\";s:8:\"Edit URL\";s:11:\"description\";s:32:\"The URL of the node\'s edit page.\";}s:14:\"field_fmc_uuid\";a:3:{s:4:\"name\";s:8:\"FMC UUID\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:14:\"field-fmc-uuid\";a:4:{s:4:\"name\";s:8:\"FMC UUID\";s:11:\"description\";s:23:\"Field \"field_fmc_uuid\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:15:\"field_freespace\";a:3:{s:4:\"name\";s:9:\"Freespace\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:15:\"field-freespace\";a:4:{s:4:\"name\";s:9:\"Freespace\";s:11:\"description\";s:24:\"Field \"field_freespace\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:22:\"field-fa-generation-id\";a:4:{s:4:\"name\";s:13:\"Generation ID\";s:11:\"description\";s:31:\"Field \"field_fa_generation_id\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:22:\"field_fa_generation_id\";a:3:{s:4:\"name\";s:13:\"Generation ID\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:14:\"field-guest-id\";a:4:{s:4:\"name\";s:8:\"Guest ID\";s:11:\"description\";s:23:\"Field \"field_guest_id\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:14:\"field_guest_id\";a:3:{s:4:\"name\";s:8:\"Guest ID\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:24:\"field_guest_memory_usage\";a:3:{s:4:\"name\";s:18:\"Guest Memory Usage\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:24:\"field-guest-memory-usage\";a:4:{s:4:\"name\";s:18:\"Guest Memory Usage\";s:11:\"description\";s:33:\"Field \"field_guest_memory_usage\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:14:\"field-guest-os\";a:4:{s:4:\"name\";s:8:\"Guest OS\";s:11:\"description\";s:23:\"Field \"field_guest_os\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:14:\"field_guest_os\";a:3:{s:4:\"name\";s:8:\"Guest OS\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:8:\"field_ha\";a:3:{s:4:\"name\";s:2:\"HA\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:8:\"field-ha\";a:4:{s:4:\"name\";s:2:\"HA\";s:11:\"description\";s:17:\"Field \"field_ha\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:10:\"field-hbtl\";a:4:{s:4:\"name\";s:4:\"HBTL\";s:11:\"description\";s:19:\"Field \"field_hbtl\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:10:\"field_hbtl\";a:3:{s:4:\"name\";s:4:\"HBTL\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:13:\"field-hit-ops\";a:4:{s:4:\"name\";s:7:\"Hit Ops\";s:11:\"description\";s:22:\"Field \"field_hit_ops\".\";s:4:\"type\";s:7:\"decimal\";s:12:\"entity-token\";b:1;}s:13:\"field_hit_ops\";a:3:{s:4:\"name\";s:7:\"Hit Ops\";s:11:\"description\";s:14:\"Decimal field.\";s:6:\"module\";s:5:\"token\";}s:23:\"field_vdisk_hit_rate_pc\";a:3:{s:4:\"name\";s:10:\"Hit Rate %\";s:11:\"description\";s:15:\"Computed field.\";s:6:\"module\";s:5:\"token\";}s:20:\"field_vm_hit_rate_pc\";a:3:{s:4:\"name\";s:10:\"Hit Rate %\";s:11:\"description\";s:15:\"Computed field.\";s:6:\"module\";s:5:\"token\";}s:16:\"field_vdisk_hits\";a:3:{s:4:\"name\";s:4:\"Hits\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:13:\"field-vm-hits\";a:4:{s:4:\"name\";s:4:\"Hits\";s:11:\"description\";s:22:\"Field \"field_vm_hits\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:16:\"field-vdisk-hits\";a:4:{s:4:\"name\";s:4:\"Hits\";s:11:\"description\";s:25:\"Field \"field_vdisk_hits\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:13:\"field_vm_hits\";a:3:{s:4:\"name\";s:4:\"Hits\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:10:\"field_host\";a:3:{s:4:\"name\";s:4:\"Host\";s:11:\"description\";s:23:\"Entity Reference field.\";s:6:\"module\";s:5:\"token\";}s:10:\"field-host\";a:4:{s:4:\"name\";s:4:\"Host\";s:11:\"description\";s:19:\"Field \"field_host\".\";s:4:\"type\";s:4:\"node\";s:12:\"entity-token\";b:1;}s:23:\"field-host-memory-usage\";a:4:{s:4:\"name\";s:17:\"Host Memory Usage\";s:11:\"description\";s:32:\"Field \"field_host_memory_usage\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:23:\"field_host_memory_usage\";a:3:{s:4:\"name\";s:17:\"Host Memory Usage\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:16:\"field_host_model\";a:3:{s:4:\"name\";s:10:\"Host Model\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:16:\"field-host-model\";a:4:{s:4:\"name\";s:10:\"Host Model\";s:11:\"description\";s:25:\"Field \"field_host_model\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:17:\"field-host-status\";a:4:{s:4:\"name\";s:11:\"Host Status\";s:11:\"description\";s:26:\"Field \"field_host_status\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:17:\"field_host_status\";a:3:{s:4:\"name\";s:11:\"Host Status\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:17:\"field_host_vendor\";a:3:{s:4:\"name\";s:11:\"Host Vendor\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:17:\"field-host-vendor\";a:4:{s:4:\"name\";s:11:\"Host Vendor\";s:11:\"description\";s:26:\"Field \"field_host_vendor\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:14:\"field_hostname\";a:3:{s:4:\"name\";s:8:\"Hostname\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:17:\"field_vm_hostname\";a:3:{s:4:\"name\";s:8:\"Hostname\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:14:\"field-hostname\";a:4:{s:4:\"name\";s:8:\"Hostname\";s:11:\"description\";s:23:\"Field \"field_hostname\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:17:\"field-vm-hostname\";a:4:{s:4:\"name\";s:8:\"Hostname\";s:11:\"description\";s:26:\"Field \"field_vm_hostname\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:13:\"field_host_ip\";a:3:{s:4:\"name\";s:2:\"IP\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:13:\"field-host-ip\";a:4:{s:4:\"name\";s:2:\"IP\";s:11:\"description\";s:22:\"Field \"field_host_ip\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:19:\"field_vm_ip_address\";a:3:{s:4:\"name\";s:10:\"IP Address\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:16:\"field_ip_address\";a:3:{s:4:\"name\";s:10:\"IP Address\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:16:\"field-ip-address\";a:4:{s:4:\"name\";s:10:\"IP Address\";s:11:\"description\";s:25:\"Field \"field_ip_address\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:19:\"field-vm-ip-address\";a:4:{s:4:\"name\";s:10:\"IP Address\";s:11:\"description\";s:28:\"Field \"field_vm_ip_address\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:22:\"field-vdisk-identifier\";a:4:{s:4:\"name\";s:10:\"Identifier\";s:11:\"description\";s:31:\"Field \"field_vdisk_identifier\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:22:\"field_vdisk_identifier\";a:3:{s:4:\"name\";s:10:\"Identifier\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:29:\"field_vdisk_insertion_rate_pc\";a:3:{s:4:\"name\";s:16:\"Insertion rate %\";s:11:\"description\";s:15:\"Computed field.\";s:6:\"module\";s:5:\"token\";}s:26:\"field_vm_insertion_rate_pc\";a:3:{s:4:\"name\";s:16:\"Insertion rate %\";s:11:\"description\";s:15:\"Computed field.\";s:6:\"module\";s:5:\"token\";}s:22:\"field-vdisk-insertions\";a:4:{s:4:\"name\";s:10:\"Insertions\";s:11:\"description\";s:31:\"Field \"field_vdisk_insertions\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:22:\"field_vdisk_insertions\";a:3:{s:4:\"name\";s:10:\"Insertions\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:19:\"field_vm_insertions\";a:3:{s:4:\"name\";s:10:\"Insertions\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:19:\"field-vm-insertions\";a:4:{s:4:\"name\";s:10:\"Insertions\";s:11:\"description\";s:28:\"Field \"field_vm_insertions\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:18:\"field-install-port\";a:4:{s:4:\"name\";s:12:\"Install Port\";s:11:\"description\";s:27:\"Field \"field_install_port\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:18:\"field_install_port\";a:3:{s:4:\"name\";s:12:\"Install Port\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:14:\"field_is_local\";a:3:{s:4:\"name\";s:8:\"Is Local\";s:11:\"description\";s:18:\"List (text) field.\";s:6:\"module\";s:5:\"token\";}s:14:\"field-is-local\";a:4:{s:4:\"name\";s:8:\"Is Local\";s:11:\"description\";s:23:\"Field \"field_is_local\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:16:\"field_is_offline\";a:3:{s:4:\"name\";s:10:\"Is Offline\";s:11:\"description\";s:18:\"List (text) field.\";s:6:\"module\";s:5:\"token\";}s:16:\"field-is-offline\";a:4:{s:4:\"name\";s:10:\"Is Offline\";s:11:\"description\";s:25:\"Field \"field_is_offline\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:29:\"field-is-perennially-reserved\";a:4:{s:4:\"name\";s:23:\"Is Perennially Reserved\";s:11:\"description\";s:38:\"Field \"field_is_perennially_reserved\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:29:\"field_is_perennially_reserved\";a:3:{s:4:\"name\";s:23:\"Is Perennially Reserved\";s:11:\"description\";s:18:\"List (text) field.\";s:6:\"module\";s:5:\"token\";}s:15:\"field_is_pseudo\";a:3:{s:4:\"name\";s:9:\"Is Pseudo\";s:11:\"description\";s:18:\"List (text) field.\";s:6:\"module\";s:5:\"token\";}s:15:\"field-is-pseudo\";a:4:{s:4:\"name\";s:9:\"Is Pseudo\";s:11:\"description\";s:24:\"Field \"field_is_pseudo\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:20:\"field-is-rdm-capable\";a:4:{s:4:\"name\";s:14:\"Is RDM Capable\";s:11:\"description\";s:29:\"Field \"field_is_rdm_capable\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:20:\"field_is_rdm_capable\";a:3:{s:4:\"name\";s:14:\"Is RDM Capable\";s:11:\"description\";s:18:\"List (text) field.\";s:6:\"module\";s:5:\"token\";}s:18:\"field_is_removable\";a:3:{s:4:\"name\";s:12:\"Is Removable\";s:11:\"description\";s:18:\"List (text) field.\";s:6:\"module\";s:5:\"token\";}s:18:\"field-is-removable\";a:4:{s:4:\"name\";s:12:\"Is Removable\";s:11:\"description\";s:27:\"Field \"field_is_removable\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:12:\"field_is_ssd\";a:3:{s:4:\"name\";s:6:\"Is SSD\";s:11:\"description\";s:18:\"List (text) field.\";s:6:\"module\";s:5:\"token\";}s:12:\"field-is-ssd\";a:4:{s:4:\"name\";s:6:\"Is SSD\";s:11:\"description\";s:21:\"Field \"field_is_ssd\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:13:\"field_is_vmfs\";a:3:{s:4:\"name\";s:7:\"Is VMFS\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:13:\"field-is-vmfs\";a:4:{s:4:\"name\";s:7:\"Is VMFS\";s:11:\"description\";s:22:\"Field \"field_is_vmfs\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:6:\"is-new\";a:4:{s:4:\"name\";s:6:\"Is new\";s:11:\"description\";s:58:\"Whether the node is new and not saved to the database yet.\";s:4:\"type\";s:7:\"boolean\";s:12:\"entity-token\";b:1;}s:8:\"language\";a:2:{s:4:\"name\";s:8:\"Language\";s:11:\"description\";s:36:\"The language the node is written in.\";}s:22:\"field-maintenance-mode\";a:4:{s:4:\"name\";s:16:\"Maintenance mode\";s:11:\"description\";s:31:\"Field \"field_maintenance_mode\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:22:\"field_maintenance_mode\";a:3:{s:4:\"name\";s:16:\"Maintenance mode\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:26:\"field-max-physical-devices\";a:4:{s:4:\"name\";s:20:\"Max Physical Devices\";s:11:\"description\";s:35:\"Field \"field_max_physical_devices\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:26:\"field_max_physical_devices\";a:3:{s:4:\"name\";s:20:\"Max Physical Devices\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:26:\"field-max-virtual-machines\";a:4:{s:4:\"name\";s:20:\"Max Virtual Machines\";s:11:\"description\";s:35:\"Field \"field_max_virtual_machines\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:26:\"field_max_virtual_machines\";a:3:{s:4:\"name\";s:20:\"Max Virtual Machines\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:17:\"field_memory_size\";a:3:{s:4:\"name\";s:11:\"Memory Size\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:17:\"field-memory-size\";a:4:{s:4:\"name\";s:11:\"Memory Size\";s:11:\"description\";s:26:\"Field \"field_memory_size\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:9:\"menu-link\";a:3:{s:4:\"name\";s:9:\"Menu link\";s:11:\"description\";s:28:\"The menu link for this node.\";s:4:\"type\";s:9:\"menu-link\";}s:31:\"field-fa-metrics-reset-interval\";a:4:{s:4:\"name\";s:22:\"Metrics Reset Interval\";s:11:\"description\";s:40:\"Field \"field_fa_metrics_reset_interval\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:31:\"field_fa_metrics_reset_interval\";a:3:{s:4:\"name\";s:22:\"Metrics Reset Interval\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:11:\"field_model\";a:3:{s:4:\"name\";s:5:\"Model\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:11:\"field-model\";a:4:{s:4:\"name\";s:5:\"Model\";s:11:\"description\";s:20:\"Field \"field_model\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:22:\"field-multipath-plugin\";a:4:{s:4:\"name\";s:16:\"Multipath Plugin\";s:11:\"description\";s:31:\"Field \"field_multipath_plugin\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:22:\"field_multipath_plugin\";a:3:{s:4:\"name\";s:16:\"Multipath Plugin\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:20:\"field_naa_identifier\";a:3:{s:4:\"name\";s:14:\"NAA Identifier\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:20:\"field-naa-identifier\";a:4:{s:4:\"name\";s:14:\"NAA Identifier\";s:11:\"description\";s:29:\"Field \"field_naa_identifier\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:17:\"comment-count-new\";a:2:{s:4:\"name\";s:17:\"New comment count\";s:11:\"description\";s:72:\"The number of comments posted on a node since the reader last viewed it.\";}s:28:\"field-fa-operational-message\";a:4:{s:4:\"name\";s:19:\"Operational Message\";s:11:\"description\";s:37:\"Field \"field_fa_operational_message\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:28:\"field_fa_operational_message\";a:3:{s:4:\"name\";s:19:\"Operational Message\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:26:\"field_fa_operational_state\";a:3:{s:4:\"name\";s:17:\"Operational State\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:26:\"field-fa-operational-state\";a:4:{s:4:\"name\";s:17:\"Operational State\";s:11:\"description\";s:35:\"Field \"field_fa_operational_state\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:8:\"original\";a:4:{s:4:\"name\";s:13:\"Original node\";s:11:\"description\";s:61:\"The original node data if the node is being updated or saved.\";s:6:\"module\";s:5:\"token\";s:4:\"type\";s:4:\"node\";}s:16:\"field-other-uids\";a:4:{s:4:\"name\";s:10:\"Other UIDs\";s:11:\"description\";s:25:\"Field \"field_other_uids\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:16:\"field_other_uids\";a:3:{s:4:\"name\";s:10:\"Other UIDs\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:19:\"field-host-password\";a:4:{s:4:\"name\";s:8:\"Password\";s:11:\"description\";s:28:\"Field \"field_host_password\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:17:\"field-vm-password\";a:4:{s:4:\"name\";s:8:\"Password\";s:11:\"description\";s:26:\"Field \"field_vm_password\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:14:\"field_password\";a:3:{s:4:\"name\";s:8:\"Password\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:17:\"field_vm_password\";a:3:{s:4:\"name\";s:8:\"Password\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:19:\"field_host_password\";a:3:{s:4:\"name\";s:8:\"Password\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:14:\"field-password\";a:4:{s:4:\"name\";s:8:\"Password\";s:11:\"description\";s:23:\"Field \"field_password\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:10:\"field_path\";a:3:{s:4:\"name\";s:4:\"Path\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:10:\"field-path\";a:4:{s:4:\"name\";s:4:\"Path\";s:11:\"description\";s:19:\"Field \"field_path\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:26:\"field_fa_performance_state\";a:3:{s:4:\"name\";s:17:\"Performance State\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:26:\"field-fa-performance-state\";a:4:{s:4:\"name\";s:17:\"Performance State\";s:11:\"description\";s:35:\"Field \"field_fa_performance_state\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:21:\"field_physical_memory\";a:3:{s:4:\"name\";s:15:\"Physical Memory\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:21:\"field-physical-memory\";a:4:{s:4:\"name\";s:15:\"Physical Memory\";s:11:\"description\";s:30:\"Field \"field_physical_memory\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:19:\"field_vm_population\";a:3:{s:4:\"name\";s:10:\"Population\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:19:\"field-vm-population\";a:4:{s:4:\"name\";s:10:\"Population\";s:11:\"description\";s:28:\"Field \"field_vm_population\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:22:\"field_vdisk_population\";a:3:{s:4:\"name\";s:10:\"Population\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:22:\"field-vdisk-population\";a:4:{s:4:\"name\";s:10:\"Population\";s:11:\"description\";s:31:\"Field \"field_vdisk_population\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:22:\"field_vm_population_pc\";a:3:{s:4:\"name\";s:12:\"Population %\";s:11:\"description\";s:15:\"Computed field.\";s:6:\"module\";s:5:\"token\";}s:25:\"field_vdisk_population_pc\";a:3:{s:4:\"name\";s:12:\"Population %\";s:11:\"description\";s:15:\"Computed field.\";s:6:\"module\";s:5:\"token\";}s:7:\"promote\";a:4:{s:4:\"name\";s:21:\"Promoted to frontpage\";s:11:\"description\";s:46:\"Whether the node is promoted to the frontpage.\";s:4:\"type\";s:7:\"boolean\";s:12:\"entity-token\";b:1;}s:20:\"field-vm-read-blocks\";a:4:{s:4:\"name\";s:11:\"Read blocks\";s:11:\"description\";s:29:\"Field \"field_vm_read_blocks\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:23:\"field_vdisk_read_blocks\";a:3:{s:4:\"name\";s:11:\"Read blocks\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:23:\"field-vdisk-read-blocks\";a:4:{s:4:\"name\";s:11:\"Read blocks\";s:11:\"description\";s:32:\"Field \"field_vdisk_read_blocks\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:20:\"field_vm_read_blocks\";a:3:{s:4:\"name\";s:11:\"Read blocks\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:21:\"field-vm-read-latency\";a:4:{s:4:\"name\";s:12:\"Read latency\";s:11:\"description\";s:30:\"Field \"field_vm_read_latency\".\";s:4:\"type\";s:7:\"decimal\";s:12:\"entity-token\";b:1;}s:21:\"field_vm_read_latency\";a:3:{s:4:\"name\";s:12:\"Read latency\";s:11:\"description\";s:14:\"Decimal field.\";s:6:\"module\";s:5:\"token\";}s:24:\"field_vdisk_read_latency\";a:3:{s:4:\"name\";s:12:\"Read latency\";s:11:\"description\";s:14:\"Decimal field.\";s:6:\"module\";s:5:\"token\";}s:24:\"field-vdisk-read-latency\";a:4:{s:4:\"name\";s:12:\"Read latency\";s:11:\"description\";s:33:\"Field \"field_vdisk_read_latency\".\";s:4:\"type\";s:7:\"decimal\";s:12:\"entity-token\";b:1;}s:17:\"field_vm_read_ops\";a:3:{s:4:\"name\";s:8:\"Read ops\";s:11:\"description\";s:14:\"Decimal field.\";s:6:\"module\";s:5:\"token\";}s:20:\"field_vdisk_read_ops\";a:3:{s:4:\"name\";s:8:\"Read ops\";s:11:\"description\";s:14:\"Decimal field.\";s:6:\"module\";s:5:\"token\";}s:20:\"field-vdisk-read-ops\";a:4:{s:4:\"name\";s:8:\"Read ops\";s:11:\"description\";s:29:\"Field \"field_vdisk_read_ops\".\";s:4:\"type\";s:7:\"decimal\";s:12:\"entity-token\";b:1;}s:17:\"field-vm-read-ops\";a:4:{s:4:\"name\";s:8:\"Read ops\";s:11:\"description\";s:26:\"Field \"field_vm_read_ops\".\";s:4:\"type\";s:7:\"decimal\";s:12:\"entity-token\";b:1;}s:21:\"field_reboot_required\";a:3:{s:4:\"name\";s:15:\"Reboot Required\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:21:\"field-reboot-required\";a:4:{s:4:\"name\";s:15:\"Reboot Required\";s:11:\"description\";s:30:\"Field \"field_reboot_required\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:23:\"field-rediscover-status\";a:4:{s:4:\"name\";s:17:\"Rediscover Status\";s:11:\"description\";s:32:\"Field \"field_rediscover_status\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:23:\"field_rediscover_status\";a:3:{s:4:\"name\";s:17:\"Rediscover Status\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:18:\"field_related_host\";a:3:{s:4:\"name\";s:12:\"Related Host\";s:11:\"description\";s:23:\"Entity Reference field.\";s:6:\"module\";s:5:\"token\";}s:18:\"field-related-host\";a:4:{s:4:\"name\";s:12:\"Related Host\";s:11:\"description\";s:27:\"Field \"field_related_host\".\";s:4:\"type\";s:4:\"node\";s:12:\"entity-token\";b:1;}s:21:\"field_related_vcenter\";a:3:{s:4:\"name\";s:15:\"Related vCenter\";s:11:\"description\";s:23:\"Entity Reference field.\";s:6:\"module\";s:5:\"token\";}s:21:\"field-related-vcenter\";a:4:{s:4:\"name\";s:15:\"Related vCenter\";s:11:\"description\";s:30:\"Field \"field_related_vcenter\".\";s:4:\"type\";s:4:\"node\";s:12:\"entity-token\";b:1;}s:14:\"field-revision\";a:4:{s:4:\"name\";s:8:\"Revision\";s:11:\"description\";s:23:\"Field \"field_revision\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:14:\"field_revision\";a:3:{s:4:\"name\";s:8:\"Revision\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:3:\"vid\";a:2:{s:4:\"name\";s:11:\"Revision ID\";s:11:\"description\";s:44:\"The unique ID of the node\'s latest revision.\";}s:3:\"log\";a:2:{s:4:\"name\";s:20:\"Revision log message\";s:11:\"description\";s:60:\"The explanation of the most recent changes made to the node.\";}s:16:\"field-scsi-level\";a:4:{s:4:\"name\";s:10:\"SCSI Level\";s:11:\"description\";s:25:\"Field \"field_scsi_level\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:16:\"field_scsi_level\";a:3:{s:4:\"name\";s:10:\"SCSI Level\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:20:\"field-fa-sector-size\";a:4:{s:4:\"name\";s:11:\"Sector Size\";s:11:\"description\";s:29:\"Field \"field_fa_sector_size\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:20:\"field_fa_sector_size\";a:3:{s:4:\"name\";s:11:\"Sector Size\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:18:\"field_segment_size\";a:3:{s:4:\"name\";s:12:\"Segment Size\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:18:\"field-segment-size\";a:4:{s:4:\"name\";s:12:\"Segment Size\";s:11:\"description\";s:27:\"Field \"field_segment_size\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:15:\"field-serial-no\";a:4:{s:4:\"name\";s:9:\"Serial No\";s:11:\"description\";s:24:\"Field \"field_serial_no\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:15:\"field_serial_no\";a:3:{s:4:\"name\";s:9:\"Serial No\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:10:\"field_size\";a:3:{s:4:\"name\";s:4:\"Size\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:10:\"field-size\";a:4:{s:4:\"name\";s:4:\"Size\";s:11:\"description\";s:19:\"Field \"field_size\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:22:\"field-software-on-host\";a:4:{s:4:\"name\";s:16:\"Software on host\";s:11:\"description\";s:31:\"Field \"field_software_on_host\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:22:\"field_software_on_host\";a:3:{s:4:\"name\";s:16:\"Software on host\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:6:\"status\";a:4:{s:4:\"name\";s:6:\"Status\";s:11:\"description\";s:45:\"Whether the node is published or unpublished.\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:12:\"field-status\";a:4:{s:4:\"name\";s:6:\"Status\";s:11:\"description\";s:21:\"Field \"field_status\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:12:\"field_status\";a:3:{s:4:\"name\";s:6:\"Status\";s:11:\"description\";s:18:\"List (text) field.\";s:6:\"module\";s:5:\"token\";}s:6:\"sticky\";a:4:{s:4:\"name\";s:15:\"Sticky in lists\";s:11:\"description\";s:70:\"Whether the node is displayed at the top of lists in which it appears.\";s:4:\"type\";s:7:\"boolean\";s:12:\"entity-token\";b:1;}s:7:\"summary\";a:2:{s:4:\"name\";s:7:\"Summary\";s:11:\"description\";s:41:\"The summary of the node\'s main body text.\";}s:10:\"field_tags\";a:3:{s:4:\"name\";s:4:\"Tags\";s:11:\"description\";s:21:\"Term reference field.\";s:6:\"module\";s:5:\"token\";}s:10:\"field-tags\";a:4:{s:4:\"name\";s:4:\"Tags\";s:11:\"description\";s:19:\"Field \"field_tags\".\";s:4:\"type\";s:10:\"list<term>\";s:12:\"entity-token\";b:1;}s:14:\"field_template\";a:3:{s:4:\"name\";s:8:\"Template\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:14:\"field-template\";a:4:{s:4:\"name\";s:8:\"Template\";s:11:\"description\";s:23:\"Field \"field_template\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:30:\"field_thin_provisioning_status\";a:3:{s:4:\"name\";s:24:\"Thin Provisioning Status\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:30:\"field-thin-provisioning-status\";a:4:{s:4:\"name\";s:24:\"Thin Provisioning Status\";s:11:\"description\";s:39:\"Field \"field_thin_provisioning_status\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:15:\"field_timestamp\";a:3:{s:4:\"name\";s:9:\"Timestamp\";s:11:\"description\";s:28:\"Date (Unix timestamp) field.\";s:6:\"module\";s:5:\"token\";}s:15:\"field-timestamp\";a:4:{s:4:\"name\";s:9:\"Timestamp\";s:11:\"description\";s:24:\"Field \"field_timestamp\".\";s:4:\"type\";s:4:\"date\";s:12:\"entity-token\";b:1;}s:5:\"title\";a:2:{s:4:\"name\";s:5:\"Title\";s:11:\"description\";s:22:\"The title of the node.\";}s:20:\"field_total_segments\";a:3:{s:4:\"name\";s:14:\"Total Segments\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:20:\"field-total-segments\";a:4:{s:4:\"name\";s:14:\"Total Segments\";s:11:\"description\";s:29:\"Field \"field_total_segments\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:16:\"field-total-size\";a:4:{s:4:\"name\";s:10:\"Total Size\";s:11:\"description\";s:25:\"Field \"field_total_size\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:16:\"field_total_size\";a:3:{s:4:\"name\";s:10:\"Total Size\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:6:\"source\";a:3:{s:4:\"name\";s:23:\"Translation source node\";s:11:\"description\";s:56:\"The source node for this current node\'s translation set.\";s:4:\"type\";s:4:\"node\";}s:3:\"url\";a:3:{s:4:\"name\";s:3:\"URL\";s:11:\"description\";s:20:\"The URL of the node.\";s:4:\"type\";s:3:\"url\";}s:22:\"field-fa-usable-blocks\";a:4:{s:4:\"name\";s:13:\"Usable Blocks\";s:11:\"description\";s:31:\"Field \"field_fa_usable_blocks\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:22:\"field_fa_usable_blocks\";a:3:{s:4:\"name\";s:13:\"Usable Blocks\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:22:\"field-vm-usable-blocks\";a:4:{s:4:\"name\";s:13:\"Usable blocks\";s:11:\"description\";s:31:\"Field \"field_vm_usable_blocks\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:25:\"field-vdisk-usable-blocks\";a:4:{s:4:\"name\";s:13:\"Usable blocks\";s:11:\"description\";s:34:\"Field \"field_vdisk_usable_blocks\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:22:\"field_vm_usable_blocks\";a:3:{s:4:\"name\";s:13:\"Usable blocks\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:25:\"field_vdisk_usable_blocks\";a:3:{s:4:\"name\";s:13:\"Usable blocks\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:17:\"field_vm_username\";a:3:{s:4:\"name\";s:8:\"Username\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:19:\"field-host-username\";a:4:{s:4:\"name\";s:8:\"Username\";s:11:\"description\";s:28:\"Field \"field_host_username\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:17:\"field-vm-username\";a:4:{s:4:\"name\";s:8:\"Username\";s:11:\"description\";s:26:\"Field \"field_vm_username\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:14:\"field-username\";a:4:{s:4:\"name\";s:8:\"Username\";s:11:\"description\";s:23:\"Field \"field_username\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:19:\"field_host_username\";a:3:{s:4:\"name\";s:8:\"Username\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:14:\"field_username\";a:3:{s:4:\"name\";s:8:\"Username\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:17:\"field-vaai-status\";a:4:{s:4:\"name\";s:11:\"VAAI Status\";s:11:\"description\";s:26:\"Field \"field_vaai_status\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:17:\"field_vaai_status\";a:3:{s:4:\"name\";s:11:\"VAAI Status\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:17:\"field_vib_version\";a:3:{s:4:\"name\";s:11:\"VIB Version\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:17:\"field-vib-version\";a:4:{s:4:\"name\";s:11:\"VIB Version\";s:11:\"description\";s:26:\"Field \"field_vib_version\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:8:\"field-vm\";a:4:{s:4:\"name\";s:2:\"VM\";s:11:\"description\";s:17:\"Field \"field_vm\".\";s:4:\"type\";s:4:\"node\";s:12:\"entity-token\";b:1;}s:8:\"field_vm\";a:3:{s:4:\"name\";s:2:\"VM\";s:11:\"description\";s:23:\"Entity Reference field.\";s:6:\"module\";s:5:\"token\";}s:18:\"field_vm_path_name\";a:3:{s:4:\"name\";s:12:\"VM Path Name\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:18:\"field-vm-path-name\";a:4:{s:4:\"name\";s:12:\"VM Path Name\";s:11:\"description\";s:27:\"Field \"field_vm_path_name\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:13:\"field_vmotion\";a:3:{s:4:\"name\";s:7:\"VMotion\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:13:\"field-vmotion\";a:4:{s:4:\"name\";s:7:\"VMotion\";s:11:\"description\";s:22:\"Field \"field_vmotion\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:20:\"field-vm-vmotionable\";a:4:{s:4:\"name\";s:12:\"V Motionable\";s:11:\"description\";s:29:\"Field \"field_vm_vmotionable\".\";s:4:\"type\";s:7:\"boolean\";s:12:\"entity-token\";b:1;}s:20:\"field_vm_vmotionable\";a:3:{s:4:\"name\";s:12:\"V Motionable\";s:11:\"description\";s:14:\"Boolean field.\";s:6:\"module\";s:5:\"token\";}s:25:\"field_vm_vmotion_hostlist\";a:3:{s:4:\"name\";s:19:\"VM vMotion Hostlist\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:25:\"field-vm-vmotion-hostlist\";a:4:{s:4:\"name\";s:19:\"VM vMotion Hostlist\";s:11:\"description\";s:34:\"Field \"field_vm_vmotion_hostlist\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:23:\"field_vm_vmotion_policy\";a:3:{s:4:\"name\";s:17:\"VM vMotion Policy\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:23:\"field-vm-vmotion-policy\";a:4:{s:4:\"name\";s:17:\"VM vMotion Policy\";s:11:\"description\";s:32:\"Field \"field_vm_vmotion_policy\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:18:\"field-vmware-tools\";a:4:{s:4:\"name\";s:12:\"VMware Tools\";s:11:\"description\";s:27:\"Field \"field_vmware_tools\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:18:\"field_vmware_tools\";a:3:{s:4:\"name\";s:12:\"VMware Tools\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:12:\"field-vendor\";a:4:{s:4:\"name\";s:6:\"Vendor\";s:11:\"description\";s:21:\"Field \"field_vendor\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:12:\"field_vendor\";a:3:{s:4:\"name\";s:6:\"Vendor\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:21:\"field-virtual-machine\";a:4:{s:4:\"name\";s:15:\"Virtual Machine\";s:11:\"description\";s:30:\"Field \"field_virtual_machine\".\";s:4:\"type\";s:4:\"node\";s:12:\"entity-token\";b:1;}s:21:\"field_virtual_machine\";a:3:{s:4:\"name\";s:15:\"Virtual Machine\";s:11:\"description\";s:23:\"Entity Reference field.\";s:6:\"module\";s:5:\"token\";}s:24:\"field-vdisk-write-blocks\";a:4:{s:4:\"name\";s:12:\"Write blocks\";s:11:\"description\";s:33:\"Field \"field_vdisk_write_blocks\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:21:\"field-vm-write-blocks\";a:4:{s:4:\"name\";s:12:\"Write blocks\";s:11:\"description\";s:30:\"Field \"field_vm_write_blocks\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:24:\"field_vdisk_write_blocks\";a:3:{s:4:\"name\";s:12:\"Write blocks\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:21:\"field_vm_write_blocks\";a:3:{s:4:\"name\";s:12:\"Write blocks\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:25:\"field_vdisk_write_latency\";a:3:{s:4:\"name\";s:13:\"Write latency\";s:11:\"description\";s:14:\"Decimal field.\";s:6:\"module\";s:5:\"token\";}s:22:\"field-vm-write-latency\";a:4:{s:4:\"name\";s:13:\"Write latency\";s:11:\"description\";s:31:\"Field \"field_vm_write_latency\".\";s:4:\"type\";s:7:\"decimal\";s:12:\"entity-token\";b:1;}s:22:\"field_vm_write_latency\";a:3:{s:4:\"name\";s:13:\"Write latency\";s:11:\"description\";s:14:\"Decimal field.\";s:6:\"module\";s:5:\"token\";}s:25:\"field-vdisk-write-latency\";a:4:{s:4:\"name\";s:13:\"Write latency\";s:11:\"description\";s:34:\"Field \"field_vdisk_write_latency\".\";s:4:\"type\";s:7:\"decimal\";s:12:\"entity-token\";b:1;}s:18:\"field-vm-write-ops\";a:4:{s:4:\"name\";s:9:\"Write ops\";s:11:\"description\";s:27:\"Field \"field_vm_write_ops\".\";s:4:\"type\";s:7:\"decimal\";s:12:\"entity-token\";b:1;}s:21:\"field-vdisk-write-ops\";a:4:{s:4:\"name\";s:9:\"Write ops\";s:11:\"description\";s:30:\"Field \"field_vdisk_write_ops\".\";s:4:\"type\";s:7:\"decimal\";s:12:\"entity-token\";b:1;}s:21:\"field_vdisk_write_ops\";a:3:{s:4:\"name\";s:9:\"Write ops\";s:11:\"description\";s:14:\"Decimal field.\";s:6:\"module\";s:5:\"token\";}s:18:\"field_vm_write_ops\";a:3:{s:4:\"name\";s:9:\"Write ops\";s:11:\"description\";s:14:\"Decimal field.\";s:6:\"module\";s:5:\"token\";}s:9:\"field-drs\";a:4:{s:4:\"name\";s:3:\"drs\";s:11:\"description\";s:18:\"Field \"field_drs\".\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:9:\"field_drs\";a:3:{s:4:\"name\";s:3:\"drs\";s:11:\"description\";s:14:\"Integer field.\";s:6:\"module\";s:5:\"token\";}s:15:\"field-no-of-cpu\";a:4:{s:4:\"name\";s:9:\"no_of_cpu\";s:11:\"description\";s:24:\"Field \"field_no_of_cpu\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:15:\"field_no_of_cpu\";a:3:{s:4:\"name\";s:9:\"no_of_cpu\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:11:\"field_vdisk\";a:3:{s:4:\"name\";s:5:\"vDisk\";s:11:\"description\";s:23:\"Entity Reference field.\";s:6:\"module\";s:5:\"token\";}s:11:\"field-vdisk\";a:4:{s:4:\"name\";s:5:\"vDisk\";s:11:\"description\";s:20:\"Field \"field_vdisk\".\";s:4:\"type\";s:4:\"node\";s:12:\"entity-token\";b:1;}s:14:\"field_vdisk_id\";a:3:{s:4:\"name\";s:8:\"vDisk Id\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:14:\"field-vdisk-id\";a:4:{s:4:\"name\";s:8:\"vDisk Id\";s:11:\"description\";s:23:\"Field \"field_vdisk_id\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:16:\"field-vdisk-name\";a:4:{s:4:\"name\";s:10:\"vDisk Name\";s:11:\"description\";s:25:\"Field \"field_vdisk_name\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:16:\"field_vdisk_name\";a:3:{s:4:\"name\";s:10:\"vDisk Name\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:16:\"field_vdisk_type\";a:3:{s:4:\"name\";s:10:\"vDisk Type\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}s:16:\"field-vdisk-type\";a:4:{s:4:\"name\";s:10:\"vDisk Type\";s:11:\"description\";s:25:\"Field \"field_vdisk_type\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:19:\"field-virtual-disks\";a:4:{s:4:\"name\";s:13:\"virtual_disks\";s:11:\"description\";s:28:\"Field \"field_virtual_disks\".\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:19:\"field_virtual_disks\";a:3:{s:4:\"name\";s:13:\"virtual_disks\";s:11:\"description\";s:11:\"Text field.\";s:6:\"module\";s:5:\"token\";}}s:12:\"content-type\";a:5:{s:11:\"description\";a:2:{s:4:\"name\";s:11:\"Description\";s:11:\"description\";s:45:\"The optional description of the content type.\";}s:8:\"edit-url\";a:2:{s:4:\"name\";s:8:\"Edit URL\";s:11:\"description\";s:40:\"The URL of the content type\'s edit page.\";}s:12:\"machine-name\";a:2:{s:4:\"name\";s:21:\"Machine-readable name\";s:11:\"description\";s:53:\"The unique machine-readable name of the content type.\";}s:4:\"name\";a:2:{s:4:\"name\";s:4:\"Name\";s:11:\"description\";s:29:\"The name of the content type.\";}s:10:\"node-count\";a:2:{s:4:\"name\";s:10:\"Node count\";s:11:\"description\";s:50:\"The number of nodes belonging to the content type.\";}}s:4:\"term\";a:13:{s:11:\"parents-all\";a:4:{s:4:\"name\";s:16:\"All parent terms\";s:11:\"description\";s:65:\"Ancestors of the term, i.e. parent of all above hierarchy levels.\";s:4:\"type\";s:10:\"list<term>\";s:12:\"entity-token\";b:1;}s:11:\"description\";a:2:{s:4:\"name\";s:11:\"Description\";s:11:\"description\";s:46:\"The optional description of the taxonomy term.\";}s:8:\"edit-url\";a:2:{s:4:\"name\";s:8:\"Edit URL\";s:11:\"description\";s:41:\"The URL of the taxonomy term\'s edit page.\";}s:4:\"name\";a:2:{s:4:\"name\";s:4:\"Name\";s:11:\"description\";s:30:\"The name of the taxonomy term.\";}s:10:\"node-count\";a:2:{s:4:\"name\";s:10:\"Node count\";s:11:\"description\";s:50:\"The number of nodes tagged with the taxonomy term.\";}s:8:\"original\";a:4:{s:4:\"name\";s:22:\"Original taxonomy term\";s:11:\"description\";s:79:\"The original taxonomy term data if the taxonomy term is being updated or saved.\";s:6:\"module\";s:5:\"token\";s:4:\"type\";s:4:\"term\";}s:7:\"parents\";a:3:{s:4:\"name\";s:7:\"Parents\";s:11:\"description\";s:59:\"An array of all the term\'s parents, starting with the root.\";s:4:\"type\";s:5:\"array\";}s:6:\"parent\";a:3:{s:4:\"name\";s:11:\"Parent term\";s:11:\"description\";s:52:\"The parent term of the taxonomy term, if one exists.\";s:4:\"type\";s:4:\"term\";}s:4:\"root\";a:3:{s:4:\"name\";s:9:\"Root term\";s:11:\"description\";s:35:\"The root term of the taxonomy term.\";s:4:\"type\";s:4:\"term\";}s:3:\"tid\";a:2:{s:4:\"name\";s:7:\"Term ID\";s:11:\"description\";s:35:\"The unique ID of the taxonomy term.\";}s:3:\"url\";a:3:{s:4:\"name\";s:3:\"URL\";s:11:\"description\";s:29:\"The URL of the taxonomy term.\";s:4:\"type\";s:3:\"url\";}s:10:\"vocabulary\";a:3:{s:4:\"name\";s:10:\"Vocabulary\";s:11:\"description\";s:44:\"The vocabulary the taxonomy term belongs to.\";s:4:\"type\";s:10:\"vocabulary\";}s:6:\"weight\";a:4:{s:4:\"name\";s:6:\"Weight\";s:11:\"description\";s:72:\"The weight of the term, which is used for ordering terms during display.\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}}s:10:\"vocabulary\";a:8:{s:11:\"description\";a:2:{s:4:\"name\";s:11:\"Description\";s:11:\"description\";s:52:\"The optional description of the taxonomy vocabulary.\";}s:8:\"edit-url\";a:2:{s:4:\"name\";s:8:\"Edit URL\";s:11:\"description\";s:38:\"The URL of the vocabulary\'s edit page.\";}s:12:\"machine-name\";a:2:{s:4:\"name\";s:21:\"Machine-readable name\";s:11:\"description\";s:51:\"The unique machine-readable name of the vocabulary.\";}s:4:\"name\";a:2:{s:4:\"name\";s:4:\"Name\";s:11:\"description\";s:36:\"The name of the taxonomy vocabulary.\";}s:10:\"node-count\";a:2:{s:4:\"name\";s:10:\"Node count\";s:11:\"description\";s:75:\"The number of nodes tagged with terms belonging to the taxonomy vocabulary.\";}s:8:\"original\";a:4:{s:4:\"name\";s:28:\"Original taxonomy vocabulary\";s:11:\"description\";s:91:\"The original taxonomy vocabulary data if the taxonomy vocabulary is being updated or saved.\";s:6:\"module\";s:5:\"token\";s:4:\"type\";s:10:\"vocabulary\";}s:10:\"term-count\";a:2:{s:4:\"name\";s:10:\"Term count\";s:11:\"description\";s:57:\"The number of terms belonging to the taxonomy vocabulary.\";}s:3:\"vid\";a:2:{s:4:\"name\";s:13:\"Vocabulary ID\";s:11:\"description\";s:41:\"The unique ID of the taxonomy vocabulary.\";}}s:4:\"file\";a:12:{s:8:\"basename\";a:2:{s:4:\"name\";s:9:\"Base name\";s:11:\"description\";s:26:\"The base name of the file.\";}s:9:\"extension\";a:2:{s:4:\"name\";s:9:\"Extension\";s:11:\"description\";s:26:\"The extension of the file.\";}s:3:\"fid\";a:2:{s:4:\"name\";s:7:\"File ID\";s:11:\"description\";s:35:\"The unique ID of the uploaded file.\";}s:8:\"size-raw\";a:2:{s:4:\"name\";s:14:\"File byte size\";s:11:\"description\";s:31:\"The size of the file, in bytes.\";}s:4:\"name\";a:2:{s:4:\"name\";s:9:\"File name\";s:11:\"description\";s:29:\"The name of the file on disk.\";}s:4:\"size\";a:2:{s:4:\"name\";s:9:\"File size\";s:11:\"description\";s:21:\"The size of the file.\";}s:4:\"mime\";a:2:{s:4:\"name\";s:9:\"MIME type\";s:11:\"description\";s:26:\"The MIME type of the file.\";}s:8:\"original\";a:4:{s:4:\"name\";s:13:\"Original file\";s:11:\"description\";s:61:\"The original file data if the file is being updated or saved.\";s:6:\"module\";s:5:\"token\";s:4:\"type\";s:4:\"file\";}s:5:\"owner\";a:3:{s:4:\"name\";s:5:\"Owner\";s:11:\"description\";s:42:\"The user who originally uploaded the file.\";s:4:\"type\";s:4:\"user\";}s:4:\"path\";a:2:{s:4:\"name\";s:4:\"Path\";s:11:\"description\";s:49:\"The location of the file relative to Drupal root.\";}s:9:\"timestamp\";a:3:{s:4:\"name\";s:9:\"Timestamp\";s:11:\"description\";s:44:\"The date the file was most recently changed.\";s:4:\"type\";s:4:\"date\";}s:3:\"url\";a:2:{s:4:\"name\";s:3:\"URL\";s:11:\"description\";s:36:\"The web-accessible URL for the file.\";}}s:4:\"user\";a:16:{s:10:\"cancel-url\";a:3:{s:4:\"name\";s:24:\"Account cancellation URL\";s:11:\"description\";s:56:\"The URL of the confirm delete page for the user account.\";s:10:\"restricted\";b:1;}s:7:\"created\";a:3:{s:4:\"name\";s:7:\"Created\";s:11:\"description\";s:38:\"The date the user account was created.\";s:4:\"type\";s:4:\"date\";}s:5:\"theme\";a:4:{s:4:\"name\";s:13:\"Default theme\";s:11:\"description\";s:25:\"The user\'s default theme.\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:8:\"edit-url\";a:2:{s:4:\"name\";s:8:\"Edit URL\";s:11:\"description\";s:33:\"The URL of the account edit page.\";}s:4:\"mail\";a:2:{s:4:\"name\";s:5:\"Email\";s:11:\"description\";s:38:\"The email address of the user account.\";}s:11:\"last-access\";a:4:{s:4:\"name\";s:11:\"Last access\";s:11:\"description\";s:41:\"The date the user last accessed the site.\";s:4:\"type\";s:4:\"date\";s:12:\"entity-token\";b:1;}s:10:\"last-login\";a:3:{s:4:\"name\";s:10:\"Last login\";s:11:\"description\";s:45:\"The date the user last logged in to the site.\";s:4:\"type\";s:4:\"date\";}s:4:\"name\";a:2:{s:4:\"name\";s:4:\"Name\";s:11:\"description\";s:35:\"The login name of the user account.\";}s:18:\"one-time-login-url\";a:3:{s:4:\"name\";s:18:\"One-time login URL\";s:11:\"description\";s:56:\"The URL of the one-time login page for the user account.\";s:10:\"restricted\";b:1;}s:8:\"original\";a:4:{s:4:\"name\";s:13:\"Original user\";s:11:\"description\";s:61:\"The original user data if the user is being updated or saved.\";s:6:\"module\";s:5:\"token\";s:4:\"type\";s:4:\"user\";}s:7:\"picture\";a:3:{s:4:\"name\";s:7:\"Picture\";s:11:\"description\";s:24:\"The picture of the user.\";s:4:\"type\";s:4:\"file\";}s:5:\"roles\";a:3:{s:4:\"name\";s:5:\"Roles\";s:11:\"description\";s:48:\"The user roles associated with the user account.\";s:4:\"type\";s:5:\"array\";}s:6:\"status\";a:4:{s:4:\"name\";s:6:\"Status\";s:11:\"description\";s:38:\"Whether the user is active or blocked.\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:3:\"url\";a:3:{s:4:\"name\";s:3:\"URL\";s:11:\"description\";s:36:\"The URL of the account profile page.\";s:4:\"type\";s:3:\"url\";}s:3:\"uid\";a:2:{s:4:\"name\";s:7:\"User ID\";s:11:\"description\";s:34:\"The unique ID of the user account.\";}s:12:\"validate-url\";a:2:{s:4:\"name\";s:12:\"Validate URL\";s:11:\"description\";s:66:\"The URL of the account validation page, provided by logintoboggan.\";}}s:12:\"current-user\";a:17:{s:10:\"cancel-url\";a:3:{s:4:\"name\";s:24:\"Account cancellation URL\";s:11:\"description\";s:56:\"The URL of the confirm delete page for the user account.\";s:10:\"restricted\";b:1;}s:7:\"created\";a:3:{s:4:\"name\";s:7:\"Created\";s:11:\"description\";s:38:\"The date the user account was created.\";s:4:\"type\";s:4:\"date\";}s:5:\"theme\";a:4:{s:4:\"name\";s:13:\"Default theme\";s:11:\"description\";s:25:\"The user\'s default theme.\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:8:\"edit-url\";a:2:{s:4:\"name\";s:8:\"Edit URL\";s:11:\"description\";s:33:\"The URL of the account edit page.\";}s:4:\"mail\";a:2:{s:4:\"name\";s:5:\"Email\";s:11:\"description\";s:38:\"The email address of the user account.\";}s:10:\"ip-address\";a:2:{s:4:\"name\";s:10:\"IP address\";s:11:\"description\";s:35:\"The IP address of the current user.\";}s:11:\"last-access\";a:4:{s:4:\"name\";s:11:\"Last access\";s:11:\"description\";s:41:\"The date the user last accessed the site.\";s:4:\"type\";s:4:\"date\";s:12:\"entity-token\";b:1;}s:10:\"last-login\";a:3:{s:4:\"name\";s:10:\"Last login\";s:11:\"description\";s:45:\"The date the user last logged in to the site.\";s:4:\"type\";s:4:\"date\";}s:4:\"name\";a:2:{s:4:\"name\";s:4:\"Name\";s:11:\"description\";s:35:\"The login name of the user account.\";}s:18:\"one-time-login-url\";a:3:{s:4:\"name\";s:18:\"One-time login URL\";s:11:\"description\";s:56:\"The URL of the one-time login page for the user account.\";s:10:\"restricted\";b:1;}s:8:\"original\";a:4:{s:4:\"name\";s:13:\"Original user\";s:11:\"description\";s:61:\"The original user data if the user is being updated or saved.\";s:6:\"module\";s:5:\"token\";s:4:\"type\";s:4:\"user\";}s:7:\"picture\";a:3:{s:4:\"name\";s:7:\"Picture\";s:11:\"description\";s:24:\"The picture of the user.\";s:4:\"type\";s:4:\"file\";}s:5:\"roles\";a:3:{s:4:\"name\";s:5:\"Roles\";s:11:\"description\";s:48:\"The user roles associated with the user account.\";s:4:\"type\";s:5:\"array\";}s:6:\"status\";a:4:{s:4:\"name\";s:6:\"Status\";s:11:\"description\";s:38:\"Whether the user is active or blocked.\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:3:\"url\";a:3:{s:4:\"name\";s:3:\"URL\";s:11:\"description\";s:36:\"The URL of the account profile page.\";s:4:\"type\";s:3:\"url\";}s:3:\"uid\";a:2:{s:4:\"name\";s:7:\"User ID\";s:11:\"description\";s:34:\"The unique ID of the user account.\";}s:12:\"validate-url\";a:2:{s:4:\"name\";s:12:\"Validate URL\";s:11:\"description\";s:66:\"The URL of the account validation page, provided by logintoboggan.\";}}s:9:\"menu-link\";a:8:{s:8:\"edit-url\";a:2:{s:4:\"name\";s:8:\"Edit URL\";s:11:\"description\";s:37:\"The URL of the menu link\'s edit page.\";}s:4:\"mlid\";a:2:{s:4:\"name\";s:7:\"Link ID\";s:11:\"description\";s:31:\"The unique ID of the menu link.\";}s:4:\"menu\";a:3:{s:4:\"name\";s:4:\"Menu\";s:11:\"description\";s:26:\"The menu of the menu link.\";s:4:\"type\";s:4:\"menu\";}s:6:\"parent\";a:3:{s:4:\"name\";s:6:\"Parent\";s:11:\"description\";s:23:\"The menu link\'s parent.\";s:4:\"type\";s:9:\"menu-link\";}s:7:\"parents\";a:3:{s:4:\"name\";s:7:\"Parents\";s:11:\"description\";s:64:\"An array of all the menu link\'s parents, starting with the root.\";s:4:\"type\";s:5:\"array\";}s:4:\"root\";a:3:{s:4:\"name\";s:4:\"Root\";s:11:\"description\";s:21:\"The menu link\'s root.\";s:4:\"type\";s:9:\"menu-link\";}s:5:\"title\";a:2:{s:4:\"name\";s:5:\"Title\";s:11:\"description\";s:27:\"The title of the menu link.\";}s:3:\"url\";a:3:{s:4:\"name\";s:3:\"URL\";s:11:\"description\";s:25:\"The URL of the menu link.\";s:4:\"type\";s:3:\"url\";}}s:12:\"current-page\";a:4:{s:11:\"page-number\";a:2:{s:4:\"name\";s:11:\"Page number\";s:11:\"description\";s:61:\"The page number of the current page when viewing paged lists.\";}s:5:\"query\";a:3:{s:4:\"name\";s:18:\"Query string value\";s:11:\"description\";s:63:\"The value of a specific query string field of the current page.\";s:7:\"dynamic\";b:1;}s:5:\"title\";a:2:{s:4:\"name\";s:5:\"Title\";s:11:\"description\";s:30:\"The title of the current page.\";}s:3:\"url\";a:3:{s:4:\"name\";s:3:\"URL\";s:11:\"description\";s:28:\"The URL of the current page.\";s:4:\"type\";s:3:\"url\";}}s:3:\"url\";a:6:{s:8:\"absolute\";a:2:{s:4:\"name\";s:12:\"Absolute URL\";s:11:\"description\";s:17:\"The absolute URL.\";}s:4:\"args\";a:3:{s:4:\"name\";s:9:\"Arguments\";s:11:\"description\";s:90:\"The specific argument of the current page (e.g. \'arg:1\' on the page \'node/1\' returns \'1\').\";s:4:\"type\";s:5:\"array\";}s:5:\"brief\";a:2:{s:4:\"name\";s:9:\"Brief URL\";s:11:\"description\";s:52:\"The URL without the protocol and trailing backslash.\";}s:4:\"path\";a:2:{s:4:\"name\";s:4:\"Path\";s:11:\"description\";s:30:\"The path component of the URL.\";}s:8:\"relative\";a:2:{s:4:\"name\";s:12:\"Relative URL\";s:11:\"description\";s:17:\"The relative URL.\";}s:9:\"unaliased\";a:3:{s:4:\"name\";s:13:\"Unaliased URL\";s:11:\"description\";s:18:\"The unaliased URL.\";s:4:\"type\";s:3:\"url\";}}s:5:\"array\";a:8:{s:5:\"count\";a:2:{s:4:\"name\";s:5:\"Count\";s:11:\"description\";s:36:\"The number of elements in the array.\";}s:5:\"first\";a:2:{s:4:\"name\";s:5:\"First\";s:11:\"description\";s:31:\"The first element of the array.\";}s:4:\"join\";a:3:{s:4:\"name\";s:8:\"Imploded\";s:11:\"description\";s:83:\"The values of the array joined together with a custom string in-between each value.\";s:7:\"dynamic\";b:1;}s:9:\"join-path\";a:2:{s:4:\"name\";s:11:\"Joined path\";s:11:\"description\";s:109:\"The array values each cleaned by Pathauto and then joined with the slash into a string that resembles an URL.\";}s:4:\"keys\";a:3:{s:4:\"name\";s:4:\"Keys\";s:11:\"description\";s:31:\"The array of keys of the array.\";s:4:\"type\";s:5:\"array\";}s:4:\"last\";a:2:{s:4:\"name\";s:4:\"Last\";s:11:\"description\";s:30:\"The last element of the array.\";}s:8:\"reversed\";a:3:{s:4:\"name\";s:8:\"Reversed\";s:11:\"description\";s:19:\"The array reversed.\";s:4:\"type\";s:5:\"array\";}s:5:\"value\";a:3:{s:4:\"name\";s:5:\"Value\";s:11:\"description\";s:32:\"The specific value of the array.\";s:7:\"dynamic\";b:1;}}s:6:\"random\";a:2:{s:4:\"hash\";a:3:{s:4:\"name\";s:4:\"Hash\";s:11:\"description\";s:478:\"A random hash. The possible hashing algorithms are: md2, md4, md5, sha1, sha224, sha256, sha384, sha512, ripemd128, ripemd160, ripemd256, ripemd320, whirlpool, tiger128,3, tiger160,3, tiger192,3, tiger128,4, tiger160,4, tiger192,4, snefru, snefru256, gost, adler32, crc32, crc32b, salsa10, salsa20, haval128,3, haval160,3, haval192,3, haval224,3, haval256,3, haval128,4, haval160,4, haval192,4, haval224,4, haval256,4, haval128,5, haval160,5, haval192,5, haval224,5, haval256,5.\";s:7:\"dynamic\";b:1;}s:6:\"number\";a:2:{s:4:\"name\";s:6:\"Number\";s:11:\"description\";s:37:\"A random number from 0 to 2147483647.\";}}s:7:\"comment\";a:18:{s:6:\"author\";a:3:{s:4:\"name\";s:6:\"Author\";s:11:\"description\";s:50:\"The author of the comment, if they were logged in.\";s:4:\"type\";s:4:\"user\";}s:3:\"cid\";a:2:{s:4:\"name\";s:10:\"Comment ID\";s:11:\"description\";s:29:\"The unique ID of the comment.\";}s:4:\"body\";a:2:{s:4:\"name\";s:7:\"Content\";s:11:\"description\";s:44:\"The formatted content of the comment itself.\";}s:7:\"changed\";a:3:{s:4:\"name\";s:12:\"Date changed\";s:11:\"description\";s:47:\"The date the comment was most recently updated.\";s:4:\"type\";s:4:\"date\";}s:7:\"created\";a:3:{s:4:\"name\";s:12:\"Date created\";s:11:\"description\";s:32:\"The date the comment was posted.\";s:4:\"type\";s:4:\"date\";}s:8:\"edit-url\";a:2:{s:4:\"name\";s:8:\"Edit URL\";s:11:\"description\";s:35:\"The URL of the comment\'s edit page.\";}s:4:\"mail\";a:2:{s:4:\"name\";s:13:\"Email address\";s:11:\"description\";s:45:\"The email address left by the comment author.\";}s:8:\"homepage\";a:2:{s:4:\"name\";s:9:\"Home page\";s:11:\"description\";s:45:\"The home page URL left by the comment author.\";}s:8:\"hostname\";a:2:{s:4:\"name\";s:10:\"IP Address\";s:11:\"description\";s:59:\"The IP address of the computer the comment was posted from.\";}s:4:\"name\";a:2:{s:4:\"name\";s:4:\"Name\";s:11:\"description\";s:36:\"The name left by the comment author.\";}s:4:\"node\";a:3:{s:4:\"name\";s:4:\"Node\";s:11:\"description\";s:35:\"The node the comment was posted to.\";s:4:\"type\";s:4:\"node\";}s:8:\"original\";a:4:{s:4:\"name\";s:16:\"Original comment\";s:11:\"description\";s:67:\"The original comment data if the comment is being updated or saved.\";s:6:\"module\";s:5:\"token\";s:4:\"type\";s:7:\"comment\";}s:6:\"parent\";a:3:{s:4:\"name\";s:6:\"Parent\";s:11:\"description\";s:53:\"The comment\'s parent, if comment threading is active.\";s:4:\"type\";s:7:\"comment\";}s:6:\"status\";a:4:{s:4:\"name\";s:6:\"Status\";s:11:\"description\";s:48:\"Whether the comment is published or unpublished.\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:7:\"subject\";a:4:{s:4:\"name\";s:7:\"Subject\";s:11:\"description\";s:27:\"The subject of the comment.\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:12:\"comment-body\";a:5:{s:4:\"name\";s:18:\"The main body text\";s:11:\"description\";s:108:\"The main body text The following properties may be appended to the token: value (Text), format (Text format)\";s:4:\"type\";s:6:\"struct\";s:12:\"entity-token\";b:1;s:7:\"dynamic\";b:1;}s:5:\"title\";a:2:{s:4:\"name\";s:5:\"Title\";s:11:\"description\";s:25:\"The title of the comment.\";}s:3:\"url\";a:3:{s:4:\"name\";s:3:\"URL\";s:11:\"description\";s:23:\"The URL of the comment.\";s:4:\"type\";s:3:\"url\";}}s:8:\"computed\";a:1:{s:8:\"rawvalue\";a:2:{s:4:\"name\";s:18:\"Raw computed value\";s:11:\"description\";s:78:\"Computed field <em class=\"placeholder\">field_vdisk_hit_rate_pc</em> raw value.\";}}s:16:\"date-field-value\";a:2:{s:4:\"date\";a:3:{s:4:\"name\";s:4:\"Date\";s:11:\"description\";s:15:\"The date value.\";s:4:\"type\";s:4:\"date\";}s:7:\"to-date\";a:3:{s:4:\"name\";s:8:\"End Date\";s:11:\"description\";s:19:\"The End date value.\";s:4:\"type\";s:4:\"date\";}}s:4:\"menu\";a:5:{s:11:\"description\";a:2:{s:4:\"name\";s:11:\"Description\";s:11:\"description\";s:37:\"The optional description of the menu.\";}s:8:\"edit-url\";a:2:{s:4:\"name\";s:8:\"Edit URL\";s:11:\"description\";s:32:\"The URL of the menu\'s edit page.\";}s:12:\"machine-name\";a:2:{s:4:\"name\";s:21:\"Machine-readable name\";s:11:\"description\";s:45:\"The unique machine-readable name of the menu.\";}s:15:\"menu-link-count\";a:2:{s:4:\"name\";s:15:\"Menu link count\";s:11:\"description\";s:47:\"The number of menu links belonging to the menu.\";}s:4:\"name\";a:2:{s:4:\"name\";s:4:\"Name\";s:11:\"description\";s:21:\"The name of the menu.\";}}s:4:\"site\";a:9:{s:12:\"current-date\";a:4:{s:4:\"name\";s:12:\"Current date\";s:11:\"description\";s:26:\"The current date and time.\";s:4:\"type\";s:4:\"date\";s:12:\"entity-token\";b:1;}s:12:\"current-page\";a:5:{s:4:\"name\";s:12:\"Current page\";s:11:\"description\";s:126:\"Information related to the current page request. The following properties may be appended to the token: path (Path), url (URL)\";s:4:\"type\";s:6:\"struct\";s:12:\"entity-token\";b:1;s:7:\"dynamic\";b:1;}s:4:\"mail\";a:2:{s:4:\"name\";s:5:\"Email\";s:11:\"description\";s:46:\"The administrative email address for the site.\";}s:12:\"current-user\";a:4:{s:4:\"name\";s:14:\"Logged in user\";s:11:\"description\";s:29:\"The currently logged in user.\";s:4:\"type\";s:4:\"user\";s:12:\"entity-token\";b:1;}s:9:\"login-url\";a:2:{s:4:\"name\";s:10:\"Login page\";s:11:\"description\";s:33:\"The URL of the site\'s login page.\";}s:4:\"name\";a:2:{s:4:\"name\";s:4:\"Name\";s:11:\"description\";s:21:\"The name of the site.\";}s:6:\"slogan\";a:2:{s:4:\"name\";s:6:\"Slogan\";s:11:\"description\";s:23:\"The slogan of the site.\";}s:3:\"url\";a:2:{s:4:\"name\";s:3:\"URL\";s:11:\"description\";s:33:\"The URL of the site\'s front page.\";}s:9:\"url-brief\";a:2:{s:4:\"name\";s:11:\"URL (brief)\";s:11:\"description\";s:54:\"The URL of the site\'s front page without the protocol.\";}}s:4:\"date\";a:6:{s:6:\"custom\";a:3:{s:4:\"name\";s:13:\"Custom format\";s:11:\"description\";s:122:\"A date in a custom format. See <a href=\"http://php.net/manual/en/function.date.php\">the PHP documentation</a> for details.\";s:7:\"dynamic\";b:1;}s:4:\"long\";a:2:{s:4:\"name\";s:11:\"Long format\";s:11:\"description\";s:88:\"A date in \'long\' format. (<em class=\"placeholder\">Wednesday, June 19, 2013 - 11:38</em>)\";}s:6:\"medium\";a:2:{s:4:\"name\";s:13:\"Medium format\";s:11:\"description\";s:81:\"A date in \'medium\' format. (<em class=\"placeholder\">Wed, 06/19/2013 - 11:38</em>)\";}s:3:\"raw\";a:2:{s:4:\"name\";s:13:\"Raw timestamp\";s:11:\"description\";s:73:\"A date in UNIX timestamp format (<em class=\"placeholder\">1371656313</em>)\";}s:5:\"short\";a:2:{s:4:\"name\";s:12:\"Short format\";s:11:\"description\";s:75:\"A date in \'short\' format. (<em class=\"placeholder\">06/19/2013 - 11:38</em>)\";}s:5:\"since\";a:2:{s:4:\"name\";s:10:\"Time-since\";s:11:\"description\";s:79:\"A date in \'time-since\' format. (<em class=\"placeholder\">43 years 6 months</em>)\";}}s:4:\"view\";a:5:{s:11:\"description\";a:2:{s:4:\"name\";s:11:\"Description\";s:11:\"description\";s:28:\"The description of the view.\";}s:12:\"machine-name\";a:2:{s:4:\"name\";s:12:\"Machine name\";s:11:\"description\";s:38:\"The machine-readable name of the view.\";}s:4:\"name\";a:2:{s:4:\"name\";s:4:\"Name\";s:11:\"description\";s:36:\"The human-readable name of the view.\";}s:5:\"title\";a:2:{s:4:\"name\";s:5:\"Title\";s:11:\"description\";s:41:\"The title of current display of the view.\";}s:3:\"url\";a:3:{s:4:\"name\";s:3:\"URL\";s:11:\"description\";s:20:\"The URL of the view.\";s:4:\"type\";s:3:\"url\";}}s:17:\"search_api_server\";a:5:{s:11:\"description\";a:4:{s:4:\"name\";s:11:\"Description\";s:11:\"description\";s:39:\"The displayed description for a server.\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:7:\"enabled\";a:4:{s:4:\"name\";s:7:\"Enabled\";s:11:\"description\";s:48:\"A flag indicating whether the server is enabled.\";s:4:\"type\";s:7:\"boolean\";s:12:\"entity-token\";b:1;}s:2:\"id\";a:4:{s:4:\"name\";s:2:\"ID\";s:11:\"description\";s:36:\"The primary identifier for a server.\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:4:\"name\";a:4:{s:4:\"name\";s:4:\"Name\";s:11:\"description\";s:32:\"The displayed name for a server.\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:5:\"class\";a:4:{s:4:\"name\";s:13:\"Service class\";s:11:\"description\";s:51:\"The ID of the service class to use for this server.\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}}s:16:\"search_api_index\";a:6:{s:11:\"description\";a:4:{s:4:\"name\";s:11:\"Description\";s:11:\"description\";s:44:\"A string describing the index\' use to users.\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:7:\"enabled\";a:4:{s:4:\"name\";s:7:\"Enabled\";s:11:\"description\";s:47:\"A flag indicating whether the index is enabled.\";s:4:\"type\";s:7:\"boolean\";s:12:\"entity-token\";b:1;}s:2:\"id\";a:4:{s:4:\"name\";s:2:\"ID\";s:11:\"description\";s:33:\"An integer identifying the index.\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:4:\"name\";a:4:{s:4:\"name\";s:4:\"Name\";s:11:\"description\";s:37:\"A name to be displayed for the index.\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:9:\"read-only\";a:4:{s:4:\"name\";s:9:\"Read only\";s:11:\"description\";s:49:\"A flag indicating whether the index is read-only.\";s:4:\"type\";s:7:\"boolean\";s:12:\"entity-token\";b:1;}s:13:\"server-entity\";a:4:{s:4:\"name\";s:6:\"Server\";s:11:\"description\";s:56:\"The search_api_server with which data should be indexed.\";s:4:\"type\";s:17:\"search_api_server\";s:12:\"entity-token\";b:1;}}s:15:\"search_api_page\";a:5:{s:11:\"description\";a:4:{s:4:\"name\";s:11:\"Description\";s:11:\"description\";s:44:\"The displayed description for a search page.\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}s:7:\"enabled\";a:4:{s:4:\"name\";s:7:\"Enabled\";s:11:\"description\";s:53:\"A flag indicating whether the search page is enabled.\";s:4:\"type\";s:7:\"boolean\";s:12:\"entity-token\";b:1;}s:2:\"id\";a:4:{s:4:\"name\";s:2:\"ID\";s:11:\"description\";s:41:\"The primary identifier for a search page.\";s:4:\"type\";s:7:\"integer\";s:12:\"entity-token\";b:1;}s:5:\"index\";a:4:{s:4:\"name\";s:5:\"Index\";s:11:\"description\";s:32:\"The index this search page uses.\";s:4:\"type\";s:16:\"search_api_index\";s:12:\"entity-token\";b:1;}s:4:\"name\";a:4:{s:4:\"name\";s:4:\"Name\";s:11:\"description\";s:37:\"The displayed name for a search page.\";s:4:\"type\";s:4:\"text\";s:12:\"entity-token\";b:1;}}s:13:\"list<comment>\";a:4:{i:0;a:3:{s:4:\"name\";s:21:\"Comments with delta 0\";s:11:\"description\";s:95:\"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:7:\"comment\";}i:1;a:3:{s:4:\"name\";s:21:\"Comments with delta 1\";s:11:\"description\";s:95:\"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:7:\"comment\";}i:2;a:3:{s:4:\"name\";s:21:\"Comments with delta 2\";s:11:\"description\";s:95:\"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:7:\"comment\";}i:3;a:3:{s:4:\"name\";s:21:\"Comments with delta 3\";s:11:\"description\";s:95:\"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:7:\"comment\";}}s:10:\"list<node>\";a:4:{i:0;a:3:{s:4:\"name\";s:18:\"Nodes with delta 0\";s:11:\"description\";s:95:\"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:4:\"node\";}i:1;a:3:{s:4:\"name\";s:18:\"Nodes with delta 1\";s:11:\"description\";s:95:\"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:4:\"node\";}i:2;a:3:{s:4:\"name\";s:18:\"Nodes with delta 2\";s:11:\"description\";s:95:\"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:4:\"node\";}i:3;a:3:{s:4:\"name\";s:18:\"Nodes with delta 3\";s:11:\"description\";s:95:\"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:4:\"node\";}}s:23:\"list<search_api_server>\";a:4:{i:0;a:3:{s:4:\"name\";s:26:\"Search server with delta 0\";s:11:\"description\";s:95:\"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:17:\"search_api_server\";}i:1;a:3:{s:4:\"name\";s:26:\"Search server with delta 1\";s:11:\"description\";s:95:\"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:17:\"search_api_server\";}i:2;a:3:{s:4:\"name\";s:26:\"Search server with delta 2\";s:11:\"description\";s:95:\"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:17:\"search_api_server\";}i:3;a:3:{s:4:\"name\";s:26:\"Search server with delta 3\";s:11:\"description\";s:95:\"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:17:\"search_api_server\";}}s:22:\"list<search_api_index>\";a:4:{i:0;a:3:{s:4:\"name\";s:25:\"Search index with delta 0\";s:11:\"description\";s:95:\"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:16:\"search_api_index\";}i:1;a:3:{s:4:\"name\";s:25:\"Search index with delta 1\";s:11:\"description\";s:95:\"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:16:\"search_api_index\";}i:2;a:3:{s:4:\"name\";s:25:\"Search index with delta 2\";s:11:\"description\";s:95:\"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:16:\"search_api_index\";}i:3;a:3:{s:4:\"name\";s:25:\"Search index with delta 3\";s:11:\"description\";s:95:\"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:16:\"search_api_index\";}}s:21:\"list<search_api_page>\";a:4:{i:0;a:3:{s:4:\"name\";s:24:\"Search page with delta 0\";s:11:\"description\";s:95:\"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:15:\"search_api_page\";}i:1;a:3:{s:4:\"name\";s:24:\"Search page with delta 1\";s:11:\"description\";s:95:\"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:15:\"search_api_page\";}i:2;a:3:{s:4:\"name\";s:24:\"Search page with delta 2\";s:11:\"description\";s:95:\"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:15:\"search_api_page\";}i:3;a:3:{s:4:\"name\";s:24:\"Search page with delta 3\";s:11:\"description\";s:95:\"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:15:\"search_api_page\";}}s:10:\"list<file>\";a:4:{i:0;a:3:{s:4:\"name\";s:18:\"Files with delta 0\";s:11:\"description\";s:95:\"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:4:\"file\";}i:1;a:3:{s:4:\"name\";s:18:\"Files with delta 1\";s:11:\"description\";s:95:\"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:4:\"file\";}i:2;a:3:{s:4:\"name\";s:18:\"Files with delta 2\";s:11:\"description\";s:95:\"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:4:\"file\";}i:3;a:3:{s:4:\"name\";s:18:\"Files with delta 3\";s:11:\"description\";s:95:\"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:4:\"file\";}}s:10:\"list<term>\";a:4:{i:0;a:3:{s:4:\"name\";s:27:\"Taxonomy terms with delta 0\";s:11:\"description\";s:95:\"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:4:\"term\";}i:1;a:3:{s:4:\"name\";s:27:\"Taxonomy terms with delta 1\";s:11:\"description\";s:95:\"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:4:\"term\";}i:2;a:3:{s:4:\"name\";s:27:\"Taxonomy terms with delta 2\";s:11:\"description\";s:95:\"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:4:\"term\";}i:3;a:3:{s:4:\"name\";s:27:\"Taxonomy terms with delta 3\";s:11:\"description\";s:95:\"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:4:\"term\";}}s:16:\"list<vocabulary>\";a:4:{i:0;a:3:{s:4:\"name\";s:25:\"Vocabularies with delta 0\";s:11:\"description\";s:95:\"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:10:\"vocabulary\";}i:1;a:3:{s:4:\"name\";s:25:\"Vocabularies with delta 1\";s:11:\"description\";s:95:\"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:10:\"vocabulary\";}i:2;a:3:{s:4:\"name\";s:25:\"Vocabularies with delta 2\";s:11:\"description\";s:95:\"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:10:\"vocabulary\";}i:3;a:3:{s:4:\"name\";s:25:\"Vocabularies with delta 3\";s:11:\"description\";s:95:\"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:10:\"vocabulary\";}}s:10:\"list<user>\";a:4:{i:0;a:3:{s:4:\"name\";s:18:\"Users with delta 0\";s:11:\"description\";s:95:\"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:4:\"user\";}i:1;a:3:{s:4:\"name\";s:18:\"Users with delta 1\";s:11:\"description\";s:95:\"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:4:\"user\";}i:2;a:3:{s:4:\"name\";s:18:\"Users with delta 2\";s:11:\"description\";s:95:\"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:4:\"user\";}i:3;a:3:{s:4:\"name\";s:18:\"Users with delta 3\";s:11:\"description\";s:95:\"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:4:\"user\";}}s:10:\"list<date>\";a:4:{i:0;a:3:{s:4:\"name\";s:18:\"Dates with delta 0\";s:11:\"description\";s:95:\"The list item with delta 0. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:4:\"date\";}i:1;a:3:{s:4:\"name\";s:18:\"Dates with delta 1\";s:11:\"description\";s:95:\"The list item with delta 1. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:4:\"date\";}i:2;a:3:{s:4:\"name\";s:18:\"Dates with delta 2\";s:11:\"description\";s:95:\"The list item with delta 2. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:4:\"date\";}i:3;a:3:{s:4:\"name\";s:18:\"Dates with delta 3\";s:11:\"description\";s:95:\"The list item with delta 3. Delta values start from 0 and are incremented by one per list item.\";s:4:\"type\";s:4:\"date\";}}s:12:\"current-date\";a:6:{s:6:\"custom\";a:3:{s:4:\"name\";s:13:\"Custom format\";s:11:\"description\";s:122:\"A date in a custom format. See <a href=\"http://php.net/manual/en/function.date.php\">the PHP documentation</a> for details.\";s:7:\"dynamic\";b:1;}s:4:\"long\";a:2:{s:4:\"name\";s:11:\"Long format\";s:11:\"description\";s:88:\"A date in \'long\' format. (<em class=\"placeholder\">Wednesday, June 19, 2013 - 11:38</em>)\";}s:6:\"medium\";a:2:{s:4:\"name\";s:13:\"Medium format\";s:11:\"description\";s:81:\"A date in \'medium\' format. (<em class=\"placeholder\">Wed, 06/19/2013 - 11:38</em>)\";}s:3:\"raw\";a:2:{s:4:\"name\";s:13:\"Raw timestamp\";s:11:\"description\";s:73:\"A date in UNIX timestamp format (<em class=\"placeholder\">1371656313</em>)\";}s:5:\"short\";a:2:{s:4:\"name\";s:12:\"Short format\";s:11:\"description\";s:75:\"A date in \'short\' format. (<em class=\"placeholder\">06/19/2013 - 11:38</em>)\";}s:5:\"since\";a:2:{s:4:\"name\";s:10:\"Time-since\";s:11:\"description\";s:79:\"A date in \'time-since\' format. (<em class=\"placeholder\">43 years 6 months</em>)\";}}}s:5:\"types\";a:33:{s:5:\"array\";a:4:{s:4:\"name\";s:5:\"Array\";s:11:\"description\";s:36:\"Tokens related to arrays of strings.\";s:10:\"needs-data\";s:5:\"array\";s:4:\"type\";s:5:\"array\";}s:7:\"comment\";a:4:{s:4:\"name\";s:8:\"Comments\";s:11:\"description\";s:39:\"Tokens for comments posted on the site.\";s:10:\"needs-data\";s:7:\"comment\";s:4:\"type\";s:7:\"comment\";}s:8:\"computed\";a:4:{s:4:\"name\";s:8:\"Computed\";s:11:\"description\";s:34:\"Tokens related to Computed fields.\";s:10:\"needs-data\";s:4:\"node\";s:4:\"type\";s:8:\"computed\";}s:12:\"content-type\";a:4:{s:4:\"name\";s:13:\"Content types\";s:11:\"description\";s:32:\"Tokens related to content types.\";s:10:\"needs-data\";s:9:\"node_type\";s:4:\"type\";s:12:\"content-type\";}s:12:\"current-date\";a:3:{s:4:\"name\";s:12:\"Current date\";s:11:\"description\";s:44:\"Tokens related to the current date and time.\";s:4:\"type\";s:4:\"date\";}s:12:\"current-page\";a:3:{s:4:\"name\";s:12:\"Current page\";s:11:\"description\";s:43:\"Tokens related to the current page request.\";s:4:\"type\";s:12:\"current-page\";}s:12:\"current-user\";a:3:{s:4:\"name\";s:12:\"Current user\";s:11:\"description\";s:47:\"Tokens related to the currently logged in user.\";s:4:\"type\";s:4:\"user\";}s:16:\"date-field-value\";a:5:{s:4:\"name\";s:17:\"Date field values\";s:11:\"description\";s:36:\"Tokens related to date field values.\";s:10:\"needs-data\";s:16:\"date-field-value\";s:11:\"field-value\";b:1;s:4:\"type\";s:16:\"date-field-value\";}s:4:\"date\";a:4:{s:4:\"name\";s:5:\"Dates\";s:11:\"description\";s:34:\"Tokens related to times and dates.\";s:10:\"needs-data\";s:4:\"date\";s:4:\"type\";s:4:\"date\";}s:4:\"file\";a:4:{s:4:\"name\";s:5:\"Files\";s:11:\"description\";s:33:\"Tokens related to uploaded files.\";s:10:\"needs-data\";s:4:\"file\";s:4:\"type\";s:4:\"file\";}s:13:\"list<comment>\";a:4:{s:4:\"name\";s:16:\"List of Comments\";s:11:\"description\";s:41:\"Tokens related to the \"Comment\" entities.\";s:10:\"needs-data\";s:13:\"list<comment>\";s:4:\"type\";s:13:\"list<comment>\";}s:10:\"list<file>\";a:4:{s:4:\"name\";s:13:\"List of Files\";s:11:\"description\";s:38:\"Tokens related to the \"File\" entities.\";s:10:\"needs-data\";s:10:\"list<file>\";s:4:\"type\";s:10:\"list<file>\";}s:10:\"list<node>\";a:4:{s:4:\"name\";s:13:\"List of Nodes\";s:11:\"description\";s:38:\"Tokens related to the \"Node\" entities.\";s:10:\"needs-data\";s:10:\"list<node>\";s:4:\"type\";s:10:\"list<node>\";}s:22:\"list<search_api_index>\";a:4:{s:4:\"name\";s:21:\"List of Search indexs\";s:11:\"description\";s:46:\"Tokens related to the \"Search index\" entities.\";s:10:\"needs-data\";s:22:\"list<search_api_index>\";s:4:\"type\";s:22:\"list<search_api_index>\";}s:21:\"list<search_api_page>\";a:4:{s:4:\"name\";s:20:\"List of Search pages\";s:11:\"description\";s:45:\"Tokens related to the \"Search page\" entities.\";s:10:\"needs-data\";s:21:\"list<search_api_page>\";s:4:\"type\";s:21:\"list<search_api_page>\";}s:23:\"list<search_api_server>\";a:4:{s:4:\"name\";s:22:\"List of Search servers\";s:11:\"description\";s:47:\"Tokens related to the \"Search server\" entities.\";s:10:\"needs-data\";s:23:\"list<search_api_server>\";s:4:\"type\";s:23:\"list<search_api_server>\";}s:10:\"list<term>\";a:4:{s:4:\"name\";s:22:\"List of Taxonomy terms\";s:11:\"description\";s:47:\"Tokens related to the \"Taxonomy term\" entities.\";s:10:\"needs-data\";s:10:\"list<term>\";s:4:\"type\";s:10:\"list<term>\";}s:16:\"list<vocabulary>\";a:4:{s:4:\"name\";s:29:\"List of Taxonomy vocabularies\";s:11:\"description\";s:53:\"Tokens related to the \"Taxonomy vocabulary\" entities.\";s:10:\"needs-data\";s:16:\"list<vocabulary>\";s:4:\"type\";s:16:\"list<vocabulary>\";}s:10:\"list<user>\";a:4:{s:4:\"name\";s:13:\"List of Users\";s:11:\"description\";s:38:\"Tokens related to the \"User\" entities.\";s:10:\"needs-data\";s:10:\"list<user>\";s:4:\"type\";s:10:\"list<user>\";}s:10:\"list<date>\";a:4:{s:4:\"name\";s:19:\"List of date values\";s:11:\"description\";s:32:\"Tokens for lists of date values.\";s:10:\"needs-data\";s:10:\"list<date>\";s:4:\"type\";s:10:\"list<date>\";}s:9:\"menu-link\";a:4:{s:4:\"name\";s:10:\"Menu links\";s:11:\"description\";s:29:\"Tokens related to menu links.\";s:10:\"needs-data\";s:9:\"menu-link\";s:4:\"type\";s:9:\"menu-link\";}s:4:\"menu\";a:4:{s:4:\"name\";s:5:\"Menus\";s:11:\"description\";s:24:\"Tokens related to menus.\";s:10:\"needs-data\";s:4:\"menu\";s:4:\"type\";s:4:\"menu\";}s:4:\"node\";a:4:{s:4:\"name\";s:5:\"Nodes\";s:11:\"description\";s:55:\"Tokens related to individual content items, or \"nodes\".\";s:10:\"needs-data\";s:4:\"node\";s:4:\"type\";s:4:\"node\";}s:6:\"random\";a:3:{s:4:\"name\";s:6:\"Random\";s:11:\"description\";s:30:\"Tokens related to random data.\";s:4:\"type\";s:6:\"random\";}s:16:\"search_api_index\";a:4:{s:4:\"name\";s:12:\"Search index\";s:11:\"description\";s:46:\"Tokens related to the \"Search index\" entities.\";s:10:\"needs-data\";s:16:\"search_api_index\";s:4:\"type\";s:16:\"search_api_index\";}s:15:\"search_api_page\";a:4:{s:4:\"name\";s:11:\"Search page\";s:11:\"description\";s:45:\"Tokens related to the \"Search page\" entities.\";s:10:\"needs-data\";s:15:\"search_api_page\";s:4:\"type\";s:15:\"search_api_page\";}s:17:\"search_api_server\";a:4:{s:4:\"name\";s:13:\"Search server\";s:11:\"description\";s:47:\"Tokens related to the \"Search server\" entities.\";s:10:\"needs-data\";s:17:\"search_api_server\";s:4:\"type\";s:17:\"search_api_server\";}s:4:\"site\";a:3:{s:4:\"name\";s:16:\"Site information\";s:11:\"description\";s:59:\"Tokens for site-wide settings and other global information.\";s:4:\"type\";s:4:\"site\";}s:4:\"term\";a:4:{s:4:\"name\";s:14:\"Taxonomy terms\";s:11:\"description\";s:33:\"Tokens related to taxonomy terms.\";s:10:\"needs-data\";s:4:\"term\";s:4:\"type\";s:4:\"term\";}s:3:\"url\";a:4:{s:4:\"name\";s:3:\"URL\";s:11:\"description\";s:23:\"Tokens related to URLs.\";s:10:\"needs-data\";s:4:\"path\";s:4:\"type\";s:3:\"url\";}s:4:\"user\";a:4:{s:4:\"name\";s:5:\"Users\";s:11:\"description\";s:43:\"Tokens related to individual user accounts.\";s:10:\"needs-data\";s:4:\"user\";s:4:\"type\";s:4:\"user\";}s:4:\"view\";a:4:{s:4:\"name\";s:4:\"View\";s:11:\"description\";s:24:\"Tokens related to views.\";s:10:\"needs-data\";s:4:\"view\";s:4:\"type\";s:4:\"view\";}s:10:\"vocabulary\";a:4:{s:4:\"name\";s:12:\"Vocabularies\";s:11:\"description\";s:40:\"Tokens related to taxonomy vocabularies.\";s:10:\"needs-data\";s:10:\"vocabulary\";s:4:\"type\";s:10:\"vocabulary\";}}}',0,1371656313,1);
/*!40000 ALTER TABLE `cache_token` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_update`
--

DROP TABLE IF EXISTS `cache_update`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_update` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Cache table for the Update module to store information...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_update`
--

LOCK TABLES `cache_update` WRITE;
/*!40000 ALTER TABLE `cache_update` DISABLE KEYS */;
INSERT INTO `cache_update` VALUES ('fetch_task::mercury',NULL,0,1355685380,0);
/*!40000 ALTER TABLE `cache_update` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_views`
--

DROP TABLE IF EXISTS `cache_views`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_views` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Generic cache table for caching things not separated out...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_views`
--

LOCK TABLES `cache_views` WRITE;
/*!40000 ALTER TABLE `cache_views` DISABLE KEYS */;
INSERT INTO `cache_views` VALUES ('views_data:en','a:344:{s:8:\"comments\";a:8:{s:8:\"moved to\";s:7:\"comment\";s:9:\"timestamp\";a:1:{s:8:\"moved to\";a:2:{i:0;s:7:\"comment\";i:1;s:7:\"changed\";}}s:18:\"timestamp_fulldate\";a:1:{s:8:\"moved to\";a:2:{i:0;s:7:\"comment\";i:1;s:16:\"changed_fulldata\";}}s:20:\"timestamp_year_month\";a:1:{s:8:\"moved to\";a:2:{i:0;s:7:\"comment\";i:1;s:18:\"changed_year_month\";}}s:14:\"timestamp_year\";a:1:{s:8:\"moved to\";a:2:{i:0;s:7:\"comment\";i:1;s:12:\"changed_year\";}}s:15:\"timestamp_month\";a:1:{s:8:\"moved to\";a:2:{i:0;s:7:\"comment\";i:1;s:13:\"changed_month\";}}s:13:\"timestamp_day\";a:1:{s:8:\"moved to\";a:2:{i:0;s:7:\"comment\";i:1;s:11:\"changed_day\";}}s:14:\"timestamp_week\";a:1:{s:8:\"moved to\";a:2:{i:0;s:7:\"comment\";i:1;s:12:\"changed_week\";}}}s:7:\"comment\";a:28:{s:7:\"comment\";a:2:{s:8:\"moved to\";a:2:{i:0;s:23:\"field_data_comment_body\";i:1;s:12:\"comment_body\";}s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:23:\"field_data_comment_body\";i:1;s:12:\"comment_body\";}}}s:5:\"table\";a:4:{s:5:\"group\";s:7:\"Comment\";s:4:\"base\";a:4:{s:5:\"field\";s:3:\"cid\";s:5:\"title\";s:7:\"Comment\";s:4:\"help\";s:39:\"Comments are responses to node content.\";s:16:\"access query tag\";s:14:\"comment_access\";}s:11:\"entity type\";s:7:\"comment\";s:20:\"default_relationship\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"cid\";}}}s:7:\"subject\";a:6:{s:5:\"title\";s:5:\"Title\";s:4:\"help\";s:25:\"The title of the comment.\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_comment\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:3:\"cid\";a:6:{s:5:\"title\";s:2:\"ID\";s:4:\"help\";s:27:\"The comment ID of the field\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_comment\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}}s:4:\"name\";a:6:{s:5:\"title\";s:6:\"Author\";s:4:\"help\";s:85:\"The name of the comment\'s author. Can be rendered as a link to the author\'s homepage.\";s:5:\"field\";a:2:{s:7:\"handler\";s:36:\"views_handler_field_comment_username\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:8:\"homepage\";a:6:{s:5:\"title\";s:16:\"Author\'s website\";s:4:\"help\";s:121:\"The website address of the comment\'s author. Can be rendered as a link. Will be empty if the author is a registered user.\";s:5:\"field\";a:2:{s:7:\"handler\";s:23:\"views_handler_field_url\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:8:\"hostname\";a:6:{s:5:\"title\";s:8:\"Hostname\";s:4:\"help\";s:41:\"Hostname of user that posted the comment.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:4:\"mail\";a:6:{s:5:\"title\";s:4:\"Mail\";s:4:\"help\";s:88:\"Email of user that posted the comment. Will be empty if the author is a registered user.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:7:\"created\";a:5:{s:5:\"title\";s:9:\"Post date\";s:4:\"help\";s:46:\"Date and time of when the comment was created.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}}s:7:\"changed\";a:5:{s:5:\"title\";s:12:\"Updated date\";s:4:\"help\";s:51:\"Date and time of when the comment was last updated.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}}s:16:\"changed_fulldata\";a:3:{s:5:\"title\";s:12:\"Created date\";s:4:\"help\";s:29:\"Date in the form of CCYYMMDD.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:44:\"views_handler_argument_node_created_fulldate\";}}s:18:\"changed_year_month\";a:3:{s:5:\"title\";s:20:\"Created year + month\";s:4:\"help\";s:27:\"Date in the form of YYYYMM.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:46:\"views_handler_argument_node_created_year_month\";}}s:12:\"changed_year\";a:3:{s:5:\"title\";s:12:\"Created year\";s:4:\"help\";s:25:\"Date in the form of YYYY.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:40:\"views_handler_argument_node_created_year\";}}s:13:\"changed_month\";a:3:{s:5:\"title\";s:13:\"Created month\";s:4:\"help\";s:33:\"Date in the form of MM (01 - 12).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:41:\"views_handler_argument_node_created_month\";}}s:11:\"changed_day\";a:3:{s:5:\"title\";s:11:\"Created day\";s:4:\"help\";s:33:\"Date in the form of DD (01 - 31).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:39:\"views_handler_argument_node_created_day\";}}s:12:\"changed_week\";a:3:{s:5:\"title\";s:12:\"Created week\";s:4:\"help\";s:33:\"Date in the form of WW (01 - 53).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:40:\"views_handler_argument_node_created_week\";}}s:6:\"status\";a:5:{s:5:\"title\";s:8:\"Approved\";s:4:\"help\";s:67:\"Whether the comment is approved (or still in the moderation queue).\";s:5:\"field\";a:3:{s:7:\"handler\";s:27:\"views_handler_field_boolean\";s:14:\"click sortable\";b:1;s:14:\"output formats\";a:1:{s:21:\"approved-not-approved\";a:2:{i:0;s:8:\"Approved\";i:1;s:12:\"Not Approved\";}}}s:6:\"filter\";a:3:{s:7:\"handler\";s:37:\"views_handler_filter_boolean_operator\";s:5:\"label\";s:16:\"Approved comment\";s:4:\"type\";s:6:\"yes-no\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:12:\"view_comment\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:9:\"View link\";s:4:\"help\";s:42:\"Provide a simple link to view the comment.\";s:7:\"handler\";s:32:\"views_handler_field_comment_link\";}}s:12:\"edit_comment\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:9:\"Edit link\";s:4:\"help\";s:42:\"Provide a simple link to edit the comment.\";s:7:\"handler\";s:37:\"views_handler_field_comment_link_edit\";}}s:14:\"delete_comment\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:11:\"Delete link\";s:4:\"help\";s:44:\"Provide a simple link to delete the comment.\";s:7:\"handler\";s:39:\"views_handler_field_comment_link_delete\";}}s:15:\"approve_comment\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:12:\"Approve link\";s:4:\"help\";s:45:\"Provide a simple link to approve the comment.\";s:7:\"handler\";s:40:\"views_handler_field_comment_link_approve\";}}s:15:\"replyto_comment\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:13:\"Reply-to link\";s:4:\"help\";s:46:\"Provide a simple link to reply to the comment.\";s:7:\"handler\";s:38:\"views_handler_field_comment_link_reply\";}}s:6:\"thread\";a:2:{s:5:\"field\";a:3:{s:5:\"title\";s:5:\"Depth\";s:4:\"help\";s:51:\"Display the depth of the comment if it is threaded.\";s:7:\"handler\";s:33:\"views_handler_field_comment_depth\";}s:4:\"sort\";a:3:{s:5:\"title\";s:6:\"Thread\";s:4:\"help\";s:86:\"Sort by the threaded order. This will keep child comments together with their parents.\";s:7:\"handler\";s:33:\"views_handler_sort_comment_thread\";}}s:3:\"nid\";a:6:{s:5:\"title\";s:3:\"Nid\";s:4:\"help\";s:47:\"The node ID to which the comment is a reply to.\";s:12:\"relationship\";a:6:{s:5:\"title\";s:7:\"Content\";s:4:\"help\";s:47:\"The content to which the comment is a reply to.\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:5:\"label\";s:7:\"Content\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}s:5:\"field\";a:1:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";}}s:3:\"uid\";a:6:{s:5:\"title\";s:10:\"Author uid\";s:4:\"help\";s:73:\"If you need more fields than the uid add the comment: author relationship\";s:12:\"relationship\";a:6:{s:5:\"title\";s:6:\"Author\";s:4:\"help\";s:36:\"The User ID of the comment\'s author.\";s:4:\"base\";s:5:\"users\";s:10:\"base field\";s:3:\"uid\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:5:\"label\";s:6:\"author\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}s:5:\"field\";a:1:{s:7:\"handler\";s:24:\"views_handler_field_user\";}}s:3:\"pid\";a:4:{s:5:\"title\";s:10:\"Parent CID\";s:4:\"help\";s:37:\"The Comment ID of the parent comment.\";s:5:\"field\";a:1:{s:7:\"handler\";s:19:\"views_handler_field\";}s:12:\"relationship\";a:6:{s:5:\"title\";s:14:\"Parent comment\";s:4:\"help\";s:19:\"The parent comment.\";s:4:\"base\";s:7:\"comment\";s:10:\"base field\";s:3:\"cid\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:5:\"label\";s:14:\"Parent comment\";}}s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:14:\"Date (comment)\";s:4:\"help\";s:168:\"Filter any Views comment date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:14:\"Date (comment)\";s:4:\"help\";s:36:\"Filter any Views comment date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}}s:23:\"node_comment_statistics\";a:7:{s:5:\"table\";a:2:{s:5:\"group\";s:7:\"Content\";s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:4:\"type\";s:5:\"INNER\";s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:3:\"nid\";}}}s:22:\"last_comment_timestamp\";a:5:{s:5:\"title\";s:17:\"Last comment time\";s:4:\"help\";s:50:\"Date and time of when the last comment was posted.\";s:5:\"field\";a:2:{s:7:\"handler\";s:42:\"views_handler_field_last_comment_timestamp\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}}s:17:\"last_comment_name\";a:4:{s:5:\"title\";s:19:\"Last comment author\";s:4:\"help\";s:50:\"The name of the author of the last posted comment.\";s:5:\"field\";a:3:{s:7:\"handler\";s:41:\"views_handler_field_ncs_last_comment_name\";s:14:\"click sortable\";b:1;s:11:\"no group by\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:40:\"views_handler_sort_ncs_last_comment_name\";s:11:\"no group by\";b:1;}}s:13:\"comment_count\";a:6:{s:5:\"title\";s:13:\"Comment count\";s:4:\"help\";s:34:\"The number of comments a node has.\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:22:\"views_handler_argument\";}}s:12:\"last_updated\";a:5:{s:5:\"title\";s:22:\"Updated/commented date\";s:4:\"help\";s:60:\"The most recent of last comment posted or node updated time.\";s:5:\"field\";a:3:{s:7:\"handler\";s:36:\"views_handler_field_ncs_last_updated\";s:14:\"click sortable\";b:1;s:11:\"no group by\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:35:\"views_handler_sort_ncs_last_updated\";s:11:\"no group by\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:37:\"views_handler_filter_ncs_last_updated\";}}s:3:\"cid\";a:3:{s:5:\"title\";s:16:\"Last comment CID\";s:4:\"help\";s:34:\"Display the last comment of a node\";s:12:\"relationship\";a:7:{s:5:\"title\";s:12:\"Last Comment\";s:4:\"help\";s:27:\"The last comment of a node.\";s:5:\"group\";s:7:\"Comment\";s:4:\"base\";s:7:\"comment\";s:10:\"base field\";s:3:\"cid\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:5:\"label\";s:12:\"Last Comment\";}}s:16:\"last_comment_uid\";a:6:{s:5:\"title\";s:16:\"Last comment uid\";s:4:\"help\";s:56:\"The User ID of the author of the last comment of a node.\";s:12:\"relationship\";a:5:{s:5:\"title\";s:19:\"Last comment author\";s:4:\"base\";s:5:\"users\";s:10:\"base field\";s:3:\"uid\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:5:\"label\";s:19:\"Last comment author\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}s:5:\"field\";a:1:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";}}}s:4:\"node\";a:47:{s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:11:\"Date (node)\";s:4:\"help\";s:165:\"Filter any Views node date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:11:\"Date (node)\";s:4:\"help\";s:33:\"Filter any Views node date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:5:\"table\";a:4:{s:5:\"group\";s:7:\"Content\";s:4:\"base\";a:5:{s:5:\"field\";s:3:\"nid\";s:5:\"title\";s:7:\"Content\";s:6:\"weight\";i:-10;s:16:\"access query tag\";s:11:\"node_access\";s:8:\"defaults\";a:1:{s:5:\"field\";s:5:\"title\";}}s:11:\"entity type\";s:4:\"node\";s:20:\"default_relationship\";a:1:{s:13:\"node_revision\";a:2:{s:5:\"table\";s:13:\"node_revision\";s:5:\"field\";s:3:\"vid\";}}}s:3:\"nid\";a:6:{s:5:\"title\";s:3:\"Nid\";s:4:\"help\";s:12:\"The node ID.\";s:5:\"field\";a:2:{s:7:\"handler\";s:24:\"views_handler_field_node\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:4:{s:7:\"handler\";s:31:\"views_handler_argument_node_nid\";s:10:\"name field\";s:5:\"title\";s:7:\"numeric\";b:1;s:13:\"validate type\";s:3:\"nid\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:5:\"title\";a:6:{s:5:\"title\";s:5:\"Title\";s:4:\"help\";s:18:\"The content title.\";s:5:\"field\";a:5:{s:5:\"field\";s:5:\"title\";s:5:\"group\";s:7:\"Content\";s:7:\"handler\";s:24:\"views_handler_field_node\";s:14:\"click sortable\";b:1;s:20:\"link_to_node default\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:7:\"created\";a:5:{s:5:\"title\";s:9:\"Post date\";s:4:\"help\";s:32:\"The date the content was posted.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}}s:7:\"changed\";a:5:{s:5:\"title\";s:12:\"Updated date\";s:4:\"help\";s:38:\"The date the content was last updated.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}}s:4:\"type\";a:6:{s:5:\"title\";s:4:\"Type\";s:4:\"help\";s:73:\"The content type (for example, \"blog entry\", \"forum post\", \"story\", etc).\";s:5:\"field\";a:2:{s:7:\"handler\";s:29:\"views_handler_field_node_type\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:30:\"views_handler_filter_node_type\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:32:\"views_handler_argument_node_type\";}}s:6:\"status\";a:5:{s:5:\"title\";s:9:\"Published\";s:4:\"help\";s:40:\"Whether or not the content is published.\";s:5:\"field\";a:3:{s:7:\"handler\";s:27:\"views_handler_field_boolean\";s:14:\"click sortable\";b:1;s:14:\"output formats\";a:1:{s:22:\"published-notpublished\";a:2:{i:0;s:9:\"Published\";i:1;s:13:\"Not published\";}}}s:6:\"filter\";a:4:{s:7:\"handler\";s:37:\"views_handler_filter_boolean_operator\";s:5:\"label\";s:9:\"Published\";s:4:\"type\";s:6:\"yes-no\";s:9:\"use equal\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:12:\"status_extra\";a:3:{s:5:\"title\";s:18:\"Published or admin\";s:4:\"help\";s:67:\"Filters out unpublished content if the current user cannot view it.\";s:6:\"filter\";a:3:{s:5:\"field\";s:6:\"status\";s:7:\"handler\";s:32:\"views_handler_filter_node_status\";s:5:\"label\";s:18:\"Published or admin\";}}s:7:\"promote\";a:5:{s:5:\"title\";s:22:\"Promoted to front page\";s:4:\"help\";s:57:\"Whether or not the content is promoted to the front page.\";s:5:\"field\";a:3:{s:7:\"handler\";s:27:\"views_handler_field_boolean\";s:14:\"click sortable\";b:1;s:14:\"output formats\";a:1:{s:20:\"promoted-notpromoted\";a:2:{i:0;s:8:\"Promoted\";i:1;s:12:\"Not promoted\";}}}s:6:\"filter\";a:3:{s:7:\"handler\";s:37:\"views_handler_filter_boolean_operator\";s:5:\"label\";s:22:\"Promoted to front page\";s:4:\"type\";s:6:\"yes-no\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:6:\"sticky\";a:5:{s:5:\"title\";s:6:\"Sticky\";s:4:\"help\";s:37:\"Whether or not the content is sticky.\";s:5:\"field\";a:3:{s:7:\"handler\";s:27:\"views_handler_field_boolean\";s:14:\"click sortable\";b:1;s:14:\"output formats\";a:1:{s:6:\"sticky\";a:2:{i:0;s:6:\"Sticky\";i:1;s:10:\"Not sticky\";}}}s:6:\"filter\";a:3:{s:7:\"handler\";s:37:\"views_handler_filter_boolean_operator\";s:5:\"label\";s:6:\"Sticky\";s:4:\"type\";s:6:\"yes-no\";}s:4:\"sort\";a:2:{s:7:\"handler\";s:18:\"views_handler_sort\";s:4:\"help\";s:91:\"Whether or not the content is sticky. To list sticky content first, set this to descending.\";}}s:9:\"view_node\";a:1:{s:8:\"moved to\";a:2:{i:0;s:17:\"views_entity_node\";i:1;s:9:\"view_node\";}}s:9:\"edit_node\";a:1:{s:8:\"moved to\";a:2:{i:0;s:17:\"views_entity_node\";i:1;s:9:\"edit_node\";}}s:11:\"delete_node\";a:1:{s:8:\"moved to\";a:2:{i:0;s:17:\"views_entity_node\";i:1;s:11:\"delete_node\";}}s:4:\"path\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:4:\"Path\";s:4:\"help\";s:33:\"The aliased path to this content.\";s:7:\"handler\";s:29:\"views_handler_field_node_path\";}}s:16:\"created_fulldate\";a:3:{s:5:\"title\";s:12:\"Created date\";s:4:\"help\";s:29:\"Date in the form of CCYYMMDD.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:44:\"views_handler_argument_node_created_fulldate\";}}s:18:\"created_year_month\";a:3:{s:5:\"title\";s:20:\"Created year + month\";s:4:\"help\";s:27:\"Date in the form of YYYYMM.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:46:\"views_handler_argument_node_created_year_month\";}}s:12:\"created_year\";a:3:{s:5:\"title\";s:12:\"Created year\";s:4:\"help\";s:25:\"Date in the form of YYYY.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:40:\"views_handler_argument_node_created_year\";}}s:13:\"created_month\";a:3:{s:5:\"title\";s:13:\"Created month\";s:4:\"help\";s:33:\"Date in the form of MM (01 - 12).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:41:\"views_handler_argument_node_created_month\";}}s:11:\"created_day\";a:3:{s:5:\"title\";s:11:\"Created day\";s:4:\"help\";s:33:\"Date in the form of DD (01 - 31).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:39:\"views_handler_argument_node_created_day\";}}s:12:\"created_week\";a:3:{s:5:\"title\";s:12:\"Created week\";s:4:\"help\";s:33:\"Date in the form of WW (01 - 53).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:40:\"views_handler_argument_node_created_week\";}}s:16:\"changed_fulldate\";a:3:{s:5:\"title\";s:12:\"Updated date\";s:4:\"help\";s:29:\"Date in the form of CCYYMMDD.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:44:\"views_handler_argument_node_created_fulldate\";}}s:18:\"changed_year_month\";a:3:{s:5:\"title\";s:20:\"Updated year + month\";s:4:\"help\";s:27:\"Date in the form of YYYYMM.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:46:\"views_handler_argument_node_created_year_month\";}}s:12:\"changed_year\";a:3:{s:5:\"title\";s:12:\"Updated year\";s:4:\"help\";s:25:\"Date in the form of YYYY.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:40:\"views_handler_argument_node_created_year\";}}s:13:\"changed_month\";a:3:{s:5:\"title\";s:13:\"Updated month\";s:4:\"help\";s:33:\"Date in the form of MM (01 - 12).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:41:\"views_handler_argument_node_created_month\";}}s:11:\"changed_day\";a:3:{s:5:\"title\";s:11:\"Updated day\";s:4:\"help\";s:33:\"Date in the form of DD (01 - 31).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:39:\"views_handler_argument_node_created_day\";}}s:12:\"changed_week\";a:3:{s:5:\"title\";s:12:\"Updated week\";s:4:\"help\";s:33:\"Date in the form of WW (01 - 53).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:40:\"views_handler_argument_node_created_week\";}}s:3:\"uid\";a:6:{s:5:\"title\";s:10:\"Author uid\";s:4:\"help\";s:105:\"The user authoring the content. If you need more fields than the uid add the content: author relationship\";s:12:\"relationship\";a:6:{s:5:\"title\";s:6:\"Author\";s:4:\"help\";s:42:\"Relate content to the user who created it.\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:5:\"users\";s:5:\"field\";s:3:\"uid\";s:5:\"label\";s:6:\"author\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:30:\"views_handler_filter_user_name\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}s:5:\"field\";a:1:{s:7:\"handler\";s:24:\"views_handler_field_user\";}}s:12:\"uid_revision\";a:5:{s:5:\"title\";s:19:\"User has a revision\";s:4:\"help\";s:45:\"All nodes where a certain user has a revision\";s:10:\"real field\";s:3:\"nid\";s:6:\"filter\";a:1:{s:7:\"handler\";s:38:\"views_handler_filter_node_uid_revision\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:40:\"views_handler_argument_node_uid_revision\";}}s:12:\"new_comments\";a:3:{s:5:\"title\";s:12:\"New comments\";s:4:\"help\";s:39:\"The number of new comments on the node.\";s:5:\"field\";a:2:{s:7:\"handler\";s:37:\"views_handler_field_node_new_comments\";s:11:\"no group by\";b:1;}}s:13:\"comments_link\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:16:\"Add comment link\";s:4:\"help\";s:133:\"Display the standard add comment link used on regular nodes, which will only display if the viewing user has access to add a comment.\";s:7:\"handler\";s:37:\"views_handler_field_comment_node_link\";}}s:7:\"comment\";a:5:{s:5:\"title\";s:14:\"Comment status\";s:4:\"help\";s:53:\"Whether comments are enabled or disabled on the node.\";s:5:\"field\";a:2:{s:7:\"handler\";s:32:\"views_handler_field_node_comment\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:33:\"views_handler_filter_node_comment\";}}s:9:\"uid_touch\";a:4:{s:5:\"title\";s:24:\"User posted or commented\";s:4:\"help\";s:70:\"Display nodes only if a user posted the node or commented on the node.\";s:8:\"argument\";a:5:{s:5:\"field\";s:3:\"uid\";s:10:\"name table\";s:5:\"users\";s:10:\"name field\";s:4:\"name\";s:7:\"handler\";s:39:\"views_handler_argument_comment_user_uid\";s:11:\"no group by\";b:1;}s:6:\"filter\";a:4:{s:5:\"field\";s:3:\"uid\";s:10:\"name table\";s:5:\"users\";s:10:\"name field\";s:4:\"name\";s:7:\"handler\";s:37:\"views_handler_filter_comment_user_uid\";}}s:3:\"cid\";a:3:{s:5:\"title\";s:20:\"Comments of the node\";s:4:\"help\";s:151:\"Relate all comments on the node. This will create 1 duplicate record for every comment. Usually if you need this it is better to create a comment view.\";s:12:\"relationship\";a:6:{s:5:\"group\";s:7:\"Comment\";s:5:\"label\";s:8:\"Comments\";s:4:\"base\";s:7:\"comment\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:3:\"nid\";s:7:\"handler\";s:26:\"views_handler_relationship\";}}s:34:\"reverse_field_related_vcenter_node\";a:1:{s:12:\"relationship\";a:10:{s:7:\"handler\";s:41:\"views_handler_relationship_entity_reverse\";s:10:\"field_name\";s:21:\"field_related_vcenter\";s:11:\"field table\";s:32:\"field_data_field_related_vcenter\";s:11:\"field field\";s:31:\"field_related_vcenter_target_id\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:54:\"Content referencing Content from field_related_vcenter\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:18:\"Referencing entity\";s:4:\"help\";s:84:\"A bridge to the Content entity that is referencing Content via field_related_vcenter\";}}s:34:\"reverse_field_virtual_machine_node\";a:1:{s:12:\"relationship\";a:10:{s:7:\"handler\";s:41:\"views_handler_relationship_entity_reverse\";s:10:\"field_name\";s:21:\"field_virtual_machine\";s:11:\"field table\";s:32:\"field_data_field_virtual_machine\";s:11:\"field field\";s:31:\"field_virtual_machine_target_id\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:54:\"Content referencing Content from field_virtual_machine\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:18:\"Referencing entity\";s:4:\"help\";s:84:\"A bridge to the Content entity that is referencing Content via field_virtual_machine\";}}s:31:\"reverse_field_related_host_node\";a:1:{s:12:\"relationship\";a:10:{s:7:\"handler\";s:41:\"views_handler_relationship_entity_reverse\";s:10:\"field_name\";s:18:\"field_related_host\";s:11:\"field table\";s:29:\"field_data_field_related_host\";s:11:\"field field\";s:28:\"field_related_host_target_id\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:51:\"Content referencing Content from field_related_host\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:18:\"Referencing entity\";s:4:\"help\";s:81:\"A bridge to the Content entity that is referencing Content via field_related_host\";}}s:29:\"reverse_field_datacenter_node\";a:1:{s:12:\"relationship\";a:10:{s:7:\"handler\";s:41:\"views_handler_relationship_entity_reverse\";s:10:\"field_name\";s:16:\"field_datacenter\";s:11:\"field table\";s:27:\"field_data_field_datacenter\";s:11:\"field field\";s:26:\"field_datacenter_target_id\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:49:\"Content referencing Content from field_datacenter\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:18:\"Referencing entity\";s:4:\"help\";s:79:\"A bridge to the Content entity that is referencing Content via field_datacenter\";}}s:23:\"reverse_field_host_node\";a:1:{s:12:\"relationship\";a:10:{s:7:\"handler\";s:41:\"views_handler_relationship_entity_reverse\";s:10:\"field_name\";s:10:\"field_host\";s:11:\"field table\";s:21:\"field_data_field_host\";s:11:\"field field\";s:20:\"field_host_target_id\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:43:\"Content referencing Content from field_host\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:18:\"Referencing entity\";s:4:\"help\";s:73:\"A bridge to the Content entity that is referencing Content via field_host\";}}s:21:\"reverse_field_vm_node\";a:1:{s:12:\"relationship\";a:10:{s:7:\"handler\";s:41:\"views_handler_relationship_entity_reverse\";s:10:\"field_name\";s:8:\"field_vm\";s:11:\"field table\";s:19:\"field_data_field_vm\";s:11:\"field field\";s:18:\"field_vm_target_id\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:41:\"Content referencing Content from field_vm\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:18:\"Referencing entity\";s:4:\"help\";s:71:\"A bridge to the Content entity that is referencing Content via field_vm\";}}s:24:\"reverse_field_vdisk_node\";a:1:{s:12:\"relationship\";a:10:{s:7:\"handler\";s:41:\"views_handler_relationship_entity_reverse\";s:10:\"field_name\";s:11:\"field_vdisk\";s:11:\"field table\";s:22:\"field_data_field_vdisk\";s:11:\"field field\";s:21:\"field_vdisk_target_id\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:44:\"Content referencing Content from field_vdisk\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:18:\"Referencing entity\";s:4:\"help\";s:74:\"A bridge to the Content entity that is referencing Content via field_vdisk\";}}s:43:\"reverse_field_cache_assigned_from_host_node\";a:1:{s:12:\"relationship\";a:9:{s:5:\"title\";s:61:\"Assigned from Host (field_cache_assigned_from_host) - reverse\";s:4:\"help\";s:68:\"Relate each Content referencing the node through Assigned from Host.\";s:7:\"handler\";s:41:\"views_handler_relationship_entity_reverse\";s:10:\"field_name\";s:30:\"field_cache_assigned_from_host\";s:11:\"field table\";s:41:\"field_data_field_cache_assigned_from_host\";s:11:\"field field\";s:34:\"field_cache_assigned_from_host_nid\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:30:\"field_cache_assigned_from_host\";}}s:40:\"reverse_field_cache_allocated_to_vm_node\";a:1:{s:12:\"relationship\";a:9:{s:5:\"title\";s:68:\"Allocated to Virtual Machine (field_cache_allocated_to_vm) - reverse\";s:4:\"help\";s:78:\"Relate each Content referencing the node through Allocated to Virtual Machine.\";s:7:\"handler\";s:41:\"views_handler_relationship_entity_reverse\";s:10:\"field_name\";s:27:\"field_cache_allocated_to_vm\";s:11:\"field table\";s:38:\"field_data_field_cache_allocated_to_vm\";s:11:\"field field\";s:31:\"field_cache_allocated_to_vm_nid\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:27:\"field_cache_allocated_to_vm\";}}s:13:\"term_node_tid\";a:4:{s:5:\"title\";s:22:\"Taxonomy terms on node\";s:4:\"help\";s:161:\"Relate nodes to taxonomy terms, specifiying which vocabulary or vocabularies to use. This relationship will cause duplicated records if there are multiple terms.\";s:12:\"relationship\";a:3:{s:7:\"handler\";s:41:\"views_handler_relationship_node_term_data\";s:5:\"label\";s:4:\"term\";s:4:\"base\";s:18:\"taxonomy_term_data\";}s:5:\"field\";a:4:{s:5:\"title\";s:18:\"All taxonomy terms\";s:4:\"help\";s:78:\"Display all taxonomy terms associated with a node from specified vocabularies.\";s:7:\"handler\";s:33:\"views_handler_field_term_node_tid\";s:11:\"no group by\";b:1;}}s:19:\"term_node_tid_depth\";a:4:{s:4:\"help\";s:175:\"Display content if it has the selected taxonomy terms, or children of the selected terms. Due to additional complexity, this has fewer options than the versions without depth.\";s:10:\"real field\";s:3:\"nid\";s:8:\"argument\";a:3:{s:5:\"title\";s:33:\"Has taxonomy term ID (with depth)\";s:7:\"handler\";s:42:\"views_handler_argument_term_node_tid_depth\";s:21:\"accept depth modifier\";b:1;}s:6:\"filter\";a:2:{s:5:\"title\";s:31:\"Has taxonomy terms (with depth)\";s:7:\"handler\";s:40:\"views_handler_filter_term_node_tid_depth\";}}s:28:\"term_node_tid_depth_modifier\";a:3:{s:5:\"title\";s:35:\"Has taxonomy term ID depth modifier\";s:4:\"help\";s:111:\"Allows the \"depth\" for Taxonomy: Term ID (with depth) to be modified via an additional contextual filter value.\";s:8:\"argument\";a:1:{s:7:\"handler\";s:51:\"views_handler_argument_term_node_tid_depth_modifier\";}}}s:13:\"node_revision\";a:11:{s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:20:\"Date (node_revision)\";s:4:\"help\";s:174:\"Filter any Views node_revision date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:20:\"Date (node_revision)\";s:4:\"help\";s:42:\"Filter any Views node_revision date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:5:\"table\";a:5:{s:11:\"entity type\";s:4:\"node\";s:5:\"group\";s:16:\"Content revision\";s:4:\"base\";a:4:{s:5:\"field\";s:3:\"vid\";s:5:\"title\";s:16:\"Content revision\";s:4:\"help\";s:52:\"Content revision is a history of changes to content.\";s:8:\"defaults\";a:1:{s:5:\"field\";s:5:\"title\";}}s:4:\"join\";a:1:{s:4:\"node\";a:2:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:3:\"vid\";}}s:20:\"default_relationship\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"vid\";}}}s:3:\"uid\";a:3:{s:5:\"title\";s:4:\"User\";s:4:\"help\";s:63:\"Relate a content revision to the user who created the revision.\";s:12:\"relationship\";a:4:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:5:\"users\";s:10:\"base field\";s:3:\"uid\";s:5:\"label\";s:13:\"revision user\";}}s:3:\"vid\";a:7:{s:5:\"title\";s:3:\"Vid\";s:4:\"help\";s:40:\"The revision ID of the content revision.\";s:5:\"field\";a:1:{s:14:\"click sortable\";b:1;}s:8:\"argument\";a:3:{s:7:\"handler\";s:31:\"views_handler_argument_node_vid\";s:14:\"click sortable\";b:1;s:7:\"numeric\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"vid\";s:5:\"title\";s:7:\"Content\";s:5:\"label\";s:47:\"Get the actual content from a content revision.\";}}s:5:\"title\";a:6:{s:5:\"title\";s:5:\"Title\";s:4:\"help\";s:18:\"The content title.\";s:5:\"field\";a:3:{s:5:\"field\";s:5:\"title\";s:7:\"handler\";s:33:\"views_handler_field_node_revision\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:3:\"log\";a:4:{s:5:\"title\";s:11:\"Log message\";s:4:\"help\";s:54:\"The log message entered when the revision was created.\";s:5:\"field\";a:1:{s:7:\"handler\";s:23:\"views_handler_field_xss\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}}s:9:\"timestamp\";a:5:{s:5:\"title\";s:12:\"Updated date\";s:4:\"help\";s:35:\"The date the node was last updated.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}}s:16:\"link_to_revision\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:4:\"Link\";s:4:\"help\";s:38:\"Provide a simple link to the revision.\";s:7:\"handler\";s:38:\"views_handler_field_node_revision_link\";}}s:15:\"revert_revision\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:11:\"Revert link\";s:4:\"help\";s:48:\"Provide a simple link to revert to the revision.\";s:7:\"handler\";s:45:\"views_handler_field_node_revision_link_revert\";}}s:15:\"delete_revision\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:11:\"Delete link\";s:4:\"help\";s:53:\"Provide a simple link to delete the content revision.\";s:7:\"handler\";s:45:\"views_handler_field_node_revision_link_delete\";}}}s:17:\"search_api_server\";a:9:{s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:24:\"Date (search_api_server)\";s:4:\"help\";s:178:\"Filter any Views search_api_server date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:24:\"Date (search_api_server)\";s:4:\"help\";s:46:\"Filter any Views search_api_server date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:5:\"table\";a:3:{s:5:\"group\";s:13:\"Search server\";s:11:\"entity type\";s:17:\"search_api_server\";s:4:\"base\";a:3:{s:5:\"field\";s:2:\"id\";s:5:\"title\";s:13:\"Search server\";s:4:\"help\";s:0:\"\";}}s:2:\"id\";a:6:{s:5:\"title\";s:2:\"ID\";s:4:\"help\";s:36:\"The primary identifier for a server.\";s:5:\"field\";a:4:{s:10:\"real field\";s:2:\"id\";s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:2:{s:10:\"real field\";s:2:\"id\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:2:\"id\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:2:\"id\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}}s:4:\"name\";a:6:{s:5:\"title\";s:4:\"Name\";s:4:\"help\";s:32:\"The displayed name for a server.\";s:5:\"field\";a:3:{s:10:\"real field\";s:4:\"name\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:4:\"name\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:4:\"name\";s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:4:\"name\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:12:\"machine_name\";a:6:{s:5:\"title\";s:12:\"Machine name\";s:4:\"help\";s:46:\"The internally used machine name for a server.\";s:5:\"field\";a:3:{s:10:\"real field\";s:12:\"machine_name\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:12:\"machine_name\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:12:\"machine_name\";s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:12:\"machine_name\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:11:\"description\";a:6:{s:5:\"title\";s:11:\"Description\";s:4:\"help\";s:39:\"The displayed description for a server.\";s:5:\"field\";a:3:{s:10:\"real field\";s:11:\"description\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:11:\"description\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:11:\"description\";s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:11:\"description\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:5:\"class\";a:6:{s:5:\"title\";s:13:\"Service class\";s:4:\"help\";s:51:\"The ID of the service class to use for this server.\";s:5:\"field\";a:3:{s:10:\"real field\";s:5:\"class\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:5:\"class\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:5:\"class\";s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:5:\"class\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:7:\"enabled\";a:6:{s:5:\"title\";s:7:\"Enabled\";s:4:\"help\";s:48:\"A flag indicating whether the server is enabled.\";s:5:\"field\";a:3:{s:10:\"real field\";s:7:\"enabled\";s:7:\"handler\";s:27:\"views_handler_field_boolean\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:7:\"enabled\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:7:\"enabled\";s:7:\"handler\";s:37:\"views_handler_filter_boolean_operator\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:7:\"enabled\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}}s:16:\"search_api_index\";a:11:{s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:23:\"Date (search_api_index)\";s:4:\"help\";s:177:\"Filter any Views search_api_index date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:23:\"Date (search_api_index)\";s:4:\"help\";s:45:\"Filter any Views search_api_index date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:5:\"table\";a:3:{s:5:\"group\";s:12:\"Search index\";s:11:\"entity type\";s:16:\"search_api_index\";s:4:\"base\";a:3:{s:5:\"field\";s:2:\"id\";s:5:\"title\";s:12:\"Search index\";s:4:\"help\";s:0:\"\";}}s:2:\"id\";a:6:{s:5:\"title\";s:2:\"ID\";s:4:\"help\";s:33:\"An integer identifying the index.\";s:5:\"field\";a:4:{s:10:\"real field\";s:2:\"id\";s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:2:{s:10:\"real field\";s:2:\"id\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:2:\"id\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:2:\"id\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}}s:4:\"name\";a:6:{s:5:\"title\";s:4:\"Name\";s:4:\"help\";s:37:\"A name to be displayed for the index.\";s:5:\"field\";a:3:{s:10:\"real field\";s:4:\"name\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:4:\"name\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:4:\"name\";s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:4:\"name\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:12:\"machine_name\";a:6:{s:5:\"title\";s:12:\"Machine name\";s:4:\"help\";s:46:\"The internally used machine name for an index.\";s:5:\"field\";a:3:{s:10:\"real field\";s:12:\"machine_name\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:12:\"machine_name\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:12:\"machine_name\";s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:12:\"machine_name\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:11:\"description\";a:6:{s:5:\"title\";s:11:\"Description\";s:4:\"help\";s:44:\"A string describing the index\' use to users.\";s:5:\"field\";a:3:{s:10:\"real field\";s:11:\"description\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:11:\"description\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:11:\"description\";s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:11:\"description\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:6:\"server\";a:6:{s:5:\"title\";s:9:\"Server ID\";s:4:\"help\";s:76:\"The machine name of the search_api_server with which data should be indexed.\";s:5:\"field\";a:3:{s:10:\"real field\";s:6:\"server\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:6:\"server\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:6:\"server\";s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:6:\"server\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:9:\"item_type\";a:6:{s:5:\"title\";s:9:\"Item type\";s:4:\"help\";s:39:\"The type of items stored in this index.\";s:5:\"field\";a:3:{s:10:\"real field\";s:9:\"item_type\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:9:\"item_type\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:9:\"item_type\";s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:9:\"item_type\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:7:\"enabled\";a:6:{s:5:\"title\";s:7:\"Enabled\";s:4:\"help\";s:47:\"A flag indicating whether the index is enabled.\";s:5:\"field\";a:3:{s:10:\"real field\";s:7:\"enabled\";s:7:\"handler\";s:27:\"views_handler_field_boolean\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:7:\"enabled\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:7:\"enabled\";s:7:\"handler\";s:37:\"views_handler_filter_boolean_operator\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:7:\"enabled\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:9:\"read_only\";a:6:{s:5:\"title\";s:9:\"Read only\";s:4:\"help\";s:49:\"A flag indicating whether the index is read-only.\";s:5:\"field\";a:3:{s:10:\"real field\";s:9:\"read_only\";s:7:\"handler\";s:27:\"views_handler_field_boolean\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:9:\"read_only\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:9:\"read_only\";s:7:\"handler\";s:37:\"views_handler_filter_boolean_operator\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:9:\"read_only\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}}s:15:\"search_api_page\";a:9:{s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:22:\"Date (search_api_page)\";s:4:\"help\";s:176:\"Filter any Views search_api_page date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:22:\"Date (search_api_page)\";s:4:\"help\";s:44:\"Filter any Views search_api_page date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:5:\"table\";a:3:{s:5:\"group\";s:11:\"Search page\";s:11:\"entity type\";s:15:\"search_api_page\";s:4:\"base\";a:3:{s:5:\"field\";s:2:\"id\";s:5:\"title\";s:11:\"Search page\";s:4:\"help\";s:0:\"\";}}s:2:\"id\";a:6:{s:5:\"title\";s:2:\"ID\";s:4:\"help\";s:41:\"The primary identifier for a search page.\";s:5:\"field\";a:4:{s:10:\"real field\";s:2:\"id\";s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:2:{s:10:\"real field\";s:2:\"id\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:2:\"id\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:2:\"id\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}}s:8:\"index_id\";a:6:{s:5:\"title\";s:8:\"Index ID\";s:4:\"help\";s:52:\"The machine name of the index this search page uses.\";s:5:\"field\";a:3:{s:10:\"real field\";s:8:\"index_id\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:8:\"index_id\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:8:\"index_id\";s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:8:\"index_id\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:4:\"name\";a:6:{s:5:\"title\";s:4:\"Name\";s:4:\"help\";s:37:\"The displayed name for a search page.\";s:5:\"field\";a:3:{s:10:\"real field\";s:4:\"name\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:4:\"name\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:4:\"name\";s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:4:\"name\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:12:\"machine_name\";a:6:{s:5:\"title\";s:12:\"Machine name\";s:4:\"help\";s:51:\"The internally used machine name for a search page.\";s:5:\"field\";a:3:{s:10:\"real field\";s:12:\"machine_name\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:12:\"machine_name\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:12:\"machine_name\";s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:12:\"machine_name\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:11:\"description\";a:6:{s:5:\"title\";s:11:\"Description\";s:4:\"help\";s:44:\"The displayed description for a search page.\";s:5:\"field\";a:3:{s:10:\"real field\";s:11:\"description\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:11:\"description\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:11:\"description\";s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:11:\"description\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:7:\"enabled\";a:6:{s:5:\"title\";s:7:\"Enabled\";s:4:\"help\";s:53:\"A flag indicating whether the search page is enabled.\";s:5:\"field\";a:3:{s:10:\"real field\";s:7:\"enabled\";s:7:\"handler\";s:27:\"views_handler_field_boolean\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:7:\"enabled\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:7:\"enabled\";s:7:\"handler\";s:37:\"views_handler_filter_boolean_operator\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:7:\"enabled\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}}s:12:\"file_managed\";a:12:{s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:19:\"Date (file_managed)\";s:4:\"help\";s:173:\"Filter any Views file_managed date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:19:\"Date (file_managed)\";s:4:\"help\";s:41:\"Filter any Views file_managed date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:5:\"table\";a:3:{s:5:\"group\";s:4:\"File\";s:4:\"base\";a:4:{s:5:\"field\";s:3:\"fid\";s:5:\"title\";s:4:\"File\";s:4:\"help\";s:47:\"Files maintained by Drupal and various modules.\";s:8:\"defaults\";a:1:{s:5:\"field\";s:8:\"filename\";}}s:11:\"entity type\";s:4:\"file\";}s:3:\"fid\";a:6:{s:5:\"title\";s:7:\"File ID\";s:4:\"help\";s:19:\"The ID of the file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:24:\"views_handler_field_file\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:3:{s:7:\"handler\";s:31:\"views_handler_argument_file_fid\";s:10:\"name field\";s:8:\"filename\";s:7:\"numeric\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:8:\"filename\";a:6:{s:5:\"title\";s:4:\"Name\";s:4:\"help\";s:21:\"The name of the file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:24:\"views_handler_field_file\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:3:\"uri\";a:6:{s:5:\"title\";s:4:\"Path\";s:4:\"help\";s:21:\"The path of the file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:28:\"views_handler_field_file_uri\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:8:\"filemime\";a:6:{s:5:\"title\";s:9:\"Mime type\";s:4:\"help\";s:26:\"The mime type of the file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"views_handler_field_file_filemime\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:9:\"extension\";a:4:{s:5:\"title\";s:9:\"Extension\";s:4:\"help\";s:26:\"The extension of the file.\";s:10:\"real field\";s:8:\"filename\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"views_handler_field_file_extension\";s:14:\"click sortable\";b:0;}}s:8:\"filesize\";a:5:{s:5:\"title\";s:4:\"Size\";s:4:\"help\";s:21:\"The size of the file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:29:\"views_handler_field_file_size\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}}s:6:\"status\";a:5:{s:5:\"title\";s:6:\"Status\";s:4:\"help\";s:23:\"The status of the file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"views_handler_field_file_status\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:32:\"views_handler_filter_file_status\";}}s:9:\"timestamp\";a:5:{s:5:\"title\";s:11:\"Upload date\";s:4:\"help\";s:31:\"The date the file was uploaded.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}}s:3:\"uid\";a:3:{s:5:\"title\";s:17:\"User who uploaded\";s:4:\"help\";s:32:\"The user that uploaded the file.\";s:12:\"relationship\";a:4:{s:5:\"title\";s:17:\"User who uploaded\";s:5:\"label\";s:17:\"User who uploaded\";s:4:\"base\";s:5:\"users\";s:10:\"base field\";s:3:\"uid\";}}}s:18:\"taxonomy_term_data\";a:12:{s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:25:\"Date (taxonomy_term_data)\";s:4:\"help\";s:179:\"Filter any Views taxonomy_term_data date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:25:\"Date (taxonomy_term_data)\";s:4:\"help\";s:47:\"Filter any Views taxonomy_term_data date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:5:\"table\";a:5:{s:5:\"group\";s:13:\"Taxonomy term\";s:4:\"base\";a:4:{s:5:\"field\";s:3:\"tid\";s:5:\"title\";s:4:\"Term\";s:4:\"help\";s:37:\"Taxonomy terms are attached to nodes.\";s:16:\"access query tag\";s:11:\"term_access\";}s:11:\"entity type\";s:13:\"taxonomy_term\";s:4:\"join\";a:2:{s:19:\"taxonomy_vocabulary\";a:2:{s:5:\"field\";s:3:\"vid\";s:10:\"left_field\";s:3:\"vid\";}s:14:\"taxonomy_index\";a:2:{s:5:\"field\";s:3:\"tid\";s:10:\"left_field\";s:3:\"tid\";}}s:20:\"default_relationship\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:5:\"field\";s:13:\"term_node_tid\";}}}s:3:\"tid\";a:6:{s:5:\"title\";s:7:\"Term ID\";s:4:\"help\";s:27:\"The tid of a taxonomy term.\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:3:{s:7:\"handler\";s:31:\"views_handler_argument_taxonomy\";s:10:\"name field\";s:4:\"name\";s:12:\"zero is null\";b:1;}s:6:\"filter\";a:5:{s:5:\"title\";s:4:\"Term\";s:4:\"help\";s:56:\"Taxonomy term chosen from autocomplete or select widget.\";s:7:\"handler\";s:34:\"views_handler_filter_term_node_tid\";s:15:\"hierarchy table\";s:23:\"taxonomy_term_hierarchy\";s:7:\"numeric\";b:1;}}s:7:\"tid_raw\";a:4:{s:5:\"title\";s:7:\"Term ID\";s:4:\"help\";s:27:\"The tid of a taxonomy term.\";s:10:\"real field\";s:3:\"tid\";s:6:\"filter\";a:2:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:11:\"allow empty\";b:1;}}s:18:\"tid_representative\";a:1:{s:12:\"relationship\";a:10:{s:5:\"title\";s:19:\"Representative node\";s:5:\"label\";s:19:\"Representative node\";s:4:\"help\";s:89:\"Obtains a single representative node for each term, according to a chosen sort criterion.\";s:7:\"handler\";s:40:\"views_handler_relationship_groupwise_max\";s:18:\"relationship field\";s:3:\"tid\";s:11:\"outer field\";s:22:\"taxonomy_term_data.tid\";s:14:\"argument table\";s:18:\"taxonomy_term_data\";s:14:\"argument field\";s:3:\"tid\";s:4:\"base\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";}}s:4:\"name\";a:6:{s:5:\"title\";s:4:\"Name\";s:4:\"help\";s:23:\"The taxonomy term name.\";s:5:\"field\";a:2:{s:7:\"handler\";s:28:\"views_handler_field_taxonomy\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:7:\"handler\";s:27:\"views_handler_filter_string\";s:4:\"help\";s:19:\"Taxonomy term name.\";}s:8:\"argument\";a:4:{s:7:\"handler\";s:29:\"views_handler_argument_string\";s:4:\"help\";s:19:\"Taxonomy term name.\";s:11:\"many to one\";b:1;s:16:\"empty field name\";s:13:\"Uncategorized\";}}s:6:\"weight\";a:6:{s:5:\"title\";s:6:\"Weight\";s:4:\"help\";s:21:\"The term weight field\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}}s:11:\"description\";a:4:{s:5:\"title\";s:16:\"Term description\";s:4:\"help\";s:48:\"The description associated with a taxonomy term.\";s:5:\"field\";a:2:{s:7:\"handler\";s:26:\"views_handler_field_markup\";s:6:\"format\";a:1:{s:5:\"field\";s:6:\"format\";}}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}}s:3:\"vid\";a:3:{s:5:\"title\";s:10:\"Vocabulary\";s:4:\"help\";s:66:\"Filter the results of \"Taxonomy: Term\" to a particular vocabulary.\";s:6:\"filter\";a:1:{s:7:\"handler\";s:35:\"views_handler_filter_vocabulary_vid\";}}s:9:\"edit_term\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:14:\"Term edit link\";s:4:\"help\";s:39:\"Provide a simple link to edit the term.\";s:7:\"handler\";s:34:\"views_handler_field_term_link_edit\";}}s:23:\"reverse_field_tags_node\";a:1:{s:12:\"relationship\";a:10:{s:5:\"title\";s:18:\"Content using Tags\";s:4:\"help\";s:48:\"Relate each Content with a Tags set to the term.\";s:7:\"handler\";s:41:\"views_handler_relationship_entity_reverse\";s:10:\"field_name\";s:10:\"field_tags\";s:11:\"field table\";s:21:\"field_data_field_tags\";s:11:\"field field\";s:14:\"field_tags_tid\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:10:\"field_tags\";s:10:\"join_extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:19:\"taxonomy_vocabulary\";a:8:{s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:26:\"Date (taxonomy_vocabulary)\";s:4:\"help\";s:180:\"Filter any Views taxonomy_vocabulary date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:26:\"Date (taxonomy_vocabulary)\";s:4:\"help\";s:48:\"Filter any Views taxonomy_vocabulary date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:5:\"table\";a:3:{s:5:\"group\";s:19:\"Taxonomy vocabulary\";s:4:\"join\";a:1:{s:18:\"taxonomy_term_data\";a:2:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:3:\"vid\";}}s:20:\"default_relationship\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:5:\"field\";s:13:\"term_node_tid\";}}}s:4:\"name\";a:3:{s:5:\"title\";s:4:\"Name\";s:5:\"field\";a:3:{s:4:\"help\";s:160:\"Name of the vocabulary a term is a member of. This will be the vocabulary that whichever term the \"Taxonomy: Term\" field is; and can similarly cause duplicates.\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:18:\"views_handler_sort\";s:4:\"help\";s:28:\"The taxonomy vocabulary name\";}}s:12:\"machine_name\";a:4:{s:5:\"title\";s:12:\"Machine name\";s:5:\"field\";a:3:{s:4:\"help\";s:168:\"Machine-Name of the vocabulary a term is a member of. This will be the vocabulary that whichever term the \"Taxonomy: Term\" field is; and can similarly cause duplicates.\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:2:{s:4:\"help\";s:66:\"Filter the results of \"Taxonomy: Term\" to a particular vocabulary.\";s:7:\"handler\";s:44:\"views_handler_filter_vocabulary_machine_name\";}s:8:\"argument\";a:2:{s:4:\"help\";s:66:\"Filter the results of \"Taxonomy: Term\" to a particular vocabulary.\";s:7:\"handler\";s:46:\"views_handler_argument_vocabulary_machine_name\";}}s:3:\"vid\";a:5:{s:5:\"title\";s:13:\"Vocabulary ID\";s:4:\"help\";s:26:\"The taxonomy vocabulary ID\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:37:\"views_handler_argument_vocabulary_vid\";s:10:\"name field\";s:4:\"name\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:11:\"description\";a:3:{s:5:\"title\";s:11:\"Description\";s:4:\"help\";s:35:\"The taxonomy vocabulary description\";s:5:\"field\";a:1:{s:7:\"handler\";s:19:\"views_handler_field\";}}s:6:\"weight\";a:6:{s:5:\"title\";s:6:\"Weight\";s:4:\"help\";s:30:\"The taxonomy vocabulary weight\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:10:\"name field\";s:6:\"weight\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}}}s:5:\"users\";a:28:{s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:12:\"Date (users)\";s:4:\"help\";s:166:\"Filter any Views users date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:12:\"Date (users)\";s:4:\"help\";s:34:\"Filter any Views users date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:5:\"table\";a:4:{s:5:\"group\";s:4:\"User\";s:4:\"base\";a:4:{s:5:\"field\";s:3:\"uid\";s:5:\"title\";s:4:\"User\";s:4:\"help\";s:45:\"Users who have created accounts on your site.\";s:16:\"access query tag\";s:11:\"user_access\";}s:11:\"entity type\";s:4:\"user\";s:20:\"default_relationship\";a:3:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"uid\";}s:13:\"node_revision\";a:2:{s:5:\"table\";s:13:\"node_revision\";s:5:\"field\";s:3:\"uid\";}s:4:\"file\";a:2:{s:5:\"table\";s:4:\"file\";s:5:\"field\";s:3:\"uid\";}}}s:3:\"uid\";a:7:{s:5:\"title\";s:3:\"Uid\";s:4:\"help\";s:11:\"The user ID\";s:5:\"field\";a:2:{s:7:\"handler\";s:24:\"views_handler_field_user\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:31:\"views_handler_argument_user_uid\";s:10:\"name field\";s:4:\"name\";}s:6:\"filter\";a:2:{s:5:\"title\";s:4:\"Name\";s:7:\"handler\";s:30:\"views_handler_filter_user_name\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:12:\"relationship\";a:7:{s:5:\"title\";s:16:\"Content authored\";s:4:\"help\";s:126:\"Relate content to the user who created it. This relationship will create one record for each content item created by the user.\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"uid\";s:5:\"field\";s:3:\"uid\";s:5:\"label\";s:5:\"nodes\";}}s:7:\"uid_raw\";a:3:{s:4:\"help\";s:24:\"The raw numeric user ID.\";s:10:\"real field\";s:3:\"uid\";s:6:\"filter\";a:2:{s:5:\"title\";s:11:\"The user ID\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}}s:18:\"uid_representative\";a:1:{s:12:\"relationship\";a:10:{s:5:\"title\";s:19:\"Representative node\";s:5:\"label\";s:19:\"Representative node\";s:4:\"help\";s:89:\"Obtains a single representative node for each user, according to a chosen sort criterion.\";s:7:\"handler\";s:40:\"views_handler_relationship_groupwise_max\";s:18:\"relationship field\";s:3:\"uid\";s:11:\"outer field\";s:9:\"users.uid\";s:14:\"argument table\";s:5:\"users\";s:14:\"argument field\";s:3:\"uid\";s:4:\"base\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";}}s:11:\"uid_current\";a:4:{s:10:\"real field\";s:3:\"uid\";s:5:\"title\";s:7:\"Current\";s:4:\"help\";s:48:\"Filter the view to the currently logged in user.\";s:6:\"filter\";a:2:{s:7:\"handler\";s:33:\"views_handler_filter_user_current\";s:4:\"type\";s:6:\"yes-no\";}}s:4:\"name\";a:6:{s:5:\"title\";s:4:\"Name\";s:4:\"help\";s:24:\"The user or author name.\";s:5:\"field\";a:2:{s:7:\"handler\";s:29:\"views_handler_field_user_name\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}s:6:\"filter\";a:3:{s:7:\"handler\";s:27:\"views_handler_filter_string\";s:5:\"title\";s:10:\"Name (raw)\";s:4:\"help\";s:130:\"The user or author name. This filter does not check if the user exists and allows partial matching. Does not utilize autocomplete.\";}}s:4:\"mail\";a:6:{s:5:\"title\";s:6:\"E-mail\";s:4:\"help\";s:104:\"Email address for a given user. This field is normally not shown to users, so be cautious when using it.\";s:5:\"field\";a:2:{s:7:\"handler\";s:29:\"views_handler_field_user_mail\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:8:\"language\";a:6:{s:5:\"title\";s:8:\"Language\";s:4:\"help\";s:20:\"Language of the user\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"views_handler_field_user_language\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:34:\"views_handler_filter_node_language\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:36:\"views_handler_argument_node_language\";}}s:11:\"picture_fid\";a:1:{s:8:\"moved to\";a:2:{i:0;s:5:\"users\";i:1;s:7:\"picture\";}}s:7:\"picture\";a:5:{s:5:\"title\";s:7:\"Picture\";s:4:\"help\";s:31:\"The user\'s picture, if allowed.\";s:5:\"field\";a:2:{s:7:\"handler\";s:32:\"views_handler_field_user_picture\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:3:{s:7:\"handler\";s:37:\"views_handler_filter_boolean_operator\";s:5:\"label\";s:10:\"Has Avatar\";s:4:\"type\";s:6:\"yes-no\";}}s:9:\"view_user\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:4:\"Link\";s:4:\"help\";s:34:\"Provide a simple link to the user.\";s:7:\"handler\";s:29:\"views_handler_field_user_link\";}}s:7:\"created\";a:5:{s:5:\"title\";s:12:\"Created date\";s:4:\"help\";s:30:\"The date the user was created.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}}s:16:\"created_fulldate\";a:3:{s:5:\"title\";s:12:\"Created date\";s:4:\"help\";s:29:\"Date in the form of CCYYMMDD.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:44:\"views_handler_argument_node_created_fulldate\";}}s:18:\"created_year_month\";a:3:{s:5:\"title\";s:20:\"Created year + month\";s:4:\"help\";s:27:\"Date in the form of YYYYMM.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:46:\"views_handler_argument_node_created_year_month\";}}s:14:\"timestamp_year\";a:1:{s:8:\"moved to\";a:2:{i:0;s:5:\"users\";i:1;s:12:\"created_year\";}}s:12:\"created_year\";a:3:{s:5:\"title\";s:12:\"Created year\";s:4:\"help\";s:25:\"Date in the form of YYYY.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:40:\"views_handler_argument_node_created_year\";}}s:13:\"created_month\";a:3:{s:5:\"title\";s:13:\"Created month\";s:4:\"help\";s:33:\"Date in the form of MM (01 - 12).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:41:\"views_handler_argument_node_created_month\";}}s:11:\"created_day\";a:3:{s:5:\"title\";s:11:\"Created day\";s:4:\"help\";s:33:\"Date in the form of DD (01 - 31).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:39:\"views_handler_argument_node_created_day\";}}s:12:\"created_week\";a:3:{s:5:\"title\";s:12:\"Created week\";s:4:\"help\";s:33:\"Date in the form of WW (01 - 53).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:40:\"views_handler_argument_node_created_week\";}}s:6:\"access\";a:5:{s:5:\"title\";s:11:\"Last access\";s:4:\"help\";s:28:\"The user\'s last access date.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}}s:5:\"login\";a:5:{s:5:\"title\";s:10:\"Last login\";s:4:\"help\";s:27:\"The user\'s last login date.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}}s:6:\"status\";a:5:{s:5:\"title\";s:6:\"Active\";s:4:\"help\";s:36:\"Whether a user is active or blocked.\";s:5:\"field\";a:3:{s:7:\"handler\";s:27:\"views_handler_field_boolean\";s:14:\"click sortable\";b:1;s:14:\"output formats\";a:1:{s:14:\"active-blocked\";a:2:{i:0;s:6:\"Active\";i:1;s:7:\"Blocked\";}}}s:6:\"filter\";a:3:{s:7:\"handler\";s:37:\"views_handler_filter_boolean_operator\";s:5:\"label\";s:6:\"Active\";s:4:\"type\";s:6:\"yes-no\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:9:\"signature\";a:4:{s:5:\"title\";s:9:\"Signature\";s:4:\"help\";s:21:\"The user\'s signature.\";s:5:\"field\";a:2:{s:7:\"handler\";s:26:\"views_handler_field_markup\";s:6:\"format\";s:10:\"plain_text\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}}s:9:\"edit_node\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:9:\"Edit link\";s:4:\"help\";s:39:\"Provide a simple link to edit the user.\";s:7:\"handler\";s:34:\"views_handler_field_user_link_edit\";}}s:11:\"cancel_node\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:11:\"Cancel link\";s:4:\"help\";s:41:\"Provide a simple link to cancel the user.\";s:7:\"handler\";s:36:\"views_handler_field_user_link_cancel\";}}s:4:\"data\";a:3:{s:5:\"title\";s:4:\"Data\";s:4:\"help\";s:35:\"Provide serialized data of the user\";s:5:\"field\";a:1:{s:7:\"handler\";s:30:\"views_handler_field_serialized\";}}}s:14:\"entity_comment\";a:17:{s:5:\"table\";a:2:{s:5:\"group\";s:7:\"Comment\";s:11:\"entity type\";s:7:\"comment\";}s:3:\"cid\";a:3:{s:5:\"title\";s:10:\"Comment ID\";s:4:\"help\";s:29:\"The unique ID of the comment.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:8:\"hostname\";a:3:{s:5:\"title\";s:10:\"IP Address\";s:4:\"help\";s:59:\"The IP address of the computer the comment was posted from.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:4:\"name\";a:3:{s:5:\"title\";s:4:\"Name\";s:4:\"help\";s:36:\"The name left by the comment author.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:4:\"mail\";a:3:{s:5:\"title\";s:13:\"Email address\";s:4:\"help\";s:45:\"The email address left by the comment author.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:8:\"homepage\";a:3:{s:5:\"title\";s:9:\"Home page\";s:4:\"help\";s:45:\"The home page URL left by the comment author.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:7:\"subject\";a:3:{s:5:\"title\";s:7:\"Subject\";s:4:\"help\";s:27:\"The subject of the comment.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:3:\"url\";a:3:{s:5:\"title\";s:3:\"URL\";s:4:\"help\";s:23:\"The URL of the comment.\";s:5:\"field\";a:2:{s:7:\"handler\";s:30:\"entity_views_handler_field_uri\";s:4:\"type\";s:3:\"uri\";}}s:8:\"edit_url\";a:3:{s:5:\"title\";s:8:\"Edit URL\";s:4:\"help\";s:35:\"The URL of the comment\'s edit page.\";s:5:\"field\";a:2:{s:7:\"handler\";s:30:\"entity_views_handler_field_uri\";s:4:\"type\";s:3:\"uri\";}}s:7:\"created\";a:3:{s:5:\"title\";s:12:\"Date created\";s:4:\"help\";s:32:\"The date the comment was posted.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_date\";s:4:\"type\";s:4:\"date\";}}s:6:\"parent\";a:4:{s:5:\"title\";s:6:\"Parent\";s:4:\"help\";s:53:\"The comment\'s parent, if comment threading is active.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:7:\"comment\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:14:\"entity_comment\";s:10:\"base field\";s:3:\"cid\";s:18:\"relationship field\";s:6:\"parent\";s:5:\"label\";s:6:\"Parent\";}}s:4:\"node\";a:4:{s:5:\"title\";s:4:\"Node\";s:4:\"help\";s:35:\"The node the comment was posted to.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"node\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_node\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:4:\"node\";s:5:\"label\";s:4:\"Node\";}}s:6:\"author\";a:4:{s:5:\"title\";s:6:\"Author\";s:4:\"help\";s:26:\"The author of the comment.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"user\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_user\";s:10:\"base field\";s:3:\"uid\";s:18:\"relationship field\";s:6:\"author\";s:5:\"label\";s:6:\"Author\";}}s:6:\"status\";a:3:{s:5:\"title\";s:6:\"Status\";s:4:\"help\";s:48:\"Whether the comment is published or unpublished.\";s:5:\"field\";a:3:{s:7:\"handler\";s:34:\"entity_views_handler_field_options\";s:4:\"type\";s:7:\"integer\";s:16:\"options callback\";a:2:{s:8:\"function\";s:35:\"entity_metadata_status_options_list\";s:4:\"info\";a:8:{s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:48:\"Whether the comment is published or unpublished.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:4:\"type\";s:7:\"integer\";s:12:\"options list\";s:35:\"entity_metadata_status_options_list\";s:17:\"setter permission\";s:19:\"administer comments\";s:12:\"schema field\";s:6:\"status\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}}}s:12:\"comment_body\";a:3:{s:5:\"title\";s:18:\"The main body text\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:14:\"text_formatted\";s:10:\"field_name\";s:12:\"comment_body\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:7:\"comment\";s:11:\"is revision\";b:0;}}s:18:\"comment_body_value\";a:4:{s:5:\"title\";s:26:\"The main body text » Text\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}s:10:\"real field\";s:18:\"comment_body:value\";}s:19:\"comment_body_format\";a:4:{s:5:\"title\";s:33:\"The main body text » Text format\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:3:{s:7:\"handler\";s:34:\"entity_views_handler_field_options\";s:4:\"type\";s:5:\"token\";s:16:\"options callback\";a:2:{s:8:\"function\";s:34:\"entity_metadata_field_text_formats\";s:4:\"info\";a:4:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}}s:10:\"real field\";s:19:\"comment_body:format\";}}s:20:\"views_entity_comment\";a:2:{s:15:\"rendered_entity\";a:3:{s:5:\"title\";s:16:\"Rendered Comment\";s:4:\"help\";s:67:\"The Comment of the current relationship rendered using a view mode.\";s:5:\"field\";a:3:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:7:\"comment\";s:10:\"real field\";s:13:\"entity object\";}}s:5:\"table\";a:3:{s:4:\"join\";a:3:{s:7:\"comment\";a:1:{s:10:\"left_table\";s:7:\"comment\";}s:14:\"entity_comment\";a:1:{s:10:\"left_table\";s:14:\"entity_comment\";}s:20:\"views_entity_comment\";a:1:{s:10:\"left_table\";s:20:\"views_entity_comment\";}}s:11:\"entity type\";s:7:\"comment\";s:5:\"group\";s:7:\"Comment\";}}s:11:\"entity_node\";a:165:{s:5:\"table\";a:2:{s:5:\"group\";s:4:\"Node\";s:11:\"entity type\";s:4:\"node\";}s:3:\"nid\";a:3:{s:5:\"title\";s:7:\"Node ID\";s:4:\"help\";s:26:\"The unique ID of the node.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:3:\"vid\";a:3:{s:5:\"title\";s:11:\"Revision ID\";s:4:\"help\";s:37:\"The unique ID of the node\'s revision.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:6:\"is_new\";a:3:{s:5:\"title\";s:6:\"Is new\";s:4:\"help\";s:58:\"Whether the node is new and not saved to the database yet.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_boolean\";s:4:\"type\";s:7:\"boolean\";}}s:4:\"type\";a:3:{s:5:\"title\";s:12:\"Content type\";s:4:\"help\";s:21:\"The type of the node.\";s:5:\"field\";a:3:{s:7:\"handler\";s:34:\"entity_views_handler_field_options\";s:4:\"type\";s:5:\"token\";s:16:\"options callback\";a:2:{s:8:\"function\";s:19:\"node_type_get_names\";s:4:\"info\";a:9:{s:5:\"label\";s:12:\"Content type\";s:4:\"type\";s:5:\"token\";s:11:\"description\";s:21:\"The type of the node.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:12:\"options list\";s:19:\"node_type_get_names\";s:8:\"required\";b:1;s:12:\"schema field\";s:4:\"type\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}}}s:5:\"title\";a:3:{s:5:\"title\";s:5:\"Title\";s:4:\"help\";s:22:\"The title of the node.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:8:\"language\";a:3:{s:5:\"title\";s:8:\"Language\";s:4:\"help\";s:36:\"The language the node is written in.\";s:5:\"field\";a:3:{s:7:\"handler\";s:34:\"entity_views_handler_field_options\";s:4:\"type\";s:5:\"token\";s:16:\"options callback\";a:2:{s:8:\"function\";s:29:\"entity_metadata_language_list\";s:4:\"info\";a:8:{s:5:\"label\";s:8:\"Language\";s:4:\"type\";s:5:\"token\";s:11:\"description\";s:36:\"The language the node is written in.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:12:\"options list\";s:29:\"entity_metadata_language_list\";s:12:\"schema field\";s:8:\"language\";s:17:\"setter permission\";s:16:\"administer nodes\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}}}s:3:\"url\";a:3:{s:5:\"title\";s:3:\"URL\";s:4:\"help\";s:20:\"The URL of the node.\";s:5:\"field\";a:2:{s:7:\"handler\";s:30:\"entity_views_handler_field_uri\";s:4:\"type\";s:3:\"uri\";}}s:8:\"edit_url\";a:3:{s:5:\"title\";s:8:\"Edit URL\";s:4:\"help\";s:32:\"The URL of the node\'s edit page.\";s:5:\"field\";a:2:{s:7:\"handler\";s:30:\"entity_views_handler_field_uri\";s:4:\"type\";s:3:\"uri\";}}s:6:\"status\";a:3:{s:5:\"title\";s:6:\"Status\";s:4:\"help\";s:45:\"Whether the node is published or unpublished.\";s:5:\"field\";a:3:{s:7:\"handler\";s:34:\"entity_views_handler_field_options\";s:4:\"type\";s:7:\"integer\";s:16:\"options callback\";a:2:{s:8:\"function\";s:35:\"entity_metadata_status_options_list\";s:4:\"info\";a:8:{s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:45:\"Whether the node is published or unpublished.\";s:4:\"type\";s:7:\"integer\";s:12:\"options list\";s:35:\"entity_metadata_status_options_list\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:12:\"schema field\";s:6:\"status\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}}}s:7:\"promote\";a:3:{s:5:\"title\";s:21:\"Promoted to frontpage\";s:4:\"help\";s:46:\"Whether the node is promoted to the frontpage.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_boolean\";s:4:\"type\";s:7:\"boolean\";}}s:6:\"sticky\";a:3:{s:5:\"title\";s:15:\"Sticky in lists\";s:4:\"help\";s:70:\"Whether the node is displayed at the top of lists in which it appears.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_boolean\";s:4:\"type\";s:7:\"boolean\";}}s:7:\"created\";a:3:{s:5:\"title\";s:12:\"Date created\";s:4:\"help\";s:29:\"The date the node was posted.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_date\";s:4:\"type\";s:4:\"date\";}}s:7:\"changed\";a:3:{s:5:\"title\";s:12:\"Date changed\";s:4:\"help\";s:44:\"The date the node was most recently updated.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_date\";s:4:\"type\";s:4:\"date\";}}s:6:\"author\";a:4:{s:5:\"title\";s:6:\"Author\";s:4:\"help\";s:23:\"The author of the node.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"user\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_user\";s:10:\"base field\";s:3:\"uid\";s:18:\"relationship field\";s:6:\"author\";s:5:\"label\";s:6:\"Author\";}}s:6:\"source\";a:4:{s:5:\"title\";s:23:\"Translation source node\";s:4:\"help\";s:58:\"The original-language version of this node, if one exists.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"node\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_node\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:6:\"source\";s:5:\"label\";s:23:\"Translation source node\";}}s:3:\"log\";a:3:{s:5:\"title\";s:20:\"Revision log message\";s:4:\"help\";s:93:\"In case a new revision is to be saved, the log entry explaining the changes for this version.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:8:\"revision\";a:3:{s:5:\"title\";s:16:\"Creates revision\";s:4:\"help\";s:48:\"Whether saving this node creates a new revision.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_boolean\";s:4:\"type\";s:7:\"boolean\";}}s:7:\"comment\";a:3:{s:5:\"title\";s:16:\"Comments allowed\";s:4:\"help\";s:97:\"Whether comments are allowed on this node: 0 = no, 1 = closed (read only), 2 = open (read/write).\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:13:\"comment_count\";a:3:{s:5:\"title\";s:13:\"Comment count\";s:4:\"help\";s:40:\"The number of comments posted on a node.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:17:\"comment_count_new\";a:3:{s:5:\"title\";s:17:\"New comment count\";s:4:\"help\";s:72:\"The number of comments posted on a node since the reader last viewed it.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:4:\"body\";a:3:{s:5:\"title\";s:18:\"The main body text\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:14:\"text_formatted\";s:10:\"field_name\";s:4:\"body\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:10:\"body_value\";a:4:{s:5:\"title\";s:26:\"The main body text » Text\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}s:10:\"real field\";s:10:\"body:value\";}s:12:\"body_summary\";a:4:{s:5:\"title\";s:29:\"The main body text » Summary\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}s:10:\"real field\";s:12:\"body:summary\";}s:11:\"body_format\";a:4:{s:5:\"title\";s:33:\"The main body text » Text format\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:3:{s:7:\"handler\";s:34:\"entity_views_handler_field_options\";s:4:\"type\";s:5:\"token\";s:16:\"options callback\";a:2:{s:8:\"function\";s:34:\"entity_metadata_field_text_formats\";s:4:\"info\";a:4:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}}s:10:\"real field\";s:11:\"body:format\";}s:10:\"field_tags\";a:4:{s:5:\"title\";s:4:\"Tags\";s:4:\"help\";s:19:\"Field \"field_tags\".\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:19:\"list<taxonomy_term>\";}s:12:\"relationship\";a:6:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:20:\"entity_taxonomy_term\";s:10:\"base field\";s:3:\"tid\";s:18:\"relationship field\";s:10:\"field_tags\";s:5:\"label\";s:4:\"Tags\";s:8:\"multiple\";b:1;}}s:16:\"field_ip_address\";a:3:{s:5:\"title\";s:10:\"IP Address\";s:4:\"help\";s:25:\"Field \"field_ip_address\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:16:\"field_ip_address\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:14:\"field_username\";a:3:{s:5:\"title\";s:8:\"Username\";s:4:\"help\";s:23:\"Field \"field_username\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:14:\"field_username\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:14:\"field_password\";a:3:{s:5:\"title\";s:8:\"Password\";s:4:\"help\";s:23:\"Field \"field_password\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:14:\"field_password\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:23:\"field_rediscover_status\";a:3:{s:5:\"title\";s:17:\"Rediscover Status\";s:4:\"help\";s:32:\"Field \"field_rediscover_status\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:23:\"field_rediscover_status\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:14:\"field_hostname\";a:3:{s:5:\"title\";s:8:\"Hostname\";s:4:\"help\";s:23:\"Field \"field_hostname\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:14:\"field_hostname\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:14:\"field_fmc_uuid\";a:3:{s:5:\"title\";s:8:\"FMC UUID\";s:4:\"help\";s:23:\"Field \"field_fmc_uuid\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:14:\"field_fmc_uuid\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:21:\"field_related_vcenter\";a:4:{s:5:\"title\";s:15:\"Related vCenter\";s:4:\"help\";s:30:\"Field \"field_related_vcenter\".\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"node\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_node\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:21:\"field_related_vcenter\";s:5:\"label\";s:15:\"Related vCenter\";}}s:19:\"field_vm_ip_address\";a:3:{s:5:\"title\";s:10:\"IP Address\";s:4:\"help\";s:28:\"Field \"field_vm_ip_address\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:19:\"field_vm_ip_address\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:17:\"field_memory_size\";a:3:{s:5:\"title\";s:11:\"Memory Size\";s:4:\"help\";s:26:\"Field \"field_memory_size\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:17:\"field_memory_size\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:14:\"field_template\";a:3:{s:5:\"title\";s:8:\"Template\";s:4:\"help\";s:23:\"Field \"field_template\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:14:\"field_template\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:18:\"field_vm_path_name\";a:3:{s:5:\"title\";s:12:\"VM Path Name\";s:4:\"help\";s:27:\"Field \"field_vm_path_name\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:18:\"field_vm_path_name\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:14:\"field_guest_os\";a:3:{s:5:\"title\";s:8:\"Guest OS\";s:4:\"help\";s:23:\"Field \"field_guest_os\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:14:\"field_guest_os\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:14:\"field_guest_id\";a:3:{s:5:\"title\";s:8:\"Guest ID\";s:4:\"help\";s:23:\"Field \"field_guest_id\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:14:\"field_guest_id\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:15:\"field_cpu_usage\";a:3:{s:5:\"title\";s:9:\"CPU Usage\";s:4:\"help\";s:24:\"Field \"field_cpu_usage\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:15:\"field_cpu_usage\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:23:\"field_host_memory_usage\";a:3:{s:5:\"title\";s:17:\"Host Memory Usage\";s:4:\"help\";s:32:\"Field \"field_host_memory_usage\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:23:\"field_host_memory_usage\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:24:\"field_guest_memory_usage\";a:3:{s:5:\"title\";s:18:\"Guest Memory Usage\";s:4:\"help\";s:33:\"Field \"field_guest_memory_usage\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:24:\"field_guest_memory_usage\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:17:\"field_vm_username\";a:3:{s:5:\"title\";s:8:\"Username\";s:4:\"help\";s:26:\"Field \"field_vm_username\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:17:\"field_vm_username\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:17:\"field_vm_password\";a:3:{s:5:\"title\";s:8:\"Password\";s:4:\"help\";s:26:\"Field \"field_vm_password\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:17:\"field_vm_password\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:19:\"field_driver_status\";a:3:{s:5:\"title\";s:13:\"Driver Status\";s:4:\"help\";s:28:\"Field \"field_driver_status\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:19:\"field_driver_status\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:10:\"field_host\";a:4:{s:5:\"title\";s:4:\"Host\";s:4:\"help\";s:19:\"Field \"field_host\".\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"node\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_node\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:10:\"field_host\";s:5:\"label\";s:4:\"Host\";}}s:18:\"field_vmware_tools\";a:3:{s:5:\"title\";s:12:\"VMware Tools\";s:4:\"help\";s:27:\"Field \"field_vmware_tools\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:18:\"field_vmware_tools\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:15:\"field_no_of_cpu\";a:3:{s:5:\"title\";s:9:\"no_of_cpu\";s:4:\"help\";s:24:\"Field \"field_no_of_cpu\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:15:\"field_no_of_cpu\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:19:\"field_virtual_disks\";a:3:{s:5:\"title\";s:13:\"virtual_disks\";s:4:\"help\";s:28:\"Field \"field_virtual_disks\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:19:\"field_virtual_disks\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:22:\"field_fa_build_version\";a:3:{s:5:\"title\";s:13:\"Build Version\";s:4:\"help\";s:31:\"Field \"field_fa_build_version\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:22:\"field_fa_build_version\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:19:\"field_fa_cache_mode\";a:3:{s:5:\"title\";s:10:\"Cache Mode\";s:4:\"help\";s:28:\"Field \"field_fa_cache_mode\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:19:\"field_fa_cache_mode\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:29:\"field_fa_administration_state\";a:3:{s:5:\"title\";s:20:\"Administration State\";s:4:\"help\";s:38:\"Field \"field_fa_administration_state\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:29:\"field_fa_administration_state\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:19:\"field_fa_cache_size\";a:3:{s:5:\"title\";s:10:\"Cache Size\";s:4:\"help\";s:28:\"Field \"field_fa_cache_size\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:19:\"field_fa_cache_size\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:26:\"field_fa_operational_state\";a:3:{s:5:\"title\";s:17:\"Operational State\";s:4:\"help\";s:35:\"Field \"field_fa_operational_state\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:26:\"field_fa_operational_state\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:28:\"field_fa_operational_message\";a:3:{s:5:\"title\";s:19:\"Operational Message\";s:4:\"help\";s:37:\"Field \"field_fa_operational_message\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:28:\"field_fa_operational_message\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:26:\"field_fa_performance_state\";a:3:{s:5:\"title\";s:17:\"Performance State\";s:4:\"help\";s:35:\"Field \"field_fa_performance_state\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:26:\"field_fa_performance_state\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:22:\"field_fa_generation_id\";a:3:{s:5:\"title\";s:13:\"Generation ID\";s:4:\"help\";s:31:\"Field \"field_fa_generation_id\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:22:\"field_fa_generation_id\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:16:\"field_cachespace\";a:3:{s:5:\"title\";s:10:\"Cachespace\";s:4:\"help\";s:25:\"Field \"field_cachespace\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:16:\"field_cachespace\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:18:\"field_install_port\";a:3:{s:5:\"title\";s:12:\"Install Port\";s:4:\"help\";s:27:\"Field \"field_install_port\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:18:\"field_install_port\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:20:\"field_vm_vmotionable\";a:3:{s:5:\"title\";s:12:\"V Motionable\";s:4:\"help\";s:29:\"Field \"field_vm_vmotionable\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"boolean\";s:10:\"field_name\";s:20:\"field_vm_vmotionable\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:22:\"field_fa_usable_blocks\";a:3:{s:5:\"title\";s:13:\"Usable Blocks\";s:4:\"help\";s:31:\"Field \"field_fa_usable_blocks\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:22:\"field_fa_usable_blocks\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:20:\"field_fa_sector_size\";a:3:{s:5:\"title\";s:11:\"Sector Size\";s:4:\"help\";s:29:\"Field \"field_fa_sector_size\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:20:\"field_fa_sector_size\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:17:\"field_vm_hostname\";a:3:{s:5:\"title\";s:8:\"Hostname\";s:4:\"help\";s:26:\"Field \"field_vm_hostname\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:17:\"field_vm_hostname\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:31:\"field_fa_metrics_reset_interval\";a:3:{s:5:\"title\";s:22:\"Metrics Reset Interval\";s:4:\"help\";s:40:\"Field \"field_fa_metrics_reset_interval\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:31:\"field_fa_metrics_reset_interval\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:23:\"field_vm_vmotion_policy\";a:3:{s:5:\"title\";s:17:\"VM vMotion Policy\";s:4:\"help\";s:32:\"Field \"field_vm_vmotion_policy\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:23:\"field_vm_vmotion_policy\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:25:\"field_vm_vmotion_hostlist\";a:3:{s:5:\"title\";s:19:\"VM vMotion Hostlist\";s:4:\"help\";s:34:\"Field \"field_vm_vmotion_hostlist\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:25:\"field_vm_vmotion_hostlist\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:15:\"field_cpu_model\";a:3:{s:5:\"title\";s:9:\"Cpu Model\";s:4:\"help\";s:24:\"Field \"field_cpu_model\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:15:\"field_cpu_model\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:14:\"field_boottime\";a:3:{s:5:\"title\";s:8:\"BootTime\";s:4:\"help\";s:23:\"Field \"field_boottime\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:14:\"field_boottime\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:17:\"field_host_status\";a:3:{s:5:\"title\";s:11:\"Host Status\";s:4:\"help\";s:26:\"Field \"field_host_status\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:17:\"field_host_status\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:22:\"field_maintenance_mode\";a:3:{s:5:\"title\";s:16:\"Maintenance mode\";s:4:\"help\";s:31:\"Field \"field_maintenance_mode\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:22:\"field_maintenance_mode\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:21:\"field_physical_memory\";a:3:{s:5:\"title\";s:15:\"Physical Memory\";s:4:\"help\";s:30:\"Field \"field_physical_memory\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:21:\"field_physical_memory\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:13:\"field_vmotion\";a:3:{s:5:\"title\";s:7:\"VMotion\";s:4:\"help\";s:22:\"Field \"field_vmotion\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:13:\"field_vmotion\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:21:\"field_reboot_required\";a:3:{s:5:\"title\";s:15:\"Reboot Required\";s:4:\"help\";s:30:\"Field \"field_reboot_required\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:21:\"field_reboot_required\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:19:\"field_host_username\";a:3:{s:5:\"title\";s:8:\"Username\";s:4:\"help\";s:28:\"Field \"field_host_username\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:19:\"field_host_username\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:19:\"field_host_password\";a:3:{s:5:\"title\";s:8:\"Password\";s:4:\"help\";s:28:\"Field \"field_host_password\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:19:\"field_host_password\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:19:\"field_bundle_status\";a:3:{s:5:\"title\";s:13:\"Bundle Status\";s:4:\"help\";s:28:\"Field \"field_bundle_status\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:19:\"field_bundle_status\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:16:\"field_datacenter\";a:4:{s:5:\"title\";s:10:\"Datacenter\";s:4:\"help\";s:25:\"Field \"field_datacenter\".\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"node\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_node\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:16:\"field_datacenter\";s:5:\"label\";s:10:\"Datacenter\";}}s:22:\"field_software_on_host\";a:3:{s:5:\"title\";s:16:\"Software on host\";s:4:\"help\";s:31:\"Field \"field_software_on_host\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:22:\"field_software_on_host\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:24:\"field_allocated_segments\";a:3:{s:5:\"title\";s:18:\"Allocated Segments\";s:4:\"help\";s:33:\"Field \"field_allocated_segments\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:24:\"field_allocated_segments\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:18:\"field_segment_size\";a:3:{s:5:\"title\";s:12:\"Segment Size\";s:4:\"help\";s:27:\"Field \"field_segment_size\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:18:\"field_segment_size\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:26:\"field_max_virtual_machines\";a:3:{s:5:\"title\";s:20:\"Max Virtual Machines\";s:4:\"help\";s:35:\"Field \"field_max_virtual_machines\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:26:\"field_max_virtual_machines\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:26:\"field_max_physical_devices\";a:3:{s:5:\"title\";s:20:\"Max Physical Devices\";s:4:\"help\";s:35:\"Field \"field_max_physical_devices\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:26:\"field_max_physical_devices\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:30:\"field_claimed_physical_devices\";a:3:{s:5:\"title\";s:24:\"Claimed Physical Devices\";s:4:\"help\";s:39:\"Field \"field_claimed_physical_devices\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:30:\"field_claimed_physical_devices\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:17:\"field_cache_state\";a:3:{s:5:\"title\";s:11:\"Cache State\";s:4:\"help\";s:26:\"Field \"field_cache_state\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:17:\"field_cache_state\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:20:\"field_total_segments\";a:3:{s:5:\"title\";s:14:\"Total Segments\";s:4:\"help\";s:29:\"Field \"field_total_segments\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:20:\"field_total_segments\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:32:\"field_allocated_virtual_machines\";a:3:{s:5:\"title\";s:26:\"Allocated Virtual Machines\";s:4:\"help\";s:41:\"Field \"field_allocated_virtual_machines\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:32:\"field_allocated_virtual_machines\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:17:\"field_vib_version\";a:3:{s:5:\"title\";s:11:\"VIB Version\";s:4:\"help\";s:26:\"Field \"field_vib_version\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:17:\"field_vib_version\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:16:\"field_total_size\";a:3:{s:5:\"title\";s:10:\"Total Size\";s:4:\"help\";s:25:\"Field \"field_total_size\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:16:\"field_total_size\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:20:\"field_naa_identifier\";a:3:{s:5:\"title\";s:14:\"NAA Identifier\";s:4:\"help\";s:29:\"Field \"field_naa_identifier\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:20:\"field_naa_identifier\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:20:\"field_allocated_size\";a:3:{s:5:\"title\";s:14:\"Allocated Size\";s:4:\"help\";s:29:\"Field \"field_allocated_size\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:20:\"field_allocated_size\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:18:\"field_device_state\";a:3:{s:5:\"title\";s:12:\"Device State\";s:4:\"help\";s:27:\"Field \"field_device_state\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:18:\"field_device_state\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:16:\"field_host_model\";a:3:{s:5:\"title\";s:10:\"Host Model\";s:4:\"help\";s:25:\"Field \"field_host_model\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:16:\"field_host_model\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:17:\"field_host_vendor\";a:3:{s:5:\"title\";s:11:\"Host Vendor\";s:4:\"help\";s:26:\"Field \"field_host_vendor\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:17:\"field_host_vendor\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:10:\"field_hbtl\";a:3:{s:5:\"title\";s:4:\"HBTL\";s:4:\"help\";s:19:\"Field \"field_hbtl\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:10:\"field_hbtl\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:13:\"field_host_ip\";a:3:{s:5:\"title\";s:2:\"IP\";s:4:\"help\";s:22:\"Field \"field_host_ip\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:13:\"field_host_ip\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:9:\"field_drs\";a:3:{s:5:\"title\";s:3:\"drs\";s:4:\"help\";s:18:\"Field \"field_drs\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:9:\"field_drs\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:8:\"field_ha\";a:3:{s:5:\"title\";s:2:\"HA\";s:4:\"help\";s:17:\"Field \"field_ha\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:8:\"field_ha\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:15:\"field_serial_no\";a:3:{s:5:\"title\";s:9:\"Serial No\";s:4:\"help\";s:24:\"Field \"field_serial_no\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:15:\"field_serial_no\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:10:\"field_size\";a:3:{s:5:\"title\";s:4:\"Size\";s:4:\"help\";s:19:\"Field \"field_size\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:10:\"field_size\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:17:\"field_device_type\";a:3:{s:5:\"title\";s:11:\"Device Type\";s:4:\"help\";s:26:\"Field \"field_device_type\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:17:\"field_device_type\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:22:\"field_multipath_plugin\";a:3:{s:5:\"title\";s:16:\"Multipath Plugin\";s:4:\"help\";s:31:\"Field \"field_multipath_plugin\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:22:\"field_multipath_plugin\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:16:\"field_devfs_path\";a:3:{s:5:\"title\";s:10:\"Devfs Path\";s:4:\"help\";s:25:\"Field \"field_devfs_path\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:16:\"field_devfs_path\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:12:\"field_vendor\";a:3:{s:5:\"title\";s:6:\"Vendor\";s:4:\"help\";s:21:\"Field \"field_vendor\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:12:\"field_vendor\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:11:\"field_model\";a:3:{s:5:\"title\";s:5:\"Model\";s:4:\"help\";s:20:\"Field \"field_model\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:11:\"field_model\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:14:\"field_revision\";a:3:{s:5:\"title\";s:8:\"Revision\";s:4:\"help\";s:23:\"Field \"field_revision\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:14:\"field_revision\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:16:\"field_scsi_level\";a:3:{s:5:\"title\";s:10:\"SCSI Level\";s:4:\"help\";s:25:\"Field \"field_scsi_level\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:16:\"field_scsi_level\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:15:\"field_is_pseudo\";a:3:{s:5:\"title\";s:9:\"Is Pseudo\";s:4:\"help\";s:24:\"Field \"field_is_pseudo\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:15:\"field_is_pseudo\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:12:\"field_status\";a:3:{s:5:\"title\";s:6:\"Status\";s:4:\"help\";s:21:\"Field \"field_status\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:12:\"field_status\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:20:\"field_is_rdm_capable\";a:3:{s:5:\"title\";s:14:\"Is RDM Capable\";s:4:\"help\";s:29:\"Field \"field_is_rdm_capable\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:20:\"field_is_rdm_capable\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:14:\"field_is_local\";a:3:{s:5:\"title\";s:8:\"Is Local\";s:4:\"help\";s:23:\"Field \"field_is_local\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:14:\"field_is_local\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:18:\"field_is_removable\";a:3:{s:5:\"title\";s:12:\"Is Removable\";s:4:\"help\";s:27:\"Field \"field_is_removable\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:18:\"field_is_removable\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:12:\"field_is_ssd\";a:3:{s:5:\"title\";s:6:\"Is SSD\";s:4:\"help\";s:21:\"Field \"field_is_ssd\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:12:\"field_is_ssd\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:16:\"field_is_offline\";a:3:{s:5:\"title\";s:10:\"Is Offline\";s:4:\"help\";s:25:\"Field \"field_is_offline\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:16:\"field_is_offline\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:29:\"field_is_perennially_reserved\";a:3:{s:5:\"title\";s:23:\"Is Perennially Reserved\";s:4:\"help\";s:38:\"Field \"field_is_perennially_reserved\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:29:\"field_is_perennially_reserved\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:30:\"field_thin_provisioning_status\";a:3:{s:5:\"title\";s:24:\"Thin Provisioning Status\";s:4:\"help\";s:39:\"Field \"field_thin_provisioning_status\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:30:\"field_thin_provisioning_status\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:22:\"field_attached_filters\";a:3:{s:5:\"title\";s:16:\"Attached Filters\";s:4:\"help\";s:31:\"Field \"field_attached_filters\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:22:\"field_attached_filters\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:17:\"field_vaai_status\";a:3:{s:5:\"title\";s:11:\"VAAI Status\";s:4:\"help\";s:26:\"Field \"field_vaai_status\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:17:\"field_vaai_status\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:16:\"field_other_uids\";a:3:{s:5:\"title\";s:10:\"Other UIDs\";s:4:\"help\";s:25:\"Field \"field_other_uids\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:16:\"field_other_uids\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:18:\"field_display_name\";a:3:{s:5:\"title\";s:12:\"Display Name\";s:4:\"help\";s:27:\"Field \"field_display_name\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:18:\"field_display_name\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:18:\"field_related_host\";a:4:{s:5:\"title\";s:12:\"Related Host\";s:4:\"help\";s:27:\"Field \"field_related_host\".\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"node\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_node\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:18:\"field_related_host\";s:5:\"label\";s:12:\"Related Host\";}}s:13:\"field_is_vmfs\";a:3:{s:5:\"title\";s:7:\"Is VMFS\";s:4:\"help\";s:22:\"Field \"field_is_vmfs\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:13:\"field_is_vmfs\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:14:\"field_capacity\";a:3:{s:5:\"title\";s:8:\"Capacity\";s:4:\"help\";s:23:\"Field \"field_capacity\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:14:\"field_capacity\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:10:\"field_path\";a:3:{s:5:\"title\";s:4:\"Path\";s:4:\"help\";s:19:\"Field \"field_path\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:10:\"field_path\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:15:\"field_freespace\";a:3:{s:5:\"title\";s:9:\"Freespace\";s:4:\"help\";s:24:\"Field \"field_freespace\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:15:\"field_freespace\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:21:\"field_virtual_machine\";a:4:{s:5:\"title\";s:15:\"Virtual Machine\";s:4:\"help\";s:30:\"Field \"field_virtual_machine\".\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"node\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_node\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:21:\"field_virtual_machine\";s:5:\"label\";s:15:\"Virtual Machine\";}}s:16:\"field_disk_index\";a:3:{s:5:\"title\";s:10:\"Disk Index\";s:4:\"help\";s:25:\"Field \"field_disk_index\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:16:\"field_disk_index\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:22:\"field_vdisk_identifier\";a:3:{s:5:\"title\";s:10:\"Identifier\";s:4:\"help\";s:31:\"Field \"field_vdisk_identifier\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:22:\"field_vdisk_identifier\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:16:\"field_vdisk_name\";a:3:{s:5:\"title\";s:10:\"vDisk Name\";s:4:\"help\";s:25:\"Field \"field_vdisk_name\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:16:\"field_vdisk_name\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:16:\"field_vdisk_type\";a:3:{s:5:\"title\";s:10:\"vDisk Type\";s:4:\"help\";s:25:\"Field \"field_vdisk_type\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:16:\"field_vdisk_type\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:14:\"field_vdisk_id\";a:3:{s:5:\"title\";s:8:\"vDisk Id\";s:4:\"help\";s:23:\"Field \"field_vdisk_id\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:14:\"field_vdisk_id\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:8:\"field_vm\";a:4:{s:5:\"title\";s:2:\"VM\";s:4:\"help\";s:17:\"Field \"field_vm\".\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"node\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_node\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:8:\"field_vm\";s:5:\"label\";s:2:\"VM\";}}s:21:\"field_vm_read_latency\";a:3:{s:5:\"title\";s:12:\"Read latency\";s:4:\"help\";s:30:\"Field \"field_vm_read_latency\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"decimal\";s:10:\"field_name\";s:21:\"field_vm_read_latency\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:22:\"field_vm_write_latency\";a:3:{s:5:\"title\";s:13:\"Write latency\";s:4:\"help\";s:31:\"Field \"field_vm_write_latency\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"decimal\";s:10:\"field_name\";s:22:\"field_vm_write_latency\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:17:\"field_vm_read_ops\";a:3:{s:5:\"title\";s:8:\"Read ops\";s:4:\"help\";s:26:\"Field \"field_vm_read_ops\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"decimal\";s:10:\"field_name\";s:17:\"field_vm_read_ops\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:18:\"field_vm_write_ops\";a:3:{s:5:\"title\";s:9:\"Write ops\";s:4:\"help\";s:27:\"Field \"field_vm_write_ops\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"decimal\";s:10:\"field_name\";s:18:\"field_vm_write_ops\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:13:\"field_vm_hits\";a:3:{s:5:\"title\";s:4:\"Hits\";s:4:\"help\";s:22:\"Field \"field_vm_hits\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:13:\"field_vm_hits\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:20:\"field_vm_read_blocks\";a:3:{s:5:\"title\";s:11:\"Read blocks\";s:4:\"help\";s:29:\"Field \"field_vm_read_blocks\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:20:\"field_vm_read_blocks\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:22:\"field_vm_cache_latency\";a:3:{s:5:\"title\";s:13:\"Cache latency\";s:4:\"help\";s:31:\"Field \"field_vm_cache_latency\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"decimal\";s:10:\"field_name\";s:22:\"field_vm_cache_latency\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:19:\"field_vm_population\";a:3:{s:5:\"title\";s:10:\"Population\";s:4:\"help\";s:28:\"Field \"field_vm_population\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:19:\"field_vm_population\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:22:\"field_vm_usable_blocks\";a:3:{s:5:\"title\";s:13:\"Usable blocks\";s:4:\"help\";s:31:\"Field \"field_vm_usable_blocks\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:22:\"field_vm_usable_blocks\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:21:\"field_vm_write_blocks\";a:3:{s:5:\"title\";s:12:\"Write blocks\";s:4:\"help\";s:30:\"Field \"field_vm_write_blocks\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:21:\"field_vm_write_blocks\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:19:\"field_vm_insertions\";a:3:{s:5:\"title\";s:10:\"Insertions\";s:4:\"help\";s:28:\"Field \"field_vm_insertions\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:19:\"field_vm_insertions\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:22:\"field_vm_population_pc\";a:3:{s:5:\"title\";s:12:\"Population %\";s:4:\"help\";s:31:\"Field \"field_vm_population_pc\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"decimal\";s:10:\"field_name\";s:22:\"field_vm_population_pc\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:26:\"field_vm_insertion_rate_pc\";a:3:{s:5:\"title\";s:16:\"Insertion rate %\";s:4:\"help\";s:35:\"Field \"field_vm_insertion_rate_pc\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"decimal\";s:10:\"field_name\";s:26:\"field_vm_insertion_rate_pc\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:15:\"field_timestamp\";a:3:{s:5:\"title\";s:9:\"Timestamp\";s:4:\"help\";s:24:\"Field \"field_timestamp\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"date\";s:10:\"field_name\";s:15:\"field_timestamp\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:20:\"field_vm_hit_rate_pc\";a:3:{s:5:\"title\";s:10:\"Hit Rate %\";s:4:\"help\";s:29:\"Field \"field_vm_hit_rate_pc\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:20:\"field_vm_hit_rate_pc\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:11:\"field_vdisk\";a:4:{s:5:\"title\";s:5:\"vDisk\";s:4:\"help\";s:20:\"Field \"field_vdisk\".\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"node\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_node\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:11:\"field_vdisk\";s:5:\"label\";s:5:\"vDisk\";}}s:24:\"field_vdisk_read_latency\";a:3:{s:5:\"title\";s:12:\"Read latency\";s:4:\"help\";s:33:\"Field \"field_vdisk_read_latency\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"decimal\";s:10:\"field_name\";s:24:\"field_vdisk_read_latency\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:25:\"field_vdisk_write_latency\";a:3:{s:5:\"title\";s:13:\"Write latency\";s:4:\"help\";s:34:\"Field \"field_vdisk_write_latency\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"decimal\";s:10:\"field_name\";s:25:\"field_vdisk_write_latency\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:20:\"field_vdisk_read_ops\";a:3:{s:5:\"title\";s:8:\"Read ops\";s:4:\"help\";s:29:\"Field \"field_vdisk_read_ops\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"decimal\";s:10:\"field_name\";s:20:\"field_vdisk_read_ops\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:21:\"field_vdisk_write_ops\";a:3:{s:5:\"title\";s:9:\"Write ops\";s:4:\"help\";s:30:\"Field \"field_vdisk_write_ops\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"decimal\";s:10:\"field_name\";s:21:\"field_vdisk_write_ops\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:16:\"field_vdisk_hits\";a:3:{s:5:\"title\";s:4:\"Hits\";s:4:\"help\";s:25:\"Field \"field_vdisk_hits\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:16:\"field_vdisk_hits\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:23:\"field_vdisk_read_blocks\";a:3:{s:5:\"title\";s:11:\"Read blocks\";s:4:\"help\";s:32:\"Field \"field_vdisk_read_blocks\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:23:\"field_vdisk_read_blocks\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:25:\"field_vdisk_cache_latency\";a:3:{s:5:\"title\";s:13:\"Cache latency\";s:4:\"help\";s:34:\"Field \"field_vdisk_cache_latency\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"decimal\";s:10:\"field_name\";s:25:\"field_vdisk_cache_latency\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:22:\"field_vdisk_population\";a:3:{s:5:\"title\";s:10:\"Population\";s:4:\"help\";s:31:\"Field \"field_vdisk_population\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:22:\"field_vdisk_population\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:25:\"field_vdisk_usable_blocks\";a:3:{s:5:\"title\";s:13:\"Usable blocks\";s:4:\"help\";s:34:\"Field \"field_vdisk_usable_blocks\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:25:\"field_vdisk_usable_blocks\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:22:\"field_vdisk_insertions\";a:3:{s:5:\"title\";s:10:\"Insertions\";s:4:\"help\";s:31:\"Field \"field_vdisk_insertions\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:22:\"field_vdisk_insertions\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:24:\"field_vdisk_write_blocks\";a:3:{s:5:\"title\";s:12:\"Write blocks\";s:4:\"help\";s:33:\"Field \"field_vdisk_write_blocks\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"integer\";s:10:\"field_name\";s:24:\"field_vdisk_write_blocks\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:25:\"field_vdisk_population_pc\";a:3:{s:5:\"title\";s:12:\"Population %\";s:4:\"help\";s:34:\"Field \"field_vdisk_population_pc\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:25:\"field_vdisk_population_pc\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:29:\"field_vdisk_insertion_rate_pc\";a:3:{s:5:\"title\";s:16:\"Insertion rate %\";s:4:\"help\";s:38:\"Field \"field_vdisk_insertion_rate_pc\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:29:\"field_vdisk_insertion_rate_pc\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:13:\"field_hit_ops\";a:3:{s:5:\"title\";s:7:\"Hit Ops\";s:4:\"help\";s:22:\"Field \"field_hit_ops\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"decimal\";s:10:\"field_name\";s:13:\"field_hit_ops\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:23:\"field_vdisk_hit_rate_pc\";a:3:{s:5:\"title\";s:10:\"Hit Rate %\";s:4:\"help\";s:32:\"Field \"field_vdisk_hit_rate_pc\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:23:\"field_vdisk_hit_rate_pc\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:19:\"field_vm_cache_size\";a:3:{s:5:\"title\";s:10:\"Cache Size\";s:4:\"help\";s:28:\"Field \"field_vm_cache_size\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:19:\"field_vm_cache_size\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:30:\"field_cache_assigned_from_host\";a:4:{s:5:\"title\";s:18:\"Assigned from Host\";s:4:\"help\";s:39:\"Field \"field_cache_assigned_from_host\".\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"node\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_node\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:30:\"field_cache_assigned_from_host\";s:5:\"label\";s:18:\"Assigned from Host\";}}s:27:\"field_cache_allocated_to_vm\";a:4:{s:5:\"title\";s:28:\"Allocated to Virtual Machine\";s:4:\"help\";s:36:\"Field \"field_cache_allocated_to_vm\".\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"node\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_node\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:27:\"field_cache_allocated_to_vm\";s:5:\"label\";s:28:\"Allocated to Virtual Machine\";}}}s:17:\"views_entity_node\";a:5:{s:15:\"rendered_entity\";a:3:{s:5:\"title\";s:13:\"Rendered Node\";s:4:\"help\";s:64:\"The Node of the current relationship rendered using a view mode.\";s:5:\"field\";a:3:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"node\";s:10:\"real field\";s:13:\"entity object\";}}s:5:\"table\";a:3:{s:5:\"group\";s:7:\"Content\";s:4:\"join\";a:4:{s:4:\"node\";a:1:{s:10:\"left_table\";s:4:\"node\";}s:13:\"node_revision\";a:1:{s:10:\"left_table\";s:13:\"node_revision\";}s:11:\"entity_node\";a:1:{s:10:\"left_table\";s:11:\"entity_node\";}s:17:\"views_entity_node\";a:1:{s:10:\"left_table\";s:17:\"views_entity_node\";}}s:11:\"entity type\";s:4:\"node\";}s:9:\"view_node\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:4:\"Link\";s:4:\"help\";s:37:\"Provide a simple link to the content.\";s:7:\"handler\";s:29:\"views_handler_field_node_link\";}}s:9:\"edit_node\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:9:\"Edit link\";s:4:\"help\";s:42:\"Provide a simple link to edit the content.\";s:7:\"handler\";s:34:\"views_handler_field_node_link_edit\";}}s:11:\"delete_node\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:11:\"Delete link\";s:4:\"help\";s:44:\"Provide a simple link to delete the content.\";s:7:\"handler\";s:36:\"views_handler_field_node_link_delete\";}}}s:24:\"entity_search_api_server\";a:7:{s:5:\"table\";a:2:{s:5:\"group\";s:13:\"Search server\";s:11:\"entity type\";s:17:\"search_api_server\";}s:2:\"id\";a:3:{s:5:\"title\";s:2:\"ID\";s:4:\"help\";s:36:\"The primary identifier for a server.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:4:\"name\";a:3:{s:5:\"title\";s:4:\"Name\";s:4:\"help\";s:32:\"The displayed name for a server.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:12:\"machine_name\";a:3:{s:5:\"title\";s:12:\"Machine name\";s:4:\"help\";s:46:\"The internally used machine name for a server.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:5:\"token\";}}s:11:\"description\";a:3:{s:5:\"title\";s:11:\"Description\";s:4:\"help\";s:39:\"The displayed description for a server.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:5:\"class\";a:3:{s:5:\"title\";s:13:\"Service class\";s:4:\"help\";s:51:\"The ID of the service class to use for this server.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:7:\"enabled\";a:3:{s:5:\"title\";s:7:\"Enabled\";s:4:\"help\";s:48:\"A flag indicating whether the server is enabled.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_boolean\";s:4:\"type\";s:7:\"boolean\";}}}s:30:\"views_entity_search_api_server\";a:2:{s:15:\"rendered_entity\";a:3:{s:5:\"title\";s:22:\"Rendered Search server\";s:4:\"help\";s:73:\"The Search server of the current relationship rendered using a view mode.\";s:5:\"field\";a:3:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:17:\"search_api_server\";s:10:\"real field\";s:13:\"entity object\";}}s:5:\"table\";a:3:{s:4:\"join\";a:3:{s:17:\"search_api_server\";a:1:{s:10:\"left_table\";s:17:\"search_api_server\";}s:24:\"entity_search_api_server\";a:1:{s:10:\"left_table\";s:24:\"entity_search_api_server\";}s:30:\"views_entity_search_api_server\";a:1:{s:10:\"left_table\";s:30:\"views_entity_search_api_server\";}}s:11:\"entity type\";s:17:\"search_api_server\";s:5:\"group\";s:13:\"Search server\";}}s:23:\"entity_search_api_index\";a:10:{s:5:\"table\";a:2:{s:5:\"group\";s:12:\"Search index\";s:11:\"entity type\";s:16:\"search_api_index\";}s:2:\"id\";a:3:{s:5:\"title\";s:2:\"ID\";s:4:\"help\";s:33:\"An integer identifying the index.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:4:\"name\";a:3:{s:5:\"title\";s:4:\"Name\";s:4:\"help\";s:37:\"A name to be displayed for the index.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:12:\"machine_name\";a:3:{s:5:\"title\";s:12:\"Machine name\";s:4:\"help\";s:46:\"The internally used machine name for an index.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:5:\"token\";}}s:11:\"description\";a:3:{s:5:\"title\";s:11:\"Description\";s:4:\"help\";s:44:\"A string describing the index\' use to users.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:6:\"server\";a:3:{s:5:\"title\";s:9:\"Server ID\";s:4:\"help\";s:76:\"The machine name of the search_api_server with which data should be indexed.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:5:\"token\";}}s:13:\"server_entity\";a:4:{s:5:\"title\";s:6:\"Server\";s:4:\"help\";s:56:\"The search_api_server with which data should be indexed.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:17:\"search_api_server\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:24:\"entity_search_api_server\";s:10:\"base field\";s:2:\"id\";s:18:\"relationship field\";s:13:\"server_entity\";s:5:\"label\";s:6:\"Server\";}}s:9:\"item_type\";a:3:{s:5:\"title\";s:9:\"Item type\";s:4:\"help\";s:39:\"The type of items stored in this index.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:5:\"token\";}}s:7:\"enabled\";a:3:{s:5:\"title\";s:7:\"Enabled\";s:4:\"help\";s:47:\"A flag indicating whether the index is enabled.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_boolean\";s:4:\"type\";s:7:\"boolean\";}}s:9:\"read_only\";a:3:{s:5:\"title\";s:9:\"Read only\";s:4:\"help\";s:49:\"A flag indicating whether the index is read-only.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_boolean\";s:4:\"type\";s:7:\"boolean\";}}}s:29:\"views_entity_search_api_index\";a:2:{s:15:\"rendered_entity\";a:3:{s:5:\"title\";s:21:\"Rendered Search index\";s:4:\"help\";s:72:\"The Search index of the current relationship rendered using a view mode.\";s:5:\"field\";a:3:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:16:\"search_api_index\";s:10:\"real field\";s:13:\"entity object\";}}s:5:\"table\";a:3:{s:4:\"join\";a:3:{s:16:\"search_api_index\";a:1:{s:10:\"left_table\";s:16:\"search_api_index\";}s:23:\"entity_search_api_index\";a:1:{s:10:\"left_table\";s:23:\"entity_search_api_index\";}s:29:\"views_entity_search_api_index\";a:1:{s:10:\"left_table\";s:29:\"views_entity_search_api_index\";}}s:11:\"entity type\";s:16:\"search_api_index\";s:5:\"group\";s:12:\"Search index\";}}s:22:\"entity_search_api_page\";a:8:{s:5:\"table\";a:2:{s:5:\"group\";s:11:\"Search page\";s:11:\"entity type\";s:15:\"search_api_page\";}s:2:\"id\";a:3:{s:5:\"title\";s:2:\"ID\";s:4:\"help\";s:41:\"The primary identifier for a search page.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:8:\"index_id\";a:3:{s:5:\"title\";s:8:\"Index ID\";s:4:\"help\";s:52:\"The machine name of the index this search page uses.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:5:\"token\";}}s:5:\"index\";a:4:{s:5:\"title\";s:5:\"Index\";s:4:\"help\";s:32:\"The index this search page uses.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:16:\"search_api_index\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:23:\"entity_search_api_index\";s:10:\"base field\";s:2:\"id\";s:18:\"relationship field\";s:5:\"index\";s:5:\"label\";s:5:\"Index\";}}s:4:\"name\";a:3:{s:5:\"title\";s:4:\"Name\";s:4:\"help\";s:37:\"The displayed name for a search page.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:12:\"machine_name\";a:3:{s:5:\"title\";s:12:\"Machine name\";s:4:\"help\";s:51:\"The internally used machine name for a search page.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:5:\"token\";}}s:11:\"description\";a:3:{s:5:\"title\";s:11:\"Description\";s:4:\"help\";s:44:\"The displayed description for a search page.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:7:\"enabled\";a:3:{s:5:\"title\";s:7:\"Enabled\";s:4:\"help\";s:53:\"A flag indicating whether the search page is enabled.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_boolean\";s:4:\"type\";s:7:\"boolean\";}}}s:28:\"views_entity_search_api_page\";a:2:{s:15:\"rendered_entity\";a:3:{s:5:\"title\";s:20:\"Rendered Search page\";s:4:\"help\";s:71:\"The Search page of the current relationship rendered using a view mode.\";s:5:\"field\";a:3:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:15:\"search_api_page\";s:10:\"real field\";s:13:\"entity object\";}}s:5:\"table\";a:3:{s:4:\"join\";a:3:{s:15:\"search_api_page\";a:1:{s:10:\"left_table\";s:15:\"search_api_page\";}s:22:\"entity_search_api_page\";a:1:{s:10:\"left_table\";s:22:\"entity_search_api_page\";}s:28:\"views_entity_search_api_page\";a:1:{s:10:\"left_table\";s:28:\"views_entity_search_api_page\";}}s:11:\"entity type\";s:15:\"search_api_page\";s:5:\"group\";s:11:\"Search page\";}}s:11:\"entity_file\";a:8:{s:5:\"table\";a:2:{s:5:\"group\";s:4:\"File\";s:11:\"entity type\";s:4:\"file\";}s:3:\"fid\";a:3:{s:5:\"title\";s:7:\"File ID\";s:4:\"help\";s:35:\"The unique ID of the uploaded file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:4:\"name\";a:3:{s:5:\"title\";s:9:\"File name\";s:4:\"help\";s:29:\"The name of the file on disk.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:4:\"mime\";a:3:{s:5:\"title\";s:9:\"MIME type\";s:4:\"help\";s:26:\"The MIME type of the file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:4:\"size\";a:3:{s:5:\"title\";s:9:\"File size\";s:4:\"help\";s:35:\"The size of the file, in kilobytes.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:3:\"url\";a:3:{s:5:\"title\";s:3:\"URL\";s:4:\"help\";s:36:\"The web-accessible URL for the file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:9:\"timestamp\";a:3:{s:5:\"title\";s:9:\"Timestamp\";s:4:\"help\";s:44:\"The date the file was most recently changed.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_date\";s:4:\"type\";s:4:\"date\";}}s:5:\"owner\";a:4:{s:5:\"title\";s:5:\"Owner\";s:4:\"help\";s:42:\"The user who originally uploaded the file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"user\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_user\";s:10:\"base field\";s:3:\"uid\";s:18:\"relationship field\";s:5:\"owner\";s:5:\"label\";s:5:\"Owner\";}}}s:17:\"views_entity_file\";a:1:{s:5:\"table\";a:3:{s:4:\"join\";a:3:{s:12:\"file_managed\";a:1:{s:10:\"left_table\";s:12:\"file_managed\";}s:11:\"entity_file\";a:1:{s:10:\"left_table\";s:11:\"entity_file\";}s:17:\"views_entity_file\";a:1:{s:10:\"left_table\";s:17:\"views_entity_file\";}}s:11:\"entity type\";s:4:\"file\";s:5:\"group\";s:4:\"File\";}}s:20:\"entity_taxonomy_term\";a:10:{s:5:\"table\";a:2:{s:5:\"group\";s:13:\"Taxonomy term\";s:11:\"entity type\";s:13:\"taxonomy_term\";}s:3:\"tid\";a:3:{s:5:\"title\";s:7:\"Term ID\";s:4:\"help\";s:35:\"The unique ID of the taxonomy term.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:4:\"name\";a:3:{s:5:\"title\";s:4:\"Name\";s:4:\"help\";s:30:\"The name of the taxonomy term.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:11:\"description\";a:3:{s:5:\"title\";s:11:\"Description\";s:4:\"help\";s:46:\"The optional description of the taxonomy term.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:6:\"weight\";a:3:{s:5:\"title\";s:6:\"Weight\";s:4:\"help\";s:72:\"The weight of the term, which is used for ordering terms during display.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:10:\"node_count\";a:3:{s:5:\"title\";s:10:\"Node count\";s:4:\"help\";s:50:\"The number of nodes tagged with the taxonomy term.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:3:\"url\";a:3:{s:5:\"title\";s:3:\"URL\";s:4:\"help\";s:29:\"The URL of the taxonomy term.\";s:5:\"field\";a:2:{s:7:\"handler\";s:30:\"entity_views_handler_field_uri\";s:4:\"type\";s:3:\"uri\";}}s:10:\"vocabulary\";a:4:{s:5:\"title\";s:10:\"Vocabulary\";s:4:\"help\";s:44:\"The vocabulary the taxonomy term belongs to.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:19:\"taxonomy_vocabulary\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:26:\"entity_taxonomy_vocabulary\";s:10:\"base field\";s:3:\"vid\";s:18:\"relationship field\";s:10:\"vocabulary\";s:5:\"label\";s:10:\"Vocabulary\";}}s:6:\"parent\";a:4:{s:5:\"title\";s:12:\"Parent terms\";s:4:\"help\";s:38:\"The parent terms of the taxonomy term.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:19:\"list<taxonomy_term>\";}s:12:\"relationship\";a:6:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:20:\"entity_taxonomy_term\";s:10:\"base field\";s:3:\"tid\";s:18:\"relationship field\";s:6:\"parent\";s:5:\"label\";s:12:\"Parent terms\";s:8:\"multiple\";b:1;}}s:11:\"parents_all\";a:4:{s:5:\"title\";s:16:\"All parent terms\";s:4:\"help\";s:65:\"Ancestors of the term, i.e. parent of all above hierarchy levels.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:19:\"list<taxonomy_term>\";}s:12:\"relationship\";a:6:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:20:\"entity_taxonomy_term\";s:10:\"base field\";s:3:\"tid\";s:18:\"relationship field\";s:11:\"parents_all\";s:5:\"label\";s:16:\"All parent terms\";s:8:\"multiple\";b:1;}}}s:26:\"views_entity_taxonomy_term\";a:2:{s:15:\"rendered_entity\";a:3:{s:5:\"title\";s:22:\"Rendered Taxonomy term\";s:4:\"help\";s:73:\"The Taxonomy term of the current relationship rendered using a view mode.\";s:5:\"field\";a:3:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:13:\"taxonomy_term\";s:10:\"real field\";s:13:\"entity object\";}}s:5:\"table\";a:3:{s:4:\"join\";a:3:{s:18:\"taxonomy_term_data\";a:1:{s:10:\"left_table\";s:18:\"taxonomy_term_data\";}s:20:\"entity_taxonomy_term\";a:1:{s:10:\"left_table\";s:20:\"entity_taxonomy_term\";}s:26:\"views_entity_taxonomy_term\";a:1:{s:10:\"left_table\";s:26:\"views_entity_taxonomy_term\";}}s:11:\"entity type\";s:13:\"taxonomy_term\";s:5:\"group\";s:13:\"Taxonomy term\";}}s:26:\"entity_taxonomy_vocabulary\";a:6:{s:5:\"table\";a:2:{s:5:\"group\";s:19:\"Taxonomy vocabulary\";s:11:\"entity type\";s:19:\"taxonomy_vocabulary\";}s:3:\"vid\";a:3:{s:5:\"title\";s:13:\"Vocabulary ID\";s:4:\"help\";s:41:\"The unique ID of the taxonomy vocabulary.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:4:\"name\";a:3:{s:5:\"title\";s:4:\"Name\";s:4:\"help\";s:36:\"The name of the taxonomy vocabulary.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:12:\"machine_name\";a:3:{s:5:\"title\";s:12:\"Machine name\";s:4:\"help\";s:44:\"The machine name of the taxonomy vocabulary.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:5:\"token\";}}s:11:\"description\";a:3:{s:5:\"title\";s:11:\"Description\";s:4:\"help\";s:52:\"The optional description of the taxonomy vocabulary.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:10:\"term_count\";a:3:{s:5:\"title\";s:10:\"Term count\";s:4:\"help\";s:57:\"The number of terms belonging to the taxonomy vocabulary.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}}s:32:\"views_entity_taxonomy_vocabulary\";a:1:{s:5:\"table\";a:3:{s:4:\"join\";a:2:{s:26:\"entity_taxonomy_vocabulary\";a:1:{s:10:\"left_table\";s:26:\"entity_taxonomy_vocabulary\";}s:32:\"views_entity_taxonomy_vocabulary\";a:1:{s:10:\"left_table\";s:32:\"views_entity_taxonomy_vocabulary\";}}s:11:\"entity type\";s:19:\"taxonomy_vocabulary\";s:5:\"group\";s:19:\"Taxonomy vocabulary\";}}s:11:\"entity_user\";a:12:{s:5:\"table\";a:2:{s:5:\"group\";s:4:\"User\";s:11:\"entity type\";s:4:\"user\";}s:3:\"uid\";a:3:{s:5:\"title\";s:7:\"User ID\";s:4:\"help\";s:34:\"The unique ID of the user account.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:4:\"name\";a:3:{s:5:\"title\";s:4:\"Name\";s:4:\"help\";s:35:\"The login name of the user account.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:4:\"mail\";a:3:{s:5:\"title\";s:5:\"Email\";s:4:\"help\";s:38:\"The email address of the user account.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:3:\"url\";a:3:{s:5:\"title\";s:3:\"URL\";s:4:\"help\";s:36:\"The URL of the account profile page.\";s:5:\"field\";a:2:{s:7:\"handler\";s:30:\"entity_views_handler_field_uri\";s:4:\"type\";s:3:\"uri\";}}s:8:\"edit_url\";a:3:{s:5:\"title\";s:8:\"Edit URL\";s:4:\"help\";s:33:\"The url of the account edit page.\";s:5:\"field\";a:2:{s:7:\"handler\";s:30:\"entity_views_handler_field_uri\";s:4:\"type\";s:3:\"uri\";}}s:11:\"last_access\";a:3:{s:5:\"title\";s:11:\"Last access\";s:4:\"help\";s:41:\"The date the user last accessed the site.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_date\";s:4:\"type\";s:4:\"date\";}}s:10:\"last_login\";a:3:{s:5:\"title\";s:10:\"Last login\";s:4:\"help\";s:45:\"The date the user last logged in to the site.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_date\";s:4:\"type\";s:4:\"date\";}}s:7:\"created\";a:3:{s:5:\"title\";s:7:\"Created\";s:4:\"help\";s:38:\"The date the user account was created.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_date\";s:4:\"type\";s:4:\"date\";}}s:5:\"roles\";a:3:{s:5:\"title\";s:10:\"User roles\";s:4:\"help\";s:22:\"The roles of the user.\";s:5:\"field\";a:3:{s:7:\"handler\";s:34:\"entity_views_handler_field_options\";s:4:\"type\";s:13:\"list<integer>\";s:16:\"options callback\";a:2:{s:8:\"function\";s:26:\"entity_metadata_user_roles\";s:4:\"info\";a:8:{s:5:\"label\";s:10:\"User roles\";s:11:\"description\";s:22:\"The roles of the user.\";s:4:\"type\";s:13:\"list<integer>\";s:15:\"getter callback\";s:35:\"entity_metadata_user_get_properties\";s:15:\"setter callback\";s:35:\"entity_metadata_user_set_properties\";s:17:\"setter permission\";s:16:\"administer users\";s:12:\"options list\";s:26:\"entity_metadata_user_roles\";s:15:\"access callback\";s:38:\"entity_metadata_user_properties_access\";}}}}s:6:\"status\";a:3:{s:5:\"title\";s:6:\"Status\";s:4:\"help\";s:38:\"Whether the user is active or blocked.\";s:5:\"field\";a:3:{s:7:\"handler\";s:34:\"entity_views_handler_field_options\";s:4:\"type\";s:7:\"integer\";s:16:\"options callback\";a:2:{s:8:\"function\";s:40:\"entity_metadata_user_status_options_list\";s:4:\"info\";a:8:{s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:38:\"Whether the user is active or blocked.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:4:\"type\";s:7:\"integer\";s:12:\"options list\";s:40:\"entity_metadata_user_status_options_list\";s:17:\"setter permission\";s:16:\"administer users\";s:12:\"schema field\";s:6:\"status\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}}}s:5:\"theme\";a:3:{s:5:\"title\";s:13:\"Default theme\";s:4:\"help\";s:25:\"The user\'s default theme.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}}s:17:\"views_entity_user\";a:2:{s:15:\"rendered_entity\";a:3:{s:5:\"title\";s:13:\"Rendered User\";s:4:\"help\";s:64:\"The User of the current relationship rendered using a view mode.\";s:5:\"field\";a:3:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"user\";s:10:\"real field\";s:13:\"entity object\";}}s:5:\"table\";a:3:{s:4:\"join\";a:3:{s:5:\"users\";a:1:{s:10:\"left_table\";s:5:\"users\";}s:11:\"entity_user\";a:1:{s:10:\"left_table\";s:11:\"entity_user\";}s:17:\"views_entity_user\";a:1:{s:10:\"left_table\";s:17:\"views_entity_user\";}}s:11:\"entity type\";s:4:\"user\";s:5:\"group\";s:4:\"User\";}}s:14:\"entity__global\";a:2:{s:5:\"table\";a:2:{s:5:\"group\";s:6:\"Entity\";s:4:\"join\";a:1:{s:7:\"#global\";a:0:{}}}s:6:\"entity\";a:3:{s:5:\"title\";s:15:\"Rendered entity\";s:4:\"help\";s:32:\"Displays a single chosen entity.\";s:4:\"area\";a:1:{s:7:\"handler\";s:32:\"entity_views_handler_area_entity\";}}}s:34:\"field_data_field_vdisk_hit_rate_pc\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:34:\"field_data_field_vdisk_hit_rate_pc\";i:1;s:23:\"field_vdisk_hit_rate_pc\";}}}s:23:\"field_vdisk_hit_rate_pc\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"Hit Rate %\";s:11:\"title short\";s:10:\"Hit Rate %\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:34:\"field_data_field_vdisk_hit_rate_pc\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:23:\"field_vdisk_hit_rate_pc\";s:10:\"real field\";s:29:\"field_vdisk_hit_rate_pc_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:29:\"field_vdisk_hit_rate_pc_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:29:\"field_vdisk_hit_rate_pc_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:36:\"Hit Rate % (field_vdisk_hit_rate_pc)\";s:11:\"title short\";s:10:\"Hit Rate %\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_vdisk_hit_rate_pc_value\";s:5:\"table\";s:34:\"field_data_field_vdisk_hit_rate_pc\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:1:{i:0;s:29:\"field_vdisk_hit_rate_pc_value\";}s:10:\"field_name\";s:23:\"field_vdisk_hit_rate_pc\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_vdisk_hit_rate_pc_value\";s:5:\"table\";s:34:\"field_data_field_vdisk_hit_rate_pc\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:1:{i:0;s:29:\"field_vdisk_hit_rate_pc_value\";}s:10:\"field_name\";s:23:\"field_vdisk_hit_rate_pc\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_vdisk_hit_rate_pc_value\";s:5:\"table\";s:34:\"field_data_field_vdisk_hit_rate_pc\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:29:\"field_vdisk_hit_rate_pc_value\";}s:10:\"field_name\";s:23:\"field_vdisk_hit_rate_pc\";}}}s:38:\"field_revision_field_vdisk_hit_rate_pc\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:38:\"field_revision_field_vdisk_hit_rate_pc\";i:1;s:35:\"field_vdisk_hit_rate_pc-revision_id\";}}}s:35:\"field_vdisk_hit_rate_pc-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:10:\"Hit Rate %\";s:11:\"title short\";s:10:\"Hit Rate %\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:38:\"field_revision_field_vdisk_hit_rate_pc\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:23:\"field_vdisk_hit_rate_pc\";s:10:\"real field\";s:41:\"field_vdisk_hit_rate_pc-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:29:\"field_vdisk_hit_rate_pc_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:29:\"field_vdisk_hit_rate_pc_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:36:\"Hit Rate % (field_vdisk_hit_rate_pc)\";s:11:\"title short\";s:10:\"Hit Rate %\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_vdisk_hit_rate_pc_value\";s:5:\"table\";s:38:\"field_revision_field_vdisk_hit_rate_pc\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:1:{i:0;s:29:\"field_vdisk_hit_rate_pc_value\";}s:10:\"field_name\";s:23:\"field_vdisk_hit_rate_pc\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_vdisk_hit_rate_pc_value\";s:5:\"table\";s:38:\"field_revision_field_vdisk_hit_rate_pc\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:1:{i:0;s:29:\"field_vdisk_hit_rate_pc_value\";}s:10:\"field_name\";s:23:\"field_vdisk_hit_rate_pc\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_vdisk_hit_rate_pc_value\";s:5:\"table\";s:38:\"field_revision_field_vdisk_hit_rate_pc\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:29:\"field_vdisk_hit_rate_pc_value\";}s:10:\"field_name\";s:23:\"field_vdisk_hit_rate_pc\";}}}s:19:\"field_data_field_ha\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:19:\"field_data_field_ha\";i:1;s:8:\"field_ha\";}}}s:8:\"field_ha\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:2:\"HA\";s:11:\"title short\";s:2:\"HA\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:19:\"field_data_field_ha\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:8:\"field_ha\";s:10:\"real field\";s:14:\"field_ha_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:14:\"field_ha_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:14:\"field_ha_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:13:\"HA (field_ha)\";s:11:\"title short\";s:2:\"HA\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:14:\"field_ha_value\";s:5:\"table\";s:19:\"field_data_field_ha\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_ha_value\";}s:10:\"field_name\";s:8:\"field_ha\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:14:\"field_ha_value\";s:5:\"table\";s:19:\"field_data_field_ha\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_ha_value\";}s:10:\"field_name\";s:8:\"field_ha\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:14:\"field_ha_value\";s:5:\"table\";s:19:\"field_data_field_ha\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_ha_value\";}s:10:\"field_name\";s:8:\"field_ha\";}}}s:23:\"field_revision_field_ha\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:23:\"field_revision_field_ha\";i:1;s:20:\"field_ha-revision_id\";}}}s:20:\"field_ha-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:2:\"HA\";s:11:\"title short\";s:2:\"HA\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:23:\"field_revision_field_ha\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:8:\"field_ha\";s:10:\"real field\";s:26:\"field_ha-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:14:\"field_ha_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:14:\"field_ha_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:13:\"HA (field_ha)\";s:11:\"title short\";s:2:\"HA\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:14:\"field_ha_value\";s:5:\"table\";s:23:\"field_revision_field_ha\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_ha_value\";}s:10:\"field_name\";s:8:\"field_ha\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:14:\"field_ha_value\";s:5:\"table\";s:23:\"field_revision_field_ha\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_ha_value\";}s:10:\"field_name\";s:8:\"field_ha\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:14:\"field_ha_value\";s:5:\"table\";s:23:\"field_revision_field_ha\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_ha_value\";}s:10:\"field_name\";s:8:\"field_ha\";}}}s:20:\"field_data_field_drs\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:20:\"field_data_field_drs\";i:1;s:9:\"field_drs\";}}}s:9:\"field_drs\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:3:\"drs\";s:11:\"title short\";s:3:\"drs\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:20:\"field_data_field_drs\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:9:\"field_drs\";s:10:\"real field\";s:15:\"field_drs_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:15:\"field_drs_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:15:\"field_drs_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:15:\"drs (field_drs)\";s:11:\"title short\";s:3:\"drs\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:15:\"field_drs_value\";s:5:\"table\";s:20:\"field_data_field_drs\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:15:\"field_drs_value\";}s:10:\"field_name\";s:9:\"field_drs\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:15:\"field_drs_value\";s:5:\"table\";s:20:\"field_data_field_drs\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:15:\"field_drs_value\";}s:10:\"field_name\";s:9:\"field_drs\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:15:\"field_drs_value\";s:5:\"table\";s:20:\"field_data_field_drs\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:15:\"field_drs_value\";}s:10:\"field_name\";s:9:\"field_drs\";}}}s:24:\"field_revision_field_drs\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:24:\"field_revision_field_drs\";i:1;s:21:\"field_drs-revision_id\";}}}s:21:\"field_drs-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:3:\"drs\";s:11:\"title short\";s:3:\"drs\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:24:\"field_revision_field_drs\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:9:\"field_drs\";s:10:\"real field\";s:27:\"field_drs-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:15:\"field_drs_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:15:\"field_drs_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:15:\"drs (field_drs)\";s:11:\"title short\";s:3:\"drs\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:15:\"field_drs_value\";s:5:\"table\";s:24:\"field_revision_field_drs\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:15:\"field_drs_value\";}s:10:\"field_name\";s:9:\"field_drs\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:15:\"field_drs_value\";s:5:\"table\";s:24:\"field_revision_field_drs\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:15:\"field_drs_value\";}s:10:\"field_name\";s:9:\"field_drs\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:15:\"field_drs_value\";s:5:\"table\";s:24:\"field_revision_field_drs\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:15:\"field_drs_value\";}s:10:\"field_name\";s:9:\"field_drs\";}}}s:36:\"field_data_field_vm_vmotion_hostlist\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:36:\"field_data_field_vm_vmotion_hostlist\";i:1;s:25:\"field_vm_vmotion_hostlist\";}}}s:25:\"field_vm_vmotion_hostlist\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:19:\"VM vMotion Hostlist\";s:11:\"title short\";s:19:\"VM vMotion Hostlist\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:36:\"field_data_field_vm_vmotion_hostlist\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:25:\"field_vm_vmotion_hostlist\";s:10:\"real field\";s:31:\"field_vm_vmotion_hostlist_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:31:\"field_vm_vmotion_hostlist_value\";i:4;s:32:\"field_vm_vmotion_hostlist_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:31:\"field_vm_vmotion_hostlist_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:47:\"VM vMotion Hostlist (field_vm_vmotion_hostlist)\";s:11:\"title short\";s:19:\"VM vMotion Hostlist\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:31:\"field_vm_vmotion_hostlist_value\";s:5:\"table\";s:36:\"field_data_field_vm_vmotion_hostlist\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:31:\"field_vm_vmotion_hostlist_value\";i:1;s:32:\"field_vm_vmotion_hostlist_format\";}s:10:\"field_name\";s:25:\"field_vm_vmotion_hostlist\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:31:\"field_vm_vmotion_hostlist_value\";s:5:\"table\";s:36:\"field_data_field_vm_vmotion_hostlist\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:31:\"field_vm_vmotion_hostlist_value\";i:1;s:32:\"field_vm_vmotion_hostlist_format\";}s:10:\"field_name\";s:25:\"field_vm_vmotion_hostlist\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:31:\"field_vm_vmotion_hostlist_value\";s:5:\"table\";s:36:\"field_data_field_vm_vmotion_hostlist\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:31:\"field_vm_vmotion_hostlist_value\";i:1;s:32:\"field_vm_vmotion_hostlist_format\";}s:10:\"field_name\";s:25:\"field_vm_vmotion_hostlist\";}}s:32:\"field_vm_vmotion_hostlist_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:54:\"VM vMotion Hostlist (field_vm_vmotion_hostlist:format)\";s:11:\"title short\";s:26:\"VM vMotion Hostlist:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:32:\"field_vm_vmotion_hostlist_format\";s:5:\"table\";s:36:\"field_data_field_vm_vmotion_hostlist\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:31:\"field_vm_vmotion_hostlist_value\";i:1;s:32:\"field_vm_vmotion_hostlist_format\";}s:10:\"field_name\";s:25:\"field_vm_vmotion_hostlist\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:32:\"field_vm_vmotion_hostlist_format\";s:5:\"table\";s:36:\"field_data_field_vm_vmotion_hostlist\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:31:\"field_vm_vmotion_hostlist_value\";i:1;s:32:\"field_vm_vmotion_hostlist_format\";}s:10:\"field_name\";s:25:\"field_vm_vmotion_hostlist\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:32:\"field_vm_vmotion_hostlist_format\";s:5:\"table\";s:36:\"field_data_field_vm_vmotion_hostlist\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:31:\"field_vm_vmotion_hostlist_value\";i:1;s:32:\"field_vm_vmotion_hostlist_format\";}s:10:\"field_name\";s:25:\"field_vm_vmotion_hostlist\";}}}s:40:\"field_revision_field_vm_vmotion_hostlist\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:40:\"field_revision_field_vm_vmotion_hostlist\";i:1;s:37:\"field_vm_vmotion_hostlist-revision_id\";}}}s:37:\"field_vm_vmotion_hostlist-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:19:\"VM vMotion Hostlist\";s:11:\"title short\";s:19:\"VM vMotion Hostlist\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:40:\"field_revision_field_vm_vmotion_hostlist\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:25:\"field_vm_vmotion_hostlist\";s:10:\"real field\";s:43:\"field_vm_vmotion_hostlist-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:31:\"field_vm_vmotion_hostlist_value\";i:4;s:32:\"field_vm_vmotion_hostlist_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:31:\"field_vm_vmotion_hostlist_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:47:\"VM vMotion Hostlist (field_vm_vmotion_hostlist)\";s:11:\"title short\";s:19:\"VM vMotion Hostlist\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:31:\"field_vm_vmotion_hostlist_value\";s:5:\"table\";s:40:\"field_revision_field_vm_vmotion_hostlist\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:31:\"field_vm_vmotion_hostlist_value\";i:1;s:32:\"field_vm_vmotion_hostlist_format\";}s:10:\"field_name\";s:25:\"field_vm_vmotion_hostlist\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:31:\"field_vm_vmotion_hostlist_value\";s:5:\"table\";s:40:\"field_revision_field_vm_vmotion_hostlist\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:31:\"field_vm_vmotion_hostlist_value\";i:1;s:32:\"field_vm_vmotion_hostlist_format\";}s:10:\"field_name\";s:25:\"field_vm_vmotion_hostlist\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:31:\"field_vm_vmotion_hostlist_value\";s:5:\"table\";s:40:\"field_revision_field_vm_vmotion_hostlist\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:31:\"field_vm_vmotion_hostlist_value\";i:1;s:32:\"field_vm_vmotion_hostlist_format\";}s:10:\"field_name\";s:25:\"field_vm_vmotion_hostlist\";}}s:32:\"field_vm_vmotion_hostlist_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:54:\"VM vMotion Hostlist (field_vm_vmotion_hostlist:format)\";s:11:\"title short\";s:26:\"VM vMotion Hostlist:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:32:\"field_vm_vmotion_hostlist_format\";s:5:\"table\";s:40:\"field_revision_field_vm_vmotion_hostlist\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:31:\"field_vm_vmotion_hostlist_value\";i:1;s:32:\"field_vm_vmotion_hostlist_format\";}s:10:\"field_name\";s:25:\"field_vm_vmotion_hostlist\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:32:\"field_vm_vmotion_hostlist_format\";s:5:\"table\";s:40:\"field_revision_field_vm_vmotion_hostlist\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:31:\"field_vm_vmotion_hostlist_value\";i:1;s:32:\"field_vm_vmotion_hostlist_format\";}s:10:\"field_name\";s:25:\"field_vm_vmotion_hostlist\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:32:\"field_vm_vmotion_hostlist_format\";s:5:\"table\";s:40:\"field_revision_field_vm_vmotion_hostlist\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:31:\"field_vm_vmotion_hostlist_value\";i:1;s:32:\"field_vm_vmotion_hostlist_format\";}s:10:\"field_name\";s:25:\"field_vm_vmotion_hostlist\";}}}s:34:\"field_data_field_vm_vmotion_policy\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:34:\"field_data_field_vm_vmotion_policy\";i:1;s:23:\"field_vm_vmotion_policy\";}}}s:23:\"field_vm_vmotion_policy\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:17:\"VM vMotion Policy\";s:11:\"title short\";s:17:\"VM vMotion Policy\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:34:\"field_data_field_vm_vmotion_policy\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:23:\"field_vm_vmotion_policy\";s:10:\"real field\";s:29:\"field_vm_vmotion_policy_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:29:\"field_vm_vmotion_policy_value\";i:4;s:30:\"field_vm_vmotion_policy_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:29:\"field_vm_vmotion_policy_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:43:\"VM vMotion Policy (field_vm_vmotion_policy)\";s:11:\"title short\";s:17:\"VM vMotion Policy\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_vm_vmotion_policy_value\";s:5:\"table\";s:34:\"field_data_field_vm_vmotion_policy\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_vm_vmotion_policy_value\";i:1;s:30:\"field_vm_vmotion_policy_format\";}s:10:\"field_name\";s:23:\"field_vm_vmotion_policy\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_vm_vmotion_policy_value\";s:5:\"table\";s:34:\"field_data_field_vm_vmotion_policy\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_vm_vmotion_policy_value\";i:1;s:30:\"field_vm_vmotion_policy_format\";}s:10:\"field_name\";s:23:\"field_vm_vmotion_policy\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_vm_vmotion_policy_value\";s:5:\"table\";s:34:\"field_data_field_vm_vmotion_policy\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_vm_vmotion_policy_value\";i:1;s:30:\"field_vm_vmotion_policy_format\";}s:10:\"field_name\";s:23:\"field_vm_vmotion_policy\";}}s:30:\"field_vm_vmotion_policy_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:50:\"VM vMotion Policy (field_vm_vmotion_policy:format)\";s:11:\"title short\";s:24:\"VM vMotion Policy:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:30:\"field_vm_vmotion_policy_format\";s:5:\"table\";s:34:\"field_data_field_vm_vmotion_policy\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_vm_vmotion_policy_value\";i:1;s:30:\"field_vm_vmotion_policy_format\";}s:10:\"field_name\";s:23:\"field_vm_vmotion_policy\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:30:\"field_vm_vmotion_policy_format\";s:5:\"table\";s:34:\"field_data_field_vm_vmotion_policy\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_vm_vmotion_policy_value\";i:1;s:30:\"field_vm_vmotion_policy_format\";}s:10:\"field_name\";s:23:\"field_vm_vmotion_policy\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:30:\"field_vm_vmotion_policy_format\";s:5:\"table\";s:34:\"field_data_field_vm_vmotion_policy\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_vm_vmotion_policy_value\";i:1;s:30:\"field_vm_vmotion_policy_format\";}s:10:\"field_name\";s:23:\"field_vm_vmotion_policy\";}}}s:38:\"field_revision_field_vm_vmotion_policy\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:38:\"field_revision_field_vm_vmotion_policy\";i:1;s:35:\"field_vm_vmotion_policy-revision_id\";}}}s:35:\"field_vm_vmotion_policy-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:17:\"VM vMotion Policy\";s:11:\"title short\";s:17:\"VM vMotion Policy\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:38:\"field_revision_field_vm_vmotion_policy\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:23:\"field_vm_vmotion_policy\";s:10:\"real field\";s:41:\"field_vm_vmotion_policy-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:29:\"field_vm_vmotion_policy_value\";i:4;s:30:\"field_vm_vmotion_policy_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:29:\"field_vm_vmotion_policy_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:43:\"VM vMotion Policy (field_vm_vmotion_policy)\";s:11:\"title short\";s:17:\"VM vMotion Policy\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_vm_vmotion_policy_value\";s:5:\"table\";s:38:\"field_revision_field_vm_vmotion_policy\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_vm_vmotion_policy_value\";i:1;s:30:\"field_vm_vmotion_policy_format\";}s:10:\"field_name\";s:23:\"field_vm_vmotion_policy\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_vm_vmotion_policy_value\";s:5:\"table\";s:38:\"field_revision_field_vm_vmotion_policy\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_vm_vmotion_policy_value\";i:1;s:30:\"field_vm_vmotion_policy_format\";}s:10:\"field_name\";s:23:\"field_vm_vmotion_policy\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_vm_vmotion_policy_value\";s:5:\"table\";s:38:\"field_revision_field_vm_vmotion_policy\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_vm_vmotion_policy_value\";i:1;s:30:\"field_vm_vmotion_policy_format\";}s:10:\"field_name\";s:23:\"field_vm_vmotion_policy\";}}s:30:\"field_vm_vmotion_policy_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:50:\"VM vMotion Policy (field_vm_vmotion_policy:format)\";s:11:\"title short\";s:24:\"VM vMotion Policy:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:30:\"field_vm_vmotion_policy_format\";s:5:\"table\";s:38:\"field_revision_field_vm_vmotion_policy\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_vm_vmotion_policy_value\";i:1;s:30:\"field_vm_vmotion_policy_format\";}s:10:\"field_name\";s:23:\"field_vm_vmotion_policy\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:30:\"field_vm_vmotion_policy_format\";s:5:\"table\";s:38:\"field_revision_field_vm_vmotion_policy\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_vm_vmotion_policy_value\";i:1;s:30:\"field_vm_vmotion_policy_format\";}s:10:\"field_name\";s:23:\"field_vm_vmotion_policy\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:30:\"field_vm_vmotion_policy_format\";s:5:\"table\";s:38:\"field_revision_field_vm_vmotion_policy\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_vm_vmotion_policy_value\";i:1;s:30:\"field_vm_vmotion_policy_format\";}s:10:\"field_name\";s:23:\"field_vm_vmotion_policy\";}}}s:31:\"field_data_field_vm_hit_rate_pc\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:31:\"field_data_field_vm_hit_rate_pc\";i:1;s:20:\"field_vm_hit_rate_pc\";}}}s:20:\"field_vm_hit_rate_pc\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"Hit Rate %\";s:11:\"title short\";s:10:\"Hit Rate %\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:31:\"field_data_field_vm_hit_rate_pc\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:20:\"field_vm_hit_rate_pc\";s:10:\"real field\";s:26:\"field_vm_hit_rate_pc_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:26:\"field_vm_hit_rate_pc_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:26:\"field_vm_hit_rate_pc_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:33:\"Hit Rate % (field_vm_hit_rate_pc)\";s:11:\"title short\";s:10:\"Hit Rate %\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_vm_hit_rate_pc_value\";s:5:\"table\";s:31:\"field_data_field_vm_hit_rate_pc\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vm_hit_rate_pc_value\";}s:10:\"field_name\";s:20:\"field_vm_hit_rate_pc\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_vm_hit_rate_pc_value\";s:5:\"table\";s:31:\"field_data_field_vm_hit_rate_pc\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vm_hit_rate_pc_value\";}s:10:\"field_name\";s:20:\"field_vm_hit_rate_pc\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_vm_hit_rate_pc_value\";s:5:\"table\";s:31:\"field_data_field_vm_hit_rate_pc\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vm_hit_rate_pc_value\";}s:10:\"field_name\";s:20:\"field_vm_hit_rate_pc\";}}}s:35:\"field_revision_field_vm_hit_rate_pc\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:35:\"field_revision_field_vm_hit_rate_pc\";i:1;s:32:\"field_vm_hit_rate_pc-revision_id\";}}}s:32:\"field_vm_hit_rate_pc-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:10:\"Hit Rate %\";s:11:\"title short\";s:10:\"Hit Rate %\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:35:\"field_revision_field_vm_hit_rate_pc\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:20:\"field_vm_hit_rate_pc\";s:10:\"real field\";s:38:\"field_vm_hit_rate_pc-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:26:\"field_vm_hit_rate_pc_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:26:\"field_vm_hit_rate_pc_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:33:\"Hit Rate % (field_vm_hit_rate_pc)\";s:11:\"title short\";s:10:\"Hit Rate %\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_vm_hit_rate_pc_value\";s:5:\"table\";s:35:\"field_revision_field_vm_hit_rate_pc\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vm_hit_rate_pc_value\";}s:10:\"field_name\";s:20:\"field_vm_hit_rate_pc\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_vm_hit_rate_pc_value\";s:5:\"table\";s:35:\"field_revision_field_vm_hit_rate_pc\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vm_hit_rate_pc_value\";}s:10:\"field_name\";s:20:\"field_vm_hit_rate_pc\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_vm_hit_rate_pc_value\";s:5:\"table\";s:35:\"field_revision_field_vm_hit_rate_pc\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vm_hit_rate_pc_value\";}s:10:\"field_name\";s:20:\"field_vm_hit_rate_pc\";}}}s:25:\"field_data_field_fmc_uuid\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:25:\"field_data_field_fmc_uuid\";i:1;s:14:\"field_fmc_uuid\";}}}s:14:\"field_fmc_uuid\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:8:\"FMC UUID\";s:11:\"title short\";s:8:\"FMC UUID\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:5:\"field\";a:9:{s:5:\"table\";s:25:\"field_data_field_fmc_uuid\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_fmc_uuid\";s:10:\"real field\";s:20:\"field_fmc_uuid_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_fmc_uuid_value\";i:4;s:21:\"field_fmc_uuid_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:20:\"field_fmc_uuid_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:25:\"FMC UUID (field_fmc_uuid)\";s:11:\"title short\";s:8:\"FMC UUID\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_fmc_uuid_value\";s:5:\"table\";s:25:\"field_data_field_fmc_uuid\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_fmc_uuid_value\";i:1;s:21:\"field_fmc_uuid_format\";}s:10:\"field_name\";s:14:\"field_fmc_uuid\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_fmc_uuid_value\";s:5:\"table\";s:25:\"field_data_field_fmc_uuid\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_fmc_uuid_value\";i:1;s:21:\"field_fmc_uuid_format\";}s:10:\"field_name\";s:14:\"field_fmc_uuid\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_fmc_uuid_value\";s:5:\"table\";s:25:\"field_data_field_fmc_uuid\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_fmc_uuid_value\";i:1;s:21:\"field_fmc_uuid_format\";}s:10:\"field_name\";s:14:\"field_fmc_uuid\";}}s:21:\"field_fmc_uuid_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:32:\"FMC UUID (field_fmc_uuid:format)\";s:11:\"title short\";s:15:\"FMC UUID:format\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_fmc_uuid_format\";s:5:\"table\";s:25:\"field_data_field_fmc_uuid\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_fmc_uuid_value\";i:1;s:21:\"field_fmc_uuid_format\";}s:10:\"field_name\";s:14:\"field_fmc_uuid\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_fmc_uuid_format\";s:5:\"table\";s:25:\"field_data_field_fmc_uuid\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_fmc_uuid_value\";i:1;s:21:\"field_fmc_uuid_format\";}s:10:\"field_name\";s:14:\"field_fmc_uuid\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_fmc_uuid_format\";s:5:\"table\";s:25:\"field_data_field_fmc_uuid\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_fmc_uuid_value\";i:1;s:21:\"field_fmc_uuid_format\";}s:10:\"field_name\";s:14:\"field_fmc_uuid\";}}}s:29:\"field_revision_field_fmc_uuid\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:29:\"field_revision_field_fmc_uuid\";i:1;s:26:\"field_fmc_uuid-revision_id\";}}}s:26:\"field_fmc_uuid-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:8:\"FMC UUID\";s:11:\"title short\";s:8:\"FMC UUID\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:5:\"field\";a:9:{s:5:\"table\";s:29:\"field_revision_field_fmc_uuid\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_fmc_uuid\";s:10:\"real field\";s:32:\"field_fmc_uuid-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_fmc_uuid_value\";i:4;s:21:\"field_fmc_uuid_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:20:\"field_fmc_uuid_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:25:\"FMC UUID (field_fmc_uuid)\";s:11:\"title short\";s:8:\"FMC UUID\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_fmc_uuid_value\";s:5:\"table\";s:29:\"field_revision_field_fmc_uuid\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_fmc_uuid_value\";i:1;s:21:\"field_fmc_uuid_format\";}s:10:\"field_name\";s:14:\"field_fmc_uuid\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_fmc_uuid_value\";s:5:\"table\";s:29:\"field_revision_field_fmc_uuid\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_fmc_uuid_value\";i:1;s:21:\"field_fmc_uuid_format\";}s:10:\"field_name\";s:14:\"field_fmc_uuid\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_fmc_uuid_value\";s:5:\"table\";s:29:\"field_revision_field_fmc_uuid\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_fmc_uuid_value\";i:1;s:21:\"field_fmc_uuid_format\";}s:10:\"field_name\";s:14:\"field_fmc_uuid\";}}s:21:\"field_fmc_uuid_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:32:\"FMC UUID (field_fmc_uuid:format)\";s:11:\"title short\";s:15:\"FMC UUID:format\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_fmc_uuid_format\";s:5:\"table\";s:29:\"field_revision_field_fmc_uuid\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_fmc_uuid_value\";i:1;s:21:\"field_fmc_uuid_format\";}s:10:\"field_name\";s:14:\"field_fmc_uuid\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_fmc_uuid_format\";s:5:\"table\";s:29:\"field_revision_field_fmc_uuid\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_fmc_uuid_value\";i:1;s:21:\"field_fmc_uuid_format\";}s:10:\"field_name\";s:14:\"field_fmc_uuid\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_fmc_uuid_format\";s:5:\"table\";s:29:\"field_revision_field_fmc_uuid\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_fmc_uuid_value\";i:1;s:21:\"field_fmc_uuid_format\";}s:10:\"field_name\";s:14:\"field_fmc_uuid\";}}}s:42:\"field_data_field_fa_metrics_reset_interval\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:42:\"field_data_field_fa_metrics_reset_interval\";i:1;s:31:\"field_fa_metrics_reset_interval\";}}}s:31:\"field_fa_metrics_reset_interval\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:22:\"Metrics Reset Interval\";s:11:\"title short\";s:22:\"Metrics Reset Interval\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:42:\"field_data_field_fa_metrics_reset_interval\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:31:\"field_fa_metrics_reset_interval\";s:10:\"real field\";s:37:\"field_fa_metrics_reset_interval_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:37:\"field_fa_metrics_reset_interval_value\";i:4;s:38:\"field_fa_metrics_reset_interval_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:37:\"field_fa_metrics_reset_interval_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:56:\"Metrics Reset Interval (field_fa_metrics_reset_interval)\";s:11:\"title short\";s:22:\"Metrics Reset Interval\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:37:\"field_fa_metrics_reset_interval_value\";s:5:\"table\";s:42:\"field_data_field_fa_metrics_reset_interval\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:37:\"field_fa_metrics_reset_interval_value\";i:1;s:38:\"field_fa_metrics_reset_interval_format\";}s:10:\"field_name\";s:31:\"field_fa_metrics_reset_interval\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:37:\"field_fa_metrics_reset_interval_value\";s:5:\"table\";s:42:\"field_data_field_fa_metrics_reset_interval\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:37:\"field_fa_metrics_reset_interval_value\";i:1;s:38:\"field_fa_metrics_reset_interval_format\";}s:10:\"field_name\";s:31:\"field_fa_metrics_reset_interval\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:37:\"field_fa_metrics_reset_interval_value\";s:5:\"table\";s:42:\"field_data_field_fa_metrics_reset_interval\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:37:\"field_fa_metrics_reset_interval_value\";i:1;s:38:\"field_fa_metrics_reset_interval_format\";}s:10:\"field_name\";s:31:\"field_fa_metrics_reset_interval\";}}s:38:\"field_fa_metrics_reset_interval_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:63:\"Metrics Reset Interval (field_fa_metrics_reset_interval:format)\";s:11:\"title short\";s:29:\"Metrics Reset Interval:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:38:\"field_fa_metrics_reset_interval_format\";s:5:\"table\";s:42:\"field_data_field_fa_metrics_reset_interval\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:37:\"field_fa_metrics_reset_interval_value\";i:1;s:38:\"field_fa_metrics_reset_interval_format\";}s:10:\"field_name\";s:31:\"field_fa_metrics_reset_interval\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:38:\"field_fa_metrics_reset_interval_format\";s:5:\"table\";s:42:\"field_data_field_fa_metrics_reset_interval\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:37:\"field_fa_metrics_reset_interval_value\";i:1;s:38:\"field_fa_metrics_reset_interval_format\";}s:10:\"field_name\";s:31:\"field_fa_metrics_reset_interval\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:38:\"field_fa_metrics_reset_interval_format\";s:5:\"table\";s:42:\"field_data_field_fa_metrics_reset_interval\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:37:\"field_fa_metrics_reset_interval_value\";i:1;s:38:\"field_fa_metrics_reset_interval_format\";}s:10:\"field_name\";s:31:\"field_fa_metrics_reset_interval\";}}}s:46:\"field_revision_field_fa_metrics_reset_interval\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:46:\"field_revision_field_fa_metrics_reset_interval\";i:1;s:43:\"field_fa_metrics_reset_interval-revision_id\";}}}s:43:\"field_fa_metrics_reset_interval-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:22:\"Metrics Reset Interval\";s:11:\"title short\";s:22:\"Metrics Reset Interval\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:46:\"field_revision_field_fa_metrics_reset_interval\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:31:\"field_fa_metrics_reset_interval\";s:10:\"real field\";s:49:\"field_fa_metrics_reset_interval-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:37:\"field_fa_metrics_reset_interval_value\";i:4;s:38:\"field_fa_metrics_reset_interval_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:37:\"field_fa_metrics_reset_interval_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:56:\"Metrics Reset Interval (field_fa_metrics_reset_interval)\";s:11:\"title short\";s:22:\"Metrics Reset Interval\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:37:\"field_fa_metrics_reset_interval_value\";s:5:\"table\";s:46:\"field_revision_field_fa_metrics_reset_interval\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:37:\"field_fa_metrics_reset_interval_value\";i:1;s:38:\"field_fa_metrics_reset_interval_format\";}s:10:\"field_name\";s:31:\"field_fa_metrics_reset_interval\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:37:\"field_fa_metrics_reset_interval_value\";s:5:\"table\";s:46:\"field_revision_field_fa_metrics_reset_interval\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:37:\"field_fa_metrics_reset_interval_value\";i:1;s:38:\"field_fa_metrics_reset_interval_format\";}s:10:\"field_name\";s:31:\"field_fa_metrics_reset_interval\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:37:\"field_fa_metrics_reset_interval_value\";s:5:\"table\";s:46:\"field_revision_field_fa_metrics_reset_interval\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:37:\"field_fa_metrics_reset_interval_value\";i:1;s:38:\"field_fa_metrics_reset_interval_format\";}s:10:\"field_name\";s:31:\"field_fa_metrics_reset_interval\";}}s:38:\"field_fa_metrics_reset_interval_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:63:\"Metrics Reset Interval (field_fa_metrics_reset_interval:format)\";s:11:\"title short\";s:29:\"Metrics Reset Interval:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:38:\"field_fa_metrics_reset_interval_format\";s:5:\"table\";s:46:\"field_revision_field_fa_metrics_reset_interval\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:37:\"field_fa_metrics_reset_interval_value\";i:1;s:38:\"field_fa_metrics_reset_interval_format\";}s:10:\"field_name\";s:31:\"field_fa_metrics_reset_interval\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:38:\"field_fa_metrics_reset_interval_format\";s:5:\"table\";s:46:\"field_revision_field_fa_metrics_reset_interval\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:37:\"field_fa_metrics_reset_interval_value\";i:1;s:38:\"field_fa_metrics_reset_interval_format\";}s:10:\"field_name\";s:31:\"field_fa_metrics_reset_interval\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:38:\"field_fa_metrics_reset_interval_format\";s:5:\"table\";s:46:\"field_revision_field_fa_metrics_reset_interval\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:37:\"field_fa_metrics_reset_interval_value\";i:1;s:38:\"field_fa_metrics_reset_interval_format\";}s:10:\"field_name\";s:31:\"field_fa_metrics_reset_interval\";}}}s:28:\"field_data_field_vm_hostname\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:28:\"field_data_field_vm_hostname\";i:1;s:17:\"field_vm_hostname\";}}}s:17:\"field_vm_hostname\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:8:\"Hostname\";s:11:\"title short\";s:8:\"Hostname\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:28:\"field_data_field_vm_hostname\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_vm_hostname\";s:10:\"real field\";s:23:\"field_vm_hostname_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_vm_hostname_value\";i:4;s:24:\"field_vm_hostname_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:23:\"field_vm_hostname_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:28:\"Hostname (field_vm_hostname)\";s:11:\"title short\";s:8:\"Hostname\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_vm_hostname_value\";s:5:\"table\";s:28:\"field_data_field_vm_hostname\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_hostname_value\";i:1;s:24:\"field_vm_hostname_format\";}s:10:\"field_name\";s:17:\"field_vm_hostname\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_vm_hostname_value\";s:5:\"table\";s:28:\"field_data_field_vm_hostname\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_hostname_value\";i:1;s:24:\"field_vm_hostname_format\";}s:10:\"field_name\";s:17:\"field_vm_hostname\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_vm_hostname_value\";s:5:\"table\";s:28:\"field_data_field_vm_hostname\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_hostname_value\";i:1;s:24:\"field_vm_hostname_format\";}s:10:\"field_name\";s:17:\"field_vm_hostname\";}}s:24:\"field_vm_hostname_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:35:\"Hostname (field_vm_hostname:format)\";s:11:\"title short\";s:15:\"Hostname:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_vm_hostname_format\";s:5:\"table\";s:28:\"field_data_field_vm_hostname\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_hostname_value\";i:1;s:24:\"field_vm_hostname_format\";}s:10:\"field_name\";s:17:\"field_vm_hostname\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_vm_hostname_format\";s:5:\"table\";s:28:\"field_data_field_vm_hostname\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_hostname_value\";i:1;s:24:\"field_vm_hostname_format\";}s:10:\"field_name\";s:17:\"field_vm_hostname\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_vm_hostname_format\";s:5:\"table\";s:28:\"field_data_field_vm_hostname\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_hostname_value\";i:1;s:24:\"field_vm_hostname_format\";}s:10:\"field_name\";s:17:\"field_vm_hostname\";}}}s:32:\"field_revision_field_vm_hostname\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:32:\"field_revision_field_vm_hostname\";i:1;s:29:\"field_vm_hostname-revision_id\";}}}s:29:\"field_vm_hostname-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:8:\"Hostname\";s:11:\"title short\";s:8:\"Hostname\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:32:\"field_revision_field_vm_hostname\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_vm_hostname\";s:10:\"real field\";s:35:\"field_vm_hostname-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_vm_hostname_value\";i:4;s:24:\"field_vm_hostname_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:23:\"field_vm_hostname_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:28:\"Hostname (field_vm_hostname)\";s:11:\"title short\";s:8:\"Hostname\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_vm_hostname_value\";s:5:\"table\";s:32:\"field_revision_field_vm_hostname\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_hostname_value\";i:1;s:24:\"field_vm_hostname_format\";}s:10:\"field_name\";s:17:\"field_vm_hostname\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_vm_hostname_value\";s:5:\"table\";s:32:\"field_revision_field_vm_hostname\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_hostname_value\";i:1;s:24:\"field_vm_hostname_format\";}s:10:\"field_name\";s:17:\"field_vm_hostname\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_vm_hostname_value\";s:5:\"table\";s:32:\"field_revision_field_vm_hostname\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_hostname_value\";i:1;s:24:\"field_vm_hostname_format\";}s:10:\"field_name\";s:17:\"field_vm_hostname\";}}s:24:\"field_vm_hostname_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:35:\"Hostname (field_vm_hostname:format)\";s:11:\"title short\";s:15:\"Hostname:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_vm_hostname_format\";s:5:\"table\";s:32:\"field_revision_field_vm_hostname\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_hostname_value\";i:1;s:24:\"field_vm_hostname_format\";}s:10:\"field_name\";s:17:\"field_vm_hostname\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_vm_hostname_format\";s:5:\"table\";s:32:\"field_revision_field_vm_hostname\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_hostname_value\";i:1;s:24:\"field_vm_hostname_format\";}s:10:\"field_name\";s:17:\"field_vm_hostname\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_vm_hostname_format\";s:5:\"table\";s:32:\"field_revision_field_vm_hostname\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_hostname_value\";i:1;s:24:\"field_vm_hostname_format\";}s:10:\"field_name\";s:17:\"field_vm_hostname\";}}}s:25:\"field_data_field_hostname\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:25:\"field_data_field_hostname\";i:1;s:14:\"field_hostname\";}}}s:14:\"field_hostname\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:8:\"Hostname\";s:11:\"title short\";s:8:\"Hostname\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:5:\"field\";a:9:{s:5:\"table\";s:25:\"field_data_field_hostname\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_hostname\";s:10:\"real field\";s:20:\"field_hostname_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_hostname_value\";i:4;s:21:\"field_hostname_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:20:\"field_hostname_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:25:\"Hostname (field_hostname)\";s:11:\"title short\";s:8:\"Hostname\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_hostname_value\";s:5:\"table\";s:25:\"field_data_field_hostname\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_hostname_value\";i:1;s:21:\"field_hostname_format\";}s:10:\"field_name\";s:14:\"field_hostname\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_hostname_value\";s:5:\"table\";s:25:\"field_data_field_hostname\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_hostname_value\";i:1;s:21:\"field_hostname_format\";}s:10:\"field_name\";s:14:\"field_hostname\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_hostname_value\";s:5:\"table\";s:25:\"field_data_field_hostname\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_hostname_value\";i:1;s:21:\"field_hostname_format\";}s:10:\"field_name\";s:14:\"field_hostname\";}}s:21:\"field_hostname_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:32:\"Hostname (field_hostname:format)\";s:11:\"title short\";s:15:\"Hostname:format\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_hostname_format\";s:5:\"table\";s:25:\"field_data_field_hostname\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_hostname_value\";i:1;s:21:\"field_hostname_format\";}s:10:\"field_name\";s:14:\"field_hostname\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_hostname_format\";s:5:\"table\";s:25:\"field_data_field_hostname\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_hostname_value\";i:1;s:21:\"field_hostname_format\";}s:10:\"field_name\";s:14:\"field_hostname\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_hostname_format\";s:5:\"table\";s:25:\"field_data_field_hostname\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_hostname_value\";i:1;s:21:\"field_hostname_format\";}s:10:\"field_name\";s:14:\"field_hostname\";}}}s:29:\"field_revision_field_hostname\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:29:\"field_revision_field_hostname\";i:1;s:26:\"field_hostname-revision_id\";}}}s:26:\"field_hostname-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:8:\"Hostname\";s:11:\"title short\";s:8:\"Hostname\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:5:\"field\";a:9:{s:5:\"table\";s:29:\"field_revision_field_hostname\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_hostname\";s:10:\"real field\";s:32:\"field_hostname-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_hostname_value\";i:4;s:21:\"field_hostname_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:20:\"field_hostname_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:25:\"Hostname (field_hostname)\";s:11:\"title short\";s:8:\"Hostname\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_hostname_value\";s:5:\"table\";s:29:\"field_revision_field_hostname\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_hostname_value\";i:1;s:21:\"field_hostname_format\";}s:10:\"field_name\";s:14:\"field_hostname\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_hostname_value\";s:5:\"table\";s:29:\"field_revision_field_hostname\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_hostname_value\";i:1;s:21:\"field_hostname_format\";}s:10:\"field_name\";s:14:\"field_hostname\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_hostname_value\";s:5:\"table\";s:29:\"field_revision_field_hostname\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_hostname_value\";i:1;s:21:\"field_hostname_format\";}s:10:\"field_name\";s:14:\"field_hostname\";}}s:21:\"field_hostname_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:32:\"Hostname (field_hostname:format)\";s:11:\"title short\";s:15:\"Hostname:format\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_hostname_format\";s:5:\"table\";s:29:\"field_revision_field_hostname\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_hostname_value\";i:1;s:21:\"field_hostname_format\";}s:10:\"field_name\";s:14:\"field_hostname\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_hostname_format\";s:5:\"table\";s:29:\"field_revision_field_hostname\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_hostname_value\";i:1;s:21:\"field_hostname_format\";}s:10:\"field_name\";s:14:\"field_hostname\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_hostname_format\";s:5:\"table\";s:29:\"field_revision_field_hostname\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_hostname_value\";i:1;s:21:\"field_hostname_format\";}s:10:\"field_name\";s:14:\"field_hostname\";}}}s:34:\"field_data_field_rediscover_status\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:34:\"field_data_field_rediscover_status\";i:1;s:23:\"field_rediscover_status\";}}}s:23:\"field_rediscover_status\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:17:\"Rediscover Status\";s:11:\"title short\";s:17:\"Rediscover Status\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:5:\"field\";a:9:{s:5:\"table\";s:34:\"field_data_field_rediscover_status\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:23:\"field_rediscover_status\";s:10:\"real field\";s:29:\"field_rediscover_status_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:29:\"field_rediscover_status_value\";i:4;s:30:\"field_rediscover_status_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:29:\"field_rediscover_status_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:43:\"Rediscover Status (field_rediscover_status)\";s:11:\"title short\";s:17:\"Rediscover Status\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_rediscover_status_value\";s:5:\"table\";s:34:\"field_data_field_rediscover_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_rediscover_status_value\";i:1;s:30:\"field_rediscover_status_format\";}s:10:\"field_name\";s:23:\"field_rediscover_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_rediscover_status_value\";s:5:\"table\";s:34:\"field_data_field_rediscover_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_rediscover_status_value\";i:1;s:30:\"field_rediscover_status_format\";}s:10:\"field_name\";s:23:\"field_rediscover_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_rediscover_status_value\";s:5:\"table\";s:34:\"field_data_field_rediscover_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_rediscover_status_value\";i:1;s:30:\"field_rediscover_status_format\";}s:10:\"field_name\";s:23:\"field_rediscover_status\";}}s:30:\"field_rediscover_status_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:50:\"Rediscover Status (field_rediscover_status:format)\";s:11:\"title short\";s:24:\"Rediscover Status:format\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:30:\"field_rediscover_status_format\";s:5:\"table\";s:34:\"field_data_field_rediscover_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_rediscover_status_value\";i:1;s:30:\"field_rediscover_status_format\";}s:10:\"field_name\";s:23:\"field_rediscover_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:30:\"field_rediscover_status_format\";s:5:\"table\";s:34:\"field_data_field_rediscover_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_rediscover_status_value\";i:1;s:30:\"field_rediscover_status_format\";}s:10:\"field_name\";s:23:\"field_rediscover_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:30:\"field_rediscover_status_format\";s:5:\"table\";s:34:\"field_data_field_rediscover_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_rediscover_status_value\";i:1;s:30:\"field_rediscover_status_format\";}s:10:\"field_name\";s:23:\"field_rediscover_status\";}}}s:38:\"field_revision_field_rediscover_status\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:38:\"field_revision_field_rediscover_status\";i:1;s:35:\"field_rediscover_status-revision_id\";}}}s:35:\"field_rediscover_status-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:17:\"Rediscover Status\";s:11:\"title short\";s:17:\"Rediscover Status\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:5:\"field\";a:9:{s:5:\"table\";s:38:\"field_revision_field_rediscover_status\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:23:\"field_rediscover_status\";s:10:\"real field\";s:41:\"field_rediscover_status-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:29:\"field_rediscover_status_value\";i:4;s:30:\"field_rediscover_status_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:29:\"field_rediscover_status_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:43:\"Rediscover Status (field_rediscover_status)\";s:11:\"title short\";s:17:\"Rediscover Status\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_rediscover_status_value\";s:5:\"table\";s:38:\"field_revision_field_rediscover_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_rediscover_status_value\";i:1;s:30:\"field_rediscover_status_format\";}s:10:\"field_name\";s:23:\"field_rediscover_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_rediscover_status_value\";s:5:\"table\";s:38:\"field_revision_field_rediscover_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_rediscover_status_value\";i:1;s:30:\"field_rediscover_status_format\";}s:10:\"field_name\";s:23:\"field_rediscover_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_rediscover_status_value\";s:5:\"table\";s:38:\"field_revision_field_rediscover_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_rediscover_status_value\";i:1;s:30:\"field_rediscover_status_format\";}s:10:\"field_name\";s:23:\"field_rediscover_status\";}}s:30:\"field_rediscover_status_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:50:\"Rediscover Status (field_rediscover_status:format)\";s:11:\"title short\";s:24:\"Rediscover Status:format\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:30:\"field_rediscover_status_format\";s:5:\"table\";s:38:\"field_revision_field_rediscover_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_rediscover_status_value\";i:1;s:30:\"field_rediscover_status_format\";}s:10:\"field_name\";s:23:\"field_rediscover_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:30:\"field_rediscover_status_format\";s:5:\"table\";s:38:\"field_revision_field_rediscover_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_rediscover_status_value\";i:1;s:30:\"field_rediscover_status_format\";}s:10:\"field_name\";s:23:\"field_rediscover_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:30:\"field_rediscover_status_format\";s:5:\"table\";s:38:\"field_revision_field_rediscover_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_rediscover_status_value\";i:1;s:30:\"field_rediscover_status_format\";}s:10:\"field_name\";s:23:\"field_rediscover_status\";}}}s:31:\"field_data_field_fa_sector_size\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:31:\"field_data_field_fa_sector_size\";i:1;s:20:\"field_fa_sector_size\";}}}s:20:\"field_fa_sector_size\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:11:\"Sector Size\";s:11:\"title short\";s:11:\"Sector Size\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:31:\"field_data_field_fa_sector_size\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:20:\"field_fa_sector_size\";s:10:\"real field\";s:26:\"field_fa_sector_size_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:26:\"field_fa_sector_size_value\";i:4;s:27:\"field_fa_sector_size_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:26:\"field_fa_sector_size_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:34:\"Sector Size (field_fa_sector_size)\";s:11:\"title short\";s:11:\"Sector Size\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_fa_sector_size_value\";s:5:\"table\";s:31:\"field_data_field_fa_sector_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_fa_sector_size_value\";i:1;s:27:\"field_fa_sector_size_format\";}s:10:\"field_name\";s:20:\"field_fa_sector_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_fa_sector_size_value\";s:5:\"table\";s:31:\"field_data_field_fa_sector_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_fa_sector_size_value\";i:1;s:27:\"field_fa_sector_size_format\";}s:10:\"field_name\";s:20:\"field_fa_sector_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_fa_sector_size_value\";s:5:\"table\";s:31:\"field_data_field_fa_sector_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_fa_sector_size_value\";i:1;s:27:\"field_fa_sector_size_format\";}s:10:\"field_name\";s:20:\"field_fa_sector_size\";}}s:27:\"field_fa_sector_size_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:41:\"Sector Size (field_fa_sector_size:format)\";s:11:\"title short\";s:18:\"Sector Size:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:27:\"field_fa_sector_size_format\";s:5:\"table\";s:31:\"field_data_field_fa_sector_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_fa_sector_size_value\";i:1;s:27:\"field_fa_sector_size_format\";}s:10:\"field_name\";s:20:\"field_fa_sector_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:27:\"field_fa_sector_size_format\";s:5:\"table\";s:31:\"field_data_field_fa_sector_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_fa_sector_size_value\";i:1;s:27:\"field_fa_sector_size_format\";}s:10:\"field_name\";s:20:\"field_fa_sector_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:27:\"field_fa_sector_size_format\";s:5:\"table\";s:31:\"field_data_field_fa_sector_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_fa_sector_size_value\";i:1;s:27:\"field_fa_sector_size_format\";}s:10:\"field_name\";s:20:\"field_fa_sector_size\";}}}s:35:\"field_revision_field_fa_sector_size\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:35:\"field_revision_field_fa_sector_size\";i:1;s:32:\"field_fa_sector_size-revision_id\";}}}s:32:\"field_fa_sector_size-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:11:\"Sector Size\";s:11:\"title short\";s:11:\"Sector Size\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:35:\"field_revision_field_fa_sector_size\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:20:\"field_fa_sector_size\";s:10:\"real field\";s:38:\"field_fa_sector_size-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:26:\"field_fa_sector_size_value\";i:4;s:27:\"field_fa_sector_size_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:26:\"field_fa_sector_size_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:34:\"Sector Size (field_fa_sector_size)\";s:11:\"title short\";s:11:\"Sector Size\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_fa_sector_size_value\";s:5:\"table\";s:35:\"field_revision_field_fa_sector_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_fa_sector_size_value\";i:1;s:27:\"field_fa_sector_size_format\";}s:10:\"field_name\";s:20:\"field_fa_sector_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_fa_sector_size_value\";s:5:\"table\";s:35:\"field_revision_field_fa_sector_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_fa_sector_size_value\";i:1;s:27:\"field_fa_sector_size_format\";}s:10:\"field_name\";s:20:\"field_fa_sector_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_fa_sector_size_value\";s:5:\"table\";s:35:\"field_revision_field_fa_sector_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_fa_sector_size_value\";i:1;s:27:\"field_fa_sector_size_format\";}s:10:\"field_name\";s:20:\"field_fa_sector_size\";}}s:27:\"field_fa_sector_size_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:41:\"Sector Size (field_fa_sector_size:format)\";s:11:\"title short\";s:18:\"Sector Size:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:27:\"field_fa_sector_size_format\";s:5:\"table\";s:35:\"field_revision_field_fa_sector_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_fa_sector_size_value\";i:1;s:27:\"field_fa_sector_size_format\";}s:10:\"field_name\";s:20:\"field_fa_sector_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:27:\"field_fa_sector_size_format\";s:5:\"table\";s:35:\"field_revision_field_fa_sector_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_fa_sector_size_value\";i:1;s:27:\"field_fa_sector_size_format\";}s:10:\"field_name\";s:20:\"field_fa_sector_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:27:\"field_fa_sector_size_format\";s:5:\"table\";s:35:\"field_revision_field_fa_sector_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_fa_sector_size_value\";i:1;s:27:\"field_fa_sector_size_format\";}s:10:\"field_name\";s:20:\"field_fa_sector_size\";}}}s:24:\"field_data_field_hit_ops\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:24:\"field_data_field_hit_ops\";i:1;s:13:\"field_hit_ops\";}}}s:13:\"field_hit_ops\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:7:\"Hit Ops\";s:11:\"title short\";s:7:\"Hit Ops\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:24:\"field_data_field_hit_ops\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:13:\"field_hit_ops\";s:10:\"real field\";s:19:\"field_hit_ops_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:19:\"field_hit_ops_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:19:\"field_hit_ops_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:23:\"Hit Ops (field_hit_ops)\";s:11:\"title short\";s:7:\"Hit Ops\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:19:\"field_hit_ops_value\";s:5:\"table\";s:24:\"field_data_field_hit_ops\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:19:\"field_hit_ops_value\";}s:10:\"field_name\";s:13:\"field_hit_ops\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:19:\"field_hit_ops_value\";s:5:\"table\";s:24:\"field_data_field_hit_ops\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:19:\"field_hit_ops_value\";}s:10:\"field_name\";s:13:\"field_hit_ops\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:19:\"field_hit_ops_value\";s:5:\"table\";s:24:\"field_data_field_hit_ops\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:19:\"field_hit_ops_value\";}s:10:\"field_name\";s:13:\"field_hit_ops\";}}}s:28:\"field_revision_field_hit_ops\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:28:\"field_revision_field_hit_ops\";i:1;s:25:\"field_hit_ops-revision_id\";}}}s:25:\"field_hit_ops-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:7:\"Hit Ops\";s:11:\"title short\";s:7:\"Hit Ops\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:28:\"field_revision_field_hit_ops\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:13:\"field_hit_ops\";s:10:\"real field\";s:31:\"field_hit_ops-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:19:\"field_hit_ops_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:19:\"field_hit_ops_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:23:\"Hit Ops (field_hit_ops)\";s:11:\"title short\";s:7:\"Hit Ops\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:19:\"field_hit_ops_value\";s:5:\"table\";s:28:\"field_revision_field_hit_ops\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:19:\"field_hit_ops_value\";}s:10:\"field_name\";s:13:\"field_hit_ops\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:19:\"field_hit_ops_value\";s:5:\"table\";s:28:\"field_revision_field_hit_ops\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:19:\"field_hit_ops_value\";}s:10:\"field_name\";s:13:\"field_hit_ops\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:19:\"field_hit_ops_value\";s:5:\"table\";s:28:\"field_revision_field_hit_ops\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:19:\"field_hit_ops_value\";}s:10:\"field_name\";s:13:\"field_hit_ops\";}}}s:24:\"field_data_field_host_ip\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:24:\"field_data_field_host_ip\";i:1;s:13:\"field_host_ip\";}}}s:13:\"field_host_ip\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:2:\"IP\";s:11:\"title short\";s:2:\"IP\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:24:\"field_data_field_host_ip\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:13:\"field_host_ip\";s:10:\"real field\";s:19:\"field_host_ip_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:19:\"field_host_ip_value\";i:4;s:20:\"field_host_ip_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:19:\"field_host_ip_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:18:\"IP (field_host_ip)\";s:11:\"title short\";s:2:\"IP\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:19:\"field_host_ip_value\";s:5:\"table\";s:24:\"field_data_field_host_ip\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_host_ip_value\";i:1;s:20:\"field_host_ip_format\";}s:10:\"field_name\";s:13:\"field_host_ip\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:19:\"field_host_ip_value\";s:5:\"table\";s:24:\"field_data_field_host_ip\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_host_ip_value\";i:1;s:20:\"field_host_ip_format\";}s:10:\"field_name\";s:13:\"field_host_ip\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:19:\"field_host_ip_value\";s:5:\"table\";s:24:\"field_data_field_host_ip\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_host_ip_value\";i:1;s:20:\"field_host_ip_format\";}s:10:\"field_name\";s:13:\"field_host_ip\";}}s:20:\"field_host_ip_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:25:\"IP (field_host_ip:format)\";s:11:\"title short\";s:9:\"IP:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_host_ip_format\";s:5:\"table\";s:24:\"field_data_field_host_ip\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_host_ip_value\";i:1;s:20:\"field_host_ip_format\";}s:10:\"field_name\";s:13:\"field_host_ip\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_host_ip_format\";s:5:\"table\";s:24:\"field_data_field_host_ip\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_host_ip_value\";i:1;s:20:\"field_host_ip_format\";}s:10:\"field_name\";s:13:\"field_host_ip\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_host_ip_format\";s:5:\"table\";s:24:\"field_data_field_host_ip\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_host_ip_value\";i:1;s:20:\"field_host_ip_format\";}s:10:\"field_name\";s:13:\"field_host_ip\";}}}s:28:\"field_revision_field_host_ip\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:28:\"field_revision_field_host_ip\";i:1;s:25:\"field_host_ip-revision_id\";}}}s:25:\"field_host_ip-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:2:\"IP\";s:11:\"title short\";s:2:\"IP\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:28:\"field_revision_field_host_ip\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:13:\"field_host_ip\";s:10:\"real field\";s:31:\"field_host_ip-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:19:\"field_host_ip_value\";i:4;s:20:\"field_host_ip_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:19:\"field_host_ip_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:18:\"IP (field_host_ip)\";s:11:\"title short\";s:2:\"IP\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:19:\"field_host_ip_value\";s:5:\"table\";s:28:\"field_revision_field_host_ip\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_host_ip_value\";i:1;s:20:\"field_host_ip_format\";}s:10:\"field_name\";s:13:\"field_host_ip\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:19:\"field_host_ip_value\";s:5:\"table\";s:28:\"field_revision_field_host_ip\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_host_ip_value\";i:1;s:20:\"field_host_ip_format\";}s:10:\"field_name\";s:13:\"field_host_ip\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:19:\"field_host_ip_value\";s:5:\"table\";s:28:\"field_revision_field_host_ip\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_host_ip_value\";i:1;s:20:\"field_host_ip_format\";}s:10:\"field_name\";s:13:\"field_host_ip\";}}s:20:\"field_host_ip_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:25:\"IP (field_host_ip:format)\";s:11:\"title short\";s:9:\"IP:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_host_ip_format\";s:5:\"table\";s:28:\"field_revision_field_host_ip\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_host_ip_value\";i:1;s:20:\"field_host_ip_format\";}s:10:\"field_name\";s:13:\"field_host_ip\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_host_ip_format\";s:5:\"table\";s:28:\"field_revision_field_host_ip\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_host_ip_value\";i:1;s:20:\"field_host_ip_format\";}s:10:\"field_name\";s:13:\"field_host_ip\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_host_ip_format\";s:5:\"table\";s:28:\"field_revision_field_host_ip\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_host_ip_value\";i:1;s:20:\"field_host_ip_format\";}s:10:\"field_name\";s:13:\"field_host_ip\";}}}s:25:\"field_data_field_vdisk_id\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:25:\"field_data_field_vdisk_id\";i:1;s:14:\"field_vdisk_id\";}}}s:14:\"field_vdisk_id\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:8:\"vDisk Id\";s:11:\"title short\";s:8:\"vDisk Id\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:25:\"field_data_field_vdisk_id\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_vdisk_id\";s:10:\"real field\";s:20:\"field_vdisk_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_vdisk_id_value\";i:4;s:21:\"field_vdisk_id_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:20:\"field_vdisk_id_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:25:\"vDisk Id (field_vdisk_id)\";s:11:\"title short\";s:8:\"vDisk Id\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_vdisk_id_value\";s:5:\"table\";s:25:\"field_data_field_vdisk_id\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_vdisk_id_value\";i:1;s:21:\"field_vdisk_id_format\";}s:10:\"field_name\";s:14:\"field_vdisk_id\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_vdisk_id_value\";s:5:\"table\";s:25:\"field_data_field_vdisk_id\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_vdisk_id_value\";i:1;s:21:\"field_vdisk_id_format\";}s:10:\"field_name\";s:14:\"field_vdisk_id\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_vdisk_id_value\";s:5:\"table\";s:25:\"field_data_field_vdisk_id\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_vdisk_id_value\";i:1;s:21:\"field_vdisk_id_format\";}s:10:\"field_name\";s:14:\"field_vdisk_id\";}}s:21:\"field_vdisk_id_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:32:\"vDisk Id (field_vdisk_id:format)\";s:11:\"title short\";s:15:\"vDisk Id:format\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_vdisk_id_format\";s:5:\"table\";s:25:\"field_data_field_vdisk_id\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_vdisk_id_value\";i:1;s:21:\"field_vdisk_id_format\";}s:10:\"field_name\";s:14:\"field_vdisk_id\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_vdisk_id_format\";s:5:\"table\";s:25:\"field_data_field_vdisk_id\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_vdisk_id_value\";i:1;s:21:\"field_vdisk_id_format\";}s:10:\"field_name\";s:14:\"field_vdisk_id\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_vdisk_id_format\";s:5:\"table\";s:25:\"field_data_field_vdisk_id\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_vdisk_id_value\";i:1;s:21:\"field_vdisk_id_format\";}s:10:\"field_name\";s:14:\"field_vdisk_id\";}}}s:29:\"field_revision_field_vdisk_id\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:29:\"field_revision_field_vdisk_id\";i:1;s:26:\"field_vdisk_id-revision_id\";}}}s:26:\"field_vdisk_id-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:8:\"vDisk Id\";s:11:\"title short\";s:8:\"vDisk Id\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:29:\"field_revision_field_vdisk_id\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_vdisk_id\";s:10:\"real field\";s:32:\"field_vdisk_id-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_vdisk_id_value\";i:4;s:21:\"field_vdisk_id_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:20:\"field_vdisk_id_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:25:\"vDisk Id (field_vdisk_id)\";s:11:\"title short\";s:8:\"vDisk Id\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_vdisk_id_value\";s:5:\"table\";s:29:\"field_revision_field_vdisk_id\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_vdisk_id_value\";i:1;s:21:\"field_vdisk_id_format\";}s:10:\"field_name\";s:14:\"field_vdisk_id\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_vdisk_id_value\";s:5:\"table\";s:29:\"field_revision_field_vdisk_id\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_vdisk_id_value\";i:1;s:21:\"field_vdisk_id_format\";}s:10:\"field_name\";s:14:\"field_vdisk_id\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_vdisk_id_value\";s:5:\"table\";s:29:\"field_revision_field_vdisk_id\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_vdisk_id_value\";i:1;s:21:\"field_vdisk_id_format\";}s:10:\"field_name\";s:14:\"field_vdisk_id\";}}s:21:\"field_vdisk_id_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:32:\"vDisk Id (field_vdisk_id:format)\";s:11:\"title short\";s:15:\"vDisk Id:format\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_vdisk_id_format\";s:5:\"table\";s:29:\"field_revision_field_vdisk_id\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_vdisk_id_value\";i:1;s:21:\"field_vdisk_id_format\";}s:10:\"field_name\";s:14:\"field_vdisk_id\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_vdisk_id_format\";s:5:\"table\";s:29:\"field_revision_field_vdisk_id\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_vdisk_id_value\";i:1;s:21:\"field_vdisk_id_format\";}s:10:\"field_name\";s:14:\"field_vdisk_id\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_vdisk_id_format\";s:5:\"table\";s:29:\"field_revision_field_vdisk_id\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_vdisk_id_value\";i:1;s:21:\"field_vdisk_id_format\";}s:10:\"field_name\";s:14:\"field_vdisk_id\";}}}s:27:\"field_data_field_vdisk_type\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:27:\"field_data_field_vdisk_type\";i:1;s:16:\"field_vdisk_type\";}}}s:16:\"field_vdisk_type\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"vDisk Type\";s:11:\"title short\";s:10:\"vDisk Type\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:27:\"field_data_field_vdisk_type\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_vdisk_type\";s:10:\"real field\";s:22:\"field_vdisk_type_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_vdisk_type_value\";i:4;s:23:\"field_vdisk_type_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:22:\"field_vdisk_type_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:29:\"vDisk Type (field_vdisk_type)\";s:11:\"title short\";s:10:\"vDisk Type\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_vdisk_type_value\";s:5:\"table\";s:27:\"field_data_field_vdisk_type\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_type_value\";i:1;s:23:\"field_vdisk_type_format\";}s:10:\"field_name\";s:16:\"field_vdisk_type\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_vdisk_type_value\";s:5:\"table\";s:27:\"field_data_field_vdisk_type\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_type_value\";i:1;s:23:\"field_vdisk_type_format\";}s:10:\"field_name\";s:16:\"field_vdisk_type\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_vdisk_type_value\";s:5:\"table\";s:27:\"field_data_field_vdisk_type\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_type_value\";i:1;s:23:\"field_vdisk_type_format\";}s:10:\"field_name\";s:16:\"field_vdisk_type\";}}s:23:\"field_vdisk_type_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:36:\"vDisk Type (field_vdisk_type:format)\";s:11:\"title short\";s:17:\"vDisk Type:format\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_vdisk_type_format\";s:5:\"table\";s:27:\"field_data_field_vdisk_type\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_type_value\";i:1;s:23:\"field_vdisk_type_format\";}s:10:\"field_name\";s:16:\"field_vdisk_type\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_vdisk_type_format\";s:5:\"table\";s:27:\"field_data_field_vdisk_type\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_type_value\";i:1;s:23:\"field_vdisk_type_format\";}s:10:\"field_name\";s:16:\"field_vdisk_type\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_vdisk_type_format\";s:5:\"table\";s:27:\"field_data_field_vdisk_type\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_type_value\";i:1;s:23:\"field_vdisk_type_format\";}s:10:\"field_name\";s:16:\"field_vdisk_type\";}}}s:31:\"field_revision_field_vdisk_type\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:31:\"field_revision_field_vdisk_type\";i:1;s:28:\"field_vdisk_type-revision_id\";}}}s:28:\"field_vdisk_type-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:10:\"vDisk Type\";s:11:\"title short\";s:10:\"vDisk Type\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:31:\"field_revision_field_vdisk_type\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_vdisk_type\";s:10:\"real field\";s:34:\"field_vdisk_type-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_vdisk_type_value\";i:4;s:23:\"field_vdisk_type_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:22:\"field_vdisk_type_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:29:\"vDisk Type (field_vdisk_type)\";s:11:\"title short\";s:10:\"vDisk Type\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_vdisk_type_value\";s:5:\"table\";s:31:\"field_revision_field_vdisk_type\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_type_value\";i:1;s:23:\"field_vdisk_type_format\";}s:10:\"field_name\";s:16:\"field_vdisk_type\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_vdisk_type_value\";s:5:\"table\";s:31:\"field_revision_field_vdisk_type\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_type_value\";i:1;s:23:\"field_vdisk_type_format\";}s:10:\"field_name\";s:16:\"field_vdisk_type\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_vdisk_type_value\";s:5:\"table\";s:31:\"field_revision_field_vdisk_type\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_type_value\";i:1;s:23:\"field_vdisk_type_format\";}s:10:\"field_name\";s:16:\"field_vdisk_type\";}}s:23:\"field_vdisk_type_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:36:\"vDisk Type (field_vdisk_type:format)\";s:11:\"title short\";s:17:\"vDisk Type:format\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_vdisk_type_format\";s:5:\"table\";s:31:\"field_revision_field_vdisk_type\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_type_value\";i:1;s:23:\"field_vdisk_type_format\";}s:10:\"field_name\";s:16:\"field_vdisk_type\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_vdisk_type_format\";s:5:\"table\";s:31:\"field_revision_field_vdisk_type\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_type_value\";i:1;s:23:\"field_vdisk_type_format\";}s:10:\"field_name\";s:16:\"field_vdisk_type\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_vdisk_type_format\";s:5:\"table\";s:31:\"field_revision_field_vdisk_type\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_type_value\";i:1;s:23:\"field_vdisk_type_format\";}s:10:\"field_name\";s:16:\"field_vdisk_type\";}}}s:27:\"field_data_field_vdisk_name\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:27:\"field_data_field_vdisk_name\";i:1;s:16:\"field_vdisk_name\";}}}s:16:\"field_vdisk_name\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"vDisk Name\";s:11:\"title short\";s:10:\"vDisk Name\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:27:\"field_data_field_vdisk_name\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_vdisk_name\";s:10:\"real field\";s:22:\"field_vdisk_name_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_vdisk_name_value\";i:4;s:23:\"field_vdisk_name_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:22:\"field_vdisk_name_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:29:\"vDisk Name (field_vdisk_name)\";s:11:\"title short\";s:10:\"vDisk Name\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_vdisk_name_value\";s:5:\"table\";s:27:\"field_data_field_vdisk_name\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_name_value\";i:1;s:23:\"field_vdisk_name_format\";}s:10:\"field_name\";s:16:\"field_vdisk_name\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_vdisk_name_value\";s:5:\"table\";s:27:\"field_data_field_vdisk_name\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_name_value\";i:1;s:23:\"field_vdisk_name_format\";}s:10:\"field_name\";s:16:\"field_vdisk_name\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_vdisk_name_value\";s:5:\"table\";s:27:\"field_data_field_vdisk_name\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_name_value\";i:1;s:23:\"field_vdisk_name_format\";}s:10:\"field_name\";s:16:\"field_vdisk_name\";}}s:23:\"field_vdisk_name_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:36:\"vDisk Name (field_vdisk_name:format)\";s:11:\"title short\";s:17:\"vDisk Name:format\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_vdisk_name_format\";s:5:\"table\";s:27:\"field_data_field_vdisk_name\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_name_value\";i:1;s:23:\"field_vdisk_name_format\";}s:10:\"field_name\";s:16:\"field_vdisk_name\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_vdisk_name_format\";s:5:\"table\";s:27:\"field_data_field_vdisk_name\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_name_value\";i:1;s:23:\"field_vdisk_name_format\";}s:10:\"field_name\";s:16:\"field_vdisk_name\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_vdisk_name_format\";s:5:\"table\";s:27:\"field_data_field_vdisk_name\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_name_value\";i:1;s:23:\"field_vdisk_name_format\";}s:10:\"field_name\";s:16:\"field_vdisk_name\";}}}s:31:\"field_revision_field_vdisk_name\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:31:\"field_revision_field_vdisk_name\";i:1;s:28:\"field_vdisk_name-revision_id\";}}}s:28:\"field_vdisk_name-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:10:\"vDisk Name\";s:11:\"title short\";s:10:\"vDisk Name\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:31:\"field_revision_field_vdisk_name\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_vdisk_name\";s:10:\"real field\";s:34:\"field_vdisk_name-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_vdisk_name_value\";i:4;s:23:\"field_vdisk_name_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:22:\"field_vdisk_name_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:29:\"vDisk Name (field_vdisk_name)\";s:11:\"title short\";s:10:\"vDisk Name\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_vdisk_name_value\";s:5:\"table\";s:31:\"field_revision_field_vdisk_name\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_name_value\";i:1;s:23:\"field_vdisk_name_format\";}s:10:\"field_name\";s:16:\"field_vdisk_name\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_vdisk_name_value\";s:5:\"table\";s:31:\"field_revision_field_vdisk_name\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_name_value\";i:1;s:23:\"field_vdisk_name_format\";}s:10:\"field_name\";s:16:\"field_vdisk_name\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_vdisk_name_value\";s:5:\"table\";s:31:\"field_revision_field_vdisk_name\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_name_value\";i:1;s:23:\"field_vdisk_name_format\";}s:10:\"field_name\";s:16:\"field_vdisk_name\";}}s:23:\"field_vdisk_name_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:36:\"vDisk Name (field_vdisk_name:format)\";s:11:\"title short\";s:17:\"vDisk Name:format\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_vdisk_name_format\";s:5:\"table\";s:31:\"field_revision_field_vdisk_name\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_name_value\";i:1;s:23:\"field_vdisk_name_format\";}s:10:\"field_name\";s:16:\"field_vdisk_name\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_vdisk_name_format\";s:5:\"table\";s:31:\"field_revision_field_vdisk_name\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_name_value\";i:1;s:23:\"field_vdisk_name_format\";}s:10:\"field_name\";s:16:\"field_vdisk_name\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_vdisk_name_format\";s:5:\"table\";s:31:\"field_revision_field_vdisk_name\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_vdisk_name_value\";i:1;s:23:\"field_vdisk_name_format\";}s:10:\"field_name\";s:16:\"field_vdisk_name\";}}}s:33:\"field_data_field_fa_usable_blocks\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:33:\"field_data_field_fa_usable_blocks\";i:1;s:22:\"field_fa_usable_blocks\";}}}s:22:\"field_fa_usable_blocks\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:13:\"Usable Blocks\";s:11:\"title short\";s:13:\"Usable Blocks\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:33:\"field_data_field_fa_usable_blocks\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_fa_usable_blocks\";s:10:\"real field\";s:28:\"field_fa_usable_blocks_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_fa_usable_blocks_value\";i:4;s:29:\"field_fa_usable_blocks_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:28:\"field_fa_usable_blocks_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:38:\"Usable Blocks (field_fa_usable_blocks)\";s:11:\"title short\";s:13:\"Usable Blocks\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_fa_usable_blocks_value\";s:5:\"table\";s:33:\"field_data_field_fa_usable_blocks\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_usable_blocks_value\";i:1;s:29:\"field_fa_usable_blocks_format\";}s:10:\"field_name\";s:22:\"field_fa_usable_blocks\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_fa_usable_blocks_value\";s:5:\"table\";s:33:\"field_data_field_fa_usable_blocks\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_usable_blocks_value\";i:1;s:29:\"field_fa_usable_blocks_format\";}s:10:\"field_name\";s:22:\"field_fa_usable_blocks\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_fa_usable_blocks_value\";s:5:\"table\";s:33:\"field_data_field_fa_usable_blocks\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_usable_blocks_value\";i:1;s:29:\"field_fa_usable_blocks_format\";}s:10:\"field_name\";s:22:\"field_fa_usable_blocks\";}}s:29:\"field_fa_usable_blocks_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:45:\"Usable Blocks (field_fa_usable_blocks:format)\";s:11:\"title short\";s:20:\"Usable Blocks:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_fa_usable_blocks_format\";s:5:\"table\";s:33:\"field_data_field_fa_usable_blocks\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_usable_blocks_value\";i:1;s:29:\"field_fa_usable_blocks_format\";}s:10:\"field_name\";s:22:\"field_fa_usable_blocks\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_fa_usable_blocks_format\";s:5:\"table\";s:33:\"field_data_field_fa_usable_blocks\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_usable_blocks_value\";i:1;s:29:\"field_fa_usable_blocks_format\";}s:10:\"field_name\";s:22:\"field_fa_usable_blocks\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_fa_usable_blocks_format\";s:5:\"table\";s:33:\"field_data_field_fa_usable_blocks\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_usable_blocks_value\";i:1;s:29:\"field_fa_usable_blocks_format\";}s:10:\"field_name\";s:22:\"field_fa_usable_blocks\";}}}s:37:\"field_revision_field_fa_usable_blocks\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:37:\"field_revision_field_fa_usable_blocks\";i:1;s:34:\"field_fa_usable_blocks-revision_id\";}}}s:34:\"field_fa_usable_blocks-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:13:\"Usable Blocks\";s:11:\"title short\";s:13:\"Usable Blocks\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:37:\"field_revision_field_fa_usable_blocks\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_fa_usable_blocks\";s:10:\"real field\";s:40:\"field_fa_usable_blocks-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_fa_usable_blocks_value\";i:4;s:29:\"field_fa_usable_blocks_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:28:\"field_fa_usable_blocks_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:38:\"Usable Blocks (field_fa_usable_blocks)\";s:11:\"title short\";s:13:\"Usable Blocks\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_fa_usable_blocks_value\";s:5:\"table\";s:37:\"field_revision_field_fa_usable_blocks\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_usable_blocks_value\";i:1;s:29:\"field_fa_usable_blocks_format\";}s:10:\"field_name\";s:22:\"field_fa_usable_blocks\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_fa_usable_blocks_value\";s:5:\"table\";s:37:\"field_revision_field_fa_usable_blocks\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_usable_blocks_value\";i:1;s:29:\"field_fa_usable_blocks_format\";}s:10:\"field_name\";s:22:\"field_fa_usable_blocks\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_fa_usable_blocks_value\";s:5:\"table\";s:37:\"field_revision_field_fa_usable_blocks\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_usable_blocks_value\";i:1;s:29:\"field_fa_usable_blocks_format\";}s:10:\"field_name\";s:22:\"field_fa_usable_blocks\";}}s:29:\"field_fa_usable_blocks_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:45:\"Usable Blocks (field_fa_usable_blocks:format)\";s:11:\"title short\";s:20:\"Usable Blocks:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_fa_usable_blocks_format\";s:5:\"table\";s:37:\"field_revision_field_fa_usable_blocks\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_usable_blocks_value\";i:1;s:29:\"field_fa_usable_blocks_format\";}s:10:\"field_name\";s:22:\"field_fa_usable_blocks\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_fa_usable_blocks_format\";s:5:\"table\";s:37:\"field_revision_field_fa_usable_blocks\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_usable_blocks_value\";i:1;s:29:\"field_fa_usable_blocks_format\";}s:10:\"field_name\";s:22:\"field_fa_usable_blocks\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_fa_usable_blocks_format\";s:5:\"table\";s:37:\"field_revision_field_fa_usable_blocks\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_usable_blocks_value\";i:1;s:29:\"field_fa_usable_blocks_format\";}s:10:\"field_name\";s:22:\"field_fa_usable_blocks\";}}}s:24:\"field_data_field_is_vmfs\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:24:\"field_data_field_is_vmfs\";i:1;s:13:\"field_is_vmfs\";}}}s:13:\"field_is_vmfs\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:7:\"Is VMFS\";s:11:\"title short\";s:7:\"Is VMFS\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:24:\"field_data_field_is_vmfs\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:13:\"field_is_vmfs\";s:10:\"real field\";s:19:\"field_is_vmfs_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:19:\"field_is_vmfs_value\";i:4;s:20:\"field_is_vmfs_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:19:\"field_is_vmfs_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:23:\"Is VMFS (field_is_vmfs)\";s:11:\"title short\";s:7:\"Is VMFS\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:19:\"field_is_vmfs_value\";s:5:\"table\";s:24:\"field_data_field_is_vmfs\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_is_vmfs_value\";i:1;s:20:\"field_is_vmfs_format\";}s:10:\"field_name\";s:13:\"field_is_vmfs\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:19:\"field_is_vmfs_value\";s:5:\"table\";s:24:\"field_data_field_is_vmfs\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_is_vmfs_value\";i:1;s:20:\"field_is_vmfs_format\";}s:10:\"field_name\";s:13:\"field_is_vmfs\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:19:\"field_is_vmfs_value\";s:5:\"table\";s:24:\"field_data_field_is_vmfs\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_is_vmfs_value\";i:1;s:20:\"field_is_vmfs_format\";}s:10:\"field_name\";s:13:\"field_is_vmfs\";}}s:20:\"field_is_vmfs_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:30:\"Is VMFS (field_is_vmfs:format)\";s:11:\"title short\";s:14:\"Is VMFS:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_is_vmfs_format\";s:5:\"table\";s:24:\"field_data_field_is_vmfs\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_is_vmfs_value\";i:1;s:20:\"field_is_vmfs_format\";}s:10:\"field_name\";s:13:\"field_is_vmfs\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_is_vmfs_format\";s:5:\"table\";s:24:\"field_data_field_is_vmfs\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_is_vmfs_value\";i:1;s:20:\"field_is_vmfs_format\";}s:10:\"field_name\";s:13:\"field_is_vmfs\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_is_vmfs_format\";s:5:\"table\";s:24:\"field_data_field_is_vmfs\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_is_vmfs_value\";i:1;s:20:\"field_is_vmfs_format\";}s:10:\"field_name\";s:13:\"field_is_vmfs\";}}}s:28:\"field_revision_field_is_vmfs\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:28:\"field_revision_field_is_vmfs\";i:1;s:25:\"field_is_vmfs-revision_id\";}}}s:25:\"field_is_vmfs-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:7:\"Is VMFS\";s:11:\"title short\";s:7:\"Is VMFS\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:28:\"field_revision_field_is_vmfs\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:13:\"field_is_vmfs\";s:10:\"real field\";s:31:\"field_is_vmfs-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:19:\"field_is_vmfs_value\";i:4;s:20:\"field_is_vmfs_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:19:\"field_is_vmfs_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:23:\"Is VMFS (field_is_vmfs)\";s:11:\"title short\";s:7:\"Is VMFS\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:19:\"field_is_vmfs_value\";s:5:\"table\";s:28:\"field_revision_field_is_vmfs\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_is_vmfs_value\";i:1;s:20:\"field_is_vmfs_format\";}s:10:\"field_name\";s:13:\"field_is_vmfs\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:19:\"field_is_vmfs_value\";s:5:\"table\";s:28:\"field_revision_field_is_vmfs\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_is_vmfs_value\";i:1;s:20:\"field_is_vmfs_format\";}s:10:\"field_name\";s:13:\"field_is_vmfs\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:19:\"field_is_vmfs_value\";s:5:\"table\";s:28:\"field_revision_field_is_vmfs\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_is_vmfs_value\";i:1;s:20:\"field_is_vmfs_format\";}s:10:\"field_name\";s:13:\"field_is_vmfs\";}}s:20:\"field_is_vmfs_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:30:\"Is VMFS (field_is_vmfs:format)\";s:11:\"title short\";s:14:\"Is VMFS:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_is_vmfs_format\";s:5:\"table\";s:28:\"field_revision_field_is_vmfs\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_is_vmfs_value\";i:1;s:20:\"field_is_vmfs_format\";}s:10:\"field_name\";s:13:\"field_is_vmfs\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_is_vmfs_format\";s:5:\"table\";s:28:\"field_revision_field_is_vmfs\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_is_vmfs_value\";i:1;s:20:\"field_is_vmfs_format\";}s:10:\"field_name\";s:13:\"field_is_vmfs\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_is_vmfs_format\";s:5:\"table\";s:28:\"field_revision_field_is_vmfs\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:19:\"field_is_vmfs_value\";i:1;s:20:\"field_is_vmfs_format\";}s:10:\"field_name\";s:13:\"field_is_vmfs\";}}}s:21:\"field_data_field_hbtl\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:21:\"field_data_field_hbtl\";i:1;s:10:\"field_hbtl\";}}}s:10:\"field_hbtl\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:4:\"HBTL\";s:11:\"title short\";s:4:\"HBTL\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:21:\"field_data_field_hbtl\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:10:\"field_hbtl\";s:10:\"real field\";s:16:\"field_hbtl_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:16:\"field_hbtl_value\";i:4;s:17:\"field_hbtl_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:16:\"field_hbtl_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:17:\"HBTL (field_hbtl)\";s:11:\"title short\";s:4:\"HBTL\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:16:\"field_hbtl_value\";s:5:\"table\";s:21:\"field_data_field_hbtl\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_hbtl_value\";i:1;s:17:\"field_hbtl_format\";}s:10:\"field_name\";s:10:\"field_hbtl\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:16:\"field_hbtl_value\";s:5:\"table\";s:21:\"field_data_field_hbtl\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_hbtl_value\";i:1;s:17:\"field_hbtl_format\";}s:10:\"field_name\";s:10:\"field_hbtl\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:16:\"field_hbtl_value\";s:5:\"table\";s:21:\"field_data_field_hbtl\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_hbtl_value\";i:1;s:17:\"field_hbtl_format\";}s:10:\"field_name\";s:10:\"field_hbtl\";}}s:17:\"field_hbtl_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:24:\"HBTL (field_hbtl:format)\";s:11:\"title short\";s:11:\"HBTL:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:17:\"field_hbtl_format\";s:5:\"table\";s:21:\"field_data_field_hbtl\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_hbtl_value\";i:1;s:17:\"field_hbtl_format\";}s:10:\"field_name\";s:10:\"field_hbtl\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:17:\"field_hbtl_format\";s:5:\"table\";s:21:\"field_data_field_hbtl\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_hbtl_value\";i:1;s:17:\"field_hbtl_format\";}s:10:\"field_name\";s:10:\"field_hbtl\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:17:\"field_hbtl_format\";s:5:\"table\";s:21:\"field_data_field_hbtl\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_hbtl_value\";i:1;s:17:\"field_hbtl_format\";}s:10:\"field_name\";s:10:\"field_hbtl\";}}}s:25:\"field_revision_field_hbtl\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:25:\"field_revision_field_hbtl\";i:1;s:22:\"field_hbtl-revision_id\";}}}s:22:\"field_hbtl-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:4:\"HBTL\";s:11:\"title short\";s:4:\"HBTL\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:25:\"field_revision_field_hbtl\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:10:\"field_hbtl\";s:10:\"real field\";s:28:\"field_hbtl-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:16:\"field_hbtl_value\";i:4;s:17:\"field_hbtl_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:16:\"field_hbtl_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:17:\"HBTL (field_hbtl)\";s:11:\"title short\";s:4:\"HBTL\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:16:\"field_hbtl_value\";s:5:\"table\";s:25:\"field_revision_field_hbtl\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_hbtl_value\";i:1;s:17:\"field_hbtl_format\";}s:10:\"field_name\";s:10:\"field_hbtl\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:16:\"field_hbtl_value\";s:5:\"table\";s:25:\"field_revision_field_hbtl\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_hbtl_value\";i:1;s:17:\"field_hbtl_format\";}s:10:\"field_name\";s:10:\"field_hbtl\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:16:\"field_hbtl_value\";s:5:\"table\";s:25:\"field_revision_field_hbtl\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_hbtl_value\";i:1;s:17:\"field_hbtl_format\";}s:10:\"field_name\";s:10:\"field_hbtl\";}}s:17:\"field_hbtl_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:24:\"HBTL (field_hbtl:format)\";s:11:\"title short\";s:11:\"HBTL:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:17:\"field_hbtl_format\";s:5:\"table\";s:25:\"field_revision_field_hbtl\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_hbtl_value\";i:1;s:17:\"field_hbtl_format\";}s:10:\"field_name\";s:10:\"field_hbtl\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:17:\"field_hbtl_format\";s:5:\"table\";s:25:\"field_revision_field_hbtl\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_hbtl_value\";i:1;s:17:\"field_hbtl_format\";}s:10:\"field_name\";s:10:\"field_hbtl\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:17:\"field_hbtl_format\";s:5:\"table\";s:25:\"field_revision_field_hbtl\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_hbtl_value\";i:1;s:17:\"field_hbtl_format\";}s:10:\"field_name\";s:10:\"field_hbtl\";}}}s:31:\"field_data_field_vm_vmotionable\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:31:\"field_data_field_vm_vmotionable\";i:1;s:20:\"field_vm_vmotionable\";}}}s:20:\"field_vm_vmotionable\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:12:\"V Motionable\";s:11:\"title short\";s:12:\"V Motionable\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:31:\"field_data_field_vm_vmotionable\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:20:\"field_vm_vmotionable\";s:10:\"real field\";s:26:\"field_vm_vmotionable_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:26:\"field_vm_vmotionable_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:26:\"field_vm_vmotionable_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:35:\"V Motionable (field_vm_vmotionable)\";s:11:\"title short\";s:12:\"V Motionable\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_vm_vmotionable_value\";s:5:\"table\";s:31:\"field_data_field_vm_vmotionable\";s:7:\"handler\";s:33:\"views_handler_argument_field_list\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vm_vmotionable_value\";}s:10:\"field_name\";s:20:\"field_vm_vmotionable\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_vm_vmotionable_value\";s:5:\"table\";s:31:\"field_data_field_vm_vmotionable\";s:7:\"handler\";s:31:\"views_handler_filter_field_list\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vm_vmotionable_value\";}s:10:\"field_name\";s:20:\"field_vm_vmotionable\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_vm_vmotionable_value\";s:5:\"table\";s:31:\"field_data_field_vm_vmotionable\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vm_vmotionable_value\";}s:10:\"field_name\";s:20:\"field_vm_vmotionable\";}}}s:35:\"field_revision_field_vm_vmotionable\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:35:\"field_revision_field_vm_vmotionable\";i:1;s:32:\"field_vm_vmotionable-revision_id\";}}}s:32:\"field_vm_vmotionable-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:12:\"V Motionable\";s:11:\"title short\";s:12:\"V Motionable\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:35:\"field_revision_field_vm_vmotionable\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:20:\"field_vm_vmotionable\";s:10:\"real field\";s:38:\"field_vm_vmotionable-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:26:\"field_vm_vmotionable_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:26:\"field_vm_vmotionable_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:35:\"V Motionable (field_vm_vmotionable)\";s:11:\"title short\";s:12:\"V Motionable\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_vm_vmotionable_value\";s:5:\"table\";s:35:\"field_revision_field_vm_vmotionable\";s:7:\"handler\";s:33:\"views_handler_argument_field_list\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vm_vmotionable_value\";}s:10:\"field_name\";s:20:\"field_vm_vmotionable\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_vm_vmotionable_value\";s:5:\"table\";s:35:\"field_revision_field_vm_vmotionable\";s:7:\"handler\";s:31:\"views_handler_filter_field_list\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vm_vmotionable_value\";}s:10:\"field_name\";s:20:\"field_vm_vmotionable\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_vm_vmotionable_value\";s:5:\"table\";s:35:\"field_revision_field_vm_vmotionable\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vm_vmotionable_value\";}s:10:\"field_name\";s:20:\"field_vm_vmotionable\";}}}s:28:\"field_data_field_host_vendor\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:28:\"field_data_field_host_vendor\";i:1;s:17:\"field_host_vendor\";}}}s:17:\"field_host_vendor\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:11:\"Host Vendor\";s:11:\"title short\";s:11:\"Host Vendor\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:28:\"field_data_field_host_vendor\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_host_vendor\";s:10:\"real field\";s:23:\"field_host_vendor_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_host_vendor_value\";i:4;s:24:\"field_host_vendor_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:23:\"field_host_vendor_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:31:\"Host Vendor (field_host_vendor)\";s:11:\"title short\";s:11:\"Host Vendor\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_host_vendor_value\";s:5:\"table\";s:28:\"field_data_field_host_vendor\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_vendor_value\";i:1;s:24:\"field_host_vendor_format\";}s:10:\"field_name\";s:17:\"field_host_vendor\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_host_vendor_value\";s:5:\"table\";s:28:\"field_data_field_host_vendor\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_vendor_value\";i:1;s:24:\"field_host_vendor_format\";}s:10:\"field_name\";s:17:\"field_host_vendor\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_host_vendor_value\";s:5:\"table\";s:28:\"field_data_field_host_vendor\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_vendor_value\";i:1;s:24:\"field_host_vendor_format\";}s:10:\"field_name\";s:17:\"field_host_vendor\";}}s:24:\"field_host_vendor_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:38:\"Host Vendor (field_host_vendor:format)\";s:11:\"title short\";s:18:\"Host Vendor:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_host_vendor_format\";s:5:\"table\";s:28:\"field_data_field_host_vendor\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_vendor_value\";i:1;s:24:\"field_host_vendor_format\";}s:10:\"field_name\";s:17:\"field_host_vendor\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_host_vendor_format\";s:5:\"table\";s:28:\"field_data_field_host_vendor\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_vendor_value\";i:1;s:24:\"field_host_vendor_format\";}s:10:\"field_name\";s:17:\"field_host_vendor\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_host_vendor_format\";s:5:\"table\";s:28:\"field_data_field_host_vendor\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_vendor_value\";i:1;s:24:\"field_host_vendor_format\";}s:10:\"field_name\";s:17:\"field_host_vendor\";}}}s:32:\"field_revision_field_host_vendor\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:32:\"field_revision_field_host_vendor\";i:1;s:29:\"field_host_vendor-revision_id\";}}}s:29:\"field_host_vendor-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:11:\"Host Vendor\";s:11:\"title short\";s:11:\"Host Vendor\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:32:\"field_revision_field_host_vendor\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_host_vendor\";s:10:\"real field\";s:35:\"field_host_vendor-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_host_vendor_value\";i:4;s:24:\"field_host_vendor_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:23:\"field_host_vendor_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:31:\"Host Vendor (field_host_vendor)\";s:11:\"title short\";s:11:\"Host Vendor\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_host_vendor_value\";s:5:\"table\";s:32:\"field_revision_field_host_vendor\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_vendor_value\";i:1;s:24:\"field_host_vendor_format\";}s:10:\"field_name\";s:17:\"field_host_vendor\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_host_vendor_value\";s:5:\"table\";s:32:\"field_revision_field_host_vendor\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_vendor_value\";i:1;s:24:\"field_host_vendor_format\";}s:10:\"field_name\";s:17:\"field_host_vendor\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_host_vendor_value\";s:5:\"table\";s:32:\"field_revision_field_host_vendor\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_vendor_value\";i:1;s:24:\"field_host_vendor_format\";}s:10:\"field_name\";s:17:\"field_host_vendor\";}}s:24:\"field_host_vendor_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:38:\"Host Vendor (field_host_vendor:format)\";s:11:\"title short\";s:18:\"Host Vendor:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_host_vendor_format\";s:5:\"table\";s:32:\"field_revision_field_host_vendor\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_vendor_value\";i:1;s:24:\"field_host_vendor_format\";}s:10:\"field_name\";s:17:\"field_host_vendor\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_host_vendor_format\";s:5:\"table\";s:32:\"field_revision_field_host_vendor\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_vendor_value\";i:1;s:24:\"field_host_vendor_format\";}s:10:\"field_name\";s:17:\"field_host_vendor\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_host_vendor_format\";s:5:\"table\";s:32:\"field_revision_field_host_vendor\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_vendor_value\";i:1;s:24:\"field_host_vendor_format\";}s:10:\"field_name\";s:17:\"field_host_vendor\";}}}s:27:\"field_data_field_host_model\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:27:\"field_data_field_host_model\";i:1;s:16:\"field_host_model\";}}}s:16:\"field_host_model\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"Host Model\";s:11:\"title short\";s:10:\"Host Model\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:27:\"field_data_field_host_model\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_host_model\";s:10:\"real field\";s:22:\"field_host_model_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_host_model_value\";i:4;s:23:\"field_host_model_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:22:\"field_host_model_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:29:\"Host Model (field_host_model)\";s:11:\"title short\";s:10:\"Host Model\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_host_model_value\";s:5:\"table\";s:27:\"field_data_field_host_model\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_host_model_value\";i:1;s:23:\"field_host_model_format\";}s:10:\"field_name\";s:16:\"field_host_model\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_host_model_value\";s:5:\"table\";s:27:\"field_data_field_host_model\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_host_model_value\";i:1;s:23:\"field_host_model_format\";}s:10:\"field_name\";s:16:\"field_host_model\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_host_model_value\";s:5:\"table\";s:27:\"field_data_field_host_model\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_host_model_value\";i:1;s:23:\"field_host_model_format\";}s:10:\"field_name\";s:16:\"field_host_model\";}}s:23:\"field_host_model_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:36:\"Host Model (field_host_model:format)\";s:11:\"title short\";s:17:\"Host Model:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_host_model_format\";s:5:\"table\";s:27:\"field_data_field_host_model\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_host_model_value\";i:1;s:23:\"field_host_model_format\";}s:10:\"field_name\";s:16:\"field_host_model\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_host_model_format\";s:5:\"table\";s:27:\"field_data_field_host_model\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_host_model_value\";i:1;s:23:\"field_host_model_format\";}s:10:\"field_name\";s:16:\"field_host_model\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_host_model_format\";s:5:\"table\";s:27:\"field_data_field_host_model\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_host_model_value\";i:1;s:23:\"field_host_model_format\";}s:10:\"field_name\";s:16:\"field_host_model\";}}}s:31:\"field_revision_field_host_model\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:31:\"field_revision_field_host_model\";i:1;s:28:\"field_host_model-revision_id\";}}}s:28:\"field_host_model-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:10:\"Host Model\";s:11:\"title short\";s:10:\"Host Model\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:31:\"field_revision_field_host_model\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_host_model\";s:10:\"real field\";s:34:\"field_host_model-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_host_model_value\";i:4;s:23:\"field_host_model_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:22:\"field_host_model_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:29:\"Host Model (field_host_model)\";s:11:\"title short\";s:10:\"Host Model\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_host_model_value\";s:5:\"table\";s:31:\"field_revision_field_host_model\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_host_model_value\";i:1;s:23:\"field_host_model_format\";}s:10:\"field_name\";s:16:\"field_host_model\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_host_model_value\";s:5:\"table\";s:31:\"field_revision_field_host_model\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_host_model_value\";i:1;s:23:\"field_host_model_format\";}s:10:\"field_name\";s:16:\"field_host_model\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_host_model_value\";s:5:\"table\";s:31:\"field_revision_field_host_model\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_host_model_value\";i:1;s:23:\"field_host_model_format\";}s:10:\"field_name\";s:16:\"field_host_model\";}}s:23:\"field_host_model_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:36:\"Host Model (field_host_model:format)\";s:11:\"title short\";s:17:\"Host Model:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_host_model_format\";s:5:\"table\";s:31:\"field_revision_field_host_model\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_host_model_value\";i:1;s:23:\"field_host_model_format\";}s:10:\"field_name\";s:16:\"field_host_model\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_host_model_format\";s:5:\"table\";s:31:\"field_revision_field_host_model\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_host_model_value\";i:1;s:23:\"field_host_model_format\";}s:10:\"field_name\";s:16:\"field_host_model\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_host_model_format\";s:5:\"table\";s:31:\"field_revision_field_host_model\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_host_model_value\";i:1;s:23:\"field_host_model_format\";}s:10:\"field_name\";s:16:\"field_host_model\";}}}s:29:\"field_data_field_install_port\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:29:\"field_data_field_install_port\";i:1;s:18:\"field_install_port\";}}}s:18:\"field_install_port\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:12:\"Install Port\";s:11:\"title short\";s:12:\"Install Port\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:29:\"field_data_field_install_port\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:18:\"field_install_port\";s:10:\"real field\";s:24:\"field_install_port_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:24:\"field_install_port_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:24:\"field_install_port_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:33:\"Install Port (field_install_port)\";s:11:\"title short\";s:12:\"Install Port\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_install_port_value\";s:5:\"table\";s:29:\"field_data_field_install_port\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_install_port_value\";}s:10:\"field_name\";s:18:\"field_install_port\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_install_port_value\";s:5:\"table\";s:29:\"field_data_field_install_port\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_install_port_value\";}s:10:\"field_name\";s:18:\"field_install_port\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_install_port_value\";s:5:\"table\";s:29:\"field_data_field_install_port\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_install_port_value\";}s:10:\"field_name\";s:18:\"field_install_port\";}}}s:33:\"field_revision_field_install_port\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:33:\"field_revision_field_install_port\";i:1;s:30:\"field_install_port-revision_id\";}}}s:30:\"field_install_port-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:12:\"Install Port\";s:11:\"title short\";s:12:\"Install Port\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:33:\"field_revision_field_install_port\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:18:\"field_install_port\";s:10:\"real field\";s:36:\"field_install_port-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:24:\"field_install_port_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:24:\"field_install_port_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:33:\"Install Port (field_install_port)\";s:11:\"title short\";s:12:\"Install Port\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_install_port_value\";s:5:\"table\";s:33:\"field_revision_field_install_port\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_install_port_value\";}s:10:\"field_name\";s:18:\"field_install_port\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_install_port_value\";s:5:\"table\";s:33:\"field_revision_field_install_port\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_install_port_value\";}s:10:\"field_name\";s:18:\"field_install_port\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_install_port_value\";s:5:\"table\";s:33:\"field_revision_field_install_port\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_install_port_value\";}s:10:\"field_name\";s:18:\"field_install_port\";}}}s:38:\"field_data_field_cache_allocated_to_vm\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:38:\"field_data_field_cache_allocated_to_vm\";i:1;s:27:\"field_cache_allocated_to_vm\";}}}s:27:\"field_cache_allocated_to_vm\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:28:\"Allocated to Virtual Machine\";s:11:\"title short\";s:28:\"Allocated to Virtual Machine\";s:4:\"help\";s:32:\"Appears in: node:vm_cache_space.\";s:5:\"field\";a:9:{s:5:\"table\";s:38:\"field_data_field_cache_allocated_to_vm\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:27:\"field_cache_allocated_to_vm\";s:10:\"real field\";s:31:\"field_cache_allocated_to_vm_nid\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:31:\"field_cache_allocated_to_vm_nid\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:31:\"field_cache_allocated_to_vm_nid\";a:8:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:58:\"Allocated to Virtual Machine (field_cache_allocated_to_vm)\";s:11:\"title short\";s:28:\"Allocated to Virtual Machine\";s:4:\"help\";s:32:\"Appears in: node:vm_cache_space.\";s:8:\"argument\";a:8:{s:5:\"field\";s:31:\"field_cache_allocated_to_vm_nid\";s:5:\"table\";s:38:\"field_data_field_cache_allocated_to_vm\";s:7:\"handler\";s:27:\"references_handler_argument\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_cache_allocated_to_vm_nid\";}s:10:\"field_name\";s:27:\"field_cache_allocated_to_vm\";s:16:\"empty field name\";s:12:\"- No value -\";s:10:\"name table\";s:48:\"field_data_field_cache_allocated_to_vm_reference\";s:10:\"name field\";s:5:\"title\";}s:6:\"filter\";a:8:{s:5:\"field\";s:31:\"field_cache_allocated_to_vm_nid\";s:5:\"table\";s:38:\"field_data_field_cache_allocated_to_vm\";s:7:\"handler\";s:32:\"views_handler_filter_in_operator\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_cache_allocated_to_vm_nid\";}s:10:\"field_name\";s:27:\"field_cache_allocated_to_vm\";s:11:\"allow empty\";b:1;s:16:\"options callback\";s:28:\"node_reference_views_options\";s:17:\"options arguments\";a:1:{i:0;s:27:\"field_cache_allocated_to_vm\";}}s:4:\"sort\";a:5:{s:5:\"field\";s:31:\"field_cache_allocated_to_vm_nid\";s:5:\"table\";s:38:\"field_data_field_cache_allocated_to_vm\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_cache_allocated_to_vm_nid\";}s:10:\"field_name\";s:27:\"field_cache_allocated_to_vm\";}s:12:\"relationship\";a:6:{s:7:\"handler\";s:31:\"references_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"field\";s:31:\"field_cache_allocated_to_vm_nid\";s:5:\"label\";s:27:\"field_cache_allocated_to_vm\";s:10:\"field_name\";s:27:\"field_cache_allocated_to_vm\";}}}s:42:\"field_revision_field_cache_allocated_to_vm\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:42:\"field_revision_field_cache_allocated_to_vm\";i:1;s:39:\"field_cache_allocated_to_vm-revision_id\";}}}s:39:\"field_cache_allocated_to_vm-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:28:\"Allocated to Virtual Machine\";s:11:\"title short\";s:28:\"Allocated to Virtual Machine\";s:4:\"help\";s:32:\"Appears in: node:vm_cache_space.\";s:5:\"field\";a:9:{s:5:\"table\";s:42:\"field_revision_field_cache_allocated_to_vm\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:27:\"field_cache_allocated_to_vm\";s:10:\"real field\";s:43:\"field_cache_allocated_to_vm-revision_id_nid\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:31:\"field_cache_allocated_to_vm_nid\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:31:\"field_cache_allocated_to_vm_nid\";a:8:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:58:\"Allocated to Virtual Machine (field_cache_allocated_to_vm)\";s:11:\"title short\";s:28:\"Allocated to Virtual Machine\";s:4:\"help\";s:32:\"Appears in: node:vm_cache_space.\";s:8:\"argument\";a:8:{s:5:\"field\";s:31:\"field_cache_allocated_to_vm_nid\";s:5:\"table\";s:42:\"field_revision_field_cache_allocated_to_vm\";s:7:\"handler\";s:27:\"references_handler_argument\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_cache_allocated_to_vm_nid\";}s:10:\"field_name\";s:27:\"field_cache_allocated_to_vm\";s:16:\"empty field name\";s:12:\"- No value -\";s:10:\"name table\";s:52:\"field_revision_field_cache_allocated_to_vm_reference\";s:10:\"name field\";s:5:\"title\";}s:6:\"filter\";a:8:{s:5:\"field\";s:31:\"field_cache_allocated_to_vm_nid\";s:5:\"table\";s:42:\"field_revision_field_cache_allocated_to_vm\";s:7:\"handler\";s:32:\"views_handler_filter_in_operator\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_cache_allocated_to_vm_nid\";}s:10:\"field_name\";s:27:\"field_cache_allocated_to_vm\";s:11:\"allow empty\";b:1;s:16:\"options callback\";s:28:\"node_reference_views_options\";s:17:\"options arguments\";a:1:{i:0;s:27:\"field_cache_allocated_to_vm\";}}s:4:\"sort\";a:5:{s:5:\"field\";s:31:\"field_cache_allocated_to_vm_nid\";s:5:\"table\";s:42:\"field_revision_field_cache_allocated_to_vm\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_cache_allocated_to_vm_nid\";}s:10:\"field_name\";s:27:\"field_cache_allocated_to_vm\";}s:12:\"relationship\";a:6:{s:7:\"handler\";s:31:\"references_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"field\";s:31:\"field_cache_allocated_to_vm_nid\";s:5:\"label\";s:27:\"field_cache_allocated_to_vm\";s:10:\"field_name\";s:27:\"field_cache_allocated_to_vm\";}}}s:48:\"field_data_field_cache_allocated_to_vm_reference\";a:1:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:38:\"field_data_field_cache_allocated_to_vm\";a:3:{s:10:\"left_field\";s:31:\"field_cache_allocated_to_vm_nid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";}}}}s:52:\"field_revision_field_cache_allocated_to_vm_reference\";a:1:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:42:\"field_revision_field_cache_allocated_to_vm\";a:3:{s:10:\"left_field\";s:31:\"field_cache_allocated_to_vm_nid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";}}}}s:41:\"field_data_field_cache_assigned_from_host\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:41:\"field_data_field_cache_assigned_from_host\";i:1;s:30:\"field_cache_assigned_from_host\";}}}s:30:\"field_cache_assigned_from_host\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:18:\"Assigned from Host\";s:11:\"title short\";s:18:\"Assigned from Host\";s:4:\"help\";s:32:\"Appears in: node:vm_cache_space.\";s:5:\"field\";a:9:{s:5:\"table\";s:41:\"field_data_field_cache_assigned_from_host\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:30:\"field_cache_assigned_from_host\";s:10:\"real field\";s:34:\"field_cache_assigned_from_host_nid\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:34:\"field_cache_assigned_from_host_nid\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:34:\"field_cache_assigned_from_host_nid\";a:8:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:51:\"Assigned from Host (field_cache_assigned_from_host)\";s:11:\"title short\";s:18:\"Assigned from Host\";s:4:\"help\";s:32:\"Appears in: node:vm_cache_space.\";s:8:\"argument\";a:8:{s:5:\"field\";s:34:\"field_cache_assigned_from_host_nid\";s:5:\"table\";s:41:\"field_data_field_cache_assigned_from_host\";s:7:\"handler\";s:27:\"references_handler_argument\";s:17:\"additional fields\";a:1:{i:0;s:34:\"field_cache_assigned_from_host_nid\";}s:10:\"field_name\";s:30:\"field_cache_assigned_from_host\";s:16:\"empty field name\";s:12:\"- No value -\";s:10:\"name table\";s:51:\"field_data_field_cache_assigned_from_host_reference\";s:10:\"name field\";s:5:\"title\";}s:6:\"filter\";a:8:{s:5:\"field\";s:34:\"field_cache_assigned_from_host_nid\";s:5:\"table\";s:41:\"field_data_field_cache_assigned_from_host\";s:7:\"handler\";s:32:\"views_handler_filter_in_operator\";s:17:\"additional fields\";a:1:{i:0;s:34:\"field_cache_assigned_from_host_nid\";}s:10:\"field_name\";s:30:\"field_cache_assigned_from_host\";s:11:\"allow empty\";b:1;s:16:\"options callback\";s:28:\"node_reference_views_options\";s:17:\"options arguments\";a:1:{i:0;s:30:\"field_cache_assigned_from_host\";}}s:4:\"sort\";a:5:{s:5:\"field\";s:34:\"field_cache_assigned_from_host_nid\";s:5:\"table\";s:41:\"field_data_field_cache_assigned_from_host\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:34:\"field_cache_assigned_from_host_nid\";}s:10:\"field_name\";s:30:\"field_cache_assigned_from_host\";}s:12:\"relationship\";a:6:{s:7:\"handler\";s:31:\"references_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"field\";s:34:\"field_cache_assigned_from_host_nid\";s:5:\"label\";s:30:\"field_cache_assigned_from_host\";s:10:\"field_name\";s:30:\"field_cache_assigned_from_host\";}}}s:45:\"field_revision_field_cache_assigned_from_host\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:45:\"field_revision_field_cache_assigned_from_host\";i:1;s:42:\"field_cache_assigned_from_host-revision_id\";}}}s:42:\"field_cache_assigned_from_host-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:18:\"Assigned from Host\";s:11:\"title short\";s:18:\"Assigned from Host\";s:4:\"help\";s:32:\"Appears in: node:vm_cache_space.\";s:5:\"field\";a:9:{s:5:\"table\";s:45:\"field_revision_field_cache_assigned_from_host\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:30:\"field_cache_assigned_from_host\";s:10:\"real field\";s:46:\"field_cache_assigned_from_host-revision_id_nid\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:34:\"field_cache_assigned_from_host_nid\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:34:\"field_cache_assigned_from_host_nid\";a:8:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:51:\"Assigned from Host (field_cache_assigned_from_host)\";s:11:\"title short\";s:18:\"Assigned from Host\";s:4:\"help\";s:32:\"Appears in: node:vm_cache_space.\";s:8:\"argument\";a:8:{s:5:\"field\";s:34:\"field_cache_assigned_from_host_nid\";s:5:\"table\";s:45:\"field_revision_field_cache_assigned_from_host\";s:7:\"handler\";s:27:\"references_handler_argument\";s:17:\"additional fields\";a:1:{i:0;s:34:\"field_cache_assigned_from_host_nid\";}s:10:\"field_name\";s:30:\"field_cache_assigned_from_host\";s:16:\"empty field name\";s:12:\"- No value -\";s:10:\"name table\";s:55:\"field_revision_field_cache_assigned_from_host_reference\";s:10:\"name field\";s:5:\"title\";}s:6:\"filter\";a:8:{s:5:\"field\";s:34:\"field_cache_assigned_from_host_nid\";s:5:\"table\";s:45:\"field_revision_field_cache_assigned_from_host\";s:7:\"handler\";s:32:\"views_handler_filter_in_operator\";s:17:\"additional fields\";a:1:{i:0;s:34:\"field_cache_assigned_from_host_nid\";}s:10:\"field_name\";s:30:\"field_cache_assigned_from_host\";s:11:\"allow empty\";b:1;s:16:\"options callback\";s:28:\"node_reference_views_options\";s:17:\"options arguments\";a:1:{i:0;s:30:\"field_cache_assigned_from_host\";}}s:4:\"sort\";a:5:{s:5:\"field\";s:34:\"field_cache_assigned_from_host_nid\";s:5:\"table\";s:45:\"field_revision_field_cache_assigned_from_host\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:34:\"field_cache_assigned_from_host_nid\";}s:10:\"field_name\";s:30:\"field_cache_assigned_from_host\";}s:12:\"relationship\";a:6:{s:7:\"handler\";s:31:\"references_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"field\";s:34:\"field_cache_assigned_from_host_nid\";s:5:\"label\";s:30:\"field_cache_assigned_from_host\";s:10:\"field_name\";s:30:\"field_cache_assigned_from_host\";}}}s:51:\"field_data_field_cache_assigned_from_host_reference\";a:1:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:41:\"field_data_field_cache_assigned_from_host\";a:3:{s:10:\"left_field\";s:34:\"field_cache_assigned_from_host_nid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";}}}}s:55:\"field_revision_field_cache_assigned_from_host_reference\";a:1:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:45:\"field_revision_field_cache_assigned_from_host\";a:3:{s:10:\"left_field\";s:34:\"field_cache_assigned_from_host_nid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";}}}}s:30:\"field_data_field_vm_cache_size\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:30:\"field_data_field_vm_cache_size\";i:1;s:19:\"field_vm_cache_size\";}}}s:19:\"field_vm_cache_size\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"Cache Size\";s:11:\"title short\";s:10:\"Cache Size\";s:4:\"help\";s:32:\"Appears in: node:vm_cache_space.\";s:5:\"field\";a:9:{s:5:\"table\";s:30:\"field_data_field_vm_cache_size\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_vm_cache_size\";s:10:\"real field\";s:25:\"field_vm_cache_size_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_vm_cache_size_value\";i:4;s:26:\"field_vm_cache_size_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:25:\"field_vm_cache_size_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:32:\"Cache Size (field_vm_cache_size)\";s:11:\"title short\";s:10:\"Cache Size\";s:4:\"help\";s:32:\"Appears in: node:vm_cache_space.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_vm_cache_size_value\";s:5:\"table\";s:30:\"field_data_field_vm_cache_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_cache_size_value\";i:1;s:26:\"field_vm_cache_size_format\";}s:10:\"field_name\";s:19:\"field_vm_cache_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_vm_cache_size_value\";s:5:\"table\";s:30:\"field_data_field_vm_cache_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_cache_size_value\";i:1;s:26:\"field_vm_cache_size_format\";}s:10:\"field_name\";s:19:\"field_vm_cache_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_vm_cache_size_value\";s:5:\"table\";s:30:\"field_data_field_vm_cache_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_cache_size_value\";i:1;s:26:\"field_vm_cache_size_format\";}s:10:\"field_name\";s:19:\"field_vm_cache_size\";}}s:26:\"field_vm_cache_size_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:39:\"Cache Size (field_vm_cache_size:format)\";s:11:\"title short\";s:17:\"Cache Size:format\";s:4:\"help\";s:32:\"Appears in: node:vm_cache_space.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_vm_cache_size_format\";s:5:\"table\";s:30:\"field_data_field_vm_cache_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_cache_size_value\";i:1;s:26:\"field_vm_cache_size_format\";}s:10:\"field_name\";s:19:\"field_vm_cache_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_vm_cache_size_format\";s:5:\"table\";s:30:\"field_data_field_vm_cache_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_cache_size_value\";i:1;s:26:\"field_vm_cache_size_format\";}s:10:\"field_name\";s:19:\"field_vm_cache_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_vm_cache_size_format\";s:5:\"table\";s:30:\"field_data_field_vm_cache_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_cache_size_value\";i:1;s:26:\"field_vm_cache_size_format\";}s:10:\"field_name\";s:19:\"field_vm_cache_size\";}}}s:34:\"field_revision_field_vm_cache_size\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:34:\"field_revision_field_vm_cache_size\";i:1;s:31:\"field_vm_cache_size-revision_id\";}}}s:31:\"field_vm_cache_size-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:10:\"Cache Size\";s:11:\"title short\";s:10:\"Cache Size\";s:4:\"help\";s:32:\"Appears in: node:vm_cache_space.\";s:5:\"field\";a:9:{s:5:\"table\";s:34:\"field_revision_field_vm_cache_size\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_vm_cache_size\";s:10:\"real field\";s:37:\"field_vm_cache_size-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_vm_cache_size_value\";i:4;s:26:\"field_vm_cache_size_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:25:\"field_vm_cache_size_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:32:\"Cache Size (field_vm_cache_size)\";s:11:\"title short\";s:10:\"Cache Size\";s:4:\"help\";s:32:\"Appears in: node:vm_cache_space.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_vm_cache_size_value\";s:5:\"table\";s:34:\"field_revision_field_vm_cache_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_cache_size_value\";i:1;s:26:\"field_vm_cache_size_format\";}s:10:\"field_name\";s:19:\"field_vm_cache_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_vm_cache_size_value\";s:5:\"table\";s:34:\"field_revision_field_vm_cache_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_cache_size_value\";i:1;s:26:\"field_vm_cache_size_format\";}s:10:\"field_name\";s:19:\"field_vm_cache_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_vm_cache_size_value\";s:5:\"table\";s:34:\"field_revision_field_vm_cache_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_cache_size_value\";i:1;s:26:\"field_vm_cache_size_format\";}s:10:\"field_name\";s:19:\"field_vm_cache_size\";}}s:26:\"field_vm_cache_size_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:39:\"Cache Size (field_vm_cache_size:format)\";s:11:\"title short\";s:17:\"Cache Size:format\";s:4:\"help\";s:32:\"Appears in: node:vm_cache_space.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_vm_cache_size_format\";s:5:\"table\";s:34:\"field_revision_field_vm_cache_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_cache_size_value\";i:1;s:26:\"field_vm_cache_size_format\";}s:10:\"field_name\";s:19:\"field_vm_cache_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_vm_cache_size_format\";s:5:\"table\";s:34:\"field_revision_field_vm_cache_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_cache_size_value\";i:1;s:26:\"field_vm_cache_size_format\";}s:10:\"field_name\";s:19:\"field_vm_cache_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_vm_cache_size_format\";s:5:\"table\";s:34:\"field_revision_field_vm_cache_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_cache_size_value\";i:1;s:26:\"field_vm_cache_size_format\";}s:10:\"field_name\";s:19:\"field_vm_cache_size\";}}}s:33:\"field_data_field_vdisk_identifier\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:33:\"field_data_field_vdisk_identifier\";i:1;s:22:\"field_vdisk_identifier\";}}}s:22:\"field_vdisk_identifier\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"Identifier\";s:11:\"title short\";s:10:\"Identifier\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:33:\"field_data_field_vdisk_identifier\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_vdisk_identifier\";s:10:\"real field\";s:28:\"field_vdisk_identifier_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_vdisk_identifier_value\";i:4;s:29:\"field_vdisk_identifier_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:28:\"field_vdisk_identifier_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:35:\"Identifier (field_vdisk_identifier)\";s:11:\"title short\";s:10:\"Identifier\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_vdisk_identifier_value\";s:5:\"table\";s:33:\"field_data_field_vdisk_identifier\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_vdisk_identifier_value\";i:1;s:29:\"field_vdisk_identifier_format\";}s:10:\"field_name\";s:22:\"field_vdisk_identifier\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_vdisk_identifier_value\";s:5:\"table\";s:33:\"field_data_field_vdisk_identifier\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_vdisk_identifier_value\";i:1;s:29:\"field_vdisk_identifier_format\";}s:10:\"field_name\";s:22:\"field_vdisk_identifier\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_vdisk_identifier_value\";s:5:\"table\";s:33:\"field_data_field_vdisk_identifier\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_vdisk_identifier_value\";i:1;s:29:\"field_vdisk_identifier_format\";}s:10:\"field_name\";s:22:\"field_vdisk_identifier\";}}s:29:\"field_vdisk_identifier_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:42:\"Identifier (field_vdisk_identifier:format)\";s:11:\"title short\";s:17:\"Identifier:format\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_vdisk_identifier_format\";s:5:\"table\";s:33:\"field_data_field_vdisk_identifier\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_vdisk_identifier_value\";i:1;s:29:\"field_vdisk_identifier_format\";}s:10:\"field_name\";s:22:\"field_vdisk_identifier\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_vdisk_identifier_format\";s:5:\"table\";s:33:\"field_data_field_vdisk_identifier\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_vdisk_identifier_value\";i:1;s:29:\"field_vdisk_identifier_format\";}s:10:\"field_name\";s:22:\"field_vdisk_identifier\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_vdisk_identifier_format\";s:5:\"table\";s:33:\"field_data_field_vdisk_identifier\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_vdisk_identifier_value\";i:1;s:29:\"field_vdisk_identifier_format\";}s:10:\"field_name\";s:22:\"field_vdisk_identifier\";}}}s:37:\"field_revision_field_vdisk_identifier\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:37:\"field_revision_field_vdisk_identifier\";i:1;s:34:\"field_vdisk_identifier-revision_id\";}}}s:34:\"field_vdisk_identifier-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:10:\"Identifier\";s:11:\"title short\";s:10:\"Identifier\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:37:\"field_revision_field_vdisk_identifier\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_vdisk_identifier\";s:10:\"real field\";s:40:\"field_vdisk_identifier-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_vdisk_identifier_value\";i:4;s:29:\"field_vdisk_identifier_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:28:\"field_vdisk_identifier_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:35:\"Identifier (field_vdisk_identifier)\";s:11:\"title short\";s:10:\"Identifier\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_vdisk_identifier_value\";s:5:\"table\";s:37:\"field_revision_field_vdisk_identifier\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_vdisk_identifier_value\";i:1;s:29:\"field_vdisk_identifier_format\";}s:10:\"field_name\";s:22:\"field_vdisk_identifier\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_vdisk_identifier_value\";s:5:\"table\";s:37:\"field_revision_field_vdisk_identifier\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_vdisk_identifier_value\";i:1;s:29:\"field_vdisk_identifier_format\";}s:10:\"field_name\";s:22:\"field_vdisk_identifier\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_vdisk_identifier_value\";s:5:\"table\";s:37:\"field_revision_field_vdisk_identifier\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_vdisk_identifier_value\";i:1;s:29:\"field_vdisk_identifier_format\";}s:10:\"field_name\";s:22:\"field_vdisk_identifier\";}}s:29:\"field_vdisk_identifier_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:42:\"Identifier (field_vdisk_identifier:format)\";s:11:\"title short\";s:17:\"Identifier:format\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_vdisk_identifier_format\";s:5:\"table\";s:37:\"field_revision_field_vdisk_identifier\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_vdisk_identifier_value\";i:1;s:29:\"field_vdisk_identifier_format\";}s:10:\"field_name\";s:22:\"field_vdisk_identifier\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_vdisk_identifier_format\";s:5:\"table\";s:37:\"field_revision_field_vdisk_identifier\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_vdisk_identifier_value\";i:1;s:29:\"field_vdisk_identifier_format\";}s:10:\"field_name\";s:22:\"field_vdisk_identifier\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_vdisk_identifier_format\";s:5:\"table\";s:37:\"field_revision_field_vdisk_identifier\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_vdisk_identifier_value\";i:1;s:29:\"field_vdisk_identifier_format\";}s:10:\"field_name\";s:22:\"field_vdisk_identifier\";}}}s:27:\"field_data_field_cachespace\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:27:\"field_data_field_cachespace\";i:1;s:16:\"field_cachespace\";}}}s:16:\"field_cachespace\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"Cachespace\";s:11:\"title short\";s:10:\"Cachespace\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:27:\"field_data_field_cachespace\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_cachespace\";s:10:\"real field\";s:22:\"field_cachespace_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_cachespace_value\";i:4;s:23:\"field_cachespace_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:22:\"field_cachespace_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:29:\"Cachespace (field_cachespace)\";s:11:\"title short\";s:10:\"Cachespace\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_cachespace_value\";s:5:\"table\";s:27:\"field_data_field_cachespace\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_cachespace_value\";i:1;s:23:\"field_cachespace_format\";}s:10:\"field_name\";s:16:\"field_cachespace\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_cachespace_value\";s:5:\"table\";s:27:\"field_data_field_cachespace\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_cachespace_value\";i:1;s:23:\"field_cachespace_format\";}s:10:\"field_name\";s:16:\"field_cachespace\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_cachespace_value\";s:5:\"table\";s:27:\"field_data_field_cachespace\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_cachespace_value\";i:1;s:23:\"field_cachespace_format\";}s:10:\"field_name\";s:16:\"field_cachespace\";}}s:23:\"field_cachespace_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:36:\"Cachespace (field_cachespace:format)\";s:11:\"title short\";s:17:\"Cachespace:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_cachespace_format\";s:5:\"table\";s:27:\"field_data_field_cachespace\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_cachespace_value\";i:1;s:23:\"field_cachespace_format\";}s:10:\"field_name\";s:16:\"field_cachespace\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_cachespace_format\";s:5:\"table\";s:27:\"field_data_field_cachespace\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_cachespace_value\";i:1;s:23:\"field_cachespace_format\";}s:10:\"field_name\";s:16:\"field_cachespace\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_cachespace_format\";s:5:\"table\";s:27:\"field_data_field_cachespace\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_cachespace_value\";i:1;s:23:\"field_cachespace_format\";}s:10:\"field_name\";s:16:\"field_cachespace\";}}}s:31:\"field_revision_field_cachespace\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:31:\"field_revision_field_cachespace\";i:1;s:28:\"field_cachespace-revision_id\";}}}s:28:\"field_cachespace-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:10:\"Cachespace\";s:11:\"title short\";s:10:\"Cachespace\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:31:\"field_revision_field_cachespace\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_cachespace\";s:10:\"real field\";s:34:\"field_cachespace-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_cachespace_value\";i:4;s:23:\"field_cachespace_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:22:\"field_cachespace_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:29:\"Cachespace (field_cachespace)\";s:11:\"title short\";s:10:\"Cachespace\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_cachespace_value\";s:5:\"table\";s:31:\"field_revision_field_cachespace\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_cachespace_value\";i:1;s:23:\"field_cachespace_format\";}s:10:\"field_name\";s:16:\"field_cachespace\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_cachespace_value\";s:5:\"table\";s:31:\"field_revision_field_cachespace\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_cachespace_value\";i:1;s:23:\"field_cachespace_format\";}s:10:\"field_name\";s:16:\"field_cachespace\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_cachespace_value\";s:5:\"table\";s:31:\"field_revision_field_cachespace\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_cachespace_value\";i:1;s:23:\"field_cachespace_format\";}s:10:\"field_name\";s:16:\"field_cachespace\";}}s:23:\"field_cachespace_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:36:\"Cachespace (field_cachespace:format)\";s:11:\"title short\";s:17:\"Cachespace:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_cachespace_format\";s:5:\"table\";s:31:\"field_revision_field_cachespace\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_cachespace_value\";i:1;s:23:\"field_cachespace_format\";}s:10:\"field_name\";s:16:\"field_cachespace\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_cachespace_format\";s:5:\"table\";s:31:\"field_revision_field_cachespace\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_cachespace_value\";i:1;s:23:\"field_cachespace_format\";}s:10:\"field_name\";s:16:\"field_cachespace\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_cachespace_format\";s:5:\"table\";s:31:\"field_revision_field_cachespace\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_cachespace_value\";i:1;s:23:\"field_cachespace_format\";}s:10:\"field_name\";s:16:\"field_cachespace\";}}}s:27:\"field_data_field_disk_index\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:27:\"field_data_field_disk_index\";i:1;s:16:\"field_disk_index\";}}}s:16:\"field_disk_index\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"Disk Index\";s:11:\"title short\";s:10:\"Disk Index\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:27:\"field_data_field_disk_index\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_disk_index\";s:10:\"real field\";s:22:\"field_disk_index_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_disk_index_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:22:\"field_disk_index_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:29:\"Disk Index (field_disk_index)\";s:11:\"title short\";s:10:\"Disk Index\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_disk_index_value\";s:5:\"table\";s:27:\"field_data_field_disk_index\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:22:\"field_disk_index_value\";}s:10:\"field_name\";s:16:\"field_disk_index\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_disk_index_value\";s:5:\"table\";s:27:\"field_data_field_disk_index\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:22:\"field_disk_index_value\";}s:10:\"field_name\";s:16:\"field_disk_index\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_disk_index_value\";s:5:\"table\";s:27:\"field_data_field_disk_index\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:22:\"field_disk_index_value\";}s:10:\"field_name\";s:16:\"field_disk_index\";}}}s:31:\"field_revision_field_disk_index\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:31:\"field_revision_field_disk_index\";i:1;s:28:\"field_disk_index-revision_id\";}}}s:28:\"field_disk_index-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:10:\"Disk Index\";s:11:\"title short\";s:10:\"Disk Index\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:31:\"field_revision_field_disk_index\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_disk_index\";s:10:\"real field\";s:34:\"field_disk_index-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_disk_index_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:22:\"field_disk_index_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:29:\"Disk Index (field_disk_index)\";s:11:\"title short\";s:10:\"Disk Index\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_disk_index_value\";s:5:\"table\";s:31:\"field_revision_field_disk_index\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:22:\"field_disk_index_value\";}s:10:\"field_name\";s:16:\"field_disk_index\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_disk_index_value\";s:5:\"table\";s:31:\"field_revision_field_disk_index\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:22:\"field_disk_index_value\";}s:10:\"field_name\";s:16:\"field_disk_index\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_disk_index_value\";s:5:\"table\";s:31:\"field_revision_field_disk_index\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:22:\"field_disk_index_value\";}s:10:\"field_name\";s:16:\"field_disk_index\";}}}s:40:\"field_data_field_vdisk_insertion_rate_pc\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:40:\"field_data_field_vdisk_insertion_rate_pc\";i:1;s:29:\"field_vdisk_insertion_rate_pc\";}}}s:29:\"field_vdisk_insertion_rate_pc\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:16:\"Insertion rate %\";s:11:\"title short\";s:16:\"Insertion rate %\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:40:\"field_data_field_vdisk_insertion_rate_pc\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:29:\"field_vdisk_insertion_rate_pc\";s:10:\"real field\";s:35:\"field_vdisk_insertion_rate_pc_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:35:\"field_vdisk_insertion_rate_pc_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:35:\"field_vdisk_insertion_rate_pc_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:48:\"Insertion rate % (field_vdisk_insertion_rate_pc)\";s:11:\"title short\";s:16:\"Insertion rate %\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:35:\"field_vdisk_insertion_rate_pc_value\";s:5:\"table\";s:40:\"field_data_field_vdisk_insertion_rate_pc\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:1:{i:0;s:35:\"field_vdisk_insertion_rate_pc_value\";}s:10:\"field_name\";s:29:\"field_vdisk_insertion_rate_pc\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:35:\"field_vdisk_insertion_rate_pc_value\";s:5:\"table\";s:40:\"field_data_field_vdisk_insertion_rate_pc\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:1:{i:0;s:35:\"field_vdisk_insertion_rate_pc_value\";}s:10:\"field_name\";s:29:\"field_vdisk_insertion_rate_pc\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:35:\"field_vdisk_insertion_rate_pc_value\";s:5:\"table\";s:40:\"field_data_field_vdisk_insertion_rate_pc\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:35:\"field_vdisk_insertion_rate_pc_value\";}s:10:\"field_name\";s:29:\"field_vdisk_insertion_rate_pc\";}}}s:44:\"field_revision_field_vdisk_insertion_rate_pc\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:44:\"field_revision_field_vdisk_insertion_rate_pc\";i:1;s:41:\"field_vdisk_insertion_rate_pc-revision_id\";}}}s:41:\"field_vdisk_insertion_rate_pc-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:16:\"Insertion rate %\";s:11:\"title short\";s:16:\"Insertion rate %\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:44:\"field_revision_field_vdisk_insertion_rate_pc\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:29:\"field_vdisk_insertion_rate_pc\";s:10:\"real field\";s:47:\"field_vdisk_insertion_rate_pc-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:35:\"field_vdisk_insertion_rate_pc_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:35:\"field_vdisk_insertion_rate_pc_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:48:\"Insertion rate % (field_vdisk_insertion_rate_pc)\";s:11:\"title short\";s:16:\"Insertion rate %\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:35:\"field_vdisk_insertion_rate_pc_value\";s:5:\"table\";s:44:\"field_revision_field_vdisk_insertion_rate_pc\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:1:{i:0;s:35:\"field_vdisk_insertion_rate_pc_value\";}s:10:\"field_name\";s:29:\"field_vdisk_insertion_rate_pc\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:35:\"field_vdisk_insertion_rate_pc_value\";s:5:\"table\";s:44:\"field_revision_field_vdisk_insertion_rate_pc\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:1:{i:0;s:35:\"field_vdisk_insertion_rate_pc_value\";}s:10:\"field_name\";s:29:\"field_vdisk_insertion_rate_pc\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:35:\"field_vdisk_insertion_rate_pc_value\";s:5:\"table\";s:44:\"field_revision_field_vdisk_insertion_rate_pc\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:35:\"field_vdisk_insertion_rate_pc_value\";}s:10:\"field_name\";s:29:\"field_vdisk_insertion_rate_pc\";}}}s:36:\"field_data_field_vdisk_population_pc\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:36:\"field_data_field_vdisk_population_pc\";i:1;s:25:\"field_vdisk_population_pc\";}}}s:25:\"field_vdisk_population_pc\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:12:\"Population %\";s:11:\"title short\";s:12:\"Population %\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:36:\"field_data_field_vdisk_population_pc\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:25:\"field_vdisk_population_pc\";s:10:\"real field\";s:31:\"field_vdisk_population_pc_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:31:\"field_vdisk_population_pc_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:31:\"field_vdisk_population_pc_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:40:\"Population % (field_vdisk_population_pc)\";s:11:\"title short\";s:12:\"Population %\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:31:\"field_vdisk_population_pc_value\";s:5:\"table\";s:36:\"field_data_field_vdisk_population_pc\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_population_pc_value\";}s:10:\"field_name\";s:25:\"field_vdisk_population_pc\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:31:\"field_vdisk_population_pc_value\";s:5:\"table\";s:36:\"field_data_field_vdisk_population_pc\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_population_pc_value\";}s:10:\"field_name\";s:25:\"field_vdisk_population_pc\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:31:\"field_vdisk_population_pc_value\";s:5:\"table\";s:36:\"field_data_field_vdisk_population_pc\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_population_pc_value\";}s:10:\"field_name\";s:25:\"field_vdisk_population_pc\";}}}s:40:\"field_revision_field_vdisk_population_pc\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:40:\"field_revision_field_vdisk_population_pc\";i:1;s:37:\"field_vdisk_population_pc-revision_id\";}}}s:37:\"field_vdisk_population_pc-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:12:\"Population %\";s:11:\"title short\";s:12:\"Population %\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:40:\"field_revision_field_vdisk_population_pc\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:25:\"field_vdisk_population_pc\";s:10:\"real field\";s:43:\"field_vdisk_population_pc-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:31:\"field_vdisk_population_pc_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:31:\"field_vdisk_population_pc_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:40:\"Population % (field_vdisk_population_pc)\";s:11:\"title short\";s:12:\"Population %\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:31:\"field_vdisk_population_pc_value\";s:5:\"table\";s:40:\"field_revision_field_vdisk_population_pc\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_population_pc_value\";}s:10:\"field_name\";s:25:\"field_vdisk_population_pc\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:31:\"field_vdisk_population_pc_value\";s:5:\"table\";s:40:\"field_revision_field_vdisk_population_pc\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_population_pc_value\";}s:10:\"field_name\";s:25:\"field_vdisk_population_pc\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:31:\"field_vdisk_population_pc_value\";s:5:\"table\";s:40:\"field_revision_field_vdisk_population_pc\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_population_pc_value\";}s:10:\"field_name\";s:25:\"field_vdisk_population_pc\";}}}s:26:\"field_data_field_timestamp\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:26:\"field_data_field_timestamp\";i:1;s:15:\"field_timestamp\";}}}s:15:\"field_timestamp\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:9:\"Timestamp\";s:11:\"title short\";s:9:\"Timestamp\";s:4:\"help\";s:48:\"Appears in: node:vdisk_metrics, node:vm_metrics.\";s:5:\"field\";a:10:{s:5:\"table\";s:26:\"field_data_field_timestamp\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:15:\"field_timestamp\";s:10:\"real field\";s:21:\"field_timestamp_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:21:\"field_timestamp_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;s:7:\"is date\";b:1;}}s:21:\"field_timestamp_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:27:\"Timestamp (field_timestamp)\";s:11:\"title short\";s:9:\"Timestamp\";s:4:\"help\";s:48:\"Appears in: node:vdisk_metrics, node:vm_metrics.\";s:8:\"argument\";a:7:{s:5:\"field\";s:21:\"field_timestamp_value\";s:5:\"table\";s:26:\"field_data_field_timestamp\";s:7:\"handler\";s:34:\"date_views_argument_handler_simple\";s:17:\"additional fields\";a:1:{i:0;s:21:\"field_timestamp_value\";}s:10:\"field_name\";s:15:\"field_timestamp\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}s:6:\"filter\";a:8:{s:5:\"field\";s:21:\"field_timestamp_value\";s:5:\"table\";s:26:\"field_data_field_timestamp\";s:7:\"handler\";s:32:\"date_views_filter_handler_simple\";s:17:\"additional fields\";a:1:{i:0;s:21:\"field_timestamp_value\";}s:10:\"field_name\";s:15:\"field_timestamp\";s:11:\"allow empty\";b:1;s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:21:\"field_timestamp_value\";s:5:\"table\";s:26:\"field_data_field_timestamp\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:21:\"field_timestamp_value\";}s:10:\"field_name\";s:15:\"field_timestamp\";s:7:\"is date\";b:1;}}}s:30:\"field_revision_field_timestamp\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:30:\"field_revision_field_timestamp\";i:1;s:27:\"field_timestamp-revision_id\";}}}s:27:\"field_timestamp-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:9:\"Timestamp\";s:11:\"title short\";s:9:\"Timestamp\";s:4:\"help\";s:48:\"Appears in: node:vdisk_metrics, node:vm_metrics.\";s:5:\"field\";a:10:{s:5:\"table\";s:30:\"field_revision_field_timestamp\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:15:\"field_timestamp\";s:10:\"real field\";s:33:\"field_timestamp-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:21:\"field_timestamp_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;s:7:\"is date\";b:1;}}s:21:\"field_timestamp_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:27:\"Timestamp (field_timestamp)\";s:11:\"title short\";s:9:\"Timestamp\";s:4:\"help\";s:48:\"Appears in: node:vdisk_metrics, node:vm_metrics.\";s:8:\"argument\";a:7:{s:5:\"field\";s:21:\"field_timestamp_value\";s:5:\"table\";s:30:\"field_revision_field_timestamp\";s:7:\"handler\";s:34:\"date_views_argument_handler_simple\";s:17:\"additional fields\";a:1:{i:0;s:21:\"field_timestamp_value\";}s:10:\"field_name\";s:15:\"field_timestamp\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}s:6:\"filter\";a:8:{s:5:\"field\";s:21:\"field_timestamp_value\";s:5:\"table\";s:30:\"field_revision_field_timestamp\";s:7:\"handler\";s:32:\"date_views_filter_handler_simple\";s:17:\"additional fields\";a:1:{i:0;s:21:\"field_timestamp_value\";}s:10:\"field_name\";s:15:\"field_timestamp\";s:11:\"allow empty\";b:1;s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:21:\"field_timestamp_value\";s:5:\"table\";s:30:\"field_revision_field_timestamp\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:21:\"field_timestamp_value\";}s:10:\"field_name\";s:15:\"field_timestamp\";s:7:\"is date\";b:1;}}}s:35:\"field_data_field_vdisk_write_blocks\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:35:\"field_data_field_vdisk_write_blocks\";i:1;s:24:\"field_vdisk_write_blocks\";}}}s:24:\"field_vdisk_write_blocks\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:12:\"Write blocks\";s:11:\"title short\";s:12:\"Write blocks\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:35:\"field_data_field_vdisk_write_blocks\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:24:\"field_vdisk_write_blocks\";s:10:\"real field\";s:30:\"field_vdisk_write_blocks_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:30:\"field_vdisk_write_blocks_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:30:\"field_vdisk_write_blocks_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:39:\"Write blocks (field_vdisk_write_blocks)\";s:11:\"title short\";s:12:\"Write blocks\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:30:\"field_vdisk_write_blocks_value\";s:5:\"table\";s:35:\"field_data_field_vdisk_write_blocks\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:30:\"field_vdisk_write_blocks_value\";}s:10:\"field_name\";s:24:\"field_vdisk_write_blocks\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:30:\"field_vdisk_write_blocks_value\";s:5:\"table\";s:35:\"field_data_field_vdisk_write_blocks\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:30:\"field_vdisk_write_blocks_value\";}s:10:\"field_name\";s:24:\"field_vdisk_write_blocks\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:30:\"field_vdisk_write_blocks_value\";s:5:\"table\";s:35:\"field_data_field_vdisk_write_blocks\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:30:\"field_vdisk_write_blocks_value\";}s:10:\"field_name\";s:24:\"field_vdisk_write_blocks\";}}}s:39:\"field_revision_field_vdisk_write_blocks\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:39:\"field_revision_field_vdisk_write_blocks\";i:1;s:36:\"field_vdisk_write_blocks-revision_id\";}}}s:36:\"field_vdisk_write_blocks-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:12:\"Write blocks\";s:11:\"title short\";s:12:\"Write blocks\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:39:\"field_revision_field_vdisk_write_blocks\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:24:\"field_vdisk_write_blocks\";s:10:\"real field\";s:42:\"field_vdisk_write_blocks-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:30:\"field_vdisk_write_blocks_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:30:\"field_vdisk_write_blocks_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:39:\"Write blocks (field_vdisk_write_blocks)\";s:11:\"title short\";s:12:\"Write blocks\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:30:\"field_vdisk_write_blocks_value\";s:5:\"table\";s:39:\"field_revision_field_vdisk_write_blocks\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:30:\"field_vdisk_write_blocks_value\";}s:10:\"field_name\";s:24:\"field_vdisk_write_blocks\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:30:\"field_vdisk_write_blocks_value\";s:5:\"table\";s:39:\"field_revision_field_vdisk_write_blocks\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:30:\"field_vdisk_write_blocks_value\";}s:10:\"field_name\";s:24:\"field_vdisk_write_blocks\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:30:\"field_vdisk_write_blocks_value\";s:5:\"table\";s:39:\"field_revision_field_vdisk_write_blocks\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:30:\"field_vdisk_write_blocks_value\";}s:10:\"field_name\";s:24:\"field_vdisk_write_blocks\";}}}s:33:\"field_data_field_vdisk_insertions\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:33:\"field_data_field_vdisk_insertions\";i:1;s:22:\"field_vdisk_insertions\";}}}s:22:\"field_vdisk_insertions\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"Insertions\";s:11:\"title short\";s:10:\"Insertions\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:33:\"field_data_field_vdisk_insertions\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_vdisk_insertions\";s:10:\"real field\";s:28:\"field_vdisk_insertions_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_vdisk_insertions_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:28:\"field_vdisk_insertions_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:35:\"Insertions (field_vdisk_insertions)\";s:11:\"title short\";s:10:\"Insertions\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_vdisk_insertions_value\";s:5:\"table\";s:33:\"field_data_field_vdisk_insertions\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vdisk_insertions_value\";}s:10:\"field_name\";s:22:\"field_vdisk_insertions\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_vdisk_insertions_value\";s:5:\"table\";s:33:\"field_data_field_vdisk_insertions\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vdisk_insertions_value\";}s:10:\"field_name\";s:22:\"field_vdisk_insertions\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_vdisk_insertions_value\";s:5:\"table\";s:33:\"field_data_field_vdisk_insertions\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vdisk_insertions_value\";}s:10:\"field_name\";s:22:\"field_vdisk_insertions\";}}}s:37:\"field_revision_field_vdisk_insertions\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:37:\"field_revision_field_vdisk_insertions\";i:1;s:34:\"field_vdisk_insertions-revision_id\";}}}s:34:\"field_vdisk_insertions-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:10:\"Insertions\";s:11:\"title short\";s:10:\"Insertions\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:37:\"field_revision_field_vdisk_insertions\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_vdisk_insertions\";s:10:\"real field\";s:40:\"field_vdisk_insertions-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_vdisk_insertions_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:28:\"field_vdisk_insertions_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:35:\"Insertions (field_vdisk_insertions)\";s:11:\"title short\";s:10:\"Insertions\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_vdisk_insertions_value\";s:5:\"table\";s:37:\"field_revision_field_vdisk_insertions\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vdisk_insertions_value\";}s:10:\"field_name\";s:22:\"field_vdisk_insertions\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_vdisk_insertions_value\";s:5:\"table\";s:37:\"field_revision_field_vdisk_insertions\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vdisk_insertions_value\";}s:10:\"field_name\";s:22:\"field_vdisk_insertions\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_vdisk_insertions_value\";s:5:\"table\";s:37:\"field_revision_field_vdisk_insertions\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vdisk_insertions_value\";}s:10:\"field_name\";s:22:\"field_vdisk_insertions\";}}}s:36:\"field_data_field_vdisk_usable_blocks\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:36:\"field_data_field_vdisk_usable_blocks\";i:1;s:25:\"field_vdisk_usable_blocks\";}}}s:25:\"field_vdisk_usable_blocks\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:13:\"Usable blocks\";s:11:\"title short\";s:13:\"Usable blocks\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:36:\"field_data_field_vdisk_usable_blocks\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:25:\"field_vdisk_usable_blocks\";s:10:\"real field\";s:31:\"field_vdisk_usable_blocks_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:31:\"field_vdisk_usable_blocks_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:31:\"field_vdisk_usable_blocks_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:41:\"Usable blocks (field_vdisk_usable_blocks)\";s:11:\"title short\";s:13:\"Usable blocks\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:31:\"field_vdisk_usable_blocks_value\";s:5:\"table\";s:36:\"field_data_field_vdisk_usable_blocks\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_usable_blocks_value\";}s:10:\"field_name\";s:25:\"field_vdisk_usable_blocks\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:31:\"field_vdisk_usable_blocks_value\";s:5:\"table\";s:36:\"field_data_field_vdisk_usable_blocks\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_usable_blocks_value\";}s:10:\"field_name\";s:25:\"field_vdisk_usable_blocks\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:31:\"field_vdisk_usable_blocks_value\";s:5:\"table\";s:36:\"field_data_field_vdisk_usable_blocks\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_usable_blocks_value\";}s:10:\"field_name\";s:25:\"field_vdisk_usable_blocks\";}}}s:40:\"field_revision_field_vdisk_usable_blocks\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:40:\"field_revision_field_vdisk_usable_blocks\";i:1;s:37:\"field_vdisk_usable_blocks-revision_id\";}}}s:37:\"field_vdisk_usable_blocks-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:13:\"Usable blocks\";s:11:\"title short\";s:13:\"Usable blocks\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:40:\"field_revision_field_vdisk_usable_blocks\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:25:\"field_vdisk_usable_blocks\";s:10:\"real field\";s:43:\"field_vdisk_usable_blocks-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:31:\"field_vdisk_usable_blocks_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:31:\"field_vdisk_usable_blocks_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:41:\"Usable blocks (field_vdisk_usable_blocks)\";s:11:\"title short\";s:13:\"Usable blocks\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:31:\"field_vdisk_usable_blocks_value\";s:5:\"table\";s:40:\"field_revision_field_vdisk_usable_blocks\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_usable_blocks_value\";}s:10:\"field_name\";s:25:\"field_vdisk_usable_blocks\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:31:\"field_vdisk_usable_blocks_value\";s:5:\"table\";s:40:\"field_revision_field_vdisk_usable_blocks\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_usable_blocks_value\";}s:10:\"field_name\";s:25:\"field_vdisk_usable_blocks\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:31:\"field_vdisk_usable_blocks_value\";s:5:\"table\";s:40:\"field_revision_field_vdisk_usable_blocks\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_usable_blocks_value\";}s:10:\"field_name\";s:25:\"field_vdisk_usable_blocks\";}}}s:33:\"field_data_field_vdisk_population\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:33:\"field_data_field_vdisk_population\";i:1;s:22:\"field_vdisk_population\";}}}s:22:\"field_vdisk_population\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"Population\";s:11:\"title short\";s:10:\"Population\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:33:\"field_data_field_vdisk_population\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_vdisk_population\";s:10:\"real field\";s:28:\"field_vdisk_population_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_vdisk_population_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:28:\"field_vdisk_population_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:35:\"Population (field_vdisk_population)\";s:11:\"title short\";s:10:\"Population\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_vdisk_population_value\";s:5:\"table\";s:33:\"field_data_field_vdisk_population\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vdisk_population_value\";}s:10:\"field_name\";s:22:\"field_vdisk_population\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_vdisk_population_value\";s:5:\"table\";s:33:\"field_data_field_vdisk_population\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vdisk_population_value\";}s:10:\"field_name\";s:22:\"field_vdisk_population\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_vdisk_population_value\";s:5:\"table\";s:33:\"field_data_field_vdisk_population\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vdisk_population_value\";}s:10:\"field_name\";s:22:\"field_vdisk_population\";}}}s:37:\"field_revision_field_vdisk_population\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:37:\"field_revision_field_vdisk_population\";i:1;s:34:\"field_vdisk_population-revision_id\";}}}s:34:\"field_vdisk_population-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:10:\"Population\";s:11:\"title short\";s:10:\"Population\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:37:\"field_revision_field_vdisk_population\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_vdisk_population\";s:10:\"real field\";s:40:\"field_vdisk_population-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_vdisk_population_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:28:\"field_vdisk_population_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:35:\"Population (field_vdisk_population)\";s:11:\"title short\";s:10:\"Population\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_vdisk_population_value\";s:5:\"table\";s:37:\"field_revision_field_vdisk_population\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vdisk_population_value\";}s:10:\"field_name\";s:22:\"field_vdisk_population\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_vdisk_population_value\";s:5:\"table\";s:37:\"field_revision_field_vdisk_population\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vdisk_population_value\";}s:10:\"field_name\";s:22:\"field_vdisk_population\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_vdisk_population_value\";s:5:\"table\";s:37:\"field_revision_field_vdisk_population\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vdisk_population_value\";}s:10:\"field_name\";s:22:\"field_vdisk_population\";}}}s:36:\"field_data_field_vdisk_cache_latency\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:36:\"field_data_field_vdisk_cache_latency\";i:1;s:25:\"field_vdisk_cache_latency\";}}}s:25:\"field_vdisk_cache_latency\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:13:\"Cache latency\";s:11:\"title short\";s:13:\"Cache latency\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:36:\"field_data_field_vdisk_cache_latency\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:25:\"field_vdisk_cache_latency\";s:10:\"real field\";s:31:\"field_vdisk_cache_latency_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:31:\"field_vdisk_cache_latency_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:31:\"field_vdisk_cache_latency_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:41:\"Cache latency (field_vdisk_cache_latency)\";s:11:\"title short\";s:13:\"Cache latency\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:31:\"field_vdisk_cache_latency_value\";s:5:\"table\";s:36:\"field_data_field_vdisk_cache_latency\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_cache_latency_value\";}s:10:\"field_name\";s:25:\"field_vdisk_cache_latency\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:31:\"field_vdisk_cache_latency_value\";s:5:\"table\";s:36:\"field_data_field_vdisk_cache_latency\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_cache_latency_value\";}s:10:\"field_name\";s:25:\"field_vdisk_cache_latency\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:31:\"field_vdisk_cache_latency_value\";s:5:\"table\";s:36:\"field_data_field_vdisk_cache_latency\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_cache_latency_value\";}s:10:\"field_name\";s:25:\"field_vdisk_cache_latency\";}}}s:40:\"field_revision_field_vdisk_cache_latency\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:40:\"field_revision_field_vdisk_cache_latency\";i:1;s:37:\"field_vdisk_cache_latency-revision_id\";}}}s:37:\"field_vdisk_cache_latency-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:13:\"Cache latency\";s:11:\"title short\";s:13:\"Cache latency\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:40:\"field_revision_field_vdisk_cache_latency\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:25:\"field_vdisk_cache_latency\";s:10:\"real field\";s:43:\"field_vdisk_cache_latency-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:31:\"field_vdisk_cache_latency_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:31:\"field_vdisk_cache_latency_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:41:\"Cache latency (field_vdisk_cache_latency)\";s:11:\"title short\";s:13:\"Cache latency\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:31:\"field_vdisk_cache_latency_value\";s:5:\"table\";s:40:\"field_revision_field_vdisk_cache_latency\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_cache_latency_value\";}s:10:\"field_name\";s:25:\"field_vdisk_cache_latency\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:31:\"field_vdisk_cache_latency_value\";s:5:\"table\";s:40:\"field_revision_field_vdisk_cache_latency\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_cache_latency_value\";}s:10:\"field_name\";s:25:\"field_vdisk_cache_latency\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:31:\"field_vdisk_cache_latency_value\";s:5:\"table\";s:40:\"field_revision_field_vdisk_cache_latency\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_cache_latency_value\";}s:10:\"field_name\";s:25:\"field_vdisk_cache_latency\";}}}s:34:\"field_data_field_vdisk_read_blocks\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:34:\"field_data_field_vdisk_read_blocks\";i:1;s:23:\"field_vdisk_read_blocks\";}}}s:23:\"field_vdisk_read_blocks\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:11:\"Read blocks\";s:11:\"title short\";s:11:\"Read blocks\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:34:\"field_data_field_vdisk_read_blocks\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:23:\"field_vdisk_read_blocks\";s:10:\"real field\";s:29:\"field_vdisk_read_blocks_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:29:\"field_vdisk_read_blocks_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:29:\"field_vdisk_read_blocks_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:37:\"Read blocks (field_vdisk_read_blocks)\";s:11:\"title short\";s:11:\"Read blocks\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_vdisk_read_blocks_value\";s:5:\"table\";s:34:\"field_data_field_vdisk_read_blocks\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:29:\"field_vdisk_read_blocks_value\";}s:10:\"field_name\";s:23:\"field_vdisk_read_blocks\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_vdisk_read_blocks_value\";s:5:\"table\";s:34:\"field_data_field_vdisk_read_blocks\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:29:\"field_vdisk_read_blocks_value\";}s:10:\"field_name\";s:23:\"field_vdisk_read_blocks\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_vdisk_read_blocks_value\";s:5:\"table\";s:34:\"field_data_field_vdisk_read_blocks\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:29:\"field_vdisk_read_blocks_value\";}s:10:\"field_name\";s:23:\"field_vdisk_read_blocks\";}}}s:38:\"field_revision_field_vdisk_read_blocks\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:38:\"field_revision_field_vdisk_read_blocks\";i:1;s:35:\"field_vdisk_read_blocks-revision_id\";}}}s:35:\"field_vdisk_read_blocks-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:11:\"Read blocks\";s:11:\"title short\";s:11:\"Read blocks\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:38:\"field_revision_field_vdisk_read_blocks\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:23:\"field_vdisk_read_blocks\";s:10:\"real field\";s:41:\"field_vdisk_read_blocks-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:29:\"field_vdisk_read_blocks_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:29:\"field_vdisk_read_blocks_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:37:\"Read blocks (field_vdisk_read_blocks)\";s:11:\"title short\";s:11:\"Read blocks\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_vdisk_read_blocks_value\";s:5:\"table\";s:38:\"field_revision_field_vdisk_read_blocks\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:29:\"field_vdisk_read_blocks_value\";}s:10:\"field_name\";s:23:\"field_vdisk_read_blocks\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_vdisk_read_blocks_value\";s:5:\"table\";s:38:\"field_revision_field_vdisk_read_blocks\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:29:\"field_vdisk_read_blocks_value\";}s:10:\"field_name\";s:23:\"field_vdisk_read_blocks\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_vdisk_read_blocks_value\";s:5:\"table\";s:38:\"field_revision_field_vdisk_read_blocks\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:29:\"field_vdisk_read_blocks_value\";}s:10:\"field_name\";s:23:\"field_vdisk_read_blocks\";}}}s:27:\"field_data_field_vdisk_hits\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:27:\"field_data_field_vdisk_hits\";i:1;s:16:\"field_vdisk_hits\";}}}s:16:\"field_vdisk_hits\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:4:\"Hits\";s:11:\"title short\";s:4:\"Hits\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:27:\"field_data_field_vdisk_hits\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_vdisk_hits\";s:10:\"real field\";s:22:\"field_vdisk_hits_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_vdisk_hits_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:22:\"field_vdisk_hits_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:23:\"Hits (field_vdisk_hits)\";s:11:\"title short\";s:4:\"Hits\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_vdisk_hits_value\";s:5:\"table\";s:27:\"field_data_field_vdisk_hits\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:22:\"field_vdisk_hits_value\";}s:10:\"field_name\";s:16:\"field_vdisk_hits\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_vdisk_hits_value\";s:5:\"table\";s:27:\"field_data_field_vdisk_hits\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:22:\"field_vdisk_hits_value\";}s:10:\"field_name\";s:16:\"field_vdisk_hits\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_vdisk_hits_value\";s:5:\"table\";s:27:\"field_data_field_vdisk_hits\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:22:\"field_vdisk_hits_value\";}s:10:\"field_name\";s:16:\"field_vdisk_hits\";}}}s:31:\"field_revision_field_vdisk_hits\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:31:\"field_revision_field_vdisk_hits\";i:1;s:28:\"field_vdisk_hits-revision_id\";}}}s:28:\"field_vdisk_hits-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:4:\"Hits\";s:11:\"title short\";s:4:\"Hits\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:31:\"field_revision_field_vdisk_hits\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_vdisk_hits\";s:10:\"real field\";s:34:\"field_vdisk_hits-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_vdisk_hits_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:22:\"field_vdisk_hits_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:23:\"Hits (field_vdisk_hits)\";s:11:\"title short\";s:4:\"Hits\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_vdisk_hits_value\";s:5:\"table\";s:31:\"field_revision_field_vdisk_hits\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:22:\"field_vdisk_hits_value\";}s:10:\"field_name\";s:16:\"field_vdisk_hits\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_vdisk_hits_value\";s:5:\"table\";s:31:\"field_revision_field_vdisk_hits\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:22:\"field_vdisk_hits_value\";}s:10:\"field_name\";s:16:\"field_vdisk_hits\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_vdisk_hits_value\";s:5:\"table\";s:31:\"field_revision_field_vdisk_hits\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:22:\"field_vdisk_hits_value\";}s:10:\"field_name\";s:16:\"field_vdisk_hits\";}}}s:32:\"field_data_field_vdisk_write_ops\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:32:\"field_data_field_vdisk_write_ops\";i:1;s:21:\"field_vdisk_write_ops\";}}}s:21:\"field_vdisk_write_ops\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:9:\"Write ops\";s:11:\"title short\";s:9:\"Write ops\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:32:\"field_data_field_vdisk_write_ops\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:21:\"field_vdisk_write_ops\";s:10:\"real field\";s:27:\"field_vdisk_write_ops_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:27:\"field_vdisk_write_ops_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:27:\"field_vdisk_write_ops_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:33:\"Write ops (field_vdisk_write_ops)\";s:11:\"title short\";s:9:\"Write ops\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:27:\"field_vdisk_write_ops_value\";s:5:\"table\";s:32:\"field_data_field_vdisk_write_ops\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_vdisk_write_ops_value\";}s:10:\"field_name\";s:21:\"field_vdisk_write_ops\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:27:\"field_vdisk_write_ops_value\";s:5:\"table\";s:32:\"field_data_field_vdisk_write_ops\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_vdisk_write_ops_value\";}s:10:\"field_name\";s:21:\"field_vdisk_write_ops\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:27:\"field_vdisk_write_ops_value\";s:5:\"table\";s:32:\"field_data_field_vdisk_write_ops\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_vdisk_write_ops_value\";}s:10:\"field_name\";s:21:\"field_vdisk_write_ops\";}}}s:36:\"field_revision_field_vdisk_write_ops\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:36:\"field_revision_field_vdisk_write_ops\";i:1;s:33:\"field_vdisk_write_ops-revision_id\";}}}s:33:\"field_vdisk_write_ops-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:9:\"Write ops\";s:11:\"title short\";s:9:\"Write ops\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:36:\"field_revision_field_vdisk_write_ops\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:21:\"field_vdisk_write_ops\";s:10:\"real field\";s:39:\"field_vdisk_write_ops-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:27:\"field_vdisk_write_ops_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:27:\"field_vdisk_write_ops_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:33:\"Write ops (field_vdisk_write_ops)\";s:11:\"title short\";s:9:\"Write ops\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:27:\"field_vdisk_write_ops_value\";s:5:\"table\";s:36:\"field_revision_field_vdisk_write_ops\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_vdisk_write_ops_value\";}s:10:\"field_name\";s:21:\"field_vdisk_write_ops\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:27:\"field_vdisk_write_ops_value\";s:5:\"table\";s:36:\"field_revision_field_vdisk_write_ops\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_vdisk_write_ops_value\";}s:10:\"field_name\";s:21:\"field_vdisk_write_ops\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:27:\"field_vdisk_write_ops_value\";s:5:\"table\";s:36:\"field_revision_field_vdisk_write_ops\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_vdisk_write_ops_value\";}s:10:\"field_name\";s:21:\"field_vdisk_write_ops\";}}}s:31:\"field_data_field_vdisk_read_ops\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:31:\"field_data_field_vdisk_read_ops\";i:1;s:20:\"field_vdisk_read_ops\";}}}s:20:\"field_vdisk_read_ops\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:8:\"Read ops\";s:11:\"title short\";s:8:\"Read ops\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:31:\"field_data_field_vdisk_read_ops\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:20:\"field_vdisk_read_ops\";s:10:\"real field\";s:26:\"field_vdisk_read_ops_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:26:\"field_vdisk_read_ops_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:26:\"field_vdisk_read_ops_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:31:\"Read ops (field_vdisk_read_ops)\";s:11:\"title short\";s:8:\"Read ops\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_vdisk_read_ops_value\";s:5:\"table\";s:31:\"field_data_field_vdisk_read_ops\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vdisk_read_ops_value\";}s:10:\"field_name\";s:20:\"field_vdisk_read_ops\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_vdisk_read_ops_value\";s:5:\"table\";s:31:\"field_data_field_vdisk_read_ops\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vdisk_read_ops_value\";}s:10:\"field_name\";s:20:\"field_vdisk_read_ops\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_vdisk_read_ops_value\";s:5:\"table\";s:31:\"field_data_field_vdisk_read_ops\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vdisk_read_ops_value\";}s:10:\"field_name\";s:20:\"field_vdisk_read_ops\";}}}s:35:\"field_revision_field_vdisk_read_ops\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:35:\"field_revision_field_vdisk_read_ops\";i:1;s:32:\"field_vdisk_read_ops-revision_id\";}}}s:32:\"field_vdisk_read_ops-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:8:\"Read ops\";s:11:\"title short\";s:8:\"Read ops\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:35:\"field_revision_field_vdisk_read_ops\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:20:\"field_vdisk_read_ops\";s:10:\"real field\";s:38:\"field_vdisk_read_ops-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:26:\"field_vdisk_read_ops_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:26:\"field_vdisk_read_ops_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:31:\"Read ops (field_vdisk_read_ops)\";s:11:\"title short\";s:8:\"Read ops\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_vdisk_read_ops_value\";s:5:\"table\";s:35:\"field_revision_field_vdisk_read_ops\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vdisk_read_ops_value\";}s:10:\"field_name\";s:20:\"field_vdisk_read_ops\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_vdisk_read_ops_value\";s:5:\"table\";s:35:\"field_revision_field_vdisk_read_ops\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vdisk_read_ops_value\";}s:10:\"field_name\";s:20:\"field_vdisk_read_ops\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_vdisk_read_ops_value\";s:5:\"table\";s:35:\"field_revision_field_vdisk_read_ops\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vdisk_read_ops_value\";}s:10:\"field_name\";s:20:\"field_vdisk_read_ops\";}}}s:36:\"field_data_field_vdisk_write_latency\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:36:\"field_data_field_vdisk_write_latency\";i:1;s:25:\"field_vdisk_write_latency\";}}}s:25:\"field_vdisk_write_latency\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:13:\"Write latency\";s:11:\"title short\";s:13:\"Write latency\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:36:\"field_data_field_vdisk_write_latency\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:25:\"field_vdisk_write_latency\";s:10:\"real field\";s:31:\"field_vdisk_write_latency_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:31:\"field_vdisk_write_latency_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:31:\"field_vdisk_write_latency_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:41:\"Write latency (field_vdisk_write_latency)\";s:11:\"title short\";s:13:\"Write latency\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:31:\"field_vdisk_write_latency_value\";s:5:\"table\";s:36:\"field_data_field_vdisk_write_latency\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_write_latency_value\";}s:10:\"field_name\";s:25:\"field_vdisk_write_latency\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:31:\"field_vdisk_write_latency_value\";s:5:\"table\";s:36:\"field_data_field_vdisk_write_latency\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_write_latency_value\";}s:10:\"field_name\";s:25:\"field_vdisk_write_latency\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:31:\"field_vdisk_write_latency_value\";s:5:\"table\";s:36:\"field_data_field_vdisk_write_latency\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_write_latency_value\";}s:10:\"field_name\";s:25:\"field_vdisk_write_latency\";}}}s:40:\"field_revision_field_vdisk_write_latency\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:40:\"field_revision_field_vdisk_write_latency\";i:1;s:37:\"field_vdisk_write_latency-revision_id\";}}}s:37:\"field_vdisk_write_latency-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:13:\"Write latency\";s:11:\"title short\";s:13:\"Write latency\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:40:\"field_revision_field_vdisk_write_latency\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:25:\"field_vdisk_write_latency\";s:10:\"real field\";s:43:\"field_vdisk_write_latency-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:31:\"field_vdisk_write_latency_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:31:\"field_vdisk_write_latency_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:41:\"Write latency (field_vdisk_write_latency)\";s:11:\"title short\";s:13:\"Write latency\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:31:\"field_vdisk_write_latency_value\";s:5:\"table\";s:40:\"field_revision_field_vdisk_write_latency\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_write_latency_value\";}s:10:\"field_name\";s:25:\"field_vdisk_write_latency\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:31:\"field_vdisk_write_latency_value\";s:5:\"table\";s:40:\"field_revision_field_vdisk_write_latency\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_write_latency_value\";}s:10:\"field_name\";s:25:\"field_vdisk_write_latency\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:31:\"field_vdisk_write_latency_value\";s:5:\"table\";s:40:\"field_revision_field_vdisk_write_latency\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_vdisk_write_latency_value\";}s:10:\"field_name\";s:25:\"field_vdisk_write_latency\";}}}s:35:\"field_data_field_vdisk_read_latency\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:35:\"field_data_field_vdisk_read_latency\";i:1;s:24:\"field_vdisk_read_latency\";}}}s:24:\"field_vdisk_read_latency\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:12:\"Read latency\";s:11:\"title short\";s:12:\"Read latency\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:35:\"field_data_field_vdisk_read_latency\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:24:\"field_vdisk_read_latency\";s:10:\"real field\";s:30:\"field_vdisk_read_latency_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:30:\"field_vdisk_read_latency_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:30:\"field_vdisk_read_latency_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:39:\"Read latency (field_vdisk_read_latency)\";s:11:\"title short\";s:12:\"Read latency\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:30:\"field_vdisk_read_latency_value\";s:5:\"table\";s:35:\"field_data_field_vdisk_read_latency\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:30:\"field_vdisk_read_latency_value\";}s:10:\"field_name\";s:24:\"field_vdisk_read_latency\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:30:\"field_vdisk_read_latency_value\";s:5:\"table\";s:35:\"field_data_field_vdisk_read_latency\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:30:\"field_vdisk_read_latency_value\";}s:10:\"field_name\";s:24:\"field_vdisk_read_latency\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:30:\"field_vdisk_read_latency_value\";s:5:\"table\";s:35:\"field_data_field_vdisk_read_latency\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:30:\"field_vdisk_read_latency_value\";}s:10:\"field_name\";s:24:\"field_vdisk_read_latency\";}}}s:39:\"field_revision_field_vdisk_read_latency\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:39:\"field_revision_field_vdisk_read_latency\";i:1;s:36:\"field_vdisk_read_latency-revision_id\";}}}s:36:\"field_vdisk_read_latency-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:12:\"Read latency\";s:11:\"title short\";s:12:\"Read latency\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:39:\"field_revision_field_vdisk_read_latency\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:24:\"field_vdisk_read_latency\";s:10:\"real field\";s:42:\"field_vdisk_read_latency-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:30:\"field_vdisk_read_latency_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:30:\"field_vdisk_read_latency_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:39:\"Read latency (field_vdisk_read_latency)\";s:11:\"title short\";s:12:\"Read latency\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:30:\"field_vdisk_read_latency_value\";s:5:\"table\";s:39:\"field_revision_field_vdisk_read_latency\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:30:\"field_vdisk_read_latency_value\";}s:10:\"field_name\";s:24:\"field_vdisk_read_latency\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:30:\"field_vdisk_read_latency_value\";s:5:\"table\";s:39:\"field_revision_field_vdisk_read_latency\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:30:\"field_vdisk_read_latency_value\";}s:10:\"field_name\";s:24:\"field_vdisk_read_latency\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:30:\"field_vdisk_read_latency_value\";s:5:\"table\";s:39:\"field_revision_field_vdisk_read_latency\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:30:\"field_vdisk_read_latency_value\";}s:10:\"field_name\";s:24:\"field_vdisk_read_latency\";}}}s:22:\"field_data_field_vdisk\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:22:\"field_data_field_vdisk\";i:1;s:11:\"field_vdisk\";}}}s:11:\"field_vdisk\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:5:\"vDisk\";s:11:\"title short\";s:5:\"vDisk\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:22:\"field_data_field_vdisk\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:11:\"field_vdisk\";s:10:\"real field\";s:21:\"field_vdisk_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:21:\"field_vdisk_target_id\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:21:\"field_vdisk_target_id\";a:8:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:19:\"vDisk (field_vdisk)\";s:11:\"title short\";s:5:\"vDisk\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_vdisk_target_id\";s:5:\"table\";s:22:\"field_data_field_vdisk\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:21:\"field_vdisk_target_id\";}s:10:\"field_name\";s:11:\"field_vdisk\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_vdisk_target_id\";s:5:\"table\";s:22:\"field_data_field_vdisk\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:21:\"field_vdisk_target_id\";}s:10:\"field_name\";s:11:\"field_vdisk\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_vdisk_target_id\";s:5:\"table\";s:22:\"field_data_field_vdisk\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:21:\"field_vdisk_target_id\";}s:10:\"field_name\";s:11:\"field_vdisk\";}s:12:\"relationship\";a:7:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:42:\"Content entity referenced from field_vdisk\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:17:\"Referenced Entity\";s:4:\"help\";s:65:\"A bridge to the Content entity that is referenced via field_vdisk\";}}}s:26:\"field_revision_field_vdisk\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:26:\"field_revision_field_vdisk\";i:1;s:23:\"field_vdisk-revision_id\";}}}s:23:\"field_vdisk-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:5:\"vDisk\";s:11:\"title short\";s:5:\"vDisk\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:26:\"field_revision_field_vdisk\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:11:\"field_vdisk\";s:10:\"real field\";s:33:\"field_vdisk-revision_id_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:21:\"field_vdisk_target_id\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:21:\"field_vdisk_target_id\";a:8:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:19:\"vDisk (field_vdisk)\";s:11:\"title short\";s:5:\"vDisk\";s:4:\"help\";s:31:\"Appears in: node:vdisk_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_vdisk_target_id\";s:5:\"table\";s:26:\"field_revision_field_vdisk\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:21:\"field_vdisk_target_id\";}s:10:\"field_name\";s:11:\"field_vdisk\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_vdisk_target_id\";s:5:\"table\";s:26:\"field_revision_field_vdisk\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:21:\"field_vdisk_target_id\";}s:10:\"field_name\";s:11:\"field_vdisk\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_vdisk_target_id\";s:5:\"table\";s:26:\"field_revision_field_vdisk\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:21:\"field_vdisk_target_id\";}s:10:\"field_name\";s:11:\"field_vdisk\";}s:12:\"relationship\";a:7:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:42:\"Content entity referenced from field_vdisk\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:17:\"Referenced Entity\";s:4:\"help\";s:65:\"A bridge to the Content entity that is referenced via field_vdisk\";}}}s:37:\"field_data_field_vm_insertion_rate_pc\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:37:\"field_data_field_vm_insertion_rate_pc\";i:1;s:26:\"field_vm_insertion_rate_pc\";}}}s:26:\"field_vm_insertion_rate_pc\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:16:\"Insertion rate %\";s:11:\"title short\";s:16:\"Insertion rate %\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:37:\"field_data_field_vm_insertion_rate_pc\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:26:\"field_vm_insertion_rate_pc\";s:10:\"real field\";s:32:\"field_vm_insertion_rate_pc_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:32:\"field_vm_insertion_rate_pc_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:32:\"field_vm_insertion_rate_pc_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:45:\"Insertion rate % (field_vm_insertion_rate_pc)\";s:11:\"title short\";s:16:\"Insertion rate %\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:32:\"field_vm_insertion_rate_pc_value\";s:5:\"table\";s:37:\"field_data_field_vm_insertion_rate_pc\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:32:\"field_vm_insertion_rate_pc_value\";}s:10:\"field_name\";s:26:\"field_vm_insertion_rate_pc\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:32:\"field_vm_insertion_rate_pc_value\";s:5:\"table\";s:37:\"field_data_field_vm_insertion_rate_pc\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:32:\"field_vm_insertion_rate_pc_value\";}s:10:\"field_name\";s:26:\"field_vm_insertion_rate_pc\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:32:\"field_vm_insertion_rate_pc_value\";s:5:\"table\";s:37:\"field_data_field_vm_insertion_rate_pc\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:32:\"field_vm_insertion_rate_pc_value\";}s:10:\"field_name\";s:26:\"field_vm_insertion_rate_pc\";}}}s:41:\"field_revision_field_vm_insertion_rate_pc\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:41:\"field_revision_field_vm_insertion_rate_pc\";i:1;s:38:\"field_vm_insertion_rate_pc-revision_id\";}}}s:38:\"field_vm_insertion_rate_pc-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:16:\"Insertion rate %\";s:11:\"title short\";s:16:\"Insertion rate %\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:41:\"field_revision_field_vm_insertion_rate_pc\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:26:\"field_vm_insertion_rate_pc\";s:10:\"real field\";s:44:\"field_vm_insertion_rate_pc-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:32:\"field_vm_insertion_rate_pc_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:32:\"field_vm_insertion_rate_pc_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:45:\"Insertion rate % (field_vm_insertion_rate_pc)\";s:11:\"title short\";s:16:\"Insertion rate %\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:32:\"field_vm_insertion_rate_pc_value\";s:5:\"table\";s:41:\"field_revision_field_vm_insertion_rate_pc\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:32:\"field_vm_insertion_rate_pc_value\";}s:10:\"field_name\";s:26:\"field_vm_insertion_rate_pc\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:32:\"field_vm_insertion_rate_pc_value\";s:5:\"table\";s:41:\"field_revision_field_vm_insertion_rate_pc\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:32:\"field_vm_insertion_rate_pc_value\";}s:10:\"field_name\";s:26:\"field_vm_insertion_rate_pc\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:32:\"field_vm_insertion_rate_pc_value\";s:5:\"table\";s:41:\"field_revision_field_vm_insertion_rate_pc\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:32:\"field_vm_insertion_rate_pc_value\";}s:10:\"field_name\";s:26:\"field_vm_insertion_rate_pc\";}}}s:33:\"field_data_field_vm_population_pc\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:33:\"field_data_field_vm_population_pc\";i:1;s:22:\"field_vm_population_pc\";}}}s:22:\"field_vm_population_pc\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:12:\"Population %\";s:11:\"title short\";s:12:\"Population %\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:33:\"field_data_field_vm_population_pc\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_vm_population_pc\";s:10:\"real field\";s:28:\"field_vm_population_pc_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_vm_population_pc_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:28:\"field_vm_population_pc_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:37:\"Population % (field_vm_population_pc)\";s:11:\"title short\";s:12:\"Population %\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_vm_population_pc_value\";s:5:\"table\";s:33:\"field_data_field_vm_population_pc\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_population_pc_value\";}s:10:\"field_name\";s:22:\"field_vm_population_pc\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_vm_population_pc_value\";s:5:\"table\";s:33:\"field_data_field_vm_population_pc\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_population_pc_value\";}s:10:\"field_name\";s:22:\"field_vm_population_pc\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_vm_population_pc_value\";s:5:\"table\";s:33:\"field_data_field_vm_population_pc\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_population_pc_value\";}s:10:\"field_name\";s:22:\"field_vm_population_pc\";}}}s:37:\"field_revision_field_vm_population_pc\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:37:\"field_revision_field_vm_population_pc\";i:1;s:34:\"field_vm_population_pc-revision_id\";}}}s:34:\"field_vm_population_pc-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:12:\"Population %\";s:11:\"title short\";s:12:\"Population %\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:37:\"field_revision_field_vm_population_pc\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_vm_population_pc\";s:10:\"real field\";s:40:\"field_vm_population_pc-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_vm_population_pc_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:28:\"field_vm_population_pc_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:37:\"Population % (field_vm_population_pc)\";s:11:\"title short\";s:12:\"Population %\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_vm_population_pc_value\";s:5:\"table\";s:37:\"field_revision_field_vm_population_pc\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_population_pc_value\";}s:10:\"field_name\";s:22:\"field_vm_population_pc\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_vm_population_pc_value\";s:5:\"table\";s:37:\"field_revision_field_vm_population_pc\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_population_pc_value\";}s:10:\"field_name\";s:22:\"field_vm_population_pc\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_vm_population_pc_value\";s:5:\"table\";s:37:\"field_revision_field_vm_population_pc\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_population_pc_value\";}s:10:\"field_name\";s:22:\"field_vm_population_pc\";}}}s:30:\"field_data_field_vm_insertions\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:30:\"field_data_field_vm_insertions\";i:1;s:19:\"field_vm_insertions\";}}}s:19:\"field_vm_insertions\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"Insertions\";s:11:\"title short\";s:10:\"Insertions\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:30:\"field_data_field_vm_insertions\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_vm_insertions\";s:10:\"real field\";s:25:\"field_vm_insertions_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_vm_insertions_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:25:\"field_vm_insertions_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:32:\"Insertions (field_vm_insertions)\";s:11:\"title short\";s:10:\"Insertions\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_vm_insertions_value\";s:5:\"table\";s:30:\"field_data_field_vm_insertions\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:25:\"field_vm_insertions_value\";}s:10:\"field_name\";s:19:\"field_vm_insertions\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_vm_insertions_value\";s:5:\"table\";s:30:\"field_data_field_vm_insertions\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:25:\"field_vm_insertions_value\";}s:10:\"field_name\";s:19:\"field_vm_insertions\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_vm_insertions_value\";s:5:\"table\";s:30:\"field_data_field_vm_insertions\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:25:\"field_vm_insertions_value\";}s:10:\"field_name\";s:19:\"field_vm_insertions\";}}}s:34:\"field_revision_field_vm_insertions\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:34:\"field_revision_field_vm_insertions\";i:1;s:31:\"field_vm_insertions-revision_id\";}}}s:31:\"field_vm_insertions-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:10:\"Insertions\";s:11:\"title short\";s:10:\"Insertions\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:34:\"field_revision_field_vm_insertions\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_vm_insertions\";s:10:\"real field\";s:37:\"field_vm_insertions-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_vm_insertions_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:25:\"field_vm_insertions_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:32:\"Insertions (field_vm_insertions)\";s:11:\"title short\";s:10:\"Insertions\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_vm_insertions_value\";s:5:\"table\";s:34:\"field_revision_field_vm_insertions\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:25:\"field_vm_insertions_value\";}s:10:\"field_name\";s:19:\"field_vm_insertions\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_vm_insertions_value\";s:5:\"table\";s:34:\"field_revision_field_vm_insertions\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:25:\"field_vm_insertions_value\";}s:10:\"field_name\";s:19:\"field_vm_insertions\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_vm_insertions_value\";s:5:\"table\";s:34:\"field_revision_field_vm_insertions\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:25:\"field_vm_insertions_value\";}s:10:\"field_name\";s:19:\"field_vm_insertions\";}}}s:32:\"field_data_field_vm_write_blocks\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:32:\"field_data_field_vm_write_blocks\";i:1;s:21:\"field_vm_write_blocks\";}}}s:21:\"field_vm_write_blocks\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:12:\"Write blocks\";s:11:\"title short\";s:12:\"Write blocks\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:32:\"field_data_field_vm_write_blocks\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:21:\"field_vm_write_blocks\";s:10:\"real field\";s:27:\"field_vm_write_blocks_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:27:\"field_vm_write_blocks_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:27:\"field_vm_write_blocks_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:36:\"Write blocks (field_vm_write_blocks)\";s:11:\"title short\";s:12:\"Write blocks\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:27:\"field_vm_write_blocks_value\";s:5:\"table\";s:32:\"field_data_field_vm_write_blocks\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_vm_write_blocks_value\";}s:10:\"field_name\";s:21:\"field_vm_write_blocks\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:27:\"field_vm_write_blocks_value\";s:5:\"table\";s:32:\"field_data_field_vm_write_blocks\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_vm_write_blocks_value\";}s:10:\"field_name\";s:21:\"field_vm_write_blocks\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:27:\"field_vm_write_blocks_value\";s:5:\"table\";s:32:\"field_data_field_vm_write_blocks\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_vm_write_blocks_value\";}s:10:\"field_name\";s:21:\"field_vm_write_blocks\";}}}s:36:\"field_revision_field_vm_write_blocks\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:36:\"field_revision_field_vm_write_blocks\";i:1;s:33:\"field_vm_write_blocks-revision_id\";}}}s:33:\"field_vm_write_blocks-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:12:\"Write blocks\";s:11:\"title short\";s:12:\"Write blocks\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:36:\"field_revision_field_vm_write_blocks\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:21:\"field_vm_write_blocks\";s:10:\"real field\";s:39:\"field_vm_write_blocks-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:27:\"field_vm_write_blocks_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:27:\"field_vm_write_blocks_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:36:\"Write blocks (field_vm_write_blocks)\";s:11:\"title short\";s:12:\"Write blocks\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:27:\"field_vm_write_blocks_value\";s:5:\"table\";s:36:\"field_revision_field_vm_write_blocks\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_vm_write_blocks_value\";}s:10:\"field_name\";s:21:\"field_vm_write_blocks\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:27:\"field_vm_write_blocks_value\";s:5:\"table\";s:36:\"field_revision_field_vm_write_blocks\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_vm_write_blocks_value\";}s:10:\"field_name\";s:21:\"field_vm_write_blocks\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:27:\"field_vm_write_blocks_value\";s:5:\"table\";s:36:\"field_revision_field_vm_write_blocks\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_vm_write_blocks_value\";}s:10:\"field_name\";s:21:\"field_vm_write_blocks\";}}}s:33:\"field_data_field_vm_usable_blocks\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:33:\"field_data_field_vm_usable_blocks\";i:1;s:22:\"field_vm_usable_blocks\";}}}s:22:\"field_vm_usable_blocks\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:13:\"Usable blocks\";s:11:\"title short\";s:13:\"Usable blocks\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:33:\"field_data_field_vm_usable_blocks\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_vm_usable_blocks\";s:10:\"real field\";s:28:\"field_vm_usable_blocks_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_vm_usable_blocks_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:28:\"field_vm_usable_blocks_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:38:\"Usable blocks (field_vm_usable_blocks)\";s:11:\"title short\";s:13:\"Usable blocks\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_vm_usable_blocks_value\";s:5:\"table\";s:33:\"field_data_field_vm_usable_blocks\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_usable_blocks_value\";}s:10:\"field_name\";s:22:\"field_vm_usable_blocks\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_vm_usable_blocks_value\";s:5:\"table\";s:33:\"field_data_field_vm_usable_blocks\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_usable_blocks_value\";}s:10:\"field_name\";s:22:\"field_vm_usable_blocks\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_vm_usable_blocks_value\";s:5:\"table\";s:33:\"field_data_field_vm_usable_blocks\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_usable_blocks_value\";}s:10:\"field_name\";s:22:\"field_vm_usable_blocks\";}}}s:37:\"field_revision_field_vm_usable_blocks\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:37:\"field_revision_field_vm_usable_blocks\";i:1;s:34:\"field_vm_usable_blocks-revision_id\";}}}s:34:\"field_vm_usable_blocks-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:13:\"Usable blocks\";s:11:\"title short\";s:13:\"Usable blocks\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:37:\"field_revision_field_vm_usable_blocks\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_vm_usable_blocks\";s:10:\"real field\";s:40:\"field_vm_usable_blocks-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_vm_usable_blocks_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:28:\"field_vm_usable_blocks_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:38:\"Usable blocks (field_vm_usable_blocks)\";s:11:\"title short\";s:13:\"Usable blocks\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_vm_usable_blocks_value\";s:5:\"table\";s:37:\"field_revision_field_vm_usable_blocks\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_usable_blocks_value\";}s:10:\"field_name\";s:22:\"field_vm_usable_blocks\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_vm_usable_blocks_value\";s:5:\"table\";s:37:\"field_revision_field_vm_usable_blocks\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_usable_blocks_value\";}s:10:\"field_name\";s:22:\"field_vm_usable_blocks\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_vm_usable_blocks_value\";s:5:\"table\";s:37:\"field_revision_field_vm_usable_blocks\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_usable_blocks_value\";}s:10:\"field_name\";s:22:\"field_vm_usable_blocks\";}}}s:30:\"field_data_field_vm_population\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:30:\"field_data_field_vm_population\";i:1;s:19:\"field_vm_population\";}}}s:19:\"field_vm_population\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"Population\";s:11:\"title short\";s:10:\"Population\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:30:\"field_data_field_vm_population\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_vm_population\";s:10:\"real field\";s:25:\"field_vm_population_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_vm_population_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:25:\"field_vm_population_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:32:\"Population (field_vm_population)\";s:11:\"title short\";s:10:\"Population\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_vm_population_value\";s:5:\"table\";s:30:\"field_data_field_vm_population\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:25:\"field_vm_population_value\";}s:10:\"field_name\";s:19:\"field_vm_population\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_vm_population_value\";s:5:\"table\";s:30:\"field_data_field_vm_population\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:25:\"field_vm_population_value\";}s:10:\"field_name\";s:19:\"field_vm_population\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_vm_population_value\";s:5:\"table\";s:30:\"field_data_field_vm_population\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:25:\"field_vm_population_value\";}s:10:\"field_name\";s:19:\"field_vm_population\";}}}s:34:\"field_revision_field_vm_population\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:34:\"field_revision_field_vm_population\";i:1;s:31:\"field_vm_population-revision_id\";}}}s:31:\"field_vm_population-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:10:\"Population\";s:11:\"title short\";s:10:\"Population\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:34:\"field_revision_field_vm_population\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_vm_population\";s:10:\"real field\";s:37:\"field_vm_population-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_vm_population_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:25:\"field_vm_population_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:32:\"Population (field_vm_population)\";s:11:\"title short\";s:10:\"Population\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_vm_population_value\";s:5:\"table\";s:34:\"field_revision_field_vm_population\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:25:\"field_vm_population_value\";}s:10:\"field_name\";s:19:\"field_vm_population\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_vm_population_value\";s:5:\"table\";s:34:\"field_revision_field_vm_population\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:25:\"field_vm_population_value\";}s:10:\"field_name\";s:19:\"field_vm_population\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_vm_population_value\";s:5:\"table\";s:34:\"field_revision_field_vm_population\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:25:\"field_vm_population_value\";}s:10:\"field_name\";s:19:\"field_vm_population\";}}}s:33:\"field_data_field_vm_cache_latency\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:33:\"field_data_field_vm_cache_latency\";i:1;s:22:\"field_vm_cache_latency\";}}}s:22:\"field_vm_cache_latency\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:13:\"Cache latency\";s:11:\"title short\";s:13:\"Cache latency\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:33:\"field_data_field_vm_cache_latency\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_vm_cache_latency\";s:10:\"real field\";s:28:\"field_vm_cache_latency_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_vm_cache_latency_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:28:\"field_vm_cache_latency_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:38:\"Cache latency (field_vm_cache_latency)\";s:11:\"title short\";s:13:\"Cache latency\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_vm_cache_latency_value\";s:5:\"table\";s:33:\"field_data_field_vm_cache_latency\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_cache_latency_value\";}s:10:\"field_name\";s:22:\"field_vm_cache_latency\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_vm_cache_latency_value\";s:5:\"table\";s:33:\"field_data_field_vm_cache_latency\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_cache_latency_value\";}s:10:\"field_name\";s:22:\"field_vm_cache_latency\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_vm_cache_latency_value\";s:5:\"table\";s:33:\"field_data_field_vm_cache_latency\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_cache_latency_value\";}s:10:\"field_name\";s:22:\"field_vm_cache_latency\";}}}s:37:\"field_revision_field_vm_cache_latency\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:37:\"field_revision_field_vm_cache_latency\";i:1;s:34:\"field_vm_cache_latency-revision_id\";}}}s:34:\"field_vm_cache_latency-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:13:\"Cache latency\";s:11:\"title short\";s:13:\"Cache latency\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:37:\"field_revision_field_vm_cache_latency\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_vm_cache_latency\";s:10:\"real field\";s:40:\"field_vm_cache_latency-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_vm_cache_latency_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:28:\"field_vm_cache_latency_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:38:\"Cache latency (field_vm_cache_latency)\";s:11:\"title short\";s:13:\"Cache latency\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_vm_cache_latency_value\";s:5:\"table\";s:37:\"field_revision_field_vm_cache_latency\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_cache_latency_value\";}s:10:\"field_name\";s:22:\"field_vm_cache_latency\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_vm_cache_latency_value\";s:5:\"table\";s:37:\"field_revision_field_vm_cache_latency\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_cache_latency_value\";}s:10:\"field_name\";s:22:\"field_vm_cache_latency\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_vm_cache_latency_value\";s:5:\"table\";s:37:\"field_revision_field_vm_cache_latency\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_cache_latency_value\";}s:10:\"field_name\";s:22:\"field_vm_cache_latency\";}}}s:31:\"field_data_field_vm_read_blocks\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:31:\"field_data_field_vm_read_blocks\";i:1;s:20:\"field_vm_read_blocks\";}}}s:20:\"field_vm_read_blocks\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:11:\"Read blocks\";s:11:\"title short\";s:11:\"Read blocks\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:31:\"field_data_field_vm_read_blocks\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:20:\"field_vm_read_blocks\";s:10:\"real field\";s:26:\"field_vm_read_blocks_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:26:\"field_vm_read_blocks_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:26:\"field_vm_read_blocks_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:34:\"Read blocks (field_vm_read_blocks)\";s:11:\"title short\";s:11:\"Read blocks\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_vm_read_blocks_value\";s:5:\"table\";s:31:\"field_data_field_vm_read_blocks\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vm_read_blocks_value\";}s:10:\"field_name\";s:20:\"field_vm_read_blocks\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_vm_read_blocks_value\";s:5:\"table\";s:31:\"field_data_field_vm_read_blocks\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vm_read_blocks_value\";}s:10:\"field_name\";s:20:\"field_vm_read_blocks\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_vm_read_blocks_value\";s:5:\"table\";s:31:\"field_data_field_vm_read_blocks\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vm_read_blocks_value\";}s:10:\"field_name\";s:20:\"field_vm_read_blocks\";}}}s:35:\"field_revision_field_vm_read_blocks\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:35:\"field_revision_field_vm_read_blocks\";i:1;s:32:\"field_vm_read_blocks-revision_id\";}}}s:32:\"field_vm_read_blocks-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:11:\"Read blocks\";s:11:\"title short\";s:11:\"Read blocks\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:35:\"field_revision_field_vm_read_blocks\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:20:\"field_vm_read_blocks\";s:10:\"real field\";s:38:\"field_vm_read_blocks-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:26:\"field_vm_read_blocks_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:26:\"field_vm_read_blocks_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:34:\"Read blocks (field_vm_read_blocks)\";s:11:\"title short\";s:11:\"Read blocks\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_vm_read_blocks_value\";s:5:\"table\";s:35:\"field_revision_field_vm_read_blocks\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vm_read_blocks_value\";}s:10:\"field_name\";s:20:\"field_vm_read_blocks\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_vm_read_blocks_value\";s:5:\"table\";s:35:\"field_revision_field_vm_read_blocks\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vm_read_blocks_value\";}s:10:\"field_name\";s:20:\"field_vm_read_blocks\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_vm_read_blocks_value\";s:5:\"table\";s:35:\"field_revision_field_vm_read_blocks\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_vm_read_blocks_value\";}s:10:\"field_name\";s:20:\"field_vm_read_blocks\";}}}s:24:\"field_data_field_vm_hits\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:24:\"field_data_field_vm_hits\";i:1;s:13:\"field_vm_hits\";}}}s:13:\"field_vm_hits\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:4:\"Hits\";s:11:\"title short\";s:4:\"Hits\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:24:\"field_data_field_vm_hits\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:13:\"field_vm_hits\";s:10:\"real field\";s:19:\"field_vm_hits_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:19:\"field_vm_hits_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:19:\"field_vm_hits_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:20:\"Hits (field_vm_hits)\";s:11:\"title short\";s:4:\"Hits\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:19:\"field_vm_hits_value\";s:5:\"table\";s:24:\"field_data_field_vm_hits\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:19:\"field_vm_hits_value\";}s:10:\"field_name\";s:13:\"field_vm_hits\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:19:\"field_vm_hits_value\";s:5:\"table\";s:24:\"field_data_field_vm_hits\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:19:\"field_vm_hits_value\";}s:10:\"field_name\";s:13:\"field_vm_hits\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:19:\"field_vm_hits_value\";s:5:\"table\";s:24:\"field_data_field_vm_hits\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:19:\"field_vm_hits_value\";}s:10:\"field_name\";s:13:\"field_vm_hits\";}}}s:28:\"field_revision_field_vm_hits\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:28:\"field_revision_field_vm_hits\";i:1;s:25:\"field_vm_hits-revision_id\";}}}s:25:\"field_vm_hits-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:4:\"Hits\";s:11:\"title short\";s:4:\"Hits\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:28:\"field_revision_field_vm_hits\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:13:\"field_vm_hits\";s:10:\"real field\";s:31:\"field_vm_hits-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:19:\"field_vm_hits_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:19:\"field_vm_hits_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:20:\"Hits (field_vm_hits)\";s:11:\"title short\";s:4:\"Hits\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:19:\"field_vm_hits_value\";s:5:\"table\";s:28:\"field_revision_field_vm_hits\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:19:\"field_vm_hits_value\";}s:10:\"field_name\";s:13:\"field_vm_hits\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:19:\"field_vm_hits_value\";s:5:\"table\";s:28:\"field_revision_field_vm_hits\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:19:\"field_vm_hits_value\";}s:10:\"field_name\";s:13:\"field_vm_hits\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:19:\"field_vm_hits_value\";s:5:\"table\";s:28:\"field_revision_field_vm_hits\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:19:\"field_vm_hits_value\";}s:10:\"field_name\";s:13:\"field_vm_hits\";}}}s:29:\"field_data_field_vm_write_ops\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:29:\"field_data_field_vm_write_ops\";i:1;s:18:\"field_vm_write_ops\";}}}s:18:\"field_vm_write_ops\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:9:\"Write ops\";s:11:\"title short\";s:9:\"Write ops\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:29:\"field_data_field_vm_write_ops\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:18:\"field_vm_write_ops\";s:10:\"real field\";s:24:\"field_vm_write_ops_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:24:\"field_vm_write_ops_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:24:\"field_vm_write_ops_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:30:\"Write ops (field_vm_write_ops)\";s:11:\"title short\";s:9:\"Write ops\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_vm_write_ops_value\";s:5:\"table\";s:29:\"field_data_field_vm_write_ops\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_vm_write_ops_value\";}s:10:\"field_name\";s:18:\"field_vm_write_ops\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_vm_write_ops_value\";s:5:\"table\";s:29:\"field_data_field_vm_write_ops\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_vm_write_ops_value\";}s:10:\"field_name\";s:18:\"field_vm_write_ops\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_vm_write_ops_value\";s:5:\"table\";s:29:\"field_data_field_vm_write_ops\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_vm_write_ops_value\";}s:10:\"field_name\";s:18:\"field_vm_write_ops\";}}}s:33:\"field_revision_field_vm_write_ops\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:33:\"field_revision_field_vm_write_ops\";i:1;s:30:\"field_vm_write_ops-revision_id\";}}}s:30:\"field_vm_write_ops-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:9:\"Write ops\";s:11:\"title short\";s:9:\"Write ops\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:33:\"field_revision_field_vm_write_ops\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:18:\"field_vm_write_ops\";s:10:\"real field\";s:36:\"field_vm_write_ops-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:24:\"field_vm_write_ops_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:24:\"field_vm_write_ops_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:30:\"Write ops (field_vm_write_ops)\";s:11:\"title short\";s:9:\"Write ops\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_vm_write_ops_value\";s:5:\"table\";s:33:\"field_revision_field_vm_write_ops\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_vm_write_ops_value\";}s:10:\"field_name\";s:18:\"field_vm_write_ops\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_vm_write_ops_value\";s:5:\"table\";s:33:\"field_revision_field_vm_write_ops\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_vm_write_ops_value\";}s:10:\"field_name\";s:18:\"field_vm_write_ops\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_vm_write_ops_value\";s:5:\"table\";s:33:\"field_revision_field_vm_write_ops\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_vm_write_ops_value\";}s:10:\"field_name\";s:18:\"field_vm_write_ops\";}}}s:28:\"field_data_field_vm_read_ops\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:28:\"field_data_field_vm_read_ops\";i:1;s:17:\"field_vm_read_ops\";}}}s:17:\"field_vm_read_ops\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:8:\"Read ops\";s:11:\"title short\";s:8:\"Read ops\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:28:\"field_data_field_vm_read_ops\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_vm_read_ops\";s:10:\"real field\";s:23:\"field_vm_read_ops_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_vm_read_ops_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:23:\"field_vm_read_ops_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:28:\"Read ops (field_vm_read_ops)\";s:11:\"title short\";s:8:\"Read ops\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_vm_read_ops_value\";s:5:\"table\";s:28:\"field_data_field_vm_read_ops\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:23:\"field_vm_read_ops_value\";}s:10:\"field_name\";s:17:\"field_vm_read_ops\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_vm_read_ops_value\";s:5:\"table\";s:28:\"field_data_field_vm_read_ops\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:23:\"field_vm_read_ops_value\";}s:10:\"field_name\";s:17:\"field_vm_read_ops\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_vm_read_ops_value\";s:5:\"table\";s:28:\"field_data_field_vm_read_ops\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:23:\"field_vm_read_ops_value\";}s:10:\"field_name\";s:17:\"field_vm_read_ops\";}}}s:32:\"field_revision_field_vm_read_ops\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:32:\"field_revision_field_vm_read_ops\";i:1;s:29:\"field_vm_read_ops-revision_id\";}}}s:29:\"field_vm_read_ops-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:8:\"Read ops\";s:11:\"title short\";s:8:\"Read ops\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:32:\"field_revision_field_vm_read_ops\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_vm_read_ops\";s:10:\"real field\";s:35:\"field_vm_read_ops-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_vm_read_ops_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:23:\"field_vm_read_ops_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:28:\"Read ops (field_vm_read_ops)\";s:11:\"title short\";s:8:\"Read ops\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_vm_read_ops_value\";s:5:\"table\";s:32:\"field_revision_field_vm_read_ops\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:23:\"field_vm_read_ops_value\";}s:10:\"field_name\";s:17:\"field_vm_read_ops\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_vm_read_ops_value\";s:5:\"table\";s:32:\"field_revision_field_vm_read_ops\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:23:\"field_vm_read_ops_value\";}s:10:\"field_name\";s:17:\"field_vm_read_ops\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_vm_read_ops_value\";s:5:\"table\";s:32:\"field_revision_field_vm_read_ops\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:23:\"field_vm_read_ops_value\";}s:10:\"field_name\";s:17:\"field_vm_read_ops\";}}}s:33:\"field_data_field_vm_write_latency\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:33:\"field_data_field_vm_write_latency\";i:1;s:22:\"field_vm_write_latency\";}}}s:22:\"field_vm_write_latency\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:13:\"Write latency\";s:11:\"title short\";s:13:\"Write latency\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:33:\"field_data_field_vm_write_latency\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_vm_write_latency\";s:10:\"real field\";s:28:\"field_vm_write_latency_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_vm_write_latency_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:28:\"field_vm_write_latency_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:38:\"Write latency (field_vm_write_latency)\";s:11:\"title short\";s:13:\"Write latency\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_vm_write_latency_value\";s:5:\"table\";s:33:\"field_data_field_vm_write_latency\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_write_latency_value\";}s:10:\"field_name\";s:22:\"field_vm_write_latency\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_vm_write_latency_value\";s:5:\"table\";s:33:\"field_data_field_vm_write_latency\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_write_latency_value\";}s:10:\"field_name\";s:22:\"field_vm_write_latency\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_vm_write_latency_value\";s:5:\"table\";s:33:\"field_data_field_vm_write_latency\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_write_latency_value\";}s:10:\"field_name\";s:22:\"field_vm_write_latency\";}}}s:37:\"field_revision_field_vm_write_latency\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:37:\"field_revision_field_vm_write_latency\";i:1;s:34:\"field_vm_write_latency-revision_id\";}}}s:34:\"field_vm_write_latency-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:13:\"Write latency\";s:11:\"title short\";s:13:\"Write latency\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:37:\"field_revision_field_vm_write_latency\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_vm_write_latency\";s:10:\"real field\";s:40:\"field_vm_write_latency-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_vm_write_latency_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:28:\"field_vm_write_latency_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:38:\"Write latency (field_vm_write_latency)\";s:11:\"title short\";s:13:\"Write latency\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_vm_write_latency_value\";s:5:\"table\";s:37:\"field_revision_field_vm_write_latency\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_write_latency_value\";}s:10:\"field_name\";s:22:\"field_vm_write_latency\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_vm_write_latency_value\";s:5:\"table\";s:37:\"field_revision_field_vm_write_latency\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_write_latency_value\";}s:10:\"field_name\";s:22:\"field_vm_write_latency\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_vm_write_latency_value\";s:5:\"table\";s:37:\"field_revision_field_vm_write_latency\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_vm_write_latency_value\";}s:10:\"field_name\";s:22:\"field_vm_write_latency\";}}}s:32:\"field_data_field_vm_read_latency\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:32:\"field_data_field_vm_read_latency\";i:1;s:21:\"field_vm_read_latency\";}}}s:21:\"field_vm_read_latency\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:12:\"Read latency\";s:11:\"title short\";s:12:\"Read latency\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:32:\"field_data_field_vm_read_latency\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:21:\"field_vm_read_latency\";s:10:\"real field\";s:27:\"field_vm_read_latency_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:27:\"field_vm_read_latency_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:27:\"field_vm_read_latency_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:36:\"Read latency (field_vm_read_latency)\";s:11:\"title short\";s:12:\"Read latency\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:27:\"field_vm_read_latency_value\";s:5:\"table\";s:32:\"field_data_field_vm_read_latency\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_vm_read_latency_value\";}s:10:\"field_name\";s:21:\"field_vm_read_latency\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:27:\"field_vm_read_latency_value\";s:5:\"table\";s:32:\"field_data_field_vm_read_latency\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_vm_read_latency_value\";}s:10:\"field_name\";s:21:\"field_vm_read_latency\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:27:\"field_vm_read_latency_value\";s:5:\"table\";s:32:\"field_data_field_vm_read_latency\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_vm_read_latency_value\";}s:10:\"field_name\";s:21:\"field_vm_read_latency\";}}}s:36:\"field_revision_field_vm_read_latency\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:36:\"field_revision_field_vm_read_latency\";i:1;s:33:\"field_vm_read_latency-revision_id\";}}}s:33:\"field_vm_read_latency-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:12:\"Read latency\";s:11:\"title short\";s:12:\"Read latency\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:36:\"field_revision_field_vm_read_latency\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:21:\"field_vm_read_latency\";s:10:\"real field\";s:39:\"field_vm_read_latency-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:27:\"field_vm_read_latency_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:27:\"field_vm_read_latency_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:36:\"Read latency (field_vm_read_latency)\";s:11:\"title short\";s:12:\"Read latency\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:27:\"field_vm_read_latency_value\";s:5:\"table\";s:36:\"field_revision_field_vm_read_latency\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_vm_read_latency_value\";}s:10:\"field_name\";s:21:\"field_vm_read_latency\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:27:\"field_vm_read_latency_value\";s:5:\"table\";s:36:\"field_revision_field_vm_read_latency\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_vm_read_latency_value\";}s:10:\"field_name\";s:21:\"field_vm_read_latency\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:27:\"field_vm_read_latency_value\";s:5:\"table\";s:36:\"field_revision_field_vm_read_latency\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_vm_read_latency_value\";}s:10:\"field_name\";s:21:\"field_vm_read_latency\";}}}s:33:\"field_data_field_fa_generation_id\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:33:\"field_data_field_fa_generation_id\";i:1;s:22:\"field_fa_generation_id\";}}}s:22:\"field_fa_generation_id\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:13:\"Generation ID\";s:11:\"title short\";s:13:\"Generation ID\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:33:\"field_data_field_fa_generation_id\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_fa_generation_id\";s:10:\"real field\";s:28:\"field_fa_generation_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_fa_generation_id_value\";i:4;s:29:\"field_fa_generation_id_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:28:\"field_fa_generation_id_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:38:\"Generation ID (field_fa_generation_id)\";s:11:\"title short\";s:13:\"Generation ID\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_fa_generation_id_value\";s:5:\"table\";s:33:\"field_data_field_fa_generation_id\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_generation_id_value\";i:1;s:29:\"field_fa_generation_id_format\";}s:10:\"field_name\";s:22:\"field_fa_generation_id\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_fa_generation_id_value\";s:5:\"table\";s:33:\"field_data_field_fa_generation_id\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_generation_id_value\";i:1;s:29:\"field_fa_generation_id_format\";}s:10:\"field_name\";s:22:\"field_fa_generation_id\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_fa_generation_id_value\";s:5:\"table\";s:33:\"field_data_field_fa_generation_id\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_generation_id_value\";i:1;s:29:\"field_fa_generation_id_format\";}s:10:\"field_name\";s:22:\"field_fa_generation_id\";}}s:29:\"field_fa_generation_id_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:45:\"Generation ID (field_fa_generation_id:format)\";s:11:\"title short\";s:20:\"Generation ID:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_fa_generation_id_format\";s:5:\"table\";s:33:\"field_data_field_fa_generation_id\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_generation_id_value\";i:1;s:29:\"field_fa_generation_id_format\";}s:10:\"field_name\";s:22:\"field_fa_generation_id\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_fa_generation_id_format\";s:5:\"table\";s:33:\"field_data_field_fa_generation_id\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_generation_id_value\";i:1;s:29:\"field_fa_generation_id_format\";}s:10:\"field_name\";s:22:\"field_fa_generation_id\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_fa_generation_id_format\";s:5:\"table\";s:33:\"field_data_field_fa_generation_id\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_generation_id_value\";i:1;s:29:\"field_fa_generation_id_format\";}s:10:\"field_name\";s:22:\"field_fa_generation_id\";}}}s:37:\"field_revision_field_fa_generation_id\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:37:\"field_revision_field_fa_generation_id\";i:1;s:34:\"field_fa_generation_id-revision_id\";}}}s:34:\"field_fa_generation_id-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:13:\"Generation ID\";s:11:\"title short\";s:13:\"Generation ID\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:37:\"field_revision_field_fa_generation_id\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_fa_generation_id\";s:10:\"real field\";s:40:\"field_fa_generation_id-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_fa_generation_id_value\";i:4;s:29:\"field_fa_generation_id_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:28:\"field_fa_generation_id_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:38:\"Generation ID (field_fa_generation_id)\";s:11:\"title short\";s:13:\"Generation ID\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_fa_generation_id_value\";s:5:\"table\";s:37:\"field_revision_field_fa_generation_id\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_generation_id_value\";i:1;s:29:\"field_fa_generation_id_format\";}s:10:\"field_name\";s:22:\"field_fa_generation_id\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_fa_generation_id_value\";s:5:\"table\";s:37:\"field_revision_field_fa_generation_id\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_generation_id_value\";i:1;s:29:\"field_fa_generation_id_format\";}s:10:\"field_name\";s:22:\"field_fa_generation_id\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_fa_generation_id_value\";s:5:\"table\";s:37:\"field_revision_field_fa_generation_id\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_generation_id_value\";i:1;s:29:\"field_fa_generation_id_format\";}s:10:\"field_name\";s:22:\"field_fa_generation_id\";}}s:29:\"field_fa_generation_id_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:45:\"Generation ID (field_fa_generation_id:format)\";s:11:\"title short\";s:20:\"Generation ID:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_fa_generation_id_format\";s:5:\"table\";s:37:\"field_revision_field_fa_generation_id\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_generation_id_value\";i:1;s:29:\"field_fa_generation_id_format\";}s:10:\"field_name\";s:22:\"field_fa_generation_id\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_fa_generation_id_format\";s:5:\"table\";s:37:\"field_revision_field_fa_generation_id\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_generation_id_value\";i:1;s:29:\"field_fa_generation_id_format\";}s:10:\"field_name\";s:22:\"field_fa_generation_id\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_fa_generation_id_format\";s:5:\"table\";s:37:\"field_revision_field_fa_generation_id\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_generation_id_value\";i:1;s:29:\"field_fa_generation_id_format\";}s:10:\"field_name\";s:22:\"field_fa_generation_id\";}}}s:37:\"field_data_field_fa_performance_state\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:37:\"field_data_field_fa_performance_state\";i:1;s:26:\"field_fa_performance_state\";}}}s:26:\"field_fa_performance_state\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:17:\"Performance State\";s:11:\"title short\";s:17:\"Performance State\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:37:\"field_data_field_fa_performance_state\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:26:\"field_fa_performance_state\";s:10:\"real field\";s:32:\"field_fa_performance_state_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:32:\"field_fa_performance_state_value\";i:4;s:33:\"field_fa_performance_state_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:32:\"field_fa_performance_state_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:46:\"Performance State (field_fa_performance_state)\";s:11:\"title short\";s:17:\"Performance State\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:32:\"field_fa_performance_state_value\";s:5:\"table\";s:37:\"field_data_field_fa_performance_state\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_performance_state_value\";i:1;s:33:\"field_fa_performance_state_format\";}s:10:\"field_name\";s:26:\"field_fa_performance_state\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:32:\"field_fa_performance_state_value\";s:5:\"table\";s:37:\"field_data_field_fa_performance_state\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_performance_state_value\";i:1;s:33:\"field_fa_performance_state_format\";}s:10:\"field_name\";s:26:\"field_fa_performance_state\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:32:\"field_fa_performance_state_value\";s:5:\"table\";s:37:\"field_data_field_fa_performance_state\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_performance_state_value\";i:1;s:33:\"field_fa_performance_state_format\";}s:10:\"field_name\";s:26:\"field_fa_performance_state\";}}s:33:\"field_fa_performance_state_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:53:\"Performance State (field_fa_performance_state:format)\";s:11:\"title short\";s:24:\"Performance State:format\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:33:\"field_fa_performance_state_format\";s:5:\"table\";s:37:\"field_data_field_fa_performance_state\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_performance_state_value\";i:1;s:33:\"field_fa_performance_state_format\";}s:10:\"field_name\";s:26:\"field_fa_performance_state\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:33:\"field_fa_performance_state_format\";s:5:\"table\";s:37:\"field_data_field_fa_performance_state\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_performance_state_value\";i:1;s:33:\"field_fa_performance_state_format\";}s:10:\"field_name\";s:26:\"field_fa_performance_state\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:33:\"field_fa_performance_state_format\";s:5:\"table\";s:37:\"field_data_field_fa_performance_state\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_performance_state_value\";i:1;s:33:\"field_fa_performance_state_format\";}s:10:\"field_name\";s:26:\"field_fa_performance_state\";}}}s:41:\"field_revision_field_fa_performance_state\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:41:\"field_revision_field_fa_performance_state\";i:1;s:38:\"field_fa_performance_state-revision_id\";}}}s:38:\"field_fa_performance_state-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:17:\"Performance State\";s:11:\"title short\";s:17:\"Performance State\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:41:\"field_revision_field_fa_performance_state\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:26:\"field_fa_performance_state\";s:10:\"real field\";s:44:\"field_fa_performance_state-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:32:\"field_fa_performance_state_value\";i:4;s:33:\"field_fa_performance_state_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:32:\"field_fa_performance_state_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:46:\"Performance State (field_fa_performance_state)\";s:11:\"title short\";s:17:\"Performance State\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:32:\"field_fa_performance_state_value\";s:5:\"table\";s:41:\"field_revision_field_fa_performance_state\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_performance_state_value\";i:1;s:33:\"field_fa_performance_state_format\";}s:10:\"field_name\";s:26:\"field_fa_performance_state\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:32:\"field_fa_performance_state_value\";s:5:\"table\";s:41:\"field_revision_field_fa_performance_state\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_performance_state_value\";i:1;s:33:\"field_fa_performance_state_format\";}s:10:\"field_name\";s:26:\"field_fa_performance_state\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:32:\"field_fa_performance_state_value\";s:5:\"table\";s:41:\"field_revision_field_fa_performance_state\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_performance_state_value\";i:1;s:33:\"field_fa_performance_state_format\";}s:10:\"field_name\";s:26:\"field_fa_performance_state\";}}s:33:\"field_fa_performance_state_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:53:\"Performance State (field_fa_performance_state:format)\";s:11:\"title short\";s:24:\"Performance State:format\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:33:\"field_fa_performance_state_format\";s:5:\"table\";s:41:\"field_revision_field_fa_performance_state\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_performance_state_value\";i:1;s:33:\"field_fa_performance_state_format\";}s:10:\"field_name\";s:26:\"field_fa_performance_state\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:33:\"field_fa_performance_state_format\";s:5:\"table\";s:41:\"field_revision_field_fa_performance_state\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_performance_state_value\";i:1;s:33:\"field_fa_performance_state_format\";}s:10:\"field_name\";s:26:\"field_fa_performance_state\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:33:\"field_fa_performance_state_format\";s:5:\"table\";s:41:\"field_revision_field_fa_performance_state\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_performance_state_value\";i:1;s:33:\"field_fa_performance_state_format\";}s:10:\"field_name\";s:26:\"field_fa_performance_state\";}}}s:39:\"field_data_field_fa_operational_message\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:39:\"field_data_field_fa_operational_message\";i:1;s:28:\"field_fa_operational_message\";}}}s:28:\"field_fa_operational_message\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:19:\"Operational Message\";s:11:\"title short\";s:19:\"Operational Message\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:39:\"field_data_field_fa_operational_message\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:28:\"field_fa_operational_message\";s:10:\"real field\";s:34:\"field_fa_operational_message_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:34:\"field_fa_operational_message_value\";i:4;s:35:\"field_fa_operational_message_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:34:\"field_fa_operational_message_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:50:\"Operational Message (field_fa_operational_message)\";s:11:\"title short\";s:19:\"Operational Message\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:34:\"field_fa_operational_message_value\";s:5:\"table\";s:39:\"field_data_field_fa_operational_message\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:34:\"field_fa_operational_message_value\";i:1;s:35:\"field_fa_operational_message_format\";}s:10:\"field_name\";s:28:\"field_fa_operational_message\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:34:\"field_fa_operational_message_value\";s:5:\"table\";s:39:\"field_data_field_fa_operational_message\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:34:\"field_fa_operational_message_value\";i:1;s:35:\"field_fa_operational_message_format\";}s:10:\"field_name\";s:28:\"field_fa_operational_message\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:34:\"field_fa_operational_message_value\";s:5:\"table\";s:39:\"field_data_field_fa_operational_message\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:34:\"field_fa_operational_message_value\";i:1;s:35:\"field_fa_operational_message_format\";}s:10:\"field_name\";s:28:\"field_fa_operational_message\";}}s:35:\"field_fa_operational_message_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:57:\"Operational Message (field_fa_operational_message:format)\";s:11:\"title short\";s:26:\"Operational Message:format\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:35:\"field_fa_operational_message_format\";s:5:\"table\";s:39:\"field_data_field_fa_operational_message\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:34:\"field_fa_operational_message_value\";i:1;s:35:\"field_fa_operational_message_format\";}s:10:\"field_name\";s:28:\"field_fa_operational_message\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:35:\"field_fa_operational_message_format\";s:5:\"table\";s:39:\"field_data_field_fa_operational_message\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:34:\"field_fa_operational_message_value\";i:1;s:35:\"field_fa_operational_message_format\";}s:10:\"field_name\";s:28:\"field_fa_operational_message\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:35:\"field_fa_operational_message_format\";s:5:\"table\";s:39:\"field_data_field_fa_operational_message\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:34:\"field_fa_operational_message_value\";i:1;s:35:\"field_fa_operational_message_format\";}s:10:\"field_name\";s:28:\"field_fa_operational_message\";}}}s:43:\"field_revision_field_fa_operational_message\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:43:\"field_revision_field_fa_operational_message\";i:1;s:40:\"field_fa_operational_message-revision_id\";}}}s:40:\"field_fa_operational_message-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:19:\"Operational Message\";s:11:\"title short\";s:19:\"Operational Message\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:43:\"field_revision_field_fa_operational_message\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:28:\"field_fa_operational_message\";s:10:\"real field\";s:46:\"field_fa_operational_message-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:34:\"field_fa_operational_message_value\";i:4;s:35:\"field_fa_operational_message_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:34:\"field_fa_operational_message_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:50:\"Operational Message (field_fa_operational_message)\";s:11:\"title short\";s:19:\"Operational Message\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:34:\"field_fa_operational_message_value\";s:5:\"table\";s:43:\"field_revision_field_fa_operational_message\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:34:\"field_fa_operational_message_value\";i:1;s:35:\"field_fa_operational_message_format\";}s:10:\"field_name\";s:28:\"field_fa_operational_message\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:34:\"field_fa_operational_message_value\";s:5:\"table\";s:43:\"field_revision_field_fa_operational_message\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:34:\"field_fa_operational_message_value\";i:1;s:35:\"field_fa_operational_message_format\";}s:10:\"field_name\";s:28:\"field_fa_operational_message\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:34:\"field_fa_operational_message_value\";s:5:\"table\";s:43:\"field_revision_field_fa_operational_message\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:34:\"field_fa_operational_message_value\";i:1;s:35:\"field_fa_operational_message_format\";}s:10:\"field_name\";s:28:\"field_fa_operational_message\";}}s:35:\"field_fa_operational_message_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:57:\"Operational Message (field_fa_operational_message:format)\";s:11:\"title short\";s:26:\"Operational Message:format\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:35:\"field_fa_operational_message_format\";s:5:\"table\";s:43:\"field_revision_field_fa_operational_message\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:34:\"field_fa_operational_message_value\";i:1;s:35:\"field_fa_operational_message_format\";}s:10:\"field_name\";s:28:\"field_fa_operational_message\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:35:\"field_fa_operational_message_format\";s:5:\"table\";s:43:\"field_revision_field_fa_operational_message\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:34:\"field_fa_operational_message_value\";i:1;s:35:\"field_fa_operational_message_format\";}s:10:\"field_name\";s:28:\"field_fa_operational_message\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:35:\"field_fa_operational_message_format\";s:5:\"table\";s:43:\"field_revision_field_fa_operational_message\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:34:\"field_fa_operational_message_value\";i:1;s:35:\"field_fa_operational_message_format\";}s:10:\"field_name\";s:28:\"field_fa_operational_message\";}}}s:37:\"field_data_field_fa_operational_state\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:37:\"field_data_field_fa_operational_state\";i:1;s:26:\"field_fa_operational_state\";}}}s:26:\"field_fa_operational_state\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:17:\"Operational State\";s:11:\"title short\";s:17:\"Operational State\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:37:\"field_data_field_fa_operational_state\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:26:\"field_fa_operational_state\";s:10:\"real field\";s:32:\"field_fa_operational_state_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:32:\"field_fa_operational_state_value\";i:4;s:33:\"field_fa_operational_state_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:32:\"field_fa_operational_state_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:46:\"Operational State (field_fa_operational_state)\";s:11:\"title short\";s:17:\"Operational State\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:32:\"field_fa_operational_state_value\";s:5:\"table\";s:37:\"field_data_field_fa_operational_state\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_operational_state_value\";i:1;s:33:\"field_fa_operational_state_format\";}s:10:\"field_name\";s:26:\"field_fa_operational_state\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:32:\"field_fa_operational_state_value\";s:5:\"table\";s:37:\"field_data_field_fa_operational_state\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_operational_state_value\";i:1;s:33:\"field_fa_operational_state_format\";}s:10:\"field_name\";s:26:\"field_fa_operational_state\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:32:\"field_fa_operational_state_value\";s:5:\"table\";s:37:\"field_data_field_fa_operational_state\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_operational_state_value\";i:1;s:33:\"field_fa_operational_state_format\";}s:10:\"field_name\";s:26:\"field_fa_operational_state\";}}s:33:\"field_fa_operational_state_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:53:\"Operational State (field_fa_operational_state:format)\";s:11:\"title short\";s:24:\"Operational State:format\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:33:\"field_fa_operational_state_format\";s:5:\"table\";s:37:\"field_data_field_fa_operational_state\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_operational_state_value\";i:1;s:33:\"field_fa_operational_state_format\";}s:10:\"field_name\";s:26:\"field_fa_operational_state\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:33:\"field_fa_operational_state_format\";s:5:\"table\";s:37:\"field_data_field_fa_operational_state\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_operational_state_value\";i:1;s:33:\"field_fa_operational_state_format\";}s:10:\"field_name\";s:26:\"field_fa_operational_state\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:33:\"field_fa_operational_state_format\";s:5:\"table\";s:37:\"field_data_field_fa_operational_state\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_operational_state_value\";i:1;s:33:\"field_fa_operational_state_format\";}s:10:\"field_name\";s:26:\"field_fa_operational_state\";}}}s:41:\"field_revision_field_fa_operational_state\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:41:\"field_revision_field_fa_operational_state\";i:1;s:38:\"field_fa_operational_state-revision_id\";}}}s:38:\"field_fa_operational_state-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:17:\"Operational State\";s:11:\"title short\";s:17:\"Operational State\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:41:\"field_revision_field_fa_operational_state\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:26:\"field_fa_operational_state\";s:10:\"real field\";s:44:\"field_fa_operational_state-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:32:\"field_fa_operational_state_value\";i:4;s:33:\"field_fa_operational_state_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:32:\"field_fa_operational_state_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:46:\"Operational State (field_fa_operational_state)\";s:11:\"title short\";s:17:\"Operational State\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:32:\"field_fa_operational_state_value\";s:5:\"table\";s:41:\"field_revision_field_fa_operational_state\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_operational_state_value\";i:1;s:33:\"field_fa_operational_state_format\";}s:10:\"field_name\";s:26:\"field_fa_operational_state\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:32:\"field_fa_operational_state_value\";s:5:\"table\";s:41:\"field_revision_field_fa_operational_state\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_operational_state_value\";i:1;s:33:\"field_fa_operational_state_format\";}s:10:\"field_name\";s:26:\"field_fa_operational_state\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:32:\"field_fa_operational_state_value\";s:5:\"table\";s:41:\"field_revision_field_fa_operational_state\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_operational_state_value\";i:1;s:33:\"field_fa_operational_state_format\";}s:10:\"field_name\";s:26:\"field_fa_operational_state\";}}s:33:\"field_fa_operational_state_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:53:\"Operational State (field_fa_operational_state:format)\";s:11:\"title short\";s:24:\"Operational State:format\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:33:\"field_fa_operational_state_format\";s:5:\"table\";s:41:\"field_revision_field_fa_operational_state\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_operational_state_value\";i:1;s:33:\"field_fa_operational_state_format\";}s:10:\"field_name\";s:26:\"field_fa_operational_state\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:33:\"field_fa_operational_state_format\";s:5:\"table\";s:41:\"field_revision_field_fa_operational_state\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_operational_state_value\";i:1;s:33:\"field_fa_operational_state_format\";}s:10:\"field_name\";s:26:\"field_fa_operational_state\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:33:\"field_fa_operational_state_format\";s:5:\"table\";s:41:\"field_revision_field_fa_operational_state\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:32:\"field_fa_operational_state_value\";i:1;s:33:\"field_fa_operational_state_format\";}s:10:\"field_name\";s:26:\"field_fa_operational_state\";}}}s:30:\"field_data_field_fa_cache_size\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:30:\"field_data_field_fa_cache_size\";i:1;s:19:\"field_fa_cache_size\";}}}s:19:\"field_fa_cache_size\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"Cache Size\";s:11:\"title short\";s:10:\"Cache Size\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:30:\"field_data_field_fa_cache_size\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_fa_cache_size\";s:10:\"real field\";s:25:\"field_fa_cache_size_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_fa_cache_size_value\";i:4;s:26:\"field_fa_cache_size_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:25:\"field_fa_cache_size_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:32:\"Cache Size (field_fa_cache_size)\";s:11:\"title short\";s:10:\"Cache Size\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_fa_cache_size_value\";s:5:\"table\";s:30:\"field_data_field_fa_cache_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_size_value\";i:1;s:26:\"field_fa_cache_size_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_fa_cache_size_value\";s:5:\"table\";s:30:\"field_data_field_fa_cache_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_size_value\";i:1;s:26:\"field_fa_cache_size_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_fa_cache_size_value\";s:5:\"table\";s:30:\"field_data_field_fa_cache_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_size_value\";i:1;s:26:\"field_fa_cache_size_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_size\";}}s:26:\"field_fa_cache_size_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:39:\"Cache Size (field_fa_cache_size:format)\";s:11:\"title short\";s:17:\"Cache Size:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_fa_cache_size_format\";s:5:\"table\";s:30:\"field_data_field_fa_cache_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_size_value\";i:1;s:26:\"field_fa_cache_size_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_fa_cache_size_format\";s:5:\"table\";s:30:\"field_data_field_fa_cache_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_size_value\";i:1;s:26:\"field_fa_cache_size_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_fa_cache_size_format\";s:5:\"table\";s:30:\"field_data_field_fa_cache_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_size_value\";i:1;s:26:\"field_fa_cache_size_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_size\";}}}s:34:\"field_revision_field_fa_cache_size\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:34:\"field_revision_field_fa_cache_size\";i:1;s:31:\"field_fa_cache_size-revision_id\";}}}s:31:\"field_fa_cache_size-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:10:\"Cache Size\";s:11:\"title short\";s:10:\"Cache Size\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:34:\"field_revision_field_fa_cache_size\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_fa_cache_size\";s:10:\"real field\";s:37:\"field_fa_cache_size-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_fa_cache_size_value\";i:4;s:26:\"field_fa_cache_size_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:25:\"field_fa_cache_size_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:32:\"Cache Size (field_fa_cache_size)\";s:11:\"title short\";s:10:\"Cache Size\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_fa_cache_size_value\";s:5:\"table\";s:34:\"field_revision_field_fa_cache_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_size_value\";i:1;s:26:\"field_fa_cache_size_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_fa_cache_size_value\";s:5:\"table\";s:34:\"field_revision_field_fa_cache_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_size_value\";i:1;s:26:\"field_fa_cache_size_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_fa_cache_size_value\";s:5:\"table\";s:34:\"field_revision_field_fa_cache_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_size_value\";i:1;s:26:\"field_fa_cache_size_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_size\";}}s:26:\"field_fa_cache_size_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:39:\"Cache Size (field_fa_cache_size:format)\";s:11:\"title short\";s:17:\"Cache Size:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_fa_cache_size_format\";s:5:\"table\";s:34:\"field_revision_field_fa_cache_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_size_value\";i:1;s:26:\"field_fa_cache_size_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_fa_cache_size_format\";s:5:\"table\";s:34:\"field_revision_field_fa_cache_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_size_value\";i:1;s:26:\"field_fa_cache_size_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_fa_cache_size_format\";s:5:\"table\";s:34:\"field_revision_field_fa_cache_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_size_value\";i:1;s:26:\"field_fa_cache_size_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_size\";}}}s:40:\"field_data_field_fa_administration_state\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:40:\"field_data_field_fa_administration_state\";i:1;s:29:\"field_fa_administration_state\";}}}s:29:\"field_fa_administration_state\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:20:\"Administration State\";s:11:\"title short\";s:20:\"Administration State\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:40:\"field_data_field_fa_administration_state\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:29:\"field_fa_administration_state\";s:10:\"real field\";s:35:\"field_fa_administration_state_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:35:\"field_fa_administration_state_value\";i:4;s:36:\"field_fa_administration_state_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:35:\"field_fa_administration_state_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:52:\"Administration State (field_fa_administration_state)\";s:11:\"title short\";s:20:\"Administration State\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:35:\"field_fa_administration_state_value\";s:5:\"table\";s:40:\"field_data_field_fa_administration_state\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:35:\"field_fa_administration_state_value\";i:1;s:36:\"field_fa_administration_state_format\";}s:10:\"field_name\";s:29:\"field_fa_administration_state\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:35:\"field_fa_administration_state_value\";s:5:\"table\";s:40:\"field_data_field_fa_administration_state\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:35:\"field_fa_administration_state_value\";i:1;s:36:\"field_fa_administration_state_format\";}s:10:\"field_name\";s:29:\"field_fa_administration_state\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:35:\"field_fa_administration_state_value\";s:5:\"table\";s:40:\"field_data_field_fa_administration_state\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:35:\"field_fa_administration_state_value\";i:1;s:36:\"field_fa_administration_state_format\";}s:10:\"field_name\";s:29:\"field_fa_administration_state\";}}s:36:\"field_fa_administration_state_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:59:\"Administration State (field_fa_administration_state:format)\";s:11:\"title short\";s:27:\"Administration State:format\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:36:\"field_fa_administration_state_format\";s:5:\"table\";s:40:\"field_data_field_fa_administration_state\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:35:\"field_fa_administration_state_value\";i:1;s:36:\"field_fa_administration_state_format\";}s:10:\"field_name\";s:29:\"field_fa_administration_state\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:36:\"field_fa_administration_state_format\";s:5:\"table\";s:40:\"field_data_field_fa_administration_state\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:35:\"field_fa_administration_state_value\";i:1;s:36:\"field_fa_administration_state_format\";}s:10:\"field_name\";s:29:\"field_fa_administration_state\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:36:\"field_fa_administration_state_format\";s:5:\"table\";s:40:\"field_data_field_fa_administration_state\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:35:\"field_fa_administration_state_value\";i:1;s:36:\"field_fa_administration_state_format\";}s:10:\"field_name\";s:29:\"field_fa_administration_state\";}}}s:44:\"field_revision_field_fa_administration_state\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:44:\"field_revision_field_fa_administration_state\";i:1;s:41:\"field_fa_administration_state-revision_id\";}}}s:41:\"field_fa_administration_state-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:20:\"Administration State\";s:11:\"title short\";s:20:\"Administration State\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:44:\"field_revision_field_fa_administration_state\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:29:\"field_fa_administration_state\";s:10:\"real field\";s:47:\"field_fa_administration_state-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:35:\"field_fa_administration_state_value\";i:4;s:36:\"field_fa_administration_state_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:35:\"field_fa_administration_state_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:52:\"Administration State (field_fa_administration_state)\";s:11:\"title short\";s:20:\"Administration State\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:35:\"field_fa_administration_state_value\";s:5:\"table\";s:44:\"field_revision_field_fa_administration_state\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:35:\"field_fa_administration_state_value\";i:1;s:36:\"field_fa_administration_state_format\";}s:10:\"field_name\";s:29:\"field_fa_administration_state\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:35:\"field_fa_administration_state_value\";s:5:\"table\";s:44:\"field_revision_field_fa_administration_state\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:35:\"field_fa_administration_state_value\";i:1;s:36:\"field_fa_administration_state_format\";}s:10:\"field_name\";s:29:\"field_fa_administration_state\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:35:\"field_fa_administration_state_value\";s:5:\"table\";s:44:\"field_revision_field_fa_administration_state\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:35:\"field_fa_administration_state_value\";i:1;s:36:\"field_fa_administration_state_format\";}s:10:\"field_name\";s:29:\"field_fa_administration_state\";}}s:36:\"field_fa_administration_state_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:59:\"Administration State (field_fa_administration_state:format)\";s:11:\"title short\";s:27:\"Administration State:format\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:36:\"field_fa_administration_state_format\";s:5:\"table\";s:44:\"field_revision_field_fa_administration_state\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:35:\"field_fa_administration_state_value\";i:1;s:36:\"field_fa_administration_state_format\";}s:10:\"field_name\";s:29:\"field_fa_administration_state\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:36:\"field_fa_administration_state_format\";s:5:\"table\";s:44:\"field_revision_field_fa_administration_state\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:35:\"field_fa_administration_state_value\";i:1;s:36:\"field_fa_administration_state_format\";}s:10:\"field_name\";s:29:\"field_fa_administration_state\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:36:\"field_fa_administration_state_format\";s:5:\"table\";s:44:\"field_revision_field_fa_administration_state\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:35:\"field_fa_administration_state_value\";i:1;s:36:\"field_fa_administration_state_format\";}s:10:\"field_name\";s:29:\"field_fa_administration_state\";}}}s:30:\"field_data_field_fa_cache_mode\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:30:\"field_data_field_fa_cache_mode\";i:1;s:19:\"field_fa_cache_mode\";}}}s:19:\"field_fa_cache_mode\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"Cache Mode\";s:11:\"title short\";s:10:\"Cache Mode\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:30:\"field_data_field_fa_cache_mode\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_fa_cache_mode\";s:10:\"real field\";s:25:\"field_fa_cache_mode_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_fa_cache_mode_value\";i:4;s:26:\"field_fa_cache_mode_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:25:\"field_fa_cache_mode_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:32:\"Cache Mode (field_fa_cache_mode)\";s:11:\"title short\";s:10:\"Cache Mode\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_fa_cache_mode_value\";s:5:\"table\";s:30:\"field_data_field_fa_cache_mode\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_mode_value\";i:1;s:26:\"field_fa_cache_mode_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_mode\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_fa_cache_mode_value\";s:5:\"table\";s:30:\"field_data_field_fa_cache_mode\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_mode_value\";i:1;s:26:\"field_fa_cache_mode_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_mode\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_fa_cache_mode_value\";s:5:\"table\";s:30:\"field_data_field_fa_cache_mode\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_mode_value\";i:1;s:26:\"field_fa_cache_mode_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_mode\";}}s:26:\"field_fa_cache_mode_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:39:\"Cache Mode (field_fa_cache_mode:format)\";s:11:\"title short\";s:17:\"Cache Mode:format\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_fa_cache_mode_format\";s:5:\"table\";s:30:\"field_data_field_fa_cache_mode\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_mode_value\";i:1;s:26:\"field_fa_cache_mode_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_mode\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_fa_cache_mode_format\";s:5:\"table\";s:30:\"field_data_field_fa_cache_mode\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_mode_value\";i:1;s:26:\"field_fa_cache_mode_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_mode\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_fa_cache_mode_format\";s:5:\"table\";s:30:\"field_data_field_fa_cache_mode\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_mode_value\";i:1;s:26:\"field_fa_cache_mode_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_mode\";}}}s:34:\"field_revision_field_fa_cache_mode\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:34:\"field_revision_field_fa_cache_mode\";i:1;s:31:\"field_fa_cache_mode-revision_id\";}}}s:31:\"field_fa_cache_mode-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:10:\"Cache Mode\";s:11:\"title short\";s:10:\"Cache Mode\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:34:\"field_revision_field_fa_cache_mode\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_fa_cache_mode\";s:10:\"real field\";s:37:\"field_fa_cache_mode-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_fa_cache_mode_value\";i:4;s:26:\"field_fa_cache_mode_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:25:\"field_fa_cache_mode_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:32:\"Cache Mode (field_fa_cache_mode)\";s:11:\"title short\";s:10:\"Cache Mode\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_fa_cache_mode_value\";s:5:\"table\";s:34:\"field_revision_field_fa_cache_mode\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_mode_value\";i:1;s:26:\"field_fa_cache_mode_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_mode\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_fa_cache_mode_value\";s:5:\"table\";s:34:\"field_revision_field_fa_cache_mode\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_mode_value\";i:1;s:26:\"field_fa_cache_mode_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_mode\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_fa_cache_mode_value\";s:5:\"table\";s:34:\"field_revision_field_fa_cache_mode\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_mode_value\";i:1;s:26:\"field_fa_cache_mode_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_mode\";}}s:26:\"field_fa_cache_mode_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:39:\"Cache Mode (field_fa_cache_mode:format)\";s:11:\"title short\";s:17:\"Cache Mode:format\";s:4:\"help\";s:45:\"Appears in: node:virtual_machine, node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_fa_cache_mode_format\";s:5:\"table\";s:34:\"field_revision_field_fa_cache_mode\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_mode_value\";i:1;s:26:\"field_fa_cache_mode_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_mode\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_fa_cache_mode_format\";s:5:\"table\";s:34:\"field_revision_field_fa_cache_mode\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_mode_value\";i:1;s:26:\"field_fa_cache_mode_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_mode\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_fa_cache_mode_format\";s:5:\"table\";s:34:\"field_revision_field_fa_cache_mode\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_fa_cache_mode_value\";i:1;s:26:\"field_fa_cache_mode_format\";}s:10:\"field_name\";s:19:\"field_fa_cache_mode\";}}}s:33:\"field_data_field_fa_build_version\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:33:\"field_data_field_fa_build_version\";i:1;s:22:\"field_fa_build_version\";}}}s:22:\"field_fa_build_version\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:13:\"Build Version\";s:11:\"title short\";s:13:\"Build Version\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:33:\"field_data_field_fa_build_version\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_fa_build_version\";s:10:\"real field\";s:28:\"field_fa_build_version_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_fa_build_version_value\";i:4;s:29:\"field_fa_build_version_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:28:\"field_fa_build_version_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:38:\"Build Version (field_fa_build_version)\";s:11:\"title short\";s:13:\"Build Version\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_fa_build_version_value\";s:5:\"table\";s:33:\"field_data_field_fa_build_version\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_build_version_value\";i:1;s:29:\"field_fa_build_version_format\";}s:10:\"field_name\";s:22:\"field_fa_build_version\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_fa_build_version_value\";s:5:\"table\";s:33:\"field_data_field_fa_build_version\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_build_version_value\";i:1;s:29:\"field_fa_build_version_format\";}s:10:\"field_name\";s:22:\"field_fa_build_version\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_fa_build_version_value\";s:5:\"table\";s:33:\"field_data_field_fa_build_version\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_build_version_value\";i:1;s:29:\"field_fa_build_version_format\";}s:10:\"field_name\";s:22:\"field_fa_build_version\";}}s:29:\"field_fa_build_version_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:45:\"Build Version (field_fa_build_version:format)\";s:11:\"title short\";s:20:\"Build Version:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_fa_build_version_format\";s:5:\"table\";s:33:\"field_data_field_fa_build_version\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_build_version_value\";i:1;s:29:\"field_fa_build_version_format\";}s:10:\"field_name\";s:22:\"field_fa_build_version\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_fa_build_version_format\";s:5:\"table\";s:33:\"field_data_field_fa_build_version\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_build_version_value\";i:1;s:29:\"field_fa_build_version_format\";}s:10:\"field_name\";s:22:\"field_fa_build_version\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_fa_build_version_format\";s:5:\"table\";s:33:\"field_data_field_fa_build_version\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_build_version_value\";i:1;s:29:\"field_fa_build_version_format\";}s:10:\"field_name\";s:22:\"field_fa_build_version\";}}}s:37:\"field_revision_field_fa_build_version\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:37:\"field_revision_field_fa_build_version\";i:1;s:34:\"field_fa_build_version-revision_id\";}}}s:34:\"field_fa_build_version-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:13:\"Build Version\";s:11:\"title short\";s:13:\"Build Version\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:37:\"field_revision_field_fa_build_version\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_fa_build_version\";s:10:\"real field\";s:40:\"field_fa_build_version-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_fa_build_version_value\";i:4;s:29:\"field_fa_build_version_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:28:\"field_fa_build_version_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:38:\"Build Version (field_fa_build_version)\";s:11:\"title short\";s:13:\"Build Version\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_fa_build_version_value\";s:5:\"table\";s:37:\"field_revision_field_fa_build_version\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_build_version_value\";i:1;s:29:\"field_fa_build_version_format\";}s:10:\"field_name\";s:22:\"field_fa_build_version\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_fa_build_version_value\";s:5:\"table\";s:37:\"field_revision_field_fa_build_version\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_build_version_value\";i:1;s:29:\"field_fa_build_version_format\";}s:10:\"field_name\";s:22:\"field_fa_build_version\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_fa_build_version_value\";s:5:\"table\";s:37:\"field_revision_field_fa_build_version\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_build_version_value\";i:1;s:29:\"field_fa_build_version_format\";}s:10:\"field_name\";s:22:\"field_fa_build_version\";}}s:29:\"field_fa_build_version_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:45:\"Build Version (field_fa_build_version:format)\";s:11:\"title short\";s:20:\"Build Version:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_fa_build_version_format\";s:5:\"table\";s:37:\"field_revision_field_fa_build_version\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_build_version_value\";i:1;s:29:\"field_fa_build_version_format\";}s:10:\"field_name\";s:22:\"field_fa_build_version\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_fa_build_version_format\";s:5:\"table\";s:37:\"field_revision_field_fa_build_version\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_build_version_value\";i:1;s:29:\"field_fa_build_version_format\";}s:10:\"field_name\";s:22:\"field_fa_build_version\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_fa_build_version_format\";s:5:\"table\";s:37:\"field_revision_field_fa_build_version\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_fa_build_version_value\";i:1;s:29:\"field_fa_build_version_format\";}s:10:\"field_name\";s:22:\"field_fa_build_version\";}}}s:30:\"field_data_field_virtual_disks\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:30:\"field_data_field_virtual_disks\";i:1;s:19:\"field_virtual_disks\";}}}s:19:\"field_virtual_disks\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:13:\"virtual_disks\";s:11:\"title short\";s:13:\"virtual_disks\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:30:\"field_data_field_virtual_disks\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_virtual_disks\";s:10:\"real field\";s:25:\"field_virtual_disks_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_virtual_disks_value\";i:4;s:26:\"field_virtual_disks_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:25:\"field_virtual_disks_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:35:\"virtual_disks (field_virtual_disks)\";s:11:\"title short\";s:13:\"virtual_disks\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_virtual_disks_value\";s:5:\"table\";s:30:\"field_data_field_virtual_disks\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_virtual_disks_value\";i:1;s:26:\"field_virtual_disks_format\";}s:10:\"field_name\";s:19:\"field_virtual_disks\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_virtual_disks_value\";s:5:\"table\";s:30:\"field_data_field_virtual_disks\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_virtual_disks_value\";i:1;s:26:\"field_virtual_disks_format\";}s:10:\"field_name\";s:19:\"field_virtual_disks\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_virtual_disks_value\";s:5:\"table\";s:30:\"field_data_field_virtual_disks\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_virtual_disks_value\";i:1;s:26:\"field_virtual_disks_format\";}s:10:\"field_name\";s:19:\"field_virtual_disks\";}}s:26:\"field_virtual_disks_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:42:\"virtual_disks (field_virtual_disks:format)\";s:11:\"title short\";s:20:\"virtual_disks:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_virtual_disks_format\";s:5:\"table\";s:30:\"field_data_field_virtual_disks\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_virtual_disks_value\";i:1;s:26:\"field_virtual_disks_format\";}s:10:\"field_name\";s:19:\"field_virtual_disks\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_virtual_disks_format\";s:5:\"table\";s:30:\"field_data_field_virtual_disks\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_virtual_disks_value\";i:1;s:26:\"field_virtual_disks_format\";}s:10:\"field_name\";s:19:\"field_virtual_disks\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_virtual_disks_format\";s:5:\"table\";s:30:\"field_data_field_virtual_disks\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_virtual_disks_value\";i:1;s:26:\"field_virtual_disks_format\";}s:10:\"field_name\";s:19:\"field_virtual_disks\";}}}s:34:\"field_revision_field_virtual_disks\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:34:\"field_revision_field_virtual_disks\";i:1;s:31:\"field_virtual_disks-revision_id\";}}}s:31:\"field_virtual_disks-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:13:\"virtual_disks\";s:11:\"title short\";s:13:\"virtual_disks\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:34:\"field_revision_field_virtual_disks\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_virtual_disks\";s:10:\"real field\";s:37:\"field_virtual_disks-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_virtual_disks_value\";i:4;s:26:\"field_virtual_disks_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:25:\"field_virtual_disks_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:35:\"virtual_disks (field_virtual_disks)\";s:11:\"title short\";s:13:\"virtual_disks\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_virtual_disks_value\";s:5:\"table\";s:34:\"field_revision_field_virtual_disks\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_virtual_disks_value\";i:1;s:26:\"field_virtual_disks_format\";}s:10:\"field_name\";s:19:\"field_virtual_disks\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_virtual_disks_value\";s:5:\"table\";s:34:\"field_revision_field_virtual_disks\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_virtual_disks_value\";i:1;s:26:\"field_virtual_disks_format\";}s:10:\"field_name\";s:19:\"field_virtual_disks\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_virtual_disks_value\";s:5:\"table\";s:34:\"field_revision_field_virtual_disks\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_virtual_disks_value\";i:1;s:26:\"field_virtual_disks_format\";}s:10:\"field_name\";s:19:\"field_virtual_disks\";}}s:26:\"field_virtual_disks_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:42:\"virtual_disks (field_virtual_disks:format)\";s:11:\"title short\";s:20:\"virtual_disks:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_virtual_disks_format\";s:5:\"table\";s:34:\"field_revision_field_virtual_disks\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_virtual_disks_value\";i:1;s:26:\"field_virtual_disks_format\";}s:10:\"field_name\";s:19:\"field_virtual_disks\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_virtual_disks_format\";s:5:\"table\";s:34:\"field_revision_field_virtual_disks\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_virtual_disks_value\";i:1;s:26:\"field_virtual_disks_format\";}s:10:\"field_name\";s:19:\"field_virtual_disks\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_virtual_disks_format\";s:5:\"table\";s:34:\"field_revision_field_virtual_disks\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_virtual_disks_value\";i:1;s:26:\"field_virtual_disks_format\";}s:10:\"field_name\";s:19:\"field_virtual_disks\";}}}s:26:\"field_data_field_no_of_cpu\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:26:\"field_data_field_no_of_cpu\";i:1;s:15:\"field_no_of_cpu\";}}}s:15:\"field_no_of_cpu\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:9:\"no_of_cpu\";s:11:\"title short\";s:9:\"no_of_cpu\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:26:\"field_data_field_no_of_cpu\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:15:\"field_no_of_cpu\";s:10:\"real field\";s:21:\"field_no_of_cpu_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:21:\"field_no_of_cpu_value\";i:4;s:22:\"field_no_of_cpu_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:21:\"field_no_of_cpu_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:27:\"no_of_cpu (field_no_of_cpu)\";s:11:\"title short\";s:9:\"no_of_cpu\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_no_of_cpu_value\";s:5:\"table\";s:26:\"field_data_field_no_of_cpu\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_no_of_cpu_value\";i:1;s:22:\"field_no_of_cpu_format\";}s:10:\"field_name\";s:15:\"field_no_of_cpu\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_no_of_cpu_value\";s:5:\"table\";s:26:\"field_data_field_no_of_cpu\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_no_of_cpu_value\";i:1;s:22:\"field_no_of_cpu_format\";}s:10:\"field_name\";s:15:\"field_no_of_cpu\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_no_of_cpu_value\";s:5:\"table\";s:26:\"field_data_field_no_of_cpu\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_no_of_cpu_value\";i:1;s:22:\"field_no_of_cpu_format\";}s:10:\"field_name\";s:15:\"field_no_of_cpu\";}}s:22:\"field_no_of_cpu_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:34:\"no_of_cpu (field_no_of_cpu:format)\";s:11:\"title short\";s:16:\"no_of_cpu:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_no_of_cpu_format\";s:5:\"table\";s:26:\"field_data_field_no_of_cpu\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_no_of_cpu_value\";i:1;s:22:\"field_no_of_cpu_format\";}s:10:\"field_name\";s:15:\"field_no_of_cpu\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_no_of_cpu_format\";s:5:\"table\";s:26:\"field_data_field_no_of_cpu\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_no_of_cpu_value\";i:1;s:22:\"field_no_of_cpu_format\";}s:10:\"field_name\";s:15:\"field_no_of_cpu\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_no_of_cpu_format\";s:5:\"table\";s:26:\"field_data_field_no_of_cpu\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_no_of_cpu_value\";i:1;s:22:\"field_no_of_cpu_format\";}s:10:\"field_name\";s:15:\"field_no_of_cpu\";}}}s:30:\"field_revision_field_no_of_cpu\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:30:\"field_revision_field_no_of_cpu\";i:1;s:27:\"field_no_of_cpu-revision_id\";}}}s:27:\"field_no_of_cpu-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:9:\"no_of_cpu\";s:11:\"title short\";s:9:\"no_of_cpu\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:30:\"field_revision_field_no_of_cpu\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:15:\"field_no_of_cpu\";s:10:\"real field\";s:33:\"field_no_of_cpu-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:21:\"field_no_of_cpu_value\";i:4;s:22:\"field_no_of_cpu_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:21:\"field_no_of_cpu_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:27:\"no_of_cpu (field_no_of_cpu)\";s:11:\"title short\";s:9:\"no_of_cpu\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_no_of_cpu_value\";s:5:\"table\";s:30:\"field_revision_field_no_of_cpu\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_no_of_cpu_value\";i:1;s:22:\"field_no_of_cpu_format\";}s:10:\"field_name\";s:15:\"field_no_of_cpu\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_no_of_cpu_value\";s:5:\"table\";s:30:\"field_revision_field_no_of_cpu\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_no_of_cpu_value\";i:1;s:22:\"field_no_of_cpu_format\";}s:10:\"field_name\";s:15:\"field_no_of_cpu\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_no_of_cpu_value\";s:5:\"table\";s:30:\"field_revision_field_no_of_cpu\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_no_of_cpu_value\";i:1;s:22:\"field_no_of_cpu_format\";}s:10:\"field_name\";s:15:\"field_no_of_cpu\";}}s:22:\"field_no_of_cpu_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:34:\"no_of_cpu (field_no_of_cpu:format)\";s:11:\"title short\";s:16:\"no_of_cpu:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_no_of_cpu_format\";s:5:\"table\";s:30:\"field_revision_field_no_of_cpu\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_no_of_cpu_value\";i:1;s:22:\"field_no_of_cpu_format\";}s:10:\"field_name\";s:15:\"field_no_of_cpu\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_no_of_cpu_format\";s:5:\"table\";s:30:\"field_revision_field_no_of_cpu\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_no_of_cpu_value\";i:1;s:22:\"field_no_of_cpu_format\";}s:10:\"field_name\";s:15:\"field_no_of_cpu\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_no_of_cpu_format\";s:5:\"table\";s:30:\"field_revision_field_no_of_cpu\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_no_of_cpu_value\";i:1;s:22:\"field_no_of_cpu_format\";}s:10:\"field_name\";s:15:\"field_no_of_cpu\";}}}s:29:\"field_data_field_device_state\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:29:\"field_data_field_device_state\";i:1;s:18:\"field_device_state\";}}}s:18:\"field_device_state\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:12:\"Device State\";s:11:\"title short\";s:12:\"Device State\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:29:\"field_data_field_device_state\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:18:\"field_device_state\";s:10:\"real field\";s:24:\"field_device_state_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:24:\"field_device_state_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:24:\"field_device_state_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:33:\"Device State (field_device_state)\";s:11:\"title short\";s:12:\"Device State\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_device_state_value\";s:5:\"table\";s:29:\"field_data_field_device_state\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_device_state_value\";}s:10:\"field_name\";s:18:\"field_device_state\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_device_state_value\";s:5:\"table\";s:29:\"field_data_field_device_state\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_device_state_value\";}s:10:\"field_name\";s:18:\"field_device_state\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_device_state_value\";s:5:\"table\";s:29:\"field_data_field_device_state\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_device_state_value\";}s:10:\"field_name\";s:18:\"field_device_state\";}}}s:33:\"field_revision_field_device_state\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:33:\"field_revision_field_device_state\";i:1;s:30:\"field_device_state-revision_id\";}}}s:30:\"field_device_state-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:12:\"Device State\";s:11:\"title short\";s:12:\"Device State\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:33:\"field_revision_field_device_state\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:18:\"field_device_state\";s:10:\"real field\";s:36:\"field_device_state-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:24:\"field_device_state_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:24:\"field_device_state_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:33:\"Device State (field_device_state)\";s:11:\"title short\";s:12:\"Device State\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_device_state_value\";s:5:\"table\";s:33:\"field_revision_field_device_state\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_device_state_value\";}s:10:\"field_name\";s:18:\"field_device_state\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_device_state_value\";s:5:\"table\";s:33:\"field_revision_field_device_state\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_device_state_value\";}s:10:\"field_name\";s:18:\"field_device_state\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_device_state_value\";s:5:\"table\";s:33:\"field_revision_field_device_state\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_device_state_value\";}s:10:\"field_name\";s:18:\"field_device_state\";}}}s:31:\"field_data_field_allocated_size\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:31:\"field_data_field_allocated_size\";i:1;s:20:\"field_allocated_size\";}}}s:20:\"field_allocated_size\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:14:\"Allocated Size\";s:11:\"title short\";s:14:\"Allocated Size\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:31:\"field_data_field_allocated_size\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:20:\"field_allocated_size\";s:10:\"real field\";s:26:\"field_allocated_size_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:26:\"field_allocated_size_value\";i:4;s:27:\"field_allocated_size_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:26:\"field_allocated_size_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:37:\"Allocated Size (field_allocated_size)\";s:11:\"title short\";s:14:\"Allocated Size\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_allocated_size_value\";s:5:\"table\";s:31:\"field_data_field_allocated_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_allocated_size_value\";i:1;s:27:\"field_allocated_size_format\";}s:10:\"field_name\";s:20:\"field_allocated_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_allocated_size_value\";s:5:\"table\";s:31:\"field_data_field_allocated_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_allocated_size_value\";i:1;s:27:\"field_allocated_size_format\";}s:10:\"field_name\";s:20:\"field_allocated_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_allocated_size_value\";s:5:\"table\";s:31:\"field_data_field_allocated_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_allocated_size_value\";i:1;s:27:\"field_allocated_size_format\";}s:10:\"field_name\";s:20:\"field_allocated_size\";}}s:27:\"field_allocated_size_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:44:\"Allocated Size (field_allocated_size:format)\";s:11:\"title short\";s:21:\"Allocated Size:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:27:\"field_allocated_size_format\";s:5:\"table\";s:31:\"field_data_field_allocated_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_allocated_size_value\";i:1;s:27:\"field_allocated_size_format\";}s:10:\"field_name\";s:20:\"field_allocated_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:27:\"field_allocated_size_format\";s:5:\"table\";s:31:\"field_data_field_allocated_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_allocated_size_value\";i:1;s:27:\"field_allocated_size_format\";}s:10:\"field_name\";s:20:\"field_allocated_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:27:\"field_allocated_size_format\";s:5:\"table\";s:31:\"field_data_field_allocated_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_allocated_size_value\";i:1;s:27:\"field_allocated_size_format\";}s:10:\"field_name\";s:20:\"field_allocated_size\";}}}s:35:\"field_revision_field_allocated_size\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:35:\"field_revision_field_allocated_size\";i:1;s:32:\"field_allocated_size-revision_id\";}}}s:32:\"field_allocated_size-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:14:\"Allocated Size\";s:11:\"title short\";s:14:\"Allocated Size\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:35:\"field_revision_field_allocated_size\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:20:\"field_allocated_size\";s:10:\"real field\";s:38:\"field_allocated_size-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:26:\"field_allocated_size_value\";i:4;s:27:\"field_allocated_size_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:26:\"field_allocated_size_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:37:\"Allocated Size (field_allocated_size)\";s:11:\"title short\";s:14:\"Allocated Size\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_allocated_size_value\";s:5:\"table\";s:35:\"field_revision_field_allocated_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_allocated_size_value\";i:1;s:27:\"field_allocated_size_format\";}s:10:\"field_name\";s:20:\"field_allocated_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_allocated_size_value\";s:5:\"table\";s:35:\"field_revision_field_allocated_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_allocated_size_value\";i:1;s:27:\"field_allocated_size_format\";}s:10:\"field_name\";s:20:\"field_allocated_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_allocated_size_value\";s:5:\"table\";s:35:\"field_revision_field_allocated_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_allocated_size_value\";i:1;s:27:\"field_allocated_size_format\";}s:10:\"field_name\";s:20:\"field_allocated_size\";}}s:27:\"field_allocated_size_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:44:\"Allocated Size (field_allocated_size:format)\";s:11:\"title short\";s:21:\"Allocated Size:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:27:\"field_allocated_size_format\";s:5:\"table\";s:35:\"field_revision_field_allocated_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_allocated_size_value\";i:1;s:27:\"field_allocated_size_format\";}s:10:\"field_name\";s:20:\"field_allocated_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:27:\"field_allocated_size_format\";s:5:\"table\";s:35:\"field_revision_field_allocated_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_allocated_size_value\";i:1;s:27:\"field_allocated_size_format\";}s:10:\"field_name\";s:20:\"field_allocated_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:27:\"field_allocated_size_format\";s:5:\"table\";s:35:\"field_revision_field_allocated_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_allocated_size_value\";i:1;s:27:\"field_allocated_size_format\";}s:10:\"field_name\";s:20:\"field_allocated_size\";}}}s:31:\"field_data_field_naa_identifier\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:31:\"field_data_field_naa_identifier\";i:1;s:20:\"field_naa_identifier\";}}}s:20:\"field_naa_identifier\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:14:\"NAA Identifier\";s:11:\"title short\";s:14:\"NAA Identifier\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:31:\"field_data_field_naa_identifier\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:20:\"field_naa_identifier\";s:10:\"real field\";s:26:\"field_naa_identifier_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:26:\"field_naa_identifier_value\";i:4;s:27:\"field_naa_identifier_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:26:\"field_naa_identifier_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:37:\"NAA Identifier (field_naa_identifier)\";s:11:\"title short\";s:14:\"NAA Identifier\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_naa_identifier_value\";s:5:\"table\";s:31:\"field_data_field_naa_identifier\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_naa_identifier_value\";i:1;s:27:\"field_naa_identifier_format\";}s:10:\"field_name\";s:20:\"field_naa_identifier\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_naa_identifier_value\";s:5:\"table\";s:31:\"field_data_field_naa_identifier\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_naa_identifier_value\";i:1;s:27:\"field_naa_identifier_format\";}s:10:\"field_name\";s:20:\"field_naa_identifier\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_naa_identifier_value\";s:5:\"table\";s:31:\"field_data_field_naa_identifier\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_naa_identifier_value\";i:1;s:27:\"field_naa_identifier_format\";}s:10:\"field_name\";s:20:\"field_naa_identifier\";}}s:27:\"field_naa_identifier_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:44:\"NAA Identifier (field_naa_identifier:format)\";s:11:\"title short\";s:21:\"NAA Identifier:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:27:\"field_naa_identifier_format\";s:5:\"table\";s:31:\"field_data_field_naa_identifier\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_naa_identifier_value\";i:1;s:27:\"field_naa_identifier_format\";}s:10:\"field_name\";s:20:\"field_naa_identifier\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:27:\"field_naa_identifier_format\";s:5:\"table\";s:31:\"field_data_field_naa_identifier\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_naa_identifier_value\";i:1;s:27:\"field_naa_identifier_format\";}s:10:\"field_name\";s:20:\"field_naa_identifier\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:27:\"field_naa_identifier_format\";s:5:\"table\";s:31:\"field_data_field_naa_identifier\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_naa_identifier_value\";i:1;s:27:\"field_naa_identifier_format\";}s:10:\"field_name\";s:20:\"field_naa_identifier\";}}}s:35:\"field_revision_field_naa_identifier\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:35:\"field_revision_field_naa_identifier\";i:1;s:32:\"field_naa_identifier-revision_id\";}}}s:32:\"field_naa_identifier-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:14:\"NAA Identifier\";s:11:\"title short\";s:14:\"NAA Identifier\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:35:\"field_revision_field_naa_identifier\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:20:\"field_naa_identifier\";s:10:\"real field\";s:38:\"field_naa_identifier-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:26:\"field_naa_identifier_value\";i:4;s:27:\"field_naa_identifier_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:26:\"field_naa_identifier_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:37:\"NAA Identifier (field_naa_identifier)\";s:11:\"title short\";s:14:\"NAA Identifier\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_naa_identifier_value\";s:5:\"table\";s:35:\"field_revision_field_naa_identifier\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_naa_identifier_value\";i:1;s:27:\"field_naa_identifier_format\";}s:10:\"field_name\";s:20:\"field_naa_identifier\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_naa_identifier_value\";s:5:\"table\";s:35:\"field_revision_field_naa_identifier\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_naa_identifier_value\";i:1;s:27:\"field_naa_identifier_format\";}s:10:\"field_name\";s:20:\"field_naa_identifier\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_naa_identifier_value\";s:5:\"table\";s:35:\"field_revision_field_naa_identifier\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_naa_identifier_value\";i:1;s:27:\"field_naa_identifier_format\";}s:10:\"field_name\";s:20:\"field_naa_identifier\";}}s:27:\"field_naa_identifier_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:44:\"NAA Identifier (field_naa_identifier:format)\";s:11:\"title short\";s:21:\"NAA Identifier:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:27:\"field_naa_identifier_format\";s:5:\"table\";s:35:\"field_revision_field_naa_identifier\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_naa_identifier_value\";i:1;s:27:\"field_naa_identifier_format\";}s:10:\"field_name\";s:20:\"field_naa_identifier\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:27:\"field_naa_identifier_format\";s:5:\"table\";s:35:\"field_revision_field_naa_identifier\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_naa_identifier_value\";i:1;s:27:\"field_naa_identifier_format\";}s:10:\"field_name\";s:20:\"field_naa_identifier\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:27:\"field_naa_identifier_format\";s:5:\"table\";s:35:\"field_revision_field_naa_identifier\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:26:\"field_naa_identifier_value\";i:1;s:27:\"field_naa_identifier_format\";}s:10:\"field_name\";s:20:\"field_naa_identifier\";}}}s:27:\"field_data_field_total_size\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:27:\"field_data_field_total_size\";i:1;s:16:\"field_total_size\";}}}s:16:\"field_total_size\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"Total Size\";s:11:\"title short\";s:10:\"Total Size\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:27:\"field_data_field_total_size\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_total_size\";s:10:\"real field\";s:22:\"field_total_size_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_total_size_value\";i:4;s:23:\"field_total_size_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:22:\"field_total_size_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:29:\"Total Size (field_total_size)\";s:11:\"title short\";s:10:\"Total Size\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_total_size_value\";s:5:\"table\";s:27:\"field_data_field_total_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_total_size_value\";i:1;s:23:\"field_total_size_format\";}s:10:\"field_name\";s:16:\"field_total_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_total_size_value\";s:5:\"table\";s:27:\"field_data_field_total_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_total_size_value\";i:1;s:23:\"field_total_size_format\";}s:10:\"field_name\";s:16:\"field_total_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_total_size_value\";s:5:\"table\";s:27:\"field_data_field_total_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_total_size_value\";i:1;s:23:\"field_total_size_format\";}s:10:\"field_name\";s:16:\"field_total_size\";}}s:23:\"field_total_size_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:36:\"Total Size (field_total_size:format)\";s:11:\"title short\";s:17:\"Total Size:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_total_size_format\";s:5:\"table\";s:27:\"field_data_field_total_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_total_size_value\";i:1;s:23:\"field_total_size_format\";}s:10:\"field_name\";s:16:\"field_total_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_total_size_format\";s:5:\"table\";s:27:\"field_data_field_total_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_total_size_value\";i:1;s:23:\"field_total_size_format\";}s:10:\"field_name\";s:16:\"field_total_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_total_size_format\";s:5:\"table\";s:27:\"field_data_field_total_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_total_size_value\";i:1;s:23:\"field_total_size_format\";}s:10:\"field_name\";s:16:\"field_total_size\";}}}s:31:\"field_revision_field_total_size\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:31:\"field_revision_field_total_size\";i:1;s:28:\"field_total_size-revision_id\";}}}s:28:\"field_total_size-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:10:\"Total Size\";s:11:\"title short\";s:10:\"Total Size\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:31:\"field_revision_field_total_size\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_total_size\";s:10:\"real field\";s:34:\"field_total_size-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_total_size_value\";i:4;s:23:\"field_total_size_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:22:\"field_total_size_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:29:\"Total Size (field_total_size)\";s:11:\"title short\";s:10:\"Total Size\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_total_size_value\";s:5:\"table\";s:31:\"field_revision_field_total_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_total_size_value\";i:1;s:23:\"field_total_size_format\";}s:10:\"field_name\";s:16:\"field_total_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_total_size_value\";s:5:\"table\";s:31:\"field_revision_field_total_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_total_size_value\";i:1;s:23:\"field_total_size_format\";}s:10:\"field_name\";s:16:\"field_total_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_total_size_value\";s:5:\"table\";s:31:\"field_revision_field_total_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_total_size_value\";i:1;s:23:\"field_total_size_format\";}s:10:\"field_name\";s:16:\"field_total_size\";}}s:23:\"field_total_size_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:36:\"Total Size (field_total_size:format)\";s:11:\"title short\";s:17:\"Total Size:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_total_size_format\";s:5:\"table\";s:31:\"field_revision_field_total_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_total_size_value\";i:1;s:23:\"field_total_size_format\";}s:10:\"field_name\";s:16:\"field_total_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_total_size_format\";s:5:\"table\";s:31:\"field_revision_field_total_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_total_size_value\";i:1;s:23:\"field_total_size_format\";}s:10:\"field_name\";s:16:\"field_total_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_total_size_format\";s:5:\"table\";s:31:\"field_revision_field_total_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_total_size_value\";i:1;s:23:\"field_total_size_format\";}s:10:\"field_name\";s:16:\"field_total_size\";}}}s:28:\"field_data_field_vib_version\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:28:\"field_data_field_vib_version\";i:1;s:17:\"field_vib_version\";}}}s:17:\"field_vib_version\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:11:\"VIB Version\";s:11:\"title short\";s:11:\"VIB Version\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:28:\"field_data_field_vib_version\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_vib_version\";s:10:\"real field\";s:23:\"field_vib_version_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_vib_version_value\";i:4;s:24:\"field_vib_version_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:23:\"field_vib_version_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:31:\"VIB Version (field_vib_version)\";s:11:\"title short\";s:11:\"VIB Version\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_vib_version_value\";s:5:\"table\";s:28:\"field_data_field_vib_version\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vib_version_value\";i:1;s:24:\"field_vib_version_format\";}s:10:\"field_name\";s:17:\"field_vib_version\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_vib_version_value\";s:5:\"table\";s:28:\"field_data_field_vib_version\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vib_version_value\";i:1;s:24:\"field_vib_version_format\";}s:10:\"field_name\";s:17:\"field_vib_version\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_vib_version_value\";s:5:\"table\";s:28:\"field_data_field_vib_version\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vib_version_value\";i:1;s:24:\"field_vib_version_format\";}s:10:\"field_name\";s:17:\"field_vib_version\";}}s:24:\"field_vib_version_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:38:\"VIB Version (field_vib_version:format)\";s:11:\"title short\";s:18:\"VIB Version:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_vib_version_format\";s:5:\"table\";s:28:\"field_data_field_vib_version\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vib_version_value\";i:1;s:24:\"field_vib_version_format\";}s:10:\"field_name\";s:17:\"field_vib_version\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_vib_version_format\";s:5:\"table\";s:28:\"field_data_field_vib_version\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vib_version_value\";i:1;s:24:\"field_vib_version_format\";}s:10:\"field_name\";s:17:\"field_vib_version\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_vib_version_format\";s:5:\"table\";s:28:\"field_data_field_vib_version\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vib_version_value\";i:1;s:24:\"field_vib_version_format\";}s:10:\"field_name\";s:17:\"field_vib_version\";}}}s:32:\"field_revision_field_vib_version\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:32:\"field_revision_field_vib_version\";i:1;s:29:\"field_vib_version-revision_id\";}}}s:29:\"field_vib_version-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:11:\"VIB Version\";s:11:\"title short\";s:11:\"VIB Version\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:32:\"field_revision_field_vib_version\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_vib_version\";s:10:\"real field\";s:35:\"field_vib_version-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_vib_version_value\";i:4;s:24:\"field_vib_version_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:23:\"field_vib_version_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:31:\"VIB Version (field_vib_version)\";s:11:\"title short\";s:11:\"VIB Version\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_vib_version_value\";s:5:\"table\";s:32:\"field_revision_field_vib_version\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vib_version_value\";i:1;s:24:\"field_vib_version_format\";}s:10:\"field_name\";s:17:\"field_vib_version\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_vib_version_value\";s:5:\"table\";s:32:\"field_revision_field_vib_version\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vib_version_value\";i:1;s:24:\"field_vib_version_format\";}s:10:\"field_name\";s:17:\"field_vib_version\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_vib_version_value\";s:5:\"table\";s:32:\"field_revision_field_vib_version\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vib_version_value\";i:1;s:24:\"field_vib_version_format\";}s:10:\"field_name\";s:17:\"field_vib_version\";}}s:24:\"field_vib_version_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:38:\"VIB Version (field_vib_version:format)\";s:11:\"title short\";s:18:\"VIB Version:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_vib_version_format\";s:5:\"table\";s:32:\"field_revision_field_vib_version\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vib_version_value\";i:1;s:24:\"field_vib_version_format\";}s:10:\"field_name\";s:17:\"field_vib_version\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_vib_version_format\";s:5:\"table\";s:32:\"field_revision_field_vib_version\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vib_version_value\";i:1;s:24:\"field_vib_version_format\";}s:10:\"field_name\";s:17:\"field_vib_version\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_vib_version_format\";s:5:\"table\";s:32:\"field_revision_field_vib_version\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vib_version_value\";i:1;s:24:\"field_vib_version_format\";}s:10:\"field_name\";s:17:\"field_vib_version\";}}}s:43:\"field_data_field_allocated_virtual_machines\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:43:\"field_data_field_allocated_virtual_machines\";i:1;s:32:\"field_allocated_virtual_machines\";}}}s:32:\"field_allocated_virtual_machines\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:26:\"Allocated Virtual Machines\";s:11:\"title short\";s:26:\"Allocated Virtual Machines\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:43:\"field_data_field_allocated_virtual_machines\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:32:\"field_allocated_virtual_machines\";s:10:\"real field\";s:38:\"field_allocated_virtual_machines_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:38:\"field_allocated_virtual_machines_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:38:\"field_allocated_virtual_machines_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:61:\"Allocated Virtual Machines (field_allocated_virtual_machines)\";s:11:\"title short\";s:26:\"Allocated Virtual Machines\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:38:\"field_allocated_virtual_machines_value\";s:5:\"table\";s:43:\"field_data_field_allocated_virtual_machines\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:38:\"field_allocated_virtual_machines_value\";}s:10:\"field_name\";s:32:\"field_allocated_virtual_machines\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:38:\"field_allocated_virtual_machines_value\";s:5:\"table\";s:43:\"field_data_field_allocated_virtual_machines\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:38:\"field_allocated_virtual_machines_value\";}s:10:\"field_name\";s:32:\"field_allocated_virtual_machines\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:38:\"field_allocated_virtual_machines_value\";s:5:\"table\";s:43:\"field_data_field_allocated_virtual_machines\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:38:\"field_allocated_virtual_machines_value\";}s:10:\"field_name\";s:32:\"field_allocated_virtual_machines\";}}}s:47:\"field_revision_field_allocated_virtual_machines\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:47:\"field_revision_field_allocated_virtual_machines\";i:1;s:44:\"field_allocated_virtual_machines-revision_id\";}}}s:44:\"field_allocated_virtual_machines-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:26:\"Allocated Virtual Machines\";s:11:\"title short\";s:26:\"Allocated Virtual Machines\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:47:\"field_revision_field_allocated_virtual_machines\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:32:\"field_allocated_virtual_machines\";s:10:\"real field\";s:50:\"field_allocated_virtual_machines-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:38:\"field_allocated_virtual_machines_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:38:\"field_allocated_virtual_machines_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:61:\"Allocated Virtual Machines (field_allocated_virtual_machines)\";s:11:\"title short\";s:26:\"Allocated Virtual Machines\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:38:\"field_allocated_virtual_machines_value\";s:5:\"table\";s:47:\"field_revision_field_allocated_virtual_machines\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:38:\"field_allocated_virtual_machines_value\";}s:10:\"field_name\";s:32:\"field_allocated_virtual_machines\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:38:\"field_allocated_virtual_machines_value\";s:5:\"table\";s:47:\"field_revision_field_allocated_virtual_machines\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:38:\"field_allocated_virtual_machines_value\";}s:10:\"field_name\";s:32:\"field_allocated_virtual_machines\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:38:\"field_allocated_virtual_machines_value\";s:5:\"table\";s:47:\"field_revision_field_allocated_virtual_machines\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:38:\"field_allocated_virtual_machines_value\";}s:10:\"field_name\";s:32:\"field_allocated_virtual_machines\";}}}s:31:\"field_data_field_total_segments\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:31:\"field_data_field_total_segments\";i:1;s:20:\"field_total_segments\";}}}s:20:\"field_total_segments\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:14:\"Total Segments\";s:11:\"title short\";s:14:\"Total Segments\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:31:\"field_data_field_total_segments\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:20:\"field_total_segments\";s:10:\"real field\";s:26:\"field_total_segments_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:26:\"field_total_segments_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:26:\"field_total_segments_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:37:\"Total Segments (field_total_segments)\";s:11:\"title short\";s:14:\"Total Segments\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_total_segments_value\";s:5:\"table\";s:31:\"field_data_field_total_segments\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_total_segments_value\";}s:10:\"field_name\";s:20:\"field_total_segments\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_total_segments_value\";s:5:\"table\";s:31:\"field_data_field_total_segments\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_total_segments_value\";}s:10:\"field_name\";s:20:\"field_total_segments\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_total_segments_value\";s:5:\"table\";s:31:\"field_data_field_total_segments\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_total_segments_value\";}s:10:\"field_name\";s:20:\"field_total_segments\";}}}s:35:\"field_revision_field_total_segments\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:35:\"field_revision_field_total_segments\";i:1;s:32:\"field_total_segments-revision_id\";}}}s:32:\"field_total_segments-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:14:\"Total Segments\";s:11:\"title short\";s:14:\"Total Segments\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:35:\"field_revision_field_total_segments\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:20:\"field_total_segments\";s:10:\"real field\";s:38:\"field_total_segments-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:26:\"field_total_segments_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:26:\"field_total_segments_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:37:\"Total Segments (field_total_segments)\";s:11:\"title short\";s:14:\"Total Segments\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_total_segments_value\";s:5:\"table\";s:35:\"field_revision_field_total_segments\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_total_segments_value\";}s:10:\"field_name\";s:20:\"field_total_segments\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_total_segments_value\";s:5:\"table\";s:35:\"field_revision_field_total_segments\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_total_segments_value\";}s:10:\"field_name\";s:20:\"field_total_segments\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_total_segments_value\";s:5:\"table\";s:35:\"field_revision_field_total_segments\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_total_segments_value\";}s:10:\"field_name\";s:20:\"field_total_segments\";}}}s:28:\"field_data_field_cache_state\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:28:\"field_data_field_cache_state\";i:1;s:17:\"field_cache_state\";}}}s:17:\"field_cache_state\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:11:\"Cache State\";s:11:\"title short\";s:11:\"Cache State\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:28:\"field_data_field_cache_state\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_cache_state\";s:10:\"real field\";s:23:\"field_cache_state_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_cache_state_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:23:\"field_cache_state_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:31:\"Cache State (field_cache_state)\";s:11:\"title short\";s:11:\"Cache State\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_cache_state_value\";s:5:\"table\";s:28:\"field_data_field_cache_state\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:23:\"field_cache_state_value\";}s:10:\"field_name\";s:17:\"field_cache_state\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_cache_state_value\";s:5:\"table\";s:28:\"field_data_field_cache_state\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:23:\"field_cache_state_value\";}s:10:\"field_name\";s:17:\"field_cache_state\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_cache_state_value\";s:5:\"table\";s:28:\"field_data_field_cache_state\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:23:\"field_cache_state_value\";}s:10:\"field_name\";s:17:\"field_cache_state\";}}}s:32:\"field_revision_field_cache_state\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:32:\"field_revision_field_cache_state\";i:1;s:29:\"field_cache_state-revision_id\";}}}s:29:\"field_cache_state-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:11:\"Cache State\";s:11:\"title short\";s:11:\"Cache State\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:32:\"field_revision_field_cache_state\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_cache_state\";s:10:\"real field\";s:35:\"field_cache_state-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_cache_state_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:23:\"field_cache_state_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:31:\"Cache State (field_cache_state)\";s:11:\"title short\";s:11:\"Cache State\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_cache_state_value\";s:5:\"table\";s:32:\"field_revision_field_cache_state\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:23:\"field_cache_state_value\";}s:10:\"field_name\";s:17:\"field_cache_state\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_cache_state_value\";s:5:\"table\";s:32:\"field_revision_field_cache_state\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:23:\"field_cache_state_value\";}s:10:\"field_name\";s:17:\"field_cache_state\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_cache_state_value\";s:5:\"table\";s:32:\"field_revision_field_cache_state\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:23:\"field_cache_state_value\";}s:10:\"field_name\";s:17:\"field_cache_state\";}}}s:41:\"field_data_field_claimed_physical_devices\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:41:\"field_data_field_claimed_physical_devices\";i:1;s:30:\"field_claimed_physical_devices\";}}}s:30:\"field_claimed_physical_devices\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:24:\"Claimed Physical Devices\";s:11:\"title short\";s:24:\"Claimed Physical Devices\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:41:\"field_data_field_claimed_physical_devices\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:30:\"field_claimed_physical_devices\";s:10:\"real field\";s:36:\"field_claimed_physical_devices_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:36:\"field_claimed_physical_devices_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:36:\"field_claimed_physical_devices_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:57:\"Claimed Physical Devices (field_claimed_physical_devices)\";s:11:\"title short\";s:24:\"Claimed Physical Devices\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:36:\"field_claimed_physical_devices_value\";s:5:\"table\";s:41:\"field_data_field_claimed_physical_devices\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:36:\"field_claimed_physical_devices_value\";}s:10:\"field_name\";s:30:\"field_claimed_physical_devices\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:36:\"field_claimed_physical_devices_value\";s:5:\"table\";s:41:\"field_data_field_claimed_physical_devices\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:36:\"field_claimed_physical_devices_value\";}s:10:\"field_name\";s:30:\"field_claimed_physical_devices\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:36:\"field_claimed_physical_devices_value\";s:5:\"table\";s:41:\"field_data_field_claimed_physical_devices\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:36:\"field_claimed_physical_devices_value\";}s:10:\"field_name\";s:30:\"field_claimed_physical_devices\";}}}s:45:\"field_revision_field_claimed_physical_devices\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:45:\"field_revision_field_claimed_physical_devices\";i:1;s:42:\"field_claimed_physical_devices-revision_id\";}}}s:42:\"field_claimed_physical_devices-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:24:\"Claimed Physical Devices\";s:11:\"title short\";s:24:\"Claimed Physical Devices\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:45:\"field_revision_field_claimed_physical_devices\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:30:\"field_claimed_physical_devices\";s:10:\"real field\";s:48:\"field_claimed_physical_devices-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:36:\"field_claimed_physical_devices_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:36:\"field_claimed_physical_devices_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:57:\"Claimed Physical Devices (field_claimed_physical_devices)\";s:11:\"title short\";s:24:\"Claimed Physical Devices\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:36:\"field_claimed_physical_devices_value\";s:5:\"table\";s:45:\"field_revision_field_claimed_physical_devices\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:36:\"field_claimed_physical_devices_value\";}s:10:\"field_name\";s:30:\"field_claimed_physical_devices\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:36:\"field_claimed_physical_devices_value\";s:5:\"table\";s:45:\"field_revision_field_claimed_physical_devices\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:36:\"field_claimed_physical_devices_value\";}s:10:\"field_name\";s:30:\"field_claimed_physical_devices\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:36:\"field_claimed_physical_devices_value\";s:5:\"table\";s:45:\"field_revision_field_claimed_physical_devices\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:36:\"field_claimed_physical_devices_value\";}s:10:\"field_name\";s:30:\"field_claimed_physical_devices\";}}}s:37:\"field_data_field_max_physical_devices\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:37:\"field_data_field_max_physical_devices\";i:1;s:26:\"field_max_physical_devices\";}}}s:26:\"field_max_physical_devices\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:20:\"Max Physical Devices\";s:11:\"title short\";s:20:\"Max Physical Devices\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:37:\"field_data_field_max_physical_devices\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:26:\"field_max_physical_devices\";s:10:\"real field\";s:32:\"field_max_physical_devices_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:32:\"field_max_physical_devices_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:32:\"field_max_physical_devices_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:49:\"Max Physical Devices (field_max_physical_devices)\";s:11:\"title short\";s:20:\"Max Physical Devices\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:32:\"field_max_physical_devices_value\";s:5:\"table\";s:37:\"field_data_field_max_physical_devices\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:32:\"field_max_physical_devices_value\";}s:10:\"field_name\";s:26:\"field_max_physical_devices\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:32:\"field_max_physical_devices_value\";s:5:\"table\";s:37:\"field_data_field_max_physical_devices\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:32:\"field_max_physical_devices_value\";}s:10:\"field_name\";s:26:\"field_max_physical_devices\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:32:\"field_max_physical_devices_value\";s:5:\"table\";s:37:\"field_data_field_max_physical_devices\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:32:\"field_max_physical_devices_value\";}s:10:\"field_name\";s:26:\"field_max_physical_devices\";}}}s:41:\"field_revision_field_max_physical_devices\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:41:\"field_revision_field_max_physical_devices\";i:1;s:38:\"field_max_physical_devices-revision_id\";}}}s:38:\"field_max_physical_devices-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:20:\"Max Physical Devices\";s:11:\"title short\";s:20:\"Max Physical Devices\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:41:\"field_revision_field_max_physical_devices\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:26:\"field_max_physical_devices\";s:10:\"real field\";s:44:\"field_max_physical_devices-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:32:\"field_max_physical_devices_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:32:\"field_max_physical_devices_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:49:\"Max Physical Devices (field_max_physical_devices)\";s:11:\"title short\";s:20:\"Max Physical Devices\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:32:\"field_max_physical_devices_value\";s:5:\"table\";s:41:\"field_revision_field_max_physical_devices\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:32:\"field_max_physical_devices_value\";}s:10:\"field_name\";s:26:\"field_max_physical_devices\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:32:\"field_max_physical_devices_value\";s:5:\"table\";s:41:\"field_revision_field_max_physical_devices\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:32:\"field_max_physical_devices_value\";}s:10:\"field_name\";s:26:\"field_max_physical_devices\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:32:\"field_max_physical_devices_value\";s:5:\"table\";s:41:\"field_revision_field_max_physical_devices\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:32:\"field_max_physical_devices_value\";}s:10:\"field_name\";s:26:\"field_max_physical_devices\";}}}s:37:\"field_data_field_max_virtual_machines\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:37:\"field_data_field_max_virtual_machines\";i:1;s:26:\"field_max_virtual_machines\";}}}s:26:\"field_max_virtual_machines\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:20:\"Max Virtual Machines\";s:11:\"title short\";s:20:\"Max Virtual Machines\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:37:\"field_data_field_max_virtual_machines\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:26:\"field_max_virtual_machines\";s:10:\"real field\";s:32:\"field_max_virtual_machines_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:32:\"field_max_virtual_machines_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:32:\"field_max_virtual_machines_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:49:\"Max Virtual Machines (field_max_virtual_machines)\";s:11:\"title short\";s:20:\"Max Virtual Machines\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:32:\"field_max_virtual_machines_value\";s:5:\"table\";s:37:\"field_data_field_max_virtual_machines\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:32:\"field_max_virtual_machines_value\";}s:10:\"field_name\";s:26:\"field_max_virtual_machines\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:32:\"field_max_virtual_machines_value\";s:5:\"table\";s:37:\"field_data_field_max_virtual_machines\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:32:\"field_max_virtual_machines_value\";}s:10:\"field_name\";s:26:\"field_max_virtual_machines\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:32:\"field_max_virtual_machines_value\";s:5:\"table\";s:37:\"field_data_field_max_virtual_machines\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:32:\"field_max_virtual_machines_value\";}s:10:\"field_name\";s:26:\"field_max_virtual_machines\";}}}s:41:\"field_revision_field_max_virtual_machines\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:41:\"field_revision_field_max_virtual_machines\";i:1;s:38:\"field_max_virtual_machines-revision_id\";}}}s:38:\"field_max_virtual_machines-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:20:\"Max Virtual Machines\";s:11:\"title short\";s:20:\"Max Virtual Machines\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:41:\"field_revision_field_max_virtual_machines\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:26:\"field_max_virtual_machines\";s:10:\"real field\";s:44:\"field_max_virtual_machines-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:32:\"field_max_virtual_machines_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:32:\"field_max_virtual_machines_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:49:\"Max Virtual Machines (field_max_virtual_machines)\";s:11:\"title short\";s:20:\"Max Virtual Machines\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:32:\"field_max_virtual_machines_value\";s:5:\"table\";s:41:\"field_revision_field_max_virtual_machines\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:32:\"field_max_virtual_machines_value\";}s:10:\"field_name\";s:26:\"field_max_virtual_machines\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:32:\"field_max_virtual_machines_value\";s:5:\"table\";s:41:\"field_revision_field_max_virtual_machines\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:32:\"field_max_virtual_machines_value\";}s:10:\"field_name\";s:26:\"field_max_virtual_machines\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:32:\"field_max_virtual_machines_value\";s:5:\"table\";s:41:\"field_revision_field_max_virtual_machines\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:32:\"field_max_virtual_machines_value\";}s:10:\"field_name\";s:26:\"field_max_virtual_machines\";}}}s:29:\"field_data_field_segment_size\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:29:\"field_data_field_segment_size\";i:1;s:18:\"field_segment_size\";}}}s:18:\"field_segment_size\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:12:\"Segment Size\";s:11:\"title short\";s:12:\"Segment Size\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:29:\"field_data_field_segment_size\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:18:\"field_segment_size\";s:10:\"real field\";s:24:\"field_segment_size_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:24:\"field_segment_size_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:24:\"field_segment_size_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:33:\"Segment Size (field_segment_size)\";s:11:\"title short\";s:12:\"Segment Size\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_segment_size_value\";s:5:\"table\";s:29:\"field_data_field_segment_size\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_segment_size_value\";}s:10:\"field_name\";s:18:\"field_segment_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_segment_size_value\";s:5:\"table\";s:29:\"field_data_field_segment_size\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_segment_size_value\";}s:10:\"field_name\";s:18:\"field_segment_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_segment_size_value\";s:5:\"table\";s:29:\"field_data_field_segment_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_segment_size_value\";}s:10:\"field_name\";s:18:\"field_segment_size\";}}}s:33:\"field_revision_field_segment_size\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:33:\"field_revision_field_segment_size\";i:1;s:30:\"field_segment_size-revision_id\";}}}s:30:\"field_segment_size-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:12:\"Segment Size\";s:11:\"title short\";s:12:\"Segment Size\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:33:\"field_revision_field_segment_size\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:18:\"field_segment_size\";s:10:\"real field\";s:36:\"field_segment_size-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:24:\"field_segment_size_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:24:\"field_segment_size_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:33:\"Segment Size (field_segment_size)\";s:11:\"title short\";s:12:\"Segment Size\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_segment_size_value\";s:5:\"table\";s:33:\"field_revision_field_segment_size\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_segment_size_value\";}s:10:\"field_name\";s:18:\"field_segment_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_segment_size_value\";s:5:\"table\";s:33:\"field_revision_field_segment_size\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_segment_size_value\";}s:10:\"field_name\";s:18:\"field_segment_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_segment_size_value\";s:5:\"table\";s:33:\"field_revision_field_segment_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_segment_size_value\";}s:10:\"field_name\";s:18:\"field_segment_size\";}}}s:35:\"field_data_field_allocated_segments\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:35:\"field_data_field_allocated_segments\";i:1;s:24:\"field_allocated_segments\";}}}s:24:\"field_allocated_segments\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:18:\"Allocated Segments\";s:11:\"title short\";s:18:\"Allocated Segments\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:35:\"field_data_field_allocated_segments\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:24:\"field_allocated_segments\";s:10:\"real field\";s:30:\"field_allocated_segments_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:30:\"field_allocated_segments_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:30:\"field_allocated_segments_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:45:\"Allocated Segments (field_allocated_segments)\";s:11:\"title short\";s:18:\"Allocated Segments\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:30:\"field_allocated_segments_value\";s:5:\"table\";s:35:\"field_data_field_allocated_segments\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:30:\"field_allocated_segments_value\";}s:10:\"field_name\";s:24:\"field_allocated_segments\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:30:\"field_allocated_segments_value\";s:5:\"table\";s:35:\"field_data_field_allocated_segments\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:30:\"field_allocated_segments_value\";}s:10:\"field_name\";s:24:\"field_allocated_segments\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:30:\"field_allocated_segments_value\";s:5:\"table\";s:35:\"field_data_field_allocated_segments\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:30:\"field_allocated_segments_value\";}s:10:\"field_name\";s:24:\"field_allocated_segments\";}}}s:39:\"field_revision_field_allocated_segments\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:39:\"field_revision_field_allocated_segments\";i:1;s:36:\"field_allocated_segments-revision_id\";}}}s:36:\"field_allocated_segments-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:18:\"Allocated Segments\";s:11:\"title short\";s:18:\"Allocated Segments\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:39:\"field_revision_field_allocated_segments\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:24:\"field_allocated_segments\";s:10:\"real field\";s:42:\"field_allocated_segments-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:30:\"field_allocated_segments_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:30:\"field_allocated_segments_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:45:\"Allocated Segments (field_allocated_segments)\";s:11:\"title short\";s:18:\"Allocated Segments\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:30:\"field_allocated_segments_value\";s:5:\"table\";s:39:\"field_revision_field_allocated_segments\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:30:\"field_allocated_segments_value\";}s:10:\"field_name\";s:24:\"field_allocated_segments\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:30:\"field_allocated_segments_value\";s:5:\"table\";s:39:\"field_revision_field_allocated_segments\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:30:\"field_allocated_segments_value\";}s:10:\"field_name\";s:24:\"field_allocated_segments\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:30:\"field_allocated_segments_value\";s:5:\"table\";s:39:\"field_revision_field_allocated_segments\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:30:\"field_allocated_segments_value\";}s:10:\"field_name\";s:24:\"field_allocated_segments\";}}}s:19:\"field_data_field_vm\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:19:\"field_data_field_vm\";i:1;s:8:\"field_vm\";}}}s:8:\"field_vm\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:2:\"VM\";s:11:\"title short\";s:2:\"VM\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:19:\"field_data_field_vm\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:8:\"field_vm\";s:10:\"real field\";s:18:\"field_vm_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:18:\"field_vm_target_id\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:18:\"field_vm_target_id\";a:8:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:13:\"VM (field_vm)\";s:11:\"title short\";s:2:\"VM\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:18:\"field_vm_target_id\";s:5:\"table\";s:19:\"field_data_field_vm\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_vm_target_id\";}s:10:\"field_name\";s:8:\"field_vm\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:18:\"field_vm_target_id\";s:5:\"table\";s:19:\"field_data_field_vm\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_vm_target_id\";}s:10:\"field_name\";s:8:\"field_vm\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:18:\"field_vm_target_id\";s:5:\"table\";s:19:\"field_data_field_vm\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_vm_target_id\";}s:10:\"field_name\";s:8:\"field_vm\";}s:12:\"relationship\";a:7:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:39:\"Content entity referenced from field_vm\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:17:\"Referenced Entity\";s:4:\"help\";s:62:\"A bridge to the Content entity that is referenced via field_vm\";}}}s:23:\"field_revision_field_vm\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:23:\"field_revision_field_vm\";i:1;s:20:\"field_vm-revision_id\";}}}s:20:\"field_vm-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:2:\"VM\";s:11:\"title short\";s:2:\"VM\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:5:\"field\";a:9:{s:5:\"table\";s:23:\"field_revision_field_vm\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:8:\"field_vm\";s:10:\"real field\";s:30:\"field_vm-revision_id_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:18:\"field_vm_target_id\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:18:\"field_vm_target_id\";a:8:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:13:\"VM (field_vm)\";s:11:\"title short\";s:2:\"VM\";s:4:\"help\";s:28:\"Appears in: node:vm_metrics.\";s:8:\"argument\";a:6:{s:5:\"field\";s:18:\"field_vm_target_id\";s:5:\"table\";s:23:\"field_revision_field_vm\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_vm_target_id\";}s:10:\"field_name\";s:8:\"field_vm\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:18:\"field_vm_target_id\";s:5:\"table\";s:23:\"field_revision_field_vm\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_vm_target_id\";}s:10:\"field_name\";s:8:\"field_vm\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:18:\"field_vm_target_id\";s:5:\"table\";s:23:\"field_revision_field_vm\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_vm_target_id\";}s:10:\"field_name\";s:8:\"field_vm\";}s:12:\"relationship\";a:7:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:39:\"Content entity referenced from field_vm\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:17:\"Referenced Entity\";s:4:\"help\";s:62:\"A bridge to the Content entity that is referenced via field_vm\";}}}s:33:\"field_data_field_software_on_host\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:33:\"field_data_field_software_on_host\";i:1;s:22:\"field_software_on_host\";}}}s:22:\"field_software_on_host\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:16:\"Software on host\";s:11:\"title short\";s:16:\"Software on host\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:33:\"field_data_field_software_on_host\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_software_on_host\";s:10:\"real field\";s:28:\"field_software_on_host_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_software_on_host_value\";i:4;s:29:\"field_software_on_host_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:28:\"field_software_on_host_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:41:\"Software on host (field_software_on_host)\";s:11:\"title short\";s:16:\"Software on host\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_software_on_host_value\";s:5:\"table\";s:33:\"field_data_field_software_on_host\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_software_on_host_value\";i:1;s:29:\"field_software_on_host_format\";}s:10:\"field_name\";s:22:\"field_software_on_host\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_software_on_host_value\";s:5:\"table\";s:33:\"field_data_field_software_on_host\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_software_on_host_value\";i:1;s:29:\"field_software_on_host_format\";}s:10:\"field_name\";s:22:\"field_software_on_host\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_software_on_host_value\";s:5:\"table\";s:33:\"field_data_field_software_on_host\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_software_on_host_value\";i:1;s:29:\"field_software_on_host_format\";}s:10:\"field_name\";s:22:\"field_software_on_host\";}}s:29:\"field_software_on_host_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:48:\"Software on host (field_software_on_host:format)\";s:11:\"title short\";s:23:\"Software on host:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_software_on_host_format\";s:5:\"table\";s:33:\"field_data_field_software_on_host\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_software_on_host_value\";i:1;s:29:\"field_software_on_host_format\";}s:10:\"field_name\";s:22:\"field_software_on_host\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_software_on_host_format\";s:5:\"table\";s:33:\"field_data_field_software_on_host\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_software_on_host_value\";i:1;s:29:\"field_software_on_host_format\";}s:10:\"field_name\";s:22:\"field_software_on_host\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_software_on_host_format\";s:5:\"table\";s:33:\"field_data_field_software_on_host\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_software_on_host_value\";i:1;s:29:\"field_software_on_host_format\";}s:10:\"field_name\";s:22:\"field_software_on_host\";}}}s:37:\"field_revision_field_software_on_host\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:37:\"field_revision_field_software_on_host\";i:1;s:34:\"field_software_on_host-revision_id\";}}}s:34:\"field_software_on_host-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:16:\"Software on host\";s:11:\"title short\";s:16:\"Software on host\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:37:\"field_revision_field_software_on_host\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_software_on_host\";s:10:\"real field\";s:40:\"field_software_on_host-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_software_on_host_value\";i:4;s:29:\"field_software_on_host_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:28:\"field_software_on_host_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:41:\"Software on host (field_software_on_host)\";s:11:\"title short\";s:16:\"Software on host\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_software_on_host_value\";s:5:\"table\";s:37:\"field_revision_field_software_on_host\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_software_on_host_value\";i:1;s:29:\"field_software_on_host_format\";}s:10:\"field_name\";s:22:\"field_software_on_host\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_software_on_host_value\";s:5:\"table\";s:37:\"field_revision_field_software_on_host\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_software_on_host_value\";i:1;s:29:\"field_software_on_host_format\";}s:10:\"field_name\";s:22:\"field_software_on_host\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_software_on_host_value\";s:5:\"table\";s:37:\"field_revision_field_software_on_host\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_software_on_host_value\";i:1;s:29:\"field_software_on_host_format\";}s:10:\"field_name\";s:22:\"field_software_on_host\";}}s:29:\"field_software_on_host_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:48:\"Software on host (field_software_on_host:format)\";s:11:\"title short\";s:23:\"Software on host:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_software_on_host_format\";s:5:\"table\";s:37:\"field_revision_field_software_on_host\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_software_on_host_value\";i:1;s:29:\"field_software_on_host_format\";}s:10:\"field_name\";s:22:\"field_software_on_host\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_software_on_host_format\";s:5:\"table\";s:37:\"field_revision_field_software_on_host\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_software_on_host_value\";i:1;s:29:\"field_software_on_host_format\";}s:10:\"field_name\";s:22:\"field_software_on_host\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_software_on_host_format\";s:5:\"table\";s:37:\"field_revision_field_software_on_host\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_software_on_host_value\";i:1;s:29:\"field_software_on_host_format\";}s:10:\"field_name\";s:22:\"field_software_on_host\";}}}s:29:\"field_data_field_vmware_tools\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:29:\"field_data_field_vmware_tools\";i:1;s:18:\"field_vmware_tools\";}}}s:18:\"field_vmware_tools\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:12:\"VMware Tools\";s:11:\"title short\";s:12:\"VMware Tools\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:29:\"field_data_field_vmware_tools\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:18:\"field_vmware_tools\";s:10:\"real field\";s:24:\"field_vmware_tools_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:24:\"field_vmware_tools_value\";i:4;s:25:\"field_vmware_tools_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:24:\"field_vmware_tools_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:33:\"VMware Tools (field_vmware_tools)\";s:11:\"title short\";s:12:\"VMware Tools\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_vmware_tools_value\";s:5:\"table\";s:29:\"field_data_field_vmware_tools\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vmware_tools_value\";i:1;s:25:\"field_vmware_tools_format\";}s:10:\"field_name\";s:18:\"field_vmware_tools\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_vmware_tools_value\";s:5:\"table\";s:29:\"field_data_field_vmware_tools\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vmware_tools_value\";i:1;s:25:\"field_vmware_tools_format\";}s:10:\"field_name\";s:18:\"field_vmware_tools\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_vmware_tools_value\";s:5:\"table\";s:29:\"field_data_field_vmware_tools\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vmware_tools_value\";i:1;s:25:\"field_vmware_tools_format\";}s:10:\"field_name\";s:18:\"field_vmware_tools\";}}s:25:\"field_vmware_tools_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:40:\"VMware Tools (field_vmware_tools:format)\";s:11:\"title short\";s:19:\"VMware Tools:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_vmware_tools_format\";s:5:\"table\";s:29:\"field_data_field_vmware_tools\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vmware_tools_value\";i:1;s:25:\"field_vmware_tools_format\";}s:10:\"field_name\";s:18:\"field_vmware_tools\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_vmware_tools_format\";s:5:\"table\";s:29:\"field_data_field_vmware_tools\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vmware_tools_value\";i:1;s:25:\"field_vmware_tools_format\";}s:10:\"field_name\";s:18:\"field_vmware_tools\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_vmware_tools_format\";s:5:\"table\";s:29:\"field_data_field_vmware_tools\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vmware_tools_value\";i:1;s:25:\"field_vmware_tools_format\";}s:10:\"field_name\";s:18:\"field_vmware_tools\";}}}s:33:\"field_revision_field_vmware_tools\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:33:\"field_revision_field_vmware_tools\";i:1;s:30:\"field_vmware_tools-revision_id\";}}}s:30:\"field_vmware_tools-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:12:\"VMware Tools\";s:11:\"title short\";s:12:\"VMware Tools\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:33:\"field_revision_field_vmware_tools\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:18:\"field_vmware_tools\";s:10:\"real field\";s:36:\"field_vmware_tools-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:24:\"field_vmware_tools_value\";i:4;s:25:\"field_vmware_tools_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:24:\"field_vmware_tools_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:33:\"VMware Tools (field_vmware_tools)\";s:11:\"title short\";s:12:\"VMware Tools\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_vmware_tools_value\";s:5:\"table\";s:33:\"field_revision_field_vmware_tools\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vmware_tools_value\";i:1;s:25:\"field_vmware_tools_format\";}s:10:\"field_name\";s:18:\"field_vmware_tools\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_vmware_tools_value\";s:5:\"table\";s:33:\"field_revision_field_vmware_tools\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vmware_tools_value\";i:1;s:25:\"field_vmware_tools_format\";}s:10:\"field_name\";s:18:\"field_vmware_tools\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_vmware_tools_value\";s:5:\"table\";s:33:\"field_revision_field_vmware_tools\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vmware_tools_value\";i:1;s:25:\"field_vmware_tools_format\";}s:10:\"field_name\";s:18:\"field_vmware_tools\";}}s:25:\"field_vmware_tools_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:40:\"VMware Tools (field_vmware_tools:format)\";s:11:\"title short\";s:19:\"VMware Tools:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_vmware_tools_format\";s:5:\"table\";s:33:\"field_revision_field_vmware_tools\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vmware_tools_value\";i:1;s:25:\"field_vmware_tools_format\";}s:10:\"field_name\";s:18:\"field_vmware_tools\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_vmware_tools_format\";s:5:\"table\";s:33:\"field_revision_field_vmware_tools\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vmware_tools_value\";i:1;s:25:\"field_vmware_tools_format\";}s:10:\"field_name\";s:18:\"field_vmware_tools\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_vmware_tools_format\";s:5:\"table\";s:33:\"field_revision_field_vmware_tools\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vmware_tools_value\";i:1;s:25:\"field_vmware_tools_format\";}s:10:\"field_name\";s:18:\"field_vmware_tools\";}}}s:21:\"field_data_field_host\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:21:\"field_data_field_host\";i:1;s:10:\"field_host\";}}}s:10:\"field_host\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:4:\"Host\";s:11:\"title short\";s:4:\"Host\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:21:\"field_data_field_host\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:10:\"field_host\";s:10:\"real field\";s:20:\"field_host_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_host_target_id\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:20:\"field_host_target_id\";a:8:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:17:\"Host (field_host)\";s:11:\"title short\";s:4:\"Host\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_host_target_id\";s:5:\"table\";s:21:\"field_data_field_host\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:20:\"field_host_target_id\";}s:10:\"field_name\";s:10:\"field_host\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_host_target_id\";s:5:\"table\";s:21:\"field_data_field_host\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:20:\"field_host_target_id\";}s:10:\"field_name\";s:10:\"field_host\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_host_target_id\";s:5:\"table\";s:21:\"field_data_field_host\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:20:\"field_host_target_id\";}s:10:\"field_name\";s:10:\"field_host\";}s:12:\"relationship\";a:7:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:41:\"Content entity referenced from field_host\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:17:\"Referenced Entity\";s:4:\"help\";s:64:\"A bridge to the Content entity that is referenced via field_host\";}}}s:25:\"field_revision_field_host\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:25:\"field_revision_field_host\";i:1;s:22:\"field_host-revision_id\";}}}s:22:\"field_host-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:4:\"Host\";s:11:\"title short\";s:4:\"Host\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:25:\"field_revision_field_host\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:10:\"field_host\";s:10:\"real field\";s:32:\"field_host-revision_id_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_host_target_id\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:20:\"field_host_target_id\";a:8:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:17:\"Host (field_host)\";s:11:\"title short\";s:4:\"Host\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_host_target_id\";s:5:\"table\";s:25:\"field_revision_field_host\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:20:\"field_host_target_id\";}s:10:\"field_name\";s:10:\"field_host\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_host_target_id\";s:5:\"table\";s:25:\"field_revision_field_host\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:20:\"field_host_target_id\";}s:10:\"field_name\";s:10:\"field_host\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_host_target_id\";s:5:\"table\";s:25:\"field_revision_field_host\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:20:\"field_host_target_id\";}s:10:\"field_name\";s:10:\"field_host\";}s:12:\"relationship\";a:7:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:41:\"Content entity referenced from field_host\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:17:\"Referenced Entity\";s:4:\"help\";s:64:\"A bridge to the Content entity that is referenced via field_host\";}}}s:27:\"field_data_field_datacenter\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:27:\"field_data_field_datacenter\";i:1;s:16:\"field_datacenter\";}}}s:16:\"field_datacenter\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"Datacenter\";s:11:\"title short\";s:10:\"Datacenter\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:27:\"field_data_field_datacenter\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_datacenter\";s:10:\"real field\";s:26:\"field_datacenter_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:26:\"field_datacenter_target_id\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:26:\"field_datacenter_target_id\";a:8:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:29:\"Datacenter (field_datacenter)\";s:11:\"title short\";s:10:\"Datacenter\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_datacenter_target_id\";s:5:\"table\";s:27:\"field_data_field_datacenter\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_datacenter_target_id\";}s:10:\"field_name\";s:16:\"field_datacenter\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_datacenter_target_id\";s:5:\"table\";s:27:\"field_data_field_datacenter\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_datacenter_target_id\";}s:10:\"field_name\";s:16:\"field_datacenter\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_datacenter_target_id\";s:5:\"table\";s:27:\"field_data_field_datacenter\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_datacenter_target_id\";}s:10:\"field_name\";s:16:\"field_datacenter\";}s:12:\"relationship\";a:7:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:47:\"Content entity referenced from field_datacenter\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:17:\"Referenced Entity\";s:4:\"help\";s:70:\"A bridge to the Content entity that is referenced via field_datacenter\";}}}s:31:\"field_revision_field_datacenter\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:31:\"field_revision_field_datacenter\";i:1;s:28:\"field_datacenter-revision_id\";}}}s:28:\"field_datacenter-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:10:\"Datacenter\";s:11:\"title short\";s:10:\"Datacenter\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:31:\"field_revision_field_datacenter\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_datacenter\";s:10:\"real field\";s:38:\"field_datacenter-revision_id_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:26:\"field_datacenter_target_id\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:26:\"field_datacenter_target_id\";a:8:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:29:\"Datacenter (field_datacenter)\";s:11:\"title short\";s:10:\"Datacenter\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_datacenter_target_id\";s:5:\"table\";s:31:\"field_revision_field_datacenter\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_datacenter_target_id\";}s:10:\"field_name\";s:16:\"field_datacenter\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_datacenter_target_id\";s:5:\"table\";s:31:\"field_revision_field_datacenter\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_datacenter_target_id\";}s:10:\"field_name\";s:16:\"field_datacenter\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_datacenter_target_id\";s:5:\"table\";s:31:\"field_revision_field_datacenter\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_datacenter_target_id\";}s:10:\"field_name\";s:16:\"field_datacenter\";}s:12:\"relationship\";a:7:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:47:\"Content entity referenced from field_datacenter\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:17:\"Referenced Entity\";s:4:\"help\";s:70:\"A bridge to the Content entity that is referenced via field_datacenter\";}}}s:29:\"field_data_field_related_host\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:29:\"field_data_field_related_host\";i:1;s:18:\"field_related_host\";}}}s:18:\"field_related_host\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:12:\"Related Host\";s:11:\"title short\";s:12:\"Related Host\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:29:\"field_data_field_related_host\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:18:\"field_related_host\";s:10:\"real field\";s:28:\"field_related_host_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_related_host_target_id\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:28:\"field_related_host_target_id\";a:8:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:33:\"Related Host (field_related_host)\";s:11:\"title short\";s:12:\"Related Host\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_related_host_target_id\";s:5:\"table\";s:29:\"field_data_field_related_host\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_related_host_target_id\";}s:10:\"field_name\";s:18:\"field_related_host\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_related_host_target_id\";s:5:\"table\";s:29:\"field_data_field_related_host\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_related_host_target_id\";}s:10:\"field_name\";s:18:\"field_related_host\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_related_host_target_id\";s:5:\"table\";s:29:\"field_data_field_related_host\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_related_host_target_id\";}s:10:\"field_name\";s:18:\"field_related_host\";}s:12:\"relationship\";a:7:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:49:\"Content entity referenced from field_related_host\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:17:\"Referenced Entity\";s:4:\"help\";s:72:\"A bridge to the Content entity that is referenced via field_related_host\";}}}s:33:\"field_revision_field_related_host\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:33:\"field_revision_field_related_host\";i:1;s:30:\"field_related_host-revision_id\";}}}s:30:\"field_related_host-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:12:\"Related Host\";s:11:\"title short\";s:12:\"Related Host\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:33:\"field_revision_field_related_host\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:18:\"field_related_host\";s:10:\"real field\";s:40:\"field_related_host-revision_id_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_related_host_target_id\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:28:\"field_related_host_target_id\";a:8:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:33:\"Related Host (field_related_host)\";s:11:\"title short\";s:12:\"Related Host\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_related_host_target_id\";s:5:\"table\";s:33:\"field_revision_field_related_host\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_related_host_target_id\";}s:10:\"field_name\";s:18:\"field_related_host\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_related_host_target_id\";s:5:\"table\";s:33:\"field_revision_field_related_host\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_related_host_target_id\";}s:10:\"field_name\";s:18:\"field_related_host\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_related_host_target_id\";s:5:\"table\";s:33:\"field_revision_field_related_host\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_related_host_target_id\";}s:10:\"field_name\";s:18:\"field_related_host\";}s:12:\"relationship\";a:7:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:49:\"Content entity referenced from field_related_host\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:17:\"Referenced Entity\";s:4:\"help\";s:72:\"A bridge to the Content entity that is referenced via field_related_host\";}}}s:32:\"field_data_field_virtual_machine\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:32:\"field_data_field_virtual_machine\";i:1;s:21:\"field_virtual_machine\";}}}s:21:\"field_virtual_machine\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:15:\"Virtual Machine\";s:11:\"title short\";s:15:\"Virtual Machine\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:32:\"field_data_field_virtual_machine\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:21:\"field_virtual_machine\";s:10:\"real field\";s:31:\"field_virtual_machine_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:31:\"field_virtual_machine_target_id\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:31:\"field_virtual_machine_target_id\";a:8:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:39:\"Virtual Machine (field_virtual_machine)\";s:11:\"title short\";s:15:\"Virtual Machine\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:31:\"field_virtual_machine_target_id\";s:5:\"table\";s:32:\"field_data_field_virtual_machine\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_virtual_machine_target_id\";}s:10:\"field_name\";s:21:\"field_virtual_machine\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:31:\"field_virtual_machine_target_id\";s:5:\"table\";s:32:\"field_data_field_virtual_machine\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_virtual_machine_target_id\";}s:10:\"field_name\";s:21:\"field_virtual_machine\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:31:\"field_virtual_machine_target_id\";s:5:\"table\";s:32:\"field_data_field_virtual_machine\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_virtual_machine_target_id\";}s:10:\"field_name\";s:21:\"field_virtual_machine\";}s:12:\"relationship\";a:7:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:52:\"Content entity referenced from field_virtual_machine\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:17:\"Referenced Entity\";s:4:\"help\";s:75:\"A bridge to the Content entity that is referenced via field_virtual_machine\";}}}s:36:\"field_revision_field_virtual_machine\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:36:\"field_revision_field_virtual_machine\";i:1;s:33:\"field_virtual_machine-revision_id\";}}}s:33:\"field_virtual_machine-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:15:\"Virtual Machine\";s:11:\"title short\";s:15:\"Virtual Machine\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:36:\"field_revision_field_virtual_machine\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:21:\"field_virtual_machine\";s:10:\"real field\";s:43:\"field_virtual_machine-revision_id_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:31:\"field_virtual_machine_target_id\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:31:\"field_virtual_machine_target_id\";a:8:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:39:\"Virtual Machine (field_virtual_machine)\";s:11:\"title short\";s:15:\"Virtual Machine\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:31:\"field_virtual_machine_target_id\";s:5:\"table\";s:36:\"field_revision_field_virtual_machine\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_virtual_machine_target_id\";}s:10:\"field_name\";s:21:\"field_virtual_machine\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:31:\"field_virtual_machine_target_id\";s:5:\"table\";s:36:\"field_revision_field_virtual_machine\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_virtual_machine_target_id\";}s:10:\"field_name\";s:21:\"field_virtual_machine\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:31:\"field_virtual_machine_target_id\";s:5:\"table\";s:36:\"field_revision_field_virtual_machine\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_virtual_machine_target_id\";}s:10:\"field_name\";s:21:\"field_virtual_machine\";}s:12:\"relationship\";a:7:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:52:\"Content entity referenced from field_virtual_machine\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:17:\"Referenced Entity\";s:4:\"help\";s:75:\"A bridge to the Content entity that is referenced via field_virtual_machine\";}}}s:32:\"field_data_field_related_vcenter\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:32:\"field_data_field_related_vcenter\";i:1;s:21:\"field_related_vcenter\";}}}s:21:\"field_related_vcenter\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:15:\"Related vCenter\";s:11:\"title short\";s:15:\"Related vCenter\";s:4:\"help\";s:29:\"Appears in: node:data_center.\";s:5:\"field\";a:9:{s:5:\"table\";s:32:\"field_data_field_related_vcenter\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:21:\"field_related_vcenter\";s:10:\"real field\";s:31:\"field_related_vcenter_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:31:\"field_related_vcenter_target_id\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:31:\"field_related_vcenter_target_id\";a:8:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:39:\"Related vCenter (field_related_vcenter)\";s:11:\"title short\";s:15:\"Related vCenter\";s:4:\"help\";s:29:\"Appears in: node:data_center.\";s:8:\"argument\";a:6:{s:5:\"field\";s:31:\"field_related_vcenter_target_id\";s:5:\"table\";s:32:\"field_data_field_related_vcenter\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_related_vcenter_target_id\";}s:10:\"field_name\";s:21:\"field_related_vcenter\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:31:\"field_related_vcenter_target_id\";s:5:\"table\";s:32:\"field_data_field_related_vcenter\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_related_vcenter_target_id\";}s:10:\"field_name\";s:21:\"field_related_vcenter\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:31:\"field_related_vcenter_target_id\";s:5:\"table\";s:32:\"field_data_field_related_vcenter\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_related_vcenter_target_id\";}s:10:\"field_name\";s:21:\"field_related_vcenter\";}s:12:\"relationship\";a:7:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:52:\"Content entity referenced from field_related_vcenter\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:17:\"Referenced Entity\";s:4:\"help\";s:75:\"A bridge to the Content entity that is referenced via field_related_vcenter\";}}}s:36:\"field_revision_field_related_vcenter\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:36:\"field_revision_field_related_vcenter\";i:1;s:33:\"field_related_vcenter-revision_id\";}}}s:33:\"field_related_vcenter-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:15:\"Related vCenter\";s:11:\"title short\";s:15:\"Related vCenter\";s:4:\"help\";s:29:\"Appears in: node:data_center.\";s:5:\"field\";a:9:{s:5:\"table\";s:36:\"field_revision_field_related_vcenter\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:21:\"field_related_vcenter\";s:10:\"real field\";s:43:\"field_related_vcenter-revision_id_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:31:\"field_related_vcenter_target_id\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:31:\"field_related_vcenter_target_id\";a:8:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:39:\"Related vCenter (field_related_vcenter)\";s:11:\"title short\";s:15:\"Related vCenter\";s:4:\"help\";s:29:\"Appears in: node:data_center.\";s:8:\"argument\";a:6:{s:5:\"field\";s:31:\"field_related_vcenter_target_id\";s:5:\"table\";s:36:\"field_revision_field_related_vcenter\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_related_vcenter_target_id\";}s:10:\"field_name\";s:21:\"field_related_vcenter\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:31:\"field_related_vcenter_target_id\";s:5:\"table\";s:36:\"field_revision_field_related_vcenter\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_related_vcenter_target_id\";}s:10:\"field_name\";s:21:\"field_related_vcenter\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:31:\"field_related_vcenter_target_id\";s:5:\"table\";s:36:\"field_revision_field_related_vcenter\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:31:\"field_related_vcenter_target_id\";}s:10:\"field_name\";s:21:\"field_related_vcenter\";}s:12:\"relationship\";a:7:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:52:\"Content entity referenced from field_related_vcenter\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:17:\"Referenced Entity\";s:4:\"help\";s:75:\"A bridge to the Content entity that is referenced via field_related_vcenter\";}}}s:30:\"field_data_field_bundle_status\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:30:\"field_data_field_bundle_status\";i:1;s:19:\"field_bundle_status\";}}}s:19:\"field_bundle_status\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:13:\"Bundle Status\";s:11:\"title short\";s:13:\"Bundle Status\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:30:\"field_data_field_bundle_status\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_bundle_status\";s:10:\"real field\";s:25:\"field_bundle_status_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_bundle_status_value\";i:4;s:26:\"field_bundle_status_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:25:\"field_bundle_status_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:35:\"Bundle Status (field_bundle_status)\";s:11:\"title short\";s:13:\"Bundle Status\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_bundle_status_value\";s:5:\"table\";s:30:\"field_data_field_bundle_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_bundle_status_value\";i:1;s:26:\"field_bundle_status_format\";}s:10:\"field_name\";s:19:\"field_bundle_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_bundle_status_value\";s:5:\"table\";s:30:\"field_data_field_bundle_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_bundle_status_value\";i:1;s:26:\"field_bundle_status_format\";}s:10:\"field_name\";s:19:\"field_bundle_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_bundle_status_value\";s:5:\"table\";s:30:\"field_data_field_bundle_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_bundle_status_value\";i:1;s:26:\"field_bundle_status_format\";}s:10:\"field_name\";s:19:\"field_bundle_status\";}}s:26:\"field_bundle_status_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:42:\"Bundle Status (field_bundle_status:format)\";s:11:\"title short\";s:20:\"Bundle Status:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_bundle_status_format\";s:5:\"table\";s:30:\"field_data_field_bundle_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_bundle_status_value\";i:1;s:26:\"field_bundle_status_format\";}s:10:\"field_name\";s:19:\"field_bundle_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_bundle_status_format\";s:5:\"table\";s:30:\"field_data_field_bundle_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_bundle_status_value\";i:1;s:26:\"field_bundle_status_format\";}s:10:\"field_name\";s:19:\"field_bundle_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_bundle_status_format\";s:5:\"table\";s:30:\"field_data_field_bundle_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_bundle_status_value\";i:1;s:26:\"field_bundle_status_format\";}s:10:\"field_name\";s:19:\"field_bundle_status\";}}}s:34:\"field_revision_field_bundle_status\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:34:\"field_revision_field_bundle_status\";i:1;s:31:\"field_bundle_status-revision_id\";}}}s:31:\"field_bundle_status-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:13:\"Bundle Status\";s:11:\"title short\";s:13:\"Bundle Status\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:34:\"field_revision_field_bundle_status\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_bundle_status\";s:10:\"real field\";s:37:\"field_bundle_status-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_bundle_status_value\";i:4;s:26:\"field_bundle_status_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:25:\"field_bundle_status_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:35:\"Bundle Status (field_bundle_status)\";s:11:\"title short\";s:13:\"Bundle Status\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_bundle_status_value\";s:5:\"table\";s:34:\"field_revision_field_bundle_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_bundle_status_value\";i:1;s:26:\"field_bundle_status_format\";}s:10:\"field_name\";s:19:\"field_bundle_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_bundle_status_value\";s:5:\"table\";s:34:\"field_revision_field_bundle_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_bundle_status_value\";i:1;s:26:\"field_bundle_status_format\";}s:10:\"field_name\";s:19:\"field_bundle_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_bundle_status_value\";s:5:\"table\";s:34:\"field_revision_field_bundle_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_bundle_status_value\";i:1;s:26:\"field_bundle_status_format\";}s:10:\"field_name\";s:19:\"field_bundle_status\";}}s:26:\"field_bundle_status_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:42:\"Bundle Status (field_bundle_status:format)\";s:11:\"title short\";s:20:\"Bundle Status:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_bundle_status_format\";s:5:\"table\";s:34:\"field_revision_field_bundle_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_bundle_status_value\";i:1;s:26:\"field_bundle_status_format\";}s:10:\"field_name\";s:19:\"field_bundle_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_bundle_status_format\";s:5:\"table\";s:34:\"field_revision_field_bundle_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_bundle_status_value\";i:1;s:26:\"field_bundle_status_format\";}s:10:\"field_name\";s:19:\"field_bundle_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_bundle_status_format\";s:5:\"table\";s:34:\"field_revision_field_bundle_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_bundle_status_value\";i:1;s:26:\"field_bundle_status_format\";}s:10:\"field_name\";s:19:\"field_bundle_status\";}}}s:30:\"field_data_field_driver_status\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:30:\"field_data_field_driver_status\";i:1;s:19:\"field_driver_status\";}}}s:19:\"field_driver_status\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:13:\"Driver Status\";s:11:\"title short\";s:13:\"Driver Status\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:30:\"field_data_field_driver_status\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_driver_status\";s:10:\"real field\";s:25:\"field_driver_status_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_driver_status_value\";i:4;s:26:\"field_driver_status_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:25:\"field_driver_status_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:35:\"Driver Status (field_driver_status)\";s:11:\"title short\";s:13:\"Driver Status\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_driver_status_value\";s:5:\"table\";s:30:\"field_data_field_driver_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_driver_status_value\";i:1;s:26:\"field_driver_status_format\";}s:10:\"field_name\";s:19:\"field_driver_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_driver_status_value\";s:5:\"table\";s:30:\"field_data_field_driver_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_driver_status_value\";i:1;s:26:\"field_driver_status_format\";}s:10:\"field_name\";s:19:\"field_driver_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_driver_status_value\";s:5:\"table\";s:30:\"field_data_field_driver_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_driver_status_value\";i:1;s:26:\"field_driver_status_format\";}s:10:\"field_name\";s:19:\"field_driver_status\";}}s:26:\"field_driver_status_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:42:\"Driver Status (field_driver_status:format)\";s:11:\"title short\";s:20:\"Driver Status:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_driver_status_format\";s:5:\"table\";s:30:\"field_data_field_driver_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_driver_status_value\";i:1;s:26:\"field_driver_status_format\";}s:10:\"field_name\";s:19:\"field_driver_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_driver_status_format\";s:5:\"table\";s:30:\"field_data_field_driver_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_driver_status_value\";i:1;s:26:\"field_driver_status_format\";}s:10:\"field_name\";s:19:\"field_driver_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_driver_status_format\";s:5:\"table\";s:30:\"field_data_field_driver_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_driver_status_value\";i:1;s:26:\"field_driver_status_format\";}s:10:\"field_name\";s:19:\"field_driver_status\";}}}s:34:\"field_revision_field_driver_status\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:34:\"field_revision_field_driver_status\";i:1;s:31:\"field_driver_status-revision_id\";}}}s:31:\"field_driver_status-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:13:\"Driver Status\";s:11:\"title short\";s:13:\"Driver Status\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:34:\"field_revision_field_driver_status\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_driver_status\";s:10:\"real field\";s:37:\"field_driver_status-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_driver_status_value\";i:4;s:26:\"field_driver_status_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:25:\"field_driver_status_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:35:\"Driver Status (field_driver_status)\";s:11:\"title short\";s:13:\"Driver Status\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_driver_status_value\";s:5:\"table\";s:34:\"field_revision_field_driver_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_driver_status_value\";i:1;s:26:\"field_driver_status_format\";}s:10:\"field_name\";s:19:\"field_driver_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_driver_status_value\";s:5:\"table\";s:34:\"field_revision_field_driver_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_driver_status_value\";i:1;s:26:\"field_driver_status_format\";}s:10:\"field_name\";s:19:\"field_driver_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_driver_status_value\";s:5:\"table\";s:34:\"field_revision_field_driver_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_driver_status_value\";i:1;s:26:\"field_driver_status_format\";}s:10:\"field_name\";s:19:\"field_driver_status\";}}s:26:\"field_driver_status_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:42:\"Driver Status (field_driver_status:format)\";s:11:\"title short\";s:20:\"Driver Status:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_driver_status_format\";s:5:\"table\";s:34:\"field_revision_field_driver_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_driver_status_value\";i:1;s:26:\"field_driver_status_format\";}s:10:\"field_name\";s:19:\"field_driver_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_driver_status_format\";s:5:\"table\";s:34:\"field_revision_field_driver_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_driver_status_value\";i:1;s:26:\"field_driver_status_format\";}s:10:\"field_name\";s:19:\"field_driver_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_driver_status_format\";s:5:\"table\";s:34:\"field_revision_field_driver_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_driver_status_value\";i:1;s:26:\"field_driver_status_format\";}s:10:\"field_name\";s:19:\"field_driver_status\";}}}s:30:\"field_data_field_host_password\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:30:\"field_data_field_host_password\";i:1;s:19:\"field_host_password\";}}}s:19:\"field_host_password\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:8:\"Password\";s:11:\"title short\";s:8:\"Password\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:30:\"field_data_field_host_password\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_host_password\";s:10:\"real field\";s:25:\"field_host_password_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_host_password_value\";i:4;s:26:\"field_host_password_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:25:\"field_host_password_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:30:\"Password (field_host_password)\";s:11:\"title short\";s:8:\"Password\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_host_password_value\";s:5:\"table\";s:30:\"field_data_field_host_password\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_password_value\";i:1;s:26:\"field_host_password_format\";}s:10:\"field_name\";s:19:\"field_host_password\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_host_password_value\";s:5:\"table\";s:30:\"field_data_field_host_password\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_password_value\";i:1;s:26:\"field_host_password_format\";}s:10:\"field_name\";s:19:\"field_host_password\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_host_password_value\";s:5:\"table\";s:30:\"field_data_field_host_password\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_password_value\";i:1;s:26:\"field_host_password_format\";}s:10:\"field_name\";s:19:\"field_host_password\";}}s:26:\"field_host_password_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:37:\"Password (field_host_password:format)\";s:11:\"title short\";s:15:\"Password:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_host_password_format\";s:5:\"table\";s:30:\"field_data_field_host_password\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_password_value\";i:1;s:26:\"field_host_password_format\";}s:10:\"field_name\";s:19:\"field_host_password\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_host_password_format\";s:5:\"table\";s:30:\"field_data_field_host_password\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_password_value\";i:1;s:26:\"field_host_password_format\";}s:10:\"field_name\";s:19:\"field_host_password\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_host_password_format\";s:5:\"table\";s:30:\"field_data_field_host_password\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_password_value\";i:1;s:26:\"field_host_password_format\";}s:10:\"field_name\";s:19:\"field_host_password\";}}}s:34:\"field_revision_field_host_password\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:34:\"field_revision_field_host_password\";i:1;s:31:\"field_host_password-revision_id\";}}}s:31:\"field_host_password-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:8:\"Password\";s:11:\"title short\";s:8:\"Password\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:34:\"field_revision_field_host_password\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_host_password\";s:10:\"real field\";s:37:\"field_host_password-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_host_password_value\";i:4;s:26:\"field_host_password_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:25:\"field_host_password_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:30:\"Password (field_host_password)\";s:11:\"title short\";s:8:\"Password\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_host_password_value\";s:5:\"table\";s:34:\"field_revision_field_host_password\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_password_value\";i:1;s:26:\"field_host_password_format\";}s:10:\"field_name\";s:19:\"field_host_password\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_host_password_value\";s:5:\"table\";s:34:\"field_revision_field_host_password\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_password_value\";i:1;s:26:\"field_host_password_format\";}s:10:\"field_name\";s:19:\"field_host_password\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_host_password_value\";s:5:\"table\";s:34:\"field_revision_field_host_password\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_password_value\";i:1;s:26:\"field_host_password_format\";}s:10:\"field_name\";s:19:\"field_host_password\";}}s:26:\"field_host_password_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:37:\"Password (field_host_password:format)\";s:11:\"title short\";s:15:\"Password:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_host_password_format\";s:5:\"table\";s:34:\"field_revision_field_host_password\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_password_value\";i:1;s:26:\"field_host_password_format\";}s:10:\"field_name\";s:19:\"field_host_password\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_host_password_format\";s:5:\"table\";s:34:\"field_revision_field_host_password\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_password_value\";i:1;s:26:\"field_host_password_format\";}s:10:\"field_name\";s:19:\"field_host_password\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_host_password_format\";s:5:\"table\";s:34:\"field_revision_field_host_password\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_password_value\";i:1;s:26:\"field_host_password_format\";}s:10:\"field_name\";s:19:\"field_host_password\";}}}s:30:\"field_data_field_host_username\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:30:\"field_data_field_host_username\";i:1;s:19:\"field_host_username\";}}}s:19:\"field_host_username\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:8:\"Username\";s:11:\"title short\";s:8:\"Username\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:30:\"field_data_field_host_username\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_host_username\";s:10:\"real field\";s:25:\"field_host_username_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_host_username_value\";i:4;s:26:\"field_host_username_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:25:\"field_host_username_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:30:\"Username (field_host_username)\";s:11:\"title short\";s:8:\"Username\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_host_username_value\";s:5:\"table\";s:30:\"field_data_field_host_username\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_username_value\";i:1;s:26:\"field_host_username_format\";}s:10:\"field_name\";s:19:\"field_host_username\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_host_username_value\";s:5:\"table\";s:30:\"field_data_field_host_username\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_username_value\";i:1;s:26:\"field_host_username_format\";}s:10:\"field_name\";s:19:\"field_host_username\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_host_username_value\";s:5:\"table\";s:30:\"field_data_field_host_username\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_username_value\";i:1;s:26:\"field_host_username_format\";}s:10:\"field_name\";s:19:\"field_host_username\";}}s:26:\"field_host_username_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:37:\"Username (field_host_username:format)\";s:11:\"title short\";s:15:\"Username:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_host_username_format\";s:5:\"table\";s:30:\"field_data_field_host_username\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_username_value\";i:1;s:26:\"field_host_username_format\";}s:10:\"field_name\";s:19:\"field_host_username\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_host_username_format\";s:5:\"table\";s:30:\"field_data_field_host_username\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_username_value\";i:1;s:26:\"field_host_username_format\";}s:10:\"field_name\";s:19:\"field_host_username\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_host_username_format\";s:5:\"table\";s:30:\"field_data_field_host_username\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_username_value\";i:1;s:26:\"field_host_username_format\";}s:10:\"field_name\";s:19:\"field_host_username\";}}}s:34:\"field_revision_field_host_username\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:34:\"field_revision_field_host_username\";i:1;s:31:\"field_host_username-revision_id\";}}}s:31:\"field_host_username-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:8:\"Username\";s:11:\"title short\";s:8:\"Username\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:34:\"field_revision_field_host_username\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_host_username\";s:10:\"real field\";s:37:\"field_host_username-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_host_username_value\";i:4;s:26:\"field_host_username_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:25:\"field_host_username_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:30:\"Username (field_host_username)\";s:11:\"title short\";s:8:\"Username\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_host_username_value\";s:5:\"table\";s:34:\"field_revision_field_host_username\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_username_value\";i:1;s:26:\"field_host_username_format\";}s:10:\"field_name\";s:19:\"field_host_username\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_host_username_value\";s:5:\"table\";s:34:\"field_revision_field_host_username\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_username_value\";i:1;s:26:\"field_host_username_format\";}s:10:\"field_name\";s:19:\"field_host_username\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_host_username_value\";s:5:\"table\";s:34:\"field_revision_field_host_username\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_username_value\";i:1;s:26:\"field_host_username_format\";}s:10:\"field_name\";s:19:\"field_host_username\";}}s:26:\"field_host_username_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:37:\"Username (field_host_username:format)\";s:11:\"title short\";s:15:\"Username:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_host_username_format\";s:5:\"table\";s:34:\"field_revision_field_host_username\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_username_value\";i:1;s:26:\"field_host_username_format\";}s:10:\"field_name\";s:19:\"field_host_username\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_host_username_format\";s:5:\"table\";s:34:\"field_revision_field_host_username\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_username_value\";i:1;s:26:\"field_host_username_format\";}s:10:\"field_name\";s:19:\"field_host_username\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_host_username_format\";s:5:\"table\";s:34:\"field_revision_field_host_username\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_host_username_value\";i:1;s:26:\"field_host_username_format\";}s:10:\"field_name\";s:19:\"field_host_username\";}}}s:28:\"field_data_field_vm_password\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:28:\"field_data_field_vm_password\";i:1;s:17:\"field_vm_password\";}}}s:17:\"field_vm_password\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:8:\"Password\";s:11:\"title short\";s:8:\"Password\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:28:\"field_data_field_vm_password\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_vm_password\";s:10:\"real field\";s:23:\"field_vm_password_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_vm_password_value\";i:4;s:24:\"field_vm_password_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:23:\"field_vm_password_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:28:\"Password (field_vm_password)\";s:11:\"title short\";s:8:\"Password\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_vm_password_value\";s:5:\"table\";s:28:\"field_data_field_vm_password\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_password_value\";i:1;s:24:\"field_vm_password_format\";}s:10:\"field_name\";s:17:\"field_vm_password\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_vm_password_value\";s:5:\"table\";s:28:\"field_data_field_vm_password\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_password_value\";i:1;s:24:\"field_vm_password_format\";}s:10:\"field_name\";s:17:\"field_vm_password\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_vm_password_value\";s:5:\"table\";s:28:\"field_data_field_vm_password\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_password_value\";i:1;s:24:\"field_vm_password_format\";}s:10:\"field_name\";s:17:\"field_vm_password\";}}s:24:\"field_vm_password_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:35:\"Password (field_vm_password:format)\";s:11:\"title short\";s:15:\"Password:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_vm_password_format\";s:5:\"table\";s:28:\"field_data_field_vm_password\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_password_value\";i:1;s:24:\"field_vm_password_format\";}s:10:\"field_name\";s:17:\"field_vm_password\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_vm_password_format\";s:5:\"table\";s:28:\"field_data_field_vm_password\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_password_value\";i:1;s:24:\"field_vm_password_format\";}s:10:\"field_name\";s:17:\"field_vm_password\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_vm_password_format\";s:5:\"table\";s:28:\"field_data_field_vm_password\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_password_value\";i:1;s:24:\"field_vm_password_format\";}s:10:\"field_name\";s:17:\"field_vm_password\";}}}s:32:\"field_revision_field_vm_password\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:32:\"field_revision_field_vm_password\";i:1;s:29:\"field_vm_password-revision_id\";}}}s:29:\"field_vm_password-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:8:\"Password\";s:11:\"title short\";s:8:\"Password\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:32:\"field_revision_field_vm_password\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_vm_password\";s:10:\"real field\";s:35:\"field_vm_password-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_vm_password_value\";i:4;s:24:\"field_vm_password_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:23:\"field_vm_password_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:28:\"Password (field_vm_password)\";s:11:\"title short\";s:8:\"Password\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_vm_password_value\";s:5:\"table\";s:32:\"field_revision_field_vm_password\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_password_value\";i:1;s:24:\"field_vm_password_format\";}s:10:\"field_name\";s:17:\"field_vm_password\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_vm_password_value\";s:5:\"table\";s:32:\"field_revision_field_vm_password\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_password_value\";i:1;s:24:\"field_vm_password_format\";}s:10:\"field_name\";s:17:\"field_vm_password\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_vm_password_value\";s:5:\"table\";s:32:\"field_revision_field_vm_password\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_password_value\";i:1;s:24:\"field_vm_password_format\";}s:10:\"field_name\";s:17:\"field_vm_password\";}}s:24:\"field_vm_password_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:35:\"Password (field_vm_password:format)\";s:11:\"title short\";s:15:\"Password:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_vm_password_format\";s:5:\"table\";s:32:\"field_revision_field_vm_password\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_password_value\";i:1;s:24:\"field_vm_password_format\";}s:10:\"field_name\";s:17:\"field_vm_password\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_vm_password_format\";s:5:\"table\";s:32:\"field_revision_field_vm_password\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_password_value\";i:1;s:24:\"field_vm_password_format\";}s:10:\"field_name\";s:17:\"field_vm_password\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_vm_password_format\";s:5:\"table\";s:32:\"field_revision_field_vm_password\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_password_value\";i:1;s:24:\"field_vm_password_format\";}s:10:\"field_name\";s:17:\"field_vm_password\";}}}s:28:\"field_data_field_vm_username\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:28:\"field_data_field_vm_username\";i:1;s:17:\"field_vm_username\";}}}s:17:\"field_vm_username\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:8:\"Username\";s:11:\"title short\";s:8:\"Username\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:28:\"field_data_field_vm_username\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_vm_username\";s:10:\"real field\";s:23:\"field_vm_username_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_vm_username_value\";i:4;s:24:\"field_vm_username_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:23:\"field_vm_username_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:28:\"Username (field_vm_username)\";s:11:\"title short\";s:8:\"Username\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_vm_username_value\";s:5:\"table\";s:28:\"field_data_field_vm_username\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_username_value\";i:1;s:24:\"field_vm_username_format\";}s:10:\"field_name\";s:17:\"field_vm_username\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_vm_username_value\";s:5:\"table\";s:28:\"field_data_field_vm_username\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_username_value\";i:1;s:24:\"field_vm_username_format\";}s:10:\"field_name\";s:17:\"field_vm_username\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_vm_username_value\";s:5:\"table\";s:28:\"field_data_field_vm_username\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_username_value\";i:1;s:24:\"field_vm_username_format\";}s:10:\"field_name\";s:17:\"field_vm_username\";}}s:24:\"field_vm_username_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:35:\"Username (field_vm_username:format)\";s:11:\"title short\";s:15:\"Username:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_vm_username_format\";s:5:\"table\";s:28:\"field_data_field_vm_username\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_username_value\";i:1;s:24:\"field_vm_username_format\";}s:10:\"field_name\";s:17:\"field_vm_username\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_vm_username_format\";s:5:\"table\";s:28:\"field_data_field_vm_username\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_username_value\";i:1;s:24:\"field_vm_username_format\";}s:10:\"field_name\";s:17:\"field_vm_username\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_vm_username_format\";s:5:\"table\";s:28:\"field_data_field_vm_username\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_username_value\";i:1;s:24:\"field_vm_username_format\";}s:10:\"field_name\";s:17:\"field_vm_username\";}}}s:32:\"field_revision_field_vm_username\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:32:\"field_revision_field_vm_username\";i:1;s:29:\"field_vm_username-revision_id\";}}}s:29:\"field_vm_username-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:8:\"Username\";s:11:\"title short\";s:8:\"Username\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:32:\"field_revision_field_vm_username\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_vm_username\";s:10:\"real field\";s:35:\"field_vm_username-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_vm_username_value\";i:4;s:24:\"field_vm_username_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:23:\"field_vm_username_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:28:\"Username (field_vm_username)\";s:11:\"title short\";s:8:\"Username\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_vm_username_value\";s:5:\"table\";s:32:\"field_revision_field_vm_username\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_username_value\";i:1;s:24:\"field_vm_username_format\";}s:10:\"field_name\";s:17:\"field_vm_username\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_vm_username_value\";s:5:\"table\";s:32:\"field_revision_field_vm_username\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_username_value\";i:1;s:24:\"field_vm_username_format\";}s:10:\"field_name\";s:17:\"field_vm_username\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_vm_username_value\";s:5:\"table\";s:32:\"field_revision_field_vm_username\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_username_value\";i:1;s:24:\"field_vm_username_format\";}s:10:\"field_name\";s:17:\"field_vm_username\";}}s:24:\"field_vm_username_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:35:\"Username (field_vm_username:format)\";s:11:\"title short\";s:15:\"Username:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_vm_username_format\";s:5:\"table\";s:32:\"field_revision_field_vm_username\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_username_value\";i:1;s:24:\"field_vm_username_format\";}s:10:\"field_name\";s:17:\"field_vm_username\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_vm_username_format\";s:5:\"table\";s:32:\"field_revision_field_vm_username\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_username_value\";i:1;s:24:\"field_vm_username_format\";}s:10:\"field_name\";s:17:\"field_vm_username\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_vm_username_format\";s:5:\"table\";s:32:\"field_revision_field_vm_username\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vm_username_value\";i:1;s:24:\"field_vm_username_format\";}s:10:\"field_name\";s:17:\"field_vm_username\";}}}s:26:\"field_data_field_freespace\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:26:\"field_data_field_freespace\";i:1;s:15:\"field_freespace\";}}}s:15:\"field_freespace\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:9:\"Freespace\";s:11:\"title short\";s:9:\"Freespace\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:26:\"field_data_field_freespace\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:15:\"field_freespace\";s:10:\"real field\";s:21:\"field_freespace_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:21:\"field_freespace_value\";i:4;s:22:\"field_freespace_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:21:\"field_freespace_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:27:\"Freespace (field_freespace)\";s:11:\"title short\";s:9:\"Freespace\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_freespace_value\";s:5:\"table\";s:26:\"field_data_field_freespace\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_freespace_value\";i:1;s:22:\"field_freespace_format\";}s:10:\"field_name\";s:15:\"field_freespace\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_freespace_value\";s:5:\"table\";s:26:\"field_data_field_freespace\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_freespace_value\";i:1;s:22:\"field_freespace_format\";}s:10:\"field_name\";s:15:\"field_freespace\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_freespace_value\";s:5:\"table\";s:26:\"field_data_field_freespace\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_freespace_value\";i:1;s:22:\"field_freespace_format\";}s:10:\"field_name\";s:15:\"field_freespace\";}}s:22:\"field_freespace_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:34:\"Freespace (field_freespace:format)\";s:11:\"title short\";s:16:\"Freespace:format\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_freespace_format\";s:5:\"table\";s:26:\"field_data_field_freespace\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_freespace_value\";i:1;s:22:\"field_freespace_format\";}s:10:\"field_name\";s:15:\"field_freespace\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_freespace_format\";s:5:\"table\";s:26:\"field_data_field_freespace\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_freespace_value\";i:1;s:22:\"field_freespace_format\";}s:10:\"field_name\";s:15:\"field_freespace\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_freespace_format\";s:5:\"table\";s:26:\"field_data_field_freespace\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_freespace_value\";i:1;s:22:\"field_freespace_format\";}s:10:\"field_name\";s:15:\"field_freespace\";}}}s:30:\"field_revision_field_freespace\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:30:\"field_revision_field_freespace\";i:1;s:27:\"field_freespace-revision_id\";}}}s:27:\"field_freespace-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:9:\"Freespace\";s:11:\"title short\";s:9:\"Freespace\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:30:\"field_revision_field_freespace\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:15:\"field_freespace\";s:10:\"real field\";s:33:\"field_freespace-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:21:\"field_freespace_value\";i:4;s:22:\"field_freespace_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:21:\"field_freespace_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:27:\"Freespace (field_freespace)\";s:11:\"title short\";s:9:\"Freespace\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_freespace_value\";s:5:\"table\";s:30:\"field_revision_field_freespace\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_freespace_value\";i:1;s:22:\"field_freespace_format\";}s:10:\"field_name\";s:15:\"field_freespace\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_freespace_value\";s:5:\"table\";s:30:\"field_revision_field_freespace\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_freespace_value\";i:1;s:22:\"field_freespace_format\";}s:10:\"field_name\";s:15:\"field_freespace\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_freespace_value\";s:5:\"table\";s:30:\"field_revision_field_freespace\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_freespace_value\";i:1;s:22:\"field_freespace_format\";}s:10:\"field_name\";s:15:\"field_freespace\";}}s:22:\"field_freespace_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:34:\"Freespace (field_freespace:format)\";s:11:\"title short\";s:16:\"Freespace:format\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_freespace_format\";s:5:\"table\";s:30:\"field_revision_field_freespace\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_freespace_value\";i:1;s:22:\"field_freespace_format\";}s:10:\"field_name\";s:15:\"field_freespace\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_freespace_format\";s:5:\"table\";s:30:\"field_revision_field_freespace\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_freespace_value\";i:1;s:22:\"field_freespace_format\";}s:10:\"field_name\";s:15:\"field_freespace\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_freespace_format\";s:5:\"table\";s:30:\"field_revision_field_freespace\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_freespace_value\";i:1;s:22:\"field_freespace_format\";}s:10:\"field_name\";s:15:\"field_freespace\";}}}s:21:\"field_data_field_path\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:21:\"field_data_field_path\";i:1;s:10:\"field_path\";}}}s:10:\"field_path\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:4:\"Path\";s:11:\"title short\";s:4:\"Path\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:21:\"field_data_field_path\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:10:\"field_path\";s:10:\"real field\";s:16:\"field_path_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:16:\"field_path_value\";i:4;s:17:\"field_path_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:16:\"field_path_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:17:\"Path (field_path)\";s:11:\"title short\";s:4:\"Path\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:16:\"field_path_value\";s:5:\"table\";s:21:\"field_data_field_path\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_path_value\";i:1;s:17:\"field_path_format\";}s:10:\"field_name\";s:10:\"field_path\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:16:\"field_path_value\";s:5:\"table\";s:21:\"field_data_field_path\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_path_value\";i:1;s:17:\"field_path_format\";}s:10:\"field_name\";s:10:\"field_path\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:16:\"field_path_value\";s:5:\"table\";s:21:\"field_data_field_path\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_path_value\";i:1;s:17:\"field_path_format\";}s:10:\"field_name\";s:10:\"field_path\";}}s:17:\"field_path_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:24:\"Path (field_path:format)\";s:11:\"title short\";s:11:\"Path:format\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:17:\"field_path_format\";s:5:\"table\";s:21:\"field_data_field_path\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_path_value\";i:1;s:17:\"field_path_format\";}s:10:\"field_name\";s:10:\"field_path\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:17:\"field_path_format\";s:5:\"table\";s:21:\"field_data_field_path\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_path_value\";i:1;s:17:\"field_path_format\";}s:10:\"field_name\";s:10:\"field_path\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:17:\"field_path_format\";s:5:\"table\";s:21:\"field_data_field_path\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_path_value\";i:1;s:17:\"field_path_format\";}s:10:\"field_name\";s:10:\"field_path\";}}}s:25:\"field_revision_field_path\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:25:\"field_revision_field_path\";i:1;s:22:\"field_path-revision_id\";}}}s:22:\"field_path-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:4:\"Path\";s:11:\"title short\";s:4:\"Path\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:25:\"field_revision_field_path\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:10:\"field_path\";s:10:\"real field\";s:28:\"field_path-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:16:\"field_path_value\";i:4;s:17:\"field_path_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:16:\"field_path_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:17:\"Path (field_path)\";s:11:\"title short\";s:4:\"Path\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:16:\"field_path_value\";s:5:\"table\";s:25:\"field_revision_field_path\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_path_value\";i:1;s:17:\"field_path_format\";}s:10:\"field_name\";s:10:\"field_path\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:16:\"field_path_value\";s:5:\"table\";s:25:\"field_revision_field_path\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_path_value\";i:1;s:17:\"field_path_format\";}s:10:\"field_name\";s:10:\"field_path\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:16:\"field_path_value\";s:5:\"table\";s:25:\"field_revision_field_path\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_path_value\";i:1;s:17:\"field_path_format\";}s:10:\"field_name\";s:10:\"field_path\";}}s:17:\"field_path_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:24:\"Path (field_path:format)\";s:11:\"title short\";s:11:\"Path:format\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:17:\"field_path_format\";s:5:\"table\";s:25:\"field_revision_field_path\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_path_value\";i:1;s:17:\"field_path_format\";}s:10:\"field_name\";s:10:\"field_path\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:17:\"field_path_format\";s:5:\"table\";s:25:\"field_revision_field_path\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_path_value\";i:1;s:17:\"field_path_format\";}s:10:\"field_name\";s:10:\"field_path\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:17:\"field_path_format\";s:5:\"table\";s:25:\"field_revision_field_path\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_path_value\";i:1;s:17:\"field_path_format\";}s:10:\"field_name\";s:10:\"field_path\";}}}s:25:\"field_data_field_capacity\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:25:\"field_data_field_capacity\";i:1;s:14:\"field_capacity\";}}}s:14:\"field_capacity\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:8:\"Capacity\";s:11:\"title short\";s:8:\"Capacity\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:25:\"field_data_field_capacity\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_capacity\";s:10:\"real field\";s:20:\"field_capacity_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_capacity_value\";i:4;s:21:\"field_capacity_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:20:\"field_capacity_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:25:\"Capacity (field_capacity)\";s:11:\"title short\";s:8:\"Capacity\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_capacity_value\";s:5:\"table\";s:25:\"field_data_field_capacity\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_capacity_value\";i:1;s:21:\"field_capacity_format\";}s:10:\"field_name\";s:14:\"field_capacity\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_capacity_value\";s:5:\"table\";s:25:\"field_data_field_capacity\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_capacity_value\";i:1;s:21:\"field_capacity_format\";}s:10:\"field_name\";s:14:\"field_capacity\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_capacity_value\";s:5:\"table\";s:25:\"field_data_field_capacity\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_capacity_value\";i:1;s:21:\"field_capacity_format\";}s:10:\"field_name\";s:14:\"field_capacity\";}}s:21:\"field_capacity_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:32:\"Capacity (field_capacity:format)\";s:11:\"title short\";s:15:\"Capacity:format\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_capacity_format\";s:5:\"table\";s:25:\"field_data_field_capacity\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_capacity_value\";i:1;s:21:\"field_capacity_format\";}s:10:\"field_name\";s:14:\"field_capacity\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_capacity_format\";s:5:\"table\";s:25:\"field_data_field_capacity\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_capacity_value\";i:1;s:21:\"field_capacity_format\";}s:10:\"field_name\";s:14:\"field_capacity\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_capacity_format\";s:5:\"table\";s:25:\"field_data_field_capacity\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_capacity_value\";i:1;s:21:\"field_capacity_format\";}s:10:\"field_name\";s:14:\"field_capacity\";}}}s:29:\"field_revision_field_capacity\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:29:\"field_revision_field_capacity\";i:1;s:26:\"field_capacity-revision_id\";}}}s:26:\"field_capacity-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:8:\"Capacity\";s:11:\"title short\";s:8:\"Capacity\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:5:\"field\";a:9:{s:5:\"table\";s:29:\"field_revision_field_capacity\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_capacity\";s:10:\"real field\";s:32:\"field_capacity-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_capacity_value\";i:4;s:21:\"field_capacity_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:20:\"field_capacity_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:25:\"Capacity (field_capacity)\";s:11:\"title short\";s:8:\"Capacity\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_capacity_value\";s:5:\"table\";s:29:\"field_revision_field_capacity\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_capacity_value\";i:1;s:21:\"field_capacity_format\";}s:10:\"field_name\";s:14:\"field_capacity\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_capacity_value\";s:5:\"table\";s:29:\"field_revision_field_capacity\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_capacity_value\";i:1;s:21:\"field_capacity_format\";}s:10:\"field_name\";s:14:\"field_capacity\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_capacity_value\";s:5:\"table\";s:29:\"field_revision_field_capacity\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_capacity_value\";i:1;s:21:\"field_capacity_format\";}s:10:\"field_name\";s:14:\"field_capacity\";}}s:21:\"field_capacity_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:32:\"Capacity (field_capacity:format)\";s:11:\"title short\";s:15:\"Capacity:format\";s:4:\"help\";s:23:\"Appears in: node:vdisk.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_capacity_format\";s:5:\"table\";s:29:\"field_revision_field_capacity\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_capacity_value\";i:1;s:21:\"field_capacity_format\";}s:10:\"field_name\";s:14:\"field_capacity\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_capacity_format\";s:5:\"table\";s:29:\"field_revision_field_capacity\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_capacity_value\";i:1;s:21:\"field_capacity_format\";}s:10:\"field_name\";s:14:\"field_capacity\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_capacity_format\";s:5:\"table\";s:29:\"field_revision_field_capacity\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_capacity_value\";i:1;s:21:\"field_capacity_format\";}s:10:\"field_name\";s:14:\"field_capacity\";}}}s:29:\"field_data_field_display_name\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:29:\"field_data_field_display_name\";i:1;s:18:\"field_display_name\";}}}s:18:\"field_display_name\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:12:\"Display Name\";s:11:\"title short\";s:12:\"Display Name\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:29:\"field_data_field_display_name\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:18:\"field_display_name\";s:10:\"real field\";s:24:\"field_display_name_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:24:\"field_display_name_value\";i:4;s:25:\"field_display_name_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:24:\"field_display_name_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:33:\"Display Name (field_display_name)\";s:11:\"title short\";s:12:\"Display Name\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_display_name_value\";s:5:\"table\";s:29:\"field_data_field_display_name\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_display_name_value\";i:1;s:25:\"field_display_name_format\";}s:10:\"field_name\";s:18:\"field_display_name\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_display_name_value\";s:5:\"table\";s:29:\"field_data_field_display_name\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_display_name_value\";i:1;s:25:\"field_display_name_format\";}s:10:\"field_name\";s:18:\"field_display_name\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_display_name_value\";s:5:\"table\";s:29:\"field_data_field_display_name\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_display_name_value\";i:1;s:25:\"field_display_name_format\";}s:10:\"field_name\";s:18:\"field_display_name\";}}s:25:\"field_display_name_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:40:\"Display Name (field_display_name:format)\";s:11:\"title short\";s:19:\"Display Name:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_display_name_format\";s:5:\"table\";s:29:\"field_data_field_display_name\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_display_name_value\";i:1;s:25:\"field_display_name_format\";}s:10:\"field_name\";s:18:\"field_display_name\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_display_name_format\";s:5:\"table\";s:29:\"field_data_field_display_name\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_display_name_value\";i:1;s:25:\"field_display_name_format\";}s:10:\"field_name\";s:18:\"field_display_name\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_display_name_format\";s:5:\"table\";s:29:\"field_data_field_display_name\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_display_name_value\";i:1;s:25:\"field_display_name_format\";}s:10:\"field_name\";s:18:\"field_display_name\";}}}s:33:\"field_revision_field_display_name\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:33:\"field_revision_field_display_name\";i:1;s:30:\"field_display_name-revision_id\";}}}s:30:\"field_display_name-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:12:\"Display Name\";s:11:\"title short\";s:12:\"Display Name\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:33:\"field_revision_field_display_name\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:18:\"field_display_name\";s:10:\"real field\";s:36:\"field_display_name-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:24:\"field_display_name_value\";i:4;s:25:\"field_display_name_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:24:\"field_display_name_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:33:\"Display Name (field_display_name)\";s:11:\"title short\";s:12:\"Display Name\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_display_name_value\";s:5:\"table\";s:33:\"field_revision_field_display_name\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_display_name_value\";i:1;s:25:\"field_display_name_format\";}s:10:\"field_name\";s:18:\"field_display_name\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_display_name_value\";s:5:\"table\";s:33:\"field_revision_field_display_name\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_display_name_value\";i:1;s:25:\"field_display_name_format\";}s:10:\"field_name\";s:18:\"field_display_name\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_display_name_value\";s:5:\"table\";s:33:\"field_revision_field_display_name\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_display_name_value\";i:1;s:25:\"field_display_name_format\";}s:10:\"field_name\";s:18:\"field_display_name\";}}s:25:\"field_display_name_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:40:\"Display Name (field_display_name:format)\";s:11:\"title short\";s:19:\"Display Name:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_display_name_format\";s:5:\"table\";s:33:\"field_revision_field_display_name\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_display_name_value\";i:1;s:25:\"field_display_name_format\";}s:10:\"field_name\";s:18:\"field_display_name\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_display_name_format\";s:5:\"table\";s:33:\"field_revision_field_display_name\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_display_name_value\";i:1;s:25:\"field_display_name_format\";}s:10:\"field_name\";s:18:\"field_display_name\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_display_name_format\";s:5:\"table\";s:33:\"field_revision_field_display_name\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_display_name_value\";i:1;s:25:\"field_display_name_format\";}s:10:\"field_name\";s:18:\"field_display_name\";}}}s:27:\"field_data_field_other_uids\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:27:\"field_data_field_other_uids\";i:1;s:16:\"field_other_uids\";}}}s:16:\"field_other_uids\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"Other UIDs\";s:11:\"title short\";s:10:\"Other UIDs\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:27:\"field_data_field_other_uids\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_other_uids\";s:10:\"real field\";s:22:\"field_other_uids_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_other_uids_value\";i:4;s:23:\"field_other_uids_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:22:\"field_other_uids_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:29:\"Other UIDs (field_other_uids)\";s:11:\"title short\";s:10:\"Other UIDs\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_other_uids_value\";s:5:\"table\";s:27:\"field_data_field_other_uids\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_other_uids_value\";i:1;s:23:\"field_other_uids_format\";}s:10:\"field_name\";s:16:\"field_other_uids\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_other_uids_value\";s:5:\"table\";s:27:\"field_data_field_other_uids\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_other_uids_value\";i:1;s:23:\"field_other_uids_format\";}s:10:\"field_name\";s:16:\"field_other_uids\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_other_uids_value\";s:5:\"table\";s:27:\"field_data_field_other_uids\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_other_uids_value\";i:1;s:23:\"field_other_uids_format\";}s:10:\"field_name\";s:16:\"field_other_uids\";}}s:23:\"field_other_uids_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:36:\"Other UIDs (field_other_uids:format)\";s:11:\"title short\";s:17:\"Other UIDs:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_other_uids_format\";s:5:\"table\";s:27:\"field_data_field_other_uids\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_other_uids_value\";i:1;s:23:\"field_other_uids_format\";}s:10:\"field_name\";s:16:\"field_other_uids\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_other_uids_format\";s:5:\"table\";s:27:\"field_data_field_other_uids\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_other_uids_value\";i:1;s:23:\"field_other_uids_format\";}s:10:\"field_name\";s:16:\"field_other_uids\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_other_uids_format\";s:5:\"table\";s:27:\"field_data_field_other_uids\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_other_uids_value\";i:1;s:23:\"field_other_uids_format\";}s:10:\"field_name\";s:16:\"field_other_uids\";}}}s:31:\"field_revision_field_other_uids\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:31:\"field_revision_field_other_uids\";i:1;s:28:\"field_other_uids-revision_id\";}}}s:28:\"field_other_uids-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:10:\"Other UIDs\";s:11:\"title short\";s:10:\"Other UIDs\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:31:\"field_revision_field_other_uids\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_other_uids\";s:10:\"real field\";s:34:\"field_other_uids-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_other_uids_value\";i:4;s:23:\"field_other_uids_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:22:\"field_other_uids_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:29:\"Other UIDs (field_other_uids)\";s:11:\"title short\";s:10:\"Other UIDs\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_other_uids_value\";s:5:\"table\";s:31:\"field_revision_field_other_uids\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_other_uids_value\";i:1;s:23:\"field_other_uids_format\";}s:10:\"field_name\";s:16:\"field_other_uids\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_other_uids_value\";s:5:\"table\";s:31:\"field_revision_field_other_uids\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_other_uids_value\";i:1;s:23:\"field_other_uids_format\";}s:10:\"field_name\";s:16:\"field_other_uids\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_other_uids_value\";s:5:\"table\";s:31:\"field_revision_field_other_uids\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_other_uids_value\";i:1;s:23:\"field_other_uids_format\";}s:10:\"field_name\";s:16:\"field_other_uids\";}}s:23:\"field_other_uids_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:36:\"Other UIDs (field_other_uids:format)\";s:11:\"title short\";s:17:\"Other UIDs:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_other_uids_format\";s:5:\"table\";s:31:\"field_revision_field_other_uids\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_other_uids_value\";i:1;s:23:\"field_other_uids_format\";}s:10:\"field_name\";s:16:\"field_other_uids\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_other_uids_format\";s:5:\"table\";s:31:\"field_revision_field_other_uids\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_other_uids_value\";i:1;s:23:\"field_other_uids_format\";}s:10:\"field_name\";s:16:\"field_other_uids\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_other_uids_format\";s:5:\"table\";s:31:\"field_revision_field_other_uids\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_other_uids_value\";i:1;s:23:\"field_other_uids_format\";}s:10:\"field_name\";s:16:\"field_other_uids\";}}}s:28:\"field_data_field_vaai_status\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:28:\"field_data_field_vaai_status\";i:1;s:17:\"field_vaai_status\";}}}s:17:\"field_vaai_status\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:11:\"VAAI Status\";s:11:\"title short\";s:11:\"VAAI Status\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:28:\"field_data_field_vaai_status\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_vaai_status\";s:10:\"real field\";s:23:\"field_vaai_status_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_vaai_status_value\";i:4;s:24:\"field_vaai_status_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:23:\"field_vaai_status_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:31:\"VAAI Status (field_vaai_status)\";s:11:\"title short\";s:11:\"VAAI Status\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_vaai_status_value\";s:5:\"table\";s:28:\"field_data_field_vaai_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vaai_status_value\";i:1;s:24:\"field_vaai_status_format\";}s:10:\"field_name\";s:17:\"field_vaai_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_vaai_status_value\";s:5:\"table\";s:28:\"field_data_field_vaai_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vaai_status_value\";i:1;s:24:\"field_vaai_status_format\";}s:10:\"field_name\";s:17:\"field_vaai_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_vaai_status_value\";s:5:\"table\";s:28:\"field_data_field_vaai_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vaai_status_value\";i:1;s:24:\"field_vaai_status_format\";}s:10:\"field_name\";s:17:\"field_vaai_status\";}}s:24:\"field_vaai_status_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:38:\"VAAI Status (field_vaai_status:format)\";s:11:\"title short\";s:18:\"VAAI Status:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_vaai_status_format\";s:5:\"table\";s:28:\"field_data_field_vaai_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vaai_status_value\";i:1;s:24:\"field_vaai_status_format\";}s:10:\"field_name\";s:17:\"field_vaai_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_vaai_status_format\";s:5:\"table\";s:28:\"field_data_field_vaai_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vaai_status_value\";i:1;s:24:\"field_vaai_status_format\";}s:10:\"field_name\";s:17:\"field_vaai_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_vaai_status_format\";s:5:\"table\";s:28:\"field_data_field_vaai_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vaai_status_value\";i:1;s:24:\"field_vaai_status_format\";}s:10:\"field_name\";s:17:\"field_vaai_status\";}}}s:32:\"field_revision_field_vaai_status\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:32:\"field_revision_field_vaai_status\";i:1;s:29:\"field_vaai_status-revision_id\";}}}s:29:\"field_vaai_status-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:11:\"VAAI Status\";s:11:\"title short\";s:11:\"VAAI Status\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:32:\"field_revision_field_vaai_status\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_vaai_status\";s:10:\"real field\";s:35:\"field_vaai_status-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_vaai_status_value\";i:4;s:24:\"field_vaai_status_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:23:\"field_vaai_status_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:31:\"VAAI Status (field_vaai_status)\";s:11:\"title short\";s:11:\"VAAI Status\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_vaai_status_value\";s:5:\"table\";s:32:\"field_revision_field_vaai_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vaai_status_value\";i:1;s:24:\"field_vaai_status_format\";}s:10:\"field_name\";s:17:\"field_vaai_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_vaai_status_value\";s:5:\"table\";s:32:\"field_revision_field_vaai_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vaai_status_value\";i:1;s:24:\"field_vaai_status_format\";}s:10:\"field_name\";s:17:\"field_vaai_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_vaai_status_value\";s:5:\"table\";s:32:\"field_revision_field_vaai_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vaai_status_value\";i:1;s:24:\"field_vaai_status_format\";}s:10:\"field_name\";s:17:\"field_vaai_status\";}}s:24:\"field_vaai_status_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:38:\"VAAI Status (field_vaai_status:format)\";s:11:\"title short\";s:18:\"VAAI Status:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_vaai_status_format\";s:5:\"table\";s:32:\"field_revision_field_vaai_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vaai_status_value\";i:1;s:24:\"field_vaai_status_format\";}s:10:\"field_name\";s:17:\"field_vaai_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_vaai_status_format\";s:5:\"table\";s:32:\"field_revision_field_vaai_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vaai_status_value\";i:1;s:24:\"field_vaai_status_format\";}s:10:\"field_name\";s:17:\"field_vaai_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_vaai_status_format\";s:5:\"table\";s:32:\"field_revision_field_vaai_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_vaai_status_value\";i:1;s:24:\"field_vaai_status_format\";}s:10:\"field_name\";s:17:\"field_vaai_status\";}}}s:33:\"field_data_field_attached_filters\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:33:\"field_data_field_attached_filters\";i:1;s:22:\"field_attached_filters\";}}}s:22:\"field_attached_filters\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:16:\"Attached Filters\";s:11:\"title short\";s:16:\"Attached Filters\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:33:\"field_data_field_attached_filters\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_attached_filters\";s:10:\"real field\";s:28:\"field_attached_filters_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_attached_filters_value\";i:4;s:29:\"field_attached_filters_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:28:\"field_attached_filters_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:41:\"Attached Filters (field_attached_filters)\";s:11:\"title short\";s:16:\"Attached Filters\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_attached_filters_value\";s:5:\"table\";s:33:\"field_data_field_attached_filters\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_attached_filters_value\";i:1;s:29:\"field_attached_filters_format\";}s:10:\"field_name\";s:22:\"field_attached_filters\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_attached_filters_value\";s:5:\"table\";s:33:\"field_data_field_attached_filters\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_attached_filters_value\";i:1;s:29:\"field_attached_filters_format\";}s:10:\"field_name\";s:22:\"field_attached_filters\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_attached_filters_value\";s:5:\"table\";s:33:\"field_data_field_attached_filters\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_attached_filters_value\";i:1;s:29:\"field_attached_filters_format\";}s:10:\"field_name\";s:22:\"field_attached_filters\";}}s:29:\"field_attached_filters_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:48:\"Attached Filters (field_attached_filters:format)\";s:11:\"title short\";s:23:\"Attached Filters:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_attached_filters_format\";s:5:\"table\";s:33:\"field_data_field_attached_filters\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_attached_filters_value\";i:1;s:29:\"field_attached_filters_format\";}s:10:\"field_name\";s:22:\"field_attached_filters\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_attached_filters_format\";s:5:\"table\";s:33:\"field_data_field_attached_filters\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_attached_filters_value\";i:1;s:29:\"field_attached_filters_format\";}s:10:\"field_name\";s:22:\"field_attached_filters\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_attached_filters_format\";s:5:\"table\";s:33:\"field_data_field_attached_filters\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_attached_filters_value\";i:1;s:29:\"field_attached_filters_format\";}s:10:\"field_name\";s:22:\"field_attached_filters\";}}}s:37:\"field_revision_field_attached_filters\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:37:\"field_revision_field_attached_filters\";i:1;s:34:\"field_attached_filters-revision_id\";}}}s:34:\"field_attached_filters-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:16:\"Attached Filters\";s:11:\"title short\";s:16:\"Attached Filters\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:37:\"field_revision_field_attached_filters\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_attached_filters\";s:10:\"real field\";s:40:\"field_attached_filters-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_attached_filters_value\";i:4;s:29:\"field_attached_filters_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:28:\"field_attached_filters_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:41:\"Attached Filters (field_attached_filters)\";s:11:\"title short\";s:16:\"Attached Filters\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_attached_filters_value\";s:5:\"table\";s:37:\"field_revision_field_attached_filters\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_attached_filters_value\";i:1;s:29:\"field_attached_filters_format\";}s:10:\"field_name\";s:22:\"field_attached_filters\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_attached_filters_value\";s:5:\"table\";s:37:\"field_revision_field_attached_filters\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_attached_filters_value\";i:1;s:29:\"field_attached_filters_format\";}s:10:\"field_name\";s:22:\"field_attached_filters\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_attached_filters_value\";s:5:\"table\";s:37:\"field_revision_field_attached_filters\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_attached_filters_value\";i:1;s:29:\"field_attached_filters_format\";}s:10:\"field_name\";s:22:\"field_attached_filters\";}}s:29:\"field_attached_filters_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:48:\"Attached Filters (field_attached_filters:format)\";s:11:\"title short\";s:23:\"Attached Filters:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_attached_filters_format\";s:5:\"table\";s:37:\"field_revision_field_attached_filters\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_attached_filters_value\";i:1;s:29:\"field_attached_filters_format\";}s:10:\"field_name\";s:22:\"field_attached_filters\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_attached_filters_format\";s:5:\"table\";s:37:\"field_revision_field_attached_filters\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_attached_filters_value\";i:1;s:29:\"field_attached_filters_format\";}s:10:\"field_name\";s:22:\"field_attached_filters\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_attached_filters_format\";s:5:\"table\";s:37:\"field_revision_field_attached_filters\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_attached_filters_value\";i:1;s:29:\"field_attached_filters_format\";}s:10:\"field_name\";s:22:\"field_attached_filters\";}}}s:41:\"field_data_field_thin_provisioning_status\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:41:\"field_data_field_thin_provisioning_status\";i:1;s:30:\"field_thin_provisioning_status\";}}}s:30:\"field_thin_provisioning_status\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:24:\"Thin Provisioning Status\";s:11:\"title short\";s:24:\"Thin Provisioning Status\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:41:\"field_data_field_thin_provisioning_status\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:30:\"field_thin_provisioning_status\";s:10:\"real field\";s:36:\"field_thin_provisioning_status_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:36:\"field_thin_provisioning_status_value\";i:4;s:37:\"field_thin_provisioning_status_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:36:\"field_thin_provisioning_status_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:57:\"Thin Provisioning Status (field_thin_provisioning_status)\";s:11:\"title short\";s:24:\"Thin Provisioning Status\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:36:\"field_thin_provisioning_status_value\";s:5:\"table\";s:41:\"field_data_field_thin_provisioning_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:36:\"field_thin_provisioning_status_value\";i:1;s:37:\"field_thin_provisioning_status_format\";}s:10:\"field_name\";s:30:\"field_thin_provisioning_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:36:\"field_thin_provisioning_status_value\";s:5:\"table\";s:41:\"field_data_field_thin_provisioning_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:36:\"field_thin_provisioning_status_value\";i:1;s:37:\"field_thin_provisioning_status_format\";}s:10:\"field_name\";s:30:\"field_thin_provisioning_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:36:\"field_thin_provisioning_status_value\";s:5:\"table\";s:41:\"field_data_field_thin_provisioning_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:36:\"field_thin_provisioning_status_value\";i:1;s:37:\"field_thin_provisioning_status_format\";}s:10:\"field_name\";s:30:\"field_thin_provisioning_status\";}}s:37:\"field_thin_provisioning_status_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:64:\"Thin Provisioning Status (field_thin_provisioning_status:format)\";s:11:\"title short\";s:31:\"Thin Provisioning Status:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:37:\"field_thin_provisioning_status_format\";s:5:\"table\";s:41:\"field_data_field_thin_provisioning_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:36:\"field_thin_provisioning_status_value\";i:1;s:37:\"field_thin_provisioning_status_format\";}s:10:\"field_name\";s:30:\"field_thin_provisioning_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:37:\"field_thin_provisioning_status_format\";s:5:\"table\";s:41:\"field_data_field_thin_provisioning_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:36:\"field_thin_provisioning_status_value\";i:1;s:37:\"field_thin_provisioning_status_format\";}s:10:\"field_name\";s:30:\"field_thin_provisioning_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:37:\"field_thin_provisioning_status_format\";s:5:\"table\";s:41:\"field_data_field_thin_provisioning_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:36:\"field_thin_provisioning_status_value\";i:1;s:37:\"field_thin_provisioning_status_format\";}s:10:\"field_name\";s:30:\"field_thin_provisioning_status\";}}}s:45:\"field_revision_field_thin_provisioning_status\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:45:\"field_revision_field_thin_provisioning_status\";i:1;s:42:\"field_thin_provisioning_status-revision_id\";}}}s:42:\"field_thin_provisioning_status-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:24:\"Thin Provisioning Status\";s:11:\"title short\";s:24:\"Thin Provisioning Status\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:45:\"field_revision_field_thin_provisioning_status\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:30:\"field_thin_provisioning_status\";s:10:\"real field\";s:48:\"field_thin_provisioning_status-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:36:\"field_thin_provisioning_status_value\";i:4;s:37:\"field_thin_provisioning_status_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:36:\"field_thin_provisioning_status_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:57:\"Thin Provisioning Status (field_thin_provisioning_status)\";s:11:\"title short\";s:24:\"Thin Provisioning Status\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:36:\"field_thin_provisioning_status_value\";s:5:\"table\";s:45:\"field_revision_field_thin_provisioning_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:36:\"field_thin_provisioning_status_value\";i:1;s:37:\"field_thin_provisioning_status_format\";}s:10:\"field_name\";s:30:\"field_thin_provisioning_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:36:\"field_thin_provisioning_status_value\";s:5:\"table\";s:45:\"field_revision_field_thin_provisioning_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:36:\"field_thin_provisioning_status_value\";i:1;s:37:\"field_thin_provisioning_status_format\";}s:10:\"field_name\";s:30:\"field_thin_provisioning_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:36:\"field_thin_provisioning_status_value\";s:5:\"table\";s:45:\"field_revision_field_thin_provisioning_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:36:\"field_thin_provisioning_status_value\";i:1;s:37:\"field_thin_provisioning_status_format\";}s:10:\"field_name\";s:30:\"field_thin_provisioning_status\";}}s:37:\"field_thin_provisioning_status_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:64:\"Thin Provisioning Status (field_thin_provisioning_status:format)\";s:11:\"title short\";s:31:\"Thin Provisioning Status:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:37:\"field_thin_provisioning_status_format\";s:5:\"table\";s:45:\"field_revision_field_thin_provisioning_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:36:\"field_thin_provisioning_status_value\";i:1;s:37:\"field_thin_provisioning_status_format\";}s:10:\"field_name\";s:30:\"field_thin_provisioning_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:37:\"field_thin_provisioning_status_format\";s:5:\"table\";s:45:\"field_revision_field_thin_provisioning_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:36:\"field_thin_provisioning_status_value\";i:1;s:37:\"field_thin_provisioning_status_format\";}s:10:\"field_name\";s:30:\"field_thin_provisioning_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:37:\"field_thin_provisioning_status_format\";s:5:\"table\";s:45:\"field_revision_field_thin_provisioning_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:36:\"field_thin_provisioning_status_value\";i:1;s:37:\"field_thin_provisioning_status_format\";}s:10:\"field_name\";s:30:\"field_thin_provisioning_status\";}}}s:40:\"field_data_field_is_perennially_reserved\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:40:\"field_data_field_is_perennially_reserved\";i:1;s:29:\"field_is_perennially_reserved\";}}}s:29:\"field_is_perennially_reserved\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:23:\"Is Perennially Reserved\";s:11:\"title short\";s:23:\"Is Perennially Reserved\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:40:\"field_data_field_is_perennially_reserved\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:29:\"field_is_perennially_reserved\";s:10:\"real field\";s:35:\"field_is_perennially_reserved_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:35:\"field_is_perennially_reserved_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:35:\"field_is_perennially_reserved_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:55:\"Is Perennially Reserved (field_is_perennially_reserved)\";s:11:\"title short\";s:23:\"Is Perennially Reserved\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:35:\"field_is_perennially_reserved_value\";s:5:\"table\";s:40:\"field_data_field_is_perennially_reserved\";s:7:\"handler\";s:40:\"views_handler_argument_field_list_string\";s:17:\"additional fields\";a:1:{i:0;s:35:\"field_is_perennially_reserved_value\";}s:10:\"field_name\";s:29:\"field_is_perennially_reserved\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:35:\"field_is_perennially_reserved_value\";s:5:\"table\";s:40:\"field_data_field_is_perennially_reserved\";s:7:\"handler\";s:31:\"views_handler_filter_field_list\";s:17:\"additional fields\";a:1:{i:0;s:35:\"field_is_perennially_reserved_value\";}s:10:\"field_name\";s:29:\"field_is_perennially_reserved\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:35:\"field_is_perennially_reserved_value\";s:5:\"table\";s:40:\"field_data_field_is_perennially_reserved\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:35:\"field_is_perennially_reserved_value\";}s:10:\"field_name\";s:29:\"field_is_perennially_reserved\";}}}s:44:\"field_revision_field_is_perennially_reserved\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:44:\"field_revision_field_is_perennially_reserved\";i:1;s:41:\"field_is_perennially_reserved-revision_id\";}}}s:41:\"field_is_perennially_reserved-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:23:\"Is Perennially Reserved\";s:11:\"title short\";s:23:\"Is Perennially Reserved\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:44:\"field_revision_field_is_perennially_reserved\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:29:\"field_is_perennially_reserved\";s:10:\"real field\";s:47:\"field_is_perennially_reserved-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:35:\"field_is_perennially_reserved_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:35:\"field_is_perennially_reserved_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:55:\"Is Perennially Reserved (field_is_perennially_reserved)\";s:11:\"title short\";s:23:\"Is Perennially Reserved\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:35:\"field_is_perennially_reserved_value\";s:5:\"table\";s:44:\"field_revision_field_is_perennially_reserved\";s:7:\"handler\";s:40:\"views_handler_argument_field_list_string\";s:17:\"additional fields\";a:1:{i:0;s:35:\"field_is_perennially_reserved_value\";}s:10:\"field_name\";s:29:\"field_is_perennially_reserved\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:35:\"field_is_perennially_reserved_value\";s:5:\"table\";s:44:\"field_revision_field_is_perennially_reserved\";s:7:\"handler\";s:31:\"views_handler_filter_field_list\";s:17:\"additional fields\";a:1:{i:0;s:35:\"field_is_perennially_reserved_value\";}s:10:\"field_name\";s:29:\"field_is_perennially_reserved\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:35:\"field_is_perennially_reserved_value\";s:5:\"table\";s:44:\"field_revision_field_is_perennially_reserved\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:35:\"field_is_perennially_reserved_value\";}s:10:\"field_name\";s:29:\"field_is_perennially_reserved\";}}}s:27:\"field_data_field_is_offline\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:27:\"field_data_field_is_offline\";i:1;s:16:\"field_is_offline\";}}}s:16:\"field_is_offline\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"Is Offline\";s:11:\"title short\";s:10:\"Is Offline\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:27:\"field_data_field_is_offline\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_is_offline\";s:10:\"real field\";s:22:\"field_is_offline_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_is_offline_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:22:\"field_is_offline_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:29:\"Is Offline (field_is_offline)\";s:11:\"title short\";s:10:\"Is Offline\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_is_offline_value\";s:5:\"table\";s:27:\"field_data_field_is_offline\";s:7:\"handler\";s:40:\"views_handler_argument_field_list_string\";s:17:\"additional fields\";a:1:{i:0;s:22:\"field_is_offline_value\";}s:10:\"field_name\";s:16:\"field_is_offline\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_is_offline_value\";s:5:\"table\";s:27:\"field_data_field_is_offline\";s:7:\"handler\";s:31:\"views_handler_filter_field_list\";s:17:\"additional fields\";a:1:{i:0;s:22:\"field_is_offline_value\";}s:10:\"field_name\";s:16:\"field_is_offline\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_is_offline_value\";s:5:\"table\";s:27:\"field_data_field_is_offline\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:22:\"field_is_offline_value\";}s:10:\"field_name\";s:16:\"field_is_offline\";}}}s:31:\"field_revision_field_is_offline\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:31:\"field_revision_field_is_offline\";i:1;s:28:\"field_is_offline-revision_id\";}}}s:28:\"field_is_offline-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:10:\"Is Offline\";s:11:\"title short\";s:10:\"Is Offline\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:31:\"field_revision_field_is_offline\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_is_offline\";s:10:\"real field\";s:34:\"field_is_offline-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_is_offline_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:22:\"field_is_offline_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:29:\"Is Offline (field_is_offline)\";s:11:\"title short\";s:10:\"Is Offline\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_is_offline_value\";s:5:\"table\";s:31:\"field_revision_field_is_offline\";s:7:\"handler\";s:40:\"views_handler_argument_field_list_string\";s:17:\"additional fields\";a:1:{i:0;s:22:\"field_is_offline_value\";}s:10:\"field_name\";s:16:\"field_is_offline\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_is_offline_value\";s:5:\"table\";s:31:\"field_revision_field_is_offline\";s:7:\"handler\";s:31:\"views_handler_filter_field_list\";s:17:\"additional fields\";a:1:{i:0;s:22:\"field_is_offline_value\";}s:10:\"field_name\";s:16:\"field_is_offline\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_is_offline_value\";s:5:\"table\";s:31:\"field_revision_field_is_offline\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:22:\"field_is_offline_value\";}s:10:\"field_name\";s:16:\"field_is_offline\";}}}s:23:\"field_data_field_is_ssd\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:23:\"field_data_field_is_ssd\";i:1;s:12:\"field_is_ssd\";}}}s:12:\"field_is_ssd\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:6:\"Is SSD\";s:11:\"title short\";s:6:\"Is SSD\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:23:\"field_data_field_is_ssd\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:12:\"field_is_ssd\";s:10:\"real field\";s:18:\"field_is_ssd_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:18:\"field_is_ssd_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:18:\"field_is_ssd_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:21:\"Is SSD (field_is_ssd)\";s:11:\"title short\";s:6:\"Is SSD\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:18:\"field_is_ssd_value\";s:5:\"table\";s:23:\"field_data_field_is_ssd\";s:7:\"handler\";s:40:\"views_handler_argument_field_list_string\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_is_ssd_value\";}s:10:\"field_name\";s:12:\"field_is_ssd\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:18:\"field_is_ssd_value\";s:5:\"table\";s:23:\"field_data_field_is_ssd\";s:7:\"handler\";s:31:\"views_handler_filter_field_list\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_is_ssd_value\";}s:10:\"field_name\";s:12:\"field_is_ssd\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:18:\"field_is_ssd_value\";s:5:\"table\";s:23:\"field_data_field_is_ssd\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_is_ssd_value\";}s:10:\"field_name\";s:12:\"field_is_ssd\";}}}s:27:\"field_revision_field_is_ssd\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:27:\"field_revision_field_is_ssd\";i:1;s:24:\"field_is_ssd-revision_id\";}}}s:24:\"field_is_ssd-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:6:\"Is SSD\";s:11:\"title short\";s:6:\"Is SSD\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:27:\"field_revision_field_is_ssd\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:12:\"field_is_ssd\";s:10:\"real field\";s:30:\"field_is_ssd-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:18:\"field_is_ssd_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:18:\"field_is_ssd_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:21:\"Is SSD (field_is_ssd)\";s:11:\"title short\";s:6:\"Is SSD\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:18:\"field_is_ssd_value\";s:5:\"table\";s:27:\"field_revision_field_is_ssd\";s:7:\"handler\";s:40:\"views_handler_argument_field_list_string\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_is_ssd_value\";}s:10:\"field_name\";s:12:\"field_is_ssd\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:18:\"field_is_ssd_value\";s:5:\"table\";s:27:\"field_revision_field_is_ssd\";s:7:\"handler\";s:31:\"views_handler_filter_field_list\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_is_ssd_value\";}s:10:\"field_name\";s:12:\"field_is_ssd\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:18:\"field_is_ssd_value\";s:5:\"table\";s:27:\"field_revision_field_is_ssd\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_is_ssd_value\";}s:10:\"field_name\";s:12:\"field_is_ssd\";}}}s:29:\"field_data_field_is_removable\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:29:\"field_data_field_is_removable\";i:1;s:18:\"field_is_removable\";}}}s:18:\"field_is_removable\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:12:\"Is Removable\";s:11:\"title short\";s:12:\"Is Removable\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:29:\"field_data_field_is_removable\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:18:\"field_is_removable\";s:10:\"real field\";s:24:\"field_is_removable_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:24:\"field_is_removable_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:24:\"field_is_removable_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:33:\"Is Removable (field_is_removable)\";s:11:\"title short\";s:12:\"Is Removable\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_is_removable_value\";s:5:\"table\";s:29:\"field_data_field_is_removable\";s:7:\"handler\";s:40:\"views_handler_argument_field_list_string\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_is_removable_value\";}s:10:\"field_name\";s:18:\"field_is_removable\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_is_removable_value\";s:5:\"table\";s:29:\"field_data_field_is_removable\";s:7:\"handler\";s:31:\"views_handler_filter_field_list\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_is_removable_value\";}s:10:\"field_name\";s:18:\"field_is_removable\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_is_removable_value\";s:5:\"table\";s:29:\"field_data_field_is_removable\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_is_removable_value\";}s:10:\"field_name\";s:18:\"field_is_removable\";}}}s:33:\"field_revision_field_is_removable\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:33:\"field_revision_field_is_removable\";i:1;s:30:\"field_is_removable-revision_id\";}}}s:30:\"field_is_removable-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:12:\"Is Removable\";s:11:\"title short\";s:12:\"Is Removable\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:33:\"field_revision_field_is_removable\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:18:\"field_is_removable\";s:10:\"real field\";s:36:\"field_is_removable-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:24:\"field_is_removable_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:24:\"field_is_removable_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:33:\"Is Removable (field_is_removable)\";s:11:\"title short\";s:12:\"Is Removable\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_is_removable_value\";s:5:\"table\";s:33:\"field_revision_field_is_removable\";s:7:\"handler\";s:40:\"views_handler_argument_field_list_string\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_is_removable_value\";}s:10:\"field_name\";s:18:\"field_is_removable\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_is_removable_value\";s:5:\"table\";s:33:\"field_revision_field_is_removable\";s:7:\"handler\";s:31:\"views_handler_filter_field_list\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_is_removable_value\";}s:10:\"field_name\";s:18:\"field_is_removable\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_is_removable_value\";s:5:\"table\";s:33:\"field_revision_field_is_removable\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_is_removable_value\";}s:10:\"field_name\";s:18:\"field_is_removable\";}}}s:25:\"field_data_field_is_local\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:25:\"field_data_field_is_local\";i:1;s:14:\"field_is_local\";}}}s:14:\"field_is_local\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:8:\"Is Local\";s:11:\"title short\";s:8:\"Is Local\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:25:\"field_data_field_is_local\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_is_local\";s:10:\"real field\";s:20:\"field_is_local_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_is_local_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:20:\"field_is_local_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:25:\"Is Local (field_is_local)\";s:11:\"title short\";s:8:\"Is Local\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_is_local_value\";s:5:\"table\";s:25:\"field_data_field_is_local\";s:7:\"handler\";s:40:\"views_handler_argument_field_list_string\";s:17:\"additional fields\";a:1:{i:0;s:20:\"field_is_local_value\";}s:10:\"field_name\";s:14:\"field_is_local\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_is_local_value\";s:5:\"table\";s:25:\"field_data_field_is_local\";s:7:\"handler\";s:31:\"views_handler_filter_field_list\";s:17:\"additional fields\";a:1:{i:0;s:20:\"field_is_local_value\";}s:10:\"field_name\";s:14:\"field_is_local\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_is_local_value\";s:5:\"table\";s:25:\"field_data_field_is_local\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:20:\"field_is_local_value\";}s:10:\"field_name\";s:14:\"field_is_local\";}}}s:29:\"field_revision_field_is_local\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:29:\"field_revision_field_is_local\";i:1;s:26:\"field_is_local-revision_id\";}}}s:26:\"field_is_local-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:8:\"Is Local\";s:11:\"title short\";s:8:\"Is Local\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:29:\"field_revision_field_is_local\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_is_local\";s:10:\"real field\";s:32:\"field_is_local-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_is_local_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:20:\"field_is_local_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:25:\"Is Local (field_is_local)\";s:11:\"title short\";s:8:\"Is Local\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_is_local_value\";s:5:\"table\";s:29:\"field_revision_field_is_local\";s:7:\"handler\";s:40:\"views_handler_argument_field_list_string\";s:17:\"additional fields\";a:1:{i:0;s:20:\"field_is_local_value\";}s:10:\"field_name\";s:14:\"field_is_local\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_is_local_value\";s:5:\"table\";s:29:\"field_revision_field_is_local\";s:7:\"handler\";s:31:\"views_handler_filter_field_list\";s:17:\"additional fields\";a:1:{i:0;s:20:\"field_is_local_value\";}s:10:\"field_name\";s:14:\"field_is_local\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_is_local_value\";s:5:\"table\";s:29:\"field_revision_field_is_local\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:20:\"field_is_local_value\";}s:10:\"field_name\";s:14:\"field_is_local\";}}}s:31:\"field_data_field_is_rdm_capable\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:31:\"field_data_field_is_rdm_capable\";i:1;s:20:\"field_is_rdm_capable\";}}}s:20:\"field_is_rdm_capable\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:14:\"Is RDM Capable\";s:11:\"title short\";s:14:\"Is RDM Capable\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:31:\"field_data_field_is_rdm_capable\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:20:\"field_is_rdm_capable\";s:10:\"real field\";s:26:\"field_is_rdm_capable_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:26:\"field_is_rdm_capable_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:26:\"field_is_rdm_capable_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:37:\"Is RDM Capable (field_is_rdm_capable)\";s:11:\"title short\";s:14:\"Is RDM Capable\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_is_rdm_capable_value\";s:5:\"table\";s:31:\"field_data_field_is_rdm_capable\";s:7:\"handler\";s:40:\"views_handler_argument_field_list_string\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_is_rdm_capable_value\";}s:10:\"field_name\";s:20:\"field_is_rdm_capable\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_is_rdm_capable_value\";s:5:\"table\";s:31:\"field_data_field_is_rdm_capable\";s:7:\"handler\";s:31:\"views_handler_filter_field_list\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_is_rdm_capable_value\";}s:10:\"field_name\";s:20:\"field_is_rdm_capable\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_is_rdm_capable_value\";s:5:\"table\";s:31:\"field_data_field_is_rdm_capable\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_is_rdm_capable_value\";}s:10:\"field_name\";s:20:\"field_is_rdm_capable\";}}}s:35:\"field_revision_field_is_rdm_capable\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:35:\"field_revision_field_is_rdm_capable\";i:1;s:32:\"field_is_rdm_capable-revision_id\";}}}s:32:\"field_is_rdm_capable-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:14:\"Is RDM Capable\";s:11:\"title short\";s:14:\"Is RDM Capable\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:35:\"field_revision_field_is_rdm_capable\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:20:\"field_is_rdm_capable\";s:10:\"real field\";s:38:\"field_is_rdm_capable-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:26:\"field_is_rdm_capable_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:26:\"field_is_rdm_capable_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:37:\"Is RDM Capable (field_is_rdm_capable)\";s:11:\"title short\";s:14:\"Is RDM Capable\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_is_rdm_capable_value\";s:5:\"table\";s:35:\"field_revision_field_is_rdm_capable\";s:7:\"handler\";s:40:\"views_handler_argument_field_list_string\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_is_rdm_capable_value\";}s:10:\"field_name\";s:20:\"field_is_rdm_capable\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_is_rdm_capable_value\";s:5:\"table\";s:35:\"field_revision_field_is_rdm_capable\";s:7:\"handler\";s:31:\"views_handler_filter_field_list\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_is_rdm_capable_value\";}s:10:\"field_name\";s:20:\"field_is_rdm_capable\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_is_rdm_capable_value\";s:5:\"table\";s:35:\"field_revision_field_is_rdm_capable\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:26:\"field_is_rdm_capable_value\";}s:10:\"field_name\";s:20:\"field_is_rdm_capable\";}}}s:23:\"field_data_field_status\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:23:\"field_data_field_status\";i:1;s:12:\"field_status\";}}}s:12:\"field_status\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:6:\"Status\";s:11:\"title short\";s:6:\"Status\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:23:\"field_data_field_status\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:12:\"field_status\";s:10:\"real field\";s:18:\"field_status_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:18:\"field_status_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:18:\"field_status_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:21:\"Status (field_status)\";s:11:\"title short\";s:6:\"Status\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:18:\"field_status_value\";s:5:\"table\";s:23:\"field_data_field_status\";s:7:\"handler\";s:40:\"views_handler_argument_field_list_string\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_status_value\";}s:10:\"field_name\";s:12:\"field_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:18:\"field_status_value\";s:5:\"table\";s:23:\"field_data_field_status\";s:7:\"handler\";s:31:\"views_handler_filter_field_list\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_status_value\";}s:10:\"field_name\";s:12:\"field_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:18:\"field_status_value\";s:5:\"table\";s:23:\"field_data_field_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_status_value\";}s:10:\"field_name\";s:12:\"field_status\";}}}s:27:\"field_revision_field_status\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:27:\"field_revision_field_status\";i:1;s:24:\"field_status-revision_id\";}}}s:24:\"field_status-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:6:\"Status\";s:11:\"title short\";s:6:\"Status\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:27:\"field_revision_field_status\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:12:\"field_status\";s:10:\"real field\";s:30:\"field_status-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:18:\"field_status_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:18:\"field_status_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:21:\"Status (field_status)\";s:11:\"title short\";s:6:\"Status\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:18:\"field_status_value\";s:5:\"table\";s:27:\"field_revision_field_status\";s:7:\"handler\";s:40:\"views_handler_argument_field_list_string\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_status_value\";}s:10:\"field_name\";s:12:\"field_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:18:\"field_status_value\";s:5:\"table\";s:27:\"field_revision_field_status\";s:7:\"handler\";s:31:\"views_handler_filter_field_list\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_status_value\";}s:10:\"field_name\";s:12:\"field_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:18:\"field_status_value\";s:5:\"table\";s:27:\"field_revision_field_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_status_value\";}s:10:\"field_name\";s:12:\"field_status\";}}}s:26:\"field_data_field_is_pseudo\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:26:\"field_data_field_is_pseudo\";i:1;s:15:\"field_is_pseudo\";}}}s:15:\"field_is_pseudo\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:9:\"Is Pseudo\";s:11:\"title short\";s:9:\"Is Pseudo\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:26:\"field_data_field_is_pseudo\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:15:\"field_is_pseudo\";s:10:\"real field\";s:21:\"field_is_pseudo_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:21:\"field_is_pseudo_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:21:\"field_is_pseudo_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:27:\"Is Pseudo (field_is_pseudo)\";s:11:\"title short\";s:9:\"Is Pseudo\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_is_pseudo_value\";s:5:\"table\";s:26:\"field_data_field_is_pseudo\";s:7:\"handler\";s:40:\"views_handler_argument_field_list_string\";s:17:\"additional fields\";a:1:{i:0;s:21:\"field_is_pseudo_value\";}s:10:\"field_name\";s:15:\"field_is_pseudo\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_is_pseudo_value\";s:5:\"table\";s:26:\"field_data_field_is_pseudo\";s:7:\"handler\";s:31:\"views_handler_filter_field_list\";s:17:\"additional fields\";a:1:{i:0;s:21:\"field_is_pseudo_value\";}s:10:\"field_name\";s:15:\"field_is_pseudo\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_is_pseudo_value\";s:5:\"table\";s:26:\"field_data_field_is_pseudo\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:21:\"field_is_pseudo_value\";}s:10:\"field_name\";s:15:\"field_is_pseudo\";}}}s:30:\"field_revision_field_is_pseudo\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:30:\"field_revision_field_is_pseudo\";i:1;s:27:\"field_is_pseudo-revision_id\";}}}s:27:\"field_is_pseudo-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:9:\"Is Pseudo\";s:11:\"title short\";s:9:\"Is Pseudo\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:30:\"field_revision_field_is_pseudo\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:15:\"field_is_pseudo\";s:10:\"real field\";s:33:\"field_is_pseudo-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:21:\"field_is_pseudo_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:21:\"field_is_pseudo_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:27:\"Is Pseudo (field_is_pseudo)\";s:11:\"title short\";s:9:\"Is Pseudo\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_is_pseudo_value\";s:5:\"table\";s:30:\"field_revision_field_is_pseudo\";s:7:\"handler\";s:40:\"views_handler_argument_field_list_string\";s:17:\"additional fields\";a:1:{i:0;s:21:\"field_is_pseudo_value\";}s:10:\"field_name\";s:15:\"field_is_pseudo\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_is_pseudo_value\";s:5:\"table\";s:30:\"field_revision_field_is_pseudo\";s:7:\"handler\";s:31:\"views_handler_filter_field_list\";s:17:\"additional fields\";a:1:{i:0;s:21:\"field_is_pseudo_value\";}s:10:\"field_name\";s:15:\"field_is_pseudo\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_is_pseudo_value\";s:5:\"table\";s:30:\"field_revision_field_is_pseudo\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:21:\"field_is_pseudo_value\";}s:10:\"field_name\";s:15:\"field_is_pseudo\";}}}s:27:\"field_data_field_scsi_level\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:27:\"field_data_field_scsi_level\";i:1;s:16:\"field_scsi_level\";}}}s:16:\"field_scsi_level\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"SCSI Level\";s:11:\"title short\";s:10:\"SCSI Level\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:27:\"field_data_field_scsi_level\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_scsi_level\";s:10:\"real field\";s:22:\"field_scsi_level_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_scsi_level_value\";i:4;s:23:\"field_scsi_level_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:22:\"field_scsi_level_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:29:\"SCSI Level (field_scsi_level)\";s:11:\"title short\";s:10:\"SCSI Level\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_scsi_level_value\";s:5:\"table\";s:27:\"field_data_field_scsi_level\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_scsi_level_value\";i:1;s:23:\"field_scsi_level_format\";}s:10:\"field_name\";s:16:\"field_scsi_level\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_scsi_level_value\";s:5:\"table\";s:27:\"field_data_field_scsi_level\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_scsi_level_value\";i:1;s:23:\"field_scsi_level_format\";}s:10:\"field_name\";s:16:\"field_scsi_level\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_scsi_level_value\";s:5:\"table\";s:27:\"field_data_field_scsi_level\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_scsi_level_value\";i:1;s:23:\"field_scsi_level_format\";}s:10:\"field_name\";s:16:\"field_scsi_level\";}}s:23:\"field_scsi_level_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:36:\"SCSI Level (field_scsi_level:format)\";s:11:\"title short\";s:17:\"SCSI Level:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_scsi_level_format\";s:5:\"table\";s:27:\"field_data_field_scsi_level\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_scsi_level_value\";i:1;s:23:\"field_scsi_level_format\";}s:10:\"field_name\";s:16:\"field_scsi_level\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_scsi_level_format\";s:5:\"table\";s:27:\"field_data_field_scsi_level\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_scsi_level_value\";i:1;s:23:\"field_scsi_level_format\";}s:10:\"field_name\";s:16:\"field_scsi_level\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_scsi_level_format\";s:5:\"table\";s:27:\"field_data_field_scsi_level\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_scsi_level_value\";i:1;s:23:\"field_scsi_level_format\";}s:10:\"field_name\";s:16:\"field_scsi_level\";}}}s:31:\"field_revision_field_scsi_level\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:31:\"field_revision_field_scsi_level\";i:1;s:28:\"field_scsi_level-revision_id\";}}}s:28:\"field_scsi_level-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:10:\"SCSI Level\";s:11:\"title short\";s:10:\"SCSI Level\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:31:\"field_revision_field_scsi_level\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_scsi_level\";s:10:\"real field\";s:34:\"field_scsi_level-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_scsi_level_value\";i:4;s:23:\"field_scsi_level_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:22:\"field_scsi_level_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:29:\"SCSI Level (field_scsi_level)\";s:11:\"title short\";s:10:\"SCSI Level\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_scsi_level_value\";s:5:\"table\";s:31:\"field_revision_field_scsi_level\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_scsi_level_value\";i:1;s:23:\"field_scsi_level_format\";}s:10:\"field_name\";s:16:\"field_scsi_level\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_scsi_level_value\";s:5:\"table\";s:31:\"field_revision_field_scsi_level\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_scsi_level_value\";i:1;s:23:\"field_scsi_level_format\";}s:10:\"field_name\";s:16:\"field_scsi_level\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_scsi_level_value\";s:5:\"table\";s:31:\"field_revision_field_scsi_level\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_scsi_level_value\";i:1;s:23:\"field_scsi_level_format\";}s:10:\"field_name\";s:16:\"field_scsi_level\";}}s:23:\"field_scsi_level_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:36:\"SCSI Level (field_scsi_level:format)\";s:11:\"title short\";s:17:\"SCSI Level:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_scsi_level_format\";s:5:\"table\";s:31:\"field_revision_field_scsi_level\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_scsi_level_value\";i:1;s:23:\"field_scsi_level_format\";}s:10:\"field_name\";s:16:\"field_scsi_level\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_scsi_level_format\";s:5:\"table\";s:31:\"field_revision_field_scsi_level\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_scsi_level_value\";i:1;s:23:\"field_scsi_level_format\";}s:10:\"field_name\";s:16:\"field_scsi_level\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_scsi_level_format\";s:5:\"table\";s:31:\"field_revision_field_scsi_level\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_scsi_level_value\";i:1;s:23:\"field_scsi_level_format\";}s:10:\"field_name\";s:16:\"field_scsi_level\";}}}s:25:\"field_data_field_revision\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:25:\"field_data_field_revision\";i:1;s:14:\"field_revision\";}}}s:14:\"field_revision\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:8:\"Revision\";s:11:\"title short\";s:8:\"Revision\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:25:\"field_data_field_revision\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_revision\";s:10:\"real field\";s:20:\"field_revision_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_revision_value\";i:4;s:21:\"field_revision_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:20:\"field_revision_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:25:\"Revision (field_revision)\";s:11:\"title short\";s:8:\"Revision\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_revision_value\";s:5:\"table\";s:25:\"field_data_field_revision\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_revision_value\";i:1;s:21:\"field_revision_format\";}s:10:\"field_name\";s:14:\"field_revision\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_revision_value\";s:5:\"table\";s:25:\"field_data_field_revision\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_revision_value\";i:1;s:21:\"field_revision_format\";}s:10:\"field_name\";s:14:\"field_revision\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_revision_value\";s:5:\"table\";s:25:\"field_data_field_revision\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_revision_value\";i:1;s:21:\"field_revision_format\";}s:10:\"field_name\";s:14:\"field_revision\";}}s:21:\"field_revision_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:32:\"Revision (field_revision:format)\";s:11:\"title short\";s:15:\"Revision:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_revision_format\";s:5:\"table\";s:25:\"field_data_field_revision\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_revision_value\";i:1;s:21:\"field_revision_format\";}s:10:\"field_name\";s:14:\"field_revision\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_revision_format\";s:5:\"table\";s:25:\"field_data_field_revision\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_revision_value\";i:1;s:21:\"field_revision_format\";}s:10:\"field_name\";s:14:\"field_revision\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_revision_format\";s:5:\"table\";s:25:\"field_data_field_revision\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_revision_value\";i:1;s:21:\"field_revision_format\";}s:10:\"field_name\";s:14:\"field_revision\";}}}s:29:\"field_revision_field_revision\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:29:\"field_revision_field_revision\";i:1;s:26:\"field_revision-revision_id\";}}}s:26:\"field_revision-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:8:\"Revision\";s:11:\"title short\";s:8:\"Revision\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:29:\"field_revision_field_revision\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_revision\";s:10:\"real field\";s:32:\"field_revision-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_revision_value\";i:4;s:21:\"field_revision_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:20:\"field_revision_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:25:\"Revision (field_revision)\";s:11:\"title short\";s:8:\"Revision\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_revision_value\";s:5:\"table\";s:29:\"field_revision_field_revision\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_revision_value\";i:1;s:21:\"field_revision_format\";}s:10:\"field_name\";s:14:\"field_revision\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_revision_value\";s:5:\"table\";s:29:\"field_revision_field_revision\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_revision_value\";i:1;s:21:\"field_revision_format\";}s:10:\"field_name\";s:14:\"field_revision\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_revision_value\";s:5:\"table\";s:29:\"field_revision_field_revision\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_revision_value\";i:1;s:21:\"field_revision_format\";}s:10:\"field_name\";s:14:\"field_revision\";}}s:21:\"field_revision_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:32:\"Revision (field_revision:format)\";s:11:\"title short\";s:15:\"Revision:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_revision_format\";s:5:\"table\";s:29:\"field_revision_field_revision\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_revision_value\";i:1;s:21:\"field_revision_format\";}s:10:\"field_name\";s:14:\"field_revision\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_revision_format\";s:5:\"table\";s:29:\"field_revision_field_revision\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_revision_value\";i:1;s:21:\"field_revision_format\";}s:10:\"field_name\";s:14:\"field_revision\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_revision_format\";s:5:\"table\";s:29:\"field_revision_field_revision\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_revision_value\";i:1;s:21:\"field_revision_format\";}s:10:\"field_name\";s:14:\"field_revision\";}}}s:22:\"field_data_field_model\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:22:\"field_data_field_model\";i:1;s:11:\"field_model\";}}}s:11:\"field_model\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:5:\"Model\";s:11:\"title short\";s:5:\"Model\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:22:\"field_data_field_model\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:11:\"field_model\";s:10:\"real field\";s:17:\"field_model_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:17:\"field_model_value\";i:4;s:18:\"field_model_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:17:\"field_model_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:19:\"Model (field_model)\";s:11:\"title short\";s:5:\"Model\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:17:\"field_model_value\";s:5:\"table\";s:22:\"field_data_field_model\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_model_value\";i:1;s:18:\"field_model_format\";}s:10:\"field_name\";s:11:\"field_model\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:17:\"field_model_value\";s:5:\"table\";s:22:\"field_data_field_model\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_model_value\";i:1;s:18:\"field_model_format\";}s:10:\"field_name\";s:11:\"field_model\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:17:\"field_model_value\";s:5:\"table\";s:22:\"field_data_field_model\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_model_value\";i:1;s:18:\"field_model_format\";}s:10:\"field_name\";s:11:\"field_model\";}}s:18:\"field_model_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:26:\"Model (field_model:format)\";s:11:\"title short\";s:12:\"Model:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:18:\"field_model_format\";s:5:\"table\";s:22:\"field_data_field_model\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_model_value\";i:1;s:18:\"field_model_format\";}s:10:\"field_name\";s:11:\"field_model\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:18:\"field_model_format\";s:5:\"table\";s:22:\"field_data_field_model\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_model_value\";i:1;s:18:\"field_model_format\";}s:10:\"field_name\";s:11:\"field_model\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:18:\"field_model_format\";s:5:\"table\";s:22:\"field_data_field_model\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_model_value\";i:1;s:18:\"field_model_format\";}s:10:\"field_name\";s:11:\"field_model\";}}}s:26:\"field_revision_field_model\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:26:\"field_revision_field_model\";i:1;s:23:\"field_model-revision_id\";}}}s:23:\"field_model-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:5:\"Model\";s:11:\"title short\";s:5:\"Model\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:26:\"field_revision_field_model\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:11:\"field_model\";s:10:\"real field\";s:29:\"field_model-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:17:\"field_model_value\";i:4;s:18:\"field_model_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:17:\"field_model_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:19:\"Model (field_model)\";s:11:\"title short\";s:5:\"Model\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:17:\"field_model_value\";s:5:\"table\";s:26:\"field_revision_field_model\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_model_value\";i:1;s:18:\"field_model_format\";}s:10:\"field_name\";s:11:\"field_model\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:17:\"field_model_value\";s:5:\"table\";s:26:\"field_revision_field_model\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_model_value\";i:1;s:18:\"field_model_format\";}s:10:\"field_name\";s:11:\"field_model\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:17:\"field_model_value\";s:5:\"table\";s:26:\"field_revision_field_model\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_model_value\";i:1;s:18:\"field_model_format\";}s:10:\"field_name\";s:11:\"field_model\";}}s:18:\"field_model_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:26:\"Model (field_model:format)\";s:11:\"title short\";s:12:\"Model:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:18:\"field_model_format\";s:5:\"table\";s:26:\"field_revision_field_model\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_model_value\";i:1;s:18:\"field_model_format\";}s:10:\"field_name\";s:11:\"field_model\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:18:\"field_model_format\";s:5:\"table\";s:26:\"field_revision_field_model\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_model_value\";i:1;s:18:\"field_model_format\";}s:10:\"field_name\";s:11:\"field_model\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:18:\"field_model_format\";s:5:\"table\";s:26:\"field_revision_field_model\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_model_value\";i:1;s:18:\"field_model_format\";}s:10:\"field_name\";s:11:\"field_model\";}}}s:23:\"field_data_field_vendor\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:23:\"field_data_field_vendor\";i:1;s:12:\"field_vendor\";}}}s:12:\"field_vendor\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:6:\"Vendor\";s:11:\"title short\";s:6:\"Vendor\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:23:\"field_data_field_vendor\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:12:\"field_vendor\";s:10:\"real field\";s:18:\"field_vendor_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:18:\"field_vendor_value\";i:4;s:19:\"field_vendor_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:18:\"field_vendor_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:21:\"Vendor (field_vendor)\";s:11:\"title short\";s:6:\"Vendor\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:18:\"field_vendor_value\";s:5:\"table\";s:23:\"field_data_field_vendor\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:18:\"field_vendor_value\";i:1;s:19:\"field_vendor_format\";}s:10:\"field_name\";s:12:\"field_vendor\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:18:\"field_vendor_value\";s:5:\"table\";s:23:\"field_data_field_vendor\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:18:\"field_vendor_value\";i:1;s:19:\"field_vendor_format\";}s:10:\"field_name\";s:12:\"field_vendor\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:18:\"field_vendor_value\";s:5:\"table\";s:23:\"field_data_field_vendor\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:18:\"field_vendor_value\";i:1;s:19:\"field_vendor_format\";}s:10:\"field_name\";s:12:\"field_vendor\";}}s:19:\"field_vendor_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:28:\"Vendor (field_vendor:format)\";s:11:\"title short\";s:13:\"Vendor:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:19:\"field_vendor_format\";s:5:\"table\";s:23:\"field_data_field_vendor\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:18:\"field_vendor_value\";i:1;s:19:\"field_vendor_format\";}s:10:\"field_name\";s:12:\"field_vendor\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:19:\"field_vendor_format\";s:5:\"table\";s:23:\"field_data_field_vendor\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:18:\"field_vendor_value\";i:1;s:19:\"field_vendor_format\";}s:10:\"field_name\";s:12:\"field_vendor\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:19:\"field_vendor_format\";s:5:\"table\";s:23:\"field_data_field_vendor\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:18:\"field_vendor_value\";i:1;s:19:\"field_vendor_format\";}s:10:\"field_name\";s:12:\"field_vendor\";}}}s:27:\"field_revision_field_vendor\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:27:\"field_revision_field_vendor\";i:1;s:24:\"field_vendor-revision_id\";}}}s:24:\"field_vendor-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:6:\"Vendor\";s:11:\"title short\";s:6:\"Vendor\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:27:\"field_revision_field_vendor\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:12:\"field_vendor\";s:10:\"real field\";s:30:\"field_vendor-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:18:\"field_vendor_value\";i:4;s:19:\"field_vendor_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:18:\"field_vendor_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:21:\"Vendor (field_vendor)\";s:11:\"title short\";s:6:\"Vendor\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:18:\"field_vendor_value\";s:5:\"table\";s:27:\"field_revision_field_vendor\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:18:\"field_vendor_value\";i:1;s:19:\"field_vendor_format\";}s:10:\"field_name\";s:12:\"field_vendor\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:18:\"field_vendor_value\";s:5:\"table\";s:27:\"field_revision_field_vendor\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:18:\"field_vendor_value\";i:1;s:19:\"field_vendor_format\";}s:10:\"field_name\";s:12:\"field_vendor\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:18:\"field_vendor_value\";s:5:\"table\";s:27:\"field_revision_field_vendor\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:18:\"field_vendor_value\";i:1;s:19:\"field_vendor_format\";}s:10:\"field_name\";s:12:\"field_vendor\";}}s:19:\"field_vendor_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:28:\"Vendor (field_vendor:format)\";s:11:\"title short\";s:13:\"Vendor:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:19:\"field_vendor_format\";s:5:\"table\";s:27:\"field_revision_field_vendor\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:18:\"field_vendor_value\";i:1;s:19:\"field_vendor_format\";}s:10:\"field_name\";s:12:\"field_vendor\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:19:\"field_vendor_format\";s:5:\"table\";s:27:\"field_revision_field_vendor\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:18:\"field_vendor_value\";i:1;s:19:\"field_vendor_format\";}s:10:\"field_name\";s:12:\"field_vendor\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:19:\"field_vendor_format\";s:5:\"table\";s:27:\"field_revision_field_vendor\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:18:\"field_vendor_value\";i:1;s:19:\"field_vendor_format\";}s:10:\"field_name\";s:12:\"field_vendor\";}}}s:27:\"field_data_field_devfs_path\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:27:\"field_data_field_devfs_path\";i:1;s:16:\"field_devfs_path\";}}}s:16:\"field_devfs_path\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"Devfs Path\";s:11:\"title short\";s:10:\"Devfs Path\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:27:\"field_data_field_devfs_path\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_devfs_path\";s:10:\"real field\";s:22:\"field_devfs_path_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_devfs_path_value\";i:4;s:23:\"field_devfs_path_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:22:\"field_devfs_path_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:29:\"Devfs Path (field_devfs_path)\";s:11:\"title short\";s:10:\"Devfs Path\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_devfs_path_value\";s:5:\"table\";s:27:\"field_data_field_devfs_path\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_devfs_path_value\";i:1;s:23:\"field_devfs_path_format\";}s:10:\"field_name\";s:16:\"field_devfs_path\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_devfs_path_value\";s:5:\"table\";s:27:\"field_data_field_devfs_path\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_devfs_path_value\";i:1;s:23:\"field_devfs_path_format\";}s:10:\"field_name\";s:16:\"field_devfs_path\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_devfs_path_value\";s:5:\"table\";s:27:\"field_data_field_devfs_path\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_devfs_path_value\";i:1;s:23:\"field_devfs_path_format\";}s:10:\"field_name\";s:16:\"field_devfs_path\";}}s:23:\"field_devfs_path_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:36:\"Devfs Path (field_devfs_path:format)\";s:11:\"title short\";s:17:\"Devfs Path:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_devfs_path_format\";s:5:\"table\";s:27:\"field_data_field_devfs_path\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_devfs_path_value\";i:1;s:23:\"field_devfs_path_format\";}s:10:\"field_name\";s:16:\"field_devfs_path\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_devfs_path_format\";s:5:\"table\";s:27:\"field_data_field_devfs_path\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_devfs_path_value\";i:1;s:23:\"field_devfs_path_format\";}s:10:\"field_name\";s:16:\"field_devfs_path\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_devfs_path_format\";s:5:\"table\";s:27:\"field_data_field_devfs_path\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_devfs_path_value\";i:1;s:23:\"field_devfs_path_format\";}s:10:\"field_name\";s:16:\"field_devfs_path\";}}}s:31:\"field_revision_field_devfs_path\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:31:\"field_revision_field_devfs_path\";i:1;s:28:\"field_devfs_path-revision_id\";}}}s:28:\"field_devfs_path-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:10:\"Devfs Path\";s:11:\"title short\";s:10:\"Devfs Path\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:31:\"field_revision_field_devfs_path\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_devfs_path\";s:10:\"real field\";s:34:\"field_devfs_path-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_devfs_path_value\";i:4;s:23:\"field_devfs_path_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:22:\"field_devfs_path_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:29:\"Devfs Path (field_devfs_path)\";s:11:\"title short\";s:10:\"Devfs Path\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_devfs_path_value\";s:5:\"table\";s:31:\"field_revision_field_devfs_path\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_devfs_path_value\";i:1;s:23:\"field_devfs_path_format\";}s:10:\"field_name\";s:16:\"field_devfs_path\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_devfs_path_value\";s:5:\"table\";s:31:\"field_revision_field_devfs_path\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_devfs_path_value\";i:1;s:23:\"field_devfs_path_format\";}s:10:\"field_name\";s:16:\"field_devfs_path\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_devfs_path_value\";s:5:\"table\";s:31:\"field_revision_field_devfs_path\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_devfs_path_value\";i:1;s:23:\"field_devfs_path_format\";}s:10:\"field_name\";s:16:\"field_devfs_path\";}}s:23:\"field_devfs_path_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:36:\"Devfs Path (field_devfs_path:format)\";s:11:\"title short\";s:17:\"Devfs Path:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_devfs_path_format\";s:5:\"table\";s:31:\"field_revision_field_devfs_path\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_devfs_path_value\";i:1;s:23:\"field_devfs_path_format\";}s:10:\"field_name\";s:16:\"field_devfs_path\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_devfs_path_format\";s:5:\"table\";s:31:\"field_revision_field_devfs_path\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_devfs_path_value\";i:1;s:23:\"field_devfs_path_format\";}s:10:\"field_name\";s:16:\"field_devfs_path\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_devfs_path_format\";s:5:\"table\";s:31:\"field_revision_field_devfs_path\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_devfs_path_value\";i:1;s:23:\"field_devfs_path_format\";}s:10:\"field_name\";s:16:\"field_devfs_path\";}}}s:33:\"field_data_field_multipath_plugin\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:33:\"field_data_field_multipath_plugin\";i:1;s:22:\"field_multipath_plugin\";}}}s:22:\"field_multipath_plugin\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:16:\"Multipath Plugin\";s:11:\"title short\";s:16:\"Multipath Plugin\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:33:\"field_data_field_multipath_plugin\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_multipath_plugin\";s:10:\"real field\";s:28:\"field_multipath_plugin_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_multipath_plugin_value\";i:4;s:29:\"field_multipath_plugin_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:28:\"field_multipath_plugin_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:41:\"Multipath Plugin (field_multipath_plugin)\";s:11:\"title short\";s:16:\"Multipath Plugin\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_multipath_plugin_value\";s:5:\"table\";s:33:\"field_data_field_multipath_plugin\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_multipath_plugin_value\";i:1;s:29:\"field_multipath_plugin_format\";}s:10:\"field_name\";s:22:\"field_multipath_plugin\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_multipath_plugin_value\";s:5:\"table\";s:33:\"field_data_field_multipath_plugin\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_multipath_plugin_value\";i:1;s:29:\"field_multipath_plugin_format\";}s:10:\"field_name\";s:22:\"field_multipath_plugin\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_multipath_plugin_value\";s:5:\"table\";s:33:\"field_data_field_multipath_plugin\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_multipath_plugin_value\";i:1;s:29:\"field_multipath_plugin_format\";}s:10:\"field_name\";s:22:\"field_multipath_plugin\";}}s:29:\"field_multipath_plugin_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:48:\"Multipath Plugin (field_multipath_plugin:format)\";s:11:\"title short\";s:23:\"Multipath Plugin:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_multipath_plugin_format\";s:5:\"table\";s:33:\"field_data_field_multipath_plugin\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_multipath_plugin_value\";i:1;s:29:\"field_multipath_plugin_format\";}s:10:\"field_name\";s:22:\"field_multipath_plugin\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_multipath_plugin_format\";s:5:\"table\";s:33:\"field_data_field_multipath_plugin\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_multipath_plugin_value\";i:1;s:29:\"field_multipath_plugin_format\";}s:10:\"field_name\";s:22:\"field_multipath_plugin\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_multipath_plugin_format\";s:5:\"table\";s:33:\"field_data_field_multipath_plugin\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_multipath_plugin_value\";i:1;s:29:\"field_multipath_plugin_format\";}s:10:\"field_name\";s:22:\"field_multipath_plugin\";}}}s:37:\"field_revision_field_multipath_plugin\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:37:\"field_revision_field_multipath_plugin\";i:1;s:34:\"field_multipath_plugin-revision_id\";}}}s:34:\"field_multipath_plugin-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:16:\"Multipath Plugin\";s:11:\"title short\";s:16:\"Multipath Plugin\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:37:\"field_revision_field_multipath_plugin\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_multipath_plugin\";s:10:\"real field\";s:40:\"field_multipath_plugin-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_multipath_plugin_value\";i:4;s:29:\"field_multipath_plugin_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:28:\"field_multipath_plugin_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:41:\"Multipath Plugin (field_multipath_plugin)\";s:11:\"title short\";s:16:\"Multipath Plugin\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_multipath_plugin_value\";s:5:\"table\";s:37:\"field_revision_field_multipath_plugin\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_multipath_plugin_value\";i:1;s:29:\"field_multipath_plugin_format\";}s:10:\"field_name\";s:22:\"field_multipath_plugin\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_multipath_plugin_value\";s:5:\"table\";s:37:\"field_revision_field_multipath_plugin\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_multipath_plugin_value\";i:1;s:29:\"field_multipath_plugin_format\";}s:10:\"field_name\";s:22:\"field_multipath_plugin\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_multipath_plugin_value\";s:5:\"table\";s:37:\"field_revision_field_multipath_plugin\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_multipath_plugin_value\";i:1;s:29:\"field_multipath_plugin_format\";}s:10:\"field_name\";s:22:\"field_multipath_plugin\";}}s:29:\"field_multipath_plugin_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:48:\"Multipath Plugin (field_multipath_plugin:format)\";s:11:\"title short\";s:23:\"Multipath Plugin:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_multipath_plugin_format\";s:5:\"table\";s:37:\"field_revision_field_multipath_plugin\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_multipath_plugin_value\";i:1;s:29:\"field_multipath_plugin_format\";}s:10:\"field_name\";s:22:\"field_multipath_plugin\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_multipath_plugin_format\";s:5:\"table\";s:37:\"field_revision_field_multipath_plugin\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_multipath_plugin_value\";i:1;s:29:\"field_multipath_plugin_format\";}s:10:\"field_name\";s:22:\"field_multipath_plugin\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_multipath_plugin_format\";s:5:\"table\";s:37:\"field_revision_field_multipath_plugin\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:28:\"field_multipath_plugin_value\";i:1;s:29:\"field_multipath_plugin_format\";}s:10:\"field_name\";s:22:\"field_multipath_plugin\";}}}s:28:\"field_data_field_device_type\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:28:\"field_data_field_device_type\";i:1;s:17:\"field_device_type\";}}}s:17:\"field_device_type\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:11:\"Device Type\";s:11:\"title short\";s:11:\"Device Type\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:28:\"field_data_field_device_type\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_device_type\";s:10:\"real field\";s:23:\"field_device_type_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_device_type_value\";i:4;s:24:\"field_device_type_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:23:\"field_device_type_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:31:\"Device Type (field_device_type)\";s:11:\"title short\";s:11:\"Device Type\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_device_type_value\";s:5:\"table\";s:28:\"field_data_field_device_type\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_device_type_value\";i:1;s:24:\"field_device_type_format\";}s:10:\"field_name\";s:17:\"field_device_type\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_device_type_value\";s:5:\"table\";s:28:\"field_data_field_device_type\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_device_type_value\";i:1;s:24:\"field_device_type_format\";}s:10:\"field_name\";s:17:\"field_device_type\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_device_type_value\";s:5:\"table\";s:28:\"field_data_field_device_type\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_device_type_value\";i:1;s:24:\"field_device_type_format\";}s:10:\"field_name\";s:17:\"field_device_type\";}}s:24:\"field_device_type_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:38:\"Device Type (field_device_type:format)\";s:11:\"title short\";s:18:\"Device Type:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_device_type_format\";s:5:\"table\";s:28:\"field_data_field_device_type\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_device_type_value\";i:1;s:24:\"field_device_type_format\";}s:10:\"field_name\";s:17:\"field_device_type\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_device_type_format\";s:5:\"table\";s:28:\"field_data_field_device_type\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_device_type_value\";i:1;s:24:\"field_device_type_format\";}s:10:\"field_name\";s:17:\"field_device_type\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_device_type_format\";s:5:\"table\";s:28:\"field_data_field_device_type\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_device_type_value\";i:1;s:24:\"field_device_type_format\";}s:10:\"field_name\";s:17:\"field_device_type\";}}}s:32:\"field_revision_field_device_type\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:32:\"field_revision_field_device_type\";i:1;s:29:\"field_device_type-revision_id\";}}}s:29:\"field_device_type-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:11:\"Device Type\";s:11:\"title short\";s:11:\"Device Type\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:32:\"field_revision_field_device_type\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_device_type\";s:10:\"real field\";s:35:\"field_device_type-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_device_type_value\";i:4;s:24:\"field_device_type_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:23:\"field_device_type_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:31:\"Device Type (field_device_type)\";s:11:\"title short\";s:11:\"Device Type\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_device_type_value\";s:5:\"table\";s:32:\"field_revision_field_device_type\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_device_type_value\";i:1;s:24:\"field_device_type_format\";}s:10:\"field_name\";s:17:\"field_device_type\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_device_type_value\";s:5:\"table\";s:32:\"field_revision_field_device_type\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_device_type_value\";i:1;s:24:\"field_device_type_format\";}s:10:\"field_name\";s:17:\"field_device_type\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_device_type_value\";s:5:\"table\";s:32:\"field_revision_field_device_type\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_device_type_value\";i:1;s:24:\"field_device_type_format\";}s:10:\"field_name\";s:17:\"field_device_type\";}}s:24:\"field_device_type_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:38:\"Device Type (field_device_type:format)\";s:11:\"title short\";s:18:\"Device Type:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_device_type_format\";s:5:\"table\";s:32:\"field_revision_field_device_type\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_device_type_value\";i:1;s:24:\"field_device_type_format\";}s:10:\"field_name\";s:17:\"field_device_type\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_device_type_format\";s:5:\"table\";s:32:\"field_revision_field_device_type\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_device_type_value\";i:1;s:24:\"field_device_type_format\";}s:10:\"field_name\";s:17:\"field_device_type\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_device_type_format\";s:5:\"table\";s:32:\"field_revision_field_device_type\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_device_type_value\";i:1;s:24:\"field_device_type_format\";}s:10:\"field_name\";s:17:\"field_device_type\";}}}s:21:\"field_data_field_size\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:21:\"field_data_field_size\";i:1;s:10:\"field_size\";}}}s:10:\"field_size\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:4:\"Size\";s:11:\"title short\";s:4:\"Size\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:21:\"field_data_field_size\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:10:\"field_size\";s:10:\"real field\";s:16:\"field_size_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:16:\"field_size_value\";i:4;s:17:\"field_size_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:16:\"field_size_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:17:\"Size (field_size)\";s:11:\"title short\";s:4:\"Size\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:16:\"field_size_value\";s:5:\"table\";s:21:\"field_data_field_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_size_value\";i:1;s:17:\"field_size_format\";}s:10:\"field_name\";s:10:\"field_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:16:\"field_size_value\";s:5:\"table\";s:21:\"field_data_field_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_size_value\";i:1;s:17:\"field_size_format\";}s:10:\"field_name\";s:10:\"field_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:16:\"field_size_value\";s:5:\"table\";s:21:\"field_data_field_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_size_value\";i:1;s:17:\"field_size_format\";}s:10:\"field_name\";s:10:\"field_size\";}}s:17:\"field_size_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:24:\"Size (field_size:format)\";s:11:\"title short\";s:11:\"Size:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:17:\"field_size_format\";s:5:\"table\";s:21:\"field_data_field_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_size_value\";i:1;s:17:\"field_size_format\";}s:10:\"field_name\";s:10:\"field_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:17:\"field_size_format\";s:5:\"table\";s:21:\"field_data_field_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_size_value\";i:1;s:17:\"field_size_format\";}s:10:\"field_name\";s:10:\"field_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:17:\"field_size_format\";s:5:\"table\";s:21:\"field_data_field_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_size_value\";i:1;s:17:\"field_size_format\";}s:10:\"field_name\";s:10:\"field_size\";}}}s:25:\"field_revision_field_size\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:25:\"field_revision_field_size\";i:1;s:22:\"field_size-revision_id\";}}}s:22:\"field_size-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:4:\"Size\";s:11:\"title short\";s:4:\"Size\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:25:\"field_revision_field_size\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:10:\"field_size\";s:10:\"real field\";s:28:\"field_size-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:16:\"field_size_value\";i:4;s:17:\"field_size_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:16:\"field_size_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:17:\"Size (field_size)\";s:11:\"title short\";s:4:\"Size\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:16:\"field_size_value\";s:5:\"table\";s:25:\"field_revision_field_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_size_value\";i:1;s:17:\"field_size_format\";}s:10:\"field_name\";s:10:\"field_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:16:\"field_size_value\";s:5:\"table\";s:25:\"field_revision_field_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_size_value\";i:1;s:17:\"field_size_format\";}s:10:\"field_name\";s:10:\"field_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:16:\"field_size_value\";s:5:\"table\";s:25:\"field_revision_field_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_size_value\";i:1;s:17:\"field_size_format\";}s:10:\"field_name\";s:10:\"field_size\";}}s:17:\"field_size_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:24:\"Size (field_size:format)\";s:11:\"title short\";s:11:\"Size:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:17:\"field_size_format\";s:5:\"table\";s:25:\"field_revision_field_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_size_value\";i:1;s:17:\"field_size_format\";}s:10:\"field_name\";s:10:\"field_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:17:\"field_size_format\";s:5:\"table\";s:25:\"field_revision_field_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_size_value\";i:1;s:17:\"field_size_format\";}s:10:\"field_name\";s:10:\"field_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:17:\"field_size_format\";s:5:\"table\";s:25:\"field_revision_field_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:16:\"field_size_value\";i:1;s:17:\"field_size_format\";}s:10:\"field_name\";s:10:\"field_size\";}}}s:26:\"field_data_field_serial_no\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:26:\"field_data_field_serial_no\";i:1;s:15:\"field_serial_no\";}}}s:15:\"field_serial_no\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:9:\"Serial No\";s:11:\"title short\";s:9:\"Serial No\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:26:\"field_data_field_serial_no\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:15:\"field_serial_no\";s:10:\"real field\";s:21:\"field_serial_no_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:21:\"field_serial_no_value\";i:4;s:22:\"field_serial_no_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:21:\"field_serial_no_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:27:\"Serial No (field_serial_no)\";s:11:\"title short\";s:9:\"Serial No\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_serial_no_value\";s:5:\"table\";s:26:\"field_data_field_serial_no\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_serial_no_value\";i:1;s:22:\"field_serial_no_format\";}s:10:\"field_name\";s:15:\"field_serial_no\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_serial_no_value\";s:5:\"table\";s:26:\"field_data_field_serial_no\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_serial_no_value\";i:1;s:22:\"field_serial_no_format\";}s:10:\"field_name\";s:15:\"field_serial_no\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_serial_no_value\";s:5:\"table\";s:26:\"field_data_field_serial_no\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_serial_no_value\";i:1;s:22:\"field_serial_no_format\";}s:10:\"field_name\";s:15:\"field_serial_no\";}}s:22:\"field_serial_no_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:34:\"Serial No (field_serial_no:format)\";s:11:\"title short\";s:16:\"Serial No:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_serial_no_format\";s:5:\"table\";s:26:\"field_data_field_serial_no\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_serial_no_value\";i:1;s:22:\"field_serial_no_format\";}s:10:\"field_name\";s:15:\"field_serial_no\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_serial_no_format\";s:5:\"table\";s:26:\"field_data_field_serial_no\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_serial_no_value\";i:1;s:22:\"field_serial_no_format\";}s:10:\"field_name\";s:15:\"field_serial_no\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_serial_no_format\";s:5:\"table\";s:26:\"field_data_field_serial_no\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_serial_no_value\";i:1;s:22:\"field_serial_no_format\";}s:10:\"field_name\";s:15:\"field_serial_no\";}}}s:30:\"field_revision_field_serial_no\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:30:\"field_revision_field_serial_no\";i:1;s:27:\"field_serial_no-revision_id\";}}}s:27:\"field_serial_no-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:9:\"Serial No\";s:11:\"title short\";s:9:\"Serial No\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:5:\"field\";a:9:{s:5:\"table\";s:30:\"field_revision_field_serial_no\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:15:\"field_serial_no\";s:10:\"real field\";s:33:\"field_serial_no-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:21:\"field_serial_no_value\";i:4;s:22:\"field_serial_no_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:21:\"field_serial_no_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:27:\"Serial No (field_serial_no)\";s:11:\"title short\";s:9:\"Serial No\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_serial_no_value\";s:5:\"table\";s:30:\"field_revision_field_serial_no\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_serial_no_value\";i:1;s:22:\"field_serial_no_format\";}s:10:\"field_name\";s:15:\"field_serial_no\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_serial_no_value\";s:5:\"table\";s:30:\"field_revision_field_serial_no\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_serial_no_value\";i:1;s:22:\"field_serial_no_format\";}s:10:\"field_name\";s:15:\"field_serial_no\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_serial_no_value\";s:5:\"table\";s:30:\"field_revision_field_serial_no\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_serial_no_value\";i:1;s:22:\"field_serial_no_format\";}s:10:\"field_name\";s:15:\"field_serial_no\";}}s:22:\"field_serial_no_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:34:\"Serial No (field_serial_no:format)\";s:11:\"title short\";s:16:\"Serial No:format\";s:4:\"help\";s:24:\"Appears in: node:device.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_serial_no_format\";s:5:\"table\";s:30:\"field_revision_field_serial_no\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_serial_no_value\";i:1;s:22:\"field_serial_no_format\";}s:10:\"field_name\";s:15:\"field_serial_no\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_serial_no_format\";s:5:\"table\";s:30:\"field_revision_field_serial_no\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_serial_no_value\";i:1;s:22:\"field_serial_no_format\";}s:10:\"field_name\";s:15:\"field_serial_no\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_serial_no_format\";s:5:\"table\";s:30:\"field_revision_field_serial_no\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_serial_no_value\";i:1;s:22:\"field_serial_no_format\";}s:10:\"field_name\";s:15:\"field_serial_no\";}}}s:32:\"field_data_field_reboot_required\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:32:\"field_data_field_reboot_required\";i:1;s:21:\"field_reboot_required\";}}}s:21:\"field_reboot_required\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:15:\"Reboot Required\";s:11:\"title short\";s:15:\"Reboot Required\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:32:\"field_data_field_reboot_required\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:21:\"field_reboot_required\";s:10:\"real field\";s:27:\"field_reboot_required_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:27:\"field_reboot_required_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:27:\"field_reboot_required_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:39:\"Reboot Required (field_reboot_required)\";s:11:\"title short\";s:15:\"Reboot Required\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:27:\"field_reboot_required_value\";s:5:\"table\";s:32:\"field_data_field_reboot_required\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_reboot_required_value\";}s:10:\"field_name\";s:21:\"field_reboot_required\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:27:\"field_reboot_required_value\";s:5:\"table\";s:32:\"field_data_field_reboot_required\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_reboot_required_value\";}s:10:\"field_name\";s:21:\"field_reboot_required\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:27:\"field_reboot_required_value\";s:5:\"table\";s:32:\"field_data_field_reboot_required\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_reboot_required_value\";}s:10:\"field_name\";s:21:\"field_reboot_required\";}}}s:36:\"field_revision_field_reboot_required\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:36:\"field_revision_field_reboot_required\";i:1;s:33:\"field_reboot_required-revision_id\";}}}s:33:\"field_reboot_required-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:15:\"Reboot Required\";s:11:\"title short\";s:15:\"Reboot Required\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:36:\"field_revision_field_reboot_required\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:21:\"field_reboot_required\";s:10:\"real field\";s:39:\"field_reboot_required-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:27:\"field_reboot_required_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:27:\"field_reboot_required_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:39:\"Reboot Required (field_reboot_required)\";s:11:\"title short\";s:15:\"Reboot Required\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:27:\"field_reboot_required_value\";s:5:\"table\";s:36:\"field_revision_field_reboot_required\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_reboot_required_value\";}s:10:\"field_name\";s:21:\"field_reboot_required\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:27:\"field_reboot_required_value\";s:5:\"table\";s:36:\"field_revision_field_reboot_required\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_reboot_required_value\";}s:10:\"field_name\";s:21:\"field_reboot_required\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:27:\"field_reboot_required_value\";s:5:\"table\";s:36:\"field_revision_field_reboot_required\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_reboot_required_value\";}s:10:\"field_name\";s:21:\"field_reboot_required\";}}}s:24:\"field_data_field_vmotion\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:24:\"field_data_field_vmotion\";i:1;s:13:\"field_vmotion\";}}}s:13:\"field_vmotion\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:7:\"VMotion\";s:11:\"title short\";s:7:\"VMotion\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:24:\"field_data_field_vmotion\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:13:\"field_vmotion\";s:10:\"real field\";s:19:\"field_vmotion_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:19:\"field_vmotion_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:19:\"field_vmotion_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:23:\"VMotion (field_vmotion)\";s:11:\"title short\";s:7:\"VMotion\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:19:\"field_vmotion_value\";s:5:\"table\";s:24:\"field_data_field_vmotion\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:19:\"field_vmotion_value\";}s:10:\"field_name\";s:13:\"field_vmotion\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:19:\"field_vmotion_value\";s:5:\"table\";s:24:\"field_data_field_vmotion\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:19:\"field_vmotion_value\";}s:10:\"field_name\";s:13:\"field_vmotion\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:19:\"field_vmotion_value\";s:5:\"table\";s:24:\"field_data_field_vmotion\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:19:\"field_vmotion_value\";}s:10:\"field_name\";s:13:\"field_vmotion\";}}}s:28:\"field_revision_field_vmotion\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:28:\"field_revision_field_vmotion\";i:1;s:25:\"field_vmotion-revision_id\";}}}s:25:\"field_vmotion-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:7:\"VMotion\";s:11:\"title short\";s:7:\"VMotion\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:28:\"field_revision_field_vmotion\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:13:\"field_vmotion\";s:10:\"real field\";s:31:\"field_vmotion-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:19:\"field_vmotion_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:19:\"field_vmotion_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:23:\"VMotion (field_vmotion)\";s:11:\"title short\";s:7:\"VMotion\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:19:\"field_vmotion_value\";s:5:\"table\";s:28:\"field_revision_field_vmotion\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:19:\"field_vmotion_value\";}s:10:\"field_name\";s:13:\"field_vmotion\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:19:\"field_vmotion_value\";s:5:\"table\";s:28:\"field_revision_field_vmotion\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:19:\"field_vmotion_value\";}s:10:\"field_name\";s:13:\"field_vmotion\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:19:\"field_vmotion_value\";s:5:\"table\";s:28:\"field_revision_field_vmotion\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:19:\"field_vmotion_value\";}s:10:\"field_name\";s:13:\"field_vmotion\";}}}s:32:\"field_data_field_physical_memory\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:32:\"field_data_field_physical_memory\";i:1;s:21:\"field_physical_memory\";}}}s:21:\"field_physical_memory\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:15:\"Physical Memory\";s:11:\"title short\";s:15:\"Physical Memory\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:32:\"field_data_field_physical_memory\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:21:\"field_physical_memory\";s:10:\"real field\";s:27:\"field_physical_memory_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:27:\"field_physical_memory_value\";i:4;s:28:\"field_physical_memory_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:27:\"field_physical_memory_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:39:\"Physical Memory (field_physical_memory)\";s:11:\"title short\";s:15:\"Physical Memory\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:27:\"field_physical_memory_value\";s:5:\"table\";s:32:\"field_data_field_physical_memory\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:27:\"field_physical_memory_value\";i:1;s:28:\"field_physical_memory_format\";}s:10:\"field_name\";s:21:\"field_physical_memory\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:27:\"field_physical_memory_value\";s:5:\"table\";s:32:\"field_data_field_physical_memory\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:27:\"field_physical_memory_value\";i:1;s:28:\"field_physical_memory_format\";}s:10:\"field_name\";s:21:\"field_physical_memory\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:27:\"field_physical_memory_value\";s:5:\"table\";s:32:\"field_data_field_physical_memory\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:27:\"field_physical_memory_value\";i:1;s:28:\"field_physical_memory_format\";}s:10:\"field_name\";s:21:\"field_physical_memory\";}}s:28:\"field_physical_memory_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:46:\"Physical Memory (field_physical_memory:format)\";s:11:\"title short\";s:22:\"Physical Memory:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_physical_memory_format\";s:5:\"table\";s:32:\"field_data_field_physical_memory\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:27:\"field_physical_memory_value\";i:1;s:28:\"field_physical_memory_format\";}s:10:\"field_name\";s:21:\"field_physical_memory\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_physical_memory_format\";s:5:\"table\";s:32:\"field_data_field_physical_memory\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:27:\"field_physical_memory_value\";i:1;s:28:\"field_physical_memory_format\";}s:10:\"field_name\";s:21:\"field_physical_memory\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_physical_memory_format\";s:5:\"table\";s:32:\"field_data_field_physical_memory\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:27:\"field_physical_memory_value\";i:1;s:28:\"field_physical_memory_format\";}s:10:\"field_name\";s:21:\"field_physical_memory\";}}}s:36:\"field_revision_field_physical_memory\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:36:\"field_revision_field_physical_memory\";i:1;s:33:\"field_physical_memory-revision_id\";}}}s:33:\"field_physical_memory-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:15:\"Physical Memory\";s:11:\"title short\";s:15:\"Physical Memory\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:36:\"field_revision_field_physical_memory\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:21:\"field_physical_memory\";s:10:\"real field\";s:39:\"field_physical_memory-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:27:\"field_physical_memory_value\";i:4;s:28:\"field_physical_memory_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:27:\"field_physical_memory_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:39:\"Physical Memory (field_physical_memory)\";s:11:\"title short\";s:15:\"Physical Memory\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:27:\"field_physical_memory_value\";s:5:\"table\";s:36:\"field_revision_field_physical_memory\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:27:\"field_physical_memory_value\";i:1;s:28:\"field_physical_memory_format\";}s:10:\"field_name\";s:21:\"field_physical_memory\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:27:\"field_physical_memory_value\";s:5:\"table\";s:36:\"field_revision_field_physical_memory\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:27:\"field_physical_memory_value\";i:1;s:28:\"field_physical_memory_format\";}s:10:\"field_name\";s:21:\"field_physical_memory\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:27:\"field_physical_memory_value\";s:5:\"table\";s:36:\"field_revision_field_physical_memory\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:27:\"field_physical_memory_value\";i:1;s:28:\"field_physical_memory_format\";}s:10:\"field_name\";s:21:\"field_physical_memory\";}}s:28:\"field_physical_memory_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:46:\"Physical Memory (field_physical_memory:format)\";s:11:\"title short\";s:22:\"Physical Memory:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_physical_memory_format\";s:5:\"table\";s:36:\"field_revision_field_physical_memory\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:27:\"field_physical_memory_value\";i:1;s:28:\"field_physical_memory_format\";}s:10:\"field_name\";s:21:\"field_physical_memory\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_physical_memory_format\";s:5:\"table\";s:36:\"field_revision_field_physical_memory\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:27:\"field_physical_memory_value\";i:1;s:28:\"field_physical_memory_format\";}s:10:\"field_name\";s:21:\"field_physical_memory\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_physical_memory_format\";s:5:\"table\";s:36:\"field_revision_field_physical_memory\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:27:\"field_physical_memory_value\";i:1;s:28:\"field_physical_memory_format\";}s:10:\"field_name\";s:21:\"field_physical_memory\";}}}s:33:\"field_data_field_maintenance_mode\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:33:\"field_data_field_maintenance_mode\";i:1;s:22:\"field_maintenance_mode\";}}}s:22:\"field_maintenance_mode\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:16:\"Maintenance mode\";s:11:\"title short\";s:16:\"Maintenance mode\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:33:\"field_data_field_maintenance_mode\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_maintenance_mode\";s:10:\"real field\";s:28:\"field_maintenance_mode_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_maintenance_mode_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:28:\"field_maintenance_mode_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:41:\"Maintenance mode (field_maintenance_mode)\";s:11:\"title short\";s:16:\"Maintenance mode\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_maintenance_mode_value\";s:5:\"table\";s:33:\"field_data_field_maintenance_mode\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_maintenance_mode_value\";}s:10:\"field_name\";s:22:\"field_maintenance_mode\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_maintenance_mode_value\";s:5:\"table\";s:33:\"field_data_field_maintenance_mode\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_maintenance_mode_value\";}s:10:\"field_name\";s:22:\"field_maintenance_mode\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_maintenance_mode_value\";s:5:\"table\";s:33:\"field_data_field_maintenance_mode\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_maintenance_mode_value\";}s:10:\"field_name\";s:22:\"field_maintenance_mode\";}}}s:37:\"field_revision_field_maintenance_mode\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:37:\"field_revision_field_maintenance_mode\";i:1;s:34:\"field_maintenance_mode-revision_id\";}}}s:34:\"field_maintenance_mode-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:16:\"Maintenance mode\";s:11:\"title short\";s:16:\"Maintenance mode\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:37:\"field_revision_field_maintenance_mode\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:22:\"field_maintenance_mode\";s:10:\"real field\";s:40:\"field_maintenance_mode-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:28:\"field_maintenance_mode_value\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:28:\"field_maintenance_mode_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:41:\"Maintenance mode (field_maintenance_mode)\";s:11:\"title short\";s:16:\"Maintenance mode\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_maintenance_mode_value\";s:5:\"table\";s:37:\"field_revision_field_maintenance_mode\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_maintenance_mode_value\";}s:10:\"field_name\";s:22:\"field_maintenance_mode\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_maintenance_mode_value\";s:5:\"table\";s:37:\"field_revision_field_maintenance_mode\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_maintenance_mode_value\";}s:10:\"field_name\";s:22:\"field_maintenance_mode\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:28:\"field_maintenance_mode_value\";s:5:\"table\";s:37:\"field_revision_field_maintenance_mode\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:28:\"field_maintenance_mode_value\";}s:10:\"field_name\";s:22:\"field_maintenance_mode\";}}}s:28:\"field_data_field_host_status\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:28:\"field_data_field_host_status\";i:1;s:17:\"field_host_status\";}}}s:17:\"field_host_status\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:11:\"Host Status\";s:11:\"title short\";s:11:\"Host Status\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:28:\"field_data_field_host_status\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_host_status\";s:10:\"real field\";s:23:\"field_host_status_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_host_status_value\";i:4;s:24:\"field_host_status_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:23:\"field_host_status_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:31:\"Host Status (field_host_status)\";s:11:\"title short\";s:11:\"Host Status\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_host_status_value\";s:5:\"table\";s:28:\"field_data_field_host_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_status_value\";i:1;s:24:\"field_host_status_format\";}s:10:\"field_name\";s:17:\"field_host_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_host_status_value\";s:5:\"table\";s:28:\"field_data_field_host_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_status_value\";i:1;s:24:\"field_host_status_format\";}s:10:\"field_name\";s:17:\"field_host_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_host_status_value\";s:5:\"table\";s:28:\"field_data_field_host_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_status_value\";i:1;s:24:\"field_host_status_format\";}s:10:\"field_name\";s:17:\"field_host_status\";}}s:24:\"field_host_status_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:38:\"Host Status (field_host_status:format)\";s:11:\"title short\";s:18:\"Host Status:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_host_status_format\";s:5:\"table\";s:28:\"field_data_field_host_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_status_value\";i:1;s:24:\"field_host_status_format\";}s:10:\"field_name\";s:17:\"field_host_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_host_status_format\";s:5:\"table\";s:28:\"field_data_field_host_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_status_value\";i:1;s:24:\"field_host_status_format\";}s:10:\"field_name\";s:17:\"field_host_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_host_status_format\";s:5:\"table\";s:28:\"field_data_field_host_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_status_value\";i:1;s:24:\"field_host_status_format\";}s:10:\"field_name\";s:17:\"field_host_status\";}}}s:32:\"field_revision_field_host_status\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:32:\"field_revision_field_host_status\";i:1;s:29:\"field_host_status-revision_id\";}}}s:29:\"field_host_status-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:11:\"Host Status\";s:11:\"title short\";s:11:\"Host Status\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:32:\"field_revision_field_host_status\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_host_status\";s:10:\"real field\";s:35:\"field_host_status-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_host_status_value\";i:4;s:24:\"field_host_status_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:23:\"field_host_status_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:31:\"Host Status (field_host_status)\";s:11:\"title short\";s:11:\"Host Status\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_host_status_value\";s:5:\"table\";s:32:\"field_revision_field_host_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_status_value\";i:1;s:24:\"field_host_status_format\";}s:10:\"field_name\";s:17:\"field_host_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_host_status_value\";s:5:\"table\";s:32:\"field_revision_field_host_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_status_value\";i:1;s:24:\"field_host_status_format\";}s:10:\"field_name\";s:17:\"field_host_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_host_status_value\";s:5:\"table\";s:32:\"field_revision_field_host_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_status_value\";i:1;s:24:\"field_host_status_format\";}s:10:\"field_name\";s:17:\"field_host_status\";}}s:24:\"field_host_status_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:38:\"Host Status (field_host_status:format)\";s:11:\"title short\";s:18:\"Host Status:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_host_status_format\";s:5:\"table\";s:32:\"field_revision_field_host_status\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_status_value\";i:1;s:24:\"field_host_status_format\";}s:10:\"field_name\";s:17:\"field_host_status\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_host_status_format\";s:5:\"table\";s:32:\"field_revision_field_host_status\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_status_value\";i:1;s:24:\"field_host_status_format\";}s:10:\"field_name\";s:17:\"field_host_status\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_host_status_format\";s:5:\"table\";s:32:\"field_revision_field_host_status\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_host_status_value\";i:1;s:24:\"field_host_status_format\";}s:10:\"field_name\";s:17:\"field_host_status\";}}}s:25:\"field_data_field_boottime\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:25:\"field_data_field_boottime\";i:1;s:14:\"field_boottime\";}}}s:14:\"field_boottime\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:8:\"BootTime\";s:11:\"title short\";s:8:\"BootTime\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:25:\"field_data_field_boottime\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_boottime\";s:10:\"real field\";s:20:\"field_boottime_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_boottime_value\";i:4;s:21:\"field_boottime_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:20:\"field_boottime_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:25:\"BootTime (field_boottime)\";s:11:\"title short\";s:8:\"BootTime\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_boottime_value\";s:5:\"table\";s:25:\"field_data_field_boottime\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_boottime_value\";i:1;s:21:\"field_boottime_format\";}s:10:\"field_name\";s:14:\"field_boottime\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_boottime_value\";s:5:\"table\";s:25:\"field_data_field_boottime\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_boottime_value\";i:1;s:21:\"field_boottime_format\";}s:10:\"field_name\";s:14:\"field_boottime\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_boottime_value\";s:5:\"table\";s:25:\"field_data_field_boottime\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_boottime_value\";i:1;s:21:\"field_boottime_format\";}s:10:\"field_name\";s:14:\"field_boottime\";}}s:21:\"field_boottime_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:32:\"BootTime (field_boottime:format)\";s:11:\"title short\";s:15:\"BootTime:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_boottime_format\";s:5:\"table\";s:25:\"field_data_field_boottime\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_boottime_value\";i:1;s:21:\"field_boottime_format\";}s:10:\"field_name\";s:14:\"field_boottime\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_boottime_format\";s:5:\"table\";s:25:\"field_data_field_boottime\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_boottime_value\";i:1;s:21:\"field_boottime_format\";}s:10:\"field_name\";s:14:\"field_boottime\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_boottime_format\";s:5:\"table\";s:25:\"field_data_field_boottime\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_boottime_value\";i:1;s:21:\"field_boottime_format\";}s:10:\"field_name\";s:14:\"field_boottime\";}}}s:29:\"field_revision_field_boottime\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:29:\"field_revision_field_boottime\";i:1;s:26:\"field_boottime-revision_id\";}}}s:26:\"field_boottime-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:8:\"BootTime\";s:11:\"title short\";s:8:\"BootTime\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:29:\"field_revision_field_boottime\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_boottime\";s:10:\"real field\";s:32:\"field_boottime-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_boottime_value\";i:4;s:21:\"field_boottime_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:20:\"field_boottime_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:25:\"BootTime (field_boottime)\";s:11:\"title short\";s:8:\"BootTime\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_boottime_value\";s:5:\"table\";s:29:\"field_revision_field_boottime\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_boottime_value\";i:1;s:21:\"field_boottime_format\";}s:10:\"field_name\";s:14:\"field_boottime\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_boottime_value\";s:5:\"table\";s:29:\"field_revision_field_boottime\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_boottime_value\";i:1;s:21:\"field_boottime_format\";}s:10:\"field_name\";s:14:\"field_boottime\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_boottime_value\";s:5:\"table\";s:29:\"field_revision_field_boottime\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_boottime_value\";i:1;s:21:\"field_boottime_format\";}s:10:\"field_name\";s:14:\"field_boottime\";}}s:21:\"field_boottime_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:32:\"BootTime (field_boottime:format)\";s:11:\"title short\";s:15:\"BootTime:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_boottime_format\";s:5:\"table\";s:29:\"field_revision_field_boottime\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_boottime_value\";i:1;s:21:\"field_boottime_format\";}s:10:\"field_name\";s:14:\"field_boottime\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_boottime_format\";s:5:\"table\";s:29:\"field_revision_field_boottime\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_boottime_value\";i:1;s:21:\"field_boottime_format\";}s:10:\"field_name\";s:14:\"field_boottime\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_boottime_format\";s:5:\"table\";s:29:\"field_revision_field_boottime\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_boottime_value\";i:1;s:21:\"field_boottime_format\";}s:10:\"field_name\";s:14:\"field_boottime\";}}}s:26:\"field_data_field_cpu_model\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:26:\"field_data_field_cpu_model\";i:1;s:15:\"field_cpu_model\";}}}s:15:\"field_cpu_model\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:9:\"Cpu Model\";s:11:\"title short\";s:9:\"Cpu Model\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:26:\"field_data_field_cpu_model\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:15:\"field_cpu_model\";s:10:\"real field\";s:21:\"field_cpu_model_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:21:\"field_cpu_model_value\";i:4;s:22:\"field_cpu_model_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:21:\"field_cpu_model_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:27:\"Cpu Model (field_cpu_model)\";s:11:\"title short\";s:9:\"Cpu Model\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_cpu_model_value\";s:5:\"table\";s:26:\"field_data_field_cpu_model\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_model_value\";i:1;s:22:\"field_cpu_model_format\";}s:10:\"field_name\";s:15:\"field_cpu_model\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_cpu_model_value\";s:5:\"table\";s:26:\"field_data_field_cpu_model\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_model_value\";i:1;s:22:\"field_cpu_model_format\";}s:10:\"field_name\";s:15:\"field_cpu_model\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_cpu_model_value\";s:5:\"table\";s:26:\"field_data_field_cpu_model\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_model_value\";i:1;s:22:\"field_cpu_model_format\";}s:10:\"field_name\";s:15:\"field_cpu_model\";}}s:22:\"field_cpu_model_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:34:\"Cpu Model (field_cpu_model:format)\";s:11:\"title short\";s:16:\"Cpu Model:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_cpu_model_format\";s:5:\"table\";s:26:\"field_data_field_cpu_model\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_model_value\";i:1;s:22:\"field_cpu_model_format\";}s:10:\"field_name\";s:15:\"field_cpu_model\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_cpu_model_format\";s:5:\"table\";s:26:\"field_data_field_cpu_model\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_model_value\";i:1;s:22:\"field_cpu_model_format\";}s:10:\"field_name\";s:15:\"field_cpu_model\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_cpu_model_format\";s:5:\"table\";s:26:\"field_data_field_cpu_model\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_model_value\";i:1;s:22:\"field_cpu_model_format\";}s:10:\"field_name\";s:15:\"field_cpu_model\";}}}s:30:\"field_revision_field_cpu_model\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:30:\"field_revision_field_cpu_model\";i:1;s:27:\"field_cpu_model-revision_id\";}}}s:27:\"field_cpu_model-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:9:\"Cpu Model\";s:11:\"title short\";s:9:\"Cpu Model\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:30:\"field_revision_field_cpu_model\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:15:\"field_cpu_model\";s:10:\"real field\";s:33:\"field_cpu_model-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:21:\"field_cpu_model_value\";i:4;s:22:\"field_cpu_model_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:21:\"field_cpu_model_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:27:\"Cpu Model (field_cpu_model)\";s:11:\"title short\";s:9:\"Cpu Model\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_cpu_model_value\";s:5:\"table\";s:30:\"field_revision_field_cpu_model\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_model_value\";i:1;s:22:\"field_cpu_model_format\";}s:10:\"field_name\";s:15:\"field_cpu_model\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_cpu_model_value\";s:5:\"table\";s:30:\"field_revision_field_cpu_model\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_model_value\";i:1;s:22:\"field_cpu_model_format\";}s:10:\"field_name\";s:15:\"field_cpu_model\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_cpu_model_value\";s:5:\"table\";s:30:\"field_revision_field_cpu_model\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_model_value\";i:1;s:22:\"field_cpu_model_format\";}s:10:\"field_name\";s:15:\"field_cpu_model\";}}s:22:\"field_cpu_model_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:34:\"Cpu Model (field_cpu_model:format)\";s:11:\"title short\";s:16:\"Cpu Model:format\";s:4:\"help\";s:22:\"Appears in: node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_cpu_model_format\";s:5:\"table\";s:30:\"field_revision_field_cpu_model\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_model_value\";i:1;s:22:\"field_cpu_model_format\";}s:10:\"field_name\";s:15:\"field_cpu_model\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_cpu_model_format\";s:5:\"table\";s:30:\"field_revision_field_cpu_model\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_model_value\";i:1;s:22:\"field_cpu_model_format\";}s:10:\"field_name\";s:15:\"field_cpu_model\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_cpu_model_format\";s:5:\"table\";s:30:\"field_revision_field_cpu_model\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_model_value\";i:1;s:22:\"field_cpu_model_format\";}s:10:\"field_name\";s:15:\"field_cpu_model\";}}}s:35:\"field_data_field_guest_memory_usage\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:35:\"field_data_field_guest_memory_usage\";i:1;s:24:\"field_guest_memory_usage\";}}}s:24:\"field_guest_memory_usage\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:18:\"Guest Memory Usage\";s:11:\"title short\";s:18:\"Guest Memory Usage\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:35:\"field_data_field_guest_memory_usage\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:24:\"field_guest_memory_usage\";s:10:\"real field\";s:30:\"field_guest_memory_usage_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:30:\"field_guest_memory_usage_value\";i:4;s:31:\"field_guest_memory_usage_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:30:\"field_guest_memory_usage_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:45:\"Guest Memory Usage (field_guest_memory_usage)\";s:11:\"title short\";s:18:\"Guest Memory Usage\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:30:\"field_guest_memory_usage_value\";s:5:\"table\";s:35:\"field_data_field_guest_memory_usage\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:30:\"field_guest_memory_usage_value\";i:1;s:31:\"field_guest_memory_usage_format\";}s:10:\"field_name\";s:24:\"field_guest_memory_usage\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:30:\"field_guest_memory_usage_value\";s:5:\"table\";s:35:\"field_data_field_guest_memory_usage\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:30:\"field_guest_memory_usage_value\";i:1;s:31:\"field_guest_memory_usage_format\";}s:10:\"field_name\";s:24:\"field_guest_memory_usage\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:30:\"field_guest_memory_usage_value\";s:5:\"table\";s:35:\"field_data_field_guest_memory_usage\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:30:\"field_guest_memory_usage_value\";i:1;s:31:\"field_guest_memory_usage_format\";}s:10:\"field_name\";s:24:\"field_guest_memory_usage\";}}s:31:\"field_guest_memory_usage_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:52:\"Guest Memory Usage (field_guest_memory_usage:format)\";s:11:\"title short\";s:25:\"Guest Memory Usage:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:31:\"field_guest_memory_usage_format\";s:5:\"table\";s:35:\"field_data_field_guest_memory_usage\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:30:\"field_guest_memory_usage_value\";i:1;s:31:\"field_guest_memory_usage_format\";}s:10:\"field_name\";s:24:\"field_guest_memory_usage\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:31:\"field_guest_memory_usage_format\";s:5:\"table\";s:35:\"field_data_field_guest_memory_usage\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:30:\"field_guest_memory_usage_value\";i:1;s:31:\"field_guest_memory_usage_format\";}s:10:\"field_name\";s:24:\"field_guest_memory_usage\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:31:\"field_guest_memory_usage_format\";s:5:\"table\";s:35:\"field_data_field_guest_memory_usage\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:30:\"field_guest_memory_usage_value\";i:1;s:31:\"field_guest_memory_usage_format\";}s:10:\"field_name\";s:24:\"field_guest_memory_usage\";}}}s:39:\"field_revision_field_guest_memory_usage\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:39:\"field_revision_field_guest_memory_usage\";i:1;s:36:\"field_guest_memory_usage-revision_id\";}}}s:36:\"field_guest_memory_usage-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:18:\"Guest Memory Usage\";s:11:\"title short\";s:18:\"Guest Memory Usage\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:39:\"field_revision_field_guest_memory_usage\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:24:\"field_guest_memory_usage\";s:10:\"real field\";s:42:\"field_guest_memory_usage-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:30:\"field_guest_memory_usage_value\";i:4;s:31:\"field_guest_memory_usage_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:30:\"field_guest_memory_usage_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:45:\"Guest Memory Usage (field_guest_memory_usage)\";s:11:\"title short\";s:18:\"Guest Memory Usage\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:30:\"field_guest_memory_usage_value\";s:5:\"table\";s:39:\"field_revision_field_guest_memory_usage\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:30:\"field_guest_memory_usage_value\";i:1;s:31:\"field_guest_memory_usage_format\";}s:10:\"field_name\";s:24:\"field_guest_memory_usage\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:30:\"field_guest_memory_usage_value\";s:5:\"table\";s:39:\"field_revision_field_guest_memory_usage\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:30:\"field_guest_memory_usage_value\";i:1;s:31:\"field_guest_memory_usage_format\";}s:10:\"field_name\";s:24:\"field_guest_memory_usage\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:30:\"field_guest_memory_usage_value\";s:5:\"table\";s:39:\"field_revision_field_guest_memory_usage\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:30:\"field_guest_memory_usage_value\";i:1;s:31:\"field_guest_memory_usage_format\";}s:10:\"field_name\";s:24:\"field_guest_memory_usage\";}}s:31:\"field_guest_memory_usage_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:52:\"Guest Memory Usage (field_guest_memory_usage:format)\";s:11:\"title short\";s:25:\"Guest Memory Usage:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:31:\"field_guest_memory_usage_format\";s:5:\"table\";s:39:\"field_revision_field_guest_memory_usage\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:30:\"field_guest_memory_usage_value\";i:1;s:31:\"field_guest_memory_usage_format\";}s:10:\"field_name\";s:24:\"field_guest_memory_usage\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:31:\"field_guest_memory_usage_format\";s:5:\"table\";s:39:\"field_revision_field_guest_memory_usage\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:30:\"field_guest_memory_usage_value\";i:1;s:31:\"field_guest_memory_usage_format\";}s:10:\"field_name\";s:24:\"field_guest_memory_usage\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:31:\"field_guest_memory_usage_format\";s:5:\"table\";s:39:\"field_revision_field_guest_memory_usage\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:30:\"field_guest_memory_usage_value\";i:1;s:31:\"field_guest_memory_usage_format\";}s:10:\"field_name\";s:24:\"field_guest_memory_usage\";}}}s:34:\"field_data_field_host_memory_usage\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:34:\"field_data_field_host_memory_usage\";i:1;s:23:\"field_host_memory_usage\";}}}s:23:\"field_host_memory_usage\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:17:\"Host Memory Usage\";s:11:\"title short\";s:17:\"Host Memory Usage\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:34:\"field_data_field_host_memory_usage\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:23:\"field_host_memory_usage\";s:10:\"real field\";s:29:\"field_host_memory_usage_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:29:\"field_host_memory_usage_value\";i:4;s:30:\"field_host_memory_usage_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:29:\"field_host_memory_usage_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:43:\"Host Memory Usage (field_host_memory_usage)\";s:11:\"title short\";s:17:\"Host Memory Usage\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_host_memory_usage_value\";s:5:\"table\";s:34:\"field_data_field_host_memory_usage\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_host_memory_usage_value\";i:1;s:30:\"field_host_memory_usage_format\";}s:10:\"field_name\";s:23:\"field_host_memory_usage\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_host_memory_usage_value\";s:5:\"table\";s:34:\"field_data_field_host_memory_usage\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_host_memory_usage_value\";i:1;s:30:\"field_host_memory_usage_format\";}s:10:\"field_name\";s:23:\"field_host_memory_usage\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_host_memory_usage_value\";s:5:\"table\";s:34:\"field_data_field_host_memory_usage\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_host_memory_usage_value\";i:1;s:30:\"field_host_memory_usage_format\";}s:10:\"field_name\";s:23:\"field_host_memory_usage\";}}s:30:\"field_host_memory_usage_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:50:\"Host Memory Usage (field_host_memory_usage:format)\";s:11:\"title short\";s:24:\"Host Memory Usage:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:30:\"field_host_memory_usage_format\";s:5:\"table\";s:34:\"field_data_field_host_memory_usage\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_host_memory_usage_value\";i:1;s:30:\"field_host_memory_usage_format\";}s:10:\"field_name\";s:23:\"field_host_memory_usage\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:30:\"field_host_memory_usage_format\";s:5:\"table\";s:34:\"field_data_field_host_memory_usage\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_host_memory_usage_value\";i:1;s:30:\"field_host_memory_usage_format\";}s:10:\"field_name\";s:23:\"field_host_memory_usage\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:30:\"field_host_memory_usage_format\";s:5:\"table\";s:34:\"field_data_field_host_memory_usage\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_host_memory_usage_value\";i:1;s:30:\"field_host_memory_usage_format\";}s:10:\"field_name\";s:23:\"field_host_memory_usage\";}}}s:38:\"field_revision_field_host_memory_usage\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:38:\"field_revision_field_host_memory_usage\";i:1;s:35:\"field_host_memory_usage-revision_id\";}}}s:35:\"field_host_memory_usage-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:17:\"Host Memory Usage\";s:11:\"title short\";s:17:\"Host Memory Usage\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:38:\"field_revision_field_host_memory_usage\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:23:\"field_host_memory_usage\";s:10:\"real field\";s:41:\"field_host_memory_usage-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:29:\"field_host_memory_usage_value\";i:4;s:30:\"field_host_memory_usage_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:29:\"field_host_memory_usage_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:43:\"Host Memory Usage (field_host_memory_usage)\";s:11:\"title short\";s:17:\"Host Memory Usage\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_host_memory_usage_value\";s:5:\"table\";s:38:\"field_revision_field_host_memory_usage\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_host_memory_usage_value\";i:1;s:30:\"field_host_memory_usage_format\";}s:10:\"field_name\";s:23:\"field_host_memory_usage\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_host_memory_usage_value\";s:5:\"table\";s:38:\"field_revision_field_host_memory_usage\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_host_memory_usage_value\";i:1;s:30:\"field_host_memory_usage_format\";}s:10:\"field_name\";s:23:\"field_host_memory_usage\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:29:\"field_host_memory_usage_value\";s:5:\"table\";s:38:\"field_revision_field_host_memory_usage\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_host_memory_usage_value\";i:1;s:30:\"field_host_memory_usage_format\";}s:10:\"field_name\";s:23:\"field_host_memory_usage\";}}s:30:\"field_host_memory_usage_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:50:\"Host Memory Usage (field_host_memory_usage:format)\";s:11:\"title short\";s:24:\"Host Memory Usage:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:30:\"field_host_memory_usage_format\";s:5:\"table\";s:38:\"field_revision_field_host_memory_usage\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_host_memory_usage_value\";i:1;s:30:\"field_host_memory_usage_format\";}s:10:\"field_name\";s:23:\"field_host_memory_usage\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:30:\"field_host_memory_usage_format\";s:5:\"table\";s:38:\"field_revision_field_host_memory_usage\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_host_memory_usage_value\";i:1;s:30:\"field_host_memory_usage_format\";}s:10:\"field_name\";s:23:\"field_host_memory_usage\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:30:\"field_host_memory_usage_format\";s:5:\"table\";s:38:\"field_revision_field_host_memory_usage\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_host_memory_usage_value\";i:1;s:30:\"field_host_memory_usage_format\";}s:10:\"field_name\";s:23:\"field_host_memory_usage\";}}}s:26:\"field_data_field_cpu_usage\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:26:\"field_data_field_cpu_usage\";i:1;s:15:\"field_cpu_usage\";}}}s:15:\"field_cpu_usage\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:9:\"CPU Usage\";s:11:\"title short\";s:9:\"CPU Usage\";s:4:\"help\";s:44:\"Appears in: node:virtual_machine, node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:26:\"field_data_field_cpu_usage\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:15:\"field_cpu_usage\";s:10:\"real field\";s:21:\"field_cpu_usage_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:21:\"field_cpu_usage_value\";i:4;s:22:\"field_cpu_usage_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:21:\"field_cpu_usage_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:27:\"CPU Usage (field_cpu_usage)\";s:11:\"title short\";s:9:\"CPU Usage\";s:4:\"help\";s:44:\"Appears in: node:virtual_machine, node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_cpu_usage_value\";s:5:\"table\";s:26:\"field_data_field_cpu_usage\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_usage_value\";i:1;s:22:\"field_cpu_usage_format\";}s:10:\"field_name\";s:15:\"field_cpu_usage\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_cpu_usage_value\";s:5:\"table\";s:26:\"field_data_field_cpu_usage\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_usage_value\";i:1;s:22:\"field_cpu_usage_format\";}s:10:\"field_name\";s:15:\"field_cpu_usage\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_cpu_usage_value\";s:5:\"table\";s:26:\"field_data_field_cpu_usage\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_usage_value\";i:1;s:22:\"field_cpu_usage_format\";}s:10:\"field_name\";s:15:\"field_cpu_usage\";}}s:22:\"field_cpu_usage_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:34:\"CPU Usage (field_cpu_usage:format)\";s:11:\"title short\";s:16:\"CPU Usage:format\";s:4:\"help\";s:44:\"Appears in: node:virtual_machine, node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_cpu_usage_format\";s:5:\"table\";s:26:\"field_data_field_cpu_usage\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_usage_value\";i:1;s:22:\"field_cpu_usage_format\";}s:10:\"field_name\";s:15:\"field_cpu_usage\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_cpu_usage_format\";s:5:\"table\";s:26:\"field_data_field_cpu_usage\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_usage_value\";i:1;s:22:\"field_cpu_usage_format\";}s:10:\"field_name\";s:15:\"field_cpu_usage\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_cpu_usage_format\";s:5:\"table\";s:26:\"field_data_field_cpu_usage\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_usage_value\";i:1;s:22:\"field_cpu_usage_format\";}s:10:\"field_name\";s:15:\"field_cpu_usage\";}}}s:30:\"field_revision_field_cpu_usage\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:30:\"field_revision_field_cpu_usage\";i:1;s:27:\"field_cpu_usage-revision_id\";}}}s:27:\"field_cpu_usage-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:9:\"CPU Usage\";s:11:\"title short\";s:9:\"CPU Usage\";s:4:\"help\";s:44:\"Appears in: node:virtual_machine, node:host.\";s:5:\"field\";a:9:{s:5:\"table\";s:30:\"field_revision_field_cpu_usage\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:15:\"field_cpu_usage\";s:10:\"real field\";s:33:\"field_cpu_usage-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:21:\"field_cpu_usage_value\";i:4;s:22:\"field_cpu_usage_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:21:\"field_cpu_usage_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:27:\"CPU Usage (field_cpu_usage)\";s:11:\"title short\";s:9:\"CPU Usage\";s:4:\"help\";s:44:\"Appears in: node:virtual_machine, node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_cpu_usage_value\";s:5:\"table\";s:30:\"field_revision_field_cpu_usage\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_usage_value\";i:1;s:22:\"field_cpu_usage_format\";}s:10:\"field_name\";s:15:\"field_cpu_usage\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_cpu_usage_value\";s:5:\"table\";s:30:\"field_revision_field_cpu_usage\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_usage_value\";i:1;s:22:\"field_cpu_usage_format\";}s:10:\"field_name\";s:15:\"field_cpu_usage\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_cpu_usage_value\";s:5:\"table\";s:30:\"field_revision_field_cpu_usage\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_usage_value\";i:1;s:22:\"field_cpu_usage_format\";}s:10:\"field_name\";s:15:\"field_cpu_usage\";}}s:22:\"field_cpu_usage_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:34:\"CPU Usage (field_cpu_usage:format)\";s:11:\"title short\";s:16:\"CPU Usage:format\";s:4:\"help\";s:44:\"Appears in: node:virtual_machine, node:host.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_cpu_usage_format\";s:5:\"table\";s:30:\"field_revision_field_cpu_usage\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_usage_value\";i:1;s:22:\"field_cpu_usage_format\";}s:10:\"field_name\";s:15:\"field_cpu_usage\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_cpu_usage_format\";s:5:\"table\";s:30:\"field_revision_field_cpu_usage\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_usage_value\";i:1;s:22:\"field_cpu_usage_format\";}s:10:\"field_name\";s:15:\"field_cpu_usage\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_cpu_usage_format\";s:5:\"table\";s:30:\"field_revision_field_cpu_usage\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:21:\"field_cpu_usage_value\";i:1;s:22:\"field_cpu_usage_format\";}s:10:\"field_name\";s:15:\"field_cpu_usage\";}}}s:25:\"field_data_field_guest_id\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:25:\"field_data_field_guest_id\";i:1;s:14:\"field_guest_id\";}}}s:14:\"field_guest_id\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:8:\"Guest ID\";s:11:\"title short\";s:8:\"Guest ID\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:25:\"field_data_field_guest_id\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_guest_id\";s:10:\"real field\";s:20:\"field_guest_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_guest_id_value\";i:4;s:21:\"field_guest_id_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:20:\"field_guest_id_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:25:\"Guest ID (field_guest_id)\";s:11:\"title short\";s:8:\"Guest ID\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_guest_id_value\";s:5:\"table\";s:25:\"field_data_field_guest_id\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_id_value\";i:1;s:21:\"field_guest_id_format\";}s:10:\"field_name\";s:14:\"field_guest_id\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_guest_id_value\";s:5:\"table\";s:25:\"field_data_field_guest_id\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_id_value\";i:1;s:21:\"field_guest_id_format\";}s:10:\"field_name\";s:14:\"field_guest_id\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_guest_id_value\";s:5:\"table\";s:25:\"field_data_field_guest_id\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_id_value\";i:1;s:21:\"field_guest_id_format\";}s:10:\"field_name\";s:14:\"field_guest_id\";}}s:21:\"field_guest_id_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:32:\"Guest ID (field_guest_id:format)\";s:11:\"title short\";s:15:\"Guest ID:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_guest_id_format\";s:5:\"table\";s:25:\"field_data_field_guest_id\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_id_value\";i:1;s:21:\"field_guest_id_format\";}s:10:\"field_name\";s:14:\"field_guest_id\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_guest_id_format\";s:5:\"table\";s:25:\"field_data_field_guest_id\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_id_value\";i:1;s:21:\"field_guest_id_format\";}s:10:\"field_name\";s:14:\"field_guest_id\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_guest_id_format\";s:5:\"table\";s:25:\"field_data_field_guest_id\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_id_value\";i:1;s:21:\"field_guest_id_format\";}s:10:\"field_name\";s:14:\"field_guest_id\";}}}s:29:\"field_revision_field_guest_id\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:29:\"field_revision_field_guest_id\";i:1;s:26:\"field_guest_id-revision_id\";}}}s:26:\"field_guest_id-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:8:\"Guest ID\";s:11:\"title short\";s:8:\"Guest ID\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:29:\"field_revision_field_guest_id\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_guest_id\";s:10:\"real field\";s:32:\"field_guest_id-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_guest_id_value\";i:4;s:21:\"field_guest_id_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:20:\"field_guest_id_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:25:\"Guest ID (field_guest_id)\";s:11:\"title short\";s:8:\"Guest ID\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_guest_id_value\";s:5:\"table\";s:29:\"field_revision_field_guest_id\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_id_value\";i:1;s:21:\"field_guest_id_format\";}s:10:\"field_name\";s:14:\"field_guest_id\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_guest_id_value\";s:5:\"table\";s:29:\"field_revision_field_guest_id\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_id_value\";i:1;s:21:\"field_guest_id_format\";}s:10:\"field_name\";s:14:\"field_guest_id\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_guest_id_value\";s:5:\"table\";s:29:\"field_revision_field_guest_id\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_id_value\";i:1;s:21:\"field_guest_id_format\";}s:10:\"field_name\";s:14:\"field_guest_id\";}}s:21:\"field_guest_id_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:32:\"Guest ID (field_guest_id:format)\";s:11:\"title short\";s:15:\"Guest ID:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_guest_id_format\";s:5:\"table\";s:29:\"field_revision_field_guest_id\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_id_value\";i:1;s:21:\"field_guest_id_format\";}s:10:\"field_name\";s:14:\"field_guest_id\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_guest_id_format\";s:5:\"table\";s:29:\"field_revision_field_guest_id\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_id_value\";i:1;s:21:\"field_guest_id_format\";}s:10:\"field_name\";s:14:\"field_guest_id\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_guest_id_format\";s:5:\"table\";s:29:\"field_revision_field_guest_id\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_id_value\";i:1;s:21:\"field_guest_id_format\";}s:10:\"field_name\";s:14:\"field_guest_id\";}}}s:25:\"field_data_field_guest_os\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:25:\"field_data_field_guest_os\";i:1;s:14:\"field_guest_os\";}}}s:14:\"field_guest_os\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:8:\"Guest OS\";s:11:\"title short\";s:8:\"Guest OS\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:25:\"field_data_field_guest_os\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_guest_os\";s:10:\"real field\";s:20:\"field_guest_os_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_guest_os_value\";i:4;s:21:\"field_guest_os_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:20:\"field_guest_os_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:25:\"Guest OS (field_guest_os)\";s:11:\"title short\";s:8:\"Guest OS\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_guest_os_value\";s:5:\"table\";s:25:\"field_data_field_guest_os\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_os_value\";i:1;s:21:\"field_guest_os_format\";}s:10:\"field_name\";s:14:\"field_guest_os\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_guest_os_value\";s:5:\"table\";s:25:\"field_data_field_guest_os\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_os_value\";i:1;s:21:\"field_guest_os_format\";}s:10:\"field_name\";s:14:\"field_guest_os\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_guest_os_value\";s:5:\"table\";s:25:\"field_data_field_guest_os\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_os_value\";i:1;s:21:\"field_guest_os_format\";}s:10:\"field_name\";s:14:\"field_guest_os\";}}s:21:\"field_guest_os_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:32:\"Guest OS (field_guest_os:format)\";s:11:\"title short\";s:15:\"Guest OS:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_guest_os_format\";s:5:\"table\";s:25:\"field_data_field_guest_os\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_os_value\";i:1;s:21:\"field_guest_os_format\";}s:10:\"field_name\";s:14:\"field_guest_os\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_guest_os_format\";s:5:\"table\";s:25:\"field_data_field_guest_os\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_os_value\";i:1;s:21:\"field_guest_os_format\";}s:10:\"field_name\";s:14:\"field_guest_os\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_guest_os_format\";s:5:\"table\";s:25:\"field_data_field_guest_os\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_os_value\";i:1;s:21:\"field_guest_os_format\";}s:10:\"field_name\";s:14:\"field_guest_os\";}}}s:29:\"field_revision_field_guest_os\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:29:\"field_revision_field_guest_os\";i:1;s:26:\"field_guest_os-revision_id\";}}}s:26:\"field_guest_os-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:8:\"Guest OS\";s:11:\"title short\";s:8:\"Guest OS\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:29:\"field_revision_field_guest_os\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_guest_os\";s:10:\"real field\";s:32:\"field_guest_os-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_guest_os_value\";i:4;s:21:\"field_guest_os_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:20:\"field_guest_os_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:25:\"Guest OS (field_guest_os)\";s:11:\"title short\";s:8:\"Guest OS\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_guest_os_value\";s:5:\"table\";s:29:\"field_revision_field_guest_os\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_os_value\";i:1;s:21:\"field_guest_os_format\";}s:10:\"field_name\";s:14:\"field_guest_os\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_guest_os_value\";s:5:\"table\";s:29:\"field_revision_field_guest_os\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_os_value\";i:1;s:21:\"field_guest_os_format\";}s:10:\"field_name\";s:14:\"field_guest_os\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_guest_os_value\";s:5:\"table\";s:29:\"field_revision_field_guest_os\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_os_value\";i:1;s:21:\"field_guest_os_format\";}s:10:\"field_name\";s:14:\"field_guest_os\";}}s:21:\"field_guest_os_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:32:\"Guest OS (field_guest_os:format)\";s:11:\"title short\";s:15:\"Guest OS:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_guest_os_format\";s:5:\"table\";s:29:\"field_revision_field_guest_os\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_os_value\";i:1;s:21:\"field_guest_os_format\";}s:10:\"field_name\";s:14:\"field_guest_os\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_guest_os_format\";s:5:\"table\";s:29:\"field_revision_field_guest_os\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_os_value\";i:1;s:21:\"field_guest_os_format\";}s:10:\"field_name\";s:14:\"field_guest_os\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_guest_os_format\";s:5:\"table\";s:29:\"field_revision_field_guest_os\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_guest_os_value\";i:1;s:21:\"field_guest_os_format\";}s:10:\"field_name\";s:14:\"field_guest_os\";}}}s:29:\"field_data_field_vm_path_name\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:29:\"field_data_field_vm_path_name\";i:1;s:18:\"field_vm_path_name\";}}}s:18:\"field_vm_path_name\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:12:\"VM Path Name\";s:11:\"title short\";s:12:\"VM Path Name\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:29:\"field_data_field_vm_path_name\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:18:\"field_vm_path_name\";s:10:\"real field\";s:24:\"field_vm_path_name_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:24:\"field_vm_path_name_value\";i:4;s:25:\"field_vm_path_name_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:24:\"field_vm_path_name_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:33:\"VM Path Name (field_vm_path_name)\";s:11:\"title short\";s:12:\"VM Path Name\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_vm_path_name_value\";s:5:\"table\";s:29:\"field_data_field_vm_path_name\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vm_path_name_value\";i:1;s:25:\"field_vm_path_name_format\";}s:10:\"field_name\";s:18:\"field_vm_path_name\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_vm_path_name_value\";s:5:\"table\";s:29:\"field_data_field_vm_path_name\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vm_path_name_value\";i:1;s:25:\"field_vm_path_name_format\";}s:10:\"field_name\";s:18:\"field_vm_path_name\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_vm_path_name_value\";s:5:\"table\";s:29:\"field_data_field_vm_path_name\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vm_path_name_value\";i:1;s:25:\"field_vm_path_name_format\";}s:10:\"field_name\";s:18:\"field_vm_path_name\";}}s:25:\"field_vm_path_name_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:40:\"VM Path Name (field_vm_path_name:format)\";s:11:\"title short\";s:19:\"VM Path Name:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_vm_path_name_format\";s:5:\"table\";s:29:\"field_data_field_vm_path_name\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vm_path_name_value\";i:1;s:25:\"field_vm_path_name_format\";}s:10:\"field_name\";s:18:\"field_vm_path_name\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_vm_path_name_format\";s:5:\"table\";s:29:\"field_data_field_vm_path_name\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vm_path_name_value\";i:1;s:25:\"field_vm_path_name_format\";}s:10:\"field_name\";s:18:\"field_vm_path_name\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_vm_path_name_format\";s:5:\"table\";s:29:\"field_data_field_vm_path_name\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vm_path_name_value\";i:1;s:25:\"field_vm_path_name_format\";}s:10:\"field_name\";s:18:\"field_vm_path_name\";}}}s:33:\"field_revision_field_vm_path_name\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:33:\"field_revision_field_vm_path_name\";i:1;s:30:\"field_vm_path_name-revision_id\";}}}s:30:\"field_vm_path_name-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:12:\"VM Path Name\";s:11:\"title short\";s:12:\"VM Path Name\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:33:\"field_revision_field_vm_path_name\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:18:\"field_vm_path_name\";s:10:\"real field\";s:36:\"field_vm_path_name-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:24:\"field_vm_path_name_value\";i:4;s:25:\"field_vm_path_name_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:24:\"field_vm_path_name_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:33:\"VM Path Name (field_vm_path_name)\";s:11:\"title short\";s:12:\"VM Path Name\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_vm_path_name_value\";s:5:\"table\";s:33:\"field_revision_field_vm_path_name\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vm_path_name_value\";i:1;s:25:\"field_vm_path_name_format\";}s:10:\"field_name\";s:18:\"field_vm_path_name\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_vm_path_name_value\";s:5:\"table\";s:33:\"field_revision_field_vm_path_name\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vm_path_name_value\";i:1;s:25:\"field_vm_path_name_format\";}s:10:\"field_name\";s:18:\"field_vm_path_name\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_vm_path_name_value\";s:5:\"table\";s:33:\"field_revision_field_vm_path_name\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vm_path_name_value\";i:1;s:25:\"field_vm_path_name_format\";}s:10:\"field_name\";s:18:\"field_vm_path_name\";}}s:25:\"field_vm_path_name_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:40:\"VM Path Name (field_vm_path_name:format)\";s:11:\"title short\";s:19:\"VM Path Name:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_vm_path_name_format\";s:5:\"table\";s:33:\"field_revision_field_vm_path_name\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vm_path_name_value\";i:1;s:25:\"field_vm_path_name_format\";}s:10:\"field_name\";s:18:\"field_vm_path_name\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_vm_path_name_format\";s:5:\"table\";s:33:\"field_revision_field_vm_path_name\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vm_path_name_value\";i:1;s:25:\"field_vm_path_name_format\";}s:10:\"field_name\";s:18:\"field_vm_path_name\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_vm_path_name_format\";s:5:\"table\";s:33:\"field_revision_field_vm_path_name\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:24:\"field_vm_path_name_value\";i:1;s:25:\"field_vm_path_name_format\";}s:10:\"field_name\";s:18:\"field_vm_path_name\";}}}s:25:\"field_data_field_template\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:25:\"field_data_field_template\";i:1;s:14:\"field_template\";}}}s:14:\"field_template\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:8:\"Template\";s:11:\"title short\";s:8:\"Template\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:25:\"field_data_field_template\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_template\";s:10:\"real field\";s:20:\"field_template_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_template_value\";i:4;s:21:\"field_template_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:20:\"field_template_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:25:\"Template (field_template)\";s:11:\"title short\";s:8:\"Template\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_template_value\";s:5:\"table\";s:25:\"field_data_field_template\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_template_value\";i:1;s:21:\"field_template_format\";}s:10:\"field_name\";s:14:\"field_template\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_template_value\";s:5:\"table\";s:25:\"field_data_field_template\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_template_value\";i:1;s:21:\"field_template_format\";}s:10:\"field_name\";s:14:\"field_template\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_template_value\";s:5:\"table\";s:25:\"field_data_field_template\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_template_value\";i:1;s:21:\"field_template_format\";}s:10:\"field_name\";s:14:\"field_template\";}}s:21:\"field_template_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:32:\"Template (field_template:format)\";s:11:\"title short\";s:15:\"Template:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_template_format\";s:5:\"table\";s:25:\"field_data_field_template\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_template_value\";i:1;s:21:\"field_template_format\";}s:10:\"field_name\";s:14:\"field_template\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_template_format\";s:5:\"table\";s:25:\"field_data_field_template\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_template_value\";i:1;s:21:\"field_template_format\";}s:10:\"field_name\";s:14:\"field_template\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_template_format\";s:5:\"table\";s:25:\"field_data_field_template\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_template_value\";i:1;s:21:\"field_template_format\";}s:10:\"field_name\";s:14:\"field_template\";}}}s:29:\"field_revision_field_template\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:29:\"field_revision_field_template\";i:1;s:26:\"field_template-revision_id\";}}}s:26:\"field_template-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:8:\"Template\";s:11:\"title short\";s:8:\"Template\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:29:\"field_revision_field_template\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_template\";s:10:\"real field\";s:32:\"field_template-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_template_value\";i:4;s:21:\"field_template_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:20:\"field_template_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:25:\"Template (field_template)\";s:11:\"title short\";s:8:\"Template\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_template_value\";s:5:\"table\";s:29:\"field_revision_field_template\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_template_value\";i:1;s:21:\"field_template_format\";}s:10:\"field_name\";s:14:\"field_template\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_template_value\";s:5:\"table\";s:29:\"field_revision_field_template\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_template_value\";i:1;s:21:\"field_template_format\";}s:10:\"field_name\";s:14:\"field_template\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_template_value\";s:5:\"table\";s:29:\"field_revision_field_template\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_template_value\";i:1;s:21:\"field_template_format\";}s:10:\"field_name\";s:14:\"field_template\";}}s:21:\"field_template_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:32:\"Template (field_template:format)\";s:11:\"title short\";s:15:\"Template:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_template_format\";s:5:\"table\";s:29:\"field_revision_field_template\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_template_value\";i:1;s:21:\"field_template_format\";}s:10:\"field_name\";s:14:\"field_template\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_template_format\";s:5:\"table\";s:29:\"field_revision_field_template\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_template_value\";i:1;s:21:\"field_template_format\";}s:10:\"field_name\";s:14:\"field_template\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_template_format\";s:5:\"table\";s:29:\"field_revision_field_template\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_template_value\";i:1;s:21:\"field_template_format\";}s:10:\"field_name\";s:14:\"field_template\";}}}s:28:\"field_data_field_memory_size\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:28:\"field_data_field_memory_size\";i:1;s:17:\"field_memory_size\";}}}s:17:\"field_memory_size\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:11:\"Memory Size\";s:11:\"title short\";s:11:\"Memory Size\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:28:\"field_data_field_memory_size\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_memory_size\";s:10:\"real field\";s:23:\"field_memory_size_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_memory_size_value\";i:4;s:24:\"field_memory_size_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:23:\"field_memory_size_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:31:\"Memory Size (field_memory_size)\";s:11:\"title short\";s:11:\"Memory Size\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_memory_size_value\";s:5:\"table\";s:28:\"field_data_field_memory_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_memory_size_value\";i:1;s:24:\"field_memory_size_format\";}s:10:\"field_name\";s:17:\"field_memory_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_memory_size_value\";s:5:\"table\";s:28:\"field_data_field_memory_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_memory_size_value\";i:1;s:24:\"field_memory_size_format\";}s:10:\"field_name\";s:17:\"field_memory_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_memory_size_value\";s:5:\"table\";s:28:\"field_data_field_memory_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_memory_size_value\";i:1;s:24:\"field_memory_size_format\";}s:10:\"field_name\";s:17:\"field_memory_size\";}}s:24:\"field_memory_size_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:38:\"Memory Size (field_memory_size:format)\";s:11:\"title short\";s:18:\"Memory Size:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_memory_size_format\";s:5:\"table\";s:28:\"field_data_field_memory_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_memory_size_value\";i:1;s:24:\"field_memory_size_format\";}s:10:\"field_name\";s:17:\"field_memory_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_memory_size_format\";s:5:\"table\";s:28:\"field_data_field_memory_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_memory_size_value\";i:1;s:24:\"field_memory_size_format\";}s:10:\"field_name\";s:17:\"field_memory_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_memory_size_format\";s:5:\"table\";s:28:\"field_data_field_memory_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_memory_size_value\";i:1;s:24:\"field_memory_size_format\";}s:10:\"field_name\";s:17:\"field_memory_size\";}}}s:32:\"field_revision_field_memory_size\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:32:\"field_revision_field_memory_size\";i:1;s:29:\"field_memory_size-revision_id\";}}}s:29:\"field_memory_size-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:11:\"Memory Size\";s:11:\"title short\";s:11:\"Memory Size\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:32:\"field_revision_field_memory_size\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_memory_size\";s:10:\"real field\";s:35:\"field_memory_size-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_memory_size_value\";i:4;s:24:\"field_memory_size_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:23:\"field_memory_size_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:31:\"Memory Size (field_memory_size)\";s:11:\"title short\";s:11:\"Memory Size\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_memory_size_value\";s:5:\"table\";s:32:\"field_revision_field_memory_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_memory_size_value\";i:1;s:24:\"field_memory_size_format\";}s:10:\"field_name\";s:17:\"field_memory_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_memory_size_value\";s:5:\"table\";s:32:\"field_revision_field_memory_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_memory_size_value\";i:1;s:24:\"field_memory_size_format\";}s:10:\"field_name\";s:17:\"field_memory_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_memory_size_value\";s:5:\"table\";s:32:\"field_revision_field_memory_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_memory_size_value\";i:1;s:24:\"field_memory_size_format\";}s:10:\"field_name\";s:17:\"field_memory_size\";}}s:24:\"field_memory_size_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:38:\"Memory Size (field_memory_size:format)\";s:11:\"title short\";s:18:\"Memory Size:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_memory_size_format\";s:5:\"table\";s:32:\"field_revision_field_memory_size\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_memory_size_value\";i:1;s:24:\"field_memory_size_format\";}s:10:\"field_name\";s:17:\"field_memory_size\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_memory_size_format\";s:5:\"table\";s:32:\"field_revision_field_memory_size\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_memory_size_value\";i:1;s:24:\"field_memory_size_format\";}s:10:\"field_name\";s:17:\"field_memory_size\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_memory_size_format\";s:5:\"table\";s:32:\"field_revision_field_memory_size\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_memory_size_value\";i:1;s:24:\"field_memory_size_format\";}s:10:\"field_name\";s:17:\"field_memory_size\";}}}s:30:\"field_data_field_vm_ip_address\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:30:\"field_data_field_vm_ip_address\";i:1;s:19:\"field_vm_ip_address\";}}}s:19:\"field_vm_ip_address\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"IP Address\";s:11:\"title short\";s:10:\"IP Address\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:30:\"field_data_field_vm_ip_address\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_vm_ip_address\";s:10:\"real field\";s:25:\"field_vm_ip_address_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_vm_ip_address_value\";i:4;s:26:\"field_vm_ip_address_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:25:\"field_vm_ip_address_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:32:\"IP Address (field_vm_ip_address)\";s:11:\"title short\";s:10:\"IP Address\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_vm_ip_address_value\";s:5:\"table\";s:30:\"field_data_field_vm_ip_address\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_ip_address_value\";i:1;s:26:\"field_vm_ip_address_format\";}s:10:\"field_name\";s:19:\"field_vm_ip_address\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_vm_ip_address_value\";s:5:\"table\";s:30:\"field_data_field_vm_ip_address\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_ip_address_value\";i:1;s:26:\"field_vm_ip_address_format\";}s:10:\"field_name\";s:19:\"field_vm_ip_address\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_vm_ip_address_value\";s:5:\"table\";s:30:\"field_data_field_vm_ip_address\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_ip_address_value\";i:1;s:26:\"field_vm_ip_address_format\";}s:10:\"field_name\";s:19:\"field_vm_ip_address\";}}s:26:\"field_vm_ip_address_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:39:\"IP Address (field_vm_ip_address:format)\";s:11:\"title short\";s:17:\"IP Address:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_vm_ip_address_format\";s:5:\"table\";s:30:\"field_data_field_vm_ip_address\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_ip_address_value\";i:1;s:26:\"field_vm_ip_address_format\";}s:10:\"field_name\";s:19:\"field_vm_ip_address\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_vm_ip_address_format\";s:5:\"table\";s:30:\"field_data_field_vm_ip_address\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_ip_address_value\";i:1;s:26:\"field_vm_ip_address_format\";}s:10:\"field_name\";s:19:\"field_vm_ip_address\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_vm_ip_address_format\";s:5:\"table\";s:30:\"field_data_field_vm_ip_address\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_ip_address_value\";i:1;s:26:\"field_vm_ip_address_format\";}s:10:\"field_name\";s:19:\"field_vm_ip_address\";}}}s:34:\"field_revision_field_vm_ip_address\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:34:\"field_revision_field_vm_ip_address\";i:1;s:31:\"field_vm_ip_address-revision_id\";}}}s:31:\"field_vm_ip_address-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:10:\"IP Address\";s:11:\"title short\";s:10:\"IP Address\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:5:\"field\";a:9:{s:5:\"table\";s:34:\"field_revision_field_vm_ip_address\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_vm_ip_address\";s:10:\"real field\";s:37:\"field_vm_ip_address-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_vm_ip_address_value\";i:4;s:26:\"field_vm_ip_address_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:25:\"field_vm_ip_address_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:32:\"IP Address (field_vm_ip_address)\";s:11:\"title short\";s:10:\"IP Address\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_vm_ip_address_value\";s:5:\"table\";s:34:\"field_revision_field_vm_ip_address\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_ip_address_value\";i:1;s:26:\"field_vm_ip_address_format\";}s:10:\"field_name\";s:19:\"field_vm_ip_address\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_vm_ip_address_value\";s:5:\"table\";s:34:\"field_revision_field_vm_ip_address\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_ip_address_value\";i:1;s:26:\"field_vm_ip_address_format\";}s:10:\"field_name\";s:19:\"field_vm_ip_address\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_vm_ip_address_value\";s:5:\"table\";s:34:\"field_revision_field_vm_ip_address\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_ip_address_value\";i:1;s:26:\"field_vm_ip_address_format\";}s:10:\"field_name\";s:19:\"field_vm_ip_address\";}}s:26:\"field_vm_ip_address_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:39:\"IP Address (field_vm_ip_address:format)\";s:11:\"title short\";s:17:\"IP Address:format\";s:4:\"help\";s:33:\"Appears in: node:virtual_machine.\";s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_vm_ip_address_format\";s:5:\"table\";s:34:\"field_revision_field_vm_ip_address\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_ip_address_value\";i:1;s:26:\"field_vm_ip_address_format\";}s:10:\"field_name\";s:19:\"field_vm_ip_address\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_vm_ip_address_format\";s:5:\"table\";s:34:\"field_revision_field_vm_ip_address\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_ip_address_value\";i:1;s:26:\"field_vm_ip_address_format\";}s:10:\"field_name\";s:19:\"field_vm_ip_address\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_vm_ip_address_format\";s:5:\"table\";s:34:\"field_revision_field_vm_ip_address\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_vm_ip_address_value\";i:1;s:26:\"field_vm_ip_address_format\";}s:10:\"field_name\";s:19:\"field_vm_ip_address\";}}}s:25:\"field_data_field_password\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:25:\"field_data_field_password\";i:1;s:14:\"field_password\";}}}s:14:\"field_password\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:8:\"Password\";s:11:\"title short\";s:8:\"Password\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:5:\"field\";a:9:{s:5:\"table\";s:25:\"field_data_field_password\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_password\";s:10:\"real field\";s:20:\"field_password_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_password_value\";i:4;s:21:\"field_password_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:20:\"field_password_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:25:\"Password (field_password)\";s:11:\"title short\";s:8:\"Password\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_password_value\";s:5:\"table\";s:25:\"field_data_field_password\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_password_value\";i:1;s:21:\"field_password_format\";}s:10:\"field_name\";s:14:\"field_password\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_password_value\";s:5:\"table\";s:25:\"field_data_field_password\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_password_value\";i:1;s:21:\"field_password_format\";}s:10:\"field_name\";s:14:\"field_password\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_password_value\";s:5:\"table\";s:25:\"field_data_field_password\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_password_value\";i:1;s:21:\"field_password_format\";}s:10:\"field_name\";s:14:\"field_password\";}}s:21:\"field_password_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:32:\"Password (field_password:format)\";s:11:\"title short\";s:15:\"Password:format\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_password_format\";s:5:\"table\";s:25:\"field_data_field_password\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_password_value\";i:1;s:21:\"field_password_format\";}s:10:\"field_name\";s:14:\"field_password\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_password_format\";s:5:\"table\";s:25:\"field_data_field_password\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_password_value\";i:1;s:21:\"field_password_format\";}s:10:\"field_name\";s:14:\"field_password\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_password_format\";s:5:\"table\";s:25:\"field_data_field_password\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_password_value\";i:1;s:21:\"field_password_format\";}s:10:\"field_name\";s:14:\"field_password\";}}}s:29:\"field_revision_field_password\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:29:\"field_revision_field_password\";i:1;s:26:\"field_password-revision_id\";}}}s:26:\"field_password-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:8:\"Password\";s:11:\"title short\";s:8:\"Password\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:5:\"field\";a:9:{s:5:\"table\";s:29:\"field_revision_field_password\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_password\";s:10:\"real field\";s:32:\"field_password-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_password_value\";i:4;s:21:\"field_password_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:20:\"field_password_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:25:\"Password (field_password)\";s:11:\"title short\";s:8:\"Password\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_password_value\";s:5:\"table\";s:29:\"field_revision_field_password\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_password_value\";i:1;s:21:\"field_password_format\";}s:10:\"field_name\";s:14:\"field_password\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_password_value\";s:5:\"table\";s:29:\"field_revision_field_password\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_password_value\";i:1;s:21:\"field_password_format\";}s:10:\"field_name\";s:14:\"field_password\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_password_value\";s:5:\"table\";s:29:\"field_revision_field_password\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_password_value\";i:1;s:21:\"field_password_format\";}s:10:\"field_name\";s:14:\"field_password\";}}s:21:\"field_password_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:32:\"Password (field_password:format)\";s:11:\"title short\";s:15:\"Password:format\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_password_format\";s:5:\"table\";s:29:\"field_revision_field_password\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_password_value\";i:1;s:21:\"field_password_format\";}s:10:\"field_name\";s:14:\"field_password\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_password_format\";s:5:\"table\";s:29:\"field_revision_field_password\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_password_value\";i:1;s:21:\"field_password_format\";}s:10:\"field_name\";s:14:\"field_password\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_password_format\";s:5:\"table\";s:29:\"field_revision_field_password\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_password_value\";i:1;s:21:\"field_password_format\";}s:10:\"field_name\";s:14:\"field_password\";}}}s:25:\"field_data_field_username\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:25:\"field_data_field_username\";i:1;s:14:\"field_username\";}}}s:14:\"field_username\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:8:\"Username\";s:11:\"title short\";s:8:\"Username\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:5:\"field\";a:9:{s:5:\"table\";s:25:\"field_data_field_username\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_username\";s:10:\"real field\";s:20:\"field_username_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_username_value\";i:4;s:21:\"field_username_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:20:\"field_username_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:25:\"Username (field_username)\";s:11:\"title short\";s:8:\"Username\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_username_value\";s:5:\"table\";s:25:\"field_data_field_username\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_username_value\";i:1;s:21:\"field_username_format\";}s:10:\"field_name\";s:14:\"field_username\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_username_value\";s:5:\"table\";s:25:\"field_data_field_username\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_username_value\";i:1;s:21:\"field_username_format\";}s:10:\"field_name\";s:14:\"field_username\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_username_value\";s:5:\"table\";s:25:\"field_data_field_username\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_username_value\";i:1;s:21:\"field_username_format\";}s:10:\"field_name\";s:14:\"field_username\";}}s:21:\"field_username_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:32:\"Username (field_username:format)\";s:11:\"title short\";s:15:\"Username:format\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_username_format\";s:5:\"table\";s:25:\"field_data_field_username\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_username_value\";i:1;s:21:\"field_username_format\";}s:10:\"field_name\";s:14:\"field_username\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_username_format\";s:5:\"table\";s:25:\"field_data_field_username\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_username_value\";i:1;s:21:\"field_username_format\";}s:10:\"field_name\";s:14:\"field_username\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_username_format\";s:5:\"table\";s:25:\"field_data_field_username\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_username_value\";i:1;s:21:\"field_username_format\";}s:10:\"field_name\";s:14:\"field_username\";}}}s:29:\"field_revision_field_username\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:29:\"field_revision_field_username\";i:1;s:26:\"field_username-revision_id\";}}}s:26:\"field_username-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:8:\"Username\";s:11:\"title short\";s:8:\"Username\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:5:\"field\";a:9:{s:5:\"table\";s:29:\"field_revision_field_username\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_username\";s:10:\"real field\";s:32:\"field_username-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:20:\"field_username_value\";i:4;s:21:\"field_username_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:20:\"field_username_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:25:\"Username (field_username)\";s:11:\"title short\";s:8:\"Username\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:20:\"field_username_value\";s:5:\"table\";s:29:\"field_revision_field_username\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_username_value\";i:1;s:21:\"field_username_format\";}s:10:\"field_name\";s:14:\"field_username\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:20:\"field_username_value\";s:5:\"table\";s:29:\"field_revision_field_username\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_username_value\";i:1;s:21:\"field_username_format\";}s:10:\"field_name\";s:14:\"field_username\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:20:\"field_username_value\";s:5:\"table\";s:29:\"field_revision_field_username\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_username_value\";i:1;s:21:\"field_username_format\";}s:10:\"field_name\";s:14:\"field_username\";}}s:21:\"field_username_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:32:\"Username (field_username:format)\";s:11:\"title short\";s:15:\"Username:format\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_username_format\";s:5:\"table\";s:29:\"field_revision_field_username\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_username_value\";i:1;s:21:\"field_username_format\";}s:10:\"field_name\";s:14:\"field_username\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_username_format\";s:5:\"table\";s:29:\"field_revision_field_username\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_username_value\";i:1;s:21:\"field_username_format\";}s:10:\"field_name\";s:14:\"field_username\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_username_format\";s:5:\"table\";s:29:\"field_revision_field_username\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:20:\"field_username_value\";i:1;s:21:\"field_username_format\";}s:10:\"field_name\";s:14:\"field_username\";}}}s:27:\"field_data_field_ip_address\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:27:\"field_data_field_ip_address\";i:1;s:16:\"field_ip_address\";}}}s:16:\"field_ip_address\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"IP Address\";s:11:\"title short\";s:10:\"IP Address\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:5:\"field\";a:9:{s:5:\"table\";s:27:\"field_data_field_ip_address\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_ip_address\";s:10:\"real field\";s:22:\"field_ip_address_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_ip_address_value\";i:4;s:23:\"field_ip_address_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:22:\"field_ip_address_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:29:\"IP Address (field_ip_address)\";s:11:\"title short\";s:10:\"IP Address\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_ip_address_value\";s:5:\"table\";s:27:\"field_data_field_ip_address\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_ip_address_value\";i:1;s:23:\"field_ip_address_format\";}s:10:\"field_name\";s:16:\"field_ip_address\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_ip_address_value\";s:5:\"table\";s:27:\"field_data_field_ip_address\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_ip_address_value\";i:1;s:23:\"field_ip_address_format\";}s:10:\"field_name\";s:16:\"field_ip_address\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_ip_address_value\";s:5:\"table\";s:27:\"field_data_field_ip_address\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_ip_address_value\";i:1;s:23:\"field_ip_address_format\";}s:10:\"field_name\";s:16:\"field_ip_address\";}}s:23:\"field_ip_address_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:36:\"IP Address (field_ip_address:format)\";s:11:\"title short\";s:17:\"IP Address:format\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_ip_address_format\";s:5:\"table\";s:27:\"field_data_field_ip_address\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_ip_address_value\";i:1;s:23:\"field_ip_address_format\";}s:10:\"field_name\";s:16:\"field_ip_address\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_ip_address_format\";s:5:\"table\";s:27:\"field_data_field_ip_address\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_ip_address_value\";i:1;s:23:\"field_ip_address_format\";}s:10:\"field_name\";s:16:\"field_ip_address\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_ip_address_format\";s:5:\"table\";s:27:\"field_data_field_ip_address\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_ip_address_value\";i:1;s:23:\"field_ip_address_format\";}s:10:\"field_name\";s:16:\"field_ip_address\";}}}s:31:\"field_revision_field_ip_address\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:31:\"field_revision_field_ip_address\";i:1;s:28:\"field_ip_address-revision_id\";}}}s:28:\"field_ip_address-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:10:\"IP Address\";s:11:\"title short\";s:10:\"IP Address\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:5:\"field\";a:9:{s:5:\"table\";s:31:\"field_revision_field_ip_address\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_ip_address\";s:10:\"real field\";s:34:\"field_ip_address-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:22:\"field_ip_address_value\";i:4;s:23:\"field_ip_address_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:22:\"field_ip_address_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:29:\"IP Address (field_ip_address)\";s:11:\"title short\";s:10:\"IP Address\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:22:\"field_ip_address_value\";s:5:\"table\";s:31:\"field_revision_field_ip_address\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_ip_address_value\";i:1;s:23:\"field_ip_address_format\";}s:10:\"field_name\";s:16:\"field_ip_address\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:22:\"field_ip_address_value\";s:5:\"table\";s:31:\"field_revision_field_ip_address\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_ip_address_value\";i:1;s:23:\"field_ip_address_format\";}s:10:\"field_name\";s:16:\"field_ip_address\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:22:\"field_ip_address_value\";s:5:\"table\";s:31:\"field_revision_field_ip_address\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_ip_address_value\";i:1;s:23:\"field_ip_address_format\";}s:10:\"field_name\";s:16:\"field_ip_address\";}}s:23:\"field_ip_address_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:36:\"IP Address (field_ip_address:format)\";s:11:\"title short\";s:17:\"IP Address:format\";s:4:\"help\";s:25:\"Appears in: node:vcenter.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_ip_address_format\";s:5:\"table\";s:31:\"field_revision_field_ip_address\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_ip_address_value\";i:1;s:23:\"field_ip_address_format\";}s:10:\"field_name\";s:16:\"field_ip_address\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_ip_address_format\";s:5:\"table\";s:31:\"field_revision_field_ip_address\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_ip_address_value\";i:1;s:23:\"field_ip_address_format\";}s:10:\"field_name\";s:16:\"field_ip_address\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:23:\"field_ip_address_format\";s:5:\"table\";s:31:\"field_revision_field_ip_address\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:22:\"field_ip_address_value\";i:1;s:23:\"field_ip_address_format\";}s:10:\"field_name\";s:16:\"field_ip_address\";}}}s:21:\"field_data_field_tags\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:21:\"field_data_field_tags\";i:1;s:10:\"field_tags\";}}}s:10:\"field_tags\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:4:\"Tags\";s:11:\"title short\";s:4:\"Tags\";s:4:\"help\";s:25:\"Appears in: node:article.\";s:5:\"field\";a:9:{s:5:\"table\";s:21:\"field_data_field_tags\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:10:\"field_tags\";s:10:\"real field\";s:14:\"field_tags_tid\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:14:\"field_tags_tid\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:14:\"field_tags_tid\";a:8:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:17:\"Tags (field_tags)\";s:11:\"title short\";s:4:\"Tags\";s:4:\"help\";s:25:\"Appears in: node:article.\";s:8:\"argument\";a:6:{s:5:\"field\";s:14:\"field_tags_tid\";s:5:\"table\";s:21:\"field_data_field_tags\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:10:\"field_name\";s:10:\"field_tags\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:7:{s:5:\"field\";s:14:\"field_tags_tid\";s:5:\"table\";s:21:\"field_data_field_tags\";s:7:\"handler\";s:34:\"views_handler_filter_term_node_tid\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:10:\"field_name\";s:10:\"field_tags\";s:11:\"allow empty\";b:1;s:10:\"vocabulary\";s:4:\"tags\";}s:4:\"sort\";a:5:{s:5:\"field\";s:14:\"field_tags_tid\";s:5:\"table\";s:21:\"field_data_field_tags\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:10:\"field_name\";s:10:\"field_tags\";}s:12:\"relationship\";a:4:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:18:\"taxonomy_term_data\";s:10:\"base field\";s:3:\"tid\";s:5:\"label\";s:20:\"term from field_tags\";}}s:5:\"delta\";a:8:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:23:\"Tags (field_tags:delta)\";s:11:\"title short\";s:10:\"Tags:delta\";s:4:\"help\";s:33:\"Delta - Appears in: node:article.\";s:5:\"field\";a:1:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";}s:8:\"argument\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:21:\"field_data_field_tags\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:16:\"empty field name\";s:12:\"- No value -\";s:10:\"field_name\";s:10:\"field_tags\";}s:6:\"filter\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:21:\"field_data_field_tags\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:10:\"field_name\";s:10:\"field_tags\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:21:\"field_data_field_tags\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:10:\"field_name\";s:10:\"field_tags\";}}}s:25:\"field_revision_field_tags\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:25:\"field_revision_field_tags\";i:1;s:22:\"field_tags-revision_id\";}}}s:22:\"field_tags-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:4:\"Tags\";s:11:\"title short\";s:4:\"Tags\";s:4:\"help\";s:25:\"Appears in: node:article.\";s:5:\"field\";a:9:{s:5:\"table\";s:25:\"field_revision_field_tags\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:10:\"field_tags\";s:10:\"real field\";s:26:\"field_tags-revision_id_tid\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:14:\"field_tags_tid\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:14:\"field_tags_tid\";a:8:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:17:\"Tags (field_tags)\";s:11:\"title short\";s:4:\"Tags\";s:4:\"help\";s:25:\"Appears in: node:article.\";s:8:\"argument\";a:6:{s:5:\"field\";s:14:\"field_tags_tid\";s:5:\"table\";s:25:\"field_revision_field_tags\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:10:\"field_name\";s:10:\"field_tags\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:7:{s:5:\"field\";s:14:\"field_tags_tid\";s:5:\"table\";s:25:\"field_revision_field_tags\";s:7:\"handler\";s:34:\"views_handler_filter_term_node_tid\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:10:\"field_name\";s:10:\"field_tags\";s:11:\"allow empty\";b:1;s:10:\"vocabulary\";s:4:\"tags\";}s:4:\"sort\";a:5:{s:5:\"field\";s:14:\"field_tags_tid\";s:5:\"table\";s:25:\"field_revision_field_tags\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:10:\"field_name\";s:10:\"field_tags\";}s:12:\"relationship\";a:4:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:18:\"taxonomy_term_data\";s:10:\"base field\";s:3:\"tid\";s:5:\"label\";s:20:\"term from field_tags\";}}s:5:\"delta\";a:8:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:23:\"Tags (field_tags:delta)\";s:11:\"title short\";s:10:\"Tags:delta\";s:4:\"help\";s:33:\"Delta - Appears in: node:article.\";s:5:\"field\";a:1:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";}s:8:\"argument\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:25:\"field_revision_field_tags\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:16:\"empty field name\";s:12:\"- No value -\";s:10:\"field_name\";s:10:\"field_tags\";}s:6:\"filter\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:25:\"field_revision_field_tags\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:10:\"field_name\";s:10:\"field_tags\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:25:\"field_revision_field_tags\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:10:\"field_name\";s:10:\"field_tags\";}}}s:15:\"field_data_body\";a:6:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:15:\"field_data_body\";i:1;s:4:\"body\";}}}s:4:\"body\";a:6:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:11:\"Description\";s:11:\"title short\";s:11:\"Description\";s:4:\"help\";s:120:\"Appears in: node:page, node:article, node:vcenter, node:data_center. Also known as: Content: Body, Content: Description.\";s:7:\"aliases\";a:1:{i:0;a:4:{s:4:\"base\";s:4:\"node\";s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:4:\"Body\";s:4:\"help\";s:41:\"This is an alias of Content: Description.\";}}s:5:\"field\";a:9:{s:5:\"table\";s:15:\"field_data_body\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:4:\"body\";s:10:\"real field\";s:10:\"body_value\";s:17:\"additional fields\";a:6:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:10:\"body_value\";i:4;s:12:\"body_summary\";i:5;s:11:\"body_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:10:\"body_value\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:18:\"Description (body)\";s:11:\"title short\";s:11:\"Description\";s:4:\"help\";s:141:\"Appears in: node:page, node:article, node:vcenter, node:data_center. Also known as: Content: Description (body), Content: Description (body).\";s:7:\"aliases\";a:1:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:11:\"Body (body)\";s:4:\"help\";s:48:\"This is an alias of Content: Description (body).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:10:\"body_value\";s:5:\"table\";s:15:\"field_data_body\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:10:\"body_value\";s:5:\"table\";s:15:\"field_data_body\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"allow empty\";b:1;}}s:12:\"body_summary\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:26:\"Description (body:summary)\";s:11:\"title short\";s:19:\"Description:summary\";s:4:\"help\";s:157:\"Appears in: node:page, node:article, node:vcenter, node:data_center. Also known as: Content: Description (body:summary), Content: Description (body:summary).\";s:7:\"aliases\";a:1:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:19:\"Body (body:summary)\";s:4:\"help\";s:56:\"This is an alias of Content: Description (body:summary).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:12:\"body_summary\";s:5:\"table\";s:15:\"field_data_body\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:12:\"body_summary\";s:5:\"table\";s:15:\"field_data_body\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"allow empty\";b:1;}}s:11:\"body_format\";a:8:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:25:\"Description (body:format)\";s:11:\"title short\";s:18:\"Description:format\";s:4:\"help\";s:155:\"Appears in: node:page, node:article, node:vcenter, node:data_center. Also known as: Content: Description (body:format), Content: Description (body:format).\";s:7:\"aliases\";a:1:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:18:\"Body (body:format)\";s:4:\"help\";s:55:\"This is an alias of Content: Description (body:format).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:15:\"field_data_body\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:15:\"field_data_body\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:15:\"field_data_body\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";}}}s:19:\"field_revision_body\";a:6:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:19:\"field_revision_body\";i:1;s:16:\"body-revision_id\";}}}s:16:\"body-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:11:\"Description\";s:11:\"title short\";s:11:\"Description\";s:4:\"help\";s:68:\"Appears in: node:page, node:article, node:vcenter, node:data_center.\";s:5:\"field\";a:9:{s:5:\"table\";s:19:\"field_revision_body\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:4:\"body\";s:10:\"real field\";s:22:\"body-revision_id_value\";s:17:\"additional fields\";a:6:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:10:\"body_value\";i:4;s:12:\"body_summary\";i:5;s:11:\"body_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:10:\"body_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:18:\"Description (body)\";s:11:\"title short\";s:11:\"Description\";s:4:\"help\";s:141:\"Appears in: node:page, node:article, node:vcenter, node:data_center. Also known as: Content: Description (body), Content: Description (body).\";s:7:\"aliases\";a:1:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:11:\"Body (body)\";s:4:\"help\";s:48:\"This is an alias of Content: Description (body).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:10:\"body_value\";s:5:\"table\";s:19:\"field_revision_body\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:10:\"body_value\";s:5:\"table\";s:19:\"field_revision_body\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"allow empty\";b:1;}}s:12:\"body_summary\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:26:\"Description (body:summary)\";s:11:\"title short\";s:19:\"Description:summary\";s:4:\"help\";s:157:\"Appears in: node:page, node:article, node:vcenter, node:data_center. Also known as: Content: Description (body:summary), Content: Description (body:summary).\";s:7:\"aliases\";a:1:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:19:\"Body (body:summary)\";s:4:\"help\";s:56:\"This is an alias of Content: Description (body:summary).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:12:\"body_summary\";s:5:\"table\";s:19:\"field_revision_body\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:12:\"body_summary\";s:5:\"table\";s:19:\"field_revision_body\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"allow empty\";b:1;}}s:11:\"body_format\";a:8:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:25:\"Description (body:format)\";s:11:\"title short\";s:18:\"Description:format\";s:4:\"help\";s:155:\"Appears in: node:page, node:article, node:vcenter, node:data_center. Also known as: Content: Description (body:format), Content: Description (body:format).\";s:7:\"aliases\";a:1:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:18:\"Body (body:format)\";s:4:\"help\";s:55:\"This is an alias of Content: Description (body:format).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:19:\"field_revision_body\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:19:\"field_revision_body\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:19:\"field_revision_body\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";}}}s:23:\"field_data_comment_body\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:7:\"comment\";a:3:{s:10:\"left_field\";s:3:\"cid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:7:\"comment\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:23:\"field_data_comment_body\";i:1;s:12:\"comment_body\";}}}s:12:\"comment_body\";a:5:{s:5:\"group\";s:7:\"Comment\";s:5:\"title\";s:7:\"Comment\";s:11:\"title short\";s:7:\"Comment\";s:4:\"help\";s:388:\"Appears in: comment:comment_node_page, comment:comment_node_article, comment:comment_node_vcenter, comment:comment_node_data_center, comment:comment_node_virtual_machine, comment:comment_node_host, comment:comment_node_device, comment:comment_node_vdisk, comment:comment_node_panel, comment:comment_node_vm_metrics, comment:comment_node_vdisk_metrics, comment:comment_node_vm_cache_space.\";s:5:\"field\";a:9:{s:5:\"table\";s:23:\"field_data_comment_body\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:12:\"comment_body\";s:10:\"real field\";s:18:\"comment_body_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:18:\"comment_body_value\";i:4;s:19:\"comment_body_format\";}s:13:\"entity_tables\";a:1:{s:7:\"comment\";s:7:\"comment\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:18:\"comment_body_value\";a:6:{s:5:\"group\";s:7:\"Comment\";s:5:\"title\";s:22:\"Comment (comment_body)\";s:11:\"title short\";s:7:\"Comment\";s:4:\"help\";s:388:\"Appears in: comment:comment_node_page, comment:comment_node_article, comment:comment_node_vcenter, comment:comment_node_data_center, comment:comment_node_virtual_machine, comment:comment_node_host, comment:comment_node_device, comment:comment_node_vdisk, comment:comment_node_panel, comment:comment_node_vm_metrics, comment:comment_node_vdisk_metrics, comment:comment_node_vm_cache_space.\";s:8:\"argument\";a:6:{s:5:\"field\";s:18:\"comment_body_value\";s:5:\"table\";s:23:\"field_data_comment_body\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:18:\"comment_body_value\";i:1;s:19:\"comment_body_format\";}s:10:\"field_name\";s:12:\"comment_body\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:18:\"comment_body_value\";s:5:\"table\";s:23:\"field_data_comment_body\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:18:\"comment_body_value\";i:1;s:19:\"comment_body_format\";}s:10:\"field_name\";s:12:\"comment_body\";s:11:\"allow empty\";b:1;}}s:19:\"comment_body_format\";a:7:{s:5:\"group\";s:7:\"Comment\";s:5:\"title\";s:29:\"Comment (comment_body:format)\";s:11:\"title short\";s:14:\"Comment:format\";s:4:\"help\";s:388:\"Appears in: comment:comment_node_page, comment:comment_node_article, comment:comment_node_vcenter, comment:comment_node_data_center, comment:comment_node_virtual_machine, comment:comment_node_host, comment:comment_node_device, comment:comment_node_vdisk, comment:comment_node_panel, comment:comment_node_vm_metrics, comment:comment_node_vdisk_metrics, comment:comment_node_vm_cache_space.\";s:8:\"argument\";a:6:{s:5:\"field\";s:19:\"comment_body_format\";s:5:\"table\";s:23:\"field_data_comment_body\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:18:\"comment_body_value\";i:1;s:19:\"comment_body_format\";}s:10:\"field_name\";s:12:\"comment_body\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:19:\"comment_body_format\";s:5:\"table\";s:23:\"field_data_comment_body\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:18:\"comment_body_value\";i:1;s:19:\"comment_body_format\";}s:10:\"field_name\";s:12:\"comment_body\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:19:\"comment_body_format\";s:5:\"table\";s:23:\"field_data_comment_body\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:18:\"comment_body_value\";i:1;s:19:\"comment_body_format\";}s:10:\"field_name\";s:12:\"comment_body\";}}}s:14:\"filter_formats\";a:1:{s:8:\"moved to\";s:13:\"filter_format\";}s:13:\"filter_format\";a:1:{s:5:\"table\";a:1:{s:4:\"join\";a:2:{s:13:\"node_revision\";a:2:{s:10:\"left_field\";s:6:\"format\";s:5:\"field\";s:6:\"format\";}s:4:\"node\";a:3:{s:10:\"left_table\";s:13:\"node_revision\";s:10:\"left_field\";s:6:\"format\";s:5:\"field\";s:6:\"format\";}}}}s:14:\"node_revisions\";a:2:{s:8:\"moved to\";s:13:\"node_revision\";s:4:\"body\";a:1:{s:8:\"moved to\";a:2:{i:0;s:19:\"field_revision_data\";i:1;s:16:\"body-revision_id\";}}}s:11:\"node_access\";a:2:{s:5:\"table\";a:2:{s:5:\"group\";s:14:\"Content access\";s:4:\"join\";a:1:{s:4:\"node\";a:2:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:3:\"nid\";}}}s:3:\"nid\";a:3:{s:5:\"title\";s:6:\"Access\";s:4:\"help\";s:17:\"Filter by access.\";s:6:\"filter\";a:2:{s:7:\"handler\";s:32:\"views_handler_filter_node_access\";s:4:\"help\";s:107:\"Filter for content by view access. <strong>Not necessary if you are using node as your base table.</strong>\";}}}s:12:\"history_user\";a:1:{s:8:\"moved to\";s:7:\"history\";}s:7:\"history\";a:2:{s:5:\"table\";a:2:{s:5:\"group\";s:7:\"Content\";s:4:\"join\";a:1:{s:4:\"node\";a:4:{s:5:\"table\";s:7:\"history\";s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:3:\"nid\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:3:\"uid\";s:5:\"value\";s:18:\"***CURRENT_USER***\";s:7:\"numeric\";b:1;}}}}}s:9:\"timestamp\";a:3:{s:5:\"title\";s:15:\"Has new content\";s:5:\"field\";a:2:{s:7:\"handler\";s:42:\"views_handler_field_history_user_timestamp\";s:4:\"help\";s:47:\"Show a marker if the content is new or updated.\";}s:6:\"filter\";a:2:{s:4:\"help\";s:41:\"Show only content that is new or updated.\";s:7:\"handler\";s:43:\"views_handler_filter_history_user_timestamp\";}}}s:12:\"search_index\";a:3:{s:5:\"table\";a:2:{s:5:\"group\";s:6:\"Search\";s:4:\"join\";a:1:{s:4:\"node\";a:2:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:3:\"sid\";}}}s:5:\"score\";a:4:{s:5:\"title\";s:5:\"Score\";s:4:\"help\";s:93:\"The score of the search item. This will not be used if the search filter is not also present.\";s:5:\"field\";a:4:{s:7:\"handler\";s:32:\"views_handler_field_search_score\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;s:11:\"no group by\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:31:\"views_handler_sort_search_score\";s:11:\"no group by\";b:1;}}s:4:\"keys\";a:4:{s:5:\"title\";s:12:\"Search Terms\";s:4:\"help\";s:24:\"The terms to search for.\";s:6:\"filter\";a:2:{s:7:\"handler\";s:27:\"views_handler_filter_search\";s:11:\"no group by\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:29:\"views_handler_argument_search\";s:11:\"no group by\";b:1;}}}s:12:\"search_total\";a:1:{s:5:\"table\";a:1:{s:4:\"join\";a:2:{s:4:\"node\";a:3:{s:10:\"left_table\";s:12:\"search_index\";s:10:\"left_field\";s:4:\"word\";s:5:\"field\";s:4:\"word\";}s:5:\"users\";a:3:{s:10:\"left_table\";s:12:\"search_index\";s:10:\"left_field\";s:4:\"word\";s:5:\"field\";s:4:\"word\";}}}}s:14:\"search_dataset\";a:1:{s:5:\"table\";a:1:{s:4:\"join\";a:2:{s:4:\"node\";a:5:{s:10:\"left_table\";s:12:\"search_index\";s:10:\"left_field\";s:3:\"sid\";s:5:\"field\";s:3:\"sid\";s:5:\"extra\";s:39:\"search_index.type = search_dataset.type\";s:4:\"type\";s:5:\"INNER\";}s:5:\"users\";a:5:{s:10:\"left_table\";s:12:\"search_index\";s:10:\"left_field\";s:3:\"sid\";s:5:\"field\";s:3:\"sid\";s:5:\"extra\";s:39:\"search_index.type = search_dataset.type\";s:4:\"type\";s:5:\"INNER\";}}}}s:22:\"search_node_links_from\";a:2:{s:5:\"table\";a:2:{s:5:\"group\";s:6:\"Search\";s:4:\"join\";a:1:{s:4:\"node\";a:1:{s:9:\"arguments\";a:6:{i:0;s:17:\"search_node_links\";i:1;s:4:\"node\";i:2;s:3:\"nid\";i:3;s:3:\"nid\";i:4;N;i:5;s:5:\"INNER\";}}}}s:3:\"sid\";a:4:{s:5:\"title\";s:10:\"Links from\";s:4:\"help\";s:42:\"Other nodes that are linked from the node.\";s:8:\"argument\";a:1:{s:7:\"handler\";s:31:\"views_handler_argument_node_nid\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:29:\"views_handler_filter_equality\";}}}s:20:\"search_node_links_to\";a:2:{s:5:\"table\";a:2:{s:5:\"group\";s:6:\"Search\";s:4:\"join\";a:1:{s:4:\"node\";a:1:{s:9:\"arguments\";a:6:{i:0;s:17:\"search_node_links\";i:1;s:4:\"node\";i:2;s:3:\"nid\";i:3;s:3:\"sid\";i:4;N;i:5;s:5:\"INNER\";}}}}s:3:\"nid\";a:4:{s:5:\"title\";s:8:\"Links to\";s:4:\"help\";s:34:\"Other nodes that link to the node.\";s:8:\"argument\";a:1:{s:7:\"handler\";s:31:\"views_handler_argument_node_nid\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:29:\"views_handler_filter_equality\";}}}s:5:\"files\";a:1:{s:8:\"moved to\";s:12:\"file_managed\";}s:10:\"file_usage\";a:15:{s:5:\"table\";a:2:{s:5:\"group\";s:10:\"File Usage\";s:4:\"join\";a:6:{s:12:\"file_managed\";a:2:{s:5:\"field\";s:3:\"fid\";s:10:\"left_field\";s:3:\"fid\";}s:4:\"node\";a:3:{s:5:\"field\";s:2:\"id\";s:10:\"left_field\";s:3:\"nid\";s:5:\"extra\";a:1:{i:0;a:2:{s:5:\"field\";s:4:\"type\";s:5:\"value\";s:4:\"node\";}}}s:5:\"users\";a:3:{s:5:\"field\";s:2:\"id\";s:10:\"left_field\";s:3:\"uid\";s:5:\"extra\";a:1:{i:0;a:2:{s:5:\"field\";s:4:\"type\";s:5:\"value\";s:4:\"user\";}}}s:7:\"comment\";a:3:{s:5:\"field\";s:2:\"id\";s:10:\"left_field\";s:3:\"cid\";s:5:\"extra\";a:1:{i:0;a:2:{s:5:\"field\";s:4:\"type\";s:5:\"value\";s:7:\"comment\";}}}s:18:\"taxonomy_term_data\";a:3:{s:5:\"field\";s:2:\"id\";s:10:\"left_field\";s:3:\"tid\";s:5:\"extra\";a:1:{i:0;a:2:{s:5:\"field\";s:4:\"type\";s:5:\"value\";s:13:\"taxonomy_term\";}}}s:19:\"taxonomy_vocabulary\";a:3:{s:5:\"field\";s:2:\"id\";s:10:\"left_field\";s:3:\"vid\";s:5:\"extra\";a:1:{i:0;a:2:{s:5:\"field\";s:4:\"type\";s:5:\"value\";s:19:\"taxonomy_vocabulary\";}}}}}s:12:\"file_to_node\";a:5:{s:5:\"title\";s:7:\"Content\";s:4:\"help\";s:98:\"Content that is associated with this file, usually because this file is in a field on the content.\";s:9:\"skip base\";a:6:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";i:2;s:5:\"users\";i:3;s:7:\"comment\";i:4;s:18:\"taxonomy_term_data\";i:5;s:19:\"taxonomy_vocabulary\";}s:10:\"real field\";s:2:\"id\";s:12:\"relationship\";a:6:{s:5:\"title\";s:7:\"Content\";s:5:\"label\";s:7:\"Content\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:2:\"id\";s:5:\"extra\";a:1:{i:0;a:4:{s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:4:\"type\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:4:\"node\";}}}}s:12:\"node_to_file\";a:5:{s:5:\"title\";s:4:\"File\";s:4:\"help\";s:87:\"A file that is associated with this node, usually because it is in a field on the node.\";s:9:\"skip base\";a:5:{i:0;s:12:\"file_managed\";i:1;s:5:\"users\";i:2;s:7:\"comment\";i:3;s:18:\"taxonomy_term_data\";i:4;s:19:\"taxonomy_vocabulary\";}s:10:\"real field\";s:3:\"fid\";s:12:\"relationship\";a:5:{s:5:\"title\";s:4:\"File\";s:5:\"label\";s:4:\"File\";s:4:\"base\";s:12:\"file_managed\";s:10:\"base field\";s:3:\"fid\";s:18:\"relationship field\";s:3:\"fid\";}}s:12:\"file_to_user\";a:5:{s:5:\"title\";s:4:\"User\";s:4:\"help\";s:94:\"A user that is associated with this file, usually because this file is in a field on the user.\";s:9:\"skip base\";a:6:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";i:2;s:5:\"users\";i:3;s:7:\"comment\";i:4;s:18:\"taxonomy_term_data\";i:5;s:19:\"taxonomy_vocabulary\";}s:10:\"real field\";s:2:\"id\";s:12:\"relationship\";a:6:{s:5:\"title\";s:4:\"User\";s:5:\"label\";s:4:\"User\";s:4:\"base\";s:5:\"users\";s:10:\"base field\";s:3:\"uid\";s:18:\"relationship field\";s:2:\"id\";s:5:\"extra\";a:1:{i:0;a:4:{s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:4:\"type\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:4:\"user\";}}}}s:12:\"user_to_file\";a:5:{s:5:\"title\";s:4:\"File\";s:4:\"help\";s:87:\"A file that is associated with this user, usually because it is in a field on the user.\";s:9:\"skip base\";a:6:{i:0;s:12:\"file_managed\";i:1;s:4:\"node\";i:2;s:13:\"node_revision\";i:3;s:7:\"comment\";i:4;s:18:\"taxonomy_term_data\";i:5;s:19:\"taxonomy_vocabulary\";}s:10:\"real field\";s:3:\"fid\";s:12:\"relationship\";a:5:{s:5:\"title\";s:4:\"File\";s:5:\"label\";s:4:\"File\";s:4:\"base\";s:12:\"file_managed\";s:10:\"base field\";s:3:\"fid\";s:18:\"relationship field\";s:3:\"fid\";}}s:15:\"file_to_comment\";a:5:{s:5:\"title\";s:7:\"Comment\";s:4:\"help\";s:100:\"A comment that is associated with this file, usually because this file is in a field on the comment.\";s:9:\"skip base\";a:6:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";i:2;s:5:\"users\";i:3;s:7:\"comment\";i:4;s:18:\"taxonomy_term_data\";i:5;s:19:\"taxonomy_vocabulary\";}s:10:\"real field\";s:2:\"id\";s:12:\"relationship\";a:6:{s:5:\"title\";s:7:\"Comment\";s:5:\"label\";s:7:\"Comment\";s:4:\"base\";s:7:\"comment\";s:10:\"base field\";s:3:\"cid\";s:18:\"relationship field\";s:2:\"id\";s:5:\"extra\";a:1:{i:0;a:4:{s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:4:\"type\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:7:\"comment\";}}}}s:15:\"comment_to_file\";a:5:{s:5:\"title\";s:4:\"File\";s:4:\"help\";s:93:\"A file that is associated with this comment, usually because it is in a field on the comment.\";s:9:\"skip base\";a:6:{i:0;s:12:\"file_managed\";i:1;s:4:\"node\";i:2;s:13:\"node_revision\";i:3;s:5:\"users\";i:4;s:18:\"taxonomy_term_data\";i:5;s:19:\"taxonomy_vocabulary\";}s:10:\"real field\";s:3:\"fid\";s:12:\"relationship\";a:5:{s:5:\"title\";s:4:\"File\";s:5:\"label\";s:4:\"File\";s:4:\"base\";s:12:\"file_managed\";s:10:\"base field\";s:3:\"fid\";s:18:\"relationship field\";s:3:\"fid\";}}s:21:\"file_to_taxonomy_term\";a:5:{s:5:\"title\";s:13:\"Taxonomy Term\";s:4:\"help\";s:112:\"A taxonomy term that is associated with this file, usually because this file is in a field on the taxonomy term.\";s:9:\"skip base\";a:6:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";i:2;s:5:\"users\";i:3;s:7:\"comment\";i:4;s:18:\"taxonomy_term_data\";i:5;s:19:\"taxonomy_vocabulary\";}s:10:\"real field\";s:2:\"id\";s:12:\"relationship\";a:6:{s:5:\"title\";s:13:\"Taxonomy Term\";s:5:\"label\";s:13:\"Taxonomy Term\";s:4:\"base\";s:18:\"taxonomy_term_data\";s:10:\"base field\";s:3:\"tid\";s:18:\"relationship field\";s:2:\"id\";s:5:\"extra\";a:1:{i:0;a:4:{s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:4:\"type\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:13:\"taxonomy_term\";}}}}s:21:\"taxonomy_term_to_file\";a:5:{s:5:\"title\";s:4:\"File\";s:4:\"help\";s:105:\"A file that is associated with this taxonomy term, usually because it is in a field on the taxonomy term.\";s:9:\"skip base\";a:6:{i:0;s:12:\"file_managed\";i:1;s:4:\"node\";i:2;s:13:\"node_revision\";i:3;s:5:\"users\";i:4;s:7:\"comment\";i:5;s:19:\"taxonomy_vocabulary\";}s:10:\"real field\";s:3:\"fid\";s:12:\"relationship\";a:5:{s:5:\"title\";s:4:\"File\";s:5:\"label\";s:4:\"File\";s:4:\"base\";s:12:\"file_managed\";s:10:\"base field\";s:3:\"fid\";s:18:\"relationship field\";s:3:\"fid\";}}s:27:\"file_to_taxonomy_vocabulary\";a:5:{s:5:\"title\";s:19:\"Taxonomy Vocabulary\";s:4:\"help\";s:124:\"A taxonomy vocabulary that is associated with this file, usually because this file is in a field on the taxonomy vocabulary.\";s:9:\"skip base\";a:6:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";i:2;s:5:\"users\";i:3;s:7:\"comment\";i:4;s:18:\"taxonomy_term_data\";i:5;s:19:\"taxonomy_vocabulary\";}s:10:\"real field\";s:2:\"id\";s:12:\"relationship\";a:6:{s:5:\"title\";s:19:\"Taxonomy Vocabulary\";s:5:\"label\";s:19:\"Taxonomy Vocabulary\";s:4:\"base\";s:19:\"taxonomy_vocabulary\";s:10:\"base field\";s:3:\"vid\";s:18:\"relationship field\";s:2:\"id\";s:5:\"extra\";a:1:{i:0;a:4:{s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:4:\"type\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:19:\"taxonomy_vocabulary\";}}}}s:27:\"taxonomy_vocabulary_to_file\";a:5:{s:5:\"title\";s:4:\"File\";s:4:\"help\";s:117:\"A file that is associated with this taxonomy vocabulary, usually because it is in a field on the taxonomy vocabulary.\";s:9:\"skip base\";a:6:{i:0;s:12:\"file_managed\";i:1;s:4:\"node\";i:2;s:13:\"node_revision\";i:3;s:5:\"users\";i:4;s:7:\"comment\";i:5;s:18:\"taxonomy_term_data\";}s:10:\"real field\";s:3:\"fid\";s:12:\"relationship\";a:5:{s:5:\"title\";s:4:\"File\";s:5:\"label\";s:4:\"File\";s:4:\"base\";s:12:\"file_managed\";s:10:\"base field\";s:3:\"fid\";s:18:\"relationship field\";s:3:\"fid\";}}s:6:\"module\";a:6:{s:5:\"title\";s:6:\"Module\";s:4:\"help\";s:43:\"The module managing this file relationship.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:4:\"type\";a:6:{s:5:\"title\";s:11:\"Entity type\";s:4:\"help\";s:47:\"The type of entity that is related to the file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:2:\"id\";a:6:{s:5:\"title\";s:9:\"Entity ID\";s:4:\"help\";s:49:\"The ID of the entity that is related to the file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:1:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:5:\"count\";a:5:{s:5:\"title\";s:9:\"Use count\";s:4:\"help\";s:52:\"The number of times the file is used by this entity.\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}}s:6:\"system\";a:6:{s:5:\"table\";a:2:{s:5:\"group\";s:6:\"System\";s:4:\"base\";a:3:{s:5:\"field\";s:8:\"filename\";s:5:\"title\";s:25:\"Module/Theme/Theme engine\";s:4:\"help\";s:46:\"Modules/Themes/Theme engines in your codebase.\";}}s:8:\"filename\";a:6:{s:5:\"title\";s:34:\"Module/Theme/Theme engine filename\";s:4:\"help\";s:103:\"The path of the primary file for this item, relative to the Drupal root; e.g. modules/node/node.module.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:29:\"views_handler_argument_string\";s:10:\"name field\";s:8:\"filename\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:4:\"name\";a:6:{s:5:\"title\";s:30:\"Module/Theme/Theme engine name\";s:4:\"help\";s:32:\"The name of the item; e.g. node.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:29:\"views_handler_argument_string\";s:10:\"name field\";s:4:\"name\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:4:\"type\";a:6:{s:5:\"title\";s:4:\"Type\";s:4:\"help\";s:60:\"The type of the item, either module, theme, or theme_engine.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:29:\"views_handler_argument_string\";s:10:\"name field\";s:4:\"type\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:32:\"views_handler_filter_system_type\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:6:\"status\";a:6:{s:5:\"title\";s:6:\"Status\";s:4:\"help\";s:55:\"Boolean indicating whether or not this item is enabled.\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_boolean\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:10:\"name field\";s:6:\"status\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:37:\"views_handler_filter_boolean_operator\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:14:\"schema_version\";a:6:{s:5:\"title\";s:14:\"Schema version\";s:4:\"help\";s:238:\"The module\'s database schema version number. -1 if the module is not installed (its tables do not exist); 0 or the largest N of the module\'s hook_update_N() function that has either been run or existed when the module was first installed.\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:10:\"name field\";s:14:\"schema_version\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}}s:10:\"vocabulary\";a:1:{s:8:\"moved to\";s:19:\"taxonomy_vocabulary\";}s:9:\"term_data\";a:1:{s:8:\"moved to\";s:18:\"taxonomy_term_data\";}s:9:\"term_node\";a:1:{s:8:\"moved to\";s:14:\"taxonomy_index\";}s:14:\"taxonomy_index\";a:3:{s:5:\"table\";a:2:{s:5:\"group\";s:13:\"Taxonomy term\";s:4:\"join\";a:3:{s:18:\"taxonomy_term_data\";a:2:{s:10:\"left_field\";s:3:\"tid\";s:5:\"field\";s:3:\"tid\";}s:4:\"node\";a:2:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:3:\"nid\";}s:23:\"taxonomy_term_hierarchy\";a:2:{s:10:\"left_field\";s:3:\"tid\";s:5:\"field\";s:3:\"tid\";}}}s:3:\"nid\";a:3:{s:5:\"title\";s:17:\"Content with term\";s:4:\"help\";s:38:\"Relate all content tagged with a term.\";s:12:\"relationship\";a:5:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:4:\"node\";s:9:\"skip base\";s:4:\"node\";}}s:3:\"tid\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:20:\"Has taxonomy term ID\";s:4:\"help\";s:54:\"Display content if it has the selected taxonomy terms.\";s:8:\"argument\";a:6:{s:7:\"handler\";s:36:\"views_handler_argument_term_node_tid\";s:10:\"name table\";s:18:\"taxonomy_term_data\";s:10:\"name field\";s:4:\"name\";s:16:\"empty field name\";s:13:\"Uncategorized\";s:7:\"numeric\";b:1;s:9:\"skip base\";s:18:\"taxonomy_term_data\";}s:6:\"filter\";a:6:{s:5:\"title\";s:17:\"Has taxonomy term\";s:7:\"handler\";s:34:\"views_handler_filter_term_node_tid\";s:15:\"hierarchy table\";s:23:\"taxonomy_term_hierarchy\";s:7:\"numeric\";b:1;s:9:\"skip base\";s:18:\"taxonomy_term_data\";s:11:\"allow empty\";b:1;}}}s:23:\"taxonomy_term_hierarchy\";a:2:{s:5:\"table\";a:3:{s:5:\"group\";s:13:\"Taxonomy term\";s:4:\"join\";a:2:{s:23:\"taxonomy_term_hierarchy\";a:2:{s:10:\"left_field\";s:3:\"tid\";s:5:\"field\";s:6:\"parent\";}s:18:\"taxonomy_term_data\";a:2:{s:10:\"left_field\";s:3:\"tid\";s:5:\"field\";s:3:\"tid\";}}s:20:\"default_relationship\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:5:\"field\";s:13:\"term_node_tid\";}}}s:6:\"parent\";a:5:{s:5:\"title\";s:11:\"Parent term\";s:4:\"help\";s:123:\"The parent term of the term. This can produce duplicate entries if you are using a vocabulary that allows multiple parents.\";s:12:\"relationship\";a:3:{s:4:\"base\";s:18:\"taxonomy_term_data\";s:5:\"field\";s:6:\"parent\";s:5:\"label\";s:6:\"Parent\";}s:6:\"filter\";a:2:{s:4:\"help\";s:57:\"Filter the results of \"Taxonomy: Term\" by the parent pid.\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:2:{s:4:\"help\";s:28:\"The parent term of the term.\";s:7:\"handler\";s:31:\"views_handler_argument_taxonomy\";}}}s:14:\"term_hierarchy\";a:1:{s:8:\"moved to\";s:23:\"taxonomy_term_hierarchy\";}s:11:\"users_roles\";a:2:{s:5:\"table\";a:3:{s:5:\"group\";s:4:\"User\";s:4:\"join\";a:1:{s:5:\"users\";a:2:{s:10:\"left_field\";s:3:\"uid\";s:5:\"field\";s:3:\"uid\";}}s:20:\"default_relationship\";a:2:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"uid\";}s:13:\"node_revision\";a:2:{s:5:\"table\";s:13:\"node_revision\";s:5:\"field\";s:3:\"uid\";}}}s:3:\"rid\";a:5:{s:5:\"title\";s:5:\"Roles\";s:4:\"help\";s:29:\"Roles that a user belongs to.\";s:5:\"field\";a:2:{s:7:\"handler\";s:30:\"views_handler_field_user_roles\";s:11:\"no group by\";b:1;}s:6:\"filter\";a:3:{s:7:\"handler\";s:31:\"views_handler_filter_user_roles\";s:7:\"numeric\";b:1;s:11:\"allow empty\";b:1;}s:8:\"argument\";a:6:{s:7:\"handler\";s:38:\"views_handler_argument_users_roles_rid\";s:10:\"name table\";s:4:\"role\";s:10:\"name field\";s:4:\"name\";s:16:\"empty field name\";s:7:\"No role\";s:12:\"zero is null\";b:1;s:7:\"numeric\";b:1;}}}s:4:\"role\";a:1:{s:5:\"table\";a:2:{s:4:\"join\";a:2:{s:5:\"users\";a:3:{s:10:\"left_table\";s:11:\"users_roles\";s:10:\"left_field\";s:3:\"rid\";s:5:\"field\";s:3:\"rid\";}s:11:\"users_roles\";a:2:{s:10:\"left_field\";s:3:\"rid\";s:5:\"field\";s:3:\"rid\";}}s:20:\"default_relationship\";a:2:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"uid\";}s:13:\"node_revision\";a:2:{s:5:\"table\";s:13:\"node_revision\";s:5:\"field\";s:3:\"uid\";}}}}s:15:\"role_permission\";a:2:{s:5:\"table\";a:2:{s:5:\"group\";s:4:\"User\";s:4:\"join\";a:1:{s:5:\"users\";a:3:{s:10:\"left_table\";s:11:\"users_roles\";s:10:\"left_field\";s:3:\"rid\";s:5:\"field\";s:3:\"rid\";}}}s:10:\"permission\";a:4:{s:5:\"title\";s:10:\"Permission\";s:4:\"help\";s:21:\"The user permissions.\";s:5:\"field\";a:2:{s:7:\"handler\";s:36:\"views_handler_field_user_permissions\";s:11:\"no group by\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:37:\"views_handler_filter_user_permissions\";}}}s:7:\"authmap\";a:4:{s:5:\"table\";a:3:{s:5:\"group\";s:4:\"User\";s:4:\"join\";a:1:{s:5:\"users\";a:2:{s:10:\"left_field\";s:3:\"uid\";s:5:\"field\";s:3:\"uid\";}}s:20:\"default_relationship\";a:2:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"uid\";}s:13:\"node_revision\";a:2:{s:5:\"table\";s:13:\"node_revision\";s:5:\"field\";s:3:\"uid\";}}}s:3:\"aid\";a:5:{s:5:\"title\";s:10:\"Authmap ID\";s:4:\"help\";s:15:\"The Authmap ID.\";s:5:\"field\";a:1:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";}s:6:\"filter\";a:2:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:7:\"numeric\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:7:\"numeric\";b:1;}}s:8:\"authname\";a:5:{s:5:\"title\";s:19:\"Authentication name\";s:4:\"help\";s:31:\"The unique authentication name.\";s:5:\"field\";a:1:{s:7:\"handler\";s:19:\"views_handler_field\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:6:\"module\";a:5:{s:5:\"title\";s:21:\"Authentication module\";s:4:\"help\";s:57:\"The name of the module managing the authentication entry.\";s:5:\"field\";a:1:{s:7:\"handler\";s:19:\"views_handler_field\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}}s:5:\"views\";a:12:{s:3:\"php\";a:6:{s:5:\"title\";s:3:\"PHP\";s:4:\"help\";s:13:\"Use PHP code.\";s:4:\"area\";a:2:{s:4:\"help\";s:48:\"Use PHP code to construct the output of an area.\";s:7:\"handler\";s:22:\"views_php_handler_area\";}s:5:\"field\";a:2:{s:4:\"help\";s:48:\"Use PHP code to construct the output of a field.\";s:7:\"handler\";s:23:\"views_php_handler_field\";}s:6:\"filter\";a:2:{s:4:\"help\";s:46:\"Use PHP code to filter the result of the view.\";s:7:\"handler\";s:24:\"views_php_handler_filter\";}s:4:\"sort\";a:2:{s:4:\"help\";s:44:\"Use PHP code to sort the result of the view.\";s:7:\"handler\";s:22:\"views_php_handler_sort\";}}s:5:\"table\";a:2:{s:5:\"group\";s:6:\"Global\";s:4:\"join\";a:1:{s:7:\"#global\";a:0:{}}}s:6:\"random\";a:3:{s:5:\"title\";s:6:\"Random\";s:4:\"help\";s:28:\"Randomize the display order.\";s:4:\"sort\";a:1:{s:7:\"handler\";s:25:\"views_handler_sort_random\";}}s:4:\"null\";a:3:{s:5:\"title\";s:4:\"Null\";s:4:\"help\";s:213:\"Allow a contextual filter value to be ignored. The query will not be altered by this contextual filter value. Can be used when contextual filter values come from the URL, and a part of the URL needs to be ignored.\";s:8:\"argument\";a:1:{s:7:\"handler\";s:27:\"views_handler_argument_null\";}}s:7:\"nothing\";a:3:{s:5:\"title\";s:11:\"Custom text\";s:4:\"help\";s:28:\"Provide custom text or link.\";s:5:\"field\";a:1:{s:7:\"handler\";s:26:\"views_handler_field_custom\";}}s:7:\"counter\";a:3:{s:5:\"title\";s:19:\"View result counter\";s:4:\"help\";s:47:\"Displays the actual position of the view result\";s:5:\"field\";a:1:{s:7:\"handler\";s:27:\"views_handler_field_counter\";}}s:4:\"area\";a:3:{s:5:\"title\";s:9:\"Text area\";s:4:\"help\";s:33:\"Provide markup text for the area.\";s:4:\"area\";a:1:{s:7:\"handler\";s:23:\"views_handler_area_text\";}}s:16:\"area_text_custom\";a:3:{s:5:\"title\";s:15:\"Unfiltered text\";s:4:\"help\";s:82:\"Add unrestricted, custom text or markup. This is similar to the custom text field.\";s:4:\"area\";a:1:{s:7:\"handler\";s:30:\"views_handler_area_text_custom\";}}s:4:\"view\";a:3:{s:5:\"title\";s:9:\"View area\";s:4:\"help\";s:29:\"Insert a view inside an area.\";s:4:\"area\";a:1:{s:7:\"handler\";s:23:\"views_handler_area_view\";}}s:6:\"result\";a:3:{s:5:\"title\";s:14:\"Result summary\";s:4:\"help\";s:53:\"Shows result summary, for example the items per page.\";s:4:\"area\";a:1:{s:7:\"handler\";s:25:\"views_handler_area_result\";}}s:7:\"combine\";a:3:{s:5:\"title\";s:21:\"Combine fields filter\";s:4:\"help\";s:47:\"Combine two fields together and search by them.\";s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_combine\";}}s:10:\"expression\";a:3:{s:5:\"title\";s:15:\"Math expression\";s:4:\"help\";s:52:\"Evaluates a mathematical expression and displays it.\";s:5:\"field\";a:2:{s:7:\"handler\";s:24:\"views_handler_field_math\";s:5:\"float\";b:1;}}}s:8:\"watchdog\";a:12:{s:5:\"table\";a:3:{s:4:\"base\";a:4:{s:5:\"field\";s:3:\"wid\";s:5:\"title\";s:14:\"Watchdog entry\";s:4:\"help\";s:54:\"Watchdog entries are a list of recorded system events.\";s:6:\"weight\";i:25;}s:5:\"group\";s:8:\"Watchdog\";s:4:\"join\";a:1:{s:5:\"users\";a:2:{s:5:\"field\";s:3:\"uid\";s:10:\"left_field\";s:3:\"uid\";}}}s:3:\"wid\";a:6:{s:5:\"title\";s:3:\"Wid\";s:4:\"help\";s:25:\"Unique watchdog event ID.\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:3:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:10:\"name field\";s:3:\"wid\";s:7:\"numeric\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:3:\"uid\";a:3:{s:5:\"title\";s:4:\"User\";s:4:\"help\";s:43:\"The ID of the user who triggered the event.\";s:12:\"relationship\";a:4:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:5:\"users\";s:10:\"base field\";s:3:\"uid\";s:5:\"label\";s:16:\"Watchdog - Users\";}}s:4:\"type\";a:6:{s:5:\"title\";s:4:\"Type\";s:4:\"help\";s:60:\"Type of log message, for example \"user\" or \"page not found\".\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:29:\"views_handler_argument_string\";s:10:\"name field\";s:4:\"type\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:34:\"views_handler_filter_watchdog_type\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:7:\"message\";a:6:{s:5:\"title\";s:7:\"Message\";s:4:\"help\";s:20:\"Text of log message.\";s:5:\"field\";a:3:{s:7:\"handler\";s:36:\"views_handler_field_watchdog_message\";s:17:\"additional fields\";a:2:{i:0;s:3:\"wid\";i:1;s:9:\"variables\";}s:14:\"click sortable\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:29:\"views_handler_argument_string\";s:10:\"name field\";s:7:\"message\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:37:\"views_handler_filter_watchdog_message\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:9:\"variables\";a:6:{s:5:\"title\";s:9:\"Variables\";s:4:\"help\";s:101:\"Serialized array of variables that match the message string and that is passed into the t() function.\";s:5:\"field\";a:1:{s:7:\"handler\";s:30:\"views_handler_field_serialized\";}s:8:\"argument\";a:2:{s:7:\"handler\";s:29:\"views_handler_argument_string\";s:10:\"name field\";s:9:\"variables\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:8:\"severity\";a:6:{s:5:\"title\";s:8:\"Severity\";s:4:\"help\";s:72:\"The severity level of the event; ranges from 0 (Emergency) to 7 (Debug).\";s:5:\"field\";a:2:{s:7:\"handler\";s:37:\"views_handler_field_watchdog_severity\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:10:\"name field\";s:8:\"severity\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:38:\"views_handler_filter_watchdog_severity\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:4:\"link\";a:6:{s:5:\"title\";s:4:\"Link\";s:4:\"help\";s:37:\"Link to view the result of the event.\";s:5:\"field\";a:2:{s:7:\"handler\";s:23:\"views_handler_field_xss\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:29:\"views_handler_argument_string\";s:10:\"name field\";s:4:\"link\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:8:\"location\";a:6:{s:5:\"title\";s:8:\"Location\";s:4:\"help\";s:31:\"URL of the origin of the event.\";s:5:\"field\";a:2:{s:7:\"handler\";s:23:\"views_handler_field_url\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:29:\"views_handler_argument_string\";s:10:\"name field\";s:8:\"location\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:7:\"referer\";a:6:{s:5:\"title\";s:8:\"Referrer\";s:4:\"help\";s:22:\"URL of referring page.\";s:5:\"field\";a:2:{s:7:\"handler\";s:23:\"views_handler_field_url\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:29:\"views_handler_argument_string\";s:10:\"name field\";s:7:\"referer\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:8:\"hostname\";a:6:{s:5:\"title\";s:8:\"Hostname\";s:4:\"help\";s:45:\"Hostname of the user who triggered the event.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:29:\"views_handler_argument_string\";s:10:\"name field\";s:8:\"hostname\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:9:\"timestamp\";a:6:{s:5:\"title\";s:9:\"Timestamp\";s:4:\"help\";s:38:\"Unix timestamp of when event occurred.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"views_handler_argument_date\";s:10:\"name field\";s:9:\"timestamp\";s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}}}}',0,1371656313,1);
INSERT INTO `cache_views` VALUES ('entity_base_tables:en','a:9:{i:0;s:7:\"comment\";i:1;s:4:\"node\";i:2;s:13:\"node_revision\";i:3;s:17:\"search_api_server\";i:4;s:16:\"search_api_index\";i:5;s:15:\"search_api_page\";i:6;s:12:\"file_managed\";i:7;s:18:\"taxonomy_term_data\";i:8;s:5:\"users\";}',0,1371656313,1),('unpack_options:e25ba9e50cc13d7b33248d068aa95e63:en','a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}',0,1371656313,1),('unpack_options:bf64a23fbbce1b80f6f40e8e73c0a0b0:en','a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:0;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:6:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}',0,1371656313,1),('unpack_options:513523f0dcaba17c48277b315670b0b3:en','a:41:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:0;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"block_description\";s:0:\"\";s:13:\"block_caching\";i:-1;}',0,1371656313,1),('unpack_options:ba6440db7c920d7600a86aed68b62535:en','a:44:{s:8:\"defaults\";a:35:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:0;s:5:\"pager\";b:0;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;s:9:\"use_pager\";b:0;s:14:\"items_per_page\";b:0;s:6:\"offset\";b:0;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:3:\"rss\";s:13:\"style_options\";a:1:{s:11:\"description\";s:0:\"\";}s:10:\"row_plugin\";s:0:\"\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:6:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}s:8:\"displays\";a:0:{}s:14:\"sitename_title\";b:0;}',0,1371656313,1),('unpack_options:5c029d7a38091e323baf1726c7979402:en','a:45:{s:8:\"defaults\";a:35:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:0;s:5:\"pager\";b:0;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;s:9:\"use_pager\";b:0;s:14:\"items_per_page\";b:0;s:6:\"offset\";b:0;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:8:\"displays\";a:0:{}s:19:\"attachment_position\";s:6:\"before\";s:17:\"inherit_arguments\";b:1;s:23:\"inherit_exposed_filters\";b:0;s:13:\"inherit_pager\";b:0;s:12:\"render_pager\";b:0;}',0,1371656313,1),('ctools_export_index:views_view','a:7:{i:0;s:15:\"comments_recent\";i:1;s:7:\"tracker\";i:2;s:7:\"archive\";i:3;s:9:\"frontpage\";i:4;s:8:\"glossary\";i:5;s:9:\"backlinks\";i:6;s:13:\"taxonomy_term\";}',0,1371656313,1),('ctools_export:views_view:comments_recent','O:4:\"view\":50:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:7:\"comment\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:15:\"comments_recent\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:162:\"Contains a block and a page to list recent comments; the block will automatically link to the page, which displays the comment body as well as a link to the node.\";s:3:\"tag\";s:7:\"default\";s:10:\"human_name\";s:15:\"Recent comments\";s:4:\"core\";i:0;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:1;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:3:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:48:\"sites/all/modules/contrib/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:13:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:5:\"title\";s:15:\"Recent comments\";s:8:\"use_more\";b:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:1:{s:14:\"items_per_page\";i:5;}}s:12:\"style_plugin\";s:4:\"list\";s:10:\"row_plugin\";s:6:\"fields\";s:13:\"relationships\";a:1:{s:3:\"nid\";a:3:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:3:\"nid\";}}s:6:\"fields\";a:2:{s:7:\"subject\";a:5:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:7:\"subject\";s:5:\"label\";s:0:\"\";s:15:\"link_to_comment\";i:1;}s:9:\"timestamp\";a:5:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:7:\"changed\";s:5:\"label\";s:0:\"\";s:11:\"date_format\";s:8:\"time ago\";}}s:5:\"sorts\";a:1:{s:9:\"timestamp\";a:4:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:7:\"changed\";s:5:\"order\";s:4:\"DESC\";}}s:7:\"filters\";a:1:{s:12:\"status_extra\";a:5:{s:2:\"id\";s:12:\"status_extra\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:12:\"status_extra\";s:12:\"relationship\";s:3:\"nid\";s:5:\"group\";i:0;}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:4:\"page\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:181;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:0;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:6:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:7:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:8:\"defaults\";a:5:{s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:6:\"fields\";b:0;}s:12:\"style_plugin\";s:4:\"list\";s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:2:{s:6:\"inline\";a:2:{s:5:\"title\";s:5:\"title\";s:9:\"timestamp\";s:9:\"timestamp\";}s:9:\"separator\";s:6:\"&nbsp;\";}s:6:\"fields\";a:4:{s:5:\"title\";a:6:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:3:\"nid\";s:5:\"label\";s:8:\"Reply to\";s:12:\"link_to_node\";i:1;}s:9:\"timestamp\";a:5:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:7:\"changed\";s:5:\"label\";s:0:\"\";s:11:\"date_format\";s:8:\"time ago\";}s:7:\"subject\";a:5:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:7:\"subject\";s:5:\"label\";s:0:\"\";s:15:\"link_to_comment\";i:1;}s:7:\"comment\";a:4:{s:2:\"id\";s:7:\"comment\";s:5:\"table\";s:23:\"field_data_comment_body\";s:5:\"field\";s:12:\"comment_body\";s:5:\"label\";s:0:\"\";}}s:4:\"path\";s:15:\"comments/recent\";}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}s:5:\"block\";O:13:\"views_display\":8:{s:7:\"handler\";O:26:\"views_plugin_display_block\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:361;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:5:\"block\";s:7:\"options\";a:41:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:0;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"block_description\";s:0:\"\";s:13:\"block_caching\";i:-1;}s:10:\"definition\";a:20:{s:5:\"title\";s:5:\"Block\";s:4:\"help\";s:28:\"Display the view as a block.\";s:7:\"handler\";s:26:\"views_plugin_display_block\";s:5:\"theme\";s:10:\"views_view\";s:15:\"uses hook block\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:5:\"block\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:5:\"Block\";s:10:\"help topic\";s:13:\"display-block\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:30:\"views_plugin_display_block.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:5:\"block\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:1:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:5:\"block\";s:13:\"display_title\";s:5:\"Block\";s:14:\"display_plugin\";s:5:\"block\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:19:\"localization_plugin\";O:30:\"views_plugin_localization_none\":9:{s:9:\"translate\";b:0;s:14:\"export_strings\";a:0:{}s:4:\"view\";r:1;s:7:\"display\";N;s:11:\"plugin_type\";s:12:\"localization\";s:11:\"plugin_name\";s:4:\"none\";s:7:\"options\";a:0:{}s:10:\"definition\";a:11:{s:5:\"title\";s:4:\"None\";s:4:\"help\";s:42:\"Do not pass admin strings for translation.\";s:7:\"handler\";s:30:\"views_plugin_localization_none\";s:10:\"help topic\";s:17:\"localization-none\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:34:\"views_plugin_localization_none.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"none\";}s:9:\"is_plugin\";b:1;}s:13:\"export_module\";s:7:\"comment\";}',0,1371656313,1),('ctools_export:views_view:tracker','O:4:\"view\":49:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:4:\"node\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:7:\"tracker\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:33:\"Shows all new activity on system.\";s:3:\"tag\";s:7:\"default\";s:10:\"human_name\";s:7:\"Tracker\";s:4:\"core\";i:0;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:1;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:2:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:48:\"sites/all/modules/contrib/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:13:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:5:\"title\";s:12:\"Recent posts\";s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";s:2:\"25\";}}s:12:\"style_plugin\";s:5:\"table\";s:13:\"style_options\";a:5:{s:7:\"columns\";a:7:{s:4:\"type\";s:4:\"type\";s:5:\"title\";s:5:\"title\";s:4:\"name\";s:4:\"name\";s:13:\"comment_count\";s:13:\"comment_count\";s:22:\"last_comment_timestamp\";s:22:\"last_comment_timestamp\";s:9:\"timestamp\";s:5:\"title\";s:12:\"new_comments\";s:13:\"comment_count\";}s:7:\"default\";s:22:\"last_comment_timestamp\";s:4:\"info\";a:7:{s:4:\"type\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:5:\"title\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:6:\"&nbsp;\";}s:4:\"name\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:13:\"comment_count\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:6:\"<br />\";}s:22:\"last_comment_timestamp\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:6:\"&nbsp;\";}s:9:\"timestamp\";a:1:{s:9:\"separator\";s:0:\"\";}s:12:\"new_comments\";a:1:{s:9:\"separator\";s:0:\"\";}}s:8:\"override\";i:1;s:5:\"order\";s:4:\"desc\";}s:13:\"relationships\";a:1:{s:3:\"uid\";a:3:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"uid\";}}s:6:\"fields\";a:7:{s:4:\"type\";a:3:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";}s:5:\"title\";a:3:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";}s:4:\"name\";a:5:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:5:\"label\";s:6:\"Author\";}s:13:\"comment_count\";a:4:{s:2:\"id\";s:13:\"comment_count\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:13:\"comment_count\";s:5:\"label\";s:7:\"Replies\";}s:22:\"last_comment_timestamp\";a:4:{s:2:\"id\";s:22:\"last_comment_timestamp\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:22:\"last_comment_timestamp\";s:5:\"label\";s:9:\"Last Post\";}s:9:\"timestamp\";a:6:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:7:\"history\";s:5:\"field\";s:9:\"timestamp\";s:5:\"label\";s:0:\"\";s:12:\"link_to_node\";i:0;s:8:\"comments\";i:1;}s:12:\"new_comments\";a:7:{s:2:\"id\";s:12:\"new_comments\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:12:\"new_comments\";s:5:\"label\";s:0:\"\";s:10:\"hide_empty\";b:1;s:6:\"suffix\";s:4:\" new\";s:15:\"link_to_comment\";i:1;}}s:5:\"sorts\";a:1:{s:22:\"last_comment_timestamp\";a:3:{s:2:\"id\";s:22:\"last_comment_timestamp\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:22:\"last_comment_timestamp\";}}s:9:\"arguments\";a:1:{s:9:\"uid_touch\";a:9:{s:2:\"id\";s:9:\"uid_touch\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"uid_touch\";s:9:\"exception\";a:1:{s:12:\"title_enable\";i:1;}s:12:\"title_enable\";i:1;s:5:\"title\";s:19:\"Recent posts for %1\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:1:{s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:1;}}s:7:\"filters\";a:1:{s:6:\"status\";a:6:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:0;s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:4:\"page\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:252;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:0;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:6:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:3:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:7:\"tracker\";s:4:\"menu\";a:2:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:12:\"Recent posts\";}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:13:\"export_module\";s:7:\"comment\";}',0,1371656313,1),('ctools_export:views_view:archive','O:4:\"view\":49:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:4:\"node\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:7:\"archive\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:61:\"Display a list of months that link to content for that month.\";s:3:\"tag\";s:7:\"default\";s:10:\"human_name\";s:7:\"Archive\";s:4:\"core\";i:0;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:1;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:3:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:48:\"sites/all/modules/contrib/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:11:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:5:\"title\";s:15:\"Monthly archive\";s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:1:{s:4:\"type\";s:4:\"full\";}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:4:\"node\";s:5:\"sorts\";a:1:{s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:9:\"arguments\";a:1:{s:18:\"created_year_month\";a:11:{s:2:\"id\";s:18:\"created_year_month\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:18:\"created_year_month\";s:14:\"default_action\";s:7:\"summary\";s:9:\"exception\";a:1:{s:12:\"title_enable\";i:1;}s:12:\"title_enable\";i:1;s:5:\"title\";s:2:\"%1\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:2:{s:10:\"sort_order\";s:4:\"desc\";s:6:\"format\";s:15:\"default_summary\";}s:15:\"summary_options\";a:2:{s:8:\"override\";b:1;s:14:\"items_per_page\";s:2:\"30\";}s:18:\"specify_validation\";i:1;}}s:7:\"filters\";a:1:{s:6:\"status\";a:6:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:5:\"value\";i:1;s:5:\"group\";i:0;s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:4:\"page\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:180;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:0;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:6:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:2:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:7:\"archive\";}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}s:5:\"block\";O:13:\"views_display\":8:{s:7:\"handler\";O:26:\"views_plugin_display_block\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:322;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:5:\"block\";s:7:\"options\";a:41:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:0;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"block_description\";s:0:\"\";s:13:\"block_caching\";i:-1;}s:10:\"definition\";a:20:{s:5:\"title\";s:5:\"Block\";s:4:\"help\";s:28:\"Display the view as a block.\";s:7:\"handler\";s:26:\"views_plugin_display_block\";s:5:\"theme\";s:10:\"views_view\";s:15:\"uses hook block\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:5:\"block\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:5:\"Block\";s:10:\"help topic\";s:13:\"display-block\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:30:\"views_plugin_display_block.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:5:\"block\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:3:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:8:\"defaults\";a:1:{s:9:\"arguments\";b:0;}s:9:\"arguments\";a:1:{s:18:\"created_year_month\";a:11:{s:2:\"id\";s:18:\"created_year_month\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:18:\"created_year_month\";s:14:\"default_action\";s:7:\"summary\";s:9:\"exception\";a:1:{s:12:\"title_enable\";i:1;}s:12:\"title_enable\";i:1;s:5:\"title\";s:2:\"%1\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:1:{s:6:\"format\";s:15:\"default_summary\";}s:15:\"summary_options\";a:1:{s:14:\"items_per_page\";s:2:\"30\";}s:18:\"specify_validation\";i:1;}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:5:\"block\";s:13:\"display_title\";s:5:\"Block\";s:14:\"display_plugin\";s:5:\"block\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:13:\"export_module\";s:4:\"node\";}',0,1371656313,1),('ctools_export:views_view:frontpage','O:4:\"view\":50:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:4:\"node\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:9:\"frontpage\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:119:\"Emulates the default Drupal front page; you may set the default home page path to this view to make it your front page.\";s:3:\"tag\";s:7:\"default\";s:10:\"human_name\";s:10:\"Front page\";s:4:\"core\";i:0;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:1;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:3:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:48:\"sites/all/modules/contrib/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:10:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:1:{s:4:\"type\";s:4:\"full\";}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:4:\"node\";s:11:\"row_options\";a:1:{s:5:\"links\";i:1;}s:5:\"sorts\";a:2:{s:6:\"sticky\";a:4:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"sticky\";s:5:\"order\";s:4:\"DESC\";}s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:7:\"filters\";a:2:{s:7:\"promote\";a:6:{s:2:\"id\";s:7:\"promote\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"promote\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:0;s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}s:6:\"status\";a:6:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:0;s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:4:\"page\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:176;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:0;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:6:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:2:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:9:\"frontpage\";}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}s:4:\"feed\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_feed\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:318;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"feed\";s:7:\"options\";a:44:{s:8:\"defaults\";a:35:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:0;s:5:\"pager\";b:0;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;s:9:\"use_pager\";b:0;s:14:\"items_per_page\";b:0;s:6:\"offset\";b:0;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:3:\"rss\";s:13:\"style_options\";a:1:{s:11:\"description\";s:0:\"\";}s:10:\"row_plugin\";s:8:\"node_rss\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:6:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}s:8:\"displays\";a:0:{}s:14:\"sitename_title\";b:0;}s:10:\"definition\";a:17:{s:5:\"title\";s:4:\"Feed\";s:4:\"help\";s:48:\"Display the view as a feed, such as an RSS feed.\";s:7:\"handler\";s:25:\"views_plugin_display_feed\";s:14:\"uses hook menu\";b:1;s:8:\"use ajax\";b:0;s:9:\"use pager\";b:0;s:18:\"accept attachments\";b:0;s:5:\"admin\";s:4:\"Feed\";s:10:\"help topic\";s:12:\"display-feed\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_feed.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"feed\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:9:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:8:\"defaults\";a:1:{s:5:\"title\";b:0;}s:5:\"title\";s:15:\"Front page feed\";s:5:\"pager\";a:1:{s:4:\"type\";s:4:\"some\";}s:12:\"style_plugin\";s:3:\"rss\";s:10:\"row_plugin\";s:8:\"node_rss\";s:4:\"path\";s:7:\"rss.xml\";s:8:\"displays\";a:2:{s:7:\"default\";s:7:\"default\";s:4:\"page\";s:4:\"page\";}s:14:\"sitename_title\";s:1:\"1\";}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:4:\"feed\";s:13:\"display_title\";s:4:\"Feed\";s:14:\"display_plugin\";s:4:\"feed\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:19:\"localization_plugin\";O:30:\"views_plugin_localization_none\":9:{s:9:\"translate\";b:0;s:14:\"export_strings\";a:0:{}s:4:\"view\";r:1;s:7:\"display\";N;s:11:\"plugin_type\";s:12:\"localization\";s:11:\"plugin_name\";s:4:\"none\";s:7:\"options\";a:0:{}s:10:\"definition\";a:11:{s:5:\"title\";s:4:\"None\";s:4:\"help\";s:42:\"Do not pass admin strings for translation.\";s:7:\"handler\";s:30:\"views_plugin_localization_none\";s:10:\"help topic\";s:17:\"localization-none\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:34:\"views_plugin_localization_none.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"none\";}s:9:\"is_plugin\";b:1;}s:13:\"export_module\";s:4:\"node\";}',0,1371656313,1),('ctools_export:views_view:glossary','O:4:\"view\":50:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:4:\"node\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:8:\"glossary\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:33:\"A list of all content, by letter.\";s:3:\"tag\";s:7:\"default\";s:10:\"human_name\";s:8:\"Glossary\";s:4:\"core\";i:0;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:1;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:3:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:48:\"sites/all/modules/contrib/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:10:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:8:\"use_ajax\";b:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";i:36;}}s:12:\"style_plugin\";s:5:\"table\";s:13:\"style_options\";a:5:{s:7:\"columns\";a:3:{s:5:\"title\";s:5:\"title\";s:4:\"name\";s:4:\"name\";s:7:\"changed\";s:7:\"changed\";}s:7:\"default\";s:5:\"title\";s:4:\"info\";a:3:{s:5:\"title\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:4:\"name\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:7:\"changed\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}}s:8:\"override\";i:1;s:6:\"sticky\";i:0;}s:6:\"fields\";a:3:{s:5:\"title\";a:4:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"link_to_node\";i:1;}s:4:\"name\";a:5:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:5:\"label\";s:6:\"Author\";s:12:\"link_to_user\";i:1;}s:7:\"changed\";a:5:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"changed\";s:5:\"label\";s:11:\"Last update\";s:11:\"date_format\";s:5:\"large\";}}s:9:\"arguments\";a:1:{s:5:\"title\";a:14:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:1:{s:12:\"title_enable\";i:1;}s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:1:\"a\";}s:7:\"summary\";a:1:{s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:1;s:8:\"glossary\";i:1;s:5:\"limit\";s:1:\"1\";s:4:\"case\";s:5:\"upper\";s:9:\"path_case\";s:5:\"lower\";s:14:\"transform_dash\";i:0;}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:4:\"page\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:203;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:0;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:6:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:3:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:8:\"glossary\";s:4:\"menu\";a:3:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:8:\"Glossary\";s:6:\"weight\";s:1:\"0\";}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}s:10:\"attachment\";O:13:\"views_display\":8:{s:7:\"handler\";O:31:\"views_plugin_display_attachment\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:349;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:10:\"attachment\";s:7:\"options\";a:45:{s:8:\"defaults\";a:35:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:0;s:5:\"pager\";b:0;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;s:9:\"use_pager\";b:0;s:14:\"items_per_page\";b:0;s:6:\"offset\";b:0;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:8:\"displays\";a:0:{}s:19:\"attachment_position\";s:6:\"before\";s:17:\"inherit_arguments\";b:1;s:23:\"inherit_exposed_filters\";b:0;s:13:\"inherit_pager\";b:0;s:12:\"render_pager\";b:0;}s:10:\"definition\";a:18:{s:5:\"title\";s:10:\"Attachment\";s:4:\"help\";s:79:\"Attachments added to other displays to achieve multiple views in the same view.\";s:7:\"handler\";s:31:\"views_plugin_display_attachment\";s:5:\"theme\";s:10:\"views_view\";s:26:\"contextual links locations\";a:0:{}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:0;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:0;s:10:\"help topic\";s:18:\"display-attachment\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:35:\"views_plugin_display_attachment.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:10:\"attachment\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:6:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:1:{s:6:\"offset\";s:1:\"0\";}}s:8:\"defaults\";a:1:{s:9:\"arguments\";b:0;}s:9:\"arguments\";a:1:{s:5:\"title\";a:15:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:14:\"default_action\";s:7:\"summary\";s:9:\"exception\";a:1:{s:12:\"title_enable\";i:1;}s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:1:\"a\";}s:7:\"summary\";a:1:{s:6:\"format\";s:19:\"unformatted_summary\";}s:15:\"summary_options\";a:3:{s:14:\"items_per_page\";s:2:\"25\";s:6:\"inline\";i:1;s:9:\"separator\";s:3:\" | \";}s:18:\"specify_validation\";i:1;s:8:\"glossary\";i:1;s:5:\"limit\";s:1:\"1\";s:4:\"case\";s:5:\"upper\";s:9:\"path_case\";s:5:\"lower\";s:14:\"transform_dash\";i:0;}}s:8:\"displays\";a:2:{s:7:\"default\";s:7:\"default\";s:4:\"page\";s:4:\"page\";}s:17:\"inherit_arguments\";i:0;}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:10:\"attachment\";s:13:\"display_title\";s:10:\"Attachment\";s:14:\"display_plugin\";s:10:\"attachment\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:19:\"localization_plugin\";O:30:\"views_plugin_localization_none\":9:{s:9:\"translate\";b:0;s:14:\"export_strings\";a:0:{}s:4:\"view\";r:1;s:7:\"display\";N;s:11:\"plugin_type\";s:12:\"localization\";s:11:\"plugin_name\";s:4:\"none\";s:7:\"options\";a:0:{}s:10:\"definition\";a:11:{s:5:\"title\";s:4:\"None\";s:4:\"help\";s:42:\"Do not pass admin strings for translation.\";s:7:\"handler\";s:30:\"views_plugin_localization_none\";s:10:\"help topic\";s:17:\"localization-none\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:34:\"views_plugin_localization_none.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"none\";}s:9:\"is_plugin\";b:1;}s:13:\"export_module\";s:4:\"node\";}',0,1371656313,1),('ctools_export:views_view:backlinks','O:4:\"view\":49:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:4:\"node\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:9:\"backlinks\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:81:\"Displays a list of nodes that link to the node, using the search backlinks table.\";s:3:\"tag\";s:7:\"default\";s:10:\"human_name\";s:9:\"Backlinks\";s:4:\"core\";i:0;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:1;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:3:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:48:\"sites/all/modules/contrib/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:12:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";i:30;}}s:12:\"style_plugin\";s:4:\"list\";s:13:\"style_options\";a:1:{s:4:\"type\";s:2:\"ol\";}s:10:\"row_plugin\";s:6:\"fields\";s:5:\"empty\";a:1:{s:4:\"text\";a:6:{s:2:\"id\";s:4:\"area\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:5:\"empty\";b:0;s:7:\"content\";s:19:\"No backlinks found.\";s:6:\"format\";s:1:\"1\";}}s:6:\"fields\";a:1:{s:5:\"title\";a:5:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:12:\"link_to_node\";i:1;}}s:9:\"arguments\";a:1:{s:3:\"nid\";a:10:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:20:\"search_node_links_to\";s:5:\"field\";s:3:\"nid\";s:14:\"default_action\";s:9:\"not found\";s:12:\"title_enable\";i:1;s:5:\"title\";s:21:\"Pages that link to %1\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:1:{s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:1;s:8:\"validate\";a:1:{s:4:\"type\";s:4:\"node\";}}}s:7:\"filters\";a:1:{s:6:\"status\";a:6:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:5:\"value\";i:1;s:5:\"group\";i:0;s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:4:\"page\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:188;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:0;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:6:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:3:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:16:\"node/%/backlinks\";s:4:\"menu\";a:3:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:15:\"What links here\";s:6:\"weight\";s:1:\"0\";}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}s:5:\"block\";O:13:\"views_display\":8:{s:7:\"handler\";O:26:\"views_plugin_display_block\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:334;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:5:\"block\";s:7:\"options\";a:41:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:0;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"block_description\";s:0:\"\";s:13:\"block_caching\";i:-1;}s:10:\"definition\";a:20:{s:5:\"title\";s:5:\"Block\";s:4:\"help\";s:28:\"Display the view as a block.\";s:7:\"handler\";s:26:\"views_plugin_display_block\";s:5:\"theme\";s:10:\"views_view\";s:15:\"uses hook block\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:5:\"block\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:5:\"Block\";s:10:\"help topic\";s:13:\"display-block\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:30:\"views_plugin_display_block.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:5:\"block\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:6:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:8:\"defaults\";a:6:{s:8:\"use_more\";b:0;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:9:\"arguments\";b:0;}s:8:\"use_more\";b:1;s:12:\"style_plugin\";s:4:\"list\";s:10:\"row_plugin\";s:6:\"fields\";s:9:\"arguments\";a:1:{s:3:\"nid\";a:10:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:20:\"search_node_links_to\";s:5:\"field\";s:3:\"nid\";s:14:\"default_action\";s:7:\"default\";s:12:\"title_enable\";i:1;s:5:\"title\";s:15:\"What links here\";s:21:\"default_argument_type\";s:4:\"node\";s:7:\"summary\";a:1:{s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:1;s:8:\"validate\";a:1:{s:4:\"type\";s:4:\"node\";}}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:5:\"block\";s:13:\"display_title\";s:15:\"What links here\";s:14:\"display_plugin\";s:5:\"block\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:13:\"export_module\";s:6:\"search\";}',0,1371656313,1),('ctools_export:views_view:taxonomy_term','O:4:\"view\":49:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:4:\"node\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:13:\"taxonomy_term\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:58:\"A view to emulate Drupal core\'s handling of taxonomy/term.\";s:3:\"tag\";s:7:\"default\";s:10:\"human_name\";s:13:\"Taxonomy term\";s:4:\"core\";i:7;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:1;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:3:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:48:\"sites/all/modules/contrib/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:10:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:1:{s:4:\"type\";s:4:\"full\";}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:4:\"node\";s:5:\"sorts\";a:2:{s:6:\"sticky\";a:4:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"sticky\";s:5:\"order\";s:4:\"DESC\";}s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:9:\"arguments\";a:2:{s:19:\"term_node_tid_depth\";a:13:{s:2:\"id\";s:19:\"term_node_tid_depth\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:19:\"term_node_tid_depth\";s:14:\"default_action\";s:9:\"not found\";s:9:\"exception\";a:1:{s:12:\"title_enable\";i:1;}s:12:\"title_enable\";i:1;s:5:\"title\";s:2:\"%1\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:1:{s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:1;s:8:\"validate\";a:1:{s:4:\"type\";s:13:\"taxonomy_term\";}s:5:\"depth\";s:1:\"0\";s:12:\"break_phrase\";i:1;}s:28:\"term_node_tid_depth_modifier\";a:7:{s:2:\"id\";s:28:\"term_node_tid_depth_modifier\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:28:\"term_node_tid_depth_modifier\";s:9:\"exception\";a:1:{s:12:\"title_enable\";i:1;}s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:1:{s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:1;}}s:7:\"filters\";a:1:{s:12:\"status_extra\";a:5:{s:2:\"id\";s:12:\"status_extra\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:12:\"status_extra\";s:5:\"group\";i:0;s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:4:\"page\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:193;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:0;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:6:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:2:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:15:\"taxonomy/term/%\";}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}s:4:\"feed\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_feed\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:335;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"feed\";s:7:\"options\";a:44:{s:8:\"defaults\";a:35:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:0;s:5:\"pager\";b:0;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;s:9:\"use_pager\";b:0;s:14:\"items_per_page\";b:0;s:6:\"offset\";b:0;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:3:\"rss\";s:13:\"style_options\";a:1:{s:11:\"description\";s:0:\"\";}s:10:\"row_plugin\";s:8:\"node_rss\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:6:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}s:8:\"displays\";a:0:{}s:14:\"sitename_title\";b:0;}s:10:\"definition\";a:17:{s:5:\"title\";s:4:\"Feed\";s:4:\"help\";s:48:\"Display the view as a feed, such as an RSS feed.\";s:7:\"handler\";s:25:\"views_plugin_display_feed\";s:14:\"uses hook menu\";b:1;s:8:\"use ajax\";b:0;s:9:\"use pager\";b:0;s:18:\"accept attachments\";b:0;s:5:\"admin\";s:4:\"Feed\";s:10:\"help topic\";s:12:\"display-feed\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_feed.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"feed\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:6:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";i:15;}}s:12:\"style_plugin\";s:3:\"rss\";s:10:\"row_plugin\";s:8:\"node_rss\";s:4:\"path\";s:22:\"taxonomy/term/%/%/feed\";s:8:\"displays\";a:2:{s:4:\"page\";s:4:\"page\";s:7:\"default\";i:0;}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:4:\"feed\";s:13:\"display_title\";s:4:\"Feed\";s:14:\"display_plugin\";s:4:\"feed\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:13:\"export_module\";s:8:\"taxonomy\";}',0,1371656313,1),('unpack_options:c5fdfbe0479c677d100f599829b77a8a:en','a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"1\";s:6:\"offset\";s:1:\"0\";}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:4:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";i:1;s:17:\"row_class_special\";i:1;}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:4:\"area\";a:11:{s:2:\"id\";s:4:\"area\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:10:\"No results\";s:5:\"empty\";b:1;s:7:\"content\";s:3:\"N/A\";s:6:\"format\";s:13:\"filtered_html\";s:8:\"tokenize\";i:0;}}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:8:{s:21:\"field_vm_read_latency\";a:34:{s:2:\"id\";s:21:\"field_vm_read_latency\";s:5:\"table\";s:32:\"field_data_field_vm_read_latency\";s:5:\"field\";s:21:\"field_vm_read_latency\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:12:\"Read latency\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";s:1:\"2\";s:13:\"prefix_suffix\";i:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:17:\"field_vm_read_ops\";a:34:{s:2:\"id\";s:17:\"field_vm_read_ops\";s:5:\"table\";s:28:\"field_data_field_vm_read_ops\";s:5:\"field\";s:17:\"field_vm_read_ops\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:8:\"Read ops\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";s:1:\"0\";s:13:\"prefix_suffix\";i:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:22:\"field_vm_write_latency\";a:34:{s:2:\"id\";s:22:\"field_vm_write_latency\";s:5:\"table\";s:33:\"field_data_field_vm_write_latency\";s:5:\"field\";s:22:\"field_vm_write_latency\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:13:\"Write latency\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";s:1:\"2\";s:13:\"prefix_suffix\";i:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:18:\"field_vm_write_ops\";a:34:{s:2:\"id\";s:18:\"field_vm_write_ops\";s:5:\"table\";s:29:\"field_data_field_vm_write_ops\";s:5:\"field\";s:18:\"field_vm_write_ops\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:9:\"Write ops\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";s:1:\"0\";s:13:\"prefix_suffix\";i:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:20:\"field_vm_hit_rate_pc\";a:34:{s:2:\"id\";s:20:\"field_vm_hit_rate_pc\";s:5:\"table\";s:31:\"field_data_field_vm_hit_rate_pc\";s:5:\"field\";s:20:\"field_vm_hit_rate_pc\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:10:\"Hit rate %\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:20:\"computed_field_plain\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:22:\"field_vm_cache_latency\";a:34:{s:2:\"id\";s:22:\"field_vm_cache_latency\";s:5:\"table\";s:33:\"field_data_field_vm_cache_latency\";s:5:\"field\";s:22:\"field_vm_cache_latency\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:13:\"Cache latency\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";s:1:\"2\";s:13:\"prefix_suffix\";i:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:22:\"field_vm_population_pc\";a:34:{s:2:\"id\";s:22:\"field_vm_population_pc\";s:5:\"table\";s:33:\"field_data_field_vm_population_pc\";s:5:\"field\";s:22:\"field_vm_population_pc\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:12:\"Population %\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:20:\"computed_field_plain\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:26:\"field_vm_insertion_rate_pc\";a:34:{s:2:\"id\";s:26:\"field_vm_insertion_rate_pc\";s:5:\"table\";s:37:\"field_data_field_vm_insertion_rate_pc\";s:5:\"field\";s:26:\"field_vm_insertion_rate_pc\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:16:\"Insertion rate %\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:20:\"computed_field_plain\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}}s:5:\"sorts\";a:1:{s:21:\"field_timestamp_value\";a:9:{s:2:\"id\";s:21:\"field_timestamp_value\";s:5:\"table\";s:26:\"field_data_field_timestamp\";s:5:\"field\";s:21:\"field_timestamp_value\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}}}s:9:\"arguments\";a:1:{s:18:\"field_vm_target_id\";a:22:{s:2:\"id\";s:18:\"field_vm_target_id\";s:5:\"table\";s:19:\"field_data_field_vm\";s:5:\"field\";s:18:\"field_vm_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:14:\"default_action\";s:5:\"empty\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";i:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";i:0;s:5:\"title\";s:0:\"\";s:17:\"breadcrumb_enable\";i:0;s:10:\"breadcrumb\";s:0:\"\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";i:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";s:1:\"1\";s:14:\"items_per_page\";s:2:\"25\";s:8:\"override\";i:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";s:1:\"0\";s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";i:0;s:3:\"not\";i:0;}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:10:\"vm_metrics\";s:10:\"vm_metrics\";}}}}',0,1371656313,1),('unpack_options:df4ab2a558cd9aa62cf7d5c3cd943cc1:en','a:44:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:0;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:99:\"Required for the VM metrics display. Modifying this display WILL break the metrics in the VM nodes.\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:11:\"entity_type\";s:4:\"node\";s:7:\"bundles\";a:1:{i:0;s:15:\"virtual_machine\";}s:13:\"argument_mode\";s:2:\"id\";s:16:\"default_argument\";N;s:10:\"show_title\";N;}',0,1371656313,1),('unpack_options:195d7cad74db6a5efc9b8c8169240c80:en','a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";s:1:\"0\";s:6:\"offset\";s:1:\"0\";s:2:\"id\";s:1:\"0\";s:11:\"total_pages\";s:0:\"\";s:8:\"quantity\";s:1:\"9\";s:4:\"tags\";a:4:{s:5:\"first\";s:8:\"« first\";s:8:\"previous\";s:12:\"‹ previous\";s:4:\"next\";s:8:\"next ›\";s:4:\"last\";s:7:\"last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";i:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:17:\"5, 10, 20, 40, 60\";s:26:\"items_per_page_options_all\";i:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";i:0;s:12:\"offset_label\";s:6:\"Offset\";}}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:4:\"area\";a:11:{s:2:\"id\";s:4:\"area\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:5:\"empty\";b:1;s:7:\"content\";s:37:\"The disk metrics could not be loaded.\";s:6:\"format\";s:13:\"filtered_html\";s:8:\"tokenize\";i:0;}}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:1:{s:5:\"title\";a:8:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:4:\"trim\";i:0;s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:0;s:10:\"strip_tags\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:1;}}s:5:\"sorts\";a:1:{s:5:\"title\";a:9:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"order\";s:3:\"ASC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}}}s:9:\"arguments\";a:1:{s:31:\"field_virtual_machine_target_id\";a:22:{s:2:\"id\";s:31:\"field_virtual_machine_target_id\";s:5:\"table\";s:32:\"field_data_field_virtual_machine\";s:5:\"field\";s:31:\"field_virtual_machine_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:14:\"default_action\";s:5:\"empty\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";i:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";i:0;s:5:\"title\";s:0:\"\";s:17:\"breadcrumb_enable\";i:0;s:10:\"breadcrumb\";s:0:\"\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";i:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";s:1:\"1\";s:14:\"items_per_page\";s:2:\"25\";s:8:\"override\";i:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";s:1:\"0\";s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";i:0;s:3:\"not\";i:0;}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:3:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:5:\"vdisk\";s:5:\"vdisk\";}}s:22:\"field_vdisk_type_value\";a:13:{s:2:\"id\";s:22:\"field_vdisk_type_value\";s:5:\"table\";s:27:\"field_data_field_vdisk_type\";s:5:\"field\";s:22:\"field_vdisk_type_value\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:2:\"!=\";s:5:\"value\";s:5:\"CACHE\";s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}}}',0,1371656313,1),('unpack_options:d447236be08ee1ef4c04422a48a99507:en','a:44:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:0;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:0;s:13:\"relationships\";b:1;s:6:\"fields\";b:0;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:4:\"area\";a:11:{s:2:\"id\";s:4:\"area\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:5:\"empty\";b:1;s:7:\"content\";s:3:\"N/A\";s:6:\"format\";s:13:\"filtered_html\";s:8:\"tokenize\";i:0;}}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:3:{s:5:\"title\";a:8:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:4:\"trim\";i:0;s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:0;s:10:\"strip_tags\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:1;}s:10:\"field_path\";a:34:{s:2:\"id\";s:10:\"field_path\";s:5:\"table\";s:21:\"field_data_field_path\";s:5:\"field\";s:10:\"field_path\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:4:\"Path\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:16:\"field_disk_index\";a:34:{s:2:\"id\";s:16:\"field_disk_index\";s:5:\"table\";s:27:\"field_data_field_disk_index\";s:5:\"field\";s:16:\"field_disk_index\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:10:\"Disk Index\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:2:{s:18:\"thousand_separator\";s:1:\" \";s:13:\"prefix_suffix\";i:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:11:\"entity_type\";s:4:\"node\";s:7:\"bundles\";a:1:{i:0;s:15:\"virtual_machine\";}s:13:\"argument_mode\";s:2:\"id\";s:16:\"default_argument\";N;s:10:\"show_title\";N;}',0,1371656313,1),('unpack_options:77e737b6016cd6b9b3f0c2de6ed38a03:en','a:44:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:0;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:0;s:13:\"relationships\";b:1;s:6:\"fields\";b:0;s:5:\"sorts\";b:1;s:9:\"arguments\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:4:\"area\";a:11:{s:2:\"id\";s:4:\"area\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:5:\"empty\";b:1;s:7:\"content\";s:3:\"N/A\";s:6:\"format\";s:13:\"filtered_html\";s:8:\"tokenize\";i:0;}}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:6:{s:5:\"title\";a:8:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:4:\"trim\";i:0;s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:0;s:10:\"strip_tags\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:1;}s:29:\"field_fa_administration_state\";a:34:{s:2:\"id\";s:29:\"field_fa_administration_state\";s:5:\"table\";s:40:\"field_data_field_fa_administration_state\";s:5:\"field\";s:29:\"field_fa_administration_state\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:26:\"field_fa_operational_state\";a:34:{s:2:\"id\";s:26:\"field_fa_operational_state\";s:5:\"table\";s:37:\"field_data_field_fa_operational_state\";s:5:\"field\";s:26:\"field_fa_operational_state\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:19:\"field_fa_cache_size\";a:34:{s:2:\"id\";s:19:\"field_fa_cache_size\";s:5:\"table\";s:30:\"field_data_field_fa_cache_size\";s:5:\"field\";s:19:\"field_fa_cache_size\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:16:\"field_vdisk_type\";a:3:{s:2:\"id\";s:16:\"field_vdisk_type\";s:5:\"table\";s:27:\"field_data_field_vdisk_type\";s:5:\"field\";s:16:\"field_vdisk_type\";}s:20:\"field_fa_sector_size\";a:34:{s:2:\"id\";s:20:\"field_fa_sector_size\";s:5:\"table\";s:31:\"field_data_field_fa_sector_size\";s:5:\"field\";s:20:\"field_fa_sector_size\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:11:\"Sector Size\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:1:{s:20:\"field_host_target_id\";a:22:{s:2:\"id\";s:20:\"field_host_target_id\";s:5:\"table\";s:21:\"field_data_field_host\";s:5:\"field\";s:20:\"field_host_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:14:\"default_action\";s:5:\"empty\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";i:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";i:0;s:5:\"title\";s:0:\"\";s:17:\"breadcrumb_enable\";i:0;s:10:\"breadcrumb\";s:0:\"\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";i:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";s:1:\"1\";s:14:\"items_per_page\";s:2:\"25\";s:8:\"override\";i:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";s:1:\"0\";s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";i:0;s:3:\"not\";i:0;}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:13:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:15:\"virtual_machine\";s:15:\"virtual_machine\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}}s:11:\"entity_type\";s:4:\"node\";s:7:\"bundles\";a:1:{i:0;s:4:\"host\";}s:13:\"argument_mode\";s:2:\"id\";s:16:\"default_argument\";s:0:\"\";s:10:\"show_title\";N;}',0,1371656313,1),('eva','a:1:{s:4:\"node\";a:3:{i:0;a:5:{s:4:\"name\";s:10:\"vm_metrics\";s:5:\"title\";s:27:\"EVA: VM metrics - EVA Field\";s:7:\"display\";s:13:\"entity_view_1\";s:7:\"bundles\";a:1:{i:0;s:15:\"virtual_machine\";}s:12:\"exposed form\";b:0;}i:1;a:5:{s:4:\"name\";s:19:\"vdisk_metric_per_vm\";s:5:\"title\";s:36:\"EVA: vDisk metric per VM - EVA Field\";s:7:\"display\";s:13:\"entity_view_1\";s:7:\"bundles\";a:1:{i:0;s:15:\"virtual_machine\";}s:12:\"exposed form\";b:0;}i:2;a:5:{s:4:\"name\";s:19:\"vdisk_metric_per_vm\";s:5:\"title\";s:38:\"EVA: vDisk metric per VM - EVA Field 2\";s:7:\"display\";s:13:\"entity_view_2\";s:7:\"bundles\";a:1:{i:0;s:4:\"host\";}s:12:\"exposed form\";b:0;}}}',0,1371656313,1);
/*!40000 ALTER TABLE `cache_views` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_views_data`
--

DROP TABLE IF EXISTS `cache_views_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_views_data` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '1' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Cache table for views to store pre-rendered queries,...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_views_data`
--

LOCK TABLES `cache_views_data` WRITE;
/*!40000 ALTER TABLE `cache_views_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `cache_views_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `comment`
--

DROP TABLE IF EXISTS `comment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `comment` (
  `cid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique comment ID.',
  `pid` int(11) NOT NULL DEFAULT '0' COMMENT 'The comment.cid to which this comment is a reply. If set to 0, this comment is not a reply to an existing comment.',
  `nid` int(11) NOT NULL DEFAULT '0' COMMENT 'The node.nid to which this comment is a reply.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid who authored the comment. If set to 0, this comment was created by an anonymous user.',
  `subject` varchar(64) NOT NULL DEFAULT '' COMMENT 'The comment title.',
  `hostname` varchar(128) NOT NULL DEFAULT '' COMMENT 'The author’s host name.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The time that the comment was created, as a Unix timestamp.',
  `changed` int(11) NOT NULL DEFAULT '0' COMMENT 'The time that the comment was last edited, as a Unix timestamp.',
  `status` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT 'The published status of a comment. (0 = Not Published, 1 = Published)',
  `thread` varchar(255) NOT NULL COMMENT 'The vancode representation of the comment’s place in a thread.',
  `name` varchar(60) DEFAULT NULL COMMENT 'The comment author’s name. Uses users.name if the user is logged in, otherwise uses the value typed into the comment form.',
  `mail` varchar(64) DEFAULT NULL COMMENT 'The comment author’s e-mail address from the comment form, if user is anonymous, and the ’Anonymous users may/must leave their contact information’ setting is turned on.',
  `homepage` varchar(255) DEFAULT NULL COMMENT 'The comment author’s home page address from the comment form, if user is anonymous, and the ’Anonymous users may/must leave their contact information’ setting is turned on.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The languages.language of this comment.',
  PRIMARY KEY (`cid`),
  KEY `comment_status_pid` (`pid`,`status`),
  KEY `comment_num_new` (`nid`,`status`,`created`,`cid`,`thread`),
  KEY `comment_uid` (`uid`),
  KEY `comment_nid_language` (`nid`,`language`),
  KEY `comment_created` (`created`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores comments and associated data.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `comment`
--

LOCK TABLES `comment` WRITE;
/*!40000 ALTER TABLE `comment` DISABLE KEYS */;
/*!40000 ALTER TABLE `comment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ctools_css_cache`
--

DROP TABLE IF EXISTS `ctools_css_cache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ctools_css_cache` (
  `cid` varchar(128) NOT NULL COMMENT 'The CSS ID this cache object belongs to.',
  `filename` varchar(255) DEFAULT NULL COMMENT 'The filename this CSS is stored in.',
  `css` longtext COMMENT 'CSS being stored.',
  `filter` tinyint(4) DEFAULT NULL COMMENT 'Whether or not this CSS needs to be filtered.',
  PRIMARY KEY (`cid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='A special cache used to store CSS that must be non-volatile.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ctools_css_cache`
--

LOCK TABLES `ctools_css_cache` WRITE;
/*!40000 ALTER TABLE `ctools_css_cache` DISABLE KEYS */;
/*!40000 ALTER TABLE `ctools_css_cache` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ctools_custom_content`
--

DROP TABLE IF EXISTS `ctools_custom_content`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ctools_custom_content` (
  `cid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'A database primary key to ensure uniqueness',
  `name` varchar(255) DEFAULT NULL COMMENT 'Unique ID for this content. Used to identify it programmatically.',
  `admin_title` varchar(255) DEFAULT NULL COMMENT 'Administrative title for this content.',
  `admin_description` longtext COMMENT 'Administrative description for this content.',
  `category` varchar(255) DEFAULT NULL COMMENT 'Administrative category for this content.',
  `settings` longtext COMMENT 'Serialized settings for the actual content to be used',
  PRIMARY KEY (`cid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Contains exportable customized content for this site.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ctools_custom_content`
--

LOCK TABLES `ctools_custom_content` WRITE;
/*!40000 ALTER TABLE `ctools_custom_content` DISABLE KEYS */;
/*!40000 ALTER TABLE `ctools_custom_content` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ctools_object_cache`
--

DROP TABLE IF EXISTS `ctools_object_cache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ctools_object_cache` (
  `sid` varchar(64) NOT NULL COMMENT 'The session ID this cache object belongs to.',
  `name` varchar(128) NOT NULL COMMENT 'The name of the object this cache is attached to.',
  `obj` varchar(32) NOT NULL COMMENT 'The type of the object this cache is attached to; this essentially represents the owner so that several sub-systems can use this cache.',
  `updated` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The time this cache was created or updated.',
  `data` longtext COMMENT 'Serialized data being stored.',
  PRIMARY KEY (`sid`,`obj`,`name`),
  KEY `updated` (`updated`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='A special cache used to store objects that are being...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ctools_object_cache`
--

LOCK TABLES `ctools_object_cache` WRITE;
/*!40000 ALTER TABLE `ctools_object_cache` DISABLE KEYS */;
INSERT INTO `ctools_object_cache` VALUES ('9lwq2yZJS-EIV3hQpMlmxeMdwP1Mtdy5qdqb-6orvqs','vdisks_test','view',1366376356,'O:4:\"view\":52:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:4:\"node\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:11:\"vdisks_test\";s:3:\"vid\";s:3:\"new\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:7:\"default\";s:10:\"human_name\";s:11:\"vDisks test\";s:4:\"core\";s:4:\"7.16\";s:11:\"api_version\";N;s:8:\"disabled\";N;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:5:\"query\";N;s:7:\"display\";a:2:{s:7:\"default\";O:13:\"views_display\":7:{s:15:\"display_options\";a:13:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";s:2:\"10\";}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:2:{s:3:\"nid\";a:22:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:3:\"Nid\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:0;}s:5:\"title\";a:22:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:5:\"Title\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:1;}}s:7:\"filters\";a:3:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:5:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:13:\"vdisk_metrics\";s:13:\"vdisk_metrics\";}s:5:\"group\";i:1;}s:21:\"field_vdisk_target_id\";a:13:{s:2:\"id\";s:21:\"field_vdisk_target_id\";s:5:\"table\";s:22:\"field_data_field_vdisk\";s:5:\"field\";s:21:\"field_vdisk_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";a:3:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:5:\"value\";s:5:\"24143\";}s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}}s:5:\"sorts\";a:1:{s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:5:\"title\";s:11:\"vDisks test\";s:11:\"row_options\";a:4:{s:22:\"default_field_elements\";i:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";i:0;}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:4:\"page\";O:13:\"views_display\":7:{s:15:\"display_options\";a:2:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:11:\"vdisks-test\";}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:19:\"localization_plugin\";O:30:\"views_plugin_localization_none\":9:{s:9:\"translate\";b:0;s:14:\"export_strings\";a:0:{}s:4:\"view\";R:1;s:7:\"display\";N;s:11:\"plugin_type\";s:12:\"localization\";s:11:\"plugin_name\";s:4:\"none\";s:7:\"options\";a:0:{}s:10:\"definition\";a:11:{s:5:\"title\";s:4:\"None\";s:4:\"help\";s:42:\"Do not pass admin strings for translation.\";s:7:\"handler\";s:30:\"views_plugin_localization_none\";s:10:\"help topic\";s:17:\"localization-none\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:34:\"views_plugin_localization_none.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"none\";}s:9:\"is_plugin\";b:1;}s:14:\"display_errors\";N;s:7:\"changed\";b:1;s:15:\"changed_display\";a:1:{s:7:\"default\";b:1;}s:5:\"stack\";a:0:{}s:16:\"changed_sections\";a:5:{s:35:\"default-filter-field_vdisk_id_value\";b:1;s:17:\"default-field-nid\";b:1;s:21:\"defaultrearrange-item\";b:1;s:19:\"default-field-title\";b:1;s:36:\"default-filter-field_vdisk_target_id\";b:1;}}'),('9Qud41LMTtmuSrzBe1rtWr5rX9GqgZ0zsgjjukFUN9M','page-home_page','page_manager_page',1366049386,'O:8:\"stdClass\":10:{s:9:\"task_name\";s:14:\"page-home_page\";s:10:\"subtask_id\";s:9:\"home_page\";s:7:\"task_id\";s:4:\"page\";s:4:\"task\";a:25:{s:5:\"title\";s:12:\"Custom pages\";s:11:\"description\";s:103:\"Administrator created pages that have a URL path, access control and entries in the Drupal menu system.\";s:14:\"non-exportable\";b:1;s:8:\"subtasks\";b:1;s:16:\"subtask callback\";s:25:\"page_manager_page_subtask\";s:17:\"subtasks callback\";s:26:\"page_manager_page_subtasks\";s:21:\"save subtask callback\";s:30:\"page_manager_page_save_subtask\";s:15:\"access callback\";s:30:\"page_manager_page_access_check\";s:9:\"hook menu\";a:3:{s:4:\"file\";s:14:\"page.admin.inc\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks\";s:8:\"function\";s:22:\"page_manager_page_menu\";}s:10:\"hook theme\";s:23:\"page_manager_page_theme\";s:9:\"task type\";s:4:\"page\";s:15:\"page operations\";a:1:{i:0;a:3:{s:5:\"title\";s:26:\" &raquo; Create a new page\";s:4:\"href\";s:25:\"admin/structure/pages/add\";s:4:\"html\";b:1;}}s:7:\"columns\";a:1:{s:7:\"storage\";a:2:{s:5:\"label\";s:7:\"Storage\";s:5:\"class\";s:25:\"page-manager-page-storage\";}}s:9:\"page type\";s:6:\"custom\";s:12:\"handler type\";s:7:\"context\";s:13:\"get arguments\";a:3:{s:4:\"file\";s:14:\"page.admin.inc\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks\";s:8:\"function\";s:31:\"page_manager_page_get_arguments\";}s:24:\"get context placeholders\";s:30:\"page_manager_page_get_contexts\";s:19:\"access restrictions\";s:37:\"page_manager_page_access_restrictions\";s:13:\"uses handlers\";b:1;s:6:\"module\";s:12:\"page_manager\";s:4:\"name\";s:4:\"page\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks\";s:4:\"file\";s:8:\"page.inc\";s:13:\"plugin module\";s:12:\"page_manager\";s:11:\"plugin type\";s:5:\"tasks\";}s:7:\"subtask\";a:14:{s:4:\"name\";s:9:\"home_page\";s:11:\"admin title\";s:9:\"Home page\";s:17:\"admin description\";s:0:\"\";s:13:\"admin summary\";s:31:\"page_manager_page_admin_summary\";s:10:\"admin path\";s:4:\"home\";s:10:\"admin type\";s:6:\"Custom\";s:7:\"subtask\";O:8:\"stdClass\":13:{s:3:\"pid\";s:1:\"1\";s:4:\"name\";s:9:\"home_page\";s:4:\"task\";s:4:\"page\";s:11:\"admin_title\";s:9:\"Home page\";s:17:\"admin_description\";s:0:\"\";s:4:\"path\";s:4:\"home\";s:6:\"access\";a:2:{s:7:\"plugins\";a:1:{i:0;a:4:{s:4:\"name\";s:4:\"role\";s:8:\"settings\";a:1:{s:4:\"rids\";a:1:{i:0;i:2;}}s:7:\"context\";s:14:\"logged-in-user\";s:3:\"not\";b:0;}}s:5:\"logic\";s:3:\"and\";}s:4:\"menu\";a:0:{}s:9:\"arguments\";a:0:{}s:4:\"conf\";a:1:{s:11:\"admin_paths\";b:0;}s:5:\"table\";s:18:\"page_manager_pages\";s:4:\"type\";s:6:\"Normal\";s:11:\"export_type\";i:1;}s:10:\"operations\";a:2:{s:8:\"settings\";a:4:{s:4:\"type\";s:5:\"group\";s:5:\"class\";a:1:{i:0;s:19:\"operations-settings\";}s:5:\"title\";s:8:\"Settings\";s:8:\"children\";a:3:{s:5:\"basic\";a:3:{s:5:\"title\";s:5:\"Basic\";s:11:\"description\";s:54:\"Edit name, path and other basic settings for the page.\";s:4:\"form\";s:28:\"page_manager_page_form_basic\";}s:6:\"access\";a:4:{s:5:\"title\";s:6:\"Access\";s:11:\"description\";s:40:\"Control what users can access this page.\";s:17:\"admin description\";s:106:\"Access rules are used to test if the page is accessible and any menu items associated with it are visible.\";s:4:\"form\";s:29:\"page_manager_page_form_access\";}s:4:\"menu\";a:3:{s:5:\"title\";s:4:\"Menu\";s:11:\"description\";s:47:\"Provide this page a visible menu or a menu tab.\";s:4:\"form\";s:27:\"page_manager_page_form_menu\";}}}s:7:\"actions\";a:1:{s:8:\"children\";a:3:{s:5:\"clone\";a:3:{s:5:\"title\";s:5:\"Clone\";s:11:\"description\";s:24:\"Make a copy of this page\";s:4:\"form\";s:28:\"page_manager_page_form_clone\";}s:6:\"export\";a:3:{s:5:\"title\";s:6:\"Export\";s:11:\"description\";s:72:\"Export this page as code that can be imported or embedded into a module.\";s:4:\"form\";s:29:\"page_manager_page_form_export\";}s:6:\"delete\";a:3:{s:5:\"title\";s:6:\"Delete\";s:11:\"description\";s:45:\"Remove this page from your system completely.\";s:4:\"form\";s:29:\"page_manager_page_form_delete\";}}}}s:18:\"operations include\";a:2:{s:4:\"file\";s:14:\"page.admin.inc\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/page_manager/plugins/tasks\";}s:11:\"single task\";b:1;s:9:\"row class\";s:20:\"page-manager-enabled\";s:7:\"storage\";s:6:\"Normal\";s:8:\"disabled\";b:0;s:15:\"enable callback\";s:24:\"page_manager_page_enable\";}s:8:\"handlers\";a:1:{s:28:\"page_home_page_panel_context\";O:8:\"stdClass\":10:{s:3:\"did\";s:1:\"1\";s:4:\"name\";s:28:\"page_home_page_panel_context\";s:4:\"task\";s:4:\"page\";s:7:\"subtask\";s:9:\"home_page\";s:7:\"handler\";s:13:\"panel_context\";s:6:\"weight\";s:1:\"0\";s:4:\"conf\";a:11:{s:5:\"title\";s:5:\"Panel\";s:9:\"no_blocks\";i:0;s:8:\"pipeline\";s:8:\"standard\";s:22:\"body_classes_to_remove\";s:0:\"\";s:19:\"body_classes_to_add\";s:0:\"\";s:6:\"css_id\";s:0:\"\";s:3:\"css\";s:0:\"\";s:8:\"contexts\";a:0:{}s:13:\"relationships\";a:0:{}s:3:\"did\";s:1:\"2\";s:7:\"display\";O:14:\"panels_display\":16:{s:4:\"args\";a:0:{}s:7:\"content\";a:1:{i:7;O:8:\"stdClass\":14:{s:3:\"pid\";s:1:\"7\";s:3:\"did\";s:1:\"2\";s:5:\"panel\";s:6:\"middle\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:33:\"mercury_utilities-home_page_block\";s:5:\"shown\";s:1:\"1\";s:6:\"access\";a:0:{}s:13:\"configuration\";a:2:{s:14:\"override_title\";i:1;s:19:\"override_title_text\";s:7:\"<block>\";}s:5:\"cache\";a:0:{}s:5:\"style\";a:1:{s:8:\"settings\";N;}s:3:\"css\";a:0:{}s:6:\"extras\";a:0:{}s:8:\"position\";s:1:\"0\";s:5:\"locks\";a:0:{}}}s:6:\"panels\";a:1:{s:6:\"middle\";a:1:{i:0;s:1:\"7\";}}s:16:\"incoming_content\";N;s:6:\"css_id\";N;s:7:\"context\";a:0:{}s:3:\"did\";s:1:\"2\";s:8:\"renderer\";s:8:\"standard\";s:6:\"layout\";s:6:\"onecol\";s:15:\"layout_settings\";a:0:{}s:14:\"panel_settings\";a:2:{s:14:\"style_settings\";a:2:{s:7:\"default\";N;s:6:\"middle\";N;}s:6:\"middle\";a:1:{s:5:\"style\";s:2:\"-1\";}}s:5:\"cache\";a:0:{}s:5:\"title\";s:0:\"\";s:10:\"hide_title\";s:1:\"1\";s:10:\"title_pane\";s:1:\"1\";s:9:\"cache_key\";s:57:\"panel_context:page-home_page:page_home_page_panel_context\";}}s:5:\"table\";s:21:\"page_manager_handlers\";s:4:\"type\";s:6:\"Normal\";s:11:\"export_type\";i:1;}}s:12:\"handler_info\";a:1:{s:28:\"page_home_page_panel_context\";a:3:{s:6:\"weight\";s:1:\"0\";s:7:\"changed\";i:2;s:4:\"name\";s:28:\"page_home_page_panel_context\";}}s:6:\"locked\";b:0;s:13:\"display_cache\";a:1:{s:28:\"page_home_page_panel_context\";O:8:\"stdClass\":4:{s:7:\"display\";R:136;s:13:\"content_types\";a:17:{s:4:\"node\";a:1:{s:4:\"node\";a:7:{s:5:\"title\";s:13:\"Existing node\";s:11:\"description\";s:37:\"Add a node from your site as content.\";s:4:\"icon\";s:73:\"sites/all/modules/contrib/ctools/plugins/content_types/node/icon_node.png\";s:8:\"category\";s:6:\"Custom\";s:9:\"top level\";b:1;s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/plugins/content_types/node\";s:2:\"js\";a:1:{i:0;s:20:\"misc/autocomplete.js\";}}}s:15:\"page_feed_icons\";a:1:{s:15:\"page_feed_icons\";a:5:{s:5:\"title\";s:10:\"Feed icons\";s:11:\"description\";s:45:\"Add the site feed_icons statement as content.\";s:4:\"icon\";s:51:\"sites/all/modules/contrib/ctools/images/no-icon.png\";s:8:\"category\";s:13:\"Page elements\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/plugins/content_types/page\";}}s:9:\"page_tabs\";a:1:{s:9:\"page_tabs\";a:5:{s:5:\"title\";s:4:\"Tabs\";s:11:\"description\";s:38:\"Add the tabs (local tasks) as content.\";s:4:\"icon\";s:51:\"sites/all/modules/contrib/ctools/images/no-icon.png\";s:8:\"category\";s:13:\"Page elements\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/plugins/content_types/page\";}}s:12:\"page_actions\";a:1:{s:12:\"page_actions\";a:5:{s:5:\"title\";s:7:\"Actions\";s:11:\"description\";s:46:\"Add the action links (local tasks) as content.\";s:4:\"icon\";s:51:\"sites/all/modules/contrib/ctools/images/no-icon.png\";s:8:\"category\";s:13:\"Page elements\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/plugins/content_types/page\";}}s:15:\"page_breadcrumb\";a:1:{s:15:\"page_breadcrumb\";a:5:{s:5:\"title\";s:10:\"Breadcrumb\";s:11:\"description\";s:36:\"Add the breadcrumb trail as content.\";s:4:\"icon\";s:51:\"sites/all/modules/contrib/ctools/images/no-icon.png\";s:8:\"category\";s:13:\"Page elements\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/plugins/content_types/page\";}}s:18:\"page_primary_links\";a:1:{s:18:\"page_primary_links\";a:5:{s:5:\"title\";s:24:\"Primary navigation links\";s:11:\"description\";s:47:\"Add the primary_links (local tasks) as content.\";s:4:\"icon\";s:51:\"sites/all/modules/contrib/ctools/images/no-icon.png\";s:8:\"category\";s:13:\"Page elements\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/plugins/content_types/page\";}}s:14:\"page_site_name\";a:1:{s:14:\"page_site_name\";a:5:{s:5:\"title\";s:9:\"Site name\";s:11:\"description\";s:21:\"The name of the site.\";s:4:\"icon\";s:51:\"sites/all/modules/contrib/ctools/images/no-icon.png\";s:8:\"category\";s:13:\"Page elements\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/plugins/content_types/page\";}}s:10:\"page_title\";a:1:{s:10:\"page_title\";a:5:{s:5:\"title\";s:10:\"Page title\";s:11:\"description\";s:30:\"Add the page title as content.\";s:4:\"icon\";s:51:\"sites/all/modules/contrib/ctools/images/no-icon.png\";s:8:\"category\";s:13:\"Page elements\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/plugins/content_types/page\";}}s:20:\"page_secondary_links\";a:1:{s:20:\"page_secondary_links\";a:5:{s:5:\"title\";s:26:\"Secondary navigation links\";s:11:\"description\";s:49:\"Add the secondary_links (local tasks) as content.\";s:4:\"icon\";s:51:\"sites/all/modules/contrib/ctools/images/no-icon.png\";s:8:\"category\";s:13:\"Page elements\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/plugins/content_types/page\";}}s:13:\"page_messages\";a:1:{s:13:\"page_messages\";a:5:{s:5:\"title\";s:15:\"Status messages\";s:11:\"description\";s:55:\"Add the status messages of the current page as content.\";s:4:\"icon\";s:51:\"sites/all/modules/contrib/ctools/images/no-icon.png\";s:8:\"category\";s:13:\"Page elements\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/plugins/content_types/page\";}}s:11:\"page_slogan\";a:1:{s:11:\"page_slogan\";a:5:{s:5:\"title\";s:11:\"Site slogan\";s:11:\"description\";s:32:\"Add the slogan trail as content.\";s:4:\"icon\";s:51:\"sites/all/modules/contrib/ctools/images/no-icon.png\";s:8:\"category\";s:13:\"Page elements\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/plugins/content_types/page\";}}s:9:\"page_logo\";a:1:{s:9:\"page_logo\";a:5:{s:5:\"title\";s:9:\"Site logo\";s:11:\"description\";s:30:\"Add the logo trail as content.\";s:4:\"icon\";s:51:\"sites/all/modules/contrib/ctools/images/no-icon.png\";s:8:\"category\";s:13:\"Page elements\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/plugins/content_types/page\";}}s:9:\"page_help\";a:1:{s:9:\"page_help\";a:5:{s:5:\"title\";s:4:\"Help\";s:11:\"description\";s:49:\"Add the help text of the current page as content.\";s:4:\"icon\";s:51:\"sites/all/modules/contrib/ctools/images/no-icon.png\";s:8:\"category\";s:13:\"Page elements\";s:4:\"path\";s:59:\"sites/all/modules/contrib/ctools/plugins/content_types/page\";}}s:5:\"block\";a:33:{s:7:\"block-1\";a:5:{s:5:\"title\";s:11:\"footer-logo\";s:4:\"icon\";s:25:\"icon_core_block_empty.png\";s:8:\"category\";s:13:\"Custom blocks\";s:8:\"defaults\";a:2:{s:14:\"override_title\";b:1;s:19:\"override_title_text\";s:0:\"\";}s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:7:\"block-2\";a:5:{s:5:\"title\";s:11:\"header-menu\";s:4:\"icon\";s:25:\"icon_core_block_empty.png\";s:8:\"category\";s:13:\"Custom blocks\";s:8:\"defaults\";a:2:{s:14:\"override_title\";b:1;s:19:\"override_title_text\";s:0:\"\";}s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:7:\"block-7\";a:5:{s:5:\"title\";s:28:\"Host node edit/refresh links\";s:4:\"icon\";s:25:\"icon_core_block_empty.png\";s:8:\"category\";s:13:\"Custom blocks\";s:8:\"defaults\";a:2:{s:14:\"override_title\";b:1;s:19:\"override_title_text\";s:0:\"\";}s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:7:\"block-3\";a:5:{s:5:\"title\";s:26:\"jump-to-header-right-block\";s:4:\"icon\";s:25:\"icon_core_block_empty.png\";s:8:\"category\";s:13:\"Custom blocks\";s:8:\"defaults\";a:2:{s:14:\"override_title\";b:1;s:19:\"override_title_text\";s:0:\"\";}s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:7:\"block-6\";a:5:{s:5:\"title\";s:35:\"VM historical performance edit link\";s:4:\"icon\";s:25:\"icon_core_block_empty.png\";s:8:\"category\";s:13:\"Custom blocks\";s:8:\"defaults\";a:2:{s:14:\"override_title\";b:1;s:19:\"override_title_text\";s:0:\"\";}s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:7:\"block-4\";a:5:{s:5:\"title\";s:26:\"VM node edit/refresh links\";s:4:\"icon\";s:25:\"icon_core_block_empty.png\";s:8:\"category\";s:13:\"Custom blocks\";s:8:\"defaults\";a:2:{s:14:\"override_title\";b:1;s:19:\"override_title_text\";s:0:\"\";}s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:7:\"block-5\";a:5:{s:5:\"title\";s:13:\"VM page links\";s:4:\"icon\";s:25:\"icon_core_block_empty.png\";s:8:\"category\";s:13:\"Custom blocks\";s:8:\"defaults\";a:2:{s:14:\"override_title\";b:1;s:19:\"override_title_text\";s:7:\"Show me\";}s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:14:\"comment-recent\";a:4:{s:5:\"title\";s:15:\"Recent comments\";s:4:\"icon\";s:28:\"icon_core_recentcomments.png\";s:8:\"category\";s:8:\"Activity\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:37:\"logintoboggan-logintoboggan_logged_in\";a:4:{s:5:\"title\";s:29:\"LoginToboggan logged in block\";s:4:\"icon\";s:22:\"icon_contrib_block.png\";s:8:\"category\";s:13:\"Miscellaneous\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:26:\"menu-menu-bulk-action-tool\";a:4:{s:5:\"title\";s:16:\"Bulk Action Tool\";s:4:\"icon\";s:24:\"icon_core_block_menu.png\";s:8:\"category\";s:5:\"Menus\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:28:\"menu-menu-mercury-navigation\";a:4:{s:5:\"title\";s:10:\"Navigation\";s:4:\"icon\";s:24:\"icon_core_block_menu.png\";s:8:\"category\";s:5:\"Menus\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:16:\"menu-menu-refine\";a:4:{s:5:\"title\";s:6:\"Refine\";s:4:\"icon\";s:24:\"icon_core_block_menu.png\";s:8:\"category\";s:5:\"Menus\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:23:\"menu-menu-selector-tool\";a:4:{s:5:\"title\";s:13:\"Selector Tool\";s:4:\"icon\";s:24:\"icon_core_block_menu.png\";s:8:\"category\";s:5:\"Menus\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:33:\"mercury_utilities-home_page_block\";a:4:{s:5:\"title\";s:30:\"Mercury vCenter Inventory View\";s:4:\"icon\";s:22:\"icon_contrib_block.png\";s:8:\"category\";s:13:\"Miscellaneous\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:33:\"mercury_utilities-select_vm_block\";a:4:{s:5:\"title\";s:24:\"Mercury VM Selector Tool\";s:4:\"icon\";s:22:\"icon_contrib_block.png\";s:8:\"category\";s:13:\"Miscellaneous\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:35:\"mercury_utilities-select_host_block\";a:4:{s:5:\"title\";s:26:\"Mercury Host Selector Tool\";s:4:\"icon\";s:22:\"icon_contrib_block.png\";s:8:\"category\";s:13:\"Miscellaneous\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:39:\"mercury_utilities-bulk_actions_vm_block\";a:4:{s:5:\"title\";s:23:\"Mercury VM Bulk Actions\";s:4:\"icon\";s:22:\"icon_contrib_block.png\";s:8:\"category\";s:13:\"Miscellaneous\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:41:\"mercury_utilities-bulk_actions_host_block\";a:4:{s:5:\"title\";s:25:\"Mercury Host Bulk Actions\";s:4:\"icon\";s:22:\"icon_contrib_block.png\";s:8:\"category\";s:13:\"Miscellaneous\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:41:\"mercury_utilities-ongoing_processes_block\";a:4:{s:5:\"title\";s:17:\"Ongoing Processes\";s:4:\"icon\";s:22:\"icon_contrib_block.png\";s:8:\"category\";s:13:\"Miscellaneous\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:14:\"node-syndicate\";a:4:{s:5:\"title\";s:9:\"Syndicate\";s:4:\"icon\";s:23:\"icon_core_syndicate.png\";s:8:\"category\";s:7:\"Widgets\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:11:\"node-recent\";a:4:{s:5:\"title\";s:14:\"Recent content\";s:4:\"icon\";s:23:\"icon_core_syndicate.png\";s:8:\"category\";s:7:\"Widgets\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:11:\"search-form\";a:4:{s:5:\"title\";s:11:\"Search form\";s:4:\"icon\";s:24:\"icon_core_searchform.png\";s:8:\"category\";s:7:\"Widgets\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:22:\"search_api_page-search\";a:4:{s:5:\"title\";s:20:\"Search block: Search\";s:4:\"icon\";s:22:\"icon_contrib_block.png\";s:8:\"category\";s:13:\"Miscellaneous\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:18:\"shortcut-shortcuts\";a:4:{s:5:\"title\";s:9:\"Shortcuts\";s:4:\"icon\";s:22:\"icon_contrib_block.png\";s:8:\"category\";s:13:\"Miscellaneous\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:17:\"system-powered-by\";a:4:{s:5:\"title\";s:17:\"Powered by Drupal\";s:4:\"icon\";s:20:\"icon_core_drupal.png\";s:8:\"category\";s:7:\"Widgets\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:11:\"system-help\";a:4:{s:5:\"title\";s:11:\"System help\";s:4:\"icon\";s:20:\"icon_core_drupal.png\";s:8:\"category\";s:13:\"Page elements\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:17:\"system-navigation\";a:4:{s:5:\"title\";s:10:\"Navigation\";s:4:\"icon\";s:24:\"icon_core_navigation.png\";s:8:\"category\";s:5:\"Menus\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:17:\"system-management\";a:4:{s:5:\"title\";s:10:\"Management\";s:4:\"icon\";s:24:\"icon_core_block_menu.png\";s:8:\"category\";s:5:\"Menus\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:16:\"system-user-menu\";a:4:{s:5:\"title\";s:9:\"User menu\";s:4:\"icon\";s:24:\"icon_core_block_menu.png\";s:8:\"category\";s:5:\"Menus\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:16:\"system-main-menu\";a:4:{s:5:\"title\";s:9:\"Main menu\";s:4:\"icon\";s:24:\"icon_core_block_menu.png\";s:8:\"category\";s:5:\"Menus\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:10:\"user-login\";a:5:{s:5:\"title\";s:10:\"User login\";s:8:\"category\";s:7:\"Widgets\";s:4:\"icon\";s:23:\"icon_core_userlogin.png\";s:15:\"render callback\";s:29:\"ctools_user_login_pane_render\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:8:\"user-new\";a:4:{s:5:\"title\";s:9:\"Who\'s new\";s:8:\"category\";s:8:\"Activity\";s:4:\"icon\";s:21:\"icon_core_whosnew.png\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}s:11:\"user-online\";a:4:{s:5:\"title\";s:12:\"Who\'s online\";s:8:\"category\";s:8:\"Activity\";s:4:\"icon\";s:24:\"icon_core_whosonline.png\";s:4:\"path\";s:60:\"sites/all/modules/contrib/ctools/plugins/content_types/block\";}}s:6:\"custom\";a:1:{s:6:\"custom\";a:10:{s:4:\"name\";s:6:\"custom\";s:5:\"title\";s:18:\"New custom content\";s:9:\"top level\";b:1;s:8:\"category\";s:6:\"Custom\";s:11:\"description\";s:49:\"Create a completely custom piece of HTML content.\";s:9:\"edit form\";s:36:\"ctools_custom_content_type_edit_form\";s:12:\"all contexts\";b:1;s:14:\"check editable\";s:35:\"ctools_custom_content_type_editable\";s:4:\"path\";s:61:\"sites/all/modules/contrib/ctools/plugins/content_types/custom\";s:2:\"js\";a:3:{i:0;s:20:\"misc/autocomplete.js\";i:1;s:16:\"misc/textarea.js\";i:2;s:16:\"misc/collapse.js\";}}}s:11:\"search_form\";a:1:{s:11:\"search_form\";a:6:{s:5:\"title\";s:20:\"Advanced search form\";s:11:\"description\";s:36:\"A search form with advanced options.\";s:4:\"icon\";s:77:\"sites/all/modules/contrib/ctools/plugins/content_types/search/icon_search.png\";s:8:\"category\";s:7:\"Widgets\";s:16:\"required context\";O:23:\"ctools_context_optional\":4:{s:8:\"required\";b:0;s:8:\"keywords\";s:6:\"string\";s:5:\"title\";s:8:\"Keywords\";s:15:\"skip_name_check\";b:0;}s:4:\"path\";s:61:\"sites/all/modules/contrib/ctools/plugins/content_types/search\";}}s:5:\"views\";a:8:{s:7:\"devices\";a:6:{s:4:\"view\";s:7:\"devices\";s:5:\"title\";s:7:\"Devices\";s:4:\"icon\";s:26:\"icon_views_page_legacy.png\";s:11:\"description\";s:0:\"\";s:8:\"category\";s:5:\"Views\";s:4:\"path\";s:68:\"sites/all/modules/contrib/ctools/views_content/plugins/content_types\";}s:8:\"all_host\";a:6:{s:4:\"view\";s:8:\"all_host\";s:5:\"title\";s:8:\"all_host\";s:4:\"icon\";s:26:\"icon_views_page_legacy.png\";s:11:\"description\";s:0:\"\";s:8:\"category\";s:5:\"Views\";s:4:\"path\";s:68:\"sites/all/modules/contrib/ctools/views_content/plugins/content_types\";}s:10:\"vm_metrics\";a:6:{s:4:\"view\";s:10:\"vm_metrics\";s:5:\"title\";s:10:\"VM metrics\";s:4:\"icon\";s:26:\"icon_views_page_legacy.png\";s:11:\"description\";s:114:\"This view displays the metrics for VMs. Modifying this may break the metrics. Deleting this may break application.\";s:8:\"category\";s:5:\"Views\";s:4:\"path\";s:68:\"sites/all/modules/contrib/ctools/views_content/plugins/content_types\";}s:19:\"vdisk_metric_per_vm\";a:6:{s:4:\"view\";s:19:\"vdisk_metric_per_vm\";s:5:\"title\";s:19:\"vDisk metric per VM\";s:4:\"icon\";s:26:\"icon_views_page_legacy.png\";s:11:\"description\";s:0:\"\";s:8:\"category\";s:5:\"Views\";s:4:\"path\";s:68:\"sites/all/modules/contrib/ctools/views_content/plugins/content_types\";}s:18:\"vm_metric_per_host\";a:6:{s:4:\"view\";s:18:\"vm_metric_per_host\";s:5:\"title\";s:18:\"VM metric per Host\";s:4:\"icon\";s:26:\"icon_views_page_legacy.png\";s:11:\"description\";s:0:\"\";s:8:\"category\";s:5:\"Views\";s:4:\"path\";s:68:\"sites/all/modules/contrib/ctools/views_content/plugins/content_types\";}s:19:\"console_log_reports\";a:6:{s:4:\"view\";s:19:\"console_log_reports\";s:5:\"title\";s:19:\"Console Logs Report\";s:4:\"icon\";s:26:\"icon_views_page_legacy.png\";s:11:\"description\";s:0:\"\";s:8:\"category\";s:5:\"Views\";s:4:\"path\";s:68:\"sites/all/modules/contrib/ctools/views_content/plugins/content_types\";}s:17:\"ongoing_processes\";a:6:{s:4:\"view\";s:17:\"ongoing_processes\";s:5:\"title\";s:17:\"Ongoing Processes\";s:4:\"icon\";s:26:\"icon_views_page_legacy.png\";s:11:\"description\";s:0:\"\";s:8:\"category\";s:5:\"Views\";s:4:\"path\";s:68:\"sites/all/modules/contrib/ctools/views_content/plugins/content_types\";}s:6:\"all_vm\";a:6:{s:4:\"view\";s:6:\"all_vm\";s:5:\"title\";s:6:\"all_vm\";s:4:\"icon\";s:26:\"icon_views_page_legacy.png\";s:11:\"description\";s:0:\"\";s:8:\"category\";s:5:\"Views\";s:4:\"path\";s:68:\"sites/all/modules/contrib/ctools/views_content/plugins/content_types\";}}}s:13:\"display_title\";b:1;s:6:\"locked\";b:0;}}s:7:\"changed\";b:1;}'),('qLKHrQz0OlDND7M9QLIJhcSsvpflMdk_w1exyJ0iYhc','vm_metrics','view',1368514520,'O:4:\"view\":54:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:4:\"node\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:10:\"vm_metrics\";s:3:\"vid\";s:1:\"4\";s:11:\"description\";s:114:\"This view displays the metrics for VMs. Modifying this may break the metrics. Deleting this may break application.\";s:3:\"tag\";s:7:\"default\";s:10:\"human_name\";s:10:\"VM metrics\";s:4:\"core\";s:1:\"7\";s:11:\"api_version\";N;s:8:\"disabled\";N;s:7:\"editing\";b:1;s:4:\"args\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:5:\"query\";N;s:7:\"display\";a:2:{s:7:\"default\";O:13:\"views_display\":7:{s:15:\"display_options\";a:13:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"1\";s:6:\"offset\";s:1:\"0\";}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:7:{s:21:\"field_vm_read_latency\";a:34:{s:2:\"id\";s:21:\"field_vm_read_latency\";s:5:\"table\";s:32:\"field_data_field_vm_read_latency\";s:5:\"field\";s:21:\"field_vm_read_latency\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:12:\"Read latency\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";s:1:\"2\";s:13:\"prefix_suffix\";i:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:17:\"field_vm_read_ops\";a:34:{s:2:\"id\";s:17:\"field_vm_read_ops\";s:5:\"table\";s:28:\"field_data_field_vm_read_ops\";s:5:\"field\";s:17:\"field_vm_read_ops\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:8:\"Read ops\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";s:1:\"0\";s:13:\"prefix_suffix\";i:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:22:\"field_vm_write_latency\";a:34:{s:2:\"id\";s:22:\"field_vm_write_latency\";s:5:\"table\";s:33:\"field_data_field_vm_write_latency\";s:5:\"field\";s:22:\"field_vm_write_latency\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:13:\"Write latency\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";s:1:\"2\";s:13:\"prefix_suffix\";i:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:18:\"field_vm_write_ops\";a:34:{s:2:\"id\";s:18:\"field_vm_write_ops\";s:5:\"table\";s:29:\"field_data_field_vm_write_ops\";s:5:\"field\";s:18:\"field_vm_write_ops\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:9:\"Write ops\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";s:1:\"0\";s:13:\"prefix_suffix\";i:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:22:\"field_vm_cache_latency\";a:34:{s:2:\"id\";s:22:\"field_vm_cache_latency\";s:5:\"table\";s:33:\"field_data_field_vm_cache_latency\";s:5:\"field\";s:22:\"field_vm_cache_latency\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:13:\"Cache latency\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";s:1:\"2\";s:13:\"prefix_suffix\";i:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:22:\"field_vm_population_pc\";a:34:{s:2:\"id\";s:22:\"field_vm_population_pc\";s:5:\"table\";s:33:\"field_data_field_vm_population_pc\";s:5:\"field\";s:22:\"field_vm_population_pc\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:12:\"Population %\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:20:\"computed_field_plain\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:26:\"field_vm_insertion_rate_pc\";a:34:{s:2:\"id\";s:26:\"field_vm_insertion_rate_pc\";s:5:\"table\";s:37:\"field_data_field_vm_insertion_rate_pc\";s:5:\"field\";s:26:\"field_vm_insertion_rate_pc\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:16:\"Insertion rate %\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:20:\"computed_field_plain\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}}s:7:\"filters\";a:2:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:10:\"vm_metrics\";s:10:\"vm_metrics\";}}}s:5:\"sorts\";a:1:{s:21:\"field_timestamp_value\";a:9:{s:2:\"id\";s:21:\"field_timestamp_value\";s:5:\"table\";s:26:\"field_data_field_timestamp\";s:5:\"field\";s:21:\"field_timestamp_value\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}}}s:13:\"style_options\";a:4:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";i:1;s:17:\"row_class_special\";i:1;}s:9:\"arguments\";a:1:{s:18:\"field_vm_target_id\";a:22:{s:2:\"id\";s:18:\"field_vm_target_id\";s:5:\"table\";s:19:\"field_data_field_vm\";s:5:\"field\";s:18:\"field_vm_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:14:\"default_action\";s:5:\"empty\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";i:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";i:0;s:5:\"title\";s:0:\"\";s:17:\"breadcrumb_enable\";i:0;s:10:\"breadcrumb\";s:0:\"\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";i:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";s:1:\"1\";s:14:\"items_per_page\";s:2:\"25\";s:8:\"override\";i:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";s:1:\"0\";s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";i:0;s:3:\"not\";i:0;}}s:5:\"empty\";a:1:{s:4:\"area\";a:11:{s:2:\"id\";s:4:\"area\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:10:\"No results\";s:5:\"empty\";b:1;s:7:\"content\";s:3:\"N/A\";s:6:\"format\";s:13:\"filtered_html\";s:8:\"tokenize\";i:0;}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";s:1:\"4\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";s:1:\"1\";}s:13:\"entity_view_1\";O:13:\"views_display\":7:{s:15:\"display_options\";a:6:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:7:\"bundles\";a:1:{i:0;s:15:\"virtual_machine\";}s:13:\"argument_mode\";s:2:\"id\";s:16:\"default_argument\";N;s:15:\"display_comment\";s:99:\"Required for the VM metrics display. Modifying this display WILL break the metrics in the VM nodes.\";}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";s:1:\"4\";s:2:\"id\";s:13:\"entity_view_1\";s:13:\"display_title\";s:9:\"EVA Field\";s:14:\"display_plugin\";s:11:\"entity_view\";s:8:\"position\";s:1:\"2\";}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:5:\"table\";s:10:\"views_view\";s:4:\"type\";s:6:\"Normal\";s:11:\"export_type\";i:1;s:8:\"executed\";b:0;s:5:\"built\";b:0;s:10:\"build_info\";a:0:{}s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:6:\"locked\";b:0;s:19:\"localization_plugin\";O:30:\"views_plugin_localization_none\":9:{s:9:\"translate\";b:0;s:14:\"export_strings\";a:0:{}s:4:\"view\";r:1;s:7:\"display\";N;s:11:\"plugin_type\";s:12:\"localization\";s:11:\"plugin_name\";s:4:\"none\";s:7:\"options\";a:0:{}s:10:\"definition\";a:11:{s:5:\"title\";s:4:\"None\";s:4:\"help\";s:42:\"Do not pass admin strings for translation.\";s:7:\"handler\";s:30:\"views_plugin_localization_none\";s:10:\"help topic\";s:17:\"localization-none\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:34:\"views_plugin_localization_none.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"none\";}s:9:\"is_plugin\";b:1;}s:14:\"display_errors\";N;s:19:\"relationships_fixed\";b:1;s:21:\"relationships_changed\";b:1;s:7:\"changed\";b:1;s:15:\"changed_display\";a:1:{s:7:\"default\";b:1;}}'),('qLKHrQz0OlDND7M9QLIJhcSsvpflMdk_w1exyJ0iYhc','vdisk_metric_test','view',1368518324,'O:4:\"view\":52:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:4:\"node\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:17:\"vdisk_metric_test\";s:3:\"vid\";s:3:\"new\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:7:\"default\";s:10:\"human_name\";s:17:\"vdisk metric test\";s:4:\"core\";s:4:\"7.16\";s:11:\"api_version\";N;s:8:\"disabled\";N;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:5:\"query\";N;s:7:\"display\";a:2:{s:7:\"default\";O:13:\"views_display\":7:{s:15:\"display_options\";a:11:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:1:{s:14:\"items_per_page\";s:1:\"5\";}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:2:{s:5:\"title\";a:8:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:4:\"trim\";i:0;s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:0;s:10:\"strip_tags\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:1;}s:3:\"nid\";a:22:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:3:\"Nid\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:0;}}s:7:\"filters\";a:3:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:13:\"vdisk_metrics\";s:13:\"vdisk_metrics\";}}s:21:\"field_vdisk_target_id\";a:13:{s:2:\"id\";s:21:\"field_vdisk_target_id\";s:5:\"table\";s:22:\"field_data_field_vdisk\";s:5:\"field\";s:21:\"field_vdisk_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";a:3:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:5:\"value\";s:5:\"89924\";}s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}}s:5:\"sorts\";a:1:{s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:5:\"title\";s:17:\"vdisk metric test\";}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:5:\"block\";O:13:\"views_display\":7:{s:15:\"display_options\";a:2:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"field\";a:1:{s:5:\"title\";a:1:{s:12:\"link_to_node\";i:1;}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:5:\"block\";s:13:\"display_title\";s:5:\"Block\";s:14:\"display_plugin\";s:5:\"block\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:19:\"localization_plugin\";O:30:\"views_plugin_localization_none\":9:{s:9:\"translate\";b:0;s:14:\"export_strings\";a:0:{}s:4:\"view\";R:1;s:7:\"display\";N;s:11:\"plugin_type\";s:12:\"localization\";s:11:\"plugin_name\";s:4:\"none\";s:7:\"options\";a:0:{}s:10:\"definition\";a:11:{s:5:\"title\";s:4:\"None\";s:4:\"help\";s:42:\"Do not pass admin strings for translation.\";s:7:\"handler\";s:30:\"views_plugin_localization_none\";s:10:\"help topic\";s:17:\"localization-none\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:37:\"sites/all/modules/contrib/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/contrib/views/plugins\";s:4:\"file\";s:34:\"views_plugin_localization_none.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"none\";}s:9:\"is_plugin\";b:1;}s:14:\"display_errors\";N;s:7:\"changed\";b:1;s:15:\"changed_display\";a:1:{s:7:\"default\";b:1;}s:5:\"stack\";a:0:{}s:16:\"changed_sections\";a:2:{s:36:\"default-filter-field_vdisk_target_id\";b:1;s:17:\"default-field-nid\";b:1;}}');
/*!40000 ALTER TABLE `ctools_object_cache` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `date_format_locale`
--

DROP TABLE IF EXISTS `date_format_locale`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `date_format_locale` (
  `format` varchar(100) NOT NULL COMMENT 'The date format string.',
  `type` varchar(64) NOT NULL COMMENT 'The date format type, e.g. medium.',
  `language` varchar(12) NOT NULL COMMENT 'A languages.language for this format to be used with.',
  PRIMARY KEY (`type`,`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores configured date formats for each locale.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `date_format_locale`
--

LOCK TABLES `date_format_locale` WRITE;
/*!40000 ALTER TABLE `date_format_locale` DISABLE KEYS */;
/*!40000 ALTER TABLE `date_format_locale` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `date_format_type`
--

DROP TABLE IF EXISTS `date_format_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `date_format_type` (
  `type` varchar(64) NOT NULL COMMENT 'The date format type, e.g. medium.',
  `title` varchar(255) NOT NULL COMMENT 'The human readable name of the format type.',
  `locked` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Whether or not this is a system provided format.',
  PRIMARY KEY (`type`),
  KEY `title` (`title`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores configured date format types.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `date_format_type`
--

LOCK TABLES `date_format_type` WRITE;
/*!40000 ALTER TABLE `date_format_type` DISABLE KEYS */;
INSERT INTO `date_format_type` VALUES ('long','Long',1),('medium','Medium',1),('short','Short',1);
/*!40000 ALTER TABLE `date_format_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `date_formats`
--

DROP TABLE IF EXISTS `date_formats`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `date_formats` (
  `dfid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The date format identifier.',
  `format` varchar(100) NOT NULL COMMENT 'The date format string.',
  `type` varchar(64) NOT NULL COMMENT 'The date format type, e.g. medium.',
  `locked` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Whether or not this format can be modified.',
  PRIMARY KEY (`dfid`),
  UNIQUE KEY `formats` (`format`,`type`)
) ENGINE=MyISAM AUTO_INCREMENT=36 DEFAULT CHARSET=utf8 COMMENT='Stores configured date formats.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `date_formats`
--

LOCK TABLES `date_formats` WRITE;
/*!40000 ALTER TABLE `date_formats` DISABLE KEYS */;
INSERT INTO `date_formats` VALUES (1,'Y-m-d H:i','short',1),(2,'m/d/Y - H:i','short',1),(3,'d/m/Y - H:i','short',1),(4,'Y/m/d - H:i','short',1),(5,'d.m.Y - H:i','short',1),(6,'m/d/Y - g:ia','short',1),(7,'d/m/Y - g:ia','short',1),(8,'Y/m/d - g:ia','short',1),(9,'M j Y - H:i','short',1),(10,'j M Y - H:i','short',1),(11,'Y M j - H:i','short',1),(12,'M j Y - g:ia','short',1),(13,'j M Y - g:ia','short',1),(14,'Y M j - g:ia','short',1),(15,'D, Y-m-d H:i','medium',1),(16,'D, m/d/Y - H:i','medium',1),(17,'D, d/m/Y - H:i','medium',1),(18,'D, Y/m/d - H:i','medium',1),(19,'F j, Y - H:i','medium',1),(20,'j F, Y - H:i','medium',1),(21,'Y, F j - H:i','medium',1),(22,'D, m/d/Y - g:ia','medium',1),(23,'D, d/m/Y - g:ia','medium',1),(24,'D, Y/m/d - g:ia','medium',1),(25,'F j, Y - g:ia','medium',1),(26,'j F Y - g:ia','medium',1),(27,'Y, F j - g:ia','medium',1),(28,'j. F Y - G:i','medium',1),(29,'l, F j, Y - H:i','long',1),(30,'l, j F, Y - H:i','long',1),(31,'l, Y,  F j - H:i','long',1),(32,'l, F j, Y - g:ia','long',1),(33,'l, j F Y - g:ia','long',1),(34,'l, Y,  F j - g:ia','long',1),(35,'l, j. F Y - G:i','long',1);
/*!40000 ALTER TABLE `date_formats` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `famc_metrics`
--

DROP TABLE IF EXISTS `famc_metrics`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `famc_metrics` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Id of the enity like vm, vdisk or host',
  `timestamp` int(10) unsigned NOT NULL COMMENT 'Unix timestamp - the time at which the metrics were fetched',
  `data` text COMMENT 'The serialized metric data',
  PRIMARY KEY (`entity_id`,`timestamp`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores the collected Flash Accel metrics';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `famc_metrics`
--

LOCK TABLES `famc_metrics` WRITE;
/*!40000 ALTER TABLE `famc_metrics` DISABLE KEYS */;
/*!40000 ALTER TABLE `famc_metrics` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_config`
--

DROP TABLE IF EXISTS `field_config`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_config` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a field',
  `field_name` varchar(32) NOT NULL COMMENT 'The name of this field. Non-deleted field names are unique, but multiple deleted fields can have the same name.',
  `type` varchar(128) NOT NULL COMMENT 'The type of this field.',
  `module` varchar(128) NOT NULL DEFAULT '' COMMENT 'The module that implements the field type.',
  `active` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the module that implements the field type is enabled.',
  `storage_type` varchar(128) NOT NULL COMMENT 'The storage backend for the field.',
  `storage_module` varchar(128) NOT NULL DEFAULT '' COMMENT 'The module that implements the storage backend.',
  `storage_active` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the module that implements the storage backend is enabled.',
  `locked` tinyint(4) NOT NULL DEFAULT '0' COMMENT '@TODO',
  `data` longblob NOT NULL COMMENT 'Serialized data containing the field properties that do not warrant a dedicated column.',
  `cardinality` tinyint(4) NOT NULL DEFAULT '0',
  `translatable` tinyint(4) NOT NULL DEFAULT '0',
  `deleted` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `field_name` (`field_name`),
  KEY `active` (`active`),
  KEY `storage_active` (`storage_active`),
  KEY `deleted` (`deleted`),
  KEY `module` (`module`),
  KEY `storage_module` (`storage_module`),
  KEY `type` (`type`),
  KEY `storage_type` (`storage_type`)
) ENGINE=MyISAM AUTO_INCREMENT=176 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_config`
--

LOCK TABLES `field_config` WRITE;
/*!40000 ALTER TABLE `field_config` DISABLE KEYS */;
INSERT INTO `field_config` VALUES (1,'comment_body','text_long','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"entity_types\";a:1:{i:0;s:7:\"comment\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:23:\"field_data_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:27:\"field_revision_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"1\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(2,'body','text_with_summary','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"entity_types\";a:1:{i:0;s:4:\"node\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:15:\"field_data_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:19:\"field_revision_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"2\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(3,'field_tags','taxonomy_term_reference','taxonomy',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:8:\"settings\";a:1:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:4:\"tags\";s:6:\"parent\";i:0;}}}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_tags\";a:1:{s:3:\"tid\";s:14:\"field_tags_tid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_tags\";a:1:{s:3:\"tid\";s:14:\"field_tags_tid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:2:\"id\";s:1:\"3\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',-1,0,0),(5,'field_ip_address','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_ip_address\";a:2:{s:5:\"value\";s:22:\"field_ip_address_value\";s:6:\"format\";s:23:\"field_ip_address_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_ip_address\";a:2:{s:5:\"value\";s:22:\"field_ip_address_value\";s:6:\"format\";s:23:\"field_ip_address_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"5\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(6,'field_username','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_username\";a:2:{s:5:\"value\";s:20:\"field_username_value\";s:6:\"format\";s:21:\"field_username_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_username\";a:2:{s:5:\"value\";s:20:\"field_username_value\";s:6:\"format\";s:21:\"field_username_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"6\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(7,'field_password','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_password\";a:2:{s:5:\"value\";s:20:\"field_password_value\";s:6:\"format\";s:21:\"field_password_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_password\";a:2:{s:5:\"value\";s:20:\"field_password_value\";s:6:\"format\";s:21:\"field_password_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"7\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(9,'field_vm_ip_address','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_vm_ip_address\";a:2:{s:5:\"value\";s:25:\"field_vm_ip_address_value\";s:6:\"format\";s:26:\"field_vm_ip_address_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_vm_ip_address\";a:2:{s:5:\"value\";s:25:\"field_vm_ip_address_value\";s:6:\"format\";s:26:\"field_vm_ip_address_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"9\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(11,'field_memory_size','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_memory_size\";a:2:{s:5:\"value\";s:23:\"field_memory_size_value\";s:6:\"format\";s:24:\"field_memory_size_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_memory_size\";a:2:{s:5:\"value\";s:23:\"field_memory_size_value\";s:6:\"format\";s:24:\"field_memory_size_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"11\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(13,'field_template','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_template\";a:2:{s:5:\"value\";s:20:\"field_template_value\";s:6:\"format\";s:21:\"field_template_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_template\";a:2:{s:5:\"value\";s:20:\"field_template_value\";s:6:\"format\";s:21:\"field_template_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"13\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(14,'field_vm_path_name','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:29:\"field_data_field_vm_path_name\";a:2:{s:5:\"value\";s:24:\"field_vm_path_name_value\";s:6:\"format\";s:25:\"field_vm_path_name_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:33:\"field_revision_field_vm_path_name\";a:2:{s:5:\"value\";s:24:\"field_vm_path_name_value\";s:6:\"format\";s:25:\"field_vm_path_name_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"14\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(15,'field_guest_os','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_guest_os\";a:2:{s:5:\"value\";s:20:\"field_guest_os_value\";s:6:\"format\";s:21:\"field_guest_os_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_guest_os\";a:2:{s:5:\"value\";s:20:\"field_guest_os_value\";s:6:\"format\";s:21:\"field_guest_os_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"15\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(16,'field_guest_id','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_guest_id\";a:2:{s:5:\"value\";s:20:\"field_guest_id_value\";s:6:\"format\";s:21:\"field_guest_id_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_guest_id\";a:2:{s:5:\"value\";s:20:\"field_guest_id_value\";s:6:\"format\";s:21:\"field_guest_id_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"16\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(18,'field_cpu_usage','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:26:\"field_data_field_cpu_usage\";a:2:{s:5:\"value\";s:21:\"field_cpu_usage_value\";s:6:\"format\";s:22:\"field_cpu_usage_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:30:\"field_revision_field_cpu_usage\";a:2:{s:5:\"value\";s:21:\"field_cpu_usage_value\";s:6:\"format\";s:22:\"field_cpu_usage_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"18\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(19,'field_host_memory_usage','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:34:\"field_data_field_host_memory_usage\";a:2:{s:5:\"value\";s:29:\"field_host_memory_usage_value\";s:6:\"format\";s:30:\"field_host_memory_usage_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:38:\"field_revision_field_host_memory_usage\";a:2:{s:5:\"value\";s:29:\"field_host_memory_usage_value\";s:6:\"format\";s:30:\"field_host_memory_usage_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"19\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(20,'field_guest_memory_usage','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:35:\"field_data_field_guest_memory_usage\";a:2:{s:5:\"value\";s:30:\"field_guest_memory_usage_value\";s:6:\"format\";s:31:\"field_guest_memory_usage_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:39:\"field_revision_field_guest_memory_usage\";a:2:{s:5:\"value\";s:30:\"field_guest_memory_usage_value\";s:6:\"format\";s:31:\"field_guest_memory_usage_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"20\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(21,'field_cpu_model','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:26:\"field_data_field_cpu_model\";a:2:{s:5:\"value\";s:21:\"field_cpu_model_value\";s:6:\"format\";s:22:\"field_cpu_model_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:30:\"field_revision_field_cpu_model\";a:2:{s:5:\"value\";s:21:\"field_cpu_model_value\";s:6:\"format\";s:22:\"field_cpu_model_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"21\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(22,'field_boottime','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_boottime\";a:2:{s:5:\"value\";s:20:\"field_boottime_value\";s:6:\"format\";s:21:\"field_boottime_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_boottime\";a:2:{s:5:\"value\";s:20:\"field_boottime_value\";s:6:\"format\";s:21:\"field_boottime_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"22\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(23,'field_host_status','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_host_status\";a:2:{s:5:\"value\";s:23:\"field_host_status_value\";s:6:\"format\";s:24:\"field_host_status_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_host_status\";a:2:{s:5:\"value\";s:23:\"field_host_status_value\";s:6:\"format\";s:24:\"field_host_status_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"23\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(24,'field_maintenance_mode','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_maintenance_mode\";a:1:{s:5:\"value\";s:28:\"field_maintenance_mode_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_maintenance_mode\";a:1:{s:5:\"value\";s:28:\"field_maintenance_mode_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"24\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(25,'field_physical_memory','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:32:\"field_data_field_physical_memory\";a:2:{s:5:\"value\";s:27:\"field_physical_memory_value\";s:6:\"format\";s:28:\"field_physical_memory_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:36:\"field_revision_field_physical_memory\";a:2:{s:5:\"value\";s:27:\"field_physical_memory_value\";s:6:\"format\";s:28:\"field_physical_memory_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"25\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(26,'field_vmotion','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:24:\"field_data_field_vmotion\";a:1:{s:5:\"value\";s:19:\"field_vmotion_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:28:\"field_revision_field_vmotion\";a:1:{s:5:\"value\";s:19:\"field_vmotion_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"26\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(27,'field_reboot_required','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:32:\"field_data_field_reboot_required\";a:1:{s:5:\"value\";s:27:\"field_reboot_required_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:36:\"field_revision_field_reboot_required\";a:1:{s:5:\"value\";s:27:\"field_reboot_required_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"27\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(31,'field_serial_no','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:26:\"field_data_field_serial_no\";a:2:{s:5:\"value\";s:21:\"field_serial_no_value\";s:6:\"format\";s:22:\"field_serial_no_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:30:\"field_revision_field_serial_no\";a:2:{s:5:\"value\";s:21:\"field_serial_no_value\";s:6:\"format\";s:22:\"field_serial_no_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"31\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(32,'field_size','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_size\";a:2:{s:5:\"value\";s:16:\"field_size_value\";s:6:\"format\";s:17:\"field_size_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_size\";a:2:{s:5:\"value\";s:16:\"field_size_value\";s:6:\"format\";s:17:\"field_size_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"32\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(33,'field_device_type','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_device_type\";a:2:{s:5:\"value\";s:23:\"field_device_type_value\";s:6:\"format\";s:24:\"field_device_type_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_device_type\";a:2:{s:5:\"value\";s:23:\"field_device_type_value\";s:6:\"format\";s:24:\"field_device_type_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"33\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(34,'field_multipath_plugin','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_multipath_plugin\";a:2:{s:5:\"value\";s:28:\"field_multipath_plugin_value\";s:6:\"format\";s:29:\"field_multipath_plugin_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_multipath_plugin\";a:2:{s:5:\"value\";s:28:\"field_multipath_plugin_value\";s:6:\"format\";s:29:\"field_multipath_plugin_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"34\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(35,'field_devfs_path','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_devfs_path\";a:2:{s:5:\"value\";s:22:\"field_devfs_path_value\";s:6:\"format\";s:23:\"field_devfs_path_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_devfs_path\";a:2:{s:5:\"value\";s:22:\"field_devfs_path_value\";s:6:\"format\";s:23:\"field_devfs_path_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"35\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(36,'field_vendor','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:23:\"field_data_field_vendor\";a:2:{s:5:\"value\";s:18:\"field_vendor_value\";s:6:\"format\";s:19:\"field_vendor_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:27:\"field_revision_field_vendor\";a:2:{s:5:\"value\";s:18:\"field_vendor_value\";s:6:\"format\";s:19:\"field_vendor_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"36\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(37,'field_model','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:22:\"field_data_field_model\";a:2:{s:5:\"value\";s:17:\"field_model_value\";s:6:\"format\";s:18:\"field_model_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:26:\"field_revision_field_model\";a:2:{s:5:\"value\";s:17:\"field_model_value\";s:6:\"format\";s:18:\"field_model_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"37\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(38,'field_revision','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_revision\";a:2:{s:5:\"value\";s:20:\"field_revision_value\";s:6:\"format\";s:21:\"field_revision_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_revision\";a:2:{s:5:\"value\";s:20:\"field_revision_value\";s:6:\"format\";s:21:\"field_revision_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"38\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(39,'field_scsi_level','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_scsi_level\";a:2:{s:5:\"value\";s:22:\"field_scsi_level_value\";s:6:\"format\";s:23:\"field_scsi_level_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_scsi_level\";a:2:{s:5:\"value\";s:22:\"field_scsi_level_value\";s:6:\"format\";s:23:\"field_scsi_level_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"39\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(40,'field_is_pseudo','list_text','list',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{s:4:\"true\";s:4:\"True\";s:5:\"false\";s:5:\"False\";}s:23:\"allowed_values_function\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:26:\"field_data_field_is_pseudo\";a:1:{s:5:\"value\";s:21:\"field_is_pseudo_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:30:\"field_revision_field_is_pseudo\";a:1:{s:5:\"value\";s:21:\"field_is_pseudo_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:2:\"id\";s:2:\"40\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(41,'field_status','list_text','list',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:3:{s:2:\"on\";s:2:\"On\";s:3:\"off\";s:3:\"Off\";s:8:\"degraded\";s:8:\"Degraded\";}s:23:\"allowed_values_function\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:23:\"field_data_field_status\";a:1:{s:5:\"value\";s:18:\"field_status_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:27:\"field_revision_field_status\";a:1:{s:5:\"value\";s:18:\"field_status_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:2:\"id\";s:2:\"41\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(42,'field_is_rdm_capable','list_text','list',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{s:4:\"true\";s:4:\"True\";s:5:\"false\";s:5:\"False\";}s:23:\"allowed_values_function\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:31:\"field_data_field_is_rdm_capable\";a:1:{s:5:\"value\";s:26:\"field_is_rdm_capable_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:35:\"field_revision_field_is_rdm_capable\";a:1:{s:5:\"value\";s:26:\"field_is_rdm_capable_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:2:\"id\";s:2:\"42\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(43,'field_is_local','list_text','list',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{s:4:\"true\";s:4:\"True\";s:5:\"false\";s:5:\"False\";}s:23:\"allowed_values_function\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_is_local\";a:1:{s:5:\"value\";s:20:\"field_is_local_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_is_local\";a:1:{s:5:\"value\";s:20:\"field_is_local_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:2:\"id\";s:2:\"43\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(44,'field_is_removable','list_text','list',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{s:4:\"true\";s:4:\"True\";s:5:\"false\";s:5:\"False\";}s:23:\"allowed_values_function\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:29:\"field_data_field_is_removable\";a:1:{s:5:\"value\";s:24:\"field_is_removable_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:33:\"field_revision_field_is_removable\";a:1:{s:5:\"value\";s:24:\"field_is_removable_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:2:\"id\";s:2:\"44\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(45,'field_is_ssd','list_text','list',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{s:4:\"true\";s:4:\"True\";s:5:\"false\";s:5:\"False\";}s:23:\"allowed_values_function\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:23:\"field_data_field_is_ssd\";a:1:{s:5:\"value\";s:18:\"field_is_ssd_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:27:\"field_revision_field_is_ssd\";a:1:{s:5:\"value\";s:18:\"field_is_ssd_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:2:\"id\";s:2:\"45\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(46,'field_is_offline','list_text','list',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{s:4:\"true\";s:4:\"True\";s:5:\"false\";s:5:\"False\";}s:23:\"allowed_values_function\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_is_offline\";a:1:{s:5:\"value\";s:22:\"field_is_offline_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_is_offline\";a:1:{s:5:\"value\";s:22:\"field_is_offline_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:2:\"id\";s:2:\"46\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(47,'field_is_perennially_reserved','list_text','list',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{s:4:\"true\";s:4:\"True\";s:5:\"false\";s:5:\"False\";}s:23:\"allowed_values_function\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:40:\"field_data_field_is_perennially_reserved\";a:1:{s:5:\"value\";s:35:\"field_is_perennially_reserved_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:44:\"field_revision_field_is_perennially_reserved\";a:1:{s:5:\"value\";s:35:\"field_is_perennially_reserved_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:2:\"id\";s:2:\"47\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(48,'field_thin_provisioning_status','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:41:\"field_data_field_thin_provisioning_status\";a:2:{s:5:\"value\";s:36:\"field_thin_provisioning_status_value\";s:6:\"format\";s:37:\"field_thin_provisioning_status_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:45:\"field_revision_field_thin_provisioning_status\";a:2:{s:5:\"value\";s:36:\"field_thin_provisioning_status_value\";s:6:\"format\";s:37:\"field_thin_provisioning_status_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"48\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(49,'field_attached_filters','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_attached_filters\";a:2:{s:5:\"value\";s:28:\"field_attached_filters_value\";s:6:\"format\";s:29:\"field_attached_filters_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_attached_filters\";a:2:{s:5:\"value\";s:28:\"field_attached_filters_value\";s:6:\"format\";s:29:\"field_attached_filters_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"49\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(50,'field_vaai_status','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_vaai_status\";a:2:{s:5:\"value\";s:23:\"field_vaai_status_value\";s:6:\"format\";s:24:\"field_vaai_status_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_vaai_status\";a:2:{s:5:\"value\";s:23:\"field_vaai_status_value\";s:6:\"format\";s:24:\"field_vaai_status_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"50\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(51,'field_other_uids','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_other_uids\";a:2:{s:5:\"value\";s:22:\"field_other_uids_value\";s:6:\"format\";s:23:\"field_other_uids_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_other_uids\";a:2:{s:5:\"value\";s:22:\"field_other_uids_value\";s:6:\"format\";s:23:\"field_other_uids_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"51\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(52,'field_display_name','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:29:\"field_data_field_display_name\";a:2:{s:5:\"value\";s:24:\"field_display_name_value\";s:6:\"format\";s:25:\"field_display_name_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:33:\"field_revision_field_display_name\";a:2:{s:5:\"value\";s:24:\"field_display_name_value\";s:6:\"format\";s:25:\"field_display_name_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"52\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(53,'field_capacity','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_capacity\";a:2:{s:5:\"value\";s:20:\"field_capacity_value\";s:6:\"format\";s:21:\"field_capacity_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_capacity\";a:2:{s:5:\"value\";s:20:\"field_capacity_value\";s:6:\"format\";s:21:\"field_capacity_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"53\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(54,'field_path','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_path\";a:2:{s:5:\"value\";s:16:\"field_path_value\";s:6:\"format\";s:17:\"field_path_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_path\";a:2:{s:5:\"value\";s:16:\"field_path_value\";s:6:\"format\";s:17:\"field_path_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"54\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(55,'field_freespace','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:26:\"field_data_field_freespace\";a:2:{s:5:\"value\";s:21:\"field_freespace_value\";s:6:\"format\";s:22:\"field_freespace_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:30:\"field_revision_field_freespace\";a:2:{s:5:\"value\";s:21:\"field_freespace_value\";s:6:\"format\";s:22:\"field_freespace_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"55\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(56,'field_vm_username','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_vm_username\";a:2:{s:5:\"value\";s:23:\"field_vm_username_value\";s:6:\"format\";s:24:\"field_vm_username_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_vm_username\";a:2:{s:5:\"value\";s:23:\"field_vm_username_value\";s:6:\"format\";s:24:\"field_vm_username_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"56\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(57,'field_vm_password','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_vm_password\";a:2:{s:5:\"value\";s:23:\"field_vm_password_value\";s:6:\"format\";s:24:\"field_vm_password_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_vm_password\";a:2:{s:5:\"value\";s:23:\"field_vm_password_value\";s:6:\"format\";s:24:\"field_vm_password_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"57\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(58,'field_host_username','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_host_username\";a:2:{s:5:\"value\";s:25:\"field_host_username_value\";s:6:\"format\";s:26:\"field_host_username_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_host_username\";a:2:{s:5:\"value\";s:25:\"field_host_username_value\";s:6:\"format\";s:26:\"field_host_username_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"58\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(59,'field_host_password','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_host_password\";a:2:{s:5:\"value\";s:25:\"field_host_password_value\";s:6:\"format\";s:26:\"field_host_password_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_host_password\";a:2:{s:5:\"value\";s:25:\"field_host_password_value\";s:6:\"format\";s:26:\"field_host_password_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"59\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(60,'field_driver_status','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_driver_status\";a:2:{s:5:\"value\";s:25:\"field_driver_status_value\";s:6:\"format\";s:26:\"field_driver_status_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_driver_status\";a:2:{s:5:\"value\";s:25:\"field_driver_status_value\";s:6:\"format\";s:26:\"field_driver_status_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"60\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(61,'field_bundle_status','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_bundle_status\";a:2:{s:5:\"value\";s:25:\"field_bundle_status_value\";s:6:\"format\";s:26:\"field_bundle_status_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_bundle_status\";a:2:{s:5:\"value\";s:25:\"field_bundle_status_value\";s:6:\"format\";s:26:\"field_bundle_status_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"61\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(62,'field_related_vcenter','entityreference','entityreference',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:7:\"vcenter\";s:7:\"vcenter\";}s:4:\"sort\";a:3:{s:4:\"type\";s:8:\"property\";s:8:\"property\";s:5:\"title\";s:9:\"direction\";s:3:\"ASC\";}s:9:\"behaviors\";a:1:{s:17:\"views-select-list\";a:1:{s:6:\"status\";i:0;}}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:32:\"field_data_field_related_vcenter\";a:1:{s:9:\"target_id\";s:31:\"field_related_vcenter_target_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:36:\"field_revision_field_related_vcenter\";a:1:{s:9:\"target_id\";s:31:\"field_related_vcenter_target_id\";}}}}}s:12:\"foreign keys\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:9:\"target_id\";s:3:\"nid\";}}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:2:\"id\";s:2:\"62\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(63,'field_virtual_machine','entityreference','entityreference',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:15:\"virtual_machine\";s:15:\"virtual_machine\";}s:4:\"sort\";a:1:{s:4:\"type\";s:4:\"none\";}s:9:\"behaviors\";a:1:{s:17:\"views-select-list\";a:1:{s:6:\"status\";i:0;}}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:32:\"field_data_field_virtual_machine\";a:1:{s:9:\"target_id\";s:31:\"field_virtual_machine_target_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:36:\"field_revision_field_virtual_machine\";a:1:{s:9:\"target_id\";s:31:\"field_virtual_machine_target_id\";}}}}}s:12:\"foreign keys\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:9:\"target_id\";s:3:\"nid\";}}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:2:\"id\";s:2:\"63\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(64,'field_related_host','entityreference','entityreference',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:4:\"host\";s:4:\"host\";}s:4:\"sort\";a:1:{s:4:\"type\";s:4:\"none\";}s:9:\"behaviors\";a:1:{s:17:\"views-select-list\";a:1:{s:6:\"status\";i:0;}}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:29:\"field_data_field_related_host\";a:1:{s:9:\"target_id\";s:28:\"field_related_host_target_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:33:\"field_revision_field_related_host\";a:1:{s:9:\"target_id\";s:28:\"field_related_host_target_id\";}}}}}s:12:\"foreign keys\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:9:\"target_id\";s:3:\"nid\";}}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:2:\"id\";s:2:\"64\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(65,'field_datacenter','entityreference','entityreference',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:11:\"data_center\";s:11:\"data_center\";}s:4:\"sort\";a:1:{s:4:\"type\";s:4:\"none\";}s:9:\"behaviors\";a:1:{s:17:\"views-select-list\";a:1:{s:6:\"status\";i:0;}}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_datacenter\";a:1:{s:9:\"target_id\";s:26:\"field_datacenter_target_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_datacenter\";a:1:{s:9:\"target_id\";s:26:\"field_datacenter_target_id\";}}}}}s:12:\"foreign keys\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:9:\"target_id\";s:3:\"nid\";}}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:2:\"id\";s:2:\"65\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(66,'field_host','entityreference','entityreference',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:4:\"host\";s:4:\"host\";}s:4:\"sort\";a:1:{s:4:\"type\";s:4:\"none\";}s:9:\"behaviors\";a:1:{s:17:\"views-select-list\";a:1:{s:6:\"status\";i:0;}}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_host\";a:1:{s:9:\"target_id\";s:20:\"field_host_target_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_host\";a:1:{s:9:\"target_id\";s:20:\"field_host_target_id\";}}}}}s:12:\"foreign keys\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:9:\"target_id\";s:3:\"nid\";}}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:2:\"id\";s:2:\"66\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(67,'field_vmware_tools','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:29:\"field_data_field_vmware_tools\";a:2:{s:5:\"value\";s:24:\"field_vmware_tools_value\";s:6:\"format\";s:25:\"field_vmware_tools_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:33:\"field_revision_field_vmware_tools\";a:2:{s:5:\"value\";s:24:\"field_vmware_tools_value\";s:6:\"format\";s:25:\"field_vmware_tools_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"67\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(68,'field_software_on_host','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_software_on_host\";a:2:{s:5:\"value\";s:28:\"field_software_on_host_value\";s:6:\"format\";s:29:\"field_software_on_host_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_software_on_host\";a:2:{s:5:\"value\";s:28:\"field_software_on_host_value\";s:6:\"format\";s:29:\"field_software_on_host_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"68\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(69,'field_vm','entityreference','entityreference',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:15:\"virtual_machine\";s:15:\"virtual_machine\";}s:4:\"sort\";a:1:{s:4:\"type\";s:4:\"none\";}s:9:\"behaviors\";a:1:{s:17:\"views-select-list\";a:1:{s:6:\"status\";i:0;}}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:19:\"field_data_field_vm\";a:1:{s:9:\"target_id\";s:18:\"field_vm_target_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:23:\"field_revision_field_vm\";a:1:{s:9:\"target_id\";s:18:\"field_vm_target_id\";}}}}}s:12:\"foreign keys\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:9:\"target_id\";s:3:\"nid\";}}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:2:\"id\";s:2:\"69\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(70,'field_allocated_segments','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:35:\"field_data_field_allocated_segments\";a:1:{s:5:\"value\";s:30:\"field_allocated_segments_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:39:\"field_revision_field_allocated_segments\";a:1:{s:5:\"value\";s:30:\"field_allocated_segments_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"70\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(71,'field_segment_size','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:29:\"field_data_field_segment_size\";a:1:{s:5:\"value\";s:24:\"field_segment_size_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:33:\"field_revision_field_segment_size\";a:1:{s:5:\"value\";s:24:\"field_segment_size_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"71\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(72,'field_max_virtual_machines','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:37:\"field_data_field_max_virtual_machines\";a:1:{s:5:\"value\";s:32:\"field_max_virtual_machines_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:41:\"field_revision_field_max_virtual_machines\";a:1:{s:5:\"value\";s:32:\"field_max_virtual_machines_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"72\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(73,'field_max_physical_devices','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:37:\"field_data_field_max_physical_devices\";a:1:{s:5:\"value\";s:32:\"field_max_physical_devices_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:41:\"field_revision_field_max_physical_devices\";a:1:{s:5:\"value\";s:32:\"field_max_physical_devices_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"73\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(74,'field_claimed_physical_devices','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:41:\"field_data_field_claimed_physical_devices\";a:1:{s:5:\"value\";s:36:\"field_claimed_physical_devices_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:45:\"field_revision_field_claimed_physical_devices\";a:1:{s:5:\"value\";s:36:\"field_claimed_physical_devices_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"74\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(75,'field_cache_state','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_cache_state\";a:1:{s:5:\"value\";s:23:\"field_cache_state_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_cache_state\";a:1:{s:5:\"value\";s:23:\"field_cache_state_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"75\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(76,'field_total_segments','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:31:\"field_data_field_total_segments\";a:1:{s:5:\"value\";s:26:\"field_total_segments_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:35:\"field_revision_field_total_segments\";a:1:{s:5:\"value\";s:26:\"field_total_segments_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"76\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(77,'field_allocated_virtual_machines','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:43:\"field_data_field_allocated_virtual_machines\";a:1:{s:5:\"value\";s:38:\"field_allocated_virtual_machines_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:47:\"field_revision_field_allocated_virtual_machines\";a:1:{s:5:\"value\";s:38:\"field_allocated_virtual_machines_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"77\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(78,'field_vib_version','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_vib_version\";a:2:{s:5:\"value\";s:23:\"field_vib_version_value\";s:6:\"format\";s:24:\"field_vib_version_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_vib_version\";a:2:{s:5:\"value\";s:23:\"field_vib_version_value\";s:6:\"format\";s:24:\"field_vib_version_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"78\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(79,'field_total_size','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_total_size\";a:2:{s:5:\"value\";s:22:\"field_total_size_value\";s:6:\"format\";s:23:\"field_total_size_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_total_size\";a:2:{s:5:\"value\";s:22:\"field_total_size_value\";s:6:\"format\";s:23:\"field_total_size_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"79\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(80,'field_naa_identifier','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:31:\"field_data_field_naa_identifier\";a:2:{s:5:\"value\";s:26:\"field_naa_identifier_value\";s:6:\"format\";s:27:\"field_naa_identifier_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:35:\"field_revision_field_naa_identifier\";a:2:{s:5:\"value\";s:26:\"field_naa_identifier_value\";s:6:\"format\";s:27:\"field_naa_identifier_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"80\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(81,'field_allocated_size','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:31:\"field_data_field_allocated_size\";a:2:{s:5:\"value\";s:26:\"field_allocated_size_value\";s:6:\"format\";s:27:\"field_allocated_size_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:35:\"field_revision_field_allocated_size\";a:2:{s:5:\"value\";s:26:\"field_allocated_size_value\";s:6:\"format\";s:27:\"field_allocated_size_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"81\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(82,'field_device_state','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:29:\"field_data_field_device_state\";a:1:{s:5:\"value\";s:24:\"field_device_state_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:33:\"field_revision_field_device_state\";a:1:{s:5:\"value\";s:24:\"field_device_state_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"82\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(83,'field_no_of_cpu','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:26:\"field_data_field_no_of_cpu\";a:2:{s:5:\"value\";s:21:\"field_no_of_cpu_value\";s:6:\"format\";s:22:\"field_no_of_cpu_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:30:\"field_revision_field_no_of_cpu\";a:2:{s:5:\"value\";s:21:\"field_no_of_cpu_value\";s:6:\"format\";s:22:\"field_no_of_cpu_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"83\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(84,'field_virtual_disks','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_virtual_disks\";a:2:{s:5:\"value\";s:25:\"field_virtual_disks_value\";s:6:\"format\";s:26:\"field_virtual_disks_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_virtual_disks\";a:2:{s:5:\"value\";s:25:\"field_virtual_disks_value\";s:6:\"format\";s:26:\"field_virtual_disks_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"84\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(86,'field_fa_build_version','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_fa_build_version\";a:2:{s:5:\"value\";s:28:\"field_fa_build_version_value\";s:6:\"format\";s:29:\"field_fa_build_version_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_fa_build_version\";a:2:{s:5:\"value\";s:28:\"field_fa_build_version_value\";s:6:\"format\";s:29:\"field_fa_build_version_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"86\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(87,'field_fa_cache_mode','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_fa_cache_mode\";a:2:{s:5:\"value\";s:25:\"field_fa_cache_mode_value\";s:6:\"format\";s:26:\"field_fa_cache_mode_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_fa_cache_mode\";a:2:{s:5:\"value\";s:25:\"field_fa_cache_mode_value\";s:6:\"format\";s:26:\"field_fa_cache_mode_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"87\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(88,'field_fa_administration_state','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:40:\"field_data_field_fa_administration_state\";a:2:{s:5:\"value\";s:35:\"field_fa_administration_state_value\";s:6:\"format\";s:36:\"field_fa_administration_state_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:44:\"field_revision_field_fa_administration_state\";a:2:{s:5:\"value\";s:35:\"field_fa_administration_state_value\";s:6:\"format\";s:36:\"field_fa_administration_state_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"88\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(89,'field_fa_cache_size','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_fa_cache_size\";a:2:{s:5:\"value\";s:25:\"field_fa_cache_size_value\";s:6:\"format\";s:26:\"field_fa_cache_size_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_fa_cache_size\";a:2:{s:5:\"value\";s:25:\"field_fa_cache_size_value\";s:6:\"format\";s:26:\"field_fa_cache_size_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"89\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(90,'field_fa_operational_state','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:37:\"field_data_field_fa_operational_state\";a:2:{s:5:\"value\";s:32:\"field_fa_operational_state_value\";s:6:\"format\";s:33:\"field_fa_operational_state_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:41:\"field_revision_field_fa_operational_state\";a:2:{s:5:\"value\";s:32:\"field_fa_operational_state_value\";s:6:\"format\";s:33:\"field_fa_operational_state_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"90\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(91,'field_fa_operational_message','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:39:\"field_data_field_fa_operational_message\";a:2:{s:5:\"value\";s:34:\"field_fa_operational_message_value\";s:6:\"format\";s:35:\"field_fa_operational_message_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:43:\"field_revision_field_fa_operational_message\";a:2:{s:5:\"value\";s:34:\"field_fa_operational_message_value\";s:6:\"format\";s:35:\"field_fa_operational_message_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"91\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(92,'field_fa_performance_state','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:37:\"field_data_field_fa_performance_state\";a:2:{s:5:\"value\";s:32:\"field_fa_performance_state_value\";s:6:\"format\";s:33:\"field_fa_performance_state_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:41:\"field_revision_field_fa_performance_state\";a:2:{s:5:\"value\";s:32:\"field_fa_performance_state_value\";s:6:\"format\";s:33:\"field_fa_performance_state_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"92\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(93,'field_fa_generation_id','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_fa_generation_id\";a:2:{s:5:\"value\";s:28:\"field_fa_generation_id_value\";s:6:\"format\";s:29:\"field_fa_generation_id_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_fa_generation_id\";a:2:{s:5:\"value\";s:28:\"field_fa_generation_id_value\";s:6:\"format\";s:29:\"field_fa_generation_id_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"93\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(94,'field_vm_read_latency','number_decimal','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:32:\"field_data_field_vm_read_latency\";a:1:{s:5:\"value\";s:27:\"field_vm_read_latency_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:36:\"field_revision_field_vm_read_latency\";a:1:{s:5:\"value\";s:27:\"field_vm_read_latency_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"94\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(95,'field_vm_write_latency','number_decimal','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_vm_write_latency\";a:1:{s:5:\"value\";s:28:\"field_vm_write_latency_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_vm_write_latency\";a:1:{s:5:\"value\";s:28:\"field_vm_write_latency_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"95\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(96,'field_vm_read_ops','number_decimal','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_vm_read_ops\";a:1:{s:5:\"value\";s:23:\"field_vm_read_ops_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_vm_read_ops\";a:1:{s:5:\"value\";s:23:\"field_vm_read_ops_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"96\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(97,'field_vm_write_ops','number_decimal','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:29:\"field_data_field_vm_write_ops\";a:1:{s:5:\"value\";s:24:\"field_vm_write_ops_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:33:\"field_revision_field_vm_write_ops\";a:1:{s:5:\"value\";s:24:\"field_vm_write_ops_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"97\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(98,'field_vm_hits','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:24:\"field_data_field_vm_hits\";a:1:{s:5:\"value\";s:19:\"field_vm_hits_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:28:\"field_revision_field_vm_hits\";a:1:{s:5:\"value\";s:19:\"field_vm_hits_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"98\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(99,'field_vm_read_blocks','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:31:\"field_data_field_vm_read_blocks\";a:1:{s:5:\"value\";s:26:\"field_vm_read_blocks_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:35:\"field_revision_field_vm_read_blocks\";a:1:{s:5:\"value\";s:26:\"field_vm_read_blocks_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"99\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(100,'field_vm_cache_latency','number_decimal','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_vm_cache_latency\";a:1:{s:5:\"value\";s:28:\"field_vm_cache_latency_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_vm_cache_latency\";a:1:{s:5:\"value\";s:28:\"field_vm_cache_latency_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"100\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(101,'field_vm_population','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_vm_population\";a:1:{s:5:\"value\";s:25:\"field_vm_population_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_vm_population\";a:1:{s:5:\"value\";s:25:\"field_vm_population_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"101\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(102,'field_vm_usable_blocks','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_vm_usable_blocks\";a:1:{s:5:\"value\";s:28:\"field_vm_usable_blocks_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_vm_usable_blocks\";a:1:{s:5:\"value\";s:28:\"field_vm_usable_blocks_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"102\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(103,'field_vm_write_blocks','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:32:\"field_data_field_vm_write_blocks\";a:1:{s:5:\"value\";s:27:\"field_vm_write_blocks_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:36:\"field_revision_field_vm_write_blocks\";a:1:{s:5:\"value\";s:27:\"field_vm_write_blocks_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"103\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(104,'field_vm_insertions','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_vm_insertions\";a:1:{s:5:\"value\";s:25:\"field_vm_insertions_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_vm_insertions\";a:1:{s:5:\"value\";s:25:\"field_vm_insertions_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"104\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(107,'field_vm_population_pc','computed','computed_field',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:4:{s:4:\"code\";s:443:\"$entity_field[0][\'value\'] = 0;\r\n\r\n$population = (int) array_pop(array_pop(field_get_items($entity_type, $entity, \'field_vm_population\')));\r\n$usable_blocks = (int) array_pop(array_pop(field_get_items($entity_type, $entity, \'field_vm_usable_blocks\')));\r\n\r\nif (is_numeric($population) && is_numeric($usable_blocks) && $population !== 0 && $usable_blocks !== 0) {\r\n  $entity_field[0][\'value\'] = round( ($population * 100) / $usable_blocks, 2 );\r\n}\";s:14:\"display_format\";s:64:\"$display_output = number_format($entity_field_item[\'value\'], 2);\";s:5:\"store\";i:1;s:8:\"database\";a:8:{s:9:\"data_type\";s:7:\"numeric\";s:11:\"data_length\";s:2:\"32\";s:9:\"data_size\";s:6:\"normal\";s:14:\"data_precision\";s:2:\"10\";s:10:\"data_scale\";s:1:\"2\";s:12:\"data_default\";s:1:\"0\";s:13:\"data_not_NULL\";i:0;s:10:\"data_index\";i:0;}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_vm_population_pc\";a:1:{s:5:\"value\";s:28:\"field_vm_population_pc_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_vm_population_pc\";a:1:{s:5:\"value\";s:28:\"field_vm_population_pc_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"107\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(108,'field_vm_insertion_rate_pc','computed','computed_field',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:4:{s:4:\"code\";s:608:\"$entity_field[0][\'value\'] = 0;\r\n\r\n$insertions = (int) array_pop(array_pop(field_get_items($entity_type, $entity, \'field_vm_insertions\')));\r\n$read_blocks = (int) array_pop(array_pop(field_get_items($entity_type, $entity, \'field_vm_read_blocks\')));\r\n$write_blocks = (int) array_pop(array_pop(field_get_items($entity_type, $entity, \'field_vm_write_blocks\')));\r\n\r\nif (is_numeric($insertions) && is_numeric($read_blocks) && is_numeric($write_blocks) && $insertions !== 0 && ($read_blocks + $write_blocks) !== 0) {\r\n  $entity_field[0][\'value\'] = round( ($insertions * 100) / ($read_blocks + $write_blocks), 2 );\r\n}\";s:14:\"display_format\";s:64:\"$display_output = number_format($entity_field_item[\'value\'], 2);\";s:5:\"store\";i:1;s:8:\"database\";a:8:{s:9:\"data_type\";s:7:\"numeric\";s:11:\"data_length\";s:2:\"32\";s:9:\"data_size\";s:6:\"normal\";s:14:\"data_precision\";s:2:\"10\";s:10:\"data_scale\";s:1:\"2\";s:12:\"data_default\";s:1:\"0\";s:13:\"data_not_NULL\";i:0;s:10:\"data_index\";i:0;}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:37:\"field_data_field_vm_insertion_rate_pc\";a:1:{s:5:\"value\";s:32:\"field_vm_insertion_rate_pc_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:41:\"field_revision_field_vm_insertion_rate_pc\";a:1:{s:5:\"value\";s:32:\"field_vm_insertion_rate_pc_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"108\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(109,'field_vdisk','entityreference','entityreference',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:5:\"vdisk\";s:5:\"vdisk\";}s:4:\"sort\";a:1:{s:4:\"type\";s:4:\"none\";}s:9:\"behaviors\";a:1:{s:17:\"views-select-list\";a:1:{s:6:\"status\";i:0;}}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:22:\"field_data_field_vdisk\";a:1:{s:9:\"target_id\";s:21:\"field_vdisk_target_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:26:\"field_revision_field_vdisk\";a:1:{s:9:\"target_id\";s:21:\"field_vdisk_target_id\";}}}}}s:12:\"foreign keys\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:9:\"target_id\";s:3:\"nid\";}}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:2:\"id\";s:3:\"109\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(110,'field_vdisk_read_latency','number_decimal','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:35:\"field_data_field_vdisk_read_latency\";a:1:{s:5:\"value\";s:30:\"field_vdisk_read_latency_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:39:\"field_revision_field_vdisk_read_latency\";a:1:{s:5:\"value\";s:30:\"field_vdisk_read_latency_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"110\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(111,'field_vdisk_write_latency','number_decimal','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:36:\"field_data_field_vdisk_write_latency\";a:1:{s:5:\"value\";s:31:\"field_vdisk_write_latency_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:40:\"field_revision_field_vdisk_write_latency\";a:1:{s:5:\"value\";s:31:\"field_vdisk_write_latency_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"111\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(112,'field_vdisk_read_ops','number_decimal','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:31:\"field_data_field_vdisk_read_ops\";a:1:{s:5:\"value\";s:26:\"field_vdisk_read_ops_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:35:\"field_revision_field_vdisk_read_ops\";a:1:{s:5:\"value\";s:26:\"field_vdisk_read_ops_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"112\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(113,'field_vdisk_write_ops','number_decimal','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:32:\"field_data_field_vdisk_write_ops\";a:1:{s:5:\"value\";s:27:\"field_vdisk_write_ops_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:36:\"field_revision_field_vdisk_write_ops\";a:1:{s:5:\"value\";s:27:\"field_vdisk_write_ops_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"113\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(114,'field_vdisk_hits','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_vdisk_hits\";a:1:{s:5:\"value\";s:22:\"field_vdisk_hits_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_vdisk_hits\";a:1:{s:5:\"value\";s:22:\"field_vdisk_hits_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"114\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(115,'field_vdisk_read_blocks','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:34:\"field_data_field_vdisk_read_blocks\";a:1:{s:5:\"value\";s:29:\"field_vdisk_read_blocks_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:38:\"field_revision_field_vdisk_read_blocks\";a:1:{s:5:\"value\";s:29:\"field_vdisk_read_blocks_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"115\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(116,'field_vdisk_cache_latency','number_decimal','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:36:\"field_data_field_vdisk_cache_latency\";a:1:{s:5:\"value\";s:31:\"field_vdisk_cache_latency_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:40:\"field_revision_field_vdisk_cache_latency\";a:1:{s:5:\"value\";s:31:\"field_vdisk_cache_latency_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"116\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(117,'field_vdisk_population','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_vdisk_population\";a:1:{s:5:\"value\";s:28:\"field_vdisk_population_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_vdisk_population\";a:1:{s:5:\"value\";s:28:\"field_vdisk_population_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"117\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(118,'field_vdisk_usable_blocks','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:36:\"field_data_field_vdisk_usable_blocks\";a:1:{s:5:\"value\";s:31:\"field_vdisk_usable_blocks_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:40:\"field_revision_field_vdisk_usable_blocks\";a:1:{s:5:\"value\";s:31:\"field_vdisk_usable_blocks_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"118\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(119,'field_vdisk_insertions','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_vdisk_insertions\";a:1:{s:5:\"value\";s:28:\"field_vdisk_insertions_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_vdisk_insertions\";a:1:{s:5:\"value\";s:28:\"field_vdisk_insertions_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"119\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(120,'field_vdisk_write_blocks','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:35:\"field_data_field_vdisk_write_blocks\";a:1:{s:5:\"value\";s:30:\"field_vdisk_write_blocks_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:39:\"field_revision_field_vdisk_write_blocks\";a:1:{s:5:\"value\";s:30:\"field_vdisk_write_blocks_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"120\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(122,'field_timestamp','datestamp','date',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:6:{s:11:\"granularity\";a:6:{s:5:\"month\";s:5:\"month\";s:3:\"day\";s:3:\"day\";s:4:\"hour\";s:4:\"hour\";s:6:\"minute\";s:6:\"minute\";s:6:\"second\";s:6:\"second\";s:4:\"year\";s:4:\"year\";}s:11:\"tz_handling\";s:4:\"none\";s:11:\"timezone_db\";s:0:\"\";s:13:\"cache_enabled\";i:0;s:11:\"cache_count\";s:1:\"4\";s:6:\"todate\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:26:\"field_data_field_timestamp\";a:1:{s:5:\"value\";s:21:\"field_timestamp_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:30:\"field_revision_field_timestamp\";a:1:{s:5:\"value\";s:21:\"field_timestamp_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"122\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(124,'field_vdisk_population_pc','computed','computed_field',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:4:{s:4:\"code\";s:437:\"$entity_field[0][\'value\'] = 0;\r\n\r\n$population = array_pop(array_pop(field_get_items($entity_type, $entity, \'field_vdisk_population\')));\r\n$usable_blocks = array_pop(array_pop(field_get_items($entity_type, $entity, \'field_vdisk_usable_blocks\')));\r\n\r\nif (is_numeric($population) && is_numeric($usable_blocks) && $population !== 0 && $usable_blocks !== 0) {\r\n  $entity_field[0][\'value\'] = round( ($population * 100) / $usable_blocks, 2 );\r\n}\";s:14:\"display_format\";s:64:\"$display_output = number_format($entity_field_item[\'value\'], 2);\";s:5:\"store\";i:1;s:8:\"database\";a:8:{s:9:\"data_type\";s:7:\"varchar\";s:11:\"data_length\";s:2:\"32\";s:9:\"data_size\";s:6:\"normal\";s:14:\"data_precision\";s:2:\"10\";s:10:\"data_scale\";s:1:\"2\";s:12:\"data_default\";s:1:\"0\";s:13:\"data_not_NULL\";i:0;s:10:\"data_index\";i:0;}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:36:\"field_data_field_vdisk_population_pc\";a:1:{s:5:\"value\";s:31:\"field_vdisk_population_pc_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:40:\"field_revision_field_vdisk_population_pc\";a:1:{s:5:\"value\";s:31:\"field_vdisk_population_pc_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"124\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(125,'field_vdisk_insertion_rate_pc','computed','computed_field',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:4:{s:4:\"code\";s:599:\"$entity_field[0][\'value\'] = 0;\r\n\r\n$insertions = array_pop(array_pop(field_get_items($entity_type, $entity, \'field_vdisk_insertions\')));\r\n$read_blocks = array_pop(array_pop(field_get_items($entity_type, $entity, \'field_vdisk_read_blocks\')));\r\n$write_blocks = array_pop(array_pop(field_get_items($entity_type, $entity, \'field_vdisk_write_blocks\')));\r\n\r\nif (is_numeric($insertions) && is_numeric($read_blocks) && is_numeric($write_blocks) && $insertions !== 0 && ($read_blocks + $write_blocks) !== 0) {\r\n  $entity_field[0][\'value\'] = round( ($insertions * 100) / ($read_blocks + $write_blocks), 2 );\r\n}\";s:14:\"display_format\";s:64:\"$display_output = number_format($entity_field_item[\'value\'], 2);\";s:5:\"store\";i:1;s:8:\"database\";a:8:{s:9:\"data_type\";s:7:\"varchar\";s:11:\"data_length\";s:2:\"32\";s:9:\"data_size\";s:6:\"normal\";s:14:\"data_precision\";s:2:\"10\";s:10:\"data_scale\";s:1:\"2\";s:12:\"data_default\";s:1:\"0\";s:13:\"data_not_NULL\";i:0;s:10:\"data_index\";i:0;}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:40:\"field_data_field_vdisk_insertion_rate_pc\";a:1:{s:5:\"value\";s:35:\"field_vdisk_insertion_rate_pc_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:44:\"field_revision_field_vdisk_insertion_rate_pc\";a:1:{s:5:\"value\";s:35:\"field_vdisk_insertion_rate_pc_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"125\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(126,'field_disk_index','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_disk_index\";a:1:{s:5:\"value\";s:22:\"field_disk_index_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_disk_index\";a:1:{s:5:\"value\";s:22:\"field_disk_index_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"126\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(127,'field_cachespace','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:8:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_cachespace\";a:2:{s:5:\"value\";s:22:\"field_cachespace_value\";s:6:\"format\";s:23:\"field_cachespace_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_cachespace\";a:2:{s:5:\"value\";s:22:\"field_cachespace_value\";s:6:\"format\";s:23:\"field_cachespace_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"127\";s:17:\"field_permissions\";a:1:{s:4:\"type\";s:1:\"2\";}}',1,0,0),(128,'field_vdisk_identifier','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_vdisk_identifier\";a:2:{s:5:\"value\";s:28:\"field_vdisk_identifier_value\";s:6:\"format\";s:29:\"field_vdisk_identifier_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_vdisk_identifier\";a:2:{s:5:\"value\";s:28:\"field_vdisk_identifier_value\";s:6:\"format\";s:29:\"field_vdisk_identifier_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"128\";}',1,0,0),(132,'field_vm_cache_size','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_vm_cache_size\";a:2:{s:5:\"value\";s:25:\"field_vm_cache_size_value\";s:6:\"format\";s:26:\"field_vm_cache_size_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_vm_cache_size\";a:2:{s:5:\"value\";s:25:\"field_vm_cache_size_value\";s:6:\"format\";s:26:\"field_vm_cache_size_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"132\";}',1,0,0),(140,'field_cache_assigned_from_host','node_reference','node_reference',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:19:\"referenceable_types\";a:12:{s:4:\"host\";s:4:\"host\";s:7:\"article\";i:0;s:4:\"page\";i:0;s:11:\"data_center\";i:0;s:6:\"device\";i:0;s:5:\"panel\";i:0;s:14:\"vm_cache_space\";i:0;s:10:\"vm_metrics\";i:0;s:15:\"virtual_machine\";i:0;s:7:\"vcenter\";i:0;s:5:\"vdisk\";i:0;s:13:\"vdisk_metrics\";i:0;}s:4:\"view\";a:3:{s:9:\"view_name\";s:0:\"\";s:12:\"display_name\";s:0:\"\";s:4:\"args\";a:0:{}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:41:\"field_data_field_cache_assigned_from_host\";a:1:{s:3:\"nid\";s:34:\"field_cache_assigned_from_host_nid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:45:\"field_revision_field_cache_assigned_from_host\";a:1:{s:3:\"nid\";s:34:\"field_cache_assigned_from_host_nid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"nid\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:3:\"nid\";s:3:\"nid\";}}}s:7:\"indexes\";a:1:{s:3:\"nid\";a:1:{i:0;s:3:\"nid\";}}s:2:\"id\";s:3:\"140\";}',1,0,0),(141,'field_cache_allocated_to_vm','node_reference','node_reference',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:19:\"referenceable_types\";a:12:{s:15:\"virtual_machine\";s:15:\"virtual_machine\";s:7:\"article\";i:0;s:4:\"page\";i:0;s:11:\"data_center\";i:0;s:6:\"device\";i:0;s:4:\"host\";i:0;s:5:\"panel\";i:0;s:14:\"vm_cache_space\";i:0;s:10:\"vm_metrics\";i:0;s:7:\"vcenter\";i:0;s:5:\"vdisk\";i:0;s:13:\"vdisk_metrics\";i:0;}s:4:\"view\";a:3:{s:9:\"view_name\";s:0:\"\";s:12:\"display_name\";s:0:\"\";s:4:\"args\";a:0:{}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:38:\"field_data_field_cache_allocated_to_vm\";a:1:{s:3:\"nid\";s:31:\"field_cache_allocated_to_vm_nid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:42:\"field_revision_field_cache_allocated_to_vm\";a:1:{s:3:\"nid\";s:31:\"field_cache_allocated_to_vm_nid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"nid\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:3:\"nid\";s:3:\"nid\";}}}s:7:\"indexes\";a:1:{s:3:\"nid\";a:1:{i:0;s:3:\"nid\";}}s:2:\"id\";s:3:\"141\";}',1,0,0),(142,'field_install_port','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:29:\"field_data_field_install_port\";a:1:{s:5:\"value\";s:24:\"field_install_port_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:33:\"field_revision_field_install_port\";a:1:{s:5:\"value\";s:24:\"field_install_port_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"142\";}',1,0,0),(143,'field_host_model','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_host_model\";a:2:{s:5:\"value\";s:22:\"field_host_model_value\";s:6:\"format\";s:23:\"field_host_model_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_host_model\";a:2:{s:5:\"value\";s:22:\"field_host_model_value\";s:6:\"format\";s:23:\"field_host_model_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"143\";}',1,0,0),(144,'field_host_vendor','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_host_vendor\";a:2:{s:5:\"value\";s:23:\"field_host_vendor_value\";s:6:\"format\";s:24:\"field_host_vendor_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_host_vendor\";a:2:{s:5:\"value\";s:23:\"field_host_vendor_value\";s:6:\"format\";s:24:\"field_host_vendor_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"144\";}',1,0,0),(145,'field_vm_vmotionable','list_boolean','list',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{i:0;s:1:\"0\";i:1;s:1:\"1\";}s:23:\"allowed_values_function\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:31:\"field_data_field_vm_vmotionable\";a:1:{s:5:\"value\";s:26:\"field_vm_vmotionable_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:35:\"field_revision_field_vm_vmotionable\";a:1:{s:5:\"value\";s:26:\"field_vm_vmotionable_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:2:\"id\";s:3:\"145\";}',1,0,0),(147,'field_hbtl','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_hbtl\";a:2:{s:5:\"value\";s:16:\"field_hbtl_value\";s:6:\"format\";s:17:\"field_hbtl_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_hbtl\";a:2:{s:5:\"value\";s:16:\"field_hbtl_value\";s:6:\"format\";s:17:\"field_hbtl_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"147\";}',1,0,0),(148,'field_is_vmfs','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:2:\"10\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:24:\"field_data_field_is_vmfs\";a:2:{s:5:\"value\";s:19:\"field_is_vmfs_value\";s:6:\"format\";s:20:\"field_is_vmfs_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:28:\"field_revision_field_is_vmfs\";a:2:{s:5:\"value\";s:19:\"field_is_vmfs_value\";s:6:\"format\";s:20:\"field_is_vmfs_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"148\";}',1,0,0),(149,'field_fa_usable_blocks','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_fa_usable_blocks\";a:2:{s:5:\"value\";s:28:\"field_fa_usable_blocks_value\";s:6:\"format\";s:29:\"field_fa_usable_blocks_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_fa_usable_blocks\";a:2:{s:5:\"value\";s:28:\"field_fa_usable_blocks_value\";s:6:\"format\";s:29:\"field_fa_usable_blocks_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"149\";}',1,0,0),(150,'field_vdisk_name','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_vdisk_name\";a:2:{s:5:\"value\";s:22:\"field_vdisk_name_value\";s:6:\"format\";s:23:\"field_vdisk_name_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_vdisk_name\";a:2:{s:5:\"value\";s:22:\"field_vdisk_name_value\";s:6:\"format\";s:23:\"field_vdisk_name_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"150\";}',1,0,0),(151,'field_vdisk_type','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_vdisk_type\";a:2:{s:5:\"value\";s:22:\"field_vdisk_type_value\";s:6:\"format\";s:23:\"field_vdisk_type_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_vdisk_type\";a:2:{s:5:\"value\";s:22:\"field_vdisk_type_value\";s:6:\"format\";s:23:\"field_vdisk_type_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"151\";}',1,0,0),(152,'field_vdisk_id','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_vdisk_id\";a:2:{s:5:\"value\";s:20:\"field_vdisk_id_value\";s:6:\"format\";s:21:\"field_vdisk_id_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_vdisk_id\";a:2:{s:5:\"value\";s:20:\"field_vdisk_id_value\";s:6:\"format\";s:21:\"field_vdisk_id_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"152\";}',1,0,0),(154,'field_host_ip','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:24:\"field_data_field_host_ip\";a:2:{s:5:\"value\";s:19:\"field_host_ip_value\";s:6:\"format\";s:20:\"field_host_ip_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:28:\"field_revision_field_host_ip\";a:2:{s:5:\"value\";s:19:\"field_host_ip_value\";s:6:\"format\";s:20:\"field_host_ip_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"154\";}',1,0,0),(155,'field_hit_ops','number_decimal','number',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:3:{s:9:\"precision\";s:2:\"10\";s:5:\"scale\";s:1:\"2\";s:17:\"decimal_separator\";s:1:\".\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:24:\"field_data_field_hit_ops\";a:1:{s:5:\"value\";s:19:\"field_hit_ops_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:28:\"field_revision_field_hit_ops\";a:1:{s:5:\"value\";s:19:\"field_hit_ops_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"155\";}',1,0,0),(156,'field_fa_sector_size','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:2:\"10\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:31:\"field_data_field_fa_sector_size\";a:2:{s:5:\"value\";s:26:\"field_fa_sector_size_value\";s:6:\"format\";s:27:\"field_fa_sector_size_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:35:\"field_revision_field_fa_sector_size\";a:2:{s:5:\"value\";s:26:\"field_fa_sector_size_value\";s:6:\"format\";s:27:\"field_fa_sector_size_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"156\";}',1,0,0),(157,'field_rediscover_status','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:34:\"field_data_field_rediscover_status\";a:2:{s:5:\"value\";s:29:\"field_rediscover_status_value\";s:6:\"format\";s:30:\"field_rediscover_status_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:38:\"field_revision_field_rediscover_status\";a:2:{s:5:\"value\";s:29:\"field_rediscover_status_value\";s:6:\"format\";s:30:\"field_rediscover_status_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"157\";}',1,0,0),(158,'field_hostname','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_hostname\";a:2:{s:5:\"value\";s:20:\"field_hostname_value\";s:6:\"format\";s:21:\"field_hostname_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_hostname\";a:2:{s:5:\"value\";s:20:\"field_hostname_value\";s:6:\"format\";s:21:\"field_hostname_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"158\";}',1,0,0),(159,'field_vm_hostname','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_vm_hostname\";a:2:{s:5:\"value\";s:23:\"field_vm_hostname_value\";s:6:\"format\";s:24:\"field_vm_hostname_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_vm_hostname\";a:2:{s:5:\"value\";s:23:\"field_vm_hostname_value\";s:6:\"format\";s:24:\"field_vm_hostname_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"159\";}',1,0,0),(160,'field_fa_metrics_reset_interval','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:42:\"field_data_field_fa_metrics_reset_interval\";a:2:{s:5:\"value\";s:37:\"field_fa_metrics_reset_interval_value\";s:6:\"format\";s:38:\"field_fa_metrics_reset_interval_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:46:\"field_revision_field_fa_metrics_reset_interval\";a:2:{s:5:\"value\";s:37:\"field_fa_metrics_reset_interval_value\";s:6:\"format\";s:38:\"field_fa_metrics_reset_interval_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"160\";}',1,0,0),(168,'field_fmc_uuid','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_fmc_uuid\";a:2:{s:5:\"value\";s:20:\"field_fmc_uuid_value\";s:6:\"format\";s:21:\"field_fmc_uuid_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_fmc_uuid\";a:2:{s:5:\"value\";s:20:\"field_fmc_uuid_value\";s:6:\"format\";s:21:\"field_fmc_uuid_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"168\";}',1,0,0),(172,'field_vm_hit_rate_pc','computed','computed_field',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:4:{s:4:\"code\";s:31:\"$entity_field[0][\'value\'] = \"\";\";s:14:\"display_format\";s:46:\"$display_output = $entity_field_item[\'value\'];\";s:5:\"store\";i:1;s:8:\"database\";a:8:{s:9:\"data_type\";s:7:\"varchar\";s:11:\"data_length\";s:2:\"32\";s:9:\"data_size\";s:6:\"normal\";s:14:\"data_precision\";s:2:\"10\";s:10:\"data_scale\";s:1:\"2\";s:12:\"data_default\";s:0:\"\";s:13:\"data_not_NULL\";i:0;s:10:\"data_index\";i:0;}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:31:\"field_data_field_vm_hit_rate_pc\";a:1:{s:5:\"value\";s:26:\"field_vm_hit_rate_pc_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:35:\"field_revision_field_vm_hit_rate_pc\";a:1:{s:5:\"value\";s:26:\"field_vm_hit_rate_pc_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"172\";}',1,0,0),(170,'field_vm_vmotion_policy','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:34:\"field_data_field_vm_vmotion_policy\";a:2:{s:5:\"value\";s:29:\"field_vm_vmotion_policy_value\";s:6:\"format\";s:30:\"field_vm_vmotion_policy_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:38:\"field_revision_field_vm_vmotion_policy\";a:2:{s:5:\"value\";s:29:\"field_vm_vmotion_policy_value\";s:6:\"format\";s:30:\"field_vm_vmotion_policy_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"170\";}',1,0,0),(171,'field_vm_vmotion_hostlist','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:4:\"1000\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:36:\"field_data_field_vm_vmotion_hostlist\";a:2:{s:5:\"value\";s:31:\"field_vm_vmotion_hostlist_value\";s:6:\"format\";s:32:\"field_vm_vmotion_hostlist_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:40:\"field_revision_field_vm_vmotion_hostlist\";a:2:{s:5:\"value\";s:31:\"field_vm_vmotion_hostlist_value\";s:6:\"format\";s:32:\"field_vm_vmotion_hostlist_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:3:\"171\";}',1,0,0),(173,'field_drs','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:20:\"field_data_field_drs\";a:1:{s:5:\"value\";s:15:\"field_drs_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:24:\"field_revision_field_drs\";a:1:{s:5:\"value\";s:15:\"field_drs_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"173\";}',1,0,0),(174,'field_ha','number_integer','number',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:19:\"field_data_field_ha\";a:1:{s:5:\"value\";s:14:\"field_ha_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:23:\"field_revision_field_ha\";a:1:{s:5:\"value\";s:14:\"field_ha_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"174\";}',1,0,0),(175,'field_vdisk_hit_rate_pc','computed','computed_field',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:4:{s:4:\"code\";s:31:\"$entity_field[0][\'value\'] = \"\";\";s:14:\"display_format\";s:46:\"$display_output = $entity_field_item[\'value\'];\";s:5:\"store\";i:1;s:8:\"database\";a:8:{s:9:\"data_type\";s:7:\"varchar\";s:11:\"data_length\";s:2:\"32\";s:9:\"data_size\";s:6:\"normal\";s:14:\"data_precision\";s:2:\"10\";s:10:\"data_scale\";s:1:\"2\";s:12:\"data_default\";s:0:\"\";s:13:\"data_not_NULL\";i:0;s:10:\"data_index\";i:0;}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:34:\"field_data_field_vdisk_hit_rate_pc\";a:1:{s:5:\"value\";s:29:\"field_vdisk_hit_rate_pc_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:38:\"field_revision_field_vdisk_hit_rate_pc\";a:1:{s:5:\"value\";s:29:\"field_vdisk_hit_rate_pc_value\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:3:\"175\";}',1,0,0);
/*!40000 ALTER TABLE `field_config` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_config_instance`
--

DROP TABLE IF EXISTS `field_config_instance`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_config_instance` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a field instance',
  `field_id` int(11) NOT NULL COMMENT 'The identifier of the field attached by this instance',
  `field_name` varchar(32) NOT NULL DEFAULT '',
  `entity_type` varchar(32) NOT NULL DEFAULT '',
  `bundle` varchar(128) NOT NULL DEFAULT '',
  `data` longblob NOT NULL,
  `deleted` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `field_name_bundle` (`field_name`,`entity_type`,`bundle`),
  KEY `deleted` (`deleted`)
) ENGINE=MyISAM AUTO_INCREMENT=200 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_config_instance`
--

LOCK TABLES `field_config_instance` WRITE;
/*!40000 ALTER TABLE `field_config_instance` DISABLE KEYS */;
INSERT INTO `field_config_instance` VALUES (1,1,'comment_body','comment','comment_node_page','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(2,2,'body','node','page','a:6:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";i:-4;s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(3,1,'comment_body','comment','comment_node_article','a:7:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"1\";s:18:\"user_register_form\";b:0;}s:8:\"required\";i:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:5:{s:6:\"weight\";i:0;s:4:\"type\";s:13:\"text_textarea\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"rows\";s:1:\"5\";}}s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(4,2,'body','node','article','a:6:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";i:-4;s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(5,3,'field_tags','node','article','a:7:{s:5:\"label\";s:4:\"Tags\";s:11:\"description\";s:63:\"Enter a comma-separated list of words to describe your content.\";s:6:\"widget\";a:5:{s:6:\"weight\";i:-4;s:4:\"type\";s:21:\"taxonomy_autocomplete\";s:6:\"module\";s:8:\"taxonomy\";s:6:\"active\";i:0;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:21:\"taxonomy/autocomplete\";}}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";i:10;s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}s:6:\"teaser\";a:5:{s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";i:10;s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:8:\"required\";i:0;s:13:\"default_value\";N;}',0),(7,1,'comment_body','comment','comment_node_vcenter','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(8,2,'body','node','vcenter','a:7:{s:5:\"label\";s:11:\"Description\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"5\";s:4:\"type\";s:26:\"text_textarea_with_summary\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:4:\"rows\";s:2:\"10\";s:12:\"summary_rows\";i:5;}}s:8:\"settings\";a:3:{s:15:\"text_processing\";s:1:\"1\";s:15:\"display_summary\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(9,5,'field_ip_address','node','vcenter','a:7:{s:5:\"label\";s:10:\"IP Address\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:1;}}s:8:\"required\";i:0;s:11:\"description\";s:27:\"Please enter the IP Address\";s:13:\"default_value\";N;}',0),(10,6,'field_username','node','vcenter','a:7:{s:5:\"label\";s:8:\"Username\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:2;}}s:8:\"required\";i:1;s:11:\"description\";s:27:\"Please provide the username\";s:13:\"default_value\";N;}',0),(11,7,'field_password','node','vcenter','a:7:{s:5:\"label\";s:8:\"Password\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:3;}}s:8:\"required\";i:1;s:11:\"description\";s:27:\"Please provide the password\";s:13:\"default_value\";N;}',0),(12,1,'comment_body','comment','comment_node_data_center','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(13,2,'body','node','data_center','a:7:{s:5:\"label\";s:11:\"Description\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"-4\";s:4:\"type\";s:26:\"text_textarea_with_summary\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:4:\"rows\";s:2:\"10\";s:12:\"summary_rows\";i:5;}}s:8:\"settings\";a:3:{s:15:\"text_processing\";s:1:\"1\";s:15:\"display_summary\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(15,1,'comment_body','comment','comment_node_virtual_machine','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(17,9,'field_vm_ip_address','node','virtual_machine','a:7:{s:5:\"label\";s:10:\"IP Address\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(19,11,'field_memory_size','node','virtual_machine','a:7:{s:5:\"label\";s:11:\"Memory Size\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"6\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(21,13,'field_template','node','virtual_machine','a:7:{s:5:\"label\";s:8:\"Template\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"7\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(22,14,'field_vm_path_name','node','virtual_machine','a:7:{s:5:\"label\";s:12:\"VM Path Name\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"8\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(23,15,'field_guest_os','node','virtual_machine','a:7:{s:5:\"label\";s:8:\"Guest OS\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"9\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(24,16,'field_guest_id','node','virtual_machine','a:7:{s:5:\"label\";s:8:\"Guest ID\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"10\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"5\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(26,18,'field_cpu_usage','node','virtual_machine','a:7:{s:5:\"label\";s:9:\"CPU Usage\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"11\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"7\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(27,19,'field_host_memory_usage','node','virtual_machine','a:7:{s:5:\"label\";s:17:\"Host Memory Usage\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"12\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"10\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(28,20,'field_guest_memory_usage','node','virtual_machine','a:7:{s:5:\"label\";s:18:\"Guest Memory Usage\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"13\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"11\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(29,1,'comment_body','comment','comment_node_host','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(31,1,'comment_body','comment','comment_node_device','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(33,1,'comment_body','comment','comment_node_vdisk','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(35,21,'field_cpu_model','node','host','a:7:{s:5:\"label\";s:9:\"Cpu Model\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:1;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(36,18,'field_cpu_usage','node','host','a:7:{s:5:\"label\";s:9:\"CPU Usage\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:2;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(37,22,'field_boottime','node','host','a:7:{s:5:\"label\";s:8:\"BootTime\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"5\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:3;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(38,23,'field_host_status','node','host','a:7:{s:5:\"label\";s:11:\"Host Status\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"6\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:4;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(39,24,'field_maintenance_mode','node','host','a:7:{s:5:\"label\";s:16:\"Maintenance mode\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"7\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:5;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(40,25,'field_physical_memory','node','host','a:7:{s:5:\"label\";s:15:\"Physical Memory\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"8\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:6;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(41,26,'field_vmotion','node','host','a:7:{s:5:\"label\";s:7:\"VMotion\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"9\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:7;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(42,27,'field_reboot_required','node','host','a:7:{s:5:\"label\";s:15:\"Reboot Required\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"10\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:8;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(47,31,'field_serial_no','node','device','a:7:{s:5:\"label\";s:9:\"Serial No\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:2;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(48,32,'field_size','node','device','a:7:{s:5:\"label\";s:4:\"Size\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:3;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(49,33,'field_device_type','node','device','a:7:{s:5:\"label\";s:11:\"Device Type\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"5\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:4;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(50,34,'field_multipath_plugin','node','device','a:7:{s:5:\"label\";s:16:\"Multipath Plugin\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"6\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:5;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(51,35,'field_devfs_path','node','device','a:7:{s:5:\"label\";s:10:\"Devfs Path\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"7\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:6;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(52,36,'field_vendor','node','device','a:7:{s:5:\"label\";s:6:\"Vendor\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"8\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:7;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(53,37,'field_model','node','device','a:7:{s:5:\"label\";s:5:\"Model\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"9\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:8;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(54,38,'field_revision','node','device','a:7:{s:5:\"label\";s:8:\"Revision\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"10\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:9;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(55,39,'field_scsi_level','node','device','a:7:{s:5:\"label\";s:10:\"SCSI Level\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"11\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:10;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(56,40,'field_is_pseudo','node','device','a:7:{s:5:\"label\";s:9:\"Is Pseudo\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"12\";s:4:\"type\";s:15:\"options_buttons\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"list_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";s:6:\"weight\";i:11;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(57,41,'field_status','node','device','a:7:{s:5:\"label\";s:6:\"Status\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"13\";s:4:\"type\";s:15:\"options_buttons\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"list_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";s:6:\"weight\";i:12;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(58,42,'field_is_rdm_capable','node','device','a:7:{s:5:\"label\";s:14:\"Is RDM Capable\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"14\";s:4:\"type\";s:15:\"options_buttons\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"list_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";s:6:\"weight\";i:13;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(59,43,'field_is_local','node','device','a:7:{s:5:\"label\";s:8:\"Is Local\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"15\";s:4:\"type\";s:15:\"options_buttons\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"list_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";s:6:\"weight\";i:14;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(60,44,'field_is_removable','node','device','a:7:{s:5:\"label\";s:12:\"Is Removable\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"16\";s:4:\"type\";s:15:\"options_buttons\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"list_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";s:6:\"weight\";i:15;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(61,45,'field_is_ssd','node','device','a:7:{s:5:\"label\";s:6:\"Is SSD\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"17\";s:4:\"type\";s:15:\"options_buttons\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"list_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";s:6:\"weight\";i:16;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(62,46,'field_is_offline','node','device','a:7:{s:5:\"label\";s:10:\"Is Offline\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"18\";s:4:\"type\";s:15:\"options_buttons\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"list_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";s:6:\"weight\";i:17;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(63,47,'field_is_perennially_reserved','node','device','a:7:{s:5:\"label\";s:23:\"Is Perennially Reserved\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"19\";s:4:\"type\";s:15:\"options_buttons\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"list_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";s:6:\"weight\";i:18;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(64,48,'field_thin_provisioning_status','node','device','a:7:{s:5:\"label\";s:24:\"Thin Provisioning Status\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"20\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:19;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(65,49,'field_attached_filters','node','device','a:7:{s:5:\"label\";s:16:\"Attached Filters\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"21\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:20;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(66,50,'field_vaai_status','node','device','a:7:{s:5:\"label\";s:11:\"VAAI Status\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"22\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:21;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(67,51,'field_other_uids','node','device','a:7:{s:5:\"label\";s:10:\"Other UIDs\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"23\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:22;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(68,52,'field_display_name','node','device','a:7:{s:5:\"label\";s:12:\"Display Name\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"1\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:23;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(69,53,'field_capacity','node','vdisk','a:7:{s:5:\"label\";s:8:\"Capacity\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:2;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(70,54,'field_path','node','vdisk','a:7:{s:5:\"label\";s:4:\"Path\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:3;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(71,55,'field_freespace','node','vdisk','a:7:{s:5:\"label\";s:9:\"Freespace\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"5\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:4;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(72,56,'field_vm_username','node','virtual_machine','a:7:{s:5:\"label\";s:8:\"Username\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"12\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(73,57,'field_vm_password','node','virtual_machine','a:7:{s:5:\"label\";s:8:\"Password\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"13\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(74,58,'field_host_username','node','host','a:7:{s:5:\"label\";s:8:\"Username\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"11\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:10;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(75,59,'field_host_password','node','host','a:7:{s:5:\"label\";s:8:\"Password\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"12\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:11;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(76,60,'field_driver_status','node','virtual_machine','a:7:{s:5:\"label\";s:13:\"Driver Status\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"14\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"14\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(77,61,'field_bundle_status','node','host','a:7:{s:5:\"label\";s:13:\"Bundle Status\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"13\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:12;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(78,1,'comment_body','comment','comment_node_panel','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(79,62,'field_related_vcenter','node','data_center','a:7:{s:5:\"label\";s:15:\"Related vCenter\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"-3\";s:4:\"type\";s:14:\"options_select\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:21:\"entityreference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:6:\"module\";s:15:\"entityreference\";s:6:\"weight\";i:1;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(80,63,'field_virtual_machine','node','vdisk','a:7:{s:5:\"label\";s:15:\"Virtual Machine\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"7\";s:4:\"type\";s:28:\"entityreference_autocomplete\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";i:1;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";s:2:\"60\";s:4:\"path\";s:0:\"\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:21:\"entityreference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:6:\"module\";s:15:\"entityreference\";s:6:\"weight\";i:5;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(81,64,'field_related_host','node','device','a:7:{s:5:\"label\";s:12:\"Related Host\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:28:\"entityreference_autocomplete\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";i:1;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";s:2:\"60\";s:4:\"path\";s:0:\"\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:21:\"entityreference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:6:\"module\";s:15:\"entityreference\";s:6:\"weight\";i:24;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(82,65,'field_datacenter','node','host','a:7:{s:5:\"label\";s:10:\"Datacenter\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:28:\"entityreference_autocomplete\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";i:1;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";s:2:\"60\";s:4:\"path\";s:0:\"\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:21:\"entityreference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:6:\"module\";s:15:\"entityreference\";s:6:\"weight\";i:13;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(83,66,'field_host','node','virtual_machine','a:7:{s:5:\"label\";s:4:\"Host\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"5\";s:4:\"type\";s:28:\"entityreference_autocomplete\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";i:1;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";s:2:\"60\";s:4:\"path\";s:0:\"\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:21:\"entityreference_label\";s:6:\"weight\";s:2:\"15\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:6:\"module\";s:15:\"entityreference\";}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(84,67,'field_vmware_tools','node','virtual_machine','a:7:{s:5:\"label\";s:12:\"VMware Tools\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"15\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"16\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(85,68,'field_software_on_host','node','host','a:7:{s:5:\"label\";s:16:\"Software on host\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"14\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:14;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(86,1,'comment_body','comment','comment_node_vm_metrics','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(88,69,'field_vm','node','vm_metrics','a:7:{s:5:\"label\";s:2:\"VM\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:28:\"entityreference_autocomplete\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";i:1;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";s:2:\"60\";s:4:\"path\";s:0:\"\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:21:\"entityreference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:6:\"module\";s:15:\"entityreference\";s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:32:\"The VM that this metrics are for\";s:13:\"default_value\";N;}',0),(89,70,'field_allocated_segments','node','host','a:7:{s:5:\"label\";s:18:\"Allocated Segments\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"31\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:15;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(90,71,'field_segment_size','node','host','a:7:{s:5:\"label\";s:12:\"Segment Size\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"32\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:16;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(91,72,'field_max_virtual_machines','node','host','a:7:{s:5:\"label\";s:20:\"Max Virtual Machines\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"33\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:17;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(92,73,'field_max_physical_devices','node','host','a:7:{s:5:\"label\";s:20:\"Max Physical Devices\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"34\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:18;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(93,74,'field_claimed_physical_devices','node','host','a:7:{s:5:\"label\";s:24:\"Claimed Physical Devices\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"35\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:19;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(94,75,'field_cache_state','node','host','a:7:{s:5:\"label\";s:11:\"Cache State\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"36\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:20;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(95,76,'field_total_segments','node','host','a:7:{s:5:\"label\";s:14:\"Total Segments\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"37\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:21;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(96,77,'field_allocated_virtual_machines','node','host','a:7:{s:5:\"label\";s:26:\"Allocated Virtual Machines\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"38\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:22;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(97,78,'field_vib_version','node','host','a:7:{s:5:\"label\";s:11:\"VIB Version\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"39\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:23;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(98,79,'field_total_size','node','host','a:7:{s:5:\"label\";s:10:\"Total Size\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"43\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:24;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(99,80,'field_naa_identifier','node','host','a:7:{s:5:\"label\";s:14:\"NAA Identifier\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"41\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:25;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(100,81,'field_allocated_size','node','host','a:7:{s:5:\"label\";s:14:\"Allocated Size\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"42\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:26;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(101,82,'field_device_state','node','host','a:7:{s:5:\"label\";s:12:\"Device State\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"44\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:27;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(102,83,'field_no_of_cpu','node','virtual_machine','a:7:{s:5:\"label\";s:9:\"no_of_cpu\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"17\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"17\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(103,84,'field_virtual_disks','node','virtual_machine','a:7:{s:5:\"label\";s:13:\"virtual_disks\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"18\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"18\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(104,86,'field_fa_build_version','node','virtual_machine','a:7:{s:5:\"label\";s:13:\"Build Version\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"33\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"19\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}}',0),(105,87,'field_fa_cache_mode','node','virtual_machine','a:7:{s:5:\"label\";s:10:\"Cache Mode\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"34\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"20\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}}',0),(106,88,'field_fa_administration_state','node','virtual_machine','a:7:{s:5:\"label\";s:20:\"Administration State\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"35\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"21\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}}',0),(107,89,'field_fa_cache_size','node','virtual_machine','a:7:{s:5:\"label\";s:10:\"Cache Size\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"36\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"22\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(108,90,'field_fa_operational_state','node','virtual_machine','a:7:{s:5:\"label\";s:17:\"Operational State\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"37\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"23\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}}',0),(109,91,'field_fa_operational_message','node','virtual_machine','a:7:{s:5:\"label\";s:19:\"Operational Message\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"38\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"24\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}}',0),(110,92,'field_fa_performance_state','node','virtual_machine','a:7:{s:5:\"label\";s:17:\"Performance State\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"39\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"25\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}}',0),(111,93,'field_fa_generation_id','node','virtual_machine','a:7:{s:5:\"label\";s:13:\"Generation ID\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"40\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"26\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}}',0),(112,94,'field_vm_read_latency','node','vm_metrics','a:7:{s:5:\"label\";s:12:\"Read latency\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"32\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:1;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(113,95,'field_vm_write_latency','node','vm_metrics','a:7:{s:5:\"label\";s:13:\"Write latency\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"33\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:2;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(114,96,'field_vm_read_ops','node','vm_metrics','a:7:{s:5:\"label\";s:8:\"Read ops\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"34\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:3;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(115,97,'field_vm_write_ops','node','vm_metrics','a:7:{s:5:\"label\";s:9:\"Write ops\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"35\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:4;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(116,98,'field_vm_hits','node','vm_metrics','a:7:{s:5:\"label\";s:4:\"Hits\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"36\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:5;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(117,99,'field_vm_read_blocks','node','vm_metrics','a:7:{s:5:\"label\";s:11:\"Read blocks\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"37\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:6;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(118,100,'field_vm_cache_latency','node','vm_metrics','a:7:{s:5:\"label\";s:13:\"Cache latency\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"40\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:7;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(119,101,'field_vm_population','node','vm_metrics','a:7:{s:5:\"label\";s:10:\"Population\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"41\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:8;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(120,102,'field_vm_usable_blocks','node','vm_metrics','a:7:{s:5:\"label\";s:13:\"Usable blocks\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"39\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:9;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(121,103,'field_vm_write_blocks','node','vm_metrics','a:7:{s:5:\"label\";s:12:\"Write blocks\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"38\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:10;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(122,104,'field_vm_insertions','node','vm_metrics','a:7:{s:5:\"label\";s:10:\"Insertions\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"42\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:11;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(125,107,'field_vm_population_pc','node','vm_metrics','a:6:{s:5:\"label\";s:12:\"Population %\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"43\";s:4:\"type\";s:8:\"computed\";s:6:\"module\";s:14:\"computed_field\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:20:\"computed_field_plain\";s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"computed_field\";s:6:\"weight\";i:13;}}s:8:\"required\";i:0;s:11:\"description\";s:43:\"Population % = (Population / Usable Blocks)\";}',0),(126,108,'field_vm_insertion_rate_pc','node','vm_metrics','a:6:{s:5:\"label\";s:16:\"Insertion rate %\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"44\";s:4:\"type\";s:8:\"computed\";s:6:\"module\";s:14:\"computed_field\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:20:\"computed_field_plain\";s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"computed_field\";s:6:\"weight\";i:14;}}s:8:\"required\";i:0;s:11:\"description\";s:64:\"Insertion rate % = ( Insertions / ( ReadBlocks + WriteBlocks ) )\";}',0),(127,1,'comment_body','comment','comment_node_vdisk_metrics','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(129,109,'field_vdisk','node','vdisk_metrics','a:7:{s:5:\"label\";s:5:\"vDisk\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:28:\"entityreference_autocomplete\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";i:1;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";s:2:\"60\";s:4:\"path\";s:0:\"\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:21:\"entityreference_label\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:6:\"module\";s:15:\"entityreference\";}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(130,110,'field_vdisk_read_latency','node','vdisk_metrics','a:7:{s:5:\"label\";s:12:\"Read latency\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_decimal\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";s:1:\"2\";s:13:\"prefix_suffix\";i:1;}s:6:\"module\";s:6:\"number\";}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(131,111,'field_vdisk_write_latency','node','vdisk_metrics','a:7:{s:5:\"label\";s:13:\"Write latency\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"5\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_decimal\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(132,112,'field_vdisk_read_ops','node','vdisk_metrics','a:7:{s:5:\"label\";s:8:\"Read ops\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"6\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_decimal\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(133,113,'field_vdisk_write_ops','node','vdisk_metrics','a:7:{s:5:\"label\";s:9:\"Write ops\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"7\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_decimal\";s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(134,114,'field_vdisk_hits','node','vdisk_metrics','a:7:{s:5:\"label\";s:4:\"Hits\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"9\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:6:\"weight\";s:1:\"5\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(135,115,'field_vdisk_read_blocks','node','vdisk_metrics','a:7:{s:5:\"label\";s:11:\"Read blocks\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"10\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:6:\"weight\";s:1:\"6\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(136,116,'field_vdisk_cache_latency','node','vdisk_metrics','a:7:{s:5:\"label\";s:13:\"Cache latency\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"12\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_decimal\";s:6:\"weight\";s:1:\"7\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(137,117,'field_vdisk_population','node','vdisk_metrics','a:7:{s:5:\"label\";s:10:\"Population\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"13\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:6:\"weight\";s:1:\"8\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(138,118,'field_vdisk_usable_blocks','node','vdisk_metrics','a:7:{s:5:\"label\";s:13:\"Usable blocks\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"14\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:6:\"weight\";s:1:\"9\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(139,119,'field_vdisk_insertions','node','vdisk_metrics','a:7:{s:5:\"label\";s:10:\"Insertions\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"15\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:6:\"weight\";s:2:\"10\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(140,120,'field_vdisk_write_blocks','node','vdisk_metrics','a:7:{s:5:\"label\";s:12:\"Write blocks\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"11\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:6:\"weight\";s:2:\"11\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:1:\"0\";}}}',0),(143,122,'field_timestamp','node','vdisk_metrics','a:6:{s:5:\"label\";s:9:\"Timestamp\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:10:\"date_popup\";s:6:\"module\";s:4:\"date\";s:6:\"active\";i:1;s:8:\"settings\";a:6:{s:12:\"input_format\";s:13:\"m/d/Y - H:i:s\";s:19:\"input_format_custom\";s:0:\"\";s:10:\"year_range\";s:5:\"-3:+3\";s:9:\"increment\";s:2:\"15\";s:14:\"label_position\";s:5:\"above\";s:10:\"text_parts\";a:0:{}}}s:8:\"settings\";a:5:{s:13:\"default_value\";s:3:\"now\";s:18:\"default_value_code\";s:0:\"\";s:14:\"default_value2\";s:4:\"same\";s:19:\"default_value_code2\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"date_default\";s:6:\"weight\";s:2:\"12\";s:8:\"settings\";a:5:{s:11:\"format_type\";s:4:\"long\";s:15:\"multiple_number\";s:0:\"\";s:13:\"multiple_from\";s:0:\"\";s:11:\"multiple_to\";s:0:\"\";s:6:\"fromto\";s:4:\"both\";}s:6:\"module\";s:4:\"date\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";}',0),(145,124,'field_vdisk_population_pc','node','vdisk_metrics','a:6:{s:5:\"label\";s:12:\"Population %\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"16\";s:4:\"type\";s:8:\"computed\";s:6:\"module\";s:14:\"computed_field\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:20:\"computed_field_plain\";s:6:\"weight\";s:2:\"14\";s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"computed_field\";}}s:8:\"required\";i:0;s:11:\"description\";s:43:\"Population % = (Population / Usable Blocks)\";}',0),(146,125,'field_vdisk_insertion_rate_pc','node','vdisk_metrics','a:6:{s:5:\"label\";s:16:\"Insertion rate %\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"17\";s:4:\"type\";s:8:\"computed\";s:6:\"module\";s:14:\"computed_field\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:20:\"computed_field_plain\";s:6:\"weight\";s:2:\"15\";s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"computed_field\";}}s:8:\"required\";i:0;s:11:\"description\";s:64:\"Insertion rate % = ( Insertions / ( ReadBlocks + WriteBlocks ) )\";}',0),(147,122,'field_timestamp','node','vm_metrics','a:6:{s:5:\"label\";s:9:\"Timestamp\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:10:\"date_popup\";s:6:\"module\";s:4:\"date\";s:6:\"active\";i:1;s:8:\"settings\";a:6:{s:12:\"input_format\";s:13:\"m/d/Y - H:i:s\";s:19:\"input_format_custom\";s:0:\"\";s:10:\"year_range\";s:5:\"-3:+3\";s:9:\"increment\";s:2:\"15\";s:14:\"label_position\";s:5:\"above\";s:10:\"text_parts\";a:0:{}}}s:8:\"settings\";a:5:{s:13:\"default_value\";s:3:\"now\";s:18:\"default_value_code\";s:0:\"\";s:14:\"default_value2\";s:4:\"same\";s:19:\"default_value_code2\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"date_default\";s:8:\"settings\";a:5:{s:11:\"format_type\";s:4:\"long\";s:15:\"multiple_number\";s:0:\"\";s:13:\"multiple_from\";s:0:\"\";s:11:\"multiple_to\";s:0:\"\";s:6:\"fromto\";s:4:\"both\";}s:6:\"module\";s:4:\"date\";s:6:\"weight\";i:15;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";}',0),(148,126,'field_disk_index','node','vdisk','a:7:{s:5:\"label\";s:10:\"Disk Index\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"9\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:6;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(149,127,'field_cachespace','node','virtual_machine','a:7:{s:5:\"label\";s:10:\"Cachespace\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"41\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:2:\"27\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(151,88,'field_fa_administration_state','node','vdisk','a:7:{s:5:\"label\";s:20:\"Administration State\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"10\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:7;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}}',0),(152,87,'field_fa_cache_mode','node','vdisk','a:7:{s:5:\"label\";s:10:\"Cache Mode\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"9\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:8;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}}',0),(153,90,'field_fa_operational_state','node','vdisk','a:7:{s:5:\"label\";s:17:\"Operational State\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"11\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:9;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}}',0),(154,91,'field_fa_operational_message','node','vdisk','a:7:{s:5:\"label\";s:19:\"Operational Message\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"12\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:10;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}}',0),(155,92,'field_fa_performance_state','node','vdisk','a:7:{s:5:\"label\";s:17:\"Performance State\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"13\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:11;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:9:\"Not Known\";}}}',0),(156,128,'field_vdisk_identifier','node','vdisk','a:7:{s:5:\"label\";s:10:\"Identifier\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"14\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:12;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(157,1,'comment_body','comment','comment_node_vm_cache_space','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(161,132,'field_vm_cache_size','node','vm_cache_space','a:7:{s:5:\"label\";s:10:\"Cache Size\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:3;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(169,140,'field_cache_assigned_from_host','node','vm_cache_space','a:7:{s:5:\"label\";s:18:\"Assigned from Host\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"11\";s:4:\"type\";s:27:\"node_reference_autocomplete\";s:6:\"module\";s:14:\"node_reference\";s:6:\"active\";i:1;s:8:\"settings\";a:3:{s:18:\"autocomplete_match\";s:8:\"contains\";s:4:\"size\";s:2:\"60\";s:17:\"autocomplete_path\";s:27:\"node_reference/autocomplete\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:22:\"node_reference_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"node_reference\";s:6:\"weight\";i:10;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(170,141,'field_cache_allocated_to_vm','node','vm_cache_space','a:7:{s:5:\"label\";s:28:\"Allocated to Virtual Machine\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"10\";s:4:\"type\";s:27:\"node_reference_autocomplete\";s:6:\"module\";s:14:\"node_reference\";s:6:\"active\";i:1;s:8:\"settings\";a:3:{s:18:\"autocomplete_match\";s:8:\"contains\";s:4:\"size\";s:2:\"60\";s:17:\"autocomplete_path\";s:27:\"node_reference/autocomplete\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:22:\"node_reference_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"node_reference\";s:6:\"weight\";i:11;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(171,142,'field_install_port','node','virtual_machine','a:7:{s:5:\"label\";s:12:\"Install Port\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"19\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:28;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:4:\"7010\";}}}',0),(172,143,'field_host_model','node','host','a:7:{s:5:\"label\";s:10:\"Host Model\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"45\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:28;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(173,144,'field_host_vendor','node','host','a:7:{s:5:\"label\";s:11:\"Host Vendor\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"46\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:29;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(174,145,'field_vm_vmotionable','node','virtual_machine','a:7:{s:5:\"label\";s:12:\"V Motionable\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"21\";s:4:\"type\";s:13:\"options_onoff\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:13:\"display_label\";i:1;}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"list_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";s:6:\"weight\";i:29;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}}',0),(176,147,'field_hbtl','node','host','a:7:{s:5:\"label\";s:4:\"HBTL\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"45\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:30;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(177,148,'field_is_vmfs','node','device','a:7:{s:5:\"label\";s:7:\"Is VMFS\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"31\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:25;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(178,149,'field_fa_usable_blocks','node','virtual_machine','a:7:{s:5:\"label\";s:13:\"Usable Blocks\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"42\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:30;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(179,150,'field_vdisk_name','node','vdisk','a:7:{s:5:\"label\";s:10:\"vDisk Name\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"1\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:13;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(180,151,'field_vdisk_type','node','vdisk','a:7:{s:5:\"label\";s:10:\"vDisk Type\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:14;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(181,152,'field_vdisk_id','node','vdisk','a:7:{s:5:\"label\";s:8:\"vDisk Id\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"6\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:15;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(183,154,'field_host_ip','node','host','a:7:{s:5:\"label\";s:2:\"IP\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"47\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:31;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(184,155,'field_hit_ops','node','vdisk_metrics','a:7:{s:5:\"label\";s:7:\"Hit Ops\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"8\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:16;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(185,156,'field_fa_sector_size','node','virtual_machine','a:7:{s:5:\"label\";s:11:\"Sector Size\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"43\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:31;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(186,157,'field_rediscover_status','node','vcenter','a:7:{s:5:\"label\";s:17:\"Rediscover Status\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"7\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:4;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(187,158,'field_hostname','node','vcenter','a:7:{s:5:\"label\";s:8:\"Hostname\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"1\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:5;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(188,159,'field_vm_hostname','node','virtual_machine','a:7:{s:5:\"label\";s:8:\"Hostname\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"1\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:32;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(189,160,'field_fa_metrics_reset_interval','node','virtual_machine','a:7:{s:5:\"label\";s:22:\"Metrics Reset Interval\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"44\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:33;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(192,168,'field_fmc_uuid','node','vcenter','a:7:{s:5:\"label\";s:8:\"FMC UUID\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"8\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:6;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(196,172,'field_vm_hit_rate_pc','node','vm_metrics','a:6:{s:5:\"label\";s:10:\"Hit Rate %\";s:6:\"widget\";a:4:{s:4:\"type\";s:8:\"computed\";s:6:\"weight\";s:2:\"45\";s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"computed_field\";}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:20:\"computed_field_plain\";s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"computed_field\";s:6:\"weight\";i:16;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(194,170,'field_vm_vmotion_policy','node','virtual_machine','a:7:{s:5:\"label\";s:17:\"VM vMotion Policy\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"24\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:35;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(195,171,'field_vm_vmotion_hostlist','node','virtual_machine','a:7:{s:5:\"label\";s:19:\"VM vMotion Hostlist\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"22\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";i:0;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:36;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(197,173,'field_drs','node','host','a:7:{s:5:\"label\";s:3:\"drs\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"48\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:32;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(198,174,'field_ha','node','host','a:7:{s:5:\"label\";s:2:\"HA\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"49\";s:4:\"type\";s:6:\"number\";s:6:\"module\";s:6:\"number\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";s:6:\"weight\";i:33;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(199,175,'field_vdisk_hit_rate_pc','node','vdisk_metrics','a:6:{s:5:\"label\";s:10:\"Hit Rate %\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"18\";s:4:\"type\";s:8:\"computed\";s:6:\"module\";s:14:\"computed_field\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:20:\"computed_field_plain\";s:8:\"settings\";a:0:{}s:6:\"module\";s:14:\"computed_field\";s:6:\"weight\";i:17;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";}',0);
/*!40000 ALTER TABLE `field_config_instance` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_body`
--

DROP TABLE IF EXISTS `field_data_body`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_body` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `body_value` longtext,
  `body_summary` longtext,
  `body_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `body_format` (`body_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 2 (body)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_body`
--

LOCK TABLES `field_data_body` WRITE;
/*!40000 ALTER TABLE `field_data_body` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_body` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_comment_body`
--

DROP TABLE IF EXISTS `field_data_comment_body`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_comment_body` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `comment_body_value` longtext,
  `comment_body_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `comment_body_format` (`comment_body_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 1 (comment_body)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_comment_body`
--

LOCK TABLES `field_data_comment_body` WRITE;
/*!40000 ALTER TABLE `field_data_comment_body` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_comment_body` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_administration_state`
--

DROP TABLE IF EXISTS `field_data_field_administration_state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_administration_state` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_administration_state_value` varchar(255) DEFAULT NULL,
  `field_administration_state_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_administration_state_format` (`field_administration_state_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 71 (field_administration_state)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_administration_state`
--

LOCK TABLES `field_data_field_administration_state` WRITE;
/*!40000 ALTER TABLE `field_data_field_administration_state` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_administration_state` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_allocated_segments`
--

DROP TABLE IF EXISTS `field_data_field_allocated_segments`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_allocated_segments` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_allocated_segments_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 70 (field_allocated_segments)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_allocated_segments`
--

LOCK TABLES `field_data_field_allocated_segments` WRITE;
/*!40000 ALTER TABLE `field_data_field_allocated_segments` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_allocated_segments` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_allocated_size`
--

DROP TABLE IF EXISTS `field_data_field_allocated_size`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_allocated_size` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_allocated_size_value` varchar(255) DEFAULT NULL,
  `field_allocated_size_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_allocated_size_format` (`field_allocated_size_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 81 (field_allocated_size)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_allocated_size`
--

LOCK TABLES `field_data_field_allocated_size` WRITE;
/*!40000 ALTER TABLE `field_data_field_allocated_size` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_allocated_size` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_allocated_virtual_machines`
--

DROP TABLE IF EXISTS `field_data_field_allocated_virtual_machines`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_allocated_virtual_machines` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_allocated_virtual_machines_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 77 (field_allocated_virtual_machines)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_allocated_virtual_machines`
--

LOCK TABLES `field_data_field_allocated_virtual_machines` WRITE;
/*!40000 ALTER TABLE `field_data_field_allocated_virtual_machines` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_allocated_virtual_machines` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_attached_filters`
--

DROP TABLE IF EXISTS `field_data_field_attached_filters`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_attached_filters` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_attached_filters_value` varchar(255) DEFAULT NULL,
  `field_attached_filters_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_attached_filters_format` (`field_attached_filters_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 49 (field_attached_filters)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_attached_filters`
--

LOCK TABLES `field_data_field_attached_filters` WRITE;
/*!40000 ALTER TABLE `field_data_field_attached_filters` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_attached_filters` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_boottime`
--

DROP TABLE IF EXISTS `field_data_field_boottime`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_boottime` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_boottime_value` varchar(255) DEFAULT NULL,
  `field_boottime_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_boottime_format` (`field_boottime_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 22 (field_boottime)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_boottime`
--

LOCK TABLES `field_data_field_boottime` WRITE;
/*!40000 ALTER TABLE `field_data_field_boottime` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_boottime` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_build_version`
--

DROP TABLE IF EXISTS `field_data_field_build_version`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_build_version` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_build_version_value` varchar(255) DEFAULT NULL,
  `field_build_version_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_build_version_format` (`field_build_version_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 69 (field_build_version)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_build_version`
--

LOCK TABLES `field_data_field_build_version` WRITE;
/*!40000 ALTER TABLE `field_data_field_build_version` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_build_version` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_bundle_status`
--

DROP TABLE IF EXISTS `field_data_field_bundle_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_bundle_status` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_bundle_status_value` varchar(255) DEFAULT NULL,
  `field_bundle_status_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_bundle_status_format` (`field_bundle_status_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 61 (field_bundle_status)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_bundle_status`
--

LOCK TABLES `field_data_field_bundle_status` WRITE;
/*!40000 ALTER TABLE `field_data_field_bundle_status` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_bundle_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_cache_allocated_to_vm`
--

DROP TABLE IF EXISTS `field_data_field_cache_allocated_to_vm`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_cache_allocated_to_vm` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_cache_allocated_to_vm_nid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_cache_allocated_to_vm_nid` (`field_cache_allocated_to_vm_nid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 141 (field_cache_allocated_to_vm)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_cache_allocated_to_vm`
--

LOCK TABLES `field_data_field_cache_allocated_to_vm` WRITE;
/*!40000 ALTER TABLE `field_data_field_cache_allocated_to_vm` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_cache_allocated_to_vm` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_cache_assigned_from_host`
--

DROP TABLE IF EXISTS `field_data_field_cache_assigned_from_host`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_cache_assigned_from_host` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_cache_assigned_from_host_nid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_cache_assigned_from_host_nid` (`field_cache_assigned_from_host_nid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 140 (field_cache_assigned_from_host)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_cache_assigned_from_host`
--

LOCK TABLES `field_data_field_cache_assigned_from_host` WRITE;
/*!40000 ALTER TABLE `field_data_field_cache_assigned_from_host` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_cache_assigned_from_host` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_cache_mode`
--

DROP TABLE IF EXISTS `field_data_field_cache_mode`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_cache_mode` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_cache_mode_value` varchar(255) DEFAULT NULL,
  `field_cache_mode_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_cache_mode_format` (`field_cache_mode_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 70 (field_cache_mode)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_cache_mode`
--

LOCK TABLES `field_data_field_cache_mode` WRITE;
/*!40000 ALTER TABLE `field_data_field_cache_mode` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_cache_mode` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_cache_size`
--

DROP TABLE IF EXISTS `field_data_field_cache_size`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_cache_size` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_cache_size_value` varchar(255) DEFAULT NULL,
  `field_cache_size_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_cache_size_format` (`field_cache_size_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 72 (field_cache_size)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_cache_size`
--

LOCK TABLES `field_data_field_cache_size` WRITE;
/*!40000 ALTER TABLE `field_data_field_cache_size` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_cache_size` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_cache_state`
--

DROP TABLE IF EXISTS `field_data_field_cache_state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_cache_state` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_cache_state_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 75 (field_cache_state)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_cache_state`
--

LOCK TABLES `field_data_field_cache_state` WRITE;
/*!40000 ALTER TABLE `field_data_field_cache_state` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_cache_state` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_cachespace`
--

DROP TABLE IF EXISTS `field_data_field_cachespace`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_cachespace` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_cachespace_value` varchar(255) DEFAULT NULL,
  `field_cachespace_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_cachespace_format` (`field_cachespace_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 127 (field_cachespace)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_cachespace`
--

LOCK TABLES `field_data_field_cachespace` WRITE;
/*!40000 ALTER TABLE `field_data_field_cachespace` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_cachespace` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_capacity`
--

DROP TABLE IF EXISTS `field_data_field_capacity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_capacity` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_capacity_value` varchar(255) DEFAULT NULL,
  `field_capacity_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_capacity_format` (`field_capacity_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 53 (field_capacity)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_capacity`
--

LOCK TABLES `field_data_field_capacity` WRITE;
/*!40000 ALTER TABLE `field_data_field_capacity` DISABLE KEYS */;
INSERT INTO `field_data_field_capacity` VALUES ('node','vdisk',0,11729,34660,'und',0,'32212254720',NULL),('node','vdisk',0,14410,14410,'und',0,'32105295872',NULL);
/*!40000 ALTER TABLE `field_data_field_capacity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_claimed_physical_devices`
--

DROP TABLE IF EXISTS `field_data_field_claimed_physical_devices`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_claimed_physical_devices` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_claimed_physical_devices_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 74 (field_claimed_physical_devices)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_claimed_physical_devices`
--

LOCK TABLES `field_data_field_claimed_physical_devices` WRITE;
/*!40000 ALTER TABLE `field_data_field_claimed_physical_devices` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_claimed_physical_devices` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_cpu_model`
--

DROP TABLE IF EXISTS `field_data_field_cpu_model`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_cpu_model` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_cpu_model_value` varchar(255) DEFAULT NULL,
  `field_cpu_model_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_cpu_model_format` (`field_cpu_model_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 21 (field_cpu_model)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_cpu_model`
--

LOCK TABLES `field_data_field_cpu_model` WRITE;
/*!40000 ALTER TABLE `field_data_field_cpu_model` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_cpu_model` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_cpu_usage`
--

DROP TABLE IF EXISTS `field_data_field_cpu_usage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_cpu_usage` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_cpu_usage_value` varchar(255) DEFAULT NULL,
  `field_cpu_usage_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_cpu_usage_format` (`field_cpu_usage_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 18 (field_cpu_usage)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_cpu_usage`
--

LOCK TABLES `field_data_field_cpu_usage` WRITE;
/*!40000 ALTER TABLE `field_data_field_cpu_usage` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_cpu_usage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_datacenter`
--

DROP TABLE IF EXISTS `field_data_field_datacenter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_datacenter` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_datacenter_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_datacenter_target_id` (`field_datacenter_target_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 65 (field_datacenter)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_datacenter`
--

LOCK TABLES `field_data_field_datacenter` WRITE;
/*!40000 ALTER TABLE `field_data_field_datacenter` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_datacenter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_devfs_path`
--

DROP TABLE IF EXISTS `field_data_field_devfs_path`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_devfs_path` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_devfs_path_value` varchar(255) DEFAULT NULL,
  `field_devfs_path_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_devfs_path_format` (`field_devfs_path_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 35 (field_devfs_path)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_devfs_path`
--

LOCK TABLES `field_data_field_devfs_path` WRITE;
/*!40000 ALTER TABLE `field_data_field_devfs_path` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_devfs_path` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_device_state`
--

DROP TABLE IF EXISTS `field_data_field_device_state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_device_state` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_device_state_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 82 (field_device_state)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_device_state`
--

LOCK TABLES `field_data_field_device_state` WRITE;
/*!40000 ALTER TABLE `field_data_field_device_state` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_device_state` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_device_type`
--

DROP TABLE IF EXISTS `field_data_field_device_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_device_type` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_device_type_value` varchar(255) DEFAULT NULL,
  `field_device_type_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_device_type_format` (`field_device_type_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 33 (field_device_type)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_device_type`
--

LOCK TABLES `field_data_field_device_type` WRITE;
/*!40000 ALTER TABLE `field_data_field_device_type` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_device_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_disk_index`
--

DROP TABLE IF EXISTS `field_data_field_disk_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_disk_index` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_disk_index_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 126 (field_disk_index)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_disk_index`
--

LOCK TABLES `field_data_field_disk_index` WRITE;
/*!40000 ALTER TABLE `field_data_field_disk_index` DISABLE KEYS */;
INSERT INTO `field_data_field_disk_index` VALUES ('node','vdisk',0,11729,34660,'und',0,0),('node','vdisk',0,14410,14410,'und',0,0);
/*!40000 ALTER TABLE `field_data_field_disk_index` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_display_name`
--

DROP TABLE IF EXISTS `field_data_field_display_name`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_display_name` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_display_name_value` varchar(255) DEFAULT NULL,
  `field_display_name_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_display_name_format` (`field_display_name_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 52 (field_display_name)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_display_name`
--

LOCK TABLES `field_data_field_display_name` WRITE;
/*!40000 ALTER TABLE `field_data_field_display_name` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_display_name` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_driver_status`
--

DROP TABLE IF EXISTS `field_data_field_driver_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_driver_status` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_driver_status_value` varchar(255) DEFAULT NULL,
  `field_driver_status_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_driver_status_format` (`field_driver_status_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 60 (field_driver_status)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_driver_status`
--

LOCK TABLES `field_data_field_driver_status` WRITE;
/*!40000 ALTER TABLE `field_data_field_driver_status` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_driver_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_drs`
--

DROP TABLE IF EXISTS `field_data_field_drs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_drs` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_drs_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 173 (field_drs)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_drs`
--

LOCK TABLES `field_data_field_drs` WRITE;
/*!40000 ALTER TABLE `field_data_field_drs` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_drs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_fa_administration_state`
--

DROP TABLE IF EXISTS `field_data_field_fa_administration_state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_fa_administration_state` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fa_administration_state_value` varchar(255) DEFAULT NULL,
  `field_fa_administration_state_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fa_administration_state_format` (`field_fa_administration_state_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 88 (field_fa_administration_state)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_fa_administration_state`
--

LOCK TABLES `field_data_field_fa_administration_state` WRITE;
/*!40000 ALTER TABLE `field_data_field_fa_administration_state` DISABLE KEYS */;
INSERT INTO `field_data_field_fa_administration_state` VALUES ('node','vdisk',0,11729,34660,'und',0,'ADMIN_ENABLED',NULL),('node','vdisk',0,14410,14410,'und',0,'ADMIN_DISABLED',NULL);
/*!40000 ALTER TABLE `field_data_field_fa_administration_state` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_fa_build_version`
--

DROP TABLE IF EXISTS `field_data_field_fa_build_version`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_fa_build_version` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fa_build_version_value` varchar(255) DEFAULT NULL,
  `field_fa_build_version_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fa_build_version_format` (`field_fa_build_version_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 86 (field_fa_build_version)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_fa_build_version`
--

LOCK TABLES `field_data_field_fa_build_version` WRITE;
/*!40000 ALTER TABLE `field_data_field_fa_build_version` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_fa_build_version` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_fa_cache_mode`
--

DROP TABLE IF EXISTS `field_data_field_fa_cache_mode`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_fa_cache_mode` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fa_cache_mode_value` varchar(255) DEFAULT NULL,
  `field_fa_cache_mode_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fa_cache_mode_format` (`field_fa_cache_mode_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 87 (field_fa_cache_mode)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_fa_cache_mode`
--

LOCK TABLES `field_data_field_fa_cache_mode` WRITE;
/*!40000 ALTER TABLE `field_data_field_fa_cache_mode` DISABLE KEYS */;
INSERT INTO `field_data_field_fa_cache_mode` VALUES ('node','vdisk',0,11729,34660,'und',0,'CM_WRITETHRU',NULL),('node','vdisk',0,14410,14410,'und',0,'CM_WRITETHRU',NULL);
/*!40000 ALTER TABLE `field_data_field_fa_cache_mode` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_fa_cache_size`
--

DROP TABLE IF EXISTS `field_data_field_fa_cache_size`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_fa_cache_size` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fa_cache_size_value` varchar(255) DEFAULT NULL,
  `field_fa_cache_size_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fa_cache_size_format` (`field_fa_cache_size_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 89 (field_fa_cache_size)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_fa_cache_size`
--

LOCK TABLES `field_data_field_fa_cache_size` WRITE;
/*!40000 ALTER TABLE `field_data_field_fa_cache_size` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_fa_cache_size` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_fa_generation_id`
--

DROP TABLE IF EXISTS `field_data_field_fa_generation_id`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_fa_generation_id` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fa_generation_id_value` varchar(255) DEFAULT NULL,
  `field_fa_generation_id_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fa_generation_id_format` (`field_fa_generation_id_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 93 (field_fa_generation_id)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_fa_generation_id`
--

LOCK TABLES `field_data_field_fa_generation_id` WRITE;
/*!40000 ALTER TABLE `field_data_field_fa_generation_id` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_fa_generation_id` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_fa_metrics_reset_interval`
--

DROP TABLE IF EXISTS `field_data_field_fa_metrics_reset_interval`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_fa_metrics_reset_interval` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fa_metrics_reset_interval_value` varchar(255) DEFAULT NULL,
  `field_fa_metrics_reset_interval_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fa_metrics_reset_interval_format` (`field_fa_metrics_reset_interval_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 160 (field_fa_metrics_reset_interval)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_fa_metrics_reset_interval`
--

LOCK TABLES `field_data_field_fa_metrics_reset_interval` WRITE;
/*!40000 ALTER TABLE `field_data_field_fa_metrics_reset_interval` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_fa_metrics_reset_interval` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_fa_operational_message`
--

DROP TABLE IF EXISTS `field_data_field_fa_operational_message`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_fa_operational_message` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fa_operational_message_value` varchar(255) DEFAULT NULL,
  `field_fa_operational_message_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fa_operational_message_format` (`field_fa_operational_message_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 91 (field_fa_operational_message)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_fa_operational_message`
--

LOCK TABLES `field_data_field_fa_operational_message` WRITE;
/*!40000 ALTER TABLE `field_data_field_fa_operational_message` DISABLE KEYS */;
INSERT INTO `field_data_field_fa_operational_message` VALUES ('node','vdisk',0,11729,34660,'und',0,'Waiting for cache ...',NULL),('node','vdisk',0,14410,14410,'und',0,'Admin disabled.',NULL);
/*!40000 ALTER TABLE `field_data_field_fa_operational_message` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_fa_operational_state`
--

DROP TABLE IF EXISTS `field_data_field_fa_operational_state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_fa_operational_state` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fa_operational_state_value` varchar(255) DEFAULT NULL,
  `field_fa_operational_state_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fa_operational_state_format` (`field_fa_operational_state_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 90 (field_fa_operational_state)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_fa_operational_state`
--

LOCK TABLES `field_data_field_fa_operational_state` WRITE;
/*!40000 ALTER TABLE `field_data_field_fa_operational_state` DISABLE KEYS */;
INSERT INTO `field_data_field_fa_operational_state` VALUES ('node','vdisk',0,11729,34660,'und',0,'OP_PENDING',NULL),('node','vdisk',0,14410,14410,'und',0,'OP_DISABLED',NULL);
/*!40000 ALTER TABLE `field_data_field_fa_operational_state` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_fa_performance_state`
--

DROP TABLE IF EXISTS `field_data_field_fa_performance_state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_fa_performance_state` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fa_performance_state_value` varchar(255) DEFAULT NULL,
  `field_fa_performance_state_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fa_performance_state_format` (`field_fa_performance_state_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 92 (field_fa_performance_state)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_fa_performance_state`
--

LOCK TABLES `field_data_field_fa_performance_state` WRITE;
/*!40000 ALTER TABLE `field_data_field_fa_performance_state` DISABLE KEYS */;
INSERT INTO `field_data_field_fa_performance_state` VALUES ('node','vdisk',0,11729,34660,'und',0,'ADMIN_ENABLED',NULL),('node','vdisk',0,14410,14410,'und',0,'ADMIN_DISABLED',NULL);
/*!40000 ALTER TABLE `field_data_field_fa_performance_state` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_fa_sector_size`
--

DROP TABLE IF EXISTS `field_data_field_fa_sector_size`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_fa_sector_size` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fa_sector_size_value` varchar(10) DEFAULT NULL,
  `field_fa_sector_size_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fa_sector_size_format` (`field_fa_sector_size_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 156 (field_fa_sector_size)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_fa_sector_size`
--

LOCK TABLES `field_data_field_fa_sector_size` WRITE;
/*!40000 ALTER TABLE `field_data_field_fa_sector_size` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_fa_sector_size` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_fa_usable_blocks`
--

DROP TABLE IF EXISTS `field_data_field_fa_usable_blocks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_fa_usable_blocks` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fa_usable_blocks_value` varchar(255) DEFAULT NULL,
  `field_fa_usable_blocks_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fa_usable_blocks_format` (`field_fa_usable_blocks_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 149 (field_fa_usable_blocks)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_fa_usable_blocks`
--

LOCK TABLES `field_data_field_fa_usable_blocks` WRITE;
/*!40000 ALTER TABLE `field_data_field_fa_usable_blocks` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_fa_usable_blocks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_fmc_uuid`
--

DROP TABLE IF EXISTS `field_data_field_fmc_uuid`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_fmc_uuid` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fmc_uuid_value` varchar(255) DEFAULT NULL,
  `field_fmc_uuid_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fmc_uuid_format` (`field_fmc_uuid_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 168 (field_fmc_uuid)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_fmc_uuid`
--

LOCK TABLES `field_data_field_fmc_uuid` WRITE;
/*!40000 ALTER TABLE `field_data_field_fmc_uuid` DISABLE KEYS */;
INSERT INTO `field_data_field_fmc_uuid` VALUES ('node','vcenter',0,1,1,'und',0,'',NULL);
/*!40000 ALTER TABLE `field_data_field_fmc_uuid` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_freespace`
--

DROP TABLE IF EXISTS `field_data_field_freespace`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_freespace` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_freespace_value` varchar(255) DEFAULT NULL,
  `field_freespace_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_freespace_format` (`field_freespace_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 55 (field_freespace)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_freespace`
--

LOCK TABLES `field_data_field_freespace` WRITE;
/*!40000 ALTER TABLE `field_data_field_freespace` DISABLE KEYS */;
INSERT INTO `field_data_field_freespace` VALUES ('node','vdisk',0,11729,34660,'und',0,'Not Known',NULL),('node','vdisk',0,14410,14410,'und',0,'17726402560',NULL);
/*!40000 ALTER TABLE `field_data_field_freespace` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_generation_id`
--

DROP TABLE IF EXISTS `field_data_field_generation_id`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_generation_id` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_generation_id_value` varchar(255) DEFAULT NULL,
  `field_generation_id_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_generation_id_format` (`field_generation_id_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 76 (field_generation_id)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_generation_id`
--

LOCK TABLES `field_data_field_generation_id` WRITE;
/*!40000 ALTER TABLE `field_data_field_generation_id` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_generation_id` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_guest_id`
--

DROP TABLE IF EXISTS `field_data_field_guest_id`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_guest_id` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_guest_id_value` varchar(255) DEFAULT NULL,
  `field_guest_id_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_guest_id_format` (`field_guest_id_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 16 (field_guest_id)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_guest_id`
--

LOCK TABLES `field_data_field_guest_id` WRITE;
/*!40000 ALTER TABLE `field_data_field_guest_id` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_guest_id` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_guest_memory_usage`
--

DROP TABLE IF EXISTS `field_data_field_guest_memory_usage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_guest_memory_usage` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_guest_memory_usage_value` varchar(255) DEFAULT NULL,
  `field_guest_memory_usage_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_guest_memory_usage_format` (`field_guest_memory_usage_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 20 (field_guest_memory_usage)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_guest_memory_usage`
--

LOCK TABLES `field_data_field_guest_memory_usage` WRITE;
/*!40000 ALTER TABLE `field_data_field_guest_memory_usage` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_guest_memory_usage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_guest_os`
--

DROP TABLE IF EXISTS `field_data_field_guest_os`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_guest_os` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_guest_os_value` varchar(255) DEFAULT NULL,
  `field_guest_os_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_guest_os_format` (`field_guest_os_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 15 (field_guest_os)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_guest_os`
--

LOCK TABLES `field_data_field_guest_os` WRITE;
/*!40000 ALTER TABLE `field_data_field_guest_os` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_guest_os` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_ha`
--

DROP TABLE IF EXISTS `field_data_field_ha`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_ha` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_ha_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 174 (field_ha)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_ha`
--

LOCK TABLES `field_data_field_ha` WRITE;
/*!40000 ALTER TABLE `field_data_field_ha` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_ha` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_hbtl`
--

DROP TABLE IF EXISTS `field_data_field_hbtl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_hbtl` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_hbtl_value` varchar(255) DEFAULT NULL,
  `field_hbtl_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_hbtl_format` (`field_hbtl_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 147 (field_hbtl)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_hbtl`
--

LOCK TABLES `field_data_field_hbtl` WRITE;
/*!40000 ALTER TABLE `field_data_field_hbtl` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_hbtl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_hit_ops`
--

DROP TABLE IF EXISTS `field_data_field_hit_ops`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_hit_ops` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_hit_ops_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 155 (field_hit_ops)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_hit_ops`
--

LOCK TABLES `field_data_field_hit_ops` WRITE;
/*!40000 ALTER TABLE `field_data_field_hit_ops` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_hit_ops` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_host`
--

DROP TABLE IF EXISTS `field_data_field_host`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_host` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_host_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_host_target_id` (`field_host_target_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 66 (field_host)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_host`
--

LOCK TABLES `field_data_field_host` WRITE;
/*!40000 ALTER TABLE `field_data_field_host` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_host` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_host_ip`
--

DROP TABLE IF EXISTS `field_data_field_host_ip`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_host_ip` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_host_ip_value` varchar(255) DEFAULT NULL,
  `field_host_ip_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_host_ip_format` (`field_host_ip_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 154 (field_host_ip)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_host_ip`
--

LOCK TABLES `field_data_field_host_ip` WRITE;
/*!40000 ALTER TABLE `field_data_field_host_ip` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_host_ip` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_host_memory_usage`
--

DROP TABLE IF EXISTS `field_data_field_host_memory_usage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_host_memory_usage` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_host_memory_usage_value` varchar(255) DEFAULT NULL,
  `field_host_memory_usage_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_host_memory_usage_format` (`field_host_memory_usage_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 19 (field_host_memory_usage)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_host_memory_usage`
--

LOCK TABLES `field_data_field_host_memory_usage` WRITE;
/*!40000 ALTER TABLE `field_data_field_host_memory_usage` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_host_memory_usage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_host_model`
--

DROP TABLE IF EXISTS `field_data_field_host_model`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_host_model` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_host_model_value` varchar(255) DEFAULT NULL,
  `field_host_model_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_host_model_format` (`field_host_model_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 143 (field_host_model)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_host_model`
--

LOCK TABLES `field_data_field_host_model` WRITE;
/*!40000 ALTER TABLE `field_data_field_host_model` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_host_model` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_host_password`
--

DROP TABLE IF EXISTS `field_data_field_host_password`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_host_password` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_host_password_value` varchar(255) DEFAULT NULL,
  `field_host_password_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_host_password_format` (`field_host_password_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 59 (field_host_password)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_host_password`
--

LOCK TABLES `field_data_field_host_password` WRITE;
/*!40000 ALTER TABLE `field_data_field_host_password` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_host_password` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_host_status`
--

DROP TABLE IF EXISTS `field_data_field_host_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_host_status` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_host_status_value` varchar(255) DEFAULT NULL,
  `field_host_status_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_host_status_format` (`field_host_status_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 23 (field_host_status)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_host_status`
--

LOCK TABLES `field_data_field_host_status` WRITE;
/*!40000 ALTER TABLE `field_data_field_host_status` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_host_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_host_username`
--

DROP TABLE IF EXISTS `field_data_field_host_username`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_host_username` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_host_username_value` varchar(255) DEFAULT NULL,
  `field_host_username_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_host_username_format` (`field_host_username_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 58 (field_host_username)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_host_username`
--

LOCK TABLES `field_data_field_host_username` WRITE;
/*!40000 ALTER TABLE `field_data_field_host_username` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_host_username` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_host_vendor`
--

DROP TABLE IF EXISTS `field_data_field_host_vendor`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_host_vendor` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_host_vendor_value` varchar(255) DEFAULT NULL,
  `field_host_vendor_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_host_vendor_format` (`field_host_vendor_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 144 (field_host_vendor)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_host_vendor`
--

LOCK TABLES `field_data_field_host_vendor` WRITE;
/*!40000 ALTER TABLE `field_data_field_host_vendor` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_host_vendor` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_hostname`
--

DROP TABLE IF EXISTS `field_data_field_hostname`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_hostname` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_hostname_value` varchar(255) DEFAULT NULL,
  `field_hostname_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_hostname_format` (`field_hostname_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 158 (field_hostname)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_hostname`
--

LOCK TABLES `field_data_field_hostname` WRITE;
/*!40000 ALTER TABLE `field_data_field_hostname` DISABLE KEYS */;
INSERT INTO `field_data_field_hostname` VALUES ('node','vcenter',0,1,1,'und',0,'',NULL);
/*!40000 ALTER TABLE `field_data_field_hostname` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_install_port`
--

DROP TABLE IF EXISTS `field_data_field_install_port`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_install_port` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_install_port_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 142 (field_install_port)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_install_port`
--

LOCK TABLES `field_data_field_install_port` WRITE;
/*!40000 ALTER TABLE `field_data_field_install_port` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_install_port` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_ip_address`
--

DROP TABLE IF EXISTS `field_data_field_ip_address`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_ip_address` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_ip_address_value` varchar(255) DEFAULT NULL,
  `field_ip_address_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_ip_address_format` (`field_ip_address_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 5 (field_ip_address)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_ip_address`
--

LOCK TABLES `field_data_field_ip_address` WRITE;
/*!40000 ALTER TABLE `field_data_field_ip_address` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_ip_address` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_is_local`
--

DROP TABLE IF EXISTS `field_data_field_is_local`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_is_local` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_is_local_value` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_is_local_value` (`field_is_local_value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 43 (field_is_local)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_is_local`
--

LOCK TABLES `field_data_field_is_local` WRITE;
/*!40000 ALTER TABLE `field_data_field_is_local` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_is_local` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_is_offline`
--

DROP TABLE IF EXISTS `field_data_field_is_offline`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_is_offline` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_is_offline_value` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_is_offline_value` (`field_is_offline_value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 46 (field_is_offline)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_is_offline`
--

LOCK TABLES `field_data_field_is_offline` WRITE;
/*!40000 ALTER TABLE `field_data_field_is_offline` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_is_offline` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_is_perennially_reserved`
--

DROP TABLE IF EXISTS `field_data_field_is_perennially_reserved`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_is_perennially_reserved` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_is_perennially_reserved_value` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_is_perennially_reserved_value` (`field_is_perennially_reserved_value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 47 (field_is_perennially_reserved)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_is_perennially_reserved`
--

LOCK TABLES `field_data_field_is_perennially_reserved` WRITE;
/*!40000 ALTER TABLE `field_data_field_is_perennially_reserved` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_is_perennially_reserved` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_is_pseudo`
--

DROP TABLE IF EXISTS `field_data_field_is_pseudo`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_is_pseudo` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_is_pseudo_value` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_is_pseudo_value` (`field_is_pseudo_value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 40 (field_is_pseudo)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_is_pseudo`
--

LOCK TABLES `field_data_field_is_pseudo` WRITE;
/*!40000 ALTER TABLE `field_data_field_is_pseudo` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_is_pseudo` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_is_rdm_capable`
--

DROP TABLE IF EXISTS `field_data_field_is_rdm_capable`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_is_rdm_capable` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_is_rdm_capable_value` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_is_rdm_capable_value` (`field_is_rdm_capable_value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 42 (field_is_rdm_capable)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_is_rdm_capable`
--

LOCK TABLES `field_data_field_is_rdm_capable` WRITE;
/*!40000 ALTER TABLE `field_data_field_is_rdm_capable` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_is_rdm_capable` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_is_removable`
--

DROP TABLE IF EXISTS `field_data_field_is_removable`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_is_removable` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_is_removable_value` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_is_removable_value` (`field_is_removable_value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 44 (field_is_removable)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_is_removable`
--

LOCK TABLES `field_data_field_is_removable` WRITE;
/*!40000 ALTER TABLE `field_data_field_is_removable` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_is_removable` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_is_ssd`
--

DROP TABLE IF EXISTS `field_data_field_is_ssd`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_is_ssd` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_is_ssd_value` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_is_ssd_value` (`field_is_ssd_value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 45 (field_is_ssd)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_is_ssd`
--

LOCK TABLES `field_data_field_is_ssd` WRITE;
/*!40000 ALTER TABLE `field_data_field_is_ssd` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_is_ssd` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_is_vmfs`
--

DROP TABLE IF EXISTS `field_data_field_is_vmfs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_is_vmfs` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_is_vmfs_value` varchar(10) DEFAULT NULL,
  `field_is_vmfs_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_is_vmfs_format` (`field_is_vmfs_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 148 (field_is_vmfs)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_is_vmfs`
--

LOCK TABLES `field_data_field_is_vmfs` WRITE;
/*!40000 ALTER TABLE `field_data_field_is_vmfs` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_is_vmfs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_maintenance_mode`
--

DROP TABLE IF EXISTS `field_data_field_maintenance_mode`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_maintenance_mode` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_maintenance_mode_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 24 (field_maintenance_mode)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_maintenance_mode`
--

LOCK TABLES `field_data_field_maintenance_mode` WRITE;
/*!40000 ALTER TABLE `field_data_field_maintenance_mode` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_maintenance_mode` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_max_physical_devices`
--

DROP TABLE IF EXISTS `field_data_field_max_physical_devices`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_max_physical_devices` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_max_physical_devices_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 73 (field_max_physical_devices)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_max_physical_devices`
--

LOCK TABLES `field_data_field_max_physical_devices` WRITE;
/*!40000 ALTER TABLE `field_data_field_max_physical_devices` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_max_physical_devices` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_max_virtual_machines`
--

DROP TABLE IF EXISTS `field_data_field_max_virtual_machines`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_max_virtual_machines` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_max_virtual_machines_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 72 (field_max_virtual_machines)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_max_virtual_machines`
--

LOCK TABLES `field_data_field_max_virtual_machines` WRITE;
/*!40000 ALTER TABLE `field_data_field_max_virtual_machines` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_max_virtual_machines` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_memory_size`
--

DROP TABLE IF EXISTS `field_data_field_memory_size`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_memory_size` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_memory_size_value` varchar(255) DEFAULT NULL,
  `field_memory_size_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_memory_size_format` (`field_memory_size_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 11 (field_memory_size)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_memory_size`
--

LOCK TABLES `field_data_field_memory_size` WRITE;
/*!40000 ALTER TABLE `field_data_field_memory_size` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_memory_size` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_model`
--

DROP TABLE IF EXISTS `field_data_field_model`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_model` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_model_value` varchar(255) DEFAULT NULL,
  `field_model_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_model_format` (`field_model_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 37 (field_model)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_model`
--

LOCK TABLES `field_data_field_model` WRITE;
/*!40000 ALTER TABLE `field_data_field_model` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_model` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_multipath_plugin`
--

DROP TABLE IF EXISTS `field_data_field_multipath_plugin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_multipath_plugin` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_multipath_plugin_value` varchar(255) DEFAULT NULL,
  `field_multipath_plugin_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_multipath_plugin_format` (`field_multipath_plugin_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 34 (field_multipath_plugin)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_multipath_plugin`
--

LOCK TABLES `field_data_field_multipath_plugin` WRITE;
/*!40000 ALTER TABLE `field_data_field_multipath_plugin` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_multipath_plugin` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_naa_identifier`
--

DROP TABLE IF EXISTS `field_data_field_naa_identifier`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_naa_identifier` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_naa_identifier_value` varchar(255) DEFAULT NULL,
  `field_naa_identifier_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_naa_identifier_format` (`field_naa_identifier_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 80 (field_naa_identifier)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_naa_identifier`
--

LOCK TABLES `field_data_field_naa_identifier` WRITE;
/*!40000 ALTER TABLE `field_data_field_naa_identifier` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_naa_identifier` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_no_of_cpu`
--

DROP TABLE IF EXISTS `field_data_field_no_of_cpu`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_no_of_cpu` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_no_of_cpu_value` varchar(255) DEFAULT NULL,
  `field_no_of_cpu_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_no_of_cpu_format` (`field_no_of_cpu_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 83 (field_no_of_cpu)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_no_of_cpu`
--

LOCK TABLES `field_data_field_no_of_cpu` WRITE;
/*!40000 ALTER TABLE `field_data_field_no_of_cpu` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_no_of_cpu` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_operational_message`
--

DROP TABLE IF EXISTS `field_data_field_operational_message`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_operational_message` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_operational_message_value` varchar(255) DEFAULT NULL,
  `field_operational_message_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_operational_message_format` (`field_operational_message_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 74 (field_operational_message)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_operational_message`
--

LOCK TABLES `field_data_field_operational_message` WRITE;
/*!40000 ALTER TABLE `field_data_field_operational_message` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_operational_message` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_operational_state`
--

DROP TABLE IF EXISTS `field_data_field_operational_state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_operational_state` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_operational_state_value` varchar(255) DEFAULT NULL,
  `field_operational_state_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_operational_state_format` (`field_operational_state_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 73 (field_operational_state)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_operational_state`
--

LOCK TABLES `field_data_field_operational_state` WRITE;
/*!40000 ALTER TABLE `field_data_field_operational_state` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_operational_state` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_other_uids`
--

DROP TABLE IF EXISTS `field_data_field_other_uids`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_other_uids` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_other_uids_value` varchar(255) DEFAULT NULL,
  `field_other_uids_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_other_uids_format` (`field_other_uids_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 51 (field_other_uids)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_other_uids`
--

LOCK TABLES `field_data_field_other_uids` WRITE;
/*!40000 ALTER TABLE `field_data_field_other_uids` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_other_uids` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_password`
--

DROP TABLE IF EXISTS `field_data_field_password`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_password` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_password_value` varchar(255) DEFAULT NULL,
  `field_password_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_password_format` (`field_password_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 7 (field_password)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_password`
--

LOCK TABLES `field_data_field_password` WRITE;
/*!40000 ALTER TABLE `field_data_field_password` DISABLE KEYS */;
INSERT INTO `field_data_field_password` VALUES ('node','vcenter',0,1,1,'und',0,'',NULL);
/*!40000 ALTER TABLE `field_data_field_password` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_path`
--

DROP TABLE IF EXISTS `field_data_field_path`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_path` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_path_value` varchar(255) DEFAULT NULL,
  `field_path_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_path_format` (`field_path_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 54 (field_path)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_path`
--

LOCK TABLES `field_data_field_path` WRITE;
/*!40000 ALTER TABLE `field_data_field_path` DISABLE KEYS */;
INSERT INTO `field_data_field_path` VALUES ('node','vdisk',0,11729,34660,'und',0,'C:',NULL),('node','vdisk',0,14410,14410,'und',0,'C:\\',NULL);
/*!40000 ALTER TABLE `field_data_field_path` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_performance_state`
--

DROP TABLE IF EXISTS `field_data_field_performance_state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_performance_state` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_performance_state_value` varchar(255) DEFAULT NULL,
  `field_performance_state_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_performance_state_format` (`field_performance_state_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 75 (field_performance_state)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_performance_state`
--

LOCK TABLES `field_data_field_performance_state` WRITE;
/*!40000 ALTER TABLE `field_data_field_performance_state` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_performance_state` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_physical_memory`
--

DROP TABLE IF EXISTS `field_data_field_physical_memory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_physical_memory` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_physical_memory_value` varchar(255) DEFAULT NULL,
  `field_physical_memory_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_physical_memory_format` (`field_physical_memory_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 25 (field_physical_memory)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_physical_memory`
--

LOCK TABLES `field_data_field_physical_memory` WRITE;
/*!40000 ALTER TABLE `field_data_field_physical_memory` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_physical_memory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_reboot_required`
--

DROP TABLE IF EXISTS `field_data_field_reboot_required`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_reboot_required` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_reboot_required_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 27 (field_reboot_required)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_reboot_required`
--

LOCK TABLES `field_data_field_reboot_required` WRITE;
/*!40000 ALTER TABLE `field_data_field_reboot_required` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_reboot_required` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_rediscover_status`
--

DROP TABLE IF EXISTS `field_data_field_rediscover_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_rediscover_status` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_rediscover_status_value` varchar(255) DEFAULT NULL,
  `field_rediscover_status_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_rediscover_status_format` (`field_rediscover_status_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 157 (field_rediscover_status)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_rediscover_status`
--

LOCK TABLES `field_data_field_rediscover_status` WRITE;
/*!40000 ALTER TABLE `field_data_field_rediscover_status` DISABLE KEYS */;
INSERT INTO `field_data_field_rediscover_status` VALUES ('node','vcenter',0,1,1,'und',0,'',NULL);
/*!40000 ALTER TABLE `field_data_field_rediscover_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_related_host`
--

DROP TABLE IF EXISTS `field_data_field_related_host`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_related_host` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_related_host_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_related_host_target_id` (`field_related_host_target_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 64 (field_related_host)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_related_host`
--

LOCK TABLES `field_data_field_related_host` WRITE;
/*!40000 ALTER TABLE `field_data_field_related_host` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_related_host` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_related_vcenter`
--

DROP TABLE IF EXISTS `field_data_field_related_vcenter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_related_vcenter` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_related_vcenter_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_related_vcenter_target_id` (`field_related_vcenter_target_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 62 (field_related_vcenter)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_related_vcenter`
--

LOCK TABLES `field_data_field_related_vcenter` WRITE;
/*!40000 ALTER TABLE `field_data_field_related_vcenter` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_related_vcenter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_revision`
--

DROP TABLE IF EXISTS `field_data_field_revision`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_revision` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_revision_value` varchar(255) DEFAULT NULL,
  `field_revision_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_revision_format` (`field_revision_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 38 (field_revision)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_revision`
--

LOCK TABLES `field_data_field_revision` WRITE;
/*!40000 ALTER TABLE `field_data_field_revision` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_revision` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_scsi_level`
--

DROP TABLE IF EXISTS `field_data_field_scsi_level`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_scsi_level` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_scsi_level_value` varchar(255) DEFAULT NULL,
  `field_scsi_level_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_scsi_level_format` (`field_scsi_level_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 39 (field_scsi_level)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_scsi_level`
--

LOCK TABLES `field_data_field_scsi_level` WRITE;
/*!40000 ALTER TABLE `field_data_field_scsi_level` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_scsi_level` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_segment_size`
--

DROP TABLE IF EXISTS `field_data_field_segment_size`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_segment_size` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_segment_size_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 71 (field_segment_size)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_segment_size`
--

LOCK TABLES `field_data_field_segment_size` WRITE;
/*!40000 ALTER TABLE `field_data_field_segment_size` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_segment_size` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_serial_no`
--

DROP TABLE IF EXISTS `field_data_field_serial_no`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_serial_no` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_serial_no_value` varchar(255) DEFAULT NULL,
  `field_serial_no_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_serial_no_format` (`field_serial_no_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 31 (field_serial_no)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_serial_no`
--

LOCK TABLES `field_data_field_serial_no` WRITE;
/*!40000 ALTER TABLE `field_data_field_serial_no` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_serial_no` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_size`
--

DROP TABLE IF EXISTS `field_data_field_size`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_size` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_size_value` varchar(255) DEFAULT NULL,
  `field_size_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_size_format` (`field_size_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 32 (field_size)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_size`
--

LOCK TABLES `field_data_field_size` WRITE;
/*!40000 ALTER TABLE `field_data_field_size` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_size` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_software_on_host`
--

DROP TABLE IF EXISTS `field_data_field_software_on_host`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_software_on_host` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_software_on_host_value` varchar(255) DEFAULT NULL,
  `field_software_on_host_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_software_on_host_format` (`field_software_on_host_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 68 (field_software_on_host)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_software_on_host`
--

LOCK TABLES `field_data_field_software_on_host` WRITE;
/*!40000 ALTER TABLE `field_data_field_software_on_host` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_software_on_host` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_status`
--

DROP TABLE IF EXISTS `field_data_field_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_status` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_status_value` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_status_value` (`field_status_value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 41 (field_status)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_status`
--

LOCK TABLES `field_data_field_status` WRITE;
/*!40000 ALTER TABLE `field_data_field_status` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_tags`
--

DROP TABLE IF EXISTS `field_data_field_tags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_tags` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_tags_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_tags_tid` (`field_tags_tid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 3 (field_tags)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_tags`
--

LOCK TABLES `field_data_field_tags` WRITE;
/*!40000 ALTER TABLE `field_data_field_tags` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_tags` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_template`
--

DROP TABLE IF EXISTS `field_data_field_template`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_template` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_template_value` varchar(255) DEFAULT NULL,
  `field_template_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_template_format` (`field_template_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 13 (field_template)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_template`
--

LOCK TABLES `field_data_field_template` WRITE;
/*!40000 ALTER TABLE `field_data_field_template` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_template` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_thin_provisioning_status`
--

DROP TABLE IF EXISTS `field_data_field_thin_provisioning_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_thin_provisioning_status` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_thin_provisioning_status_value` varchar(255) DEFAULT NULL,
  `field_thin_provisioning_status_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_thin_provisioning_status_format` (`field_thin_provisioning_status_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 48 (field_thin_provisioning_status)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_thin_provisioning_status`
--

LOCK TABLES `field_data_field_thin_provisioning_status` WRITE;
/*!40000 ALTER TABLE `field_data_field_thin_provisioning_status` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_thin_provisioning_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_timestamp`
--

DROP TABLE IF EXISTS `field_data_field_timestamp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_timestamp` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_timestamp_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 122 (field_timestamp)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_timestamp`
--

LOCK TABLES `field_data_field_timestamp` WRITE;
/*!40000 ALTER TABLE `field_data_field_timestamp` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_timestamp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_total_segments`
--

DROP TABLE IF EXISTS `field_data_field_total_segments`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_total_segments` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_total_segments_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 76 (field_total_segments)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_total_segments`
--

LOCK TABLES `field_data_field_total_segments` WRITE;
/*!40000 ALTER TABLE `field_data_field_total_segments` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_total_segments` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_total_size`
--

DROP TABLE IF EXISTS `field_data_field_total_size`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_total_size` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_total_size_value` varchar(255) DEFAULT NULL,
  `field_total_size_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_total_size_format` (`field_total_size_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 79 (field_total_size)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_total_size`
--

LOCK TABLES `field_data_field_total_size` WRITE;
/*!40000 ALTER TABLE `field_data_field_total_size` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_total_size` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_username`
--

DROP TABLE IF EXISTS `field_data_field_username`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_username` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_username_value` varchar(255) DEFAULT NULL,
  `field_username_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_username_format` (`field_username_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 6 (field_username)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_username`
--

LOCK TABLES `field_data_field_username` WRITE;
/*!40000 ALTER TABLE `field_data_field_username` DISABLE KEYS */;
INSERT INTO `field_data_field_username` VALUES ('node','vcenter',0,1,1,'und',0,'',NULL);
/*!40000 ALTER TABLE `field_data_field_username` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vaai_status`
--

DROP TABLE IF EXISTS `field_data_field_vaai_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vaai_status` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vaai_status_value` varchar(255) DEFAULT NULL,
  `field_vaai_status_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vaai_status_format` (`field_vaai_status_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 50 (field_vaai_status)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vaai_status`
--

LOCK TABLES `field_data_field_vaai_status` WRITE;
/*!40000 ALTER TABLE `field_data_field_vaai_status` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vaai_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vdisk`
--

DROP TABLE IF EXISTS `field_data_field_vdisk`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vdisk` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vdisk_target_id` (`field_vdisk_target_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 109 (field_vdisk)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vdisk`
--

LOCK TABLES `field_data_field_vdisk` WRITE;
/*!40000 ALTER TABLE `field_data_field_vdisk` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vdisk` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vdisk_cache_latency`
--

DROP TABLE IF EXISTS `field_data_field_vdisk_cache_latency`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vdisk_cache_latency` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_cache_latency_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 116 (field_vdisk_cache_latency)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vdisk_cache_latency`
--

LOCK TABLES `field_data_field_vdisk_cache_latency` WRITE;
/*!40000 ALTER TABLE `field_data_field_vdisk_cache_latency` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vdisk_cache_latency` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vdisk_hit_rate_pc`
--

DROP TABLE IF EXISTS `field_data_field_vdisk_hit_rate_pc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vdisk_hit_rate_pc` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_hit_rate_pc_value` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 175 (field_vdisk_hit_rate_pc)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vdisk_hit_rate_pc`
--

LOCK TABLES `field_data_field_vdisk_hit_rate_pc` WRITE;
/*!40000 ALTER TABLE `field_data_field_vdisk_hit_rate_pc` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vdisk_hit_rate_pc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vdisk_hits`
--

DROP TABLE IF EXISTS `field_data_field_vdisk_hits`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vdisk_hits` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_hits_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 114 (field_vdisk_hits)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vdisk_hits`
--

LOCK TABLES `field_data_field_vdisk_hits` WRITE;
/*!40000 ALTER TABLE `field_data_field_vdisk_hits` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vdisk_hits` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vdisk_id`
--

DROP TABLE IF EXISTS `field_data_field_vdisk_id`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vdisk_id` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_id_value` varchar(255) DEFAULT NULL,
  `field_vdisk_id_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vdisk_id_format` (`field_vdisk_id_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 152 (field_vdisk_id)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vdisk_id`
--

LOCK TABLES `field_data_field_vdisk_id` WRITE;
/*!40000 ALTER TABLE `field_data_field_vdisk_id` DISABLE KEYS */;
INSERT INTO `field_data_field_vdisk_id` VALUES ('node','vdisk',0,11729,34660,'und',0,'naa.6000C2951b9e65799ddfac1e8f841c76',NULL);
/*!40000 ALTER TABLE `field_data_field_vdisk_id` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vdisk_identifier`
--

DROP TABLE IF EXISTS `field_data_field_vdisk_identifier`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vdisk_identifier` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_identifier_value` varchar(255) DEFAULT NULL,
  `field_vdisk_identifier_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vdisk_identifier_format` (`field_vdisk_identifier_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 128 (field_vdisk_identifier)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vdisk_identifier`
--

LOCK TABLES `field_data_field_vdisk_identifier` WRITE;
/*!40000 ALTER TABLE `field_data_field_vdisk_identifier` DISABLE KEYS */;
INSERT INTO `field_data_field_vdisk_identifier` VALUES ('node','vdisk',0,11729,34660,'und',0,'6000c2951b9e65799ddfac1e8f841c76',NULL),('node','vdisk',0,14410,14410,'und',0,'6000c2951b9e65799ddfac1e8f841c76',NULL);
/*!40000 ALTER TABLE `field_data_field_vdisk_identifier` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vdisk_insertion_rate_pc`
--

DROP TABLE IF EXISTS `field_data_field_vdisk_insertion_rate_pc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vdisk_insertion_rate_pc` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_insertion_rate_pc_value` varchar(32) DEFAULT '0',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 125 (field_vdisk_insertion_rate_pc)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vdisk_insertion_rate_pc`
--

LOCK TABLES `field_data_field_vdisk_insertion_rate_pc` WRITE;
/*!40000 ALTER TABLE `field_data_field_vdisk_insertion_rate_pc` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vdisk_insertion_rate_pc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vdisk_insertions`
--

DROP TABLE IF EXISTS `field_data_field_vdisk_insertions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vdisk_insertions` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_insertions_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 119 (field_vdisk_insertions)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vdisk_insertions`
--

LOCK TABLES `field_data_field_vdisk_insertions` WRITE;
/*!40000 ALTER TABLE `field_data_field_vdisk_insertions` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vdisk_insertions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vdisk_name`
--

DROP TABLE IF EXISTS `field_data_field_vdisk_name`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vdisk_name` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_name_value` varchar(255) DEFAULT NULL,
  `field_vdisk_name_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vdisk_name_format` (`field_vdisk_name_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 150 (field_vdisk_name)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vdisk_name`
--

LOCK TABLES `field_data_field_vdisk_name` WRITE;
/*!40000 ALTER TABLE `field_data_field_vdisk_name` DISABLE KEYS */;
INSERT INTO `field_data_field_vdisk_name` VALUES ('node','vdisk',0,11729,34660,'und',0,'Hard disk 1',NULL);
/*!40000 ALTER TABLE `field_data_field_vdisk_name` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vdisk_population`
--

DROP TABLE IF EXISTS `field_data_field_vdisk_population`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vdisk_population` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_population_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 117 (field_vdisk_population)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vdisk_population`
--

LOCK TABLES `field_data_field_vdisk_population` WRITE;
/*!40000 ALTER TABLE `field_data_field_vdisk_population` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vdisk_population` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vdisk_population_pc`
--

DROP TABLE IF EXISTS `field_data_field_vdisk_population_pc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vdisk_population_pc` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_population_pc_value` varchar(32) DEFAULT '0',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 124 (field_vdisk_population_pc)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vdisk_population_pc`
--

LOCK TABLES `field_data_field_vdisk_population_pc` WRITE;
/*!40000 ALTER TABLE `field_data_field_vdisk_population_pc` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vdisk_population_pc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vdisk_read_blocks`
--

DROP TABLE IF EXISTS `field_data_field_vdisk_read_blocks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vdisk_read_blocks` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_read_blocks_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 115 (field_vdisk_read_blocks)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vdisk_read_blocks`
--

LOCK TABLES `field_data_field_vdisk_read_blocks` WRITE;
/*!40000 ALTER TABLE `field_data_field_vdisk_read_blocks` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vdisk_read_blocks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vdisk_read_latency`
--

DROP TABLE IF EXISTS `field_data_field_vdisk_read_latency`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vdisk_read_latency` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_read_latency_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 110 (field_vdisk_read_latency)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vdisk_read_latency`
--

LOCK TABLES `field_data_field_vdisk_read_latency` WRITE;
/*!40000 ALTER TABLE `field_data_field_vdisk_read_latency` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vdisk_read_latency` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vdisk_read_ops`
--

DROP TABLE IF EXISTS `field_data_field_vdisk_read_ops`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vdisk_read_ops` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_read_ops_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 112 (field_vdisk_read_ops)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vdisk_read_ops`
--

LOCK TABLES `field_data_field_vdisk_read_ops` WRITE;
/*!40000 ALTER TABLE `field_data_field_vdisk_read_ops` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vdisk_read_ops` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vdisk_type`
--

DROP TABLE IF EXISTS `field_data_field_vdisk_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vdisk_type` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_type_value` varchar(255) DEFAULT NULL,
  `field_vdisk_type_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vdisk_type_format` (`field_vdisk_type_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 151 (field_vdisk_type)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vdisk_type`
--

LOCK TABLES `field_data_field_vdisk_type` WRITE;
/*!40000 ALTER TABLE `field_data_field_vdisk_type` DISABLE KEYS */;
INSERT INTO `field_data_field_vdisk_type` VALUES ('node','vdisk',0,11729,34660,'und',0,'VMDK',NULL);
/*!40000 ALTER TABLE `field_data_field_vdisk_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vdisk_usable_blocks`
--

DROP TABLE IF EXISTS `field_data_field_vdisk_usable_blocks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vdisk_usable_blocks` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_usable_blocks_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 118 (field_vdisk_usable_blocks)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vdisk_usable_blocks`
--

LOCK TABLES `field_data_field_vdisk_usable_blocks` WRITE;
/*!40000 ALTER TABLE `field_data_field_vdisk_usable_blocks` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vdisk_usable_blocks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vdisk_write_blocks`
--

DROP TABLE IF EXISTS `field_data_field_vdisk_write_blocks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vdisk_write_blocks` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_write_blocks_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 120 (field_vdisk_write_blocks)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vdisk_write_blocks`
--

LOCK TABLES `field_data_field_vdisk_write_blocks` WRITE;
/*!40000 ALTER TABLE `field_data_field_vdisk_write_blocks` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vdisk_write_blocks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vdisk_write_latency`
--

DROP TABLE IF EXISTS `field_data_field_vdisk_write_latency`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vdisk_write_latency` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_write_latency_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 111 (field_vdisk_write_latency)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vdisk_write_latency`
--

LOCK TABLES `field_data_field_vdisk_write_latency` WRITE;
/*!40000 ALTER TABLE `field_data_field_vdisk_write_latency` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vdisk_write_latency` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vdisk_write_ops`
--

DROP TABLE IF EXISTS `field_data_field_vdisk_write_ops`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vdisk_write_ops` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_write_ops_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 113 (field_vdisk_write_ops)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vdisk_write_ops`
--

LOCK TABLES `field_data_field_vdisk_write_ops` WRITE;
/*!40000 ALTER TABLE `field_data_field_vdisk_write_ops` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vdisk_write_ops` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vendor`
--

DROP TABLE IF EXISTS `field_data_field_vendor`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vendor` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vendor_value` varchar(255) DEFAULT NULL,
  `field_vendor_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vendor_format` (`field_vendor_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 36 (field_vendor)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vendor`
--

LOCK TABLES `field_data_field_vendor` WRITE;
/*!40000 ALTER TABLE `field_data_field_vendor` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vendor` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vib_version`
--

DROP TABLE IF EXISTS `field_data_field_vib_version`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vib_version` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vib_version_value` varchar(255) DEFAULT NULL,
  `field_vib_version_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vib_version_format` (`field_vib_version_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 78 (field_vib_version)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vib_version`
--

LOCK TABLES `field_data_field_vib_version` WRITE;
/*!40000 ALTER TABLE `field_data_field_vib_version` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vib_version` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_virtual_disks`
--

DROP TABLE IF EXISTS `field_data_field_virtual_disks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_virtual_disks` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_virtual_disks_value` varchar(255) DEFAULT NULL,
  `field_virtual_disks_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_virtual_disks_format` (`field_virtual_disks_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 84 (field_virtual_disks)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_virtual_disks`
--

LOCK TABLES `field_data_field_virtual_disks` WRITE;
/*!40000 ALTER TABLE `field_data_field_virtual_disks` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_virtual_disks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_virtual_machine`
--

DROP TABLE IF EXISTS `field_data_field_virtual_machine`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_virtual_machine` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_virtual_machine_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_virtual_machine_target_id` (`field_virtual_machine_target_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 63 (field_virtual_machine)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_virtual_machine`
--

LOCK TABLES `field_data_field_virtual_machine` WRITE;
/*!40000 ALTER TABLE `field_data_field_virtual_machine` DISABLE KEYS */;
INSERT INTO `field_data_field_virtual_machine` VALUES ('node','vdisk',0,11729,34660,'und',0,11728),('node','vdisk',0,14410,14410,'und',0,14405);
/*!40000 ALTER TABLE `field_data_field_virtual_machine` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm`
--

DROP TABLE IF EXISTS `field_data_field_vm`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vm_target_id` (`field_vm_target_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 69 (field_vm)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm`
--

LOCK TABLES `field_data_field_vm` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm_cache_latency`
--

DROP TABLE IF EXISTS `field_data_field_vm_cache_latency`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm_cache_latency` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_cache_latency_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 100 (field_vm_cache_latency)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm_cache_latency`
--

LOCK TABLES `field_data_field_vm_cache_latency` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm_cache_latency` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm_cache_latency` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm_cache_size`
--

DROP TABLE IF EXISTS `field_data_field_vm_cache_size`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm_cache_size` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_cache_size_value` varchar(255) DEFAULT NULL,
  `field_vm_cache_size_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vm_cache_size_format` (`field_vm_cache_size_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 132 (field_vm_cache_size)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm_cache_size`
--

LOCK TABLES `field_data_field_vm_cache_size` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm_cache_size` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm_cache_size` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm_hit_rate_pc`
--

DROP TABLE IF EXISTS `field_data_field_vm_hit_rate_pc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm_hit_rate_pc` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_hit_rate_pc_value` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 172 (field_vm_hit_rate_pc)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm_hit_rate_pc`
--

LOCK TABLES `field_data_field_vm_hit_rate_pc` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm_hit_rate_pc` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm_hit_rate_pc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm_hits`
--

DROP TABLE IF EXISTS `field_data_field_vm_hits`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm_hits` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_hits_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 98 (field_vm_hits)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm_hits`
--

LOCK TABLES `field_data_field_vm_hits` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm_hits` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm_hits` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm_hostname`
--

DROP TABLE IF EXISTS `field_data_field_vm_hostname`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm_hostname` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_hostname_value` varchar(255) DEFAULT NULL,
  `field_vm_hostname_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vm_hostname_format` (`field_vm_hostname_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 159 (field_vm_hostname)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm_hostname`
--

LOCK TABLES `field_data_field_vm_hostname` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm_hostname` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm_hostname` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm_insertion_rate_pc`
--

DROP TABLE IF EXISTS `field_data_field_vm_insertion_rate_pc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm_insertion_rate_pc` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_insertion_rate_pc_value` decimal(10,2) DEFAULT '0.00',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 108 (field_vm_insertion_rate_pc)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm_insertion_rate_pc`
--

LOCK TABLES `field_data_field_vm_insertion_rate_pc` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm_insertion_rate_pc` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm_insertion_rate_pc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm_insertions`
--

DROP TABLE IF EXISTS `field_data_field_vm_insertions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm_insertions` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_insertions_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 104 (field_vm_insertions)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm_insertions`
--

LOCK TABLES `field_data_field_vm_insertions` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm_insertions` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm_insertions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm_ip_address`
--

DROP TABLE IF EXISTS `field_data_field_vm_ip_address`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm_ip_address` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_ip_address_value` varchar(255) DEFAULT NULL,
  `field_vm_ip_address_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vm_ip_address_format` (`field_vm_ip_address_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 9 (field_vm_ip_address)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm_ip_address`
--

LOCK TABLES `field_data_field_vm_ip_address` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm_ip_address` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm_ip_address` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm_password`
--

DROP TABLE IF EXISTS `field_data_field_vm_password`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm_password` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_password_value` varchar(255) DEFAULT NULL,
  `field_vm_password_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vm_password_format` (`field_vm_password_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 57 (field_vm_password)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm_password`
--

LOCK TABLES `field_data_field_vm_password` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm_password` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm_password` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm_path_name`
--

DROP TABLE IF EXISTS `field_data_field_vm_path_name`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm_path_name` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_path_name_value` varchar(255) DEFAULT NULL,
  `field_vm_path_name_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vm_path_name_format` (`field_vm_path_name_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 14 (field_vm_path_name)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm_path_name`
--

LOCK TABLES `field_data_field_vm_path_name` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm_path_name` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm_path_name` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm_population`
--

DROP TABLE IF EXISTS `field_data_field_vm_population`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm_population` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_population_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 101 (field_vm_population)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm_population`
--

LOCK TABLES `field_data_field_vm_population` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm_population` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm_population` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm_population_pc`
--

DROP TABLE IF EXISTS `field_data_field_vm_population_pc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm_population_pc` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_population_pc_value` decimal(10,2) DEFAULT '0.00',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 107 (field_vm_population_pc)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm_population_pc`
--

LOCK TABLES `field_data_field_vm_population_pc` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm_population_pc` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm_population_pc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm_read_blocks`
--

DROP TABLE IF EXISTS `field_data_field_vm_read_blocks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm_read_blocks` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_read_blocks_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 99 (field_vm_read_blocks)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm_read_blocks`
--

LOCK TABLES `field_data_field_vm_read_blocks` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm_read_blocks` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm_read_blocks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm_read_latency`
--

DROP TABLE IF EXISTS `field_data_field_vm_read_latency`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm_read_latency` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_read_latency_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 94 (field_vm_read_latency)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm_read_latency`
--

LOCK TABLES `field_data_field_vm_read_latency` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm_read_latency` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm_read_latency` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm_read_ops`
--

DROP TABLE IF EXISTS `field_data_field_vm_read_ops`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm_read_ops` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_read_ops_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 96 (field_vm_read_ops)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm_read_ops`
--

LOCK TABLES `field_data_field_vm_read_ops` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm_read_ops` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm_read_ops` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm_usable_blocks`
--

DROP TABLE IF EXISTS `field_data_field_vm_usable_blocks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm_usable_blocks` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_usable_blocks_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 102 (field_vm_usable_blocks)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm_usable_blocks`
--

LOCK TABLES `field_data_field_vm_usable_blocks` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm_usable_blocks` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm_usable_blocks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm_username`
--

DROP TABLE IF EXISTS `field_data_field_vm_username`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm_username` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_username_value` varchar(255) DEFAULT NULL,
  `field_vm_username_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vm_username_format` (`field_vm_username_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 56 (field_vm_username)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm_username`
--

LOCK TABLES `field_data_field_vm_username` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm_username` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm_username` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm_vmotion_hostlist`
--

DROP TABLE IF EXISTS `field_data_field_vm_vmotion_hostlist`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm_vmotion_hostlist` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_vmotion_hostlist_value` varchar(1000) DEFAULT NULL,
  `field_vm_vmotion_hostlist_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vm_vmotion_hostlist_format` (`field_vm_vmotion_hostlist_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 171 (field_vm_vmotion_hostlist)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm_vmotion_hostlist`
--

LOCK TABLES `field_data_field_vm_vmotion_hostlist` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm_vmotion_hostlist` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm_vmotion_hostlist` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm_vmotion_policy`
--

DROP TABLE IF EXISTS `field_data_field_vm_vmotion_policy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm_vmotion_policy` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_vmotion_policy_value` varchar(255) DEFAULT NULL,
  `field_vm_vmotion_policy_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vm_vmotion_policy_format` (`field_vm_vmotion_policy_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 170 (field_vm_vmotion_policy)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm_vmotion_policy`
--

LOCK TABLES `field_data_field_vm_vmotion_policy` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm_vmotion_policy` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm_vmotion_policy` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm_vmotionable`
--

DROP TABLE IF EXISTS `field_data_field_vm_vmotionable`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm_vmotionable` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_vmotionable_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vm_vmotionable_value` (`field_vm_vmotionable_value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 145 (field_vm_vmotionable)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm_vmotionable`
--

LOCK TABLES `field_data_field_vm_vmotionable` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm_vmotionable` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm_vmotionable` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm_write_blocks`
--

DROP TABLE IF EXISTS `field_data_field_vm_write_blocks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm_write_blocks` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_write_blocks_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 103 (field_vm_write_blocks)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm_write_blocks`
--

LOCK TABLES `field_data_field_vm_write_blocks` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm_write_blocks` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm_write_blocks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm_write_latency`
--

DROP TABLE IF EXISTS `field_data_field_vm_write_latency`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm_write_latency` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_write_latency_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 95 (field_vm_write_latency)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm_write_latency`
--

LOCK TABLES `field_data_field_vm_write_latency` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm_write_latency` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm_write_latency` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vm_write_ops`
--

DROP TABLE IF EXISTS `field_data_field_vm_write_ops`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vm_write_ops` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_write_ops_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 97 (field_vm_write_ops)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vm_write_ops`
--

LOCK TABLES `field_data_field_vm_write_ops` WRITE;
/*!40000 ALTER TABLE `field_data_field_vm_write_ops` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vm_write_ops` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vmotion`
--

DROP TABLE IF EXISTS `field_data_field_vmotion`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vmotion` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vmotion_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 26 (field_vmotion)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vmotion`
--

LOCK TABLES `field_data_field_vmotion` WRITE;
/*!40000 ALTER TABLE `field_data_field_vmotion` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vmotion` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_vmware_tools`
--

DROP TABLE IF EXISTS `field_data_field_vmware_tools`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vmware_tools` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vmware_tools_value` varchar(255) DEFAULT NULL,
  `field_vmware_tools_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vmware_tools_format` (`field_vmware_tools_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Data storage for field 67 (field_vmware_tools)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vmware_tools`
--

LOCK TABLES `field_data_field_vmware_tools` WRITE;
/*!40000 ALTER TABLE `field_data_field_vmware_tools` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_data_field_vmware_tools` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_group`
--

DROP TABLE IF EXISTS `field_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_group` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a group',
  `identifier` varchar(255) NOT NULL DEFAULT '' COMMENT 'The unique string identifier for a group.',
  `group_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The name of this group.',
  `entity_type` varchar(32) NOT NULL DEFAULT '',
  `bundle` varchar(128) NOT NULL DEFAULT '',
  `mode` varchar(128) NOT NULL DEFAULT '',
  `parent_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The parent name for a group',
  `data` longblob NOT NULL COMMENT 'Serialized data containing the group properties that do not warrant a dedicated column.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `identifier` (`identifier`),
  KEY `group_name` (`group_name`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8 COMMENT='Table that contains field group entries and settings.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_group`
--

LOCK TABLES `field_group` WRITE;
/*!40000 ALTER TABLE `field_group` DISABLE KEYS */;
INSERT INTO `field_group` VALUES (1,'group_metrics|node|vm_metrics|form','group_metrics','node','vm_metrics','form','','a:5:{s:5:\"label\";s:7:\"Metrics\";s:6:\"weight\";s:1:\"4\";s:8:\"children\";a:14:{i:0;s:21:\"field_vm_read_latency\";i:1;s:22:\"field_vm_write_latency\";i:2;s:17:\"field_vm_read_ops\";i:3;s:18:\"field_vm_write_ops\";i:4;s:13:\"field_vm_hits\";i:5;s:20:\"field_vm_read_blocks\";i:6;s:22:\"field_vm_cache_latency\";i:7;s:19:\"field_vm_population\";i:8;s:22:\"field_vm_usable_blocks\";i:9;s:21:\"field_vm_write_blocks\";i:10;s:19:\"field_vm_insertions\";i:11;s:22:\"field_vm_population_pc\";i:12;s:26:\"field_vm_insertion_rate_pc\";i:13;s:20:\"field_vm_hit_rate_pc\";}s:11:\"format_type\";s:8:\"fieldset\";s:15:\"format_settings\";a:2:{s:9:\"formatter\";s:11:\"collapsible\";s:17:\"instance_settings\";a:3:{s:11:\"description\";s:0:\"\";s:7:\"classes\";s:0:\"\";s:15:\"required_fields\";i:1;}}}'),(2,'group_device|node|host|form','group_device','node','host','form','','a:5:{s:5:\"label\";s:6:\"Device\";s:6:\"weight\";s:2:\"42\";s:8:\"children\";a:5:{i:0;s:16:\"field_total_size\";i:1;s:20:\"field_naa_identifier\";i:2;s:20:\"field_allocated_size\";i:3;s:18:\"field_device_state\";i:4;s:10:\"field_hbtl\";}s:11:\"format_type\";s:8:\"fieldset\";s:15:\"format_settings\";a:2:{s:9:\"formatter\";s:11:\"collapsible\";s:17:\"instance_settings\";a:3:{s:11:\"description\";s:0:\"\";s:7:\"classes\";s:0:\"\";s:15:\"required_fields\";i:1;}}}'),(3,'group_flash_accel_attributes|node|virtual_machine|form','group_flash_accel_attributes','node','virtual_machine','form','','a:5:{s:5:\"label\";s:22:\"Flash Accel Attributes\";s:6:\"weight\";s:2:\"22\";s:8:\"children\";a:12:{i:0;s:22:\"field_fa_build_version\";i:1;s:19:\"field_fa_cache_mode\";i:2;s:29:\"field_fa_administration_state\";i:3;s:19:\"field_fa_cache_size\";i:4;s:26:\"field_fa_operational_state\";i:5;s:28:\"field_fa_operational_message\";i:6;s:26:\"field_fa_performance_state\";i:7;s:22:\"field_fa_generation_id\";i:8;s:16:\"field_cachespace\";i:9;s:22:\"field_fa_usable_blocks\";i:10;s:20:\"field_fa_sector_size\";i:11;s:31:\"field_fa_metrics_reset_interval\";}s:11:\"format_type\";s:8:\"fieldset\";s:15:\"format_settings\";a:2:{s:9:\"formatter\";s:11:\"collapsible\";s:17:\"instance_settings\";a:3:{s:11:\"description\";s:0:\"\";s:7:\"classes\";s:0:\"\";s:15:\"required_fields\";i:1;}}}'),(4,'group_metrics|node|vdisk_metrics|form','group_metrics','node','vdisk_metrics','form','','a:5:{s:5:\"label\";s:7:\"Metrics\";s:6:\"weight\";s:1:\"4\";s:8:\"children\";a:15:{i:0;s:24:\"field_vdisk_read_latency\";i:1;s:25:\"field_vdisk_write_latency\";i:2;s:20:\"field_vdisk_read_ops\";i:3;s:21:\"field_vdisk_write_ops\";i:4;s:16:\"field_vdisk_hits\";i:5;s:23:\"field_vdisk_read_blocks\";i:6;s:25:\"field_vdisk_cache_latency\";i:7;s:22:\"field_vdisk_population\";i:8;s:25:\"field_vdisk_usable_blocks\";i:9;s:22:\"field_vdisk_insertions\";i:10;s:24:\"field_vdisk_write_blocks\";i:11;s:25:\"field_vdisk_population_pc\";i:12;s:29:\"field_vdisk_insertion_rate_pc\";i:13;s:13:\"field_hit_ops\";i:14;s:23:\"field_vdisk_hit_rate_pc\";}s:11:\"format_type\";s:8:\"fieldset\";s:15:\"format_settings\";a:2:{s:9:\"formatter\";s:11:\"collapsible\";s:17:\"instance_settings\";a:3:{s:11:\"description\";s:0:\"\";s:7:\"classes\";s:0:\"\";s:15:\"required_fields\";i:1;}}}'),(5,'group_flash_accel|node|vdisk|form','group_flash_accel','node','vdisk','form','','a:5:{s:5:\"label\";s:22:\"Flash Accel Attributes\";s:6:\"weight\";s:2:\"10\";s:8:\"children\";a:6:{i:0;s:29:\"field_fa_administration_state\";i:1;s:19:\"field_fa_cache_mode\";i:2;s:26:\"field_fa_operational_state\";i:3;s:28:\"field_fa_operational_message\";i:4;s:26:\"field_fa_performance_state\";i:5;s:22:\"field_vdisk_identifier\";}s:11:\"format_type\";s:8:\"fieldset\";s:15:\"format_settings\";a:2:{s:9:\"formatter\";s:11:\"collapsible\";s:17:\"instance_settings\";a:3:{s:11:\"description\";s:0:\"\";s:7:\"classes\";s:0:\"\";s:15:\"required_fields\";i:1;}}}'),(6,'group_vm_vmotion|node|virtual_machine|form','group_vm_vmotion','node','virtual_machine','form','','a:5:{s:5:\"label\";s:12:\"V Motionable\";s:6:\"weight\";s:2:\"20\";s:8:\"children\";a:4:{i:0;s:20:\"field_vm_vmotionable\";i:1;s:24:\"field_vm_vmotion_hotlist\";i:2;s:23:\"field_vm_vmotion_policy\";i:3;s:25:\"field_vm_vmotion_hostlist\";}s:11:\"format_type\";s:8:\"fieldset\";s:15:\"format_settings\";a:2:{s:9:\"formatter\";s:11:\"collapsible\";s:17:\"instance_settings\";a:3:{s:11:\"description\";s:0:\"\";s:7:\"classes\";s:0:\"\";s:15:\"required_fields\";i:1;}}}'),(7,'group_vm_reboot|node|virtual_machine|form','group_vm_reboot','node','virtual_machine','form','','a:5:{s:5:\"label\";s:9:\"VM Reboot\";s:6:\"weight\";s:2:\"21\";s:8:\"children\";a:0:{}s:11:\"format_type\";s:8:\"fieldset\";s:15:\"format_settings\";a:2:{s:9:\"formatter\";s:11:\"collapsible\";s:17:\"instance_settings\";a:3:{s:11:\"description\";s:0:\"\";s:7:\"classes\";s:0:\"\";s:15:\"required_fields\";i:1;}}}');
/*!40000 ALTER TABLE `field_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_body`
--

DROP TABLE IF EXISTS `field_revision_body`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_body` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `body_value` longtext,
  `body_summary` longtext,
  `body_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `body_format` (`body_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 2 (body)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_body`
--

LOCK TABLES `field_revision_body` WRITE;
/*!40000 ALTER TABLE `field_revision_body` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_body` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_comment_body`
--

DROP TABLE IF EXISTS `field_revision_comment_body`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_comment_body` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `comment_body_value` longtext,
  `comment_body_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `comment_body_format` (`comment_body_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 1 (comment_body)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_comment_body`
--

LOCK TABLES `field_revision_comment_body` WRITE;
/*!40000 ALTER TABLE `field_revision_comment_body` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_comment_body` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_administration_state`
--

DROP TABLE IF EXISTS `field_revision_field_administration_state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_administration_state` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_administration_state_value` varchar(255) DEFAULT NULL,
  `field_administration_state_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_administration_state_format` (`field_administration_state_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 71 (field...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_administration_state`
--

LOCK TABLES `field_revision_field_administration_state` WRITE;
/*!40000 ALTER TABLE `field_revision_field_administration_state` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_administration_state` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_allocated_segments`
--

DROP TABLE IF EXISTS `field_revision_field_allocated_segments`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_allocated_segments` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_allocated_segments_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 70 (field_allocated...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_allocated_segments`
--

LOCK TABLES `field_revision_field_allocated_segments` WRITE;
/*!40000 ALTER TABLE `field_revision_field_allocated_segments` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_allocated_segments` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_allocated_size`
--

DROP TABLE IF EXISTS `field_revision_field_allocated_size`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_allocated_size` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_allocated_size_value` varchar(255) DEFAULT NULL,
  `field_allocated_size_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_allocated_size_format` (`field_allocated_size_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 81 (field_allocated_size)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_allocated_size`
--

LOCK TABLES `field_revision_field_allocated_size` WRITE;
/*!40000 ALTER TABLE `field_revision_field_allocated_size` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_allocated_size` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_allocated_virtual_machines`
--

DROP TABLE IF EXISTS `field_revision_field_allocated_virtual_machines`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_allocated_virtual_machines` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_allocated_virtual_machines_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 77 (field_allocated...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_allocated_virtual_machines`
--

LOCK TABLES `field_revision_field_allocated_virtual_machines` WRITE;
/*!40000 ALTER TABLE `field_revision_field_allocated_virtual_machines` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_allocated_virtual_machines` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_attached_filters`
--

DROP TABLE IF EXISTS `field_revision_field_attached_filters`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_attached_filters` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_attached_filters_value` varchar(255) DEFAULT NULL,
  `field_attached_filters_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_attached_filters_format` (`field_attached_filters_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 49 (field_attached...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_attached_filters`
--

LOCK TABLES `field_revision_field_attached_filters` WRITE;
/*!40000 ALTER TABLE `field_revision_field_attached_filters` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_attached_filters` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_boottime`
--

DROP TABLE IF EXISTS `field_revision_field_boottime`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_boottime` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_boottime_value` varchar(255) DEFAULT NULL,
  `field_boottime_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_boottime_format` (`field_boottime_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 22 (field_boottime)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_boottime`
--

LOCK TABLES `field_revision_field_boottime` WRITE;
/*!40000 ALTER TABLE `field_revision_field_boottime` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_boottime` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_build_version`
--

DROP TABLE IF EXISTS `field_revision_field_build_version`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_build_version` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_build_version_value` varchar(255) DEFAULT NULL,
  `field_build_version_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_build_version_format` (`field_build_version_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 69 (field_build_version)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_build_version`
--

LOCK TABLES `field_revision_field_build_version` WRITE;
/*!40000 ALTER TABLE `field_revision_field_build_version` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_build_version` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_bundle_status`
--

DROP TABLE IF EXISTS `field_revision_field_bundle_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_bundle_status` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_bundle_status_value` varchar(255) DEFAULT NULL,
  `field_bundle_status_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_bundle_status_format` (`field_bundle_status_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 61 (field_bundle_status)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_bundle_status`
--

LOCK TABLES `field_revision_field_bundle_status` WRITE;
/*!40000 ALTER TABLE `field_revision_field_bundle_status` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_bundle_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_cache_allocated_to_vm`
--

DROP TABLE IF EXISTS `field_revision_field_cache_allocated_to_vm`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_cache_allocated_to_vm` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_cache_allocated_to_vm_nid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_cache_allocated_to_vm_nid` (`field_cache_allocated_to_vm_nid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 141 (field_cache...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_cache_allocated_to_vm`
--

LOCK TABLES `field_revision_field_cache_allocated_to_vm` WRITE;
/*!40000 ALTER TABLE `field_revision_field_cache_allocated_to_vm` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_cache_allocated_to_vm` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_cache_assigned_from_host`
--

DROP TABLE IF EXISTS `field_revision_field_cache_assigned_from_host`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_cache_assigned_from_host` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_cache_assigned_from_host_nid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_cache_assigned_from_host_nid` (`field_cache_assigned_from_host_nid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 140 (field_cache...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_cache_assigned_from_host`
--

LOCK TABLES `field_revision_field_cache_assigned_from_host` WRITE;
/*!40000 ALTER TABLE `field_revision_field_cache_assigned_from_host` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_cache_assigned_from_host` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_cache_mode`
--

DROP TABLE IF EXISTS `field_revision_field_cache_mode`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_cache_mode` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_cache_mode_value` varchar(255) DEFAULT NULL,
  `field_cache_mode_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_cache_mode_format` (`field_cache_mode_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 70 (field_cache_mode)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_cache_mode`
--

LOCK TABLES `field_revision_field_cache_mode` WRITE;
/*!40000 ALTER TABLE `field_revision_field_cache_mode` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_cache_mode` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_cache_size`
--

DROP TABLE IF EXISTS `field_revision_field_cache_size`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_cache_size` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_cache_size_value` varchar(255) DEFAULT NULL,
  `field_cache_size_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_cache_size_format` (`field_cache_size_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 72 (field_cache_size)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_cache_size`
--

LOCK TABLES `field_revision_field_cache_size` WRITE;
/*!40000 ALTER TABLE `field_revision_field_cache_size` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_cache_size` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_cache_state`
--

DROP TABLE IF EXISTS `field_revision_field_cache_state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_cache_state` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_cache_state_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 75 (field_cache_state)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_cache_state`
--

LOCK TABLES `field_revision_field_cache_state` WRITE;
/*!40000 ALTER TABLE `field_revision_field_cache_state` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_cache_state` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_cachespace`
--

DROP TABLE IF EXISTS `field_revision_field_cachespace`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_cachespace` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_cachespace_value` varchar(255) DEFAULT NULL,
  `field_cachespace_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_cachespace_format` (`field_cachespace_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 127 (field_cachespace)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_cachespace`
--

LOCK TABLES `field_revision_field_cachespace` WRITE;
/*!40000 ALTER TABLE `field_revision_field_cachespace` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_cachespace` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_capacity`
--

DROP TABLE IF EXISTS `field_revision_field_capacity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_capacity` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_capacity_value` varchar(255) DEFAULT NULL,
  `field_capacity_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_capacity_format` (`field_capacity_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 53 (field_capacity)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_capacity`
--

LOCK TABLES `field_revision_field_capacity` WRITE;
/*!40000 ALTER TABLE `field_revision_field_capacity` DISABLE KEYS */;
INSERT INTO `field_revision_field_capacity` VALUES ('node','vdisk',0,11729,34660,'und',0,'32212254720',NULL),('node','vdisk',0,14410,14410,'und',0,'32105295872',NULL);
/*!40000 ALTER TABLE `field_revision_field_capacity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_claimed_physical_devices`
--

DROP TABLE IF EXISTS `field_revision_field_claimed_physical_devices`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_claimed_physical_devices` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_claimed_physical_devices_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 74 (field_claimed...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_claimed_physical_devices`
--

LOCK TABLES `field_revision_field_claimed_physical_devices` WRITE;
/*!40000 ALTER TABLE `field_revision_field_claimed_physical_devices` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_claimed_physical_devices` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_cpu_model`
--

DROP TABLE IF EXISTS `field_revision_field_cpu_model`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_cpu_model` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_cpu_model_value` varchar(255) DEFAULT NULL,
  `field_cpu_model_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_cpu_model_format` (`field_cpu_model_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 21 (field_cpu_model)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_cpu_model`
--

LOCK TABLES `field_revision_field_cpu_model` WRITE;
/*!40000 ALTER TABLE `field_revision_field_cpu_model` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_cpu_model` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_cpu_usage`
--

DROP TABLE IF EXISTS `field_revision_field_cpu_usage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_cpu_usage` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_cpu_usage_value` varchar(255) DEFAULT NULL,
  `field_cpu_usage_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_cpu_usage_format` (`field_cpu_usage_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 18 (field_cpu_usage)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_cpu_usage`
--

LOCK TABLES `field_revision_field_cpu_usage` WRITE;
/*!40000 ALTER TABLE `field_revision_field_cpu_usage` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_cpu_usage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_datacenter`
--

DROP TABLE IF EXISTS `field_revision_field_datacenter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_datacenter` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_datacenter_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_datacenter_target_id` (`field_datacenter_target_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 65 (field_datacenter)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_datacenter`
--

LOCK TABLES `field_revision_field_datacenter` WRITE;
/*!40000 ALTER TABLE `field_revision_field_datacenter` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_datacenter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_devfs_path`
--

DROP TABLE IF EXISTS `field_revision_field_devfs_path`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_devfs_path` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_devfs_path_value` varchar(255) DEFAULT NULL,
  `field_devfs_path_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_devfs_path_format` (`field_devfs_path_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 35 (field_devfs_path)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_devfs_path`
--

LOCK TABLES `field_revision_field_devfs_path` WRITE;
/*!40000 ALTER TABLE `field_revision_field_devfs_path` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_devfs_path` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_device_state`
--

DROP TABLE IF EXISTS `field_revision_field_device_state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_device_state` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_device_state_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 82 (field_device_state)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_device_state`
--

LOCK TABLES `field_revision_field_device_state` WRITE;
/*!40000 ALTER TABLE `field_revision_field_device_state` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_device_state` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_device_type`
--

DROP TABLE IF EXISTS `field_revision_field_device_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_device_type` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_device_type_value` varchar(255) DEFAULT NULL,
  `field_device_type_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_device_type_format` (`field_device_type_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 33 (field_device_type)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_device_type`
--

LOCK TABLES `field_revision_field_device_type` WRITE;
/*!40000 ALTER TABLE `field_revision_field_device_type` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_device_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_disk_index`
--

DROP TABLE IF EXISTS `field_revision_field_disk_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_disk_index` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_disk_index_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 126 (field_disk_index)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_disk_index`
--

LOCK TABLES `field_revision_field_disk_index` WRITE;
/*!40000 ALTER TABLE `field_revision_field_disk_index` DISABLE KEYS */;
INSERT INTO `field_revision_field_disk_index` VALUES ('node','vdisk',0,11729,34660,'und',0,0),('node','vdisk',0,14410,14410,'und',0,0);
/*!40000 ALTER TABLE `field_revision_field_disk_index` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_display_name`
--

DROP TABLE IF EXISTS `field_revision_field_display_name`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_display_name` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_display_name_value` varchar(255) DEFAULT NULL,
  `field_display_name_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_display_name_format` (`field_display_name_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 52 (field_display_name)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_display_name`
--

LOCK TABLES `field_revision_field_display_name` WRITE;
/*!40000 ALTER TABLE `field_revision_field_display_name` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_display_name` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_driver_status`
--

DROP TABLE IF EXISTS `field_revision_field_driver_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_driver_status` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_driver_status_value` varchar(255) DEFAULT NULL,
  `field_driver_status_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_driver_status_format` (`field_driver_status_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 60 (field_driver_status)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_driver_status`
--

LOCK TABLES `field_revision_field_driver_status` WRITE;
/*!40000 ALTER TABLE `field_revision_field_driver_status` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_driver_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_drs`
--

DROP TABLE IF EXISTS `field_revision_field_drs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_drs` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_drs_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 173 (field_drs)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_drs`
--

LOCK TABLES `field_revision_field_drs` WRITE;
/*!40000 ALTER TABLE `field_revision_field_drs` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_drs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_fa_administration_state`
--

DROP TABLE IF EXISTS `field_revision_field_fa_administration_state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_fa_administration_state` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fa_administration_state_value` varchar(255) DEFAULT NULL,
  `field_fa_administration_state_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fa_administration_state_format` (`field_fa_administration_state_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 88 (field_fa...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_fa_administration_state`
--

LOCK TABLES `field_revision_field_fa_administration_state` WRITE;
/*!40000 ALTER TABLE `field_revision_field_fa_administration_state` DISABLE KEYS */;
INSERT INTO `field_revision_field_fa_administration_state` VALUES ('node','vdisk',0,11729,34660,'und',0,'ADMIN_ENABLED',NULL),('node','vdisk',0,14410,14410,'und',0,'ADMIN_DISABLED',NULL);
/*!40000 ALTER TABLE `field_revision_field_fa_administration_state` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_fa_build_version`
--

DROP TABLE IF EXISTS `field_revision_field_fa_build_version`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_fa_build_version` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fa_build_version_value` varchar(255) DEFAULT NULL,
  `field_fa_build_version_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fa_build_version_format` (`field_fa_build_version_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 86 (field_fa_build...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_fa_build_version`
--

LOCK TABLES `field_revision_field_fa_build_version` WRITE;
/*!40000 ALTER TABLE `field_revision_field_fa_build_version` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_fa_build_version` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_fa_cache_mode`
--

DROP TABLE IF EXISTS `field_revision_field_fa_cache_mode`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_fa_cache_mode` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fa_cache_mode_value` varchar(255) DEFAULT NULL,
  `field_fa_cache_mode_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fa_cache_mode_format` (`field_fa_cache_mode_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 87 (field_fa_cache_mode)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_fa_cache_mode`
--

LOCK TABLES `field_revision_field_fa_cache_mode` WRITE;
/*!40000 ALTER TABLE `field_revision_field_fa_cache_mode` DISABLE KEYS */;
INSERT INTO `field_revision_field_fa_cache_mode` VALUES ('node','vdisk',0,11729,34660,'und',0,'CM_WRITETHRU',NULL),('node','vdisk',0,14410,14410,'und',0,'CM_WRITETHRU',NULL);
/*!40000 ALTER TABLE `field_revision_field_fa_cache_mode` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_fa_cache_size`
--

DROP TABLE IF EXISTS `field_revision_field_fa_cache_size`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_fa_cache_size` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fa_cache_size_value` varchar(255) DEFAULT NULL,
  `field_fa_cache_size_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fa_cache_size_format` (`field_fa_cache_size_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 89 (field_fa_cache_size)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_fa_cache_size`
--

LOCK TABLES `field_revision_field_fa_cache_size` WRITE;
/*!40000 ALTER TABLE `field_revision_field_fa_cache_size` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_fa_cache_size` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_fa_generation_id`
--

DROP TABLE IF EXISTS `field_revision_field_fa_generation_id`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_fa_generation_id` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fa_generation_id_value` varchar(255) DEFAULT NULL,
  `field_fa_generation_id_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fa_generation_id_format` (`field_fa_generation_id_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 93 (field_fa...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_fa_generation_id`
--

LOCK TABLES `field_revision_field_fa_generation_id` WRITE;
/*!40000 ALTER TABLE `field_revision_field_fa_generation_id` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_fa_generation_id` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_fa_metrics_reset_interval`
--

DROP TABLE IF EXISTS `field_revision_field_fa_metrics_reset_interval`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_fa_metrics_reset_interval` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fa_metrics_reset_interval_value` varchar(255) DEFAULT NULL,
  `field_fa_metrics_reset_interval_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fa_metrics_reset_interval_format` (`field_fa_metrics_reset_interval_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 160 (field_fa_metrics...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_fa_metrics_reset_interval`
--

LOCK TABLES `field_revision_field_fa_metrics_reset_interval` WRITE;
/*!40000 ALTER TABLE `field_revision_field_fa_metrics_reset_interval` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_fa_metrics_reset_interval` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_fa_operational_message`
--

DROP TABLE IF EXISTS `field_revision_field_fa_operational_message`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_fa_operational_message` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fa_operational_message_value` varchar(255) DEFAULT NULL,
  `field_fa_operational_message_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fa_operational_message_format` (`field_fa_operational_message_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 91 (field_fa...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_fa_operational_message`
--

LOCK TABLES `field_revision_field_fa_operational_message` WRITE;
/*!40000 ALTER TABLE `field_revision_field_fa_operational_message` DISABLE KEYS */;
INSERT INTO `field_revision_field_fa_operational_message` VALUES ('node','vdisk',0,11729,34660,'und',0,'Waiting for cache ...',NULL),('node','vdisk',0,14410,14410,'und',0,'Admin disabled.',NULL);
/*!40000 ALTER TABLE `field_revision_field_fa_operational_message` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_fa_operational_state`
--

DROP TABLE IF EXISTS `field_revision_field_fa_operational_state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_fa_operational_state` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fa_operational_state_value` varchar(255) DEFAULT NULL,
  `field_fa_operational_state_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fa_operational_state_format` (`field_fa_operational_state_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 90 (field_fa...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_fa_operational_state`
--

LOCK TABLES `field_revision_field_fa_operational_state` WRITE;
/*!40000 ALTER TABLE `field_revision_field_fa_operational_state` DISABLE KEYS */;
INSERT INTO `field_revision_field_fa_operational_state` VALUES ('node','vdisk',0,11729,34660,'und',0,'OP_PENDING',NULL),('node','vdisk',0,14410,14410,'und',0,'OP_DISABLED',NULL);
/*!40000 ALTER TABLE `field_revision_field_fa_operational_state` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_fa_performance_state`
--

DROP TABLE IF EXISTS `field_revision_field_fa_performance_state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_fa_performance_state` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fa_performance_state_value` varchar(255) DEFAULT NULL,
  `field_fa_performance_state_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fa_performance_state_format` (`field_fa_performance_state_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 92 (field_fa...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_fa_performance_state`
--

LOCK TABLES `field_revision_field_fa_performance_state` WRITE;
/*!40000 ALTER TABLE `field_revision_field_fa_performance_state` DISABLE KEYS */;
INSERT INTO `field_revision_field_fa_performance_state` VALUES ('node','vdisk',0,11729,34660,'und',0,'ADMIN_ENABLED',NULL),('node','vdisk',0,14410,14410,'und',0,'ADMIN_DISABLED',NULL);
/*!40000 ALTER TABLE `field_revision_field_fa_performance_state` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_fa_sector_size`
--

DROP TABLE IF EXISTS `field_revision_field_fa_sector_size`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_fa_sector_size` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fa_sector_size_value` varchar(10) DEFAULT NULL,
  `field_fa_sector_size_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fa_sector_size_format` (`field_fa_sector_size_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 156 (field_fa_sector...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_fa_sector_size`
--

LOCK TABLES `field_revision_field_fa_sector_size` WRITE;
/*!40000 ALTER TABLE `field_revision_field_fa_sector_size` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_fa_sector_size` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_fa_usable_blocks`
--

DROP TABLE IF EXISTS `field_revision_field_fa_usable_blocks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_fa_usable_blocks` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fa_usable_blocks_value` varchar(255) DEFAULT NULL,
  `field_fa_usable_blocks_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fa_usable_blocks_format` (`field_fa_usable_blocks_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 149 (field_fa_usable...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_fa_usable_blocks`
--

LOCK TABLES `field_revision_field_fa_usable_blocks` WRITE;
/*!40000 ALTER TABLE `field_revision_field_fa_usable_blocks` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_fa_usable_blocks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_fmc_uuid`
--

DROP TABLE IF EXISTS `field_revision_field_fmc_uuid`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_fmc_uuid` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_fmc_uuid_value` varchar(255) DEFAULT NULL,
  `field_fmc_uuid_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_fmc_uuid_format` (`field_fmc_uuid_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 168 (field_fmc_uuid)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_fmc_uuid`
--

LOCK TABLES `field_revision_field_fmc_uuid` WRITE;
/*!40000 ALTER TABLE `field_revision_field_fmc_uuid` DISABLE KEYS */;
INSERT INTO `field_revision_field_fmc_uuid` VALUES ('node','vcenter',0,1,1,'und',0,'',NULL);
/*!40000 ALTER TABLE `field_revision_field_fmc_uuid` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_freespace`
--

DROP TABLE IF EXISTS `field_revision_field_freespace`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_freespace` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_freespace_value` varchar(255) DEFAULT NULL,
  `field_freespace_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_freespace_format` (`field_freespace_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 55 (field_freespace)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_freespace`
--

LOCK TABLES `field_revision_field_freespace` WRITE;
/*!40000 ALTER TABLE `field_revision_field_freespace` DISABLE KEYS */;
INSERT INTO `field_revision_field_freespace` VALUES ('node','vdisk',0,11729,34660,'und',0,'Not Known',NULL),('node','vdisk',0,14410,14410,'und',0,'17726402560',NULL);
/*!40000 ALTER TABLE `field_revision_field_freespace` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_generation_id`
--

DROP TABLE IF EXISTS `field_revision_field_generation_id`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_generation_id` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_generation_id_value` varchar(255) DEFAULT NULL,
  `field_generation_id_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_generation_id_format` (`field_generation_id_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 76 (field_generation_id)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_generation_id`
--

LOCK TABLES `field_revision_field_generation_id` WRITE;
/*!40000 ALTER TABLE `field_revision_field_generation_id` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_generation_id` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_guest_id`
--

DROP TABLE IF EXISTS `field_revision_field_guest_id`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_guest_id` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_guest_id_value` varchar(255) DEFAULT NULL,
  `field_guest_id_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_guest_id_format` (`field_guest_id_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 16 (field_guest_id)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_guest_id`
--

LOCK TABLES `field_revision_field_guest_id` WRITE;
/*!40000 ALTER TABLE `field_revision_field_guest_id` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_guest_id` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_guest_memory_usage`
--

DROP TABLE IF EXISTS `field_revision_field_guest_memory_usage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_guest_memory_usage` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_guest_memory_usage_value` varchar(255) DEFAULT NULL,
  `field_guest_memory_usage_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_guest_memory_usage_format` (`field_guest_memory_usage_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 20 (field_guest_memory...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_guest_memory_usage`
--

LOCK TABLES `field_revision_field_guest_memory_usage` WRITE;
/*!40000 ALTER TABLE `field_revision_field_guest_memory_usage` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_guest_memory_usage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_guest_os`
--

DROP TABLE IF EXISTS `field_revision_field_guest_os`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_guest_os` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_guest_os_value` varchar(255) DEFAULT NULL,
  `field_guest_os_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_guest_os_format` (`field_guest_os_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 15 (field_guest_os)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_guest_os`
--

LOCK TABLES `field_revision_field_guest_os` WRITE;
/*!40000 ALTER TABLE `field_revision_field_guest_os` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_guest_os` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_ha`
--

DROP TABLE IF EXISTS `field_revision_field_ha`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_ha` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_ha_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 174 (field_ha)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_ha`
--

LOCK TABLES `field_revision_field_ha` WRITE;
/*!40000 ALTER TABLE `field_revision_field_ha` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_ha` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_hbtl`
--

DROP TABLE IF EXISTS `field_revision_field_hbtl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_hbtl` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_hbtl_value` varchar(255) DEFAULT NULL,
  `field_hbtl_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_hbtl_format` (`field_hbtl_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 147 (field_hbtl)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_hbtl`
--

LOCK TABLES `field_revision_field_hbtl` WRITE;
/*!40000 ALTER TABLE `field_revision_field_hbtl` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_hbtl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_hit_ops`
--

DROP TABLE IF EXISTS `field_revision_field_hit_ops`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_hit_ops` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_hit_ops_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 155 (field_hit_ops)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_hit_ops`
--

LOCK TABLES `field_revision_field_hit_ops` WRITE;
/*!40000 ALTER TABLE `field_revision_field_hit_ops` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_hit_ops` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_host`
--

DROP TABLE IF EXISTS `field_revision_field_host`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_host` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_host_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_host_target_id` (`field_host_target_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 66 (field_host)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_host`
--

LOCK TABLES `field_revision_field_host` WRITE;
/*!40000 ALTER TABLE `field_revision_field_host` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_host` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_host_ip`
--

DROP TABLE IF EXISTS `field_revision_field_host_ip`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_host_ip` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_host_ip_value` varchar(255) DEFAULT NULL,
  `field_host_ip_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_host_ip_format` (`field_host_ip_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 154 (field_host_ip)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_host_ip`
--

LOCK TABLES `field_revision_field_host_ip` WRITE;
/*!40000 ALTER TABLE `field_revision_field_host_ip` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_host_ip` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_host_memory_usage`
--

DROP TABLE IF EXISTS `field_revision_field_host_memory_usage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_host_memory_usage` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_host_memory_usage_value` varchar(255) DEFAULT NULL,
  `field_host_memory_usage_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_host_memory_usage_format` (`field_host_memory_usage_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 19 (field_host_memory...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_host_memory_usage`
--

LOCK TABLES `field_revision_field_host_memory_usage` WRITE;
/*!40000 ALTER TABLE `field_revision_field_host_memory_usage` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_host_memory_usage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_host_model`
--

DROP TABLE IF EXISTS `field_revision_field_host_model`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_host_model` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_host_model_value` varchar(255) DEFAULT NULL,
  `field_host_model_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_host_model_format` (`field_host_model_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 143 (field_host_model)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_host_model`
--

LOCK TABLES `field_revision_field_host_model` WRITE;
/*!40000 ALTER TABLE `field_revision_field_host_model` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_host_model` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_host_password`
--

DROP TABLE IF EXISTS `field_revision_field_host_password`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_host_password` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_host_password_value` varchar(255) DEFAULT NULL,
  `field_host_password_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_host_password_format` (`field_host_password_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 59 (field_host_password)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_host_password`
--

LOCK TABLES `field_revision_field_host_password` WRITE;
/*!40000 ALTER TABLE `field_revision_field_host_password` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_host_password` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_host_status`
--

DROP TABLE IF EXISTS `field_revision_field_host_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_host_status` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_host_status_value` varchar(255) DEFAULT NULL,
  `field_host_status_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_host_status_format` (`field_host_status_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 23 (field_host_status)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_host_status`
--

LOCK TABLES `field_revision_field_host_status` WRITE;
/*!40000 ALTER TABLE `field_revision_field_host_status` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_host_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_host_username`
--

DROP TABLE IF EXISTS `field_revision_field_host_username`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_host_username` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_host_username_value` varchar(255) DEFAULT NULL,
  `field_host_username_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_host_username_format` (`field_host_username_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 58 (field_host_username)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_host_username`
--

LOCK TABLES `field_revision_field_host_username` WRITE;
/*!40000 ALTER TABLE `field_revision_field_host_username` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_host_username` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_host_vendor`
--

DROP TABLE IF EXISTS `field_revision_field_host_vendor`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_host_vendor` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_host_vendor_value` varchar(255) DEFAULT NULL,
  `field_host_vendor_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_host_vendor_format` (`field_host_vendor_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 144 (field_host_vendor)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_host_vendor`
--

LOCK TABLES `field_revision_field_host_vendor` WRITE;
/*!40000 ALTER TABLE `field_revision_field_host_vendor` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_host_vendor` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_hostname`
--

DROP TABLE IF EXISTS `field_revision_field_hostname`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_hostname` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_hostname_value` varchar(255) DEFAULT NULL,
  `field_hostname_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_hostname_format` (`field_hostname_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 158 (field_hostname)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_hostname`
--

LOCK TABLES `field_revision_field_hostname` WRITE;
/*!40000 ALTER TABLE `field_revision_field_hostname` DISABLE KEYS */;
INSERT INTO `field_revision_field_hostname` VALUES ('node','vcenter',0,1,1,'und',0,'',NULL);
/*!40000 ALTER TABLE `field_revision_field_hostname` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_install_port`
--

DROP TABLE IF EXISTS `field_revision_field_install_port`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_install_port` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_install_port_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 142 (field_install_port)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_install_port`
--

LOCK TABLES `field_revision_field_install_port` WRITE;
/*!40000 ALTER TABLE `field_revision_field_install_port` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_install_port` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_ip_address`
--

DROP TABLE IF EXISTS `field_revision_field_ip_address`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_ip_address` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_ip_address_value` varchar(255) DEFAULT NULL,
  `field_ip_address_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_ip_address_format` (`field_ip_address_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 5 (field_ip_address)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_ip_address`
--

LOCK TABLES `field_revision_field_ip_address` WRITE;
/*!40000 ALTER TABLE `field_revision_field_ip_address` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_ip_address` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_is_local`
--

DROP TABLE IF EXISTS `field_revision_field_is_local`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_is_local` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_is_local_value` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_is_local_value` (`field_is_local_value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 43 (field_is_local)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_is_local`
--

LOCK TABLES `field_revision_field_is_local` WRITE;
/*!40000 ALTER TABLE `field_revision_field_is_local` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_is_local` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_is_offline`
--

DROP TABLE IF EXISTS `field_revision_field_is_offline`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_is_offline` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_is_offline_value` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_is_offline_value` (`field_is_offline_value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 46 (field_is_offline)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_is_offline`
--

LOCK TABLES `field_revision_field_is_offline` WRITE;
/*!40000 ALTER TABLE `field_revision_field_is_offline` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_is_offline` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_is_perennially_reserved`
--

DROP TABLE IF EXISTS `field_revision_field_is_perennially_reserved`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_is_perennially_reserved` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_is_perennially_reserved_value` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_is_perennially_reserved_value` (`field_is_perennially_reserved_value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 47 (field_is...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_is_perennially_reserved`
--

LOCK TABLES `field_revision_field_is_perennially_reserved` WRITE;
/*!40000 ALTER TABLE `field_revision_field_is_perennially_reserved` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_is_perennially_reserved` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_is_pseudo`
--

DROP TABLE IF EXISTS `field_revision_field_is_pseudo`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_is_pseudo` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_is_pseudo_value` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_is_pseudo_value` (`field_is_pseudo_value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 40 (field_is_pseudo)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_is_pseudo`
--

LOCK TABLES `field_revision_field_is_pseudo` WRITE;
/*!40000 ALTER TABLE `field_revision_field_is_pseudo` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_is_pseudo` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_is_rdm_capable`
--

DROP TABLE IF EXISTS `field_revision_field_is_rdm_capable`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_is_rdm_capable` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_is_rdm_capable_value` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_is_rdm_capable_value` (`field_is_rdm_capable_value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 42 (field_is_rdm_capable)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_is_rdm_capable`
--

LOCK TABLES `field_revision_field_is_rdm_capable` WRITE;
/*!40000 ALTER TABLE `field_revision_field_is_rdm_capable` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_is_rdm_capable` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_is_removable`
--

DROP TABLE IF EXISTS `field_revision_field_is_removable`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_is_removable` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_is_removable_value` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_is_removable_value` (`field_is_removable_value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 44 (field_is_removable)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_is_removable`
--

LOCK TABLES `field_revision_field_is_removable` WRITE;
/*!40000 ALTER TABLE `field_revision_field_is_removable` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_is_removable` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_is_ssd`
--

DROP TABLE IF EXISTS `field_revision_field_is_ssd`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_is_ssd` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_is_ssd_value` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_is_ssd_value` (`field_is_ssd_value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 45 (field_is_ssd)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_is_ssd`
--

LOCK TABLES `field_revision_field_is_ssd` WRITE;
/*!40000 ALTER TABLE `field_revision_field_is_ssd` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_is_ssd` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_is_vmfs`
--

DROP TABLE IF EXISTS `field_revision_field_is_vmfs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_is_vmfs` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_is_vmfs_value` varchar(10) DEFAULT NULL,
  `field_is_vmfs_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_is_vmfs_format` (`field_is_vmfs_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 148 (field_is_vmfs)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_is_vmfs`
--

LOCK TABLES `field_revision_field_is_vmfs` WRITE;
/*!40000 ALTER TABLE `field_revision_field_is_vmfs` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_is_vmfs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_maintenance_mode`
--

DROP TABLE IF EXISTS `field_revision_field_maintenance_mode`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_maintenance_mode` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_maintenance_mode_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 24 (field_maintenance...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_maintenance_mode`
--

LOCK TABLES `field_revision_field_maintenance_mode` WRITE;
/*!40000 ALTER TABLE `field_revision_field_maintenance_mode` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_maintenance_mode` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_max_physical_devices`
--

DROP TABLE IF EXISTS `field_revision_field_max_physical_devices`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_max_physical_devices` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_max_physical_devices_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 73 (field_max_physical...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_max_physical_devices`
--

LOCK TABLES `field_revision_field_max_physical_devices` WRITE;
/*!40000 ALTER TABLE `field_revision_field_max_physical_devices` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_max_physical_devices` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_max_virtual_machines`
--

DROP TABLE IF EXISTS `field_revision_field_max_virtual_machines`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_max_virtual_machines` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_max_virtual_machines_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 72 (field_max_virtual...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_max_virtual_machines`
--

LOCK TABLES `field_revision_field_max_virtual_machines` WRITE;
/*!40000 ALTER TABLE `field_revision_field_max_virtual_machines` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_max_virtual_machines` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_memory_size`
--

DROP TABLE IF EXISTS `field_revision_field_memory_size`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_memory_size` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_memory_size_value` varchar(255) DEFAULT NULL,
  `field_memory_size_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_memory_size_format` (`field_memory_size_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 11 (field_memory_size)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_memory_size`
--

LOCK TABLES `field_revision_field_memory_size` WRITE;
/*!40000 ALTER TABLE `field_revision_field_memory_size` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_memory_size` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_model`
--

DROP TABLE IF EXISTS `field_revision_field_model`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_model` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_model_value` varchar(255) DEFAULT NULL,
  `field_model_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_model_format` (`field_model_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 37 (field_model)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_model`
--

LOCK TABLES `field_revision_field_model` WRITE;
/*!40000 ALTER TABLE `field_revision_field_model` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_model` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_multipath_plugin`
--

DROP TABLE IF EXISTS `field_revision_field_multipath_plugin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_multipath_plugin` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_multipath_plugin_value` varchar(255) DEFAULT NULL,
  `field_multipath_plugin_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_multipath_plugin_format` (`field_multipath_plugin_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 34 (field_multipath...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_multipath_plugin`
--

LOCK TABLES `field_revision_field_multipath_plugin` WRITE;
/*!40000 ALTER TABLE `field_revision_field_multipath_plugin` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_multipath_plugin` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_naa_identifier`
--

DROP TABLE IF EXISTS `field_revision_field_naa_identifier`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_naa_identifier` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_naa_identifier_value` varchar(255) DEFAULT NULL,
  `field_naa_identifier_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_naa_identifier_format` (`field_naa_identifier_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 80 (field_naa_identifier)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_naa_identifier`
--

LOCK TABLES `field_revision_field_naa_identifier` WRITE;
/*!40000 ALTER TABLE `field_revision_field_naa_identifier` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_naa_identifier` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_no_of_cpu`
--

DROP TABLE IF EXISTS `field_revision_field_no_of_cpu`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_no_of_cpu` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_no_of_cpu_value` varchar(255) DEFAULT NULL,
  `field_no_of_cpu_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_no_of_cpu_format` (`field_no_of_cpu_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 83 (field_no_of_cpu)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_no_of_cpu`
--

LOCK TABLES `field_revision_field_no_of_cpu` WRITE;
/*!40000 ALTER TABLE `field_revision_field_no_of_cpu` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_no_of_cpu` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_operational_message`
--

DROP TABLE IF EXISTS `field_revision_field_operational_message`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_operational_message` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_operational_message_value` varchar(255) DEFAULT NULL,
  `field_operational_message_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_operational_message_format` (`field_operational_message_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 74 (field_operational...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_operational_message`
--

LOCK TABLES `field_revision_field_operational_message` WRITE;
/*!40000 ALTER TABLE `field_revision_field_operational_message` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_operational_message` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_operational_state`
--

DROP TABLE IF EXISTS `field_revision_field_operational_state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_operational_state` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_operational_state_value` varchar(255) DEFAULT NULL,
  `field_operational_state_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_operational_state_format` (`field_operational_state_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 73 (field_operational...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_operational_state`
--

LOCK TABLES `field_revision_field_operational_state` WRITE;
/*!40000 ALTER TABLE `field_revision_field_operational_state` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_operational_state` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_other_uids`
--

DROP TABLE IF EXISTS `field_revision_field_other_uids`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_other_uids` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_other_uids_value` varchar(255) DEFAULT NULL,
  `field_other_uids_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_other_uids_format` (`field_other_uids_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 51 (field_other_uids)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_other_uids`
--

LOCK TABLES `field_revision_field_other_uids` WRITE;
/*!40000 ALTER TABLE `field_revision_field_other_uids` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_other_uids` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_password`
--

DROP TABLE IF EXISTS `field_revision_field_password`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_password` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_password_value` varchar(255) DEFAULT NULL,
  `field_password_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_password_format` (`field_password_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 7 (field_password)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_password`
--

LOCK TABLES `field_revision_field_password` WRITE;
/*!40000 ALTER TABLE `field_revision_field_password` DISABLE KEYS */;
INSERT INTO `field_revision_field_password` VALUES ('node','vcenter',0,1,1,'und',0,'',NULL);
/*!40000 ALTER TABLE `field_revision_field_password` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_path`
--

DROP TABLE IF EXISTS `field_revision_field_path`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_path` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_path_value` varchar(255) DEFAULT NULL,
  `field_path_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_path_format` (`field_path_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 54 (field_path)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_path`
--

LOCK TABLES `field_revision_field_path` WRITE;
/*!40000 ALTER TABLE `field_revision_field_path` DISABLE KEYS */;
INSERT INTO `field_revision_field_path` VALUES ('node','vdisk',0,11729,34660,'und',0,'C:',NULL),('node','vdisk',0,14410,14410,'und',0,'C:\\',NULL);
/*!40000 ALTER TABLE `field_revision_field_path` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_performance_state`
--

DROP TABLE IF EXISTS `field_revision_field_performance_state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_performance_state` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_performance_state_value` varchar(255) DEFAULT NULL,
  `field_performance_state_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_performance_state_format` (`field_performance_state_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 75 (field_performance...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_performance_state`
--

LOCK TABLES `field_revision_field_performance_state` WRITE;
/*!40000 ALTER TABLE `field_revision_field_performance_state` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_performance_state` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_physical_memory`
--

DROP TABLE IF EXISTS `field_revision_field_physical_memory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_physical_memory` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_physical_memory_value` varchar(255) DEFAULT NULL,
  `field_physical_memory_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_physical_memory_format` (`field_physical_memory_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 25 (field_physical...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_physical_memory`
--

LOCK TABLES `field_revision_field_physical_memory` WRITE;
/*!40000 ALTER TABLE `field_revision_field_physical_memory` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_physical_memory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_reboot_required`
--

DROP TABLE IF EXISTS `field_revision_field_reboot_required`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_reboot_required` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_reboot_required_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 27 (field_reboot...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_reboot_required`
--

LOCK TABLES `field_revision_field_reboot_required` WRITE;
/*!40000 ALTER TABLE `field_revision_field_reboot_required` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_reboot_required` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_rediscover_status`
--

DROP TABLE IF EXISTS `field_revision_field_rediscover_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_rediscover_status` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_rediscover_status_value` varchar(255) DEFAULT NULL,
  `field_rediscover_status_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_rediscover_status_format` (`field_rediscover_status_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 157 (field_rediscover...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_rediscover_status`
--

LOCK TABLES `field_revision_field_rediscover_status` WRITE;
/*!40000 ALTER TABLE `field_revision_field_rediscover_status` DISABLE KEYS */;
INSERT INTO `field_revision_field_rediscover_status` VALUES ('node','vcenter',0,1,1,'und',0,'',NULL);
/*!40000 ALTER TABLE `field_revision_field_rediscover_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_related_host`
--

DROP TABLE IF EXISTS `field_revision_field_related_host`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_related_host` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_related_host_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_related_host_target_id` (`field_related_host_target_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 64 (field_related_host)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_related_host`
--

LOCK TABLES `field_revision_field_related_host` WRITE;
/*!40000 ALTER TABLE `field_revision_field_related_host` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_related_host` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_related_vcenter`
--

DROP TABLE IF EXISTS `field_revision_field_related_vcenter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_related_vcenter` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_related_vcenter_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_related_vcenter_target_id` (`field_related_vcenter_target_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 62 (field_related...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_related_vcenter`
--

LOCK TABLES `field_revision_field_related_vcenter` WRITE;
/*!40000 ALTER TABLE `field_revision_field_related_vcenter` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_related_vcenter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_revision`
--

DROP TABLE IF EXISTS `field_revision_field_revision`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_revision` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_revision_value` varchar(255) DEFAULT NULL,
  `field_revision_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_revision_format` (`field_revision_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 38 (field_revision)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_revision`
--

LOCK TABLES `field_revision_field_revision` WRITE;
/*!40000 ALTER TABLE `field_revision_field_revision` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_revision` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_scsi_level`
--

DROP TABLE IF EXISTS `field_revision_field_scsi_level`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_scsi_level` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_scsi_level_value` varchar(255) DEFAULT NULL,
  `field_scsi_level_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_scsi_level_format` (`field_scsi_level_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 39 (field_scsi_level)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_scsi_level`
--

LOCK TABLES `field_revision_field_scsi_level` WRITE;
/*!40000 ALTER TABLE `field_revision_field_scsi_level` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_scsi_level` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_segment_size`
--

DROP TABLE IF EXISTS `field_revision_field_segment_size`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_segment_size` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_segment_size_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 71 (field_segment_size)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_segment_size`
--

LOCK TABLES `field_revision_field_segment_size` WRITE;
/*!40000 ALTER TABLE `field_revision_field_segment_size` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_segment_size` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_serial_no`
--

DROP TABLE IF EXISTS `field_revision_field_serial_no`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_serial_no` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_serial_no_value` varchar(255) DEFAULT NULL,
  `field_serial_no_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_serial_no_format` (`field_serial_no_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 31 (field_serial_no)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_serial_no`
--

LOCK TABLES `field_revision_field_serial_no` WRITE;
/*!40000 ALTER TABLE `field_revision_field_serial_no` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_serial_no` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_size`
--

DROP TABLE IF EXISTS `field_revision_field_size`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_size` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_size_value` varchar(255) DEFAULT NULL,
  `field_size_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_size_format` (`field_size_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 32 (field_size)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_size`
--

LOCK TABLES `field_revision_field_size` WRITE;
/*!40000 ALTER TABLE `field_revision_field_size` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_size` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_software_on_host`
--

DROP TABLE IF EXISTS `field_revision_field_software_on_host`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_software_on_host` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_software_on_host_value` varchar(255) DEFAULT NULL,
  `field_software_on_host_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_software_on_host_format` (`field_software_on_host_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 68 (field_software_on...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_software_on_host`
--

LOCK TABLES `field_revision_field_software_on_host` WRITE;
/*!40000 ALTER TABLE `field_revision_field_software_on_host` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_software_on_host` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_status`
--

DROP TABLE IF EXISTS `field_revision_field_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_status` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_status_value` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_status_value` (`field_status_value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 41 (field_status)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_status`
--

LOCK TABLES `field_revision_field_status` WRITE;
/*!40000 ALTER TABLE `field_revision_field_status` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_tags`
--

DROP TABLE IF EXISTS `field_revision_field_tags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_tags` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_tags_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_tags_tid` (`field_tags_tid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 3 (field_tags)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_tags`
--

LOCK TABLES `field_revision_field_tags` WRITE;
/*!40000 ALTER TABLE `field_revision_field_tags` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_tags` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_template`
--

DROP TABLE IF EXISTS `field_revision_field_template`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_template` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_template_value` varchar(255) DEFAULT NULL,
  `field_template_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_template_format` (`field_template_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 13 (field_template)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_template`
--

LOCK TABLES `field_revision_field_template` WRITE;
/*!40000 ALTER TABLE `field_revision_field_template` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_template` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_thin_provisioning_status`
--

DROP TABLE IF EXISTS `field_revision_field_thin_provisioning_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_thin_provisioning_status` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_thin_provisioning_status_value` varchar(255) DEFAULT NULL,
  `field_thin_provisioning_status_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_thin_provisioning_status_format` (`field_thin_provisioning_status_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 48 (field_thin...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_thin_provisioning_status`
--

LOCK TABLES `field_revision_field_thin_provisioning_status` WRITE;
/*!40000 ALTER TABLE `field_revision_field_thin_provisioning_status` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_thin_provisioning_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_timestamp`
--

DROP TABLE IF EXISTS `field_revision_field_timestamp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_timestamp` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_timestamp_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 122 (field_timestamp)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_timestamp`
--

LOCK TABLES `field_revision_field_timestamp` WRITE;
/*!40000 ALTER TABLE `field_revision_field_timestamp` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_timestamp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_total_segments`
--

DROP TABLE IF EXISTS `field_revision_field_total_segments`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_total_segments` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_total_segments_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 76 (field_total_segments)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_total_segments`
--

LOCK TABLES `field_revision_field_total_segments` WRITE;
/*!40000 ALTER TABLE `field_revision_field_total_segments` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_total_segments` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_total_size`
--

DROP TABLE IF EXISTS `field_revision_field_total_size`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_total_size` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_total_size_value` varchar(255) DEFAULT NULL,
  `field_total_size_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_total_size_format` (`field_total_size_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 79 (field_total_size)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_total_size`
--

LOCK TABLES `field_revision_field_total_size` WRITE;
/*!40000 ALTER TABLE `field_revision_field_total_size` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_total_size` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_username`
--

DROP TABLE IF EXISTS `field_revision_field_username`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_username` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_username_value` varchar(255) DEFAULT NULL,
  `field_username_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_username_format` (`field_username_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 6 (field_username)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_username`
--

LOCK TABLES `field_revision_field_username` WRITE;
/*!40000 ALTER TABLE `field_revision_field_username` DISABLE KEYS */;
INSERT INTO `field_revision_field_username` VALUES ('node','vcenter',0,1,1,'und',0,'',NULL);
/*!40000 ALTER TABLE `field_revision_field_username` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vaai_status`
--

DROP TABLE IF EXISTS `field_revision_field_vaai_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vaai_status` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vaai_status_value` varchar(255) DEFAULT NULL,
  `field_vaai_status_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vaai_status_format` (`field_vaai_status_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 50 (field_vaai_status)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vaai_status`
--

LOCK TABLES `field_revision_field_vaai_status` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vaai_status` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vaai_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vdisk`
--

DROP TABLE IF EXISTS `field_revision_field_vdisk`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vdisk` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vdisk_target_id` (`field_vdisk_target_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 109 (field_vdisk)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vdisk`
--

LOCK TABLES `field_revision_field_vdisk` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vdisk` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vdisk` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vdisk_cache_latency`
--

DROP TABLE IF EXISTS `field_revision_field_vdisk_cache_latency`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vdisk_cache_latency` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_cache_latency_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 116 (field_vdisk_cache...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vdisk_cache_latency`
--

LOCK TABLES `field_revision_field_vdisk_cache_latency` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vdisk_cache_latency` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vdisk_cache_latency` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vdisk_hit_rate_pc`
--

DROP TABLE IF EXISTS `field_revision_field_vdisk_hit_rate_pc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vdisk_hit_rate_pc` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_hit_rate_pc_value` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 175 (field_vdisk_hit...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vdisk_hit_rate_pc`
--

LOCK TABLES `field_revision_field_vdisk_hit_rate_pc` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vdisk_hit_rate_pc` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vdisk_hit_rate_pc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vdisk_hits`
--

DROP TABLE IF EXISTS `field_revision_field_vdisk_hits`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vdisk_hits` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_hits_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 114 (field_vdisk_hits)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vdisk_hits`
--

LOCK TABLES `field_revision_field_vdisk_hits` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vdisk_hits` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vdisk_hits` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vdisk_id`
--

DROP TABLE IF EXISTS `field_revision_field_vdisk_id`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vdisk_id` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_id_value` varchar(255) DEFAULT NULL,
  `field_vdisk_id_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vdisk_id_format` (`field_vdisk_id_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 152 (field_vdisk_id)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vdisk_id`
--

LOCK TABLES `field_revision_field_vdisk_id` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vdisk_id` DISABLE KEYS */;
INSERT INTO `field_revision_field_vdisk_id` VALUES ('node','vdisk',0,11729,34660,'und',0,'naa.6000C2951b9e65799ddfac1e8f841c76',NULL);
/*!40000 ALTER TABLE `field_revision_field_vdisk_id` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vdisk_identifier`
--

DROP TABLE IF EXISTS `field_revision_field_vdisk_identifier`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vdisk_identifier` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_identifier_value` varchar(255) DEFAULT NULL,
  `field_vdisk_identifier_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vdisk_identifier_format` (`field_vdisk_identifier_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 128 (field_vdisk...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vdisk_identifier`
--

LOCK TABLES `field_revision_field_vdisk_identifier` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vdisk_identifier` DISABLE KEYS */;
INSERT INTO `field_revision_field_vdisk_identifier` VALUES ('node','vdisk',0,11729,34660,'und',0,'6000c2951b9e65799ddfac1e8f841c76',NULL),('node','vdisk',0,14410,14410,'und',0,'6000c2951b9e65799ddfac1e8f841c76',NULL);
/*!40000 ALTER TABLE `field_revision_field_vdisk_identifier` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vdisk_insertion_rate_pc`
--

DROP TABLE IF EXISTS `field_revision_field_vdisk_insertion_rate_pc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vdisk_insertion_rate_pc` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_insertion_rate_pc_value` varchar(32) DEFAULT '0',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 125 (field_vdisk...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vdisk_insertion_rate_pc`
--

LOCK TABLES `field_revision_field_vdisk_insertion_rate_pc` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vdisk_insertion_rate_pc` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vdisk_insertion_rate_pc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vdisk_insertions`
--

DROP TABLE IF EXISTS `field_revision_field_vdisk_insertions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vdisk_insertions` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_insertions_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 119 (field_vdisk...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vdisk_insertions`
--

LOCK TABLES `field_revision_field_vdisk_insertions` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vdisk_insertions` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vdisk_insertions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vdisk_name`
--

DROP TABLE IF EXISTS `field_revision_field_vdisk_name`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vdisk_name` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_name_value` varchar(255) DEFAULT NULL,
  `field_vdisk_name_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vdisk_name_format` (`field_vdisk_name_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 150 (field_vdisk_name)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vdisk_name`
--

LOCK TABLES `field_revision_field_vdisk_name` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vdisk_name` DISABLE KEYS */;
INSERT INTO `field_revision_field_vdisk_name` VALUES ('node','vdisk',0,11729,34660,'und',0,'Hard disk 1',NULL);
/*!40000 ALTER TABLE `field_revision_field_vdisk_name` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vdisk_population`
--

DROP TABLE IF EXISTS `field_revision_field_vdisk_population`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vdisk_population` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_population_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 117 (field_vdisk...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vdisk_population`
--

LOCK TABLES `field_revision_field_vdisk_population` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vdisk_population` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vdisk_population` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vdisk_population_pc`
--

DROP TABLE IF EXISTS `field_revision_field_vdisk_population_pc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vdisk_population_pc` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_population_pc_value` varchar(32) DEFAULT '0',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 124 (field_vdisk...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vdisk_population_pc`
--

LOCK TABLES `field_revision_field_vdisk_population_pc` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vdisk_population_pc` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vdisk_population_pc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vdisk_read_blocks`
--

DROP TABLE IF EXISTS `field_revision_field_vdisk_read_blocks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vdisk_read_blocks` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_read_blocks_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 115 (field_vdisk_read...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vdisk_read_blocks`
--

LOCK TABLES `field_revision_field_vdisk_read_blocks` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vdisk_read_blocks` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vdisk_read_blocks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vdisk_read_latency`
--

DROP TABLE IF EXISTS `field_revision_field_vdisk_read_latency`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vdisk_read_latency` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_read_latency_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 110 (field_vdisk_read...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vdisk_read_latency`
--

LOCK TABLES `field_revision_field_vdisk_read_latency` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vdisk_read_latency` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vdisk_read_latency` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vdisk_read_ops`
--

DROP TABLE IF EXISTS `field_revision_field_vdisk_read_ops`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vdisk_read_ops` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_read_ops_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 112 (field_vdisk_read...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vdisk_read_ops`
--

LOCK TABLES `field_revision_field_vdisk_read_ops` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vdisk_read_ops` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vdisk_read_ops` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vdisk_type`
--

DROP TABLE IF EXISTS `field_revision_field_vdisk_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vdisk_type` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_type_value` varchar(255) DEFAULT NULL,
  `field_vdisk_type_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vdisk_type_format` (`field_vdisk_type_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 151 (field_vdisk_type)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vdisk_type`
--

LOCK TABLES `field_revision_field_vdisk_type` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vdisk_type` DISABLE KEYS */;
INSERT INTO `field_revision_field_vdisk_type` VALUES ('node','vdisk',0,11729,34660,'und',0,'VMDK',NULL);
/*!40000 ALTER TABLE `field_revision_field_vdisk_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vdisk_usable_blocks`
--

DROP TABLE IF EXISTS `field_revision_field_vdisk_usable_blocks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vdisk_usable_blocks` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_usable_blocks_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 118 (field_vdisk...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vdisk_usable_blocks`
--

LOCK TABLES `field_revision_field_vdisk_usable_blocks` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vdisk_usable_blocks` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vdisk_usable_blocks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vdisk_write_blocks`
--

DROP TABLE IF EXISTS `field_revision_field_vdisk_write_blocks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vdisk_write_blocks` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_write_blocks_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 120 (field_vdisk_write...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vdisk_write_blocks`
--

LOCK TABLES `field_revision_field_vdisk_write_blocks` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vdisk_write_blocks` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vdisk_write_blocks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vdisk_write_latency`
--

DROP TABLE IF EXISTS `field_revision_field_vdisk_write_latency`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vdisk_write_latency` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_write_latency_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 111 (field_vdisk_write...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vdisk_write_latency`
--

LOCK TABLES `field_revision_field_vdisk_write_latency` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vdisk_write_latency` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vdisk_write_latency` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vdisk_write_ops`
--

DROP TABLE IF EXISTS `field_revision_field_vdisk_write_ops`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vdisk_write_ops` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vdisk_write_ops_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 113 (field_vdisk_write...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vdisk_write_ops`
--

LOCK TABLES `field_revision_field_vdisk_write_ops` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vdisk_write_ops` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vdisk_write_ops` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vendor`
--

DROP TABLE IF EXISTS `field_revision_field_vendor`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vendor` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vendor_value` varchar(255) DEFAULT NULL,
  `field_vendor_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vendor_format` (`field_vendor_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 36 (field_vendor)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vendor`
--

LOCK TABLES `field_revision_field_vendor` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vendor` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vendor` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vib_version`
--

DROP TABLE IF EXISTS `field_revision_field_vib_version`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vib_version` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vib_version_value` varchar(255) DEFAULT NULL,
  `field_vib_version_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vib_version_format` (`field_vib_version_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 78 (field_vib_version)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vib_version`
--

LOCK TABLES `field_revision_field_vib_version` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vib_version` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vib_version` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_virtual_disks`
--

DROP TABLE IF EXISTS `field_revision_field_virtual_disks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_virtual_disks` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_virtual_disks_value` varchar(255) DEFAULT NULL,
  `field_virtual_disks_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_virtual_disks_format` (`field_virtual_disks_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 84 (field_virtual_disks)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_virtual_disks`
--

LOCK TABLES `field_revision_field_virtual_disks` WRITE;
/*!40000 ALTER TABLE `field_revision_field_virtual_disks` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_virtual_disks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_virtual_machine`
--

DROP TABLE IF EXISTS `field_revision_field_virtual_machine`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_virtual_machine` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_virtual_machine_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_virtual_machine_target_id` (`field_virtual_machine_target_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 63 (field_virtual...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_virtual_machine`
--

LOCK TABLES `field_revision_field_virtual_machine` WRITE;
/*!40000 ALTER TABLE `field_revision_field_virtual_machine` DISABLE KEYS */;
INSERT INTO `field_revision_field_virtual_machine` VALUES ('node','vdisk',0,11729,34660,'und',0,11728),('node','vdisk',0,14410,14410,'und',0,14405);
/*!40000 ALTER TABLE `field_revision_field_virtual_machine` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm`
--

DROP TABLE IF EXISTS `field_revision_field_vm`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vm_target_id` (`field_vm_target_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 69 (field_vm)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm`
--

LOCK TABLES `field_revision_field_vm` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm_cache_latency`
--

DROP TABLE IF EXISTS `field_revision_field_vm_cache_latency`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm_cache_latency` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_cache_latency_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 100 (field_vm_cache...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm_cache_latency`
--

LOCK TABLES `field_revision_field_vm_cache_latency` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm_cache_latency` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm_cache_latency` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm_cache_size`
--

DROP TABLE IF EXISTS `field_revision_field_vm_cache_size`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm_cache_size` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_cache_size_value` varchar(255) DEFAULT NULL,
  `field_vm_cache_size_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vm_cache_size_format` (`field_vm_cache_size_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 132 (field_vm_cache_size)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm_cache_size`
--

LOCK TABLES `field_revision_field_vm_cache_size` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm_cache_size` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm_cache_size` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm_hit_rate_pc`
--

DROP TABLE IF EXISTS `field_revision_field_vm_hit_rate_pc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm_hit_rate_pc` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_hit_rate_pc_value` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 172 (field_vm_hit_rate...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm_hit_rate_pc`
--

LOCK TABLES `field_revision_field_vm_hit_rate_pc` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm_hit_rate_pc` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm_hit_rate_pc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm_hits`
--

DROP TABLE IF EXISTS `field_revision_field_vm_hits`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm_hits` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_hits_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 98 (field_vm_hits)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm_hits`
--

LOCK TABLES `field_revision_field_vm_hits` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm_hits` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm_hits` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm_hostname`
--

DROP TABLE IF EXISTS `field_revision_field_vm_hostname`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm_hostname` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_hostname_value` varchar(255) DEFAULT NULL,
  `field_vm_hostname_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vm_hostname_format` (`field_vm_hostname_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 159 (field_vm_hostname)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm_hostname`
--

LOCK TABLES `field_revision_field_vm_hostname` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm_hostname` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm_hostname` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm_insertion_rate_pc`
--

DROP TABLE IF EXISTS `field_revision_field_vm_insertion_rate_pc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm_insertion_rate_pc` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_insertion_rate_pc_value` decimal(10,2) DEFAULT '0.00',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 108 (field_vm...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm_insertion_rate_pc`
--

LOCK TABLES `field_revision_field_vm_insertion_rate_pc` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm_insertion_rate_pc` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm_insertion_rate_pc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm_insertions`
--

DROP TABLE IF EXISTS `field_revision_field_vm_insertions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm_insertions` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_insertions_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 104 (field_vm_insertions)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm_insertions`
--

LOCK TABLES `field_revision_field_vm_insertions` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm_insertions` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm_insertions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm_ip_address`
--

DROP TABLE IF EXISTS `field_revision_field_vm_ip_address`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm_ip_address` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_ip_address_value` varchar(255) DEFAULT NULL,
  `field_vm_ip_address_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vm_ip_address_format` (`field_vm_ip_address_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 9 (field_vm_ip_address)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm_ip_address`
--

LOCK TABLES `field_revision_field_vm_ip_address` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm_ip_address` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm_ip_address` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm_password`
--

DROP TABLE IF EXISTS `field_revision_field_vm_password`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm_password` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_password_value` varchar(255) DEFAULT NULL,
  `field_vm_password_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vm_password_format` (`field_vm_password_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 57 (field_vm_password)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm_password`
--

LOCK TABLES `field_revision_field_vm_password` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm_password` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm_password` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm_path_name`
--

DROP TABLE IF EXISTS `field_revision_field_vm_path_name`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm_path_name` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_path_name_value` varchar(255) DEFAULT NULL,
  `field_vm_path_name_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vm_path_name_format` (`field_vm_path_name_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 14 (field_vm_path_name)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm_path_name`
--

LOCK TABLES `field_revision_field_vm_path_name` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm_path_name` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm_path_name` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm_population`
--

DROP TABLE IF EXISTS `field_revision_field_vm_population`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm_population` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_population_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 101 (field_vm_population)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm_population`
--

LOCK TABLES `field_revision_field_vm_population` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm_population` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm_population` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm_population_pc`
--

DROP TABLE IF EXISTS `field_revision_field_vm_population_pc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm_population_pc` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_population_pc_value` decimal(10,2) DEFAULT '0.00',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 107 (field_vm...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm_population_pc`
--

LOCK TABLES `field_revision_field_vm_population_pc` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm_population_pc` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm_population_pc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm_read_blocks`
--

DROP TABLE IF EXISTS `field_revision_field_vm_read_blocks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm_read_blocks` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_read_blocks_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 99 (field_vm_read_blocks)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm_read_blocks`
--

LOCK TABLES `field_revision_field_vm_read_blocks` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm_read_blocks` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm_read_blocks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm_read_latency`
--

DROP TABLE IF EXISTS `field_revision_field_vm_read_latency`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm_read_latency` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_read_latency_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 94 (field_vm_read...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm_read_latency`
--

LOCK TABLES `field_revision_field_vm_read_latency` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm_read_latency` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm_read_latency` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm_read_ops`
--

DROP TABLE IF EXISTS `field_revision_field_vm_read_ops`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm_read_ops` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_read_ops_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 96 (field_vm_read_ops)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm_read_ops`
--

LOCK TABLES `field_revision_field_vm_read_ops` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm_read_ops` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm_read_ops` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm_usable_blocks`
--

DROP TABLE IF EXISTS `field_revision_field_vm_usable_blocks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm_usable_blocks` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_usable_blocks_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 102 (field_vm_usable...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm_usable_blocks`
--

LOCK TABLES `field_revision_field_vm_usable_blocks` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm_usable_blocks` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm_usable_blocks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm_username`
--

DROP TABLE IF EXISTS `field_revision_field_vm_username`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm_username` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_username_value` varchar(255) DEFAULT NULL,
  `field_vm_username_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vm_username_format` (`field_vm_username_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 56 (field_vm_username)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm_username`
--

LOCK TABLES `field_revision_field_vm_username` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm_username` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm_username` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm_vmotion_hostlist`
--

DROP TABLE IF EXISTS `field_revision_field_vm_vmotion_hostlist`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm_vmotion_hostlist` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_vmotion_hostlist_value` varchar(1000) DEFAULT NULL,
  `field_vm_vmotion_hostlist_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vm_vmotion_hostlist_format` (`field_vm_vmotion_hostlist_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 171 (field_vm_vmotion...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm_vmotion_hostlist`
--

LOCK TABLES `field_revision_field_vm_vmotion_hostlist` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm_vmotion_hostlist` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm_vmotion_hostlist` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm_vmotion_policy`
--

DROP TABLE IF EXISTS `field_revision_field_vm_vmotion_policy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm_vmotion_policy` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_vmotion_policy_value` varchar(255) DEFAULT NULL,
  `field_vm_vmotion_policy_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vm_vmotion_policy_format` (`field_vm_vmotion_policy_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 170 (field_vm_vmotion...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm_vmotion_policy`
--

LOCK TABLES `field_revision_field_vm_vmotion_policy` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm_vmotion_policy` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm_vmotion_policy` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm_vmotionable`
--

DROP TABLE IF EXISTS `field_revision_field_vm_vmotionable`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm_vmotionable` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_vmotionable_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vm_vmotionable_value` (`field_vm_vmotionable_value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 145 (field_vm...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm_vmotionable`
--

LOCK TABLES `field_revision_field_vm_vmotionable` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm_vmotionable` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm_vmotionable` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm_write_blocks`
--

DROP TABLE IF EXISTS `field_revision_field_vm_write_blocks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm_write_blocks` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_write_blocks_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 103 (field_vm_write...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm_write_blocks`
--

LOCK TABLES `field_revision_field_vm_write_blocks` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm_write_blocks` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm_write_blocks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm_write_latency`
--

DROP TABLE IF EXISTS `field_revision_field_vm_write_latency`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm_write_latency` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_write_latency_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 95 (field_vm_write...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm_write_latency`
--

LOCK TABLES `field_revision_field_vm_write_latency` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm_write_latency` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm_write_latency` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vm_write_ops`
--

DROP TABLE IF EXISTS `field_revision_field_vm_write_ops`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vm_write_ops` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vm_write_ops_value` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 97 (field_vm_write_ops)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vm_write_ops`
--

LOCK TABLES `field_revision_field_vm_write_ops` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vm_write_ops` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vm_write_ops` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vmotion`
--

DROP TABLE IF EXISTS `field_revision_field_vmotion`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vmotion` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vmotion_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 26 (field_vmotion)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vmotion`
--

LOCK TABLES `field_revision_field_vmotion` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vmotion` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vmotion` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_vmware_tools`
--

DROP TABLE IF EXISTS `field_revision_field_vmware_tools`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vmware_tools` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vmware_tools_value` varchar(255) DEFAULT NULL,
  `field_vmware_tools_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_vmware_tools_format` (`field_vmware_tools_format`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 67 (field_vmware_tools)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vmware_tools`
--

LOCK TABLES `field_revision_field_vmware_tools` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vmware_tools` DISABLE KEYS */;
/*!40000 ALTER TABLE `field_revision_field_vmware_tools` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `file_managed`
--

DROP TABLE IF EXISTS `file_managed`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `file_managed` (
  `fid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'File ID.',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The users.uid of the user who is associated with the file.',
  `filename` varchar(255) NOT NULL DEFAULT '' COMMENT 'Name of the file with no path components. This may differ from the basename of the URI if the file is renamed to avoid overwriting an existing file.',
  `uri` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '' COMMENT 'The URI to access the file (either local or remote).',
  `filemime` varchar(255) NOT NULL DEFAULT '' COMMENT 'The file’s MIME type.',
  `filesize` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The size of the file in bytes.',
  `status` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A field indicating the status of the file. Two status are defined in core: temporary (0) and permanent (1). Temporary files older than DRUPAL_MAXIMUM_TEMP_FILE_AGE will be removed during a cron run.',
  `timestamp` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'UNIX timestamp for when the file was added.',
  PRIMARY KEY (`fid`),
  UNIQUE KEY `uri` (`uri`),
  KEY `uid` (`uid`),
  KEY `status` (`status`),
  KEY `timestamp` (`timestamp`)
) ENGINE=MyISAM AUTO_INCREMENT=244 DEFAULT CHARSET=utf8 COMMENT='Stores information for uploaded files.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `file_managed`
--

LOCK TABLES `file_managed` WRITE;
/*!40000 ALTER TABLE `file_managed` DISABLE KEYS */;
INSERT INTO `file_managed` VALUES (243,1,'NetApp_FlashAccel-Base-MC_1.2.0.20755599_all.deb_.gz','public://fmc_agents//NetApp_FlashAccel-Base-MC_1.2.0.20755599_all.deb_.gz','application/octet-stream',2901288,1,1371233948);
/*!40000 ALTER TABLE `file_managed` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `file_usage`
--

DROP TABLE IF EXISTS `file_usage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `file_usage` (
  `fid` int(10) unsigned NOT NULL COMMENT 'File ID.',
  `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the module that is using the file.',
  `type` varchar(64) NOT NULL DEFAULT '' COMMENT 'The name of the object type in which the file is used.',
  `id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The primary key of the object using the file.',
  `count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The number of times this file is used by this object.',
  PRIMARY KEY (`fid`,`type`,`id`,`module`),
  KEY `type_id` (`type`,`id`),
  KEY `fid_count` (`fid`,`count`),
  KEY `fid_module` (`fid`,`module`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Track where a file is used.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `file_usage`
--

LOCK TABLES `file_usage` WRITE;
/*!40000 ALTER TABLE `file_usage` DISABLE KEYS */;
/*!40000 ALTER TABLE `file_usage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `filter`
--

DROP TABLE IF EXISTS `filter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `filter` (
  `format` varchar(255) NOT NULL COMMENT 'Foreign key: The filter_format.format to which this filter is assigned.',
  `module` varchar(64) NOT NULL DEFAULT '' COMMENT 'The origin module of the filter.',
  `name` varchar(32) NOT NULL DEFAULT '' COMMENT 'Name of the filter being referenced.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Weight of filter within format.',
  `status` int(11) NOT NULL DEFAULT '0' COMMENT 'Filter enabled status. (1 = enabled, 0 = disabled)',
  `settings` longblob COMMENT 'A serialized array of name value pairs that store the filter settings for the specific format.',
  PRIMARY KEY (`format`,`name`),
  KEY `list` (`weight`,`module`,`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Table that maps filters (HTML corrector) to text formats ...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `filter`
--

LOCK TABLES `filter` WRITE;
/*!40000 ALTER TABLE `filter` DISABLE KEYS */;
INSERT INTO `filter` VALUES ('filtered_html','filter','filter_autop',2,1,'a:0:{}'),('filtered_html','filter','filter_html',1,1,'a:3:{s:12:\"allowed_html\";s:74:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}'),('filtered_html','filter','filter_htmlcorrector',10,1,'a:0:{}'),('filtered_html','filter','filter_html_escape',-10,0,'a:0:{}'),('filtered_html','filter','filter_url',0,1,'a:1:{s:17:\"filter_url_length\";i:72;}'),('full_html','filter','filter_autop',1,1,'a:0:{}'),('full_html','filter','filter_html',-10,0,'a:3:{s:12:\"allowed_html\";s:74:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}'),('full_html','filter','filter_htmlcorrector',10,1,'a:0:{}'),('full_html','filter','filter_html_escape',-10,0,'a:0:{}'),('full_html','filter','filter_url',0,1,'a:1:{s:17:\"filter_url_length\";i:72;}'),('php_code','filter','filter_autop',0,0,'a:0:{}'),('php_code','filter','filter_html',-10,0,'a:3:{s:12:\"allowed_html\";s:74:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}'),('php_code','filter','filter_htmlcorrector',10,0,'a:0:{}'),('php_code','filter','filter_html_escape',-10,0,'a:0:{}'),('php_code','filter','filter_url',0,0,'a:1:{s:17:\"filter_url_length\";i:72;}'),('php_code','php','php_code',0,1,'a:0:{}'),('plain_text','filter','filter_autop',2,1,'a:0:{}'),('plain_text','filter','filter_html',-10,0,'a:3:{s:12:\"allowed_html\";s:74:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}'),('plain_text','filter','filter_htmlcorrector',10,0,'a:0:{}'),('plain_text','filter','filter_html_escape',0,1,'a:0:{}'),('plain_text','filter','filter_url',1,1,'a:1:{s:17:\"filter_url_length\";i:72;}');
/*!40000 ALTER TABLE `filter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `filter_format`
--

DROP TABLE IF EXISTS `filter_format`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `filter_format` (
  `format` varchar(255) NOT NULL COMMENT 'Primary Key: Unique machine name of the format.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'Name of the text format (Filtered HTML).',
  `cache` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Flag to indicate whether format is cacheable. (1 = cacheable, 0 = not cacheable)',
  `status` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT 'The status of the text format. (1 = enabled, 0 = disabled)',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Weight of text format to use when listing.',
  PRIMARY KEY (`format`),
  UNIQUE KEY `name` (`name`),
  KEY `status_weight` (`status`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores text formats: custom groupings of filters, such as...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `filter_format`
--

LOCK TABLES `filter_format` WRITE;
/*!40000 ALTER TABLE `filter_format` DISABLE KEYS */;
INSERT INTO `filter_format` VALUES ('filtered_html','Filtered HTML',1,1,0),('full_html','Full HTML',1,1,1),('php_code','PHP code',0,1,11),('plain_text','Plain text',1,1,10);
/*!40000 ALTER TABLE `filter_format` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `flood`
--

DROP TABLE IF EXISTS `flood`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `flood` (
  `fid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Unique flood event ID.',
  `event` varchar(64) NOT NULL DEFAULT '' COMMENT 'Name of event (e.g. contact).',
  `identifier` varchar(128) NOT NULL DEFAULT '' COMMENT 'Identifier of the visitor, such as an IP address or hostname.',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp of the event.',
  `expiration` int(11) NOT NULL DEFAULT '0' COMMENT 'Expiration timestamp. Expired events are purged on cron run.',
  PRIMARY KEY (`fid`),
  KEY `allow` (`event`,`identifier`,`timestamp`),
  KEY `purge` (`expiration`)
) ENGINE=MyISAM AUTO_INCREMENT=138 DEFAULT CHARSET=utf8 COMMENT='Flood controls the threshold of events, such as the...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `flood`
--

LOCK TABLES `flood` WRITE;
/*!40000 ALTER TABLE `flood` DISABLE KEYS */;
/*!40000 ALTER TABLE `flood` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fuzzysearch_default_fuzzysearch_index_author`
--

DROP TABLE IF EXISTS `fuzzysearch_default_fuzzysearch_index_author`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fuzzysearch_default_fuzzysearch_index_author` (
  `item_id` int(11) NOT NULL COMMENT 'The primary identifier of the entity.',
  `value` int(11) DEFAULT NULL COMMENT 'The field’s value for this item.',
  PRIMARY KEY (`item_id`),
  KEY `value` (`value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fuzzysearch_default_fuzzysearch_index_author`
--

LOCK TABLES `fuzzysearch_default_fuzzysearch_index_author` WRITE;
/*!40000 ALTER TABLE `fuzzysearch_default_fuzzysearch_index_author` DISABLE KEYS */;
INSERT INTO `fuzzysearch_default_fuzzysearch_index_author` VALUES (1,1),(2,9),(3,9),(4,9),(5,9),(6,9),(7,9),(8,9),(9,9),(10,9),(11,9),(12,9),(13,9),(14,9),(15,9),(16,9),(17,9),(18,9),(19,9),(20,9),(21,9),(22,9),(23,9),(24,9),(25,9),(26,9),(27,9),(28,9),(29,9),(30,9),(31,9),(32,9),(33,9),(34,9),(35,9),(36,9),(37,9),(38,9),(39,9),(40,9),(41,9),(42,9),(43,9),(44,9),(45,9),(46,9),(47,9),(48,9),(49,9),(50,9),(51,9),(52,9),(53,9),(54,9),(55,9),(56,9),(57,9),(58,9),(59,9),(60,9),(61,9),(62,9),(63,9),(64,9),(65,9),(66,9),(67,9),(68,9),(69,9),(70,9),(71,9),(72,9),(73,9),(74,9),(75,9),(76,9),(77,9),(78,9),(79,9),(80,9),(81,9),(82,9),(83,9),(84,9),(85,9),(86,9),(87,9),(88,9),(89,9),(90,9),(91,9),(92,9),(93,9),(94,9),(95,9),(96,9),(97,9),(98,9),(99,9),(100,9),(101,9),(102,9),(103,9),(104,9),(105,9),(106,9),(107,9),(108,9),(109,9),(110,9),(111,9),(112,9),(113,9),(114,9),(115,9),(116,9),(117,9),(118,9),(119,9),(120,9),(121,9),(122,9),(123,9),(124,9),(125,9),(126,9),(127,9),(128,9),(129,9),(130,9),(131,9),(132,9),(133,9),(134,9),(135,9),(136,9),(137,9),(138,9),(139,9),(140,9),(141,9),(142,9),(143,9),(144,9),(145,9),(146,9),(147,9),(148,9),(149,9),(150,9),(151,9),(152,9),(153,9),(154,9),(155,9),(156,9),(157,9),(158,9),(159,9),(160,9),(161,9),(162,9),(163,9),(164,9),(165,9),(166,9),(167,9),(168,9),(169,9),(170,9),(171,9),(172,9),(173,9),(174,9),(175,9),(176,9),(177,9),(178,9),(179,9),(180,9),(181,9),(182,9),(183,9),(184,9),(185,9),(186,9),(187,9),(188,9),(189,9),(190,9),(191,9),(192,9),(193,9),(194,9),(195,9),(196,9),(197,9),(198,9),(199,9),(200,9),(201,9),(202,9),(203,9),(204,9),(205,9),(206,9),(207,9),(208,9),(209,9),(210,9),(211,9),(212,9),(213,9),(214,9),(215,9),(216,9),(217,9),(218,9),(219,9),(220,9),(221,9),(222,9),(223,9),(224,9),(225,9),(226,9),(227,9),(228,9),(229,9),(230,9),(231,9),(232,9),(233,9),(234,9),(235,9),(236,9),(237,9),(238,9),(239,9),(240,9),(241,9),(242,9),(243,9),(244,9),(245,9),(246,9),(247,9),(248,9),(249,9),(250,9),(251,9),(252,9),(253,9),(254,9),(255,9),(256,9),(257,9),(258,9),(259,9),(260,9),(261,9),(262,9),(263,9),(264,9),(265,9),(266,9),(267,9),(268,9),(269,9),(270,9),(271,9),(272,9),(273,9),(274,9),(275,9),(276,9),(277,9),(278,9),(279,9),(280,9),(281,9),(282,9),(283,9),(284,9),(285,9),(286,9),(287,9),(288,9),(289,9),(290,9),(291,9),(292,9),(293,9),(294,9),(295,9),(296,9),(297,9),(298,9),(299,9),(300,9),(301,9),(302,9),(303,9),(304,9),(305,9),(306,9),(307,9),(308,9),(309,9),(310,9),(311,9),(312,9),(313,9),(314,9),(315,9),(316,9),(317,9),(318,9),(319,9),(320,9),(321,9),(322,9),(323,9),(324,9),(325,9),(326,9),(327,9),(328,9),(329,9),(330,9),(331,9),(332,9),(333,9),(334,9),(335,9),(336,9),(337,9),(338,9),(339,9),(340,9),(341,9),(342,9),(343,9),(344,9),(345,9),(346,9),(347,9),(348,9),(349,9),(350,9),(351,9),(352,9),(353,9),(354,9),(355,9),(356,9),(357,9),(358,9),(359,9),(360,9),(361,9),(362,9),(363,9),(364,9),(365,9),(366,9),(367,9),(368,9),(369,9),(370,9),(371,9),(372,9),(373,9),(374,9),(375,9),(376,9),(377,9),(378,9),(379,9),(380,9),(381,9),(382,9),(383,9),(384,9),(385,9),(386,9),(387,9),(388,9),(389,9),(390,9),(391,9),(392,9),(393,9),(394,9),(395,9),(396,9),(397,9),(398,9),(399,9),(400,9),(401,9),(402,9),(403,9),(404,9),(405,9),(406,9),(407,9),(408,9),(409,9),(410,9),(411,9),(412,9),(413,9),(414,9),(415,9),(416,9),(417,9),(418,9),(419,9),(420,9),(421,9),(422,9),(423,9),(424,9),(425,9),(426,9),(427,9),(428,9),(429,9),(430,9),(431,9),(432,9),(433,9),(434,9),(435,9),(436,9),(437,9),(438,9),(439,9),(440,9),(441,9),(442,9),(443,9),(444,9),(445,9),(446,9),(447,9),(448,9),(449,9),(450,9),(451,9),(452,9),(453,9),(454,9),(455,9),(456,9),(457,9),(458,9),(459,9),(460,9),(461,9),(462,9),(463,9),(464,9),(465,9),(466,9),(467,9),(468,9),(469,9),(470,9),(471,9),(472,9),(473,9),(474,9),(475,9),(476,9),(477,9),(478,9),(479,9),(480,9),(481,9),(482,9),(483,9),(484,9),(485,9),(486,9),(487,9),(488,9),(489,9),(490,9),(491,9),(492,9),(493,9),(494,9),(495,9),(496,9),(497,9),(498,9),(499,9),(500,9),(501,9),(502,9),(503,9),(504,9),(505,9),(506,9),(507,9),(508,9),(509,9),(510,9),(511,9),(512,9),(513,9),(514,9),(515,9),(516,9),(517,9),(518,9),(519,9),(520,9),(521,9),(522,9),(523,9),(524,9),(525,9),(526,9),(527,9),(528,9),(529,9),(530,9),(531,9),(532,9),(533,9),(534,9),(535,9),(536,9),(537,9),(538,9),(539,9),(540,9),(541,9),(542,9),(543,9),(544,9),(545,9),(546,9),(547,9),(548,9),(549,9),(550,9),(551,9),(552,9),(553,9),(554,9),(555,9),(556,9),(557,9),(558,9),(559,9),(560,9),(561,9),(562,9),(563,9),(564,9),(565,9),(566,9),(567,9),(568,9),(569,9),(570,9),(571,9),(572,9),(573,9),(574,9),(575,9),(576,9),(577,9),(578,9),(579,9),(580,9),(581,9),(582,9),(583,9),(584,9),(585,9),(586,9),(587,9),(588,9),(589,9),(590,9),(591,9),(592,9),(593,9),(594,9),(595,9),(596,9),(597,9),(598,9),(599,9),(600,9),(601,9),(602,9),(603,9),(604,9),(605,9),(606,9),(607,9),(608,9),(609,9),(610,9),(611,9),(612,9),(613,9),(614,9),(615,9),(616,9),(617,9),(618,9),(619,9),(620,9),(621,9),(622,9),(623,9),(624,9),(625,9),(626,9),(627,9),(628,9),(629,9),(630,9),(631,9),(632,9),(633,9),(634,9),(635,9),(636,9),(637,9),(638,9),(639,9),(640,9),(641,9),(642,9),(643,9),(644,9),(645,9),(646,9),(647,9),(648,9),(649,9),(650,9),(651,9),(652,9),(653,9),(654,9),(655,9),(656,9),(657,9),(658,9),(659,9),(660,9),(661,9),(662,9),(663,9),(664,9),(665,9),(666,9),(667,9),(668,9),(669,9),(670,9),(671,9),(672,9),(673,9),(674,9),(675,9),(676,9),(677,9),(678,9),(679,9),(680,9),(681,9),(682,9),(683,9),(684,9),(685,9),(686,9),(687,9),(688,9),(689,9),(690,9),(691,9),(692,9),(693,9),(694,9),(695,9),(696,9),(697,9),(698,9),(699,9),(700,9),(701,9),(702,9),(703,9),(704,9),(705,9),(706,9),(707,9),(708,9),(709,9),(710,9),(711,9),(712,9),(713,9),(714,9),(715,9),(716,9),(717,9),(718,9),(719,9),(720,9),(721,9),(722,9),(723,9),(724,9),(725,9),(726,9),(727,9),(728,9),(729,9),(730,9),(731,9),(732,9),(733,9),(734,9),(735,9),(736,9),(737,9),(738,9),(739,9),(740,9),(741,9),(742,9),(743,9),(744,9),(745,9),(746,9),(747,9),(748,9),(749,9),(750,9),(751,9),(752,9),(753,9),(754,9),(755,9),(756,9),(757,9),(758,9),(759,9),(760,9),(761,9),(762,9),(763,9),(764,9),(765,9),(766,9),(767,9),(768,9),(769,9),(770,9),(771,9),(772,9),(773,9),(774,9),(775,9),(776,9),(777,9),(778,9),(779,9),(780,9),(781,9),(782,9),(783,9),(784,9),(785,9),(786,9),(787,9),(788,9),(789,9),(790,9),(791,9),(792,9),(793,9),(794,9),(795,9),(796,9),(797,9),(798,9),(799,9),(800,9),(801,9),(802,9),(803,9),(804,9),(805,9),(806,9),(807,9),(808,9),(809,9),(810,9),(811,9),(812,9),(813,9),(814,9),(815,9),(816,9),(817,9),(818,9),(819,9),(820,9),(821,9),(822,9),(823,9),(824,9),(825,9),(826,9),(827,9),(828,9),(829,9),(830,9),(831,9),(832,9),(833,9),(834,9),(835,9),(836,9),(837,9),(838,9),(839,9),(840,9),(841,9),(842,9),(843,9),(844,9),(845,9),(846,9),(847,9),(848,9),(849,9),(850,9),(851,9),(852,9),(853,9),(854,9),(855,9),(856,9),(857,9),(858,9),(859,9),(860,9),(861,9),(862,9),(863,9),(864,9),(865,9),(866,9),(867,9),(868,9),(869,9),(870,9),(871,9),(872,9),(873,9),(874,9),(875,9),(876,9),(877,9),(878,9),(879,9),(880,9),(881,9),(882,9),(883,9),(884,9),(885,9),(886,9),(887,9),(888,9),(889,9),(890,9),(891,9),(892,9),(893,9),(894,9),(895,9),(896,9),(897,9),(898,9),(899,9),(900,9),(901,9),(902,9),(903,9),(904,9),(905,9),(906,9),(907,9),(908,9),(909,9),(910,9),(911,9),(912,9),(913,9),(914,9),(915,9),(916,9),(917,9),(918,9),(919,9),(920,9),(921,9),(922,9),(923,9),(924,9),(925,9),(926,9),(927,9),(928,9),(929,9),(930,9),(931,9),(932,9),(933,9),(934,9),(935,9),(936,9),(937,9),(938,9),(939,9),(940,9),(941,9),(942,9),(943,9),(944,9),(945,9),(946,9),(947,9),(948,9),(949,9),(950,9),(951,9),(952,9),(953,9),(954,9),(955,9),(956,9),(957,9),(958,9),(959,9),(960,9),(961,9),(962,9),(963,9),(964,9),(965,9),(966,9),(967,9),(968,9),(969,9),(970,9),(971,9),(972,9),(973,9),(974,9),(975,9),(976,9),(977,9),(978,9),(979,9),(980,9),(981,9),(982,9),(983,9),(984,9),(985,9),(986,9),(987,9),(988,9),(989,9),(990,9),(991,9),(992,9),(993,9),(994,9),(995,9),(996,9),(997,9),(998,9),(999,9),(1000,9),(1001,9),(1002,9),(1003,9),(1004,9),(1005,9),(1006,9),(1007,9),(1008,9),(1009,9),(1010,9),(1011,9),(1012,9),(1013,9),(1014,9),(1015,9),(1016,9),(1017,9),(1018,9),(1019,9),(1020,9),(1021,9),(1022,9),(1023,9),(1024,9),(1025,9),(1026,9),(1027,9),(1028,9),(1029,9),(1030,9),(1031,9),(1032,9),(1033,9),(1034,9),(1035,9),(1036,9),(1037,9),(1038,9),(1039,9),(1040,9),(1041,9),(1042,9),(1043,9),(1044,9),(1045,9),(1046,9),(1047,9),(1048,9),(1049,9),(1050,9),(1051,9),(1052,9),(1053,9),(1054,9),(1055,9),(1056,9),(1057,9),(1058,9),(1059,9),(1060,9),(1061,9),(1062,9),(1063,9),(1064,9),(1065,9),(1066,9),(1067,9),(1068,9),(1069,9),(1070,9),(1071,9),(1072,9),(1073,9),(1074,9),(1075,9),(1076,9),(1077,9),(1078,9),(1079,9),(1080,9),(1081,9),(1082,9),(1083,9),(1084,9),(1085,9),(1086,9),(1087,9),(1088,9),(1089,9),(1090,9),(1091,9),(1092,9),(1093,9),(1094,9),(1095,9),(1096,9),(1097,9),(1098,9),(1099,9),(1100,9),(1101,9),(1102,9),(1103,9),(1104,9),(1105,9),(1106,9),(1107,9),(1108,9),(1109,9),(1110,9),(1111,9),(1112,9),(1113,9),(1114,9),(1115,9),(1116,9),(1117,9),(1118,9),(1119,9),(1120,9),(1121,9),(1122,9);
/*!40000 ALTER TABLE `fuzzysearch_default_fuzzysearch_index_author` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fuzzysearch_default_fuzzysearch_index_search_api_access_node`
--

DROP TABLE IF EXISTS `fuzzysearch_default_fuzzysearch_index_search_api_access_node`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fuzzysearch_default_fuzzysearch_index_search_api_access_node` (
  `item_id` int(11) NOT NULL COMMENT 'The primary identifier of the entity.',
  `value` varchar(255) NOT NULL COMMENT 'The field’s value for this item.',
  PRIMARY KEY (`item_id`,`value`),
  KEY `value` (`value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fuzzysearch_default_fuzzysearch_index_search_api_access_node`
--

LOCK TABLES `fuzzysearch_default_fuzzysearch_index_search_api_access_node` WRITE;
/*!40000 ALTER TABLE `fuzzysearch_default_fuzzysearch_index_search_api_access_node` DISABLE KEYS */;
INSERT INTO `fuzzysearch_default_fuzzysearch_index_search_api_access_node` VALUES (1,'node_access_all:0'),(2,'node_access_all:0'),(3,'node_access_all:0'),(4,'node_access_all:0'),(5,'node_access_all:0'),(6,'node_access_all:0'),(7,'node_access_all:0'),(8,'node_access_all:0'),(9,'node_access_all:0'),(10,'node_access_all:0'),(11,'node_access_all:0'),(12,'node_access_all:0'),(13,'node_access_all:0'),(14,'node_access_all:0'),(15,'node_access_all:0'),(16,'node_access_all:0'),(17,'node_access_all:0'),(18,'node_access_all:0'),(19,'node_access_all:0'),(20,'node_access_all:0'),(21,'node_access_all:0'),(22,'node_access_all:0'),(23,'node_access_all:0'),(24,'node_access_all:0'),(25,'node_access_all:0'),(26,'node_access_all:0'),(27,'node_access_all:0'),(28,'node_access_all:0'),(29,'node_access_all:0'),(30,'node_access_all:0'),(31,'node_access_all:0'),(32,'node_access_all:0'),(33,'node_access_all:0'),(34,'node_access_all:0'),(35,'node_access_all:0'),(36,'node_access_all:0'),(37,'node_access_all:0'),(38,'node_access_all:0'),(39,'node_access_all:0'),(40,'node_access_all:0'),(41,'node_access_all:0'),(42,'node_access_all:0'),(43,'node_access_all:0'),(44,'node_access_all:0'),(45,'node_access_all:0'),(46,'node_access_all:0'),(47,'node_access_all:0'),(48,'node_access_all:0'),(49,'node_access_all:0'),(50,'node_access_all:0'),(51,'node_access_all:0'),(52,'node_access_all:0'),(53,'node_access_all:0'),(54,'node_access_all:0'),(55,'node_access_all:0'),(56,'node_access_all:0'),(57,'node_access_all:0'),(58,'node_access_all:0'),(59,'node_access_all:0'),(60,'node_access_all:0'),(61,'node_access_all:0'),(62,'node_access_all:0'),(63,'node_access_all:0'),(64,'node_access_all:0'),(65,'node_access_all:0'),(66,'node_access_all:0'),(67,'node_access_all:0'),(68,'node_access_all:0'),(69,'node_access_all:0'),(70,'node_access_all:0'),(71,'node_access_all:0'),(72,'node_access_all:0'),(73,'node_access_all:0'),(74,'node_access_all:0'),(75,'node_access_all:0'),(76,'node_access_all:0'),(77,'node_access_all:0'),(78,'node_access_all:0'),(79,'node_access_all:0'),(80,'node_access_all:0'),(81,'node_access_all:0'),(82,'node_access_all:0'),(83,'node_access_all:0'),(84,'node_access_all:0'),(85,'node_access_all:0'),(86,'node_access_all:0'),(87,'node_access_all:0'),(88,'node_access_all:0'),(89,'node_access_all:0'),(90,'node_access_all:0'),(91,'node_access_all:0'),(92,'node_access_all:0'),(93,'node_access_all:0'),(94,'node_access_all:0'),(95,'node_access_all:0'),(96,'node_access_all:0'),(97,'node_access_all:0'),(98,'node_access_all:0'),(99,'node_access_all:0'),(100,'node_access_all:0'),(101,'node_access_all:0'),(102,'node_access_all:0'),(103,'node_access_all:0'),(104,'node_access_all:0'),(105,'node_access_all:0'),(106,'node_access_all:0'),(107,'node_access_all:0'),(108,'node_access_all:0'),(109,'node_access_all:0'),(110,'node_access_all:0'),(111,'node_access_all:0'),(112,'node_access_all:0'),(113,'node_access_all:0'),(114,'node_access_all:0'),(115,'node_access_all:0'),(116,'node_access_all:0'),(117,'node_access_all:0'),(118,'node_access_all:0'),(119,'node_access_all:0'),(120,'node_access_all:0'),(121,'node_access_all:0'),(122,'node_access_all:0'),(123,'node_access_all:0'),(124,'node_access_all:0'),(125,'node_access_all:0'),(126,'node_access_all:0'),(127,'node_access_all:0'),(128,'node_access_all:0'),(129,'node_access_all:0'),(130,'node_access_all:0'),(131,'node_access_all:0'),(132,'node_access_all:0'),(133,'node_access_all:0'),(134,'node_access_all:0'),(135,'node_access_all:0'),(136,'node_access_all:0'),(137,'node_access_all:0'),(138,'node_access_all:0'),(139,'node_access_all:0'),(140,'node_access_all:0'),(141,'node_access_all:0'),(142,'node_access_all:0'),(143,'node_access_all:0'),(144,'node_access_all:0'),(145,'node_access_all:0'),(146,'node_access_all:0'),(147,'node_access_all:0'),(148,'node_access_all:0'),(149,'node_access_all:0'),(150,'node_access_all:0'),(151,'node_access_all:0'),(152,'node_access_all:0'),(153,'node_access_all:0'),(154,'node_access_all:0'),(155,'node_access_all:0'),(156,'node_access_all:0'),(157,'node_access_all:0'),(158,'node_access_all:0'),(159,'node_access_all:0'),(160,'node_access_all:0'),(161,'node_access_all:0'),(162,'node_access_all:0'),(163,'node_access_all:0'),(164,'node_access_all:0'),(165,'node_access_all:0'),(166,'node_access_all:0'),(167,'node_access_all:0'),(168,'node_access_all:0'),(169,'node_access_all:0'),(170,'node_access_all:0'),(171,'node_access_all:0'),(172,'node_access_all:0'),(173,'node_access_all:0'),(174,'node_access_all:0'),(175,'node_access_all:0'),(176,'node_access_all:0'),(177,'node_access_all:0'),(178,'node_access_all:0'),(179,'node_access_all:0'),(180,'node_access_all:0'),(181,'node_access_all:0'),(182,'node_access_all:0'),(183,'node_access_all:0'),(184,'node_access_all:0'),(185,'node_access_all:0'),(186,'node_access_all:0'),(187,'node_access_all:0'),(188,'node_access_all:0'),(189,'node_access_all:0'),(190,'node_access_all:0'),(191,'node_access_all:0'),(192,'node_access_all:0'),(193,'node_access_all:0'),(194,'node_access_all:0'),(195,'node_access_all:0'),(196,'node_access_all:0'),(197,'node_access_all:0'),(198,'node_access_all:0'),(199,'node_access_all:0'),(200,'node_access_all:0'),(201,'node_access_all:0'),(202,'node_access_all:0'),(203,'node_access_all:0'),(204,'node_access_all:0'),(205,'node_access_all:0'),(206,'node_access_all:0'),(207,'node_access_all:0'),(208,'node_access_all:0'),(209,'node_access_all:0'),(210,'node_access_all:0'),(211,'node_access_all:0'),(212,'node_access_all:0'),(213,'node_access_all:0'),(214,'node_access_all:0'),(215,'node_access_all:0'),(216,'node_access_all:0'),(217,'node_access_all:0'),(218,'node_access_all:0'),(219,'node_access_all:0'),(220,'node_access_all:0'),(221,'node_access_all:0'),(222,'node_access_all:0'),(223,'node_access_all:0'),(224,'node_access_all:0'),(225,'node_access_all:0'),(226,'node_access_all:0'),(227,'node_access_all:0'),(228,'node_access_all:0'),(229,'node_access_all:0'),(230,'node_access_all:0'),(231,'node_access_all:0'),(232,'node_access_all:0'),(233,'node_access_all:0'),(234,'node_access_all:0'),(235,'node_access_all:0'),(236,'node_access_all:0'),(237,'node_access_all:0'),(238,'node_access_all:0'),(239,'node_access_all:0'),(240,'node_access_all:0'),(241,'node_access_all:0'),(242,'node_access_all:0'),(243,'node_access_all:0'),(244,'node_access_all:0'),(245,'node_access_all:0'),(246,'node_access_all:0'),(247,'node_access_all:0'),(248,'node_access_all:0'),(249,'node_access_all:0'),(250,'node_access_all:0'),(251,'node_access_all:0'),(252,'node_access_all:0'),(253,'node_access_all:0'),(254,'node_access_all:0'),(255,'node_access_all:0'),(256,'node_access_all:0'),(257,'node_access_all:0'),(258,'node_access_all:0'),(259,'node_access_all:0'),(260,'node_access_all:0'),(261,'node_access_all:0'),(262,'node_access_all:0'),(263,'node_access_all:0'),(264,'node_access_all:0'),(265,'node_access_all:0'),(266,'node_access_all:0'),(267,'node_access_all:0'),(268,'node_access_all:0'),(269,'node_access_all:0'),(270,'node_access_all:0'),(271,'node_access_all:0'),(272,'node_access_all:0'),(273,'node_access_all:0'),(274,'node_access_all:0'),(275,'node_access_all:0'),(276,'node_access_all:0'),(277,'node_access_all:0'),(278,'node_access_all:0'),(279,'node_access_all:0'),(280,'node_access_all:0'),(281,'node_access_all:0'),(282,'node_access_all:0'),(283,'node_access_all:0'),(284,'node_access_all:0'),(285,'node_access_all:0'),(286,'node_access_all:0'),(287,'node_access_all:0'),(288,'node_access_all:0'),(289,'node_access_all:0'),(290,'node_access_all:0'),(291,'node_access_all:0'),(292,'node_access_all:0'),(293,'node_access_all:0'),(294,'node_access_all:0'),(295,'node_access_all:0'),(296,'node_access_all:0'),(297,'node_access_all:0'),(298,'node_access_all:0'),(299,'node_access_all:0'),(300,'node_access_all:0'),(301,'node_access_all:0'),(302,'node_access_all:0'),(303,'node_access_all:0'),(304,'node_access_all:0'),(305,'node_access_all:0'),(306,'node_access_all:0'),(307,'node_access_all:0'),(308,'node_access_all:0'),(309,'node_access_all:0'),(310,'node_access_all:0'),(311,'node_access_all:0'),(312,'node_access_all:0'),(313,'node_access_all:0'),(314,'node_access_all:0'),(315,'node_access_all:0'),(316,'node_access_all:0'),(317,'node_access_all:0'),(318,'node_access_all:0'),(319,'node_access_all:0'),(320,'node_access_all:0'),(321,'node_access_all:0'),(322,'node_access_all:0'),(323,'node_access_all:0'),(324,'node_access_all:0'),(325,'node_access_all:0'),(326,'node_access_all:0'),(327,'node_access_all:0'),(328,'node_access_all:0'),(329,'node_access_all:0'),(330,'node_access_all:0'),(331,'node_access_all:0'),(332,'node_access_all:0'),(333,'node_access_all:0'),(334,'node_access_all:0'),(335,'node_access_all:0'),(336,'node_access_all:0'),(337,'node_access_all:0'),(338,'node_access_all:0'),(339,'node_access_all:0'),(340,'node_access_all:0'),(341,'node_access_all:0'),(342,'node_access_all:0'),(343,'node_access_all:0'),(344,'node_access_all:0'),(345,'node_access_all:0'),(346,'node_access_all:0'),(347,'node_access_all:0'),(348,'node_access_all:0'),(349,'node_access_all:0'),(350,'node_access_all:0'),(351,'node_access_all:0'),(352,'node_access_all:0'),(353,'node_access_all:0'),(354,'node_access_all:0'),(355,'node_access_all:0'),(356,'node_access_all:0'),(357,'node_access_all:0'),(358,'node_access_all:0'),(359,'node_access_all:0'),(360,'node_access_all:0'),(361,'node_access_all:0'),(362,'node_access_all:0'),(363,'node_access_all:0'),(364,'node_access_all:0'),(365,'node_access_all:0'),(366,'node_access_all:0'),(367,'node_access_all:0'),(368,'node_access_all:0'),(369,'node_access_all:0'),(370,'node_access_all:0'),(371,'node_access_all:0'),(372,'node_access_all:0'),(373,'node_access_all:0'),(374,'node_access_all:0'),(375,'node_access_all:0'),(376,'node_access_all:0'),(377,'node_access_all:0'),(378,'node_access_all:0'),(379,'node_access_all:0'),(380,'node_access_all:0'),(381,'node_access_all:0'),(382,'node_access_all:0'),(383,'node_access_all:0'),(384,'node_access_all:0'),(385,'node_access_all:0'),(386,'node_access_all:0'),(387,'node_access_all:0'),(388,'node_access_all:0'),(389,'node_access_all:0'),(390,'node_access_all:0'),(391,'node_access_all:0'),(392,'node_access_all:0'),(393,'node_access_all:0'),(394,'node_access_all:0'),(395,'node_access_all:0'),(396,'node_access_all:0'),(397,'node_access_all:0'),(398,'node_access_all:0'),(399,'node_access_all:0'),(400,'node_access_all:0'),(401,'node_access_all:0'),(402,'node_access_all:0'),(403,'node_access_all:0'),(404,'node_access_all:0'),(405,'node_access_all:0'),(406,'node_access_all:0'),(407,'node_access_all:0'),(408,'node_access_all:0'),(409,'node_access_all:0'),(410,'node_access_all:0'),(411,'node_access_all:0'),(412,'node_access_all:0'),(413,'node_access_all:0'),(414,'node_access_all:0'),(415,'node_access_all:0'),(416,'node_access_all:0'),(417,'node_access_all:0'),(418,'node_access_all:0'),(419,'node_access_all:0'),(420,'node_access_all:0'),(421,'node_access_all:0'),(422,'node_access_all:0'),(423,'node_access_all:0'),(424,'node_access_all:0'),(425,'node_access_all:0'),(426,'node_access_all:0'),(427,'node_access_all:0'),(428,'node_access_all:0'),(429,'node_access_all:0'),(430,'node_access_all:0'),(431,'node_access_all:0'),(432,'node_access_all:0'),(433,'node_access_all:0'),(434,'node_access_all:0'),(435,'node_access_all:0'),(436,'node_access_all:0'),(437,'node_access_all:0'),(438,'node_access_all:0'),(439,'node_access_all:0'),(440,'node_access_all:0'),(441,'node_access_all:0'),(442,'node_access_all:0'),(443,'node_access_all:0'),(444,'node_access_all:0'),(445,'node_access_all:0'),(446,'node_access_all:0'),(447,'node_access_all:0'),(448,'node_access_all:0'),(449,'node_access_all:0'),(450,'node_access_all:0'),(451,'node_access_all:0'),(452,'node_access_all:0'),(453,'node_access_all:0'),(454,'node_access_all:0'),(455,'node_access_all:0'),(456,'node_access_all:0'),(457,'node_access_all:0'),(458,'node_access_all:0'),(459,'node_access_all:0'),(460,'node_access_all:0'),(461,'node_access_all:0'),(462,'node_access_all:0'),(463,'node_access_all:0'),(464,'node_access_all:0'),(465,'node_access_all:0'),(466,'node_access_all:0'),(467,'node_access_all:0'),(468,'node_access_all:0'),(469,'node_access_all:0'),(470,'node_access_all:0'),(471,'node_access_all:0'),(472,'node_access_all:0'),(473,'node_access_all:0'),(474,'node_access_all:0'),(475,'node_access_all:0'),(476,'node_access_all:0'),(477,'node_access_all:0'),(478,'node_access_all:0'),(479,'node_access_all:0'),(480,'node_access_all:0'),(481,'node_access_all:0'),(482,'node_access_all:0'),(483,'node_access_all:0'),(484,'node_access_all:0'),(485,'node_access_all:0'),(486,'node_access_all:0'),(487,'node_access_all:0'),(488,'node_access_all:0'),(489,'node_access_all:0'),(490,'node_access_all:0'),(491,'node_access_all:0'),(492,'node_access_all:0'),(493,'node_access_all:0'),(494,'node_access_all:0'),(495,'node_access_all:0'),(496,'node_access_all:0'),(497,'node_access_all:0'),(498,'node_access_all:0'),(499,'node_access_all:0'),(500,'node_access_all:0'),(501,'node_access_all:0'),(502,'node_access_all:0'),(503,'node_access_all:0'),(504,'node_access_all:0'),(505,'node_access_all:0'),(506,'node_access_all:0'),(507,'node_access_all:0'),(508,'node_access_all:0'),(509,'node_access_all:0'),(510,'node_access_all:0'),(511,'node_access_all:0'),(512,'node_access_all:0'),(513,'node_access_all:0'),(514,'node_access_all:0'),(515,'node_access_all:0'),(516,'node_access_all:0'),(517,'node_access_all:0'),(518,'node_access_all:0'),(519,'node_access_all:0'),(520,'node_access_all:0'),(521,'node_access_all:0'),(522,'node_access_all:0'),(523,'node_access_all:0'),(524,'node_access_all:0'),(525,'node_access_all:0'),(526,'node_access_all:0'),(527,'node_access_all:0'),(528,'node_access_all:0'),(529,'node_access_all:0'),(530,'node_access_all:0'),(531,'node_access_all:0'),(532,'node_access_all:0'),(533,'node_access_all:0'),(534,'node_access_all:0'),(535,'node_access_all:0'),(536,'node_access_all:0'),(537,'node_access_all:0'),(538,'node_access_all:0'),(539,'node_access_all:0'),(540,'node_access_all:0'),(541,'node_access_all:0'),(542,'node_access_all:0'),(543,'node_access_all:0'),(544,'node_access_all:0'),(545,'node_access_all:0'),(546,'node_access_all:0'),(547,'node_access_all:0'),(548,'node_access_all:0'),(549,'node_access_all:0'),(550,'node_access_all:0'),(551,'node_access_all:0'),(552,'node_access_all:0'),(553,'node_access_all:0'),(554,'node_access_all:0'),(555,'node_access_all:0'),(556,'node_access_all:0'),(557,'node_access_all:0'),(558,'node_access_all:0'),(559,'node_access_all:0'),(560,'node_access_all:0'),(561,'node_access_all:0'),(562,'node_access_all:0'),(563,'node_access_all:0'),(564,'node_access_all:0'),(565,'node_access_all:0'),(566,'node_access_all:0'),(567,'node_access_all:0'),(568,'node_access_all:0'),(569,'node_access_all:0'),(570,'node_access_all:0'),(571,'node_access_all:0'),(572,'node_access_all:0'),(573,'node_access_all:0'),(574,'node_access_all:0'),(575,'node_access_all:0'),(576,'node_access_all:0'),(577,'node_access_all:0'),(578,'node_access_all:0'),(579,'node_access_all:0'),(580,'node_access_all:0'),(581,'node_access_all:0'),(582,'node_access_all:0'),(583,'node_access_all:0'),(584,'node_access_all:0'),(585,'node_access_all:0'),(586,'node_access_all:0'),(587,'node_access_all:0'),(588,'node_access_all:0'),(589,'node_access_all:0'),(590,'node_access_all:0'),(591,'node_access_all:0'),(592,'node_access_all:0'),(593,'node_access_all:0'),(594,'node_access_all:0'),(595,'node_access_all:0'),(596,'node_access_all:0'),(597,'node_access_all:0'),(598,'node_access_all:0'),(599,'node_access_all:0'),(600,'node_access_all:0'),(601,'node_access_all:0'),(602,'node_access_all:0'),(603,'node_access_all:0'),(604,'node_access_all:0'),(605,'node_access_all:0'),(606,'node_access_all:0'),(607,'node_access_all:0'),(608,'node_access_all:0'),(609,'node_access_all:0'),(610,'node_access_all:0'),(611,'node_access_all:0'),(612,'node_access_all:0'),(613,'node_access_all:0'),(614,'node_access_all:0'),(615,'node_access_all:0'),(616,'node_access_all:0'),(617,'node_access_all:0'),(618,'node_access_all:0'),(619,'node_access_all:0'),(620,'node_access_all:0'),(621,'node_access_all:0'),(622,'node_access_all:0'),(623,'node_access_all:0'),(624,'node_access_all:0'),(625,'node_access_all:0'),(626,'node_access_all:0'),(627,'node_access_all:0'),(628,'node_access_all:0'),(629,'node_access_all:0'),(630,'node_access_all:0'),(631,'node_access_all:0'),(632,'node_access_all:0'),(633,'node_access_all:0'),(634,'node_access_all:0'),(635,'node_access_all:0'),(636,'node_access_all:0'),(637,'node_access_all:0'),(638,'node_access_all:0'),(639,'node_access_all:0'),(640,'node_access_all:0'),(641,'node_access_all:0'),(642,'node_access_all:0'),(643,'node_access_all:0'),(644,'node_access_all:0'),(645,'node_access_all:0'),(646,'node_access_all:0'),(647,'node_access_all:0'),(648,'node_access_all:0'),(649,'node_access_all:0'),(650,'node_access_all:0'),(651,'node_access_all:0'),(652,'node_access_all:0'),(653,'node_access_all:0'),(654,'node_access_all:0'),(655,'node_access_all:0'),(656,'node_access_all:0'),(657,'node_access_all:0'),(658,'node_access_all:0'),(659,'node_access_all:0'),(660,'node_access_all:0'),(661,'node_access_all:0'),(662,'node_access_all:0'),(663,'node_access_all:0'),(664,'node_access_all:0'),(665,'node_access_all:0'),(666,'node_access_all:0'),(667,'node_access_all:0'),(668,'node_access_all:0'),(669,'node_access_all:0'),(670,'node_access_all:0'),(671,'node_access_all:0'),(672,'node_access_all:0'),(673,'node_access_all:0'),(674,'node_access_all:0'),(675,'node_access_all:0'),(676,'node_access_all:0'),(677,'node_access_all:0'),(678,'node_access_all:0'),(679,'node_access_all:0'),(680,'node_access_all:0'),(681,'node_access_all:0'),(682,'node_access_all:0'),(683,'node_access_all:0'),(684,'node_access_all:0'),(685,'node_access_all:0'),(686,'node_access_all:0'),(687,'node_access_all:0'),(688,'node_access_all:0'),(689,'node_access_all:0'),(690,'node_access_all:0'),(691,'node_access_all:0'),(692,'node_access_all:0'),(693,'node_access_all:0'),(694,'node_access_all:0'),(695,'node_access_all:0'),(696,'node_access_all:0'),(697,'node_access_all:0'),(698,'node_access_all:0'),(699,'node_access_all:0'),(700,'node_access_all:0'),(701,'node_access_all:0'),(702,'node_access_all:0'),(703,'node_access_all:0'),(704,'node_access_all:0'),(705,'node_access_all:0'),(706,'node_access_all:0'),(707,'node_access_all:0'),(708,'node_access_all:0'),(709,'node_access_all:0'),(710,'node_access_all:0'),(711,'node_access_all:0'),(712,'node_access_all:0'),(713,'node_access_all:0'),(714,'node_access_all:0'),(715,'node_access_all:0'),(716,'node_access_all:0'),(717,'node_access_all:0'),(718,'node_access_all:0'),(719,'node_access_all:0'),(720,'node_access_all:0'),(721,'node_access_all:0'),(722,'node_access_all:0'),(723,'node_access_all:0'),(724,'node_access_all:0'),(725,'node_access_all:0'),(726,'node_access_all:0'),(727,'node_access_all:0'),(728,'node_access_all:0'),(729,'node_access_all:0'),(730,'node_access_all:0'),(731,'node_access_all:0'),(732,'node_access_all:0'),(733,'node_access_all:0'),(734,'node_access_all:0'),(735,'node_access_all:0'),(736,'node_access_all:0'),(737,'node_access_all:0'),(738,'node_access_all:0'),(739,'node_access_all:0'),(740,'node_access_all:0'),(741,'node_access_all:0'),(742,'node_access_all:0'),(743,'node_access_all:0'),(744,'node_access_all:0'),(745,'node_access_all:0'),(746,'node_access_all:0'),(747,'node_access_all:0'),(748,'node_access_all:0'),(749,'node_access_all:0'),(750,'node_access_all:0'),(751,'node_access_all:0'),(752,'node_access_all:0'),(753,'node_access_all:0'),(754,'node_access_all:0'),(755,'node_access_all:0'),(756,'node_access_all:0'),(757,'node_access_all:0'),(758,'node_access_all:0'),(759,'node_access_all:0'),(760,'node_access_all:0'),(761,'node_access_all:0'),(762,'node_access_all:0'),(763,'node_access_all:0'),(764,'node_access_all:0'),(765,'node_access_all:0'),(766,'node_access_all:0'),(767,'node_access_all:0'),(768,'node_access_all:0'),(769,'node_access_all:0'),(770,'node_access_all:0'),(771,'node_access_all:0'),(772,'node_access_all:0'),(773,'node_access_all:0'),(774,'node_access_all:0'),(775,'node_access_all:0'),(776,'node_access_all:0'),(777,'node_access_all:0'),(778,'node_access_all:0'),(779,'node_access_all:0'),(780,'node_access_all:0'),(781,'node_access_all:0'),(782,'node_access_all:0'),(783,'node_access_all:0'),(784,'node_access_all:0'),(785,'node_access_all:0'),(786,'node_access_all:0'),(787,'node_access_all:0'),(788,'node_access_all:0'),(789,'node_access_all:0'),(790,'node_access_all:0'),(791,'node_access_all:0'),(792,'node_access_all:0'),(793,'node_access_all:0'),(794,'node_access_all:0'),(795,'node_access_all:0'),(796,'node_access_all:0'),(797,'node_access_all:0'),(798,'node_access_all:0'),(799,'node_access_all:0'),(800,'node_access_all:0'),(801,'node_access_all:0'),(802,'node_access_all:0'),(803,'node_access_all:0'),(804,'node_access_all:0'),(805,'node_access_all:0'),(806,'node_access_all:0'),(807,'node_access_all:0'),(808,'node_access_all:0'),(809,'node_access_all:0'),(810,'node_access_all:0'),(811,'node_access_all:0'),(812,'node_access_all:0'),(813,'node_access_all:0'),(814,'node_access_all:0'),(815,'node_access_all:0'),(816,'node_access_all:0'),(817,'node_access_all:0'),(818,'node_access_all:0'),(819,'node_access_all:0'),(820,'node_access_all:0'),(821,'node_access_all:0'),(822,'node_access_all:0'),(823,'node_access_all:0'),(824,'node_access_all:0'),(825,'node_access_all:0'),(826,'node_access_all:0'),(827,'node_access_all:0'),(828,'node_access_all:0'),(829,'node_access_all:0'),(830,'node_access_all:0'),(831,'node_access_all:0'),(832,'node_access_all:0'),(833,'node_access_all:0'),(834,'node_access_all:0'),(835,'node_access_all:0'),(836,'node_access_all:0'),(837,'node_access_all:0'),(838,'node_access_all:0'),(839,'node_access_all:0'),(840,'node_access_all:0'),(841,'node_access_all:0'),(842,'node_access_all:0'),(843,'node_access_all:0'),(844,'node_access_all:0'),(845,'node_access_all:0'),(846,'node_access_all:0'),(847,'node_access_all:0'),(848,'node_access_all:0'),(849,'node_access_all:0'),(850,'node_access_all:0'),(851,'node_access_all:0'),(852,'node_access_all:0'),(853,'node_access_all:0'),(854,'node_access_all:0'),(855,'node_access_all:0'),(856,'node_access_all:0'),(857,'node_access_all:0'),(858,'node_access_all:0'),(859,'node_access_all:0'),(860,'node_access_all:0'),(861,'node_access_all:0'),(862,'node_access_all:0'),(863,'node_access_all:0'),(864,'node_access_all:0'),(865,'node_access_all:0'),(866,'node_access_all:0'),(867,'node_access_all:0'),(868,'node_access_all:0'),(869,'node_access_all:0'),(870,'node_access_all:0'),(871,'node_access_all:0'),(872,'node_access_all:0'),(873,'node_access_all:0'),(874,'node_access_all:0'),(875,'node_access_all:0'),(876,'node_access_all:0'),(877,'node_access_all:0'),(878,'node_access_all:0'),(879,'node_access_all:0'),(880,'node_access_all:0'),(881,'node_access_all:0'),(882,'node_access_all:0'),(883,'node_access_all:0'),(884,'node_access_all:0'),(885,'node_access_all:0'),(886,'node_access_all:0'),(887,'node_access_all:0'),(888,'node_access_all:0'),(889,'node_access_all:0'),(890,'node_access_all:0'),(891,'node_access_all:0'),(892,'node_access_all:0'),(893,'node_access_all:0'),(894,'node_access_all:0'),(895,'node_access_all:0'),(896,'node_access_all:0'),(897,'node_access_all:0'),(898,'node_access_all:0'),(899,'node_access_all:0'),(900,'node_access_all:0'),(901,'node_access_all:0'),(902,'node_access_all:0'),(903,'node_access_all:0'),(904,'node_access_all:0'),(905,'node_access_all:0'),(906,'node_access_all:0'),(907,'node_access_all:0'),(908,'node_access_all:0'),(909,'node_access_all:0'),(910,'node_access_all:0'),(911,'node_access_all:0'),(912,'node_access_all:0'),(913,'node_access_all:0'),(914,'node_access_all:0'),(915,'node_access_all:0'),(916,'node_access_all:0'),(917,'node_access_all:0'),(918,'node_access_all:0'),(919,'node_access_all:0'),(920,'node_access_all:0'),(921,'node_access_all:0'),(922,'node_access_all:0'),(923,'node_access_all:0'),(924,'node_access_all:0'),(925,'node_access_all:0'),(926,'node_access_all:0'),(927,'node_access_all:0'),(928,'node_access_all:0'),(929,'node_access_all:0'),(930,'node_access_all:0'),(931,'node_access_all:0'),(932,'node_access_all:0'),(933,'node_access_all:0'),(934,'node_access_all:0'),(935,'node_access_all:0'),(936,'node_access_all:0'),(937,'node_access_all:0'),(938,'node_access_all:0'),(939,'node_access_all:0'),(940,'node_access_all:0'),(941,'node_access_all:0'),(942,'node_access_all:0'),(943,'node_access_all:0'),(944,'node_access_all:0'),(945,'node_access_all:0'),(946,'node_access_all:0'),(947,'node_access_all:0'),(948,'node_access_all:0'),(949,'node_access_all:0'),(950,'node_access_all:0'),(951,'node_access_all:0'),(952,'node_access_all:0'),(953,'node_access_all:0'),(954,'node_access_all:0'),(955,'node_access_all:0'),(956,'node_access_all:0'),(957,'node_access_all:0'),(958,'node_access_all:0'),(959,'node_access_all:0'),(960,'node_access_all:0'),(961,'node_access_all:0'),(962,'node_access_all:0'),(963,'node_access_all:0'),(964,'node_access_all:0'),(965,'node_access_all:0'),(966,'node_access_all:0'),(967,'node_access_all:0'),(968,'node_access_all:0'),(969,'node_access_all:0'),(970,'node_access_all:0'),(971,'node_access_all:0'),(972,'node_access_all:0'),(973,'node_access_all:0'),(974,'node_access_all:0'),(975,'node_access_all:0'),(976,'node_access_all:0'),(977,'node_access_all:0'),(978,'node_access_all:0'),(979,'node_access_all:0'),(980,'node_access_all:0'),(981,'node_access_all:0'),(982,'node_access_all:0'),(983,'node_access_all:0'),(984,'node_access_all:0'),(985,'node_access_all:0'),(986,'node_access_all:0'),(987,'node_access_all:0'),(988,'node_access_all:0'),(989,'node_access_all:0'),(990,'node_access_all:0'),(991,'node_access_all:0'),(992,'node_access_all:0'),(993,'node_access_all:0'),(994,'node_access_all:0'),(995,'node_access_all:0'),(996,'node_access_all:0'),(997,'node_access_all:0'),(998,'node_access_all:0'),(999,'node_access_all:0'),(1000,'node_access_all:0'),(1001,'node_access_all:0'),(1002,'node_access_all:0'),(1003,'node_access_all:0'),(1004,'node_access_all:0'),(1005,'node_access_all:0'),(1006,'node_access_all:0'),(1007,'node_access_all:0'),(1008,'node_access_all:0'),(1009,'node_access_all:0'),(1010,'node_access_all:0'),(1011,'node_access_all:0'),(1012,'node_access_all:0'),(1013,'node_access_all:0'),(1014,'node_access_all:0'),(1015,'node_access_all:0'),(1016,'node_access_all:0'),(1017,'node_access_all:0'),(1018,'node_access_all:0'),(1019,'node_access_all:0'),(1020,'node_access_all:0'),(1021,'node_access_all:0'),(1022,'node_access_all:0'),(1023,'node_access_all:0'),(1024,'node_access_all:0'),(1025,'node_access_all:0'),(1026,'node_access_all:0'),(1027,'node_access_all:0'),(1028,'node_access_all:0'),(1029,'node_access_all:0'),(1030,'node_access_all:0'),(1031,'node_access_all:0'),(1032,'node_access_all:0'),(1033,'node_access_all:0'),(1034,'node_access_all:0'),(1035,'node_access_all:0'),(1036,'node_access_all:0'),(1037,'node_access_all:0'),(1038,'node_access_all:0'),(1039,'node_access_all:0'),(1040,'node_access_all:0'),(1041,'node_access_all:0'),(1042,'node_access_all:0'),(1043,'node_access_all:0'),(1044,'node_access_all:0'),(1045,'node_access_all:0'),(1046,'node_access_all:0'),(1047,'node_access_all:0'),(1048,'node_access_all:0'),(1049,'node_access_all:0'),(1050,'node_access_all:0'),(1051,'node_access_all:0'),(1052,'node_access_all:0'),(1053,'node_access_all:0'),(1054,'node_access_all:0'),(1055,'node_access_all:0'),(1056,'node_access_all:0'),(1057,'node_access_all:0'),(1058,'node_access_all:0'),(1059,'node_access_all:0'),(1060,'node_access_all:0'),(1061,'node_access_all:0'),(1062,'node_access_all:0'),(1063,'node_access_all:0'),(1064,'node_access_all:0'),(1065,'node_access_all:0'),(1066,'node_access_all:0'),(1067,'node_access_all:0'),(1068,'node_access_all:0'),(1069,'node_access_all:0'),(1070,'node_access_all:0'),(1071,'node_access_all:0'),(1072,'node_access_all:0'),(1073,'node_access_all:0'),(1074,'node_access_all:0'),(1075,'node_access_all:0'),(1076,'node_access_all:0'),(1077,'node_access_all:0'),(1078,'node_access_all:0'),(1079,'node_access_all:0'),(1080,'node_access_all:0'),(1081,'node_access_all:0'),(1082,'node_access_all:0'),(1083,'node_access_all:0'),(1084,'node_access_all:0'),(1085,'node_access_all:0'),(1086,'node_access_all:0'),(1087,'node_access_all:0'),(1088,'node_access_all:0'),(1089,'node_access_all:0'),(1090,'node_access_all:0'),(1091,'node_access_all:0'),(1092,'node_access_all:0'),(1093,'node_access_all:0'),(1094,'node_access_all:0'),(1095,'node_access_all:0'),(1096,'node_access_all:0'),(1097,'node_access_all:0'),(1098,'node_access_all:0'),(1099,'node_access_all:0'),(1100,'node_access_all:0'),(1101,'node_access_all:0'),(1102,'node_access_all:0'),(1103,'node_access_all:0'),(1104,'node_access_all:0'),(1105,'node_access_all:0'),(1106,'node_access_all:0'),(1107,'node_access_all:0'),(1108,'node_access_all:0'),(1109,'node_access_all:0'),(1110,'node_access_all:0'),(1111,'node_access_all:0'),(1112,'node_access_all:0'),(1113,'node_access_all:0'),(1114,'node_access_all:0'),(1115,'node_access_all:0'),(1116,'node_access_all:0'),(1117,'node_access_all:0'),(1118,'node_access_all:0'),(1119,'node_access_all:0'),(1120,'node_access_all:0'),(1121,'node_access_all:0'),(1122,'node_access_all:0');
/*!40000 ALTER TABLE `fuzzysearch_default_fuzzysearch_index_search_api_access_node` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fuzzysearch_default_fuzzysearch_index_search_api_language`
--

DROP TABLE IF EXISTS `fuzzysearch_default_fuzzysearch_index_search_api_language`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fuzzysearch_default_fuzzysearch_index_search_api_language` (
  `item_id` int(11) NOT NULL COMMENT 'The primary identifier of the entity.',
  `value` varchar(255) DEFAULT NULL COMMENT 'The field’s value for this item.',
  PRIMARY KEY (`item_id`),
  KEY `value` (`value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fuzzysearch_default_fuzzysearch_index_search_api_language`
--

LOCK TABLES `fuzzysearch_default_fuzzysearch_index_search_api_language` WRITE;
/*!40000 ALTER TABLE `fuzzysearch_default_fuzzysearch_index_search_api_language` DISABLE KEYS */;
INSERT INTO `fuzzysearch_default_fuzzysearch_index_search_api_language` VALUES (1,'und'),(2,'und'),(3,'und'),(4,'und'),(5,'und'),(6,'und'),(7,'und'),(8,'und'),(9,'und'),(10,'und'),(11,'und'),(12,'und'),(13,'und'),(14,'und'),(15,'und'),(16,'und'),(17,'und'),(18,'und'),(19,'und'),(20,'und'),(21,'und'),(22,'und'),(23,'und'),(24,'und'),(25,'und'),(26,'und'),(27,'und'),(28,'und'),(29,'und'),(30,'und'),(31,'und'),(32,'und'),(33,'und'),(34,'und'),(35,'und'),(36,'und'),(37,'und'),(38,'und'),(39,'und'),(40,'und'),(41,'und'),(42,'und'),(43,'und'),(44,'und'),(45,'und'),(46,'und'),(47,'und'),(48,'und'),(49,'und'),(50,'und'),(51,'und'),(52,'und'),(53,'und'),(54,'und'),(55,'und'),(56,'und'),(57,'und'),(58,'und'),(59,'und'),(60,'und'),(61,'und'),(62,'und'),(63,'und'),(64,'und'),(65,'und'),(66,'und'),(67,'und'),(68,'und'),(69,'und'),(70,'und'),(71,'und'),(72,'und'),(73,'und'),(74,'und'),(75,'und'),(76,'und'),(77,'und'),(78,'und'),(79,'und'),(80,'und'),(81,'und'),(82,'und'),(83,'und'),(84,'und'),(85,'und'),(86,'und'),(87,'und'),(88,'und'),(89,'und'),(90,'und'),(91,'und'),(92,'und'),(93,'und'),(94,'und'),(95,'und'),(96,'und'),(97,'und'),(98,'und'),(99,'und'),(100,'und'),(101,'und'),(102,'und'),(103,'und'),(104,'und'),(105,'und'),(106,'und'),(107,'und'),(108,'und'),(109,'und'),(110,'und'),(111,'und'),(112,'und'),(113,'und'),(114,'und'),(115,'und'),(116,'und'),(117,'und'),(118,'und'),(119,'und'),(120,'und'),(121,'und'),(122,'und'),(123,'und'),(124,'und'),(125,'und'),(126,'und'),(127,'und'),(128,'und'),(129,'und'),(130,'und'),(131,'und'),(132,'und'),(133,'und'),(134,'und'),(135,'und'),(136,'und'),(137,'und'),(138,'und'),(139,'und'),(140,'und'),(141,'und'),(142,'und'),(143,'und'),(144,'und'),(145,'und'),(146,'und'),(147,'und'),(148,'und'),(149,'und'),(150,'und'),(151,'und'),(152,'und'),(153,'und'),(154,'und'),(155,'und'),(156,'und'),(157,'und'),(158,'und'),(159,'und'),(160,'und'),(161,'und'),(162,'und'),(163,'und'),(164,'und'),(165,'und'),(166,'und'),(167,'und'),(168,'und'),(169,'und'),(170,'und'),(171,'und'),(172,'und'),(173,'und'),(174,'und'),(175,'und'),(176,'und'),(177,'und'),(178,'und'),(179,'und'),(180,'und'),(181,'und'),(182,'und'),(183,'und'),(184,'und'),(185,'und'),(186,'und'),(187,'und'),(188,'und'),(189,'und'),(190,'und'),(191,'und'),(192,'und'),(193,'und'),(194,'und'),(195,'und'),(196,'und'),(197,'und'),(198,'und'),(199,'und'),(200,'und'),(201,'und'),(202,'und'),(203,'und'),(204,'und'),(205,'und'),(206,'und'),(207,'und'),(208,'und'),(209,'und'),(210,'und'),(211,'und'),(212,'und'),(213,'und'),(214,'und'),(215,'und'),(216,'und'),(217,'und'),(218,'und'),(219,'und'),(220,'und'),(221,'und'),(222,'und'),(223,'und'),(224,'und'),(225,'und'),(226,'und'),(227,'und'),(228,'und'),(229,'und'),(230,'und'),(231,'und'),(232,'und'),(233,'und'),(234,'und'),(235,'und'),(236,'und'),(237,'und'),(238,'und'),(239,'und'),(240,'und'),(241,'und'),(242,'und'),(243,'und'),(244,'und'),(245,'und'),(246,'und'),(247,'und'),(248,'und'),(249,'und'),(250,'und'),(251,'und'),(252,'und'),(253,'und'),(254,'und'),(255,'und'),(256,'und'),(257,'und'),(258,'und'),(259,'und'),(260,'und'),(261,'und'),(262,'und'),(263,'und'),(264,'und'),(265,'und'),(266,'und'),(267,'und'),(268,'und'),(269,'und'),(270,'und'),(271,'und'),(272,'und'),(273,'und'),(274,'und'),(275,'und'),(276,'und'),(277,'und'),(278,'und'),(279,'und'),(280,'und'),(281,'und'),(282,'und'),(283,'und'),(284,'und'),(285,'und'),(286,'und'),(287,'und'),(288,'und'),(289,'und'),(290,'und'),(291,'und'),(292,'und'),(293,'und'),(294,'und'),(295,'und'),(296,'und'),(297,'und'),(298,'und'),(299,'und'),(300,'und'),(301,'und'),(302,'und'),(303,'und'),(304,'und'),(305,'und'),(306,'und'),(307,'und'),(308,'und'),(309,'und'),(310,'und'),(311,'und'),(312,'und'),(313,'und'),(314,'und'),(315,'und'),(316,'und'),(317,'und'),(318,'und'),(319,'und'),(320,'und'),(321,'und'),(322,'und'),(323,'und'),(324,'und'),(325,'und'),(326,'und'),(327,'und'),(328,'und'),(329,'und'),(330,'und'),(331,'und'),(332,'und'),(333,'und'),(334,'und'),(335,'und'),(336,'und'),(337,'und'),(338,'und'),(339,'und'),(340,'und'),(341,'und'),(342,'und'),(343,'und'),(344,'und'),(345,'und'),(346,'und'),(347,'und'),(348,'und'),(349,'und'),(350,'und'),(351,'und'),(352,'und'),(353,'und'),(354,'und'),(355,'und'),(356,'und'),(357,'und'),(358,'und'),(359,'und'),(360,'und'),(361,'und'),(362,'und'),(363,'und'),(364,'und'),(365,'und'),(366,'und'),(367,'und'),(368,'und'),(369,'und'),(370,'und'),(371,'und'),(372,'und'),(373,'und'),(374,'und'),(375,'und'),(376,'und'),(377,'und'),(378,'und'),(379,'und'),(380,'und'),(381,'und'),(382,'und'),(383,'und'),(384,'und'),(385,'und'),(386,'und'),(387,'und'),(388,'und'),(389,'und'),(390,'und'),(391,'und'),(392,'und'),(393,'und'),(394,'und'),(395,'und'),(396,'und'),(397,'und'),(398,'und'),(399,'und'),(400,'und'),(401,'und'),(402,'und'),(403,'und'),(404,'und'),(405,'und'),(406,'und'),(407,'und'),(408,'und'),(409,'und'),(410,'und'),(411,'und'),(412,'und'),(413,'und'),(414,'und'),(415,'und'),(416,'und'),(417,'und'),(418,'und'),(419,'und'),(420,'und'),(421,'und'),(422,'und'),(423,'und'),(424,'und'),(425,'und'),(426,'und'),(427,'und'),(428,'und'),(429,'und'),(430,'und'),(431,'und'),(432,'und'),(433,'und'),(434,'und'),(435,'und'),(436,'und'),(437,'und'),(438,'und'),(439,'und'),(440,'und'),(441,'und'),(442,'und'),(443,'und'),(444,'und'),(445,'und'),(446,'und'),(447,'und'),(448,'und'),(449,'und'),(450,'und'),(451,'und'),(452,'und'),(453,'und'),(454,'und'),(455,'und'),(456,'und'),(457,'und'),(458,'und'),(459,'und'),(460,'und'),(461,'und'),(462,'und'),(463,'und'),(464,'und'),(465,'und'),(466,'und'),(467,'und'),(468,'und'),(469,'und'),(470,'und'),(471,'und'),(472,'und'),(473,'und'),(474,'und'),(475,'und'),(476,'und'),(477,'und'),(478,'und'),(479,'und'),(480,'und'),(481,'und'),(482,'und'),(483,'und'),(484,'und'),(485,'und'),(486,'und'),(487,'und'),(488,'und'),(489,'und'),(490,'und'),(491,'und'),(492,'und'),(493,'und'),(494,'und'),(495,'und'),(496,'und'),(497,'und'),(498,'und'),(499,'und'),(500,'und'),(501,'und'),(502,'und'),(503,'und'),(504,'und'),(505,'und'),(506,'und'),(507,'und'),(508,'und'),(509,'und'),(510,'und'),(511,'und'),(512,'und'),(513,'und'),(514,'und'),(515,'und'),(516,'und'),(517,'und'),(518,'und'),(519,'und'),(520,'und'),(521,'und'),(522,'und'),(523,'und'),(524,'und'),(525,'und'),(526,'und'),(527,'und'),(528,'und'),(529,'und'),(530,'und'),(531,'und'),(532,'und'),(533,'und'),(534,'und'),(535,'und'),(536,'und'),(537,'und'),(538,'und'),(539,'und'),(540,'und'),(541,'und'),(542,'und'),(543,'und'),(544,'und'),(545,'und'),(546,'und'),(547,'und'),(548,'und'),(549,'und'),(550,'und'),(551,'und'),(552,'und'),(553,'und'),(554,'und'),(555,'und'),(556,'und'),(557,'und'),(558,'und'),(559,'und'),(560,'und'),(561,'und'),(562,'und'),(563,'und'),(564,'und'),(565,'und'),(566,'und'),(567,'und'),(568,'und'),(569,'und'),(570,'und'),(571,'und'),(572,'und'),(573,'und'),(574,'und'),(575,'und'),(576,'und'),(577,'und'),(578,'und'),(579,'und'),(580,'und'),(581,'und'),(582,'und'),(583,'und'),(584,'und'),(585,'und'),(586,'und'),(587,'und'),(588,'und'),(589,'und'),(590,'und'),(591,'und'),(592,'und'),(593,'und'),(594,'und'),(595,'und'),(596,'und'),(597,'und'),(598,'und'),(599,'und'),(600,'und'),(601,'und'),(602,'und'),(603,'und'),(604,'und'),(605,'und'),(606,'und'),(607,'und'),(608,'und'),(609,'und'),(610,'und'),(611,'und'),(612,'und'),(613,'und'),(614,'und'),(615,'und'),(616,'und'),(617,'und'),(618,'und'),(619,'und'),(620,'und'),(621,'und'),(622,'und'),(623,'und'),(624,'und'),(625,'und'),(626,'und'),(627,'und'),(628,'und'),(629,'und'),(630,'und'),(631,'und'),(632,'und'),(633,'und'),(634,'und'),(635,'und'),(636,'und'),(637,'und'),(638,'und'),(639,'und'),(640,'und'),(641,'und'),(642,'und'),(643,'und'),(644,'und'),(645,'und'),(646,'und'),(647,'und'),(648,'und'),(649,'und'),(650,'und'),(651,'und'),(652,'und'),(653,'und'),(654,'und'),(655,'und'),(656,'und'),(657,'und'),(658,'und'),(659,'und'),(660,'und'),(661,'und'),(662,'und'),(663,'und'),(664,'und'),(665,'und'),(666,'und'),(667,'und'),(668,'und'),(669,'und'),(670,'und'),(671,'und'),(672,'und'),(673,'und'),(674,'und'),(675,'und'),(676,'und'),(677,'und'),(678,'und'),(679,'und'),(680,'und'),(681,'und'),(682,'und'),(683,'und'),(684,'und'),(685,'und'),(686,'und'),(687,'und'),(688,'und'),(689,'und'),(690,'und'),(691,'und'),(692,'und'),(693,'und'),(694,'und'),(695,'und'),(696,'und'),(697,'und'),(698,'und'),(699,'und'),(700,'und'),(701,'und'),(702,'und'),(703,'und'),(704,'und'),(705,'und'),(706,'und'),(707,'und'),(708,'und'),(709,'und'),(710,'und'),(711,'und'),(712,'und'),(713,'und'),(714,'und'),(715,'und'),(716,'und'),(717,'und'),(718,'und'),(719,'und'),(720,'und'),(721,'und'),(722,'und'),(723,'und'),(724,'und'),(725,'und'),(726,'und'),(727,'und'),(728,'und'),(729,'und'),(730,'und'),(731,'und'),(732,'und'),(733,'und'),(734,'und'),(735,'und'),(736,'und'),(737,'und'),(738,'und'),(739,'und'),(740,'und'),(741,'und'),(742,'und'),(743,'und'),(744,'und'),(745,'und'),(746,'und'),(747,'und'),(748,'und'),(749,'und'),(750,'und'),(751,'und'),(752,'und'),(753,'und'),(754,'und'),(755,'und'),(756,'und'),(757,'und'),(758,'und'),(759,'und'),(760,'und'),(761,'und'),(762,'und'),(763,'und'),(764,'und'),(765,'und'),(766,'und'),(767,'und'),(768,'und'),(769,'und'),(770,'und'),(771,'und'),(772,'und'),(773,'und'),(774,'und'),(775,'und'),(776,'und'),(777,'und'),(778,'und'),(779,'und'),(780,'und'),(781,'und'),(782,'und'),(783,'und'),(784,'und'),(785,'und'),(786,'und'),(787,'und'),(788,'und'),(789,'und'),(790,'und'),(791,'und'),(792,'und'),(793,'und'),(794,'und'),(795,'und'),(796,'und'),(797,'und'),(798,'und'),(799,'und'),(800,'und'),(801,'und'),(802,'und'),(803,'und'),(804,'und'),(805,'und'),(806,'und'),(807,'und'),(808,'und'),(809,'und'),(810,'und'),(811,'und'),(812,'und'),(813,'und'),(814,'und'),(815,'und'),(816,'und'),(817,'und'),(818,'und'),(819,'und'),(820,'und'),(821,'und'),(822,'und'),(823,'und'),(824,'und'),(825,'und'),(826,'und'),(827,'und'),(828,'und'),(829,'und'),(830,'und'),(831,'und'),(832,'und'),(833,'und'),(834,'und'),(835,'und'),(836,'und'),(837,'und'),(838,'und'),(839,'und'),(840,'und'),(841,'und'),(842,'und'),(843,'und'),(844,'und'),(845,'und'),(846,'und'),(847,'und'),(848,'und'),(849,'und'),(850,'und'),(851,'und'),(852,'und'),(853,'und'),(854,'und'),(855,'und'),(856,'und'),(857,'und'),(858,'und'),(859,'und'),(860,'und'),(861,'und'),(862,'und'),(863,'und'),(864,'und'),(865,'und'),(866,'und'),(867,'und'),(868,'und'),(869,'und'),(870,'und'),(871,'und'),(872,'und'),(873,'und'),(874,'und'),(875,'und'),(876,'und'),(877,'und'),(878,'und'),(879,'und'),(880,'und'),(881,'und'),(882,'und'),(883,'und'),(884,'und'),(885,'und'),(886,'und'),(887,'und'),(888,'und'),(889,'und'),(890,'und'),(891,'und'),(892,'und'),(893,'und'),(894,'und'),(895,'und'),(896,'und'),(897,'und'),(898,'und'),(899,'und'),(900,'und'),(901,'und'),(902,'und'),(903,'und'),(904,'und'),(905,'und'),(906,'und'),(907,'und'),(908,'und'),(909,'und'),(910,'und'),(911,'und'),(912,'und'),(913,'und'),(914,'und'),(915,'und'),(916,'und'),(917,'und'),(918,'und'),(919,'und'),(920,'und'),(921,'und'),(922,'und'),(923,'und'),(924,'und'),(925,'und'),(926,'und'),(927,'und'),(928,'und'),(929,'und'),(930,'und'),(931,'und'),(932,'und'),(933,'und'),(934,'und'),(935,'und'),(936,'und'),(937,'und'),(938,'und'),(939,'und'),(940,'und'),(941,'und'),(942,'und'),(943,'und'),(944,'und'),(945,'und'),(946,'und'),(947,'und'),(948,'und'),(949,'und'),(950,'und'),(951,'und'),(952,'und'),(953,'und'),(954,'und'),(955,'und'),(956,'und'),(957,'und'),(958,'und'),(959,'und'),(960,'und'),(961,'und'),(962,'und'),(963,'und'),(964,'und'),(965,'und'),(966,'und'),(967,'und'),(968,'und'),(969,'und'),(970,'und'),(971,'und'),(972,'und'),(973,'und'),(974,'und'),(975,'und'),(976,'und'),(977,'und'),(978,'und'),(979,'und'),(980,'und'),(981,'und'),(982,'und'),(983,'und'),(984,'und'),(985,'und'),(986,'und'),(987,'und'),(988,'und'),(989,'und'),(990,'und'),(991,'und'),(992,'und'),(993,'und'),(994,'und'),(995,'und'),(996,'und'),(997,'und'),(998,'und'),(999,'und'),(1000,'und'),(1001,'und'),(1002,'und'),(1003,'und'),(1004,'und'),(1005,'und'),(1006,'und'),(1007,'und'),(1008,'und'),(1009,'und'),(1010,'und'),(1011,'und'),(1012,'und'),(1013,'und'),(1014,'und'),(1015,'und'),(1016,'und'),(1017,'und'),(1018,'und'),(1019,'und'),(1020,'und'),(1021,'und'),(1022,'und'),(1023,'und'),(1024,'und'),(1025,'und'),(1026,'und'),(1027,'und'),(1028,'und'),(1029,'und'),(1030,'und'),(1031,'und'),(1032,'und'),(1033,'und'),(1034,'und'),(1035,'und'),(1036,'und'),(1037,'und'),(1038,'und'),(1039,'und'),(1040,'und'),(1041,'und'),(1042,'und'),(1043,'und'),(1044,'und'),(1045,'und'),(1046,'und'),(1047,'und'),(1048,'und'),(1049,'und'),(1050,'und'),(1051,'und'),(1052,'und'),(1053,'und'),(1054,'und'),(1055,'und'),(1056,'und'),(1057,'und'),(1058,'und'),(1059,'und'),(1060,'und'),(1061,'und'),(1062,'und'),(1063,'und'),(1064,'und'),(1065,'und'),(1066,'und'),(1067,'und'),(1068,'und'),(1069,'und'),(1070,'und'),(1071,'und'),(1072,'und'),(1073,'und'),(1074,'und'),(1075,'und'),(1076,'und'),(1077,'und'),(1078,'und'),(1079,'und'),(1080,'und'),(1081,'und'),(1082,'und'),(1083,'und'),(1084,'und'),(1085,'und'),(1086,'und'),(1087,'und'),(1088,'und'),(1089,'und'),(1090,'und'),(1091,'und'),(1092,'und'),(1093,'und'),(1094,'und'),(1095,'und'),(1096,'und'),(1097,'und'),(1098,'und'),(1099,'und'),(1100,'und'),(1101,'und'),(1102,'und'),(1103,'und'),(1104,'und'),(1105,'und'),(1106,'und'),(1107,'und'),(1108,'und'),(1109,'und'),(1110,'und'),(1111,'und'),(1112,'und'),(1113,'und'),(1114,'und'),(1115,'und'),(1116,'und'),(1117,'und'),(1118,'und'),(1119,'und'),(1120,'und'),(1121,'und'),(1122,'und');
/*!40000 ALTER TABLE `fuzzysearch_default_fuzzysearch_index_search_api_language` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fuzzysearch_default_fuzzysearch_index_search_api_viewed`
--

DROP TABLE IF EXISTS `fuzzysearch_default_fuzzysearch_index_search_api_viewed`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fuzzysearch_default_fuzzysearch_index_search_api_viewed` (
  `item_id` int(11) NOT NULL COMMENT 'The primary identifier of the entity.',
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The ngram id.',
  `word_id` int(10) unsigned NOT NULL COMMENT 'The word id.',
  `ngram` varchar(50) NOT NULL COMMENT 'The ngram.',
  `completeness` float NOT NULL COMMENT 'Completeness',
  `score` float NOT NULL COMMENT 'The score associated with this ngram.',
  PRIMARY KEY (`id`),
  KEY `ngram` (`ngram`(10)),
  KEY `completeness` (`completeness`)
) ENGINE=MyISAM AUTO_INCREMENT=7621500 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fuzzysearch_default_fuzzysearch_index_search_api_viewed`
--

LOCK TABLES `fuzzysearch_default_fuzzysearch_index_search_api_viewed` WRITE;
/*!40000 ALTER TABLE `fuzzysearch_default_fuzzysearch_index_search_api_viewed` DISABLE KEYS */;
INSERT INTO `fuzzysearch_default_fuzzysearch_index_search_api_viewed` VALUES (7,7402430,7402429,'att',12.5,1),(7,7402431,7402429,'ttr',12.5,1),(7,7402432,7402429,'tri',12.5,1),(7,7402433,7402429,'rib',12.5,1),(7,7402434,7402429,'ibu',12.5,1),(7,7402435,7402429,'but',12.5,1),(7,7402436,7402429,'ute',12.5,1),(7,7402437,7402429,'tes',12.5,1),(7,7402438,7402430,'pla',16.667,1),(7,7402439,7402430,'lat',16.667,1),(7,7402440,7402430,'atf',16.667,1),(7,7402441,7402430,'tfo',16.667,1),(7,7402442,7402430,'for',16.667,1),(7,7402443,7402430,'orm',16.667,1),(7,7402444,7402438,'nam',50,2),(7,7402445,7402438,'ame',50,2),(7,7402446,7402444,'fuj',7.692,1),(7,7402447,7402444,'uji',7.692,1),(7,7402448,7402444,'jit',7.692,1),(7,7402449,7402444,'its',7.692,1),(7,7402450,7402444,'tsu',7.692,1),(7,7402451,7402444,'sup',7.692,1),(7,7402452,7402444,'upr',7.692,1),(7,7402453,7402444,'pri',7.692,1),(7,7402454,7402444,'rim',7.692,1),(7,7402455,7402444,'ime',7.692,1),(7,7402456,7402444,'mer',7.692,1),(7,7402457,7402444,'erg',7.692,1),(7,7402458,7402444,'rgy',7.692,1),(7,7402459,7402446,'rx6',33.333,1),(7,7402460,7402446,'x60',33.333,1),(7,7402461,7402446,'600',33.333,1),(7,7402462,7402459,'esx',100,1),(7,7402463,7402462,'hos',50,3),(7,7402464,7402462,'ost',50,3),(7,7402465,7402463,'vmw',25,1),(7,7402466,7402463,'mwa',25,1),(7,7402467,7402463,'war',25,1),(7,7402468,7402463,'are',25,1),(7,7402469,7402465,'esx',50,1),(7,7402470,7402465,'sxi',50,1),(7,7402471,7402469,'bui',11.111,1),(7,7402472,7402469,'uil',11.111,1),(7,7402473,7402469,'ild',11.111,1),(7,7402474,7402469,'ld4',11.111,1),(7,7402475,7402469,'d46',11.111,1),(7,7402476,7402469,'469',11.111,1),(7,7402477,7402469,'695',11.111,1),(7,7402478,7402469,'951',11.111,1),(7,7402479,7402469,'512',11.111,1),(7,7402480,7402471,'fla',33.333,3),(7,7402481,7402471,'las',33.333,3),(7,7402482,7402471,'ash',33.333,3),(7,7402483,7402480,'acc',33.333,2),(7,7402484,7402480,'cce',33.333,2),(7,7402485,7402480,'cel',33.333,2),(7,7402486,7402483,'con',9.091,1),(7,7402487,7402483,'onf',9.091,1),(7,7402488,7402483,'nfi',9.091,1),(7,7402489,7402483,'fig',9.091,1),(7,7402490,7402483,'igu',9.091,1),(7,7402491,7402483,'gur',9.091,1),(7,7402492,7402483,'ura',9.091,1),(7,7402493,7402483,'rat',9.091,1),(7,7402494,7402483,'ati',9.091,1),(7,7402495,7402483,'tio',9.091,1),(7,7402496,7402483,'ion',9.091,1),(7,7402497,7402486,'age',33.333,2),(7,7402498,7402486,'gen',33.333,2),(7,7402499,7402486,'ent',33.333,2),(7,7402500,7402497,'yes',100,1),(7,7402501,7402500,'ver',20,1),(7,7402502,7402500,'ers',20,1),(7,7402503,7402500,'rsi',20,1),(7,7402504,7402500,'sio',20,1),(7,7402505,7402500,'ion',20,1),(7,7402506,7402501,'019',14.286,1),(7,7402507,7402501,'192',14.286,1),(7,7402508,7402501,'923',14.286,1),(7,7402509,7402501,'234',14.286,1),(7,7402510,7402501,'343',14.286,1),(7,7402511,7402501,'432',14.286,1),(7,7402512,7402501,'329',14.286,1),(7,7402513,7402506,'cac',33.333,3),(7,7402514,7402506,'ach',33.333,3),(7,7402515,7402506,'che',33.333,3),(7,7402516,7402513,'sta',33.333,1),(7,7402517,7402513,'tat',33.333,1),(7,7402518,7402513,'ate',33.333,1),(7,7402519,7402516,'ena',20,1),(7,7402520,7402516,'nab',20,1),(7,7402521,7402516,'abl',20,1),(7,7402522,7402516,'ble',20,1),(7,7402523,7402516,'led',20,1),(7,7402524,7402519,'all',12.5,1),(7,7402525,7402519,'llo',12.5,1),(7,7402526,7402519,'loc',12.5,1),(7,7402527,7402519,'oca',12.5,1),(7,7402528,7402519,'cat',12.5,1),(7,7402529,7402519,'ati',12.5,1),(7,7402530,7402519,'tio',12.5,1),(7,7402531,7402519,'ion',12.5,1),(7,7402532,7402524,'inf',11.111,1),(7,7402533,7402524,'nfo',11.111,1),(7,7402534,7402524,'for',11.111,1),(7,7402535,7402524,'orm',11.111,1),(7,7402536,7402524,'rma',11.111,1),(7,7402537,7402524,'mat',11.111,1),(7,7402538,7402524,'ati',11.111,1),(7,7402539,7402524,'tio',11.111,1),(7,7402540,7402524,'ion',11.111,1),(7,7402541,7402532,'siz',50,3),(7,7402542,7402532,'ize',50,3),(7,7402543,7402541,'303',100,1),(7,7402544,7402543,'75g',50,1),(7,7402545,7402543,'5gb',50,1),(7,7402546,7402544,'557',100,2),(7,7402547,7402546,'00g',50,1),(7,7402548,7402546,'0gb',50,1),(7,7402549,7402547,'lar',20,1),(7,7402550,7402547,'arg',20,1),(7,7402551,7402547,'rge',20,1),(7,7402552,7402547,'ges',20,1),(7,7402553,7402547,'est',20,1),(7,7402554,7402549,'all',11.111,1),(7,7402555,7402549,'llo',11.111,1),(7,7402556,7402549,'loc',11.111,1),(7,7402557,7402549,'oca',11.111,1),(7,7402558,7402549,'cat',11.111,1),(7,7402559,7402549,'ata',11.111,1),(7,7402560,7402549,'tab',11.111,1),(7,7402561,7402549,'abl',11.111,1),(7,7402562,7402549,'ble',11.111,1),(7,7402563,7402554,'253',100,1),(7,7402564,7402563,'25g',50,1),(7,7402565,7402563,'5gb',50,1),(7,7402566,7402564,'vms',100,1),(7,7402567,7402566,'use',50,1),(7,7402568,7402566,'sed',50,1),(7,7402569,7402567,'dev',25,3),(7,7402570,7402567,'evi',25,3),(7,7402571,7402567,'vic',25,3),(7,7402572,7402567,'ice',25,3),(7,7402573,7402569,'naa',100,1),(7,7402574,7402573,'600',3.333,1),(7,7402575,7402573,'003',3.333,1),(7,7402576,7402573,'030',3.333,1),(7,7402577,7402573,'300',3.333,1),(7,7402578,7402573,'005',3.333,1),(7,7402579,7402573,'057',3.333,1),(7,7402580,7402573,'570',3.333,1),(7,7402581,7402573,'701',3.333,1),(7,7402582,7402573,'014',3.333,1),(7,7402583,7402573,'144',3.333,1),(7,7402584,7402573,'448',3.333,1),(7,7402585,7402573,'484',3.333,1),(7,7402586,7402573,'849',3.333,1),(7,7402587,7402573,'490',3.333,1),(7,7402588,7402573,'901',3.333,1),(7,7402589,7402573,'018',3.333,1),(7,7402590,7402573,'187',3.333,1),(7,7402591,7402573,'87d',3.333,1),(7,7402592,7402573,'7de',3.333,1),(7,7402593,7402573,'de2',3.333,1),(7,7402594,7402573,'e2b',3.333,1),(7,7402595,7402573,'2b8',3.333,1),(7,7402596,7402573,'b84',3.333,1),(7,7402597,7402573,'849',3.333,1),(7,7402598,7402573,'495',3.333,1),(7,7402599,7402573,'951',3.333,1),(7,7402600,7402573,'51b',3.333,1),(7,7402601,7402573,'1b3',3.333,1),(7,7402602,7402573,'b3d',3.333,1),(7,7402603,7402573,'3df',3.333,1),(7,7402604,7402574,'vir',20,1),(7,7402605,7402574,'irt',20,1),(7,7402606,7402574,'rtu',20,1),(7,7402607,7402574,'tua',20,1),(7,7402608,7402574,'ual',20,1),(7,7402609,7402604,'mac',20,1),(7,7402610,7402604,'ach',20,1),(7,7402611,7402604,'chi',20,1),(7,7402612,7402604,'hin',20,1),(7,7402613,7402604,'ine',20,1),(7,7402614,7402609,'met',20,1),(7,7402615,7402609,'etr',20,1),(7,7402616,7402609,'tri',20,1),(7,7402617,7402609,'ric',20,1),(7,7402618,7402609,'ics',20,1),(8,7402620,7402619,'net',25,3),(8,7402621,7402619,'eta',25,3),(8,7402622,7402619,'tap',25,3),(8,7402623,7402619,'app',25,3),(8,7402624,7402620,'fib',33.333,2),(8,7402625,7402620,'ibr',33.333,2),(8,7402626,7402620,'bre',33.333,2),(8,7402627,7402624,'cha',20,2),(8,7402628,7402624,'han',20,2),(8,7402629,7402624,'ann',20,2),(8,7402630,7402624,'nne',20,2),(8,7402631,7402624,'nel',20,2),(8,7402632,7402627,'dis',50,2),(8,7402633,7402627,'isk',50,2),(8,7402634,7402632,'naa',100,4),(8,7402635,7402634,'600',3.333,4),(8,7402636,7402634,'00a',3.333,4),(8,7402637,7402634,'0a0',3.333,4),(8,7402638,7402634,'a09',3.333,4),(8,7402639,7402634,'098',3.333,4),(8,7402640,7402634,'980',3.333,4),(8,7402641,7402634,'804',3.333,4),(8,7402642,7402634,'044',3.333,4),(8,7402643,7402634,'443',3.333,4),(8,7402644,7402634,'430',3.333,4),(8,7402645,7402634,'307',3.333,4),(8,7402646,7402634,'072',3.333,4),(8,7402647,7402634,'725',3.333,4),(8,7402648,7402634,'259',3.333,4),(8,7402649,7402634,'593',3.333,4),(8,7402650,7402634,'931',3.333,4),(8,7402651,7402634,'313',3.333,4),(8,7402652,7402634,'13f',3.333,4),(8,7402653,7402634,'3f3',3.333,4),(8,7402654,7402634,'f33',3.333,4),(8,7402655,7402634,'334',3.333,4),(8,7402656,7402634,'345',3.333,4),(8,7402657,7402634,'455',3.333,4),(8,7402658,7402634,'556',3.333,4),(8,7402659,7402634,'563',3.333,4),(8,7402660,7402634,'639',3.333,4),(8,7402661,7402634,'393',3.333,4),(8,7402662,7402634,'934',3.333,4),(8,7402663,7402634,'346',3.333,4),(8,7402664,7402634,'464',3.333,4),(8,7402665,7402635,'ser',25,1),(8,7402666,7402635,'eri',25,1),(8,7402667,7402635,'ria',25,1),(8,7402668,7402635,'ial',25,1),(8,7402669,7402665,'siz',50,1),(8,7402670,7402665,'ize',50,1),(8,7402671,7402669,'321',100,1),(8,7402672,7402671,'dev',25,1),(8,7402673,7402671,'evi',25,1),(8,7402674,7402671,'vic',25,1),(8,7402675,7402671,'ice',25,1),(8,7402676,7402672,'typ',50,1),(8,7402677,7402672,'ype',50,1),(8,7402678,7402676,'dir',10,1),(8,7402679,7402676,'ire',10,1),(8,7402680,7402676,'rec',10,1),(8,7402681,7402676,'ect',10,1),(8,7402682,7402676,'cta',10,1),(8,7402683,7402676,'tac',10,1),(8,7402684,7402676,'acc',10,1),(8,7402685,7402676,'cce',10,1),(8,7402686,7402676,'ces',10,1),(8,7402687,7402676,'ess',10,1),(8,7402688,7402678,'mul',14.286,1),(8,7402689,7402678,'ult',14.286,1),(8,7402690,7402678,'lti',14.286,1),(8,7402691,7402678,'tip',14.286,1),(8,7402692,7402678,'ipa',14.286,1),(8,7402693,7402678,'pat',14.286,1),(8,7402694,7402678,'ath',14.286,1),(8,7402695,7402688,'plu',25,1),(8,7402696,7402688,'lug',25,1),(8,7402697,7402688,'ugi',25,1),(8,7402698,7402688,'gin',25,1),(8,7402699,7402695,'nmp',100,1),(8,7402700,7402699,'dev',33.333,1),(8,7402701,7402699,'evf',33.333,1),(8,7402702,7402699,'vfs',33.333,1),(8,7402703,7402700,'pat',50,1),(8,7402704,7402700,'ath',50,1),(8,7402705,7402703,'vmf',50,1),(8,7402706,7402703,'mfs',50,1),(8,7402707,7402705,'dev',20,1),(8,7402708,7402705,'evi',20,1),(8,7402709,7402705,'vic',20,1),(8,7402710,7402705,'ice',20,1),(8,7402711,7402705,'ces',20,1),(8,7402712,7402707,'dis',33.333,1),(8,7402713,7402707,'isk',33.333,1),(8,7402714,7402707,'sks',33.333,1),(8,7402715,7402712,'ven',25,1),(8,7402716,7402712,'end',25,1),(8,7402717,7402712,'ndo',25,1),(8,7402718,7402712,'dor',25,1),(8,7402719,7402715,'mod',33.333,1),(8,7402720,7402715,'ode',33.333,1),(8,7402721,7402715,'del',33.333,1),(8,7402722,7402719,'lun',100,1),(8,7402723,7402722,'cmo',33.333,1),(8,7402724,7402722,'mod',33.333,1),(8,7402725,7402722,'ode',33.333,1),(8,7402726,7402723,'rev',16.667,1),(8,7402727,7402723,'evi',16.667,1),(8,7402728,7402723,'vis',16.667,1),(8,7402729,7402723,'isi',16.667,1),(8,7402730,7402723,'sio',16.667,1),(8,7402731,7402723,'ion',16.667,1),(8,7402732,7402726,'810',50,1),(8,7402733,7402726,'100',50,1),(8,7402734,7402732,'scs',50,1),(8,7402735,7402732,'csi',50,1),(8,7402736,7402734,'lev',33.333,1),(8,7402737,7402734,'eve',33.333,1),(8,7402738,7402734,'vel',33.333,1),(8,7402739,7402736,'pse',25,1),(8,7402740,7402736,'seu',25,1),(8,7402741,7402736,'eud',25,1),(8,7402742,7402736,'udo',25,1),(8,7402743,7402739,'fal',33.333,6),(8,7402744,7402739,'als',33.333,6),(8,7402745,7402739,'lse',33.333,6),(8,7402746,7402743,'sta',25,3),(8,7402747,7402743,'tat',25,3),(8,7402748,7402743,'atu',25,3),(8,7402749,7402743,'tus',25,3),(8,7402750,7402746,'rdm',100,1),(8,7402751,7402750,'cap',20,1),(8,7402752,7402750,'apa',20,1),(8,7402753,7402750,'pab',20,1),(8,7402754,7402750,'abl',20,1),(8,7402755,7402750,'ble',20,1),(8,7402756,7402751,'tru',50,1),(8,7402757,7402751,'rue',50,1),(8,7402758,7402756,'loc',33.333,1),(8,7402759,7402756,'oca',33.333,1),(8,7402760,7402756,'cal',33.333,1),(8,7402761,7402758,'rem',14.286,1),(8,7402762,7402758,'emo',14.286,1),(8,7402763,7402758,'mov',14.286,1),(8,7402764,7402758,'ova',14.286,1),(8,7402765,7402758,'vab',14.286,1),(8,7402766,7402758,'abl',14.286,1),(8,7402767,7402758,'ble',14.286,1),(8,7402768,7402761,'ssd',100,1),(8,7402769,7402768,'off',20,1),(8,7402770,7402768,'ffl',20,1),(8,7402771,7402768,'fli',20,1),(8,7402772,7402768,'lin',20,1),(8,7402773,7402768,'ine',20,1),(8,7402774,7402769,'per',11.111,1),(8,7402775,7402769,'ere',11.111,1),(8,7402776,7402769,'ren',11.111,1),(8,7402777,7402769,'enn',11.111,1),(8,7402778,7402769,'nni',11.111,1),(8,7402779,7402769,'nia',11.111,1),(8,7402780,7402769,'ial',11.111,1),(8,7402781,7402769,'all',11.111,1),(8,7402782,7402769,'lly',11.111,1),(8,7402783,7402774,'res',16.667,1),(8,7402784,7402774,'ese',16.667,1),(8,7402785,7402774,'ser',16.667,1),(8,7402786,7402774,'erv',16.667,1),(8,7402787,7402774,'rve',16.667,1),(8,7402788,7402774,'ved',16.667,1),(8,7402789,7402783,'thi',50,1),(8,7402790,7402783,'hin',50,1),(8,7402791,7402789,'pro',10,1),(8,7402792,7402789,'rov',10,1),(8,7402793,7402789,'ovi',10,1),(8,7402794,7402789,'vis',10,1),(8,7402795,7402789,'isi',10,1),(8,7402796,7402789,'sio',10,1),(8,7402797,7402789,'ion',10,1),(8,7402798,7402789,'oni',10,1),(8,7402799,7402789,'nin',10,1),(8,7402800,7402789,'ing',10,1),(8,7402801,7402791,'yes',100,1),(8,7402802,7402801,'att',16.667,1),(8,7402803,7402801,'tta',16.667,1),(8,7402804,7402801,'tac',16.667,1),(8,7402805,7402801,'ach',16.667,1),(8,7402806,7402801,'che',16.667,1),(8,7402807,7402801,'hed',16.667,1),(8,7402808,7402802,'fil',20,1),(8,7402809,7402802,'ilt',20,1),(8,7402810,7402802,'lte',20,1),(8,7402811,7402802,'ter',20,1),(8,7402812,7402802,'ers',20,1),(8,7402813,7402808,'vaa',50,1),(8,7402814,7402808,'aai',50,1),(8,7402815,7402813,'unk',20,1),(8,7402816,7402813,'nkn',20,1),(8,7402817,7402813,'kno',20,1),(8,7402818,7402813,'now',20,1),(8,7402819,7402813,'own',20,1),(8,7402820,7402815,'oth',33.333,1),(8,7402821,7402815,'the',33.333,1),(8,7402822,7402815,'her',33.333,1),(8,7402823,7402820,'uid',50,1),(8,7402824,7402820,'ids',50,1),(8,7402825,7402823,'vml',100,1),(8,7402826,7402825,'dis',20,1),(8,7402827,7402825,'isp',20,1),(8,7402828,7402825,'spl',20,1),(8,7402829,7402825,'pla',20,1),(8,7402830,7402825,'lay',20,1),(8,7402831,7402826,'nam',50,1),(8,7402832,7402826,'ame',50,1),(9,7402834,7402833,'net',25,3),(9,7402835,7402833,'eta',25,3),(9,7402836,7402833,'tap',25,3),(9,7402837,7402833,'app',25,3),(9,7402838,7402834,'ser',25,3),(9,7402839,7402834,'eri',25,3),(9,7402840,7402834,'ria',25,3),(9,7402841,7402834,'ial',25,3),(9,7402842,7402838,'att',16.667,3),(9,7402843,7402838,'tta',16.667,3),(9,7402844,7402838,'tac',16.667,3),(9,7402845,7402838,'ach',16.667,3),(9,7402846,7402838,'che',16.667,3),(9,7402847,7402838,'hed',16.667,3),(9,7402848,7402842,'scs',50,3),(9,7402849,7402842,'csi',50,3),(9,7402850,7402848,'dis',50,2),(9,7402851,7402848,'isk',50,2),(9,7402852,7402850,'naa',100,4),(9,7402853,7402852,'600',3.333,4),(9,7402854,7402852,'00a',3.333,4),(9,7402855,7402852,'0a0',3.333,4),(9,7402856,7402852,'a09',3.333,4),(9,7402857,7402852,'098',3.333,4),(9,7402858,7402852,'980',3.333,4),(9,7402859,7402852,'80c',3.333,4),(9,7402860,7402852,'0c6',3.333,4),(9,7402861,7402852,'c66',3.333,4),(9,7402862,7402852,'667',3.333,4),(9,7402863,7402852,'678',3.333,4),(9,7402864,7402852,'784',3.333,4),(9,7402865,7402852,'84e',3.333,4),(9,7402866,7402852,'4ee',3.333,4),(9,7402867,7402852,'ee9',3.333,4),(9,7402868,7402852,'e99',3.333,4),(9,7402869,7402852,'99b',3.333,4),(9,7402870,7402852,'9b0',3.333,4),(9,7402871,7402852,'b04',3.333,4),(9,7402872,7402852,'04d',3.333,4),(9,7402873,7402852,'4d1',3.333,4),(9,7402874,7402852,'d11',3.333,4),(9,7402875,7402852,'117',3.333,4),(9,7402876,7402852,'17b',3.333,4),(9,7402877,7402852,'7b0',3.333,4),(9,7402878,7402852,'b0b',3.333,4),(9,7402879,7402852,'0ba',3.333,4),(9,7402880,7402852,'bab',3.333,4),(9,7402881,7402852,'aba',3.333,4),(9,7402882,7402852,'ba2',3.333,4),(9,7402883,7402853,'siz',50,1),(9,7402884,7402853,'ize',50,1),(9,7402885,7402883,'163',33.333,1),(9,7402886,7402883,'638',33.333,1),(9,7402887,7402883,'384',33.333,1),(9,7402888,7402885,'dev',25,1),(9,7402889,7402885,'evi',25,1),(9,7402890,7402885,'vic',25,1),(9,7402891,7402885,'ice',25,1),(9,7402892,7402888,'typ',50,1),(9,7402893,7402888,'ype',50,1),(9,7402894,7402892,'dir',10,1),(9,7402895,7402892,'ire',10,1),(9,7402896,7402892,'rec',10,1),(9,7402897,7402892,'ect',10,1),(9,7402898,7402892,'cta',10,1),(9,7402899,7402892,'tac',10,1),(9,7402900,7402892,'acc',10,1),(9,7402901,7402892,'cce',10,1),(9,7402902,7402892,'ces',10,1),(9,7402903,7402892,'ess',10,1),(9,7402904,7402894,'mul',14.286,1),(9,7402905,7402894,'ult',14.286,1),(9,7402906,7402894,'lti',14.286,1),(9,7402907,7402894,'tip',14.286,1),(9,7402908,7402894,'ipa',14.286,1),(9,7402909,7402894,'pat',14.286,1),(9,7402910,7402894,'ath',14.286,1),(9,7402911,7402904,'plu',25,1),(9,7402912,7402904,'lug',25,1),(9,7402913,7402904,'ugi',25,1),(9,7402914,7402904,'gin',25,1),(9,7402915,7402911,'nmp',100,1),(9,7402916,7402915,'dev',33.333,1),(9,7402917,7402915,'evf',33.333,1),(9,7402918,7402915,'vfs',33.333,1),(9,7402919,7402916,'pat',50,1),(9,7402920,7402916,'ath',50,1),(9,7402921,7402919,'vmf',50,1),(9,7402922,7402919,'mfs',50,1),(9,7402923,7402921,'dev',20,1),(9,7402924,7402921,'evi',20,1),(9,7402925,7402921,'vic',20,1),(9,7402926,7402921,'ice',20,1),(9,7402927,7402921,'ces',20,1),(9,7402928,7402923,'dis',33.333,1),(9,7402929,7402923,'isk',33.333,1),(9,7402930,7402923,'sks',33.333,1),(9,7402931,7402928,'ven',25,1),(9,7402932,7402928,'end',25,1),(9,7402933,7402928,'ndo',25,1),(9,7402934,7402928,'dor',25,1),(9,7402935,7402931,'mod',33.333,1),(9,7402936,7402931,'ode',33.333,1),(9,7402937,7402931,'del',33.333,1),(9,7402938,7402935,'fla',33.333,1),(9,7402939,7402935,'las',33.333,1),(9,7402940,7402935,'ash',33.333,1),(9,7402941,7402938,'acc',33.333,1),(9,7402942,7402938,'cce',33.333,1),(9,7402943,7402938,'cel',33.333,1),(9,7402944,7402941,'rev',16.667,1),(9,7402945,7402941,'evi',16.667,1),(9,7402946,7402941,'vis',16.667,1),(9,7402947,7402941,'isi',16.667,1),(9,7402948,7402941,'sio',16.667,1),(9,7402949,7402941,'ion',16.667,1),(9,7402950,7402944,'lev',33.333,1),(9,7402951,7402944,'eve',33.333,1),(9,7402952,7402944,'vel',33.333,1),(9,7402953,7402950,'pse',25,1),(9,7402954,7402950,'seu',25,1),(9,7402955,7402950,'eud',25,1),(9,7402956,7402950,'udo',25,1),(9,7402957,7402953,'fal',33.333,5),(9,7402958,7402953,'als',33.333,5),(9,7402959,7402953,'lse',33.333,5),(9,7402960,7402957,'sta',25,3),(9,7402961,7402957,'tat',25,3),(9,7402962,7402957,'atu',25,3),(9,7402963,7402957,'tus',25,3),(9,7402964,7402960,'deg',16.667,1),(9,7402965,7402960,'egr',16.667,1),(9,7402966,7402960,'gra',16.667,1),(9,7402967,7402960,'rad',16.667,1),(9,7402968,7402960,'ade',16.667,1),(9,7402969,7402960,'ded',16.667,1),(9,7402970,7402964,'rdm',100,1),(9,7402971,7402970,'cap',20,1),(9,7402972,7402970,'apa',20,1),(9,7402973,7402970,'pab',20,1),(9,7402974,7402970,'abl',20,1),(9,7402975,7402970,'ble',20,1),(9,7402976,7402971,'tru',50,2),(9,7402977,7402971,'rue',50,2),(9,7402978,7402976,'loc',33.333,1),(9,7402979,7402976,'oca',33.333,1),(9,7402980,7402976,'cal',33.333,1),(9,7402981,7402978,'rem',14.286,1),(9,7402982,7402978,'emo',14.286,1),(9,7402983,7402978,'mov',14.286,1),(9,7402984,7402978,'ova',14.286,1),(9,7402985,7402978,'vab',14.286,1),(9,7402986,7402978,'abl',14.286,1),(9,7402987,7402978,'ble',14.286,1),(9,7402988,7402981,'ssd',100,1),(9,7402989,7402988,'off',20,1),(9,7402990,7402988,'ffl',20,1),(9,7402991,7402988,'fli',20,1),(9,7402992,7402988,'lin',20,1),(9,7402993,7402988,'ine',20,1),(9,7402994,7402989,'per',11.111,1),(9,7402995,7402989,'ere',11.111,1),(9,7402996,7402989,'ren',11.111,1),(9,7402997,7402989,'enn',11.111,1),(9,7402998,7402989,'nni',11.111,1),(9,7402999,7402989,'nia',11.111,1),(9,7403000,7402989,'ial',11.111,1),(9,7403001,7402989,'all',11.111,1),(9,7403002,7402989,'lly',11.111,1),(9,7403003,7402994,'res',16.667,1),(9,7403004,7402994,'ese',16.667,1),(9,7403005,7402994,'ser',16.667,1),(9,7403006,7402994,'erv',16.667,1),(9,7403007,7402994,'rve',16.667,1),(9,7403008,7402994,'ved',16.667,1),(9,7403009,7403003,'thi',50,1),(9,7403010,7403003,'hin',50,1),(9,7403011,7403009,'pro',10,1),(9,7403012,7403009,'rov',10,1),(9,7403013,7403009,'ovi',10,1),(9,7403014,7403009,'vis',10,1),(9,7403015,7403009,'isi',10,1),(9,7403016,7403009,'sio',10,1),(9,7403017,7403009,'ion',10,1),(9,7403018,7403009,'oni',10,1),(9,7403019,7403009,'nin',10,1),(9,7403020,7403009,'ing',10,1),(9,7403021,7403011,'unk',20,1),(9,7403022,7403011,'nkn',20,1),(9,7403023,7403011,'kno',20,1),(9,7403024,7403011,'now',20,1),(9,7403025,7403011,'own',20,1),(9,7403026,7403021,'fil',20,1),(9,7403027,7403021,'ilt',20,1),(9,7403028,7403021,'lte',20,1),(9,7403029,7403021,'ter',20,1),(9,7403030,7403021,'ers',20,1),(9,7403031,7403026,'vaa',50,1),(9,7403032,7403026,'aai',50,1),(9,7403033,7403031,'uns',11.111,1),(9,7403034,7403031,'nsu',11.111,1),(9,7403035,7403031,'sup',11.111,1),(9,7403036,7403031,'upp',11.111,1),(9,7403037,7403031,'ppo',11.111,1),(9,7403038,7403031,'por',11.111,1),(9,7403039,7403031,'ort',11.111,1),(9,7403040,7403031,'rte',11.111,1),(9,7403041,7403031,'ted',11.111,1),(9,7403042,7403033,'oth',33.333,1),(9,7403043,7403033,'the',33.333,1),(9,7403044,7403033,'her',33.333,1),(9,7403045,7403042,'uid',50,1),(9,7403046,7403042,'ids',50,1),(9,7403047,7403045,'vml',100,1),(9,7403048,7403047,'dis',20,1),(9,7403049,7403047,'isp',20,1),(9,7403050,7403047,'spl',20,1),(9,7403051,7403047,'pla',20,1),(9,7403052,7403047,'lay',20,1),(9,7403053,7403048,'nam',50,1),(9,7403054,7403048,'ame',50,1),(10,7403056,7403055,'net',25,3),(10,7403057,7403055,'eta',25,3),(10,7403058,7403055,'tap',25,3),(10,7403059,7403055,'app',25,3),(10,7403060,7403056,'fib',33.333,2),(10,7403061,7403056,'ibr',33.333,2),(10,7403062,7403056,'bre',33.333,2),(10,7403063,7403060,'cha',20,2),(10,7403064,7403060,'han',20,2),(10,7403065,7403060,'ann',20,2),(10,7403066,7403060,'nne',20,2),(10,7403067,7403060,'nel',20,2),(10,7403068,7403063,'dis',50,2),(10,7403069,7403063,'isk',50,2),(10,7403070,7403068,'naa',100,4),(10,7403071,7403070,'600',3.333,4),(10,7403072,7403070,'00a',3.333,4),(10,7403073,7403070,'0a0',3.333,4),(10,7403074,7403070,'a09',3.333,4),(10,7403075,7403070,'098',3.333,4),(10,7403076,7403070,'980',3.333,4),(10,7403077,7403070,'804',3.333,4),(10,7403078,7403070,'044',3.333,4),(10,7403079,7403070,'443',3.333,4),(10,7403080,7403070,'430',3.333,4),(10,7403081,7403070,'307',3.333,4),(10,7403082,7403070,'072',3.333,4),(10,7403083,7403070,'725',3.333,4),(10,7403084,7403070,'259',3.333,4),(10,7403085,7403070,'593',3.333,4),(10,7403086,7403070,'931',3.333,4),(10,7403087,7403070,'313',3.333,4),(10,7403088,7403070,'13f',3.333,4),(10,7403089,7403070,'3f3',3.333,4),(10,7403090,7403070,'f33',3.333,4),(10,7403091,7403070,'334',3.333,4),(10,7403092,7403070,'345',3.333,4),(10,7403093,7403070,'455',3.333,4),(10,7403094,7403070,'556',3.333,4),(10,7403095,7403070,'563',3.333,4),(10,7403096,7403070,'639',3.333,4),(10,7403097,7403070,'393',3.333,4),(10,7403098,7403070,'934',3.333,4),(10,7403099,7403070,'346',3.333,4),(10,7403100,7403070,'465',3.333,4),(10,7403101,7403071,'ser',25,1),(10,7403102,7403071,'eri',25,1),(10,7403103,7403071,'ria',25,1),(10,7403104,7403071,'ial',25,1),(10,7403105,7403101,'siz',50,1),(10,7403106,7403101,'ize',50,1),(10,7403107,7403105,'321',100,1),(10,7403108,7403107,'dev',25,1),(10,7403109,7403107,'evi',25,1),(10,7403110,7403107,'vic',25,1),(10,7403111,7403107,'ice',25,1),(10,7403112,7403108,'typ',50,1),(10,7403113,7403108,'ype',50,1),(10,7403114,7403112,'dir',10,1),(10,7403115,7403112,'ire',10,1),(10,7403116,7403112,'rec',10,1),(10,7403117,7403112,'ect',10,1),(10,7403118,7403112,'cta',10,1),(10,7403119,7403112,'tac',10,1),(10,7403120,7403112,'acc',10,1),(10,7403121,7403112,'cce',10,1),(10,7403122,7403112,'ces',10,1),(10,7403123,7403112,'ess',10,1),(10,7403124,7403114,'mul',14.286,1),(10,7403125,7403114,'ult',14.286,1),(10,7403126,7403114,'lti',14.286,1),(10,7403127,7403114,'tip',14.286,1),(10,7403128,7403114,'ipa',14.286,1),(10,7403129,7403114,'pat',14.286,1),(10,7403130,7403114,'ath',14.286,1),(10,7403131,7403124,'plu',25,1),(10,7403132,7403124,'lug',25,1),(10,7403133,7403124,'ugi',25,1),(10,7403134,7403124,'gin',25,1),(10,7403135,7403131,'nmp',100,1),(10,7403136,7403135,'dev',33.333,1),(10,7403137,7403135,'evf',33.333,1),(10,7403138,7403135,'vfs',33.333,1),(10,7403139,7403136,'pat',50,1),(10,7403140,7403136,'ath',50,1),(10,7403141,7403139,'vmf',50,1),(10,7403142,7403139,'mfs',50,1),(10,7403143,7403141,'dev',20,1),(10,7403144,7403141,'evi',20,1),(10,7403145,7403141,'vic',20,1),(10,7403146,7403141,'ice',20,1),(10,7403147,7403141,'ces',20,1),(10,7403148,7403143,'dis',33.333,1),(10,7403149,7403143,'isk',33.333,1),(10,7403150,7403143,'sks',33.333,1),(10,7403151,7403148,'ven',25,1),(10,7403152,7403148,'end',25,1),(10,7403153,7403148,'ndo',25,1),(10,7403154,7403148,'dor',25,1),(10,7403155,7403151,'mod',33.333,1),(10,7403156,7403151,'ode',33.333,1),(10,7403157,7403151,'del',33.333,1),(10,7403158,7403155,'lun',100,1),(10,7403159,7403158,'cmo',33.333,1),(10,7403160,7403158,'mod',33.333,1),(10,7403161,7403158,'ode',33.333,1),(10,7403162,7403159,'rev',16.667,1),(10,7403163,7403159,'evi',16.667,1),(10,7403164,7403159,'vis',16.667,1),(10,7403165,7403159,'isi',16.667,1),(10,7403166,7403159,'sio',16.667,1),(10,7403167,7403159,'ion',16.667,1),(10,7403168,7403162,'810',50,1),(10,7403169,7403162,'100',50,1),(10,7403170,7403168,'scs',50,1),(10,7403171,7403168,'csi',50,1),(10,7403172,7403170,'lev',33.333,1),(10,7403173,7403170,'eve',33.333,1),(10,7403174,7403170,'vel',33.333,1),(10,7403175,7403172,'pse',25,1),(10,7403176,7403172,'seu',25,1),(10,7403177,7403172,'eud',25,1),(10,7403178,7403172,'udo',25,1),(10,7403179,7403175,'fal',33.333,6),(10,7403180,7403175,'als',33.333,6),(10,7403181,7403175,'lse',33.333,6),(10,7403182,7403179,'sta',25,3),(10,7403183,7403179,'tat',25,3),(10,7403184,7403179,'atu',25,3),(10,7403185,7403179,'tus',25,3),(10,7403186,7403182,'rdm',100,1),(10,7403187,7403186,'cap',20,1),(10,7403188,7403186,'apa',20,1),(10,7403189,7403186,'pab',20,1),(10,7403190,7403186,'abl',20,1),(10,7403191,7403186,'ble',20,1),(10,7403192,7403187,'tru',50,1),(10,7403193,7403187,'rue',50,1),(10,7403194,7403192,'loc',33.333,1),(10,7403195,7403192,'oca',33.333,1),(10,7403196,7403192,'cal',33.333,1),(10,7403197,7403194,'rem',14.286,1),(10,7403198,7403194,'emo',14.286,1),(10,7403199,7403194,'mov',14.286,1),(10,7403200,7403194,'ova',14.286,1),(10,7403201,7403194,'vab',14.286,1),(10,7403202,7403194,'abl',14.286,1),(10,7403203,7403194,'ble',14.286,1),(10,7403204,7403197,'ssd',100,1),(10,7403205,7403204,'off',20,1),(10,7403206,7403204,'ffl',20,1),(10,7403207,7403204,'fli',20,1),(10,7403208,7403204,'lin',20,1),(10,7403209,7403204,'ine',20,1),(10,7403210,7403205,'per',11.111,1),(10,7403211,7403205,'ere',11.111,1),(10,7403212,7403205,'ren',11.111,1),(10,7403213,7403205,'enn',11.111,1),(10,7403214,7403205,'nni',11.111,1),(10,7403215,7403205,'nia',11.111,1),(10,7403216,7403205,'ial',11.111,1),(10,7403217,7403205,'all',11.111,1),(10,7403218,7403205,'lly',11.111,1),(10,7403219,7403210,'res',16.667,1),(10,7403220,7403210,'ese',16.667,1),(10,7403221,7403210,'ser',16.667,1),(10,7403222,7403210,'erv',16.667,1),(10,7403223,7403210,'rve',16.667,1),(10,7403224,7403210,'ved',16.667,1),(10,7403225,7403219,'thi',50,1),(10,7403226,7403219,'hin',50,1),(10,7403227,7403225,'pro',10,1),(10,7403228,7403225,'rov',10,1),(10,7403229,7403225,'ovi',10,1),(10,7403230,7403225,'vis',10,1),(10,7403231,7403225,'isi',10,1),(10,7403232,7403225,'sio',10,1),(10,7403233,7403225,'ion',10,1),(10,7403234,7403225,'oni',10,1),(10,7403235,7403225,'nin',10,1),(10,7403236,7403225,'ing',10,1),(10,7403237,7403227,'yes',100,1),(10,7403238,7403237,'att',16.667,1),(10,7403239,7403237,'tta',16.667,1),(10,7403240,7403237,'tac',16.667,1),(10,7403241,7403237,'ach',16.667,1),(10,7403242,7403237,'che',16.667,1),(10,7403243,7403237,'hed',16.667,1),(10,7403244,7403238,'fil',20,1),(10,7403245,7403238,'ilt',20,1),(10,7403246,7403238,'lte',20,1),(10,7403247,7403238,'ter',20,1),(10,7403248,7403238,'ers',20,1),(10,7403249,7403244,'vaa',50,1),(10,7403250,7403244,'aai',50,1),(10,7403251,7403249,'unk',20,1),(10,7403252,7403249,'nkn',20,1),(10,7403253,7403249,'kno',20,1),(10,7403254,7403249,'now',20,1),(10,7403255,7403249,'own',20,1),(10,7403256,7403251,'oth',33.333,1),(10,7403257,7403251,'the',33.333,1),(10,7403258,7403251,'her',33.333,1),(10,7403259,7403256,'uid',50,1),(10,7403260,7403256,'ids',50,1),(10,7403261,7403259,'vml',100,1),(10,7403262,7403261,'dis',20,1),(10,7403263,7403261,'isp',20,1),(10,7403264,7403261,'spl',20,1),(10,7403265,7403261,'pla',20,1),(10,7403266,7403261,'lay',20,1),(10,7403267,7403262,'nam',50,1),(10,7403268,7403262,'ame',50,1),(11,7403270,7403269,'net',25,3),(11,7403271,7403269,'eta',25,3),(11,7403272,7403269,'tap',25,3),(11,7403273,7403269,'app',25,3),(11,7403274,7403270,'fib',33.333,2),(11,7403275,7403270,'ibr',33.333,2),(11,7403276,7403270,'bre',33.333,2),(11,7403277,7403274,'cha',20,2),(11,7403278,7403274,'han',20,2),(11,7403279,7403274,'ann',20,2),(11,7403280,7403274,'nne',20,2),(11,7403281,7403274,'nel',20,2),(11,7403282,7403277,'dis',50,2),(11,7403283,7403277,'isk',50,2),(11,7403284,7403282,'naa',100,4),(11,7403285,7403284,'600',3.333,4),(11,7403286,7403284,'00a',3.333,4),(11,7403287,7403284,'0a0',3.333,4),(11,7403288,7403284,'a09',3.333,4),(11,7403289,7403284,'098',3.333,4),(11,7403290,7403284,'980',3.333,4),(11,7403291,7403284,'804',3.333,4),(11,7403292,7403284,'044',3.333,4),(11,7403293,7403284,'443',3.333,4),(11,7403294,7403284,'430',3.333,4),(11,7403295,7403284,'307',3.333,4),(11,7403296,7403284,'072',3.333,4),(11,7403297,7403284,'725',3.333,4),(11,7403298,7403284,'259',3.333,4),(11,7403299,7403284,'593',3.333,4),(11,7403300,7403284,'931',3.333,4),(11,7403301,7403284,'313',3.333,4),(11,7403302,7403284,'13f',3.333,4),(11,7403303,7403284,'3f3',3.333,4),(11,7403304,7403284,'f33',3.333,4),(11,7403305,7403284,'334',3.333,4),(11,7403306,7403284,'345',3.333,4),(11,7403307,7403284,'455',3.333,4),(11,7403308,7403284,'556',3.333,4),(11,7403309,7403284,'563',3.333,4),(11,7403310,7403284,'639',3.333,4),(11,7403311,7403284,'393',3.333,4),(11,7403312,7403284,'934',3.333,4),(11,7403313,7403284,'346',3.333,4),(11,7403314,7403284,'466',3.333,4),(11,7403315,7403285,'ser',25,1),(11,7403316,7403285,'eri',25,1),(11,7403317,7403285,'ria',25,1),(11,7403318,7403285,'ial',25,1),(11,7403319,7403315,'siz',50,1),(11,7403320,7403315,'ize',50,1),(11,7403321,7403319,'321',100,1),(11,7403322,7403321,'dev',25,1),(11,7403323,7403321,'evi',25,1),(11,7403324,7403321,'vic',25,1),(11,7403325,7403321,'ice',25,1),(11,7403326,7403322,'typ',50,1),(11,7403327,7403322,'ype',50,1),(11,7403328,7403326,'dir',10,1),(11,7403329,7403326,'ire',10,1),(11,7403330,7403326,'rec',10,1),(11,7403331,7403326,'ect',10,1),(11,7403332,7403326,'cta',10,1),(11,7403333,7403326,'tac',10,1),(11,7403334,7403326,'acc',10,1),(11,7403335,7403326,'cce',10,1),(11,7403336,7403326,'ces',10,1),(11,7403337,7403326,'ess',10,1),(11,7403338,7403328,'mul',14.286,1),(11,7403339,7403328,'ult',14.286,1),(11,7403340,7403328,'lti',14.286,1),(11,7403341,7403328,'tip',14.286,1),(11,7403342,7403328,'ipa',14.286,1),(11,7403343,7403328,'pat',14.286,1),(11,7403344,7403328,'ath',14.286,1),(11,7403345,7403338,'plu',25,1),(11,7403346,7403338,'lug',25,1),(11,7403347,7403338,'ugi',25,1),(11,7403348,7403338,'gin',25,1),(11,7403349,7403345,'nmp',100,1),(11,7403350,7403349,'dev',33.333,1),(11,7403351,7403349,'evf',33.333,1),(11,7403352,7403349,'vfs',33.333,1),(11,7403353,7403350,'pat',50,1),(11,7403354,7403350,'ath',50,1),(11,7403355,7403353,'vmf',50,1),(11,7403356,7403353,'mfs',50,1),(11,7403357,7403355,'dev',20,1),(11,7403358,7403355,'evi',20,1),(11,7403359,7403355,'vic',20,1),(11,7403360,7403355,'ice',20,1),(11,7403361,7403355,'ces',20,1),(11,7403362,7403357,'dis',33.333,1),(11,7403363,7403357,'isk',33.333,1),(11,7403364,7403357,'sks',33.333,1),(11,7403365,7403362,'ven',25,1),(11,7403366,7403362,'end',25,1),(11,7403367,7403362,'ndo',25,1),(11,7403368,7403362,'dor',25,1),(11,7403369,7403365,'mod',33.333,1),(11,7403370,7403365,'ode',33.333,1),(11,7403371,7403365,'del',33.333,1),(11,7403372,7403369,'lun',100,1),(11,7403373,7403372,'cmo',33.333,1),(11,7403374,7403372,'mod',33.333,1),(11,7403375,7403372,'ode',33.333,1),(11,7403376,7403373,'rev',16.667,1),(11,7403377,7403373,'evi',16.667,1),(11,7403378,7403373,'vis',16.667,1),(11,7403379,7403373,'isi',16.667,1),(11,7403380,7403373,'sio',16.667,1),(11,7403381,7403373,'ion',16.667,1),(11,7403382,7403376,'810',50,1),(11,7403383,7403376,'100',50,1),(11,7403384,7403382,'scs',50,1),(11,7403385,7403382,'csi',50,1),(11,7403386,7403384,'lev',33.333,1),(11,7403387,7403384,'eve',33.333,1),(11,7403388,7403384,'vel',33.333,1),(11,7403389,7403386,'pse',25,1),(11,7403390,7403386,'seu',25,1),(11,7403391,7403386,'eud',25,1),(11,7403392,7403386,'udo',25,1),(11,7403393,7403389,'fal',33.333,6),(11,7403394,7403389,'als',33.333,6),(11,7403395,7403389,'lse',33.333,6),(11,7403396,7403393,'sta',25,3),(11,7403397,7403393,'tat',25,3),(11,7403398,7403393,'atu',25,3),(11,7403399,7403393,'tus',25,3),(11,7403400,7403396,'rdm',100,1),(11,7403401,7403400,'cap',20,1),(11,7403402,7403400,'apa',20,1),(11,7403403,7403400,'pab',20,1),(11,7403404,7403400,'abl',20,1),(11,7403405,7403400,'ble',20,1),(11,7403406,7403401,'tru',50,1),(11,7403407,7403401,'rue',50,1),(11,7403408,7403406,'loc',33.333,1),(11,7403409,7403406,'oca',33.333,1),(11,7403410,7403406,'cal',33.333,1),(11,7403411,7403408,'rem',14.286,1),(11,7403412,7403408,'emo',14.286,1),(11,7403413,7403408,'mov',14.286,1),(11,7403414,7403408,'ova',14.286,1),(11,7403415,7403408,'vab',14.286,1),(11,7403416,7403408,'abl',14.286,1),(11,7403417,7403408,'ble',14.286,1),(11,7403418,7403411,'ssd',100,1),(11,7403419,7403418,'off',20,1),(11,7403420,7403418,'ffl',20,1),(11,7403421,7403418,'fli',20,1),(11,7403422,7403418,'lin',20,1),(11,7403423,7403418,'ine',20,1),(11,7403424,7403419,'per',11.111,1),(11,7403425,7403419,'ere',11.111,1),(11,7403426,7403419,'ren',11.111,1),(11,7403427,7403419,'enn',11.111,1),(11,7403428,7403419,'nni',11.111,1),(11,7403429,7403419,'nia',11.111,1),(11,7403430,7403419,'ial',11.111,1),(11,7403431,7403419,'all',11.111,1),(11,7403432,7403419,'lly',11.111,1),(11,7403433,7403424,'res',16.667,1),(11,7403434,7403424,'ese',16.667,1),(11,7403435,7403424,'ser',16.667,1),(11,7403436,7403424,'erv',16.667,1),(11,7403437,7403424,'rve',16.667,1),(11,7403438,7403424,'ved',16.667,1),(11,7403439,7403433,'thi',50,1),(11,7403440,7403433,'hin',50,1),(11,7403441,7403439,'pro',10,1),(11,7403442,7403439,'rov',10,1),(11,7403443,7403439,'ovi',10,1),(11,7403444,7403439,'vis',10,1),(11,7403445,7403439,'isi',10,1),(11,7403446,7403439,'sio',10,1),(11,7403447,7403439,'ion',10,1),(11,7403448,7403439,'oni',10,1),(11,7403449,7403439,'nin',10,1),(11,7403450,7403439,'ing',10,1),(11,7403451,7403441,'yes',100,1),(11,7403452,7403451,'att',16.667,1),(11,7403453,7403451,'tta',16.667,1),(11,7403454,7403451,'tac',16.667,1),(11,7403455,7403451,'ach',16.667,1),(11,7403456,7403451,'che',16.667,1),(11,7403457,7403451,'hed',16.667,1),(11,7403458,7403452,'fil',20,1),(11,7403459,7403452,'ilt',20,1),(11,7403460,7403452,'lte',20,1),(11,7403461,7403452,'ter',20,1),(11,7403462,7403452,'ers',20,1),(11,7403463,7403458,'vaa',50,1),(11,7403464,7403458,'aai',50,1),(11,7403465,7403463,'unk',20,1),(11,7403466,7403463,'nkn',20,1),(11,7403467,7403463,'kno',20,1),(11,7403468,7403463,'now',20,1),(11,7403469,7403463,'own',20,1),(11,7403470,7403465,'oth',33.333,1),(11,7403471,7403465,'the',33.333,1),(11,7403472,7403465,'her',33.333,1),(11,7403473,7403470,'uid',50,1),(11,7403474,7403470,'ids',50,1),(11,7403475,7403473,'vml',100,1),(11,7403476,7403475,'dis',20,1),(11,7403477,7403475,'isp',20,1),(11,7403478,7403475,'spl',20,1),(11,7403479,7403475,'pla',20,1),(11,7403480,7403475,'lay',20,1),(11,7403481,7403476,'nam',50,1),(11,7403482,7403476,'ame',50,1),(12,7403484,7403483,'net',25,3),(12,7403485,7403483,'eta',25,3),(12,7403486,7403483,'tap',25,3),(12,7403487,7403483,'app',25,3),(12,7403488,7403484,'fib',33.333,2),(12,7403489,7403484,'ibr',33.333,2),(12,7403490,7403484,'bre',33.333,2),(12,7403491,7403488,'cha',20,2),(12,7403492,7403488,'han',20,2),(12,7403493,7403488,'ann',20,2),(12,7403494,7403488,'nne',20,2),(12,7403495,7403488,'nel',20,2),(12,7403496,7403491,'dis',50,2),(12,7403497,7403491,'isk',50,2),(12,7403498,7403496,'naa',100,4),(12,7403499,7403498,'600',3.333,4),(12,7403500,7403498,'00a',3.333,4),(12,7403501,7403498,'0a0',3.333,4),(12,7403502,7403498,'a09',3.333,4),(12,7403503,7403498,'098',3.333,4),(12,7403504,7403498,'980',3.333,4),(12,7403505,7403498,'804',3.333,4),(12,7403506,7403498,'044',3.333,4),(12,7403507,7403498,'443',3.333,4),(12,7403508,7403498,'430',3.333,4),(12,7403509,7403498,'307',3.333,4),(12,7403510,7403498,'072',3.333,4),(12,7403511,7403498,'725',3.333,4),(12,7403512,7403498,'259',3.333,4),(12,7403513,7403498,'593',3.333,4),(12,7403514,7403498,'931',3.333,4),(12,7403515,7403498,'313',3.333,4),(12,7403516,7403498,'13f',3.333,4),(12,7403517,7403498,'3f3',3.333,4),(12,7403518,7403498,'f33',3.333,4),(12,7403519,7403498,'334',3.333,4),(12,7403520,7403498,'345',3.333,4),(12,7403521,7403498,'455',3.333,4),(12,7403522,7403498,'556',3.333,4),(12,7403523,7403498,'563',3.333,4),(12,7403524,7403498,'639',3.333,4),(12,7403525,7403498,'393',3.333,4),(12,7403526,7403498,'934',3.333,4),(12,7403527,7403498,'346',3.333,4),(12,7403528,7403498,'467',3.333,4),(12,7403529,7403499,'ser',25,1),(12,7403530,7403499,'eri',25,1),(12,7403531,7403499,'ria',25,1),(12,7403532,7403499,'ial',25,1),(12,7403533,7403529,'siz',50,1),(12,7403534,7403529,'ize',50,1),(12,7403535,7403533,'321',100,1),(12,7403536,7403535,'dev',25,1),(12,7403537,7403535,'evi',25,1),(12,7403538,7403535,'vic',25,1),(12,7403539,7403535,'ice',25,1),(12,7403540,7403536,'typ',50,1),(12,7403541,7403536,'ype',50,1),(12,7403542,7403540,'dir',10,1),(12,7403543,7403540,'ire',10,1),(12,7403544,7403540,'rec',10,1),(12,7403545,7403540,'ect',10,1),(12,7403546,7403540,'cta',10,1),(12,7403547,7403540,'tac',10,1),(12,7403548,7403540,'acc',10,1),(12,7403549,7403540,'cce',10,1),(12,7403550,7403540,'ces',10,1),(12,7403551,7403540,'ess',10,1),(12,7403552,7403542,'mul',14.286,1),(12,7403553,7403542,'ult',14.286,1),(12,7403554,7403542,'lti',14.286,1),(12,7403555,7403542,'tip',14.286,1),(12,7403556,7403542,'ipa',14.286,1),(12,7403557,7403542,'pat',14.286,1),(12,7403558,7403542,'ath',14.286,1),(12,7403559,7403552,'plu',25,1),(12,7403560,7403552,'lug',25,1),(12,7403561,7403552,'ugi',25,1),(12,7403562,7403552,'gin',25,1),(12,7403563,7403559,'nmp',100,1),(12,7403564,7403563,'dev',33.333,1),(12,7403565,7403563,'evf',33.333,1),(12,7403566,7403563,'vfs',33.333,1),(12,7403567,7403564,'pat',50,1),(12,7403568,7403564,'ath',50,1),(12,7403569,7403567,'vmf',50,1),(12,7403570,7403567,'mfs',50,1),(12,7403571,7403569,'dev',20,1),(12,7403572,7403569,'evi',20,1),(12,7403573,7403569,'vic',20,1),(12,7403574,7403569,'ice',20,1),(12,7403575,7403569,'ces',20,1),(12,7403576,7403571,'dis',33.333,1),(12,7403577,7403571,'isk',33.333,1),(12,7403578,7403571,'sks',33.333,1),(12,7403579,7403576,'ven',25,1),(12,7403580,7403576,'end',25,1),(12,7403581,7403576,'ndo',25,1),(12,7403582,7403576,'dor',25,1),(12,7403583,7403579,'mod',33.333,1),(12,7403584,7403579,'ode',33.333,1),(12,7403585,7403579,'del',33.333,1),(12,7403586,7403583,'lun',100,1),(12,7403587,7403586,'cmo',33.333,1),(12,7403588,7403586,'mod',33.333,1),(12,7403589,7403586,'ode',33.333,1),(12,7403590,7403587,'rev',16.667,1),(12,7403591,7403587,'evi',16.667,1),(12,7403592,7403587,'vis',16.667,1),(12,7403593,7403587,'isi',16.667,1),(12,7403594,7403587,'sio',16.667,1),(12,7403595,7403587,'ion',16.667,1),(12,7403596,7403590,'810',50,1),(12,7403597,7403590,'100',50,1),(12,7403598,7403596,'scs',50,1),(12,7403599,7403596,'csi',50,1),(12,7403600,7403598,'lev',33.333,1),(12,7403601,7403598,'eve',33.333,1),(12,7403602,7403598,'vel',33.333,1),(12,7403603,7403600,'pse',25,1),(12,7403604,7403600,'seu',25,1),(12,7403605,7403600,'eud',25,1),(12,7403606,7403600,'udo',25,1),(12,7403607,7403603,'fal',33.333,6),(12,7403608,7403603,'als',33.333,6),(12,7403609,7403603,'lse',33.333,6),(12,7403610,7403607,'sta',25,3),(12,7403611,7403607,'tat',25,3),(12,7403612,7403607,'atu',25,3),(12,7403613,7403607,'tus',25,3),(12,7403614,7403610,'rdm',100,1),(12,7403615,7403614,'cap',20,1),(12,7403616,7403614,'apa',20,1),(12,7403617,7403614,'pab',20,1),(12,7403618,7403614,'abl',20,1),(12,7403619,7403614,'ble',20,1),(12,7403620,7403615,'tru',50,1),(12,7403621,7403615,'rue',50,1),(12,7403622,7403620,'loc',33.333,1),(12,7403623,7403620,'oca',33.333,1),(12,7403624,7403620,'cal',33.333,1),(12,7403625,7403622,'rem',14.286,1),(12,7403626,7403622,'emo',14.286,1),(12,7403627,7403622,'mov',14.286,1),(12,7403628,7403622,'ova',14.286,1),(12,7403629,7403622,'vab',14.286,1),(12,7403630,7403622,'abl',14.286,1),(12,7403631,7403622,'ble',14.286,1),(12,7403632,7403625,'ssd',100,1),(12,7403633,7403632,'off',20,1),(12,7403634,7403632,'ffl',20,1),(12,7403635,7403632,'fli',20,1),(12,7403636,7403632,'lin',20,1),(12,7403637,7403632,'ine',20,1),(12,7403638,7403633,'per',11.111,1),(12,7403639,7403633,'ere',11.111,1),(12,7403640,7403633,'ren',11.111,1),(12,7403641,7403633,'enn',11.111,1),(12,7403642,7403633,'nni',11.111,1),(12,7403643,7403633,'nia',11.111,1),(12,7403644,7403633,'ial',11.111,1),(12,7403645,7403633,'all',11.111,1),(12,7403646,7403633,'lly',11.111,1),(12,7403647,7403638,'res',16.667,1),(12,7403648,7403638,'ese',16.667,1),(12,7403649,7403638,'ser',16.667,1),(12,7403650,7403638,'erv',16.667,1),(12,7403651,7403638,'rve',16.667,1),(12,7403652,7403638,'ved',16.667,1),(12,7403653,7403647,'thi',50,1),(12,7403654,7403647,'hin',50,1),(12,7403655,7403653,'pro',10,1),(12,7403656,7403653,'rov',10,1),(12,7403657,7403653,'ovi',10,1),(12,7403658,7403653,'vis',10,1),(12,7403659,7403653,'isi',10,1),(12,7403660,7403653,'sio',10,1),(12,7403661,7403653,'ion',10,1),(12,7403662,7403653,'oni',10,1),(12,7403663,7403653,'nin',10,1),(12,7403664,7403653,'ing',10,1),(12,7403665,7403655,'yes',100,1),(12,7403666,7403665,'att',16.667,1),(12,7403667,7403665,'tta',16.667,1),(12,7403668,7403665,'tac',16.667,1),(12,7403669,7403665,'ach',16.667,1),(12,7403670,7403665,'che',16.667,1),(12,7403671,7403665,'hed',16.667,1),(12,7403672,7403666,'fil',20,1),(12,7403673,7403666,'ilt',20,1),(12,7403674,7403666,'lte',20,1),(12,7403675,7403666,'ter',20,1),(12,7403676,7403666,'ers',20,1),(12,7403677,7403672,'vaa',50,1),(12,7403678,7403672,'aai',50,1),(12,7403679,7403677,'unk',20,1),(12,7403680,7403677,'nkn',20,1),(12,7403681,7403677,'kno',20,1),(12,7403682,7403677,'now',20,1),(12,7403683,7403677,'own',20,1),(12,7403684,7403679,'oth',33.333,1),(12,7403685,7403679,'the',33.333,1),(12,7403686,7403679,'her',33.333,1),(12,7403687,7403684,'uid',50,1),(12,7403688,7403684,'ids',50,1),(12,7403689,7403687,'vml',100,1),(12,7403690,7403689,'dis',20,1),(12,7403691,7403689,'isp',20,1),(12,7403692,7403689,'spl',20,1),(12,7403693,7403689,'pla',20,1),(12,7403694,7403689,'lay',20,1),(12,7403695,7403690,'nam',50,1),(12,7403696,7403690,'ame',50,1),(13,7403698,7403697,'net',25,3),(13,7403699,7403697,'eta',25,3),(13,7403700,7403697,'tap',25,3),(13,7403701,7403697,'app',25,3),(13,7403702,7403698,'fib',33.333,2),(13,7403703,7403698,'ibr',33.333,2),(13,7403704,7403698,'bre',33.333,2),(13,7403705,7403702,'cha',20,2),(13,7403706,7403702,'han',20,2),(13,7403707,7403702,'ann',20,2),(13,7403708,7403702,'nne',20,2),(13,7403709,7403702,'nel',20,2),(13,7403710,7403705,'dis',50,2),(13,7403711,7403705,'isk',50,2),(13,7403712,7403710,'naa',100,4),(13,7403713,7403712,'600',3.333,4),(13,7403714,7403712,'00a',3.333,4),(13,7403715,7403712,'0a0',3.333,4),(13,7403716,7403712,'a09',3.333,4),(13,7403717,7403712,'098',3.333,4),(13,7403718,7403712,'980',3.333,4),(13,7403719,7403712,'804',3.333,4),(13,7403720,7403712,'044',3.333,4),(13,7403721,7403712,'443',3.333,4),(13,7403722,7403712,'430',3.333,4),(13,7403723,7403712,'307',3.333,4),(13,7403724,7403712,'072',3.333,4),(13,7403725,7403712,'725',3.333,4),(13,7403726,7403712,'259',3.333,4),(13,7403727,7403712,'593',3.333,4),(13,7403728,7403712,'931',3.333,4),(13,7403729,7403712,'313',3.333,4),(13,7403730,7403712,'13f',3.333,4),(13,7403731,7403712,'3f3',3.333,4),(13,7403732,7403712,'f33',3.333,4),(13,7403733,7403712,'334',3.333,4),(13,7403734,7403712,'345',3.333,4),(13,7403735,7403712,'455',3.333,4),(13,7403736,7403712,'556',3.333,4),(13,7403737,7403712,'563',3.333,4),(13,7403738,7403712,'639',3.333,4),(13,7403739,7403712,'393',3.333,4),(13,7403740,7403712,'934',3.333,4),(13,7403741,7403712,'346',3.333,4),(13,7403742,7403712,'468',3.333,4),(13,7403743,7403713,'ser',25,1),(13,7403744,7403713,'eri',25,1),(13,7403745,7403713,'ria',25,1),(13,7403746,7403713,'ial',25,1),(13,7403747,7403743,'siz',50,1),(13,7403748,7403743,'ize',50,1),(13,7403749,7403747,'321',100,1),(13,7403750,7403749,'dev',25,1),(13,7403751,7403749,'evi',25,1),(13,7403752,7403749,'vic',25,1),(13,7403753,7403749,'ice',25,1),(13,7403754,7403750,'typ',50,1),(13,7403755,7403750,'ype',50,1),(13,7403756,7403754,'dir',10,1),(13,7403757,7403754,'ire',10,1),(13,7403758,7403754,'rec',10,1),(13,7403759,7403754,'ect',10,1),(13,7403760,7403754,'cta',10,1),(13,7403761,7403754,'tac',10,1),(13,7403762,7403754,'acc',10,1),(13,7403763,7403754,'cce',10,1),(13,7403764,7403754,'ces',10,1),(13,7403765,7403754,'ess',10,1),(13,7403766,7403756,'mul',14.286,1),(13,7403767,7403756,'ult',14.286,1),(13,7403768,7403756,'lti',14.286,1),(13,7403769,7403756,'tip',14.286,1),(13,7403770,7403756,'ipa',14.286,1),(13,7403771,7403756,'pat',14.286,1),(13,7403772,7403756,'ath',14.286,1),(13,7403773,7403766,'plu',25,1),(13,7403774,7403766,'lug',25,1),(13,7403775,7403766,'ugi',25,1),(13,7403776,7403766,'gin',25,1),(13,7403777,7403773,'nmp',100,1),(13,7403778,7403777,'dev',33.333,1),(13,7403779,7403777,'evf',33.333,1),(13,7403780,7403777,'vfs',33.333,1),(13,7403781,7403778,'pat',50,1),(13,7403782,7403778,'ath',50,1),(13,7403783,7403781,'vmf',50,1),(13,7403784,7403781,'mfs',50,1),(13,7403785,7403783,'dev',20,1),(13,7403786,7403783,'evi',20,1),(13,7403787,7403783,'vic',20,1),(13,7403788,7403783,'ice',20,1),(13,7403789,7403783,'ces',20,1),(13,7403790,7403785,'dis',33.333,1),(13,7403791,7403785,'isk',33.333,1),(13,7403792,7403785,'sks',33.333,1),(13,7403793,7403790,'ven',25,1),(13,7403794,7403790,'end',25,1),(13,7403795,7403790,'ndo',25,1),(13,7403796,7403790,'dor',25,1),(13,7403797,7403793,'mod',33.333,1),(13,7403798,7403793,'ode',33.333,1),(13,7403799,7403793,'del',33.333,1),(13,7403800,7403797,'lun',100,1),(13,7403801,7403800,'cmo',33.333,1),(13,7403802,7403800,'mod',33.333,1),(13,7403803,7403800,'ode',33.333,1),(13,7403804,7403801,'rev',16.667,1),(13,7403805,7403801,'evi',16.667,1),(13,7403806,7403801,'vis',16.667,1),(13,7403807,7403801,'isi',16.667,1),(13,7403808,7403801,'sio',16.667,1),(13,7403809,7403801,'ion',16.667,1),(13,7403810,7403804,'810',50,1),(13,7403811,7403804,'100',50,1),(13,7403812,7403810,'scs',50,1),(13,7403813,7403810,'csi',50,1),(13,7403814,7403812,'lev',33.333,1),(13,7403815,7403812,'eve',33.333,1),(13,7403816,7403812,'vel',33.333,1),(13,7403817,7403814,'pse',25,1),(13,7403818,7403814,'seu',25,1),(13,7403819,7403814,'eud',25,1),(13,7403820,7403814,'udo',25,1),(13,7403821,7403817,'fal',33.333,6),(13,7403822,7403817,'als',33.333,6),(13,7403823,7403817,'lse',33.333,6),(13,7403824,7403821,'sta',25,3),(13,7403825,7403821,'tat',25,3),(13,7403826,7403821,'atu',25,3),(13,7403827,7403821,'tus',25,3),(13,7403828,7403824,'rdm',100,1),(13,7403829,7403828,'cap',20,1),(13,7403830,7403828,'apa',20,1),(13,7403831,7403828,'pab',20,1),(13,7403832,7403828,'abl',20,1),(13,7403833,7403828,'ble',20,1),(13,7403834,7403829,'tru',50,1),(13,7403835,7403829,'rue',50,1),(13,7403836,7403834,'loc',33.333,1),(13,7403837,7403834,'oca',33.333,1),(13,7403838,7403834,'cal',33.333,1),(13,7403839,7403836,'rem',14.286,1),(13,7403840,7403836,'emo',14.286,1),(13,7403841,7403836,'mov',14.286,1),(13,7403842,7403836,'ova',14.286,1),(13,7403843,7403836,'vab',14.286,1),(13,7403844,7403836,'abl',14.286,1),(13,7403845,7403836,'ble',14.286,1),(13,7403846,7403839,'ssd',100,1),(13,7403847,7403846,'off',20,1),(13,7403848,7403846,'ffl',20,1),(13,7403849,7403846,'fli',20,1),(13,7403850,7403846,'lin',20,1),(13,7403851,7403846,'ine',20,1),(13,7403852,7403847,'per',11.111,1),(13,7403853,7403847,'ere',11.111,1),(13,7403854,7403847,'ren',11.111,1),(13,7403855,7403847,'enn',11.111,1),(13,7403856,7403847,'nni',11.111,1),(13,7403857,7403847,'nia',11.111,1),(13,7403858,7403847,'ial',11.111,1),(13,7403859,7403847,'all',11.111,1),(13,7403860,7403847,'lly',11.111,1),(13,7403861,7403852,'res',16.667,1),(13,7403862,7403852,'ese',16.667,1),(13,7403863,7403852,'ser',16.667,1),(13,7403864,7403852,'erv',16.667,1),(13,7403865,7403852,'rve',16.667,1),(13,7403866,7403852,'ved',16.667,1),(13,7403867,7403861,'thi',50,1),(13,7403868,7403861,'hin',50,1),(13,7403869,7403867,'pro',10,1),(13,7403870,7403867,'rov',10,1),(13,7403871,7403867,'ovi',10,1),(13,7403872,7403867,'vis',10,1),(13,7403873,7403867,'isi',10,1),(13,7403874,7403867,'sio',10,1),(13,7403875,7403867,'ion',10,1),(13,7403876,7403867,'oni',10,1),(13,7403877,7403867,'nin',10,1),(13,7403878,7403867,'ing',10,1),(13,7403879,7403869,'yes',100,1),(13,7403880,7403879,'att',16.667,1),(13,7403881,7403879,'tta',16.667,1),(13,7403882,7403879,'tac',16.667,1),(13,7403883,7403879,'ach',16.667,1),(13,7403884,7403879,'che',16.667,1),(13,7403885,7403879,'hed',16.667,1),(13,7403886,7403880,'fil',20,1),(13,7403887,7403880,'ilt',20,1),(13,7403888,7403880,'lte',20,1),(13,7403889,7403880,'ter',20,1),(13,7403890,7403880,'ers',20,1),(13,7403891,7403886,'vaa',50,1),(13,7403892,7403886,'aai',50,1),(13,7403893,7403891,'unk',20,1),(13,7403894,7403891,'nkn',20,1),(13,7403895,7403891,'kno',20,1),(13,7403896,7403891,'now',20,1),(13,7403897,7403891,'own',20,1),(13,7403898,7403893,'oth',33.333,1),(13,7403899,7403893,'the',33.333,1),(13,7403900,7403893,'her',33.333,1),(13,7403901,7403898,'uid',50,1),(13,7403902,7403898,'ids',50,1),(13,7403903,7403901,'vml',100,1),(13,7403904,7403903,'dis',20,1),(13,7403905,7403903,'isp',20,1),(13,7403906,7403903,'spl',20,1),(13,7403907,7403903,'pla',20,1),(13,7403908,7403903,'lay',20,1),(13,7403909,7403904,'nam',50,1),(13,7403910,7403904,'ame',50,1),(14,7403912,7403911,'net',25,3),(14,7403913,7403911,'eta',25,3),(14,7403914,7403911,'tap',25,3),(14,7403915,7403911,'app',25,3),(14,7403916,7403912,'fib',33.333,2),(14,7403917,7403912,'ibr',33.333,2),(14,7403918,7403912,'bre',33.333,2),(14,7403919,7403916,'cha',20,2),(14,7403920,7403916,'han',20,2),(14,7403921,7403916,'ann',20,2),(14,7403922,7403916,'nne',20,2),(14,7403923,7403916,'nel',20,2),(14,7403924,7403919,'dis',50,2),(14,7403925,7403919,'isk',50,2),(14,7403926,7403924,'naa',100,4),(14,7403927,7403926,'600',3.333,4),(14,7403928,7403926,'00a',3.333,4),(14,7403929,7403926,'0a0',3.333,4),(14,7403930,7403926,'a09',3.333,4),(14,7403931,7403926,'098',3.333,4),(14,7403932,7403926,'980',3.333,4),(14,7403933,7403926,'804',3.333,4),(14,7403934,7403926,'044',3.333,4),(14,7403935,7403926,'443',3.333,4),(14,7403936,7403926,'430',3.333,4),(14,7403937,7403926,'307',3.333,4),(14,7403938,7403926,'072',3.333,4),(14,7403939,7403926,'725',3.333,4),(14,7403940,7403926,'259',3.333,4),(14,7403941,7403926,'593',3.333,4),(14,7403942,7403926,'931',3.333,4),(14,7403943,7403926,'313',3.333,4),(14,7403944,7403926,'13f',3.333,4),(14,7403945,7403926,'3f3',3.333,4),(14,7403946,7403926,'f33',3.333,4),(14,7403947,7403926,'334',3.333,4),(14,7403948,7403926,'345',3.333,4),(14,7403949,7403926,'455',3.333,4),(14,7403950,7403926,'556',3.333,4),(14,7403951,7403926,'563',3.333,4),(14,7403952,7403926,'639',3.333,4),(14,7403953,7403926,'393',3.333,4),(14,7403954,7403926,'934',3.333,4),(14,7403955,7403926,'346',3.333,4),(14,7403956,7403926,'469',3.333,4),(14,7403957,7403927,'ser',25,1),(14,7403958,7403927,'eri',25,1),(14,7403959,7403927,'ria',25,1),(14,7403960,7403927,'ial',25,1),(14,7403961,7403957,'siz',50,1),(14,7403962,7403957,'ize',50,1),(14,7403963,7403961,'321',100,1),(14,7403964,7403963,'dev',25,1),(14,7403965,7403963,'evi',25,1),(14,7403966,7403963,'vic',25,1),(14,7403967,7403963,'ice',25,1),(14,7403968,7403964,'typ',50,1),(14,7403969,7403964,'ype',50,1),(14,7403970,7403968,'dir',10,1),(14,7403971,7403968,'ire',10,1),(14,7403972,7403968,'rec',10,1),(14,7403973,7403968,'ect',10,1),(14,7403974,7403968,'cta',10,1),(14,7403975,7403968,'tac',10,1),(14,7403976,7403968,'acc',10,1),(14,7403977,7403968,'cce',10,1),(14,7403978,7403968,'ces',10,1),(14,7403979,7403968,'ess',10,1),(14,7403980,7403970,'mul',14.286,1),(14,7403981,7403970,'ult',14.286,1),(14,7403982,7403970,'lti',14.286,1),(14,7403983,7403970,'tip',14.286,1),(14,7403984,7403970,'ipa',14.286,1),(14,7403985,7403970,'pat',14.286,1),(14,7403986,7403970,'ath',14.286,1),(14,7403987,7403980,'plu',25,1),(14,7403988,7403980,'lug',25,1),(14,7403989,7403980,'ugi',25,1),(14,7403990,7403980,'gin',25,1),(14,7403991,7403987,'nmp',100,1),(14,7403992,7403991,'dev',33.333,1),(14,7403993,7403991,'evf',33.333,1),(14,7403994,7403991,'vfs',33.333,1),(14,7403995,7403992,'pat',50,1),(14,7403996,7403992,'ath',50,1),(14,7403997,7403995,'vmf',50,1),(14,7403998,7403995,'mfs',50,1),(14,7403999,7403997,'dev',20,1),(14,7404000,7403997,'evi',20,1),(14,7404001,7403997,'vic',20,1),(14,7404002,7403997,'ice',20,1),(14,7404003,7403997,'ces',20,1),(14,7404004,7403999,'dis',33.333,1),(14,7404005,7403999,'isk',33.333,1),(14,7404006,7403999,'sks',33.333,1),(14,7404007,7404004,'ven',25,1),(14,7404008,7404004,'end',25,1),(14,7404009,7404004,'ndo',25,1),(14,7404010,7404004,'dor',25,1),(14,7404011,7404007,'mod',33.333,1),(14,7404012,7404007,'ode',33.333,1),(14,7404013,7404007,'del',33.333,1),(14,7404014,7404011,'lun',100,1),(14,7404015,7404014,'cmo',33.333,1),(14,7404016,7404014,'mod',33.333,1),(14,7404017,7404014,'ode',33.333,1),(14,7404018,7404015,'rev',16.667,1),(14,7404019,7404015,'evi',16.667,1),(14,7404020,7404015,'vis',16.667,1),(14,7404021,7404015,'isi',16.667,1),(14,7404022,7404015,'sio',16.667,1),(14,7404023,7404015,'ion',16.667,1),(14,7404024,7404018,'810',50,1),(14,7404025,7404018,'100',50,1),(14,7404026,7404024,'scs',50,1),(14,7404027,7404024,'csi',50,1),(14,7404028,7404026,'lev',33.333,1),(14,7404029,7404026,'eve',33.333,1),(14,7404030,7404026,'vel',33.333,1),(14,7404031,7404028,'pse',25,1),(14,7404032,7404028,'seu',25,1),(14,7404033,7404028,'eud',25,1),(14,7404034,7404028,'udo',25,1),(14,7404035,7404031,'fal',33.333,6),(14,7404036,7404031,'als',33.333,6),(14,7404037,7404031,'lse',33.333,6),(14,7404038,7404035,'sta',25,3),(14,7404039,7404035,'tat',25,3),(14,7404040,7404035,'atu',25,3),(14,7404041,7404035,'tus',25,3),(14,7404042,7404038,'rdm',100,1),(14,7404043,7404042,'cap',20,1),(14,7404044,7404042,'apa',20,1),(14,7404045,7404042,'pab',20,1),(14,7404046,7404042,'abl',20,1),(14,7404047,7404042,'ble',20,1),(14,7404048,7404043,'tru',50,1),(14,7404049,7404043,'rue',50,1),(14,7404050,7404048,'loc',33.333,1),(14,7404051,7404048,'oca',33.333,1),(14,7404052,7404048,'cal',33.333,1),(14,7404053,7404050,'rem',14.286,1),(14,7404054,7404050,'emo',14.286,1),(14,7404055,7404050,'mov',14.286,1),(14,7404056,7404050,'ova',14.286,1),(14,7404057,7404050,'vab',14.286,1),(14,7404058,7404050,'abl',14.286,1),(14,7404059,7404050,'ble',14.286,1),(14,7404060,7404053,'ssd',100,1),(14,7404061,7404060,'off',20,1),(14,7404062,7404060,'ffl',20,1),(14,7404063,7404060,'fli',20,1),(14,7404064,7404060,'lin',20,1),(14,7404065,7404060,'ine',20,1),(14,7404066,7404061,'per',11.111,1),(14,7404067,7404061,'ere',11.111,1),(14,7404068,7404061,'ren',11.111,1),(14,7404069,7404061,'enn',11.111,1),(14,7404070,7404061,'nni',11.111,1),(14,7404071,7404061,'nia',11.111,1),(14,7404072,7404061,'ial',11.111,1),(14,7404073,7404061,'all',11.111,1),(14,7404074,7404061,'lly',11.111,1),(14,7404075,7404066,'res',16.667,1),(14,7404076,7404066,'ese',16.667,1),(14,7404077,7404066,'ser',16.667,1),(14,7404078,7404066,'erv',16.667,1),(14,7404079,7404066,'rve',16.667,1),(14,7404080,7404066,'ved',16.667,1),(14,7404081,7404075,'thi',50,1),(14,7404082,7404075,'hin',50,1),(14,7404083,7404081,'pro',10,1),(14,7404084,7404081,'rov',10,1),(14,7404085,7404081,'ovi',10,1),(14,7404086,7404081,'vis',10,1),(14,7404087,7404081,'isi',10,1),(14,7404088,7404081,'sio',10,1),(14,7404089,7404081,'ion',10,1),(14,7404090,7404081,'oni',10,1),(14,7404091,7404081,'nin',10,1),(14,7404092,7404081,'ing',10,1),(14,7404093,7404083,'yes',100,1),(14,7404094,7404093,'att',16.667,1),(14,7404095,7404093,'tta',16.667,1),(14,7404096,7404093,'tac',16.667,1),(14,7404097,7404093,'ach',16.667,1),(14,7404098,7404093,'che',16.667,1),(14,7404099,7404093,'hed',16.667,1),(14,7404100,7404094,'fil',20,1),(14,7404101,7404094,'ilt',20,1),(14,7404102,7404094,'lte',20,1),(14,7404103,7404094,'ter',20,1),(14,7404104,7404094,'ers',20,1),(14,7404105,7404100,'vaa',50,1),(14,7404106,7404100,'aai',50,1),(14,7404107,7404105,'unk',20,1),(14,7404108,7404105,'nkn',20,1),(14,7404109,7404105,'kno',20,1),(14,7404110,7404105,'now',20,1),(14,7404111,7404105,'own',20,1),(14,7404112,7404107,'oth',33.333,1),(14,7404113,7404107,'the',33.333,1),(14,7404114,7404107,'her',33.333,1),(14,7404115,7404112,'uid',50,1),(14,7404116,7404112,'ids',50,1),(14,7404117,7404115,'vml',100,1),(14,7404118,7404117,'dis',20,1),(14,7404119,7404117,'isp',20,1),(14,7404120,7404117,'spl',20,1),(14,7404121,7404117,'pla',20,1),(14,7404122,7404117,'lay',20,1),(14,7404123,7404118,'nam',50,1),(14,7404124,7404118,'ame',50,1),(15,7404126,7404125,'net',25,3),(15,7404127,7404125,'eta',25,3),(15,7404128,7404125,'tap',25,3),(15,7404129,7404125,'app',25,3),(15,7404130,7404126,'fib',33.333,2),(15,7404131,7404126,'ibr',33.333,2),(15,7404132,7404126,'bre',33.333,2),(15,7404133,7404130,'cha',20,2),(15,7404134,7404130,'han',20,2),(15,7404135,7404130,'ann',20,2),(15,7404136,7404130,'nne',20,2),(15,7404137,7404130,'nel',20,2),(15,7404138,7404133,'dis',50,2),(15,7404139,7404133,'isk',50,2),(15,7404140,7404138,'naa',100,4),(15,7404141,7404140,'600',3.333,4),(15,7404142,7404140,'00a',3.333,4),(15,7404143,7404140,'0a0',3.333,4),(15,7404144,7404140,'a09',3.333,4),(15,7404145,7404140,'098',3.333,4),(15,7404146,7404140,'980',3.333,4),(15,7404147,7404140,'804',3.333,4),(15,7404148,7404140,'044',3.333,4),(15,7404149,7404140,'443',3.333,4),(15,7404150,7404140,'430',3.333,4),(15,7404151,7404140,'307',3.333,4),(15,7404152,7404140,'072',3.333,4),(15,7404153,7404140,'725',3.333,4),(15,7404154,7404140,'259',3.333,4),(15,7404155,7404140,'593',3.333,4),(15,7404156,7404140,'931',3.333,4),(15,7404157,7404140,'313',3.333,4),(15,7404158,7404140,'13f',3.333,4),(15,7404159,7404140,'3f3',3.333,4),(15,7404160,7404140,'f33',3.333,4),(15,7404161,7404140,'334',3.333,4),(15,7404162,7404140,'345',3.333,4),(15,7404163,7404140,'455',3.333,4),(15,7404164,7404140,'556',3.333,4),(15,7404165,7404140,'563',3.333,4),(15,7404166,7404140,'639',3.333,4),(15,7404167,7404140,'393',3.333,4),(15,7404168,7404140,'934',3.333,4),(15,7404169,7404140,'342',3.333,4),(15,7404170,7404140,'42d',3.333,4),(15,7404171,7404141,'ser',25,1),(15,7404172,7404141,'eri',25,1),(15,7404173,7404141,'ria',25,1),(15,7404174,7404141,'ial',25,1),(15,7404175,7404171,'siz',50,1),(15,7404176,7404171,'ize',50,1),(15,7404177,7404175,'321',100,1),(15,7404178,7404177,'dev',25,1),(15,7404179,7404177,'evi',25,1),(15,7404180,7404177,'vic',25,1),(15,7404181,7404177,'ice',25,1),(15,7404182,7404178,'typ',50,1),(15,7404183,7404178,'ype',50,1),(15,7404184,7404182,'dir',10,1),(15,7404185,7404182,'ire',10,1),(15,7404186,7404182,'rec',10,1),(15,7404187,7404182,'ect',10,1),(15,7404188,7404182,'cta',10,1),(15,7404189,7404182,'tac',10,1),(15,7404190,7404182,'acc',10,1),(15,7404191,7404182,'cce',10,1),(15,7404192,7404182,'ces',10,1),(15,7404193,7404182,'ess',10,1),(15,7404194,7404184,'mul',14.286,1),(15,7404195,7404184,'ult',14.286,1),(15,7404196,7404184,'lti',14.286,1),(15,7404197,7404184,'tip',14.286,1),(15,7404198,7404184,'ipa',14.286,1),(15,7404199,7404184,'pat',14.286,1),(15,7404200,7404184,'ath',14.286,1),(15,7404201,7404194,'plu',25,1),(15,7404202,7404194,'lug',25,1),(15,7404203,7404194,'ugi',25,1),(15,7404204,7404194,'gin',25,1),(15,7404205,7404201,'nmp',100,1),(15,7404206,7404205,'dev',33.333,1),(15,7404207,7404205,'evf',33.333,1),(15,7404208,7404205,'vfs',33.333,1),(15,7404209,7404206,'pat',50,1),(15,7404210,7404206,'ath',50,1),(15,7404211,7404209,'vmf',50,1),(15,7404212,7404209,'mfs',50,1),(15,7404213,7404211,'dev',20,1),(15,7404214,7404211,'evi',20,1),(15,7404215,7404211,'vic',20,1),(15,7404216,7404211,'ice',20,1),(15,7404217,7404211,'ces',20,1),(15,7404218,7404213,'dis',33.333,1),(15,7404219,7404213,'isk',33.333,1),(15,7404220,7404213,'sks',33.333,1),(15,7404221,7404218,'ven',25,1),(15,7404222,7404218,'end',25,1),(15,7404223,7404218,'ndo',25,1),(15,7404224,7404218,'dor',25,1),(15,7404225,7404221,'mod',33.333,1),(15,7404226,7404221,'ode',33.333,1),(15,7404227,7404221,'del',33.333,1),(15,7404228,7404225,'lun',100,1),(15,7404229,7404228,'cmo',33.333,1),(15,7404230,7404228,'mod',33.333,1),(15,7404231,7404228,'ode',33.333,1),(15,7404232,7404229,'rev',16.667,1),(15,7404233,7404229,'evi',16.667,1),(15,7404234,7404229,'vis',16.667,1),(15,7404235,7404229,'isi',16.667,1),(15,7404236,7404229,'sio',16.667,1),(15,7404237,7404229,'ion',16.667,1),(15,7404238,7404232,'810',50,1),(15,7404239,7404232,'100',50,1),(15,7404240,7404238,'scs',50,1),(15,7404241,7404238,'csi',50,1),(15,7404242,7404240,'lev',33.333,1),(15,7404243,7404240,'eve',33.333,1),(15,7404244,7404240,'vel',33.333,1),(15,7404245,7404242,'pse',25,1),(15,7404246,7404242,'seu',25,1),(15,7404247,7404242,'eud',25,1),(15,7404248,7404242,'udo',25,1),(15,7404249,7404245,'fal',33.333,6),(15,7404250,7404245,'als',33.333,6),(15,7404251,7404245,'lse',33.333,6),(15,7404252,7404249,'sta',25,3),(15,7404253,7404249,'tat',25,3),(15,7404254,7404249,'atu',25,3),(15,7404255,7404249,'tus',25,3),(15,7404256,7404252,'rdm',100,1),(15,7404257,7404256,'cap',20,1),(15,7404258,7404256,'apa',20,1),(15,7404259,7404256,'pab',20,1),(15,7404260,7404256,'abl',20,1),(15,7404261,7404256,'ble',20,1),(15,7404262,7404257,'tru',50,1),(15,7404263,7404257,'rue',50,1),(15,7404264,7404262,'loc',33.333,1),(15,7404265,7404262,'oca',33.333,1),(15,7404266,7404262,'cal',33.333,1),(15,7404267,7404264,'rem',14.286,1),(15,7404268,7404264,'emo',14.286,1),(15,7404269,7404264,'mov',14.286,1),(15,7404270,7404264,'ova',14.286,1),(15,7404271,7404264,'vab',14.286,1),(15,7404272,7404264,'abl',14.286,1),(15,7404273,7404264,'ble',14.286,1),(15,7404274,7404267,'ssd',100,1),(15,7404275,7404274,'off',20,1),(15,7404276,7404274,'ffl',20,1),(15,7404277,7404274,'fli',20,1),(15,7404278,7404274,'lin',20,1),(15,7404279,7404274,'ine',20,1),(15,7404280,7404275,'per',11.111,1),(15,7404281,7404275,'ere',11.111,1),(15,7404282,7404275,'ren',11.111,1),(15,7404283,7404275,'enn',11.111,1),(15,7404284,7404275,'nni',11.111,1),(15,7404285,7404275,'nia',11.111,1),(15,7404286,7404275,'ial',11.111,1),(15,7404287,7404275,'all',11.111,1),(15,7404288,7404275,'lly',11.111,1),(15,7404289,7404280,'res',16.667,1),(15,7404290,7404280,'ese',16.667,1),(15,7404291,7404280,'ser',16.667,1),(15,7404292,7404280,'erv',16.667,1),(15,7404293,7404280,'rve',16.667,1),(15,7404294,7404280,'ved',16.667,1),(15,7404295,7404289,'thi',50,1),(15,7404296,7404289,'hin',50,1),(15,7404297,7404295,'pro',10,1),(15,7404298,7404295,'rov',10,1),(15,7404299,7404295,'ovi',10,1),(15,7404300,7404295,'vis',10,1),(15,7404301,7404295,'isi',10,1),(15,7404302,7404295,'sio',10,1),(15,7404303,7404295,'ion',10,1),(15,7404304,7404295,'oni',10,1),(15,7404305,7404295,'nin',10,1),(15,7404306,7404295,'ing',10,1),(15,7404307,7404297,'yes',100,1),(15,7404308,7404307,'att',16.667,1),(15,7404309,7404307,'tta',16.667,1),(15,7404310,7404307,'tac',16.667,1),(15,7404311,7404307,'ach',16.667,1),(15,7404312,7404307,'che',16.667,1),(15,7404313,7404307,'hed',16.667,1),(15,7404314,7404308,'fil',20,1),(15,7404315,7404308,'ilt',20,1),(15,7404316,7404308,'lte',20,1),(15,7404317,7404308,'ter',20,1),(15,7404318,7404308,'ers',20,1),(15,7404319,7404314,'vaa',50,1),(15,7404320,7404314,'aai',50,1),(15,7404321,7404319,'unk',20,1),(15,7404322,7404319,'nkn',20,1),(15,7404323,7404319,'kno',20,1),(15,7404324,7404319,'now',20,1),(15,7404325,7404319,'own',20,1),(15,7404326,7404321,'oth',33.333,1),(15,7404327,7404321,'the',33.333,1),(15,7404328,7404321,'her',33.333,1),(15,7404329,7404326,'uid',50,1),(15,7404330,7404326,'ids',50,1),(15,7404331,7404329,'vml',100,1),(15,7404332,7404331,'dis',20,1),(15,7404333,7404331,'isp',20,1),(15,7404334,7404331,'spl',20,1),(15,7404335,7404331,'pla',20,1),(15,7404336,7404331,'lay',20,1),(15,7404337,7404332,'nam',50,1),(15,7404338,7404332,'ame',50,1),(16,7404340,7404339,'net',25,3),(16,7404341,7404339,'eta',25,3),(16,7404342,7404339,'tap',25,3),(16,7404343,7404339,'app',25,3),(16,7404344,7404340,'fib',33.333,2),(16,7404345,7404340,'ibr',33.333,2),(16,7404346,7404340,'bre',33.333,2),(16,7404347,7404344,'cha',20,2),(16,7404348,7404344,'han',20,2),(16,7404349,7404344,'ann',20,2),(16,7404350,7404344,'nne',20,2),(16,7404351,7404344,'nel',20,2),(16,7404352,7404347,'dis',50,2),(16,7404353,7404347,'isk',50,2),(16,7404354,7404352,'naa',100,4),(16,7404355,7404354,'600',3.333,4),(16,7404356,7404354,'00a',3.333,4),(16,7404357,7404354,'0a0',3.333,4),(16,7404358,7404354,'a09',3.333,4),(16,7404359,7404354,'098',3.333,4),(16,7404360,7404354,'980',3.333,4),(16,7404361,7404354,'804',3.333,4),(16,7404362,7404354,'044',3.333,4),(16,7404363,7404354,'443',3.333,4),(16,7404364,7404354,'430',3.333,4),(16,7404365,7404354,'307',3.333,4),(16,7404366,7404354,'072',3.333,4),(16,7404367,7404354,'725',3.333,4),(16,7404368,7404354,'259',3.333,4),(16,7404369,7404354,'593',3.333,4),(16,7404370,7404354,'931',3.333,4),(16,7404371,7404354,'313',3.333,4),(16,7404372,7404354,'13f',3.333,4),(16,7404373,7404354,'3f3',3.333,4),(16,7404374,7404354,'f33',3.333,4),(16,7404375,7404354,'334',3.333,4),(16,7404376,7404354,'345',3.333,4),(16,7404377,7404354,'455',3.333,4),(16,7404378,7404354,'556',3.333,4),(16,7404379,7404354,'563',3.333,4),(16,7404380,7404354,'639',3.333,4),(16,7404381,7404354,'393',3.333,4),(16,7404382,7404354,'934',3.333,4),(16,7404383,7404354,'342',3.333,4),(16,7404384,7404354,'42f',3.333,4),(16,7404385,7404355,'ser',25,1),(16,7404386,7404355,'eri',25,1),(16,7404387,7404355,'ria',25,1),(16,7404388,7404355,'ial',25,1),(16,7404389,7404385,'siz',50,1),(16,7404390,7404385,'ize',50,1),(16,7404391,7404389,'321',100,1),(16,7404392,7404391,'dev',25,1),(16,7404393,7404391,'evi',25,1),(16,7404394,7404391,'vic',25,1),(16,7404395,7404391,'ice',25,1),(16,7404396,7404392,'typ',50,1),(16,7404397,7404392,'ype',50,1),(16,7404398,7404396,'dir',10,1),(16,7404399,7404396,'ire',10,1),(16,7404400,7404396,'rec',10,1),(16,7404401,7404396,'ect',10,1),(16,7404402,7404396,'cta',10,1),(16,7404403,7404396,'tac',10,1),(16,7404404,7404396,'acc',10,1),(16,7404405,7404396,'cce',10,1),(16,7404406,7404396,'ces',10,1),(16,7404407,7404396,'ess',10,1),(16,7404408,7404398,'mul',14.286,1),(16,7404409,7404398,'ult',14.286,1),(16,7404410,7404398,'lti',14.286,1),(16,7404411,7404398,'tip',14.286,1),(16,7404412,7404398,'ipa',14.286,1),(16,7404413,7404398,'pat',14.286,1),(16,7404414,7404398,'ath',14.286,1),(16,7404415,7404408,'plu',25,1),(16,7404416,7404408,'lug',25,1),(16,7404417,7404408,'ugi',25,1),(16,7404418,7404408,'gin',25,1),(16,7404419,7404415,'nmp',100,1),(16,7404420,7404419,'dev',33.333,1),(16,7404421,7404419,'evf',33.333,1),(16,7404422,7404419,'vfs',33.333,1),(16,7404423,7404420,'pat',50,1),(16,7404424,7404420,'ath',50,1),(16,7404425,7404423,'vmf',50,1),(16,7404426,7404423,'mfs',50,1),(16,7404427,7404425,'dev',20,1),(16,7404428,7404425,'evi',20,1),(16,7404429,7404425,'vic',20,1),(16,7404430,7404425,'ice',20,1),(16,7404431,7404425,'ces',20,1),(16,7404432,7404427,'dis',33.333,1),(16,7404433,7404427,'isk',33.333,1),(16,7404434,7404427,'sks',33.333,1),(16,7404435,7404432,'ven',25,1),(16,7404436,7404432,'end',25,1),(16,7404437,7404432,'ndo',25,1),(16,7404438,7404432,'dor',25,1),(16,7404439,7404435,'mod',33.333,1),(16,7404440,7404435,'ode',33.333,1),(16,7404441,7404435,'del',33.333,1),(16,7404442,7404439,'lun',100,1),(16,7404443,7404442,'cmo',33.333,1),(16,7404444,7404442,'mod',33.333,1),(16,7404445,7404442,'ode',33.333,1),(16,7404446,7404443,'rev',16.667,1),(16,7404447,7404443,'evi',16.667,1),(16,7404448,7404443,'vis',16.667,1),(16,7404449,7404443,'isi',16.667,1),(16,7404450,7404443,'sio',16.667,1),(16,7404451,7404443,'ion',16.667,1),(16,7404452,7404446,'810',50,1),(16,7404453,7404446,'100',50,1),(16,7404454,7404452,'scs',50,1),(16,7404455,7404452,'csi',50,1),(16,7404456,7404454,'lev',33.333,1),(16,7404457,7404454,'eve',33.333,1),(16,7404458,7404454,'vel',33.333,1),(16,7404459,7404456,'pse',25,1),(16,7404460,7404456,'seu',25,1),(16,7404461,7404456,'eud',25,1),(16,7404462,7404456,'udo',25,1),(16,7404463,7404459,'fal',33.333,6),(16,7404464,7404459,'als',33.333,6),(16,7404465,7404459,'lse',33.333,6),(16,7404466,7404463,'sta',25,3),(16,7404467,7404463,'tat',25,3),(16,7404468,7404463,'atu',25,3),(16,7404469,7404463,'tus',25,3),(16,7404470,7404466,'rdm',100,1),(16,7404471,7404470,'cap',20,1),(16,7404472,7404470,'apa',20,1),(16,7404473,7404470,'pab',20,1),(16,7404474,7404470,'abl',20,1),(16,7404475,7404470,'ble',20,1),(16,7404476,7404471,'tru',50,1),(16,7404477,7404471,'rue',50,1),(16,7404478,7404476,'loc',33.333,1),(16,7404479,7404476,'oca',33.333,1),(16,7404480,7404476,'cal',33.333,1),(16,7404481,7404478,'rem',14.286,1),(16,7404482,7404478,'emo',14.286,1),(16,7404483,7404478,'mov',14.286,1),(16,7404484,7404478,'ova',14.286,1),(16,7404485,7404478,'vab',14.286,1),(16,7404486,7404478,'abl',14.286,1),(16,7404487,7404478,'ble',14.286,1),(16,7404488,7404481,'ssd',100,1),(16,7404489,7404488,'off',20,1),(16,7404490,7404488,'ffl',20,1),(16,7404491,7404488,'fli',20,1),(16,7404492,7404488,'lin',20,1),(16,7404493,7404488,'ine',20,1),(16,7404494,7404489,'per',11.111,1),(16,7404495,7404489,'ere',11.111,1),(16,7404496,7404489,'ren',11.111,1),(16,7404497,7404489,'enn',11.111,1),(16,7404498,7404489,'nni',11.111,1),(16,7404499,7404489,'nia',11.111,1),(16,7404500,7404489,'ial',11.111,1),(16,7404501,7404489,'all',11.111,1),(16,7404502,7404489,'lly',11.111,1),(16,7404503,7404494,'res',16.667,1),(16,7404504,7404494,'ese',16.667,1),(16,7404505,7404494,'ser',16.667,1),(16,7404506,7404494,'erv',16.667,1),(16,7404507,7404494,'rve',16.667,1),(16,7404508,7404494,'ved',16.667,1),(16,7404509,7404503,'thi',50,1),(16,7404510,7404503,'hin',50,1),(16,7404511,7404509,'pro',10,1),(16,7404512,7404509,'rov',10,1),(16,7404513,7404509,'ovi',10,1),(16,7404514,7404509,'vis',10,1),(16,7404515,7404509,'isi',10,1),(16,7404516,7404509,'sio',10,1),(16,7404517,7404509,'ion',10,1),(16,7404518,7404509,'oni',10,1),(16,7404519,7404509,'nin',10,1),(16,7404520,7404509,'ing',10,1),(16,7404521,7404511,'yes',100,1),(16,7404522,7404521,'att',16.667,1),(16,7404523,7404521,'tta',16.667,1),(16,7404524,7404521,'tac',16.667,1),(16,7404525,7404521,'ach',16.667,1),(16,7404526,7404521,'che',16.667,1),(16,7404527,7404521,'hed',16.667,1),(16,7404528,7404522,'fil',20,1),(16,7404529,7404522,'ilt',20,1),(16,7404530,7404522,'lte',20,1),(16,7404531,7404522,'ter',20,1),(16,7404532,7404522,'ers',20,1),(16,7404533,7404528,'vaa',50,1),(16,7404534,7404528,'aai',50,1),(16,7404535,7404533,'unk',20,1),(16,7404536,7404533,'nkn',20,1),(16,7404537,7404533,'kno',20,1),(16,7404538,7404533,'now',20,1),(16,7404539,7404533,'own',20,1),(16,7404540,7404535,'oth',33.333,1),(16,7404541,7404535,'the',33.333,1),(16,7404542,7404535,'her',33.333,1),(16,7404543,7404540,'uid',50,1),(16,7404544,7404540,'ids',50,1),(16,7404545,7404543,'vml',100,1),(16,7404546,7404545,'dis',20,1),(16,7404547,7404545,'isp',20,1),(16,7404548,7404545,'spl',20,1),(16,7404549,7404545,'pla',20,1),(16,7404550,7404545,'lay',20,1),(16,7404551,7404546,'nam',50,1),(16,7404552,7404546,'ame',50,1),(17,7404554,7404553,'net',25,3),(17,7404555,7404553,'eta',25,3),(17,7404556,7404553,'tap',25,3),(17,7404557,7404553,'app',25,3),(17,7404558,7404554,'fib',33.333,2),(17,7404559,7404554,'ibr',33.333,2),(17,7404560,7404554,'bre',33.333,2),(17,7404561,7404558,'cha',20,2),(17,7404562,7404558,'han',20,2),(17,7404563,7404558,'ann',20,2),(17,7404564,7404558,'nne',20,2),(17,7404565,7404558,'nel',20,2),(17,7404566,7404561,'dis',50,2),(17,7404567,7404561,'isk',50,2),(17,7404568,7404566,'naa',100,4),(17,7404569,7404568,'600',3.333,4),(17,7404570,7404568,'00a',3.333,4),(17,7404571,7404568,'0a0',3.333,4),(17,7404572,7404568,'a09',3.333,4),(17,7404573,7404568,'098',3.333,4),(17,7404574,7404568,'980',3.333,4),(17,7404575,7404568,'804',3.333,4),(17,7404576,7404568,'044',3.333,4),(17,7404577,7404568,'443',3.333,4),(17,7404578,7404568,'430',3.333,4),(17,7404579,7404568,'307',3.333,4),(17,7404580,7404568,'072',3.333,4),(17,7404581,7404568,'725',3.333,4),(17,7404582,7404568,'259',3.333,4),(17,7404583,7404568,'593',3.333,4),(17,7404584,7404568,'931',3.333,4),(17,7404585,7404568,'313',3.333,4),(17,7404586,7404568,'13f',3.333,4),(17,7404587,7404568,'3f3',3.333,4),(17,7404588,7404568,'f33',3.333,4),(17,7404589,7404568,'334',3.333,4),(17,7404590,7404568,'345',3.333,4),(17,7404591,7404568,'455',3.333,4),(17,7404592,7404568,'556',3.333,4),(17,7404593,7404568,'563',3.333,4),(17,7404594,7404568,'639',3.333,4),(17,7404595,7404568,'393',3.333,4),(17,7404596,7404568,'934',3.333,4),(17,7404597,7404568,'346',3.333,4),(17,7404598,7404568,'46a',3.333,4),(17,7404599,7404569,'ser',25,1),(17,7404600,7404569,'eri',25,1),(17,7404601,7404569,'ria',25,1),(17,7404602,7404569,'ial',25,1),(17,7404603,7404599,'siz',50,1),(17,7404604,7404599,'ize',50,1),(17,7404605,7404603,'321',100,1),(17,7404606,7404605,'dev',25,1),(17,7404607,7404605,'evi',25,1),(17,7404608,7404605,'vic',25,1),(17,7404609,7404605,'ice',25,1),(17,7404610,7404606,'typ',50,1),(17,7404611,7404606,'ype',50,1),(17,7404612,7404610,'dir',10,1),(17,7404613,7404610,'ire',10,1),(17,7404614,7404610,'rec',10,1),(17,7404615,7404610,'ect',10,1),(17,7404616,7404610,'cta',10,1),(17,7404617,7404610,'tac',10,1),(17,7404618,7404610,'acc',10,1),(17,7404619,7404610,'cce',10,1),(17,7404620,7404610,'ces',10,1),(17,7404621,7404610,'ess',10,1),(17,7404622,7404612,'mul',14.286,1),(17,7404623,7404612,'ult',14.286,1),(17,7404624,7404612,'lti',14.286,1),(17,7404625,7404612,'tip',14.286,1),(17,7404626,7404612,'ipa',14.286,1),(17,7404627,7404612,'pat',14.286,1),(17,7404628,7404612,'ath',14.286,1),(17,7404629,7404622,'plu',25,1),(17,7404630,7404622,'lug',25,1),(17,7404631,7404622,'ugi',25,1),(17,7404632,7404622,'gin',25,1),(17,7404633,7404629,'nmp',100,1),(17,7404634,7404633,'dev',33.333,1),(17,7404635,7404633,'evf',33.333,1),(17,7404636,7404633,'vfs',33.333,1),(17,7404637,7404634,'pat',50,1),(17,7404638,7404634,'ath',50,1),(17,7404639,7404637,'vmf',50,1),(17,7404640,7404637,'mfs',50,1),(17,7404641,7404639,'dev',20,1),(17,7404642,7404639,'evi',20,1),(17,7404643,7404639,'vic',20,1),(17,7404644,7404639,'ice',20,1),(17,7404645,7404639,'ces',20,1),(17,7404646,7404641,'dis',33.333,1),(17,7404647,7404641,'isk',33.333,1),(17,7404648,7404641,'sks',33.333,1),(17,7404649,7404646,'ven',25,1),(17,7404650,7404646,'end',25,1),(17,7404651,7404646,'ndo',25,1),(17,7404652,7404646,'dor',25,1),(17,7404653,7404649,'mod',33.333,1),(17,7404654,7404649,'ode',33.333,1),(17,7404655,7404649,'del',33.333,1),(17,7404656,7404653,'lun',100,1),(17,7404657,7404656,'cmo',33.333,1),(17,7404658,7404656,'mod',33.333,1),(17,7404659,7404656,'ode',33.333,1),(17,7404660,7404657,'rev',16.667,1),(17,7404661,7404657,'evi',16.667,1),(17,7404662,7404657,'vis',16.667,1),(17,7404663,7404657,'isi',16.667,1),(17,7404664,7404657,'sio',16.667,1),(17,7404665,7404657,'ion',16.667,1),(17,7404666,7404660,'810',50,1),(17,7404667,7404660,'100',50,1),(17,7404668,7404666,'scs',50,1),(17,7404669,7404666,'csi',50,1),(17,7404670,7404668,'lev',33.333,1),(17,7404671,7404668,'eve',33.333,1),(17,7404672,7404668,'vel',33.333,1),(17,7404673,7404670,'pse',25,1),(17,7404674,7404670,'seu',25,1),(17,7404675,7404670,'eud',25,1),(17,7404676,7404670,'udo',25,1),(17,7404677,7404673,'fal',33.333,6),(17,7404678,7404673,'als',33.333,6),(17,7404679,7404673,'lse',33.333,6),(17,7404680,7404677,'sta',25,3),(17,7404681,7404677,'tat',25,3),(17,7404682,7404677,'atu',25,3),(17,7404683,7404677,'tus',25,3),(17,7404684,7404680,'rdm',100,1),(17,7404685,7404684,'cap',20,1),(17,7404686,7404684,'apa',20,1),(17,7404687,7404684,'pab',20,1),(17,7404688,7404684,'abl',20,1),(17,7404689,7404684,'ble',20,1),(17,7404690,7404685,'tru',50,1),(17,7404691,7404685,'rue',50,1),(17,7404692,7404690,'loc',33.333,1),(17,7404693,7404690,'oca',33.333,1),(17,7404694,7404690,'cal',33.333,1),(17,7404695,7404692,'rem',14.286,1),(17,7404696,7404692,'emo',14.286,1),(17,7404697,7404692,'mov',14.286,1),(17,7404698,7404692,'ova',14.286,1),(17,7404699,7404692,'vab',14.286,1),(17,7404700,7404692,'abl',14.286,1),(17,7404701,7404692,'ble',14.286,1),(17,7404702,7404695,'ssd',100,1),(17,7404703,7404702,'off',20,1),(17,7404704,7404702,'ffl',20,1),(17,7404705,7404702,'fli',20,1),(17,7404706,7404702,'lin',20,1),(17,7404707,7404702,'ine',20,1),(17,7404708,7404703,'per',11.111,1),(17,7404709,7404703,'ere',11.111,1),(17,7404710,7404703,'ren',11.111,1),(17,7404711,7404703,'enn',11.111,1),(17,7404712,7404703,'nni',11.111,1),(17,7404713,7404703,'nia',11.111,1),(17,7404714,7404703,'ial',11.111,1),(17,7404715,7404703,'all',11.111,1),(17,7404716,7404703,'lly',11.111,1),(17,7404717,7404708,'res',16.667,1),(17,7404718,7404708,'ese',16.667,1),(17,7404719,7404708,'ser',16.667,1),(17,7404720,7404708,'erv',16.667,1),(17,7404721,7404708,'rve',16.667,1),(17,7404722,7404708,'ved',16.667,1),(17,7404723,7404717,'thi',50,1),(17,7404724,7404717,'hin',50,1),(17,7404725,7404723,'pro',10,1),(17,7404726,7404723,'rov',10,1),(17,7404727,7404723,'ovi',10,1),(17,7404728,7404723,'vis',10,1),(17,7404729,7404723,'isi',10,1),(17,7404730,7404723,'sio',10,1),(17,7404731,7404723,'ion',10,1),(17,7404732,7404723,'oni',10,1),(17,7404733,7404723,'nin',10,1),(17,7404734,7404723,'ing',10,1),(17,7404735,7404725,'yes',100,1),(17,7404736,7404735,'att',16.667,1),(17,7404737,7404735,'tta',16.667,1),(17,7404738,7404735,'tac',16.667,1),(17,7404739,7404735,'ach',16.667,1),(17,7404740,7404735,'che',16.667,1),(17,7404741,7404735,'hed',16.667,1),(17,7404742,7404736,'fil',20,1),(17,7404743,7404736,'ilt',20,1),(17,7404744,7404736,'lte',20,1),(17,7404745,7404736,'ter',20,1),(17,7404746,7404736,'ers',20,1),(17,7404747,7404742,'vaa',50,1),(17,7404748,7404742,'aai',50,1),(17,7404749,7404747,'unk',20,1),(17,7404750,7404747,'nkn',20,1),(17,7404751,7404747,'kno',20,1),(17,7404752,7404747,'now',20,1),(17,7404753,7404747,'own',20,1),(17,7404754,7404749,'oth',33.333,1),(17,7404755,7404749,'the',33.333,1),(17,7404756,7404749,'her',33.333,1),(17,7404757,7404754,'uid',50,1),(17,7404758,7404754,'ids',50,1),(17,7404759,7404757,'vml',100,1),(17,7404760,7404759,'dis',20,1),(17,7404761,7404759,'isp',20,1),(17,7404762,7404759,'spl',20,1),(17,7404763,7404759,'pla',20,1),(17,7404764,7404759,'lay',20,1),(17,7404765,7404760,'nam',50,1),(17,7404766,7404760,'ame',50,1),(18,7404768,7404767,'net',25,3),(18,7404769,7404767,'eta',25,3),(18,7404770,7404767,'tap',25,3),(18,7404771,7404767,'app',25,3),(18,7404772,7404768,'fib',33.333,2),(18,7404773,7404768,'ibr',33.333,2),(18,7404774,7404768,'bre',33.333,2),(18,7404775,7404772,'cha',20,2),(18,7404776,7404772,'han',20,2),(18,7404777,7404772,'ann',20,2),(18,7404778,7404772,'nne',20,2),(18,7404779,7404772,'nel',20,2),(18,7404780,7404775,'dis',50,2),(18,7404781,7404775,'isk',50,2),(18,7404782,7404780,'naa',100,4),(18,7404783,7404782,'600',3.333,4),(18,7404784,7404782,'00a',3.333,4),(18,7404785,7404782,'0a0',3.333,4),(18,7404786,7404782,'a09',3.333,4),(18,7404787,7404782,'098',3.333,4),(18,7404788,7404782,'980',3.333,4),(18,7404789,7404782,'804',3.333,4),(18,7404790,7404782,'044',3.333,4),(18,7404791,7404782,'443',3.333,4),(18,7404792,7404782,'430',3.333,4),(18,7404793,7404782,'307',3.333,4),(18,7404794,7404782,'072',3.333,4),(18,7404795,7404782,'725',3.333,4),(18,7404796,7404782,'259',3.333,4),(18,7404797,7404782,'593',3.333,4),(18,7404798,7404782,'931',3.333,4),(18,7404799,7404782,'313',3.333,4),(18,7404800,7404782,'13f',3.333,4),(18,7404801,7404782,'3f3',3.333,4),(18,7404802,7404782,'f33',3.333,4),(18,7404803,7404782,'334',3.333,4),(18,7404804,7404782,'345',3.333,4),(18,7404805,7404782,'455',3.333,4),(18,7404806,7404782,'556',3.333,4),(18,7404807,7404782,'563',3.333,4),(18,7404808,7404782,'639',3.333,4),(18,7404809,7404782,'393',3.333,4),(18,7404810,7404782,'934',3.333,4),(18,7404811,7404782,'346',3.333,4),(18,7404812,7404782,'46b',3.333,4),(18,7404813,7404783,'ser',25,1),(18,7404814,7404783,'eri',25,1),(18,7404815,7404783,'ria',25,1),(18,7404816,7404783,'ial',25,1),(18,7404817,7404813,'siz',50,1),(18,7404818,7404813,'ize',50,1),(18,7404819,7404817,'321',100,1),(18,7404820,7404819,'dev',25,1),(18,7404821,7404819,'evi',25,1),(18,7404822,7404819,'vic',25,1),(18,7404823,7404819,'ice',25,1),(18,7404824,7404820,'typ',50,1),(18,7404825,7404820,'ype',50,1),(18,7404826,7404824,'dir',10,1),(18,7404827,7404824,'ire',10,1),(18,7404828,7404824,'rec',10,1),(18,7404829,7404824,'ect',10,1),(18,7404830,7404824,'cta',10,1),(18,7404831,7404824,'tac',10,1),(18,7404832,7404824,'acc',10,1),(18,7404833,7404824,'cce',10,1),(18,7404834,7404824,'ces',10,1),(18,7404835,7404824,'ess',10,1),(18,7404836,7404826,'mul',14.286,1),(18,7404837,7404826,'ult',14.286,1),(18,7404838,7404826,'lti',14.286,1),(18,7404839,7404826,'tip',14.286,1),(18,7404840,7404826,'ipa',14.286,1),(18,7404841,7404826,'pat',14.286,1),(18,7404842,7404826,'ath',14.286,1),(18,7404843,7404836,'plu',25,1),(18,7404844,7404836,'lug',25,1),(18,7404845,7404836,'ugi',25,1),(18,7404846,7404836,'gin',25,1),(18,7404847,7404843,'nmp',100,1),(18,7404848,7404847,'dev',33.333,1),(18,7404849,7404847,'evf',33.333,1),(18,7404850,7404847,'vfs',33.333,1),(18,7404851,7404848,'pat',50,1),(18,7404852,7404848,'ath',50,1),(18,7404853,7404851,'vmf',50,1),(18,7404854,7404851,'mfs',50,1),(18,7404855,7404853,'dev',20,1),(18,7404856,7404853,'evi',20,1),(18,7404857,7404853,'vic',20,1),(18,7404858,7404853,'ice',20,1),(18,7404859,7404853,'ces',20,1),(18,7404860,7404855,'dis',33.333,1),(18,7404861,7404855,'isk',33.333,1),(18,7404862,7404855,'sks',33.333,1),(18,7404863,7404860,'ven',25,1),(18,7404864,7404860,'end',25,1),(18,7404865,7404860,'ndo',25,1),(18,7404866,7404860,'dor',25,1),(18,7404867,7404863,'mod',33.333,1),(18,7404868,7404863,'ode',33.333,1),(18,7404869,7404863,'del',33.333,1),(18,7404870,7404867,'lun',100,1),(18,7404871,7404870,'cmo',33.333,1),(18,7404872,7404870,'mod',33.333,1),(18,7404873,7404870,'ode',33.333,1),(18,7404874,7404871,'rev',16.667,1),(18,7404875,7404871,'evi',16.667,1),(18,7404876,7404871,'vis',16.667,1),(18,7404877,7404871,'isi',16.667,1),(18,7404878,7404871,'sio',16.667,1),(18,7404879,7404871,'ion',16.667,1),(18,7404880,7404874,'810',50,1),(18,7404881,7404874,'100',50,1),(18,7404882,7404880,'scs',50,1),(18,7404883,7404880,'csi',50,1),(18,7404884,7404882,'lev',33.333,1),(18,7404885,7404882,'eve',33.333,1),(18,7404886,7404882,'vel',33.333,1),(18,7404887,7404884,'pse',25,1),(18,7404888,7404884,'seu',25,1),(18,7404889,7404884,'eud',25,1),(18,7404890,7404884,'udo',25,1),(18,7404891,7404887,'fal',33.333,6),(18,7404892,7404887,'als',33.333,6),(18,7404893,7404887,'lse',33.333,6),(18,7404894,7404891,'sta',25,3),(18,7404895,7404891,'tat',25,3),(18,7404896,7404891,'atu',25,3),(18,7404897,7404891,'tus',25,3),(18,7404898,7404894,'rdm',100,1),(18,7404899,7404898,'cap',20,1),(18,7404900,7404898,'apa',20,1),(18,7404901,7404898,'pab',20,1),(18,7404902,7404898,'abl',20,1),(18,7404903,7404898,'ble',20,1),(18,7404904,7404899,'tru',50,1),(18,7404905,7404899,'rue',50,1),(18,7404906,7404904,'loc',33.333,1),(18,7404907,7404904,'oca',33.333,1),(18,7404908,7404904,'cal',33.333,1),(18,7404909,7404906,'rem',14.286,1),(18,7404910,7404906,'emo',14.286,1),(18,7404911,7404906,'mov',14.286,1),(18,7404912,7404906,'ova',14.286,1),(18,7404913,7404906,'vab',14.286,1),(18,7404914,7404906,'abl',14.286,1),(18,7404915,7404906,'ble',14.286,1),(18,7404916,7404909,'ssd',100,1),(18,7404917,7404916,'off',20,1),(18,7404918,7404916,'ffl',20,1),(18,7404919,7404916,'fli',20,1),(18,7404920,7404916,'lin',20,1),(18,7404921,7404916,'ine',20,1),(18,7404922,7404917,'per',11.111,1),(18,7404923,7404917,'ere',11.111,1),(18,7404924,7404917,'ren',11.111,1),(18,7404925,7404917,'enn',11.111,1),(18,7404926,7404917,'nni',11.111,1),(18,7404927,7404917,'nia',11.111,1),(18,7404928,7404917,'ial',11.111,1),(18,7404929,7404917,'all',11.111,1),(18,7404930,7404917,'lly',11.111,1),(18,7404931,7404922,'res',16.667,1),(18,7404932,7404922,'ese',16.667,1),(18,7404933,7404922,'ser',16.667,1),(18,7404934,7404922,'erv',16.667,1),(18,7404935,7404922,'rve',16.667,1),(18,7404936,7404922,'ved',16.667,1),(18,7404937,7404931,'thi',50,1),(18,7404938,7404931,'hin',50,1),(18,7404939,7404937,'pro',10,1),(18,7404940,7404937,'rov',10,1),(18,7404941,7404937,'ovi',10,1),(18,7404942,7404937,'vis',10,1),(18,7404943,7404937,'isi',10,1),(18,7404944,7404937,'sio',10,1),(18,7404945,7404937,'ion',10,1),(18,7404946,7404937,'oni',10,1),(18,7404947,7404937,'nin',10,1),(18,7404948,7404937,'ing',10,1),(18,7404949,7404939,'yes',100,1),(18,7404950,7404949,'att',16.667,1),(18,7404951,7404949,'tta',16.667,1),(18,7404952,7404949,'tac',16.667,1),(18,7404953,7404949,'ach',16.667,1),(18,7404954,7404949,'che',16.667,1),(18,7404955,7404949,'hed',16.667,1),(18,7404956,7404950,'fil',20,1),(18,7404957,7404950,'ilt',20,1),(18,7404958,7404950,'lte',20,1),(18,7404959,7404950,'ter',20,1),(18,7404960,7404950,'ers',20,1),(18,7404961,7404956,'vaa',50,1),(18,7404962,7404956,'aai',50,1),(18,7404963,7404961,'unk',20,1),(18,7404964,7404961,'nkn',20,1),(18,7404965,7404961,'kno',20,1),(18,7404966,7404961,'now',20,1),(18,7404967,7404961,'own',20,1),(18,7404968,7404963,'oth',33.333,1),(18,7404969,7404963,'the',33.333,1),(18,7404970,7404963,'her',33.333,1),(18,7404971,7404968,'uid',50,1),(18,7404972,7404968,'ids',50,1),(18,7404973,7404971,'vml',100,1),(18,7404974,7404973,'dis',20,1),(18,7404975,7404973,'isp',20,1),(18,7404976,7404973,'spl',20,1),(18,7404977,7404973,'pla',20,1),(18,7404978,7404973,'lay',20,1),(18,7404979,7404974,'nam',50,1),(18,7404980,7404974,'ame',50,1),(19,7404982,7404981,'net',25,3),(19,7404983,7404981,'eta',25,3),(19,7404984,7404981,'tap',25,3),(19,7404985,7404981,'app',25,3),(19,7404986,7404982,'ser',25,3),(19,7404987,7404982,'eri',25,3),(19,7404988,7404982,'ria',25,3),(19,7404989,7404982,'ial',25,3),(19,7404990,7404986,'att',16.667,3),(19,7404991,7404986,'tta',16.667,3),(19,7404992,7404986,'tac',16.667,3),(19,7404993,7404986,'ach',16.667,3),(19,7404994,7404986,'che',16.667,3),(19,7404995,7404986,'hed',16.667,3),(19,7404996,7404990,'scs',50,3),(19,7404997,7404990,'csi',50,3),(19,7404998,7404996,'dis',50,2),(19,7404999,7404996,'isk',50,2),(19,7405000,7404998,'naa',100,4),(19,7405001,7405000,'600',3.333,4),(19,7405002,7405000,'00a',3.333,4),(19,7405003,7405000,'0a0',3.333,4),(19,7405004,7405000,'a09',3.333,4),(19,7405005,7405000,'098',3.333,4),(19,7405006,7405000,'980',3.333,4),(19,7405007,7405000,'801',3.333,4),(19,7405008,7405000,'016',3.333,4),(19,7405009,7405000,'167',3.333,4),(19,7405010,7405000,'677',3.333,4),(19,7405011,7405000,'778',3.333,4),(19,7405012,7405000,'784',3.333,4),(19,7405013,7405000,'84e',3.333,4),(19,7405014,7405000,'4ee',3.333,4),(19,7405015,7405000,'eec',3.333,4),(19,7405016,7405000,'ec4',3.333,4),(19,7405017,7405000,'c4d',3.333,4),(19,7405018,7405000,'4d3',3.333,4),(19,7405019,7405000,'d34',3.333,4),(19,7405020,7405000,'341',3.333,4),(19,7405021,7405000,'411',3.333,4),(19,7405022,7405000,'111',3.333,4),(19,7405023,7405000,'117',3.333,4),(19,7405024,7405000,'17b',3.333,4),(19,7405025,7405000,'7b0',3.333,4),(19,7405026,7405000,'b0d',3.333,4),(19,7405027,7405000,'0da',3.333,4),(19,7405028,7405000,'dab',3.333,4),(19,7405029,7405000,'aba',3.333,4),(19,7405030,7405000,'ba2',3.333,4),(19,7405031,7405001,'siz',50,1),(19,7405032,7405001,'ize',50,1),(19,7405033,7405031,'163',33.333,1),(19,7405034,7405031,'638',33.333,1),(19,7405035,7405031,'384',33.333,1),(19,7405036,7405033,'dev',25,1),(19,7405037,7405033,'evi',25,1),(19,7405038,7405033,'vic',25,1),(19,7405039,7405033,'ice',25,1),(19,7405040,7405036,'typ',50,1),(19,7405041,7405036,'ype',50,1),(19,7405042,7405040,'dir',10,1),(19,7405043,7405040,'ire',10,1),(19,7405044,7405040,'rec',10,1),(19,7405045,7405040,'ect',10,1),(19,7405046,7405040,'cta',10,1),(19,7405047,7405040,'tac',10,1),(19,7405048,7405040,'acc',10,1),(19,7405049,7405040,'cce',10,1),(19,7405050,7405040,'ces',10,1),(19,7405051,7405040,'ess',10,1),(19,7405052,7405042,'mul',14.286,1),(19,7405053,7405042,'ult',14.286,1),(19,7405054,7405042,'lti',14.286,1),(19,7405055,7405042,'tip',14.286,1),(19,7405056,7405042,'ipa',14.286,1),(19,7405057,7405042,'pat',14.286,1),(19,7405058,7405042,'ath',14.286,1),(19,7405059,7405052,'plu',25,1),(19,7405060,7405052,'lug',25,1),(19,7405061,7405052,'ugi',25,1),(19,7405062,7405052,'gin',25,1),(19,7405063,7405059,'nmp',100,1),(19,7405064,7405063,'dev',33.333,1),(19,7405065,7405063,'evf',33.333,1),(19,7405066,7405063,'vfs',33.333,1),(19,7405067,7405064,'pat',50,1),(19,7405068,7405064,'ath',50,1),(19,7405069,7405067,'vmf',50,1),(19,7405070,7405067,'mfs',50,1),(19,7405071,7405069,'dev',20,1),(19,7405072,7405069,'evi',20,1),(19,7405073,7405069,'vic',20,1),(19,7405074,7405069,'ice',20,1),(19,7405075,7405069,'ces',20,1),(19,7405076,7405071,'dis',33.333,1),(19,7405077,7405071,'isk',33.333,1),(19,7405078,7405071,'sks',33.333,1),(19,7405079,7405076,'ven',25,1),(19,7405080,7405076,'end',25,1),(19,7405081,7405076,'ndo',25,1),(19,7405082,7405076,'dor',25,1),(19,7405083,7405079,'mod',33.333,1),(19,7405084,7405079,'ode',33.333,1),(19,7405085,7405079,'del',33.333,1),(19,7405086,7405083,'fla',33.333,1),(19,7405087,7405083,'las',33.333,1),(19,7405088,7405083,'ash',33.333,1),(19,7405089,7405086,'acc',33.333,1),(19,7405090,7405086,'cce',33.333,1),(19,7405091,7405086,'cel',33.333,1),(19,7405092,7405089,'rev',16.667,1),(19,7405093,7405089,'evi',16.667,1),(19,7405094,7405089,'vis',16.667,1),(19,7405095,7405089,'isi',16.667,1),(19,7405096,7405089,'sio',16.667,1),(19,7405097,7405089,'ion',16.667,1),(19,7405098,7405092,'lev',33.333,1),(19,7405099,7405092,'eve',33.333,1),(19,7405100,7405092,'vel',33.333,1),(19,7405101,7405098,'pse',25,1),(19,7405102,7405098,'seu',25,1),(19,7405103,7405098,'eud',25,1),(19,7405104,7405098,'udo',25,1),(19,7405105,7405101,'fal',33.333,5),(19,7405106,7405101,'als',33.333,5),(19,7405107,7405101,'lse',33.333,5),(19,7405108,7405105,'sta',25,3),(19,7405109,7405105,'tat',25,3),(19,7405110,7405105,'atu',25,3),(19,7405111,7405105,'tus',25,3),(19,7405112,7405108,'deg',16.667,1),(19,7405113,7405108,'egr',16.667,1),(19,7405114,7405108,'gra',16.667,1),(19,7405115,7405108,'rad',16.667,1),(19,7405116,7405108,'ade',16.667,1),(19,7405117,7405108,'ded',16.667,1),(19,7405118,7405112,'rdm',100,1),(19,7405119,7405118,'cap',20,1),(19,7405120,7405118,'apa',20,1),(19,7405121,7405118,'pab',20,1),(19,7405122,7405118,'abl',20,1),(19,7405123,7405118,'ble',20,1),(19,7405124,7405119,'tru',50,2),(19,7405125,7405119,'rue',50,2),(19,7405126,7405124,'loc',33.333,1),(19,7405127,7405124,'oca',33.333,1),(19,7405128,7405124,'cal',33.333,1),(19,7405129,7405126,'rem',14.286,1),(19,7405130,7405126,'emo',14.286,1),(19,7405131,7405126,'mov',14.286,1),(19,7405132,7405126,'ova',14.286,1),(19,7405133,7405126,'vab',14.286,1),(19,7405134,7405126,'abl',14.286,1),(19,7405135,7405126,'ble',14.286,1),(19,7405136,7405129,'ssd',100,1),(19,7405137,7405136,'off',20,1),(19,7405138,7405136,'ffl',20,1),(19,7405139,7405136,'fli',20,1),(19,7405140,7405136,'lin',20,1),(19,7405141,7405136,'ine',20,1),(19,7405142,7405137,'per',11.111,1),(19,7405143,7405137,'ere',11.111,1),(19,7405144,7405137,'ren',11.111,1),(19,7405145,7405137,'enn',11.111,1),(19,7405146,7405137,'nni',11.111,1),(19,7405147,7405137,'nia',11.111,1),(19,7405148,7405137,'ial',11.111,1),(19,7405149,7405137,'all',11.111,1),(19,7405150,7405137,'lly',11.111,1),(19,7405151,7405142,'res',16.667,1),(19,7405152,7405142,'ese',16.667,1),(19,7405153,7405142,'ser',16.667,1),(19,7405154,7405142,'erv',16.667,1),(19,7405155,7405142,'rve',16.667,1),(19,7405156,7405142,'ved',16.667,1),(19,7405157,7405151,'thi',50,1),(19,7405158,7405151,'hin',50,1),(19,7405159,7405157,'pro',10,1),(19,7405160,7405157,'rov',10,1),(19,7405161,7405157,'ovi',10,1),(19,7405162,7405157,'vis',10,1),(19,7405163,7405157,'isi',10,1),(19,7405164,7405157,'sio',10,1),(19,7405165,7405157,'ion',10,1),(19,7405166,7405157,'oni',10,1),(19,7405167,7405157,'nin',10,1),(19,7405168,7405157,'ing',10,1),(19,7405169,7405159,'unk',20,1),(19,7405170,7405159,'nkn',20,1),(19,7405171,7405159,'kno',20,1),(19,7405172,7405159,'now',20,1),(19,7405173,7405159,'own',20,1),(19,7405174,7405169,'fil',20,1),(19,7405175,7405169,'ilt',20,1),(19,7405176,7405169,'lte',20,1),(19,7405177,7405169,'ter',20,1),(19,7405178,7405169,'ers',20,1),(19,7405179,7405174,'vaa',50,1),(19,7405180,7405174,'aai',50,1),(19,7405181,7405179,'uns',11.111,1),(19,7405182,7405179,'nsu',11.111,1),(19,7405183,7405179,'sup',11.111,1),(19,7405184,7405179,'upp',11.111,1),(19,7405185,7405179,'ppo',11.111,1),(19,7405186,7405179,'por',11.111,1),(19,7405187,7405179,'ort',11.111,1),(19,7405188,7405179,'rte',11.111,1),(19,7405189,7405179,'ted',11.111,1),(19,7405190,7405181,'oth',33.333,1),(19,7405191,7405181,'the',33.333,1),(19,7405192,7405181,'her',33.333,1),(19,7405193,7405190,'uid',50,1),(19,7405194,7405190,'ids',50,1),(19,7405195,7405193,'vml',100,1),(19,7405196,7405195,'dis',20,1),(19,7405197,7405195,'isp',20,1),(19,7405198,7405195,'spl',20,1),(19,7405199,7405195,'pla',20,1),(19,7405200,7405195,'lay',20,1),(19,7405201,7405196,'nam',50,1),(19,7405202,7405196,'ame',50,1),(20,7405204,7405203,'net',25,3),(20,7405205,7405203,'eta',25,3),(20,7405206,7405203,'tap',25,3),(20,7405207,7405203,'app',25,3),(20,7405208,7405204,'fib',33.333,2),(20,7405209,7405204,'ibr',33.333,2),(20,7405210,7405204,'bre',33.333,2),(20,7405211,7405208,'cha',20,2),(20,7405212,7405208,'han',20,2),(20,7405213,7405208,'ann',20,2),(20,7405214,7405208,'nne',20,2),(20,7405215,7405208,'nel',20,2),(20,7405216,7405211,'dis',50,2),(20,7405217,7405211,'isk',50,2),(20,7405218,7405216,'naa',100,4),(20,7405219,7405218,'600',3.333,4),(20,7405220,7405218,'00a',3.333,4),(20,7405221,7405218,'0a0',3.333,4),(20,7405222,7405218,'a09',3.333,4),(20,7405223,7405218,'098',3.333,4),(20,7405224,7405218,'980',3.333,4),(20,7405225,7405218,'804',3.333,4),(20,7405226,7405218,'044',3.333,4),(20,7405227,7405218,'443',3.333,4),(20,7405228,7405218,'430',3.333,4),(20,7405229,7405218,'307',3.333,4),(20,7405230,7405218,'072',3.333,4),(20,7405231,7405218,'725',3.333,4),(20,7405232,7405218,'259',3.333,4),(20,7405233,7405218,'593',3.333,4),(20,7405234,7405218,'931',3.333,4),(20,7405235,7405218,'313',3.333,4),(20,7405236,7405218,'13f',3.333,4),(20,7405237,7405218,'3f3',3.333,4),(20,7405238,7405218,'f33',3.333,4),(20,7405239,7405218,'334',3.333,4),(20,7405240,7405218,'345',3.333,4),(20,7405241,7405218,'455',3.333,4),(20,7405242,7405218,'556',3.333,4),(20,7405243,7405218,'563',3.333,4),(20,7405244,7405218,'639',3.333,4),(20,7405245,7405218,'393',3.333,4),(20,7405246,7405218,'934',3.333,4),(20,7405247,7405218,'346',3.333,4),(20,7405248,7405218,'46c',3.333,4),(20,7405249,7405219,'ser',25,1),(20,7405250,7405219,'eri',25,1),(20,7405251,7405219,'ria',25,1),(20,7405252,7405219,'ial',25,1),(20,7405253,7405249,'siz',50,1),(20,7405254,7405249,'ize',50,1),(20,7405255,7405253,'321',100,1),(20,7405256,7405255,'dev',25,1),(20,7405257,7405255,'evi',25,1),(20,7405258,7405255,'vic',25,1),(20,7405259,7405255,'ice',25,1),(20,7405260,7405256,'typ',50,1),(20,7405261,7405256,'ype',50,1),(20,7405262,7405260,'dir',10,1),(20,7405263,7405260,'ire',10,1),(20,7405264,7405260,'rec',10,1),(20,7405265,7405260,'ect',10,1),(20,7405266,7405260,'cta',10,1),(20,7405267,7405260,'tac',10,1),(20,7405268,7405260,'acc',10,1),(20,7405269,7405260,'cce',10,1),(20,7405270,7405260,'ces',10,1),(20,7405271,7405260,'ess',10,1),(20,7405272,7405262,'mul',14.286,1),(20,7405273,7405262,'ult',14.286,1),(20,7405274,7405262,'lti',14.286,1),(20,7405275,7405262,'tip',14.286,1),(20,7405276,7405262,'ipa',14.286,1),(20,7405277,7405262,'pat',14.286,1),(20,7405278,7405262,'ath',14.286,1),(20,7405279,7405272,'plu',25,1),(20,7405280,7405272,'lug',25,1),(20,7405281,7405272,'ugi',25,1),(20,7405282,7405272,'gin',25,1),(20,7405283,7405279,'nmp',100,1),(20,7405284,7405283,'dev',33.333,1),(20,7405285,7405283,'evf',33.333,1),(20,7405286,7405283,'vfs',33.333,1),(20,7405287,7405284,'pat',50,1),(20,7405288,7405284,'ath',50,1),(20,7405289,7405287,'vmf',50,1),(20,7405290,7405287,'mfs',50,1),(20,7405291,7405289,'dev',20,1),(20,7405292,7405289,'evi',20,1),(20,7405293,7405289,'vic',20,1),(20,7405294,7405289,'ice',20,1),(20,7405295,7405289,'ces',20,1),(20,7405296,7405291,'dis',33.333,1),(20,7405297,7405291,'isk',33.333,1),(20,7405298,7405291,'sks',33.333,1),(20,7405299,7405296,'ven',25,1),(20,7405300,7405296,'end',25,1),(20,7405301,7405296,'ndo',25,1),(20,7405302,7405296,'dor',25,1),(20,7405303,7405299,'mod',33.333,1),(20,7405304,7405299,'ode',33.333,1),(20,7405305,7405299,'del',33.333,1),(20,7405306,7405303,'lun',100,1),(20,7405307,7405306,'cmo',33.333,1),(20,7405308,7405306,'mod',33.333,1),(20,7405309,7405306,'ode',33.333,1),(20,7405310,7405307,'rev',16.667,1),(20,7405311,7405307,'evi',16.667,1),(20,7405312,7405307,'vis',16.667,1),(20,7405313,7405307,'isi',16.667,1),(20,7405314,7405307,'sio',16.667,1),(20,7405315,7405307,'ion',16.667,1),(20,7405316,7405310,'810',50,1),(20,7405317,7405310,'100',50,1),(20,7405318,7405316,'scs',50,1),(20,7405319,7405316,'csi',50,1),(20,7405320,7405318,'lev',33.333,1),(20,7405321,7405318,'eve',33.333,1),(20,7405322,7405318,'vel',33.333,1),(20,7405323,7405320,'pse',25,1),(20,7405324,7405320,'seu',25,1),(20,7405325,7405320,'eud',25,1),(20,7405326,7405320,'udo',25,1),(20,7405327,7405323,'fal',33.333,6),(20,7405328,7405323,'als',33.333,6),(20,7405329,7405323,'lse',33.333,6),(20,7405330,7405327,'sta',25,3),(20,7405331,7405327,'tat',25,3),(20,7405332,7405327,'atu',25,3),(20,7405333,7405327,'tus',25,3),(20,7405334,7405330,'rdm',100,1),(20,7405335,7405334,'cap',20,1),(20,7405336,7405334,'apa',20,1),(20,7405337,7405334,'pab',20,1),(20,7405338,7405334,'abl',20,1),(20,7405339,7405334,'ble',20,1),(20,7405340,7405335,'tru',50,1),(20,7405341,7405335,'rue',50,1),(20,7405342,7405340,'loc',33.333,1),(20,7405343,7405340,'oca',33.333,1),(20,7405344,7405340,'cal',33.333,1),(20,7405345,7405342,'rem',14.286,1),(20,7405346,7405342,'emo',14.286,1),(20,7405347,7405342,'mov',14.286,1),(20,7405348,7405342,'ova',14.286,1),(20,7405349,7405342,'vab',14.286,1),(20,7405350,7405342,'abl',14.286,1),(20,7405351,7405342,'ble',14.286,1),(20,7405352,7405345,'ssd',100,1),(20,7405353,7405352,'off',20,1),(20,7405354,7405352,'ffl',20,1),(20,7405355,7405352,'fli',20,1),(20,7405356,7405352,'lin',20,1),(20,7405357,7405352,'ine',20,1),(20,7405358,7405353,'per',11.111,1),(20,7405359,7405353,'ere',11.111,1),(20,7405360,7405353,'ren',11.111,1),(20,7405361,7405353,'enn',11.111,1),(20,7405362,7405353,'nni',11.111,1),(20,7405363,7405353,'nia',11.111,1),(20,7405364,7405353,'ial',11.111,1),(20,7405365,7405353,'all',11.111,1),(20,7405366,7405353,'lly',11.111,1),(20,7405367,7405358,'res',16.667,1),(20,7405368,7405358,'ese',16.667,1),(20,7405369,7405358,'ser',16.667,1),(20,7405370,7405358,'erv',16.667,1),(20,7405371,7405358,'rve',16.667,1),(20,7405372,7405358,'ved',16.667,1),(20,7405373,7405367,'thi',50,1),(20,7405374,7405367,'hin',50,1),(20,7405375,7405373,'pro',10,1),(20,7405376,7405373,'rov',10,1),(20,7405377,7405373,'ovi',10,1),(20,7405378,7405373,'vis',10,1),(20,7405379,7405373,'isi',10,1),(20,7405380,7405373,'sio',10,1),(20,7405381,7405373,'ion',10,1),(20,7405382,7405373,'oni',10,1),(20,7405383,7405373,'nin',10,1),(20,7405384,7405373,'ing',10,1),(20,7405385,7405375,'yes',100,1),(20,7405386,7405385,'att',16.667,1),(20,7405387,7405385,'tta',16.667,1),(20,7405388,7405385,'tac',16.667,1),(20,7405389,7405385,'ach',16.667,1),(20,7405390,7405385,'che',16.667,1),(20,7405391,7405385,'hed',16.667,1),(20,7405392,7405386,'fil',20,1),(20,7405393,7405386,'ilt',20,1),(20,7405394,7405386,'lte',20,1),(20,7405395,7405386,'ter',20,1),(20,7405396,7405386,'ers',20,1),(20,7405397,7405392,'vaa',50,1),(20,7405398,7405392,'aai',50,1),(20,7405399,7405397,'unk',20,1),(20,7405400,7405397,'nkn',20,1),(20,7405401,7405397,'kno',20,1),(20,7405402,7405397,'now',20,1),(20,7405403,7405397,'own',20,1),(20,7405404,7405399,'oth',33.333,1),(20,7405405,7405399,'the',33.333,1),(20,7405406,7405399,'her',33.333,1),(20,7405407,7405404,'uid',50,1),(20,7405408,7405404,'ids',50,1),(20,7405409,7405407,'vml',100,1),(20,7405410,7405409,'dis',20,1),(20,7405411,7405409,'isp',20,1),(20,7405412,7405409,'spl',20,1),(20,7405413,7405409,'pla',20,1),(20,7405414,7405409,'lay',20,1),(20,7405415,7405410,'nam',50,1),(20,7405416,7405410,'ame',50,1),(21,7405418,7405417,'net',25,3),(21,7405419,7405417,'eta',25,3),(21,7405420,7405417,'tap',25,3),(21,7405421,7405417,'app',25,3),(21,7405422,7405418,'fib',33.333,2),(21,7405423,7405418,'ibr',33.333,2),(21,7405424,7405418,'bre',33.333,2),(21,7405425,7405422,'cha',20,2),(21,7405426,7405422,'han',20,2),(21,7405427,7405422,'ann',20,2),(21,7405428,7405422,'nne',20,2),(21,7405429,7405422,'nel',20,2),(21,7405430,7405425,'dis',50,2),(21,7405431,7405425,'isk',50,2),(21,7405432,7405430,'naa',100,4),(21,7405433,7405432,'600',3.333,4),(21,7405434,7405432,'00a',3.333,4),(21,7405435,7405432,'0a0',3.333,4),(21,7405436,7405432,'a09',3.333,4),(21,7405437,7405432,'098',3.333,4),(21,7405438,7405432,'980',3.333,4),(21,7405439,7405432,'804',3.333,4),(21,7405440,7405432,'044',3.333,4),(21,7405441,7405432,'443',3.333,4),(21,7405442,7405432,'430',3.333,4),(21,7405443,7405432,'307',3.333,4),(21,7405444,7405432,'072',3.333,4),(21,7405445,7405432,'725',3.333,4),(21,7405446,7405432,'259',3.333,4),(21,7405447,7405432,'593',3.333,4),(21,7405448,7405432,'931',3.333,4),(21,7405449,7405432,'313',3.333,4),(21,7405450,7405432,'13f',3.333,4),(21,7405451,7405432,'3f3',3.333,4),(21,7405452,7405432,'f33',3.333,4),(21,7405453,7405432,'334',3.333,4),(21,7405454,7405432,'345',3.333,4),(21,7405455,7405432,'455',3.333,4),(21,7405456,7405432,'556',3.333,4),(21,7405457,7405432,'563',3.333,4),(21,7405458,7405432,'639',3.333,4),(21,7405459,7405432,'393',3.333,4),(21,7405460,7405432,'934',3.333,4),(21,7405461,7405432,'346',3.333,4),(21,7405462,7405432,'46d',3.333,4),(21,7405463,7405433,'ser',25,1),(21,7405464,7405433,'eri',25,1),(21,7405465,7405433,'ria',25,1),(21,7405466,7405433,'ial',25,1),(21,7405467,7405463,'siz',50,1),(21,7405468,7405463,'ize',50,1),(21,7405469,7405467,'321',100,1),(21,7405470,7405469,'dev',25,1),(21,7405471,7405469,'evi',25,1),(21,7405472,7405469,'vic',25,1),(21,7405473,7405469,'ice',25,1),(21,7405474,7405470,'typ',50,1),(21,7405475,7405470,'ype',50,1),(21,7405476,7405474,'dir',10,1),(21,7405477,7405474,'ire',10,1),(21,7405478,7405474,'rec',10,1),(21,7405479,7405474,'ect',10,1),(21,7405480,7405474,'cta',10,1),(21,7405481,7405474,'tac',10,1),(21,7405482,7405474,'acc',10,1),(21,7405483,7405474,'cce',10,1),(21,7405484,7405474,'ces',10,1),(21,7405485,7405474,'ess',10,1),(21,7405486,7405476,'mul',14.286,1),(21,7405487,7405476,'ult',14.286,1),(21,7405488,7405476,'lti',14.286,1),(21,7405489,7405476,'tip',14.286,1),(21,7405490,7405476,'ipa',14.286,1),(21,7405491,7405476,'pat',14.286,1),(21,7405492,7405476,'ath',14.286,1),(21,7405493,7405486,'plu',25,1),(21,7405494,7405486,'lug',25,1),(21,7405495,7405486,'ugi',25,1),(21,7405496,7405486,'gin',25,1),(21,7405497,7405493,'nmp',100,1),(21,7405498,7405497,'dev',33.333,1),(21,7405499,7405497,'evf',33.333,1),(21,7405500,7405497,'vfs',33.333,1),(21,7405501,7405498,'pat',50,1),(21,7405502,7405498,'ath',50,1),(21,7405503,7405501,'vmf',50,1),(21,7405504,7405501,'mfs',50,1),(21,7405505,7405503,'dev',20,1),(21,7405506,7405503,'evi',20,1),(21,7405507,7405503,'vic',20,1),(21,7405508,7405503,'ice',20,1),(21,7405509,7405503,'ces',20,1),(21,7405510,7405505,'dis',33.333,1),(21,7405511,7405505,'isk',33.333,1),(21,7405512,7405505,'sks',33.333,1),(21,7405513,7405510,'ven',25,1),(21,7405514,7405510,'end',25,1),(21,7405515,7405510,'ndo',25,1),(21,7405516,7405510,'dor',25,1),(21,7405517,7405513,'mod',33.333,1),(21,7405518,7405513,'ode',33.333,1),(21,7405519,7405513,'del',33.333,1),(21,7405520,7405517,'lun',100,1),(21,7405521,7405520,'cmo',33.333,1),(21,7405522,7405520,'mod',33.333,1),(21,7405523,7405520,'ode',33.333,1),(21,7405524,7405521,'rev',16.667,1),(21,7405525,7405521,'evi',16.667,1),(21,7405526,7405521,'vis',16.667,1),(21,7405527,7405521,'isi',16.667,1),(21,7405528,7405521,'sio',16.667,1),(21,7405529,7405521,'ion',16.667,1),(21,7405530,7405524,'810',50,1),(21,7405531,7405524,'100',50,1),(21,7405532,7405530,'scs',50,1),(21,7405533,7405530,'csi',50,1),(21,7405534,7405532,'lev',33.333,1),(21,7405535,7405532,'eve',33.333,1),(21,7405536,7405532,'vel',33.333,1),(21,7405537,7405534,'pse',25,1),(21,7405538,7405534,'seu',25,1),(21,7405539,7405534,'eud',25,1),(21,7405540,7405534,'udo',25,1),(21,7405541,7405537,'fal',33.333,6),(21,7405542,7405537,'als',33.333,6),(21,7405543,7405537,'lse',33.333,6),(21,7405544,7405541,'sta',25,3),(21,7405545,7405541,'tat',25,3),(21,7405546,7405541,'atu',25,3),(21,7405547,7405541,'tus',25,3),(21,7405548,7405544,'rdm',100,1),(21,7405549,7405548,'cap',20,1),(21,7405550,7405548,'apa',20,1),(21,7405551,7405548,'pab',20,1),(21,7405552,7405548,'abl',20,1),(21,7405553,7405548,'ble',20,1),(21,7405554,7405549,'tru',50,1),(21,7405555,7405549,'rue',50,1),(21,7405556,7405554,'loc',33.333,1),(21,7405557,7405554,'oca',33.333,1),(21,7405558,7405554,'cal',33.333,1),(21,7405559,7405556,'rem',14.286,1),(21,7405560,7405556,'emo',14.286,1),(21,7405561,7405556,'mov',14.286,1),(21,7405562,7405556,'ova',14.286,1),(21,7405563,7405556,'vab',14.286,1),(21,7405564,7405556,'abl',14.286,1),(21,7405565,7405556,'ble',14.286,1),(21,7405566,7405559,'ssd',100,1),(21,7405567,7405566,'off',20,1),(21,7405568,7405566,'ffl',20,1),(21,7405569,7405566,'fli',20,1),(21,7405570,7405566,'lin',20,1),(21,7405571,7405566,'ine',20,1),(21,7405572,7405567,'per',11.111,1),(21,7405573,7405567,'ere',11.111,1),(21,7405574,7405567,'ren',11.111,1),(21,7405575,7405567,'enn',11.111,1),(21,7405576,7405567,'nni',11.111,1),(21,7405577,7405567,'nia',11.111,1),(21,7405578,7405567,'ial',11.111,1),(21,7405579,7405567,'all',11.111,1),(21,7405580,7405567,'lly',11.111,1),(21,7405581,7405572,'res',16.667,1),(21,7405582,7405572,'ese',16.667,1),(21,7405583,7405572,'ser',16.667,1),(21,7405584,7405572,'erv',16.667,1),(21,7405585,7405572,'rve',16.667,1),(21,7405586,7405572,'ved',16.667,1),(21,7405587,7405581,'thi',50,1),(21,7405588,7405581,'hin',50,1),(21,7405589,7405587,'pro',10,1),(21,7405590,7405587,'rov',10,1),(21,7405591,7405587,'ovi',10,1),(21,7405592,7405587,'vis',10,1),(21,7405593,7405587,'isi',10,1),(21,7405594,7405587,'sio',10,1),(21,7405595,7405587,'ion',10,1),(21,7405596,7405587,'oni',10,1),(21,7405597,7405587,'nin',10,1),(21,7405598,7405587,'ing',10,1),(21,7405599,7405589,'yes',100,1),(21,7405600,7405599,'att',16.667,1),(21,7405601,7405599,'tta',16.667,1),(21,7405602,7405599,'tac',16.667,1),(21,7405603,7405599,'ach',16.667,1),(21,7405604,7405599,'che',16.667,1),(21,7405605,7405599,'hed',16.667,1),(21,7405606,7405600,'fil',20,1),(21,7405607,7405600,'ilt',20,1),(21,7405608,7405600,'lte',20,1),(21,7405609,7405600,'ter',20,1),(21,7405610,7405600,'ers',20,1),(21,7405611,7405606,'vaa',50,1),(21,7405612,7405606,'aai',50,1),(21,7405613,7405611,'unk',20,1),(21,7405614,7405611,'nkn',20,1),(21,7405615,7405611,'kno',20,1),(21,7405616,7405611,'now',20,1),(21,7405617,7405611,'own',20,1),(21,7405618,7405613,'oth',33.333,1),(21,7405619,7405613,'the',33.333,1),(21,7405620,7405613,'her',33.333,1),(21,7405621,7405618,'uid',50,1),(21,7405622,7405618,'ids',50,1),(21,7405623,7405621,'vml',100,1),(21,7405624,7405623,'dis',20,1),(21,7405625,7405623,'isp',20,1),(21,7405626,7405623,'spl',20,1),(21,7405627,7405623,'pla',20,1),(21,7405628,7405623,'lay',20,1),(21,7405629,7405624,'nam',50,1),(21,7405630,7405624,'ame',50,1),(22,7405632,7405631,'net',25,3),(22,7405633,7405631,'eta',25,3),(22,7405634,7405631,'tap',25,3),(22,7405635,7405631,'app',25,3),(22,7405636,7405632,'fib',33.333,2),(22,7405637,7405632,'ibr',33.333,2),(22,7405638,7405632,'bre',33.333,2),(22,7405639,7405636,'cha',20,2),(22,7405640,7405636,'han',20,2),(22,7405641,7405636,'ann',20,2),(22,7405642,7405636,'nne',20,2),(22,7405643,7405636,'nel',20,2),(22,7405644,7405639,'dis',50,2),(22,7405645,7405639,'isk',50,2),(22,7405646,7405644,'naa',100,4),(22,7405647,7405646,'600',3.333,4),(22,7405648,7405646,'00a',3.333,4),(22,7405649,7405646,'0a0',3.333,4),(22,7405650,7405646,'a09',3.333,4),(22,7405651,7405646,'098',3.333,4),(22,7405652,7405646,'980',3.333,4),(22,7405653,7405646,'804',3.333,4),(22,7405654,7405646,'044',3.333,4),(22,7405655,7405646,'443',3.333,4),(22,7405656,7405646,'430',3.333,4),(22,7405657,7405646,'307',3.333,4),(22,7405658,7405646,'072',3.333,4),(22,7405659,7405646,'725',3.333,4),(22,7405660,7405646,'259',3.333,4),(22,7405661,7405646,'593',3.333,4),(22,7405662,7405646,'931',3.333,4),(22,7405663,7405646,'313',3.333,4),(22,7405664,7405646,'13f',3.333,4),(22,7405665,7405646,'3f3',3.333,4),(22,7405666,7405646,'f33',3.333,4),(22,7405667,7405646,'334',3.333,4),(22,7405668,7405646,'345',3.333,4),(22,7405669,7405646,'455',3.333,4),(22,7405670,7405646,'556',3.333,4),(22,7405671,7405646,'563',3.333,4),(22,7405672,7405646,'639',3.333,4),(22,7405673,7405646,'393',3.333,4),(22,7405674,7405646,'934',3.333,4),(22,7405675,7405646,'346',3.333,4),(22,7405676,7405646,'46e',3.333,4),(22,7405677,7405647,'ser',25,1),(22,7405678,7405647,'eri',25,1),(22,7405679,7405647,'ria',25,1),(22,7405680,7405647,'ial',25,1),(22,7405681,7405677,'siz',50,1),(22,7405682,7405677,'ize',50,1),(22,7405683,7405681,'321',100,1),(22,7405684,7405683,'dev',25,1),(22,7405685,7405683,'evi',25,1),(22,7405686,7405683,'vic',25,1),(22,7405687,7405683,'ice',25,1),(22,7405688,7405684,'typ',50,1),(22,7405689,7405684,'ype',50,1),(22,7405690,7405688,'dir',10,1),(22,7405691,7405688,'ire',10,1),(22,7405692,7405688,'rec',10,1),(22,7405693,7405688,'ect',10,1),(22,7405694,7405688,'cta',10,1),(22,7405695,7405688,'tac',10,1),(22,7405696,7405688,'acc',10,1),(22,7405697,7405688,'cce',10,1),(22,7405698,7405688,'ces',10,1),(22,7405699,7405688,'ess',10,1),(22,7405700,7405690,'mul',14.286,1),(22,7405701,7405690,'ult',14.286,1),(22,7405702,7405690,'lti',14.286,1),(22,7405703,7405690,'tip',14.286,1),(22,7405704,7405690,'ipa',14.286,1),(22,7405705,7405690,'pat',14.286,1),(22,7405706,7405690,'ath',14.286,1),(22,7405707,7405700,'plu',25,1),(22,7405708,7405700,'lug',25,1),(22,7405709,7405700,'ugi',25,1),(22,7405710,7405700,'gin',25,1),(22,7405711,7405707,'nmp',100,1),(22,7405712,7405711,'dev',33.333,1),(22,7405713,7405711,'evf',33.333,1),(22,7405714,7405711,'vfs',33.333,1),(22,7405715,7405712,'pat',50,1),(22,7405716,7405712,'ath',50,1),(22,7405717,7405715,'vmf',50,1),(22,7405718,7405715,'mfs',50,1),(22,7405719,7405717,'dev',20,1),(22,7405720,7405717,'evi',20,1),(22,7405721,7405717,'vic',20,1),(22,7405722,7405717,'ice',20,1),(22,7405723,7405717,'ces',20,1),(22,7405724,7405719,'dis',33.333,1),(22,7405725,7405719,'isk',33.333,1),(22,7405726,7405719,'sks',33.333,1),(22,7405727,7405724,'ven',25,1),(22,7405728,7405724,'end',25,1),(22,7405729,7405724,'ndo',25,1),(22,7405730,7405724,'dor',25,1),(22,7405731,7405727,'mod',33.333,1),(22,7405732,7405727,'ode',33.333,1),(22,7405733,7405727,'del',33.333,1),(22,7405734,7405731,'lun',100,1),(22,7405735,7405734,'cmo',33.333,1),(22,7405736,7405734,'mod',33.333,1),(22,7405737,7405734,'ode',33.333,1),(22,7405738,7405735,'rev',16.667,1),(22,7405739,7405735,'evi',16.667,1),(22,7405740,7405735,'vis',16.667,1),(22,7405741,7405735,'isi',16.667,1),(22,7405742,7405735,'sio',16.667,1),(22,7405743,7405735,'ion',16.667,1),(22,7405744,7405738,'810',50,1),(22,7405745,7405738,'100',50,1),(22,7405746,7405744,'scs',50,1),(22,7405747,7405744,'csi',50,1),(22,7405748,7405746,'lev',33.333,1),(22,7405749,7405746,'eve',33.333,1),(22,7405750,7405746,'vel',33.333,1),(22,7405751,7405748,'pse',25,1),(22,7405752,7405748,'seu',25,1),(22,7405753,7405748,'eud',25,1),(22,7405754,7405748,'udo',25,1),(22,7405755,7405751,'fal',33.333,6),(22,7405756,7405751,'als',33.333,6),(22,7405757,7405751,'lse',33.333,6),(22,7405758,7405755,'sta',25,3),(22,7405759,7405755,'tat',25,3),(22,7405760,7405755,'atu',25,3),(22,7405761,7405755,'tus',25,3),(22,7405762,7405758,'rdm',100,1),(22,7405763,7405762,'cap',20,1),(22,7405764,7405762,'apa',20,1),(22,7405765,7405762,'pab',20,1),(22,7405766,7405762,'abl',20,1),(22,7405767,7405762,'ble',20,1),(22,7405768,7405763,'tru',50,1),(22,7405769,7405763,'rue',50,1),(22,7405770,7405768,'loc',33.333,1),(22,7405771,7405768,'oca',33.333,1),(22,7405772,7405768,'cal',33.333,1),(22,7405773,7405770,'rem',14.286,1),(22,7405774,7405770,'emo',14.286,1),(22,7405775,7405770,'mov',14.286,1),(22,7405776,7405770,'ova',14.286,1),(22,7405777,7405770,'vab',14.286,1),(22,7405778,7405770,'abl',14.286,1),(22,7405779,7405770,'ble',14.286,1),(22,7405780,7405773,'ssd',100,1),(22,7405781,7405780,'off',20,1),(22,7405782,7405780,'ffl',20,1),(22,7405783,7405780,'fli',20,1),(22,7405784,7405780,'lin',20,1),(22,7405785,7405780,'ine',20,1),(22,7405786,7405781,'per',11.111,1),(22,7405787,7405781,'ere',11.111,1),(22,7405788,7405781,'ren',11.111,1),(22,7405789,7405781,'enn',11.111,1),(22,7405790,7405781,'nni',11.111,1),(22,7405791,7405781,'nia',11.111,1),(22,7405792,7405781,'ial',11.111,1),(22,7405793,7405781,'all',11.111,1),(22,7405794,7405781,'lly',11.111,1),(22,7405795,7405786,'res',16.667,1),(22,7405796,7405786,'ese',16.667,1),(22,7405797,7405786,'ser',16.667,1),(22,7405798,7405786,'erv',16.667,1),(22,7405799,7405786,'rve',16.667,1),(22,7405800,7405786,'ved',16.667,1),(22,7405801,7405795,'thi',50,1),(22,7405802,7405795,'hin',50,1),(22,7405803,7405801,'pro',10,1),(22,7405804,7405801,'rov',10,1),(22,7405805,7405801,'ovi',10,1),(22,7405806,7405801,'vis',10,1),(22,7405807,7405801,'isi',10,1),(22,7405808,7405801,'sio',10,1),(22,7405809,7405801,'ion',10,1),(22,7405810,7405801,'oni',10,1),(22,7405811,7405801,'nin',10,1),(22,7405812,7405801,'ing',10,1),(22,7405813,7405803,'yes',100,1),(22,7405814,7405813,'att',16.667,1),(22,7405815,7405813,'tta',16.667,1),(22,7405816,7405813,'tac',16.667,1),(22,7405817,7405813,'ach',16.667,1),(22,7405818,7405813,'che',16.667,1),(22,7405819,7405813,'hed',16.667,1),(22,7405820,7405814,'fil',20,1),(22,7405821,7405814,'ilt',20,1),(22,7405822,7405814,'lte',20,1),(22,7405823,7405814,'ter',20,1),(22,7405824,7405814,'ers',20,1),(22,7405825,7405820,'vaa',50,1),(22,7405826,7405820,'aai',50,1),(22,7405827,7405825,'unk',20,1),(22,7405828,7405825,'nkn',20,1),(22,7405829,7405825,'kno',20,1),(22,7405830,7405825,'now',20,1),(22,7405831,7405825,'own',20,1),(22,7405832,7405827,'oth',33.333,1),(22,7405833,7405827,'the',33.333,1),(22,7405834,7405827,'her',33.333,1),(22,7405835,7405832,'uid',50,1),(22,7405836,7405832,'ids',50,1),(22,7405837,7405835,'vml',100,1),(22,7405838,7405837,'dis',20,1),(22,7405839,7405837,'isp',20,1),(22,7405840,7405837,'spl',20,1),(22,7405841,7405837,'pla',20,1),(22,7405842,7405837,'lay',20,1),(22,7405843,7405838,'nam',50,1),(22,7405844,7405838,'ame',50,1),(23,7405846,7405845,'net',25,3),(23,7405847,7405845,'eta',25,3),(23,7405848,7405845,'tap',25,3),(23,7405849,7405845,'app',25,3),(23,7405850,7405846,'fib',33.333,2),(23,7405851,7405846,'ibr',33.333,2),(23,7405852,7405846,'bre',33.333,2),(23,7405853,7405850,'cha',20,2),(23,7405854,7405850,'han',20,2),(23,7405855,7405850,'ann',20,2),(23,7405856,7405850,'nne',20,2),(23,7405857,7405850,'nel',20,2),(23,7405858,7405853,'dis',50,2),(23,7405859,7405853,'isk',50,2),(23,7405860,7405858,'naa',100,4),(23,7405861,7405860,'600',3.333,4),(23,7405862,7405860,'00a',3.333,4),(23,7405863,7405860,'0a0',3.333,4),(23,7405864,7405860,'a09',3.333,4),(23,7405865,7405860,'098',3.333,4),(23,7405866,7405860,'980',3.333,4),(23,7405867,7405860,'804',3.333,4),(23,7405868,7405860,'044',3.333,4),(23,7405869,7405860,'443',3.333,4),(23,7405870,7405860,'430',3.333,4),(23,7405871,7405860,'307',3.333,4),(23,7405872,7405860,'072',3.333,4),(23,7405873,7405860,'725',3.333,4),(23,7405874,7405860,'259',3.333,4),(23,7405875,7405860,'593',3.333,4),(23,7405876,7405860,'931',3.333,4),(23,7405877,7405860,'313',3.333,4),(23,7405878,7405860,'13f',3.333,4),(23,7405879,7405860,'3f3',3.333,4),(23,7405880,7405860,'f33',3.333,4),(23,7405881,7405860,'334',3.333,4),(23,7405882,7405860,'345',3.333,4),(23,7405883,7405860,'455',3.333,4),(23,7405884,7405860,'556',3.333,4),(23,7405885,7405860,'563',3.333,4),(23,7405886,7405860,'639',3.333,4),(23,7405887,7405860,'393',3.333,4),(23,7405888,7405860,'934',3.333,4),(23,7405889,7405860,'346',3.333,4),(23,7405890,7405860,'46f',3.333,4),(23,7405891,7405861,'ser',25,1),(23,7405892,7405861,'eri',25,1),(23,7405893,7405861,'ria',25,1),(23,7405894,7405861,'ial',25,1),(23,7405895,7405891,'siz',50,1),(23,7405896,7405891,'ize',50,1),(23,7405897,7405895,'321',100,1),(23,7405898,7405897,'dev',25,1),(23,7405899,7405897,'evi',25,1),(23,7405900,7405897,'vic',25,1),(23,7405901,7405897,'ice',25,1),(23,7405902,7405898,'typ',50,1),(23,7405903,7405898,'ype',50,1),(23,7405904,7405902,'dir',10,1),(23,7405905,7405902,'ire',10,1),(23,7405906,7405902,'rec',10,1),(23,7405907,7405902,'ect',10,1),(23,7405908,7405902,'cta',10,1),(23,7405909,7405902,'tac',10,1),(23,7405910,7405902,'acc',10,1),(23,7405911,7405902,'cce',10,1),(23,7405912,7405902,'ces',10,1),(23,7405913,7405902,'ess',10,1),(23,7405914,7405904,'mul',14.286,1),(23,7405915,7405904,'ult',14.286,1),(23,7405916,7405904,'lti',14.286,1),(23,7405917,7405904,'tip',14.286,1),(23,7405918,7405904,'ipa',14.286,1),(23,7405919,7405904,'pat',14.286,1),(23,7405920,7405904,'ath',14.286,1),(23,7405921,7405914,'plu',25,1),(23,7405922,7405914,'lug',25,1),(23,7405923,7405914,'ugi',25,1),(23,7405924,7405914,'gin',25,1),(23,7405925,7405921,'nmp',100,1),(23,7405926,7405925,'dev',33.333,1),(23,7405927,7405925,'evf',33.333,1),(23,7405928,7405925,'vfs',33.333,1),(23,7405929,7405926,'pat',50,1),(23,7405930,7405926,'ath',50,1),(23,7405931,7405929,'vmf',50,1),(23,7405932,7405929,'mfs',50,1),(23,7405933,7405931,'dev',20,1),(23,7405934,7405931,'evi',20,1),(23,7405935,7405931,'vic',20,1),(23,7405936,7405931,'ice',20,1),(23,7405937,7405931,'ces',20,1),(23,7405938,7405933,'dis',33.333,1),(23,7405939,7405933,'isk',33.333,1),(23,7405940,7405933,'sks',33.333,1),(23,7405941,7405938,'ven',25,1),(23,7405942,7405938,'end',25,1),(23,7405943,7405938,'ndo',25,1),(23,7405944,7405938,'dor',25,1),(23,7405945,7405941,'mod',33.333,1),(23,7405946,7405941,'ode',33.333,1),(23,7405947,7405941,'del',33.333,1),(23,7405948,7405945,'lun',100,1),(23,7405949,7405948,'cmo',33.333,1),(23,7405950,7405948,'mod',33.333,1),(23,7405951,7405948,'ode',33.333,1),(23,7405952,7405949,'rev',16.667,1),(23,7405953,7405949,'evi',16.667,1),(23,7405954,7405949,'vis',16.667,1),(23,7405955,7405949,'isi',16.667,1),(23,7405956,7405949,'sio',16.667,1),(23,7405957,7405949,'ion',16.667,1),(23,7405958,7405952,'810',50,1),(23,7405959,7405952,'100',50,1),(23,7405960,7405958,'scs',50,1),(23,7405961,7405958,'csi',50,1),(23,7405962,7405960,'lev',33.333,1),(23,7405963,7405960,'eve',33.333,1),(23,7405964,7405960,'vel',33.333,1),(23,7405965,7405962,'pse',25,1),(23,7405966,7405962,'seu',25,1),(23,7405967,7405962,'eud',25,1),(23,7405968,7405962,'udo',25,1),(23,7405969,7405965,'fal',33.333,6),(23,7405970,7405965,'als',33.333,6),(23,7405971,7405965,'lse',33.333,6),(23,7405972,7405969,'sta',25,3),(23,7405973,7405969,'tat',25,3),(23,7405974,7405969,'atu',25,3),(23,7405975,7405969,'tus',25,3),(23,7405976,7405972,'rdm',100,1),(23,7405977,7405976,'cap',20,1),(23,7405978,7405976,'apa',20,1),(23,7405979,7405976,'pab',20,1),(23,7405980,7405976,'abl',20,1),(23,7405981,7405976,'ble',20,1),(23,7405982,7405977,'tru',50,1),(23,7405983,7405977,'rue',50,1),(23,7405984,7405982,'loc',33.333,1),(23,7405985,7405982,'oca',33.333,1),(23,7405986,7405982,'cal',33.333,1),(23,7405987,7405984,'rem',14.286,1),(23,7405988,7405984,'emo',14.286,1),(23,7405989,7405984,'mov',14.286,1),(23,7405990,7405984,'ova',14.286,1),(23,7405991,7405984,'vab',14.286,1),(23,7405992,7405984,'abl',14.286,1),(23,7405993,7405984,'ble',14.286,1),(23,7405994,7405987,'ssd',100,1),(23,7405995,7405994,'off',20,1),(23,7405996,7405994,'ffl',20,1),(23,7405997,7405994,'fli',20,1),(23,7405998,7405994,'lin',20,1),(23,7405999,7405994,'ine',20,1),(23,7406000,7405995,'per',11.111,1),(23,7406001,7405995,'ere',11.111,1),(23,7406002,7405995,'ren',11.111,1),(23,7406003,7405995,'enn',11.111,1),(23,7406004,7405995,'nni',11.111,1),(23,7406005,7405995,'nia',11.111,1),(23,7406006,7405995,'ial',11.111,1),(23,7406007,7405995,'all',11.111,1),(23,7406008,7405995,'lly',11.111,1),(23,7406009,7406000,'res',16.667,1),(23,7406010,7406000,'ese',16.667,1),(23,7406011,7406000,'ser',16.667,1),(23,7406012,7406000,'erv',16.667,1),(23,7406013,7406000,'rve',16.667,1),(23,7406014,7406000,'ved',16.667,1),(23,7406015,7406009,'thi',50,1),(23,7406016,7406009,'hin',50,1),(23,7406017,7406015,'pro',10,1),(23,7406018,7406015,'rov',10,1),(23,7406019,7406015,'ovi',10,1),(23,7406020,7406015,'vis',10,1),(23,7406021,7406015,'isi',10,1),(23,7406022,7406015,'sio',10,1),(23,7406023,7406015,'ion',10,1),(23,7406024,7406015,'oni',10,1),(23,7406025,7406015,'nin',10,1),(23,7406026,7406015,'ing',10,1),(23,7406027,7406017,'yes',100,1),(23,7406028,7406027,'att',16.667,1),(23,7406029,7406027,'tta',16.667,1),(23,7406030,7406027,'tac',16.667,1),(23,7406031,7406027,'ach',16.667,1),(23,7406032,7406027,'che',16.667,1),(23,7406033,7406027,'hed',16.667,1),(23,7406034,7406028,'fil',20,1),(23,7406035,7406028,'ilt',20,1),(23,7406036,7406028,'lte',20,1),(23,7406037,7406028,'ter',20,1),(23,7406038,7406028,'ers',20,1),(23,7406039,7406034,'vaa',50,1),(23,7406040,7406034,'aai',50,1),(23,7406041,7406039,'unk',20,1),(23,7406042,7406039,'nkn',20,1),(23,7406043,7406039,'kno',20,1),(23,7406044,7406039,'now',20,1),(23,7406045,7406039,'own',20,1),(23,7406046,7406041,'oth',33.333,1),(23,7406047,7406041,'the',33.333,1),(23,7406048,7406041,'her',33.333,1),(23,7406049,7406046,'uid',50,1),(23,7406050,7406046,'ids',50,1),(23,7406051,7406049,'vml',100,1),(23,7406052,7406051,'dis',20,1),(23,7406053,7406051,'isp',20,1),(23,7406054,7406051,'spl',20,1),(23,7406055,7406051,'pla',20,1),(23,7406056,7406051,'lay',20,1),(23,7406057,7406052,'nam',50,1),(23,7406058,7406052,'ame',50,1),(24,7406060,7406059,'net',25,3),(24,7406061,7406059,'eta',25,3),(24,7406062,7406059,'tap',25,3),(24,7406063,7406059,'app',25,3),(24,7406064,7406060,'fib',33.333,2),(24,7406065,7406060,'ibr',33.333,2),(24,7406066,7406060,'bre',33.333,2),(24,7406067,7406064,'cha',20,2),(24,7406068,7406064,'han',20,2),(24,7406069,7406064,'ann',20,2),(24,7406070,7406064,'nne',20,2),(24,7406071,7406064,'nel',20,2),(24,7406072,7406067,'dis',50,2),(24,7406073,7406067,'isk',50,2),(24,7406074,7406072,'naa',100,4),(24,7406075,7406074,'600',3.333,4),(24,7406076,7406074,'00a',3.333,4),(24,7406077,7406074,'0a0',3.333,4),(24,7406078,7406074,'a09',3.333,4),(24,7406079,7406074,'098',3.333,4),(24,7406080,7406074,'980',3.333,4),(24,7406081,7406074,'804',3.333,4),(24,7406082,7406074,'044',3.333,4),(24,7406083,7406074,'443',3.333,4),(24,7406084,7406074,'430',3.333,4),(24,7406085,7406074,'307',3.333,4),(24,7406086,7406074,'075',3.333,4),(24,7406087,7406074,'753',3.333,4),(24,7406088,7406074,'535',3.333,4),(24,7406089,7406074,'357',3.333,4),(24,7406090,7406074,'573',3.333,4),(24,7406091,7406074,'732',3.333,4),(24,7406092,7406074,'32b',3.333,4),(24,7406093,7406074,'2b3',3.333,4),(24,7406094,7406074,'b33',3.333,4),(24,7406095,7406074,'334',3.333,4),(24,7406096,7406074,'345',3.333,4),(24,7406097,7406074,'457',3.333,4),(24,7406098,7406074,'571',3.333,4),(24,7406099,7406074,'715',3.333,4),(24,7406100,7406074,'153',3.333,4),(24,7406101,7406074,'533',3.333,4),(24,7406102,7406074,'336',3.333,4),(24,7406103,7406074,'363',3.333,4),(24,7406104,7406074,'630',3.333,4),(24,7406105,7406075,'ser',25,1),(24,7406106,7406075,'eri',25,1),(24,7406107,7406075,'ria',25,1),(24,7406108,7406075,'ial',25,1),(24,7406109,7406105,'siz',50,1),(24,7406110,7406105,'ize',50,1),(24,7406111,7406109,'321',100,1),(24,7406112,7406111,'dev',25,1),(24,7406113,7406111,'evi',25,1),(24,7406114,7406111,'vic',25,1),(24,7406115,7406111,'ice',25,1),(24,7406116,7406112,'typ',50,1),(24,7406117,7406112,'ype',50,1),(24,7406118,7406116,'dir',10,1),(24,7406119,7406116,'ire',10,1),(24,7406120,7406116,'rec',10,1),(24,7406121,7406116,'ect',10,1),(24,7406122,7406116,'cta',10,1),(24,7406123,7406116,'tac',10,1),(24,7406124,7406116,'acc',10,1),(24,7406125,7406116,'cce',10,1),(24,7406126,7406116,'ces',10,1),(24,7406127,7406116,'ess',10,1),(24,7406128,7406118,'mul',14.286,1),(24,7406129,7406118,'ult',14.286,1),(24,7406130,7406118,'lti',14.286,1),(24,7406131,7406118,'tip',14.286,1),(24,7406132,7406118,'ipa',14.286,1),(24,7406133,7406118,'pat',14.286,1),(24,7406134,7406118,'ath',14.286,1),(24,7406135,7406128,'plu',25,1),(24,7406136,7406128,'lug',25,1),(24,7406137,7406128,'ugi',25,1),(24,7406138,7406128,'gin',25,1),(24,7406139,7406135,'nmp',100,1),(24,7406140,7406139,'dev',33.333,1),(24,7406141,7406139,'evf',33.333,1),(24,7406142,7406139,'vfs',33.333,1),(24,7406143,7406140,'pat',50,1),(24,7406144,7406140,'ath',50,1),(24,7406145,7406143,'vmf',50,1),(24,7406146,7406143,'mfs',50,1),(24,7406147,7406145,'dev',20,1),(24,7406148,7406145,'evi',20,1),(24,7406149,7406145,'vic',20,1),(24,7406150,7406145,'ice',20,1),(24,7406151,7406145,'ces',20,1),(24,7406152,7406147,'dis',33.333,1),(24,7406153,7406147,'isk',33.333,1),(24,7406154,7406147,'sks',33.333,1),(24,7406155,7406152,'ven',25,1),(24,7406156,7406152,'end',25,1),(24,7406157,7406152,'ndo',25,1),(24,7406158,7406152,'dor',25,1),(24,7406159,7406155,'mod',33.333,1),(24,7406160,7406155,'ode',33.333,1),(24,7406161,7406155,'del',33.333,1),(24,7406162,7406159,'lun',100,1),(24,7406163,7406162,'cmo',33.333,1),(24,7406164,7406162,'mod',33.333,1),(24,7406165,7406162,'ode',33.333,1),(24,7406166,7406163,'rev',16.667,1),(24,7406167,7406163,'evi',16.667,1),(24,7406168,7406163,'vis',16.667,1),(24,7406169,7406163,'isi',16.667,1),(24,7406170,7406163,'sio',16.667,1),(24,7406171,7406163,'ion',16.667,1),(24,7406172,7406166,'810',50,1),(24,7406173,7406166,'100',50,1),(24,7406174,7406172,'scs',50,1),(24,7406175,7406172,'csi',50,1),(24,7406176,7406174,'lev',33.333,1),(24,7406177,7406174,'eve',33.333,1),(24,7406178,7406174,'vel',33.333,1),(24,7406179,7406176,'pse',25,1),(24,7406180,7406176,'seu',25,1),(24,7406181,7406176,'eud',25,1),(24,7406182,7406176,'udo',25,1),(24,7406183,7406179,'fal',33.333,6),(24,7406184,7406179,'als',33.333,6),(24,7406185,7406179,'lse',33.333,6),(24,7406186,7406183,'sta',25,3),(24,7406187,7406183,'tat',25,3),(24,7406188,7406183,'atu',25,3),(24,7406189,7406183,'tus',25,3),(24,7406190,7406186,'rdm',100,1),(24,7406191,7406190,'cap',20,1),(24,7406192,7406190,'apa',20,1),(24,7406193,7406190,'pab',20,1),(24,7406194,7406190,'abl',20,1),(24,7406195,7406190,'ble',20,1),(24,7406196,7406191,'tru',50,1),(24,7406197,7406191,'rue',50,1),(24,7406198,7406196,'loc',33.333,1),(24,7406199,7406196,'oca',33.333,1),(24,7406200,7406196,'cal',33.333,1),(24,7406201,7406198,'rem',14.286,1),(24,7406202,7406198,'emo',14.286,1),(24,7406203,7406198,'mov',14.286,1),(24,7406204,7406198,'ova',14.286,1),(24,7406205,7406198,'vab',14.286,1),(24,7406206,7406198,'abl',14.286,1),(24,7406207,7406198,'ble',14.286,1),(24,7406208,7406201,'ssd',100,1),(24,7406209,7406208,'off',20,1),(24,7406210,7406208,'ffl',20,1),(24,7406211,7406208,'fli',20,1),(24,7406212,7406208,'lin',20,1),(24,7406213,7406208,'ine',20,1),(24,7406214,7406209,'per',11.111,1),(24,7406215,7406209,'ere',11.111,1),(24,7406216,7406209,'ren',11.111,1),(24,7406217,7406209,'enn',11.111,1),(24,7406218,7406209,'nni',11.111,1),(24,7406219,7406209,'nia',11.111,1),(24,7406220,7406209,'ial',11.111,1),(24,7406221,7406209,'all',11.111,1),(24,7406222,7406209,'lly',11.111,1),(24,7406223,7406214,'res',16.667,1),(24,7406224,7406214,'ese',16.667,1),(24,7406225,7406214,'ser',16.667,1),(24,7406226,7406214,'erv',16.667,1),(24,7406227,7406214,'rve',16.667,1),(24,7406228,7406214,'ved',16.667,1),(24,7406229,7406223,'thi',50,1),(24,7406230,7406223,'hin',50,1),(24,7406231,7406229,'pro',10,1),(24,7406232,7406229,'rov',10,1),(24,7406233,7406229,'ovi',10,1),(24,7406234,7406229,'vis',10,1),(24,7406235,7406229,'isi',10,1),(24,7406236,7406229,'sio',10,1),(24,7406237,7406229,'ion',10,1),(24,7406238,7406229,'oni',10,1),(24,7406239,7406229,'nin',10,1),(24,7406240,7406229,'ing',10,1),(24,7406241,7406231,'yes',100,1),(24,7406242,7406241,'att',16.667,1),(24,7406243,7406241,'tta',16.667,1),(24,7406244,7406241,'tac',16.667,1),(24,7406245,7406241,'ach',16.667,1),(24,7406246,7406241,'che',16.667,1),(24,7406247,7406241,'hed',16.667,1),(24,7406248,7406242,'fil',20,1),(24,7406249,7406242,'ilt',20,1),(24,7406250,7406242,'lte',20,1),(24,7406251,7406242,'ter',20,1),(24,7406252,7406242,'ers',20,1),(24,7406253,7406248,'vaa',50,1),(24,7406254,7406248,'aai',50,1),(24,7406255,7406253,'unk',20,1),(24,7406256,7406253,'nkn',20,1),(24,7406257,7406253,'kno',20,1),(24,7406258,7406253,'now',20,1),(24,7406259,7406253,'own',20,1),(24,7406260,7406255,'oth',33.333,1),(24,7406261,7406255,'the',33.333,1),(24,7406262,7406255,'her',33.333,1),(24,7406263,7406260,'uid',50,1),(24,7406264,7406260,'ids',50,1),(24,7406265,7406263,'vml',100,1),(24,7406266,7406265,'dis',20,1),(24,7406267,7406265,'isp',20,1),(24,7406268,7406265,'spl',20,1),(24,7406269,7406265,'pla',20,1),(24,7406270,7406265,'lay',20,1),(24,7406271,7406266,'nam',50,1),(24,7406272,7406266,'ame',50,1),(25,7406274,7406273,'net',25,3),(25,7406275,7406273,'eta',25,3),(25,7406276,7406273,'tap',25,3),(25,7406277,7406273,'app',25,3),(25,7406278,7406274,'fib',33.333,2),(25,7406279,7406274,'ibr',33.333,2),(25,7406280,7406274,'bre',33.333,2),(25,7406281,7406278,'cha',20,2),(25,7406282,7406278,'han',20,2),(25,7406283,7406278,'ann',20,2),(25,7406284,7406278,'nne',20,2),(25,7406285,7406278,'nel',20,2),(25,7406286,7406281,'dis',50,2),(25,7406287,7406281,'isk',50,2),(25,7406288,7406286,'naa',100,4),(25,7406289,7406288,'600',3.333,4),(25,7406290,7406288,'00a',3.333,4),(25,7406291,7406288,'0a0',3.333,4),(25,7406292,7406288,'a09',3.333,4),(25,7406293,7406288,'098',3.333,4),(25,7406294,7406288,'980',3.333,4),(25,7406295,7406288,'804',3.333,4),(25,7406296,7406288,'044',3.333,4),(25,7406297,7406288,'443',3.333,4),(25,7406298,7406288,'430',3.333,4),(25,7406299,7406288,'307',3.333,4),(25,7406300,7406288,'075',3.333,4),(25,7406301,7406288,'753',3.333,4),(25,7406302,7406288,'535',3.333,4),(25,7406303,7406288,'357',3.333,4),(25,7406304,7406288,'573',3.333,4),(25,7406305,7406288,'732',3.333,4),(25,7406306,7406288,'32b',3.333,4),(25,7406307,7406288,'2b3',3.333,4),(25,7406308,7406288,'b33',3.333,4),(25,7406309,7406288,'334',3.333,4),(25,7406310,7406288,'345',3.333,4),(25,7406311,7406288,'457',3.333,4),(25,7406312,7406288,'571',3.333,4),(25,7406313,7406288,'715',3.333,4),(25,7406314,7406288,'153',3.333,4),(25,7406315,7406288,'533',3.333,4),(25,7406316,7406288,'336',3.333,4),(25,7406317,7406288,'363',3.333,4),(25,7406318,7406288,'631',3.333,4),(25,7406319,7406289,'ser',25,1),(25,7406320,7406289,'eri',25,1),(25,7406321,7406289,'ria',25,1),(25,7406322,7406289,'ial',25,1),(25,7406323,7406319,'siz',50,1),(25,7406324,7406319,'ize',50,1),(25,7406325,7406323,'321',100,1),(25,7406326,7406325,'dev',25,1),(25,7406327,7406325,'evi',25,1),(25,7406328,7406325,'vic',25,1),(25,7406329,7406325,'ice',25,1),(25,7406330,7406326,'typ',50,1),(25,7406331,7406326,'ype',50,1),(25,7406332,7406330,'dir',10,1),(25,7406333,7406330,'ire',10,1),(25,7406334,7406330,'rec',10,1),(25,7406335,7406330,'ect',10,1),(25,7406336,7406330,'cta',10,1),(25,7406337,7406330,'tac',10,1),(25,7406338,7406330,'acc',10,1),(25,7406339,7406330,'cce',10,1),(25,7406340,7406330,'ces',10,1),(25,7406341,7406330,'ess',10,1),(25,7406342,7406332,'mul',14.286,1),(25,7406343,7406332,'ult',14.286,1),(25,7406344,7406332,'lti',14.286,1),(25,7406345,7406332,'tip',14.286,1),(25,7406346,7406332,'ipa',14.286,1),(25,7406347,7406332,'pat',14.286,1),(25,7406348,7406332,'ath',14.286,1),(25,7406349,7406342,'plu',25,1),(25,7406350,7406342,'lug',25,1),(25,7406351,7406342,'ugi',25,1),(25,7406352,7406342,'gin',25,1),(25,7406353,7406349,'nmp',100,1),(25,7406354,7406353,'dev',33.333,1),(25,7406355,7406353,'evf',33.333,1),(25,7406356,7406353,'vfs',33.333,1),(25,7406357,7406354,'pat',50,1),(25,7406358,7406354,'ath',50,1),(25,7406359,7406357,'vmf',50,1),(25,7406360,7406357,'mfs',50,1),(25,7406361,7406359,'dev',20,1),(25,7406362,7406359,'evi',20,1),(25,7406363,7406359,'vic',20,1),(25,7406364,7406359,'ice',20,1),(25,7406365,7406359,'ces',20,1),(25,7406366,7406361,'dis',33.333,1),(25,7406367,7406361,'isk',33.333,1),(25,7406368,7406361,'sks',33.333,1),(25,7406369,7406366,'ven',25,1),(25,7406370,7406366,'end',25,1),(25,7406371,7406366,'ndo',25,1),(25,7406372,7406366,'dor',25,1),(25,7406373,7406369,'mod',33.333,1),(25,7406374,7406369,'ode',33.333,1),(25,7406375,7406369,'del',33.333,1),(25,7406376,7406373,'lun',100,1),(25,7406377,7406376,'cmo',33.333,1),(25,7406378,7406376,'mod',33.333,1),(25,7406379,7406376,'ode',33.333,1),(25,7406380,7406377,'rev',16.667,1),(25,7406381,7406377,'evi',16.667,1),(25,7406382,7406377,'vis',16.667,1),(25,7406383,7406377,'isi',16.667,1),(25,7406384,7406377,'sio',16.667,1),(25,7406385,7406377,'ion',16.667,1),(25,7406386,7406380,'810',50,1),(25,7406387,7406380,'100',50,1),(25,7406388,7406386,'scs',50,1),(25,7406389,7406386,'csi',50,1),(25,7406390,7406388,'lev',33.333,1),(25,7406391,7406388,'eve',33.333,1),(25,7406392,7406388,'vel',33.333,1),(25,7406393,7406390,'pse',25,1),(25,7406394,7406390,'seu',25,1),(25,7406395,7406390,'eud',25,1),(25,7406396,7406390,'udo',25,1),(25,7406397,7406393,'fal',33.333,6),(25,7406398,7406393,'als',33.333,6),(25,7406399,7406393,'lse',33.333,6),(25,7406400,7406397,'sta',25,3),(25,7406401,7406397,'tat',25,3),(25,7406402,7406397,'atu',25,3),(25,7406403,7406397,'tus',25,3),(25,7406404,7406400,'rdm',100,1),(25,7406405,7406404,'cap',20,1),(25,7406406,7406404,'apa',20,1),(25,7406407,7406404,'pab',20,1),(25,7406408,7406404,'abl',20,1),(25,7406409,7406404,'ble',20,1),(25,7406410,7406405,'tru',50,1),(25,7406411,7406405,'rue',50,1),(25,7406412,7406410,'loc',33.333,1),(25,7406413,7406410,'oca',33.333,1),(25,7406414,7406410,'cal',33.333,1),(25,7406415,7406412,'rem',14.286,1),(25,7406416,7406412,'emo',14.286,1),(25,7406417,7406412,'mov',14.286,1),(25,7406418,7406412,'ova',14.286,1),(25,7406419,7406412,'vab',14.286,1),(25,7406420,7406412,'abl',14.286,1),(25,7406421,7406412,'ble',14.286,1),(25,7406422,7406415,'ssd',100,1),(25,7406423,7406422,'off',20,1),(25,7406424,7406422,'ffl',20,1),(25,7406425,7406422,'fli',20,1),(25,7406426,7406422,'lin',20,1),(25,7406427,7406422,'ine',20,1),(25,7406428,7406423,'per',11.111,1),(25,7406429,7406423,'ere',11.111,1),(25,7406430,7406423,'ren',11.111,1),(25,7406431,7406423,'enn',11.111,1),(25,7406432,7406423,'nni',11.111,1),(25,7406433,7406423,'nia',11.111,1),(25,7406434,7406423,'ial',11.111,1),(25,7406435,7406423,'all',11.111,1),(25,7406436,7406423,'lly',11.111,1),(25,7406437,7406428,'res',16.667,1),(25,7406438,7406428,'ese',16.667,1),(25,7406439,7406428,'ser',16.667,1),(25,7406440,7406428,'erv',16.667,1),(25,7406441,7406428,'rve',16.667,1),(25,7406442,7406428,'ved',16.667,1),(25,7406443,7406437,'thi',50,1),(25,7406444,7406437,'hin',50,1),(25,7406445,7406443,'pro',10,1),(25,7406446,7406443,'rov',10,1),(25,7406447,7406443,'ovi',10,1),(25,7406448,7406443,'vis',10,1),(25,7406449,7406443,'isi',10,1),(25,7406450,7406443,'sio',10,1),(25,7406451,7406443,'ion',10,1),(25,7406452,7406443,'oni',10,1),(25,7406453,7406443,'nin',10,1),(25,7406454,7406443,'ing',10,1),(25,7406455,7406445,'yes',100,1),(25,7406456,7406455,'att',16.667,1),(25,7406457,7406455,'tta',16.667,1),(25,7406458,7406455,'tac',16.667,1),(25,7406459,7406455,'ach',16.667,1),(25,7406460,7406455,'che',16.667,1),(25,7406461,7406455,'hed',16.667,1),(25,7406462,7406456,'fil',20,1),(25,7406463,7406456,'ilt',20,1),(25,7406464,7406456,'lte',20,1),(25,7406465,7406456,'ter',20,1),(25,7406466,7406456,'ers',20,1),(25,7406467,7406462,'vaa',50,1),(25,7406468,7406462,'aai',50,1),(25,7406469,7406467,'unk',20,1),(25,7406470,7406467,'nkn',20,1),(25,7406471,7406467,'kno',20,1),(25,7406472,7406467,'now',20,1),(25,7406473,7406467,'own',20,1),(25,7406474,7406469,'oth',33.333,1),(25,7406475,7406469,'the',33.333,1),(25,7406476,7406469,'her',33.333,1),(25,7406477,7406474,'uid',50,1),(25,7406478,7406474,'ids',50,1),(25,7406479,7406477,'vml',100,1),(25,7406480,7406479,'dis',20,1),(25,7406481,7406479,'isp',20,1),(25,7406482,7406479,'spl',20,1),(25,7406483,7406479,'pla',20,1),(25,7406484,7406479,'lay',20,1),(25,7406485,7406480,'nam',50,1),(25,7406486,7406480,'ame',50,1),(26,7406488,7406487,'net',25,3),(26,7406489,7406487,'eta',25,3),(26,7406490,7406487,'tap',25,3),(26,7406491,7406487,'app',25,3),(26,7406492,7406488,'fib',33.333,2),(26,7406493,7406488,'ibr',33.333,2),(26,7406494,7406488,'bre',33.333,2),(26,7406495,7406492,'cha',20,2),(26,7406496,7406492,'han',20,2),(26,7406497,7406492,'ann',20,2),(26,7406498,7406492,'nne',20,2),(26,7406499,7406492,'nel',20,2),(26,7406500,7406495,'dis',50,2),(26,7406501,7406495,'isk',50,2),(26,7406502,7406500,'naa',100,4),(26,7406503,7406502,'600',3.333,4),(26,7406504,7406502,'00a',3.333,4),(26,7406505,7406502,'0a0',3.333,4),(26,7406506,7406502,'a09',3.333,4),(26,7406507,7406502,'098',3.333,4),(26,7406508,7406502,'980',3.333,4),(26,7406509,7406502,'804',3.333,4),(26,7406510,7406502,'044',3.333,4),(26,7406511,7406502,'443',3.333,4),(26,7406512,7406502,'430',3.333,4),(26,7406513,7406502,'307',3.333,4),(26,7406514,7406502,'075',3.333,4),(26,7406515,7406502,'753',3.333,4),(26,7406516,7406502,'535',3.333,4),(26,7406517,7406502,'357',3.333,4),(26,7406518,7406502,'573',3.333,4),(26,7406519,7406502,'732',3.333,4),(26,7406520,7406502,'32b',3.333,4),(26,7406521,7406502,'2b3',3.333,4),(26,7406522,7406502,'b33',3.333,4),(26,7406523,7406502,'334',3.333,4),(26,7406524,7406502,'345',3.333,4),(26,7406525,7406502,'457',3.333,4),(26,7406526,7406502,'571',3.333,4),(26,7406527,7406502,'715',3.333,4),(26,7406528,7406502,'153',3.333,4),(26,7406529,7406502,'533',3.333,4),(26,7406530,7406502,'336',3.333,4),(26,7406531,7406502,'363',3.333,4),(26,7406532,7406502,'632',3.333,4),(26,7406533,7406503,'ser',25,1),(26,7406534,7406503,'eri',25,1),(26,7406535,7406503,'ria',25,1),(26,7406536,7406503,'ial',25,1),(26,7406537,7406533,'siz',50,1),(26,7406538,7406533,'ize',50,1),(26,7406539,7406537,'321',100,1),(26,7406540,7406539,'dev',25,1),(26,7406541,7406539,'evi',25,1),(26,7406542,7406539,'vic',25,1),(26,7406543,7406539,'ice',25,1),(26,7406544,7406540,'typ',50,1),(26,7406545,7406540,'ype',50,1),(26,7406546,7406544,'dir',10,1),(26,7406547,7406544,'ire',10,1),(26,7406548,7406544,'rec',10,1),(26,7406549,7406544,'ect',10,1),(26,7406550,7406544,'cta',10,1),(26,7406551,7406544,'tac',10,1),(26,7406552,7406544,'acc',10,1),(26,7406553,7406544,'cce',10,1),(26,7406554,7406544,'ces',10,1),(26,7406555,7406544,'ess',10,1),(26,7406556,7406546,'mul',14.286,1),(26,7406557,7406546,'ult',14.286,1),(26,7406558,7406546,'lti',14.286,1),(26,7406559,7406546,'tip',14.286,1),(26,7406560,7406546,'ipa',14.286,1),(26,7406561,7406546,'pat',14.286,1),(26,7406562,7406546,'ath',14.286,1),(26,7406563,7406556,'plu',25,1),(26,7406564,7406556,'lug',25,1),(26,7406565,7406556,'ugi',25,1),(26,7406566,7406556,'gin',25,1),(26,7406567,7406563,'nmp',100,1),(26,7406568,7406567,'dev',33.333,1),(26,7406569,7406567,'evf',33.333,1),(26,7406570,7406567,'vfs',33.333,1),(26,7406571,7406568,'pat',50,1),(26,7406572,7406568,'ath',50,1),(26,7406573,7406571,'vmf',50,1),(26,7406574,7406571,'mfs',50,1),(26,7406575,7406573,'dev',20,1),(26,7406576,7406573,'evi',20,1),(26,7406577,7406573,'vic',20,1),(26,7406578,7406573,'ice',20,1),(26,7406579,7406573,'ces',20,1),(26,7406580,7406575,'dis',33.333,1),(26,7406581,7406575,'isk',33.333,1),(26,7406582,7406575,'sks',33.333,1),(26,7406583,7406580,'ven',25,1),(26,7406584,7406580,'end',25,1),(26,7406585,7406580,'ndo',25,1),(26,7406586,7406580,'dor',25,1),(26,7406587,7406583,'mod',33.333,1),(26,7406588,7406583,'ode',33.333,1),(26,7406589,7406583,'del',33.333,1),(26,7406590,7406587,'lun',100,1),(26,7406591,7406590,'cmo',33.333,1),(26,7406592,7406590,'mod',33.333,1),(26,7406593,7406590,'ode',33.333,1),(26,7406594,7406591,'rev',16.667,1),(26,7406595,7406591,'evi',16.667,1),(26,7406596,7406591,'vis',16.667,1),(26,7406597,7406591,'isi',16.667,1),(26,7406598,7406591,'sio',16.667,1),(26,7406599,7406591,'ion',16.667,1),(26,7406600,7406594,'810',50,1),(26,7406601,7406594,'100',50,1),(26,7406602,7406600,'scs',50,1),(26,7406603,7406600,'csi',50,1),(26,7406604,7406602,'lev',33.333,1),(26,7406605,7406602,'eve',33.333,1),(26,7406606,7406602,'vel',33.333,1),(26,7406607,7406604,'pse',25,1),(26,7406608,7406604,'seu',25,1),(26,7406609,7406604,'eud',25,1),(26,7406610,7406604,'udo',25,1),(26,7406611,7406607,'fal',33.333,6),(26,7406612,7406607,'als',33.333,6),(26,7406613,7406607,'lse',33.333,6),(26,7406614,7406611,'sta',25,3),(26,7406615,7406611,'tat',25,3),(26,7406616,7406611,'atu',25,3),(26,7406617,7406611,'tus',25,3),(26,7406618,7406614,'rdm',100,1),(26,7406619,7406618,'cap',20,1),(26,7406620,7406618,'apa',20,1),(26,7406621,7406618,'pab',20,1),(26,7406622,7406618,'abl',20,1),(26,7406623,7406618,'ble',20,1),(26,7406624,7406619,'tru',50,1),(26,7406625,7406619,'rue',50,1),(26,7406626,7406624,'loc',33.333,1),(26,7406627,7406624,'oca',33.333,1),(26,7406628,7406624,'cal',33.333,1),(26,7406629,7406626,'rem',14.286,1),(26,7406630,7406626,'emo',14.286,1),(26,7406631,7406626,'mov',14.286,1),(26,7406632,7406626,'ova',14.286,1),(26,7406633,7406626,'vab',14.286,1),(26,7406634,7406626,'abl',14.286,1),(26,7406635,7406626,'ble',14.286,1),(26,7406636,7406629,'ssd',100,1),(26,7406637,7406636,'off',20,1),(26,7406638,7406636,'ffl',20,1),(26,7406639,7406636,'fli',20,1),(26,7406640,7406636,'lin',20,1),(26,7406641,7406636,'ine',20,1),(26,7406642,7406637,'per',11.111,1),(26,7406643,7406637,'ere',11.111,1),(26,7406644,7406637,'ren',11.111,1),(26,7406645,7406637,'enn',11.111,1),(26,7406646,7406637,'nni',11.111,1),(26,7406647,7406637,'nia',11.111,1),(26,7406648,7406637,'ial',11.111,1),(26,7406649,7406637,'all',11.111,1),(26,7406650,7406637,'lly',11.111,1),(26,7406651,7406642,'res',16.667,1),(26,7406652,7406642,'ese',16.667,1),(26,7406653,7406642,'ser',16.667,1),(26,7406654,7406642,'erv',16.667,1),(26,7406655,7406642,'rve',16.667,1),(26,7406656,7406642,'ved',16.667,1),(26,7406657,7406651,'thi',50,1),(26,7406658,7406651,'hin',50,1),(26,7406659,7406657,'pro',10,1),(26,7406660,7406657,'rov',10,1),(26,7406661,7406657,'ovi',10,1),(26,7406662,7406657,'vis',10,1),(26,7406663,7406657,'isi',10,1),(26,7406664,7406657,'sio',10,1),(26,7406665,7406657,'ion',10,1),(26,7406666,7406657,'oni',10,1),(26,7406667,7406657,'nin',10,1),(26,7406668,7406657,'ing',10,1),(26,7406669,7406659,'yes',100,1),(26,7406670,7406669,'att',16.667,1),(26,7406671,7406669,'tta',16.667,1),(26,7406672,7406669,'tac',16.667,1),(26,7406673,7406669,'ach',16.667,1),(26,7406674,7406669,'che',16.667,1),(26,7406675,7406669,'hed',16.667,1),(26,7406676,7406670,'fil',20,1),(26,7406677,7406670,'ilt',20,1),(26,7406678,7406670,'lte',20,1),(26,7406679,7406670,'ter',20,1),(26,7406680,7406670,'ers',20,1),(26,7406681,7406676,'vaa',50,1),(26,7406682,7406676,'aai',50,1),(26,7406683,7406681,'unk',20,1),(26,7406684,7406681,'nkn',20,1),(26,7406685,7406681,'kno',20,1),(26,7406686,7406681,'now',20,1),(26,7406687,7406681,'own',20,1),(26,7406688,7406683,'oth',33.333,1),(26,7406689,7406683,'the',33.333,1),(26,7406690,7406683,'her',33.333,1),(26,7406691,7406688,'uid',50,1),(26,7406692,7406688,'ids',50,1),(26,7406693,7406691,'vml',100,1),(26,7406694,7406693,'dis',20,1),(26,7406695,7406693,'isp',20,1),(26,7406696,7406693,'spl',20,1),(26,7406697,7406693,'pla',20,1),(26,7406698,7406693,'lay',20,1),(26,7406699,7406694,'nam',50,1),(26,7406700,7406694,'ame',50,1),(27,7406702,7406701,'net',25,3),(27,7406703,7406701,'eta',25,3),(27,7406704,7406701,'tap',25,3),(27,7406705,7406701,'app',25,3),(27,7406706,7406702,'fib',33.333,2),(27,7406707,7406702,'ibr',33.333,2),(27,7406708,7406702,'bre',33.333,2),(27,7406709,7406706,'cha',20,2),(27,7406710,7406706,'han',20,2),(27,7406711,7406706,'ann',20,2),(27,7406712,7406706,'nne',20,2),(27,7406713,7406706,'nel',20,2),(27,7406714,7406709,'dis',50,2),(27,7406715,7406709,'isk',50,2),(27,7406716,7406714,'naa',100,4),(27,7406717,7406716,'600',3.333,4),(27,7406718,7406716,'00a',3.333,4),(27,7406719,7406716,'0a0',3.333,4),(27,7406720,7406716,'a09',3.333,4),(27,7406721,7406716,'098',3.333,4),(27,7406722,7406716,'980',3.333,4),(27,7406723,7406716,'804',3.333,4),(27,7406724,7406716,'044',3.333,4),(27,7406725,7406716,'443',3.333,4),(27,7406726,7406716,'430',3.333,4),(27,7406727,7406716,'307',3.333,4),(27,7406728,7406716,'075',3.333,4),(27,7406729,7406716,'753',3.333,4),(27,7406730,7406716,'535',3.333,4),(27,7406731,7406716,'357',3.333,4),(27,7406732,7406716,'573',3.333,4),(27,7406733,7406716,'732',3.333,4),(27,7406734,7406716,'32b',3.333,4),(27,7406735,7406716,'2b3',3.333,4),(27,7406736,7406716,'b33',3.333,4),(27,7406737,7406716,'334',3.333,4),(27,7406738,7406716,'345',3.333,4),(27,7406739,7406716,'457',3.333,4),(27,7406740,7406716,'571',3.333,4),(27,7406741,7406716,'715',3.333,4),(27,7406742,7406716,'153',3.333,4),(27,7406743,7406716,'533',3.333,4),(27,7406744,7406716,'336',3.333,4),(27,7406745,7406716,'363',3.333,4),(27,7406746,7406716,'633',3.333,4),(27,7406747,7406717,'ser',25,1),(27,7406748,7406717,'eri',25,1),(27,7406749,7406717,'ria',25,1),(27,7406750,7406717,'ial',25,1),(27,7406751,7406747,'siz',50,1),(27,7406752,7406747,'ize',50,1),(27,7406753,7406751,'321',100,1),(27,7406754,7406753,'dev',25,1),(27,7406755,7406753,'evi',25,1),(27,7406756,7406753,'vic',25,1),(27,7406757,7406753,'ice',25,1),(27,7406758,7406754,'typ',50,1),(27,7406759,7406754,'ype',50,1),(27,7406760,7406758,'dir',10,1),(27,7406761,7406758,'ire',10,1),(27,7406762,7406758,'rec',10,1),(27,7406763,7406758,'ect',10,1),(27,7406764,7406758,'cta',10,1),(27,7406765,7406758,'tac',10,1),(27,7406766,7406758,'acc',10,1),(27,7406767,7406758,'cce',10,1),(27,7406768,7406758,'ces',10,1),(27,7406769,7406758,'ess',10,1),(27,7406770,7406760,'mul',14.286,1),(27,7406771,7406760,'ult',14.286,1),(27,7406772,7406760,'lti',14.286,1),(27,7406773,7406760,'tip',14.286,1),(27,7406774,7406760,'ipa',14.286,1),(27,7406775,7406760,'pat',14.286,1),(27,7406776,7406760,'ath',14.286,1),(27,7406777,7406770,'plu',25,1),(27,7406778,7406770,'lug',25,1),(27,7406779,7406770,'ugi',25,1),(27,7406780,7406770,'gin',25,1),(27,7406781,7406777,'nmp',100,1),(27,7406782,7406781,'dev',33.333,1),(27,7406783,7406781,'evf',33.333,1),(27,7406784,7406781,'vfs',33.333,1),(27,7406785,7406782,'pat',50,1),(27,7406786,7406782,'ath',50,1),(27,7406787,7406785,'vmf',50,1),(27,7406788,7406785,'mfs',50,1),(27,7406789,7406787,'dev',20,1),(27,7406790,7406787,'evi',20,1),(27,7406791,7406787,'vic',20,1),(27,7406792,7406787,'ice',20,1),(27,7406793,7406787,'ces',20,1),(27,7406794,7406789,'dis',33.333,1),(27,7406795,7406789,'isk',33.333,1),(27,7406796,7406789,'sks',33.333,1),(27,7406797,7406794,'ven',25,1),(27,7406798,7406794,'end',25,1),(27,7406799,7406794,'ndo',25,1),(27,7406800,7406794,'dor',25,1),(27,7406801,7406797,'mod',33.333,1),(27,7406802,7406797,'ode',33.333,1),(27,7406803,7406797,'del',33.333,1),(27,7406804,7406801,'lun',100,1),(27,7406805,7406804,'cmo',33.333,1),(27,7406806,7406804,'mod',33.333,1),(27,7406807,7406804,'ode',33.333,1),(27,7406808,7406805,'rev',16.667,1),(27,7406809,7406805,'evi',16.667,1),(27,7406810,7406805,'vis',16.667,1),(27,7406811,7406805,'isi',16.667,1),(27,7406812,7406805,'sio',16.667,1),(27,7406813,7406805,'ion',16.667,1),(27,7406814,7406808,'810',50,1),(27,7406815,7406808,'100',50,1),(27,7406816,7406814,'scs',50,1),(27,7406817,7406814,'csi',50,1),(27,7406818,7406816,'lev',33.333,1),(27,7406819,7406816,'eve',33.333,1),(27,7406820,7406816,'vel',33.333,1),(27,7406821,7406818,'pse',25,1),(27,7406822,7406818,'seu',25,1),(27,7406823,7406818,'eud',25,1),(27,7406824,7406818,'udo',25,1),(27,7406825,7406821,'fal',33.333,6),(27,7406826,7406821,'als',33.333,6),(27,7406827,7406821,'lse',33.333,6),(27,7406828,7406825,'sta',25,3),(27,7406829,7406825,'tat',25,3),(27,7406830,7406825,'atu',25,3),(27,7406831,7406825,'tus',25,3),(27,7406832,7406828,'rdm',100,1),(27,7406833,7406832,'cap',20,1),(27,7406834,7406832,'apa',20,1),(27,7406835,7406832,'pab',20,1),(27,7406836,7406832,'abl',20,1),(27,7406837,7406832,'ble',20,1),(27,7406838,7406833,'tru',50,1),(27,7406839,7406833,'rue',50,1),(27,7406840,7406838,'loc',33.333,1),(27,7406841,7406838,'oca',33.333,1),(27,7406842,7406838,'cal',33.333,1),(27,7406843,7406840,'rem',14.286,1),(27,7406844,7406840,'emo',14.286,1),(27,7406845,7406840,'mov',14.286,1),(27,7406846,7406840,'ova',14.286,1),(27,7406847,7406840,'vab',14.286,1),(27,7406848,7406840,'abl',14.286,1),(27,7406849,7406840,'ble',14.286,1),(27,7406850,7406843,'ssd',100,1),(27,7406851,7406850,'off',20,1),(27,7406852,7406850,'ffl',20,1),(27,7406853,7406850,'fli',20,1),(27,7406854,7406850,'lin',20,1),(27,7406855,7406850,'ine',20,1),(27,7406856,7406851,'per',11.111,1),(27,7406857,7406851,'ere',11.111,1),(27,7406858,7406851,'ren',11.111,1),(27,7406859,7406851,'enn',11.111,1),(27,7406860,7406851,'nni',11.111,1),(27,7406861,7406851,'nia',11.111,1),(27,7406862,7406851,'ial',11.111,1),(27,7406863,7406851,'all',11.111,1),(27,7406864,7406851,'lly',11.111,1),(27,7406865,7406856,'res',16.667,1),(27,7406866,7406856,'ese',16.667,1),(27,7406867,7406856,'ser',16.667,1),(27,7406868,7406856,'erv',16.667,1),(27,7406869,7406856,'rve',16.667,1),(27,7406870,7406856,'ved',16.667,1),(27,7406871,7406865,'thi',50,1),(27,7406872,7406865,'hin',50,1),(27,7406873,7406871,'pro',10,1),(27,7406874,7406871,'rov',10,1),(27,7406875,7406871,'ovi',10,1),(27,7406876,7406871,'vis',10,1),(27,7406877,7406871,'isi',10,1),(27,7406878,7406871,'sio',10,1),(27,7406879,7406871,'ion',10,1),(27,7406880,7406871,'oni',10,1),(27,7406881,7406871,'nin',10,1),(27,7406882,7406871,'ing',10,1),(27,7406883,7406873,'yes',100,1),(27,7406884,7406883,'att',16.667,1),(27,7406885,7406883,'tta',16.667,1),(27,7406886,7406883,'tac',16.667,1),(27,7406887,7406883,'ach',16.667,1),(27,7406888,7406883,'che',16.667,1),(27,7406889,7406883,'hed',16.667,1),(27,7406890,7406884,'fil',20,1),(27,7406891,7406884,'ilt',20,1),(27,7406892,7406884,'lte',20,1),(27,7406893,7406884,'ter',20,1),(27,7406894,7406884,'ers',20,1),(27,7406895,7406890,'vaa',50,1),(27,7406896,7406890,'aai',50,1),(27,7406897,7406895,'unk',20,1),(27,7406898,7406895,'nkn',20,1),(27,7406899,7406895,'kno',20,1),(27,7406900,7406895,'now',20,1),(27,7406901,7406895,'own',20,1),(27,7406902,7406897,'oth',33.333,1),(27,7406903,7406897,'the',33.333,1),(27,7406904,7406897,'her',33.333,1),(27,7406905,7406902,'uid',50,1),(27,7406906,7406902,'ids',50,1),(27,7406907,7406905,'vml',100,1),(27,7406908,7406907,'dis',20,1),(27,7406909,7406907,'isp',20,1),(27,7406910,7406907,'spl',20,1),(27,7406911,7406907,'pla',20,1),(27,7406912,7406907,'lay',20,1),(27,7406913,7406908,'nam',50,1),(27,7406914,7406908,'ame',50,1),(28,7406916,7406915,'net',25,3),(28,7406917,7406915,'eta',25,3),(28,7406918,7406915,'tap',25,3),(28,7406919,7406915,'app',25,3),(28,7406920,7406916,'fib',33.333,2),(28,7406921,7406916,'ibr',33.333,2),(28,7406922,7406916,'bre',33.333,2),(28,7406923,7406920,'cha',20,2),(28,7406924,7406920,'han',20,2),(28,7406925,7406920,'ann',20,2),(28,7406926,7406920,'nne',20,2),(28,7406927,7406920,'nel',20,2),(28,7406928,7406923,'dis',50,2),(28,7406929,7406923,'isk',50,2),(28,7406930,7406928,'naa',100,4),(28,7406931,7406930,'600',3.333,4),(28,7406932,7406930,'00a',3.333,4),(28,7406933,7406930,'0a0',3.333,4),(28,7406934,7406930,'a09',3.333,4),(28,7406935,7406930,'098',3.333,4),(28,7406936,7406930,'980',3.333,4),(28,7406937,7406930,'804',3.333,4),(28,7406938,7406930,'044',3.333,4),(28,7406939,7406930,'443',3.333,4),(28,7406940,7406930,'430',3.333,4),(28,7406941,7406930,'307',3.333,4),(28,7406942,7406930,'075',3.333,4),(28,7406943,7406930,'753',3.333,4),(28,7406944,7406930,'535',3.333,4),(28,7406945,7406930,'357',3.333,4),(28,7406946,7406930,'573',3.333,4),(28,7406947,7406930,'732',3.333,4),(28,7406948,7406930,'32b',3.333,4),(28,7406949,7406930,'2b3',3.333,4),(28,7406950,7406930,'b33',3.333,4),(28,7406951,7406930,'334',3.333,4),(28,7406952,7406930,'345',3.333,4),(28,7406953,7406930,'457',3.333,4),(28,7406954,7406930,'571',3.333,4),(28,7406955,7406930,'715',3.333,4),(28,7406956,7406930,'153',3.333,4),(28,7406957,7406930,'533',3.333,4),(28,7406958,7406930,'336',3.333,4),(28,7406959,7406930,'363',3.333,4),(28,7406960,7406930,'634',3.333,4),(28,7406961,7406931,'ser',25,1),(28,7406962,7406931,'eri',25,1),(28,7406963,7406931,'ria',25,1),(28,7406964,7406931,'ial',25,1),(28,7406965,7406961,'siz',50,1),(28,7406966,7406961,'ize',50,1),(28,7406967,7406965,'321',100,1),(28,7406968,7406967,'dev',25,1),(28,7406969,7406967,'evi',25,1),(28,7406970,7406967,'vic',25,1),(28,7406971,7406967,'ice',25,1),(28,7406972,7406968,'typ',50,1),(28,7406973,7406968,'ype',50,1),(28,7406974,7406972,'dir',10,1),(28,7406975,7406972,'ire',10,1),(28,7406976,7406972,'rec',10,1),(28,7406977,7406972,'ect',10,1),(28,7406978,7406972,'cta',10,1),(28,7406979,7406972,'tac',10,1),(28,7406980,7406972,'acc',10,1),(28,7406981,7406972,'cce',10,1),(28,7406982,7406972,'ces',10,1),(28,7406983,7406972,'ess',10,1),(28,7406984,7406974,'mul',14.286,1),(28,7406985,7406974,'ult',14.286,1),(28,7406986,7406974,'lti',14.286,1),(28,7406987,7406974,'tip',14.286,1),(28,7406988,7406974,'ipa',14.286,1),(28,7406989,7406974,'pat',14.286,1),(28,7406990,7406974,'ath',14.286,1),(28,7406991,7406984,'plu',25,1),(28,7406992,7406984,'lug',25,1),(28,7406993,7406984,'ugi',25,1),(28,7406994,7406984,'gin',25,1),(28,7406995,7406991,'nmp',100,1),(28,7406996,7406995,'dev',33.333,1),(28,7406997,7406995,'evf',33.333,1),(28,7406998,7406995,'vfs',33.333,1),(28,7406999,7406996,'pat',50,1),(28,7407000,7406996,'ath',50,1),(28,7407001,7406999,'vmf',50,1),(28,7407002,7406999,'mfs',50,1),(28,7407003,7407001,'dev',20,1),(28,7407004,7407001,'evi',20,1),(28,7407005,7407001,'vic',20,1),(28,7407006,7407001,'ice',20,1),(28,7407007,7407001,'ces',20,1),(28,7407008,7407003,'dis',33.333,1),(28,7407009,7407003,'isk',33.333,1),(28,7407010,7407003,'sks',33.333,1),(28,7407011,7407008,'ven',25,1),(28,7407012,7407008,'end',25,1),(28,7407013,7407008,'ndo',25,1),(28,7407014,7407008,'dor',25,1),(28,7407015,7407011,'mod',33.333,1),(28,7407016,7407011,'ode',33.333,1),(28,7407017,7407011,'del',33.333,1),(28,7407018,7407015,'lun',100,1),(28,7407019,7407018,'cmo',33.333,1),(28,7407020,7407018,'mod',33.333,1),(28,7407021,7407018,'ode',33.333,1),(28,7407022,7407019,'rev',16.667,1),(28,7407023,7407019,'evi',16.667,1),(28,7407024,7407019,'vis',16.667,1),(28,7407025,7407019,'isi',16.667,1),(28,7407026,7407019,'sio',16.667,1),(28,7407027,7407019,'ion',16.667,1),(28,7407028,7407022,'810',50,1),(28,7407029,7407022,'100',50,1),(28,7407030,7407028,'scs',50,1),(28,7407031,7407028,'csi',50,1),(28,7407032,7407030,'lev',33.333,1),(28,7407033,7407030,'eve',33.333,1),(28,7407034,7407030,'vel',33.333,1),(28,7407035,7407032,'pse',25,1),(28,7407036,7407032,'seu',25,1),(28,7407037,7407032,'eud',25,1),(28,7407038,7407032,'udo',25,1),(28,7407039,7407035,'fal',33.333,6),(28,7407040,7407035,'als',33.333,6),(28,7407041,7407035,'lse',33.333,6),(28,7407042,7407039,'sta',25,3),(28,7407043,7407039,'tat',25,3),(28,7407044,7407039,'atu',25,3),(28,7407045,7407039,'tus',25,3),(28,7407046,7407042,'rdm',100,1),(28,7407047,7407046,'cap',20,1),(28,7407048,7407046,'apa',20,1),(28,7407049,7407046,'pab',20,1),(28,7407050,7407046,'abl',20,1),(28,7407051,7407046,'ble',20,1),(28,7407052,7407047,'tru',50,1),(28,7407053,7407047,'rue',50,1),(28,7407054,7407052,'loc',33.333,1),(28,7407055,7407052,'oca',33.333,1),(28,7407056,7407052,'cal',33.333,1),(28,7407057,7407054,'rem',14.286,1),(28,7407058,7407054,'emo',14.286,1),(28,7407059,7407054,'mov',14.286,1),(28,7407060,7407054,'ova',14.286,1),(28,7407061,7407054,'vab',14.286,1),(28,7407062,7407054,'abl',14.286,1),(28,7407063,7407054,'ble',14.286,1),(28,7407064,7407057,'ssd',100,1),(28,7407065,7407064,'off',20,1),(28,7407066,7407064,'ffl',20,1),(28,7407067,7407064,'fli',20,1),(28,7407068,7407064,'lin',20,1),(28,7407069,7407064,'ine',20,1),(28,7407070,7407065,'per',11.111,1),(28,7407071,7407065,'ere',11.111,1),(28,7407072,7407065,'ren',11.111,1),(28,7407073,7407065,'enn',11.111,1),(28,7407074,7407065,'nni',11.111,1),(28,7407075,7407065,'nia',11.111,1),(28,7407076,7407065,'ial',11.111,1),(28,7407077,7407065,'all',11.111,1),(28,7407078,7407065,'lly',11.111,1),(28,7407079,7407070,'res',16.667,1),(28,7407080,7407070,'ese',16.667,1),(28,7407081,7407070,'ser',16.667,1),(28,7407082,7407070,'erv',16.667,1),(28,7407083,7407070,'rve',16.667,1),(28,7407084,7407070,'ved',16.667,1),(28,7407085,7407079,'thi',50,1),(28,7407086,7407079,'hin',50,1),(28,7407087,7407085,'pro',10,1),(28,7407088,7407085,'rov',10,1),(28,7407089,7407085,'ovi',10,1),(28,7407090,7407085,'vis',10,1),(28,7407091,7407085,'isi',10,1),(28,7407092,7407085,'sio',10,1),(28,7407093,7407085,'ion',10,1),(28,7407094,7407085,'oni',10,1),(28,7407095,7407085,'nin',10,1),(28,7407096,7407085,'ing',10,1),(28,7407097,7407087,'yes',100,1),(28,7407098,7407097,'att',16.667,1),(28,7407099,7407097,'tta',16.667,1),(28,7407100,7407097,'tac',16.667,1),(28,7407101,7407097,'ach',16.667,1),(28,7407102,7407097,'che',16.667,1),(28,7407103,7407097,'hed',16.667,1),(28,7407104,7407098,'fil',20,1),(28,7407105,7407098,'ilt',20,1),(28,7407106,7407098,'lte',20,1),(28,7407107,7407098,'ter',20,1),(28,7407108,7407098,'ers',20,1),(28,7407109,7407104,'vaa',50,1),(28,7407110,7407104,'aai',50,1),(28,7407111,7407109,'unk',20,1),(28,7407112,7407109,'nkn',20,1),(28,7407113,7407109,'kno',20,1),(28,7407114,7407109,'now',20,1),(28,7407115,7407109,'own',20,1),(28,7407116,7407111,'oth',33.333,1),(28,7407117,7407111,'the',33.333,1),(28,7407118,7407111,'her',33.333,1),(28,7407119,7407116,'uid',50,1),(28,7407120,7407116,'ids',50,1),(28,7407121,7407119,'vml',100,1),(28,7407122,7407121,'dis',20,1),(28,7407123,7407121,'isp',20,1),(28,7407124,7407121,'spl',20,1),(28,7407125,7407121,'pla',20,1),(28,7407126,7407121,'lay',20,1),(28,7407127,7407122,'nam',50,1),(28,7407128,7407122,'ame',50,1),(29,7407130,7407129,'net',25,3),(29,7407131,7407129,'eta',25,3),(29,7407132,7407129,'tap',25,3),(29,7407133,7407129,'app',25,3),(29,7407134,7407130,'fib',33.333,2),(29,7407135,7407130,'ibr',33.333,2),(29,7407136,7407130,'bre',33.333,2),(29,7407137,7407134,'cha',20,2),(29,7407138,7407134,'han',20,2),(29,7407139,7407134,'ann',20,2),(29,7407140,7407134,'nne',20,2),(29,7407141,7407134,'nel',20,2),(29,7407142,7407137,'dis',50,2),(29,7407143,7407137,'isk',50,2),(29,7407144,7407142,'naa',100,4),(29,7407145,7407144,'600',3.333,4),(29,7407146,7407144,'00a',3.333,4),(29,7407147,7407144,'0a0',3.333,4),(29,7407148,7407144,'a09',3.333,4),(29,7407149,7407144,'098',3.333,4),(29,7407150,7407144,'980',3.333,4),(29,7407151,7407144,'804',3.333,4),(29,7407152,7407144,'044',3.333,4),(29,7407153,7407144,'443',3.333,4),(29,7407154,7407144,'430',3.333,4),(29,7407155,7407144,'307',3.333,4),(29,7407156,7407144,'075',3.333,4),(29,7407157,7407144,'753',3.333,4),(29,7407158,7407144,'535',3.333,4),(29,7407159,7407144,'357',3.333,4),(29,7407160,7407144,'573',3.333,4),(29,7407161,7407144,'732',3.333,4),(29,7407162,7407144,'32b',3.333,4),(29,7407163,7407144,'2b3',3.333,4),(29,7407164,7407144,'b33',3.333,4),(29,7407165,7407144,'334',3.333,4),(29,7407166,7407144,'345',3.333,4),(29,7407167,7407144,'457',3.333,4),(29,7407168,7407144,'571',3.333,4),(29,7407169,7407144,'715',3.333,4),(29,7407170,7407144,'153',3.333,4),(29,7407171,7407144,'533',3.333,4),(29,7407172,7407144,'336',3.333,4),(29,7407173,7407144,'363',3.333,4),(29,7407174,7407144,'635',3.333,4),(29,7407175,7407145,'ser',25,1),(29,7407176,7407145,'eri',25,1),(29,7407177,7407145,'ria',25,1),(29,7407178,7407145,'ial',25,1),(29,7407179,7407175,'siz',50,1),(29,7407180,7407175,'ize',50,1),(29,7407181,7407179,'321',100,1),(29,7407182,7407181,'dev',25,1),(29,7407183,7407181,'evi',25,1),(29,7407184,7407181,'vic',25,1),(29,7407185,7407181,'ice',25,1),(29,7407186,7407182,'typ',50,1),(29,7407187,7407182,'ype',50,1),(29,7407188,7407186,'dir',10,1),(29,7407189,7407186,'ire',10,1),(29,7407190,7407186,'rec',10,1),(29,7407191,7407186,'ect',10,1),(29,7407192,7407186,'cta',10,1),(29,7407193,7407186,'tac',10,1),(29,7407194,7407186,'acc',10,1),(29,7407195,7407186,'cce',10,1),(29,7407196,7407186,'ces',10,1),(29,7407197,7407186,'ess',10,1),(29,7407198,7407188,'mul',14.286,1),(29,7407199,7407188,'ult',14.286,1),(29,7407200,7407188,'lti',14.286,1),(29,7407201,7407188,'tip',14.286,1),(29,7407202,7407188,'ipa',14.286,1),(29,7407203,7407188,'pat',14.286,1),(29,7407204,7407188,'ath',14.286,1),(29,7407205,7407198,'plu',25,1),(29,7407206,7407198,'lug',25,1),(29,7407207,7407198,'ugi',25,1),(29,7407208,7407198,'gin',25,1),(29,7407209,7407205,'nmp',100,1),(29,7407210,7407209,'dev',33.333,1),(29,7407211,7407209,'evf',33.333,1),(29,7407212,7407209,'vfs',33.333,1),(29,7407213,7407210,'pat',50,1),(29,7407214,7407210,'ath',50,1),(29,7407215,7407213,'vmf',50,1),(29,7407216,7407213,'mfs',50,1),(29,7407217,7407215,'dev',20,1),(29,7407218,7407215,'evi',20,1),(29,7407219,7407215,'vic',20,1),(29,7407220,7407215,'ice',20,1),(29,7407221,7407215,'ces',20,1),(29,7407222,7407217,'dis',33.333,1),(29,7407223,7407217,'isk',33.333,1),(29,7407224,7407217,'sks',33.333,1),(29,7407225,7407222,'ven',25,1),(29,7407226,7407222,'end',25,1),(29,7407227,7407222,'ndo',25,1),(29,7407228,7407222,'dor',25,1),(29,7407229,7407225,'mod',33.333,1),(29,7407230,7407225,'ode',33.333,1),(29,7407231,7407225,'del',33.333,1),(29,7407232,7407229,'lun',100,1),(29,7407233,7407232,'cmo',33.333,1),(29,7407234,7407232,'mod',33.333,1),(29,7407235,7407232,'ode',33.333,1),(29,7407236,7407233,'rev',16.667,1),(29,7407237,7407233,'evi',16.667,1),(29,7407238,7407233,'vis',16.667,1),(29,7407239,7407233,'isi',16.667,1),(29,7407240,7407233,'sio',16.667,1),(29,7407241,7407233,'ion',16.667,1),(29,7407242,7407236,'810',50,1),(29,7407243,7407236,'100',50,1),(29,7407244,7407242,'scs',50,1),(29,7407245,7407242,'csi',50,1),(29,7407246,7407244,'lev',33.333,1),(29,7407247,7407244,'eve',33.333,1),(29,7407248,7407244,'vel',33.333,1),(29,7407249,7407246,'pse',25,1),(29,7407250,7407246,'seu',25,1),(29,7407251,7407246,'eud',25,1),(29,7407252,7407246,'udo',25,1),(29,7407253,7407249,'fal',33.333,6),(29,7407254,7407249,'als',33.333,6),(29,7407255,7407249,'lse',33.333,6),(29,7407256,7407253,'sta',25,3),(29,7407257,7407253,'tat',25,3),(29,7407258,7407253,'atu',25,3),(29,7407259,7407253,'tus',25,3),(29,7407260,7407256,'rdm',100,1),(29,7407261,7407260,'cap',20,1),(29,7407262,7407260,'apa',20,1),(29,7407263,7407260,'pab',20,1),(29,7407264,7407260,'abl',20,1),(29,7407265,7407260,'ble',20,1),(29,7407266,7407261,'tru',50,1),(29,7407267,7407261,'rue',50,1),(29,7407268,7407266,'loc',33.333,1),(29,7407269,7407266,'oca',33.333,1),(29,7407270,7407266,'cal',33.333,1),(29,7407271,7407268,'rem',14.286,1),(29,7407272,7407268,'emo',14.286,1),(29,7407273,7407268,'mov',14.286,1),(29,7407274,7407268,'ova',14.286,1),(29,7407275,7407268,'vab',14.286,1),(29,7407276,7407268,'abl',14.286,1),(29,7407277,7407268,'ble',14.286,1),(29,7407278,7407271,'ssd',100,1),(29,7407279,7407278,'off',20,1),(29,7407280,7407278,'ffl',20,1),(29,7407281,7407278,'fli',20,1),(29,7407282,7407278,'lin',20,1),(29,7407283,7407278,'ine',20,1),(29,7407284,7407279,'per',11.111,1),(29,7407285,7407279,'ere',11.111,1),(29,7407286,7407279,'ren',11.111,1),(29,7407287,7407279,'enn',11.111,1),(29,7407288,7407279,'nni',11.111,1),(29,7407289,7407279,'nia',11.111,1),(29,7407290,7407279,'ial',11.111,1),(29,7407291,7407279,'all',11.111,1),(29,7407292,7407279,'lly',11.111,1),(29,7407293,7407284,'res',16.667,1),(29,7407294,7407284,'ese',16.667,1),(29,7407295,7407284,'ser',16.667,1),(29,7407296,7407284,'erv',16.667,1),(29,7407297,7407284,'rve',16.667,1),(29,7407298,7407284,'ved',16.667,1),(29,7407299,7407293,'thi',50,1),(29,7407300,7407293,'hin',50,1),(29,7407301,7407299,'pro',10,1),(29,7407302,7407299,'rov',10,1),(29,7407303,7407299,'ovi',10,1),(29,7407304,7407299,'vis',10,1),(29,7407305,7407299,'isi',10,1),(29,7407306,7407299,'sio',10,1),(29,7407307,7407299,'ion',10,1),(29,7407308,7407299,'oni',10,1),(29,7407309,7407299,'nin',10,1),(29,7407310,7407299,'ing',10,1),(29,7407311,7407301,'yes',100,1),(29,7407312,7407311,'att',16.667,1),(29,7407313,7407311,'tta',16.667,1),(29,7407314,7407311,'tac',16.667,1),(29,7407315,7407311,'ach',16.667,1),(29,7407316,7407311,'che',16.667,1),(29,7407317,7407311,'hed',16.667,1),(29,7407318,7407312,'fil',20,1),(29,7407319,7407312,'ilt',20,1),(29,7407320,7407312,'lte',20,1),(29,7407321,7407312,'ter',20,1),(29,7407322,7407312,'ers',20,1),(29,7407323,7407318,'vaa',50,1),(29,7407324,7407318,'aai',50,1),(29,7407325,7407323,'unk',20,1),(29,7407326,7407323,'nkn',20,1),(29,7407327,7407323,'kno',20,1),(29,7407328,7407323,'now',20,1),(29,7407329,7407323,'own',20,1),(29,7407330,7407325,'oth',33.333,1),(29,7407331,7407325,'the',33.333,1),(29,7407332,7407325,'her',33.333,1),(29,7407333,7407330,'uid',50,1),(29,7407334,7407330,'ids',50,1),(29,7407335,7407333,'vml',100,1),(29,7407336,7407335,'dis',20,1),(29,7407337,7407335,'isp',20,1),(29,7407338,7407335,'spl',20,1),(29,7407339,7407335,'pla',20,1),(29,7407340,7407335,'lay',20,1),(29,7407341,7407336,'nam',50,1),(29,7407342,7407336,'ame',50,1),(30,7407344,7407343,'net',25,3),(30,7407345,7407343,'eta',25,3),(30,7407346,7407343,'tap',25,3),(30,7407347,7407343,'app',25,3),(30,7407348,7407344,'fib',33.333,2),(30,7407349,7407344,'ibr',33.333,2),(30,7407350,7407344,'bre',33.333,2),(30,7407351,7407348,'cha',20,2),(30,7407352,7407348,'han',20,2),(30,7407353,7407348,'ann',20,2),(30,7407354,7407348,'nne',20,2),(30,7407355,7407348,'nel',20,2),(30,7407356,7407351,'dis',50,2),(30,7407357,7407351,'isk',50,2),(30,7407358,7407356,'naa',100,4),(30,7407359,7407358,'600',3.333,4),(30,7407360,7407358,'00a',3.333,4),(30,7407361,7407358,'0a0',3.333,4),(30,7407362,7407358,'a09',3.333,4),(30,7407363,7407358,'098',3.333,4),(30,7407364,7407358,'980',3.333,4),(30,7407365,7407358,'804',3.333,4),(30,7407366,7407358,'044',3.333,4),(30,7407367,7407358,'443',3.333,4),(30,7407368,7407358,'430',3.333,4),(30,7407369,7407358,'307',3.333,4),(30,7407370,7407358,'075',3.333,4),(30,7407371,7407358,'753',3.333,4),(30,7407372,7407358,'535',3.333,4),(30,7407373,7407358,'357',3.333,4),(30,7407374,7407358,'573',3.333,4),(30,7407375,7407358,'732',3.333,4),(30,7407376,7407358,'32b',3.333,4),(30,7407377,7407358,'2b3',3.333,4),(30,7407378,7407358,'b33',3.333,4),(30,7407379,7407358,'334',3.333,4),(30,7407380,7407358,'345',3.333,4),(30,7407381,7407358,'457',3.333,4),(30,7407382,7407358,'571',3.333,4),(30,7407383,7407358,'715',3.333,4),(30,7407384,7407358,'153',3.333,4),(30,7407385,7407358,'533',3.333,4),(30,7407386,7407358,'336',3.333,4),(30,7407387,7407358,'363',3.333,4),(30,7407388,7407358,'636',3.333,4),(30,7407389,7407359,'ser',25,1),(30,7407390,7407359,'eri',25,1),(30,7407391,7407359,'ria',25,1),(30,7407392,7407359,'ial',25,1),(30,7407393,7407389,'siz',50,1),(30,7407394,7407389,'ize',50,1),(30,7407395,7407393,'321',100,1),(30,7407396,7407395,'dev',25,1),(30,7407397,7407395,'evi',25,1),(30,7407398,7407395,'vic',25,1),(30,7407399,7407395,'ice',25,1),(30,7407400,7407396,'typ',50,1),(30,7407401,7407396,'ype',50,1),(30,7407402,7407400,'dir',10,1),(30,7407403,7407400,'ire',10,1),(30,7407404,7407400,'rec',10,1),(30,7407405,7407400,'ect',10,1),(30,7407406,7407400,'cta',10,1),(30,7407407,7407400,'tac',10,1),(30,7407408,7407400,'acc',10,1),(30,7407409,7407400,'cce',10,1),(30,7407410,7407400,'ces',10,1),(30,7407411,7407400,'ess',10,1),(30,7407412,7407402,'mul',14.286,1),(30,7407413,7407402,'ult',14.286,1),(30,7407414,7407402,'lti',14.286,1),(30,7407415,7407402,'tip',14.286,1),(30,7407416,7407402,'ipa',14.286,1),(30,7407417,7407402,'pat',14.286,1),(30,7407418,7407402,'ath',14.286,1),(30,7407419,7407412,'plu',25,1),(30,7407420,7407412,'lug',25,1),(30,7407421,7407412,'ugi',25,1),(30,7407422,7407412,'gin',25,1),(30,7407423,7407419,'nmp',100,1),(30,7407424,7407423,'dev',33.333,1),(30,7407425,7407423,'evf',33.333,1),(30,7407426,7407423,'vfs',33.333,1),(30,7407427,7407424,'pat',50,1),(30,7407428,7407424,'ath',50,1),(30,7407429,7407427,'vmf',50,1),(30,7407430,7407427,'mfs',50,1),(30,7407431,7407429,'dev',20,1),(30,7407432,7407429,'evi',20,1),(30,7407433,7407429,'vic',20,1),(30,7407434,7407429,'ice',20,1),(30,7407435,7407429,'ces',20,1),(30,7407436,7407431,'dis',33.333,1),(30,7407437,7407431,'isk',33.333,1),(30,7407438,7407431,'sks',33.333,1),(30,7407439,7407436,'ven',25,1),(30,7407440,7407436,'end',25,1),(30,7407441,7407436,'ndo',25,1),(30,7407442,7407436,'dor',25,1),(30,7407443,7407439,'mod',33.333,1),(30,7407444,7407439,'ode',33.333,1),(30,7407445,7407439,'del',33.333,1),(30,7407446,7407443,'lun',100,1),(30,7407447,7407446,'cmo',33.333,1),(30,7407448,7407446,'mod',33.333,1),(30,7407449,7407446,'ode',33.333,1),(30,7407450,7407447,'rev',16.667,1),(30,7407451,7407447,'evi',16.667,1),(30,7407452,7407447,'vis',16.667,1),(30,7407453,7407447,'isi',16.667,1),(30,7407454,7407447,'sio',16.667,1),(30,7407455,7407447,'ion',16.667,1),(30,7407456,7407450,'810',50,1),(30,7407457,7407450,'100',50,1),(30,7407458,7407456,'scs',50,1),(30,7407459,7407456,'csi',50,1),(30,7407460,7407458,'lev',33.333,1),(30,7407461,7407458,'eve',33.333,1),(30,7407462,7407458,'vel',33.333,1),(30,7407463,7407460,'pse',25,1),(30,7407464,7407460,'seu',25,1),(30,7407465,7407460,'eud',25,1),(30,7407466,7407460,'udo',25,1),(30,7407467,7407463,'fal',33.333,6),(30,7407468,7407463,'als',33.333,6),(30,7407469,7407463,'lse',33.333,6),(30,7407470,7407467,'sta',25,3),(30,7407471,7407467,'tat',25,3),(30,7407472,7407467,'atu',25,3),(30,7407473,7407467,'tus',25,3),(30,7407474,7407470,'rdm',100,1),(30,7407475,7407474,'cap',20,1),(30,7407476,7407474,'apa',20,1),(30,7407477,7407474,'pab',20,1),(30,7407478,7407474,'abl',20,1),(30,7407479,7407474,'ble',20,1),(30,7407480,7407475,'tru',50,1),(30,7407481,7407475,'rue',50,1),(30,7407482,7407480,'loc',33.333,1),(30,7407483,7407480,'oca',33.333,1),(30,7407484,7407480,'cal',33.333,1),(30,7407485,7407482,'rem',14.286,1),(30,7407486,7407482,'emo',14.286,1),(30,7407487,7407482,'mov',14.286,1),(30,7407488,7407482,'ova',14.286,1),(30,7407489,7407482,'vab',14.286,1),(30,7407490,7407482,'abl',14.286,1),(30,7407491,7407482,'ble',14.286,1),(30,7407492,7407485,'ssd',100,1),(30,7407493,7407492,'off',20,1),(30,7407494,7407492,'ffl',20,1),(30,7407495,7407492,'fli',20,1),(30,7407496,7407492,'lin',20,1),(30,7407497,7407492,'ine',20,1),(30,7407498,7407493,'per',11.111,1),(30,7407499,7407493,'ere',11.111,1),(30,7407500,7407493,'ren',11.111,1),(30,7407501,7407493,'enn',11.111,1),(30,7407502,7407493,'nni',11.111,1),(30,7407503,7407493,'nia',11.111,1),(30,7407504,7407493,'ial',11.111,1),(30,7407505,7407493,'all',11.111,1),(30,7407506,7407493,'lly',11.111,1),(30,7407507,7407498,'res',16.667,1),(30,7407508,7407498,'ese',16.667,1),(30,7407509,7407498,'ser',16.667,1),(30,7407510,7407498,'erv',16.667,1),(30,7407511,7407498,'rve',16.667,1),(30,7407512,7407498,'ved',16.667,1),(30,7407513,7407507,'thi',50,1),(30,7407514,7407507,'hin',50,1),(30,7407515,7407513,'pro',10,1),(30,7407516,7407513,'rov',10,1),(30,7407517,7407513,'ovi',10,1),(30,7407518,7407513,'vis',10,1),(30,7407519,7407513,'isi',10,1),(30,7407520,7407513,'sio',10,1),(30,7407521,7407513,'ion',10,1),(30,7407522,7407513,'oni',10,1),(30,7407523,7407513,'nin',10,1),(30,7407524,7407513,'ing',10,1),(30,7407525,7407515,'yes',100,1),(30,7407526,7407525,'att',16.667,1),(30,7407527,7407525,'tta',16.667,1),(30,7407528,7407525,'tac',16.667,1),(30,7407529,7407525,'ach',16.667,1),(30,7407530,7407525,'che',16.667,1),(30,7407531,7407525,'hed',16.667,1),(30,7407532,7407526,'fil',20,1),(30,7407533,7407526,'ilt',20,1),(30,7407534,7407526,'lte',20,1),(30,7407535,7407526,'ter',20,1),(30,7407536,7407526,'ers',20,1),(30,7407537,7407532,'vaa',50,1),(30,7407538,7407532,'aai',50,1),(30,7407539,7407537,'unk',20,1),(30,7407540,7407537,'nkn',20,1),(30,7407541,7407537,'kno',20,1),(30,7407542,7407537,'now',20,1),(30,7407543,7407537,'own',20,1),(30,7407544,7407539,'oth',33.333,1),(30,7407545,7407539,'the',33.333,1),(30,7407546,7407539,'her',33.333,1),(30,7407547,7407544,'uid',50,1),(30,7407548,7407544,'ids',50,1),(30,7407549,7407547,'vml',100,1),(30,7407550,7407549,'dis',20,1),(30,7407551,7407549,'isp',20,1),(30,7407552,7407549,'spl',20,1),(30,7407553,7407549,'pla',20,1),(30,7407554,7407549,'lay',20,1),(30,7407555,7407550,'nam',50,1),(30,7407556,7407550,'ame',50,1),(31,7407558,7407557,'net',25,3),(31,7407559,7407557,'eta',25,3),(31,7407560,7407557,'tap',25,3),(31,7407561,7407557,'app',25,3),(31,7407562,7407558,'fib',33.333,2),(31,7407563,7407558,'ibr',33.333,2),(31,7407564,7407558,'bre',33.333,2),(31,7407565,7407562,'cha',20,2),(31,7407566,7407562,'han',20,2),(31,7407567,7407562,'ann',20,2),(31,7407568,7407562,'nne',20,2),(31,7407569,7407562,'nel',20,2),(31,7407570,7407565,'dis',50,2),(31,7407571,7407565,'isk',50,2),(31,7407572,7407570,'naa',100,4),(31,7407573,7407572,'600',3.333,4),(31,7407574,7407572,'00a',3.333,4),(31,7407575,7407572,'0a0',3.333,4),(31,7407576,7407572,'a09',3.333,4),(31,7407577,7407572,'098',3.333,4),(31,7407578,7407572,'980',3.333,4),(31,7407579,7407572,'804',3.333,4),(31,7407580,7407572,'044',3.333,4),(31,7407581,7407572,'443',3.333,4),(31,7407582,7407572,'430',3.333,4),(31,7407583,7407572,'307',3.333,4),(31,7407584,7407572,'075',3.333,4),(31,7407585,7407572,'753',3.333,4),(31,7407586,7407572,'535',3.333,4),(31,7407587,7407572,'357',3.333,4),(31,7407588,7407572,'573',3.333,4),(31,7407589,7407572,'732',3.333,4),(31,7407590,7407572,'32b',3.333,4),(31,7407591,7407572,'2b3',3.333,4),(31,7407592,7407572,'b33',3.333,4),(31,7407593,7407572,'334',3.333,4),(31,7407594,7407572,'345',3.333,4),(31,7407595,7407572,'457',3.333,4),(31,7407596,7407572,'571',3.333,4),(31,7407597,7407572,'715',3.333,4),(31,7407598,7407572,'153',3.333,4),(31,7407599,7407572,'533',3.333,4),(31,7407600,7407572,'336',3.333,4),(31,7407601,7407572,'363',3.333,4),(31,7407602,7407572,'637',3.333,4),(31,7407603,7407573,'ser',25,1),(31,7407604,7407573,'eri',25,1),(31,7407605,7407573,'ria',25,1),(31,7407606,7407573,'ial',25,1),(31,7407607,7407603,'siz',50,1),(31,7407608,7407603,'ize',50,1),(31,7407609,7407607,'321',100,1),(31,7407610,7407609,'dev',25,1),(31,7407611,7407609,'evi',25,1),(31,7407612,7407609,'vic',25,1),(31,7407613,7407609,'ice',25,1),(31,7407614,7407610,'typ',50,1),(31,7407615,7407610,'ype',50,1),(31,7407616,7407614,'dir',10,1),(31,7407617,7407614,'ire',10,1),(31,7407618,7407614,'rec',10,1),(31,7407619,7407614,'ect',10,1),(31,7407620,7407614,'cta',10,1),(31,7407621,7407614,'tac',10,1),(31,7407622,7407614,'acc',10,1),(31,7407623,7407614,'cce',10,1),(31,7407624,7407614,'ces',10,1),(31,7407625,7407614,'ess',10,1),(31,7407626,7407616,'mul',14.286,1),(31,7407627,7407616,'ult',14.286,1),(31,7407628,7407616,'lti',14.286,1),(31,7407629,7407616,'tip',14.286,1),(31,7407630,7407616,'ipa',14.286,1),(31,7407631,7407616,'pat',14.286,1),(31,7407632,7407616,'ath',14.286,1),(31,7407633,7407626,'plu',25,1),(31,7407634,7407626,'lug',25,1),(31,7407635,7407626,'ugi',25,1),(31,7407636,7407626,'gin',25,1),(31,7407637,7407633,'nmp',100,1),(31,7407638,7407637,'dev',33.333,1),(31,7407639,7407637,'evf',33.333,1),(31,7407640,7407637,'vfs',33.333,1),(31,7407641,7407638,'pat',50,1),(31,7407642,7407638,'ath',50,1),(31,7407643,7407641,'vmf',50,1),(31,7407644,7407641,'mfs',50,1),(31,7407645,7407643,'dev',20,1),(31,7407646,7407643,'evi',20,1),(31,7407647,7407643,'vic',20,1),(31,7407648,7407643,'ice',20,1),(31,7407649,7407643,'ces',20,1),(31,7407650,7407645,'dis',33.333,1),(31,7407651,7407645,'isk',33.333,1),(31,7407652,7407645,'sks',33.333,1),(31,7407653,7407650,'ven',25,1),(31,7407654,7407650,'end',25,1),(31,7407655,7407650,'ndo',25,1),(31,7407656,7407650,'dor',25,1),(31,7407657,7407653,'mod',33.333,1),(31,7407658,7407653,'ode',33.333,1),(31,7407659,7407653,'del',33.333,1),(31,7407660,7407657,'lun',100,1),(31,7407661,7407660,'cmo',33.333,1),(31,7407662,7407660,'mod',33.333,1),(31,7407663,7407660,'ode',33.333,1),(31,7407664,7407661,'rev',16.667,1),(31,7407665,7407661,'evi',16.667,1),(31,7407666,7407661,'vis',16.667,1),(31,7407667,7407661,'isi',16.667,1),(31,7407668,7407661,'sio',16.667,1),(31,7407669,7407661,'ion',16.667,1),(31,7407670,7407664,'810',50,1),(31,7407671,7407664,'100',50,1),(31,7407672,7407670,'scs',50,1),(31,7407673,7407670,'csi',50,1),(31,7407674,7407672,'lev',33.333,1),(31,7407675,7407672,'eve',33.333,1),(31,7407676,7407672,'vel',33.333,1),(31,7407677,7407674,'pse',25,1),(31,7407678,7407674,'seu',25,1),(31,7407679,7407674,'eud',25,1),(31,7407680,7407674,'udo',25,1),(31,7407681,7407677,'fal',33.333,6),(31,7407682,7407677,'als',33.333,6),(31,7407683,7407677,'lse',33.333,6),(31,7407684,7407681,'sta',25,3),(31,7407685,7407681,'tat',25,3),(31,7407686,7407681,'atu',25,3),(31,7407687,7407681,'tus',25,3),(31,7407688,7407684,'rdm',100,1),(31,7407689,7407688,'cap',20,1),(31,7407690,7407688,'apa',20,1),(31,7407691,7407688,'pab',20,1),(31,7407692,7407688,'abl',20,1),(31,7407693,7407688,'ble',20,1),(31,7407694,7407689,'tru',50,1),(31,7407695,7407689,'rue',50,1),(31,7407696,7407694,'loc',33.333,1),(31,7407697,7407694,'oca',33.333,1),(31,7407698,7407694,'cal',33.333,1),(31,7407699,7407696,'rem',14.286,1),(31,7407700,7407696,'emo',14.286,1),(31,7407701,7407696,'mov',14.286,1),(31,7407702,7407696,'ova',14.286,1),(31,7407703,7407696,'vab',14.286,1),(31,7407704,7407696,'abl',14.286,1),(31,7407705,7407696,'ble',14.286,1),(31,7407706,7407699,'ssd',100,1),(31,7407707,7407706,'off',20,1),(31,7407708,7407706,'ffl',20,1),(31,7407709,7407706,'fli',20,1),(31,7407710,7407706,'lin',20,1),(31,7407711,7407706,'ine',20,1),(31,7407712,7407707,'per',11.111,1),(31,7407713,7407707,'ere',11.111,1),(31,7407714,7407707,'ren',11.111,1),(31,7407715,7407707,'enn',11.111,1),(31,7407716,7407707,'nni',11.111,1),(31,7407717,7407707,'nia',11.111,1),(31,7407718,7407707,'ial',11.111,1),(31,7407719,7407707,'all',11.111,1),(31,7407720,7407707,'lly',11.111,1),(31,7407721,7407712,'res',16.667,1),(31,7407722,7407712,'ese',16.667,1),(31,7407723,7407712,'ser',16.667,1),(31,7407724,7407712,'erv',16.667,1),(31,7407725,7407712,'rve',16.667,1),(31,7407726,7407712,'ved',16.667,1),(31,7407727,7407721,'thi',50,1),(31,7407728,7407721,'hin',50,1),(31,7407729,7407727,'pro',10,1),(31,7407730,7407727,'rov',10,1),(31,7407731,7407727,'ovi',10,1),(31,7407732,7407727,'vis',10,1),(31,7407733,7407727,'isi',10,1),(31,7407734,7407727,'sio',10,1),(31,7407735,7407727,'ion',10,1),(31,7407736,7407727,'oni',10,1),(31,7407737,7407727,'nin',10,1),(31,7407738,7407727,'ing',10,1),(31,7407739,7407729,'yes',100,1),(31,7407740,7407739,'att',16.667,1),(31,7407741,7407739,'tta',16.667,1),(31,7407742,7407739,'tac',16.667,1),(31,7407743,7407739,'ach',16.667,1),(31,7407744,7407739,'che',16.667,1),(31,7407745,7407739,'hed',16.667,1),(31,7407746,7407740,'fil',20,1),(31,7407747,7407740,'ilt',20,1),(31,7407748,7407740,'lte',20,1),(31,7407749,7407740,'ter',20,1),(31,7407750,7407740,'ers',20,1),(31,7407751,7407746,'vaa',50,1),(31,7407752,7407746,'aai',50,1),(31,7407753,7407751,'unk',20,1),(31,7407754,7407751,'nkn',20,1),(31,7407755,7407751,'kno',20,1),(31,7407756,7407751,'now',20,1),(31,7407757,7407751,'own',20,1),(31,7407758,7407753,'oth',33.333,1),(31,7407759,7407753,'the',33.333,1),(31,7407760,7407753,'her',33.333,1),(31,7407761,7407758,'uid',50,1),(31,7407762,7407758,'ids',50,1),(31,7407763,7407761,'vml',100,1),(31,7407764,7407763,'dis',20,1),(31,7407765,7407763,'isp',20,1),(31,7407766,7407763,'spl',20,1),(31,7407767,7407763,'pla',20,1),(31,7407768,7407763,'lay',20,1),(31,7407769,7407764,'nam',50,1),(31,7407770,7407764,'ame',50,1),(32,7407772,7407771,'net',25,3),(32,7407773,7407771,'eta',25,3),(32,7407774,7407771,'tap',25,3),(32,7407775,7407771,'app',25,3),(32,7407776,7407772,'fib',33.333,2),(32,7407777,7407772,'ibr',33.333,2),(32,7407778,7407772,'bre',33.333,2),(32,7407779,7407776,'cha',20,2),(32,7407780,7407776,'han',20,2),(32,7407781,7407776,'ann',20,2),(32,7407782,7407776,'nne',20,2),(32,7407783,7407776,'nel',20,2),(32,7407784,7407779,'dis',50,2),(32,7407785,7407779,'isk',50,2),(32,7407786,7407784,'naa',100,4),(32,7407787,7407786,'600',3.333,4),(32,7407788,7407786,'00a',3.333,4),(32,7407789,7407786,'0a0',3.333,4),(32,7407790,7407786,'a09',3.333,4),(32,7407791,7407786,'098',3.333,4),(32,7407792,7407786,'980',3.333,4),(32,7407793,7407786,'804',3.333,4),(32,7407794,7407786,'044',3.333,4),(32,7407795,7407786,'443',3.333,4),(32,7407796,7407786,'430',3.333,4),(32,7407797,7407786,'307',3.333,4),(32,7407798,7407786,'075',3.333,4),(32,7407799,7407786,'753',3.333,4),(32,7407800,7407786,'535',3.333,4),(32,7407801,7407786,'357',3.333,4),(32,7407802,7407786,'573',3.333,4),(32,7407803,7407786,'732',3.333,4),(32,7407804,7407786,'32b',3.333,4),(32,7407805,7407786,'2b3',3.333,4),(32,7407806,7407786,'b33',3.333,4),(32,7407807,7407786,'334',3.333,4),(32,7407808,7407786,'345',3.333,4),(32,7407809,7407786,'457',3.333,4),(32,7407810,7407786,'571',3.333,4),(32,7407811,7407786,'715',3.333,4),(32,7407812,7407786,'153',3.333,4),(32,7407813,7407786,'533',3.333,4),(32,7407814,7407786,'336',3.333,4),(32,7407815,7407786,'363',3.333,4),(32,7407816,7407786,'638',3.333,4),(32,7407817,7407787,'ser',25,1),(32,7407818,7407787,'eri',25,1),(32,7407819,7407787,'ria',25,1),(32,7407820,7407787,'ial',25,1),(32,7407821,7407817,'siz',50,1),(32,7407822,7407817,'ize',50,1),(32,7407823,7407821,'321',100,1),(32,7407824,7407823,'dev',25,1),(32,7407825,7407823,'evi',25,1),(32,7407826,7407823,'vic',25,1),(32,7407827,7407823,'ice',25,1),(32,7407828,7407824,'typ',50,1),(32,7407829,7407824,'ype',50,1),(32,7407830,7407828,'dir',10,1),(32,7407831,7407828,'ire',10,1),(32,7407832,7407828,'rec',10,1),(32,7407833,7407828,'ect',10,1),(32,7407834,7407828,'cta',10,1),(32,7407835,7407828,'tac',10,1),(32,7407836,7407828,'acc',10,1),(32,7407837,7407828,'cce',10,1),(32,7407838,7407828,'ces',10,1),(32,7407839,7407828,'ess',10,1),(32,7407840,7407830,'mul',14.286,1),(32,7407841,7407830,'ult',14.286,1),(32,7407842,7407830,'lti',14.286,1),(32,7407843,7407830,'tip',14.286,1),(32,7407844,7407830,'ipa',14.286,1),(32,7407845,7407830,'pat',14.286,1),(32,7407846,7407830,'ath',14.286,1),(32,7407847,7407840,'plu',25,1),(32,7407848,7407840,'lug',25,1),(32,7407849,7407840,'ugi',25,1),(32,7407850,7407840,'gin',25,1),(32,7407851,7407847,'nmp',100,1),(32,7407852,7407851,'dev',33.333,1),(32,7407853,7407851,'evf',33.333,1),(32,7407854,7407851,'vfs',33.333,1),(32,7407855,7407852,'pat',50,1),(32,7407856,7407852,'ath',50,1),(32,7407857,7407855,'vmf',50,1),(32,7407858,7407855,'mfs',50,1),(32,7407859,7407857,'dev',20,1),(32,7407860,7407857,'evi',20,1),(32,7407861,7407857,'vic',20,1),(32,7407862,7407857,'ice',20,1),(32,7407863,7407857,'ces',20,1),(32,7407864,7407859,'dis',33.333,1),(32,7407865,7407859,'isk',33.333,1),(32,7407866,7407859,'sks',33.333,1),(32,7407867,7407864,'ven',25,1),(32,7407868,7407864,'end',25,1),(32,7407869,7407864,'ndo',25,1),(32,7407870,7407864,'dor',25,1),(32,7407871,7407867,'mod',33.333,1),(32,7407872,7407867,'ode',33.333,1),(32,7407873,7407867,'del',33.333,1),(32,7407874,7407871,'lun',100,1),(32,7407875,7407874,'cmo',33.333,1),(32,7407876,7407874,'mod',33.333,1),(32,7407877,7407874,'ode',33.333,1),(32,7407878,7407875,'rev',16.667,1),(32,7407879,7407875,'evi',16.667,1),(32,7407880,7407875,'vis',16.667,1),(32,7407881,7407875,'isi',16.667,1),(32,7407882,7407875,'sio',16.667,1),(32,7407883,7407875,'ion',16.667,1),(32,7407884,7407878,'810',50,1),(32,7407885,7407878,'100',50,1),(32,7407886,7407884,'scs',50,1),(32,7407887,7407884,'csi',50,1),(32,7407888,7407886,'lev',33.333,1),(32,7407889,7407886,'eve',33.333,1),(32,7407890,7407886,'vel',33.333,1),(32,7407891,7407888,'pse',25,1),(32,7407892,7407888,'seu',25,1),(32,7407893,7407888,'eud',25,1),(32,7407894,7407888,'udo',25,1),(32,7407895,7407891,'fal',33.333,6),(32,7407896,7407891,'als',33.333,6),(32,7407897,7407891,'lse',33.333,6),(32,7407898,7407895,'sta',25,3),(32,7407899,7407895,'tat',25,3),(32,7407900,7407895,'atu',25,3),(32,7407901,7407895,'tus',25,3),(32,7407902,7407898,'rdm',100,1),(32,7407903,7407902,'cap',20,1),(32,7407904,7407902,'apa',20,1),(32,7407905,7407902,'pab',20,1),(32,7407906,7407902,'abl',20,1),(32,7407907,7407902,'ble',20,1),(32,7407908,7407903,'tru',50,1),(32,7407909,7407903,'rue',50,1),(32,7407910,7407908,'loc',33.333,1),(32,7407911,7407908,'oca',33.333,1),(32,7407912,7407908,'cal',33.333,1),(32,7407913,7407910,'rem',14.286,1),(32,7407914,7407910,'emo',14.286,1),(32,7407915,7407910,'mov',14.286,1),(32,7407916,7407910,'ova',14.286,1),(32,7407917,7407910,'vab',14.286,1),(32,7407918,7407910,'abl',14.286,1),(32,7407919,7407910,'ble',14.286,1),(32,7407920,7407913,'ssd',100,1),(32,7407921,7407920,'off',20,1),(32,7407922,7407920,'ffl',20,1),(32,7407923,7407920,'fli',20,1),(32,7407924,7407920,'lin',20,1),(32,7407925,7407920,'ine',20,1),(32,7407926,7407921,'per',11.111,1),(32,7407927,7407921,'ere',11.111,1),(32,7407928,7407921,'ren',11.111,1),(32,7407929,7407921,'enn',11.111,1),(32,7407930,7407921,'nni',11.111,1),(32,7407931,7407921,'nia',11.111,1),(32,7407932,7407921,'ial',11.111,1),(32,7407933,7407921,'all',11.111,1),(32,7407934,7407921,'lly',11.111,1),(32,7407935,7407926,'res',16.667,1),(32,7407936,7407926,'ese',16.667,1),(32,7407937,7407926,'ser',16.667,1),(32,7407938,7407926,'erv',16.667,1),(32,7407939,7407926,'rve',16.667,1),(32,7407940,7407926,'ved',16.667,1),(32,7407941,7407935,'thi',50,1),(32,7407942,7407935,'hin',50,1),(32,7407943,7407941,'pro',10,1),(32,7407944,7407941,'rov',10,1),(32,7407945,7407941,'ovi',10,1),(32,7407946,7407941,'vis',10,1),(32,7407947,7407941,'isi',10,1),(32,7407948,7407941,'sio',10,1),(32,7407949,7407941,'ion',10,1),(32,7407950,7407941,'oni',10,1),(32,7407951,7407941,'nin',10,1),(32,7407952,7407941,'ing',10,1),(32,7407953,7407943,'yes',100,1),(32,7407954,7407953,'att',16.667,1),(32,7407955,7407953,'tta',16.667,1),(32,7407956,7407953,'tac',16.667,1),(32,7407957,7407953,'ach',16.667,1),(32,7407958,7407953,'che',16.667,1),(32,7407959,7407953,'hed',16.667,1),(32,7407960,7407954,'fil',20,1),(32,7407961,7407954,'ilt',20,1),(32,7407962,7407954,'lte',20,1),(32,7407963,7407954,'ter',20,1),(32,7407964,7407954,'ers',20,1),(32,7407965,7407960,'vaa',50,1),(32,7407966,7407960,'aai',50,1),(32,7407967,7407965,'unk',20,1),(32,7407968,7407965,'nkn',20,1),(32,7407969,7407965,'kno',20,1),(32,7407970,7407965,'now',20,1),(32,7407971,7407965,'own',20,1),(32,7407972,7407967,'oth',33.333,1),(32,7407973,7407967,'the',33.333,1),(32,7407974,7407967,'her',33.333,1),(32,7407975,7407972,'uid',50,1),(32,7407976,7407972,'ids',50,1),(32,7407977,7407975,'vml',100,1),(32,7407978,7407977,'dis',20,1),(32,7407979,7407977,'isp',20,1),(32,7407980,7407977,'spl',20,1),(32,7407981,7407977,'pla',20,1),(32,7407982,7407977,'lay',20,1),(32,7407983,7407978,'nam',50,1),(32,7407984,7407978,'ame',50,1),(33,7407986,7407985,'net',25,3),(33,7407987,7407985,'eta',25,3),(33,7407988,7407985,'tap',25,3),(33,7407989,7407985,'app',25,3),(33,7407990,7407986,'fib',33.333,2),(33,7407991,7407986,'ibr',33.333,2),(33,7407992,7407986,'bre',33.333,2),(33,7407993,7407990,'cha',20,2),(33,7407994,7407990,'han',20,2),(33,7407995,7407990,'ann',20,2),(33,7407996,7407990,'nne',20,2),(33,7407997,7407990,'nel',20,2),(33,7407998,7407993,'dis',50,2),(33,7407999,7407993,'isk',50,2),(33,7408000,7407998,'naa',100,4),(33,7408001,7408000,'600',3.333,4),(33,7408002,7408000,'00a',3.333,4),(33,7408003,7408000,'0a0',3.333,4),(33,7408004,7408000,'a09',3.333,4),(33,7408005,7408000,'098',3.333,4),(33,7408006,7408000,'980',3.333,4),(33,7408007,7408000,'804',3.333,4),(33,7408008,7408000,'044',3.333,4),(33,7408009,7408000,'443',3.333,4),(33,7408010,7408000,'430',3.333,4),(33,7408011,7408000,'307',3.333,4),(33,7408012,7408000,'075',3.333,4),(33,7408013,7408000,'753',3.333,4),(33,7408014,7408000,'535',3.333,4),(33,7408015,7408000,'357',3.333,4),(33,7408016,7408000,'573',3.333,4),(33,7408017,7408000,'732',3.333,4),(33,7408018,7408000,'32b',3.333,4),(33,7408019,7408000,'2b3',3.333,4),(33,7408020,7408000,'b33',3.333,4),(33,7408021,7408000,'334',3.333,4),(33,7408022,7408000,'345',3.333,4),(33,7408023,7408000,'457',3.333,4),(33,7408024,7408000,'571',3.333,4),(33,7408025,7408000,'715',3.333,4),(33,7408026,7408000,'153',3.333,4),(33,7408027,7408000,'533',3.333,4),(33,7408028,7408000,'336',3.333,4),(33,7408029,7408000,'363',3.333,4),(33,7408030,7408000,'639',3.333,4),(33,7408031,7408001,'ser',25,1),(33,7408032,7408001,'eri',25,1),(33,7408033,7408001,'ria',25,1),(33,7408034,7408001,'ial',25,1),(33,7408035,7408031,'siz',50,1),(33,7408036,7408031,'ize',50,1),(33,7408037,7408035,'321',100,1),(33,7408038,7408037,'dev',25,1),(33,7408039,7408037,'evi',25,1),(33,7408040,7408037,'vic',25,1),(33,7408041,7408037,'ice',25,1),(33,7408042,7408038,'typ',50,1),(33,7408043,7408038,'ype',50,1),(33,7408044,7408042,'dir',10,1),(33,7408045,7408042,'ire',10,1),(33,7408046,7408042,'rec',10,1),(33,7408047,7408042,'ect',10,1),(33,7408048,7408042,'cta',10,1),(33,7408049,7408042,'tac',10,1),(33,7408050,7408042,'acc',10,1),(33,7408051,7408042,'cce',10,1),(33,7408052,7408042,'ces',10,1),(33,7408053,7408042,'ess',10,1),(33,7408054,7408044,'mul',14.286,1),(33,7408055,7408044,'ult',14.286,1),(33,7408056,7408044,'lti',14.286,1),(33,7408057,7408044,'tip',14.286,1),(33,7408058,7408044,'ipa',14.286,1),(33,7408059,7408044,'pat',14.286,1),(33,7408060,7408044,'ath',14.286,1),(33,7408061,7408054,'plu',25,1),(33,7408062,7408054,'lug',25,1),(33,7408063,7408054,'ugi',25,1),(33,7408064,7408054,'gin',25,1),(33,7408065,7408061,'nmp',100,1),(33,7408066,7408065,'dev',33.333,1),(33,7408067,7408065,'evf',33.333,1),(33,7408068,7408065,'vfs',33.333,1),(33,7408069,7408066,'pat',50,1),(33,7408070,7408066,'ath',50,1),(33,7408071,7408069,'vmf',50,1),(33,7408072,7408069,'mfs',50,1),(33,7408073,7408071,'dev',20,1),(33,7408074,7408071,'evi',20,1),(33,7408075,7408071,'vic',20,1),(33,7408076,7408071,'ice',20,1),(33,7408077,7408071,'ces',20,1),(33,7408078,7408073,'dis',33.333,1),(33,7408079,7408073,'isk',33.333,1),(33,7408080,7408073,'sks',33.333,1),(33,7408081,7408078,'ven',25,1),(33,7408082,7408078,'end',25,1),(33,7408083,7408078,'ndo',25,1),(33,7408084,7408078,'dor',25,1),(33,7408085,7408081,'mod',33.333,1),(33,7408086,7408081,'ode',33.333,1),(33,7408087,7408081,'del',33.333,1),(33,7408088,7408085,'lun',100,1),(33,7408089,7408088,'cmo',33.333,1),(33,7408090,7408088,'mod',33.333,1),(33,7408091,7408088,'ode',33.333,1),(33,7408092,7408089,'rev',16.667,1),(33,7408093,7408089,'evi',16.667,1),(33,7408094,7408089,'vis',16.667,1),(33,7408095,7408089,'isi',16.667,1),(33,7408096,7408089,'sio',16.667,1),(33,7408097,7408089,'ion',16.667,1),(33,7408098,7408092,'810',50,1),(33,7408099,7408092,'100',50,1),(33,7408100,7408098,'scs',50,1),(33,7408101,7408098,'csi',50,1),(33,7408102,7408100,'lev',33.333,1),(33,7408103,7408100,'eve',33.333,1),(33,7408104,7408100,'vel',33.333,1),(33,7408105,7408102,'pse',25,1),(33,7408106,7408102,'seu',25,1),(33,7408107,7408102,'eud',25,1),(33,7408108,7408102,'udo',25,1),(33,7408109,7408105,'fal',33.333,6),(33,7408110,7408105,'als',33.333,6),(33,7408111,7408105,'lse',33.333,6),(33,7408112,7408109,'sta',25,3),(33,7408113,7408109,'tat',25,3),(33,7408114,7408109,'atu',25,3),(33,7408115,7408109,'tus',25,3),(33,7408116,7408112,'rdm',100,1),(33,7408117,7408116,'cap',20,1),(33,7408118,7408116,'apa',20,1),(33,7408119,7408116,'pab',20,1),(33,7408120,7408116,'abl',20,1),(33,7408121,7408116,'ble',20,1),(33,7408122,7408117,'tru',50,1),(33,7408123,7408117,'rue',50,1),(33,7408124,7408122,'loc',33.333,1),(33,7408125,7408122,'oca',33.333,1),(33,7408126,7408122,'cal',33.333,1),(33,7408127,7408124,'rem',14.286,1),(33,7408128,7408124,'emo',14.286,1),(33,7408129,7408124,'mov',14.286,1),(33,7408130,7408124,'ova',14.286,1),(33,7408131,7408124,'vab',14.286,1),(33,7408132,7408124,'abl',14.286,1),(33,7408133,7408124,'ble',14.286,1),(33,7408134,7408127,'ssd',100,1),(33,7408135,7408134,'off',20,1),(33,7408136,7408134,'ffl',20,1),(33,7408137,7408134,'fli',20,1),(33,7408138,7408134,'lin',20,1),(33,7408139,7408134,'ine',20,1),(33,7408140,7408135,'per',11.111,1),(33,7408141,7408135,'ere',11.111,1),(33,7408142,7408135,'ren',11.111,1),(33,7408143,7408135,'enn',11.111,1),(33,7408144,7408135,'nni',11.111,1),(33,7408145,7408135,'nia',11.111,1),(33,7408146,7408135,'ial',11.111,1),(33,7408147,7408135,'all',11.111,1),(33,7408148,7408135,'lly',11.111,1),(33,7408149,7408140,'res',16.667,1),(33,7408150,7408140,'ese',16.667,1),(33,7408151,7408140,'ser',16.667,1),(33,7408152,7408140,'erv',16.667,1),(33,7408153,7408140,'rve',16.667,1),(33,7408154,7408140,'ved',16.667,1),(33,7408155,7408149,'thi',50,1),(33,7408156,7408149,'hin',50,1),(33,7408157,7408155,'pro',10,1),(33,7408158,7408155,'rov',10,1),(33,7408159,7408155,'ovi',10,1),(33,7408160,7408155,'vis',10,1),(33,7408161,7408155,'isi',10,1),(33,7408162,7408155,'sio',10,1),(33,7408163,7408155,'ion',10,1),(33,7408164,7408155,'oni',10,1),(33,7408165,7408155,'nin',10,1),(33,7408166,7408155,'ing',10,1),(33,7408167,7408157,'yes',100,1),(33,7408168,7408167,'att',16.667,1),(33,7408169,7408167,'tta',16.667,1),(33,7408170,7408167,'tac',16.667,1),(33,7408171,7408167,'ach',16.667,1),(33,7408172,7408167,'che',16.667,1),(33,7408173,7408167,'hed',16.667,1),(33,7408174,7408168,'fil',20,1),(33,7408175,7408168,'ilt',20,1),(33,7408176,7408168,'lte',20,1),(33,7408177,7408168,'ter',20,1),(33,7408178,7408168,'ers',20,1),(33,7408179,7408174,'vaa',50,1),(33,7408180,7408174,'aai',50,1),(33,7408181,7408179,'unk',20,1),(33,7408182,7408179,'nkn',20,1),(33,7408183,7408179,'kno',20,1),(33,7408184,7408179,'now',20,1),(33,7408185,7408179,'own',20,1),(33,7408186,7408181,'oth',33.333,1),(33,7408187,7408181,'the',33.333,1),(33,7408188,7408181,'her',33.333,1),(33,7408189,7408186,'uid',50,1),(33,7408190,7408186,'ids',50,1),(33,7408191,7408189,'vml',100,1),(33,7408192,7408191,'dis',20,1),(33,7408193,7408191,'isp',20,1),(33,7408194,7408191,'spl',20,1),(33,7408195,7408191,'pla',20,1),(33,7408196,7408191,'lay',20,1),(33,7408197,7408192,'nam',50,1),(33,7408198,7408192,'ame',50,1),(34,7408200,7408199,'net',25,3),(34,7408201,7408199,'eta',25,3),(34,7408202,7408199,'tap',25,3),(34,7408203,7408199,'app',25,3),(34,7408204,7408200,'fib',33.333,2),(34,7408205,7408200,'ibr',33.333,2),(34,7408206,7408200,'bre',33.333,2),(34,7408207,7408204,'cha',20,2),(34,7408208,7408204,'han',20,2),(34,7408209,7408204,'ann',20,2),(34,7408210,7408204,'nne',20,2),(34,7408211,7408204,'nel',20,2),(34,7408212,7408207,'dis',50,2),(34,7408213,7408207,'isk',50,2),(34,7408214,7408212,'naa',100,4),(34,7408215,7408214,'600',3.333,4),(34,7408216,7408214,'00a',3.333,4),(34,7408217,7408214,'0a0',3.333,4),(34,7408218,7408214,'a09',3.333,4),(34,7408219,7408214,'098',3.333,4),(34,7408220,7408214,'980',3.333,4),(34,7408221,7408214,'804',3.333,4),(34,7408222,7408214,'044',3.333,4),(34,7408223,7408214,'443',3.333,4),(34,7408224,7408214,'430',3.333,4),(34,7408225,7408214,'307',3.333,4),(34,7408226,7408214,'075',3.333,4),(34,7408227,7408214,'753',3.333,4),(34,7408228,7408214,'535',3.333,4),(34,7408229,7408214,'357',3.333,4),(34,7408230,7408214,'573',3.333,4),(34,7408231,7408214,'732',3.333,4),(34,7408232,7408214,'32b',3.333,4),(34,7408233,7408214,'2b3',3.333,4),(34,7408234,7408214,'b33',3.333,4),(34,7408235,7408214,'334',3.333,4),(34,7408236,7408214,'345',3.333,4),(34,7408237,7408214,'457',3.333,4),(34,7408238,7408214,'571',3.333,4),(34,7408239,7408214,'715',3.333,4),(34,7408240,7408214,'153',3.333,4),(34,7408241,7408214,'533',3.333,4),(34,7408242,7408214,'336',3.333,4),(34,7408243,7408214,'367',3.333,4),(34,7408244,7408214,'670',3.333,4),(34,7408245,7408215,'ser',25,1),(34,7408246,7408215,'eri',25,1),(34,7408247,7408215,'ria',25,1),(34,7408248,7408215,'ial',25,1),(34,7408249,7408245,'siz',50,1),(34,7408250,7408245,'ize',50,1),(34,7408251,7408249,'321',100,1),(34,7408252,7408251,'dev',25,1),(34,7408253,7408251,'evi',25,1),(34,7408254,7408251,'vic',25,1),(34,7408255,7408251,'ice',25,1),(34,7408256,7408252,'typ',50,1),(34,7408257,7408252,'ype',50,1),(34,7408258,7408256,'dir',10,1),(34,7408259,7408256,'ire',10,1),(34,7408260,7408256,'rec',10,1),(34,7408261,7408256,'ect',10,1),(34,7408262,7408256,'cta',10,1),(34,7408263,7408256,'tac',10,1),(34,7408264,7408256,'acc',10,1),(34,7408265,7408256,'cce',10,1),(34,7408266,7408256,'ces',10,1),(34,7408267,7408256,'ess',10,1),(34,7408268,7408258,'mul',14.286,1),(34,7408269,7408258,'ult',14.286,1),(34,7408270,7408258,'lti',14.286,1),(34,7408271,7408258,'tip',14.286,1),(34,7408272,7408258,'ipa',14.286,1),(34,7408273,7408258,'pat',14.286,1),(34,7408274,7408258,'ath',14.286,1),(34,7408275,7408268,'plu',25,1),(34,7408276,7408268,'lug',25,1),(34,7408277,7408268,'ugi',25,1),(34,7408278,7408268,'gin',25,1),(34,7408279,7408275,'nmp',100,1),(34,7408280,7408279,'dev',33.333,1),(34,7408281,7408279,'evf',33.333,1),(34,7408282,7408279,'vfs',33.333,1),(34,7408283,7408280,'pat',50,1),(34,7408284,7408280,'ath',50,1),(34,7408285,7408283,'vmf',50,1),(34,7408286,7408283,'mfs',50,1),(34,7408287,7408285,'dev',20,1),(34,7408288,7408285,'evi',20,1),(34,7408289,7408285,'vic',20,1),(34,7408290,7408285,'ice',20,1),(34,7408291,7408285,'ces',20,1),(34,7408292,7408287,'dis',33.333,1),(34,7408293,7408287,'isk',33.333,1),(34,7408294,7408287,'sks',33.333,1),(34,7408295,7408292,'ven',25,1),(34,7408296,7408292,'end',25,1),(34,7408297,7408292,'ndo',25,1),(34,7408298,7408292,'dor',25,1),(34,7408299,7408295,'mod',33.333,1),(34,7408300,7408295,'ode',33.333,1),(34,7408301,7408295,'del',33.333,1),(34,7408302,7408299,'lun',100,1),(34,7408303,7408302,'cmo',33.333,1),(34,7408304,7408302,'mod',33.333,1),(34,7408305,7408302,'ode',33.333,1),(34,7408306,7408303,'rev',16.667,1),(34,7408307,7408303,'evi',16.667,1),(34,7408308,7408303,'vis',16.667,1),(34,7408309,7408303,'isi',16.667,1),(34,7408310,7408303,'sio',16.667,1),(34,7408311,7408303,'ion',16.667,1),(34,7408312,7408306,'810',50,1),(34,7408313,7408306,'100',50,1),(34,7408314,7408312,'scs',50,1),(34,7408315,7408312,'csi',50,1),(34,7408316,7408314,'lev',33.333,1),(34,7408317,7408314,'eve',33.333,1),(34,7408318,7408314,'vel',33.333,1),(34,7408319,7408316,'pse',25,1),(34,7408320,7408316,'seu',25,1),(34,7408321,7408316,'eud',25,1),(34,7408322,7408316,'udo',25,1),(34,7408323,7408319,'fal',33.333,6),(34,7408324,7408319,'als',33.333,6),(34,7408325,7408319,'lse',33.333,6),(34,7408326,7408323,'sta',25,3),(34,7408327,7408323,'tat',25,3),(34,7408328,7408323,'atu',25,3),(34,7408329,7408323,'tus',25,3),(34,7408330,7408326,'rdm',100,1),(34,7408331,7408330,'cap',20,1),(34,7408332,7408330,'apa',20,1),(34,7408333,7408330,'pab',20,1),(34,7408334,7408330,'abl',20,1),(34,7408335,7408330,'ble',20,1),(34,7408336,7408331,'tru',50,1),(34,7408337,7408331,'rue',50,1),(34,7408338,7408336,'loc',33.333,1),(34,7408339,7408336,'oca',33.333,1),(34,7408340,7408336,'cal',33.333,1),(34,7408341,7408338,'rem',14.286,1),(34,7408342,7408338,'emo',14.286,1),(34,7408343,7408338,'mov',14.286,1),(34,7408344,7408338,'ova',14.286,1),(34,7408345,7408338,'vab',14.286,1),(34,7408346,7408338,'abl',14.286,1),(34,7408347,7408338,'ble',14.286,1),(34,7408348,7408341,'ssd',100,1),(34,7408349,7408348,'off',20,1),(34,7408350,7408348,'ffl',20,1),(34,7408351,7408348,'fli',20,1),(34,7408352,7408348,'lin',20,1),(34,7408353,7408348,'ine',20,1),(34,7408354,7408349,'per',11.111,1),(34,7408355,7408349,'ere',11.111,1),(34,7408356,7408349,'ren',11.111,1),(34,7408357,7408349,'enn',11.111,1),(34,7408358,7408349,'nni',11.111,1),(34,7408359,7408349,'nia',11.111,1),(34,7408360,7408349,'ial',11.111,1),(34,7408361,7408349,'all',11.111,1),(34,7408362,7408349,'lly',11.111,1),(34,7408363,7408354,'res',16.667,1),(34,7408364,7408354,'ese',16.667,1),(34,7408365,7408354,'ser',16.667,1),(34,7408366,7408354,'erv',16.667,1),(34,7408367,7408354,'rve',16.667,1),(34,7408368,7408354,'ved',16.667,1),(34,7408369,7408363,'thi',50,1),(34,7408370,7408363,'hin',50,1),(34,7408371,7408369,'pro',10,1),(34,7408372,7408369,'rov',10,1),(34,7408373,7408369,'ovi',10,1),(34,7408374,7408369,'vis',10,1),(34,7408375,7408369,'isi',10,1),(34,7408376,7408369,'sio',10,1),(34,7408377,7408369,'ion',10,1),(34,7408378,7408369,'oni',10,1),(34,7408379,7408369,'nin',10,1),(34,7408380,7408369,'ing',10,1),(34,7408381,7408371,'yes',100,1),(34,7408382,7408381,'att',16.667,1),(34,7408383,7408381,'tta',16.667,1),(34,7408384,7408381,'tac',16.667,1),(34,7408385,7408381,'ach',16.667,1),(34,7408386,7408381,'che',16.667,1),(34,7408387,7408381,'hed',16.667,1),(34,7408388,7408382,'fil',20,1),(34,7408389,7408382,'ilt',20,1),(34,7408390,7408382,'lte',20,1),(34,7408391,7408382,'ter',20,1),(34,7408392,7408382,'ers',20,1),(34,7408393,7408388,'vaa',50,1),(34,7408394,7408388,'aai',50,1),(34,7408395,7408393,'unk',20,1),(34,7408396,7408393,'nkn',20,1),(34,7408397,7408393,'kno',20,1),(34,7408398,7408393,'now',20,1),(34,7408399,7408393,'own',20,1),(34,7408400,7408395,'oth',33.333,1),(34,7408401,7408395,'the',33.333,1),(34,7408402,7408395,'her',33.333,1),(34,7408403,7408400,'uid',50,1),(34,7408404,7408400,'ids',50,1),(34,7408405,7408403,'vml',100,1),(34,7408406,7408405,'dis',20,1),(34,7408407,7408405,'isp',20,1),(34,7408408,7408405,'spl',20,1),(34,7408409,7408405,'pla',20,1),(34,7408410,7408405,'lay',20,1),(34,7408411,7408406,'nam',50,1),(34,7408412,7408406,'ame',50,1),(35,7408414,7408413,'net',25,3),(35,7408415,7408413,'eta',25,3),(35,7408416,7408413,'tap',25,3),(35,7408417,7408413,'app',25,3),(35,7408418,7408414,'fib',33.333,2),(35,7408419,7408414,'ibr',33.333,2),(35,7408420,7408414,'bre',33.333,2),(35,7408421,7408418,'cha',20,2),(35,7408422,7408418,'han',20,2),(35,7408423,7408418,'ann',20,2),(35,7408424,7408418,'nne',20,2),(35,7408425,7408418,'nel',20,2),(35,7408426,7408421,'dis',50,2),(35,7408427,7408421,'isk',50,2),(35,7408428,7408426,'naa',100,4),(35,7408429,7408428,'600',3.333,4),(35,7408430,7408428,'00a',3.333,4),(35,7408431,7408428,'0a0',3.333,4),(35,7408432,7408428,'a09',3.333,4),(35,7408433,7408428,'098',3.333,4),(35,7408434,7408428,'980',3.333,4),(35,7408435,7408428,'804',3.333,4),(35,7408436,7408428,'044',3.333,4),(35,7408437,7408428,'443',3.333,4),(35,7408438,7408428,'430',3.333,4),(35,7408439,7408428,'307',3.333,4),(35,7408440,7408428,'075',3.333,4),(35,7408441,7408428,'753',3.333,4),(35,7408442,7408428,'535',3.333,4),(35,7408443,7408428,'357',3.333,4),(35,7408444,7408428,'573',3.333,4),(35,7408445,7408428,'732',3.333,4),(35,7408446,7408428,'32b',3.333,4),(35,7408447,7408428,'2b3',3.333,4),(35,7408448,7408428,'b33',3.333,4),(35,7408449,7408428,'334',3.333,4),(35,7408450,7408428,'345',3.333,4),(35,7408451,7408428,'457',3.333,4),(35,7408452,7408428,'571',3.333,4),(35,7408453,7408428,'715',3.333,4),(35,7408454,7408428,'153',3.333,4),(35,7408455,7408428,'533',3.333,4),(35,7408456,7408428,'336',3.333,4),(35,7408457,7408428,'367',3.333,4),(35,7408458,7408428,'671',3.333,4),(35,7408459,7408429,'ser',25,1),(35,7408460,7408429,'eri',25,1),(35,7408461,7408429,'ria',25,1),(35,7408462,7408429,'ial',25,1),(35,7408463,7408459,'siz',50,1),(35,7408464,7408459,'ize',50,1),(35,7408465,7408463,'532',25,1),(35,7408466,7408463,'325',25,1),(35,7408467,7408463,'250',25,1),(35,7408468,7408463,'508',25,1),(35,7408469,7408465,'dev',25,1),(35,7408470,7408465,'evi',25,1),(35,7408471,7408465,'vic',25,1),(35,7408472,7408465,'ice',25,1),(35,7408473,7408469,'typ',50,1),(35,7408474,7408469,'ype',50,1),(35,7408475,7408473,'dir',10,1),(35,7408476,7408473,'ire',10,1),(35,7408477,7408473,'rec',10,1),(35,7408478,7408473,'ect',10,1),(35,7408479,7408473,'cta',10,1),(35,7408480,7408473,'tac',10,1),(35,7408481,7408473,'acc',10,1),(35,7408482,7408473,'cce',10,1),(35,7408483,7408473,'ces',10,1),(35,7408484,7408473,'ess',10,1),(35,7408485,7408475,'mul',14.286,1),(35,7408486,7408475,'ult',14.286,1),(35,7408487,7408475,'lti',14.286,1),(35,7408488,7408475,'tip',14.286,1),(35,7408489,7408475,'ipa',14.286,1),(35,7408490,7408475,'pat',14.286,1),(35,7408491,7408475,'ath',14.286,1),(35,7408492,7408485,'plu',25,1),(35,7408493,7408485,'lug',25,1),(35,7408494,7408485,'ugi',25,1),(35,7408495,7408485,'gin',25,1),(35,7408496,7408492,'nmp',100,1),(35,7408497,7408496,'dev',33.333,1),(35,7408498,7408496,'evf',33.333,1),(35,7408499,7408496,'vfs',33.333,1),(35,7408500,7408497,'pat',50,1),(35,7408501,7408497,'ath',50,1),(35,7408502,7408500,'vmf',50,1),(35,7408503,7408500,'mfs',50,1),(35,7408504,7408502,'dev',20,1),(35,7408505,7408502,'evi',20,1),(35,7408506,7408502,'vic',20,1),(35,7408507,7408502,'ice',20,1),(35,7408508,7408502,'ces',20,1),(35,7408509,7408504,'dis',33.333,1),(35,7408510,7408504,'isk',33.333,1),(35,7408511,7408504,'sks',33.333,1),(35,7408512,7408509,'ven',25,1),(35,7408513,7408509,'end',25,1),(35,7408514,7408509,'ndo',25,1),(35,7408515,7408509,'dor',25,1),(35,7408516,7408512,'mod',33.333,1),(35,7408517,7408512,'ode',33.333,1),(35,7408518,7408512,'del',33.333,1),(35,7408519,7408516,'lun',100,1),(35,7408520,7408519,'cmo',33.333,1),(35,7408521,7408519,'mod',33.333,1),(35,7408522,7408519,'ode',33.333,1),(35,7408523,7408520,'rev',16.667,1),(35,7408524,7408520,'evi',16.667,1),(35,7408525,7408520,'vis',16.667,1),(35,7408526,7408520,'isi',16.667,1),(35,7408527,7408520,'sio',16.667,1),(35,7408528,7408520,'ion',16.667,1),(35,7408529,7408523,'810',50,1),(35,7408530,7408523,'100',50,1),(35,7408531,7408529,'scs',50,1),(35,7408532,7408529,'csi',50,1),(35,7408533,7408531,'lev',33.333,1),(35,7408534,7408531,'eve',33.333,1),(35,7408535,7408531,'vel',33.333,1),(35,7408536,7408533,'pse',25,1),(35,7408537,7408533,'seu',25,1),(35,7408538,7408533,'eud',25,1),(35,7408539,7408533,'udo',25,1),(35,7408540,7408536,'fal',33.333,6),(35,7408541,7408536,'als',33.333,6),(35,7408542,7408536,'lse',33.333,6),(35,7408543,7408540,'sta',25,3),(35,7408544,7408540,'tat',25,3),(35,7408545,7408540,'atu',25,3),(35,7408546,7408540,'tus',25,3),(35,7408547,7408543,'rdm',100,1),(35,7408548,7408547,'cap',20,1),(35,7408549,7408547,'apa',20,1),(35,7408550,7408547,'pab',20,1),(35,7408551,7408547,'abl',20,1),(35,7408552,7408547,'ble',20,1),(35,7408553,7408548,'tru',50,1),(35,7408554,7408548,'rue',50,1),(35,7408555,7408553,'loc',33.333,1),(35,7408556,7408553,'oca',33.333,1),(35,7408557,7408553,'cal',33.333,1),(35,7408558,7408555,'rem',14.286,1),(35,7408559,7408555,'emo',14.286,1),(35,7408560,7408555,'mov',14.286,1),(35,7408561,7408555,'ova',14.286,1),(35,7408562,7408555,'vab',14.286,1),(35,7408563,7408555,'abl',14.286,1),(35,7408564,7408555,'ble',14.286,1),(35,7408565,7408558,'ssd',100,1),(35,7408566,7408565,'off',20,1),(35,7408567,7408565,'ffl',20,1),(35,7408568,7408565,'fli',20,1),(35,7408569,7408565,'lin',20,1),(35,7408570,7408565,'ine',20,1),(35,7408571,7408566,'per',11.111,1),(35,7408572,7408566,'ere',11.111,1),(35,7408573,7408566,'ren',11.111,1),(35,7408574,7408566,'enn',11.111,1),(35,7408575,7408566,'nni',11.111,1),(35,7408576,7408566,'nia',11.111,1),(35,7408577,7408566,'ial',11.111,1),(35,7408578,7408566,'all',11.111,1),(35,7408579,7408566,'lly',11.111,1),(35,7408580,7408571,'res',16.667,1),(35,7408581,7408571,'ese',16.667,1),(35,7408582,7408571,'ser',16.667,1),(35,7408583,7408571,'erv',16.667,1),(35,7408584,7408571,'rve',16.667,1),(35,7408585,7408571,'ved',16.667,1),(35,7408586,7408580,'thi',50,1),(35,7408587,7408580,'hin',50,1),(35,7408588,7408586,'pro',10,1),(35,7408589,7408586,'rov',10,1),(35,7408590,7408586,'ovi',10,1),(35,7408591,7408586,'vis',10,1),(35,7408592,7408586,'isi',10,1),(35,7408593,7408586,'sio',10,1),(35,7408594,7408586,'ion',10,1),(35,7408595,7408586,'oni',10,1),(35,7408596,7408586,'nin',10,1),(35,7408597,7408586,'ing',10,1),(35,7408598,7408588,'yes',100,1),(35,7408599,7408598,'att',16.667,1),(35,7408600,7408598,'tta',16.667,1),(35,7408601,7408598,'tac',16.667,1),(35,7408602,7408598,'ach',16.667,1),(35,7408603,7408598,'che',16.667,1),(35,7408604,7408598,'hed',16.667,1),(35,7408605,7408599,'fil',20,1),(35,7408606,7408599,'ilt',20,1),(35,7408607,7408599,'lte',20,1),(35,7408608,7408599,'ter',20,1),(35,7408609,7408599,'ers',20,1),(35,7408610,7408605,'vaa',50,1),(35,7408611,7408605,'aai',50,1),(35,7408612,7408610,'unk',20,1),(35,7408613,7408610,'nkn',20,1),(35,7408614,7408610,'kno',20,1),(35,7408615,7408610,'now',20,1),(35,7408616,7408610,'own',20,1),(35,7408617,7408612,'oth',33.333,1),(35,7408618,7408612,'the',33.333,1),(35,7408619,7408612,'her',33.333,1),(35,7408620,7408617,'uid',50,1),(35,7408621,7408617,'ids',50,1),(35,7408622,7408620,'vml',100,1),(35,7408623,7408622,'dis',20,1),(35,7408624,7408622,'isp',20,1),(35,7408625,7408622,'spl',20,1),(35,7408626,7408622,'pla',20,1),(35,7408627,7408622,'lay',20,1),(35,7408628,7408623,'nam',50,1),(35,7408629,7408623,'ame',50,1),(36,7408631,7408630,'net',25,3),(36,7408632,7408630,'eta',25,3),(36,7408633,7408630,'tap',25,3),(36,7408634,7408630,'app',25,3),(36,7408635,7408631,'ser',25,3),(36,7408636,7408631,'eri',25,3),(36,7408637,7408631,'ria',25,3),(36,7408638,7408631,'ial',25,3),(36,7408639,7408635,'att',16.667,3),(36,7408640,7408635,'tta',16.667,3),(36,7408641,7408635,'tac',16.667,3),(36,7408642,7408635,'ach',16.667,3),(36,7408643,7408635,'che',16.667,3),(36,7408644,7408635,'hed',16.667,3),(36,7408645,7408639,'scs',50,3),(36,7408646,7408639,'csi',50,3),(36,7408647,7408645,'dis',50,2),(36,7408648,7408645,'isk',50,2),(36,7408649,7408647,'naa',100,4),(36,7408650,7408649,'600',3.333,4),(36,7408651,7408649,'00a',3.333,4),(36,7408652,7408649,'0a0',3.333,4),(36,7408653,7408649,'a09',3.333,4),(36,7408654,7408649,'098',3.333,4),(36,7408655,7408649,'980',3.333,4),(36,7408656,7408649,'80c',3.333,4),(36,7408657,7408649,'0c1',3.333,4),(36,7408658,7408649,'c15',3.333,4),(36,7408659,7408649,'155',3.333,4),(36,7408660,7408649,'558',3.333,4),(36,7408661,7408649,'584',3.333,4),(36,7408662,7408649,'84e',3.333,4),(36,7408663,7408649,'4ee',3.333,4),(36,7408664,7408649,'eeb',3.333,4),(36,7408665,7408649,'eb9',3.333,4),(36,7408666,7408649,'b98',3.333,4),(36,7408667,7408649,'984',3.333,4),(36,7408668,7408649,'844',3.333,4),(36,7408669,7408649,'444',3.333,4),(36,7408670,7408649,'441',3.333,4),(36,7408671,7408649,'411',3.333,4),(36,7408672,7408649,'117',3.333,4),(36,7408673,7408649,'17b',3.333,4),(36,7408674,7408649,'7b0',3.333,4),(36,7408675,7408649,'b09',3.333,4),(36,7408676,7408649,'09a',3.333,4),(36,7408677,7408649,'9ab',3.333,4),(36,7408678,7408649,'aba',3.333,4),(36,7408679,7408649,'ba2',3.333,4),(36,7408680,7408650,'siz',50,1),(36,7408681,7408650,'ize',50,1),(36,7408682,7408680,'163',33.333,1),(36,7408683,7408680,'638',33.333,1),(36,7408684,7408680,'384',33.333,1),(36,7408685,7408682,'dev',25,1),(36,7408686,7408682,'evi',25,1),(36,7408687,7408682,'vic',25,1),(36,7408688,7408682,'ice',25,1),(36,7408689,7408685,'typ',50,1),(36,7408690,7408685,'ype',50,1),(36,7408691,7408689,'dir',10,1),(36,7408692,7408689,'ire',10,1),(36,7408693,7408689,'rec',10,1),(36,7408694,7408689,'ect',10,1),(36,7408695,7408689,'cta',10,1),(36,7408696,7408689,'tac',10,1),(36,7408697,7408689,'acc',10,1),(36,7408698,7408689,'cce',10,1),(36,7408699,7408689,'ces',10,1),(36,7408700,7408689,'ess',10,1),(36,7408701,7408691,'mul',14.286,1),(36,7408702,7408691,'ult',14.286,1),(36,7408703,7408691,'lti',14.286,1),(36,7408704,7408691,'tip',14.286,1),(36,7408705,7408691,'ipa',14.286,1),(36,7408706,7408691,'pat',14.286,1),(36,7408707,7408691,'ath',14.286,1),(36,7408708,7408701,'plu',25,1),(36,7408709,7408701,'lug',25,1),(36,7408710,7408701,'ugi',25,1),(36,7408711,7408701,'gin',25,1),(36,7408712,7408708,'nmp',100,1),(36,7408713,7408712,'dev',33.333,1),(36,7408714,7408712,'evf',33.333,1),(36,7408715,7408712,'vfs',33.333,1),(36,7408716,7408713,'pat',50,1),(36,7408717,7408713,'ath',50,1),(36,7408718,7408716,'vmf',50,1),(36,7408719,7408716,'mfs',50,1),(36,7408720,7408718,'dev',20,1),(36,7408721,7408718,'evi',20,1),(36,7408722,7408718,'vic',20,1),(36,7408723,7408718,'ice',20,1),(36,7408724,7408718,'ces',20,1),(36,7408725,7408720,'dis',33.333,1),(36,7408726,7408720,'isk',33.333,1),(36,7408727,7408720,'sks',33.333,1),(36,7408728,7408725,'ven',25,1),(36,7408729,7408725,'end',25,1),(36,7408730,7408725,'ndo',25,1),(36,7408731,7408725,'dor',25,1),(36,7408732,7408728,'mod',33.333,1),(36,7408733,7408728,'ode',33.333,1),(36,7408734,7408728,'del',33.333,1),(36,7408735,7408732,'fla',33.333,1),(36,7408736,7408732,'las',33.333,1),(36,7408737,7408732,'ash',33.333,1),(36,7408738,7408735,'acc',33.333,1),(36,7408739,7408735,'cce',33.333,1),(36,7408740,7408735,'cel',33.333,1),(36,7408741,7408738,'rev',16.667,1),(36,7408742,7408738,'evi',16.667,1),(36,7408743,7408738,'vis',16.667,1),(36,7408744,7408738,'isi',16.667,1),(36,7408745,7408738,'sio',16.667,1),(36,7408746,7408738,'ion',16.667,1),(36,7408747,7408741,'lev',33.333,1),(36,7408748,7408741,'eve',33.333,1),(36,7408749,7408741,'vel',33.333,1),(36,7408750,7408747,'pse',25,1),(36,7408751,7408747,'seu',25,1),(36,7408752,7408747,'eud',25,1),(36,7408753,7408747,'udo',25,1),(36,7408754,7408750,'fal',33.333,5),(36,7408755,7408750,'als',33.333,5),(36,7408756,7408750,'lse',33.333,5),(36,7408757,7408754,'sta',25,3),(36,7408758,7408754,'tat',25,3),(36,7408759,7408754,'atu',25,3),(36,7408760,7408754,'tus',25,3),(36,7408761,7408757,'deg',16.667,1),(36,7408762,7408757,'egr',16.667,1),(36,7408763,7408757,'gra',16.667,1),(36,7408764,7408757,'rad',16.667,1),(36,7408765,7408757,'ade',16.667,1),(36,7408766,7408757,'ded',16.667,1),(36,7408767,7408761,'rdm',100,1),(36,7408768,7408767,'cap',20,1),(36,7408769,7408767,'apa',20,1),(36,7408770,7408767,'pab',20,1),(36,7408771,7408767,'abl',20,1),(36,7408772,7408767,'ble',20,1),(36,7408773,7408768,'tru',50,2),(36,7408774,7408768,'rue',50,2),(36,7408775,7408773,'loc',33.333,1),(36,7408776,7408773,'oca',33.333,1),(36,7408777,7408773,'cal',33.333,1),(36,7408778,7408775,'rem',14.286,1),(36,7408779,7408775,'emo',14.286,1),(36,7408780,7408775,'mov',14.286,1),(36,7408781,7408775,'ova',14.286,1),(36,7408782,7408775,'vab',14.286,1),(36,7408783,7408775,'abl',14.286,1),(36,7408784,7408775,'ble',14.286,1),(36,7408785,7408778,'ssd',100,1),(36,7408786,7408785,'off',20,1),(36,7408787,7408785,'ffl',20,1),(36,7408788,7408785,'fli',20,1),(36,7408789,7408785,'lin',20,1),(36,7408790,7408785,'ine',20,1),(36,7408791,7408786,'per',11.111,1),(36,7408792,7408786,'ere',11.111,1),(36,7408793,7408786,'ren',11.111,1),(36,7408794,7408786,'enn',11.111,1),(36,7408795,7408786,'nni',11.111,1),(36,7408796,7408786,'nia',11.111,1),(36,7408797,7408786,'ial',11.111,1),(36,7408798,7408786,'all',11.111,1),(36,7408799,7408786,'lly',11.111,1),(36,7408800,7408791,'res',16.667,1),(36,7408801,7408791,'ese',16.667,1),(36,7408802,7408791,'ser',16.667,1),(36,7408803,7408791,'erv',16.667,1),(36,7408804,7408791,'rve',16.667,1),(36,7408805,7408791,'ved',16.667,1),(36,7408806,7408800,'thi',50,1),(36,7408807,7408800,'hin',50,1),(36,7408808,7408806,'pro',10,1),(36,7408809,7408806,'rov',10,1),(36,7408810,7408806,'ovi',10,1),(36,7408811,7408806,'vis',10,1),(36,7408812,7408806,'isi',10,1),(36,7408813,7408806,'sio',10,1),(36,7408814,7408806,'ion',10,1),(36,7408815,7408806,'oni',10,1),(36,7408816,7408806,'nin',10,1),(36,7408817,7408806,'ing',10,1),(36,7408818,7408808,'unk',20,1),(36,7408819,7408808,'nkn',20,1),(36,7408820,7408808,'kno',20,1),(36,7408821,7408808,'now',20,1),(36,7408822,7408808,'own',20,1),(36,7408823,7408818,'fil',20,1),(36,7408824,7408818,'ilt',20,1),(36,7408825,7408818,'lte',20,1),(36,7408826,7408818,'ter',20,1),(36,7408827,7408818,'ers',20,1),(36,7408828,7408823,'vaa',50,1),(36,7408829,7408823,'aai',50,1),(36,7408830,7408828,'uns',11.111,1),(36,7408831,7408828,'nsu',11.111,1),(36,7408832,7408828,'sup',11.111,1),(36,7408833,7408828,'upp',11.111,1),(36,7408834,7408828,'ppo',11.111,1),(36,7408835,7408828,'por',11.111,1),(36,7408836,7408828,'ort',11.111,1),(36,7408837,7408828,'rte',11.111,1),(36,7408838,7408828,'ted',11.111,1),(36,7408839,7408830,'oth',33.333,1),(36,7408840,7408830,'the',33.333,1),(36,7408841,7408830,'her',33.333,1),(36,7408842,7408839,'uid',50,1),(36,7408843,7408839,'ids',50,1),(36,7408844,7408842,'vml',100,1),(36,7408845,7408844,'dis',20,1),(36,7408846,7408844,'isp',20,1),(36,7408847,7408844,'spl',20,1),(36,7408848,7408844,'pla',20,1),(36,7408849,7408844,'lay',20,1),(36,7408850,7408845,'nam',50,1),(36,7408851,7408845,'ame',50,1),(37,7408853,7408852,'net',25,3),(37,7408854,7408852,'eta',25,3),(37,7408855,7408852,'tap',25,3),(37,7408856,7408852,'app',25,3),(37,7408857,7408853,'ser',25,3),(37,7408858,7408853,'eri',25,3),(37,7408859,7408853,'ria',25,3),(37,7408860,7408853,'ial',25,3),(37,7408861,7408857,'att',16.667,3),(37,7408862,7408857,'tta',16.667,3),(37,7408863,7408857,'tac',16.667,3),(37,7408864,7408857,'ach',16.667,3),(37,7408865,7408857,'che',16.667,3),(37,7408866,7408857,'hed',16.667,3),(37,7408867,7408861,'scs',50,3),(37,7408868,7408861,'csi',50,3),(37,7408869,7408867,'dis',50,2),(37,7408870,7408867,'isk',50,2),(37,7408871,7408869,'naa',100,4),(37,7408872,7408871,'600',3.333,4),(37,7408873,7408871,'00a',3.333,4),(37,7408874,7408871,'0a0',3.333,4),(37,7408875,7408871,'a09',3.333,4),(37,7408876,7408871,'098',3.333,4),(37,7408877,7408871,'980',3.333,4),(37,7408878,7408871,'800',3.333,4),(37,7408879,7408871,'00b',3.333,4),(37,7408880,7408871,'0b5',3.333,4),(37,7408881,7408871,'b56',3.333,4),(37,7408882,7408871,'568',3.333,4),(37,7408883,7408871,'684',3.333,4),(37,7408884,7408871,'84e',3.333,4),(37,7408885,7408871,'4ee',3.333,4),(37,7408886,7408871,'ee5',3.333,4),(37,7408887,7408871,'e5a',3.333,4),(37,7408888,7408871,'5a9',3.333,4),(37,7408889,7408871,'a9d',3.333,4),(37,7408890,7408871,'9d4',3.333,4),(37,7408891,7408871,'d40',3.333,4),(37,7408892,7408871,'401',3.333,4),(37,7408893,7408871,'011',3.333,4),(37,7408894,7408871,'117',3.333,4),(37,7408895,7408871,'17b',3.333,4),(37,7408896,7408871,'7b0',3.333,4),(37,7408897,7408871,'b0a',3.333,4),(37,7408898,7408871,'0aa',3.333,4),(37,7408899,7408871,'aab',3.333,4),(37,7408900,7408871,'aba',3.333,4),(37,7408901,7408871,'ba2',3.333,4),(37,7408902,7408872,'siz',50,1),(37,7408903,7408872,'ize',50,1),(37,7408904,7408902,'163',33.333,1),(37,7408905,7408902,'638',33.333,1),(37,7408906,7408902,'384',33.333,1),(37,7408907,7408904,'dev',25,1),(37,7408908,7408904,'evi',25,1),(37,7408909,7408904,'vic',25,1),(37,7408910,7408904,'ice',25,1),(37,7408911,7408907,'typ',50,1),(37,7408912,7408907,'ype',50,1),(37,7408913,7408911,'dir',10,1),(37,7408914,7408911,'ire',10,1),(37,7408915,7408911,'rec',10,1),(37,7408916,7408911,'ect',10,1),(37,7408917,7408911,'cta',10,1),(37,7408918,7408911,'tac',10,1),(37,7408919,7408911,'acc',10,1),(37,7408920,7408911,'cce',10,1),(37,7408921,7408911,'ces',10,1),(37,7408922,7408911,'ess',10,1),(37,7408923,7408913,'mul',14.286,1),(37,7408924,7408913,'ult',14.286,1),(37,7408925,7408913,'lti',14.286,1),(37,7408926,7408913,'tip',14.286,1),(37,7408927,7408913,'ipa',14.286,1),(37,7408928,7408913,'pat',14.286,1),(37,7408929,7408913,'ath',14.286,1),(37,7408930,7408923,'plu',25,1),(37,7408931,7408923,'lug',25,1),(37,7408932,7408923,'ugi',25,1),(37,7408933,7408923,'gin',25,1),(37,7408934,7408930,'nmp',100,1),(37,7408935,7408934,'dev',33.333,1),(37,7408936,7408934,'evf',33.333,1),(37,7408937,7408934,'vfs',33.333,1),(37,7408938,7408935,'pat',50,1),(37,7408939,7408935,'ath',50,1),(37,7408940,7408938,'vmf',50,1),(37,7408941,7408938,'mfs',50,1),(37,7408942,7408940,'dev',20,1),(37,7408943,7408940,'evi',20,1),(37,7408944,7408940,'vic',20,1),(37,7408945,7408940,'ice',20,1),(37,7408946,7408940,'ces',20,1),(37,7408947,7408942,'dis',33.333,1),(37,7408948,7408942,'isk',33.333,1),(37,7408949,7408942,'sks',33.333,1),(37,7408950,7408947,'ven',25,1),(37,7408951,7408947,'end',25,1),(37,7408952,7408947,'ndo',25,1),(37,7408953,7408947,'dor',25,1),(37,7408954,7408950,'mod',33.333,1),(37,7408955,7408950,'ode',33.333,1),(37,7408956,7408950,'del',33.333,1),(37,7408957,7408954,'fla',33.333,1),(37,7408958,7408954,'las',33.333,1),(37,7408959,7408954,'ash',33.333,1),(37,7408960,7408957,'acc',33.333,1),(37,7408961,7408957,'cce',33.333,1),(37,7408962,7408957,'cel',33.333,1),(37,7408963,7408960,'rev',16.667,1),(37,7408964,7408960,'evi',16.667,1),(37,7408965,7408960,'vis',16.667,1),(37,7408966,7408960,'isi',16.667,1),(37,7408967,7408960,'sio',16.667,1),(37,7408968,7408960,'ion',16.667,1),(37,7408969,7408963,'lev',33.333,1),(37,7408970,7408963,'eve',33.333,1),(37,7408971,7408963,'vel',33.333,1),(37,7408972,7408969,'pse',25,1),(37,7408973,7408969,'seu',25,1),(37,7408974,7408969,'eud',25,1),(37,7408975,7408969,'udo',25,1),(37,7408976,7408972,'fal',33.333,5),(37,7408977,7408972,'als',33.333,5),(37,7408978,7408972,'lse',33.333,5),(37,7408979,7408976,'sta',25,3),(37,7408980,7408976,'tat',25,3),(37,7408981,7408976,'atu',25,3),(37,7408982,7408976,'tus',25,3),(37,7408983,7408979,'deg',16.667,1),(37,7408984,7408979,'egr',16.667,1),(37,7408985,7408979,'gra',16.667,1),(37,7408986,7408979,'rad',16.667,1),(37,7408987,7408979,'ade',16.667,1),(37,7408988,7408979,'ded',16.667,1),(37,7408989,7408983,'rdm',100,1),(37,7408990,7408989,'cap',20,1),(37,7408991,7408989,'apa',20,1),(37,7408992,7408989,'pab',20,1),(37,7408993,7408989,'abl',20,1),(37,7408994,7408989,'ble',20,1),(37,7408995,7408990,'tru',50,2),(37,7408996,7408990,'rue',50,2),(37,7408997,7408995,'loc',33.333,1),(37,7408998,7408995,'oca',33.333,1),(37,7408999,7408995,'cal',33.333,1),(37,7409000,7408997,'rem',14.286,1),(37,7409001,7408997,'emo',14.286,1),(37,7409002,7408997,'mov',14.286,1),(37,7409003,7408997,'ova',14.286,1),(37,7409004,7408997,'vab',14.286,1),(37,7409005,7408997,'abl',14.286,1),(37,7409006,7408997,'ble',14.286,1),(37,7409007,7409000,'ssd',100,1),(37,7409008,7409007,'off',20,1),(37,7409009,7409007,'ffl',20,1),(37,7409010,7409007,'fli',20,1),(37,7409011,7409007,'lin',20,1),(37,7409012,7409007,'ine',20,1),(37,7409013,7409008,'per',11.111,1),(37,7409014,7409008,'ere',11.111,1),(37,7409015,7409008,'ren',11.111,1),(37,7409016,7409008,'enn',11.111,1),(37,7409017,7409008,'nni',11.111,1),(37,7409018,7409008,'nia',11.111,1),(37,7409019,7409008,'ial',11.111,1),(37,7409020,7409008,'all',11.111,1),(37,7409021,7409008,'lly',11.111,1),(37,7409022,7409013,'res',16.667,1),(37,7409023,7409013,'ese',16.667,1),(37,7409024,7409013,'ser',16.667,1),(37,7409025,7409013,'erv',16.667,1),(37,7409026,7409013,'rve',16.667,1),(37,7409027,7409013,'ved',16.667,1),(37,7409028,7409022,'thi',50,1),(37,7409029,7409022,'hin',50,1),(37,7409030,7409028,'pro',10,1),(37,7409031,7409028,'rov',10,1),(37,7409032,7409028,'ovi',10,1),(37,7409033,7409028,'vis',10,1),(37,7409034,7409028,'isi',10,1),(37,7409035,7409028,'sio',10,1),(37,7409036,7409028,'ion',10,1),(37,7409037,7409028,'oni',10,1),(37,7409038,7409028,'nin',10,1),(37,7409039,7409028,'ing',10,1),(37,7409040,7409030,'unk',20,1),(37,7409041,7409030,'nkn',20,1),(37,7409042,7409030,'kno',20,1),(37,7409043,7409030,'now',20,1),(37,7409044,7409030,'own',20,1),(37,7409045,7409040,'fil',20,1),(37,7409046,7409040,'ilt',20,1),(37,7409047,7409040,'lte',20,1),(37,7409048,7409040,'ter',20,1),(37,7409049,7409040,'ers',20,1),(37,7409050,7409045,'vaa',50,1),(37,7409051,7409045,'aai',50,1),(37,7409052,7409050,'uns',11.111,1),(37,7409053,7409050,'nsu',11.111,1),(37,7409054,7409050,'sup',11.111,1),(37,7409055,7409050,'upp',11.111,1),(37,7409056,7409050,'ppo',11.111,1),(37,7409057,7409050,'por',11.111,1),(37,7409058,7409050,'ort',11.111,1),(37,7409059,7409050,'rte',11.111,1),(37,7409060,7409050,'ted',11.111,1),(37,7409061,7409052,'oth',33.333,1),(37,7409062,7409052,'the',33.333,1),(37,7409063,7409052,'her',33.333,1),(37,7409064,7409061,'uid',50,1),(37,7409065,7409061,'ids',50,1),(37,7409066,7409064,'vml',100,1),(37,7409067,7409066,'dis',20,1),(37,7409068,7409066,'isp',20,1),(37,7409069,7409066,'spl',20,1),(37,7409070,7409066,'pla',20,1),(37,7409071,7409066,'lay',20,1),(37,7409072,7409067,'nam',50,1),(37,7409073,7409067,'ame',50,1),(38,7409075,7409074,'net',25,3),(38,7409076,7409074,'eta',25,3),(38,7409077,7409074,'tap',25,3),(38,7409078,7409074,'app',25,3),(38,7409079,7409075,'ser',25,3),(38,7409080,7409075,'eri',25,3),(38,7409081,7409075,'ria',25,3),(38,7409082,7409075,'ial',25,3),(38,7409083,7409079,'att',16.667,3),(38,7409084,7409079,'tta',16.667,3),(38,7409085,7409079,'tac',16.667,3),(38,7409086,7409079,'ach',16.667,3),(38,7409087,7409079,'che',16.667,3),(38,7409088,7409079,'hed',16.667,3),(38,7409089,7409083,'scs',50,3),(38,7409090,7409083,'csi',50,3),(38,7409091,7409089,'dis',50,2),(38,7409092,7409089,'isk',50,2),(38,7409093,7409091,'naa',100,4),(38,7409094,7409093,'600',3.333,4),(38,7409095,7409093,'00a',3.333,4),(38,7409096,7409093,'0a0',3.333,4),(38,7409097,7409093,'a09',3.333,4),(38,7409098,7409093,'098',3.333,4),(38,7409099,7409093,'980',3.333,4),(38,7409100,7409093,'807',3.333,4),(38,7409101,7409093,'072',3.333,4),(38,7409102,7409093,'727',3.333,4),(38,7409103,7409093,'272',3.333,4),(38,7409104,7409093,'728',3.333,4),(38,7409105,7409093,'284',3.333,4),(38,7409106,7409093,'84e',3.333,4),(38,7409107,7409093,'4ee',3.333,4),(38,7409108,7409093,'ee1',3.333,4),(38,7409109,7409093,'e19',3.333,4),(38,7409110,7409093,'193',3.333,4),(38,7409111,7409093,'937',3.333,4),(38,7409112,7409093,'374',3.333,4),(38,7409113,7409093,'742',3.333,4),(38,7409114,7409093,'421',3.333,4),(38,7409115,7409093,'211',3.333,4),(38,7409116,7409093,'117',3.333,4),(38,7409117,7409093,'17b',3.333,4),(38,7409118,7409093,'7b0',3.333,4),(38,7409119,7409093,'b0c',3.333,4),(38,7409120,7409093,'0ca',3.333,4),(38,7409121,7409093,'cab',3.333,4),(38,7409122,7409093,'aba',3.333,4),(38,7409123,7409093,'ba2',3.333,4),(38,7409124,7409094,'siz',50,1),(38,7409125,7409094,'ize',50,1),(38,7409126,7409124,'163',33.333,1),(38,7409127,7409124,'638',33.333,1),(38,7409128,7409124,'384',33.333,1),(38,7409129,7409126,'dev',25,1),(38,7409130,7409126,'evi',25,1),(38,7409131,7409126,'vic',25,1),(38,7409132,7409126,'ice',25,1),(38,7409133,7409129,'typ',50,1),(38,7409134,7409129,'ype',50,1),(38,7409135,7409133,'dir',10,1),(38,7409136,7409133,'ire',10,1),(38,7409137,7409133,'rec',10,1),(38,7409138,7409133,'ect',10,1),(38,7409139,7409133,'cta',10,1),(38,7409140,7409133,'tac',10,1),(38,7409141,7409133,'acc',10,1),(38,7409142,7409133,'cce',10,1),(38,7409143,7409133,'ces',10,1),(38,7409144,7409133,'ess',10,1),(38,7409145,7409135,'mul',14.286,1),(38,7409146,7409135,'ult',14.286,1),(38,7409147,7409135,'lti',14.286,1),(38,7409148,7409135,'tip',14.286,1),(38,7409149,7409135,'ipa',14.286,1),(38,7409150,7409135,'pat',14.286,1),(38,7409151,7409135,'ath',14.286,1),(38,7409152,7409145,'plu',25,1),(38,7409153,7409145,'lug',25,1),(38,7409154,7409145,'ugi',25,1),(38,7409155,7409145,'gin',25,1),(38,7409156,7409152,'nmp',100,1),(38,7409157,7409156,'dev',33.333,1),(38,7409158,7409156,'evf',33.333,1),(38,7409159,7409156,'vfs',33.333,1),(38,7409160,7409157,'pat',50,1),(38,7409161,7409157,'ath',50,1),(38,7409162,7409160,'vmf',50,1),(38,7409163,7409160,'mfs',50,1),(38,7409164,7409162,'dev',20,1),(38,7409165,7409162,'evi',20,1),(38,7409166,7409162,'vic',20,1),(38,7409167,7409162,'ice',20,1),(38,7409168,7409162,'ces',20,1),(38,7409169,7409164,'dis',33.333,1),(38,7409170,7409164,'isk',33.333,1),(38,7409171,7409164,'sks',33.333,1),(38,7409172,7409169,'ven',25,1),(38,7409173,7409169,'end',25,1),(38,7409174,7409169,'ndo',25,1),(38,7409175,7409169,'dor',25,1),(38,7409176,7409172,'mod',33.333,1),(38,7409177,7409172,'ode',33.333,1),(38,7409178,7409172,'del',33.333,1),(38,7409179,7409176,'fla',33.333,1),(38,7409180,7409176,'las',33.333,1),(38,7409181,7409176,'ash',33.333,1),(38,7409182,7409179,'acc',33.333,1),(38,7409183,7409179,'cce',33.333,1),(38,7409184,7409179,'cel',33.333,1),(38,7409185,7409182,'rev',16.667,1),(38,7409186,7409182,'evi',16.667,1),(38,7409187,7409182,'vis',16.667,1),(38,7409188,7409182,'isi',16.667,1),(38,7409189,7409182,'sio',16.667,1),(38,7409190,7409182,'ion',16.667,1),(38,7409191,7409185,'lev',33.333,1),(38,7409192,7409185,'eve',33.333,1),(38,7409193,7409185,'vel',33.333,1),(38,7409194,7409191,'pse',25,1),(38,7409195,7409191,'seu',25,1),(38,7409196,7409191,'eud',25,1),(38,7409197,7409191,'udo',25,1),(38,7409198,7409194,'fal',33.333,5),(38,7409199,7409194,'als',33.333,5),(38,7409200,7409194,'lse',33.333,5),(38,7409201,7409198,'sta',25,3),(38,7409202,7409198,'tat',25,3),(38,7409203,7409198,'atu',25,3),(38,7409204,7409198,'tus',25,3),(38,7409205,7409201,'deg',16.667,1),(38,7409206,7409201,'egr',16.667,1),(38,7409207,7409201,'gra',16.667,1),(38,7409208,7409201,'rad',16.667,1),(38,7409209,7409201,'ade',16.667,1),(38,7409210,7409201,'ded',16.667,1),(38,7409211,7409205,'rdm',100,1),(38,7409212,7409211,'cap',20,1),(38,7409213,7409211,'apa',20,1),(38,7409214,7409211,'pab',20,1),(38,7409215,7409211,'abl',20,1),(38,7409216,7409211,'ble',20,1),(38,7409217,7409212,'tru',50,2),(38,7409218,7409212,'rue',50,2),(38,7409219,7409217,'loc',33.333,1),(38,7409220,7409217,'oca',33.333,1),(38,7409221,7409217,'cal',33.333,1),(38,7409222,7409219,'rem',14.286,1),(38,7409223,7409219,'emo',14.286,1),(38,7409224,7409219,'mov',14.286,1),(38,7409225,7409219,'ova',14.286,1),(38,7409226,7409219,'vab',14.286,1),(38,7409227,7409219,'abl',14.286,1),(38,7409228,7409219,'ble',14.286,1),(38,7409229,7409222,'ssd',100,1),(38,7409230,7409229,'off',20,1),(38,7409231,7409229,'ffl',20,1),(38,7409232,7409229,'fli',20,1),(38,7409233,7409229,'lin',20,1),(38,7409234,7409229,'ine',20,1),(38,7409235,7409230,'per',11.111,1),(38,7409236,7409230,'ere',11.111,1),(38,7409237,7409230,'ren',11.111,1),(38,7409238,7409230,'enn',11.111,1),(38,7409239,7409230,'nni',11.111,1),(38,7409240,7409230,'nia',11.111,1),(38,7409241,7409230,'ial',11.111,1),(38,7409242,7409230,'all',11.111,1),(38,7409243,7409230,'lly',11.111,1),(38,7409244,7409235,'res',16.667,1),(38,7409245,7409235,'ese',16.667,1),(38,7409246,7409235,'ser',16.667,1),(38,7409247,7409235,'erv',16.667,1),(38,7409248,7409235,'rve',16.667,1),(38,7409249,7409235,'ved',16.667,1),(38,7409250,7409244,'thi',50,1),(38,7409251,7409244,'hin',50,1),(38,7409252,7409250,'pro',10,1),(38,7409253,7409250,'rov',10,1),(38,7409254,7409250,'ovi',10,1),(38,7409255,7409250,'vis',10,1),(38,7409256,7409250,'isi',10,1),(38,7409257,7409250,'sio',10,1),(38,7409258,7409250,'ion',10,1),(38,7409259,7409250,'oni',10,1),(38,7409260,7409250,'nin',10,1),(38,7409261,7409250,'ing',10,1),(38,7409262,7409252,'unk',20,1),(38,7409263,7409252,'nkn',20,1),(38,7409264,7409252,'kno',20,1),(38,7409265,7409252,'now',20,1),(38,7409266,7409252,'own',20,1),(38,7409267,7409262,'fil',20,1),(38,7409268,7409262,'ilt',20,1),(38,7409269,7409262,'lte',20,1),(38,7409270,7409262,'ter',20,1),(38,7409271,7409262,'ers',20,1),(38,7409272,7409267,'vaa',50,1),(38,7409273,7409267,'aai',50,1),(38,7409274,7409272,'uns',11.111,1),(38,7409275,7409272,'nsu',11.111,1),(38,7409276,7409272,'sup',11.111,1),(38,7409277,7409272,'upp',11.111,1),(38,7409278,7409272,'ppo',11.111,1),(38,7409279,7409272,'por',11.111,1),(38,7409280,7409272,'ort',11.111,1),(38,7409281,7409272,'rte',11.111,1),(38,7409282,7409272,'ted',11.111,1),(38,7409283,7409274,'oth',33.333,1),(38,7409284,7409274,'the',33.333,1),(38,7409285,7409274,'her',33.333,1),(38,7409286,7409283,'uid',50,1),(38,7409287,7409283,'ids',50,1),(38,7409288,7409286,'vml',100,1),(38,7409289,7409288,'dis',20,1),(38,7409290,7409288,'isp',20,1),(38,7409291,7409288,'spl',20,1),(38,7409292,7409288,'pla',20,1),(38,7409293,7409288,'lay',20,1),(38,7409294,7409289,'nam',50,1),(38,7409295,7409289,'ame',50,1),(39,7409297,7409296,'lsi',100,3),(39,7409298,7409297,'ser',25,3),(39,7409299,7409297,'eri',25,3),(39,7409300,7409297,'ria',25,3),(39,7409301,7409297,'ial',25,3),(39,7409302,7409298,'att',16.667,3),(39,7409303,7409298,'tta',16.667,3),(39,7409304,7409298,'tac',16.667,3),(39,7409305,7409298,'ach',16.667,3),(39,7409306,7409298,'che',16.667,3),(39,7409307,7409298,'hed',16.667,3),(39,7409308,7409302,'scs',50,3),(39,7409309,7409302,'csi',50,3),(39,7409310,7409308,'dis',50,2),(39,7409311,7409308,'isk',50,2),(39,7409312,7409310,'naa',100,4),(39,7409313,7409312,'600',3.333,4),(39,7409314,7409312,'005',3.333,4),(39,7409315,7409312,'050',3.333,4),(39,7409316,7409312,'508',3.333,4),(39,7409317,7409312,'08e',3.333,4),(39,7409318,7409312,'8e0',3.333,4),(39,7409319,7409312,'e07',3.333,4),(39,7409320,7409312,'07e',3.333,4),(39,7409321,7409312,'7e7',3.333,4),(39,7409322,7409312,'e72',3.333,4),(39,7409323,7409312,'726',3.333,4),(39,7409324,7409312,'261',3.333,4),(39,7409325,7409312,'617',3.333,4),(39,7409326,7409312,'177',3.333,4),(39,7409327,7409312,'775',3.333,4),(39,7409328,7409312,'75c',3.333,4),(39,7409329,7409312,'5c3',3.333,4),(39,7409330,7409312,'c39',3.333,4),(39,7409331,7409312,'39b',3.333,4),(39,7409332,7409312,'9bd',3.333,4),(39,7409333,7409312,'bd2',3.333,4),(39,7409334,7409312,'d2e',3.333,4),(39,7409335,7409312,'2eb',3.333,4),(39,7409336,7409312,'eba',3.333,4),(39,7409337,7409312,'bac',3.333,4),(39,7409338,7409312,'ac3',3.333,4),(39,7409339,7409312,'c34',3.333,4),(39,7409340,7409312,'341',3.333,4),(39,7409341,7409312,'410',3.333,4),(39,7409342,7409312,'10f',3.333,4),(39,7409343,7409313,'siz',50,1),(39,7409344,7409313,'ize',50,1),(39,7409345,7409343,'152',20,1),(39,7409346,7409343,'525',20,1),(39,7409347,7409343,'258',20,1),(39,7409348,7409343,'587',20,1),(39,7409349,7409343,'878',20,1),(39,7409350,7409345,'dev',25,1),(39,7409351,7409345,'evi',25,1),(39,7409352,7409345,'vic',25,1),(39,7409353,7409345,'ice',25,1),(39,7409354,7409350,'typ',50,1),(39,7409355,7409350,'ype',50,1),(39,7409356,7409354,'dir',10,1),(39,7409357,7409354,'ire',10,1),(39,7409358,7409354,'rec',10,1),(39,7409359,7409354,'ect',10,1),(39,7409360,7409354,'cta',10,1),(39,7409361,7409354,'tac',10,1),(39,7409362,7409354,'acc',10,1),(39,7409363,7409354,'cce',10,1),(39,7409364,7409354,'ces',10,1),(39,7409365,7409354,'ess',10,1),(39,7409366,7409356,'mul',14.286,1),(39,7409367,7409356,'ult',14.286,1),(39,7409368,7409356,'lti',14.286,1),(39,7409369,7409356,'tip',14.286,1),(39,7409370,7409356,'ipa',14.286,1),(39,7409371,7409356,'pat',14.286,1),(39,7409372,7409356,'ath',14.286,1),(39,7409373,7409366,'plu',25,1),(39,7409374,7409366,'lug',25,1),(39,7409375,7409366,'ugi',25,1),(39,7409376,7409366,'gin',25,1),(39,7409377,7409373,'nmp',100,1),(39,7409378,7409377,'dev',33.333,1),(39,7409379,7409377,'evf',33.333,1),(39,7409380,7409377,'vfs',33.333,1),(39,7409381,7409378,'pat',50,1),(39,7409382,7409378,'ath',50,1),(39,7409383,7409381,'vmf',50,1),(39,7409384,7409381,'mfs',50,1),(39,7409385,7409383,'dev',20,1),(39,7409386,7409383,'evi',20,1),(39,7409387,7409383,'vic',20,1),(39,7409388,7409383,'ice',20,1),(39,7409389,7409383,'ces',20,1),(39,7409390,7409385,'dis',33.333,1),(39,7409391,7409385,'isk',33.333,1),(39,7409392,7409385,'sks',33.333,1),(39,7409393,7409390,'ven',25,1),(39,7409394,7409390,'end',25,1),(39,7409395,7409390,'ndo',25,1),(39,7409396,7409390,'dor',25,1),(39,7409397,7409393,'mod',33.333,1),(39,7409398,7409393,'ode',33.333,1),(39,7409399,7409393,'del',33.333,1),(39,7409400,7409397,'nwd',11.111,1),(39,7409401,7409397,'wdb',11.111,1),(39,7409402,7409397,'dbl',11.111,1),(39,7409403,7409397,'blp',11.111,1),(39,7409404,7409397,'lp4',11.111,1),(39,7409405,7409397,'p41',11.111,1),(39,7409406,7409397,'416',11.111,1),(39,7409407,7409397,'160',11.111,1),(39,7409408,7409397,'600',11.111,1),(39,7409409,7409400,'rev',16.667,1),(39,7409410,7409400,'evi',16.667,1),(39,7409411,7409400,'vis',16.667,1),(39,7409412,7409400,'isi',16.667,1),(39,7409413,7409400,'sio',16.667,1),(39,7409414,7409400,'ion',16.667,1),(39,7409415,7409409,'000',50,1),(39,7409416,7409409,'002',50,1),(39,7409417,7409415,'lev',33.333,1),(39,7409418,7409415,'eve',33.333,1),(39,7409419,7409415,'vel',33.333,1),(39,7409420,7409417,'pse',25,1),(39,7409421,7409417,'seu',25,1),(39,7409422,7409417,'eud',25,1),(39,7409423,7409417,'udo',25,1),(39,7409424,7409420,'fal',33.333,5),(39,7409425,7409420,'als',33.333,5),(39,7409426,7409420,'lse',33.333,5),(39,7409427,7409424,'sta',25,3),(39,7409428,7409424,'tat',25,3),(39,7409429,7409424,'atu',25,3),(39,7409430,7409424,'tus',25,3),(39,7409431,7409427,'deg',16.667,1),(39,7409432,7409427,'egr',16.667,1),(39,7409433,7409427,'gra',16.667,1),(39,7409434,7409427,'rad',16.667,1),(39,7409435,7409427,'ade',16.667,1),(39,7409436,7409427,'ded',16.667,1),(39,7409437,7409431,'rdm',100,1),(39,7409438,7409437,'cap',20,1),(39,7409439,7409437,'apa',20,1),(39,7409440,7409437,'pab',20,1),(39,7409441,7409437,'abl',20,1),(39,7409442,7409437,'ble',20,1),(39,7409443,7409438,'tru',50,2),(39,7409444,7409438,'rue',50,2),(39,7409445,7409443,'loc',33.333,1),(39,7409446,7409443,'oca',33.333,1),(39,7409447,7409443,'cal',33.333,1),(39,7409448,7409445,'rem',14.286,1),(39,7409449,7409445,'emo',14.286,1),(39,7409450,7409445,'mov',14.286,1),(39,7409451,7409445,'ova',14.286,1),(39,7409452,7409445,'vab',14.286,1),(39,7409453,7409445,'abl',14.286,1),(39,7409454,7409445,'ble',14.286,1),(39,7409455,7409448,'ssd',100,1),(39,7409456,7409455,'off',20,1),(39,7409457,7409455,'ffl',20,1),(39,7409458,7409455,'fli',20,1),(39,7409459,7409455,'lin',20,1),(39,7409460,7409455,'ine',20,1),(39,7409461,7409456,'per',11.111,1),(39,7409462,7409456,'ere',11.111,1),(39,7409463,7409456,'ren',11.111,1),(39,7409464,7409456,'enn',11.111,1),(39,7409465,7409456,'nni',11.111,1),(39,7409466,7409456,'nia',11.111,1),(39,7409467,7409456,'ial',11.111,1),(39,7409468,7409456,'all',11.111,1),(39,7409469,7409456,'lly',11.111,1),(39,7409470,7409461,'res',16.667,1),(39,7409471,7409461,'ese',16.667,1),(39,7409472,7409461,'ser',16.667,1),(39,7409473,7409461,'erv',16.667,1),(39,7409474,7409461,'rve',16.667,1),(39,7409475,7409461,'ved',16.667,1),(39,7409476,7409470,'thi',50,1),(39,7409477,7409470,'hin',50,1),(39,7409478,7409476,'pro',10,1),(39,7409479,7409476,'rov',10,1),(39,7409480,7409476,'ovi',10,1),(39,7409481,7409476,'vis',10,1),(39,7409482,7409476,'isi',10,1),(39,7409483,7409476,'sio',10,1),(39,7409484,7409476,'ion',10,1),(39,7409485,7409476,'oni',10,1),(39,7409486,7409476,'nin',10,1),(39,7409487,7409476,'ing',10,1),(39,7409488,7409478,'yes',100,1),(39,7409489,7409488,'fil',20,1),(39,7409490,7409488,'ilt',20,1),(39,7409491,7409488,'lte',20,1),(39,7409492,7409488,'ter',20,1),(39,7409493,7409488,'ers',20,1),(39,7409494,7409489,'vaa',50,1),(39,7409495,7409489,'aai',50,1),(39,7409496,7409494,'unk',20,1),(39,7409497,7409494,'nkn',20,1),(39,7409498,7409494,'kno',20,1),(39,7409499,7409494,'now',20,1),(39,7409500,7409494,'own',20,1),(39,7409501,7409496,'oth',33.333,1),(39,7409502,7409496,'the',33.333,1),(39,7409503,7409496,'her',33.333,1),(39,7409504,7409501,'uid',50,1),(39,7409505,7409501,'ids',50,1),(39,7409506,7409504,'vml',100,1),(39,7409507,7409506,'dis',20,1),(39,7409508,7409506,'isp',20,1),(39,7409509,7409506,'spl',20,1),(39,7409510,7409506,'pla',20,1),(39,7409511,7409506,'lay',20,1),(39,7409512,7409507,'nam',50,1),(39,7409513,7409507,'ame',50,1),(40,7409515,7409514,'net',25,3),(40,7409516,7409514,'eta',25,3),(40,7409517,7409514,'tap',25,3),(40,7409518,7409514,'app',25,3),(40,7409519,7409515,'fib',33.333,2),(40,7409520,7409515,'ibr',33.333,2),(40,7409521,7409515,'bre',33.333,2),(40,7409522,7409519,'cha',20,2),(40,7409523,7409519,'han',20,2),(40,7409524,7409519,'ann',20,2),(40,7409525,7409519,'nne',20,2),(40,7409526,7409519,'nel',20,2),(40,7409527,7409522,'dis',50,2),(40,7409528,7409522,'isk',50,2),(40,7409529,7409527,'naa',100,4),(40,7409530,7409529,'600',3.333,4),(40,7409531,7409529,'00a',3.333,4),(40,7409532,7409529,'0a0',3.333,4),(40,7409533,7409529,'a09',3.333,4),(40,7409534,7409529,'098',3.333,4),(40,7409535,7409529,'980',3.333,4),(40,7409536,7409529,'804',3.333,4),(40,7409537,7409529,'044',3.333,4),(40,7409538,7409529,'443',3.333,4),(40,7409539,7409529,'430',3.333,4),(40,7409540,7409529,'307',3.333,4),(40,7409541,7409529,'072',3.333,4),(40,7409542,7409529,'725',3.333,4),(40,7409543,7409529,'259',3.333,4),(40,7409544,7409529,'593',3.333,4),(40,7409545,7409529,'931',3.333,4),(40,7409546,7409529,'313',3.333,4),(40,7409547,7409529,'13f',3.333,4),(40,7409548,7409529,'3f3',3.333,4),(40,7409549,7409529,'f33',3.333,4),(40,7409550,7409529,'334',3.333,4),(40,7409551,7409529,'345',3.333,4),(40,7409552,7409529,'455',3.333,4),(40,7409553,7409529,'556',3.333,4),(40,7409554,7409529,'563',3.333,4),(40,7409555,7409529,'639',3.333,4),(40,7409556,7409529,'393',3.333,4),(40,7409557,7409529,'934',3.333,4),(40,7409558,7409529,'343',3.333,4),(40,7409559,7409529,'430',3.333,4),(40,7409560,7409530,'ser',25,1),(40,7409561,7409530,'eri',25,1),(40,7409562,7409530,'ria',25,1),(40,7409563,7409530,'ial',25,1),(40,7409564,7409560,'siz',50,1),(40,7409565,7409560,'ize',50,1),(40,7409566,7409564,'460',33.333,1),(40,7409567,7409564,'608',33.333,1),(40,7409568,7409564,'080',33.333,1),(40,7409569,7409566,'dev',25,1),(40,7409570,7409566,'evi',25,1),(40,7409571,7409566,'vic',25,1),(40,7409572,7409566,'ice',25,1),(40,7409573,7409569,'typ',50,1),(40,7409574,7409569,'ype',50,1),(40,7409575,7409573,'dir',10,1),(40,7409576,7409573,'ire',10,1),(40,7409577,7409573,'rec',10,1),(40,7409578,7409573,'ect',10,1),(40,7409579,7409573,'cta',10,1),(40,7409580,7409573,'tac',10,1),(40,7409581,7409573,'acc',10,1),(40,7409582,7409573,'cce',10,1),(40,7409583,7409573,'ces',10,1),(40,7409584,7409573,'ess',10,1),(40,7409585,7409575,'mul',14.286,1),(40,7409586,7409575,'ult',14.286,1),(40,7409587,7409575,'lti',14.286,1),(40,7409588,7409575,'tip',14.286,1),(40,7409589,7409575,'ipa',14.286,1),(40,7409590,7409575,'pat',14.286,1),(40,7409591,7409575,'ath',14.286,1),(40,7409592,7409585,'plu',25,1),(40,7409593,7409585,'lug',25,1),(40,7409594,7409585,'ugi',25,1),(40,7409595,7409585,'gin',25,1),(40,7409596,7409592,'nmp',100,1),(40,7409597,7409596,'dev',33.333,1),(40,7409598,7409596,'evf',33.333,1),(40,7409599,7409596,'vfs',33.333,1),(40,7409600,7409597,'pat',50,1),(40,7409601,7409597,'ath',50,1),(40,7409602,7409600,'vmf',50,1),(40,7409603,7409600,'mfs',50,1),(40,7409604,7409602,'dev',20,1),(40,7409605,7409602,'evi',20,1),(40,7409606,7409602,'vic',20,1),(40,7409607,7409602,'ice',20,1),(40,7409608,7409602,'ces',20,1),(40,7409609,7409604,'dis',33.333,1),(40,7409610,7409604,'isk',33.333,1),(40,7409611,7409604,'sks',33.333,1),(40,7409612,7409609,'ven',25,1),(40,7409613,7409609,'end',25,1),(40,7409614,7409609,'ndo',25,1),(40,7409615,7409609,'dor',25,1),(40,7409616,7409612,'mod',33.333,1),(40,7409617,7409612,'ode',33.333,1),(40,7409618,7409612,'del',33.333,1),(40,7409619,7409616,'lun',100,1),(40,7409620,7409619,'cmo',33.333,1),(40,7409621,7409619,'mod',33.333,1),(40,7409622,7409619,'ode',33.333,1),(40,7409623,7409620,'rev',16.667,1),(40,7409624,7409620,'evi',16.667,1),(40,7409625,7409620,'vis',16.667,1),(40,7409626,7409620,'isi',16.667,1),(40,7409627,7409620,'sio',16.667,1),(40,7409628,7409620,'ion',16.667,1),(40,7409629,7409623,'810',50,1),(40,7409630,7409623,'100',50,1),(40,7409631,7409629,'scs',50,1),(40,7409632,7409629,'csi',50,1),(40,7409633,7409631,'lev',33.333,1),(40,7409634,7409631,'eve',33.333,1),(40,7409635,7409631,'vel',33.333,1),(40,7409636,7409633,'pse',25,1),(40,7409637,7409633,'seu',25,1),(40,7409638,7409633,'eud',25,1),(40,7409639,7409633,'udo',25,1),(40,7409640,7409636,'fal',33.333,6),(40,7409641,7409636,'als',33.333,6),(40,7409642,7409636,'lse',33.333,6),(40,7409643,7409640,'sta',25,3),(40,7409644,7409640,'tat',25,3),(40,7409645,7409640,'atu',25,3),(40,7409646,7409640,'tus',25,3),(40,7409647,7409643,'rdm',100,1),(40,7409648,7409647,'cap',20,1),(40,7409649,7409647,'apa',20,1),(40,7409650,7409647,'pab',20,1),(40,7409651,7409647,'abl',20,1),(40,7409652,7409647,'ble',20,1),(40,7409653,7409648,'tru',50,1),(40,7409654,7409648,'rue',50,1),(40,7409655,7409653,'loc',33.333,1),(40,7409656,7409653,'oca',33.333,1),(40,7409657,7409653,'cal',33.333,1),(40,7409658,7409655,'rem',14.286,1),(40,7409659,7409655,'emo',14.286,1),(40,7409660,7409655,'mov',14.286,1),(40,7409661,7409655,'ova',14.286,1),(40,7409662,7409655,'vab',14.286,1),(40,7409663,7409655,'abl',14.286,1),(40,7409664,7409655,'ble',14.286,1),(40,7409665,7409658,'ssd',100,1),(40,7409666,7409665,'off',20,1),(40,7409667,7409665,'ffl',20,1),(40,7409668,7409665,'fli',20,1),(40,7409669,7409665,'lin',20,1),(40,7409670,7409665,'ine',20,1),(40,7409671,7409666,'per',11.111,1),(40,7409672,7409666,'ere',11.111,1),(40,7409673,7409666,'ren',11.111,1),(40,7409674,7409666,'enn',11.111,1),(40,7409675,7409666,'nni',11.111,1),(40,7409676,7409666,'nia',11.111,1),(40,7409677,7409666,'ial',11.111,1),(40,7409678,7409666,'all',11.111,1),(40,7409679,7409666,'lly',11.111,1),(40,7409680,7409671,'res',16.667,1),(40,7409681,7409671,'ese',16.667,1),(40,7409682,7409671,'ser',16.667,1),(40,7409683,7409671,'erv',16.667,1),(40,7409684,7409671,'rve',16.667,1),(40,7409685,7409671,'ved',16.667,1),(40,7409686,7409680,'thi',50,1),(40,7409687,7409680,'hin',50,1),(40,7409688,7409686,'pro',10,1),(40,7409689,7409686,'rov',10,1),(40,7409690,7409686,'ovi',10,1),(40,7409691,7409686,'vis',10,1),(40,7409692,7409686,'isi',10,1),(40,7409693,7409686,'sio',10,1),(40,7409694,7409686,'ion',10,1),(40,7409695,7409686,'oni',10,1),(40,7409696,7409686,'nin',10,1),(40,7409697,7409686,'ing',10,1),(40,7409698,7409688,'yes',100,1),(40,7409699,7409698,'att',16.667,1),(40,7409700,7409698,'tta',16.667,1),(40,7409701,7409698,'tac',16.667,1),(40,7409702,7409698,'ach',16.667,1),(40,7409703,7409698,'che',16.667,1),(40,7409704,7409698,'hed',16.667,1),(40,7409705,7409699,'fil',20,1),(40,7409706,7409699,'ilt',20,1),(40,7409707,7409699,'lte',20,1),(40,7409708,7409699,'ter',20,1),(40,7409709,7409699,'ers',20,1),(40,7409710,7409705,'vaa',50,1),(40,7409711,7409705,'aai',50,1),(40,7409712,7409710,'unk',20,1),(40,7409713,7409710,'nkn',20,1),(40,7409714,7409710,'kno',20,1),(40,7409715,7409710,'now',20,1),(40,7409716,7409710,'own',20,1),(40,7409717,7409712,'oth',33.333,1),(40,7409718,7409712,'the',33.333,1),(40,7409719,7409712,'her',33.333,1),(40,7409720,7409717,'uid',50,1),(40,7409721,7409717,'ids',50,1),(40,7409722,7409720,'vml',100,1),(40,7409723,7409722,'dis',20,1),(40,7409724,7409722,'isp',20,1),(40,7409725,7409722,'spl',20,1),(40,7409726,7409722,'pla',20,1),(40,7409727,7409722,'lay',20,1),(40,7409728,7409723,'nam',50,1),(40,7409729,7409723,'ame',50,1),(41,7409731,7409730,'net',25,3),(41,7409732,7409730,'eta',25,3),(41,7409733,7409730,'tap',25,3),(41,7409734,7409730,'app',25,3),(41,7409735,7409731,'fib',33.333,2),(41,7409736,7409731,'ibr',33.333,2),(41,7409737,7409731,'bre',33.333,2),(41,7409738,7409735,'cha',20,2),(41,7409739,7409735,'han',20,2),(41,7409740,7409735,'ann',20,2),(41,7409741,7409735,'nne',20,2),(41,7409742,7409735,'nel',20,2),(41,7409743,7409738,'dis',50,2),(41,7409744,7409738,'isk',50,2),(41,7409745,7409743,'naa',100,4),(41,7409746,7409745,'600',3.333,4),(41,7409747,7409745,'00a',3.333,4),(41,7409748,7409745,'0a0',3.333,4),(41,7409749,7409745,'a09',3.333,4),(41,7409750,7409745,'098',3.333,4),(41,7409751,7409745,'980',3.333,4),(41,7409752,7409745,'804',3.333,4),(41,7409753,7409745,'044',3.333,4),(41,7409754,7409745,'443',3.333,4),(41,7409755,7409745,'430',3.333,4),(41,7409756,7409745,'307',3.333,4),(41,7409757,7409745,'072',3.333,4),(41,7409758,7409745,'725',3.333,4),(41,7409759,7409745,'259',3.333,4),(41,7409760,7409745,'593',3.333,4),(41,7409761,7409745,'931',3.333,4),(41,7409762,7409745,'313',3.333,4),(41,7409763,7409745,'13f',3.333,4),(41,7409764,7409745,'3f3',3.333,4),(41,7409765,7409745,'f33',3.333,4),(41,7409766,7409745,'334',3.333,4),(41,7409767,7409745,'345',3.333,4),(41,7409768,7409745,'455',3.333,4),(41,7409769,7409745,'556',3.333,4),(41,7409770,7409745,'563',3.333,4),(41,7409771,7409745,'639',3.333,4),(41,7409772,7409745,'393',3.333,4),(41,7409773,7409745,'934',3.333,4),(41,7409774,7409745,'343',3.333,4),(41,7409775,7409745,'431',3.333,4),(41,7409776,7409746,'ser',25,1),(41,7409777,7409746,'eri',25,1),(41,7409778,7409746,'ria',25,1),(41,7409779,7409746,'ial',25,1),(41,7409780,7409776,'siz',50,1),(41,7409781,7409776,'ize',50,1),(41,7409782,7409780,'460',33.333,1),(41,7409783,7409780,'608',33.333,1),(41,7409784,7409780,'080',33.333,1),(41,7409785,7409782,'dev',25,1),(41,7409786,7409782,'evi',25,1),(41,7409787,7409782,'vic',25,1),(41,7409788,7409782,'ice',25,1),(41,7409789,7409785,'typ',50,1),(41,7409790,7409785,'ype',50,1),(41,7409791,7409789,'dir',10,1),(41,7409792,7409789,'ire',10,1),(41,7409793,7409789,'rec',10,1),(41,7409794,7409789,'ect',10,1),(41,7409795,7409789,'cta',10,1),(41,7409796,7409789,'tac',10,1),(41,7409797,7409789,'acc',10,1),(41,7409798,7409789,'cce',10,1),(41,7409799,7409789,'ces',10,1),(41,7409800,7409789,'ess',10,1),(41,7409801,7409791,'mul',14.286,1),(41,7409802,7409791,'ult',14.286,1),(41,7409803,7409791,'lti',14.286,1),(41,7409804,7409791,'tip',14.286,1),(41,7409805,7409791,'ipa',14.286,1),(41,7409806,7409791,'pat',14.286,1),(41,7409807,7409791,'ath',14.286,1),(41,7409808,7409801,'plu',25,1),(41,7409809,7409801,'lug',25,1),(41,7409810,7409801,'ugi',25,1),(41,7409811,7409801,'gin',25,1),(41,7409812,7409808,'nmp',100,1),(41,7409813,7409812,'dev',33.333,1),(41,7409814,7409812,'evf',33.333,1),(41,7409815,7409812,'vfs',33.333,1),(41,7409816,7409813,'pat',50,1),(41,7409817,7409813,'ath',50,1),(41,7409818,7409816,'vmf',50,1),(41,7409819,7409816,'mfs',50,1),(41,7409820,7409818,'dev',20,1),(41,7409821,7409818,'evi',20,1),(41,7409822,7409818,'vic',20,1),(41,7409823,7409818,'ice',20,1),(41,7409824,7409818,'ces',20,1),(41,7409825,7409820,'dis',33.333,1),(41,7409826,7409820,'isk',33.333,1),(41,7409827,7409820,'sks',33.333,1),(41,7409828,7409825,'ven',25,1),(41,7409829,7409825,'end',25,1),(41,7409830,7409825,'ndo',25,1),(41,7409831,7409825,'dor',25,1),(41,7409832,7409828,'mod',33.333,1),(41,7409833,7409828,'ode',33.333,1),(41,7409834,7409828,'del',33.333,1),(41,7409835,7409832,'lun',100,1),(41,7409836,7409835,'cmo',33.333,1),(41,7409837,7409835,'mod',33.333,1),(41,7409838,7409835,'ode',33.333,1),(41,7409839,7409836,'rev',16.667,1),(41,7409840,7409836,'evi',16.667,1),(41,7409841,7409836,'vis',16.667,1),(41,7409842,7409836,'isi',16.667,1),(41,7409843,7409836,'sio',16.667,1),(41,7409844,7409836,'ion',16.667,1),(41,7409845,7409839,'810',50,1),(41,7409846,7409839,'100',50,1),(41,7409847,7409845,'scs',50,1),(41,7409848,7409845,'csi',50,1),(41,7409849,7409847,'lev',33.333,1),(41,7409850,7409847,'eve',33.333,1),(41,7409851,7409847,'vel',33.333,1),(41,7409852,7409849,'pse',25,1),(41,7409853,7409849,'seu',25,1),(41,7409854,7409849,'eud',25,1),(41,7409855,7409849,'udo',25,1),(41,7409856,7409852,'fal',33.333,6),(41,7409857,7409852,'als',33.333,6),(41,7409858,7409852,'lse',33.333,6),(41,7409859,7409856,'sta',25,3),(41,7409860,7409856,'tat',25,3),(41,7409861,7409856,'atu',25,3),(41,7409862,7409856,'tus',25,3),(41,7409863,7409859,'rdm',100,1),(41,7409864,7409863,'cap',20,1),(41,7409865,7409863,'apa',20,1),(41,7409866,7409863,'pab',20,1),(41,7409867,7409863,'abl',20,1),(41,7409868,7409863,'ble',20,1),(41,7409869,7409864,'tru',50,1),(41,7409870,7409864,'rue',50,1),(41,7409871,7409869,'loc',33.333,1),(41,7409872,7409869,'oca',33.333,1),(41,7409873,7409869,'cal',33.333,1),(41,7409874,7409871,'rem',14.286,1),(41,7409875,7409871,'emo',14.286,1),(41,7409876,7409871,'mov',14.286,1),(41,7409877,7409871,'ova',14.286,1),(41,7409878,7409871,'vab',14.286,1),(41,7409879,7409871,'abl',14.286,1),(41,7409880,7409871,'ble',14.286,1),(41,7409881,7409874,'ssd',100,1),(41,7409882,7409881,'off',20,1),(41,7409883,7409881,'ffl',20,1),(41,7409884,7409881,'fli',20,1),(41,7409885,7409881,'lin',20,1),(41,7409886,7409881,'ine',20,1),(41,7409887,7409882,'per',11.111,1),(41,7409888,7409882,'ere',11.111,1),(41,7409889,7409882,'ren',11.111,1),(41,7409890,7409882,'enn',11.111,1),(41,7409891,7409882,'nni',11.111,1),(41,7409892,7409882,'nia',11.111,1),(41,7409893,7409882,'ial',11.111,1),(41,7409894,7409882,'all',11.111,1),(41,7409895,7409882,'lly',11.111,1),(41,7409896,7409887,'res',16.667,1),(41,7409897,7409887,'ese',16.667,1),(41,7409898,7409887,'ser',16.667,1),(41,7409899,7409887,'erv',16.667,1),(41,7409900,7409887,'rve',16.667,1),(41,7409901,7409887,'ved',16.667,1),(41,7409902,7409896,'thi',50,1),(41,7409903,7409896,'hin',50,1),(41,7409904,7409902,'pro',10,1),(41,7409905,7409902,'rov',10,1),(41,7409906,7409902,'ovi',10,1),(41,7409907,7409902,'vis',10,1),(41,7409908,7409902,'isi',10,1),(41,7409909,7409902,'sio',10,1),(41,7409910,7409902,'ion',10,1),(41,7409911,7409902,'oni',10,1),(41,7409912,7409902,'nin',10,1),(41,7409913,7409902,'ing',10,1),(41,7409914,7409904,'yes',100,1),(41,7409915,7409914,'att',16.667,1),(41,7409916,7409914,'tta',16.667,1),(41,7409917,7409914,'tac',16.667,1),(41,7409918,7409914,'ach',16.667,1),(41,7409919,7409914,'che',16.667,1),(41,7409920,7409914,'hed',16.667,1),(41,7409921,7409915,'fil',20,1),(41,7409922,7409915,'ilt',20,1),(41,7409923,7409915,'lte',20,1),(41,7409924,7409915,'ter',20,1),(41,7409925,7409915,'ers',20,1),(41,7409926,7409921,'vaa',50,1),(41,7409927,7409921,'aai',50,1),(41,7409928,7409926,'unk',20,1),(41,7409929,7409926,'nkn',20,1),(41,7409930,7409926,'kno',20,1),(41,7409931,7409926,'now',20,1),(41,7409932,7409926,'own',20,1),(41,7409933,7409928,'oth',33.333,1),(41,7409934,7409928,'the',33.333,1),(41,7409935,7409928,'her',33.333,1),(41,7409936,7409933,'uid',50,1),(41,7409937,7409933,'ids',50,1),(41,7409938,7409936,'vml',100,1),(41,7409939,7409938,'dis',20,1),(41,7409940,7409938,'isp',20,1),(41,7409941,7409938,'spl',20,1),(41,7409942,7409938,'pla',20,1),(41,7409943,7409938,'lay',20,1),(41,7409944,7409939,'nam',50,1),(41,7409945,7409939,'ame',50,1),(42,7409947,7409946,'net',25,3),(42,7409948,7409946,'eta',25,3),(42,7409949,7409946,'tap',25,3),(42,7409950,7409946,'app',25,3),(42,7409951,7409947,'fib',33.333,2),(42,7409952,7409947,'ibr',33.333,2),(42,7409953,7409947,'bre',33.333,2),(42,7409954,7409951,'cha',20,2),(42,7409955,7409951,'han',20,2),(42,7409956,7409951,'ann',20,2),(42,7409957,7409951,'nne',20,2),(42,7409958,7409951,'nel',20,2),(42,7409959,7409954,'dis',50,2),(42,7409960,7409954,'isk',50,2),(42,7409961,7409959,'naa',100,4),(42,7409962,7409961,'600',3.333,4),(42,7409963,7409961,'00a',3.333,4),(42,7409964,7409961,'0a0',3.333,4),(42,7409965,7409961,'a09',3.333,4),(42,7409966,7409961,'098',3.333,4),(42,7409967,7409961,'980',3.333,4),(42,7409968,7409961,'804',3.333,4),(42,7409969,7409961,'044',3.333,4),(42,7409970,7409961,'443',3.333,4),(42,7409971,7409961,'430',3.333,4),(42,7409972,7409961,'307',3.333,4),(42,7409973,7409961,'072',3.333,4),(42,7409974,7409961,'725',3.333,4),(42,7409975,7409961,'259',3.333,4),(42,7409976,7409961,'593',3.333,4),(42,7409977,7409961,'931',3.333,4),(42,7409978,7409961,'313',3.333,4),(42,7409979,7409961,'13f',3.333,4),(42,7409980,7409961,'3f3',3.333,4),(42,7409981,7409961,'f33',3.333,4),(42,7409982,7409961,'334',3.333,4),(42,7409983,7409961,'345',3.333,4),(42,7409984,7409961,'455',3.333,4),(42,7409985,7409961,'556',3.333,4),(42,7409986,7409961,'563',3.333,4),(42,7409987,7409961,'639',3.333,4),(42,7409988,7409961,'393',3.333,4),(42,7409989,7409961,'934',3.333,4),(42,7409990,7409961,'343',3.333,4),(42,7409991,7409961,'432',3.333,4),(42,7409992,7409962,'ser',25,1),(42,7409993,7409962,'eri',25,1),(42,7409994,7409962,'ria',25,1),(42,7409995,7409962,'ial',25,1),(42,7409996,7409992,'siz',50,1),(42,7409997,7409992,'ize',50,1),(42,7409998,7409996,'460',33.333,1),(42,7409999,7409996,'608',33.333,1),(42,7410000,7409996,'080',33.333,1),(42,7410001,7409998,'dev',25,1),(42,7410002,7409998,'evi',25,1),(42,7410003,7409998,'vic',25,1),(42,7410004,7409998,'ice',25,1),(42,7410005,7410001,'typ',50,1),(42,7410006,7410001,'ype',50,1),(42,7410007,7410005,'dir',10,1),(42,7410008,7410005,'ire',10,1),(42,7410009,7410005,'rec',10,1),(42,7410010,7410005,'ect',10,1),(42,7410011,7410005,'cta',10,1),(42,7410012,7410005,'tac',10,1),(42,7410013,7410005,'acc',10,1),(42,7410014,7410005,'cce',10,1),(42,7410015,7410005,'ces',10,1),(42,7410016,7410005,'ess',10,1),(42,7410017,7410007,'mul',14.286,1),(42,7410018,7410007,'ult',14.286,1),(42,7410019,7410007,'lti',14.286,1),(42,7410020,7410007,'tip',14.286,1),(42,7410021,7410007,'ipa',14.286,1),(42,7410022,7410007,'pat',14.286,1),(42,7410023,7410007,'ath',14.286,1),(42,7410024,7410017,'plu',25,1),(42,7410025,7410017,'lug',25,1),(42,7410026,7410017,'ugi',25,1),(42,7410027,7410017,'gin',25,1),(42,7410028,7410024,'nmp',100,1),(42,7410029,7410028,'dev',33.333,1),(42,7410030,7410028,'evf',33.333,1),(42,7410031,7410028,'vfs',33.333,1),(42,7410032,7410029,'pat',50,1),(42,7410033,7410029,'ath',50,1),(42,7410034,7410032,'vmf',50,1),(42,7410035,7410032,'mfs',50,1),(42,7410036,7410034,'dev',20,1),(42,7410037,7410034,'evi',20,1),(42,7410038,7410034,'vic',20,1),(42,7410039,7410034,'ice',20,1),(42,7410040,7410034,'ces',20,1),(42,7410041,7410036,'dis',33.333,1),(42,7410042,7410036,'isk',33.333,1),(42,7410043,7410036,'sks',33.333,1),(42,7410044,7410041,'ven',25,1),(42,7410045,7410041,'end',25,1),(42,7410046,7410041,'ndo',25,1),(42,7410047,7410041,'dor',25,1),(42,7410048,7410044,'mod',33.333,1),(42,7410049,7410044,'ode',33.333,1),(42,7410050,7410044,'del',33.333,1),(42,7410051,7410048,'lun',100,1),(42,7410052,7410051,'cmo',33.333,1),(42,7410053,7410051,'mod',33.333,1),(42,7410054,7410051,'ode',33.333,1),(42,7410055,7410052,'rev',16.667,1),(42,7410056,7410052,'evi',16.667,1),(42,7410057,7410052,'vis',16.667,1),(42,7410058,7410052,'isi',16.667,1),(42,7410059,7410052,'sio',16.667,1),(42,7410060,7410052,'ion',16.667,1),(42,7410061,7410055,'810',50,1),(42,7410062,7410055,'100',50,1),(42,7410063,7410061,'scs',50,1),(42,7410064,7410061,'csi',50,1),(42,7410065,7410063,'lev',33.333,1),(42,7410066,7410063,'eve',33.333,1),(42,7410067,7410063,'vel',33.333,1),(42,7410068,7410065,'pse',25,1),(42,7410069,7410065,'seu',25,1),(42,7410070,7410065,'eud',25,1),(42,7410071,7410065,'udo',25,1),(42,7410072,7410068,'fal',33.333,6),(42,7410073,7410068,'als',33.333,6),(42,7410074,7410068,'lse',33.333,6),(42,7410075,7410072,'sta',25,3),(42,7410076,7410072,'tat',25,3),(42,7410077,7410072,'atu',25,3),(42,7410078,7410072,'tus',25,3),(42,7410079,7410075,'rdm',100,1),(42,7410080,7410079,'cap',20,1),(42,7410081,7410079,'apa',20,1),(42,7410082,7410079,'pab',20,1),(42,7410083,7410079,'abl',20,1),(42,7410084,7410079,'ble',20,1),(42,7410085,7410080,'tru',50,1),(42,7410086,7410080,'rue',50,1),(42,7410087,7410085,'loc',33.333,1),(42,7410088,7410085,'oca',33.333,1),(42,7410089,7410085,'cal',33.333,1),(42,7410090,7410087,'rem',14.286,1),(42,7410091,7410087,'emo',14.286,1),(42,7410092,7410087,'mov',14.286,1),(42,7410093,7410087,'ova',14.286,1),(42,7410094,7410087,'vab',14.286,1),(42,7410095,7410087,'abl',14.286,1),(42,7410096,7410087,'ble',14.286,1),(42,7410097,7410090,'ssd',100,1),(42,7410098,7410097,'off',20,1),(42,7410099,7410097,'ffl',20,1),(42,7410100,7410097,'fli',20,1),(42,7410101,7410097,'lin',20,1),(42,7410102,7410097,'ine',20,1),(42,7410103,7410098,'per',11.111,1),(42,7410104,7410098,'ere',11.111,1),(42,7410105,7410098,'ren',11.111,1),(42,7410106,7410098,'enn',11.111,1),(42,7410107,7410098,'nni',11.111,1),(42,7410108,7410098,'nia',11.111,1),(42,7410109,7410098,'ial',11.111,1),(42,7410110,7410098,'all',11.111,1),(42,7410111,7410098,'lly',11.111,1),(42,7410112,7410103,'res',16.667,1),(42,7410113,7410103,'ese',16.667,1),(42,7410114,7410103,'ser',16.667,1),(42,7410115,7410103,'erv',16.667,1),(42,7410116,7410103,'rve',16.667,1),(42,7410117,7410103,'ved',16.667,1),(42,7410118,7410112,'thi',50,1),(42,7410119,7410112,'hin',50,1),(42,7410120,7410118,'pro',10,1),(42,7410121,7410118,'rov',10,1),(42,7410122,7410118,'ovi',10,1),(42,7410123,7410118,'vis',10,1),(42,7410124,7410118,'isi',10,1),(42,7410125,7410118,'sio',10,1),(42,7410126,7410118,'ion',10,1),(42,7410127,7410118,'oni',10,1),(42,7410128,7410118,'nin',10,1),(42,7410129,7410118,'ing',10,1),(42,7410130,7410120,'yes',100,1),(42,7410131,7410130,'att',16.667,1),(42,7410132,7410130,'tta',16.667,1),(42,7410133,7410130,'tac',16.667,1),(42,7410134,7410130,'ach',16.667,1),(42,7410135,7410130,'che',16.667,1),(42,7410136,7410130,'hed',16.667,1),(42,7410137,7410131,'fil',20,1),(42,7410138,7410131,'ilt',20,1),(42,7410139,7410131,'lte',20,1),(42,7410140,7410131,'ter',20,1),(42,7410141,7410131,'ers',20,1),(42,7410142,7410137,'vaa',50,1),(42,7410143,7410137,'aai',50,1),(42,7410144,7410142,'unk',20,1),(42,7410145,7410142,'nkn',20,1),(42,7410146,7410142,'kno',20,1),(42,7410147,7410142,'now',20,1),(42,7410148,7410142,'own',20,1),(42,7410149,7410144,'oth',33.333,1),(42,7410150,7410144,'the',33.333,1),(42,7410151,7410144,'her',33.333,1),(42,7410152,7410149,'uid',50,1),(42,7410153,7410149,'ids',50,1),(42,7410154,7410152,'vml',100,1),(42,7410155,7410154,'dis',20,1),(42,7410156,7410154,'isp',20,1),(42,7410157,7410154,'spl',20,1),(42,7410158,7410154,'pla',20,1),(42,7410159,7410154,'lay',20,1),(42,7410160,7410155,'nam',50,1),(42,7410161,7410155,'ame',50,1),(43,7410163,7410162,'net',25,3),(43,7410164,7410162,'eta',25,3),(43,7410165,7410162,'tap',25,3),(43,7410166,7410162,'app',25,3),(43,7410167,7410163,'fib',33.333,2),(43,7410168,7410163,'ibr',33.333,2),(43,7410169,7410163,'bre',33.333,2),(43,7410170,7410167,'cha',20,2),(43,7410171,7410167,'han',20,2),(43,7410172,7410167,'ann',20,2),(43,7410173,7410167,'nne',20,2),(43,7410174,7410167,'nel',20,2),(43,7410175,7410170,'dis',50,2),(43,7410176,7410170,'isk',50,2),(43,7410177,7410175,'naa',100,4),(43,7410178,7410177,'600',3.333,4),(43,7410179,7410177,'00a',3.333,4),(43,7410180,7410177,'0a0',3.333,4),(43,7410181,7410177,'a09',3.333,4),(43,7410182,7410177,'098',3.333,4),(43,7410183,7410177,'980',3.333,4),(43,7410184,7410177,'804',3.333,4),(43,7410185,7410177,'044',3.333,4),(43,7410186,7410177,'443',3.333,4),(43,7410187,7410177,'430',3.333,4),(43,7410188,7410177,'307',3.333,4),(43,7410189,7410177,'072',3.333,4),(43,7410190,7410177,'725',3.333,4),(43,7410191,7410177,'259',3.333,4),(43,7410192,7410177,'593',3.333,4),(43,7410193,7410177,'931',3.333,4),(43,7410194,7410177,'313',3.333,4),(43,7410195,7410177,'13f',3.333,4),(43,7410196,7410177,'3f3',3.333,4),(43,7410197,7410177,'f33',3.333,4),(43,7410198,7410177,'334',3.333,4),(43,7410199,7410177,'345',3.333,4),(43,7410200,7410177,'455',3.333,4),(43,7410201,7410177,'556',3.333,4),(43,7410202,7410177,'563',3.333,4),(43,7410203,7410177,'639',3.333,4),(43,7410204,7410177,'393',3.333,4),(43,7410205,7410177,'934',3.333,4),(43,7410206,7410177,'343',3.333,4),(43,7410207,7410177,'433',3.333,4),(43,7410208,7410178,'ser',25,1),(43,7410209,7410178,'eri',25,1),(43,7410210,7410178,'ria',25,1),(43,7410211,7410178,'ial',25,1),(43,7410212,7410208,'siz',50,1),(43,7410213,7410208,'ize',50,1),(43,7410214,7410212,'460',33.333,1),(43,7410215,7410212,'608',33.333,1),(43,7410216,7410212,'080',33.333,1),(43,7410217,7410214,'dev',25,1),(43,7410218,7410214,'evi',25,1),(43,7410219,7410214,'vic',25,1),(43,7410220,7410214,'ice',25,1),(43,7410221,7410217,'typ',50,1),(43,7410222,7410217,'ype',50,1),(43,7410223,7410221,'dir',10,1),(43,7410224,7410221,'ire',10,1),(43,7410225,7410221,'rec',10,1),(43,7410226,7410221,'ect',10,1),(43,7410227,7410221,'cta',10,1),(43,7410228,7410221,'tac',10,1),(43,7410229,7410221,'acc',10,1),(43,7410230,7410221,'cce',10,1),(43,7410231,7410221,'ces',10,1),(43,7410232,7410221,'ess',10,1),(43,7410233,7410223,'mul',14.286,1),(43,7410234,7410223,'ult',14.286,1),(43,7410235,7410223,'lti',14.286,1),(43,7410236,7410223,'tip',14.286,1),(43,7410237,7410223,'ipa',14.286,1),(43,7410238,7410223,'pat',14.286,1),(43,7410239,7410223,'ath',14.286,1),(43,7410240,7410233,'plu',25,1),(43,7410241,7410233,'lug',25,1),(43,7410242,7410233,'ugi',25,1),(43,7410243,7410233,'gin',25,1),(43,7410244,7410240,'nmp',100,1),(43,7410245,7410244,'dev',33.333,1),(43,7410246,7410244,'evf',33.333,1),(43,7410247,7410244,'vfs',33.333,1),(43,7410248,7410245,'pat',50,1),(43,7410249,7410245,'ath',50,1),(43,7410250,7410248,'vmf',50,1),(43,7410251,7410248,'mfs',50,1),(43,7410252,7410250,'dev',20,1),(43,7410253,7410250,'evi',20,1),(43,7410254,7410250,'vic',20,1),(43,7410255,7410250,'ice',20,1),(43,7410256,7410250,'ces',20,1),(43,7410257,7410252,'dis',33.333,1),(43,7410258,7410252,'isk',33.333,1),(43,7410259,7410252,'sks',33.333,1),(43,7410260,7410257,'ven',25,1),(43,7410261,7410257,'end',25,1),(43,7410262,7410257,'ndo',25,1),(43,7410263,7410257,'dor',25,1),(43,7410264,7410260,'mod',33.333,1),(43,7410265,7410260,'ode',33.333,1),(43,7410266,7410260,'del',33.333,1),(43,7410267,7410264,'lun',100,1),(43,7410268,7410267,'cmo',33.333,1),(43,7410269,7410267,'mod',33.333,1),(43,7410270,7410267,'ode',33.333,1),(43,7410271,7410268,'rev',16.667,1),(43,7410272,7410268,'evi',16.667,1),(43,7410273,7410268,'vis',16.667,1),(43,7410274,7410268,'isi',16.667,1),(43,7410275,7410268,'sio',16.667,1),(43,7410276,7410268,'ion',16.667,1),(43,7410277,7410271,'810',50,1),(43,7410278,7410271,'100',50,1),(43,7410279,7410277,'scs',50,1),(43,7410280,7410277,'csi',50,1),(43,7410281,7410279,'lev',33.333,1),(43,7410282,7410279,'eve',33.333,1),(43,7410283,7410279,'vel',33.333,1),(43,7410284,7410281,'pse',25,1),(43,7410285,7410281,'seu',25,1),(43,7410286,7410281,'eud',25,1),(43,7410287,7410281,'udo',25,1),(43,7410288,7410284,'fal',33.333,6),(43,7410289,7410284,'als',33.333,6),(43,7410290,7410284,'lse',33.333,6),(43,7410291,7410288,'sta',25,3),(43,7410292,7410288,'tat',25,3),(43,7410293,7410288,'atu',25,3),(43,7410294,7410288,'tus',25,3),(43,7410295,7410291,'rdm',100,1),(43,7410296,7410295,'cap',20,1),(43,7410297,7410295,'apa',20,1),(43,7410298,7410295,'pab',20,1),(43,7410299,7410295,'abl',20,1),(43,7410300,7410295,'ble',20,1),(43,7410301,7410296,'tru',50,1),(43,7410302,7410296,'rue',50,1),(43,7410303,7410301,'loc',33.333,1),(43,7410304,7410301,'oca',33.333,1),(43,7410305,7410301,'cal',33.333,1),(43,7410306,7410303,'rem',14.286,1),(43,7410307,7410303,'emo',14.286,1),(43,7410308,7410303,'mov',14.286,1),(43,7410309,7410303,'ova',14.286,1),(43,7410310,7410303,'vab',14.286,1),(43,7410311,7410303,'abl',14.286,1),(43,7410312,7410303,'ble',14.286,1),(43,7410313,7410306,'ssd',100,1),(43,7410314,7410313,'off',20,1),(43,7410315,7410313,'ffl',20,1),(43,7410316,7410313,'fli',20,1),(43,7410317,7410313,'lin',20,1),(43,7410318,7410313,'ine',20,1),(43,7410319,7410314,'per',11.111,1),(43,7410320,7410314,'ere',11.111,1),(43,7410321,7410314,'ren',11.111,1),(43,7410322,7410314,'enn',11.111,1),(43,7410323,7410314,'nni',11.111,1),(43,7410324,7410314,'nia',11.111,1),(43,7410325,7410314,'ial',11.111,1),(43,7410326,7410314,'all',11.111,1),(43,7410327,7410314,'lly',11.111,1),(43,7410328,7410319,'res',16.667,1),(43,7410329,7410319,'ese',16.667,1),(43,7410330,7410319,'ser',16.667,1),(43,7410331,7410319,'erv',16.667,1),(43,7410332,7410319,'rve',16.667,1),(43,7410333,7410319,'ved',16.667,1),(43,7410334,7410328,'thi',50,1),(43,7410335,7410328,'hin',50,1),(43,7410336,7410334,'pro',10,1),(43,7410337,7410334,'rov',10,1),(43,7410338,7410334,'ovi',10,1),(43,7410339,7410334,'vis',10,1),(43,7410340,7410334,'isi',10,1),(43,7410341,7410334,'sio',10,1),(43,7410342,7410334,'ion',10,1),(43,7410343,7410334,'oni',10,1),(43,7410344,7410334,'nin',10,1),(43,7410345,7410334,'ing',10,1),(43,7410346,7410336,'yes',100,1),(43,7410347,7410346,'att',16.667,1),(43,7410348,7410346,'tta',16.667,1),(43,7410349,7410346,'tac',16.667,1),(43,7410350,7410346,'ach',16.667,1),(43,7410351,7410346,'che',16.667,1),(43,7410352,7410346,'hed',16.667,1),(43,7410353,7410347,'fil',20,1),(43,7410354,7410347,'ilt',20,1),(43,7410355,7410347,'lte',20,1),(43,7410356,7410347,'ter',20,1),(43,7410357,7410347,'ers',20,1),(43,7410358,7410353,'vaa',50,1),(43,7410359,7410353,'aai',50,1),(43,7410360,7410358,'unk',20,1),(43,7410361,7410358,'nkn',20,1),(43,7410362,7410358,'kno',20,1),(43,7410363,7410358,'now',20,1),(43,7410364,7410358,'own',20,1),(43,7410365,7410360,'oth',33.333,1),(43,7410366,7410360,'the',33.333,1),(43,7410367,7410360,'her',33.333,1),(43,7410368,7410365,'uid',50,1),(43,7410369,7410365,'ids',50,1),(43,7410370,7410368,'vml',100,1),(43,7410371,7410370,'dis',20,1),(43,7410372,7410370,'isp',20,1),(43,7410373,7410370,'spl',20,1),(43,7410374,7410370,'pla',20,1),(43,7410375,7410370,'lay',20,1),(43,7410376,7410371,'nam',50,1),(43,7410377,7410371,'ame',50,1),(44,7410379,7410378,'net',25,3),(44,7410380,7410378,'eta',25,3),(44,7410381,7410378,'tap',25,3),(44,7410382,7410378,'app',25,3),(44,7410383,7410379,'fib',33.333,2),(44,7410384,7410379,'ibr',33.333,2),(44,7410385,7410379,'bre',33.333,2),(44,7410386,7410383,'cha',20,2),(44,7410387,7410383,'han',20,2),(44,7410388,7410383,'ann',20,2),(44,7410389,7410383,'nne',20,2),(44,7410390,7410383,'nel',20,2),(44,7410391,7410386,'dis',50,2),(44,7410392,7410386,'isk',50,2),(44,7410393,7410391,'naa',100,4),(44,7410394,7410393,'600',3.333,4),(44,7410395,7410393,'00a',3.333,4),(44,7410396,7410393,'0a0',3.333,4),(44,7410397,7410393,'a09',3.333,4),(44,7410398,7410393,'098',3.333,4),(44,7410399,7410393,'980',3.333,4),(44,7410400,7410393,'804',3.333,4),(44,7410401,7410393,'044',3.333,4),(44,7410402,7410393,'443',3.333,4),(44,7410403,7410393,'430',3.333,4),(44,7410404,7410393,'307',3.333,4),(44,7410405,7410393,'072',3.333,4),(44,7410406,7410393,'725',3.333,4),(44,7410407,7410393,'259',3.333,4),(44,7410408,7410393,'593',3.333,4),(44,7410409,7410393,'931',3.333,4),(44,7410410,7410393,'313',3.333,4),(44,7410411,7410393,'13f',3.333,4),(44,7410412,7410393,'3f3',3.333,4),(44,7410413,7410393,'f33',3.333,4),(44,7410414,7410393,'334',3.333,4),(44,7410415,7410393,'345',3.333,4),(44,7410416,7410393,'455',3.333,4),(44,7410417,7410393,'556',3.333,4),(44,7410418,7410393,'563',3.333,4),(44,7410419,7410393,'639',3.333,4),(44,7410420,7410393,'393',3.333,4),(44,7410421,7410393,'934',3.333,4),(44,7410422,7410393,'343',3.333,4),(44,7410423,7410393,'434',3.333,4),(44,7410424,7410394,'ser',25,1),(44,7410425,7410394,'eri',25,1),(44,7410426,7410394,'ria',25,1),(44,7410427,7410394,'ial',25,1),(44,7410428,7410424,'siz',50,1),(44,7410429,7410424,'ize',50,1),(44,7410430,7410428,'460',33.333,1),(44,7410431,7410428,'608',33.333,1),(44,7410432,7410428,'080',33.333,1),(44,7410433,7410430,'dev',25,1),(44,7410434,7410430,'evi',25,1),(44,7410435,7410430,'vic',25,1),(44,7410436,7410430,'ice',25,1),(44,7410437,7410433,'typ',50,1),(44,7410438,7410433,'ype',50,1),(44,7410439,7410437,'dir',10,1),(44,7410440,7410437,'ire',10,1),(44,7410441,7410437,'rec',10,1),(44,7410442,7410437,'ect',10,1),(44,7410443,7410437,'cta',10,1),(44,7410444,7410437,'tac',10,1),(44,7410445,7410437,'acc',10,1),(44,7410446,7410437,'cce',10,1),(44,7410447,7410437,'ces',10,1),(44,7410448,7410437,'ess',10,1),(44,7410449,7410439,'mul',14.286,1),(44,7410450,7410439,'ult',14.286,1),(44,7410451,7410439,'lti',14.286,1),(44,7410452,7410439,'tip',14.286,1),(44,7410453,7410439,'ipa',14.286,1),(44,7410454,7410439,'pat',14.286,1),(44,7410455,7410439,'ath',14.286,1),(44,7410456,7410449,'plu',25,1),(44,7410457,7410449,'lug',25,1),(44,7410458,7410449,'ugi',25,1),(44,7410459,7410449,'gin',25,1),(44,7410460,7410456,'nmp',100,1),(44,7410461,7410460,'dev',33.333,1),(44,7410462,7410460,'evf',33.333,1),(44,7410463,7410460,'vfs',33.333,1),(44,7410464,7410461,'pat',50,1),(44,7410465,7410461,'ath',50,1),(44,7410466,7410464,'vmf',50,1),(44,7410467,7410464,'mfs',50,1),(44,7410468,7410466,'dev',20,1),(44,7410469,7410466,'evi',20,1),(44,7410470,7410466,'vic',20,1),(44,7410471,7410466,'ice',20,1),(44,7410472,7410466,'ces',20,1),(44,7410473,7410468,'dis',33.333,1),(44,7410474,7410468,'isk',33.333,1),(44,7410475,7410468,'sks',33.333,1),(44,7410476,7410473,'ven',25,1),(44,7410477,7410473,'end',25,1),(44,7410478,7410473,'ndo',25,1),(44,7410479,7410473,'dor',25,1),(44,7410480,7410476,'mod',33.333,1),(44,7410481,7410476,'ode',33.333,1),(44,7410482,7410476,'del',33.333,1),(44,7410483,7410480,'lun',100,1),(44,7410484,7410483,'cmo',33.333,1),(44,7410485,7410483,'mod',33.333,1),(44,7410486,7410483,'ode',33.333,1),(44,7410487,7410484,'rev',16.667,1),(44,7410488,7410484,'evi',16.667,1),(44,7410489,7410484,'vis',16.667,1),(44,7410490,7410484,'isi',16.667,1),(44,7410491,7410484,'sio',16.667,1),(44,7410492,7410484,'ion',16.667,1),(44,7410493,7410487,'810',50,1),(44,7410494,7410487,'100',50,1),(44,7410495,7410493,'scs',50,1),(44,7410496,7410493,'csi',50,1),(44,7410497,7410495,'lev',33.333,1),(44,7410498,7410495,'eve',33.333,1),(44,7410499,7410495,'vel',33.333,1),(44,7410500,7410497,'pse',25,1),(44,7410501,7410497,'seu',25,1),(44,7410502,7410497,'eud',25,1),(44,7410503,7410497,'udo',25,1),(44,7410504,7410500,'fal',33.333,6),(44,7410505,7410500,'als',33.333,6),(44,7410506,7410500,'lse',33.333,6),(44,7410507,7410504,'sta',25,3),(44,7410508,7410504,'tat',25,3),(44,7410509,7410504,'atu',25,3),(44,7410510,7410504,'tus',25,3),(44,7410511,7410507,'rdm',100,1),(44,7410512,7410511,'cap',20,1),(44,7410513,7410511,'apa',20,1),(44,7410514,7410511,'pab',20,1),(44,7410515,7410511,'abl',20,1),(44,7410516,7410511,'ble',20,1),(44,7410517,7410512,'tru',50,1),(44,7410518,7410512,'rue',50,1),(44,7410519,7410517,'loc',33.333,1),(44,7410520,7410517,'oca',33.333,1),(44,7410521,7410517,'cal',33.333,1),(44,7410522,7410519,'rem',14.286,1),(44,7410523,7410519,'emo',14.286,1),(44,7410524,7410519,'mov',14.286,1),(44,7410525,7410519,'ova',14.286,1),(44,7410526,7410519,'vab',14.286,1),(44,7410527,7410519,'abl',14.286,1),(44,7410528,7410519,'ble',14.286,1),(44,7410529,7410522,'ssd',100,1),(44,7410530,7410529,'off',20,1),(44,7410531,7410529,'ffl',20,1),(44,7410532,7410529,'fli',20,1),(44,7410533,7410529,'lin',20,1),(44,7410534,7410529,'ine',20,1),(44,7410535,7410530,'per',11.111,1),(44,7410536,7410530,'ere',11.111,1),(44,7410537,7410530,'ren',11.111,1),(44,7410538,7410530,'enn',11.111,1),(44,7410539,7410530,'nni',11.111,1),(44,7410540,7410530,'nia',11.111,1),(44,7410541,7410530,'ial',11.111,1),(44,7410542,7410530,'all',11.111,1),(44,7410543,7410530,'lly',11.111,1),(44,7410544,7410535,'res',16.667,1),(44,7410545,7410535,'ese',16.667,1),(44,7410546,7410535,'ser',16.667,1),(44,7410547,7410535,'erv',16.667,1),(44,7410548,7410535,'rve',16.667,1),(44,7410549,7410535,'ved',16.667,1),(44,7410550,7410544,'thi',50,1),(44,7410551,7410544,'hin',50,1),(44,7410552,7410550,'pro',10,1),(44,7410553,7410550,'rov',10,1),(44,7410554,7410550,'ovi',10,1),(44,7410555,7410550,'vis',10,1),(44,7410556,7410550,'isi',10,1),(44,7410557,7410550,'sio',10,1),(44,7410558,7410550,'ion',10,1),(44,7410559,7410550,'oni',10,1),(44,7410560,7410550,'nin',10,1),(44,7410561,7410550,'ing',10,1),(44,7410562,7410552,'yes',100,1),(44,7410563,7410562,'att',16.667,1),(44,7410564,7410562,'tta',16.667,1),(44,7410565,7410562,'tac',16.667,1),(44,7410566,7410562,'ach',16.667,1),(44,7410567,7410562,'che',16.667,1),(44,7410568,7410562,'hed',16.667,1),(44,7410569,7410563,'fil',20,1),(44,7410570,7410563,'ilt',20,1),(44,7410571,7410563,'lte',20,1),(44,7410572,7410563,'ter',20,1),(44,7410573,7410563,'ers',20,1),(44,7410574,7410569,'vaa',50,1),(44,7410575,7410569,'aai',50,1),(44,7410576,7410574,'unk',20,1),(44,7410577,7410574,'nkn',20,1),(44,7410578,7410574,'kno',20,1),(44,7410579,7410574,'now',20,1),(44,7410580,7410574,'own',20,1),(44,7410581,7410576,'oth',33.333,1),(44,7410582,7410576,'the',33.333,1),(44,7410583,7410576,'her',33.333,1),(44,7410584,7410581,'uid',50,1),(44,7410585,7410581,'ids',50,1),(44,7410586,7410584,'vml',100,1),(44,7410587,7410586,'dis',20,1),(44,7410588,7410586,'isp',20,1),(44,7410589,7410586,'spl',20,1),(44,7410590,7410586,'pla',20,1),(44,7410591,7410586,'lay',20,1),(44,7410592,7410587,'nam',50,1),(44,7410593,7410587,'ame',50,1),(45,7410595,7410594,'net',25,3),(45,7410596,7410594,'eta',25,3),(45,7410597,7410594,'tap',25,3),(45,7410598,7410594,'app',25,3),(45,7410599,7410595,'fib',33.333,2),(45,7410600,7410595,'ibr',33.333,2),(45,7410601,7410595,'bre',33.333,2),(45,7410602,7410599,'cha',20,2),(45,7410603,7410599,'han',20,2),(45,7410604,7410599,'ann',20,2),(45,7410605,7410599,'nne',20,2),(45,7410606,7410599,'nel',20,2),(45,7410607,7410602,'dis',50,2),(45,7410608,7410602,'isk',50,2),(45,7410609,7410607,'naa',100,4),(45,7410610,7410609,'600',3.333,4),(45,7410611,7410609,'00a',3.333,4),(45,7410612,7410609,'0a0',3.333,4),(45,7410613,7410609,'a09',3.333,4),(45,7410614,7410609,'098',3.333,4),(45,7410615,7410609,'980',3.333,4),(45,7410616,7410609,'804',3.333,4),(45,7410617,7410609,'044',3.333,4),(45,7410618,7410609,'443',3.333,4),(45,7410619,7410609,'430',3.333,4),(45,7410620,7410609,'307',3.333,4),(45,7410621,7410609,'072',3.333,4),(45,7410622,7410609,'725',3.333,4),(45,7410623,7410609,'259',3.333,4),(45,7410624,7410609,'593',3.333,4),(45,7410625,7410609,'931',3.333,4),(45,7410626,7410609,'313',3.333,4),(45,7410627,7410609,'13f',3.333,4),(45,7410628,7410609,'3f3',3.333,4),(45,7410629,7410609,'f33',3.333,4),(45,7410630,7410609,'334',3.333,4),(45,7410631,7410609,'345',3.333,4),(45,7410632,7410609,'455',3.333,4),(45,7410633,7410609,'556',3.333,4),(45,7410634,7410609,'563',3.333,4),(45,7410635,7410609,'639',3.333,4),(45,7410636,7410609,'393',3.333,4),(45,7410637,7410609,'934',3.333,4),(45,7410638,7410609,'343',3.333,4),(45,7410639,7410609,'435',3.333,4),(45,7410640,7410610,'ser',25,1),(45,7410641,7410610,'eri',25,1),(45,7410642,7410610,'ria',25,1),(45,7410643,7410610,'ial',25,1),(45,7410644,7410640,'siz',50,1),(45,7410645,7410640,'ize',50,1),(45,7410646,7410644,'321',100,1),(45,7410647,7410646,'dev',25,1),(45,7410648,7410646,'evi',25,1),(45,7410649,7410646,'vic',25,1),(45,7410650,7410646,'ice',25,1),(45,7410651,7410647,'typ',50,1),(45,7410652,7410647,'ype',50,1),(45,7410653,7410651,'dir',10,1),(45,7410654,7410651,'ire',10,1),(45,7410655,7410651,'rec',10,1),(45,7410656,7410651,'ect',10,1),(45,7410657,7410651,'cta',10,1),(45,7410658,7410651,'tac',10,1),(45,7410659,7410651,'acc',10,1),(45,7410660,7410651,'cce',10,1),(45,7410661,7410651,'ces',10,1),(45,7410662,7410651,'ess',10,1),(45,7410663,7410653,'mul',14.286,1),(45,7410664,7410653,'ult',14.286,1),(45,7410665,7410653,'lti',14.286,1),(45,7410666,7410653,'tip',14.286,1),(45,7410667,7410653,'ipa',14.286,1),(45,7410668,7410653,'pat',14.286,1),(45,7410669,7410653,'ath',14.286,1),(45,7410670,7410663,'plu',25,1),(45,7410671,7410663,'lug',25,1),(45,7410672,7410663,'ugi',25,1),(45,7410673,7410663,'gin',25,1),(45,7410674,7410670,'nmp',100,1),(45,7410675,7410674,'dev',33.333,1),(45,7410676,7410674,'evf',33.333,1),(45,7410677,7410674,'vfs',33.333,1),(45,7410678,7410675,'pat',50,1),(45,7410679,7410675,'ath',50,1),(45,7410680,7410678,'vmf',50,1),(45,7410681,7410678,'mfs',50,1),(45,7410682,7410680,'dev',20,1),(45,7410683,7410680,'evi',20,1),(45,7410684,7410680,'vic',20,1),(45,7410685,7410680,'ice',20,1),(45,7410686,7410680,'ces',20,1),(45,7410687,7410682,'dis',33.333,1),(45,7410688,7410682,'isk',33.333,1),(45,7410689,7410682,'sks',33.333,1),(45,7410690,7410687,'ven',25,1),(45,7410691,7410687,'end',25,1),(45,7410692,7410687,'ndo',25,1),(45,7410693,7410687,'dor',25,1),(45,7410694,7410690,'mod',33.333,1),(45,7410695,7410690,'ode',33.333,1),(45,7410696,7410690,'del',33.333,1),(45,7410697,7410694,'lun',100,1),(45,7410698,7410697,'cmo',33.333,1),(45,7410699,7410697,'mod',33.333,1),(45,7410700,7410697,'ode',33.333,1),(45,7410701,7410698,'rev',16.667,1),(45,7410702,7410698,'evi',16.667,1),(45,7410703,7410698,'vis',16.667,1),(45,7410704,7410698,'isi',16.667,1),(45,7410705,7410698,'sio',16.667,1),(45,7410706,7410698,'ion',16.667,1),(45,7410707,7410701,'810',50,1),(45,7410708,7410701,'100',50,1),(45,7410709,7410707,'scs',50,1),(45,7410710,7410707,'csi',50,1),(45,7410711,7410709,'lev',33.333,1),(45,7410712,7410709,'eve',33.333,1),(45,7410713,7410709,'vel',33.333,1),(45,7410714,7410711,'pse',25,1),(45,7410715,7410711,'seu',25,1),(45,7410716,7410711,'eud',25,1),(45,7410717,7410711,'udo',25,1),(45,7410718,7410714,'fal',33.333,6),(45,7410719,7410714,'als',33.333,6),(45,7410720,7410714,'lse',33.333,6),(45,7410721,7410718,'sta',25,3),(45,7410722,7410718,'tat',25,3),(45,7410723,7410718,'atu',25,3),(45,7410724,7410718,'tus',25,3),(45,7410725,7410721,'rdm',100,1),(45,7410726,7410725,'cap',20,1),(45,7410727,7410725,'apa',20,1),(45,7410728,7410725,'pab',20,1),(45,7410729,7410725,'abl',20,1),(45,7410730,7410725,'ble',20,1),(45,7410731,7410726,'tru',50,1),(45,7410732,7410726,'rue',50,1),(45,7410733,7410731,'loc',33.333,1),(45,7410734,7410731,'oca',33.333,1),(45,7410735,7410731,'cal',33.333,1),(45,7410736,7410733,'rem',14.286,1),(45,7410737,7410733,'emo',14.286,1),(45,7410738,7410733,'mov',14.286,1),(45,7410739,7410733,'ova',14.286,1),(45,7410740,7410733,'vab',14.286,1),(45,7410741,7410733,'abl',14.286,1),(45,7410742,7410733,'ble',14.286,1),(45,7410743,7410736,'ssd',100,1),(45,7410744,7410743,'off',20,1),(45,7410745,7410743,'ffl',20,1),(45,7410746,7410743,'fli',20,1),(45,7410747,7410743,'lin',20,1),(45,7410748,7410743,'ine',20,1),(45,7410749,7410744,'per',11.111,1),(45,7410750,7410744,'ere',11.111,1),(45,7410751,7410744,'ren',11.111,1),(45,7410752,7410744,'enn',11.111,1),(45,7410753,7410744,'nni',11.111,1),(45,7410754,7410744,'nia',11.111,1),(45,7410755,7410744,'ial',11.111,1),(45,7410756,7410744,'all',11.111,1),(45,7410757,7410744,'lly',11.111,1),(45,7410758,7410749,'res',16.667,1),(45,7410759,7410749,'ese',16.667,1),(45,7410760,7410749,'ser',16.667,1),(45,7410761,7410749,'erv',16.667,1),(45,7410762,7410749,'rve',16.667,1),(45,7410763,7410749,'ved',16.667,1),(45,7410764,7410758,'thi',50,1),(45,7410765,7410758,'hin',50,1),(45,7410766,7410764,'pro',10,1),(45,7410767,7410764,'rov',10,1),(45,7410768,7410764,'ovi',10,1),(45,7410769,7410764,'vis',10,1),(45,7410770,7410764,'isi',10,1),(45,7410771,7410764,'sio',10,1),(45,7410772,7410764,'ion',10,1),(45,7410773,7410764,'oni',10,1),(45,7410774,7410764,'nin',10,1),(45,7410775,7410764,'ing',10,1),(45,7410776,7410766,'yes',100,1),(45,7410777,7410776,'att',16.667,1),(45,7410778,7410776,'tta',16.667,1),(45,7410779,7410776,'tac',16.667,1),(45,7410780,7410776,'ach',16.667,1),(45,7410781,7410776,'che',16.667,1),(45,7410782,7410776,'hed',16.667,1),(45,7410783,7410777,'fil',20,1),(45,7410784,7410777,'ilt',20,1),(45,7410785,7410777,'lte',20,1),(45,7410786,7410777,'ter',20,1),(45,7410787,7410777,'ers',20,1),(45,7410788,7410783,'vaa',50,1),(45,7410789,7410783,'aai',50,1),(45,7410790,7410788,'unk',20,1),(45,7410791,7410788,'nkn',20,1),(45,7410792,7410788,'kno',20,1),(45,7410793,7410788,'now',20,1),(45,7410794,7410788,'own',20,1),(45,7410795,7410790,'oth',33.333,1),(45,7410796,7410790,'the',33.333,1),(45,7410797,7410790,'her',33.333,1),(45,7410798,7410795,'uid',50,1),(45,7410799,7410795,'ids',50,1),(45,7410800,7410798,'vml',100,1),(45,7410801,7410800,'dis',20,1),(45,7410802,7410800,'isp',20,1),(45,7410803,7410800,'spl',20,1),(45,7410804,7410800,'pla',20,1),(45,7410805,7410800,'lay',20,1),(45,7410806,7410801,'nam',50,1),(45,7410807,7410801,'ame',50,1),(46,7410809,7410808,'net',25,3),(46,7410810,7410808,'eta',25,3),(46,7410811,7410808,'tap',25,3),(46,7410812,7410808,'app',25,3),(46,7410813,7410809,'fib',33.333,2),(46,7410814,7410809,'ibr',33.333,2),(46,7410815,7410809,'bre',33.333,2),(46,7410816,7410813,'cha',20,2),(46,7410817,7410813,'han',20,2),(46,7410818,7410813,'ann',20,2),(46,7410819,7410813,'nne',20,2),(46,7410820,7410813,'nel',20,2),(46,7410821,7410816,'dis',50,2),(46,7410822,7410816,'isk',50,2),(46,7410823,7410821,'naa',100,4),(46,7410824,7410823,'600',3.333,4),(46,7410825,7410823,'00a',3.333,4),(46,7410826,7410823,'0a0',3.333,4),(46,7410827,7410823,'a09',3.333,4),(46,7410828,7410823,'098',3.333,4),(46,7410829,7410823,'980',3.333,4),(46,7410830,7410823,'804',3.333,4),(46,7410831,7410823,'044',3.333,4),(46,7410832,7410823,'443',3.333,4),(46,7410833,7410823,'430',3.333,4),(46,7410834,7410823,'307',3.333,4),(46,7410835,7410823,'072',3.333,4),(46,7410836,7410823,'725',3.333,4),(46,7410837,7410823,'259',3.333,4),(46,7410838,7410823,'593',3.333,4),(46,7410839,7410823,'931',3.333,4),(46,7410840,7410823,'313',3.333,4),(46,7410841,7410823,'13f',3.333,4),(46,7410842,7410823,'3f3',3.333,4),(46,7410843,7410823,'f33',3.333,4),(46,7410844,7410823,'334',3.333,4),(46,7410845,7410823,'345',3.333,4),(46,7410846,7410823,'455',3.333,4),(46,7410847,7410823,'556',3.333,4),(46,7410848,7410823,'563',3.333,4),(46,7410849,7410823,'639',3.333,4),(46,7410850,7410823,'393',3.333,4),(46,7410851,7410823,'934',3.333,4),(46,7410852,7410823,'343',3.333,4),(46,7410853,7410823,'436',3.333,4),(46,7410854,7410824,'ser',25,1),(46,7410855,7410824,'eri',25,1),(46,7410856,7410824,'ria',25,1),(46,7410857,7410824,'ial',25,1),(46,7410858,7410854,'siz',50,1),(46,7410859,7410854,'ize',50,1),(46,7410860,7410858,'321',100,1),(46,7410861,7410860,'dev',25,1),(46,7410862,7410860,'evi',25,1),(46,7410863,7410860,'vic',25,1),(46,7410864,7410860,'ice',25,1),(46,7410865,7410861,'typ',50,1),(46,7410866,7410861,'ype',50,1),(46,7410867,7410865,'dir',10,1),(46,7410868,7410865,'ire',10,1),(46,7410869,7410865,'rec',10,1),(46,7410870,7410865,'ect',10,1),(46,7410871,7410865,'cta',10,1),(46,7410872,7410865,'tac',10,1),(46,7410873,7410865,'acc',10,1),(46,7410874,7410865,'cce',10,1),(46,7410875,7410865,'ces',10,1),(46,7410876,7410865,'ess',10,1),(46,7410877,7410867,'mul',14.286,1),(46,7410878,7410867,'ult',14.286,1),(46,7410879,7410867,'lti',14.286,1),(46,7410880,7410867,'tip',14.286,1),(46,7410881,7410867,'ipa',14.286,1),(46,7410882,7410867,'pat',14.286,1),(46,7410883,7410867,'ath',14.286,1),(46,7410884,7410877,'plu',25,1),(46,7410885,7410877,'lug',25,1),(46,7410886,7410877,'ugi',25,1),(46,7410887,7410877,'gin',25,1),(46,7410888,7410884,'nmp',100,1),(46,7410889,7410888,'dev',33.333,1),(46,7410890,7410888,'evf',33.333,1),(46,7410891,7410888,'vfs',33.333,1),(46,7410892,7410889,'pat',50,1),(46,7410893,7410889,'ath',50,1),(46,7410894,7410892,'vmf',50,1),(46,7410895,7410892,'mfs',50,1),(46,7410896,7410894,'dev',20,1),(46,7410897,7410894,'evi',20,1),(46,7410898,7410894,'vic',20,1),(46,7410899,7410894,'ice',20,1),(46,7410900,7410894,'ces',20,1),(46,7410901,7410896,'dis',33.333,1),(46,7410902,7410896,'isk',33.333,1),(46,7410903,7410896,'sks',33.333,1),(46,7410904,7410901,'ven',25,1),(46,7410905,7410901,'end',25,1),(46,7410906,7410901,'ndo',25,1),(46,7410907,7410901,'dor',25,1),(46,7410908,7410904,'mod',33.333,1),(46,7410909,7410904,'ode',33.333,1),(46,7410910,7410904,'del',33.333,1),(46,7410911,7410908,'lun',100,1),(46,7410912,7410911,'cmo',33.333,1),(46,7410913,7410911,'mod',33.333,1),(46,7410914,7410911,'ode',33.333,1),(46,7410915,7410912,'rev',16.667,1),(46,7410916,7410912,'evi',16.667,1),(46,7410917,7410912,'vis',16.667,1),(46,7410918,7410912,'isi',16.667,1),(46,7410919,7410912,'sio',16.667,1),(46,7410920,7410912,'ion',16.667,1),(46,7410921,7410915,'810',50,1),(46,7410922,7410915,'100',50,1),(46,7410923,7410921,'scs',50,1),(46,7410924,7410921,'csi',50,1),(46,7410925,7410923,'lev',33.333,1),(46,7410926,7410923,'eve',33.333,1),(46,7410927,7410923,'vel',33.333,1),(46,7410928,7410925,'pse',25,1),(46,7410929,7410925,'seu',25,1),(46,7410930,7410925,'eud',25,1),(46,7410931,7410925,'udo',25,1),(46,7410932,7410928,'fal',33.333,6),(46,7410933,7410928,'als',33.333,6),(46,7410934,7410928,'lse',33.333,6),(46,7410935,7410932,'sta',25,3),(46,7410936,7410932,'tat',25,3),(46,7410937,7410932,'atu',25,3),(46,7410938,7410932,'tus',25,3),(46,7410939,7410935,'rdm',100,1),(46,7410940,7410939,'cap',20,1),(46,7410941,7410939,'apa',20,1),(46,7410942,7410939,'pab',20,1),(46,7410943,7410939,'abl',20,1),(46,7410944,7410939,'ble',20,1),(46,7410945,7410940,'tru',50,1),(46,7410946,7410940,'rue',50,1),(46,7410947,7410945,'loc',33.333,1),(46,7410948,7410945,'oca',33.333,1),(46,7410949,7410945,'cal',33.333,1),(46,7410950,7410947,'rem',14.286,1),(46,7410951,7410947,'emo',14.286,1),(46,7410952,7410947,'mov',14.286,1),(46,7410953,7410947,'ova',14.286,1),(46,7410954,7410947,'vab',14.286,1),(46,7410955,7410947,'abl',14.286,1),(46,7410956,7410947,'ble',14.286,1),(46,7410957,7410950,'ssd',100,1),(46,7410958,7410957,'off',20,1),(46,7410959,7410957,'ffl',20,1),(46,7410960,7410957,'fli',20,1),(46,7410961,7410957,'lin',20,1),(46,7410962,7410957,'ine',20,1),(46,7410963,7410958,'per',11.111,1),(46,7410964,7410958,'ere',11.111,1),(46,7410965,7410958,'ren',11.111,1),(46,7410966,7410958,'enn',11.111,1),(46,7410967,7410958,'nni',11.111,1),(46,7410968,7410958,'nia',11.111,1),(46,7410969,7410958,'ial',11.111,1),(46,7410970,7410958,'all',11.111,1),(46,7410971,7410958,'lly',11.111,1),(46,7410972,7410963,'res',16.667,1),(46,7410973,7410963,'ese',16.667,1),(46,7410974,7410963,'ser',16.667,1),(46,7410975,7410963,'erv',16.667,1),(46,7410976,7410963,'rve',16.667,1),(46,7410977,7410963,'ved',16.667,1),(46,7410978,7410972,'thi',50,1),(46,7410979,7410972,'hin',50,1),(46,7410980,7410978,'pro',10,1),(46,7410981,7410978,'rov',10,1),(46,7410982,7410978,'ovi',10,1),(46,7410983,7410978,'vis',10,1),(46,7410984,7410978,'isi',10,1),(46,7410985,7410978,'sio',10,1),(46,7410986,7410978,'ion',10,1),(46,7410987,7410978,'oni',10,1),(46,7410988,7410978,'nin',10,1),(46,7410989,7410978,'ing',10,1),(46,7410990,7410980,'yes',100,1),(46,7410991,7410990,'att',16.667,1),(46,7410992,7410990,'tta',16.667,1),(46,7410993,7410990,'tac',16.667,1),(46,7410994,7410990,'ach',16.667,1),(46,7410995,7410990,'che',16.667,1),(46,7410996,7410990,'hed',16.667,1),(46,7410997,7410991,'fil',20,1),(46,7410998,7410991,'ilt',20,1),(46,7410999,7410991,'lte',20,1),(46,7411000,7410991,'ter',20,1),(46,7411001,7410991,'ers',20,1),(46,7411002,7410997,'vaa',50,1),(46,7411003,7410997,'aai',50,1),(46,7411004,7411002,'unk',20,1),(46,7411005,7411002,'nkn',20,1),(46,7411006,7411002,'kno',20,1),(46,7411007,7411002,'now',20,1),(46,7411008,7411002,'own',20,1),(46,7411009,7411004,'oth',33.333,1),(46,7411010,7411004,'the',33.333,1),(46,7411011,7411004,'her',33.333,1),(46,7411012,7411009,'uid',50,1),(46,7411013,7411009,'ids',50,1),(46,7411014,7411012,'vml',100,1),(46,7411015,7411014,'dis',20,1),(46,7411016,7411014,'isp',20,1),(46,7411017,7411014,'spl',20,1),(46,7411018,7411014,'pla',20,1),(46,7411019,7411014,'lay',20,1),(46,7411020,7411015,'nam',50,1),(46,7411021,7411015,'ame',50,1),(47,7411023,7411022,'net',25,3),(47,7411024,7411022,'eta',25,3),(47,7411025,7411022,'tap',25,3),(47,7411026,7411022,'app',25,3),(47,7411027,7411023,'fib',33.333,2),(47,7411028,7411023,'ibr',33.333,2),(47,7411029,7411023,'bre',33.333,2),(47,7411030,7411027,'cha',20,2),(47,7411031,7411027,'han',20,2),(47,7411032,7411027,'ann',20,2),(47,7411033,7411027,'nne',20,2),(47,7411034,7411027,'nel',20,2),(47,7411035,7411030,'dis',50,2),(47,7411036,7411030,'isk',50,2),(47,7411037,7411035,'naa',100,4),(47,7411038,7411037,'600',3.333,4),(47,7411039,7411037,'00a',3.333,4),(47,7411040,7411037,'0a0',3.333,4),(47,7411041,7411037,'a09',3.333,4),(47,7411042,7411037,'098',3.333,4),(47,7411043,7411037,'980',3.333,4),(47,7411044,7411037,'804',3.333,4),(47,7411045,7411037,'044',3.333,4),(47,7411046,7411037,'443',3.333,4),(47,7411047,7411037,'430',3.333,4),(47,7411048,7411037,'307',3.333,4),(47,7411049,7411037,'072',3.333,4),(47,7411050,7411037,'725',3.333,4),(47,7411051,7411037,'259',3.333,4),(47,7411052,7411037,'593',3.333,4),(47,7411053,7411037,'931',3.333,4),(47,7411054,7411037,'313',3.333,4),(47,7411055,7411037,'13f',3.333,4),(47,7411056,7411037,'3f3',3.333,4),(47,7411057,7411037,'f33',3.333,4),(47,7411058,7411037,'334',3.333,4),(47,7411059,7411037,'345',3.333,4),(47,7411060,7411037,'455',3.333,4),(47,7411061,7411037,'556',3.333,4),(47,7411062,7411037,'563',3.333,4),(47,7411063,7411037,'639',3.333,4),(47,7411064,7411037,'393',3.333,4),(47,7411065,7411037,'934',3.333,4),(47,7411066,7411037,'343',3.333,4),(47,7411067,7411037,'437',3.333,4),(47,7411068,7411038,'ser',25,1),(47,7411069,7411038,'eri',25,1),(47,7411070,7411038,'ria',25,1),(47,7411071,7411038,'ial',25,1),(47,7411072,7411068,'siz',50,1),(47,7411073,7411068,'ize',50,1),(47,7411074,7411072,'321',100,1),(47,7411075,7411074,'dev',25,1),(47,7411076,7411074,'evi',25,1),(47,7411077,7411074,'vic',25,1),(47,7411078,7411074,'ice',25,1),(47,7411079,7411075,'typ',50,1),(47,7411080,7411075,'ype',50,1),(47,7411081,7411079,'dir',10,1),(47,7411082,7411079,'ire',10,1),(47,7411083,7411079,'rec',10,1),(47,7411084,7411079,'ect',10,1),(47,7411085,7411079,'cta',10,1),(47,7411086,7411079,'tac',10,1),(47,7411087,7411079,'acc',10,1),(47,7411088,7411079,'cce',10,1),(47,7411089,7411079,'ces',10,1),(47,7411090,7411079,'ess',10,1),(47,7411091,7411081,'mul',14.286,1),(47,7411092,7411081,'ult',14.286,1),(47,7411093,7411081,'lti',14.286,1),(47,7411094,7411081,'tip',14.286,1),(47,7411095,7411081,'ipa',14.286,1),(47,7411096,7411081,'pat',14.286,1),(47,7411097,7411081,'ath',14.286,1),(47,7411098,7411091,'plu',25,1),(47,7411099,7411091,'lug',25,1),(47,7411100,7411091,'ugi',25,1),(47,7411101,7411091,'gin',25,1),(47,7411102,7411098,'nmp',100,1),(47,7411103,7411102,'dev',33.333,1),(47,7411104,7411102,'evf',33.333,1),(47,7411105,7411102,'vfs',33.333,1),(47,7411106,7411103,'pat',50,1),(47,7411107,7411103,'ath',50,1),(47,7411108,7411106,'vmf',50,1),(47,7411109,7411106,'mfs',50,1),(47,7411110,7411108,'dev',20,1),(47,7411111,7411108,'evi',20,1),(47,7411112,7411108,'vic',20,1),(47,7411113,7411108,'ice',20,1),(47,7411114,7411108,'ces',20,1),(47,7411115,7411110,'dis',33.333,1),(47,7411116,7411110,'isk',33.333,1),(47,7411117,7411110,'sks',33.333,1),(47,7411118,7411115,'ven',25,1),(47,7411119,7411115,'end',25,1),(47,7411120,7411115,'ndo',25,1),(47,7411121,7411115,'dor',25,1),(47,7411122,7411118,'mod',33.333,1),(47,7411123,7411118,'ode',33.333,1),(47,7411124,7411118,'del',33.333,1),(47,7411125,7411122,'lun',100,1),(47,7411126,7411125,'cmo',33.333,1),(47,7411127,7411125,'mod',33.333,1),(47,7411128,7411125,'ode',33.333,1),(47,7411129,7411126,'rev',16.667,1),(47,7411130,7411126,'evi',16.667,1),(47,7411131,7411126,'vis',16.667,1),(47,7411132,7411126,'isi',16.667,1),(47,7411133,7411126,'sio',16.667,1),(47,7411134,7411126,'ion',16.667,1),(47,7411135,7411129,'810',50,1),(47,7411136,7411129,'100',50,1),(47,7411137,7411135,'scs',50,1),(47,7411138,7411135,'csi',50,1),(47,7411139,7411137,'lev',33.333,1),(47,7411140,7411137,'eve',33.333,1),(47,7411141,7411137,'vel',33.333,1),(47,7411142,7411139,'pse',25,1),(47,7411143,7411139,'seu',25,1),(47,7411144,7411139,'eud',25,1),(47,7411145,7411139,'udo',25,1),(47,7411146,7411142,'fal',33.333,6),(47,7411147,7411142,'als',33.333,6),(47,7411148,7411142,'lse',33.333,6),(47,7411149,7411146,'sta',25,3),(47,7411150,7411146,'tat',25,3),(47,7411151,7411146,'atu',25,3),(47,7411152,7411146,'tus',25,3),(47,7411153,7411149,'rdm',100,1),(47,7411154,7411153,'cap',20,1),(47,7411155,7411153,'apa',20,1),(47,7411156,7411153,'pab',20,1),(47,7411157,7411153,'abl',20,1),(47,7411158,7411153,'ble',20,1),(47,7411159,7411154,'tru',50,1),(47,7411160,7411154,'rue',50,1),(47,7411161,7411159,'loc',33.333,1),(47,7411162,7411159,'oca',33.333,1),(47,7411163,7411159,'cal',33.333,1),(47,7411164,7411161,'rem',14.286,1),(47,7411165,7411161,'emo',14.286,1),(47,7411166,7411161,'mov',14.286,1),(47,7411167,7411161,'ova',14.286,1),(47,7411168,7411161,'vab',14.286,1),(47,7411169,7411161,'abl',14.286,1),(47,7411170,7411161,'ble',14.286,1),(47,7411171,7411164,'ssd',100,1),(47,7411172,7411171,'off',20,1),(47,7411173,7411171,'ffl',20,1),(47,7411174,7411171,'fli',20,1),(47,7411175,7411171,'lin',20,1),(47,7411176,7411171,'ine',20,1),(47,7411177,7411172,'per',11.111,1),(47,7411178,7411172,'ere',11.111,1),(47,7411179,7411172,'ren',11.111,1),(47,7411180,7411172,'enn',11.111,1),(47,7411181,7411172,'nni',11.111,1),(47,7411182,7411172,'nia',11.111,1),(47,7411183,7411172,'ial',11.111,1),(47,7411184,7411172,'all',11.111,1),(47,7411185,7411172,'lly',11.111,1),(47,7411186,7411177,'res',16.667,1),(47,7411187,7411177,'ese',16.667,1),(47,7411188,7411177,'ser',16.667,1),(47,7411189,7411177,'erv',16.667,1),(47,7411190,7411177,'rve',16.667,1),(47,7411191,7411177,'ved',16.667,1),(47,7411192,7411186,'thi',50,1),(47,7411193,7411186,'hin',50,1),(47,7411194,7411192,'pro',10,1),(47,7411195,7411192,'rov',10,1),(47,7411196,7411192,'ovi',10,1),(47,7411197,7411192,'vis',10,1),(47,7411198,7411192,'isi',10,1),(47,7411199,7411192,'sio',10,1),(47,7411200,7411192,'ion',10,1),(47,7411201,7411192,'oni',10,1),(47,7411202,7411192,'nin',10,1),(47,7411203,7411192,'ing',10,1),(47,7411204,7411194,'yes',100,1),(47,7411205,7411204,'att',16.667,1),(47,7411206,7411204,'tta',16.667,1),(47,7411207,7411204,'tac',16.667,1),(47,7411208,7411204,'ach',16.667,1),(47,7411209,7411204,'che',16.667,1),(47,7411210,7411204,'hed',16.667,1),(47,7411211,7411205,'fil',20,1),(47,7411212,7411205,'ilt',20,1),(47,7411213,7411205,'lte',20,1),(47,7411214,7411205,'ter',20,1),(47,7411215,7411205,'ers',20,1),(47,7411216,7411211,'vaa',50,1),(47,7411217,7411211,'aai',50,1),(47,7411218,7411216,'unk',20,1),(47,7411219,7411216,'nkn',20,1),(47,7411220,7411216,'kno',20,1),(47,7411221,7411216,'now',20,1),(47,7411222,7411216,'own',20,1),(47,7411223,7411218,'oth',33.333,1),(47,7411224,7411218,'the',33.333,1),(47,7411225,7411218,'her',33.333,1),(47,7411226,7411223,'uid',50,1),(47,7411227,7411223,'ids',50,1),(47,7411228,7411226,'vml',100,1),(47,7411229,7411228,'dis',20,1),(47,7411230,7411228,'isp',20,1),(47,7411231,7411228,'spl',20,1),(47,7411232,7411228,'pla',20,1),(47,7411233,7411228,'lay',20,1),(47,7411234,7411229,'nam',50,1),(47,7411235,7411229,'ame',50,1),(48,7411237,7411236,'net',25,3),(48,7411238,7411236,'eta',25,3),(48,7411239,7411236,'tap',25,3),(48,7411240,7411236,'app',25,3),(48,7411241,7411237,'fib',33.333,2),(48,7411242,7411237,'ibr',33.333,2),(48,7411243,7411237,'bre',33.333,2),(48,7411244,7411241,'cha',20,2),(48,7411245,7411241,'han',20,2),(48,7411246,7411241,'ann',20,2),(48,7411247,7411241,'nne',20,2),(48,7411248,7411241,'nel',20,2),(48,7411249,7411244,'dis',50,2),(48,7411250,7411244,'isk',50,2),(48,7411251,7411249,'naa',100,4),(48,7411252,7411251,'600',3.333,4),(48,7411253,7411251,'00a',3.333,4),(48,7411254,7411251,'0a0',3.333,4),(48,7411255,7411251,'a09',3.333,4),(48,7411256,7411251,'098',3.333,4),(48,7411257,7411251,'980',3.333,4),(48,7411258,7411251,'804',3.333,4),(48,7411259,7411251,'044',3.333,4),(48,7411260,7411251,'443',3.333,4),(48,7411261,7411251,'430',3.333,4),(48,7411262,7411251,'307',3.333,4),(48,7411263,7411251,'072',3.333,4),(48,7411264,7411251,'725',3.333,4),(48,7411265,7411251,'259',3.333,4),(48,7411266,7411251,'593',3.333,4),(48,7411267,7411251,'931',3.333,4),(48,7411268,7411251,'313',3.333,4),(48,7411269,7411251,'13f',3.333,4),(48,7411270,7411251,'3f3',3.333,4),(48,7411271,7411251,'f33',3.333,4),(48,7411272,7411251,'334',3.333,4),(48,7411273,7411251,'345',3.333,4),(48,7411274,7411251,'455',3.333,4),(48,7411275,7411251,'556',3.333,4),(48,7411276,7411251,'563',3.333,4),(48,7411277,7411251,'639',3.333,4),(48,7411278,7411251,'393',3.333,4),(48,7411279,7411251,'934',3.333,4),(48,7411280,7411251,'343',3.333,4),(48,7411281,7411251,'438',3.333,4),(48,7411282,7411252,'ser',25,1),(48,7411283,7411252,'eri',25,1),(48,7411284,7411252,'ria',25,1),(48,7411285,7411252,'ial',25,1),(48,7411286,7411282,'siz',50,1),(48,7411287,7411282,'ize',50,1),(48,7411288,7411286,'321',100,1),(48,7411289,7411288,'dev',25,1),(48,7411290,7411288,'evi',25,1),(48,7411291,7411288,'vic',25,1),(48,7411292,7411288,'ice',25,1),(48,7411293,7411289,'typ',50,1),(48,7411294,7411289,'ype',50,1),(48,7411295,7411293,'dir',10,1),(48,7411296,7411293,'ire',10,1),(48,7411297,7411293,'rec',10,1),(48,7411298,7411293,'ect',10,1),(48,7411299,7411293,'cta',10,1),(48,7411300,7411293,'tac',10,1),(48,7411301,7411293,'acc',10,1),(48,7411302,7411293,'cce',10,1),(48,7411303,7411293,'ces',10,1),(48,7411304,7411293,'ess',10,1),(48,7411305,7411295,'mul',14.286,1),(48,7411306,7411295,'ult',14.286,1),(48,7411307,7411295,'lti',14.286,1),(48,7411308,7411295,'tip',14.286,1),(48,7411309,7411295,'ipa',14.286,1),(48,7411310,7411295,'pat',14.286,1),(48,7411311,7411295,'ath',14.286,1),(48,7411312,7411305,'plu',25,1),(48,7411313,7411305,'lug',25,1),(48,7411314,7411305,'ugi',25,1),(48,7411315,7411305,'gin',25,1),(48,7411316,7411312,'nmp',100,1),(48,7411317,7411316,'dev',33.333,1),(48,7411318,7411316,'evf',33.333,1),(48,7411319,7411316,'vfs',33.333,1),(48,7411320,7411317,'pat',50,1),(48,7411321,7411317,'ath',50,1),(48,7411322,7411320,'vmf',50,1),(48,7411323,7411320,'mfs',50,1),(48,7411324,7411322,'dev',20,1),(48,7411325,7411322,'evi',20,1),(48,7411326,7411322,'vic',20,1),(48,7411327,7411322,'ice',20,1),(48,7411328,7411322,'ces',20,1),(48,7411329,7411324,'dis',33.333,1),(48,7411330,7411324,'isk',33.333,1),(48,7411331,7411324,'sks',33.333,1),(48,7411332,7411329,'ven',25,1),(48,7411333,7411329,'end',25,1),(48,7411334,7411329,'ndo',25,1),(48,7411335,7411329,'dor',25,1),(48,7411336,7411332,'mod',33.333,1),(48,7411337,7411332,'ode',33.333,1),(48,7411338,7411332,'del',33.333,1),(48,7411339,7411336,'lun',100,1),(48,7411340,7411339,'cmo',33.333,1),(48,7411341,7411339,'mod',33.333,1),(48,7411342,7411339,'ode',33.333,1),(48,7411343,7411340,'rev',16.667,1),(48,7411344,7411340,'evi',16.667,1),(48,7411345,7411340,'vis',16.667,1),(48,7411346,7411340,'isi',16.667,1),(48,7411347,7411340,'sio',16.667,1),(48,7411348,7411340,'ion',16.667,1),(48,7411349,7411343,'810',50,1),(48,7411350,7411343,'100',50,1),(48,7411351,7411349,'scs',50,1),(48,7411352,7411349,'csi',50,1),(48,7411353,7411351,'lev',33.333,1),(48,7411354,7411351,'eve',33.333,1),(48,7411355,7411351,'vel',33.333,1),(48,7411356,7411353,'pse',25,1),(48,7411357,7411353,'seu',25,1),(48,7411358,7411353,'eud',25,1),(48,7411359,7411353,'udo',25,1),(48,7411360,7411356,'fal',33.333,6),(48,7411361,7411356,'als',33.333,6),(48,7411362,7411356,'lse',33.333,6),(48,7411363,7411360,'sta',25,3),(48,7411364,7411360,'tat',25,3),(48,7411365,7411360,'atu',25,3),(48,7411366,7411360,'tus',25,3),(48,7411367,7411363,'rdm',100,1),(48,7411368,7411367,'cap',20,1),(48,7411369,7411367,'apa',20,1),(48,7411370,7411367,'pab',20,1),(48,7411371,7411367,'abl',20,1),(48,7411372,7411367,'ble',20,1),(48,7411373,7411368,'tru',50,1),(48,7411374,7411368,'rue',50,1),(48,7411375,7411373,'loc',33.333,1),(48,7411376,7411373,'oca',33.333,1),(48,7411377,7411373,'cal',33.333,1),(48,7411378,7411375,'rem',14.286,1),(48,7411379,7411375,'emo',14.286,1),(48,7411380,7411375,'mov',14.286,1),(48,7411381,7411375,'ova',14.286,1),(48,7411382,7411375,'vab',14.286,1),(48,7411383,7411375,'abl',14.286,1),(48,7411384,7411375,'ble',14.286,1),(48,7411385,7411378,'ssd',100,1),(48,7411386,7411385,'off',20,1),(48,7411387,7411385,'ffl',20,1),(48,7411388,7411385,'fli',20,1),(48,7411389,7411385,'lin',20,1),(48,7411390,7411385,'ine',20,1),(48,7411391,7411386,'per',11.111,1),(48,7411392,7411386,'ere',11.111,1),(48,7411393,7411386,'ren',11.111,1),(48,7411394,7411386,'enn',11.111,1),(48,7411395,7411386,'nni',11.111,1),(48,7411396,7411386,'nia',11.111,1),(48,7411397,7411386,'ial',11.111,1),(48,7411398,7411386,'all',11.111,1),(48,7411399,7411386,'lly',11.111,1),(48,7411400,7411391,'res',16.667,1),(48,7411401,7411391,'ese',16.667,1),(48,7411402,7411391,'ser',16.667,1),(48,7411403,7411391,'erv',16.667,1),(48,7411404,7411391,'rve',16.667,1),(48,7411405,7411391,'ved',16.667,1),(48,7411406,7411400,'thi',50,1),(48,7411407,7411400,'hin',50,1),(48,7411408,7411406,'pro',10,1),(48,7411409,7411406,'rov',10,1),(48,7411410,7411406,'ovi',10,1),(48,7411411,7411406,'vis',10,1),(48,7411412,7411406,'isi',10,1),(48,7411413,7411406,'sio',10,1),(48,7411414,7411406,'ion',10,1),(48,7411415,7411406,'oni',10,1),(48,7411416,7411406,'nin',10,1),(48,7411417,7411406,'ing',10,1),(48,7411418,7411408,'yes',100,1),(48,7411419,7411418,'att',16.667,1),(48,7411420,7411418,'tta',16.667,1),(48,7411421,7411418,'tac',16.667,1),(48,7411422,7411418,'ach',16.667,1),(48,7411423,7411418,'che',16.667,1),(48,7411424,7411418,'hed',16.667,1),(48,7411425,7411419,'fil',20,1),(48,7411426,7411419,'ilt',20,1),(48,7411427,7411419,'lte',20,1),(48,7411428,7411419,'ter',20,1),(48,7411429,7411419,'ers',20,1),(48,7411430,7411425,'vaa',50,1),(48,7411431,7411425,'aai',50,1),(48,7411432,7411430,'unk',20,1),(48,7411433,7411430,'nkn',20,1),(48,7411434,7411430,'kno',20,1),(48,7411435,7411430,'now',20,1),(48,7411436,7411430,'own',20,1),(48,7411437,7411432,'oth',33.333,1),(48,7411438,7411432,'the',33.333,1),(48,7411439,7411432,'her',33.333,1),(48,7411440,7411437,'uid',50,1),(48,7411441,7411437,'ids',50,1),(48,7411442,7411440,'vml',100,1),(48,7411443,7411442,'dis',20,1),(48,7411444,7411442,'isp',20,1),(48,7411445,7411442,'spl',20,1),(48,7411446,7411442,'pla',20,1),(48,7411447,7411442,'lay',20,1),(48,7411448,7411443,'nam',50,1),(48,7411449,7411443,'ame',50,1),(49,7411451,7411450,'net',25,3),(49,7411452,7411450,'eta',25,3),(49,7411453,7411450,'tap',25,3),(49,7411454,7411450,'app',25,3),(49,7411455,7411451,'fib',33.333,2),(49,7411456,7411451,'ibr',33.333,2),(49,7411457,7411451,'bre',33.333,2),(49,7411458,7411455,'cha',20,2),(49,7411459,7411455,'han',20,2),(49,7411460,7411455,'ann',20,2),(49,7411461,7411455,'nne',20,2),(49,7411462,7411455,'nel',20,2),(49,7411463,7411458,'dis',50,2),(49,7411464,7411458,'isk',50,2),(49,7411465,7411463,'naa',100,4),(49,7411466,7411465,'600',3.333,4),(49,7411467,7411465,'00a',3.333,4),(49,7411468,7411465,'0a0',3.333,4),(49,7411469,7411465,'a09',3.333,4),(49,7411470,7411465,'098',3.333,4),(49,7411471,7411465,'980',3.333,4),(49,7411472,7411465,'804',3.333,4),(49,7411473,7411465,'044',3.333,4),(49,7411474,7411465,'443',3.333,4),(49,7411475,7411465,'430',3.333,4),(49,7411476,7411465,'307',3.333,4),(49,7411477,7411465,'072',3.333,4),(49,7411478,7411465,'725',3.333,4),(49,7411479,7411465,'259',3.333,4),(49,7411480,7411465,'593',3.333,4),(49,7411481,7411465,'931',3.333,4),(49,7411482,7411465,'313',3.333,4),(49,7411483,7411465,'13f',3.333,4),(49,7411484,7411465,'3f3',3.333,4),(49,7411485,7411465,'f33',3.333,4),(49,7411486,7411465,'334',3.333,4),(49,7411487,7411465,'345',3.333,4),(49,7411488,7411465,'455',3.333,4),(49,7411489,7411465,'556',3.333,4),(49,7411490,7411465,'563',3.333,4),(49,7411491,7411465,'639',3.333,4),(49,7411492,7411465,'393',3.333,4),(49,7411493,7411465,'934',3.333,4),(49,7411494,7411465,'343',3.333,4),(49,7411495,7411465,'439',3.333,4),(49,7411496,7411466,'ser',25,1),(49,7411497,7411466,'eri',25,1),(49,7411498,7411466,'ria',25,1),(49,7411499,7411466,'ial',25,1),(49,7411500,7411496,'siz',50,1),(49,7411501,7411496,'ize',50,1),(49,7411502,7411500,'321',100,1),(49,7411503,7411502,'dev',25,1),(49,7411504,7411502,'evi',25,1),(49,7411505,7411502,'vic',25,1),(49,7411506,7411502,'ice',25,1),(49,7411507,7411503,'typ',50,1),(49,7411508,7411503,'ype',50,1),(49,7411509,7411507,'dir',10,1),(49,7411510,7411507,'ire',10,1),(49,7411511,7411507,'rec',10,1),(49,7411512,7411507,'ect',10,1),(49,7411513,7411507,'cta',10,1),(49,7411514,7411507,'tac',10,1),(49,7411515,7411507,'acc',10,1),(49,7411516,7411507,'cce',10,1),(49,7411517,7411507,'ces',10,1),(49,7411518,7411507,'ess',10,1),(49,7411519,7411509,'mul',14.286,1),(49,7411520,7411509,'ult',14.286,1),(49,7411521,7411509,'lti',14.286,1),(49,7411522,7411509,'tip',14.286,1),(49,7411523,7411509,'ipa',14.286,1),(49,7411524,7411509,'pat',14.286,1),(49,7411525,7411509,'ath',14.286,1),(49,7411526,7411519,'plu',25,1),(49,7411527,7411519,'lug',25,1),(49,7411528,7411519,'ugi',25,1),(49,7411529,7411519,'gin',25,1),(49,7411530,7411526,'nmp',100,1),(49,7411531,7411530,'dev',33.333,1),(49,7411532,7411530,'evf',33.333,1),(49,7411533,7411530,'vfs',33.333,1),(49,7411534,7411531,'pat',50,1),(49,7411535,7411531,'ath',50,1),(49,7411536,7411534,'vmf',50,1),(49,7411537,7411534,'mfs',50,1),(49,7411538,7411536,'dev',20,1),(49,7411539,7411536,'evi',20,1),(49,7411540,7411536,'vic',20,1),(49,7411541,7411536,'ice',20,1),(49,7411542,7411536,'ces',20,1),(49,7411543,7411538,'dis',33.333,1),(49,7411544,7411538,'isk',33.333,1),(49,7411545,7411538,'sks',33.333,1),(49,7411546,7411543,'ven',25,1),(49,7411547,7411543,'end',25,1),(49,7411548,7411543,'ndo',25,1),(49,7411549,7411543,'dor',25,1),(49,7411550,7411546,'mod',33.333,1),(49,7411551,7411546,'ode',33.333,1),(49,7411552,7411546,'del',33.333,1),(49,7411553,7411550,'lun',100,1),(49,7411554,7411553,'cmo',33.333,1),(49,7411555,7411553,'mod',33.333,1),(49,7411556,7411553,'ode',33.333,1),(49,7411557,7411554,'rev',16.667,1),(49,7411558,7411554,'evi',16.667,1),(49,7411559,7411554,'vis',16.667,1),(49,7411560,7411554,'isi',16.667,1),(49,7411561,7411554,'sio',16.667,1),(49,7411562,7411554,'ion',16.667,1),(49,7411563,7411557,'810',50,1),(49,7411564,7411557,'100',50,1),(49,7411565,7411563,'scs',50,1),(49,7411566,7411563,'csi',50,1),(49,7411567,7411565,'lev',33.333,1),(49,7411568,7411565,'eve',33.333,1),(49,7411569,7411565,'vel',33.333,1),(49,7411570,7411567,'pse',25,1),(49,7411571,7411567,'seu',25,1),(49,7411572,7411567,'eud',25,1),(49,7411573,7411567,'udo',25,1),(49,7411574,7411570,'fal',33.333,6),(49,7411575,7411570,'als',33.333,6),(49,7411576,7411570,'lse',33.333,6),(49,7411577,7411574,'sta',25,3),(49,7411578,7411574,'tat',25,3),(49,7411579,7411574,'atu',25,3),(49,7411580,7411574,'tus',25,3),(49,7411581,7411577,'rdm',100,1),(49,7411582,7411581,'cap',20,1),(49,7411583,7411581,'apa',20,1),(49,7411584,7411581,'pab',20,1),(49,7411585,7411581,'abl',20,1),(49,7411586,7411581,'ble',20,1),(49,7411587,7411582,'tru',50,1),(49,7411588,7411582,'rue',50,1),(49,7411589,7411587,'loc',33.333,1),(49,7411590,7411587,'oca',33.333,1),(49,7411591,7411587,'cal',33.333,1),(49,7411592,7411589,'rem',14.286,1),(49,7411593,7411589,'emo',14.286,1),(49,7411594,7411589,'mov',14.286,1),(49,7411595,7411589,'ova',14.286,1),(49,7411596,7411589,'vab',14.286,1),(49,7411597,7411589,'abl',14.286,1),(49,7411598,7411589,'ble',14.286,1),(49,7411599,7411592,'ssd',100,1),(49,7411600,7411599,'off',20,1),(49,7411601,7411599,'ffl',20,1),(49,7411602,7411599,'fli',20,1),(49,7411603,7411599,'lin',20,1),(49,7411604,7411599,'ine',20,1),(49,7411605,7411600,'per',11.111,1),(49,7411606,7411600,'ere',11.111,1),(49,7411607,7411600,'ren',11.111,1),(49,7411608,7411600,'enn',11.111,1),(49,7411609,7411600,'nni',11.111,1),(49,7411610,7411600,'nia',11.111,1),(49,7411611,7411600,'ial',11.111,1),(49,7411612,7411600,'all',11.111,1),(49,7411613,7411600,'lly',11.111,1),(49,7411614,7411605,'res',16.667,1),(49,7411615,7411605,'ese',16.667,1),(49,7411616,7411605,'ser',16.667,1),(49,7411617,7411605,'erv',16.667,1),(49,7411618,7411605,'rve',16.667,1),(49,7411619,7411605,'ved',16.667,1),(49,7411620,7411614,'thi',50,1),(49,7411621,7411614,'hin',50,1),(49,7411622,7411620,'pro',10,1),(49,7411623,7411620,'rov',10,1),(49,7411624,7411620,'ovi',10,1),(49,7411625,7411620,'vis',10,1),(49,7411626,7411620,'isi',10,1),(49,7411627,7411620,'sio',10,1),(49,7411628,7411620,'ion',10,1),(49,7411629,7411620,'oni',10,1),(49,7411630,7411620,'nin',10,1),(49,7411631,7411620,'ing',10,1),(49,7411632,7411622,'yes',100,1),(49,7411633,7411632,'att',16.667,1),(49,7411634,7411632,'tta',16.667,1),(49,7411635,7411632,'tac',16.667,1),(49,7411636,7411632,'ach',16.667,1),(49,7411637,7411632,'che',16.667,1),(49,7411638,7411632,'hed',16.667,1),(49,7411639,7411633,'fil',20,1),(49,7411640,7411633,'ilt',20,1),(49,7411641,7411633,'lte',20,1),(49,7411642,7411633,'ter',20,1),(49,7411643,7411633,'ers',20,1),(49,7411644,7411639,'vaa',50,1),(49,7411645,7411639,'aai',50,1),(49,7411646,7411644,'unk',20,1),(49,7411647,7411644,'nkn',20,1),(49,7411648,7411644,'kno',20,1),(49,7411649,7411644,'now',20,1),(49,7411650,7411644,'own',20,1),(49,7411651,7411646,'oth',33.333,1),(49,7411652,7411646,'the',33.333,1),(49,7411653,7411646,'her',33.333,1),(49,7411654,7411651,'uid',50,1),(49,7411655,7411651,'ids',50,1),(49,7411656,7411654,'vml',100,1),(49,7411657,7411656,'dis',20,1),(49,7411658,7411656,'isp',20,1),(49,7411659,7411656,'spl',20,1),(49,7411660,7411656,'pla',20,1),(49,7411661,7411656,'lay',20,1),(49,7411662,7411657,'nam',50,1),(49,7411663,7411657,'ame',50,1),(50,7411665,7411664,'net',25,3),(50,7411666,7411664,'eta',25,3),(50,7411667,7411664,'tap',25,3),(50,7411668,7411664,'app',25,3),(50,7411669,7411665,'fib',33.333,2),(50,7411670,7411665,'ibr',33.333,2),(50,7411671,7411665,'bre',33.333,2),(50,7411672,7411669,'cha',20,2),(50,7411673,7411669,'han',20,2),(50,7411674,7411669,'ann',20,2),(50,7411675,7411669,'nne',20,2),(50,7411676,7411669,'nel',20,2),(50,7411677,7411672,'dis',50,2),(50,7411678,7411672,'isk',50,2),(50,7411679,7411677,'naa',100,4),(50,7411680,7411679,'600',3.333,4),(50,7411681,7411679,'00a',3.333,4),(50,7411682,7411679,'0a0',3.333,4),(50,7411683,7411679,'a09',3.333,4),(50,7411684,7411679,'098',3.333,4),(50,7411685,7411679,'980',3.333,4),(50,7411686,7411679,'804',3.333,4),(50,7411687,7411679,'044',3.333,4),(50,7411688,7411679,'443',3.333,4),(50,7411689,7411679,'430',3.333,4),(50,7411690,7411679,'307',3.333,4),(50,7411691,7411679,'072',3.333,4),(50,7411692,7411679,'725',3.333,4),(50,7411693,7411679,'259',3.333,4),(50,7411694,7411679,'593',3.333,4),(50,7411695,7411679,'931',3.333,4),(50,7411696,7411679,'313',3.333,4),(50,7411697,7411679,'13f',3.333,4),(50,7411698,7411679,'3f3',3.333,4),(50,7411699,7411679,'f33',3.333,4),(50,7411700,7411679,'334',3.333,4),(50,7411701,7411679,'345',3.333,4),(50,7411702,7411679,'455',3.333,4),(50,7411703,7411679,'556',3.333,4),(50,7411704,7411679,'563',3.333,4),(50,7411705,7411679,'639',3.333,4),(50,7411706,7411679,'393',3.333,4),(50,7411707,7411679,'934',3.333,4),(50,7411708,7411679,'347',3.333,4),(50,7411709,7411679,'470',3.333,4),(50,7411710,7411680,'ser',25,1),(50,7411711,7411680,'eri',25,1),(50,7411712,7411680,'ria',25,1),(50,7411713,7411680,'ial',25,1),(50,7411714,7411710,'siz',50,1),(50,7411715,7411710,'ize',50,1),(50,7411716,7411714,'321',100,1),(50,7411717,7411716,'dev',25,1),(50,7411718,7411716,'evi',25,1),(50,7411719,7411716,'vic',25,1),(50,7411720,7411716,'ice',25,1),(50,7411721,7411717,'typ',50,1),(50,7411722,7411717,'ype',50,1),(50,7411723,7411721,'dir',10,1),(50,7411724,7411721,'ire',10,1),(50,7411725,7411721,'rec',10,1),(50,7411726,7411721,'ect',10,1),(50,7411727,7411721,'cta',10,1),(50,7411728,7411721,'tac',10,1),(50,7411729,7411721,'acc',10,1),(50,7411730,7411721,'cce',10,1),(50,7411731,7411721,'ces',10,1),(50,7411732,7411721,'ess',10,1),(50,7411733,7411723,'mul',14.286,1),(50,7411734,7411723,'ult',14.286,1),(50,7411735,7411723,'lti',14.286,1),(50,7411736,7411723,'tip',14.286,1),(50,7411737,7411723,'ipa',14.286,1),(50,7411738,7411723,'pat',14.286,1),(50,7411739,7411723,'ath',14.286,1),(50,7411740,7411733,'plu',25,1),(50,7411741,7411733,'lug',25,1),(50,7411742,7411733,'ugi',25,1),(50,7411743,7411733,'gin',25,1),(50,7411744,7411740,'nmp',100,1),(50,7411745,7411744,'dev',33.333,1),(50,7411746,7411744,'evf',33.333,1),(50,7411747,7411744,'vfs',33.333,1),(50,7411748,7411745,'pat',50,1),(50,7411749,7411745,'ath',50,1),(50,7411750,7411748,'vmf',50,1),(50,7411751,7411748,'mfs',50,1),(50,7411752,7411750,'dev',20,1),(50,7411753,7411750,'evi',20,1),(50,7411754,7411750,'vic',20,1),(50,7411755,7411750,'ice',20,1),(50,7411756,7411750,'ces',20,1),(50,7411757,7411752,'dis',33.333,1),(50,7411758,7411752,'isk',33.333,1),(50,7411759,7411752,'sks',33.333,1),(50,7411760,7411757,'ven',25,1),(50,7411761,7411757,'end',25,1),(50,7411762,7411757,'ndo',25,1),(50,7411763,7411757,'dor',25,1),(50,7411764,7411760,'mod',33.333,1),(50,7411765,7411760,'ode',33.333,1),(50,7411766,7411760,'del',33.333,1),(50,7411767,7411764,'lun',100,1),(50,7411768,7411767,'cmo',33.333,1),(50,7411769,7411767,'mod',33.333,1),(50,7411770,7411767,'ode',33.333,1),(50,7411771,7411768,'rev',16.667,1),(50,7411772,7411768,'evi',16.667,1),(50,7411773,7411768,'vis',16.667,1),(50,7411774,7411768,'isi',16.667,1),(50,7411775,7411768,'sio',16.667,1),(50,7411776,7411768,'ion',16.667,1),(50,7411777,7411771,'810',50,1),(50,7411778,7411771,'100',50,1),(50,7411779,7411777,'scs',50,1),(50,7411780,7411777,'csi',50,1),(50,7411781,7411779,'lev',33.333,1),(50,7411782,7411779,'eve',33.333,1),(50,7411783,7411779,'vel',33.333,1),(50,7411784,7411781,'pse',25,1),(50,7411785,7411781,'seu',25,1),(50,7411786,7411781,'eud',25,1),(50,7411787,7411781,'udo',25,1),(50,7411788,7411784,'fal',33.333,6),(50,7411789,7411784,'als',33.333,6),(50,7411790,7411784,'lse',33.333,6),(50,7411791,7411788,'sta',25,3),(50,7411792,7411788,'tat',25,3),(50,7411793,7411788,'atu',25,3),(50,7411794,7411788,'tus',25,3),(50,7411795,7411791,'rdm',100,1),(50,7411796,7411795,'cap',20,1),(50,7411797,7411795,'apa',20,1),(50,7411798,7411795,'pab',20,1),(50,7411799,7411795,'abl',20,1),(50,7411800,7411795,'ble',20,1),(50,7411801,7411796,'tru',50,1),(50,7411802,7411796,'rue',50,1),(50,7411803,7411801,'loc',33.333,1),(50,7411804,7411801,'oca',33.333,1),(50,7411805,7411801,'cal',33.333,1),(50,7411806,7411803,'rem',14.286,1),(50,7411807,7411803,'emo',14.286,1),(50,7411808,7411803,'mov',14.286,1),(50,7411809,7411803,'ova',14.286,1),(50,7411810,7411803,'vab',14.286,1),(50,7411811,7411803,'abl',14.286,1),(50,7411812,7411803,'ble',14.286,1),(50,7411813,7411806,'ssd',100,1),(50,7411814,7411813,'off',20,1),(50,7411815,7411813,'ffl',20,1),(50,7411816,7411813,'fli',20,1),(50,7411817,7411813,'lin',20,1),(50,7411818,7411813,'ine',20,1),(50,7411819,7411814,'per',11.111,1),(50,7411820,7411814,'ere',11.111,1),(50,7411821,7411814,'ren',11.111,1),(50,7411822,7411814,'enn',11.111,1),(50,7411823,7411814,'nni',11.111,1),(50,7411824,7411814,'nia',11.111,1),(50,7411825,7411814,'ial',11.111,1),(50,7411826,7411814,'all',11.111,1),(50,7411827,7411814,'lly',11.111,1),(50,7411828,7411819,'res',16.667,1),(50,7411829,7411819,'ese',16.667,1),(50,7411830,7411819,'ser',16.667,1),(50,7411831,7411819,'erv',16.667,1),(50,7411832,7411819,'rve',16.667,1),(50,7411833,7411819,'ved',16.667,1),(50,7411834,7411828,'thi',50,1),(50,7411835,7411828,'hin',50,1),(50,7411836,7411834,'pro',10,1),(50,7411837,7411834,'rov',10,1),(50,7411838,7411834,'ovi',10,1),(50,7411839,7411834,'vis',10,1),(50,7411840,7411834,'isi',10,1),(50,7411841,7411834,'sio',10,1),(50,7411842,7411834,'ion',10,1),(50,7411843,7411834,'oni',10,1),(50,7411844,7411834,'nin',10,1),(50,7411845,7411834,'ing',10,1),(50,7411846,7411836,'yes',100,1),(50,7411847,7411846,'att',16.667,1),(50,7411848,7411846,'tta',16.667,1),(50,7411849,7411846,'tac',16.667,1),(50,7411850,7411846,'ach',16.667,1),(50,7411851,7411846,'che',16.667,1),(50,7411852,7411846,'hed',16.667,1),(50,7411853,7411847,'fil',20,1),(50,7411854,7411847,'ilt',20,1),(50,7411855,7411847,'lte',20,1),(50,7411856,7411847,'ter',20,1),(50,7411857,7411847,'ers',20,1),(50,7411858,7411853,'vaa',50,1),(50,7411859,7411853,'aai',50,1),(50,7411860,7411858,'unk',20,1),(50,7411861,7411858,'nkn',20,1),(50,7411862,7411858,'kno',20,1),(50,7411863,7411858,'now',20,1),(50,7411864,7411858,'own',20,1),(50,7411865,7411860,'oth',33.333,1),(50,7411866,7411860,'the',33.333,1),(50,7411867,7411860,'her',33.333,1),(50,7411868,7411865,'uid',50,1),(50,7411869,7411865,'ids',50,1),(50,7411870,7411868,'vml',100,1),(50,7411871,7411870,'dis',20,1),(50,7411872,7411870,'isp',20,1),(50,7411873,7411870,'spl',20,1),(50,7411874,7411870,'pla',20,1),(50,7411875,7411870,'lay',20,1),(50,7411876,7411871,'nam',50,1),(50,7411877,7411871,'ame',50,1),(51,7411879,7411878,'net',25,3),(51,7411880,7411878,'eta',25,3),(51,7411881,7411878,'tap',25,3),(51,7411882,7411878,'app',25,3),(51,7411883,7411879,'fib',33.333,2),(51,7411884,7411879,'ibr',33.333,2),(51,7411885,7411879,'bre',33.333,2),(51,7411886,7411883,'cha',20,2),(51,7411887,7411883,'han',20,2),(51,7411888,7411883,'ann',20,2),(51,7411889,7411883,'nne',20,2),(51,7411890,7411883,'nel',20,2),(51,7411891,7411886,'dis',50,2),(51,7411892,7411886,'isk',50,2),(51,7411893,7411891,'naa',100,4),(51,7411894,7411893,'600',3.333,4),(51,7411895,7411893,'00a',3.333,4),(51,7411896,7411893,'0a0',3.333,4),(51,7411897,7411893,'a09',3.333,4),(51,7411898,7411893,'098',3.333,4),(51,7411899,7411893,'980',3.333,4),(51,7411900,7411893,'804',3.333,4),(51,7411901,7411893,'044',3.333,4),(51,7411902,7411893,'443',3.333,4),(51,7411903,7411893,'430',3.333,4),(51,7411904,7411893,'307',3.333,4),(51,7411905,7411893,'072',3.333,4),(51,7411906,7411893,'725',3.333,4),(51,7411907,7411893,'259',3.333,4),(51,7411908,7411893,'593',3.333,4),(51,7411909,7411893,'931',3.333,4),(51,7411910,7411893,'313',3.333,4),(51,7411911,7411893,'13f',3.333,4),(51,7411912,7411893,'3f3',3.333,4),(51,7411913,7411893,'f33',3.333,4),(51,7411914,7411893,'334',3.333,4),(51,7411915,7411893,'345',3.333,4),(51,7411916,7411893,'455',3.333,4),(51,7411917,7411893,'556',3.333,4),(51,7411918,7411893,'563',3.333,4),(51,7411919,7411893,'639',3.333,4),(51,7411920,7411893,'393',3.333,4),(51,7411921,7411893,'934',3.333,4),(51,7411922,7411893,'347',3.333,4),(51,7411923,7411893,'471',3.333,4),(51,7411924,7411894,'ser',25,1),(51,7411925,7411894,'eri',25,1),(51,7411926,7411894,'ria',25,1),(51,7411927,7411894,'ial',25,1),(51,7411928,7411924,'siz',50,1),(51,7411929,7411924,'ize',50,1),(51,7411930,7411928,'321',100,1),(51,7411931,7411930,'dev',25,1),(51,7411932,7411930,'evi',25,1),(51,7411933,7411930,'vic',25,1),(51,7411934,7411930,'ice',25,1),(51,7411935,7411931,'typ',50,1),(51,7411936,7411931,'ype',50,1),(51,7411937,7411935,'dir',10,1),(51,7411938,7411935,'ire',10,1),(51,7411939,7411935,'rec',10,1),(51,7411940,7411935,'ect',10,1),(51,7411941,7411935,'cta',10,1),(51,7411942,7411935,'tac',10,1),(51,7411943,7411935,'acc',10,1),(51,7411944,7411935,'cce',10,1),(51,7411945,7411935,'ces',10,1),(51,7411946,7411935,'ess',10,1),(51,7411947,7411937,'mul',14.286,1),(51,7411948,7411937,'ult',14.286,1),(51,7411949,7411937,'lti',14.286,1),(51,7411950,7411937,'tip',14.286,1),(51,7411951,7411937,'ipa',14.286,1),(51,7411952,7411937,'pat',14.286,1),(51,7411953,7411937,'ath',14.286,1),(51,7411954,7411947,'plu',25,1),(51,7411955,7411947,'lug',25,1),(51,7411956,7411947,'ugi',25,1),(51,7411957,7411947,'gin',25,1),(51,7411958,7411954,'nmp',100,1),(51,7411959,7411958,'dev',33.333,1),(51,7411960,7411958,'evf',33.333,1),(51,7411961,7411958,'vfs',33.333,1),(51,7411962,7411959,'pat',50,1),(51,7411963,7411959,'ath',50,1),(51,7411964,7411962,'vmf',50,1),(51,7411965,7411962,'mfs',50,1),(51,7411966,7411964,'dev',20,1),(51,7411967,7411964,'evi',20,1),(51,7411968,7411964,'vic',20,1),(51,7411969,7411964,'ice',20,1),(51,7411970,7411964,'ces',20,1),(51,7411971,7411966,'dis',33.333,1),(51,7411972,7411966,'isk',33.333,1),(51,7411973,7411966,'sks',33.333,1),(51,7411974,7411971,'ven',25,1),(51,7411975,7411971,'end',25,1),(51,7411976,7411971,'ndo',25,1),(51,7411977,7411971,'dor',25,1),(51,7411978,7411974,'mod',33.333,1),(51,7411979,7411974,'ode',33.333,1),(51,7411980,7411974,'del',33.333,1),(51,7411981,7411978,'lun',100,1),(51,7411982,7411981,'cmo',33.333,1),(51,7411983,7411981,'mod',33.333,1),(51,7411984,7411981,'ode',33.333,1),(51,7411985,7411982,'rev',16.667,1),(51,7411986,7411982,'evi',16.667,1),(51,7411987,7411982,'vis',16.667,1),(51,7411988,7411982,'isi',16.667,1),(51,7411989,7411982,'sio',16.667,1),(51,7411990,7411982,'ion',16.667,1),(51,7411991,7411985,'810',50,1),(51,7411992,7411985,'100',50,1),(51,7411993,7411991,'scs',50,1),(51,7411994,7411991,'csi',50,1),(51,7411995,7411993,'lev',33.333,1),(51,7411996,7411993,'eve',33.333,1),(51,7411997,7411993,'vel',33.333,1),(51,7411998,7411995,'pse',25,1),(51,7411999,7411995,'seu',25,1),(51,7412000,7411995,'eud',25,1),(51,7412001,7411995,'udo',25,1),(51,7412002,7411998,'fal',33.333,6),(51,7412003,7411998,'als',33.333,6),(51,7412004,7411998,'lse',33.333,6),(51,7412005,7412002,'sta',25,3),(51,7412006,7412002,'tat',25,3),(51,7412007,7412002,'atu',25,3),(51,7412008,7412002,'tus',25,3),(51,7412009,7412005,'rdm',100,1),(51,7412010,7412009,'cap',20,1),(51,7412011,7412009,'apa',20,1),(51,7412012,7412009,'pab',20,1),(51,7412013,7412009,'abl',20,1),(51,7412014,7412009,'ble',20,1),(51,7412015,7412010,'tru',50,1),(51,7412016,7412010,'rue',50,1),(51,7412017,7412015,'loc',33.333,1),(51,7412018,7412015,'oca',33.333,1),(51,7412019,7412015,'cal',33.333,1),(51,7412020,7412017,'rem',14.286,1),(51,7412021,7412017,'emo',14.286,1),(51,7412022,7412017,'mov',14.286,1),(51,7412023,7412017,'ova',14.286,1),(51,7412024,7412017,'vab',14.286,1),(51,7412025,7412017,'abl',14.286,1),(51,7412026,7412017,'ble',14.286,1),(51,7412027,7412020,'ssd',100,1),(51,7412028,7412027,'off',20,1),(51,7412029,7412027,'ffl',20,1),(51,7412030,7412027,'fli',20,1),(51,7412031,7412027,'lin',20,1),(51,7412032,7412027,'ine',20,1),(51,7412033,7412028,'per',11.111,1),(51,7412034,7412028,'ere',11.111,1),(51,7412035,7412028,'ren',11.111,1),(51,7412036,7412028,'enn',11.111,1),(51,7412037,7412028,'nni',11.111,1),(51,7412038,7412028,'nia',11.111,1),(51,7412039,7412028,'ial',11.111,1),(51,7412040,7412028,'all',11.111,1),(51,7412041,7412028,'lly',11.111,1),(51,7412042,7412033,'res',16.667,1),(51,7412043,7412033,'ese',16.667,1),(51,7412044,7412033,'ser',16.667,1),(51,7412045,7412033,'erv',16.667,1),(51,7412046,7412033,'rve',16.667,1),(51,7412047,7412033,'ved',16.667,1),(51,7412048,7412042,'thi',50,1),(51,7412049,7412042,'hin',50,1),(51,7412050,7412048,'pro',10,1),(51,7412051,7412048,'rov',10,1),(51,7412052,7412048,'ovi',10,1),(51,7412053,7412048,'vis',10,1),(51,7412054,7412048,'isi',10,1),(51,7412055,7412048,'sio',10,1),(51,7412056,7412048,'ion',10,1),(51,7412057,7412048,'oni',10,1),(51,7412058,7412048,'nin',10,1),(51,7412059,7412048,'ing',10,1),(51,7412060,7412050,'yes',100,1),(51,7412061,7412060,'att',16.667,1),(51,7412062,7412060,'tta',16.667,1),(51,7412063,7412060,'tac',16.667,1),(51,7412064,7412060,'ach',16.667,1),(51,7412065,7412060,'che',16.667,1),(51,7412066,7412060,'hed',16.667,1),(51,7412067,7412061,'fil',20,1),(51,7412068,7412061,'ilt',20,1),(51,7412069,7412061,'lte',20,1),(51,7412070,7412061,'ter',20,1),(51,7412071,7412061,'ers',20,1),(51,7412072,7412067,'vaa',50,1),(51,7412073,7412067,'aai',50,1),(51,7412074,7412072,'unk',20,1),(51,7412075,7412072,'nkn',20,1),(51,7412076,7412072,'kno',20,1),(51,7412077,7412072,'now',20,1),(51,7412078,7412072,'own',20,1),(51,7412079,7412074,'oth',33.333,1),(51,7412080,7412074,'the',33.333,1),(51,7412081,7412074,'her',33.333,1),(51,7412082,7412079,'uid',50,1),(51,7412083,7412079,'ids',50,1),(51,7412084,7412082,'vml',100,1),(51,7412085,7412084,'dis',20,1),(51,7412086,7412084,'isp',20,1),(51,7412087,7412084,'spl',20,1),(51,7412088,7412084,'pla',20,1),(51,7412089,7412084,'lay',20,1),(51,7412090,7412085,'nam',50,1),(51,7412091,7412085,'ame',50,1),(52,7412093,7412092,'net',25,3),(52,7412094,7412092,'eta',25,3),(52,7412095,7412092,'tap',25,3),(52,7412096,7412092,'app',25,3),(52,7412097,7412093,'fib',33.333,2),(52,7412098,7412093,'ibr',33.333,2),(52,7412099,7412093,'bre',33.333,2),(52,7412100,7412097,'cha',20,2),(52,7412101,7412097,'han',20,2),(52,7412102,7412097,'ann',20,2),(52,7412103,7412097,'nne',20,2),(52,7412104,7412097,'nel',20,2),(52,7412105,7412100,'dis',50,2),(52,7412106,7412100,'isk',50,2),(52,7412107,7412105,'naa',100,4),(52,7412108,7412107,'600',3.333,4),(52,7412109,7412107,'00a',3.333,4),(52,7412110,7412107,'0a0',3.333,4),(52,7412111,7412107,'a09',3.333,4),(52,7412112,7412107,'098',3.333,4),(52,7412113,7412107,'980',3.333,4),(52,7412114,7412107,'804',3.333,4),(52,7412115,7412107,'044',3.333,4),(52,7412116,7412107,'443',3.333,4),(52,7412117,7412107,'430',3.333,4),(52,7412118,7412107,'307',3.333,4),(52,7412119,7412107,'072',3.333,4),(52,7412120,7412107,'725',3.333,4),(52,7412121,7412107,'259',3.333,4),(52,7412122,7412107,'593',3.333,4),(52,7412123,7412107,'931',3.333,4),(52,7412124,7412107,'313',3.333,4),(52,7412125,7412107,'13f',3.333,4),(52,7412126,7412107,'3f3',3.333,4),(52,7412127,7412107,'f33',3.333,4),(52,7412128,7412107,'334',3.333,4),(52,7412129,7412107,'345',3.333,4),(52,7412130,7412107,'455',3.333,4),(52,7412131,7412107,'556',3.333,4),(52,7412132,7412107,'563',3.333,4),(52,7412133,7412107,'639',3.333,4),(52,7412134,7412107,'393',3.333,4),(52,7412135,7412107,'934',3.333,4),(52,7412136,7412107,'347',3.333,4),(52,7412137,7412107,'472',3.333,4),(52,7412138,7412108,'ser',25,1),(52,7412139,7412108,'eri',25,1),(52,7412140,7412108,'ria',25,1),(52,7412141,7412108,'ial',25,1),(52,7412142,7412138,'siz',50,1),(52,7412143,7412138,'ize',50,1),(52,7412144,7412142,'321',100,1),(52,7412145,7412144,'dev',25,1),(52,7412146,7412144,'evi',25,1),(52,7412147,7412144,'vic',25,1),(52,7412148,7412144,'ice',25,1),(52,7412149,7412145,'typ',50,1),(52,7412150,7412145,'ype',50,1),(52,7412151,7412149,'dir',10,1),(52,7412152,7412149,'ire',10,1),(52,7412153,7412149,'rec',10,1),(52,7412154,7412149,'ect',10,1),(52,7412155,7412149,'cta',10,1),(52,7412156,7412149,'tac',10,1),(52,7412157,7412149,'acc',10,1),(52,7412158,7412149,'cce',10,1),(52,7412159,7412149,'ces',10,1),(52,7412160,7412149,'ess',10,1),(52,7412161,7412151,'mul',14.286,1),(52,7412162,7412151,'ult',14.286,1),(52,7412163,7412151,'lti',14.286,1),(52,7412164,7412151,'tip',14.286,1),(52,7412165,7412151,'ipa',14.286,1),(52,7412166,7412151,'pat',14.286,1),(52,7412167,7412151,'ath',14.286,1),(52,7412168,7412161,'plu',25,1),(52,7412169,7412161,'lug',25,1),(52,7412170,7412161,'ugi',25,1),(52,7412171,7412161,'gin',25,1),(52,7412172,7412168,'nmp',100,1),(52,7412173,7412172,'dev',33.333,1),(52,7412174,7412172,'evf',33.333,1),(52,7412175,7412172,'vfs',33.333,1),(52,7412176,7412173,'pat',50,1),(52,7412177,7412173,'ath',50,1),(52,7412178,7412176,'vmf',50,1),(52,7412179,7412176,'mfs',50,1),(52,7412180,7412178,'dev',20,1),(52,7412181,7412178,'evi',20,1),(52,7412182,7412178,'vic',20,1),(52,7412183,7412178,'ice',20,1),(52,7412184,7412178,'ces',20,1),(52,7412185,7412180,'dis',33.333,1),(52,7412186,7412180,'isk',33.333,1),(52,7412187,7412180,'sks',33.333,1),(52,7412188,7412185,'ven',25,1),(52,7412189,7412185,'end',25,1),(52,7412190,7412185,'ndo',25,1),(52,7412191,7412185,'dor',25,1),(52,7412192,7412188,'mod',33.333,1),(52,7412193,7412188,'ode',33.333,1),(52,7412194,7412188,'del',33.333,1),(52,7412195,7412192,'lun',100,1),(52,7412196,7412195,'cmo',33.333,1),(52,7412197,7412195,'mod',33.333,1),(52,7412198,7412195,'ode',33.333,1),(52,7412199,7412196,'rev',16.667,1),(52,7412200,7412196,'evi',16.667,1),(52,7412201,7412196,'vis',16.667,1),(52,7412202,7412196,'isi',16.667,1),(52,7412203,7412196,'sio',16.667,1),(52,7412204,7412196,'ion',16.667,1),(52,7412205,7412199,'810',50,1),(52,7412206,7412199,'100',50,1),(52,7412207,7412205,'scs',50,1),(52,7412208,7412205,'csi',50,1),(52,7412209,7412207,'lev',33.333,1),(52,7412210,7412207,'eve',33.333,1),(52,7412211,7412207,'vel',33.333,1),(52,7412212,7412209,'pse',25,1),(52,7412213,7412209,'seu',25,1),(52,7412214,7412209,'eud',25,1),(52,7412215,7412209,'udo',25,1),(52,7412216,7412212,'fal',33.333,6),(52,7412217,7412212,'als',33.333,6),(52,7412218,7412212,'lse',33.333,6),(52,7412219,7412216,'sta',25,3),(52,7412220,7412216,'tat',25,3),(52,7412221,7412216,'atu',25,3),(52,7412222,7412216,'tus',25,3),(52,7412223,7412219,'rdm',100,1),(52,7412224,7412223,'cap',20,1),(52,7412225,7412223,'apa',20,1),(52,7412226,7412223,'pab',20,1),(52,7412227,7412223,'abl',20,1),(52,7412228,7412223,'ble',20,1),(52,7412229,7412224,'tru',50,1),(52,7412230,7412224,'rue',50,1),(52,7412231,7412229,'loc',33.333,1),(52,7412232,7412229,'oca',33.333,1),(52,7412233,7412229,'cal',33.333,1),(52,7412234,7412231,'rem',14.286,1),(52,7412235,7412231,'emo',14.286,1),(52,7412236,7412231,'mov',14.286,1),(52,7412237,7412231,'ova',14.286,1),(52,7412238,7412231,'vab',14.286,1),(52,7412239,7412231,'abl',14.286,1),(52,7412240,7412231,'ble',14.286,1),(52,7412241,7412234,'ssd',100,1),(52,7412242,7412241,'off',20,1),(52,7412243,7412241,'ffl',20,1),(52,7412244,7412241,'fli',20,1),(52,7412245,7412241,'lin',20,1),(52,7412246,7412241,'ine',20,1),(52,7412247,7412242,'per',11.111,1),(52,7412248,7412242,'ere',11.111,1),(52,7412249,7412242,'ren',11.111,1),(52,7412250,7412242,'enn',11.111,1),(52,7412251,7412242,'nni',11.111,1),(52,7412252,7412242,'nia',11.111,1),(52,7412253,7412242,'ial',11.111,1),(52,7412254,7412242,'all',11.111,1),(52,7412255,7412242,'lly',11.111,1),(52,7412256,7412247,'res',16.667,1),(52,7412257,7412247,'ese',16.667,1),(52,7412258,7412247,'ser',16.667,1),(52,7412259,7412247,'erv',16.667,1),(52,7412260,7412247,'rve',16.667,1),(52,7412261,7412247,'ved',16.667,1),(52,7412262,7412256,'thi',50,1),(52,7412263,7412256,'hin',50,1),(52,7412264,7412262,'pro',10,1),(52,7412265,7412262,'rov',10,1),(52,7412266,7412262,'ovi',10,1),(52,7412267,7412262,'vis',10,1),(52,7412268,7412262,'isi',10,1),(52,7412269,7412262,'sio',10,1),(52,7412270,7412262,'ion',10,1),(52,7412271,7412262,'oni',10,1),(52,7412272,7412262,'nin',10,1),(52,7412273,7412262,'ing',10,1),(52,7412274,7412264,'yes',100,1),(52,7412275,7412274,'att',16.667,1),(52,7412276,7412274,'tta',16.667,1),(52,7412277,7412274,'tac',16.667,1),(52,7412278,7412274,'ach',16.667,1),(52,7412279,7412274,'che',16.667,1),(52,7412280,7412274,'hed',16.667,1),(52,7412281,7412275,'fil',20,1),(52,7412282,7412275,'ilt',20,1),(52,7412283,7412275,'lte',20,1),(52,7412284,7412275,'ter',20,1),(52,7412285,7412275,'ers',20,1),(52,7412286,7412281,'vaa',50,1),(52,7412287,7412281,'aai',50,1),(52,7412288,7412286,'unk',20,1),(52,7412289,7412286,'nkn',20,1),(52,7412290,7412286,'kno',20,1),(52,7412291,7412286,'now',20,1),(52,7412292,7412286,'own',20,1),(52,7412293,7412288,'oth',33.333,1),(52,7412294,7412288,'the',33.333,1),(52,7412295,7412288,'her',33.333,1),(52,7412296,7412293,'uid',50,1),(52,7412297,7412293,'ids',50,1),(52,7412298,7412296,'vml',100,1),(52,7412299,7412298,'dis',20,1),(52,7412300,7412298,'isp',20,1),(52,7412301,7412298,'spl',20,1),(52,7412302,7412298,'pla',20,1),(52,7412303,7412298,'lay',20,1),(52,7412304,7412299,'nam',50,1),(52,7412305,7412299,'ame',50,1),(53,7412307,7412306,'net',25,3),(53,7412308,7412306,'eta',25,3),(53,7412309,7412306,'tap',25,3),(53,7412310,7412306,'app',25,3),(53,7412311,7412307,'fib',33.333,2),(53,7412312,7412307,'ibr',33.333,2),(53,7412313,7412307,'bre',33.333,2),(53,7412314,7412311,'cha',20,2),(53,7412315,7412311,'han',20,2),(53,7412316,7412311,'ann',20,2),(53,7412317,7412311,'nne',20,2),(53,7412318,7412311,'nel',20,2),(53,7412319,7412314,'dis',50,2),(53,7412320,7412314,'isk',50,2),(53,7412321,7412319,'naa',100,4),(53,7412322,7412321,'600',3.333,4),(53,7412323,7412321,'00a',3.333,4),(53,7412324,7412321,'0a0',3.333,4),(53,7412325,7412321,'a09',3.333,4),(53,7412326,7412321,'098',3.333,4),(53,7412327,7412321,'980',3.333,4),(53,7412328,7412321,'804',3.333,4),(53,7412329,7412321,'044',3.333,4),(53,7412330,7412321,'443',3.333,4),(53,7412331,7412321,'430',3.333,4),(53,7412332,7412321,'307',3.333,4),(53,7412333,7412321,'072',3.333,4),(53,7412334,7412321,'725',3.333,4),(53,7412335,7412321,'259',3.333,4),(53,7412336,7412321,'593',3.333,4),(53,7412337,7412321,'931',3.333,4),(53,7412338,7412321,'313',3.333,4),(53,7412339,7412321,'13f',3.333,4),(53,7412340,7412321,'3f3',3.333,4),(53,7412341,7412321,'f33',3.333,4),(53,7412342,7412321,'334',3.333,4),(53,7412343,7412321,'345',3.333,4),(53,7412344,7412321,'455',3.333,4),(53,7412345,7412321,'556',3.333,4),(53,7412346,7412321,'563',3.333,4),(53,7412347,7412321,'639',3.333,4),(53,7412348,7412321,'393',3.333,4),(53,7412349,7412321,'934',3.333,4),(53,7412350,7412321,'347',3.333,4),(53,7412351,7412321,'473',3.333,4),(53,7412352,7412322,'ser',25,1),(53,7412353,7412322,'eri',25,1),(53,7412354,7412322,'ria',25,1),(53,7412355,7412322,'ial',25,1),(53,7412356,7412352,'siz',50,1),(53,7412357,7412352,'ize',50,1),(53,7412358,7412356,'321',100,1),(53,7412359,7412358,'dev',25,1),(53,7412360,7412358,'evi',25,1),(53,7412361,7412358,'vic',25,1),(53,7412362,7412358,'ice',25,1),(53,7412363,7412359,'typ',50,1),(53,7412364,7412359,'ype',50,1),(53,7412365,7412363,'dir',10,1),(53,7412366,7412363,'ire',10,1),(53,7412367,7412363,'rec',10,1),(53,7412368,7412363,'ect',10,1),(53,7412369,7412363,'cta',10,1),(53,7412370,7412363,'tac',10,1),(53,7412371,7412363,'acc',10,1),(53,7412372,7412363,'cce',10,1),(53,7412373,7412363,'ces',10,1),(53,7412374,7412363,'ess',10,1),(53,7412375,7412365,'mul',14.286,1),(53,7412376,7412365,'ult',14.286,1),(53,7412377,7412365,'lti',14.286,1),(53,7412378,7412365,'tip',14.286,1),(53,7412379,7412365,'ipa',14.286,1),(53,7412380,7412365,'pat',14.286,1),(53,7412381,7412365,'ath',14.286,1),(53,7412382,7412375,'plu',25,1),(53,7412383,7412375,'lug',25,1),(53,7412384,7412375,'ugi',25,1),(53,7412385,7412375,'gin',25,1),(53,7412386,7412382,'nmp',100,1),(53,7412387,7412386,'dev',33.333,1),(53,7412388,7412386,'evf',33.333,1),(53,7412389,7412386,'vfs',33.333,1),(53,7412390,7412387,'pat',50,1),(53,7412391,7412387,'ath',50,1),(53,7412392,7412390,'vmf',50,1),(53,7412393,7412390,'mfs',50,1),(53,7412394,7412392,'dev',20,1),(53,7412395,7412392,'evi',20,1),(53,7412396,7412392,'vic',20,1),(53,7412397,7412392,'ice',20,1),(53,7412398,7412392,'ces',20,1),(53,7412399,7412394,'dis',33.333,1),(53,7412400,7412394,'isk',33.333,1),(53,7412401,7412394,'sks',33.333,1),(53,7412402,7412399,'ven',25,1),(53,7412403,7412399,'end',25,1),(53,7412404,7412399,'ndo',25,1),(53,7412405,7412399,'dor',25,1),(53,7412406,7412402,'mod',33.333,1),(53,7412407,7412402,'ode',33.333,1),(53,7412408,7412402,'del',33.333,1),(53,7412409,7412406,'lun',100,1),(53,7412410,7412409,'cmo',33.333,1),(53,7412411,7412409,'mod',33.333,1),(53,7412412,7412409,'ode',33.333,1),(53,7412413,7412410,'rev',16.667,1),(53,7412414,7412410,'evi',16.667,1),(53,7412415,7412410,'vis',16.667,1),(53,7412416,7412410,'isi',16.667,1),(53,7412417,7412410,'sio',16.667,1),(53,7412418,7412410,'ion',16.667,1),(53,7412419,7412413,'810',50,1),(53,7412420,7412413,'100',50,1),(53,7412421,7412419,'scs',50,1),(53,7412422,7412419,'csi',50,1),(53,7412423,7412421,'lev',33.333,1),(53,7412424,7412421,'eve',33.333,1),(53,7412425,7412421,'vel',33.333,1),(53,7412426,7412423,'pse',25,1),(53,7412427,7412423,'seu',25,1),(53,7412428,7412423,'eud',25,1),(53,7412429,7412423,'udo',25,1),(53,7412430,7412426,'fal',33.333,6),(53,7412431,7412426,'als',33.333,6),(53,7412432,7412426,'lse',33.333,6),(53,7412433,7412430,'sta',25,3),(53,7412434,7412430,'tat',25,3),(53,7412435,7412430,'atu',25,3),(53,7412436,7412430,'tus',25,3),(53,7412437,7412433,'rdm',100,1),(53,7412438,7412437,'cap',20,1),(53,7412439,7412437,'apa',20,1),(53,7412440,7412437,'pab',20,1),(53,7412441,7412437,'abl',20,1),(53,7412442,7412437,'ble',20,1),(53,7412443,7412438,'tru',50,1),(53,7412444,7412438,'rue',50,1),(53,7412445,7412443,'loc',33.333,1),(53,7412446,7412443,'oca',33.333,1),(53,7412447,7412443,'cal',33.333,1),(53,7412448,7412445,'rem',14.286,1),(53,7412449,7412445,'emo',14.286,1),(53,7412450,7412445,'mov',14.286,1),(53,7412451,7412445,'ova',14.286,1),(53,7412452,7412445,'vab',14.286,1),(53,7412453,7412445,'abl',14.286,1),(53,7412454,7412445,'ble',14.286,1),(53,7412455,7412448,'ssd',100,1),(53,7412456,7412455,'off',20,1),(53,7412457,7412455,'ffl',20,1),(53,7412458,7412455,'fli',20,1),(53,7412459,7412455,'lin',20,1),(53,7412460,7412455,'ine',20,1),(53,7412461,7412456,'per',11.111,1),(53,7412462,7412456,'ere',11.111,1),(53,7412463,7412456,'ren',11.111,1),(53,7412464,7412456,'enn',11.111,1),(53,7412465,7412456,'nni',11.111,1),(53,7412466,7412456,'nia',11.111,1),(53,7412467,7412456,'ial',11.111,1),(53,7412468,7412456,'all',11.111,1),(53,7412469,7412456,'lly',11.111,1),(53,7412470,7412461,'res',16.667,1),(53,7412471,7412461,'ese',16.667,1),(53,7412472,7412461,'ser',16.667,1),(53,7412473,7412461,'erv',16.667,1),(53,7412474,7412461,'rve',16.667,1),(53,7412475,7412461,'ved',16.667,1),(53,7412476,7412470,'thi',50,1),(53,7412477,7412470,'hin',50,1),(53,7412478,7412476,'pro',10,1),(53,7412479,7412476,'rov',10,1),(53,7412480,7412476,'ovi',10,1),(53,7412481,7412476,'vis',10,1),(53,7412482,7412476,'isi',10,1),(53,7412483,7412476,'sio',10,1),(53,7412484,7412476,'ion',10,1),(53,7412485,7412476,'oni',10,1),(53,7412486,7412476,'nin',10,1),(53,7412487,7412476,'ing',10,1),(53,7412488,7412478,'yes',100,1),(53,7412489,7412488,'att',16.667,1),(53,7412490,7412488,'tta',16.667,1),(53,7412491,7412488,'tac',16.667,1),(53,7412492,7412488,'ach',16.667,1),(53,7412493,7412488,'che',16.667,1),(53,7412494,7412488,'hed',16.667,1),(53,7412495,7412489,'fil',20,1),(53,7412496,7412489,'ilt',20,1),(53,7412497,7412489,'lte',20,1),(53,7412498,7412489,'ter',20,1),(53,7412499,7412489,'ers',20,1),(53,7412500,7412495,'vaa',50,1),(53,7412501,7412495,'aai',50,1),(53,7412502,7412500,'unk',20,1),(53,7412503,7412500,'nkn',20,1),(53,7412504,7412500,'kno',20,1),(53,7412505,7412500,'now',20,1),(53,7412506,7412500,'own',20,1),(53,7412507,7412502,'oth',33.333,1),(53,7412508,7412502,'the',33.333,1),(53,7412509,7412502,'her',33.333,1),(53,7412510,7412507,'uid',50,1),(53,7412511,7412507,'ids',50,1),(53,7412512,7412510,'vml',100,1),(53,7412513,7412512,'dis',20,1),(53,7412514,7412512,'isp',20,1),(53,7412515,7412512,'spl',20,1),(53,7412516,7412512,'pla',20,1),(53,7412517,7412512,'lay',20,1),(53,7412518,7412513,'nam',50,1),(53,7412519,7412513,'ame',50,1),(54,7412521,7412520,'net',25,3),(54,7412522,7412520,'eta',25,3),(54,7412523,7412520,'tap',25,3),(54,7412524,7412520,'app',25,3),(54,7412525,7412521,'fib',33.333,2),(54,7412526,7412521,'ibr',33.333,2),(54,7412527,7412521,'bre',33.333,2),(54,7412528,7412525,'cha',20,2),(54,7412529,7412525,'han',20,2),(54,7412530,7412525,'ann',20,2),(54,7412531,7412525,'nne',20,2),(54,7412532,7412525,'nel',20,2),(54,7412533,7412528,'dis',50,2),(54,7412534,7412528,'isk',50,2),(54,7412535,7412533,'naa',100,4),(54,7412536,7412535,'600',3.333,4),(54,7412537,7412535,'00a',3.333,4),(54,7412538,7412535,'0a0',3.333,4),(54,7412539,7412535,'a09',3.333,4),(54,7412540,7412535,'098',3.333,4),(54,7412541,7412535,'980',3.333,4),(54,7412542,7412535,'804',3.333,4),(54,7412543,7412535,'044',3.333,4),(54,7412544,7412535,'443',3.333,4),(54,7412545,7412535,'430',3.333,4),(54,7412546,7412535,'307',3.333,4),(54,7412547,7412535,'072',3.333,4),(54,7412548,7412535,'725',3.333,4),(54,7412549,7412535,'259',3.333,4),(54,7412550,7412535,'593',3.333,4),(54,7412551,7412535,'931',3.333,4),(54,7412552,7412535,'313',3.333,4),(54,7412553,7412535,'13f',3.333,4),(54,7412554,7412535,'3f3',3.333,4),(54,7412555,7412535,'f33',3.333,4),(54,7412556,7412535,'334',3.333,4),(54,7412557,7412535,'345',3.333,4),(54,7412558,7412535,'455',3.333,4),(54,7412559,7412535,'556',3.333,4),(54,7412560,7412535,'563',3.333,4),(54,7412561,7412535,'639',3.333,4),(54,7412562,7412535,'393',3.333,4),(54,7412563,7412535,'934',3.333,4),(54,7412564,7412535,'347',3.333,4),(54,7412565,7412535,'474',3.333,4),(54,7412566,7412536,'ser',25,1),(54,7412567,7412536,'eri',25,1),(54,7412568,7412536,'ria',25,1),(54,7412569,7412536,'ial',25,1),(54,7412570,7412566,'siz',50,1),(54,7412571,7412566,'ize',50,1),(54,7412572,7412570,'321',100,1),(54,7412573,7412572,'dev',25,1),(54,7412574,7412572,'evi',25,1),(54,7412575,7412572,'vic',25,1),(54,7412576,7412572,'ice',25,1),(54,7412577,7412573,'typ',50,1),(54,7412578,7412573,'ype',50,1),(54,7412579,7412577,'dir',10,1),(54,7412580,7412577,'ire',10,1),(54,7412581,7412577,'rec',10,1),(54,7412582,7412577,'ect',10,1),(54,7412583,7412577,'cta',10,1),(54,7412584,7412577,'tac',10,1),(54,7412585,7412577,'acc',10,1),(54,7412586,7412577,'cce',10,1),(54,7412587,7412577,'ces',10,1),(54,7412588,7412577,'ess',10,1),(54,7412589,7412579,'mul',14.286,1),(54,7412590,7412579,'ult',14.286,1),(54,7412591,7412579,'lti',14.286,1),(54,7412592,7412579,'tip',14.286,1),(54,7412593,7412579,'ipa',14.286,1),(54,7412594,7412579,'pat',14.286,1),(54,7412595,7412579,'ath',14.286,1),(54,7412596,7412589,'plu',25,1),(54,7412597,7412589,'lug',25,1),(54,7412598,7412589,'ugi',25,1),(54,7412599,7412589,'gin',25,1),(54,7412600,7412596,'nmp',100,1),(54,7412601,7412600,'dev',33.333,1),(54,7412602,7412600,'evf',33.333,1),(54,7412603,7412600,'vfs',33.333,1),(54,7412604,7412601,'pat',50,1),(54,7412605,7412601,'ath',50,1),(54,7412606,7412604,'vmf',50,1),(54,7412607,7412604,'mfs',50,1),(54,7412608,7412606,'dev',20,1),(54,7412609,7412606,'evi',20,1),(54,7412610,7412606,'vic',20,1),(54,7412611,7412606,'ice',20,1),(54,7412612,7412606,'ces',20,1),(54,7412613,7412608,'dis',33.333,1),(54,7412614,7412608,'isk',33.333,1),(54,7412615,7412608,'sks',33.333,1),(54,7412616,7412613,'ven',25,1),(54,7412617,7412613,'end',25,1),(54,7412618,7412613,'ndo',25,1),(54,7412619,7412613,'dor',25,1),(54,7412620,7412616,'mod',33.333,1),(54,7412621,7412616,'ode',33.333,1),(54,7412622,7412616,'del',33.333,1),(54,7412623,7412620,'lun',100,1),(54,7412624,7412623,'cmo',33.333,1),(54,7412625,7412623,'mod',33.333,1),(54,7412626,7412623,'ode',33.333,1),(54,7412627,7412624,'rev',16.667,1),(54,7412628,7412624,'evi',16.667,1),(54,7412629,7412624,'vis',16.667,1),(54,7412630,7412624,'isi',16.667,1),(54,7412631,7412624,'sio',16.667,1),(54,7412632,7412624,'ion',16.667,1),(54,7412633,7412627,'810',50,1),(54,7412634,7412627,'100',50,1),(54,7412635,7412633,'scs',50,1),(54,7412636,7412633,'csi',50,1),(54,7412637,7412635,'lev',33.333,1),(54,7412638,7412635,'eve',33.333,1),(54,7412639,7412635,'vel',33.333,1),(54,7412640,7412637,'pse',25,1),(54,7412641,7412637,'seu',25,1),(54,7412642,7412637,'eud',25,1),(54,7412643,7412637,'udo',25,1),(54,7412644,7412640,'fal',33.333,6),(54,7412645,7412640,'als',33.333,6),(54,7412646,7412640,'lse',33.333,6),(54,7412647,7412644,'sta',25,3),(54,7412648,7412644,'tat',25,3),(54,7412649,7412644,'atu',25,3),(54,7412650,7412644,'tus',25,3),(54,7412651,7412647,'rdm',100,1),(54,7412652,7412651,'cap',20,1),(54,7412653,7412651,'apa',20,1),(54,7412654,7412651,'pab',20,1),(54,7412655,7412651,'abl',20,1),(54,7412656,7412651,'ble',20,1),(54,7412657,7412652,'tru',50,1),(54,7412658,7412652,'rue',50,1),(54,7412659,7412657,'loc',33.333,1),(54,7412660,7412657,'oca',33.333,1),(54,7412661,7412657,'cal',33.333,1),(54,7412662,7412659,'rem',14.286,1),(54,7412663,7412659,'emo',14.286,1),(54,7412664,7412659,'mov',14.286,1),(54,7412665,7412659,'ova',14.286,1),(54,7412666,7412659,'vab',14.286,1),(54,7412667,7412659,'abl',14.286,1),(54,7412668,7412659,'ble',14.286,1),(54,7412669,7412662,'ssd',100,1),(54,7412670,7412669,'off',20,1),(54,7412671,7412669,'ffl',20,1),(54,7412672,7412669,'fli',20,1),(54,7412673,7412669,'lin',20,1),(54,7412674,7412669,'ine',20,1),(54,7412675,7412670,'per',11.111,1),(54,7412676,7412670,'ere',11.111,1),(54,7412677,7412670,'ren',11.111,1),(54,7412678,7412670,'enn',11.111,1),(54,7412679,7412670,'nni',11.111,1),(54,7412680,7412670,'nia',11.111,1),(54,7412681,7412670,'ial',11.111,1),(54,7412682,7412670,'all',11.111,1),(54,7412683,7412670,'lly',11.111,1),(54,7412684,7412675,'res',16.667,1),(54,7412685,7412675,'ese',16.667,1),(54,7412686,7412675,'ser',16.667,1),(54,7412687,7412675,'erv',16.667,1),(54,7412688,7412675,'rve',16.667,1),(54,7412689,7412675,'ved',16.667,1),(54,7412690,7412684,'thi',50,1),(54,7412691,7412684,'hin',50,1),(54,7412692,7412690,'pro',10,1),(54,7412693,7412690,'rov',10,1),(54,7412694,7412690,'ovi',10,1),(54,7412695,7412690,'vis',10,1),(54,7412696,7412690,'isi',10,1),(54,7412697,7412690,'sio',10,1),(54,7412698,7412690,'ion',10,1),(54,7412699,7412690,'oni',10,1),(54,7412700,7412690,'nin',10,1),(54,7412701,7412690,'ing',10,1),(54,7412702,7412692,'yes',100,1),(54,7412703,7412702,'att',16.667,1),(54,7412704,7412702,'tta',16.667,1),(54,7412705,7412702,'tac',16.667,1),(54,7412706,7412702,'ach',16.667,1),(54,7412707,7412702,'che',16.667,1),(54,7412708,7412702,'hed',16.667,1),(54,7412709,7412703,'fil',20,1),(54,7412710,7412703,'ilt',20,1),(54,7412711,7412703,'lte',20,1),(54,7412712,7412703,'ter',20,1),(54,7412713,7412703,'ers',20,1),(54,7412714,7412709,'vaa',50,1),(54,7412715,7412709,'aai',50,1),(54,7412716,7412714,'unk',20,1),(54,7412717,7412714,'nkn',20,1),(54,7412718,7412714,'kno',20,1),(54,7412719,7412714,'now',20,1),(54,7412720,7412714,'own',20,1),(54,7412721,7412716,'oth',33.333,1),(54,7412722,7412716,'the',33.333,1),(54,7412723,7412716,'her',33.333,1),(54,7412724,7412721,'uid',50,1),(54,7412725,7412721,'ids',50,1),(54,7412726,7412724,'vml',100,1),(54,7412727,7412726,'dis',20,1),(54,7412728,7412726,'isp',20,1),(54,7412729,7412726,'spl',20,1),(54,7412730,7412726,'pla',20,1),(54,7412731,7412726,'lay',20,1),(54,7412732,7412727,'nam',50,1),(54,7412733,7412727,'ame',50,1),(55,7412735,7412734,'net',25,3),(55,7412736,7412734,'eta',25,3),(55,7412737,7412734,'tap',25,3),(55,7412738,7412734,'app',25,3),(55,7412739,7412735,'fib',33.333,2),(55,7412740,7412735,'ibr',33.333,2),(55,7412741,7412735,'bre',33.333,2),(55,7412742,7412739,'cha',20,2),(55,7412743,7412739,'han',20,2),(55,7412744,7412739,'ann',20,2),(55,7412745,7412739,'nne',20,2),(55,7412746,7412739,'nel',20,2),(55,7412747,7412742,'dis',50,2),(55,7412748,7412742,'isk',50,2),(55,7412749,7412747,'naa',100,4),(55,7412750,7412749,'600',3.333,4),(55,7412751,7412749,'00a',3.333,4),(55,7412752,7412749,'0a0',3.333,4),(55,7412753,7412749,'a09',3.333,4),(55,7412754,7412749,'098',3.333,4),(55,7412755,7412749,'980',3.333,4),(55,7412756,7412749,'804',3.333,4),(55,7412757,7412749,'044',3.333,4),(55,7412758,7412749,'443',3.333,4),(55,7412759,7412749,'430',3.333,4),(55,7412760,7412749,'307',3.333,4),(55,7412761,7412749,'072',3.333,4),(55,7412762,7412749,'725',3.333,4),(55,7412763,7412749,'259',3.333,4),(55,7412764,7412749,'593',3.333,4),(55,7412765,7412749,'931',3.333,4),(55,7412766,7412749,'313',3.333,4),(55,7412767,7412749,'13f',3.333,4),(55,7412768,7412749,'3f3',3.333,4),(55,7412769,7412749,'f33',3.333,4),(55,7412770,7412749,'334',3.333,4),(55,7412771,7412749,'345',3.333,4),(55,7412772,7412749,'455',3.333,4),(55,7412773,7412749,'556',3.333,4),(55,7412774,7412749,'563',3.333,4),(55,7412775,7412749,'639',3.333,4),(55,7412776,7412749,'393',3.333,4),(55,7412777,7412749,'934',3.333,4),(55,7412778,7412749,'347',3.333,4),(55,7412779,7412749,'475',3.333,4),(55,7412780,7412750,'ser',25,1),(55,7412781,7412750,'eri',25,1),(55,7412782,7412750,'ria',25,1),(55,7412783,7412750,'ial',25,1),(55,7412784,7412780,'siz',50,1),(55,7412785,7412780,'ize',50,1),(55,7412786,7412784,'321',100,1),(55,7412787,7412786,'dev',25,1),(55,7412788,7412786,'evi',25,1),(55,7412789,7412786,'vic',25,1),(55,7412790,7412786,'ice',25,1),(55,7412791,7412787,'typ',50,1),(55,7412792,7412787,'ype',50,1),(55,7412793,7412791,'dir',10,1),(55,7412794,7412791,'ire',10,1),(55,7412795,7412791,'rec',10,1),(55,7412796,7412791,'ect',10,1),(55,7412797,7412791,'cta',10,1),(55,7412798,7412791,'tac',10,1),(55,7412799,7412791,'acc',10,1),(55,7412800,7412791,'cce',10,1),(55,7412801,7412791,'ces',10,1),(55,7412802,7412791,'ess',10,1),(55,7412803,7412793,'mul',14.286,1),(55,7412804,7412793,'ult',14.286,1),(55,7412805,7412793,'lti',14.286,1),(55,7412806,7412793,'tip',14.286,1),(55,7412807,7412793,'ipa',14.286,1),(55,7412808,7412793,'pat',14.286,1),(55,7412809,7412793,'ath',14.286,1),(55,7412810,7412803,'plu',25,1),(55,7412811,7412803,'lug',25,1),(55,7412812,7412803,'ugi',25,1),(55,7412813,7412803,'gin',25,1),(55,7412814,7412810,'nmp',100,1),(55,7412815,7412814,'dev',33.333,1),(55,7412816,7412814,'evf',33.333,1),(55,7412817,7412814,'vfs',33.333,1),(55,7412818,7412815,'pat',50,1),(55,7412819,7412815,'ath',50,1),(55,7412820,7412818,'vmf',50,1),(55,7412821,7412818,'mfs',50,1),(55,7412822,7412820,'dev',20,1),(55,7412823,7412820,'evi',20,1),(55,7412824,7412820,'vic',20,1),(55,7412825,7412820,'ice',20,1),(55,7412826,7412820,'ces',20,1),(55,7412827,7412822,'dis',33.333,1),(55,7412828,7412822,'isk',33.333,1),(55,7412829,7412822,'sks',33.333,1),(55,7412830,7412827,'ven',25,1),(55,7412831,7412827,'end',25,1),(55,7412832,7412827,'ndo',25,1),(55,7412833,7412827,'dor',25,1),(55,7412834,7412830,'mod',33.333,1),(55,7412835,7412830,'ode',33.333,1),(55,7412836,7412830,'del',33.333,1),(55,7412837,7412834,'lun',100,1),(55,7412838,7412837,'cmo',33.333,1),(55,7412839,7412837,'mod',33.333,1),(55,7412840,7412837,'ode',33.333,1),(55,7412841,7412838,'rev',16.667,1),(55,7412842,7412838,'evi',16.667,1),(55,7412843,7412838,'vis',16.667,1),(55,7412844,7412838,'isi',16.667,1),(55,7412845,7412838,'sio',16.667,1),(55,7412846,7412838,'ion',16.667,1),(55,7412847,7412841,'810',50,1),(55,7412848,7412841,'100',50,1),(55,7412849,7412847,'scs',50,1),(55,7412850,7412847,'csi',50,1),(55,7412851,7412849,'lev',33.333,1),(55,7412852,7412849,'eve',33.333,1),(55,7412853,7412849,'vel',33.333,1),(55,7412854,7412851,'pse',25,1),(55,7412855,7412851,'seu',25,1),(55,7412856,7412851,'eud',25,1),(55,7412857,7412851,'udo',25,1),(55,7412858,7412854,'fal',33.333,6),(55,7412859,7412854,'als',33.333,6),(55,7412860,7412854,'lse',33.333,6),(55,7412861,7412858,'sta',25,3),(55,7412862,7412858,'tat',25,3),(55,7412863,7412858,'atu',25,3),(55,7412864,7412858,'tus',25,3),(55,7412865,7412861,'rdm',100,1),(55,7412866,7412865,'cap',20,1),(55,7412867,7412865,'apa',20,1),(55,7412868,7412865,'pab',20,1),(55,7412869,7412865,'abl',20,1),(55,7412870,7412865,'ble',20,1),(55,7412871,7412866,'tru',50,1),(55,7412872,7412866,'rue',50,1),(55,7412873,7412871,'loc',33.333,1),(55,7412874,7412871,'oca',33.333,1),(55,7412875,7412871,'cal',33.333,1),(55,7412876,7412873,'rem',14.286,1),(55,7412877,7412873,'emo',14.286,1),(55,7412878,7412873,'mov',14.286,1),(55,7412879,7412873,'ova',14.286,1),(55,7412880,7412873,'vab',14.286,1),(55,7412881,7412873,'abl',14.286,1),(55,7412882,7412873,'ble',14.286,1),(55,7412883,7412876,'ssd',100,1),(55,7412884,7412883,'off',20,1),(55,7412885,7412883,'ffl',20,1),(55,7412886,7412883,'fli',20,1),(55,7412887,7412883,'lin',20,1),(55,7412888,7412883,'ine',20,1),(55,7412889,7412884,'per',11.111,1),(55,7412890,7412884,'ere',11.111,1),(55,7412891,7412884,'ren',11.111,1),(55,7412892,7412884,'enn',11.111,1),(55,7412893,7412884,'nni',11.111,1),(55,7412894,7412884,'nia',11.111,1),(55,7412895,7412884,'ial',11.111,1),(55,7412896,7412884,'all',11.111,1),(55,7412897,7412884,'lly',11.111,1),(55,7412898,7412889,'res',16.667,1),(55,7412899,7412889,'ese',16.667,1),(55,7412900,7412889,'ser',16.667,1),(55,7412901,7412889,'erv',16.667,1),(55,7412902,7412889,'rve',16.667,1),(55,7412903,7412889,'ved',16.667,1),(55,7412904,7412898,'thi',50,1),(55,7412905,7412898,'hin',50,1),(55,7412906,7412904,'pro',10,1),(55,7412907,7412904,'rov',10,1),(55,7412908,7412904,'ovi',10,1),(55,7412909,7412904,'vis',10,1),(55,7412910,7412904,'isi',10,1),(55,7412911,7412904,'sio',10,1),(55,7412912,7412904,'ion',10,1),(55,7412913,7412904,'oni',10,1),(55,7412914,7412904,'nin',10,1),(55,7412915,7412904,'ing',10,1),(55,7412916,7412906,'yes',100,1),(55,7412917,7412916,'att',16.667,1),(55,7412918,7412916,'tta',16.667,1),(55,7412919,7412916,'tac',16.667,1),(55,7412920,7412916,'ach',16.667,1),(55,7412921,7412916,'che',16.667,1),(55,7412922,7412916,'hed',16.667,1),(55,7412923,7412917,'fil',20,1),(55,7412924,7412917,'ilt',20,1),(55,7412925,7412917,'lte',20,1),(55,7412926,7412917,'ter',20,1),(55,7412927,7412917,'ers',20,1),(55,7412928,7412923,'vaa',50,1),(55,7412929,7412923,'aai',50,1),(55,7412930,7412928,'unk',20,1),(55,7412931,7412928,'nkn',20,1),(55,7412932,7412928,'kno',20,1),(55,7412933,7412928,'now',20,1),(55,7412934,7412928,'own',20,1),(55,7412935,7412930,'oth',33.333,1),(55,7412936,7412930,'the',33.333,1),(55,7412937,7412930,'her',33.333,1),(55,7412938,7412935,'uid',50,1),(55,7412939,7412935,'ids',50,1),(55,7412940,7412938,'vml',100,1),(55,7412941,7412940,'dis',20,1),(55,7412942,7412940,'isp',20,1),(55,7412943,7412940,'spl',20,1),(55,7412944,7412940,'pla',20,1),(55,7412945,7412940,'lay',20,1),(55,7412946,7412941,'nam',50,1),(55,7412947,7412941,'ame',50,1),(56,7412949,7412948,'net',25,3),(56,7412950,7412948,'eta',25,3),(56,7412951,7412948,'tap',25,3),(56,7412952,7412948,'app',25,3),(56,7412953,7412949,'fib',33.333,2),(56,7412954,7412949,'ibr',33.333,2),(56,7412955,7412949,'bre',33.333,2),(56,7412956,7412953,'cha',20,2),(56,7412957,7412953,'han',20,2),(56,7412958,7412953,'ann',20,2),(56,7412959,7412953,'nne',20,2),(56,7412960,7412953,'nel',20,2),(56,7412961,7412956,'dis',50,2),(56,7412962,7412956,'isk',50,2),(56,7412963,7412961,'naa',100,4),(56,7412964,7412963,'600',3.333,4),(56,7412965,7412963,'00a',3.333,4),(56,7412966,7412963,'0a0',3.333,4),(56,7412967,7412963,'a09',3.333,4),(56,7412968,7412963,'098',3.333,4),(56,7412969,7412963,'980',3.333,4),(56,7412970,7412963,'804',3.333,4),(56,7412971,7412963,'044',3.333,4),(56,7412972,7412963,'443',3.333,4),(56,7412973,7412963,'430',3.333,4),(56,7412974,7412963,'307',3.333,4),(56,7412975,7412963,'072',3.333,4),(56,7412976,7412963,'725',3.333,4),(56,7412977,7412963,'259',3.333,4),(56,7412978,7412963,'593',3.333,4),(56,7412979,7412963,'931',3.333,4),(56,7412980,7412963,'313',3.333,4),(56,7412981,7412963,'13f',3.333,4),(56,7412982,7412963,'3f3',3.333,4),(56,7412983,7412963,'f33',3.333,4),(56,7412984,7412963,'334',3.333,4),(56,7412985,7412963,'345',3.333,4),(56,7412986,7412963,'455',3.333,4),(56,7412987,7412963,'556',3.333,4),(56,7412988,7412963,'563',3.333,4),(56,7412989,7412963,'639',3.333,4),(56,7412990,7412963,'393',3.333,4),(56,7412991,7412963,'934',3.333,4),(56,7412992,7412963,'347',3.333,4),(56,7412993,7412963,'476',3.333,4),(56,7412994,7412964,'ser',25,1),(56,7412995,7412964,'eri',25,1),(56,7412996,7412964,'ria',25,1),(56,7412997,7412964,'ial',25,1),(56,7412998,7412994,'siz',50,1),(56,7412999,7412994,'ize',50,1),(56,7413000,7412998,'321',100,1),(56,7413001,7413000,'dev',25,1),(56,7413002,7413000,'evi',25,1),(56,7413003,7413000,'vic',25,1),(56,7413004,7413000,'ice',25,1),(56,7413005,7413001,'typ',50,1),(56,7413006,7413001,'ype',50,1),(56,7413007,7413005,'dir',10,1),(56,7413008,7413005,'ire',10,1),(56,7413009,7413005,'rec',10,1),(56,7413010,7413005,'ect',10,1),(56,7413011,7413005,'cta',10,1),(56,7413012,7413005,'tac',10,1),(56,7413013,7413005,'acc',10,1),(56,7413014,7413005,'cce',10,1),(56,7413015,7413005,'ces',10,1),(56,7413016,7413005,'ess',10,1),(56,7413017,7413007,'mul',14.286,1),(56,7413018,7413007,'ult',14.286,1),(56,7413019,7413007,'lti',14.286,1),(56,7413020,7413007,'tip',14.286,1),(56,7413021,7413007,'ipa',14.286,1),(56,7413022,7413007,'pat',14.286,1),(56,7413023,7413007,'ath',14.286,1),(56,7413024,7413017,'plu',25,1),(56,7413025,7413017,'lug',25,1),(56,7413026,7413017,'ugi',25,1),(56,7413027,7413017,'gin',25,1),(56,7413028,7413024,'nmp',100,1),(56,7413029,7413028,'dev',33.333,1),(56,7413030,7413028,'evf',33.333,1),(56,7413031,7413028,'vfs',33.333,1),(56,7413032,7413029,'pat',50,1),(56,7413033,7413029,'ath',50,1),(56,7413034,7413032,'vmf',50,1),(56,7413035,7413032,'mfs',50,1),(56,7413036,7413034,'dev',20,1),(56,7413037,7413034,'evi',20,1),(56,7413038,7413034,'vic',20,1),(56,7413039,7413034,'ice',20,1),(56,7413040,7413034,'ces',20,1),(56,7413041,7413036,'dis',33.333,1),(56,7413042,7413036,'isk',33.333,1),(56,7413043,7413036,'sks',33.333,1),(56,7413044,7413041,'ven',25,1),(56,7413045,7413041,'end',25,1),(56,7413046,7413041,'ndo',25,1),(56,7413047,7413041,'dor',25,1),(56,7413048,7413044,'mod',33.333,1),(56,7413049,7413044,'ode',33.333,1),(56,7413050,7413044,'del',33.333,1),(56,7413051,7413048,'lun',100,1),(56,7413052,7413051,'cmo',33.333,1),(56,7413053,7413051,'mod',33.333,1),(56,7413054,7413051,'ode',33.333,1),(56,7413055,7413052,'rev',16.667,1),(56,7413056,7413052,'evi',16.667,1),(56,7413057,7413052,'vis',16.667,1),(56,7413058,7413052,'isi',16.667,1),(56,7413059,7413052,'sio',16.667,1),(56,7413060,7413052,'ion',16.667,1),(56,7413061,7413055,'810',50,1),(56,7413062,7413055,'100',50,1),(56,7413063,7413061,'scs',50,1),(56,7413064,7413061,'csi',50,1),(56,7413065,7413063,'lev',33.333,1),(56,7413066,7413063,'eve',33.333,1),(56,7413067,7413063,'vel',33.333,1),(56,7413068,7413065,'pse',25,1),(56,7413069,7413065,'seu',25,1),(56,7413070,7413065,'eud',25,1),(56,7413071,7413065,'udo',25,1),(56,7413072,7413068,'fal',33.333,6),(56,7413073,7413068,'als',33.333,6),(56,7413074,7413068,'lse',33.333,6),(56,7413075,7413072,'sta',25,3),(56,7413076,7413072,'tat',25,3),(56,7413077,7413072,'atu',25,3),(56,7413078,7413072,'tus',25,3),(56,7413079,7413075,'rdm',100,1),(56,7413080,7413079,'cap',20,1),(56,7413081,7413079,'apa',20,1),(56,7413082,7413079,'pab',20,1),(56,7413083,7413079,'abl',20,1),(56,7413084,7413079,'ble',20,1),(56,7413085,7413080,'tru',50,1),(56,7413086,7413080,'rue',50,1),(56,7413087,7413085,'loc',33.333,1),(56,7413088,7413085,'oca',33.333,1),(56,7413089,7413085,'cal',33.333,1),(56,7413090,7413087,'rem',14.286,1),(56,7413091,7413087,'emo',14.286,1),(56,7413092,7413087,'mov',14.286,1),(56,7413093,7413087,'ova',14.286,1),(56,7413094,7413087,'vab',14.286,1),(56,7413095,7413087,'abl',14.286,1),(56,7413096,7413087,'ble',14.286,1),(56,7413097,7413090,'ssd',100,1),(56,7413098,7413097,'off',20,1),(56,7413099,7413097,'ffl',20,1),(56,7413100,7413097,'fli',20,1),(56,7413101,7413097,'lin',20,1),(56,7413102,7413097,'ine',20,1),(56,7413103,7413098,'per',11.111,1),(56,7413104,7413098,'ere',11.111,1),(56,7413105,7413098,'ren',11.111,1),(56,7413106,7413098,'enn',11.111,1),(56,7413107,7413098,'nni',11.111,1),(56,7413108,7413098,'nia',11.111,1),(56,7413109,7413098,'ial',11.111,1),(56,7413110,7413098,'all',11.111,1),(56,7413111,7413098,'lly',11.111,1),(56,7413112,7413103,'res',16.667,1),(56,7413113,7413103,'ese',16.667,1),(56,7413114,7413103,'ser',16.667,1),(56,7413115,7413103,'erv',16.667,1),(56,7413116,7413103,'rve',16.667,1),(56,7413117,7413103,'ved',16.667,1),(56,7413118,7413112,'thi',50,1),(56,7413119,7413112,'hin',50,1),(56,7413120,7413118,'pro',10,1),(56,7413121,7413118,'rov',10,1),(56,7413122,7413118,'ovi',10,1),(56,7413123,7413118,'vis',10,1),(56,7413124,7413118,'isi',10,1),(56,7413125,7413118,'sio',10,1),(56,7413126,7413118,'ion',10,1),(56,7413127,7413118,'oni',10,1),(56,7413128,7413118,'nin',10,1),(56,7413129,7413118,'ing',10,1),(56,7413130,7413120,'yes',100,1),(56,7413131,7413130,'att',16.667,1),(56,7413132,7413130,'tta',16.667,1),(56,7413133,7413130,'tac',16.667,1),(56,7413134,7413130,'ach',16.667,1),(56,7413135,7413130,'che',16.667,1),(56,7413136,7413130,'hed',16.667,1),(56,7413137,7413131,'fil',20,1),(56,7413138,7413131,'ilt',20,1),(56,7413139,7413131,'lte',20,1),(56,7413140,7413131,'ter',20,1),(56,7413141,7413131,'ers',20,1),(56,7413142,7413137,'vaa',50,1),(56,7413143,7413137,'aai',50,1),(56,7413144,7413142,'unk',20,1),(56,7413145,7413142,'nkn',20,1),(56,7413146,7413142,'kno',20,1),(56,7413147,7413142,'now',20,1),(56,7413148,7413142,'own',20,1),(56,7413149,7413144,'oth',33.333,1),(56,7413150,7413144,'the',33.333,1),(56,7413151,7413144,'her',33.333,1),(56,7413152,7413149,'uid',50,1),(56,7413153,7413149,'ids',50,1),(56,7413154,7413152,'vml',100,1),(56,7413155,7413154,'dis',20,1),(56,7413156,7413154,'isp',20,1),(56,7413157,7413154,'spl',20,1),(56,7413158,7413154,'pla',20,1),(56,7413159,7413154,'lay',20,1),(56,7413160,7413155,'nam',50,1),(56,7413161,7413155,'ame',50,1),(57,7413163,7413162,'net',25,3),(57,7413164,7413162,'eta',25,3),(57,7413165,7413162,'tap',25,3),(57,7413166,7413162,'app',25,3),(57,7413167,7413163,'fib',33.333,2),(57,7413168,7413163,'ibr',33.333,2),(57,7413169,7413163,'bre',33.333,2),(57,7413170,7413167,'cha',20,2),(57,7413171,7413167,'han',20,2),(57,7413172,7413167,'ann',20,2),(57,7413173,7413167,'nne',20,2),(57,7413174,7413167,'nel',20,2),(57,7413175,7413170,'dis',50,2),(57,7413176,7413170,'isk',50,2),(57,7413177,7413175,'naa',100,4),(57,7413178,7413177,'600',3.333,4),(57,7413179,7413177,'00a',3.333,4),(57,7413180,7413177,'0a0',3.333,4),(57,7413181,7413177,'a09',3.333,4),(57,7413182,7413177,'098',3.333,4),(57,7413183,7413177,'980',3.333,4),(57,7413184,7413177,'804',3.333,4),(57,7413185,7413177,'044',3.333,4),(57,7413186,7413177,'443',3.333,4),(57,7413187,7413177,'430',3.333,4),(57,7413188,7413177,'307',3.333,4),(57,7413189,7413177,'072',3.333,4),(57,7413190,7413177,'725',3.333,4),(57,7413191,7413177,'259',3.333,4),(57,7413192,7413177,'593',3.333,4),(57,7413193,7413177,'931',3.333,4),(57,7413194,7413177,'313',3.333,4),(57,7413195,7413177,'13f',3.333,4),(57,7413196,7413177,'3f3',3.333,4),(57,7413197,7413177,'f33',3.333,4),(57,7413198,7413177,'334',3.333,4),(57,7413199,7413177,'345',3.333,4),(57,7413200,7413177,'455',3.333,4),(57,7413201,7413177,'556',3.333,4),(57,7413202,7413177,'563',3.333,4),(57,7413203,7413177,'639',3.333,4),(57,7413204,7413177,'393',3.333,4),(57,7413205,7413177,'934',3.333,4),(57,7413206,7413177,'347',3.333,4),(57,7413207,7413177,'477',3.333,4),(57,7413208,7413178,'ser',25,1),(57,7413209,7413178,'eri',25,1),(57,7413210,7413178,'ria',25,1),(57,7413211,7413178,'ial',25,1),(57,7413212,7413208,'siz',50,1),(57,7413213,7413208,'ize',50,1),(57,7413214,7413212,'321',100,1),(57,7413215,7413214,'dev',25,1),(57,7413216,7413214,'evi',25,1),(57,7413217,7413214,'vic',25,1),(57,7413218,7413214,'ice',25,1),(57,7413219,7413215,'typ',50,1),(57,7413220,7413215,'ype',50,1),(57,7413221,7413219,'dir',10,1),(57,7413222,7413219,'ire',10,1),(57,7413223,7413219,'rec',10,1),(57,7413224,7413219,'ect',10,1),(57,7413225,7413219,'cta',10,1),(57,7413226,7413219,'tac',10,1),(57,7413227,7413219,'acc',10,1),(57,7413228,7413219,'cce',10,1),(57,7413229,7413219,'ces',10,1),(57,7413230,7413219,'ess',10,1),(57,7413231,7413221,'mul',14.286,1),(57,7413232,7413221,'ult',14.286,1),(57,7413233,7413221,'lti',14.286,1),(57,7413234,7413221,'tip',14.286,1),(57,7413235,7413221,'ipa',14.286,1),(57,7413236,7413221,'pat',14.286,1),(57,7413237,7413221,'ath',14.286,1),(57,7413238,7413231,'plu',25,1),(57,7413239,7413231,'lug',25,1),(57,7413240,7413231,'ugi',25,1),(57,7413241,7413231,'gin',25,1),(57,7413242,7413238,'nmp',100,1),(57,7413243,7413242,'dev',33.333,1),(57,7413244,7413242,'evf',33.333,1),(57,7413245,7413242,'vfs',33.333,1),(57,7413246,7413243,'pat',50,1),(57,7413247,7413243,'ath',50,1),(57,7413248,7413246,'vmf',50,1),(57,7413249,7413246,'mfs',50,1),(57,7413250,7413248,'dev',20,1),(57,7413251,7413248,'evi',20,1),(57,7413252,7413248,'vic',20,1),(57,7413253,7413248,'ice',20,1),(57,7413254,7413248,'ces',20,1),(57,7413255,7413250,'dis',33.333,1),(57,7413256,7413250,'isk',33.333,1),(57,7413257,7413250,'sks',33.333,1),(57,7413258,7413255,'ven',25,1),(57,7413259,7413255,'end',25,1),(57,7413260,7413255,'ndo',25,1),(57,7413261,7413255,'dor',25,1),(57,7413262,7413258,'mod',33.333,1),(57,7413263,7413258,'ode',33.333,1),(57,7413264,7413258,'del',33.333,1),(57,7413265,7413262,'lun',100,1),(57,7413266,7413265,'cmo',33.333,1),(57,7413267,7413265,'mod',33.333,1),(57,7413268,7413265,'ode',33.333,1),(57,7413269,7413266,'rev',16.667,1),(57,7413270,7413266,'evi',16.667,1),(57,7413271,7413266,'vis',16.667,1),(57,7413272,7413266,'isi',16.667,1),(57,7413273,7413266,'sio',16.667,1),(57,7413274,7413266,'ion',16.667,1),(57,7413275,7413269,'810',50,1),(57,7413276,7413269,'100',50,1),(57,7413277,7413275,'scs',50,1),(57,7413278,7413275,'csi',50,1),(57,7413279,7413277,'lev',33.333,1),(57,7413280,7413277,'eve',33.333,1),(57,7413281,7413277,'vel',33.333,1),(57,7413282,7413279,'pse',25,1),(57,7413283,7413279,'seu',25,1),(57,7413284,7413279,'eud',25,1),(57,7413285,7413279,'udo',25,1),(57,7413286,7413282,'fal',33.333,6),(57,7413287,7413282,'als',33.333,6),(57,7413288,7413282,'lse',33.333,6),(57,7413289,7413286,'sta',25,3),(57,7413290,7413286,'tat',25,3),(57,7413291,7413286,'atu',25,3),(57,7413292,7413286,'tus',25,3),(57,7413293,7413289,'rdm',100,1),(57,7413294,7413293,'cap',20,1),(57,7413295,7413293,'apa',20,1),(57,7413296,7413293,'pab',20,1),(57,7413297,7413293,'abl',20,1),(57,7413298,7413293,'ble',20,1),(57,7413299,7413294,'tru',50,1),(57,7413300,7413294,'rue',50,1),(57,7413301,7413299,'loc',33.333,1),(57,7413302,7413299,'oca',33.333,1),(57,7413303,7413299,'cal',33.333,1),(57,7413304,7413301,'rem',14.286,1),(57,7413305,7413301,'emo',14.286,1),(57,7413306,7413301,'mov',14.286,1),(57,7413307,7413301,'ova',14.286,1),(57,7413308,7413301,'vab',14.286,1),(57,7413309,7413301,'abl',14.286,1),(57,7413310,7413301,'ble',14.286,1),(57,7413311,7413304,'ssd',100,1),(57,7413312,7413311,'off',20,1),(57,7413313,7413311,'ffl',20,1),(57,7413314,7413311,'fli',20,1),(57,7413315,7413311,'lin',20,1),(57,7413316,7413311,'ine',20,1),(57,7413317,7413312,'per',11.111,1),(57,7413318,7413312,'ere',11.111,1),(57,7413319,7413312,'ren',11.111,1),(57,7413320,7413312,'enn',11.111,1),(57,7413321,7413312,'nni',11.111,1),(57,7413322,7413312,'nia',11.111,1),(57,7413323,7413312,'ial',11.111,1),(57,7413324,7413312,'all',11.111,1),(57,7413325,7413312,'lly',11.111,1),(57,7413326,7413317,'res',16.667,1),(57,7413327,7413317,'ese',16.667,1),(57,7413328,7413317,'ser',16.667,1),(57,7413329,7413317,'erv',16.667,1),(57,7413330,7413317,'rve',16.667,1),(57,7413331,7413317,'ved',16.667,1),(57,7413332,7413326,'thi',50,1),(57,7413333,7413326,'hin',50,1),(57,7413334,7413332,'pro',10,1),(57,7413335,7413332,'rov',10,1),(57,7413336,7413332,'ovi',10,1),(57,7413337,7413332,'vis',10,1),(57,7413338,7413332,'isi',10,1),(57,7413339,7413332,'sio',10,1),(57,7413340,7413332,'ion',10,1),(57,7413341,7413332,'oni',10,1),(57,7413342,7413332,'nin',10,1),(57,7413343,7413332,'ing',10,1),(57,7413344,7413334,'yes',100,1),(57,7413345,7413344,'att',16.667,1),(57,7413346,7413344,'tta',16.667,1),(57,7413347,7413344,'tac',16.667,1),(57,7413348,7413344,'ach',16.667,1),(57,7413349,7413344,'che',16.667,1),(57,7413350,7413344,'hed',16.667,1),(57,7413351,7413345,'fil',20,1),(57,7413352,7413345,'ilt',20,1),(57,7413353,7413345,'lte',20,1),(57,7413354,7413345,'ter',20,1),(57,7413355,7413345,'ers',20,1),(57,7413356,7413351,'vaa',50,1),(57,7413357,7413351,'aai',50,1),(57,7413358,7413356,'unk',20,1),(57,7413359,7413356,'nkn',20,1),(57,7413360,7413356,'kno',20,1),(57,7413361,7413356,'now',20,1),(57,7413362,7413356,'own',20,1),(57,7413363,7413358,'oth',33.333,1),(57,7413364,7413358,'the',33.333,1),(57,7413365,7413358,'her',33.333,1),(57,7413366,7413363,'uid',50,1),(57,7413367,7413363,'ids',50,1),(57,7413368,7413366,'vml',100,1),(57,7413369,7413368,'dis',20,1),(57,7413370,7413368,'isp',20,1),(57,7413371,7413368,'spl',20,1),(57,7413372,7413368,'pla',20,1),(57,7413373,7413368,'lay',20,1),(57,7413374,7413369,'nam',50,1),(57,7413375,7413369,'ame',50,1),(58,7413377,7413376,'net',25,3),(58,7413378,7413376,'eta',25,3),(58,7413379,7413376,'tap',25,3),(58,7413380,7413376,'app',25,3),(58,7413381,7413377,'ser',25,3),(58,7413382,7413377,'eri',25,3),(58,7413383,7413377,'ria',25,3),(58,7413384,7413377,'ial',25,3),(58,7413385,7413381,'att',16.667,3),(58,7413386,7413381,'tta',16.667,3),(58,7413387,7413381,'tac',16.667,3),(58,7413388,7413381,'ach',16.667,3),(58,7413389,7413381,'che',16.667,3),(58,7413390,7413381,'hed',16.667,3),(58,7413391,7413385,'scs',50,3),(58,7413392,7413385,'csi',50,3),(58,7413393,7413391,'dis',50,2),(58,7413394,7413391,'isk',50,2),(58,7413395,7413393,'naa',100,4),(58,7413396,7413395,'600',3.333,4),(58,7413397,7413395,'00a',3.333,4),(58,7413398,7413395,'0a0',3.333,4),(58,7413399,7413395,'a09',3.333,4),(58,7413400,7413395,'098',3.333,4),(58,7413401,7413395,'980',3.333,4),(58,7413402,7413395,'804',3.333,4),(58,7413403,7413395,'04c',3.333,4),(58,7413404,7413395,'4c5',3.333,4),(58,7413405,7413395,'c53',3.333,4),(58,7413406,7413395,'538',3.333,4),(58,7413407,7413395,'384',3.333,4),(58,7413408,7413395,'84e',3.333,4),(58,7413409,7413395,'4ee',3.333,4),(58,7413410,7413395,'ee1',3.333,4),(58,7413411,7413395,'e1f',3.333,4),(58,7413412,7413395,'1fa',3.333,4),(58,7413413,7413395,'fa8',3.333,4),(58,7413414,7413395,'a84',3.333,4),(58,7413415,7413395,'84a',3.333,4),(58,7413416,7413395,'4a1',3.333,4),(58,7413417,7413395,'a11',3.333,4),(58,7413418,7413395,'117',3.333,4),(58,7413419,7413395,'17b',3.333,4),(58,7413420,7413395,'7b0',3.333,4),(58,7413421,7413395,'b08',3.333,4),(58,7413422,7413395,'08a',3.333,4),(58,7413423,7413395,'8ab',3.333,4),(58,7413424,7413395,'aba',3.333,4),(58,7413425,7413395,'ba2',3.333,4),(58,7413426,7413396,'siz',50,1),(58,7413427,7413396,'ize',50,1),(58,7413428,7413426,'163',33.333,1),(58,7413429,7413426,'638',33.333,1),(58,7413430,7413426,'384',33.333,1),(58,7413431,7413428,'dev',25,1),(58,7413432,7413428,'evi',25,1),(58,7413433,7413428,'vic',25,1),(58,7413434,7413428,'ice',25,1),(58,7413435,7413431,'typ',50,1),(58,7413436,7413431,'ype',50,1),(58,7413437,7413435,'dir',10,1),(58,7413438,7413435,'ire',10,1),(58,7413439,7413435,'rec',10,1),(58,7413440,7413435,'ect',10,1),(58,7413441,7413435,'cta',10,1),(58,7413442,7413435,'tac',10,1),(58,7413443,7413435,'acc',10,1),(58,7413444,7413435,'cce',10,1),(58,7413445,7413435,'ces',10,1),(58,7413446,7413435,'ess',10,1),(58,7413447,7413437,'mul',14.286,1),(58,7413448,7413437,'ult',14.286,1),(58,7413449,7413437,'lti',14.286,1),(58,7413450,7413437,'tip',14.286,1),(58,7413451,7413437,'ipa',14.286,1),(58,7413452,7413437,'pat',14.286,1),(58,7413453,7413437,'ath',14.286,1),(58,7413454,7413447,'plu',25,1),(58,7413455,7413447,'lug',25,1),(58,7413456,7413447,'ugi',25,1),(58,7413457,7413447,'gin',25,1),(58,7413458,7413454,'nmp',100,1),(58,7413459,7413458,'dev',33.333,1),(58,7413460,7413458,'evf',33.333,1),(58,7413461,7413458,'vfs',33.333,1),(58,7413462,7413459,'pat',50,1),(58,7413463,7413459,'ath',50,1),(58,7413464,7413462,'vmf',50,1),(58,7413465,7413462,'mfs',50,1),(58,7413466,7413464,'dev',20,1),(58,7413467,7413464,'evi',20,1),(58,7413468,7413464,'vic',20,1),(58,7413469,7413464,'ice',20,1),(58,7413470,7413464,'ces',20,1),(58,7413471,7413466,'dis',33.333,1),(58,7413472,7413466,'isk',33.333,1),(58,7413473,7413466,'sks',33.333,1),(58,7413474,7413471,'ven',25,1),(58,7413475,7413471,'end',25,1),(58,7413476,7413471,'ndo',25,1),(58,7413477,7413471,'dor',25,1),(58,7413478,7413474,'mod',33.333,1),(58,7413479,7413474,'ode',33.333,1),(58,7413480,7413474,'del',33.333,1),(58,7413481,7413478,'fla',33.333,1),(58,7413482,7413478,'las',33.333,1),(58,7413483,7413478,'ash',33.333,1),(58,7413484,7413481,'acc',33.333,1),(58,7413485,7413481,'cce',33.333,1),(58,7413486,7413481,'cel',33.333,1),(58,7413487,7413484,'rev',16.667,1),(58,7413488,7413484,'evi',16.667,1),(58,7413489,7413484,'vis',16.667,1),(58,7413490,7413484,'isi',16.667,1),(58,7413491,7413484,'sio',16.667,1),(58,7413492,7413484,'ion',16.667,1),(58,7413493,7413487,'lev',33.333,1),(58,7413494,7413487,'eve',33.333,1),(58,7413495,7413487,'vel',33.333,1),(58,7413496,7413493,'pse',25,1),(58,7413497,7413493,'seu',25,1),(58,7413498,7413493,'eud',25,1),(58,7413499,7413493,'udo',25,1),(58,7413500,7413496,'fal',33.333,5),(58,7413501,7413496,'als',33.333,5),(58,7413502,7413496,'lse',33.333,5),(58,7413503,7413500,'sta',25,3),(58,7413504,7413500,'tat',25,3),(58,7413505,7413500,'atu',25,3),(58,7413506,7413500,'tus',25,3),(58,7413507,7413503,'deg',16.667,1),(58,7413508,7413503,'egr',16.667,1),(58,7413509,7413503,'gra',16.667,1),(58,7413510,7413503,'rad',16.667,1),(58,7413511,7413503,'ade',16.667,1),(58,7413512,7413503,'ded',16.667,1),(58,7413513,7413507,'rdm',100,1),(58,7413514,7413513,'cap',20,1),(58,7413515,7413513,'apa',20,1),(58,7413516,7413513,'pab',20,1),(58,7413517,7413513,'abl',20,1),(58,7413518,7413513,'ble',20,1),(58,7413519,7413514,'tru',50,2),(58,7413520,7413514,'rue',50,2),(58,7413521,7413519,'loc',33.333,1),(58,7413522,7413519,'oca',33.333,1),(58,7413523,7413519,'cal',33.333,1),(58,7413524,7413521,'rem',14.286,1),(58,7413525,7413521,'emo',14.286,1),(58,7413526,7413521,'mov',14.286,1),(58,7413527,7413521,'ova',14.286,1),(58,7413528,7413521,'vab',14.286,1),(58,7413529,7413521,'abl',14.286,1),(58,7413530,7413521,'ble',14.286,1),(58,7413531,7413524,'ssd',100,1),(58,7413532,7413531,'off',20,1),(58,7413533,7413531,'ffl',20,1),(58,7413534,7413531,'fli',20,1),(58,7413535,7413531,'lin',20,1),(58,7413536,7413531,'ine',20,1),(58,7413537,7413532,'per',11.111,1),(58,7413538,7413532,'ere',11.111,1),(58,7413539,7413532,'ren',11.111,1),(58,7413540,7413532,'enn',11.111,1),(58,7413541,7413532,'nni',11.111,1),(58,7413542,7413532,'nia',11.111,1),(58,7413543,7413532,'ial',11.111,1),(58,7413544,7413532,'all',11.111,1),(58,7413545,7413532,'lly',11.111,1),(58,7413546,7413537,'res',16.667,1),(58,7413547,7413537,'ese',16.667,1),(58,7413548,7413537,'ser',16.667,1),(58,7413549,7413537,'erv',16.667,1),(58,7413550,7413537,'rve',16.667,1),(58,7413551,7413537,'ved',16.667,1),(58,7413552,7413546,'thi',50,1),(58,7413553,7413546,'hin',50,1),(58,7413554,7413552,'pro',10,1),(58,7413555,7413552,'rov',10,1),(58,7413556,7413552,'ovi',10,1),(58,7413557,7413552,'vis',10,1),(58,7413558,7413552,'isi',10,1),(58,7413559,7413552,'sio',10,1),(58,7413560,7413552,'ion',10,1),(58,7413561,7413552,'oni',10,1),(58,7413562,7413552,'nin',10,1),(58,7413563,7413552,'ing',10,1),(58,7413564,7413554,'unk',20,1),(58,7413565,7413554,'nkn',20,1),(58,7413566,7413554,'kno',20,1),(58,7413567,7413554,'now',20,1),(58,7413568,7413554,'own',20,1),(58,7413569,7413564,'fil',20,1),(58,7413570,7413564,'ilt',20,1),(58,7413571,7413564,'lte',20,1),(58,7413572,7413564,'ter',20,1),(58,7413573,7413564,'ers',20,1),(58,7413574,7413569,'vaa',50,1),(58,7413575,7413569,'aai',50,1),(58,7413576,7413574,'uns',11.111,1),(58,7413577,7413574,'nsu',11.111,1),(58,7413578,7413574,'sup',11.111,1),(58,7413579,7413574,'upp',11.111,1),(58,7413580,7413574,'ppo',11.111,1),(58,7413581,7413574,'por',11.111,1),(58,7413582,7413574,'ort',11.111,1),(58,7413583,7413574,'rte',11.111,1),(58,7413584,7413574,'ted',11.111,1),(58,7413585,7413576,'oth',33.333,1),(58,7413586,7413576,'the',33.333,1),(58,7413587,7413576,'her',33.333,1),(58,7413588,7413585,'uid',50,1),(58,7413589,7413585,'ids',50,1),(58,7413590,7413588,'vml',100,1),(58,7413591,7413590,'dis',20,1),(58,7413592,7413590,'isp',20,1),(58,7413593,7413590,'spl',20,1),(58,7413594,7413590,'pla',20,1),(58,7413595,7413590,'lay',20,1),(58,7413596,7413591,'nam',50,1),(58,7413597,7413591,'ame',50,1),(59,7413714,7413713,'net',25,3),(59,7413715,7413713,'eta',25,3),(59,7413716,7413713,'tap',25,3),(59,7413717,7413713,'app',25,3),(59,7413718,7413714,'fib',33.333,2),(59,7413719,7413714,'ibr',33.333,2),(59,7413720,7413714,'bre',33.333,2),(59,7413721,7413718,'cha',20,2),(59,7413722,7413718,'han',20,2),(59,7413723,7413718,'ann',20,2),(59,7413724,7413718,'nne',20,2),(59,7413725,7413718,'nel',20,2),(59,7413726,7413721,'dis',50,2),(59,7413727,7413721,'isk',50,2),(59,7413728,7413726,'naa',100,4),(59,7413729,7413728,'600',3.333,4),(59,7413730,7413728,'00a',3.333,4),(59,7413731,7413728,'0a0',3.333,4),(59,7413732,7413728,'a09',3.333,4),(59,7413733,7413728,'098',3.333,4),(59,7413734,7413728,'980',3.333,4),(59,7413735,7413728,'804',3.333,4),(59,7413736,7413728,'044',3.333,4),(59,7413737,7413728,'443',3.333,4),(59,7413738,7413728,'430',3.333,4),(59,7413739,7413728,'307',3.333,4),(59,7413740,7413728,'072',3.333,4),(59,7413741,7413728,'725',3.333,4),(59,7413742,7413728,'259',3.333,4),(59,7413743,7413728,'593',3.333,4),(59,7413744,7413728,'931',3.333,4),(59,7413745,7413728,'313',3.333,4),(59,7413746,7413728,'13f',3.333,4),(59,7413747,7413728,'3f3',3.333,4),(59,7413748,7413728,'f33',3.333,4),(59,7413749,7413728,'334',3.333,4),(59,7413750,7413728,'345',3.333,4),(59,7413751,7413728,'455',3.333,4),(59,7413752,7413728,'556',3.333,4),(59,7413753,7413728,'563',3.333,4),(59,7413754,7413728,'639',3.333,4),(59,7413755,7413728,'393',3.333,4),(59,7413756,7413728,'934',3.333,4),(59,7413757,7413728,'347',3.333,4),(59,7413758,7413728,'478',3.333,4),(59,7413759,7413729,'ser',25,1),(59,7413760,7413729,'eri',25,1),(59,7413761,7413729,'ria',25,1),(59,7413762,7413729,'ial',25,1),(59,7413763,7413759,'siz',50,1),(59,7413764,7413759,'ize',50,1),(59,7413765,7413763,'321',100,1),(59,7413766,7413765,'dev',25,1),(59,7413767,7413765,'evi',25,1),(59,7413768,7413765,'vic',25,1),(59,7413769,7413765,'ice',25,1),(59,7413770,7413766,'typ',50,1),(59,7413771,7413766,'ype',50,1),(59,7413772,7413770,'dir',10,1),(59,7413773,7413770,'ire',10,1),(59,7413774,7413770,'rec',10,1),(59,7413775,7413770,'ect',10,1),(59,7413776,7413770,'cta',10,1),(59,7413777,7413770,'tac',10,1),(59,7413778,7413770,'acc',10,1),(59,7413779,7413770,'cce',10,1),(59,7413780,7413770,'ces',10,1),(59,7413781,7413770,'ess',10,1),(59,7413782,7413772,'mul',14.286,1),(59,7413783,7413772,'ult',14.286,1),(59,7413784,7413772,'lti',14.286,1),(59,7413785,7413772,'tip',14.286,1),(59,7413786,7413772,'ipa',14.286,1),(59,7413787,7413772,'pat',14.286,1),(59,7413788,7413772,'ath',14.286,1),(59,7413789,7413782,'plu',25,1),(59,7413790,7413782,'lug',25,1),(59,7413791,7413782,'ugi',25,1),(59,7413792,7413782,'gin',25,1),(59,7413793,7413789,'nmp',100,1),(59,7413794,7413793,'dev',33.333,1),(59,7413795,7413793,'evf',33.333,1),(59,7413796,7413793,'vfs',33.333,1),(59,7413797,7413794,'pat',50,1),(59,7413798,7413794,'ath',50,1),(59,7413799,7413797,'vmf',50,1),(59,7413800,7413797,'mfs',50,1),(59,7413801,7413799,'dev',20,1),(59,7413802,7413799,'evi',20,1),(59,7413803,7413799,'vic',20,1),(59,7413804,7413799,'ice',20,1),(59,7413805,7413799,'ces',20,1),(59,7413806,7413801,'dis',33.333,1),(59,7413807,7413801,'isk',33.333,1),(59,7413808,7413801,'sks',33.333,1),(59,7413809,7413806,'ven',25,1),(59,7413810,7413806,'end',25,1),(59,7413811,7413806,'ndo',25,1),(59,7413812,7413806,'dor',25,1),(59,7413813,7413809,'mod',33.333,1),(59,7413814,7413809,'ode',33.333,1),(59,7413815,7413809,'del',33.333,1),(59,7413816,7413813,'lun',100,1),(59,7413817,7413816,'cmo',33.333,1),(59,7413818,7413816,'mod',33.333,1),(59,7413819,7413816,'ode',33.333,1),(59,7413820,7413817,'rev',16.667,1),(59,7413821,7413817,'evi',16.667,1),(59,7413822,7413817,'vis',16.667,1),(59,7413823,7413817,'isi',16.667,1),(59,7413824,7413817,'sio',16.667,1),(59,7413825,7413817,'ion',16.667,1),(59,7413826,7413820,'810',50,1),(59,7413827,7413820,'100',50,1),(59,7413828,7413826,'scs',50,1),(59,7413829,7413826,'csi',50,1),(59,7413830,7413828,'lev',33.333,1),(59,7413831,7413828,'eve',33.333,1),(59,7413832,7413828,'vel',33.333,1),(59,7413833,7413830,'pse',25,1),(59,7413834,7413830,'seu',25,1),(59,7413835,7413830,'eud',25,1),(59,7413836,7413830,'udo',25,1),(59,7413837,7413833,'fal',33.333,6),(59,7413838,7413833,'als',33.333,6),(59,7413839,7413833,'lse',33.333,6),(59,7413840,7413837,'sta',25,3),(59,7413841,7413837,'tat',25,3),(59,7413842,7413837,'atu',25,3),(59,7413843,7413837,'tus',25,3),(59,7413844,7413840,'rdm',100,1),(59,7413845,7413844,'cap',20,1),(59,7413846,7413844,'apa',20,1),(59,7413847,7413844,'pab',20,1),(59,7413848,7413844,'abl',20,1),(59,7413849,7413844,'ble',20,1),(59,7413850,7413845,'tru',50,1),(59,7413851,7413845,'rue',50,1),(59,7413852,7413850,'loc',33.333,1),(59,7413853,7413850,'oca',33.333,1),(59,7413854,7413850,'cal',33.333,1),(59,7413855,7413852,'rem',14.286,1),(59,7413856,7413852,'emo',14.286,1),(59,7413857,7413852,'mov',14.286,1),(59,7413858,7413852,'ova',14.286,1),(59,7413859,7413852,'vab',14.286,1),(59,7413860,7413852,'abl',14.286,1),(59,7413861,7413852,'ble',14.286,1),(59,7413862,7413855,'ssd',100,1),(59,7413863,7413862,'off',20,1),(59,7413864,7413862,'ffl',20,1),(59,7413865,7413862,'fli',20,1),(59,7413866,7413862,'lin',20,1),(59,7413867,7413862,'ine',20,1),(59,7413868,7413863,'per',11.111,1),(59,7413869,7413863,'ere',11.111,1),(59,7413870,7413863,'ren',11.111,1),(59,7413871,7413863,'enn',11.111,1),(59,7413872,7413863,'nni',11.111,1),(59,7413873,7413863,'nia',11.111,1),(59,7413874,7413863,'ial',11.111,1),(59,7413875,7413863,'all',11.111,1),(59,7413876,7413863,'lly',11.111,1),(59,7413877,7413868,'res',16.667,1),(59,7413878,7413868,'ese',16.667,1),(59,7413879,7413868,'ser',16.667,1),(59,7413880,7413868,'erv',16.667,1),(59,7413881,7413868,'rve',16.667,1),(59,7413882,7413868,'ved',16.667,1),(59,7413883,7413877,'thi',50,1),(59,7413884,7413877,'hin',50,1),(59,7413885,7413883,'pro',10,1),(59,7413886,7413883,'rov',10,1),(59,7413887,7413883,'ovi',10,1),(59,7413888,7413883,'vis',10,1),(59,7413889,7413883,'isi',10,1),(59,7413890,7413883,'sio',10,1),(59,7413891,7413883,'ion',10,1),(59,7413892,7413883,'oni',10,1),(59,7413893,7413883,'nin',10,1),(59,7413894,7413883,'ing',10,1),(59,7413895,7413885,'yes',100,1),(59,7413896,7413895,'att',16.667,1),(59,7413897,7413895,'tta',16.667,1),(59,7413898,7413895,'tac',16.667,1),(59,7413899,7413895,'ach',16.667,1),(59,7413900,7413895,'che',16.667,1),(59,7413901,7413895,'hed',16.667,1),(59,7413902,7413896,'fil',20,1),(59,7413903,7413896,'ilt',20,1),(59,7413904,7413896,'lte',20,1),(59,7413905,7413896,'ter',20,1),(59,7413906,7413896,'ers',20,1),(59,7413907,7413902,'vaa',50,1),(59,7413908,7413902,'aai',50,1),(59,7413909,7413907,'unk',20,1),(59,7413910,7413907,'nkn',20,1),(59,7413911,7413907,'kno',20,1),(59,7413912,7413907,'now',20,1),(59,7413913,7413907,'own',20,1),(59,7413914,7413909,'oth',33.333,1),(59,7413915,7413909,'the',33.333,1),(59,7413916,7413909,'her',33.333,1),(59,7413917,7413914,'uid',50,1),(59,7413918,7413914,'ids',50,1),(59,7413919,7413917,'vml',100,1),(59,7413920,7413919,'dis',20,1),(59,7413921,7413919,'isp',20,1),(59,7413922,7413919,'spl',20,1),(59,7413923,7413919,'pla',20,1),(59,7413924,7413919,'lay',20,1),(59,7413925,7413920,'nam',50,1),(59,7413926,7413920,'ame',50,1),(60,7413928,7413927,'net',25,3),(60,7413929,7413927,'eta',25,3),(60,7413930,7413927,'tap',25,3),(60,7413931,7413927,'app',25,3),(60,7413932,7413928,'fib',33.333,2),(60,7413933,7413928,'ibr',33.333,2),(60,7413934,7413928,'bre',33.333,2),(60,7413935,7413932,'cha',20,2),(60,7413936,7413932,'han',20,2),(60,7413937,7413932,'ann',20,2),(60,7413938,7413932,'nne',20,2),(60,7413939,7413932,'nel',20,2),(60,7413940,7413935,'dis',50,2),(60,7413941,7413935,'isk',50,2),(60,7413942,7413940,'naa',100,4),(60,7413943,7413942,'600',3.333,4),(60,7413944,7413942,'00a',3.333,4),(60,7413945,7413942,'0a0',3.333,4),(60,7413946,7413942,'a09',3.333,4),(60,7413947,7413942,'098',3.333,4),(60,7413948,7413942,'980',3.333,4),(60,7413949,7413942,'804',3.333,4),(60,7413950,7413942,'044',3.333,4),(60,7413951,7413942,'443',3.333,4),(60,7413952,7413942,'430',3.333,4),(60,7413953,7413942,'307',3.333,4),(60,7413954,7413942,'072',3.333,4),(60,7413955,7413942,'725',3.333,4),(60,7413956,7413942,'259',3.333,4),(60,7413957,7413942,'593',3.333,4),(60,7413958,7413942,'931',3.333,4),(60,7413959,7413942,'313',3.333,4),(60,7413960,7413942,'13f',3.333,4),(60,7413961,7413942,'3f3',3.333,4),(60,7413962,7413942,'f33',3.333,4),(60,7413963,7413942,'334',3.333,4),(60,7413964,7413942,'345',3.333,4),(60,7413965,7413942,'455',3.333,4),(60,7413966,7413942,'556',3.333,4),(60,7413967,7413942,'563',3.333,4),(60,7413968,7413942,'639',3.333,4),(60,7413969,7413942,'393',3.333,4),(60,7413970,7413942,'934',3.333,4),(60,7413971,7413942,'347',3.333,4),(60,7413972,7413942,'479',3.333,4),(60,7413973,7413943,'ser',25,1),(60,7413974,7413943,'eri',25,1),(60,7413975,7413943,'ria',25,1),(60,7413976,7413943,'ial',25,1),(60,7413977,7413973,'siz',50,1),(60,7413978,7413973,'ize',50,1),(60,7413979,7413977,'321',100,1),(60,7413980,7413979,'dev',25,1),(60,7413981,7413979,'evi',25,1),(60,7413982,7413979,'vic',25,1),(60,7413983,7413979,'ice',25,1),(60,7413984,7413980,'typ',50,1),(60,7413985,7413980,'ype',50,1),(60,7413986,7413984,'dir',10,1),(60,7413987,7413984,'ire',10,1),(60,7413988,7413984,'rec',10,1),(60,7413989,7413984,'ect',10,1),(60,7413990,7413984,'cta',10,1),(60,7413991,7413984,'tac',10,1),(60,7413992,7413984,'acc',10,1),(60,7413993,7413984,'cce',10,1),(60,7413994,7413984,'ces',10,1),(60,7413995,7413984,'ess',10,1),(60,7413996,7413986,'mul',14.286,1),(60,7413997,7413986,'ult',14.286,1),(60,7413998,7413986,'lti',14.286,1),(60,7413999,7413986,'tip',14.286,1),(60,7414000,7413986,'ipa',14.286,1),(60,7414001,7413986,'pat',14.286,1),(60,7414002,7413986,'ath',14.286,1),(60,7414003,7413996,'plu',25,1),(60,7414004,7413996,'lug',25,1),(60,7414005,7413996,'ugi',25,1),(60,7414006,7413996,'gin',25,1),(60,7414007,7414003,'nmp',100,1),(60,7414008,7414007,'dev',33.333,1),(60,7414009,7414007,'evf',33.333,1),(60,7414010,7414007,'vfs',33.333,1),(60,7414011,7414008,'pat',50,1),(60,7414012,7414008,'ath',50,1),(60,7414013,7414011,'vmf',50,1),(60,7414014,7414011,'mfs',50,1),(60,7414015,7414013,'dev',20,1),(60,7414016,7414013,'evi',20,1),(60,7414017,7414013,'vic',20,1),(60,7414018,7414013,'ice',20,1),(60,7414019,7414013,'ces',20,1),(60,7414020,7414015,'dis',33.333,1),(60,7414021,7414015,'isk',33.333,1),(60,7414022,7414015,'sks',33.333,1),(60,7414023,7414020,'ven',25,1),(60,7414024,7414020,'end',25,1),(60,7414025,7414020,'ndo',25,1),(60,7414026,7414020,'dor',25,1),(60,7414027,7414023,'mod',33.333,1),(60,7414028,7414023,'ode',33.333,1),(60,7414029,7414023,'del',33.333,1),(60,7414030,7414027,'lun',100,1),(60,7414031,7414030,'cmo',33.333,1),(60,7414032,7414030,'mod',33.333,1),(60,7414033,7414030,'ode',33.333,1),(60,7414034,7414031,'rev',16.667,1),(60,7414035,7414031,'evi',16.667,1),(60,7414036,7414031,'vis',16.667,1),(60,7414037,7414031,'isi',16.667,1),(60,7414038,7414031,'sio',16.667,1),(60,7414039,7414031,'ion',16.667,1),(60,7414040,7414034,'810',50,1),(60,7414041,7414034,'100',50,1),(60,7414042,7414040,'scs',50,1),(60,7414043,7414040,'csi',50,1),(60,7414044,7414042,'lev',33.333,1),(60,7414045,7414042,'eve',33.333,1),(60,7414046,7414042,'vel',33.333,1),(60,7414047,7414044,'pse',25,1),(60,7414048,7414044,'seu',25,1),(60,7414049,7414044,'eud',25,1),(60,7414050,7414044,'udo',25,1),(60,7414051,7414047,'fal',33.333,6),(60,7414052,7414047,'als',33.333,6),(60,7414053,7414047,'lse',33.333,6),(60,7414054,7414051,'sta',25,3),(60,7414055,7414051,'tat',25,3),(60,7414056,7414051,'atu',25,3),(60,7414057,7414051,'tus',25,3),(60,7414058,7414054,'rdm',100,1),(60,7414059,7414058,'cap',20,1),(60,7414060,7414058,'apa',20,1),(60,7414061,7414058,'pab',20,1),(60,7414062,7414058,'abl',20,1),(60,7414063,7414058,'ble',20,1),(60,7414064,7414059,'tru',50,1),(60,7414065,7414059,'rue',50,1),(60,7414066,7414064,'loc',33.333,1),(60,7414067,7414064,'oca',33.333,1),(60,7414068,7414064,'cal',33.333,1),(60,7414069,7414066,'rem',14.286,1),(60,7414070,7414066,'emo',14.286,1),(60,7414071,7414066,'mov',14.286,1),(60,7414072,7414066,'ova',14.286,1),(60,7414073,7414066,'vab',14.286,1),(60,7414074,7414066,'abl',14.286,1),(60,7414075,7414066,'ble',14.286,1),(60,7414076,7414069,'ssd',100,1),(60,7414077,7414076,'off',20,1),(60,7414078,7414076,'ffl',20,1),(60,7414079,7414076,'fli',20,1),(60,7414080,7414076,'lin',20,1),(60,7414081,7414076,'ine',20,1),(60,7414082,7414077,'per',11.111,1),(60,7414083,7414077,'ere',11.111,1),(60,7414084,7414077,'ren',11.111,1),(60,7414085,7414077,'enn',11.111,1),(60,7414086,7414077,'nni',11.111,1),(60,7414087,7414077,'nia',11.111,1),(60,7414088,7414077,'ial',11.111,1),(60,7414089,7414077,'all',11.111,1),(60,7414090,7414077,'lly',11.111,1),(60,7414091,7414082,'res',16.667,1),(60,7414092,7414082,'ese',16.667,1),(60,7414093,7414082,'ser',16.667,1),(60,7414094,7414082,'erv',16.667,1),(60,7414095,7414082,'rve',16.667,1),(60,7414096,7414082,'ved',16.667,1),(60,7414097,7414091,'thi',50,1),(60,7414098,7414091,'hin',50,1),(60,7414099,7414097,'pro',10,1),(60,7414100,7414097,'rov',10,1),(60,7414101,7414097,'ovi',10,1),(60,7414102,7414097,'vis',10,1),(60,7414103,7414097,'isi',10,1),(60,7414104,7414097,'sio',10,1),(60,7414105,7414097,'ion',10,1),(60,7414106,7414097,'oni',10,1),(60,7414107,7414097,'nin',10,1),(60,7414108,7414097,'ing',10,1),(60,7414109,7414099,'yes',100,1),(60,7414110,7414109,'att',16.667,1),(60,7414111,7414109,'tta',16.667,1),(60,7414112,7414109,'tac',16.667,1),(60,7414113,7414109,'ach',16.667,1),(60,7414114,7414109,'che',16.667,1),(60,7414115,7414109,'hed',16.667,1),(60,7414116,7414110,'fil',20,1),(60,7414117,7414110,'ilt',20,1),(60,7414118,7414110,'lte',20,1),(60,7414119,7414110,'ter',20,1),(60,7414120,7414110,'ers',20,1),(60,7414121,7414116,'vaa',50,1),(60,7414122,7414116,'aai',50,1),(60,7414123,7414121,'unk',20,1),(60,7414124,7414121,'nkn',20,1),(60,7414125,7414121,'kno',20,1),(60,7414126,7414121,'now',20,1),(60,7414127,7414121,'own',20,1),(60,7414128,7414123,'oth',33.333,1),(60,7414129,7414123,'the',33.333,1),(60,7414130,7414123,'her',33.333,1),(60,7414131,7414128,'uid',50,1),(60,7414132,7414128,'ids',50,1),(60,7414133,7414131,'vml',100,1),(60,7414134,7414133,'dis',20,1),(60,7414135,7414133,'isp',20,1),(60,7414136,7414133,'spl',20,1),(60,7414137,7414133,'pla',20,1),(60,7414138,7414133,'lay',20,1),(60,7414139,7414134,'nam',50,1),(60,7414140,7414134,'ame',50,1),(61,7414142,7414141,'net',25,3),(61,7414143,7414141,'eta',25,3),(61,7414144,7414141,'tap',25,3),(61,7414145,7414141,'app',25,3),(61,7414146,7414142,'ser',25,3),(61,7414147,7414142,'eri',25,3),(61,7414148,7414142,'ria',25,3),(61,7414149,7414142,'ial',25,3),(61,7414150,7414146,'att',16.667,3),(61,7414151,7414146,'tta',16.667,3),(61,7414152,7414146,'tac',16.667,3),(61,7414153,7414146,'ach',16.667,3),(61,7414154,7414146,'che',16.667,3),(61,7414155,7414146,'hed',16.667,3),(61,7414156,7414150,'scs',50,3),(61,7414157,7414150,'csi',50,3),(61,7414158,7414156,'dis',50,2),(61,7414159,7414156,'isk',50,2),(61,7414160,7414158,'naa',100,4),(61,7414161,7414160,'600',3.333,4),(61,7414162,7414160,'00a',3.333,4),(61,7414163,7414160,'0a0',3.333,4),(61,7414164,7414160,'a09',3.333,4),(61,7414165,7414160,'098',3.333,4),(61,7414166,7414160,'980',3.333,4),(61,7414167,7414160,'803',3.333,4),(61,7414168,7414160,'034',3.333,4),(61,7414169,7414160,'343',3.333,4),(61,7414170,7414160,'436',3.333,4),(61,7414171,7414160,'368',3.333,4),(61,7414172,7414160,'684',3.333,4),(61,7414173,7414160,'84e',3.333,4),(61,7414174,7414160,'4ee',3.333,4),(61,7414175,7414160,'eef',3.333,4),(61,7414176,7414160,'ef3',3.333,4),(61,7414177,7414160,'f3e',3.333,4),(61,7414178,7414160,'3ed',3.333,4),(61,7414179,7414160,'ed3',3.333,4),(61,7414180,7414160,'d3f',3.333,4),(61,7414181,7414160,'3f1',3.333,4),(61,7414182,7414160,'f11',3.333,4),(61,7414183,7414160,'117',3.333,4),(61,7414184,7414160,'17b',3.333,4),(61,7414185,7414160,'7b0',3.333,4),(61,7414186,7414160,'b02',3.333,4),(61,7414187,7414160,'02a',3.333,4),(61,7414188,7414160,'2ab',3.333,4),(61,7414189,7414160,'aba',3.333,4),(61,7414190,7414160,'ba2',3.333,4),(61,7414191,7414161,'siz',50,1),(61,7414192,7414161,'ize',50,1),(61,7414193,7414191,'163',33.333,1),(61,7414194,7414191,'638',33.333,1),(61,7414195,7414191,'384',33.333,1),(61,7414196,7414193,'dev',25,1),(61,7414197,7414193,'evi',25,1),(61,7414198,7414193,'vic',25,1),(61,7414199,7414193,'ice',25,1),(61,7414200,7414196,'typ',50,1),(61,7414201,7414196,'ype',50,1),(61,7414202,7414200,'dir',10,1),(61,7414203,7414200,'ire',10,1),(61,7414204,7414200,'rec',10,1),(61,7414205,7414200,'ect',10,1),(61,7414206,7414200,'cta',10,1),(61,7414207,7414200,'tac',10,1),(61,7414208,7414200,'acc',10,1),(61,7414209,7414200,'cce',10,1),(61,7414210,7414200,'ces',10,1),(61,7414211,7414200,'ess',10,1),(61,7414212,7414202,'mul',14.286,1),(61,7414213,7414202,'ult',14.286,1),(61,7414214,7414202,'lti',14.286,1),(61,7414215,7414202,'tip',14.286,1),(61,7414216,7414202,'ipa',14.286,1),(61,7414217,7414202,'pat',14.286,1),(61,7414218,7414202,'ath',14.286,1),(61,7414219,7414212,'plu',25,1),(61,7414220,7414212,'lug',25,1),(61,7414221,7414212,'ugi',25,1),(61,7414222,7414212,'gin',25,1),(61,7414223,7414219,'nmp',100,1),(61,7414224,7414223,'dev',33.333,1),(61,7414225,7414223,'evf',33.333,1),(61,7414226,7414223,'vfs',33.333,1),(61,7414227,7414224,'pat',50,1),(61,7414228,7414224,'ath',50,1),(61,7414229,7414227,'vmf',50,1),(61,7414230,7414227,'mfs',50,1),(61,7414231,7414229,'dev',20,1),(61,7414232,7414229,'evi',20,1),(61,7414233,7414229,'vic',20,1),(61,7414234,7414229,'ice',20,1),(61,7414235,7414229,'ces',20,1),(61,7414236,7414231,'dis',33.333,1),(61,7414237,7414231,'isk',33.333,1),(61,7414238,7414231,'sks',33.333,1),(61,7414239,7414236,'ven',25,1),(61,7414240,7414236,'end',25,1),(61,7414241,7414236,'ndo',25,1),(61,7414242,7414236,'dor',25,1),(61,7414243,7414239,'mod',33.333,1),(61,7414244,7414239,'ode',33.333,1),(61,7414245,7414239,'del',33.333,1),(61,7414246,7414243,'fla',33.333,1),(61,7414247,7414243,'las',33.333,1),(61,7414248,7414243,'ash',33.333,1),(61,7414249,7414246,'acc',33.333,1),(61,7414250,7414246,'cce',33.333,1),(61,7414251,7414246,'cel',33.333,1),(61,7414252,7414249,'rev',16.667,1),(61,7414253,7414249,'evi',16.667,1),(61,7414254,7414249,'vis',16.667,1),(61,7414255,7414249,'isi',16.667,1),(61,7414256,7414249,'sio',16.667,1),(61,7414257,7414249,'ion',16.667,1),(61,7414258,7414252,'lev',33.333,1),(61,7414259,7414252,'eve',33.333,1),(61,7414260,7414252,'vel',33.333,1),(61,7414261,7414258,'pse',25,1),(61,7414262,7414258,'seu',25,1),(61,7414263,7414258,'eud',25,1),(61,7414264,7414258,'udo',25,1),(61,7414265,7414261,'fal',33.333,5),(61,7414266,7414261,'als',33.333,5),(61,7414267,7414261,'lse',33.333,5),(61,7414268,7414265,'sta',25,3),(61,7414269,7414265,'tat',25,3),(61,7414270,7414265,'atu',25,3),(61,7414271,7414265,'tus',25,3),(61,7414272,7414268,'deg',16.667,1),(61,7414273,7414268,'egr',16.667,1),(61,7414274,7414268,'gra',16.667,1),(61,7414275,7414268,'rad',16.667,1),(61,7414276,7414268,'ade',16.667,1),(61,7414277,7414268,'ded',16.667,1),(61,7414278,7414272,'rdm',100,1),(61,7414279,7414278,'cap',20,1),(61,7414280,7414278,'apa',20,1),(61,7414281,7414278,'pab',20,1),(61,7414282,7414278,'abl',20,1),(61,7414283,7414278,'ble',20,1),(61,7414284,7414279,'tru',50,2),(61,7414285,7414279,'rue',50,2),(61,7414286,7414284,'loc',33.333,1),(61,7414287,7414284,'oca',33.333,1),(61,7414288,7414284,'cal',33.333,1),(61,7414289,7414286,'rem',14.286,1),(61,7414290,7414286,'emo',14.286,1),(61,7414291,7414286,'mov',14.286,1),(61,7414292,7414286,'ova',14.286,1),(61,7414293,7414286,'vab',14.286,1),(61,7414294,7414286,'abl',14.286,1),(61,7414295,7414286,'ble',14.286,1),(61,7414296,7414289,'ssd',100,1),(61,7414297,7414296,'off',20,1),(61,7414298,7414296,'ffl',20,1),(61,7414299,7414296,'fli',20,1),(61,7414300,7414296,'lin',20,1),(61,7414301,7414296,'ine',20,1),(61,7414302,7414297,'per',11.111,1),(61,7414303,7414297,'ere',11.111,1),(61,7414304,7414297,'ren',11.111,1),(61,7414305,7414297,'enn',11.111,1),(61,7414306,7414297,'nni',11.111,1),(61,7414307,7414297,'nia',11.111,1),(61,7414308,7414297,'ial',11.111,1),(61,7414309,7414297,'all',11.111,1),(61,7414310,7414297,'lly',11.111,1),(61,7414311,7414302,'res',16.667,1),(61,7414312,7414302,'ese',16.667,1),(61,7414313,7414302,'ser',16.667,1),(61,7414314,7414302,'erv',16.667,1),(61,7414315,7414302,'rve',16.667,1),(61,7414316,7414302,'ved',16.667,1),(61,7414317,7414311,'thi',50,1),(61,7414318,7414311,'hin',50,1),(61,7414319,7414317,'pro',10,1),(61,7414320,7414317,'rov',10,1),(61,7414321,7414317,'ovi',10,1),(61,7414322,7414317,'vis',10,1),(61,7414323,7414317,'isi',10,1),(61,7414324,7414317,'sio',10,1),(61,7414325,7414317,'ion',10,1),(61,7414326,7414317,'oni',10,1),(61,7414327,7414317,'nin',10,1),(61,7414328,7414317,'ing',10,1),(61,7414329,7414319,'unk',20,1),(61,7414330,7414319,'nkn',20,1),(61,7414331,7414319,'kno',20,1),(61,7414332,7414319,'now',20,1),(61,7414333,7414319,'own',20,1),(61,7414334,7414329,'fil',20,1),(61,7414335,7414329,'ilt',20,1),(61,7414336,7414329,'lte',20,1),(61,7414337,7414329,'ter',20,1),(61,7414338,7414329,'ers',20,1),(61,7414339,7414334,'vaa',50,1),(61,7414340,7414334,'aai',50,1),(61,7414341,7414339,'uns',11.111,1),(61,7414342,7414339,'nsu',11.111,1),(61,7414343,7414339,'sup',11.111,1),(61,7414344,7414339,'upp',11.111,1),(61,7414345,7414339,'ppo',11.111,1),(61,7414346,7414339,'por',11.111,1),(61,7414347,7414339,'ort',11.111,1),(61,7414348,7414339,'rte',11.111,1),(61,7414349,7414339,'ted',11.111,1),(61,7414350,7414341,'oth',33.333,1),(61,7414351,7414341,'the',33.333,1),(61,7414352,7414341,'her',33.333,1),(61,7414353,7414350,'uid',50,1),(61,7414354,7414350,'ids',50,1),(61,7414355,7414353,'vml',100,1),(61,7414356,7414355,'dis',20,1),(61,7414357,7414355,'isp',20,1),(61,7414358,7414355,'spl',20,1),(61,7414359,7414355,'pla',20,1),(61,7414360,7414355,'lay',20,1),(61,7414361,7414356,'nam',50,1),(61,7414362,7414356,'ame',50,1),(62,7414364,7414363,'net',25,3),(62,7414365,7414363,'eta',25,3),(62,7414366,7414363,'tap',25,3),(62,7414367,7414363,'app',25,3),(62,7414368,7414364,'ser',25,3),(62,7414369,7414364,'eri',25,3),(62,7414370,7414364,'ria',25,3),(62,7414371,7414364,'ial',25,3),(62,7414372,7414368,'att',16.667,3),(62,7414373,7414368,'tta',16.667,3),(62,7414374,7414368,'tac',16.667,3),(62,7414375,7414368,'ach',16.667,3),(62,7414376,7414368,'che',16.667,3),(62,7414377,7414368,'hed',16.667,3),(62,7414378,7414372,'scs',50,3),(62,7414379,7414372,'csi',50,3),(62,7414380,7414378,'dis',50,2),(62,7414381,7414378,'isk',50,2),(62,7414382,7414380,'naa',100,4),(62,7414383,7414382,'600',3.333,4),(62,7414384,7414382,'00a',3.333,4),(62,7414385,7414382,'0a0',3.333,4),(62,7414386,7414382,'a09',3.333,4),(62,7414387,7414382,'098',3.333,4),(62,7414388,7414382,'980',3.333,4),(62,7414389,7414382,'808',3.333,4),(62,7414390,7414382,'08b',3.333,4),(62,7414391,7414382,'8b4',3.333,4),(62,7414392,7414382,'b4f',3.333,4),(62,7414393,7414382,'4f8',3.333,4),(62,7414394,7414382,'f84',3.333,4),(62,7414395,7414382,'84e',3.333,4),(62,7414396,7414382,'4ee',3.333,4),(62,7414397,7414382,'ee1',3.333,4),(62,7414398,7414382,'e1b',3.333,4),(62,7414399,7414382,'1b4',3.333,4),(62,7414400,7414382,'b44',3.333,4),(62,7414401,7414382,'444',3.333,4),(62,7414402,7414382,'448',3.333,4),(62,7414403,7414382,'481',3.333,4),(62,7414404,7414382,'811',3.333,4),(62,7414405,7414382,'117',3.333,4),(62,7414406,7414382,'17b',3.333,4),(62,7414407,7414382,'7b0',3.333,4),(62,7414408,7414382,'b07',3.333,4),(62,7414409,7414382,'07a',3.333,4),(62,7414410,7414382,'7ab',3.333,4),(62,7414411,7414382,'aba',3.333,4),(62,7414412,7414382,'ba2',3.333,4),(62,7414413,7414383,'siz',50,1),(62,7414414,7414383,'ize',50,1),(62,7414415,7414413,'163',33.333,1),(62,7414416,7414413,'638',33.333,1),(62,7414417,7414413,'384',33.333,1),(62,7414418,7414415,'dev',25,1),(62,7414419,7414415,'evi',25,1),(62,7414420,7414415,'vic',25,1),(62,7414421,7414415,'ice',25,1),(62,7414422,7414418,'typ',50,1),(62,7414423,7414418,'ype',50,1),(62,7414424,7414422,'dir',10,1),(62,7414425,7414422,'ire',10,1),(62,7414426,7414422,'rec',10,1),(62,7414427,7414422,'ect',10,1),(62,7414428,7414422,'cta',10,1),(62,7414429,7414422,'tac',10,1),(62,7414430,7414422,'acc',10,1),(62,7414431,7414422,'cce',10,1),(62,7414432,7414422,'ces',10,1),(62,7414433,7414422,'ess',10,1),(62,7414434,7414424,'mul',14.286,1),(62,7414435,7414424,'ult',14.286,1),(62,7414436,7414424,'lti',14.286,1),(62,7414437,7414424,'tip',14.286,1),(62,7414438,7414424,'ipa',14.286,1),(62,7414439,7414424,'pat',14.286,1),(62,7414440,7414424,'ath',14.286,1),(62,7414441,7414434,'plu',25,1),(62,7414442,7414434,'lug',25,1),(62,7414443,7414434,'ugi',25,1),(62,7414444,7414434,'gin',25,1),(62,7414445,7414441,'nmp',100,1),(62,7414446,7414445,'dev',33.333,1),(62,7414447,7414445,'evf',33.333,1),(62,7414448,7414445,'vfs',33.333,1),(62,7414449,7414446,'pat',50,1),(62,7414450,7414446,'ath',50,1),(62,7414451,7414449,'vmf',50,1),(62,7414452,7414449,'mfs',50,1),(62,7414453,7414451,'dev',20,1),(62,7414454,7414451,'evi',20,1),(62,7414455,7414451,'vic',20,1),(62,7414456,7414451,'ice',20,1),(62,7414457,7414451,'ces',20,1),(62,7414458,7414453,'dis',33.333,1),(62,7414459,7414453,'isk',33.333,1),(62,7414460,7414453,'sks',33.333,1),(62,7414461,7414458,'ven',25,1),(62,7414462,7414458,'end',25,1),(62,7414463,7414458,'ndo',25,1),(62,7414464,7414458,'dor',25,1),(62,7414465,7414461,'mod',33.333,1),(62,7414466,7414461,'ode',33.333,1),(62,7414467,7414461,'del',33.333,1),(62,7414468,7414465,'fla',33.333,1),(62,7414469,7414465,'las',33.333,1),(62,7414470,7414465,'ash',33.333,1),(62,7414471,7414468,'acc',33.333,1),(62,7414472,7414468,'cce',33.333,1),(62,7414473,7414468,'cel',33.333,1),(62,7414474,7414471,'rev',16.667,1),(62,7414475,7414471,'evi',16.667,1),(62,7414476,7414471,'vis',16.667,1),(62,7414477,7414471,'isi',16.667,1),(62,7414478,7414471,'sio',16.667,1),(62,7414479,7414471,'ion',16.667,1),(62,7414480,7414474,'lev',33.333,1),(62,7414481,7414474,'eve',33.333,1),(62,7414482,7414474,'vel',33.333,1),(62,7414483,7414480,'pse',25,1),(62,7414484,7414480,'seu',25,1),(62,7414485,7414480,'eud',25,1),(62,7414486,7414480,'udo',25,1),(62,7414487,7414483,'fal',33.333,5),(62,7414488,7414483,'als',33.333,5),(62,7414489,7414483,'lse',33.333,5),(62,7414490,7414487,'sta',25,3),(62,7414491,7414487,'tat',25,3),(62,7414492,7414487,'atu',25,3),(62,7414493,7414487,'tus',25,3),(62,7414494,7414490,'deg',16.667,1),(62,7414495,7414490,'egr',16.667,1),(62,7414496,7414490,'gra',16.667,1),(62,7414497,7414490,'rad',16.667,1),(62,7414498,7414490,'ade',16.667,1),(62,7414499,7414490,'ded',16.667,1),(62,7414500,7414494,'rdm',100,1),(62,7414501,7414500,'cap',20,1),(62,7414502,7414500,'apa',20,1),(62,7414503,7414500,'pab',20,1),(62,7414504,7414500,'abl',20,1),(62,7414505,7414500,'ble',20,1),(62,7414506,7414501,'tru',50,2),(62,7414507,7414501,'rue',50,2),(62,7414508,7414506,'loc',33.333,1),(62,7414509,7414506,'oca',33.333,1),(62,7414510,7414506,'cal',33.333,1),(62,7414511,7414508,'rem',14.286,1),(62,7414512,7414508,'emo',14.286,1),(62,7414513,7414508,'mov',14.286,1),(62,7414514,7414508,'ova',14.286,1),(62,7414515,7414508,'vab',14.286,1),(62,7414516,7414508,'abl',14.286,1),(62,7414517,7414508,'ble',14.286,1),(62,7414518,7414511,'ssd',100,1),(62,7414519,7414518,'off',20,1),(62,7414520,7414518,'ffl',20,1),(62,7414521,7414518,'fli',20,1),(62,7414522,7414518,'lin',20,1),(62,7414523,7414518,'ine',20,1),(62,7414524,7414519,'per',11.111,1),(62,7414525,7414519,'ere',11.111,1),(62,7414526,7414519,'ren',11.111,1),(62,7414527,7414519,'enn',11.111,1),(62,7414528,7414519,'nni',11.111,1),(62,7414529,7414519,'nia',11.111,1),(62,7414530,7414519,'ial',11.111,1),(62,7414531,7414519,'all',11.111,1),(62,7414532,7414519,'lly',11.111,1),(62,7414533,7414524,'res',16.667,1),(62,7414534,7414524,'ese',16.667,1),(62,7414535,7414524,'ser',16.667,1),(62,7414536,7414524,'erv',16.667,1),(62,7414537,7414524,'rve',16.667,1),(62,7414538,7414524,'ved',16.667,1),(62,7414539,7414533,'thi',50,1),(62,7414540,7414533,'hin',50,1),(62,7414541,7414539,'pro',10,1),(62,7414542,7414539,'rov',10,1),(62,7414543,7414539,'ovi',10,1),(62,7414544,7414539,'vis',10,1),(62,7414545,7414539,'isi',10,1),(62,7414546,7414539,'sio',10,1),(62,7414547,7414539,'ion',10,1),(62,7414548,7414539,'oni',10,1),(62,7414549,7414539,'nin',10,1),(62,7414550,7414539,'ing',10,1),(62,7414551,7414541,'unk',20,1),(62,7414552,7414541,'nkn',20,1),(62,7414553,7414541,'kno',20,1),(62,7414554,7414541,'now',20,1),(62,7414555,7414541,'own',20,1),(62,7414556,7414551,'fil',20,1),(62,7414557,7414551,'ilt',20,1),(62,7414558,7414551,'lte',20,1),(62,7414559,7414551,'ter',20,1),(62,7414560,7414551,'ers',20,1),(62,7414561,7414556,'vaa',50,1),(62,7414562,7414556,'aai',50,1),(62,7414563,7414561,'uns',11.111,1),(62,7414564,7414561,'nsu',11.111,1),(62,7414565,7414561,'sup',11.111,1),(62,7414566,7414561,'upp',11.111,1),(62,7414567,7414561,'ppo',11.111,1),(62,7414568,7414561,'por',11.111,1),(62,7414569,7414561,'ort',11.111,1),(62,7414570,7414561,'rte',11.111,1),(62,7414571,7414561,'ted',11.111,1),(62,7414572,7414563,'oth',33.333,1),(62,7414573,7414563,'the',33.333,1),(62,7414574,7414563,'her',33.333,1),(62,7414575,7414572,'uid',50,1),(62,7414576,7414572,'ids',50,1),(62,7414577,7414575,'vml',100,1),(62,7414578,7414577,'dis',20,1),(62,7414579,7414577,'isp',20,1),(62,7414580,7414577,'spl',20,1),(62,7414581,7414577,'pla',20,1),(62,7414582,7414577,'lay',20,1),(62,7414583,7414578,'nam',50,1),(62,7414584,7414578,'ame',50,1),(63,7414586,7414585,'net',25,3),(63,7414587,7414585,'eta',25,3),(63,7414588,7414585,'tap',25,3),(63,7414589,7414585,'app',25,3),(63,7414590,7414586,'fib',33.333,2),(63,7414591,7414586,'ibr',33.333,2),(63,7414592,7414586,'bre',33.333,2),(63,7414593,7414590,'cha',20,2),(63,7414594,7414590,'han',20,2),(63,7414595,7414590,'ann',20,2),(63,7414596,7414590,'nne',20,2),(63,7414597,7414590,'nel',20,2),(63,7414598,7414593,'dis',50,2),(63,7414599,7414593,'isk',50,2),(63,7414600,7414598,'naa',100,4),(63,7414601,7414600,'600',3.333,4),(63,7414602,7414600,'00a',3.333,4),(63,7414603,7414600,'0a0',3.333,4),(63,7414604,7414600,'a09',3.333,4),(63,7414605,7414600,'098',3.333,4),(63,7414606,7414600,'980',3.333,4),(63,7414607,7414600,'804',3.333,4),(63,7414608,7414600,'044',3.333,4),(63,7414609,7414600,'443',3.333,4),(63,7414610,7414600,'430',3.333,4),(63,7414611,7414600,'307',3.333,4),(63,7414612,7414600,'072',3.333,4),(63,7414613,7414600,'725',3.333,4),(63,7414614,7414600,'259',3.333,4),(63,7414615,7414600,'593',3.333,4),(63,7414616,7414600,'931',3.333,4),(63,7414617,7414600,'313',3.333,4),(63,7414618,7414600,'13f',3.333,4),(63,7414619,7414600,'3f3',3.333,4),(63,7414620,7414600,'f33',3.333,4),(63,7414621,7414600,'334',3.333,4),(63,7414622,7414600,'345',3.333,4),(63,7414623,7414600,'455',3.333,4),(63,7414624,7414600,'556',3.333,4),(63,7414625,7414600,'563',3.333,4),(63,7414626,7414600,'639',3.333,4),(63,7414627,7414600,'393',3.333,4),(63,7414628,7414600,'934',3.333,4),(63,7414629,7414600,'347',3.333,4),(63,7414630,7414600,'47a',3.333,4),(63,7414631,7414601,'ser',25,1),(63,7414632,7414601,'eri',25,1),(63,7414633,7414601,'ria',25,1),(63,7414634,7414601,'ial',25,1),(63,7414635,7414631,'siz',50,1),(63,7414636,7414631,'ize',50,1),(63,7414637,7414635,'321',100,1),(63,7414638,7414637,'dev',25,1),(63,7414639,7414637,'evi',25,1),(63,7414640,7414637,'vic',25,1),(63,7414641,7414637,'ice',25,1),(63,7414642,7414638,'typ',50,1),(63,7414643,7414638,'ype',50,1),(63,7414644,7414642,'dir',10,1),(63,7414645,7414642,'ire',10,1),(63,7414646,7414642,'rec',10,1),(63,7414647,7414642,'ect',10,1),(63,7414648,7414642,'cta',10,1),(63,7414649,7414642,'tac',10,1),(63,7414650,7414642,'acc',10,1),(63,7414651,7414642,'cce',10,1),(63,7414652,7414642,'ces',10,1),(63,7414653,7414642,'ess',10,1),(63,7414654,7414644,'mul',14.286,1),(63,7414655,7414644,'ult',14.286,1),(63,7414656,7414644,'lti',14.286,1),(63,7414657,7414644,'tip',14.286,1),(63,7414658,7414644,'ipa',14.286,1),(63,7414659,7414644,'pat',14.286,1),(63,7414660,7414644,'ath',14.286,1),(63,7414661,7414654,'plu',25,1),(63,7414662,7414654,'lug',25,1),(63,7414663,7414654,'ugi',25,1),(63,7414664,7414654,'gin',25,1),(63,7414665,7414661,'nmp',100,1),(63,7414666,7414665,'dev',33.333,1),(63,7414667,7414665,'evf',33.333,1),(63,7414668,7414665,'vfs',33.333,1),(63,7414669,7414666,'pat',50,1),(63,7414670,7414666,'ath',50,1),(63,7414671,7414669,'vmf',50,1),(63,7414672,7414669,'mfs',50,1),(63,7414673,7414671,'dev',20,1),(63,7414674,7414671,'evi',20,1),(63,7414675,7414671,'vic',20,1),(63,7414676,7414671,'ice',20,1),(63,7414677,7414671,'ces',20,1),(63,7414678,7414673,'dis',33.333,1),(63,7414679,7414673,'isk',33.333,1),(63,7414680,7414673,'sks',33.333,1),(63,7414681,7414678,'ven',25,1),(63,7414682,7414678,'end',25,1),(63,7414683,7414678,'ndo',25,1),(63,7414684,7414678,'dor',25,1),(63,7414685,7414681,'mod',33.333,1),(63,7414686,7414681,'ode',33.333,1),(63,7414687,7414681,'del',33.333,1),(63,7414688,7414685,'lun',100,1),(63,7414689,7414688,'cmo',33.333,1),(63,7414690,7414688,'mod',33.333,1),(63,7414691,7414688,'ode',33.333,1),(63,7414692,7414689,'rev',16.667,1),(63,7414693,7414689,'evi',16.667,1),(63,7414694,7414689,'vis',16.667,1),(63,7414695,7414689,'isi',16.667,1),(63,7414696,7414689,'sio',16.667,1),(63,7414697,7414689,'ion',16.667,1),(63,7414698,7414692,'810',50,1),(63,7414699,7414692,'100',50,1),(63,7414700,7414698,'scs',50,1),(63,7414701,7414698,'csi',50,1),(63,7414702,7414700,'lev',33.333,1),(63,7414703,7414700,'eve',33.333,1),(63,7414704,7414700,'vel',33.333,1),(63,7414705,7414702,'pse',25,1),(63,7414706,7414702,'seu',25,1),(63,7414707,7414702,'eud',25,1),(63,7414708,7414702,'udo',25,1),(63,7414709,7414705,'fal',33.333,6),(63,7414710,7414705,'als',33.333,6),(63,7414711,7414705,'lse',33.333,6),(63,7414712,7414709,'sta',25,3),(63,7414713,7414709,'tat',25,3),(63,7414714,7414709,'atu',25,3),(63,7414715,7414709,'tus',25,3),(63,7414716,7414712,'rdm',100,1),(63,7414717,7414716,'cap',20,1),(63,7414718,7414716,'apa',20,1),(63,7414719,7414716,'pab',20,1),(63,7414720,7414716,'abl',20,1),(63,7414721,7414716,'ble',20,1),(63,7414722,7414717,'tru',50,1),(63,7414723,7414717,'rue',50,1),(63,7414724,7414722,'loc',33.333,1),(63,7414725,7414722,'oca',33.333,1),(63,7414726,7414722,'cal',33.333,1),(63,7414727,7414724,'rem',14.286,1),(63,7414728,7414724,'emo',14.286,1),(63,7414729,7414724,'mov',14.286,1),(63,7414730,7414724,'ova',14.286,1),(63,7414731,7414724,'vab',14.286,1),(63,7414732,7414724,'abl',14.286,1),(63,7414733,7414724,'ble',14.286,1),(63,7414734,7414727,'ssd',100,1),(63,7414735,7414734,'off',20,1),(63,7414736,7414734,'ffl',20,1),(63,7414737,7414734,'fli',20,1),(63,7414738,7414734,'lin',20,1),(63,7414739,7414734,'ine',20,1),(63,7414740,7414735,'per',11.111,1),(63,7414741,7414735,'ere',11.111,1),(63,7414742,7414735,'ren',11.111,1),(63,7414743,7414735,'enn',11.111,1),(63,7414744,7414735,'nni',11.111,1),(63,7414745,7414735,'nia',11.111,1),(63,7414746,7414735,'ial',11.111,1),(63,7414747,7414735,'all',11.111,1),(63,7414748,7414735,'lly',11.111,1),(63,7414749,7414740,'res',16.667,1),(63,7414750,7414740,'ese',16.667,1),(63,7414751,7414740,'ser',16.667,1),(63,7414752,7414740,'erv',16.667,1),(63,7414753,7414740,'rve',16.667,1),(63,7414754,7414740,'ved',16.667,1),(63,7414755,7414749,'thi',50,1),(63,7414756,7414749,'hin',50,1),(63,7414757,7414755,'pro',10,1),(63,7414758,7414755,'rov',10,1),(63,7414759,7414755,'ovi',10,1),(63,7414760,7414755,'vis',10,1),(63,7414761,7414755,'isi',10,1),(63,7414762,7414755,'sio',10,1),(63,7414763,7414755,'ion',10,1),(63,7414764,7414755,'oni',10,1),(63,7414765,7414755,'nin',10,1),(63,7414766,7414755,'ing',10,1),(63,7414767,7414757,'yes',100,1),(63,7414768,7414767,'att',16.667,1),(63,7414769,7414767,'tta',16.667,1),(63,7414770,7414767,'tac',16.667,1),(63,7414771,7414767,'ach',16.667,1),(63,7414772,7414767,'che',16.667,1),(63,7414773,7414767,'hed',16.667,1),(63,7414774,7414768,'fil',20,1),(63,7414775,7414768,'ilt',20,1),(63,7414776,7414768,'lte',20,1),(63,7414777,7414768,'ter',20,1),(63,7414778,7414768,'ers',20,1),(63,7414779,7414774,'vaa',50,1),(63,7414780,7414774,'aai',50,1),(63,7414781,7414779,'unk',20,1),(63,7414782,7414779,'nkn',20,1),(63,7414783,7414779,'kno',20,1),(63,7414784,7414779,'now',20,1),(63,7414785,7414779,'own',20,1),(63,7414786,7414781,'oth',33.333,1),(63,7414787,7414781,'the',33.333,1),(63,7414788,7414781,'her',33.333,1),(63,7414789,7414786,'uid',50,1),(63,7414790,7414786,'ids',50,1),(63,7414791,7414789,'vml',100,1),(63,7414792,7414791,'dis',20,1),(63,7414793,7414791,'isp',20,1),(63,7414794,7414791,'spl',20,1),(63,7414795,7414791,'pla',20,1),(63,7414796,7414791,'lay',20,1),(63,7414797,7414792,'nam',50,1),(63,7414798,7414792,'ame',50,1),(64,7414800,7414799,'net',25,3),(64,7414801,7414799,'eta',25,3),(64,7414802,7414799,'tap',25,3),(64,7414803,7414799,'app',25,3),(64,7414804,7414800,'fib',33.333,2),(64,7414805,7414800,'ibr',33.333,2),(64,7414806,7414800,'bre',33.333,2),(64,7414807,7414804,'cha',20,2),(64,7414808,7414804,'han',20,2),(64,7414809,7414804,'ann',20,2),(64,7414810,7414804,'nne',20,2),(64,7414811,7414804,'nel',20,2),(64,7414812,7414807,'dis',50,2),(64,7414813,7414807,'isk',50,2),(64,7414814,7414812,'naa',100,4),(64,7414815,7414814,'600',3.333,4),(64,7414816,7414814,'00a',3.333,4),(64,7414817,7414814,'0a0',3.333,4),(64,7414818,7414814,'a09',3.333,4),(64,7414819,7414814,'098',3.333,4),(64,7414820,7414814,'980',3.333,4),(64,7414821,7414814,'804',3.333,4),(64,7414822,7414814,'044',3.333,4),(64,7414823,7414814,'443',3.333,4),(64,7414824,7414814,'430',3.333,4),(64,7414825,7414814,'307',3.333,4),(64,7414826,7414814,'075',3.333,4),(64,7414827,7414814,'753',3.333,4),(64,7414828,7414814,'535',3.333,4),(64,7414829,7414814,'357',3.333,4),(64,7414830,7414814,'573',3.333,4),(64,7414831,7414814,'732',3.333,4),(64,7414832,7414814,'32b',3.333,4),(64,7414833,7414814,'2b3',3.333,4),(64,7414834,7414814,'b33',3.333,4),(64,7414835,7414814,'334',3.333,4),(64,7414836,7414814,'345',3.333,4),(64,7414837,7414814,'457',3.333,4),(64,7414838,7414814,'571',3.333,4),(64,7414839,7414814,'715',3.333,4),(64,7414840,7414814,'153',3.333,4),(64,7414841,7414814,'533',3.333,4),(64,7414842,7414814,'335',3.333,4),(64,7414843,7414814,'356',3.333,4),(64,7414844,7414814,'561',3.333,4),(64,7414845,7414815,'ser',25,1),(64,7414846,7414815,'eri',25,1),(64,7414847,7414815,'ria',25,1),(64,7414848,7414815,'ial',25,1),(64,7414849,7414845,'siz',50,1),(64,7414850,7414845,'ize',50,1),(64,7414851,7414849,'460',33.333,1),(64,7414852,7414849,'608',33.333,1),(64,7414853,7414849,'080',33.333,1),(64,7414854,7414851,'dev',25,1),(64,7414855,7414851,'evi',25,1),(64,7414856,7414851,'vic',25,1),(64,7414857,7414851,'ice',25,1),(64,7414858,7414854,'typ',50,1),(64,7414859,7414854,'ype',50,1),(64,7414860,7414858,'dir',10,1),(64,7414861,7414858,'ire',10,1),(64,7414862,7414858,'rec',10,1),(64,7414863,7414858,'ect',10,1),(64,7414864,7414858,'cta',10,1),(64,7414865,7414858,'tac',10,1),(64,7414866,7414858,'acc',10,1),(64,7414867,7414858,'cce',10,1),(64,7414868,7414858,'ces',10,1),(64,7414869,7414858,'ess',10,1),(64,7414870,7414860,'mul',14.286,1),(64,7414871,7414860,'ult',14.286,1),(64,7414872,7414860,'lti',14.286,1),(64,7414873,7414860,'tip',14.286,1),(64,7414874,7414860,'ipa',14.286,1),(64,7414875,7414860,'pat',14.286,1),(64,7414876,7414860,'ath',14.286,1),(64,7414877,7414870,'plu',25,1),(64,7414878,7414870,'lug',25,1),(64,7414879,7414870,'ugi',25,1),(64,7414880,7414870,'gin',25,1),(64,7414881,7414877,'nmp',100,1),(64,7414882,7414881,'dev',33.333,1),(64,7414883,7414881,'evf',33.333,1),(64,7414884,7414881,'vfs',33.333,1),(64,7414885,7414882,'pat',50,1),(64,7414886,7414882,'ath',50,1),(64,7414887,7414885,'vmf',50,1),(64,7414888,7414885,'mfs',50,1),(64,7414889,7414887,'dev',20,1),(64,7414890,7414887,'evi',20,1),(64,7414891,7414887,'vic',20,1),(64,7414892,7414887,'ice',20,1),(64,7414893,7414887,'ces',20,1),(64,7414894,7414889,'dis',33.333,1),(64,7414895,7414889,'isk',33.333,1),(64,7414896,7414889,'sks',33.333,1),(64,7414897,7414894,'ven',25,1),(64,7414898,7414894,'end',25,1),(64,7414899,7414894,'ndo',25,1),(64,7414900,7414894,'dor',25,1),(64,7414901,7414897,'mod',33.333,1),(64,7414902,7414897,'ode',33.333,1),(64,7414903,7414897,'del',33.333,1),(64,7414904,7414901,'lun',100,1),(64,7414905,7414904,'cmo',33.333,1),(64,7414906,7414904,'mod',33.333,1),(64,7414907,7414904,'ode',33.333,1),(64,7414908,7414905,'rev',16.667,1),(64,7414909,7414905,'evi',16.667,1),(64,7414910,7414905,'vis',16.667,1),(64,7414911,7414905,'isi',16.667,1),(64,7414912,7414905,'sio',16.667,1),(64,7414913,7414905,'ion',16.667,1),(64,7414914,7414908,'810',50,1),(64,7414915,7414908,'100',50,1),(64,7414916,7414914,'scs',50,1),(64,7414917,7414914,'csi',50,1),(64,7414918,7414916,'lev',33.333,1),(64,7414919,7414916,'eve',33.333,1),(64,7414920,7414916,'vel',33.333,1),(64,7414921,7414918,'pse',25,1),(64,7414922,7414918,'seu',25,1),(64,7414923,7414918,'eud',25,1),(64,7414924,7414918,'udo',25,1),(64,7414925,7414921,'fal',33.333,6),(64,7414926,7414921,'als',33.333,6),(64,7414927,7414921,'lse',33.333,6),(64,7414928,7414925,'sta',25,3),(64,7414929,7414925,'tat',25,3),(64,7414930,7414925,'atu',25,3),(64,7414931,7414925,'tus',25,3),(64,7414932,7414928,'rdm',100,1),(64,7414933,7414932,'cap',20,1),(64,7414934,7414932,'apa',20,1),(64,7414935,7414932,'pab',20,1),(64,7414936,7414932,'abl',20,1),(64,7414937,7414932,'ble',20,1),(64,7414938,7414933,'tru',50,1),(64,7414939,7414933,'rue',50,1),(64,7414940,7414938,'loc',33.333,1),(64,7414941,7414938,'oca',33.333,1),(64,7414942,7414938,'cal',33.333,1),(64,7414943,7414940,'rem',14.286,1),(64,7414944,7414940,'emo',14.286,1),(64,7414945,7414940,'mov',14.286,1),(64,7414946,7414940,'ova',14.286,1),(64,7414947,7414940,'vab',14.286,1),(64,7414948,7414940,'abl',14.286,1),(64,7414949,7414940,'ble',14.286,1),(64,7414950,7414943,'ssd',100,1),(64,7414951,7414950,'off',20,1),(64,7414952,7414950,'ffl',20,1),(64,7414953,7414950,'fli',20,1),(64,7414954,7414950,'lin',20,1),(64,7414955,7414950,'ine',20,1),(64,7414956,7414951,'per',11.111,1),(64,7414957,7414951,'ere',11.111,1),(64,7414958,7414951,'ren',11.111,1),(64,7414959,7414951,'enn',11.111,1),(64,7414960,7414951,'nni',11.111,1),(64,7414961,7414951,'nia',11.111,1),(64,7414962,7414951,'ial',11.111,1),(64,7414963,7414951,'all',11.111,1),(64,7414964,7414951,'lly',11.111,1),(64,7414965,7414956,'res',16.667,1),(64,7414966,7414956,'ese',16.667,1),(64,7414967,7414956,'ser',16.667,1),(64,7414968,7414956,'erv',16.667,1),(64,7414969,7414956,'rve',16.667,1),(64,7414970,7414956,'ved',16.667,1),(64,7414971,7414965,'thi',50,1),(64,7414972,7414965,'hin',50,1),(64,7414973,7414971,'pro',10,1),(64,7414974,7414971,'rov',10,1),(64,7414975,7414971,'ovi',10,1),(64,7414976,7414971,'vis',10,1),(64,7414977,7414971,'isi',10,1),(64,7414978,7414971,'sio',10,1),(64,7414979,7414971,'ion',10,1),(64,7414980,7414971,'oni',10,1),(64,7414981,7414971,'nin',10,1),(64,7414982,7414971,'ing',10,1),(64,7414983,7414973,'yes',100,1),(64,7414984,7414983,'att',16.667,1),(64,7414985,7414983,'tta',16.667,1),(64,7414986,7414983,'tac',16.667,1),(64,7414987,7414983,'ach',16.667,1),(64,7414988,7414983,'che',16.667,1),(64,7414989,7414983,'hed',16.667,1),(64,7414990,7414984,'fil',20,1),(64,7414991,7414984,'ilt',20,1),(64,7414992,7414984,'lte',20,1),(64,7414993,7414984,'ter',20,1),(64,7414994,7414984,'ers',20,1),(64,7414995,7414990,'vaa',50,1),(64,7414996,7414990,'aai',50,1),(64,7414997,7414995,'unk',20,1),(64,7414998,7414995,'nkn',20,1),(64,7414999,7414995,'kno',20,1),(64,7415000,7414995,'now',20,1),(64,7415001,7414995,'own',20,1),(64,7415002,7414997,'oth',33.333,1),(64,7415003,7414997,'the',33.333,1),(64,7415004,7414997,'her',33.333,1),(64,7415005,7415002,'uid',50,1),(64,7415006,7415002,'ids',50,1),(64,7415007,7415005,'vml',100,1),(64,7415008,7415007,'dis',20,1),(64,7415009,7415007,'isp',20,1),(64,7415010,7415007,'spl',20,1),(64,7415011,7415007,'pla',20,1),(64,7415012,7415007,'lay',20,1),(64,7415013,7415008,'nam',50,1),(64,7415014,7415008,'ame',50,1),(65,7415016,7415015,'net',25,3),(65,7415017,7415015,'eta',25,3),(65,7415018,7415015,'tap',25,3),(65,7415019,7415015,'app',25,3),(65,7415020,7415016,'fib',33.333,2),(65,7415021,7415016,'ibr',33.333,2),(65,7415022,7415016,'bre',33.333,2),(65,7415023,7415020,'cha',20,2),(65,7415024,7415020,'han',20,2),(65,7415025,7415020,'ann',20,2),(65,7415026,7415020,'nne',20,2),(65,7415027,7415020,'nel',20,2),(65,7415028,7415023,'dis',50,2),(65,7415029,7415023,'isk',50,2),(65,7415030,7415028,'naa',100,4),(65,7415031,7415030,'600',3.333,4),(65,7415032,7415030,'00a',3.333,4),(65,7415033,7415030,'0a0',3.333,4),(65,7415034,7415030,'a09',3.333,4),(65,7415035,7415030,'098',3.333,4),(65,7415036,7415030,'980',3.333,4),(65,7415037,7415030,'804',3.333,4),(65,7415038,7415030,'044',3.333,4),(65,7415039,7415030,'443',3.333,4),(65,7415040,7415030,'430',3.333,4),(65,7415041,7415030,'307',3.333,4),(65,7415042,7415030,'075',3.333,4),(65,7415043,7415030,'753',3.333,4),(65,7415044,7415030,'535',3.333,4),(65,7415045,7415030,'357',3.333,4),(65,7415046,7415030,'573',3.333,4),(65,7415047,7415030,'732',3.333,4),(65,7415048,7415030,'32b',3.333,4),(65,7415049,7415030,'2b3',3.333,4),(65,7415050,7415030,'b33',3.333,4),(65,7415051,7415030,'334',3.333,4),(65,7415052,7415030,'345',3.333,4),(65,7415053,7415030,'457',3.333,4),(65,7415054,7415030,'571',3.333,4),(65,7415055,7415030,'715',3.333,4),(65,7415056,7415030,'153',3.333,4),(65,7415057,7415030,'533',3.333,4),(65,7415058,7415030,'335',3.333,4),(65,7415059,7415030,'356',3.333,4),(65,7415060,7415030,'562',3.333,4),(65,7415061,7415031,'ser',25,1),(65,7415062,7415031,'eri',25,1),(65,7415063,7415031,'ria',25,1),(65,7415064,7415031,'ial',25,1),(65,7415065,7415061,'siz',50,1),(65,7415066,7415061,'ize',50,1),(65,7415067,7415065,'460',33.333,1),(65,7415068,7415065,'608',33.333,1),(65,7415069,7415065,'080',33.333,1),(65,7415070,7415067,'dev',25,1),(65,7415071,7415067,'evi',25,1),(65,7415072,7415067,'vic',25,1),(65,7415073,7415067,'ice',25,1),(65,7415074,7415070,'typ',50,1),(65,7415075,7415070,'ype',50,1),(65,7415076,7415074,'dir',10,1),(65,7415077,7415074,'ire',10,1),(65,7415078,7415074,'rec',10,1),(65,7415079,7415074,'ect',10,1),(65,7415080,7415074,'cta',10,1),(65,7415081,7415074,'tac',10,1),(65,7415082,7415074,'acc',10,1),(65,7415083,7415074,'cce',10,1),(65,7415084,7415074,'ces',10,1),(65,7415085,7415074,'ess',10,1),(65,7415086,7415076,'mul',14.286,1),(65,7415087,7415076,'ult',14.286,1),(65,7415088,7415076,'lti',14.286,1),(65,7415089,7415076,'tip',14.286,1),(65,7415090,7415076,'ipa',14.286,1),(65,7415091,7415076,'pat',14.286,1),(65,7415092,7415076,'ath',14.286,1),(65,7415093,7415086,'plu',25,1),(65,7415094,7415086,'lug',25,1),(65,7415095,7415086,'ugi',25,1),(65,7415096,7415086,'gin',25,1),(65,7415097,7415093,'nmp',100,1),(65,7415098,7415097,'dev',33.333,1),(65,7415099,7415097,'evf',33.333,1),(65,7415100,7415097,'vfs',33.333,1),(65,7415101,7415098,'pat',50,1),(65,7415102,7415098,'ath',50,1),(65,7415103,7415101,'vmf',50,1),(65,7415104,7415101,'mfs',50,1),(65,7415105,7415103,'dev',20,1),(65,7415106,7415103,'evi',20,1),(65,7415107,7415103,'vic',20,1),(65,7415108,7415103,'ice',20,1),(65,7415109,7415103,'ces',20,1),(65,7415110,7415105,'dis',33.333,1),(65,7415111,7415105,'isk',33.333,1),(65,7415112,7415105,'sks',33.333,1),(65,7415113,7415110,'ven',25,1),(65,7415114,7415110,'end',25,1),(65,7415115,7415110,'ndo',25,1),(65,7415116,7415110,'dor',25,1),(65,7415117,7415113,'mod',33.333,1),(65,7415118,7415113,'ode',33.333,1),(65,7415119,7415113,'del',33.333,1),(65,7415120,7415117,'lun',100,1),(65,7415121,7415120,'cmo',33.333,1),(65,7415122,7415120,'mod',33.333,1),(65,7415123,7415120,'ode',33.333,1),(65,7415124,7415121,'rev',16.667,1),(65,7415125,7415121,'evi',16.667,1),(65,7415126,7415121,'vis',16.667,1),(65,7415127,7415121,'isi',16.667,1),(65,7415128,7415121,'sio',16.667,1),(65,7415129,7415121,'ion',16.667,1),(65,7415130,7415124,'810',50,1),(65,7415131,7415124,'100',50,1),(65,7415132,7415130,'scs',50,1),(65,7415133,7415130,'csi',50,1),(65,7415134,7415132,'lev',33.333,1),(65,7415135,7415132,'eve',33.333,1),(65,7415136,7415132,'vel',33.333,1),(65,7415137,7415134,'pse',25,1),(65,7415138,7415134,'seu',25,1),(65,7415139,7415134,'eud',25,1),(65,7415140,7415134,'udo',25,1),(65,7415141,7415137,'fal',33.333,6),(65,7415142,7415137,'als',33.333,6),(65,7415143,7415137,'lse',33.333,6),(65,7415144,7415141,'sta',25,3),(65,7415145,7415141,'tat',25,3),(65,7415146,7415141,'atu',25,3),(65,7415147,7415141,'tus',25,3),(65,7415148,7415144,'rdm',100,1),(65,7415149,7415148,'cap',20,1),(65,7415150,7415148,'apa',20,1),(65,7415151,7415148,'pab',20,1),(65,7415152,7415148,'abl',20,1),(65,7415153,7415148,'ble',20,1),(65,7415154,7415149,'tru',50,1),(65,7415155,7415149,'rue',50,1),(65,7415156,7415154,'loc',33.333,1),(65,7415157,7415154,'oca',33.333,1),(65,7415158,7415154,'cal',33.333,1),(65,7415159,7415156,'rem',14.286,1),(65,7415160,7415156,'emo',14.286,1),(65,7415161,7415156,'mov',14.286,1),(65,7415162,7415156,'ova',14.286,1),(65,7415163,7415156,'vab',14.286,1),(65,7415164,7415156,'abl',14.286,1),(65,7415165,7415156,'ble',14.286,1),(65,7415166,7415159,'ssd',100,1),(65,7415167,7415166,'off',20,1),(65,7415168,7415166,'ffl',20,1),(65,7415169,7415166,'fli',20,1),(65,7415170,7415166,'lin',20,1),(65,7415171,7415166,'ine',20,1),(65,7415172,7415167,'per',11.111,1),(65,7415173,7415167,'ere',11.111,1),(65,7415174,7415167,'ren',11.111,1),(65,7415175,7415167,'enn',11.111,1),(65,7415176,7415167,'nni',11.111,1),(65,7415177,7415167,'nia',11.111,1),(65,7415178,7415167,'ial',11.111,1),(65,7415179,7415167,'all',11.111,1),(65,7415180,7415167,'lly',11.111,1),(65,7415181,7415172,'res',16.667,1),(65,7415182,7415172,'ese',16.667,1),(65,7415183,7415172,'ser',16.667,1),(65,7415184,7415172,'erv',16.667,1),(65,7415185,7415172,'rve',16.667,1),(65,7415186,7415172,'ved',16.667,1),(65,7415187,7415181,'thi',50,1),(65,7415188,7415181,'hin',50,1),(65,7415189,7415187,'pro',10,1),(65,7415190,7415187,'rov',10,1),(65,7415191,7415187,'ovi',10,1),(65,7415192,7415187,'vis',10,1),(65,7415193,7415187,'isi',10,1),(65,7415194,7415187,'sio',10,1),(65,7415195,7415187,'ion',10,1),(65,7415196,7415187,'oni',10,1),(65,7415197,7415187,'nin',10,1),(65,7415198,7415187,'ing',10,1),(65,7415199,7415189,'yes',100,1),(65,7415200,7415199,'att',16.667,1),(65,7415201,7415199,'tta',16.667,1),(65,7415202,7415199,'tac',16.667,1),(65,7415203,7415199,'ach',16.667,1),(65,7415204,7415199,'che',16.667,1),(65,7415205,7415199,'hed',16.667,1),(65,7415206,7415200,'fil',20,1),(65,7415207,7415200,'ilt',20,1),(65,7415208,7415200,'lte',20,1),(65,7415209,7415200,'ter',20,1),(65,7415210,7415200,'ers',20,1),(65,7415211,7415206,'vaa',50,1),(65,7415212,7415206,'aai',50,1),(65,7415213,7415211,'unk',20,1),(65,7415214,7415211,'nkn',20,1),(65,7415215,7415211,'kno',20,1),(65,7415216,7415211,'now',20,1),(65,7415217,7415211,'own',20,1),(65,7415218,7415213,'oth',33.333,1),(65,7415219,7415213,'the',33.333,1),(65,7415220,7415213,'her',33.333,1),(65,7415221,7415218,'uid',50,1),(65,7415222,7415218,'ids',50,1),(65,7415223,7415221,'vml',100,1),(65,7415224,7415223,'dis',20,1),(65,7415225,7415223,'isp',20,1),(65,7415226,7415223,'spl',20,1),(65,7415227,7415223,'pla',20,1),(65,7415228,7415223,'lay',20,1),(65,7415229,7415224,'nam',50,1),(65,7415230,7415224,'ame',50,1),(66,7415232,7415231,'net',25,3),(66,7415233,7415231,'eta',25,3),(66,7415234,7415231,'tap',25,3),(66,7415235,7415231,'app',25,3),(66,7415236,7415232,'fib',33.333,2),(66,7415237,7415232,'ibr',33.333,2),(66,7415238,7415232,'bre',33.333,2),(66,7415239,7415236,'cha',20,2),(66,7415240,7415236,'han',20,2),(66,7415241,7415236,'ann',20,2),(66,7415242,7415236,'nne',20,2),(66,7415243,7415236,'nel',20,2),(66,7415244,7415239,'dis',50,2),(66,7415245,7415239,'isk',50,2),(66,7415246,7415244,'naa',100,4),(66,7415247,7415246,'600',3.333,4),(66,7415248,7415246,'00a',3.333,4),(66,7415249,7415246,'0a0',3.333,4),(66,7415250,7415246,'a09',3.333,4),(66,7415251,7415246,'098',3.333,4),(66,7415252,7415246,'980',3.333,4),(66,7415253,7415246,'804',3.333,4),(66,7415254,7415246,'044',3.333,4),(66,7415255,7415246,'443',3.333,4),(66,7415256,7415246,'430',3.333,4),(66,7415257,7415246,'307',3.333,4),(66,7415258,7415246,'075',3.333,4),(66,7415259,7415246,'753',3.333,4),(66,7415260,7415246,'535',3.333,4),(66,7415261,7415246,'357',3.333,4),(66,7415262,7415246,'573',3.333,4),(66,7415263,7415246,'732',3.333,4),(66,7415264,7415246,'32b',3.333,4),(66,7415265,7415246,'2b3',3.333,4),(66,7415266,7415246,'b33',3.333,4),(66,7415267,7415246,'334',3.333,4),(66,7415268,7415246,'345',3.333,4),(66,7415269,7415246,'457',3.333,4),(66,7415270,7415246,'571',3.333,4),(66,7415271,7415246,'715',3.333,4),(66,7415272,7415246,'153',3.333,4),(66,7415273,7415246,'533',3.333,4),(66,7415274,7415246,'335',3.333,4),(66,7415275,7415246,'356',3.333,4),(66,7415276,7415246,'563',3.333,4),(66,7415277,7415247,'ser',25,1),(66,7415278,7415247,'eri',25,1),(66,7415279,7415247,'ria',25,1),(66,7415280,7415247,'ial',25,1),(66,7415281,7415277,'siz',50,1),(66,7415282,7415277,'ize',50,1),(66,7415283,7415281,'460',33.333,1),(66,7415284,7415281,'608',33.333,1),(66,7415285,7415281,'080',33.333,1),(66,7415286,7415283,'dev',25,1),(66,7415287,7415283,'evi',25,1),(66,7415288,7415283,'vic',25,1),(66,7415289,7415283,'ice',25,1),(66,7415290,7415286,'typ',50,1),(66,7415291,7415286,'ype',50,1),(66,7415292,7415290,'dir',10,1),(66,7415293,7415290,'ire',10,1),(66,7415294,7415290,'rec',10,1),(66,7415295,7415290,'ect',10,1),(66,7415296,7415290,'cta',10,1),(66,7415297,7415290,'tac',10,1),(66,7415298,7415290,'acc',10,1),(66,7415299,7415290,'cce',10,1),(66,7415300,7415290,'ces',10,1),(66,7415301,7415290,'ess',10,1),(66,7415302,7415292,'mul',14.286,1),(66,7415303,7415292,'ult',14.286,1),(66,7415304,7415292,'lti',14.286,1),(66,7415305,7415292,'tip',14.286,1),(66,7415306,7415292,'ipa',14.286,1),(66,7415307,7415292,'pat',14.286,1),(66,7415308,7415292,'ath',14.286,1),(66,7415309,7415302,'plu',25,1),(66,7415310,7415302,'lug',25,1),(66,7415311,7415302,'ugi',25,1),(66,7415312,7415302,'gin',25,1),(66,7415313,7415309,'nmp',100,1),(66,7415314,7415313,'dev',33.333,1),(66,7415315,7415313,'evf',33.333,1),(66,7415316,7415313,'vfs',33.333,1),(66,7415317,7415314,'pat',50,1),(66,7415318,7415314,'ath',50,1),(66,7415319,7415317,'vmf',50,1),(66,7415320,7415317,'mfs',50,1),(66,7415321,7415319,'dev',20,1),(66,7415322,7415319,'evi',20,1),(66,7415323,7415319,'vic',20,1),(66,7415324,7415319,'ice',20,1),(66,7415325,7415319,'ces',20,1),(66,7415326,7415321,'dis',33.333,1),(66,7415327,7415321,'isk',33.333,1),(66,7415328,7415321,'sks',33.333,1),(66,7415329,7415326,'ven',25,1),(66,7415330,7415326,'end',25,1),(66,7415331,7415326,'ndo',25,1),(66,7415332,7415326,'dor',25,1),(66,7415333,7415329,'mod',33.333,1),(66,7415334,7415329,'ode',33.333,1),(66,7415335,7415329,'del',33.333,1),(66,7415336,7415333,'lun',100,1),(66,7415337,7415336,'cmo',33.333,1),(66,7415338,7415336,'mod',33.333,1),(66,7415339,7415336,'ode',33.333,1),(66,7415340,7415337,'rev',16.667,1),(66,7415341,7415337,'evi',16.667,1),(66,7415342,7415337,'vis',16.667,1),(66,7415343,7415337,'isi',16.667,1),(66,7415344,7415337,'sio',16.667,1),(66,7415345,7415337,'ion',16.667,1),(66,7415346,7415340,'810',50,1),(66,7415347,7415340,'100',50,1),(66,7415348,7415346,'scs',50,1),(66,7415349,7415346,'csi',50,1),(66,7415350,7415348,'lev',33.333,1),(66,7415351,7415348,'eve',33.333,1),(66,7415352,7415348,'vel',33.333,1),(66,7415353,7415350,'pse',25,1),(66,7415354,7415350,'seu',25,1),(66,7415355,7415350,'eud',25,1),(66,7415356,7415350,'udo',25,1),(66,7415357,7415353,'fal',33.333,6),(66,7415358,7415353,'als',33.333,6),(66,7415359,7415353,'lse',33.333,6),(66,7415360,7415357,'sta',25,3),(66,7415361,7415357,'tat',25,3),(66,7415362,7415357,'atu',25,3),(66,7415363,7415357,'tus',25,3),(66,7415364,7415360,'rdm',100,1),(66,7415365,7415364,'cap',20,1),(66,7415366,7415364,'apa',20,1),(66,7415367,7415364,'pab',20,1),(66,7415368,7415364,'abl',20,1),(66,7415369,7415364,'ble',20,1),(66,7415370,7415365,'tru',50,1),(66,7415371,7415365,'rue',50,1),(66,7415372,7415370,'loc',33.333,1),(66,7415373,7415370,'oca',33.333,1),(66,7415374,7415370,'cal',33.333,1),(66,7415375,7415372,'rem',14.286,1),(66,7415376,7415372,'emo',14.286,1),(66,7415377,7415372,'mov',14.286,1),(66,7415378,7415372,'ova',14.286,1),(66,7415379,7415372,'vab',14.286,1),(66,7415380,7415372,'abl',14.286,1),(66,7415381,7415372,'ble',14.286,1),(66,7415382,7415375,'ssd',100,1),(66,7415383,7415382,'off',20,1),(66,7415384,7415382,'ffl',20,1),(66,7415385,7415382,'fli',20,1),(66,7415386,7415382,'lin',20,1),(66,7415387,7415382,'ine',20,1),(66,7415388,7415383,'per',11.111,1),(66,7415389,7415383,'ere',11.111,1),(66,7415390,7415383,'ren',11.111,1),(66,7415391,7415383,'enn',11.111,1),(66,7415392,7415383,'nni',11.111,1),(66,7415393,7415383,'nia',11.111,1),(66,7415394,7415383,'ial',11.111,1),(66,7415395,7415383,'all',11.111,1),(66,7415396,7415383,'lly',11.111,1),(66,7415397,7415388,'res',16.667,1),(66,7415398,7415388,'ese',16.667,1),(66,7415399,7415388,'ser',16.667,1),(66,7415400,7415388,'erv',16.667,1),(66,7415401,7415388,'rve',16.667,1),(66,7415402,7415388,'ved',16.667,1),(66,7415403,7415397,'thi',50,1),(66,7415404,7415397,'hin',50,1),(66,7415405,7415403,'pro',10,1),(66,7415406,7415403,'rov',10,1),(66,7415407,7415403,'ovi',10,1),(66,7415408,7415403,'vis',10,1),(66,7415409,7415403,'isi',10,1),(66,7415410,7415403,'sio',10,1),(66,7415411,7415403,'ion',10,1),(66,7415412,7415403,'oni',10,1),(66,7415413,7415403,'nin',10,1),(66,7415414,7415403,'ing',10,1),(66,7415415,7415405,'yes',100,1),(66,7415416,7415415,'att',16.667,1),(66,7415417,7415415,'tta',16.667,1),(66,7415418,7415415,'tac',16.667,1),(66,7415419,7415415,'ach',16.667,1),(66,7415420,7415415,'che',16.667,1),(66,7415421,7415415,'hed',16.667,1),(66,7415422,7415416,'fil',20,1),(66,7415423,7415416,'ilt',20,1),(66,7415424,7415416,'lte',20,1),(66,7415425,7415416,'ter',20,1),(66,7415426,7415416,'ers',20,1),(66,7415427,7415422,'vaa',50,1),(66,7415428,7415422,'aai',50,1),(66,7415429,7415427,'unk',20,1),(66,7415430,7415427,'nkn',20,1),(66,7415431,7415427,'kno',20,1),(66,7415432,7415427,'now',20,1),(66,7415433,7415427,'own',20,1),(66,7415434,7415429,'oth',33.333,1),(66,7415435,7415429,'the',33.333,1),(66,7415436,7415429,'her',33.333,1),(66,7415437,7415434,'uid',50,1),(66,7415438,7415434,'ids',50,1),(66,7415439,7415437,'vml',100,1),(66,7415440,7415439,'dis',20,1),(66,7415441,7415439,'isp',20,1),(66,7415442,7415439,'spl',20,1),(66,7415443,7415439,'pla',20,1),(66,7415444,7415439,'lay',20,1),(66,7415445,7415440,'nam',50,1),(66,7415446,7415440,'ame',50,1),(67,7415448,7415447,'net',25,3),(67,7415449,7415447,'eta',25,3),(67,7415450,7415447,'tap',25,3),(67,7415451,7415447,'app',25,3),(67,7415452,7415448,'fib',33.333,2),(67,7415453,7415448,'ibr',33.333,2),(67,7415454,7415448,'bre',33.333,2),(67,7415455,7415452,'cha',20,2),(67,7415456,7415452,'han',20,2),(67,7415457,7415452,'ann',20,2),(67,7415458,7415452,'nne',20,2),(67,7415459,7415452,'nel',20,2),(67,7415460,7415455,'dis',50,2),(67,7415461,7415455,'isk',50,2),(67,7415462,7415460,'naa',100,4),(67,7415463,7415462,'600',3.333,4),(67,7415464,7415462,'00a',3.333,4),(67,7415465,7415462,'0a0',3.333,4),(67,7415466,7415462,'a09',3.333,4),(67,7415467,7415462,'098',3.333,4),(67,7415468,7415462,'980',3.333,4),(67,7415469,7415462,'804',3.333,4),(67,7415470,7415462,'044',3.333,4),(67,7415471,7415462,'443',3.333,4),(67,7415472,7415462,'430',3.333,4),(67,7415473,7415462,'307',3.333,4),(67,7415474,7415462,'075',3.333,4),(67,7415475,7415462,'753',3.333,4),(67,7415476,7415462,'535',3.333,4),(67,7415477,7415462,'357',3.333,4),(67,7415478,7415462,'573',3.333,4),(67,7415479,7415462,'732',3.333,4),(67,7415480,7415462,'32b',3.333,4),(67,7415481,7415462,'2b3',3.333,4),(67,7415482,7415462,'b33',3.333,4),(67,7415483,7415462,'334',3.333,4),(67,7415484,7415462,'345',3.333,4),(67,7415485,7415462,'457',3.333,4),(67,7415486,7415462,'571',3.333,4),(67,7415487,7415462,'715',3.333,4),(67,7415488,7415462,'153',3.333,4),(67,7415489,7415462,'533',3.333,4),(67,7415490,7415462,'335',3.333,4),(67,7415491,7415462,'356',3.333,4),(67,7415492,7415462,'564',3.333,4),(67,7415493,7415463,'ser',25,1),(67,7415494,7415463,'eri',25,1),(67,7415495,7415463,'ria',25,1),(67,7415496,7415463,'ial',25,1),(67,7415497,7415493,'siz',50,1),(67,7415498,7415493,'ize',50,1),(67,7415499,7415497,'460',33.333,1),(67,7415500,7415497,'608',33.333,1),(67,7415501,7415497,'080',33.333,1),(67,7415502,7415499,'dev',25,1),(67,7415503,7415499,'evi',25,1),(67,7415504,7415499,'vic',25,1),(67,7415505,7415499,'ice',25,1),(67,7415506,7415502,'typ',50,1),(67,7415507,7415502,'ype',50,1),(67,7415508,7415506,'dir',10,1),(67,7415509,7415506,'ire',10,1),(67,7415510,7415506,'rec',10,1),(67,7415511,7415506,'ect',10,1),(67,7415512,7415506,'cta',10,1),(67,7415513,7415506,'tac',10,1),(67,7415514,7415506,'acc',10,1),(67,7415515,7415506,'cce',10,1),(67,7415516,7415506,'ces',10,1),(67,7415517,7415506,'ess',10,1),(67,7415518,7415508,'mul',14.286,1),(67,7415519,7415508,'ult',14.286,1),(67,7415520,7415508,'lti',14.286,1),(67,7415521,7415508,'tip',14.286,1),(67,7415522,7415508,'ipa',14.286,1),(67,7415523,7415508,'pat',14.286,1),(67,7415524,7415508,'ath',14.286,1),(67,7415525,7415518,'plu',25,1),(67,7415526,7415518,'lug',25,1),(67,7415527,7415518,'ugi',25,1),(67,7415528,7415518,'gin',25,1),(67,7415529,7415525,'nmp',100,1),(67,7415530,7415529,'dev',33.333,1),(67,7415531,7415529,'evf',33.333,1),(67,7415532,7415529,'vfs',33.333,1),(67,7415533,7415530,'pat',50,1),(67,7415534,7415530,'ath',50,1),(67,7415535,7415533,'vmf',50,1),(67,7415536,7415533,'mfs',50,1),(67,7415537,7415535,'dev',20,1),(67,7415538,7415535,'evi',20,1),(67,7415539,7415535,'vic',20,1),(67,7415540,7415535,'ice',20,1),(67,7415541,7415535,'ces',20,1),(67,7415542,7415537,'dis',33.333,1),(67,7415543,7415537,'isk',33.333,1),(67,7415544,7415537,'sks',33.333,1),(67,7415545,7415542,'ven',25,1),(67,7415546,7415542,'end',25,1),(67,7415547,7415542,'ndo',25,1),(67,7415548,7415542,'dor',25,1),(67,7415549,7415545,'mod',33.333,1),(67,7415550,7415545,'ode',33.333,1),(67,7415551,7415545,'del',33.333,1),(67,7415552,7415549,'lun',100,1),(67,7415553,7415552,'cmo',33.333,1),(67,7415554,7415552,'mod',33.333,1),(67,7415555,7415552,'ode',33.333,1),(67,7415556,7415553,'rev',16.667,1),(67,7415557,7415553,'evi',16.667,1),(67,7415558,7415553,'vis',16.667,1),(67,7415559,7415553,'isi',16.667,1),(67,7415560,7415553,'sio',16.667,1),(67,7415561,7415553,'ion',16.667,1),(67,7415562,7415556,'810',50,1),(67,7415563,7415556,'100',50,1),(67,7415564,7415562,'scs',50,1),(67,7415565,7415562,'csi',50,1),(67,7415566,7415564,'lev',33.333,1),(67,7415567,7415564,'eve',33.333,1),(67,7415568,7415564,'vel',33.333,1),(67,7415569,7415566,'pse',25,1),(67,7415570,7415566,'seu',25,1),(67,7415571,7415566,'eud',25,1),(67,7415572,7415566,'udo',25,1),(67,7415573,7415569,'fal',33.333,6),(67,7415574,7415569,'als',33.333,6),(67,7415575,7415569,'lse',33.333,6),(67,7415576,7415573,'sta',25,3),(67,7415577,7415573,'tat',25,3),(67,7415578,7415573,'atu',25,3),(67,7415579,7415573,'tus',25,3),(67,7415580,7415576,'rdm',100,1),(67,7415581,7415580,'cap',20,1),(67,7415582,7415580,'apa',20,1),(67,7415583,7415580,'pab',20,1),(67,7415584,7415580,'abl',20,1),(67,7415585,7415580,'ble',20,1),(67,7415586,7415581,'tru',50,1),(67,7415587,7415581,'rue',50,1),(67,7415588,7415586,'loc',33.333,1),(67,7415589,7415586,'oca',33.333,1),(67,7415590,7415586,'cal',33.333,1),(67,7415591,7415588,'rem',14.286,1),(67,7415592,7415588,'emo',14.286,1),(67,7415593,7415588,'mov',14.286,1),(67,7415594,7415588,'ova',14.286,1),(67,7415595,7415588,'vab',14.286,1),(67,7415596,7415588,'abl',14.286,1),(67,7415597,7415588,'ble',14.286,1),(67,7415598,7415591,'ssd',100,1),(67,7415599,7415598,'off',20,1),(67,7415600,7415598,'ffl',20,1),(67,7415601,7415598,'fli',20,1),(67,7415602,7415598,'lin',20,1),(67,7415603,7415598,'ine',20,1),(67,7415604,7415599,'per',11.111,1),(67,7415605,7415599,'ere',11.111,1),(67,7415606,7415599,'ren',11.111,1),(67,7415607,7415599,'enn',11.111,1),(67,7415608,7415599,'nni',11.111,1),(67,7415609,7415599,'nia',11.111,1),(67,7415610,7415599,'ial',11.111,1),(67,7415611,7415599,'all',11.111,1),(67,7415612,7415599,'lly',11.111,1),(67,7415613,7415604,'res',16.667,1),(67,7415614,7415604,'ese',16.667,1),(67,7415615,7415604,'ser',16.667,1),(67,7415616,7415604,'erv',16.667,1),(67,7415617,7415604,'rve',16.667,1),(67,7415618,7415604,'ved',16.667,1),(67,7415619,7415613,'thi',50,1),(67,7415620,7415613,'hin',50,1),(67,7415621,7415619,'pro',10,1),(67,7415622,7415619,'rov',10,1),(67,7415623,7415619,'ovi',10,1),(67,7415624,7415619,'vis',10,1),(67,7415625,7415619,'isi',10,1),(67,7415626,7415619,'sio',10,1),(67,7415627,7415619,'ion',10,1),(67,7415628,7415619,'oni',10,1),(67,7415629,7415619,'nin',10,1),(67,7415630,7415619,'ing',10,1),(67,7415631,7415621,'yes',100,1),(67,7415632,7415631,'att',16.667,1),(67,7415633,7415631,'tta',16.667,1),(67,7415634,7415631,'tac',16.667,1),(67,7415635,7415631,'ach',16.667,1),(67,7415636,7415631,'che',16.667,1),(67,7415637,7415631,'hed',16.667,1),(67,7415638,7415632,'fil',20,1),(67,7415639,7415632,'ilt',20,1),(67,7415640,7415632,'lte',20,1),(67,7415641,7415632,'ter',20,1),(67,7415642,7415632,'ers',20,1),(67,7415643,7415638,'vaa',50,1),(67,7415644,7415638,'aai',50,1),(67,7415645,7415643,'unk',20,1),(67,7415646,7415643,'nkn',20,1),(67,7415647,7415643,'kno',20,1),(67,7415648,7415643,'now',20,1),(67,7415649,7415643,'own',20,1),(67,7415650,7415645,'oth',33.333,1),(67,7415651,7415645,'the',33.333,1),(67,7415652,7415645,'her',33.333,1),(67,7415653,7415650,'uid',50,1),(67,7415654,7415650,'ids',50,1),(67,7415655,7415653,'vml',100,1),(67,7415656,7415655,'dis',20,1),(67,7415657,7415655,'isp',20,1),(67,7415658,7415655,'spl',20,1),(67,7415659,7415655,'pla',20,1),(67,7415660,7415655,'lay',20,1),(67,7415661,7415656,'nam',50,1),(67,7415662,7415656,'ame',50,1),(68,7415664,7415663,'net',25,3),(68,7415665,7415663,'eta',25,3),(68,7415666,7415663,'tap',25,3),(68,7415667,7415663,'app',25,3),(68,7415668,7415664,'fib',33.333,2),(68,7415669,7415664,'ibr',33.333,2),(68,7415670,7415664,'bre',33.333,2),(68,7415671,7415668,'cha',20,2),(68,7415672,7415668,'han',20,2),(68,7415673,7415668,'ann',20,2),(68,7415674,7415668,'nne',20,2),(68,7415675,7415668,'nel',20,2),(68,7415676,7415671,'dis',50,2),(68,7415677,7415671,'isk',50,2),(68,7415678,7415676,'naa',100,4),(68,7415679,7415678,'600',3.333,4),(68,7415680,7415678,'00a',3.333,4),(68,7415681,7415678,'0a0',3.333,4),(68,7415682,7415678,'a09',3.333,4),(68,7415683,7415678,'098',3.333,4),(68,7415684,7415678,'980',3.333,4),(68,7415685,7415678,'804',3.333,4),(68,7415686,7415678,'044',3.333,4),(68,7415687,7415678,'443',3.333,4),(68,7415688,7415678,'430',3.333,4),(68,7415689,7415678,'307',3.333,4),(68,7415690,7415678,'075',3.333,4),(68,7415691,7415678,'753',3.333,4),(68,7415692,7415678,'535',3.333,4),(68,7415693,7415678,'357',3.333,4),(68,7415694,7415678,'573',3.333,4),(68,7415695,7415678,'732',3.333,4),(68,7415696,7415678,'32b',3.333,4),(68,7415697,7415678,'2b3',3.333,4),(68,7415698,7415678,'b33',3.333,4),(68,7415699,7415678,'334',3.333,4),(68,7415700,7415678,'345',3.333,4),(68,7415701,7415678,'457',3.333,4),(68,7415702,7415678,'571',3.333,4),(68,7415703,7415678,'715',3.333,4),(68,7415704,7415678,'153',3.333,4),(68,7415705,7415678,'533',3.333,4),(68,7415706,7415678,'336',3.333,4),(68,7415707,7415678,'364',3.333,4),(68,7415708,7415678,'641',3.333,4),(68,7415709,7415679,'ser',25,1),(68,7415710,7415679,'eri',25,1),(68,7415711,7415679,'ria',25,1),(68,7415712,7415679,'ial',25,1),(68,7415713,7415709,'siz',50,1),(68,7415714,7415709,'ize',50,1),(68,7415715,7415713,'321',100,1),(68,7415716,7415715,'dev',25,1),(68,7415717,7415715,'evi',25,1),(68,7415718,7415715,'vic',25,1),(68,7415719,7415715,'ice',25,1),(68,7415720,7415716,'typ',50,1),(68,7415721,7415716,'ype',50,1),(68,7415722,7415720,'dir',10,1),(68,7415723,7415720,'ire',10,1),(68,7415724,7415720,'rec',10,1),(68,7415725,7415720,'ect',10,1),(68,7415726,7415720,'cta',10,1),(68,7415727,7415720,'tac',10,1),(68,7415728,7415720,'acc',10,1),(68,7415729,7415720,'cce',10,1),(68,7415730,7415720,'ces',10,1),(68,7415731,7415720,'ess',10,1),(68,7415732,7415722,'mul',14.286,1),(68,7415733,7415722,'ult',14.286,1),(68,7415734,7415722,'lti',14.286,1),(68,7415735,7415722,'tip',14.286,1),(68,7415736,7415722,'ipa',14.286,1),(68,7415737,7415722,'pat',14.286,1),(68,7415738,7415722,'ath',14.286,1),(68,7415739,7415732,'plu',25,1),(68,7415740,7415732,'lug',25,1),(68,7415741,7415732,'ugi',25,1),(68,7415742,7415732,'gin',25,1),(68,7415743,7415739,'nmp',100,1),(68,7415744,7415743,'dev',33.333,1),(68,7415745,7415743,'evf',33.333,1),(68,7415746,7415743,'vfs',33.333,1),(68,7415747,7415744,'pat',50,1),(68,7415748,7415744,'ath',50,1),(68,7415749,7415747,'vmf',50,1),(68,7415750,7415747,'mfs',50,1),(68,7415751,7415749,'dev',20,1),(68,7415752,7415749,'evi',20,1),(68,7415753,7415749,'vic',20,1),(68,7415754,7415749,'ice',20,1),(68,7415755,7415749,'ces',20,1),(68,7415756,7415751,'dis',33.333,1),(68,7415757,7415751,'isk',33.333,1),(68,7415758,7415751,'sks',33.333,1),(68,7415759,7415756,'ven',25,1),(68,7415760,7415756,'end',25,1),(68,7415761,7415756,'ndo',25,1),(68,7415762,7415756,'dor',25,1),(68,7415763,7415759,'mod',33.333,1),(68,7415764,7415759,'ode',33.333,1),(68,7415765,7415759,'del',33.333,1),(68,7415766,7415763,'lun',100,1),(68,7415767,7415766,'cmo',33.333,1),(68,7415768,7415766,'mod',33.333,1),(68,7415769,7415766,'ode',33.333,1),(68,7415770,7415767,'rev',16.667,1),(68,7415771,7415767,'evi',16.667,1),(68,7415772,7415767,'vis',16.667,1),(68,7415773,7415767,'isi',16.667,1),(68,7415774,7415767,'sio',16.667,1),(68,7415775,7415767,'ion',16.667,1),(68,7415776,7415770,'810',50,1),(68,7415777,7415770,'100',50,1),(68,7415778,7415776,'scs',50,1),(68,7415779,7415776,'csi',50,1),(68,7415780,7415778,'lev',33.333,1),(68,7415781,7415778,'eve',33.333,1),(68,7415782,7415778,'vel',33.333,1),(68,7415783,7415780,'pse',25,1),(68,7415784,7415780,'seu',25,1),(68,7415785,7415780,'eud',25,1),(68,7415786,7415780,'udo',25,1),(68,7415787,7415783,'fal',33.333,6),(68,7415788,7415783,'als',33.333,6),(68,7415789,7415783,'lse',33.333,6),(68,7415790,7415787,'sta',25,3),(68,7415791,7415787,'tat',25,3),(68,7415792,7415787,'atu',25,3),(68,7415793,7415787,'tus',25,3),(68,7415794,7415790,'rdm',100,1),(68,7415795,7415794,'cap',20,1),(68,7415796,7415794,'apa',20,1),(68,7415797,7415794,'pab',20,1),(68,7415798,7415794,'abl',20,1),(68,7415799,7415794,'ble',20,1),(68,7415800,7415795,'tru',50,1),(68,7415801,7415795,'rue',50,1),(68,7415802,7415800,'loc',33.333,1),(68,7415803,7415800,'oca',33.333,1),(68,7415804,7415800,'cal',33.333,1),(68,7415805,7415802,'rem',14.286,1),(68,7415806,7415802,'emo',14.286,1),(68,7415807,7415802,'mov',14.286,1),(68,7415808,7415802,'ova',14.286,1),(68,7415809,7415802,'vab',14.286,1),(68,7415810,7415802,'abl',14.286,1),(68,7415811,7415802,'ble',14.286,1),(68,7415812,7415805,'ssd',100,1),(68,7415813,7415812,'off',20,1),(68,7415814,7415812,'ffl',20,1),(68,7415815,7415812,'fli',20,1),(68,7415816,7415812,'lin',20,1),(68,7415817,7415812,'ine',20,1),(68,7415818,7415813,'per',11.111,1),(68,7415819,7415813,'ere',11.111,1),(68,7415820,7415813,'ren',11.111,1),(68,7415821,7415813,'enn',11.111,1),(68,7415822,7415813,'nni',11.111,1),(68,7415823,7415813,'nia',11.111,1),(68,7415824,7415813,'ial',11.111,1),(68,7415825,7415813,'all',11.111,1),(68,7415826,7415813,'lly',11.111,1),(68,7415827,7415818,'res',16.667,1),(68,7415828,7415818,'ese',16.667,1),(68,7415829,7415818,'ser',16.667,1),(68,7415830,7415818,'erv',16.667,1),(68,7415831,7415818,'rve',16.667,1),(68,7415832,7415818,'ved',16.667,1),(68,7415833,7415827,'thi',50,1),(68,7415834,7415827,'hin',50,1),(68,7415835,7415833,'pro',10,1),(68,7415836,7415833,'rov',10,1),(68,7415837,7415833,'ovi',10,1),(68,7415838,7415833,'vis',10,1),(68,7415839,7415833,'isi',10,1),(68,7415840,7415833,'sio',10,1),(68,7415841,7415833,'ion',10,1),(68,7415842,7415833,'oni',10,1),(68,7415843,7415833,'nin',10,1),(68,7415844,7415833,'ing',10,1),(68,7415845,7415835,'yes',100,1),(68,7415846,7415845,'att',16.667,1),(68,7415847,7415845,'tta',16.667,1),(68,7415848,7415845,'tac',16.667,1),(68,7415849,7415845,'ach',16.667,1),(68,7415850,7415845,'che',16.667,1),(68,7415851,7415845,'hed',16.667,1),(68,7415852,7415846,'fil',20,1),(68,7415853,7415846,'ilt',20,1),(68,7415854,7415846,'lte',20,1),(68,7415855,7415846,'ter',20,1),(68,7415856,7415846,'ers',20,1),(68,7415857,7415852,'vaa',50,1),(68,7415858,7415852,'aai',50,1),(68,7415859,7415857,'unk',20,1),(68,7415860,7415857,'nkn',20,1),(68,7415861,7415857,'kno',20,1),(68,7415862,7415857,'now',20,1),(68,7415863,7415857,'own',20,1),(68,7415864,7415859,'oth',33.333,1),(68,7415865,7415859,'the',33.333,1),(68,7415866,7415859,'her',33.333,1),(68,7415867,7415864,'uid',50,1),(68,7415868,7415864,'ids',50,1),(68,7415869,7415867,'vml',100,1),(68,7415870,7415869,'dis',20,1),(68,7415871,7415869,'isp',20,1),(68,7415872,7415869,'spl',20,1),(68,7415873,7415869,'pla',20,1),(68,7415874,7415869,'lay',20,1),(68,7415875,7415870,'nam',50,1),(68,7415876,7415870,'ame',50,1),(69,7415878,7415877,'net',25,3),(69,7415879,7415877,'eta',25,3),(69,7415880,7415877,'tap',25,3),(69,7415881,7415877,'app',25,3),(69,7415882,7415878,'fib',33.333,2),(69,7415883,7415878,'ibr',33.333,2),(69,7415884,7415878,'bre',33.333,2),(69,7415885,7415882,'cha',20,2),(69,7415886,7415882,'han',20,2),(69,7415887,7415882,'ann',20,2),(69,7415888,7415882,'nne',20,2),(69,7415889,7415882,'nel',20,2),(69,7415890,7415885,'dis',50,2),(69,7415891,7415885,'isk',50,2),(69,7415892,7415890,'naa',100,4),(69,7415893,7415892,'600',3.333,4),(69,7415894,7415892,'00a',3.333,4),(69,7415895,7415892,'0a0',3.333,4),(69,7415896,7415892,'a09',3.333,4),(69,7415897,7415892,'098',3.333,4),(69,7415898,7415892,'980',3.333,4),(69,7415899,7415892,'804',3.333,4),(69,7415900,7415892,'044',3.333,4),(69,7415901,7415892,'443',3.333,4),(69,7415902,7415892,'430',3.333,4),(69,7415903,7415892,'307',3.333,4),(69,7415904,7415892,'075',3.333,4),(69,7415905,7415892,'753',3.333,4),(69,7415906,7415892,'535',3.333,4),(69,7415907,7415892,'357',3.333,4),(69,7415908,7415892,'573',3.333,4),(69,7415909,7415892,'732',3.333,4),(69,7415910,7415892,'32b',3.333,4),(69,7415911,7415892,'2b3',3.333,4),(69,7415912,7415892,'b33',3.333,4),(69,7415913,7415892,'334',3.333,4),(69,7415914,7415892,'345',3.333,4),(69,7415915,7415892,'457',3.333,4),(69,7415916,7415892,'571',3.333,4),(69,7415917,7415892,'715',3.333,4),(69,7415918,7415892,'153',3.333,4),(69,7415919,7415892,'533',3.333,4),(69,7415920,7415892,'335',3.333,4),(69,7415921,7415892,'356',3.333,4),(69,7415922,7415892,'565',3.333,4),(69,7415923,7415893,'ser',25,1),(69,7415924,7415893,'eri',25,1),(69,7415925,7415893,'ria',25,1),(69,7415926,7415893,'ial',25,1),(69,7415927,7415923,'siz',50,1),(69,7415928,7415923,'ize',50,1),(69,7415929,7415927,'460',33.333,1),(69,7415930,7415927,'608',33.333,1),(69,7415931,7415927,'080',33.333,1),(69,7415932,7415929,'dev',25,1),(69,7415933,7415929,'evi',25,1),(69,7415934,7415929,'vic',25,1),(69,7415935,7415929,'ice',25,1),(69,7415936,7415932,'typ',50,1),(69,7415937,7415932,'ype',50,1),(69,7415938,7415936,'dir',10,1),(69,7415939,7415936,'ire',10,1),(69,7415940,7415936,'rec',10,1),(69,7415941,7415936,'ect',10,1),(69,7415942,7415936,'cta',10,1),(69,7415943,7415936,'tac',10,1),(69,7415944,7415936,'acc',10,1),(69,7415945,7415936,'cce',10,1),(69,7415946,7415936,'ces',10,1),(69,7415947,7415936,'ess',10,1),(69,7415948,7415938,'mul',14.286,1),(69,7415949,7415938,'ult',14.286,1),(69,7415950,7415938,'lti',14.286,1),(69,7415951,7415938,'tip',14.286,1),(69,7415952,7415938,'ipa',14.286,1),(69,7415953,7415938,'pat',14.286,1),(69,7415954,7415938,'ath',14.286,1),(69,7415955,7415948,'plu',25,1),(69,7415956,7415948,'lug',25,1),(69,7415957,7415948,'ugi',25,1),(69,7415958,7415948,'gin',25,1),(69,7415959,7415955,'nmp',100,1),(69,7415960,7415959,'dev',33.333,1),(69,7415961,7415959,'evf',33.333,1),(69,7415962,7415959,'vfs',33.333,1),(69,7415963,7415960,'pat',50,1),(69,7415964,7415960,'ath',50,1),(69,7415965,7415963,'vmf',50,1),(69,7415966,7415963,'mfs',50,1),(69,7415967,7415965,'dev',20,1),(69,7415968,7415965,'evi',20,1),(69,7415969,7415965,'vic',20,1),(69,7415970,7415965,'ice',20,1),(69,7415971,7415965,'ces',20,1),(69,7415972,7415967,'dis',33.333,1),(69,7415973,7415967,'isk',33.333,1),(69,7415974,7415967,'sks',33.333,1),(69,7415975,7415972,'ven',25,1),(69,7415976,7415972,'end',25,1),(69,7415977,7415972,'ndo',25,1),(69,7415978,7415972,'dor',25,1),(69,7415979,7415975,'mod',33.333,1),(69,7415980,7415975,'ode',33.333,1),(69,7415981,7415975,'del',33.333,1),(69,7415982,7415979,'lun',100,1),(69,7415983,7415982,'cmo',33.333,1),(69,7415984,7415982,'mod',33.333,1),(69,7415985,7415982,'ode',33.333,1),(69,7415986,7415983,'rev',16.667,1),(69,7415987,7415983,'evi',16.667,1),(69,7415988,7415983,'vis',16.667,1),(69,7415989,7415983,'isi',16.667,1),(69,7415990,7415983,'sio',16.667,1),(69,7415991,7415983,'ion',16.667,1),(69,7415992,7415986,'810',50,1),(69,7415993,7415986,'100',50,1),(69,7415994,7415992,'scs',50,1),(69,7415995,7415992,'csi',50,1),(69,7415996,7415994,'lev',33.333,1),(69,7415997,7415994,'eve',33.333,1),(69,7415998,7415994,'vel',33.333,1),(69,7415999,7415996,'pse',25,1),(69,7416000,7415996,'seu',25,1),(69,7416001,7415996,'eud',25,1),(69,7416002,7415996,'udo',25,1),(69,7416003,7415999,'fal',33.333,6),(69,7416004,7415999,'als',33.333,6),(69,7416005,7415999,'lse',33.333,6),(69,7416006,7416003,'sta',25,3),(69,7416007,7416003,'tat',25,3),(69,7416008,7416003,'atu',25,3),(69,7416009,7416003,'tus',25,3),(69,7416010,7416006,'rdm',100,1),(69,7416011,7416010,'cap',20,1),(69,7416012,7416010,'apa',20,1),(69,7416013,7416010,'pab',20,1),(69,7416014,7416010,'abl',20,1),(69,7416015,7416010,'ble',20,1),(69,7416016,7416011,'tru',50,1),(69,7416017,7416011,'rue',50,1),(69,7416018,7416016,'loc',33.333,1),(69,7416019,7416016,'oca',33.333,1),(69,7416020,7416016,'cal',33.333,1),(69,7416021,7416018,'rem',14.286,1),(69,7416022,7416018,'emo',14.286,1),(69,7416023,7416018,'mov',14.286,1),(69,7416024,7416018,'ova',14.286,1),(69,7416025,7416018,'vab',14.286,1),(69,7416026,7416018,'abl',14.286,1),(69,7416027,7416018,'ble',14.286,1),(69,7416028,7416021,'ssd',100,1),(69,7416029,7416028,'off',20,1),(69,7416030,7416028,'ffl',20,1),(69,7416031,7416028,'fli',20,1),(69,7416032,7416028,'lin',20,1),(69,7416033,7416028,'ine',20,1),(69,7416034,7416029,'per',11.111,1),(69,7416035,7416029,'ere',11.111,1),(69,7416036,7416029,'ren',11.111,1),(69,7416037,7416029,'enn',11.111,1),(69,7416038,7416029,'nni',11.111,1),(69,7416039,7416029,'nia',11.111,1),(69,7416040,7416029,'ial',11.111,1),(69,7416041,7416029,'all',11.111,1),(69,7416042,7416029,'lly',11.111,1),(69,7416043,7416034,'res',16.667,1),(69,7416044,7416034,'ese',16.667,1),(69,7416045,7416034,'ser',16.667,1),(69,7416046,7416034,'erv',16.667,1),(69,7416047,7416034,'rve',16.667,1),(69,7416048,7416034,'ved',16.667,1),(69,7416049,7416043,'thi',50,1),(69,7416050,7416043,'hin',50,1),(69,7416051,7416049,'pro',10,1),(69,7416052,7416049,'rov',10,1),(69,7416053,7416049,'ovi',10,1),(69,7416054,7416049,'vis',10,1),(69,7416055,7416049,'isi',10,1),(69,7416056,7416049,'sio',10,1),(69,7416057,7416049,'ion',10,1),(69,7416058,7416049,'oni',10,1),(69,7416059,7416049,'nin',10,1),(69,7416060,7416049,'ing',10,1),(69,7416061,7416051,'yes',100,1),(69,7416062,7416061,'att',16.667,1),(69,7416063,7416061,'tta',16.667,1),(69,7416064,7416061,'tac',16.667,1),(69,7416065,7416061,'ach',16.667,1),(69,7416066,7416061,'che',16.667,1),(69,7416067,7416061,'hed',16.667,1),(69,7416068,7416062,'fil',20,1),(69,7416069,7416062,'ilt',20,1),(69,7416070,7416062,'lte',20,1),(69,7416071,7416062,'ter',20,1),(69,7416072,7416062,'ers',20,1),(69,7416073,7416068,'vaa',50,1),(69,7416074,7416068,'aai',50,1),(69,7416075,7416073,'unk',20,1),(69,7416076,7416073,'nkn',20,1),(69,7416077,7416073,'kno',20,1),(69,7416078,7416073,'now',20,1),(69,7416079,7416073,'own',20,1),(69,7416080,7416075,'oth',33.333,1),(69,7416081,7416075,'the',33.333,1),(69,7416082,7416075,'her',33.333,1),(69,7416083,7416080,'uid',50,1),(69,7416084,7416080,'ids',50,1),(69,7416085,7416083,'vml',100,1),(69,7416086,7416085,'dis',20,1),(69,7416087,7416085,'isp',20,1),(69,7416088,7416085,'spl',20,1),(69,7416089,7416085,'pla',20,1),(69,7416090,7416085,'lay',20,1),(69,7416091,7416086,'nam',50,1),(69,7416092,7416086,'ame',50,1),(70,7416094,7416093,'net',25,3),(70,7416095,7416093,'eta',25,3),(70,7416096,7416093,'tap',25,3),(70,7416097,7416093,'app',25,3),(70,7416098,7416094,'fib',33.333,2),(70,7416099,7416094,'ibr',33.333,2),(70,7416100,7416094,'bre',33.333,2),(70,7416101,7416098,'cha',20,2),(70,7416102,7416098,'han',20,2),(70,7416103,7416098,'ann',20,2),(70,7416104,7416098,'nne',20,2),(70,7416105,7416098,'nel',20,2),(70,7416106,7416101,'dis',50,2),(70,7416107,7416101,'isk',50,2),(70,7416108,7416106,'naa',100,4),(70,7416109,7416108,'600',3.333,4),(70,7416110,7416108,'00a',3.333,4),(70,7416111,7416108,'0a0',3.333,4),(70,7416112,7416108,'a09',3.333,4),(70,7416113,7416108,'098',3.333,4),(70,7416114,7416108,'980',3.333,4),(70,7416115,7416108,'804',3.333,4),(70,7416116,7416108,'044',3.333,4),(70,7416117,7416108,'443',3.333,4),(70,7416118,7416108,'430',3.333,4),(70,7416119,7416108,'307',3.333,4),(70,7416120,7416108,'075',3.333,4),(70,7416121,7416108,'753',3.333,4),(70,7416122,7416108,'535',3.333,4),(70,7416123,7416108,'357',3.333,4),(70,7416124,7416108,'573',3.333,4),(70,7416125,7416108,'732',3.333,4),(70,7416126,7416108,'32b',3.333,4),(70,7416127,7416108,'2b3',3.333,4),(70,7416128,7416108,'b33',3.333,4),(70,7416129,7416108,'334',3.333,4),(70,7416130,7416108,'345',3.333,4),(70,7416131,7416108,'457',3.333,4),(70,7416132,7416108,'571',3.333,4),(70,7416133,7416108,'715',3.333,4),(70,7416134,7416108,'153',3.333,4),(70,7416135,7416108,'533',3.333,4),(70,7416136,7416108,'336',3.333,4),(70,7416137,7416108,'364',3.333,4),(70,7416138,7416108,'642',3.333,4),(70,7416139,7416109,'ser',25,1),(70,7416140,7416109,'eri',25,1),(70,7416141,7416109,'ria',25,1),(70,7416142,7416109,'ial',25,1),(70,7416143,7416139,'siz',50,1),(70,7416144,7416139,'ize',50,1),(70,7416145,7416143,'321',100,1),(70,7416146,7416145,'dev',25,1),(70,7416147,7416145,'evi',25,1),(70,7416148,7416145,'vic',25,1),(70,7416149,7416145,'ice',25,1),(70,7416150,7416146,'typ',50,1),(70,7416151,7416146,'ype',50,1),(70,7416152,7416150,'dir',10,1),(70,7416153,7416150,'ire',10,1),(70,7416154,7416150,'rec',10,1),(70,7416155,7416150,'ect',10,1),(70,7416156,7416150,'cta',10,1),(70,7416157,7416150,'tac',10,1),(70,7416158,7416150,'acc',10,1),(70,7416159,7416150,'cce',10,1),(70,7416160,7416150,'ces',10,1),(70,7416161,7416150,'ess',10,1),(70,7416162,7416152,'mul',14.286,1),(70,7416163,7416152,'ult',14.286,1),(70,7416164,7416152,'lti',14.286,1),(70,7416165,7416152,'tip',14.286,1),(70,7416166,7416152,'ipa',14.286,1),(70,7416167,7416152,'pat',14.286,1),(70,7416168,7416152,'ath',14.286,1),(70,7416169,7416162,'plu',25,1),(70,7416170,7416162,'lug',25,1),(70,7416171,7416162,'ugi',25,1),(70,7416172,7416162,'gin',25,1),(70,7416173,7416169,'nmp',100,1),(70,7416174,7416173,'dev',33.333,1),(70,7416175,7416173,'evf',33.333,1),(70,7416176,7416173,'vfs',33.333,1),(70,7416177,7416174,'pat',50,1),(70,7416178,7416174,'ath',50,1),(70,7416179,7416177,'vmf',50,1),(70,7416180,7416177,'mfs',50,1),(70,7416181,7416179,'dev',20,1),(70,7416182,7416179,'evi',20,1),(70,7416183,7416179,'vic',20,1),(70,7416184,7416179,'ice',20,1),(70,7416185,7416179,'ces',20,1),(70,7416186,7416181,'dis',33.333,1),(70,7416187,7416181,'isk',33.333,1),(70,7416188,7416181,'sks',33.333,1),(70,7416189,7416186,'ven',25,1),(70,7416190,7416186,'end',25,1),(70,7416191,7416186,'ndo',25,1),(70,7416192,7416186,'dor',25,1),(70,7416193,7416189,'mod',33.333,1),(70,7416194,7416189,'ode',33.333,1),(70,7416195,7416189,'del',33.333,1),(70,7416196,7416193,'lun',100,1),(70,7416197,7416196,'cmo',33.333,1),(70,7416198,7416196,'mod',33.333,1),(70,7416199,7416196,'ode',33.333,1),(70,7416200,7416197,'rev',16.667,1),(70,7416201,7416197,'evi',16.667,1),(70,7416202,7416197,'vis',16.667,1),(70,7416203,7416197,'isi',16.667,1),(70,7416204,7416197,'sio',16.667,1),(70,7416205,7416197,'ion',16.667,1),(70,7416206,7416200,'810',50,1),(70,7416207,7416200,'100',50,1),(70,7416208,7416206,'scs',50,1),(70,7416209,7416206,'csi',50,1),(70,7416210,7416208,'lev',33.333,1),(70,7416211,7416208,'eve',33.333,1),(70,7416212,7416208,'vel',33.333,1),(70,7416213,7416210,'pse',25,1),(70,7416214,7416210,'seu',25,1),(70,7416215,7416210,'eud',25,1),(70,7416216,7416210,'udo',25,1),(70,7416217,7416213,'fal',33.333,6),(70,7416218,7416213,'als',33.333,6),(70,7416219,7416213,'lse',33.333,6),(70,7416220,7416217,'sta',25,3),(70,7416221,7416217,'tat',25,3),(70,7416222,7416217,'atu',25,3),(70,7416223,7416217,'tus',25,3),(70,7416224,7416220,'rdm',100,1),(70,7416225,7416224,'cap',20,1),(70,7416226,7416224,'apa',20,1),(70,7416227,7416224,'pab',20,1),(70,7416228,7416224,'abl',20,1),(70,7416229,7416224,'ble',20,1),(70,7416230,7416225,'tru',50,1),(70,7416231,7416225,'rue',50,1),(70,7416232,7416230,'loc',33.333,1),(70,7416233,7416230,'oca',33.333,1),(70,7416234,7416230,'cal',33.333,1),(70,7416235,7416232,'rem',14.286,1),(70,7416236,7416232,'emo',14.286,1),(70,7416237,7416232,'mov',14.286,1),(70,7416238,7416232,'ova',14.286,1),(70,7416239,7416232,'vab',14.286,1),(70,7416240,7416232,'abl',14.286,1),(70,7416241,7416232,'ble',14.286,1),(70,7416242,7416235,'ssd',100,1),(70,7416243,7416242,'off',20,1),(70,7416244,7416242,'ffl',20,1),(70,7416245,7416242,'fli',20,1),(70,7416246,7416242,'lin',20,1),(70,7416247,7416242,'ine',20,1),(70,7416248,7416243,'per',11.111,1),(70,7416249,7416243,'ere',11.111,1),(70,7416250,7416243,'ren',11.111,1),(70,7416251,7416243,'enn',11.111,1),(70,7416252,7416243,'nni',11.111,1),(70,7416253,7416243,'nia',11.111,1),(70,7416254,7416243,'ial',11.111,1),(70,7416255,7416243,'all',11.111,1),(70,7416256,7416243,'lly',11.111,1),(70,7416257,7416248,'res',16.667,1),(70,7416258,7416248,'ese',16.667,1),(70,7416259,7416248,'ser',16.667,1),(70,7416260,7416248,'erv',16.667,1),(70,7416261,7416248,'rve',16.667,1),(70,7416262,7416248,'ved',16.667,1),(70,7416263,7416257,'thi',50,1),(70,7416264,7416257,'hin',50,1),(70,7416265,7416263,'pro',10,1),(70,7416266,7416263,'rov',10,1),(70,7416267,7416263,'ovi',10,1),(70,7416268,7416263,'vis',10,1),(70,7416269,7416263,'isi',10,1),(70,7416270,7416263,'sio',10,1),(70,7416271,7416263,'ion',10,1),(70,7416272,7416263,'oni',10,1),(70,7416273,7416263,'nin',10,1),(70,7416274,7416263,'ing',10,1),(70,7416275,7416265,'yes',100,1),(70,7416276,7416275,'att',16.667,1),(70,7416277,7416275,'tta',16.667,1),(70,7416278,7416275,'tac',16.667,1),(70,7416279,7416275,'ach',16.667,1),(70,7416280,7416275,'che',16.667,1),(70,7416281,7416275,'hed',16.667,1),(70,7416282,7416276,'fil',20,1),(70,7416283,7416276,'ilt',20,1),(70,7416284,7416276,'lte',20,1),(70,7416285,7416276,'ter',20,1),(70,7416286,7416276,'ers',20,1),(70,7416287,7416282,'vaa',50,1),(70,7416288,7416282,'aai',50,1),(70,7416289,7416287,'unk',20,1),(70,7416290,7416287,'nkn',20,1),(70,7416291,7416287,'kno',20,1),(70,7416292,7416287,'now',20,1),(70,7416293,7416287,'own',20,1),(70,7416294,7416289,'oth',33.333,1),(70,7416295,7416289,'the',33.333,1),(70,7416296,7416289,'her',33.333,1),(70,7416297,7416294,'uid',50,1),(70,7416298,7416294,'ids',50,1),(70,7416299,7416297,'vml',100,1),(70,7416300,7416299,'dis',20,1),(70,7416301,7416299,'isp',20,1),(70,7416302,7416299,'spl',20,1),(70,7416303,7416299,'pla',20,1),(70,7416304,7416299,'lay',20,1),(70,7416305,7416300,'nam',50,1),(70,7416306,7416300,'ame',50,1),(71,7416308,7416307,'net',25,3),(71,7416309,7416307,'eta',25,3),(71,7416310,7416307,'tap',25,3),(71,7416311,7416307,'app',25,3),(71,7416312,7416308,'fib',33.333,2),(71,7416313,7416308,'ibr',33.333,2),(71,7416314,7416308,'bre',33.333,2),(71,7416315,7416312,'cha',20,2),(71,7416316,7416312,'han',20,2),(71,7416317,7416312,'ann',20,2),(71,7416318,7416312,'nne',20,2),(71,7416319,7416312,'nel',20,2),(71,7416320,7416315,'dis',50,2),(71,7416321,7416315,'isk',50,2),(71,7416322,7416320,'naa',100,4),(71,7416323,7416322,'600',3.333,4),(71,7416324,7416322,'00a',3.333,4),(71,7416325,7416322,'0a0',3.333,4),(71,7416326,7416322,'a09',3.333,4),(71,7416327,7416322,'098',3.333,4),(71,7416328,7416322,'980',3.333,4),(71,7416329,7416322,'804',3.333,4),(71,7416330,7416322,'044',3.333,4),(71,7416331,7416322,'443',3.333,4),(71,7416332,7416322,'430',3.333,4),(71,7416333,7416322,'307',3.333,4),(71,7416334,7416322,'075',3.333,4),(71,7416335,7416322,'753',3.333,4),(71,7416336,7416322,'535',3.333,4),(71,7416337,7416322,'357',3.333,4),(71,7416338,7416322,'573',3.333,4),(71,7416339,7416322,'732',3.333,4),(71,7416340,7416322,'32b',3.333,4),(71,7416341,7416322,'2b3',3.333,4),(71,7416342,7416322,'b33',3.333,4),(71,7416343,7416322,'334',3.333,4),(71,7416344,7416322,'345',3.333,4),(71,7416345,7416322,'457',3.333,4),(71,7416346,7416322,'571',3.333,4),(71,7416347,7416322,'715',3.333,4),(71,7416348,7416322,'153',3.333,4),(71,7416349,7416322,'533',3.333,4),(71,7416350,7416322,'335',3.333,4),(71,7416351,7416322,'356',3.333,4),(71,7416352,7416322,'566',3.333,4),(71,7416353,7416323,'ser',25,1),(71,7416354,7416323,'eri',25,1),(71,7416355,7416323,'ria',25,1),(71,7416356,7416323,'ial',25,1),(71,7416357,7416353,'siz',50,1),(71,7416358,7416353,'ize',50,1),(71,7416359,7416357,'460',33.333,1),(71,7416360,7416357,'608',33.333,1),(71,7416361,7416357,'080',33.333,1),(71,7416362,7416359,'dev',25,1),(71,7416363,7416359,'evi',25,1),(71,7416364,7416359,'vic',25,1),(71,7416365,7416359,'ice',25,1),(71,7416366,7416362,'typ',50,1),(71,7416367,7416362,'ype',50,1),(71,7416368,7416366,'dir',10,1),(71,7416369,7416366,'ire',10,1),(71,7416370,7416366,'rec',10,1),(71,7416371,7416366,'ect',10,1),(71,7416372,7416366,'cta',10,1),(71,7416373,7416366,'tac',10,1),(71,7416374,7416366,'acc',10,1),(71,7416375,7416366,'cce',10,1),(71,7416376,7416366,'ces',10,1),(71,7416377,7416366,'ess',10,1),(71,7416378,7416368,'mul',14.286,1),(71,7416379,7416368,'ult',14.286,1),(71,7416380,7416368,'lti',14.286,1),(71,7416381,7416368,'tip',14.286,1),(71,7416382,7416368,'ipa',14.286,1),(71,7416383,7416368,'pat',14.286,1),(71,7416384,7416368,'ath',14.286,1),(71,7416385,7416378,'plu',25,1),(71,7416386,7416378,'lug',25,1),(71,7416387,7416378,'ugi',25,1),(71,7416388,7416378,'gin',25,1),(71,7416389,7416385,'nmp',100,1),(71,7416390,7416389,'dev',33.333,1),(71,7416391,7416389,'evf',33.333,1),(71,7416392,7416389,'vfs',33.333,1),(71,7416393,7416390,'pat',50,1),(71,7416394,7416390,'ath',50,1),(71,7416395,7416393,'vmf',50,1),(71,7416396,7416393,'mfs',50,1),(71,7416397,7416395,'dev',20,1),(71,7416398,7416395,'evi',20,1),(71,7416399,7416395,'vic',20,1),(71,7416400,7416395,'ice',20,1),(71,7416401,7416395,'ces',20,1),(71,7416402,7416397,'dis',33.333,1),(71,7416403,7416397,'isk',33.333,1),(71,7416404,7416397,'sks',33.333,1),(71,7416405,7416402,'ven',25,1),(71,7416406,7416402,'end',25,1),(71,7416407,7416402,'ndo',25,1),(71,7416408,7416402,'dor',25,1),(71,7416409,7416405,'mod',33.333,1),(71,7416410,7416405,'ode',33.333,1),(71,7416411,7416405,'del',33.333,1),(71,7416412,7416409,'lun',100,1),(71,7416413,7416412,'cmo',33.333,1),(71,7416414,7416412,'mod',33.333,1),(71,7416415,7416412,'ode',33.333,1),(71,7416416,7416413,'rev',16.667,1),(71,7416417,7416413,'evi',16.667,1),(71,7416418,7416413,'vis',16.667,1),(71,7416419,7416413,'isi',16.667,1),(71,7416420,7416413,'sio',16.667,1),(71,7416421,7416413,'ion',16.667,1),(71,7416422,7416416,'810',50,1),(71,7416423,7416416,'100',50,1),(71,7416424,7416422,'scs',50,1),(71,7416425,7416422,'csi',50,1),(71,7416426,7416424,'lev',33.333,1),(71,7416427,7416424,'eve',33.333,1),(71,7416428,7416424,'vel',33.333,1),(71,7416429,7416426,'pse',25,1),(71,7416430,7416426,'seu',25,1),(71,7416431,7416426,'eud',25,1),(71,7416432,7416426,'udo',25,1),(71,7416433,7416429,'fal',33.333,6),(71,7416434,7416429,'als',33.333,6),(71,7416435,7416429,'lse',33.333,6),(71,7416436,7416433,'sta',25,3),(71,7416437,7416433,'tat',25,3),(71,7416438,7416433,'atu',25,3),(71,7416439,7416433,'tus',25,3),(71,7416440,7416436,'rdm',100,1),(71,7416441,7416440,'cap',20,1),(71,7416442,7416440,'apa',20,1),(71,7416443,7416440,'pab',20,1),(71,7416444,7416440,'abl',20,1),(71,7416445,7416440,'ble',20,1),(71,7416446,7416441,'tru',50,1),(71,7416447,7416441,'rue',50,1),(71,7416448,7416446,'loc',33.333,1),(71,7416449,7416446,'oca',33.333,1),(71,7416450,7416446,'cal',33.333,1),(71,7416451,7416448,'rem',14.286,1),(71,7416452,7416448,'emo',14.286,1),(71,7416453,7416448,'mov',14.286,1),(71,7416454,7416448,'ova',14.286,1),(71,7416455,7416448,'vab',14.286,1),(71,7416456,7416448,'abl',14.286,1),(71,7416457,7416448,'ble',14.286,1),(71,7416458,7416451,'ssd',100,1),(71,7416459,7416458,'off',20,1),(71,7416460,7416458,'ffl',20,1),(71,7416461,7416458,'fli',20,1),(71,7416462,7416458,'lin',20,1),(71,7416463,7416458,'ine',20,1),(71,7416464,7416459,'per',11.111,1),(71,7416465,7416459,'ere',11.111,1),(71,7416466,7416459,'ren',11.111,1),(71,7416467,7416459,'enn',11.111,1),(71,7416468,7416459,'nni',11.111,1),(71,7416469,7416459,'nia',11.111,1),(71,7416470,7416459,'ial',11.111,1),(71,7416471,7416459,'all',11.111,1),(71,7416472,7416459,'lly',11.111,1),(71,7416473,7416464,'res',16.667,1),(71,7416474,7416464,'ese',16.667,1),(71,7416475,7416464,'ser',16.667,1),(71,7416476,7416464,'erv',16.667,1),(71,7416477,7416464,'rve',16.667,1),(71,7416478,7416464,'ved',16.667,1),(71,7416479,7416473,'thi',50,1),(71,7416480,7416473,'hin',50,1),(71,7416481,7416479,'pro',10,1),(71,7416482,7416479,'rov',10,1),(71,7416483,7416479,'ovi',10,1),(71,7416484,7416479,'vis',10,1),(71,7416485,7416479,'isi',10,1),(71,7416486,7416479,'sio',10,1),(71,7416487,7416479,'ion',10,1),(71,7416488,7416479,'oni',10,1),(71,7416489,7416479,'nin',10,1),(71,7416490,7416479,'ing',10,1),(71,7416491,7416481,'yes',100,1),(71,7416492,7416491,'att',16.667,1),(71,7416493,7416491,'tta',16.667,1),(71,7416494,7416491,'tac',16.667,1),(71,7416495,7416491,'ach',16.667,1),(71,7416496,7416491,'che',16.667,1),(71,7416497,7416491,'hed',16.667,1),(71,7416498,7416492,'fil',20,1),(71,7416499,7416492,'ilt',20,1),(71,7416500,7416492,'lte',20,1),(71,7416501,7416492,'ter',20,1),(71,7416502,7416492,'ers',20,1),(71,7416503,7416498,'vaa',50,1),(71,7416504,7416498,'aai',50,1),(71,7416505,7416503,'unk',20,1),(71,7416506,7416503,'nkn',20,1),(71,7416507,7416503,'kno',20,1),(71,7416508,7416503,'now',20,1),(71,7416509,7416503,'own',20,1),(71,7416510,7416505,'oth',33.333,1),(71,7416511,7416505,'the',33.333,1),(71,7416512,7416505,'her',33.333,1),(71,7416513,7416510,'uid',50,1),(71,7416514,7416510,'ids',50,1),(71,7416515,7416513,'vml',100,1),(71,7416516,7416515,'dis',20,1),(71,7416517,7416515,'isp',20,1),(71,7416518,7416515,'spl',20,1),(71,7416519,7416515,'pla',20,1),(71,7416520,7416515,'lay',20,1),(71,7416521,7416516,'nam',50,1),(71,7416522,7416516,'ame',50,1),(72,7416524,7416523,'net',25,3),(72,7416525,7416523,'eta',25,3),(72,7416526,7416523,'tap',25,3),(72,7416527,7416523,'app',25,3),(72,7416528,7416524,'fib',33.333,2),(72,7416529,7416524,'ibr',33.333,2),(72,7416530,7416524,'bre',33.333,2),(72,7416531,7416528,'cha',20,2),(72,7416532,7416528,'han',20,2),(72,7416533,7416528,'ann',20,2),(72,7416534,7416528,'nne',20,2),(72,7416535,7416528,'nel',20,2),(72,7416536,7416531,'dis',50,2),(72,7416537,7416531,'isk',50,2),(72,7416538,7416536,'naa',100,4),(72,7416539,7416538,'600',3.333,4),(72,7416540,7416538,'00a',3.333,4),(72,7416541,7416538,'0a0',3.333,4),(72,7416542,7416538,'a09',3.333,4),(72,7416543,7416538,'098',3.333,4),(72,7416544,7416538,'980',3.333,4),(72,7416545,7416538,'804',3.333,4),(72,7416546,7416538,'044',3.333,4),(72,7416547,7416538,'443',3.333,4),(72,7416548,7416538,'430',3.333,4),(72,7416549,7416538,'307',3.333,4),(72,7416550,7416538,'075',3.333,4),(72,7416551,7416538,'753',3.333,4),(72,7416552,7416538,'535',3.333,4),(72,7416553,7416538,'357',3.333,4),(72,7416554,7416538,'573',3.333,4),(72,7416555,7416538,'732',3.333,4),(72,7416556,7416538,'32b',3.333,4),(72,7416557,7416538,'2b3',3.333,4),(72,7416558,7416538,'b33',3.333,4),(72,7416559,7416538,'334',3.333,4),(72,7416560,7416538,'345',3.333,4),(72,7416561,7416538,'457',3.333,4),(72,7416562,7416538,'571',3.333,4),(72,7416563,7416538,'715',3.333,4),(72,7416564,7416538,'153',3.333,4),(72,7416565,7416538,'533',3.333,4),(72,7416566,7416538,'336',3.333,4),(72,7416567,7416538,'364',3.333,4),(72,7416568,7416538,'643',3.333,4),(72,7416569,7416539,'ser',25,1),(72,7416570,7416539,'eri',25,1),(72,7416571,7416539,'ria',25,1),(72,7416572,7416539,'ial',25,1),(72,7416573,7416569,'siz',50,1),(72,7416574,7416569,'ize',50,1),(72,7416575,7416573,'321',100,1),(72,7416576,7416575,'dev',25,1),(72,7416577,7416575,'evi',25,1),(72,7416578,7416575,'vic',25,1),(72,7416579,7416575,'ice',25,1),(72,7416580,7416576,'typ',50,1),(72,7416581,7416576,'ype',50,1),(72,7416582,7416580,'dir',10,1),(72,7416583,7416580,'ire',10,1),(72,7416584,7416580,'rec',10,1),(72,7416585,7416580,'ect',10,1),(72,7416586,7416580,'cta',10,1),(72,7416587,7416580,'tac',10,1),(72,7416588,7416580,'acc',10,1),(72,7416589,7416580,'cce',10,1),(72,7416590,7416580,'ces',10,1),(72,7416591,7416580,'ess',10,1),(72,7416592,7416582,'mul',14.286,1),(72,7416593,7416582,'ult',14.286,1),(72,7416594,7416582,'lti',14.286,1),(72,7416595,7416582,'tip',14.286,1),(72,7416596,7416582,'ipa',14.286,1),(72,7416597,7416582,'pat',14.286,1),(72,7416598,7416582,'ath',14.286,1),(72,7416599,7416592,'plu',25,1),(72,7416600,7416592,'lug',25,1),(72,7416601,7416592,'ugi',25,1),(72,7416602,7416592,'gin',25,1),(72,7416603,7416599,'nmp',100,1),(72,7416604,7416603,'dev',33.333,1),(72,7416605,7416603,'evf',33.333,1),(72,7416606,7416603,'vfs',33.333,1),(72,7416607,7416604,'pat',50,1),(72,7416608,7416604,'ath',50,1),(72,7416609,7416607,'vmf',50,1),(72,7416610,7416607,'mfs',50,1),(72,7416611,7416609,'dev',20,1),(72,7416612,7416609,'evi',20,1),(72,7416613,7416609,'vic',20,1),(72,7416614,7416609,'ice',20,1),(72,7416615,7416609,'ces',20,1),(72,7416616,7416611,'dis',33.333,1),(72,7416617,7416611,'isk',33.333,1),(72,7416618,7416611,'sks',33.333,1),(72,7416619,7416616,'ven',25,1),(72,7416620,7416616,'end',25,1),(72,7416621,7416616,'ndo',25,1),(72,7416622,7416616,'dor',25,1),(72,7416623,7416619,'mod',33.333,1),(72,7416624,7416619,'ode',33.333,1),(72,7416625,7416619,'del',33.333,1),(72,7416626,7416623,'lun',100,1),(72,7416627,7416626,'cmo',33.333,1),(72,7416628,7416626,'mod',33.333,1),(72,7416629,7416626,'ode',33.333,1),(72,7416630,7416627,'rev',16.667,1),(72,7416631,7416627,'evi',16.667,1),(72,7416632,7416627,'vis',16.667,1),(72,7416633,7416627,'isi',16.667,1),(72,7416634,7416627,'sio',16.667,1),(72,7416635,7416627,'ion',16.667,1),(72,7416636,7416630,'810',50,1),(72,7416637,7416630,'100',50,1),(72,7416638,7416636,'scs',50,1),(72,7416639,7416636,'csi',50,1),(72,7416640,7416638,'lev',33.333,1),(72,7416641,7416638,'eve',33.333,1),(72,7416642,7416638,'vel',33.333,1),(72,7416643,7416640,'pse',25,1),(72,7416644,7416640,'seu',25,1),(72,7416645,7416640,'eud',25,1),(72,7416646,7416640,'udo',25,1),(72,7416647,7416643,'fal',33.333,6),(72,7416648,7416643,'als',33.333,6),(72,7416649,7416643,'lse',33.333,6),(72,7416650,7416647,'sta',25,3),(72,7416651,7416647,'tat',25,3),(72,7416652,7416647,'atu',25,3),(72,7416653,7416647,'tus',25,3),(72,7416654,7416650,'rdm',100,1),(72,7416655,7416654,'cap',20,1),(72,7416656,7416654,'apa',20,1),(72,7416657,7416654,'pab',20,1),(72,7416658,7416654,'abl',20,1),(72,7416659,7416654,'ble',20,1),(72,7416660,7416655,'tru',50,1),(72,7416661,7416655,'rue',50,1),(72,7416662,7416660,'loc',33.333,1),(72,7416663,7416660,'oca',33.333,1),(72,7416664,7416660,'cal',33.333,1),(72,7416665,7416662,'rem',14.286,1),(72,7416666,7416662,'emo',14.286,1),(72,7416667,7416662,'mov',14.286,1),(72,7416668,7416662,'ova',14.286,1),(72,7416669,7416662,'vab',14.286,1),(72,7416670,7416662,'abl',14.286,1),(72,7416671,7416662,'ble',14.286,1),(72,7416672,7416665,'ssd',100,1),(72,7416673,7416672,'off',20,1),(72,7416674,7416672,'ffl',20,1),(72,7416675,7416672,'fli',20,1),(72,7416676,7416672,'lin',20,1),(72,7416677,7416672,'ine',20,1),(72,7416678,7416673,'per',11.111,1),(72,7416679,7416673,'ere',11.111,1),(72,7416680,7416673,'ren',11.111,1),(72,7416681,7416673,'enn',11.111,1),(72,7416682,7416673,'nni',11.111,1),(72,7416683,7416673,'nia',11.111,1),(72,7416684,7416673,'ial',11.111,1),(72,7416685,7416673,'all',11.111,1),(72,7416686,7416673,'lly',11.111,1),(72,7416687,7416678,'res',16.667,1),(72,7416688,7416678,'ese',16.667,1),(72,7416689,7416678,'ser',16.667,1),(72,7416690,7416678,'erv',16.667,1),(72,7416691,7416678,'rve',16.667,1),(72,7416692,7416678,'ved',16.667,1),(72,7416693,7416687,'thi',50,1),(72,7416694,7416687,'hin',50,1),(72,7416695,7416693,'pro',10,1),(72,7416696,7416693,'rov',10,1),(72,7416697,7416693,'ovi',10,1),(72,7416698,7416693,'vis',10,1),(72,7416699,7416693,'isi',10,1),(72,7416700,7416693,'sio',10,1),(72,7416701,7416693,'ion',10,1),(72,7416702,7416693,'oni',10,1),(72,7416703,7416693,'nin',10,1),(72,7416704,7416693,'ing',10,1),(72,7416705,7416695,'yes',100,1),(72,7416706,7416705,'att',16.667,1),(72,7416707,7416705,'tta',16.667,1),(72,7416708,7416705,'tac',16.667,1),(72,7416709,7416705,'ach',16.667,1),(72,7416710,7416705,'che',16.667,1),(72,7416711,7416705,'hed',16.667,1),(72,7416712,7416706,'fil',20,1),(72,7416713,7416706,'ilt',20,1),(72,7416714,7416706,'lte',20,1),(72,7416715,7416706,'ter',20,1),(72,7416716,7416706,'ers',20,1),(72,7416717,7416712,'vaa',50,1),(72,7416718,7416712,'aai',50,1),(72,7416719,7416717,'unk',20,1),(72,7416720,7416717,'nkn',20,1),(72,7416721,7416717,'kno',20,1),(72,7416722,7416717,'now',20,1),(72,7416723,7416717,'own',20,1),(72,7416724,7416719,'oth',33.333,1),(72,7416725,7416719,'the',33.333,1),(72,7416726,7416719,'her',33.333,1),(72,7416727,7416724,'uid',50,1),(72,7416728,7416724,'ids',50,1),(72,7416729,7416727,'vml',100,1),(72,7416730,7416729,'dis',20,1),(72,7416731,7416729,'isp',20,1),(72,7416732,7416729,'spl',20,1),(72,7416733,7416729,'pla',20,1),(72,7416734,7416729,'lay',20,1),(72,7416735,7416730,'nam',50,1),(72,7416736,7416730,'ame',50,1),(73,7416738,7416737,'net',25,3),(73,7416739,7416737,'eta',25,3),(73,7416740,7416737,'tap',25,3),(73,7416741,7416737,'app',25,3),(73,7416742,7416738,'fib',33.333,2),(73,7416743,7416738,'ibr',33.333,2),(73,7416744,7416738,'bre',33.333,2),(73,7416745,7416742,'cha',20,2),(73,7416746,7416742,'han',20,2),(73,7416747,7416742,'ann',20,2),(73,7416748,7416742,'nne',20,2),(73,7416749,7416742,'nel',20,2),(73,7416750,7416745,'dis',50,2),(73,7416751,7416745,'isk',50,2),(73,7416752,7416750,'naa',100,4),(73,7416753,7416752,'600',3.333,4),(73,7416754,7416752,'00a',3.333,4),(73,7416755,7416752,'0a0',3.333,4),(73,7416756,7416752,'a09',3.333,4),(73,7416757,7416752,'098',3.333,4),(73,7416758,7416752,'980',3.333,4),(73,7416759,7416752,'804',3.333,4),(73,7416760,7416752,'044',3.333,4),(73,7416761,7416752,'443',3.333,4),(73,7416762,7416752,'430',3.333,4),(73,7416763,7416752,'307',3.333,4),(73,7416764,7416752,'075',3.333,4),(73,7416765,7416752,'753',3.333,4),(73,7416766,7416752,'535',3.333,4),(73,7416767,7416752,'357',3.333,4),(73,7416768,7416752,'573',3.333,4),(73,7416769,7416752,'732',3.333,4),(73,7416770,7416752,'32b',3.333,4),(73,7416771,7416752,'2b3',3.333,4),(73,7416772,7416752,'b33',3.333,4),(73,7416773,7416752,'334',3.333,4),(73,7416774,7416752,'345',3.333,4),(73,7416775,7416752,'457',3.333,4),(73,7416776,7416752,'571',3.333,4),(73,7416777,7416752,'715',3.333,4),(73,7416778,7416752,'153',3.333,4),(73,7416779,7416752,'533',3.333,4),(73,7416780,7416752,'335',3.333,4),(73,7416781,7416752,'356',3.333,4),(73,7416782,7416752,'567',3.333,4),(73,7416783,7416753,'ser',25,1),(73,7416784,7416753,'eri',25,1),(73,7416785,7416753,'ria',25,1),(73,7416786,7416753,'ial',25,1),(73,7416787,7416783,'siz',50,1),(73,7416788,7416783,'ize',50,1),(73,7416789,7416787,'460',33.333,1),(73,7416790,7416787,'608',33.333,1),(73,7416791,7416787,'080',33.333,1),(73,7416792,7416789,'dev',25,1),(73,7416793,7416789,'evi',25,1),(73,7416794,7416789,'vic',25,1),(73,7416795,7416789,'ice',25,1),(73,7416796,7416792,'typ',50,1),(73,7416797,7416792,'ype',50,1),(73,7416798,7416796,'dir',10,1),(73,7416799,7416796,'ire',10,1),(73,7416800,7416796,'rec',10,1),(73,7416801,7416796,'ect',10,1),(73,7416802,7416796,'cta',10,1),(73,7416803,7416796,'tac',10,1),(73,7416804,7416796,'acc',10,1),(73,7416805,7416796,'cce',10,1),(73,7416806,7416796,'ces',10,1),(73,7416807,7416796,'ess',10,1),(73,7416808,7416798,'mul',14.286,1),(73,7416809,7416798,'ult',14.286,1),(73,7416810,7416798,'lti',14.286,1),(73,7416811,7416798,'tip',14.286,1),(73,7416812,7416798,'ipa',14.286,1),(73,7416813,7416798,'pat',14.286,1),(73,7416814,7416798,'ath',14.286,1),(73,7416815,7416808,'plu',25,1),(73,7416816,7416808,'lug',25,1),(73,7416817,7416808,'ugi',25,1),(73,7416818,7416808,'gin',25,1),(73,7416819,7416815,'nmp',100,1),(73,7416820,7416819,'dev',33.333,1),(73,7416821,7416819,'evf',33.333,1),(73,7416822,7416819,'vfs',33.333,1),(73,7416823,7416820,'pat',50,1),(73,7416824,7416820,'ath',50,1),(73,7416825,7416823,'vmf',50,1),(73,7416826,7416823,'mfs',50,1),(73,7416827,7416825,'dev',20,1),(73,7416828,7416825,'evi',20,1),(73,7416829,7416825,'vic',20,1),(73,7416830,7416825,'ice',20,1),(73,7416831,7416825,'ces',20,1),(73,7416832,7416827,'dis',33.333,1),(73,7416833,7416827,'isk',33.333,1),(73,7416834,7416827,'sks',33.333,1),(73,7416835,7416832,'ven',25,1),(73,7416836,7416832,'end',25,1),(73,7416837,7416832,'ndo',25,1),(73,7416838,7416832,'dor',25,1),(73,7416839,7416835,'mod',33.333,1),(73,7416840,7416835,'ode',33.333,1),(73,7416841,7416835,'del',33.333,1),(73,7416842,7416839,'lun',100,1),(73,7416843,7416842,'cmo',33.333,1),(73,7416844,7416842,'mod',33.333,1),(73,7416845,7416842,'ode',33.333,1),(73,7416846,7416843,'rev',16.667,1),(73,7416847,7416843,'evi',16.667,1),(73,7416848,7416843,'vis',16.667,1),(73,7416849,7416843,'isi',16.667,1),(73,7416850,7416843,'sio',16.667,1),(73,7416851,7416843,'ion',16.667,1),(73,7416852,7416846,'810',50,1),(73,7416853,7416846,'100',50,1),(73,7416854,7416852,'scs',50,1),(73,7416855,7416852,'csi',50,1),(73,7416856,7416854,'lev',33.333,1),(73,7416857,7416854,'eve',33.333,1),(73,7416858,7416854,'vel',33.333,1),(73,7416859,7416856,'pse',25,1),(73,7416860,7416856,'seu',25,1),(73,7416861,7416856,'eud',25,1),(73,7416862,7416856,'udo',25,1),(73,7416863,7416859,'fal',33.333,6),(73,7416864,7416859,'als',33.333,6),(73,7416865,7416859,'lse',33.333,6),(73,7416866,7416863,'sta',25,3),(73,7416867,7416863,'tat',25,3),(73,7416868,7416863,'atu',25,3),(73,7416869,7416863,'tus',25,3),(73,7416870,7416866,'rdm',100,1),(73,7416871,7416870,'cap',20,1),(73,7416872,7416870,'apa',20,1),(73,7416873,7416870,'pab',20,1),(73,7416874,7416870,'abl',20,1),(73,7416875,7416870,'ble',20,1),(73,7416876,7416871,'tru',50,1),(73,7416877,7416871,'rue',50,1),(73,7416878,7416876,'loc',33.333,1),(73,7416879,7416876,'oca',33.333,1),(73,7416880,7416876,'cal',33.333,1),(73,7416881,7416878,'rem',14.286,1),(73,7416882,7416878,'emo',14.286,1),(73,7416883,7416878,'mov',14.286,1),(73,7416884,7416878,'ova',14.286,1),(73,7416885,7416878,'vab',14.286,1),(73,7416886,7416878,'abl',14.286,1),(73,7416887,7416878,'ble',14.286,1),(73,7416888,7416881,'ssd',100,1),(73,7416889,7416888,'off',20,1),(73,7416890,7416888,'ffl',20,1),(73,7416891,7416888,'fli',20,1),(73,7416892,7416888,'lin',20,1),(73,7416893,7416888,'ine',20,1),(73,7416894,7416889,'per',11.111,1),(73,7416895,7416889,'ere',11.111,1),(73,7416896,7416889,'ren',11.111,1),(73,7416897,7416889,'enn',11.111,1),(73,7416898,7416889,'nni',11.111,1),(73,7416899,7416889,'nia',11.111,1),(73,7416900,7416889,'ial',11.111,1),(73,7416901,7416889,'all',11.111,1),(73,7416902,7416889,'lly',11.111,1),(73,7416903,7416894,'res',16.667,1),(73,7416904,7416894,'ese',16.667,1),(73,7416905,7416894,'ser',16.667,1),(73,7416906,7416894,'erv',16.667,1),(73,7416907,7416894,'rve',16.667,1),(73,7416908,7416894,'ved',16.667,1),(73,7416909,7416903,'thi',50,1),(73,7416910,7416903,'hin',50,1),(73,7416911,7416909,'pro',10,1),(73,7416912,7416909,'rov',10,1),(73,7416913,7416909,'ovi',10,1),(73,7416914,7416909,'vis',10,1),(73,7416915,7416909,'isi',10,1),(73,7416916,7416909,'sio',10,1),(73,7416917,7416909,'ion',10,1),(73,7416918,7416909,'oni',10,1),(73,7416919,7416909,'nin',10,1),(73,7416920,7416909,'ing',10,1),(73,7416921,7416911,'yes',100,1),(73,7416922,7416921,'att',16.667,1),(73,7416923,7416921,'tta',16.667,1),(73,7416924,7416921,'tac',16.667,1),(73,7416925,7416921,'ach',16.667,1),(73,7416926,7416921,'che',16.667,1),(73,7416927,7416921,'hed',16.667,1),(73,7416928,7416922,'fil',20,1),(73,7416929,7416922,'ilt',20,1),(73,7416930,7416922,'lte',20,1),(73,7416931,7416922,'ter',20,1),(73,7416932,7416922,'ers',20,1),(73,7416933,7416928,'vaa',50,1),(73,7416934,7416928,'aai',50,1),(73,7416935,7416933,'unk',20,1),(73,7416936,7416933,'nkn',20,1),(73,7416937,7416933,'kno',20,1),(73,7416938,7416933,'now',20,1),(73,7416939,7416933,'own',20,1),(73,7416940,7416935,'oth',33.333,1),(73,7416941,7416935,'the',33.333,1),(73,7416942,7416935,'her',33.333,1),(73,7416943,7416940,'uid',50,1),(73,7416944,7416940,'ids',50,1),(73,7416945,7416943,'vml',100,1),(73,7416946,7416945,'dis',20,1),(73,7416947,7416945,'isp',20,1),(73,7416948,7416945,'spl',20,1),(73,7416949,7416945,'pla',20,1),(73,7416950,7416945,'lay',20,1),(73,7416951,7416946,'nam',50,1),(73,7416952,7416946,'ame',50,1),(74,7416954,7416953,'net',25,3),(74,7416955,7416953,'eta',25,3),(74,7416956,7416953,'tap',25,3),(74,7416957,7416953,'app',25,3),(74,7416958,7416954,'fib',33.333,2),(74,7416959,7416954,'ibr',33.333,2),(74,7416960,7416954,'bre',33.333,2),(74,7416961,7416958,'cha',20,2),(74,7416962,7416958,'han',20,2),(74,7416963,7416958,'ann',20,2),(74,7416964,7416958,'nne',20,2),(74,7416965,7416958,'nel',20,2),(74,7416966,7416961,'dis',50,2),(74,7416967,7416961,'isk',50,2),(74,7416968,7416966,'naa',100,4),(74,7416969,7416968,'600',3.333,4),(74,7416970,7416968,'00a',3.333,4),(74,7416971,7416968,'0a0',3.333,4),(74,7416972,7416968,'a09',3.333,4),(74,7416973,7416968,'098',3.333,4),(74,7416974,7416968,'980',3.333,4),(74,7416975,7416968,'804',3.333,4),(74,7416976,7416968,'044',3.333,4),(74,7416977,7416968,'443',3.333,4),(74,7416978,7416968,'430',3.333,4),(74,7416979,7416968,'307',3.333,4),(74,7416980,7416968,'075',3.333,4),(74,7416981,7416968,'753',3.333,4),(74,7416982,7416968,'535',3.333,4),(74,7416983,7416968,'357',3.333,4),(74,7416984,7416968,'573',3.333,4),(74,7416985,7416968,'732',3.333,4),(74,7416986,7416968,'32b',3.333,4),(74,7416987,7416968,'2b3',3.333,4),(74,7416988,7416968,'b33',3.333,4),(74,7416989,7416968,'334',3.333,4),(74,7416990,7416968,'345',3.333,4),(74,7416991,7416968,'457',3.333,4),(74,7416992,7416968,'571',3.333,4),(74,7416993,7416968,'715',3.333,4),(74,7416994,7416968,'153',3.333,4),(74,7416995,7416968,'533',3.333,4),(74,7416996,7416968,'336',3.333,4),(74,7416997,7416968,'364',3.333,4),(74,7416998,7416968,'644',3.333,4),(74,7416999,7416969,'ser',25,1),(74,7417000,7416969,'eri',25,1),(74,7417001,7416969,'ria',25,1),(74,7417002,7416969,'ial',25,1),(74,7417003,7416999,'siz',50,1),(74,7417004,7416999,'ize',50,1),(74,7417005,7417003,'321',100,1),(74,7417006,7417005,'dev',25,1),(74,7417007,7417005,'evi',25,1),(74,7417008,7417005,'vic',25,1),(74,7417009,7417005,'ice',25,1),(74,7417010,7417006,'typ',50,1),(74,7417011,7417006,'ype',50,1),(74,7417012,7417010,'dir',10,1),(74,7417013,7417010,'ire',10,1),(74,7417014,7417010,'rec',10,1),(74,7417015,7417010,'ect',10,1),(74,7417016,7417010,'cta',10,1),(74,7417017,7417010,'tac',10,1),(74,7417018,7417010,'acc',10,1),(74,7417019,7417010,'cce',10,1),(74,7417020,7417010,'ces',10,1),(74,7417021,7417010,'ess',10,1),(74,7417022,7417012,'mul',14.286,1),(74,7417023,7417012,'ult',14.286,1),(74,7417024,7417012,'lti',14.286,1),(74,7417025,7417012,'tip',14.286,1),(74,7417026,7417012,'ipa',14.286,1),(74,7417027,7417012,'pat',14.286,1),(74,7417028,7417012,'ath',14.286,1),(74,7417029,7417022,'plu',25,1),(74,7417030,7417022,'lug',25,1),(74,7417031,7417022,'ugi',25,1),(74,7417032,7417022,'gin',25,1),(74,7417033,7417029,'nmp',100,1),(74,7417034,7417033,'dev',33.333,1),(74,7417035,7417033,'evf',33.333,1),(74,7417036,7417033,'vfs',33.333,1),(74,7417037,7417034,'pat',50,1),(74,7417038,7417034,'ath',50,1),(74,7417039,7417037,'vmf',50,1),(74,7417040,7417037,'mfs',50,1),(74,7417041,7417039,'dev',20,1),(74,7417042,7417039,'evi',20,1),(74,7417043,7417039,'vic',20,1),(74,7417044,7417039,'ice',20,1),(74,7417045,7417039,'ces',20,1),(74,7417046,7417041,'dis',33.333,1),(74,7417047,7417041,'isk',33.333,1),(74,7417048,7417041,'sks',33.333,1),(74,7417049,7417046,'ven',25,1),(74,7417050,7417046,'end',25,1),(74,7417051,7417046,'ndo',25,1),(74,7417052,7417046,'dor',25,1),(74,7417053,7417049,'mod',33.333,1),(74,7417054,7417049,'ode',33.333,1),(74,7417055,7417049,'del',33.333,1),(74,7417056,7417053,'lun',100,1),(74,7417057,7417056,'cmo',33.333,1),(74,7417058,7417056,'mod',33.333,1),(74,7417059,7417056,'ode',33.333,1),(74,7417060,7417057,'rev',16.667,1),(74,7417061,7417057,'evi',16.667,1),(74,7417062,7417057,'vis',16.667,1),(74,7417063,7417057,'isi',16.667,1),(74,7417064,7417057,'sio',16.667,1),(74,7417065,7417057,'ion',16.667,1),(74,7417066,7417060,'810',50,1),(74,7417067,7417060,'100',50,1),(74,7417068,7417066,'scs',50,1),(74,7417069,7417066,'csi',50,1),(74,7417070,7417068,'lev',33.333,1),(74,7417071,7417068,'eve',33.333,1),(74,7417072,7417068,'vel',33.333,1),(74,7417073,7417070,'pse',25,1),(74,7417074,7417070,'seu',25,1),(74,7417075,7417070,'eud',25,1),(74,7417076,7417070,'udo',25,1),(74,7417077,7417073,'fal',33.333,6),(74,7417078,7417073,'als',33.333,6),(74,7417079,7417073,'lse',33.333,6),(74,7417080,7417077,'sta',25,3),(74,7417081,7417077,'tat',25,3),(74,7417082,7417077,'atu',25,3),(74,7417083,7417077,'tus',25,3),(74,7417084,7417080,'rdm',100,1),(74,7417085,7417084,'cap',20,1),(74,7417086,7417084,'apa',20,1),(74,7417087,7417084,'pab',20,1),(74,7417088,7417084,'abl',20,1),(74,7417089,7417084,'ble',20,1),(74,7417090,7417085,'tru',50,1),(74,7417091,7417085,'rue',50,1),(74,7417092,7417090,'loc',33.333,1),(74,7417093,7417090,'oca',33.333,1),(74,7417094,7417090,'cal',33.333,1),(74,7417095,7417092,'rem',14.286,1),(74,7417096,7417092,'emo',14.286,1),(74,7417097,7417092,'mov',14.286,1),(74,7417098,7417092,'ova',14.286,1),(74,7417099,7417092,'vab',14.286,1),(74,7417100,7417092,'abl',14.286,1),(74,7417101,7417092,'ble',14.286,1),(74,7417102,7417095,'ssd',100,1),(74,7417103,7417102,'off',20,1),(74,7417104,7417102,'ffl',20,1),(74,7417105,7417102,'fli',20,1),(74,7417106,7417102,'lin',20,1),(74,7417107,7417102,'ine',20,1),(74,7417108,7417103,'per',11.111,1),(74,7417109,7417103,'ere',11.111,1),(74,7417110,7417103,'ren',11.111,1),(74,7417111,7417103,'enn',11.111,1),(74,7417112,7417103,'nni',11.111,1),(74,7417113,7417103,'nia',11.111,1),(74,7417114,7417103,'ial',11.111,1),(74,7417115,7417103,'all',11.111,1),(74,7417116,7417103,'lly',11.111,1),(74,7417117,7417108,'res',16.667,1),(74,7417118,7417108,'ese',16.667,1),(74,7417119,7417108,'ser',16.667,1),(74,7417120,7417108,'erv',16.667,1),(74,7417121,7417108,'rve',16.667,1),(74,7417122,7417108,'ved',16.667,1),(74,7417123,7417117,'thi',50,1),(74,7417124,7417117,'hin',50,1),(74,7417125,7417123,'pro',10,1),(74,7417126,7417123,'rov',10,1),(74,7417127,7417123,'ovi',10,1),(74,7417128,7417123,'vis',10,1),(74,7417129,7417123,'isi',10,1),(74,7417130,7417123,'sio',10,1),(74,7417131,7417123,'ion',10,1),(74,7417132,7417123,'oni',10,1),(74,7417133,7417123,'nin',10,1),(74,7417134,7417123,'ing',10,1),(74,7417135,7417125,'yes',100,1),(74,7417136,7417135,'att',16.667,1),(74,7417137,7417135,'tta',16.667,1),(74,7417138,7417135,'tac',16.667,1),(74,7417139,7417135,'ach',16.667,1),(74,7417140,7417135,'che',16.667,1),(74,7417141,7417135,'hed',16.667,1),(74,7417142,7417136,'fil',20,1),(74,7417143,7417136,'ilt',20,1),(74,7417144,7417136,'lte',20,1),(74,7417145,7417136,'ter',20,1),(74,7417146,7417136,'ers',20,1),(74,7417147,7417142,'vaa',50,1),(74,7417148,7417142,'aai',50,1),(74,7417149,7417147,'unk',20,1),(74,7417150,7417147,'nkn',20,1),(74,7417151,7417147,'kno',20,1),(74,7417152,7417147,'now',20,1),(74,7417153,7417147,'own',20,1),(74,7417154,7417149,'oth',33.333,1),(74,7417155,7417149,'the',33.333,1),(74,7417156,7417149,'her',33.333,1),(74,7417157,7417154,'uid',50,1),(74,7417158,7417154,'ids',50,1),(74,7417159,7417157,'vml',100,1),(74,7417160,7417159,'dis',20,1),(74,7417161,7417159,'isp',20,1),(74,7417162,7417159,'spl',20,1),(74,7417163,7417159,'pla',20,1),(74,7417164,7417159,'lay',20,1),(74,7417165,7417160,'nam',50,1),(74,7417166,7417160,'ame',50,1),(75,7417168,7417167,'net',25,3),(75,7417169,7417167,'eta',25,3),(75,7417170,7417167,'tap',25,3),(75,7417171,7417167,'app',25,3),(75,7417172,7417168,'fib',33.333,2),(75,7417173,7417168,'ibr',33.333,2),(75,7417174,7417168,'bre',33.333,2),(75,7417175,7417172,'cha',20,2),(75,7417176,7417172,'han',20,2),(75,7417177,7417172,'ann',20,2),(75,7417178,7417172,'nne',20,2),(75,7417179,7417172,'nel',20,2),(75,7417180,7417175,'dis',50,2),(75,7417181,7417175,'isk',50,2),(75,7417182,7417180,'naa',100,4),(75,7417183,7417182,'600',3.333,4),(75,7417184,7417182,'00a',3.333,4),(75,7417185,7417182,'0a0',3.333,4),(75,7417186,7417182,'a09',3.333,4),(75,7417187,7417182,'098',3.333,4),(75,7417188,7417182,'980',3.333,4),(75,7417189,7417182,'804',3.333,4),(75,7417190,7417182,'044',3.333,4),(75,7417191,7417182,'443',3.333,4),(75,7417192,7417182,'430',3.333,4),(75,7417193,7417182,'307',3.333,4),(75,7417194,7417182,'075',3.333,4),(75,7417195,7417182,'753',3.333,4),(75,7417196,7417182,'535',3.333,4),(75,7417197,7417182,'357',3.333,4),(75,7417198,7417182,'573',3.333,4),(75,7417199,7417182,'732',3.333,4),(75,7417200,7417182,'32b',3.333,4),(75,7417201,7417182,'2b3',3.333,4),(75,7417202,7417182,'b33',3.333,4),(75,7417203,7417182,'334',3.333,4),(75,7417204,7417182,'345',3.333,4),(75,7417205,7417182,'457',3.333,4),(75,7417206,7417182,'571',3.333,4),(75,7417207,7417182,'715',3.333,4),(75,7417208,7417182,'153',3.333,4),(75,7417209,7417182,'533',3.333,4),(75,7417210,7417182,'335',3.333,4),(75,7417211,7417182,'356',3.333,4),(75,7417212,7417182,'568',3.333,4),(75,7417213,7417183,'ser',25,1),(75,7417214,7417183,'eri',25,1),(75,7417215,7417183,'ria',25,1),(75,7417216,7417183,'ial',25,1),(75,7417217,7417213,'siz',50,1),(75,7417218,7417213,'ize',50,1),(75,7417219,7417217,'460',33.333,1),(75,7417220,7417217,'608',33.333,1),(75,7417221,7417217,'080',33.333,1),(75,7417222,7417219,'dev',25,1),(75,7417223,7417219,'evi',25,1),(75,7417224,7417219,'vic',25,1),(75,7417225,7417219,'ice',25,1),(75,7417226,7417222,'typ',50,1),(75,7417227,7417222,'ype',50,1),(75,7417228,7417226,'dir',10,1),(75,7417229,7417226,'ire',10,1),(75,7417230,7417226,'rec',10,1),(75,7417231,7417226,'ect',10,1),(75,7417232,7417226,'cta',10,1),(75,7417233,7417226,'tac',10,1),(75,7417234,7417226,'acc',10,1),(75,7417235,7417226,'cce',10,1),(75,7417236,7417226,'ces',10,1),(75,7417237,7417226,'ess',10,1),(75,7417238,7417228,'mul',14.286,1),(75,7417239,7417228,'ult',14.286,1),(75,7417240,7417228,'lti',14.286,1),(75,7417241,7417228,'tip',14.286,1),(75,7417242,7417228,'ipa',14.286,1),(75,7417243,7417228,'pat',14.286,1),(75,7417244,7417228,'ath',14.286,1),(75,7417245,7417238,'plu',25,1),(75,7417246,7417238,'lug',25,1),(75,7417247,7417238,'ugi',25,1),(75,7417248,7417238,'gin',25,1),(75,7417249,7417245,'nmp',100,1),(75,7417250,7417249,'dev',33.333,1),(75,7417251,7417249,'evf',33.333,1),(75,7417252,7417249,'vfs',33.333,1),(75,7417253,7417250,'pat',50,1),(75,7417254,7417250,'ath',50,1),(75,7417255,7417253,'vmf',50,1),(75,7417256,7417253,'mfs',50,1),(75,7417257,7417255,'dev',20,1),(75,7417258,7417255,'evi',20,1),(75,7417259,7417255,'vic',20,1),(75,7417260,7417255,'ice',20,1),(75,7417261,7417255,'ces',20,1),(75,7417262,7417257,'dis',33.333,1),(75,7417263,7417257,'isk',33.333,1),(75,7417264,7417257,'sks',33.333,1),(75,7417265,7417262,'ven',25,1),(75,7417266,7417262,'end',25,1),(75,7417267,7417262,'ndo',25,1),(75,7417268,7417262,'dor',25,1),(75,7417269,7417265,'mod',33.333,1),(75,7417270,7417265,'ode',33.333,1),(75,7417271,7417265,'del',33.333,1),(75,7417272,7417269,'lun',100,1),(75,7417273,7417272,'cmo',33.333,1),(75,7417274,7417272,'mod',33.333,1),(75,7417275,7417272,'ode',33.333,1),(75,7417276,7417273,'rev',16.667,1),(75,7417277,7417273,'evi',16.667,1),(75,7417278,7417273,'vis',16.667,1),(75,7417279,7417273,'isi',16.667,1),(75,7417280,7417273,'sio',16.667,1),(75,7417281,7417273,'ion',16.667,1),(75,7417282,7417276,'810',50,1),(75,7417283,7417276,'100',50,1),(75,7417284,7417282,'scs',50,1),(75,7417285,7417282,'csi',50,1),(75,7417286,7417284,'lev',33.333,1),(75,7417287,7417284,'eve',33.333,1),(75,7417288,7417284,'vel',33.333,1),(75,7417289,7417286,'pse',25,1),(75,7417290,7417286,'seu',25,1),(75,7417291,7417286,'eud',25,1),(75,7417292,7417286,'udo',25,1),(75,7417293,7417289,'fal',33.333,6),(75,7417294,7417289,'als',33.333,6),(75,7417295,7417289,'lse',33.333,6),(75,7417296,7417293,'sta',25,3),(75,7417297,7417293,'tat',25,3),(75,7417298,7417293,'atu',25,3),(75,7417299,7417293,'tus',25,3),(75,7417300,7417296,'rdm',100,1),(75,7417301,7417300,'cap',20,1),(75,7417302,7417300,'apa',20,1),(75,7417303,7417300,'pab',20,1),(75,7417304,7417300,'abl',20,1),(75,7417305,7417300,'ble',20,1),(75,7417306,7417301,'tru',50,1),(75,7417307,7417301,'rue',50,1),(75,7417308,7417306,'loc',33.333,1),(75,7417309,7417306,'oca',33.333,1),(75,7417310,7417306,'cal',33.333,1),(75,7417311,7417308,'rem',14.286,1),(75,7417312,7417308,'emo',14.286,1),(75,7417313,7417308,'mov',14.286,1),(75,7417314,7417308,'ova',14.286,1),(75,7417315,7417308,'vab',14.286,1),(75,7417316,7417308,'abl',14.286,1),(75,7417317,7417308,'ble',14.286,1),(75,7417318,7417311,'ssd',100,1),(75,7417319,7417318,'off',20,1),(75,7417320,7417318,'ffl',20,1),(75,7417321,7417318,'fli',20,1),(75,7417322,7417318,'lin',20,1),(75,7417323,7417318,'ine',20,1),(75,7417324,7417319,'per',11.111,1),(75,7417325,7417319,'ere',11.111,1),(75,7417326,7417319,'ren',11.111,1),(75,7417327,7417319,'enn',11.111,1),(75,7417328,7417319,'nni',11.111,1),(75,7417329,7417319,'nia',11.111,1),(75,7417330,7417319,'ial',11.111,1),(75,7417331,7417319,'all',11.111,1),(75,7417332,7417319,'lly',11.111,1),(75,7417333,7417324,'res',16.667,1),(75,7417334,7417324,'ese',16.667,1),(75,7417335,7417324,'ser',16.667,1),(75,7417336,7417324,'erv',16.667,1),(75,7417337,7417324,'rve',16.667,1),(75,7417338,7417324,'ved',16.667,1),(75,7417339,7417333,'thi',50,1),(75,7417340,7417333,'hin',50,1),(75,7417341,7417339,'pro',10,1),(75,7417342,7417339,'rov',10,1),(75,7417343,7417339,'ovi',10,1),(75,7417344,7417339,'vis',10,1),(75,7417345,7417339,'isi',10,1),(75,7417346,7417339,'sio',10,1),(75,7417347,7417339,'ion',10,1),(75,7417348,7417339,'oni',10,1),(75,7417349,7417339,'nin',10,1),(75,7417350,7417339,'ing',10,1),(75,7417351,7417341,'yes',100,1),(75,7417352,7417351,'att',16.667,1),(75,7417353,7417351,'tta',16.667,1),(75,7417354,7417351,'tac',16.667,1),(75,7417355,7417351,'ach',16.667,1),(75,7417356,7417351,'che',16.667,1),(75,7417357,7417351,'hed',16.667,1),(75,7417358,7417352,'fil',20,1),(75,7417359,7417352,'ilt',20,1),(75,7417360,7417352,'lte',20,1),(75,7417361,7417352,'ter',20,1),(75,7417362,7417352,'ers',20,1),(75,7417363,7417358,'vaa',50,1),(75,7417364,7417358,'aai',50,1),(75,7417365,7417363,'unk',20,1),(75,7417366,7417363,'nkn',20,1),(75,7417367,7417363,'kno',20,1),(75,7417368,7417363,'now',20,1),(75,7417369,7417363,'own',20,1),(75,7417370,7417365,'oth',33.333,1),(75,7417371,7417365,'the',33.333,1),(75,7417372,7417365,'her',33.333,1),(75,7417373,7417370,'uid',50,1),(75,7417374,7417370,'ids',50,1),(75,7417375,7417373,'vml',100,1),(75,7417376,7417375,'dis',20,1),(75,7417377,7417375,'isp',20,1),(75,7417378,7417375,'spl',20,1),(75,7417379,7417375,'pla',20,1),(75,7417380,7417375,'lay',20,1),(75,7417381,7417376,'nam',50,1),(75,7417382,7417376,'ame',50,1),(76,7417384,7417383,'net',25,3),(76,7417385,7417383,'eta',25,3),(76,7417386,7417383,'tap',25,3),(76,7417387,7417383,'app',25,3),(76,7417388,7417384,'fib',33.333,2),(76,7417389,7417384,'ibr',33.333,2),(76,7417390,7417384,'bre',33.333,2),(76,7417391,7417388,'cha',20,2),(76,7417392,7417388,'han',20,2),(76,7417393,7417388,'ann',20,2),(76,7417394,7417388,'nne',20,2),(76,7417395,7417388,'nel',20,2),(76,7417396,7417391,'dis',50,2),(76,7417397,7417391,'isk',50,2),(76,7417398,7417396,'naa',100,4),(76,7417399,7417398,'600',3.333,4),(76,7417400,7417398,'00a',3.333,4),(76,7417401,7417398,'0a0',3.333,4),(76,7417402,7417398,'a09',3.333,4),(76,7417403,7417398,'098',3.333,4),(76,7417404,7417398,'980',3.333,4),(76,7417405,7417398,'804',3.333,4),(76,7417406,7417398,'044',3.333,4),(76,7417407,7417398,'443',3.333,4),(76,7417408,7417398,'430',3.333,4),(76,7417409,7417398,'307',3.333,4),(76,7417410,7417398,'075',3.333,4),(76,7417411,7417398,'753',3.333,4),(76,7417412,7417398,'535',3.333,4),(76,7417413,7417398,'357',3.333,4),(76,7417414,7417398,'573',3.333,4),(76,7417415,7417398,'732',3.333,4),(76,7417416,7417398,'32b',3.333,4),(76,7417417,7417398,'2b3',3.333,4),(76,7417418,7417398,'b33',3.333,4),(76,7417419,7417398,'334',3.333,4),(76,7417420,7417398,'345',3.333,4),(76,7417421,7417398,'457',3.333,4),(76,7417422,7417398,'571',3.333,4),(76,7417423,7417398,'715',3.333,4),(76,7417424,7417398,'153',3.333,4),(76,7417425,7417398,'533',3.333,4),(76,7417426,7417398,'336',3.333,4),(76,7417427,7417398,'364',3.333,4),(76,7417428,7417398,'645',3.333,4),(76,7417429,7417399,'ser',25,1),(76,7417430,7417399,'eri',25,1),(76,7417431,7417399,'ria',25,1),(76,7417432,7417399,'ial',25,1),(76,7417433,7417429,'siz',50,1),(76,7417434,7417429,'ize',50,1),(76,7417435,7417433,'321',100,1),(76,7417436,7417435,'dev',25,1),(76,7417437,7417435,'evi',25,1),(76,7417438,7417435,'vic',25,1),(76,7417439,7417435,'ice',25,1),(76,7417440,7417436,'typ',50,1),(76,7417441,7417436,'ype',50,1),(76,7417442,7417440,'dir',10,1),(76,7417443,7417440,'ire',10,1),(76,7417444,7417440,'rec',10,1),(76,7417445,7417440,'ect',10,1),(76,7417446,7417440,'cta',10,1),(76,7417447,7417440,'tac',10,1),(76,7417448,7417440,'acc',10,1),(76,7417449,7417440,'cce',10,1),(76,7417450,7417440,'ces',10,1),(76,7417451,7417440,'ess',10,1),(76,7417452,7417442,'mul',14.286,1),(76,7417453,7417442,'ult',14.286,1),(76,7417454,7417442,'lti',14.286,1),(76,7417455,7417442,'tip',14.286,1),(76,7417456,7417442,'ipa',14.286,1),(76,7417457,7417442,'pat',14.286,1),(76,7417458,7417442,'ath',14.286,1),(76,7417459,7417452,'plu',25,1),(76,7417460,7417452,'lug',25,1),(76,7417461,7417452,'ugi',25,1),(76,7417462,7417452,'gin',25,1),(76,7417463,7417459,'nmp',100,1),(76,7417464,7417463,'dev',33.333,1),(76,7417465,7417463,'evf',33.333,1),(76,7417466,7417463,'vfs',33.333,1),(76,7417467,7417464,'pat',50,1),(76,7417468,7417464,'ath',50,1),(76,7417469,7417467,'vmf',50,1),(76,7417470,7417467,'mfs',50,1),(76,7417471,7417469,'dev',20,1),(76,7417472,7417469,'evi',20,1),(76,7417473,7417469,'vic',20,1),(76,7417474,7417469,'ice',20,1),(76,7417475,7417469,'ces',20,1),(76,7417476,7417471,'dis',33.333,1),(76,7417477,7417471,'isk',33.333,1),(76,7417478,7417471,'sks',33.333,1),(76,7417479,7417476,'ven',25,1),(76,7417480,7417476,'end',25,1),(76,7417481,7417476,'ndo',25,1),(76,7417482,7417476,'dor',25,1),(76,7417483,7417479,'mod',33.333,1),(76,7417484,7417479,'ode',33.333,1),(76,7417485,7417479,'del',33.333,1),(76,7417486,7417483,'lun',100,1),(76,7417487,7417486,'cmo',33.333,1),(76,7417488,7417486,'mod',33.333,1),(76,7417489,7417486,'ode',33.333,1),(76,7417490,7417487,'rev',16.667,1),(76,7417491,7417487,'evi',16.667,1),(76,7417492,7417487,'vis',16.667,1),(76,7417493,7417487,'isi',16.667,1),(76,7417494,7417487,'sio',16.667,1),(76,7417495,7417487,'ion',16.667,1),(76,7417496,7417490,'810',50,1),(76,7417497,7417490,'100',50,1),(76,7417498,7417496,'scs',50,1),(76,7417499,7417496,'csi',50,1),(76,7417500,7417498,'lev',33.333,1),(76,7417501,7417498,'eve',33.333,1),(76,7417502,7417498,'vel',33.333,1),(76,7417503,7417500,'pse',25,1),(76,7417504,7417500,'seu',25,1),(76,7417505,7417500,'eud',25,1),(76,7417506,7417500,'udo',25,1),(76,7417507,7417503,'fal',33.333,6),(76,7417508,7417503,'als',33.333,6),(76,7417509,7417503,'lse',33.333,6),(76,7417510,7417507,'sta',25,3),(76,7417511,7417507,'tat',25,3),(76,7417512,7417507,'atu',25,3),(76,7417513,7417507,'tus',25,3),(76,7417514,7417510,'rdm',100,1),(76,7417515,7417514,'cap',20,1),(76,7417516,7417514,'apa',20,1),(76,7417517,7417514,'pab',20,1),(76,7417518,7417514,'abl',20,1),(76,7417519,7417514,'ble',20,1),(76,7417520,7417515,'tru',50,1),(76,7417521,7417515,'rue',50,1),(76,7417522,7417520,'loc',33.333,1),(76,7417523,7417520,'oca',33.333,1),(76,7417524,7417520,'cal',33.333,1),(76,7417525,7417522,'rem',14.286,1),(76,7417526,7417522,'emo',14.286,1),(76,7417527,7417522,'mov',14.286,1),(76,7417528,7417522,'ova',14.286,1),(76,7417529,7417522,'vab',14.286,1),(76,7417530,7417522,'abl',14.286,1),(76,7417531,7417522,'ble',14.286,1),(76,7417532,7417525,'ssd',100,1),(76,7417533,7417532,'off',20,1),(76,7417534,7417532,'ffl',20,1),(76,7417535,7417532,'fli',20,1),(76,7417536,7417532,'lin',20,1),(76,7417537,7417532,'ine',20,1),(76,7417538,7417533,'per',11.111,1),(76,7417539,7417533,'ere',11.111,1),(76,7417540,7417533,'ren',11.111,1),(76,7417541,7417533,'enn',11.111,1),(76,7417542,7417533,'nni',11.111,1),(76,7417543,7417533,'nia',11.111,1),(76,7417544,7417533,'ial',11.111,1),(76,7417545,7417533,'all',11.111,1),(76,7417546,7417533,'lly',11.111,1),(76,7417547,7417538,'res',16.667,1),(76,7417548,7417538,'ese',16.667,1),(76,7417549,7417538,'ser',16.667,1),(76,7417550,7417538,'erv',16.667,1),(76,7417551,7417538,'rve',16.667,1),(76,7417552,7417538,'ved',16.667,1),(76,7417553,7417547,'thi',50,1),(76,7417554,7417547,'hin',50,1),(76,7417555,7417553,'pro',10,1),(76,7417556,7417553,'rov',10,1),(76,7417557,7417553,'ovi',10,1),(76,7417558,7417553,'vis',10,1),(76,7417559,7417553,'isi',10,1),(76,7417560,7417553,'sio',10,1),(76,7417561,7417553,'ion',10,1),(76,7417562,7417553,'oni',10,1),(76,7417563,7417553,'nin',10,1),(76,7417564,7417553,'ing',10,1),(76,7417565,7417555,'yes',100,1),(76,7417566,7417565,'att',16.667,1),(76,7417567,7417565,'tta',16.667,1),(76,7417568,7417565,'tac',16.667,1),(76,7417569,7417565,'ach',16.667,1),(76,7417570,7417565,'che',16.667,1),(76,7417571,7417565,'hed',16.667,1),(76,7417572,7417566,'fil',20,1),(76,7417573,7417566,'ilt',20,1),(76,7417574,7417566,'lte',20,1),(76,7417575,7417566,'ter',20,1),(76,7417576,7417566,'ers',20,1),(76,7417577,7417572,'vaa',50,1),(76,7417578,7417572,'aai',50,1),(76,7417579,7417577,'unk',20,1),(76,7417580,7417577,'nkn',20,1),(76,7417581,7417577,'kno',20,1),(76,7417582,7417577,'now',20,1),(76,7417583,7417577,'own',20,1),(76,7417584,7417579,'oth',33.333,1),(76,7417585,7417579,'the',33.333,1),(76,7417586,7417579,'her',33.333,1),(76,7417587,7417584,'uid',50,1),(76,7417588,7417584,'ids',50,1),(76,7417589,7417587,'vml',100,1),(76,7417590,7417589,'dis',20,1),(76,7417591,7417589,'isp',20,1),(76,7417592,7417589,'spl',20,1),(76,7417593,7417589,'pla',20,1),(76,7417594,7417589,'lay',20,1),(76,7417595,7417590,'nam',50,1),(76,7417596,7417590,'ame',50,1),(77,7417598,7417597,'net',25,3),(77,7417599,7417597,'eta',25,3),(77,7417600,7417597,'tap',25,3),(77,7417601,7417597,'app',25,3),(77,7417602,7417598,'fib',33.333,2),(77,7417603,7417598,'ibr',33.333,2),(77,7417604,7417598,'bre',33.333,2),(77,7417605,7417602,'cha',20,2),(77,7417606,7417602,'han',20,2),(77,7417607,7417602,'ann',20,2),(77,7417608,7417602,'nne',20,2),(77,7417609,7417602,'nel',20,2),(77,7417610,7417605,'dis',50,2),(77,7417611,7417605,'isk',50,2),(77,7417612,7417610,'naa',100,4),(77,7417613,7417612,'600',3.333,4),(77,7417614,7417612,'00a',3.333,4),(77,7417615,7417612,'0a0',3.333,4),(77,7417616,7417612,'a09',3.333,4),(77,7417617,7417612,'098',3.333,4),(77,7417618,7417612,'980',3.333,4),(77,7417619,7417612,'804',3.333,4),(77,7417620,7417612,'044',3.333,4),(77,7417621,7417612,'443',3.333,4),(77,7417622,7417612,'430',3.333,4),(77,7417623,7417612,'307',3.333,4),(77,7417624,7417612,'075',3.333,4),(77,7417625,7417612,'753',3.333,4),(77,7417626,7417612,'535',3.333,4),(77,7417627,7417612,'357',3.333,4),(77,7417628,7417612,'573',3.333,4),(77,7417629,7417612,'732',3.333,4),(77,7417630,7417612,'32b',3.333,4),(77,7417631,7417612,'2b3',3.333,4),(77,7417632,7417612,'b33',3.333,4),(77,7417633,7417612,'334',3.333,4),(77,7417634,7417612,'345',3.333,4),(77,7417635,7417612,'457',3.333,4),(77,7417636,7417612,'571',3.333,4),(77,7417637,7417612,'715',3.333,4),(77,7417638,7417612,'153',3.333,4),(77,7417639,7417612,'533',3.333,4),(77,7417640,7417612,'335',3.333,4),(77,7417641,7417612,'356',3.333,4),(77,7417642,7417612,'569',3.333,4),(77,7417643,7417613,'ser',25,1),(77,7417644,7417613,'eri',25,1),(77,7417645,7417613,'ria',25,1),(77,7417646,7417613,'ial',25,1),(77,7417647,7417643,'siz',50,1),(77,7417648,7417643,'ize',50,1),(77,7417649,7417647,'460',33.333,1),(77,7417650,7417647,'608',33.333,1),(77,7417651,7417647,'080',33.333,1),(77,7417652,7417649,'dev',25,1),(77,7417653,7417649,'evi',25,1),(77,7417654,7417649,'vic',25,1),(77,7417655,7417649,'ice',25,1),(77,7417656,7417652,'typ',50,1),(77,7417657,7417652,'ype',50,1),(77,7417658,7417656,'dir',10,1),(77,7417659,7417656,'ire',10,1),(77,7417660,7417656,'rec',10,1),(77,7417661,7417656,'ect',10,1),(77,7417662,7417656,'cta',10,1),(77,7417663,7417656,'tac',10,1),(77,7417664,7417656,'acc',10,1),(77,7417665,7417656,'cce',10,1),(77,7417666,7417656,'ces',10,1),(77,7417667,7417656,'ess',10,1),(77,7417668,7417658,'mul',14.286,1),(77,7417669,7417658,'ult',14.286,1),(77,7417670,7417658,'lti',14.286,1),(77,7417671,7417658,'tip',14.286,1),(77,7417672,7417658,'ipa',14.286,1),(77,7417673,7417658,'pat',14.286,1),(77,7417674,7417658,'ath',14.286,1),(77,7417675,7417668,'plu',25,1),(77,7417676,7417668,'lug',25,1),(77,7417677,7417668,'ugi',25,1),(77,7417678,7417668,'gin',25,1),(77,7417679,7417675,'nmp',100,1),(77,7417680,7417679,'dev',33.333,1),(77,7417681,7417679,'evf',33.333,1),(77,7417682,7417679,'vfs',33.333,1),(77,7417683,7417680,'pat',50,1),(77,7417684,7417680,'ath',50,1),(77,7417685,7417683,'vmf',50,1),(77,7417686,7417683,'mfs',50,1),(77,7417687,7417685,'dev',20,1),(77,7417688,7417685,'evi',20,1),(77,7417689,7417685,'vic',20,1),(77,7417690,7417685,'ice',20,1),(77,7417691,7417685,'ces',20,1),(77,7417692,7417687,'dis',33.333,1),(77,7417693,7417687,'isk',33.333,1),(77,7417694,7417687,'sks',33.333,1),(77,7417695,7417692,'ven',25,1),(77,7417696,7417692,'end',25,1),(77,7417697,7417692,'ndo',25,1),(77,7417698,7417692,'dor',25,1),(77,7417699,7417695,'mod',33.333,1),(77,7417700,7417695,'ode',33.333,1),(77,7417701,7417695,'del',33.333,1),(77,7417702,7417699,'lun',100,1),(77,7417703,7417702,'cmo',33.333,1),(77,7417704,7417702,'mod',33.333,1),(77,7417705,7417702,'ode',33.333,1),(77,7417706,7417703,'rev',16.667,1),(77,7417707,7417703,'evi',16.667,1),(77,7417708,7417703,'vis',16.667,1),(77,7417709,7417703,'isi',16.667,1),(77,7417710,7417703,'sio',16.667,1),(77,7417711,7417703,'ion',16.667,1),(77,7417712,7417706,'810',50,1),(77,7417713,7417706,'100',50,1),(77,7417714,7417712,'scs',50,1),(77,7417715,7417712,'csi',50,1),(77,7417716,7417714,'lev',33.333,1),(77,7417717,7417714,'eve',33.333,1),(77,7417718,7417714,'vel',33.333,1),(77,7417719,7417716,'pse',25,1),(77,7417720,7417716,'seu',25,1),(77,7417721,7417716,'eud',25,1),(77,7417722,7417716,'udo',25,1),(77,7417723,7417719,'fal',33.333,6),(77,7417724,7417719,'als',33.333,6),(77,7417725,7417719,'lse',33.333,6),(77,7417726,7417723,'sta',25,3),(77,7417727,7417723,'tat',25,3),(77,7417728,7417723,'atu',25,3),(77,7417729,7417723,'tus',25,3),(77,7417730,7417726,'rdm',100,1),(77,7417731,7417730,'cap',20,1),(77,7417732,7417730,'apa',20,1),(77,7417733,7417730,'pab',20,1),(77,7417734,7417730,'abl',20,1),(77,7417735,7417730,'ble',20,1),(77,7417736,7417731,'tru',50,1),(77,7417737,7417731,'rue',50,1),(77,7417738,7417736,'loc',33.333,1),(77,7417739,7417736,'oca',33.333,1),(77,7417740,7417736,'cal',33.333,1),(77,7417741,7417738,'rem',14.286,1),(77,7417742,7417738,'emo',14.286,1),(77,7417743,7417738,'mov',14.286,1),(77,7417744,7417738,'ova',14.286,1),(77,7417745,7417738,'vab',14.286,1),(77,7417746,7417738,'abl',14.286,1),(77,7417747,7417738,'ble',14.286,1),(77,7417748,7417741,'ssd',100,1),(77,7417749,7417748,'off',20,1),(77,7417750,7417748,'ffl',20,1),(77,7417751,7417748,'fli',20,1),(77,7417752,7417748,'lin',20,1),(77,7417753,7417748,'ine',20,1),(77,7417754,7417749,'per',11.111,1),(77,7417755,7417749,'ere',11.111,1),(77,7417756,7417749,'ren',11.111,1),(77,7417757,7417749,'enn',11.111,1),(77,7417758,7417749,'nni',11.111,1),(77,7417759,7417749,'nia',11.111,1),(77,7417760,7417749,'ial',11.111,1),(77,7417761,7417749,'all',11.111,1),(77,7417762,7417749,'lly',11.111,1),(77,7417763,7417754,'res',16.667,1),(77,7417764,7417754,'ese',16.667,1),(77,7417765,7417754,'ser',16.667,1),(77,7417766,7417754,'erv',16.667,1),(77,7417767,7417754,'rve',16.667,1),(77,7417768,7417754,'ved',16.667,1),(77,7417769,7417763,'thi',50,1),(77,7417770,7417763,'hin',50,1),(77,7417771,7417769,'pro',10,1),(77,7417772,7417769,'rov',10,1),(77,7417773,7417769,'ovi',10,1),(77,7417774,7417769,'vis',10,1),(77,7417775,7417769,'isi',10,1),(77,7417776,7417769,'sio',10,1),(77,7417777,7417769,'ion',10,1),(77,7417778,7417769,'oni',10,1),(77,7417779,7417769,'nin',10,1),(77,7417780,7417769,'ing',10,1),(77,7417781,7417771,'yes',100,1),(77,7417782,7417781,'att',16.667,1),(77,7417783,7417781,'tta',16.667,1),(77,7417784,7417781,'tac',16.667,1),(77,7417785,7417781,'ach',16.667,1),(77,7417786,7417781,'che',16.667,1),(77,7417787,7417781,'hed',16.667,1),(77,7417788,7417782,'fil',20,1),(77,7417789,7417782,'ilt',20,1),(77,7417790,7417782,'lte',20,1),(77,7417791,7417782,'ter',20,1),(77,7417792,7417782,'ers',20,1),(77,7417793,7417788,'vaa',50,1),(77,7417794,7417788,'aai',50,1),(77,7417795,7417793,'unk',20,1),(77,7417796,7417793,'nkn',20,1),(77,7417797,7417793,'kno',20,1),(77,7417798,7417793,'now',20,1),(77,7417799,7417793,'own',20,1),(77,7417800,7417795,'oth',33.333,1),(77,7417801,7417795,'the',33.333,1),(77,7417802,7417795,'her',33.333,1),(77,7417803,7417800,'uid',50,1),(77,7417804,7417800,'ids',50,1),(77,7417805,7417803,'vml',100,1),(77,7417806,7417805,'dis',20,1),(77,7417807,7417805,'isp',20,1),(77,7417808,7417805,'spl',20,1),(77,7417809,7417805,'pla',20,1),(77,7417810,7417805,'lay',20,1),(77,7417811,7417806,'nam',50,1),(77,7417812,7417806,'ame',50,1),(78,7417814,7417813,'net',25,3),(78,7417815,7417813,'eta',25,3),(78,7417816,7417813,'tap',25,3),(78,7417817,7417813,'app',25,3),(78,7417818,7417814,'fib',33.333,2),(78,7417819,7417814,'ibr',33.333,2),(78,7417820,7417814,'bre',33.333,2),(78,7417821,7417818,'cha',20,2),(78,7417822,7417818,'han',20,2),(78,7417823,7417818,'ann',20,2),(78,7417824,7417818,'nne',20,2),(78,7417825,7417818,'nel',20,2),(78,7417826,7417821,'dis',50,2),(78,7417827,7417821,'isk',50,2),(78,7417828,7417826,'naa',100,4),(78,7417829,7417828,'600',3.333,4),(78,7417830,7417828,'00a',3.333,4),(78,7417831,7417828,'0a0',3.333,4),(78,7417832,7417828,'a09',3.333,4),(78,7417833,7417828,'098',3.333,4),(78,7417834,7417828,'980',3.333,4),(78,7417835,7417828,'804',3.333,4),(78,7417836,7417828,'044',3.333,4),(78,7417837,7417828,'443',3.333,4),(78,7417838,7417828,'430',3.333,4),(78,7417839,7417828,'307',3.333,4),(78,7417840,7417828,'075',3.333,4),(78,7417841,7417828,'753',3.333,4),(78,7417842,7417828,'535',3.333,4),(78,7417843,7417828,'357',3.333,4),(78,7417844,7417828,'573',3.333,4),(78,7417845,7417828,'732',3.333,4),(78,7417846,7417828,'32b',3.333,4),(78,7417847,7417828,'2b3',3.333,4),(78,7417848,7417828,'b33',3.333,4),(78,7417849,7417828,'334',3.333,4),(78,7417850,7417828,'345',3.333,4),(78,7417851,7417828,'457',3.333,4),(78,7417852,7417828,'571',3.333,4),(78,7417853,7417828,'715',3.333,4),(78,7417854,7417828,'153',3.333,4),(78,7417855,7417828,'533',3.333,4),(78,7417856,7417828,'336',3.333,4),(78,7417857,7417828,'364',3.333,4),(78,7417858,7417828,'646',3.333,4),(78,7417859,7417829,'ser',25,1),(78,7417860,7417829,'eri',25,1),(78,7417861,7417829,'ria',25,1),(78,7417862,7417829,'ial',25,1),(78,7417863,7417859,'siz',50,1),(78,7417864,7417859,'ize',50,1),(78,7417865,7417863,'321',100,1),(78,7417866,7417865,'dev',25,1),(78,7417867,7417865,'evi',25,1),(78,7417868,7417865,'vic',25,1),(78,7417869,7417865,'ice',25,1),(78,7417870,7417866,'typ',50,1),(78,7417871,7417866,'ype',50,1),(78,7417872,7417870,'dir',10,1),(78,7417873,7417870,'ire',10,1),(78,7417874,7417870,'rec',10,1),(78,7417875,7417870,'ect',10,1),(78,7417876,7417870,'cta',10,1),(78,7417877,7417870,'tac',10,1),(78,7417878,7417870,'acc',10,1),(78,7417879,7417870,'cce',10,1),(78,7417880,7417870,'ces',10,1),(78,7417881,7417870,'ess',10,1),(78,7417882,7417872,'mul',14.286,1),(78,7417883,7417872,'ult',14.286,1),(78,7417884,7417872,'lti',14.286,1),(78,7417885,7417872,'tip',14.286,1),(78,7417886,7417872,'ipa',14.286,1),(78,7417887,7417872,'pat',14.286,1),(78,7417888,7417872,'ath',14.286,1),(78,7417889,7417882,'plu',25,1),(78,7417890,7417882,'lug',25,1),(78,7417891,7417882,'ugi',25,1),(78,7417892,7417882,'gin',25,1),(78,7417893,7417889,'nmp',100,1),(78,7417894,7417893,'dev',33.333,1),(78,7417895,7417893,'evf',33.333,1),(78,7417896,7417893,'vfs',33.333,1),(78,7417897,7417894,'pat',50,1),(78,7417898,7417894,'ath',50,1),(78,7417899,7417897,'vmf',50,1),(78,7417900,7417897,'mfs',50,1),(78,7417901,7417899,'dev',20,1),(78,7417902,7417899,'evi',20,1),(78,7417903,7417899,'vic',20,1),(78,7417904,7417899,'ice',20,1),(78,7417905,7417899,'ces',20,1),(78,7417906,7417901,'dis',33.333,1),(78,7417907,7417901,'isk',33.333,1),(78,7417908,7417901,'sks',33.333,1),(78,7417909,7417906,'ven',25,1),(78,7417910,7417906,'end',25,1),(78,7417911,7417906,'ndo',25,1),(78,7417912,7417906,'dor',25,1),(78,7417913,7417909,'mod',33.333,1),(78,7417914,7417909,'ode',33.333,1),(78,7417915,7417909,'del',33.333,1),(78,7417916,7417913,'lun',100,1),(78,7417917,7417916,'cmo',33.333,1),(78,7417918,7417916,'mod',33.333,1),(78,7417919,7417916,'ode',33.333,1),(78,7417920,7417917,'rev',16.667,1),(78,7417921,7417917,'evi',16.667,1),(78,7417922,7417917,'vis',16.667,1),(78,7417923,7417917,'isi',16.667,1),(78,7417924,7417917,'sio',16.667,1),(78,7417925,7417917,'ion',16.667,1),(78,7417926,7417920,'810',50,1),(78,7417927,7417920,'100',50,1),(78,7417928,7417926,'scs',50,1),(78,7417929,7417926,'csi',50,1),(78,7417930,7417928,'lev',33.333,1),(78,7417931,7417928,'eve',33.333,1),(78,7417932,7417928,'vel',33.333,1),(78,7417933,7417930,'pse',25,1),(78,7417934,7417930,'seu',25,1),(78,7417935,7417930,'eud',25,1),(78,7417936,7417930,'udo',25,1),(78,7417937,7417933,'fal',33.333,6),(78,7417938,7417933,'als',33.333,6),(78,7417939,7417933,'lse',33.333,6),(78,7417940,7417937,'sta',25,3),(78,7417941,7417937,'tat',25,3),(78,7417942,7417937,'atu',25,3),(78,7417943,7417937,'tus',25,3),(78,7417944,7417940,'rdm',100,1),(78,7417945,7417944,'cap',20,1),(78,7417946,7417944,'apa',20,1),(78,7417947,7417944,'pab',20,1),(78,7417948,7417944,'abl',20,1),(78,7417949,7417944,'ble',20,1),(78,7417950,7417945,'tru',50,1),(78,7417951,7417945,'rue',50,1),(78,7417952,7417950,'loc',33.333,1),(78,7417953,7417950,'oca',33.333,1),(78,7417954,7417950,'cal',33.333,1),(78,7417955,7417952,'rem',14.286,1),(78,7417956,7417952,'emo',14.286,1),(78,7417957,7417952,'mov',14.286,1),(78,7417958,7417952,'ova',14.286,1),(78,7417959,7417952,'vab',14.286,1),(78,7417960,7417952,'abl',14.286,1),(78,7417961,7417952,'ble',14.286,1),(78,7417962,7417955,'ssd',100,1),(78,7417963,7417962,'off',20,1),(78,7417964,7417962,'ffl',20,1),(78,7417965,7417962,'fli',20,1),(78,7417966,7417962,'lin',20,1),(78,7417967,7417962,'ine',20,1),(78,7417968,7417963,'per',11.111,1),(78,7417969,7417963,'ere',11.111,1),(78,7417970,7417963,'ren',11.111,1),(78,7417971,7417963,'enn',11.111,1),(78,7417972,7417963,'nni',11.111,1),(78,7417973,7417963,'nia',11.111,1),(78,7417974,7417963,'ial',11.111,1),(78,7417975,7417963,'all',11.111,1),(78,7417976,7417963,'lly',11.111,1),(78,7417977,7417968,'res',16.667,1),(78,7417978,7417968,'ese',16.667,1),(78,7417979,7417968,'ser',16.667,1),(78,7417980,7417968,'erv',16.667,1),(78,7417981,7417968,'rve',16.667,1),(78,7417982,7417968,'ved',16.667,1),(78,7417983,7417977,'thi',50,1),(78,7417984,7417977,'hin',50,1),(78,7417985,7417983,'pro',10,1),(78,7417986,7417983,'rov',10,1),(78,7417987,7417983,'ovi',10,1),(78,7417988,7417983,'vis',10,1),(78,7417989,7417983,'isi',10,1),(78,7417990,7417983,'sio',10,1),(78,7417991,7417983,'ion',10,1),(78,7417992,7417983,'oni',10,1),(78,7417993,7417983,'nin',10,1),(78,7417994,7417983,'ing',10,1),(78,7417995,7417985,'yes',100,1),(78,7417996,7417995,'att',16.667,1),(78,7417997,7417995,'tta',16.667,1),(78,7417998,7417995,'tac',16.667,1),(78,7417999,7417995,'ach',16.667,1),(78,7418000,7417995,'che',16.667,1),(78,7418001,7417995,'hed',16.667,1),(78,7418002,7417996,'fil',20,1),(78,7418003,7417996,'ilt',20,1),(78,7418004,7417996,'lte',20,1),(78,7418005,7417996,'ter',20,1),(78,7418006,7417996,'ers',20,1),(78,7418007,7418002,'vaa',50,1),(78,7418008,7418002,'aai',50,1),(78,7418009,7418007,'unk',20,1),(78,7418010,7418007,'nkn',20,1),(78,7418011,7418007,'kno',20,1),(78,7418012,7418007,'now',20,1),(78,7418013,7418007,'own',20,1),(78,7418014,7418009,'oth',33.333,1),(78,7418015,7418009,'the',33.333,1),(78,7418016,7418009,'her',33.333,1),(78,7418017,7418014,'uid',50,1),(78,7418018,7418014,'ids',50,1),(78,7418019,7418017,'vml',100,1),(78,7418020,7418019,'dis',20,1),(78,7418021,7418019,'isp',20,1),(78,7418022,7418019,'spl',20,1),(78,7418023,7418019,'pla',20,1),(78,7418024,7418019,'lay',20,1),(78,7418025,7418020,'nam',50,1),(78,7418026,7418020,'ame',50,1),(79,7418028,7418027,'net',25,3),(79,7418029,7418027,'eta',25,3),(79,7418030,7418027,'tap',25,3),(79,7418031,7418027,'app',25,3),(79,7418032,7418028,'fib',33.333,2),(79,7418033,7418028,'ibr',33.333,2),(79,7418034,7418028,'bre',33.333,2),(79,7418035,7418032,'cha',20,2),(79,7418036,7418032,'han',20,2),(79,7418037,7418032,'ann',20,2),(79,7418038,7418032,'nne',20,2),(79,7418039,7418032,'nel',20,2),(79,7418040,7418035,'dis',50,2),(79,7418041,7418035,'isk',50,2),(79,7418042,7418040,'naa',100,4),(79,7418043,7418042,'600',3.333,4),(79,7418044,7418042,'00a',3.333,4),(79,7418045,7418042,'0a0',3.333,4),(79,7418046,7418042,'a09',3.333,4),(79,7418047,7418042,'098',3.333,4),(79,7418048,7418042,'980',3.333,4),(79,7418049,7418042,'804',3.333,4),(79,7418050,7418042,'044',3.333,4),(79,7418051,7418042,'443',3.333,4),(79,7418052,7418042,'430',3.333,4),(79,7418053,7418042,'307',3.333,4),(79,7418054,7418042,'075',3.333,4),(79,7418055,7418042,'753',3.333,4),(79,7418056,7418042,'535',3.333,4),(79,7418057,7418042,'357',3.333,4),(79,7418058,7418042,'573',3.333,4),(79,7418059,7418042,'732',3.333,4),(79,7418060,7418042,'32b',3.333,4),(79,7418061,7418042,'2b3',3.333,4),(79,7418062,7418042,'b33',3.333,4),(79,7418063,7418042,'334',3.333,4),(79,7418064,7418042,'345',3.333,4),(79,7418065,7418042,'457',3.333,4),(79,7418066,7418042,'571',3.333,4),(79,7418067,7418042,'715',3.333,4),(79,7418068,7418042,'153',3.333,4),(79,7418069,7418042,'533',3.333,4),(79,7418070,7418042,'336',3.333,4),(79,7418071,7418042,'364',3.333,4),(79,7418072,7418042,'647',3.333,4),(79,7418073,7418043,'ser',25,1),(79,7418074,7418043,'eri',25,1),(79,7418075,7418043,'ria',25,1),(79,7418076,7418043,'ial',25,1),(79,7418077,7418073,'siz',50,1),(79,7418078,7418073,'ize',50,1),(79,7418079,7418077,'321',100,1),(79,7418080,7418079,'dev',25,1),(79,7418081,7418079,'evi',25,1),(79,7418082,7418079,'vic',25,1),(79,7418083,7418079,'ice',25,1),(79,7418084,7418080,'typ',50,1),(79,7418085,7418080,'ype',50,1),(79,7418086,7418084,'dir',10,1),(79,7418087,7418084,'ire',10,1),(79,7418088,7418084,'rec',10,1),(79,7418089,7418084,'ect',10,1),(79,7418090,7418084,'cta',10,1),(79,7418091,7418084,'tac',10,1),(79,7418092,7418084,'acc',10,1),(79,7418093,7418084,'cce',10,1),(79,7418094,7418084,'ces',10,1),(79,7418095,7418084,'ess',10,1),(79,7418096,7418086,'mul',14.286,1),(79,7418097,7418086,'ult',14.286,1),(79,7418098,7418086,'lti',14.286,1),(79,7418099,7418086,'tip',14.286,1),(79,7418100,7418086,'ipa',14.286,1),(79,7418101,7418086,'pat',14.286,1),(79,7418102,7418086,'ath',14.286,1),(79,7418103,7418096,'plu',25,1),(79,7418104,7418096,'lug',25,1),(79,7418105,7418096,'ugi',25,1),(79,7418106,7418096,'gin',25,1),(79,7418107,7418103,'nmp',100,1),(79,7418108,7418107,'dev',33.333,1),(79,7418109,7418107,'evf',33.333,1),(79,7418110,7418107,'vfs',33.333,1),(79,7418111,7418108,'pat',50,1),(79,7418112,7418108,'ath',50,1),(79,7418113,7418111,'vmf',50,1),(79,7418114,7418111,'mfs',50,1),(79,7418115,7418113,'dev',20,1),(79,7418116,7418113,'evi',20,1),(79,7418117,7418113,'vic',20,1),(79,7418118,7418113,'ice',20,1),(79,7418119,7418113,'ces',20,1),(79,7418120,7418115,'dis',33.333,1),(79,7418121,7418115,'isk',33.333,1),(79,7418122,7418115,'sks',33.333,1),(79,7418123,7418120,'ven',25,1),(79,7418124,7418120,'end',25,1),(79,7418125,7418120,'ndo',25,1),(79,7418126,7418120,'dor',25,1),(79,7418127,7418123,'mod',33.333,1),(79,7418128,7418123,'ode',33.333,1),(79,7418129,7418123,'del',33.333,1),(79,7418130,7418127,'lun',100,1),(79,7418131,7418130,'cmo',33.333,1),(79,7418132,7418130,'mod',33.333,1),(79,7418133,7418130,'ode',33.333,1),(79,7418134,7418131,'rev',16.667,1),(79,7418135,7418131,'evi',16.667,1),(79,7418136,7418131,'vis',16.667,1),(79,7418137,7418131,'isi',16.667,1),(79,7418138,7418131,'sio',16.667,1),(79,7418139,7418131,'ion',16.667,1),(79,7418140,7418134,'810',50,1),(79,7418141,7418134,'100',50,1),(79,7418142,7418140,'scs',50,1),(79,7418143,7418140,'csi',50,1),(79,7418144,7418142,'lev',33.333,1),(79,7418145,7418142,'eve',33.333,1),(79,7418146,7418142,'vel',33.333,1),(79,7418147,7418144,'pse',25,1),(79,7418148,7418144,'seu',25,1),(79,7418149,7418144,'eud',25,1),(79,7418150,7418144,'udo',25,1),(79,7418151,7418147,'fal',33.333,6),(79,7418152,7418147,'als',33.333,6),(79,7418153,7418147,'lse',33.333,6),(79,7418154,7418151,'sta',25,3),(79,7418155,7418151,'tat',25,3),(79,7418156,7418151,'atu',25,3),(79,7418157,7418151,'tus',25,3),(79,7418158,7418154,'rdm',100,1),(79,7418159,7418158,'cap',20,1),(79,7418160,7418158,'apa',20,1),(79,7418161,7418158,'pab',20,1),(79,7418162,7418158,'abl',20,1),(79,7418163,7418158,'ble',20,1),(79,7418164,7418159,'tru',50,1),(79,7418165,7418159,'rue',50,1),(79,7418166,7418164,'loc',33.333,1),(79,7418167,7418164,'oca',33.333,1),(79,7418168,7418164,'cal',33.333,1),(79,7418169,7418166,'rem',14.286,1),(79,7418170,7418166,'emo',14.286,1),(79,7418171,7418166,'mov',14.286,1),(79,7418172,7418166,'ova',14.286,1),(79,7418173,7418166,'vab',14.286,1),(79,7418174,7418166,'abl',14.286,1),(79,7418175,7418166,'ble',14.286,1),(79,7418176,7418169,'ssd',100,1),(79,7418177,7418176,'off',20,1),(79,7418178,7418176,'ffl',20,1),(79,7418179,7418176,'fli',20,1),(79,7418180,7418176,'lin',20,1),(79,7418181,7418176,'ine',20,1),(79,7418182,7418177,'per',11.111,1),(79,7418183,7418177,'ere',11.111,1),(79,7418184,7418177,'ren',11.111,1),(79,7418185,7418177,'enn',11.111,1),(79,7418186,7418177,'nni',11.111,1),(79,7418187,7418177,'nia',11.111,1),(79,7418188,7418177,'ial',11.111,1),(79,7418189,7418177,'all',11.111,1),(79,7418190,7418177,'lly',11.111,1),(79,7418191,7418182,'res',16.667,1),(79,7418192,7418182,'ese',16.667,1),(79,7418193,7418182,'ser',16.667,1),(79,7418194,7418182,'erv',16.667,1),(79,7418195,7418182,'rve',16.667,1),(79,7418196,7418182,'ved',16.667,1),(79,7418197,7418191,'thi',50,1),(79,7418198,7418191,'hin',50,1),(79,7418199,7418197,'pro',10,1),(79,7418200,7418197,'rov',10,1),(79,7418201,7418197,'ovi',10,1),(79,7418202,7418197,'vis',10,1),(79,7418203,7418197,'isi',10,1),(79,7418204,7418197,'sio',10,1),(79,7418205,7418197,'ion',10,1),(79,7418206,7418197,'oni',10,1),(79,7418207,7418197,'nin',10,1),(79,7418208,7418197,'ing',10,1),(79,7418209,7418199,'yes',100,1),(79,7418210,7418209,'att',16.667,1),(79,7418211,7418209,'tta',16.667,1),(79,7418212,7418209,'tac',16.667,1),(79,7418213,7418209,'ach',16.667,1),(79,7418214,7418209,'che',16.667,1),(79,7418215,7418209,'hed',16.667,1),(79,7418216,7418210,'fil',20,1),(79,7418217,7418210,'ilt',20,1),(79,7418218,7418210,'lte',20,1),(79,7418219,7418210,'ter',20,1),(79,7418220,7418210,'ers',20,1),(79,7418221,7418216,'vaa',50,1),(79,7418222,7418216,'aai',50,1),(79,7418223,7418221,'unk',20,1),(79,7418224,7418221,'nkn',20,1),(79,7418225,7418221,'kno',20,1),(79,7418226,7418221,'now',20,1),(79,7418227,7418221,'own',20,1),(79,7418228,7418223,'oth',33.333,1),(79,7418229,7418223,'the',33.333,1),(79,7418230,7418223,'her',33.333,1),(79,7418231,7418228,'uid',50,1),(79,7418232,7418228,'ids',50,1),(79,7418233,7418231,'vml',100,1),(79,7418234,7418233,'dis',20,1),(79,7418235,7418233,'isp',20,1),(79,7418236,7418233,'spl',20,1),(79,7418237,7418233,'pla',20,1),(79,7418238,7418233,'lay',20,1),(79,7418239,7418234,'nam',50,1),(79,7418240,7418234,'ame',50,1),(80,7418242,7418241,'net',25,3),(80,7418243,7418241,'eta',25,3),(80,7418244,7418241,'tap',25,3),(80,7418245,7418241,'app',25,3),(80,7418246,7418242,'fib',33.333,2),(80,7418247,7418242,'ibr',33.333,2),(80,7418248,7418242,'bre',33.333,2),(80,7418249,7418246,'cha',20,2),(80,7418250,7418246,'han',20,2),(80,7418251,7418246,'ann',20,2),(80,7418252,7418246,'nne',20,2),(80,7418253,7418246,'nel',20,2),(80,7418254,7418249,'dis',50,2),(80,7418255,7418249,'isk',50,2),(80,7418256,7418254,'naa',100,4),(80,7418257,7418256,'600',3.333,4),(80,7418258,7418256,'00a',3.333,4),(80,7418259,7418256,'0a0',3.333,4),(80,7418260,7418256,'a09',3.333,4),(80,7418261,7418256,'098',3.333,4),(80,7418262,7418256,'980',3.333,4),(80,7418263,7418256,'804',3.333,4),(80,7418264,7418256,'044',3.333,4),(80,7418265,7418256,'443',3.333,4),(80,7418266,7418256,'430',3.333,4),(80,7418267,7418256,'307',3.333,4),(80,7418268,7418256,'075',3.333,4),(80,7418269,7418256,'753',3.333,4),(80,7418270,7418256,'535',3.333,4),(80,7418271,7418256,'357',3.333,4),(80,7418272,7418256,'573',3.333,4),(80,7418273,7418256,'732',3.333,4),(80,7418274,7418256,'32b',3.333,4),(80,7418275,7418256,'2b3',3.333,4),(80,7418276,7418256,'b33',3.333,4),(80,7418277,7418256,'334',3.333,4),(80,7418278,7418256,'345',3.333,4),(80,7418279,7418256,'457',3.333,4),(80,7418280,7418256,'571',3.333,4),(80,7418281,7418256,'715',3.333,4),(80,7418282,7418256,'153',3.333,4),(80,7418283,7418256,'533',3.333,4),(80,7418284,7418256,'336',3.333,4),(80,7418285,7418256,'364',3.333,4),(80,7418286,7418256,'648',3.333,4),(80,7418287,7418257,'ser',25,1),(80,7418288,7418257,'eri',25,1),(80,7418289,7418257,'ria',25,1),(80,7418290,7418257,'ial',25,1),(80,7418291,7418287,'siz',50,1),(80,7418292,7418287,'ize',50,1),(80,7418293,7418291,'321',100,1),(80,7418294,7418293,'dev',25,1),(80,7418295,7418293,'evi',25,1),(80,7418296,7418293,'vic',25,1),(80,7418297,7418293,'ice',25,1),(80,7418298,7418294,'typ',50,1),(80,7418299,7418294,'ype',50,1),(80,7418300,7418298,'dir',10,1),(80,7418301,7418298,'ire',10,1),(80,7418302,7418298,'rec',10,1),(80,7418303,7418298,'ect',10,1),(80,7418304,7418298,'cta',10,1),(80,7418305,7418298,'tac',10,1),(80,7418306,7418298,'acc',10,1),(80,7418307,7418298,'cce',10,1),(80,7418308,7418298,'ces',10,1),(80,7418309,7418298,'ess',10,1),(80,7418310,7418300,'mul',14.286,1),(80,7418311,7418300,'ult',14.286,1),(80,7418312,7418300,'lti',14.286,1),(80,7418313,7418300,'tip',14.286,1),(80,7418314,7418300,'ipa',14.286,1),(80,7418315,7418300,'pat',14.286,1),(80,7418316,7418300,'ath',14.286,1),(80,7418317,7418310,'plu',25,1),(80,7418318,7418310,'lug',25,1),(80,7418319,7418310,'ugi',25,1),(80,7418320,7418310,'gin',25,1),(80,7418321,7418317,'nmp',100,1),(80,7418322,7418321,'dev',33.333,1),(80,7418323,7418321,'evf',33.333,1),(80,7418324,7418321,'vfs',33.333,1),(80,7418325,7418322,'pat',50,1),(80,7418326,7418322,'ath',50,1),(80,7418327,7418325,'vmf',50,1),(80,7418328,7418325,'mfs',50,1),(80,7418329,7418327,'dev',20,1),(80,7418330,7418327,'evi',20,1),(80,7418331,7418327,'vic',20,1),(80,7418332,7418327,'ice',20,1),(80,7418333,7418327,'ces',20,1),(80,7418334,7418329,'dis',33.333,1),(80,7418335,7418329,'isk',33.333,1),(80,7418336,7418329,'sks',33.333,1),(80,7418337,7418334,'ven',25,1),(80,7418338,7418334,'end',25,1),(80,7418339,7418334,'ndo',25,1),(80,7418340,7418334,'dor',25,1),(80,7418341,7418337,'mod',33.333,1),(80,7418342,7418337,'ode',33.333,1),(80,7418343,7418337,'del',33.333,1),(80,7418344,7418341,'lun',100,1),(80,7418345,7418344,'cmo',33.333,1),(80,7418346,7418344,'mod',33.333,1),(80,7418347,7418344,'ode',33.333,1),(80,7418348,7418345,'rev',16.667,1),(80,7418349,7418345,'evi',16.667,1),(80,7418350,7418345,'vis',16.667,1),(80,7418351,7418345,'isi',16.667,1),(80,7418352,7418345,'sio',16.667,1),(80,7418353,7418345,'ion',16.667,1),(80,7418354,7418348,'810',50,1),(80,7418355,7418348,'100',50,1),(80,7418356,7418354,'scs',50,1),(80,7418357,7418354,'csi',50,1),(80,7418358,7418356,'lev',33.333,1),(80,7418359,7418356,'eve',33.333,1),(80,7418360,7418356,'vel',33.333,1),(80,7418361,7418358,'pse',25,1),(80,7418362,7418358,'seu',25,1),(80,7418363,7418358,'eud',25,1),(80,7418364,7418358,'udo',25,1),(80,7418365,7418361,'fal',33.333,6),(80,7418366,7418361,'als',33.333,6),(80,7418367,7418361,'lse',33.333,6),(80,7418368,7418365,'sta',25,3),(80,7418369,7418365,'tat',25,3),(80,7418370,7418365,'atu',25,3),(80,7418371,7418365,'tus',25,3),(80,7418372,7418368,'rdm',100,1),(80,7418373,7418372,'cap',20,1),(80,7418374,7418372,'apa',20,1),(80,7418375,7418372,'pab',20,1),(80,7418376,7418372,'abl',20,1),(80,7418377,7418372,'ble',20,1),(80,7418378,7418373,'tru',50,1),(80,7418379,7418373,'rue',50,1),(80,7418380,7418378,'loc',33.333,1),(80,7418381,7418378,'oca',33.333,1),(80,7418382,7418378,'cal',33.333,1),(80,7418383,7418380,'rem',14.286,1),(80,7418384,7418380,'emo',14.286,1),(80,7418385,7418380,'mov',14.286,1),(80,7418386,7418380,'ova',14.286,1),(80,7418387,7418380,'vab',14.286,1),(80,7418388,7418380,'abl',14.286,1),(80,7418389,7418380,'ble',14.286,1),(80,7418390,7418383,'ssd',100,1),(80,7418391,7418390,'off',20,1),(80,7418392,7418390,'ffl',20,1),(80,7418393,7418390,'fli',20,1),(80,7418394,7418390,'lin',20,1),(80,7418395,7418390,'ine',20,1),(80,7418396,7418391,'per',11.111,1),(80,7418397,7418391,'ere',11.111,1),(80,7418398,7418391,'ren',11.111,1),(80,7418399,7418391,'enn',11.111,1),(80,7418400,7418391,'nni',11.111,1),(80,7418401,7418391,'nia',11.111,1),(80,7418402,7418391,'ial',11.111,1),(80,7418403,7418391,'all',11.111,1),(80,7418404,7418391,'lly',11.111,1),(80,7418405,7418396,'res',16.667,1),(80,7418406,7418396,'ese',16.667,1),(80,7418407,7418396,'ser',16.667,1),(80,7418408,7418396,'erv',16.667,1),(80,7418409,7418396,'rve',16.667,1),(80,7418410,7418396,'ved',16.667,1),(80,7418411,7418405,'thi',50,1),(80,7418412,7418405,'hin',50,1),(80,7418413,7418411,'pro',10,1),(80,7418414,7418411,'rov',10,1),(80,7418415,7418411,'ovi',10,1),(80,7418416,7418411,'vis',10,1),(80,7418417,7418411,'isi',10,1),(80,7418418,7418411,'sio',10,1),(80,7418419,7418411,'ion',10,1),(80,7418420,7418411,'oni',10,1),(80,7418421,7418411,'nin',10,1),(80,7418422,7418411,'ing',10,1),(80,7418423,7418413,'yes',100,1),(80,7418424,7418423,'att',16.667,1),(80,7418425,7418423,'tta',16.667,1),(80,7418426,7418423,'tac',16.667,1),(80,7418427,7418423,'ach',16.667,1),(80,7418428,7418423,'che',16.667,1),(80,7418429,7418423,'hed',16.667,1),(80,7418430,7418424,'fil',20,1),(80,7418431,7418424,'ilt',20,1),(80,7418432,7418424,'lte',20,1),(80,7418433,7418424,'ter',20,1),(80,7418434,7418424,'ers',20,1),(80,7418435,7418430,'vaa',50,1),(80,7418436,7418430,'aai',50,1),(80,7418437,7418435,'unk',20,1),(80,7418438,7418435,'nkn',20,1),(80,7418439,7418435,'kno',20,1),(80,7418440,7418435,'now',20,1),(80,7418441,7418435,'own',20,1),(80,7418442,7418437,'oth',33.333,1),(80,7418443,7418437,'the',33.333,1),(80,7418444,7418437,'her',33.333,1),(80,7418445,7418442,'uid',50,1),(80,7418446,7418442,'ids',50,1),(80,7418447,7418445,'vml',100,1),(80,7418448,7418447,'dis',20,1),(80,7418449,7418447,'isp',20,1),(80,7418450,7418447,'spl',20,1),(80,7418451,7418447,'pla',20,1),(80,7418452,7418447,'lay',20,1),(80,7418453,7418448,'nam',50,1),(80,7418454,7418448,'ame',50,1),(81,7418456,7418455,'net',25,3),(81,7418457,7418455,'eta',25,3),(81,7418458,7418455,'tap',25,3),(81,7418459,7418455,'app',25,3),(81,7418460,7418456,'fib',33.333,2),(81,7418461,7418456,'ibr',33.333,2),(81,7418462,7418456,'bre',33.333,2),(81,7418463,7418460,'cha',20,2),(81,7418464,7418460,'han',20,2),(81,7418465,7418460,'ann',20,2),(81,7418466,7418460,'nne',20,2),(81,7418467,7418460,'nel',20,2),(81,7418468,7418463,'dis',50,2),(81,7418469,7418463,'isk',50,2),(81,7418470,7418468,'naa',100,4),(81,7418471,7418470,'600',3.333,4),(81,7418472,7418470,'00a',3.333,4),(81,7418473,7418470,'0a0',3.333,4),(81,7418474,7418470,'a09',3.333,4),(81,7418475,7418470,'098',3.333,4),(81,7418476,7418470,'980',3.333,4),(81,7418477,7418470,'804',3.333,4),(81,7418478,7418470,'044',3.333,4),(81,7418479,7418470,'443',3.333,4),(81,7418480,7418470,'430',3.333,4),(81,7418481,7418470,'307',3.333,4),(81,7418482,7418470,'075',3.333,4),(81,7418483,7418470,'753',3.333,4),(81,7418484,7418470,'535',3.333,4),(81,7418485,7418470,'357',3.333,4),(81,7418486,7418470,'573',3.333,4),(81,7418487,7418470,'732',3.333,4),(81,7418488,7418470,'32b',3.333,4),(81,7418489,7418470,'2b3',3.333,4),(81,7418490,7418470,'b33',3.333,4),(81,7418491,7418470,'334',3.333,4),(81,7418492,7418470,'345',3.333,4),(81,7418493,7418470,'457',3.333,4),(81,7418494,7418470,'571',3.333,4),(81,7418495,7418470,'715',3.333,4),(81,7418496,7418470,'153',3.333,4),(81,7418497,7418470,'533',3.333,4),(81,7418498,7418470,'336',3.333,4),(81,7418499,7418470,'364',3.333,4),(81,7418500,7418470,'649',3.333,4),(81,7418501,7418471,'ser',25,1),(81,7418502,7418471,'eri',25,1),(81,7418503,7418471,'ria',25,1),(81,7418504,7418471,'ial',25,1),(81,7418505,7418501,'siz',50,1),(81,7418506,7418501,'ize',50,1),(81,7418507,7418505,'321',100,1),(81,7418508,7418507,'dev',25,1),(81,7418509,7418507,'evi',25,1),(81,7418510,7418507,'vic',25,1),(81,7418511,7418507,'ice',25,1),(81,7418512,7418508,'typ',50,1),(81,7418513,7418508,'ype',50,1),(81,7418514,7418512,'dir',10,1),(81,7418515,7418512,'ire',10,1),(81,7418516,7418512,'rec',10,1),(81,7418517,7418512,'ect',10,1),(81,7418518,7418512,'cta',10,1),(81,7418519,7418512,'tac',10,1),(81,7418520,7418512,'acc',10,1),(81,7418521,7418512,'cce',10,1),(81,7418522,7418512,'ces',10,1),(81,7418523,7418512,'ess',10,1),(81,7418524,7418514,'mul',14.286,1),(81,7418525,7418514,'ult',14.286,1),(81,7418526,7418514,'lti',14.286,1),(81,7418527,7418514,'tip',14.286,1),(81,7418528,7418514,'ipa',14.286,1),(81,7418529,7418514,'pat',14.286,1),(81,7418530,7418514,'ath',14.286,1),(81,7418531,7418524,'plu',25,1),(81,7418532,7418524,'lug',25,1),(81,7418533,7418524,'ugi',25,1),(81,7418534,7418524,'gin',25,1),(81,7418535,7418531,'nmp',100,1),(81,7418536,7418535,'dev',33.333,1),(81,7418537,7418535,'evf',33.333,1),(81,7418538,7418535,'vfs',33.333,1),(81,7418539,7418536,'pat',50,1),(81,7418540,7418536,'ath',50,1),(81,7418541,7418539,'vmf',50,1),(81,7418542,7418539,'mfs',50,1),(81,7418543,7418541,'dev',20,1),(81,7418544,7418541,'evi',20,1),(81,7418545,7418541,'vic',20,1),(81,7418546,7418541,'ice',20,1),(81,7418547,7418541,'ces',20,1),(81,7418548,7418543,'dis',33.333,1),(81,7418549,7418543,'isk',33.333,1),(81,7418550,7418543,'sks',33.333,1),(81,7418551,7418548,'ven',25,1),(81,7418552,7418548,'end',25,1),(81,7418553,7418548,'ndo',25,1),(81,7418554,7418548,'dor',25,1),(81,7418555,7418551,'mod',33.333,1),(81,7418556,7418551,'ode',33.333,1),(81,7418557,7418551,'del',33.333,1),(81,7418558,7418555,'lun',100,1),(81,7418559,7418558,'cmo',33.333,1),(81,7418560,7418558,'mod',33.333,1),(81,7418561,7418558,'ode',33.333,1),(81,7418562,7418559,'rev',16.667,1),(81,7418563,7418559,'evi',16.667,1),(81,7418564,7418559,'vis',16.667,1),(81,7418565,7418559,'isi',16.667,1),(81,7418566,7418559,'sio',16.667,1),(81,7418567,7418559,'ion',16.667,1),(81,7418568,7418562,'810',50,1),(81,7418569,7418562,'100',50,1),(81,7418570,7418568,'scs',50,1),(81,7418571,7418568,'csi',50,1),(81,7418572,7418570,'lev',33.333,1),(81,7418573,7418570,'eve',33.333,1),(81,7418574,7418570,'vel',33.333,1),(81,7418575,7418572,'pse',25,1),(81,7418576,7418572,'seu',25,1),(81,7418577,7418572,'eud',25,1),(81,7418578,7418572,'udo',25,1),(81,7418579,7418575,'fal',33.333,6),(81,7418580,7418575,'als',33.333,6),(81,7418581,7418575,'lse',33.333,6),(81,7418582,7418579,'sta',25,3),(81,7418583,7418579,'tat',25,3),(81,7418584,7418579,'atu',25,3),(81,7418585,7418579,'tus',25,3),(81,7418586,7418582,'rdm',100,1),(81,7418587,7418586,'cap',20,1),(81,7418588,7418586,'apa',20,1),(81,7418589,7418586,'pab',20,1),(81,7418590,7418586,'abl',20,1),(81,7418591,7418586,'ble',20,1),(81,7418592,7418587,'tru',50,1),(81,7418593,7418587,'rue',50,1),(81,7418594,7418592,'loc',33.333,1),(81,7418595,7418592,'oca',33.333,1),(81,7418596,7418592,'cal',33.333,1),(81,7418597,7418594,'rem',14.286,1),(81,7418598,7418594,'emo',14.286,1),(81,7418599,7418594,'mov',14.286,1),(81,7418600,7418594,'ova',14.286,1),(81,7418601,7418594,'vab',14.286,1),(81,7418602,7418594,'abl',14.286,1),(81,7418603,7418594,'ble',14.286,1),(81,7418604,7418597,'ssd',100,1),(81,7418605,7418604,'off',20,1),(81,7418606,7418604,'ffl',20,1),(81,7418607,7418604,'fli',20,1),(81,7418608,7418604,'lin',20,1),(81,7418609,7418604,'ine',20,1),(81,7418610,7418605,'per',11.111,1),(81,7418611,7418605,'ere',11.111,1),(81,7418612,7418605,'ren',11.111,1),(81,7418613,7418605,'enn',11.111,1),(81,7418614,7418605,'nni',11.111,1),(81,7418615,7418605,'nia',11.111,1),(81,7418616,7418605,'ial',11.111,1),(81,7418617,7418605,'all',11.111,1),(81,7418618,7418605,'lly',11.111,1),(81,7418619,7418610,'res',16.667,1),(81,7418620,7418610,'ese',16.667,1),(81,7418621,7418610,'ser',16.667,1),(81,7418622,7418610,'erv',16.667,1),(81,7418623,7418610,'rve',16.667,1),(81,7418624,7418610,'ved',16.667,1),(81,7418625,7418619,'thi',50,1),(81,7418626,7418619,'hin',50,1),(81,7418627,7418625,'pro',10,1),(81,7418628,7418625,'rov',10,1),(81,7418629,7418625,'ovi',10,1),(81,7418630,7418625,'vis',10,1),(81,7418631,7418625,'isi',10,1),(81,7418632,7418625,'sio',10,1),(81,7418633,7418625,'ion',10,1),(81,7418634,7418625,'oni',10,1),(81,7418635,7418625,'nin',10,1),(81,7418636,7418625,'ing',10,1),(81,7418637,7418627,'yes',100,1),(81,7418638,7418637,'att',16.667,1),(81,7418639,7418637,'tta',16.667,1),(81,7418640,7418637,'tac',16.667,1),(81,7418641,7418637,'ach',16.667,1),(81,7418642,7418637,'che',16.667,1),(81,7418643,7418637,'hed',16.667,1),(81,7418644,7418638,'fil',20,1),(81,7418645,7418638,'ilt',20,1),(81,7418646,7418638,'lte',20,1),(81,7418647,7418638,'ter',20,1),(81,7418648,7418638,'ers',20,1),(81,7418649,7418644,'vaa',50,1),(81,7418650,7418644,'aai',50,1),(81,7418651,7418649,'unk',20,1),(81,7418652,7418649,'nkn',20,1),(81,7418653,7418649,'kno',20,1),(81,7418654,7418649,'now',20,1),(81,7418655,7418649,'own',20,1),(81,7418656,7418651,'oth',33.333,1),(81,7418657,7418651,'the',33.333,1),(81,7418658,7418651,'her',33.333,1),(81,7418659,7418656,'uid',50,1),(81,7418660,7418656,'ids',50,1),(81,7418661,7418659,'vml',100,1),(81,7418662,7418661,'dis',20,1),(81,7418663,7418661,'isp',20,1),(81,7418664,7418661,'spl',20,1),(81,7418665,7418661,'pla',20,1),(81,7418666,7418661,'lay',20,1),(81,7418667,7418662,'nam',50,1),(81,7418668,7418662,'ame',50,1),(82,7418670,7418669,'net',25,3),(82,7418671,7418669,'eta',25,3),(82,7418672,7418669,'tap',25,3),(82,7418673,7418669,'app',25,3),(82,7418674,7418670,'ser',25,3),(82,7418675,7418670,'eri',25,3),(82,7418676,7418670,'ria',25,3),(82,7418677,7418670,'ial',25,3),(82,7418678,7418674,'att',16.667,3),(82,7418679,7418674,'tta',16.667,3),(82,7418680,7418674,'tac',16.667,3),(82,7418681,7418674,'ach',16.667,3),(82,7418682,7418674,'che',16.667,3),(82,7418683,7418674,'hed',16.667,3),(82,7418684,7418678,'scs',50,3),(82,7418685,7418678,'csi',50,3),(82,7418686,7418684,'dis',50,2),(82,7418687,7418684,'isk',50,2),(82,7418688,7418686,'naa',100,4),(82,7418689,7418688,'600',3.333,4),(82,7418690,7418688,'00a',3.333,4),(82,7418691,7418688,'0a0',3.333,4),(82,7418692,7418688,'a09',3.333,4),(82,7418693,7418688,'098',3.333,4),(82,7418694,7418688,'980',3.333,4),(82,7418695,7418688,'80d',3.333,4),(82,7418696,7418688,'0db',3.333,4),(82,7418697,7418688,'dba',3.333,4),(82,7418698,7418688,'ba0',3.333,4),(82,7418699,7418688,'a08',3.333,4),(82,7418700,7418688,'084',3.333,4),(82,7418701,7418688,'84e',3.333,4),(82,7418702,7418688,'4ee',3.333,4),(82,7418703,7418688,'eeb',3.333,4),(82,7418704,7418688,'ebc',3.333,4),(82,7418705,7418688,'bc0',3.333,4),(82,7418706,7418688,'c08',3.333,4),(82,7418707,7418688,'084',3.333,4),(82,7418708,7418688,'84b',3.333,4),(82,7418709,7418688,'4b1',3.333,4),(82,7418710,7418688,'b11',3.333,4),(82,7418711,7418688,'117',3.333,4),(82,7418712,7418688,'17b',3.333,4),(82,7418713,7418688,'7b1',3.333,4),(82,7418714,7418688,'b10',3.333,4),(82,7418715,7418688,'10a',3.333,4),(82,7418716,7418688,'0ab',3.333,4),(82,7418717,7418688,'aba',3.333,4),(82,7418718,7418688,'ba2',3.333,4),(82,7418719,7418689,'siz',50,1),(82,7418720,7418689,'ize',50,1),(82,7418721,7418719,'163',33.333,1),(82,7418722,7418719,'638',33.333,1),(82,7418723,7418719,'384',33.333,1),(82,7418724,7418721,'dev',25,1),(82,7418725,7418721,'evi',25,1),(82,7418726,7418721,'vic',25,1),(82,7418727,7418721,'ice',25,1),(82,7418728,7418724,'typ',50,1),(82,7418729,7418724,'ype',50,1),(82,7418730,7418728,'dir',10,1),(82,7418731,7418728,'ire',10,1),(82,7418732,7418728,'rec',10,1),(82,7418733,7418728,'ect',10,1),(82,7418734,7418728,'cta',10,1),(82,7418735,7418728,'tac',10,1),(82,7418736,7418728,'acc',10,1),(82,7418737,7418728,'cce',10,1),(82,7418738,7418728,'ces',10,1),(82,7418739,7418728,'ess',10,1),(82,7418740,7418730,'mul',14.286,1),(82,7418741,7418730,'ult',14.286,1),(82,7418742,7418730,'lti',14.286,1),(82,7418743,7418730,'tip',14.286,1),(82,7418744,7418730,'ipa',14.286,1),(82,7418745,7418730,'pat',14.286,1),(82,7418746,7418730,'ath',14.286,1),(82,7418747,7418740,'plu',25,1),(82,7418748,7418740,'lug',25,1),(82,7418749,7418740,'ugi',25,1),(82,7418750,7418740,'gin',25,1),(82,7418751,7418747,'nmp',100,1),(82,7418752,7418751,'dev',33.333,1),(82,7418753,7418751,'evf',33.333,1),(82,7418754,7418751,'vfs',33.333,1),(82,7418755,7418752,'pat',50,1),(82,7418756,7418752,'ath',50,1),(82,7418757,7418755,'vmf',50,1),(82,7418758,7418755,'mfs',50,1),(82,7418759,7418757,'dev',20,1),(82,7418760,7418757,'evi',20,1),(82,7418761,7418757,'vic',20,1),(82,7418762,7418757,'ice',20,1),(82,7418763,7418757,'ces',20,1),(82,7418764,7418759,'dis',33.333,1),(82,7418765,7418759,'isk',33.333,1),(82,7418766,7418759,'sks',33.333,1),(82,7418767,7418764,'ven',25,1),(82,7418768,7418764,'end',25,1),(82,7418769,7418764,'ndo',25,1),(82,7418770,7418764,'dor',25,1),(82,7418771,7418767,'mod',33.333,1),(82,7418772,7418767,'ode',33.333,1),(82,7418773,7418767,'del',33.333,1),(82,7418774,7418771,'fla',33.333,1),(82,7418775,7418771,'las',33.333,1),(82,7418776,7418771,'ash',33.333,1),(82,7418777,7418774,'acc',33.333,1),(82,7418778,7418774,'cce',33.333,1),(82,7418779,7418774,'cel',33.333,1),(82,7418780,7418777,'rev',16.667,1),(82,7418781,7418777,'evi',16.667,1),(82,7418782,7418777,'vis',16.667,1),(82,7418783,7418777,'isi',16.667,1),(82,7418784,7418777,'sio',16.667,1),(82,7418785,7418777,'ion',16.667,1),(82,7418786,7418780,'lev',33.333,1),(82,7418787,7418780,'eve',33.333,1),(82,7418788,7418780,'vel',33.333,1),(82,7418789,7418786,'pse',25,1),(82,7418790,7418786,'seu',25,1),(82,7418791,7418786,'eud',25,1),(82,7418792,7418786,'udo',25,1),(82,7418793,7418789,'fal',33.333,5),(82,7418794,7418789,'als',33.333,5),(82,7418795,7418789,'lse',33.333,5),(82,7418796,7418793,'sta',25,3),(82,7418797,7418793,'tat',25,3),(82,7418798,7418793,'atu',25,3),(82,7418799,7418793,'tus',25,3),(82,7418800,7418796,'deg',16.667,1),(82,7418801,7418796,'egr',16.667,1),(82,7418802,7418796,'gra',16.667,1),(82,7418803,7418796,'rad',16.667,1),(82,7418804,7418796,'ade',16.667,1),(82,7418805,7418796,'ded',16.667,1),(82,7418806,7418800,'rdm',100,1),(82,7418807,7418806,'cap',20,1),(82,7418808,7418806,'apa',20,1),(82,7418809,7418806,'pab',20,1),(82,7418810,7418806,'abl',20,1),(82,7418811,7418806,'ble',20,1),(82,7418812,7418807,'tru',50,2),(82,7418813,7418807,'rue',50,2),(82,7418814,7418812,'loc',33.333,1),(82,7418815,7418812,'oca',33.333,1),(82,7418816,7418812,'cal',33.333,1),(82,7418817,7418814,'rem',14.286,1),(82,7418818,7418814,'emo',14.286,1),(82,7418819,7418814,'mov',14.286,1),(82,7418820,7418814,'ova',14.286,1),(82,7418821,7418814,'vab',14.286,1),(82,7418822,7418814,'abl',14.286,1),(82,7418823,7418814,'ble',14.286,1),(82,7418824,7418817,'ssd',100,1),(82,7418825,7418824,'off',20,1),(82,7418826,7418824,'ffl',20,1),(82,7418827,7418824,'fli',20,1),(82,7418828,7418824,'lin',20,1),(82,7418829,7418824,'ine',20,1),(82,7418830,7418825,'per',11.111,1),(82,7418831,7418825,'ere',11.111,1),(82,7418832,7418825,'ren',11.111,1),(82,7418833,7418825,'enn',11.111,1),(82,7418834,7418825,'nni',11.111,1),(82,7418835,7418825,'nia',11.111,1),(82,7418836,7418825,'ial',11.111,1),(82,7418837,7418825,'all',11.111,1),(82,7418838,7418825,'lly',11.111,1),(82,7418839,7418830,'res',16.667,1),(82,7418840,7418830,'ese',16.667,1),(82,7418841,7418830,'ser',16.667,1),(82,7418842,7418830,'erv',16.667,1),(82,7418843,7418830,'rve',16.667,1),(82,7418844,7418830,'ved',16.667,1),(82,7418845,7418839,'thi',50,1),(82,7418846,7418839,'hin',50,1),(82,7418847,7418845,'pro',10,1),(82,7418848,7418845,'rov',10,1),(82,7418849,7418845,'ovi',10,1),(82,7418850,7418845,'vis',10,1),(82,7418851,7418845,'isi',10,1),(82,7418852,7418845,'sio',10,1),(82,7418853,7418845,'ion',10,1),(82,7418854,7418845,'oni',10,1),(82,7418855,7418845,'nin',10,1),(82,7418856,7418845,'ing',10,1),(82,7418857,7418847,'unk',20,1),(82,7418858,7418847,'nkn',20,1),(82,7418859,7418847,'kno',20,1),(82,7418860,7418847,'now',20,1),(82,7418861,7418847,'own',20,1),(82,7418862,7418857,'fil',20,1),(82,7418863,7418857,'ilt',20,1),(82,7418864,7418857,'lte',20,1),(82,7418865,7418857,'ter',20,1),(82,7418866,7418857,'ers',20,1),(82,7418867,7418862,'vaa',50,1),(82,7418868,7418862,'aai',50,1),(82,7418869,7418867,'uns',11.111,1),(82,7418870,7418867,'nsu',11.111,1),(82,7418871,7418867,'sup',11.111,1),(82,7418872,7418867,'upp',11.111,1),(82,7418873,7418867,'ppo',11.111,1),(82,7418874,7418867,'por',11.111,1),(82,7418875,7418867,'ort',11.111,1),(82,7418876,7418867,'rte',11.111,1),(82,7418877,7418867,'ted',11.111,1),(82,7418878,7418869,'oth',33.333,1),(82,7418879,7418869,'the',33.333,1),(82,7418880,7418869,'her',33.333,1),(82,7418881,7418878,'uid',50,1),(82,7418882,7418878,'ids',50,1),(82,7418883,7418881,'vml',100,1),(82,7418884,7418883,'dis',20,1),(82,7418885,7418883,'isp',20,1),(82,7418886,7418883,'spl',20,1),(82,7418887,7418883,'pla',20,1),(82,7418888,7418883,'lay',20,1),(82,7418889,7418884,'nam',50,1),(82,7418890,7418884,'ame',50,1),(83,7418892,7418891,'net',25,3),(83,7418893,7418891,'eta',25,3),(83,7418894,7418891,'tap',25,3),(83,7418895,7418891,'app',25,3),(83,7418896,7418892,'fib',33.333,2),(83,7418897,7418892,'ibr',33.333,2),(83,7418898,7418892,'bre',33.333,2),(83,7418899,7418896,'cha',20,2),(83,7418900,7418896,'han',20,2),(83,7418901,7418896,'ann',20,2),(83,7418902,7418896,'nne',20,2),(83,7418903,7418896,'nel',20,2),(83,7418904,7418899,'dis',50,2),(83,7418905,7418899,'isk',50,2),(83,7418906,7418904,'naa',100,4),(83,7418907,7418906,'600',3.333,4),(83,7418908,7418906,'00a',3.333,4),(83,7418909,7418906,'0a0',3.333,4),(83,7418910,7418906,'a09',3.333,4),(83,7418911,7418906,'098',3.333,4),(83,7418912,7418906,'980',3.333,4),(83,7418913,7418906,'804',3.333,4),(83,7418914,7418906,'044',3.333,4),(83,7418915,7418906,'443',3.333,4),(83,7418916,7418906,'430',3.333,4),(83,7418917,7418906,'307',3.333,4),(83,7418918,7418906,'075',3.333,4),(83,7418919,7418906,'753',3.333,4),(83,7418920,7418906,'535',3.333,4),(83,7418921,7418906,'357',3.333,4),(83,7418922,7418906,'573',3.333,4),(83,7418923,7418906,'732',3.333,4),(83,7418924,7418906,'32b',3.333,4),(83,7418925,7418906,'2b3',3.333,4),(83,7418926,7418906,'b33',3.333,4),(83,7418927,7418906,'334',3.333,4),(83,7418928,7418906,'345',3.333,4),(83,7418929,7418906,'457',3.333,4),(83,7418930,7418906,'571',3.333,4),(83,7418931,7418906,'715',3.333,4),(83,7418932,7418906,'153',3.333,4),(83,7418933,7418906,'533',3.333,4),(83,7418934,7418906,'335',3.333,4),(83,7418935,7418906,'356',3.333,4),(83,7418936,7418906,'56a',3.333,4),(83,7418937,7418907,'ser',25,1),(83,7418938,7418907,'eri',25,1),(83,7418939,7418907,'ria',25,1),(83,7418940,7418907,'ial',25,1),(83,7418941,7418937,'siz',50,1),(83,7418942,7418937,'ize',50,1),(83,7418943,7418941,'460',33.333,1),(83,7418944,7418941,'608',33.333,1),(83,7418945,7418941,'080',33.333,1),(83,7418946,7418943,'dev',25,1),(83,7418947,7418943,'evi',25,1),(83,7418948,7418943,'vic',25,1),(83,7418949,7418943,'ice',25,1),(83,7418950,7418946,'typ',50,1),(83,7418951,7418946,'ype',50,1),(83,7418952,7418950,'dir',10,1),(83,7418953,7418950,'ire',10,1),(83,7418954,7418950,'rec',10,1),(83,7418955,7418950,'ect',10,1),(83,7418956,7418950,'cta',10,1),(83,7418957,7418950,'tac',10,1),(83,7418958,7418950,'acc',10,1),(83,7418959,7418950,'cce',10,1),(83,7418960,7418950,'ces',10,1),(83,7418961,7418950,'ess',10,1),(83,7418962,7418952,'mul',14.286,1),(83,7418963,7418952,'ult',14.286,1),(83,7418964,7418952,'lti',14.286,1),(83,7418965,7418952,'tip',14.286,1),(83,7418966,7418952,'ipa',14.286,1),(83,7418967,7418952,'pat',14.286,1),(83,7418968,7418952,'ath',14.286,1),(83,7418969,7418962,'plu',25,1),(83,7418970,7418962,'lug',25,1),(83,7418971,7418962,'ugi',25,1),(83,7418972,7418962,'gin',25,1),(83,7418973,7418969,'nmp',100,1),(83,7418974,7418973,'dev',33.333,1),(83,7418975,7418973,'evf',33.333,1),(83,7418976,7418973,'vfs',33.333,1),(83,7418977,7418974,'pat',50,1),(83,7418978,7418974,'ath',50,1),(83,7418979,7418977,'vmf',50,1),(83,7418980,7418977,'mfs',50,1),(83,7418981,7418979,'dev',20,1),(83,7418982,7418979,'evi',20,1),(83,7418983,7418979,'vic',20,1),(83,7418984,7418979,'ice',20,1),(83,7418985,7418979,'ces',20,1),(83,7418986,7418981,'dis',33.333,1),(83,7418987,7418981,'isk',33.333,1),(83,7418988,7418981,'sks',33.333,1),(83,7418989,7418986,'ven',25,1),(83,7418990,7418986,'end',25,1),(83,7418991,7418986,'ndo',25,1),(83,7418992,7418986,'dor',25,1),(83,7418993,7418989,'mod',33.333,1),(83,7418994,7418989,'ode',33.333,1),(83,7418995,7418989,'del',33.333,1),(83,7418996,7418993,'lun',100,1),(83,7418997,7418996,'cmo',33.333,1),(83,7418998,7418996,'mod',33.333,1),(83,7418999,7418996,'ode',33.333,1),(83,7419000,7418997,'rev',16.667,1),(83,7419001,7418997,'evi',16.667,1),(83,7419002,7418997,'vis',16.667,1),(83,7419003,7418997,'isi',16.667,1),(83,7419004,7418997,'sio',16.667,1),(83,7419005,7418997,'ion',16.667,1),(83,7419006,7419000,'810',50,1),(83,7419007,7419000,'100',50,1),(83,7419008,7419006,'scs',50,1),(83,7419009,7419006,'csi',50,1),(83,7419010,7419008,'lev',33.333,1),(83,7419011,7419008,'eve',33.333,1),(83,7419012,7419008,'vel',33.333,1),(83,7419013,7419010,'pse',25,1),(83,7419014,7419010,'seu',25,1),(83,7419015,7419010,'eud',25,1),(83,7419016,7419010,'udo',25,1),(83,7419017,7419013,'fal',33.333,6),(83,7419018,7419013,'als',33.333,6),(83,7419019,7419013,'lse',33.333,6),(83,7419020,7419017,'sta',25,3),(83,7419021,7419017,'tat',25,3),(83,7419022,7419017,'atu',25,3),(83,7419023,7419017,'tus',25,3),(83,7419024,7419020,'rdm',100,1),(83,7419025,7419024,'cap',20,1),(83,7419026,7419024,'apa',20,1),(83,7419027,7419024,'pab',20,1),(83,7419028,7419024,'abl',20,1),(83,7419029,7419024,'ble',20,1),(83,7419030,7419025,'tru',50,1),(83,7419031,7419025,'rue',50,1),(83,7419032,7419030,'loc',33.333,1),(83,7419033,7419030,'oca',33.333,1),(83,7419034,7419030,'cal',33.333,1),(83,7419035,7419032,'rem',14.286,1),(83,7419036,7419032,'emo',14.286,1),(83,7419037,7419032,'mov',14.286,1),(83,7419038,7419032,'ova',14.286,1),(83,7419039,7419032,'vab',14.286,1),(83,7419040,7419032,'abl',14.286,1),(83,7419041,7419032,'ble',14.286,1),(83,7419042,7419035,'ssd',100,1),(83,7419043,7419042,'off',20,1),(83,7419044,7419042,'ffl',20,1),(83,7419045,7419042,'fli',20,1),(83,7419046,7419042,'lin',20,1),(83,7419047,7419042,'ine',20,1),(83,7419048,7419043,'per',11.111,1),(83,7419049,7419043,'ere',11.111,1),(83,7419050,7419043,'ren',11.111,1),(83,7419051,7419043,'enn',11.111,1),(83,7419052,7419043,'nni',11.111,1),(83,7419053,7419043,'nia',11.111,1),(83,7419054,7419043,'ial',11.111,1),(83,7419055,7419043,'all',11.111,1),(83,7419056,7419043,'lly',11.111,1),(83,7419057,7419048,'res',16.667,1),(83,7419058,7419048,'ese',16.667,1),(83,7419059,7419048,'ser',16.667,1),(83,7419060,7419048,'erv',16.667,1),(83,7419061,7419048,'rve',16.667,1),(83,7419062,7419048,'ved',16.667,1),(83,7419063,7419057,'thi',50,1),(83,7419064,7419057,'hin',50,1),(83,7419065,7419063,'pro',10,1),(83,7419066,7419063,'rov',10,1),(83,7419067,7419063,'ovi',10,1),(83,7419068,7419063,'vis',10,1),(83,7419069,7419063,'isi',10,1),(83,7419070,7419063,'sio',10,1),(83,7419071,7419063,'ion',10,1),(83,7419072,7419063,'oni',10,1),(83,7419073,7419063,'nin',10,1),(83,7419074,7419063,'ing',10,1),(83,7419075,7419065,'yes',100,1),(83,7419076,7419075,'att',16.667,1),(83,7419077,7419075,'tta',16.667,1),(83,7419078,7419075,'tac',16.667,1),(83,7419079,7419075,'ach',16.667,1),(83,7419080,7419075,'che',16.667,1),(83,7419081,7419075,'hed',16.667,1),(83,7419082,7419076,'fil',20,1),(83,7419083,7419076,'ilt',20,1),(83,7419084,7419076,'lte',20,1),(83,7419085,7419076,'ter',20,1),(83,7419086,7419076,'ers',20,1),(83,7419087,7419082,'vaa',50,1),(83,7419088,7419082,'aai',50,1),(83,7419089,7419087,'unk',20,1),(83,7419090,7419087,'nkn',20,1),(83,7419091,7419087,'kno',20,1),(83,7419092,7419087,'now',20,1),(83,7419093,7419087,'own',20,1),(83,7419094,7419089,'oth',33.333,1),(83,7419095,7419089,'the',33.333,1),(83,7419096,7419089,'her',33.333,1),(83,7419097,7419094,'uid',50,1),(83,7419098,7419094,'ids',50,1),(83,7419099,7419097,'vml',100,1),(83,7419100,7419099,'dis',20,1),(83,7419101,7419099,'isp',20,1),(83,7419102,7419099,'spl',20,1),(83,7419103,7419099,'pla',20,1),(83,7419104,7419099,'lay',20,1),(83,7419105,7419100,'nam',50,1),(83,7419106,7419100,'ame',50,1),(84,7419108,7419107,'net',25,3),(84,7419109,7419107,'eta',25,3),(84,7419110,7419107,'tap',25,3),(84,7419111,7419107,'app',25,3),(84,7419112,7419108,'ser',25,3),(84,7419113,7419108,'eri',25,3),(84,7419114,7419108,'ria',25,3),(84,7419115,7419108,'ial',25,3),(84,7419116,7419112,'att',16.667,3),(84,7419117,7419112,'tta',16.667,3),(84,7419118,7419112,'tac',16.667,3),(84,7419119,7419112,'ach',16.667,3),(84,7419120,7419112,'che',16.667,3),(84,7419121,7419112,'hed',16.667,3),(84,7419122,7419116,'scs',50,3),(84,7419123,7419116,'csi',50,3),(84,7419124,7419122,'dis',50,2),(84,7419125,7419122,'isk',50,2),(84,7419126,7419124,'naa',100,4),(84,7419127,7419126,'600',3.333,4),(84,7419128,7419126,'00a',3.333,4),(84,7419129,7419126,'0a0',3.333,4),(84,7419130,7419126,'a09',3.333,4),(84,7419131,7419126,'098',3.333,4),(84,7419132,7419126,'980',3.333,4),(84,7419133,7419126,'803',3.333,4),(84,7419134,7419126,'034',3.333,4),(84,7419135,7419126,'34a',3.333,4),(84,7419136,7419126,'4a4',3.333,4),(84,7419137,7419126,'a48',3.333,4),(84,7419138,7419126,'484',3.333,4),(84,7419139,7419126,'84e',3.333,4),(84,7419140,7419126,'4ee',3.333,4),(84,7419141,7419126,'ee5',3.333,4),(84,7419142,7419126,'e5c',3.333,4),(84,7419143,7419126,'5ca',3.333,4),(84,7419144,7419126,'ca9',3.333,4),(84,7419145,7419126,'a94',3.333,4),(84,7419146,7419126,'94a',3.333,4),(84,7419147,7419126,'4a1',3.333,4),(84,7419148,7419126,'a11',3.333,4),(84,7419149,7419126,'117',3.333,4),(84,7419150,7419126,'17b',3.333,4),(84,7419151,7419126,'7b1',3.333,4),(84,7419152,7419126,'b11',3.333,4),(84,7419153,7419126,'11a',3.333,4),(84,7419154,7419126,'1ab',3.333,4),(84,7419155,7419126,'aba',3.333,4),(84,7419156,7419126,'ba2',3.333,4),(84,7419157,7419127,'siz',50,1),(84,7419158,7419127,'ize',50,1),(84,7419159,7419157,'163',33.333,1),(84,7419160,7419157,'638',33.333,1),(84,7419161,7419157,'384',33.333,1),(84,7419162,7419159,'dev',25,1),(84,7419163,7419159,'evi',25,1),(84,7419164,7419159,'vic',25,1),(84,7419165,7419159,'ice',25,1),(84,7419166,7419162,'typ',50,1),(84,7419167,7419162,'ype',50,1),(84,7419168,7419166,'dir',10,1),(84,7419169,7419166,'ire',10,1),(84,7419170,7419166,'rec',10,1),(84,7419171,7419166,'ect',10,1),(84,7419172,7419166,'cta',10,1),(84,7419173,7419166,'tac',10,1),(84,7419174,7419166,'acc',10,1),(84,7419175,7419166,'cce',10,1),(84,7419176,7419166,'ces',10,1),(84,7419177,7419166,'ess',10,1),(84,7419178,7419168,'mul',14.286,1),(84,7419179,7419168,'ult',14.286,1),(84,7419180,7419168,'lti',14.286,1),(84,7419181,7419168,'tip',14.286,1),(84,7419182,7419168,'ipa',14.286,1),(84,7419183,7419168,'pat',14.286,1),(84,7419184,7419168,'ath',14.286,1),(84,7419185,7419178,'plu',25,1),(84,7419186,7419178,'lug',25,1),(84,7419187,7419178,'ugi',25,1),(84,7419188,7419178,'gin',25,1),(84,7419189,7419185,'nmp',100,1),(84,7419190,7419189,'dev',33.333,1),(84,7419191,7419189,'evf',33.333,1),(84,7419192,7419189,'vfs',33.333,1),(84,7419193,7419190,'pat',50,1),(84,7419194,7419190,'ath',50,1),(84,7419195,7419193,'vmf',50,1),(84,7419196,7419193,'mfs',50,1),(84,7419197,7419195,'dev',20,1),(84,7419198,7419195,'evi',20,1),(84,7419199,7419195,'vic',20,1),(84,7419200,7419195,'ice',20,1),(84,7419201,7419195,'ces',20,1),(84,7419202,7419197,'dis',33.333,1),(84,7419203,7419197,'isk',33.333,1),(84,7419204,7419197,'sks',33.333,1),(84,7419205,7419202,'ven',25,1),(84,7419206,7419202,'end',25,1),(84,7419207,7419202,'ndo',25,1),(84,7419208,7419202,'dor',25,1),(84,7419209,7419205,'mod',33.333,1),(84,7419210,7419205,'ode',33.333,1),(84,7419211,7419205,'del',33.333,1),(84,7419212,7419209,'fla',33.333,1),(84,7419213,7419209,'las',33.333,1),(84,7419214,7419209,'ash',33.333,1),(84,7419215,7419212,'acc',33.333,1),(84,7419216,7419212,'cce',33.333,1),(84,7419217,7419212,'cel',33.333,1),(84,7419218,7419215,'rev',16.667,1),(84,7419219,7419215,'evi',16.667,1),(84,7419220,7419215,'vis',16.667,1),(84,7419221,7419215,'isi',16.667,1),(84,7419222,7419215,'sio',16.667,1),(84,7419223,7419215,'ion',16.667,1),(84,7419224,7419218,'lev',33.333,1),(84,7419225,7419218,'eve',33.333,1),(84,7419226,7419218,'vel',33.333,1),(84,7419227,7419224,'pse',25,1),(84,7419228,7419224,'seu',25,1),(84,7419229,7419224,'eud',25,1),(84,7419230,7419224,'udo',25,1),(84,7419231,7419227,'fal',33.333,5),(84,7419232,7419227,'als',33.333,5),(84,7419233,7419227,'lse',33.333,5),(84,7419234,7419231,'sta',25,3),(84,7419235,7419231,'tat',25,3),(84,7419236,7419231,'atu',25,3),(84,7419237,7419231,'tus',25,3),(84,7419238,7419234,'deg',16.667,1),(84,7419239,7419234,'egr',16.667,1),(84,7419240,7419234,'gra',16.667,1),(84,7419241,7419234,'rad',16.667,1),(84,7419242,7419234,'ade',16.667,1),(84,7419243,7419234,'ded',16.667,1),(84,7419244,7419238,'rdm',100,1),(84,7419245,7419244,'cap',20,1),(84,7419246,7419244,'apa',20,1),(84,7419247,7419244,'pab',20,1),(84,7419248,7419244,'abl',20,1),(84,7419249,7419244,'ble',20,1),(84,7419250,7419245,'tru',50,2),(84,7419251,7419245,'rue',50,2),(84,7419252,7419250,'loc',33.333,1),(84,7419253,7419250,'oca',33.333,1),(84,7419254,7419250,'cal',33.333,1),(84,7419255,7419252,'rem',14.286,1),(84,7419256,7419252,'emo',14.286,1),(84,7419257,7419252,'mov',14.286,1),(84,7419258,7419252,'ova',14.286,1),(84,7419259,7419252,'vab',14.286,1),(84,7419260,7419252,'abl',14.286,1),(84,7419261,7419252,'ble',14.286,1),(84,7419262,7419255,'ssd',100,1),(84,7419263,7419262,'off',20,1),(84,7419264,7419262,'ffl',20,1),(84,7419265,7419262,'fli',20,1),(84,7419266,7419262,'lin',20,1),(84,7419267,7419262,'ine',20,1),(84,7419268,7419263,'per',11.111,1),(84,7419269,7419263,'ere',11.111,1),(84,7419270,7419263,'ren',11.111,1),(84,7419271,7419263,'enn',11.111,1),(84,7419272,7419263,'nni',11.111,1),(84,7419273,7419263,'nia',11.111,1),(84,7419274,7419263,'ial',11.111,1),(84,7419275,7419263,'all',11.111,1),(84,7419276,7419263,'lly',11.111,1),(84,7419277,7419268,'res',16.667,1),(84,7419278,7419268,'ese',16.667,1),(84,7419279,7419268,'ser',16.667,1),(84,7419280,7419268,'erv',16.667,1),(84,7419281,7419268,'rve',16.667,1),(84,7419282,7419268,'ved',16.667,1),(84,7419283,7419277,'thi',50,1),(84,7419284,7419277,'hin',50,1),(84,7419285,7419283,'pro',10,1),(84,7419286,7419283,'rov',10,1),(84,7419287,7419283,'ovi',10,1),(84,7419288,7419283,'vis',10,1),(84,7419289,7419283,'isi',10,1),(84,7419290,7419283,'sio',10,1),(84,7419291,7419283,'ion',10,1),(84,7419292,7419283,'oni',10,1),(84,7419293,7419283,'nin',10,1),(84,7419294,7419283,'ing',10,1),(84,7419295,7419285,'unk',20,1),(84,7419296,7419285,'nkn',20,1),(84,7419297,7419285,'kno',20,1),(84,7419298,7419285,'now',20,1),(84,7419299,7419285,'own',20,1),(84,7419300,7419295,'fil',20,1),(84,7419301,7419295,'ilt',20,1),(84,7419302,7419295,'lte',20,1),(84,7419303,7419295,'ter',20,1),(84,7419304,7419295,'ers',20,1),(84,7419305,7419300,'vaa',50,1),(84,7419306,7419300,'aai',50,1),(84,7419307,7419305,'uns',11.111,1),(84,7419308,7419305,'nsu',11.111,1),(84,7419309,7419305,'sup',11.111,1),(84,7419310,7419305,'upp',11.111,1),(84,7419311,7419305,'ppo',11.111,1),(84,7419312,7419305,'por',11.111,1),(84,7419313,7419305,'ort',11.111,1),(84,7419314,7419305,'rte',11.111,1),(84,7419315,7419305,'ted',11.111,1),(84,7419316,7419307,'oth',33.333,1),(84,7419317,7419307,'the',33.333,1),(84,7419318,7419307,'her',33.333,1),(84,7419319,7419316,'uid',50,1),(84,7419320,7419316,'ids',50,1),(84,7419321,7419319,'vml',100,1),(84,7419322,7419321,'dis',20,1),(84,7419323,7419321,'isp',20,1),(84,7419324,7419321,'spl',20,1),(84,7419325,7419321,'pla',20,1),(84,7419326,7419321,'lay',20,1),(84,7419327,7419322,'nam',50,1),(84,7419328,7419322,'ame',50,1),(85,7419330,7419329,'net',25,3),(85,7419331,7419329,'eta',25,3),(85,7419332,7419329,'tap',25,3),(85,7419333,7419329,'app',25,3),(85,7419334,7419330,'fib',33.333,2),(85,7419335,7419330,'ibr',33.333,2),(85,7419336,7419330,'bre',33.333,2),(85,7419337,7419334,'cha',20,2),(85,7419338,7419334,'han',20,2),(85,7419339,7419334,'ann',20,2),(85,7419340,7419334,'nne',20,2),(85,7419341,7419334,'nel',20,2),(85,7419342,7419337,'dis',50,2),(85,7419343,7419337,'isk',50,2),(85,7419344,7419342,'naa',100,4),(85,7419345,7419344,'600',3.333,4),(85,7419346,7419344,'00a',3.333,4),(85,7419347,7419344,'0a0',3.333,4),(85,7419348,7419344,'a09',3.333,4),(85,7419349,7419344,'098',3.333,4),(85,7419350,7419344,'980',3.333,4),(85,7419351,7419344,'804',3.333,4),(85,7419352,7419344,'044',3.333,4),(85,7419353,7419344,'443',3.333,4),(85,7419354,7419344,'430',3.333,4),(85,7419355,7419344,'307',3.333,4),(85,7419356,7419344,'075',3.333,4),(85,7419357,7419344,'753',3.333,4),(85,7419358,7419344,'535',3.333,4),(85,7419359,7419344,'357',3.333,4),(85,7419360,7419344,'573',3.333,4),(85,7419361,7419344,'732',3.333,4),(85,7419362,7419344,'32b',3.333,4),(85,7419363,7419344,'2b3',3.333,4),(85,7419364,7419344,'b33',3.333,4),(85,7419365,7419344,'334',3.333,4),(85,7419366,7419344,'345',3.333,4),(85,7419367,7419344,'457',3.333,4),(85,7419368,7419344,'571',3.333,4),(85,7419369,7419344,'715',3.333,4),(85,7419370,7419344,'153',3.333,4),(85,7419371,7419344,'533',3.333,4),(85,7419372,7419344,'335',3.333,4),(85,7419373,7419344,'356',3.333,4),(85,7419374,7419344,'56b',3.333,4),(85,7419375,7419345,'ser',25,1),(85,7419376,7419345,'eri',25,1),(85,7419377,7419345,'ria',25,1),(85,7419378,7419345,'ial',25,1),(85,7419379,7419375,'siz',50,1),(85,7419380,7419375,'ize',50,1),(85,7419381,7419379,'460',33.333,1),(85,7419382,7419379,'608',33.333,1),(85,7419383,7419379,'080',33.333,1),(85,7419384,7419381,'dev',25,1),(85,7419385,7419381,'evi',25,1),(85,7419386,7419381,'vic',25,1),(85,7419387,7419381,'ice',25,1),(85,7419388,7419384,'typ',50,1),(85,7419389,7419384,'ype',50,1),(85,7419390,7419388,'dir',10,1),(85,7419391,7419388,'ire',10,1),(85,7419392,7419388,'rec',10,1),(85,7419393,7419388,'ect',10,1),(85,7419394,7419388,'cta',10,1),(85,7419395,7419388,'tac',10,1),(85,7419396,7419388,'acc',10,1),(85,7419397,7419388,'cce',10,1),(85,7419398,7419388,'ces',10,1),(85,7419399,7419388,'ess',10,1),(85,7419400,7419390,'mul',14.286,1),(85,7419401,7419390,'ult',14.286,1),(85,7419402,7419390,'lti',14.286,1),(85,7419403,7419390,'tip',14.286,1),(85,7419404,7419390,'ipa',14.286,1),(85,7419405,7419390,'pat',14.286,1),(85,7419406,7419390,'ath',14.286,1),(85,7419407,7419400,'plu',25,1),(85,7419408,7419400,'lug',25,1),(85,7419409,7419400,'ugi',25,1),(85,7419410,7419400,'gin',25,1),(85,7419411,7419407,'nmp',100,1),(85,7419412,7419411,'dev',33.333,1),(85,7419413,7419411,'evf',33.333,1),(85,7419414,7419411,'vfs',33.333,1),(85,7419415,7419412,'pat',50,1),(85,7419416,7419412,'ath',50,1),(85,7419417,7419415,'vmf',50,1),(85,7419418,7419415,'mfs',50,1),(85,7419419,7419417,'dev',20,1),(85,7419420,7419417,'evi',20,1),(85,7419421,7419417,'vic',20,1),(85,7419422,7419417,'ice',20,1),(85,7419423,7419417,'ces',20,1),(85,7419424,7419419,'dis',33.333,1),(85,7419425,7419419,'isk',33.333,1),(85,7419426,7419419,'sks',33.333,1),(85,7419427,7419424,'ven',25,1),(85,7419428,7419424,'end',25,1),(85,7419429,7419424,'ndo',25,1),(85,7419430,7419424,'dor',25,1),(85,7419431,7419427,'mod',33.333,1),(85,7419432,7419427,'ode',33.333,1),(85,7419433,7419427,'del',33.333,1),(85,7419434,7419431,'lun',100,1),(85,7419435,7419434,'cmo',33.333,1),(85,7419436,7419434,'mod',33.333,1),(85,7419437,7419434,'ode',33.333,1),(85,7419438,7419435,'rev',16.667,1),(85,7419439,7419435,'evi',16.667,1),(85,7419440,7419435,'vis',16.667,1),(85,7419441,7419435,'isi',16.667,1),(85,7419442,7419435,'sio',16.667,1),(85,7419443,7419435,'ion',16.667,1),(85,7419444,7419438,'810',50,1),(85,7419445,7419438,'100',50,1),(85,7419446,7419444,'scs',50,1),(85,7419447,7419444,'csi',50,1),(85,7419448,7419446,'lev',33.333,1),(85,7419449,7419446,'eve',33.333,1),(85,7419450,7419446,'vel',33.333,1),(85,7419451,7419448,'pse',25,1),(85,7419452,7419448,'seu',25,1),(85,7419453,7419448,'eud',25,1),(85,7419454,7419448,'udo',25,1),(85,7419455,7419451,'fal',33.333,6),(85,7419456,7419451,'als',33.333,6),(85,7419457,7419451,'lse',33.333,6),(85,7419458,7419455,'sta',25,3),(85,7419459,7419455,'tat',25,3),(85,7419460,7419455,'atu',25,3),(85,7419461,7419455,'tus',25,3),(85,7419462,7419458,'rdm',100,1),(85,7419463,7419462,'cap',20,1),(85,7419464,7419462,'apa',20,1),(85,7419465,7419462,'pab',20,1),(85,7419466,7419462,'abl',20,1),(85,7419467,7419462,'ble',20,1),(85,7419468,7419463,'tru',50,1),(85,7419469,7419463,'rue',50,1),(85,7419470,7419468,'loc',33.333,1),(85,7419471,7419468,'oca',33.333,1),(85,7419472,7419468,'cal',33.333,1),(85,7419473,7419470,'rem',14.286,1),(85,7419474,7419470,'emo',14.286,1),(85,7419475,7419470,'mov',14.286,1),(85,7419476,7419470,'ova',14.286,1),(85,7419477,7419470,'vab',14.286,1),(85,7419478,7419470,'abl',14.286,1),(85,7419479,7419470,'ble',14.286,1),(85,7419480,7419473,'ssd',100,1),(85,7419481,7419480,'off',20,1),(85,7419482,7419480,'ffl',20,1),(85,7419483,7419480,'fli',20,1),(85,7419484,7419480,'lin',20,1),(85,7419485,7419480,'ine',20,1),(85,7419486,7419481,'per',11.111,1),(85,7419487,7419481,'ere',11.111,1),(85,7419488,7419481,'ren',11.111,1),(85,7419489,7419481,'enn',11.111,1),(85,7419490,7419481,'nni',11.111,1),(85,7419491,7419481,'nia',11.111,1),(85,7419492,7419481,'ial',11.111,1),(85,7419493,7419481,'all',11.111,1),(85,7419494,7419481,'lly',11.111,1),(85,7419495,7419486,'res',16.667,1),(85,7419496,7419486,'ese',16.667,1),(85,7419497,7419486,'ser',16.667,1),(85,7419498,7419486,'erv',16.667,1),(85,7419499,7419486,'rve',16.667,1),(85,7419500,7419486,'ved',16.667,1),(85,7419501,7419495,'thi',50,1),(85,7419502,7419495,'hin',50,1),(85,7419503,7419501,'pro',10,1),(85,7419504,7419501,'rov',10,1),(85,7419505,7419501,'ovi',10,1),(85,7419506,7419501,'vis',10,1),(85,7419507,7419501,'isi',10,1),(85,7419508,7419501,'sio',10,1),(85,7419509,7419501,'ion',10,1),(85,7419510,7419501,'oni',10,1),(85,7419511,7419501,'nin',10,1),(85,7419512,7419501,'ing',10,1),(85,7419513,7419503,'yes',100,1),(85,7419514,7419513,'att',16.667,1),(85,7419515,7419513,'tta',16.667,1),(85,7419516,7419513,'tac',16.667,1),(85,7419517,7419513,'ach',16.667,1),(85,7419518,7419513,'che',16.667,1),(85,7419519,7419513,'hed',16.667,1),(85,7419520,7419514,'fil',20,1),(85,7419521,7419514,'ilt',20,1),(85,7419522,7419514,'lte',20,1),(85,7419523,7419514,'ter',20,1),(85,7419524,7419514,'ers',20,1),(85,7419525,7419520,'vaa',50,1),(85,7419526,7419520,'aai',50,1),(85,7419527,7419525,'unk',20,1),(85,7419528,7419525,'nkn',20,1),(85,7419529,7419525,'kno',20,1),(85,7419530,7419525,'now',20,1),(85,7419531,7419525,'own',20,1),(85,7419532,7419527,'oth',33.333,1),(85,7419533,7419527,'the',33.333,1),(85,7419534,7419527,'her',33.333,1),(85,7419535,7419532,'uid',50,1),(85,7419536,7419532,'ids',50,1),(85,7419537,7419535,'vml',100,1),(85,7419538,7419537,'dis',20,1),(85,7419539,7419537,'isp',20,1),(85,7419540,7419537,'spl',20,1),(85,7419541,7419537,'pla',20,1),(85,7419542,7419537,'lay',20,1),(85,7419543,7419538,'nam',50,1),(85,7419544,7419538,'ame',50,1),(86,7419546,7419545,'net',25,3),(86,7419547,7419545,'eta',25,3),(86,7419548,7419545,'tap',25,3),(86,7419549,7419545,'app',25,3),(86,7419550,7419546,'fib',33.333,2),(86,7419551,7419546,'ibr',33.333,2),(86,7419552,7419546,'bre',33.333,2),(86,7419553,7419550,'cha',20,2),(86,7419554,7419550,'han',20,2),(86,7419555,7419550,'ann',20,2),(86,7419556,7419550,'nne',20,2),(86,7419557,7419550,'nel',20,2),(86,7419558,7419553,'dis',50,2),(86,7419559,7419553,'isk',50,2),(86,7419560,7419558,'naa',100,4),(86,7419561,7419560,'600',3.333,4),(86,7419562,7419560,'00a',3.333,4),(86,7419563,7419560,'0a0',3.333,4),(86,7419564,7419560,'a09',3.333,4),(86,7419565,7419560,'098',3.333,4),(86,7419566,7419560,'980',3.333,4),(86,7419567,7419560,'804',3.333,4),(86,7419568,7419560,'044',3.333,4),(86,7419569,7419560,'443',3.333,4),(86,7419570,7419560,'430',3.333,4),(86,7419571,7419560,'307',3.333,4),(86,7419572,7419560,'075',3.333,4),(86,7419573,7419560,'753',3.333,4),(86,7419574,7419560,'535',3.333,4),(86,7419575,7419560,'357',3.333,4),(86,7419576,7419560,'573',3.333,4),(86,7419577,7419560,'732',3.333,4),(86,7419578,7419560,'32b',3.333,4),(86,7419579,7419560,'2b3',3.333,4),(86,7419580,7419560,'b33',3.333,4),(86,7419581,7419560,'334',3.333,4),(86,7419582,7419560,'345',3.333,4),(86,7419583,7419560,'457',3.333,4),(86,7419584,7419560,'571',3.333,4),(86,7419585,7419560,'715',3.333,4),(86,7419586,7419560,'153',3.333,4),(86,7419587,7419560,'533',3.333,4),(86,7419588,7419560,'335',3.333,4),(86,7419589,7419560,'356',3.333,4),(86,7419590,7419560,'56c',3.333,4),(86,7419591,7419561,'ser',25,1),(86,7419592,7419561,'eri',25,1),(86,7419593,7419561,'ria',25,1),(86,7419594,7419561,'ial',25,1),(86,7419595,7419591,'siz',50,1),(86,7419596,7419591,'ize',50,1),(86,7419597,7419595,'460',33.333,1),(86,7419598,7419595,'608',33.333,1),(86,7419599,7419595,'080',33.333,1),(86,7419600,7419597,'dev',25,1),(86,7419601,7419597,'evi',25,1),(86,7419602,7419597,'vic',25,1),(86,7419603,7419597,'ice',25,1),(86,7419604,7419600,'typ',50,1),(86,7419605,7419600,'ype',50,1),(86,7419606,7419604,'dir',10,1),(86,7419607,7419604,'ire',10,1),(86,7419608,7419604,'rec',10,1),(86,7419609,7419604,'ect',10,1),(86,7419610,7419604,'cta',10,1),(86,7419611,7419604,'tac',10,1),(86,7419612,7419604,'acc',10,1),(86,7419613,7419604,'cce',10,1),(86,7419614,7419604,'ces',10,1),(86,7419615,7419604,'ess',10,1),(86,7419616,7419606,'mul',14.286,1),(86,7419617,7419606,'ult',14.286,1),(86,7419618,7419606,'lti',14.286,1),(86,7419619,7419606,'tip',14.286,1),(86,7419620,7419606,'ipa',14.286,1),(86,7419621,7419606,'pat',14.286,1),(86,7419622,7419606,'ath',14.286,1),(86,7419623,7419616,'plu',25,1),(86,7419624,7419616,'lug',25,1),(86,7419625,7419616,'ugi',25,1),(86,7419626,7419616,'gin',25,1),(86,7419627,7419623,'nmp',100,1),(86,7419628,7419627,'dev',33.333,1),(86,7419629,7419627,'evf',33.333,1),(86,7419630,7419627,'vfs',33.333,1),(86,7419631,7419628,'pat',50,1),(86,7419632,7419628,'ath',50,1),(86,7419633,7419631,'vmf',50,1),(86,7419634,7419631,'mfs',50,1),(86,7419635,7419633,'dev',20,1),(86,7419636,7419633,'evi',20,1),(86,7419637,7419633,'vic',20,1),(86,7419638,7419633,'ice',20,1),(86,7419639,7419633,'ces',20,1),(86,7419640,7419635,'dis',33.333,1),(86,7419641,7419635,'isk',33.333,1),(86,7419642,7419635,'sks',33.333,1),(86,7419643,7419640,'ven',25,1),(86,7419644,7419640,'end',25,1),(86,7419645,7419640,'ndo',25,1),(86,7419646,7419640,'dor',25,1),(86,7419647,7419643,'mod',33.333,1),(86,7419648,7419643,'ode',33.333,1),(86,7419649,7419643,'del',33.333,1),(86,7419650,7419647,'lun',100,1),(86,7419651,7419650,'cmo',33.333,1),(86,7419652,7419650,'mod',33.333,1),(86,7419653,7419650,'ode',33.333,1),(86,7419654,7419651,'rev',16.667,1),(86,7419655,7419651,'evi',16.667,1),(86,7419656,7419651,'vis',16.667,1),(86,7419657,7419651,'isi',16.667,1),(86,7419658,7419651,'sio',16.667,1),(86,7419659,7419651,'ion',16.667,1),(86,7419660,7419654,'810',50,1),(86,7419661,7419654,'100',50,1),(86,7419662,7419660,'scs',50,1),(86,7419663,7419660,'csi',50,1),(86,7419664,7419662,'lev',33.333,1),(86,7419665,7419662,'eve',33.333,1),(86,7419666,7419662,'vel',33.333,1),(86,7419667,7419664,'pse',25,1),(86,7419668,7419664,'seu',25,1),(86,7419669,7419664,'eud',25,1),(86,7419670,7419664,'udo',25,1),(86,7419671,7419667,'fal',33.333,6),(86,7419672,7419667,'als',33.333,6),(86,7419673,7419667,'lse',33.333,6),(86,7419674,7419671,'sta',25,3),(86,7419675,7419671,'tat',25,3),(86,7419676,7419671,'atu',25,3),(86,7419677,7419671,'tus',25,3),(86,7419678,7419674,'rdm',100,1),(86,7419679,7419678,'cap',20,1),(86,7419680,7419678,'apa',20,1),(86,7419681,7419678,'pab',20,1),(86,7419682,7419678,'abl',20,1),(86,7419683,7419678,'ble',20,1),(86,7419684,7419679,'tru',50,1),(86,7419685,7419679,'rue',50,1),(86,7419686,7419684,'loc',33.333,1),(86,7419687,7419684,'oca',33.333,1),(86,7419688,7419684,'cal',33.333,1),(86,7419689,7419686,'rem',14.286,1),(86,7419690,7419686,'emo',14.286,1),(86,7419691,7419686,'mov',14.286,1),(86,7419692,7419686,'ova',14.286,1),(86,7419693,7419686,'vab',14.286,1),(86,7419694,7419686,'abl',14.286,1),(86,7419695,7419686,'ble',14.286,1),(86,7419696,7419689,'ssd',100,1),(86,7419697,7419696,'off',20,1),(86,7419698,7419696,'ffl',20,1),(86,7419699,7419696,'fli',20,1),(86,7419700,7419696,'lin',20,1),(86,7419701,7419696,'ine',20,1),(86,7419702,7419697,'per',11.111,1),(86,7419703,7419697,'ere',11.111,1),(86,7419704,7419697,'ren',11.111,1),(86,7419705,7419697,'enn',11.111,1),(86,7419706,7419697,'nni',11.111,1),(86,7419707,7419697,'nia',11.111,1),(86,7419708,7419697,'ial',11.111,1),(86,7419709,7419697,'all',11.111,1),(86,7419710,7419697,'lly',11.111,1),(86,7419711,7419702,'res',16.667,1),(86,7419712,7419702,'ese',16.667,1),(86,7419713,7419702,'ser',16.667,1),(86,7419714,7419702,'erv',16.667,1),(86,7419715,7419702,'rve',16.667,1),(86,7419716,7419702,'ved',16.667,1),(86,7419717,7419711,'thi',50,1),(86,7419718,7419711,'hin',50,1),(86,7419719,7419717,'pro',10,1),(86,7419720,7419717,'rov',10,1),(86,7419721,7419717,'ovi',10,1),(86,7419722,7419717,'vis',10,1),(86,7419723,7419717,'isi',10,1),(86,7419724,7419717,'sio',10,1),(86,7419725,7419717,'ion',10,1),(86,7419726,7419717,'oni',10,1),(86,7419727,7419717,'nin',10,1),(86,7419728,7419717,'ing',10,1),(86,7419729,7419719,'yes',100,1),(86,7419730,7419729,'att',16.667,1),(86,7419731,7419729,'tta',16.667,1),(86,7419732,7419729,'tac',16.667,1),(86,7419733,7419729,'ach',16.667,1),(86,7419734,7419729,'che',16.667,1),(86,7419735,7419729,'hed',16.667,1),(86,7419736,7419730,'fil',20,1),(86,7419737,7419730,'ilt',20,1),(86,7419738,7419730,'lte',20,1),(86,7419739,7419730,'ter',20,1),(86,7419740,7419730,'ers',20,1),(86,7419741,7419736,'vaa',50,1),(86,7419742,7419736,'aai',50,1),(86,7419743,7419741,'unk',20,1),(86,7419744,7419741,'nkn',20,1),(86,7419745,7419741,'kno',20,1),(86,7419746,7419741,'now',20,1),(86,7419747,7419741,'own',20,1),(86,7419748,7419743,'oth',33.333,1),(86,7419749,7419743,'the',33.333,1),(86,7419750,7419743,'her',33.333,1),(86,7419751,7419748,'uid',50,1),(86,7419752,7419748,'ids',50,1),(86,7419753,7419751,'vml',100,1),(86,7419754,7419753,'dis',20,1),(86,7419755,7419753,'isp',20,1),(86,7419756,7419753,'spl',20,1),(86,7419757,7419753,'pla',20,1),(86,7419758,7419753,'lay',20,1),(86,7419759,7419754,'nam',50,1),(86,7419760,7419754,'ame',50,1),(87,7419762,7419761,'net',25,3),(87,7419763,7419761,'eta',25,3),(87,7419764,7419761,'tap',25,3),(87,7419765,7419761,'app',25,3),(87,7419766,7419762,'fib',33.333,2),(87,7419767,7419762,'ibr',33.333,2),(87,7419768,7419762,'bre',33.333,2),(87,7419769,7419766,'cha',20,2),(87,7419770,7419766,'han',20,2),(87,7419771,7419766,'ann',20,2),(87,7419772,7419766,'nne',20,2),(87,7419773,7419766,'nel',20,2),(87,7419774,7419769,'dis',50,2),(87,7419775,7419769,'isk',50,2),(87,7419776,7419774,'naa',100,4),(87,7419777,7419776,'600',3.333,4),(87,7419778,7419776,'00a',3.333,4),(87,7419779,7419776,'0a0',3.333,4),(87,7419780,7419776,'a09',3.333,4),(87,7419781,7419776,'098',3.333,4),(87,7419782,7419776,'980',3.333,4),(87,7419783,7419776,'804',3.333,4),(87,7419784,7419776,'044',3.333,4),(87,7419785,7419776,'443',3.333,4),(87,7419786,7419776,'430',3.333,4),(87,7419787,7419776,'307',3.333,4),(87,7419788,7419776,'075',3.333,4),(87,7419789,7419776,'753',3.333,4),(87,7419790,7419776,'535',3.333,4),(87,7419791,7419776,'357',3.333,4),(87,7419792,7419776,'573',3.333,4),(87,7419793,7419776,'732',3.333,4),(87,7419794,7419776,'32b',3.333,4),(87,7419795,7419776,'2b3',3.333,4),(87,7419796,7419776,'b33',3.333,4),(87,7419797,7419776,'334',3.333,4),(87,7419798,7419776,'345',3.333,4),(87,7419799,7419776,'457',3.333,4),(87,7419800,7419776,'571',3.333,4),(87,7419801,7419776,'715',3.333,4),(87,7419802,7419776,'153',3.333,4),(87,7419803,7419776,'533',3.333,4),(87,7419804,7419776,'335',3.333,4),(87,7419805,7419776,'356',3.333,4),(87,7419806,7419776,'56d',3.333,4),(87,7419807,7419777,'ser',25,1),(87,7419808,7419777,'eri',25,1),(87,7419809,7419777,'ria',25,1),(87,7419810,7419777,'ial',25,1),(87,7419811,7419807,'siz',50,1),(87,7419812,7419807,'ize',50,1),(87,7419813,7419811,'460',33.333,1),(87,7419814,7419811,'608',33.333,1),(87,7419815,7419811,'080',33.333,1),(87,7419816,7419813,'dev',25,1),(87,7419817,7419813,'evi',25,1),(87,7419818,7419813,'vic',25,1),(87,7419819,7419813,'ice',25,1),(87,7419820,7419816,'typ',50,1),(87,7419821,7419816,'ype',50,1),(87,7419822,7419820,'dir',10,1),(87,7419823,7419820,'ire',10,1),(87,7419824,7419820,'rec',10,1),(87,7419825,7419820,'ect',10,1),(87,7419826,7419820,'cta',10,1),(87,7419827,7419820,'tac',10,1),(87,7419828,7419820,'acc',10,1),(87,7419829,7419820,'cce',10,1),(87,7419830,7419820,'ces',10,1),(87,7419831,7419820,'ess',10,1),(87,7419832,7419822,'mul',14.286,1),(87,7419833,7419822,'ult',14.286,1),(87,7419834,7419822,'lti',14.286,1),(87,7419835,7419822,'tip',14.286,1),(87,7419836,7419822,'ipa',14.286,1),(87,7419837,7419822,'pat',14.286,1),(87,7419838,7419822,'ath',14.286,1),(87,7419839,7419832,'plu',25,1),(87,7419840,7419832,'lug',25,1),(87,7419841,7419832,'ugi',25,1),(87,7419842,7419832,'gin',25,1),(87,7419843,7419839,'nmp',100,1),(87,7419844,7419843,'dev',33.333,1),(87,7419845,7419843,'evf',33.333,1),(87,7419846,7419843,'vfs',33.333,1),(87,7419847,7419844,'pat',50,1),(87,7419848,7419844,'ath',50,1),(87,7419849,7419847,'vmf',50,1),(87,7419850,7419847,'mfs',50,1),(87,7419851,7419849,'dev',20,1),(87,7419852,7419849,'evi',20,1),(87,7419853,7419849,'vic',20,1),(87,7419854,7419849,'ice',20,1),(87,7419855,7419849,'ces',20,1),(87,7419856,7419851,'dis',33.333,1),(87,7419857,7419851,'isk',33.333,1),(87,7419858,7419851,'sks',33.333,1),(87,7419859,7419856,'ven',25,1),(87,7419860,7419856,'end',25,1),(87,7419861,7419856,'ndo',25,1),(87,7419862,7419856,'dor',25,1),(87,7419863,7419859,'mod',33.333,1),(87,7419864,7419859,'ode',33.333,1),(87,7419865,7419859,'del',33.333,1),(87,7419866,7419863,'lun',100,1),(87,7419867,7419866,'cmo',33.333,1),(87,7419868,7419866,'mod',33.333,1),(87,7419869,7419866,'ode',33.333,1),(87,7419870,7419867,'rev',16.667,1),(87,7419871,7419867,'evi',16.667,1),(87,7419872,7419867,'vis',16.667,1),(87,7419873,7419867,'isi',16.667,1),(87,7419874,7419867,'sio',16.667,1),(87,7419875,7419867,'ion',16.667,1),(87,7419876,7419870,'810',50,1),(87,7419877,7419870,'100',50,1),(87,7419878,7419876,'scs',50,1),(87,7419879,7419876,'csi',50,1),(87,7419880,7419878,'lev',33.333,1),(87,7419881,7419878,'eve',33.333,1),(87,7419882,7419878,'vel',33.333,1),(87,7419883,7419880,'pse',25,1),(87,7419884,7419880,'seu',25,1),(87,7419885,7419880,'eud',25,1),(87,7419886,7419880,'udo',25,1),(87,7419887,7419883,'fal',33.333,6),(87,7419888,7419883,'als',33.333,6),(87,7419889,7419883,'lse',33.333,6),(87,7419890,7419887,'sta',25,3),(87,7419891,7419887,'tat',25,3),(87,7419892,7419887,'atu',25,3),(87,7419893,7419887,'tus',25,3),(87,7419894,7419890,'rdm',100,1),(87,7419895,7419894,'cap',20,1),(87,7419896,7419894,'apa',20,1),(87,7419897,7419894,'pab',20,1),(87,7419898,7419894,'abl',20,1),(87,7419899,7419894,'ble',20,1),(87,7419900,7419895,'tru',50,1),(87,7419901,7419895,'rue',50,1),(87,7419902,7419900,'loc',33.333,1),(87,7419903,7419900,'oca',33.333,1),(87,7419904,7419900,'cal',33.333,1),(87,7419905,7419902,'rem',14.286,1),(87,7419906,7419902,'emo',14.286,1),(87,7419907,7419902,'mov',14.286,1),(87,7419908,7419902,'ova',14.286,1),(87,7419909,7419902,'vab',14.286,1),(87,7419910,7419902,'abl',14.286,1),(87,7419911,7419902,'ble',14.286,1),(87,7419912,7419905,'ssd',100,1),(87,7419913,7419912,'off',20,1),(87,7419914,7419912,'ffl',20,1),(87,7419915,7419912,'fli',20,1),(87,7419916,7419912,'lin',20,1),(87,7419917,7419912,'ine',20,1),(87,7419918,7419913,'per',11.111,1),(87,7419919,7419913,'ere',11.111,1),(87,7419920,7419913,'ren',11.111,1),(87,7419921,7419913,'enn',11.111,1),(87,7419922,7419913,'nni',11.111,1),(87,7419923,7419913,'nia',11.111,1),(87,7419924,7419913,'ial',11.111,1),(87,7419925,7419913,'all',11.111,1),(87,7419926,7419913,'lly',11.111,1),(87,7419927,7419918,'res',16.667,1),(87,7419928,7419918,'ese',16.667,1),(87,7419929,7419918,'ser',16.667,1),(87,7419930,7419918,'erv',16.667,1),(87,7419931,7419918,'rve',16.667,1),(87,7419932,7419918,'ved',16.667,1),(87,7419933,7419927,'thi',50,1),(87,7419934,7419927,'hin',50,1),(87,7419935,7419933,'pro',10,1),(87,7419936,7419933,'rov',10,1),(87,7419937,7419933,'ovi',10,1),(87,7419938,7419933,'vis',10,1),(87,7419939,7419933,'isi',10,1),(87,7419940,7419933,'sio',10,1),(87,7419941,7419933,'ion',10,1),(87,7419942,7419933,'oni',10,1),(87,7419943,7419933,'nin',10,1),(87,7419944,7419933,'ing',10,1),(87,7419945,7419935,'yes',100,1),(87,7419946,7419945,'att',16.667,1),(87,7419947,7419945,'tta',16.667,1),(87,7419948,7419945,'tac',16.667,1),(87,7419949,7419945,'ach',16.667,1),(87,7419950,7419945,'che',16.667,1),(87,7419951,7419945,'hed',16.667,1),(87,7419952,7419946,'fil',20,1),(87,7419953,7419946,'ilt',20,1),(87,7419954,7419946,'lte',20,1),(87,7419955,7419946,'ter',20,1),(87,7419956,7419946,'ers',20,1),(87,7419957,7419952,'vaa',50,1),(87,7419958,7419952,'aai',50,1),(87,7419959,7419957,'unk',20,1),(87,7419960,7419957,'nkn',20,1),(87,7419961,7419957,'kno',20,1),(87,7419962,7419957,'now',20,1),(87,7419963,7419957,'own',20,1),(87,7419964,7419959,'oth',33.333,1),(87,7419965,7419959,'the',33.333,1),(87,7419966,7419959,'her',33.333,1),(87,7419967,7419964,'uid',50,1),(87,7419968,7419964,'ids',50,1),(87,7419969,7419967,'vml',100,1),(87,7419970,7419969,'dis',20,1),(87,7419971,7419969,'isp',20,1),(87,7419972,7419969,'spl',20,1),(87,7419973,7419969,'pla',20,1),(87,7419974,7419969,'lay',20,1),(87,7419975,7419970,'nam',50,1),(87,7419976,7419970,'ame',50,1),(88,7419978,7419977,'net',25,3),(88,7419979,7419977,'eta',25,3),(88,7419980,7419977,'tap',25,3),(88,7419981,7419977,'app',25,3),(88,7419982,7419978,'fib',33.333,2),(88,7419983,7419978,'ibr',33.333,2),(88,7419984,7419978,'bre',33.333,2),(88,7419985,7419982,'cha',20,2),(88,7419986,7419982,'han',20,2),(88,7419987,7419982,'ann',20,2),(88,7419988,7419982,'nne',20,2),(88,7419989,7419982,'nel',20,2),(88,7419990,7419985,'dis',50,2),(88,7419991,7419985,'isk',50,2),(88,7419992,7419990,'naa',100,4),(88,7419993,7419992,'600',3.333,4),(88,7419994,7419992,'00a',3.333,4),(88,7419995,7419992,'0a0',3.333,4),(88,7419996,7419992,'a09',3.333,4),(88,7419997,7419992,'098',3.333,4),(88,7419998,7419992,'980',3.333,4),(88,7419999,7419992,'804',3.333,4),(88,7420000,7419992,'044',3.333,4),(88,7420001,7419992,'443',3.333,4),(88,7420002,7419992,'430',3.333,4),(88,7420003,7419992,'307',3.333,4),(88,7420004,7419992,'075',3.333,4),(88,7420005,7419992,'753',3.333,4),(88,7420006,7419992,'535',3.333,4),(88,7420007,7419992,'357',3.333,4),(88,7420008,7419992,'573',3.333,4),(88,7420009,7419992,'732',3.333,4),(88,7420010,7419992,'32b',3.333,4),(88,7420011,7419992,'2b3',3.333,4),(88,7420012,7419992,'b33',3.333,4),(88,7420013,7419992,'334',3.333,4),(88,7420014,7419992,'345',3.333,4),(88,7420015,7419992,'457',3.333,4),(88,7420016,7419992,'571',3.333,4),(88,7420017,7419992,'715',3.333,4),(88,7420018,7419992,'153',3.333,4),(88,7420019,7419992,'533',3.333,4),(88,7420020,7419992,'336',3.333,4),(88,7420021,7419992,'364',3.333,4),(88,7420022,7419992,'64a',3.333,4),(88,7420023,7419993,'ser',25,1),(88,7420024,7419993,'eri',25,1),(88,7420025,7419993,'ria',25,1),(88,7420026,7419993,'ial',25,1),(88,7420027,7420023,'siz',50,1),(88,7420028,7420023,'ize',50,1),(88,7420029,7420027,'321',100,1),(88,7420030,7420029,'dev',25,1),(88,7420031,7420029,'evi',25,1),(88,7420032,7420029,'vic',25,1),(88,7420033,7420029,'ice',25,1),(88,7420034,7420030,'typ',50,1),(88,7420035,7420030,'ype',50,1),(88,7420036,7420034,'dir',10,1),(88,7420037,7420034,'ire',10,1),(88,7420038,7420034,'rec',10,1),(88,7420039,7420034,'ect',10,1),(88,7420040,7420034,'cta',10,1),(88,7420041,7420034,'tac',10,1),(88,7420042,7420034,'acc',10,1),(88,7420043,7420034,'cce',10,1),(88,7420044,7420034,'ces',10,1),(88,7420045,7420034,'ess',10,1),(88,7420046,7420036,'mul',14.286,1),(88,7420047,7420036,'ult',14.286,1),(88,7420048,7420036,'lti',14.286,1),(88,7420049,7420036,'tip',14.286,1),(88,7420050,7420036,'ipa',14.286,1),(88,7420051,7420036,'pat',14.286,1),(88,7420052,7420036,'ath',14.286,1),(88,7420053,7420046,'plu',25,1),(88,7420054,7420046,'lug',25,1),(88,7420055,7420046,'ugi',25,1),(88,7420056,7420046,'gin',25,1),(88,7420057,7420053,'nmp',100,1),(88,7420058,7420057,'dev',33.333,1),(88,7420059,7420057,'evf',33.333,1),(88,7420060,7420057,'vfs',33.333,1),(88,7420061,7420058,'pat',50,1),(88,7420062,7420058,'ath',50,1),(88,7420063,7420061,'vmf',50,1),(88,7420064,7420061,'mfs',50,1),(88,7420065,7420063,'dev',20,1),(88,7420066,7420063,'evi',20,1),(88,7420067,7420063,'vic',20,1),(88,7420068,7420063,'ice',20,1),(88,7420069,7420063,'ces',20,1),(88,7420070,7420065,'dis',33.333,1),(88,7420071,7420065,'isk',33.333,1),(88,7420072,7420065,'sks',33.333,1),(88,7420073,7420070,'ven',25,1),(88,7420074,7420070,'end',25,1),(88,7420075,7420070,'ndo',25,1),(88,7420076,7420070,'dor',25,1),(88,7420077,7420073,'mod',33.333,1),(88,7420078,7420073,'ode',33.333,1),(88,7420079,7420073,'del',33.333,1),(88,7420080,7420077,'lun',100,1),(88,7420081,7420080,'cmo',33.333,1),(88,7420082,7420080,'mod',33.333,1),(88,7420083,7420080,'ode',33.333,1),(88,7420084,7420081,'rev',16.667,1),(88,7420085,7420081,'evi',16.667,1),(88,7420086,7420081,'vis',16.667,1),(88,7420087,7420081,'isi',16.667,1),(88,7420088,7420081,'sio',16.667,1),(88,7420089,7420081,'ion',16.667,1),(88,7420090,7420084,'810',50,1),(88,7420091,7420084,'100',50,1),(88,7420092,7420090,'scs',50,1),(88,7420093,7420090,'csi',50,1),(88,7420094,7420092,'lev',33.333,1),(88,7420095,7420092,'eve',33.333,1),(88,7420096,7420092,'vel',33.333,1),(88,7420097,7420094,'pse',25,1),(88,7420098,7420094,'seu',25,1),(88,7420099,7420094,'eud',25,1),(88,7420100,7420094,'udo',25,1),(88,7420101,7420097,'fal',33.333,6),(88,7420102,7420097,'als',33.333,6),(88,7420103,7420097,'lse',33.333,6),(88,7420104,7420101,'sta',25,3),(88,7420105,7420101,'tat',25,3),(88,7420106,7420101,'atu',25,3),(88,7420107,7420101,'tus',25,3),(88,7420108,7420104,'rdm',100,1),(88,7420109,7420108,'cap',20,1),(88,7420110,7420108,'apa',20,1),(88,7420111,7420108,'pab',20,1),(88,7420112,7420108,'abl',20,1),(88,7420113,7420108,'ble',20,1),(88,7420114,7420109,'tru',50,1),(88,7420115,7420109,'rue',50,1),(88,7420116,7420114,'loc',33.333,1),(88,7420117,7420114,'oca',33.333,1),(88,7420118,7420114,'cal',33.333,1),(88,7420119,7420116,'rem',14.286,1),(88,7420120,7420116,'emo',14.286,1),(88,7420121,7420116,'mov',14.286,1),(88,7420122,7420116,'ova',14.286,1),(88,7420123,7420116,'vab',14.286,1),(88,7420124,7420116,'abl',14.286,1),(88,7420125,7420116,'ble',14.286,1),(88,7420126,7420119,'ssd',100,1),(88,7420127,7420126,'off',20,1),(88,7420128,7420126,'ffl',20,1),(88,7420129,7420126,'fli',20,1),(88,7420130,7420126,'lin',20,1),(88,7420131,7420126,'ine',20,1),(88,7420132,7420127,'per',11.111,1),(88,7420133,7420127,'ere',11.111,1),(88,7420134,7420127,'ren',11.111,1),(88,7420135,7420127,'enn',11.111,1),(88,7420136,7420127,'nni',11.111,1),(88,7420137,7420127,'nia',11.111,1),(88,7420138,7420127,'ial',11.111,1),(88,7420139,7420127,'all',11.111,1),(88,7420140,7420127,'lly',11.111,1),(88,7420141,7420132,'res',16.667,1),(88,7420142,7420132,'ese',16.667,1),(88,7420143,7420132,'ser',16.667,1),(88,7420144,7420132,'erv',16.667,1),(88,7420145,7420132,'rve',16.667,1),(88,7420146,7420132,'ved',16.667,1),(88,7420147,7420141,'thi',50,1),(88,7420148,7420141,'hin',50,1),(88,7420149,7420147,'pro',10,1),(88,7420150,7420147,'rov',10,1),(88,7420151,7420147,'ovi',10,1),(88,7420152,7420147,'vis',10,1),(88,7420153,7420147,'isi',10,1),(88,7420154,7420147,'sio',10,1),(88,7420155,7420147,'ion',10,1),(88,7420156,7420147,'oni',10,1),(88,7420157,7420147,'nin',10,1),(88,7420158,7420147,'ing',10,1),(88,7420159,7420149,'yes',100,1),(88,7420160,7420159,'att',16.667,1),(88,7420161,7420159,'tta',16.667,1),(88,7420162,7420159,'tac',16.667,1),(88,7420163,7420159,'ach',16.667,1),(88,7420164,7420159,'che',16.667,1),(88,7420165,7420159,'hed',16.667,1),(88,7420166,7420160,'fil',20,1),(88,7420167,7420160,'ilt',20,1),(88,7420168,7420160,'lte',20,1),(88,7420169,7420160,'ter',20,1),(88,7420170,7420160,'ers',20,1),(88,7420171,7420166,'vaa',50,1),(88,7420172,7420166,'aai',50,1),(88,7420173,7420171,'unk',20,1),(88,7420174,7420171,'nkn',20,1),(88,7420175,7420171,'kno',20,1),(88,7420176,7420171,'now',20,1),(88,7420177,7420171,'own',20,1),(88,7420178,7420173,'oth',33.333,1),(88,7420179,7420173,'the',33.333,1),(88,7420180,7420173,'her',33.333,1),(88,7420181,7420178,'uid',50,1),(88,7420182,7420178,'ids',50,1),(88,7420183,7420181,'vml',100,1),(88,7420184,7420183,'dis',20,1),(88,7420185,7420183,'isp',20,1),(88,7420186,7420183,'spl',20,1),(88,7420187,7420183,'pla',20,1),(88,7420188,7420183,'lay',20,1),(88,7420189,7420184,'nam',50,1),(88,7420190,7420184,'ame',50,1),(89,7420192,7420191,'net',25,3),(89,7420193,7420191,'eta',25,3),(89,7420194,7420191,'tap',25,3),(89,7420195,7420191,'app',25,3),(89,7420196,7420192,'fib',33.333,2),(89,7420197,7420192,'ibr',33.333,2),(89,7420198,7420192,'bre',33.333,2),(89,7420199,7420196,'cha',20,2),(89,7420200,7420196,'han',20,2),(89,7420201,7420196,'ann',20,2),(89,7420202,7420196,'nne',20,2),(89,7420203,7420196,'nel',20,2),(89,7420204,7420199,'dis',50,2),(89,7420205,7420199,'isk',50,2),(89,7420206,7420204,'naa',100,4),(89,7420207,7420206,'600',3.333,4),(89,7420208,7420206,'00a',3.333,4),(89,7420209,7420206,'0a0',3.333,4),(89,7420210,7420206,'a09',3.333,4),(89,7420211,7420206,'098',3.333,4),(89,7420212,7420206,'980',3.333,4),(89,7420213,7420206,'804',3.333,4),(89,7420214,7420206,'044',3.333,4),(89,7420215,7420206,'443',3.333,4),(89,7420216,7420206,'430',3.333,4),(89,7420217,7420206,'307',3.333,4),(89,7420218,7420206,'075',3.333,4),(89,7420219,7420206,'753',3.333,4),(89,7420220,7420206,'535',3.333,4),(89,7420221,7420206,'357',3.333,4),(89,7420222,7420206,'573',3.333,4),(89,7420223,7420206,'732',3.333,4),(89,7420224,7420206,'32b',3.333,4),(89,7420225,7420206,'2b3',3.333,4),(89,7420226,7420206,'b33',3.333,4),(89,7420227,7420206,'334',3.333,4),(89,7420228,7420206,'345',3.333,4),(89,7420229,7420206,'457',3.333,4),(89,7420230,7420206,'571',3.333,4),(89,7420231,7420206,'715',3.333,4),(89,7420232,7420206,'153',3.333,4),(89,7420233,7420206,'533',3.333,4),(89,7420234,7420206,'335',3.333,4),(89,7420235,7420206,'356',3.333,4),(89,7420236,7420206,'56e',3.333,4),(89,7420237,7420207,'ser',25,1),(89,7420238,7420207,'eri',25,1),(89,7420239,7420207,'ria',25,1),(89,7420240,7420207,'ial',25,1),(89,7420241,7420237,'siz',50,1),(89,7420242,7420237,'ize',50,1),(89,7420243,7420241,'460',33.333,1),(89,7420244,7420241,'608',33.333,1),(89,7420245,7420241,'080',33.333,1),(89,7420246,7420243,'dev',25,1),(89,7420247,7420243,'evi',25,1),(89,7420248,7420243,'vic',25,1),(89,7420249,7420243,'ice',25,1),(89,7420250,7420246,'typ',50,1),(89,7420251,7420246,'ype',50,1),(89,7420252,7420250,'dir',10,1),(89,7420253,7420250,'ire',10,1),(89,7420254,7420250,'rec',10,1),(89,7420255,7420250,'ect',10,1),(89,7420256,7420250,'cta',10,1),(89,7420257,7420250,'tac',10,1),(89,7420258,7420250,'acc',10,1),(89,7420259,7420250,'cce',10,1),(89,7420260,7420250,'ces',10,1),(89,7420261,7420250,'ess',10,1),(89,7420262,7420252,'mul',14.286,1),(89,7420263,7420252,'ult',14.286,1),(89,7420264,7420252,'lti',14.286,1),(89,7420265,7420252,'tip',14.286,1),(89,7420266,7420252,'ipa',14.286,1),(89,7420267,7420252,'pat',14.286,1),(89,7420268,7420252,'ath',14.286,1),(89,7420269,7420262,'plu',25,1),(89,7420270,7420262,'lug',25,1),(89,7420271,7420262,'ugi',25,1),(89,7420272,7420262,'gin',25,1),(89,7420273,7420269,'nmp',100,1),(89,7420274,7420273,'dev',33.333,1),(89,7420275,7420273,'evf',33.333,1),(89,7420276,7420273,'vfs',33.333,1),(89,7420277,7420274,'pat',50,1),(89,7420278,7420274,'ath',50,1),(89,7420279,7420277,'vmf',50,1),(89,7420280,7420277,'mfs',50,1),(89,7420281,7420279,'dev',20,1),(89,7420282,7420279,'evi',20,1),(89,7420283,7420279,'vic',20,1),(89,7420284,7420279,'ice',20,1),(89,7420285,7420279,'ces',20,1),(89,7420286,7420281,'dis',33.333,1),(89,7420287,7420281,'isk',33.333,1),(89,7420288,7420281,'sks',33.333,1),(89,7420289,7420286,'ven',25,1),(89,7420290,7420286,'end',25,1),(89,7420291,7420286,'ndo',25,1),(89,7420292,7420286,'dor',25,1),(89,7420293,7420289,'mod',33.333,1),(89,7420294,7420289,'ode',33.333,1),(89,7420295,7420289,'del',33.333,1),(89,7420296,7420293,'lun',100,1),(89,7420297,7420296,'cmo',33.333,1),(89,7420298,7420296,'mod',33.333,1),(89,7420299,7420296,'ode',33.333,1),(89,7420300,7420297,'rev',16.667,1),(89,7420301,7420297,'evi',16.667,1),(89,7420302,7420297,'vis',16.667,1),(89,7420303,7420297,'isi',16.667,1),(89,7420304,7420297,'sio',16.667,1),(89,7420305,7420297,'ion',16.667,1),(89,7420306,7420300,'810',50,1),(89,7420307,7420300,'100',50,1),(89,7420308,7420306,'scs',50,1),(89,7420309,7420306,'csi',50,1),(89,7420310,7420308,'lev',33.333,1),(89,7420311,7420308,'eve',33.333,1),(89,7420312,7420308,'vel',33.333,1),(89,7420313,7420310,'pse',25,1),(89,7420314,7420310,'seu',25,1),(89,7420315,7420310,'eud',25,1),(89,7420316,7420310,'udo',25,1),(89,7420317,7420313,'fal',33.333,6),(89,7420318,7420313,'als',33.333,6),(89,7420319,7420313,'lse',33.333,6),(89,7420320,7420317,'sta',25,3),(89,7420321,7420317,'tat',25,3),(89,7420322,7420317,'atu',25,3),(89,7420323,7420317,'tus',25,3),(89,7420324,7420320,'rdm',100,1),(89,7420325,7420324,'cap',20,1),(89,7420326,7420324,'apa',20,1),(89,7420327,7420324,'pab',20,1),(89,7420328,7420324,'abl',20,1),(89,7420329,7420324,'ble',20,1),(89,7420330,7420325,'tru',50,1),(89,7420331,7420325,'rue',50,1),(89,7420332,7420330,'loc',33.333,1),(89,7420333,7420330,'oca',33.333,1),(89,7420334,7420330,'cal',33.333,1),(89,7420335,7420332,'rem',14.286,1),(89,7420336,7420332,'emo',14.286,1),(89,7420337,7420332,'mov',14.286,1),(89,7420338,7420332,'ova',14.286,1),(89,7420339,7420332,'vab',14.286,1),(89,7420340,7420332,'abl',14.286,1),(89,7420341,7420332,'ble',14.286,1),(89,7420342,7420335,'ssd',100,1),(89,7420343,7420342,'off',20,1),(89,7420344,7420342,'ffl',20,1),(89,7420345,7420342,'fli',20,1),(89,7420346,7420342,'lin',20,1),(89,7420347,7420342,'ine',20,1),(89,7420348,7420343,'per',11.111,1),(89,7420349,7420343,'ere',11.111,1),(89,7420350,7420343,'ren',11.111,1),(89,7420351,7420343,'enn',11.111,1),(89,7420352,7420343,'nni',11.111,1),(89,7420353,7420343,'nia',11.111,1),(89,7420354,7420343,'ial',11.111,1),(89,7420355,7420343,'all',11.111,1),(89,7420356,7420343,'lly',11.111,1),(89,7420357,7420348,'res',16.667,1),(89,7420358,7420348,'ese',16.667,1),(89,7420359,7420348,'ser',16.667,1),(89,7420360,7420348,'erv',16.667,1),(89,7420361,7420348,'rve',16.667,1),(89,7420362,7420348,'ved',16.667,1),(89,7420363,7420357,'thi',50,1),(89,7420364,7420357,'hin',50,1),(89,7420365,7420363,'pro',10,1),(89,7420366,7420363,'rov',10,1),(89,7420367,7420363,'ovi',10,1),(89,7420368,7420363,'vis',10,1),(89,7420369,7420363,'isi',10,1),(89,7420370,7420363,'sio',10,1),(89,7420371,7420363,'ion',10,1),(89,7420372,7420363,'oni',10,1),(89,7420373,7420363,'nin',10,1),(89,7420374,7420363,'ing',10,1),(89,7420375,7420365,'yes',100,1),(89,7420376,7420375,'att',16.667,1),(89,7420377,7420375,'tta',16.667,1),(89,7420378,7420375,'tac',16.667,1),(89,7420379,7420375,'ach',16.667,1),(89,7420380,7420375,'che',16.667,1),(89,7420381,7420375,'hed',16.667,1),(89,7420382,7420376,'fil',20,1),(89,7420383,7420376,'ilt',20,1),(89,7420384,7420376,'lte',20,1),(89,7420385,7420376,'ter',20,1),(89,7420386,7420376,'ers',20,1),(89,7420387,7420382,'vaa',50,1),(89,7420388,7420382,'aai',50,1),(89,7420389,7420387,'unk',20,1),(89,7420390,7420387,'nkn',20,1),(89,7420391,7420387,'kno',20,1),(89,7420392,7420387,'now',20,1),(89,7420393,7420387,'own',20,1),(89,7420394,7420389,'oth',33.333,1),(89,7420395,7420389,'the',33.333,1),(89,7420396,7420389,'her',33.333,1),(89,7420397,7420394,'uid',50,1),(89,7420398,7420394,'ids',50,1),(89,7420399,7420397,'vml',100,1),(89,7420400,7420399,'dis',20,1),(89,7420401,7420399,'isp',20,1),(89,7420402,7420399,'spl',20,1),(89,7420403,7420399,'pla',20,1),(89,7420404,7420399,'lay',20,1),(89,7420405,7420400,'nam',50,1),(89,7420406,7420400,'ame',50,1),(90,7420408,7420407,'net',25,3),(90,7420409,7420407,'eta',25,3),(90,7420410,7420407,'tap',25,3),(90,7420411,7420407,'app',25,3),(90,7420412,7420408,'fib',33.333,2),(90,7420413,7420408,'ibr',33.333,2),(90,7420414,7420408,'bre',33.333,2),(90,7420415,7420412,'cha',20,2),(90,7420416,7420412,'han',20,2),(90,7420417,7420412,'ann',20,2),(90,7420418,7420412,'nne',20,2),(90,7420419,7420412,'nel',20,2),(90,7420420,7420415,'dis',50,2),(90,7420421,7420415,'isk',50,2),(90,7420422,7420420,'naa',100,4),(90,7420423,7420422,'600',3.333,4),(90,7420424,7420422,'00a',3.333,4),(90,7420425,7420422,'0a0',3.333,4),(90,7420426,7420422,'a09',3.333,4),(90,7420427,7420422,'098',3.333,4),(90,7420428,7420422,'980',3.333,4),(90,7420429,7420422,'804',3.333,4),(90,7420430,7420422,'044',3.333,4),(90,7420431,7420422,'443',3.333,4),(90,7420432,7420422,'430',3.333,4),(90,7420433,7420422,'307',3.333,4),(90,7420434,7420422,'075',3.333,4),(90,7420435,7420422,'753',3.333,4),(90,7420436,7420422,'535',3.333,4),(90,7420437,7420422,'357',3.333,4),(90,7420438,7420422,'573',3.333,4),(90,7420439,7420422,'732',3.333,4),(90,7420440,7420422,'32b',3.333,4),(90,7420441,7420422,'2b3',3.333,4),(90,7420442,7420422,'b33',3.333,4),(90,7420443,7420422,'334',3.333,4),(90,7420444,7420422,'345',3.333,4),(90,7420445,7420422,'457',3.333,4),(90,7420446,7420422,'571',3.333,4),(90,7420447,7420422,'715',3.333,4),(90,7420448,7420422,'153',3.333,4),(90,7420449,7420422,'533',3.333,4),(90,7420450,7420422,'336',3.333,4),(90,7420451,7420422,'364',3.333,4),(90,7420452,7420422,'64b',3.333,4),(90,7420453,7420423,'ser',25,1),(90,7420454,7420423,'eri',25,1),(90,7420455,7420423,'ria',25,1),(90,7420456,7420423,'ial',25,1),(90,7420457,7420453,'siz',50,1),(90,7420458,7420453,'ize',50,1),(90,7420459,7420457,'321',100,1),(90,7420460,7420459,'dev',25,1),(90,7420461,7420459,'evi',25,1),(90,7420462,7420459,'vic',25,1),(90,7420463,7420459,'ice',25,1),(90,7420464,7420460,'typ',50,1),(90,7420465,7420460,'ype',50,1),(90,7420466,7420464,'dir',10,1),(90,7420467,7420464,'ire',10,1),(90,7420468,7420464,'rec',10,1),(90,7420469,7420464,'ect',10,1),(90,7420470,7420464,'cta',10,1),(90,7420471,7420464,'tac',10,1),(90,7420472,7420464,'acc',10,1),(90,7420473,7420464,'cce',10,1),(90,7420474,7420464,'ces',10,1),(90,7420475,7420464,'ess',10,1),(90,7420476,7420466,'mul',14.286,1),(90,7420477,7420466,'ult',14.286,1),(90,7420478,7420466,'lti',14.286,1),(90,7420479,7420466,'tip',14.286,1),(90,7420480,7420466,'ipa',14.286,1),(90,7420481,7420466,'pat',14.286,1),(90,7420482,7420466,'ath',14.286,1),(90,7420483,7420476,'plu',25,1),(90,7420484,7420476,'lug',25,1),(90,7420485,7420476,'ugi',25,1),(90,7420486,7420476,'gin',25,1),(90,7420487,7420483,'nmp',100,1),(90,7420488,7420487,'dev',33.333,1),(90,7420489,7420487,'evf',33.333,1),(90,7420490,7420487,'vfs',33.333,1),(90,7420491,7420488,'pat',50,1),(90,7420492,7420488,'ath',50,1),(90,7420493,7420491,'vmf',50,1),(90,7420494,7420491,'mfs',50,1),(90,7420495,7420493,'dev',20,1),(90,7420496,7420493,'evi',20,1),(90,7420497,7420493,'vic',20,1),(90,7420498,7420493,'ice',20,1),(90,7420499,7420493,'ces',20,1),(90,7420500,7420495,'dis',33.333,1),(90,7420501,7420495,'isk',33.333,1),(90,7420502,7420495,'sks',33.333,1),(90,7420503,7420500,'ven',25,1),(90,7420504,7420500,'end',25,1),(90,7420505,7420500,'ndo',25,1),(90,7420506,7420500,'dor',25,1),(90,7420507,7420503,'mod',33.333,1),(90,7420508,7420503,'ode',33.333,1),(90,7420509,7420503,'del',33.333,1),(90,7420510,7420507,'lun',100,1),(90,7420511,7420510,'cmo',33.333,1),(90,7420512,7420510,'mod',33.333,1),(90,7420513,7420510,'ode',33.333,1),(90,7420514,7420511,'rev',16.667,1),(90,7420515,7420511,'evi',16.667,1),(90,7420516,7420511,'vis',16.667,1),(90,7420517,7420511,'isi',16.667,1),(90,7420518,7420511,'sio',16.667,1),(90,7420519,7420511,'ion',16.667,1),(90,7420520,7420514,'810',50,1),(90,7420521,7420514,'100',50,1),(90,7420522,7420520,'scs',50,1),(90,7420523,7420520,'csi',50,1),(90,7420524,7420522,'lev',33.333,1),(90,7420525,7420522,'eve',33.333,1),(90,7420526,7420522,'vel',33.333,1),(90,7420527,7420524,'pse',25,1),(90,7420528,7420524,'seu',25,1),(90,7420529,7420524,'eud',25,1),(90,7420530,7420524,'udo',25,1),(90,7420531,7420527,'fal',33.333,6),(90,7420532,7420527,'als',33.333,6),(90,7420533,7420527,'lse',33.333,6),(90,7420534,7420531,'sta',25,3),(90,7420535,7420531,'tat',25,3),(90,7420536,7420531,'atu',25,3),(90,7420537,7420531,'tus',25,3),(90,7420538,7420534,'rdm',100,1),(90,7420539,7420538,'cap',20,1),(90,7420540,7420538,'apa',20,1),(90,7420541,7420538,'pab',20,1),(90,7420542,7420538,'abl',20,1),(90,7420543,7420538,'ble',20,1),(90,7420544,7420539,'tru',50,1),(90,7420545,7420539,'rue',50,1),(90,7420546,7420544,'loc',33.333,1),(90,7420547,7420544,'oca',33.333,1),(90,7420548,7420544,'cal',33.333,1),(90,7420549,7420546,'rem',14.286,1),(90,7420550,7420546,'emo',14.286,1),(90,7420551,7420546,'mov',14.286,1),(90,7420552,7420546,'ova',14.286,1),(90,7420553,7420546,'vab',14.286,1),(90,7420554,7420546,'abl',14.286,1),(90,7420555,7420546,'ble',14.286,1),(90,7420556,7420549,'ssd',100,1),(90,7420557,7420556,'off',20,1),(90,7420558,7420556,'ffl',20,1),(90,7420559,7420556,'fli',20,1),(90,7420560,7420556,'lin',20,1),(90,7420561,7420556,'ine',20,1),(90,7420562,7420557,'per',11.111,1),(90,7420563,7420557,'ere',11.111,1),(90,7420564,7420557,'ren',11.111,1),(90,7420565,7420557,'enn',11.111,1),(90,7420566,7420557,'nni',11.111,1),(90,7420567,7420557,'nia',11.111,1),(90,7420568,7420557,'ial',11.111,1),(90,7420569,7420557,'all',11.111,1),(90,7420570,7420557,'lly',11.111,1),(90,7420571,7420562,'res',16.667,1),(90,7420572,7420562,'ese',16.667,1),(90,7420573,7420562,'ser',16.667,1),(90,7420574,7420562,'erv',16.667,1),(90,7420575,7420562,'rve',16.667,1),(90,7420576,7420562,'ved',16.667,1),(90,7420577,7420571,'thi',50,1),(90,7420578,7420571,'hin',50,1),(90,7420579,7420577,'pro',10,1),(90,7420580,7420577,'rov',10,1),(90,7420581,7420577,'ovi',10,1),(90,7420582,7420577,'vis',10,1),(90,7420583,7420577,'isi',10,1),(90,7420584,7420577,'sio',10,1),(90,7420585,7420577,'ion',10,1),(90,7420586,7420577,'oni',10,1),(90,7420587,7420577,'nin',10,1),(90,7420588,7420577,'ing',10,1),(90,7420589,7420579,'yes',100,1),(90,7420590,7420589,'att',16.667,1),(90,7420591,7420589,'tta',16.667,1),(90,7420592,7420589,'tac',16.667,1),(90,7420593,7420589,'ach',16.667,1),(90,7420594,7420589,'che',16.667,1),(90,7420595,7420589,'hed',16.667,1),(90,7420596,7420590,'fil',20,1),(90,7420597,7420590,'ilt',20,1),(90,7420598,7420590,'lte',20,1),(90,7420599,7420590,'ter',20,1),(90,7420600,7420590,'ers',20,1),(90,7420601,7420596,'vaa',50,1),(90,7420602,7420596,'aai',50,1),(90,7420603,7420601,'unk',20,1),(90,7420604,7420601,'nkn',20,1),(90,7420605,7420601,'kno',20,1),(90,7420606,7420601,'now',20,1),(90,7420607,7420601,'own',20,1),(90,7420608,7420603,'oth',33.333,1),(90,7420609,7420603,'the',33.333,1),(90,7420610,7420603,'her',33.333,1),(90,7420611,7420608,'uid',50,1),(90,7420612,7420608,'ids',50,1),(90,7420613,7420611,'vml',100,1),(90,7420614,7420613,'dis',20,1),(90,7420615,7420613,'isp',20,1),(90,7420616,7420613,'spl',20,1),(90,7420617,7420613,'pla',20,1),(90,7420618,7420613,'lay',20,1),(90,7420619,7420614,'nam',50,1),(90,7420620,7420614,'ame',50,1),(91,7420622,7420621,'net',25,3),(91,7420623,7420621,'eta',25,3),(91,7420624,7420621,'tap',25,3),(91,7420625,7420621,'app',25,3),(91,7420626,7420622,'fib',33.333,2),(91,7420627,7420622,'ibr',33.333,2),(91,7420628,7420622,'bre',33.333,2),(91,7420629,7420626,'cha',20,2),(91,7420630,7420626,'han',20,2),(91,7420631,7420626,'ann',20,2),(91,7420632,7420626,'nne',20,2),(91,7420633,7420626,'nel',20,2),(91,7420634,7420629,'dis',50,2),(91,7420635,7420629,'isk',50,2),(91,7420636,7420634,'naa',100,4),(91,7420637,7420636,'600',3.333,4),(91,7420638,7420636,'00a',3.333,4),(91,7420639,7420636,'0a0',3.333,4),(91,7420640,7420636,'a09',3.333,4),(91,7420641,7420636,'098',3.333,4),(91,7420642,7420636,'980',3.333,4),(91,7420643,7420636,'804',3.333,4),(91,7420644,7420636,'044',3.333,4),(91,7420645,7420636,'443',3.333,4),(91,7420646,7420636,'430',3.333,4),(91,7420647,7420636,'307',3.333,4),(91,7420648,7420636,'075',3.333,4),(91,7420649,7420636,'753',3.333,4),(91,7420650,7420636,'535',3.333,4),(91,7420651,7420636,'357',3.333,4),(91,7420652,7420636,'573',3.333,4),(91,7420653,7420636,'732',3.333,4),(91,7420654,7420636,'32b',3.333,4),(91,7420655,7420636,'2b3',3.333,4),(91,7420656,7420636,'b33',3.333,4),(91,7420657,7420636,'334',3.333,4),(91,7420658,7420636,'345',3.333,4),(91,7420659,7420636,'457',3.333,4),(91,7420660,7420636,'571',3.333,4),(91,7420661,7420636,'715',3.333,4),(91,7420662,7420636,'153',3.333,4),(91,7420663,7420636,'533',3.333,4),(91,7420664,7420636,'335',3.333,4),(91,7420665,7420636,'356',3.333,4),(91,7420666,7420636,'56f',3.333,4),(91,7420667,7420637,'ser',25,1),(91,7420668,7420637,'eri',25,1),(91,7420669,7420637,'ria',25,1),(91,7420670,7420637,'ial',25,1),(91,7420671,7420667,'siz',50,1),(91,7420672,7420667,'ize',50,1),(91,7420673,7420671,'460',33.333,1),(91,7420674,7420671,'608',33.333,1),(91,7420675,7420671,'080',33.333,1),(91,7420676,7420673,'dev',25,1),(91,7420677,7420673,'evi',25,1),(91,7420678,7420673,'vic',25,1),(91,7420679,7420673,'ice',25,1),(91,7420680,7420676,'typ',50,1),(91,7420681,7420676,'ype',50,1),(91,7420682,7420680,'dir',10,1),(91,7420683,7420680,'ire',10,1),(91,7420684,7420680,'rec',10,1),(91,7420685,7420680,'ect',10,1),(91,7420686,7420680,'cta',10,1),(91,7420687,7420680,'tac',10,1),(91,7420688,7420680,'acc',10,1),(91,7420689,7420680,'cce',10,1),(91,7420690,7420680,'ces',10,1),(91,7420691,7420680,'ess',10,1),(91,7420692,7420682,'mul',14.286,1),(91,7420693,7420682,'ult',14.286,1),(91,7420694,7420682,'lti',14.286,1),(91,7420695,7420682,'tip',14.286,1),(91,7420696,7420682,'ipa',14.286,1),(91,7420697,7420682,'pat',14.286,1),(91,7420698,7420682,'ath',14.286,1),(91,7420699,7420692,'plu',25,1),(91,7420700,7420692,'lug',25,1),(91,7420701,7420692,'ugi',25,1),(91,7420702,7420692,'gin',25,1),(91,7420703,7420699,'nmp',100,1),(91,7420704,7420703,'dev',33.333,1),(91,7420705,7420703,'evf',33.333,1),(91,7420706,7420703,'vfs',33.333,1),(91,7420707,7420704,'pat',50,1),(91,7420708,7420704,'ath',50,1),(91,7420709,7420707,'vmf',50,1),(91,7420710,7420707,'mfs',50,1),(91,7420711,7420709,'dev',20,1),(91,7420712,7420709,'evi',20,1),(91,7420713,7420709,'vic',20,1),(91,7420714,7420709,'ice',20,1),(91,7420715,7420709,'ces',20,1),(91,7420716,7420711,'dis',33.333,1),(91,7420717,7420711,'isk',33.333,1),(91,7420718,7420711,'sks',33.333,1),(91,7420719,7420716,'ven',25,1),(91,7420720,7420716,'end',25,1),(91,7420721,7420716,'ndo',25,1),(91,7420722,7420716,'dor',25,1),(91,7420723,7420719,'mod',33.333,1),(91,7420724,7420719,'ode',33.333,1),(91,7420725,7420719,'del',33.333,1),(91,7420726,7420723,'lun',100,1),(91,7420727,7420726,'cmo',33.333,1),(91,7420728,7420726,'mod',33.333,1),(91,7420729,7420726,'ode',33.333,1),(91,7420730,7420727,'rev',16.667,1),(91,7420731,7420727,'evi',16.667,1),(91,7420732,7420727,'vis',16.667,1),(91,7420733,7420727,'isi',16.667,1),(91,7420734,7420727,'sio',16.667,1),(91,7420735,7420727,'ion',16.667,1),(91,7420736,7420730,'810',50,1),(91,7420737,7420730,'100',50,1),(91,7420738,7420736,'scs',50,1),(91,7420739,7420736,'csi',50,1),(91,7420740,7420738,'lev',33.333,1),(91,7420741,7420738,'eve',33.333,1),(91,7420742,7420738,'vel',33.333,1),(91,7420743,7420740,'pse',25,1),(91,7420744,7420740,'seu',25,1),(91,7420745,7420740,'eud',25,1),(91,7420746,7420740,'udo',25,1),(91,7420747,7420743,'fal',33.333,6),(91,7420748,7420743,'als',33.333,6),(91,7420749,7420743,'lse',33.333,6),(91,7420750,7420747,'sta',25,3),(91,7420751,7420747,'tat',25,3),(91,7420752,7420747,'atu',25,3),(91,7420753,7420747,'tus',25,3),(91,7420754,7420750,'rdm',100,1),(91,7420755,7420754,'cap',20,1),(91,7420756,7420754,'apa',20,1),(91,7420757,7420754,'pab',20,1),(91,7420758,7420754,'abl',20,1),(91,7420759,7420754,'ble',20,1),(91,7420760,7420755,'tru',50,1),(91,7420761,7420755,'rue',50,1),(91,7420762,7420760,'loc',33.333,1),(91,7420763,7420760,'oca',33.333,1),(91,7420764,7420760,'cal',33.333,1),(91,7420765,7420762,'rem',14.286,1),(91,7420766,7420762,'emo',14.286,1),(91,7420767,7420762,'mov',14.286,1),(91,7420768,7420762,'ova',14.286,1),(91,7420769,7420762,'vab',14.286,1),(91,7420770,7420762,'abl',14.286,1),(91,7420771,7420762,'ble',14.286,1),(91,7420772,7420765,'ssd',100,1),(91,7420773,7420772,'off',20,1),(91,7420774,7420772,'ffl',20,1),(91,7420775,7420772,'fli',20,1),(91,7420776,7420772,'lin',20,1),(91,7420777,7420772,'ine',20,1),(91,7420778,7420773,'per',11.111,1),(91,7420779,7420773,'ere',11.111,1),(91,7420780,7420773,'ren',11.111,1),(91,7420781,7420773,'enn',11.111,1),(91,7420782,7420773,'nni',11.111,1),(91,7420783,7420773,'nia',11.111,1),(91,7420784,7420773,'ial',11.111,1),(91,7420785,7420773,'all',11.111,1),(91,7420786,7420773,'lly',11.111,1),(91,7420787,7420778,'res',16.667,1),(91,7420788,7420778,'ese',16.667,1),(91,7420789,7420778,'ser',16.667,1),(91,7420790,7420778,'erv',16.667,1),(91,7420791,7420778,'rve',16.667,1),(91,7420792,7420778,'ved',16.667,1),(91,7420793,7420787,'thi',50,1),(91,7420794,7420787,'hin',50,1),(91,7420795,7420793,'pro',10,1),(91,7420796,7420793,'rov',10,1),(91,7420797,7420793,'ovi',10,1),(91,7420798,7420793,'vis',10,1),(91,7420799,7420793,'isi',10,1),(91,7420800,7420793,'sio',10,1),(91,7420801,7420793,'ion',10,1),(91,7420802,7420793,'oni',10,1),(91,7420803,7420793,'nin',10,1),(91,7420804,7420793,'ing',10,1),(91,7420805,7420795,'yes',100,1),(91,7420806,7420805,'att',16.667,1),(91,7420807,7420805,'tta',16.667,1),(91,7420808,7420805,'tac',16.667,1),(91,7420809,7420805,'ach',16.667,1),(91,7420810,7420805,'che',16.667,1),(91,7420811,7420805,'hed',16.667,1),(91,7420812,7420806,'fil',20,1),(91,7420813,7420806,'ilt',20,1),(91,7420814,7420806,'lte',20,1),(91,7420815,7420806,'ter',20,1),(91,7420816,7420806,'ers',20,1),(91,7420817,7420812,'vaa',50,1),(91,7420818,7420812,'aai',50,1),(91,7420819,7420817,'unk',20,1),(91,7420820,7420817,'nkn',20,1),(91,7420821,7420817,'kno',20,1),(91,7420822,7420817,'now',20,1),(91,7420823,7420817,'own',20,1),(91,7420824,7420819,'oth',33.333,1),(91,7420825,7420819,'the',33.333,1),(91,7420826,7420819,'her',33.333,1),(91,7420827,7420824,'uid',50,1),(91,7420828,7420824,'ids',50,1),(91,7420829,7420827,'vml',100,1),(91,7420830,7420829,'dis',20,1),(91,7420831,7420829,'isp',20,1),(91,7420832,7420829,'spl',20,1),(91,7420833,7420829,'pla',20,1),(91,7420834,7420829,'lay',20,1),(91,7420835,7420830,'nam',50,1),(91,7420836,7420830,'ame',50,1),(92,7420838,7420837,'net',25,3),(92,7420839,7420837,'eta',25,3),(92,7420840,7420837,'tap',25,3),(92,7420841,7420837,'app',25,3),(92,7420842,7420838,'fib',33.333,2),(92,7420843,7420838,'ibr',33.333,2),(92,7420844,7420838,'bre',33.333,2),(92,7420845,7420842,'cha',20,2),(92,7420846,7420842,'han',20,2),(92,7420847,7420842,'ann',20,2),(92,7420848,7420842,'nne',20,2),(92,7420849,7420842,'nel',20,2),(92,7420850,7420845,'dis',50,2),(92,7420851,7420845,'isk',50,2),(92,7420852,7420850,'naa',100,4),(92,7420853,7420852,'600',3.333,4),(92,7420854,7420852,'00a',3.333,4),(92,7420855,7420852,'0a0',3.333,4),(92,7420856,7420852,'a09',3.333,4),(92,7420857,7420852,'098',3.333,4),(92,7420858,7420852,'980',3.333,4),(92,7420859,7420852,'804',3.333,4),(92,7420860,7420852,'044',3.333,4),(92,7420861,7420852,'443',3.333,4),(92,7420862,7420852,'430',3.333,4),(92,7420863,7420852,'307',3.333,4),(92,7420864,7420852,'075',3.333,4),(92,7420865,7420852,'753',3.333,4),(92,7420866,7420852,'535',3.333,4),(92,7420867,7420852,'357',3.333,4),(92,7420868,7420852,'573',3.333,4),(92,7420869,7420852,'732',3.333,4),(92,7420870,7420852,'32b',3.333,4),(92,7420871,7420852,'2b3',3.333,4),(92,7420872,7420852,'b33',3.333,4),(92,7420873,7420852,'334',3.333,4),(92,7420874,7420852,'345',3.333,4),(92,7420875,7420852,'457',3.333,4),(92,7420876,7420852,'571',3.333,4),(92,7420877,7420852,'715',3.333,4),(92,7420878,7420852,'153',3.333,4),(92,7420879,7420852,'533',3.333,4),(92,7420880,7420852,'336',3.333,4),(92,7420881,7420852,'364',3.333,4),(92,7420882,7420852,'64c',3.333,4),(92,7420883,7420853,'ser',25,1),(92,7420884,7420853,'eri',25,1),(92,7420885,7420853,'ria',25,1),(92,7420886,7420853,'ial',25,1),(92,7420887,7420883,'siz',50,1),(92,7420888,7420883,'ize',50,1),(92,7420889,7420887,'321',100,1),(92,7420890,7420889,'dev',25,1),(92,7420891,7420889,'evi',25,1),(92,7420892,7420889,'vic',25,1),(92,7420893,7420889,'ice',25,1),(92,7420894,7420890,'typ',50,1),(92,7420895,7420890,'ype',50,1),(92,7420896,7420894,'dir',10,1),(92,7420897,7420894,'ire',10,1),(92,7420898,7420894,'rec',10,1),(92,7420899,7420894,'ect',10,1),(92,7420900,7420894,'cta',10,1),(92,7420901,7420894,'tac',10,1),(92,7420902,7420894,'acc',10,1),(92,7420903,7420894,'cce',10,1),(92,7420904,7420894,'ces',10,1),(92,7420905,7420894,'ess',10,1),(92,7420906,7420896,'mul',14.286,1),(92,7420907,7420896,'ult',14.286,1),(92,7420908,7420896,'lti',14.286,1),(92,7420909,7420896,'tip',14.286,1),(92,7420910,7420896,'ipa',14.286,1),(92,7420911,7420896,'pat',14.286,1),(92,7420912,7420896,'ath',14.286,1),(92,7420913,7420906,'plu',25,1),(92,7420914,7420906,'lug',25,1),(92,7420915,7420906,'ugi',25,1),(92,7420916,7420906,'gin',25,1),(92,7420917,7420913,'nmp',100,1),(92,7420918,7420917,'dev',33.333,1),(92,7420919,7420917,'evf',33.333,1),(92,7420920,7420917,'vfs',33.333,1),(92,7420921,7420918,'pat',50,1),(92,7420922,7420918,'ath',50,1),(92,7420923,7420921,'vmf',50,1),(92,7420924,7420921,'mfs',50,1),(92,7420925,7420923,'dev',20,1),(92,7420926,7420923,'evi',20,1),(92,7420927,7420923,'vic',20,1),(92,7420928,7420923,'ice',20,1),(92,7420929,7420923,'ces',20,1),(92,7420930,7420925,'dis',33.333,1),(92,7420931,7420925,'isk',33.333,1),(92,7420932,7420925,'sks',33.333,1),(92,7420933,7420930,'ven',25,1),(92,7420934,7420930,'end',25,1),(92,7420935,7420930,'ndo',25,1),(92,7420936,7420930,'dor',25,1),(92,7420937,7420933,'mod',33.333,1),(92,7420938,7420933,'ode',33.333,1),(92,7420939,7420933,'del',33.333,1),(92,7420940,7420937,'lun',100,1),(92,7420941,7420940,'cmo',33.333,1),(92,7420942,7420940,'mod',33.333,1),(92,7420943,7420940,'ode',33.333,1),(92,7420944,7420941,'rev',16.667,1),(92,7420945,7420941,'evi',16.667,1),(92,7420946,7420941,'vis',16.667,1),(92,7420947,7420941,'isi',16.667,1),(92,7420948,7420941,'sio',16.667,1),(92,7420949,7420941,'ion',16.667,1),(92,7420950,7420944,'810',50,1),(92,7420951,7420944,'100',50,1),(92,7420952,7420950,'scs',50,1),(92,7420953,7420950,'csi',50,1),(92,7420954,7420952,'lev',33.333,1),(92,7420955,7420952,'eve',33.333,1),(92,7420956,7420952,'vel',33.333,1),(92,7420957,7420954,'pse',25,1),(92,7420958,7420954,'seu',25,1),(92,7420959,7420954,'eud',25,1),(92,7420960,7420954,'udo',25,1),(92,7420961,7420957,'fal',33.333,6),(92,7420962,7420957,'als',33.333,6),(92,7420963,7420957,'lse',33.333,6),(92,7420964,7420961,'sta',25,3),(92,7420965,7420961,'tat',25,3),(92,7420966,7420961,'atu',25,3),(92,7420967,7420961,'tus',25,3),(92,7420968,7420964,'rdm',100,1),(92,7420969,7420968,'cap',20,1),(92,7420970,7420968,'apa',20,1),(92,7420971,7420968,'pab',20,1),(92,7420972,7420968,'abl',20,1),(92,7420973,7420968,'ble',20,1),(92,7420974,7420969,'tru',50,1),(92,7420975,7420969,'rue',50,1),(92,7420976,7420974,'loc',33.333,1),(92,7420977,7420974,'oca',33.333,1),(92,7420978,7420974,'cal',33.333,1),(92,7420979,7420976,'rem',14.286,1),(92,7420980,7420976,'emo',14.286,1),(92,7420981,7420976,'mov',14.286,1),(92,7420982,7420976,'ova',14.286,1),(92,7420983,7420976,'vab',14.286,1),(92,7420984,7420976,'abl',14.286,1),(92,7420985,7420976,'ble',14.286,1),(92,7420986,7420979,'ssd',100,1),(92,7420987,7420986,'off',20,1),(92,7420988,7420986,'ffl',20,1),(92,7420989,7420986,'fli',20,1),(92,7420990,7420986,'lin',20,1),(92,7420991,7420986,'ine',20,1),(92,7420992,7420987,'per',11.111,1),(92,7420993,7420987,'ere',11.111,1),(92,7420994,7420987,'ren',11.111,1),(92,7420995,7420987,'enn',11.111,1),(92,7420996,7420987,'nni',11.111,1),(92,7420997,7420987,'nia',11.111,1),(92,7420998,7420987,'ial',11.111,1),(92,7420999,7420987,'all',11.111,1),(92,7421000,7420987,'lly',11.111,1),(92,7421001,7420992,'res',16.667,1),(92,7421002,7420992,'ese',16.667,1),(92,7421003,7420992,'ser',16.667,1),(92,7421004,7420992,'erv',16.667,1),(92,7421005,7420992,'rve',16.667,1),(92,7421006,7420992,'ved',16.667,1),(92,7421007,7421001,'thi',50,1),(92,7421008,7421001,'hin',50,1),(92,7421009,7421007,'pro',10,1),(92,7421010,7421007,'rov',10,1),(92,7421011,7421007,'ovi',10,1),(92,7421012,7421007,'vis',10,1),(92,7421013,7421007,'isi',10,1),(92,7421014,7421007,'sio',10,1),(92,7421015,7421007,'ion',10,1),(92,7421016,7421007,'oni',10,1),(92,7421017,7421007,'nin',10,1),(92,7421018,7421007,'ing',10,1),(92,7421019,7421009,'yes',100,1),(92,7421020,7421019,'att',16.667,1),(92,7421021,7421019,'tta',16.667,1),(92,7421022,7421019,'tac',16.667,1),(92,7421023,7421019,'ach',16.667,1),(92,7421024,7421019,'che',16.667,1),(92,7421025,7421019,'hed',16.667,1),(92,7421026,7421020,'fil',20,1),(92,7421027,7421020,'ilt',20,1),(92,7421028,7421020,'lte',20,1),(92,7421029,7421020,'ter',20,1),(92,7421030,7421020,'ers',20,1),(92,7421031,7421026,'vaa',50,1),(92,7421032,7421026,'aai',50,1),(92,7421033,7421031,'unk',20,1),(92,7421034,7421031,'nkn',20,1),(92,7421035,7421031,'kno',20,1),(92,7421036,7421031,'now',20,1),(92,7421037,7421031,'own',20,1),(92,7421038,7421033,'oth',33.333,1),(92,7421039,7421033,'the',33.333,1),(92,7421040,7421033,'her',33.333,1),(92,7421041,7421038,'uid',50,1),(92,7421042,7421038,'ids',50,1),(92,7421043,7421041,'vml',100,1),(92,7421044,7421043,'dis',20,1),(92,7421045,7421043,'isp',20,1),(92,7421046,7421043,'spl',20,1),(92,7421047,7421043,'pla',20,1),(92,7421048,7421043,'lay',20,1),(92,7421049,7421044,'nam',50,1),(92,7421050,7421044,'ame',50,1),(93,7421052,7421051,'net',25,3),(93,7421053,7421051,'eta',25,3),(93,7421054,7421051,'tap',25,3),(93,7421055,7421051,'app',25,3),(93,7421056,7421052,'fib',33.333,2),(93,7421057,7421052,'ibr',33.333,2),(93,7421058,7421052,'bre',33.333,2),(93,7421059,7421056,'cha',20,2),(93,7421060,7421056,'han',20,2),(93,7421061,7421056,'ann',20,2),(93,7421062,7421056,'nne',20,2),(93,7421063,7421056,'nel',20,2),(93,7421064,7421059,'dis',50,2),(93,7421065,7421059,'isk',50,2),(93,7421066,7421064,'naa',100,4),(93,7421067,7421066,'600',3.333,4),(93,7421068,7421066,'00a',3.333,4),(93,7421069,7421066,'0a0',3.333,4),(93,7421070,7421066,'a09',3.333,4),(93,7421071,7421066,'098',3.333,4),(93,7421072,7421066,'980',3.333,4),(93,7421073,7421066,'804',3.333,4),(93,7421074,7421066,'044',3.333,4),(93,7421075,7421066,'443',3.333,4),(93,7421076,7421066,'430',3.333,4),(93,7421077,7421066,'307',3.333,4),(93,7421078,7421066,'075',3.333,4),(93,7421079,7421066,'753',3.333,4),(93,7421080,7421066,'535',3.333,4),(93,7421081,7421066,'357',3.333,4),(93,7421082,7421066,'573',3.333,4),(93,7421083,7421066,'732',3.333,4),(93,7421084,7421066,'32b',3.333,4),(93,7421085,7421066,'2b3',3.333,4),(93,7421086,7421066,'b33',3.333,4),(93,7421087,7421066,'334',3.333,4),(93,7421088,7421066,'345',3.333,4),(93,7421089,7421066,'457',3.333,4),(93,7421090,7421066,'571',3.333,4),(93,7421091,7421066,'715',3.333,4),(93,7421092,7421066,'153',3.333,4),(93,7421093,7421066,'533',3.333,4),(93,7421094,7421066,'336',3.333,4),(93,7421095,7421066,'364',3.333,4),(93,7421096,7421066,'64d',3.333,4),(93,7421097,7421067,'ser',25,1),(93,7421098,7421067,'eri',25,1),(93,7421099,7421067,'ria',25,1),(93,7421100,7421067,'ial',25,1),(93,7421101,7421097,'siz',50,1),(93,7421102,7421097,'ize',50,1),(93,7421103,7421101,'321',100,1),(93,7421104,7421103,'dev',25,1),(93,7421105,7421103,'evi',25,1),(93,7421106,7421103,'vic',25,1),(93,7421107,7421103,'ice',25,1),(93,7421108,7421104,'typ',50,1),(93,7421109,7421104,'ype',50,1),(93,7421110,7421108,'dir',10,1),(93,7421111,7421108,'ire',10,1),(93,7421112,7421108,'rec',10,1),(93,7421113,7421108,'ect',10,1),(93,7421114,7421108,'cta',10,1),(93,7421115,7421108,'tac',10,1),(93,7421116,7421108,'acc',10,1),(93,7421117,7421108,'cce',10,1),(93,7421118,7421108,'ces',10,1),(93,7421119,7421108,'ess',10,1),(93,7421120,7421110,'mul',14.286,1),(93,7421121,7421110,'ult',14.286,1),(93,7421122,7421110,'lti',14.286,1),(93,7421123,7421110,'tip',14.286,1),(93,7421124,7421110,'ipa',14.286,1),(93,7421125,7421110,'pat',14.286,1),(93,7421126,7421110,'ath',14.286,1),(93,7421127,7421120,'plu',25,1),(93,7421128,7421120,'lug',25,1),(93,7421129,7421120,'ugi',25,1),(93,7421130,7421120,'gin',25,1),(93,7421131,7421127,'nmp',100,1),(93,7421132,7421131,'dev',33.333,1),(93,7421133,7421131,'evf',33.333,1),(93,7421134,7421131,'vfs',33.333,1),(93,7421135,7421132,'pat',50,1),(93,7421136,7421132,'ath',50,1),(93,7421137,7421135,'vmf',50,1),(93,7421138,7421135,'mfs',50,1),(93,7421139,7421137,'dev',20,1),(93,7421140,7421137,'evi',20,1),(93,7421141,7421137,'vic',20,1),(93,7421142,7421137,'ice',20,1),(93,7421143,7421137,'ces',20,1),(93,7421144,7421139,'dis',33.333,1),(93,7421145,7421139,'isk',33.333,1),(93,7421146,7421139,'sks',33.333,1),(93,7421147,7421144,'ven',25,1),(93,7421148,7421144,'end',25,1),(93,7421149,7421144,'ndo',25,1),(93,7421150,7421144,'dor',25,1),(93,7421151,7421147,'mod',33.333,1),(93,7421152,7421147,'ode',33.333,1),(93,7421153,7421147,'del',33.333,1),(93,7421154,7421151,'lun',100,1),(93,7421155,7421154,'cmo',33.333,1),(93,7421156,7421154,'mod',33.333,1),(93,7421157,7421154,'ode',33.333,1),(93,7421158,7421155,'rev',16.667,1),(93,7421159,7421155,'evi',16.667,1),(93,7421160,7421155,'vis',16.667,1),(93,7421161,7421155,'isi',16.667,1),(93,7421162,7421155,'sio',16.667,1),(93,7421163,7421155,'ion',16.667,1),(93,7421164,7421158,'810',50,1),(93,7421165,7421158,'100',50,1),(93,7421166,7421164,'scs',50,1),(93,7421167,7421164,'csi',50,1),(93,7421168,7421166,'lev',33.333,1),(93,7421169,7421166,'eve',33.333,1),(93,7421170,7421166,'vel',33.333,1),(93,7421171,7421168,'pse',25,1),(93,7421172,7421168,'seu',25,1),(93,7421173,7421168,'eud',25,1),(93,7421174,7421168,'udo',25,1),(93,7421175,7421171,'fal',33.333,6),(93,7421176,7421171,'als',33.333,6),(93,7421177,7421171,'lse',33.333,6),(93,7421178,7421175,'sta',25,3),(93,7421179,7421175,'tat',25,3),(93,7421180,7421175,'atu',25,3),(93,7421181,7421175,'tus',25,3),(93,7421182,7421178,'rdm',100,1),(93,7421183,7421182,'cap',20,1),(93,7421184,7421182,'apa',20,1),(93,7421185,7421182,'pab',20,1),(93,7421186,7421182,'abl',20,1),(93,7421187,7421182,'ble',20,1),(93,7421188,7421183,'tru',50,1),(93,7421189,7421183,'rue',50,1),(93,7421190,7421188,'loc',33.333,1),(93,7421191,7421188,'oca',33.333,1),(93,7421192,7421188,'cal',33.333,1),(93,7421193,7421190,'rem',14.286,1),(93,7421194,7421190,'emo',14.286,1),(93,7421195,7421190,'mov',14.286,1),(93,7421196,7421190,'ova',14.286,1),(93,7421197,7421190,'vab',14.286,1),(93,7421198,7421190,'abl',14.286,1),(93,7421199,7421190,'ble',14.286,1),(93,7421200,7421193,'ssd',100,1),(93,7421201,7421200,'off',20,1),(93,7421202,7421200,'ffl',20,1),(93,7421203,7421200,'fli',20,1),(93,7421204,7421200,'lin',20,1),(93,7421205,7421200,'ine',20,1),(93,7421206,7421201,'per',11.111,1),(93,7421207,7421201,'ere',11.111,1),(93,7421208,7421201,'ren',11.111,1),(93,7421209,7421201,'enn',11.111,1),(93,7421210,7421201,'nni',11.111,1),(93,7421211,7421201,'nia',11.111,1),(93,7421212,7421201,'ial',11.111,1),(93,7421213,7421201,'all',11.111,1),(93,7421214,7421201,'lly',11.111,1),(93,7421215,7421206,'res',16.667,1),(93,7421216,7421206,'ese',16.667,1),(93,7421217,7421206,'ser',16.667,1),(93,7421218,7421206,'erv',16.667,1),(93,7421219,7421206,'rve',16.667,1),(93,7421220,7421206,'ved',16.667,1),(93,7421221,7421215,'thi',50,1),(93,7421222,7421215,'hin',50,1),(93,7421223,7421221,'pro',10,1),(93,7421224,7421221,'rov',10,1),(93,7421225,7421221,'ovi',10,1),(93,7421226,7421221,'vis',10,1),(93,7421227,7421221,'isi',10,1),(93,7421228,7421221,'sio',10,1),(93,7421229,7421221,'ion',10,1),(93,7421230,7421221,'oni',10,1),(93,7421231,7421221,'nin',10,1),(93,7421232,7421221,'ing',10,1),(93,7421233,7421223,'yes',100,1),(93,7421234,7421233,'att',16.667,1),(93,7421235,7421233,'tta',16.667,1),(93,7421236,7421233,'tac',16.667,1),(93,7421237,7421233,'ach',16.667,1),(93,7421238,7421233,'che',16.667,1),(93,7421239,7421233,'hed',16.667,1),(93,7421240,7421234,'fil',20,1),(93,7421241,7421234,'ilt',20,1),(93,7421242,7421234,'lte',20,1),(93,7421243,7421234,'ter',20,1),(93,7421244,7421234,'ers',20,1),(93,7421245,7421240,'vaa',50,1),(93,7421246,7421240,'aai',50,1),(93,7421247,7421245,'unk',20,1),(93,7421248,7421245,'nkn',20,1),(93,7421249,7421245,'kno',20,1),(93,7421250,7421245,'now',20,1),(93,7421251,7421245,'own',20,1),(93,7421252,7421247,'oth',33.333,1),(93,7421253,7421247,'the',33.333,1),(93,7421254,7421247,'her',33.333,1),(93,7421255,7421252,'uid',50,1),(93,7421256,7421252,'ids',50,1),(93,7421257,7421255,'vml',100,1),(93,7421258,7421257,'dis',20,1),(93,7421259,7421257,'isp',20,1),(93,7421260,7421257,'spl',20,1),(93,7421261,7421257,'pla',20,1),(93,7421262,7421257,'lay',20,1),(93,7421263,7421258,'nam',50,1),(93,7421264,7421258,'ame',50,1),(94,7421266,7421265,'net',25,3),(94,7421267,7421265,'eta',25,3),(94,7421268,7421265,'tap',25,3),(94,7421269,7421265,'app',25,3),(94,7421270,7421266,'fib',33.333,2),(94,7421271,7421266,'ibr',33.333,2),(94,7421272,7421266,'bre',33.333,2),(94,7421273,7421270,'cha',20,2),(94,7421274,7421270,'han',20,2),(94,7421275,7421270,'ann',20,2),(94,7421276,7421270,'nne',20,2),(94,7421277,7421270,'nel',20,2),(94,7421278,7421273,'dis',50,2),(94,7421279,7421273,'isk',50,2),(94,7421280,7421278,'naa',100,4),(94,7421281,7421280,'600',3.333,4),(94,7421282,7421280,'00a',3.333,4),(94,7421283,7421280,'0a0',3.333,4),(94,7421284,7421280,'a09',3.333,4),(94,7421285,7421280,'098',3.333,4),(94,7421286,7421280,'980',3.333,4),(94,7421287,7421280,'804',3.333,4),(94,7421288,7421280,'044',3.333,4),(94,7421289,7421280,'443',3.333,4),(94,7421290,7421280,'430',3.333,4),(94,7421291,7421280,'307',3.333,4),(94,7421292,7421280,'075',3.333,4),(94,7421293,7421280,'753',3.333,4),(94,7421294,7421280,'535',3.333,4),(94,7421295,7421280,'357',3.333,4),(94,7421296,7421280,'573',3.333,4),(94,7421297,7421280,'732',3.333,4),(94,7421298,7421280,'32b',3.333,4),(94,7421299,7421280,'2b3',3.333,4),(94,7421300,7421280,'b33',3.333,4),(94,7421301,7421280,'334',3.333,4),(94,7421302,7421280,'345',3.333,4),(94,7421303,7421280,'457',3.333,4),(94,7421304,7421280,'571',3.333,4),(94,7421305,7421280,'715',3.333,4),(94,7421306,7421280,'153',3.333,4),(94,7421307,7421280,'533',3.333,4),(94,7421308,7421280,'336',3.333,4),(94,7421309,7421280,'364',3.333,4),(94,7421310,7421280,'64e',3.333,4),(94,7421311,7421281,'ser',25,1),(94,7421312,7421281,'eri',25,1),(94,7421313,7421281,'ria',25,1),(94,7421314,7421281,'ial',25,1),(94,7421315,7421311,'siz',50,1),(94,7421316,7421311,'ize',50,1),(94,7421317,7421315,'321',100,1),(94,7421318,7421317,'dev',25,1),(94,7421319,7421317,'evi',25,1),(94,7421320,7421317,'vic',25,1),(94,7421321,7421317,'ice',25,1),(94,7421322,7421318,'typ',50,1),(94,7421323,7421318,'ype',50,1),(94,7421324,7421322,'dir',10,1),(94,7421325,7421322,'ire',10,1),(94,7421326,7421322,'rec',10,1),(94,7421327,7421322,'ect',10,1),(94,7421328,7421322,'cta',10,1),(94,7421329,7421322,'tac',10,1),(94,7421330,7421322,'acc',10,1),(94,7421331,7421322,'cce',10,1),(94,7421332,7421322,'ces',10,1),(94,7421333,7421322,'ess',10,1),(94,7421334,7421324,'mul',14.286,1),(94,7421335,7421324,'ult',14.286,1),(94,7421336,7421324,'lti',14.286,1),(94,7421337,7421324,'tip',14.286,1),(94,7421338,7421324,'ipa',14.286,1),(94,7421339,7421324,'pat',14.286,1),(94,7421340,7421324,'ath',14.286,1),(94,7421341,7421334,'plu',25,1),(94,7421342,7421334,'lug',25,1),(94,7421343,7421334,'ugi',25,1),(94,7421344,7421334,'gin',25,1),(94,7421345,7421341,'nmp',100,1),(94,7421346,7421345,'dev',33.333,1),(94,7421347,7421345,'evf',33.333,1),(94,7421348,7421345,'vfs',33.333,1),(94,7421349,7421346,'pat',50,1),(94,7421350,7421346,'ath',50,1),(94,7421351,7421349,'vmf',50,1),(94,7421352,7421349,'mfs',50,1),(94,7421353,7421351,'dev',20,1),(94,7421354,7421351,'evi',20,1),(94,7421355,7421351,'vic',20,1),(94,7421356,7421351,'ice',20,1),(94,7421357,7421351,'ces',20,1),(94,7421358,7421353,'dis',33.333,1),(94,7421359,7421353,'isk',33.333,1),(94,7421360,7421353,'sks',33.333,1),(94,7421361,7421358,'ven',25,1),(94,7421362,7421358,'end',25,1),(94,7421363,7421358,'ndo',25,1),(94,7421364,7421358,'dor',25,1),(94,7421365,7421361,'mod',33.333,1),(94,7421366,7421361,'ode',33.333,1),(94,7421367,7421361,'del',33.333,1),(94,7421368,7421365,'lun',100,1),(94,7421369,7421368,'cmo',33.333,1),(94,7421370,7421368,'mod',33.333,1),(94,7421371,7421368,'ode',33.333,1),(94,7421372,7421369,'rev',16.667,1),(94,7421373,7421369,'evi',16.667,1),(94,7421374,7421369,'vis',16.667,1),(94,7421375,7421369,'isi',16.667,1),(94,7421376,7421369,'sio',16.667,1),(94,7421377,7421369,'ion',16.667,1),(94,7421378,7421372,'810',50,1),(94,7421379,7421372,'100',50,1),(94,7421380,7421378,'scs',50,1),(94,7421381,7421378,'csi',50,1),(94,7421382,7421380,'lev',33.333,1),(94,7421383,7421380,'eve',33.333,1),(94,7421384,7421380,'vel',33.333,1),(94,7421385,7421382,'pse',25,1),(94,7421386,7421382,'seu',25,1),(94,7421387,7421382,'eud',25,1),(94,7421388,7421382,'udo',25,1),(94,7421389,7421385,'fal',33.333,6),(94,7421390,7421385,'als',33.333,6),(94,7421391,7421385,'lse',33.333,6),(94,7421392,7421389,'sta',25,3),(94,7421393,7421389,'tat',25,3),(94,7421394,7421389,'atu',25,3),(94,7421395,7421389,'tus',25,3),(94,7421396,7421392,'rdm',100,1),(94,7421397,7421396,'cap',20,1),(94,7421398,7421396,'apa',20,1),(94,7421399,7421396,'pab',20,1),(94,7421400,7421396,'abl',20,1),(94,7421401,7421396,'ble',20,1),(94,7421402,7421397,'tru',50,1),(94,7421403,7421397,'rue',50,1),(94,7421404,7421402,'loc',33.333,1),(94,7421405,7421402,'oca',33.333,1),(94,7421406,7421402,'cal',33.333,1),(94,7421407,7421404,'rem',14.286,1),(94,7421408,7421404,'emo',14.286,1),(94,7421409,7421404,'mov',14.286,1),(94,7421410,7421404,'ova',14.286,1),(94,7421411,7421404,'vab',14.286,1),(94,7421412,7421404,'abl',14.286,1),(94,7421413,7421404,'ble',14.286,1),(94,7421414,7421407,'ssd',100,1),(94,7421415,7421414,'off',20,1),(94,7421416,7421414,'ffl',20,1),(94,7421417,7421414,'fli',20,1),(94,7421418,7421414,'lin',20,1),(94,7421419,7421414,'ine',20,1),(94,7421420,7421415,'per',11.111,1),(94,7421421,7421415,'ere',11.111,1),(94,7421422,7421415,'ren',11.111,1),(94,7421423,7421415,'enn',11.111,1),(94,7421424,7421415,'nni',11.111,1),(94,7421425,7421415,'nia',11.111,1),(94,7421426,7421415,'ial',11.111,1),(94,7421427,7421415,'all',11.111,1),(94,7421428,7421415,'lly',11.111,1),(94,7421429,7421420,'res',16.667,1),(94,7421430,7421420,'ese',16.667,1),(94,7421431,7421420,'ser',16.667,1),(94,7421432,7421420,'erv',16.667,1),(94,7421433,7421420,'rve',16.667,1),(94,7421434,7421420,'ved',16.667,1),(94,7421435,7421429,'thi',50,1),(94,7421436,7421429,'hin',50,1),(94,7421437,7421435,'pro',10,1),(94,7421438,7421435,'rov',10,1),(94,7421439,7421435,'ovi',10,1),(94,7421440,7421435,'vis',10,1),(94,7421441,7421435,'isi',10,1),(94,7421442,7421435,'sio',10,1),(94,7421443,7421435,'ion',10,1),(94,7421444,7421435,'oni',10,1),(94,7421445,7421435,'nin',10,1),(94,7421446,7421435,'ing',10,1),(94,7421447,7421437,'yes',100,1),(94,7421448,7421447,'att',16.667,1),(94,7421449,7421447,'tta',16.667,1),(94,7421450,7421447,'tac',16.667,1),(94,7421451,7421447,'ach',16.667,1),(94,7421452,7421447,'che',16.667,1),(94,7421453,7421447,'hed',16.667,1),(94,7421454,7421448,'fil',20,1),(94,7421455,7421448,'ilt',20,1),(94,7421456,7421448,'lte',20,1),(94,7421457,7421448,'ter',20,1),(94,7421458,7421448,'ers',20,1),(94,7421459,7421454,'vaa',50,1),(94,7421460,7421454,'aai',50,1),(94,7421461,7421459,'unk',20,1),(94,7421462,7421459,'nkn',20,1),(94,7421463,7421459,'kno',20,1),(94,7421464,7421459,'now',20,1),(94,7421465,7421459,'own',20,1),(94,7421466,7421461,'oth',33.333,1),(94,7421467,7421461,'the',33.333,1),(94,7421468,7421461,'her',33.333,1),(94,7421469,7421466,'uid',50,1),(94,7421470,7421466,'ids',50,1),(94,7421471,7421469,'vml',100,1),(94,7421472,7421471,'dis',20,1),(94,7421473,7421471,'isp',20,1),(94,7421474,7421471,'spl',20,1),(94,7421475,7421471,'pla',20,1),(94,7421476,7421471,'lay',20,1),(94,7421477,7421472,'nam',50,1),(94,7421478,7421472,'ame',50,1),(95,7421480,7421479,'net',25,3),(95,7421481,7421479,'eta',25,3),(95,7421482,7421479,'tap',25,3),(95,7421483,7421479,'app',25,3),(95,7421484,7421480,'fib',33.333,2),(95,7421485,7421480,'ibr',33.333,2),(95,7421486,7421480,'bre',33.333,2),(95,7421487,7421484,'cha',20,2),(95,7421488,7421484,'han',20,2),(95,7421489,7421484,'ann',20,2),(95,7421490,7421484,'nne',20,2),(95,7421491,7421484,'nel',20,2),(95,7421492,7421487,'dis',50,2),(95,7421493,7421487,'isk',50,2),(95,7421494,7421492,'naa',100,4),(95,7421495,7421494,'600',3.333,4),(95,7421496,7421494,'00a',3.333,4),(95,7421497,7421494,'0a0',3.333,4),(95,7421498,7421494,'a09',3.333,4),(95,7421499,7421494,'098',3.333,4),(95,7421500,7421494,'980',3.333,4),(95,7421501,7421494,'804',3.333,4),(95,7421502,7421494,'044',3.333,4),(95,7421503,7421494,'443',3.333,4),(95,7421504,7421494,'430',3.333,4),(95,7421505,7421494,'307',3.333,4),(95,7421506,7421494,'075',3.333,4),(95,7421507,7421494,'753',3.333,4),(95,7421508,7421494,'535',3.333,4),(95,7421509,7421494,'357',3.333,4),(95,7421510,7421494,'573',3.333,4),(95,7421511,7421494,'732',3.333,4),(95,7421512,7421494,'32b',3.333,4),(95,7421513,7421494,'2b3',3.333,4),(95,7421514,7421494,'b33',3.333,4),(95,7421515,7421494,'334',3.333,4),(95,7421516,7421494,'345',3.333,4),(95,7421517,7421494,'457',3.333,4),(95,7421518,7421494,'571',3.333,4),(95,7421519,7421494,'715',3.333,4),(95,7421520,7421494,'153',3.333,4),(95,7421521,7421494,'533',3.333,4),(95,7421522,7421494,'336',3.333,4),(95,7421523,7421494,'364',3.333,4),(95,7421524,7421494,'64f',3.333,4),(95,7421525,7421495,'ser',25,1),(95,7421526,7421495,'eri',25,1),(95,7421527,7421495,'ria',25,1),(95,7421528,7421495,'ial',25,1),(95,7421529,7421525,'siz',50,1),(95,7421530,7421525,'ize',50,1),(95,7421531,7421529,'321',100,1),(95,7421532,7421531,'dev',25,1),(95,7421533,7421531,'evi',25,1),(95,7421534,7421531,'vic',25,1),(95,7421535,7421531,'ice',25,1),(95,7421536,7421532,'typ',50,1),(95,7421537,7421532,'ype',50,1),(95,7421538,7421536,'dir',10,1),(95,7421539,7421536,'ire',10,1),(95,7421540,7421536,'rec',10,1),(95,7421541,7421536,'ect',10,1),(95,7421542,7421536,'cta',10,1),(95,7421543,7421536,'tac',10,1),(95,7421544,7421536,'acc',10,1),(95,7421545,7421536,'cce',10,1),(95,7421546,7421536,'ces',10,1),(95,7421547,7421536,'ess',10,1),(95,7421548,7421538,'mul',14.286,1),(95,7421549,7421538,'ult',14.286,1),(95,7421550,7421538,'lti',14.286,1),(95,7421551,7421538,'tip',14.286,1),(95,7421552,7421538,'ipa',14.286,1),(95,7421553,7421538,'pat',14.286,1),(95,7421554,7421538,'ath',14.286,1),(95,7421555,7421548,'plu',25,1),(95,7421556,7421548,'lug',25,1),(95,7421557,7421548,'ugi',25,1),(95,7421558,7421548,'gin',25,1),(95,7421559,7421555,'nmp',100,1),(95,7421560,7421559,'dev',33.333,1),(95,7421561,7421559,'evf',33.333,1),(95,7421562,7421559,'vfs',33.333,1),(95,7421563,7421560,'pat',50,1),(95,7421564,7421560,'ath',50,1),(95,7421565,7421563,'vmf',50,1),(95,7421566,7421563,'mfs',50,1),(95,7421567,7421565,'dev',20,1),(95,7421568,7421565,'evi',20,1),(95,7421569,7421565,'vic',20,1),(95,7421570,7421565,'ice',20,1),(95,7421571,7421565,'ces',20,1),(95,7421572,7421567,'dis',33.333,1),(95,7421573,7421567,'isk',33.333,1),(95,7421574,7421567,'sks',33.333,1),(95,7421575,7421572,'ven',25,1),(95,7421576,7421572,'end',25,1),(95,7421577,7421572,'ndo',25,1),(95,7421578,7421572,'dor',25,1),(95,7421579,7421575,'mod',33.333,1),(95,7421580,7421575,'ode',33.333,1),(95,7421581,7421575,'del',33.333,1),(95,7421582,7421579,'lun',100,1),(95,7421583,7421582,'cmo',33.333,1),(95,7421584,7421582,'mod',33.333,1),(95,7421585,7421582,'ode',33.333,1),(95,7421586,7421583,'rev',16.667,1),(95,7421587,7421583,'evi',16.667,1),(95,7421588,7421583,'vis',16.667,1),(95,7421589,7421583,'isi',16.667,1),(95,7421590,7421583,'sio',16.667,1),(95,7421591,7421583,'ion',16.667,1),(95,7421592,7421586,'810',50,1),(95,7421593,7421586,'100',50,1),(95,7421594,7421592,'scs',50,1),(95,7421595,7421592,'csi',50,1),(95,7421596,7421594,'lev',33.333,1),(95,7421597,7421594,'eve',33.333,1),(95,7421598,7421594,'vel',33.333,1),(95,7421599,7421596,'pse',25,1),(95,7421600,7421596,'seu',25,1),(95,7421601,7421596,'eud',25,1),(95,7421602,7421596,'udo',25,1),(95,7421603,7421599,'fal',33.333,6),(95,7421604,7421599,'als',33.333,6),(95,7421605,7421599,'lse',33.333,6),(95,7421606,7421603,'sta',25,3),(95,7421607,7421603,'tat',25,3),(95,7421608,7421603,'atu',25,3),(95,7421609,7421603,'tus',25,3),(95,7421610,7421606,'rdm',100,1),(95,7421611,7421610,'cap',20,1),(95,7421612,7421610,'apa',20,1),(95,7421613,7421610,'pab',20,1),(95,7421614,7421610,'abl',20,1),(95,7421615,7421610,'ble',20,1),(95,7421616,7421611,'tru',50,1),(95,7421617,7421611,'rue',50,1),(95,7421618,7421616,'loc',33.333,1),(95,7421619,7421616,'oca',33.333,1),(95,7421620,7421616,'cal',33.333,1),(95,7421621,7421618,'rem',14.286,1),(95,7421622,7421618,'emo',14.286,1),(95,7421623,7421618,'mov',14.286,1),(95,7421624,7421618,'ova',14.286,1),(95,7421625,7421618,'vab',14.286,1),(95,7421626,7421618,'abl',14.286,1),(95,7421627,7421618,'ble',14.286,1),(95,7421628,7421621,'ssd',100,1),(95,7421629,7421628,'off',20,1),(95,7421630,7421628,'ffl',20,1),(95,7421631,7421628,'fli',20,1),(95,7421632,7421628,'lin',20,1),(95,7421633,7421628,'ine',20,1),(95,7421634,7421629,'per',11.111,1),(95,7421635,7421629,'ere',11.111,1),(95,7421636,7421629,'ren',11.111,1),(95,7421637,7421629,'enn',11.111,1),(95,7421638,7421629,'nni',11.111,1),(95,7421639,7421629,'nia',11.111,1),(95,7421640,7421629,'ial',11.111,1),(95,7421641,7421629,'all',11.111,1),(95,7421642,7421629,'lly',11.111,1),(95,7421643,7421634,'res',16.667,1),(95,7421644,7421634,'ese',16.667,1),(95,7421645,7421634,'ser',16.667,1),(95,7421646,7421634,'erv',16.667,1),(95,7421647,7421634,'rve',16.667,1),(95,7421648,7421634,'ved',16.667,1),(95,7421649,7421643,'thi',50,1),(95,7421650,7421643,'hin',50,1),(95,7421651,7421649,'pro',10,1),(95,7421652,7421649,'rov',10,1),(95,7421653,7421649,'ovi',10,1),(95,7421654,7421649,'vis',10,1),(95,7421655,7421649,'isi',10,1),(95,7421656,7421649,'sio',10,1),(95,7421657,7421649,'ion',10,1),(95,7421658,7421649,'oni',10,1),(95,7421659,7421649,'nin',10,1),(95,7421660,7421649,'ing',10,1),(95,7421661,7421651,'yes',100,1),(95,7421662,7421661,'att',16.667,1),(95,7421663,7421661,'tta',16.667,1),(95,7421664,7421661,'tac',16.667,1),(95,7421665,7421661,'ach',16.667,1),(95,7421666,7421661,'che',16.667,1),(95,7421667,7421661,'hed',16.667,1),(95,7421668,7421662,'fil',20,1),(95,7421669,7421662,'ilt',20,1),(95,7421670,7421662,'lte',20,1),(95,7421671,7421662,'ter',20,1),(95,7421672,7421662,'ers',20,1),(95,7421673,7421668,'vaa',50,1),(95,7421674,7421668,'aai',50,1),(95,7421675,7421673,'unk',20,1),(95,7421676,7421673,'nkn',20,1),(95,7421677,7421673,'kno',20,1),(95,7421678,7421673,'now',20,1),(95,7421679,7421673,'own',20,1),(95,7421680,7421675,'oth',33.333,1),(95,7421681,7421675,'the',33.333,1),(95,7421682,7421675,'her',33.333,1),(95,7421683,7421680,'uid',50,1),(95,7421684,7421680,'ids',50,1),(95,7421685,7421683,'vml',100,1),(95,7421686,7421685,'dis',20,1),(95,7421687,7421685,'isp',20,1),(95,7421688,7421685,'spl',20,1),(95,7421689,7421685,'pla',20,1),(95,7421690,7421685,'lay',20,1),(95,7421691,7421686,'nam',50,1),(95,7421692,7421686,'ame',50,1),(96,7421694,7421693,'net',25,3),(96,7421695,7421693,'eta',25,3),(96,7421696,7421693,'tap',25,3),(96,7421697,7421693,'app',25,3),(96,7421698,7421694,'fib',33.333,2),(96,7421699,7421694,'ibr',33.333,2),(96,7421700,7421694,'bre',33.333,2),(96,7421701,7421698,'cha',20,2),(96,7421702,7421698,'han',20,2),(96,7421703,7421698,'ann',20,2),(96,7421704,7421698,'nne',20,2),(96,7421705,7421698,'nel',20,2),(96,7421706,7421701,'dis',50,2),(96,7421707,7421701,'isk',50,2),(96,7421708,7421706,'naa',100,4),(96,7421709,7421708,'600',3.333,4),(96,7421710,7421708,'00a',3.333,4),(96,7421711,7421708,'0a0',3.333,4),(96,7421712,7421708,'a09',3.333,4),(96,7421713,7421708,'098',3.333,4),(96,7421714,7421708,'980',3.333,4),(96,7421715,7421708,'804',3.333,4),(96,7421716,7421708,'044',3.333,4),(96,7421717,7421708,'443',3.333,4),(96,7421718,7421708,'430',3.333,4),(96,7421719,7421708,'307',3.333,4),(96,7421720,7421708,'072',3.333,4),(96,7421721,7421708,'725',3.333,4),(96,7421722,7421708,'259',3.333,4),(96,7421723,7421708,'593',3.333,4),(96,7421724,7421708,'931',3.333,4),(96,7421725,7421708,'313',3.333,4),(96,7421726,7421708,'13f',3.333,4),(96,7421727,7421708,'3f3',3.333,4),(96,7421728,7421708,'f33',3.333,4),(96,7421729,7421708,'334',3.333,4),(96,7421730,7421708,'345',3.333,4),(96,7421731,7421708,'455',3.333,4),(96,7421732,7421708,'556',3.333,4),(96,7421733,7421708,'563',3.333,4),(96,7421734,7421708,'639',3.333,4),(96,7421735,7421708,'393',3.333,4),(96,7421736,7421708,'934',3.333,4),(96,7421737,7421708,'344',3.333,4),(96,7421738,7421708,'441',3.333,4),(96,7421739,7421709,'ser',25,1),(96,7421740,7421709,'eri',25,1),(96,7421741,7421709,'ria',25,1),(96,7421742,7421709,'ial',25,1),(96,7421743,7421739,'siz',50,1),(96,7421744,7421739,'ize',50,1),(96,7421745,7421743,'321',100,1),(96,7421746,7421745,'dev',25,1),(96,7421747,7421745,'evi',25,1),(96,7421748,7421745,'vic',25,1),(96,7421749,7421745,'ice',25,1),(96,7421750,7421746,'typ',50,1),(96,7421751,7421746,'ype',50,1),(96,7421752,7421750,'dir',10,1),(96,7421753,7421750,'ire',10,1),(96,7421754,7421750,'rec',10,1),(96,7421755,7421750,'ect',10,1),(96,7421756,7421750,'cta',10,1),(96,7421757,7421750,'tac',10,1),(96,7421758,7421750,'acc',10,1),(96,7421759,7421750,'cce',10,1),(96,7421760,7421750,'ces',10,1),(96,7421761,7421750,'ess',10,1),(96,7421762,7421752,'mul',14.286,1),(96,7421763,7421752,'ult',14.286,1),(96,7421764,7421752,'lti',14.286,1),(96,7421765,7421752,'tip',14.286,1),(96,7421766,7421752,'ipa',14.286,1),(96,7421767,7421752,'pat',14.286,1),(96,7421768,7421752,'ath',14.286,1),(96,7421769,7421762,'plu',25,1),(96,7421770,7421762,'lug',25,1),(96,7421771,7421762,'ugi',25,1),(96,7421772,7421762,'gin',25,1),(96,7421773,7421769,'nmp',100,1),(96,7421774,7421773,'dev',33.333,1),(96,7421775,7421773,'evf',33.333,1),(96,7421776,7421773,'vfs',33.333,1),(96,7421777,7421774,'pat',50,1),(96,7421778,7421774,'ath',50,1),(96,7421779,7421777,'vmf',50,1),(96,7421780,7421777,'mfs',50,1),(96,7421781,7421779,'dev',20,1),(96,7421782,7421779,'evi',20,1),(96,7421783,7421779,'vic',20,1),(96,7421784,7421779,'ice',20,1),(96,7421785,7421779,'ces',20,1),(96,7421786,7421781,'dis',33.333,1),(96,7421787,7421781,'isk',33.333,1),(96,7421788,7421781,'sks',33.333,1),(96,7421789,7421786,'ven',25,1),(96,7421790,7421786,'end',25,1),(96,7421791,7421786,'ndo',25,1),(96,7421792,7421786,'dor',25,1),(96,7421793,7421789,'mod',33.333,1),(96,7421794,7421789,'ode',33.333,1),(96,7421795,7421789,'del',33.333,1),(96,7421796,7421793,'lun',100,1),(96,7421797,7421796,'cmo',33.333,1),(96,7421798,7421796,'mod',33.333,1),(96,7421799,7421796,'ode',33.333,1),(96,7421800,7421797,'rev',16.667,1),(96,7421801,7421797,'evi',16.667,1),(96,7421802,7421797,'vis',16.667,1),(96,7421803,7421797,'isi',16.667,1),(96,7421804,7421797,'sio',16.667,1),(96,7421805,7421797,'ion',16.667,1),(96,7421806,7421800,'810',50,1),(96,7421807,7421800,'100',50,1),(96,7421808,7421806,'scs',50,1),(96,7421809,7421806,'csi',50,1),(96,7421810,7421808,'lev',33.333,1),(96,7421811,7421808,'eve',33.333,1),(96,7421812,7421808,'vel',33.333,1),(96,7421813,7421810,'pse',25,1),(96,7421814,7421810,'seu',25,1),(96,7421815,7421810,'eud',25,1),(96,7421816,7421810,'udo',25,1),(96,7421817,7421813,'fal',33.333,6),(96,7421818,7421813,'als',33.333,6),(96,7421819,7421813,'lse',33.333,6),(96,7421820,7421817,'sta',25,3),(96,7421821,7421817,'tat',25,3),(96,7421822,7421817,'atu',25,3),(96,7421823,7421817,'tus',25,3),(96,7421824,7421820,'rdm',100,1),(96,7421825,7421824,'cap',20,1),(96,7421826,7421824,'apa',20,1),(96,7421827,7421824,'pab',20,1),(96,7421828,7421824,'abl',20,1),(96,7421829,7421824,'ble',20,1),(96,7421830,7421825,'tru',50,1),(96,7421831,7421825,'rue',50,1),(96,7421832,7421830,'loc',33.333,1),(96,7421833,7421830,'oca',33.333,1),(96,7421834,7421830,'cal',33.333,1),(96,7421835,7421832,'rem',14.286,1),(96,7421836,7421832,'emo',14.286,1),(96,7421837,7421832,'mov',14.286,1),(96,7421838,7421832,'ova',14.286,1),(96,7421839,7421832,'vab',14.286,1),(96,7421840,7421832,'abl',14.286,1),(96,7421841,7421832,'ble',14.286,1),(96,7421842,7421835,'ssd',100,1),(96,7421843,7421842,'off',20,1),(96,7421844,7421842,'ffl',20,1),(96,7421845,7421842,'fli',20,1),(96,7421846,7421842,'lin',20,1),(96,7421847,7421842,'ine',20,1),(96,7421848,7421843,'per',11.111,1),(96,7421849,7421843,'ere',11.111,1),(96,7421850,7421843,'ren',11.111,1),(96,7421851,7421843,'enn',11.111,1),(96,7421852,7421843,'nni',11.111,1),(96,7421853,7421843,'nia',11.111,1),(96,7421854,7421843,'ial',11.111,1),(96,7421855,7421843,'all',11.111,1),(96,7421856,7421843,'lly',11.111,1),(96,7421857,7421848,'res',16.667,1),(96,7421858,7421848,'ese',16.667,1),(96,7421859,7421848,'ser',16.667,1),(96,7421860,7421848,'erv',16.667,1),(96,7421861,7421848,'rve',16.667,1),(96,7421862,7421848,'ved',16.667,1),(96,7421863,7421857,'thi',50,1),(96,7421864,7421857,'hin',50,1),(96,7421865,7421863,'pro',10,1),(96,7421866,7421863,'rov',10,1),(96,7421867,7421863,'ovi',10,1),(96,7421868,7421863,'vis',10,1),(96,7421869,7421863,'isi',10,1),(96,7421870,7421863,'sio',10,1),(96,7421871,7421863,'ion',10,1),(96,7421872,7421863,'oni',10,1),(96,7421873,7421863,'nin',10,1),(96,7421874,7421863,'ing',10,1),(96,7421875,7421865,'yes',100,1),(96,7421876,7421875,'att',16.667,1),(96,7421877,7421875,'tta',16.667,1),(96,7421878,7421875,'tac',16.667,1),(96,7421879,7421875,'ach',16.667,1),(96,7421880,7421875,'che',16.667,1),(96,7421881,7421875,'hed',16.667,1),(96,7421882,7421876,'fil',20,1),(96,7421883,7421876,'ilt',20,1),(96,7421884,7421876,'lte',20,1),(96,7421885,7421876,'ter',20,1),(96,7421886,7421876,'ers',20,1),(96,7421887,7421882,'vaa',50,1),(96,7421888,7421882,'aai',50,1),(96,7421889,7421887,'unk',20,1),(96,7421890,7421887,'nkn',20,1),(96,7421891,7421887,'kno',20,1),(96,7421892,7421887,'now',20,1),(96,7421893,7421887,'own',20,1),(96,7421894,7421889,'oth',33.333,1),(96,7421895,7421889,'the',33.333,1),(96,7421896,7421889,'her',33.333,1),(96,7421897,7421894,'uid',50,1),(96,7421898,7421894,'ids',50,1),(96,7421899,7421897,'vml',100,1),(96,7421900,7421899,'dis',20,1),(96,7421901,7421899,'isp',20,1),(96,7421902,7421899,'spl',20,1),(96,7421903,7421899,'pla',20,1),(96,7421904,7421899,'lay',20,1),(96,7421905,7421900,'nam',50,1),(96,7421906,7421900,'ame',50,1),(97,7421908,7421907,'net',25,3),(97,7421909,7421907,'eta',25,3),(97,7421910,7421907,'tap',25,3),(97,7421911,7421907,'app',25,3),(97,7421912,7421908,'fib',33.333,2),(97,7421913,7421908,'ibr',33.333,2),(97,7421914,7421908,'bre',33.333,2),(97,7421915,7421912,'cha',20,2),(97,7421916,7421912,'han',20,2),(97,7421917,7421912,'ann',20,2),(97,7421918,7421912,'nne',20,2),(97,7421919,7421912,'nel',20,2),(97,7421920,7421915,'dis',50,2),(97,7421921,7421915,'isk',50,2),(97,7421922,7421920,'naa',100,4),(97,7421923,7421922,'600',3.333,4),(97,7421924,7421922,'00a',3.333,4),(97,7421925,7421922,'0a0',3.333,4),(97,7421926,7421922,'a09',3.333,4),(97,7421927,7421922,'098',3.333,4),(97,7421928,7421922,'980',3.333,4),(97,7421929,7421922,'804',3.333,4),(97,7421930,7421922,'044',3.333,4),(97,7421931,7421922,'443',3.333,4),(97,7421932,7421922,'430',3.333,4),(97,7421933,7421922,'307',3.333,4),(97,7421934,7421922,'072',3.333,4),(97,7421935,7421922,'725',3.333,4),(97,7421936,7421922,'259',3.333,4),(97,7421937,7421922,'593',3.333,4),(97,7421938,7421922,'931',3.333,4),(97,7421939,7421922,'313',3.333,4),(97,7421940,7421922,'13f',3.333,4),(97,7421941,7421922,'3f3',3.333,4),(97,7421942,7421922,'f33',3.333,4),(97,7421943,7421922,'334',3.333,4),(97,7421944,7421922,'345',3.333,4),(97,7421945,7421922,'455',3.333,4),(97,7421946,7421922,'556',3.333,4),(97,7421947,7421922,'563',3.333,4),(97,7421948,7421922,'639',3.333,4),(97,7421949,7421922,'393',3.333,4),(97,7421950,7421922,'934',3.333,4),(97,7421951,7421922,'344',3.333,4),(97,7421952,7421922,'442',3.333,4),(97,7421953,7421923,'ser',25,1),(97,7421954,7421923,'eri',25,1),(97,7421955,7421923,'ria',25,1),(97,7421956,7421923,'ial',25,1),(97,7421957,7421953,'siz',50,1),(97,7421958,7421953,'ize',50,1),(97,7421959,7421957,'321',100,1),(97,7421960,7421959,'dev',25,1),(97,7421961,7421959,'evi',25,1),(97,7421962,7421959,'vic',25,1),(97,7421963,7421959,'ice',25,1),(97,7421964,7421960,'typ',50,1),(97,7421965,7421960,'ype',50,1),(97,7421966,7421964,'dir',10,1),(97,7421967,7421964,'ire',10,1),(97,7421968,7421964,'rec',10,1),(97,7421969,7421964,'ect',10,1),(97,7421970,7421964,'cta',10,1),(97,7421971,7421964,'tac',10,1),(97,7421972,7421964,'acc',10,1),(97,7421973,7421964,'cce',10,1),(97,7421974,7421964,'ces',10,1),(97,7421975,7421964,'ess',10,1),(97,7421976,7421966,'mul',14.286,1),(97,7421977,7421966,'ult',14.286,1),(97,7421978,7421966,'lti',14.286,1),(97,7421979,7421966,'tip',14.286,1),(97,7421980,7421966,'ipa',14.286,1),(97,7421981,7421966,'pat',14.286,1),(97,7421982,7421966,'ath',14.286,1),(97,7421983,7421976,'plu',25,1),(97,7421984,7421976,'lug',25,1),(97,7421985,7421976,'ugi',25,1),(97,7421986,7421976,'gin',25,1),(97,7421987,7421983,'nmp',100,1),(97,7421988,7421987,'dev',33.333,1),(97,7421989,7421987,'evf',33.333,1),(97,7421990,7421987,'vfs',33.333,1),(97,7421991,7421988,'pat',50,1),(97,7421992,7421988,'ath',50,1),(97,7421993,7421991,'vmf',50,1),(97,7421994,7421991,'mfs',50,1),(97,7421995,7421993,'dev',20,1),(97,7421996,7421993,'evi',20,1),(97,7421997,7421993,'vic',20,1),(97,7421998,7421993,'ice',20,1),(97,7421999,7421993,'ces',20,1),(97,7422000,7421995,'dis',33.333,1),(97,7422001,7421995,'isk',33.333,1),(97,7422002,7421995,'sks',33.333,1),(97,7422003,7422000,'ven',25,1),(97,7422004,7422000,'end',25,1),(97,7422005,7422000,'ndo',25,1),(97,7422006,7422000,'dor',25,1),(97,7422007,7422003,'mod',33.333,1),(97,7422008,7422003,'ode',33.333,1),(97,7422009,7422003,'del',33.333,1),(97,7422010,7422007,'lun',100,1),(97,7422011,7422010,'cmo',33.333,1),(97,7422012,7422010,'mod',33.333,1),(97,7422013,7422010,'ode',33.333,1),(97,7422014,7422011,'rev',16.667,1),(97,7422015,7422011,'evi',16.667,1),(97,7422016,7422011,'vis',16.667,1),(97,7422017,7422011,'isi',16.667,1),(97,7422018,7422011,'sio',16.667,1),(97,7422019,7422011,'ion',16.667,1),(97,7422020,7422014,'810',50,1),(97,7422021,7422014,'100',50,1),(97,7422022,7422020,'scs',50,1),(97,7422023,7422020,'csi',50,1),(97,7422024,7422022,'lev',33.333,1),(97,7422025,7422022,'eve',33.333,1),(97,7422026,7422022,'vel',33.333,1),(97,7422027,7422024,'pse',25,1),(97,7422028,7422024,'seu',25,1),(97,7422029,7422024,'eud',25,1),(97,7422030,7422024,'udo',25,1),(97,7422031,7422027,'fal',33.333,6),(97,7422032,7422027,'als',33.333,6),(97,7422033,7422027,'lse',33.333,6),(97,7422034,7422031,'sta',25,3),(97,7422035,7422031,'tat',25,3),(97,7422036,7422031,'atu',25,3),(97,7422037,7422031,'tus',25,3),(97,7422038,7422034,'rdm',100,1),(97,7422039,7422038,'cap',20,1),(97,7422040,7422038,'apa',20,1),(97,7422041,7422038,'pab',20,1),(97,7422042,7422038,'abl',20,1),(97,7422043,7422038,'ble',20,1),(97,7422044,7422039,'tru',50,1),(97,7422045,7422039,'rue',50,1),(97,7422046,7422044,'loc',33.333,1),(97,7422047,7422044,'oca',33.333,1),(97,7422048,7422044,'cal',33.333,1),(97,7422049,7422046,'rem',14.286,1),(97,7422050,7422046,'emo',14.286,1),(97,7422051,7422046,'mov',14.286,1),(97,7422052,7422046,'ova',14.286,1),(97,7422053,7422046,'vab',14.286,1),(97,7422054,7422046,'abl',14.286,1),(97,7422055,7422046,'ble',14.286,1),(97,7422056,7422049,'ssd',100,1),(97,7422057,7422056,'off',20,1),(97,7422058,7422056,'ffl',20,1),(97,7422059,7422056,'fli',20,1),(97,7422060,7422056,'lin',20,1),(97,7422061,7422056,'ine',20,1),(97,7422062,7422057,'per',11.111,1),(97,7422063,7422057,'ere',11.111,1),(97,7422064,7422057,'ren',11.111,1),(97,7422065,7422057,'enn',11.111,1),(97,7422066,7422057,'nni',11.111,1),(97,7422067,7422057,'nia',11.111,1),(97,7422068,7422057,'ial',11.111,1),(97,7422069,7422057,'all',11.111,1),(97,7422070,7422057,'lly',11.111,1),(97,7422071,7422062,'res',16.667,1),(97,7422072,7422062,'ese',16.667,1),(97,7422073,7422062,'ser',16.667,1),(97,7422074,7422062,'erv',16.667,1),(97,7422075,7422062,'rve',16.667,1),(97,7422076,7422062,'ved',16.667,1),(97,7422077,7422071,'thi',50,1),(97,7422078,7422071,'hin',50,1),(97,7422079,7422077,'pro',10,1),(97,7422080,7422077,'rov',10,1),(97,7422081,7422077,'ovi',10,1),(97,7422082,7422077,'vis',10,1),(97,7422083,7422077,'isi',10,1),(97,7422084,7422077,'sio',10,1),(97,7422085,7422077,'ion',10,1),(97,7422086,7422077,'oni',10,1),(97,7422087,7422077,'nin',10,1),(97,7422088,7422077,'ing',10,1),(97,7422089,7422079,'yes',100,1),(97,7422090,7422089,'att',16.667,1),(97,7422091,7422089,'tta',16.667,1),(97,7422092,7422089,'tac',16.667,1),(97,7422093,7422089,'ach',16.667,1),(97,7422094,7422089,'che',16.667,1),(97,7422095,7422089,'hed',16.667,1),(97,7422096,7422090,'fil',20,1),(97,7422097,7422090,'ilt',20,1),(97,7422098,7422090,'lte',20,1),(97,7422099,7422090,'ter',20,1),(97,7422100,7422090,'ers',20,1),(97,7422101,7422096,'vaa',50,1),(97,7422102,7422096,'aai',50,1),(97,7422103,7422101,'unk',20,1),(97,7422104,7422101,'nkn',20,1),(97,7422105,7422101,'kno',20,1),(97,7422106,7422101,'now',20,1),(97,7422107,7422101,'own',20,1),(97,7422108,7422103,'oth',33.333,1),(97,7422109,7422103,'the',33.333,1),(97,7422110,7422103,'her',33.333,1),(97,7422111,7422108,'uid',50,1),(97,7422112,7422108,'ids',50,1),(97,7422113,7422111,'vml',100,1),(97,7422114,7422113,'dis',20,1),(97,7422115,7422113,'isp',20,1),(97,7422116,7422113,'spl',20,1),(97,7422117,7422113,'pla',20,1),(97,7422118,7422113,'lay',20,1),(97,7422119,7422114,'nam',50,1),(97,7422120,7422114,'ame',50,1),(98,7422122,7422121,'net',25,3),(98,7422123,7422121,'eta',25,3),(98,7422124,7422121,'tap',25,3),(98,7422125,7422121,'app',25,3),(98,7422126,7422122,'fib',33.333,2),(98,7422127,7422122,'ibr',33.333,2),(98,7422128,7422122,'bre',33.333,2),(98,7422129,7422126,'cha',20,2),(98,7422130,7422126,'han',20,2),(98,7422131,7422126,'ann',20,2),(98,7422132,7422126,'nne',20,2),(98,7422133,7422126,'nel',20,2),(98,7422134,7422129,'dis',50,2),(98,7422135,7422129,'isk',50,2),(98,7422136,7422134,'naa',100,4),(98,7422137,7422136,'600',3.333,4),(98,7422138,7422136,'00a',3.333,4),(98,7422139,7422136,'0a0',3.333,4),(98,7422140,7422136,'a09',3.333,4),(98,7422141,7422136,'098',3.333,4),(98,7422142,7422136,'980',3.333,4),(98,7422143,7422136,'804',3.333,4),(98,7422144,7422136,'044',3.333,4),(98,7422145,7422136,'443',3.333,4),(98,7422146,7422136,'430',3.333,4),(98,7422147,7422136,'307',3.333,4),(98,7422148,7422136,'072',3.333,4),(98,7422149,7422136,'725',3.333,4),(98,7422150,7422136,'259',3.333,4),(98,7422151,7422136,'593',3.333,4),(98,7422152,7422136,'931',3.333,4),(98,7422153,7422136,'313',3.333,4),(98,7422154,7422136,'13f',3.333,4),(98,7422155,7422136,'3f3',3.333,4),(98,7422156,7422136,'f33',3.333,4),(98,7422157,7422136,'334',3.333,4),(98,7422158,7422136,'345',3.333,4),(98,7422159,7422136,'455',3.333,4),(98,7422160,7422136,'556',3.333,4),(98,7422161,7422136,'563',3.333,4),(98,7422162,7422136,'639',3.333,4),(98,7422163,7422136,'393',3.333,4),(98,7422164,7422136,'934',3.333,4),(98,7422165,7422136,'344',3.333,4),(98,7422166,7422136,'443',3.333,4),(98,7422167,7422137,'ser',25,1),(98,7422168,7422137,'eri',25,1),(98,7422169,7422137,'ria',25,1),(98,7422170,7422137,'ial',25,1),(98,7422171,7422167,'siz',50,1),(98,7422172,7422167,'ize',50,1),(98,7422173,7422171,'321',100,1),(98,7422174,7422173,'dev',25,1),(98,7422175,7422173,'evi',25,1),(98,7422176,7422173,'vic',25,1),(98,7422177,7422173,'ice',25,1),(98,7422178,7422174,'typ',50,1),(98,7422179,7422174,'ype',50,1),(98,7422180,7422178,'dir',10,1),(98,7422181,7422178,'ire',10,1),(98,7422182,7422178,'rec',10,1),(98,7422183,7422178,'ect',10,1),(98,7422184,7422178,'cta',10,1),(98,7422185,7422178,'tac',10,1),(98,7422186,7422178,'acc',10,1),(98,7422187,7422178,'cce',10,1),(98,7422188,7422178,'ces',10,1),(98,7422189,7422178,'ess',10,1),(98,7422190,7422180,'mul',14.286,1),(98,7422191,7422180,'ult',14.286,1),(98,7422192,7422180,'lti',14.286,1),(98,7422193,7422180,'tip',14.286,1),(98,7422194,7422180,'ipa',14.286,1),(98,7422195,7422180,'pat',14.286,1),(98,7422196,7422180,'ath',14.286,1),(98,7422197,7422190,'plu',25,1),(98,7422198,7422190,'lug',25,1),(98,7422199,7422190,'ugi',25,1),(98,7422200,7422190,'gin',25,1),(98,7422201,7422197,'nmp',100,1),(98,7422202,7422201,'dev',33.333,1),(98,7422203,7422201,'evf',33.333,1),(98,7422204,7422201,'vfs',33.333,1),(98,7422205,7422202,'pat',50,1),(98,7422206,7422202,'ath',50,1),(98,7422207,7422205,'vmf',50,1),(98,7422208,7422205,'mfs',50,1),(98,7422209,7422207,'dev',20,1),(98,7422210,7422207,'evi',20,1),(98,7422211,7422207,'vic',20,1),(98,7422212,7422207,'ice',20,1),(98,7422213,7422207,'ces',20,1),(98,7422214,7422209,'dis',33.333,1),(98,7422215,7422209,'isk',33.333,1),(98,7422216,7422209,'sks',33.333,1),(98,7422217,7422214,'ven',25,1),(98,7422218,7422214,'end',25,1),(98,7422219,7422214,'ndo',25,1),(98,7422220,7422214,'dor',25,1),(98,7422221,7422217,'mod',33.333,1),(98,7422222,7422217,'ode',33.333,1),(98,7422223,7422217,'del',33.333,1),(98,7422224,7422221,'lun',100,1),(98,7422225,7422224,'cmo',33.333,1),(98,7422226,7422224,'mod',33.333,1),(98,7422227,7422224,'ode',33.333,1),(98,7422228,7422225,'rev',16.667,1),(98,7422229,7422225,'evi',16.667,1),(98,7422230,7422225,'vis',16.667,1),(98,7422231,7422225,'isi',16.667,1),(98,7422232,7422225,'sio',16.667,1),(98,7422233,7422225,'ion',16.667,1),(98,7422234,7422228,'810',50,1),(98,7422235,7422228,'100',50,1),(98,7422236,7422234,'scs',50,1),(98,7422237,7422234,'csi',50,1),(98,7422238,7422236,'lev',33.333,1),(98,7422239,7422236,'eve',33.333,1),(98,7422240,7422236,'vel',33.333,1),(98,7422241,7422238,'pse',25,1),(98,7422242,7422238,'seu',25,1),(98,7422243,7422238,'eud',25,1),(98,7422244,7422238,'udo',25,1),(98,7422245,7422241,'fal',33.333,6),(98,7422246,7422241,'als',33.333,6),(98,7422247,7422241,'lse',33.333,6),(98,7422248,7422245,'sta',25,3),(98,7422249,7422245,'tat',25,3),(98,7422250,7422245,'atu',25,3),(98,7422251,7422245,'tus',25,3),(98,7422252,7422248,'rdm',100,1),(98,7422253,7422252,'cap',20,1),(98,7422254,7422252,'apa',20,1),(98,7422255,7422252,'pab',20,1),(98,7422256,7422252,'abl',20,1),(98,7422257,7422252,'ble',20,1),(98,7422258,7422253,'tru',50,1),(98,7422259,7422253,'rue',50,1),(98,7422260,7422258,'loc',33.333,1),(98,7422261,7422258,'oca',33.333,1),(98,7422262,7422258,'cal',33.333,1),(98,7422263,7422260,'rem',14.286,1),(98,7422264,7422260,'emo',14.286,1),(98,7422265,7422260,'mov',14.286,1),(98,7422266,7422260,'ova',14.286,1),(98,7422267,7422260,'vab',14.286,1),(98,7422268,7422260,'abl',14.286,1),(98,7422269,7422260,'ble',14.286,1),(98,7422270,7422263,'ssd',100,1),(98,7422271,7422270,'off',20,1),(98,7422272,7422270,'ffl',20,1),(98,7422273,7422270,'fli',20,1),(98,7422274,7422270,'lin',20,1),(98,7422275,7422270,'ine',20,1),(98,7422276,7422271,'per',11.111,1),(98,7422277,7422271,'ere',11.111,1),(98,7422278,7422271,'ren',11.111,1),(98,7422279,7422271,'enn',11.111,1),(98,7422280,7422271,'nni',11.111,1),(98,7422281,7422271,'nia',11.111,1),(98,7422282,7422271,'ial',11.111,1),(98,7422283,7422271,'all',11.111,1),(98,7422284,7422271,'lly',11.111,1),(98,7422285,7422276,'res',16.667,1),(98,7422286,7422276,'ese',16.667,1),(98,7422287,7422276,'ser',16.667,1),(98,7422288,7422276,'erv',16.667,1),(98,7422289,7422276,'rve',16.667,1),(98,7422290,7422276,'ved',16.667,1),(98,7422291,7422285,'thi',50,1),(98,7422292,7422285,'hin',50,1),(98,7422293,7422291,'pro',10,1),(98,7422294,7422291,'rov',10,1),(98,7422295,7422291,'ovi',10,1),(98,7422296,7422291,'vis',10,1),(98,7422297,7422291,'isi',10,1),(98,7422298,7422291,'sio',10,1),(98,7422299,7422291,'ion',10,1),(98,7422300,7422291,'oni',10,1),(98,7422301,7422291,'nin',10,1),(98,7422302,7422291,'ing',10,1),(98,7422303,7422293,'yes',100,1),(98,7422304,7422303,'att',16.667,1),(98,7422305,7422303,'tta',16.667,1),(98,7422306,7422303,'tac',16.667,1),(98,7422307,7422303,'ach',16.667,1),(98,7422308,7422303,'che',16.667,1),(98,7422309,7422303,'hed',16.667,1),(98,7422310,7422304,'fil',20,1),(98,7422311,7422304,'ilt',20,1),(98,7422312,7422304,'lte',20,1),(98,7422313,7422304,'ter',20,1),(98,7422314,7422304,'ers',20,1),(98,7422315,7422310,'vaa',50,1),(98,7422316,7422310,'aai',50,1),(98,7422317,7422315,'unk',20,1),(98,7422318,7422315,'nkn',20,1),(98,7422319,7422315,'kno',20,1),(98,7422320,7422315,'now',20,1),(98,7422321,7422315,'own',20,1),(98,7422322,7422317,'oth',33.333,1),(98,7422323,7422317,'the',33.333,1),(98,7422324,7422317,'her',33.333,1),(98,7422325,7422322,'uid',50,1),(98,7422326,7422322,'ids',50,1),(98,7422327,7422325,'vml',100,1),(98,7422328,7422327,'dis',20,1),(98,7422329,7422327,'isp',20,1),(98,7422330,7422327,'spl',20,1),(98,7422331,7422327,'pla',20,1),(98,7422332,7422327,'lay',20,1),(98,7422333,7422328,'nam',50,1),(98,7422334,7422328,'ame',50,1),(99,7422336,7422335,'net',25,3),(99,7422337,7422335,'eta',25,3),(99,7422338,7422335,'tap',25,3),(99,7422339,7422335,'app',25,3),(99,7422340,7422336,'fib',33.333,2),(99,7422341,7422336,'ibr',33.333,2),(99,7422342,7422336,'bre',33.333,2),(99,7422343,7422340,'cha',20,2),(99,7422344,7422340,'han',20,2),(99,7422345,7422340,'ann',20,2),(99,7422346,7422340,'nne',20,2),(99,7422347,7422340,'nel',20,2),(99,7422348,7422343,'dis',50,2),(99,7422349,7422343,'isk',50,2),(99,7422350,7422348,'naa',100,4),(99,7422351,7422350,'600',3.333,4),(99,7422352,7422350,'00a',3.333,4),(99,7422353,7422350,'0a0',3.333,4),(99,7422354,7422350,'a09',3.333,4),(99,7422355,7422350,'098',3.333,4),(99,7422356,7422350,'980',3.333,4),(99,7422357,7422350,'804',3.333,4),(99,7422358,7422350,'044',3.333,4),(99,7422359,7422350,'443',3.333,4),(99,7422360,7422350,'430',3.333,4),(99,7422361,7422350,'307',3.333,4),(99,7422362,7422350,'075',3.333,4),(99,7422363,7422350,'753',3.333,4),(99,7422364,7422350,'535',3.333,4),(99,7422365,7422350,'357',3.333,4),(99,7422366,7422350,'573',3.333,4),(99,7422367,7422350,'732',3.333,4),(99,7422368,7422350,'32b',3.333,4),(99,7422369,7422350,'2b3',3.333,4),(99,7422370,7422350,'b33',3.333,4),(99,7422371,7422350,'334',3.333,4),(99,7422372,7422350,'345',3.333,4),(99,7422373,7422350,'457',3.333,4),(99,7422374,7422350,'571',3.333,4),(99,7422375,7422350,'715',3.333,4),(99,7422376,7422350,'152',3.333,4),(99,7422377,7422350,'527',3.333,4),(99,7422378,7422350,'275',3.333,4),(99,7422379,7422350,'752',3.333,4),(99,7422380,7422350,'52d',3.333,4),(99,7422381,7422351,'ser',25,1),(99,7422382,7422351,'eri',25,1),(99,7422383,7422351,'ria',25,1),(99,7422384,7422351,'ial',25,1),(99,7422385,7422381,'siz',50,1),(99,7422386,7422381,'ize',50,1),(99,7422387,7422385,'460',33.333,1),(99,7422388,7422385,'608',33.333,1),(99,7422389,7422385,'080',33.333,1),(99,7422390,7422387,'dev',25,1),(99,7422391,7422387,'evi',25,1),(99,7422392,7422387,'vic',25,1),(99,7422393,7422387,'ice',25,1),(99,7422394,7422390,'typ',50,1),(99,7422395,7422390,'ype',50,1),(99,7422396,7422394,'dir',10,1),(99,7422397,7422394,'ire',10,1),(99,7422398,7422394,'rec',10,1),(99,7422399,7422394,'ect',10,1),(99,7422400,7422394,'cta',10,1),(99,7422401,7422394,'tac',10,1),(99,7422402,7422394,'acc',10,1),(99,7422403,7422394,'cce',10,1),(99,7422404,7422394,'ces',10,1),(99,7422405,7422394,'ess',10,1),(99,7422406,7422396,'mul',14.286,1),(99,7422407,7422396,'ult',14.286,1),(99,7422408,7422396,'lti',14.286,1),(99,7422409,7422396,'tip',14.286,1),(99,7422410,7422396,'ipa',14.286,1),(99,7422411,7422396,'pat',14.286,1),(99,7422412,7422396,'ath',14.286,1),(99,7422413,7422406,'plu',25,1),(99,7422414,7422406,'lug',25,1),(99,7422415,7422406,'ugi',25,1),(99,7422416,7422406,'gin',25,1),(99,7422417,7422413,'nmp',100,1),(99,7422418,7422417,'dev',33.333,1),(99,7422419,7422417,'evf',33.333,1),(99,7422420,7422417,'vfs',33.333,1),(99,7422421,7422418,'pat',50,1),(99,7422422,7422418,'ath',50,1),(99,7422423,7422421,'vmf',50,1),(99,7422424,7422421,'mfs',50,1),(99,7422425,7422423,'dev',20,1),(99,7422426,7422423,'evi',20,1),(99,7422427,7422423,'vic',20,1),(99,7422428,7422423,'ice',20,1),(99,7422429,7422423,'ces',20,1),(99,7422430,7422425,'dis',33.333,1),(99,7422431,7422425,'isk',33.333,1),(99,7422432,7422425,'sks',33.333,1),(99,7422433,7422430,'ven',25,1),(99,7422434,7422430,'end',25,1),(99,7422435,7422430,'ndo',25,1),(99,7422436,7422430,'dor',25,1),(99,7422437,7422433,'mod',33.333,1),(99,7422438,7422433,'ode',33.333,1),(99,7422439,7422433,'del',33.333,1),(99,7422440,7422437,'lun',100,1),(99,7422441,7422440,'cmo',33.333,1),(99,7422442,7422440,'mod',33.333,1),(99,7422443,7422440,'ode',33.333,1),(99,7422444,7422441,'rev',16.667,1),(99,7422445,7422441,'evi',16.667,1),(99,7422446,7422441,'vis',16.667,1),(99,7422447,7422441,'isi',16.667,1),(99,7422448,7422441,'sio',16.667,1),(99,7422449,7422441,'ion',16.667,1),(99,7422450,7422444,'810',50,1),(99,7422451,7422444,'100',50,1),(99,7422452,7422450,'scs',50,1),(99,7422453,7422450,'csi',50,1),(99,7422454,7422452,'lev',33.333,1),(99,7422455,7422452,'eve',33.333,1),(99,7422456,7422452,'vel',33.333,1),(99,7422457,7422454,'pse',25,1),(99,7422458,7422454,'seu',25,1),(99,7422459,7422454,'eud',25,1),(99,7422460,7422454,'udo',25,1),(99,7422461,7422457,'fal',33.333,6),(99,7422462,7422457,'als',33.333,6),(99,7422463,7422457,'lse',33.333,6),(99,7422464,7422461,'sta',25,3),(99,7422465,7422461,'tat',25,3),(99,7422466,7422461,'atu',25,3),(99,7422467,7422461,'tus',25,3),(99,7422468,7422464,'rdm',100,1),(99,7422469,7422468,'cap',20,1),(99,7422470,7422468,'apa',20,1),(99,7422471,7422468,'pab',20,1),(99,7422472,7422468,'abl',20,1),(99,7422473,7422468,'ble',20,1),(99,7422474,7422469,'tru',50,1),(99,7422475,7422469,'rue',50,1),(99,7422476,7422474,'loc',33.333,1),(99,7422477,7422474,'oca',33.333,1),(99,7422478,7422474,'cal',33.333,1),(99,7422479,7422476,'rem',14.286,1),(99,7422480,7422476,'emo',14.286,1),(99,7422481,7422476,'mov',14.286,1),(99,7422482,7422476,'ova',14.286,1),(99,7422483,7422476,'vab',14.286,1),(99,7422484,7422476,'abl',14.286,1),(99,7422485,7422476,'ble',14.286,1),(99,7422486,7422479,'ssd',100,1),(99,7422487,7422486,'off',20,1),(99,7422488,7422486,'ffl',20,1),(99,7422489,7422486,'fli',20,1),(99,7422490,7422486,'lin',20,1),(99,7422491,7422486,'ine',20,1),(99,7422492,7422487,'per',11.111,1),(99,7422493,7422487,'ere',11.111,1),(99,7422494,7422487,'ren',11.111,1),(99,7422495,7422487,'enn',11.111,1),(99,7422496,7422487,'nni',11.111,1),(99,7422497,7422487,'nia',11.111,1),(99,7422498,7422487,'ial',11.111,1),(99,7422499,7422487,'all',11.111,1),(99,7422500,7422487,'lly',11.111,1),(99,7422501,7422492,'res',16.667,1),(99,7422502,7422492,'ese',16.667,1),(99,7422503,7422492,'ser',16.667,1),(99,7422504,7422492,'erv',16.667,1),(99,7422505,7422492,'rve',16.667,1),(99,7422506,7422492,'ved',16.667,1),(99,7422507,7422501,'thi',50,1),(99,7422508,7422501,'hin',50,1),(99,7422509,7422507,'pro',10,1),(99,7422510,7422507,'rov',10,1),(99,7422511,7422507,'ovi',10,1),(99,7422512,7422507,'vis',10,1),(99,7422513,7422507,'isi',10,1),(99,7422514,7422507,'sio',10,1),(99,7422515,7422507,'ion',10,1),(99,7422516,7422507,'oni',10,1),(99,7422517,7422507,'nin',10,1),(99,7422518,7422507,'ing',10,1),(99,7422519,7422509,'yes',100,1),(99,7422520,7422519,'att',16.667,1),(99,7422521,7422519,'tta',16.667,1),(99,7422522,7422519,'tac',16.667,1),(99,7422523,7422519,'ach',16.667,1),(99,7422524,7422519,'che',16.667,1),(99,7422525,7422519,'hed',16.667,1),(99,7422526,7422520,'fil',20,1),(99,7422527,7422520,'ilt',20,1),(99,7422528,7422520,'lte',20,1),(99,7422529,7422520,'ter',20,1),(99,7422530,7422520,'ers',20,1),(99,7422531,7422526,'vaa',50,1),(99,7422532,7422526,'aai',50,1),(99,7422533,7422531,'unk',20,1),(99,7422534,7422531,'nkn',20,1),(99,7422535,7422531,'kno',20,1),(99,7422536,7422531,'now',20,1),(99,7422537,7422531,'own',20,1),(99,7422538,7422533,'oth',33.333,1),(99,7422539,7422533,'the',33.333,1),(99,7422540,7422533,'her',33.333,1),(99,7422541,7422538,'uid',50,1),(99,7422542,7422538,'ids',50,1),(99,7422543,7422541,'vml',100,1),(99,7422544,7422543,'dis',20,1),(99,7422545,7422543,'isp',20,1),(99,7422546,7422543,'spl',20,1),(99,7422547,7422543,'pla',20,1),(99,7422548,7422543,'lay',20,1),(99,7422549,7422544,'nam',50,1),(99,7422550,7422544,'ame',50,1),(100,7422552,7422551,'net',25,3),(100,7422553,7422551,'eta',25,3),(100,7422554,7422551,'tap',25,3),(100,7422555,7422551,'app',25,3),(100,7422556,7422552,'fib',33.333,2),(100,7422557,7422552,'ibr',33.333,2),(100,7422558,7422552,'bre',33.333,2),(100,7422559,7422556,'cha',20,2),(100,7422560,7422556,'han',20,2),(100,7422561,7422556,'ann',20,2),(100,7422562,7422556,'nne',20,2),(100,7422563,7422556,'nel',20,2),(100,7422564,7422559,'dis',50,2),(100,7422565,7422559,'isk',50,2),(100,7422566,7422564,'naa',100,4),(100,7422567,7422566,'600',3.333,4),(100,7422568,7422566,'00a',3.333,4),(100,7422569,7422566,'0a0',3.333,4),(100,7422570,7422566,'a09',3.333,4),(100,7422571,7422566,'098',3.333,4),(100,7422572,7422566,'980',3.333,4),(100,7422573,7422566,'804',3.333,4),(100,7422574,7422566,'044',3.333,4),(100,7422575,7422566,'443',3.333,4),(100,7422576,7422566,'430',3.333,4),(100,7422577,7422566,'307',3.333,4),(100,7422578,7422566,'072',3.333,4),(100,7422579,7422566,'725',3.333,4),(100,7422580,7422566,'259',3.333,4),(100,7422581,7422566,'593',3.333,4),(100,7422582,7422566,'931',3.333,4),(100,7422583,7422566,'313',3.333,4),(100,7422584,7422566,'13f',3.333,4),(100,7422585,7422566,'3f3',3.333,4),(100,7422586,7422566,'f33',3.333,4),(100,7422587,7422566,'334',3.333,4),(100,7422588,7422566,'345',3.333,4),(100,7422589,7422566,'455',3.333,4),(100,7422590,7422566,'556',3.333,4),(100,7422591,7422566,'563',3.333,4),(100,7422592,7422566,'639',3.333,4),(100,7422593,7422566,'393',3.333,4),(100,7422594,7422566,'934',3.333,4),(100,7422595,7422566,'344',3.333,4),(100,7422596,7422566,'444',3.333,4),(100,7422597,7422567,'ser',25,1),(100,7422598,7422567,'eri',25,1),(100,7422599,7422567,'ria',25,1),(100,7422600,7422567,'ial',25,1),(100,7422601,7422597,'siz',50,1),(100,7422602,7422597,'ize',50,1),(100,7422603,7422601,'321',100,1),(100,7422604,7422603,'dev',25,1),(100,7422605,7422603,'evi',25,1),(100,7422606,7422603,'vic',25,1),(100,7422607,7422603,'ice',25,1),(100,7422608,7422604,'typ',50,1),(100,7422609,7422604,'ype',50,1),(100,7422610,7422608,'dir',10,1),(100,7422611,7422608,'ire',10,1),(100,7422612,7422608,'rec',10,1),(100,7422613,7422608,'ect',10,1),(100,7422614,7422608,'cta',10,1),(100,7422615,7422608,'tac',10,1),(100,7422616,7422608,'acc',10,1),(100,7422617,7422608,'cce',10,1),(100,7422618,7422608,'ces',10,1),(100,7422619,7422608,'ess',10,1),(100,7422620,7422610,'mul',14.286,1),(100,7422621,7422610,'ult',14.286,1),(100,7422622,7422610,'lti',14.286,1),(100,7422623,7422610,'tip',14.286,1),(100,7422624,7422610,'ipa',14.286,1),(100,7422625,7422610,'pat',14.286,1),(100,7422626,7422610,'ath',14.286,1),(100,7422627,7422620,'plu',25,1),(100,7422628,7422620,'lug',25,1),(100,7422629,7422620,'ugi',25,1),(100,7422630,7422620,'gin',25,1),(100,7422631,7422627,'nmp',100,1),(100,7422632,7422631,'dev',33.333,1),(100,7422633,7422631,'evf',33.333,1),(100,7422634,7422631,'vfs',33.333,1),(100,7422635,7422632,'pat',50,1),(100,7422636,7422632,'ath',50,1),(100,7422637,7422635,'vmf',50,1),(100,7422638,7422635,'mfs',50,1),(100,7422639,7422637,'dev',20,1),(100,7422640,7422637,'evi',20,1),(100,7422641,7422637,'vic',20,1),(100,7422642,7422637,'ice',20,1),(100,7422643,7422637,'ces',20,1),(100,7422644,7422639,'dis',33.333,1),(100,7422645,7422639,'isk',33.333,1),(100,7422646,7422639,'sks',33.333,1),(100,7422647,7422644,'ven',25,1),(100,7422648,7422644,'end',25,1),(100,7422649,7422644,'ndo',25,1),(100,7422650,7422644,'dor',25,1),(100,7422651,7422647,'mod',33.333,1),(100,7422652,7422647,'ode',33.333,1),(100,7422653,7422647,'del',33.333,1),(100,7422654,7422651,'lun',100,1),(100,7422655,7422654,'cmo',33.333,1),(100,7422656,7422654,'mod',33.333,1),(100,7422657,7422654,'ode',33.333,1),(100,7422658,7422655,'rev',16.667,1),(100,7422659,7422655,'evi',16.667,1),(100,7422660,7422655,'vis',16.667,1),(100,7422661,7422655,'isi',16.667,1),(100,7422662,7422655,'sio',16.667,1),(100,7422663,7422655,'ion',16.667,1),(100,7422664,7422658,'810',50,1),(100,7422665,7422658,'100',50,1),(100,7422666,7422664,'scs',50,1),(100,7422667,7422664,'csi',50,1),(100,7422668,7422666,'lev',33.333,1),(100,7422669,7422666,'eve',33.333,1),(100,7422670,7422666,'vel',33.333,1),(100,7422671,7422668,'pse',25,1),(100,7422672,7422668,'seu',25,1),(100,7422673,7422668,'eud',25,1),(100,7422674,7422668,'udo',25,1),(100,7422675,7422671,'fal',33.333,6),(100,7422676,7422671,'als',33.333,6),(100,7422677,7422671,'lse',33.333,6),(100,7422678,7422675,'sta',25,3),(100,7422679,7422675,'tat',25,3),(100,7422680,7422675,'atu',25,3),(100,7422681,7422675,'tus',25,3),(100,7422682,7422678,'rdm',100,1),(100,7422683,7422682,'cap',20,1),(100,7422684,7422682,'apa',20,1),(100,7422685,7422682,'pab',20,1),(100,7422686,7422682,'abl',20,1),(100,7422687,7422682,'ble',20,1),(100,7422688,7422683,'tru',50,1),(100,7422689,7422683,'rue',50,1),(100,7422690,7422688,'loc',33.333,1),(100,7422691,7422688,'oca',33.333,1),(100,7422692,7422688,'cal',33.333,1),(100,7422693,7422690,'rem',14.286,1),(100,7422694,7422690,'emo',14.286,1),(100,7422695,7422690,'mov',14.286,1),(100,7422696,7422690,'ova',14.286,1),(100,7422697,7422690,'vab',14.286,1),(100,7422698,7422690,'abl',14.286,1),(100,7422699,7422690,'ble',14.286,1),(100,7422700,7422693,'ssd',100,1),(100,7422701,7422700,'off',20,1),(100,7422702,7422700,'ffl',20,1),(100,7422703,7422700,'fli',20,1),(100,7422704,7422700,'lin',20,1),(100,7422705,7422700,'ine',20,1),(100,7422706,7422701,'per',11.111,1),(100,7422707,7422701,'ere',11.111,1),(100,7422708,7422701,'ren',11.111,1),(100,7422709,7422701,'enn',11.111,1),(100,7422710,7422701,'nni',11.111,1),(100,7422711,7422701,'nia',11.111,1),(100,7422712,7422701,'ial',11.111,1),(100,7422713,7422701,'all',11.111,1),(100,7422714,7422701,'lly',11.111,1),(100,7422715,7422706,'res',16.667,1),(100,7422716,7422706,'ese',16.667,1),(100,7422717,7422706,'ser',16.667,1),(100,7422718,7422706,'erv',16.667,1),(100,7422719,7422706,'rve',16.667,1),(100,7422720,7422706,'ved',16.667,1),(100,7422721,7422715,'thi',50,1),(100,7422722,7422715,'hin',50,1),(100,7422723,7422721,'pro',10,1),(100,7422724,7422721,'rov',10,1),(100,7422725,7422721,'ovi',10,1),(100,7422726,7422721,'vis',10,1),(100,7422727,7422721,'isi',10,1),(100,7422728,7422721,'sio',10,1),(100,7422729,7422721,'ion',10,1),(100,7422730,7422721,'oni',10,1),(100,7422731,7422721,'nin',10,1),(100,7422732,7422721,'ing',10,1),(100,7422733,7422723,'yes',100,1),(100,7422734,7422733,'att',16.667,1),(100,7422735,7422733,'tta',16.667,1),(100,7422736,7422733,'tac',16.667,1),(100,7422737,7422733,'ach',16.667,1),(100,7422738,7422733,'che',16.667,1),(100,7422739,7422733,'hed',16.667,1),(100,7422740,7422734,'fil',20,1),(100,7422741,7422734,'ilt',20,1),(100,7422742,7422734,'lte',20,1),(100,7422743,7422734,'ter',20,1),(100,7422744,7422734,'ers',20,1),(100,7422745,7422740,'vaa',50,1),(100,7422746,7422740,'aai',50,1),(100,7422747,7422745,'unk',20,1),(100,7422748,7422745,'nkn',20,1),(100,7422749,7422745,'kno',20,1),(100,7422750,7422745,'now',20,1),(100,7422751,7422745,'own',20,1),(100,7422752,7422747,'oth',33.333,1),(100,7422753,7422747,'the',33.333,1),(100,7422754,7422747,'her',33.333,1),(100,7422755,7422752,'uid',50,1),(100,7422756,7422752,'ids',50,1),(100,7422757,7422755,'vml',100,1),(100,7422758,7422757,'dis',20,1),(100,7422759,7422757,'isp',20,1),(100,7422760,7422757,'spl',20,1),(100,7422761,7422757,'pla',20,1),(100,7422762,7422757,'lay',20,1),(100,7422763,7422758,'nam',50,1),(100,7422764,7422758,'ame',50,1),(101,7422766,7422765,'net',25,3),(101,7422767,7422765,'eta',25,3),(101,7422768,7422765,'tap',25,3),(101,7422769,7422765,'app',25,3),(101,7422770,7422766,'fib',33.333,2),(101,7422771,7422766,'ibr',33.333,2),(101,7422772,7422766,'bre',33.333,2),(101,7422773,7422770,'cha',20,2),(101,7422774,7422770,'han',20,2),(101,7422775,7422770,'ann',20,2),(101,7422776,7422770,'nne',20,2),(101,7422777,7422770,'nel',20,2),(101,7422778,7422773,'dis',50,2),(101,7422779,7422773,'isk',50,2),(101,7422780,7422778,'naa',100,4),(101,7422781,7422780,'600',3.333,4),(101,7422782,7422780,'00a',3.333,4),(101,7422783,7422780,'0a0',3.333,4),(101,7422784,7422780,'a09',3.333,4),(101,7422785,7422780,'098',3.333,4),(101,7422786,7422780,'980',3.333,4),(101,7422787,7422780,'804',3.333,4),(101,7422788,7422780,'044',3.333,4),(101,7422789,7422780,'443',3.333,4),(101,7422790,7422780,'430',3.333,4),(101,7422791,7422780,'307',3.333,4),(101,7422792,7422780,'072',3.333,4),(101,7422793,7422780,'725',3.333,4),(101,7422794,7422780,'259',3.333,4),(101,7422795,7422780,'593',3.333,4),(101,7422796,7422780,'931',3.333,4),(101,7422797,7422780,'313',3.333,4),(101,7422798,7422780,'13f',3.333,4),(101,7422799,7422780,'3f3',3.333,4),(101,7422800,7422780,'f33',3.333,4),(101,7422801,7422780,'334',3.333,4),(101,7422802,7422780,'345',3.333,4),(101,7422803,7422780,'455',3.333,4),(101,7422804,7422780,'556',3.333,4),(101,7422805,7422780,'563',3.333,4),(101,7422806,7422780,'639',3.333,4),(101,7422807,7422780,'393',3.333,4),(101,7422808,7422780,'934',3.333,4),(101,7422809,7422780,'344',3.333,4),(101,7422810,7422780,'445',3.333,4),(101,7422811,7422781,'ser',25,1),(101,7422812,7422781,'eri',25,1),(101,7422813,7422781,'ria',25,1),(101,7422814,7422781,'ial',25,1),(101,7422815,7422811,'siz',50,1),(101,7422816,7422811,'ize',50,1),(101,7422817,7422815,'321',100,1),(101,7422818,7422817,'dev',25,1),(101,7422819,7422817,'evi',25,1),(101,7422820,7422817,'vic',25,1),(101,7422821,7422817,'ice',25,1),(101,7422822,7422818,'typ',50,1),(101,7422823,7422818,'ype',50,1),(101,7422824,7422822,'dir',10,1),(101,7422825,7422822,'ire',10,1),(101,7422826,7422822,'rec',10,1),(101,7422827,7422822,'ect',10,1),(101,7422828,7422822,'cta',10,1),(101,7422829,7422822,'tac',10,1),(101,7422830,7422822,'acc',10,1),(101,7422831,7422822,'cce',10,1),(101,7422832,7422822,'ces',10,1),(101,7422833,7422822,'ess',10,1),(101,7422834,7422824,'mul',14.286,1),(101,7422835,7422824,'ult',14.286,1),(101,7422836,7422824,'lti',14.286,1),(101,7422837,7422824,'tip',14.286,1),(101,7422838,7422824,'ipa',14.286,1),(101,7422839,7422824,'pat',14.286,1),(101,7422840,7422824,'ath',14.286,1),(101,7422841,7422834,'plu',25,1),(101,7422842,7422834,'lug',25,1),(101,7422843,7422834,'ugi',25,1),(101,7422844,7422834,'gin',25,1),(101,7422845,7422841,'nmp',100,1),(101,7422846,7422845,'dev',33.333,1),(101,7422847,7422845,'evf',33.333,1),(101,7422848,7422845,'vfs',33.333,1),(101,7422849,7422846,'pat',50,1),(101,7422850,7422846,'ath',50,1),(101,7422851,7422849,'vmf',50,1),(101,7422852,7422849,'mfs',50,1),(101,7422853,7422851,'dev',20,1),(101,7422854,7422851,'evi',20,1),(101,7422855,7422851,'vic',20,1),(101,7422856,7422851,'ice',20,1),(101,7422857,7422851,'ces',20,1),(101,7422858,7422853,'dis',33.333,1),(101,7422859,7422853,'isk',33.333,1),(101,7422860,7422853,'sks',33.333,1),(101,7422861,7422858,'ven',25,1),(101,7422862,7422858,'end',25,1),(101,7422863,7422858,'ndo',25,1),(101,7422864,7422858,'dor',25,1),(101,7422865,7422861,'mod',33.333,1),(101,7422866,7422861,'ode',33.333,1),(101,7422867,7422861,'del',33.333,1),(101,7422868,7422865,'lun',100,1),(101,7422869,7422868,'cmo',33.333,1),(101,7422870,7422868,'mod',33.333,1),(101,7422871,7422868,'ode',33.333,1),(101,7422872,7422869,'rev',16.667,1),(101,7422873,7422869,'evi',16.667,1),(101,7422874,7422869,'vis',16.667,1),(101,7422875,7422869,'isi',16.667,1),(101,7422876,7422869,'sio',16.667,1),(101,7422877,7422869,'ion',16.667,1),(101,7422878,7422872,'810',50,1),(101,7422879,7422872,'100',50,1),(101,7422880,7422878,'scs',50,1),(101,7422881,7422878,'csi',50,1),(101,7422882,7422880,'lev',33.333,1),(101,7422883,7422880,'eve',33.333,1),(101,7422884,7422880,'vel',33.333,1),(101,7422885,7422882,'pse',25,1),(101,7422886,7422882,'seu',25,1),(101,7422887,7422882,'eud',25,1),(101,7422888,7422882,'udo',25,1),(101,7422889,7422885,'fal',33.333,6),(101,7422890,7422885,'als',33.333,6),(101,7422891,7422885,'lse',33.333,6),(101,7422892,7422889,'sta',25,3),(101,7422893,7422889,'tat',25,3),(101,7422894,7422889,'atu',25,3),(101,7422895,7422889,'tus',25,3),(101,7422896,7422892,'rdm',100,1),(101,7422897,7422896,'cap',20,1),(101,7422898,7422896,'apa',20,1),(101,7422899,7422896,'pab',20,1),(101,7422900,7422896,'abl',20,1),(101,7422901,7422896,'ble',20,1),(101,7422902,7422897,'tru',50,1),(101,7422903,7422897,'rue',50,1),(101,7422904,7422902,'loc',33.333,1),(101,7422905,7422902,'oca',33.333,1),(101,7422906,7422902,'cal',33.333,1),(101,7422907,7422904,'rem',14.286,1),(101,7422908,7422904,'emo',14.286,1),(101,7422909,7422904,'mov',14.286,1),(101,7422910,7422904,'ova',14.286,1),(101,7422911,7422904,'vab',14.286,1),(101,7422912,7422904,'abl',14.286,1),(101,7422913,7422904,'ble',14.286,1),(101,7422914,7422907,'ssd',100,1),(101,7422915,7422914,'off',20,1),(101,7422916,7422914,'ffl',20,1),(101,7422917,7422914,'fli',20,1),(101,7422918,7422914,'lin',20,1),(101,7422919,7422914,'ine',20,1),(101,7422920,7422915,'per',11.111,1),(101,7422921,7422915,'ere',11.111,1),(101,7422922,7422915,'ren',11.111,1),(101,7422923,7422915,'enn',11.111,1),(101,7422924,7422915,'nni',11.111,1),(101,7422925,7422915,'nia',11.111,1),(101,7422926,7422915,'ial',11.111,1),(101,7422927,7422915,'all',11.111,1),(101,7422928,7422915,'lly',11.111,1),(101,7422929,7422920,'res',16.667,1),(101,7422930,7422920,'ese',16.667,1),(101,7422931,7422920,'ser',16.667,1),(101,7422932,7422920,'erv',16.667,1),(101,7422933,7422920,'rve',16.667,1),(101,7422934,7422920,'ved',16.667,1),(101,7422935,7422929,'thi',50,1),(101,7422936,7422929,'hin',50,1),(101,7422937,7422935,'pro',10,1),(101,7422938,7422935,'rov',10,1),(101,7422939,7422935,'ovi',10,1),(101,7422940,7422935,'vis',10,1),(101,7422941,7422935,'isi',10,1),(101,7422942,7422935,'sio',10,1),(101,7422943,7422935,'ion',10,1),(101,7422944,7422935,'oni',10,1),(101,7422945,7422935,'nin',10,1),(101,7422946,7422935,'ing',10,1),(101,7422947,7422937,'yes',100,1),(101,7422948,7422947,'att',16.667,1),(101,7422949,7422947,'tta',16.667,1),(101,7422950,7422947,'tac',16.667,1),(101,7422951,7422947,'ach',16.667,1),(101,7422952,7422947,'che',16.667,1),(101,7422953,7422947,'hed',16.667,1),(101,7422954,7422948,'fil',20,1),(101,7422955,7422948,'ilt',20,1),(101,7422956,7422948,'lte',20,1),(101,7422957,7422948,'ter',20,1),(101,7422958,7422948,'ers',20,1),(101,7422959,7422954,'vaa',50,1),(101,7422960,7422954,'aai',50,1),(101,7422961,7422959,'unk',20,1),(101,7422962,7422959,'nkn',20,1),(101,7422963,7422959,'kno',20,1),(101,7422964,7422959,'now',20,1),(101,7422965,7422959,'own',20,1),(101,7422966,7422961,'oth',33.333,1),(101,7422967,7422961,'the',33.333,1),(101,7422968,7422961,'her',33.333,1),(101,7422969,7422966,'uid',50,1),(101,7422970,7422966,'ids',50,1),(101,7422971,7422969,'vml',100,1),(101,7422972,7422971,'dis',20,1),(101,7422973,7422971,'isp',20,1),(101,7422974,7422971,'spl',20,1),(101,7422975,7422971,'pla',20,1),(101,7422976,7422971,'lay',20,1),(101,7422977,7422972,'nam',50,1),(101,7422978,7422972,'ame',50,1),(102,7422980,7422979,'net',25,3),(102,7422981,7422979,'eta',25,3),(102,7422982,7422979,'tap',25,3),(102,7422983,7422979,'app',25,3),(102,7422984,7422980,'fib',33.333,2),(102,7422985,7422980,'ibr',33.333,2),(102,7422986,7422980,'bre',33.333,2),(102,7422987,7422984,'cha',20,2),(102,7422988,7422984,'han',20,2),(102,7422989,7422984,'ann',20,2),(102,7422990,7422984,'nne',20,2),(102,7422991,7422984,'nel',20,2),(102,7422992,7422987,'dis',50,2),(102,7422993,7422987,'isk',50,2),(102,7422994,7422992,'naa',100,4),(102,7422995,7422994,'600',3.333,4),(102,7422996,7422994,'00a',3.333,4),(102,7422997,7422994,'0a0',3.333,4),(102,7422998,7422994,'a09',3.333,4),(102,7422999,7422994,'098',3.333,4),(102,7423000,7422994,'980',3.333,4),(102,7423001,7422994,'804',3.333,4),(102,7423002,7422994,'044',3.333,4),(102,7423003,7422994,'443',3.333,4),(102,7423004,7422994,'430',3.333,4),(102,7423005,7422994,'307',3.333,4),(102,7423006,7422994,'072',3.333,4),(102,7423007,7422994,'725',3.333,4),(102,7423008,7422994,'259',3.333,4),(102,7423009,7422994,'593',3.333,4),(102,7423010,7422994,'931',3.333,4),(102,7423011,7422994,'313',3.333,4),(102,7423012,7422994,'13f',3.333,4),(102,7423013,7422994,'3f3',3.333,4),(102,7423014,7422994,'f33',3.333,4),(102,7423015,7422994,'334',3.333,4),(102,7423016,7422994,'345',3.333,4),(102,7423017,7422994,'455',3.333,4),(102,7423018,7422994,'556',3.333,4),(102,7423019,7422994,'563',3.333,4),(102,7423020,7422994,'639',3.333,4),(102,7423021,7422994,'393',3.333,4),(102,7423022,7422994,'934',3.333,4),(102,7423023,7422994,'344',3.333,4),(102,7423024,7422994,'446',3.333,4),(102,7423025,7422995,'ser',25,1),(102,7423026,7422995,'eri',25,1),(102,7423027,7422995,'ria',25,1),(102,7423028,7422995,'ial',25,1),(102,7423029,7423025,'siz',50,1),(102,7423030,7423025,'ize',50,1),(102,7423031,7423029,'321',100,1),(102,7423032,7423031,'dev',25,1),(102,7423033,7423031,'evi',25,1),(102,7423034,7423031,'vic',25,1),(102,7423035,7423031,'ice',25,1),(102,7423036,7423032,'typ',50,1),(102,7423037,7423032,'ype',50,1),(102,7423038,7423036,'dir',10,1),(102,7423039,7423036,'ire',10,1),(102,7423040,7423036,'rec',10,1),(102,7423041,7423036,'ect',10,1),(102,7423042,7423036,'cta',10,1),(102,7423043,7423036,'tac',10,1),(102,7423044,7423036,'acc',10,1),(102,7423045,7423036,'cce',10,1),(102,7423046,7423036,'ces',10,1),(102,7423047,7423036,'ess',10,1),(102,7423048,7423038,'mul',14.286,1),(102,7423049,7423038,'ult',14.286,1),(102,7423050,7423038,'lti',14.286,1),(102,7423051,7423038,'tip',14.286,1),(102,7423052,7423038,'ipa',14.286,1),(102,7423053,7423038,'pat',14.286,1),(102,7423054,7423038,'ath',14.286,1),(102,7423055,7423048,'plu',25,1),(102,7423056,7423048,'lug',25,1),(102,7423057,7423048,'ugi',25,1),(102,7423058,7423048,'gin',25,1),(102,7423059,7423055,'nmp',100,1),(102,7423060,7423059,'dev',33.333,1),(102,7423061,7423059,'evf',33.333,1),(102,7423062,7423059,'vfs',33.333,1),(102,7423063,7423060,'pat',50,1),(102,7423064,7423060,'ath',50,1),(102,7423065,7423063,'vmf',50,1),(102,7423066,7423063,'mfs',50,1),(102,7423067,7423065,'dev',20,1),(102,7423068,7423065,'evi',20,1),(102,7423069,7423065,'vic',20,1),(102,7423070,7423065,'ice',20,1),(102,7423071,7423065,'ces',20,1),(102,7423072,7423067,'dis',33.333,1),(102,7423073,7423067,'isk',33.333,1),(102,7423074,7423067,'sks',33.333,1),(102,7423075,7423072,'ven',25,1),(102,7423076,7423072,'end',25,1),(102,7423077,7423072,'ndo',25,1),(102,7423078,7423072,'dor',25,1),(102,7423079,7423075,'mod',33.333,1),(102,7423080,7423075,'ode',33.333,1),(102,7423081,7423075,'del',33.333,1),(102,7423082,7423079,'lun',100,1),(102,7423083,7423082,'cmo',33.333,1),(102,7423084,7423082,'mod',33.333,1),(102,7423085,7423082,'ode',33.333,1),(102,7423086,7423083,'rev',16.667,1),(102,7423087,7423083,'evi',16.667,1),(102,7423088,7423083,'vis',16.667,1),(102,7423089,7423083,'isi',16.667,1),(102,7423090,7423083,'sio',16.667,1),(102,7423091,7423083,'ion',16.667,1),(102,7423092,7423086,'810',50,1),(102,7423093,7423086,'100',50,1),(102,7423094,7423092,'scs',50,1),(102,7423095,7423092,'csi',50,1),(102,7423096,7423094,'lev',33.333,1),(102,7423097,7423094,'eve',33.333,1),(102,7423098,7423094,'vel',33.333,1),(102,7423099,7423096,'pse',25,1),(102,7423100,7423096,'seu',25,1),(102,7423101,7423096,'eud',25,1),(102,7423102,7423096,'udo',25,1),(102,7423103,7423099,'fal',33.333,6),(102,7423104,7423099,'als',33.333,6),(102,7423105,7423099,'lse',33.333,6),(102,7423106,7423103,'sta',25,3),(102,7423107,7423103,'tat',25,3),(102,7423108,7423103,'atu',25,3),(102,7423109,7423103,'tus',25,3),(102,7423110,7423106,'rdm',100,1),(102,7423111,7423110,'cap',20,1),(102,7423112,7423110,'apa',20,1),(102,7423113,7423110,'pab',20,1),(102,7423114,7423110,'abl',20,1),(102,7423115,7423110,'ble',20,1),(102,7423116,7423111,'tru',50,1),(102,7423117,7423111,'rue',50,1),(102,7423118,7423116,'loc',33.333,1),(102,7423119,7423116,'oca',33.333,1),(102,7423120,7423116,'cal',33.333,1),(102,7423121,7423118,'rem',14.286,1),(102,7423122,7423118,'emo',14.286,1),(102,7423123,7423118,'mov',14.286,1),(102,7423124,7423118,'ova',14.286,1),(102,7423125,7423118,'vab',14.286,1),(102,7423126,7423118,'abl',14.286,1),(102,7423127,7423118,'ble',14.286,1),(102,7423128,7423121,'ssd',100,1),(102,7423129,7423128,'off',20,1),(102,7423130,7423128,'ffl',20,1),(102,7423131,7423128,'fli',20,1),(102,7423132,7423128,'lin',20,1),(102,7423133,7423128,'ine',20,1),(102,7423134,7423129,'per',11.111,1),(102,7423135,7423129,'ere',11.111,1),(102,7423136,7423129,'ren',11.111,1),(102,7423137,7423129,'enn',11.111,1),(102,7423138,7423129,'nni',11.111,1),(102,7423139,7423129,'nia',11.111,1),(102,7423140,7423129,'ial',11.111,1),(102,7423141,7423129,'all',11.111,1),(102,7423142,7423129,'lly',11.111,1),(102,7423143,7423134,'res',16.667,1),(102,7423144,7423134,'ese',16.667,1),(102,7423145,7423134,'ser',16.667,1),(102,7423146,7423134,'erv',16.667,1),(102,7423147,7423134,'rve',16.667,1),(102,7423148,7423134,'ved',16.667,1),(102,7423149,7423143,'thi',50,1),(102,7423150,7423143,'hin',50,1),(102,7423151,7423149,'pro',10,1),(102,7423152,7423149,'rov',10,1),(102,7423153,7423149,'ovi',10,1),(102,7423154,7423149,'vis',10,1),(102,7423155,7423149,'isi',10,1),(102,7423156,7423149,'sio',10,1),(102,7423157,7423149,'ion',10,1),(102,7423158,7423149,'oni',10,1),(102,7423159,7423149,'nin',10,1),(102,7423160,7423149,'ing',10,1),(102,7423161,7423151,'yes',100,1),(102,7423162,7423161,'att',16.667,1),(102,7423163,7423161,'tta',16.667,1),(102,7423164,7423161,'tac',16.667,1),(102,7423165,7423161,'ach',16.667,1),(102,7423166,7423161,'che',16.667,1),(102,7423167,7423161,'hed',16.667,1),(102,7423168,7423162,'fil',20,1),(102,7423169,7423162,'ilt',20,1),(102,7423170,7423162,'lte',20,1),(102,7423171,7423162,'ter',20,1),(102,7423172,7423162,'ers',20,1),(102,7423173,7423168,'vaa',50,1),(102,7423174,7423168,'aai',50,1),(102,7423175,7423173,'unk',20,1),(102,7423176,7423173,'nkn',20,1),(102,7423177,7423173,'kno',20,1),(102,7423178,7423173,'now',20,1),(102,7423179,7423173,'own',20,1),(102,7423180,7423175,'oth',33.333,1),(102,7423181,7423175,'the',33.333,1),(102,7423182,7423175,'her',33.333,1),(102,7423183,7423180,'uid',50,1),(102,7423184,7423180,'ids',50,1),(102,7423185,7423183,'vml',100,1),(102,7423186,7423185,'dis',20,1),(102,7423187,7423185,'isp',20,1),(102,7423188,7423185,'spl',20,1),(102,7423189,7423185,'pla',20,1),(102,7423190,7423185,'lay',20,1),(102,7423191,7423186,'nam',50,1),(102,7423192,7423186,'ame',50,1),(103,7423194,7423193,'net',25,3),(103,7423195,7423193,'eta',25,3),(103,7423196,7423193,'tap',25,3),(103,7423197,7423193,'app',25,3),(103,7423198,7423194,'fib',33.333,2),(103,7423199,7423194,'ibr',33.333,2),(103,7423200,7423194,'bre',33.333,2),(103,7423201,7423198,'cha',20,2),(103,7423202,7423198,'han',20,2),(103,7423203,7423198,'ann',20,2),(103,7423204,7423198,'nne',20,2),(103,7423205,7423198,'nel',20,2),(103,7423206,7423201,'dis',50,2),(103,7423207,7423201,'isk',50,2),(103,7423208,7423206,'naa',100,4),(103,7423209,7423208,'600',3.333,4),(103,7423210,7423208,'00a',3.333,4),(103,7423211,7423208,'0a0',3.333,4),(103,7423212,7423208,'a09',3.333,4),(103,7423213,7423208,'098',3.333,4),(103,7423214,7423208,'980',3.333,4),(103,7423215,7423208,'804',3.333,4),(103,7423216,7423208,'044',3.333,4),(103,7423217,7423208,'443',3.333,4),(103,7423218,7423208,'430',3.333,4),(103,7423219,7423208,'307',3.333,4),(103,7423220,7423208,'072',3.333,4),(103,7423221,7423208,'725',3.333,4),(103,7423222,7423208,'259',3.333,4),(103,7423223,7423208,'593',3.333,4),(103,7423224,7423208,'931',3.333,4),(103,7423225,7423208,'313',3.333,4),(103,7423226,7423208,'13f',3.333,4),(103,7423227,7423208,'3f3',3.333,4),(103,7423228,7423208,'f33',3.333,4),(103,7423229,7423208,'334',3.333,4),(103,7423230,7423208,'345',3.333,4),(103,7423231,7423208,'455',3.333,4),(103,7423232,7423208,'556',3.333,4),(103,7423233,7423208,'563',3.333,4),(103,7423234,7423208,'639',3.333,4),(103,7423235,7423208,'393',3.333,4),(103,7423236,7423208,'934',3.333,4),(103,7423237,7423208,'344',3.333,4),(103,7423238,7423208,'447',3.333,4),(103,7423239,7423209,'ser',25,1),(103,7423240,7423209,'eri',25,1),(103,7423241,7423209,'ria',25,1),(103,7423242,7423209,'ial',25,1),(103,7423243,7423239,'siz',50,1),(103,7423244,7423239,'ize',50,1),(103,7423245,7423243,'321',100,1),(103,7423246,7423245,'dev',25,1),(103,7423247,7423245,'evi',25,1),(103,7423248,7423245,'vic',25,1),(103,7423249,7423245,'ice',25,1),(103,7423250,7423246,'typ',50,1),(103,7423251,7423246,'ype',50,1),(103,7423252,7423250,'dir',10,1),(103,7423253,7423250,'ire',10,1),(103,7423254,7423250,'rec',10,1),(103,7423255,7423250,'ect',10,1),(103,7423256,7423250,'cta',10,1),(103,7423257,7423250,'tac',10,1),(103,7423258,7423250,'acc',10,1),(103,7423259,7423250,'cce',10,1),(103,7423260,7423250,'ces',10,1),(103,7423261,7423250,'ess',10,1),(103,7423262,7423252,'mul',14.286,1),(103,7423263,7423252,'ult',14.286,1),(103,7423264,7423252,'lti',14.286,1),(103,7423265,7423252,'tip',14.286,1),(103,7423266,7423252,'ipa',14.286,1),(103,7423267,7423252,'pat',14.286,1),(103,7423268,7423252,'ath',14.286,1),(103,7423269,7423262,'plu',25,1),(103,7423270,7423262,'lug',25,1),(103,7423271,7423262,'ugi',25,1),(103,7423272,7423262,'gin',25,1),(103,7423273,7423269,'nmp',100,1),(103,7423274,7423273,'dev',33.333,1),(103,7423275,7423273,'evf',33.333,1),(103,7423276,7423273,'vfs',33.333,1),(103,7423277,7423274,'pat',50,1),(103,7423278,7423274,'ath',50,1),(103,7423279,7423277,'vmf',50,1),(103,7423280,7423277,'mfs',50,1),(103,7423281,7423279,'dev',20,1),(103,7423282,7423279,'evi',20,1),(103,7423283,7423279,'vic',20,1),(103,7423284,7423279,'ice',20,1),(103,7423285,7423279,'ces',20,1),(103,7423286,7423281,'dis',33.333,1),(103,7423287,7423281,'isk',33.333,1),(103,7423288,7423281,'sks',33.333,1),(103,7423289,7423286,'ven',25,1),(103,7423290,7423286,'end',25,1),(103,7423291,7423286,'ndo',25,1),(103,7423292,7423286,'dor',25,1),(103,7423293,7423289,'mod',33.333,1),(103,7423294,7423289,'ode',33.333,1),(103,7423295,7423289,'del',33.333,1),(103,7423296,7423293,'lun',100,1),(103,7423297,7423296,'cmo',33.333,1),(103,7423298,7423296,'mod',33.333,1),(103,7423299,7423296,'ode',33.333,1),(103,7423300,7423297,'rev',16.667,1),(103,7423301,7423297,'evi',16.667,1),(103,7423302,7423297,'vis',16.667,1),(103,7423303,7423297,'isi',16.667,1),(103,7423304,7423297,'sio',16.667,1),(103,7423305,7423297,'ion',16.667,1),(103,7423306,7423300,'810',50,1),(103,7423307,7423300,'100',50,1),(103,7423308,7423306,'scs',50,1),(103,7423309,7423306,'csi',50,1),(103,7423310,7423308,'lev',33.333,1),(103,7423311,7423308,'eve',33.333,1),(103,7423312,7423308,'vel',33.333,1),(103,7423313,7423310,'pse',25,1),(103,7423314,7423310,'seu',25,1),(103,7423315,7423310,'eud',25,1),(103,7423316,7423310,'udo',25,1),(103,7423317,7423313,'fal',33.333,6),(103,7423318,7423313,'als',33.333,6),(103,7423319,7423313,'lse',33.333,6),(103,7423320,7423317,'sta',25,3),(103,7423321,7423317,'tat',25,3),(103,7423322,7423317,'atu',25,3),(103,7423323,7423317,'tus',25,3),(103,7423324,7423320,'rdm',100,1),(103,7423325,7423324,'cap',20,1),(103,7423326,7423324,'apa',20,1),(103,7423327,7423324,'pab',20,1),(103,7423328,7423324,'abl',20,1),(103,7423329,7423324,'ble',20,1),(103,7423330,7423325,'tru',50,1),(103,7423331,7423325,'rue',50,1),(103,7423332,7423330,'loc',33.333,1),(103,7423333,7423330,'oca',33.333,1),(103,7423334,7423330,'cal',33.333,1),(103,7423335,7423332,'rem',14.286,1),(103,7423336,7423332,'emo',14.286,1),(103,7423337,7423332,'mov',14.286,1),(103,7423338,7423332,'ova',14.286,1),(103,7423339,7423332,'vab',14.286,1),(103,7423340,7423332,'abl',14.286,1),(103,7423341,7423332,'ble',14.286,1),(103,7423342,7423335,'ssd',100,1),(103,7423343,7423342,'off',20,1),(103,7423344,7423342,'ffl',20,1),(103,7423345,7423342,'fli',20,1),(103,7423346,7423342,'lin',20,1),(103,7423347,7423342,'ine',20,1),(103,7423348,7423343,'per',11.111,1),(103,7423349,7423343,'ere',11.111,1),(103,7423350,7423343,'ren',11.111,1),(103,7423351,7423343,'enn',11.111,1),(103,7423352,7423343,'nni',11.111,1),(103,7423353,7423343,'nia',11.111,1),(103,7423354,7423343,'ial',11.111,1),(103,7423355,7423343,'all',11.111,1),(103,7423356,7423343,'lly',11.111,1),(103,7423357,7423348,'res',16.667,1),(103,7423358,7423348,'ese',16.667,1),(103,7423359,7423348,'ser',16.667,1),(103,7423360,7423348,'erv',16.667,1),(103,7423361,7423348,'rve',16.667,1),(103,7423362,7423348,'ved',16.667,1),(103,7423363,7423357,'thi',50,1),(103,7423364,7423357,'hin',50,1),(103,7423365,7423363,'pro',10,1),(103,7423366,7423363,'rov',10,1),(103,7423367,7423363,'ovi',10,1),(103,7423368,7423363,'vis',10,1),(103,7423369,7423363,'isi',10,1),(103,7423370,7423363,'sio',10,1),(103,7423371,7423363,'ion',10,1),(103,7423372,7423363,'oni',10,1),(103,7423373,7423363,'nin',10,1),(103,7423374,7423363,'ing',10,1),(103,7423375,7423365,'yes',100,1),(103,7423376,7423375,'att',16.667,1),(103,7423377,7423375,'tta',16.667,1),(103,7423378,7423375,'tac',16.667,1),(103,7423379,7423375,'ach',16.667,1),(103,7423380,7423375,'che',16.667,1),(103,7423381,7423375,'hed',16.667,1),(103,7423382,7423376,'fil',20,1),(103,7423383,7423376,'ilt',20,1),(103,7423384,7423376,'lte',20,1),(103,7423385,7423376,'ter',20,1),(103,7423386,7423376,'ers',20,1),(103,7423387,7423382,'vaa',50,1),(103,7423388,7423382,'aai',50,1),(103,7423389,7423387,'unk',20,1),(103,7423390,7423387,'nkn',20,1),(103,7423391,7423387,'kno',20,1),(103,7423392,7423387,'now',20,1),(103,7423393,7423387,'own',20,1),(103,7423394,7423389,'oth',33.333,1),(103,7423395,7423389,'the',33.333,1),(103,7423396,7423389,'her',33.333,1),(103,7423397,7423394,'uid',50,1),(103,7423398,7423394,'ids',50,1),(103,7423399,7423397,'vml',100,1),(103,7423400,7423399,'dis',20,1),(103,7423401,7423399,'isp',20,1),(103,7423402,7423399,'spl',20,1),(103,7423403,7423399,'pla',20,1),(103,7423404,7423399,'lay',20,1),(103,7423405,7423400,'nam',50,1),(103,7423406,7423400,'ame',50,1),(104,7423408,7423407,'net',25,3),(104,7423409,7423407,'eta',25,3),(104,7423410,7423407,'tap',25,3),(104,7423411,7423407,'app',25,3),(104,7423412,7423408,'fib',33.333,2),(104,7423413,7423408,'ibr',33.333,2),(104,7423414,7423408,'bre',33.333,2),(104,7423415,7423412,'cha',20,2),(104,7423416,7423412,'han',20,2),(104,7423417,7423412,'ann',20,2),(104,7423418,7423412,'nne',20,2),(104,7423419,7423412,'nel',20,2),(104,7423420,7423415,'dis',50,2),(104,7423421,7423415,'isk',50,2),(104,7423422,7423420,'naa',100,4),(104,7423423,7423422,'600',3.333,4),(104,7423424,7423422,'00a',3.333,4),(104,7423425,7423422,'0a0',3.333,4),(104,7423426,7423422,'a09',3.333,4),(104,7423427,7423422,'098',3.333,4),(104,7423428,7423422,'980',3.333,4),(104,7423429,7423422,'804',3.333,4),(104,7423430,7423422,'044',3.333,4),(104,7423431,7423422,'443',3.333,4),(104,7423432,7423422,'430',3.333,4),(104,7423433,7423422,'307',3.333,4),(104,7423434,7423422,'072',3.333,4),(104,7423435,7423422,'725',3.333,4),(104,7423436,7423422,'259',3.333,4),(104,7423437,7423422,'593',3.333,4),(104,7423438,7423422,'931',3.333,4),(104,7423439,7423422,'313',3.333,4),(104,7423440,7423422,'13f',3.333,4),(104,7423441,7423422,'3f3',3.333,4),(104,7423442,7423422,'f33',3.333,4),(104,7423443,7423422,'334',3.333,4),(104,7423444,7423422,'345',3.333,4),(104,7423445,7423422,'455',3.333,4),(104,7423446,7423422,'556',3.333,4),(104,7423447,7423422,'563',3.333,4),(104,7423448,7423422,'639',3.333,4),(104,7423449,7423422,'393',3.333,4),(104,7423450,7423422,'934',3.333,4),(104,7423451,7423422,'344',3.333,4),(104,7423452,7423422,'448',3.333,4),(104,7423453,7423423,'ser',25,1),(104,7423454,7423423,'eri',25,1),(104,7423455,7423423,'ria',25,1),(104,7423456,7423423,'ial',25,1),(104,7423457,7423453,'siz',50,1),(104,7423458,7423453,'ize',50,1),(104,7423459,7423457,'321',100,1),(104,7423460,7423459,'dev',25,1),(104,7423461,7423459,'evi',25,1),(104,7423462,7423459,'vic',25,1),(104,7423463,7423459,'ice',25,1),(104,7423464,7423460,'typ',50,1),(104,7423465,7423460,'ype',50,1),(104,7423466,7423464,'dir',10,1),(104,7423467,7423464,'ire',10,1),(104,7423468,7423464,'rec',10,1),(104,7423469,7423464,'ect',10,1),(104,7423470,7423464,'cta',10,1),(104,7423471,7423464,'tac',10,1),(104,7423472,7423464,'acc',10,1),(104,7423473,7423464,'cce',10,1),(104,7423474,7423464,'ces',10,1),(104,7423475,7423464,'ess',10,1),(104,7423476,7423466,'mul',14.286,1),(104,7423477,7423466,'ult',14.286,1),(104,7423478,7423466,'lti',14.286,1),(104,7423479,7423466,'tip',14.286,1),(104,7423480,7423466,'ipa',14.286,1),(104,7423481,7423466,'pat',14.286,1),(104,7423482,7423466,'ath',14.286,1),(104,7423483,7423476,'plu',25,1),(104,7423484,7423476,'lug',25,1),(104,7423485,7423476,'ugi',25,1),(104,7423486,7423476,'gin',25,1),(104,7423487,7423483,'nmp',100,1),(104,7423488,7423487,'dev',33.333,1),(104,7423489,7423487,'evf',33.333,1),(104,7423490,7423487,'vfs',33.333,1),(104,7423491,7423488,'pat',50,1),(104,7423492,7423488,'ath',50,1),(104,7423493,7423491,'vmf',50,1),(104,7423494,7423491,'mfs',50,1),(104,7423495,7423493,'dev',20,1),(104,7423496,7423493,'evi',20,1),(104,7423497,7423493,'vic',20,1),(104,7423498,7423493,'ice',20,1),(104,7423499,7423493,'ces',20,1),(104,7423500,7423495,'dis',33.333,1),(104,7423501,7423495,'isk',33.333,1),(104,7423502,7423495,'sks',33.333,1),(104,7423503,7423500,'ven',25,1),(104,7423504,7423500,'end',25,1),(104,7423505,7423500,'ndo',25,1),(104,7423506,7423500,'dor',25,1),(104,7423507,7423503,'mod',33.333,1),(104,7423508,7423503,'ode',33.333,1),(104,7423509,7423503,'del',33.333,1),(104,7423510,7423507,'lun',100,1),(104,7423511,7423510,'cmo',33.333,1),(104,7423512,7423510,'mod',33.333,1),(104,7423513,7423510,'ode',33.333,1),(104,7423514,7423511,'rev',16.667,1),(104,7423515,7423511,'evi',16.667,1),(104,7423516,7423511,'vis',16.667,1),(104,7423517,7423511,'isi',16.667,1),(104,7423518,7423511,'sio',16.667,1),(104,7423519,7423511,'ion',16.667,1),(104,7423520,7423514,'810',50,1),(104,7423521,7423514,'100',50,1),(104,7423522,7423520,'scs',50,1),(104,7423523,7423520,'csi',50,1),(104,7423524,7423522,'lev',33.333,1),(104,7423525,7423522,'eve',33.333,1),(104,7423526,7423522,'vel',33.333,1),(104,7423527,7423524,'pse',25,1),(104,7423528,7423524,'seu',25,1),(104,7423529,7423524,'eud',25,1),(104,7423530,7423524,'udo',25,1),(104,7423531,7423527,'fal',33.333,6),(104,7423532,7423527,'als',33.333,6),(104,7423533,7423527,'lse',33.333,6),(104,7423534,7423531,'sta',25,3),(104,7423535,7423531,'tat',25,3),(104,7423536,7423531,'atu',25,3),(104,7423537,7423531,'tus',25,3),(104,7423538,7423534,'rdm',100,1),(104,7423539,7423538,'cap',20,1),(104,7423540,7423538,'apa',20,1),(104,7423541,7423538,'pab',20,1),(104,7423542,7423538,'abl',20,1),(104,7423543,7423538,'ble',20,1),(104,7423544,7423539,'tru',50,1),(104,7423545,7423539,'rue',50,1),(104,7423546,7423544,'loc',33.333,1),(104,7423547,7423544,'oca',33.333,1),(104,7423548,7423544,'cal',33.333,1),(104,7423549,7423546,'rem',14.286,1),(104,7423550,7423546,'emo',14.286,1),(104,7423551,7423546,'mov',14.286,1),(104,7423552,7423546,'ova',14.286,1),(104,7423553,7423546,'vab',14.286,1),(104,7423554,7423546,'abl',14.286,1),(104,7423555,7423546,'ble',14.286,1),(104,7423556,7423549,'ssd',100,1),(104,7423557,7423556,'off',20,1),(104,7423558,7423556,'ffl',20,1),(104,7423559,7423556,'fli',20,1),(104,7423560,7423556,'lin',20,1),(104,7423561,7423556,'ine',20,1),(104,7423562,7423557,'per',11.111,1),(104,7423563,7423557,'ere',11.111,1),(104,7423564,7423557,'ren',11.111,1),(104,7423565,7423557,'enn',11.111,1),(104,7423566,7423557,'nni',11.111,1),(104,7423567,7423557,'nia',11.111,1),(104,7423568,7423557,'ial',11.111,1),(104,7423569,7423557,'all',11.111,1),(104,7423570,7423557,'lly',11.111,1),(104,7423571,7423562,'res',16.667,1),(104,7423572,7423562,'ese',16.667,1),(104,7423573,7423562,'ser',16.667,1),(104,7423574,7423562,'erv',16.667,1),(104,7423575,7423562,'rve',16.667,1),(104,7423576,7423562,'ved',16.667,1),(104,7423577,7423571,'thi',50,1),(104,7423578,7423571,'hin',50,1),(104,7423579,7423577,'pro',10,1),(104,7423580,7423577,'rov',10,1),(104,7423581,7423577,'ovi',10,1),(104,7423582,7423577,'vis',10,1),(104,7423583,7423577,'isi',10,1),(104,7423584,7423577,'sio',10,1),(104,7423585,7423577,'ion',10,1),(104,7423586,7423577,'oni',10,1),(104,7423587,7423577,'nin',10,1),(104,7423588,7423577,'ing',10,1),(104,7423589,7423579,'yes',100,1),(104,7423590,7423589,'att',16.667,1),(104,7423591,7423589,'tta',16.667,1),(104,7423592,7423589,'tac',16.667,1),(104,7423593,7423589,'ach',16.667,1),(104,7423594,7423589,'che',16.667,1),(104,7423595,7423589,'hed',16.667,1),(104,7423596,7423590,'fil',20,1),(104,7423597,7423590,'ilt',20,1),(104,7423598,7423590,'lte',20,1),(104,7423599,7423590,'ter',20,1),(104,7423600,7423590,'ers',20,1),(104,7423601,7423596,'vaa',50,1),(104,7423602,7423596,'aai',50,1),(104,7423603,7423601,'unk',20,1),(104,7423604,7423601,'nkn',20,1),(104,7423605,7423601,'kno',20,1),(104,7423606,7423601,'now',20,1),(104,7423607,7423601,'own',20,1),(104,7423608,7423603,'oth',33.333,1),(104,7423609,7423603,'the',33.333,1),(104,7423610,7423603,'her',33.333,1),(104,7423611,7423608,'uid',50,1),(104,7423612,7423608,'ids',50,1),(104,7423613,7423611,'vml',100,1),(104,7423614,7423613,'dis',20,1),(104,7423615,7423613,'isp',20,1),(104,7423616,7423613,'spl',20,1),(104,7423617,7423613,'pla',20,1),(104,7423618,7423613,'lay',20,1),(104,7423619,7423614,'nam',50,1),(104,7423620,7423614,'ame',50,1),(105,7423622,7423621,'net',25,3),(105,7423623,7423621,'eta',25,3),(105,7423624,7423621,'tap',25,3),(105,7423625,7423621,'app',25,3),(105,7423626,7423622,'fib',33.333,2),(105,7423627,7423622,'ibr',33.333,2),(105,7423628,7423622,'bre',33.333,2),(105,7423629,7423626,'cha',20,2),(105,7423630,7423626,'han',20,2),(105,7423631,7423626,'ann',20,2),(105,7423632,7423626,'nne',20,2),(105,7423633,7423626,'nel',20,2),(105,7423634,7423629,'dis',50,2),(105,7423635,7423629,'isk',50,2),(105,7423636,7423634,'naa',100,4),(105,7423637,7423636,'600',3.333,4),(105,7423638,7423636,'00a',3.333,4),(105,7423639,7423636,'0a0',3.333,4),(105,7423640,7423636,'a09',3.333,4),(105,7423641,7423636,'098',3.333,4),(105,7423642,7423636,'980',3.333,4),(105,7423643,7423636,'804',3.333,4),(105,7423644,7423636,'044',3.333,4),(105,7423645,7423636,'443',3.333,4),(105,7423646,7423636,'430',3.333,4),(105,7423647,7423636,'307',3.333,4),(105,7423648,7423636,'072',3.333,4),(105,7423649,7423636,'725',3.333,4),(105,7423650,7423636,'259',3.333,4),(105,7423651,7423636,'593',3.333,4),(105,7423652,7423636,'931',3.333,4),(105,7423653,7423636,'313',3.333,4),(105,7423654,7423636,'13f',3.333,4),(105,7423655,7423636,'3f3',3.333,4),(105,7423656,7423636,'f33',3.333,4),(105,7423657,7423636,'334',3.333,4),(105,7423658,7423636,'345',3.333,4),(105,7423659,7423636,'455',3.333,4),(105,7423660,7423636,'556',3.333,4),(105,7423661,7423636,'563',3.333,4),(105,7423662,7423636,'639',3.333,4),(105,7423663,7423636,'393',3.333,4),(105,7423664,7423636,'934',3.333,4),(105,7423665,7423636,'344',3.333,4),(105,7423666,7423636,'449',3.333,4),(105,7423667,7423637,'ser',25,1),(105,7423668,7423637,'eri',25,1),(105,7423669,7423637,'ria',25,1),(105,7423670,7423637,'ial',25,1),(105,7423671,7423667,'siz',50,1),(105,7423672,7423667,'ize',50,1),(105,7423673,7423671,'321',100,1),(105,7423674,7423673,'dev',25,1),(105,7423675,7423673,'evi',25,1),(105,7423676,7423673,'vic',25,1),(105,7423677,7423673,'ice',25,1),(105,7423678,7423674,'typ',50,1),(105,7423679,7423674,'ype',50,1),(105,7423680,7423678,'dir',10,1),(105,7423681,7423678,'ire',10,1),(105,7423682,7423678,'rec',10,1),(105,7423683,7423678,'ect',10,1),(105,7423684,7423678,'cta',10,1),(105,7423685,7423678,'tac',10,1),(105,7423686,7423678,'acc',10,1),(105,7423687,7423678,'cce',10,1),(105,7423688,7423678,'ces',10,1),(105,7423689,7423678,'ess',10,1),(105,7423690,7423680,'mul',14.286,1),(105,7423691,7423680,'ult',14.286,1),(105,7423692,7423680,'lti',14.286,1),(105,7423693,7423680,'tip',14.286,1),(105,7423694,7423680,'ipa',14.286,1),(105,7423695,7423680,'pat',14.286,1),(105,7423696,7423680,'ath',14.286,1),(105,7423697,7423690,'plu',25,1),(105,7423698,7423690,'lug',25,1),(105,7423699,7423690,'ugi',25,1),(105,7423700,7423690,'gin',25,1),(105,7423701,7423697,'nmp',100,1),(105,7423702,7423701,'dev',33.333,1),(105,7423703,7423701,'evf',33.333,1),(105,7423704,7423701,'vfs',33.333,1),(105,7423705,7423702,'pat',50,1),(105,7423706,7423702,'ath',50,1),(105,7423707,7423705,'vmf',50,1),(105,7423708,7423705,'mfs',50,1),(105,7423709,7423707,'dev',20,1),(105,7423710,7423707,'evi',20,1),(105,7423711,7423707,'vic',20,1),(105,7423712,7423707,'ice',20,1),(105,7423713,7423707,'ces',20,1),(105,7423714,7423709,'dis',33.333,1),(105,7423715,7423709,'isk',33.333,1),(105,7423716,7423709,'sks',33.333,1),(105,7423717,7423714,'ven',25,1),(105,7423718,7423714,'end',25,1),(105,7423719,7423714,'ndo',25,1),(105,7423720,7423714,'dor',25,1),(105,7423721,7423717,'mod',33.333,1),(105,7423722,7423717,'ode',33.333,1),(105,7423723,7423717,'del',33.333,1),(105,7423724,7423721,'lun',100,1),(105,7423725,7423724,'cmo',33.333,1),(105,7423726,7423724,'mod',33.333,1),(105,7423727,7423724,'ode',33.333,1),(105,7423728,7423725,'rev',16.667,1),(105,7423729,7423725,'evi',16.667,1),(105,7423730,7423725,'vis',16.667,1),(105,7423731,7423725,'isi',16.667,1),(105,7423732,7423725,'sio',16.667,1),(105,7423733,7423725,'ion',16.667,1),(105,7423734,7423728,'810',50,1),(105,7423735,7423728,'100',50,1),(105,7423736,7423734,'scs',50,1),(105,7423737,7423734,'csi',50,1),(105,7423738,7423736,'lev',33.333,1),(105,7423739,7423736,'eve',33.333,1),(105,7423740,7423736,'vel',33.333,1),(105,7423741,7423738,'pse',25,1),(105,7423742,7423738,'seu',25,1),(105,7423743,7423738,'eud',25,1),(105,7423744,7423738,'udo',25,1),(105,7423745,7423741,'fal',33.333,6),(105,7423746,7423741,'als',33.333,6),(105,7423747,7423741,'lse',33.333,6),(105,7423748,7423745,'sta',25,3),(105,7423749,7423745,'tat',25,3),(105,7423750,7423745,'atu',25,3),(105,7423751,7423745,'tus',25,3),(105,7423752,7423748,'rdm',100,1),(105,7423753,7423752,'cap',20,1),(105,7423754,7423752,'apa',20,1),(105,7423755,7423752,'pab',20,1),(105,7423756,7423752,'abl',20,1),(105,7423757,7423752,'ble',20,1),(105,7423758,7423753,'tru',50,1),(105,7423759,7423753,'rue',50,1),(105,7423760,7423758,'loc',33.333,1),(105,7423761,7423758,'oca',33.333,1),(105,7423762,7423758,'cal',33.333,1),(105,7423763,7423760,'rem',14.286,1),(105,7423764,7423760,'emo',14.286,1),(105,7423765,7423760,'mov',14.286,1),(105,7423766,7423760,'ova',14.286,1),(105,7423767,7423760,'vab',14.286,1),(105,7423768,7423760,'abl',14.286,1),(105,7423769,7423760,'ble',14.286,1),(105,7423770,7423763,'ssd',100,1),(105,7423771,7423770,'off',20,1),(105,7423772,7423770,'ffl',20,1),(105,7423773,7423770,'fli',20,1),(105,7423774,7423770,'lin',20,1),(105,7423775,7423770,'ine',20,1),(105,7423776,7423771,'per',11.111,1),(105,7423777,7423771,'ere',11.111,1),(105,7423778,7423771,'ren',11.111,1),(105,7423779,7423771,'enn',11.111,1),(105,7423780,7423771,'nni',11.111,1),(105,7423781,7423771,'nia',11.111,1),(105,7423782,7423771,'ial',11.111,1),(105,7423783,7423771,'all',11.111,1),(105,7423784,7423771,'lly',11.111,1),(105,7423785,7423776,'res',16.667,1),(105,7423786,7423776,'ese',16.667,1),(105,7423787,7423776,'ser',16.667,1),(105,7423788,7423776,'erv',16.667,1),(105,7423789,7423776,'rve',16.667,1),(105,7423790,7423776,'ved',16.667,1),(105,7423791,7423785,'thi',50,1),(105,7423792,7423785,'hin',50,1),(105,7423793,7423791,'pro',10,1),(105,7423794,7423791,'rov',10,1),(105,7423795,7423791,'ovi',10,1),(105,7423796,7423791,'vis',10,1),(105,7423797,7423791,'isi',10,1),(105,7423798,7423791,'sio',10,1),(105,7423799,7423791,'ion',10,1),(105,7423800,7423791,'oni',10,1),(105,7423801,7423791,'nin',10,1),(105,7423802,7423791,'ing',10,1),(105,7423803,7423793,'yes',100,1),(105,7423804,7423803,'att',16.667,1),(105,7423805,7423803,'tta',16.667,1),(105,7423806,7423803,'tac',16.667,1),(105,7423807,7423803,'ach',16.667,1),(105,7423808,7423803,'che',16.667,1),(105,7423809,7423803,'hed',16.667,1),(105,7423810,7423804,'fil',20,1),(105,7423811,7423804,'ilt',20,1),(105,7423812,7423804,'lte',20,1),(105,7423813,7423804,'ter',20,1),(105,7423814,7423804,'ers',20,1),(105,7423815,7423810,'vaa',50,1),(105,7423816,7423810,'aai',50,1),(105,7423817,7423815,'unk',20,1),(105,7423818,7423815,'nkn',20,1),(105,7423819,7423815,'kno',20,1),(105,7423820,7423815,'now',20,1),(105,7423821,7423815,'own',20,1),(105,7423822,7423817,'oth',33.333,1),(105,7423823,7423817,'the',33.333,1),(105,7423824,7423817,'her',33.333,1),(105,7423825,7423822,'uid',50,1),(105,7423826,7423822,'ids',50,1),(105,7423827,7423825,'vml',100,1),(105,7423828,7423827,'dis',20,1),(105,7423829,7423827,'isp',20,1),(105,7423830,7423827,'spl',20,1),(105,7423831,7423827,'pla',20,1),(105,7423832,7423827,'lay',20,1),(105,7423833,7423828,'nam',50,1),(105,7423834,7423828,'ame',50,1),(106,7423836,7423835,'net',25,3),(106,7423837,7423835,'eta',25,3),(106,7423838,7423835,'tap',25,3),(106,7423839,7423835,'app',25,3),(106,7423840,7423836,'fib',33.333,2),(106,7423841,7423836,'ibr',33.333,2),(106,7423842,7423836,'bre',33.333,2),(106,7423843,7423840,'cha',20,2),(106,7423844,7423840,'han',20,2),(106,7423845,7423840,'ann',20,2),(106,7423846,7423840,'nne',20,2),(106,7423847,7423840,'nel',20,2),(106,7423848,7423843,'dis',50,2),(106,7423849,7423843,'isk',50,2),(106,7423850,7423848,'naa',100,4),(106,7423851,7423850,'600',3.333,4),(106,7423852,7423850,'00a',3.333,4),(106,7423853,7423850,'0a0',3.333,4),(106,7423854,7423850,'a09',3.333,4),(106,7423855,7423850,'098',3.333,4),(106,7423856,7423850,'980',3.333,4),(106,7423857,7423850,'804',3.333,4),(106,7423858,7423850,'044',3.333,4),(106,7423859,7423850,'443',3.333,4),(106,7423860,7423850,'430',3.333,4),(106,7423861,7423850,'307',3.333,4),(106,7423862,7423850,'072',3.333,4),(106,7423863,7423850,'725',3.333,4),(106,7423864,7423850,'259',3.333,4),(106,7423865,7423850,'593',3.333,4),(106,7423866,7423850,'931',3.333,4),(106,7423867,7423850,'313',3.333,4),(106,7423868,7423850,'13f',3.333,4),(106,7423869,7423850,'3f3',3.333,4),(106,7423870,7423850,'f33',3.333,4),(106,7423871,7423850,'334',3.333,4),(106,7423872,7423850,'345',3.333,4),(106,7423873,7423850,'455',3.333,4),(106,7423874,7423850,'556',3.333,4),(106,7423875,7423850,'563',3.333,4),(106,7423876,7423850,'638',3.333,4),(106,7423877,7423850,'387',3.333,4),(106,7423878,7423850,'872',3.333,4),(106,7423879,7423850,'724',3.333,4),(106,7423880,7423850,'243',3.333,4),(106,7423881,7423851,'ser',25,1),(106,7423882,7423851,'eri',25,1),(106,7423883,7423851,'ria',25,1),(106,7423884,7423851,'ial',25,1),(106,7423885,7423881,'siz',50,1),(106,7423886,7423881,'ize',50,1),(106,7423887,7423885,'460',33.333,1),(106,7423888,7423885,'608',33.333,1),(106,7423889,7423885,'080',33.333,1),(106,7423890,7423887,'dev',25,1),(106,7423891,7423887,'evi',25,1),(106,7423892,7423887,'vic',25,1),(106,7423893,7423887,'ice',25,1),(106,7423894,7423890,'typ',50,1),(106,7423895,7423890,'ype',50,1),(106,7423896,7423894,'dir',10,1),(106,7423897,7423894,'ire',10,1),(106,7423898,7423894,'rec',10,1),(106,7423899,7423894,'ect',10,1),(106,7423900,7423894,'cta',10,1),(106,7423901,7423894,'tac',10,1),(106,7423902,7423894,'acc',10,1),(106,7423903,7423894,'cce',10,1),(106,7423904,7423894,'ces',10,1),(106,7423905,7423894,'ess',10,1),(106,7423906,7423896,'mul',14.286,1),(106,7423907,7423896,'ult',14.286,1),(106,7423908,7423896,'lti',14.286,1),(106,7423909,7423896,'tip',14.286,1),(106,7423910,7423896,'ipa',14.286,1),(106,7423911,7423896,'pat',14.286,1),(106,7423912,7423896,'ath',14.286,1),(106,7423913,7423906,'plu',25,1),(106,7423914,7423906,'lug',25,1),(106,7423915,7423906,'ugi',25,1),(106,7423916,7423906,'gin',25,1),(106,7423917,7423913,'nmp',100,1),(106,7423918,7423917,'dev',33.333,1),(106,7423919,7423917,'evf',33.333,1),(106,7423920,7423917,'vfs',33.333,1),(106,7423921,7423918,'pat',50,1),(106,7423922,7423918,'ath',50,1),(106,7423923,7423921,'vmf',50,1),(106,7423924,7423921,'mfs',50,1),(106,7423925,7423923,'dev',20,1),(106,7423926,7423923,'evi',20,1),(106,7423927,7423923,'vic',20,1),(106,7423928,7423923,'ice',20,1),(106,7423929,7423923,'ces',20,1),(106,7423930,7423925,'dis',33.333,1),(106,7423931,7423925,'isk',33.333,1),(106,7423932,7423925,'sks',33.333,1),(106,7423933,7423930,'ven',25,1),(106,7423934,7423930,'end',25,1),(106,7423935,7423930,'ndo',25,1),(106,7423936,7423930,'dor',25,1),(106,7423937,7423933,'mod',33.333,1),(106,7423938,7423933,'ode',33.333,1),(106,7423939,7423933,'del',33.333,1),(106,7423940,7423937,'lun',100,1),(106,7423941,7423940,'cmo',33.333,1),(106,7423942,7423940,'mod',33.333,1),(106,7423943,7423940,'ode',33.333,1),(106,7423944,7423941,'rev',16.667,1),(106,7423945,7423941,'evi',16.667,1),(106,7423946,7423941,'vis',16.667,1),(106,7423947,7423941,'isi',16.667,1),(106,7423948,7423941,'sio',16.667,1),(106,7423949,7423941,'ion',16.667,1),(106,7423950,7423944,'810',50,1),(106,7423951,7423944,'100',50,1),(106,7423952,7423950,'scs',50,1),(106,7423953,7423950,'csi',50,1),(106,7423954,7423952,'lev',33.333,1),(106,7423955,7423952,'eve',33.333,1),(106,7423956,7423952,'vel',33.333,1),(106,7423957,7423954,'pse',25,1),(106,7423958,7423954,'seu',25,1),(106,7423959,7423954,'eud',25,1),(106,7423960,7423954,'udo',25,1),(106,7423961,7423957,'fal',33.333,6),(106,7423962,7423957,'als',33.333,6),(106,7423963,7423957,'lse',33.333,6),(106,7423964,7423961,'sta',25,3),(106,7423965,7423961,'tat',25,3),(106,7423966,7423961,'atu',25,3),(106,7423967,7423961,'tus',25,3),(106,7423968,7423964,'rdm',100,1),(106,7423969,7423968,'cap',20,1),(106,7423970,7423968,'apa',20,1),(106,7423971,7423968,'pab',20,1),(106,7423972,7423968,'abl',20,1),(106,7423973,7423968,'ble',20,1),(106,7423974,7423969,'tru',50,1),(106,7423975,7423969,'rue',50,1),(106,7423976,7423974,'loc',33.333,1),(106,7423977,7423974,'oca',33.333,1),(106,7423978,7423974,'cal',33.333,1),(106,7423979,7423976,'rem',14.286,1),(106,7423980,7423976,'emo',14.286,1),(106,7423981,7423976,'mov',14.286,1),(106,7423982,7423976,'ova',14.286,1),(106,7423983,7423976,'vab',14.286,1),(106,7423984,7423976,'abl',14.286,1),(106,7423985,7423976,'ble',14.286,1),(106,7423986,7423979,'ssd',100,1),(106,7423987,7423986,'off',20,1),(106,7423988,7423986,'ffl',20,1),(106,7423989,7423986,'fli',20,1),(106,7423990,7423986,'lin',20,1),(106,7423991,7423986,'ine',20,1),(106,7423992,7423987,'per',11.111,1),(106,7423993,7423987,'ere',11.111,1),(106,7423994,7423987,'ren',11.111,1),(106,7423995,7423987,'enn',11.111,1),(106,7423996,7423987,'nni',11.111,1),(106,7423997,7423987,'nia',11.111,1),(106,7423998,7423987,'ial',11.111,1),(106,7423999,7423987,'all',11.111,1),(106,7424000,7423987,'lly',11.111,1),(106,7424001,7423992,'res',16.667,1),(106,7424002,7423992,'ese',16.667,1),(106,7424003,7423992,'ser',16.667,1),(106,7424004,7423992,'erv',16.667,1),(106,7424005,7423992,'rve',16.667,1),(106,7424006,7423992,'ved',16.667,1),(106,7424007,7424001,'thi',50,1),(106,7424008,7424001,'hin',50,1),(106,7424009,7424007,'pro',10,1),(106,7424010,7424007,'rov',10,1),(106,7424011,7424007,'ovi',10,1),(106,7424012,7424007,'vis',10,1),(106,7424013,7424007,'isi',10,1),(106,7424014,7424007,'sio',10,1),(106,7424015,7424007,'ion',10,1),(106,7424016,7424007,'oni',10,1),(106,7424017,7424007,'nin',10,1),(106,7424018,7424007,'ing',10,1),(106,7424019,7424009,'yes',100,1),(106,7424020,7424019,'att',16.667,1),(106,7424021,7424019,'tta',16.667,1),(106,7424022,7424019,'tac',16.667,1),(106,7424023,7424019,'ach',16.667,1),(106,7424024,7424019,'che',16.667,1),(106,7424025,7424019,'hed',16.667,1),(106,7424026,7424020,'fil',20,1),(106,7424027,7424020,'ilt',20,1),(106,7424028,7424020,'lte',20,1),(106,7424029,7424020,'ter',20,1),(106,7424030,7424020,'ers',20,1),(106,7424031,7424026,'vaa',50,1),(106,7424032,7424026,'aai',50,1),(106,7424033,7424031,'unk',20,1),(106,7424034,7424031,'nkn',20,1),(106,7424035,7424031,'kno',20,1),(106,7424036,7424031,'now',20,1),(106,7424037,7424031,'own',20,1),(106,7424038,7424033,'oth',33.333,1),(106,7424039,7424033,'the',33.333,1),(106,7424040,7424033,'her',33.333,1),(106,7424041,7424038,'uid',50,1),(106,7424042,7424038,'ids',50,1),(106,7424043,7424041,'vml',100,1),(106,7424044,7424043,'dis',20,1),(106,7424045,7424043,'isp',20,1),(106,7424046,7424043,'spl',20,1),(106,7424047,7424043,'pla',20,1),(106,7424048,7424043,'lay',20,1),(106,7424049,7424044,'nam',50,1),(106,7424050,7424044,'ame',50,1),(107,7424052,7424051,'net',25,3),(107,7424053,7424051,'eta',25,3),(107,7424054,7424051,'tap',25,3),(107,7424055,7424051,'app',25,3),(107,7424056,7424052,'fib',33.333,2),(107,7424057,7424052,'ibr',33.333,2),(107,7424058,7424052,'bre',33.333,2),(107,7424059,7424056,'cha',20,2),(107,7424060,7424056,'han',20,2),(107,7424061,7424056,'ann',20,2),(107,7424062,7424056,'nne',20,2),(107,7424063,7424056,'nel',20,2),(107,7424064,7424059,'dis',50,2),(107,7424065,7424059,'isk',50,2),(107,7424066,7424064,'naa',100,4),(107,7424067,7424066,'600',3.333,4),(107,7424068,7424066,'00a',3.333,4),(107,7424069,7424066,'0a0',3.333,4),(107,7424070,7424066,'a09',3.333,4),(107,7424071,7424066,'098',3.333,4),(107,7424072,7424066,'980',3.333,4),(107,7424073,7424066,'804',3.333,4),(107,7424074,7424066,'044',3.333,4),(107,7424075,7424066,'443',3.333,4),(107,7424076,7424066,'430',3.333,4),(107,7424077,7424066,'307',3.333,4),(107,7424078,7424066,'072',3.333,4),(107,7424079,7424066,'725',3.333,4),(107,7424080,7424066,'259',3.333,4),(107,7424081,7424066,'593',3.333,4),(107,7424082,7424066,'931',3.333,4),(107,7424083,7424066,'313',3.333,4),(107,7424084,7424066,'13f',3.333,4),(107,7424085,7424066,'3f3',3.333,4),(107,7424086,7424066,'f33',3.333,4),(107,7424087,7424066,'334',3.333,4),(107,7424088,7424066,'345',3.333,4),(107,7424089,7424066,'455',3.333,4),(107,7424090,7424066,'556',3.333,4),(107,7424091,7424066,'563',3.333,4),(107,7424092,7424066,'638',3.333,4),(107,7424093,7424066,'387',3.333,4),(107,7424094,7424066,'872',3.333,4),(107,7424095,7424066,'724',3.333,4),(107,7424096,7424066,'244',3.333,4),(107,7424097,7424067,'ser',25,1),(107,7424098,7424067,'eri',25,1),(107,7424099,7424067,'ria',25,1),(107,7424100,7424067,'ial',25,1),(107,7424101,7424097,'siz',50,1),(107,7424102,7424097,'ize',50,1),(107,7424103,7424101,'460',33.333,1),(107,7424104,7424101,'608',33.333,1),(107,7424105,7424101,'080',33.333,1),(107,7424106,7424103,'dev',25,1),(107,7424107,7424103,'evi',25,1),(107,7424108,7424103,'vic',25,1),(107,7424109,7424103,'ice',25,1),(107,7424110,7424106,'typ',50,1),(107,7424111,7424106,'ype',50,1),(107,7424112,7424110,'dir',10,1),(107,7424113,7424110,'ire',10,1),(107,7424114,7424110,'rec',10,1),(107,7424115,7424110,'ect',10,1),(107,7424116,7424110,'cta',10,1),(107,7424117,7424110,'tac',10,1),(107,7424118,7424110,'acc',10,1),(107,7424119,7424110,'cce',10,1),(107,7424120,7424110,'ces',10,1),(107,7424121,7424110,'ess',10,1),(107,7424122,7424112,'mul',14.286,1),(107,7424123,7424112,'ult',14.286,1),(107,7424124,7424112,'lti',14.286,1),(107,7424125,7424112,'tip',14.286,1),(107,7424126,7424112,'ipa',14.286,1),(107,7424127,7424112,'pat',14.286,1),(107,7424128,7424112,'ath',14.286,1),(107,7424129,7424122,'plu',25,1),(107,7424130,7424122,'lug',25,1),(107,7424131,7424122,'ugi',25,1),(107,7424132,7424122,'gin',25,1),(107,7424133,7424129,'nmp',100,1),(107,7424134,7424133,'dev',33.333,1),(107,7424135,7424133,'evf',33.333,1),(107,7424136,7424133,'vfs',33.333,1),(107,7424137,7424134,'pat',50,1),(107,7424138,7424134,'ath',50,1),(107,7424139,7424137,'vmf',50,1),(107,7424140,7424137,'mfs',50,1),(107,7424141,7424139,'dev',20,1),(107,7424142,7424139,'evi',20,1),(107,7424143,7424139,'vic',20,1),(107,7424144,7424139,'ice',20,1),(107,7424145,7424139,'ces',20,1),(107,7424146,7424141,'dis',33.333,1),(107,7424147,7424141,'isk',33.333,1),(107,7424148,7424141,'sks',33.333,1),(107,7424149,7424146,'ven',25,1),(107,7424150,7424146,'end',25,1),(107,7424151,7424146,'ndo',25,1),(107,7424152,7424146,'dor',25,1),(107,7424153,7424149,'mod',33.333,1),(107,7424154,7424149,'ode',33.333,1),(107,7424155,7424149,'del',33.333,1),(107,7424156,7424153,'lun',100,1),(107,7424157,7424156,'cmo',33.333,1),(107,7424158,7424156,'mod',33.333,1),(107,7424159,7424156,'ode',33.333,1),(107,7424160,7424157,'rev',16.667,1),(107,7424161,7424157,'evi',16.667,1),(107,7424162,7424157,'vis',16.667,1),(107,7424163,7424157,'isi',16.667,1),(107,7424164,7424157,'sio',16.667,1),(107,7424165,7424157,'ion',16.667,1),(107,7424166,7424160,'810',50,1),(107,7424167,7424160,'100',50,1),(107,7424168,7424166,'scs',50,1),(107,7424169,7424166,'csi',50,1),(107,7424170,7424168,'lev',33.333,1),(107,7424171,7424168,'eve',33.333,1),(107,7424172,7424168,'vel',33.333,1),(107,7424173,7424170,'pse',25,1),(107,7424174,7424170,'seu',25,1),(107,7424175,7424170,'eud',25,1),(107,7424176,7424170,'udo',25,1),(107,7424177,7424173,'fal',33.333,6),(107,7424178,7424173,'als',33.333,6),(107,7424179,7424173,'lse',33.333,6),(107,7424180,7424177,'sta',25,3),(107,7424181,7424177,'tat',25,3),(107,7424182,7424177,'atu',25,3),(107,7424183,7424177,'tus',25,3),(107,7424184,7424180,'rdm',100,1),(107,7424185,7424184,'cap',20,1),(107,7424186,7424184,'apa',20,1),(107,7424187,7424184,'pab',20,1),(107,7424188,7424184,'abl',20,1),(107,7424189,7424184,'ble',20,1),(107,7424190,7424185,'tru',50,1),(107,7424191,7424185,'rue',50,1),(107,7424192,7424190,'loc',33.333,1),(107,7424193,7424190,'oca',33.333,1),(107,7424194,7424190,'cal',33.333,1),(107,7424195,7424192,'rem',14.286,1),(107,7424196,7424192,'emo',14.286,1),(107,7424197,7424192,'mov',14.286,1),(107,7424198,7424192,'ova',14.286,1),(107,7424199,7424192,'vab',14.286,1),(107,7424200,7424192,'abl',14.286,1),(107,7424201,7424192,'ble',14.286,1),(107,7424202,7424195,'ssd',100,1),(107,7424203,7424202,'off',20,1),(107,7424204,7424202,'ffl',20,1),(107,7424205,7424202,'fli',20,1),(107,7424206,7424202,'lin',20,1),(107,7424207,7424202,'ine',20,1),(107,7424208,7424203,'per',11.111,1),(107,7424209,7424203,'ere',11.111,1),(107,7424210,7424203,'ren',11.111,1),(107,7424211,7424203,'enn',11.111,1),(107,7424212,7424203,'nni',11.111,1),(107,7424213,7424203,'nia',11.111,1),(107,7424214,7424203,'ial',11.111,1),(107,7424215,7424203,'all',11.111,1),(107,7424216,7424203,'lly',11.111,1),(107,7424217,7424208,'res',16.667,1),(107,7424218,7424208,'ese',16.667,1),(107,7424219,7424208,'ser',16.667,1),(107,7424220,7424208,'erv',16.667,1),(107,7424221,7424208,'rve',16.667,1),(107,7424222,7424208,'ved',16.667,1),(107,7424223,7424217,'thi',50,1),(107,7424224,7424217,'hin',50,1),(107,7424225,7424223,'pro',10,1),(107,7424226,7424223,'rov',10,1),(107,7424227,7424223,'ovi',10,1),(107,7424228,7424223,'vis',10,1),(107,7424229,7424223,'isi',10,1),(107,7424230,7424223,'sio',10,1),(107,7424231,7424223,'ion',10,1),(107,7424232,7424223,'oni',10,1),(107,7424233,7424223,'nin',10,1),(107,7424234,7424223,'ing',10,1),(107,7424235,7424225,'yes',100,1),(107,7424236,7424235,'att',16.667,1),(107,7424237,7424235,'tta',16.667,1),(107,7424238,7424235,'tac',16.667,1),(107,7424239,7424235,'ach',16.667,1),(107,7424240,7424235,'che',16.667,1),(107,7424241,7424235,'hed',16.667,1),(107,7424242,7424236,'fil',20,1),(107,7424243,7424236,'ilt',20,1),(107,7424244,7424236,'lte',20,1),(107,7424245,7424236,'ter',20,1),(107,7424246,7424236,'ers',20,1),(107,7424247,7424242,'vaa',50,1),(107,7424248,7424242,'aai',50,1),(107,7424249,7424247,'unk',20,1),(107,7424250,7424247,'nkn',20,1),(107,7424251,7424247,'kno',20,1),(107,7424252,7424247,'now',20,1),(107,7424253,7424247,'own',20,1),(107,7424254,7424249,'oth',33.333,1),(107,7424255,7424249,'the',33.333,1),(107,7424256,7424249,'her',33.333,1),(107,7424257,7424254,'uid',50,1),(107,7424258,7424254,'ids',50,1),(107,7424259,7424257,'vml',100,1),(107,7424260,7424259,'dis',20,1),(107,7424261,7424259,'isp',20,1),(107,7424262,7424259,'spl',20,1),(107,7424263,7424259,'pla',20,1),(107,7424264,7424259,'lay',20,1),(107,7424265,7424260,'nam',50,1),(107,7424266,7424260,'ame',50,1),(108,7424268,7424267,'net',25,3),(108,7424269,7424267,'eta',25,3),(108,7424270,7424267,'tap',25,3),(108,7424271,7424267,'app',25,3),(108,7424272,7424268,'fib',33.333,2),(108,7424273,7424268,'ibr',33.333,2),(108,7424274,7424268,'bre',33.333,2),(108,7424275,7424272,'cha',20,2),(108,7424276,7424272,'han',20,2),(108,7424277,7424272,'ann',20,2),(108,7424278,7424272,'nne',20,2),(108,7424279,7424272,'nel',20,2),(108,7424280,7424275,'dis',50,2),(108,7424281,7424275,'isk',50,2),(108,7424282,7424280,'naa',100,4),(108,7424283,7424282,'600',3.333,4),(108,7424284,7424282,'00a',3.333,4),(108,7424285,7424282,'0a0',3.333,4),(108,7424286,7424282,'a09',3.333,4),(108,7424287,7424282,'098',3.333,4),(108,7424288,7424282,'980',3.333,4),(108,7424289,7424282,'804',3.333,4),(108,7424290,7424282,'044',3.333,4),(108,7424291,7424282,'443',3.333,4),(108,7424292,7424282,'430',3.333,4),(108,7424293,7424282,'307',3.333,4),(108,7424294,7424282,'072',3.333,4),(108,7424295,7424282,'725',3.333,4),(108,7424296,7424282,'259',3.333,4),(108,7424297,7424282,'593',3.333,4),(108,7424298,7424282,'931',3.333,4),(108,7424299,7424282,'313',3.333,4),(108,7424300,7424282,'13f',3.333,4),(108,7424301,7424282,'3f3',3.333,4),(108,7424302,7424282,'f33',3.333,4),(108,7424303,7424282,'334',3.333,4),(108,7424304,7424282,'345',3.333,4),(108,7424305,7424282,'455',3.333,4),(108,7424306,7424282,'556',3.333,4),(108,7424307,7424282,'563',3.333,4),(108,7424308,7424282,'638',3.333,4),(108,7424309,7424282,'387',3.333,4),(108,7424310,7424282,'872',3.333,4),(108,7424311,7424282,'724',3.333,4),(108,7424312,7424282,'245',3.333,4),(108,7424313,7424283,'ser',25,1),(108,7424314,7424283,'eri',25,1),(108,7424315,7424283,'ria',25,1),(108,7424316,7424283,'ial',25,1),(108,7424317,7424313,'siz',50,1),(108,7424318,7424313,'ize',50,1),(108,7424319,7424317,'460',33.333,1),(108,7424320,7424317,'608',33.333,1),(108,7424321,7424317,'080',33.333,1),(108,7424322,7424319,'dev',25,1),(108,7424323,7424319,'evi',25,1),(108,7424324,7424319,'vic',25,1),(108,7424325,7424319,'ice',25,1),(108,7424326,7424322,'typ',50,1),(108,7424327,7424322,'ype',50,1),(108,7424328,7424326,'dir',10,1),(108,7424329,7424326,'ire',10,1),(108,7424330,7424326,'rec',10,1),(108,7424331,7424326,'ect',10,1),(108,7424332,7424326,'cta',10,1),(108,7424333,7424326,'tac',10,1),(108,7424334,7424326,'acc',10,1),(108,7424335,7424326,'cce',10,1),(108,7424336,7424326,'ces',10,1),(108,7424337,7424326,'ess',10,1),(108,7424338,7424328,'mul',14.286,1),(108,7424339,7424328,'ult',14.286,1),(108,7424340,7424328,'lti',14.286,1),(108,7424341,7424328,'tip',14.286,1),(108,7424342,7424328,'ipa',14.286,1),(108,7424343,7424328,'pat',14.286,1),(108,7424344,7424328,'ath',14.286,1),(108,7424345,7424338,'plu',25,1),(108,7424346,7424338,'lug',25,1),(108,7424347,7424338,'ugi',25,1),(108,7424348,7424338,'gin',25,1),(108,7424349,7424345,'nmp',100,1),(108,7424350,7424349,'dev',33.333,1),(108,7424351,7424349,'evf',33.333,1),(108,7424352,7424349,'vfs',33.333,1),(108,7424353,7424350,'pat',50,1),(108,7424354,7424350,'ath',50,1),(108,7424355,7424353,'vmf',50,1),(108,7424356,7424353,'mfs',50,1),(108,7424357,7424355,'dev',20,1),(108,7424358,7424355,'evi',20,1),(108,7424359,7424355,'vic',20,1),(108,7424360,7424355,'ice',20,1),(108,7424361,7424355,'ces',20,1),(108,7424362,7424357,'dis',33.333,1),(108,7424363,7424357,'isk',33.333,1),(108,7424364,7424357,'sks',33.333,1),(108,7424365,7424362,'ven',25,1),(108,7424366,7424362,'end',25,1),(108,7424367,7424362,'ndo',25,1),(108,7424368,7424362,'dor',25,1),(108,7424369,7424365,'mod',33.333,1),(108,7424370,7424365,'ode',33.333,1),(108,7424371,7424365,'del',33.333,1),(108,7424372,7424369,'lun',100,1),(108,7424373,7424372,'cmo',33.333,1),(108,7424374,7424372,'mod',33.333,1),(108,7424375,7424372,'ode',33.333,1),(108,7424376,7424373,'rev',16.667,1),(108,7424377,7424373,'evi',16.667,1),(108,7424378,7424373,'vis',16.667,1),(108,7424379,7424373,'isi',16.667,1),(108,7424380,7424373,'sio',16.667,1),(108,7424381,7424373,'ion',16.667,1),(108,7424382,7424376,'810',50,1),(108,7424383,7424376,'100',50,1),(108,7424384,7424382,'scs',50,1),(108,7424385,7424382,'csi',50,1),(108,7424386,7424384,'lev',33.333,1),(108,7424387,7424384,'eve',33.333,1),(108,7424388,7424384,'vel',33.333,1),(108,7424389,7424386,'pse',25,1),(108,7424390,7424386,'seu',25,1),(108,7424391,7424386,'eud',25,1),(108,7424392,7424386,'udo',25,1),(108,7424393,7424389,'fal',33.333,6),(108,7424394,7424389,'als',33.333,6),(108,7424395,7424389,'lse',33.333,6),(108,7424396,7424393,'sta',25,3),(108,7424397,7424393,'tat',25,3),(108,7424398,7424393,'atu',25,3),(108,7424399,7424393,'tus',25,3),(108,7424400,7424396,'rdm',100,1),(108,7424401,7424400,'cap',20,1),(108,7424402,7424400,'apa',20,1),(108,7424403,7424400,'pab',20,1),(108,7424404,7424400,'abl',20,1),(108,7424405,7424400,'ble',20,1),(108,7424406,7424401,'tru',50,1),(108,7424407,7424401,'rue',50,1),(108,7424408,7424406,'loc',33.333,1),(108,7424409,7424406,'oca',33.333,1),(108,7424410,7424406,'cal',33.333,1),(108,7424411,7424408,'rem',14.286,1),(108,7424412,7424408,'emo',14.286,1),(108,7424413,7424408,'mov',14.286,1),(108,7424414,7424408,'ova',14.286,1),(108,7424415,7424408,'vab',14.286,1),(108,7424416,7424408,'abl',14.286,1),(108,7424417,7424408,'ble',14.286,1),(108,7424418,7424411,'ssd',100,1),(108,7424419,7424418,'off',20,1),(108,7424420,7424418,'ffl',20,1),(108,7424421,7424418,'fli',20,1),(108,7424422,7424418,'lin',20,1),(108,7424423,7424418,'ine',20,1),(108,7424424,7424419,'per',11.111,1),(108,7424425,7424419,'ere',11.111,1),(108,7424426,7424419,'ren',11.111,1),(108,7424427,7424419,'enn',11.111,1),(108,7424428,7424419,'nni',11.111,1),(108,7424429,7424419,'nia',11.111,1),(108,7424430,7424419,'ial',11.111,1),(108,7424431,7424419,'all',11.111,1),(108,7424432,7424419,'lly',11.111,1),(108,7424433,7424424,'res',16.667,1),(108,7424434,7424424,'ese',16.667,1),(108,7424435,7424424,'ser',16.667,1),(108,7424436,7424424,'erv',16.667,1),(108,7424437,7424424,'rve',16.667,1),(108,7424438,7424424,'ved',16.667,1),(108,7424439,7424433,'thi',50,1),(108,7424440,7424433,'hin',50,1),(108,7424441,7424439,'pro',10,1),(108,7424442,7424439,'rov',10,1),(108,7424443,7424439,'ovi',10,1),(108,7424444,7424439,'vis',10,1),(108,7424445,7424439,'isi',10,1),(108,7424446,7424439,'sio',10,1),(108,7424447,7424439,'ion',10,1),(108,7424448,7424439,'oni',10,1),(108,7424449,7424439,'nin',10,1),(108,7424450,7424439,'ing',10,1),(108,7424451,7424441,'yes',100,1),(108,7424452,7424451,'att',16.667,1),(108,7424453,7424451,'tta',16.667,1),(108,7424454,7424451,'tac',16.667,1),(108,7424455,7424451,'ach',16.667,1),(108,7424456,7424451,'che',16.667,1),(108,7424457,7424451,'hed',16.667,1),(108,7424458,7424452,'fil',20,1),(108,7424459,7424452,'ilt',20,1),(108,7424460,7424452,'lte',20,1),(108,7424461,7424452,'ter',20,1),(108,7424462,7424452,'ers',20,1),(108,7424463,7424458,'vaa',50,1),(108,7424464,7424458,'aai',50,1),(108,7424465,7424463,'unk',20,1),(108,7424466,7424463,'nkn',20,1),(108,7424467,7424463,'kno',20,1),(108,7424468,7424463,'now',20,1),(108,7424469,7424463,'own',20,1),(108,7424470,7424465,'oth',33.333,1),(108,7424471,7424465,'the',33.333,1),(108,7424472,7424465,'her',33.333,1),(108,7424473,7424470,'uid',50,1),(108,7424474,7424470,'ids',50,1),(108,7424475,7424473,'vml',100,1),(108,7424476,7424475,'dis',20,1),(108,7424477,7424475,'isp',20,1),(108,7424478,7424475,'spl',20,1),(108,7424479,7424475,'pla',20,1),(108,7424480,7424475,'lay',20,1),(108,7424481,7424476,'nam',50,1),(108,7424482,7424476,'ame',50,1),(109,7424484,7424483,'net',25,3),(109,7424485,7424483,'eta',25,3),(109,7424486,7424483,'tap',25,3),(109,7424487,7424483,'app',25,3),(109,7424488,7424484,'fib',33.333,2),(109,7424489,7424484,'ibr',33.333,2),(109,7424490,7424484,'bre',33.333,2),(109,7424491,7424488,'cha',20,2),(109,7424492,7424488,'han',20,2),(109,7424493,7424488,'ann',20,2),(109,7424494,7424488,'nne',20,2),(109,7424495,7424488,'nel',20,2),(109,7424496,7424491,'dis',50,2),(109,7424497,7424491,'isk',50,2),(109,7424498,7424496,'naa',100,4),(109,7424499,7424498,'600',3.333,4),(109,7424500,7424498,'00a',3.333,4),(109,7424501,7424498,'0a0',3.333,4),(109,7424502,7424498,'a09',3.333,4),(109,7424503,7424498,'098',3.333,4),(109,7424504,7424498,'980',3.333,4),(109,7424505,7424498,'804',3.333,4),(109,7424506,7424498,'044',3.333,4),(109,7424507,7424498,'443',3.333,4),(109,7424508,7424498,'430',3.333,4),(109,7424509,7424498,'307',3.333,4),(109,7424510,7424498,'072',3.333,4),(109,7424511,7424498,'725',3.333,4),(109,7424512,7424498,'259',3.333,4),(109,7424513,7424498,'593',3.333,4),(109,7424514,7424498,'931',3.333,4),(109,7424515,7424498,'313',3.333,4),(109,7424516,7424498,'13f',3.333,4),(109,7424517,7424498,'3f3',3.333,4),(109,7424518,7424498,'f33',3.333,4),(109,7424519,7424498,'334',3.333,4),(109,7424520,7424498,'345',3.333,4),(109,7424521,7424498,'455',3.333,4),(109,7424522,7424498,'556',3.333,4),(109,7424523,7424498,'563',3.333,4),(109,7424524,7424498,'638',3.333,4),(109,7424525,7424498,'387',3.333,4),(109,7424526,7424498,'872',3.333,4),(109,7424527,7424498,'724',3.333,4),(109,7424528,7424498,'246',3.333,4),(109,7424529,7424499,'ser',25,1),(109,7424530,7424499,'eri',25,1),(109,7424531,7424499,'ria',25,1),(109,7424532,7424499,'ial',25,1),(109,7424533,7424529,'siz',50,1),(109,7424534,7424529,'ize',50,1),(109,7424535,7424533,'460',33.333,1),(109,7424536,7424533,'608',33.333,1),(109,7424537,7424533,'080',33.333,1),(109,7424538,7424535,'dev',25,1),(109,7424539,7424535,'evi',25,1),(109,7424540,7424535,'vic',25,1),(109,7424541,7424535,'ice',25,1),(109,7424542,7424538,'typ',50,1),(109,7424543,7424538,'ype',50,1),(109,7424544,7424542,'dir',10,1),(109,7424545,7424542,'ire',10,1),(109,7424546,7424542,'rec',10,1),(109,7424547,7424542,'ect',10,1),(109,7424548,7424542,'cta',10,1),(109,7424549,7424542,'tac',10,1),(109,7424550,7424542,'acc',10,1),(109,7424551,7424542,'cce',10,1),(109,7424552,7424542,'ces',10,1),(109,7424553,7424542,'ess',10,1),(109,7424554,7424544,'mul',14.286,1),(109,7424555,7424544,'ult',14.286,1),(109,7424556,7424544,'lti',14.286,1),(109,7424557,7424544,'tip',14.286,1),(109,7424558,7424544,'ipa',14.286,1),(109,7424559,7424544,'pat',14.286,1),(109,7424560,7424544,'ath',14.286,1),(109,7424561,7424554,'plu',25,1),(109,7424562,7424554,'lug',25,1),(109,7424563,7424554,'ugi',25,1),(109,7424564,7424554,'gin',25,1),(109,7424565,7424561,'nmp',100,1),(109,7424566,7424565,'dev',33.333,1),(109,7424567,7424565,'evf',33.333,1),(109,7424568,7424565,'vfs',33.333,1),(109,7424569,7424566,'pat',50,1),(109,7424570,7424566,'ath',50,1),(109,7424571,7424569,'vmf',50,1),(109,7424572,7424569,'mfs',50,1),(109,7424573,7424571,'dev',20,1),(109,7424574,7424571,'evi',20,1),(109,7424575,7424571,'vic',20,1),(109,7424576,7424571,'ice',20,1),(109,7424577,7424571,'ces',20,1),(109,7424578,7424573,'dis',33.333,1),(109,7424579,7424573,'isk',33.333,1),(109,7424580,7424573,'sks',33.333,1),(109,7424581,7424578,'ven',25,1),(109,7424582,7424578,'end',25,1),(109,7424583,7424578,'ndo',25,1),(109,7424584,7424578,'dor',25,1),(109,7424585,7424581,'mod',33.333,1),(109,7424586,7424581,'ode',33.333,1),(109,7424587,7424581,'del',33.333,1),(109,7424588,7424585,'lun',100,1),(109,7424589,7424588,'cmo',33.333,1),(109,7424590,7424588,'mod',33.333,1),(109,7424591,7424588,'ode',33.333,1),(109,7424592,7424589,'rev',16.667,1),(109,7424593,7424589,'evi',16.667,1),(109,7424594,7424589,'vis',16.667,1),(109,7424595,7424589,'isi',16.667,1),(109,7424596,7424589,'sio',16.667,1),(109,7424597,7424589,'ion',16.667,1),(109,7424598,7424592,'810',50,1),(109,7424599,7424592,'100',50,1),(109,7424600,7424598,'scs',50,1),(109,7424601,7424598,'csi',50,1),(109,7424602,7424600,'lev',33.333,1),(109,7424603,7424600,'eve',33.333,1),(109,7424604,7424600,'vel',33.333,1),(109,7424605,7424602,'pse',25,1),(109,7424606,7424602,'seu',25,1),(109,7424607,7424602,'eud',25,1),(109,7424608,7424602,'udo',25,1),(109,7424609,7424605,'fal',33.333,6),(109,7424610,7424605,'als',33.333,6),(109,7424611,7424605,'lse',33.333,6),(109,7424612,7424609,'sta',25,3),(109,7424613,7424609,'tat',25,3),(109,7424614,7424609,'atu',25,3),(109,7424615,7424609,'tus',25,3),(109,7424616,7424612,'rdm',100,1),(109,7424617,7424616,'cap',20,1),(109,7424618,7424616,'apa',20,1),(109,7424619,7424616,'pab',20,1),(109,7424620,7424616,'abl',20,1),(109,7424621,7424616,'ble',20,1),(109,7424622,7424617,'tru',50,1),(109,7424623,7424617,'rue',50,1),(109,7424624,7424622,'loc',33.333,1),(109,7424625,7424622,'oca',33.333,1),(109,7424626,7424622,'cal',33.333,1),(109,7424627,7424624,'rem',14.286,1),(109,7424628,7424624,'emo',14.286,1),(109,7424629,7424624,'mov',14.286,1),(109,7424630,7424624,'ova',14.286,1),(109,7424631,7424624,'vab',14.286,1),(109,7424632,7424624,'abl',14.286,1),(109,7424633,7424624,'ble',14.286,1),(109,7424634,7424627,'ssd',100,1),(109,7424635,7424634,'off',20,1),(109,7424636,7424634,'ffl',20,1),(109,7424637,7424634,'fli',20,1),(109,7424638,7424634,'lin',20,1),(109,7424639,7424634,'ine',20,1),(109,7424640,7424635,'per',11.111,1),(109,7424641,7424635,'ere',11.111,1),(109,7424642,7424635,'ren',11.111,1),(109,7424643,7424635,'enn',11.111,1),(109,7424644,7424635,'nni',11.111,1),(109,7424645,7424635,'nia',11.111,1),(109,7424646,7424635,'ial',11.111,1),(109,7424647,7424635,'all',11.111,1),(109,7424648,7424635,'lly',11.111,1),(109,7424649,7424640,'res',16.667,1),(109,7424650,7424640,'ese',16.667,1),(109,7424651,7424640,'ser',16.667,1),(109,7424652,7424640,'erv',16.667,1),(109,7424653,7424640,'rve',16.667,1),(109,7424654,7424640,'ved',16.667,1),(109,7424655,7424649,'thi',50,1),(109,7424656,7424649,'hin',50,1),(109,7424657,7424655,'pro',10,1),(109,7424658,7424655,'rov',10,1),(109,7424659,7424655,'ovi',10,1),(109,7424660,7424655,'vis',10,1),(109,7424661,7424655,'isi',10,1),(109,7424662,7424655,'sio',10,1),(109,7424663,7424655,'ion',10,1),(109,7424664,7424655,'oni',10,1),(109,7424665,7424655,'nin',10,1),(109,7424666,7424655,'ing',10,1),(109,7424667,7424657,'yes',100,1),(109,7424668,7424667,'att',16.667,1),(109,7424669,7424667,'tta',16.667,1),(109,7424670,7424667,'tac',16.667,1),(109,7424671,7424667,'ach',16.667,1),(109,7424672,7424667,'che',16.667,1),(109,7424673,7424667,'hed',16.667,1),(109,7424674,7424668,'fil',20,1),(109,7424675,7424668,'ilt',20,1),(109,7424676,7424668,'lte',20,1),(109,7424677,7424668,'ter',20,1),(109,7424678,7424668,'ers',20,1),(109,7424679,7424674,'vaa',50,1),(109,7424680,7424674,'aai',50,1),(109,7424681,7424679,'unk',20,1),(109,7424682,7424679,'nkn',20,1),(109,7424683,7424679,'kno',20,1),(109,7424684,7424679,'now',20,1),(109,7424685,7424679,'own',20,1),(109,7424686,7424681,'oth',33.333,1),(109,7424687,7424681,'the',33.333,1),(109,7424688,7424681,'her',33.333,1),(109,7424689,7424686,'uid',50,1),(109,7424690,7424686,'ids',50,1),(109,7424691,7424689,'vml',100,1),(109,7424692,7424691,'dis',20,1),(109,7424693,7424691,'isp',20,1),(109,7424694,7424691,'spl',20,1),(109,7424695,7424691,'pla',20,1),(109,7424696,7424691,'lay',20,1),(109,7424697,7424692,'nam',50,1),(109,7424698,7424692,'ame',50,1),(110,7424700,7424699,'net',25,3),(110,7424701,7424699,'eta',25,3),(110,7424702,7424699,'tap',25,3),(110,7424703,7424699,'app',25,3),(110,7424704,7424700,'fib',33.333,2),(110,7424705,7424700,'ibr',33.333,2),(110,7424706,7424700,'bre',33.333,2),(110,7424707,7424704,'cha',20,2),(110,7424708,7424704,'han',20,2),(110,7424709,7424704,'ann',20,2),(110,7424710,7424704,'nne',20,2),(110,7424711,7424704,'nel',20,2),(110,7424712,7424707,'dis',50,2),(110,7424713,7424707,'isk',50,2),(110,7424714,7424712,'naa',100,4),(110,7424715,7424714,'600',3.333,4),(110,7424716,7424714,'00a',3.333,4),(110,7424717,7424714,'0a0',3.333,4),(110,7424718,7424714,'a09',3.333,4),(110,7424719,7424714,'098',3.333,4),(110,7424720,7424714,'980',3.333,4),(110,7424721,7424714,'804',3.333,4),(110,7424722,7424714,'044',3.333,4),(110,7424723,7424714,'443',3.333,4),(110,7424724,7424714,'430',3.333,4),(110,7424725,7424714,'307',3.333,4),(110,7424726,7424714,'072',3.333,4),(110,7424727,7424714,'725',3.333,4),(110,7424728,7424714,'259',3.333,4),(110,7424729,7424714,'593',3.333,4),(110,7424730,7424714,'931',3.333,4),(110,7424731,7424714,'313',3.333,4),(110,7424732,7424714,'13f',3.333,4),(110,7424733,7424714,'3f3',3.333,4),(110,7424734,7424714,'f33',3.333,4),(110,7424735,7424714,'334',3.333,4),(110,7424736,7424714,'345',3.333,4),(110,7424737,7424714,'455',3.333,4),(110,7424738,7424714,'556',3.333,4),(110,7424739,7424714,'563',3.333,4),(110,7424740,7424714,'638',3.333,4),(110,7424741,7424714,'387',3.333,4),(110,7424742,7424714,'872',3.333,4),(110,7424743,7424714,'724',3.333,4),(110,7424744,7424714,'247',3.333,4),(110,7424745,7424715,'ser',25,1),(110,7424746,7424715,'eri',25,1),(110,7424747,7424715,'ria',25,1),(110,7424748,7424715,'ial',25,1),(110,7424749,7424745,'siz',50,1),(110,7424750,7424745,'ize',50,1),(110,7424751,7424749,'460',33.333,1),(110,7424752,7424749,'608',33.333,1),(110,7424753,7424749,'080',33.333,1),(110,7424754,7424751,'dev',25,1),(110,7424755,7424751,'evi',25,1),(110,7424756,7424751,'vic',25,1),(110,7424757,7424751,'ice',25,1),(110,7424758,7424754,'typ',50,1),(110,7424759,7424754,'ype',50,1),(110,7424760,7424758,'dir',10,1),(110,7424761,7424758,'ire',10,1),(110,7424762,7424758,'rec',10,1),(110,7424763,7424758,'ect',10,1),(110,7424764,7424758,'cta',10,1),(110,7424765,7424758,'tac',10,1),(110,7424766,7424758,'acc',10,1),(110,7424767,7424758,'cce',10,1),(110,7424768,7424758,'ces',10,1),(110,7424769,7424758,'ess',10,1),(110,7424770,7424760,'mul',14.286,1),(110,7424771,7424760,'ult',14.286,1),(110,7424772,7424760,'lti',14.286,1),(110,7424773,7424760,'tip',14.286,1),(110,7424774,7424760,'ipa',14.286,1),(110,7424775,7424760,'pat',14.286,1),(110,7424776,7424760,'ath',14.286,1),(110,7424777,7424770,'plu',25,1),(110,7424778,7424770,'lug',25,1),(110,7424779,7424770,'ugi',25,1),(110,7424780,7424770,'gin',25,1),(110,7424781,7424777,'nmp',100,1),(110,7424782,7424781,'dev',33.333,1),(110,7424783,7424781,'evf',33.333,1),(110,7424784,7424781,'vfs',33.333,1),(110,7424785,7424782,'pat',50,1),(110,7424786,7424782,'ath',50,1),(110,7424787,7424785,'vmf',50,1),(110,7424788,7424785,'mfs',50,1),(110,7424789,7424787,'dev',20,1),(110,7424790,7424787,'evi',20,1),(110,7424791,7424787,'vic',20,1),(110,7424792,7424787,'ice',20,1),(110,7424793,7424787,'ces',20,1),(110,7424794,7424789,'dis',33.333,1),(110,7424795,7424789,'isk',33.333,1),(110,7424796,7424789,'sks',33.333,1),(110,7424797,7424794,'ven',25,1),(110,7424798,7424794,'end',25,1),(110,7424799,7424794,'ndo',25,1),(110,7424800,7424794,'dor',25,1),(110,7424801,7424797,'mod',33.333,1),(110,7424802,7424797,'ode',33.333,1),(110,7424803,7424797,'del',33.333,1),(110,7424804,7424801,'lun',100,1),(110,7424805,7424804,'cmo',33.333,1),(110,7424806,7424804,'mod',33.333,1),(110,7424807,7424804,'ode',33.333,1),(110,7424808,7424805,'rev',16.667,1),(110,7424809,7424805,'evi',16.667,1),(110,7424810,7424805,'vis',16.667,1),(110,7424811,7424805,'isi',16.667,1),(110,7424812,7424805,'sio',16.667,1),(110,7424813,7424805,'ion',16.667,1),(110,7424814,7424808,'810',50,1),(110,7424815,7424808,'100',50,1),(110,7424816,7424814,'scs',50,1),(110,7424817,7424814,'csi',50,1),(110,7424818,7424816,'lev',33.333,1),(110,7424819,7424816,'eve',33.333,1),(110,7424820,7424816,'vel',33.333,1),(110,7424821,7424818,'pse',25,1),(110,7424822,7424818,'seu',25,1),(110,7424823,7424818,'eud',25,1),(110,7424824,7424818,'udo',25,1),(110,7424825,7424821,'fal',33.333,6),(110,7424826,7424821,'als',33.333,6),(110,7424827,7424821,'lse',33.333,6),(110,7424828,7424825,'sta',25,3),(110,7424829,7424825,'tat',25,3),(110,7424830,7424825,'atu',25,3),(110,7424831,7424825,'tus',25,3),(110,7424832,7424828,'rdm',100,1),(110,7424833,7424832,'cap',20,1),(110,7424834,7424832,'apa',20,1),(110,7424835,7424832,'pab',20,1),(110,7424836,7424832,'abl',20,1),(110,7424837,7424832,'ble',20,1),(110,7424838,7424833,'tru',50,1),(110,7424839,7424833,'rue',50,1),(110,7424840,7424838,'loc',33.333,1),(110,7424841,7424838,'oca',33.333,1),(110,7424842,7424838,'cal',33.333,1),(110,7424843,7424840,'rem',14.286,1),(110,7424844,7424840,'emo',14.286,1),(110,7424845,7424840,'mov',14.286,1),(110,7424846,7424840,'ova',14.286,1),(110,7424847,7424840,'vab',14.286,1),(110,7424848,7424840,'abl',14.286,1),(110,7424849,7424840,'ble',14.286,1),(110,7424850,7424843,'ssd',100,1),(110,7424851,7424850,'off',20,1),(110,7424852,7424850,'ffl',20,1),(110,7424853,7424850,'fli',20,1),(110,7424854,7424850,'lin',20,1),(110,7424855,7424850,'ine',20,1),(110,7424856,7424851,'per',11.111,1),(110,7424857,7424851,'ere',11.111,1),(110,7424858,7424851,'ren',11.111,1),(110,7424859,7424851,'enn',11.111,1),(110,7424860,7424851,'nni',11.111,1),(110,7424861,7424851,'nia',11.111,1),(110,7424862,7424851,'ial',11.111,1),(110,7424863,7424851,'all',11.111,1),(110,7424864,7424851,'lly',11.111,1),(110,7424865,7424856,'res',16.667,1),(110,7424866,7424856,'ese',16.667,1),(110,7424867,7424856,'ser',16.667,1),(110,7424868,7424856,'erv',16.667,1),(110,7424869,7424856,'rve',16.667,1),(110,7424870,7424856,'ved',16.667,1),(110,7424871,7424865,'thi',50,1),(110,7424872,7424865,'hin',50,1),(110,7424873,7424871,'pro',10,1),(110,7424874,7424871,'rov',10,1),(110,7424875,7424871,'ovi',10,1),(110,7424876,7424871,'vis',10,1),(110,7424877,7424871,'isi',10,1),(110,7424878,7424871,'sio',10,1),(110,7424879,7424871,'ion',10,1),(110,7424880,7424871,'oni',10,1),(110,7424881,7424871,'nin',10,1),(110,7424882,7424871,'ing',10,1),(110,7424883,7424873,'yes',100,1),(110,7424884,7424883,'att',16.667,1),(110,7424885,7424883,'tta',16.667,1),(110,7424886,7424883,'tac',16.667,1),(110,7424887,7424883,'ach',16.667,1),(110,7424888,7424883,'che',16.667,1),(110,7424889,7424883,'hed',16.667,1),(110,7424890,7424884,'fil',20,1),(110,7424891,7424884,'ilt',20,1),(110,7424892,7424884,'lte',20,1),(110,7424893,7424884,'ter',20,1),(110,7424894,7424884,'ers',20,1),(110,7424895,7424890,'vaa',50,1),(110,7424896,7424890,'aai',50,1),(110,7424897,7424895,'unk',20,1),(110,7424898,7424895,'nkn',20,1),(110,7424899,7424895,'kno',20,1),(110,7424900,7424895,'now',20,1),(110,7424901,7424895,'own',20,1),(110,7424902,7424897,'oth',33.333,1),(110,7424903,7424897,'the',33.333,1),(110,7424904,7424897,'her',33.333,1),(110,7424905,7424902,'uid',50,1),(110,7424906,7424902,'ids',50,1),(110,7424907,7424905,'vml',100,1),(110,7424908,7424907,'dis',20,1),(110,7424909,7424907,'isp',20,1),(110,7424910,7424907,'spl',20,1),(110,7424911,7424907,'pla',20,1),(110,7424912,7424907,'lay',20,1),(110,7424913,7424908,'nam',50,1),(110,7424914,7424908,'ame',50,1),(111,7424916,7424915,'net',25,3),(111,7424917,7424915,'eta',25,3),(111,7424918,7424915,'tap',25,3),(111,7424919,7424915,'app',25,3),(111,7424920,7424916,'fib',33.333,2),(111,7424921,7424916,'ibr',33.333,2),(111,7424922,7424916,'bre',33.333,2),(111,7424923,7424920,'cha',20,2),(111,7424924,7424920,'han',20,2),(111,7424925,7424920,'ann',20,2),(111,7424926,7424920,'nne',20,2),(111,7424927,7424920,'nel',20,2),(111,7424928,7424923,'dis',50,2),(111,7424929,7424923,'isk',50,2),(111,7424930,7424928,'naa',100,4),(111,7424931,7424930,'600',3.333,4),(111,7424932,7424930,'00a',3.333,4),(111,7424933,7424930,'0a0',3.333,4),(111,7424934,7424930,'a09',3.333,4),(111,7424935,7424930,'098',3.333,4),(111,7424936,7424930,'980',3.333,4),(111,7424937,7424930,'804',3.333,4),(111,7424938,7424930,'044',3.333,4),(111,7424939,7424930,'443',3.333,4),(111,7424940,7424930,'430',3.333,4),(111,7424941,7424930,'307',3.333,4),(111,7424942,7424930,'072',3.333,4),(111,7424943,7424930,'725',3.333,4),(111,7424944,7424930,'259',3.333,4),(111,7424945,7424930,'593',3.333,4),(111,7424946,7424930,'931',3.333,4),(111,7424947,7424930,'313',3.333,4),(111,7424948,7424930,'13f',3.333,4),(111,7424949,7424930,'3f3',3.333,4),(111,7424950,7424930,'f33',3.333,4),(111,7424951,7424930,'334',3.333,4),(111,7424952,7424930,'345',3.333,4),(111,7424953,7424930,'455',3.333,4),(111,7424954,7424930,'556',3.333,4),(111,7424955,7424930,'563',3.333,4),(111,7424956,7424930,'638',3.333,4),(111,7424957,7424930,'387',3.333,4),(111,7424958,7424930,'872',3.333,4),(111,7424959,7424930,'724',3.333,4),(111,7424960,7424930,'248',3.333,4),(111,7424961,7424931,'ser',25,1),(111,7424962,7424931,'eri',25,1),(111,7424963,7424931,'ria',25,1),(111,7424964,7424931,'ial',25,1),(111,7424965,7424961,'siz',50,1),(111,7424966,7424961,'ize',50,1),(111,7424967,7424965,'460',33.333,1),(111,7424968,7424965,'608',33.333,1),(111,7424969,7424965,'080',33.333,1),(111,7424970,7424967,'dev',25,1),(111,7424971,7424967,'evi',25,1),(111,7424972,7424967,'vic',25,1),(111,7424973,7424967,'ice',25,1),(111,7424974,7424970,'typ',50,1),(111,7424975,7424970,'ype',50,1),(111,7424976,7424974,'dir',10,1),(111,7424977,7424974,'ire',10,1),(111,7424978,7424974,'rec',10,1),(111,7424979,7424974,'ect',10,1),(111,7424980,7424974,'cta',10,1),(111,7424981,7424974,'tac',10,1),(111,7424982,7424974,'acc',10,1),(111,7424983,7424974,'cce',10,1),(111,7424984,7424974,'ces',10,1),(111,7424985,7424974,'ess',10,1),(111,7424986,7424976,'mul',14.286,1),(111,7424987,7424976,'ult',14.286,1),(111,7424988,7424976,'lti',14.286,1),(111,7424989,7424976,'tip',14.286,1),(111,7424990,7424976,'ipa',14.286,1),(111,7424991,7424976,'pat',14.286,1),(111,7424992,7424976,'ath',14.286,1),(111,7424993,7424986,'plu',25,1),(111,7424994,7424986,'lug',25,1),(111,7424995,7424986,'ugi',25,1),(111,7424996,7424986,'gin',25,1),(111,7424997,7424993,'nmp',100,1),(111,7424998,7424997,'dev',33.333,1),(111,7424999,7424997,'evf',33.333,1),(111,7425000,7424997,'vfs',33.333,1),(111,7425001,7424998,'pat',50,1),(111,7425002,7424998,'ath',50,1),(111,7425003,7425001,'vmf',50,1),(111,7425004,7425001,'mfs',50,1),(111,7425005,7425003,'dev',20,1),(111,7425006,7425003,'evi',20,1),(111,7425007,7425003,'vic',20,1),(111,7425008,7425003,'ice',20,1),(111,7425009,7425003,'ces',20,1),(111,7425010,7425005,'dis',33.333,1),(111,7425011,7425005,'isk',33.333,1),(111,7425012,7425005,'sks',33.333,1),(111,7425013,7425010,'ven',25,1),(111,7425014,7425010,'end',25,1),(111,7425015,7425010,'ndo',25,1),(111,7425016,7425010,'dor',25,1),(111,7425017,7425013,'mod',33.333,1),(111,7425018,7425013,'ode',33.333,1),(111,7425019,7425013,'del',33.333,1),(111,7425020,7425017,'lun',100,1),(111,7425021,7425020,'cmo',33.333,1),(111,7425022,7425020,'mod',33.333,1),(111,7425023,7425020,'ode',33.333,1),(111,7425024,7425021,'rev',16.667,1),(111,7425025,7425021,'evi',16.667,1),(111,7425026,7425021,'vis',16.667,1),(111,7425027,7425021,'isi',16.667,1),(111,7425028,7425021,'sio',16.667,1),(111,7425029,7425021,'ion',16.667,1),(111,7425030,7425024,'810',50,1),(111,7425031,7425024,'100',50,1),(111,7425032,7425030,'scs',50,1),(111,7425033,7425030,'csi',50,1),(111,7425034,7425032,'lev',33.333,1),(111,7425035,7425032,'eve',33.333,1),(111,7425036,7425032,'vel',33.333,1),(111,7425037,7425034,'pse',25,1),(111,7425038,7425034,'seu',25,1),(111,7425039,7425034,'eud',25,1),(111,7425040,7425034,'udo',25,1),(111,7425041,7425037,'fal',33.333,6),(111,7425042,7425037,'als',33.333,6),(111,7425043,7425037,'lse',33.333,6),(111,7425044,7425041,'sta',25,3),(111,7425045,7425041,'tat',25,3),(111,7425046,7425041,'atu',25,3),(111,7425047,7425041,'tus',25,3),(111,7425048,7425044,'rdm',100,1),(111,7425049,7425048,'cap',20,1),(111,7425050,7425048,'apa',20,1),(111,7425051,7425048,'pab',20,1),(111,7425052,7425048,'abl',20,1),(111,7425053,7425048,'ble',20,1),(111,7425054,7425049,'tru',50,1),(111,7425055,7425049,'rue',50,1),(111,7425056,7425054,'loc',33.333,1),(111,7425057,7425054,'oca',33.333,1),(111,7425058,7425054,'cal',33.333,1),(111,7425059,7425056,'rem',14.286,1),(111,7425060,7425056,'emo',14.286,1),(111,7425061,7425056,'mov',14.286,1),(111,7425062,7425056,'ova',14.286,1),(111,7425063,7425056,'vab',14.286,1),(111,7425064,7425056,'abl',14.286,1),(111,7425065,7425056,'ble',14.286,1),(111,7425066,7425059,'ssd',100,1),(111,7425067,7425066,'off',20,1),(111,7425068,7425066,'ffl',20,1),(111,7425069,7425066,'fli',20,1),(111,7425070,7425066,'lin',20,1),(111,7425071,7425066,'ine',20,1),(111,7425072,7425067,'per',11.111,1),(111,7425073,7425067,'ere',11.111,1),(111,7425074,7425067,'ren',11.111,1),(111,7425075,7425067,'enn',11.111,1),(111,7425076,7425067,'nni',11.111,1),(111,7425077,7425067,'nia',11.111,1),(111,7425078,7425067,'ial',11.111,1),(111,7425079,7425067,'all',11.111,1),(111,7425080,7425067,'lly',11.111,1),(111,7425081,7425072,'res',16.667,1),(111,7425082,7425072,'ese',16.667,1),(111,7425083,7425072,'ser',16.667,1),(111,7425084,7425072,'erv',16.667,1),(111,7425085,7425072,'rve',16.667,1),(111,7425086,7425072,'ved',16.667,1),(111,7425087,7425081,'thi',50,1),(111,7425088,7425081,'hin',50,1),(111,7425089,7425087,'pro',10,1),(111,7425090,7425087,'rov',10,1),(111,7425091,7425087,'ovi',10,1),(111,7425092,7425087,'vis',10,1),(111,7425093,7425087,'isi',10,1),(111,7425094,7425087,'sio',10,1),(111,7425095,7425087,'ion',10,1),(111,7425096,7425087,'oni',10,1),(111,7425097,7425087,'nin',10,1),(111,7425098,7425087,'ing',10,1),(111,7425099,7425089,'yes',100,1),(111,7425100,7425099,'att',16.667,1),(111,7425101,7425099,'tta',16.667,1),(111,7425102,7425099,'tac',16.667,1),(111,7425103,7425099,'ach',16.667,1),(111,7425104,7425099,'che',16.667,1),(111,7425105,7425099,'hed',16.667,1),(111,7425106,7425100,'fil',20,1),(111,7425107,7425100,'ilt',20,1),(111,7425108,7425100,'lte',20,1),(111,7425109,7425100,'ter',20,1),(111,7425110,7425100,'ers',20,1),(111,7425111,7425106,'vaa',50,1),(111,7425112,7425106,'aai',50,1),(111,7425113,7425111,'unk',20,1),(111,7425114,7425111,'nkn',20,1),(111,7425115,7425111,'kno',20,1),(111,7425116,7425111,'now',20,1),(111,7425117,7425111,'own',20,1),(111,7425118,7425113,'oth',33.333,1),(111,7425119,7425113,'the',33.333,1),(111,7425120,7425113,'her',33.333,1),(111,7425121,7425118,'uid',50,1),(111,7425122,7425118,'ids',50,1),(111,7425123,7425121,'vml',100,1),(111,7425124,7425123,'dis',20,1),(111,7425125,7425123,'isp',20,1),(111,7425126,7425123,'spl',20,1),(111,7425127,7425123,'pla',20,1),(111,7425128,7425123,'lay',20,1),(111,7425129,7425124,'nam',50,1),(111,7425130,7425124,'ame',50,1),(112,7425132,7425131,'net',25,3),(112,7425133,7425131,'eta',25,3),(112,7425134,7425131,'tap',25,3),(112,7425135,7425131,'app',25,3),(112,7425136,7425132,'fib',33.333,2),(112,7425137,7425132,'ibr',33.333,2),(112,7425138,7425132,'bre',33.333,2),(112,7425139,7425136,'cha',20,2),(112,7425140,7425136,'han',20,2),(112,7425141,7425136,'ann',20,2),(112,7425142,7425136,'nne',20,2),(112,7425143,7425136,'nel',20,2),(112,7425144,7425139,'dis',50,2),(112,7425145,7425139,'isk',50,2),(112,7425146,7425144,'naa',100,4),(112,7425147,7425146,'600',3.333,4),(112,7425148,7425146,'00a',3.333,4),(112,7425149,7425146,'0a0',3.333,4),(112,7425150,7425146,'a09',3.333,4),(112,7425151,7425146,'098',3.333,4),(112,7425152,7425146,'980',3.333,4),(112,7425153,7425146,'804',3.333,4),(112,7425154,7425146,'044',3.333,4),(112,7425155,7425146,'443',3.333,4),(112,7425156,7425146,'430',3.333,4),(112,7425157,7425146,'307',3.333,4),(112,7425158,7425146,'072',3.333,4),(112,7425159,7425146,'725',3.333,4),(112,7425160,7425146,'259',3.333,4),(112,7425161,7425146,'593',3.333,4),(112,7425162,7425146,'931',3.333,4),(112,7425163,7425146,'313',3.333,4),(112,7425164,7425146,'13f',3.333,4),(112,7425165,7425146,'3f3',3.333,4),(112,7425166,7425146,'f33',3.333,4),(112,7425167,7425146,'334',3.333,4),(112,7425168,7425146,'345',3.333,4),(112,7425169,7425146,'455',3.333,4),(112,7425170,7425146,'556',3.333,4),(112,7425171,7425146,'563',3.333,4),(112,7425172,7425146,'638',3.333,4),(112,7425173,7425146,'387',3.333,4),(112,7425174,7425146,'872',3.333,4),(112,7425175,7425146,'724',3.333,4),(112,7425176,7425146,'249',3.333,4),(112,7425177,7425147,'ser',25,1),(112,7425178,7425147,'eri',25,1),(112,7425179,7425147,'ria',25,1),(112,7425180,7425147,'ial',25,1),(112,7425181,7425177,'siz',50,1),(112,7425182,7425177,'ize',50,1),(112,7425183,7425181,'460',33.333,1),(112,7425184,7425181,'608',33.333,1),(112,7425185,7425181,'080',33.333,1),(112,7425186,7425183,'dev',25,1),(112,7425187,7425183,'evi',25,1),(112,7425188,7425183,'vic',25,1),(112,7425189,7425183,'ice',25,1),(112,7425190,7425186,'typ',50,1),(112,7425191,7425186,'ype',50,1),(112,7425192,7425190,'dir',10,1),(112,7425193,7425190,'ire',10,1),(112,7425194,7425190,'rec',10,1),(112,7425195,7425190,'ect',10,1),(112,7425196,7425190,'cta',10,1),(112,7425197,7425190,'tac',10,1),(112,7425198,7425190,'acc',10,1),(112,7425199,7425190,'cce',10,1),(112,7425200,7425190,'ces',10,1),(112,7425201,7425190,'ess',10,1),(112,7425202,7425192,'mul',14.286,1),(112,7425203,7425192,'ult',14.286,1),(112,7425204,7425192,'lti',14.286,1),(112,7425205,7425192,'tip',14.286,1),(112,7425206,7425192,'ipa',14.286,1),(112,7425207,7425192,'pat',14.286,1),(112,7425208,7425192,'ath',14.286,1),(112,7425209,7425202,'plu',25,1),(112,7425210,7425202,'lug',25,1),(112,7425211,7425202,'ugi',25,1),(112,7425212,7425202,'gin',25,1),(112,7425213,7425209,'nmp',100,1),(112,7425214,7425213,'dev',33.333,1),(112,7425215,7425213,'evf',33.333,1),(112,7425216,7425213,'vfs',33.333,1),(112,7425217,7425214,'pat',50,1),(112,7425218,7425214,'ath',50,1),(112,7425219,7425217,'vmf',50,1),(112,7425220,7425217,'mfs',50,1),(112,7425221,7425219,'dev',20,1),(112,7425222,7425219,'evi',20,1),(112,7425223,7425219,'vic',20,1),(112,7425224,7425219,'ice',20,1),(112,7425225,7425219,'ces',20,1),(112,7425226,7425221,'dis',33.333,1),(112,7425227,7425221,'isk',33.333,1),(112,7425228,7425221,'sks',33.333,1),(112,7425229,7425226,'ven',25,1),(112,7425230,7425226,'end',25,1),(112,7425231,7425226,'ndo',25,1),(112,7425232,7425226,'dor',25,1),(112,7425233,7425229,'mod',33.333,1),(112,7425234,7425229,'ode',33.333,1),(112,7425235,7425229,'del',33.333,1),(112,7425236,7425233,'lun',100,1),(112,7425237,7425236,'cmo',33.333,1),(112,7425238,7425236,'mod',33.333,1),(112,7425239,7425236,'ode',33.333,1),(112,7425240,7425237,'rev',16.667,1),(112,7425241,7425237,'evi',16.667,1),(112,7425242,7425237,'vis',16.667,1),(112,7425243,7425237,'isi',16.667,1),(112,7425244,7425237,'sio',16.667,1),(112,7425245,7425237,'ion',16.667,1),(112,7425246,7425240,'810',50,1),(112,7425247,7425240,'100',50,1),(112,7425248,7425246,'scs',50,1),(112,7425249,7425246,'csi',50,1),(112,7425250,7425248,'lev',33.333,1),(112,7425251,7425248,'eve',33.333,1),(112,7425252,7425248,'vel',33.333,1),(112,7425253,7425250,'pse',25,1),(112,7425254,7425250,'seu',25,1),(112,7425255,7425250,'eud',25,1),(112,7425256,7425250,'udo',25,1),(112,7425257,7425253,'fal',33.333,6),(112,7425258,7425253,'als',33.333,6),(112,7425259,7425253,'lse',33.333,6),(112,7425260,7425257,'sta',25,3),(112,7425261,7425257,'tat',25,3),(112,7425262,7425257,'atu',25,3),(112,7425263,7425257,'tus',25,3),(112,7425264,7425260,'rdm',100,1),(112,7425265,7425264,'cap',20,1),(112,7425266,7425264,'apa',20,1),(112,7425267,7425264,'pab',20,1),(112,7425268,7425264,'abl',20,1),(112,7425269,7425264,'ble',20,1),(112,7425270,7425265,'tru',50,1),(112,7425271,7425265,'rue',50,1),(112,7425272,7425270,'loc',33.333,1),(112,7425273,7425270,'oca',33.333,1),(112,7425274,7425270,'cal',33.333,1),(112,7425275,7425272,'rem',14.286,1),(112,7425276,7425272,'emo',14.286,1),(112,7425277,7425272,'mov',14.286,1),(112,7425278,7425272,'ova',14.286,1),(112,7425279,7425272,'vab',14.286,1),(112,7425280,7425272,'abl',14.286,1),(112,7425281,7425272,'ble',14.286,1),(112,7425282,7425275,'ssd',100,1),(112,7425283,7425282,'off',20,1),(112,7425284,7425282,'ffl',20,1),(112,7425285,7425282,'fli',20,1),(112,7425286,7425282,'lin',20,1),(112,7425287,7425282,'ine',20,1),(112,7425288,7425283,'per',11.111,1),(112,7425289,7425283,'ere',11.111,1),(112,7425290,7425283,'ren',11.111,1),(112,7425291,7425283,'enn',11.111,1),(112,7425292,7425283,'nni',11.111,1),(112,7425293,7425283,'nia',11.111,1),(112,7425294,7425283,'ial',11.111,1),(112,7425295,7425283,'all',11.111,1),(112,7425296,7425283,'lly',11.111,1),(112,7425297,7425288,'res',16.667,1),(112,7425298,7425288,'ese',16.667,1),(112,7425299,7425288,'ser',16.667,1),(112,7425300,7425288,'erv',16.667,1),(112,7425301,7425288,'rve',16.667,1),(112,7425302,7425288,'ved',16.667,1),(112,7425303,7425297,'thi',50,1),(112,7425304,7425297,'hin',50,1),(112,7425305,7425303,'pro',10,1),(112,7425306,7425303,'rov',10,1),(112,7425307,7425303,'ovi',10,1),(112,7425308,7425303,'vis',10,1),(112,7425309,7425303,'isi',10,1),(112,7425310,7425303,'sio',10,1),(112,7425311,7425303,'ion',10,1),(112,7425312,7425303,'oni',10,1),(112,7425313,7425303,'nin',10,1),(112,7425314,7425303,'ing',10,1),(112,7425315,7425305,'yes',100,1),(112,7425316,7425315,'att',16.667,1),(112,7425317,7425315,'tta',16.667,1),(112,7425318,7425315,'tac',16.667,1),(112,7425319,7425315,'ach',16.667,1),(112,7425320,7425315,'che',16.667,1),(112,7425321,7425315,'hed',16.667,1),(112,7425322,7425316,'fil',20,1),(112,7425323,7425316,'ilt',20,1),(112,7425324,7425316,'lte',20,1),(112,7425325,7425316,'ter',20,1),(112,7425326,7425316,'ers',20,1),(112,7425327,7425322,'vaa',50,1),(112,7425328,7425322,'aai',50,1),(112,7425329,7425327,'unk',20,1),(112,7425330,7425327,'nkn',20,1),(112,7425331,7425327,'kno',20,1),(112,7425332,7425327,'now',20,1),(112,7425333,7425327,'own',20,1),(112,7425334,7425329,'oth',33.333,1),(112,7425335,7425329,'the',33.333,1),(112,7425336,7425329,'her',33.333,1),(112,7425337,7425334,'uid',50,1),(112,7425338,7425334,'ids',50,1),(112,7425339,7425337,'vml',100,1),(112,7425340,7425339,'dis',20,1),(112,7425341,7425339,'isp',20,1),(112,7425342,7425339,'spl',20,1),(112,7425343,7425339,'pla',20,1),(112,7425344,7425339,'lay',20,1),(112,7425345,7425340,'nam',50,1),(112,7425346,7425340,'ame',50,1),(113,7425348,7425347,'net',25,3),(113,7425349,7425347,'eta',25,3),(113,7425350,7425347,'tap',25,3),(113,7425351,7425347,'app',25,3),(113,7425352,7425348,'ser',25,3),(113,7425353,7425348,'eri',25,3),(113,7425354,7425348,'ria',25,3),(113,7425355,7425348,'ial',25,3),(113,7425356,7425352,'att',16.667,3),(113,7425357,7425352,'tta',16.667,3),(113,7425358,7425352,'tac',16.667,3),(113,7425359,7425352,'ach',16.667,3),(113,7425360,7425352,'che',16.667,3),(113,7425361,7425352,'hed',16.667,3),(113,7425362,7425356,'scs',50,3),(113,7425363,7425356,'csi',50,3),(113,7425364,7425362,'dis',50,2),(113,7425365,7425362,'isk',50,2),(113,7425366,7425364,'naa',100,4),(113,7425367,7425366,'600',3.333,4),(113,7425368,7425366,'00a',3.333,4),(113,7425369,7425366,'0a0',3.333,4),(113,7425370,7425366,'a09',3.333,4),(113,7425371,7425366,'098',3.333,4),(113,7425372,7425366,'980',3.333,4),(113,7425373,7425366,'804',3.333,4),(113,7425374,7425366,'043',3.333,4),(113,7425375,7425366,'434',3.333,4),(113,7425376,7425366,'34e',3.333,4),(113,7425377,7425366,'4e8',3.333,4),(113,7425378,7425366,'e84',3.333,4),(113,7425379,7425366,'84e',3.333,4),(113,7425380,7425366,'4ee',3.333,4),(113,7425381,7425366,'ee1',3.333,4),(113,7425382,7425366,'e1b',3.333,4),(113,7425383,7425366,'1b7',3.333,4),(113,7425384,7425366,'b73',3.333,4),(113,7425385,7425366,'734',3.333,4),(113,7425386,7425366,'348',3.333,4),(113,7425387,7425366,'481',3.333,4),(113,7425388,7425366,'811',3.333,4),(113,7425389,7425366,'117',3.333,4),(113,7425390,7425366,'17b',3.333,4),(113,7425391,7425366,'7b0',3.333,4),(113,7425392,7425366,'b06',3.333,4),(113,7425393,7425366,'06a',3.333,4),(113,7425394,7425366,'6ab',3.333,4),(113,7425395,7425366,'aba',3.333,4),(113,7425396,7425366,'ba2',3.333,4),(113,7425397,7425367,'siz',50,1),(113,7425398,7425367,'ize',50,1),(113,7425399,7425397,'163',33.333,1),(113,7425400,7425397,'638',33.333,1),(113,7425401,7425397,'384',33.333,1),(113,7425402,7425399,'dev',25,1),(113,7425403,7425399,'evi',25,1),(113,7425404,7425399,'vic',25,1),(113,7425405,7425399,'ice',25,1),(113,7425406,7425402,'typ',50,1),(113,7425407,7425402,'ype',50,1),(113,7425408,7425406,'dir',10,1),(113,7425409,7425406,'ire',10,1),(113,7425410,7425406,'rec',10,1),(113,7425411,7425406,'ect',10,1),(113,7425412,7425406,'cta',10,1),(113,7425413,7425406,'tac',10,1),(113,7425414,7425406,'acc',10,1),(113,7425415,7425406,'cce',10,1),(113,7425416,7425406,'ces',10,1),(113,7425417,7425406,'ess',10,1),(113,7425418,7425408,'mul',14.286,1),(113,7425419,7425408,'ult',14.286,1),(113,7425420,7425408,'lti',14.286,1),(113,7425421,7425408,'tip',14.286,1),(113,7425422,7425408,'ipa',14.286,1),(113,7425423,7425408,'pat',14.286,1),(113,7425424,7425408,'ath',14.286,1),(113,7425425,7425418,'plu',25,1),(113,7425426,7425418,'lug',25,1),(113,7425427,7425418,'ugi',25,1),(113,7425428,7425418,'gin',25,1),(113,7425429,7425425,'nmp',100,1),(113,7425430,7425429,'dev',33.333,1),(113,7425431,7425429,'evf',33.333,1),(113,7425432,7425429,'vfs',33.333,1),(113,7425433,7425430,'pat',50,1),(113,7425434,7425430,'ath',50,1),(113,7425435,7425433,'vmf',50,1),(113,7425436,7425433,'mfs',50,1),(113,7425437,7425435,'dev',20,1),(113,7425438,7425435,'evi',20,1),(113,7425439,7425435,'vic',20,1),(113,7425440,7425435,'ice',20,1),(113,7425441,7425435,'ces',20,1),(113,7425442,7425437,'dis',33.333,1),(113,7425443,7425437,'isk',33.333,1),(113,7425444,7425437,'sks',33.333,1),(113,7425445,7425442,'ven',25,1),(113,7425446,7425442,'end',25,1),(113,7425447,7425442,'ndo',25,1),(113,7425448,7425442,'dor',25,1),(113,7425449,7425445,'mod',33.333,1),(113,7425450,7425445,'ode',33.333,1),(113,7425451,7425445,'del',33.333,1),(113,7425452,7425449,'fla',33.333,1),(113,7425453,7425449,'las',33.333,1),(113,7425454,7425449,'ash',33.333,1),(113,7425455,7425452,'acc',33.333,1),(113,7425456,7425452,'cce',33.333,1),(113,7425457,7425452,'cel',33.333,1),(113,7425458,7425455,'rev',16.667,1),(113,7425459,7425455,'evi',16.667,1),(113,7425460,7425455,'vis',16.667,1),(113,7425461,7425455,'isi',16.667,1),(113,7425462,7425455,'sio',16.667,1),(113,7425463,7425455,'ion',16.667,1),(113,7425464,7425458,'lev',33.333,1),(113,7425465,7425458,'eve',33.333,1),(113,7425466,7425458,'vel',33.333,1),(113,7425467,7425464,'pse',25,1),(113,7425468,7425464,'seu',25,1),(113,7425469,7425464,'eud',25,1),(113,7425470,7425464,'udo',25,1),(113,7425471,7425467,'fal',33.333,5),(113,7425472,7425467,'als',33.333,5),(113,7425473,7425467,'lse',33.333,5),(113,7425474,7425471,'sta',25,3),(113,7425475,7425471,'tat',25,3),(113,7425476,7425471,'atu',25,3),(113,7425477,7425471,'tus',25,3),(113,7425478,7425474,'deg',16.667,1),(113,7425479,7425474,'egr',16.667,1),(113,7425480,7425474,'gra',16.667,1),(113,7425481,7425474,'rad',16.667,1),(113,7425482,7425474,'ade',16.667,1),(113,7425483,7425474,'ded',16.667,1),(113,7425484,7425478,'rdm',100,1),(113,7425485,7425484,'cap',20,1),(113,7425486,7425484,'apa',20,1),(113,7425487,7425484,'pab',20,1),(113,7425488,7425484,'abl',20,1),(113,7425489,7425484,'ble',20,1),(113,7425490,7425485,'tru',50,2),(113,7425491,7425485,'rue',50,2),(113,7425492,7425490,'loc',33.333,1),(113,7425493,7425490,'oca',33.333,1),(113,7425494,7425490,'cal',33.333,1),(113,7425495,7425492,'rem',14.286,1),(113,7425496,7425492,'emo',14.286,1),(113,7425497,7425492,'mov',14.286,1),(113,7425498,7425492,'ova',14.286,1),(113,7425499,7425492,'vab',14.286,1),(113,7425500,7425492,'abl',14.286,1),(113,7425501,7425492,'ble',14.286,1),(113,7425502,7425495,'ssd',100,1),(113,7425503,7425502,'off',20,1),(113,7425504,7425502,'ffl',20,1),(113,7425505,7425502,'fli',20,1),(113,7425506,7425502,'lin',20,1),(113,7425507,7425502,'ine',20,1),(113,7425508,7425503,'per',11.111,1),(113,7425509,7425503,'ere',11.111,1),(113,7425510,7425503,'ren',11.111,1),(113,7425511,7425503,'enn',11.111,1),(113,7425512,7425503,'nni',11.111,1),(113,7425513,7425503,'nia',11.111,1),(113,7425514,7425503,'ial',11.111,1),(113,7425515,7425503,'all',11.111,1),(113,7425516,7425503,'lly',11.111,1),(113,7425517,7425508,'res',16.667,1),(113,7425518,7425508,'ese',16.667,1),(113,7425519,7425508,'ser',16.667,1),(113,7425520,7425508,'erv',16.667,1),(113,7425521,7425508,'rve',16.667,1),(113,7425522,7425508,'ved',16.667,1),(113,7425523,7425517,'thi',50,1),(113,7425524,7425517,'hin',50,1),(113,7425525,7425523,'pro',10,1),(113,7425526,7425523,'rov',10,1),(113,7425527,7425523,'ovi',10,1),(113,7425528,7425523,'vis',10,1),(113,7425529,7425523,'isi',10,1),(113,7425530,7425523,'sio',10,1),(113,7425531,7425523,'ion',10,1),(113,7425532,7425523,'oni',10,1),(113,7425533,7425523,'nin',10,1),(113,7425534,7425523,'ing',10,1),(113,7425535,7425525,'unk',20,1),(113,7425536,7425525,'nkn',20,1),(113,7425537,7425525,'kno',20,1),(113,7425538,7425525,'now',20,1),(113,7425539,7425525,'own',20,1),(113,7425540,7425535,'fil',20,1),(113,7425541,7425535,'ilt',20,1),(113,7425542,7425535,'lte',20,1),(113,7425543,7425535,'ter',20,1),(113,7425544,7425535,'ers',20,1),(113,7425545,7425540,'vaa',50,1),(113,7425546,7425540,'aai',50,1),(113,7425547,7425545,'uns',11.111,1),(113,7425548,7425545,'nsu',11.111,1),(113,7425549,7425545,'sup',11.111,1),(113,7425550,7425545,'upp',11.111,1),(113,7425551,7425545,'ppo',11.111,1),(113,7425552,7425545,'por',11.111,1),(113,7425553,7425545,'ort',11.111,1),(113,7425554,7425545,'rte',11.111,1),(113,7425555,7425545,'ted',11.111,1),(113,7425556,7425547,'oth',33.333,1),(113,7425557,7425547,'the',33.333,1),(113,7425558,7425547,'her',33.333,1),(113,7425559,7425556,'uid',50,1),(113,7425560,7425556,'ids',50,1),(113,7425561,7425559,'vml',100,1),(113,7425562,7425561,'dis',20,1),(113,7425563,7425561,'isp',20,1),(113,7425564,7425561,'spl',20,1),(113,7425565,7425561,'pla',20,1),(113,7425566,7425561,'lay',20,1),(113,7425567,7425562,'nam',50,1),(113,7425568,7425562,'ame',50,1),(114,7425570,7425569,'net',25,3),(114,7425571,7425569,'eta',25,3),(114,7425572,7425569,'tap',25,3),(114,7425573,7425569,'app',25,3),(114,7425574,7425570,'fib',33.333,2),(114,7425575,7425570,'ibr',33.333,2),(114,7425576,7425570,'bre',33.333,2),(114,7425577,7425574,'cha',20,2),(114,7425578,7425574,'han',20,2),(114,7425579,7425574,'ann',20,2),(114,7425580,7425574,'nne',20,2),(114,7425581,7425574,'nel',20,2),(114,7425582,7425577,'dis',50,2),(114,7425583,7425577,'isk',50,2),(114,7425584,7425582,'naa',100,4),(114,7425585,7425584,'600',3.333,4),(114,7425586,7425584,'00a',3.333,4),(114,7425587,7425584,'0a0',3.333,4),(114,7425588,7425584,'a09',3.333,4),(114,7425589,7425584,'098',3.333,4),(114,7425590,7425584,'980',3.333,4),(114,7425591,7425584,'804',3.333,4),(114,7425592,7425584,'044',3.333,4),(114,7425593,7425584,'443',3.333,4),(114,7425594,7425584,'430',3.333,4),(114,7425595,7425584,'307',3.333,4),(114,7425596,7425584,'072',3.333,4),(114,7425597,7425584,'725',3.333,4),(114,7425598,7425584,'259',3.333,4),(114,7425599,7425584,'593',3.333,4),(114,7425600,7425584,'931',3.333,4),(114,7425601,7425584,'313',3.333,4),(114,7425602,7425584,'13f',3.333,4),(114,7425603,7425584,'3f3',3.333,4),(114,7425604,7425584,'f33',3.333,4),(114,7425605,7425584,'334',3.333,4),(114,7425606,7425584,'345',3.333,4),(114,7425607,7425584,'455',3.333,4),(114,7425608,7425584,'556',3.333,4),(114,7425609,7425584,'563',3.333,4),(114,7425610,7425584,'639',3.333,4),(114,7425611,7425584,'393',3.333,4),(114,7425612,7425584,'934',3.333,4),(114,7425613,7425584,'344',3.333,4),(114,7425614,7425584,'44a',3.333,4),(114,7425615,7425585,'ser',25,1),(114,7425616,7425585,'eri',25,1),(114,7425617,7425585,'ria',25,1),(114,7425618,7425585,'ial',25,1),(114,7425619,7425615,'siz',50,1),(114,7425620,7425615,'ize',50,1),(114,7425621,7425619,'321',100,1),(114,7425622,7425621,'dev',25,1),(114,7425623,7425621,'evi',25,1),(114,7425624,7425621,'vic',25,1),(114,7425625,7425621,'ice',25,1),(114,7425626,7425622,'typ',50,1),(114,7425627,7425622,'ype',50,1),(114,7425628,7425626,'dir',10,1),(114,7425629,7425626,'ire',10,1),(114,7425630,7425626,'rec',10,1),(114,7425631,7425626,'ect',10,1),(114,7425632,7425626,'cta',10,1),(114,7425633,7425626,'tac',10,1),(114,7425634,7425626,'acc',10,1),(114,7425635,7425626,'cce',10,1),(114,7425636,7425626,'ces',10,1),(114,7425637,7425626,'ess',10,1),(114,7425638,7425628,'mul',14.286,1),(114,7425639,7425628,'ult',14.286,1),(114,7425640,7425628,'lti',14.286,1),(114,7425641,7425628,'tip',14.286,1),(114,7425642,7425628,'ipa',14.286,1),(114,7425643,7425628,'pat',14.286,1),(114,7425644,7425628,'ath',14.286,1),(114,7425645,7425638,'plu',25,1),(114,7425646,7425638,'lug',25,1),(114,7425647,7425638,'ugi',25,1),(114,7425648,7425638,'gin',25,1),(114,7425649,7425645,'nmp',100,1),(114,7425650,7425649,'dev',33.333,1),(114,7425651,7425649,'evf',33.333,1),(114,7425652,7425649,'vfs',33.333,1),(114,7425653,7425650,'pat',50,1),(114,7425654,7425650,'ath',50,1),(114,7425655,7425653,'vmf',50,1),(114,7425656,7425653,'mfs',50,1),(114,7425657,7425655,'dev',20,1),(114,7425658,7425655,'evi',20,1),(114,7425659,7425655,'vic',20,1),(114,7425660,7425655,'ice',20,1),(114,7425661,7425655,'ces',20,1),(114,7425662,7425657,'dis',33.333,1),(114,7425663,7425657,'isk',33.333,1),(114,7425664,7425657,'sks',33.333,1),(114,7425665,7425662,'ven',25,1),(114,7425666,7425662,'end',25,1),(114,7425667,7425662,'ndo',25,1),(114,7425668,7425662,'dor',25,1),(114,7425669,7425665,'mod',33.333,1),(114,7425670,7425665,'ode',33.333,1),(114,7425671,7425665,'del',33.333,1),(114,7425672,7425669,'lun',100,1),(114,7425673,7425672,'cmo',33.333,1),(114,7425674,7425672,'mod',33.333,1),(114,7425675,7425672,'ode',33.333,1),(114,7425676,7425673,'rev',16.667,1),(114,7425677,7425673,'evi',16.667,1),(114,7425678,7425673,'vis',16.667,1),(114,7425679,7425673,'isi',16.667,1),(114,7425680,7425673,'sio',16.667,1),(114,7425681,7425673,'ion',16.667,1),(114,7425682,7425676,'810',50,1),(114,7425683,7425676,'100',50,1),(114,7425684,7425682,'scs',50,1),(114,7425685,7425682,'csi',50,1),(114,7425686,7425684,'lev',33.333,1),(114,7425687,7425684,'eve',33.333,1),(114,7425688,7425684,'vel',33.333,1),(114,7425689,7425686,'pse',25,1),(114,7425690,7425686,'seu',25,1),(114,7425691,7425686,'eud',25,1),(114,7425692,7425686,'udo',25,1),(114,7425693,7425689,'fal',33.333,6),(114,7425694,7425689,'als',33.333,6),(114,7425695,7425689,'lse',33.333,6),(114,7425696,7425693,'sta',25,3),(114,7425697,7425693,'tat',25,3),(114,7425698,7425693,'atu',25,3),(114,7425699,7425693,'tus',25,3),(114,7425700,7425696,'rdm',100,1),(114,7425701,7425700,'cap',20,1),(114,7425702,7425700,'apa',20,1),(114,7425703,7425700,'pab',20,1),(114,7425704,7425700,'abl',20,1),(114,7425705,7425700,'ble',20,1),(114,7425706,7425701,'tru',50,1),(114,7425707,7425701,'rue',50,1),(114,7425708,7425706,'loc',33.333,1),(114,7425709,7425706,'oca',33.333,1),(114,7425710,7425706,'cal',33.333,1),(114,7425711,7425708,'rem',14.286,1),(114,7425712,7425708,'emo',14.286,1),(114,7425713,7425708,'mov',14.286,1),(114,7425714,7425708,'ova',14.286,1),(114,7425715,7425708,'vab',14.286,1),(114,7425716,7425708,'abl',14.286,1),(114,7425717,7425708,'ble',14.286,1),(114,7425718,7425711,'ssd',100,1),(114,7425719,7425718,'off',20,1),(114,7425720,7425718,'ffl',20,1),(114,7425721,7425718,'fli',20,1),(114,7425722,7425718,'lin',20,1),(114,7425723,7425718,'ine',20,1),(114,7425724,7425719,'per',11.111,1),(114,7425725,7425719,'ere',11.111,1),(114,7425726,7425719,'ren',11.111,1),(114,7425727,7425719,'enn',11.111,1),(114,7425728,7425719,'nni',11.111,1),(114,7425729,7425719,'nia',11.111,1),(114,7425730,7425719,'ial',11.111,1),(114,7425731,7425719,'all',11.111,1),(114,7425732,7425719,'lly',11.111,1),(114,7425733,7425724,'res',16.667,1),(114,7425734,7425724,'ese',16.667,1),(114,7425735,7425724,'ser',16.667,1),(114,7425736,7425724,'erv',16.667,1),(114,7425737,7425724,'rve',16.667,1),(114,7425738,7425724,'ved',16.667,1),(114,7425739,7425733,'thi',50,1),(114,7425740,7425733,'hin',50,1),(114,7425741,7425739,'pro',10,1),(114,7425742,7425739,'rov',10,1),(114,7425743,7425739,'ovi',10,1),(114,7425744,7425739,'vis',10,1),(114,7425745,7425739,'isi',10,1),(114,7425746,7425739,'sio',10,1),(114,7425747,7425739,'ion',10,1),(114,7425748,7425739,'oni',10,1),(114,7425749,7425739,'nin',10,1),(114,7425750,7425739,'ing',10,1),(114,7425751,7425741,'yes',100,1),(114,7425752,7425751,'att',16.667,1),(114,7425753,7425751,'tta',16.667,1),(114,7425754,7425751,'tac',16.667,1),(114,7425755,7425751,'ach',16.667,1),(114,7425756,7425751,'che',16.667,1),(114,7425757,7425751,'hed',16.667,1),(114,7425758,7425752,'fil',20,1),(114,7425759,7425752,'ilt',20,1),(114,7425760,7425752,'lte',20,1),(114,7425761,7425752,'ter',20,1),(114,7425762,7425752,'ers',20,1),(114,7425763,7425758,'vaa',50,1),(114,7425764,7425758,'aai',50,1),(114,7425765,7425763,'unk',20,1),(114,7425766,7425763,'nkn',20,1),(114,7425767,7425763,'kno',20,1),(114,7425768,7425763,'now',20,1),(114,7425769,7425763,'own',20,1),(114,7425770,7425765,'oth',33.333,1),(114,7425771,7425765,'the',33.333,1),(114,7425772,7425765,'her',33.333,1),(114,7425773,7425770,'uid',50,1),(114,7425774,7425770,'ids',50,1),(114,7425775,7425773,'vml',100,1),(114,7425776,7425775,'dis',20,1),(114,7425777,7425775,'isp',20,1),(114,7425778,7425775,'spl',20,1),(114,7425779,7425775,'pla',20,1),(114,7425780,7425775,'lay',20,1),(114,7425781,7425776,'nam',50,1),(114,7425782,7425776,'ame',50,1),(115,7425784,7425783,'net',25,3),(115,7425785,7425783,'eta',25,3),(115,7425786,7425783,'tap',25,3),(115,7425787,7425783,'app',25,3),(115,7425788,7425784,'fib',33.333,2),(115,7425789,7425784,'ibr',33.333,2),(115,7425790,7425784,'bre',33.333,2),(115,7425791,7425788,'cha',20,2),(115,7425792,7425788,'han',20,2),(115,7425793,7425788,'ann',20,2),(115,7425794,7425788,'nne',20,2),(115,7425795,7425788,'nel',20,2),(115,7425796,7425791,'dis',50,2),(115,7425797,7425791,'isk',50,2),(115,7425798,7425796,'naa',100,4),(115,7425799,7425798,'600',3.333,4),(115,7425800,7425798,'00a',3.333,4),(115,7425801,7425798,'0a0',3.333,4),(115,7425802,7425798,'a09',3.333,4),(115,7425803,7425798,'098',3.333,4),(115,7425804,7425798,'980',3.333,4),(115,7425805,7425798,'804',3.333,4),(115,7425806,7425798,'044',3.333,4),(115,7425807,7425798,'443',3.333,4),(115,7425808,7425798,'430',3.333,4),(115,7425809,7425798,'307',3.333,4),(115,7425810,7425798,'072',3.333,4),(115,7425811,7425798,'725',3.333,4),(115,7425812,7425798,'259',3.333,4),(115,7425813,7425798,'593',3.333,4),(115,7425814,7425798,'931',3.333,4),(115,7425815,7425798,'313',3.333,4),(115,7425816,7425798,'13f',3.333,4),(115,7425817,7425798,'3f3',3.333,4),(115,7425818,7425798,'f33',3.333,4),(115,7425819,7425798,'334',3.333,4),(115,7425820,7425798,'345',3.333,4),(115,7425821,7425798,'455',3.333,4),(115,7425822,7425798,'556',3.333,4),(115,7425823,7425798,'563',3.333,4),(115,7425824,7425798,'639',3.333,4),(115,7425825,7425798,'393',3.333,4),(115,7425826,7425798,'934',3.333,4),(115,7425827,7425798,'344',3.333,4),(115,7425828,7425798,'44b',3.333,4),(115,7425829,7425799,'ser',25,1),(115,7425830,7425799,'eri',25,1),(115,7425831,7425799,'ria',25,1),(115,7425832,7425799,'ial',25,1),(115,7425833,7425829,'siz',50,1),(115,7425834,7425829,'ize',50,1),(115,7425835,7425833,'321',100,1),(115,7425836,7425835,'dev',25,1),(115,7425837,7425835,'evi',25,1),(115,7425838,7425835,'vic',25,1),(115,7425839,7425835,'ice',25,1),(115,7425840,7425836,'typ',50,1),(115,7425841,7425836,'ype',50,1),(115,7425842,7425840,'dir',10,1),(115,7425843,7425840,'ire',10,1),(115,7425844,7425840,'rec',10,1),(115,7425845,7425840,'ect',10,1),(115,7425846,7425840,'cta',10,1),(115,7425847,7425840,'tac',10,1),(115,7425848,7425840,'acc',10,1),(115,7425849,7425840,'cce',10,1),(115,7425850,7425840,'ces',10,1),(115,7425851,7425840,'ess',10,1),(115,7425852,7425842,'mul',14.286,1),(115,7425853,7425842,'ult',14.286,1),(115,7425854,7425842,'lti',14.286,1),(115,7425855,7425842,'tip',14.286,1),(115,7425856,7425842,'ipa',14.286,1),(115,7425857,7425842,'pat',14.286,1),(115,7425858,7425842,'ath',14.286,1),(115,7425859,7425852,'plu',25,1),(115,7425860,7425852,'lug',25,1),(115,7425861,7425852,'ugi',25,1),(115,7425862,7425852,'gin',25,1),(115,7425863,7425859,'nmp',100,1),(115,7425864,7425863,'dev',33.333,1),(115,7425865,7425863,'evf',33.333,1),(115,7425866,7425863,'vfs',33.333,1),(115,7425867,7425864,'pat',50,1),(115,7425868,7425864,'ath',50,1),(115,7425869,7425867,'vmf',50,1),(115,7425870,7425867,'mfs',50,1),(115,7425871,7425869,'dev',20,1),(115,7425872,7425869,'evi',20,1),(115,7425873,7425869,'vic',20,1),(115,7425874,7425869,'ice',20,1),(115,7425875,7425869,'ces',20,1),(115,7425876,7425871,'dis',33.333,1),(115,7425877,7425871,'isk',33.333,1),(115,7425878,7425871,'sks',33.333,1),(115,7425879,7425876,'ven',25,1),(115,7425880,7425876,'end',25,1),(115,7425881,7425876,'ndo',25,1),(115,7425882,7425876,'dor',25,1),(115,7425883,7425879,'mod',33.333,1),(115,7425884,7425879,'ode',33.333,1),(115,7425885,7425879,'del',33.333,1),(115,7425886,7425883,'lun',100,1),(115,7425887,7425886,'cmo',33.333,1),(115,7425888,7425886,'mod',33.333,1),(115,7425889,7425886,'ode',33.333,1),(115,7425890,7425887,'rev',16.667,1),(115,7425891,7425887,'evi',16.667,1),(115,7425892,7425887,'vis',16.667,1),(115,7425893,7425887,'isi',16.667,1),(115,7425894,7425887,'sio',16.667,1),(115,7425895,7425887,'ion',16.667,1),(115,7425896,7425890,'810',50,1),(115,7425897,7425890,'100',50,1),(115,7425898,7425896,'scs',50,1),(115,7425899,7425896,'csi',50,1),(115,7425900,7425898,'lev',33.333,1),(115,7425901,7425898,'eve',33.333,1),(115,7425902,7425898,'vel',33.333,1),(115,7425903,7425900,'pse',25,1),(115,7425904,7425900,'seu',25,1),(115,7425905,7425900,'eud',25,1),(115,7425906,7425900,'udo',25,1),(115,7425907,7425903,'fal',33.333,6),(115,7425908,7425903,'als',33.333,6),(115,7425909,7425903,'lse',33.333,6),(115,7425910,7425907,'sta',25,3),(115,7425911,7425907,'tat',25,3),(115,7425912,7425907,'atu',25,3),(115,7425913,7425907,'tus',25,3),(115,7425914,7425910,'rdm',100,1),(115,7425915,7425914,'cap',20,1),(115,7425916,7425914,'apa',20,1),(115,7425917,7425914,'pab',20,1),(115,7425918,7425914,'abl',20,1),(115,7425919,7425914,'ble',20,1),(115,7425920,7425915,'tru',50,1),(115,7425921,7425915,'rue',50,1),(115,7425922,7425920,'loc',33.333,1),(115,7425923,7425920,'oca',33.333,1),(115,7425924,7425920,'cal',33.333,1),(115,7425925,7425922,'rem',14.286,1),(115,7425926,7425922,'emo',14.286,1),(115,7425927,7425922,'mov',14.286,1),(115,7425928,7425922,'ova',14.286,1),(115,7425929,7425922,'vab',14.286,1),(115,7425930,7425922,'abl',14.286,1),(115,7425931,7425922,'ble',14.286,1),(115,7425932,7425925,'ssd',100,1),(115,7425933,7425932,'off',20,1),(115,7425934,7425932,'ffl',20,1),(115,7425935,7425932,'fli',20,1),(115,7425936,7425932,'lin',20,1),(115,7425937,7425932,'ine',20,1),(115,7425938,7425933,'per',11.111,1),(115,7425939,7425933,'ere',11.111,1),(115,7425940,7425933,'ren',11.111,1),(115,7425941,7425933,'enn',11.111,1),(115,7425942,7425933,'nni',11.111,1),(115,7425943,7425933,'nia',11.111,1),(115,7425944,7425933,'ial',11.111,1),(115,7425945,7425933,'all',11.111,1),(115,7425946,7425933,'lly',11.111,1),(115,7425947,7425938,'res',16.667,1),(115,7425948,7425938,'ese',16.667,1),(115,7425949,7425938,'ser',16.667,1),(115,7425950,7425938,'erv',16.667,1),(115,7425951,7425938,'rve',16.667,1),(115,7425952,7425938,'ved',16.667,1),(115,7425953,7425947,'thi',50,1),(115,7425954,7425947,'hin',50,1),(115,7425955,7425953,'pro',10,1),(115,7425956,7425953,'rov',10,1),(115,7425957,7425953,'ovi',10,1),(115,7425958,7425953,'vis',10,1),(115,7425959,7425953,'isi',10,1),(115,7425960,7425953,'sio',10,1),(115,7425961,7425953,'ion',10,1),(115,7425962,7425953,'oni',10,1),(115,7425963,7425953,'nin',10,1),(115,7425964,7425953,'ing',10,1),(115,7425965,7425955,'yes',100,1),(115,7425966,7425965,'att',16.667,1),(115,7425967,7425965,'tta',16.667,1),(115,7425968,7425965,'tac',16.667,1),(115,7425969,7425965,'ach',16.667,1),(115,7425970,7425965,'che',16.667,1),(115,7425971,7425965,'hed',16.667,1),(115,7425972,7425966,'fil',20,1),(115,7425973,7425966,'ilt',20,1),(115,7425974,7425966,'lte',20,1),(115,7425975,7425966,'ter',20,1),(115,7425976,7425966,'ers',20,1),(115,7425977,7425972,'vaa',50,1),(115,7425978,7425972,'aai',50,1),(115,7425979,7425977,'unk',20,1),(115,7425980,7425977,'nkn',20,1),(115,7425981,7425977,'kno',20,1),(115,7425982,7425977,'now',20,1),(115,7425983,7425977,'own',20,1),(115,7425984,7425979,'oth',33.333,1),(115,7425985,7425979,'the',33.333,1),(115,7425986,7425979,'her',33.333,1),(115,7425987,7425984,'uid',50,1),(115,7425988,7425984,'ids',50,1),(115,7425989,7425987,'vml',100,1),(115,7425990,7425989,'dis',20,1),(115,7425991,7425989,'isp',20,1),(115,7425992,7425989,'spl',20,1),(115,7425993,7425989,'pla',20,1),(115,7425994,7425989,'lay',20,1),(115,7425995,7425990,'nam',50,1),(115,7425996,7425990,'ame',50,1),(116,7425998,7425997,'net',25,3),(116,7425999,7425997,'eta',25,3),(116,7426000,7425997,'tap',25,3),(116,7426001,7425997,'app',25,3),(116,7426002,7425998,'fib',33.333,2),(116,7426003,7425998,'ibr',33.333,2),(116,7426004,7425998,'bre',33.333,2),(116,7426005,7426002,'cha',20,2),(116,7426006,7426002,'han',20,2),(116,7426007,7426002,'ann',20,2),(116,7426008,7426002,'nne',20,2),(116,7426009,7426002,'nel',20,2),(116,7426010,7426005,'dis',50,2),(116,7426011,7426005,'isk',50,2),(116,7426012,7426010,'naa',100,4),(116,7426013,7426012,'600',3.333,4),(116,7426014,7426012,'00a',3.333,4),(116,7426015,7426012,'0a0',3.333,4),(116,7426016,7426012,'a09',3.333,4),(116,7426017,7426012,'098',3.333,4),(116,7426018,7426012,'980',3.333,4),(116,7426019,7426012,'804',3.333,4),(116,7426020,7426012,'044',3.333,4),(116,7426021,7426012,'443',3.333,4),(116,7426022,7426012,'430',3.333,4),(116,7426023,7426012,'307',3.333,4),(116,7426024,7426012,'072',3.333,4),(116,7426025,7426012,'725',3.333,4),(116,7426026,7426012,'259',3.333,4),(116,7426027,7426012,'593',3.333,4),(116,7426028,7426012,'931',3.333,4),(116,7426029,7426012,'313',3.333,4),(116,7426030,7426012,'13f',3.333,4),(116,7426031,7426012,'3f3',3.333,4),(116,7426032,7426012,'f33',3.333,4),(116,7426033,7426012,'334',3.333,4),(116,7426034,7426012,'345',3.333,4),(116,7426035,7426012,'455',3.333,4),(116,7426036,7426012,'556',3.333,4),(116,7426037,7426012,'563',3.333,4),(116,7426038,7426012,'639',3.333,4),(116,7426039,7426012,'393',3.333,4),(116,7426040,7426012,'934',3.333,4),(116,7426041,7426012,'344',3.333,4),(116,7426042,7426012,'44c',3.333,4),(116,7426043,7426013,'ser',25,1),(116,7426044,7426013,'eri',25,1),(116,7426045,7426013,'ria',25,1),(116,7426046,7426013,'ial',25,1),(116,7426047,7426043,'siz',50,1),(116,7426048,7426043,'ize',50,1),(116,7426049,7426047,'321',100,1),(116,7426050,7426049,'dev',25,1),(116,7426051,7426049,'evi',25,1),(116,7426052,7426049,'vic',25,1),(116,7426053,7426049,'ice',25,1),(116,7426054,7426050,'typ',50,1),(116,7426055,7426050,'ype',50,1),(116,7426056,7426054,'dir',10,1),(116,7426057,7426054,'ire',10,1),(116,7426058,7426054,'rec',10,1),(116,7426059,7426054,'ect',10,1),(116,7426060,7426054,'cta',10,1),(116,7426061,7426054,'tac',10,1),(116,7426062,7426054,'acc',10,1),(116,7426063,7426054,'cce',10,1),(116,7426064,7426054,'ces',10,1),(116,7426065,7426054,'ess',10,1),(116,7426066,7426056,'mul',14.286,1),(116,7426067,7426056,'ult',14.286,1),(116,7426068,7426056,'lti',14.286,1),(116,7426069,7426056,'tip',14.286,1),(116,7426070,7426056,'ipa',14.286,1),(116,7426071,7426056,'pat',14.286,1),(116,7426072,7426056,'ath',14.286,1),(116,7426073,7426066,'plu',25,1),(116,7426074,7426066,'lug',25,1),(116,7426075,7426066,'ugi',25,1),(116,7426076,7426066,'gin',25,1),(116,7426077,7426073,'nmp',100,1),(116,7426078,7426077,'dev',33.333,1),(116,7426079,7426077,'evf',33.333,1),(116,7426080,7426077,'vfs',33.333,1),(116,7426081,7426078,'pat',50,1),(116,7426082,7426078,'ath',50,1),(116,7426083,7426081,'vmf',50,1),(116,7426084,7426081,'mfs',50,1),(116,7426085,7426083,'dev',20,1),(116,7426086,7426083,'evi',20,1),(116,7426087,7426083,'vic',20,1),(116,7426088,7426083,'ice',20,1),(116,7426089,7426083,'ces',20,1),(116,7426090,7426085,'dis',33.333,1),(116,7426091,7426085,'isk',33.333,1),(116,7426092,7426085,'sks',33.333,1),(116,7426093,7426090,'ven',25,1),(116,7426094,7426090,'end',25,1),(116,7426095,7426090,'ndo',25,1),(116,7426096,7426090,'dor',25,1),(116,7426097,7426093,'mod',33.333,1),(116,7426098,7426093,'ode',33.333,1),(116,7426099,7426093,'del',33.333,1),(116,7426100,7426097,'lun',100,1),(116,7426101,7426100,'cmo',33.333,1),(116,7426102,7426100,'mod',33.333,1),(116,7426103,7426100,'ode',33.333,1),(116,7426104,7426101,'rev',16.667,1),(116,7426105,7426101,'evi',16.667,1),(116,7426106,7426101,'vis',16.667,1),(116,7426107,7426101,'isi',16.667,1),(116,7426108,7426101,'sio',16.667,1),(116,7426109,7426101,'ion',16.667,1),(116,7426110,7426104,'810',50,1),(116,7426111,7426104,'100',50,1),(116,7426112,7426110,'scs',50,1),(116,7426113,7426110,'csi',50,1),(116,7426114,7426112,'lev',33.333,1),(116,7426115,7426112,'eve',33.333,1),(116,7426116,7426112,'vel',33.333,1),(116,7426117,7426114,'pse',25,1),(116,7426118,7426114,'seu',25,1),(116,7426119,7426114,'eud',25,1),(116,7426120,7426114,'udo',25,1),(116,7426121,7426117,'fal',33.333,6),(116,7426122,7426117,'als',33.333,6),(116,7426123,7426117,'lse',33.333,6),(116,7426124,7426121,'sta',25,3),(116,7426125,7426121,'tat',25,3),(116,7426126,7426121,'atu',25,3),(116,7426127,7426121,'tus',25,3),(116,7426128,7426124,'rdm',100,1),(116,7426129,7426128,'cap',20,1),(116,7426130,7426128,'apa',20,1),(116,7426131,7426128,'pab',20,1),(116,7426132,7426128,'abl',20,1),(116,7426133,7426128,'ble',20,1),(116,7426134,7426129,'tru',50,1),(116,7426135,7426129,'rue',50,1),(116,7426136,7426134,'loc',33.333,1),(116,7426137,7426134,'oca',33.333,1),(116,7426138,7426134,'cal',33.333,1),(116,7426139,7426136,'rem',14.286,1),(116,7426140,7426136,'emo',14.286,1),(116,7426141,7426136,'mov',14.286,1),(116,7426142,7426136,'ova',14.286,1),(116,7426143,7426136,'vab',14.286,1),(116,7426144,7426136,'abl',14.286,1),(116,7426145,7426136,'ble',14.286,1),(116,7426146,7426139,'ssd',100,1),(116,7426147,7426146,'off',20,1),(116,7426148,7426146,'ffl',20,1),(116,7426149,7426146,'fli',20,1),(116,7426150,7426146,'lin',20,1),(116,7426151,7426146,'ine',20,1),(116,7426152,7426147,'per',11.111,1),(116,7426153,7426147,'ere',11.111,1),(116,7426154,7426147,'ren',11.111,1),(116,7426155,7426147,'enn',11.111,1),(116,7426156,7426147,'nni',11.111,1),(116,7426157,7426147,'nia',11.111,1),(116,7426158,7426147,'ial',11.111,1),(116,7426159,7426147,'all',11.111,1),(116,7426160,7426147,'lly',11.111,1),(116,7426161,7426152,'res',16.667,1),(116,7426162,7426152,'ese',16.667,1),(116,7426163,7426152,'ser',16.667,1),(116,7426164,7426152,'erv',16.667,1),(116,7426165,7426152,'rve',16.667,1),(116,7426166,7426152,'ved',16.667,1),(116,7426167,7426161,'thi',50,1),(116,7426168,7426161,'hin',50,1),(116,7426169,7426167,'pro',10,1),(116,7426170,7426167,'rov',10,1),(116,7426171,7426167,'ovi',10,1),(116,7426172,7426167,'vis',10,1),(116,7426173,7426167,'isi',10,1),(116,7426174,7426167,'sio',10,1),(116,7426175,7426167,'ion',10,1),(116,7426176,7426167,'oni',10,1),(116,7426177,7426167,'nin',10,1),(116,7426178,7426167,'ing',10,1),(116,7426179,7426169,'yes',100,1),(116,7426180,7426179,'att',16.667,1),(116,7426181,7426179,'tta',16.667,1),(116,7426182,7426179,'tac',16.667,1),(116,7426183,7426179,'ach',16.667,1),(116,7426184,7426179,'che',16.667,1),(116,7426185,7426179,'hed',16.667,1),(116,7426186,7426180,'fil',20,1),(116,7426187,7426180,'ilt',20,1),(116,7426188,7426180,'lte',20,1),(116,7426189,7426180,'ter',20,1),(116,7426190,7426180,'ers',20,1),(116,7426191,7426186,'vaa',50,1),(116,7426192,7426186,'aai',50,1),(116,7426193,7426191,'unk',20,1),(116,7426194,7426191,'nkn',20,1),(116,7426195,7426191,'kno',20,1),(116,7426196,7426191,'now',20,1),(116,7426197,7426191,'own',20,1),(116,7426198,7426193,'oth',33.333,1),(116,7426199,7426193,'the',33.333,1),(116,7426200,7426193,'her',33.333,1),(116,7426201,7426198,'uid',50,1),(116,7426202,7426198,'ids',50,1),(116,7426203,7426201,'vml',100,1),(116,7426204,7426203,'dis',20,1),(116,7426205,7426203,'isp',20,1),(116,7426206,7426203,'spl',20,1),(116,7426207,7426203,'pla',20,1),(116,7426208,7426203,'lay',20,1),(116,7426209,7426204,'nam',50,1),(116,7426210,7426204,'ame',50,1),(117,7426212,7426211,'net',25,3),(117,7426213,7426211,'eta',25,3),(117,7426214,7426211,'tap',25,3),(117,7426215,7426211,'app',25,3),(117,7426216,7426212,'fib',33.333,2),(117,7426217,7426212,'ibr',33.333,2),(117,7426218,7426212,'bre',33.333,2),(117,7426219,7426216,'cha',20,2),(117,7426220,7426216,'han',20,2),(117,7426221,7426216,'ann',20,2),(117,7426222,7426216,'nne',20,2),(117,7426223,7426216,'nel',20,2),(117,7426224,7426219,'dis',50,2),(117,7426225,7426219,'isk',50,2),(117,7426226,7426224,'naa',100,4),(117,7426227,7426226,'600',3.333,4),(117,7426228,7426226,'00a',3.333,4),(117,7426229,7426226,'0a0',3.333,4),(117,7426230,7426226,'a09',3.333,4),(117,7426231,7426226,'098',3.333,4),(117,7426232,7426226,'980',3.333,4),(117,7426233,7426226,'804',3.333,4),(117,7426234,7426226,'044',3.333,4),(117,7426235,7426226,'443',3.333,4),(117,7426236,7426226,'430',3.333,4),(117,7426237,7426226,'307',3.333,4),(117,7426238,7426226,'072',3.333,4),(117,7426239,7426226,'725',3.333,4),(117,7426240,7426226,'259',3.333,4),(117,7426241,7426226,'593',3.333,4),(117,7426242,7426226,'931',3.333,4),(117,7426243,7426226,'313',3.333,4),(117,7426244,7426226,'13f',3.333,4),(117,7426245,7426226,'3f3',3.333,4),(117,7426246,7426226,'f33',3.333,4),(117,7426247,7426226,'334',3.333,4),(117,7426248,7426226,'345',3.333,4),(117,7426249,7426226,'455',3.333,4),(117,7426250,7426226,'556',3.333,4),(117,7426251,7426226,'563',3.333,4),(117,7426252,7426226,'639',3.333,4),(117,7426253,7426226,'393',3.333,4),(117,7426254,7426226,'934',3.333,4),(117,7426255,7426226,'344',3.333,4),(117,7426256,7426226,'44d',3.333,4),(117,7426257,7426227,'ser',25,1),(117,7426258,7426227,'eri',25,1),(117,7426259,7426227,'ria',25,1),(117,7426260,7426227,'ial',25,1),(117,7426261,7426257,'siz',50,1),(117,7426262,7426257,'ize',50,1),(117,7426263,7426261,'321',100,1),(117,7426264,7426263,'dev',25,1),(117,7426265,7426263,'evi',25,1),(117,7426266,7426263,'vic',25,1),(117,7426267,7426263,'ice',25,1),(117,7426268,7426264,'typ',50,1),(117,7426269,7426264,'ype',50,1),(117,7426270,7426268,'dir',10,1),(117,7426271,7426268,'ire',10,1),(117,7426272,7426268,'rec',10,1),(117,7426273,7426268,'ect',10,1),(117,7426274,7426268,'cta',10,1),(117,7426275,7426268,'tac',10,1),(117,7426276,7426268,'acc',10,1),(117,7426277,7426268,'cce',10,1),(117,7426278,7426268,'ces',10,1),(117,7426279,7426268,'ess',10,1),(117,7426280,7426270,'mul',14.286,1),(117,7426281,7426270,'ult',14.286,1),(117,7426282,7426270,'lti',14.286,1),(117,7426283,7426270,'tip',14.286,1),(117,7426284,7426270,'ipa',14.286,1),(117,7426285,7426270,'pat',14.286,1),(117,7426286,7426270,'ath',14.286,1),(117,7426287,7426280,'plu',25,1),(117,7426288,7426280,'lug',25,1),(117,7426289,7426280,'ugi',25,1),(117,7426290,7426280,'gin',25,1),(117,7426291,7426287,'nmp',100,1),(117,7426292,7426291,'dev',33.333,1),(117,7426293,7426291,'evf',33.333,1),(117,7426294,7426291,'vfs',33.333,1),(117,7426295,7426292,'pat',50,1),(117,7426296,7426292,'ath',50,1),(117,7426297,7426295,'vmf',50,1),(117,7426298,7426295,'mfs',50,1),(117,7426299,7426297,'dev',20,1),(117,7426300,7426297,'evi',20,1),(117,7426301,7426297,'vic',20,1),(117,7426302,7426297,'ice',20,1),(117,7426303,7426297,'ces',20,1),(117,7426304,7426299,'dis',33.333,1),(117,7426305,7426299,'isk',33.333,1),(117,7426306,7426299,'sks',33.333,1),(117,7426307,7426304,'ven',25,1),(117,7426308,7426304,'end',25,1),(117,7426309,7426304,'ndo',25,1),(117,7426310,7426304,'dor',25,1),(117,7426311,7426307,'mod',33.333,1),(117,7426312,7426307,'ode',33.333,1),(117,7426313,7426307,'del',33.333,1),(117,7426314,7426311,'lun',100,1),(117,7426315,7426314,'cmo',33.333,1),(117,7426316,7426314,'mod',33.333,1),(117,7426317,7426314,'ode',33.333,1),(117,7426318,7426315,'rev',16.667,1),(117,7426319,7426315,'evi',16.667,1),(117,7426320,7426315,'vis',16.667,1),(117,7426321,7426315,'isi',16.667,1),(117,7426322,7426315,'sio',16.667,1),(117,7426323,7426315,'ion',16.667,1),(117,7426324,7426318,'810',50,1),(117,7426325,7426318,'100',50,1),(117,7426326,7426324,'scs',50,1),(117,7426327,7426324,'csi',50,1),(117,7426328,7426326,'lev',33.333,1),(117,7426329,7426326,'eve',33.333,1),(117,7426330,7426326,'vel',33.333,1),(117,7426331,7426328,'pse',25,1),(117,7426332,7426328,'seu',25,1),(117,7426333,7426328,'eud',25,1),(117,7426334,7426328,'udo',25,1),(117,7426335,7426331,'fal',33.333,6),(117,7426336,7426331,'als',33.333,6),(117,7426337,7426331,'lse',33.333,6),(117,7426338,7426335,'sta',25,3),(117,7426339,7426335,'tat',25,3),(117,7426340,7426335,'atu',25,3),(117,7426341,7426335,'tus',25,3),(117,7426342,7426338,'rdm',100,1),(117,7426343,7426342,'cap',20,1),(117,7426344,7426342,'apa',20,1),(117,7426345,7426342,'pab',20,1),(117,7426346,7426342,'abl',20,1),(117,7426347,7426342,'ble',20,1),(117,7426348,7426343,'tru',50,1),(117,7426349,7426343,'rue',50,1),(117,7426350,7426348,'loc',33.333,1),(117,7426351,7426348,'oca',33.333,1),(117,7426352,7426348,'cal',33.333,1),(117,7426353,7426350,'rem',14.286,1),(117,7426354,7426350,'emo',14.286,1),(117,7426355,7426350,'mov',14.286,1),(117,7426356,7426350,'ova',14.286,1),(117,7426357,7426350,'vab',14.286,1),(117,7426358,7426350,'abl',14.286,1),(117,7426359,7426350,'ble',14.286,1),(117,7426360,7426353,'ssd',100,1),(117,7426361,7426360,'off',20,1),(117,7426362,7426360,'ffl',20,1),(117,7426363,7426360,'fli',20,1),(117,7426364,7426360,'lin',20,1),(117,7426365,7426360,'ine',20,1),(117,7426366,7426361,'per',11.111,1),(117,7426367,7426361,'ere',11.111,1),(117,7426368,7426361,'ren',11.111,1),(117,7426369,7426361,'enn',11.111,1),(117,7426370,7426361,'nni',11.111,1),(117,7426371,7426361,'nia',11.111,1),(117,7426372,7426361,'ial',11.111,1),(117,7426373,7426361,'all',11.111,1),(117,7426374,7426361,'lly',11.111,1),(117,7426375,7426366,'res',16.667,1),(117,7426376,7426366,'ese',16.667,1),(117,7426377,7426366,'ser',16.667,1),(117,7426378,7426366,'erv',16.667,1),(117,7426379,7426366,'rve',16.667,1),(117,7426380,7426366,'ved',16.667,1),(117,7426381,7426375,'thi',50,1),(117,7426382,7426375,'hin',50,1),(117,7426383,7426381,'pro',10,1),(117,7426384,7426381,'rov',10,1),(117,7426385,7426381,'ovi',10,1),(117,7426386,7426381,'vis',10,1),(117,7426387,7426381,'isi',10,1),(117,7426388,7426381,'sio',10,1),(117,7426389,7426381,'ion',10,1),(117,7426390,7426381,'oni',10,1),(117,7426391,7426381,'nin',10,1),(117,7426392,7426381,'ing',10,1),(117,7426393,7426383,'yes',100,1),(117,7426394,7426393,'att',16.667,1),(117,7426395,7426393,'tta',16.667,1),(117,7426396,7426393,'tac',16.667,1),(117,7426397,7426393,'ach',16.667,1),(117,7426398,7426393,'che',16.667,1),(117,7426399,7426393,'hed',16.667,1),(117,7426400,7426394,'fil',20,1),(117,7426401,7426394,'ilt',20,1),(117,7426402,7426394,'lte',20,1),(117,7426403,7426394,'ter',20,1),(117,7426404,7426394,'ers',20,1),(117,7426405,7426400,'vaa',50,1),(117,7426406,7426400,'aai',50,1),(117,7426407,7426405,'unk',20,1),(117,7426408,7426405,'nkn',20,1),(117,7426409,7426405,'kno',20,1),(117,7426410,7426405,'now',20,1),(117,7426411,7426405,'own',20,1),(117,7426412,7426407,'oth',33.333,1),(117,7426413,7426407,'the',33.333,1),(117,7426414,7426407,'her',33.333,1),(117,7426415,7426412,'uid',50,1),(117,7426416,7426412,'ids',50,1),(117,7426417,7426415,'vml',100,1),(117,7426418,7426417,'dis',20,1),(117,7426419,7426417,'isp',20,1),(117,7426420,7426417,'spl',20,1),(117,7426421,7426417,'pla',20,1),(117,7426422,7426417,'lay',20,1),(117,7426423,7426418,'nam',50,1),(117,7426424,7426418,'ame',50,1),(118,7426426,7426425,'net',25,3),(118,7426427,7426425,'eta',25,3),(118,7426428,7426425,'tap',25,3),(118,7426429,7426425,'app',25,3),(118,7426430,7426426,'fib',33.333,2),(118,7426431,7426426,'ibr',33.333,2),(118,7426432,7426426,'bre',33.333,2),(118,7426433,7426430,'cha',20,2),(118,7426434,7426430,'han',20,2),(118,7426435,7426430,'ann',20,2),(118,7426436,7426430,'nne',20,2),(118,7426437,7426430,'nel',20,2),(118,7426438,7426433,'dis',50,2),(118,7426439,7426433,'isk',50,2),(118,7426440,7426438,'naa',100,4),(118,7426441,7426440,'600',3.333,4),(118,7426442,7426440,'00a',3.333,4),(118,7426443,7426440,'0a0',3.333,4),(118,7426444,7426440,'a09',3.333,4),(118,7426445,7426440,'098',3.333,4),(118,7426446,7426440,'980',3.333,4),(118,7426447,7426440,'804',3.333,4),(118,7426448,7426440,'044',3.333,4),(118,7426449,7426440,'443',3.333,4),(118,7426450,7426440,'430',3.333,4),(118,7426451,7426440,'307',3.333,4),(118,7426452,7426440,'072',3.333,4),(118,7426453,7426440,'725',3.333,4),(118,7426454,7426440,'259',3.333,4),(118,7426455,7426440,'593',3.333,4),(118,7426456,7426440,'931',3.333,4),(118,7426457,7426440,'313',3.333,4),(118,7426458,7426440,'13f',3.333,4),(118,7426459,7426440,'3f3',3.333,4),(118,7426460,7426440,'f33',3.333,4),(118,7426461,7426440,'334',3.333,4),(118,7426462,7426440,'345',3.333,4),(118,7426463,7426440,'455',3.333,4),(118,7426464,7426440,'556',3.333,4),(118,7426465,7426440,'563',3.333,4),(118,7426466,7426440,'639',3.333,4),(118,7426467,7426440,'393',3.333,4),(118,7426468,7426440,'934',3.333,4),(118,7426469,7426440,'344',3.333,4),(118,7426470,7426440,'44e',3.333,4),(118,7426471,7426441,'ser',25,1),(118,7426472,7426441,'eri',25,1),(118,7426473,7426441,'ria',25,1),(118,7426474,7426441,'ial',25,1),(118,7426475,7426471,'siz',50,1),(118,7426476,7426471,'ize',50,1),(118,7426477,7426475,'321',100,1),(118,7426478,7426477,'dev',25,1),(118,7426479,7426477,'evi',25,1),(118,7426480,7426477,'vic',25,1),(118,7426481,7426477,'ice',25,1),(118,7426482,7426478,'typ',50,1),(118,7426483,7426478,'ype',50,1),(118,7426484,7426482,'dir',10,1),(118,7426485,7426482,'ire',10,1),(118,7426486,7426482,'rec',10,1),(118,7426487,7426482,'ect',10,1),(118,7426488,7426482,'cta',10,1),(118,7426489,7426482,'tac',10,1),(118,7426490,7426482,'acc',10,1),(118,7426491,7426482,'cce',10,1),(118,7426492,7426482,'ces',10,1),(118,7426493,7426482,'ess',10,1),(118,7426494,7426484,'mul',14.286,1),(118,7426495,7426484,'ult',14.286,1),(118,7426496,7426484,'lti',14.286,1),(118,7426497,7426484,'tip',14.286,1),(118,7426498,7426484,'ipa',14.286,1),(118,7426499,7426484,'pat',14.286,1),(118,7426500,7426484,'ath',14.286,1),(118,7426501,7426494,'plu',25,1),(118,7426502,7426494,'lug',25,1),(118,7426503,7426494,'ugi',25,1),(118,7426504,7426494,'gin',25,1),(118,7426505,7426501,'nmp',100,1),(118,7426506,7426505,'dev',33.333,1),(118,7426507,7426505,'evf',33.333,1),(118,7426508,7426505,'vfs',33.333,1),(118,7426509,7426506,'pat',50,1),(118,7426510,7426506,'ath',50,1),(118,7426511,7426509,'vmf',50,1),(118,7426512,7426509,'mfs',50,1),(118,7426513,7426511,'dev',20,1),(118,7426514,7426511,'evi',20,1),(118,7426515,7426511,'vic',20,1),(118,7426516,7426511,'ice',20,1),(118,7426517,7426511,'ces',20,1),(118,7426518,7426513,'dis',33.333,1),(118,7426519,7426513,'isk',33.333,1),(118,7426520,7426513,'sks',33.333,1),(118,7426521,7426518,'ven',25,1),(118,7426522,7426518,'end',25,1),(118,7426523,7426518,'ndo',25,1),(118,7426524,7426518,'dor',25,1),(118,7426525,7426521,'mod',33.333,1),(118,7426526,7426521,'ode',33.333,1),(118,7426527,7426521,'del',33.333,1),(118,7426528,7426525,'lun',100,1),(118,7426529,7426528,'cmo',33.333,1),(118,7426530,7426528,'mod',33.333,1),(118,7426531,7426528,'ode',33.333,1),(118,7426532,7426529,'rev',16.667,1),(118,7426533,7426529,'evi',16.667,1),(118,7426534,7426529,'vis',16.667,1),(118,7426535,7426529,'isi',16.667,1),(118,7426536,7426529,'sio',16.667,1),(118,7426537,7426529,'ion',16.667,1),(118,7426538,7426532,'810',50,1),(118,7426539,7426532,'100',50,1),(118,7426540,7426538,'scs',50,1),(118,7426541,7426538,'csi',50,1),(118,7426542,7426540,'lev',33.333,1),(118,7426543,7426540,'eve',33.333,1),(118,7426544,7426540,'vel',33.333,1),(118,7426545,7426542,'pse',25,1),(118,7426546,7426542,'seu',25,1),(118,7426547,7426542,'eud',25,1),(118,7426548,7426542,'udo',25,1),(118,7426549,7426545,'fal',33.333,6),(118,7426550,7426545,'als',33.333,6),(118,7426551,7426545,'lse',33.333,6),(118,7426552,7426549,'sta',25,3),(118,7426553,7426549,'tat',25,3),(118,7426554,7426549,'atu',25,3),(118,7426555,7426549,'tus',25,3),(118,7426556,7426552,'rdm',100,1),(118,7426557,7426556,'cap',20,1),(118,7426558,7426556,'apa',20,1),(118,7426559,7426556,'pab',20,1),(118,7426560,7426556,'abl',20,1),(118,7426561,7426556,'ble',20,1),(118,7426562,7426557,'tru',50,1),(118,7426563,7426557,'rue',50,1),(118,7426564,7426562,'loc',33.333,1),(118,7426565,7426562,'oca',33.333,1),(118,7426566,7426562,'cal',33.333,1),(118,7426567,7426564,'rem',14.286,1),(118,7426568,7426564,'emo',14.286,1),(118,7426569,7426564,'mov',14.286,1),(118,7426570,7426564,'ova',14.286,1),(118,7426571,7426564,'vab',14.286,1),(118,7426572,7426564,'abl',14.286,1),(118,7426573,7426564,'ble',14.286,1),(118,7426574,7426567,'ssd',100,1),(118,7426575,7426574,'off',20,1),(118,7426576,7426574,'ffl',20,1),(118,7426577,7426574,'fli',20,1),(118,7426578,7426574,'lin',20,1),(118,7426579,7426574,'ine',20,1),(118,7426580,7426575,'per',11.111,1),(118,7426581,7426575,'ere',11.111,1),(118,7426582,7426575,'ren',11.111,1),(118,7426583,7426575,'enn',11.111,1),(118,7426584,7426575,'nni',11.111,1),(118,7426585,7426575,'nia',11.111,1),(118,7426586,7426575,'ial',11.111,1),(118,7426587,7426575,'all',11.111,1),(118,7426588,7426575,'lly',11.111,1),(118,7426589,7426580,'res',16.667,1),(118,7426590,7426580,'ese',16.667,1),(118,7426591,7426580,'ser',16.667,1),(118,7426592,7426580,'erv',16.667,1),(118,7426593,7426580,'rve',16.667,1),(118,7426594,7426580,'ved',16.667,1),(118,7426595,7426589,'thi',50,1),(118,7426596,7426589,'hin',50,1),(118,7426597,7426595,'pro',10,1),(118,7426598,7426595,'rov',10,1),(118,7426599,7426595,'ovi',10,1),(118,7426600,7426595,'vis',10,1),(118,7426601,7426595,'isi',10,1),(118,7426602,7426595,'sio',10,1),(118,7426603,7426595,'ion',10,1),(118,7426604,7426595,'oni',10,1),(118,7426605,7426595,'nin',10,1),(118,7426606,7426595,'ing',10,1),(118,7426607,7426597,'yes',100,1),(118,7426608,7426607,'att',16.667,1),(118,7426609,7426607,'tta',16.667,1),(118,7426610,7426607,'tac',16.667,1),(118,7426611,7426607,'ach',16.667,1),(118,7426612,7426607,'che',16.667,1),(118,7426613,7426607,'hed',16.667,1),(118,7426614,7426608,'fil',20,1),(118,7426615,7426608,'ilt',20,1),(118,7426616,7426608,'lte',20,1),(118,7426617,7426608,'ter',20,1),(118,7426618,7426608,'ers',20,1),(118,7426619,7426614,'vaa',50,1),(118,7426620,7426614,'aai',50,1),(118,7426621,7426619,'unk',20,1),(118,7426622,7426619,'nkn',20,1),(118,7426623,7426619,'kno',20,1),(118,7426624,7426619,'now',20,1),(118,7426625,7426619,'own',20,1),(118,7426626,7426621,'oth',33.333,1),(118,7426627,7426621,'the',33.333,1),(118,7426628,7426621,'her',33.333,1),(118,7426629,7426626,'uid',50,1),(118,7426630,7426626,'ids',50,1),(118,7426631,7426629,'vml',100,1),(118,7426632,7426631,'dis',20,1),(118,7426633,7426631,'isp',20,1),(118,7426634,7426631,'spl',20,1),(118,7426635,7426631,'pla',20,1),(118,7426636,7426631,'lay',20,1),(118,7426637,7426632,'nam',50,1),(118,7426638,7426632,'ame',50,1),(119,7426640,7426639,'net',25,3),(119,7426641,7426639,'eta',25,3),(119,7426642,7426639,'tap',25,3),(119,7426643,7426639,'app',25,3),(119,7426644,7426640,'fib',33.333,2),(119,7426645,7426640,'ibr',33.333,2),(119,7426646,7426640,'bre',33.333,2),(119,7426647,7426644,'cha',20,2),(119,7426648,7426644,'han',20,2),(119,7426649,7426644,'ann',20,2),(119,7426650,7426644,'nne',20,2),(119,7426651,7426644,'nel',20,2),(119,7426652,7426647,'dis',50,2),(119,7426653,7426647,'isk',50,2),(119,7426654,7426652,'naa',100,4),(119,7426655,7426654,'600',3.333,4),(119,7426656,7426654,'00a',3.333,4),(119,7426657,7426654,'0a0',3.333,4),(119,7426658,7426654,'a09',3.333,4),(119,7426659,7426654,'098',3.333,4),(119,7426660,7426654,'980',3.333,4),(119,7426661,7426654,'804',3.333,4),(119,7426662,7426654,'044',3.333,4),(119,7426663,7426654,'443',3.333,4),(119,7426664,7426654,'430',3.333,4),(119,7426665,7426654,'307',3.333,4),(119,7426666,7426654,'072',3.333,4),(119,7426667,7426654,'725',3.333,4),(119,7426668,7426654,'259',3.333,4),(119,7426669,7426654,'593',3.333,4),(119,7426670,7426654,'931',3.333,4),(119,7426671,7426654,'313',3.333,4),(119,7426672,7426654,'13f',3.333,4),(119,7426673,7426654,'3f3',3.333,4),(119,7426674,7426654,'f33',3.333,4),(119,7426675,7426654,'334',3.333,4),(119,7426676,7426654,'345',3.333,4),(119,7426677,7426654,'455',3.333,4),(119,7426678,7426654,'556',3.333,4),(119,7426679,7426654,'563',3.333,4),(119,7426680,7426654,'639',3.333,4),(119,7426681,7426654,'393',3.333,4),(119,7426682,7426654,'934',3.333,4),(119,7426683,7426654,'344',3.333,4),(119,7426684,7426654,'44f',3.333,4),(119,7426685,7426655,'ser',25,1),(119,7426686,7426655,'eri',25,1),(119,7426687,7426655,'ria',25,1),(119,7426688,7426655,'ial',25,1),(119,7426689,7426685,'siz',50,1),(119,7426690,7426685,'ize',50,1),(119,7426691,7426689,'321',100,1),(119,7426692,7426691,'dev',25,1),(119,7426693,7426691,'evi',25,1),(119,7426694,7426691,'vic',25,1),(119,7426695,7426691,'ice',25,1),(119,7426696,7426692,'typ',50,1),(119,7426697,7426692,'ype',50,1),(119,7426698,7426696,'dir',10,1),(119,7426699,7426696,'ire',10,1),(119,7426700,7426696,'rec',10,1),(119,7426701,7426696,'ect',10,1),(119,7426702,7426696,'cta',10,1),(119,7426703,7426696,'tac',10,1),(119,7426704,7426696,'acc',10,1),(119,7426705,7426696,'cce',10,1),(119,7426706,7426696,'ces',10,1),(119,7426707,7426696,'ess',10,1),(119,7426708,7426698,'mul',14.286,1),(119,7426709,7426698,'ult',14.286,1),(119,7426710,7426698,'lti',14.286,1),(119,7426711,7426698,'tip',14.286,1),(119,7426712,7426698,'ipa',14.286,1),(119,7426713,7426698,'pat',14.286,1),(119,7426714,7426698,'ath',14.286,1),(119,7426715,7426708,'plu',25,1),(119,7426716,7426708,'lug',25,1),(119,7426717,7426708,'ugi',25,1),(119,7426718,7426708,'gin',25,1),(119,7426719,7426715,'nmp',100,1),(119,7426720,7426719,'dev',33.333,1),(119,7426721,7426719,'evf',33.333,1),(119,7426722,7426719,'vfs',33.333,1),(119,7426723,7426720,'pat',50,1),(119,7426724,7426720,'ath',50,1),(119,7426725,7426723,'vmf',50,1),(119,7426726,7426723,'mfs',50,1),(119,7426727,7426725,'dev',20,1),(119,7426728,7426725,'evi',20,1),(119,7426729,7426725,'vic',20,1),(119,7426730,7426725,'ice',20,1),(119,7426731,7426725,'ces',20,1),(119,7426732,7426727,'dis',33.333,1),(119,7426733,7426727,'isk',33.333,1),(119,7426734,7426727,'sks',33.333,1),(119,7426735,7426732,'ven',25,1),(119,7426736,7426732,'end',25,1),(119,7426737,7426732,'ndo',25,1),(119,7426738,7426732,'dor',25,1),(119,7426739,7426735,'mod',33.333,1),(119,7426740,7426735,'ode',33.333,1),(119,7426741,7426735,'del',33.333,1),(119,7426742,7426739,'lun',100,1),(119,7426743,7426742,'cmo',33.333,1),(119,7426744,7426742,'mod',33.333,1),(119,7426745,7426742,'ode',33.333,1),(119,7426746,7426743,'rev',16.667,1),(119,7426747,7426743,'evi',16.667,1),(119,7426748,7426743,'vis',16.667,1),(119,7426749,7426743,'isi',16.667,1),(119,7426750,7426743,'sio',16.667,1),(119,7426751,7426743,'ion',16.667,1),(119,7426752,7426746,'810',50,1),(119,7426753,7426746,'100',50,1),(119,7426754,7426752,'scs',50,1),(119,7426755,7426752,'csi',50,1),(119,7426756,7426754,'lev',33.333,1),(119,7426757,7426754,'eve',33.333,1),(119,7426758,7426754,'vel',33.333,1),(119,7426759,7426756,'pse',25,1),(119,7426760,7426756,'seu',25,1),(119,7426761,7426756,'eud',25,1),(119,7426762,7426756,'udo',25,1),(119,7426763,7426759,'fal',33.333,6),(119,7426764,7426759,'als',33.333,6),(119,7426765,7426759,'lse',33.333,6),(119,7426766,7426763,'sta',25,3),(119,7426767,7426763,'tat',25,3),(119,7426768,7426763,'atu',25,3),(119,7426769,7426763,'tus',25,3),(119,7426770,7426766,'rdm',100,1),(119,7426771,7426770,'cap',20,1),(119,7426772,7426770,'apa',20,1),(119,7426773,7426770,'pab',20,1),(119,7426774,7426770,'abl',20,1),(119,7426775,7426770,'ble',20,1),(119,7426776,7426771,'tru',50,1),(119,7426777,7426771,'rue',50,1),(119,7426778,7426776,'loc',33.333,1),(119,7426779,7426776,'oca',33.333,1),(119,7426780,7426776,'cal',33.333,1),(119,7426781,7426778,'rem',14.286,1),(119,7426782,7426778,'emo',14.286,1),(119,7426783,7426778,'mov',14.286,1),(119,7426784,7426778,'ova',14.286,1),(119,7426785,7426778,'vab',14.286,1),(119,7426786,7426778,'abl',14.286,1),(119,7426787,7426778,'ble',14.286,1),(119,7426788,7426781,'ssd',100,1),(119,7426789,7426788,'off',20,1),(119,7426790,7426788,'ffl',20,1),(119,7426791,7426788,'fli',20,1),(119,7426792,7426788,'lin',20,1),(119,7426793,7426788,'ine',20,1),(119,7426794,7426789,'per',11.111,1),(119,7426795,7426789,'ere',11.111,1),(119,7426796,7426789,'ren',11.111,1),(119,7426797,7426789,'enn',11.111,1),(119,7426798,7426789,'nni',11.111,1),(119,7426799,7426789,'nia',11.111,1),(119,7426800,7426789,'ial',11.111,1),(119,7426801,7426789,'all',11.111,1),(119,7426802,7426789,'lly',11.111,1),(119,7426803,7426794,'res',16.667,1),(119,7426804,7426794,'ese',16.667,1),(119,7426805,7426794,'ser',16.667,1),(119,7426806,7426794,'erv',16.667,1),(119,7426807,7426794,'rve',16.667,1),(119,7426808,7426794,'ved',16.667,1),(119,7426809,7426803,'thi',50,1),(119,7426810,7426803,'hin',50,1),(119,7426811,7426809,'pro',10,1),(119,7426812,7426809,'rov',10,1),(119,7426813,7426809,'ovi',10,1),(119,7426814,7426809,'vis',10,1),(119,7426815,7426809,'isi',10,1),(119,7426816,7426809,'sio',10,1),(119,7426817,7426809,'ion',10,1),(119,7426818,7426809,'oni',10,1),(119,7426819,7426809,'nin',10,1),(119,7426820,7426809,'ing',10,1),(119,7426821,7426811,'yes',100,1),(119,7426822,7426821,'att',16.667,1),(119,7426823,7426821,'tta',16.667,1),(119,7426824,7426821,'tac',16.667,1),(119,7426825,7426821,'ach',16.667,1),(119,7426826,7426821,'che',16.667,1),(119,7426827,7426821,'hed',16.667,1),(119,7426828,7426822,'fil',20,1),(119,7426829,7426822,'ilt',20,1),(119,7426830,7426822,'lte',20,1),(119,7426831,7426822,'ter',20,1),(119,7426832,7426822,'ers',20,1),(119,7426833,7426828,'vaa',50,1),(119,7426834,7426828,'aai',50,1),(119,7426835,7426833,'unk',20,1),(119,7426836,7426833,'nkn',20,1),(119,7426837,7426833,'kno',20,1),(119,7426838,7426833,'now',20,1),(119,7426839,7426833,'own',20,1),(119,7426840,7426835,'oth',33.333,1),(119,7426841,7426835,'the',33.333,1),(119,7426842,7426835,'her',33.333,1),(119,7426843,7426840,'uid',50,1),(119,7426844,7426840,'ids',50,1),(119,7426845,7426843,'vml',100,1),(119,7426846,7426845,'dis',20,1),(119,7426847,7426845,'isp',20,1),(119,7426848,7426845,'spl',20,1),(119,7426849,7426845,'pla',20,1),(119,7426850,7426845,'lay',20,1),(119,7426851,7426846,'nam',50,1),(119,7426852,7426846,'ame',50,1),(120,7426854,7426853,'net',25,3),(120,7426855,7426853,'eta',25,3),(120,7426856,7426853,'tap',25,3),(120,7426857,7426853,'app',25,3),(120,7426858,7426854,'fib',33.333,2),(120,7426859,7426854,'ibr',33.333,2),(120,7426860,7426854,'bre',33.333,2),(120,7426861,7426858,'cha',20,2),(120,7426862,7426858,'han',20,2),(120,7426863,7426858,'ann',20,2),(120,7426864,7426858,'nne',20,2),(120,7426865,7426858,'nel',20,2),(120,7426866,7426861,'dis',50,2),(120,7426867,7426861,'isk',50,2),(120,7426868,7426866,'naa',100,4),(120,7426869,7426868,'600',3.333,4),(120,7426870,7426868,'00a',3.333,4),(120,7426871,7426868,'0a0',3.333,4),(120,7426872,7426868,'a09',3.333,4),(120,7426873,7426868,'098',3.333,4),(120,7426874,7426868,'980',3.333,4),(120,7426875,7426868,'804',3.333,4),(120,7426876,7426868,'044',3.333,4),(120,7426877,7426868,'443',3.333,4),(120,7426878,7426868,'430',3.333,4),(120,7426879,7426868,'307',3.333,4),(120,7426880,7426868,'072',3.333,4),(120,7426881,7426868,'725',3.333,4),(120,7426882,7426868,'259',3.333,4),(120,7426883,7426868,'593',3.333,4),(120,7426884,7426868,'931',3.333,4),(120,7426885,7426868,'313',3.333,4),(120,7426886,7426868,'13f',3.333,4),(120,7426887,7426868,'3f3',3.333,4),(120,7426888,7426868,'f33',3.333,4),(120,7426889,7426868,'334',3.333,4),(120,7426890,7426868,'345',3.333,4),(120,7426891,7426868,'455',3.333,4),(120,7426892,7426868,'556',3.333,4),(120,7426893,7426868,'563',3.333,4),(120,7426894,7426868,'638',3.333,4),(120,7426895,7426868,'387',3.333,4),(120,7426896,7426868,'872',3.333,4),(120,7426897,7426868,'724',3.333,4),(120,7426898,7426868,'24a',3.333,4),(120,7426899,7426869,'ser',25,1),(120,7426900,7426869,'eri',25,1),(120,7426901,7426869,'ria',25,1),(120,7426902,7426869,'ial',25,1),(120,7426903,7426899,'siz',50,1),(120,7426904,7426899,'ize',50,1),(120,7426905,7426903,'460',33.333,1),(120,7426906,7426903,'608',33.333,1),(120,7426907,7426903,'080',33.333,1),(120,7426908,7426905,'dev',25,1),(120,7426909,7426905,'evi',25,1),(120,7426910,7426905,'vic',25,1),(120,7426911,7426905,'ice',25,1),(120,7426912,7426908,'typ',50,1),(120,7426913,7426908,'ype',50,1),(120,7426914,7426912,'dir',10,1),(120,7426915,7426912,'ire',10,1),(120,7426916,7426912,'rec',10,1),(120,7426917,7426912,'ect',10,1),(120,7426918,7426912,'cta',10,1),(120,7426919,7426912,'tac',10,1),(120,7426920,7426912,'acc',10,1),(120,7426921,7426912,'cce',10,1),(120,7426922,7426912,'ces',10,1),(120,7426923,7426912,'ess',10,1),(120,7426924,7426914,'mul',14.286,1),(120,7426925,7426914,'ult',14.286,1),(120,7426926,7426914,'lti',14.286,1),(120,7426927,7426914,'tip',14.286,1),(120,7426928,7426914,'ipa',14.286,1),(120,7426929,7426914,'pat',14.286,1),(120,7426930,7426914,'ath',14.286,1),(120,7426931,7426924,'plu',25,1),(120,7426932,7426924,'lug',25,1),(120,7426933,7426924,'ugi',25,1),(120,7426934,7426924,'gin',25,1),(120,7426935,7426931,'nmp',100,1),(120,7426936,7426935,'dev',33.333,1),(120,7426937,7426935,'evf',33.333,1),(120,7426938,7426935,'vfs',33.333,1),(120,7426939,7426936,'pat',50,1),(120,7426940,7426936,'ath',50,1),(120,7426941,7426939,'vmf',50,1),(120,7426942,7426939,'mfs',50,1),(120,7426943,7426941,'dev',20,1),(120,7426944,7426941,'evi',20,1),(120,7426945,7426941,'vic',20,1),(120,7426946,7426941,'ice',20,1),(120,7426947,7426941,'ces',20,1),(120,7426948,7426943,'dis',33.333,1),(120,7426949,7426943,'isk',33.333,1),(120,7426950,7426943,'sks',33.333,1),(120,7426951,7426948,'ven',25,1),(120,7426952,7426948,'end',25,1),(120,7426953,7426948,'ndo',25,1),(120,7426954,7426948,'dor',25,1),(120,7426955,7426951,'mod',33.333,1),(120,7426956,7426951,'ode',33.333,1),(120,7426957,7426951,'del',33.333,1),(120,7426958,7426955,'lun',100,1),(120,7426959,7426958,'cmo',33.333,1),(120,7426960,7426958,'mod',33.333,1),(120,7426961,7426958,'ode',33.333,1),(120,7426962,7426959,'rev',16.667,1),(120,7426963,7426959,'evi',16.667,1),(120,7426964,7426959,'vis',16.667,1),(120,7426965,7426959,'isi',16.667,1),(120,7426966,7426959,'sio',16.667,1),(120,7426967,7426959,'ion',16.667,1),(120,7426968,7426962,'810',50,1),(120,7426969,7426962,'100',50,1),(120,7426970,7426968,'scs',50,1),(120,7426971,7426968,'csi',50,1),(120,7426972,7426970,'lev',33.333,1),(120,7426973,7426970,'eve',33.333,1),(120,7426974,7426970,'vel',33.333,1),(120,7426975,7426972,'pse',25,1),(120,7426976,7426972,'seu',25,1),(120,7426977,7426972,'eud',25,1),(120,7426978,7426972,'udo',25,1),(120,7426979,7426975,'fal',33.333,6),(120,7426980,7426975,'als',33.333,6),(120,7426981,7426975,'lse',33.333,6),(120,7426982,7426979,'sta',25,3),(120,7426983,7426979,'tat',25,3),(120,7426984,7426979,'atu',25,3),(120,7426985,7426979,'tus',25,3),(120,7426986,7426982,'rdm',100,1),(120,7426987,7426986,'cap',20,1),(120,7426988,7426986,'apa',20,1),(120,7426989,7426986,'pab',20,1),(120,7426990,7426986,'abl',20,1),(120,7426991,7426986,'ble',20,1),(120,7426992,7426987,'tru',50,1),(120,7426993,7426987,'rue',50,1),(120,7426994,7426992,'loc',33.333,1),(120,7426995,7426992,'oca',33.333,1),(120,7426996,7426992,'cal',33.333,1),(120,7426997,7426994,'rem',14.286,1),(120,7426998,7426994,'emo',14.286,1),(120,7426999,7426994,'mov',14.286,1),(120,7427000,7426994,'ova',14.286,1),(120,7427001,7426994,'vab',14.286,1),(120,7427002,7426994,'abl',14.286,1),(120,7427003,7426994,'ble',14.286,1),(120,7427004,7426997,'ssd',100,1),(120,7427005,7427004,'off',20,1),(120,7427006,7427004,'ffl',20,1),(120,7427007,7427004,'fli',20,1),(120,7427008,7427004,'lin',20,1),(120,7427009,7427004,'ine',20,1),(120,7427010,7427005,'per',11.111,1),(120,7427011,7427005,'ere',11.111,1),(120,7427012,7427005,'ren',11.111,1),(120,7427013,7427005,'enn',11.111,1),(120,7427014,7427005,'nni',11.111,1),(120,7427015,7427005,'nia',11.111,1),(120,7427016,7427005,'ial',11.111,1),(120,7427017,7427005,'all',11.111,1),(120,7427018,7427005,'lly',11.111,1),(120,7427019,7427010,'res',16.667,1),(120,7427020,7427010,'ese',16.667,1),(120,7427021,7427010,'ser',16.667,1),(120,7427022,7427010,'erv',16.667,1),(120,7427023,7427010,'rve',16.667,1),(120,7427024,7427010,'ved',16.667,1),(120,7427025,7427019,'thi',50,1),(120,7427026,7427019,'hin',50,1),(120,7427027,7427025,'pro',10,1),(120,7427028,7427025,'rov',10,1),(120,7427029,7427025,'ovi',10,1),(120,7427030,7427025,'vis',10,1),(120,7427031,7427025,'isi',10,1),(120,7427032,7427025,'sio',10,1),(120,7427033,7427025,'ion',10,1),(120,7427034,7427025,'oni',10,1),(120,7427035,7427025,'nin',10,1),(120,7427036,7427025,'ing',10,1),(120,7427037,7427027,'yes',100,1),(120,7427038,7427037,'att',16.667,1),(120,7427039,7427037,'tta',16.667,1),(120,7427040,7427037,'tac',16.667,1),(120,7427041,7427037,'ach',16.667,1),(120,7427042,7427037,'che',16.667,1),(120,7427043,7427037,'hed',16.667,1),(120,7427044,7427038,'fil',20,1),(120,7427045,7427038,'ilt',20,1),(120,7427046,7427038,'lte',20,1),(120,7427047,7427038,'ter',20,1),(120,7427048,7427038,'ers',20,1),(120,7427049,7427044,'vaa',50,1),(120,7427050,7427044,'aai',50,1),(120,7427051,7427049,'unk',20,1),(120,7427052,7427049,'nkn',20,1),(120,7427053,7427049,'kno',20,1),(120,7427054,7427049,'now',20,1),(120,7427055,7427049,'own',20,1),(120,7427056,7427051,'oth',33.333,1),(120,7427057,7427051,'the',33.333,1),(120,7427058,7427051,'her',33.333,1),(120,7427059,7427056,'uid',50,1),(120,7427060,7427056,'ids',50,1),(120,7427061,7427059,'vml',100,1),(120,7427062,7427061,'dis',20,1),(120,7427063,7427061,'isp',20,1),(120,7427064,7427061,'spl',20,1),(120,7427065,7427061,'pla',20,1),(120,7427066,7427061,'lay',20,1),(120,7427067,7427062,'nam',50,1),(120,7427068,7427062,'ame',50,1),(121,7427070,7427069,'net',25,3),(121,7427071,7427069,'eta',25,3),(121,7427072,7427069,'tap',25,3),(121,7427073,7427069,'app',25,3),(121,7427074,7427070,'fib',33.333,2),(121,7427075,7427070,'ibr',33.333,2),(121,7427076,7427070,'bre',33.333,2),(121,7427077,7427074,'cha',20,2),(121,7427078,7427074,'han',20,2),(121,7427079,7427074,'ann',20,2),(121,7427080,7427074,'nne',20,2),(121,7427081,7427074,'nel',20,2),(121,7427082,7427077,'dis',50,2),(121,7427083,7427077,'isk',50,2),(121,7427084,7427082,'naa',100,4),(121,7427085,7427084,'600',3.333,4),(121,7427086,7427084,'00a',3.333,4),(121,7427087,7427084,'0a0',3.333,4),(121,7427088,7427084,'a09',3.333,4),(121,7427089,7427084,'098',3.333,4),(121,7427090,7427084,'980',3.333,4),(121,7427091,7427084,'804',3.333,4),(121,7427092,7427084,'044',3.333,4),(121,7427093,7427084,'443',3.333,4),(121,7427094,7427084,'430',3.333,4),(121,7427095,7427084,'307',3.333,4),(121,7427096,7427084,'072',3.333,4),(121,7427097,7427084,'725',3.333,4),(121,7427098,7427084,'259',3.333,4),(121,7427099,7427084,'593',3.333,4),(121,7427100,7427084,'931',3.333,4),(121,7427101,7427084,'313',3.333,4),(121,7427102,7427084,'13f',3.333,4),(121,7427103,7427084,'3f3',3.333,4),(121,7427104,7427084,'f33',3.333,4),(121,7427105,7427084,'334',3.333,4),(121,7427106,7427084,'345',3.333,4),(121,7427107,7427084,'455',3.333,4),(121,7427108,7427084,'556',3.333,4),(121,7427109,7427084,'563',3.333,4),(121,7427110,7427084,'638',3.333,4),(121,7427111,7427084,'387',3.333,4),(121,7427112,7427084,'872',3.333,4),(121,7427113,7427084,'724',3.333,4),(121,7427114,7427084,'24b',3.333,4),(121,7427115,7427085,'ser',25,1),(121,7427116,7427085,'eri',25,1),(121,7427117,7427085,'ria',25,1),(121,7427118,7427085,'ial',25,1),(121,7427119,7427115,'siz',50,1),(121,7427120,7427115,'ize',50,1),(121,7427121,7427119,'460',33.333,1),(121,7427122,7427119,'608',33.333,1),(121,7427123,7427119,'080',33.333,1),(121,7427124,7427121,'dev',25,1),(121,7427125,7427121,'evi',25,1),(121,7427126,7427121,'vic',25,1),(121,7427127,7427121,'ice',25,1),(121,7427128,7427124,'typ',50,1),(121,7427129,7427124,'ype',50,1),(121,7427130,7427128,'dir',10,1),(121,7427131,7427128,'ire',10,1),(121,7427132,7427128,'rec',10,1),(121,7427133,7427128,'ect',10,1),(121,7427134,7427128,'cta',10,1),(121,7427135,7427128,'tac',10,1),(121,7427136,7427128,'acc',10,1),(121,7427137,7427128,'cce',10,1),(121,7427138,7427128,'ces',10,1),(121,7427139,7427128,'ess',10,1),(121,7427140,7427130,'mul',14.286,1),(121,7427141,7427130,'ult',14.286,1),(121,7427142,7427130,'lti',14.286,1),(121,7427143,7427130,'tip',14.286,1),(121,7427144,7427130,'ipa',14.286,1),(121,7427145,7427130,'pat',14.286,1),(121,7427146,7427130,'ath',14.286,1),(121,7427147,7427140,'plu',25,1),(121,7427148,7427140,'lug',25,1),(121,7427149,7427140,'ugi',25,1),(121,7427150,7427140,'gin',25,1),(121,7427151,7427147,'nmp',100,1),(121,7427152,7427151,'dev',33.333,1),(121,7427153,7427151,'evf',33.333,1),(121,7427154,7427151,'vfs',33.333,1),(121,7427155,7427152,'pat',50,1),(121,7427156,7427152,'ath',50,1),(121,7427157,7427155,'vmf',50,1),(121,7427158,7427155,'mfs',50,1),(121,7427159,7427157,'dev',20,1),(121,7427160,7427157,'evi',20,1),(121,7427161,7427157,'vic',20,1),(121,7427162,7427157,'ice',20,1),(121,7427163,7427157,'ces',20,1),(121,7427164,7427159,'dis',33.333,1),(121,7427165,7427159,'isk',33.333,1),(121,7427166,7427159,'sks',33.333,1),(121,7427167,7427164,'ven',25,1),(121,7427168,7427164,'end',25,1),(121,7427169,7427164,'ndo',25,1),(121,7427170,7427164,'dor',25,1),(121,7427171,7427167,'mod',33.333,1),(121,7427172,7427167,'ode',33.333,1),(121,7427173,7427167,'del',33.333,1),(121,7427174,7427171,'lun',100,1),(121,7427175,7427174,'cmo',33.333,1),(121,7427176,7427174,'mod',33.333,1),(121,7427177,7427174,'ode',33.333,1),(121,7427178,7427175,'rev',16.667,1),(121,7427179,7427175,'evi',16.667,1),(121,7427180,7427175,'vis',16.667,1),(121,7427181,7427175,'isi',16.667,1),(121,7427182,7427175,'sio',16.667,1),(121,7427183,7427175,'ion',16.667,1),(121,7427184,7427178,'810',50,1),(121,7427185,7427178,'100',50,1),(121,7427186,7427184,'scs',50,1),(121,7427187,7427184,'csi',50,1),(121,7427188,7427186,'lev',33.333,1),(121,7427189,7427186,'eve',33.333,1),(121,7427190,7427186,'vel',33.333,1),(121,7427191,7427188,'pse',25,1),(121,7427192,7427188,'seu',25,1),(121,7427193,7427188,'eud',25,1),(121,7427194,7427188,'udo',25,1),(121,7427195,7427191,'fal',33.333,6),(121,7427196,7427191,'als',33.333,6),(121,7427197,7427191,'lse',33.333,6),(121,7427198,7427195,'sta',25,3),(121,7427199,7427195,'tat',25,3),(121,7427200,7427195,'atu',25,3),(121,7427201,7427195,'tus',25,3),(121,7427202,7427198,'rdm',100,1),(121,7427203,7427202,'cap',20,1),(121,7427204,7427202,'apa',20,1),(121,7427205,7427202,'pab',20,1),(121,7427206,7427202,'abl',20,1),(121,7427207,7427202,'ble',20,1),(121,7427208,7427203,'tru',50,1),(121,7427209,7427203,'rue',50,1),(121,7427210,7427208,'loc',33.333,1),(121,7427211,7427208,'oca',33.333,1),(121,7427212,7427208,'cal',33.333,1),(121,7427213,7427210,'rem',14.286,1),(121,7427214,7427210,'emo',14.286,1),(121,7427215,7427210,'mov',14.286,1),(121,7427216,7427210,'ova',14.286,1),(121,7427217,7427210,'vab',14.286,1),(121,7427218,7427210,'abl',14.286,1),(121,7427219,7427210,'ble',14.286,1),(121,7427220,7427213,'ssd',100,1),(121,7427221,7427220,'off',20,1),(121,7427222,7427220,'ffl',20,1),(121,7427223,7427220,'fli',20,1),(121,7427224,7427220,'lin',20,1),(121,7427225,7427220,'ine',20,1),(121,7427226,7427221,'per',11.111,1),(121,7427227,7427221,'ere',11.111,1),(121,7427228,7427221,'ren',11.111,1),(121,7427229,7427221,'enn',11.111,1),(121,7427230,7427221,'nni',11.111,1),(121,7427231,7427221,'nia',11.111,1),(121,7427232,7427221,'ial',11.111,1),(121,7427233,7427221,'all',11.111,1),(121,7427234,7427221,'lly',11.111,1),(121,7427235,7427226,'res',16.667,1),(121,7427236,7427226,'ese',16.667,1),(121,7427237,7427226,'ser',16.667,1),(121,7427238,7427226,'erv',16.667,1),(121,7427239,7427226,'rve',16.667,1),(121,7427240,7427226,'ved',16.667,1),(121,7427241,7427235,'thi',50,1),(121,7427242,7427235,'hin',50,1),(121,7427243,7427241,'pro',10,1),(121,7427244,7427241,'rov',10,1),(121,7427245,7427241,'ovi',10,1),(121,7427246,7427241,'vis',10,1),(121,7427247,7427241,'isi',10,1),(121,7427248,7427241,'sio',10,1),(121,7427249,7427241,'ion',10,1),(121,7427250,7427241,'oni',10,1),(121,7427251,7427241,'nin',10,1),(121,7427252,7427241,'ing',10,1),(121,7427253,7427243,'yes',100,1),(121,7427254,7427253,'att',16.667,1),(121,7427255,7427253,'tta',16.667,1),(121,7427256,7427253,'tac',16.667,1),(121,7427257,7427253,'ach',16.667,1),(121,7427258,7427253,'che',16.667,1),(121,7427259,7427253,'hed',16.667,1),(121,7427260,7427254,'fil',20,1),(121,7427261,7427254,'ilt',20,1),(121,7427262,7427254,'lte',20,1),(121,7427263,7427254,'ter',20,1),(121,7427264,7427254,'ers',20,1),(121,7427265,7427260,'vaa',50,1),(121,7427266,7427260,'aai',50,1),(121,7427267,7427265,'unk',20,1),(121,7427268,7427265,'nkn',20,1),(121,7427269,7427265,'kno',20,1),(121,7427270,7427265,'now',20,1),(121,7427271,7427265,'own',20,1),(121,7427272,7427267,'oth',33.333,1),(121,7427273,7427267,'the',33.333,1),(121,7427274,7427267,'her',33.333,1),(121,7427275,7427272,'uid',50,1),(121,7427276,7427272,'ids',50,1),(121,7427277,7427275,'vml',100,1),(121,7427278,7427277,'dis',20,1),(121,7427279,7427277,'isp',20,1),(121,7427280,7427277,'spl',20,1),(121,7427281,7427277,'pla',20,1),(121,7427282,7427277,'lay',20,1),(121,7427283,7427278,'nam',50,1),(121,7427284,7427278,'ame',50,1),(122,7427286,7427285,'net',25,3),(122,7427287,7427285,'eta',25,3),(122,7427288,7427285,'tap',25,3),(122,7427289,7427285,'app',25,3),(122,7427290,7427286,'fib',33.333,2),(122,7427291,7427286,'ibr',33.333,2),(122,7427292,7427286,'bre',33.333,2),(122,7427293,7427290,'cha',20,2),(122,7427294,7427290,'han',20,2),(122,7427295,7427290,'ann',20,2),(122,7427296,7427290,'nne',20,2),(122,7427297,7427290,'nel',20,2),(122,7427298,7427293,'dis',50,2),(122,7427299,7427293,'isk',50,2),(122,7427300,7427298,'naa',100,4),(122,7427301,7427300,'600',3.333,4),(122,7427302,7427300,'00a',3.333,4),(122,7427303,7427300,'0a0',3.333,4),(122,7427304,7427300,'a09',3.333,4),(122,7427305,7427300,'098',3.333,4),(122,7427306,7427300,'980',3.333,4),(122,7427307,7427300,'804',3.333,4),(122,7427308,7427300,'044',3.333,4),(122,7427309,7427300,'443',3.333,4),(122,7427310,7427300,'430',3.333,4),(122,7427311,7427300,'307',3.333,4),(122,7427312,7427300,'072',3.333,4),(122,7427313,7427300,'725',3.333,4),(122,7427314,7427300,'259',3.333,4),(122,7427315,7427300,'593',3.333,4),(122,7427316,7427300,'931',3.333,4),(122,7427317,7427300,'313',3.333,4),(122,7427318,7427300,'13f',3.333,4),(122,7427319,7427300,'3f3',3.333,4),(122,7427320,7427300,'f33',3.333,4),(122,7427321,7427300,'334',3.333,4),(122,7427322,7427300,'345',3.333,4),(122,7427323,7427300,'455',3.333,4),(122,7427324,7427300,'556',3.333,4),(122,7427325,7427300,'563',3.333,4),(122,7427326,7427300,'638',3.333,4),(122,7427327,7427300,'387',3.333,4),(122,7427328,7427300,'872',3.333,4),(122,7427329,7427300,'724',3.333,4),(122,7427330,7427300,'24c',3.333,4),(122,7427331,7427301,'ser',25,1),(122,7427332,7427301,'eri',25,1),(122,7427333,7427301,'ria',25,1),(122,7427334,7427301,'ial',25,1),(122,7427335,7427331,'siz',50,1),(122,7427336,7427331,'ize',50,1),(122,7427337,7427335,'460',33.333,1),(122,7427338,7427335,'608',33.333,1),(122,7427339,7427335,'080',33.333,1),(122,7427340,7427337,'dev',25,1),(122,7427341,7427337,'evi',25,1),(122,7427342,7427337,'vic',25,1),(122,7427343,7427337,'ice',25,1),(122,7427344,7427340,'typ',50,1),(122,7427345,7427340,'ype',50,1),(122,7427346,7427344,'dir',10,1),(122,7427347,7427344,'ire',10,1),(122,7427348,7427344,'rec',10,1),(122,7427349,7427344,'ect',10,1),(122,7427350,7427344,'cta',10,1),(122,7427351,7427344,'tac',10,1),(122,7427352,7427344,'acc',10,1),(122,7427353,7427344,'cce',10,1),(122,7427354,7427344,'ces',10,1),(122,7427355,7427344,'ess',10,1),(122,7427356,7427346,'mul',14.286,1),(122,7427357,7427346,'ult',14.286,1),(122,7427358,7427346,'lti',14.286,1),(122,7427359,7427346,'tip',14.286,1),(122,7427360,7427346,'ipa',14.286,1),(122,7427361,7427346,'pat',14.286,1),(122,7427362,7427346,'ath',14.286,1),(122,7427363,7427356,'plu',25,1),(122,7427364,7427356,'lug',25,1),(122,7427365,7427356,'ugi',25,1),(122,7427366,7427356,'gin',25,1),(122,7427367,7427363,'nmp',100,1),(122,7427368,7427367,'dev',33.333,1),(122,7427369,7427367,'evf',33.333,1),(122,7427370,7427367,'vfs',33.333,1),(122,7427371,7427368,'pat',50,1),(122,7427372,7427368,'ath',50,1),(122,7427373,7427371,'vmf',50,1),(122,7427374,7427371,'mfs',50,1),(122,7427375,7427373,'dev',20,1),(122,7427376,7427373,'evi',20,1),(122,7427377,7427373,'vic',20,1),(122,7427378,7427373,'ice',20,1),(122,7427379,7427373,'ces',20,1),(122,7427380,7427375,'dis',33.333,1),(122,7427381,7427375,'isk',33.333,1),(122,7427382,7427375,'sks',33.333,1),(122,7427383,7427380,'ven',25,1),(122,7427384,7427380,'end',25,1),(122,7427385,7427380,'ndo',25,1),(122,7427386,7427380,'dor',25,1),(122,7427387,7427383,'mod',33.333,1),(122,7427388,7427383,'ode',33.333,1),(122,7427389,7427383,'del',33.333,1),(122,7427390,7427387,'lun',100,1),(122,7427391,7427390,'cmo',33.333,1),(122,7427392,7427390,'mod',33.333,1),(122,7427393,7427390,'ode',33.333,1),(122,7427394,7427391,'rev',16.667,1),(122,7427395,7427391,'evi',16.667,1),(122,7427396,7427391,'vis',16.667,1),(122,7427397,7427391,'isi',16.667,1),(122,7427398,7427391,'sio',16.667,1),(122,7427399,7427391,'ion',16.667,1),(122,7427400,7427394,'810',50,1),(122,7427401,7427394,'100',50,1),(122,7427402,7427400,'scs',50,1),(122,7427403,7427400,'csi',50,1),(122,7427404,7427402,'lev',33.333,1),(122,7427405,7427402,'eve',33.333,1),(122,7427406,7427402,'vel',33.333,1),(122,7427407,7427404,'pse',25,1),(122,7427408,7427404,'seu',25,1),(122,7427409,7427404,'eud',25,1),(122,7427410,7427404,'udo',25,1),(122,7427411,7427407,'fal',33.333,6),(122,7427412,7427407,'als',33.333,6),(122,7427413,7427407,'lse',33.333,6),(122,7427414,7427411,'sta',25,3),(122,7427415,7427411,'tat',25,3),(122,7427416,7427411,'atu',25,3),(122,7427417,7427411,'tus',25,3),(122,7427418,7427414,'rdm',100,1),(122,7427419,7427418,'cap',20,1),(122,7427420,7427418,'apa',20,1),(122,7427421,7427418,'pab',20,1),(122,7427422,7427418,'abl',20,1),(122,7427423,7427418,'ble',20,1),(122,7427424,7427419,'tru',50,1),(122,7427425,7427419,'rue',50,1),(122,7427426,7427424,'loc',33.333,1),(122,7427427,7427424,'oca',33.333,1),(122,7427428,7427424,'cal',33.333,1),(122,7427429,7427426,'rem',14.286,1),(122,7427430,7427426,'emo',14.286,1),(122,7427431,7427426,'mov',14.286,1),(122,7427432,7427426,'ova',14.286,1),(122,7427433,7427426,'vab',14.286,1),(122,7427434,7427426,'abl',14.286,1),(122,7427435,7427426,'ble',14.286,1),(122,7427436,7427429,'ssd',100,1),(122,7427437,7427436,'off',20,1),(122,7427438,7427436,'ffl',20,1),(122,7427439,7427436,'fli',20,1),(122,7427440,7427436,'lin',20,1),(122,7427441,7427436,'ine',20,1),(122,7427442,7427437,'per',11.111,1),(122,7427443,7427437,'ere',11.111,1),(122,7427444,7427437,'ren',11.111,1),(122,7427445,7427437,'enn',11.111,1),(122,7427446,7427437,'nni',11.111,1),(122,7427447,7427437,'nia',11.111,1),(122,7427448,7427437,'ial',11.111,1),(122,7427449,7427437,'all',11.111,1),(122,7427450,7427437,'lly',11.111,1),(122,7427451,7427442,'res',16.667,1),(122,7427452,7427442,'ese',16.667,1),(122,7427453,7427442,'ser',16.667,1),(122,7427454,7427442,'erv',16.667,1),(122,7427455,7427442,'rve',16.667,1),(122,7427456,7427442,'ved',16.667,1),(122,7427457,7427451,'thi',50,1),(122,7427458,7427451,'hin',50,1),(122,7427459,7427457,'pro',10,1),(122,7427460,7427457,'rov',10,1),(122,7427461,7427457,'ovi',10,1),(122,7427462,7427457,'vis',10,1),(122,7427463,7427457,'isi',10,1),(122,7427464,7427457,'sio',10,1),(122,7427465,7427457,'ion',10,1),(122,7427466,7427457,'oni',10,1),(122,7427467,7427457,'nin',10,1),(122,7427468,7427457,'ing',10,1),(122,7427469,7427459,'yes',100,1),(122,7427470,7427469,'att',16.667,1),(122,7427471,7427469,'tta',16.667,1),(122,7427472,7427469,'tac',16.667,1),(122,7427473,7427469,'ach',16.667,1),(122,7427474,7427469,'che',16.667,1),(122,7427475,7427469,'hed',16.667,1),(122,7427476,7427470,'fil',20,1),(122,7427477,7427470,'ilt',20,1),(122,7427478,7427470,'lte',20,1),(122,7427479,7427470,'ter',20,1),(122,7427480,7427470,'ers',20,1),(122,7427481,7427476,'vaa',50,1),(122,7427482,7427476,'aai',50,1),(122,7427483,7427481,'unk',20,1),(122,7427484,7427481,'nkn',20,1),(122,7427485,7427481,'kno',20,1),(122,7427486,7427481,'now',20,1),(122,7427487,7427481,'own',20,1),(122,7427488,7427483,'oth',33.333,1),(122,7427489,7427483,'the',33.333,1),(122,7427490,7427483,'her',33.333,1),(122,7427491,7427488,'uid',50,1),(122,7427492,7427488,'ids',50,1),(122,7427493,7427491,'vml',100,1),(122,7427494,7427493,'dis',20,1),(122,7427495,7427493,'isp',20,1),(122,7427496,7427493,'spl',20,1),(122,7427497,7427493,'pla',20,1),(122,7427498,7427493,'lay',20,1),(122,7427499,7427494,'nam',50,1),(122,7427500,7427494,'ame',50,1),(123,7427502,7427501,'net',25,3),(123,7427503,7427501,'eta',25,3),(123,7427504,7427501,'tap',25,3),(123,7427505,7427501,'app',25,3),(123,7427506,7427502,'fib',33.333,2),(123,7427507,7427502,'ibr',33.333,2),(123,7427508,7427502,'bre',33.333,2),(123,7427509,7427506,'cha',20,2),(123,7427510,7427506,'han',20,2),(123,7427511,7427506,'ann',20,2),(123,7427512,7427506,'nne',20,2),(123,7427513,7427506,'nel',20,2),(123,7427514,7427509,'dis',50,2),(123,7427515,7427509,'isk',50,2),(123,7427516,7427514,'naa',100,4),(123,7427517,7427516,'600',3.333,4),(123,7427518,7427516,'00a',3.333,4),(123,7427519,7427516,'0a0',3.333,4),(123,7427520,7427516,'a09',3.333,4),(123,7427521,7427516,'098',3.333,4),(123,7427522,7427516,'980',3.333,4),(123,7427523,7427516,'804',3.333,4),(123,7427524,7427516,'044',3.333,4),(123,7427525,7427516,'443',3.333,4),(123,7427526,7427516,'430',3.333,4),(123,7427527,7427516,'307',3.333,4),(123,7427528,7427516,'072',3.333,4),(123,7427529,7427516,'725',3.333,4),(123,7427530,7427516,'259',3.333,4),(123,7427531,7427516,'593',3.333,4),(123,7427532,7427516,'931',3.333,4),(123,7427533,7427516,'313',3.333,4),(123,7427534,7427516,'13f',3.333,4),(123,7427535,7427516,'3f3',3.333,4),(123,7427536,7427516,'f33',3.333,4),(123,7427537,7427516,'334',3.333,4),(123,7427538,7427516,'345',3.333,4),(123,7427539,7427516,'455',3.333,4),(123,7427540,7427516,'556',3.333,4),(123,7427541,7427516,'563',3.333,4),(123,7427542,7427516,'638',3.333,4),(123,7427543,7427516,'387',3.333,4),(123,7427544,7427516,'872',3.333,4),(123,7427545,7427516,'724',3.333,4),(123,7427546,7427516,'24d',3.333,4),(123,7427547,7427517,'ser',25,1),(123,7427548,7427517,'eri',25,1),(123,7427549,7427517,'ria',25,1),(123,7427550,7427517,'ial',25,1),(123,7427551,7427547,'siz',50,1),(123,7427552,7427547,'ize',50,1),(123,7427553,7427551,'460',33.333,1),(123,7427554,7427551,'608',33.333,1),(123,7427555,7427551,'080',33.333,1),(123,7427556,7427553,'dev',25,1),(123,7427557,7427553,'evi',25,1),(123,7427558,7427553,'vic',25,1),(123,7427559,7427553,'ice',25,1),(123,7427560,7427556,'typ',50,1),(123,7427561,7427556,'ype',50,1),(123,7427562,7427560,'dir',10,1),(123,7427563,7427560,'ire',10,1),(123,7427564,7427560,'rec',10,1),(123,7427565,7427560,'ect',10,1),(123,7427566,7427560,'cta',10,1),(123,7427567,7427560,'tac',10,1),(123,7427568,7427560,'acc',10,1),(123,7427569,7427560,'cce',10,1),(123,7427570,7427560,'ces',10,1),(123,7427571,7427560,'ess',10,1),(123,7427572,7427562,'mul',14.286,1),(123,7427573,7427562,'ult',14.286,1),(123,7427574,7427562,'lti',14.286,1),(123,7427575,7427562,'tip',14.286,1),(123,7427576,7427562,'ipa',14.286,1),(123,7427577,7427562,'pat',14.286,1),(123,7427578,7427562,'ath',14.286,1),(123,7427579,7427572,'plu',25,1),(123,7427580,7427572,'lug',25,1),(123,7427581,7427572,'ugi',25,1),(123,7427582,7427572,'gin',25,1),(123,7427583,7427579,'nmp',100,1),(123,7427584,7427583,'dev',33.333,1),(123,7427585,7427583,'evf',33.333,1),(123,7427586,7427583,'vfs',33.333,1),(123,7427587,7427584,'pat',50,1),(123,7427588,7427584,'ath',50,1),(123,7427589,7427587,'vmf',50,1),(123,7427590,7427587,'mfs',50,1),(123,7427591,7427589,'dev',20,1),(123,7427592,7427589,'evi',20,1),(123,7427593,7427589,'vic',20,1),(123,7427594,7427589,'ice',20,1),(123,7427595,7427589,'ces',20,1),(123,7427596,7427591,'dis',33.333,1),(123,7427597,7427591,'isk',33.333,1),(123,7427598,7427591,'sks',33.333,1),(123,7427599,7427596,'ven',25,1),(123,7427600,7427596,'end',25,1),(123,7427601,7427596,'ndo',25,1),(123,7427602,7427596,'dor',25,1),(123,7427603,7427599,'mod',33.333,1),(123,7427604,7427599,'ode',33.333,1),(123,7427605,7427599,'del',33.333,1),(123,7427606,7427603,'lun',100,1),(123,7427607,7427606,'cmo',33.333,1),(123,7427608,7427606,'mod',33.333,1),(123,7427609,7427606,'ode',33.333,1),(123,7427610,7427607,'rev',16.667,1),(123,7427611,7427607,'evi',16.667,1),(123,7427612,7427607,'vis',16.667,1),(123,7427613,7427607,'isi',16.667,1),(123,7427614,7427607,'sio',16.667,1),(123,7427615,7427607,'ion',16.667,1),(123,7427616,7427610,'810',50,1),(123,7427617,7427610,'100',50,1),(123,7427618,7427616,'scs',50,1),(123,7427619,7427616,'csi',50,1),(123,7427620,7427618,'lev',33.333,1),(123,7427621,7427618,'eve',33.333,1),(123,7427622,7427618,'vel',33.333,1),(123,7427623,7427620,'pse',25,1),(123,7427624,7427620,'seu',25,1),(123,7427625,7427620,'eud',25,1),(123,7427626,7427620,'udo',25,1),(123,7427627,7427623,'fal',33.333,6),(123,7427628,7427623,'als',33.333,6),(123,7427629,7427623,'lse',33.333,6),(123,7427630,7427627,'sta',25,3),(123,7427631,7427627,'tat',25,3),(123,7427632,7427627,'atu',25,3),(123,7427633,7427627,'tus',25,3),(123,7427634,7427630,'rdm',100,1),(123,7427635,7427634,'cap',20,1),(123,7427636,7427634,'apa',20,1),(123,7427637,7427634,'pab',20,1),(123,7427638,7427634,'abl',20,1),(123,7427639,7427634,'ble',20,1),(123,7427640,7427635,'tru',50,1),(123,7427641,7427635,'rue',50,1),(123,7427642,7427640,'loc',33.333,1),(123,7427643,7427640,'oca',33.333,1),(123,7427644,7427640,'cal',33.333,1),(123,7427645,7427642,'rem',14.286,1),(123,7427646,7427642,'emo',14.286,1),(123,7427647,7427642,'mov',14.286,1),(123,7427648,7427642,'ova',14.286,1),(123,7427649,7427642,'vab',14.286,1),(123,7427650,7427642,'abl',14.286,1),(123,7427651,7427642,'ble',14.286,1),(123,7427652,7427645,'ssd',100,1),(123,7427653,7427652,'off',20,1),(123,7427654,7427652,'ffl',20,1),(123,7427655,7427652,'fli',20,1),(123,7427656,7427652,'lin',20,1),(123,7427657,7427652,'ine',20,1),(123,7427658,7427653,'per',11.111,1),(123,7427659,7427653,'ere',11.111,1),(123,7427660,7427653,'ren',11.111,1),(123,7427661,7427653,'enn',11.111,1),(123,7427662,7427653,'nni',11.111,1),(123,7427663,7427653,'nia',11.111,1),(123,7427664,7427653,'ial',11.111,1),(123,7427665,7427653,'all',11.111,1),(123,7427666,7427653,'lly',11.111,1),(123,7427667,7427658,'res',16.667,1),(123,7427668,7427658,'ese',16.667,1),(123,7427669,7427658,'ser',16.667,1),(123,7427670,7427658,'erv',16.667,1),(123,7427671,7427658,'rve',16.667,1),(123,7427672,7427658,'ved',16.667,1),(123,7427673,7427667,'thi',50,1),(123,7427674,7427667,'hin',50,1),(123,7427675,7427673,'pro',10,1),(123,7427676,7427673,'rov',10,1),(123,7427677,7427673,'ovi',10,1),(123,7427678,7427673,'vis',10,1),(123,7427679,7427673,'isi',10,1),(123,7427680,7427673,'sio',10,1),(123,7427681,7427673,'ion',10,1),(123,7427682,7427673,'oni',10,1),(123,7427683,7427673,'nin',10,1),(123,7427684,7427673,'ing',10,1),(123,7427685,7427675,'yes',100,1),(123,7427686,7427685,'att',16.667,1),(123,7427687,7427685,'tta',16.667,1),(123,7427688,7427685,'tac',16.667,1),(123,7427689,7427685,'ach',16.667,1),(123,7427690,7427685,'che',16.667,1),(123,7427691,7427685,'hed',16.667,1),(123,7427692,7427686,'fil',20,1),(123,7427693,7427686,'ilt',20,1),(123,7427694,7427686,'lte',20,1),(123,7427695,7427686,'ter',20,1),(123,7427696,7427686,'ers',20,1),(123,7427697,7427692,'vaa',50,1),(123,7427698,7427692,'aai',50,1),(123,7427699,7427697,'unk',20,1),(123,7427700,7427697,'nkn',20,1),(123,7427701,7427697,'kno',20,1),(123,7427702,7427697,'now',20,1),(123,7427703,7427697,'own',20,1),(123,7427704,7427699,'oth',33.333,1),(123,7427705,7427699,'the',33.333,1),(123,7427706,7427699,'her',33.333,1),(123,7427707,7427704,'uid',50,1),(123,7427708,7427704,'ids',50,1),(123,7427709,7427707,'vml',100,1),(123,7427710,7427709,'dis',20,1),(123,7427711,7427709,'isp',20,1),(123,7427712,7427709,'spl',20,1),(123,7427713,7427709,'pla',20,1),(123,7427714,7427709,'lay',20,1),(123,7427715,7427710,'nam',50,1),(123,7427716,7427710,'ame',50,1),(124,7427718,7427717,'net',25,3),(124,7427719,7427717,'eta',25,3),(124,7427720,7427717,'tap',25,3),(124,7427721,7427717,'app',25,3),(124,7427722,7427718,'fib',33.333,2),(124,7427723,7427718,'ibr',33.333,2),(124,7427724,7427718,'bre',33.333,2),(124,7427725,7427722,'cha',20,2),(124,7427726,7427722,'han',20,2),(124,7427727,7427722,'ann',20,2),(124,7427728,7427722,'nne',20,2),(124,7427729,7427722,'nel',20,2),(124,7427730,7427725,'dis',50,2),(124,7427731,7427725,'isk',50,2),(124,7427732,7427730,'naa',100,4),(124,7427733,7427732,'600',3.333,4),(124,7427734,7427732,'00a',3.333,4),(124,7427735,7427732,'0a0',3.333,4),(124,7427736,7427732,'a09',3.333,4),(124,7427737,7427732,'098',3.333,4),(124,7427738,7427732,'980',3.333,4),(124,7427739,7427732,'804',3.333,4),(124,7427740,7427732,'044',3.333,4),(124,7427741,7427732,'443',3.333,4),(124,7427742,7427732,'430',3.333,4),(124,7427743,7427732,'307',3.333,4),(124,7427744,7427732,'072',3.333,4),(124,7427745,7427732,'725',3.333,4),(124,7427746,7427732,'259',3.333,4),(124,7427747,7427732,'593',3.333,4),(124,7427748,7427732,'931',3.333,4),(124,7427749,7427732,'313',3.333,4),(124,7427750,7427732,'13f',3.333,4),(124,7427751,7427732,'3f3',3.333,4),(124,7427752,7427732,'f33',3.333,4),(124,7427753,7427732,'334',3.333,4),(124,7427754,7427732,'345',3.333,4),(124,7427755,7427732,'455',3.333,4),(124,7427756,7427732,'556',3.333,4),(124,7427757,7427732,'563',3.333,4),(124,7427758,7427732,'638',3.333,4),(124,7427759,7427732,'387',3.333,4),(124,7427760,7427732,'872',3.333,4),(124,7427761,7427732,'724',3.333,4),(124,7427762,7427732,'24e',3.333,4),(124,7427763,7427733,'ser',25,1),(124,7427764,7427733,'eri',25,1),(124,7427765,7427733,'ria',25,1),(124,7427766,7427733,'ial',25,1),(124,7427767,7427763,'siz',50,1),(124,7427768,7427763,'ize',50,1),(124,7427769,7427767,'460',33.333,1),(124,7427770,7427767,'608',33.333,1),(124,7427771,7427767,'080',33.333,1),(124,7427772,7427769,'dev',25,1),(124,7427773,7427769,'evi',25,1),(124,7427774,7427769,'vic',25,1),(124,7427775,7427769,'ice',25,1),(124,7427776,7427772,'typ',50,1),(124,7427777,7427772,'ype',50,1),(124,7427778,7427776,'dir',10,1),(124,7427779,7427776,'ire',10,1),(124,7427780,7427776,'rec',10,1),(124,7427781,7427776,'ect',10,1),(124,7427782,7427776,'cta',10,1),(124,7427783,7427776,'tac',10,1),(124,7427784,7427776,'acc',10,1),(124,7427785,7427776,'cce',10,1),(124,7427786,7427776,'ces',10,1),(124,7427787,7427776,'ess',10,1),(124,7427788,7427778,'mul',14.286,1),(124,7427789,7427778,'ult',14.286,1),(124,7427790,7427778,'lti',14.286,1),(124,7427791,7427778,'tip',14.286,1),(124,7427792,7427778,'ipa',14.286,1),(124,7427793,7427778,'pat',14.286,1),(124,7427794,7427778,'ath',14.286,1),(124,7427795,7427788,'plu',25,1),(124,7427796,7427788,'lug',25,1),(124,7427797,7427788,'ugi',25,1),(124,7427798,7427788,'gin',25,1),(124,7427799,7427795,'nmp',100,1),(124,7427800,7427799,'dev',33.333,1),(124,7427801,7427799,'evf',33.333,1),(124,7427802,7427799,'vfs',33.333,1),(124,7427803,7427800,'pat',50,1),(124,7427804,7427800,'ath',50,1),(124,7427805,7427803,'vmf',50,1),(124,7427806,7427803,'mfs',50,1),(124,7427807,7427805,'dev',20,1),(124,7427808,7427805,'evi',20,1),(124,7427809,7427805,'vic',20,1),(124,7427810,7427805,'ice',20,1),(124,7427811,7427805,'ces',20,1),(124,7427812,7427807,'dis',33.333,1),(124,7427813,7427807,'isk',33.333,1),(124,7427814,7427807,'sks',33.333,1),(124,7427815,7427812,'ven',25,1),(124,7427816,7427812,'end',25,1),(124,7427817,7427812,'ndo',25,1),(124,7427818,7427812,'dor',25,1),(124,7427819,7427815,'mod',33.333,1),(124,7427820,7427815,'ode',33.333,1),(124,7427821,7427815,'del',33.333,1),(124,7427822,7427819,'lun',100,1),(124,7427823,7427822,'cmo',33.333,1),(124,7427824,7427822,'mod',33.333,1),(124,7427825,7427822,'ode',33.333,1),(124,7427826,7427823,'rev',16.667,1),(124,7427827,7427823,'evi',16.667,1),(124,7427828,7427823,'vis',16.667,1),(124,7427829,7427823,'isi',16.667,1),(124,7427830,7427823,'sio',16.667,1),(124,7427831,7427823,'ion',16.667,1),(124,7427832,7427826,'810',50,1),(124,7427833,7427826,'100',50,1),(124,7427834,7427832,'scs',50,1),(124,7427835,7427832,'csi',50,1),(124,7427836,7427834,'lev',33.333,1),(124,7427837,7427834,'eve',33.333,1),(124,7427838,7427834,'vel',33.333,1),(124,7427839,7427836,'pse',25,1),(124,7427840,7427836,'seu',25,1),(124,7427841,7427836,'eud',25,1),(124,7427842,7427836,'udo',25,1),(124,7427843,7427839,'fal',33.333,6),(124,7427844,7427839,'als',33.333,6),(124,7427845,7427839,'lse',33.333,6),(124,7427846,7427843,'sta',25,3),(124,7427847,7427843,'tat',25,3),(124,7427848,7427843,'atu',25,3),(124,7427849,7427843,'tus',25,3),(124,7427850,7427846,'rdm',100,1),(124,7427851,7427850,'cap',20,1),(124,7427852,7427850,'apa',20,1),(124,7427853,7427850,'pab',20,1),(124,7427854,7427850,'abl',20,1),(124,7427855,7427850,'ble',20,1),(124,7427856,7427851,'tru',50,1),(124,7427857,7427851,'rue',50,1),(124,7427858,7427856,'loc',33.333,1),(124,7427859,7427856,'oca',33.333,1),(124,7427860,7427856,'cal',33.333,1),(124,7427861,7427858,'rem',14.286,1),(124,7427862,7427858,'emo',14.286,1),(124,7427863,7427858,'mov',14.286,1),(124,7427864,7427858,'ova',14.286,1),(124,7427865,7427858,'vab',14.286,1),(124,7427866,7427858,'abl',14.286,1),(124,7427867,7427858,'ble',14.286,1),(124,7427868,7427861,'ssd',100,1),(124,7427869,7427868,'off',20,1),(124,7427870,7427868,'ffl',20,1),(124,7427871,7427868,'fli',20,1),(124,7427872,7427868,'lin',20,1),(124,7427873,7427868,'ine',20,1),(124,7427874,7427869,'per',11.111,1),(124,7427875,7427869,'ere',11.111,1),(124,7427876,7427869,'ren',11.111,1),(124,7427877,7427869,'enn',11.111,1),(124,7427878,7427869,'nni',11.111,1),(124,7427879,7427869,'nia',11.111,1),(124,7427880,7427869,'ial',11.111,1),(124,7427881,7427869,'all',11.111,1),(124,7427882,7427869,'lly',11.111,1),(124,7427883,7427874,'res',16.667,1),(124,7427884,7427874,'ese',16.667,1),(124,7427885,7427874,'ser',16.667,1),(124,7427886,7427874,'erv',16.667,1),(124,7427887,7427874,'rve',16.667,1),(124,7427888,7427874,'ved',16.667,1),(124,7427889,7427883,'thi',50,1),(124,7427890,7427883,'hin',50,1),(124,7427891,7427889,'pro',10,1),(124,7427892,7427889,'rov',10,1),(124,7427893,7427889,'ovi',10,1),(124,7427894,7427889,'vis',10,1),(124,7427895,7427889,'isi',10,1),(124,7427896,7427889,'sio',10,1),(124,7427897,7427889,'ion',10,1),(124,7427898,7427889,'oni',10,1),(124,7427899,7427889,'nin',10,1),(124,7427900,7427889,'ing',10,1),(124,7427901,7427891,'yes',100,1),(124,7427902,7427901,'att',16.667,1),(124,7427903,7427901,'tta',16.667,1),(124,7427904,7427901,'tac',16.667,1),(124,7427905,7427901,'ach',16.667,1),(124,7427906,7427901,'che',16.667,1),(124,7427907,7427901,'hed',16.667,1),(124,7427908,7427902,'fil',20,1),(124,7427909,7427902,'ilt',20,1),(124,7427910,7427902,'lte',20,1),(124,7427911,7427902,'ter',20,1),(124,7427912,7427902,'ers',20,1),(124,7427913,7427908,'vaa',50,1),(124,7427914,7427908,'aai',50,1),(124,7427915,7427913,'unk',20,1),(124,7427916,7427913,'nkn',20,1),(124,7427917,7427913,'kno',20,1),(124,7427918,7427913,'now',20,1),(124,7427919,7427913,'own',20,1),(124,7427920,7427915,'oth',33.333,1),(124,7427921,7427915,'the',33.333,1),(124,7427922,7427915,'her',33.333,1),(124,7427923,7427920,'uid',50,1),(124,7427924,7427920,'ids',50,1),(124,7427925,7427923,'vml',100,1),(124,7427926,7427925,'dis',20,1),(124,7427927,7427925,'isp',20,1),(124,7427928,7427925,'spl',20,1),(124,7427929,7427925,'pla',20,1),(124,7427930,7427925,'lay',20,1),(124,7427931,7427926,'nam',50,1),(124,7427932,7427926,'ame',50,1),(125,7427934,7427933,'net',25,3),(125,7427935,7427933,'eta',25,3),(125,7427936,7427933,'tap',25,3),(125,7427937,7427933,'app',25,3),(125,7427938,7427934,'fib',33.333,2),(125,7427939,7427934,'ibr',33.333,2),(125,7427940,7427934,'bre',33.333,2),(125,7427941,7427938,'cha',20,2),(125,7427942,7427938,'han',20,2),(125,7427943,7427938,'ann',20,2),(125,7427944,7427938,'nne',20,2),(125,7427945,7427938,'nel',20,2),(125,7427946,7427941,'dis',50,2),(125,7427947,7427941,'isk',50,2),(125,7427948,7427946,'naa',100,4),(125,7427949,7427948,'600',3.333,4),(125,7427950,7427948,'00a',3.333,4),(125,7427951,7427948,'0a0',3.333,4),(125,7427952,7427948,'a09',3.333,4),(125,7427953,7427948,'098',3.333,4),(125,7427954,7427948,'980',3.333,4),(125,7427955,7427948,'804',3.333,4),(125,7427956,7427948,'044',3.333,4),(125,7427957,7427948,'443',3.333,4),(125,7427958,7427948,'430',3.333,4),(125,7427959,7427948,'307',3.333,4),(125,7427960,7427948,'072',3.333,4),(125,7427961,7427948,'725',3.333,4),(125,7427962,7427948,'259',3.333,4),(125,7427963,7427948,'593',3.333,4),(125,7427964,7427948,'931',3.333,4),(125,7427965,7427948,'313',3.333,4),(125,7427966,7427948,'13f',3.333,4),(125,7427967,7427948,'3f3',3.333,4),(125,7427968,7427948,'f33',3.333,4),(125,7427969,7427948,'334',3.333,4),(125,7427970,7427948,'345',3.333,4),(125,7427971,7427948,'455',3.333,4),(125,7427972,7427948,'556',3.333,4),(125,7427973,7427948,'563',3.333,4),(125,7427974,7427948,'638',3.333,4),(125,7427975,7427948,'387',3.333,4),(125,7427976,7427948,'872',3.333,4),(125,7427977,7427948,'724',3.333,4),(125,7427978,7427948,'24f',3.333,4),(125,7427979,7427949,'ser',25,1),(125,7427980,7427949,'eri',25,1),(125,7427981,7427949,'ria',25,1),(125,7427982,7427949,'ial',25,1),(125,7427983,7427979,'siz',50,1),(125,7427984,7427979,'ize',50,1),(125,7427985,7427983,'460',33.333,1),(125,7427986,7427983,'608',33.333,1),(125,7427987,7427983,'080',33.333,1),(125,7427988,7427985,'dev',25,1),(125,7427989,7427985,'evi',25,1),(125,7427990,7427985,'vic',25,1),(125,7427991,7427985,'ice',25,1),(125,7427992,7427988,'typ',50,1),(125,7427993,7427988,'ype',50,1),(125,7427994,7427992,'dir',10,1),(125,7427995,7427992,'ire',10,1),(125,7427996,7427992,'rec',10,1),(125,7427997,7427992,'ect',10,1),(125,7427998,7427992,'cta',10,1),(125,7427999,7427992,'tac',10,1),(125,7428000,7427992,'acc',10,1),(125,7428001,7427992,'cce',10,1),(125,7428002,7427992,'ces',10,1),(125,7428003,7427992,'ess',10,1),(125,7428004,7427994,'mul',14.286,1),(125,7428005,7427994,'ult',14.286,1),(125,7428006,7427994,'lti',14.286,1),(125,7428007,7427994,'tip',14.286,1),(125,7428008,7427994,'ipa',14.286,1),(125,7428009,7427994,'pat',14.286,1),(125,7428010,7427994,'ath',14.286,1),(125,7428011,7428004,'plu',25,1),(125,7428012,7428004,'lug',25,1),(125,7428013,7428004,'ugi',25,1),(125,7428014,7428004,'gin',25,1),(125,7428015,7428011,'nmp',100,1),(125,7428016,7428015,'dev',33.333,1),(125,7428017,7428015,'evf',33.333,1),(125,7428018,7428015,'vfs',33.333,1),(125,7428019,7428016,'pat',50,1),(125,7428020,7428016,'ath',50,1),(125,7428021,7428019,'vmf',50,1),(125,7428022,7428019,'mfs',50,1),(125,7428023,7428021,'dev',20,1),(125,7428024,7428021,'evi',20,1),(125,7428025,7428021,'vic',20,1),(125,7428026,7428021,'ice',20,1),(125,7428027,7428021,'ces',20,1),(125,7428028,7428023,'dis',33.333,1),(125,7428029,7428023,'isk',33.333,1),(125,7428030,7428023,'sks',33.333,1),(125,7428031,7428028,'ven',25,1),(125,7428032,7428028,'end',25,1),(125,7428033,7428028,'ndo',25,1),(125,7428034,7428028,'dor',25,1),(125,7428035,7428031,'mod',33.333,1),(125,7428036,7428031,'ode',33.333,1),(125,7428037,7428031,'del',33.333,1),(125,7428038,7428035,'lun',100,1),(125,7428039,7428038,'cmo',33.333,1),(125,7428040,7428038,'mod',33.333,1),(125,7428041,7428038,'ode',33.333,1),(125,7428042,7428039,'rev',16.667,1),(125,7428043,7428039,'evi',16.667,1),(125,7428044,7428039,'vis',16.667,1),(125,7428045,7428039,'isi',16.667,1),(125,7428046,7428039,'sio',16.667,1),(125,7428047,7428039,'ion',16.667,1),(125,7428048,7428042,'810',50,1),(125,7428049,7428042,'100',50,1),(125,7428050,7428048,'scs',50,1),(125,7428051,7428048,'csi',50,1),(125,7428052,7428050,'lev',33.333,1),(125,7428053,7428050,'eve',33.333,1),(125,7428054,7428050,'vel',33.333,1),(125,7428055,7428052,'pse',25,1),(125,7428056,7428052,'seu',25,1),(125,7428057,7428052,'eud',25,1),(125,7428058,7428052,'udo',25,1),(125,7428059,7428055,'fal',33.333,6),(125,7428060,7428055,'als',33.333,6),(125,7428061,7428055,'lse',33.333,6),(125,7428062,7428059,'sta',25,3),(125,7428063,7428059,'tat',25,3),(125,7428064,7428059,'atu',25,3),(125,7428065,7428059,'tus',25,3),(125,7428066,7428062,'rdm',100,1),(125,7428067,7428066,'cap',20,1),(125,7428068,7428066,'apa',20,1),(125,7428069,7428066,'pab',20,1),(125,7428070,7428066,'abl',20,1),(125,7428071,7428066,'ble',20,1),(125,7428072,7428067,'tru',50,1),(125,7428073,7428067,'rue',50,1),(125,7428074,7428072,'loc',33.333,1),(125,7428075,7428072,'oca',33.333,1),(125,7428076,7428072,'cal',33.333,1),(125,7428077,7428074,'rem',14.286,1),(125,7428078,7428074,'emo',14.286,1),(125,7428079,7428074,'mov',14.286,1),(125,7428080,7428074,'ova',14.286,1),(125,7428081,7428074,'vab',14.286,1),(125,7428082,7428074,'abl',14.286,1),(125,7428083,7428074,'ble',14.286,1),(125,7428084,7428077,'ssd',100,1),(125,7428085,7428084,'off',20,1),(125,7428086,7428084,'ffl',20,1),(125,7428087,7428084,'fli',20,1),(125,7428088,7428084,'lin',20,1),(125,7428089,7428084,'ine',20,1),(125,7428090,7428085,'per',11.111,1),(125,7428091,7428085,'ere',11.111,1),(125,7428092,7428085,'ren',11.111,1),(125,7428093,7428085,'enn',11.111,1),(125,7428094,7428085,'nni',11.111,1),(125,7428095,7428085,'nia',11.111,1),(125,7428096,7428085,'ial',11.111,1),(125,7428097,7428085,'all',11.111,1),(125,7428098,7428085,'lly',11.111,1),(125,7428099,7428090,'res',16.667,1),(125,7428100,7428090,'ese',16.667,1),(125,7428101,7428090,'ser',16.667,1),(125,7428102,7428090,'erv',16.667,1),(125,7428103,7428090,'rve',16.667,1),(125,7428104,7428090,'ved',16.667,1),(125,7428105,7428099,'thi',50,1),(125,7428106,7428099,'hin',50,1),(125,7428107,7428105,'pro',10,1),(125,7428108,7428105,'rov',10,1),(125,7428109,7428105,'ovi',10,1),(125,7428110,7428105,'vis',10,1),(125,7428111,7428105,'isi',10,1),(125,7428112,7428105,'sio',10,1),(125,7428113,7428105,'ion',10,1),(125,7428114,7428105,'oni',10,1),(125,7428115,7428105,'nin',10,1),(125,7428116,7428105,'ing',10,1),(125,7428117,7428107,'yes',100,1),(125,7428118,7428117,'att',16.667,1),(125,7428119,7428117,'tta',16.667,1),(125,7428120,7428117,'tac',16.667,1),(125,7428121,7428117,'ach',16.667,1),(125,7428122,7428117,'che',16.667,1),(125,7428123,7428117,'hed',16.667,1),(125,7428124,7428118,'fil',20,1),(125,7428125,7428118,'ilt',20,1),(125,7428126,7428118,'lte',20,1),(125,7428127,7428118,'ter',20,1),(125,7428128,7428118,'ers',20,1),(125,7428129,7428124,'vaa',50,1),(125,7428130,7428124,'aai',50,1),(125,7428131,7428129,'unk',20,1),(125,7428132,7428129,'nkn',20,1),(125,7428133,7428129,'kno',20,1),(125,7428134,7428129,'now',20,1),(125,7428135,7428129,'own',20,1),(125,7428136,7428131,'oth',33.333,1),(125,7428137,7428131,'the',33.333,1),(125,7428138,7428131,'her',33.333,1),(125,7428139,7428136,'uid',50,1),(125,7428140,7428136,'ids',50,1),(125,7428141,7428139,'vml',100,1),(125,7428142,7428141,'dis',20,1),(125,7428143,7428141,'isp',20,1),(125,7428144,7428141,'spl',20,1),(125,7428145,7428141,'pla',20,1),(125,7428146,7428141,'lay',20,1),(125,7428147,7428142,'nam',50,1),(125,7428148,7428142,'ame',50,1),(126,7428150,7428149,'net',25,3),(126,7428151,7428149,'eta',25,3),(126,7428152,7428149,'tap',25,3),(126,7428153,7428149,'app',25,3),(126,7428154,7428150,'fib',33.333,2),(126,7428155,7428150,'ibr',33.333,2),(126,7428156,7428150,'bre',33.333,2),(126,7428157,7428154,'cha',20,2),(126,7428158,7428154,'han',20,2),(126,7428159,7428154,'ann',20,2),(126,7428160,7428154,'nne',20,2),(126,7428161,7428154,'nel',20,2),(126,7428162,7428157,'dis',50,2),(126,7428163,7428157,'isk',50,2),(126,7428164,7428162,'naa',100,4),(126,7428165,7428164,'600',3.333,4),(126,7428166,7428164,'00a',3.333,4),(126,7428167,7428164,'0a0',3.333,4),(126,7428168,7428164,'a09',3.333,4),(126,7428169,7428164,'098',3.333,4),(126,7428170,7428164,'980',3.333,4),(126,7428171,7428164,'804',3.333,4),(126,7428172,7428164,'044',3.333,4),(126,7428173,7428164,'443',3.333,4),(126,7428174,7428164,'430',3.333,4),(126,7428175,7428164,'307',3.333,4),(126,7428176,7428164,'075',3.333,4),(126,7428177,7428164,'753',3.333,4),(126,7428178,7428164,'535',3.333,4),(126,7428179,7428164,'357',3.333,4),(126,7428180,7428164,'573',3.333,4),(126,7428181,7428164,'732',3.333,4),(126,7428182,7428164,'32b',3.333,4),(126,7428183,7428164,'2b3',3.333,4),(126,7428184,7428164,'b33',3.333,4),(126,7428185,7428164,'334',3.333,4),(126,7428186,7428164,'345',3.333,4),(126,7428187,7428164,'457',3.333,4),(126,7428188,7428164,'571',3.333,4),(126,7428189,7428164,'715',3.333,4),(126,7428190,7428164,'153',3.333,4),(126,7428191,7428164,'533',3.333,4),(126,7428192,7428164,'335',3.333,4),(126,7428193,7428164,'357',3.333,4),(126,7428194,7428164,'570',3.333,4),(126,7428195,7428165,'ser',25,1),(126,7428196,7428165,'eri',25,1),(126,7428197,7428165,'ria',25,1),(126,7428198,7428165,'ial',25,1),(126,7428199,7428195,'siz',50,1),(126,7428200,7428195,'ize',50,1),(126,7428201,7428199,'460',33.333,1),(126,7428202,7428199,'608',33.333,1),(126,7428203,7428199,'080',33.333,1),(126,7428204,7428201,'dev',25,1),(126,7428205,7428201,'evi',25,1),(126,7428206,7428201,'vic',25,1),(126,7428207,7428201,'ice',25,1),(126,7428208,7428204,'typ',50,1),(126,7428209,7428204,'ype',50,1),(126,7428210,7428208,'dir',10,1),(126,7428211,7428208,'ire',10,1),(126,7428212,7428208,'rec',10,1),(126,7428213,7428208,'ect',10,1),(126,7428214,7428208,'cta',10,1),(126,7428215,7428208,'tac',10,1),(126,7428216,7428208,'acc',10,1),(126,7428217,7428208,'cce',10,1),(126,7428218,7428208,'ces',10,1),(126,7428219,7428208,'ess',10,1),(126,7428220,7428210,'mul',14.286,1),(126,7428221,7428210,'ult',14.286,1),(126,7428222,7428210,'lti',14.286,1),(126,7428223,7428210,'tip',14.286,1),(126,7428224,7428210,'ipa',14.286,1),(126,7428225,7428210,'pat',14.286,1),(126,7428226,7428210,'ath',14.286,1),(126,7428227,7428220,'plu',25,1),(126,7428228,7428220,'lug',25,1),(126,7428229,7428220,'ugi',25,1),(126,7428230,7428220,'gin',25,1),(126,7428231,7428227,'nmp',100,1),(126,7428232,7428231,'dev',33.333,1),(126,7428233,7428231,'evf',33.333,1),(126,7428234,7428231,'vfs',33.333,1),(126,7428235,7428232,'pat',50,1),(126,7428236,7428232,'ath',50,1),(126,7428237,7428235,'vmf',50,1),(126,7428238,7428235,'mfs',50,1),(126,7428239,7428237,'dev',20,1),(126,7428240,7428237,'evi',20,1),(126,7428241,7428237,'vic',20,1),(126,7428242,7428237,'ice',20,1),(126,7428243,7428237,'ces',20,1),(126,7428244,7428239,'dis',33.333,1),(126,7428245,7428239,'isk',33.333,1),(126,7428246,7428239,'sks',33.333,1),(126,7428247,7428244,'ven',25,1),(126,7428248,7428244,'end',25,1),(126,7428249,7428244,'ndo',25,1),(126,7428250,7428244,'dor',25,1),(126,7428251,7428247,'mod',33.333,1),(126,7428252,7428247,'ode',33.333,1),(126,7428253,7428247,'del',33.333,1),(126,7428254,7428251,'lun',100,1),(126,7428255,7428254,'cmo',33.333,1),(126,7428256,7428254,'mod',33.333,1),(126,7428257,7428254,'ode',33.333,1),(126,7428258,7428255,'rev',16.667,1),(126,7428259,7428255,'evi',16.667,1),(126,7428260,7428255,'vis',16.667,1),(126,7428261,7428255,'isi',16.667,1),(126,7428262,7428255,'sio',16.667,1),(126,7428263,7428255,'ion',16.667,1),(126,7428264,7428258,'810',50,1),(126,7428265,7428258,'100',50,1),(126,7428266,7428264,'scs',50,1),(126,7428267,7428264,'csi',50,1),(126,7428268,7428266,'lev',33.333,1),(126,7428269,7428266,'eve',33.333,1),(126,7428270,7428266,'vel',33.333,1),(126,7428271,7428268,'pse',25,1),(126,7428272,7428268,'seu',25,1),(126,7428273,7428268,'eud',25,1),(126,7428274,7428268,'udo',25,1),(126,7428275,7428271,'fal',33.333,6),(126,7428276,7428271,'als',33.333,6),(126,7428277,7428271,'lse',33.333,6),(126,7428278,7428275,'sta',25,3),(126,7428279,7428275,'tat',25,3),(126,7428280,7428275,'atu',25,3),(126,7428281,7428275,'tus',25,3),(126,7428282,7428278,'rdm',100,1),(126,7428283,7428282,'cap',20,1),(126,7428284,7428282,'apa',20,1),(126,7428285,7428282,'pab',20,1),(126,7428286,7428282,'abl',20,1),(126,7428287,7428282,'ble',20,1),(126,7428288,7428283,'tru',50,1),(126,7428289,7428283,'rue',50,1),(126,7428290,7428288,'loc',33.333,1),(126,7428291,7428288,'oca',33.333,1),(126,7428292,7428288,'cal',33.333,1),(126,7428293,7428290,'rem',14.286,1),(126,7428294,7428290,'emo',14.286,1),(126,7428295,7428290,'mov',14.286,1),(126,7428296,7428290,'ova',14.286,1),(126,7428297,7428290,'vab',14.286,1),(126,7428298,7428290,'abl',14.286,1),(126,7428299,7428290,'ble',14.286,1),(126,7428300,7428293,'ssd',100,1),(126,7428301,7428300,'off',20,1),(126,7428302,7428300,'ffl',20,1),(126,7428303,7428300,'fli',20,1),(126,7428304,7428300,'lin',20,1),(126,7428305,7428300,'ine',20,1),(126,7428306,7428301,'per',11.111,1),(126,7428307,7428301,'ere',11.111,1),(126,7428308,7428301,'ren',11.111,1),(126,7428309,7428301,'enn',11.111,1),(126,7428310,7428301,'nni',11.111,1),(126,7428311,7428301,'nia',11.111,1),(126,7428312,7428301,'ial',11.111,1),(126,7428313,7428301,'all',11.111,1),(126,7428314,7428301,'lly',11.111,1),(126,7428315,7428306,'res',16.667,1),(126,7428316,7428306,'ese',16.667,1),(126,7428317,7428306,'ser',16.667,1),(126,7428318,7428306,'erv',16.667,1),(126,7428319,7428306,'rve',16.667,1),(126,7428320,7428306,'ved',16.667,1),(126,7428321,7428315,'thi',50,1),(126,7428322,7428315,'hin',50,1),(126,7428323,7428321,'pro',10,1),(126,7428324,7428321,'rov',10,1),(126,7428325,7428321,'ovi',10,1),(126,7428326,7428321,'vis',10,1),(126,7428327,7428321,'isi',10,1),(126,7428328,7428321,'sio',10,1),(126,7428329,7428321,'ion',10,1),(126,7428330,7428321,'oni',10,1),(126,7428331,7428321,'nin',10,1),(126,7428332,7428321,'ing',10,1),(126,7428333,7428323,'yes',100,1),(126,7428334,7428333,'att',16.667,1),(126,7428335,7428333,'tta',16.667,1),(126,7428336,7428333,'tac',16.667,1),(126,7428337,7428333,'ach',16.667,1),(126,7428338,7428333,'che',16.667,1),(126,7428339,7428333,'hed',16.667,1),(126,7428340,7428334,'fil',20,1),(126,7428341,7428334,'ilt',20,1),(126,7428342,7428334,'lte',20,1),(126,7428343,7428334,'ter',20,1),(126,7428344,7428334,'ers',20,1),(126,7428345,7428340,'vaa',50,1),(126,7428346,7428340,'aai',50,1),(126,7428347,7428345,'unk',20,1),(126,7428348,7428345,'nkn',20,1),(126,7428349,7428345,'kno',20,1),(126,7428350,7428345,'now',20,1),(126,7428351,7428345,'own',20,1),(126,7428352,7428347,'oth',33.333,1),(126,7428353,7428347,'the',33.333,1),(126,7428354,7428347,'her',33.333,1),(126,7428355,7428352,'uid',50,1),(126,7428356,7428352,'ids',50,1),(126,7428357,7428355,'vml',100,1),(126,7428358,7428357,'dis',20,1),(126,7428359,7428357,'isp',20,1),(126,7428360,7428357,'spl',20,1),(126,7428361,7428357,'pla',20,1),(126,7428362,7428357,'lay',20,1),(126,7428363,7428358,'nam',50,1),(126,7428364,7428358,'ame',50,1),(127,7428366,7428365,'net',25,3),(127,7428367,7428365,'eta',25,3),(127,7428368,7428365,'tap',25,3),(127,7428369,7428365,'app',25,3),(127,7428370,7428366,'fib',33.333,2),(127,7428371,7428366,'ibr',33.333,2),(127,7428372,7428366,'bre',33.333,2),(127,7428373,7428370,'cha',20,2),(127,7428374,7428370,'han',20,2),(127,7428375,7428370,'ann',20,2),(127,7428376,7428370,'nne',20,2),(127,7428377,7428370,'nel',20,2),(127,7428378,7428373,'dis',50,2),(127,7428379,7428373,'isk',50,2),(127,7428380,7428378,'naa',100,4),(127,7428381,7428380,'600',3.333,4),(127,7428382,7428380,'00a',3.333,4),(127,7428383,7428380,'0a0',3.333,4),(127,7428384,7428380,'a09',3.333,4),(127,7428385,7428380,'098',3.333,4),(127,7428386,7428380,'980',3.333,4),(127,7428387,7428380,'804',3.333,4),(127,7428388,7428380,'044',3.333,4),(127,7428389,7428380,'443',3.333,4),(127,7428390,7428380,'430',3.333,4),(127,7428391,7428380,'307',3.333,4),(127,7428392,7428380,'075',3.333,4),(127,7428393,7428380,'753',3.333,4),(127,7428394,7428380,'535',3.333,4),(127,7428395,7428380,'357',3.333,4),(127,7428396,7428380,'573',3.333,4),(127,7428397,7428380,'732',3.333,4),(127,7428398,7428380,'32b',3.333,4),(127,7428399,7428380,'2b3',3.333,4),(127,7428400,7428380,'b33',3.333,4),(127,7428401,7428380,'334',3.333,4),(127,7428402,7428380,'345',3.333,4),(127,7428403,7428380,'457',3.333,4),(127,7428404,7428380,'571',3.333,4),(127,7428405,7428380,'715',3.333,4),(127,7428406,7428380,'153',3.333,4),(127,7428407,7428380,'533',3.333,4),(127,7428408,7428380,'335',3.333,4),(127,7428409,7428380,'357',3.333,4),(127,7428410,7428380,'571',3.333,4),(127,7428411,7428381,'ser',25,1),(127,7428412,7428381,'eri',25,1),(127,7428413,7428381,'ria',25,1),(127,7428414,7428381,'ial',25,1),(127,7428415,7428411,'siz',50,1),(127,7428416,7428411,'ize',50,1),(127,7428417,7428415,'321',100,1),(127,7428418,7428417,'dev',25,1),(127,7428419,7428417,'evi',25,1),(127,7428420,7428417,'vic',25,1),(127,7428421,7428417,'ice',25,1),(127,7428422,7428418,'typ',50,1),(127,7428423,7428418,'ype',50,1),(127,7428424,7428422,'dir',10,1),(127,7428425,7428422,'ire',10,1),(127,7428426,7428422,'rec',10,1),(127,7428427,7428422,'ect',10,1),(127,7428428,7428422,'cta',10,1),(127,7428429,7428422,'tac',10,1),(127,7428430,7428422,'acc',10,1),(127,7428431,7428422,'cce',10,1),(127,7428432,7428422,'ces',10,1),(127,7428433,7428422,'ess',10,1),(127,7428434,7428424,'mul',14.286,1),(127,7428435,7428424,'ult',14.286,1),(127,7428436,7428424,'lti',14.286,1),(127,7428437,7428424,'tip',14.286,1),(127,7428438,7428424,'ipa',14.286,1),(127,7428439,7428424,'pat',14.286,1),(127,7428440,7428424,'ath',14.286,1),(127,7428441,7428434,'plu',25,1),(127,7428442,7428434,'lug',25,1),(127,7428443,7428434,'ugi',25,1),(127,7428444,7428434,'gin',25,1),(127,7428445,7428441,'nmp',100,1),(127,7428446,7428445,'dev',33.333,1),(127,7428447,7428445,'evf',33.333,1),(127,7428448,7428445,'vfs',33.333,1),(127,7428449,7428446,'pat',50,1),(127,7428450,7428446,'ath',50,1),(127,7428451,7428449,'vmf',50,1),(127,7428452,7428449,'mfs',50,1),(127,7428453,7428451,'dev',20,1),(127,7428454,7428451,'evi',20,1),(127,7428455,7428451,'vic',20,1),(127,7428456,7428451,'ice',20,1),(127,7428457,7428451,'ces',20,1),(127,7428458,7428453,'dis',33.333,1),(127,7428459,7428453,'isk',33.333,1),(127,7428460,7428453,'sks',33.333,1),(127,7428461,7428458,'ven',25,1),(127,7428462,7428458,'end',25,1),(127,7428463,7428458,'ndo',25,1),(127,7428464,7428458,'dor',25,1),(127,7428465,7428461,'mod',33.333,1),(127,7428466,7428461,'ode',33.333,1),(127,7428467,7428461,'del',33.333,1),(127,7428468,7428465,'lun',100,1),(127,7428469,7428468,'cmo',33.333,1),(127,7428470,7428468,'mod',33.333,1),(127,7428471,7428468,'ode',33.333,1),(127,7428472,7428469,'rev',16.667,1),(127,7428473,7428469,'evi',16.667,1),(127,7428474,7428469,'vis',16.667,1),(127,7428475,7428469,'isi',16.667,1),(127,7428476,7428469,'sio',16.667,1),(127,7428477,7428469,'ion',16.667,1),(127,7428478,7428472,'810',50,1),(127,7428479,7428472,'100',50,1),(127,7428480,7428478,'scs',50,1),(127,7428481,7428478,'csi',50,1),(127,7428482,7428480,'lev',33.333,1),(127,7428483,7428480,'eve',33.333,1),(127,7428484,7428480,'vel',33.333,1),(127,7428485,7428482,'pse',25,1),(127,7428486,7428482,'seu',25,1),(127,7428487,7428482,'eud',25,1),(127,7428488,7428482,'udo',25,1),(127,7428489,7428485,'fal',33.333,6),(127,7428490,7428485,'als',33.333,6),(127,7428491,7428485,'lse',33.333,6),(127,7428492,7428489,'sta',25,3),(127,7428493,7428489,'tat',25,3),(127,7428494,7428489,'atu',25,3),(127,7428495,7428489,'tus',25,3),(127,7428496,7428492,'rdm',100,1),(127,7428497,7428496,'cap',20,1),(127,7428498,7428496,'apa',20,1),(127,7428499,7428496,'pab',20,1),(127,7428500,7428496,'abl',20,1),(127,7428501,7428496,'ble',20,1),(127,7428502,7428497,'tru',50,1),(127,7428503,7428497,'rue',50,1),(127,7428504,7428502,'loc',33.333,1),(127,7428505,7428502,'oca',33.333,1),(127,7428506,7428502,'cal',33.333,1),(127,7428507,7428504,'rem',14.286,1),(127,7428508,7428504,'emo',14.286,1),(127,7428509,7428504,'mov',14.286,1),(127,7428510,7428504,'ova',14.286,1),(127,7428511,7428504,'vab',14.286,1),(127,7428512,7428504,'abl',14.286,1),(127,7428513,7428504,'ble',14.286,1),(127,7428514,7428507,'ssd',100,1),(127,7428515,7428514,'off',20,1),(127,7428516,7428514,'ffl',20,1),(127,7428517,7428514,'fli',20,1),(127,7428518,7428514,'lin',20,1),(127,7428519,7428514,'ine',20,1),(127,7428520,7428515,'per',11.111,1),(127,7428521,7428515,'ere',11.111,1),(127,7428522,7428515,'ren',11.111,1),(127,7428523,7428515,'enn',11.111,1),(127,7428524,7428515,'nni',11.111,1),(127,7428525,7428515,'nia',11.111,1),(127,7428526,7428515,'ial',11.111,1),(127,7428527,7428515,'all',11.111,1),(127,7428528,7428515,'lly',11.111,1),(127,7428529,7428520,'res',16.667,1),(127,7428530,7428520,'ese',16.667,1),(127,7428531,7428520,'ser',16.667,1),(127,7428532,7428520,'erv',16.667,1),(127,7428533,7428520,'rve',16.667,1),(127,7428534,7428520,'ved',16.667,1),(127,7428535,7428529,'thi',50,1),(127,7428536,7428529,'hin',50,1),(127,7428537,7428535,'pro',10,1),(127,7428538,7428535,'rov',10,1),(127,7428539,7428535,'ovi',10,1),(127,7428540,7428535,'vis',10,1),(127,7428541,7428535,'isi',10,1),(127,7428542,7428535,'sio',10,1),(127,7428543,7428535,'ion',10,1),(127,7428544,7428535,'oni',10,1),(127,7428545,7428535,'nin',10,1),(127,7428546,7428535,'ing',10,1),(127,7428547,7428537,'yes',100,1),(127,7428548,7428547,'att',16.667,1),(127,7428549,7428547,'tta',16.667,1),(127,7428550,7428547,'tac',16.667,1),(127,7428551,7428547,'ach',16.667,1),(127,7428552,7428547,'che',16.667,1),(127,7428553,7428547,'hed',16.667,1),(127,7428554,7428548,'fil',20,1),(127,7428555,7428548,'ilt',20,1),(127,7428556,7428548,'lte',20,1),(127,7428557,7428548,'ter',20,1),(127,7428558,7428548,'ers',20,1),(127,7428559,7428554,'vaa',50,1),(127,7428560,7428554,'aai',50,1),(127,7428561,7428559,'unk',20,1),(127,7428562,7428559,'nkn',20,1),(127,7428563,7428559,'kno',20,1),(127,7428564,7428559,'now',20,1),(127,7428565,7428559,'own',20,1),(127,7428566,7428561,'oth',33.333,1),(127,7428567,7428561,'the',33.333,1),(127,7428568,7428561,'her',33.333,1),(127,7428569,7428566,'uid',50,1),(127,7428570,7428566,'ids',50,1),(127,7428571,7428569,'vml',100,1),(127,7428572,7428571,'dis',20,1),(127,7428573,7428571,'isp',20,1),(127,7428574,7428571,'spl',20,1),(127,7428575,7428571,'pla',20,1),(127,7428576,7428571,'lay',20,1),(127,7428577,7428572,'nam',50,1),(127,7428578,7428572,'ame',50,1),(128,7428580,7428579,'net',25,3),(128,7428581,7428579,'eta',25,3),(128,7428582,7428579,'tap',25,3),(128,7428583,7428579,'app',25,3),(128,7428584,7428580,'fib',33.333,2),(128,7428585,7428580,'ibr',33.333,2),(128,7428586,7428580,'bre',33.333,2),(128,7428587,7428584,'cha',20,2),(128,7428588,7428584,'han',20,2),(128,7428589,7428584,'ann',20,2),(128,7428590,7428584,'nne',20,2),(128,7428591,7428584,'nel',20,2),(128,7428592,7428587,'dis',50,2),(128,7428593,7428587,'isk',50,2),(128,7428594,7428592,'naa',100,4),(128,7428595,7428594,'600',3.333,4),(128,7428596,7428594,'00a',3.333,4),(128,7428597,7428594,'0a0',3.333,4),(128,7428598,7428594,'a09',3.333,4),(128,7428599,7428594,'098',3.333,4),(128,7428600,7428594,'980',3.333,4),(128,7428601,7428594,'804',3.333,4),(128,7428602,7428594,'044',3.333,4),(128,7428603,7428594,'443',3.333,4),(128,7428604,7428594,'430',3.333,4),(128,7428605,7428594,'307',3.333,4),(128,7428606,7428594,'075',3.333,4),(128,7428607,7428594,'753',3.333,4),(128,7428608,7428594,'535',3.333,4),(128,7428609,7428594,'357',3.333,4),(128,7428610,7428594,'573',3.333,4),(128,7428611,7428594,'732',3.333,4),(128,7428612,7428594,'32b',3.333,4),(128,7428613,7428594,'2b3',3.333,4),(128,7428614,7428594,'b33',3.333,4),(128,7428615,7428594,'334',3.333,4),(128,7428616,7428594,'345',3.333,4),(128,7428617,7428594,'457',3.333,4),(128,7428618,7428594,'571',3.333,4),(128,7428619,7428594,'715',3.333,4),(128,7428620,7428594,'153',3.333,4),(128,7428621,7428594,'533',3.333,4),(128,7428622,7428594,'335',3.333,4),(128,7428623,7428594,'357',3.333,4),(128,7428624,7428594,'572',3.333,4),(128,7428625,7428595,'ser',25,1),(128,7428626,7428595,'eri',25,1),(128,7428627,7428595,'ria',25,1),(128,7428628,7428595,'ial',25,1),(128,7428629,7428625,'siz',50,1),(128,7428630,7428625,'ize',50,1),(128,7428631,7428629,'321',100,1),(128,7428632,7428631,'dev',25,1),(128,7428633,7428631,'evi',25,1),(128,7428634,7428631,'vic',25,1),(128,7428635,7428631,'ice',25,1),(128,7428636,7428632,'typ',50,1),(128,7428637,7428632,'ype',50,1),(128,7428638,7428636,'dir',10,1),(128,7428639,7428636,'ire',10,1),(128,7428640,7428636,'rec',10,1),(128,7428641,7428636,'ect',10,1),(128,7428642,7428636,'cta',10,1),(128,7428643,7428636,'tac',10,1),(128,7428644,7428636,'acc',10,1),(128,7428645,7428636,'cce',10,1),(128,7428646,7428636,'ces',10,1),(128,7428647,7428636,'ess',10,1),(128,7428648,7428638,'mul',14.286,1),(128,7428649,7428638,'ult',14.286,1),(128,7428650,7428638,'lti',14.286,1),(128,7428651,7428638,'tip',14.286,1),(128,7428652,7428638,'ipa',14.286,1),(128,7428653,7428638,'pat',14.286,1),(128,7428654,7428638,'ath',14.286,1),(128,7428655,7428648,'plu',25,1),(128,7428656,7428648,'lug',25,1),(128,7428657,7428648,'ugi',25,1),(128,7428658,7428648,'gin',25,1),(128,7428659,7428655,'nmp',100,1),(128,7428660,7428659,'dev',33.333,1),(128,7428661,7428659,'evf',33.333,1),(128,7428662,7428659,'vfs',33.333,1),(128,7428663,7428660,'pat',50,1),(128,7428664,7428660,'ath',50,1),(128,7428665,7428663,'vmf',50,1),(128,7428666,7428663,'mfs',50,1),(128,7428667,7428665,'dev',20,1),(128,7428668,7428665,'evi',20,1),(128,7428669,7428665,'vic',20,1),(128,7428670,7428665,'ice',20,1),(128,7428671,7428665,'ces',20,1),(128,7428672,7428667,'dis',33.333,1),(128,7428673,7428667,'isk',33.333,1),(128,7428674,7428667,'sks',33.333,1),(128,7428675,7428672,'ven',25,1),(128,7428676,7428672,'end',25,1),(128,7428677,7428672,'ndo',25,1),(128,7428678,7428672,'dor',25,1),(128,7428679,7428675,'mod',33.333,1),(128,7428680,7428675,'ode',33.333,1),(128,7428681,7428675,'del',33.333,1),(128,7428682,7428679,'lun',100,1),(128,7428683,7428682,'cmo',33.333,1),(128,7428684,7428682,'mod',33.333,1),(128,7428685,7428682,'ode',33.333,1),(128,7428686,7428683,'rev',16.667,1),(128,7428687,7428683,'evi',16.667,1),(128,7428688,7428683,'vis',16.667,1),(128,7428689,7428683,'isi',16.667,1),(128,7428690,7428683,'sio',16.667,1),(128,7428691,7428683,'ion',16.667,1),(128,7428692,7428686,'810',50,1),(128,7428693,7428686,'100',50,1),(128,7428694,7428692,'scs',50,1),(128,7428695,7428692,'csi',50,1),(128,7428696,7428694,'lev',33.333,1),(128,7428697,7428694,'eve',33.333,1),(128,7428698,7428694,'vel',33.333,1),(128,7428699,7428696,'pse',25,1),(128,7428700,7428696,'seu',25,1),(128,7428701,7428696,'eud',25,1),(128,7428702,7428696,'udo',25,1),(128,7428703,7428699,'fal',33.333,6),(128,7428704,7428699,'als',33.333,6),(128,7428705,7428699,'lse',33.333,6),(128,7428706,7428703,'sta',25,3),(128,7428707,7428703,'tat',25,3),(128,7428708,7428703,'atu',25,3),(128,7428709,7428703,'tus',25,3),(128,7428710,7428706,'rdm',100,1),(128,7428711,7428710,'cap',20,1),(128,7428712,7428710,'apa',20,1),(128,7428713,7428710,'pab',20,1),(128,7428714,7428710,'abl',20,1),(128,7428715,7428710,'ble',20,1),(128,7428716,7428711,'tru',50,1),(128,7428717,7428711,'rue',50,1),(128,7428718,7428716,'loc',33.333,1),(128,7428719,7428716,'oca',33.333,1),(128,7428720,7428716,'cal',33.333,1),(128,7428721,7428718,'rem',14.286,1),(128,7428722,7428718,'emo',14.286,1),(128,7428723,7428718,'mov',14.286,1),(128,7428724,7428718,'ova',14.286,1),(128,7428725,7428718,'vab',14.286,1),(128,7428726,7428718,'abl',14.286,1),(128,7428727,7428718,'ble',14.286,1),(128,7428728,7428721,'ssd',100,1),(128,7428729,7428728,'off',20,1),(128,7428730,7428728,'ffl',20,1),(128,7428731,7428728,'fli',20,1),(128,7428732,7428728,'lin',20,1),(128,7428733,7428728,'ine',20,1),(128,7428734,7428729,'per',11.111,1),(128,7428735,7428729,'ere',11.111,1),(128,7428736,7428729,'ren',11.111,1),(128,7428737,7428729,'enn',11.111,1),(128,7428738,7428729,'nni',11.111,1),(128,7428739,7428729,'nia',11.111,1),(128,7428740,7428729,'ial',11.111,1),(128,7428741,7428729,'all',11.111,1),(128,7428742,7428729,'lly',11.111,1),(128,7428743,7428734,'res',16.667,1),(128,7428744,7428734,'ese',16.667,1),(128,7428745,7428734,'ser',16.667,1),(128,7428746,7428734,'erv',16.667,1),(128,7428747,7428734,'rve',16.667,1),(128,7428748,7428734,'ved',16.667,1),(128,7428749,7428743,'thi',50,1),(128,7428750,7428743,'hin',50,1),(128,7428751,7428749,'pro',10,1),(128,7428752,7428749,'rov',10,1),(128,7428753,7428749,'ovi',10,1),(128,7428754,7428749,'vis',10,1),(128,7428755,7428749,'isi',10,1),(128,7428756,7428749,'sio',10,1),(128,7428757,7428749,'ion',10,1),(128,7428758,7428749,'oni',10,1),(128,7428759,7428749,'nin',10,1),(128,7428760,7428749,'ing',10,1),(128,7428761,7428751,'yes',100,1),(128,7428762,7428761,'att',16.667,1),(128,7428763,7428761,'tta',16.667,1),(128,7428764,7428761,'tac',16.667,1),(128,7428765,7428761,'ach',16.667,1),(128,7428766,7428761,'che',16.667,1),(128,7428767,7428761,'hed',16.667,1),(128,7428768,7428762,'fil',20,1),(128,7428769,7428762,'ilt',20,1),(128,7428770,7428762,'lte',20,1),(128,7428771,7428762,'ter',20,1),(128,7428772,7428762,'ers',20,1),(128,7428773,7428768,'vaa',50,1),(128,7428774,7428768,'aai',50,1),(128,7428775,7428773,'unk',20,1),(128,7428776,7428773,'nkn',20,1),(128,7428777,7428773,'kno',20,1),(128,7428778,7428773,'now',20,1),(128,7428779,7428773,'own',20,1),(128,7428780,7428775,'oth',33.333,1),(128,7428781,7428775,'the',33.333,1),(128,7428782,7428775,'her',33.333,1),(128,7428783,7428780,'uid',50,1),(128,7428784,7428780,'ids',50,1),(128,7428785,7428783,'vml',100,1),(128,7428786,7428785,'dis',20,1),(128,7428787,7428785,'isp',20,1),(128,7428788,7428785,'spl',20,1),(128,7428789,7428785,'pla',20,1),(128,7428790,7428785,'lay',20,1),(128,7428791,7428786,'nam',50,1),(128,7428792,7428786,'ame',50,1),(129,7428794,7428793,'net',25,3),(129,7428795,7428793,'eta',25,3),(129,7428796,7428793,'tap',25,3),(129,7428797,7428793,'app',25,3),(129,7428798,7428794,'fib',33.333,2),(129,7428799,7428794,'ibr',33.333,2),(129,7428800,7428794,'bre',33.333,2),(129,7428801,7428798,'cha',20,2),(129,7428802,7428798,'han',20,2),(129,7428803,7428798,'ann',20,2),(129,7428804,7428798,'nne',20,2),(129,7428805,7428798,'nel',20,2),(129,7428806,7428801,'dis',50,2),(129,7428807,7428801,'isk',50,2),(129,7428808,7428806,'naa',100,4),(129,7428809,7428808,'600',3.333,4),(129,7428810,7428808,'00a',3.333,4),(129,7428811,7428808,'0a0',3.333,4),(129,7428812,7428808,'a09',3.333,4),(129,7428813,7428808,'098',3.333,4),(129,7428814,7428808,'980',3.333,4),(129,7428815,7428808,'804',3.333,4),(129,7428816,7428808,'044',3.333,4),(129,7428817,7428808,'443',3.333,4),(129,7428818,7428808,'430',3.333,4),(129,7428819,7428808,'307',3.333,4),(129,7428820,7428808,'075',3.333,4),(129,7428821,7428808,'753',3.333,4),(129,7428822,7428808,'535',3.333,4),(129,7428823,7428808,'357',3.333,4),(129,7428824,7428808,'573',3.333,4),(129,7428825,7428808,'732',3.333,4),(129,7428826,7428808,'32b',3.333,4),(129,7428827,7428808,'2b3',3.333,4),(129,7428828,7428808,'b33',3.333,4),(129,7428829,7428808,'334',3.333,4),(129,7428830,7428808,'345',3.333,4),(129,7428831,7428808,'457',3.333,4),(129,7428832,7428808,'571',3.333,4),(129,7428833,7428808,'715',3.333,4),(129,7428834,7428808,'153',3.333,4),(129,7428835,7428808,'533',3.333,4),(129,7428836,7428808,'336',3.333,4),(129,7428837,7428808,'365',3.333,4),(129,7428838,7428808,'650',3.333,4),(129,7428839,7428809,'ser',25,1),(129,7428840,7428809,'eri',25,1),(129,7428841,7428809,'ria',25,1),(129,7428842,7428809,'ial',25,1),(129,7428843,7428839,'siz',50,1),(129,7428844,7428839,'ize',50,1),(129,7428845,7428843,'321',100,1),(129,7428846,7428845,'dev',25,1),(129,7428847,7428845,'evi',25,1),(129,7428848,7428845,'vic',25,1),(129,7428849,7428845,'ice',25,1),(129,7428850,7428846,'typ',50,1),(129,7428851,7428846,'ype',50,1),(129,7428852,7428850,'dir',10,1),(129,7428853,7428850,'ire',10,1),(129,7428854,7428850,'rec',10,1),(129,7428855,7428850,'ect',10,1),(129,7428856,7428850,'cta',10,1),(129,7428857,7428850,'tac',10,1),(129,7428858,7428850,'acc',10,1),(129,7428859,7428850,'cce',10,1),(129,7428860,7428850,'ces',10,1),(129,7428861,7428850,'ess',10,1),(129,7428862,7428852,'mul',14.286,1),(129,7428863,7428852,'ult',14.286,1),(129,7428864,7428852,'lti',14.286,1),(129,7428865,7428852,'tip',14.286,1),(129,7428866,7428852,'ipa',14.286,1),(129,7428867,7428852,'pat',14.286,1),(129,7428868,7428852,'ath',14.286,1),(129,7428869,7428862,'plu',25,1),(129,7428870,7428862,'lug',25,1),(129,7428871,7428862,'ugi',25,1),(129,7428872,7428862,'gin',25,1),(129,7428873,7428869,'nmp',100,1),(129,7428874,7428873,'dev',33.333,1),(129,7428875,7428873,'evf',33.333,1),(129,7428876,7428873,'vfs',33.333,1),(129,7428877,7428874,'pat',50,1),(129,7428878,7428874,'ath',50,1),(129,7428879,7428877,'vmf',50,1),(129,7428880,7428877,'mfs',50,1),(129,7428881,7428879,'dev',20,1),(129,7428882,7428879,'evi',20,1),(129,7428883,7428879,'vic',20,1),(129,7428884,7428879,'ice',20,1),(129,7428885,7428879,'ces',20,1),(129,7428886,7428881,'dis',33.333,1),(129,7428887,7428881,'isk',33.333,1),(129,7428888,7428881,'sks',33.333,1),(129,7428889,7428886,'ven',25,1),(129,7428890,7428886,'end',25,1),(129,7428891,7428886,'ndo',25,1),(129,7428892,7428886,'dor',25,1),(129,7428893,7428889,'mod',33.333,1),(129,7428894,7428889,'ode',33.333,1),(129,7428895,7428889,'del',33.333,1),(129,7428896,7428893,'lun',100,1),(129,7428897,7428896,'cmo',33.333,1),(129,7428898,7428896,'mod',33.333,1),(129,7428899,7428896,'ode',33.333,1),(129,7428900,7428897,'rev',16.667,1),(129,7428901,7428897,'evi',16.667,1),(129,7428902,7428897,'vis',16.667,1),(129,7428903,7428897,'isi',16.667,1),(129,7428904,7428897,'sio',16.667,1),(129,7428905,7428897,'ion',16.667,1),(129,7428906,7428900,'810',50,1),(129,7428907,7428900,'100',50,1),(129,7428908,7428906,'scs',50,1),(129,7428909,7428906,'csi',50,1),(129,7428910,7428908,'lev',33.333,1),(129,7428911,7428908,'eve',33.333,1),(129,7428912,7428908,'vel',33.333,1),(129,7428913,7428910,'pse',25,1),(129,7428914,7428910,'seu',25,1),(129,7428915,7428910,'eud',25,1),(129,7428916,7428910,'udo',25,1),(129,7428917,7428913,'fal',33.333,6),(129,7428918,7428913,'als',33.333,6),(129,7428919,7428913,'lse',33.333,6),(129,7428920,7428917,'sta',25,3),(129,7428921,7428917,'tat',25,3),(129,7428922,7428917,'atu',25,3),(129,7428923,7428917,'tus',25,3),(129,7428924,7428920,'rdm',100,1),(129,7428925,7428924,'cap',20,1),(129,7428926,7428924,'apa',20,1),(129,7428927,7428924,'pab',20,1),(129,7428928,7428924,'abl',20,1),(129,7428929,7428924,'ble',20,1),(129,7428930,7428925,'tru',50,1),(129,7428931,7428925,'rue',50,1),(129,7428932,7428930,'loc',33.333,1),(129,7428933,7428930,'oca',33.333,1),(129,7428934,7428930,'cal',33.333,1),(129,7428935,7428932,'rem',14.286,1),(129,7428936,7428932,'emo',14.286,1),(129,7428937,7428932,'mov',14.286,1),(129,7428938,7428932,'ova',14.286,1),(129,7428939,7428932,'vab',14.286,1),(129,7428940,7428932,'abl',14.286,1),(129,7428941,7428932,'ble',14.286,1),(129,7428942,7428935,'ssd',100,1),(129,7428943,7428942,'off',20,1),(129,7428944,7428942,'ffl',20,1),(129,7428945,7428942,'fli',20,1),(129,7428946,7428942,'lin',20,1),(129,7428947,7428942,'ine',20,1),(129,7428948,7428943,'per',11.111,1),(129,7428949,7428943,'ere',11.111,1),(129,7428950,7428943,'ren',11.111,1),(129,7428951,7428943,'enn',11.111,1),(129,7428952,7428943,'nni',11.111,1),(129,7428953,7428943,'nia',11.111,1),(129,7428954,7428943,'ial',11.111,1),(129,7428955,7428943,'all',11.111,1),(129,7428956,7428943,'lly',11.111,1),(129,7428957,7428948,'res',16.667,1),(129,7428958,7428948,'ese',16.667,1),(129,7428959,7428948,'ser',16.667,1),(129,7428960,7428948,'erv',16.667,1),(129,7428961,7428948,'rve',16.667,1),(129,7428962,7428948,'ved',16.667,1),(129,7428963,7428957,'thi',50,1),(129,7428964,7428957,'hin',50,1),(129,7428965,7428963,'pro',10,1),(129,7428966,7428963,'rov',10,1),(129,7428967,7428963,'ovi',10,1),(129,7428968,7428963,'vis',10,1),(129,7428969,7428963,'isi',10,1),(129,7428970,7428963,'sio',10,1),(129,7428971,7428963,'ion',10,1),(129,7428972,7428963,'oni',10,1),(129,7428973,7428963,'nin',10,1),(129,7428974,7428963,'ing',10,1),(129,7428975,7428965,'yes',100,1),(129,7428976,7428975,'att',16.667,1),(129,7428977,7428975,'tta',16.667,1),(129,7428978,7428975,'tac',16.667,1),(129,7428979,7428975,'ach',16.667,1),(129,7428980,7428975,'che',16.667,1),(129,7428981,7428975,'hed',16.667,1),(129,7428982,7428976,'fil',20,1),(129,7428983,7428976,'ilt',20,1),(129,7428984,7428976,'lte',20,1),(129,7428985,7428976,'ter',20,1),(129,7428986,7428976,'ers',20,1),(129,7428987,7428982,'vaa',50,1),(129,7428988,7428982,'aai',50,1),(129,7428989,7428987,'unk',20,1),(129,7428990,7428987,'nkn',20,1),(129,7428991,7428987,'kno',20,1),(129,7428992,7428987,'now',20,1),(129,7428993,7428987,'own',20,1),(129,7428994,7428989,'oth',33.333,1),(129,7428995,7428989,'the',33.333,1),(129,7428996,7428989,'her',33.333,1),(129,7428997,7428994,'uid',50,1),(129,7428998,7428994,'ids',50,1),(129,7428999,7428997,'vml',100,1),(129,7429000,7428999,'dis',20,1),(129,7429001,7428999,'isp',20,1),(129,7429002,7428999,'spl',20,1),(129,7429003,7428999,'pla',20,1),(129,7429004,7428999,'lay',20,1),(129,7429005,7429000,'nam',50,1),(129,7429006,7429000,'ame',50,1),(130,7429008,7429007,'net',25,3),(130,7429009,7429007,'eta',25,3),(130,7429010,7429007,'tap',25,3),(130,7429011,7429007,'app',25,3),(130,7429012,7429008,'fib',33.333,2),(130,7429013,7429008,'ibr',33.333,2),(130,7429014,7429008,'bre',33.333,2),(130,7429015,7429012,'cha',20,2),(130,7429016,7429012,'han',20,2),(130,7429017,7429012,'ann',20,2),(130,7429018,7429012,'nne',20,2),(130,7429019,7429012,'nel',20,2),(130,7429020,7429015,'dis',50,2),(130,7429021,7429015,'isk',50,2),(130,7429022,7429020,'naa',100,4),(130,7429023,7429022,'600',3.333,4),(130,7429024,7429022,'00a',3.333,4),(130,7429025,7429022,'0a0',3.333,4),(130,7429026,7429022,'a09',3.333,4),(130,7429027,7429022,'098',3.333,4),(130,7429028,7429022,'980',3.333,4),(130,7429029,7429022,'804',3.333,4),(130,7429030,7429022,'044',3.333,4),(130,7429031,7429022,'443',3.333,4),(130,7429032,7429022,'430',3.333,4),(130,7429033,7429022,'307',3.333,4),(130,7429034,7429022,'075',3.333,4),(130,7429035,7429022,'753',3.333,4),(130,7429036,7429022,'535',3.333,4),(130,7429037,7429022,'357',3.333,4),(130,7429038,7429022,'573',3.333,4),(130,7429039,7429022,'732',3.333,4),(130,7429040,7429022,'32b',3.333,4),(130,7429041,7429022,'2b3',3.333,4),(130,7429042,7429022,'b33',3.333,4),(130,7429043,7429022,'334',3.333,4),(130,7429044,7429022,'345',3.333,4),(130,7429045,7429022,'457',3.333,4),(130,7429046,7429022,'571',3.333,4),(130,7429047,7429022,'715',3.333,4),(130,7429048,7429022,'153',3.333,4),(130,7429049,7429022,'533',3.333,4),(130,7429050,7429022,'335',3.333,4),(130,7429051,7429022,'357',3.333,4),(130,7429052,7429022,'573',3.333,4),(130,7429053,7429023,'ser',25,1),(130,7429054,7429023,'eri',25,1),(130,7429055,7429023,'ria',25,1),(130,7429056,7429023,'ial',25,1),(130,7429057,7429053,'siz',50,1),(130,7429058,7429053,'ize',50,1),(130,7429059,7429057,'321',100,1),(130,7429060,7429059,'dev',25,1),(130,7429061,7429059,'evi',25,1),(130,7429062,7429059,'vic',25,1),(130,7429063,7429059,'ice',25,1),(130,7429064,7429060,'typ',50,1),(130,7429065,7429060,'ype',50,1),(130,7429066,7429064,'dir',10,1),(130,7429067,7429064,'ire',10,1),(130,7429068,7429064,'rec',10,1),(130,7429069,7429064,'ect',10,1),(130,7429070,7429064,'cta',10,1),(130,7429071,7429064,'tac',10,1),(130,7429072,7429064,'acc',10,1),(130,7429073,7429064,'cce',10,1),(130,7429074,7429064,'ces',10,1),(130,7429075,7429064,'ess',10,1),(130,7429076,7429066,'mul',14.286,1),(130,7429077,7429066,'ult',14.286,1),(130,7429078,7429066,'lti',14.286,1),(130,7429079,7429066,'tip',14.286,1),(130,7429080,7429066,'ipa',14.286,1),(130,7429081,7429066,'pat',14.286,1),(130,7429082,7429066,'ath',14.286,1),(130,7429083,7429076,'plu',25,1),(130,7429084,7429076,'lug',25,1),(130,7429085,7429076,'ugi',25,1),(130,7429086,7429076,'gin',25,1),(130,7429087,7429083,'nmp',100,1),(130,7429088,7429087,'dev',33.333,1),(130,7429089,7429087,'evf',33.333,1),(130,7429090,7429087,'vfs',33.333,1),(130,7429091,7429088,'pat',50,1),(130,7429092,7429088,'ath',50,1),(130,7429093,7429091,'vmf',50,1),(130,7429094,7429091,'mfs',50,1),(130,7429095,7429093,'dev',20,1),(130,7429096,7429093,'evi',20,1),(130,7429097,7429093,'vic',20,1),(130,7429098,7429093,'ice',20,1),(130,7429099,7429093,'ces',20,1),(130,7429100,7429095,'dis',33.333,1),(130,7429101,7429095,'isk',33.333,1),(130,7429102,7429095,'sks',33.333,1),(130,7429103,7429100,'ven',25,1),(130,7429104,7429100,'end',25,1),(130,7429105,7429100,'ndo',25,1),(130,7429106,7429100,'dor',25,1),(130,7429107,7429103,'mod',33.333,1),(130,7429108,7429103,'ode',33.333,1),(130,7429109,7429103,'del',33.333,1),(130,7429110,7429107,'lun',100,1),(130,7429111,7429110,'cmo',33.333,1),(130,7429112,7429110,'mod',33.333,1),(130,7429113,7429110,'ode',33.333,1),(130,7429114,7429111,'rev',16.667,1),(130,7429115,7429111,'evi',16.667,1),(130,7429116,7429111,'vis',16.667,1),(130,7429117,7429111,'isi',16.667,1),(130,7429118,7429111,'sio',16.667,1),(130,7429119,7429111,'ion',16.667,1),(130,7429120,7429114,'810',50,1),(130,7429121,7429114,'100',50,1),(130,7429122,7429120,'scs',50,1),(130,7429123,7429120,'csi',50,1),(130,7429124,7429122,'lev',33.333,1),(130,7429125,7429122,'eve',33.333,1),(130,7429126,7429122,'vel',33.333,1),(130,7429127,7429124,'pse',25,1),(130,7429128,7429124,'seu',25,1),(130,7429129,7429124,'eud',25,1),(130,7429130,7429124,'udo',25,1),(130,7429131,7429127,'fal',33.333,6),(130,7429132,7429127,'als',33.333,6),(130,7429133,7429127,'lse',33.333,6),(130,7429134,7429131,'sta',25,3),(130,7429135,7429131,'tat',25,3),(130,7429136,7429131,'atu',25,3),(130,7429137,7429131,'tus',25,3),(130,7429138,7429134,'rdm',100,1),(130,7429139,7429138,'cap',20,1),(130,7429140,7429138,'apa',20,1),(130,7429141,7429138,'pab',20,1),(130,7429142,7429138,'abl',20,1),(130,7429143,7429138,'ble',20,1),(130,7429144,7429139,'tru',50,1),(130,7429145,7429139,'rue',50,1),(130,7429146,7429144,'loc',33.333,1),(130,7429147,7429144,'oca',33.333,1),(130,7429148,7429144,'cal',33.333,1),(130,7429149,7429146,'rem',14.286,1),(130,7429150,7429146,'emo',14.286,1),(130,7429151,7429146,'mov',14.286,1),(130,7429152,7429146,'ova',14.286,1),(130,7429153,7429146,'vab',14.286,1),(130,7429154,7429146,'abl',14.286,1),(130,7429155,7429146,'ble',14.286,1),(130,7429156,7429149,'ssd',100,1),(130,7429157,7429156,'off',20,1),(130,7429158,7429156,'ffl',20,1),(130,7429159,7429156,'fli',20,1),(130,7429160,7429156,'lin',20,1),(130,7429161,7429156,'ine',20,1),(130,7429162,7429157,'per',11.111,1),(130,7429163,7429157,'ere',11.111,1),(130,7429164,7429157,'ren',11.111,1),(130,7429165,7429157,'enn',11.111,1),(130,7429166,7429157,'nni',11.111,1),(130,7429167,7429157,'nia',11.111,1),(130,7429168,7429157,'ial',11.111,1),(130,7429169,7429157,'all',11.111,1),(130,7429170,7429157,'lly',11.111,1),(130,7429171,7429162,'res',16.667,1),(130,7429172,7429162,'ese',16.667,1),(130,7429173,7429162,'ser',16.667,1),(130,7429174,7429162,'erv',16.667,1),(130,7429175,7429162,'rve',16.667,1),(130,7429176,7429162,'ved',16.667,1),(130,7429177,7429171,'thi',50,1),(130,7429178,7429171,'hin',50,1),(130,7429179,7429177,'pro',10,1),(130,7429180,7429177,'rov',10,1),(130,7429181,7429177,'ovi',10,1),(130,7429182,7429177,'vis',10,1),(130,7429183,7429177,'isi',10,1),(130,7429184,7429177,'sio',10,1),(130,7429185,7429177,'ion',10,1),(130,7429186,7429177,'oni',10,1),(130,7429187,7429177,'nin',10,1),(130,7429188,7429177,'ing',10,1),(130,7429189,7429179,'yes',100,1),(130,7429190,7429189,'att',16.667,1),(130,7429191,7429189,'tta',16.667,1),(130,7429192,7429189,'tac',16.667,1),(130,7429193,7429189,'ach',16.667,1),(130,7429194,7429189,'che',16.667,1),(130,7429195,7429189,'hed',16.667,1),(130,7429196,7429190,'fil',20,1),(130,7429197,7429190,'ilt',20,1),(130,7429198,7429190,'lte',20,1),(130,7429199,7429190,'ter',20,1),(130,7429200,7429190,'ers',20,1),(130,7429201,7429196,'vaa',50,1),(130,7429202,7429196,'aai',50,1),(130,7429203,7429201,'unk',20,1),(130,7429204,7429201,'nkn',20,1),(130,7429205,7429201,'kno',20,1),(130,7429206,7429201,'now',20,1),(130,7429207,7429201,'own',20,1),(130,7429208,7429203,'oth',33.333,1),(130,7429209,7429203,'the',33.333,1),(130,7429210,7429203,'her',33.333,1),(130,7429211,7429208,'uid',50,1),(130,7429212,7429208,'ids',50,1),(130,7429213,7429211,'vml',100,1),(130,7429214,7429213,'dis',20,1),(130,7429215,7429213,'isp',20,1),(130,7429216,7429213,'spl',20,1),(130,7429217,7429213,'pla',20,1),(130,7429218,7429213,'lay',20,1),(130,7429219,7429214,'nam',50,1),(130,7429220,7429214,'ame',50,1),(131,7429222,7429221,'net',25,3),(131,7429223,7429221,'eta',25,3),(131,7429224,7429221,'tap',25,3),(131,7429225,7429221,'app',25,3),(131,7429226,7429222,'fib',33.333,2),(131,7429227,7429222,'ibr',33.333,2),(131,7429228,7429222,'bre',33.333,2),(131,7429229,7429226,'cha',20,2),(131,7429230,7429226,'han',20,2),(131,7429231,7429226,'ann',20,2),(131,7429232,7429226,'nne',20,2),(131,7429233,7429226,'nel',20,2),(131,7429234,7429229,'dis',50,2),(131,7429235,7429229,'isk',50,2),(131,7429236,7429234,'naa',100,4),(131,7429237,7429236,'600',3.333,4),(131,7429238,7429236,'00a',3.333,4),(131,7429239,7429236,'0a0',3.333,4),(131,7429240,7429236,'a09',3.333,4),(131,7429241,7429236,'098',3.333,4),(131,7429242,7429236,'980',3.333,4),(131,7429243,7429236,'804',3.333,4),(131,7429244,7429236,'044',3.333,4),(131,7429245,7429236,'443',3.333,4),(131,7429246,7429236,'430',3.333,4),(131,7429247,7429236,'307',3.333,4),(131,7429248,7429236,'075',3.333,4),(131,7429249,7429236,'753',3.333,4),(131,7429250,7429236,'535',3.333,4),(131,7429251,7429236,'357',3.333,4),(131,7429252,7429236,'573',3.333,4),(131,7429253,7429236,'732',3.333,4),(131,7429254,7429236,'32b',3.333,4),(131,7429255,7429236,'2b3',3.333,4),(131,7429256,7429236,'b33',3.333,4),(131,7429257,7429236,'334',3.333,4),(131,7429258,7429236,'345',3.333,4),(131,7429259,7429236,'457',3.333,4),(131,7429260,7429236,'571',3.333,4),(131,7429261,7429236,'715',3.333,4),(131,7429262,7429236,'153',3.333,4),(131,7429263,7429236,'533',3.333,4),(131,7429264,7429236,'336',3.333,4),(131,7429265,7429236,'365',3.333,4),(131,7429266,7429236,'651',3.333,4),(131,7429267,7429237,'ser',25,1),(131,7429268,7429237,'eri',25,1),(131,7429269,7429237,'ria',25,1),(131,7429270,7429237,'ial',25,1),(131,7429271,7429267,'siz',50,1),(131,7429272,7429267,'ize',50,1),(131,7429273,7429271,'321',100,1),(131,7429274,7429273,'dev',25,1),(131,7429275,7429273,'evi',25,1),(131,7429276,7429273,'vic',25,1),(131,7429277,7429273,'ice',25,1),(131,7429278,7429274,'typ',50,1),(131,7429279,7429274,'ype',50,1),(131,7429280,7429278,'dir',10,1),(131,7429281,7429278,'ire',10,1),(131,7429282,7429278,'rec',10,1),(131,7429283,7429278,'ect',10,1),(131,7429284,7429278,'cta',10,1),(131,7429285,7429278,'tac',10,1),(131,7429286,7429278,'acc',10,1),(131,7429287,7429278,'cce',10,1),(131,7429288,7429278,'ces',10,1),(131,7429289,7429278,'ess',10,1),(131,7429290,7429280,'mul',14.286,1),(131,7429291,7429280,'ult',14.286,1),(131,7429292,7429280,'lti',14.286,1),(131,7429293,7429280,'tip',14.286,1),(131,7429294,7429280,'ipa',14.286,1),(131,7429295,7429280,'pat',14.286,1),(131,7429296,7429280,'ath',14.286,1),(131,7429297,7429290,'plu',25,1),(131,7429298,7429290,'lug',25,1),(131,7429299,7429290,'ugi',25,1),(131,7429300,7429290,'gin',25,1),(131,7429301,7429297,'nmp',100,1),(131,7429302,7429301,'dev',33.333,1),(131,7429303,7429301,'evf',33.333,1),(131,7429304,7429301,'vfs',33.333,1),(131,7429305,7429302,'pat',50,1),(131,7429306,7429302,'ath',50,1),(131,7429307,7429305,'vmf',50,1),(131,7429308,7429305,'mfs',50,1),(131,7429309,7429307,'dev',20,1),(131,7429310,7429307,'evi',20,1),(131,7429311,7429307,'vic',20,1),(131,7429312,7429307,'ice',20,1),(131,7429313,7429307,'ces',20,1),(131,7429314,7429309,'dis',33.333,1),(131,7429315,7429309,'isk',33.333,1),(131,7429316,7429309,'sks',33.333,1),(131,7429317,7429314,'ven',25,1),(131,7429318,7429314,'end',25,1),(131,7429319,7429314,'ndo',25,1),(131,7429320,7429314,'dor',25,1),(131,7429321,7429317,'mod',33.333,1),(131,7429322,7429317,'ode',33.333,1),(131,7429323,7429317,'del',33.333,1),(131,7429324,7429321,'lun',100,1),(131,7429325,7429324,'cmo',33.333,1),(131,7429326,7429324,'mod',33.333,1),(131,7429327,7429324,'ode',33.333,1),(131,7429328,7429325,'rev',16.667,1),(131,7429329,7429325,'evi',16.667,1),(131,7429330,7429325,'vis',16.667,1),(131,7429331,7429325,'isi',16.667,1),(131,7429332,7429325,'sio',16.667,1),(131,7429333,7429325,'ion',16.667,1),(131,7429334,7429328,'810',50,1),(131,7429335,7429328,'100',50,1),(131,7429336,7429334,'scs',50,1),(131,7429337,7429334,'csi',50,1),(131,7429338,7429336,'lev',33.333,1),(131,7429339,7429336,'eve',33.333,1),(131,7429340,7429336,'vel',33.333,1),(131,7429341,7429338,'pse',25,1),(131,7429342,7429338,'seu',25,1),(131,7429343,7429338,'eud',25,1),(131,7429344,7429338,'udo',25,1),(131,7429345,7429341,'fal',33.333,6),(131,7429346,7429341,'als',33.333,6),(131,7429347,7429341,'lse',33.333,6),(131,7429348,7429345,'sta',25,3),(131,7429349,7429345,'tat',25,3),(131,7429350,7429345,'atu',25,3),(131,7429351,7429345,'tus',25,3),(131,7429352,7429348,'rdm',100,1),(131,7429353,7429352,'cap',20,1),(131,7429354,7429352,'apa',20,1),(131,7429355,7429352,'pab',20,1),(131,7429356,7429352,'abl',20,1),(131,7429357,7429352,'ble',20,1),(131,7429358,7429353,'tru',50,1),(131,7429359,7429353,'rue',50,1),(131,7429360,7429358,'loc',33.333,1),(131,7429361,7429358,'oca',33.333,1),(131,7429362,7429358,'cal',33.333,1),(131,7429363,7429360,'rem',14.286,1),(131,7429364,7429360,'emo',14.286,1),(131,7429365,7429360,'mov',14.286,1),(131,7429366,7429360,'ova',14.286,1),(131,7429367,7429360,'vab',14.286,1),(131,7429368,7429360,'abl',14.286,1),(131,7429369,7429360,'ble',14.286,1),(131,7429370,7429363,'ssd',100,1),(131,7429371,7429370,'off',20,1),(131,7429372,7429370,'ffl',20,1),(131,7429373,7429370,'fli',20,1),(131,7429374,7429370,'lin',20,1),(131,7429375,7429370,'ine',20,1),(131,7429376,7429371,'per',11.111,1),(131,7429377,7429371,'ere',11.111,1),(131,7429378,7429371,'ren',11.111,1),(131,7429379,7429371,'enn',11.111,1),(131,7429380,7429371,'nni',11.111,1),(131,7429381,7429371,'nia',11.111,1),(131,7429382,7429371,'ial',11.111,1),(131,7429383,7429371,'all',11.111,1),(131,7429384,7429371,'lly',11.111,1),(131,7429385,7429376,'res',16.667,1),(131,7429386,7429376,'ese',16.667,1),(131,7429387,7429376,'ser',16.667,1),(131,7429388,7429376,'erv',16.667,1),(131,7429389,7429376,'rve',16.667,1),(131,7429390,7429376,'ved',16.667,1),(131,7429391,7429385,'thi',50,1),(131,7429392,7429385,'hin',50,1),(131,7429393,7429391,'pro',10,1),(131,7429394,7429391,'rov',10,1),(131,7429395,7429391,'ovi',10,1),(131,7429396,7429391,'vis',10,1),(131,7429397,7429391,'isi',10,1),(131,7429398,7429391,'sio',10,1),(131,7429399,7429391,'ion',10,1),(131,7429400,7429391,'oni',10,1),(131,7429401,7429391,'nin',10,1),(131,7429402,7429391,'ing',10,1),(131,7429403,7429393,'yes',100,1),(131,7429404,7429403,'att',16.667,1),(131,7429405,7429403,'tta',16.667,1),(131,7429406,7429403,'tac',16.667,1),(131,7429407,7429403,'ach',16.667,1),(131,7429408,7429403,'che',16.667,1),(131,7429409,7429403,'hed',16.667,1),(131,7429410,7429404,'fil',20,1),(131,7429411,7429404,'ilt',20,1),(131,7429412,7429404,'lte',20,1),(131,7429413,7429404,'ter',20,1),(131,7429414,7429404,'ers',20,1),(131,7429415,7429410,'vaa',50,1),(131,7429416,7429410,'aai',50,1),(131,7429417,7429415,'unk',20,1),(131,7429418,7429415,'nkn',20,1),(131,7429419,7429415,'kno',20,1),(131,7429420,7429415,'now',20,1),(131,7429421,7429415,'own',20,1),(131,7429422,7429417,'oth',33.333,1),(131,7429423,7429417,'the',33.333,1),(131,7429424,7429417,'her',33.333,1),(131,7429425,7429422,'uid',50,1),(131,7429426,7429422,'ids',50,1),(131,7429427,7429425,'vml',100,1),(131,7429428,7429427,'dis',20,1),(131,7429429,7429427,'isp',20,1),(131,7429430,7429427,'spl',20,1),(131,7429431,7429427,'pla',20,1),(131,7429432,7429427,'lay',20,1),(131,7429433,7429428,'nam',50,1),(131,7429434,7429428,'ame',50,1),(132,7429436,7429435,'net',25,3),(132,7429437,7429435,'eta',25,3),(132,7429438,7429435,'tap',25,3),(132,7429439,7429435,'app',25,3),(132,7429440,7429436,'fib',33.333,2),(132,7429441,7429436,'ibr',33.333,2),(132,7429442,7429436,'bre',33.333,2),(132,7429443,7429440,'cha',20,2),(132,7429444,7429440,'han',20,2),(132,7429445,7429440,'ann',20,2),(132,7429446,7429440,'nne',20,2),(132,7429447,7429440,'nel',20,2),(132,7429448,7429443,'dis',50,2),(132,7429449,7429443,'isk',50,2),(132,7429450,7429448,'naa',100,4),(132,7429451,7429450,'600',3.333,4),(132,7429452,7429450,'00a',3.333,4),(132,7429453,7429450,'0a0',3.333,4),(132,7429454,7429450,'a09',3.333,4),(132,7429455,7429450,'098',3.333,4),(132,7429456,7429450,'980',3.333,4),(132,7429457,7429450,'804',3.333,4),(132,7429458,7429450,'044',3.333,4),(132,7429459,7429450,'443',3.333,4),(132,7429460,7429450,'430',3.333,4),(132,7429461,7429450,'307',3.333,4),(132,7429462,7429450,'075',3.333,4),(132,7429463,7429450,'753',3.333,4),(132,7429464,7429450,'535',3.333,4),(132,7429465,7429450,'357',3.333,4),(132,7429466,7429450,'573',3.333,4),(132,7429467,7429450,'732',3.333,4),(132,7429468,7429450,'32b',3.333,4),(132,7429469,7429450,'2b3',3.333,4),(132,7429470,7429450,'b33',3.333,4),(132,7429471,7429450,'334',3.333,4),(132,7429472,7429450,'345',3.333,4),(132,7429473,7429450,'457',3.333,4),(132,7429474,7429450,'571',3.333,4),(132,7429475,7429450,'715',3.333,4),(132,7429476,7429450,'153',3.333,4),(132,7429477,7429450,'533',3.333,4),(132,7429478,7429450,'335',3.333,4),(132,7429479,7429450,'357',3.333,4),(132,7429480,7429450,'574',3.333,4),(132,7429481,7429451,'ser',25,1),(132,7429482,7429451,'eri',25,1),(132,7429483,7429451,'ria',25,1),(132,7429484,7429451,'ial',25,1),(132,7429485,7429481,'siz',50,1),(132,7429486,7429481,'ize',50,1),(132,7429487,7429485,'321',100,1),(132,7429488,7429487,'dev',25,1),(132,7429489,7429487,'evi',25,1),(132,7429490,7429487,'vic',25,1),(132,7429491,7429487,'ice',25,1),(132,7429492,7429488,'typ',50,1),(132,7429493,7429488,'ype',50,1),(132,7429494,7429492,'dir',10,1),(132,7429495,7429492,'ire',10,1),(132,7429496,7429492,'rec',10,1),(132,7429497,7429492,'ect',10,1),(132,7429498,7429492,'cta',10,1),(132,7429499,7429492,'tac',10,1),(132,7429500,7429492,'acc',10,1),(132,7429501,7429492,'cce',10,1),(132,7429502,7429492,'ces',10,1),(132,7429503,7429492,'ess',10,1),(132,7429504,7429494,'mul',14.286,1),(132,7429505,7429494,'ult',14.286,1),(132,7429506,7429494,'lti',14.286,1),(132,7429507,7429494,'tip',14.286,1),(132,7429508,7429494,'ipa',14.286,1),(132,7429509,7429494,'pat',14.286,1),(132,7429510,7429494,'ath',14.286,1),(132,7429511,7429504,'plu',25,1),(132,7429512,7429504,'lug',25,1),(132,7429513,7429504,'ugi',25,1),(132,7429514,7429504,'gin',25,1),(132,7429515,7429511,'nmp',100,1),(132,7429516,7429515,'dev',33.333,1),(132,7429517,7429515,'evf',33.333,1),(132,7429518,7429515,'vfs',33.333,1),(132,7429519,7429516,'pat',50,1),(132,7429520,7429516,'ath',50,1),(132,7429521,7429519,'vmf',50,1),(132,7429522,7429519,'mfs',50,1),(132,7429523,7429521,'dev',20,1),(132,7429524,7429521,'evi',20,1),(132,7429525,7429521,'vic',20,1),(132,7429526,7429521,'ice',20,1),(132,7429527,7429521,'ces',20,1),(132,7429528,7429523,'dis',33.333,1),(132,7429529,7429523,'isk',33.333,1),(132,7429530,7429523,'sks',33.333,1),(132,7429531,7429528,'ven',25,1),(132,7429532,7429528,'end',25,1),(132,7429533,7429528,'ndo',25,1),(132,7429534,7429528,'dor',25,1),(132,7429535,7429531,'mod',33.333,1),(132,7429536,7429531,'ode',33.333,1),(132,7429537,7429531,'del',33.333,1),(132,7429538,7429535,'lun',100,1),(132,7429539,7429538,'cmo',33.333,1),(132,7429540,7429538,'mod',33.333,1),(132,7429541,7429538,'ode',33.333,1),(132,7429542,7429539,'rev',16.667,1),(132,7429543,7429539,'evi',16.667,1),(132,7429544,7429539,'vis',16.667,1),(132,7429545,7429539,'isi',16.667,1),(132,7429546,7429539,'sio',16.667,1),(132,7429547,7429539,'ion',16.667,1),(132,7429548,7429542,'810',50,1),(132,7429549,7429542,'100',50,1),(132,7429550,7429548,'scs',50,1),(132,7429551,7429548,'csi',50,1),(132,7429552,7429550,'lev',33.333,1),(132,7429553,7429550,'eve',33.333,1),(132,7429554,7429550,'vel',33.333,1),(132,7429555,7429552,'pse',25,1),(132,7429556,7429552,'seu',25,1),(132,7429557,7429552,'eud',25,1),(132,7429558,7429552,'udo',25,1),(132,7429559,7429555,'fal',33.333,6),(132,7429560,7429555,'als',33.333,6),(132,7429561,7429555,'lse',33.333,6),(132,7429562,7429559,'sta',25,3),(132,7429563,7429559,'tat',25,3),(132,7429564,7429559,'atu',25,3),(132,7429565,7429559,'tus',25,3),(132,7429566,7429562,'rdm',100,1),(132,7429567,7429566,'cap',20,1),(132,7429568,7429566,'apa',20,1),(132,7429569,7429566,'pab',20,1),(132,7429570,7429566,'abl',20,1),(132,7429571,7429566,'ble',20,1),(132,7429572,7429567,'tru',50,1),(132,7429573,7429567,'rue',50,1),(132,7429574,7429572,'loc',33.333,1),(132,7429575,7429572,'oca',33.333,1),(132,7429576,7429572,'cal',33.333,1),(132,7429577,7429574,'rem',14.286,1),(132,7429578,7429574,'emo',14.286,1),(132,7429579,7429574,'mov',14.286,1),(132,7429580,7429574,'ova',14.286,1),(132,7429581,7429574,'vab',14.286,1),(132,7429582,7429574,'abl',14.286,1),(132,7429583,7429574,'ble',14.286,1),(132,7429584,7429577,'ssd',100,1),(132,7429585,7429584,'off',20,1),(132,7429586,7429584,'ffl',20,1),(132,7429587,7429584,'fli',20,1),(132,7429588,7429584,'lin',20,1),(132,7429589,7429584,'ine',20,1),(132,7429590,7429585,'per',11.111,1),(132,7429591,7429585,'ere',11.111,1),(132,7429592,7429585,'ren',11.111,1),(132,7429593,7429585,'enn',11.111,1),(132,7429594,7429585,'nni',11.111,1),(132,7429595,7429585,'nia',11.111,1),(132,7429596,7429585,'ial',11.111,1),(132,7429597,7429585,'all',11.111,1),(132,7429598,7429585,'lly',11.111,1),(132,7429599,7429590,'res',16.667,1),(132,7429600,7429590,'ese',16.667,1),(132,7429601,7429590,'ser',16.667,1),(132,7429602,7429590,'erv',16.667,1),(132,7429603,7429590,'rve',16.667,1),(132,7429604,7429590,'ved',16.667,1),(132,7429605,7429599,'thi',50,1),(132,7429606,7429599,'hin',50,1),(132,7429607,7429605,'pro',10,1),(132,7429608,7429605,'rov',10,1),(132,7429609,7429605,'ovi',10,1),(132,7429610,7429605,'vis',10,1),(132,7429611,7429605,'isi',10,1),(132,7429612,7429605,'sio',10,1),(132,7429613,7429605,'ion',10,1),(132,7429614,7429605,'oni',10,1),(132,7429615,7429605,'nin',10,1),(132,7429616,7429605,'ing',10,1),(132,7429617,7429607,'yes',100,1),(132,7429618,7429617,'att',16.667,1),(132,7429619,7429617,'tta',16.667,1),(132,7429620,7429617,'tac',16.667,1),(132,7429621,7429617,'ach',16.667,1),(132,7429622,7429617,'che',16.667,1),(132,7429623,7429617,'hed',16.667,1),(132,7429624,7429618,'fil',20,1),(132,7429625,7429618,'ilt',20,1),(132,7429626,7429618,'lte',20,1),(132,7429627,7429618,'ter',20,1),(132,7429628,7429618,'ers',20,1),(132,7429629,7429624,'vaa',50,1),(132,7429630,7429624,'aai',50,1),(132,7429631,7429629,'unk',20,1),(132,7429632,7429629,'nkn',20,1),(132,7429633,7429629,'kno',20,1),(132,7429634,7429629,'now',20,1),(132,7429635,7429629,'own',20,1),(132,7429636,7429631,'oth',33.333,1),(132,7429637,7429631,'the',33.333,1),(132,7429638,7429631,'her',33.333,1),(132,7429639,7429636,'uid',50,1),(132,7429640,7429636,'ids',50,1),(132,7429641,7429639,'vml',100,1),(132,7429642,7429641,'dis',20,1),(132,7429643,7429641,'isp',20,1),(132,7429644,7429641,'spl',20,1),(132,7429645,7429641,'pla',20,1),(132,7429646,7429641,'lay',20,1),(132,7429647,7429642,'nam',50,1),(132,7429648,7429642,'ame',50,1),(133,7429650,7429649,'net',25,3),(133,7429651,7429649,'eta',25,3),(133,7429652,7429649,'tap',25,3),(133,7429653,7429649,'app',25,3),(133,7429654,7429650,'fib',33.333,2),(133,7429655,7429650,'ibr',33.333,2),(133,7429656,7429650,'bre',33.333,2),(133,7429657,7429654,'cha',20,2),(133,7429658,7429654,'han',20,2),(133,7429659,7429654,'ann',20,2),(133,7429660,7429654,'nne',20,2),(133,7429661,7429654,'nel',20,2),(133,7429662,7429657,'dis',50,2),(133,7429663,7429657,'isk',50,2),(133,7429664,7429662,'naa',100,4),(133,7429665,7429664,'600',3.333,4),(133,7429666,7429664,'00a',3.333,4),(133,7429667,7429664,'0a0',3.333,4),(133,7429668,7429664,'a09',3.333,4),(133,7429669,7429664,'098',3.333,4),(133,7429670,7429664,'980',3.333,4),(133,7429671,7429664,'804',3.333,4),(133,7429672,7429664,'044',3.333,4),(133,7429673,7429664,'443',3.333,4),(133,7429674,7429664,'430',3.333,4),(133,7429675,7429664,'307',3.333,4),(133,7429676,7429664,'075',3.333,4),(133,7429677,7429664,'753',3.333,4),(133,7429678,7429664,'535',3.333,4),(133,7429679,7429664,'357',3.333,4),(133,7429680,7429664,'573',3.333,4),(133,7429681,7429664,'732',3.333,4),(133,7429682,7429664,'32b',3.333,4),(133,7429683,7429664,'2b3',3.333,4),(133,7429684,7429664,'b33',3.333,4),(133,7429685,7429664,'334',3.333,4),(133,7429686,7429664,'345',3.333,4),(133,7429687,7429664,'457',3.333,4),(133,7429688,7429664,'571',3.333,4),(133,7429689,7429664,'715',3.333,4),(133,7429690,7429664,'153',3.333,4),(133,7429691,7429664,'533',3.333,4),(133,7429692,7429664,'336',3.333,4),(133,7429693,7429664,'365',3.333,4),(133,7429694,7429664,'652',3.333,4),(133,7429695,7429665,'ser',25,1),(133,7429696,7429665,'eri',25,1),(133,7429697,7429665,'ria',25,1),(133,7429698,7429665,'ial',25,1),(133,7429699,7429695,'siz',50,1),(133,7429700,7429695,'ize',50,1),(133,7429701,7429699,'321',100,1),(133,7429702,7429701,'dev',25,1),(133,7429703,7429701,'evi',25,1),(133,7429704,7429701,'vic',25,1),(133,7429705,7429701,'ice',25,1),(133,7429706,7429702,'typ',50,1),(133,7429707,7429702,'ype',50,1),(133,7429708,7429706,'dir',10,1),(133,7429709,7429706,'ire',10,1),(133,7429710,7429706,'rec',10,1),(133,7429711,7429706,'ect',10,1),(133,7429712,7429706,'cta',10,1),(133,7429713,7429706,'tac',10,1),(133,7429714,7429706,'acc',10,1),(133,7429715,7429706,'cce',10,1),(133,7429716,7429706,'ces',10,1),(133,7429717,7429706,'ess',10,1),(133,7429718,7429708,'mul',14.286,1),(133,7429719,7429708,'ult',14.286,1),(133,7429720,7429708,'lti',14.286,1),(133,7429721,7429708,'tip',14.286,1),(133,7429722,7429708,'ipa',14.286,1),(133,7429723,7429708,'pat',14.286,1),(133,7429724,7429708,'ath',14.286,1),(133,7429725,7429718,'plu',25,1),(133,7429726,7429718,'lug',25,1),(133,7429727,7429718,'ugi',25,1),(133,7429728,7429718,'gin',25,1),(133,7429729,7429725,'nmp',100,1),(133,7429730,7429729,'dev',33.333,1),(133,7429731,7429729,'evf',33.333,1),(133,7429732,7429729,'vfs',33.333,1),(133,7429733,7429730,'pat',50,1),(133,7429734,7429730,'ath',50,1),(133,7429735,7429733,'vmf',50,1),(133,7429736,7429733,'mfs',50,1),(133,7429737,7429735,'dev',20,1),(133,7429738,7429735,'evi',20,1),(133,7429739,7429735,'vic',20,1),(133,7429740,7429735,'ice',20,1),(133,7429741,7429735,'ces',20,1),(133,7429742,7429737,'dis',33.333,1),(133,7429743,7429737,'isk',33.333,1),(133,7429744,7429737,'sks',33.333,1),(133,7429745,7429742,'ven',25,1),(133,7429746,7429742,'end',25,1),(133,7429747,7429742,'ndo',25,1),(133,7429748,7429742,'dor',25,1),(133,7429749,7429745,'mod',33.333,1),(133,7429750,7429745,'ode',33.333,1),(133,7429751,7429745,'del',33.333,1),(133,7429752,7429749,'lun',100,1),(133,7429753,7429752,'cmo',33.333,1),(133,7429754,7429752,'mod',33.333,1),(133,7429755,7429752,'ode',33.333,1),(133,7429756,7429753,'rev',16.667,1),(133,7429757,7429753,'evi',16.667,1),(133,7429758,7429753,'vis',16.667,1),(133,7429759,7429753,'isi',16.667,1),(133,7429760,7429753,'sio',16.667,1),(133,7429761,7429753,'ion',16.667,1),(133,7429762,7429756,'810',50,1),(133,7429763,7429756,'100',50,1),(133,7429764,7429762,'scs',50,1),(133,7429765,7429762,'csi',50,1),(133,7429766,7429764,'lev',33.333,1),(133,7429767,7429764,'eve',33.333,1),(133,7429768,7429764,'vel',33.333,1),(133,7429769,7429766,'pse',25,1),(133,7429770,7429766,'seu',25,1),(133,7429771,7429766,'eud',25,1),(133,7429772,7429766,'udo',25,1),(133,7429773,7429769,'fal',33.333,6),(133,7429774,7429769,'als',33.333,6),(133,7429775,7429769,'lse',33.333,6),(133,7429776,7429773,'sta',25,3),(133,7429777,7429773,'tat',25,3),(133,7429778,7429773,'atu',25,3),(133,7429779,7429773,'tus',25,3),(133,7429780,7429776,'rdm',100,1),(133,7429781,7429780,'cap',20,1),(133,7429782,7429780,'apa',20,1),(133,7429783,7429780,'pab',20,1),(133,7429784,7429780,'abl',20,1),(133,7429785,7429780,'ble',20,1),(133,7429786,7429781,'tru',50,1),(133,7429787,7429781,'rue',50,1),(133,7429788,7429786,'loc',33.333,1),(133,7429789,7429786,'oca',33.333,1),(133,7429790,7429786,'cal',33.333,1),(133,7429791,7429788,'rem',14.286,1),(133,7429792,7429788,'emo',14.286,1),(133,7429793,7429788,'mov',14.286,1),(133,7429794,7429788,'ova',14.286,1),(133,7429795,7429788,'vab',14.286,1),(133,7429796,7429788,'abl',14.286,1),(133,7429797,7429788,'ble',14.286,1),(133,7429798,7429791,'ssd',100,1),(133,7429799,7429798,'off',20,1),(133,7429800,7429798,'ffl',20,1),(133,7429801,7429798,'fli',20,1),(133,7429802,7429798,'lin',20,1),(133,7429803,7429798,'ine',20,1),(133,7429804,7429799,'per',11.111,1),(133,7429805,7429799,'ere',11.111,1),(133,7429806,7429799,'ren',11.111,1),(133,7429807,7429799,'enn',11.111,1),(133,7429808,7429799,'nni',11.111,1),(133,7429809,7429799,'nia',11.111,1),(133,7429810,7429799,'ial',11.111,1),(133,7429811,7429799,'all',11.111,1),(133,7429812,7429799,'lly',11.111,1),(133,7429813,7429804,'res',16.667,1),(133,7429814,7429804,'ese',16.667,1),(133,7429815,7429804,'ser',16.667,1),(133,7429816,7429804,'erv',16.667,1),(133,7429817,7429804,'rve',16.667,1),(133,7429818,7429804,'ved',16.667,1),(133,7429819,7429813,'thi',50,1),(133,7429820,7429813,'hin',50,1),(133,7429821,7429819,'pro',10,1),(133,7429822,7429819,'rov',10,1),(133,7429823,7429819,'ovi',10,1),(133,7429824,7429819,'vis',10,1),(133,7429825,7429819,'isi',10,1),(133,7429826,7429819,'sio',10,1),(133,7429827,7429819,'ion',10,1),(133,7429828,7429819,'oni',10,1),(133,7429829,7429819,'nin',10,1),(133,7429830,7429819,'ing',10,1),(133,7429831,7429821,'yes',100,1),(133,7429832,7429831,'att',16.667,1),(133,7429833,7429831,'tta',16.667,1),(133,7429834,7429831,'tac',16.667,1),(133,7429835,7429831,'ach',16.667,1),(133,7429836,7429831,'che',16.667,1),(133,7429837,7429831,'hed',16.667,1),(133,7429838,7429832,'fil',20,1),(133,7429839,7429832,'ilt',20,1),(133,7429840,7429832,'lte',20,1),(133,7429841,7429832,'ter',20,1),(133,7429842,7429832,'ers',20,1),(133,7429843,7429838,'vaa',50,1),(133,7429844,7429838,'aai',50,1),(133,7429845,7429843,'unk',20,1),(133,7429846,7429843,'nkn',20,1),(133,7429847,7429843,'kno',20,1),(133,7429848,7429843,'now',20,1),(133,7429849,7429843,'own',20,1),(133,7429850,7429845,'oth',33.333,1),(133,7429851,7429845,'the',33.333,1),(133,7429852,7429845,'her',33.333,1),(133,7429853,7429850,'uid',50,1),(133,7429854,7429850,'ids',50,1),(133,7429855,7429853,'vml',100,1),(133,7429856,7429855,'dis',20,1),(133,7429857,7429855,'isp',20,1),(133,7429858,7429855,'spl',20,1),(133,7429859,7429855,'pla',20,1),(133,7429860,7429855,'lay',20,1),(133,7429861,7429856,'nam',50,1),(133,7429862,7429856,'ame',50,1),(134,7429864,7429863,'net',25,3),(134,7429865,7429863,'eta',25,3),(134,7429866,7429863,'tap',25,3),(134,7429867,7429863,'app',25,3),(134,7429868,7429864,'fib',33.333,2),(134,7429869,7429864,'ibr',33.333,2),(134,7429870,7429864,'bre',33.333,2),(134,7429871,7429868,'cha',20,2),(134,7429872,7429868,'han',20,2),(134,7429873,7429868,'ann',20,2),(134,7429874,7429868,'nne',20,2),(134,7429875,7429868,'nel',20,2),(134,7429876,7429871,'dis',50,2),(134,7429877,7429871,'isk',50,2),(134,7429878,7429876,'naa',100,4),(134,7429879,7429878,'600',3.333,4),(134,7429880,7429878,'00a',3.333,4),(134,7429881,7429878,'0a0',3.333,4),(134,7429882,7429878,'a09',3.333,4),(134,7429883,7429878,'098',3.333,4),(134,7429884,7429878,'980',3.333,4),(134,7429885,7429878,'804',3.333,4),(134,7429886,7429878,'044',3.333,4),(134,7429887,7429878,'443',3.333,4),(134,7429888,7429878,'430',3.333,4),(134,7429889,7429878,'307',3.333,4),(134,7429890,7429878,'075',3.333,4),(134,7429891,7429878,'753',3.333,4),(134,7429892,7429878,'535',3.333,4),(134,7429893,7429878,'357',3.333,4),(134,7429894,7429878,'573',3.333,4),(134,7429895,7429878,'732',3.333,4),(134,7429896,7429878,'32b',3.333,4),(134,7429897,7429878,'2b3',3.333,4),(134,7429898,7429878,'b33',3.333,4),(134,7429899,7429878,'334',3.333,4),(134,7429900,7429878,'345',3.333,4),(134,7429901,7429878,'457',3.333,4),(134,7429902,7429878,'571',3.333,4),(134,7429903,7429878,'715',3.333,4),(134,7429904,7429878,'153',3.333,4),(134,7429905,7429878,'533',3.333,4),(134,7429906,7429878,'335',3.333,4),(134,7429907,7429878,'357',3.333,4),(134,7429908,7429878,'575',3.333,4),(134,7429909,7429879,'ser',25,1),(134,7429910,7429879,'eri',25,1),(134,7429911,7429879,'ria',25,1),(134,7429912,7429879,'ial',25,1),(134,7429913,7429909,'siz',50,1),(134,7429914,7429909,'ize',50,1),(134,7429915,7429913,'321',100,1),(134,7429916,7429915,'dev',25,1),(134,7429917,7429915,'evi',25,1),(134,7429918,7429915,'vic',25,1),(134,7429919,7429915,'ice',25,1),(134,7429920,7429916,'typ',50,1),(134,7429921,7429916,'ype',50,1),(134,7429922,7429920,'dir',10,1),(134,7429923,7429920,'ire',10,1),(134,7429924,7429920,'rec',10,1),(134,7429925,7429920,'ect',10,1),(134,7429926,7429920,'cta',10,1),(134,7429927,7429920,'tac',10,1),(134,7429928,7429920,'acc',10,1),(134,7429929,7429920,'cce',10,1),(134,7429930,7429920,'ces',10,1),(134,7429931,7429920,'ess',10,1),(134,7429932,7429922,'mul',14.286,1),(134,7429933,7429922,'ult',14.286,1),(134,7429934,7429922,'lti',14.286,1),(134,7429935,7429922,'tip',14.286,1),(134,7429936,7429922,'ipa',14.286,1),(134,7429937,7429922,'pat',14.286,1),(134,7429938,7429922,'ath',14.286,1),(134,7429939,7429932,'plu',25,1),(134,7429940,7429932,'lug',25,1),(134,7429941,7429932,'ugi',25,1),(134,7429942,7429932,'gin',25,1),(134,7429943,7429939,'nmp',100,1),(134,7429944,7429943,'dev',33.333,1),(134,7429945,7429943,'evf',33.333,1),(134,7429946,7429943,'vfs',33.333,1),(134,7429947,7429944,'pat',50,1),(134,7429948,7429944,'ath',50,1),(134,7429949,7429947,'vmf',50,1),(134,7429950,7429947,'mfs',50,1),(134,7429951,7429949,'dev',20,1),(134,7429952,7429949,'evi',20,1),(134,7429953,7429949,'vic',20,1),(134,7429954,7429949,'ice',20,1),(134,7429955,7429949,'ces',20,1),(134,7429956,7429951,'dis',33.333,1),(134,7429957,7429951,'isk',33.333,1),(134,7429958,7429951,'sks',33.333,1),(134,7429959,7429956,'ven',25,1),(134,7429960,7429956,'end',25,1),(134,7429961,7429956,'ndo',25,1),(134,7429962,7429956,'dor',25,1),(134,7429963,7429959,'mod',33.333,1),(134,7429964,7429959,'ode',33.333,1),(134,7429965,7429959,'del',33.333,1),(134,7429966,7429963,'lun',100,1),(134,7429967,7429966,'cmo',33.333,1),(134,7429968,7429966,'mod',33.333,1),(134,7429969,7429966,'ode',33.333,1),(134,7429970,7429967,'rev',16.667,1),(134,7429971,7429967,'evi',16.667,1),(134,7429972,7429967,'vis',16.667,1),(134,7429973,7429967,'isi',16.667,1),(134,7429974,7429967,'sio',16.667,1),(134,7429975,7429967,'ion',16.667,1),(134,7429976,7429970,'810',50,1),(134,7429977,7429970,'100',50,1),(134,7429978,7429976,'scs',50,1),(134,7429979,7429976,'csi',50,1),(134,7429980,7429978,'lev',33.333,1),(134,7429981,7429978,'eve',33.333,1),(134,7429982,7429978,'vel',33.333,1),(134,7429983,7429980,'pse',25,1),(134,7429984,7429980,'seu',25,1),(134,7429985,7429980,'eud',25,1),(134,7429986,7429980,'udo',25,1),(134,7429987,7429983,'fal',33.333,6),(134,7429988,7429983,'als',33.333,6),(134,7429989,7429983,'lse',33.333,6),(134,7429990,7429987,'sta',25,3),(134,7429991,7429987,'tat',25,3),(134,7429992,7429987,'atu',25,3),(134,7429993,7429987,'tus',25,3),(134,7429994,7429990,'rdm',100,1),(134,7429995,7429994,'cap',20,1),(134,7429996,7429994,'apa',20,1),(134,7429997,7429994,'pab',20,1),(134,7429998,7429994,'abl',20,1),(134,7429999,7429994,'ble',20,1),(134,7430000,7429995,'tru',50,1),(134,7430001,7429995,'rue',50,1),(134,7430002,7430000,'loc',33.333,1),(134,7430003,7430000,'oca',33.333,1),(134,7430004,7430000,'cal',33.333,1),(134,7430005,7430002,'rem',14.286,1),(134,7430006,7430002,'emo',14.286,1),(134,7430007,7430002,'mov',14.286,1),(134,7430008,7430002,'ova',14.286,1),(134,7430009,7430002,'vab',14.286,1),(134,7430010,7430002,'abl',14.286,1),(134,7430011,7430002,'ble',14.286,1),(134,7430012,7430005,'ssd',100,1),(134,7430013,7430012,'off',20,1),(134,7430014,7430012,'ffl',20,1),(134,7430015,7430012,'fli',20,1),(134,7430016,7430012,'lin',20,1),(134,7430017,7430012,'ine',20,1),(134,7430018,7430013,'per',11.111,1),(134,7430019,7430013,'ere',11.111,1),(134,7430020,7430013,'ren',11.111,1),(134,7430021,7430013,'enn',11.111,1),(134,7430022,7430013,'nni',11.111,1),(134,7430023,7430013,'nia',11.111,1),(134,7430024,7430013,'ial',11.111,1),(134,7430025,7430013,'all',11.111,1),(134,7430026,7430013,'lly',11.111,1),(134,7430027,7430018,'res',16.667,1),(134,7430028,7430018,'ese',16.667,1),(134,7430029,7430018,'ser',16.667,1),(134,7430030,7430018,'erv',16.667,1),(134,7430031,7430018,'rve',16.667,1),(134,7430032,7430018,'ved',16.667,1),(134,7430033,7430027,'thi',50,1),(134,7430034,7430027,'hin',50,1),(134,7430035,7430033,'pro',10,1),(134,7430036,7430033,'rov',10,1),(134,7430037,7430033,'ovi',10,1),(134,7430038,7430033,'vis',10,1),(134,7430039,7430033,'isi',10,1),(134,7430040,7430033,'sio',10,1),(134,7430041,7430033,'ion',10,1),(134,7430042,7430033,'oni',10,1),(134,7430043,7430033,'nin',10,1),(134,7430044,7430033,'ing',10,1),(134,7430045,7430035,'yes',100,1),(134,7430046,7430045,'att',16.667,1),(134,7430047,7430045,'tta',16.667,1),(134,7430048,7430045,'tac',16.667,1),(134,7430049,7430045,'ach',16.667,1),(134,7430050,7430045,'che',16.667,1),(134,7430051,7430045,'hed',16.667,1),(134,7430052,7430046,'fil',20,1),(134,7430053,7430046,'ilt',20,1),(134,7430054,7430046,'lte',20,1),(134,7430055,7430046,'ter',20,1),(134,7430056,7430046,'ers',20,1),(134,7430057,7430052,'vaa',50,1),(134,7430058,7430052,'aai',50,1),(134,7430059,7430057,'unk',20,1),(134,7430060,7430057,'nkn',20,1),(134,7430061,7430057,'kno',20,1),(134,7430062,7430057,'now',20,1),(134,7430063,7430057,'own',20,1),(134,7430064,7430059,'oth',33.333,1),(134,7430065,7430059,'the',33.333,1),(134,7430066,7430059,'her',33.333,1),(134,7430067,7430064,'uid',50,1),(134,7430068,7430064,'ids',50,1),(134,7430069,7430067,'vml',100,1),(134,7430070,7430069,'dis',20,1),(134,7430071,7430069,'isp',20,1),(134,7430072,7430069,'spl',20,1),(134,7430073,7430069,'pla',20,1),(134,7430074,7430069,'lay',20,1),(134,7430075,7430070,'nam',50,1),(134,7430076,7430070,'ame',50,1),(135,7430078,7430077,'net',25,3),(135,7430079,7430077,'eta',25,3),(135,7430080,7430077,'tap',25,3),(135,7430081,7430077,'app',25,3),(135,7430082,7430078,'fib',33.333,2),(135,7430083,7430078,'ibr',33.333,2),(135,7430084,7430078,'bre',33.333,2),(135,7430085,7430082,'cha',20,2),(135,7430086,7430082,'han',20,2),(135,7430087,7430082,'ann',20,2),(135,7430088,7430082,'nne',20,2),(135,7430089,7430082,'nel',20,2),(135,7430090,7430085,'dis',50,2),(135,7430091,7430085,'isk',50,2),(135,7430092,7430090,'naa',100,4),(135,7430093,7430092,'600',3.333,4),(135,7430094,7430092,'00a',3.333,4),(135,7430095,7430092,'0a0',3.333,4),(135,7430096,7430092,'a09',3.333,4),(135,7430097,7430092,'098',3.333,4),(135,7430098,7430092,'980',3.333,4),(135,7430099,7430092,'804',3.333,4),(135,7430100,7430092,'044',3.333,4),(135,7430101,7430092,'443',3.333,4),(135,7430102,7430092,'430',3.333,4),(135,7430103,7430092,'307',3.333,4),(135,7430104,7430092,'075',3.333,4),(135,7430105,7430092,'753',3.333,4),(135,7430106,7430092,'535',3.333,4),(135,7430107,7430092,'357',3.333,4),(135,7430108,7430092,'573',3.333,4),(135,7430109,7430092,'732',3.333,4),(135,7430110,7430092,'32b',3.333,4),(135,7430111,7430092,'2b3',3.333,4),(135,7430112,7430092,'b33',3.333,4),(135,7430113,7430092,'334',3.333,4),(135,7430114,7430092,'345',3.333,4),(135,7430115,7430092,'457',3.333,4),(135,7430116,7430092,'571',3.333,4),(135,7430117,7430092,'715',3.333,4),(135,7430118,7430092,'153',3.333,4),(135,7430119,7430092,'533',3.333,4),(135,7430120,7430092,'336',3.333,4),(135,7430121,7430092,'365',3.333,4),(135,7430122,7430092,'653',3.333,4),(135,7430123,7430093,'ser',25,1),(135,7430124,7430093,'eri',25,1),(135,7430125,7430093,'ria',25,1),(135,7430126,7430093,'ial',25,1),(135,7430127,7430123,'siz',50,1),(135,7430128,7430123,'ize',50,1),(135,7430129,7430127,'321',100,1),(135,7430130,7430129,'dev',25,1),(135,7430131,7430129,'evi',25,1),(135,7430132,7430129,'vic',25,1),(135,7430133,7430129,'ice',25,1),(135,7430134,7430130,'typ',50,1),(135,7430135,7430130,'ype',50,1),(135,7430136,7430134,'dir',10,1),(135,7430137,7430134,'ire',10,1),(135,7430138,7430134,'rec',10,1),(135,7430139,7430134,'ect',10,1),(135,7430140,7430134,'cta',10,1),(135,7430141,7430134,'tac',10,1),(135,7430142,7430134,'acc',10,1),(135,7430143,7430134,'cce',10,1),(135,7430144,7430134,'ces',10,1),(135,7430145,7430134,'ess',10,1),(135,7430146,7430136,'mul',14.286,1),(135,7430147,7430136,'ult',14.286,1),(135,7430148,7430136,'lti',14.286,1),(135,7430149,7430136,'tip',14.286,1),(135,7430150,7430136,'ipa',14.286,1),(135,7430151,7430136,'pat',14.286,1),(135,7430152,7430136,'ath',14.286,1),(135,7430153,7430146,'plu',25,1),(135,7430154,7430146,'lug',25,1),(135,7430155,7430146,'ugi',25,1),(135,7430156,7430146,'gin',25,1),(135,7430157,7430153,'nmp',100,1),(135,7430158,7430157,'dev',33.333,1),(135,7430159,7430157,'evf',33.333,1),(135,7430160,7430157,'vfs',33.333,1),(135,7430161,7430158,'pat',50,1),(135,7430162,7430158,'ath',50,1),(135,7430163,7430161,'vmf',50,1),(135,7430164,7430161,'mfs',50,1),(135,7430165,7430163,'dev',20,1),(135,7430166,7430163,'evi',20,1),(135,7430167,7430163,'vic',20,1),(135,7430168,7430163,'ice',20,1),(135,7430169,7430163,'ces',20,1),(135,7430170,7430165,'dis',33.333,1),(135,7430171,7430165,'isk',33.333,1),(135,7430172,7430165,'sks',33.333,1),(135,7430173,7430170,'ven',25,1),(135,7430174,7430170,'end',25,1),(135,7430175,7430170,'ndo',25,1),(135,7430176,7430170,'dor',25,1),(135,7430177,7430173,'mod',33.333,1),(135,7430178,7430173,'ode',33.333,1),(135,7430179,7430173,'del',33.333,1),(135,7430180,7430177,'lun',100,1),(135,7430181,7430180,'cmo',33.333,1),(135,7430182,7430180,'mod',33.333,1),(135,7430183,7430180,'ode',33.333,1),(135,7430184,7430181,'rev',16.667,1),(135,7430185,7430181,'evi',16.667,1),(135,7430186,7430181,'vis',16.667,1),(135,7430187,7430181,'isi',16.667,1),(135,7430188,7430181,'sio',16.667,1),(135,7430189,7430181,'ion',16.667,1),(135,7430190,7430184,'810',50,1),(135,7430191,7430184,'100',50,1),(135,7430192,7430190,'scs',50,1),(135,7430193,7430190,'csi',50,1),(135,7430194,7430192,'lev',33.333,1),(135,7430195,7430192,'eve',33.333,1),(135,7430196,7430192,'vel',33.333,1),(135,7430197,7430194,'pse',25,1),(135,7430198,7430194,'seu',25,1),(135,7430199,7430194,'eud',25,1),(135,7430200,7430194,'udo',25,1),(135,7430201,7430197,'fal',33.333,6),(135,7430202,7430197,'als',33.333,6),(135,7430203,7430197,'lse',33.333,6),(135,7430204,7430201,'sta',25,3),(135,7430205,7430201,'tat',25,3),(135,7430206,7430201,'atu',25,3),(135,7430207,7430201,'tus',25,3),(135,7430208,7430204,'rdm',100,1),(135,7430209,7430208,'cap',20,1),(135,7430210,7430208,'apa',20,1),(135,7430211,7430208,'pab',20,1),(135,7430212,7430208,'abl',20,1),(135,7430213,7430208,'ble',20,1),(135,7430214,7430209,'tru',50,1),(135,7430215,7430209,'rue',50,1),(135,7430216,7430214,'loc',33.333,1),(135,7430217,7430214,'oca',33.333,1),(135,7430218,7430214,'cal',33.333,1),(135,7430219,7430216,'rem',14.286,1),(135,7430220,7430216,'emo',14.286,1),(135,7430221,7430216,'mov',14.286,1),(135,7430222,7430216,'ova',14.286,1),(135,7430223,7430216,'vab',14.286,1),(135,7430224,7430216,'abl',14.286,1),(135,7430225,7430216,'ble',14.286,1),(135,7430226,7430219,'ssd',100,1),(135,7430227,7430226,'off',20,1),(135,7430228,7430226,'ffl',20,1),(135,7430229,7430226,'fli',20,1),(135,7430230,7430226,'lin',20,1),(135,7430231,7430226,'ine',20,1),(135,7430232,7430227,'per',11.111,1),(135,7430233,7430227,'ere',11.111,1),(135,7430234,7430227,'ren',11.111,1),(135,7430235,7430227,'enn',11.111,1),(135,7430236,7430227,'nni',11.111,1),(135,7430237,7430227,'nia',11.111,1),(135,7430238,7430227,'ial',11.111,1),(135,7430239,7430227,'all',11.111,1),(135,7430240,7430227,'lly',11.111,1),(135,7430241,7430232,'res',16.667,1),(135,7430242,7430232,'ese',16.667,1),(135,7430243,7430232,'ser',16.667,1),(135,7430244,7430232,'erv',16.667,1),(135,7430245,7430232,'rve',16.667,1),(135,7430246,7430232,'ved',16.667,1),(135,7430247,7430241,'thi',50,1),(135,7430248,7430241,'hin',50,1),(135,7430249,7430247,'pro',10,1),(135,7430250,7430247,'rov',10,1),(135,7430251,7430247,'ovi',10,1),(135,7430252,7430247,'vis',10,1),(135,7430253,7430247,'isi',10,1),(135,7430254,7430247,'sio',10,1),(135,7430255,7430247,'ion',10,1),(135,7430256,7430247,'oni',10,1),(135,7430257,7430247,'nin',10,1),(135,7430258,7430247,'ing',10,1),(135,7430259,7430249,'yes',100,1),(135,7430260,7430259,'att',16.667,1),(135,7430261,7430259,'tta',16.667,1),(135,7430262,7430259,'tac',16.667,1),(135,7430263,7430259,'ach',16.667,1),(135,7430264,7430259,'che',16.667,1),(135,7430265,7430259,'hed',16.667,1),(135,7430266,7430260,'fil',20,1),(135,7430267,7430260,'ilt',20,1),(135,7430268,7430260,'lte',20,1),(135,7430269,7430260,'ter',20,1),(135,7430270,7430260,'ers',20,1),(135,7430271,7430266,'vaa',50,1),(135,7430272,7430266,'aai',50,1),(135,7430273,7430271,'unk',20,1),(135,7430274,7430271,'nkn',20,1),(135,7430275,7430271,'kno',20,1),(135,7430276,7430271,'now',20,1),(135,7430277,7430271,'own',20,1),(135,7430278,7430273,'oth',33.333,1),(135,7430279,7430273,'the',33.333,1),(135,7430280,7430273,'her',33.333,1),(135,7430281,7430278,'uid',50,1),(135,7430282,7430278,'ids',50,1),(135,7430283,7430281,'vml',100,1),(135,7430284,7430283,'dis',20,1),(135,7430285,7430283,'isp',20,1),(135,7430286,7430283,'spl',20,1),(135,7430287,7430283,'pla',20,1),(135,7430288,7430283,'lay',20,1),(135,7430289,7430284,'nam',50,1),(135,7430290,7430284,'ame',50,1),(136,7430292,7430291,'net',25,3),(136,7430293,7430291,'eta',25,3),(136,7430294,7430291,'tap',25,3),(136,7430295,7430291,'app',25,3),(136,7430296,7430292,'fib',33.333,2),(136,7430297,7430292,'ibr',33.333,2),(136,7430298,7430292,'bre',33.333,2),(136,7430299,7430296,'cha',20,2),(136,7430300,7430296,'han',20,2),(136,7430301,7430296,'ann',20,2),(136,7430302,7430296,'nne',20,2),(136,7430303,7430296,'nel',20,2),(136,7430304,7430299,'dis',50,2),(136,7430305,7430299,'isk',50,2),(136,7430306,7430304,'naa',100,4),(136,7430307,7430306,'600',3.333,4),(136,7430308,7430306,'00a',3.333,4),(136,7430309,7430306,'0a0',3.333,4),(136,7430310,7430306,'a09',3.333,4),(136,7430311,7430306,'098',3.333,4),(136,7430312,7430306,'980',3.333,4),(136,7430313,7430306,'804',3.333,4),(136,7430314,7430306,'044',3.333,4),(136,7430315,7430306,'443',3.333,4),(136,7430316,7430306,'430',3.333,4),(136,7430317,7430306,'307',3.333,4),(136,7430318,7430306,'075',3.333,4),(136,7430319,7430306,'753',3.333,4),(136,7430320,7430306,'535',3.333,4),(136,7430321,7430306,'357',3.333,4),(136,7430322,7430306,'573',3.333,4),(136,7430323,7430306,'732',3.333,4),(136,7430324,7430306,'32b',3.333,4),(136,7430325,7430306,'2b3',3.333,4),(136,7430326,7430306,'b33',3.333,4),(136,7430327,7430306,'334',3.333,4),(136,7430328,7430306,'345',3.333,4),(136,7430329,7430306,'457',3.333,4),(136,7430330,7430306,'571',3.333,4),(136,7430331,7430306,'715',3.333,4),(136,7430332,7430306,'153',3.333,4),(136,7430333,7430306,'533',3.333,4),(136,7430334,7430306,'335',3.333,4),(136,7430335,7430306,'357',3.333,4),(136,7430336,7430306,'576',3.333,4),(136,7430337,7430307,'ser',25,1),(136,7430338,7430307,'eri',25,1),(136,7430339,7430307,'ria',25,1),(136,7430340,7430307,'ial',25,1),(136,7430341,7430337,'siz',50,1),(136,7430342,7430337,'ize',50,1),(136,7430343,7430341,'321',100,1),(136,7430344,7430343,'dev',25,1),(136,7430345,7430343,'evi',25,1),(136,7430346,7430343,'vic',25,1),(136,7430347,7430343,'ice',25,1),(136,7430348,7430344,'typ',50,1),(136,7430349,7430344,'ype',50,1),(136,7430350,7430348,'dir',10,1),(136,7430351,7430348,'ire',10,1),(136,7430352,7430348,'rec',10,1),(136,7430353,7430348,'ect',10,1),(136,7430354,7430348,'cta',10,1),(136,7430355,7430348,'tac',10,1),(136,7430356,7430348,'acc',10,1),(136,7430357,7430348,'cce',10,1),(136,7430358,7430348,'ces',10,1),(136,7430359,7430348,'ess',10,1),(136,7430360,7430350,'mul',14.286,1),(136,7430361,7430350,'ult',14.286,1),(136,7430362,7430350,'lti',14.286,1),(136,7430363,7430350,'tip',14.286,1),(136,7430364,7430350,'ipa',14.286,1),(136,7430365,7430350,'pat',14.286,1),(136,7430366,7430350,'ath',14.286,1),(136,7430367,7430360,'plu',25,1),(136,7430368,7430360,'lug',25,1),(136,7430369,7430360,'ugi',25,1),(136,7430370,7430360,'gin',25,1),(136,7430371,7430367,'nmp',100,1),(136,7430372,7430371,'dev',33.333,1),(136,7430373,7430371,'evf',33.333,1),(136,7430374,7430371,'vfs',33.333,1),(136,7430375,7430372,'pat',50,1),(136,7430376,7430372,'ath',50,1),(136,7430377,7430375,'vmf',50,1),(136,7430378,7430375,'mfs',50,1),(136,7430379,7430377,'dev',20,1),(136,7430380,7430377,'evi',20,1),(136,7430381,7430377,'vic',20,1),(136,7430382,7430377,'ice',20,1),(136,7430383,7430377,'ces',20,1),(136,7430384,7430379,'dis',33.333,1),(136,7430385,7430379,'isk',33.333,1),(136,7430386,7430379,'sks',33.333,1),(136,7430387,7430384,'ven',25,1),(136,7430388,7430384,'end',25,1),(136,7430389,7430384,'ndo',25,1),(136,7430390,7430384,'dor',25,1),(136,7430391,7430387,'mod',33.333,1),(136,7430392,7430387,'ode',33.333,1),(136,7430393,7430387,'del',33.333,1),(136,7430394,7430391,'lun',100,1),(136,7430395,7430394,'cmo',33.333,1),(136,7430396,7430394,'mod',33.333,1),(136,7430397,7430394,'ode',33.333,1),(136,7430398,7430395,'rev',16.667,1),(136,7430399,7430395,'evi',16.667,1),(136,7430400,7430395,'vis',16.667,1),(136,7430401,7430395,'isi',16.667,1),(136,7430402,7430395,'sio',16.667,1),(136,7430403,7430395,'ion',16.667,1),(136,7430404,7430398,'810',50,1),(136,7430405,7430398,'100',50,1),(136,7430406,7430404,'scs',50,1),(136,7430407,7430404,'csi',50,1),(136,7430408,7430406,'lev',33.333,1),(136,7430409,7430406,'eve',33.333,1),(136,7430410,7430406,'vel',33.333,1),(136,7430411,7430408,'pse',25,1),(136,7430412,7430408,'seu',25,1),(136,7430413,7430408,'eud',25,1),(136,7430414,7430408,'udo',25,1),(136,7430415,7430411,'fal',33.333,6),(136,7430416,7430411,'als',33.333,6),(136,7430417,7430411,'lse',33.333,6),(136,7430418,7430415,'sta',25,3),(136,7430419,7430415,'tat',25,3),(136,7430420,7430415,'atu',25,3),(136,7430421,7430415,'tus',25,3),(136,7430422,7430418,'rdm',100,1),(136,7430423,7430422,'cap',20,1),(136,7430424,7430422,'apa',20,1),(136,7430425,7430422,'pab',20,1),(136,7430426,7430422,'abl',20,1),(136,7430427,7430422,'ble',20,1),(136,7430428,7430423,'tru',50,1),(136,7430429,7430423,'rue',50,1),(136,7430430,7430428,'loc',33.333,1),(136,7430431,7430428,'oca',33.333,1),(136,7430432,7430428,'cal',33.333,1),(136,7430433,7430430,'rem',14.286,1),(136,7430434,7430430,'emo',14.286,1),(136,7430435,7430430,'mov',14.286,1),(136,7430436,7430430,'ova',14.286,1),(136,7430437,7430430,'vab',14.286,1),(136,7430438,7430430,'abl',14.286,1),(136,7430439,7430430,'ble',14.286,1),(136,7430440,7430433,'ssd',100,1),(136,7430441,7430440,'off',20,1),(136,7430442,7430440,'ffl',20,1),(136,7430443,7430440,'fli',20,1),(136,7430444,7430440,'lin',20,1),(136,7430445,7430440,'ine',20,1),(136,7430446,7430441,'per',11.111,1),(136,7430447,7430441,'ere',11.111,1),(136,7430448,7430441,'ren',11.111,1),(136,7430449,7430441,'enn',11.111,1),(136,7430450,7430441,'nni',11.111,1),(136,7430451,7430441,'nia',11.111,1),(136,7430452,7430441,'ial',11.111,1),(136,7430453,7430441,'all',11.111,1),(136,7430454,7430441,'lly',11.111,1),(136,7430455,7430446,'res',16.667,1),(136,7430456,7430446,'ese',16.667,1),(136,7430457,7430446,'ser',16.667,1),(136,7430458,7430446,'erv',16.667,1),(136,7430459,7430446,'rve',16.667,1),(136,7430460,7430446,'ved',16.667,1),(136,7430461,7430455,'thi',50,1),(136,7430462,7430455,'hin',50,1),(136,7430463,7430461,'pro',10,1),(136,7430464,7430461,'rov',10,1),(136,7430465,7430461,'ovi',10,1),(136,7430466,7430461,'vis',10,1),(136,7430467,7430461,'isi',10,1),(136,7430468,7430461,'sio',10,1),(136,7430469,7430461,'ion',10,1),(136,7430470,7430461,'oni',10,1),(136,7430471,7430461,'nin',10,1),(136,7430472,7430461,'ing',10,1),(136,7430473,7430463,'yes',100,1),(136,7430474,7430473,'att',16.667,1),(136,7430475,7430473,'tta',16.667,1),(136,7430476,7430473,'tac',16.667,1),(136,7430477,7430473,'ach',16.667,1),(136,7430478,7430473,'che',16.667,1),(136,7430479,7430473,'hed',16.667,1),(136,7430480,7430474,'fil',20,1),(136,7430481,7430474,'ilt',20,1),(136,7430482,7430474,'lte',20,1),(136,7430483,7430474,'ter',20,1),(136,7430484,7430474,'ers',20,1),(136,7430485,7430480,'vaa',50,1),(136,7430486,7430480,'aai',50,1),(136,7430487,7430485,'unk',20,1),(136,7430488,7430485,'nkn',20,1),(136,7430489,7430485,'kno',20,1),(136,7430490,7430485,'now',20,1),(136,7430491,7430485,'own',20,1),(136,7430492,7430487,'oth',33.333,1),(136,7430493,7430487,'the',33.333,1),(136,7430494,7430487,'her',33.333,1),(136,7430495,7430492,'uid',50,1),(136,7430496,7430492,'ids',50,1),(136,7430497,7430495,'vml',100,1),(136,7430498,7430497,'dis',20,1),(136,7430499,7430497,'isp',20,1),(136,7430500,7430497,'spl',20,1),(136,7430501,7430497,'pla',20,1),(136,7430502,7430497,'lay',20,1),(136,7430503,7430498,'nam',50,1),(136,7430504,7430498,'ame',50,1),(137,7430506,7430505,'net',25,3),(137,7430507,7430505,'eta',25,3),(137,7430508,7430505,'tap',25,3),(137,7430509,7430505,'app',25,3),(137,7430510,7430506,'fib',33.333,2),(137,7430511,7430506,'ibr',33.333,2),(137,7430512,7430506,'bre',33.333,2),(137,7430513,7430510,'cha',20,2),(137,7430514,7430510,'han',20,2),(137,7430515,7430510,'ann',20,2),(137,7430516,7430510,'nne',20,2),(137,7430517,7430510,'nel',20,2),(137,7430518,7430513,'dis',50,2),(137,7430519,7430513,'isk',50,2),(137,7430520,7430518,'naa',100,4),(137,7430521,7430520,'600',3.333,4),(137,7430522,7430520,'00a',3.333,4),(137,7430523,7430520,'0a0',3.333,4),(137,7430524,7430520,'a09',3.333,4),(137,7430525,7430520,'098',3.333,4),(137,7430526,7430520,'980',3.333,4),(137,7430527,7430520,'804',3.333,4),(137,7430528,7430520,'044',3.333,4),(137,7430529,7430520,'443',3.333,4),(137,7430530,7430520,'430',3.333,4),(137,7430531,7430520,'307',3.333,4),(137,7430532,7430520,'075',3.333,4),(137,7430533,7430520,'753',3.333,4),(137,7430534,7430520,'535',3.333,4),(137,7430535,7430520,'357',3.333,4),(137,7430536,7430520,'573',3.333,4),(137,7430537,7430520,'732',3.333,4),(137,7430538,7430520,'32b',3.333,4),(137,7430539,7430520,'2b3',3.333,4),(137,7430540,7430520,'b33',3.333,4),(137,7430541,7430520,'334',3.333,4),(137,7430542,7430520,'345',3.333,4),(137,7430543,7430520,'457',3.333,4),(137,7430544,7430520,'571',3.333,4),(137,7430545,7430520,'715',3.333,4),(137,7430546,7430520,'153',3.333,4),(137,7430547,7430520,'533',3.333,4),(137,7430548,7430520,'335',3.333,4),(137,7430549,7430520,'357',3.333,4),(137,7430550,7430520,'577',3.333,4),(137,7430551,7430521,'ser',25,1),(137,7430552,7430521,'eri',25,1),(137,7430553,7430521,'ria',25,1),(137,7430554,7430521,'ial',25,1),(137,7430555,7430551,'siz',50,1),(137,7430556,7430551,'ize',50,1),(137,7430557,7430555,'321',100,1),(137,7430558,7430557,'dev',25,1),(137,7430559,7430557,'evi',25,1),(137,7430560,7430557,'vic',25,1),(137,7430561,7430557,'ice',25,1),(137,7430562,7430558,'typ',50,1),(137,7430563,7430558,'ype',50,1),(137,7430564,7430562,'dir',10,1),(137,7430565,7430562,'ire',10,1),(137,7430566,7430562,'rec',10,1),(137,7430567,7430562,'ect',10,1),(137,7430568,7430562,'cta',10,1),(137,7430569,7430562,'tac',10,1),(137,7430570,7430562,'acc',10,1),(137,7430571,7430562,'cce',10,1),(137,7430572,7430562,'ces',10,1),(137,7430573,7430562,'ess',10,1),(137,7430574,7430564,'mul',14.286,1),(137,7430575,7430564,'ult',14.286,1),(137,7430576,7430564,'lti',14.286,1),(137,7430577,7430564,'tip',14.286,1),(137,7430578,7430564,'ipa',14.286,1),(137,7430579,7430564,'pat',14.286,1),(137,7430580,7430564,'ath',14.286,1),(137,7430581,7430574,'plu',25,1),(137,7430582,7430574,'lug',25,1),(137,7430583,7430574,'ugi',25,1),(137,7430584,7430574,'gin',25,1),(137,7430585,7430581,'nmp',100,1),(137,7430586,7430585,'dev',33.333,1),(137,7430587,7430585,'evf',33.333,1),(137,7430588,7430585,'vfs',33.333,1),(137,7430589,7430586,'pat',50,1),(137,7430590,7430586,'ath',50,1),(137,7430591,7430589,'vmf',50,1),(137,7430592,7430589,'mfs',50,1),(137,7430593,7430591,'dev',20,1),(137,7430594,7430591,'evi',20,1),(137,7430595,7430591,'vic',20,1),(137,7430596,7430591,'ice',20,1),(137,7430597,7430591,'ces',20,1),(137,7430598,7430593,'dis',33.333,1),(137,7430599,7430593,'isk',33.333,1),(137,7430600,7430593,'sks',33.333,1),(137,7430601,7430598,'ven',25,1),(137,7430602,7430598,'end',25,1),(137,7430603,7430598,'ndo',25,1),(137,7430604,7430598,'dor',25,1),(137,7430605,7430601,'mod',33.333,1),(137,7430606,7430601,'ode',33.333,1),(137,7430607,7430601,'del',33.333,1),(137,7430608,7430605,'lun',100,1),(137,7430609,7430608,'cmo',33.333,1),(137,7430610,7430608,'mod',33.333,1),(137,7430611,7430608,'ode',33.333,1),(137,7430612,7430609,'rev',16.667,1),(137,7430613,7430609,'evi',16.667,1),(137,7430614,7430609,'vis',16.667,1),(137,7430615,7430609,'isi',16.667,1),(137,7430616,7430609,'sio',16.667,1),(137,7430617,7430609,'ion',16.667,1),(137,7430618,7430612,'810',50,1),(137,7430619,7430612,'100',50,1),(137,7430620,7430618,'scs',50,1),(137,7430621,7430618,'csi',50,1),(137,7430622,7430620,'lev',33.333,1),(137,7430623,7430620,'eve',33.333,1),(137,7430624,7430620,'vel',33.333,1),(137,7430625,7430622,'pse',25,1),(137,7430626,7430622,'seu',25,1),(137,7430627,7430622,'eud',25,1),(137,7430628,7430622,'udo',25,1),(137,7430629,7430625,'fal',33.333,6),(137,7430630,7430625,'als',33.333,6),(137,7430631,7430625,'lse',33.333,6),(137,7430632,7430629,'sta',25,3),(137,7430633,7430629,'tat',25,3),(137,7430634,7430629,'atu',25,3),(137,7430635,7430629,'tus',25,3),(137,7430636,7430632,'rdm',100,1),(137,7430637,7430636,'cap',20,1),(137,7430638,7430636,'apa',20,1),(137,7430639,7430636,'pab',20,1),(137,7430640,7430636,'abl',20,1),(137,7430641,7430636,'ble',20,1),(137,7430642,7430637,'tru',50,1),(137,7430643,7430637,'rue',50,1),(137,7430644,7430642,'loc',33.333,1),(137,7430645,7430642,'oca',33.333,1),(137,7430646,7430642,'cal',33.333,1),(137,7430647,7430644,'rem',14.286,1),(137,7430648,7430644,'emo',14.286,1),(137,7430649,7430644,'mov',14.286,1),(137,7430650,7430644,'ova',14.286,1),(137,7430651,7430644,'vab',14.286,1),(137,7430652,7430644,'abl',14.286,1),(137,7430653,7430644,'ble',14.286,1),(137,7430654,7430647,'ssd',100,1),(137,7430655,7430654,'off',20,1),(137,7430656,7430654,'ffl',20,1),(137,7430657,7430654,'fli',20,1),(137,7430658,7430654,'lin',20,1),(137,7430659,7430654,'ine',20,1),(137,7430660,7430655,'per',11.111,1),(137,7430661,7430655,'ere',11.111,1),(137,7430662,7430655,'ren',11.111,1),(137,7430663,7430655,'enn',11.111,1),(137,7430664,7430655,'nni',11.111,1),(137,7430665,7430655,'nia',11.111,1),(137,7430666,7430655,'ial',11.111,1),(137,7430667,7430655,'all',11.111,1),(137,7430668,7430655,'lly',11.111,1),(137,7430669,7430660,'res',16.667,1),(137,7430670,7430660,'ese',16.667,1),(137,7430671,7430660,'ser',16.667,1),(137,7430672,7430660,'erv',16.667,1),(137,7430673,7430660,'rve',16.667,1),(137,7430674,7430660,'ved',16.667,1),(137,7430675,7430669,'thi',50,1),(137,7430676,7430669,'hin',50,1),(137,7430677,7430675,'pro',10,1),(137,7430678,7430675,'rov',10,1),(137,7430679,7430675,'ovi',10,1),(137,7430680,7430675,'vis',10,1),(137,7430681,7430675,'isi',10,1),(137,7430682,7430675,'sio',10,1),(137,7430683,7430675,'ion',10,1),(137,7430684,7430675,'oni',10,1),(137,7430685,7430675,'nin',10,1),(137,7430686,7430675,'ing',10,1),(137,7430687,7430677,'yes',100,1),(137,7430688,7430687,'att',16.667,1),(137,7430689,7430687,'tta',16.667,1),(137,7430690,7430687,'tac',16.667,1),(137,7430691,7430687,'ach',16.667,1),(137,7430692,7430687,'che',16.667,1),(137,7430693,7430687,'hed',16.667,1),(137,7430694,7430688,'fil',20,1),(137,7430695,7430688,'ilt',20,1),(137,7430696,7430688,'lte',20,1),(137,7430697,7430688,'ter',20,1),(137,7430698,7430688,'ers',20,1),(137,7430699,7430694,'vaa',50,1),(137,7430700,7430694,'aai',50,1),(137,7430701,7430699,'unk',20,1),(137,7430702,7430699,'nkn',20,1),(137,7430703,7430699,'kno',20,1),(137,7430704,7430699,'now',20,1),(137,7430705,7430699,'own',20,1),(137,7430706,7430701,'oth',33.333,1),(137,7430707,7430701,'the',33.333,1),(137,7430708,7430701,'her',33.333,1),(137,7430709,7430706,'uid',50,1),(137,7430710,7430706,'ids',50,1),(137,7430711,7430709,'vml',100,1),(137,7430712,7430711,'dis',20,1),(137,7430713,7430711,'isp',20,1),(137,7430714,7430711,'spl',20,1),(137,7430715,7430711,'pla',20,1),(137,7430716,7430711,'lay',20,1),(137,7430717,7430712,'nam',50,1),(137,7430718,7430712,'ame',50,1),(138,7430720,7430719,'net',25,3),(138,7430721,7430719,'eta',25,3),(138,7430722,7430719,'tap',25,3),(138,7430723,7430719,'app',25,3),(138,7430724,7430720,'fib',33.333,2),(138,7430725,7430720,'ibr',33.333,2),(138,7430726,7430720,'bre',33.333,2),(138,7430727,7430724,'cha',20,2),(138,7430728,7430724,'han',20,2),(138,7430729,7430724,'ann',20,2),(138,7430730,7430724,'nne',20,2),(138,7430731,7430724,'nel',20,2),(138,7430732,7430727,'dis',50,2),(138,7430733,7430727,'isk',50,2),(138,7430734,7430732,'naa',100,4),(138,7430735,7430734,'600',3.333,4),(138,7430736,7430734,'00a',3.333,4),(138,7430737,7430734,'0a0',3.333,4),(138,7430738,7430734,'a09',3.333,4),(138,7430739,7430734,'098',3.333,4),(138,7430740,7430734,'980',3.333,4),(138,7430741,7430734,'804',3.333,4),(138,7430742,7430734,'044',3.333,4),(138,7430743,7430734,'443',3.333,4),(138,7430744,7430734,'430',3.333,4),(138,7430745,7430734,'307',3.333,4),(138,7430746,7430734,'075',3.333,4),(138,7430747,7430734,'753',3.333,4),(138,7430748,7430734,'535',3.333,4),(138,7430749,7430734,'357',3.333,4),(138,7430750,7430734,'573',3.333,4),(138,7430751,7430734,'732',3.333,4),(138,7430752,7430734,'32b',3.333,4),(138,7430753,7430734,'2b3',3.333,4),(138,7430754,7430734,'b33',3.333,4),(138,7430755,7430734,'334',3.333,4),(138,7430756,7430734,'345',3.333,4),(138,7430757,7430734,'457',3.333,4),(138,7430758,7430734,'571',3.333,4),(138,7430759,7430734,'715',3.333,4),(138,7430760,7430734,'153',3.333,4),(138,7430761,7430734,'533',3.333,4),(138,7430762,7430734,'336',3.333,4),(138,7430763,7430734,'365',3.333,4),(138,7430764,7430734,'654',3.333,4),(138,7430765,7430735,'ser',25,1),(138,7430766,7430735,'eri',25,1),(138,7430767,7430735,'ria',25,1),(138,7430768,7430735,'ial',25,1),(138,7430769,7430765,'siz',50,1),(138,7430770,7430765,'ize',50,1),(138,7430771,7430769,'321',100,1),(138,7430772,7430771,'dev',25,1),(138,7430773,7430771,'evi',25,1),(138,7430774,7430771,'vic',25,1),(138,7430775,7430771,'ice',25,1),(138,7430776,7430772,'typ',50,1),(138,7430777,7430772,'ype',50,1),(138,7430778,7430776,'dir',10,1),(138,7430779,7430776,'ire',10,1),(138,7430780,7430776,'rec',10,1),(138,7430781,7430776,'ect',10,1),(138,7430782,7430776,'cta',10,1),(138,7430783,7430776,'tac',10,1),(138,7430784,7430776,'acc',10,1),(138,7430785,7430776,'cce',10,1),(138,7430786,7430776,'ces',10,1),(138,7430787,7430776,'ess',10,1),(138,7430788,7430778,'mul',14.286,1),(138,7430789,7430778,'ult',14.286,1),(138,7430790,7430778,'lti',14.286,1),(138,7430791,7430778,'tip',14.286,1),(138,7430792,7430778,'ipa',14.286,1),(138,7430793,7430778,'pat',14.286,1),(138,7430794,7430778,'ath',14.286,1),(138,7430795,7430788,'plu',25,1),(138,7430796,7430788,'lug',25,1),(138,7430797,7430788,'ugi',25,1),(138,7430798,7430788,'gin',25,1),(138,7430799,7430795,'nmp',100,1),(138,7430800,7430799,'dev',33.333,1),(138,7430801,7430799,'evf',33.333,1),(138,7430802,7430799,'vfs',33.333,1),(138,7430803,7430800,'pat',50,1),(138,7430804,7430800,'ath',50,1),(138,7430805,7430803,'vmf',50,1),(138,7430806,7430803,'mfs',50,1),(138,7430807,7430805,'dev',20,1),(138,7430808,7430805,'evi',20,1),(138,7430809,7430805,'vic',20,1),(138,7430810,7430805,'ice',20,1),(138,7430811,7430805,'ces',20,1),(138,7430812,7430807,'dis',33.333,1),(138,7430813,7430807,'isk',33.333,1),(138,7430814,7430807,'sks',33.333,1),(138,7430815,7430812,'ven',25,1),(138,7430816,7430812,'end',25,1),(138,7430817,7430812,'ndo',25,1),(138,7430818,7430812,'dor',25,1),(138,7430819,7430815,'mod',33.333,1),(138,7430820,7430815,'ode',33.333,1),(138,7430821,7430815,'del',33.333,1),(138,7430822,7430819,'lun',100,1),(138,7430823,7430822,'cmo',33.333,1),(138,7430824,7430822,'mod',33.333,1),(138,7430825,7430822,'ode',33.333,1),(138,7430826,7430823,'rev',16.667,1),(138,7430827,7430823,'evi',16.667,1),(138,7430828,7430823,'vis',16.667,1),(138,7430829,7430823,'isi',16.667,1),(138,7430830,7430823,'sio',16.667,1),(138,7430831,7430823,'ion',16.667,1),(138,7430832,7430826,'810',50,1),(138,7430833,7430826,'100',50,1),(138,7430834,7430832,'scs',50,1),(138,7430835,7430832,'csi',50,1),(138,7430836,7430834,'lev',33.333,1),(138,7430837,7430834,'eve',33.333,1),(138,7430838,7430834,'vel',33.333,1),(138,7430839,7430836,'pse',25,1),(138,7430840,7430836,'seu',25,1),(138,7430841,7430836,'eud',25,1),(138,7430842,7430836,'udo',25,1),(138,7430843,7430839,'fal',33.333,6),(138,7430844,7430839,'als',33.333,6),(138,7430845,7430839,'lse',33.333,6),(138,7430846,7430843,'sta',25,3),(138,7430847,7430843,'tat',25,3),(138,7430848,7430843,'atu',25,3),(138,7430849,7430843,'tus',25,3),(138,7430850,7430846,'rdm',100,1),(138,7430851,7430850,'cap',20,1),(138,7430852,7430850,'apa',20,1),(138,7430853,7430850,'pab',20,1),(138,7430854,7430850,'abl',20,1),(138,7430855,7430850,'ble',20,1),(138,7430856,7430851,'tru',50,1),(138,7430857,7430851,'rue',50,1),(138,7430858,7430856,'loc',33.333,1),(138,7430859,7430856,'oca',33.333,1),(138,7430860,7430856,'cal',33.333,1),(138,7430861,7430858,'rem',14.286,1),(138,7430862,7430858,'emo',14.286,1),(138,7430863,7430858,'mov',14.286,1),(138,7430864,7430858,'ova',14.286,1),(138,7430865,7430858,'vab',14.286,1),(138,7430866,7430858,'abl',14.286,1),(138,7430867,7430858,'ble',14.286,1),(138,7430868,7430861,'ssd',100,1),(138,7430869,7430868,'off',20,1),(138,7430870,7430868,'ffl',20,1),(138,7430871,7430868,'fli',20,1),(138,7430872,7430868,'lin',20,1),(138,7430873,7430868,'ine',20,1),(138,7430874,7430869,'per',11.111,1),(138,7430875,7430869,'ere',11.111,1),(138,7430876,7430869,'ren',11.111,1),(138,7430877,7430869,'enn',11.111,1),(138,7430878,7430869,'nni',11.111,1),(138,7430879,7430869,'nia',11.111,1),(138,7430880,7430869,'ial',11.111,1),(138,7430881,7430869,'all',11.111,1),(138,7430882,7430869,'lly',11.111,1),(138,7430883,7430874,'res',16.667,1),(138,7430884,7430874,'ese',16.667,1),(138,7430885,7430874,'ser',16.667,1),(138,7430886,7430874,'erv',16.667,1),(138,7430887,7430874,'rve',16.667,1),(138,7430888,7430874,'ved',16.667,1),(138,7430889,7430883,'thi',50,1),(138,7430890,7430883,'hin',50,1),(138,7430891,7430889,'pro',10,1),(138,7430892,7430889,'rov',10,1),(138,7430893,7430889,'ovi',10,1),(138,7430894,7430889,'vis',10,1),(138,7430895,7430889,'isi',10,1),(138,7430896,7430889,'sio',10,1),(138,7430897,7430889,'ion',10,1),(138,7430898,7430889,'oni',10,1),(138,7430899,7430889,'nin',10,1),(138,7430900,7430889,'ing',10,1),(138,7430901,7430891,'yes',100,1),(138,7430902,7430901,'att',16.667,1),(138,7430903,7430901,'tta',16.667,1),(138,7430904,7430901,'tac',16.667,1),(138,7430905,7430901,'ach',16.667,1),(138,7430906,7430901,'che',16.667,1),(138,7430907,7430901,'hed',16.667,1),(138,7430908,7430902,'fil',20,1),(138,7430909,7430902,'ilt',20,1),(138,7430910,7430902,'lte',20,1),(138,7430911,7430902,'ter',20,1),(138,7430912,7430902,'ers',20,1),(138,7430913,7430908,'vaa',50,1),(138,7430914,7430908,'aai',50,1),(138,7430915,7430913,'unk',20,1),(138,7430916,7430913,'nkn',20,1),(138,7430917,7430913,'kno',20,1),(138,7430918,7430913,'now',20,1),(138,7430919,7430913,'own',20,1),(138,7430920,7430915,'oth',33.333,1),(138,7430921,7430915,'the',33.333,1),(138,7430922,7430915,'her',33.333,1),(138,7430923,7430920,'uid',50,1),(138,7430924,7430920,'ids',50,1),(138,7430925,7430923,'vml',100,1),(138,7430926,7430925,'dis',20,1),(138,7430927,7430925,'isp',20,1),(138,7430928,7430925,'spl',20,1),(138,7430929,7430925,'pla',20,1),(138,7430930,7430925,'lay',20,1),(138,7430931,7430926,'nam',50,1),(138,7430932,7430926,'ame',50,1),(139,7430934,7430933,'net',25,3),(139,7430935,7430933,'eta',25,3),(139,7430936,7430933,'tap',25,3),(139,7430937,7430933,'app',25,3),(139,7430938,7430934,'fib',33.333,2),(139,7430939,7430934,'ibr',33.333,2),(139,7430940,7430934,'bre',33.333,2),(139,7430941,7430938,'cha',20,2),(139,7430942,7430938,'han',20,2),(139,7430943,7430938,'ann',20,2),(139,7430944,7430938,'nne',20,2),(139,7430945,7430938,'nel',20,2),(139,7430946,7430941,'dis',50,2),(139,7430947,7430941,'isk',50,2),(139,7430948,7430946,'naa',100,4),(139,7430949,7430948,'600',3.333,4),(139,7430950,7430948,'00a',3.333,4),(139,7430951,7430948,'0a0',3.333,4),(139,7430952,7430948,'a09',3.333,4),(139,7430953,7430948,'098',3.333,4),(139,7430954,7430948,'980',3.333,4),(139,7430955,7430948,'804',3.333,4),(139,7430956,7430948,'044',3.333,4),(139,7430957,7430948,'443',3.333,4),(139,7430958,7430948,'430',3.333,4),(139,7430959,7430948,'307',3.333,4),(139,7430960,7430948,'075',3.333,4),(139,7430961,7430948,'753',3.333,4),(139,7430962,7430948,'535',3.333,4),(139,7430963,7430948,'357',3.333,4),(139,7430964,7430948,'573',3.333,4),(139,7430965,7430948,'732',3.333,4),(139,7430966,7430948,'32b',3.333,4),(139,7430967,7430948,'2b3',3.333,4),(139,7430968,7430948,'b33',3.333,4),(139,7430969,7430948,'334',3.333,4),(139,7430970,7430948,'345',3.333,4),(139,7430971,7430948,'457',3.333,4),(139,7430972,7430948,'571',3.333,4),(139,7430973,7430948,'715',3.333,4),(139,7430974,7430948,'153',3.333,4),(139,7430975,7430948,'533',3.333,4),(139,7430976,7430948,'335',3.333,4),(139,7430977,7430948,'357',3.333,4),(139,7430978,7430948,'578',3.333,4),(139,7430979,7430949,'ser',25,1),(139,7430980,7430949,'eri',25,1),(139,7430981,7430949,'ria',25,1),(139,7430982,7430949,'ial',25,1),(139,7430983,7430979,'siz',50,1),(139,7430984,7430979,'ize',50,1),(139,7430985,7430983,'321',100,1),(139,7430986,7430985,'dev',25,1),(139,7430987,7430985,'evi',25,1),(139,7430988,7430985,'vic',25,1),(139,7430989,7430985,'ice',25,1),(139,7430990,7430986,'typ',50,1),(139,7430991,7430986,'ype',50,1),(139,7430992,7430990,'dir',10,1),(139,7430993,7430990,'ire',10,1),(139,7430994,7430990,'rec',10,1),(139,7430995,7430990,'ect',10,1),(139,7430996,7430990,'cta',10,1),(139,7430997,7430990,'tac',10,1),(139,7430998,7430990,'acc',10,1),(139,7430999,7430990,'cce',10,1),(139,7431000,7430990,'ces',10,1),(139,7431001,7430990,'ess',10,1),(139,7431002,7430992,'mul',14.286,1),(139,7431003,7430992,'ult',14.286,1),(139,7431004,7430992,'lti',14.286,1),(139,7431005,7430992,'tip',14.286,1),(139,7431006,7430992,'ipa',14.286,1),(139,7431007,7430992,'pat',14.286,1),(139,7431008,7430992,'ath',14.286,1),(139,7431009,7431002,'plu',25,1),(139,7431010,7431002,'lug',25,1),(139,7431011,7431002,'ugi',25,1),(139,7431012,7431002,'gin',25,1),(139,7431013,7431009,'nmp',100,1),(139,7431014,7431013,'dev',33.333,1),(139,7431015,7431013,'evf',33.333,1),(139,7431016,7431013,'vfs',33.333,1),(139,7431017,7431014,'pat',50,1),(139,7431018,7431014,'ath',50,1),(139,7431019,7431017,'vmf',50,1),(139,7431020,7431017,'mfs',50,1),(139,7431021,7431019,'dev',20,1),(139,7431022,7431019,'evi',20,1),(139,7431023,7431019,'vic',20,1),(139,7431024,7431019,'ice',20,1),(139,7431025,7431019,'ces',20,1),(139,7431026,7431021,'dis',33.333,1),(139,7431027,7431021,'isk',33.333,1),(139,7431028,7431021,'sks',33.333,1),(139,7431029,7431026,'ven',25,1),(139,7431030,7431026,'end',25,1),(139,7431031,7431026,'ndo',25,1),(139,7431032,7431026,'dor',25,1),(139,7431033,7431029,'mod',33.333,1),(139,7431034,7431029,'ode',33.333,1),(139,7431035,7431029,'del',33.333,1),(139,7431036,7431033,'lun',100,1),(139,7431037,7431036,'cmo',33.333,1),(139,7431038,7431036,'mod',33.333,1),(139,7431039,7431036,'ode',33.333,1),(139,7431040,7431037,'rev',16.667,1),(139,7431041,7431037,'evi',16.667,1),(139,7431042,7431037,'vis',16.667,1),(139,7431043,7431037,'isi',16.667,1),(139,7431044,7431037,'sio',16.667,1),(139,7431045,7431037,'ion',16.667,1),(139,7431046,7431040,'810',50,1),(139,7431047,7431040,'100',50,1),(139,7431048,7431046,'scs',50,1),(139,7431049,7431046,'csi',50,1),(139,7431050,7431048,'lev',33.333,1),(139,7431051,7431048,'eve',33.333,1),(139,7431052,7431048,'vel',33.333,1),(139,7431053,7431050,'pse',25,1),(139,7431054,7431050,'seu',25,1),(139,7431055,7431050,'eud',25,1),(139,7431056,7431050,'udo',25,1),(139,7431057,7431053,'fal',33.333,6),(139,7431058,7431053,'als',33.333,6),(139,7431059,7431053,'lse',33.333,6),(139,7431060,7431057,'sta',25,3),(139,7431061,7431057,'tat',25,3),(139,7431062,7431057,'atu',25,3),(139,7431063,7431057,'tus',25,3),(139,7431064,7431060,'rdm',100,1),(139,7431065,7431064,'cap',20,1),(139,7431066,7431064,'apa',20,1),(139,7431067,7431064,'pab',20,1),(139,7431068,7431064,'abl',20,1),(139,7431069,7431064,'ble',20,1),(139,7431070,7431065,'tru',50,1),(139,7431071,7431065,'rue',50,1),(139,7431072,7431070,'loc',33.333,1),(139,7431073,7431070,'oca',33.333,1),(139,7431074,7431070,'cal',33.333,1),(139,7431075,7431072,'rem',14.286,1),(139,7431076,7431072,'emo',14.286,1),(139,7431077,7431072,'mov',14.286,1),(139,7431078,7431072,'ova',14.286,1),(139,7431079,7431072,'vab',14.286,1),(139,7431080,7431072,'abl',14.286,1),(139,7431081,7431072,'ble',14.286,1),(139,7431082,7431075,'ssd',100,1),(139,7431083,7431082,'off',20,1),(139,7431084,7431082,'ffl',20,1),(139,7431085,7431082,'fli',20,1),(139,7431086,7431082,'lin',20,1),(139,7431087,7431082,'ine',20,1),(139,7431088,7431083,'per',11.111,1),(139,7431089,7431083,'ere',11.111,1),(139,7431090,7431083,'ren',11.111,1),(139,7431091,7431083,'enn',11.111,1),(139,7431092,7431083,'nni',11.111,1),(139,7431093,7431083,'nia',11.111,1),(139,7431094,7431083,'ial',11.111,1),(139,7431095,7431083,'all',11.111,1),(139,7431096,7431083,'lly',11.111,1),(139,7431097,7431088,'res',16.667,1),(139,7431098,7431088,'ese',16.667,1),(139,7431099,7431088,'ser',16.667,1),(139,7431100,7431088,'erv',16.667,1),(139,7431101,7431088,'rve',16.667,1),(139,7431102,7431088,'ved',16.667,1),(139,7431103,7431097,'thi',50,1),(139,7431104,7431097,'hin',50,1),(139,7431105,7431103,'pro',10,1),(139,7431106,7431103,'rov',10,1),(139,7431107,7431103,'ovi',10,1),(139,7431108,7431103,'vis',10,1),(139,7431109,7431103,'isi',10,1),(139,7431110,7431103,'sio',10,1),(139,7431111,7431103,'ion',10,1),(139,7431112,7431103,'oni',10,1),(139,7431113,7431103,'nin',10,1),(139,7431114,7431103,'ing',10,1),(139,7431115,7431105,'yes',100,1),(139,7431116,7431115,'att',16.667,1),(139,7431117,7431115,'tta',16.667,1),(139,7431118,7431115,'tac',16.667,1),(139,7431119,7431115,'ach',16.667,1),(139,7431120,7431115,'che',16.667,1),(139,7431121,7431115,'hed',16.667,1),(139,7431122,7431116,'fil',20,1),(139,7431123,7431116,'ilt',20,1),(139,7431124,7431116,'lte',20,1),(139,7431125,7431116,'ter',20,1),(139,7431126,7431116,'ers',20,1),(139,7431127,7431122,'vaa',50,1),(139,7431128,7431122,'aai',50,1),(139,7431129,7431127,'unk',20,1),(139,7431130,7431127,'nkn',20,1),(139,7431131,7431127,'kno',20,1),(139,7431132,7431127,'now',20,1),(139,7431133,7431127,'own',20,1),(139,7431134,7431129,'oth',33.333,1),(139,7431135,7431129,'the',33.333,1),(139,7431136,7431129,'her',33.333,1),(139,7431137,7431134,'uid',50,1),(139,7431138,7431134,'ids',50,1),(139,7431139,7431137,'vml',100,1),(139,7431140,7431139,'dis',20,1),(139,7431141,7431139,'isp',20,1),(139,7431142,7431139,'spl',20,1),(139,7431143,7431139,'pla',20,1),(139,7431144,7431139,'lay',20,1),(139,7431145,7431140,'nam',50,1),(139,7431146,7431140,'ame',50,1),(140,7431148,7431147,'net',25,3),(140,7431149,7431147,'eta',25,3),(140,7431150,7431147,'tap',25,3),(140,7431151,7431147,'app',25,3),(140,7431152,7431148,'fib',33.333,2),(140,7431153,7431148,'ibr',33.333,2),(140,7431154,7431148,'bre',33.333,2),(140,7431155,7431152,'cha',20,2),(140,7431156,7431152,'han',20,2),(140,7431157,7431152,'ann',20,2),(140,7431158,7431152,'nne',20,2),(140,7431159,7431152,'nel',20,2),(140,7431160,7431155,'dis',50,2),(140,7431161,7431155,'isk',50,2),(140,7431162,7431160,'naa',100,4),(140,7431163,7431162,'600',3.333,4),(140,7431164,7431162,'00a',3.333,4),(140,7431165,7431162,'0a0',3.333,4),(140,7431166,7431162,'a09',3.333,4),(140,7431167,7431162,'098',3.333,4),(140,7431168,7431162,'980',3.333,4),(140,7431169,7431162,'804',3.333,4),(140,7431170,7431162,'044',3.333,4),(140,7431171,7431162,'443',3.333,4),(140,7431172,7431162,'430',3.333,4),(140,7431173,7431162,'307',3.333,4),(140,7431174,7431162,'075',3.333,4),(140,7431175,7431162,'753',3.333,4),(140,7431176,7431162,'535',3.333,4),(140,7431177,7431162,'357',3.333,4),(140,7431178,7431162,'573',3.333,4),(140,7431179,7431162,'732',3.333,4),(140,7431180,7431162,'32b',3.333,4),(140,7431181,7431162,'2b3',3.333,4),(140,7431182,7431162,'b33',3.333,4),(140,7431183,7431162,'334',3.333,4),(140,7431184,7431162,'345',3.333,4),(140,7431185,7431162,'457',3.333,4),(140,7431186,7431162,'571',3.333,4),(140,7431187,7431162,'715',3.333,4),(140,7431188,7431162,'153',3.333,4),(140,7431189,7431162,'533',3.333,4),(140,7431190,7431162,'336',3.333,4),(140,7431191,7431162,'365',3.333,4),(140,7431192,7431162,'655',3.333,4),(140,7431193,7431163,'ser',25,1),(140,7431194,7431163,'eri',25,1),(140,7431195,7431163,'ria',25,1),(140,7431196,7431163,'ial',25,1),(140,7431197,7431193,'siz',50,1),(140,7431198,7431193,'ize',50,1),(140,7431199,7431197,'321',100,1),(140,7431200,7431199,'dev',25,1),(140,7431201,7431199,'evi',25,1),(140,7431202,7431199,'vic',25,1),(140,7431203,7431199,'ice',25,1),(140,7431204,7431200,'typ',50,1),(140,7431205,7431200,'ype',50,1),(140,7431206,7431204,'dir',10,1),(140,7431207,7431204,'ire',10,1),(140,7431208,7431204,'rec',10,1),(140,7431209,7431204,'ect',10,1),(140,7431210,7431204,'cta',10,1),(140,7431211,7431204,'tac',10,1),(140,7431212,7431204,'acc',10,1),(140,7431213,7431204,'cce',10,1),(140,7431214,7431204,'ces',10,1),(140,7431215,7431204,'ess',10,1),(140,7431216,7431206,'mul',14.286,1),(140,7431217,7431206,'ult',14.286,1),(140,7431218,7431206,'lti',14.286,1),(140,7431219,7431206,'tip',14.286,1),(140,7431220,7431206,'ipa',14.286,1),(140,7431221,7431206,'pat',14.286,1),(140,7431222,7431206,'ath',14.286,1),(140,7431223,7431216,'plu',25,1),(140,7431224,7431216,'lug',25,1),(140,7431225,7431216,'ugi',25,1),(140,7431226,7431216,'gin',25,1),(140,7431227,7431223,'nmp',100,1),(140,7431228,7431227,'dev',33.333,1),(140,7431229,7431227,'evf',33.333,1),(140,7431230,7431227,'vfs',33.333,1),(140,7431231,7431228,'pat',50,1),(140,7431232,7431228,'ath',50,1),(140,7431233,7431231,'vmf',50,1),(140,7431234,7431231,'mfs',50,1),(140,7431235,7431233,'dev',20,1),(140,7431236,7431233,'evi',20,1),(140,7431237,7431233,'vic',20,1),(140,7431238,7431233,'ice',20,1),(140,7431239,7431233,'ces',20,1),(140,7431240,7431235,'dis',33.333,1),(140,7431241,7431235,'isk',33.333,1),(140,7431242,7431235,'sks',33.333,1),(140,7431243,7431240,'ven',25,1),(140,7431244,7431240,'end',25,1),(140,7431245,7431240,'ndo',25,1),(140,7431246,7431240,'dor',25,1),(140,7431247,7431243,'mod',33.333,1),(140,7431248,7431243,'ode',33.333,1),(140,7431249,7431243,'del',33.333,1),(140,7431250,7431247,'lun',100,1),(140,7431251,7431250,'cmo',33.333,1),(140,7431252,7431250,'mod',33.333,1),(140,7431253,7431250,'ode',33.333,1),(140,7431254,7431251,'rev',16.667,1),(140,7431255,7431251,'evi',16.667,1),(140,7431256,7431251,'vis',16.667,1),(140,7431257,7431251,'isi',16.667,1),(140,7431258,7431251,'sio',16.667,1),(140,7431259,7431251,'ion',16.667,1),(140,7431260,7431254,'810',50,1),(140,7431261,7431254,'100',50,1),(140,7431262,7431260,'scs',50,1),(140,7431263,7431260,'csi',50,1),(140,7431264,7431262,'lev',33.333,1),(140,7431265,7431262,'eve',33.333,1),(140,7431266,7431262,'vel',33.333,1),(140,7431267,7431264,'pse',25,1),(140,7431268,7431264,'seu',25,1),(140,7431269,7431264,'eud',25,1),(140,7431270,7431264,'udo',25,1),(140,7431271,7431267,'fal',33.333,6),(140,7431272,7431267,'als',33.333,6),(140,7431273,7431267,'lse',33.333,6),(140,7431274,7431271,'sta',25,3),(140,7431275,7431271,'tat',25,3),(140,7431276,7431271,'atu',25,3),(140,7431277,7431271,'tus',25,3),(140,7431278,7431274,'rdm',100,1),(140,7431279,7431278,'cap',20,1),(140,7431280,7431278,'apa',20,1),(140,7431281,7431278,'pab',20,1),(140,7431282,7431278,'abl',20,1),(140,7431283,7431278,'ble',20,1),(140,7431284,7431279,'tru',50,1),(140,7431285,7431279,'rue',50,1),(140,7431286,7431284,'loc',33.333,1),(140,7431287,7431284,'oca',33.333,1),(140,7431288,7431284,'cal',33.333,1),(140,7431289,7431286,'rem',14.286,1),(140,7431290,7431286,'emo',14.286,1),(140,7431291,7431286,'mov',14.286,1),(140,7431292,7431286,'ova',14.286,1),(140,7431293,7431286,'vab',14.286,1),(140,7431294,7431286,'abl',14.286,1),(140,7431295,7431286,'ble',14.286,1),(140,7431296,7431289,'ssd',100,1),(140,7431297,7431296,'off',20,1),(140,7431298,7431296,'ffl',20,1),(140,7431299,7431296,'fli',20,1),(140,7431300,7431296,'lin',20,1),(140,7431301,7431296,'ine',20,1),(140,7431302,7431297,'per',11.111,1),(140,7431303,7431297,'ere',11.111,1),(140,7431304,7431297,'ren',11.111,1),(140,7431305,7431297,'enn',11.111,1),(140,7431306,7431297,'nni',11.111,1),(140,7431307,7431297,'nia',11.111,1),(140,7431308,7431297,'ial',11.111,1),(140,7431309,7431297,'all',11.111,1),(140,7431310,7431297,'lly',11.111,1),(140,7431311,7431302,'res',16.667,1),(140,7431312,7431302,'ese',16.667,1),(140,7431313,7431302,'ser',16.667,1),(140,7431314,7431302,'erv',16.667,1),(140,7431315,7431302,'rve',16.667,1),(140,7431316,7431302,'ved',16.667,1),(140,7431317,7431311,'thi',50,1),(140,7431318,7431311,'hin',50,1),(140,7431319,7431317,'pro',10,1),(140,7431320,7431317,'rov',10,1),(140,7431321,7431317,'ovi',10,1),(140,7431322,7431317,'vis',10,1),(140,7431323,7431317,'isi',10,1),(140,7431324,7431317,'sio',10,1),(140,7431325,7431317,'ion',10,1),(140,7431326,7431317,'oni',10,1),(140,7431327,7431317,'nin',10,1),(140,7431328,7431317,'ing',10,1),(140,7431329,7431319,'yes',100,1),(140,7431330,7431329,'att',16.667,1),(140,7431331,7431329,'tta',16.667,1),(140,7431332,7431329,'tac',16.667,1),(140,7431333,7431329,'ach',16.667,1),(140,7431334,7431329,'che',16.667,1),(140,7431335,7431329,'hed',16.667,1),(140,7431336,7431330,'fil',20,1),(140,7431337,7431330,'ilt',20,1),(140,7431338,7431330,'lte',20,1),(140,7431339,7431330,'ter',20,1),(140,7431340,7431330,'ers',20,1),(140,7431341,7431336,'vaa',50,1),(140,7431342,7431336,'aai',50,1),(140,7431343,7431341,'unk',20,1),(140,7431344,7431341,'nkn',20,1),(140,7431345,7431341,'kno',20,1),(140,7431346,7431341,'now',20,1),(140,7431347,7431341,'own',20,1),(140,7431348,7431343,'oth',33.333,1),(140,7431349,7431343,'the',33.333,1),(140,7431350,7431343,'her',33.333,1),(140,7431351,7431348,'uid',50,1),(140,7431352,7431348,'ids',50,1),(140,7431353,7431351,'vml',100,1),(140,7431354,7431353,'dis',20,1),(140,7431355,7431353,'isp',20,1),(140,7431356,7431353,'spl',20,1),(140,7431357,7431353,'pla',20,1),(140,7431358,7431353,'lay',20,1),(140,7431359,7431354,'nam',50,1),(140,7431360,7431354,'ame',50,1),(141,7431362,7431361,'net',25,3),(141,7431363,7431361,'eta',25,3),(141,7431364,7431361,'tap',25,3),(141,7431365,7431361,'app',25,3),(141,7431366,7431362,'fib',33.333,2),(141,7431367,7431362,'ibr',33.333,2),(141,7431368,7431362,'bre',33.333,2),(141,7431369,7431366,'cha',20,2),(141,7431370,7431366,'han',20,2),(141,7431371,7431366,'ann',20,2),(141,7431372,7431366,'nne',20,2),(141,7431373,7431366,'nel',20,2),(141,7431374,7431369,'dis',50,2),(141,7431375,7431369,'isk',50,2),(141,7431376,7431374,'naa',100,4),(141,7431377,7431376,'600',3.333,4),(141,7431378,7431376,'00a',3.333,4),(141,7431379,7431376,'0a0',3.333,4),(141,7431380,7431376,'a09',3.333,4),(141,7431381,7431376,'098',3.333,4),(141,7431382,7431376,'980',3.333,4),(141,7431383,7431376,'804',3.333,4),(141,7431384,7431376,'044',3.333,4),(141,7431385,7431376,'443',3.333,4),(141,7431386,7431376,'430',3.333,4),(141,7431387,7431376,'307',3.333,4),(141,7431388,7431376,'075',3.333,4),(141,7431389,7431376,'753',3.333,4),(141,7431390,7431376,'535',3.333,4),(141,7431391,7431376,'357',3.333,4),(141,7431392,7431376,'573',3.333,4),(141,7431393,7431376,'732',3.333,4),(141,7431394,7431376,'32b',3.333,4),(141,7431395,7431376,'2b3',3.333,4),(141,7431396,7431376,'b33',3.333,4),(141,7431397,7431376,'334',3.333,4),(141,7431398,7431376,'345',3.333,4),(141,7431399,7431376,'457',3.333,4),(141,7431400,7431376,'571',3.333,4),(141,7431401,7431376,'715',3.333,4),(141,7431402,7431376,'153',3.333,4),(141,7431403,7431376,'533',3.333,4),(141,7431404,7431376,'335',3.333,4),(141,7431405,7431376,'357',3.333,4),(141,7431406,7431376,'579',3.333,4),(141,7431407,7431377,'ser',25,1),(141,7431408,7431377,'eri',25,1),(141,7431409,7431377,'ria',25,1),(141,7431410,7431377,'ial',25,1),(141,7431411,7431407,'siz',50,1),(141,7431412,7431407,'ize',50,1),(141,7431413,7431411,'321',100,1),(141,7431414,7431413,'dev',25,1),(141,7431415,7431413,'evi',25,1),(141,7431416,7431413,'vic',25,1),(141,7431417,7431413,'ice',25,1),(141,7431418,7431414,'typ',50,1),(141,7431419,7431414,'ype',50,1),(141,7431420,7431418,'dir',10,1),(141,7431421,7431418,'ire',10,1),(141,7431422,7431418,'rec',10,1),(141,7431423,7431418,'ect',10,1),(141,7431424,7431418,'cta',10,1),(141,7431425,7431418,'tac',10,1),(141,7431426,7431418,'acc',10,1),(141,7431427,7431418,'cce',10,1),(141,7431428,7431418,'ces',10,1),(141,7431429,7431418,'ess',10,1),(141,7431430,7431420,'mul',14.286,1),(141,7431431,7431420,'ult',14.286,1),(141,7431432,7431420,'lti',14.286,1),(141,7431433,7431420,'tip',14.286,1),(141,7431434,7431420,'ipa',14.286,1),(141,7431435,7431420,'pat',14.286,1),(141,7431436,7431420,'ath',14.286,1),(141,7431437,7431430,'plu',25,1),(141,7431438,7431430,'lug',25,1),(141,7431439,7431430,'ugi',25,1),(141,7431440,7431430,'gin',25,1),(141,7431441,7431437,'nmp',100,1),(141,7431442,7431441,'dev',33.333,1),(141,7431443,7431441,'evf',33.333,1),(141,7431444,7431441,'vfs',33.333,1),(141,7431445,7431442,'pat',50,1),(141,7431446,7431442,'ath',50,1),(141,7431447,7431445,'vmf',50,1),(141,7431448,7431445,'mfs',50,1),(141,7431449,7431447,'dev',20,1),(141,7431450,7431447,'evi',20,1),(141,7431451,7431447,'vic',20,1),(141,7431452,7431447,'ice',20,1),(141,7431453,7431447,'ces',20,1),(141,7431454,7431449,'dis',33.333,1),(141,7431455,7431449,'isk',33.333,1),(141,7431456,7431449,'sks',33.333,1),(141,7431457,7431454,'ven',25,1),(141,7431458,7431454,'end',25,1),(141,7431459,7431454,'ndo',25,1),(141,7431460,7431454,'dor',25,1),(141,7431461,7431457,'mod',33.333,1),(141,7431462,7431457,'ode',33.333,1),(141,7431463,7431457,'del',33.333,1),(141,7431464,7431461,'lun',100,1),(141,7431465,7431464,'cmo',33.333,1),(141,7431466,7431464,'mod',33.333,1),(141,7431467,7431464,'ode',33.333,1),(141,7431468,7431465,'rev',16.667,1),(141,7431469,7431465,'evi',16.667,1),(141,7431470,7431465,'vis',16.667,1),(141,7431471,7431465,'isi',16.667,1),(141,7431472,7431465,'sio',16.667,1),(141,7431473,7431465,'ion',16.667,1),(141,7431474,7431468,'810',50,1),(141,7431475,7431468,'100',50,1),(141,7431476,7431474,'scs',50,1),(141,7431477,7431474,'csi',50,1),(141,7431478,7431476,'lev',33.333,1),(141,7431479,7431476,'eve',33.333,1),(141,7431480,7431476,'vel',33.333,1),(141,7431481,7431478,'pse',25,1),(141,7431482,7431478,'seu',25,1),(141,7431483,7431478,'eud',25,1),(141,7431484,7431478,'udo',25,1),(141,7431485,7431481,'fal',33.333,6),(141,7431486,7431481,'als',33.333,6),(141,7431487,7431481,'lse',33.333,6),(141,7431488,7431485,'sta',25,3),(141,7431489,7431485,'tat',25,3),(141,7431490,7431485,'atu',25,3),(141,7431491,7431485,'tus',25,3),(141,7431492,7431488,'rdm',100,1),(141,7431493,7431492,'cap',20,1),(141,7431494,7431492,'apa',20,1),(141,7431495,7431492,'pab',20,1),(141,7431496,7431492,'abl',20,1),(141,7431497,7431492,'ble',20,1),(141,7431498,7431493,'tru',50,1),(141,7431499,7431493,'rue',50,1),(141,7431500,7431498,'loc',33.333,1),(141,7431501,7431498,'oca',33.333,1),(141,7431502,7431498,'cal',33.333,1),(141,7431503,7431500,'rem',14.286,1),(141,7431504,7431500,'emo',14.286,1),(141,7431505,7431500,'mov',14.286,1),(141,7431506,7431500,'ova',14.286,1),(141,7431507,7431500,'vab',14.286,1),(141,7431508,7431500,'abl',14.286,1),(141,7431509,7431500,'ble',14.286,1),(141,7431510,7431503,'ssd',100,1),(141,7431511,7431510,'off',20,1),(141,7431512,7431510,'ffl',20,1),(141,7431513,7431510,'fli',20,1),(141,7431514,7431510,'lin',20,1),(141,7431515,7431510,'ine',20,1),(141,7431516,7431511,'per',11.111,1),(141,7431517,7431511,'ere',11.111,1),(141,7431518,7431511,'ren',11.111,1),(141,7431519,7431511,'enn',11.111,1),(141,7431520,7431511,'nni',11.111,1),(141,7431521,7431511,'nia',11.111,1),(141,7431522,7431511,'ial',11.111,1),(141,7431523,7431511,'all',11.111,1),(141,7431524,7431511,'lly',11.111,1),(141,7431525,7431516,'res',16.667,1),(141,7431526,7431516,'ese',16.667,1),(141,7431527,7431516,'ser',16.667,1),(141,7431528,7431516,'erv',16.667,1),(141,7431529,7431516,'rve',16.667,1),(141,7431530,7431516,'ved',16.667,1),(141,7431531,7431525,'thi',50,1),(141,7431532,7431525,'hin',50,1),(141,7431533,7431531,'pro',10,1),(141,7431534,7431531,'rov',10,1),(141,7431535,7431531,'ovi',10,1),(141,7431536,7431531,'vis',10,1),(141,7431537,7431531,'isi',10,1),(141,7431538,7431531,'sio',10,1),(141,7431539,7431531,'ion',10,1),(141,7431540,7431531,'oni',10,1),(141,7431541,7431531,'nin',10,1),(141,7431542,7431531,'ing',10,1),(141,7431543,7431533,'yes',100,1),(141,7431544,7431543,'att',16.667,1),(141,7431545,7431543,'tta',16.667,1),(141,7431546,7431543,'tac',16.667,1),(141,7431547,7431543,'ach',16.667,1),(141,7431548,7431543,'che',16.667,1),(141,7431549,7431543,'hed',16.667,1),(141,7431550,7431544,'fil',20,1),(141,7431551,7431544,'ilt',20,1),(141,7431552,7431544,'lte',20,1),(141,7431553,7431544,'ter',20,1),(141,7431554,7431544,'ers',20,1),(141,7431555,7431550,'vaa',50,1),(141,7431556,7431550,'aai',50,1),(141,7431557,7431555,'unk',20,1),(141,7431558,7431555,'nkn',20,1),(141,7431559,7431555,'kno',20,1),(141,7431560,7431555,'now',20,1),(141,7431561,7431555,'own',20,1),(141,7431562,7431557,'oth',33.333,1),(141,7431563,7431557,'the',33.333,1),(141,7431564,7431557,'her',33.333,1),(141,7431565,7431562,'uid',50,1),(141,7431566,7431562,'ids',50,1),(141,7431567,7431565,'vml',100,1),(141,7431568,7431567,'dis',20,1),(141,7431569,7431567,'isp',20,1),(141,7431570,7431567,'spl',20,1),(141,7431571,7431567,'pla',20,1),(141,7431572,7431567,'lay',20,1),(141,7431573,7431568,'nam',50,1),(141,7431574,7431568,'ame',50,1),(142,7431576,7431575,'net',25,3),(142,7431577,7431575,'eta',25,3),(142,7431578,7431575,'tap',25,3),(142,7431579,7431575,'app',25,3),(142,7431580,7431576,'fib',33.333,2),(142,7431581,7431576,'ibr',33.333,2),(142,7431582,7431576,'bre',33.333,2),(142,7431583,7431580,'cha',20,2),(142,7431584,7431580,'han',20,2),(142,7431585,7431580,'ann',20,2),(142,7431586,7431580,'nne',20,2),(142,7431587,7431580,'nel',20,2),(142,7431588,7431583,'dis',50,2),(142,7431589,7431583,'isk',50,2),(142,7431590,7431588,'naa',100,4),(142,7431591,7431590,'600',3.333,4),(142,7431592,7431590,'00a',3.333,4),(142,7431593,7431590,'0a0',3.333,4),(142,7431594,7431590,'a09',3.333,4),(142,7431595,7431590,'098',3.333,4),(142,7431596,7431590,'980',3.333,4),(142,7431597,7431590,'804',3.333,4),(142,7431598,7431590,'044',3.333,4),(142,7431599,7431590,'443',3.333,4),(142,7431600,7431590,'430',3.333,4),(142,7431601,7431590,'307',3.333,4),(142,7431602,7431590,'075',3.333,4),(142,7431603,7431590,'753',3.333,4),(142,7431604,7431590,'535',3.333,4),(142,7431605,7431590,'357',3.333,4),(142,7431606,7431590,'573',3.333,4),(142,7431607,7431590,'732',3.333,4),(142,7431608,7431590,'32b',3.333,4),(142,7431609,7431590,'2b3',3.333,4),(142,7431610,7431590,'b33',3.333,4),(142,7431611,7431590,'334',3.333,4),(142,7431612,7431590,'345',3.333,4),(142,7431613,7431590,'457',3.333,4),(142,7431614,7431590,'571',3.333,4),(142,7431615,7431590,'715',3.333,4),(142,7431616,7431590,'153',3.333,4),(142,7431617,7431590,'533',3.333,4),(142,7431618,7431590,'336',3.333,4),(142,7431619,7431590,'365',3.333,4),(142,7431620,7431590,'656',3.333,4),(142,7431621,7431591,'ser',25,1),(142,7431622,7431591,'eri',25,1),(142,7431623,7431591,'ria',25,1),(142,7431624,7431591,'ial',25,1),(142,7431625,7431621,'siz',50,1),(142,7431626,7431621,'ize',50,1),(142,7431627,7431625,'321',100,1),(142,7431628,7431627,'dev',25,1),(142,7431629,7431627,'evi',25,1),(142,7431630,7431627,'vic',25,1),(142,7431631,7431627,'ice',25,1),(142,7431632,7431628,'typ',50,1),(142,7431633,7431628,'ype',50,1),(142,7431634,7431632,'dir',10,1),(142,7431635,7431632,'ire',10,1),(142,7431636,7431632,'rec',10,1),(142,7431637,7431632,'ect',10,1),(142,7431638,7431632,'cta',10,1),(142,7431639,7431632,'tac',10,1),(142,7431640,7431632,'acc',10,1),(142,7431641,7431632,'cce',10,1),(142,7431642,7431632,'ces',10,1),(142,7431643,7431632,'ess',10,1),(142,7431644,7431634,'mul',14.286,1),(142,7431645,7431634,'ult',14.286,1),(142,7431646,7431634,'lti',14.286,1),(142,7431647,7431634,'tip',14.286,1),(142,7431648,7431634,'ipa',14.286,1),(142,7431649,7431634,'pat',14.286,1),(142,7431650,7431634,'ath',14.286,1),(142,7431651,7431644,'plu',25,1),(142,7431652,7431644,'lug',25,1),(142,7431653,7431644,'ugi',25,1),(142,7431654,7431644,'gin',25,1),(142,7431655,7431651,'nmp',100,1),(142,7431656,7431655,'dev',33.333,1),(142,7431657,7431655,'evf',33.333,1),(142,7431658,7431655,'vfs',33.333,1),(142,7431659,7431656,'pat',50,1),(142,7431660,7431656,'ath',50,1),(142,7431661,7431659,'vmf',50,1),(142,7431662,7431659,'mfs',50,1),(142,7431663,7431661,'dev',20,1),(142,7431664,7431661,'evi',20,1),(142,7431665,7431661,'vic',20,1),(142,7431666,7431661,'ice',20,1),(142,7431667,7431661,'ces',20,1),(142,7431668,7431663,'dis',33.333,1),(142,7431669,7431663,'isk',33.333,1),(142,7431670,7431663,'sks',33.333,1),(142,7431671,7431668,'ven',25,1),(142,7431672,7431668,'end',25,1),(142,7431673,7431668,'ndo',25,1),(142,7431674,7431668,'dor',25,1),(142,7431675,7431671,'mod',33.333,1),(142,7431676,7431671,'ode',33.333,1),(142,7431677,7431671,'del',33.333,1),(142,7431678,7431675,'lun',100,1),(142,7431679,7431678,'cmo',33.333,1),(142,7431680,7431678,'mod',33.333,1),(142,7431681,7431678,'ode',33.333,1),(142,7431682,7431679,'rev',16.667,1),(142,7431683,7431679,'evi',16.667,1),(142,7431684,7431679,'vis',16.667,1),(142,7431685,7431679,'isi',16.667,1),(142,7431686,7431679,'sio',16.667,1),(142,7431687,7431679,'ion',16.667,1),(142,7431688,7431682,'810',50,1),(142,7431689,7431682,'100',50,1),(142,7431690,7431688,'scs',50,1),(142,7431691,7431688,'csi',50,1),(142,7431692,7431690,'lev',33.333,1),(142,7431693,7431690,'eve',33.333,1),(142,7431694,7431690,'vel',33.333,1),(142,7431695,7431692,'pse',25,1),(142,7431696,7431692,'seu',25,1),(142,7431697,7431692,'eud',25,1),(142,7431698,7431692,'udo',25,1),(142,7431699,7431695,'fal',33.333,6),(142,7431700,7431695,'als',33.333,6),(142,7431701,7431695,'lse',33.333,6),(142,7431702,7431699,'sta',25,3),(142,7431703,7431699,'tat',25,3),(142,7431704,7431699,'atu',25,3),(142,7431705,7431699,'tus',25,3),(142,7431706,7431702,'rdm',100,1),(142,7431707,7431706,'cap',20,1),(142,7431708,7431706,'apa',20,1),(142,7431709,7431706,'pab',20,1),(142,7431710,7431706,'abl',20,1),(142,7431711,7431706,'ble',20,1),(142,7431712,7431707,'tru',50,1),(142,7431713,7431707,'rue',50,1),(142,7431714,7431712,'loc',33.333,1),(142,7431715,7431712,'oca',33.333,1),(142,7431716,7431712,'cal',33.333,1),(142,7431717,7431714,'rem',14.286,1),(142,7431718,7431714,'emo',14.286,1),(142,7431719,7431714,'mov',14.286,1),(142,7431720,7431714,'ova',14.286,1),(142,7431721,7431714,'vab',14.286,1),(142,7431722,7431714,'abl',14.286,1),(142,7431723,7431714,'ble',14.286,1),(142,7431724,7431717,'ssd',100,1),(142,7431725,7431724,'off',20,1),(142,7431726,7431724,'ffl',20,1),(142,7431727,7431724,'fli',20,1),(142,7431728,7431724,'lin',20,1),(142,7431729,7431724,'ine',20,1),(142,7431730,7431725,'per',11.111,1),(142,7431731,7431725,'ere',11.111,1),(142,7431732,7431725,'ren',11.111,1),(142,7431733,7431725,'enn',11.111,1),(142,7431734,7431725,'nni',11.111,1),(142,7431735,7431725,'nia',11.111,1),(142,7431736,7431725,'ial',11.111,1),(142,7431737,7431725,'all',11.111,1),(142,7431738,7431725,'lly',11.111,1),(142,7431739,7431730,'res',16.667,1),(142,7431740,7431730,'ese',16.667,1),(142,7431741,7431730,'ser',16.667,1),(142,7431742,7431730,'erv',16.667,1),(142,7431743,7431730,'rve',16.667,1),(142,7431744,7431730,'ved',16.667,1),(142,7431745,7431739,'thi',50,1),(142,7431746,7431739,'hin',50,1),(142,7431747,7431745,'pro',10,1),(142,7431748,7431745,'rov',10,1),(142,7431749,7431745,'ovi',10,1),(142,7431750,7431745,'vis',10,1),(142,7431751,7431745,'isi',10,1),(142,7431752,7431745,'sio',10,1),(142,7431753,7431745,'ion',10,1),(142,7431754,7431745,'oni',10,1),(142,7431755,7431745,'nin',10,1),(142,7431756,7431745,'ing',10,1),(142,7431757,7431747,'yes',100,1),(142,7431758,7431757,'att',16.667,1),(142,7431759,7431757,'tta',16.667,1),(142,7431760,7431757,'tac',16.667,1),(142,7431761,7431757,'ach',16.667,1),(142,7431762,7431757,'che',16.667,1),(142,7431763,7431757,'hed',16.667,1),(142,7431764,7431758,'fil',20,1),(142,7431765,7431758,'ilt',20,1),(142,7431766,7431758,'lte',20,1),(142,7431767,7431758,'ter',20,1),(142,7431768,7431758,'ers',20,1),(142,7431769,7431764,'vaa',50,1),(142,7431770,7431764,'aai',50,1),(142,7431771,7431769,'unk',20,1),(142,7431772,7431769,'nkn',20,1),(142,7431773,7431769,'kno',20,1),(142,7431774,7431769,'now',20,1),(142,7431775,7431769,'own',20,1),(142,7431776,7431771,'oth',33.333,1),(142,7431777,7431771,'the',33.333,1),(142,7431778,7431771,'her',33.333,1),(142,7431779,7431776,'uid',50,1),(142,7431780,7431776,'ids',50,1),(142,7431781,7431779,'vml',100,1),(142,7431782,7431781,'dis',20,1),(142,7431783,7431781,'isp',20,1),(142,7431784,7431781,'spl',20,1),(142,7431785,7431781,'pla',20,1),(142,7431786,7431781,'lay',20,1),(142,7431787,7431782,'nam',50,1),(142,7431788,7431782,'ame',50,1),(143,7431790,7431789,'net',25,3),(143,7431791,7431789,'eta',25,3),(143,7431792,7431789,'tap',25,3),(143,7431793,7431789,'app',25,3),(143,7431794,7431790,'ser',25,3),(143,7431795,7431790,'eri',25,3),(143,7431796,7431790,'ria',25,3),(143,7431797,7431790,'ial',25,3),(143,7431798,7431794,'att',16.667,3),(143,7431799,7431794,'tta',16.667,3),(143,7431800,7431794,'tac',16.667,3),(143,7431801,7431794,'ach',16.667,3),(143,7431802,7431794,'che',16.667,3),(143,7431803,7431794,'hed',16.667,3),(143,7431804,7431798,'scs',50,3),(143,7431805,7431798,'csi',50,3),(143,7431806,7431804,'dis',50,2),(143,7431807,7431804,'isk',50,2),(143,7431808,7431806,'naa',100,4),(143,7431809,7431808,'600',3.333,4),(143,7431810,7431808,'00a',3.333,4),(143,7431811,7431808,'0a0',3.333,4),(143,7431812,7431808,'a09',3.333,4),(143,7431813,7431808,'098',3.333,4),(143,7431814,7431808,'980',3.333,4),(143,7431815,7431808,'80b',3.333,4),(143,7431816,7431808,'0b6',3.333,4),(143,7431817,7431808,'b64',3.333,4),(143,7431818,7431808,'640',3.333,4),(143,7431819,7431808,'408',3.333,4),(143,7431820,7431808,'084',3.333,4),(143,7431821,7431808,'84e',3.333,4),(143,7431822,7431808,'4ee',3.333,4),(143,7431823,7431808,'ee9',3.333,4),(143,7431824,7431808,'e93',3.333,4),(143,7431825,7431808,'934',3.333,4),(143,7431826,7431808,'344',3.333,4),(143,7431827,7431808,'444',3.333,4),(143,7431828,7431808,'448',3.333,4),(143,7431829,7431808,'481',3.333,4),(143,7431830,7431808,'811',3.333,4),(143,7431831,7431808,'117',3.333,4),(143,7431832,7431808,'17b',3.333,4),(143,7431833,7431808,'7b0',3.333,4),(143,7431834,7431808,'b04',3.333,4),(143,7431835,7431808,'04a',3.333,4),(143,7431836,7431808,'4ab',3.333,4),(143,7431837,7431808,'aba',3.333,4),(143,7431838,7431808,'ba2',3.333,4),(143,7431839,7431809,'siz',50,1),(143,7431840,7431809,'ize',50,1),(143,7431841,7431839,'163',33.333,1),(143,7431842,7431839,'638',33.333,1),(143,7431843,7431839,'384',33.333,1),(143,7431844,7431841,'dev',25,1),(143,7431845,7431841,'evi',25,1),(143,7431846,7431841,'vic',25,1),(143,7431847,7431841,'ice',25,1),(143,7431848,7431844,'typ',50,1),(143,7431849,7431844,'ype',50,1),(143,7431850,7431848,'dir',10,1),(143,7431851,7431848,'ire',10,1),(143,7431852,7431848,'rec',10,1),(143,7431853,7431848,'ect',10,1),(143,7431854,7431848,'cta',10,1),(143,7431855,7431848,'tac',10,1),(143,7431856,7431848,'acc',10,1),(143,7431857,7431848,'cce',10,1),(143,7431858,7431848,'ces',10,1),(143,7431859,7431848,'ess',10,1),(143,7431860,7431850,'mul',14.286,1),(143,7431861,7431850,'ult',14.286,1),(143,7431862,7431850,'lti',14.286,1),(143,7431863,7431850,'tip',14.286,1),(143,7431864,7431850,'ipa',14.286,1),(143,7431865,7431850,'pat',14.286,1),(143,7431866,7431850,'ath',14.286,1),(143,7431867,7431860,'plu',25,1),(143,7431868,7431860,'lug',25,1),(143,7431869,7431860,'ugi',25,1),(143,7431870,7431860,'gin',25,1),(143,7431871,7431867,'nmp',100,1),(143,7431872,7431871,'dev',33.333,1),(143,7431873,7431871,'evf',33.333,1),(143,7431874,7431871,'vfs',33.333,1),(143,7431875,7431872,'pat',50,1),(143,7431876,7431872,'ath',50,1),(143,7431877,7431875,'vmf',50,1),(143,7431878,7431875,'mfs',50,1),(143,7431879,7431877,'dev',20,1),(143,7431880,7431877,'evi',20,1),(143,7431881,7431877,'vic',20,1),(143,7431882,7431877,'ice',20,1),(143,7431883,7431877,'ces',20,1),(143,7431884,7431879,'dis',33.333,1),(143,7431885,7431879,'isk',33.333,1),(143,7431886,7431879,'sks',33.333,1),(143,7431887,7431884,'ven',25,1),(143,7431888,7431884,'end',25,1),(143,7431889,7431884,'ndo',25,1),(143,7431890,7431884,'dor',25,1),(143,7431891,7431887,'mod',33.333,1),(143,7431892,7431887,'ode',33.333,1),(143,7431893,7431887,'del',33.333,1),(143,7431894,7431891,'fla',33.333,1),(143,7431895,7431891,'las',33.333,1),(143,7431896,7431891,'ash',33.333,1),(143,7431897,7431894,'acc',33.333,1),(143,7431898,7431894,'cce',33.333,1),(143,7431899,7431894,'cel',33.333,1),(143,7431900,7431897,'rev',16.667,1),(143,7431901,7431897,'evi',16.667,1),(143,7431902,7431897,'vis',16.667,1),(143,7431903,7431897,'isi',16.667,1),(143,7431904,7431897,'sio',16.667,1),(143,7431905,7431897,'ion',16.667,1),(143,7431906,7431900,'lev',33.333,1),(143,7431907,7431900,'eve',33.333,1),(143,7431908,7431900,'vel',33.333,1),(143,7431909,7431906,'pse',25,1),(143,7431910,7431906,'seu',25,1),(143,7431911,7431906,'eud',25,1),(143,7431912,7431906,'udo',25,1),(143,7431913,7431909,'fal',33.333,5),(143,7431914,7431909,'als',33.333,5),(143,7431915,7431909,'lse',33.333,5),(143,7431916,7431913,'sta',25,3),(143,7431917,7431913,'tat',25,3),(143,7431918,7431913,'atu',25,3),(143,7431919,7431913,'tus',25,3),(143,7431920,7431916,'deg',16.667,1),(143,7431921,7431916,'egr',16.667,1),(143,7431922,7431916,'gra',16.667,1),(143,7431923,7431916,'rad',16.667,1),(143,7431924,7431916,'ade',16.667,1),(143,7431925,7431916,'ded',16.667,1),(143,7431926,7431920,'rdm',100,1),(143,7431927,7431926,'cap',20,1),(143,7431928,7431926,'apa',20,1),(143,7431929,7431926,'pab',20,1),(143,7431930,7431926,'abl',20,1),(143,7431931,7431926,'ble',20,1),(143,7431932,7431927,'tru',50,2),(143,7431933,7431927,'rue',50,2),(143,7431934,7431932,'loc',33.333,1),(143,7431935,7431932,'oca',33.333,1),(143,7431936,7431932,'cal',33.333,1),(143,7431937,7431934,'rem',14.286,1),(143,7431938,7431934,'emo',14.286,1),(143,7431939,7431934,'mov',14.286,1),(143,7431940,7431934,'ova',14.286,1),(143,7431941,7431934,'vab',14.286,1),(143,7431942,7431934,'abl',14.286,1),(143,7431943,7431934,'ble',14.286,1),(143,7431944,7431937,'ssd',100,1),(143,7431945,7431944,'off',20,1),(143,7431946,7431944,'ffl',20,1),(143,7431947,7431944,'fli',20,1),(143,7431948,7431944,'lin',20,1),(143,7431949,7431944,'ine',20,1),(143,7431950,7431945,'per',11.111,1),(143,7431951,7431945,'ere',11.111,1),(143,7431952,7431945,'ren',11.111,1),(143,7431953,7431945,'enn',11.111,1),(143,7431954,7431945,'nni',11.111,1),(143,7431955,7431945,'nia',11.111,1),(143,7431956,7431945,'ial',11.111,1),(143,7431957,7431945,'all',11.111,1),(143,7431958,7431945,'lly',11.111,1),(143,7431959,7431950,'res',16.667,1),(143,7431960,7431950,'ese',16.667,1),(143,7431961,7431950,'ser',16.667,1),(143,7431962,7431950,'erv',16.667,1),(143,7431963,7431950,'rve',16.667,1),(143,7431964,7431950,'ved',16.667,1),(143,7431965,7431959,'thi',50,1),(143,7431966,7431959,'hin',50,1),(143,7431967,7431965,'pro',10,1),(143,7431968,7431965,'rov',10,1),(143,7431969,7431965,'ovi',10,1),(143,7431970,7431965,'vis',10,1),(143,7431971,7431965,'isi',10,1),(143,7431972,7431965,'sio',10,1),(143,7431973,7431965,'ion',10,1),(143,7431974,7431965,'oni',10,1),(143,7431975,7431965,'nin',10,1),(143,7431976,7431965,'ing',10,1),(143,7431977,7431967,'unk',20,1),(143,7431978,7431967,'nkn',20,1),(143,7431979,7431967,'kno',20,1),(143,7431980,7431967,'now',20,1),(143,7431981,7431967,'own',20,1),(143,7431982,7431977,'fil',20,1),(143,7431983,7431977,'ilt',20,1),(143,7431984,7431977,'lte',20,1),(143,7431985,7431977,'ter',20,1),(143,7431986,7431977,'ers',20,1),(143,7431987,7431982,'vaa',50,1),(143,7431988,7431982,'aai',50,1),(143,7431989,7431987,'uns',11.111,1),(143,7431990,7431987,'nsu',11.111,1),(143,7431991,7431987,'sup',11.111,1),(143,7431992,7431987,'upp',11.111,1),(143,7431993,7431987,'ppo',11.111,1),(143,7431994,7431987,'por',11.111,1),(143,7431995,7431987,'ort',11.111,1),(143,7431996,7431987,'rte',11.111,1),(143,7431997,7431987,'ted',11.111,1),(143,7431998,7431989,'oth',33.333,1),(143,7431999,7431989,'the',33.333,1),(143,7432000,7431989,'her',33.333,1),(143,7432001,7431998,'uid',50,1),(143,7432002,7431998,'ids',50,1),(143,7432003,7432001,'vml',100,1),(143,7432004,7432003,'dis',20,1),(143,7432005,7432003,'isp',20,1),(143,7432006,7432003,'spl',20,1),(143,7432007,7432003,'pla',20,1),(143,7432008,7432003,'lay',20,1),(143,7432009,7432004,'nam',50,1),(143,7432010,7432004,'ame',50,1),(144,7432012,7432011,'net',25,3),(144,7432013,7432011,'eta',25,3),(144,7432014,7432011,'tap',25,3),(144,7432015,7432011,'app',25,3),(144,7432016,7432012,'fib',33.333,2),(144,7432017,7432012,'ibr',33.333,2),(144,7432018,7432012,'bre',33.333,2),(144,7432019,7432016,'cha',20,2),(144,7432020,7432016,'han',20,2),(144,7432021,7432016,'ann',20,2),(144,7432022,7432016,'nne',20,2),(144,7432023,7432016,'nel',20,2),(144,7432024,7432019,'dis',50,2),(144,7432025,7432019,'isk',50,2),(144,7432026,7432024,'naa',100,4),(144,7432027,7432026,'600',3.333,4),(144,7432028,7432026,'00a',3.333,4),(144,7432029,7432026,'0a0',3.333,4),(144,7432030,7432026,'a09',3.333,4),(144,7432031,7432026,'098',3.333,4),(144,7432032,7432026,'980',3.333,4),(144,7432033,7432026,'804',3.333,4),(144,7432034,7432026,'044',3.333,4),(144,7432035,7432026,'443',3.333,4),(144,7432036,7432026,'430',3.333,4),(144,7432037,7432026,'307',3.333,4),(144,7432038,7432026,'075',3.333,4),(144,7432039,7432026,'753',3.333,4),(144,7432040,7432026,'535',3.333,4),(144,7432041,7432026,'357',3.333,4),(144,7432042,7432026,'573',3.333,4),(144,7432043,7432026,'732',3.333,4),(144,7432044,7432026,'32b',3.333,4),(144,7432045,7432026,'2b3',3.333,4),(144,7432046,7432026,'b33',3.333,4),(144,7432047,7432026,'334',3.333,4),(144,7432048,7432026,'345',3.333,4),(144,7432049,7432026,'457',3.333,4),(144,7432050,7432026,'571',3.333,4),(144,7432051,7432026,'715',3.333,4),(144,7432052,7432026,'153',3.333,4),(144,7432053,7432026,'533',3.333,4),(144,7432054,7432026,'336',3.333,4),(144,7432055,7432026,'365',3.333,4),(144,7432056,7432026,'657',3.333,4),(144,7432057,7432027,'ser',25,1),(144,7432058,7432027,'eri',25,1),(144,7432059,7432027,'ria',25,1),(144,7432060,7432027,'ial',25,1),(144,7432061,7432057,'siz',50,1),(144,7432062,7432057,'ize',50,1),(144,7432063,7432061,'321',100,1),(144,7432064,7432063,'dev',25,1),(144,7432065,7432063,'evi',25,1),(144,7432066,7432063,'vic',25,1),(144,7432067,7432063,'ice',25,1),(144,7432068,7432064,'typ',50,1),(144,7432069,7432064,'ype',50,1),(144,7432070,7432068,'dir',10,1),(144,7432071,7432068,'ire',10,1),(144,7432072,7432068,'rec',10,1),(144,7432073,7432068,'ect',10,1),(144,7432074,7432068,'cta',10,1),(144,7432075,7432068,'tac',10,1),(144,7432076,7432068,'acc',10,1),(144,7432077,7432068,'cce',10,1),(144,7432078,7432068,'ces',10,1),(144,7432079,7432068,'ess',10,1),(144,7432080,7432070,'mul',14.286,1),(144,7432081,7432070,'ult',14.286,1),(144,7432082,7432070,'lti',14.286,1),(144,7432083,7432070,'tip',14.286,1),(144,7432084,7432070,'ipa',14.286,1),(144,7432085,7432070,'pat',14.286,1),(144,7432086,7432070,'ath',14.286,1),(144,7432087,7432080,'plu',25,1),(144,7432088,7432080,'lug',25,1),(144,7432089,7432080,'ugi',25,1),(144,7432090,7432080,'gin',25,1),(144,7432091,7432087,'nmp',100,1),(144,7432092,7432091,'dev',33.333,1),(144,7432093,7432091,'evf',33.333,1),(144,7432094,7432091,'vfs',33.333,1),(144,7432095,7432092,'pat',50,1),(144,7432096,7432092,'ath',50,1),(144,7432097,7432095,'vmf',50,1),(144,7432098,7432095,'mfs',50,1),(144,7432099,7432097,'dev',20,1),(144,7432100,7432097,'evi',20,1),(144,7432101,7432097,'vic',20,1),(144,7432102,7432097,'ice',20,1),(144,7432103,7432097,'ces',20,1),(144,7432104,7432099,'dis',33.333,1),(144,7432105,7432099,'isk',33.333,1),(144,7432106,7432099,'sks',33.333,1),(144,7432107,7432104,'ven',25,1),(144,7432108,7432104,'end',25,1),(144,7432109,7432104,'ndo',25,1),(144,7432110,7432104,'dor',25,1),(144,7432111,7432107,'mod',33.333,1),(144,7432112,7432107,'ode',33.333,1),(144,7432113,7432107,'del',33.333,1),(144,7432114,7432111,'lun',100,1),(144,7432115,7432114,'cmo',33.333,1),(144,7432116,7432114,'mod',33.333,1),(144,7432117,7432114,'ode',33.333,1),(144,7432118,7432115,'rev',16.667,1),(144,7432119,7432115,'evi',16.667,1),(144,7432120,7432115,'vis',16.667,1),(144,7432121,7432115,'isi',16.667,1),(144,7432122,7432115,'sio',16.667,1),(144,7432123,7432115,'ion',16.667,1),(144,7432124,7432118,'810',50,1),(144,7432125,7432118,'100',50,1),(144,7432126,7432124,'scs',50,1),(144,7432127,7432124,'csi',50,1),(144,7432128,7432126,'lev',33.333,1),(144,7432129,7432126,'eve',33.333,1),(144,7432130,7432126,'vel',33.333,1),(144,7432131,7432128,'pse',25,1),(144,7432132,7432128,'seu',25,1),(144,7432133,7432128,'eud',25,1),(144,7432134,7432128,'udo',25,1),(144,7432135,7432131,'fal',33.333,6),(144,7432136,7432131,'als',33.333,6),(144,7432137,7432131,'lse',33.333,6),(144,7432138,7432135,'sta',25,3),(144,7432139,7432135,'tat',25,3),(144,7432140,7432135,'atu',25,3),(144,7432141,7432135,'tus',25,3),(144,7432142,7432138,'rdm',100,1),(144,7432143,7432142,'cap',20,1),(144,7432144,7432142,'apa',20,1),(144,7432145,7432142,'pab',20,1),(144,7432146,7432142,'abl',20,1),(144,7432147,7432142,'ble',20,1),(144,7432148,7432143,'tru',50,1),(144,7432149,7432143,'rue',50,1),(144,7432150,7432148,'loc',33.333,1),(144,7432151,7432148,'oca',33.333,1),(144,7432152,7432148,'cal',33.333,1),(144,7432153,7432150,'rem',14.286,1),(144,7432154,7432150,'emo',14.286,1),(144,7432155,7432150,'mov',14.286,1),(144,7432156,7432150,'ova',14.286,1),(144,7432157,7432150,'vab',14.286,1),(144,7432158,7432150,'abl',14.286,1),(144,7432159,7432150,'ble',14.286,1),(144,7432160,7432153,'ssd',100,1),(144,7432161,7432160,'off',20,1),(144,7432162,7432160,'ffl',20,1),(144,7432163,7432160,'fli',20,1),(144,7432164,7432160,'lin',20,1),(144,7432165,7432160,'ine',20,1),(144,7432166,7432161,'per',11.111,1),(144,7432167,7432161,'ere',11.111,1),(144,7432168,7432161,'ren',11.111,1),(144,7432169,7432161,'enn',11.111,1),(144,7432170,7432161,'nni',11.111,1),(144,7432171,7432161,'nia',11.111,1),(144,7432172,7432161,'ial',11.111,1),(144,7432173,7432161,'all',11.111,1),(144,7432174,7432161,'lly',11.111,1),(144,7432175,7432166,'res',16.667,1),(144,7432176,7432166,'ese',16.667,1),(144,7432177,7432166,'ser',16.667,1),(144,7432178,7432166,'erv',16.667,1),(144,7432179,7432166,'rve',16.667,1),(144,7432180,7432166,'ved',16.667,1),(144,7432181,7432175,'thi',50,1),(144,7432182,7432175,'hin',50,1),(144,7432183,7432181,'pro',10,1),(144,7432184,7432181,'rov',10,1),(144,7432185,7432181,'ovi',10,1),(144,7432186,7432181,'vis',10,1),(144,7432187,7432181,'isi',10,1),(144,7432188,7432181,'sio',10,1),(144,7432189,7432181,'ion',10,1),(144,7432190,7432181,'oni',10,1),(144,7432191,7432181,'nin',10,1),(144,7432192,7432181,'ing',10,1),(144,7432193,7432183,'yes',100,1),(144,7432194,7432193,'att',16.667,1),(144,7432195,7432193,'tta',16.667,1),(144,7432196,7432193,'tac',16.667,1),(144,7432197,7432193,'ach',16.667,1),(144,7432198,7432193,'che',16.667,1),(144,7432199,7432193,'hed',16.667,1),(144,7432200,7432194,'fil',20,1),(144,7432201,7432194,'ilt',20,1),(144,7432202,7432194,'lte',20,1),(144,7432203,7432194,'ter',20,1),(144,7432204,7432194,'ers',20,1),(144,7432205,7432200,'vaa',50,1),(144,7432206,7432200,'aai',50,1),(144,7432207,7432205,'unk',20,1),(144,7432208,7432205,'nkn',20,1),(144,7432209,7432205,'kno',20,1),(144,7432210,7432205,'now',20,1),(144,7432211,7432205,'own',20,1),(144,7432212,7432207,'oth',33.333,1),(144,7432213,7432207,'the',33.333,1),(144,7432214,7432207,'her',33.333,1),(144,7432215,7432212,'uid',50,1),(144,7432216,7432212,'ids',50,1),(144,7432217,7432215,'vml',100,1),(144,7432218,7432217,'dis',20,1),(144,7432219,7432217,'isp',20,1),(144,7432220,7432217,'spl',20,1),(144,7432221,7432217,'pla',20,1),(144,7432222,7432217,'lay',20,1),(144,7432223,7432218,'nam',50,1),(144,7432224,7432218,'ame',50,1),(145,7432226,7432225,'net',25,3),(145,7432227,7432225,'eta',25,3),(145,7432228,7432225,'tap',25,3),(145,7432229,7432225,'app',25,3),(145,7432230,7432226,'fib',33.333,2),(145,7432231,7432226,'ibr',33.333,2),(145,7432232,7432226,'bre',33.333,2),(145,7432233,7432230,'cha',20,2),(145,7432234,7432230,'han',20,2),(145,7432235,7432230,'ann',20,2),(145,7432236,7432230,'nne',20,2),(145,7432237,7432230,'nel',20,2),(145,7432238,7432233,'dis',50,2),(145,7432239,7432233,'isk',50,2),(145,7432240,7432238,'naa',100,4),(145,7432241,7432240,'600',3.333,4),(145,7432242,7432240,'00a',3.333,4),(145,7432243,7432240,'0a0',3.333,4),(145,7432244,7432240,'a09',3.333,4),(145,7432245,7432240,'098',3.333,4),(145,7432246,7432240,'980',3.333,4),(145,7432247,7432240,'804',3.333,4),(145,7432248,7432240,'044',3.333,4),(145,7432249,7432240,'443',3.333,4),(145,7432250,7432240,'430',3.333,4),(145,7432251,7432240,'307',3.333,4),(145,7432252,7432240,'075',3.333,4),(145,7432253,7432240,'753',3.333,4),(145,7432254,7432240,'535',3.333,4),(145,7432255,7432240,'357',3.333,4),(145,7432256,7432240,'573',3.333,4),(145,7432257,7432240,'732',3.333,4),(145,7432258,7432240,'32b',3.333,4),(145,7432259,7432240,'2b3',3.333,4),(145,7432260,7432240,'b33',3.333,4),(145,7432261,7432240,'334',3.333,4),(145,7432262,7432240,'345',3.333,4),(145,7432263,7432240,'457',3.333,4),(145,7432264,7432240,'571',3.333,4),(145,7432265,7432240,'715',3.333,4),(145,7432266,7432240,'153',3.333,4),(145,7432267,7432240,'533',3.333,4),(145,7432268,7432240,'336',3.333,4),(145,7432269,7432240,'365',3.333,4),(145,7432270,7432240,'658',3.333,4),(145,7432271,7432241,'ser',25,1),(145,7432272,7432241,'eri',25,1),(145,7432273,7432241,'ria',25,1),(145,7432274,7432241,'ial',25,1),(145,7432275,7432271,'siz',50,1),(145,7432276,7432271,'ize',50,1),(145,7432277,7432275,'321',100,1),(145,7432278,7432277,'dev',25,1),(145,7432279,7432277,'evi',25,1),(145,7432280,7432277,'vic',25,1),(145,7432281,7432277,'ice',25,1),(145,7432282,7432278,'typ',50,1),(145,7432283,7432278,'ype',50,1),(145,7432284,7432282,'dir',10,1),(145,7432285,7432282,'ire',10,1),(145,7432286,7432282,'rec',10,1),(145,7432287,7432282,'ect',10,1),(145,7432288,7432282,'cta',10,1),(145,7432289,7432282,'tac',10,1),(145,7432290,7432282,'acc',10,1),(145,7432291,7432282,'cce',10,1),(145,7432292,7432282,'ces',10,1),(145,7432293,7432282,'ess',10,1),(145,7432294,7432284,'mul',14.286,1),(145,7432295,7432284,'ult',14.286,1),(145,7432296,7432284,'lti',14.286,1),(145,7432297,7432284,'tip',14.286,1),(145,7432298,7432284,'ipa',14.286,1),(145,7432299,7432284,'pat',14.286,1),(145,7432300,7432284,'ath',14.286,1),(145,7432301,7432294,'plu',25,1),(145,7432302,7432294,'lug',25,1),(145,7432303,7432294,'ugi',25,1),(145,7432304,7432294,'gin',25,1),(145,7432305,7432301,'nmp',100,1),(145,7432306,7432305,'dev',33.333,1),(145,7432307,7432305,'evf',33.333,1),(145,7432308,7432305,'vfs',33.333,1),(145,7432309,7432306,'pat',50,1),(145,7432310,7432306,'ath',50,1),(145,7432311,7432309,'vmf',50,1),(145,7432312,7432309,'mfs',50,1),(145,7432313,7432311,'dev',20,1),(145,7432314,7432311,'evi',20,1),(145,7432315,7432311,'vic',20,1),(145,7432316,7432311,'ice',20,1),(145,7432317,7432311,'ces',20,1),(145,7432318,7432313,'dis',33.333,1),(145,7432319,7432313,'isk',33.333,1),(145,7432320,7432313,'sks',33.333,1),(145,7432321,7432318,'ven',25,1),(145,7432322,7432318,'end',25,1),(145,7432323,7432318,'ndo',25,1),(145,7432324,7432318,'dor',25,1),(145,7432325,7432321,'mod',33.333,1),(145,7432326,7432321,'ode',33.333,1),(145,7432327,7432321,'del',33.333,1),(145,7432328,7432325,'lun',100,1),(145,7432329,7432328,'cmo',33.333,1),(145,7432330,7432328,'mod',33.333,1),(145,7432331,7432328,'ode',33.333,1),(145,7432332,7432329,'rev',16.667,1),(145,7432333,7432329,'evi',16.667,1),(145,7432334,7432329,'vis',16.667,1),(145,7432335,7432329,'isi',16.667,1),(145,7432336,7432329,'sio',16.667,1),(145,7432337,7432329,'ion',16.667,1),(145,7432338,7432332,'810',50,1),(145,7432339,7432332,'100',50,1),(145,7432340,7432338,'scs',50,1),(145,7432341,7432338,'csi',50,1),(145,7432342,7432340,'lev',33.333,1),(145,7432343,7432340,'eve',33.333,1),(145,7432344,7432340,'vel',33.333,1),(145,7432345,7432342,'pse',25,1),(145,7432346,7432342,'seu',25,1),(145,7432347,7432342,'eud',25,1),(145,7432348,7432342,'udo',25,1),(145,7432349,7432345,'fal',33.333,6),(145,7432350,7432345,'als',33.333,6),(145,7432351,7432345,'lse',33.333,6),(145,7432352,7432349,'sta',25,3),(145,7432353,7432349,'tat',25,3),(145,7432354,7432349,'atu',25,3),(145,7432355,7432349,'tus',25,3),(145,7432356,7432352,'rdm',100,1),(145,7432357,7432356,'cap',20,1),(145,7432358,7432356,'apa',20,1),(145,7432359,7432356,'pab',20,1),(145,7432360,7432356,'abl',20,1),(145,7432361,7432356,'ble',20,1),(145,7432362,7432357,'tru',50,1),(145,7432363,7432357,'rue',50,1),(145,7432364,7432362,'loc',33.333,1),(145,7432365,7432362,'oca',33.333,1),(145,7432366,7432362,'cal',33.333,1),(145,7432367,7432364,'rem',14.286,1),(145,7432368,7432364,'emo',14.286,1),(145,7432369,7432364,'mov',14.286,1),(145,7432370,7432364,'ova',14.286,1),(145,7432371,7432364,'vab',14.286,1),(145,7432372,7432364,'abl',14.286,1),(145,7432373,7432364,'ble',14.286,1),(145,7432374,7432367,'ssd',100,1),(145,7432375,7432374,'off',20,1),(145,7432376,7432374,'ffl',20,1),(145,7432377,7432374,'fli',20,1),(145,7432378,7432374,'lin',20,1),(145,7432379,7432374,'ine',20,1),(145,7432380,7432375,'per',11.111,1),(145,7432381,7432375,'ere',11.111,1),(145,7432382,7432375,'ren',11.111,1),(145,7432383,7432375,'enn',11.111,1),(145,7432384,7432375,'nni',11.111,1),(145,7432385,7432375,'nia',11.111,1),(145,7432386,7432375,'ial',11.111,1),(145,7432387,7432375,'all',11.111,1),(145,7432388,7432375,'lly',11.111,1),(145,7432389,7432380,'res',16.667,1),(145,7432390,7432380,'ese',16.667,1),(145,7432391,7432380,'ser',16.667,1),(145,7432392,7432380,'erv',16.667,1),(145,7432393,7432380,'rve',16.667,1),(145,7432394,7432380,'ved',16.667,1),(145,7432395,7432389,'thi',50,1),(145,7432396,7432389,'hin',50,1),(145,7432397,7432395,'pro',10,1),(145,7432398,7432395,'rov',10,1),(145,7432399,7432395,'ovi',10,1),(145,7432400,7432395,'vis',10,1),(145,7432401,7432395,'isi',10,1),(145,7432402,7432395,'sio',10,1),(145,7432403,7432395,'ion',10,1),(145,7432404,7432395,'oni',10,1),(145,7432405,7432395,'nin',10,1),(145,7432406,7432395,'ing',10,1),(145,7432407,7432397,'yes',100,1),(145,7432408,7432407,'att',16.667,1),(145,7432409,7432407,'tta',16.667,1),(145,7432410,7432407,'tac',16.667,1),(145,7432411,7432407,'ach',16.667,1),(145,7432412,7432407,'che',16.667,1),(145,7432413,7432407,'hed',16.667,1),(145,7432414,7432408,'fil',20,1),(145,7432415,7432408,'ilt',20,1),(145,7432416,7432408,'lte',20,1),(145,7432417,7432408,'ter',20,1),(145,7432418,7432408,'ers',20,1),(145,7432419,7432414,'vaa',50,1),(145,7432420,7432414,'aai',50,1),(145,7432421,7432419,'unk',20,1),(145,7432422,7432419,'nkn',20,1),(145,7432423,7432419,'kno',20,1),(145,7432424,7432419,'now',20,1),(145,7432425,7432419,'own',20,1),(145,7432426,7432421,'oth',33.333,1),(145,7432427,7432421,'the',33.333,1),(145,7432428,7432421,'her',33.333,1),(145,7432429,7432426,'uid',50,1),(145,7432430,7432426,'ids',50,1),(145,7432431,7432429,'vml',100,1),(145,7432432,7432431,'dis',20,1),(145,7432433,7432431,'isp',20,1),(145,7432434,7432431,'spl',20,1),(145,7432435,7432431,'pla',20,1),(145,7432436,7432431,'lay',20,1),(145,7432437,7432432,'nam',50,1),(145,7432438,7432432,'ame',50,1),(146,7432440,7432439,'net',25,3),(146,7432441,7432439,'eta',25,3),(146,7432442,7432439,'tap',25,3),(146,7432443,7432439,'app',25,3),(146,7432444,7432440,'fib',33.333,2),(146,7432445,7432440,'ibr',33.333,2),(146,7432446,7432440,'bre',33.333,2),(146,7432447,7432444,'cha',20,2),(146,7432448,7432444,'han',20,2),(146,7432449,7432444,'ann',20,2),(146,7432450,7432444,'nne',20,2),(146,7432451,7432444,'nel',20,2),(146,7432452,7432447,'dis',50,2),(146,7432453,7432447,'isk',50,2),(146,7432454,7432452,'naa',100,4),(146,7432455,7432454,'600',3.333,4),(146,7432456,7432454,'00a',3.333,4),(146,7432457,7432454,'0a0',3.333,4),(146,7432458,7432454,'a09',3.333,4),(146,7432459,7432454,'098',3.333,4),(146,7432460,7432454,'980',3.333,4),(146,7432461,7432454,'804',3.333,4),(146,7432462,7432454,'044',3.333,4),(146,7432463,7432454,'443',3.333,4),(146,7432464,7432454,'430',3.333,4),(146,7432465,7432454,'307',3.333,4),(146,7432466,7432454,'075',3.333,4),(146,7432467,7432454,'753',3.333,4),(146,7432468,7432454,'535',3.333,4),(146,7432469,7432454,'357',3.333,4),(146,7432470,7432454,'573',3.333,4),(146,7432471,7432454,'732',3.333,4),(146,7432472,7432454,'32b',3.333,4),(146,7432473,7432454,'2b3',3.333,4),(146,7432474,7432454,'b33',3.333,4),(146,7432475,7432454,'334',3.333,4),(146,7432476,7432454,'345',3.333,4),(146,7432477,7432454,'457',3.333,4),(146,7432478,7432454,'571',3.333,4),(146,7432479,7432454,'715',3.333,4),(146,7432480,7432454,'153',3.333,4),(146,7432481,7432454,'533',3.333,4),(146,7432482,7432454,'336',3.333,4),(146,7432483,7432454,'365',3.333,4),(146,7432484,7432454,'659',3.333,4),(146,7432485,7432455,'ser',25,1),(146,7432486,7432455,'eri',25,1),(146,7432487,7432455,'ria',25,1),(146,7432488,7432455,'ial',25,1),(146,7432489,7432485,'siz',50,1),(146,7432490,7432485,'ize',50,1),(146,7432491,7432489,'321',100,1),(146,7432492,7432491,'dev',25,1),(146,7432493,7432491,'evi',25,1),(146,7432494,7432491,'vic',25,1),(146,7432495,7432491,'ice',25,1),(146,7432496,7432492,'typ',50,1),(146,7432497,7432492,'ype',50,1),(146,7432498,7432496,'dir',10,1),(146,7432499,7432496,'ire',10,1),(146,7432500,7432496,'rec',10,1),(146,7432501,7432496,'ect',10,1),(146,7432502,7432496,'cta',10,1),(146,7432503,7432496,'tac',10,1),(146,7432504,7432496,'acc',10,1),(146,7432505,7432496,'cce',10,1),(146,7432506,7432496,'ces',10,1),(146,7432507,7432496,'ess',10,1),(146,7432508,7432498,'mul',14.286,1),(146,7432509,7432498,'ult',14.286,1),(146,7432510,7432498,'lti',14.286,1);
INSERT INTO `fuzzysearch_default_fuzzysearch_index_search_api_viewed` VALUES (146,7432511,7432498,'tip',14.286,1),(146,7432512,7432498,'ipa',14.286,1),(146,7432513,7432498,'pat',14.286,1),(146,7432514,7432498,'ath',14.286,1),(146,7432515,7432508,'plu',25,1),(146,7432516,7432508,'lug',25,1),(146,7432517,7432508,'ugi',25,1),(146,7432518,7432508,'gin',25,1),(146,7432519,7432515,'nmp',100,1),(146,7432520,7432519,'dev',33.333,1),(146,7432521,7432519,'evf',33.333,1),(146,7432522,7432519,'vfs',33.333,1),(146,7432523,7432520,'pat',50,1),(146,7432524,7432520,'ath',50,1),(146,7432525,7432523,'vmf',50,1),(146,7432526,7432523,'mfs',50,1),(146,7432527,7432525,'dev',20,1),(146,7432528,7432525,'evi',20,1),(146,7432529,7432525,'vic',20,1),(146,7432530,7432525,'ice',20,1),(146,7432531,7432525,'ces',20,1),(146,7432532,7432527,'dis',33.333,1),(146,7432533,7432527,'isk',33.333,1),(146,7432534,7432527,'sks',33.333,1),(146,7432535,7432532,'ven',25,1),(146,7432536,7432532,'end',25,1),(146,7432537,7432532,'ndo',25,1),(146,7432538,7432532,'dor',25,1),(146,7432539,7432535,'mod',33.333,1),(146,7432540,7432535,'ode',33.333,1),(146,7432541,7432535,'del',33.333,1),(146,7432542,7432539,'lun',100,1),(146,7432543,7432542,'cmo',33.333,1),(146,7432544,7432542,'mod',33.333,1),(146,7432545,7432542,'ode',33.333,1),(146,7432546,7432543,'rev',16.667,1),(146,7432547,7432543,'evi',16.667,1),(146,7432548,7432543,'vis',16.667,1),(146,7432549,7432543,'isi',16.667,1),(146,7432550,7432543,'sio',16.667,1),(146,7432551,7432543,'ion',16.667,1),(146,7432552,7432546,'810',50,1),(146,7432553,7432546,'100',50,1),(146,7432554,7432552,'scs',50,1),(146,7432555,7432552,'csi',50,1),(146,7432556,7432554,'lev',33.333,1),(146,7432557,7432554,'eve',33.333,1),(146,7432558,7432554,'vel',33.333,1),(146,7432559,7432556,'pse',25,1),(146,7432560,7432556,'seu',25,1),(146,7432561,7432556,'eud',25,1),(146,7432562,7432556,'udo',25,1),(146,7432563,7432559,'fal',33.333,6),(146,7432564,7432559,'als',33.333,6),(146,7432565,7432559,'lse',33.333,6),(146,7432566,7432563,'sta',25,3),(146,7432567,7432563,'tat',25,3),(146,7432568,7432563,'atu',25,3),(146,7432569,7432563,'tus',25,3),(146,7432570,7432566,'rdm',100,1),(146,7432571,7432570,'cap',20,1),(146,7432572,7432570,'apa',20,1),(146,7432573,7432570,'pab',20,1),(146,7432574,7432570,'abl',20,1),(146,7432575,7432570,'ble',20,1),(146,7432576,7432571,'tru',50,1),(146,7432577,7432571,'rue',50,1),(146,7432578,7432576,'loc',33.333,1),(146,7432579,7432576,'oca',33.333,1),(146,7432580,7432576,'cal',33.333,1),(146,7432581,7432578,'rem',14.286,1),(146,7432582,7432578,'emo',14.286,1),(146,7432583,7432578,'mov',14.286,1),(146,7432584,7432578,'ova',14.286,1),(146,7432585,7432578,'vab',14.286,1),(146,7432586,7432578,'abl',14.286,1),(146,7432587,7432578,'ble',14.286,1),(146,7432588,7432581,'ssd',100,1),(146,7432589,7432588,'off',20,1),(146,7432590,7432588,'ffl',20,1),(146,7432591,7432588,'fli',20,1),(146,7432592,7432588,'lin',20,1),(146,7432593,7432588,'ine',20,1),(146,7432594,7432589,'per',11.111,1),(146,7432595,7432589,'ere',11.111,1),(146,7432596,7432589,'ren',11.111,1),(146,7432597,7432589,'enn',11.111,1),(146,7432598,7432589,'nni',11.111,1),(146,7432599,7432589,'nia',11.111,1),(146,7432600,7432589,'ial',11.111,1),(146,7432601,7432589,'all',11.111,1),(146,7432602,7432589,'lly',11.111,1),(146,7432603,7432594,'res',16.667,1),(146,7432604,7432594,'ese',16.667,1),(146,7432605,7432594,'ser',16.667,1),(146,7432606,7432594,'erv',16.667,1),(146,7432607,7432594,'rve',16.667,1),(146,7432608,7432594,'ved',16.667,1),(146,7432609,7432603,'thi',50,1),(146,7432610,7432603,'hin',50,1),(146,7432611,7432609,'pro',10,1),(146,7432612,7432609,'rov',10,1),(146,7432613,7432609,'ovi',10,1),(146,7432614,7432609,'vis',10,1),(146,7432615,7432609,'isi',10,1),(146,7432616,7432609,'sio',10,1),(146,7432617,7432609,'ion',10,1),(146,7432618,7432609,'oni',10,1),(146,7432619,7432609,'nin',10,1),(146,7432620,7432609,'ing',10,1),(146,7432621,7432611,'yes',100,1),(146,7432622,7432621,'att',16.667,1),(146,7432623,7432621,'tta',16.667,1),(146,7432624,7432621,'tac',16.667,1),(146,7432625,7432621,'ach',16.667,1),(146,7432626,7432621,'che',16.667,1),(146,7432627,7432621,'hed',16.667,1),(146,7432628,7432622,'fil',20,1),(146,7432629,7432622,'ilt',20,1),(146,7432630,7432622,'lte',20,1),(146,7432631,7432622,'ter',20,1),(146,7432632,7432622,'ers',20,1),(146,7432633,7432628,'vaa',50,1),(146,7432634,7432628,'aai',50,1),(146,7432635,7432633,'unk',20,1),(146,7432636,7432633,'nkn',20,1),(146,7432637,7432633,'kno',20,1),(146,7432638,7432633,'now',20,1),(146,7432639,7432633,'own',20,1),(146,7432640,7432635,'oth',33.333,1),(146,7432641,7432635,'the',33.333,1),(146,7432642,7432635,'her',33.333,1),(146,7432643,7432640,'uid',50,1),(146,7432644,7432640,'ids',50,1),(146,7432645,7432643,'vml',100,1),(146,7432646,7432645,'dis',20,1),(146,7432647,7432645,'isp',20,1),(146,7432648,7432645,'spl',20,1),(146,7432649,7432645,'pla',20,1),(146,7432650,7432645,'lay',20,1),(146,7432651,7432646,'nam',50,1),(146,7432652,7432646,'ame',50,1),(147,7432654,7432653,'net',25,3),(147,7432655,7432653,'eta',25,3),(147,7432656,7432653,'tap',25,3),(147,7432657,7432653,'app',25,3),(147,7432658,7432654,'fib',33.333,2),(147,7432659,7432654,'ibr',33.333,2),(147,7432660,7432654,'bre',33.333,2),(147,7432661,7432658,'cha',20,2),(147,7432662,7432658,'han',20,2),(147,7432663,7432658,'ann',20,2),(147,7432664,7432658,'nne',20,2),(147,7432665,7432658,'nel',20,2),(147,7432666,7432661,'dis',50,2),(147,7432667,7432661,'isk',50,2),(147,7432668,7432666,'naa',100,4),(147,7432669,7432668,'600',3.333,4),(147,7432670,7432668,'00a',3.333,4),(147,7432671,7432668,'0a0',3.333,4),(147,7432672,7432668,'a09',3.333,4),(147,7432673,7432668,'098',3.333,4),(147,7432674,7432668,'980',3.333,4),(147,7432675,7432668,'804',3.333,4),(147,7432676,7432668,'044',3.333,4),(147,7432677,7432668,'443',3.333,4),(147,7432678,7432668,'430',3.333,4),(147,7432679,7432668,'307',3.333,4),(147,7432680,7432668,'075',3.333,4),(147,7432681,7432668,'753',3.333,4),(147,7432682,7432668,'535',3.333,4),(147,7432683,7432668,'357',3.333,4),(147,7432684,7432668,'573',3.333,4),(147,7432685,7432668,'732',3.333,4),(147,7432686,7432668,'32b',3.333,4),(147,7432687,7432668,'2b3',3.333,4),(147,7432688,7432668,'b33',3.333,4),(147,7432689,7432668,'334',3.333,4),(147,7432690,7432668,'345',3.333,4),(147,7432691,7432668,'457',3.333,4),(147,7432692,7432668,'571',3.333,4),(147,7432693,7432668,'715',3.333,4),(147,7432694,7432668,'152',3.333,4),(147,7432695,7432668,'527',3.333,4),(147,7432696,7432668,'275',3.333,4),(147,7432697,7432668,'753',3.333,4),(147,7432698,7432668,'534',3.333,4),(147,7432699,7432669,'ser',25,1),(147,7432700,7432669,'eri',25,1),(147,7432701,7432669,'ria',25,1),(147,7432702,7432669,'ial',25,1),(147,7432703,7432699,'siz',50,1),(147,7432704,7432699,'ize',50,1),(147,7432705,7432703,'460',33.333,1),(147,7432706,7432703,'608',33.333,1),(147,7432707,7432703,'080',33.333,1),(147,7432708,7432705,'dev',25,1),(147,7432709,7432705,'evi',25,1),(147,7432710,7432705,'vic',25,1),(147,7432711,7432705,'ice',25,1),(147,7432712,7432708,'typ',50,1),(147,7432713,7432708,'ype',50,1),(147,7432714,7432712,'dir',10,1),(147,7432715,7432712,'ire',10,1),(147,7432716,7432712,'rec',10,1),(147,7432717,7432712,'ect',10,1),(147,7432718,7432712,'cta',10,1),(147,7432719,7432712,'tac',10,1),(147,7432720,7432712,'acc',10,1),(147,7432721,7432712,'cce',10,1),(147,7432722,7432712,'ces',10,1),(147,7432723,7432712,'ess',10,1),(147,7432724,7432714,'mul',14.286,1),(147,7432725,7432714,'ult',14.286,1),(147,7432726,7432714,'lti',14.286,1),(147,7432727,7432714,'tip',14.286,1),(147,7432728,7432714,'ipa',14.286,1),(147,7432729,7432714,'pat',14.286,1),(147,7432730,7432714,'ath',14.286,1),(147,7432731,7432724,'plu',25,1),(147,7432732,7432724,'lug',25,1),(147,7432733,7432724,'ugi',25,1),(147,7432734,7432724,'gin',25,1),(147,7432735,7432731,'nmp',100,1),(147,7432736,7432735,'dev',33.333,1),(147,7432737,7432735,'evf',33.333,1),(147,7432738,7432735,'vfs',33.333,1),(147,7432739,7432736,'pat',50,1),(147,7432740,7432736,'ath',50,1),(147,7432741,7432739,'vmf',50,1),(147,7432742,7432739,'mfs',50,1),(147,7432743,7432741,'dev',20,1),(147,7432744,7432741,'evi',20,1),(147,7432745,7432741,'vic',20,1),(147,7432746,7432741,'ice',20,1),(147,7432747,7432741,'ces',20,1),(147,7432748,7432743,'dis',33.333,1),(147,7432749,7432743,'isk',33.333,1),(147,7432750,7432743,'sks',33.333,1),(147,7432751,7432748,'ven',25,1),(147,7432752,7432748,'end',25,1),(147,7432753,7432748,'ndo',25,1),(147,7432754,7432748,'dor',25,1),(147,7432755,7432751,'mod',33.333,1),(147,7432756,7432751,'ode',33.333,1),(147,7432757,7432751,'del',33.333,1),(147,7432758,7432755,'lun',100,1),(147,7432759,7432758,'cmo',33.333,1),(147,7432760,7432758,'mod',33.333,1),(147,7432761,7432758,'ode',33.333,1),(147,7432762,7432759,'rev',16.667,1),(147,7432763,7432759,'evi',16.667,1),(147,7432764,7432759,'vis',16.667,1),(147,7432765,7432759,'isi',16.667,1),(147,7432766,7432759,'sio',16.667,1),(147,7432767,7432759,'ion',16.667,1),(147,7432768,7432762,'810',50,1),(147,7432769,7432762,'100',50,1),(147,7432770,7432768,'scs',50,1),(147,7432771,7432768,'csi',50,1),(147,7432772,7432770,'lev',33.333,1),(147,7432773,7432770,'eve',33.333,1),(147,7432774,7432770,'vel',33.333,1),(147,7432775,7432772,'pse',25,1),(147,7432776,7432772,'seu',25,1),(147,7432777,7432772,'eud',25,1),(147,7432778,7432772,'udo',25,1),(147,7432779,7432775,'fal',33.333,6),(147,7432780,7432775,'als',33.333,6),(147,7432781,7432775,'lse',33.333,6),(147,7432782,7432779,'sta',25,3),(147,7432783,7432779,'tat',25,3),(147,7432784,7432779,'atu',25,3),(147,7432785,7432779,'tus',25,3),(147,7432786,7432782,'rdm',100,1),(147,7432787,7432786,'cap',20,1),(147,7432788,7432786,'apa',20,1),(147,7432789,7432786,'pab',20,1),(147,7432790,7432786,'abl',20,1),(147,7432791,7432786,'ble',20,1),(147,7432792,7432787,'tru',50,1),(147,7432793,7432787,'rue',50,1),(147,7432794,7432792,'loc',33.333,1),(147,7432795,7432792,'oca',33.333,1),(147,7432796,7432792,'cal',33.333,1),(147,7432797,7432794,'rem',14.286,1),(147,7432798,7432794,'emo',14.286,1),(147,7432799,7432794,'mov',14.286,1),(147,7432800,7432794,'ova',14.286,1),(147,7432801,7432794,'vab',14.286,1),(147,7432802,7432794,'abl',14.286,1),(147,7432803,7432794,'ble',14.286,1),(147,7432804,7432797,'ssd',100,1),(147,7432805,7432804,'off',20,1),(147,7432806,7432804,'ffl',20,1),(147,7432807,7432804,'fli',20,1),(147,7432808,7432804,'lin',20,1),(147,7432809,7432804,'ine',20,1),(147,7432810,7432805,'per',11.111,1),(147,7432811,7432805,'ere',11.111,1),(147,7432812,7432805,'ren',11.111,1),(147,7432813,7432805,'enn',11.111,1),(147,7432814,7432805,'nni',11.111,1),(147,7432815,7432805,'nia',11.111,1),(147,7432816,7432805,'ial',11.111,1),(147,7432817,7432805,'all',11.111,1),(147,7432818,7432805,'lly',11.111,1),(147,7432819,7432810,'res',16.667,1),(147,7432820,7432810,'ese',16.667,1),(147,7432821,7432810,'ser',16.667,1),(147,7432822,7432810,'erv',16.667,1),(147,7432823,7432810,'rve',16.667,1),(147,7432824,7432810,'ved',16.667,1),(147,7432825,7432819,'thi',50,1),(147,7432826,7432819,'hin',50,1),(147,7432827,7432825,'pro',10,1),(147,7432828,7432825,'rov',10,1),(147,7432829,7432825,'ovi',10,1),(147,7432830,7432825,'vis',10,1),(147,7432831,7432825,'isi',10,1),(147,7432832,7432825,'sio',10,1),(147,7432833,7432825,'ion',10,1),(147,7432834,7432825,'oni',10,1),(147,7432835,7432825,'nin',10,1),(147,7432836,7432825,'ing',10,1),(147,7432837,7432827,'yes',100,1),(147,7432838,7432837,'att',16.667,1),(147,7432839,7432837,'tta',16.667,1),(147,7432840,7432837,'tac',16.667,1),(147,7432841,7432837,'ach',16.667,1),(147,7432842,7432837,'che',16.667,1),(147,7432843,7432837,'hed',16.667,1),(147,7432844,7432838,'fil',20,1),(147,7432845,7432838,'ilt',20,1),(147,7432846,7432838,'lte',20,1),(147,7432847,7432838,'ter',20,1),(147,7432848,7432838,'ers',20,1),(147,7432849,7432844,'vaa',50,1),(147,7432850,7432844,'aai',50,1),(147,7432851,7432849,'unk',20,1),(147,7432852,7432849,'nkn',20,1),(147,7432853,7432849,'kno',20,1),(147,7432854,7432849,'now',20,1),(147,7432855,7432849,'own',20,1),(147,7432856,7432851,'oth',33.333,1),(147,7432857,7432851,'the',33.333,1),(147,7432858,7432851,'her',33.333,1),(147,7432859,7432856,'uid',50,1),(147,7432860,7432856,'ids',50,1),(147,7432861,7432859,'vml',100,1),(147,7432862,7432861,'dis',20,1),(147,7432863,7432861,'isp',20,1),(147,7432864,7432861,'spl',20,1),(147,7432865,7432861,'pla',20,1),(147,7432866,7432861,'lay',20,1),(147,7432867,7432862,'nam',50,1),(147,7432868,7432862,'ame',50,1),(148,7432870,7432869,'net',25,3),(148,7432871,7432869,'eta',25,3),(148,7432872,7432869,'tap',25,3),(148,7432873,7432869,'app',25,3),(148,7432874,7432870,'fib',33.333,2),(148,7432875,7432870,'ibr',33.333,2),(148,7432876,7432870,'bre',33.333,2),(148,7432877,7432874,'cha',20,2),(148,7432878,7432874,'han',20,2),(148,7432879,7432874,'ann',20,2),(148,7432880,7432874,'nne',20,2),(148,7432881,7432874,'nel',20,2),(148,7432882,7432877,'dis',50,2),(148,7432883,7432877,'isk',50,2),(148,7432884,7432882,'naa',100,4),(148,7432885,7432884,'600',3.333,4),(148,7432886,7432884,'00a',3.333,4),(148,7432887,7432884,'0a0',3.333,4),(148,7432888,7432884,'a09',3.333,4),(148,7432889,7432884,'098',3.333,4),(148,7432890,7432884,'980',3.333,4),(148,7432891,7432884,'804',3.333,4),(148,7432892,7432884,'044',3.333,4),(148,7432893,7432884,'443',3.333,4),(148,7432894,7432884,'430',3.333,4),(148,7432895,7432884,'307',3.333,4),(148,7432896,7432884,'075',3.333,4),(148,7432897,7432884,'753',3.333,4),(148,7432898,7432884,'535',3.333,4),(148,7432899,7432884,'357',3.333,4),(148,7432900,7432884,'573',3.333,4),(148,7432901,7432884,'732',3.333,4),(148,7432902,7432884,'32b',3.333,4),(148,7432903,7432884,'2b3',3.333,4),(148,7432904,7432884,'b33',3.333,4),(148,7432905,7432884,'334',3.333,4),(148,7432906,7432884,'345',3.333,4),(148,7432907,7432884,'457',3.333,4),(148,7432908,7432884,'571',3.333,4),(148,7432909,7432884,'715',3.333,4),(148,7432910,7432884,'152',3.333,4),(148,7432911,7432884,'527',3.333,4),(148,7432912,7432884,'275',3.333,4),(148,7432913,7432884,'753',3.333,4),(148,7432914,7432884,'535',3.333,4),(148,7432915,7432885,'ser',25,1),(148,7432916,7432885,'eri',25,1),(148,7432917,7432885,'ria',25,1),(148,7432918,7432885,'ial',25,1),(148,7432919,7432915,'siz',50,1),(148,7432920,7432915,'ize',50,1),(148,7432921,7432919,'460',33.333,1),(148,7432922,7432919,'608',33.333,1),(148,7432923,7432919,'080',33.333,1),(148,7432924,7432921,'dev',25,1),(148,7432925,7432921,'evi',25,1),(148,7432926,7432921,'vic',25,1),(148,7432927,7432921,'ice',25,1),(148,7432928,7432924,'typ',50,1),(148,7432929,7432924,'ype',50,1),(148,7432930,7432928,'dir',10,1),(148,7432931,7432928,'ire',10,1),(148,7432932,7432928,'rec',10,1),(148,7432933,7432928,'ect',10,1),(148,7432934,7432928,'cta',10,1),(148,7432935,7432928,'tac',10,1),(148,7432936,7432928,'acc',10,1),(148,7432937,7432928,'cce',10,1),(148,7432938,7432928,'ces',10,1),(148,7432939,7432928,'ess',10,1),(148,7432940,7432930,'mul',14.286,1),(148,7432941,7432930,'ult',14.286,1),(148,7432942,7432930,'lti',14.286,1),(148,7432943,7432930,'tip',14.286,1),(148,7432944,7432930,'ipa',14.286,1),(148,7432945,7432930,'pat',14.286,1),(148,7432946,7432930,'ath',14.286,1),(148,7432947,7432940,'plu',25,1),(148,7432948,7432940,'lug',25,1),(148,7432949,7432940,'ugi',25,1),(148,7432950,7432940,'gin',25,1),(148,7432951,7432947,'nmp',100,1),(148,7432952,7432951,'dev',33.333,1),(148,7432953,7432951,'evf',33.333,1),(148,7432954,7432951,'vfs',33.333,1),(148,7432955,7432952,'pat',50,1),(148,7432956,7432952,'ath',50,1),(148,7432957,7432955,'vmf',50,1),(148,7432958,7432955,'mfs',50,1),(148,7432959,7432957,'dev',20,1),(148,7432960,7432957,'evi',20,1),(148,7432961,7432957,'vic',20,1),(148,7432962,7432957,'ice',20,1),(148,7432963,7432957,'ces',20,1),(148,7432964,7432959,'dis',33.333,1),(148,7432965,7432959,'isk',33.333,1),(148,7432966,7432959,'sks',33.333,1),(148,7432967,7432964,'ven',25,1),(148,7432968,7432964,'end',25,1),(148,7432969,7432964,'ndo',25,1),(148,7432970,7432964,'dor',25,1),(148,7432971,7432967,'mod',33.333,1),(148,7432972,7432967,'ode',33.333,1),(148,7432973,7432967,'del',33.333,1),(148,7432974,7432971,'lun',100,1),(148,7432975,7432974,'cmo',33.333,1),(148,7432976,7432974,'mod',33.333,1),(148,7432977,7432974,'ode',33.333,1),(148,7432978,7432975,'rev',16.667,1),(148,7432979,7432975,'evi',16.667,1),(148,7432980,7432975,'vis',16.667,1),(148,7432981,7432975,'isi',16.667,1),(148,7432982,7432975,'sio',16.667,1),(148,7432983,7432975,'ion',16.667,1),(148,7432984,7432978,'810',50,1),(148,7432985,7432978,'100',50,1),(148,7432986,7432984,'scs',50,1),(148,7432987,7432984,'csi',50,1),(148,7432988,7432986,'lev',33.333,1),(148,7432989,7432986,'eve',33.333,1),(148,7432990,7432986,'vel',33.333,1),(148,7432991,7432988,'pse',25,1),(148,7432992,7432988,'seu',25,1),(148,7432993,7432988,'eud',25,1),(148,7432994,7432988,'udo',25,1),(148,7432995,7432991,'fal',33.333,6),(148,7432996,7432991,'als',33.333,6),(148,7432997,7432991,'lse',33.333,6),(148,7432998,7432995,'sta',25,3),(148,7432999,7432995,'tat',25,3),(148,7433000,7432995,'atu',25,3),(148,7433001,7432995,'tus',25,3),(148,7433002,7432998,'rdm',100,1),(148,7433003,7433002,'cap',20,1),(148,7433004,7433002,'apa',20,1),(148,7433005,7433002,'pab',20,1),(148,7433006,7433002,'abl',20,1),(148,7433007,7433002,'ble',20,1),(148,7433008,7433003,'tru',50,1),(148,7433009,7433003,'rue',50,1),(148,7433010,7433008,'loc',33.333,1),(148,7433011,7433008,'oca',33.333,1),(148,7433012,7433008,'cal',33.333,1),(148,7433013,7433010,'rem',14.286,1),(148,7433014,7433010,'emo',14.286,1),(148,7433015,7433010,'mov',14.286,1),(148,7433016,7433010,'ova',14.286,1),(148,7433017,7433010,'vab',14.286,1),(148,7433018,7433010,'abl',14.286,1),(148,7433019,7433010,'ble',14.286,1),(148,7433020,7433013,'ssd',100,1),(148,7433021,7433020,'off',20,1),(148,7433022,7433020,'ffl',20,1),(148,7433023,7433020,'fli',20,1),(148,7433024,7433020,'lin',20,1),(148,7433025,7433020,'ine',20,1),(148,7433026,7433021,'per',11.111,1),(148,7433027,7433021,'ere',11.111,1),(148,7433028,7433021,'ren',11.111,1),(148,7433029,7433021,'enn',11.111,1),(148,7433030,7433021,'nni',11.111,1),(148,7433031,7433021,'nia',11.111,1),(148,7433032,7433021,'ial',11.111,1),(148,7433033,7433021,'all',11.111,1),(148,7433034,7433021,'lly',11.111,1),(148,7433035,7433026,'res',16.667,1),(148,7433036,7433026,'ese',16.667,1),(148,7433037,7433026,'ser',16.667,1),(148,7433038,7433026,'erv',16.667,1),(148,7433039,7433026,'rve',16.667,1),(148,7433040,7433026,'ved',16.667,1),(148,7433041,7433035,'thi',50,1),(148,7433042,7433035,'hin',50,1),(148,7433043,7433041,'pro',10,1),(148,7433044,7433041,'rov',10,1),(148,7433045,7433041,'ovi',10,1),(148,7433046,7433041,'vis',10,1),(148,7433047,7433041,'isi',10,1),(148,7433048,7433041,'sio',10,1),(148,7433049,7433041,'ion',10,1),(148,7433050,7433041,'oni',10,1),(148,7433051,7433041,'nin',10,1),(148,7433052,7433041,'ing',10,1),(148,7433053,7433043,'yes',100,1),(148,7433054,7433053,'att',16.667,1),(148,7433055,7433053,'tta',16.667,1),(148,7433056,7433053,'tac',16.667,1),(148,7433057,7433053,'ach',16.667,1),(148,7433058,7433053,'che',16.667,1),(148,7433059,7433053,'hed',16.667,1),(148,7433060,7433054,'fil',20,1),(148,7433061,7433054,'ilt',20,1),(148,7433062,7433054,'lte',20,1),(148,7433063,7433054,'ter',20,1),(148,7433064,7433054,'ers',20,1),(148,7433065,7433060,'vaa',50,1),(148,7433066,7433060,'aai',50,1),(148,7433067,7433065,'unk',20,1),(148,7433068,7433065,'nkn',20,1),(148,7433069,7433065,'kno',20,1),(148,7433070,7433065,'now',20,1),(148,7433071,7433065,'own',20,1),(148,7433072,7433067,'oth',33.333,1),(148,7433073,7433067,'the',33.333,1),(148,7433074,7433067,'her',33.333,1),(148,7433075,7433072,'uid',50,1),(148,7433076,7433072,'ids',50,1),(148,7433077,7433075,'vml',100,1),(148,7433078,7433077,'dis',20,1),(148,7433079,7433077,'isp',20,1),(148,7433080,7433077,'spl',20,1),(148,7433081,7433077,'pla',20,1),(148,7433082,7433077,'lay',20,1),(148,7433083,7433078,'nam',50,1),(148,7433084,7433078,'ame',50,1),(149,7433086,7433085,'net',25,3),(149,7433087,7433085,'eta',25,3),(149,7433088,7433085,'tap',25,3),(149,7433089,7433085,'app',25,3),(149,7433090,7433086,'fib',33.333,2),(149,7433091,7433086,'ibr',33.333,2),(149,7433092,7433086,'bre',33.333,2),(149,7433093,7433090,'cha',20,2),(149,7433094,7433090,'han',20,2),(149,7433095,7433090,'ann',20,2),(149,7433096,7433090,'nne',20,2),(149,7433097,7433090,'nel',20,2),(149,7433098,7433093,'dis',50,2),(149,7433099,7433093,'isk',50,2),(149,7433100,7433098,'naa',100,4),(149,7433101,7433100,'600',3.333,4),(149,7433102,7433100,'00a',3.333,4),(149,7433103,7433100,'0a0',3.333,4),(149,7433104,7433100,'a09',3.333,4),(149,7433105,7433100,'098',3.333,4),(149,7433106,7433100,'980',3.333,4),(149,7433107,7433100,'804',3.333,4),(149,7433108,7433100,'044',3.333,4),(149,7433109,7433100,'443',3.333,4),(149,7433110,7433100,'430',3.333,4),(149,7433111,7433100,'307',3.333,4),(149,7433112,7433100,'075',3.333,4),(149,7433113,7433100,'753',3.333,4),(149,7433114,7433100,'535',3.333,4),(149,7433115,7433100,'357',3.333,4),(149,7433116,7433100,'573',3.333,4),(149,7433117,7433100,'732',3.333,4),(149,7433118,7433100,'32b',3.333,4),(149,7433119,7433100,'2b3',3.333,4),(149,7433120,7433100,'b33',3.333,4),(149,7433121,7433100,'334',3.333,4),(149,7433122,7433100,'345',3.333,4),(149,7433123,7433100,'457',3.333,4),(149,7433124,7433100,'571',3.333,4),(149,7433125,7433100,'715',3.333,4),(149,7433126,7433100,'152',3.333,4),(149,7433127,7433100,'527',3.333,4),(149,7433128,7433100,'275',3.333,4),(149,7433129,7433100,'753',3.333,4),(149,7433130,7433100,'536',3.333,4),(149,7433131,7433101,'ser',25,1),(149,7433132,7433101,'eri',25,1),(149,7433133,7433101,'ria',25,1),(149,7433134,7433101,'ial',25,1),(149,7433135,7433131,'siz',50,1),(149,7433136,7433131,'ize',50,1),(149,7433137,7433135,'460',33.333,1),(149,7433138,7433135,'608',33.333,1),(149,7433139,7433135,'080',33.333,1),(149,7433140,7433137,'dev',25,1),(149,7433141,7433137,'evi',25,1),(149,7433142,7433137,'vic',25,1),(149,7433143,7433137,'ice',25,1),(149,7433144,7433140,'typ',50,1),(149,7433145,7433140,'ype',50,1),(149,7433146,7433144,'dir',10,1),(149,7433147,7433144,'ire',10,1),(149,7433148,7433144,'rec',10,1),(149,7433149,7433144,'ect',10,1),(149,7433150,7433144,'cta',10,1),(149,7433151,7433144,'tac',10,1),(149,7433152,7433144,'acc',10,1),(149,7433153,7433144,'cce',10,1),(149,7433154,7433144,'ces',10,1),(149,7433155,7433144,'ess',10,1),(149,7433156,7433146,'mul',14.286,1),(149,7433157,7433146,'ult',14.286,1),(149,7433158,7433146,'lti',14.286,1),(149,7433159,7433146,'tip',14.286,1),(149,7433160,7433146,'ipa',14.286,1),(149,7433161,7433146,'pat',14.286,1),(149,7433162,7433146,'ath',14.286,1),(149,7433163,7433156,'plu',25,1),(149,7433164,7433156,'lug',25,1),(149,7433165,7433156,'ugi',25,1),(149,7433166,7433156,'gin',25,1),(149,7433167,7433163,'nmp',100,1),(149,7433168,7433167,'dev',33.333,1),(149,7433169,7433167,'evf',33.333,1),(149,7433170,7433167,'vfs',33.333,1),(149,7433171,7433168,'pat',50,1),(149,7433172,7433168,'ath',50,1),(149,7433173,7433171,'vmf',50,1),(149,7433174,7433171,'mfs',50,1),(149,7433175,7433173,'dev',20,1),(149,7433176,7433173,'evi',20,1),(149,7433177,7433173,'vic',20,1),(149,7433178,7433173,'ice',20,1),(149,7433179,7433173,'ces',20,1),(149,7433180,7433175,'dis',33.333,1),(149,7433181,7433175,'isk',33.333,1),(149,7433182,7433175,'sks',33.333,1),(149,7433183,7433180,'ven',25,1),(149,7433184,7433180,'end',25,1),(149,7433185,7433180,'ndo',25,1),(149,7433186,7433180,'dor',25,1),(149,7433187,7433183,'mod',33.333,1),(149,7433188,7433183,'ode',33.333,1),(149,7433189,7433183,'del',33.333,1),(149,7433190,7433187,'lun',100,1),(149,7433191,7433190,'cmo',33.333,1),(149,7433192,7433190,'mod',33.333,1),(149,7433193,7433190,'ode',33.333,1),(149,7433194,7433191,'rev',16.667,1),(149,7433195,7433191,'evi',16.667,1),(149,7433196,7433191,'vis',16.667,1),(149,7433197,7433191,'isi',16.667,1),(149,7433198,7433191,'sio',16.667,1),(149,7433199,7433191,'ion',16.667,1),(149,7433200,7433194,'810',50,1),(149,7433201,7433194,'100',50,1),(149,7433202,7433200,'scs',50,1),(149,7433203,7433200,'csi',50,1),(149,7433204,7433202,'lev',33.333,1),(149,7433205,7433202,'eve',33.333,1),(149,7433206,7433202,'vel',33.333,1),(149,7433207,7433204,'pse',25,1),(149,7433208,7433204,'seu',25,1),(149,7433209,7433204,'eud',25,1),(149,7433210,7433204,'udo',25,1),(149,7433211,7433207,'fal',33.333,6),(149,7433212,7433207,'als',33.333,6),(149,7433213,7433207,'lse',33.333,6),(149,7433214,7433211,'sta',25,3),(149,7433215,7433211,'tat',25,3),(149,7433216,7433211,'atu',25,3),(149,7433217,7433211,'tus',25,3),(149,7433218,7433214,'rdm',100,1),(149,7433219,7433218,'cap',20,1),(149,7433220,7433218,'apa',20,1),(149,7433221,7433218,'pab',20,1),(149,7433222,7433218,'abl',20,1),(149,7433223,7433218,'ble',20,1),(149,7433224,7433219,'tru',50,1),(149,7433225,7433219,'rue',50,1),(149,7433226,7433224,'loc',33.333,1),(149,7433227,7433224,'oca',33.333,1),(149,7433228,7433224,'cal',33.333,1),(149,7433229,7433226,'rem',14.286,1),(149,7433230,7433226,'emo',14.286,1),(149,7433231,7433226,'mov',14.286,1),(149,7433232,7433226,'ova',14.286,1),(149,7433233,7433226,'vab',14.286,1),(149,7433234,7433226,'abl',14.286,1),(149,7433235,7433226,'ble',14.286,1),(149,7433236,7433229,'ssd',100,1),(149,7433237,7433236,'off',20,1),(149,7433238,7433236,'ffl',20,1),(149,7433239,7433236,'fli',20,1),(149,7433240,7433236,'lin',20,1),(149,7433241,7433236,'ine',20,1),(149,7433242,7433237,'per',11.111,1),(149,7433243,7433237,'ere',11.111,1),(149,7433244,7433237,'ren',11.111,1),(149,7433245,7433237,'enn',11.111,1),(149,7433246,7433237,'nni',11.111,1),(149,7433247,7433237,'nia',11.111,1),(149,7433248,7433237,'ial',11.111,1),(149,7433249,7433237,'all',11.111,1),(149,7433250,7433237,'lly',11.111,1),(149,7433251,7433242,'res',16.667,1),(149,7433252,7433242,'ese',16.667,1),(149,7433253,7433242,'ser',16.667,1),(149,7433254,7433242,'erv',16.667,1),(149,7433255,7433242,'rve',16.667,1),(149,7433256,7433242,'ved',16.667,1),(149,7433257,7433251,'thi',50,1),(149,7433258,7433251,'hin',50,1),(149,7433259,7433257,'pro',10,1),(149,7433260,7433257,'rov',10,1),(149,7433261,7433257,'ovi',10,1),(149,7433262,7433257,'vis',10,1),(149,7433263,7433257,'isi',10,1),(149,7433264,7433257,'sio',10,1),(149,7433265,7433257,'ion',10,1),(149,7433266,7433257,'oni',10,1),(149,7433267,7433257,'nin',10,1),(149,7433268,7433257,'ing',10,1),(149,7433269,7433259,'yes',100,1),(149,7433270,7433269,'att',16.667,1),(149,7433271,7433269,'tta',16.667,1),(149,7433272,7433269,'tac',16.667,1),(149,7433273,7433269,'ach',16.667,1),(149,7433274,7433269,'che',16.667,1),(149,7433275,7433269,'hed',16.667,1),(149,7433276,7433270,'fil',20,1),(149,7433277,7433270,'ilt',20,1),(149,7433278,7433270,'lte',20,1),(149,7433279,7433270,'ter',20,1),(149,7433280,7433270,'ers',20,1),(149,7433281,7433276,'vaa',50,1),(149,7433282,7433276,'aai',50,1),(149,7433283,7433281,'unk',20,1),(149,7433284,7433281,'nkn',20,1),(149,7433285,7433281,'kno',20,1),(149,7433286,7433281,'now',20,1),(149,7433287,7433281,'own',20,1),(149,7433288,7433283,'oth',33.333,1),(149,7433289,7433283,'the',33.333,1),(149,7433290,7433283,'her',33.333,1),(149,7433291,7433288,'uid',50,1),(149,7433292,7433288,'ids',50,1),(149,7433293,7433291,'vml',100,1),(149,7433294,7433293,'dis',20,1),(149,7433295,7433293,'isp',20,1),(149,7433296,7433293,'spl',20,1),(149,7433297,7433293,'pla',20,1),(149,7433298,7433293,'lay',20,1),(149,7433299,7433294,'nam',50,1),(149,7433300,7433294,'ame',50,1),(150,7433302,7433301,'net',25,3),(150,7433303,7433301,'eta',25,3),(150,7433304,7433301,'tap',25,3),(150,7433305,7433301,'app',25,3),(150,7433306,7433302,'fib',33.333,2),(150,7433307,7433302,'ibr',33.333,2),(150,7433308,7433302,'bre',33.333,2),(150,7433309,7433306,'cha',20,2),(150,7433310,7433306,'han',20,2),(150,7433311,7433306,'ann',20,2),(150,7433312,7433306,'nne',20,2),(150,7433313,7433306,'nel',20,2),(150,7433314,7433309,'dis',50,2),(150,7433315,7433309,'isk',50,2),(150,7433316,7433314,'naa',100,4),(150,7433317,7433316,'600',3.333,4),(150,7433318,7433316,'00a',3.333,4),(150,7433319,7433316,'0a0',3.333,4),(150,7433320,7433316,'a09',3.333,4),(150,7433321,7433316,'098',3.333,4),(150,7433322,7433316,'980',3.333,4),(150,7433323,7433316,'804',3.333,4),(150,7433324,7433316,'044',3.333,4),(150,7433325,7433316,'443',3.333,4),(150,7433326,7433316,'430',3.333,4),(150,7433327,7433316,'307',3.333,4),(150,7433328,7433316,'075',3.333,4),(150,7433329,7433316,'753',3.333,4),(150,7433330,7433316,'535',3.333,4),(150,7433331,7433316,'357',3.333,4),(150,7433332,7433316,'573',3.333,4),(150,7433333,7433316,'732',3.333,4),(150,7433334,7433316,'32b',3.333,4),(150,7433335,7433316,'2b3',3.333,4),(150,7433336,7433316,'b33',3.333,4),(150,7433337,7433316,'334',3.333,4),(150,7433338,7433316,'345',3.333,4),(150,7433339,7433316,'457',3.333,4),(150,7433340,7433316,'571',3.333,4),(150,7433341,7433316,'715',3.333,4),(150,7433342,7433316,'152',3.333,4),(150,7433343,7433316,'527',3.333,4),(150,7433344,7433316,'275',3.333,4),(150,7433345,7433316,'753',3.333,4),(150,7433346,7433316,'537',3.333,4),(150,7433347,7433317,'ser',25,1),(150,7433348,7433317,'eri',25,1),(150,7433349,7433317,'ria',25,1),(150,7433350,7433317,'ial',25,1),(150,7433351,7433347,'siz',50,1),(150,7433352,7433347,'ize',50,1),(150,7433353,7433351,'460',33.333,1),(150,7433354,7433351,'608',33.333,1),(150,7433355,7433351,'080',33.333,1),(150,7433356,7433353,'dev',25,1),(150,7433357,7433353,'evi',25,1),(150,7433358,7433353,'vic',25,1),(150,7433359,7433353,'ice',25,1),(150,7433360,7433356,'typ',50,1),(150,7433361,7433356,'ype',50,1),(150,7433362,7433360,'dir',10,1),(150,7433363,7433360,'ire',10,1),(150,7433364,7433360,'rec',10,1),(150,7433365,7433360,'ect',10,1),(150,7433366,7433360,'cta',10,1),(150,7433367,7433360,'tac',10,1),(150,7433368,7433360,'acc',10,1),(150,7433369,7433360,'cce',10,1),(150,7433370,7433360,'ces',10,1),(150,7433371,7433360,'ess',10,1),(150,7433372,7433362,'mul',14.286,1),(150,7433373,7433362,'ult',14.286,1),(150,7433374,7433362,'lti',14.286,1),(150,7433375,7433362,'tip',14.286,1),(150,7433376,7433362,'ipa',14.286,1),(150,7433377,7433362,'pat',14.286,1),(150,7433378,7433362,'ath',14.286,1),(150,7433379,7433372,'plu',25,1),(150,7433380,7433372,'lug',25,1),(150,7433381,7433372,'ugi',25,1),(150,7433382,7433372,'gin',25,1),(150,7433383,7433379,'nmp',100,1),(150,7433384,7433383,'dev',33.333,1),(150,7433385,7433383,'evf',33.333,1),(150,7433386,7433383,'vfs',33.333,1),(150,7433387,7433384,'pat',50,1),(150,7433388,7433384,'ath',50,1),(150,7433389,7433387,'vmf',50,1),(150,7433390,7433387,'mfs',50,1),(150,7433391,7433389,'dev',20,1),(150,7433392,7433389,'evi',20,1),(150,7433393,7433389,'vic',20,1),(150,7433394,7433389,'ice',20,1),(150,7433395,7433389,'ces',20,1),(150,7433396,7433391,'dis',33.333,1),(150,7433397,7433391,'isk',33.333,1),(150,7433398,7433391,'sks',33.333,1),(150,7433399,7433396,'ven',25,1),(150,7433400,7433396,'end',25,1),(150,7433401,7433396,'ndo',25,1),(150,7433402,7433396,'dor',25,1),(150,7433403,7433399,'mod',33.333,1),(150,7433404,7433399,'ode',33.333,1),(150,7433405,7433399,'del',33.333,1),(150,7433406,7433403,'lun',100,1),(150,7433407,7433406,'cmo',33.333,1),(150,7433408,7433406,'mod',33.333,1),(150,7433409,7433406,'ode',33.333,1),(150,7433410,7433407,'rev',16.667,1),(150,7433411,7433407,'evi',16.667,1),(150,7433412,7433407,'vis',16.667,1),(150,7433413,7433407,'isi',16.667,1),(150,7433414,7433407,'sio',16.667,1),(150,7433415,7433407,'ion',16.667,1),(150,7433416,7433410,'810',50,1),(150,7433417,7433410,'100',50,1),(150,7433418,7433416,'scs',50,1),(150,7433419,7433416,'csi',50,1),(150,7433420,7433418,'lev',33.333,1),(150,7433421,7433418,'eve',33.333,1),(150,7433422,7433418,'vel',33.333,1),(150,7433423,7433420,'pse',25,1),(150,7433424,7433420,'seu',25,1),(150,7433425,7433420,'eud',25,1),(150,7433426,7433420,'udo',25,1),(150,7433427,7433423,'fal',33.333,6),(150,7433428,7433423,'als',33.333,6),(150,7433429,7433423,'lse',33.333,6),(150,7433430,7433427,'sta',25,3),(150,7433431,7433427,'tat',25,3),(150,7433432,7433427,'atu',25,3),(150,7433433,7433427,'tus',25,3),(150,7433434,7433430,'rdm',100,1),(150,7433435,7433434,'cap',20,1),(150,7433436,7433434,'apa',20,1),(150,7433437,7433434,'pab',20,1),(150,7433438,7433434,'abl',20,1),(150,7433439,7433434,'ble',20,1),(150,7433440,7433435,'tru',50,1),(150,7433441,7433435,'rue',50,1),(150,7433442,7433440,'loc',33.333,1),(150,7433443,7433440,'oca',33.333,1),(150,7433444,7433440,'cal',33.333,1),(150,7433445,7433442,'rem',14.286,1),(150,7433446,7433442,'emo',14.286,1),(150,7433447,7433442,'mov',14.286,1),(150,7433448,7433442,'ova',14.286,1),(150,7433449,7433442,'vab',14.286,1),(150,7433450,7433442,'abl',14.286,1),(150,7433451,7433442,'ble',14.286,1),(150,7433452,7433445,'ssd',100,1),(150,7433453,7433452,'off',20,1),(150,7433454,7433452,'ffl',20,1),(150,7433455,7433452,'fli',20,1),(150,7433456,7433452,'lin',20,1),(150,7433457,7433452,'ine',20,1),(150,7433458,7433453,'per',11.111,1),(150,7433459,7433453,'ere',11.111,1),(150,7433460,7433453,'ren',11.111,1),(150,7433461,7433453,'enn',11.111,1),(150,7433462,7433453,'nni',11.111,1),(150,7433463,7433453,'nia',11.111,1),(150,7433464,7433453,'ial',11.111,1),(150,7433465,7433453,'all',11.111,1),(150,7433466,7433453,'lly',11.111,1),(150,7433467,7433458,'res',16.667,1),(150,7433468,7433458,'ese',16.667,1),(150,7433469,7433458,'ser',16.667,1),(150,7433470,7433458,'erv',16.667,1),(150,7433471,7433458,'rve',16.667,1),(150,7433472,7433458,'ved',16.667,1),(150,7433473,7433467,'thi',50,1),(150,7433474,7433467,'hin',50,1),(150,7433475,7433473,'pro',10,1),(150,7433476,7433473,'rov',10,1),(150,7433477,7433473,'ovi',10,1),(150,7433478,7433473,'vis',10,1),(150,7433479,7433473,'isi',10,1),(150,7433480,7433473,'sio',10,1),(150,7433481,7433473,'ion',10,1),(150,7433482,7433473,'oni',10,1),(150,7433483,7433473,'nin',10,1),(150,7433484,7433473,'ing',10,1),(150,7433485,7433475,'yes',100,1),(150,7433486,7433485,'att',16.667,1),(150,7433487,7433485,'tta',16.667,1),(150,7433488,7433485,'tac',16.667,1),(150,7433489,7433485,'ach',16.667,1),(150,7433490,7433485,'che',16.667,1),(150,7433491,7433485,'hed',16.667,1),(150,7433492,7433486,'fil',20,1),(150,7433493,7433486,'ilt',20,1),(150,7433494,7433486,'lte',20,1),(150,7433495,7433486,'ter',20,1),(150,7433496,7433486,'ers',20,1),(150,7433497,7433492,'vaa',50,1),(150,7433498,7433492,'aai',50,1),(150,7433499,7433497,'unk',20,1),(150,7433500,7433497,'nkn',20,1),(150,7433501,7433497,'kno',20,1),(150,7433502,7433497,'now',20,1),(150,7433503,7433497,'own',20,1),(150,7433504,7433499,'oth',33.333,1),(150,7433505,7433499,'the',33.333,1),(150,7433506,7433499,'her',33.333,1),(150,7433507,7433504,'uid',50,1),(150,7433508,7433504,'ids',50,1),(150,7433509,7433507,'vml',100,1),(150,7433510,7433509,'dis',20,1),(150,7433511,7433509,'isp',20,1),(150,7433512,7433509,'spl',20,1),(150,7433513,7433509,'pla',20,1),(150,7433514,7433509,'lay',20,1),(150,7433515,7433510,'nam',50,1),(150,7433516,7433510,'ame',50,1),(151,7433518,7433517,'net',25,3),(151,7433519,7433517,'eta',25,3),(151,7433520,7433517,'tap',25,3),(151,7433521,7433517,'app',25,3),(151,7433522,7433518,'fib',33.333,2),(151,7433523,7433518,'ibr',33.333,2),(151,7433524,7433518,'bre',33.333,2),(151,7433525,7433522,'cha',20,2),(151,7433526,7433522,'han',20,2),(151,7433527,7433522,'ann',20,2),(151,7433528,7433522,'nne',20,2),(151,7433529,7433522,'nel',20,2),(151,7433530,7433525,'dis',50,2),(151,7433531,7433525,'isk',50,2),(151,7433532,7433530,'naa',100,4),(151,7433533,7433532,'600',3.333,4),(151,7433534,7433532,'00a',3.333,4),(151,7433535,7433532,'0a0',3.333,4),(151,7433536,7433532,'a09',3.333,4),(151,7433537,7433532,'098',3.333,4),(151,7433538,7433532,'980',3.333,4),(151,7433539,7433532,'804',3.333,4),(151,7433540,7433532,'044',3.333,4),(151,7433541,7433532,'443',3.333,4),(151,7433542,7433532,'430',3.333,4),(151,7433543,7433532,'307',3.333,4),(151,7433544,7433532,'075',3.333,4),(151,7433545,7433532,'753',3.333,4),(151,7433546,7433532,'535',3.333,4),(151,7433547,7433532,'357',3.333,4),(151,7433548,7433532,'573',3.333,4),(151,7433549,7433532,'732',3.333,4),(151,7433550,7433532,'32b',3.333,4),(151,7433551,7433532,'2b3',3.333,4),(151,7433552,7433532,'b33',3.333,4),(151,7433553,7433532,'334',3.333,4),(151,7433554,7433532,'345',3.333,4),(151,7433555,7433532,'457',3.333,4),(151,7433556,7433532,'571',3.333,4),(151,7433557,7433532,'715',3.333,4),(151,7433558,7433532,'152',3.333,4),(151,7433559,7433532,'527',3.333,4),(151,7433560,7433532,'275',3.333,4),(151,7433561,7433532,'753',3.333,4),(151,7433562,7433532,'538',3.333,4),(151,7433563,7433533,'ser',25,1),(151,7433564,7433533,'eri',25,1),(151,7433565,7433533,'ria',25,1),(151,7433566,7433533,'ial',25,1),(151,7433567,7433563,'siz',50,1),(151,7433568,7433563,'ize',50,1),(151,7433569,7433567,'460',33.333,1),(151,7433570,7433567,'608',33.333,1),(151,7433571,7433567,'080',33.333,1),(151,7433572,7433569,'dev',25,1),(151,7433573,7433569,'evi',25,1),(151,7433574,7433569,'vic',25,1),(151,7433575,7433569,'ice',25,1),(151,7433576,7433572,'typ',50,1),(151,7433577,7433572,'ype',50,1),(151,7433578,7433576,'dir',10,1),(151,7433579,7433576,'ire',10,1),(151,7433580,7433576,'rec',10,1),(151,7433581,7433576,'ect',10,1),(151,7433582,7433576,'cta',10,1),(151,7433583,7433576,'tac',10,1),(151,7433584,7433576,'acc',10,1),(151,7433585,7433576,'cce',10,1),(151,7433586,7433576,'ces',10,1),(151,7433587,7433576,'ess',10,1),(151,7433588,7433578,'mul',14.286,1),(151,7433589,7433578,'ult',14.286,1),(151,7433590,7433578,'lti',14.286,1),(151,7433591,7433578,'tip',14.286,1),(151,7433592,7433578,'ipa',14.286,1),(151,7433593,7433578,'pat',14.286,1),(151,7433594,7433578,'ath',14.286,1),(151,7433595,7433588,'plu',25,1),(151,7433596,7433588,'lug',25,1),(151,7433597,7433588,'ugi',25,1),(151,7433598,7433588,'gin',25,1),(151,7433599,7433595,'nmp',100,1),(151,7433600,7433599,'dev',33.333,1),(151,7433601,7433599,'evf',33.333,1),(151,7433602,7433599,'vfs',33.333,1),(151,7433603,7433600,'pat',50,1),(151,7433604,7433600,'ath',50,1),(151,7433605,7433603,'vmf',50,1),(151,7433606,7433603,'mfs',50,1),(151,7433607,7433605,'dev',20,1),(151,7433608,7433605,'evi',20,1),(151,7433609,7433605,'vic',20,1),(151,7433610,7433605,'ice',20,1),(151,7433611,7433605,'ces',20,1),(151,7433612,7433607,'dis',33.333,1),(151,7433613,7433607,'isk',33.333,1),(151,7433614,7433607,'sks',33.333,1),(151,7433615,7433612,'ven',25,1),(151,7433616,7433612,'end',25,1),(151,7433617,7433612,'ndo',25,1),(151,7433618,7433612,'dor',25,1),(151,7433619,7433615,'mod',33.333,1),(151,7433620,7433615,'ode',33.333,1),(151,7433621,7433615,'del',33.333,1),(151,7433622,7433619,'lun',100,1),(151,7433623,7433622,'cmo',33.333,1),(151,7433624,7433622,'mod',33.333,1),(151,7433625,7433622,'ode',33.333,1),(151,7433626,7433623,'rev',16.667,1),(151,7433627,7433623,'evi',16.667,1),(151,7433628,7433623,'vis',16.667,1),(151,7433629,7433623,'isi',16.667,1),(151,7433630,7433623,'sio',16.667,1),(151,7433631,7433623,'ion',16.667,1),(151,7433632,7433626,'810',50,1),(151,7433633,7433626,'100',50,1),(151,7433634,7433632,'scs',50,1),(151,7433635,7433632,'csi',50,1),(151,7433636,7433634,'lev',33.333,1),(151,7433637,7433634,'eve',33.333,1),(151,7433638,7433634,'vel',33.333,1),(151,7433639,7433636,'pse',25,1),(151,7433640,7433636,'seu',25,1),(151,7433641,7433636,'eud',25,1),(151,7433642,7433636,'udo',25,1),(151,7433643,7433639,'fal',33.333,6),(151,7433644,7433639,'als',33.333,6),(151,7433645,7433639,'lse',33.333,6),(151,7433646,7433643,'sta',25,3),(151,7433647,7433643,'tat',25,3),(151,7433648,7433643,'atu',25,3),(151,7433649,7433643,'tus',25,3),(151,7433650,7433646,'rdm',100,1),(151,7433651,7433650,'cap',20,1),(151,7433652,7433650,'apa',20,1),(151,7433653,7433650,'pab',20,1),(151,7433654,7433650,'abl',20,1),(151,7433655,7433650,'ble',20,1),(151,7433656,7433651,'tru',50,1),(151,7433657,7433651,'rue',50,1),(151,7433658,7433656,'loc',33.333,1),(151,7433659,7433656,'oca',33.333,1),(151,7433660,7433656,'cal',33.333,1),(151,7433661,7433658,'rem',14.286,1),(151,7433662,7433658,'emo',14.286,1),(151,7433663,7433658,'mov',14.286,1),(151,7433664,7433658,'ova',14.286,1),(151,7433665,7433658,'vab',14.286,1),(151,7433666,7433658,'abl',14.286,1),(151,7433667,7433658,'ble',14.286,1),(151,7433668,7433661,'ssd',100,1),(151,7433669,7433668,'off',20,1),(151,7433670,7433668,'ffl',20,1),(151,7433671,7433668,'fli',20,1),(151,7433672,7433668,'lin',20,1),(151,7433673,7433668,'ine',20,1),(151,7433674,7433669,'per',11.111,1),(151,7433675,7433669,'ere',11.111,1),(151,7433676,7433669,'ren',11.111,1),(151,7433677,7433669,'enn',11.111,1),(151,7433678,7433669,'nni',11.111,1),(151,7433679,7433669,'nia',11.111,1),(151,7433680,7433669,'ial',11.111,1),(151,7433681,7433669,'all',11.111,1),(151,7433682,7433669,'lly',11.111,1),(151,7433683,7433674,'res',16.667,1),(151,7433684,7433674,'ese',16.667,1),(151,7433685,7433674,'ser',16.667,1),(151,7433686,7433674,'erv',16.667,1),(151,7433687,7433674,'rve',16.667,1),(151,7433688,7433674,'ved',16.667,1),(151,7433689,7433683,'thi',50,1),(151,7433690,7433683,'hin',50,1),(151,7433691,7433689,'pro',10,1),(151,7433692,7433689,'rov',10,1),(151,7433693,7433689,'ovi',10,1),(151,7433694,7433689,'vis',10,1),(151,7433695,7433689,'isi',10,1),(151,7433696,7433689,'sio',10,1),(151,7433697,7433689,'ion',10,1),(151,7433698,7433689,'oni',10,1),(151,7433699,7433689,'nin',10,1),(151,7433700,7433689,'ing',10,1),(151,7433701,7433691,'yes',100,1),(151,7433702,7433701,'att',16.667,1),(151,7433703,7433701,'tta',16.667,1),(151,7433704,7433701,'tac',16.667,1),(151,7433705,7433701,'ach',16.667,1),(151,7433706,7433701,'che',16.667,1),(151,7433707,7433701,'hed',16.667,1),(151,7433708,7433702,'fil',20,1),(151,7433709,7433702,'ilt',20,1),(151,7433710,7433702,'lte',20,1),(151,7433711,7433702,'ter',20,1),(151,7433712,7433702,'ers',20,1),(151,7433713,7433708,'vaa',50,1),(151,7433714,7433708,'aai',50,1),(151,7433715,7433713,'unk',20,1),(151,7433716,7433713,'nkn',20,1),(151,7433717,7433713,'kno',20,1),(151,7433718,7433713,'now',20,1),(151,7433719,7433713,'own',20,1),(151,7433720,7433715,'oth',33.333,1),(151,7433721,7433715,'the',33.333,1),(151,7433722,7433715,'her',33.333,1),(151,7433723,7433720,'uid',50,1),(151,7433724,7433720,'ids',50,1),(151,7433725,7433723,'vml',100,1),(151,7433726,7433725,'dis',20,1),(151,7433727,7433725,'isp',20,1),(151,7433728,7433725,'spl',20,1),(151,7433729,7433725,'pla',20,1),(151,7433730,7433725,'lay',20,1),(151,7433731,7433726,'nam',50,1),(151,7433732,7433726,'ame',50,1),(152,7433734,7433733,'net',25,3),(152,7433735,7433733,'eta',25,3),(152,7433736,7433733,'tap',25,3),(152,7433737,7433733,'app',25,3),(152,7433738,7433734,'fib',33.333,2),(152,7433739,7433734,'ibr',33.333,2),(152,7433740,7433734,'bre',33.333,2),(152,7433741,7433738,'cha',20,2),(152,7433742,7433738,'han',20,2),(152,7433743,7433738,'ann',20,2),(152,7433744,7433738,'nne',20,2),(152,7433745,7433738,'nel',20,2),(152,7433746,7433741,'dis',50,2),(152,7433747,7433741,'isk',50,2),(152,7433748,7433746,'naa',100,4),(152,7433749,7433748,'600',3.333,4),(152,7433750,7433748,'00a',3.333,4),(152,7433751,7433748,'0a0',3.333,4),(152,7433752,7433748,'a09',3.333,4),(152,7433753,7433748,'098',3.333,4),(152,7433754,7433748,'980',3.333,4),(152,7433755,7433748,'804',3.333,4),(152,7433756,7433748,'044',3.333,4),(152,7433757,7433748,'443',3.333,4),(152,7433758,7433748,'430',3.333,4),(152,7433759,7433748,'307',3.333,4),(152,7433760,7433748,'075',3.333,4),(152,7433761,7433748,'753',3.333,4),(152,7433762,7433748,'535',3.333,4),(152,7433763,7433748,'357',3.333,4),(152,7433764,7433748,'573',3.333,4),(152,7433765,7433748,'732',3.333,4),(152,7433766,7433748,'32b',3.333,4),(152,7433767,7433748,'2b3',3.333,4),(152,7433768,7433748,'b33',3.333,4),(152,7433769,7433748,'334',3.333,4),(152,7433770,7433748,'345',3.333,4),(152,7433771,7433748,'457',3.333,4),(152,7433772,7433748,'571',3.333,4),(152,7433773,7433748,'715',3.333,4),(152,7433774,7433748,'152',3.333,4),(152,7433775,7433748,'527',3.333,4),(152,7433776,7433748,'275',3.333,4),(152,7433777,7433748,'753',3.333,4),(152,7433778,7433748,'539',3.333,4),(152,7433779,7433749,'ser',25,1),(152,7433780,7433749,'eri',25,1),(152,7433781,7433749,'ria',25,1),(152,7433782,7433749,'ial',25,1),(152,7433783,7433779,'siz',50,1),(152,7433784,7433779,'ize',50,1),(152,7433785,7433783,'460',33.333,1),(152,7433786,7433783,'608',33.333,1),(152,7433787,7433783,'080',33.333,1),(152,7433788,7433785,'dev',25,1),(152,7433789,7433785,'evi',25,1),(152,7433790,7433785,'vic',25,1),(152,7433791,7433785,'ice',25,1),(152,7433792,7433788,'typ',50,1),(152,7433793,7433788,'ype',50,1),(152,7433794,7433792,'dir',10,1),(152,7433795,7433792,'ire',10,1),(152,7433796,7433792,'rec',10,1),(152,7433797,7433792,'ect',10,1),(152,7433798,7433792,'cta',10,1),(152,7433799,7433792,'tac',10,1),(152,7433800,7433792,'acc',10,1),(152,7433801,7433792,'cce',10,1),(152,7433802,7433792,'ces',10,1),(152,7433803,7433792,'ess',10,1),(152,7433804,7433794,'mul',14.286,1),(152,7433805,7433794,'ult',14.286,1),(152,7433806,7433794,'lti',14.286,1),(152,7433807,7433794,'tip',14.286,1),(152,7433808,7433794,'ipa',14.286,1),(152,7433809,7433794,'pat',14.286,1),(152,7433810,7433794,'ath',14.286,1),(152,7433811,7433804,'plu',25,1),(152,7433812,7433804,'lug',25,1),(152,7433813,7433804,'ugi',25,1),(152,7433814,7433804,'gin',25,1),(152,7433815,7433811,'nmp',100,1),(152,7433816,7433815,'dev',33.333,1),(152,7433817,7433815,'evf',33.333,1),(152,7433818,7433815,'vfs',33.333,1),(152,7433819,7433816,'pat',50,1),(152,7433820,7433816,'ath',50,1),(152,7433821,7433819,'vmf',50,1),(152,7433822,7433819,'mfs',50,1),(152,7433823,7433821,'dev',20,1),(152,7433824,7433821,'evi',20,1),(152,7433825,7433821,'vic',20,1),(152,7433826,7433821,'ice',20,1),(152,7433827,7433821,'ces',20,1),(152,7433828,7433823,'dis',33.333,1),(152,7433829,7433823,'isk',33.333,1),(152,7433830,7433823,'sks',33.333,1),(152,7433831,7433828,'ven',25,1),(152,7433832,7433828,'end',25,1),(152,7433833,7433828,'ndo',25,1),(152,7433834,7433828,'dor',25,1),(152,7433835,7433831,'mod',33.333,1),(152,7433836,7433831,'ode',33.333,1),(152,7433837,7433831,'del',33.333,1),(152,7433838,7433835,'lun',100,1),(152,7433839,7433838,'cmo',33.333,1),(152,7433840,7433838,'mod',33.333,1),(152,7433841,7433838,'ode',33.333,1),(152,7433842,7433839,'rev',16.667,1),(152,7433843,7433839,'evi',16.667,1),(152,7433844,7433839,'vis',16.667,1),(152,7433845,7433839,'isi',16.667,1),(152,7433846,7433839,'sio',16.667,1),(152,7433847,7433839,'ion',16.667,1),(152,7433848,7433842,'810',50,1),(152,7433849,7433842,'100',50,1),(152,7433850,7433848,'scs',50,1),(152,7433851,7433848,'csi',50,1),(152,7433852,7433850,'lev',33.333,1),(152,7433853,7433850,'eve',33.333,1),(152,7433854,7433850,'vel',33.333,1),(152,7433855,7433852,'pse',25,1),(152,7433856,7433852,'seu',25,1),(152,7433857,7433852,'eud',25,1),(152,7433858,7433852,'udo',25,1),(152,7433859,7433855,'fal',33.333,6),(152,7433860,7433855,'als',33.333,6),(152,7433861,7433855,'lse',33.333,6),(152,7433862,7433859,'sta',25,3),(152,7433863,7433859,'tat',25,3),(152,7433864,7433859,'atu',25,3),(152,7433865,7433859,'tus',25,3),(152,7433866,7433862,'rdm',100,1),(152,7433867,7433866,'cap',20,1),(152,7433868,7433866,'apa',20,1),(152,7433869,7433866,'pab',20,1),(152,7433870,7433866,'abl',20,1),(152,7433871,7433866,'ble',20,1),(152,7433872,7433867,'tru',50,1),(152,7433873,7433867,'rue',50,1),(152,7433874,7433872,'loc',33.333,1),(152,7433875,7433872,'oca',33.333,1),(152,7433876,7433872,'cal',33.333,1),(152,7433877,7433874,'rem',14.286,1),(152,7433878,7433874,'emo',14.286,1),(152,7433879,7433874,'mov',14.286,1),(152,7433880,7433874,'ova',14.286,1),(152,7433881,7433874,'vab',14.286,1),(152,7433882,7433874,'abl',14.286,1),(152,7433883,7433874,'ble',14.286,1),(152,7433884,7433877,'ssd',100,1),(152,7433885,7433884,'off',20,1),(152,7433886,7433884,'ffl',20,1),(152,7433887,7433884,'fli',20,1),(152,7433888,7433884,'lin',20,1),(152,7433889,7433884,'ine',20,1),(152,7433890,7433885,'per',11.111,1),(152,7433891,7433885,'ere',11.111,1),(152,7433892,7433885,'ren',11.111,1),(152,7433893,7433885,'enn',11.111,1),(152,7433894,7433885,'nni',11.111,1),(152,7433895,7433885,'nia',11.111,1),(152,7433896,7433885,'ial',11.111,1),(152,7433897,7433885,'all',11.111,1),(152,7433898,7433885,'lly',11.111,1),(152,7433899,7433890,'res',16.667,1),(152,7433900,7433890,'ese',16.667,1),(152,7433901,7433890,'ser',16.667,1),(152,7433902,7433890,'erv',16.667,1),(152,7433903,7433890,'rve',16.667,1),(152,7433904,7433890,'ved',16.667,1),(152,7433905,7433899,'thi',50,1),(152,7433906,7433899,'hin',50,1),(152,7433907,7433905,'pro',10,1),(152,7433908,7433905,'rov',10,1),(152,7433909,7433905,'ovi',10,1),(152,7433910,7433905,'vis',10,1),(152,7433911,7433905,'isi',10,1),(152,7433912,7433905,'sio',10,1),(152,7433913,7433905,'ion',10,1),(152,7433914,7433905,'oni',10,1),(152,7433915,7433905,'nin',10,1),(152,7433916,7433905,'ing',10,1),(152,7433917,7433907,'yes',100,1),(152,7433918,7433917,'att',16.667,1),(152,7433919,7433917,'tta',16.667,1),(152,7433920,7433917,'tac',16.667,1),(152,7433921,7433917,'ach',16.667,1),(152,7433922,7433917,'che',16.667,1),(152,7433923,7433917,'hed',16.667,1),(152,7433924,7433918,'fil',20,1),(152,7433925,7433918,'ilt',20,1),(152,7433926,7433918,'lte',20,1),(152,7433927,7433918,'ter',20,1),(152,7433928,7433918,'ers',20,1),(152,7433929,7433924,'vaa',50,1),(152,7433930,7433924,'aai',50,1),(152,7433931,7433929,'unk',20,1),(152,7433932,7433929,'nkn',20,1),(152,7433933,7433929,'kno',20,1),(152,7433934,7433929,'now',20,1),(152,7433935,7433929,'own',20,1),(152,7433936,7433931,'oth',33.333,1),(152,7433937,7433931,'the',33.333,1),(152,7433938,7433931,'her',33.333,1),(152,7433939,7433936,'uid',50,1),(152,7433940,7433936,'ids',50,1),(152,7433941,7433939,'vml',100,1),(152,7433942,7433941,'dis',20,1),(152,7433943,7433941,'isp',20,1),(152,7433944,7433941,'spl',20,1),(152,7433945,7433941,'pla',20,1),(152,7433946,7433941,'lay',20,1),(152,7433947,7433942,'nam',50,1),(152,7433948,7433942,'ame',50,1),(153,7433950,7433949,'loc',33.333,3),(153,7433951,7433949,'oca',33.333,3),(153,7433952,7433949,'cal',33.333,3),(153,7433953,7433950,'lsi',100,3),(153,7433954,7433953,'dis',50,2),(153,7433955,7433953,'isk',50,2),(153,7433956,7433954,'naa',100,4),(153,7433957,7433956,'600',3.333,4),(153,7433958,7433956,'003',3.333,4),(153,7433959,7433956,'030',3.333,4),(153,7433960,7433956,'300',3.333,4),(153,7433961,7433956,'005',3.333,4),(153,7433962,7433956,'057',3.333,4),(153,7433963,7433956,'570',3.333,4),(153,7433964,7433956,'701',3.333,4),(153,7433965,7433956,'014',3.333,4),(153,7433966,7433956,'144',3.333,4),(153,7433967,7433956,'448',3.333,4),(153,7433968,7433956,'484',3.333,4),(153,7433969,7433956,'849',3.333,4),(153,7433970,7433956,'490',3.333,4),(153,7433971,7433956,'901',3.333,4),(153,7433972,7433956,'018',3.333,4),(153,7433973,7433956,'186',3.333,4),(153,7433974,7433956,'862',3.333,4),(153,7433975,7433956,'622',3.333,4),(153,7433976,7433956,'22c',3.333,4),(153,7433977,7433956,'2c7',3.333,4),(153,7433978,7433956,'c7f',3.333,4),(153,7433979,7433956,'7f0',3.333,4),(153,7433980,7433956,'f0b',3.333,4),(153,7433981,7433956,'0bb',3.333,4),(153,7433982,7433956,'bb6',3.333,4),(153,7433983,7433956,'b62',3.333,4),(153,7433984,7433956,'624',3.333,4),(153,7433985,7433956,'24f',3.333,4),(153,7433986,7433956,'4f8',3.333,4),(153,7433987,7433957,'ser',25,1),(153,7433988,7433957,'eri',25,1),(153,7433989,7433957,'ria',25,1),(153,7433990,7433957,'ial',25,1),(153,7433991,7433987,'siz',50,1),(153,7433992,7433987,'ize',50,1),(153,7433993,7433991,'571',25,1),(153,7433994,7433991,'711',25,1),(153,7433995,7433991,'113',25,1),(153,7433996,7433991,'136',25,1),(153,7433997,7433993,'dev',25,1),(153,7433998,7433993,'evi',25,1),(153,7433999,7433993,'vic',25,1),(153,7434000,7433993,'ice',25,1),(153,7434001,7433997,'typ',50,1),(153,7434002,7433997,'ype',50,1),(153,7434003,7434001,'dir',10,1),(153,7434004,7434001,'ire',10,1),(153,7434005,7434001,'rec',10,1),(153,7434006,7434001,'ect',10,1),(153,7434007,7434001,'cta',10,1),(153,7434008,7434001,'tac',10,1),(153,7434009,7434001,'acc',10,1),(153,7434010,7434001,'cce',10,1),(153,7434011,7434001,'ces',10,1),(153,7434012,7434001,'ess',10,1),(153,7434013,7434003,'mul',14.286,1),(153,7434014,7434003,'ult',14.286,1),(153,7434015,7434003,'lti',14.286,1),(153,7434016,7434003,'tip',14.286,1),(153,7434017,7434003,'ipa',14.286,1),(153,7434018,7434003,'pat',14.286,1),(153,7434019,7434003,'ath',14.286,1),(153,7434020,7434013,'plu',25,1),(153,7434021,7434013,'lug',25,1),(153,7434022,7434013,'ugi',25,1),(153,7434023,7434013,'gin',25,1),(153,7434024,7434020,'nmp',100,1),(153,7434025,7434024,'dev',33.333,1),(153,7434026,7434024,'evf',33.333,1),(153,7434027,7434024,'vfs',33.333,1),(153,7434028,7434025,'pat',50,1),(153,7434029,7434025,'ath',50,1),(153,7434030,7434028,'vmf',50,1),(153,7434031,7434028,'mfs',50,1),(153,7434032,7434030,'dev',20,1),(153,7434033,7434030,'evi',20,1),(153,7434034,7434030,'vic',20,1),(153,7434035,7434030,'ice',20,1),(153,7434036,7434030,'ces',20,1),(153,7434037,7434032,'dis',33.333,1),(153,7434038,7434032,'isk',33.333,1),(153,7434039,7434032,'sks',33.333,1),(153,7434040,7434037,'ven',25,1),(153,7434041,7434037,'end',25,1),(153,7434042,7434037,'ndo',25,1),(153,7434043,7434037,'dor',25,1),(153,7434044,7434040,'mod',33.333,1),(153,7434045,7434040,'ode',33.333,1),(153,7434046,7434040,'del',33.333,1),(153,7434047,7434044,'rai',50,1),(153,7434048,7434044,'aid',50,1),(153,7434049,7434047,'sas',100,1),(153,7434050,7434049,'rev',16.667,1),(153,7434051,7434049,'evi',16.667,1),(153,7434052,7434049,'vis',16.667,1),(153,7434053,7434049,'isi',16.667,1),(153,7434054,7434049,'sio',16.667,1),(153,7434055,7434049,'ion',16.667,1),(153,7434056,7434050,'scs',50,1),(153,7434057,7434050,'csi',50,1),(153,7434058,7434056,'lev',33.333,1),(153,7434059,7434056,'eve',33.333,1),(153,7434060,7434056,'vel',33.333,1),(153,7434061,7434058,'pse',25,1),(153,7434062,7434058,'seu',25,1),(153,7434063,7434058,'eud',25,1),(153,7434064,7434058,'udo',25,1),(153,7434065,7434061,'fal',33.333,6),(153,7434066,7434061,'als',33.333,6),(153,7434067,7434061,'lse',33.333,6),(153,7434068,7434065,'sta',25,3),(153,7434069,7434065,'tat',25,3),(153,7434070,7434065,'atu',25,3),(153,7434071,7434065,'tus',25,3),(153,7434072,7434068,'rdm',100,1),(153,7434073,7434072,'cap',20,1),(153,7434074,7434072,'apa',20,1),(153,7434075,7434072,'pab',20,1),(153,7434076,7434072,'abl',20,1),(153,7434077,7434072,'ble',20,1),(153,7434078,7434073,'tru',50,1),(153,7434079,7434073,'rue',50,1),(153,7434080,7434078,'rem',14.286,1),(153,7434081,7434078,'emo',14.286,1),(153,7434082,7434078,'mov',14.286,1),(153,7434083,7434078,'ova',14.286,1),(153,7434084,7434078,'vab',14.286,1),(153,7434085,7434078,'abl',14.286,1),(153,7434086,7434078,'ble',14.286,1),(153,7434087,7434080,'ssd',100,1),(153,7434088,7434087,'off',20,1),(153,7434089,7434087,'ffl',20,1),(153,7434090,7434087,'fli',20,1),(153,7434091,7434087,'lin',20,1),(153,7434092,7434087,'ine',20,1),(153,7434093,7434088,'per',11.111,1),(153,7434094,7434088,'ere',11.111,1),(153,7434095,7434088,'ren',11.111,1),(153,7434096,7434088,'enn',11.111,1),(153,7434097,7434088,'nni',11.111,1),(153,7434098,7434088,'nia',11.111,1),(153,7434099,7434088,'ial',11.111,1),(153,7434100,7434088,'all',11.111,1),(153,7434101,7434088,'lly',11.111,1),(153,7434102,7434093,'res',16.667,1),(153,7434103,7434093,'ese',16.667,1),(153,7434104,7434093,'ser',16.667,1),(153,7434105,7434093,'erv',16.667,1),(153,7434106,7434093,'rve',16.667,1),(153,7434107,7434093,'ved',16.667,1),(153,7434108,7434102,'thi',50,1),(153,7434109,7434102,'hin',50,1),(153,7434110,7434108,'pro',10,1),(153,7434111,7434108,'rov',10,1),(153,7434112,7434108,'ovi',10,1),(153,7434113,7434108,'vis',10,1),(153,7434114,7434108,'isi',10,1),(153,7434115,7434108,'sio',10,1),(153,7434116,7434108,'ion',10,1),(153,7434117,7434108,'oni',10,1),(153,7434118,7434108,'nin',10,1),(153,7434119,7434108,'ing',10,1),(153,7434120,7434110,'unk',20,1),(153,7434121,7434110,'nkn',20,1),(153,7434122,7434110,'kno',20,1),(153,7434123,7434110,'now',20,1),(153,7434124,7434110,'own',20,1),(153,7434125,7434120,'att',16.667,1),(153,7434126,7434120,'tta',16.667,1),(153,7434127,7434120,'tac',16.667,1),(153,7434128,7434120,'ach',16.667,1),(153,7434129,7434120,'che',16.667,1),(153,7434130,7434120,'hed',16.667,1),(153,7434131,7434125,'fil',20,1),(153,7434132,7434125,'ilt',20,1),(153,7434133,7434125,'lte',20,1),(153,7434134,7434125,'ter',20,1),(153,7434135,7434125,'ers',20,1),(153,7434136,7434131,'vaa',50,1),(153,7434137,7434131,'aai',50,1),(153,7434138,7434136,'uns',11.111,1),(153,7434139,7434136,'nsu',11.111,1),(153,7434140,7434136,'sup',11.111,1),(153,7434141,7434136,'upp',11.111,1),(153,7434142,7434136,'ppo',11.111,1),(153,7434143,7434136,'por',11.111,1),(153,7434144,7434136,'ort',11.111,1),(153,7434145,7434136,'rte',11.111,1),(153,7434146,7434136,'ted',11.111,1),(153,7434147,7434138,'oth',33.333,1),(153,7434148,7434138,'the',33.333,1),(153,7434149,7434138,'her',33.333,1),(153,7434150,7434147,'uid',50,1),(153,7434151,7434147,'ids',50,1),(153,7434152,7434150,'vml',100,1),(153,7434153,7434152,'dis',20,1),(153,7434154,7434152,'isp',20,1),(153,7434155,7434152,'spl',20,1),(153,7434156,7434152,'pla',20,1),(153,7434157,7434152,'lay',20,1),(153,7434158,7434153,'nam',50,1),(153,7434159,7434153,'ame',50,1),(154,7434161,7434160,'net',25,3),(154,7434162,7434160,'eta',25,3),(154,7434163,7434160,'tap',25,3),(154,7434164,7434160,'app',25,3),(154,7434165,7434161,'ser',25,3),(154,7434166,7434161,'eri',25,3),(154,7434167,7434161,'ria',25,3),(154,7434168,7434161,'ial',25,3),(154,7434169,7434165,'att',16.667,3),(154,7434170,7434165,'tta',16.667,3),(154,7434171,7434165,'tac',16.667,3),(154,7434172,7434165,'ach',16.667,3),(154,7434173,7434165,'che',16.667,3),(154,7434174,7434165,'hed',16.667,3),(154,7434175,7434169,'scs',50,3),(154,7434176,7434169,'csi',50,3),(154,7434177,7434175,'dis',50,2),(154,7434178,7434175,'isk',50,2),(154,7434179,7434177,'naa',100,4),(154,7434180,7434179,'600',3.333,4),(154,7434181,7434179,'00a',3.333,4),(154,7434182,7434179,'0a0',3.333,4),(154,7434183,7434179,'a09',3.333,4),(154,7434184,7434179,'098',3.333,4),(154,7434185,7434179,'980',3.333,4),(154,7434186,7434179,'80f',3.333,4),(154,7434187,7434179,'0f8',3.333,4),(154,7434188,7434179,'f87',3.333,4),(154,7434189,7434179,'879',3.333,4),(154,7434190,7434179,'798',3.333,4),(154,7434191,7434179,'984',3.333,4),(154,7434192,7434179,'84e',3.333,4),(154,7434193,7434179,'4ee',3.333,4),(154,7434194,7434179,'ee8',3.333,4),(154,7434195,7434179,'e8e',3.333,4),(154,7434196,7434179,'8e5',3.333,4),(154,7434197,7434179,'e52',3.333,4),(154,7434198,7434179,'524',3.333,4),(154,7434199,7434179,'24c',3.333,4),(154,7434200,7434179,'4c1',3.333,4),(154,7434201,7434179,'c11',3.333,4),(154,7434202,7434179,'117',3.333,4),(154,7434203,7434179,'17b',3.333,4),(154,7434204,7434179,'7b0',3.333,4),(154,7434205,7434179,'b0e',3.333,4),(154,7434206,7434179,'0ea',3.333,4),(154,7434207,7434179,'eab',3.333,4),(154,7434208,7434179,'aba',3.333,4),(154,7434209,7434179,'ba2',3.333,4),(154,7434210,7434180,'siz',50,1),(154,7434211,7434180,'ize',50,1),(154,7434212,7434210,'163',33.333,1),(154,7434213,7434210,'638',33.333,1),(154,7434214,7434210,'384',33.333,1),(154,7434215,7434212,'dev',25,1),(154,7434216,7434212,'evi',25,1),(154,7434217,7434212,'vic',25,1),(154,7434218,7434212,'ice',25,1),(154,7434219,7434215,'typ',50,1),(154,7434220,7434215,'ype',50,1),(154,7434221,7434219,'dir',10,1),(154,7434222,7434219,'ire',10,1),(154,7434223,7434219,'rec',10,1),(154,7434224,7434219,'ect',10,1),(154,7434225,7434219,'cta',10,1),(154,7434226,7434219,'tac',10,1),(154,7434227,7434219,'acc',10,1),(154,7434228,7434219,'cce',10,1),(154,7434229,7434219,'ces',10,1),(154,7434230,7434219,'ess',10,1),(154,7434231,7434221,'mul',14.286,1),(154,7434232,7434221,'ult',14.286,1),(154,7434233,7434221,'lti',14.286,1),(154,7434234,7434221,'tip',14.286,1),(154,7434235,7434221,'ipa',14.286,1),(154,7434236,7434221,'pat',14.286,1),(154,7434237,7434221,'ath',14.286,1),(154,7434238,7434231,'plu',25,1),(154,7434239,7434231,'lug',25,1),(154,7434240,7434231,'ugi',25,1),(154,7434241,7434231,'gin',25,1),(154,7434242,7434238,'nmp',100,1),(154,7434243,7434242,'dev',33.333,1),(154,7434244,7434242,'evf',33.333,1),(154,7434245,7434242,'vfs',33.333,1),(154,7434246,7434243,'pat',50,1),(154,7434247,7434243,'ath',50,1),(154,7434248,7434246,'vmf',50,1),(154,7434249,7434246,'mfs',50,1),(154,7434250,7434248,'dev',20,1),(154,7434251,7434248,'evi',20,1),(154,7434252,7434248,'vic',20,1),(154,7434253,7434248,'ice',20,1),(154,7434254,7434248,'ces',20,1),(154,7434255,7434250,'dis',33.333,1),(154,7434256,7434250,'isk',33.333,1),(154,7434257,7434250,'sks',33.333,1),(154,7434258,7434255,'ven',25,1),(154,7434259,7434255,'end',25,1),(154,7434260,7434255,'ndo',25,1),(154,7434261,7434255,'dor',25,1),(154,7434262,7434258,'mod',33.333,1),(154,7434263,7434258,'ode',33.333,1),(154,7434264,7434258,'del',33.333,1),(154,7434265,7434262,'fla',33.333,1),(154,7434266,7434262,'las',33.333,1),(154,7434267,7434262,'ash',33.333,1),(154,7434268,7434265,'acc',33.333,1),(154,7434269,7434265,'cce',33.333,1),(154,7434270,7434265,'cel',33.333,1),(154,7434271,7434268,'rev',16.667,1),(154,7434272,7434268,'evi',16.667,1),(154,7434273,7434268,'vis',16.667,1),(154,7434274,7434268,'isi',16.667,1),(154,7434275,7434268,'sio',16.667,1),(154,7434276,7434268,'ion',16.667,1),(154,7434277,7434271,'lev',33.333,1),(154,7434278,7434271,'eve',33.333,1),(154,7434279,7434271,'vel',33.333,1),(154,7434280,7434277,'pse',25,1),(154,7434281,7434277,'seu',25,1),(154,7434282,7434277,'eud',25,1),(154,7434283,7434277,'udo',25,1),(154,7434284,7434280,'fal',33.333,5),(154,7434285,7434280,'als',33.333,5),(154,7434286,7434280,'lse',33.333,5),(154,7434287,7434284,'sta',25,3),(154,7434288,7434284,'tat',25,3),(154,7434289,7434284,'atu',25,3),(154,7434290,7434284,'tus',25,3),(154,7434291,7434287,'deg',16.667,1),(154,7434292,7434287,'egr',16.667,1),(154,7434293,7434287,'gra',16.667,1),(154,7434294,7434287,'rad',16.667,1),(154,7434295,7434287,'ade',16.667,1),(154,7434296,7434287,'ded',16.667,1),(154,7434297,7434291,'rdm',100,1),(154,7434298,7434297,'cap',20,1),(154,7434299,7434297,'apa',20,1),(154,7434300,7434297,'pab',20,1),(154,7434301,7434297,'abl',20,1),(154,7434302,7434297,'ble',20,1),(154,7434303,7434298,'tru',50,2),(154,7434304,7434298,'rue',50,2),(154,7434305,7434303,'loc',33.333,1),(154,7434306,7434303,'oca',33.333,1),(154,7434307,7434303,'cal',33.333,1),(154,7434308,7434305,'rem',14.286,1),(154,7434309,7434305,'emo',14.286,1),(154,7434310,7434305,'mov',14.286,1),(154,7434311,7434305,'ova',14.286,1),(154,7434312,7434305,'vab',14.286,1),(154,7434313,7434305,'abl',14.286,1),(154,7434314,7434305,'ble',14.286,1),(154,7434315,7434308,'ssd',100,1),(154,7434316,7434315,'off',20,1),(154,7434317,7434315,'ffl',20,1),(154,7434318,7434315,'fli',20,1),(154,7434319,7434315,'lin',20,1),(154,7434320,7434315,'ine',20,1),(154,7434321,7434316,'per',11.111,1),(154,7434322,7434316,'ere',11.111,1),(154,7434323,7434316,'ren',11.111,1),(154,7434324,7434316,'enn',11.111,1),(154,7434325,7434316,'nni',11.111,1),(154,7434326,7434316,'nia',11.111,1),(154,7434327,7434316,'ial',11.111,1),(154,7434328,7434316,'all',11.111,1),(154,7434329,7434316,'lly',11.111,1),(154,7434330,7434321,'res',16.667,1),(154,7434331,7434321,'ese',16.667,1),(154,7434332,7434321,'ser',16.667,1),(154,7434333,7434321,'erv',16.667,1),(154,7434334,7434321,'rve',16.667,1),(154,7434335,7434321,'ved',16.667,1),(154,7434336,7434330,'thi',50,1),(154,7434337,7434330,'hin',50,1),(154,7434338,7434336,'pro',10,1),(154,7434339,7434336,'rov',10,1),(154,7434340,7434336,'ovi',10,1),(154,7434341,7434336,'vis',10,1),(154,7434342,7434336,'isi',10,1),(154,7434343,7434336,'sio',10,1),(154,7434344,7434336,'ion',10,1),(154,7434345,7434336,'oni',10,1),(154,7434346,7434336,'nin',10,1),(154,7434347,7434336,'ing',10,1),(154,7434348,7434338,'unk',20,1),(154,7434349,7434338,'nkn',20,1),(154,7434350,7434338,'kno',20,1),(154,7434351,7434338,'now',20,1),(154,7434352,7434338,'own',20,1),(154,7434353,7434348,'fil',20,1),(154,7434354,7434348,'ilt',20,1),(154,7434355,7434348,'lte',20,1),(154,7434356,7434348,'ter',20,1),(154,7434357,7434348,'ers',20,1),(154,7434358,7434353,'vaa',50,1),(154,7434359,7434353,'aai',50,1),(154,7434360,7434358,'uns',11.111,1),(154,7434361,7434358,'nsu',11.111,1),(154,7434362,7434358,'sup',11.111,1),(154,7434363,7434358,'upp',11.111,1),(154,7434364,7434358,'ppo',11.111,1),(154,7434365,7434358,'por',11.111,1),(154,7434366,7434358,'ort',11.111,1),(154,7434367,7434358,'rte',11.111,1),(154,7434368,7434358,'ted',11.111,1),(154,7434369,7434360,'oth',33.333,1),(154,7434370,7434360,'the',33.333,1),(154,7434371,7434360,'her',33.333,1),(154,7434372,7434369,'uid',50,1),(154,7434373,7434369,'ids',50,1),(154,7434374,7434372,'vml',100,1),(154,7434375,7434374,'dis',20,1),(154,7434376,7434374,'isp',20,1),(154,7434377,7434374,'spl',20,1),(154,7434378,7434374,'pla',20,1),(154,7434379,7434374,'lay',20,1),(154,7434380,7434375,'nam',50,1),(154,7434381,7434375,'ame',50,1),(155,7434383,7434382,'net',25,3),(155,7434384,7434382,'eta',25,3),(155,7434385,7434382,'tap',25,3),(155,7434386,7434382,'app',25,3),(155,7434387,7434383,'fib',33.333,2),(155,7434388,7434383,'ibr',33.333,2),(155,7434389,7434383,'bre',33.333,2),(155,7434390,7434387,'cha',20,2),(155,7434391,7434387,'han',20,2),(155,7434392,7434387,'ann',20,2),(155,7434393,7434387,'nne',20,2),(155,7434394,7434387,'nel',20,2),(155,7434395,7434390,'dis',50,2),(155,7434396,7434390,'isk',50,2),(155,7434397,7434395,'naa',100,4),(155,7434398,7434397,'600',3.333,4),(155,7434399,7434397,'00a',3.333,4),(155,7434400,7434397,'0a0',3.333,4),(155,7434401,7434397,'a09',3.333,4),(155,7434402,7434397,'098',3.333,4),(155,7434403,7434397,'980',3.333,4),(155,7434404,7434397,'804',3.333,4),(155,7434405,7434397,'044',3.333,4),(155,7434406,7434397,'443',3.333,4),(155,7434407,7434397,'430',3.333,4),(155,7434408,7434397,'307',3.333,4),(155,7434409,7434397,'075',3.333,4),(155,7434410,7434397,'753',3.333,4),(155,7434411,7434397,'535',3.333,4),(155,7434412,7434397,'357',3.333,4),(155,7434413,7434397,'573',3.333,4),(155,7434414,7434397,'732',3.333,4),(155,7434415,7434397,'32b',3.333,4),(155,7434416,7434397,'2b3',3.333,4),(155,7434417,7434397,'b33',3.333,4),(155,7434418,7434397,'334',3.333,4),(155,7434419,7434397,'345',3.333,4),(155,7434420,7434397,'457',3.333,4),(155,7434421,7434397,'571',3.333,4),(155,7434422,7434397,'715',3.333,4),(155,7434423,7434397,'153',3.333,4),(155,7434424,7434397,'533',3.333,4),(155,7434425,7434397,'335',3.333,4),(155,7434426,7434397,'357',3.333,4),(155,7434427,7434397,'57a',3.333,4),(155,7434428,7434398,'ser',25,1),(155,7434429,7434398,'eri',25,1),(155,7434430,7434398,'ria',25,1),(155,7434431,7434398,'ial',25,1),(155,7434432,7434428,'siz',50,1),(155,7434433,7434428,'ize',50,1),(155,7434434,7434432,'321',100,1),(155,7434435,7434434,'dev',25,1),(155,7434436,7434434,'evi',25,1),(155,7434437,7434434,'vic',25,1),(155,7434438,7434434,'ice',25,1),(155,7434439,7434435,'typ',50,1),(155,7434440,7434435,'ype',50,1),(155,7434441,7434439,'dir',10,1),(155,7434442,7434439,'ire',10,1),(155,7434443,7434439,'rec',10,1),(155,7434444,7434439,'ect',10,1),(155,7434445,7434439,'cta',10,1),(155,7434446,7434439,'tac',10,1),(155,7434447,7434439,'acc',10,1),(155,7434448,7434439,'cce',10,1),(155,7434449,7434439,'ces',10,1),(155,7434450,7434439,'ess',10,1),(155,7434451,7434441,'mul',14.286,1),(155,7434452,7434441,'ult',14.286,1),(155,7434453,7434441,'lti',14.286,1),(155,7434454,7434441,'tip',14.286,1),(155,7434455,7434441,'ipa',14.286,1),(155,7434456,7434441,'pat',14.286,1),(155,7434457,7434441,'ath',14.286,1),(155,7434458,7434451,'plu',25,1),(155,7434459,7434451,'lug',25,1),(155,7434460,7434451,'ugi',25,1),(155,7434461,7434451,'gin',25,1),(155,7434462,7434458,'nmp',100,1),(155,7434463,7434462,'dev',33.333,1),(155,7434464,7434462,'evf',33.333,1),(155,7434465,7434462,'vfs',33.333,1),(155,7434466,7434463,'pat',50,1),(155,7434467,7434463,'ath',50,1),(155,7434468,7434466,'vmf',50,1),(155,7434469,7434466,'mfs',50,1),(155,7434470,7434468,'dev',20,1),(155,7434471,7434468,'evi',20,1),(155,7434472,7434468,'vic',20,1),(155,7434473,7434468,'ice',20,1),(155,7434474,7434468,'ces',20,1),(155,7434475,7434470,'dis',33.333,1),(155,7434476,7434470,'isk',33.333,1),(155,7434477,7434470,'sks',33.333,1),(155,7434478,7434475,'ven',25,1),(155,7434479,7434475,'end',25,1),(155,7434480,7434475,'ndo',25,1),(155,7434481,7434475,'dor',25,1),(155,7434482,7434478,'mod',33.333,1),(155,7434483,7434478,'ode',33.333,1),(155,7434484,7434478,'del',33.333,1),(155,7434485,7434482,'lun',100,1),(155,7434486,7434485,'cmo',33.333,1),(155,7434487,7434485,'mod',33.333,1),(155,7434488,7434485,'ode',33.333,1),(155,7434489,7434486,'rev',16.667,1),(155,7434490,7434486,'evi',16.667,1),(155,7434491,7434486,'vis',16.667,1),(155,7434492,7434486,'isi',16.667,1),(155,7434493,7434486,'sio',16.667,1),(155,7434494,7434486,'ion',16.667,1),(155,7434495,7434489,'810',50,1),(155,7434496,7434489,'100',50,1),(155,7434497,7434495,'scs',50,1),(155,7434498,7434495,'csi',50,1),(155,7434499,7434497,'lev',33.333,1),(155,7434500,7434497,'eve',33.333,1),(155,7434501,7434497,'vel',33.333,1),(155,7434502,7434499,'pse',25,1),(155,7434503,7434499,'seu',25,1),(155,7434504,7434499,'eud',25,1),(155,7434505,7434499,'udo',25,1),(155,7434506,7434502,'fal',33.333,6),(155,7434507,7434502,'als',33.333,6),(155,7434508,7434502,'lse',33.333,6),(155,7434509,7434506,'sta',25,3),(155,7434510,7434506,'tat',25,3),(155,7434511,7434506,'atu',25,3),(155,7434512,7434506,'tus',25,3),(155,7434513,7434509,'rdm',100,1),(155,7434514,7434513,'cap',20,1),(155,7434515,7434513,'apa',20,1),(155,7434516,7434513,'pab',20,1),(155,7434517,7434513,'abl',20,1),(155,7434518,7434513,'ble',20,1),(155,7434519,7434514,'tru',50,1),(155,7434520,7434514,'rue',50,1),(155,7434521,7434519,'loc',33.333,1),(155,7434522,7434519,'oca',33.333,1),(155,7434523,7434519,'cal',33.333,1),(155,7434524,7434521,'rem',14.286,1),(155,7434525,7434521,'emo',14.286,1),(155,7434526,7434521,'mov',14.286,1),(155,7434527,7434521,'ova',14.286,1),(155,7434528,7434521,'vab',14.286,1),(155,7434529,7434521,'abl',14.286,1),(155,7434530,7434521,'ble',14.286,1),(155,7434531,7434524,'ssd',100,1),(155,7434532,7434531,'off',20,1),(155,7434533,7434531,'ffl',20,1),(155,7434534,7434531,'fli',20,1),(155,7434535,7434531,'lin',20,1),(155,7434536,7434531,'ine',20,1),(155,7434537,7434532,'per',11.111,1),(155,7434538,7434532,'ere',11.111,1),(155,7434539,7434532,'ren',11.111,1),(155,7434540,7434532,'enn',11.111,1),(155,7434541,7434532,'nni',11.111,1),(155,7434542,7434532,'nia',11.111,1),(155,7434543,7434532,'ial',11.111,1),(155,7434544,7434532,'all',11.111,1),(155,7434545,7434532,'lly',11.111,1),(155,7434546,7434537,'res',16.667,1),(155,7434547,7434537,'ese',16.667,1),(155,7434548,7434537,'ser',16.667,1),(155,7434549,7434537,'erv',16.667,1),(155,7434550,7434537,'rve',16.667,1),(155,7434551,7434537,'ved',16.667,1),(155,7434552,7434546,'thi',50,1),(155,7434553,7434546,'hin',50,1),(155,7434554,7434552,'pro',10,1),(155,7434555,7434552,'rov',10,1),(155,7434556,7434552,'ovi',10,1),(155,7434557,7434552,'vis',10,1),(155,7434558,7434552,'isi',10,1),(155,7434559,7434552,'sio',10,1),(155,7434560,7434552,'ion',10,1),(155,7434561,7434552,'oni',10,1),(155,7434562,7434552,'nin',10,1),(155,7434563,7434552,'ing',10,1),(155,7434564,7434554,'yes',100,1),(155,7434565,7434564,'att',16.667,1),(155,7434566,7434564,'tta',16.667,1),(155,7434567,7434564,'tac',16.667,1),(155,7434568,7434564,'ach',16.667,1),(155,7434569,7434564,'che',16.667,1),(155,7434570,7434564,'hed',16.667,1),(155,7434571,7434565,'fil',20,1),(155,7434572,7434565,'ilt',20,1),(155,7434573,7434565,'lte',20,1),(155,7434574,7434565,'ter',20,1),(155,7434575,7434565,'ers',20,1),(155,7434576,7434571,'vaa',50,1),(155,7434577,7434571,'aai',50,1),(155,7434578,7434576,'unk',20,1),(155,7434579,7434576,'nkn',20,1),(155,7434580,7434576,'kno',20,1),(155,7434581,7434576,'now',20,1),(155,7434582,7434576,'own',20,1),(155,7434583,7434578,'oth',33.333,1),(155,7434584,7434578,'the',33.333,1),(155,7434585,7434578,'her',33.333,1),(155,7434586,7434583,'uid',50,1),(155,7434587,7434583,'ids',50,1),(155,7434588,7434586,'vml',100,1),(155,7434589,7434588,'dis',20,1),(155,7434590,7434588,'isp',20,1),(155,7434591,7434588,'spl',20,1),(155,7434592,7434588,'pla',20,1),(155,7434593,7434588,'lay',20,1),(155,7434594,7434589,'nam',50,1),(155,7434595,7434589,'ame',50,1),(156,7434597,7434596,'net',25,3),(156,7434598,7434596,'eta',25,3),(156,7434599,7434596,'tap',25,3),(156,7434600,7434596,'app',25,3),(156,7434601,7434597,'fib',33.333,2),(156,7434602,7434597,'ibr',33.333,2),(156,7434603,7434597,'bre',33.333,2),(156,7434604,7434601,'cha',20,2),(156,7434605,7434601,'han',20,2),(156,7434606,7434601,'ann',20,2),(156,7434607,7434601,'nne',20,2),(156,7434608,7434601,'nel',20,2),(156,7434609,7434604,'dis',50,2),(156,7434610,7434604,'isk',50,2),(156,7434611,7434609,'naa',100,4),(156,7434612,7434611,'600',3.333,4),(156,7434613,7434611,'00a',3.333,4),(156,7434614,7434611,'0a0',3.333,4),(156,7434615,7434611,'a09',3.333,4),(156,7434616,7434611,'098',3.333,4),(156,7434617,7434611,'980',3.333,4),(156,7434618,7434611,'804',3.333,4),(156,7434619,7434611,'044',3.333,4),(156,7434620,7434611,'443',3.333,4),(156,7434621,7434611,'430',3.333,4),(156,7434622,7434611,'307',3.333,4),(156,7434623,7434611,'075',3.333,4),(156,7434624,7434611,'753',3.333,4),(156,7434625,7434611,'535',3.333,4),(156,7434626,7434611,'357',3.333,4),(156,7434627,7434611,'573',3.333,4),(156,7434628,7434611,'732',3.333,4),(156,7434629,7434611,'32b',3.333,4),(156,7434630,7434611,'2b3',3.333,4),(156,7434631,7434611,'b33',3.333,4),(156,7434632,7434611,'334',3.333,4),(156,7434633,7434611,'345',3.333,4),(156,7434634,7434611,'457',3.333,4),(156,7434635,7434611,'571',3.333,4),(156,7434636,7434611,'715',3.333,4),(156,7434637,7434611,'153',3.333,4),(156,7434638,7434611,'533',3.333,4),(156,7434639,7434611,'336',3.333,4),(156,7434640,7434611,'365',3.333,4),(156,7434641,7434611,'65a',3.333,4),(156,7434642,7434612,'ser',25,1),(156,7434643,7434612,'eri',25,1),(156,7434644,7434612,'ria',25,1),(156,7434645,7434612,'ial',25,1),(156,7434646,7434642,'siz',50,1),(156,7434647,7434642,'ize',50,1),(156,7434648,7434646,'321',100,1),(156,7434649,7434648,'dev',25,1),(156,7434650,7434648,'evi',25,1),(156,7434651,7434648,'vic',25,1),(156,7434652,7434648,'ice',25,1),(156,7434653,7434649,'typ',50,1),(156,7434654,7434649,'ype',50,1),(156,7434655,7434653,'dir',10,1),(156,7434656,7434653,'ire',10,1),(156,7434657,7434653,'rec',10,1),(156,7434658,7434653,'ect',10,1),(156,7434659,7434653,'cta',10,1),(156,7434660,7434653,'tac',10,1),(156,7434661,7434653,'acc',10,1),(156,7434662,7434653,'cce',10,1),(156,7434663,7434653,'ces',10,1),(156,7434664,7434653,'ess',10,1),(156,7434665,7434655,'mul',14.286,1),(156,7434666,7434655,'ult',14.286,1),(156,7434667,7434655,'lti',14.286,1),(156,7434668,7434655,'tip',14.286,1),(156,7434669,7434655,'ipa',14.286,1),(156,7434670,7434655,'pat',14.286,1),(156,7434671,7434655,'ath',14.286,1),(156,7434672,7434665,'plu',25,1),(156,7434673,7434665,'lug',25,1),(156,7434674,7434665,'ugi',25,1),(156,7434675,7434665,'gin',25,1),(156,7434676,7434672,'nmp',100,1),(156,7434677,7434676,'dev',33.333,1),(156,7434678,7434676,'evf',33.333,1),(156,7434679,7434676,'vfs',33.333,1),(156,7434680,7434677,'pat',50,1),(156,7434681,7434677,'ath',50,1),(156,7434682,7434680,'vmf',50,1),(156,7434683,7434680,'mfs',50,1),(156,7434684,7434682,'dev',20,1),(156,7434685,7434682,'evi',20,1),(156,7434686,7434682,'vic',20,1),(156,7434687,7434682,'ice',20,1),(156,7434688,7434682,'ces',20,1),(156,7434689,7434684,'dis',33.333,1),(156,7434690,7434684,'isk',33.333,1),(156,7434691,7434684,'sks',33.333,1),(156,7434692,7434689,'ven',25,1),(156,7434693,7434689,'end',25,1),(156,7434694,7434689,'ndo',25,1),(156,7434695,7434689,'dor',25,1),(156,7434696,7434692,'mod',33.333,1),(156,7434697,7434692,'ode',33.333,1),(156,7434698,7434692,'del',33.333,1),(156,7434699,7434696,'lun',100,1),(156,7434700,7434699,'cmo',33.333,1),(156,7434701,7434699,'mod',33.333,1),(156,7434702,7434699,'ode',33.333,1),(156,7434703,7434700,'rev',16.667,1),(156,7434704,7434700,'evi',16.667,1),(156,7434705,7434700,'vis',16.667,1),(156,7434706,7434700,'isi',16.667,1),(156,7434707,7434700,'sio',16.667,1),(156,7434708,7434700,'ion',16.667,1),(156,7434709,7434703,'810',50,1),(156,7434710,7434703,'100',50,1),(156,7434711,7434709,'scs',50,1),(156,7434712,7434709,'csi',50,1),(156,7434713,7434711,'lev',33.333,1),(156,7434714,7434711,'eve',33.333,1),(156,7434715,7434711,'vel',33.333,1),(156,7434716,7434713,'pse',25,1),(156,7434717,7434713,'seu',25,1),(156,7434718,7434713,'eud',25,1),(156,7434719,7434713,'udo',25,1),(156,7434720,7434716,'fal',33.333,6),(156,7434721,7434716,'als',33.333,6),(156,7434722,7434716,'lse',33.333,6),(156,7434723,7434720,'sta',25,3),(156,7434724,7434720,'tat',25,3),(156,7434725,7434720,'atu',25,3),(156,7434726,7434720,'tus',25,3),(156,7434727,7434723,'rdm',100,1),(156,7434728,7434727,'cap',20,1),(156,7434729,7434727,'apa',20,1),(156,7434730,7434727,'pab',20,1),(156,7434731,7434727,'abl',20,1),(156,7434732,7434727,'ble',20,1),(156,7434733,7434728,'tru',50,1),(156,7434734,7434728,'rue',50,1),(156,7434735,7434733,'loc',33.333,1),(156,7434736,7434733,'oca',33.333,1),(156,7434737,7434733,'cal',33.333,1),(156,7434738,7434735,'rem',14.286,1),(156,7434739,7434735,'emo',14.286,1),(156,7434740,7434735,'mov',14.286,1),(156,7434741,7434735,'ova',14.286,1),(156,7434742,7434735,'vab',14.286,1),(156,7434743,7434735,'abl',14.286,1),(156,7434744,7434735,'ble',14.286,1),(156,7434745,7434738,'ssd',100,1),(156,7434746,7434745,'off',20,1),(156,7434747,7434745,'ffl',20,1),(156,7434748,7434745,'fli',20,1),(156,7434749,7434745,'lin',20,1),(156,7434750,7434745,'ine',20,1),(156,7434751,7434746,'per',11.111,1),(156,7434752,7434746,'ere',11.111,1),(156,7434753,7434746,'ren',11.111,1),(156,7434754,7434746,'enn',11.111,1),(156,7434755,7434746,'nni',11.111,1),(156,7434756,7434746,'nia',11.111,1),(156,7434757,7434746,'ial',11.111,1),(156,7434758,7434746,'all',11.111,1),(156,7434759,7434746,'lly',11.111,1),(156,7434760,7434751,'res',16.667,1),(156,7434761,7434751,'ese',16.667,1),(156,7434762,7434751,'ser',16.667,1),(156,7434763,7434751,'erv',16.667,1),(156,7434764,7434751,'rve',16.667,1),(156,7434765,7434751,'ved',16.667,1),(156,7434766,7434760,'thi',50,1),(156,7434767,7434760,'hin',50,1),(156,7434768,7434766,'pro',10,1),(156,7434769,7434766,'rov',10,1),(156,7434770,7434766,'ovi',10,1),(156,7434771,7434766,'vis',10,1),(156,7434772,7434766,'isi',10,1),(156,7434773,7434766,'sio',10,1),(156,7434774,7434766,'ion',10,1),(156,7434775,7434766,'oni',10,1),(156,7434776,7434766,'nin',10,1),(156,7434777,7434766,'ing',10,1),(156,7434778,7434768,'yes',100,1),(156,7434779,7434778,'att',16.667,1),(156,7434780,7434778,'tta',16.667,1),(156,7434781,7434778,'tac',16.667,1),(156,7434782,7434778,'ach',16.667,1),(156,7434783,7434778,'che',16.667,1),(156,7434784,7434778,'hed',16.667,1),(156,7434785,7434779,'fil',20,1),(156,7434786,7434779,'ilt',20,1),(156,7434787,7434779,'lte',20,1),(156,7434788,7434779,'ter',20,1),(156,7434789,7434779,'ers',20,1),(156,7434790,7434785,'vaa',50,1),(156,7434791,7434785,'aai',50,1),(156,7434792,7434790,'unk',20,1),(156,7434793,7434790,'nkn',20,1),(156,7434794,7434790,'kno',20,1),(156,7434795,7434790,'now',20,1),(156,7434796,7434790,'own',20,1),(156,7434797,7434792,'oth',33.333,1),(156,7434798,7434792,'the',33.333,1),(156,7434799,7434792,'her',33.333,1),(156,7434800,7434797,'uid',50,1),(156,7434801,7434797,'ids',50,1),(156,7434802,7434800,'vml',100,1),(156,7434803,7434802,'dis',20,1),(156,7434804,7434802,'isp',20,1),(156,7434805,7434802,'spl',20,1),(156,7434806,7434802,'pla',20,1),(156,7434807,7434802,'lay',20,1),(156,7434808,7434803,'nam',50,1),(156,7434809,7434803,'ame',50,1),(157,7434811,7434810,'net',25,3),(157,7434812,7434810,'eta',25,3),(157,7434813,7434810,'tap',25,3),(157,7434814,7434810,'app',25,3),(157,7434815,7434811,'fib',33.333,2),(157,7434816,7434811,'ibr',33.333,2),(157,7434817,7434811,'bre',33.333,2),(157,7434818,7434815,'cha',20,2),(157,7434819,7434815,'han',20,2),(157,7434820,7434815,'ann',20,2),(157,7434821,7434815,'nne',20,2),(157,7434822,7434815,'nel',20,2),(157,7434823,7434818,'dis',50,2),(157,7434824,7434818,'isk',50,2),(157,7434825,7434823,'naa',100,4),(157,7434826,7434825,'600',3.333,4),(157,7434827,7434825,'00a',3.333,4),(157,7434828,7434825,'0a0',3.333,4),(157,7434829,7434825,'a09',3.333,4),(157,7434830,7434825,'098',3.333,4),(157,7434831,7434825,'980',3.333,4),(157,7434832,7434825,'804',3.333,4),(157,7434833,7434825,'044',3.333,4),(157,7434834,7434825,'443',3.333,4),(157,7434835,7434825,'430',3.333,4),(157,7434836,7434825,'307',3.333,4),(157,7434837,7434825,'072',3.333,4),(157,7434838,7434825,'725',3.333,4),(157,7434839,7434825,'259',3.333,4),(157,7434840,7434825,'593',3.333,4),(157,7434841,7434825,'931',3.333,4),(157,7434842,7434825,'313',3.333,4),(157,7434843,7434825,'13f',3.333,4),(157,7434844,7434825,'3f3',3.333,4),(157,7434845,7434825,'f33',3.333,4),(157,7434846,7434825,'334',3.333,4),(157,7434847,7434825,'345',3.333,4),(157,7434848,7434825,'455',3.333,4),(157,7434849,7434825,'556',3.333,4),(157,7434850,7434825,'563',3.333,4),(157,7434851,7434825,'639',3.333,4),(157,7434852,7434825,'393',3.333,4),(157,7434853,7434825,'933',3.333,4),(157,7434854,7434825,'337',3.333,4),(157,7434855,7434825,'370',3.333,4),(157,7434856,7434826,'ser',25,1),(157,7434857,7434826,'eri',25,1),(157,7434858,7434826,'ria',25,1),(157,7434859,7434826,'ial',25,1),(157,7434860,7434856,'siz',50,1),(157,7434861,7434856,'ize',50,1),(157,7434862,7434860,'460',33.333,1),(157,7434863,7434860,'608',33.333,1),(157,7434864,7434860,'080',33.333,1),(157,7434865,7434862,'dev',25,1),(157,7434866,7434862,'evi',25,1),(157,7434867,7434862,'vic',25,1),(157,7434868,7434862,'ice',25,1),(157,7434869,7434865,'typ',50,1),(157,7434870,7434865,'ype',50,1),(157,7434871,7434869,'dir',10,1),(157,7434872,7434869,'ire',10,1),(157,7434873,7434869,'rec',10,1),(157,7434874,7434869,'ect',10,1),(157,7434875,7434869,'cta',10,1),(157,7434876,7434869,'tac',10,1),(157,7434877,7434869,'acc',10,1),(157,7434878,7434869,'cce',10,1),(157,7434879,7434869,'ces',10,1),(157,7434880,7434869,'ess',10,1),(157,7434881,7434871,'mul',14.286,1),(157,7434882,7434871,'ult',14.286,1),(157,7434883,7434871,'lti',14.286,1),(157,7434884,7434871,'tip',14.286,1),(157,7434885,7434871,'ipa',14.286,1),(157,7434886,7434871,'pat',14.286,1),(157,7434887,7434871,'ath',14.286,1),(157,7434888,7434881,'plu',25,1),(157,7434889,7434881,'lug',25,1),(157,7434890,7434881,'ugi',25,1),(157,7434891,7434881,'gin',25,1),(157,7434892,7434888,'nmp',100,1),(157,7434893,7434892,'dev',33.333,1),(157,7434894,7434892,'evf',33.333,1),(157,7434895,7434892,'vfs',33.333,1),(157,7434896,7434893,'pat',50,1),(157,7434897,7434893,'ath',50,1),(157,7434898,7434896,'vmf',50,1),(157,7434899,7434896,'mfs',50,1),(157,7434900,7434898,'dev',20,1),(157,7434901,7434898,'evi',20,1),(157,7434902,7434898,'vic',20,1),(157,7434903,7434898,'ice',20,1),(157,7434904,7434898,'ces',20,1),(157,7434905,7434900,'dis',33.333,1),(157,7434906,7434900,'isk',33.333,1),(157,7434907,7434900,'sks',33.333,1),(157,7434908,7434905,'ven',25,1),(157,7434909,7434905,'end',25,1),(157,7434910,7434905,'ndo',25,1),(157,7434911,7434905,'dor',25,1),(157,7434912,7434908,'mod',33.333,1),(157,7434913,7434908,'ode',33.333,1),(157,7434914,7434908,'del',33.333,1),(157,7434915,7434912,'lun',100,1),(157,7434916,7434915,'cmo',33.333,1),(157,7434917,7434915,'mod',33.333,1),(157,7434918,7434915,'ode',33.333,1),(157,7434919,7434916,'rev',16.667,1),(157,7434920,7434916,'evi',16.667,1),(157,7434921,7434916,'vis',16.667,1),(157,7434922,7434916,'isi',16.667,1),(157,7434923,7434916,'sio',16.667,1),(157,7434924,7434916,'ion',16.667,1),(157,7434925,7434919,'810',50,1),(157,7434926,7434919,'100',50,1),(157,7434927,7434925,'scs',50,1),(157,7434928,7434925,'csi',50,1),(157,7434929,7434927,'lev',33.333,1),(157,7434930,7434927,'eve',33.333,1),(157,7434931,7434927,'vel',33.333,1),(157,7434932,7434929,'pse',25,1),(157,7434933,7434929,'seu',25,1),(157,7434934,7434929,'eud',25,1),(157,7434935,7434929,'udo',25,1),(157,7434936,7434932,'fal',33.333,6),(157,7434937,7434932,'als',33.333,6),(157,7434938,7434932,'lse',33.333,6),(157,7434939,7434936,'sta',25,3),(157,7434940,7434936,'tat',25,3),(157,7434941,7434936,'atu',25,3),(157,7434942,7434936,'tus',25,3),(157,7434943,7434939,'rdm',100,1),(157,7434944,7434943,'cap',20,1),(157,7434945,7434943,'apa',20,1),(157,7434946,7434943,'pab',20,1),(157,7434947,7434943,'abl',20,1),(157,7434948,7434943,'ble',20,1),(157,7434949,7434944,'tru',50,1),(157,7434950,7434944,'rue',50,1),(157,7434951,7434949,'loc',33.333,1),(157,7434952,7434949,'oca',33.333,1),(157,7434953,7434949,'cal',33.333,1),(157,7434954,7434951,'rem',14.286,1),(157,7434955,7434951,'emo',14.286,1),(157,7434956,7434951,'mov',14.286,1),(157,7434957,7434951,'ova',14.286,1),(157,7434958,7434951,'vab',14.286,1),(157,7434959,7434951,'abl',14.286,1),(157,7434960,7434951,'ble',14.286,1),(157,7434961,7434954,'ssd',100,1),(157,7434962,7434961,'off',20,1),(157,7434963,7434961,'ffl',20,1),(157,7434964,7434961,'fli',20,1),(157,7434965,7434961,'lin',20,1),(157,7434966,7434961,'ine',20,1),(157,7434967,7434962,'per',11.111,1),(157,7434968,7434962,'ere',11.111,1),(157,7434969,7434962,'ren',11.111,1),(157,7434970,7434962,'enn',11.111,1),(157,7434971,7434962,'nni',11.111,1),(157,7434972,7434962,'nia',11.111,1),(157,7434973,7434962,'ial',11.111,1),(157,7434974,7434962,'all',11.111,1),(157,7434975,7434962,'lly',11.111,1),(157,7434976,7434967,'res',16.667,1),(157,7434977,7434967,'ese',16.667,1),(157,7434978,7434967,'ser',16.667,1),(157,7434979,7434967,'erv',16.667,1),(157,7434980,7434967,'rve',16.667,1),(157,7434981,7434967,'ved',16.667,1),(157,7434982,7434976,'thi',50,1),(157,7434983,7434976,'hin',50,1),(157,7434984,7434982,'pro',10,1),(157,7434985,7434982,'rov',10,1),(157,7434986,7434982,'ovi',10,1),(157,7434987,7434982,'vis',10,1),(157,7434988,7434982,'isi',10,1),(157,7434989,7434982,'sio',10,1),(157,7434990,7434982,'ion',10,1),(157,7434991,7434982,'oni',10,1),(157,7434992,7434982,'nin',10,1),(157,7434993,7434982,'ing',10,1),(157,7434994,7434984,'yes',100,1),(157,7434995,7434994,'att',16.667,1),(157,7434996,7434994,'tta',16.667,1),(157,7434997,7434994,'tac',16.667,1),(157,7434998,7434994,'ach',16.667,1),(157,7434999,7434994,'che',16.667,1),(157,7435000,7434994,'hed',16.667,1),(157,7435001,7434995,'fil',20,1),(157,7435002,7434995,'ilt',20,1),(157,7435003,7434995,'lte',20,1),(157,7435004,7434995,'ter',20,1),(157,7435005,7434995,'ers',20,1),(157,7435006,7435001,'vaa',50,1),(157,7435007,7435001,'aai',50,1),(157,7435008,7435006,'unk',20,1),(157,7435009,7435006,'nkn',20,1),(157,7435010,7435006,'kno',20,1),(157,7435011,7435006,'now',20,1),(157,7435012,7435006,'own',20,1),(157,7435013,7435008,'oth',33.333,1),(157,7435014,7435008,'the',33.333,1),(157,7435015,7435008,'her',33.333,1),(157,7435016,7435013,'uid',50,1),(157,7435017,7435013,'ids',50,1),(157,7435018,7435016,'vml',100,1),(157,7435019,7435018,'dis',20,1),(157,7435020,7435018,'isp',20,1),(157,7435021,7435018,'spl',20,1),(157,7435022,7435018,'pla',20,1),(157,7435023,7435018,'lay',20,1),(157,7435024,7435019,'nam',50,1),(157,7435025,7435019,'ame',50,1),(158,7435027,7435026,'net',25,3),(158,7435028,7435026,'eta',25,3),(158,7435029,7435026,'tap',25,3),(158,7435030,7435026,'app',25,3),(158,7435031,7435027,'ser',25,3),(158,7435032,7435027,'eri',25,3),(158,7435033,7435027,'ria',25,3),(158,7435034,7435027,'ial',25,3),(158,7435035,7435031,'att',16.667,3),(158,7435036,7435031,'tta',16.667,3),(158,7435037,7435031,'tac',16.667,3),(158,7435038,7435031,'ach',16.667,3),(158,7435039,7435031,'che',16.667,3),(158,7435040,7435031,'hed',16.667,3),(158,7435041,7435035,'scs',50,3),(158,7435042,7435035,'csi',50,3),(158,7435043,7435041,'dis',50,2),(158,7435044,7435041,'isk',50,2),(158,7435045,7435043,'naa',100,4),(158,7435046,7435045,'600',3.333,4),(158,7435047,7435045,'00a',3.333,4),(158,7435048,7435045,'0a0',3.333,4),(158,7435049,7435045,'a09',3.333,4),(158,7435050,7435045,'098',3.333,4),(158,7435051,7435045,'980',3.333,4),(158,7435052,7435045,'807',3.333,4),(158,7435053,7435045,'074',3.333,4),(158,7435054,7435045,'744',3.333,4),(158,7435055,7435045,'44e',3.333,4),(158,7435056,7435045,'4e8',3.333,4),(158,7435057,7435045,'e83',3.333,4),(158,7435058,7435045,'83e',3.333,4),(158,7435059,7435045,'3ee',3.333,4),(158,7435060,7435045,'ee1',3.333,4),(158,7435061,7435045,'e10',3.333,4),(158,7435062,7435045,'10d',3.333,4),(158,7435063,7435045,'0dd',3.333,4),(158,7435064,7435045,'dd4',3.333,4),(158,7435065,7435045,'d42',3.333,4),(158,7435066,7435045,'421',3.333,4),(158,7435067,7435045,'211',3.333,4),(158,7435068,7435045,'117',3.333,4),(158,7435069,7435045,'17b',3.333,4),(158,7435070,7435045,'7b0',3.333,4),(158,7435071,7435045,'b00',3.333,4),(158,7435072,7435045,'00a',3.333,4),(158,7435073,7435045,'0ab',3.333,4),(158,7435074,7435045,'aba',3.333,4),(158,7435075,7435045,'ba2',3.333,4),(158,7435076,7435046,'siz',50,1),(158,7435077,7435046,'ize',50,1),(158,7435078,7435076,'163',33.333,1),(158,7435079,7435076,'638',33.333,1),(158,7435080,7435076,'384',33.333,1),(158,7435081,7435078,'dev',25,1),(158,7435082,7435078,'evi',25,1),(158,7435083,7435078,'vic',25,1),(158,7435084,7435078,'ice',25,1),(158,7435085,7435081,'typ',50,1),(158,7435086,7435081,'ype',50,1),(158,7435087,7435085,'dir',10,1),(158,7435088,7435085,'ire',10,1),(158,7435089,7435085,'rec',10,1),(158,7435090,7435085,'ect',10,1),(158,7435091,7435085,'cta',10,1),(158,7435092,7435085,'tac',10,1),(158,7435093,7435085,'acc',10,1),(158,7435094,7435085,'cce',10,1),(158,7435095,7435085,'ces',10,1),(158,7435096,7435085,'ess',10,1),(158,7435097,7435087,'mul',14.286,1),(158,7435098,7435087,'ult',14.286,1),(158,7435099,7435087,'lti',14.286,1),(158,7435100,7435087,'tip',14.286,1),(158,7435101,7435087,'ipa',14.286,1),(158,7435102,7435087,'pat',14.286,1),(158,7435103,7435087,'ath',14.286,1),(158,7435104,7435097,'plu',25,1),(158,7435105,7435097,'lug',25,1),(158,7435106,7435097,'ugi',25,1),(158,7435107,7435097,'gin',25,1),(158,7435108,7435104,'nmp',100,1),(158,7435109,7435108,'dev',33.333,1),(158,7435110,7435108,'evf',33.333,1),(158,7435111,7435108,'vfs',33.333,1),(158,7435112,7435109,'pat',50,1),(158,7435113,7435109,'ath',50,1),(158,7435114,7435112,'vmf',50,1),(158,7435115,7435112,'mfs',50,1),(158,7435116,7435114,'dev',20,1),(158,7435117,7435114,'evi',20,1),(158,7435118,7435114,'vic',20,1),(158,7435119,7435114,'ice',20,1),(158,7435120,7435114,'ces',20,1),(158,7435121,7435116,'dis',33.333,1),(158,7435122,7435116,'isk',33.333,1),(158,7435123,7435116,'sks',33.333,1),(158,7435124,7435121,'ven',25,1),(158,7435125,7435121,'end',25,1),(158,7435126,7435121,'ndo',25,1),(158,7435127,7435121,'dor',25,1),(158,7435128,7435124,'mod',33.333,1),(158,7435129,7435124,'ode',33.333,1),(158,7435130,7435124,'del',33.333,1),(158,7435131,7435128,'fla',33.333,1),(158,7435132,7435128,'las',33.333,1),(158,7435133,7435128,'ash',33.333,1),(158,7435134,7435131,'acc',33.333,1),(158,7435135,7435131,'cce',33.333,1),(158,7435136,7435131,'cel',33.333,1),(158,7435137,7435134,'rev',16.667,1),(158,7435138,7435134,'evi',16.667,1),(158,7435139,7435134,'vis',16.667,1),(158,7435140,7435134,'isi',16.667,1),(158,7435141,7435134,'sio',16.667,1),(158,7435142,7435134,'ion',16.667,1),(158,7435143,7435137,'lev',33.333,1),(158,7435144,7435137,'eve',33.333,1),(158,7435145,7435137,'vel',33.333,1),(158,7435146,7435143,'pse',25,1),(158,7435147,7435143,'seu',25,1),(158,7435148,7435143,'eud',25,1),(158,7435149,7435143,'udo',25,1),(158,7435150,7435146,'fal',33.333,5),(158,7435151,7435146,'als',33.333,5),(158,7435152,7435146,'lse',33.333,5),(158,7435153,7435150,'sta',25,3),(158,7435154,7435150,'tat',25,3),(158,7435155,7435150,'atu',25,3),(158,7435156,7435150,'tus',25,3),(158,7435157,7435153,'deg',16.667,1),(158,7435158,7435153,'egr',16.667,1),(158,7435159,7435153,'gra',16.667,1),(158,7435160,7435153,'rad',16.667,1),(158,7435161,7435153,'ade',16.667,1),(158,7435162,7435153,'ded',16.667,1),(158,7435163,7435157,'rdm',100,1),(158,7435164,7435163,'cap',20,1),(158,7435165,7435163,'apa',20,1),(158,7435166,7435163,'pab',20,1),(158,7435167,7435163,'abl',20,1),(158,7435168,7435163,'ble',20,1),(158,7435169,7435164,'tru',50,2),(158,7435170,7435164,'rue',50,2),(158,7435171,7435169,'loc',33.333,1),(158,7435172,7435169,'oca',33.333,1),(158,7435173,7435169,'cal',33.333,1),(158,7435174,7435171,'rem',14.286,1),(158,7435175,7435171,'emo',14.286,1),(158,7435176,7435171,'mov',14.286,1),(158,7435177,7435171,'ova',14.286,1),(158,7435178,7435171,'vab',14.286,1),(158,7435179,7435171,'abl',14.286,1),(158,7435180,7435171,'ble',14.286,1),(158,7435181,7435174,'ssd',100,1),(158,7435182,7435181,'off',20,1),(158,7435183,7435181,'ffl',20,1),(158,7435184,7435181,'fli',20,1),(158,7435185,7435181,'lin',20,1),(158,7435186,7435181,'ine',20,1),(158,7435187,7435182,'per',11.111,1),(158,7435188,7435182,'ere',11.111,1),(158,7435189,7435182,'ren',11.111,1),(158,7435190,7435182,'enn',11.111,1),(158,7435191,7435182,'nni',11.111,1),(158,7435192,7435182,'nia',11.111,1),(158,7435193,7435182,'ial',11.111,1),(158,7435194,7435182,'all',11.111,1),(158,7435195,7435182,'lly',11.111,1),(158,7435196,7435187,'res',16.667,1),(158,7435197,7435187,'ese',16.667,1),(158,7435198,7435187,'ser',16.667,1),(158,7435199,7435187,'erv',16.667,1),(158,7435200,7435187,'rve',16.667,1),(158,7435201,7435187,'ved',16.667,1),(158,7435202,7435196,'thi',50,1),(158,7435203,7435196,'hin',50,1),(158,7435204,7435202,'pro',10,1),(158,7435205,7435202,'rov',10,1),(158,7435206,7435202,'ovi',10,1),(158,7435207,7435202,'vis',10,1),(158,7435208,7435202,'isi',10,1),(158,7435209,7435202,'sio',10,1),(158,7435210,7435202,'ion',10,1),(158,7435211,7435202,'oni',10,1),(158,7435212,7435202,'nin',10,1),(158,7435213,7435202,'ing',10,1),(158,7435214,7435204,'unk',20,1),(158,7435215,7435204,'nkn',20,1),(158,7435216,7435204,'kno',20,1),(158,7435217,7435204,'now',20,1),(158,7435218,7435204,'own',20,1),(158,7435219,7435214,'fil',20,1),(158,7435220,7435214,'ilt',20,1),(158,7435221,7435214,'lte',20,1),(158,7435222,7435214,'ter',20,1),(158,7435223,7435214,'ers',20,1),(158,7435224,7435219,'vaa',50,1),(158,7435225,7435219,'aai',50,1),(158,7435226,7435224,'uns',11.111,1),(158,7435227,7435224,'nsu',11.111,1),(158,7435228,7435224,'sup',11.111,1),(158,7435229,7435224,'upp',11.111,1),(158,7435230,7435224,'ppo',11.111,1),(158,7435231,7435224,'por',11.111,1),(158,7435232,7435224,'ort',11.111,1),(158,7435233,7435224,'rte',11.111,1),(158,7435234,7435224,'ted',11.111,1),(158,7435235,7435226,'oth',33.333,1),(158,7435236,7435226,'the',33.333,1),(158,7435237,7435226,'her',33.333,1),(158,7435238,7435235,'uid',50,1),(158,7435239,7435235,'ids',50,1),(158,7435240,7435238,'vml',100,1),(158,7435241,7435240,'dis',20,1),(158,7435242,7435240,'isp',20,1),(158,7435243,7435240,'spl',20,1),(158,7435244,7435240,'pla',20,1),(158,7435245,7435240,'lay',20,1),(158,7435246,7435241,'nam',50,1),(158,7435247,7435241,'ame',50,1),(159,7435249,7435248,'net',25,3),(159,7435250,7435248,'eta',25,3),(159,7435251,7435248,'tap',25,3),(159,7435252,7435248,'app',25,3),(159,7435253,7435249,'fib',33.333,2),(159,7435254,7435249,'ibr',33.333,2),(159,7435255,7435249,'bre',33.333,2),(159,7435256,7435253,'cha',20,2),(159,7435257,7435253,'han',20,2),(159,7435258,7435253,'ann',20,2),(159,7435259,7435253,'nne',20,2),(159,7435260,7435253,'nel',20,2),(159,7435261,7435256,'dis',50,2),(159,7435262,7435256,'isk',50,2),(159,7435263,7435261,'naa',100,4),(159,7435264,7435263,'600',3.333,4),(159,7435265,7435263,'00a',3.333,4),(159,7435266,7435263,'0a0',3.333,4),(159,7435267,7435263,'a09',3.333,4),(159,7435268,7435263,'098',3.333,4),(159,7435269,7435263,'980',3.333,4),(159,7435270,7435263,'804',3.333,4),(159,7435271,7435263,'044',3.333,4),(159,7435272,7435263,'443',3.333,4),(159,7435273,7435263,'430',3.333,4),(159,7435274,7435263,'307',3.333,4),(159,7435275,7435263,'072',3.333,4),(159,7435276,7435263,'725',3.333,4),(159,7435277,7435263,'259',3.333,4),(159,7435278,7435263,'593',3.333,4),(159,7435279,7435263,'931',3.333,4),(159,7435280,7435263,'313',3.333,4),(159,7435281,7435263,'13f',3.333,4),(159,7435282,7435263,'3f3',3.333,4),(159,7435283,7435263,'f33',3.333,4),(159,7435284,7435263,'334',3.333,4),(159,7435285,7435263,'345',3.333,4),(159,7435286,7435263,'455',3.333,4),(159,7435287,7435263,'556',3.333,4),(159,7435288,7435263,'563',3.333,4),(159,7435289,7435263,'639',3.333,4),(159,7435290,7435263,'393',3.333,4),(159,7435291,7435263,'933',3.333,4),(159,7435292,7435263,'337',3.333,4),(159,7435293,7435263,'371',3.333,4),(159,7435294,7435264,'ser',25,1),(159,7435295,7435264,'eri',25,1),(159,7435296,7435264,'ria',25,1),(159,7435297,7435264,'ial',25,1),(159,7435298,7435294,'siz',50,1),(159,7435299,7435294,'ize',50,1),(159,7435300,7435298,'460',33.333,1),(159,7435301,7435298,'608',33.333,1),(159,7435302,7435298,'080',33.333,1),(159,7435303,7435300,'dev',25,1),(159,7435304,7435300,'evi',25,1),(159,7435305,7435300,'vic',25,1),(159,7435306,7435300,'ice',25,1),(159,7435307,7435303,'typ',50,1),(159,7435308,7435303,'ype',50,1),(159,7435309,7435307,'dir',10,1),(159,7435310,7435307,'ire',10,1),(159,7435311,7435307,'rec',10,1),(159,7435312,7435307,'ect',10,1),(159,7435313,7435307,'cta',10,1),(159,7435314,7435307,'tac',10,1),(159,7435315,7435307,'acc',10,1),(159,7435316,7435307,'cce',10,1),(159,7435317,7435307,'ces',10,1),(159,7435318,7435307,'ess',10,1),(159,7435319,7435309,'mul',14.286,1),(159,7435320,7435309,'ult',14.286,1),(159,7435321,7435309,'lti',14.286,1),(159,7435322,7435309,'tip',14.286,1),(159,7435323,7435309,'ipa',14.286,1),(159,7435324,7435309,'pat',14.286,1),(159,7435325,7435309,'ath',14.286,1),(159,7435326,7435319,'plu',25,1),(159,7435327,7435319,'lug',25,1),(159,7435328,7435319,'ugi',25,1),(159,7435329,7435319,'gin',25,1),(159,7435330,7435326,'nmp',100,1),(159,7435331,7435330,'dev',33.333,1),(159,7435332,7435330,'evf',33.333,1),(159,7435333,7435330,'vfs',33.333,1),(159,7435334,7435331,'pat',50,1),(159,7435335,7435331,'ath',50,1),(159,7435336,7435334,'vmf',50,1),(159,7435337,7435334,'mfs',50,1),(159,7435338,7435336,'dev',20,1),(159,7435339,7435336,'evi',20,1),(159,7435340,7435336,'vic',20,1),(159,7435341,7435336,'ice',20,1),(159,7435342,7435336,'ces',20,1),(159,7435343,7435338,'dis',33.333,1),(159,7435344,7435338,'isk',33.333,1),(159,7435345,7435338,'sks',33.333,1),(159,7435346,7435343,'ven',25,1),(159,7435347,7435343,'end',25,1),(159,7435348,7435343,'ndo',25,1),(159,7435349,7435343,'dor',25,1),(159,7435350,7435346,'mod',33.333,1),(159,7435351,7435346,'ode',33.333,1),(159,7435352,7435346,'del',33.333,1),(159,7435353,7435350,'lun',100,1),(159,7435354,7435353,'cmo',33.333,1),(159,7435355,7435353,'mod',33.333,1),(159,7435356,7435353,'ode',33.333,1),(159,7435357,7435354,'rev',16.667,1),(159,7435358,7435354,'evi',16.667,1),(159,7435359,7435354,'vis',16.667,1),(159,7435360,7435354,'isi',16.667,1),(159,7435361,7435354,'sio',16.667,1),(159,7435362,7435354,'ion',16.667,1),(159,7435363,7435357,'810',50,1),(159,7435364,7435357,'100',50,1),(159,7435365,7435363,'scs',50,1),(159,7435366,7435363,'csi',50,1),(159,7435367,7435365,'lev',33.333,1),(159,7435368,7435365,'eve',33.333,1),(159,7435369,7435365,'vel',33.333,1),(159,7435370,7435367,'pse',25,1),(159,7435371,7435367,'seu',25,1),(159,7435372,7435367,'eud',25,1),(159,7435373,7435367,'udo',25,1),(159,7435374,7435370,'fal',33.333,6),(159,7435375,7435370,'als',33.333,6),(159,7435376,7435370,'lse',33.333,6),(159,7435377,7435374,'sta',25,3),(159,7435378,7435374,'tat',25,3),(159,7435379,7435374,'atu',25,3),(159,7435380,7435374,'tus',25,3),(159,7435381,7435377,'rdm',100,1),(159,7435382,7435381,'cap',20,1),(159,7435383,7435381,'apa',20,1),(159,7435384,7435381,'pab',20,1),(159,7435385,7435381,'abl',20,1),(159,7435386,7435381,'ble',20,1),(159,7435387,7435382,'tru',50,1),(159,7435388,7435382,'rue',50,1),(159,7435389,7435387,'loc',33.333,1),(159,7435390,7435387,'oca',33.333,1),(159,7435391,7435387,'cal',33.333,1),(159,7435392,7435389,'rem',14.286,1),(159,7435393,7435389,'emo',14.286,1),(159,7435394,7435389,'mov',14.286,1),(159,7435395,7435389,'ova',14.286,1),(159,7435396,7435389,'vab',14.286,1),(159,7435397,7435389,'abl',14.286,1),(159,7435398,7435389,'ble',14.286,1),(159,7435399,7435392,'ssd',100,1),(159,7435400,7435399,'off',20,1),(159,7435401,7435399,'ffl',20,1),(159,7435402,7435399,'fli',20,1),(159,7435403,7435399,'lin',20,1),(159,7435404,7435399,'ine',20,1),(159,7435405,7435400,'per',11.111,1),(159,7435406,7435400,'ere',11.111,1),(159,7435407,7435400,'ren',11.111,1),(159,7435408,7435400,'enn',11.111,1),(159,7435409,7435400,'nni',11.111,1),(159,7435410,7435400,'nia',11.111,1),(159,7435411,7435400,'ial',11.111,1),(159,7435412,7435400,'all',11.111,1),(159,7435413,7435400,'lly',11.111,1),(159,7435414,7435405,'res',16.667,1),(159,7435415,7435405,'ese',16.667,1),(159,7435416,7435405,'ser',16.667,1),(159,7435417,7435405,'erv',16.667,1),(159,7435418,7435405,'rve',16.667,1),(159,7435419,7435405,'ved',16.667,1),(159,7435420,7435414,'thi',50,1),(159,7435421,7435414,'hin',50,1),(159,7435422,7435420,'pro',10,1),(159,7435423,7435420,'rov',10,1),(159,7435424,7435420,'ovi',10,1),(159,7435425,7435420,'vis',10,1),(159,7435426,7435420,'isi',10,1),(159,7435427,7435420,'sio',10,1),(159,7435428,7435420,'ion',10,1),(159,7435429,7435420,'oni',10,1),(159,7435430,7435420,'nin',10,1),(159,7435431,7435420,'ing',10,1),(159,7435432,7435422,'yes',100,1),(159,7435433,7435432,'att',16.667,1),(159,7435434,7435432,'tta',16.667,1),(159,7435435,7435432,'tac',16.667,1),(159,7435436,7435432,'ach',16.667,1),(159,7435437,7435432,'che',16.667,1),(159,7435438,7435432,'hed',16.667,1),(159,7435439,7435433,'fil',20,1),(159,7435440,7435433,'ilt',20,1),(159,7435441,7435433,'lte',20,1),(159,7435442,7435433,'ter',20,1),(159,7435443,7435433,'ers',20,1),(159,7435444,7435439,'vaa',50,1),(159,7435445,7435439,'aai',50,1),(159,7435446,7435444,'unk',20,1),(159,7435447,7435444,'nkn',20,1),(159,7435448,7435444,'kno',20,1),(159,7435449,7435444,'now',20,1),(159,7435450,7435444,'own',20,1),(159,7435451,7435446,'oth',33.333,1),(159,7435452,7435446,'the',33.333,1),(159,7435453,7435446,'her',33.333,1),(159,7435454,7435451,'uid',50,1),(159,7435455,7435451,'ids',50,1),(159,7435456,7435454,'vml',100,1),(159,7435457,7435456,'dis',20,1),(159,7435458,7435456,'isp',20,1),(159,7435459,7435456,'spl',20,1),(159,7435460,7435456,'pla',20,1),(159,7435461,7435456,'lay',20,1),(159,7435462,7435457,'nam',50,1),(159,7435463,7435457,'ame',50,1),(160,7435465,7435464,'net',25,3),(160,7435466,7435464,'eta',25,3),(160,7435467,7435464,'tap',25,3),(160,7435468,7435464,'app',25,3),(160,7435469,7435465,'fib',33.333,2),(160,7435470,7435465,'ibr',33.333,2),(160,7435471,7435465,'bre',33.333,2),(160,7435472,7435469,'cha',20,2),(160,7435473,7435469,'han',20,2),(160,7435474,7435469,'ann',20,2),(160,7435475,7435469,'nne',20,2),(160,7435476,7435469,'nel',20,2),(160,7435477,7435472,'dis',50,2),(160,7435478,7435472,'isk',50,2),(160,7435479,7435477,'naa',100,4),(160,7435480,7435479,'600',3.333,4),(160,7435481,7435479,'00a',3.333,4),(160,7435482,7435479,'0a0',3.333,4),(160,7435483,7435479,'a09',3.333,4),(160,7435484,7435479,'098',3.333,4),(160,7435485,7435479,'980',3.333,4),(160,7435486,7435479,'804',3.333,4),(160,7435487,7435479,'044',3.333,4),(160,7435488,7435479,'443',3.333,4),(160,7435489,7435479,'430',3.333,4),(160,7435490,7435479,'307',3.333,4),(160,7435491,7435479,'072',3.333,4),(160,7435492,7435479,'725',3.333,4),(160,7435493,7435479,'259',3.333,4),(160,7435494,7435479,'593',3.333,4),(160,7435495,7435479,'931',3.333,4),(160,7435496,7435479,'313',3.333,4),(160,7435497,7435479,'13f',3.333,4),(160,7435498,7435479,'3f3',3.333,4),(160,7435499,7435479,'f33',3.333,4),(160,7435500,7435479,'334',3.333,4),(160,7435501,7435479,'345',3.333,4),(160,7435502,7435479,'455',3.333,4),(160,7435503,7435479,'556',3.333,4),(160,7435504,7435479,'563',3.333,4),(160,7435505,7435479,'639',3.333,4),(160,7435506,7435479,'393',3.333,4),(160,7435507,7435479,'933',3.333,4),(160,7435508,7435479,'337',3.333,4),(160,7435509,7435479,'372',3.333,4),(160,7435510,7435480,'ser',25,1),(160,7435511,7435480,'eri',25,1),(160,7435512,7435480,'ria',25,1),(160,7435513,7435480,'ial',25,1),(160,7435514,7435510,'siz',50,1),(160,7435515,7435510,'ize',50,1),(160,7435516,7435514,'460',33.333,1),(160,7435517,7435514,'608',33.333,1),(160,7435518,7435514,'080',33.333,1),(160,7435519,7435516,'dev',25,1),(160,7435520,7435516,'evi',25,1),(160,7435521,7435516,'vic',25,1),(160,7435522,7435516,'ice',25,1),(160,7435523,7435519,'typ',50,1),(160,7435524,7435519,'ype',50,1),(160,7435525,7435523,'dir',10,1),(160,7435526,7435523,'ire',10,1),(160,7435527,7435523,'rec',10,1),(160,7435528,7435523,'ect',10,1),(160,7435529,7435523,'cta',10,1),(160,7435530,7435523,'tac',10,1),(160,7435531,7435523,'acc',10,1),(160,7435532,7435523,'cce',10,1),(160,7435533,7435523,'ces',10,1),(160,7435534,7435523,'ess',10,1),(160,7435535,7435525,'mul',14.286,1),(160,7435536,7435525,'ult',14.286,1),(160,7435537,7435525,'lti',14.286,1),(160,7435538,7435525,'tip',14.286,1),(160,7435539,7435525,'ipa',14.286,1),(160,7435540,7435525,'pat',14.286,1),(160,7435541,7435525,'ath',14.286,1),(160,7435542,7435535,'plu',25,1),(160,7435543,7435535,'lug',25,1),(160,7435544,7435535,'ugi',25,1),(160,7435545,7435535,'gin',25,1),(160,7435546,7435542,'nmp',100,1),(160,7435547,7435546,'dev',33.333,1),(160,7435548,7435546,'evf',33.333,1),(160,7435549,7435546,'vfs',33.333,1),(160,7435550,7435547,'pat',50,1),(160,7435551,7435547,'ath',50,1),(160,7435552,7435550,'vmf',50,1),(160,7435553,7435550,'mfs',50,1),(160,7435554,7435552,'dev',20,1),(160,7435555,7435552,'evi',20,1),(160,7435556,7435552,'vic',20,1),(160,7435557,7435552,'ice',20,1),(160,7435558,7435552,'ces',20,1),(160,7435559,7435554,'dis',33.333,1),(160,7435560,7435554,'isk',33.333,1),(160,7435561,7435554,'sks',33.333,1),(160,7435562,7435559,'ven',25,1),(160,7435563,7435559,'end',25,1),(160,7435564,7435559,'ndo',25,1),(160,7435565,7435559,'dor',25,1),(160,7435566,7435562,'mod',33.333,1),(160,7435567,7435562,'ode',33.333,1),(160,7435568,7435562,'del',33.333,1),(160,7435569,7435566,'lun',100,1),(160,7435570,7435569,'cmo',33.333,1),(160,7435571,7435569,'mod',33.333,1),(160,7435572,7435569,'ode',33.333,1),(160,7435573,7435570,'rev',16.667,1),(160,7435574,7435570,'evi',16.667,1),(160,7435575,7435570,'vis',16.667,1),(160,7435576,7435570,'isi',16.667,1),(160,7435577,7435570,'sio',16.667,1),(160,7435578,7435570,'ion',16.667,1),(160,7435579,7435573,'810',50,1),(160,7435580,7435573,'100',50,1),(160,7435581,7435579,'scs',50,1),(160,7435582,7435579,'csi',50,1),(160,7435583,7435581,'lev',33.333,1),(160,7435584,7435581,'eve',33.333,1),(160,7435585,7435581,'vel',33.333,1),(160,7435586,7435583,'pse',25,1),(160,7435587,7435583,'seu',25,1),(160,7435588,7435583,'eud',25,1),(160,7435589,7435583,'udo',25,1),(160,7435590,7435586,'fal',33.333,6),(160,7435591,7435586,'als',33.333,6),(160,7435592,7435586,'lse',33.333,6),(160,7435593,7435590,'sta',25,3),(160,7435594,7435590,'tat',25,3),(160,7435595,7435590,'atu',25,3),(160,7435596,7435590,'tus',25,3),(160,7435597,7435593,'rdm',100,1),(160,7435598,7435597,'cap',20,1),(160,7435599,7435597,'apa',20,1),(160,7435600,7435597,'pab',20,1),(160,7435601,7435597,'abl',20,1),(160,7435602,7435597,'ble',20,1),(160,7435603,7435598,'tru',50,1),(160,7435604,7435598,'rue',50,1),(160,7435605,7435603,'loc',33.333,1),(160,7435606,7435603,'oca',33.333,1),(160,7435607,7435603,'cal',33.333,1),(160,7435608,7435605,'rem',14.286,1),(160,7435609,7435605,'emo',14.286,1),(160,7435610,7435605,'mov',14.286,1),(160,7435611,7435605,'ova',14.286,1),(160,7435612,7435605,'vab',14.286,1),(160,7435613,7435605,'abl',14.286,1),(160,7435614,7435605,'ble',14.286,1),(160,7435615,7435608,'ssd',100,1),(160,7435616,7435615,'off',20,1),(160,7435617,7435615,'ffl',20,1),(160,7435618,7435615,'fli',20,1),(160,7435619,7435615,'lin',20,1),(160,7435620,7435615,'ine',20,1),(160,7435621,7435616,'per',11.111,1),(160,7435622,7435616,'ere',11.111,1),(160,7435623,7435616,'ren',11.111,1),(160,7435624,7435616,'enn',11.111,1),(160,7435625,7435616,'nni',11.111,1),(160,7435626,7435616,'nia',11.111,1),(160,7435627,7435616,'ial',11.111,1),(160,7435628,7435616,'all',11.111,1),(160,7435629,7435616,'lly',11.111,1),(160,7435630,7435621,'res',16.667,1),(160,7435631,7435621,'ese',16.667,1),(160,7435632,7435621,'ser',16.667,1),(160,7435633,7435621,'erv',16.667,1),(160,7435634,7435621,'rve',16.667,1),(160,7435635,7435621,'ved',16.667,1),(160,7435636,7435630,'thi',50,1),(160,7435637,7435630,'hin',50,1),(160,7435638,7435636,'pro',10,1),(160,7435639,7435636,'rov',10,1),(160,7435640,7435636,'ovi',10,1),(160,7435641,7435636,'vis',10,1),(160,7435642,7435636,'isi',10,1),(160,7435643,7435636,'sio',10,1),(160,7435644,7435636,'ion',10,1),(160,7435645,7435636,'oni',10,1),(160,7435646,7435636,'nin',10,1),(160,7435647,7435636,'ing',10,1),(160,7435648,7435638,'yes',100,1),(160,7435649,7435648,'att',16.667,1),(160,7435650,7435648,'tta',16.667,1),(160,7435651,7435648,'tac',16.667,1),(160,7435652,7435648,'ach',16.667,1),(160,7435653,7435648,'che',16.667,1),(160,7435654,7435648,'hed',16.667,1),(160,7435655,7435649,'fil',20,1),(160,7435656,7435649,'ilt',20,1),(160,7435657,7435649,'lte',20,1),(160,7435658,7435649,'ter',20,1),(160,7435659,7435649,'ers',20,1),(160,7435660,7435655,'vaa',50,1),(160,7435661,7435655,'aai',50,1),(160,7435662,7435660,'unk',20,1),(160,7435663,7435660,'nkn',20,1),(160,7435664,7435660,'kno',20,1),(160,7435665,7435660,'now',20,1),(160,7435666,7435660,'own',20,1),(160,7435667,7435662,'oth',33.333,1),(160,7435668,7435662,'the',33.333,1),(160,7435669,7435662,'her',33.333,1),(160,7435670,7435667,'uid',50,1),(160,7435671,7435667,'ids',50,1),(160,7435672,7435670,'vml',100,1),(160,7435673,7435672,'dis',20,1),(160,7435674,7435672,'isp',20,1),(160,7435675,7435672,'spl',20,1),(160,7435676,7435672,'pla',20,1),(160,7435677,7435672,'lay',20,1),(160,7435678,7435673,'nam',50,1),(160,7435679,7435673,'ame',50,1),(161,7435681,7435680,'net',25,3),(161,7435682,7435680,'eta',25,3),(161,7435683,7435680,'tap',25,3),(161,7435684,7435680,'app',25,3),(161,7435685,7435681,'fib',33.333,2),(161,7435686,7435681,'ibr',33.333,2),(161,7435687,7435681,'bre',33.333,2),(161,7435688,7435685,'cha',20,2),(161,7435689,7435685,'han',20,2),(161,7435690,7435685,'ann',20,2),(161,7435691,7435685,'nne',20,2),(161,7435692,7435685,'nel',20,2),(161,7435693,7435688,'dis',50,2),(161,7435694,7435688,'isk',50,2),(161,7435695,7435693,'naa',100,4),(161,7435696,7435695,'600',3.333,4),(161,7435697,7435695,'00a',3.333,4),(161,7435698,7435695,'0a0',3.333,4),(161,7435699,7435695,'a09',3.333,4),(161,7435700,7435695,'098',3.333,4),(161,7435701,7435695,'980',3.333,4),(161,7435702,7435695,'804',3.333,4),(161,7435703,7435695,'044',3.333,4),(161,7435704,7435695,'443',3.333,4),(161,7435705,7435695,'430',3.333,4),(161,7435706,7435695,'307',3.333,4),(161,7435707,7435695,'072',3.333,4),(161,7435708,7435695,'725',3.333,4),(161,7435709,7435695,'259',3.333,4),(161,7435710,7435695,'593',3.333,4),(161,7435711,7435695,'931',3.333,4),(161,7435712,7435695,'313',3.333,4),(161,7435713,7435695,'13f',3.333,4),(161,7435714,7435695,'3f3',3.333,4),(161,7435715,7435695,'f33',3.333,4),(161,7435716,7435695,'334',3.333,4),(161,7435717,7435695,'345',3.333,4),(161,7435718,7435695,'455',3.333,4),(161,7435719,7435695,'556',3.333,4),(161,7435720,7435695,'563',3.333,4),(161,7435721,7435695,'639',3.333,4),(161,7435722,7435695,'393',3.333,4),(161,7435723,7435695,'933',3.333,4),(161,7435724,7435695,'337',3.333,4),(161,7435725,7435695,'373',3.333,4),(161,7435726,7435696,'ser',25,1),(161,7435727,7435696,'eri',25,1),(161,7435728,7435696,'ria',25,1),(161,7435729,7435696,'ial',25,1),(161,7435730,7435726,'siz',50,1),(161,7435731,7435726,'ize',50,1),(161,7435732,7435730,'460',33.333,1),(161,7435733,7435730,'608',33.333,1),(161,7435734,7435730,'080',33.333,1),(161,7435735,7435732,'dev',25,1),(161,7435736,7435732,'evi',25,1),(161,7435737,7435732,'vic',25,1),(161,7435738,7435732,'ice',25,1),(161,7435739,7435735,'typ',50,1),(161,7435740,7435735,'ype',50,1),(161,7435741,7435739,'dir',10,1),(161,7435742,7435739,'ire',10,1),(161,7435743,7435739,'rec',10,1),(161,7435744,7435739,'ect',10,1),(161,7435745,7435739,'cta',10,1),(161,7435746,7435739,'tac',10,1),(161,7435747,7435739,'acc',10,1),(161,7435748,7435739,'cce',10,1),(161,7435749,7435739,'ces',10,1),(161,7435750,7435739,'ess',10,1),(161,7435751,7435741,'mul',14.286,1),(161,7435752,7435741,'ult',14.286,1),(161,7435753,7435741,'lti',14.286,1),(161,7435754,7435741,'tip',14.286,1),(161,7435755,7435741,'ipa',14.286,1),(161,7435756,7435741,'pat',14.286,1),(161,7435757,7435741,'ath',14.286,1),(161,7435758,7435751,'plu',25,1),(161,7435759,7435751,'lug',25,1),(161,7435760,7435751,'ugi',25,1),(161,7435761,7435751,'gin',25,1),(161,7435762,7435758,'nmp',100,1),(161,7435763,7435762,'dev',33.333,1),(161,7435764,7435762,'evf',33.333,1),(161,7435765,7435762,'vfs',33.333,1),(161,7435766,7435763,'pat',50,1),(161,7435767,7435763,'ath',50,1),(161,7435768,7435766,'vmf',50,1),(161,7435769,7435766,'mfs',50,1),(161,7435770,7435768,'dev',20,1),(161,7435771,7435768,'evi',20,1),(161,7435772,7435768,'vic',20,1),(161,7435773,7435768,'ice',20,1),(161,7435774,7435768,'ces',20,1),(161,7435775,7435770,'dis',33.333,1),(161,7435776,7435770,'isk',33.333,1),(161,7435777,7435770,'sks',33.333,1),(161,7435778,7435775,'ven',25,1),(161,7435779,7435775,'end',25,1),(161,7435780,7435775,'ndo',25,1),(161,7435781,7435775,'dor',25,1),(161,7435782,7435778,'mod',33.333,1),(161,7435783,7435778,'ode',33.333,1),(161,7435784,7435778,'del',33.333,1),(161,7435785,7435782,'lun',100,1),(161,7435786,7435785,'cmo',33.333,1),(161,7435787,7435785,'mod',33.333,1),(161,7435788,7435785,'ode',33.333,1),(161,7435789,7435786,'rev',16.667,1),(161,7435790,7435786,'evi',16.667,1),(161,7435791,7435786,'vis',16.667,1),(161,7435792,7435786,'isi',16.667,1),(161,7435793,7435786,'sio',16.667,1),(161,7435794,7435786,'ion',16.667,1),(161,7435795,7435789,'810',50,1),(161,7435796,7435789,'100',50,1),(161,7435797,7435795,'scs',50,1),(161,7435798,7435795,'csi',50,1),(161,7435799,7435797,'lev',33.333,1),(161,7435800,7435797,'eve',33.333,1),(161,7435801,7435797,'vel',33.333,1),(161,7435802,7435799,'pse',25,1),(161,7435803,7435799,'seu',25,1),(161,7435804,7435799,'eud',25,1),(161,7435805,7435799,'udo',25,1),(161,7435806,7435802,'fal',33.333,6),(161,7435807,7435802,'als',33.333,6),(161,7435808,7435802,'lse',33.333,6),(161,7435809,7435806,'sta',25,3),(161,7435810,7435806,'tat',25,3),(161,7435811,7435806,'atu',25,3),(161,7435812,7435806,'tus',25,3),(161,7435813,7435809,'rdm',100,1),(161,7435814,7435813,'cap',20,1),(161,7435815,7435813,'apa',20,1),(161,7435816,7435813,'pab',20,1),(161,7435817,7435813,'abl',20,1),(161,7435818,7435813,'ble',20,1),(161,7435819,7435814,'tru',50,1),(161,7435820,7435814,'rue',50,1),(161,7435821,7435819,'loc',33.333,1),(161,7435822,7435819,'oca',33.333,1),(161,7435823,7435819,'cal',33.333,1),(161,7435824,7435821,'rem',14.286,1),(161,7435825,7435821,'emo',14.286,1),(161,7435826,7435821,'mov',14.286,1),(161,7435827,7435821,'ova',14.286,1),(161,7435828,7435821,'vab',14.286,1),(161,7435829,7435821,'abl',14.286,1),(161,7435830,7435821,'ble',14.286,1),(161,7435831,7435824,'ssd',100,1),(161,7435832,7435831,'off',20,1),(161,7435833,7435831,'ffl',20,1),(161,7435834,7435831,'fli',20,1),(161,7435835,7435831,'lin',20,1),(161,7435836,7435831,'ine',20,1),(161,7435837,7435832,'per',11.111,1),(161,7435838,7435832,'ere',11.111,1),(161,7435839,7435832,'ren',11.111,1),(161,7435840,7435832,'enn',11.111,1),(161,7435841,7435832,'nni',11.111,1),(161,7435842,7435832,'nia',11.111,1),(161,7435843,7435832,'ial',11.111,1),(161,7435844,7435832,'all',11.111,1),(161,7435845,7435832,'lly',11.111,1),(161,7435846,7435837,'res',16.667,1),(161,7435847,7435837,'ese',16.667,1),(161,7435848,7435837,'ser',16.667,1),(161,7435849,7435837,'erv',16.667,1),(161,7435850,7435837,'rve',16.667,1),(161,7435851,7435837,'ved',16.667,1),(161,7435852,7435846,'thi',50,1),(161,7435853,7435846,'hin',50,1),(161,7435854,7435852,'pro',10,1),(161,7435855,7435852,'rov',10,1),(161,7435856,7435852,'ovi',10,1),(161,7435857,7435852,'vis',10,1),(161,7435858,7435852,'isi',10,1),(161,7435859,7435852,'sio',10,1),(161,7435860,7435852,'ion',10,1),(161,7435861,7435852,'oni',10,1),(161,7435862,7435852,'nin',10,1),(161,7435863,7435852,'ing',10,1),(161,7435864,7435854,'yes',100,1),(161,7435865,7435864,'att',16.667,1),(161,7435866,7435864,'tta',16.667,1),(161,7435867,7435864,'tac',16.667,1),(161,7435868,7435864,'ach',16.667,1),(161,7435869,7435864,'che',16.667,1),(161,7435870,7435864,'hed',16.667,1),(161,7435871,7435865,'fil',20,1),(161,7435872,7435865,'ilt',20,1),(161,7435873,7435865,'lte',20,1),(161,7435874,7435865,'ter',20,1),(161,7435875,7435865,'ers',20,1),(161,7435876,7435871,'vaa',50,1),(161,7435877,7435871,'aai',50,1),(161,7435878,7435876,'unk',20,1),(161,7435879,7435876,'nkn',20,1),(161,7435880,7435876,'kno',20,1),(161,7435881,7435876,'now',20,1),(161,7435882,7435876,'own',20,1),(161,7435883,7435878,'oth',33.333,1),(161,7435884,7435878,'the',33.333,1),(161,7435885,7435878,'her',33.333,1),(161,7435886,7435883,'uid',50,1),(161,7435887,7435883,'ids',50,1),(161,7435888,7435886,'vml',100,1),(161,7435889,7435888,'dis',20,1),(161,7435890,7435888,'isp',20,1),(161,7435891,7435888,'spl',20,1),(161,7435892,7435888,'pla',20,1),(161,7435893,7435888,'lay',20,1),(161,7435894,7435889,'nam',50,1),(161,7435895,7435889,'ame',50,1),(162,7435897,7435896,'net',25,3),(162,7435898,7435896,'eta',25,3),(162,7435899,7435896,'tap',25,3),(162,7435900,7435896,'app',25,3),(162,7435901,7435897,'fib',33.333,2),(162,7435902,7435897,'ibr',33.333,2),(162,7435903,7435897,'bre',33.333,2),(162,7435904,7435901,'cha',20,2),(162,7435905,7435901,'han',20,2),(162,7435906,7435901,'ann',20,2),(162,7435907,7435901,'nne',20,2),(162,7435908,7435901,'nel',20,2),(162,7435909,7435904,'dis',50,2),(162,7435910,7435904,'isk',50,2),(162,7435911,7435909,'naa',100,4),(162,7435912,7435911,'600',3.333,4),(162,7435913,7435911,'00a',3.333,4),(162,7435914,7435911,'0a0',3.333,4),(162,7435915,7435911,'a09',3.333,4),(162,7435916,7435911,'098',3.333,4),(162,7435917,7435911,'980',3.333,4),(162,7435918,7435911,'804',3.333,4),(162,7435919,7435911,'044',3.333,4),(162,7435920,7435911,'443',3.333,4),(162,7435921,7435911,'430',3.333,4),(162,7435922,7435911,'307',3.333,4),(162,7435923,7435911,'072',3.333,4),(162,7435924,7435911,'725',3.333,4),(162,7435925,7435911,'259',3.333,4),(162,7435926,7435911,'593',3.333,4),(162,7435927,7435911,'931',3.333,4),(162,7435928,7435911,'313',3.333,4),(162,7435929,7435911,'13f',3.333,4),(162,7435930,7435911,'3f3',3.333,4),(162,7435931,7435911,'f33',3.333,4),(162,7435932,7435911,'334',3.333,4),(162,7435933,7435911,'345',3.333,4),(162,7435934,7435911,'455',3.333,4),(162,7435935,7435911,'556',3.333,4),(162,7435936,7435911,'563',3.333,4),(162,7435937,7435911,'639',3.333,4),(162,7435938,7435911,'393',3.333,4),(162,7435939,7435911,'934',3.333,4),(162,7435940,7435911,'345',3.333,4),(162,7435941,7435911,'450',3.333,4),(162,7435942,7435912,'ser',25,1),(162,7435943,7435912,'eri',25,1),(162,7435944,7435912,'ria',25,1),(162,7435945,7435912,'ial',25,1),(162,7435946,7435942,'siz',50,1),(162,7435947,7435942,'ize',50,1),(162,7435948,7435946,'321',100,1),(162,7435949,7435948,'dev',25,1),(162,7435950,7435948,'evi',25,1),(162,7435951,7435948,'vic',25,1),(162,7435952,7435948,'ice',25,1),(162,7435953,7435949,'typ',50,1),(162,7435954,7435949,'ype',50,1),(162,7435955,7435953,'dir',10,1),(162,7435956,7435953,'ire',10,1),(162,7435957,7435953,'rec',10,1),(162,7435958,7435953,'ect',10,1),(162,7435959,7435953,'cta',10,1),(162,7435960,7435953,'tac',10,1),(162,7435961,7435953,'acc',10,1),(162,7435962,7435953,'cce',10,1),(162,7435963,7435953,'ces',10,1),(162,7435964,7435953,'ess',10,1),(162,7435965,7435955,'mul',14.286,1),(162,7435966,7435955,'ult',14.286,1),(162,7435967,7435955,'lti',14.286,1),(162,7435968,7435955,'tip',14.286,1),(162,7435969,7435955,'ipa',14.286,1),(162,7435970,7435955,'pat',14.286,1),(162,7435971,7435955,'ath',14.286,1),(162,7435972,7435965,'plu',25,1),(162,7435973,7435965,'lug',25,1),(162,7435974,7435965,'ugi',25,1),(162,7435975,7435965,'gin',25,1),(162,7435976,7435972,'nmp',100,1),(162,7435977,7435976,'dev',33.333,1),(162,7435978,7435976,'evf',33.333,1),(162,7435979,7435976,'vfs',33.333,1),(162,7435980,7435977,'pat',50,1),(162,7435981,7435977,'ath',50,1),(162,7435982,7435980,'vmf',50,1),(162,7435983,7435980,'mfs',50,1),(162,7435984,7435982,'dev',20,1),(162,7435985,7435982,'evi',20,1),(162,7435986,7435982,'vic',20,1),(162,7435987,7435982,'ice',20,1),(162,7435988,7435982,'ces',20,1),(162,7435989,7435984,'dis',33.333,1),(162,7435990,7435984,'isk',33.333,1),(162,7435991,7435984,'sks',33.333,1),(162,7435992,7435989,'ven',25,1),(162,7435993,7435989,'end',25,1),(162,7435994,7435989,'ndo',25,1),(162,7435995,7435989,'dor',25,1),(162,7435996,7435992,'mod',33.333,1),(162,7435997,7435992,'ode',33.333,1),(162,7435998,7435992,'del',33.333,1),(162,7435999,7435996,'lun',100,1),(162,7436000,7435999,'cmo',33.333,1),(162,7436001,7435999,'mod',33.333,1),(162,7436002,7435999,'ode',33.333,1),(162,7436003,7436000,'rev',16.667,1),(162,7436004,7436000,'evi',16.667,1),(162,7436005,7436000,'vis',16.667,1),(162,7436006,7436000,'isi',16.667,1),(162,7436007,7436000,'sio',16.667,1),(162,7436008,7436000,'ion',16.667,1),(162,7436009,7436003,'810',50,1),(162,7436010,7436003,'100',50,1),(162,7436011,7436009,'scs',50,1),(162,7436012,7436009,'csi',50,1),(162,7436013,7436011,'lev',33.333,1),(162,7436014,7436011,'eve',33.333,1),(162,7436015,7436011,'vel',33.333,1),(162,7436016,7436013,'pse',25,1),(162,7436017,7436013,'seu',25,1),(162,7436018,7436013,'eud',25,1),(162,7436019,7436013,'udo',25,1),(162,7436020,7436016,'fal',33.333,6),(162,7436021,7436016,'als',33.333,6),(162,7436022,7436016,'lse',33.333,6),(162,7436023,7436020,'sta',25,3),(162,7436024,7436020,'tat',25,3),(162,7436025,7436020,'atu',25,3),(162,7436026,7436020,'tus',25,3),(162,7436027,7436023,'rdm',100,1),(162,7436028,7436027,'cap',20,1),(162,7436029,7436027,'apa',20,1),(162,7436030,7436027,'pab',20,1),(162,7436031,7436027,'abl',20,1),(162,7436032,7436027,'ble',20,1),(162,7436033,7436028,'tru',50,1),(162,7436034,7436028,'rue',50,1),(162,7436035,7436033,'loc',33.333,1),(162,7436036,7436033,'oca',33.333,1),(162,7436037,7436033,'cal',33.333,1),(162,7436038,7436035,'rem',14.286,1),(162,7436039,7436035,'emo',14.286,1),(162,7436040,7436035,'mov',14.286,1),(162,7436041,7436035,'ova',14.286,1),(162,7436042,7436035,'vab',14.286,1),(162,7436043,7436035,'abl',14.286,1),(162,7436044,7436035,'ble',14.286,1),(162,7436045,7436038,'ssd',100,1),(162,7436046,7436045,'off',20,1),(162,7436047,7436045,'ffl',20,1),(162,7436048,7436045,'fli',20,1),(162,7436049,7436045,'lin',20,1),(162,7436050,7436045,'ine',20,1),(162,7436051,7436046,'per',11.111,1),(162,7436052,7436046,'ere',11.111,1),(162,7436053,7436046,'ren',11.111,1),(162,7436054,7436046,'enn',11.111,1),(162,7436055,7436046,'nni',11.111,1),(162,7436056,7436046,'nia',11.111,1),(162,7436057,7436046,'ial',11.111,1),(162,7436058,7436046,'all',11.111,1),(162,7436059,7436046,'lly',11.111,1),(162,7436060,7436051,'res',16.667,1),(162,7436061,7436051,'ese',16.667,1),(162,7436062,7436051,'ser',16.667,1),(162,7436063,7436051,'erv',16.667,1),(162,7436064,7436051,'rve',16.667,1),(162,7436065,7436051,'ved',16.667,1),(162,7436066,7436060,'thi',50,1),(162,7436067,7436060,'hin',50,1),(162,7436068,7436066,'pro',10,1),(162,7436069,7436066,'rov',10,1),(162,7436070,7436066,'ovi',10,1),(162,7436071,7436066,'vis',10,1),(162,7436072,7436066,'isi',10,1),(162,7436073,7436066,'sio',10,1),(162,7436074,7436066,'ion',10,1),(162,7436075,7436066,'oni',10,1),(162,7436076,7436066,'nin',10,1),(162,7436077,7436066,'ing',10,1),(162,7436078,7436068,'yes',100,1),(162,7436079,7436078,'att',16.667,1),(162,7436080,7436078,'tta',16.667,1),(162,7436081,7436078,'tac',16.667,1),(162,7436082,7436078,'ach',16.667,1),(162,7436083,7436078,'che',16.667,1),(162,7436084,7436078,'hed',16.667,1),(162,7436085,7436079,'fil',20,1),(162,7436086,7436079,'ilt',20,1),(162,7436087,7436079,'lte',20,1),(162,7436088,7436079,'ter',20,1),(162,7436089,7436079,'ers',20,1),(162,7436090,7436085,'vaa',50,1),(162,7436091,7436085,'aai',50,1),(162,7436092,7436090,'unk',20,1),(162,7436093,7436090,'nkn',20,1),(162,7436094,7436090,'kno',20,1),(162,7436095,7436090,'now',20,1),(162,7436096,7436090,'own',20,1),(162,7436097,7436092,'oth',33.333,1),(162,7436098,7436092,'the',33.333,1),(162,7436099,7436092,'her',33.333,1),(162,7436100,7436097,'uid',50,1),(162,7436101,7436097,'ids',50,1),(162,7436102,7436100,'vml',100,1),(162,7436103,7436102,'dis',20,1),(162,7436104,7436102,'isp',20,1),(162,7436105,7436102,'spl',20,1),(162,7436106,7436102,'pla',20,1),(162,7436107,7436102,'lay',20,1),(162,7436108,7436103,'nam',50,1),(162,7436109,7436103,'ame',50,1),(163,7436111,7436110,'net',25,3),(163,7436112,7436110,'eta',25,3),(163,7436113,7436110,'tap',25,3),(163,7436114,7436110,'app',25,3),(163,7436115,7436111,'fib',33.333,2),(163,7436116,7436111,'ibr',33.333,2),(163,7436117,7436111,'bre',33.333,2),(163,7436118,7436115,'cha',20,2),(163,7436119,7436115,'han',20,2),(163,7436120,7436115,'ann',20,2),(163,7436121,7436115,'nne',20,2),(163,7436122,7436115,'nel',20,2),(163,7436123,7436118,'dis',50,2),(163,7436124,7436118,'isk',50,2),(163,7436125,7436123,'naa',100,4),(163,7436126,7436125,'600',3.333,4),(163,7436127,7436125,'00a',3.333,4),(163,7436128,7436125,'0a0',3.333,4),(163,7436129,7436125,'a09',3.333,4),(163,7436130,7436125,'098',3.333,4),(163,7436131,7436125,'980',3.333,4),(163,7436132,7436125,'804',3.333,4),(163,7436133,7436125,'044',3.333,4),(163,7436134,7436125,'443',3.333,4),(163,7436135,7436125,'430',3.333,4),(163,7436136,7436125,'307',3.333,4),(163,7436137,7436125,'072',3.333,4),(163,7436138,7436125,'725',3.333,4),(163,7436139,7436125,'259',3.333,4),(163,7436140,7436125,'593',3.333,4),(163,7436141,7436125,'931',3.333,4),(163,7436142,7436125,'313',3.333,4),(163,7436143,7436125,'13f',3.333,4),(163,7436144,7436125,'3f3',3.333,4),(163,7436145,7436125,'f33',3.333,4),(163,7436146,7436125,'334',3.333,4),(163,7436147,7436125,'345',3.333,4),(163,7436148,7436125,'455',3.333,4),(163,7436149,7436125,'556',3.333,4),(163,7436150,7436125,'563',3.333,4),(163,7436151,7436125,'639',3.333,4),(163,7436152,7436125,'393',3.333,4),(163,7436153,7436125,'933',3.333,4),(163,7436154,7436125,'337',3.333,4),(163,7436155,7436125,'374',3.333,4),(163,7436156,7436126,'ser',25,1),(163,7436157,7436126,'eri',25,1),(163,7436158,7436126,'ria',25,1),(163,7436159,7436126,'ial',25,1),(163,7436160,7436156,'siz',50,1),(163,7436161,7436156,'ize',50,1),(163,7436162,7436160,'460',33.333,1),(163,7436163,7436160,'608',33.333,1),(163,7436164,7436160,'080',33.333,1),(163,7436165,7436162,'dev',25,1),(163,7436166,7436162,'evi',25,1),(163,7436167,7436162,'vic',25,1),(163,7436168,7436162,'ice',25,1),(163,7436169,7436165,'typ',50,1),(163,7436170,7436165,'ype',50,1),(163,7436171,7436169,'dir',10,1),(163,7436172,7436169,'ire',10,1),(163,7436173,7436169,'rec',10,1),(163,7436174,7436169,'ect',10,1),(163,7436175,7436169,'cta',10,1),(163,7436176,7436169,'tac',10,1),(163,7436177,7436169,'acc',10,1),(163,7436178,7436169,'cce',10,1),(163,7436179,7436169,'ces',10,1),(163,7436180,7436169,'ess',10,1),(163,7436181,7436171,'mul',14.286,1),(163,7436182,7436171,'ult',14.286,1),(163,7436183,7436171,'lti',14.286,1),(163,7436184,7436171,'tip',14.286,1),(163,7436185,7436171,'ipa',14.286,1),(163,7436186,7436171,'pat',14.286,1),(163,7436187,7436171,'ath',14.286,1),(163,7436188,7436181,'plu',25,1),(163,7436189,7436181,'lug',25,1),(163,7436190,7436181,'ugi',25,1),(163,7436191,7436181,'gin',25,1),(163,7436192,7436188,'nmp',100,1),(163,7436193,7436192,'dev',33.333,1),(163,7436194,7436192,'evf',33.333,1),(163,7436195,7436192,'vfs',33.333,1),(163,7436196,7436193,'pat',50,1),(163,7436197,7436193,'ath',50,1),(163,7436198,7436196,'vmf',50,1),(163,7436199,7436196,'mfs',50,1),(163,7436200,7436198,'dev',20,1),(163,7436201,7436198,'evi',20,1),(163,7436202,7436198,'vic',20,1),(163,7436203,7436198,'ice',20,1),(163,7436204,7436198,'ces',20,1),(163,7436205,7436200,'dis',33.333,1),(163,7436206,7436200,'isk',33.333,1),(163,7436207,7436200,'sks',33.333,1),(163,7436208,7436205,'ven',25,1),(163,7436209,7436205,'end',25,1),(163,7436210,7436205,'ndo',25,1),(163,7436211,7436205,'dor',25,1),(163,7436212,7436208,'mod',33.333,1),(163,7436213,7436208,'ode',33.333,1),(163,7436214,7436208,'del',33.333,1),(163,7436215,7436212,'lun',100,1),(163,7436216,7436215,'cmo',33.333,1),(163,7436217,7436215,'mod',33.333,1),(163,7436218,7436215,'ode',33.333,1),(163,7436219,7436216,'rev',16.667,1),(163,7436220,7436216,'evi',16.667,1),(163,7436221,7436216,'vis',16.667,1),(163,7436222,7436216,'isi',16.667,1),(163,7436223,7436216,'sio',16.667,1),(163,7436224,7436216,'ion',16.667,1),(163,7436225,7436219,'810',50,1),(163,7436226,7436219,'100',50,1),(163,7436227,7436225,'scs',50,1),(163,7436228,7436225,'csi',50,1),(163,7436229,7436227,'lev',33.333,1),(163,7436230,7436227,'eve',33.333,1),(163,7436231,7436227,'vel',33.333,1),(163,7436232,7436229,'pse',25,1),(163,7436233,7436229,'seu',25,1),(163,7436234,7436229,'eud',25,1),(163,7436235,7436229,'udo',25,1),(163,7436236,7436232,'fal',33.333,6),(163,7436237,7436232,'als',33.333,6),(163,7436238,7436232,'lse',33.333,6),(163,7436239,7436236,'sta',25,3),(163,7436240,7436236,'tat',25,3),(163,7436241,7436236,'atu',25,3),(163,7436242,7436236,'tus',25,3),(163,7436243,7436239,'rdm',100,1),(163,7436244,7436243,'cap',20,1),(163,7436245,7436243,'apa',20,1),(163,7436246,7436243,'pab',20,1),(163,7436247,7436243,'abl',20,1),(163,7436248,7436243,'ble',20,1),(163,7436249,7436244,'tru',50,1),(163,7436250,7436244,'rue',50,1),(163,7436251,7436249,'loc',33.333,1),(163,7436252,7436249,'oca',33.333,1),(163,7436253,7436249,'cal',33.333,1),(163,7436254,7436251,'rem',14.286,1),(163,7436255,7436251,'emo',14.286,1),(163,7436256,7436251,'mov',14.286,1),(163,7436257,7436251,'ova',14.286,1),(163,7436258,7436251,'vab',14.286,1),(163,7436259,7436251,'abl',14.286,1),(163,7436260,7436251,'ble',14.286,1),(163,7436261,7436254,'ssd',100,1),(163,7436262,7436261,'off',20,1),(163,7436263,7436261,'ffl',20,1),(163,7436264,7436261,'fli',20,1),(163,7436265,7436261,'lin',20,1),(163,7436266,7436261,'ine',20,1),(163,7436267,7436262,'per',11.111,1),(163,7436268,7436262,'ere',11.111,1),(163,7436269,7436262,'ren',11.111,1),(163,7436270,7436262,'enn',11.111,1),(163,7436271,7436262,'nni',11.111,1),(163,7436272,7436262,'nia',11.111,1),(163,7436273,7436262,'ial',11.111,1),(163,7436274,7436262,'all',11.111,1),(163,7436275,7436262,'lly',11.111,1),(163,7436276,7436267,'res',16.667,1),(163,7436277,7436267,'ese',16.667,1),(163,7436278,7436267,'ser',16.667,1),(163,7436279,7436267,'erv',16.667,1),(163,7436280,7436267,'rve',16.667,1),(163,7436281,7436267,'ved',16.667,1),(163,7436282,7436276,'thi',50,1),(163,7436283,7436276,'hin',50,1),(163,7436284,7436282,'pro',10,1),(163,7436285,7436282,'rov',10,1),(163,7436286,7436282,'ovi',10,1),(163,7436287,7436282,'vis',10,1),(163,7436288,7436282,'isi',10,1),(163,7436289,7436282,'sio',10,1),(163,7436290,7436282,'ion',10,1),(163,7436291,7436282,'oni',10,1),(163,7436292,7436282,'nin',10,1),(163,7436293,7436282,'ing',10,1),(163,7436294,7436284,'yes',100,1),(163,7436295,7436294,'att',16.667,1),(163,7436296,7436294,'tta',16.667,1),(163,7436297,7436294,'tac',16.667,1),(163,7436298,7436294,'ach',16.667,1),(163,7436299,7436294,'che',16.667,1),(163,7436300,7436294,'hed',16.667,1),(163,7436301,7436295,'fil',20,1),(163,7436302,7436295,'ilt',20,1),(163,7436303,7436295,'lte',20,1),(163,7436304,7436295,'ter',20,1),(163,7436305,7436295,'ers',20,1),(163,7436306,7436301,'vaa',50,1),(163,7436307,7436301,'aai',50,1),(163,7436308,7436306,'unk',20,1),(163,7436309,7436306,'nkn',20,1),(163,7436310,7436306,'kno',20,1),(163,7436311,7436306,'now',20,1),(163,7436312,7436306,'own',20,1),(163,7436313,7436308,'oth',33.333,1),(163,7436314,7436308,'the',33.333,1),(163,7436315,7436308,'her',33.333,1),(163,7436316,7436313,'uid',50,1),(163,7436317,7436313,'ids',50,1),(163,7436318,7436316,'vml',100,1),(163,7436319,7436318,'dis',20,1),(163,7436320,7436318,'isp',20,1),(163,7436321,7436318,'spl',20,1),(163,7436322,7436318,'pla',20,1),(163,7436323,7436318,'lay',20,1),(163,7436324,7436319,'nam',50,1),(163,7436325,7436319,'ame',50,1),(164,7436327,7436326,'net',25,3),(164,7436328,7436326,'eta',25,3),(164,7436329,7436326,'tap',25,3),(164,7436330,7436326,'app',25,3),(164,7436331,7436327,'fib',33.333,2),(164,7436332,7436327,'ibr',33.333,2),(164,7436333,7436327,'bre',33.333,2),(164,7436334,7436331,'cha',20,2),(164,7436335,7436331,'han',20,2),(164,7436336,7436331,'ann',20,2),(164,7436337,7436331,'nne',20,2),(164,7436338,7436331,'nel',20,2),(164,7436339,7436334,'dis',50,2),(164,7436340,7436334,'isk',50,2),(164,7436341,7436339,'naa',100,4),(164,7436342,7436341,'600',3.333,4),(164,7436343,7436341,'00a',3.333,4),(164,7436344,7436341,'0a0',3.333,4),(164,7436345,7436341,'a09',3.333,4),(164,7436346,7436341,'098',3.333,4),(164,7436347,7436341,'980',3.333,4),(164,7436348,7436341,'804',3.333,4),(164,7436349,7436341,'044',3.333,4),(164,7436350,7436341,'443',3.333,4),(164,7436351,7436341,'430',3.333,4),(164,7436352,7436341,'307',3.333,4),(164,7436353,7436341,'072',3.333,4),(164,7436354,7436341,'725',3.333,4),(164,7436355,7436341,'259',3.333,4),(164,7436356,7436341,'593',3.333,4),(164,7436357,7436341,'931',3.333,4),(164,7436358,7436341,'313',3.333,4),(164,7436359,7436341,'13f',3.333,4),(164,7436360,7436341,'3f3',3.333,4),(164,7436361,7436341,'f33',3.333,4),(164,7436362,7436341,'334',3.333,4),(164,7436363,7436341,'345',3.333,4),(164,7436364,7436341,'455',3.333,4),(164,7436365,7436341,'556',3.333,4),(164,7436366,7436341,'563',3.333,4),(164,7436367,7436341,'639',3.333,4),(164,7436368,7436341,'393',3.333,4),(164,7436369,7436341,'934',3.333,4),(164,7436370,7436341,'345',3.333,4),(164,7436371,7436341,'451',3.333,4),(164,7436372,7436342,'ser',25,1),(164,7436373,7436342,'eri',25,1),(164,7436374,7436342,'ria',25,1),(164,7436375,7436342,'ial',25,1),(164,7436376,7436372,'siz',50,1),(164,7436377,7436372,'ize',50,1),(164,7436378,7436376,'321',100,1),(164,7436379,7436378,'dev',25,1),(164,7436380,7436378,'evi',25,1),(164,7436381,7436378,'vic',25,1),(164,7436382,7436378,'ice',25,1),(164,7436383,7436379,'typ',50,1),(164,7436384,7436379,'ype',50,1),(164,7436385,7436383,'dir',10,1),(164,7436386,7436383,'ire',10,1),(164,7436387,7436383,'rec',10,1),(164,7436388,7436383,'ect',10,1),(164,7436389,7436383,'cta',10,1),(164,7436390,7436383,'tac',10,1),(164,7436391,7436383,'acc',10,1),(164,7436392,7436383,'cce',10,1),(164,7436393,7436383,'ces',10,1),(164,7436394,7436383,'ess',10,1),(164,7436395,7436385,'mul',14.286,1),(164,7436396,7436385,'ult',14.286,1),(164,7436397,7436385,'lti',14.286,1),(164,7436398,7436385,'tip',14.286,1),(164,7436399,7436385,'ipa',14.286,1),(164,7436400,7436385,'pat',14.286,1),(164,7436401,7436385,'ath',14.286,1),(164,7436402,7436395,'plu',25,1),(164,7436403,7436395,'lug',25,1),(164,7436404,7436395,'ugi',25,1),(164,7436405,7436395,'gin',25,1),(164,7436406,7436402,'nmp',100,1),(164,7436407,7436406,'dev',33.333,1),(164,7436408,7436406,'evf',33.333,1),(164,7436409,7436406,'vfs',33.333,1),(164,7436410,7436407,'pat',50,1),(164,7436411,7436407,'ath',50,1),(164,7436412,7436410,'vmf',50,1),(164,7436413,7436410,'mfs',50,1),(164,7436414,7436412,'dev',20,1),(164,7436415,7436412,'evi',20,1),(164,7436416,7436412,'vic',20,1),(164,7436417,7436412,'ice',20,1),(164,7436418,7436412,'ces',20,1),(164,7436419,7436414,'dis',33.333,1),(164,7436420,7436414,'isk',33.333,1),(164,7436421,7436414,'sks',33.333,1),(164,7436422,7436419,'ven',25,1),(164,7436423,7436419,'end',25,1),(164,7436424,7436419,'ndo',25,1),(164,7436425,7436419,'dor',25,1),(164,7436426,7436422,'mod',33.333,1),(164,7436427,7436422,'ode',33.333,1),(164,7436428,7436422,'del',33.333,1),(164,7436429,7436426,'lun',100,1),(164,7436430,7436429,'cmo',33.333,1),(164,7436431,7436429,'mod',33.333,1),(164,7436432,7436429,'ode',33.333,1),(164,7436433,7436430,'rev',16.667,1),(164,7436434,7436430,'evi',16.667,1),(164,7436435,7436430,'vis',16.667,1),(164,7436436,7436430,'isi',16.667,1),(164,7436437,7436430,'sio',16.667,1),(164,7436438,7436430,'ion',16.667,1),(164,7436439,7436433,'810',50,1),(164,7436440,7436433,'100',50,1),(164,7436441,7436439,'scs',50,1),(164,7436442,7436439,'csi',50,1),(164,7436443,7436441,'lev',33.333,1),(164,7436444,7436441,'eve',33.333,1),(164,7436445,7436441,'vel',33.333,1),(164,7436446,7436443,'pse',25,1),(164,7436447,7436443,'seu',25,1),(164,7436448,7436443,'eud',25,1),(164,7436449,7436443,'udo',25,1),(164,7436450,7436446,'fal',33.333,6),(164,7436451,7436446,'als',33.333,6),(164,7436452,7436446,'lse',33.333,6),(164,7436453,7436450,'sta',25,3),(164,7436454,7436450,'tat',25,3),(164,7436455,7436450,'atu',25,3),(164,7436456,7436450,'tus',25,3),(164,7436457,7436453,'rdm',100,1),(164,7436458,7436457,'cap',20,1),(164,7436459,7436457,'apa',20,1),(164,7436460,7436457,'pab',20,1),(164,7436461,7436457,'abl',20,1),(164,7436462,7436457,'ble',20,1),(164,7436463,7436458,'tru',50,1),(164,7436464,7436458,'rue',50,1),(164,7436465,7436463,'loc',33.333,1),(164,7436466,7436463,'oca',33.333,1),(164,7436467,7436463,'cal',33.333,1),(164,7436468,7436465,'rem',14.286,1),(164,7436469,7436465,'emo',14.286,1),(164,7436470,7436465,'mov',14.286,1),(164,7436471,7436465,'ova',14.286,1),(164,7436472,7436465,'vab',14.286,1),(164,7436473,7436465,'abl',14.286,1),(164,7436474,7436465,'ble',14.286,1),(164,7436475,7436468,'ssd',100,1),(164,7436476,7436475,'off',20,1),(164,7436477,7436475,'ffl',20,1),(164,7436478,7436475,'fli',20,1),(164,7436479,7436475,'lin',20,1),(164,7436480,7436475,'ine',20,1),(164,7436481,7436476,'per',11.111,1),(164,7436482,7436476,'ere',11.111,1),(164,7436483,7436476,'ren',11.111,1),(164,7436484,7436476,'enn',11.111,1),(164,7436485,7436476,'nni',11.111,1),(164,7436486,7436476,'nia',11.111,1),(164,7436487,7436476,'ial',11.111,1),(164,7436488,7436476,'all',11.111,1),(164,7436489,7436476,'lly',11.111,1),(164,7436490,7436481,'res',16.667,1),(164,7436491,7436481,'ese',16.667,1),(164,7436492,7436481,'ser',16.667,1),(164,7436493,7436481,'erv',16.667,1),(164,7436494,7436481,'rve',16.667,1),(164,7436495,7436481,'ved',16.667,1),(164,7436496,7436490,'thi',50,1),(164,7436497,7436490,'hin',50,1),(164,7436498,7436496,'pro',10,1),(164,7436499,7436496,'rov',10,1),(164,7436500,7436496,'ovi',10,1),(164,7436501,7436496,'vis',10,1),(164,7436502,7436496,'isi',10,1),(164,7436503,7436496,'sio',10,1),(164,7436504,7436496,'ion',10,1),(164,7436505,7436496,'oni',10,1),(164,7436506,7436496,'nin',10,1),(164,7436507,7436496,'ing',10,1),(164,7436508,7436498,'yes',100,1),(164,7436509,7436508,'att',16.667,1),(164,7436510,7436508,'tta',16.667,1),(164,7436511,7436508,'tac',16.667,1),(164,7436512,7436508,'ach',16.667,1),(164,7436513,7436508,'che',16.667,1),(164,7436514,7436508,'hed',16.667,1),(164,7436515,7436509,'fil',20,1),(164,7436516,7436509,'ilt',20,1),(164,7436517,7436509,'lte',20,1),(164,7436518,7436509,'ter',20,1),(164,7436519,7436509,'ers',20,1),(164,7436520,7436515,'vaa',50,1),(164,7436521,7436515,'aai',50,1),(164,7436522,7436520,'unk',20,1),(164,7436523,7436520,'nkn',20,1),(164,7436524,7436520,'kno',20,1),(164,7436525,7436520,'now',20,1),(164,7436526,7436520,'own',20,1),(164,7436527,7436522,'oth',33.333,1),(164,7436528,7436522,'the',33.333,1),(164,7436529,7436522,'her',33.333,1),(164,7436530,7436527,'uid',50,1),(164,7436531,7436527,'ids',50,1),(164,7436532,7436530,'vml',100,1),(164,7436533,7436532,'dis',20,1),(164,7436534,7436532,'isp',20,1),(164,7436535,7436532,'spl',20,1),(164,7436536,7436532,'pla',20,1),(164,7436537,7436532,'lay',20,1),(164,7436538,7436533,'nam',50,1),(164,7436539,7436533,'ame',50,1),(165,7436541,7436540,'net',25,3),(165,7436542,7436540,'eta',25,3),(165,7436543,7436540,'tap',25,3),(165,7436544,7436540,'app',25,3),(165,7436545,7436541,'fib',33.333,2),(165,7436546,7436541,'ibr',33.333,2),(165,7436547,7436541,'bre',33.333,2),(165,7436548,7436545,'cha',20,2),(165,7436549,7436545,'han',20,2),(165,7436550,7436545,'ann',20,2),(165,7436551,7436545,'nne',20,2),(165,7436552,7436545,'nel',20,2),(165,7436553,7436548,'dis',50,2),(165,7436554,7436548,'isk',50,2),(165,7436555,7436553,'naa',100,4),(165,7436556,7436555,'600',3.333,4),(165,7436557,7436555,'00a',3.333,4),(165,7436558,7436555,'0a0',3.333,4),(165,7436559,7436555,'a09',3.333,4),(165,7436560,7436555,'098',3.333,4),(165,7436561,7436555,'980',3.333,4),(165,7436562,7436555,'804',3.333,4),(165,7436563,7436555,'044',3.333,4),(165,7436564,7436555,'443',3.333,4),(165,7436565,7436555,'430',3.333,4),(165,7436566,7436555,'307',3.333,4),(165,7436567,7436555,'072',3.333,4),(165,7436568,7436555,'725',3.333,4),(165,7436569,7436555,'259',3.333,4),(165,7436570,7436555,'593',3.333,4),(165,7436571,7436555,'931',3.333,4),(165,7436572,7436555,'313',3.333,4),(165,7436573,7436555,'13f',3.333,4),(165,7436574,7436555,'3f3',3.333,4),(165,7436575,7436555,'f33',3.333,4),(165,7436576,7436555,'334',3.333,4),(165,7436577,7436555,'345',3.333,4),(165,7436578,7436555,'455',3.333,4),(165,7436579,7436555,'556',3.333,4),(165,7436580,7436555,'563',3.333,4),(165,7436581,7436555,'639',3.333,4),(165,7436582,7436555,'393',3.333,4),(165,7436583,7436555,'933',3.333,4),(165,7436584,7436555,'337',3.333,4),(165,7436585,7436555,'375',3.333,4),(165,7436586,7436556,'ser',25,1),(165,7436587,7436556,'eri',25,1),(165,7436588,7436556,'ria',25,1),(165,7436589,7436556,'ial',25,1),(165,7436590,7436586,'siz',50,1),(165,7436591,7436586,'ize',50,1),(165,7436592,7436590,'460',33.333,1),(165,7436593,7436590,'608',33.333,1),(165,7436594,7436590,'080',33.333,1),(165,7436595,7436592,'dev',25,1),(165,7436596,7436592,'evi',25,1),(165,7436597,7436592,'vic',25,1),(165,7436598,7436592,'ice',25,1),(165,7436599,7436595,'typ',50,1),(165,7436600,7436595,'ype',50,1),(165,7436601,7436599,'dir',10,1),(165,7436602,7436599,'ire',10,1),(165,7436603,7436599,'rec',10,1),(165,7436604,7436599,'ect',10,1),(165,7436605,7436599,'cta',10,1),(165,7436606,7436599,'tac',10,1),(165,7436607,7436599,'acc',10,1),(165,7436608,7436599,'cce',10,1),(165,7436609,7436599,'ces',10,1),(165,7436610,7436599,'ess',10,1),(165,7436611,7436601,'mul',14.286,1),(165,7436612,7436601,'ult',14.286,1),(165,7436613,7436601,'lti',14.286,1),(165,7436614,7436601,'tip',14.286,1),(165,7436615,7436601,'ipa',14.286,1),(165,7436616,7436601,'pat',14.286,1),(165,7436617,7436601,'ath',14.286,1),(165,7436618,7436611,'plu',25,1),(165,7436619,7436611,'lug',25,1),(165,7436620,7436611,'ugi',25,1),(165,7436621,7436611,'gin',25,1),(165,7436622,7436618,'nmp',100,1),(165,7436623,7436622,'dev',33.333,1),(165,7436624,7436622,'evf',33.333,1),(165,7436625,7436622,'vfs',33.333,1),(165,7436626,7436623,'pat',50,1),(165,7436627,7436623,'ath',50,1),(165,7436628,7436626,'vmf',50,1),(165,7436629,7436626,'mfs',50,1),(165,7436630,7436628,'dev',20,1),(165,7436631,7436628,'evi',20,1),(165,7436632,7436628,'vic',20,1),(165,7436633,7436628,'ice',20,1),(165,7436634,7436628,'ces',20,1),(165,7436635,7436630,'dis',33.333,1),(165,7436636,7436630,'isk',33.333,1),(165,7436637,7436630,'sks',33.333,1),(165,7436638,7436635,'ven',25,1),(165,7436639,7436635,'end',25,1),(165,7436640,7436635,'ndo',25,1),(165,7436641,7436635,'dor',25,1),(165,7436642,7436638,'mod',33.333,1),(165,7436643,7436638,'ode',33.333,1),(165,7436644,7436638,'del',33.333,1),(165,7436645,7436642,'lun',100,1),(165,7436646,7436645,'cmo',33.333,1),(165,7436647,7436645,'mod',33.333,1),(165,7436648,7436645,'ode',33.333,1),(165,7436649,7436646,'rev',16.667,1),(165,7436650,7436646,'evi',16.667,1),(165,7436651,7436646,'vis',16.667,1),(165,7436652,7436646,'isi',16.667,1),(165,7436653,7436646,'sio',16.667,1),(165,7436654,7436646,'ion',16.667,1),(165,7436655,7436649,'810',50,1),(165,7436656,7436649,'100',50,1),(165,7436657,7436655,'scs',50,1),(165,7436658,7436655,'csi',50,1),(165,7436659,7436657,'lev',33.333,1),(165,7436660,7436657,'eve',33.333,1),(165,7436661,7436657,'vel',33.333,1),(165,7436662,7436659,'pse',25,1),(165,7436663,7436659,'seu',25,1),(165,7436664,7436659,'eud',25,1),(165,7436665,7436659,'udo',25,1),(165,7436666,7436662,'fal',33.333,6),(165,7436667,7436662,'als',33.333,6),(165,7436668,7436662,'lse',33.333,6),(165,7436669,7436666,'sta',25,3),(165,7436670,7436666,'tat',25,3),(165,7436671,7436666,'atu',25,3),(165,7436672,7436666,'tus',25,3),(165,7436673,7436669,'rdm',100,1),(165,7436674,7436673,'cap',20,1),(165,7436675,7436673,'apa',20,1),(165,7436676,7436673,'pab',20,1),(165,7436677,7436673,'abl',20,1),(165,7436678,7436673,'ble',20,1),(165,7436679,7436674,'tru',50,1),(165,7436680,7436674,'rue',50,1),(165,7436681,7436679,'loc',33.333,1),(165,7436682,7436679,'oca',33.333,1),(165,7436683,7436679,'cal',33.333,1),(165,7436684,7436681,'rem',14.286,1),(165,7436685,7436681,'emo',14.286,1),(165,7436686,7436681,'mov',14.286,1),(165,7436687,7436681,'ova',14.286,1),(165,7436688,7436681,'vab',14.286,1),(165,7436689,7436681,'abl',14.286,1),(165,7436690,7436681,'ble',14.286,1),(165,7436691,7436684,'ssd',100,1),(165,7436692,7436691,'off',20,1),(165,7436693,7436691,'ffl',20,1),(165,7436694,7436691,'fli',20,1),(165,7436695,7436691,'lin',20,1),(165,7436696,7436691,'ine',20,1),(165,7436697,7436692,'per',11.111,1),(165,7436698,7436692,'ere',11.111,1),(165,7436699,7436692,'ren',11.111,1),(165,7436700,7436692,'enn',11.111,1),(165,7436701,7436692,'nni',11.111,1),(165,7436702,7436692,'nia',11.111,1),(165,7436703,7436692,'ial',11.111,1),(165,7436704,7436692,'all',11.111,1),(165,7436705,7436692,'lly',11.111,1),(165,7436706,7436697,'res',16.667,1),(165,7436707,7436697,'ese',16.667,1),(165,7436708,7436697,'ser',16.667,1),(165,7436709,7436697,'erv',16.667,1),(165,7436710,7436697,'rve',16.667,1),(165,7436711,7436697,'ved',16.667,1),(165,7436712,7436706,'thi',50,1),(165,7436713,7436706,'hin',50,1),(165,7436714,7436712,'pro',10,1),(165,7436715,7436712,'rov',10,1),(165,7436716,7436712,'ovi',10,1),(165,7436717,7436712,'vis',10,1),(165,7436718,7436712,'isi',10,1),(165,7436719,7436712,'sio',10,1),(165,7436720,7436712,'ion',10,1),(165,7436721,7436712,'oni',10,1),(165,7436722,7436712,'nin',10,1),(165,7436723,7436712,'ing',10,1),(165,7436724,7436714,'yes',100,1),(165,7436725,7436724,'att',16.667,1),(165,7436726,7436724,'tta',16.667,1),(165,7436727,7436724,'tac',16.667,1),(165,7436728,7436724,'ach',16.667,1),(165,7436729,7436724,'che',16.667,1),(165,7436730,7436724,'hed',16.667,1),(165,7436731,7436725,'fil',20,1),(165,7436732,7436725,'ilt',20,1),(165,7436733,7436725,'lte',20,1),(165,7436734,7436725,'ter',20,1),(165,7436735,7436725,'ers',20,1),(165,7436736,7436731,'vaa',50,1),(165,7436737,7436731,'aai',50,1),(165,7436738,7436736,'unk',20,1),(165,7436739,7436736,'nkn',20,1),(165,7436740,7436736,'kno',20,1),(165,7436741,7436736,'now',20,1),(165,7436742,7436736,'own',20,1),(165,7436743,7436738,'oth',33.333,1),(165,7436744,7436738,'the',33.333,1),(165,7436745,7436738,'her',33.333,1),(165,7436746,7436743,'uid',50,1),(165,7436747,7436743,'ids',50,1),(165,7436748,7436746,'vml',100,1),(165,7436749,7436748,'dis',20,1),(165,7436750,7436748,'isp',20,1),(165,7436751,7436748,'spl',20,1),(165,7436752,7436748,'pla',20,1),(165,7436753,7436748,'lay',20,1),(165,7436754,7436749,'nam',50,1),(165,7436755,7436749,'ame',50,1),(166,7436757,7436756,'net',25,3),(166,7436758,7436756,'eta',25,3),(166,7436759,7436756,'tap',25,3),(166,7436760,7436756,'app',25,3),(166,7436761,7436757,'fib',33.333,2),(166,7436762,7436757,'ibr',33.333,2),(166,7436763,7436757,'bre',33.333,2),(166,7436764,7436761,'cha',20,2),(166,7436765,7436761,'han',20,2),(166,7436766,7436761,'ann',20,2),(166,7436767,7436761,'nne',20,2),(166,7436768,7436761,'nel',20,2),(166,7436769,7436764,'dis',50,2),(166,7436770,7436764,'isk',50,2),(166,7436771,7436769,'naa',100,4),(166,7436772,7436771,'600',3.333,4),(166,7436773,7436771,'00a',3.333,4),(166,7436774,7436771,'0a0',3.333,4),(166,7436775,7436771,'a09',3.333,4),(166,7436776,7436771,'098',3.333,4),(166,7436777,7436771,'980',3.333,4),(166,7436778,7436771,'804',3.333,4),(166,7436779,7436771,'044',3.333,4),(166,7436780,7436771,'443',3.333,4),(166,7436781,7436771,'430',3.333,4),(166,7436782,7436771,'307',3.333,4),(166,7436783,7436771,'072',3.333,4),(166,7436784,7436771,'725',3.333,4),(166,7436785,7436771,'259',3.333,4),(166,7436786,7436771,'593',3.333,4),(166,7436787,7436771,'931',3.333,4),(166,7436788,7436771,'313',3.333,4),(166,7436789,7436771,'13f',3.333,4),(166,7436790,7436771,'3f3',3.333,4),(166,7436791,7436771,'f33',3.333,4),(166,7436792,7436771,'334',3.333,4),(166,7436793,7436771,'345',3.333,4),(166,7436794,7436771,'455',3.333,4),(166,7436795,7436771,'556',3.333,4),(166,7436796,7436771,'563',3.333,4),(166,7436797,7436771,'639',3.333,4),(166,7436798,7436771,'393',3.333,4),(166,7436799,7436771,'934',3.333,4),(166,7436800,7436771,'345',3.333,4),(166,7436801,7436771,'452',3.333,4),(166,7436802,7436772,'ser',25,1),(166,7436803,7436772,'eri',25,1),(166,7436804,7436772,'ria',25,1),(166,7436805,7436772,'ial',25,1),(166,7436806,7436802,'siz',50,1),(166,7436807,7436802,'ize',50,1),(166,7436808,7436806,'321',100,1),(166,7436809,7436808,'dev',25,1),(166,7436810,7436808,'evi',25,1),(166,7436811,7436808,'vic',25,1),(166,7436812,7436808,'ice',25,1),(166,7436813,7436809,'typ',50,1),(166,7436814,7436809,'ype',50,1),(166,7436815,7436813,'dir',10,1),(166,7436816,7436813,'ire',10,1),(166,7436817,7436813,'rec',10,1),(166,7436818,7436813,'ect',10,1),(166,7436819,7436813,'cta',10,1),(166,7436820,7436813,'tac',10,1),(166,7436821,7436813,'acc',10,1),(166,7436822,7436813,'cce',10,1),(166,7436823,7436813,'ces',10,1),(166,7436824,7436813,'ess',10,1),(166,7436825,7436815,'mul',14.286,1),(166,7436826,7436815,'ult',14.286,1),(166,7436827,7436815,'lti',14.286,1),(166,7436828,7436815,'tip',14.286,1),(166,7436829,7436815,'ipa',14.286,1),(166,7436830,7436815,'pat',14.286,1),(166,7436831,7436815,'ath',14.286,1),(166,7436832,7436825,'plu',25,1),(166,7436833,7436825,'lug',25,1),(166,7436834,7436825,'ugi',25,1),(166,7436835,7436825,'gin',25,1),(166,7436836,7436832,'nmp',100,1),(166,7436837,7436836,'dev',33.333,1),(166,7436838,7436836,'evf',33.333,1),(166,7436839,7436836,'vfs',33.333,1),(166,7436840,7436837,'pat',50,1),(166,7436841,7436837,'ath',50,1),(166,7436842,7436840,'vmf',50,1),(166,7436843,7436840,'mfs',50,1),(166,7436844,7436842,'dev',20,1),(166,7436845,7436842,'evi',20,1),(166,7436846,7436842,'vic',20,1),(166,7436847,7436842,'ice',20,1),(166,7436848,7436842,'ces',20,1),(166,7436849,7436844,'dis',33.333,1),(166,7436850,7436844,'isk',33.333,1),(166,7436851,7436844,'sks',33.333,1),(166,7436852,7436849,'ven',25,1),(166,7436853,7436849,'end',25,1),(166,7436854,7436849,'ndo',25,1),(166,7436855,7436849,'dor',25,1),(166,7436856,7436852,'mod',33.333,1),(166,7436857,7436852,'ode',33.333,1),(166,7436858,7436852,'del',33.333,1),(166,7436859,7436856,'lun',100,1),(166,7436860,7436859,'cmo',33.333,1),(166,7436861,7436859,'mod',33.333,1),(166,7436862,7436859,'ode',33.333,1),(166,7436863,7436860,'rev',16.667,1),(166,7436864,7436860,'evi',16.667,1),(166,7436865,7436860,'vis',16.667,1),(166,7436866,7436860,'isi',16.667,1),(166,7436867,7436860,'sio',16.667,1),(166,7436868,7436860,'ion',16.667,1),(166,7436869,7436863,'810',50,1),(166,7436870,7436863,'100',50,1),(166,7436871,7436869,'scs',50,1),(166,7436872,7436869,'csi',50,1),(166,7436873,7436871,'lev',33.333,1),(166,7436874,7436871,'eve',33.333,1),(166,7436875,7436871,'vel',33.333,1),(166,7436876,7436873,'pse',25,1),(166,7436877,7436873,'seu',25,1),(166,7436878,7436873,'eud',25,1),(166,7436879,7436873,'udo',25,1),(166,7436880,7436876,'fal',33.333,6),(166,7436881,7436876,'als',33.333,6),(166,7436882,7436876,'lse',33.333,6),(166,7436883,7436880,'sta',25,3),(166,7436884,7436880,'tat',25,3),(166,7436885,7436880,'atu',25,3),(166,7436886,7436880,'tus',25,3),(166,7436887,7436883,'rdm',100,1),(166,7436888,7436887,'cap',20,1),(166,7436889,7436887,'apa',20,1),(166,7436890,7436887,'pab',20,1),(166,7436891,7436887,'abl',20,1),(166,7436892,7436887,'ble',20,1),(166,7436893,7436888,'tru',50,1),(166,7436894,7436888,'rue',50,1),(166,7436895,7436893,'loc',33.333,1),(166,7436896,7436893,'oca',33.333,1),(166,7436897,7436893,'cal',33.333,1),(166,7436898,7436895,'rem',14.286,1),(166,7436899,7436895,'emo',14.286,1),(166,7436900,7436895,'mov',14.286,1),(166,7436901,7436895,'ova',14.286,1),(166,7436902,7436895,'vab',14.286,1),(166,7436903,7436895,'abl',14.286,1),(166,7436904,7436895,'ble',14.286,1),(166,7436905,7436898,'ssd',100,1),(166,7436906,7436905,'off',20,1),(166,7436907,7436905,'ffl',20,1),(166,7436908,7436905,'fli',20,1),(166,7436909,7436905,'lin',20,1),(166,7436910,7436905,'ine',20,1),(166,7436911,7436906,'per',11.111,1),(166,7436912,7436906,'ere',11.111,1),(166,7436913,7436906,'ren',11.111,1),(166,7436914,7436906,'enn',11.111,1),(166,7436915,7436906,'nni',11.111,1),(166,7436916,7436906,'nia',11.111,1),(166,7436917,7436906,'ial',11.111,1),(166,7436918,7436906,'all',11.111,1),(166,7436919,7436906,'lly',11.111,1),(166,7436920,7436911,'res',16.667,1),(166,7436921,7436911,'ese',16.667,1),(166,7436922,7436911,'ser',16.667,1),(166,7436923,7436911,'erv',16.667,1),(166,7436924,7436911,'rve',16.667,1),(166,7436925,7436911,'ved',16.667,1),(166,7436926,7436920,'thi',50,1),(166,7436927,7436920,'hin',50,1),(166,7436928,7436926,'pro',10,1),(166,7436929,7436926,'rov',10,1),(166,7436930,7436926,'ovi',10,1),(166,7436931,7436926,'vis',10,1),(166,7436932,7436926,'isi',10,1),(166,7436933,7436926,'sio',10,1),(166,7436934,7436926,'ion',10,1),(166,7436935,7436926,'oni',10,1),(166,7436936,7436926,'nin',10,1),(166,7436937,7436926,'ing',10,1),(166,7436938,7436928,'yes',100,1),(166,7436939,7436938,'att',16.667,1),(166,7436940,7436938,'tta',16.667,1),(166,7436941,7436938,'tac',16.667,1),(166,7436942,7436938,'ach',16.667,1),(166,7436943,7436938,'che',16.667,1),(166,7436944,7436938,'hed',16.667,1),(166,7436945,7436939,'fil',20,1),(166,7436946,7436939,'ilt',20,1),(166,7436947,7436939,'lte',20,1),(166,7436948,7436939,'ter',20,1),(166,7436949,7436939,'ers',20,1),(166,7436950,7436945,'vaa',50,1),(166,7436951,7436945,'aai',50,1),(166,7436952,7436950,'unk',20,1),(166,7436953,7436950,'nkn',20,1),(166,7436954,7436950,'kno',20,1),(166,7436955,7436950,'now',20,1),(166,7436956,7436950,'own',20,1),(166,7436957,7436952,'oth',33.333,1),(166,7436958,7436952,'the',33.333,1),(166,7436959,7436952,'her',33.333,1),(166,7436960,7436957,'uid',50,1),(166,7436961,7436957,'ids',50,1),(166,7436962,7436960,'vml',100,1),(166,7436963,7436962,'dis',20,1),(166,7436964,7436962,'isp',20,1),(166,7436965,7436962,'spl',20,1),(166,7436966,7436962,'pla',20,1),(166,7436967,7436962,'lay',20,1),(166,7436968,7436963,'nam',50,1),(166,7436969,7436963,'ame',50,1),(167,7436971,7436970,'net',25,3),(167,7436972,7436970,'eta',25,3),(167,7436973,7436970,'tap',25,3),(167,7436974,7436970,'app',25,3),(167,7436975,7436971,'fib',33.333,2),(167,7436976,7436971,'ibr',33.333,2),(167,7436977,7436971,'bre',33.333,2),(167,7436978,7436975,'cha',20,2),(167,7436979,7436975,'han',20,2),(167,7436980,7436975,'ann',20,2),(167,7436981,7436975,'nne',20,2),(167,7436982,7436975,'nel',20,2),(167,7436983,7436978,'dis',50,2),(167,7436984,7436978,'isk',50,2),(167,7436985,7436983,'naa',100,4),(167,7436986,7436985,'600',3.333,4),(167,7436987,7436985,'00a',3.333,4),(167,7436988,7436985,'0a0',3.333,4),(167,7436989,7436985,'a09',3.333,4),(167,7436990,7436985,'098',3.333,4),(167,7436991,7436985,'980',3.333,4),(167,7436992,7436985,'804',3.333,4),(167,7436993,7436985,'044',3.333,4),(167,7436994,7436985,'443',3.333,4),(167,7436995,7436985,'430',3.333,4),(167,7436996,7436985,'307',3.333,4),(167,7436997,7436985,'072',3.333,4),(167,7436998,7436985,'725',3.333,4),(167,7436999,7436985,'259',3.333,4),(167,7437000,7436985,'593',3.333,4),(167,7437001,7436985,'931',3.333,4),(167,7437002,7436985,'313',3.333,4),(167,7437003,7436985,'13f',3.333,4),(167,7437004,7436985,'3f3',3.333,4),(167,7437005,7436985,'f33',3.333,4),(167,7437006,7436985,'334',3.333,4),(167,7437007,7436985,'345',3.333,4),(167,7437008,7436985,'455',3.333,4),(167,7437009,7436985,'556',3.333,4),(167,7437010,7436985,'563',3.333,4),(167,7437011,7436985,'639',3.333,4),(167,7437012,7436985,'393',3.333,4),(167,7437013,7436985,'933',3.333,4),(167,7437014,7436985,'337',3.333,4),(167,7437015,7436985,'376',3.333,4),(167,7437016,7436986,'ser',25,1),(167,7437017,7436986,'eri',25,1),(167,7437018,7436986,'ria',25,1),(167,7437019,7436986,'ial',25,1),(167,7437020,7437016,'siz',50,1),(167,7437021,7437016,'ize',50,1),(167,7437022,7437020,'460',33.333,1),(167,7437023,7437020,'608',33.333,1),(167,7437024,7437020,'080',33.333,1),(167,7437025,7437022,'dev',25,1),(167,7437026,7437022,'evi',25,1),(167,7437027,7437022,'vic',25,1),(167,7437028,7437022,'ice',25,1),(167,7437029,7437025,'typ',50,1),(167,7437030,7437025,'ype',50,1),(167,7437031,7437029,'dir',10,1),(167,7437032,7437029,'ire',10,1),(167,7437033,7437029,'rec',10,1),(167,7437034,7437029,'ect',10,1),(167,7437035,7437029,'cta',10,1),(167,7437036,7437029,'tac',10,1),(167,7437037,7437029,'acc',10,1),(167,7437038,7437029,'cce',10,1),(167,7437039,7437029,'ces',10,1),(167,7437040,7437029,'ess',10,1),(167,7437041,7437031,'mul',14.286,1),(167,7437042,7437031,'ult',14.286,1),(167,7437043,7437031,'lti',14.286,1),(167,7437044,7437031,'tip',14.286,1),(167,7437045,7437031,'ipa',14.286,1),(167,7437046,7437031,'pat',14.286,1),(167,7437047,7437031,'ath',14.286,1),(167,7437048,7437041,'plu',25,1),(167,7437049,7437041,'lug',25,1),(167,7437050,7437041,'ugi',25,1),(167,7437051,7437041,'gin',25,1),(167,7437052,7437048,'nmp',100,1),(167,7437053,7437052,'dev',33.333,1),(167,7437054,7437052,'evf',33.333,1),(167,7437055,7437052,'vfs',33.333,1),(167,7437056,7437053,'pat',50,1),(167,7437057,7437053,'ath',50,1),(167,7437058,7437056,'vmf',50,1),(167,7437059,7437056,'mfs',50,1),(167,7437060,7437058,'dev',20,1),(167,7437061,7437058,'evi',20,1),(167,7437062,7437058,'vic',20,1),(167,7437063,7437058,'ice',20,1),(167,7437064,7437058,'ces',20,1),(167,7437065,7437060,'dis',33.333,1),(167,7437066,7437060,'isk',33.333,1),(167,7437067,7437060,'sks',33.333,1),(167,7437068,7437065,'ven',25,1),(167,7437069,7437065,'end',25,1),(167,7437070,7437065,'ndo',25,1),(167,7437071,7437065,'dor',25,1),(167,7437072,7437068,'mod',33.333,1),(167,7437073,7437068,'ode',33.333,1),(167,7437074,7437068,'del',33.333,1),(167,7437075,7437072,'lun',100,1),(167,7437076,7437075,'cmo',33.333,1),(167,7437077,7437075,'mod',33.333,1),(167,7437078,7437075,'ode',33.333,1),(167,7437079,7437076,'rev',16.667,1),(167,7437080,7437076,'evi',16.667,1),(167,7437081,7437076,'vis',16.667,1),(167,7437082,7437076,'isi',16.667,1),(167,7437083,7437076,'sio',16.667,1),(167,7437084,7437076,'ion',16.667,1),(167,7437085,7437079,'810',50,1),(167,7437086,7437079,'100',50,1),(167,7437087,7437085,'scs',50,1),(167,7437088,7437085,'csi',50,1),(167,7437089,7437087,'lev',33.333,1),(167,7437090,7437087,'eve',33.333,1),(167,7437091,7437087,'vel',33.333,1),(167,7437092,7437089,'pse',25,1),(167,7437093,7437089,'seu',25,1),(167,7437094,7437089,'eud',25,1),(167,7437095,7437089,'udo',25,1),(167,7437096,7437092,'fal',33.333,6),(167,7437097,7437092,'als',33.333,6),(167,7437098,7437092,'lse',33.333,6),(167,7437099,7437096,'sta',25,3),(167,7437100,7437096,'tat',25,3),(167,7437101,7437096,'atu',25,3),(167,7437102,7437096,'tus',25,3),(167,7437103,7437099,'rdm',100,1),(167,7437104,7437103,'cap',20,1),(167,7437105,7437103,'apa',20,1),(167,7437106,7437103,'pab',20,1),(167,7437107,7437103,'abl',20,1),(167,7437108,7437103,'ble',20,1),(167,7437109,7437104,'tru',50,1),(167,7437110,7437104,'rue',50,1),(167,7437111,7437109,'loc',33.333,1),(167,7437112,7437109,'oca',33.333,1),(167,7437113,7437109,'cal',33.333,1),(167,7437114,7437111,'rem',14.286,1),(167,7437115,7437111,'emo',14.286,1),(167,7437116,7437111,'mov',14.286,1),(167,7437117,7437111,'ova',14.286,1),(167,7437118,7437111,'vab',14.286,1),(167,7437119,7437111,'abl',14.286,1),(167,7437120,7437111,'ble',14.286,1),(167,7437121,7437114,'ssd',100,1),(167,7437122,7437121,'off',20,1),(167,7437123,7437121,'ffl',20,1),(167,7437124,7437121,'fli',20,1),(167,7437125,7437121,'lin',20,1),(167,7437126,7437121,'ine',20,1),(167,7437127,7437122,'per',11.111,1),(167,7437128,7437122,'ere',11.111,1),(167,7437129,7437122,'ren',11.111,1),(167,7437130,7437122,'enn',11.111,1),(167,7437131,7437122,'nni',11.111,1),(167,7437132,7437122,'nia',11.111,1),(167,7437133,7437122,'ial',11.111,1),(167,7437134,7437122,'all',11.111,1),(167,7437135,7437122,'lly',11.111,1),(167,7437136,7437127,'res',16.667,1),(167,7437137,7437127,'ese',16.667,1),(167,7437138,7437127,'ser',16.667,1),(167,7437139,7437127,'erv',16.667,1),(167,7437140,7437127,'rve',16.667,1),(167,7437141,7437127,'ved',16.667,1),(167,7437142,7437136,'thi',50,1),(167,7437143,7437136,'hin',50,1),(167,7437144,7437142,'pro',10,1),(167,7437145,7437142,'rov',10,1),(167,7437146,7437142,'ovi',10,1),(167,7437147,7437142,'vis',10,1),(167,7437148,7437142,'isi',10,1),(167,7437149,7437142,'sio',10,1),(167,7437150,7437142,'ion',10,1),(167,7437151,7437142,'oni',10,1),(167,7437152,7437142,'nin',10,1),(167,7437153,7437142,'ing',10,1),(167,7437154,7437144,'yes',100,1),(167,7437155,7437154,'att',16.667,1),(167,7437156,7437154,'tta',16.667,1),(167,7437157,7437154,'tac',16.667,1),(167,7437158,7437154,'ach',16.667,1),(167,7437159,7437154,'che',16.667,1),(167,7437160,7437154,'hed',16.667,1),(167,7437161,7437155,'fil',20,1),(167,7437162,7437155,'ilt',20,1),(167,7437163,7437155,'lte',20,1),(167,7437164,7437155,'ter',20,1),(167,7437165,7437155,'ers',20,1),(167,7437166,7437161,'vaa',50,1),(167,7437167,7437161,'aai',50,1),(167,7437168,7437166,'unk',20,1),(167,7437169,7437166,'nkn',20,1),(167,7437170,7437166,'kno',20,1),(167,7437171,7437166,'now',20,1),(167,7437172,7437166,'own',20,1),(167,7437173,7437168,'oth',33.333,1),(167,7437174,7437168,'the',33.333,1),(167,7437175,7437168,'her',33.333,1),(167,7437176,7437173,'uid',50,1),(167,7437177,7437173,'ids',50,1),(167,7437178,7437176,'vml',100,1),(167,7437179,7437178,'dis',20,1),(167,7437180,7437178,'isp',20,1),(167,7437181,7437178,'spl',20,1),(167,7437182,7437178,'pla',20,1),(167,7437183,7437178,'lay',20,1),(167,7437184,7437179,'nam',50,1),(167,7437185,7437179,'ame',50,1),(168,7437187,7437186,'net',25,3),(168,7437188,7437186,'eta',25,3),(168,7437189,7437186,'tap',25,3),(168,7437190,7437186,'app',25,3),(168,7437191,7437187,'fib',33.333,2),(168,7437192,7437187,'ibr',33.333,2),(168,7437193,7437187,'bre',33.333,2),(168,7437194,7437191,'cha',20,2),(168,7437195,7437191,'han',20,2),(168,7437196,7437191,'ann',20,2),(168,7437197,7437191,'nne',20,2),(168,7437198,7437191,'nel',20,2),(168,7437199,7437194,'dis',50,2),(168,7437200,7437194,'isk',50,2),(168,7437201,7437199,'naa',100,4),(168,7437202,7437201,'600',3.333,4),(168,7437203,7437201,'00a',3.333,4),(168,7437204,7437201,'0a0',3.333,4),(168,7437205,7437201,'a09',3.333,4),(168,7437206,7437201,'098',3.333,4),(168,7437207,7437201,'980',3.333,4),(168,7437208,7437201,'804',3.333,4),(168,7437209,7437201,'044',3.333,4),(168,7437210,7437201,'443',3.333,4),(168,7437211,7437201,'430',3.333,4),(168,7437212,7437201,'307',3.333,4),(168,7437213,7437201,'072',3.333,4),(168,7437214,7437201,'725',3.333,4),(168,7437215,7437201,'259',3.333,4),(168,7437216,7437201,'593',3.333,4),(168,7437217,7437201,'931',3.333,4),(168,7437218,7437201,'313',3.333,4),(168,7437219,7437201,'13f',3.333,4),(168,7437220,7437201,'3f3',3.333,4),(168,7437221,7437201,'f33',3.333,4),(168,7437222,7437201,'334',3.333,4),(168,7437223,7437201,'345',3.333,4),(168,7437224,7437201,'455',3.333,4),(168,7437225,7437201,'556',3.333,4),(168,7437226,7437201,'563',3.333,4),(168,7437227,7437201,'639',3.333,4),(168,7437228,7437201,'393',3.333,4),(168,7437229,7437201,'934',3.333,4),(168,7437230,7437201,'345',3.333,4),(168,7437231,7437201,'453',3.333,4),(168,7437232,7437202,'ser',25,1),(168,7437233,7437202,'eri',25,1),(168,7437234,7437202,'ria',25,1),(168,7437235,7437202,'ial',25,1),(168,7437236,7437232,'siz',50,1),(168,7437237,7437232,'ize',50,1),(168,7437238,7437236,'321',100,1),(168,7437239,7437238,'dev',25,1),(168,7437240,7437238,'evi',25,1),(168,7437241,7437238,'vic',25,1),(168,7437242,7437238,'ice',25,1),(168,7437243,7437239,'typ',50,1),(168,7437244,7437239,'ype',50,1),(168,7437245,7437243,'dir',10,1),(168,7437246,7437243,'ire',10,1),(168,7437247,7437243,'rec',10,1),(168,7437248,7437243,'ect',10,1),(168,7437249,7437243,'cta',10,1),(168,7437250,7437243,'tac',10,1),(168,7437251,7437243,'acc',10,1),(168,7437252,7437243,'cce',10,1),(168,7437253,7437243,'ces',10,1),(168,7437254,7437243,'ess',10,1),(168,7437255,7437245,'mul',14.286,1),(168,7437256,7437245,'ult',14.286,1),(168,7437257,7437245,'lti',14.286,1),(168,7437258,7437245,'tip',14.286,1),(168,7437259,7437245,'ipa',14.286,1),(168,7437260,7437245,'pat',14.286,1),(168,7437261,7437245,'ath',14.286,1),(168,7437262,7437255,'plu',25,1),(168,7437263,7437255,'lug',25,1),(168,7437264,7437255,'ugi',25,1),(168,7437265,7437255,'gin',25,1),(168,7437266,7437262,'nmp',100,1),(168,7437267,7437266,'dev',33.333,1),(168,7437268,7437266,'evf',33.333,1),(168,7437269,7437266,'vfs',33.333,1),(168,7437270,7437267,'pat',50,1),(168,7437271,7437267,'ath',50,1),(168,7437272,7437270,'vmf',50,1),(168,7437273,7437270,'mfs',50,1),(168,7437274,7437272,'dev',20,1),(168,7437275,7437272,'evi',20,1),(168,7437276,7437272,'vic',20,1),(168,7437277,7437272,'ice',20,1),(168,7437278,7437272,'ces',20,1),(168,7437279,7437274,'dis',33.333,1),(168,7437280,7437274,'isk',33.333,1),(168,7437281,7437274,'sks',33.333,1),(168,7437282,7437279,'ven',25,1),(168,7437283,7437279,'end',25,1),(168,7437284,7437279,'ndo',25,1),(168,7437285,7437279,'dor',25,1),(168,7437286,7437282,'mod',33.333,1),(168,7437287,7437282,'ode',33.333,1),(168,7437288,7437282,'del',33.333,1),(168,7437289,7437286,'lun',100,1),(168,7437290,7437289,'cmo',33.333,1),(168,7437291,7437289,'mod',33.333,1),(168,7437292,7437289,'ode',33.333,1),(168,7437293,7437290,'rev',16.667,1),(168,7437294,7437290,'evi',16.667,1),(168,7437295,7437290,'vis',16.667,1),(168,7437296,7437290,'isi',16.667,1),(168,7437297,7437290,'sio',16.667,1),(168,7437298,7437290,'ion',16.667,1),(168,7437299,7437293,'810',50,1),(168,7437300,7437293,'100',50,1),(168,7437301,7437299,'scs',50,1),(168,7437302,7437299,'csi',50,1),(168,7437303,7437301,'lev',33.333,1),(168,7437304,7437301,'eve',33.333,1),(168,7437305,7437301,'vel',33.333,1),(168,7437306,7437303,'pse',25,1),(168,7437307,7437303,'seu',25,1),(168,7437308,7437303,'eud',25,1),(168,7437309,7437303,'udo',25,1),(168,7437310,7437306,'fal',33.333,6),(168,7437311,7437306,'als',33.333,6),(168,7437312,7437306,'lse',33.333,6),(168,7437313,7437310,'sta',25,3),(168,7437314,7437310,'tat',25,3),(168,7437315,7437310,'atu',25,3),(168,7437316,7437310,'tus',25,3),(168,7437317,7437313,'rdm',100,1),(168,7437318,7437317,'cap',20,1),(168,7437319,7437317,'apa',20,1),(168,7437320,7437317,'pab',20,1),(168,7437321,7437317,'abl',20,1),(168,7437322,7437317,'ble',20,1),(168,7437323,7437318,'tru',50,1),(168,7437324,7437318,'rue',50,1),(168,7437325,7437323,'loc',33.333,1),(168,7437326,7437323,'oca',33.333,1),(168,7437327,7437323,'cal',33.333,1),(168,7437328,7437325,'rem',14.286,1),(168,7437329,7437325,'emo',14.286,1),(168,7437330,7437325,'mov',14.286,1),(168,7437331,7437325,'ova',14.286,1),(168,7437332,7437325,'vab',14.286,1),(168,7437333,7437325,'abl',14.286,1),(168,7437334,7437325,'ble',14.286,1),(168,7437335,7437328,'ssd',100,1),(168,7437336,7437335,'off',20,1),(168,7437337,7437335,'ffl',20,1),(168,7437338,7437335,'fli',20,1),(168,7437339,7437335,'lin',20,1),(168,7437340,7437335,'ine',20,1),(168,7437341,7437336,'per',11.111,1),(168,7437342,7437336,'ere',11.111,1),(168,7437343,7437336,'ren',11.111,1),(168,7437344,7437336,'enn',11.111,1),(168,7437345,7437336,'nni',11.111,1),(168,7437346,7437336,'nia',11.111,1),(168,7437347,7437336,'ial',11.111,1),(168,7437348,7437336,'all',11.111,1),(168,7437349,7437336,'lly',11.111,1),(168,7437350,7437341,'res',16.667,1),(168,7437351,7437341,'ese',16.667,1),(168,7437352,7437341,'ser',16.667,1),(168,7437353,7437341,'erv',16.667,1),(168,7437354,7437341,'rve',16.667,1),(168,7437355,7437341,'ved',16.667,1),(168,7437356,7437350,'thi',50,1),(168,7437357,7437350,'hin',50,1),(168,7437358,7437356,'pro',10,1),(168,7437359,7437356,'rov',10,1),(168,7437360,7437356,'ovi',10,1),(168,7437361,7437356,'vis',10,1),(168,7437362,7437356,'isi',10,1),(168,7437363,7437356,'sio',10,1),(168,7437364,7437356,'ion',10,1),(168,7437365,7437356,'oni',10,1),(168,7437366,7437356,'nin',10,1),(168,7437367,7437356,'ing',10,1),(168,7437368,7437358,'yes',100,1),(168,7437369,7437368,'att',16.667,1),(168,7437370,7437368,'tta',16.667,1),(168,7437371,7437368,'tac',16.667,1),(168,7437372,7437368,'ach',16.667,1),(168,7437373,7437368,'che',16.667,1),(168,7437374,7437368,'hed',16.667,1),(168,7437375,7437369,'fil',20,1),(168,7437376,7437369,'ilt',20,1),(168,7437377,7437369,'lte',20,1),(168,7437378,7437369,'ter',20,1),(168,7437379,7437369,'ers',20,1),(168,7437380,7437375,'vaa',50,1),(168,7437381,7437375,'aai',50,1),(168,7437382,7437380,'unk',20,1),(168,7437383,7437380,'nkn',20,1),(168,7437384,7437380,'kno',20,1),(168,7437385,7437380,'now',20,1),(168,7437386,7437380,'own',20,1),(168,7437387,7437382,'oth',33.333,1),(168,7437388,7437382,'the',33.333,1),(168,7437389,7437382,'her',33.333,1),(168,7437390,7437387,'uid',50,1),(168,7437391,7437387,'ids',50,1),(168,7437392,7437390,'vml',100,1),(168,7437393,7437392,'dis',20,1),(168,7437394,7437392,'isp',20,1),(168,7437395,7437392,'spl',20,1),(168,7437396,7437392,'pla',20,1),(168,7437397,7437392,'lay',20,1),(168,7437398,7437393,'nam',50,1),(168,7437399,7437393,'ame',50,1),(169,7437401,7437400,'net',25,3),(169,7437402,7437400,'eta',25,3),(169,7437403,7437400,'tap',25,3),(169,7437404,7437400,'app',25,3),(169,7437405,7437401,'fib',33.333,2),(169,7437406,7437401,'ibr',33.333,2),(169,7437407,7437401,'bre',33.333,2),(169,7437408,7437405,'cha',20,2),(169,7437409,7437405,'han',20,2),(169,7437410,7437405,'ann',20,2),(169,7437411,7437405,'nne',20,2),(169,7437412,7437405,'nel',20,2),(169,7437413,7437408,'dis',50,2),(169,7437414,7437408,'isk',50,2),(169,7437415,7437413,'naa',100,4),(169,7437416,7437415,'600',3.333,4),(169,7437417,7437415,'00a',3.333,4),(169,7437418,7437415,'0a0',3.333,4),(169,7437419,7437415,'a09',3.333,4),(169,7437420,7437415,'098',3.333,4),(169,7437421,7437415,'980',3.333,4),(169,7437422,7437415,'804',3.333,4),(169,7437423,7437415,'044',3.333,4),(169,7437424,7437415,'443',3.333,4),(169,7437425,7437415,'430',3.333,4),(169,7437426,7437415,'307',3.333,4),(169,7437427,7437415,'072',3.333,4),(169,7437428,7437415,'725',3.333,4),(169,7437429,7437415,'259',3.333,4),(169,7437430,7437415,'593',3.333,4),(169,7437431,7437415,'931',3.333,4),(169,7437432,7437415,'313',3.333,4),(169,7437433,7437415,'13f',3.333,4),(169,7437434,7437415,'3f3',3.333,4),(169,7437435,7437415,'f33',3.333,4),(169,7437436,7437415,'334',3.333,4),(169,7437437,7437415,'345',3.333,4),(169,7437438,7437415,'455',3.333,4),(169,7437439,7437415,'556',3.333,4),(169,7437440,7437415,'563',3.333,4),(169,7437441,7437415,'639',3.333,4),(169,7437442,7437415,'393',3.333,4),(169,7437443,7437415,'935',3.333,4),(169,7437444,7437415,'353',3.333,4),(169,7437445,7437415,'530',3.333,4),(169,7437446,7437416,'ser',25,1),(169,7437447,7437416,'eri',25,1),(169,7437448,7437416,'ria',25,1),(169,7437449,7437416,'ial',25,1),(169,7437450,7437446,'siz',50,1),(169,7437451,7437446,'ize',50,1),(169,7437452,7437450,'321',100,1),(169,7437453,7437452,'dev',25,1),(169,7437454,7437452,'evi',25,1),(169,7437455,7437452,'vic',25,1),(169,7437456,7437452,'ice',25,1),(169,7437457,7437453,'typ',50,1),(169,7437458,7437453,'ype',50,1),(169,7437459,7437457,'dir',10,1),(169,7437460,7437457,'ire',10,1),(169,7437461,7437457,'rec',10,1),(169,7437462,7437457,'ect',10,1),(169,7437463,7437457,'cta',10,1),(169,7437464,7437457,'tac',10,1),(169,7437465,7437457,'acc',10,1),(169,7437466,7437457,'cce',10,1),(169,7437467,7437457,'ces',10,1),(169,7437468,7437457,'ess',10,1),(169,7437469,7437459,'mul',14.286,1),(169,7437470,7437459,'ult',14.286,1),(169,7437471,7437459,'lti',14.286,1),(169,7437472,7437459,'tip',14.286,1),(169,7437473,7437459,'ipa',14.286,1),(169,7437474,7437459,'pat',14.286,1),(169,7437475,7437459,'ath',14.286,1),(169,7437476,7437469,'plu',25,1),(169,7437477,7437469,'lug',25,1),(169,7437478,7437469,'ugi',25,1),(169,7437479,7437469,'gin',25,1),(169,7437480,7437476,'nmp',100,1),(169,7437481,7437480,'dev',33.333,1),(169,7437482,7437480,'evf',33.333,1),(169,7437483,7437480,'vfs',33.333,1),(169,7437484,7437481,'pat',50,1),(169,7437485,7437481,'ath',50,1),(169,7437486,7437484,'vmf',50,1),(169,7437487,7437484,'mfs',50,1),(169,7437488,7437486,'dev',20,1),(169,7437489,7437486,'evi',20,1),(169,7437490,7437486,'vic',20,1),(169,7437491,7437486,'ice',20,1),(169,7437492,7437486,'ces',20,1),(169,7437493,7437488,'dis',33.333,1),(169,7437494,7437488,'isk',33.333,1),(169,7437495,7437488,'sks',33.333,1),(169,7437496,7437493,'ven',25,1),(169,7437497,7437493,'end',25,1),(169,7437498,7437493,'ndo',25,1),(169,7437499,7437493,'dor',25,1),(169,7437500,7437496,'mod',33.333,1),(169,7437501,7437496,'ode',33.333,1),(169,7437502,7437496,'del',33.333,1),(169,7437503,7437500,'lun',100,1),(169,7437504,7437503,'cmo',33.333,1),(169,7437505,7437503,'mod',33.333,1),(169,7437506,7437503,'ode',33.333,1),(169,7437507,7437504,'rev',16.667,1),(169,7437508,7437504,'evi',16.667,1),(169,7437509,7437504,'vis',16.667,1),(169,7437510,7437504,'isi',16.667,1),(169,7437511,7437504,'sio',16.667,1),(169,7437512,7437504,'ion',16.667,1),(169,7437513,7437507,'810',50,1),(169,7437514,7437507,'100',50,1),(169,7437515,7437513,'scs',50,1),(169,7437516,7437513,'csi',50,1),(169,7437517,7437515,'lev',33.333,1),(169,7437518,7437515,'eve',33.333,1),(169,7437519,7437515,'vel',33.333,1),(169,7437520,7437517,'pse',25,1),(169,7437521,7437517,'seu',25,1),(169,7437522,7437517,'eud',25,1),(169,7437523,7437517,'udo',25,1),(169,7437524,7437520,'fal',33.333,6),(169,7437525,7437520,'als',33.333,6),(169,7437526,7437520,'lse',33.333,6),(169,7437527,7437524,'sta',25,3),(169,7437528,7437524,'tat',25,3),(169,7437529,7437524,'atu',25,3),(169,7437530,7437524,'tus',25,3),(169,7437531,7437527,'rdm',100,1),(169,7437532,7437531,'cap',20,1),(169,7437533,7437531,'apa',20,1),(169,7437534,7437531,'pab',20,1),(169,7437535,7437531,'abl',20,1),(169,7437536,7437531,'ble',20,1),(169,7437537,7437532,'tru',50,1),(169,7437538,7437532,'rue',50,1),(169,7437539,7437537,'loc',33.333,1),(169,7437540,7437537,'oca',33.333,1),(169,7437541,7437537,'cal',33.333,1),(169,7437542,7437539,'rem',14.286,1),(169,7437543,7437539,'emo',14.286,1),(169,7437544,7437539,'mov',14.286,1),(169,7437545,7437539,'ova',14.286,1),(169,7437546,7437539,'vab',14.286,1),(169,7437547,7437539,'abl',14.286,1),(169,7437548,7437539,'ble',14.286,1),(169,7437549,7437542,'ssd',100,1),(169,7437550,7437549,'off',20,1),(169,7437551,7437549,'ffl',20,1),(169,7437552,7437549,'fli',20,1),(169,7437553,7437549,'lin',20,1),(169,7437554,7437549,'ine',20,1),(169,7437555,7437550,'per',11.111,1),(169,7437556,7437550,'ere',11.111,1),(169,7437557,7437550,'ren',11.111,1),(169,7437558,7437550,'enn',11.111,1),(169,7437559,7437550,'nni',11.111,1),(169,7437560,7437550,'nia',11.111,1),(169,7437561,7437550,'ial',11.111,1),(169,7437562,7437550,'all',11.111,1),(169,7437563,7437550,'lly',11.111,1),(169,7437564,7437555,'res',16.667,1),(169,7437565,7437555,'ese',16.667,1),(169,7437566,7437555,'ser',16.667,1),(169,7437567,7437555,'erv',16.667,1),(169,7437568,7437555,'rve',16.667,1),(169,7437569,7437555,'ved',16.667,1),(169,7437570,7437564,'thi',50,1),(169,7437571,7437564,'hin',50,1),(169,7437572,7437570,'pro',10,1),(169,7437573,7437570,'rov',10,1),(169,7437574,7437570,'ovi',10,1),(169,7437575,7437570,'vis',10,1),(169,7437576,7437570,'isi',10,1),(169,7437577,7437570,'sio',10,1),(169,7437578,7437570,'ion',10,1),(169,7437579,7437570,'oni',10,1),(169,7437580,7437570,'nin',10,1),(169,7437581,7437570,'ing',10,1),(169,7437582,7437572,'yes',100,1),(169,7437583,7437582,'att',16.667,1),(169,7437584,7437582,'tta',16.667,1),(169,7437585,7437582,'tac',16.667,1),(169,7437586,7437582,'ach',16.667,1),(169,7437587,7437582,'che',16.667,1),(169,7437588,7437582,'hed',16.667,1),(169,7437589,7437583,'fil',20,1),(169,7437590,7437583,'ilt',20,1),(169,7437591,7437583,'lte',20,1),(169,7437592,7437583,'ter',20,1),(169,7437593,7437583,'ers',20,1),(169,7437594,7437589,'vaa',50,1),(169,7437595,7437589,'aai',50,1),(169,7437596,7437594,'unk',20,1),(169,7437597,7437594,'nkn',20,1),(169,7437598,7437594,'kno',20,1),(169,7437599,7437594,'now',20,1),(169,7437600,7437594,'own',20,1),(169,7437601,7437596,'oth',33.333,1),(169,7437602,7437596,'the',33.333,1),(169,7437603,7437596,'her',33.333,1),(169,7437604,7437601,'uid',50,1),(169,7437605,7437601,'ids',50,1),(169,7437606,7437604,'vml',100,1),(169,7437607,7437606,'dis',20,1),(169,7437608,7437606,'isp',20,1),(169,7437609,7437606,'spl',20,1),(169,7437610,7437606,'pla',20,1),(169,7437611,7437606,'lay',20,1),(169,7437612,7437607,'nam',50,1),(169,7437613,7437607,'ame',50,1),(170,7437615,7437614,'net',25,3),(170,7437616,7437614,'eta',25,3),(170,7437617,7437614,'tap',25,3),(170,7437618,7437614,'app',25,3),(170,7437619,7437615,'fib',33.333,2),(170,7437620,7437615,'ibr',33.333,2),(170,7437621,7437615,'bre',33.333,2),(170,7437622,7437619,'cha',20,2),(170,7437623,7437619,'han',20,2),(170,7437624,7437619,'ann',20,2),(170,7437625,7437619,'nne',20,2),(170,7437626,7437619,'nel',20,2),(170,7437627,7437622,'dis',50,2),(170,7437628,7437622,'isk',50,2),(170,7437629,7437627,'naa',100,4),(170,7437630,7437629,'600',3.333,4),(170,7437631,7437629,'00a',3.333,4),(170,7437632,7437629,'0a0',3.333,4),(170,7437633,7437629,'a09',3.333,4),(170,7437634,7437629,'098',3.333,4),(170,7437635,7437629,'980',3.333,4),(170,7437636,7437629,'804',3.333,4),(170,7437637,7437629,'044',3.333,4),(170,7437638,7437629,'443',3.333,4),(170,7437639,7437629,'430',3.333,4),(170,7437640,7437629,'307',3.333,4),(170,7437641,7437629,'072',3.333,4),(170,7437642,7437629,'725',3.333,4),(170,7437643,7437629,'259',3.333,4),(170,7437644,7437629,'593',3.333,4),(170,7437645,7437629,'931',3.333,4),(170,7437646,7437629,'313',3.333,4),(170,7437647,7437629,'13f',3.333,4),(170,7437648,7437629,'3f3',3.333,4),(170,7437649,7437629,'f33',3.333,4),(170,7437650,7437629,'334',3.333,4),(170,7437651,7437629,'345',3.333,4),(170,7437652,7437629,'455',3.333,4),(170,7437653,7437629,'556',3.333,4),(170,7437654,7437629,'563',3.333,4),(170,7437655,7437629,'639',3.333,4),(170,7437656,7437629,'393',3.333,4),(170,7437657,7437629,'933',3.333,4),(170,7437658,7437629,'337',3.333,4),(170,7437659,7437629,'377',3.333,4),(170,7437660,7437630,'ser',25,1),(170,7437661,7437630,'eri',25,1),(170,7437662,7437630,'ria',25,1),(170,7437663,7437630,'ial',25,1),(170,7437664,7437660,'siz',50,1),(170,7437665,7437660,'ize',50,1),(170,7437666,7437664,'460',33.333,1),(170,7437667,7437664,'608',33.333,1),(170,7437668,7437664,'080',33.333,1),(170,7437669,7437666,'dev',25,1),(170,7437670,7437666,'evi',25,1),(170,7437671,7437666,'vic',25,1),(170,7437672,7437666,'ice',25,1),(170,7437673,7437669,'typ',50,1),(170,7437674,7437669,'ype',50,1),(170,7437675,7437673,'dir',10,1),(170,7437676,7437673,'ire',10,1),(170,7437677,7437673,'rec',10,1),(170,7437678,7437673,'ect',10,1),(170,7437679,7437673,'cta',10,1),(170,7437680,7437673,'tac',10,1),(170,7437681,7437673,'acc',10,1),(170,7437682,7437673,'cce',10,1),(170,7437683,7437673,'ces',10,1),(170,7437684,7437673,'ess',10,1),(170,7437685,7437675,'mul',14.286,1),(170,7437686,7437675,'ult',14.286,1),(170,7437687,7437675,'lti',14.286,1),(170,7437688,7437675,'tip',14.286,1),(170,7437689,7437675,'ipa',14.286,1),(170,7437690,7437675,'pat',14.286,1),(170,7437691,7437675,'ath',14.286,1),(170,7437692,7437685,'plu',25,1),(170,7437693,7437685,'lug',25,1),(170,7437694,7437685,'ugi',25,1),(170,7437695,7437685,'gin',25,1),(170,7437696,7437692,'nmp',100,1),(170,7437697,7437696,'dev',33.333,1),(170,7437698,7437696,'evf',33.333,1),(170,7437699,7437696,'vfs',33.333,1),(170,7437700,7437697,'pat',50,1),(170,7437701,7437697,'ath',50,1),(170,7437702,7437700,'vmf',50,1),(170,7437703,7437700,'mfs',50,1),(170,7437704,7437702,'dev',20,1),(170,7437705,7437702,'evi',20,1),(170,7437706,7437702,'vic',20,1),(170,7437707,7437702,'ice',20,1),(170,7437708,7437702,'ces',20,1),(170,7437709,7437704,'dis',33.333,1),(170,7437710,7437704,'isk',33.333,1),(170,7437711,7437704,'sks',33.333,1),(170,7437712,7437709,'ven',25,1),(170,7437713,7437709,'end',25,1),(170,7437714,7437709,'ndo',25,1),(170,7437715,7437709,'dor',25,1),(170,7437716,7437712,'mod',33.333,1),(170,7437717,7437712,'ode',33.333,1),(170,7437718,7437712,'del',33.333,1),(170,7437719,7437716,'lun',100,1),(170,7437720,7437719,'cmo',33.333,1),(170,7437721,7437719,'mod',33.333,1),(170,7437722,7437719,'ode',33.333,1),(170,7437723,7437720,'rev',16.667,1),(170,7437724,7437720,'evi',16.667,1),(170,7437725,7437720,'vis',16.667,1),(170,7437726,7437720,'isi',16.667,1),(170,7437727,7437720,'sio',16.667,1),(170,7437728,7437720,'ion',16.667,1),(170,7437729,7437723,'810',50,1),(170,7437730,7437723,'100',50,1),(170,7437731,7437729,'scs',50,1),(170,7437732,7437729,'csi',50,1),(170,7437733,7437731,'lev',33.333,1),(170,7437734,7437731,'eve',33.333,1),(170,7437735,7437731,'vel',33.333,1),(170,7437736,7437733,'pse',25,1),(170,7437737,7437733,'seu',25,1),(170,7437738,7437733,'eud',25,1),(170,7437739,7437733,'udo',25,1),(170,7437740,7437736,'fal',33.333,6),(170,7437741,7437736,'als',33.333,6),(170,7437742,7437736,'lse',33.333,6),(170,7437743,7437740,'sta',25,3),(170,7437744,7437740,'tat',25,3),(170,7437745,7437740,'atu',25,3),(170,7437746,7437740,'tus',25,3),(170,7437747,7437743,'rdm',100,1),(170,7437748,7437747,'cap',20,1),(170,7437749,7437747,'apa',20,1),(170,7437750,7437747,'pab',20,1),(170,7437751,7437747,'abl',20,1),(170,7437752,7437747,'ble',20,1),(170,7437753,7437748,'tru',50,1),(170,7437754,7437748,'rue',50,1),(170,7437755,7437753,'loc',33.333,1),(170,7437756,7437753,'oca',33.333,1),(170,7437757,7437753,'cal',33.333,1),(170,7437758,7437755,'rem',14.286,1),(170,7437759,7437755,'emo',14.286,1),(170,7437760,7437755,'mov',14.286,1),(170,7437761,7437755,'ova',14.286,1),(170,7437762,7437755,'vab',14.286,1),(170,7437763,7437755,'abl',14.286,1),(170,7437764,7437755,'ble',14.286,1),(170,7437765,7437758,'ssd',100,1),(170,7437766,7437765,'off',20,1),(170,7437767,7437765,'ffl',20,1),(170,7437768,7437765,'fli',20,1),(170,7437769,7437765,'lin',20,1),(170,7437770,7437765,'ine',20,1),(170,7437771,7437766,'per',11.111,1),(170,7437772,7437766,'ere',11.111,1),(170,7437773,7437766,'ren',11.111,1),(170,7437774,7437766,'enn',11.111,1),(170,7437775,7437766,'nni',11.111,1),(170,7437776,7437766,'nia',11.111,1),(170,7437777,7437766,'ial',11.111,1),(170,7437778,7437766,'all',11.111,1),(170,7437779,7437766,'lly',11.111,1),(170,7437780,7437771,'res',16.667,1),(170,7437781,7437771,'ese',16.667,1),(170,7437782,7437771,'ser',16.667,1),(170,7437783,7437771,'erv',16.667,1),(170,7437784,7437771,'rve',16.667,1),(170,7437785,7437771,'ved',16.667,1),(170,7437786,7437780,'thi',50,1),(170,7437787,7437780,'hin',50,1),(170,7437788,7437786,'pro',10,1),(170,7437789,7437786,'rov',10,1),(170,7437790,7437786,'ovi',10,1),(170,7437791,7437786,'vis',10,1),(170,7437792,7437786,'isi',10,1),(170,7437793,7437786,'sio',10,1),(170,7437794,7437786,'ion',10,1),(170,7437795,7437786,'oni',10,1),(170,7437796,7437786,'nin',10,1),(170,7437797,7437786,'ing',10,1),(170,7437798,7437788,'yes',100,1),(170,7437799,7437798,'att',16.667,1),(170,7437800,7437798,'tta',16.667,1),(170,7437801,7437798,'tac',16.667,1),(170,7437802,7437798,'ach',16.667,1),(170,7437803,7437798,'che',16.667,1),(170,7437804,7437798,'hed',16.667,1),(170,7437805,7437799,'fil',20,1),(170,7437806,7437799,'ilt',20,1),(170,7437807,7437799,'lte',20,1),(170,7437808,7437799,'ter',20,1),(170,7437809,7437799,'ers',20,1),(170,7437810,7437805,'vaa',50,1),(170,7437811,7437805,'aai',50,1),(170,7437812,7437810,'unk',20,1),(170,7437813,7437810,'nkn',20,1),(170,7437814,7437810,'kno',20,1),(170,7437815,7437810,'now',20,1),(170,7437816,7437810,'own',20,1),(170,7437817,7437812,'oth',33.333,1),(170,7437818,7437812,'the',33.333,1),(170,7437819,7437812,'her',33.333,1),(170,7437820,7437817,'uid',50,1),(170,7437821,7437817,'ids',50,1),(170,7437822,7437820,'vml',100,1),(170,7437823,7437822,'dis',20,1),(170,7437824,7437822,'isp',20,1),(170,7437825,7437822,'spl',20,1),(170,7437826,7437822,'pla',20,1),(170,7437827,7437822,'lay',20,1),(170,7437828,7437823,'nam',50,1),(170,7437829,7437823,'ame',50,1),(171,7437831,7437830,'net',25,3),(171,7437832,7437830,'eta',25,3),(171,7437833,7437830,'tap',25,3),(171,7437834,7437830,'app',25,3),(171,7437835,7437831,'fib',33.333,2),(171,7437836,7437831,'ibr',33.333,2),(171,7437837,7437831,'bre',33.333,2),(171,7437838,7437835,'cha',20,2),(171,7437839,7437835,'han',20,2),(171,7437840,7437835,'ann',20,2),(171,7437841,7437835,'nne',20,2),(171,7437842,7437835,'nel',20,2),(171,7437843,7437838,'dis',50,2),(171,7437844,7437838,'isk',50,2),(171,7437845,7437843,'naa',100,4),(171,7437846,7437845,'600',3.333,4),(171,7437847,7437845,'00a',3.333,4),(171,7437848,7437845,'0a0',3.333,4),(171,7437849,7437845,'a09',3.333,4),(171,7437850,7437845,'098',3.333,4),(171,7437851,7437845,'980',3.333,4),(171,7437852,7437845,'804',3.333,4),(171,7437853,7437845,'044',3.333,4),(171,7437854,7437845,'443',3.333,4),(171,7437855,7437845,'430',3.333,4),(171,7437856,7437845,'307',3.333,4),(171,7437857,7437845,'072',3.333,4),(171,7437858,7437845,'725',3.333,4),(171,7437859,7437845,'259',3.333,4),(171,7437860,7437845,'593',3.333,4),(171,7437861,7437845,'931',3.333,4),(171,7437862,7437845,'313',3.333,4),(171,7437863,7437845,'13f',3.333,4),(171,7437864,7437845,'3f3',3.333,4),(171,7437865,7437845,'f33',3.333,4),(171,7437866,7437845,'334',3.333,4),(171,7437867,7437845,'345',3.333,4),(171,7437868,7437845,'455',3.333,4),(171,7437869,7437845,'556',3.333,4),(171,7437870,7437845,'563',3.333,4),(171,7437871,7437845,'639',3.333,4),(171,7437872,7437845,'393',3.333,4),(171,7437873,7437845,'935',3.333,4),(171,7437874,7437845,'353',3.333,4),(171,7437875,7437845,'531',3.333,4),(171,7437876,7437846,'ser',25,1),(171,7437877,7437846,'eri',25,1),(171,7437878,7437846,'ria',25,1),(171,7437879,7437846,'ial',25,1),(171,7437880,7437876,'siz',50,1),(171,7437881,7437876,'ize',50,1),(171,7437882,7437880,'321',100,1),(171,7437883,7437882,'dev',25,1),(171,7437884,7437882,'evi',25,1),(171,7437885,7437882,'vic',25,1),(171,7437886,7437882,'ice',25,1),(171,7437887,7437883,'typ',50,1),(171,7437888,7437883,'ype',50,1),(171,7437889,7437887,'dir',10,1),(171,7437890,7437887,'ire',10,1),(171,7437891,7437887,'rec',10,1),(171,7437892,7437887,'ect',10,1),(171,7437893,7437887,'cta',10,1),(171,7437894,7437887,'tac',10,1),(171,7437895,7437887,'acc',10,1),(171,7437896,7437887,'cce',10,1),(171,7437897,7437887,'ces',10,1),(171,7437898,7437887,'ess',10,1),(171,7437899,7437889,'mul',14.286,1),(171,7437900,7437889,'ult',14.286,1),(171,7437901,7437889,'lti',14.286,1),(171,7437902,7437889,'tip',14.286,1),(171,7437903,7437889,'ipa',14.286,1),(171,7437904,7437889,'pat',14.286,1),(171,7437905,7437889,'ath',14.286,1),(171,7437906,7437899,'plu',25,1),(171,7437907,7437899,'lug',25,1),(171,7437908,7437899,'ugi',25,1),(171,7437909,7437899,'gin',25,1),(171,7437910,7437906,'nmp',100,1),(171,7437911,7437910,'dev',33.333,1),(171,7437912,7437910,'evf',33.333,1),(171,7437913,7437910,'vfs',33.333,1),(171,7437914,7437911,'pat',50,1),(171,7437915,7437911,'ath',50,1),(171,7437916,7437914,'vmf',50,1),(171,7437917,7437914,'mfs',50,1),(171,7437918,7437916,'dev',20,1),(171,7437919,7437916,'evi',20,1),(171,7437920,7437916,'vic',20,1),(171,7437921,7437916,'ice',20,1),(171,7437922,7437916,'ces',20,1),(171,7437923,7437918,'dis',33.333,1),(171,7437924,7437918,'isk',33.333,1),(171,7437925,7437918,'sks',33.333,1),(171,7437926,7437923,'ven',25,1),(171,7437927,7437923,'end',25,1),(171,7437928,7437923,'ndo',25,1),(171,7437929,7437923,'dor',25,1),(171,7437930,7437926,'mod',33.333,1),(171,7437931,7437926,'ode',33.333,1),(171,7437932,7437926,'del',33.333,1),(171,7437933,7437930,'lun',100,1),(171,7437934,7437933,'cmo',33.333,1),(171,7437935,7437933,'mod',33.333,1),(171,7437936,7437933,'ode',33.333,1),(171,7437937,7437934,'rev',16.667,1),(171,7437938,7437934,'evi',16.667,1),(171,7437939,7437934,'vis',16.667,1),(171,7437940,7437934,'isi',16.667,1),(171,7437941,7437934,'sio',16.667,1),(171,7437942,7437934,'ion',16.667,1),(171,7437943,7437937,'810',50,1),(171,7437944,7437937,'100',50,1),(171,7437945,7437943,'scs',50,1),(171,7437946,7437943,'csi',50,1),(171,7437947,7437945,'lev',33.333,1),(171,7437948,7437945,'eve',33.333,1),(171,7437949,7437945,'vel',33.333,1),(171,7437950,7437947,'pse',25,1),(171,7437951,7437947,'seu',25,1),(171,7437952,7437947,'eud',25,1),(171,7437953,7437947,'udo',25,1),(171,7437954,7437950,'fal',33.333,6),(171,7437955,7437950,'als',33.333,6),(171,7437956,7437950,'lse',33.333,6),(171,7437957,7437954,'sta',25,3),(171,7437958,7437954,'tat',25,3),(171,7437959,7437954,'atu',25,3),(171,7437960,7437954,'tus',25,3),(171,7437961,7437957,'rdm',100,1),(171,7437962,7437961,'cap',20,1),(171,7437963,7437961,'apa',20,1),(171,7437964,7437961,'pab',20,1),(171,7437965,7437961,'abl',20,1),(171,7437966,7437961,'ble',20,1),(171,7437967,7437962,'tru',50,1),(171,7437968,7437962,'rue',50,1),(171,7437969,7437967,'loc',33.333,1),(171,7437970,7437967,'oca',33.333,1),(171,7437971,7437967,'cal',33.333,1),(171,7437972,7437969,'rem',14.286,1),(171,7437973,7437969,'emo',14.286,1),(171,7437974,7437969,'mov',14.286,1),(171,7437975,7437969,'ova',14.286,1),(171,7437976,7437969,'vab',14.286,1),(171,7437977,7437969,'abl',14.286,1),(171,7437978,7437969,'ble',14.286,1),(171,7437979,7437972,'ssd',100,1),(171,7437980,7437979,'off',20,1),(171,7437981,7437979,'ffl',20,1),(171,7437982,7437979,'fli',20,1),(171,7437983,7437979,'lin',20,1),(171,7437984,7437979,'ine',20,1),(171,7437985,7437980,'per',11.111,1),(171,7437986,7437980,'ere',11.111,1),(171,7437987,7437980,'ren',11.111,1),(171,7437988,7437980,'enn',11.111,1),(171,7437989,7437980,'nni',11.111,1),(171,7437990,7437980,'nia',11.111,1),(171,7437991,7437980,'ial',11.111,1),(171,7437992,7437980,'all',11.111,1),(171,7437993,7437980,'lly',11.111,1),(171,7437994,7437985,'res',16.667,1),(171,7437995,7437985,'ese',16.667,1),(171,7437996,7437985,'ser',16.667,1),(171,7437997,7437985,'erv',16.667,1),(171,7437998,7437985,'rve',16.667,1),(171,7437999,7437985,'ved',16.667,1),(171,7438000,7437994,'thi',50,1),(171,7438001,7437994,'hin',50,1),(171,7438002,7438000,'pro',10,1),(171,7438003,7438000,'rov',10,1),(171,7438004,7438000,'ovi',10,1),(171,7438005,7438000,'vis',10,1),(171,7438006,7438000,'isi',10,1),(171,7438007,7438000,'sio',10,1),(171,7438008,7438000,'ion',10,1),(171,7438009,7438000,'oni',10,1),(171,7438010,7438000,'nin',10,1),(171,7438011,7438000,'ing',10,1),(171,7438012,7438002,'yes',100,1),(171,7438013,7438012,'att',16.667,1),(171,7438014,7438012,'tta',16.667,1),(171,7438015,7438012,'tac',16.667,1),(171,7438016,7438012,'ach',16.667,1),(171,7438017,7438012,'che',16.667,1),(171,7438018,7438012,'hed',16.667,1),(171,7438019,7438013,'fil',20,1),(171,7438020,7438013,'ilt',20,1),(171,7438021,7438013,'lte',20,1),(171,7438022,7438013,'ter',20,1),(171,7438023,7438013,'ers',20,1),(171,7438024,7438019,'vaa',50,1),(171,7438025,7438019,'aai',50,1),(171,7438026,7438024,'unk',20,1),(171,7438027,7438024,'nkn',20,1),(171,7438028,7438024,'kno',20,1),(171,7438029,7438024,'now',20,1),(171,7438030,7438024,'own',20,1),(171,7438031,7438026,'oth',33.333,1),(171,7438032,7438026,'the',33.333,1),(171,7438033,7438026,'her',33.333,1),(171,7438034,7438031,'uid',50,1),(171,7438035,7438031,'ids',50,1),(171,7438036,7438034,'vml',100,1),(171,7438037,7438036,'dis',20,1),(171,7438038,7438036,'isp',20,1),(171,7438039,7438036,'spl',20,1),(171,7438040,7438036,'pla',20,1),(171,7438041,7438036,'lay',20,1),(171,7438042,7438037,'nam',50,1),(171,7438043,7438037,'ame',50,1),(172,7438045,7438044,'net',25,3),(172,7438046,7438044,'eta',25,3),(172,7438047,7438044,'tap',25,3),(172,7438048,7438044,'app',25,3),(172,7438049,7438045,'fib',33.333,2),(172,7438050,7438045,'ibr',33.333,2),(172,7438051,7438045,'bre',33.333,2),(172,7438052,7438049,'cha',20,2),(172,7438053,7438049,'han',20,2),(172,7438054,7438049,'ann',20,2),(172,7438055,7438049,'nne',20,2),(172,7438056,7438049,'nel',20,2),(172,7438057,7438052,'dis',50,2),(172,7438058,7438052,'isk',50,2),(172,7438059,7438057,'naa',100,4),(172,7438060,7438059,'600',3.333,4),(172,7438061,7438059,'00a',3.333,4),(172,7438062,7438059,'0a0',3.333,4),(172,7438063,7438059,'a09',3.333,4),(172,7438064,7438059,'098',3.333,4),(172,7438065,7438059,'980',3.333,4),(172,7438066,7438059,'804',3.333,4),(172,7438067,7438059,'044',3.333,4),(172,7438068,7438059,'443',3.333,4),(172,7438069,7438059,'430',3.333,4),(172,7438070,7438059,'307',3.333,4),(172,7438071,7438059,'072',3.333,4),(172,7438072,7438059,'725',3.333,4),(172,7438073,7438059,'259',3.333,4),(172,7438074,7438059,'593',3.333,4),(172,7438075,7438059,'931',3.333,4),(172,7438076,7438059,'313',3.333,4),(172,7438077,7438059,'13f',3.333,4),(172,7438078,7438059,'3f3',3.333,4),(172,7438079,7438059,'f33',3.333,4),(172,7438080,7438059,'334',3.333,4),(172,7438081,7438059,'345',3.333,4),(172,7438082,7438059,'455',3.333,4),(172,7438083,7438059,'556',3.333,4),(172,7438084,7438059,'563',3.333,4),(172,7438085,7438059,'639',3.333,4),(172,7438086,7438059,'393',3.333,4),(172,7438087,7438059,'934',3.333,4),(172,7438088,7438059,'345',3.333,4),(172,7438089,7438059,'454',3.333,4),(172,7438090,7438060,'ser',25,1),(172,7438091,7438060,'eri',25,1),(172,7438092,7438060,'ria',25,1),(172,7438093,7438060,'ial',25,1),(172,7438094,7438090,'siz',50,1),(172,7438095,7438090,'ize',50,1),(172,7438096,7438094,'321',100,1),(172,7438097,7438096,'dev',25,1),(172,7438098,7438096,'evi',25,1),(172,7438099,7438096,'vic',25,1),(172,7438100,7438096,'ice',25,1),(172,7438101,7438097,'typ',50,1),(172,7438102,7438097,'ype',50,1),(172,7438103,7438101,'dir',10,1),(172,7438104,7438101,'ire',10,1),(172,7438105,7438101,'rec',10,1),(172,7438106,7438101,'ect',10,1),(172,7438107,7438101,'cta',10,1),(172,7438108,7438101,'tac',10,1),(172,7438109,7438101,'acc',10,1),(172,7438110,7438101,'cce',10,1),(172,7438111,7438101,'ces',10,1),(172,7438112,7438101,'ess',10,1),(172,7438113,7438103,'mul',14.286,1),(172,7438114,7438103,'ult',14.286,1),(172,7438115,7438103,'lti',14.286,1),(172,7438116,7438103,'tip',14.286,1),(172,7438117,7438103,'ipa',14.286,1),(172,7438118,7438103,'pat',14.286,1),(172,7438119,7438103,'ath',14.286,1),(172,7438120,7438113,'plu',25,1),(172,7438121,7438113,'lug',25,1),(172,7438122,7438113,'ugi',25,1),(172,7438123,7438113,'gin',25,1),(172,7438124,7438120,'nmp',100,1),(172,7438125,7438124,'dev',33.333,1),(172,7438126,7438124,'evf',33.333,1),(172,7438127,7438124,'vfs',33.333,1),(172,7438128,7438125,'pat',50,1),(172,7438129,7438125,'ath',50,1),(172,7438130,7438128,'vmf',50,1),(172,7438131,7438128,'mfs',50,1),(172,7438132,7438130,'dev',20,1),(172,7438133,7438130,'evi',20,1),(172,7438134,7438130,'vic',20,1),(172,7438135,7438130,'ice',20,1),(172,7438136,7438130,'ces',20,1),(172,7438137,7438132,'dis',33.333,1),(172,7438138,7438132,'isk',33.333,1),(172,7438139,7438132,'sks',33.333,1),(172,7438140,7438137,'ven',25,1),(172,7438141,7438137,'end',25,1),(172,7438142,7438137,'ndo',25,1),(172,7438143,7438137,'dor',25,1),(172,7438144,7438140,'mod',33.333,1),(172,7438145,7438140,'ode',33.333,1),(172,7438146,7438140,'del',33.333,1),(172,7438147,7438144,'lun',100,1),(172,7438148,7438147,'cmo',33.333,1),(172,7438149,7438147,'mod',33.333,1),(172,7438150,7438147,'ode',33.333,1),(172,7438151,7438148,'rev',16.667,1),(172,7438152,7438148,'evi',16.667,1),(172,7438153,7438148,'vis',16.667,1),(172,7438154,7438148,'isi',16.667,1),(172,7438155,7438148,'sio',16.667,1),(172,7438156,7438148,'ion',16.667,1),(172,7438157,7438151,'810',50,1),(172,7438158,7438151,'100',50,1),(172,7438159,7438157,'scs',50,1),(172,7438160,7438157,'csi',50,1),(172,7438161,7438159,'lev',33.333,1),(172,7438162,7438159,'eve',33.333,1),(172,7438163,7438159,'vel',33.333,1),(172,7438164,7438161,'pse',25,1),(172,7438165,7438161,'seu',25,1),(172,7438166,7438161,'eud',25,1),(172,7438167,7438161,'udo',25,1),(172,7438168,7438164,'fal',33.333,6),(172,7438169,7438164,'als',33.333,6),(172,7438170,7438164,'lse',33.333,6),(172,7438171,7438168,'sta',25,3),(172,7438172,7438168,'tat',25,3),(172,7438173,7438168,'atu',25,3),(172,7438174,7438168,'tus',25,3),(172,7438175,7438171,'rdm',100,1),(172,7438176,7438175,'cap',20,1),(172,7438177,7438175,'apa',20,1),(172,7438178,7438175,'pab',20,1),(172,7438179,7438175,'abl',20,1),(172,7438180,7438175,'ble',20,1),(172,7438181,7438176,'tru',50,1),(172,7438182,7438176,'rue',50,1),(172,7438183,7438181,'loc',33.333,1),(172,7438184,7438181,'oca',33.333,1),(172,7438185,7438181,'cal',33.333,1),(172,7438186,7438183,'rem',14.286,1),(172,7438187,7438183,'emo',14.286,1),(172,7438188,7438183,'mov',14.286,1),(172,7438189,7438183,'ova',14.286,1),(172,7438190,7438183,'vab',14.286,1),(172,7438191,7438183,'abl',14.286,1),(172,7438192,7438183,'ble',14.286,1),(172,7438193,7438186,'ssd',100,1),(172,7438194,7438193,'off',20,1),(172,7438195,7438193,'ffl',20,1),(172,7438196,7438193,'fli',20,1),(172,7438197,7438193,'lin',20,1),(172,7438198,7438193,'ine',20,1),(172,7438199,7438194,'per',11.111,1),(172,7438200,7438194,'ere',11.111,1),(172,7438201,7438194,'ren',11.111,1),(172,7438202,7438194,'enn',11.111,1),(172,7438203,7438194,'nni',11.111,1),(172,7438204,7438194,'nia',11.111,1),(172,7438205,7438194,'ial',11.111,1),(172,7438206,7438194,'all',11.111,1),(172,7438207,7438194,'lly',11.111,1),(172,7438208,7438199,'res',16.667,1),(172,7438209,7438199,'ese',16.667,1),(172,7438210,7438199,'ser',16.667,1),(172,7438211,7438199,'erv',16.667,1),(172,7438212,7438199,'rve',16.667,1),(172,7438213,7438199,'ved',16.667,1),(172,7438214,7438208,'thi',50,1),(172,7438215,7438208,'hin',50,1),(172,7438216,7438214,'pro',10,1),(172,7438217,7438214,'rov',10,1),(172,7438218,7438214,'ovi',10,1),(172,7438219,7438214,'vis',10,1),(172,7438220,7438214,'isi',10,1),(172,7438221,7438214,'sio',10,1),(172,7438222,7438214,'ion',10,1),(172,7438223,7438214,'oni',10,1),(172,7438224,7438214,'nin',10,1),(172,7438225,7438214,'ing',10,1),(172,7438226,7438216,'yes',100,1),(172,7438227,7438226,'att',16.667,1),(172,7438228,7438226,'tta',16.667,1),(172,7438229,7438226,'tac',16.667,1),(172,7438230,7438226,'ach',16.667,1),(172,7438231,7438226,'che',16.667,1),(172,7438232,7438226,'hed',16.667,1),(172,7438233,7438227,'fil',20,1),(172,7438234,7438227,'ilt',20,1),(172,7438235,7438227,'lte',20,1),(172,7438236,7438227,'ter',20,1),(172,7438237,7438227,'ers',20,1),(172,7438238,7438233,'vaa',50,1),(172,7438239,7438233,'aai',50,1),(172,7438240,7438238,'unk',20,1),(172,7438241,7438238,'nkn',20,1),(172,7438242,7438238,'kno',20,1),(172,7438243,7438238,'now',20,1),(172,7438244,7438238,'own',20,1),(172,7438245,7438240,'oth',33.333,1),(172,7438246,7438240,'the',33.333,1),(172,7438247,7438240,'her',33.333,1),(172,7438248,7438245,'uid',50,1),(172,7438249,7438245,'ids',50,1),(172,7438250,7438248,'vml',100,1),(172,7438251,7438250,'dis',20,1),(172,7438252,7438250,'isp',20,1),(172,7438253,7438250,'spl',20,1),(172,7438254,7438250,'pla',20,1),(172,7438255,7438250,'lay',20,1),(172,7438256,7438251,'nam',50,1),(172,7438257,7438251,'ame',50,1),(173,7438259,7438258,'net',25,3),(173,7438260,7438258,'eta',25,3),(173,7438261,7438258,'tap',25,3),(173,7438262,7438258,'app',25,3),(173,7438263,7438259,'fib',33.333,2),(173,7438264,7438259,'ibr',33.333,2),(173,7438265,7438259,'bre',33.333,2),(173,7438266,7438263,'cha',20,2),(173,7438267,7438263,'han',20,2),(173,7438268,7438263,'ann',20,2),(173,7438269,7438263,'nne',20,2),(173,7438270,7438263,'nel',20,2),(173,7438271,7438266,'dis',50,2),(173,7438272,7438266,'isk',50,2),(173,7438273,7438271,'naa',100,4),(173,7438274,7438273,'600',3.333,4),(173,7438275,7438273,'00a',3.333,4),(173,7438276,7438273,'0a0',3.333,4),(173,7438277,7438273,'a09',3.333,4),(173,7438278,7438273,'098',3.333,4),(173,7438279,7438273,'980',3.333,4),(173,7438280,7438273,'804',3.333,4),(173,7438281,7438273,'044',3.333,4),(173,7438282,7438273,'443',3.333,4),(173,7438283,7438273,'430',3.333,4),(173,7438284,7438273,'307',3.333,4),(173,7438285,7438273,'072',3.333,4),(173,7438286,7438273,'725',3.333,4),(173,7438287,7438273,'259',3.333,4),(173,7438288,7438273,'593',3.333,4),(173,7438289,7438273,'931',3.333,4),(173,7438290,7438273,'313',3.333,4),(173,7438291,7438273,'13f',3.333,4),(173,7438292,7438273,'3f3',3.333,4),(173,7438293,7438273,'f33',3.333,4),(173,7438294,7438273,'334',3.333,4),(173,7438295,7438273,'345',3.333,4),(173,7438296,7438273,'455',3.333,4),(173,7438297,7438273,'556',3.333,4),(173,7438298,7438273,'563',3.333,4),(173,7438299,7438273,'639',3.333,4),(173,7438300,7438273,'393',3.333,4),(173,7438301,7438273,'933',3.333,4),(173,7438302,7438273,'337',3.333,4),(173,7438303,7438273,'378',3.333,4),(173,7438304,7438274,'ser',25,1),(173,7438305,7438274,'eri',25,1),(173,7438306,7438274,'ria',25,1),(173,7438307,7438274,'ial',25,1),(173,7438308,7438304,'siz',50,1),(173,7438309,7438304,'ize',50,1),(173,7438310,7438308,'460',33.333,1),(173,7438311,7438308,'608',33.333,1),(173,7438312,7438308,'080',33.333,1),(173,7438313,7438310,'dev',25,1),(173,7438314,7438310,'evi',25,1),(173,7438315,7438310,'vic',25,1),(173,7438316,7438310,'ice',25,1),(173,7438317,7438313,'typ',50,1),(173,7438318,7438313,'ype',50,1),(173,7438319,7438317,'dir',10,1),(173,7438320,7438317,'ire',10,1),(173,7438321,7438317,'rec',10,1),(173,7438322,7438317,'ect',10,1),(173,7438323,7438317,'cta',10,1),(173,7438324,7438317,'tac',10,1),(173,7438325,7438317,'acc',10,1),(173,7438326,7438317,'cce',10,1),(173,7438327,7438317,'ces',10,1),(173,7438328,7438317,'ess',10,1),(173,7438329,7438319,'mul',14.286,1),(173,7438330,7438319,'ult',14.286,1),(173,7438331,7438319,'lti',14.286,1),(173,7438332,7438319,'tip',14.286,1),(173,7438333,7438319,'ipa',14.286,1),(173,7438334,7438319,'pat',14.286,1),(173,7438335,7438319,'ath',14.286,1),(173,7438336,7438329,'plu',25,1),(173,7438337,7438329,'lug',25,1),(173,7438338,7438329,'ugi',25,1),(173,7438339,7438329,'gin',25,1),(173,7438340,7438336,'nmp',100,1),(173,7438341,7438340,'dev',33.333,1),(173,7438342,7438340,'evf',33.333,1),(173,7438343,7438340,'vfs',33.333,1),(173,7438344,7438341,'pat',50,1),(173,7438345,7438341,'ath',50,1),(173,7438346,7438344,'vmf',50,1),(173,7438347,7438344,'mfs',50,1),(173,7438348,7438346,'dev',20,1),(173,7438349,7438346,'evi',20,1),(173,7438350,7438346,'vic',20,1),(173,7438351,7438346,'ice',20,1),(173,7438352,7438346,'ces',20,1),(173,7438353,7438348,'dis',33.333,1),(173,7438354,7438348,'isk',33.333,1),(173,7438355,7438348,'sks',33.333,1),(173,7438356,7438353,'ven',25,1),(173,7438357,7438353,'end',25,1),(173,7438358,7438353,'ndo',25,1),(173,7438359,7438353,'dor',25,1),(173,7438360,7438356,'mod',33.333,1),(173,7438361,7438356,'ode',33.333,1),(173,7438362,7438356,'del',33.333,1),(173,7438363,7438360,'lun',100,1),(173,7438364,7438363,'cmo',33.333,1),(173,7438365,7438363,'mod',33.333,1),(173,7438366,7438363,'ode',33.333,1),(173,7438367,7438364,'rev',16.667,1),(173,7438368,7438364,'evi',16.667,1),(173,7438369,7438364,'vis',16.667,1),(173,7438370,7438364,'isi',16.667,1),(173,7438371,7438364,'sio',16.667,1),(173,7438372,7438364,'ion',16.667,1),(173,7438373,7438367,'810',50,1),(173,7438374,7438367,'100',50,1),(173,7438375,7438373,'scs',50,1),(173,7438376,7438373,'csi',50,1),(173,7438377,7438375,'lev',33.333,1),(173,7438378,7438375,'eve',33.333,1),(173,7438379,7438375,'vel',33.333,1),(173,7438380,7438377,'pse',25,1),(173,7438381,7438377,'seu',25,1),(173,7438382,7438377,'eud',25,1),(173,7438383,7438377,'udo',25,1),(173,7438384,7438380,'fal',33.333,6),(173,7438385,7438380,'als',33.333,6),(173,7438386,7438380,'lse',33.333,6),(173,7438387,7438384,'sta',25,3),(173,7438388,7438384,'tat',25,3),(173,7438389,7438384,'atu',25,3),(173,7438390,7438384,'tus',25,3),(173,7438391,7438387,'rdm',100,1),(173,7438392,7438391,'cap',20,1),(173,7438393,7438391,'apa',20,1),(173,7438394,7438391,'pab',20,1),(173,7438395,7438391,'abl',20,1),(173,7438396,7438391,'ble',20,1),(173,7438397,7438392,'tru',50,1),(173,7438398,7438392,'rue',50,1),(173,7438399,7438397,'loc',33.333,1),(173,7438400,7438397,'oca',33.333,1),(173,7438401,7438397,'cal',33.333,1),(173,7438402,7438399,'rem',14.286,1),(173,7438403,7438399,'emo',14.286,1),(173,7438404,7438399,'mov',14.286,1),(173,7438405,7438399,'ova',14.286,1),(173,7438406,7438399,'vab',14.286,1),(173,7438407,7438399,'abl',14.286,1),(173,7438408,7438399,'ble',14.286,1),(173,7438409,7438402,'ssd',100,1),(173,7438410,7438409,'off',20,1),(173,7438411,7438409,'ffl',20,1),(173,7438412,7438409,'fli',20,1),(173,7438413,7438409,'lin',20,1),(173,7438414,7438409,'ine',20,1),(173,7438415,7438410,'per',11.111,1),(173,7438416,7438410,'ere',11.111,1),(173,7438417,7438410,'ren',11.111,1),(173,7438418,7438410,'enn',11.111,1),(173,7438419,7438410,'nni',11.111,1),(173,7438420,7438410,'nia',11.111,1),(173,7438421,7438410,'ial',11.111,1),(173,7438422,7438410,'all',11.111,1),(173,7438423,7438410,'lly',11.111,1),(173,7438424,7438415,'res',16.667,1),(173,7438425,7438415,'ese',16.667,1),(173,7438426,7438415,'ser',16.667,1),(173,7438427,7438415,'erv',16.667,1),(173,7438428,7438415,'rve',16.667,1),(173,7438429,7438415,'ved',16.667,1),(173,7438430,7438424,'thi',50,1),(173,7438431,7438424,'hin',50,1),(173,7438432,7438430,'pro',10,1),(173,7438433,7438430,'rov',10,1),(173,7438434,7438430,'ovi',10,1),(173,7438435,7438430,'vis',10,1),(173,7438436,7438430,'isi',10,1),(173,7438437,7438430,'sio',10,1),(173,7438438,7438430,'ion',10,1),(173,7438439,7438430,'oni',10,1),(173,7438440,7438430,'nin',10,1),(173,7438441,7438430,'ing',10,1),(173,7438442,7438432,'yes',100,1),(173,7438443,7438442,'att',16.667,1),(173,7438444,7438442,'tta',16.667,1),(173,7438445,7438442,'tac',16.667,1),(173,7438446,7438442,'ach',16.667,1),(173,7438447,7438442,'che',16.667,1),(173,7438448,7438442,'hed',16.667,1),(173,7438449,7438443,'fil',20,1),(173,7438450,7438443,'ilt',20,1),(173,7438451,7438443,'lte',20,1),(173,7438452,7438443,'ter',20,1),(173,7438453,7438443,'ers',20,1),(173,7438454,7438449,'vaa',50,1),(173,7438455,7438449,'aai',50,1),(173,7438456,7438454,'unk',20,1),(173,7438457,7438454,'nkn',20,1),(173,7438458,7438454,'kno',20,1),(173,7438459,7438454,'now',20,1),(173,7438460,7438454,'own',20,1),(173,7438461,7438456,'oth',33.333,1),(173,7438462,7438456,'the',33.333,1),(173,7438463,7438456,'her',33.333,1),(173,7438464,7438461,'uid',50,1),(173,7438465,7438461,'ids',50,1),(173,7438466,7438464,'vml',100,1),(173,7438467,7438466,'dis',20,1),(173,7438468,7438466,'isp',20,1),(173,7438469,7438466,'spl',20,1),(173,7438470,7438466,'pla',20,1),(173,7438471,7438466,'lay',20,1),(173,7438472,7438467,'nam',50,1),(173,7438473,7438467,'ame',50,1),(174,7438475,7438474,'net',25,3),(174,7438476,7438474,'eta',25,3),(174,7438477,7438474,'tap',25,3),(174,7438478,7438474,'app',25,3),(174,7438479,7438475,'fib',33.333,2),(174,7438480,7438475,'ibr',33.333,2),(174,7438481,7438475,'bre',33.333,2),(174,7438482,7438479,'cha',20,2),(174,7438483,7438479,'han',20,2),(174,7438484,7438479,'ann',20,2),(174,7438485,7438479,'nne',20,2),(174,7438486,7438479,'nel',20,2),(174,7438487,7438482,'dis',50,2),(174,7438488,7438482,'isk',50,2),(174,7438489,7438487,'naa',100,4),(174,7438490,7438489,'600',3.333,4),(174,7438491,7438489,'00a',3.333,4),(174,7438492,7438489,'0a0',3.333,4),(174,7438493,7438489,'a09',3.333,4),(174,7438494,7438489,'098',3.333,4),(174,7438495,7438489,'980',3.333,4),(174,7438496,7438489,'804',3.333,4),(174,7438497,7438489,'044',3.333,4),(174,7438498,7438489,'443',3.333,4),(174,7438499,7438489,'430',3.333,4),(174,7438500,7438489,'307',3.333,4),(174,7438501,7438489,'072',3.333,4),(174,7438502,7438489,'725',3.333,4),(174,7438503,7438489,'259',3.333,4),(174,7438504,7438489,'593',3.333,4),(174,7438505,7438489,'931',3.333,4),(174,7438506,7438489,'313',3.333,4),(174,7438507,7438489,'13f',3.333,4),(174,7438508,7438489,'3f3',3.333,4),(174,7438509,7438489,'f33',3.333,4),(174,7438510,7438489,'334',3.333,4),(174,7438511,7438489,'345',3.333,4),(174,7438512,7438489,'455',3.333,4),(174,7438513,7438489,'556',3.333,4),(174,7438514,7438489,'563',3.333,4),(174,7438515,7438489,'639',3.333,4),(174,7438516,7438489,'393',3.333,4),(174,7438517,7438489,'935',3.333,4),(174,7438518,7438489,'353',3.333,4),(174,7438519,7438489,'532',3.333,4),(174,7438520,7438490,'ser',25,1),(174,7438521,7438490,'eri',25,1),(174,7438522,7438490,'ria',25,1),(174,7438523,7438490,'ial',25,1),(174,7438524,7438520,'siz',50,1),(174,7438525,7438520,'ize',50,1),(174,7438526,7438524,'321',100,1),(174,7438527,7438526,'dev',25,1),(174,7438528,7438526,'evi',25,1),(174,7438529,7438526,'vic',25,1),(174,7438530,7438526,'ice',25,1),(174,7438531,7438527,'typ',50,1),(174,7438532,7438527,'ype',50,1),(174,7438533,7438531,'dir',10,1),(174,7438534,7438531,'ire',10,1),(174,7438535,7438531,'rec',10,1),(174,7438536,7438531,'ect',10,1),(174,7438537,7438531,'cta',10,1),(174,7438538,7438531,'tac',10,1),(174,7438539,7438531,'acc',10,1),(174,7438540,7438531,'cce',10,1),(174,7438541,7438531,'ces',10,1),(174,7438542,7438531,'ess',10,1),(174,7438543,7438533,'mul',14.286,1),(174,7438544,7438533,'ult',14.286,1),(174,7438545,7438533,'lti',14.286,1),(174,7438546,7438533,'tip',14.286,1),(174,7438547,7438533,'ipa',14.286,1),(174,7438548,7438533,'pat',14.286,1),(174,7438549,7438533,'ath',14.286,1),(174,7438550,7438543,'plu',25,1),(174,7438551,7438543,'lug',25,1),(174,7438552,7438543,'ugi',25,1),(174,7438553,7438543,'gin',25,1),(174,7438554,7438550,'nmp',100,1),(174,7438555,7438554,'dev',33.333,1),(174,7438556,7438554,'evf',33.333,1),(174,7438557,7438554,'vfs',33.333,1),(174,7438558,7438555,'pat',50,1),(174,7438559,7438555,'ath',50,1),(174,7438560,7438558,'vmf',50,1),(174,7438561,7438558,'mfs',50,1),(174,7438562,7438560,'dev',20,1),(174,7438563,7438560,'evi',20,1),(174,7438564,7438560,'vic',20,1),(174,7438565,7438560,'ice',20,1),(174,7438566,7438560,'ces',20,1),(174,7438567,7438562,'dis',33.333,1),(174,7438568,7438562,'isk',33.333,1),(174,7438569,7438562,'sks',33.333,1),(174,7438570,7438567,'ven',25,1),(174,7438571,7438567,'end',25,1),(174,7438572,7438567,'ndo',25,1),(174,7438573,7438567,'dor',25,1),(174,7438574,7438570,'mod',33.333,1),(174,7438575,7438570,'ode',33.333,1),(174,7438576,7438570,'del',33.333,1),(174,7438577,7438574,'lun',100,1),(174,7438578,7438577,'cmo',33.333,1),(174,7438579,7438577,'mod',33.333,1),(174,7438580,7438577,'ode',33.333,1),(174,7438581,7438578,'rev',16.667,1),(174,7438582,7438578,'evi',16.667,1),(174,7438583,7438578,'vis',16.667,1),(174,7438584,7438578,'isi',16.667,1),(174,7438585,7438578,'sio',16.667,1),(174,7438586,7438578,'ion',16.667,1),(174,7438587,7438581,'810',50,1),(174,7438588,7438581,'100',50,1),(174,7438589,7438587,'scs',50,1),(174,7438590,7438587,'csi',50,1),(174,7438591,7438589,'lev',33.333,1),(174,7438592,7438589,'eve',33.333,1),(174,7438593,7438589,'vel',33.333,1),(174,7438594,7438591,'pse',25,1),(174,7438595,7438591,'seu',25,1),(174,7438596,7438591,'eud',25,1),(174,7438597,7438591,'udo',25,1),(174,7438598,7438594,'fal',33.333,6),(174,7438599,7438594,'als',33.333,6),(174,7438600,7438594,'lse',33.333,6),(174,7438601,7438598,'sta',25,3),(174,7438602,7438598,'tat',25,3),(174,7438603,7438598,'atu',25,3),(174,7438604,7438598,'tus',25,3),(174,7438605,7438601,'rdm',100,1),(174,7438606,7438605,'cap',20,1),(174,7438607,7438605,'apa',20,1),(174,7438608,7438605,'pab',20,1),(174,7438609,7438605,'abl',20,1),(174,7438610,7438605,'ble',20,1),(174,7438611,7438606,'tru',50,1),(174,7438612,7438606,'rue',50,1),(174,7438613,7438611,'loc',33.333,1),(174,7438614,7438611,'oca',33.333,1),(174,7438615,7438611,'cal',33.333,1),(174,7438616,7438613,'rem',14.286,1),(174,7438617,7438613,'emo',14.286,1),(174,7438618,7438613,'mov',14.286,1),(174,7438619,7438613,'ova',14.286,1),(174,7438620,7438613,'vab',14.286,1),(174,7438621,7438613,'abl',14.286,1),(174,7438622,7438613,'ble',14.286,1),(174,7438623,7438616,'ssd',100,1),(174,7438624,7438623,'off',20,1),(174,7438625,7438623,'ffl',20,1),(174,7438626,7438623,'fli',20,1),(174,7438627,7438623,'lin',20,1),(174,7438628,7438623,'ine',20,1),(174,7438629,7438624,'per',11.111,1),(174,7438630,7438624,'ere',11.111,1),(174,7438631,7438624,'ren',11.111,1),(174,7438632,7438624,'enn',11.111,1),(174,7438633,7438624,'nni',11.111,1),(174,7438634,7438624,'nia',11.111,1),(174,7438635,7438624,'ial',11.111,1),(174,7438636,7438624,'all',11.111,1),(174,7438637,7438624,'lly',11.111,1),(174,7438638,7438629,'res',16.667,1),(174,7438639,7438629,'ese',16.667,1),(174,7438640,7438629,'ser',16.667,1),(174,7438641,7438629,'erv',16.667,1),(174,7438642,7438629,'rve',16.667,1),(174,7438643,7438629,'ved',16.667,1),(174,7438644,7438638,'thi',50,1),(174,7438645,7438638,'hin',50,1),(174,7438646,7438644,'pro',10,1),(174,7438647,7438644,'rov',10,1),(174,7438648,7438644,'ovi',10,1),(174,7438649,7438644,'vis',10,1),(174,7438650,7438644,'isi',10,1),(174,7438651,7438644,'sio',10,1),(174,7438652,7438644,'ion',10,1),(174,7438653,7438644,'oni',10,1),(174,7438654,7438644,'nin',10,1),(174,7438655,7438644,'ing',10,1),(174,7438656,7438646,'yes',100,1),(174,7438657,7438656,'att',16.667,1),(174,7438658,7438656,'tta',16.667,1),(174,7438659,7438656,'tac',16.667,1),(174,7438660,7438656,'ach',16.667,1),(174,7438661,7438656,'che',16.667,1),(174,7438662,7438656,'hed',16.667,1),(174,7438663,7438657,'fil',20,1),(174,7438664,7438657,'ilt',20,1),(174,7438665,7438657,'lte',20,1),(174,7438666,7438657,'ter',20,1),(174,7438667,7438657,'ers',20,1),(174,7438668,7438663,'vaa',50,1),(174,7438669,7438663,'aai',50,1),(174,7438670,7438668,'unk',20,1),(174,7438671,7438668,'nkn',20,1),(174,7438672,7438668,'kno',20,1),(174,7438673,7438668,'now',20,1),(174,7438674,7438668,'own',20,1),(174,7438675,7438670,'oth',33.333,1),(174,7438676,7438670,'the',33.333,1),(174,7438677,7438670,'her',33.333,1),(174,7438678,7438675,'uid',50,1),(174,7438679,7438675,'ids',50,1),(174,7438680,7438678,'vml',100,1),(174,7438681,7438680,'dis',20,1),(174,7438682,7438680,'isp',20,1),(174,7438683,7438680,'spl',20,1),(174,7438684,7438680,'pla',20,1),(174,7438685,7438680,'lay',20,1),(174,7438686,7438681,'nam',50,1),(174,7438687,7438681,'ame',50,1),(175,7438689,7438688,'net',25,3),(175,7438690,7438688,'eta',25,3),(175,7438691,7438688,'tap',25,3),(175,7438692,7438688,'app',25,3),(175,7438693,7438689,'fib',33.333,2),(175,7438694,7438689,'ibr',33.333,2),(175,7438695,7438689,'bre',33.333,2),(175,7438696,7438693,'cha',20,2),(175,7438697,7438693,'han',20,2),(175,7438698,7438693,'ann',20,2),(175,7438699,7438693,'nne',20,2),(175,7438700,7438693,'nel',20,2),(175,7438701,7438696,'dis',50,2),(175,7438702,7438696,'isk',50,2),(175,7438703,7438701,'naa',100,4),(175,7438704,7438703,'600',3.333,4),(175,7438705,7438703,'00a',3.333,4),(175,7438706,7438703,'0a0',3.333,4),(175,7438707,7438703,'a09',3.333,4),(175,7438708,7438703,'098',3.333,4),(175,7438709,7438703,'980',3.333,4),(175,7438710,7438703,'804',3.333,4),(175,7438711,7438703,'044',3.333,4),(175,7438712,7438703,'443',3.333,4),(175,7438713,7438703,'430',3.333,4),(175,7438714,7438703,'307',3.333,4),(175,7438715,7438703,'072',3.333,4),(175,7438716,7438703,'725',3.333,4),(175,7438717,7438703,'259',3.333,4),(175,7438718,7438703,'593',3.333,4),(175,7438719,7438703,'931',3.333,4),(175,7438720,7438703,'313',3.333,4),(175,7438721,7438703,'13f',3.333,4),(175,7438722,7438703,'3f3',3.333,4),(175,7438723,7438703,'f33',3.333,4),(175,7438724,7438703,'334',3.333,4),(175,7438725,7438703,'345',3.333,4),(175,7438726,7438703,'455',3.333,4),(175,7438727,7438703,'556',3.333,4),(175,7438728,7438703,'563',3.333,4),(175,7438729,7438703,'639',3.333,4),(175,7438730,7438703,'393',3.333,4),(175,7438731,7438703,'934',3.333,4),(175,7438732,7438703,'345',3.333,4),(175,7438733,7438703,'455',3.333,4),(175,7438734,7438704,'ser',25,1),(175,7438735,7438704,'eri',25,1),(175,7438736,7438704,'ria',25,1),(175,7438737,7438704,'ial',25,1),(175,7438738,7438734,'siz',50,1),(175,7438739,7438734,'ize',50,1),(175,7438740,7438738,'321',100,1),(175,7438741,7438740,'dev',25,1),(175,7438742,7438740,'evi',25,1),(175,7438743,7438740,'vic',25,1),(175,7438744,7438740,'ice',25,1),(175,7438745,7438741,'typ',50,1),(175,7438746,7438741,'ype',50,1),(175,7438747,7438745,'dir',10,1),(175,7438748,7438745,'ire',10,1),(175,7438749,7438745,'rec',10,1),(175,7438750,7438745,'ect',10,1),(175,7438751,7438745,'cta',10,1),(175,7438752,7438745,'tac',10,1),(175,7438753,7438745,'acc',10,1),(175,7438754,7438745,'cce',10,1),(175,7438755,7438745,'ces',10,1),(175,7438756,7438745,'ess',10,1),(175,7438757,7438747,'mul',14.286,1),(175,7438758,7438747,'ult',14.286,1),(175,7438759,7438747,'lti',14.286,1),(175,7438760,7438747,'tip',14.286,1),(175,7438761,7438747,'ipa',14.286,1),(175,7438762,7438747,'pat',14.286,1),(175,7438763,7438747,'ath',14.286,1),(175,7438764,7438757,'plu',25,1),(175,7438765,7438757,'lug',25,1),(175,7438766,7438757,'ugi',25,1),(175,7438767,7438757,'gin',25,1),(175,7438768,7438764,'nmp',100,1),(175,7438769,7438768,'dev',33.333,1),(175,7438770,7438768,'evf',33.333,1),(175,7438771,7438768,'vfs',33.333,1),(175,7438772,7438769,'pat',50,1),(175,7438773,7438769,'ath',50,1),(175,7438774,7438772,'vmf',50,1),(175,7438775,7438772,'mfs',50,1),(175,7438776,7438774,'dev',20,1),(175,7438777,7438774,'evi',20,1),(175,7438778,7438774,'vic',20,1),(175,7438779,7438774,'ice',20,1),(175,7438780,7438774,'ces',20,1),(175,7438781,7438776,'dis',33.333,1),(175,7438782,7438776,'isk',33.333,1),(175,7438783,7438776,'sks',33.333,1),(175,7438784,7438781,'ven',25,1),(175,7438785,7438781,'end',25,1),(175,7438786,7438781,'ndo',25,1),(175,7438787,7438781,'dor',25,1),(175,7438788,7438784,'mod',33.333,1),(175,7438789,7438784,'ode',33.333,1),(175,7438790,7438784,'del',33.333,1),(175,7438791,7438788,'lun',100,1),(175,7438792,7438791,'cmo',33.333,1),(175,7438793,7438791,'mod',33.333,1),(175,7438794,7438791,'ode',33.333,1),(175,7438795,7438792,'rev',16.667,1),(175,7438796,7438792,'evi',16.667,1),(175,7438797,7438792,'vis',16.667,1),(175,7438798,7438792,'isi',16.667,1),(175,7438799,7438792,'sio',16.667,1),(175,7438800,7438792,'ion',16.667,1),(175,7438801,7438795,'810',50,1),(175,7438802,7438795,'100',50,1),(175,7438803,7438801,'scs',50,1),(175,7438804,7438801,'csi',50,1),(175,7438805,7438803,'lev',33.333,1),(175,7438806,7438803,'eve',33.333,1),(175,7438807,7438803,'vel',33.333,1),(175,7438808,7438805,'pse',25,1),(175,7438809,7438805,'seu',25,1),(175,7438810,7438805,'eud',25,1),(175,7438811,7438805,'udo',25,1),(175,7438812,7438808,'fal',33.333,6),(175,7438813,7438808,'als',33.333,6),(175,7438814,7438808,'lse',33.333,6),(175,7438815,7438812,'sta',25,3),(175,7438816,7438812,'tat',25,3),(175,7438817,7438812,'atu',25,3),(175,7438818,7438812,'tus',25,3),(175,7438819,7438815,'rdm',100,1),(175,7438820,7438819,'cap',20,1),(175,7438821,7438819,'apa',20,1),(175,7438822,7438819,'pab',20,1),(175,7438823,7438819,'abl',20,1),(175,7438824,7438819,'ble',20,1),(175,7438825,7438820,'tru',50,1),(175,7438826,7438820,'rue',50,1),(175,7438827,7438825,'loc',33.333,1),(175,7438828,7438825,'oca',33.333,1),(175,7438829,7438825,'cal',33.333,1),(175,7438830,7438827,'rem',14.286,1),(175,7438831,7438827,'emo',14.286,1),(175,7438832,7438827,'mov',14.286,1),(175,7438833,7438827,'ova',14.286,1),(175,7438834,7438827,'vab',14.286,1),(175,7438835,7438827,'abl',14.286,1),(175,7438836,7438827,'ble',14.286,1),(175,7438837,7438830,'ssd',100,1),(175,7438838,7438837,'off',20,1),(175,7438839,7438837,'ffl',20,1),(175,7438840,7438837,'fli',20,1),(175,7438841,7438837,'lin',20,1),(175,7438842,7438837,'ine',20,1),(175,7438843,7438838,'per',11.111,1),(175,7438844,7438838,'ere',11.111,1),(175,7438845,7438838,'ren',11.111,1),(175,7438846,7438838,'enn',11.111,1),(175,7438847,7438838,'nni',11.111,1),(175,7438848,7438838,'nia',11.111,1),(175,7438849,7438838,'ial',11.111,1),(175,7438850,7438838,'all',11.111,1),(175,7438851,7438838,'lly',11.111,1),(175,7438852,7438843,'res',16.667,1),(175,7438853,7438843,'ese',16.667,1),(175,7438854,7438843,'ser',16.667,1),(175,7438855,7438843,'erv',16.667,1),(175,7438856,7438843,'rve',16.667,1),(175,7438857,7438843,'ved',16.667,1),(175,7438858,7438852,'thi',50,1),(175,7438859,7438852,'hin',50,1),(175,7438860,7438858,'pro',10,1),(175,7438861,7438858,'rov',10,1),(175,7438862,7438858,'ovi',10,1),(175,7438863,7438858,'vis',10,1),(175,7438864,7438858,'isi',10,1),(175,7438865,7438858,'sio',10,1),(175,7438866,7438858,'ion',10,1),(175,7438867,7438858,'oni',10,1),(175,7438868,7438858,'nin',10,1),(175,7438869,7438858,'ing',10,1),(175,7438870,7438860,'yes',100,1),(175,7438871,7438870,'att',16.667,1),(175,7438872,7438870,'tta',16.667,1),(175,7438873,7438870,'tac',16.667,1),(175,7438874,7438870,'ach',16.667,1),(175,7438875,7438870,'che',16.667,1),(175,7438876,7438870,'hed',16.667,1),(175,7438877,7438871,'fil',20,1),(175,7438878,7438871,'ilt',20,1),(175,7438879,7438871,'lte',20,1),(175,7438880,7438871,'ter',20,1),(175,7438881,7438871,'ers',20,1),(175,7438882,7438877,'vaa',50,1),(175,7438883,7438877,'aai',50,1),(175,7438884,7438882,'unk',20,1),(175,7438885,7438882,'nkn',20,1),(175,7438886,7438882,'kno',20,1),(175,7438887,7438882,'now',20,1),(175,7438888,7438882,'own',20,1),(175,7438889,7438884,'oth',33.333,1),(175,7438890,7438884,'the',33.333,1),(175,7438891,7438884,'her',33.333,1),(175,7438892,7438889,'uid',50,1),(175,7438893,7438889,'ids',50,1),(175,7438894,7438892,'vml',100,1),(175,7438895,7438894,'dis',20,1),(175,7438896,7438894,'isp',20,1),(175,7438897,7438894,'spl',20,1),(175,7438898,7438894,'pla',20,1),(175,7438899,7438894,'lay',20,1),(175,7438900,7438895,'nam',50,1),(175,7438901,7438895,'ame',50,1),(176,7438903,7438902,'net',25,3),(176,7438904,7438902,'eta',25,3),(176,7438905,7438902,'tap',25,3),(176,7438906,7438902,'app',25,3),(176,7438907,7438903,'fib',33.333,2),(176,7438908,7438903,'ibr',33.333,2),(176,7438909,7438903,'bre',33.333,2),(176,7438910,7438907,'cha',20,2),(176,7438911,7438907,'han',20,2),(176,7438912,7438907,'ann',20,2),(176,7438913,7438907,'nne',20,2),(176,7438914,7438907,'nel',20,2),(176,7438915,7438910,'dis',50,2),(176,7438916,7438910,'isk',50,2),(176,7438917,7438915,'naa',100,4),(176,7438918,7438917,'600',3.333,4),(176,7438919,7438917,'00a',3.333,4),(176,7438920,7438917,'0a0',3.333,4),(176,7438921,7438917,'a09',3.333,4),(176,7438922,7438917,'098',3.333,4),(176,7438923,7438917,'980',3.333,4),(176,7438924,7438917,'804',3.333,4),(176,7438925,7438917,'044',3.333,4),(176,7438926,7438917,'443',3.333,4),(176,7438927,7438917,'430',3.333,4),(176,7438928,7438917,'307',3.333,4),(176,7438929,7438917,'072',3.333,4),(176,7438930,7438917,'725',3.333,4),(176,7438931,7438917,'259',3.333,4),(176,7438932,7438917,'593',3.333,4),(176,7438933,7438917,'931',3.333,4),(176,7438934,7438917,'313',3.333,4),(176,7438935,7438917,'13f',3.333,4),(176,7438936,7438917,'3f3',3.333,4),(176,7438937,7438917,'f33',3.333,4),(176,7438938,7438917,'334',3.333,4),(176,7438939,7438917,'345',3.333,4),(176,7438940,7438917,'455',3.333,4),(176,7438941,7438917,'556',3.333,4),(176,7438942,7438917,'563',3.333,4),(176,7438943,7438917,'639',3.333,4),(176,7438944,7438917,'393',3.333,4),(176,7438945,7438917,'933',3.333,4),(176,7438946,7438917,'337',3.333,4),(176,7438947,7438917,'379',3.333,4),(176,7438948,7438918,'ser',25,1),(176,7438949,7438918,'eri',25,1),(176,7438950,7438918,'ria',25,1),(176,7438951,7438918,'ial',25,1),(176,7438952,7438948,'siz',50,1),(176,7438953,7438948,'ize',50,1),(176,7438954,7438952,'460',33.333,1),(176,7438955,7438952,'608',33.333,1),(176,7438956,7438952,'080',33.333,1),(176,7438957,7438954,'dev',25,1),(176,7438958,7438954,'evi',25,1),(176,7438959,7438954,'vic',25,1),(176,7438960,7438954,'ice',25,1),(176,7438961,7438957,'typ',50,1),(176,7438962,7438957,'ype',50,1),(176,7438963,7438961,'dir',10,1),(176,7438964,7438961,'ire',10,1),(176,7438965,7438961,'rec',10,1),(176,7438966,7438961,'ect',10,1),(176,7438967,7438961,'cta',10,1),(176,7438968,7438961,'tac',10,1),(176,7438969,7438961,'acc',10,1),(176,7438970,7438961,'cce',10,1),(176,7438971,7438961,'ces',10,1),(176,7438972,7438961,'ess',10,1),(176,7438973,7438963,'mul',14.286,1),(176,7438974,7438963,'ult',14.286,1),(176,7438975,7438963,'lti',14.286,1),(176,7438976,7438963,'tip',14.286,1),(176,7438977,7438963,'ipa',14.286,1),(176,7438978,7438963,'pat',14.286,1),(176,7438979,7438963,'ath',14.286,1),(176,7438980,7438973,'plu',25,1),(176,7438981,7438973,'lug',25,1),(176,7438982,7438973,'ugi',25,1),(176,7438983,7438973,'gin',25,1),(176,7438984,7438980,'nmp',100,1),(176,7438985,7438984,'dev',33.333,1),(176,7438986,7438984,'evf',33.333,1),(176,7438987,7438984,'vfs',33.333,1),(176,7438988,7438985,'pat',50,1),(176,7438989,7438985,'ath',50,1),(176,7438990,7438988,'vmf',50,1),(176,7438991,7438988,'mfs',50,1),(176,7438992,7438990,'dev',20,1),(176,7438993,7438990,'evi',20,1),(176,7438994,7438990,'vic',20,1),(176,7438995,7438990,'ice',20,1),(176,7438996,7438990,'ces',20,1),(176,7438997,7438992,'dis',33.333,1),(176,7438998,7438992,'isk',33.333,1),(176,7438999,7438992,'sks',33.333,1),(176,7439000,7438997,'ven',25,1),(176,7439001,7438997,'end',25,1),(176,7439002,7438997,'ndo',25,1),(176,7439003,7438997,'dor',25,1),(176,7439004,7439000,'mod',33.333,1),(176,7439005,7439000,'ode',33.333,1),(176,7439006,7439000,'del',33.333,1),(176,7439007,7439004,'lun',100,1),(176,7439008,7439007,'cmo',33.333,1),(176,7439009,7439007,'mod',33.333,1),(176,7439010,7439007,'ode',33.333,1),(176,7439011,7439008,'rev',16.667,1),(176,7439012,7439008,'evi',16.667,1),(176,7439013,7439008,'vis',16.667,1),(176,7439014,7439008,'isi',16.667,1),(176,7439015,7439008,'sio',16.667,1),(176,7439016,7439008,'ion',16.667,1),(176,7439017,7439011,'810',50,1),(176,7439018,7439011,'100',50,1),(176,7439019,7439017,'scs',50,1),(176,7439020,7439017,'csi',50,1),(176,7439021,7439019,'lev',33.333,1),(176,7439022,7439019,'eve',33.333,1),(176,7439023,7439019,'vel',33.333,1),(176,7439024,7439021,'pse',25,1),(176,7439025,7439021,'seu',25,1),(176,7439026,7439021,'eud',25,1),(176,7439027,7439021,'udo',25,1),(176,7439028,7439024,'fal',33.333,6),(176,7439029,7439024,'als',33.333,6),(176,7439030,7439024,'lse',33.333,6),(176,7439031,7439028,'sta',25,3),(176,7439032,7439028,'tat',25,3),(176,7439033,7439028,'atu',25,3),(176,7439034,7439028,'tus',25,3),(176,7439035,7439031,'rdm',100,1),(176,7439036,7439035,'cap',20,1),(176,7439037,7439035,'apa',20,1),(176,7439038,7439035,'pab',20,1),(176,7439039,7439035,'abl',20,1),(176,7439040,7439035,'ble',20,1),(176,7439041,7439036,'tru',50,1),(176,7439042,7439036,'rue',50,1),(176,7439043,7439041,'loc',33.333,1),(176,7439044,7439041,'oca',33.333,1),(176,7439045,7439041,'cal',33.333,1),(176,7439046,7439043,'rem',14.286,1),(176,7439047,7439043,'emo',14.286,1),(176,7439048,7439043,'mov',14.286,1),(176,7439049,7439043,'ova',14.286,1),(176,7439050,7439043,'vab',14.286,1),(176,7439051,7439043,'abl',14.286,1),(176,7439052,7439043,'ble',14.286,1),(176,7439053,7439046,'ssd',100,1),(176,7439054,7439053,'off',20,1),(176,7439055,7439053,'ffl',20,1),(176,7439056,7439053,'fli',20,1),(176,7439057,7439053,'lin',20,1),(176,7439058,7439053,'ine',20,1),(176,7439059,7439054,'per',11.111,1),(176,7439060,7439054,'ere',11.111,1),(176,7439061,7439054,'ren',11.111,1),(176,7439062,7439054,'enn',11.111,1),(176,7439063,7439054,'nni',11.111,1),(176,7439064,7439054,'nia',11.111,1),(176,7439065,7439054,'ial',11.111,1),(176,7439066,7439054,'all',11.111,1),(176,7439067,7439054,'lly',11.111,1),(176,7439068,7439059,'res',16.667,1),(176,7439069,7439059,'ese',16.667,1),(176,7439070,7439059,'ser',16.667,1),(176,7439071,7439059,'erv',16.667,1),(176,7439072,7439059,'rve',16.667,1),(176,7439073,7439059,'ved',16.667,1),(176,7439074,7439068,'thi',50,1),(176,7439075,7439068,'hin',50,1),(176,7439076,7439074,'pro',10,1),(176,7439077,7439074,'rov',10,1),(176,7439078,7439074,'ovi',10,1),(176,7439079,7439074,'vis',10,1),(176,7439080,7439074,'isi',10,1),(176,7439081,7439074,'sio',10,1),(176,7439082,7439074,'ion',10,1),(176,7439083,7439074,'oni',10,1),(176,7439084,7439074,'nin',10,1),(176,7439085,7439074,'ing',10,1),(176,7439086,7439076,'yes',100,1),(176,7439087,7439086,'att',16.667,1),(176,7439088,7439086,'tta',16.667,1),(176,7439089,7439086,'tac',16.667,1),(176,7439090,7439086,'ach',16.667,1),(176,7439091,7439086,'che',16.667,1),(176,7439092,7439086,'hed',16.667,1),(176,7439093,7439087,'fil',20,1),(176,7439094,7439087,'ilt',20,1),(176,7439095,7439087,'lte',20,1),(176,7439096,7439087,'ter',20,1),(176,7439097,7439087,'ers',20,1),(176,7439098,7439093,'vaa',50,1),(176,7439099,7439093,'aai',50,1),(176,7439100,7439098,'unk',20,1),(176,7439101,7439098,'nkn',20,1),(176,7439102,7439098,'kno',20,1),(176,7439103,7439098,'now',20,1),(176,7439104,7439098,'own',20,1),(176,7439105,7439100,'oth',33.333,1),(176,7439106,7439100,'the',33.333,1),(176,7439107,7439100,'her',33.333,1),(176,7439108,7439105,'uid',50,1),(176,7439109,7439105,'ids',50,1),(176,7439110,7439108,'vml',100,1),(176,7439111,7439110,'dis',20,1),(176,7439112,7439110,'isp',20,1),(176,7439113,7439110,'spl',20,1),(176,7439114,7439110,'pla',20,1),(176,7439115,7439110,'lay',20,1),(176,7439116,7439111,'nam',50,1),(176,7439117,7439111,'ame',50,1),(177,7439119,7439118,'net',25,3),(177,7439120,7439118,'eta',25,3),(177,7439121,7439118,'tap',25,3),(177,7439122,7439118,'app',25,3),(177,7439123,7439119,'fib',33.333,2),(177,7439124,7439119,'ibr',33.333,2),(177,7439125,7439119,'bre',33.333,2),(177,7439126,7439123,'cha',20,2),(177,7439127,7439123,'han',20,2),(177,7439128,7439123,'ann',20,2),(177,7439129,7439123,'nne',20,2),(177,7439130,7439123,'nel',20,2),(177,7439131,7439126,'dis',50,2),(177,7439132,7439126,'isk',50,2),(177,7439133,7439131,'naa',100,4),(177,7439134,7439133,'600',3.333,4),(177,7439135,7439133,'00a',3.333,4),(177,7439136,7439133,'0a0',3.333,4),(177,7439137,7439133,'a09',3.333,4),(177,7439138,7439133,'098',3.333,4),(177,7439139,7439133,'980',3.333,4),(177,7439140,7439133,'804',3.333,4),(177,7439141,7439133,'044',3.333,4),(177,7439142,7439133,'443',3.333,4),(177,7439143,7439133,'430',3.333,4),(177,7439144,7439133,'307',3.333,4),(177,7439145,7439133,'072',3.333,4),(177,7439146,7439133,'725',3.333,4),(177,7439147,7439133,'259',3.333,4),(177,7439148,7439133,'593',3.333,4),(177,7439149,7439133,'931',3.333,4),(177,7439150,7439133,'313',3.333,4),(177,7439151,7439133,'13f',3.333,4),(177,7439152,7439133,'3f3',3.333,4),(177,7439153,7439133,'f33',3.333,4),(177,7439154,7439133,'334',3.333,4),(177,7439155,7439133,'345',3.333,4),(177,7439156,7439133,'455',3.333,4),(177,7439157,7439133,'556',3.333,4),(177,7439158,7439133,'563',3.333,4),(177,7439159,7439133,'639',3.333,4),(177,7439160,7439133,'393',3.333,4),(177,7439161,7439133,'935',3.333,4),(177,7439162,7439133,'353',3.333,4),(177,7439163,7439133,'533',3.333,4),(177,7439164,7439134,'ser',25,1),(177,7439165,7439134,'eri',25,1),(177,7439166,7439134,'ria',25,1),(177,7439167,7439134,'ial',25,1),(177,7439168,7439164,'siz',50,1),(177,7439169,7439164,'ize',50,1),(177,7439170,7439168,'321',100,1),(177,7439171,7439170,'dev',25,1),(177,7439172,7439170,'evi',25,1),(177,7439173,7439170,'vic',25,1),(177,7439174,7439170,'ice',25,1),(177,7439175,7439171,'typ',50,1),(177,7439176,7439171,'ype',50,1),(177,7439177,7439175,'dir',10,1),(177,7439178,7439175,'ire',10,1),(177,7439179,7439175,'rec',10,1),(177,7439180,7439175,'ect',10,1),(177,7439181,7439175,'cta',10,1),(177,7439182,7439175,'tac',10,1),(177,7439183,7439175,'acc',10,1),(177,7439184,7439175,'cce',10,1),(177,7439185,7439175,'ces',10,1),(177,7439186,7439175,'ess',10,1),(177,7439187,7439177,'mul',14.286,1),(177,7439188,7439177,'ult',14.286,1),(177,7439189,7439177,'lti',14.286,1),(177,7439190,7439177,'tip',14.286,1),(177,7439191,7439177,'ipa',14.286,1),(177,7439192,7439177,'pat',14.286,1),(177,7439193,7439177,'ath',14.286,1),(177,7439194,7439187,'plu',25,1),(177,7439195,7439187,'lug',25,1),(177,7439196,7439187,'ugi',25,1),(177,7439197,7439187,'gin',25,1),(177,7439198,7439194,'nmp',100,1),(177,7439199,7439198,'dev',33.333,1),(177,7439200,7439198,'evf',33.333,1),(177,7439201,7439198,'vfs',33.333,1),(177,7439202,7439199,'pat',50,1),(177,7439203,7439199,'ath',50,1),(177,7439204,7439202,'vmf',50,1),(177,7439205,7439202,'mfs',50,1),(177,7439206,7439204,'dev',20,1),(177,7439207,7439204,'evi',20,1),(177,7439208,7439204,'vic',20,1),(177,7439209,7439204,'ice',20,1),(177,7439210,7439204,'ces',20,1),(177,7439211,7439206,'dis',33.333,1),(177,7439212,7439206,'isk',33.333,1),(177,7439213,7439206,'sks',33.333,1),(177,7439214,7439211,'ven',25,1),(177,7439215,7439211,'end',25,1),(177,7439216,7439211,'ndo',25,1),(177,7439217,7439211,'dor',25,1),(177,7439218,7439214,'mod',33.333,1),(177,7439219,7439214,'ode',33.333,1),(177,7439220,7439214,'del',33.333,1),(177,7439221,7439218,'lun',100,1),(177,7439222,7439221,'cmo',33.333,1),(177,7439223,7439221,'mod',33.333,1),(177,7439224,7439221,'ode',33.333,1),(177,7439225,7439222,'rev',16.667,1),(177,7439226,7439222,'evi',16.667,1),(177,7439227,7439222,'vis',16.667,1),(177,7439228,7439222,'isi',16.667,1),(177,7439229,7439222,'sio',16.667,1),(177,7439230,7439222,'ion',16.667,1),(177,7439231,7439225,'810',50,1),(177,7439232,7439225,'100',50,1),(177,7439233,7439231,'scs',50,1),(177,7439234,7439231,'csi',50,1),(177,7439235,7439233,'lev',33.333,1),(177,7439236,7439233,'eve',33.333,1),(177,7439237,7439233,'vel',33.333,1),(177,7439238,7439235,'pse',25,1),(177,7439239,7439235,'seu',25,1),(177,7439240,7439235,'eud',25,1),(177,7439241,7439235,'udo',25,1),(177,7439242,7439238,'fal',33.333,6),(177,7439243,7439238,'als',33.333,6),(177,7439244,7439238,'lse',33.333,6),(177,7439245,7439242,'sta',25,3),(177,7439246,7439242,'tat',25,3),(177,7439247,7439242,'atu',25,3),(177,7439248,7439242,'tus',25,3),(177,7439249,7439245,'rdm',100,1),(177,7439250,7439249,'cap',20,1),(177,7439251,7439249,'apa',20,1),(177,7439252,7439249,'pab',20,1),(177,7439253,7439249,'abl',20,1),(177,7439254,7439249,'ble',20,1),(177,7439255,7439250,'tru',50,1),(177,7439256,7439250,'rue',50,1),(177,7439257,7439255,'loc',33.333,1),(177,7439258,7439255,'oca',33.333,1),(177,7439259,7439255,'cal',33.333,1),(177,7439260,7439257,'rem',14.286,1),(177,7439261,7439257,'emo',14.286,1),(177,7439262,7439257,'mov',14.286,1),(177,7439263,7439257,'ova',14.286,1),(177,7439264,7439257,'vab',14.286,1),(177,7439265,7439257,'abl',14.286,1),(177,7439266,7439257,'ble',14.286,1),(177,7439267,7439260,'ssd',100,1),(177,7439268,7439267,'off',20,1),(177,7439269,7439267,'ffl',20,1),(177,7439270,7439267,'fli',20,1),(177,7439271,7439267,'lin',20,1),(177,7439272,7439267,'ine',20,1),(177,7439273,7439268,'per',11.111,1),(177,7439274,7439268,'ere',11.111,1),(177,7439275,7439268,'ren',11.111,1),(177,7439276,7439268,'enn',11.111,1),(177,7439277,7439268,'nni',11.111,1),(177,7439278,7439268,'nia',11.111,1),(177,7439279,7439268,'ial',11.111,1),(177,7439280,7439268,'all',11.111,1),(177,7439281,7439268,'lly',11.111,1),(177,7439282,7439273,'res',16.667,1),(177,7439283,7439273,'ese',16.667,1),(177,7439284,7439273,'ser',16.667,1),(177,7439285,7439273,'erv',16.667,1),(177,7439286,7439273,'rve',16.667,1),(177,7439287,7439273,'ved',16.667,1),(177,7439288,7439282,'thi',50,1),(177,7439289,7439282,'hin',50,1),(177,7439290,7439288,'pro',10,1),(177,7439291,7439288,'rov',10,1),(177,7439292,7439288,'ovi',10,1),(177,7439293,7439288,'vis',10,1),(177,7439294,7439288,'isi',10,1),(177,7439295,7439288,'sio',10,1),(177,7439296,7439288,'ion',10,1),(177,7439297,7439288,'oni',10,1),(177,7439298,7439288,'nin',10,1),(177,7439299,7439288,'ing',10,1),(177,7439300,7439290,'yes',100,1),(177,7439301,7439300,'att',16.667,1),(177,7439302,7439300,'tta',16.667,1),(177,7439303,7439300,'tac',16.667,1),(177,7439304,7439300,'ach',16.667,1),(177,7439305,7439300,'che',16.667,1),(177,7439306,7439300,'hed',16.667,1),(177,7439307,7439301,'fil',20,1),(177,7439308,7439301,'ilt',20,1),(177,7439309,7439301,'lte',20,1),(177,7439310,7439301,'ter',20,1),(177,7439311,7439301,'ers',20,1),(177,7439312,7439307,'vaa',50,1),(177,7439313,7439307,'aai',50,1),(177,7439314,7439312,'unk',20,1),(177,7439315,7439312,'nkn',20,1),(177,7439316,7439312,'kno',20,1),(177,7439317,7439312,'now',20,1),(177,7439318,7439312,'own',20,1),(177,7439319,7439314,'oth',33.333,1),(177,7439320,7439314,'the',33.333,1),(177,7439321,7439314,'her',33.333,1),(177,7439322,7439319,'uid',50,1),(177,7439323,7439319,'ids',50,1),(177,7439324,7439322,'vml',100,1),(177,7439325,7439324,'dis',20,1),(177,7439326,7439324,'isp',20,1),(177,7439327,7439324,'spl',20,1),(177,7439328,7439324,'pla',20,1),(177,7439329,7439324,'lay',20,1),(177,7439330,7439325,'nam',50,1),(177,7439331,7439325,'ame',50,1),(178,7439333,7439332,'net',25,3),(178,7439334,7439332,'eta',25,3),(178,7439335,7439332,'tap',25,3),(178,7439336,7439332,'app',25,3),(178,7439337,7439333,'fib',33.333,2),(178,7439338,7439333,'ibr',33.333,2),(178,7439339,7439333,'bre',33.333,2),(178,7439340,7439337,'cha',20,2),(178,7439341,7439337,'han',20,2),(178,7439342,7439337,'ann',20,2),(178,7439343,7439337,'nne',20,2),(178,7439344,7439337,'nel',20,2),(178,7439345,7439340,'dis',50,2),(178,7439346,7439340,'isk',50,2),(178,7439347,7439345,'naa',100,4),(178,7439348,7439347,'600',3.333,4),(178,7439349,7439347,'00a',3.333,4),(178,7439350,7439347,'0a0',3.333,4),(178,7439351,7439347,'a09',3.333,4),(178,7439352,7439347,'098',3.333,4),(178,7439353,7439347,'980',3.333,4),(178,7439354,7439347,'804',3.333,4),(178,7439355,7439347,'044',3.333,4),(178,7439356,7439347,'443',3.333,4),(178,7439357,7439347,'430',3.333,4),(178,7439358,7439347,'307',3.333,4),(178,7439359,7439347,'072',3.333,4),(178,7439360,7439347,'725',3.333,4),(178,7439361,7439347,'259',3.333,4),(178,7439362,7439347,'593',3.333,4),(178,7439363,7439347,'931',3.333,4),(178,7439364,7439347,'313',3.333,4),(178,7439365,7439347,'13f',3.333,4),(178,7439366,7439347,'3f3',3.333,4),(178,7439367,7439347,'f33',3.333,4),(178,7439368,7439347,'334',3.333,4),(178,7439369,7439347,'345',3.333,4),(178,7439370,7439347,'455',3.333,4),(178,7439371,7439347,'556',3.333,4),(178,7439372,7439347,'563',3.333,4),(178,7439373,7439347,'639',3.333,4),(178,7439374,7439347,'393',3.333,4),(178,7439375,7439347,'934',3.333,4),(178,7439376,7439347,'345',3.333,4),(178,7439377,7439347,'456',3.333,4),(178,7439378,7439348,'ser',25,1),(178,7439379,7439348,'eri',25,1),(178,7439380,7439348,'ria',25,1),(178,7439381,7439348,'ial',25,1),(178,7439382,7439378,'siz',50,1),(178,7439383,7439378,'ize',50,1),(178,7439384,7439382,'321',100,1),(178,7439385,7439384,'dev',25,1),(178,7439386,7439384,'evi',25,1),(178,7439387,7439384,'vic',25,1),(178,7439388,7439384,'ice',25,1),(178,7439389,7439385,'typ',50,1),(178,7439390,7439385,'ype',50,1),(178,7439391,7439389,'dir',10,1),(178,7439392,7439389,'ire',10,1),(178,7439393,7439389,'rec',10,1),(178,7439394,7439389,'ect',10,1),(178,7439395,7439389,'cta',10,1),(178,7439396,7439389,'tac',10,1),(178,7439397,7439389,'acc',10,1),(178,7439398,7439389,'cce',10,1),(178,7439399,7439389,'ces',10,1),(178,7439400,7439389,'ess',10,1),(178,7439401,7439391,'mul',14.286,1),(178,7439402,7439391,'ult',14.286,1),(178,7439403,7439391,'lti',14.286,1),(178,7439404,7439391,'tip',14.286,1),(178,7439405,7439391,'ipa',14.286,1),(178,7439406,7439391,'pat',14.286,1),(178,7439407,7439391,'ath',14.286,1),(178,7439408,7439401,'plu',25,1),(178,7439409,7439401,'lug',25,1),(178,7439410,7439401,'ugi',25,1),(178,7439411,7439401,'gin',25,1),(178,7439412,7439408,'nmp',100,1),(178,7439413,7439412,'dev',33.333,1),(178,7439414,7439412,'evf',33.333,1),(178,7439415,7439412,'vfs',33.333,1),(178,7439416,7439413,'pat',50,1),(178,7439417,7439413,'ath',50,1),(178,7439418,7439416,'vmf',50,1),(178,7439419,7439416,'mfs',50,1),(178,7439420,7439418,'dev',20,1),(178,7439421,7439418,'evi',20,1),(178,7439422,7439418,'vic',20,1),(178,7439423,7439418,'ice',20,1),(178,7439424,7439418,'ces',20,1),(178,7439425,7439420,'dis',33.333,1),(178,7439426,7439420,'isk',33.333,1),(178,7439427,7439420,'sks',33.333,1),(178,7439428,7439425,'ven',25,1),(178,7439429,7439425,'end',25,1),(178,7439430,7439425,'ndo',25,1),(178,7439431,7439425,'dor',25,1),(178,7439432,7439428,'mod',33.333,1),(178,7439433,7439428,'ode',33.333,1),(178,7439434,7439428,'del',33.333,1),(178,7439435,7439432,'lun',100,1),(178,7439436,7439435,'cmo',33.333,1),(178,7439437,7439435,'mod',33.333,1),(178,7439438,7439435,'ode',33.333,1),(178,7439439,7439436,'rev',16.667,1),(178,7439440,7439436,'evi',16.667,1),(178,7439441,7439436,'vis',16.667,1),(178,7439442,7439436,'isi',16.667,1),(178,7439443,7439436,'sio',16.667,1),(178,7439444,7439436,'ion',16.667,1),(178,7439445,7439439,'810',50,1),(178,7439446,7439439,'100',50,1),(178,7439447,7439445,'scs',50,1),(178,7439448,7439445,'csi',50,1),(178,7439449,7439447,'lev',33.333,1),(178,7439450,7439447,'eve',33.333,1),(178,7439451,7439447,'vel',33.333,1),(178,7439452,7439449,'pse',25,1),(178,7439453,7439449,'seu',25,1),(178,7439454,7439449,'eud',25,1),(178,7439455,7439449,'udo',25,1),(178,7439456,7439452,'fal',33.333,6),(178,7439457,7439452,'als',33.333,6),(178,7439458,7439452,'lse',33.333,6),(178,7439459,7439456,'sta',25,3),(178,7439460,7439456,'tat',25,3),(178,7439461,7439456,'atu',25,3),(178,7439462,7439456,'tus',25,3),(178,7439463,7439459,'rdm',100,1),(178,7439464,7439463,'cap',20,1),(178,7439465,7439463,'apa',20,1),(178,7439466,7439463,'pab',20,1),(178,7439467,7439463,'abl',20,1),(178,7439468,7439463,'ble',20,1),(178,7439469,7439464,'tru',50,1),(178,7439470,7439464,'rue',50,1),(178,7439471,7439469,'loc',33.333,1),(178,7439472,7439469,'oca',33.333,1),(178,7439473,7439469,'cal',33.333,1),(178,7439474,7439471,'rem',14.286,1),(178,7439475,7439471,'emo',14.286,1),(178,7439476,7439471,'mov',14.286,1),(178,7439477,7439471,'ova',14.286,1),(178,7439478,7439471,'vab',14.286,1),(178,7439479,7439471,'abl',14.286,1),(178,7439480,7439471,'ble',14.286,1),(178,7439481,7439474,'ssd',100,1),(178,7439482,7439481,'off',20,1),(178,7439483,7439481,'ffl',20,1),(178,7439484,7439481,'fli',20,1),(178,7439485,7439481,'lin',20,1),(178,7439486,7439481,'ine',20,1),(178,7439487,7439482,'per',11.111,1),(178,7439488,7439482,'ere',11.111,1),(178,7439489,7439482,'ren',11.111,1),(178,7439490,7439482,'enn',11.111,1),(178,7439491,7439482,'nni',11.111,1),(178,7439492,7439482,'nia',11.111,1),(178,7439493,7439482,'ial',11.111,1),(178,7439494,7439482,'all',11.111,1),(178,7439495,7439482,'lly',11.111,1),(178,7439496,7439487,'res',16.667,1),(178,7439497,7439487,'ese',16.667,1),(178,7439498,7439487,'ser',16.667,1),(178,7439499,7439487,'erv',16.667,1),(178,7439500,7439487,'rve',16.667,1),(178,7439501,7439487,'ved',16.667,1),(178,7439502,7439496,'thi',50,1),(178,7439503,7439496,'hin',50,1),(178,7439504,7439502,'pro',10,1),(178,7439505,7439502,'rov',10,1),(178,7439506,7439502,'ovi',10,1),(178,7439507,7439502,'vis',10,1),(178,7439508,7439502,'isi',10,1),(178,7439509,7439502,'sio',10,1),(178,7439510,7439502,'ion',10,1),(178,7439511,7439502,'oni',10,1),(178,7439512,7439502,'nin',10,1),(178,7439513,7439502,'ing',10,1),(178,7439514,7439504,'yes',100,1),(178,7439515,7439514,'att',16.667,1),(178,7439516,7439514,'tta',16.667,1),(178,7439517,7439514,'tac',16.667,1),(178,7439518,7439514,'ach',16.667,1),(178,7439519,7439514,'che',16.667,1),(178,7439520,7439514,'hed',16.667,1),(178,7439521,7439515,'fil',20,1),(178,7439522,7439515,'ilt',20,1),(178,7439523,7439515,'lte',20,1),(178,7439524,7439515,'ter',20,1),(178,7439525,7439515,'ers',20,1),(178,7439526,7439521,'vaa',50,1),(178,7439527,7439521,'aai',50,1),(178,7439528,7439526,'unk',20,1),(178,7439529,7439526,'nkn',20,1),(178,7439530,7439526,'kno',20,1),(178,7439531,7439526,'now',20,1),(178,7439532,7439526,'own',20,1),(178,7439533,7439528,'oth',33.333,1),(178,7439534,7439528,'the',33.333,1),(178,7439535,7439528,'her',33.333,1),(178,7439536,7439533,'uid',50,1),(178,7439537,7439533,'ids',50,1),(178,7439538,7439536,'vml',100,1),(178,7439539,7439538,'dis',20,1),(178,7439540,7439538,'isp',20,1),(178,7439541,7439538,'spl',20,1),(178,7439542,7439538,'pla',20,1),(178,7439543,7439538,'lay',20,1),(178,7439544,7439539,'nam',50,1),(178,7439545,7439539,'ame',50,1),(179,7439547,7439546,'net',25,3),(179,7439548,7439546,'eta',25,3),(179,7439549,7439546,'tap',25,3),(179,7439550,7439546,'app',25,3),(179,7439551,7439547,'fib',33.333,2),(179,7439552,7439547,'ibr',33.333,2),(179,7439553,7439547,'bre',33.333,2),(179,7439554,7439551,'cha',20,2),(179,7439555,7439551,'han',20,2),(179,7439556,7439551,'ann',20,2),(179,7439557,7439551,'nne',20,2),(179,7439558,7439551,'nel',20,2),(179,7439559,7439554,'dis',50,2),(179,7439560,7439554,'isk',50,2),(179,7439561,7439559,'naa',100,4),(179,7439562,7439561,'600',3.333,4),(179,7439563,7439561,'00a',3.333,4),(179,7439564,7439561,'0a0',3.333,4),(179,7439565,7439561,'a09',3.333,4),(179,7439566,7439561,'098',3.333,4),(179,7439567,7439561,'980',3.333,4),(179,7439568,7439561,'804',3.333,4),(179,7439569,7439561,'044',3.333,4),(179,7439570,7439561,'443',3.333,4),(179,7439571,7439561,'430',3.333,4),(179,7439572,7439561,'307',3.333,4),(179,7439573,7439561,'072',3.333,4),(179,7439574,7439561,'725',3.333,4),(179,7439575,7439561,'259',3.333,4),(179,7439576,7439561,'593',3.333,4),(179,7439577,7439561,'931',3.333,4),(179,7439578,7439561,'313',3.333,4),(179,7439579,7439561,'13f',3.333,4),(179,7439580,7439561,'3f3',3.333,4),(179,7439581,7439561,'f33',3.333,4),(179,7439582,7439561,'334',3.333,4),(179,7439583,7439561,'345',3.333,4),(179,7439584,7439561,'455',3.333,4),(179,7439585,7439561,'556',3.333,4),(179,7439586,7439561,'563',3.333,4),(179,7439587,7439561,'639',3.333,4),(179,7439588,7439561,'393',3.333,4),(179,7439589,7439561,'935',3.333,4),(179,7439590,7439561,'353',3.333,4),(179,7439591,7439561,'534',3.333,4),(179,7439592,7439562,'ser',25,1),(179,7439593,7439562,'eri',25,1),(179,7439594,7439562,'ria',25,1),(179,7439595,7439562,'ial',25,1),(179,7439596,7439592,'siz',50,1),(179,7439597,7439592,'ize',50,1),(179,7439598,7439596,'321',100,1),(179,7439599,7439598,'dev',25,1),(179,7439600,7439598,'evi',25,1),(179,7439601,7439598,'vic',25,1),(179,7439602,7439598,'ice',25,1),(179,7439603,7439599,'typ',50,1),(179,7439604,7439599,'ype',50,1),(179,7439605,7439603,'dir',10,1),(179,7439606,7439603,'ire',10,1),(179,7439607,7439603,'rec',10,1),(179,7439608,7439603,'ect',10,1),(179,7439609,7439603,'cta',10,1),(179,7439610,7439603,'tac',10,1),(179,7439611,7439603,'acc',10,1),(179,7439612,7439603,'cce',10,1),(179,7439613,7439603,'ces',10,1),(179,7439614,7439603,'ess',10,1),(179,7439615,7439605,'mul',14.286,1),(179,7439616,7439605,'ult',14.286,1),(179,7439617,7439605,'lti',14.286,1),(179,7439618,7439605,'tip',14.286,1),(179,7439619,7439605,'ipa',14.286,1),(179,7439620,7439605,'pat',14.286,1),(179,7439621,7439605,'ath',14.286,1),(179,7439622,7439615,'plu',25,1),(179,7439623,7439615,'lug',25,1),(179,7439624,7439615,'ugi',25,1),(179,7439625,7439615,'gin',25,1),(179,7439626,7439622,'nmp',100,1),(179,7439627,7439626,'dev',33.333,1),(179,7439628,7439626,'evf',33.333,1),(179,7439629,7439626,'vfs',33.333,1),(179,7439630,7439627,'pat',50,1),(179,7439631,7439627,'ath',50,1),(179,7439632,7439630,'vmf',50,1),(179,7439633,7439630,'mfs',50,1),(179,7439634,7439632,'dev',20,1),(179,7439635,7439632,'evi',20,1),(179,7439636,7439632,'vic',20,1),(179,7439637,7439632,'ice',20,1),(179,7439638,7439632,'ces',20,1),(179,7439639,7439634,'dis',33.333,1),(179,7439640,7439634,'isk',33.333,1),(179,7439641,7439634,'sks',33.333,1),(179,7439642,7439639,'ven',25,1),(179,7439643,7439639,'end',25,1),(179,7439644,7439639,'ndo',25,1),(179,7439645,7439639,'dor',25,1),(179,7439646,7439642,'mod',33.333,1),(179,7439647,7439642,'ode',33.333,1),(179,7439648,7439642,'del',33.333,1),(179,7439649,7439646,'lun',100,1),(179,7439650,7439649,'cmo',33.333,1),(179,7439651,7439649,'mod',33.333,1),(179,7439652,7439649,'ode',33.333,1),(179,7439653,7439650,'rev',16.667,1),(179,7439654,7439650,'evi',16.667,1),(179,7439655,7439650,'vis',16.667,1),(179,7439656,7439650,'isi',16.667,1),(179,7439657,7439650,'sio',16.667,1),(179,7439658,7439650,'ion',16.667,1),(179,7439659,7439653,'810',50,1),(179,7439660,7439653,'100',50,1),(179,7439661,7439659,'scs',50,1),(179,7439662,7439659,'csi',50,1),(179,7439663,7439661,'lev',33.333,1),(179,7439664,7439661,'eve',33.333,1),(179,7439665,7439661,'vel',33.333,1),(179,7439666,7439663,'pse',25,1),(179,7439667,7439663,'seu',25,1),(179,7439668,7439663,'eud',25,1),(179,7439669,7439663,'udo',25,1),(179,7439670,7439666,'fal',33.333,6),(179,7439671,7439666,'als',33.333,6),(179,7439672,7439666,'lse',33.333,6),(179,7439673,7439670,'sta',25,3),(179,7439674,7439670,'tat',25,3),(179,7439675,7439670,'atu',25,3),(179,7439676,7439670,'tus',25,3),(179,7439677,7439673,'rdm',100,1),(179,7439678,7439677,'cap',20,1),(179,7439679,7439677,'apa',20,1),(179,7439680,7439677,'pab',20,1),(179,7439681,7439677,'abl',20,1),(179,7439682,7439677,'ble',20,1),(179,7439683,7439678,'tru',50,1),(179,7439684,7439678,'rue',50,1),(179,7439685,7439683,'loc',33.333,1),(179,7439686,7439683,'oca',33.333,1),(179,7439687,7439683,'cal',33.333,1),(179,7439688,7439685,'rem',14.286,1),(179,7439689,7439685,'emo',14.286,1),(179,7439690,7439685,'mov',14.286,1),(179,7439691,7439685,'ova',14.286,1),(179,7439692,7439685,'vab',14.286,1),(179,7439693,7439685,'abl',14.286,1),(179,7439694,7439685,'ble',14.286,1),(179,7439695,7439688,'ssd',100,1),(179,7439696,7439695,'off',20,1),(179,7439697,7439695,'ffl',20,1),(179,7439698,7439695,'fli',20,1),(179,7439699,7439695,'lin',20,1),(179,7439700,7439695,'ine',20,1),(179,7439701,7439696,'per',11.111,1),(179,7439702,7439696,'ere',11.111,1),(179,7439703,7439696,'ren',11.111,1),(179,7439704,7439696,'enn',11.111,1),(179,7439705,7439696,'nni',11.111,1),(179,7439706,7439696,'nia',11.111,1),(179,7439707,7439696,'ial',11.111,1),(179,7439708,7439696,'all',11.111,1),(179,7439709,7439696,'lly',11.111,1),(179,7439710,7439701,'res',16.667,1),(179,7439711,7439701,'ese',16.667,1),(179,7439712,7439701,'ser',16.667,1),(179,7439713,7439701,'erv',16.667,1),(179,7439714,7439701,'rve',16.667,1),(179,7439715,7439701,'ved',16.667,1),(179,7439716,7439710,'thi',50,1),(179,7439717,7439710,'hin',50,1),(179,7439718,7439716,'pro',10,1),(179,7439719,7439716,'rov',10,1),(179,7439720,7439716,'ovi',10,1),(179,7439721,7439716,'vis',10,1),(179,7439722,7439716,'isi',10,1),(179,7439723,7439716,'sio',10,1),(179,7439724,7439716,'ion',10,1),(179,7439725,7439716,'oni',10,1),(179,7439726,7439716,'nin',10,1),(179,7439727,7439716,'ing',10,1),(179,7439728,7439718,'yes',100,1),(179,7439729,7439728,'att',16.667,1),(179,7439730,7439728,'tta',16.667,1),(179,7439731,7439728,'tac',16.667,1),(179,7439732,7439728,'ach',16.667,1),(179,7439733,7439728,'che',16.667,1),(179,7439734,7439728,'hed',16.667,1),(179,7439735,7439729,'fil',20,1),(179,7439736,7439729,'ilt',20,1),(179,7439737,7439729,'lte',20,1),(179,7439738,7439729,'ter',20,1),(179,7439739,7439729,'ers',20,1),(179,7439740,7439735,'vaa',50,1),(179,7439741,7439735,'aai',50,1),(179,7439742,7439740,'unk',20,1),(179,7439743,7439740,'nkn',20,1),(179,7439744,7439740,'kno',20,1),(179,7439745,7439740,'now',20,1),(179,7439746,7439740,'own',20,1),(179,7439747,7439742,'oth',33.333,1),(179,7439748,7439742,'the',33.333,1),(179,7439749,7439742,'her',33.333,1),(179,7439750,7439747,'uid',50,1),(179,7439751,7439747,'ids',50,1),(179,7439752,7439750,'vml',100,1),(179,7439753,7439752,'dis',20,1),(179,7439754,7439752,'isp',20,1),(179,7439755,7439752,'spl',20,1),(179,7439756,7439752,'pla',20,1),(179,7439757,7439752,'lay',20,1),(179,7439758,7439753,'nam',50,1),(179,7439759,7439753,'ame',50,1),(180,7439761,7439760,'net',25,3),(180,7439762,7439760,'eta',25,3),(180,7439763,7439760,'tap',25,3),(180,7439764,7439760,'app',25,3),(180,7439765,7439761,'fib',33.333,2),(180,7439766,7439761,'ibr',33.333,2),(180,7439767,7439761,'bre',33.333,2),(180,7439768,7439765,'cha',20,2),(180,7439769,7439765,'han',20,2),(180,7439770,7439765,'ann',20,2),(180,7439771,7439765,'nne',20,2),(180,7439772,7439765,'nel',20,2),(180,7439773,7439768,'dis',50,2),(180,7439774,7439768,'isk',50,2),(180,7439775,7439773,'naa',100,4),(180,7439776,7439775,'600',3.333,4),(180,7439777,7439775,'00a',3.333,4),(180,7439778,7439775,'0a0',3.333,4),(180,7439779,7439775,'a09',3.333,4),(180,7439780,7439775,'098',3.333,4),(180,7439781,7439775,'980',3.333,4),(180,7439782,7439775,'804',3.333,4),(180,7439783,7439775,'044',3.333,4),(180,7439784,7439775,'443',3.333,4),(180,7439785,7439775,'430',3.333,4),(180,7439786,7439775,'307',3.333,4),(180,7439787,7439775,'072',3.333,4),(180,7439788,7439775,'725',3.333,4),(180,7439789,7439775,'259',3.333,4),(180,7439790,7439775,'593',3.333,4),(180,7439791,7439775,'931',3.333,4),(180,7439792,7439775,'313',3.333,4),(180,7439793,7439775,'13f',3.333,4),(180,7439794,7439775,'3f3',3.333,4),(180,7439795,7439775,'f33',3.333,4),(180,7439796,7439775,'334',3.333,4),(180,7439797,7439775,'345',3.333,4),(180,7439798,7439775,'455',3.333,4),(180,7439799,7439775,'556',3.333,4),(180,7439800,7439775,'563',3.333,4),(180,7439801,7439775,'639',3.333,4),(180,7439802,7439775,'393',3.333,4),(180,7439803,7439775,'934',3.333,4),(180,7439804,7439775,'345',3.333,4),(180,7439805,7439775,'457',3.333,4),(180,7439806,7439776,'ser',25,1),(180,7439807,7439776,'eri',25,1),(180,7439808,7439776,'ria',25,1),(180,7439809,7439776,'ial',25,1),(180,7439810,7439806,'siz',50,1),(180,7439811,7439806,'ize',50,1),(180,7439812,7439810,'321',100,1),(180,7439813,7439812,'dev',25,1),(180,7439814,7439812,'evi',25,1),(180,7439815,7439812,'vic',25,1),(180,7439816,7439812,'ice',25,1),(180,7439817,7439813,'typ',50,1),(180,7439818,7439813,'ype',50,1),(180,7439819,7439817,'dir',10,1),(180,7439820,7439817,'ire',10,1),(180,7439821,7439817,'rec',10,1),(180,7439822,7439817,'ect',10,1),(180,7439823,7439817,'cta',10,1),(180,7439824,7439817,'tac',10,1),(180,7439825,7439817,'acc',10,1),(180,7439826,7439817,'cce',10,1),(180,7439827,7439817,'ces',10,1),(180,7439828,7439817,'ess',10,1),(180,7439829,7439819,'mul',14.286,1),(180,7439830,7439819,'ult',14.286,1),(180,7439831,7439819,'lti',14.286,1),(180,7439832,7439819,'tip',14.286,1),(180,7439833,7439819,'ipa',14.286,1),(180,7439834,7439819,'pat',14.286,1),(180,7439835,7439819,'ath',14.286,1),(180,7439836,7439829,'plu',25,1),(180,7439837,7439829,'lug',25,1),(180,7439838,7439829,'ugi',25,1),(180,7439839,7439829,'gin',25,1),(180,7439840,7439836,'nmp',100,1),(180,7439841,7439840,'dev',33.333,1),(180,7439842,7439840,'evf',33.333,1),(180,7439843,7439840,'vfs',33.333,1),(180,7439844,7439841,'pat',50,1),(180,7439845,7439841,'ath',50,1),(180,7439846,7439844,'vmf',50,1),(180,7439847,7439844,'mfs',50,1),(180,7439848,7439846,'dev',20,1),(180,7439849,7439846,'evi',20,1),(180,7439850,7439846,'vic',20,1),(180,7439851,7439846,'ice',20,1),(180,7439852,7439846,'ces',20,1),(180,7439853,7439848,'dis',33.333,1),(180,7439854,7439848,'isk',33.333,1),(180,7439855,7439848,'sks',33.333,1),(180,7439856,7439853,'ven',25,1),(180,7439857,7439853,'end',25,1),(180,7439858,7439853,'ndo',25,1),(180,7439859,7439853,'dor',25,1),(180,7439860,7439856,'mod',33.333,1),(180,7439861,7439856,'ode',33.333,1),(180,7439862,7439856,'del',33.333,1),(180,7439863,7439860,'lun',100,1),(180,7439864,7439863,'cmo',33.333,1),(180,7439865,7439863,'mod',33.333,1),(180,7439866,7439863,'ode',33.333,1),(180,7439867,7439864,'rev',16.667,1),(180,7439868,7439864,'evi',16.667,1),(180,7439869,7439864,'vis',16.667,1),(180,7439870,7439864,'isi',16.667,1),(180,7439871,7439864,'sio',16.667,1),(180,7439872,7439864,'ion',16.667,1),(180,7439873,7439867,'810',50,1),(180,7439874,7439867,'100',50,1),(180,7439875,7439873,'scs',50,1),(180,7439876,7439873,'csi',50,1),(180,7439877,7439875,'lev',33.333,1),(180,7439878,7439875,'eve',33.333,1),(180,7439879,7439875,'vel',33.333,1),(180,7439880,7439877,'pse',25,1),(180,7439881,7439877,'seu',25,1),(180,7439882,7439877,'eud',25,1),(180,7439883,7439877,'udo',25,1),(180,7439884,7439880,'fal',33.333,6),(180,7439885,7439880,'als',33.333,6),(180,7439886,7439880,'lse',33.333,6),(180,7439887,7439884,'sta',25,3),(180,7439888,7439884,'tat',25,3),(180,7439889,7439884,'atu',25,3),(180,7439890,7439884,'tus',25,3),(180,7439891,7439887,'rdm',100,1),(180,7439892,7439891,'cap',20,1),(180,7439893,7439891,'apa',20,1),(180,7439894,7439891,'pab',20,1),(180,7439895,7439891,'abl',20,1),(180,7439896,7439891,'ble',20,1),(180,7439897,7439892,'tru',50,1),(180,7439898,7439892,'rue',50,1),(180,7439899,7439897,'loc',33.333,1),(180,7439900,7439897,'oca',33.333,1),(180,7439901,7439897,'cal',33.333,1),(180,7439902,7439899,'rem',14.286,1),(180,7439903,7439899,'emo',14.286,1),(180,7439904,7439899,'mov',14.286,1),(180,7439905,7439899,'ova',14.286,1),(180,7439906,7439899,'vab',14.286,1),(180,7439907,7439899,'abl',14.286,1),(180,7439908,7439899,'ble',14.286,1),(180,7439909,7439902,'ssd',100,1),(180,7439910,7439909,'off',20,1),(180,7439911,7439909,'ffl',20,1),(180,7439912,7439909,'fli',20,1),(180,7439913,7439909,'lin',20,1),(180,7439914,7439909,'ine',20,1),(180,7439915,7439910,'per',11.111,1),(180,7439916,7439910,'ere',11.111,1),(180,7439917,7439910,'ren',11.111,1),(180,7439918,7439910,'enn',11.111,1),(180,7439919,7439910,'nni',11.111,1),(180,7439920,7439910,'nia',11.111,1),(180,7439921,7439910,'ial',11.111,1),(180,7439922,7439910,'all',11.111,1),(180,7439923,7439910,'lly',11.111,1),(180,7439924,7439915,'res',16.667,1),(180,7439925,7439915,'ese',16.667,1),(180,7439926,7439915,'ser',16.667,1),(180,7439927,7439915,'erv',16.667,1),(180,7439928,7439915,'rve',16.667,1),(180,7439929,7439915,'ved',16.667,1),(180,7439930,7439924,'thi',50,1),(180,7439931,7439924,'hin',50,1),(180,7439932,7439930,'pro',10,1),(180,7439933,7439930,'rov',10,1),(180,7439934,7439930,'ovi',10,1),(180,7439935,7439930,'vis',10,1),(180,7439936,7439930,'isi',10,1),(180,7439937,7439930,'sio',10,1),(180,7439938,7439930,'ion',10,1),(180,7439939,7439930,'oni',10,1),(180,7439940,7439930,'nin',10,1),(180,7439941,7439930,'ing',10,1),(180,7439942,7439932,'yes',100,1),(180,7439943,7439942,'att',16.667,1),(180,7439944,7439942,'tta',16.667,1),(180,7439945,7439942,'tac',16.667,1),(180,7439946,7439942,'ach',16.667,1),(180,7439947,7439942,'che',16.667,1),(180,7439948,7439942,'hed',16.667,1),(180,7439949,7439943,'fil',20,1),(180,7439950,7439943,'ilt',20,1),(180,7439951,7439943,'lte',20,1),(180,7439952,7439943,'ter',20,1),(180,7439953,7439943,'ers',20,1),(180,7439954,7439949,'vaa',50,1),(180,7439955,7439949,'aai',50,1),(180,7439956,7439954,'unk',20,1),(180,7439957,7439954,'nkn',20,1),(180,7439958,7439954,'kno',20,1),(180,7439959,7439954,'now',20,1),(180,7439960,7439954,'own',20,1),(180,7439961,7439956,'oth',33.333,1),(180,7439962,7439956,'the',33.333,1),(180,7439963,7439956,'her',33.333,1),(180,7439964,7439961,'uid',50,1),(180,7439965,7439961,'ids',50,1),(180,7439966,7439964,'vml',100,1),(180,7439967,7439966,'dis',20,1),(180,7439968,7439966,'isp',20,1),(180,7439969,7439966,'spl',20,1),(180,7439970,7439966,'pla',20,1),(180,7439971,7439966,'lay',20,1),(180,7439972,7439967,'nam',50,1),(180,7439973,7439967,'ame',50,1),(181,7439975,7439974,'net',25,3),(181,7439976,7439974,'eta',25,3),(181,7439977,7439974,'tap',25,3),(181,7439978,7439974,'app',25,3),(181,7439979,7439975,'fib',33.333,2),(181,7439980,7439975,'ibr',33.333,2),(181,7439981,7439975,'bre',33.333,2),(181,7439982,7439979,'cha',20,2),(181,7439983,7439979,'han',20,2),(181,7439984,7439979,'ann',20,2),(181,7439985,7439979,'nne',20,2),(181,7439986,7439979,'nel',20,2),(181,7439987,7439982,'dis',50,2),(181,7439988,7439982,'isk',50,2),(181,7439989,7439987,'naa',100,4),(181,7439990,7439989,'600',3.333,4),(181,7439991,7439989,'00a',3.333,4),(181,7439992,7439989,'0a0',3.333,4),(181,7439993,7439989,'a09',3.333,4),(181,7439994,7439989,'098',3.333,4),(181,7439995,7439989,'980',3.333,4),(181,7439996,7439989,'804',3.333,4),(181,7439997,7439989,'044',3.333,4),(181,7439998,7439989,'443',3.333,4),(181,7439999,7439989,'430',3.333,4),(181,7440000,7439989,'307',3.333,4),(181,7440001,7439989,'072',3.333,4),(181,7440002,7439989,'725',3.333,4),(181,7440003,7439989,'259',3.333,4),(181,7440004,7439989,'593',3.333,4),(181,7440005,7439989,'931',3.333,4),(181,7440006,7439989,'313',3.333,4),(181,7440007,7439989,'13f',3.333,4),(181,7440008,7439989,'3f3',3.333,4),(181,7440009,7439989,'f33',3.333,4),(181,7440010,7439989,'334',3.333,4),(181,7440011,7439989,'345',3.333,4),(181,7440012,7439989,'455',3.333,4),(181,7440013,7439989,'556',3.333,4),(181,7440014,7439989,'563',3.333,4),(181,7440015,7439989,'639',3.333,4),(181,7440016,7439989,'393',3.333,4),(181,7440017,7439989,'934',3.333,4),(181,7440018,7439989,'345',3.333,4),(181,7440019,7439989,'458',3.333,4),(181,7440020,7439990,'ser',25,1),(181,7440021,7439990,'eri',25,1),(181,7440022,7439990,'ria',25,1),(181,7440023,7439990,'ial',25,1),(181,7440024,7440020,'siz',50,1),(181,7440025,7440020,'ize',50,1),(181,7440026,7440024,'321',100,1),(181,7440027,7440026,'dev',25,1),(181,7440028,7440026,'evi',25,1),(181,7440029,7440026,'vic',25,1),(181,7440030,7440026,'ice',25,1),(181,7440031,7440027,'typ',50,1),(181,7440032,7440027,'ype',50,1),(181,7440033,7440031,'dir',10,1),(181,7440034,7440031,'ire',10,1),(181,7440035,7440031,'rec',10,1),(181,7440036,7440031,'ect',10,1),(181,7440037,7440031,'cta',10,1),(181,7440038,7440031,'tac',10,1),(181,7440039,7440031,'acc',10,1),(181,7440040,7440031,'cce',10,1),(181,7440041,7440031,'ces',10,1),(181,7440042,7440031,'ess',10,1),(181,7440043,7440033,'mul',14.286,1),(181,7440044,7440033,'ult',14.286,1),(181,7440045,7440033,'lti',14.286,1),(181,7440046,7440033,'tip',14.286,1),(181,7440047,7440033,'ipa',14.286,1),(181,7440048,7440033,'pat',14.286,1),(181,7440049,7440033,'ath',14.286,1),(181,7440050,7440043,'plu',25,1),(181,7440051,7440043,'lug',25,1),(181,7440052,7440043,'ugi',25,1),(181,7440053,7440043,'gin',25,1),(181,7440054,7440050,'nmp',100,1),(181,7440055,7440054,'dev',33.333,1),(181,7440056,7440054,'evf',33.333,1),(181,7440057,7440054,'vfs',33.333,1),(181,7440058,7440055,'pat',50,1),(181,7440059,7440055,'ath',50,1),(181,7440060,7440058,'vmf',50,1),(181,7440061,7440058,'mfs',50,1),(181,7440062,7440060,'dev',20,1),(181,7440063,7440060,'evi',20,1),(181,7440064,7440060,'vic',20,1),(181,7440065,7440060,'ice',20,1),(181,7440066,7440060,'ces',20,1),(181,7440067,7440062,'dis',33.333,1),(181,7440068,7440062,'isk',33.333,1),(181,7440069,7440062,'sks',33.333,1),(181,7440070,7440067,'ven',25,1),(181,7440071,7440067,'end',25,1),(181,7440072,7440067,'ndo',25,1),(181,7440073,7440067,'dor',25,1),(181,7440074,7440070,'mod',33.333,1),(181,7440075,7440070,'ode',33.333,1),(181,7440076,7440070,'del',33.333,1),(181,7440077,7440074,'lun',100,1),(181,7440078,7440077,'cmo',33.333,1),(181,7440079,7440077,'mod',33.333,1),(181,7440080,7440077,'ode',33.333,1),(181,7440081,7440078,'rev',16.667,1),(181,7440082,7440078,'evi',16.667,1),(181,7440083,7440078,'vis',16.667,1),(181,7440084,7440078,'isi',16.667,1),(181,7440085,7440078,'sio',16.667,1),(181,7440086,7440078,'ion',16.667,1),(181,7440087,7440081,'810',50,1),(181,7440088,7440081,'100',50,1),(181,7440089,7440087,'scs',50,1),(181,7440090,7440087,'csi',50,1),(181,7440091,7440089,'lev',33.333,1),(181,7440092,7440089,'eve',33.333,1),(181,7440093,7440089,'vel',33.333,1),(181,7440094,7440091,'pse',25,1),(181,7440095,7440091,'seu',25,1),(181,7440096,7440091,'eud',25,1),(181,7440097,7440091,'udo',25,1),(181,7440098,7440094,'fal',33.333,6),(181,7440099,7440094,'als',33.333,6),(181,7440100,7440094,'lse',33.333,6),(181,7440101,7440098,'sta',25,3),(181,7440102,7440098,'tat',25,3),(181,7440103,7440098,'atu',25,3),(181,7440104,7440098,'tus',25,3),(181,7440105,7440101,'rdm',100,1),(181,7440106,7440105,'cap',20,1),(181,7440107,7440105,'apa',20,1),(181,7440108,7440105,'pab',20,1),(181,7440109,7440105,'abl',20,1),(181,7440110,7440105,'ble',20,1),(181,7440111,7440106,'tru',50,1),(181,7440112,7440106,'rue',50,1),(181,7440113,7440111,'loc',33.333,1),(181,7440114,7440111,'oca',33.333,1),(181,7440115,7440111,'cal',33.333,1),(181,7440116,7440113,'rem',14.286,1),(181,7440117,7440113,'emo',14.286,1),(181,7440118,7440113,'mov',14.286,1),(181,7440119,7440113,'ova',14.286,1),(181,7440120,7440113,'vab',14.286,1),(181,7440121,7440113,'abl',14.286,1),(181,7440122,7440113,'ble',14.286,1),(181,7440123,7440116,'ssd',100,1),(181,7440124,7440123,'off',20,1),(181,7440125,7440123,'ffl',20,1),(181,7440126,7440123,'fli',20,1),(181,7440127,7440123,'lin',20,1),(181,7440128,7440123,'ine',20,1),(181,7440129,7440124,'per',11.111,1),(181,7440130,7440124,'ere',11.111,1),(181,7440131,7440124,'ren',11.111,1),(181,7440132,7440124,'enn',11.111,1),(181,7440133,7440124,'nni',11.111,1),(181,7440134,7440124,'nia',11.111,1),(181,7440135,7440124,'ial',11.111,1),(181,7440136,7440124,'all',11.111,1),(181,7440137,7440124,'lly',11.111,1),(181,7440138,7440129,'res',16.667,1),(181,7440139,7440129,'ese',16.667,1),(181,7440140,7440129,'ser',16.667,1),(181,7440141,7440129,'erv',16.667,1),(181,7440142,7440129,'rve',16.667,1),(181,7440143,7440129,'ved',16.667,1),(181,7440144,7440138,'thi',50,1),(181,7440145,7440138,'hin',50,1),(181,7440146,7440144,'pro',10,1),(181,7440147,7440144,'rov',10,1),(181,7440148,7440144,'ovi',10,1),(181,7440149,7440144,'vis',10,1),(181,7440150,7440144,'isi',10,1),(181,7440151,7440144,'sio',10,1),(181,7440152,7440144,'ion',10,1),(181,7440153,7440144,'oni',10,1),(181,7440154,7440144,'nin',10,1),(181,7440155,7440144,'ing',10,1),(181,7440156,7440146,'yes',100,1),(181,7440157,7440156,'att',16.667,1),(181,7440158,7440156,'tta',16.667,1),(181,7440159,7440156,'tac',16.667,1),(181,7440160,7440156,'ach',16.667,1),(181,7440161,7440156,'che',16.667,1),(181,7440162,7440156,'hed',16.667,1),(181,7440163,7440157,'fil',20,1),(181,7440164,7440157,'ilt',20,1),(181,7440165,7440157,'lte',20,1),(181,7440166,7440157,'ter',20,1),(181,7440167,7440157,'ers',20,1),(181,7440168,7440163,'vaa',50,1),(181,7440169,7440163,'aai',50,1),(181,7440170,7440168,'unk',20,1),(181,7440171,7440168,'nkn',20,1),(181,7440172,7440168,'kno',20,1),(181,7440173,7440168,'now',20,1),(181,7440174,7440168,'own',20,1),(181,7440175,7440170,'oth',33.333,1),(181,7440176,7440170,'the',33.333,1),(181,7440177,7440170,'her',33.333,1),(181,7440178,7440175,'uid',50,1),(181,7440179,7440175,'ids',50,1),(181,7440180,7440178,'vml',100,1),(181,7440181,7440180,'dis',20,1),(181,7440182,7440180,'isp',20,1),(181,7440183,7440180,'spl',20,1),(181,7440184,7440180,'pla',20,1),(181,7440185,7440180,'lay',20,1),(181,7440186,7440181,'nam',50,1),(181,7440187,7440181,'ame',50,1),(182,7440189,7440188,'net',25,3),(182,7440190,7440188,'eta',25,3),(182,7440191,7440188,'tap',25,3),(182,7440192,7440188,'app',25,3),(182,7440193,7440189,'fib',33.333,2),(182,7440194,7440189,'ibr',33.333,2),(182,7440195,7440189,'bre',33.333,2),(182,7440196,7440193,'cha',20,2),(182,7440197,7440193,'han',20,2),(182,7440198,7440193,'ann',20,2),(182,7440199,7440193,'nne',20,2),(182,7440200,7440193,'nel',20,2),(182,7440201,7440196,'dis',50,2),(182,7440202,7440196,'isk',50,2),(182,7440203,7440201,'naa',100,4),(182,7440204,7440203,'600',3.333,4),(182,7440205,7440203,'00a',3.333,4),(182,7440206,7440203,'0a0',3.333,4),(182,7440207,7440203,'a09',3.333,4),(182,7440208,7440203,'098',3.333,4),(182,7440209,7440203,'980',3.333,4),(182,7440210,7440203,'804',3.333,4),(182,7440211,7440203,'044',3.333,4),(182,7440212,7440203,'443',3.333,4),(182,7440213,7440203,'430',3.333,4),(182,7440214,7440203,'307',3.333,4),(182,7440215,7440203,'072',3.333,4),(182,7440216,7440203,'725',3.333,4),(182,7440217,7440203,'259',3.333,4),(182,7440218,7440203,'593',3.333,4),(182,7440219,7440203,'931',3.333,4),(182,7440220,7440203,'313',3.333,4),(182,7440221,7440203,'13f',3.333,4),(182,7440222,7440203,'3f3',3.333,4),(182,7440223,7440203,'f33',3.333,4),(182,7440224,7440203,'334',3.333,4),(182,7440225,7440203,'345',3.333,4),(182,7440226,7440203,'455',3.333,4),(182,7440227,7440203,'556',3.333,4),(182,7440228,7440203,'563',3.333,4),(182,7440229,7440203,'639',3.333,4),(182,7440230,7440203,'393',3.333,4),(182,7440231,7440203,'934',3.333,4),(182,7440232,7440203,'345',3.333,4),(182,7440233,7440203,'459',3.333,4),(182,7440234,7440204,'ser',25,1),(182,7440235,7440204,'eri',25,1),(182,7440236,7440204,'ria',25,1),(182,7440237,7440204,'ial',25,1),(182,7440238,7440234,'siz',50,1),(182,7440239,7440234,'ize',50,1),(182,7440240,7440238,'321',100,1),(182,7440241,7440240,'dev',25,1),(182,7440242,7440240,'evi',25,1),(182,7440243,7440240,'vic',25,1),(182,7440244,7440240,'ice',25,1),(182,7440245,7440241,'typ',50,1),(182,7440246,7440241,'ype',50,1),(182,7440247,7440245,'dir',10,1),(182,7440248,7440245,'ire',10,1),(182,7440249,7440245,'rec',10,1),(182,7440250,7440245,'ect',10,1),(182,7440251,7440245,'cta',10,1),(182,7440252,7440245,'tac',10,1),(182,7440253,7440245,'acc',10,1),(182,7440254,7440245,'cce',10,1),(182,7440255,7440245,'ces',10,1),(182,7440256,7440245,'ess',10,1),(182,7440257,7440247,'mul',14.286,1),(182,7440258,7440247,'ult',14.286,1),(182,7440259,7440247,'lti',14.286,1),(182,7440260,7440247,'tip',14.286,1),(182,7440261,7440247,'ipa',14.286,1),(182,7440262,7440247,'pat',14.286,1),(182,7440263,7440247,'ath',14.286,1),(182,7440264,7440257,'plu',25,1),(182,7440265,7440257,'lug',25,1),(182,7440266,7440257,'ugi',25,1),(182,7440267,7440257,'gin',25,1),(182,7440268,7440264,'nmp',100,1),(182,7440269,7440268,'dev',33.333,1),(182,7440270,7440268,'evf',33.333,1),(182,7440271,7440268,'vfs',33.333,1),(182,7440272,7440269,'pat',50,1),(182,7440273,7440269,'ath',50,1),(182,7440274,7440272,'vmf',50,1),(182,7440275,7440272,'mfs',50,1),(182,7440276,7440274,'dev',20,1),(182,7440277,7440274,'evi',20,1),(182,7440278,7440274,'vic',20,1),(182,7440279,7440274,'ice',20,1),(182,7440280,7440274,'ces',20,1),(182,7440281,7440276,'dis',33.333,1),(182,7440282,7440276,'isk',33.333,1),(182,7440283,7440276,'sks',33.333,1),(182,7440284,7440281,'ven',25,1),(182,7440285,7440281,'end',25,1),(182,7440286,7440281,'ndo',25,1),(182,7440287,7440281,'dor',25,1),(182,7440288,7440284,'mod',33.333,1),(182,7440289,7440284,'ode',33.333,1),(182,7440290,7440284,'del',33.333,1),(182,7440291,7440288,'lun',100,1),(182,7440292,7440291,'cmo',33.333,1),(182,7440293,7440291,'mod',33.333,1),(182,7440294,7440291,'ode',33.333,1),(182,7440295,7440292,'rev',16.667,1),(182,7440296,7440292,'evi',16.667,1),(182,7440297,7440292,'vis',16.667,1),(182,7440298,7440292,'isi',16.667,1),(182,7440299,7440292,'sio',16.667,1),(182,7440300,7440292,'ion',16.667,1),(182,7440301,7440295,'810',50,1),(182,7440302,7440295,'100',50,1),(182,7440303,7440301,'scs',50,1),(182,7440304,7440301,'csi',50,1),(182,7440305,7440303,'lev',33.333,1),(182,7440306,7440303,'eve',33.333,1),(182,7440307,7440303,'vel',33.333,1),(182,7440308,7440305,'pse',25,1),(182,7440309,7440305,'seu',25,1),(182,7440310,7440305,'eud',25,1),(182,7440311,7440305,'udo',25,1),(182,7440312,7440308,'fal',33.333,6),(182,7440313,7440308,'als',33.333,6),(182,7440314,7440308,'lse',33.333,6),(182,7440315,7440312,'sta',25,3),(182,7440316,7440312,'tat',25,3),(182,7440317,7440312,'atu',25,3),(182,7440318,7440312,'tus',25,3),(182,7440319,7440315,'rdm',100,1),(182,7440320,7440319,'cap',20,1),(182,7440321,7440319,'apa',20,1),(182,7440322,7440319,'pab',20,1),(182,7440323,7440319,'abl',20,1),(182,7440324,7440319,'ble',20,1),(182,7440325,7440320,'tru',50,1),(182,7440326,7440320,'rue',50,1),(182,7440327,7440325,'loc',33.333,1),(182,7440328,7440325,'oca',33.333,1),(182,7440329,7440325,'cal',33.333,1),(182,7440330,7440327,'rem',14.286,1),(182,7440331,7440327,'emo',14.286,1),(182,7440332,7440327,'mov',14.286,1),(182,7440333,7440327,'ova',14.286,1),(182,7440334,7440327,'vab',14.286,1),(182,7440335,7440327,'abl',14.286,1),(182,7440336,7440327,'ble',14.286,1),(182,7440337,7440330,'ssd',100,1),(182,7440338,7440337,'off',20,1),(182,7440339,7440337,'ffl',20,1),(182,7440340,7440337,'fli',20,1),(182,7440341,7440337,'lin',20,1),(182,7440342,7440337,'ine',20,1),(182,7440343,7440338,'per',11.111,1),(182,7440344,7440338,'ere',11.111,1),(182,7440345,7440338,'ren',11.111,1),(182,7440346,7440338,'enn',11.111,1),(182,7440347,7440338,'nni',11.111,1),(182,7440348,7440338,'nia',11.111,1),(182,7440349,7440338,'ial',11.111,1),(182,7440350,7440338,'all',11.111,1),(182,7440351,7440338,'lly',11.111,1),(182,7440352,7440343,'res',16.667,1),(182,7440353,7440343,'ese',16.667,1),(182,7440354,7440343,'ser',16.667,1),(182,7440355,7440343,'erv',16.667,1),(182,7440356,7440343,'rve',16.667,1),(182,7440357,7440343,'ved',16.667,1),(182,7440358,7440352,'thi',50,1),(182,7440359,7440352,'hin',50,1),(182,7440360,7440358,'pro',10,1),(182,7440361,7440358,'rov',10,1),(182,7440362,7440358,'ovi',10,1),(182,7440363,7440358,'vis',10,1),(182,7440364,7440358,'isi',10,1),(182,7440365,7440358,'sio',10,1),(182,7440366,7440358,'ion',10,1),(182,7440367,7440358,'oni',10,1),(182,7440368,7440358,'nin',10,1),(182,7440369,7440358,'ing',10,1),(182,7440370,7440360,'yes',100,1),(182,7440371,7440370,'att',16.667,1),(182,7440372,7440370,'tta',16.667,1),(182,7440373,7440370,'tac',16.667,1),(182,7440374,7440370,'ach',16.667,1),(182,7440375,7440370,'che',16.667,1),(182,7440376,7440370,'hed',16.667,1),(182,7440377,7440371,'fil',20,1),(182,7440378,7440371,'ilt',20,1),(182,7440379,7440371,'lte',20,1),(182,7440380,7440371,'ter',20,1),(182,7440381,7440371,'ers',20,1),(182,7440382,7440377,'vaa',50,1),(182,7440383,7440377,'aai',50,1),(182,7440384,7440382,'unk',20,1),(182,7440385,7440382,'nkn',20,1),(182,7440386,7440382,'kno',20,1),(182,7440387,7440382,'now',20,1),(182,7440388,7440382,'own',20,1),(182,7440389,7440384,'oth',33.333,1),(182,7440390,7440384,'the',33.333,1),(182,7440391,7440384,'her',33.333,1),(182,7440392,7440389,'uid',50,1),(182,7440393,7440389,'ids',50,1),(182,7440394,7440392,'vml',100,1),(182,7440395,7440394,'dis',20,1),(182,7440396,7440394,'isp',20,1),(182,7440397,7440394,'spl',20,1),(182,7440398,7440394,'pla',20,1),(182,7440399,7440394,'lay',20,1),(182,7440400,7440395,'nam',50,1),(182,7440401,7440395,'ame',50,1),(183,7440403,7440402,'net',25,3),(183,7440404,7440402,'eta',25,3),(183,7440405,7440402,'tap',25,3),(183,7440406,7440402,'app',25,3),(183,7440407,7440403,'fib',33.333,2),(183,7440408,7440403,'ibr',33.333,2),(183,7440409,7440403,'bre',33.333,2),(183,7440410,7440407,'cha',20,2),(183,7440411,7440407,'han',20,2),(183,7440412,7440407,'ann',20,2),(183,7440413,7440407,'nne',20,2),(183,7440414,7440407,'nel',20,2),(183,7440415,7440410,'dis',50,2),(183,7440416,7440410,'isk',50,2),(183,7440417,7440415,'naa',100,4),(183,7440418,7440417,'600',3.333,4),(183,7440419,7440417,'00a',3.333,4),(183,7440420,7440417,'0a0',3.333,4),(183,7440421,7440417,'a09',3.333,4),(183,7440422,7440417,'098',3.333,4),(183,7440423,7440417,'980',3.333,4),(183,7440424,7440417,'804',3.333,4),(183,7440425,7440417,'044',3.333,4),(183,7440426,7440417,'443',3.333,4),(183,7440427,7440417,'430',3.333,4),(183,7440428,7440417,'307',3.333,4),(183,7440429,7440417,'072',3.333,4),(183,7440430,7440417,'725',3.333,4),(183,7440431,7440417,'259',3.333,4),(183,7440432,7440417,'593',3.333,4),(183,7440433,7440417,'931',3.333,4),(183,7440434,7440417,'313',3.333,4),(183,7440435,7440417,'13f',3.333,4),(183,7440436,7440417,'3f3',3.333,4),(183,7440437,7440417,'f33',3.333,4),(183,7440438,7440417,'334',3.333,4),(183,7440439,7440417,'345',3.333,4),(183,7440440,7440417,'455',3.333,4),(183,7440441,7440417,'556',3.333,4),(183,7440442,7440417,'563',3.333,4),(183,7440443,7440417,'638',3.333,4),(183,7440444,7440417,'387',3.333,4),(183,7440445,7440417,'872',3.333,4),(183,7440446,7440417,'725',3.333,4),(183,7440447,7440417,'250',3.333,4),(183,7440448,7440418,'ser',25,1),(183,7440449,7440418,'eri',25,1),(183,7440450,7440418,'ria',25,1),(183,7440451,7440418,'ial',25,1),(183,7440452,7440448,'siz',50,1),(183,7440453,7440448,'ize',50,1),(183,7440454,7440452,'460',33.333,1),(183,7440455,7440452,'608',33.333,1),(183,7440456,7440452,'080',33.333,1),(183,7440457,7440454,'dev',25,1),(183,7440458,7440454,'evi',25,1),(183,7440459,7440454,'vic',25,1),(183,7440460,7440454,'ice',25,1),(183,7440461,7440457,'typ',50,1),(183,7440462,7440457,'ype',50,1),(183,7440463,7440461,'dir',10,1),(183,7440464,7440461,'ire',10,1),(183,7440465,7440461,'rec',10,1),(183,7440466,7440461,'ect',10,1),(183,7440467,7440461,'cta',10,1),(183,7440468,7440461,'tac',10,1),(183,7440469,7440461,'acc',10,1),(183,7440470,7440461,'cce',10,1),(183,7440471,7440461,'ces',10,1),(183,7440472,7440461,'ess',10,1),(183,7440473,7440463,'mul',14.286,1),(183,7440474,7440463,'ult',14.286,1),(183,7440475,7440463,'lti',14.286,1),(183,7440476,7440463,'tip',14.286,1),(183,7440477,7440463,'ipa',14.286,1),(183,7440478,7440463,'pat',14.286,1),(183,7440479,7440463,'ath',14.286,1),(183,7440480,7440473,'plu',25,1),(183,7440481,7440473,'lug',25,1),(183,7440482,7440473,'ugi',25,1),(183,7440483,7440473,'gin',25,1),(183,7440484,7440480,'nmp',100,1),(183,7440485,7440484,'dev',33.333,1),(183,7440486,7440484,'evf',33.333,1),(183,7440487,7440484,'vfs',33.333,1),(183,7440488,7440485,'pat',50,1),(183,7440489,7440485,'ath',50,1),(183,7440490,7440488,'vmf',50,1),(183,7440491,7440488,'mfs',50,1),(183,7440492,7440490,'dev',20,1),(183,7440493,7440490,'evi',20,1),(183,7440494,7440490,'vic',20,1),(183,7440495,7440490,'ice',20,1),(183,7440496,7440490,'ces',20,1),(183,7440497,7440492,'dis',33.333,1),(183,7440498,7440492,'isk',33.333,1),(183,7440499,7440492,'sks',33.333,1),(183,7440500,7440497,'ven',25,1),(183,7440501,7440497,'end',25,1),(183,7440502,7440497,'ndo',25,1),(183,7440503,7440497,'dor',25,1),(183,7440504,7440500,'mod',33.333,1),(183,7440505,7440500,'ode',33.333,1),(183,7440506,7440500,'del',33.333,1),(183,7440507,7440504,'lun',100,1),(183,7440508,7440507,'cmo',33.333,1),(183,7440509,7440507,'mod',33.333,1),(183,7440510,7440507,'ode',33.333,1),(183,7440511,7440508,'rev',16.667,1),(183,7440512,7440508,'evi',16.667,1),(183,7440513,7440508,'vis',16.667,1),(183,7440514,7440508,'isi',16.667,1),(183,7440515,7440508,'sio',16.667,1),(183,7440516,7440508,'ion',16.667,1),(183,7440517,7440511,'810',50,1),(183,7440518,7440511,'100',50,1),(183,7440519,7440517,'scs',50,1),(183,7440520,7440517,'csi',50,1),(183,7440521,7440519,'lev',33.333,1),(183,7440522,7440519,'eve',33.333,1),(183,7440523,7440519,'vel',33.333,1),(183,7440524,7440521,'pse',25,1),(183,7440525,7440521,'seu',25,1),(183,7440526,7440521,'eud',25,1),(183,7440527,7440521,'udo',25,1),(183,7440528,7440524,'fal',33.333,6),(183,7440529,7440524,'als',33.333,6),(183,7440530,7440524,'lse',33.333,6),(183,7440531,7440528,'sta',25,3),(183,7440532,7440528,'tat',25,3),(183,7440533,7440528,'atu',25,3),(183,7440534,7440528,'tus',25,3),(183,7440535,7440531,'rdm',100,1),(183,7440536,7440535,'cap',20,1),(183,7440537,7440535,'apa',20,1),(183,7440538,7440535,'pab',20,1),(183,7440539,7440535,'abl',20,1),(183,7440540,7440535,'ble',20,1),(183,7440541,7440536,'tru',50,1),(183,7440542,7440536,'rue',50,1),(183,7440543,7440541,'loc',33.333,1),(183,7440544,7440541,'oca',33.333,1),(183,7440545,7440541,'cal',33.333,1),(183,7440546,7440543,'rem',14.286,1),(183,7440547,7440543,'emo',14.286,1),(183,7440548,7440543,'mov',14.286,1),(183,7440549,7440543,'ova',14.286,1),(183,7440550,7440543,'vab',14.286,1),(183,7440551,7440543,'abl',14.286,1),(183,7440552,7440543,'ble',14.286,1),(183,7440553,7440546,'ssd',100,1),(183,7440554,7440553,'off',20,1),(183,7440555,7440553,'ffl',20,1),(183,7440556,7440553,'fli',20,1),(183,7440557,7440553,'lin',20,1),(183,7440558,7440553,'ine',20,1),(183,7440559,7440554,'per',11.111,1),(183,7440560,7440554,'ere',11.111,1),(183,7440561,7440554,'ren',11.111,1),(183,7440562,7440554,'enn',11.111,1),(183,7440563,7440554,'nni',11.111,1),(183,7440564,7440554,'nia',11.111,1),(183,7440565,7440554,'ial',11.111,1),(183,7440566,7440554,'all',11.111,1),(183,7440567,7440554,'lly',11.111,1),(183,7440568,7440559,'res',16.667,1),(183,7440569,7440559,'ese',16.667,1),(183,7440570,7440559,'ser',16.667,1),(183,7440571,7440559,'erv',16.667,1),(183,7440572,7440559,'rve',16.667,1),(183,7440573,7440559,'ved',16.667,1),(183,7440574,7440568,'thi',50,1),(183,7440575,7440568,'hin',50,1),(183,7440576,7440574,'pro',10,1),(183,7440577,7440574,'rov',10,1),(183,7440578,7440574,'ovi',10,1),(183,7440579,7440574,'vis',10,1),(183,7440580,7440574,'isi',10,1),(183,7440581,7440574,'sio',10,1),(183,7440582,7440574,'ion',10,1),(183,7440583,7440574,'oni',10,1),(183,7440584,7440574,'nin',10,1),(183,7440585,7440574,'ing',10,1),(183,7440586,7440576,'yes',100,1),(183,7440587,7440586,'att',16.667,1),(183,7440588,7440586,'tta',16.667,1),(183,7440589,7440586,'tac',16.667,1),(183,7440590,7440586,'ach',16.667,1),(183,7440591,7440586,'che',16.667,1),(183,7440592,7440586,'hed',16.667,1),(183,7440593,7440587,'fil',20,1),(183,7440594,7440587,'ilt',20,1),(183,7440595,7440587,'lte',20,1),(183,7440596,7440587,'ter',20,1),(183,7440597,7440587,'ers',20,1),(183,7440598,7440593,'vaa',50,1),(183,7440599,7440593,'aai',50,1),(183,7440600,7440598,'unk',20,1),(183,7440601,7440598,'nkn',20,1),(183,7440602,7440598,'kno',20,1),(183,7440603,7440598,'now',20,1),(183,7440604,7440598,'own',20,1),(183,7440605,7440600,'oth',33.333,1),(183,7440606,7440600,'the',33.333,1),(183,7440607,7440600,'her',33.333,1),(183,7440608,7440605,'uid',50,1),(183,7440609,7440605,'ids',50,1),(183,7440610,7440608,'vml',100,1),(183,7440611,7440610,'dis',20,1),(183,7440612,7440610,'isp',20,1),(183,7440613,7440610,'spl',20,1),(183,7440614,7440610,'pla',20,1),(183,7440615,7440610,'lay',20,1),(183,7440616,7440611,'nam',50,1),(183,7440617,7440611,'ame',50,1),(184,7440619,7440618,'net',25,3),(184,7440620,7440618,'eta',25,3),(184,7440621,7440618,'tap',25,3),(184,7440622,7440618,'app',25,3),(184,7440623,7440619,'fib',33.333,2),(184,7440624,7440619,'ibr',33.333,2),(184,7440625,7440619,'bre',33.333,2),(184,7440626,7440623,'cha',20,2),(184,7440627,7440623,'han',20,2),(184,7440628,7440623,'ann',20,2),(184,7440629,7440623,'nne',20,2),(184,7440630,7440623,'nel',20,2),(184,7440631,7440626,'dis',50,2),(184,7440632,7440626,'isk',50,2),(184,7440633,7440631,'naa',100,4),(184,7440634,7440633,'600',3.333,4),(184,7440635,7440633,'00a',3.333,4),(184,7440636,7440633,'0a0',3.333,4),(184,7440637,7440633,'a09',3.333,4),(184,7440638,7440633,'098',3.333,4),(184,7440639,7440633,'980',3.333,4),(184,7440640,7440633,'804',3.333,4),(184,7440641,7440633,'044',3.333,4),(184,7440642,7440633,'443',3.333,4),(184,7440643,7440633,'430',3.333,4),(184,7440644,7440633,'307',3.333,4),(184,7440645,7440633,'072',3.333,4),(184,7440646,7440633,'725',3.333,4),(184,7440647,7440633,'259',3.333,4),(184,7440648,7440633,'593',3.333,4),(184,7440649,7440633,'931',3.333,4),(184,7440650,7440633,'313',3.333,4),(184,7440651,7440633,'13f',3.333,4),(184,7440652,7440633,'3f3',3.333,4),(184,7440653,7440633,'f33',3.333,4),(184,7440654,7440633,'334',3.333,4),(184,7440655,7440633,'345',3.333,4),(184,7440656,7440633,'455',3.333,4),(184,7440657,7440633,'556',3.333,4),(184,7440658,7440633,'563',3.333,4),(184,7440659,7440633,'638',3.333,4),(184,7440660,7440633,'387',3.333,4),(184,7440661,7440633,'872',3.333,4),(184,7440662,7440633,'725',3.333,4),(184,7440663,7440633,'251',3.333,4),(184,7440664,7440634,'ser',25,1),(184,7440665,7440634,'eri',25,1),(184,7440666,7440634,'ria',25,1),(184,7440667,7440634,'ial',25,1),(184,7440668,7440664,'siz',50,1),(184,7440669,7440664,'ize',50,1),(184,7440670,7440668,'460',33.333,1),(184,7440671,7440668,'608',33.333,1),(184,7440672,7440668,'080',33.333,1),(184,7440673,7440670,'dev',25,1),(184,7440674,7440670,'evi',25,1),(184,7440675,7440670,'vic',25,1),(184,7440676,7440670,'ice',25,1),(184,7440677,7440673,'typ',50,1),(184,7440678,7440673,'ype',50,1),(184,7440679,7440677,'dir',10,1),(184,7440680,7440677,'ire',10,1),(184,7440681,7440677,'rec',10,1),(184,7440682,7440677,'ect',10,1),(184,7440683,7440677,'cta',10,1),(184,7440684,7440677,'tac',10,1),(184,7440685,7440677,'acc',10,1),(184,7440686,7440677,'cce',10,1),(184,7440687,7440677,'ces',10,1),(184,7440688,7440677,'ess',10,1),(184,7440689,7440679,'mul',14.286,1),(184,7440690,7440679,'ult',14.286,1),(184,7440691,7440679,'lti',14.286,1),(184,7440692,7440679,'tip',14.286,1),(184,7440693,7440679,'ipa',14.286,1),(184,7440694,7440679,'pat',14.286,1),(184,7440695,7440679,'ath',14.286,1),(184,7440696,7440689,'plu',25,1),(184,7440697,7440689,'lug',25,1),(184,7440698,7440689,'ugi',25,1),(184,7440699,7440689,'gin',25,1),(184,7440700,7440696,'nmp',100,1),(184,7440701,7440700,'dev',33.333,1),(184,7440702,7440700,'evf',33.333,1),(184,7440703,7440700,'vfs',33.333,1),(184,7440704,7440701,'pat',50,1),(184,7440705,7440701,'ath',50,1),(184,7440706,7440704,'vmf',50,1),(184,7440707,7440704,'mfs',50,1),(184,7440708,7440706,'dev',20,1),(184,7440709,7440706,'evi',20,1),(184,7440710,7440706,'vic',20,1),(184,7440711,7440706,'ice',20,1),(184,7440712,7440706,'ces',20,1),(184,7440713,7440708,'dis',33.333,1),(184,7440714,7440708,'isk',33.333,1),(184,7440715,7440708,'sks',33.333,1),(184,7440716,7440713,'ven',25,1),(184,7440717,7440713,'end',25,1),(184,7440718,7440713,'ndo',25,1),(184,7440719,7440713,'dor',25,1),(184,7440720,7440716,'mod',33.333,1),(184,7440721,7440716,'ode',33.333,1),(184,7440722,7440716,'del',33.333,1),(184,7440723,7440720,'lun',100,1),(184,7440724,7440723,'cmo',33.333,1),(184,7440725,7440723,'mod',33.333,1),(184,7440726,7440723,'ode',33.333,1),(184,7440727,7440724,'rev',16.667,1),(184,7440728,7440724,'evi',16.667,1),(184,7440729,7440724,'vis',16.667,1),(184,7440730,7440724,'isi',16.667,1),(184,7440731,7440724,'sio',16.667,1),(184,7440732,7440724,'ion',16.667,1),(184,7440733,7440727,'810',50,1),(184,7440734,7440727,'100',50,1),(184,7440735,7440733,'scs',50,1),(184,7440736,7440733,'csi',50,1),(184,7440737,7440735,'lev',33.333,1),(184,7440738,7440735,'eve',33.333,1),(184,7440739,7440735,'vel',33.333,1),(184,7440740,7440737,'pse',25,1),(184,7440741,7440737,'seu',25,1),(184,7440742,7440737,'eud',25,1),(184,7440743,7440737,'udo',25,1),(184,7440744,7440740,'fal',33.333,6),(184,7440745,7440740,'als',33.333,6),(184,7440746,7440740,'lse',33.333,6),(184,7440747,7440744,'sta',25,3),(184,7440748,7440744,'tat',25,3),(184,7440749,7440744,'atu',25,3),(184,7440750,7440744,'tus',25,3),(184,7440751,7440747,'rdm',100,1),(184,7440752,7440751,'cap',20,1),(184,7440753,7440751,'apa',20,1),(184,7440754,7440751,'pab',20,1),(184,7440755,7440751,'abl',20,1),(184,7440756,7440751,'ble',20,1),(184,7440757,7440752,'tru',50,1),(184,7440758,7440752,'rue',50,1),(184,7440759,7440757,'loc',33.333,1),(184,7440760,7440757,'oca',33.333,1),(184,7440761,7440757,'cal',33.333,1),(184,7440762,7440759,'rem',14.286,1),(184,7440763,7440759,'emo',14.286,1),(184,7440764,7440759,'mov',14.286,1),(184,7440765,7440759,'ova',14.286,1),(184,7440766,7440759,'vab',14.286,1),(184,7440767,7440759,'abl',14.286,1),(184,7440768,7440759,'ble',14.286,1),(184,7440769,7440762,'ssd',100,1),(184,7440770,7440769,'off',20,1),(184,7440771,7440769,'ffl',20,1),(184,7440772,7440769,'fli',20,1),(184,7440773,7440769,'lin',20,1),(184,7440774,7440769,'ine',20,1),(184,7440775,7440770,'per',11.111,1),(184,7440776,7440770,'ere',11.111,1),(184,7440777,7440770,'ren',11.111,1),(184,7440778,7440770,'enn',11.111,1),(184,7440779,7440770,'nni',11.111,1),(184,7440780,7440770,'nia',11.111,1),(184,7440781,7440770,'ial',11.111,1),(184,7440782,7440770,'all',11.111,1),(184,7440783,7440770,'lly',11.111,1),(184,7440784,7440775,'res',16.667,1),(184,7440785,7440775,'ese',16.667,1),(184,7440786,7440775,'ser',16.667,1),(184,7440787,7440775,'erv',16.667,1),(184,7440788,7440775,'rve',16.667,1),(184,7440789,7440775,'ved',16.667,1),(184,7440790,7440784,'thi',50,1),(184,7440791,7440784,'hin',50,1),(184,7440792,7440790,'pro',10,1),(184,7440793,7440790,'rov',10,1),(184,7440794,7440790,'ovi',10,1),(184,7440795,7440790,'vis',10,1),(184,7440796,7440790,'isi',10,1),(184,7440797,7440790,'sio',10,1),(184,7440798,7440790,'ion',10,1),(184,7440799,7440790,'oni',10,1),(184,7440800,7440790,'nin',10,1),(184,7440801,7440790,'ing',10,1),(184,7440802,7440792,'yes',100,1),(184,7440803,7440802,'att',16.667,1),(184,7440804,7440802,'tta',16.667,1),(184,7440805,7440802,'tac',16.667,1),(184,7440806,7440802,'ach',16.667,1),(184,7440807,7440802,'che',16.667,1),(184,7440808,7440802,'hed',16.667,1),(184,7440809,7440803,'fil',20,1),(184,7440810,7440803,'ilt',20,1),(184,7440811,7440803,'lte',20,1),(184,7440812,7440803,'ter',20,1),(184,7440813,7440803,'ers',20,1),(184,7440814,7440809,'vaa',50,1),(184,7440815,7440809,'aai',50,1),(184,7440816,7440814,'unk',20,1),(184,7440817,7440814,'nkn',20,1),(184,7440818,7440814,'kno',20,1),(184,7440819,7440814,'now',20,1),(184,7440820,7440814,'own',20,1),(184,7440821,7440816,'oth',33.333,1),(184,7440822,7440816,'the',33.333,1),(184,7440823,7440816,'her',33.333,1),(184,7440824,7440821,'uid',50,1),(184,7440825,7440821,'ids',50,1),(184,7440826,7440824,'vml',100,1),(184,7440827,7440826,'dis',20,1),(184,7440828,7440826,'isp',20,1),(184,7440829,7440826,'spl',20,1),(184,7440830,7440826,'pla',20,1),(184,7440831,7440826,'lay',20,1),(184,7440832,7440827,'nam',50,1),(184,7440833,7440827,'ame',50,1),(185,7440835,7440834,'net',25,3),(185,7440836,7440834,'eta',25,3),(185,7440837,7440834,'tap',25,3),(185,7440838,7440834,'app',25,3),(185,7440839,7440835,'fib',33.333,2),(185,7440840,7440835,'ibr',33.333,2),(185,7440841,7440835,'bre',33.333,2),(185,7440842,7440839,'cha',20,2),(185,7440843,7440839,'han',20,2),(185,7440844,7440839,'ann',20,2),(185,7440845,7440839,'nne',20,2),(185,7440846,7440839,'nel',20,2),(185,7440847,7440842,'dis',50,2),(185,7440848,7440842,'isk',50,2),(185,7440849,7440847,'naa',100,4),(185,7440850,7440849,'600',3.333,4),(185,7440851,7440849,'00a',3.333,4),(185,7440852,7440849,'0a0',3.333,4),(185,7440853,7440849,'a09',3.333,4),(185,7440854,7440849,'098',3.333,4),(185,7440855,7440849,'980',3.333,4),(185,7440856,7440849,'804',3.333,4),(185,7440857,7440849,'044',3.333,4),(185,7440858,7440849,'443',3.333,4),(185,7440859,7440849,'430',3.333,4),(185,7440860,7440849,'307',3.333,4),(185,7440861,7440849,'072',3.333,4),(185,7440862,7440849,'725',3.333,4),(185,7440863,7440849,'259',3.333,4),(185,7440864,7440849,'593',3.333,4),(185,7440865,7440849,'931',3.333,4),(185,7440866,7440849,'313',3.333,4),(185,7440867,7440849,'13f',3.333,4),(185,7440868,7440849,'3f3',3.333,4),(185,7440869,7440849,'f33',3.333,4),(185,7440870,7440849,'334',3.333,4),(185,7440871,7440849,'345',3.333,4),(185,7440872,7440849,'455',3.333,4),(185,7440873,7440849,'556',3.333,4),(185,7440874,7440849,'563',3.333,4),(185,7440875,7440849,'638',3.333,4),(185,7440876,7440849,'387',3.333,4),(185,7440877,7440849,'872',3.333,4),(185,7440878,7440849,'725',3.333,4),(185,7440879,7440849,'252',3.333,4),(185,7440880,7440850,'ser',25,1),(185,7440881,7440850,'eri',25,1),(185,7440882,7440850,'ria',25,1),(185,7440883,7440850,'ial',25,1),(185,7440884,7440880,'siz',50,1),(185,7440885,7440880,'ize',50,1),(185,7440886,7440884,'174',25,1),(185,7440887,7440884,'740',25,1),(185,7440888,7440884,'409',25,1),(185,7440889,7440884,'096',25,1),(185,7440890,7440886,'dev',25,1),(185,7440891,7440886,'evi',25,1),(185,7440892,7440886,'vic',25,1),(185,7440893,7440886,'ice',25,1),(185,7440894,7440890,'typ',50,1),(185,7440895,7440890,'ype',50,1),(185,7440896,7440894,'dir',10,1),(185,7440897,7440894,'ire',10,1),(185,7440898,7440894,'rec',10,1),(185,7440899,7440894,'ect',10,1),(185,7440900,7440894,'cta',10,1),(185,7440901,7440894,'tac',10,1),(185,7440902,7440894,'acc',10,1),(185,7440903,7440894,'cce',10,1),(185,7440904,7440894,'ces',10,1),(185,7440905,7440894,'ess',10,1),(185,7440906,7440896,'mul',14.286,1),(185,7440907,7440896,'ult',14.286,1),(185,7440908,7440896,'lti',14.286,1),(185,7440909,7440896,'tip',14.286,1),(185,7440910,7440896,'ipa',14.286,1),(185,7440911,7440896,'pat',14.286,1),(185,7440912,7440896,'ath',14.286,1),(185,7440913,7440906,'plu',25,1),(185,7440914,7440906,'lug',25,1),(185,7440915,7440906,'ugi',25,1),(185,7440916,7440906,'gin',25,1),(185,7440917,7440913,'nmp',100,1),(185,7440918,7440917,'dev',33.333,1),(185,7440919,7440917,'evf',33.333,1),(185,7440920,7440917,'vfs',33.333,1),(185,7440921,7440918,'pat',50,1),(185,7440922,7440918,'ath',50,1),(185,7440923,7440921,'vmf',50,1),(185,7440924,7440921,'mfs',50,1),(185,7440925,7440923,'dev',20,1),(185,7440926,7440923,'evi',20,1),(185,7440927,7440923,'vic',20,1),(185,7440928,7440923,'ice',20,1),(185,7440929,7440923,'ces',20,1),(185,7440930,7440925,'dis',33.333,1),(185,7440931,7440925,'isk',33.333,1),(185,7440932,7440925,'sks',33.333,1),(185,7440933,7440930,'ven',25,1),(185,7440934,7440930,'end',25,1),(185,7440935,7440930,'ndo',25,1),(185,7440936,7440930,'dor',25,1),(185,7440937,7440933,'mod',33.333,1),(185,7440938,7440933,'ode',33.333,1),(185,7440939,7440933,'del',33.333,1),(185,7440940,7440937,'lun',100,1),(185,7440941,7440940,'cmo',33.333,1),(185,7440942,7440940,'mod',33.333,1),(185,7440943,7440940,'ode',33.333,1),(185,7440944,7440941,'rev',16.667,1),(185,7440945,7440941,'evi',16.667,1),(185,7440946,7440941,'vis',16.667,1),(185,7440947,7440941,'isi',16.667,1),(185,7440948,7440941,'sio',16.667,1),(185,7440949,7440941,'ion',16.667,1),(185,7440950,7440944,'810',50,1),(185,7440951,7440944,'100',50,1),(185,7440952,7440950,'scs',50,1),(185,7440953,7440950,'csi',50,1),(185,7440954,7440952,'lev',33.333,1),(185,7440955,7440952,'eve',33.333,1),(185,7440956,7440952,'vel',33.333,1),(185,7440957,7440954,'pse',25,1),(185,7440958,7440954,'seu',25,1),(185,7440959,7440954,'eud',25,1),(185,7440960,7440954,'udo',25,1),(185,7440961,7440957,'fal',33.333,6),(185,7440962,7440957,'als',33.333,6),(185,7440963,7440957,'lse',33.333,6),(185,7440964,7440961,'sta',25,3),(185,7440965,7440961,'tat',25,3),(185,7440966,7440961,'atu',25,3),(185,7440967,7440961,'tus',25,3),(185,7440968,7440964,'rdm',100,1),(185,7440969,7440968,'cap',20,1),(185,7440970,7440968,'apa',20,1),(185,7440971,7440968,'pab',20,1),(185,7440972,7440968,'abl',20,1),(185,7440973,7440968,'ble',20,1),(185,7440974,7440969,'tru',50,1),(185,7440975,7440969,'rue',50,1),(185,7440976,7440974,'loc',33.333,1),(185,7440977,7440974,'oca',33.333,1),(185,7440978,7440974,'cal',33.333,1),(185,7440979,7440976,'rem',14.286,1),(185,7440980,7440976,'emo',14.286,1),(185,7440981,7440976,'mov',14.286,1),(185,7440982,7440976,'ova',14.286,1),(185,7440983,7440976,'vab',14.286,1),(185,7440984,7440976,'abl',14.286,1),(185,7440985,7440976,'ble',14.286,1),(185,7440986,7440979,'ssd',100,1),(185,7440987,7440986,'off',20,1),(185,7440988,7440986,'ffl',20,1),(185,7440989,7440986,'fli',20,1),(185,7440990,7440986,'lin',20,1),(185,7440991,7440986,'ine',20,1),(185,7440992,7440987,'per',11.111,1),(185,7440993,7440987,'ere',11.111,1),(185,7440994,7440987,'ren',11.111,1),(185,7440995,7440987,'enn',11.111,1),(185,7440996,7440987,'nni',11.111,1),(185,7440997,7440987,'nia',11.111,1),(185,7440998,7440987,'ial',11.111,1),(185,7440999,7440987,'all',11.111,1),(185,7441000,7440987,'lly',11.111,1),(185,7441001,7440992,'res',16.667,1),(185,7441002,7440992,'ese',16.667,1),(185,7441003,7440992,'ser',16.667,1),(185,7441004,7440992,'erv',16.667,1),(185,7441005,7440992,'rve',16.667,1),(185,7441006,7440992,'ved',16.667,1),(185,7441007,7441001,'thi',50,1),(185,7441008,7441001,'hin',50,1),(185,7441009,7441007,'pro',10,1),(185,7441010,7441007,'rov',10,1),(185,7441011,7441007,'ovi',10,1),(185,7441012,7441007,'vis',10,1),(185,7441013,7441007,'isi',10,1),(185,7441014,7441007,'sio',10,1),(185,7441015,7441007,'ion',10,1),(185,7441016,7441007,'oni',10,1),(185,7441017,7441007,'nin',10,1),(185,7441018,7441007,'ing',10,1),(185,7441019,7441009,'yes',100,1),(185,7441020,7441019,'att',16.667,1),(185,7441021,7441019,'tta',16.667,1),(185,7441022,7441019,'tac',16.667,1),(185,7441023,7441019,'ach',16.667,1),(185,7441024,7441019,'che',16.667,1),(185,7441025,7441019,'hed',16.667,1),(185,7441026,7441020,'fil',20,1),(185,7441027,7441020,'ilt',20,1),(185,7441028,7441020,'lte',20,1),(185,7441029,7441020,'ter',20,1),(185,7441030,7441020,'ers',20,1),(185,7441031,7441026,'vaa',50,1),(185,7441032,7441026,'aai',50,1),(185,7441033,7441031,'unk',20,1),(185,7441034,7441031,'nkn',20,1),(185,7441035,7441031,'kno',20,1),(185,7441036,7441031,'now',20,1),(185,7441037,7441031,'own',20,1),(185,7441038,7441033,'oth',33.333,1),(185,7441039,7441033,'the',33.333,1),(185,7441040,7441033,'her',33.333,1),(185,7441041,7441038,'uid',50,1),(185,7441042,7441038,'ids',50,1),(185,7441043,7441041,'vml',100,1),(185,7441044,7441043,'dis',20,1),(185,7441045,7441043,'isp',20,1),(185,7441046,7441043,'spl',20,1),(185,7441047,7441043,'pla',20,1),(185,7441048,7441043,'lay',20,1),(185,7441049,7441044,'nam',50,1),(185,7441050,7441044,'ame',50,1),(186,7441052,7441051,'net',25,3),(186,7441053,7441051,'eta',25,3),(186,7441054,7441051,'tap',25,3),(186,7441055,7441051,'app',25,3),(186,7441056,7441052,'fib',33.333,2),(186,7441057,7441052,'ibr',33.333,2),(186,7441058,7441052,'bre',33.333,2),(186,7441059,7441056,'cha',20,2),(186,7441060,7441056,'han',20,2),(186,7441061,7441056,'ann',20,2),(186,7441062,7441056,'nne',20,2),(186,7441063,7441056,'nel',20,2),(186,7441064,7441059,'dis',50,2),(186,7441065,7441059,'isk',50,2),(186,7441066,7441064,'naa',100,4),(186,7441067,7441066,'600',3.333,4),(186,7441068,7441066,'00a',3.333,4),(186,7441069,7441066,'0a0',3.333,4),(186,7441070,7441066,'a09',3.333,4),(186,7441071,7441066,'098',3.333,4),(186,7441072,7441066,'980',3.333,4),(186,7441073,7441066,'804',3.333,4),(186,7441074,7441066,'044',3.333,4),(186,7441075,7441066,'443',3.333,4),(186,7441076,7441066,'430',3.333,4),(186,7441077,7441066,'307',3.333,4),(186,7441078,7441066,'072',3.333,4),(186,7441079,7441066,'725',3.333,4),(186,7441080,7441066,'259',3.333,4),(186,7441081,7441066,'593',3.333,4),(186,7441082,7441066,'931',3.333,4),(186,7441083,7441066,'313',3.333,4),(186,7441084,7441066,'13f',3.333,4),(186,7441085,7441066,'3f3',3.333,4),(186,7441086,7441066,'f33',3.333,4),(186,7441087,7441066,'334',3.333,4),(186,7441088,7441066,'345',3.333,4),(186,7441089,7441066,'455',3.333,4),(186,7441090,7441066,'556',3.333,4),(186,7441091,7441066,'563',3.333,4),(186,7441092,7441066,'639',3.333,4),(186,7441093,7441066,'393',3.333,4),(186,7441094,7441066,'933',3.333,4),(186,7441095,7441066,'337',3.333,4),(186,7441096,7441066,'37a',3.333,4),(186,7441097,7441067,'ser',25,1),(186,7441098,7441067,'eri',25,1),(186,7441099,7441067,'ria',25,1),(186,7441100,7441067,'ial',25,1),(186,7441101,7441097,'siz',50,1),(186,7441102,7441097,'ize',50,1),(186,7441103,7441101,'460',33.333,1),(186,7441104,7441101,'608',33.333,1),(186,7441105,7441101,'080',33.333,1),(186,7441106,7441103,'dev',25,1),(186,7441107,7441103,'evi',25,1),(186,7441108,7441103,'vic',25,1),(186,7441109,7441103,'ice',25,1),(186,7441110,7441106,'typ',50,1),(186,7441111,7441106,'ype',50,1),(186,7441112,7441110,'dir',10,1),(186,7441113,7441110,'ire',10,1),(186,7441114,7441110,'rec',10,1),(186,7441115,7441110,'ect',10,1),(186,7441116,7441110,'cta',10,1),(186,7441117,7441110,'tac',10,1),(186,7441118,7441110,'acc',10,1),(186,7441119,7441110,'cce',10,1),(186,7441120,7441110,'ces',10,1),(186,7441121,7441110,'ess',10,1),(186,7441122,7441112,'mul',14.286,1),(186,7441123,7441112,'ult',14.286,1),(186,7441124,7441112,'lti',14.286,1),(186,7441125,7441112,'tip',14.286,1),(186,7441126,7441112,'ipa',14.286,1),(186,7441127,7441112,'pat',14.286,1),(186,7441128,7441112,'ath',14.286,1),(186,7441129,7441122,'plu',25,1),(186,7441130,7441122,'lug',25,1),(186,7441131,7441122,'ugi',25,1),(186,7441132,7441122,'gin',25,1),(186,7441133,7441129,'nmp',100,1),(186,7441134,7441133,'dev',33.333,1),(186,7441135,7441133,'evf',33.333,1),(186,7441136,7441133,'vfs',33.333,1),(186,7441137,7441134,'pat',50,1),(186,7441138,7441134,'ath',50,1),(186,7441139,7441137,'vmf',50,1),(186,7441140,7441137,'mfs',50,1),(186,7441141,7441139,'dev',20,1),(186,7441142,7441139,'evi',20,1),(186,7441143,7441139,'vic',20,1),(186,7441144,7441139,'ice',20,1),(186,7441145,7441139,'ces',20,1),(186,7441146,7441141,'dis',33.333,1),(186,7441147,7441141,'isk',33.333,1),(186,7441148,7441141,'sks',33.333,1),(186,7441149,7441146,'ven',25,1),(186,7441150,7441146,'end',25,1),(186,7441151,7441146,'ndo',25,1),(186,7441152,7441146,'dor',25,1),(186,7441153,7441149,'mod',33.333,1),(186,7441154,7441149,'ode',33.333,1),(186,7441155,7441149,'del',33.333,1),(186,7441156,7441153,'lun',100,1),(186,7441157,7441156,'cmo',33.333,1),(186,7441158,7441156,'mod',33.333,1),(186,7441159,7441156,'ode',33.333,1),(186,7441160,7441157,'rev',16.667,1),(186,7441161,7441157,'evi',16.667,1),(186,7441162,7441157,'vis',16.667,1),(186,7441163,7441157,'isi',16.667,1),(186,7441164,7441157,'sio',16.667,1),(186,7441165,7441157,'ion',16.667,1),(186,7441166,7441160,'810',50,1),(186,7441167,7441160,'100',50,1),(186,7441168,7441166,'scs',50,1),(186,7441169,7441166,'csi',50,1),(186,7441170,7441168,'lev',33.333,1),(186,7441171,7441168,'eve',33.333,1),(186,7441172,7441168,'vel',33.333,1),(186,7441173,7441170,'pse',25,1),(186,7441174,7441170,'seu',25,1),(186,7441175,7441170,'eud',25,1),(186,7441176,7441170,'udo',25,1),(186,7441177,7441173,'fal',33.333,6),(186,7441178,7441173,'als',33.333,6),(186,7441179,7441173,'lse',33.333,6),(186,7441180,7441177,'sta',25,3),(186,7441181,7441177,'tat',25,3),(186,7441182,7441177,'atu',25,3),(186,7441183,7441177,'tus',25,3),(186,7441184,7441180,'rdm',100,1),(186,7441185,7441184,'cap',20,1),(186,7441186,7441184,'apa',20,1),(186,7441187,7441184,'pab',20,1),(186,7441188,7441184,'abl',20,1),(186,7441189,7441184,'ble',20,1),(186,7441190,7441185,'tru',50,1),(186,7441191,7441185,'rue',50,1),(186,7441192,7441190,'loc',33.333,1),(186,7441193,7441190,'oca',33.333,1),(186,7441194,7441190,'cal',33.333,1),(186,7441195,7441192,'rem',14.286,1),(186,7441196,7441192,'emo',14.286,1),(186,7441197,7441192,'mov',14.286,1),(186,7441198,7441192,'ova',14.286,1),(186,7441199,7441192,'vab',14.286,1),(186,7441200,7441192,'abl',14.286,1),(186,7441201,7441192,'ble',14.286,1),(186,7441202,7441195,'ssd',100,1),(186,7441203,7441202,'off',20,1),(186,7441204,7441202,'ffl',20,1),(186,7441205,7441202,'fli',20,1),(186,7441206,7441202,'lin',20,1),(186,7441207,7441202,'ine',20,1),(186,7441208,7441203,'per',11.111,1),(186,7441209,7441203,'ere',11.111,1),(186,7441210,7441203,'ren',11.111,1),(186,7441211,7441203,'enn',11.111,1),(186,7441212,7441203,'nni',11.111,1),(186,7441213,7441203,'nia',11.111,1),(186,7441214,7441203,'ial',11.111,1),(186,7441215,7441203,'all',11.111,1),(186,7441216,7441203,'lly',11.111,1),(186,7441217,7441208,'res',16.667,1),(186,7441218,7441208,'ese',16.667,1),(186,7441219,7441208,'ser',16.667,1),(186,7441220,7441208,'erv',16.667,1),(186,7441221,7441208,'rve',16.667,1),(186,7441222,7441208,'ved',16.667,1),(186,7441223,7441217,'thi',50,1),(186,7441224,7441217,'hin',50,1),(186,7441225,7441223,'pro',10,1),(186,7441226,7441223,'rov',10,1),(186,7441227,7441223,'ovi',10,1),(186,7441228,7441223,'vis',10,1),(186,7441229,7441223,'isi',10,1),(186,7441230,7441223,'sio',10,1),(186,7441231,7441223,'ion',10,1),(186,7441232,7441223,'oni',10,1),(186,7441233,7441223,'nin',10,1),(186,7441234,7441223,'ing',10,1),(186,7441235,7441225,'yes',100,1),(186,7441236,7441235,'att',16.667,1),(186,7441237,7441235,'tta',16.667,1),(186,7441238,7441235,'tac',16.667,1),(186,7441239,7441235,'ach',16.667,1),(186,7441240,7441235,'che',16.667,1),(186,7441241,7441235,'hed',16.667,1),(186,7441242,7441236,'fil',20,1),(186,7441243,7441236,'ilt',20,1),(186,7441244,7441236,'lte',20,1),(186,7441245,7441236,'ter',20,1),(186,7441246,7441236,'ers',20,1),(186,7441247,7441242,'vaa',50,1),(186,7441248,7441242,'aai',50,1),(186,7441249,7441247,'unk',20,1),(186,7441250,7441247,'nkn',20,1),(186,7441251,7441247,'kno',20,1),(186,7441252,7441247,'now',20,1),(186,7441253,7441247,'own',20,1),(186,7441254,7441249,'oth',33.333,1),(186,7441255,7441249,'the',33.333,1),(186,7441256,7441249,'her',33.333,1),(186,7441257,7441254,'uid',50,1),(186,7441258,7441254,'ids',50,1),(186,7441259,7441257,'vml',100,1),(186,7441260,7441259,'dis',20,1),(186,7441261,7441259,'isp',20,1),(186,7441262,7441259,'spl',20,1),(186,7441263,7441259,'pla',20,1),(186,7441264,7441259,'lay',20,1),(186,7441265,7441260,'nam',50,1),(186,7441266,7441260,'ame',50,1),(187,7441268,7441267,'net',25,3),(187,7441269,7441267,'eta',25,3),(187,7441270,7441267,'tap',25,3),(187,7441271,7441267,'app',25,3),(187,7441272,7441268,'fib',33.333,2),(187,7441273,7441268,'ibr',33.333,2),(187,7441274,7441268,'bre',33.333,2),(187,7441275,7441272,'cha',20,2),(187,7441276,7441272,'han',20,2),(187,7441277,7441272,'ann',20,2),(187,7441278,7441272,'nne',20,2),(187,7441279,7441272,'nel',20,2),(187,7441280,7441275,'dis',50,2),(187,7441281,7441275,'isk',50,2),(187,7441282,7441280,'naa',100,4),(187,7441283,7441282,'600',3.333,4),(187,7441284,7441282,'00a',3.333,4),(187,7441285,7441282,'0a0',3.333,4),(187,7441286,7441282,'a09',3.333,4),(187,7441287,7441282,'098',3.333,4),(187,7441288,7441282,'980',3.333,4),(187,7441289,7441282,'804',3.333,4),(187,7441290,7441282,'044',3.333,4),(187,7441291,7441282,'443',3.333,4),(187,7441292,7441282,'430',3.333,4),(187,7441293,7441282,'307',3.333,4),(187,7441294,7441282,'072',3.333,4),(187,7441295,7441282,'725',3.333,4),(187,7441296,7441282,'259',3.333,4),(187,7441297,7441282,'593',3.333,4),(187,7441298,7441282,'931',3.333,4),(187,7441299,7441282,'313',3.333,4),(187,7441300,7441282,'13f',3.333,4),(187,7441301,7441282,'3f3',3.333,4),(187,7441302,7441282,'f33',3.333,4),(187,7441303,7441282,'334',3.333,4),(187,7441304,7441282,'345',3.333,4),(187,7441305,7441282,'455',3.333,4),(187,7441306,7441282,'556',3.333,4),(187,7441307,7441282,'563',3.333,4),(187,7441308,7441282,'639',3.333,4),(187,7441309,7441282,'393',3.333,4),(187,7441310,7441282,'934',3.333,4),(187,7441311,7441282,'345',3.333,4),(187,7441312,7441282,'45a',3.333,4),(187,7441313,7441283,'ser',25,1),(187,7441314,7441283,'eri',25,1),(187,7441315,7441283,'ria',25,1),(187,7441316,7441283,'ial',25,1),(187,7441317,7441313,'siz',50,1),(187,7441318,7441313,'ize',50,1),(187,7441319,7441317,'321',100,1),(187,7441320,7441319,'dev',25,1),(187,7441321,7441319,'evi',25,1),(187,7441322,7441319,'vic',25,1),(187,7441323,7441319,'ice',25,1),(187,7441324,7441320,'typ',50,1),(187,7441325,7441320,'ype',50,1),(187,7441326,7441324,'dir',10,1),(187,7441327,7441324,'ire',10,1),(187,7441328,7441324,'rec',10,1),(187,7441329,7441324,'ect',10,1),(187,7441330,7441324,'cta',10,1),(187,7441331,7441324,'tac',10,1),(187,7441332,7441324,'acc',10,1),(187,7441333,7441324,'cce',10,1),(187,7441334,7441324,'ces',10,1),(187,7441335,7441324,'ess',10,1),(187,7441336,7441326,'mul',14.286,1),(187,7441337,7441326,'ult',14.286,1),(187,7441338,7441326,'lti',14.286,1),(187,7441339,7441326,'tip',14.286,1),(187,7441340,7441326,'ipa',14.286,1),(187,7441341,7441326,'pat',14.286,1),(187,7441342,7441326,'ath',14.286,1),(187,7441343,7441336,'plu',25,1),(187,7441344,7441336,'lug',25,1),(187,7441345,7441336,'ugi',25,1),(187,7441346,7441336,'gin',25,1),(187,7441347,7441343,'nmp',100,1),(187,7441348,7441347,'dev',33.333,1),(187,7441349,7441347,'evf',33.333,1),(187,7441350,7441347,'vfs',33.333,1),(187,7441351,7441348,'pat',50,1),(187,7441352,7441348,'ath',50,1),(187,7441353,7441351,'vmf',50,1),(187,7441354,7441351,'mfs',50,1),(187,7441355,7441353,'dev',20,1),(187,7441356,7441353,'evi',20,1),(187,7441357,7441353,'vic',20,1),(187,7441358,7441353,'ice',20,1),(187,7441359,7441353,'ces',20,1),(187,7441360,7441355,'dis',33.333,1),(187,7441361,7441355,'isk',33.333,1),(187,7441362,7441355,'sks',33.333,1),(187,7441363,7441360,'ven',25,1),(187,7441364,7441360,'end',25,1),(187,7441365,7441360,'ndo',25,1),(187,7441366,7441360,'dor',25,1),(187,7441367,7441363,'mod',33.333,1),(187,7441368,7441363,'ode',33.333,1),(187,7441369,7441363,'del',33.333,1),(187,7441370,7441367,'lun',100,1),(187,7441371,7441370,'cmo',33.333,1),(187,7441372,7441370,'mod',33.333,1),(187,7441373,7441370,'ode',33.333,1),(187,7441374,7441371,'rev',16.667,1),(187,7441375,7441371,'evi',16.667,1),(187,7441376,7441371,'vis',16.667,1),(187,7441377,7441371,'isi',16.667,1),(187,7441378,7441371,'sio',16.667,1),(187,7441379,7441371,'ion',16.667,1),(187,7441380,7441374,'810',50,1),(187,7441381,7441374,'100',50,1),(187,7441382,7441380,'scs',50,1),(187,7441383,7441380,'csi',50,1),(187,7441384,7441382,'lev',33.333,1),(187,7441385,7441382,'eve',33.333,1),(187,7441386,7441382,'vel',33.333,1),(187,7441387,7441384,'pse',25,1),(187,7441388,7441384,'seu',25,1),(187,7441389,7441384,'eud',25,1),(187,7441390,7441384,'udo',25,1),(187,7441391,7441387,'fal',33.333,6),(187,7441392,7441387,'als',33.333,6),(187,7441393,7441387,'lse',33.333,6),(187,7441394,7441391,'sta',25,3),(187,7441395,7441391,'tat',25,3),(187,7441396,7441391,'atu',25,3),(187,7441397,7441391,'tus',25,3),(187,7441398,7441394,'rdm',100,1),(187,7441399,7441398,'cap',20,1),(187,7441400,7441398,'apa',20,1),(187,7441401,7441398,'pab',20,1),(187,7441402,7441398,'abl',20,1),(187,7441403,7441398,'ble',20,1),(187,7441404,7441399,'tru',50,1),(187,7441405,7441399,'rue',50,1),(187,7441406,7441404,'loc',33.333,1),(187,7441407,7441404,'oca',33.333,1),(187,7441408,7441404,'cal',33.333,1),(187,7441409,7441406,'rem',14.286,1),(187,7441410,7441406,'emo',14.286,1),(187,7441411,7441406,'mov',14.286,1),(187,7441412,7441406,'ova',14.286,1),(187,7441413,7441406,'vab',14.286,1),(187,7441414,7441406,'abl',14.286,1),(187,7441415,7441406,'ble',14.286,1),(187,7441416,7441409,'ssd',100,1),(187,7441417,7441416,'off',20,1),(187,7441418,7441416,'ffl',20,1),(187,7441419,7441416,'fli',20,1),(187,7441420,7441416,'lin',20,1),(187,7441421,7441416,'ine',20,1),(187,7441422,7441417,'per',11.111,1),(187,7441423,7441417,'ere',11.111,1),(187,7441424,7441417,'ren',11.111,1),(187,7441425,7441417,'enn',11.111,1),(187,7441426,7441417,'nni',11.111,1),(187,7441427,7441417,'nia',11.111,1),(187,7441428,7441417,'ial',11.111,1),(187,7441429,7441417,'all',11.111,1),(187,7441430,7441417,'lly',11.111,1),(187,7441431,7441422,'res',16.667,1),(187,7441432,7441422,'ese',16.667,1),(187,7441433,7441422,'ser',16.667,1),(187,7441434,7441422,'erv',16.667,1),(187,7441435,7441422,'rve',16.667,1),(187,7441436,7441422,'ved',16.667,1),(187,7441437,7441431,'thi',50,1),(187,7441438,7441431,'hin',50,1),(187,7441439,7441437,'pro',10,1),(187,7441440,7441437,'rov',10,1),(187,7441441,7441437,'ovi',10,1),(187,7441442,7441437,'vis',10,1),(187,7441443,7441437,'isi',10,1),(187,7441444,7441437,'sio',10,1),(187,7441445,7441437,'ion',10,1),(187,7441446,7441437,'oni',10,1),(187,7441447,7441437,'nin',10,1),(187,7441448,7441437,'ing',10,1),(187,7441449,7441439,'yes',100,1),(187,7441450,7441449,'att',16.667,1),(187,7441451,7441449,'tta',16.667,1),(187,7441452,7441449,'tac',16.667,1),(187,7441453,7441449,'ach',16.667,1),(187,7441454,7441449,'che',16.667,1),(187,7441455,7441449,'hed',16.667,1),(187,7441456,7441450,'fil',20,1),(187,7441457,7441450,'ilt',20,1),(187,7441458,7441450,'lte',20,1),(187,7441459,7441450,'ter',20,1),(187,7441460,7441450,'ers',20,1),(187,7441461,7441456,'vaa',50,1),(187,7441462,7441456,'aai',50,1),(187,7441463,7441461,'unk',20,1),(187,7441464,7441461,'nkn',20,1),(187,7441465,7441461,'kno',20,1),(187,7441466,7441461,'now',20,1),(187,7441467,7441461,'own',20,1),(187,7441468,7441463,'oth',33.333,1),(187,7441469,7441463,'the',33.333,1),(187,7441470,7441463,'her',33.333,1),(187,7441471,7441468,'uid',50,1),(187,7441472,7441468,'ids',50,1),(187,7441473,7441471,'vml',100,1),(187,7441474,7441473,'dis',20,1),(187,7441475,7441473,'isp',20,1),(187,7441476,7441473,'spl',20,1),(187,7441477,7441473,'pla',20,1),(187,7441478,7441473,'lay',20,1),(187,7441479,7441474,'nam',50,1),(187,7441480,7441474,'ame',50,1),(188,7441482,7441481,'net',25,3),(188,7441483,7441481,'eta',25,3),(188,7441484,7441481,'tap',25,3),(188,7441485,7441481,'app',25,3),(188,7441486,7441482,'ser',25,3),(188,7441487,7441482,'eri',25,3),(188,7441488,7441482,'ria',25,3),(188,7441489,7441482,'ial',25,3),(188,7441490,7441486,'att',16.667,3),(188,7441491,7441486,'tta',16.667,3),(188,7441492,7441486,'tac',16.667,3),(188,7441493,7441486,'ach',16.667,3),(188,7441494,7441486,'che',16.667,3),(188,7441495,7441486,'hed',16.667,3),(188,7441496,7441490,'scs',50,3),(188,7441497,7441490,'csi',50,3),(188,7441498,7441496,'dis',50,2),(188,7441499,7441496,'isk',50,2),(188,7441500,7441498,'naa',100,4),(188,7441501,7441500,'600',3.333,4),(188,7441502,7441500,'00a',3.333,4),(188,7441503,7441500,'0a0',3.333,4),(188,7441504,7441500,'a09',3.333,4),(188,7441505,7441500,'098',3.333,4),(188,7441506,7441500,'980',3.333,4),(188,7441507,7441500,'805',3.333,4),(188,7441508,7441500,'052',3.333,4),(188,7441509,7441500,'527',3.333,4),(188,7441510,7441500,'27b',3.333,4),(188,7441511,7441500,'7b8',3.333,4),(188,7441512,7441500,'b84',3.333,4),(188,7441513,7441500,'84e',3.333,4),(188,7441514,7441500,'4ee',3.333,4),(188,7441515,7441500,'eeb',3.333,4),(188,7441516,7441500,'eba',3.333,4),(188,7441517,7441500,'bad',3.333,4),(188,7441518,7441500,'ad7',3.333,4),(188,7441519,7441500,'d74',3.333,4),(188,7441520,7441500,'742',3.333,4),(188,7441521,7441500,'421',3.333,4),(188,7441522,7441500,'211',3.333,4),(188,7441523,7441500,'117',3.333,4),(188,7441524,7441500,'17b',3.333,4),(188,7441525,7441500,'7b0',3.333,4),(188,7441526,7441500,'b0f',3.333,4),(188,7441527,7441500,'0fa',3.333,4),(188,7441528,7441500,'fab',3.333,4),(188,7441529,7441500,'aba',3.333,4),(188,7441530,7441500,'ba2',3.333,4),(188,7441531,7441501,'siz',50,1),(188,7441532,7441501,'ize',50,1),(188,7441533,7441531,'163',33.333,1),(188,7441534,7441531,'638',33.333,1),(188,7441535,7441531,'384',33.333,1),(188,7441536,7441533,'dev',25,1),(188,7441537,7441533,'evi',25,1),(188,7441538,7441533,'vic',25,1),(188,7441539,7441533,'ice',25,1),(188,7441540,7441536,'typ',50,1),(188,7441541,7441536,'ype',50,1),(188,7441542,7441540,'dir',10,1),(188,7441543,7441540,'ire',10,1),(188,7441544,7441540,'rec',10,1),(188,7441545,7441540,'ect',10,1),(188,7441546,7441540,'cta',10,1),(188,7441547,7441540,'tac',10,1),(188,7441548,7441540,'acc',10,1),(188,7441549,7441540,'cce',10,1),(188,7441550,7441540,'ces',10,1),(188,7441551,7441540,'ess',10,1),(188,7441552,7441542,'mul',14.286,1),(188,7441553,7441542,'ult',14.286,1),(188,7441554,7441542,'lti',14.286,1),(188,7441555,7441542,'tip',14.286,1),(188,7441556,7441542,'ipa',14.286,1),(188,7441557,7441542,'pat',14.286,1),(188,7441558,7441542,'ath',14.286,1),(188,7441559,7441552,'plu',25,1),(188,7441560,7441552,'lug',25,1),(188,7441561,7441552,'ugi',25,1),(188,7441562,7441552,'gin',25,1),(188,7441563,7441559,'nmp',100,1),(188,7441564,7441563,'dev',33.333,1),(188,7441565,7441563,'evf',33.333,1),(188,7441566,7441563,'vfs',33.333,1),(188,7441567,7441564,'pat',50,1),(188,7441568,7441564,'ath',50,1),(188,7441569,7441567,'vmf',50,1),(188,7441570,7441567,'mfs',50,1),(188,7441571,7441569,'dev',20,1),(188,7441572,7441569,'evi',20,1),(188,7441573,7441569,'vic',20,1),(188,7441574,7441569,'ice',20,1),(188,7441575,7441569,'ces',20,1),(188,7441576,7441571,'dis',33.333,1),(188,7441577,7441571,'isk',33.333,1),(188,7441578,7441571,'sks',33.333,1),(188,7441579,7441576,'ven',25,1),(188,7441580,7441576,'end',25,1),(188,7441581,7441576,'ndo',25,1),(188,7441582,7441576,'dor',25,1),(188,7441583,7441579,'mod',33.333,1),(188,7441584,7441579,'ode',33.333,1),(188,7441585,7441579,'del',33.333,1),(188,7441586,7441583,'fla',33.333,1),(188,7441587,7441583,'las',33.333,1),(188,7441588,7441583,'ash',33.333,1),(188,7441589,7441586,'acc',33.333,1),(188,7441590,7441586,'cce',33.333,1),(188,7441591,7441586,'cel',33.333,1),(188,7441592,7441589,'rev',16.667,1),(188,7441593,7441589,'evi',16.667,1),(188,7441594,7441589,'vis',16.667,1),(188,7441595,7441589,'isi',16.667,1),(188,7441596,7441589,'sio',16.667,1),(188,7441597,7441589,'ion',16.667,1),(188,7441598,7441592,'lev',33.333,1),(188,7441599,7441592,'eve',33.333,1),(188,7441600,7441592,'vel',33.333,1),(188,7441601,7441598,'pse',25,1),(188,7441602,7441598,'seu',25,1),(188,7441603,7441598,'eud',25,1),(188,7441604,7441598,'udo',25,1),(188,7441605,7441601,'fal',33.333,5),(188,7441606,7441601,'als',33.333,5),(188,7441607,7441601,'lse',33.333,5),(188,7441608,7441605,'sta',25,3),(188,7441609,7441605,'tat',25,3),(188,7441610,7441605,'atu',25,3),(188,7441611,7441605,'tus',25,3),(188,7441612,7441608,'deg',16.667,1),(188,7441613,7441608,'egr',16.667,1),(188,7441614,7441608,'gra',16.667,1),(188,7441615,7441608,'rad',16.667,1),(188,7441616,7441608,'ade',16.667,1),(188,7441617,7441608,'ded',16.667,1),(188,7441618,7441612,'rdm',100,1),(188,7441619,7441618,'cap',20,1),(188,7441620,7441618,'apa',20,1),(188,7441621,7441618,'pab',20,1),(188,7441622,7441618,'abl',20,1),(188,7441623,7441618,'ble',20,1),(188,7441624,7441619,'tru',50,2),(188,7441625,7441619,'rue',50,2),(188,7441626,7441624,'loc',33.333,1),(188,7441627,7441624,'oca',33.333,1),(188,7441628,7441624,'cal',33.333,1),(188,7441629,7441626,'rem',14.286,1),(188,7441630,7441626,'emo',14.286,1),(188,7441631,7441626,'mov',14.286,1),(188,7441632,7441626,'ova',14.286,1),(188,7441633,7441626,'vab',14.286,1),(188,7441634,7441626,'abl',14.286,1),(188,7441635,7441626,'ble',14.286,1),(188,7441636,7441629,'ssd',100,1),(188,7441637,7441636,'off',20,1),(188,7441638,7441636,'ffl',20,1),(188,7441639,7441636,'fli',20,1),(188,7441640,7441636,'lin',20,1),(188,7441641,7441636,'ine',20,1),(188,7441642,7441637,'per',11.111,1),(188,7441643,7441637,'ere',11.111,1),(188,7441644,7441637,'ren',11.111,1),(188,7441645,7441637,'enn',11.111,1),(188,7441646,7441637,'nni',11.111,1),(188,7441647,7441637,'nia',11.111,1),(188,7441648,7441637,'ial',11.111,1),(188,7441649,7441637,'all',11.111,1),(188,7441650,7441637,'lly',11.111,1),(188,7441651,7441642,'res',16.667,1),(188,7441652,7441642,'ese',16.667,1),(188,7441653,7441642,'ser',16.667,1),(188,7441654,7441642,'erv',16.667,1),(188,7441655,7441642,'rve',16.667,1),(188,7441656,7441642,'ved',16.667,1),(188,7441657,7441651,'thi',50,1),(188,7441658,7441651,'hin',50,1),(188,7441659,7441657,'pro',10,1),(188,7441660,7441657,'rov',10,1),(188,7441661,7441657,'ovi',10,1),(188,7441662,7441657,'vis',10,1),(188,7441663,7441657,'isi',10,1),(188,7441664,7441657,'sio',10,1),(188,7441665,7441657,'ion',10,1),(188,7441666,7441657,'oni',10,1),(188,7441667,7441657,'nin',10,1),(188,7441668,7441657,'ing',10,1),(188,7441669,7441659,'unk',20,1),(188,7441670,7441659,'nkn',20,1),(188,7441671,7441659,'kno',20,1),(188,7441672,7441659,'now',20,1),(188,7441673,7441659,'own',20,1),(188,7441674,7441669,'fil',20,1),(188,7441675,7441669,'ilt',20,1),(188,7441676,7441669,'lte',20,1),(188,7441677,7441669,'ter',20,1),(188,7441678,7441669,'ers',20,1),(188,7441679,7441674,'vaa',50,1),(188,7441680,7441674,'aai',50,1),(188,7441681,7441679,'uns',11.111,1),(188,7441682,7441679,'nsu',11.111,1),(188,7441683,7441679,'sup',11.111,1),(188,7441684,7441679,'upp',11.111,1),(188,7441685,7441679,'ppo',11.111,1),(188,7441686,7441679,'por',11.111,1),(188,7441687,7441679,'ort',11.111,1),(188,7441688,7441679,'rte',11.111,1),(188,7441689,7441679,'ted',11.111,1),(188,7441690,7441681,'oth',33.333,1),(188,7441691,7441681,'the',33.333,1),(188,7441692,7441681,'her',33.333,1),(188,7441693,7441690,'uid',50,1),(188,7441694,7441690,'ids',50,1),(188,7441695,7441693,'vml',100,1),(188,7441696,7441695,'dis',20,1),(188,7441697,7441695,'isp',20,1),(188,7441698,7441695,'spl',20,1),(188,7441699,7441695,'pla',20,1),(188,7441700,7441695,'lay',20,1),(188,7441701,7441696,'nam',50,1),(188,7441702,7441696,'ame',50,1),(189,7441704,7441703,'net',25,3),(189,7441705,7441703,'eta',25,3),(189,7441706,7441703,'tap',25,3),(189,7441707,7441703,'app',25,3),(189,7441708,7441704,'ser',25,3),(189,7441709,7441704,'eri',25,3),(189,7441710,7441704,'ria',25,3),(189,7441711,7441704,'ial',25,3),(189,7441712,7441708,'att',16.667,3),(189,7441713,7441708,'tta',16.667,3),(189,7441714,7441708,'tac',16.667,3),(189,7441715,7441708,'ach',16.667,3),(189,7441716,7441708,'che',16.667,3),(189,7441717,7441708,'hed',16.667,3),(189,7441718,7441712,'scs',50,3),(189,7441719,7441712,'csi',50,3),(189,7441720,7441718,'dis',50,2),(189,7441721,7441718,'isk',50,2),(189,7441722,7441720,'naa',100,4),(189,7441723,7441722,'600',3.333,4),(189,7441724,7441722,'00a',3.333,4),(189,7441725,7441722,'0a0',3.333,4),(189,7441726,7441722,'a09',3.333,4),(189,7441727,7441722,'098',3.333,4),(189,7441728,7441722,'980',3.333,4),(189,7441729,7441722,'807',3.333,4),(189,7441730,7441722,'078',3.333,4),(189,7441731,7441722,'785',3.333,4),(189,7441732,7441722,'853',3.333,4),(189,7441733,7441722,'538',3.333,4),(189,7441734,7441722,'383',3.333,4),(189,7441735,7441722,'83e',3.333,4),(189,7441736,7441722,'3ee',3.333,4),(189,7441737,7441722,'eee',3.333,4),(189,7441738,7441722,'ee6',3.333,4),(189,7441739,7441722,'e61',3.333,4),(189,7441740,7441722,'617',3.333,4),(189,7441741,7441722,'174',3.333,4),(189,7441742,7441722,'74a',3.333,4),(189,7441743,7441722,'4a1',3.333,4),(189,7441744,7441722,'a11',3.333,4),(189,7441745,7441722,'117',3.333,4),(189,7441746,7441722,'17b',3.333,4),(189,7441747,7441722,'7b0',3.333,4),(189,7441748,7441722,'b01',3.333,4),(189,7441749,7441722,'01a',3.333,4),(189,7441750,7441722,'1ab',3.333,4),(189,7441751,7441722,'aba',3.333,4),(189,7441752,7441722,'ba2',3.333,4),(189,7441753,7441723,'siz',50,1),(189,7441754,7441723,'ize',50,1),(189,7441755,7441753,'163',33.333,1),(189,7441756,7441753,'638',33.333,1),(189,7441757,7441753,'384',33.333,1),(189,7441758,7441755,'dev',25,1),(189,7441759,7441755,'evi',25,1),(189,7441760,7441755,'vic',25,1),(189,7441761,7441755,'ice',25,1),(189,7441762,7441758,'typ',50,1),(189,7441763,7441758,'ype',50,1),(189,7441764,7441762,'dir',10,1),(189,7441765,7441762,'ire',10,1),(189,7441766,7441762,'rec',10,1),(189,7441767,7441762,'ect',10,1),(189,7441768,7441762,'cta',10,1),(189,7441769,7441762,'tac',10,1),(189,7441770,7441762,'acc',10,1),(189,7441771,7441762,'cce',10,1),(189,7441772,7441762,'ces',10,1),(189,7441773,7441762,'ess',10,1),(189,7441774,7441764,'mul',14.286,1),(189,7441775,7441764,'ult',14.286,1),(189,7441776,7441764,'lti',14.286,1),(189,7441777,7441764,'tip',14.286,1),(189,7441778,7441764,'ipa',14.286,1),(189,7441779,7441764,'pat',14.286,1),(189,7441780,7441764,'ath',14.286,1),(189,7441781,7441774,'plu',25,1),(189,7441782,7441774,'lug',25,1),(189,7441783,7441774,'ugi',25,1),(189,7441784,7441774,'gin',25,1),(189,7441785,7441781,'nmp',100,1),(189,7441786,7441785,'dev',33.333,1),(189,7441787,7441785,'evf',33.333,1),(189,7441788,7441785,'vfs',33.333,1),(189,7441789,7441786,'pat',50,1),(189,7441790,7441786,'ath',50,1),(189,7441791,7441789,'vmf',50,1),(189,7441792,7441789,'mfs',50,1),(189,7441793,7441791,'dev',20,1),(189,7441794,7441791,'evi',20,1),(189,7441795,7441791,'vic',20,1),(189,7441796,7441791,'ice',20,1),(189,7441797,7441791,'ces',20,1),(189,7441798,7441793,'dis',33.333,1),(189,7441799,7441793,'isk',33.333,1),(189,7441800,7441793,'sks',33.333,1),(189,7441801,7441798,'ven',25,1),(189,7441802,7441798,'end',25,1),(189,7441803,7441798,'ndo',25,1),(189,7441804,7441798,'dor',25,1),(189,7441805,7441801,'mod',33.333,1),(189,7441806,7441801,'ode',33.333,1),(189,7441807,7441801,'del',33.333,1),(189,7441808,7441805,'fla',33.333,1),(189,7441809,7441805,'las',33.333,1),(189,7441810,7441805,'ash',33.333,1),(189,7441811,7441808,'acc',33.333,1),(189,7441812,7441808,'cce',33.333,1),(189,7441813,7441808,'cel',33.333,1),(189,7441814,7441811,'rev',16.667,1),(189,7441815,7441811,'evi',16.667,1),(189,7441816,7441811,'vis',16.667,1),(189,7441817,7441811,'isi',16.667,1),(189,7441818,7441811,'sio',16.667,1),(189,7441819,7441811,'ion',16.667,1),(189,7441820,7441814,'lev',33.333,1),(189,7441821,7441814,'eve',33.333,1),(189,7441822,7441814,'vel',33.333,1),(189,7441823,7441820,'pse',25,1),(189,7441824,7441820,'seu',25,1),(189,7441825,7441820,'eud',25,1),(189,7441826,7441820,'udo',25,1),(189,7441827,7441823,'fal',33.333,5),(189,7441828,7441823,'als',33.333,5),(189,7441829,7441823,'lse',33.333,5),(189,7441830,7441827,'sta',25,3),(189,7441831,7441827,'tat',25,3),(189,7441832,7441827,'atu',25,3),(189,7441833,7441827,'tus',25,3),(189,7441834,7441830,'deg',16.667,1),(189,7441835,7441830,'egr',16.667,1),(189,7441836,7441830,'gra',16.667,1),(189,7441837,7441830,'rad',16.667,1),(189,7441838,7441830,'ade',16.667,1),(189,7441839,7441830,'ded',16.667,1),(189,7441840,7441834,'rdm',100,1),(189,7441841,7441840,'cap',20,1),(189,7441842,7441840,'apa',20,1),(189,7441843,7441840,'pab',20,1),(189,7441844,7441840,'abl',20,1),(189,7441845,7441840,'ble',20,1),(189,7441846,7441841,'tru',50,2),(189,7441847,7441841,'rue',50,2),(189,7441848,7441846,'loc',33.333,1),(189,7441849,7441846,'oca',33.333,1),(189,7441850,7441846,'cal',33.333,1),(189,7441851,7441848,'rem',14.286,1),(189,7441852,7441848,'emo',14.286,1),(189,7441853,7441848,'mov',14.286,1),(189,7441854,7441848,'ova',14.286,1),(189,7441855,7441848,'vab',14.286,1),(189,7441856,7441848,'abl',14.286,1),(189,7441857,7441848,'ble',14.286,1),(189,7441858,7441851,'ssd',100,1),(189,7441859,7441858,'off',20,1),(189,7441860,7441858,'ffl',20,1),(189,7441861,7441858,'fli',20,1),(189,7441862,7441858,'lin',20,1),(189,7441863,7441858,'ine',20,1),(189,7441864,7441859,'per',11.111,1),(189,7441865,7441859,'ere',11.111,1),(189,7441866,7441859,'ren',11.111,1),(189,7441867,7441859,'enn',11.111,1),(189,7441868,7441859,'nni',11.111,1),(189,7441869,7441859,'nia',11.111,1),(189,7441870,7441859,'ial',11.111,1),(189,7441871,7441859,'all',11.111,1),(189,7441872,7441859,'lly',11.111,1),(189,7441873,7441864,'res',16.667,1),(189,7441874,7441864,'ese',16.667,1),(189,7441875,7441864,'ser',16.667,1),(189,7441876,7441864,'erv',16.667,1),(189,7441877,7441864,'rve',16.667,1),(189,7441878,7441864,'ved',16.667,1),(189,7441879,7441873,'thi',50,1),(189,7441880,7441873,'hin',50,1),(189,7441881,7441879,'pro',10,1),(189,7441882,7441879,'rov',10,1),(189,7441883,7441879,'ovi',10,1),(189,7441884,7441879,'vis',10,1),(189,7441885,7441879,'isi',10,1),(189,7441886,7441879,'sio',10,1),(189,7441887,7441879,'ion',10,1),(189,7441888,7441879,'oni',10,1),(189,7441889,7441879,'nin',10,1),(189,7441890,7441879,'ing',10,1),(189,7441891,7441881,'unk',20,1),(189,7441892,7441881,'nkn',20,1),(189,7441893,7441881,'kno',20,1),(189,7441894,7441881,'now',20,1),(189,7441895,7441881,'own',20,1),(189,7441896,7441891,'fil',20,1),(189,7441897,7441891,'ilt',20,1),(189,7441898,7441891,'lte',20,1),(189,7441899,7441891,'ter',20,1),(189,7441900,7441891,'ers',20,1),(189,7441901,7441896,'vaa',50,1),(189,7441902,7441896,'aai',50,1),(189,7441903,7441901,'uns',11.111,1),(189,7441904,7441901,'nsu',11.111,1),(189,7441905,7441901,'sup',11.111,1),(189,7441906,7441901,'upp',11.111,1),(189,7441907,7441901,'ppo',11.111,1),(189,7441908,7441901,'por',11.111,1),(189,7441909,7441901,'ort',11.111,1),(189,7441910,7441901,'rte',11.111,1),(189,7441911,7441901,'ted',11.111,1),(189,7441912,7441903,'oth',33.333,1),(189,7441913,7441903,'the',33.333,1),(189,7441914,7441903,'her',33.333,1),(189,7441915,7441912,'uid',50,1),(189,7441916,7441912,'ids',50,1),(189,7441917,7441915,'vml',100,1),(189,7441918,7441917,'dis',20,1),(189,7441919,7441917,'isp',20,1),(189,7441920,7441917,'spl',20,1),(189,7441921,7441917,'pla',20,1),(189,7441922,7441917,'lay',20,1),(189,7441923,7441918,'nam',50,1),(189,7441924,7441918,'ame',50,1),(190,7441926,7441925,'net',25,3),(190,7441927,7441925,'eta',25,3),(190,7441928,7441925,'tap',25,3),(190,7441929,7441925,'app',25,3),(190,7441930,7441926,'fib',33.333,2),(190,7441931,7441926,'ibr',33.333,2),(190,7441932,7441926,'bre',33.333,2),(190,7441933,7441930,'cha',20,2),(190,7441934,7441930,'han',20,2),(190,7441935,7441930,'ann',20,2),(190,7441936,7441930,'nne',20,2),(190,7441937,7441930,'nel',20,2),(190,7441938,7441933,'dis',50,2),(190,7441939,7441933,'isk',50,2),(190,7441940,7441938,'naa',100,4),(190,7441941,7441940,'600',3.333,4),(190,7441942,7441940,'00a',3.333,4),(190,7441943,7441940,'0a0',3.333,4),(190,7441944,7441940,'a09',3.333,4),(190,7441945,7441940,'098',3.333,4),(190,7441946,7441940,'980',3.333,4),(190,7441947,7441940,'804',3.333,4),(190,7441948,7441940,'044',3.333,4),(190,7441949,7441940,'443',3.333,4),(190,7441950,7441940,'430',3.333,4),(190,7441951,7441940,'307',3.333,4),(190,7441952,7441940,'075',3.333,4),(190,7441953,7441940,'753',3.333,4),(190,7441954,7441940,'535',3.333,4),(190,7441955,7441940,'357',3.333,4),(190,7441956,7441940,'573',3.333,4),(190,7441957,7441940,'732',3.333,4),(190,7441958,7441940,'32b',3.333,4),(190,7441959,7441940,'2b3',3.333,4),(190,7441960,7441940,'b33',3.333,4),(190,7441961,7441940,'334',3.333,4),(190,7441962,7441940,'345',3.333,4),(190,7441963,7441940,'457',3.333,4),(190,7441964,7441940,'571',3.333,4),(190,7441965,7441940,'715',3.333,4),(190,7441966,7441940,'153',3.333,4),(190,7441967,7441940,'533',3.333,4),(190,7441968,7441940,'336',3.333,4),(190,7441969,7441940,'366',3.333,4),(190,7441970,7441940,'661',3.333,4),(190,7441971,7441941,'ser',25,1),(190,7441972,7441941,'eri',25,1),(190,7441973,7441941,'ria',25,1),(190,7441974,7441941,'ial',25,1),(190,7441975,7441971,'siz',50,1),(190,7441976,7441971,'ize',50,1),(190,7441977,7441975,'321',100,1),(190,7441978,7441977,'dev',25,1),(190,7441979,7441977,'evi',25,1),(190,7441980,7441977,'vic',25,1),(190,7441981,7441977,'ice',25,1),(190,7441982,7441978,'typ',50,1),(190,7441983,7441978,'ype',50,1),(190,7441984,7441982,'dir',10,1),(190,7441985,7441982,'ire',10,1),(190,7441986,7441982,'rec',10,1),(190,7441987,7441982,'ect',10,1),(190,7441988,7441982,'cta',10,1),(190,7441989,7441982,'tac',10,1),(190,7441990,7441982,'acc',10,1),(190,7441991,7441982,'cce',10,1),(190,7441992,7441982,'ces',10,1),(190,7441993,7441982,'ess',10,1),(190,7441994,7441984,'mul',14.286,1),(190,7441995,7441984,'ult',14.286,1),(190,7441996,7441984,'lti',14.286,1),(190,7441997,7441984,'tip',14.286,1),(190,7441998,7441984,'ipa',14.286,1),(190,7441999,7441984,'pat',14.286,1),(190,7442000,7441984,'ath',14.286,1),(190,7442001,7441994,'plu',25,1),(190,7442002,7441994,'lug',25,1),(190,7442003,7441994,'ugi',25,1),(190,7442004,7441994,'gin',25,1),(190,7442005,7442001,'nmp',100,1),(190,7442006,7442005,'dev',33.333,1),(190,7442007,7442005,'evf',33.333,1),(190,7442008,7442005,'vfs',33.333,1),(190,7442009,7442006,'pat',50,1),(190,7442010,7442006,'ath',50,1),(190,7442011,7442009,'vmf',50,1),(190,7442012,7442009,'mfs',50,1),(190,7442013,7442011,'dev',20,1),(190,7442014,7442011,'evi',20,1),(190,7442015,7442011,'vic',20,1),(190,7442016,7442011,'ice',20,1),(190,7442017,7442011,'ces',20,1),(190,7442018,7442013,'dis',33.333,1),(190,7442019,7442013,'isk',33.333,1),(190,7442020,7442013,'sks',33.333,1),(190,7442021,7442018,'ven',25,1),(190,7442022,7442018,'end',25,1),(190,7442023,7442018,'ndo',25,1),(190,7442024,7442018,'dor',25,1),(190,7442025,7442021,'mod',33.333,1),(190,7442026,7442021,'ode',33.333,1),(190,7442027,7442021,'del',33.333,1),(190,7442028,7442025,'lun',100,1),(190,7442029,7442028,'cmo',33.333,1),(190,7442030,7442028,'mod',33.333,1),(190,7442031,7442028,'ode',33.333,1),(190,7442032,7442029,'rev',16.667,1),(190,7442033,7442029,'evi',16.667,1),(190,7442034,7442029,'vis',16.667,1),(190,7442035,7442029,'isi',16.667,1),(190,7442036,7442029,'sio',16.667,1),(190,7442037,7442029,'ion',16.667,1),(190,7442038,7442032,'810',50,1),(190,7442039,7442032,'100',50,1),(190,7442040,7442038,'scs',50,1),(190,7442041,7442038,'csi',50,1),(190,7442042,7442040,'lev',33.333,1),(190,7442043,7442040,'eve',33.333,1),(190,7442044,7442040,'vel',33.333,1),(190,7442045,7442042,'pse',25,1),(190,7442046,7442042,'seu',25,1),(190,7442047,7442042,'eud',25,1),(190,7442048,7442042,'udo',25,1),(190,7442049,7442045,'fal',33.333,6),(190,7442050,7442045,'als',33.333,6),(190,7442051,7442045,'lse',33.333,6),(190,7442052,7442049,'sta',25,3),(190,7442053,7442049,'tat',25,3),(190,7442054,7442049,'atu',25,3),(190,7442055,7442049,'tus',25,3),(190,7442056,7442052,'rdm',100,1),(190,7442057,7442056,'cap',20,1),(190,7442058,7442056,'apa',20,1),(190,7442059,7442056,'pab',20,1),(190,7442060,7442056,'abl',20,1),(190,7442061,7442056,'ble',20,1),(190,7442062,7442057,'tru',50,1),(190,7442063,7442057,'rue',50,1),(190,7442064,7442062,'loc',33.333,1),(190,7442065,7442062,'oca',33.333,1),(190,7442066,7442062,'cal',33.333,1),(190,7442067,7442064,'rem',14.286,1),(190,7442068,7442064,'emo',14.286,1),(190,7442069,7442064,'mov',14.286,1),(190,7442070,7442064,'ova',14.286,1),(190,7442071,7442064,'vab',14.286,1),(190,7442072,7442064,'abl',14.286,1),(190,7442073,7442064,'ble',14.286,1),(190,7442074,7442067,'ssd',100,1),(190,7442075,7442074,'off',20,1),(190,7442076,7442074,'ffl',20,1),(190,7442077,7442074,'fli',20,1),(190,7442078,7442074,'lin',20,1),(190,7442079,7442074,'ine',20,1),(190,7442080,7442075,'per',11.111,1),(190,7442081,7442075,'ere',11.111,1),(190,7442082,7442075,'ren',11.111,1),(190,7442083,7442075,'enn',11.111,1),(190,7442084,7442075,'nni',11.111,1),(190,7442085,7442075,'nia',11.111,1),(190,7442086,7442075,'ial',11.111,1),(190,7442087,7442075,'all',11.111,1),(190,7442088,7442075,'lly',11.111,1),(190,7442089,7442080,'res',16.667,1),(190,7442090,7442080,'ese',16.667,1),(190,7442091,7442080,'ser',16.667,1),(190,7442092,7442080,'erv',16.667,1),(190,7442093,7442080,'rve',16.667,1),(190,7442094,7442080,'ved',16.667,1),(190,7442095,7442089,'thi',50,1),(190,7442096,7442089,'hin',50,1),(190,7442097,7442095,'pro',10,1),(190,7442098,7442095,'rov',10,1),(190,7442099,7442095,'ovi',10,1),(190,7442100,7442095,'vis',10,1),(190,7442101,7442095,'isi',10,1),(190,7442102,7442095,'sio',10,1),(190,7442103,7442095,'ion',10,1),(190,7442104,7442095,'oni',10,1),(190,7442105,7442095,'nin',10,1),(190,7442106,7442095,'ing',10,1),(190,7442107,7442097,'yes',100,1),(190,7442108,7442107,'att',16.667,1),(190,7442109,7442107,'tta',16.667,1),(190,7442110,7442107,'tac',16.667,1),(190,7442111,7442107,'ach',16.667,1),(190,7442112,7442107,'che',16.667,1),(190,7442113,7442107,'hed',16.667,1),(190,7442114,7442108,'fil',20,1),(190,7442115,7442108,'ilt',20,1),(190,7442116,7442108,'lte',20,1),(190,7442117,7442108,'ter',20,1),(190,7442118,7442108,'ers',20,1),(190,7442119,7442114,'vaa',50,1),(190,7442120,7442114,'aai',50,1),(190,7442121,7442119,'unk',20,1),(190,7442122,7442119,'nkn',20,1),(190,7442123,7442119,'kno',20,1),(190,7442124,7442119,'now',20,1),(190,7442125,7442119,'own',20,1),(190,7442126,7442121,'oth',33.333,1),(190,7442127,7442121,'the',33.333,1),(190,7442128,7442121,'her',33.333,1),(190,7442129,7442126,'uid',50,1),(190,7442130,7442126,'ids',50,1),(190,7442131,7442129,'vml',100,1),(190,7442132,7442131,'dis',20,1),(190,7442133,7442131,'isp',20,1),(190,7442134,7442131,'spl',20,1),(190,7442135,7442131,'pla',20,1),(190,7442136,7442131,'lay',20,1),(190,7442137,7442132,'nam',50,1),(190,7442138,7442132,'ame',50,1),(191,7442140,7442139,'net',25,3),(191,7442141,7442139,'eta',25,3),(191,7442142,7442139,'tap',25,3),(191,7442143,7442139,'app',25,3),(191,7442144,7442140,'fib',33.333,2),(191,7442145,7442140,'ibr',33.333,2),(191,7442146,7442140,'bre',33.333,2),(191,7442147,7442144,'cha',20,2),(191,7442148,7442144,'han',20,2),(191,7442149,7442144,'ann',20,2),(191,7442150,7442144,'nne',20,2),(191,7442151,7442144,'nel',20,2),(191,7442152,7442147,'dis',50,2),(191,7442153,7442147,'isk',50,2),(191,7442154,7442152,'naa',100,4),(191,7442155,7442154,'600',3.333,4),(191,7442156,7442154,'00a',3.333,4),(191,7442157,7442154,'0a0',3.333,4),(191,7442158,7442154,'a09',3.333,4),(191,7442159,7442154,'098',3.333,4),(191,7442160,7442154,'980',3.333,4),(191,7442161,7442154,'804',3.333,4),(191,7442162,7442154,'044',3.333,4),(191,7442163,7442154,'443',3.333,4),(191,7442164,7442154,'430',3.333,4),(191,7442165,7442154,'307',3.333,4),(191,7442166,7442154,'075',3.333,4),(191,7442167,7442154,'753',3.333,4),(191,7442168,7442154,'535',3.333,4),(191,7442169,7442154,'357',3.333,4),(191,7442170,7442154,'573',3.333,4),(191,7442171,7442154,'732',3.333,4),(191,7442172,7442154,'32b',3.333,4),(191,7442173,7442154,'2b3',3.333,4),(191,7442174,7442154,'b33',3.333,4),(191,7442175,7442154,'334',3.333,4),(191,7442176,7442154,'345',3.333,4),(191,7442177,7442154,'457',3.333,4),(191,7442178,7442154,'571',3.333,4),(191,7442179,7442154,'715',3.333,4),(191,7442180,7442154,'153',3.333,4),(191,7442181,7442154,'533',3.333,4),(191,7442182,7442154,'336',3.333,4),(191,7442183,7442154,'366',3.333,4),(191,7442184,7442154,'662',3.333,4),(191,7442185,7442155,'ser',25,1),(191,7442186,7442155,'eri',25,1),(191,7442187,7442155,'ria',25,1),(191,7442188,7442155,'ial',25,1),(191,7442189,7442185,'siz',50,1),(191,7442190,7442185,'ize',50,1),(191,7442191,7442189,'321',100,1),(191,7442192,7442191,'dev',25,1),(191,7442193,7442191,'evi',25,1),(191,7442194,7442191,'vic',25,1),(191,7442195,7442191,'ice',25,1),(191,7442196,7442192,'typ',50,1),(191,7442197,7442192,'ype',50,1),(191,7442198,7442196,'dir',10,1),(191,7442199,7442196,'ire',10,1),(191,7442200,7442196,'rec',10,1),(191,7442201,7442196,'ect',10,1),(191,7442202,7442196,'cta',10,1),(191,7442203,7442196,'tac',10,1),(191,7442204,7442196,'acc',10,1),(191,7442205,7442196,'cce',10,1),(191,7442206,7442196,'ces',10,1),(191,7442207,7442196,'ess',10,1),(191,7442208,7442198,'mul',14.286,1),(191,7442209,7442198,'ult',14.286,1),(191,7442210,7442198,'lti',14.286,1),(191,7442211,7442198,'tip',14.286,1),(191,7442212,7442198,'ipa',14.286,1),(191,7442213,7442198,'pat',14.286,1),(191,7442214,7442198,'ath',14.286,1),(191,7442215,7442208,'plu',25,1),(191,7442216,7442208,'lug',25,1),(191,7442217,7442208,'ugi',25,1),(191,7442218,7442208,'gin',25,1),(191,7442219,7442215,'nmp',100,1),(191,7442220,7442219,'dev',33.333,1),(191,7442221,7442219,'evf',33.333,1),(191,7442222,7442219,'vfs',33.333,1),(191,7442223,7442220,'pat',50,1),(191,7442224,7442220,'ath',50,1),(191,7442225,7442223,'vmf',50,1),(191,7442226,7442223,'mfs',50,1),(191,7442227,7442225,'dev',20,1),(191,7442228,7442225,'evi',20,1),(191,7442229,7442225,'vic',20,1),(191,7442230,7442225,'ice',20,1),(191,7442231,7442225,'ces',20,1),(191,7442232,7442227,'dis',33.333,1),(191,7442233,7442227,'isk',33.333,1),(191,7442234,7442227,'sks',33.333,1),(191,7442235,7442232,'ven',25,1),(191,7442236,7442232,'end',25,1),(191,7442237,7442232,'ndo',25,1),(191,7442238,7442232,'dor',25,1),(191,7442239,7442235,'mod',33.333,1),(191,7442240,7442235,'ode',33.333,1),(191,7442241,7442235,'del',33.333,1),(191,7442242,7442239,'lun',100,1),(191,7442243,7442242,'cmo',33.333,1),(191,7442244,7442242,'mod',33.333,1),(191,7442245,7442242,'ode',33.333,1),(191,7442246,7442243,'rev',16.667,1),(191,7442247,7442243,'evi',16.667,1),(191,7442248,7442243,'vis',16.667,1),(191,7442249,7442243,'isi',16.667,1),(191,7442250,7442243,'sio',16.667,1),(191,7442251,7442243,'ion',16.667,1),(191,7442252,7442246,'810',50,1),(191,7442253,7442246,'100',50,1),(191,7442254,7442252,'scs',50,1),(191,7442255,7442252,'csi',50,1),(191,7442256,7442254,'lev',33.333,1),(191,7442257,7442254,'eve',33.333,1),(191,7442258,7442254,'vel',33.333,1),(191,7442259,7442256,'pse',25,1),(191,7442260,7442256,'seu',25,1),(191,7442261,7442256,'eud',25,1),(191,7442262,7442256,'udo',25,1),(191,7442263,7442259,'fal',33.333,6),(191,7442264,7442259,'als',33.333,6),(191,7442265,7442259,'lse',33.333,6),(191,7442266,7442263,'sta',25,3),(191,7442267,7442263,'tat',25,3),(191,7442268,7442263,'atu',25,3),(191,7442269,7442263,'tus',25,3),(191,7442270,7442266,'rdm',100,1),(191,7442271,7442270,'cap',20,1),(191,7442272,7442270,'apa',20,1),(191,7442273,7442270,'pab',20,1),(191,7442274,7442270,'abl',20,1),(191,7442275,7442270,'ble',20,1),(191,7442276,7442271,'tru',50,1),(191,7442277,7442271,'rue',50,1),(191,7442278,7442276,'loc',33.333,1),(191,7442279,7442276,'oca',33.333,1),(191,7442280,7442276,'cal',33.333,1),(191,7442281,7442278,'rem',14.286,1),(191,7442282,7442278,'emo',14.286,1),(191,7442283,7442278,'mov',14.286,1),(191,7442284,7442278,'ova',14.286,1),(191,7442285,7442278,'vab',14.286,1),(191,7442286,7442278,'abl',14.286,1),(191,7442287,7442278,'ble',14.286,1),(191,7442288,7442281,'ssd',100,1),(191,7442289,7442288,'off',20,1),(191,7442290,7442288,'ffl',20,1),(191,7442291,7442288,'fli',20,1),(191,7442292,7442288,'lin',20,1),(191,7442293,7442288,'ine',20,1),(191,7442294,7442289,'per',11.111,1),(191,7442295,7442289,'ere',11.111,1),(191,7442296,7442289,'ren',11.111,1),(191,7442297,7442289,'enn',11.111,1),(191,7442298,7442289,'nni',11.111,1),(191,7442299,7442289,'nia',11.111,1),(191,7442300,7442289,'ial',11.111,1),(191,7442301,7442289,'all',11.111,1),(191,7442302,7442289,'lly',11.111,1),(191,7442303,7442294,'res',16.667,1),(191,7442304,7442294,'ese',16.667,1),(191,7442305,7442294,'ser',16.667,1),(191,7442306,7442294,'erv',16.667,1),(191,7442307,7442294,'rve',16.667,1),(191,7442308,7442294,'ved',16.667,1),(191,7442309,7442303,'thi',50,1),(191,7442310,7442303,'hin',50,1),(191,7442311,7442309,'pro',10,1),(191,7442312,7442309,'rov',10,1),(191,7442313,7442309,'ovi',10,1),(191,7442314,7442309,'vis',10,1),(191,7442315,7442309,'isi',10,1),(191,7442316,7442309,'sio',10,1),(191,7442317,7442309,'ion',10,1),(191,7442318,7442309,'oni',10,1),(191,7442319,7442309,'nin',10,1),(191,7442320,7442309,'ing',10,1),(191,7442321,7442311,'yes',100,1),(191,7442322,7442321,'att',16.667,1),(191,7442323,7442321,'tta',16.667,1),(191,7442324,7442321,'tac',16.667,1),(191,7442325,7442321,'ach',16.667,1),(191,7442326,7442321,'che',16.667,1),(191,7442327,7442321,'hed',16.667,1),(191,7442328,7442322,'fil',20,1),(191,7442329,7442322,'ilt',20,1),(191,7442330,7442322,'lte',20,1),(191,7442331,7442322,'ter',20,1),(191,7442332,7442322,'ers',20,1),(191,7442333,7442328,'vaa',50,1),(191,7442334,7442328,'aai',50,1),(191,7442335,7442333,'unk',20,1),(191,7442336,7442333,'nkn',20,1),(191,7442337,7442333,'kno',20,1),(191,7442338,7442333,'now',20,1),(191,7442339,7442333,'own',20,1),(191,7442340,7442335,'oth',33.333,1),(191,7442341,7442335,'the',33.333,1),(191,7442342,7442335,'her',33.333,1),(191,7442343,7442340,'uid',50,1),(191,7442344,7442340,'ids',50,1),(191,7442345,7442343,'vml',100,1),(191,7442346,7442345,'dis',20,1),(191,7442347,7442345,'isp',20,1),(191,7442348,7442345,'spl',20,1),(191,7442349,7442345,'pla',20,1),(191,7442350,7442345,'lay',20,1),(191,7442351,7442346,'nam',50,1),(191,7442352,7442346,'ame',50,1),(192,7442354,7442353,'net',25,3),(192,7442355,7442353,'eta',25,3),(192,7442356,7442353,'tap',25,3),(192,7442357,7442353,'app',25,3),(192,7442358,7442354,'fib',33.333,2),(192,7442359,7442354,'ibr',33.333,2),(192,7442360,7442354,'bre',33.333,2),(192,7442361,7442358,'cha',20,2),(192,7442362,7442358,'han',20,2),(192,7442363,7442358,'ann',20,2),(192,7442364,7442358,'nne',20,2),(192,7442365,7442358,'nel',20,2),(192,7442366,7442361,'dis',50,2),(192,7442367,7442361,'isk',50,2),(192,7442368,7442366,'naa',100,4),(192,7442369,7442368,'600',3.333,4),(192,7442370,7442368,'00a',3.333,4),(192,7442371,7442368,'0a0',3.333,4),(192,7442372,7442368,'a09',3.333,4),(192,7442373,7442368,'098',3.333,4),(192,7442374,7442368,'980',3.333,4),(192,7442375,7442368,'804',3.333,4),(192,7442376,7442368,'044',3.333,4),(192,7442377,7442368,'443',3.333,4),(192,7442378,7442368,'430',3.333,4),(192,7442379,7442368,'307',3.333,4),(192,7442380,7442368,'075',3.333,4),(192,7442381,7442368,'753',3.333,4),(192,7442382,7442368,'535',3.333,4),(192,7442383,7442368,'357',3.333,4),(192,7442384,7442368,'573',3.333,4),(192,7442385,7442368,'732',3.333,4),(192,7442386,7442368,'32b',3.333,4),(192,7442387,7442368,'2b3',3.333,4),(192,7442388,7442368,'b33',3.333,4),(192,7442389,7442368,'334',3.333,4),(192,7442390,7442368,'345',3.333,4),(192,7442391,7442368,'457',3.333,4),(192,7442392,7442368,'571',3.333,4),(192,7442393,7442368,'715',3.333,4),(192,7442394,7442368,'153',3.333,4),(192,7442395,7442368,'533',3.333,4),(192,7442396,7442368,'336',3.333,4),(192,7442397,7442368,'366',3.333,4),(192,7442398,7442368,'663',3.333,4),(192,7442399,7442369,'ser',25,1),(192,7442400,7442369,'eri',25,1),(192,7442401,7442369,'ria',25,1),(192,7442402,7442369,'ial',25,1),(192,7442403,7442399,'siz',50,1),(192,7442404,7442399,'ize',50,1),(192,7442405,7442403,'321',100,1),(192,7442406,7442405,'dev',25,1),(192,7442407,7442405,'evi',25,1),(192,7442408,7442405,'vic',25,1),(192,7442409,7442405,'ice',25,1),(192,7442410,7442406,'typ',50,1),(192,7442411,7442406,'ype',50,1),(192,7442412,7442410,'dir',10,1),(192,7442413,7442410,'ire',10,1),(192,7442414,7442410,'rec',10,1),(192,7442415,7442410,'ect',10,1),(192,7442416,7442410,'cta',10,1),(192,7442417,7442410,'tac',10,1),(192,7442418,7442410,'acc',10,1),(192,7442419,7442410,'cce',10,1),(192,7442420,7442410,'ces',10,1),(192,7442421,7442410,'ess',10,1),(192,7442422,7442412,'mul',14.286,1),(192,7442423,7442412,'ult',14.286,1),(192,7442424,7442412,'lti',14.286,1),(192,7442425,7442412,'tip',14.286,1),(192,7442426,7442412,'ipa',14.286,1),(192,7442427,7442412,'pat',14.286,1),(192,7442428,7442412,'ath',14.286,1),(192,7442429,7442422,'plu',25,1),(192,7442430,7442422,'lug',25,1),(192,7442431,7442422,'ugi',25,1),(192,7442432,7442422,'gin',25,1),(192,7442433,7442429,'nmp',100,1),(192,7442434,7442433,'dev',33.333,1),(192,7442435,7442433,'evf',33.333,1),(192,7442436,7442433,'vfs',33.333,1),(192,7442437,7442434,'pat',50,1),(192,7442438,7442434,'ath',50,1),(192,7442439,7442437,'vmf',50,1),(192,7442440,7442437,'mfs',50,1),(192,7442441,7442439,'dev',20,1),(192,7442442,7442439,'evi',20,1),(192,7442443,7442439,'vic',20,1),(192,7442444,7442439,'ice',20,1),(192,7442445,7442439,'ces',20,1),(192,7442446,7442441,'dis',33.333,1),(192,7442447,7442441,'isk',33.333,1),(192,7442448,7442441,'sks',33.333,1),(192,7442449,7442446,'ven',25,1),(192,7442450,7442446,'end',25,1),(192,7442451,7442446,'ndo',25,1),(192,7442452,7442446,'dor',25,1),(192,7442453,7442449,'mod',33.333,1),(192,7442454,7442449,'ode',33.333,1),(192,7442455,7442449,'del',33.333,1),(192,7442456,7442453,'lun',100,1),(192,7442457,7442456,'cmo',33.333,1),(192,7442458,7442456,'mod',33.333,1),(192,7442459,7442456,'ode',33.333,1),(192,7442460,7442457,'rev',16.667,1),(192,7442461,7442457,'evi',16.667,1),(192,7442462,7442457,'vis',16.667,1),(192,7442463,7442457,'isi',16.667,1),(192,7442464,7442457,'sio',16.667,1),(192,7442465,7442457,'ion',16.667,1),(192,7442466,7442460,'810',50,1),(192,7442467,7442460,'100',50,1),(192,7442468,7442466,'scs',50,1),(192,7442469,7442466,'csi',50,1),(192,7442470,7442468,'lev',33.333,1),(192,7442471,7442468,'eve',33.333,1),(192,7442472,7442468,'vel',33.333,1),(192,7442473,7442470,'pse',25,1),(192,7442474,7442470,'seu',25,1),(192,7442475,7442470,'eud',25,1),(192,7442476,7442470,'udo',25,1),(192,7442477,7442473,'fal',33.333,6),(192,7442478,7442473,'als',33.333,6),(192,7442479,7442473,'lse',33.333,6),(192,7442480,7442477,'sta',25,3),(192,7442481,7442477,'tat',25,3),(192,7442482,7442477,'atu',25,3),(192,7442483,7442477,'tus',25,3),(192,7442484,7442480,'rdm',100,1),(192,7442485,7442484,'cap',20,1),(192,7442486,7442484,'apa',20,1),(192,7442487,7442484,'pab',20,1),(192,7442488,7442484,'abl',20,1),(192,7442489,7442484,'ble',20,1),(192,7442490,7442485,'tru',50,1),(192,7442491,7442485,'rue',50,1),(192,7442492,7442490,'loc',33.333,1),(192,7442493,7442490,'oca',33.333,1),(192,7442494,7442490,'cal',33.333,1),(192,7442495,7442492,'rem',14.286,1),(192,7442496,7442492,'emo',14.286,1),(192,7442497,7442492,'mov',14.286,1),(192,7442498,7442492,'ova',14.286,1),(192,7442499,7442492,'vab',14.286,1),(192,7442500,7442492,'abl',14.286,1),(192,7442501,7442492,'ble',14.286,1),(192,7442502,7442495,'ssd',100,1),(192,7442503,7442502,'off',20,1),(192,7442504,7442502,'ffl',20,1),(192,7442505,7442502,'fli',20,1),(192,7442506,7442502,'lin',20,1),(192,7442507,7442502,'ine',20,1),(192,7442508,7442503,'per',11.111,1),(192,7442509,7442503,'ere',11.111,1),(192,7442510,7442503,'ren',11.111,1),(192,7442511,7442503,'enn',11.111,1),(192,7442512,7442503,'nni',11.111,1),(192,7442513,7442503,'nia',11.111,1),(192,7442514,7442503,'ial',11.111,1),(192,7442515,7442503,'all',11.111,1),(192,7442516,7442503,'lly',11.111,1),(192,7442517,7442508,'res',16.667,1),(192,7442518,7442508,'ese',16.667,1),(192,7442519,7442508,'ser',16.667,1),(192,7442520,7442508,'erv',16.667,1),(192,7442521,7442508,'rve',16.667,1),(192,7442522,7442508,'ved',16.667,1),(192,7442523,7442517,'thi',50,1),(192,7442524,7442517,'hin',50,1),(192,7442525,7442523,'pro',10,1),(192,7442526,7442523,'rov',10,1),(192,7442527,7442523,'ovi',10,1),(192,7442528,7442523,'vis',10,1),(192,7442529,7442523,'isi',10,1),(192,7442530,7442523,'sio',10,1),(192,7442531,7442523,'ion',10,1),(192,7442532,7442523,'oni',10,1),(192,7442533,7442523,'nin',10,1),(192,7442534,7442523,'ing',10,1),(192,7442535,7442525,'yes',100,1),(192,7442536,7442535,'att',16.667,1),(192,7442537,7442535,'tta',16.667,1),(192,7442538,7442535,'tac',16.667,1),(192,7442539,7442535,'ach',16.667,1),(192,7442540,7442535,'che',16.667,1),(192,7442541,7442535,'hed',16.667,1),(192,7442542,7442536,'fil',20,1),(192,7442543,7442536,'ilt',20,1),(192,7442544,7442536,'lte',20,1),(192,7442545,7442536,'ter',20,1),(192,7442546,7442536,'ers',20,1),(192,7442547,7442542,'vaa',50,1),(192,7442548,7442542,'aai',50,1),(192,7442549,7442547,'unk',20,1),(192,7442550,7442547,'nkn',20,1),(192,7442551,7442547,'kno',20,1),(192,7442552,7442547,'now',20,1),(192,7442553,7442547,'own',20,1),(192,7442554,7442549,'oth',33.333,1),(192,7442555,7442549,'the',33.333,1),(192,7442556,7442549,'her',33.333,1),(192,7442557,7442554,'uid',50,1),(192,7442558,7442554,'ids',50,1),(192,7442559,7442557,'vml',100,1),(192,7442560,7442559,'dis',20,1),(192,7442561,7442559,'isp',20,1),(192,7442562,7442559,'spl',20,1),(192,7442563,7442559,'pla',20,1),(192,7442564,7442559,'lay',20,1),(192,7442565,7442560,'nam',50,1),(192,7442566,7442560,'ame',50,1),(193,7442568,7442567,'net',25,3),(193,7442569,7442567,'eta',25,3),(193,7442570,7442567,'tap',25,3),(193,7442571,7442567,'app',25,3),(193,7442572,7442568,'fib',33.333,2),(193,7442573,7442568,'ibr',33.333,2),(193,7442574,7442568,'bre',33.333,2),(193,7442575,7442572,'cha',20,2),(193,7442576,7442572,'han',20,2),(193,7442577,7442572,'ann',20,2),(193,7442578,7442572,'nne',20,2),(193,7442579,7442572,'nel',20,2),(193,7442580,7442575,'dis',50,2),(193,7442581,7442575,'isk',50,2),(193,7442582,7442580,'naa',100,4),(193,7442583,7442582,'600',3.333,4),(193,7442584,7442582,'00a',3.333,4),(193,7442585,7442582,'0a0',3.333,4),(193,7442586,7442582,'a09',3.333,4),(193,7442587,7442582,'098',3.333,4),(193,7442588,7442582,'980',3.333,4),(193,7442589,7442582,'804',3.333,4),(193,7442590,7442582,'044',3.333,4),(193,7442591,7442582,'443',3.333,4),(193,7442592,7442582,'430',3.333,4),(193,7442593,7442582,'307',3.333,4),(193,7442594,7442582,'075',3.333,4),(193,7442595,7442582,'753',3.333,4),(193,7442596,7442582,'535',3.333,4),(193,7442597,7442582,'357',3.333,4),(193,7442598,7442582,'573',3.333,4),(193,7442599,7442582,'732',3.333,4),(193,7442600,7442582,'32b',3.333,4),(193,7442601,7442582,'2b3',3.333,4),(193,7442602,7442582,'b33',3.333,4),(193,7442603,7442582,'334',3.333,4),(193,7442604,7442582,'345',3.333,4),(193,7442605,7442582,'457',3.333,4),(193,7442606,7442582,'571',3.333,4),(193,7442607,7442582,'715',3.333,4),(193,7442608,7442582,'153',3.333,4),(193,7442609,7442582,'533',3.333,4),(193,7442610,7442582,'336',3.333,4),(193,7442611,7442582,'366',3.333,4),(193,7442612,7442582,'664',3.333,4),(193,7442613,7442583,'ser',25,1),(193,7442614,7442583,'eri',25,1),(193,7442615,7442583,'ria',25,1),(193,7442616,7442583,'ial',25,1),(193,7442617,7442613,'siz',50,1),(193,7442618,7442613,'ize',50,1),(193,7442619,7442617,'321',100,1),(193,7442620,7442619,'dev',25,1),(193,7442621,7442619,'evi',25,1),(193,7442622,7442619,'vic',25,1),(193,7442623,7442619,'ice',25,1),(193,7442624,7442620,'typ',50,1),(193,7442625,7442620,'ype',50,1),(193,7442626,7442624,'dir',10,1),(193,7442627,7442624,'ire',10,1),(193,7442628,7442624,'rec',10,1),(193,7442629,7442624,'ect',10,1),(193,7442630,7442624,'cta',10,1),(193,7442631,7442624,'tac',10,1),(193,7442632,7442624,'acc',10,1),(193,7442633,7442624,'cce',10,1),(193,7442634,7442624,'ces',10,1),(193,7442635,7442624,'ess',10,1),(193,7442636,7442626,'mul',14.286,1),(193,7442637,7442626,'ult',14.286,1),(193,7442638,7442626,'lti',14.286,1),(193,7442639,7442626,'tip',14.286,1),(193,7442640,7442626,'ipa',14.286,1),(193,7442641,7442626,'pat',14.286,1),(193,7442642,7442626,'ath',14.286,1),(193,7442643,7442636,'plu',25,1),(193,7442644,7442636,'lug',25,1),(193,7442645,7442636,'ugi',25,1),(193,7442646,7442636,'gin',25,1),(193,7442647,7442643,'nmp',100,1),(193,7442648,7442647,'dev',33.333,1),(193,7442649,7442647,'evf',33.333,1),(193,7442650,7442647,'vfs',33.333,1),(193,7442651,7442648,'pat',50,1),(193,7442652,7442648,'ath',50,1),(193,7442653,7442651,'vmf',50,1),(193,7442654,7442651,'mfs',50,1),(193,7442655,7442653,'dev',20,1),(193,7442656,7442653,'evi',20,1),(193,7442657,7442653,'vic',20,1),(193,7442658,7442653,'ice',20,1),(193,7442659,7442653,'ces',20,1),(193,7442660,7442655,'dis',33.333,1),(193,7442661,7442655,'isk',33.333,1),(193,7442662,7442655,'sks',33.333,1),(193,7442663,7442660,'ven',25,1),(193,7442664,7442660,'end',25,1),(193,7442665,7442660,'ndo',25,1),(193,7442666,7442660,'dor',25,1),(193,7442667,7442663,'mod',33.333,1),(193,7442668,7442663,'ode',33.333,1),(193,7442669,7442663,'del',33.333,1),(193,7442670,7442667,'lun',100,1),(193,7442671,7442670,'cmo',33.333,1),(193,7442672,7442670,'mod',33.333,1),(193,7442673,7442670,'ode',33.333,1),(193,7442674,7442671,'rev',16.667,1),(193,7442675,7442671,'evi',16.667,1),(193,7442676,7442671,'vis',16.667,1),(193,7442677,7442671,'isi',16.667,1),(193,7442678,7442671,'sio',16.667,1),(193,7442679,7442671,'ion',16.667,1),(193,7442680,7442674,'810',50,1),(193,7442681,7442674,'100',50,1),(193,7442682,7442680,'scs',50,1),(193,7442683,7442680,'csi',50,1),(193,7442684,7442682,'lev',33.333,1),(193,7442685,7442682,'eve',33.333,1),(193,7442686,7442682,'vel',33.333,1),(193,7442687,7442684,'pse',25,1),(193,7442688,7442684,'seu',25,1),(193,7442689,7442684,'eud',25,1),(193,7442690,7442684,'udo',25,1),(193,7442691,7442687,'fal',33.333,6),(193,7442692,7442687,'als',33.333,6),(193,7442693,7442687,'lse',33.333,6),(193,7442694,7442691,'sta',25,3),(193,7442695,7442691,'tat',25,3),(193,7442696,7442691,'atu',25,3),(193,7442697,7442691,'tus',25,3),(193,7442698,7442694,'rdm',100,1),(193,7442699,7442698,'cap',20,1),(193,7442700,7442698,'apa',20,1),(193,7442701,7442698,'pab',20,1),(193,7442702,7442698,'abl',20,1),(193,7442703,7442698,'ble',20,1),(193,7442704,7442699,'tru',50,1),(193,7442705,7442699,'rue',50,1),(193,7442706,7442704,'loc',33.333,1),(193,7442707,7442704,'oca',33.333,1),(193,7442708,7442704,'cal',33.333,1),(193,7442709,7442706,'rem',14.286,1),(193,7442710,7442706,'emo',14.286,1),(193,7442711,7442706,'mov',14.286,1),(193,7442712,7442706,'ova',14.286,1),(193,7442713,7442706,'vab',14.286,1),(193,7442714,7442706,'abl',14.286,1),(193,7442715,7442706,'ble',14.286,1),(193,7442716,7442709,'ssd',100,1),(193,7442717,7442716,'off',20,1),(193,7442718,7442716,'ffl',20,1),(193,7442719,7442716,'fli',20,1),(193,7442720,7442716,'lin',20,1),(193,7442721,7442716,'ine',20,1),(193,7442722,7442717,'per',11.111,1),(193,7442723,7442717,'ere',11.111,1),(193,7442724,7442717,'ren',11.111,1),(193,7442725,7442717,'enn',11.111,1),(193,7442726,7442717,'nni',11.111,1),(193,7442727,7442717,'nia',11.111,1),(193,7442728,7442717,'ial',11.111,1),(193,7442729,7442717,'all',11.111,1),(193,7442730,7442717,'lly',11.111,1),(193,7442731,7442722,'res',16.667,1),(193,7442732,7442722,'ese',16.667,1),(193,7442733,7442722,'ser',16.667,1),(193,7442734,7442722,'erv',16.667,1),(193,7442735,7442722,'rve',16.667,1),(193,7442736,7442722,'ved',16.667,1),(193,7442737,7442731,'thi',50,1),(193,7442738,7442731,'hin',50,1),(193,7442739,7442737,'pro',10,1),(193,7442740,7442737,'rov',10,1),(193,7442741,7442737,'ovi',10,1),(193,7442742,7442737,'vis',10,1),(193,7442743,7442737,'isi',10,1),(193,7442744,7442737,'sio',10,1),(193,7442745,7442737,'ion',10,1),(193,7442746,7442737,'oni',10,1),(193,7442747,7442737,'nin',10,1),(193,7442748,7442737,'ing',10,1),(193,7442749,7442739,'yes',100,1),(193,7442750,7442749,'att',16.667,1),(193,7442751,7442749,'tta',16.667,1),(193,7442752,7442749,'tac',16.667,1),(193,7442753,7442749,'ach',16.667,1),(193,7442754,7442749,'che',16.667,1),(193,7442755,7442749,'hed',16.667,1),(193,7442756,7442750,'fil',20,1),(193,7442757,7442750,'ilt',20,1),(193,7442758,7442750,'lte',20,1),(193,7442759,7442750,'ter',20,1),(193,7442760,7442750,'ers',20,1),(193,7442761,7442756,'vaa',50,1),(193,7442762,7442756,'aai',50,1),(193,7442763,7442761,'unk',20,1),(193,7442764,7442761,'nkn',20,1),(193,7442765,7442761,'kno',20,1),(193,7442766,7442761,'now',20,1),(193,7442767,7442761,'own',20,1),(193,7442768,7442763,'oth',33.333,1),(193,7442769,7442763,'the',33.333,1),(193,7442770,7442763,'her',33.333,1),(193,7442771,7442768,'uid',50,1),(193,7442772,7442768,'ids',50,1),(193,7442773,7442771,'vml',100,1),(193,7442774,7442773,'dis',20,1),(193,7442775,7442773,'isp',20,1),(193,7442776,7442773,'spl',20,1),(193,7442777,7442773,'pla',20,1),(193,7442778,7442773,'lay',20,1),(193,7442779,7442774,'nam',50,1),(193,7442780,7442774,'ame',50,1),(194,7442782,7442781,'net',25,3),(194,7442783,7442781,'eta',25,3),(194,7442784,7442781,'tap',25,3),(194,7442785,7442781,'app',25,3),(194,7442786,7442782,'fib',33.333,2),(194,7442787,7442782,'ibr',33.333,2),(194,7442788,7442782,'bre',33.333,2),(194,7442789,7442786,'cha',20,2),(194,7442790,7442786,'han',20,2),(194,7442791,7442786,'ann',20,2),(194,7442792,7442786,'nne',20,2),(194,7442793,7442786,'nel',20,2),(194,7442794,7442789,'dis',50,2),(194,7442795,7442789,'isk',50,2),(194,7442796,7442794,'naa',100,4),(194,7442797,7442796,'600',3.333,4),(194,7442798,7442796,'00a',3.333,4),(194,7442799,7442796,'0a0',3.333,4),(194,7442800,7442796,'a09',3.333,4),(194,7442801,7442796,'098',3.333,4),(194,7442802,7442796,'980',3.333,4),(194,7442803,7442796,'804',3.333,4),(194,7442804,7442796,'044',3.333,4),(194,7442805,7442796,'443',3.333,4),(194,7442806,7442796,'430',3.333,4),(194,7442807,7442796,'307',3.333,4),(194,7442808,7442796,'075',3.333,4),(194,7442809,7442796,'753',3.333,4),(194,7442810,7442796,'535',3.333,4),(194,7442811,7442796,'357',3.333,4),(194,7442812,7442796,'573',3.333,4),(194,7442813,7442796,'732',3.333,4),(194,7442814,7442796,'32b',3.333,4),(194,7442815,7442796,'2b3',3.333,4),(194,7442816,7442796,'b33',3.333,4),(194,7442817,7442796,'334',3.333,4),(194,7442818,7442796,'345',3.333,4),(194,7442819,7442796,'457',3.333,4),(194,7442820,7442796,'571',3.333,4),(194,7442821,7442796,'715',3.333,4),(194,7442822,7442796,'153',3.333,4),(194,7442823,7442796,'533',3.333,4),(194,7442824,7442796,'336',3.333,4),(194,7442825,7442796,'366',3.333,4),(194,7442826,7442796,'665',3.333,4),(194,7442827,7442797,'ser',25,1),(194,7442828,7442797,'eri',25,1),(194,7442829,7442797,'ria',25,1),(194,7442830,7442797,'ial',25,1),(194,7442831,7442827,'siz',50,1),(194,7442832,7442827,'ize',50,1),(194,7442833,7442831,'321',100,1),(194,7442834,7442833,'dev',25,1),(194,7442835,7442833,'evi',25,1),(194,7442836,7442833,'vic',25,1),(194,7442837,7442833,'ice',25,1),(194,7442838,7442834,'typ',50,1),(194,7442839,7442834,'ype',50,1),(194,7442840,7442838,'dir',10,1),(194,7442841,7442838,'ire',10,1),(194,7442842,7442838,'rec',10,1),(194,7442843,7442838,'ect',10,1),(194,7442844,7442838,'cta',10,1),(194,7442845,7442838,'tac',10,1),(194,7442846,7442838,'acc',10,1),(194,7442847,7442838,'cce',10,1),(194,7442848,7442838,'ces',10,1),(194,7442849,7442838,'ess',10,1),(194,7442850,7442840,'mul',14.286,1),(194,7442851,7442840,'ult',14.286,1),(194,7442852,7442840,'lti',14.286,1),(194,7442853,7442840,'tip',14.286,1),(194,7442854,7442840,'ipa',14.286,1),(194,7442855,7442840,'pat',14.286,1),(194,7442856,7442840,'ath',14.286,1),(194,7442857,7442850,'plu',25,1),(194,7442858,7442850,'lug',25,1),(194,7442859,7442850,'ugi',25,1),(194,7442860,7442850,'gin',25,1),(194,7442861,7442857,'nmp',100,1),(194,7442862,7442861,'dev',33.333,1),(194,7442863,7442861,'evf',33.333,1),(194,7442864,7442861,'vfs',33.333,1),(194,7442865,7442862,'pat',50,1),(194,7442866,7442862,'ath',50,1),(194,7442867,7442865,'vmf',50,1),(194,7442868,7442865,'mfs',50,1),(194,7442869,7442867,'dev',20,1),(194,7442870,7442867,'evi',20,1),(194,7442871,7442867,'vic',20,1),(194,7442872,7442867,'ice',20,1),(194,7442873,7442867,'ces',20,1),(194,7442874,7442869,'dis',33.333,1),(194,7442875,7442869,'isk',33.333,1),(194,7442876,7442869,'sks',33.333,1),(194,7442877,7442874,'ven',25,1),(194,7442878,7442874,'end',25,1),(194,7442879,7442874,'ndo',25,1),(194,7442880,7442874,'dor',25,1),(194,7442881,7442877,'mod',33.333,1),(194,7442882,7442877,'ode',33.333,1),(194,7442883,7442877,'del',33.333,1),(194,7442884,7442881,'lun',100,1),(194,7442885,7442884,'cmo',33.333,1),(194,7442886,7442884,'mod',33.333,1),(194,7442887,7442884,'ode',33.333,1),(194,7442888,7442885,'rev',16.667,1),(194,7442889,7442885,'evi',16.667,1),(194,7442890,7442885,'vis',16.667,1),(194,7442891,7442885,'isi',16.667,1),(194,7442892,7442885,'sio',16.667,1),(194,7442893,7442885,'ion',16.667,1),(194,7442894,7442888,'810',50,1),(194,7442895,7442888,'100',50,1),(194,7442896,7442894,'scs',50,1),(194,7442897,7442894,'csi',50,1),(194,7442898,7442896,'lev',33.333,1),(194,7442899,7442896,'eve',33.333,1),(194,7442900,7442896,'vel',33.333,1),(194,7442901,7442898,'pse',25,1),(194,7442902,7442898,'seu',25,1),(194,7442903,7442898,'eud',25,1),(194,7442904,7442898,'udo',25,1),(194,7442905,7442901,'fal',33.333,6),(194,7442906,7442901,'als',33.333,6),(194,7442907,7442901,'lse',33.333,6),(194,7442908,7442905,'sta',25,3),(194,7442909,7442905,'tat',25,3),(194,7442910,7442905,'atu',25,3),(194,7442911,7442905,'tus',25,3),(194,7442912,7442908,'rdm',100,1),(194,7442913,7442912,'cap',20,1),(194,7442914,7442912,'apa',20,1),(194,7442915,7442912,'pab',20,1),(194,7442916,7442912,'abl',20,1),(194,7442917,7442912,'ble',20,1),(194,7442918,7442913,'tru',50,1),(194,7442919,7442913,'rue',50,1),(194,7442920,7442918,'loc',33.333,1),(194,7442921,7442918,'oca',33.333,1),(194,7442922,7442918,'cal',33.333,1),(194,7442923,7442920,'rem',14.286,1),(194,7442924,7442920,'emo',14.286,1),(194,7442925,7442920,'mov',14.286,1),(194,7442926,7442920,'ova',14.286,1),(194,7442927,7442920,'vab',14.286,1),(194,7442928,7442920,'abl',14.286,1),(194,7442929,7442920,'ble',14.286,1),(194,7442930,7442923,'ssd',100,1),(194,7442931,7442930,'off',20,1),(194,7442932,7442930,'ffl',20,1),(194,7442933,7442930,'fli',20,1),(194,7442934,7442930,'lin',20,1),(194,7442935,7442930,'ine',20,1),(194,7442936,7442931,'per',11.111,1),(194,7442937,7442931,'ere',11.111,1),(194,7442938,7442931,'ren',11.111,1),(194,7442939,7442931,'enn',11.111,1),(194,7442940,7442931,'nni',11.111,1),(194,7442941,7442931,'nia',11.111,1),(194,7442942,7442931,'ial',11.111,1),(194,7442943,7442931,'all',11.111,1),(194,7442944,7442931,'lly',11.111,1),(194,7442945,7442936,'res',16.667,1),(194,7442946,7442936,'ese',16.667,1),(194,7442947,7442936,'ser',16.667,1),(194,7442948,7442936,'erv',16.667,1),(194,7442949,7442936,'rve',16.667,1),(194,7442950,7442936,'ved',16.667,1),(194,7442951,7442945,'thi',50,1),(194,7442952,7442945,'hin',50,1),(194,7442953,7442951,'pro',10,1),(194,7442954,7442951,'rov',10,1),(194,7442955,7442951,'ovi',10,1),(194,7442956,7442951,'vis',10,1),(194,7442957,7442951,'isi',10,1),(194,7442958,7442951,'sio',10,1),(194,7442959,7442951,'ion',10,1),(194,7442960,7442951,'oni',10,1),(194,7442961,7442951,'nin',10,1),(194,7442962,7442951,'ing',10,1),(194,7442963,7442953,'yes',100,1),(194,7442964,7442963,'att',16.667,1),(194,7442965,7442963,'tta',16.667,1),(194,7442966,7442963,'tac',16.667,1),(194,7442967,7442963,'ach',16.667,1),(194,7442968,7442963,'che',16.667,1),(194,7442969,7442963,'hed',16.667,1),(194,7442970,7442964,'fil',20,1),(194,7442971,7442964,'ilt',20,1),(194,7442972,7442964,'lte',20,1),(194,7442973,7442964,'ter',20,1),(194,7442974,7442964,'ers',20,1),(194,7442975,7442970,'vaa',50,1),(194,7442976,7442970,'aai',50,1),(194,7442977,7442975,'unk',20,1),(194,7442978,7442975,'nkn',20,1),(194,7442979,7442975,'kno',20,1),(194,7442980,7442975,'now',20,1),(194,7442981,7442975,'own',20,1),(194,7442982,7442977,'oth',33.333,1),(194,7442983,7442977,'the',33.333,1),(194,7442984,7442977,'her',33.333,1),(194,7442985,7442982,'uid',50,1),(194,7442986,7442982,'ids',50,1),(194,7442987,7442985,'vml',100,1),(194,7442988,7442987,'dis',20,1),(194,7442989,7442987,'isp',20,1),(194,7442990,7442987,'spl',20,1),(194,7442991,7442987,'pla',20,1),(194,7442992,7442987,'lay',20,1),(194,7442993,7442988,'nam',50,1),(194,7442994,7442988,'ame',50,1),(195,7442996,7442995,'net',25,3),(195,7442997,7442995,'eta',25,3),(195,7442998,7442995,'tap',25,3),(195,7442999,7442995,'app',25,3),(195,7443000,7442996,'fib',33.333,2),(195,7443001,7442996,'ibr',33.333,2),(195,7443002,7442996,'bre',33.333,2),(195,7443003,7443000,'cha',20,2),(195,7443004,7443000,'han',20,2),(195,7443005,7443000,'ann',20,2),(195,7443006,7443000,'nne',20,2),(195,7443007,7443000,'nel',20,2),(195,7443008,7443003,'dis',50,2),(195,7443009,7443003,'isk',50,2),(195,7443010,7443008,'naa',100,4),(195,7443011,7443010,'600',3.333,4),(195,7443012,7443010,'00a',3.333,4),(195,7443013,7443010,'0a0',3.333,4),(195,7443014,7443010,'a09',3.333,4),(195,7443015,7443010,'098',3.333,4),(195,7443016,7443010,'980',3.333,4),(195,7443017,7443010,'804',3.333,4),(195,7443018,7443010,'044',3.333,4),(195,7443019,7443010,'443',3.333,4),(195,7443020,7443010,'430',3.333,4),(195,7443021,7443010,'307',3.333,4),(195,7443022,7443010,'075',3.333,4),(195,7443023,7443010,'753',3.333,4),(195,7443024,7443010,'535',3.333,4),(195,7443025,7443010,'357',3.333,4),(195,7443026,7443010,'573',3.333,4),(195,7443027,7443010,'732',3.333,4),(195,7443028,7443010,'32b',3.333,4),(195,7443029,7443010,'2b3',3.333,4),(195,7443030,7443010,'b33',3.333,4),(195,7443031,7443010,'334',3.333,4),(195,7443032,7443010,'345',3.333,4),(195,7443033,7443010,'457',3.333,4),(195,7443034,7443010,'571',3.333,4),(195,7443035,7443010,'715',3.333,4),(195,7443036,7443010,'153',3.333,4),(195,7443037,7443010,'533',3.333,4),(195,7443038,7443010,'336',3.333,4),(195,7443039,7443010,'366',3.333,4),(195,7443040,7443010,'666',3.333,4),(195,7443041,7443011,'ser',25,1),(195,7443042,7443011,'eri',25,1),(195,7443043,7443011,'ria',25,1),(195,7443044,7443011,'ial',25,1),(195,7443045,7443041,'siz',50,1),(195,7443046,7443041,'ize',50,1),(195,7443047,7443045,'321',100,1),(195,7443048,7443047,'dev',25,1),(195,7443049,7443047,'evi',25,1),(195,7443050,7443047,'vic',25,1),(195,7443051,7443047,'ice',25,1),(195,7443052,7443048,'typ',50,1),(195,7443053,7443048,'ype',50,1),(195,7443054,7443052,'dir',10,1),(195,7443055,7443052,'ire',10,1),(195,7443056,7443052,'rec',10,1),(195,7443057,7443052,'ect',10,1),(195,7443058,7443052,'cta',10,1),(195,7443059,7443052,'tac',10,1),(195,7443060,7443052,'acc',10,1),(195,7443061,7443052,'cce',10,1),(195,7443062,7443052,'ces',10,1),(195,7443063,7443052,'ess',10,1),(195,7443064,7443054,'mul',14.286,1),(195,7443065,7443054,'ult',14.286,1),(195,7443066,7443054,'lti',14.286,1),(195,7443067,7443054,'tip',14.286,1),(195,7443068,7443054,'ipa',14.286,1),(195,7443069,7443054,'pat',14.286,1),(195,7443070,7443054,'ath',14.286,1),(195,7443071,7443064,'plu',25,1),(195,7443072,7443064,'lug',25,1),(195,7443073,7443064,'ugi',25,1),(195,7443074,7443064,'gin',25,1),(195,7443075,7443071,'nmp',100,1),(195,7443076,7443075,'dev',33.333,1),(195,7443077,7443075,'evf',33.333,1),(195,7443078,7443075,'vfs',33.333,1),(195,7443079,7443076,'pat',50,1),(195,7443080,7443076,'ath',50,1),(195,7443081,7443079,'vmf',50,1),(195,7443082,7443079,'mfs',50,1),(195,7443083,7443081,'dev',20,1),(195,7443084,7443081,'evi',20,1),(195,7443085,7443081,'vic',20,1),(195,7443086,7443081,'ice',20,1),(195,7443087,7443081,'ces',20,1),(195,7443088,7443083,'dis',33.333,1),(195,7443089,7443083,'isk',33.333,1),(195,7443090,7443083,'sks',33.333,1),(195,7443091,7443088,'ven',25,1),(195,7443092,7443088,'end',25,1),(195,7443093,7443088,'ndo',25,1),(195,7443094,7443088,'dor',25,1),(195,7443095,7443091,'mod',33.333,1),(195,7443096,7443091,'ode',33.333,1),(195,7443097,7443091,'del',33.333,1),(195,7443098,7443095,'lun',100,1),(195,7443099,7443098,'cmo',33.333,1),(195,7443100,7443098,'mod',33.333,1),(195,7443101,7443098,'ode',33.333,1),(195,7443102,7443099,'rev',16.667,1),(195,7443103,7443099,'evi',16.667,1),(195,7443104,7443099,'vis',16.667,1),(195,7443105,7443099,'isi',16.667,1),(195,7443106,7443099,'sio',16.667,1),(195,7443107,7443099,'ion',16.667,1),(195,7443108,7443102,'810',50,1),(195,7443109,7443102,'100',50,1),(195,7443110,7443108,'scs',50,1),(195,7443111,7443108,'csi',50,1),(195,7443112,7443110,'lev',33.333,1),(195,7443113,7443110,'eve',33.333,1),(195,7443114,7443110,'vel',33.333,1),(195,7443115,7443112,'pse',25,1),(195,7443116,7443112,'seu',25,1),(195,7443117,7443112,'eud',25,1),(195,7443118,7443112,'udo',25,1),(195,7443119,7443115,'fal',33.333,6),(195,7443120,7443115,'als',33.333,6),(195,7443121,7443115,'lse',33.333,6),(195,7443122,7443119,'sta',25,3),(195,7443123,7443119,'tat',25,3),(195,7443124,7443119,'atu',25,3),(195,7443125,7443119,'tus',25,3),(195,7443126,7443122,'rdm',100,1),(195,7443127,7443126,'cap',20,1),(195,7443128,7443126,'apa',20,1),(195,7443129,7443126,'pab',20,1),(195,7443130,7443126,'abl',20,1),(195,7443131,7443126,'ble',20,1),(195,7443132,7443127,'tru',50,1),(195,7443133,7443127,'rue',50,1),(195,7443134,7443132,'loc',33.333,1),(195,7443135,7443132,'oca',33.333,1),(195,7443136,7443132,'cal',33.333,1),(195,7443137,7443134,'rem',14.286,1),(195,7443138,7443134,'emo',14.286,1),(195,7443139,7443134,'mov',14.286,1),(195,7443140,7443134,'ova',14.286,1),(195,7443141,7443134,'vab',14.286,1),(195,7443142,7443134,'abl',14.286,1),(195,7443143,7443134,'ble',14.286,1),(195,7443144,7443137,'ssd',100,1),(195,7443145,7443144,'off',20,1),(195,7443146,7443144,'ffl',20,1),(195,7443147,7443144,'fli',20,1),(195,7443148,7443144,'lin',20,1),(195,7443149,7443144,'ine',20,1),(195,7443150,7443145,'per',11.111,1),(195,7443151,7443145,'ere',11.111,1),(195,7443152,7443145,'ren',11.111,1),(195,7443153,7443145,'enn',11.111,1),(195,7443154,7443145,'nni',11.111,1),(195,7443155,7443145,'nia',11.111,1),(195,7443156,7443145,'ial',11.111,1),(195,7443157,7443145,'all',11.111,1),(195,7443158,7443145,'lly',11.111,1),(195,7443159,7443150,'res',16.667,1),(195,7443160,7443150,'ese',16.667,1),(195,7443161,7443150,'ser',16.667,1),(195,7443162,7443150,'erv',16.667,1),(195,7443163,7443150,'rve',16.667,1),(195,7443164,7443150,'ved',16.667,1),(195,7443165,7443159,'thi',50,1),(195,7443166,7443159,'hin',50,1),(195,7443167,7443165,'pro',10,1),(195,7443168,7443165,'rov',10,1),(195,7443169,7443165,'ovi',10,1),(195,7443170,7443165,'vis',10,1),(195,7443171,7443165,'isi',10,1),(195,7443172,7443165,'sio',10,1),(195,7443173,7443165,'ion',10,1),(195,7443174,7443165,'oni',10,1),(195,7443175,7443165,'nin',10,1),(195,7443176,7443165,'ing',10,1),(195,7443177,7443167,'yes',100,1),(195,7443178,7443177,'att',16.667,1),(195,7443179,7443177,'tta',16.667,1),(195,7443180,7443177,'tac',16.667,1),(195,7443181,7443177,'ach',16.667,1),(195,7443182,7443177,'che',16.667,1),(195,7443183,7443177,'hed',16.667,1),(195,7443184,7443178,'fil',20,1),(195,7443185,7443178,'ilt',20,1),(195,7443186,7443178,'lte',20,1),(195,7443187,7443178,'ter',20,1),(195,7443188,7443178,'ers',20,1),(195,7443189,7443184,'vaa',50,1),(195,7443190,7443184,'aai',50,1),(195,7443191,7443189,'unk',20,1),(195,7443192,7443189,'nkn',20,1),(195,7443193,7443189,'kno',20,1),(195,7443194,7443189,'now',20,1),(195,7443195,7443189,'own',20,1),(195,7443196,7443191,'oth',33.333,1),(195,7443197,7443191,'the',33.333,1),(195,7443198,7443191,'her',33.333,1),(195,7443199,7443196,'uid',50,1),(195,7443200,7443196,'ids',50,1),(195,7443201,7443199,'vml',100,1),(195,7443202,7443201,'dis',20,1),(195,7443203,7443201,'isp',20,1),(195,7443204,7443201,'spl',20,1),(195,7443205,7443201,'pla',20,1),(195,7443206,7443201,'lay',20,1),(195,7443207,7443202,'nam',50,1),(195,7443208,7443202,'ame',50,1),(196,7443210,7443209,'net',25,3),(196,7443211,7443209,'eta',25,3),(196,7443212,7443209,'tap',25,3),(196,7443213,7443209,'app',25,3),(196,7443214,7443210,'fib',33.333,2),(196,7443215,7443210,'ibr',33.333,2),(196,7443216,7443210,'bre',33.333,2),(196,7443217,7443214,'cha',20,2),(196,7443218,7443214,'han',20,2),(196,7443219,7443214,'ann',20,2),(196,7443220,7443214,'nne',20,2),(196,7443221,7443214,'nel',20,2),(196,7443222,7443217,'dis',50,2),(196,7443223,7443217,'isk',50,2),(196,7443224,7443222,'naa',100,4),(196,7443225,7443224,'600',3.333,4),(196,7443226,7443224,'00a',3.333,4),(196,7443227,7443224,'0a0',3.333,4),(196,7443228,7443224,'a09',3.333,4),(196,7443229,7443224,'098',3.333,4),(196,7443230,7443224,'980',3.333,4),(196,7443231,7443224,'804',3.333,4),(196,7443232,7443224,'044',3.333,4),(196,7443233,7443224,'443',3.333,4),(196,7443234,7443224,'430',3.333,4),(196,7443235,7443224,'307',3.333,4),(196,7443236,7443224,'075',3.333,4),(196,7443237,7443224,'753',3.333,4),(196,7443238,7443224,'535',3.333,4),(196,7443239,7443224,'357',3.333,4),(196,7443240,7443224,'573',3.333,4),(196,7443241,7443224,'732',3.333,4),(196,7443242,7443224,'32b',3.333,4),(196,7443243,7443224,'2b3',3.333,4),(196,7443244,7443224,'b33',3.333,4),(196,7443245,7443224,'334',3.333,4),(196,7443246,7443224,'345',3.333,4),(196,7443247,7443224,'457',3.333,4),(196,7443248,7443224,'571',3.333,4),(196,7443249,7443224,'715',3.333,4),(196,7443250,7443224,'153',3.333,4),(196,7443251,7443224,'533',3.333,4),(196,7443252,7443224,'336',3.333,4),(196,7443253,7443224,'366',3.333,4),(196,7443254,7443224,'667',3.333,4),(196,7443255,7443225,'ser',25,1),(196,7443256,7443225,'eri',25,1),(196,7443257,7443225,'ria',25,1),(196,7443258,7443225,'ial',25,1),(196,7443259,7443255,'siz',50,1),(196,7443260,7443255,'ize',50,1),(196,7443261,7443259,'321',100,1),(196,7443262,7443261,'dev',25,1),(196,7443263,7443261,'evi',25,1),(196,7443264,7443261,'vic',25,1),(196,7443265,7443261,'ice',25,1),(196,7443266,7443262,'typ',50,1),(196,7443267,7443262,'ype',50,1),(196,7443268,7443266,'dir',10,1),(196,7443269,7443266,'ire',10,1),(196,7443270,7443266,'rec',10,1),(196,7443271,7443266,'ect',10,1),(196,7443272,7443266,'cta',10,1),(196,7443273,7443266,'tac',10,1),(196,7443274,7443266,'acc',10,1),(196,7443275,7443266,'cce',10,1),(196,7443276,7443266,'ces',10,1),(196,7443277,7443266,'ess',10,1),(196,7443278,7443268,'mul',14.286,1),(196,7443279,7443268,'ult',14.286,1),(196,7443280,7443268,'lti',14.286,1),(196,7443281,7443268,'tip',14.286,1),(196,7443282,7443268,'ipa',14.286,1),(196,7443283,7443268,'pat',14.286,1),(196,7443284,7443268,'ath',14.286,1),(196,7443285,7443278,'plu',25,1),(196,7443286,7443278,'lug',25,1),(196,7443287,7443278,'ugi',25,1),(196,7443288,7443278,'gin',25,1),(196,7443289,7443285,'nmp',100,1),(196,7443290,7443289,'dev',33.333,1),(196,7443291,7443289,'evf',33.333,1),(196,7443292,7443289,'vfs',33.333,1),(196,7443293,7443290,'pat',50,1),(196,7443294,7443290,'ath',50,1),(196,7443295,7443293,'vmf',50,1),(196,7443296,7443293,'mfs',50,1),(196,7443297,7443295,'dev',20,1),(196,7443298,7443295,'evi',20,1),(196,7443299,7443295,'vic',20,1),(196,7443300,7443295,'ice',20,1),(196,7443301,7443295,'ces',20,1),(196,7443302,7443297,'dis',33.333,1),(196,7443303,7443297,'isk',33.333,1),(196,7443304,7443297,'sks',33.333,1),(196,7443305,7443302,'ven',25,1),(196,7443306,7443302,'end',25,1),(196,7443307,7443302,'ndo',25,1),(196,7443308,7443302,'dor',25,1),(196,7443309,7443305,'mod',33.333,1),(196,7443310,7443305,'ode',33.333,1),(196,7443311,7443305,'del',33.333,1),(196,7443312,7443309,'lun',100,1),(196,7443313,7443312,'cmo',33.333,1),(196,7443314,7443312,'mod',33.333,1),(196,7443315,7443312,'ode',33.333,1),(196,7443316,7443313,'rev',16.667,1),(196,7443317,7443313,'evi',16.667,1),(196,7443318,7443313,'vis',16.667,1),(196,7443319,7443313,'isi',16.667,1),(196,7443320,7443313,'sio',16.667,1),(196,7443321,7443313,'ion',16.667,1),(196,7443322,7443316,'810',50,1),(196,7443323,7443316,'100',50,1),(196,7443324,7443322,'scs',50,1),(196,7443325,7443322,'csi',50,1),(196,7443326,7443324,'lev',33.333,1),(196,7443327,7443324,'eve',33.333,1),(196,7443328,7443324,'vel',33.333,1),(196,7443329,7443326,'pse',25,1),(196,7443330,7443326,'seu',25,1),(196,7443331,7443326,'eud',25,1),(196,7443332,7443326,'udo',25,1),(196,7443333,7443329,'fal',33.333,6),(196,7443334,7443329,'als',33.333,6),(196,7443335,7443329,'lse',33.333,6),(196,7443336,7443333,'sta',25,3),(196,7443337,7443333,'tat',25,3),(196,7443338,7443333,'atu',25,3),(196,7443339,7443333,'tus',25,3),(196,7443340,7443336,'rdm',100,1),(196,7443341,7443340,'cap',20,1),(196,7443342,7443340,'apa',20,1),(196,7443343,7443340,'pab',20,1),(196,7443344,7443340,'abl',20,1),(196,7443345,7443340,'ble',20,1),(196,7443346,7443341,'tru',50,1),(196,7443347,7443341,'rue',50,1),(196,7443348,7443346,'loc',33.333,1),(196,7443349,7443346,'oca',33.333,1),(196,7443350,7443346,'cal',33.333,1),(196,7443351,7443348,'rem',14.286,1),(196,7443352,7443348,'emo',14.286,1),(196,7443353,7443348,'mov',14.286,1),(196,7443354,7443348,'ova',14.286,1),(196,7443355,7443348,'vab',14.286,1),(196,7443356,7443348,'abl',14.286,1),(196,7443357,7443348,'ble',14.286,1),(196,7443358,7443351,'ssd',100,1),(196,7443359,7443358,'off',20,1),(196,7443360,7443358,'ffl',20,1),(196,7443361,7443358,'fli',20,1),(196,7443362,7443358,'lin',20,1),(196,7443363,7443358,'ine',20,1),(196,7443364,7443359,'per',11.111,1),(196,7443365,7443359,'ere',11.111,1),(196,7443366,7443359,'ren',11.111,1),(196,7443367,7443359,'enn',11.111,1),(196,7443368,7443359,'nni',11.111,1),(196,7443369,7443359,'nia',11.111,1),(196,7443370,7443359,'ial',11.111,1),(196,7443371,7443359,'all',11.111,1),(196,7443372,7443359,'lly',11.111,1),(196,7443373,7443364,'res',16.667,1),(196,7443374,7443364,'ese',16.667,1),(196,7443375,7443364,'ser',16.667,1),(196,7443376,7443364,'erv',16.667,1),(196,7443377,7443364,'rve',16.667,1),(196,7443378,7443364,'ved',16.667,1),(196,7443379,7443373,'thi',50,1),(196,7443380,7443373,'hin',50,1),(196,7443381,7443379,'pro',10,1),(196,7443382,7443379,'rov',10,1),(196,7443383,7443379,'ovi',10,1),(196,7443384,7443379,'vis',10,1),(196,7443385,7443379,'isi',10,1),(196,7443386,7443379,'sio',10,1),(196,7443387,7443379,'ion',10,1),(196,7443388,7443379,'oni',10,1),(196,7443389,7443379,'nin',10,1),(196,7443390,7443379,'ing',10,1),(196,7443391,7443381,'yes',100,1),(196,7443392,7443391,'att',16.667,1),(196,7443393,7443391,'tta',16.667,1),(196,7443394,7443391,'tac',16.667,1),(196,7443395,7443391,'ach',16.667,1),(196,7443396,7443391,'che',16.667,1),(196,7443397,7443391,'hed',16.667,1),(196,7443398,7443392,'fil',20,1),(196,7443399,7443392,'ilt',20,1),(196,7443400,7443392,'lte',20,1),(196,7443401,7443392,'ter',20,1),(196,7443402,7443392,'ers',20,1),(196,7443403,7443398,'vaa',50,1),(196,7443404,7443398,'aai',50,1),(196,7443405,7443403,'unk',20,1),(196,7443406,7443403,'nkn',20,1),(196,7443407,7443403,'kno',20,1),(196,7443408,7443403,'now',20,1),(196,7443409,7443403,'own',20,1),(196,7443410,7443405,'oth',33.333,1),(196,7443411,7443405,'the',33.333,1),(196,7443412,7443405,'her',33.333,1),(196,7443413,7443410,'uid',50,1),(196,7443414,7443410,'ids',50,1),(196,7443415,7443413,'vml',100,1),(196,7443416,7443415,'dis',20,1),(196,7443417,7443415,'isp',20,1),(196,7443418,7443415,'spl',20,1),(196,7443419,7443415,'pla',20,1),(196,7443420,7443415,'lay',20,1),(196,7443421,7443416,'nam',50,1),(196,7443422,7443416,'ame',50,1),(197,7443424,7443423,'net',25,3),(197,7443425,7443423,'eta',25,3),(197,7443426,7443423,'tap',25,3),(197,7443427,7443423,'app',25,3),(197,7443428,7443424,'fib',33.333,2),(197,7443429,7443424,'ibr',33.333,2),(197,7443430,7443424,'bre',33.333,2),(197,7443431,7443428,'cha',20,2),(197,7443432,7443428,'han',20,2),(197,7443433,7443428,'ann',20,2),(197,7443434,7443428,'nne',20,2),(197,7443435,7443428,'nel',20,2),(197,7443436,7443431,'dis',50,2),(197,7443437,7443431,'isk',50,2),(197,7443438,7443436,'naa',100,4),(197,7443439,7443438,'600',3.333,4),(197,7443440,7443438,'00a',3.333,4),(197,7443441,7443438,'0a0',3.333,4),(197,7443442,7443438,'a09',3.333,4),(197,7443443,7443438,'098',3.333,4),(197,7443444,7443438,'980',3.333,4),(197,7443445,7443438,'804',3.333,4),(197,7443446,7443438,'044',3.333,4),(197,7443447,7443438,'443',3.333,4),(197,7443448,7443438,'430',3.333,4),(197,7443449,7443438,'307',3.333,4),(197,7443450,7443438,'075',3.333,4),(197,7443451,7443438,'753',3.333,4),(197,7443452,7443438,'535',3.333,4),(197,7443453,7443438,'357',3.333,4),(197,7443454,7443438,'573',3.333,4),(197,7443455,7443438,'732',3.333,4),(197,7443456,7443438,'32b',3.333,4),(197,7443457,7443438,'2b3',3.333,4),(197,7443458,7443438,'b33',3.333,4),(197,7443459,7443438,'334',3.333,4),(197,7443460,7443438,'345',3.333,4),(197,7443461,7443438,'457',3.333,4),(197,7443462,7443438,'571',3.333,4),(197,7443463,7443438,'715',3.333,4),(197,7443464,7443438,'153',3.333,4),(197,7443465,7443438,'533',3.333,4),(197,7443466,7443438,'336',3.333,4),(197,7443467,7443438,'366',3.333,4),(197,7443468,7443438,'668',3.333,4),(197,7443469,7443439,'ser',25,1),(197,7443470,7443439,'eri',25,1),(197,7443471,7443439,'ria',25,1),(197,7443472,7443439,'ial',25,1),(197,7443473,7443469,'siz',50,1),(197,7443474,7443469,'ize',50,1),(197,7443475,7443473,'321',100,1),(197,7443476,7443475,'dev',25,1),(197,7443477,7443475,'evi',25,1),(197,7443478,7443475,'vic',25,1),(197,7443479,7443475,'ice',25,1),(197,7443480,7443476,'typ',50,1),(197,7443481,7443476,'ype',50,1),(197,7443482,7443480,'dir',10,1),(197,7443483,7443480,'ire',10,1),(197,7443484,7443480,'rec',10,1),(197,7443485,7443480,'ect',10,1),(197,7443486,7443480,'cta',10,1),(197,7443487,7443480,'tac',10,1),(197,7443488,7443480,'acc',10,1),(197,7443489,7443480,'cce',10,1),(197,7443490,7443480,'ces',10,1),(197,7443491,7443480,'ess',10,1),(197,7443492,7443482,'mul',14.286,1),(197,7443493,7443482,'ult',14.286,1),(197,7443494,7443482,'lti',14.286,1),(197,7443495,7443482,'tip',14.286,1),(197,7443496,7443482,'ipa',14.286,1),(197,7443497,7443482,'pat',14.286,1),(197,7443498,7443482,'ath',14.286,1),(197,7443499,7443492,'plu',25,1),(197,7443500,7443492,'lug',25,1),(197,7443501,7443492,'ugi',25,1),(197,7443502,7443492,'gin',25,1),(197,7443503,7443499,'nmp',100,1),(197,7443504,7443503,'dev',33.333,1),(197,7443505,7443503,'evf',33.333,1),(197,7443506,7443503,'vfs',33.333,1),(197,7443507,7443504,'pat',50,1),(197,7443508,7443504,'ath',50,1),(197,7443509,7443507,'vmf',50,1),(197,7443510,7443507,'mfs',50,1),(197,7443511,7443509,'dev',20,1),(197,7443512,7443509,'evi',20,1),(197,7443513,7443509,'vic',20,1),(197,7443514,7443509,'ice',20,1),(197,7443515,7443509,'ces',20,1),(197,7443516,7443511,'dis',33.333,1),(197,7443517,7443511,'isk',33.333,1),(197,7443518,7443511,'sks',33.333,1),(197,7443519,7443516,'ven',25,1),(197,7443520,7443516,'end',25,1),(197,7443521,7443516,'ndo',25,1),(197,7443522,7443516,'dor',25,1),(197,7443523,7443519,'mod',33.333,1),(197,7443524,7443519,'ode',33.333,1),(197,7443525,7443519,'del',33.333,1),(197,7443526,7443523,'lun',100,1),(197,7443527,7443526,'cmo',33.333,1),(197,7443528,7443526,'mod',33.333,1),(197,7443529,7443526,'ode',33.333,1),(197,7443530,7443527,'rev',16.667,1),(197,7443531,7443527,'evi',16.667,1),(197,7443532,7443527,'vis',16.667,1),(197,7443533,7443527,'isi',16.667,1),(197,7443534,7443527,'sio',16.667,1),(197,7443535,7443527,'ion',16.667,1),(197,7443536,7443530,'810',50,1),(197,7443537,7443530,'100',50,1),(197,7443538,7443536,'scs',50,1),(197,7443539,7443536,'csi',50,1),(197,7443540,7443538,'lev',33.333,1),(197,7443541,7443538,'eve',33.333,1),(197,7443542,7443538,'vel',33.333,1),(197,7443543,7443540,'pse',25,1),(197,7443544,7443540,'seu',25,1),(197,7443545,7443540,'eud',25,1),(197,7443546,7443540,'udo',25,1),(197,7443547,7443543,'fal',33.333,6),(197,7443548,7443543,'als',33.333,6),(197,7443549,7443543,'lse',33.333,6),(197,7443550,7443547,'sta',25,3),(197,7443551,7443547,'tat',25,3),(197,7443552,7443547,'atu',25,3),(197,7443553,7443547,'tus',25,3),(197,7443554,7443550,'rdm',100,1),(197,7443555,7443554,'cap',20,1),(197,7443556,7443554,'apa',20,1),(197,7443557,7443554,'pab',20,1),(197,7443558,7443554,'abl',20,1),(197,7443559,7443554,'ble',20,1),(197,7443560,7443555,'tru',50,1),(197,7443561,7443555,'rue',50,1),(197,7443562,7443560,'loc',33.333,1),(197,7443563,7443560,'oca',33.333,1),(197,7443564,7443560,'cal',33.333,1),(197,7443565,7443562,'rem',14.286,1),(197,7443566,7443562,'emo',14.286,1),(197,7443567,7443562,'mov',14.286,1),(197,7443568,7443562,'ova',14.286,1),(197,7443569,7443562,'vab',14.286,1),(197,7443570,7443562,'abl',14.286,1),(197,7443571,7443562,'ble',14.286,1),(197,7443572,7443565,'ssd',100,1),(197,7443573,7443572,'off',20,1),(197,7443574,7443572,'ffl',20,1),(197,7443575,7443572,'fli',20,1),(197,7443576,7443572,'lin',20,1),(197,7443577,7443572,'ine',20,1),(197,7443578,7443573,'per',11.111,1),(197,7443579,7443573,'ere',11.111,1),(197,7443580,7443573,'ren',11.111,1),(197,7443581,7443573,'enn',11.111,1),(197,7443582,7443573,'nni',11.111,1),(197,7443583,7443573,'nia',11.111,1),(197,7443584,7443573,'ial',11.111,1),(197,7443585,7443573,'all',11.111,1),(197,7443586,7443573,'lly',11.111,1),(197,7443587,7443578,'res',16.667,1),(197,7443588,7443578,'ese',16.667,1),(197,7443589,7443578,'ser',16.667,1),(197,7443590,7443578,'erv',16.667,1),(197,7443591,7443578,'rve',16.667,1),(197,7443592,7443578,'ved',16.667,1),(197,7443593,7443587,'thi',50,1),(197,7443594,7443587,'hin',50,1),(197,7443595,7443593,'pro',10,1),(197,7443596,7443593,'rov',10,1),(197,7443597,7443593,'ovi',10,1),(197,7443598,7443593,'vis',10,1),(197,7443599,7443593,'isi',10,1),(197,7443600,7443593,'sio',10,1),(197,7443601,7443593,'ion',10,1),(197,7443602,7443593,'oni',10,1),(197,7443603,7443593,'nin',10,1),(197,7443604,7443593,'ing',10,1),(197,7443605,7443595,'yes',100,1),(197,7443606,7443605,'att',16.667,1),(197,7443607,7443605,'tta',16.667,1),(197,7443608,7443605,'tac',16.667,1),(197,7443609,7443605,'ach',16.667,1),(197,7443610,7443605,'che',16.667,1),(197,7443611,7443605,'hed',16.667,1),(197,7443612,7443606,'fil',20,1),(197,7443613,7443606,'ilt',20,1),(197,7443614,7443606,'lte',20,1),(197,7443615,7443606,'ter',20,1),(197,7443616,7443606,'ers',20,1),(197,7443617,7443612,'vaa',50,1),(197,7443618,7443612,'aai',50,1),(197,7443619,7443617,'unk',20,1),(197,7443620,7443617,'nkn',20,1),(197,7443621,7443617,'kno',20,1),(197,7443622,7443617,'now',20,1),(197,7443623,7443617,'own',20,1),(197,7443624,7443619,'oth',33.333,1),(197,7443625,7443619,'the',33.333,1),(197,7443626,7443619,'her',33.333,1),(197,7443627,7443624,'uid',50,1),(197,7443628,7443624,'ids',50,1),(197,7443629,7443627,'vml',100,1),(197,7443630,7443629,'dis',20,1),(197,7443631,7443629,'isp',20,1),(197,7443632,7443629,'spl',20,1),(197,7443633,7443629,'pla',20,1),(197,7443634,7443629,'lay',20,1),(197,7443635,7443630,'nam',50,1),(197,7443636,7443630,'ame',50,1),(198,7443638,7443637,'net',25,3),(198,7443639,7443637,'eta',25,3),(198,7443640,7443637,'tap',25,3),(198,7443641,7443637,'app',25,3),(198,7443642,7443638,'fib',33.333,2),(198,7443643,7443638,'ibr',33.333,2),(198,7443644,7443638,'bre',33.333,2),(198,7443645,7443642,'cha',20,2),(198,7443646,7443642,'han',20,2),(198,7443647,7443642,'ann',20,2),(198,7443648,7443642,'nne',20,2),(198,7443649,7443642,'nel',20,2),(198,7443650,7443645,'dis',50,2),(198,7443651,7443645,'isk',50,2),(198,7443652,7443650,'naa',100,4),(198,7443653,7443652,'600',3.333,4),(198,7443654,7443652,'00a',3.333,4),(198,7443655,7443652,'0a0',3.333,4),(198,7443656,7443652,'a09',3.333,4),(198,7443657,7443652,'098',3.333,4),(198,7443658,7443652,'980',3.333,4),(198,7443659,7443652,'804',3.333,4),(198,7443660,7443652,'044',3.333,4),(198,7443661,7443652,'443',3.333,4),(198,7443662,7443652,'430',3.333,4),(198,7443663,7443652,'307',3.333,4),(198,7443664,7443652,'075',3.333,4),(198,7443665,7443652,'753',3.333,4),(198,7443666,7443652,'535',3.333,4),(198,7443667,7443652,'357',3.333,4),(198,7443668,7443652,'573',3.333,4),(198,7443669,7443652,'732',3.333,4),(198,7443670,7443652,'32b',3.333,4),(198,7443671,7443652,'2b3',3.333,4),(198,7443672,7443652,'b33',3.333,4),(198,7443673,7443652,'334',3.333,4),(198,7443674,7443652,'345',3.333,4),(198,7443675,7443652,'457',3.333,4),(198,7443676,7443652,'571',3.333,4),(198,7443677,7443652,'715',3.333,4),(198,7443678,7443652,'153',3.333,4),(198,7443679,7443652,'533',3.333,4),(198,7443680,7443652,'336',3.333,4),(198,7443681,7443652,'366',3.333,4),(198,7443682,7443652,'669',3.333,4),(198,7443683,7443653,'ser',25,1),(198,7443684,7443653,'eri',25,1),(198,7443685,7443653,'ria',25,1),(198,7443686,7443653,'ial',25,1),(198,7443687,7443683,'siz',50,1),(198,7443688,7443683,'ize',50,1),(198,7443689,7443687,'321',100,1),(198,7443690,7443689,'dev',25,1),(198,7443691,7443689,'evi',25,1),(198,7443692,7443689,'vic',25,1),(198,7443693,7443689,'ice',25,1),(198,7443694,7443690,'typ',50,1),(198,7443695,7443690,'ype',50,1),(198,7443696,7443694,'dir',10,1),(198,7443697,7443694,'ire',10,1),(198,7443698,7443694,'rec',10,1),(198,7443699,7443694,'ect',10,1),(198,7443700,7443694,'cta',10,1),(198,7443701,7443694,'tac',10,1),(198,7443702,7443694,'acc',10,1),(198,7443703,7443694,'cce',10,1),(198,7443704,7443694,'ces',10,1),(198,7443705,7443694,'ess',10,1),(198,7443706,7443696,'mul',14.286,1),(198,7443707,7443696,'ult',14.286,1),(198,7443708,7443696,'lti',14.286,1),(198,7443709,7443696,'tip',14.286,1),(198,7443710,7443696,'ipa',14.286,1),(198,7443711,7443696,'pat',14.286,1),(198,7443712,7443696,'ath',14.286,1),(198,7443713,7443706,'plu',25,1),(198,7443714,7443706,'lug',25,1),(198,7443715,7443706,'ugi',25,1),(198,7443716,7443706,'gin',25,1),(198,7443717,7443713,'nmp',100,1),(198,7443718,7443717,'dev',33.333,1),(198,7443719,7443717,'evf',33.333,1),(198,7443720,7443717,'vfs',33.333,1),(198,7443721,7443718,'pat',50,1),(198,7443722,7443718,'ath',50,1),(198,7443723,7443721,'vmf',50,1),(198,7443724,7443721,'mfs',50,1),(198,7443725,7443723,'dev',20,1),(198,7443726,7443723,'evi',20,1),(198,7443727,7443723,'vic',20,1),(198,7443728,7443723,'ice',20,1),(198,7443729,7443723,'ces',20,1),(198,7443730,7443725,'dis',33.333,1),(198,7443731,7443725,'isk',33.333,1),(198,7443732,7443725,'sks',33.333,1),(198,7443733,7443730,'ven',25,1),(198,7443734,7443730,'end',25,1),(198,7443735,7443730,'ndo',25,1),(198,7443736,7443730,'dor',25,1),(198,7443737,7443733,'mod',33.333,1),(198,7443738,7443733,'ode',33.333,1),(198,7443739,7443733,'del',33.333,1),(198,7443740,7443737,'lun',100,1),(198,7443741,7443740,'cmo',33.333,1),(198,7443742,7443740,'mod',33.333,1),(198,7443743,7443740,'ode',33.333,1),(198,7443744,7443741,'rev',16.667,1),(198,7443745,7443741,'evi',16.667,1),(198,7443746,7443741,'vis',16.667,1),(198,7443747,7443741,'isi',16.667,1),(198,7443748,7443741,'sio',16.667,1),(198,7443749,7443741,'ion',16.667,1),(198,7443750,7443744,'810',50,1),(198,7443751,7443744,'100',50,1),(198,7443752,7443750,'scs',50,1),(198,7443753,7443750,'csi',50,1),(198,7443754,7443752,'lev',33.333,1),(198,7443755,7443752,'eve',33.333,1),(198,7443756,7443752,'vel',33.333,1),(198,7443757,7443754,'pse',25,1),(198,7443758,7443754,'seu',25,1),(198,7443759,7443754,'eud',25,1),(198,7443760,7443754,'udo',25,1),(198,7443761,7443757,'fal',33.333,6),(198,7443762,7443757,'als',33.333,6),(198,7443763,7443757,'lse',33.333,6),(198,7443764,7443761,'sta',25,3),(198,7443765,7443761,'tat',25,3),(198,7443766,7443761,'atu',25,3),(198,7443767,7443761,'tus',25,3),(198,7443768,7443764,'rdm',100,1),(198,7443769,7443768,'cap',20,1),(198,7443770,7443768,'apa',20,1),(198,7443771,7443768,'pab',20,1),(198,7443772,7443768,'abl',20,1),(198,7443773,7443768,'ble',20,1),(198,7443774,7443769,'tru',50,1),(198,7443775,7443769,'rue',50,1),(198,7443776,7443774,'loc',33.333,1),(198,7443777,7443774,'oca',33.333,1),(198,7443778,7443774,'cal',33.333,1),(198,7443779,7443776,'rem',14.286,1),(198,7443780,7443776,'emo',14.286,1),(198,7443781,7443776,'mov',14.286,1),(198,7443782,7443776,'ova',14.286,1),(198,7443783,7443776,'vab',14.286,1),(198,7443784,7443776,'abl',14.286,1),(198,7443785,7443776,'ble',14.286,1),(198,7443786,7443779,'ssd',100,1),(198,7443787,7443786,'off',20,1),(198,7443788,7443786,'ffl',20,1),(198,7443789,7443786,'fli',20,1),(198,7443790,7443786,'lin',20,1),(198,7443791,7443786,'ine',20,1),(198,7443792,7443787,'per',11.111,1),(198,7443793,7443787,'ere',11.111,1),(198,7443794,7443787,'ren',11.111,1),(198,7443795,7443787,'enn',11.111,1),(198,7443796,7443787,'nni',11.111,1),(198,7443797,7443787,'nia',11.111,1),(198,7443798,7443787,'ial',11.111,1),(198,7443799,7443787,'all',11.111,1),(198,7443800,7443787,'lly',11.111,1),(198,7443801,7443792,'res',16.667,1),(198,7443802,7443792,'ese',16.667,1),(198,7443803,7443792,'ser',16.667,1),(198,7443804,7443792,'erv',16.667,1),(198,7443805,7443792,'rve',16.667,1),(198,7443806,7443792,'ved',16.667,1),(198,7443807,7443801,'thi',50,1),(198,7443808,7443801,'hin',50,1),(198,7443809,7443807,'pro',10,1),(198,7443810,7443807,'rov',10,1),(198,7443811,7443807,'ovi',10,1),(198,7443812,7443807,'vis',10,1),(198,7443813,7443807,'isi',10,1),(198,7443814,7443807,'sio',10,1),(198,7443815,7443807,'ion',10,1),(198,7443816,7443807,'oni',10,1),(198,7443817,7443807,'nin',10,1),(198,7443818,7443807,'ing',10,1),(198,7443819,7443809,'yes',100,1),(198,7443820,7443819,'att',16.667,1),(198,7443821,7443819,'tta',16.667,1),(198,7443822,7443819,'tac',16.667,1),(198,7443823,7443819,'ach',16.667,1),(198,7443824,7443819,'che',16.667,1),(198,7443825,7443819,'hed',16.667,1),(198,7443826,7443820,'fil',20,1),(198,7443827,7443820,'ilt',20,1),(198,7443828,7443820,'lte',20,1),(198,7443829,7443820,'ter',20,1),(198,7443830,7443820,'ers',20,1),(198,7443831,7443826,'vaa',50,1),(198,7443832,7443826,'aai',50,1),(198,7443833,7443831,'unk',20,1),(198,7443834,7443831,'nkn',20,1),(198,7443835,7443831,'kno',20,1),(198,7443836,7443831,'now',20,1),(198,7443837,7443831,'own',20,1),(198,7443838,7443833,'oth',33.333,1),(198,7443839,7443833,'the',33.333,1),(198,7443840,7443833,'her',33.333,1),(198,7443841,7443838,'uid',50,1),(198,7443842,7443838,'ids',50,1),(198,7443843,7443841,'vml',100,1),(198,7443844,7443843,'dis',20,1),(198,7443845,7443843,'isp',20,1),(198,7443846,7443843,'spl',20,1),(198,7443847,7443843,'pla',20,1),(198,7443848,7443843,'lay',20,1),(198,7443849,7443844,'nam',50,1),(198,7443850,7443844,'ame',50,1),(199,7443852,7443851,'net',25,3),(199,7443853,7443851,'eta',25,3),(199,7443854,7443851,'tap',25,3),(199,7443855,7443851,'app',25,3),(199,7443856,7443852,'fib',33.333,2),(199,7443857,7443852,'ibr',33.333,2),(199,7443858,7443852,'bre',33.333,2),(199,7443859,7443856,'cha',20,2),(199,7443860,7443856,'han',20,2),(199,7443861,7443856,'ann',20,2),(199,7443862,7443856,'nne',20,2),(199,7443863,7443856,'nel',20,2),(199,7443864,7443859,'dis',50,2),(199,7443865,7443859,'isk',50,2),(199,7443866,7443864,'naa',100,4),(199,7443867,7443866,'600',3.333,4),(199,7443868,7443866,'00a',3.333,4),(199,7443869,7443866,'0a0',3.333,4),(199,7443870,7443866,'a09',3.333,4),(199,7443871,7443866,'098',3.333,4),(199,7443872,7443866,'980',3.333,4),(199,7443873,7443866,'804',3.333,4),(199,7443874,7443866,'044',3.333,4),(199,7443875,7443866,'443',3.333,4),(199,7443876,7443866,'430',3.333,4),(199,7443877,7443866,'307',3.333,4),(199,7443878,7443866,'075',3.333,4),(199,7443879,7443866,'753',3.333,4),(199,7443880,7443866,'535',3.333,4),(199,7443881,7443866,'357',3.333,4),(199,7443882,7443866,'573',3.333,4),(199,7443883,7443866,'732',3.333,4),(199,7443884,7443866,'32b',3.333,4),(199,7443885,7443866,'2b3',3.333,4),(199,7443886,7443866,'b33',3.333,4),(199,7443887,7443866,'334',3.333,4),(199,7443888,7443866,'345',3.333,4),(199,7443889,7443866,'457',3.333,4),(199,7443890,7443866,'571',3.333,4),(199,7443891,7443866,'715',3.333,4),(199,7443892,7443866,'152',3.333,4),(199,7443893,7443866,'527',3.333,4),(199,7443894,7443866,'275',3.333,4),(199,7443895,7443866,'754',3.333,4),(199,7443896,7443866,'541',3.333,4),(199,7443897,7443867,'ser',25,1),(199,7443898,7443867,'eri',25,1),(199,7443899,7443867,'ria',25,1),(199,7443900,7443867,'ial',25,1),(199,7443901,7443897,'siz',50,1),(199,7443902,7443897,'ize',50,1),(199,7443903,7443901,'460',33.333,1),(199,7443904,7443901,'608',33.333,1),(199,7443905,7443901,'080',33.333,1),(199,7443906,7443903,'dev',25,1),(199,7443907,7443903,'evi',25,1),(199,7443908,7443903,'vic',25,1),(199,7443909,7443903,'ice',25,1),(199,7443910,7443906,'typ',50,1),(199,7443911,7443906,'ype',50,1),(199,7443912,7443910,'dir',10,1),(199,7443913,7443910,'ire',10,1),(199,7443914,7443910,'rec',10,1),(199,7443915,7443910,'ect',10,1),(199,7443916,7443910,'cta',10,1),(199,7443917,7443910,'tac',10,1),(199,7443918,7443910,'acc',10,1),(199,7443919,7443910,'cce',10,1),(199,7443920,7443910,'ces',10,1),(199,7443921,7443910,'ess',10,1),(199,7443922,7443912,'mul',14.286,1),(199,7443923,7443912,'ult',14.286,1),(199,7443924,7443912,'lti',14.286,1),(199,7443925,7443912,'tip',14.286,1),(199,7443926,7443912,'ipa',14.286,1),(199,7443927,7443912,'pat',14.286,1),(199,7443928,7443912,'ath',14.286,1),(199,7443929,7443922,'plu',25,1),(199,7443930,7443922,'lug',25,1),(199,7443931,7443922,'ugi',25,1),(199,7443932,7443922,'gin',25,1),(199,7443933,7443929,'nmp',100,1),(199,7443934,7443933,'dev',33.333,1),(199,7443935,7443933,'evf',33.333,1),(199,7443936,7443933,'vfs',33.333,1),(199,7443937,7443934,'pat',50,1),(199,7443938,7443934,'ath',50,1),(199,7443939,7443937,'vmf',50,1),(199,7443940,7443937,'mfs',50,1),(199,7443941,7443939,'dev',20,1),(199,7443942,7443939,'evi',20,1),(199,7443943,7443939,'vic',20,1),(199,7443944,7443939,'ice',20,1),(199,7443945,7443939,'ces',20,1),(199,7443946,7443941,'dis',33.333,1),(199,7443947,7443941,'isk',33.333,1),(199,7443948,7443941,'sks',33.333,1),(199,7443949,7443946,'ven',25,1),(199,7443950,7443946,'end',25,1),(199,7443951,7443946,'ndo',25,1),(199,7443952,7443946,'dor',25,1),(199,7443953,7443949,'mod',33.333,1),(199,7443954,7443949,'ode',33.333,1),(199,7443955,7443949,'del',33.333,1),(199,7443956,7443953,'lun',100,1),(199,7443957,7443956,'cmo',33.333,1),(199,7443958,7443956,'mod',33.333,1),(199,7443959,7443956,'ode',33.333,1),(199,7443960,7443957,'rev',16.667,1),(199,7443961,7443957,'evi',16.667,1),(199,7443962,7443957,'vis',16.667,1),(199,7443963,7443957,'isi',16.667,1),(199,7443964,7443957,'sio',16.667,1),(199,7443965,7443957,'ion',16.667,1),(199,7443966,7443960,'810',50,1),(199,7443967,7443960,'100',50,1),(199,7443968,7443966,'scs',50,1),(199,7443969,7443966,'csi',50,1),(199,7443970,7443968,'lev',33.333,1),(199,7443971,7443968,'eve',33.333,1),(199,7443972,7443968,'vel',33.333,1),(199,7443973,7443970,'pse',25,1),(199,7443974,7443970,'seu',25,1),(199,7443975,7443970,'eud',25,1),(199,7443976,7443970,'udo',25,1),(199,7443977,7443973,'fal',33.333,6),(199,7443978,7443973,'als',33.333,6),(199,7443979,7443973,'lse',33.333,6),(199,7443980,7443977,'sta',25,3),(199,7443981,7443977,'tat',25,3),(199,7443982,7443977,'atu',25,3),(199,7443983,7443977,'tus',25,3),(199,7443984,7443980,'rdm',100,1),(199,7443985,7443984,'cap',20,1),(199,7443986,7443984,'apa',20,1),(199,7443987,7443984,'pab',20,1),(199,7443988,7443984,'abl',20,1),(199,7443989,7443984,'ble',20,1),(199,7443990,7443985,'tru',50,1),(199,7443991,7443985,'rue',50,1),(199,7443992,7443990,'loc',33.333,1),(199,7443993,7443990,'oca',33.333,1),(199,7443994,7443990,'cal',33.333,1),(199,7443995,7443992,'rem',14.286,1),(199,7443996,7443992,'emo',14.286,1),(199,7443997,7443992,'mov',14.286,1),(199,7443998,7443992,'ova',14.286,1),(199,7443999,7443992,'vab',14.286,1),(199,7444000,7443992,'abl',14.286,1),(199,7444001,7443992,'ble',14.286,1),(199,7444002,7443995,'ssd',100,1),(199,7444003,7444002,'off',20,1),(199,7444004,7444002,'ffl',20,1),(199,7444005,7444002,'fli',20,1),(199,7444006,7444002,'lin',20,1),(199,7444007,7444002,'ine',20,1),(199,7444008,7444003,'per',11.111,1),(199,7444009,7444003,'ere',11.111,1),(199,7444010,7444003,'ren',11.111,1),(199,7444011,7444003,'enn',11.111,1),(199,7444012,7444003,'nni',11.111,1),(199,7444013,7444003,'nia',11.111,1),(199,7444014,7444003,'ial',11.111,1),(199,7444015,7444003,'all',11.111,1),(199,7444016,7444003,'lly',11.111,1),(199,7444017,7444008,'res',16.667,1),(199,7444018,7444008,'ese',16.667,1),(199,7444019,7444008,'ser',16.667,1),(199,7444020,7444008,'erv',16.667,1),(199,7444021,7444008,'rve',16.667,1),(199,7444022,7444008,'ved',16.667,1),(199,7444023,7444017,'thi',50,1),(199,7444024,7444017,'hin',50,1),(199,7444025,7444023,'pro',10,1),(199,7444026,7444023,'rov',10,1),(199,7444027,7444023,'ovi',10,1),(199,7444028,7444023,'vis',10,1),(199,7444029,7444023,'isi',10,1),(199,7444030,7444023,'sio',10,1),(199,7444031,7444023,'ion',10,1),(199,7444032,7444023,'oni',10,1),(199,7444033,7444023,'nin',10,1),(199,7444034,7444023,'ing',10,1),(199,7444035,7444025,'yes',100,1),(199,7444036,7444035,'att',16.667,1),(199,7444037,7444035,'tta',16.667,1),(199,7444038,7444035,'tac',16.667,1),(199,7444039,7444035,'ach',16.667,1),(199,7444040,7444035,'che',16.667,1),(199,7444041,7444035,'hed',16.667,1),(199,7444042,7444036,'fil',20,1),(199,7444043,7444036,'ilt',20,1),(199,7444044,7444036,'lte',20,1),(199,7444045,7444036,'ter',20,1),(199,7444046,7444036,'ers',20,1),(199,7444047,7444042,'vaa',50,1),(199,7444048,7444042,'aai',50,1),(199,7444049,7444047,'unk',20,1),(199,7444050,7444047,'nkn',20,1),(199,7444051,7444047,'kno',20,1),(199,7444052,7444047,'now',20,1),(199,7444053,7444047,'own',20,1),(199,7444054,7444049,'oth',33.333,1),(199,7444055,7444049,'the',33.333,1),(199,7444056,7444049,'her',33.333,1),(199,7444057,7444054,'uid',50,1),(199,7444058,7444054,'ids',50,1),(199,7444059,7444057,'vml',100,1),(199,7444060,7444059,'dis',20,1),(199,7444061,7444059,'isp',20,1),(199,7444062,7444059,'spl',20,1),(199,7444063,7444059,'pla',20,1),(199,7444064,7444059,'lay',20,1),(199,7444065,7444060,'nam',50,1),(199,7444066,7444060,'ame',50,1),(200,7444068,7444067,'net',25,3),(200,7444069,7444067,'eta',25,3),(200,7444070,7444067,'tap',25,3),(200,7444071,7444067,'app',25,3),(200,7444072,7444068,'fib',33.333,2),(200,7444073,7444068,'ibr',33.333,2),(200,7444074,7444068,'bre',33.333,2),(200,7444075,7444072,'cha',20,2),(200,7444076,7444072,'han',20,2),(200,7444077,7444072,'ann',20,2),(200,7444078,7444072,'nne',20,2),(200,7444079,7444072,'nel',20,2),(200,7444080,7444075,'dis',50,2),(200,7444081,7444075,'isk',50,2),(200,7444082,7444080,'naa',100,4),(200,7444083,7444082,'600',3.333,4),(200,7444084,7444082,'00a',3.333,4),(200,7444085,7444082,'0a0',3.333,4),(200,7444086,7444082,'a09',3.333,4),(200,7444087,7444082,'098',3.333,4),(200,7444088,7444082,'980',3.333,4),(200,7444089,7444082,'804',3.333,4),(200,7444090,7444082,'044',3.333,4),(200,7444091,7444082,'443',3.333,4),(200,7444092,7444082,'430',3.333,4),(200,7444093,7444082,'307',3.333,4),(200,7444094,7444082,'075',3.333,4),(200,7444095,7444082,'753',3.333,4),(200,7444096,7444082,'535',3.333,4),(200,7444097,7444082,'357',3.333,4),(200,7444098,7444082,'573',3.333,4),(200,7444099,7444082,'732',3.333,4),(200,7444100,7444082,'32b',3.333,4),(200,7444101,7444082,'2b3',3.333,4),(200,7444102,7444082,'b33',3.333,4),(200,7444103,7444082,'334',3.333,4),(200,7444104,7444082,'345',3.333,4),(200,7444105,7444082,'457',3.333,4),(200,7444106,7444082,'571',3.333,4),(200,7444107,7444082,'715',3.333,4),(200,7444108,7444082,'152',3.333,4),(200,7444109,7444082,'527',3.333,4),(200,7444110,7444082,'275',3.333,4),(200,7444111,7444082,'754',3.333,4),(200,7444112,7444082,'542',3.333,4),(200,7444113,7444083,'ser',25,1),(200,7444114,7444083,'eri',25,1),(200,7444115,7444083,'ria',25,1),(200,7444116,7444083,'ial',25,1),(200,7444117,7444113,'siz',50,1),(200,7444118,7444113,'ize',50,1),(200,7444119,7444117,'460',33.333,1),(200,7444120,7444117,'608',33.333,1),(200,7444121,7444117,'080',33.333,1),(200,7444122,7444119,'dev',25,1),(200,7444123,7444119,'evi',25,1),(200,7444124,7444119,'vic',25,1),(200,7444125,7444119,'ice',25,1),(200,7444126,7444122,'typ',50,1),(200,7444127,7444122,'ype',50,1),(200,7444128,7444126,'dir',10,1),(200,7444129,7444126,'ire',10,1),(200,7444130,7444126,'rec',10,1),(200,7444131,7444126,'ect',10,1),(200,7444132,7444126,'cta',10,1),(200,7444133,7444126,'tac',10,1),(200,7444134,7444126,'acc',10,1),(200,7444135,7444126,'cce',10,1),(200,7444136,7444126,'ces',10,1),(200,7444137,7444126,'ess',10,1),(200,7444138,7444128,'mul',14.286,1),(200,7444139,7444128,'ult',14.286,1),(200,7444140,7444128,'lti',14.286,1),(200,7444141,7444128,'tip',14.286,1),(200,7444142,7444128,'ipa',14.286,1),(200,7444143,7444128,'pat',14.286,1),(200,7444144,7444128,'ath',14.286,1),(200,7444145,7444138,'plu',25,1),(200,7444146,7444138,'lug',25,1),(200,7444147,7444138,'ugi',25,1),(200,7444148,7444138,'gin',25,1),(200,7444149,7444145,'nmp',100,1),(200,7444150,7444149,'dev',33.333,1),(200,7444151,7444149,'evf',33.333,1),(200,7444152,7444149,'vfs',33.333,1),(200,7444153,7444150,'pat',50,1),(200,7444154,7444150,'ath',50,1),(200,7444155,7444153,'vmf',50,1),(200,7444156,7444153,'mfs',50,1),(200,7444157,7444155,'dev',20,1),(200,7444158,7444155,'evi',20,1),(200,7444159,7444155,'vic',20,1),(200,7444160,7444155,'ice',20,1),(200,7444161,7444155,'ces',20,1),(200,7444162,7444157,'dis',33.333,1),(200,7444163,7444157,'isk',33.333,1),(200,7444164,7444157,'sks',33.333,1),(200,7444165,7444162,'ven',25,1),(200,7444166,7444162,'end',25,1),(200,7444167,7444162,'ndo',25,1),(200,7444168,7444162,'dor',25,1),(200,7444169,7444165,'mod',33.333,1),(200,7444170,7444165,'ode',33.333,1),(200,7444171,7444165,'del',33.333,1),(200,7444172,7444169,'lun',100,1),(200,7444173,7444172,'cmo',33.333,1),(200,7444174,7444172,'mod',33.333,1),(200,7444175,7444172,'ode',33.333,1),(200,7444176,7444173,'rev',16.667,1),(200,7444177,7444173,'evi',16.667,1),(200,7444178,7444173,'vis',16.667,1),(200,7444179,7444173,'isi',16.667,1),(200,7444180,7444173,'sio',16.667,1),(200,7444181,7444173,'ion',16.667,1),(200,7444182,7444176,'810',50,1),(200,7444183,7444176,'100',50,1),(200,7444184,7444182,'scs',50,1),(200,7444185,7444182,'csi',50,1),(200,7444186,7444184,'lev',33.333,1),(200,7444187,7444184,'eve',33.333,1),(200,7444188,7444184,'vel',33.333,1),(200,7444189,7444186,'pse',25,1),(200,7444190,7444186,'seu',25,1),(200,7444191,7444186,'eud',25,1),(200,7444192,7444186,'udo',25,1),(200,7444193,7444189,'fal',33.333,6),(200,7444194,7444189,'als',33.333,6),(200,7444195,7444189,'lse',33.333,6),(200,7444196,7444193,'sta',25,3),(200,7444197,7444193,'tat',25,3),(200,7444198,7444193,'atu',25,3),(200,7444199,7444193,'tus',25,3),(200,7444200,7444196,'rdm',100,1),(200,7444201,7444200,'cap',20,1),(200,7444202,7444200,'apa',20,1),(200,7444203,7444200,'pab',20,1),(200,7444204,7444200,'abl',20,1),(200,7444205,7444200,'ble',20,1),(200,7444206,7444201,'tru',50,1),(200,7444207,7444201,'rue',50,1),(200,7444208,7444206,'loc',33.333,1),(200,7444209,7444206,'oca',33.333,1),(200,7444210,7444206,'cal',33.333,1),(200,7444211,7444208,'rem',14.286,1),(200,7444212,7444208,'emo',14.286,1),(200,7444213,7444208,'mov',14.286,1),(200,7444214,7444208,'ova',14.286,1),(200,7444215,7444208,'vab',14.286,1),(200,7444216,7444208,'abl',14.286,1),(200,7444217,7444208,'ble',14.286,1),(200,7444218,7444211,'ssd',100,1),(200,7444219,7444218,'off',20,1),(200,7444220,7444218,'ffl',20,1),(200,7444221,7444218,'fli',20,1),(200,7444222,7444218,'lin',20,1),(200,7444223,7444218,'ine',20,1),(200,7444224,7444219,'per',11.111,1),(200,7444225,7444219,'ere',11.111,1),(200,7444226,7444219,'ren',11.111,1),(200,7444227,7444219,'enn',11.111,1),(200,7444228,7444219,'nni',11.111,1),(200,7444229,7444219,'nia',11.111,1),(200,7444230,7444219,'ial',11.111,1),(200,7444231,7444219,'all',11.111,1),(200,7444232,7444219,'lly',11.111,1),(200,7444233,7444224,'res',16.667,1),(200,7444234,7444224,'ese',16.667,1),(200,7444235,7444224,'ser',16.667,1),(200,7444236,7444224,'erv',16.667,1),(200,7444237,7444224,'rve',16.667,1),(200,7444238,7444224,'ved',16.667,1),(200,7444239,7444233,'thi',50,1),(200,7444240,7444233,'hin',50,1),(200,7444241,7444239,'pro',10,1),(200,7444242,7444239,'rov',10,1),(200,7444243,7444239,'ovi',10,1),(200,7444244,7444239,'vis',10,1),(200,7444245,7444239,'isi',10,1),(200,7444246,7444239,'sio',10,1),(200,7444247,7444239,'ion',10,1),(200,7444248,7444239,'oni',10,1),(200,7444249,7444239,'nin',10,1),(200,7444250,7444239,'ing',10,1),(200,7444251,7444241,'yes',100,1),(200,7444252,7444251,'att',16.667,1),(200,7444253,7444251,'tta',16.667,1),(200,7444254,7444251,'tac',16.667,1),(200,7444255,7444251,'ach',16.667,1),(200,7444256,7444251,'che',16.667,1),(200,7444257,7444251,'hed',16.667,1),(200,7444258,7444252,'fil',20,1),(200,7444259,7444252,'ilt',20,1),(200,7444260,7444252,'lte',20,1),(200,7444261,7444252,'ter',20,1),(200,7444262,7444252,'ers',20,1),(200,7444263,7444258,'vaa',50,1),(200,7444264,7444258,'aai',50,1),(200,7444265,7444263,'unk',20,1),(200,7444266,7444263,'nkn',20,1),(200,7444267,7444263,'kno',20,1),(200,7444268,7444263,'now',20,1),(200,7444269,7444263,'own',20,1),(200,7444270,7444265,'oth',33.333,1),(200,7444271,7444265,'the',33.333,1),(200,7444272,7444265,'her',33.333,1),(200,7444273,7444270,'uid',50,1),(200,7444274,7444270,'ids',50,1),(200,7444275,7444273,'vml',100,1),(200,7444276,7444275,'dis',20,1),(200,7444277,7444275,'isp',20,1),(200,7444278,7444275,'spl',20,1),(200,7444279,7444275,'pla',20,1),(200,7444280,7444275,'lay',20,1),(200,7444281,7444276,'nam',50,1),(200,7444282,7444276,'ame',50,1),(201,7444284,7444283,'net',25,3),(201,7444285,7444283,'eta',25,3),(201,7444286,7444283,'tap',25,3),(201,7444287,7444283,'app',25,3),(201,7444288,7444284,'fib',33.333,2),(201,7444289,7444284,'ibr',33.333,2),(201,7444290,7444284,'bre',33.333,2),(201,7444291,7444288,'cha',20,2),(201,7444292,7444288,'han',20,2),(201,7444293,7444288,'ann',20,2),(201,7444294,7444288,'nne',20,2),(201,7444295,7444288,'nel',20,2),(201,7444296,7444291,'dis',50,2),(201,7444297,7444291,'isk',50,2),(201,7444298,7444296,'naa',100,4),(201,7444299,7444298,'600',3.333,4),(201,7444300,7444298,'00a',3.333,4),(201,7444301,7444298,'0a0',3.333,4),(201,7444302,7444298,'a09',3.333,4),(201,7444303,7444298,'098',3.333,4),(201,7444304,7444298,'980',3.333,4),(201,7444305,7444298,'804',3.333,4),(201,7444306,7444298,'044',3.333,4),(201,7444307,7444298,'443',3.333,4),(201,7444308,7444298,'430',3.333,4),(201,7444309,7444298,'307',3.333,4),(201,7444310,7444298,'075',3.333,4),(201,7444311,7444298,'753',3.333,4),(201,7444312,7444298,'535',3.333,4),(201,7444313,7444298,'357',3.333,4),(201,7444314,7444298,'573',3.333,4),(201,7444315,7444298,'732',3.333,4),(201,7444316,7444298,'32b',3.333,4),(201,7444317,7444298,'2b3',3.333,4),(201,7444318,7444298,'b33',3.333,4),(201,7444319,7444298,'334',3.333,4),(201,7444320,7444298,'345',3.333,4),(201,7444321,7444298,'457',3.333,4),(201,7444322,7444298,'571',3.333,4),(201,7444323,7444298,'715',3.333,4),(201,7444324,7444298,'152',3.333,4),(201,7444325,7444298,'527',3.333,4),(201,7444326,7444298,'275',3.333,4),(201,7444327,7444298,'754',3.333,4),(201,7444328,7444298,'543',3.333,4),(201,7444329,7444299,'ser',25,1),(201,7444330,7444299,'eri',25,1),(201,7444331,7444299,'ria',25,1),(201,7444332,7444299,'ial',25,1),(201,7444333,7444329,'siz',50,1),(201,7444334,7444329,'ize',50,1),(201,7444335,7444333,'460',33.333,1),(201,7444336,7444333,'608',33.333,1),(201,7444337,7444333,'080',33.333,1),(201,7444338,7444335,'dev',25,1),(201,7444339,7444335,'evi',25,1),(201,7444340,7444335,'vic',25,1),(201,7444341,7444335,'ice',25,1),(201,7444342,7444338,'typ',50,1),(201,7444343,7444338,'ype',50,1),(201,7444344,7444342,'dir',10,1),(201,7444345,7444342,'ire',10,1),(201,7444346,7444342,'rec',10,1),(201,7444347,7444342,'ect',10,1),(201,7444348,7444342,'cta',10,1),(201,7444349,7444342,'tac',10,1),(201,7444350,7444342,'acc',10,1),(201,7444351,7444342,'cce',10,1),(201,7444352,7444342,'ces',10,1),(201,7444353,7444342,'ess',10,1),(201,7444354,7444344,'mul',14.286,1),(201,7444355,7444344,'ult',14.286,1),(201,7444356,7444344,'lti',14.286,1),(201,7444357,7444344,'tip',14.286,1),(201,7444358,7444344,'ipa',14.286,1),(201,7444359,7444344,'pat',14.286,1),(201,7444360,7444344,'ath',14.286,1),(201,7444361,7444354,'plu',25,1),(201,7444362,7444354,'lug',25,1),(201,7444363,7444354,'ugi',25,1),(201,7444364,7444354,'gin',25,1),(201,7444365,7444361,'nmp',100,1),(201,7444366,7444365,'dev',33.333,1),(201,7444367,7444365,'evf',33.333,1),(201,7444368,7444365,'vfs',33.333,1),(201,7444369,7444366,'pat',50,1),(201,7444370,7444366,'ath',50,1),(201,7444371,7444369,'vmf',50,1),(201,7444372,7444369,'mfs',50,1),(201,7444373,7444371,'dev',20,1),(201,7444374,7444371,'evi',20,1),(201,7444375,7444371,'vic',20,1),(201,7444376,7444371,'ice',20,1),(201,7444377,7444371,'ces',20,1),(201,7444378,7444373,'dis',33.333,1),(201,7444379,7444373,'isk',33.333,1),(201,7444380,7444373,'sks',33.333,1),(201,7444381,7444378,'ven',25,1),(201,7444382,7444378,'end',25,1),(201,7444383,7444378,'ndo',25,1),(201,7444384,7444378,'dor',25,1),(201,7444385,7444381,'mod',33.333,1),(201,7444386,7444381,'ode',33.333,1),(201,7444387,7444381,'del',33.333,1),(201,7444388,7444385,'lun',100,1),(201,7444389,7444388,'cmo',33.333,1),(201,7444390,7444388,'mod',33.333,1),(201,7444391,7444388,'ode',33.333,1),(201,7444392,7444389,'rev',16.667,1),(201,7444393,7444389,'evi',16.667,1),(201,7444394,7444389,'vis',16.667,1),(201,7444395,7444389,'isi',16.667,1),(201,7444396,7444389,'sio',16.667,1),(201,7444397,7444389,'ion',16.667,1),(201,7444398,7444392,'810',50,1),(201,7444399,7444392,'100',50,1),(201,7444400,7444398,'scs',50,1),(201,7444401,7444398,'csi',50,1),(201,7444402,7444400,'lev',33.333,1),(201,7444403,7444400,'eve',33.333,1),(201,7444404,7444400,'vel',33.333,1),(201,7444405,7444402,'pse',25,1),(201,7444406,7444402,'seu',25,1),(201,7444407,7444402,'eud',25,1),(201,7444408,7444402,'udo',25,1),(201,7444409,7444405,'fal',33.333,6),(201,7444410,7444405,'als',33.333,6),(201,7444411,7444405,'lse',33.333,6),(201,7444412,7444409,'sta',25,3),(201,7444413,7444409,'tat',25,3),(201,7444414,7444409,'atu',25,3),(201,7444415,7444409,'tus',25,3),(201,7444416,7444412,'rdm',100,1),(201,7444417,7444416,'cap',20,1),(201,7444418,7444416,'apa',20,1),(201,7444419,7444416,'pab',20,1),(201,7444420,7444416,'abl',20,1),(201,7444421,7444416,'ble',20,1),(201,7444422,7444417,'tru',50,1),(201,7444423,7444417,'rue',50,1),(201,7444424,7444422,'loc',33.333,1),(201,7444425,7444422,'oca',33.333,1),(201,7444426,7444422,'cal',33.333,1),(201,7444427,7444424,'rem',14.286,1),(201,7444428,7444424,'emo',14.286,1),(201,7444429,7444424,'mov',14.286,1),(201,7444430,7444424,'ova',14.286,1),(201,7444431,7444424,'vab',14.286,1),(201,7444432,7444424,'abl',14.286,1),(201,7444433,7444424,'ble',14.286,1),(201,7444434,7444427,'ssd',100,1),(201,7444435,7444434,'off',20,1),(201,7444436,7444434,'ffl',20,1),(201,7444437,7444434,'fli',20,1),(201,7444438,7444434,'lin',20,1),(201,7444439,7444434,'ine',20,1),(201,7444440,7444435,'per',11.111,1),(201,7444441,7444435,'ere',11.111,1),(201,7444442,7444435,'ren',11.111,1),(201,7444443,7444435,'enn',11.111,1),(201,7444444,7444435,'nni',11.111,1),(201,7444445,7444435,'nia',11.111,1),(201,7444446,7444435,'ial',11.111,1),(201,7444447,7444435,'all',11.111,1),(201,7444448,7444435,'lly',11.111,1),(201,7444449,7444440,'res',16.667,1),(201,7444450,7444440,'ese',16.667,1),(201,7444451,7444440,'ser',16.667,1),(201,7444452,7444440,'erv',16.667,1),(201,7444453,7444440,'rve',16.667,1),(201,7444454,7444440,'ved',16.667,1),(201,7444455,7444449,'thi',50,1),(201,7444456,7444449,'hin',50,1),(201,7444457,7444455,'pro',10,1),(201,7444458,7444455,'rov',10,1),(201,7444459,7444455,'ovi',10,1),(201,7444460,7444455,'vis',10,1),(201,7444461,7444455,'isi',10,1),(201,7444462,7444455,'sio',10,1),(201,7444463,7444455,'ion',10,1),(201,7444464,7444455,'oni',10,1),(201,7444465,7444455,'nin',10,1),(201,7444466,7444455,'ing',10,1),(201,7444467,7444457,'yes',100,1),(201,7444468,7444467,'att',16.667,1),(201,7444469,7444467,'tta',16.667,1),(201,7444470,7444467,'tac',16.667,1),(201,7444471,7444467,'ach',16.667,1),(201,7444472,7444467,'che',16.667,1),(201,7444473,7444467,'hed',16.667,1),(201,7444474,7444468,'fil',20,1),(201,7444475,7444468,'ilt',20,1),(201,7444476,7444468,'lte',20,1),(201,7444477,7444468,'ter',20,1),(201,7444478,7444468,'ers',20,1),(201,7444479,7444474,'vaa',50,1),(201,7444480,7444474,'aai',50,1),(201,7444481,7444479,'unk',20,1),(201,7444482,7444479,'nkn',20,1),(201,7444483,7444479,'kno',20,1),(201,7444484,7444479,'now',20,1),(201,7444485,7444479,'own',20,1),(201,7444486,7444481,'oth',33.333,1),(201,7444487,7444481,'the',33.333,1),(201,7444488,7444481,'her',33.333,1),(201,7444489,7444486,'uid',50,1),(201,7444490,7444486,'ids',50,1),(201,7444491,7444489,'vml',100,1),(201,7444492,7444491,'dis',20,1),(201,7444493,7444491,'isp',20,1),(201,7444494,7444491,'spl',20,1),(201,7444495,7444491,'pla',20,1),(201,7444496,7444491,'lay',20,1),(201,7444497,7444492,'nam',50,1),(201,7444498,7444492,'ame',50,1),(202,7444500,7444499,'net',25,3),(202,7444501,7444499,'eta',25,3),(202,7444502,7444499,'tap',25,3),(202,7444503,7444499,'app',25,3),(202,7444504,7444500,'fib',33.333,2),(202,7444505,7444500,'ibr',33.333,2),(202,7444506,7444500,'bre',33.333,2),(202,7444507,7444504,'cha',20,2),(202,7444508,7444504,'han',20,2),(202,7444509,7444504,'ann',20,2),(202,7444510,7444504,'nne',20,2),(202,7444511,7444504,'nel',20,2),(202,7444512,7444507,'dis',50,2),(202,7444513,7444507,'isk',50,2),(202,7444514,7444512,'naa',100,4),(202,7444515,7444514,'600',3.333,4),(202,7444516,7444514,'00a',3.333,4),(202,7444517,7444514,'0a0',3.333,4),(202,7444518,7444514,'a09',3.333,4),(202,7444519,7444514,'098',3.333,4),(202,7444520,7444514,'980',3.333,4),(202,7444521,7444514,'804',3.333,4),(202,7444522,7444514,'044',3.333,4),(202,7444523,7444514,'443',3.333,4),(202,7444524,7444514,'430',3.333,4),(202,7444525,7444514,'307',3.333,4),(202,7444526,7444514,'075',3.333,4),(202,7444527,7444514,'753',3.333,4),(202,7444528,7444514,'535',3.333,4),(202,7444529,7444514,'357',3.333,4),(202,7444530,7444514,'573',3.333,4),(202,7444531,7444514,'732',3.333,4),(202,7444532,7444514,'32b',3.333,4),(202,7444533,7444514,'2b3',3.333,4),(202,7444534,7444514,'b33',3.333,4),(202,7444535,7444514,'334',3.333,4),(202,7444536,7444514,'345',3.333,4),(202,7444537,7444514,'457',3.333,4),(202,7444538,7444514,'571',3.333,4),(202,7444539,7444514,'715',3.333,4),(202,7444540,7444514,'152',3.333,4),(202,7444541,7444514,'527',3.333,4),(202,7444542,7444514,'275',3.333,4),(202,7444543,7444514,'754',3.333,4),(202,7444544,7444514,'544',3.333,4),(202,7444545,7444515,'ser',25,1),(202,7444546,7444515,'eri',25,1),(202,7444547,7444515,'ria',25,1),(202,7444548,7444515,'ial',25,1),(202,7444549,7444545,'siz',50,1),(202,7444550,7444545,'ize',50,1),(202,7444551,7444549,'460',33.333,1),(202,7444552,7444549,'608',33.333,1),(202,7444553,7444549,'080',33.333,1),(202,7444554,7444551,'dev',25,1),(202,7444555,7444551,'evi',25,1),(202,7444556,7444551,'vic',25,1),(202,7444557,7444551,'ice',25,1),(202,7444558,7444554,'typ',50,1),(202,7444559,7444554,'ype',50,1),(202,7444560,7444558,'dir',10,1),(202,7444561,7444558,'ire',10,1),(202,7444562,7444558,'rec',10,1),(202,7444563,7444558,'ect',10,1),(202,7444564,7444558,'cta',10,1),(202,7444565,7444558,'tac',10,1),(202,7444566,7444558,'acc',10,1),(202,7444567,7444558,'cce',10,1),(202,7444568,7444558,'ces',10,1),(202,7444569,7444558,'ess',10,1),(202,7444570,7444560,'mul',14.286,1),(202,7444571,7444560,'ult',14.286,1),(202,7444572,7444560,'lti',14.286,1),(202,7444573,7444560,'tip',14.286,1),(202,7444574,7444560,'ipa',14.286,1),(202,7444575,7444560,'pat',14.286,1),(202,7444576,7444560,'ath',14.286,1),(202,7444577,7444570,'plu',25,1),(202,7444578,7444570,'lug',25,1),(202,7444579,7444570,'ugi',25,1),(202,7444580,7444570,'gin',25,1),(202,7444581,7444577,'nmp',100,1),(202,7444582,7444581,'dev',33.333,1),(202,7444583,7444581,'evf',33.333,1),(202,7444584,7444581,'vfs',33.333,1),(202,7444585,7444582,'pat',50,1),(202,7444586,7444582,'ath',50,1),(202,7444587,7444585,'vmf',50,1),(202,7444588,7444585,'mfs',50,1),(202,7444589,7444587,'dev',20,1),(202,7444590,7444587,'evi',20,1),(202,7444591,7444587,'vic',20,1),(202,7444592,7444587,'ice',20,1),(202,7444593,7444587,'ces',20,1),(202,7444594,7444589,'dis',33.333,1),(202,7444595,7444589,'isk',33.333,1),(202,7444596,7444589,'sks',33.333,1),(202,7444597,7444594,'ven',25,1),(202,7444598,7444594,'end',25,1),(202,7444599,7444594,'ndo',25,1),(202,7444600,7444594,'dor',25,1),(202,7444601,7444597,'mod',33.333,1),(202,7444602,7444597,'ode',33.333,1),(202,7444603,7444597,'del',33.333,1),(202,7444604,7444601,'lun',100,1),(202,7444605,7444604,'cmo',33.333,1),(202,7444606,7444604,'mod',33.333,1),(202,7444607,7444604,'ode',33.333,1),(202,7444608,7444605,'rev',16.667,1),(202,7444609,7444605,'evi',16.667,1),(202,7444610,7444605,'vis',16.667,1),(202,7444611,7444605,'isi',16.667,1),(202,7444612,7444605,'sio',16.667,1),(202,7444613,7444605,'ion',16.667,1),(202,7444614,7444608,'810',50,1),(202,7444615,7444608,'100',50,1),(202,7444616,7444614,'scs',50,1),(202,7444617,7444614,'csi',50,1),(202,7444618,7444616,'lev',33.333,1),(202,7444619,7444616,'eve',33.333,1),(202,7444620,7444616,'vel',33.333,1),(202,7444621,7444618,'pse',25,1),(202,7444622,7444618,'seu',25,1),(202,7444623,7444618,'eud',25,1),(202,7444624,7444618,'udo',25,1),(202,7444625,7444621,'fal',33.333,6),(202,7444626,7444621,'als',33.333,6),(202,7444627,7444621,'lse',33.333,6),(202,7444628,7444625,'sta',25,3),(202,7444629,7444625,'tat',25,3),(202,7444630,7444625,'atu',25,3),(202,7444631,7444625,'tus',25,3),(202,7444632,7444628,'rdm',100,1),(202,7444633,7444632,'cap',20,1),(202,7444634,7444632,'apa',20,1),(202,7444635,7444632,'pab',20,1),(202,7444636,7444632,'abl',20,1),(202,7444637,7444632,'ble',20,1),(202,7444638,7444633,'tru',50,1),(202,7444639,7444633,'rue',50,1),(202,7444640,7444638,'loc',33.333,1),(202,7444641,7444638,'oca',33.333,1),(202,7444642,7444638,'cal',33.333,1),(202,7444643,7444640,'rem',14.286,1),(202,7444644,7444640,'emo',14.286,1),(202,7444645,7444640,'mov',14.286,1),(202,7444646,7444640,'ova',14.286,1),(202,7444647,7444640,'vab',14.286,1),(202,7444648,7444640,'abl',14.286,1),(202,7444649,7444640,'ble',14.286,1),(202,7444650,7444643,'ssd',100,1),(202,7444651,7444650,'off',20,1),(202,7444652,7444650,'ffl',20,1),(202,7444653,7444650,'fli',20,1),(202,7444654,7444650,'lin',20,1),(202,7444655,7444650,'ine',20,1),(202,7444656,7444651,'per',11.111,1),(202,7444657,7444651,'ere',11.111,1),(202,7444658,7444651,'ren',11.111,1),(202,7444659,7444651,'enn',11.111,1),(202,7444660,7444651,'nni',11.111,1),(202,7444661,7444651,'nia',11.111,1),(202,7444662,7444651,'ial',11.111,1),(202,7444663,7444651,'all',11.111,1),(202,7444664,7444651,'lly',11.111,1),(202,7444665,7444656,'res',16.667,1),(202,7444666,7444656,'ese',16.667,1),(202,7444667,7444656,'ser',16.667,1),(202,7444668,7444656,'erv',16.667,1),(202,7444669,7444656,'rve',16.667,1),(202,7444670,7444656,'ved',16.667,1),(202,7444671,7444665,'thi',50,1),(202,7444672,7444665,'hin',50,1),(202,7444673,7444671,'pro',10,1),(202,7444674,7444671,'rov',10,1),(202,7444675,7444671,'ovi',10,1),(202,7444676,7444671,'vis',10,1),(202,7444677,7444671,'isi',10,1),(202,7444678,7444671,'sio',10,1),(202,7444679,7444671,'ion',10,1),(202,7444680,7444671,'oni',10,1),(202,7444681,7444671,'nin',10,1),(202,7444682,7444671,'ing',10,1),(202,7444683,7444673,'yes',100,1),(202,7444684,7444683,'att',16.667,1),(202,7444685,7444683,'tta',16.667,1),(202,7444686,7444683,'tac',16.667,1),(202,7444687,7444683,'ach',16.667,1),(202,7444688,7444683,'che',16.667,1),(202,7444689,7444683,'hed',16.667,1),(202,7444690,7444684,'fil',20,1),(202,7444691,7444684,'ilt',20,1),(202,7444692,7444684,'lte',20,1),(202,7444693,7444684,'ter',20,1),(202,7444694,7444684,'ers',20,1),(202,7444695,7444690,'vaa',50,1),(202,7444696,7444690,'aai',50,1),(202,7444697,7444695,'unk',20,1),(202,7444698,7444695,'nkn',20,1),(202,7444699,7444695,'kno',20,1),(202,7444700,7444695,'now',20,1),(202,7444701,7444695,'own',20,1),(202,7444702,7444697,'oth',33.333,1),(202,7444703,7444697,'the',33.333,1),(202,7444704,7444697,'her',33.333,1),(202,7444705,7444702,'uid',50,1),(202,7444706,7444702,'ids',50,1),(202,7444707,7444705,'vml',100,1),(202,7444708,7444707,'dis',20,1),(202,7444709,7444707,'isp',20,1),(202,7444710,7444707,'spl',20,1),(202,7444711,7444707,'pla',20,1),(202,7444712,7444707,'lay',20,1),(202,7444713,7444708,'nam',50,1),(202,7444714,7444708,'ame',50,1),(203,7444716,7444715,'net',25,3),(203,7444717,7444715,'eta',25,3),(203,7444718,7444715,'tap',25,3),(203,7444719,7444715,'app',25,3),(203,7444720,7444716,'fib',33.333,2),(203,7444721,7444716,'ibr',33.333,2),(203,7444722,7444716,'bre',33.333,2),(203,7444723,7444720,'cha',20,2),(203,7444724,7444720,'han',20,2),(203,7444725,7444720,'ann',20,2),(203,7444726,7444720,'nne',20,2),(203,7444727,7444720,'nel',20,2),(203,7444728,7444723,'dis',50,2),(203,7444729,7444723,'isk',50,2),(203,7444730,7444728,'naa',100,4),(203,7444731,7444730,'600',3.333,4),(203,7444732,7444730,'00a',3.333,4),(203,7444733,7444730,'0a0',3.333,4),(203,7444734,7444730,'a09',3.333,4),(203,7444735,7444730,'098',3.333,4),(203,7444736,7444730,'980',3.333,4),(203,7444737,7444730,'804',3.333,4),(203,7444738,7444730,'044',3.333,4),(203,7444739,7444730,'443',3.333,4),(203,7444740,7444730,'430',3.333,4),(203,7444741,7444730,'307',3.333,4),(203,7444742,7444730,'075',3.333,4),(203,7444743,7444730,'753',3.333,4),(203,7444744,7444730,'535',3.333,4),(203,7444745,7444730,'357',3.333,4),(203,7444746,7444730,'573',3.333,4),(203,7444747,7444730,'732',3.333,4),(203,7444748,7444730,'32b',3.333,4),(203,7444749,7444730,'2b3',3.333,4),(203,7444750,7444730,'b33',3.333,4),(203,7444751,7444730,'334',3.333,4),(203,7444752,7444730,'345',3.333,4),(203,7444753,7444730,'457',3.333,4),(203,7444754,7444730,'571',3.333,4),(203,7444755,7444730,'715',3.333,4),(203,7444756,7444730,'152',3.333,4),(203,7444757,7444730,'527',3.333,4),(203,7444758,7444730,'275',3.333,4),(203,7444759,7444730,'754',3.333,4),(203,7444760,7444730,'545',3.333,4),(203,7444761,7444731,'ser',25,1),(203,7444762,7444731,'eri',25,1),(203,7444763,7444731,'ria',25,1),(203,7444764,7444731,'ial',25,1),(203,7444765,7444761,'siz',50,1),(203,7444766,7444761,'ize',50,1),(203,7444767,7444765,'460',33.333,1),(203,7444768,7444765,'608',33.333,1),(203,7444769,7444765,'080',33.333,1),(203,7444770,7444767,'dev',25,1),(203,7444771,7444767,'evi',25,1),(203,7444772,7444767,'vic',25,1),(203,7444773,7444767,'ice',25,1),(203,7444774,7444770,'typ',50,1),(203,7444775,7444770,'ype',50,1),(203,7444776,7444774,'dir',10,1),(203,7444777,7444774,'ire',10,1),(203,7444778,7444774,'rec',10,1),(203,7444779,7444774,'ect',10,1),(203,7444780,7444774,'cta',10,1),(203,7444781,7444774,'tac',10,1),(203,7444782,7444774,'acc',10,1),(203,7444783,7444774,'cce',10,1),(203,7444784,7444774,'ces',10,1),(203,7444785,7444774,'ess',10,1),(203,7444786,7444776,'mul',14.286,1),(203,7444787,7444776,'ult',14.286,1),(203,7444788,7444776,'lti',14.286,1),(203,7444789,7444776,'tip',14.286,1),(203,7444790,7444776,'ipa',14.286,1),(203,7444791,7444776,'pat',14.286,1),(203,7444792,7444776,'ath',14.286,1),(203,7444793,7444786,'plu',25,1),(203,7444794,7444786,'lug',25,1),(203,7444795,7444786,'ugi',25,1),(203,7444796,7444786,'gin',25,1),(203,7444797,7444793,'nmp',100,1),(203,7444798,7444797,'dev',33.333,1),(203,7444799,7444797,'evf',33.333,1),(203,7444800,7444797,'vfs',33.333,1),(203,7444801,7444798,'pat',50,1),(203,7444802,7444798,'ath',50,1),(203,7444803,7444801,'vmf',50,1),(203,7444804,7444801,'mfs',50,1),(203,7444805,7444803,'dev',20,1),(203,7444806,7444803,'evi',20,1),(203,7444807,7444803,'vic',20,1),(203,7444808,7444803,'ice',20,1),(203,7444809,7444803,'ces',20,1),(203,7444810,7444805,'dis',33.333,1),(203,7444811,7444805,'isk',33.333,1),(203,7444812,7444805,'sks',33.333,1),(203,7444813,7444810,'ven',25,1),(203,7444814,7444810,'end',25,1),(203,7444815,7444810,'ndo',25,1),(203,7444816,7444810,'dor',25,1),(203,7444817,7444813,'mod',33.333,1),(203,7444818,7444813,'ode',33.333,1),(203,7444819,7444813,'del',33.333,1),(203,7444820,7444817,'lun',100,1),(203,7444821,7444820,'cmo',33.333,1),(203,7444822,7444820,'mod',33.333,1),(203,7444823,7444820,'ode',33.333,1),(203,7444824,7444821,'rev',16.667,1),(203,7444825,7444821,'evi',16.667,1),(203,7444826,7444821,'vis',16.667,1),(203,7444827,7444821,'isi',16.667,1),(203,7444828,7444821,'sio',16.667,1),(203,7444829,7444821,'ion',16.667,1),(203,7444830,7444824,'810',50,1),(203,7444831,7444824,'100',50,1),(203,7444832,7444830,'scs',50,1),(203,7444833,7444830,'csi',50,1),(203,7444834,7444832,'lev',33.333,1),(203,7444835,7444832,'eve',33.333,1),(203,7444836,7444832,'vel',33.333,1),(203,7444837,7444834,'pse',25,1),(203,7444838,7444834,'seu',25,1),(203,7444839,7444834,'eud',25,1),(203,7444840,7444834,'udo',25,1),(203,7444841,7444837,'fal',33.333,6),(203,7444842,7444837,'als',33.333,6),(203,7444843,7444837,'lse',33.333,6),(203,7444844,7444841,'sta',25,3),(203,7444845,7444841,'tat',25,3),(203,7444846,7444841,'atu',25,3),(203,7444847,7444841,'tus',25,3),(203,7444848,7444844,'rdm',100,1),(203,7444849,7444848,'cap',20,1),(203,7444850,7444848,'apa',20,1),(203,7444851,7444848,'pab',20,1),(203,7444852,7444848,'abl',20,1),(203,7444853,7444848,'ble',20,1),(203,7444854,7444849,'tru',50,1),(203,7444855,7444849,'rue',50,1),(203,7444856,7444854,'loc',33.333,1),(203,7444857,7444854,'oca',33.333,1),(203,7444858,7444854,'cal',33.333,1),(203,7444859,7444856,'rem',14.286,1),(203,7444860,7444856,'emo',14.286,1),(203,7444861,7444856,'mov',14.286,1),(203,7444862,7444856,'ova',14.286,1),(203,7444863,7444856,'vab',14.286,1),(203,7444864,7444856,'abl',14.286,1),(203,7444865,7444856,'ble',14.286,1),(203,7444866,7444859,'ssd',100,1),(203,7444867,7444866,'off',20,1),(203,7444868,7444866,'ffl',20,1),(203,7444869,7444866,'fli',20,1),(203,7444870,7444866,'lin',20,1),(203,7444871,7444866,'ine',20,1),(203,7444872,7444867,'per',11.111,1),(203,7444873,7444867,'ere',11.111,1),(203,7444874,7444867,'ren',11.111,1),(203,7444875,7444867,'enn',11.111,1),(203,7444876,7444867,'nni',11.111,1),(203,7444877,7444867,'nia',11.111,1),(203,7444878,7444867,'ial',11.111,1),(203,7444879,7444867,'all',11.111,1),(203,7444880,7444867,'lly',11.111,1),(203,7444881,7444872,'res',16.667,1),(203,7444882,7444872,'ese',16.667,1),(203,7444883,7444872,'ser',16.667,1),(203,7444884,7444872,'erv',16.667,1),(203,7444885,7444872,'rve',16.667,1),(203,7444886,7444872,'ved',16.667,1),(203,7444887,7444881,'thi',50,1),(203,7444888,7444881,'hin',50,1),(203,7444889,7444887,'pro',10,1),(203,7444890,7444887,'rov',10,1),(203,7444891,7444887,'ovi',10,1),(203,7444892,7444887,'vis',10,1),(203,7444893,7444887,'isi',10,1),(203,7444894,7444887,'sio',10,1),(203,7444895,7444887,'ion',10,1),(203,7444896,7444887,'oni',10,1),(203,7444897,7444887,'nin',10,1),(203,7444898,7444887,'ing',10,1),(203,7444899,7444889,'yes',100,1),(203,7444900,7444899,'att',16.667,1),(203,7444901,7444899,'tta',16.667,1),(203,7444902,7444899,'tac',16.667,1),(203,7444903,7444899,'ach',16.667,1),(203,7444904,7444899,'che',16.667,1),(203,7444905,7444899,'hed',16.667,1),(203,7444906,7444900,'fil',20,1),(203,7444907,7444900,'ilt',20,1),(203,7444908,7444900,'lte',20,1),(203,7444909,7444900,'ter',20,1),(203,7444910,7444900,'ers',20,1),(203,7444911,7444906,'vaa',50,1),(203,7444912,7444906,'aai',50,1),(203,7444913,7444911,'unk',20,1),(203,7444914,7444911,'nkn',20,1),(203,7444915,7444911,'kno',20,1),(203,7444916,7444911,'now',20,1),(203,7444917,7444911,'own',20,1),(203,7444918,7444913,'oth',33.333,1),(203,7444919,7444913,'the',33.333,1),(203,7444920,7444913,'her',33.333,1),(203,7444921,7444918,'uid',50,1),(203,7444922,7444918,'ids',50,1),(203,7444923,7444921,'vml',100,1),(203,7444924,7444923,'dis',20,1),(203,7444925,7444923,'isp',20,1),(203,7444926,7444923,'spl',20,1),(203,7444927,7444923,'pla',20,1),(203,7444928,7444923,'lay',20,1),(203,7444929,7444924,'nam',50,1),(203,7444930,7444924,'ame',50,1),(204,7444932,7444931,'net',25,3),(204,7444933,7444931,'eta',25,3),(204,7444934,7444931,'tap',25,3),(204,7444935,7444931,'app',25,3),(204,7444936,7444932,'fib',33.333,2),(204,7444937,7444932,'ibr',33.333,2),(204,7444938,7444932,'bre',33.333,2),(204,7444939,7444936,'cha',20,2),(204,7444940,7444936,'han',20,2),(204,7444941,7444936,'ann',20,2),(204,7444942,7444936,'nne',20,2),(204,7444943,7444936,'nel',20,2),(204,7444944,7444939,'dis',50,2),(204,7444945,7444939,'isk',50,2),(204,7444946,7444944,'naa',100,4),(204,7444947,7444946,'600',3.333,4),(204,7444948,7444946,'00a',3.333,4),(204,7444949,7444946,'0a0',3.333,4),(204,7444950,7444946,'a09',3.333,4),(204,7444951,7444946,'098',3.333,4),(204,7444952,7444946,'980',3.333,4),(204,7444953,7444946,'804',3.333,4),(204,7444954,7444946,'044',3.333,4),(204,7444955,7444946,'443',3.333,4),(204,7444956,7444946,'430',3.333,4),(204,7444957,7444946,'307',3.333,4),(204,7444958,7444946,'075',3.333,4),(204,7444959,7444946,'753',3.333,4),(204,7444960,7444946,'535',3.333,4),(204,7444961,7444946,'357',3.333,4),(204,7444962,7444946,'573',3.333,4),(204,7444963,7444946,'732',3.333,4),(204,7444964,7444946,'32b',3.333,4),(204,7444965,7444946,'2b3',3.333,4),(204,7444966,7444946,'b33',3.333,4),(204,7444967,7444946,'334',3.333,4),(204,7444968,7444946,'345',3.333,4),(204,7444969,7444946,'457',3.333,4),(204,7444970,7444946,'571',3.333,4),(204,7444971,7444946,'715',3.333,4),(204,7444972,7444946,'152',3.333,4),(204,7444973,7444946,'527',3.333,4),(204,7444974,7444946,'275',3.333,4),(204,7444975,7444946,'754',3.333,4),(204,7444976,7444946,'546',3.333,4),(204,7444977,7444947,'ser',25,1),(204,7444978,7444947,'eri',25,1),(204,7444979,7444947,'ria',25,1),(204,7444980,7444947,'ial',25,1),(204,7444981,7444977,'siz',50,1),(204,7444982,7444977,'ize',50,1),(204,7444983,7444981,'460',33.333,1),(204,7444984,7444981,'608',33.333,1),(204,7444985,7444981,'080',33.333,1),(204,7444986,7444983,'dev',25,1),(204,7444987,7444983,'evi',25,1),(204,7444988,7444983,'vic',25,1),(204,7444989,7444983,'ice',25,1),(204,7444990,7444986,'typ',50,1),(204,7444991,7444986,'ype',50,1),(204,7444992,7444990,'dir',10,1),(204,7444993,7444990,'ire',10,1),(204,7444994,7444990,'rec',10,1),(204,7444995,7444990,'ect',10,1),(204,7444996,7444990,'cta',10,1),(204,7444997,7444990,'tac',10,1),(204,7444998,7444990,'acc',10,1),(204,7444999,7444990,'cce',10,1),(204,7445000,7444990,'ces',10,1),(204,7445001,7444990,'ess',10,1),(204,7445002,7444992,'mul',14.286,1),(204,7445003,7444992,'ult',14.286,1),(204,7445004,7444992,'lti',14.286,1),(204,7445005,7444992,'tip',14.286,1),(204,7445006,7444992,'ipa',14.286,1),(204,7445007,7444992,'pat',14.286,1),(204,7445008,7444992,'ath',14.286,1),(204,7445009,7445002,'plu',25,1),(204,7445010,7445002,'lug',25,1),(204,7445011,7445002,'ugi',25,1),(204,7445012,7445002,'gin',25,1),(204,7445013,7445009,'nmp',100,1),(204,7445014,7445013,'dev',33.333,1),(204,7445015,7445013,'evf',33.333,1),(204,7445016,7445013,'vfs',33.333,1),(204,7445017,7445014,'pat',50,1),(204,7445018,7445014,'ath',50,1),(204,7445019,7445017,'vmf',50,1),(204,7445020,7445017,'mfs',50,1),(204,7445021,7445019,'dev',20,1),(204,7445022,7445019,'evi',20,1),(204,7445023,7445019,'vic',20,1),(204,7445024,7445019,'ice',20,1),(204,7445025,7445019,'ces',20,1),(204,7445026,7445021,'dis',33.333,1),(204,7445027,7445021,'isk',33.333,1),(204,7445028,7445021,'sks',33.333,1),(204,7445029,7445026,'ven',25,1),(204,7445030,7445026,'end',25,1),(204,7445031,7445026,'ndo',25,1),(204,7445032,7445026,'dor',25,1),(204,7445033,7445029,'mod',33.333,1),(204,7445034,7445029,'ode',33.333,1),(204,7445035,7445029,'del',33.333,1),(204,7445036,7445033,'lun',100,1),(204,7445037,7445036,'cmo',33.333,1),(204,7445038,7445036,'mod',33.333,1),(204,7445039,7445036,'ode',33.333,1),(204,7445040,7445037,'rev',16.667,1),(204,7445041,7445037,'evi',16.667,1),(204,7445042,7445037,'vis',16.667,1),(204,7445043,7445037,'isi',16.667,1),(204,7445044,7445037,'sio',16.667,1),(204,7445045,7445037,'ion',16.667,1),(204,7445046,7445040,'810',50,1),(204,7445047,7445040,'100',50,1),(204,7445048,7445046,'scs',50,1),(204,7445049,7445046,'csi',50,1),(204,7445050,7445048,'lev',33.333,1),(204,7445051,7445048,'eve',33.333,1),(204,7445052,7445048,'vel',33.333,1),(204,7445053,7445050,'pse',25,1),(204,7445054,7445050,'seu',25,1),(204,7445055,7445050,'eud',25,1),(204,7445056,7445050,'udo',25,1),(204,7445057,7445053,'fal',33.333,6),(204,7445058,7445053,'als',33.333,6),(204,7445059,7445053,'lse',33.333,6),(204,7445060,7445057,'sta',25,3),(204,7445061,7445057,'tat',25,3),(204,7445062,7445057,'atu',25,3),(204,7445063,7445057,'tus',25,3),(204,7445064,7445060,'rdm',100,1),(204,7445065,7445064,'cap',20,1),(204,7445066,7445064,'apa',20,1),(204,7445067,7445064,'pab',20,1),(204,7445068,7445064,'abl',20,1),(204,7445069,7445064,'ble',20,1),(204,7445070,7445065,'tru',50,1),(204,7445071,7445065,'rue',50,1),(204,7445072,7445070,'loc',33.333,1),(204,7445073,7445070,'oca',33.333,1),(204,7445074,7445070,'cal',33.333,1),(204,7445075,7445072,'rem',14.286,1),(204,7445076,7445072,'emo',14.286,1),(204,7445077,7445072,'mov',14.286,1),(204,7445078,7445072,'ova',14.286,1),(204,7445079,7445072,'vab',14.286,1),(204,7445080,7445072,'abl',14.286,1),(204,7445081,7445072,'ble',14.286,1),(204,7445082,7445075,'ssd',100,1),(204,7445083,7445082,'off',20,1),(204,7445084,7445082,'ffl',20,1),(204,7445085,7445082,'fli',20,1),(204,7445086,7445082,'lin',20,1),(204,7445087,7445082,'ine',20,1),(204,7445088,7445083,'per',11.111,1),(204,7445089,7445083,'ere',11.111,1),(204,7445090,7445083,'ren',11.111,1),(204,7445091,7445083,'enn',11.111,1),(204,7445092,7445083,'nni',11.111,1),(204,7445093,7445083,'nia',11.111,1),(204,7445094,7445083,'ial',11.111,1),(204,7445095,7445083,'all',11.111,1),(204,7445096,7445083,'lly',11.111,1),(204,7445097,7445088,'res',16.667,1),(204,7445098,7445088,'ese',16.667,1),(204,7445099,7445088,'ser',16.667,1),(204,7445100,7445088,'erv',16.667,1),(204,7445101,7445088,'rve',16.667,1),(204,7445102,7445088,'ved',16.667,1),(204,7445103,7445097,'thi',50,1),(204,7445104,7445097,'hin',50,1),(204,7445105,7445103,'pro',10,1),(204,7445106,7445103,'rov',10,1),(204,7445107,7445103,'ovi',10,1),(204,7445108,7445103,'vis',10,1),(204,7445109,7445103,'isi',10,1),(204,7445110,7445103,'sio',10,1),(204,7445111,7445103,'ion',10,1),(204,7445112,7445103,'oni',10,1),(204,7445113,7445103,'nin',10,1),(204,7445114,7445103,'ing',10,1),(204,7445115,7445105,'yes',100,1),(204,7445116,7445115,'att',16.667,1),(204,7445117,7445115,'tta',16.667,1),(204,7445118,7445115,'tac',16.667,1),(204,7445119,7445115,'ach',16.667,1),(204,7445120,7445115,'che',16.667,1),(204,7445121,7445115,'hed',16.667,1),(204,7445122,7445116,'fil',20,1),(204,7445123,7445116,'ilt',20,1),(204,7445124,7445116,'lte',20,1),(204,7445125,7445116,'ter',20,1),(204,7445126,7445116,'ers',20,1),(204,7445127,7445122,'vaa',50,1),(204,7445128,7445122,'aai',50,1),(204,7445129,7445127,'unk',20,1),(204,7445130,7445127,'nkn',20,1),(204,7445131,7445127,'kno',20,1),(204,7445132,7445127,'now',20,1),(204,7445133,7445127,'own',20,1),(204,7445134,7445129,'oth',33.333,1),(204,7445135,7445129,'the',33.333,1),(204,7445136,7445129,'her',33.333,1),(204,7445137,7445134,'uid',50,1),(204,7445138,7445134,'ids',50,1),(204,7445139,7445137,'vml',100,1),(204,7445140,7445139,'dis',20,1),(204,7445141,7445139,'isp',20,1),(204,7445142,7445139,'spl',20,1),(204,7445143,7445139,'pla',20,1),(204,7445144,7445139,'lay',20,1),(204,7445145,7445140,'nam',50,1),(204,7445146,7445140,'ame',50,1),(205,7445148,7445147,'net',25,3),(205,7445149,7445147,'eta',25,3),(205,7445150,7445147,'tap',25,3),(205,7445151,7445147,'app',25,3),(205,7445152,7445148,'fib',33.333,2),(205,7445153,7445148,'ibr',33.333,2),(205,7445154,7445148,'bre',33.333,2),(205,7445155,7445152,'cha',20,2),(205,7445156,7445152,'han',20,2),(205,7445157,7445152,'ann',20,2),(205,7445158,7445152,'nne',20,2),(205,7445159,7445152,'nel',20,2),(205,7445160,7445155,'dis',50,2),(205,7445161,7445155,'isk',50,2),(205,7445162,7445160,'naa',100,4),(205,7445163,7445162,'600',3.333,4),(205,7445164,7445162,'00a',3.333,4),(205,7445165,7445162,'0a0',3.333,4),(205,7445166,7445162,'a09',3.333,4),(205,7445167,7445162,'098',3.333,4),(205,7445168,7445162,'980',3.333,4),(205,7445169,7445162,'804',3.333,4),(205,7445170,7445162,'044',3.333,4),(205,7445171,7445162,'443',3.333,4),(205,7445172,7445162,'430',3.333,4),(205,7445173,7445162,'307',3.333,4),(205,7445174,7445162,'075',3.333,4),(205,7445175,7445162,'753',3.333,4),(205,7445176,7445162,'535',3.333,4),(205,7445177,7445162,'357',3.333,4),(205,7445178,7445162,'573',3.333,4),(205,7445179,7445162,'732',3.333,4),(205,7445180,7445162,'32b',3.333,4),(205,7445181,7445162,'2b3',3.333,4),(205,7445182,7445162,'b33',3.333,4),(205,7445183,7445162,'334',3.333,4),(205,7445184,7445162,'345',3.333,4),(205,7445185,7445162,'457',3.333,4),(205,7445186,7445162,'571',3.333,4),(205,7445187,7445162,'715',3.333,4),(205,7445188,7445162,'152',3.333,4),(205,7445189,7445162,'527',3.333,4),(205,7445190,7445162,'275',3.333,4),(205,7445191,7445162,'754',3.333,4),(205,7445192,7445162,'547',3.333,4),(205,7445193,7445163,'ser',25,1),(205,7445194,7445163,'eri',25,1),(205,7445195,7445163,'ria',25,1),(205,7445196,7445163,'ial',25,1),(205,7445197,7445193,'siz',50,1),(205,7445198,7445193,'ize',50,1),(205,7445199,7445197,'460',33.333,1),(205,7445200,7445197,'608',33.333,1),(205,7445201,7445197,'080',33.333,1),(205,7445202,7445199,'dev',25,1),(205,7445203,7445199,'evi',25,1),(205,7445204,7445199,'vic',25,1),(205,7445205,7445199,'ice',25,1),(205,7445206,7445202,'typ',50,1),(205,7445207,7445202,'ype',50,1),(205,7445208,7445206,'dir',10,1),(205,7445209,7445206,'ire',10,1),(205,7445210,7445206,'rec',10,1),(205,7445211,7445206,'ect',10,1),(205,7445212,7445206,'cta',10,1),(205,7445213,7445206,'tac',10,1),(205,7445214,7445206,'acc',10,1),(205,7445215,7445206,'cce',10,1),(205,7445216,7445206,'ces',10,1),(205,7445217,7445206,'ess',10,1),(205,7445218,7445208,'mul',14.286,1),(205,7445219,7445208,'ult',14.286,1),(205,7445220,7445208,'lti',14.286,1),(205,7445221,7445208,'tip',14.286,1),(205,7445222,7445208,'ipa',14.286,1),(205,7445223,7445208,'pat',14.286,1),(205,7445224,7445208,'ath',14.286,1),(205,7445225,7445218,'plu',25,1),(205,7445226,7445218,'lug',25,1),(205,7445227,7445218,'ugi',25,1),(205,7445228,7445218,'gin',25,1),(205,7445229,7445225,'nmp',100,1),(205,7445230,7445229,'dev',33.333,1),(205,7445231,7445229,'evf',33.333,1),(205,7445232,7445229,'vfs',33.333,1),(205,7445233,7445230,'pat',50,1),(205,7445234,7445230,'ath',50,1),(205,7445235,7445233,'vmf',50,1),(205,7445236,7445233,'mfs',50,1),(205,7445237,7445235,'dev',20,1),(205,7445238,7445235,'evi',20,1),(205,7445239,7445235,'vic',20,1),(205,7445240,7445235,'ice',20,1),(205,7445241,7445235,'ces',20,1),(205,7445242,7445237,'dis',33.333,1),(205,7445243,7445237,'isk',33.333,1),(205,7445244,7445237,'sks',33.333,1),(205,7445245,7445242,'ven',25,1),(205,7445246,7445242,'end',25,1),(205,7445247,7445242,'ndo',25,1),(205,7445248,7445242,'dor',25,1),(205,7445249,7445245,'mod',33.333,1),(205,7445250,7445245,'ode',33.333,1),(205,7445251,7445245,'del',33.333,1),(205,7445252,7445249,'lun',100,1),(205,7445253,7445252,'cmo',33.333,1),(205,7445254,7445252,'mod',33.333,1),(205,7445255,7445252,'ode',33.333,1),(205,7445256,7445253,'rev',16.667,1),(205,7445257,7445253,'evi',16.667,1),(205,7445258,7445253,'vis',16.667,1),(205,7445259,7445253,'isi',16.667,1),(205,7445260,7445253,'sio',16.667,1),(205,7445261,7445253,'ion',16.667,1),(205,7445262,7445256,'810',50,1),(205,7445263,7445256,'100',50,1),(205,7445264,7445262,'scs',50,1),(205,7445265,7445262,'csi',50,1),(205,7445266,7445264,'lev',33.333,1),(205,7445267,7445264,'eve',33.333,1),(205,7445268,7445264,'vel',33.333,1),(205,7445269,7445266,'pse',25,1),(205,7445270,7445266,'seu',25,1),(205,7445271,7445266,'eud',25,1),(205,7445272,7445266,'udo',25,1),(205,7445273,7445269,'fal',33.333,6),(205,7445274,7445269,'als',33.333,6),(205,7445275,7445269,'lse',33.333,6),(205,7445276,7445273,'sta',25,3),(205,7445277,7445273,'tat',25,3),(205,7445278,7445273,'atu',25,3),(205,7445279,7445273,'tus',25,3),(205,7445280,7445276,'rdm',100,1),(205,7445281,7445280,'cap',20,1),(205,7445282,7445280,'apa',20,1),(205,7445283,7445280,'pab',20,1),(205,7445284,7445280,'abl',20,1),(205,7445285,7445280,'ble',20,1),(205,7445286,7445281,'tru',50,1),(205,7445287,7445281,'rue',50,1),(205,7445288,7445286,'loc',33.333,1),(205,7445289,7445286,'oca',33.333,1),(205,7445290,7445286,'cal',33.333,1),(205,7445291,7445288,'rem',14.286,1),(205,7445292,7445288,'emo',14.286,1),(205,7445293,7445288,'mov',14.286,1),(205,7445294,7445288,'ova',14.286,1),(205,7445295,7445288,'vab',14.286,1),(205,7445296,7445288,'abl',14.286,1),(205,7445297,7445288,'ble',14.286,1),(205,7445298,7445291,'ssd',100,1),(205,7445299,7445298,'off',20,1),(205,7445300,7445298,'ffl',20,1),(205,7445301,7445298,'fli',20,1),(205,7445302,7445298,'lin',20,1),(205,7445303,7445298,'ine',20,1),(205,7445304,7445299,'per',11.111,1),(205,7445305,7445299,'ere',11.111,1),(205,7445306,7445299,'ren',11.111,1),(205,7445307,7445299,'enn',11.111,1),(205,7445308,7445299,'nni',11.111,1),(205,7445309,7445299,'nia',11.111,1),(205,7445310,7445299,'ial',11.111,1),(205,7445311,7445299,'all',11.111,1),(205,7445312,7445299,'lly',11.111,1),(205,7445313,7445304,'res',16.667,1),(205,7445314,7445304,'ese',16.667,1),(205,7445315,7445304,'ser',16.667,1),(205,7445316,7445304,'erv',16.667,1),(205,7445317,7445304,'rve',16.667,1),(205,7445318,7445304,'ved',16.667,1),(205,7445319,7445313,'thi',50,1),(205,7445320,7445313,'hin',50,1),(205,7445321,7445319,'pro',10,1),(205,7445322,7445319,'rov',10,1),(205,7445323,7445319,'ovi',10,1),(205,7445324,7445319,'vis',10,1),(205,7445325,7445319,'isi',10,1),(205,7445326,7445319,'sio',10,1),(205,7445327,7445319,'ion',10,1),(205,7445328,7445319,'oni',10,1),(205,7445329,7445319,'nin',10,1),(205,7445330,7445319,'ing',10,1),(205,7445331,7445321,'yes',100,1),(205,7445332,7445331,'att',16.667,1),(205,7445333,7445331,'tta',16.667,1),(205,7445334,7445331,'tac',16.667,1),(205,7445335,7445331,'ach',16.667,1),(205,7445336,7445331,'che',16.667,1),(205,7445337,7445331,'hed',16.667,1),(205,7445338,7445332,'fil',20,1),(205,7445339,7445332,'ilt',20,1),(205,7445340,7445332,'lte',20,1),(205,7445341,7445332,'ter',20,1),(205,7445342,7445332,'ers',20,1),(205,7445343,7445338,'vaa',50,1),(205,7445344,7445338,'aai',50,1),(205,7445345,7445343,'unk',20,1),(205,7445346,7445343,'nkn',20,1),(205,7445347,7445343,'kno',20,1),(205,7445348,7445343,'now',20,1),(205,7445349,7445343,'own',20,1),(205,7445350,7445345,'oth',33.333,1),(205,7445351,7445345,'the',33.333,1),(205,7445352,7445345,'her',33.333,1),(205,7445353,7445350,'uid',50,1),(205,7445354,7445350,'ids',50,1),(205,7445355,7445353,'vml',100,1),(205,7445356,7445355,'dis',20,1),(205,7445357,7445355,'isp',20,1),(205,7445358,7445355,'spl',20,1),(205,7445359,7445355,'pla',20,1),(205,7445360,7445355,'lay',20,1),(205,7445361,7445356,'nam',50,1),(205,7445362,7445356,'ame',50,1),(206,7445364,7445363,'net',25,3),(206,7445365,7445363,'eta',25,3),(206,7445366,7445363,'tap',25,3),(206,7445367,7445363,'app',25,3),(206,7445368,7445364,'fib',33.333,2),(206,7445369,7445364,'ibr',33.333,2),(206,7445370,7445364,'bre',33.333,2),(206,7445371,7445368,'cha',20,2),(206,7445372,7445368,'han',20,2),(206,7445373,7445368,'ann',20,2),(206,7445374,7445368,'nne',20,2),(206,7445375,7445368,'nel',20,2),(206,7445376,7445371,'dis',50,2),(206,7445377,7445371,'isk',50,2),(206,7445378,7445376,'naa',100,4),(206,7445379,7445378,'600',3.333,4),(206,7445380,7445378,'00a',3.333,4),(206,7445381,7445378,'0a0',3.333,4),(206,7445382,7445378,'a09',3.333,4),(206,7445383,7445378,'098',3.333,4),(206,7445384,7445378,'980',3.333,4),(206,7445385,7445378,'804',3.333,4),(206,7445386,7445378,'044',3.333,4),(206,7445387,7445378,'443',3.333,4),(206,7445388,7445378,'430',3.333,4),(206,7445389,7445378,'307',3.333,4),(206,7445390,7445378,'075',3.333,4),(206,7445391,7445378,'753',3.333,4),(206,7445392,7445378,'535',3.333,4),(206,7445393,7445378,'357',3.333,4),(206,7445394,7445378,'573',3.333,4),(206,7445395,7445378,'732',3.333,4),(206,7445396,7445378,'32b',3.333,4),(206,7445397,7445378,'2b3',3.333,4),(206,7445398,7445378,'b33',3.333,4),(206,7445399,7445378,'334',3.333,4),(206,7445400,7445378,'345',3.333,4),(206,7445401,7445378,'457',3.333,4),(206,7445402,7445378,'571',3.333,4),(206,7445403,7445378,'715',3.333,4),(206,7445404,7445378,'152',3.333,4),(206,7445405,7445378,'527',3.333,4),(206,7445406,7445378,'275',3.333,4),(206,7445407,7445378,'754',3.333,4),(206,7445408,7445378,'548',3.333,4),(206,7445409,7445379,'ser',25,1),(206,7445410,7445379,'eri',25,1),(206,7445411,7445379,'ria',25,1),(206,7445412,7445379,'ial',25,1),(206,7445413,7445409,'siz',50,1),(206,7445414,7445409,'ize',50,1),(206,7445415,7445413,'460',33.333,1),(206,7445416,7445413,'608',33.333,1),(206,7445417,7445413,'080',33.333,1),(206,7445418,7445415,'dev',25,1),(206,7445419,7445415,'evi',25,1),(206,7445420,7445415,'vic',25,1),(206,7445421,7445415,'ice',25,1),(206,7445422,7445418,'typ',50,1),(206,7445423,7445418,'ype',50,1),(206,7445424,7445422,'dir',10,1),(206,7445425,7445422,'ire',10,1),(206,7445426,7445422,'rec',10,1),(206,7445427,7445422,'ect',10,1),(206,7445428,7445422,'cta',10,1),(206,7445429,7445422,'tac',10,1),(206,7445430,7445422,'acc',10,1),(206,7445431,7445422,'cce',10,1),(206,7445432,7445422,'ces',10,1),(206,7445433,7445422,'ess',10,1),(206,7445434,7445424,'mul',14.286,1),(206,7445435,7445424,'ult',14.286,1),(206,7445436,7445424,'lti',14.286,1),(206,7445437,7445424,'tip',14.286,1),(206,7445438,7445424,'ipa',14.286,1),(206,7445439,7445424,'pat',14.286,1),(206,7445440,7445424,'ath',14.286,1),(206,7445441,7445434,'plu',25,1),(206,7445442,7445434,'lug',25,1),(206,7445443,7445434,'ugi',25,1),(206,7445444,7445434,'gin',25,1),(206,7445445,7445441,'nmp',100,1),(206,7445446,7445445,'dev',33.333,1),(206,7445447,7445445,'evf',33.333,1),(206,7445448,7445445,'vfs',33.333,1),(206,7445449,7445446,'pat',50,1),(206,7445450,7445446,'ath',50,1),(206,7445451,7445449,'vmf',50,1),(206,7445452,7445449,'mfs',50,1),(206,7445453,7445451,'dev',20,1),(206,7445454,7445451,'evi',20,1),(206,7445455,7445451,'vic',20,1),(206,7445456,7445451,'ice',20,1),(206,7445457,7445451,'ces',20,1),(206,7445458,7445453,'dis',33.333,1),(206,7445459,7445453,'isk',33.333,1),(206,7445460,7445453,'sks',33.333,1),(206,7445461,7445458,'ven',25,1),(206,7445462,7445458,'end',25,1),(206,7445463,7445458,'ndo',25,1),(206,7445464,7445458,'dor',25,1),(206,7445465,7445461,'mod',33.333,1),(206,7445466,7445461,'ode',33.333,1),(206,7445467,7445461,'del',33.333,1),(206,7445468,7445465,'lun',100,1),(206,7445469,7445468,'cmo',33.333,1),(206,7445470,7445468,'mod',33.333,1),(206,7445471,7445468,'ode',33.333,1),(206,7445472,7445469,'rev',16.667,1),(206,7445473,7445469,'evi',16.667,1),(206,7445474,7445469,'vis',16.667,1),(206,7445475,7445469,'isi',16.667,1),(206,7445476,7445469,'sio',16.667,1),(206,7445477,7445469,'ion',16.667,1),(206,7445478,7445472,'810',50,1),(206,7445479,7445472,'100',50,1),(206,7445480,7445478,'scs',50,1),(206,7445481,7445478,'csi',50,1),(206,7445482,7445480,'lev',33.333,1),(206,7445483,7445480,'eve',33.333,1),(206,7445484,7445480,'vel',33.333,1),(206,7445485,7445482,'pse',25,1),(206,7445486,7445482,'seu',25,1),(206,7445487,7445482,'eud',25,1),(206,7445488,7445482,'udo',25,1),(206,7445489,7445485,'fal',33.333,6),(206,7445490,7445485,'als',33.333,6),(206,7445491,7445485,'lse',33.333,6),(206,7445492,7445489,'sta',25,3),(206,7445493,7445489,'tat',25,3),(206,7445494,7445489,'atu',25,3),(206,7445495,7445489,'tus',25,3),(206,7445496,7445492,'rdm',100,1),(206,7445497,7445496,'cap',20,1),(206,7445498,7445496,'apa',20,1),(206,7445499,7445496,'pab',20,1),(206,7445500,7445496,'abl',20,1),(206,7445501,7445496,'ble',20,1),(206,7445502,7445497,'tru',50,1),(206,7445503,7445497,'rue',50,1),(206,7445504,7445502,'loc',33.333,1),(206,7445505,7445502,'oca',33.333,1),(206,7445506,7445502,'cal',33.333,1),(206,7445507,7445504,'rem',14.286,1),(206,7445508,7445504,'emo',14.286,1),(206,7445509,7445504,'mov',14.286,1),(206,7445510,7445504,'ova',14.286,1),(206,7445511,7445504,'vab',14.286,1),(206,7445512,7445504,'abl',14.286,1),(206,7445513,7445504,'ble',14.286,1),(206,7445514,7445507,'ssd',100,1),(206,7445515,7445514,'off',20,1),(206,7445516,7445514,'ffl',20,1),(206,7445517,7445514,'fli',20,1),(206,7445518,7445514,'lin',20,1),(206,7445519,7445514,'ine',20,1),(206,7445520,7445515,'per',11.111,1),(206,7445521,7445515,'ere',11.111,1),(206,7445522,7445515,'ren',11.111,1),(206,7445523,7445515,'enn',11.111,1),(206,7445524,7445515,'nni',11.111,1),(206,7445525,7445515,'nia',11.111,1),(206,7445526,7445515,'ial',11.111,1),(206,7445527,7445515,'all',11.111,1),(206,7445528,7445515,'lly',11.111,1),(206,7445529,7445520,'res',16.667,1),(206,7445530,7445520,'ese',16.667,1),(206,7445531,7445520,'ser',16.667,1),(206,7445532,7445520,'erv',16.667,1),(206,7445533,7445520,'rve',16.667,1),(206,7445534,7445520,'ved',16.667,1),(206,7445535,7445529,'thi',50,1),(206,7445536,7445529,'hin',50,1),(206,7445537,7445535,'pro',10,1),(206,7445538,7445535,'rov',10,1),(206,7445539,7445535,'ovi',10,1),(206,7445540,7445535,'vis',10,1),(206,7445541,7445535,'isi',10,1),(206,7445542,7445535,'sio',10,1),(206,7445543,7445535,'ion',10,1),(206,7445544,7445535,'oni',10,1),(206,7445545,7445535,'nin',10,1),(206,7445546,7445535,'ing',10,1),(206,7445547,7445537,'yes',100,1),(206,7445548,7445547,'att',16.667,1),(206,7445549,7445547,'tta',16.667,1),(206,7445550,7445547,'tac',16.667,1),(206,7445551,7445547,'ach',16.667,1),(206,7445552,7445547,'che',16.667,1),(206,7445553,7445547,'hed',16.667,1),(206,7445554,7445548,'fil',20,1),(206,7445555,7445548,'ilt',20,1),(206,7445556,7445548,'lte',20,1),(206,7445557,7445548,'ter',20,1),(206,7445558,7445548,'ers',20,1),(206,7445559,7445554,'vaa',50,1),(206,7445560,7445554,'aai',50,1),(206,7445561,7445559,'unk',20,1),(206,7445562,7445559,'nkn',20,1),(206,7445563,7445559,'kno',20,1),(206,7445564,7445559,'now',20,1),(206,7445565,7445559,'own',20,1),(206,7445566,7445561,'oth',33.333,1),(206,7445567,7445561,'the',33.333,1),(206,7445568,7445561,'her',33.333,1),(206,7445569,7445566,'uid',50,1),(206,7445570,7445566,'ids',50,1),(206,7445571,7445569,'vml',100,1),(206,7445572,7445571,'dis',20,1),(206,7445573,7445571,'isp',20,1),(206,7445574,7445571,'spl',20,1),(206,7445575,7445571,'pla',20,1),(206,7445576,7445571,'lay',20,1),(206,7445577,7445572,'nam',50,1),(206,7445578,7445572,'ame',50,1),(207,7445580,7445579,'net',25,3),(207,7445581,7445579,'eta',25,3),(207,7445582,7445579,'tap',25,3),(207,7445583,7445579,'app',25,3),(207,7445584,7445580,'fib',33.333,2),(207,7445585,7445580,'ibr',33.333,2),(207,7445586,7445580,'bre',33.333,2),(207,7445587,7445584,'cha',20,2),(207,7445588,7445584,'han',20,2),(207,7445589,7445584,'ann',20,2),(207,7445590,7445584,'nne',20,2),(207,7445591,7445584,'nel',20,2),(207,7445592,7445587,'dis',50,2),(207,7445593,7445587,'isk',50,2),(207,7445594,7445592,'naa',100,4),(207,7445595,7445594,'600',3.333,4),(207,7445596,7445594,'00a',3.333,4),(207,7445597,7445594,'0a0',3.333,4),(207,7445598,7445594,'a09',3.333,4),(207,7445599,7445594,'098',3.333,4),(207,7445600,7445594,'980',3.333,4),(207,7445601,7445594,'804',3.333,4),(207,7445602,7445594,'044',3.333,4),(207,7445603,7445594,'443',3.333,4),(207,7445604,7445594,'430',3.333,4),(207,7445605,7445594,'307',3.333,4),(207,7445606,7445594,'075',3.333,4),(207,7445607,7445594,'753',3.333,4),(207,7445608,7445594,'535',3.333,4),(207,7445609,7445594,'357',3.333,4),(207,7445610,7445594,'573',3.333,4),(207,7445611,7445594,'732',3.333,4),(207,7445612,7445594,'32b',3.333,4),(207,7445613,7445594,'2b3',3.333,4),(207,7445614,7445594,'b33',3.333,4),(207,7445615,7445594,'334',3.333,4),(207,7445616,7445594,'345',3.333,4),(207,7445617,7445594,'457',3.333,4),(207,7445618,7445594,'571',3.333,4),(207,7445619,7445594,'715',3.333,4),(207,7445620,7445594,'152',3.333,4),(207,7445621,7445594,'527',3.333,4),(207,7445622,7445594,'275',3.333,4),(207,7445623,7445594,'754',3.333,4),(207,7445624,7445594,'549',3.333,4),(207,7445625,7445595,'ser',25,1),(207,7445626,7445595,'eri',25,1),(207,7445627,7445595,'ria',25,1),(207,7445628,7445595,'ial',25,1),(207,7445629,7445625,'siz',50,1),(207,7445630,7445625,'ize',50,1),(207,7445631,7445629,'460',33.333,1),(207,7445632,7445629,'608',33.333,1),(207,7445633,7445629,'080',33.333,1),(207,7445634,7445631,'dev',25,1),(207,7445635,7445631,'evi',25,1),(207,7445636,7445631,'vic',25,1),(207,7445637,7445631,'ice',25,1),(207,7445638,7445634,'typ',50,1),(207,7445639,7445634,'ype',50,1),(207,7445640,7445638,'dir',10,1),(207,7445641,7445638,'ire',10,1),(207,7445642,7445638,'rec',10,1),(207,7445643,7445638,'ect',10,1),(207,7445644,7445638,'cta',10,1),(207,7445645,7445638,'tac',10,1),(207,7445646,7445638,'acc',10,1),(207,7445647,7445638,'cce',10,1),(207,7445648,7445638,'ces',10,1),(207,7445649,7445638,'ess',10,1),(207,7445650,7445640,'mul',14.286,1),(207,7445651,7445640,'ult',14.286,1),(207,7445652,7445640,'lti',14.286,1),(207,7445653,7445640,'tip',14.286,1),(207,7445654,7445640,'ipa',14.286,1),(207,7445655,7445640,'pat',14.286,1),(207,7445656,7445640,'ath',14.286,1),(207,7445657,7445650,'plu',25,1),(207,7445658,7445650,'lug',25,1),(207,7445659,7445650,'ugi',25,1),(207,7445660,7445650,'gin',25,1),(207,7445661,7445657,'nmp',100,1),(207,7445662,7445661,'dev',33.333,1),(207,7445663,7445661,'evf',33.333,1),(207,7445664,7445661,'vfs',33.333,1),(207,7445665,7445662,'pat',50,1),(207,7445666,7445662,'ath',50,1),(207,7445667,7445665,'vmf',50,1),(207,7445668,7445665,'mfs',50,1),(207,7445669,7445667,'dev',20,1),(207,7445670,7445667,'evi',20,1),(207,7445671,7445667,'vic',20,1),(207,7445672,7445667,'ice',20,1),(207,7445673,7445667,'ces',20,1),(207,7445674,7445669,'dis',33.333,1),(207,7445675,7445669,'isk',33.333,1),(207,7445676,7445669,'sks',33.333,1),(207,7445677,7445674,'ven',25,1),(207,7445678,7445674,'end',25,1),(207,7445679,7445674,'ndo',25,1),(207,7445680,7445674,'dor',25,1),(207,7445681,7445677,'mod',33.333,1),(207,7445682,7445677,'ode',33.333,1),(207,7445683,7445677,'del',33.333,1),(207,7445684,7445681,'lun',100,1),(207,7445685,7445684,'cmo',33.333,1),(207,7445686,7445684,'mod',33.333,1),(207,7445687,7445684,'ode',33.333,1),(207,7445688,7445685,'rev',16.667,1),(207,7445689,7445685,'evi',16.667,1),(207,7445690,7445685,'vis',16.667,1),(207,7445691,7445685,'isi',16.667,1),(207,7445692,7445685,'sio',16.667,1),(207,7445693,7445685,'ion',16.667,1),(207,7445694,7445688,'810',50,1),(207,7445695,7445688,'100',50,1),(207,7445696,7445694,'scs',50,1),(207,7445697,7445694,'csi',50,1),(207,7445698,7445696,'lev',33.333,1),(207,7445699,7445696,'eve',33.333,1),(207,7445700,7445696,'vel',33.333,1),(207,7445701,7445698,'pse',25,1),(207,7445702,7445698,'seu',25,1),(207,7445703,7445698,'eud',25,1),(207,7445704,7445698,'udo',25,1),(207,7445705,7445701,'fal',33.333,6),(207,7445706,7445701,'als',33.333,6),(207,7445707,7445701,'lse',33.333,6),(207,7445708,7445705,'sta',25,3),(207,7445709,7445705,'tat',25,3),(207,7445710,7445705,'atu',25,3),(207,7445711,7445705,'tus',25,3),(207,7445712,7445708,'rdm',100,1),(207,7445713,7445712,'cap',20,1),(207,7445714,7445712,'apa',20,1),(207,7445715,7445712,'pab',20,1),(207,7445716,7445712,'abl',20,1),(207,7445717,7445712,'ble',20,1),(207,7445718,7445713,'tru',50,1),(207,7445719,7445713,'rue',50,1),(207,7445720,7445718,'loc',33.333,1),(207,7445721,7445718,'oca',33.333,1),(207,7445722,7445718,'cal',33.333,1),(207,7445723,7445720,'rem',14.286,1),(207,7445724,7445720,'emo',14.286,1),(207,7445725,7445720,'mov',14.286,1),(207,7445726,7445720,'ova',14.286,1),(207,7445727,7445720,'vab',14.286,1),(207,7445728,7445720,'abl',14.286,1),(207,7445729,7445720,'ble',14.286,1),(207,7445730,7445723,'ssd',100,1),(207,7445731,7445730,'off',20,1),(207,7445732,7445730,'ffl',20,1),(207,7445733,7445730,'fli',20,1),(207,7445734,7445730,'lin',20,1),(207,7445735,7445730,'ine',20,1),(207,7445736,7445731,'per',11.111,1),(207,7445737,7445731,'ere',11.111,1),(207,7445738,7445731,'ren',11.111,1),(207,7445739,7445731,'enn',11.111,1),(207,7445740,7445731,'nni',11.111,1),(207,7445741,7445731,'nia',11.111,1),(207,7445742,7445731,'ial',11.111,1),(207,7445743,7445731,'all',11.111,1),(207,7445744,7445731,'lly',11.111,1),(207,7445745,7445736,'res',16.667,1),(207,7445746,7445736,'ese',16.667,1),(207,7445747,7445736,'ser',16.667,1),(207,7445748,7445736,'erv',16.667,1),(207,7445749,7445736,'rve',16.667,1),(207,7445750,7445736,'ved',16.667,1),(207,7445751,7445745,'thi',50,1),(207,7445752,7445745,'hin',50,1),(207,7445753,7445751,'pro',10,1),(207,7445754,7445751,'rov',10,1),(207,7445755,7445751,'ovi',10,1),(207,7445756,7445751,'vis',10,1),(207,7445757,7445751,'isi',10,1),(207,7445758,7445751,'sio',10,1),(207,7445759,7445751,'ion',10,1),(207,7445760,7445751,'oni',10,1),(207,7445761,7445751,'nin',10,1),(207,7445762,7445751,'ing',10,1),(207,7445763,7445753,'yes',100,1),(207,7445764,7445763,'att',16.667,1),(207,7445765,7445763,'tta',16.667,1),(207,7445766,7445763,'tac',16.667,1),(207,7445767,7445763,'ach',16.667,1),(207,7445768,7445763,'che',16.667,1),(207,7445769,7445763,'hed',16.667,1),(207,7445770,7445764,'fil',20,1),(207,7445771,7445764,'ilt',20,1),(207,7445772,7445764,'lte',20,1),(207,7445773,7445764,'ter',20,1),(207,7445774,7445764,'ers',20,1),(207,7445775,7445770,'vaa',50,1),(207,7445776,7445770,'aai',50,1),(207,7445777,7445775,'unk',20,1),(207,7445778,7445775,'nkn',20,1),(207,7445779,7445775,'kno',20,1),(207,7445780,7445775,'now',20,1),(207,7445781,7445775,'own',20,1),(207,7445782,7445777,'oth',33.333,1),(207,7445783,7445777,'the',33.333,1),(207,7445784,7445777,'her',33.333,1),(207,7445785,7445782,'uid',50,1),(207,7445786,7445782,'ids',50,1),(207,7445787,7445785,'vml',100,1),(207,7445788,7445787,'dis',20,1),(207,7445789,7445787,'isp',20,1),(207,7445790,7445787,'spl',20,1),(207,7445791,7445787,'pla',20,1),(207,7445792,7445787,'lay',20,1),(207,7445793,7445788,'nam',50,1),(207,7445794,7445788,'ame',50,1),(208,7445796,7445795,'net',25,3),(208,7445797,7445795,'eta',25,3),(208,7445798,7445795,'tap',25,3),(208,7445799,7445795,'app',25,3),(208,7445800,7445796,'fib',33.333,2),(208,7445801,7445796,'ibr',33.333,2),(208,7445802,7445796,'bre',33.333,2),(208,7445803,7445800,'cha',20,2),(208,7445804,7445800,'han',20,2),(208,7445805,7445800,'ann',20,2),(208,7445806,7445800,'nne',20,2),(208,7445807,7445800,'nel',20,2),(208,7445808,7445803,'dis',50,2),(208,7445809,7445803,'isk',50,2),(208,7445810,7445808,'naa',100,4),(208,7445811,7445810,'600',3.333,4),(208,7445812,7445810,'00a',3.333,4),(208,7445813,7445810,'0a0',3.333,4),(208,7445814,7445810,'a09',3.333,4),(208,7445815,7445810,'098',3.333,4),(208,7445816,7445810,'980',3.333,4),(208,7445817,7445810,'804',3.333,4),(208,7445818,7445810,'044',3.333,4),(208,7445819,7445810,'443',3.333,4),(208,7445820,7445810,'430',3.333,4),(208,7445821,7445810,'307',3.333,4),(208,7445822,7445810,'075',3.333,4),(208,7445823,7445810,'753',3.333,4),(208,7445824,7445810,'535',3.333,4),(208,7445825,7445810,'357',3.333,4),(208,7445826,7445810,'573',3.333,4),(208,7445827,7445810,'732',3.333,4),(208,7445828,7445810,'32b',3.333,4),(208,7445829,7445810,'2b3',3.333,4),(208,7445830,7445810,'b33',3.333,4),(208,7445831,7445810,'334',3.333,4),(208,7445832,7445810,'345',3.333,4),(208,7445833,7445810,'457',3.333,4),(208,7445834,7445810,'571',3.333,4),(208,7445835,7445810,'715',3.333,4),(208,7445836,7445810,'153',3.333,4),(208,7445837,7445810,'533',3.333,4),(208,7445838,7445810,'336',3.333,4),(208,7445839,7445810,'362',3.333,4),(208,7445840,7445810,'62d',3.333,4),(208,7445841,7445811,'ser',25,1),(208,7445842,7445811,'eri',25,1),(208,7445843,7445811,'ria',25,1),(208,7445844,7445811,'ial',25,1),(208,7445845,7445841,'siz',50,1),(208,7445846,7445841,'ize',50,1),(208,7445847,7445845,'321',100,1),(208,7445848,7445847,'dev',25,1),(208,7445849,7445847,'evi',25,1),(208,7445850,7445847,'vic',25,1),(208,7445851,7445847,'ice',25,1),(208,7445852,7445848,'typ',50,1),(208,7445853,7445848,'ype',50,1),(208,7445854,7445852,'dir',10,1),(208,7445855,7445852,'ire',10,1),(208,7445856,7445852,'rec',10,1),(208,7445857,7445852,'ect',10,1),(208,7445858,7445852,'cta',10,1),(208,7445859,7445852,'tac',10,1),(208,7445860,7445852,'acc',10,1),(208,7445861,7445852,'cce',10,1),(208,7445862,7445852,'ces',10,1),(208,7445863,7445852,'ess',10,1),(208,7445864,7445854,'mul',14.286,1),(208,7445865,7445854,'ult',14.286,1),(208,7445866,7445854,'lti',14.286,1),(208,7445867,7445854,'tip',14.286,1),(208,7445868,7445854,'ipa',14.286,1),(208,7445869,7445854,'pat',14.286,1),(208,7445870,7445854,'ath',14.286,1),(208,7445871,7445864,'plu',25,1),(208,7445872,7445864,'lug',25,1),(208,7445873,7445864,'ugi',25,1),(208,7445874,7445864,'gin',25,1),(208,7445875,7445871,'nmp',100,1),(208,7445876,7445875,'dev',33.333,1),(208,7445877,7445875,'evf',33.333,1),(208,7445878,7445875,'vfs',33.333,1),(208,7445879,7445876,'pat',50,1),(208,7445880,7445876,'ath',50,1),(208,7445881,7445879,'vmf',50,1),(208,7445882,7445879,'mfs',50,1),(208,7445883,7445881,'dev',20,1),(208,7445884,7445881,'evi',20,1),(208,7445885,7445881,'vic',20,1),(208,7445886,7445881,'ice',20,1),(208,7445887,7445881,'ces',20,1),(208,7445888,7445883,'dis',33.333,1),(208,7445889,7445883,'isk',33.333,1),(208,7445890,7445883,'sks',33.333,1),(208,7445891,7445888,'ven',25,1),(208,7445892,7445888,'end',25,1),(208,7445893,7445888,'ndo',25,1),(208,7445894,7445888,'dor',25,1),(208,7445895,7445891,'mod',33.333,1),(208,7445896,7445891,'ode',33.333,1),(208,7445897,7445891,'del',33.333,1),(208,7445898,7445895,'lun',100,1),(208,7445899,7445898,'cmo',33.333,1),(208,7445900,7445898,'mod',33.333,1),(208,7445901,7445898,'ode',33.333,1),(208,7445902,7445899,'rev',16.667,1),(208,7445903,7445899,'evi',16.667,1),(208,7445904,7445899,'vis',16.667,1),(208,7445905,7445899,'isi',16.667,1),(208,7445906,7445899,'sio',16.667,1),(208,7445907,7445899,'ion',16.667,1),(208,7445908,7445902,'810',50,1),(208,7445909,7445902,'100',50,1),(208,7445910,7445908,'scs',50,1),(208,7445911,7445908,'csi',50,1),(208,7445912,7445910,'lev',33.333,1),(208,7445913,7445910,'eve',33.333,1),(208,7445914,7445910,'vel',33.333,1),(208,7445915,7445912,'pse',25,1),(208,7445916,7445912,'seu',25,1),(208,7445917,7445912,'eud',25,1),(208,7445918,7445912,'udo',25,1),(208,7445919,7445915,'fal',33.333,6),(208,7445920,7445915,'als',33.333,6),(208,7445921,7445915,'lse',33.333,6),(208,7445922,7445919,'sta',25,3),(208,7445923,7445919,'tat',25,3),(208,7445924,7445919,'atu',25,3),(208,7445925,7445919,'tus',25,3),(208,7445926,7445922,'rdm',100,1),(208,7445927,7445926,'cap',20,1),(208,7445928,7445926,'apa',20,1),(208,7445929,7445926,'pab',20,1),(208,7445930,7445926,'abl',20,1),(208,7445931,7445926,'ble',20,1),(208,7445932,7445927,'tru',50,1),(208,7445933,7445927,'rue',50,1),(208,7445934,7445932,'loc',33.333,1),(208,7445935,7445932,'oca',33.333,1),(208,7445936,7445932,'cal',33.333,1),(208,7445937,7445934,'rem',14.286,1),(208,7445938,7445934,'emo',14.286,1),(208,7445939,7445934,'mov',14.286,1),(208,7445940,7445934,'ova',14.286,1),(208,7445941,7445934,'vab',14.286,1),(208,7445942,7445934,'abl',14.286,1),(208,7445943,7445934,'ble',14.286,1),(208,7445944,7445937,'ssd',100,1),(208,7445945,7445944,'off',20,1),(208,7445946,7445944,'ffl',20,1),(208,7445947,7445944,'fli',20,1),(208,7445948,7445944,'lin',20,1),(208,7445949,7445944,'ine',20,1),(208,7445950,7445945,'per',11.111,1),(208,7445951,7445945,'ere',11.111,1),(208,7445952,7445945,'ren',11.111,1),(208,7445953,7445945,'enn',11.111,1),(208,7445954,7445945,'nni',11.111,1),(208,7445955,7445945,'nia',11.111,1),(208,7445956,7445945,'ial',11.111,1),(208,7445957,7445945,'all',11.111,1),(208,7445958,7445945,'lly',11.111,1),(208,7445959,7445950,'res',16.667,1),(208,7445960,7445950,'ese',16.667,1),(208,7445961,7445950,'ser',16.667,1),(208,7445962,7445950,'erv',16.667,1),(208,7445963,7445950,'rve',16.667,1),(208,7445964,7445950,'ved',16.667,1),(208,7445965,7445959,'thi',50,1),(208,7445966,7445959,'hin',50,1),(208,7445967,7445965,'pro',10,1),(208,7445968,7445965,'rov',10,1),(208,7445969,7445965,'ovi',10,1),(208,7445970,7445965,'vis',10,1),(208,7445971,7445965,'isi',10,1),(208,7445972,7445965,'sio',10,1),(208,7445973,7445965,'ion',10,1),(208,7445974,7445965,'oni',10,1),(208,7445975,7445965,'nin',10,1),(208,7445976,7445965,'ing',10,1),(208,7445977,7445967,'yes',100,1),(208,7445978,7445977,'att',16.667,1),(208,7445979,7445977,'tta',16.667,1),(208,7445980,7445977,'tac',16.667,1),(208,7445981,7445977,'ach',16.667,1),(208,7445982,7445977,'che',16.667,1),(208,7445983,7445977,'hed',16.667,1),(208,7445984,7445978,'fil',20,1),(208,7445985,7445978,'ilt',20,1),(208,7445986,7445978,'lte',20,1),(208,7445987,7445978,'ter',20,1),(208,7445988,7445978,'ers',20,1),(208,7445989,7445984,'vaa',50,1),(208,7445990,7445984,'aai',50,1),(208,7445991,7445989,'unk',20,1),(208,7445992,7445989,'nkn',20,1),(208,7445993,7445989,'kno',20,1),(208,7445994,7445989,'now',20,1),(208,7445995,7445989,'own',20,1),(208,7445996,7445991,'oth',33.333,1),(208,7445997,7445991,'the',33.333,1),(208,7445998,7445991,'her',33.333,1),(208,7445999,7445996,'uid',50,1),(208,7446000,7445996,'ids',50,1),(208,7446001,7445999,'vml',100,1),(208,7446002,7446001,'dis',20,1),(208,7446003,7446001,'isp',20,1),(208,7446004,7446001,'spl',20,1),(208,7446005,7446001,'pla',20,1),(208,7446006,7446001,'lay',20,1),(208,7446007,7446002,'nam',50,1),(208,7446008,7446002,'ame',50,1),(209,7446010,7446009,'net',25,3),(209,7446011,7446009,'eta',25,3),(209,7446012,7446009,'tap',25,3),(209,7446013,7446009,'app',25,3),(209,7446014,7446010,'fib',33.333,2),(209,7446015,7446010,'ibr',33.333,2),(209,7446016,7446010,'bre',33.333,2),(209,7446017,7446014,'cha',20,2),(209,7446018,7446014,'han',20,2),(209,7446019,7446014,'ann',20,2),(209,7446020,7446014,'nne',20,2),(209,7446021,7446014,'nel',20,2),(209,7446022,7446017,'dis',50,2),(209,7446023,7446017,'isk',50,2),(209,7446024,7446022,'naa',100,4),(209,7446025,7446024,'600',3.333,4),(209,7446026,7446024,'00a',3.333,4),(209,7446027,7446024,'0a0',3.333,4),(209,7446028,7446024,'a09',3.333,4),(209,7446029,7446024,'098',3.333,4),(209,7446030,7446024,'980',3.333,4),(209,7446031,7446024,'804',3.333,4),(209,7446032,7446024,'044',3.333,4),(209,7446033,7446024,'443',3.333,4),(209,7446034,7446024,'430',3.333,4),(209,7446035,7446024,'307',3.333,4),(209,7446036,7446024,'075',3.333,4),(209,7446037,7446024,'753',3.333,4),(209,7446038,7446024,'535',3.333,4),(209,7446039,7446024,'357',3.333,4),(209,7446040,7446024,'573',3.333,4),(209,7446041,7446024,'732',3.333,4),(209,7446042,7446024,'32b',3.333,4),(209,7446043,7446024,'2b3',3.333,4),(209,7446044,7446024,'b33',3.333,4),(209,7446045,7446024,'334',3.333,4),(209,7446046,7446024,'345',3.333,4),(209,7446047,7446024,'457',3.333,4),(209,7446048,7446024,'571',3.333,4),(209,7446049,7446024,'715',3.333,4),(209,7446050,7446024,'153',3.333,4),(209,7446051,7446024,'533',3.333,4),(209,7446052,7446024,'336',3.333,4),(209,7446053,7446024,'362',3.333,4),(209,7446054,7446024,'62f',3.333,4),(209,7446055,7446025,'ser',25,1),(209,7446056,7446025,'eri',25,1),(209,7446057,7446025,'ria',25,1),(209,7446058,7446025,'ial',25,1),(209,7446059,7446055,'siz',50,1),(209,7446060,7446055,'ize',50,1),(209,7446061,7446059,'321',100,1),(209,7446062,7446061,'dev',25,1),(209,7446063,7446061,'evi',25,1),(209,7446064,7446061,'vic',25,1),(209,7446065,7446061,'ice',25,1),(209,7446066,7446062,'typ',50,1),(209,7446067,7446062,'ype',50,1),(209,7446068,7446066,'dir',10,1),(209,7446069,7446066,'ire',10,1),(209,7446070,7446066,'rec',10,1),(209,7446071,7446066,'ect',10,1),(209,7446072,7446066,'cta',10,1),(209,7446073,7446066,'tac',10,1),(209,7446074,7446066,'acc',10,1),(209,7446075,7446066,'cce',10,1),(209,7446076,7446066,'ces',10,1),(209,7446077,7446066,'ess',10,1),(209,7446078,7446068,'mul',14.286,1),(209,7446079,7446068,'ult',14.286,1),(209,7446080,7446068,'lti',14.286,1),(209,7446081,7446068,'tip',14.286,1),(209,7446082,7446068,'ipa',14.286,1),(209,7446083,7446068,'pat',14.286,1),(209,7446084,7446068,'ath',14.286,1),(209,7446085,7446078,'plu',25,1),(209,7446086,7446078,'lug',25,1),(209,7446087,7446078,'ugi',25,1),(209,7446088,7446078,'gin',25,1),(209,7446089,7446085,'nmp',100,1),(209,7446090,7446089,'dev',33.333,1),(209,7446091,7446089,'evf',33.333,1),(209,7446092,7446089,'vfs',33.333,1),(209,7446093,7446090,'pat',50,1),(209,7446094,7446090,'ath',50,1),(209,7446095,7446093,'vmf',50,1),(209,7446096,7446093,'mfs',50,1),(209,7446097,7446095,'dev',20,1),(209,7446098,7446095,'evi',20,1),(209,7446099,7446095,'vic',20,1),(209,7446100,7446095,'ice',20,1),(209,7446101,7446095,'ces',20,1),(209,7446102,7446097,'dis',33.333,1),(209,7446103,7446097,'isk',33.333,1),(209,7446104,7446097,'sks',33.333,1),(209,7446105,7446102,'ven',25,1),(209,7446106,7446102,'end',25,1),(209,7446107,7446102,'ndo',25,1),(209,7446108,7446102,'dor',25,1),(209,7446109,7446105,'mod',33.333,1),(209,7446110,7446105,'ode',33.333,1),(209,7446111,7446105,'del',33.333,1),(209,7446112,7446109,'lun',100,1),(209,7446113,7446112,'cmo',33.333,1),(209,7446114,7446112,'mod',33.333,1),(209,7446115,7446112,'ode',33.333,1),(209,7446116,7446113,'rev',16.667,1),(209,7446117,7446113,'evi',16.667,1),(209,7446118,7446113,'vis',16.667,1),(209,7446119,7446113,'isi',16.667,1),(209,7446120,7446113,'sio',16.667,1),(209,7446121,7446113,'ion',16.667,1),(209,7446122,7446116,'810',50,1),(209,7446123,7446116,'100',50,1),(209,7446124,7446122,'scs',50,1),(209,7446125,7446122,'csi',50,1),(209,7446126,7446124,'lev',33.333,1),(209,7446127,7446124,'eve',33.333,1),(209,7446128,7446124,'vel',33.333,1),(209,7446129,7446126,'pse',25,1),(209,7446130,7446126,'seu',25,1),(209,7446131,7446126,'eud',25,1),(209,7446132,7446126,'udo',25,1),(209,7446133,7446129,'fal',33.333,6),(209,7446134,7446129,'als',33.333,6),(209,7446135,7446129,'lse',33.333,6),(209,7446136,7446133,'sta',25,3),(209,7446137,7446133,'tat',25,3),(209,7446138,7446133,'atu',25,3),(209,7446139,7446133,'tus',25,3),(209,7446140,7446136,'rdm',100,1),(209,7446141,7446140,'cap',20,1),(209,7446142,7446140,'apa',20,1),(209,7446143,7446140,'pab',20,1),(209,7446144,7446140,'abl',20,1),(209,7446145,7446140,'ble',20,1),(209,7446146,7446141,'tru',50,1),(209,7446147,7446141,'rue',50,1),(209,7446148,7446146,'loc',33.333,1),(209,7446149,7446146,'oca',33.333,1),(209,7446150,7446146,'cal',33.333,1),(209,7446151,7446148,'rem',14.286,1),(209,7446152,7446148,'emo',14.286,1),(209,7446153,7446148,'mov',14.286,1),(209,7446154,7446148,'ova',14.286,1),(209,7446155,7446148,'vab',14.286,1),(209,7446156,7446148,'abl',14.286,1),(209,7446157,7446148,'ble',14.286,1),(209,7446158,7446151,'ssd',100,1),(209,7446159,7446158,'off',20,1),(209,7446160,7446158,'ffl',20,1),(209,7446161,7446158,'fli',20,1),(209,7446162,7446158,'lin',20,1),(209,7446163,7446158,'ine',20,1),(209,7446164,7446159,'per',11.111,1),(209,7446165,7446159,'ere',11.111,1),(209,7446166,7446159,'ren',11.111,1),(209,7446167,7446159,'enn',11.111,1),(209,7446168,7446159,'nni',11.111,1),(209,7446169,7446159,'nia',11.111,1),(209,7446170,7446159,'ial',11.111,1),(209,7446171,7446159,'all',11.111,1),(209,7446172,7446159,'lly',11.111,1),(209,7446173,7446164,'res',16.667,1),(209,7446174,7446164,'ese',16.667,1),(209,7446175,7446164,'ser',16.667,1),(209,7446176,7446164,'erv',16.667,1),(209,7446177,7446164,'rve',16.667,1),(209,7446178,7446164,'ved',16.667,1),(209,7446179,7446173,'thi',50,1),(209,7446180,7446173,'hin',50,1),(209,7446181,7446179,'pro',10,1),(209,7446182,7446179,'rov',10,1),(209,7446183,7446179,'ovi',10,1),(209,7446184,7446179,'vis',10,1),(209,7446185,7446179,'isi',10,1),(209,7446186,7446179,'sio',10,1),(209,7446187,7446179,'ion',10,1),(209,7446188,7446179,'oni',10,1),(209,7446189,7446179,'nin',10,1),(209,7446190,7446179,'ing',10,1),(209,7446191,7446181,'yes',100,1),(209,7446192,7446191,'att',16.667,1),(209,7446193,7446191,'tta',16.667,1),(209,7446194,7446191,'tac',16.667,1),(209,7446195,7446191,'ach',16.667,1),(209,7446196,7446191,'che',16.667,1),(209,7446197,7446191,'hed',16.667,1),(209,7446198,7446192,'fil',20,1),(209,7446199,7446192,'ilt',20,1),(209,7446200,7446192,'lte',20,1),(209,7446201,7446192,'ter',20,1),(209,7446202,7446192,'ers',20,1),(209,7446203,7446198,'vaa',50,1),(209,7446204,7446198,'aai',50,1),(209,7446205,7446203,'unk',20,1),(209,7446206,7446203,'nkn',20,1),(209,7446207,7446203,'kno',20,1),(209,7446208,7446203,'now',20,1),(209,7446209,7446203,'own',20,1),(209,7446210,7446205,'oth',33.333,1),(209,7446211,7446205,'the',33.333,1),(209,7446212,7446205,'her',33.333,1),(209,7446213,7446210,'uid',50,1),(209,7446214,7446210,'ids',50,1),(209,7446215,7446213,'vml',100,1),(209,7446216,7446215,'dis',20,1),(209,7446217,7446215,'isp',20,1),(209,7446218,7446215,'spl',20,1),(209,7446219,7446215,'pla',20,1),(209,7446220,7446215,'lay',20,1),(209,7446221,7446216,'nam',50,1),(209,7446222,7446216,'ame',50,1),(210,7446224,7446223,'net',25,3),(210,7446225,7446223,'eta',25,3),(210,7446226,7446223,'tap',25,3),(210,7446227,7446223,'app',25,3),(210,7446228,7446224,'ser',25,3),(210,7446229,7446224,'eri',25,3),(210,7446230,7446224,'ria',25,3),(210,7446231,7446224,'ial',25,3),(210,7446232,7446228,'att',16.667,3),(210,7446233,7446228,'tta',16.667,3),(210,7446234,7446228,'tac',16.667,3),(210,7446235,7446228,'ach',16.667,3),(210,7446236,7446228,'che',16.667,3),(210,7446237,7446228,'hed',16.667,3),(210,7446238,7446232,'scs',50,3),(210,7446239,7446232,'csi',50,3),(210,7446240,7446238,'dis',50,2),(210,7446241,7446238,'isk',50,2),(210,7446242,7446240,'naa',100,4),(210,7446243,7446242,'600',3.333,4),(210,7446244,7446242,'00a',3.333,4),(210,7446245,7446242,'0a0',3.333,4),(210,7446246,7446242,'a09',3.333,4),(210,7446247,7446242,'098',3.333,4),(210,7446248,7446242,'980',3.333,4),(210,7446249,7446242,'80a',3.333,4),(210,7446250,7446242,'0a6',3.333,4),(210,7446251,7446242,'a64',3.333,4),(210,7446252,7446242,'64c',3.333,4),(210,7446253,7446242,'4c8',3.333,4),(210,7446254,7446242,'c84',3.333,4),(210,7446255,7446242,'84e',3.333,4),(210,7446256,7446242,'4ee',3.333,4),(210,7446257,7446242,'ee0',3.333,4),(210,7446258,7446242,'e03',3.333,4),(210,7446259,7446242,'034',3.333,4),(210,7446260,7446242,'347',3.333,4),(210,7446261,7446242,'474',3.333,4),(210,7446262,7446242,'743',3.333,4),(210,7446263,7446242,'431',3.333,4),(210,7446264,7446242,'311',3.333,4),(210,7446265,7446242,'117',3.333,4),(210,7446266,7446242,'17b',3.333,4),(210,7446267,7446242,'7b0',3.333,4),(210,7446268,7446242,'b05',3.333,4),(210,7446269,7446242,'05a',3.333,4),(210,7446270,7446242,'5ab',3.333,4),(210,7446271,7446242,'aba',3.333,4),(210,7446272,7446242,'ba2',3.333,4),(210,7446273,7446243,'siz',50,1),(210,7446274,7446243,'ize',50,1),(210,7446275,7446273,'163',33.333,1),(210,7446276,7446273,'638',33.333,1),(210,7446277,7446273,'384',33.333,1),(210,7446278,7446275,'dev',25,1),(210,7446279,7446275,'evi',25,1),(210,7446280,7446275,'vic',25,1),(210,7446281,7446275,'ice',25,1),(210,7446282,7446278,'typ',50,1),(210,7446283,7446278,'ype',50,1),(210,7446284,7446282,'dir',10,1),(210,7446285,7446282,'ire',10,1),(210,7446286,7446282,'rec',10,1),(210,7446287,7446282,'ect',10,1),(210,7446288,7446282,'cta',10,1),(210,7446289,7446282,'tac',10,1),(210,7446290,7446282,'acc',10,1),(210,7446291,7446282,'cce',10,1),(210,7446292,7446282,'ces',10,1),(210,7446293,7446282,'ess',10,1),(210,7446294,7446284,'mul',14.286,1),(210,7446295,7446284,'ult',14.286,1),(210,7446296,7446284,'lti',14.286,1),(210,7446297,7446284,'tip',14.286,1),(210,7446298,7446284,'ipa',14.286,1),(210,7446299,7446284,'pat',14.286,1),(210,7446300,7446284,'ath',14.286,1),(210,7446301,7446294,'plu',25,1),(210,7446302,7446294,'lug',25,1),(210,7446303,7446294,'ugi',25,1),(210,7446304,7446294,'gin',25,1),(210,7446305,7446301,'nmp',100,1),(210,7446306,7446305,'dev',33.333,1),(210,7446307,7446305,'evf',33.333,1),(210,7446308,7446305,'vfs',33.333,1),(210,7446309,7446306,'pat',50,1),(210,7446310,7446306,'ath',50,1),(210,7446311,7446309,'vmf',50,1),(210,7446312,7446309,'mfs',50,1),(210,7446313,7446311,'dev',20,1),(210,7446314,7446311,'evi',20,1),(210,7446315,7446311,'vic',20,1),(210,7446316,7446311,'ice',20,1),(210,7446317,7446311,'ces',20,1),(210,7446318,7446313,'dis',33.333,1),(210,7446319,7446313,'isk',33.333,1),(210,7446320,7446313,'sks',33.333,1),(210,7446321,7446318,'ven',25,1),(210,7446322,7446318,'end',25,1),(210,7446323,7446318,'ndo',25,1),(210,7446324,7446318,'dor',25,1),(210,7446325,7446321,'mod',33.333,1),(210,7446326,7446321,'ode',33.333,1),(210,7446327,7446321,'del',33.333,1),(210,7446328,7446325,'fla',33.333,1),(210,7446329,7446325,'las',33.333,1),(210,7446330,7446325,'ash',33.333,1),(210,7446331,7446328,'acc',33.333,1),(210,7446332,7446328,'cce',33.333,1),(210,7446333,7446328,'cel',33.333,1),(210,7446334,7446331,'rev',16.667,1),(210,7446335,7446331,'evi',16.667,1),(210,7446336,7446331,'vis',16.667,1),(210,7446337,7446331,'isi',16.667,1),(210,7446338,7446331,'sio',16.667,1),(210,7446339,7446331,'ion',16.667,1),(210,7446340,7446334,'lev',33.333,1),(210,7446341,7446334,'eve',33.333,1),(210,7446342,7446334,'vel',33.333,1),(210,7446343,7446340,'pse',25,1),(210,7446344,7446340,'seu',25,1),(210,7446345,7446340,'eud',25,1),(210,7446346,7446340,'udo',25,1),(210,7446347,7446343,'fal',33.333,5),(210,7446348,7446343,'als',33.333,5),(210,7446349,7446343,'lse',33.333,5),(210,7446350,7446347,'sta',25,3),(210,7446351,7446347,'tat',25,3),(210,7446352,7446347,'atu',25,3),(210,7446353,7446347,'tus',25,3),(210,7446354,7446350,'deg',16.667,1),(210,7446355,7446350,'egr',16.667,1),(210,7446356,7446350,'gra',16.667,1),(210,7446357,7446350,'rad',16.667,1),(210,7446358,7446350,'ade',16.667,1),(210,7446359,7446350,'ded',16.667,1),(210,7446360,7446354,'rdm',100,1),(210,7446361,7446360,'cap',20,1),(210,7446362,7446360,'apa',20,1),(210,7446363,7446360,'pab',20,1),(210,7446364,7446360,'abl',20,1),(210,7446365,7446360,'ble',20,1),(210,7446366,7446361,'tru',50,2),(210,7446367,7446361,'rue',50,2),(210,7446368,7446366,'loc',33.333,1),(210,7446369,7446366,'oca',33.333,1),(210,7446370,7446366,'cal',33.333,1),(210,7446371,7446368,'rem',14.286,1),(210,7446372,7446368,'emo',14.286,1),(210,7446373,7446368,'mov',14.286,1),(210,7446374,7446368,'ova',14.286,1),(210,7446375,7446368,'vab',14.286,1),(210,7446376,7446368,'abl',14.286,1),(210,7446377,7446368,'ble',14.286,1),(210,7446378,7446371,'ssd',100,1),(210,7446379,7446378,'off',20,1),(210,7446380,7446378,'ffl',20,1),(210,7446381,7446378,'fli',20,1),(210,7446382,7446378,'lin',20,1),(210,7446383,7446378,'ine',20,1),(210,7446384,7446379,'per',11.111,1),(210,7446385,7446379,'ere',11.111,1),(210,7446386,7446379,'ren',11.111,1),(210,7446387,7446379,'enn',11.111,1),(210,7446388,7446379,'nni',11.111,1),(210,7446389,7446379,'nia',11.111,1),(210,7446390,7446379,'ial',11.111,1),(210,7446391,7446379,'all',11.111,1),(210,7446392,7446379,'lly',11.111,1),(210,7446393,7446384,'res',16.667,1),(210,7446394,7446384,'ese',16.667,1),(210,7446395,7446384,'ser',16.667,1),(210,7446396,7446384,'erv',16.667,1),(210,7446397,7446384,'rve',16.667,1),(210,7446398,7446384,'ved',16.667,1),(210,7446399,7446393,'thi',50,1),(210,7446400,7446393,'hin',50,1),(210,7446401,7446399,'pro',10,1),(210,7446402,7446399,'rov',10,1),(210,7446403,7446399,'ovi',10,1),(210,7446404,7446399,'vis',10,1),(210,7446405,7446399,'isi',10,1),(210,7446406,7446399,'sio',10,1),(210,7446407,7446399,'ion',10,1),(210,7446408,7446399,'oni',10,1),(210,7446409,7446399,'nin',10,1),(210,7446410,7446399,'ing',10,1),(210,7446411,7446401,'unk',20,1),(210,7446412,7446401,'nkn',20,1),(210,7446413,7446401,'kno',20,1),(210,7446414,7446401,'now',20,1),(210,7446415,7446401,'own',20,1),(210,7446416,7446411,'fil',20,1),(210,7446417,7446411,'ilt',20,1),(210,7446418,7446411,'lte',20,1),(210,7446419,7446411,'ter',20,1),(210,7446420,7446411,'ers',20,1),(210,7446421,7446416,'vaa',50,1),(210,7446422,7446416,'aai',50,1),(210,7446423,7446421,'uns',11.111,1),(210,7446424,7446421,'nsu',11.111,1),(210,7446425,7446421,'sup',11.111,1),(210,7446426,7446421,'upp',11.111,1),(210,7446427,7446421,'ppo',11.111,1),(210,7446428,7446421,'por',11.111,1),(210,7446429,7446421,'ort',11.111,1),(210,7446430,7446421,'rte',11.111,1),(210,7446431,7446421,'ted',11.111,1),(210,7446432,7446423,'oth',33.333,1),(210,7446433,7446423,'the',33.333,1),(210,7446434,7446423,'her',33.333,1),(210,7446435,7446432,'uid',50,1),(210,7446436,7446432,'ids',50,1),(210,7446437,7446435,'vml',100,1),(210,7446438,7446437,'dis',20,1),(210,7446439,7446437,'isp',20,1),(210,7446440,7446437,'spl',20,1),(210,7446441,7446437,'pla',20,1),(210,7446442,7446437,'lay',20,1),(210,7446443,7446438,'nam',50,1),(210,7446444,7446438,'ame',50,1),(211,7446446,7446445,'net',25,3),(211,7446447,7446445,'eta',25,3),(211,7446448,7446445,'tap',25,3),(211,7446449,7446445,'app',25,3),(211,7446450,7446446,'fib',33.333,2),(211,7446451,7446446,'ibr',33.333,2),(211,7446452,7446446,'bre',33.333,2),(211,7446453,7446450,'cha',20,2),(211,7446454,7446450,'han',20,2),(211,7446455,7446450,'ann',20,2),(211,7446456,7446450,'nne',20,2),(211,7446457,7446450,'nel',20,2),(211,7446458,7446453,'dis',50,2),(211,7446459,7446453,'isk',50,2),(211,7446460,7446458,'naa',100,4),(211,7446461,7446460,'600',3.333,4),(211,7446462,7446460,'00a',3.333,4),(211,7446463,7446460,'0a0',3.333,4),(211,7446464,7446460,'a09',3.333,4),(211,7446465,7446460,'098',3.333,4),(211,7446466,7446460,'980',3.333,4),(211,7446467,7446460,'804',3.333,4),(211,7446468,7446460,'044',3.333,4),(211,7446469,7446460,'443',3.333,4),(211,7446470,7446460,'430',3.333,4),(211,7446471,7446460,'307',3.333,4),(211,7446472,7446460,'075',3.333,4),(211,7446473,7446460,'753',3.333,4),(211,7446474,7446460,'535',3.333,4),(211,7446475,7446460,'357',3.333,4),(211,7446476,7446460,'573',3.333,4),(211,7446477,7446460,'732',3.333,4),(211,7446478,7446460,'32b',3.333,4),(211,7446479,7446460,'2b3',3.333,4),(211,7446480,7446460,'b33',3.333,4),(211,7446481,7446460,'334',3.333,4),(211,7446482,7446460,'345',3.333,4),(211,7446483,7446460,'457',3.333,4),(211,7446484,7446460,'571',3.333,4),(211,7446485,7446460,'715',3.333,4),(211,7446486,7446460,'153',3.333,4),(211,7446487,7446460,'533',3.333,4),(211,7446488,7446460,'336',3.333,4),(211,7446489,7446460,'366',3.333,4),(211,7446490,7446460,'66a',3.333,4),(211,7446491,7446461,'ser',25,1),(211,7446492,7446461,'eri',25,1),(211,7446493,7446461,'ria',25,1),(211,7446494,7446461,'ial',25,1),(211,7446495,7446491,'siz',50,1),(211,7446496,7446491,'ize',50,1),(211,7446497,7446495,'321',100,1),(211,7446498,7446497,'dev',25,1),(211,7446499,7446497,'evi',25,1),(211,7446500,7446497,'vic',25,1),(211,7446501,7446497,'ice',25,1),(211,7446502,7446498,'typ',50,1),(211,7446503,7446498,'ype',50,1),(211,7446504,7446502,'dir',10,1),(211,7446505,7446502,'ire',10,1),(211,7446506,7446502,'rec',10,1),(211,7446507,7446502,'ect',10,1),(211,7446508,7446502,'cta',10,1),(211,7446509,7446502,'tac',10,1),(211,7446510,7446502,'acc',10,1),(211,7446511,7446502,'cce',10,1),(211,7446512,7446502,'ces',10,1),(211,7446513,7446502,'ess',10,1),(211,7446514,7446504,'mul',14.286,1),(211,7446515,7446504,'ult',14.286,1),(211,7446516,7446504,'lti',14.286,1),(211,7446517,7446504,'tip',14.286,1),(211,7446518,7446504,'ipa',14.286,1),(211,7446519,7446504,'pat',14.286,1),(211,7446520,7446504,'ath',14.286,1),(211,7446521,7446514,'plu',25,1),(211,7446522,7446514,'lug',25,1),(211,7446523,7446514,'ugi',25,1),(211,7446524,7446514,'gin',25,1),(211,7446525,7446521,'nmp',100,1),(211,7446526,7446525,'dev',33.333,1),(211,7446527,7446525,'evf',33.333,1),(211,7446528,7446525,'vfs',33.333,1),(211,7446529,7446526,'pat',50,1),(211,7446530,7446526,'ath',50,1),(211,7446531,7446529,'vmf',50,1),(211,7446532,7446529,'mfs',50,1),(211,7446533,7446531,'dev',20,1),(211,7446534,7446531,'evi',20,1),(211,7446535,7446531,'vic',20,1),(211,7446536,7446531,'ice',20,1),(211,7446537,7446531,'ces',20,1),(211,7446538,7446533,'dis',33.333,1),(211,7446539,7446533,'isk',33.333,1),(211,7446540,7446533,'sks',33.333,1),(211,7446541,7446538,'ven',25,1),(211,7446542,7446538,'end',25,1),(211,7446543,7446538,'ndo',25,1),(211,7446544,7446538,'dor',25,1),(211,7446545,7446541,'mod',33.333,1),(211,7446546,7446541,'ode',33.333,1),(211,7446547,7446541,'del',33.333,1),(211,7446548,7446545,'lun',100,1),(211,7446549,7446548,'cmo',33.333,1),(211,7446550,7446548,'mod',33.333,1),(211,7446551,7446548,'ode',33.333,1),(211,7446552,7446549,'rev',16.667,1),(211,7446553,7446549,'evi',16.667,1),(211,7446554,7446549,'vis',16.667,1),(211,7446555,7446549,'isi',16.667,1),(211,7446556,7446549,'sio',16.667,1),(211,7446557,7446549,'ion',16.667,1),(211,7446558,7446552,'810',50,1),(211,7446559,7446552,'100',50,1),(211,7446560,7446558,'scs',50,1),(211,7446561,7446558,'csi',50,1),(211,7446562,7446560,'lev',33.333,1),(211,7446563,7446560,'eve',33.333,1),(211,7446564,7446560,'vel',33.333,1),(211,7446565,7446562,'pse',25,1),(211,7446566,7446562,'seu',25,1),(211,7446567,7446562,'eud',25,1),(211,7446568,7446562,'udo',25,1),(211,7446569,7446565,'fal',33.333,6),(211,7446570,7446565,'als',33.333,6),(211,7446571,7446565,'lse',33.333,6),(211,7446572,7446569,'sta',25,3),(211,7446573,7446569,'tat',25,3),(211,7446574,7446569,'atu',25,3),(211,7446575,7446569,'tus',25,3),(211,7446576,7446572,'rdm',100,1),(211,7446577,7446576,'cap',20,1),(211,7446578,7446576,'apa',20,1),(211,7446579,7446576,'pab',20,1),(211,7446580,7446576,'abl',20,1),(211,7446581,7446576,'ble',20,1),(211,7446582,7446577,'tru',50,1),(211,7446583,7446577,'rue',50,1),(211,7446584,7446582,'loc',33.333,1),(211,7446585,7446582,'oca',33.333,1),(211,7446586,7446582,'cal',33.333,1),(211,7446587,7446584,'rem',14.286,1),(211,7446588,7446584,'emo',14.286,1),(211,7446589,7446584,'mov',14.286,1),(211,7446590,7446584,'ova',14.286,1),(211,7446591,7446584,'vab',14.286,1),(211,7446592,7446584,'abl',14.286,1),(211,7446593,7446584,'ble',14.286,1),(211,7446594,7446587,'ssd',100,1),(211,7446595,7446594,'off',20,1),(211,7446596,7446594,'ffl',20,1),(211,7446597,7446594,'fli',20,1),(211,7446598,7446594,'lin',20,1),(211,7446599,7446594,'ine',20,1),(211,7446600,7446595,'per',11.111,1),(211,7446601,7446595,'ere',11.111,1),(211,7446602,7446595,'ren',11.111,1),(211,7446603,7446595,'enn',11.111,1),(211,7446604,7446595,'nni',11.111,1),(211,7446605,7446595,'nia',11.111,1),(211,7446606,7446595,'ial',11.111,1),(211,7446607,7446595,'all',11.111,1),(211,7446608,7446595,'lly',11.111,1),(211,7446609,7446600,'res',16.667,1),(211,7446610,7446600,'ese',16.667,1),(211,7446611,7446600,'ser',16.667,1),(211,7446612,7446600,'erv',16.667,1),(211,7446613,7446600,'rve',16.667,1),(211,7446614,7446600,'ved',16.667,1),(211,7446615,7446609,'thi',50,1),(211,7446616,7446609,'hin',50,1),(211,7446617,7446615,'pro',10,1),(211,7446618,7446615,'rov',10,1),(211,7446619,7446615,'ovi',10,1),(211,7446620,7446615,'vis',10,1),(211,7446621,7446615,'isi',10,1),(211,7446622,7446615,'sio',10,1),(211,7446623,7446615,'ion',10,1),(211,7446624,7446615,'oni',10,1),(211,7446625,7446615,'nin',10,1),(211,7446626,7446615,'ing',10,1),(211,7446627,7446617,'yes',100,1),(211,7446628,7446627,'att',16.667,1),(211,7446629,7446627,'tta',16.667,1),(211,7446630,7446627,'tac',16.667,1),(211,7446631,7446627,'ach',16.667,1),(211,7446632,7446627,'che',16.667,1),(211,7446633,7446627,'hed',16.667,1),(211,7446634,7446628,'fil',20,1),(211,7446635,7446628,'ilt',20,1),(211,7446636,7446628,'lte',20,1),(211,7446637,7446628,'ter',20,1),(211,7446638,7446628,'ers',20,1),(211,7446639,7446634,'vaa',50,1),(211,7446640,7446634,'aai',50,1),(211,7446641,7446639,'unk',20,1),(211,7446642,7446639,'nkn',20,1),(211,7446643,7446639,'kno',20,1),(211,7446644,7446639,'now',20,1),(211,7446645,7446639,'own',20,1),(211,7446646,7446641,'oth',33.333,1),(211,7446647,7446641,'the',33.333,1),(211,7446648,7446641,'her',33.333,1),(211,7446649,7446646,'uid',50,1),(211,7446650,7446646,'ids',50,1),(211,7446651,7446649,'vml',100,1),(211,7446652,7446651,'dis',20,1),(211,7446653,7446651,'isp',20,1),(211,7446654,7446651,'spl',20,1),(211,7446655,7446651,'pla',20,1),(211,7446656,7446651,'lay',20,1),(211,7446657,7446652,'nam',50,1),(211,7446658,7446652,'ame',50,1),(212,7446660,7446659,'net',25,3),(212,7446661,7446659,'eta',25,3),(212,7446662,7446659,'tap',25,3),(212,7446663,7446659,'app',25,3),(212,7446664,7446660,'fib',33.333,2),(212,7446665,7446660,'ibr',33.333,2),(212,7446666,7446660,'bre',33.333,2),(212,7446667,7446664,'cha',20,2),(212,7446668,7446664,'han',20,2),(212,7446669,7446664,'ann',20,2),(212,7446670,7446664,'nne',20,2),(212,7446671,7446664,'nel',20,2),(212,7446672,7446667,'dis',50,2),(212,7446673,7446667,'isk',50,2),(212,7446674,7446672,'naa',100,4),(212,7446675,7446674,'600',3.333,4),(212,7446676,7446674,'00a',3.333,4),(212,7446677,7446674,'0a0',3.333,4),(212,7446678,7446674,'a09',3.333,4),(212,7446679,7446674,'098',3.333,4),(212,7446680,7446674,'980',3.333,4),(212,7446681,7446674,'804',3.333,4),(212,7446682,7446674,'044',3.333,4),(212,7446683,7446674,'443',3.333,4),(212,7446684,7446674,'430',3.333,4),(212,7446685,7446674,'307',3.333,4),(212,7446686,7446674,'075',3.333,4),(212,7446687,7446674,'753',3.333,4),(212,7446688,7446674,'535',3.333,4),(212,7446689,7446674,'357',3.333,4),(212,7446690,7446674,'573',3.333,4),(212,7446691,7446674,'732',3.333,4),(212,7446692,7446674,'32b',3.333,4),(212,7446693,7446674,'2b3',3.333,4),(212,7446694,7446674,'b33',3.333,4),(212,7446695,7446674,'334',3.333,4),(212,7446696,7446674,'345',3.333,4),(212,7446697,7446674,'457',3.333,4),(212,7446698,7446674,'571',3.333,4),(212,7446699,7446674,'715',3.333,4),(212,7446700,7446674,'153',3.333,4),(212,7446701,7446674,'533',3.333,4),(212,7446702,7446674,'336',3.333,4),(212,7446703,7446674,'366',3.333,4),(212,7446704,7446674,'66b',3.333,4),(212,7446705,7446675,'ser',25,1),(212,7446706,7446675,'eri',25,1),(212,7446707,7446675,'ria',25,1),(212,7446708,7446675,'ial',25,1),(212,7446709,7446705,'siz',50,1),(212,7446710,7446705,'ize',50,1),(212,7446711,7446709,'321',100,1),(212,7446712,7446711,'dev',25,1),(212,7446713,7446711,'evi',25,1),(212,7446714,7446711,'vic',25,1),(212,7446715,7446711,'ice',25,1),(212,7446716,7446712,'typ',50,1),(212,7446717,7446712,'ype',50,1),(212,7446718,7446716,'dir',10,1),(212,7446719,7446716,'ire',10,1),(212,7446720,7446716,'rec',10,1),(212,7446721,7446716,'ect',10,1),(212,7446722,7446716,'cta',10,1),(212,7446723,7446716,'tac',10,1),(212,7446724,7446716,'acc',10,1),(212,7446725,7446716,'cce',10,1),(212,7446726,7446716,'ces',10,1),(212,7446727,7446716,'ess',10,1),(212,7446728,7446718,'mul',14.286,1),(212,7446729,7446718,'ult',14.286,1),(212,7446730,7446718,'lti',14.286,1),(212,7446731,7446718,'tip',14.286,1),(212,7446732,7446718,'ipa',14.286,1),(212,7446733,7446718,'pat',14.286,1),(212,7446734,7446718,'ath',14.286,1),(212,7446735,7446728,'plu',25,1),(212,7446736,7446728,'lug',25,1),(212,7446737,7446728,'ugi',25,1),(212,7446738,7446728,'gin',25,1),(212,7446739,7446735,'nmp',100,1),(212,7446740,7446739,'dev',33.333,1),(212,7446741,7446739,'evf',33.333,1),(212,7446742,7446739,'vfs',33.333,1),(212,7446743,7446740,'pat',50,1),(212,7446744,7446740,'ath',50,1),(212,7446745,7446743,'vmf',50,1),(212,7446746,7446743,'mfs',50,1),(212,7446747,7446745,'dev',20,1),(212,7446748,7446745,'evi',20,1),(212,7446749,7446745,'vic',20,1),(212,7446750,7446745,'ice',20,1),(212,7446751,7446745,'ces',20,1),(212,7446752,7446747,'dis',33.333,1),(212,7446753,7446747,'isk',33.333,1),(212,7446754,7446747,'sks',33.333,1),(212,7446755,7446752,'ven',25,1),(212,7446756,7446752,'end',25,1),(212,7446757,7446752,'ndo',25,1),(212,7446758,7446752,'dor',25,1),(212,7446759,7446755,'mod',33.333,1),(212,7446760,7446755,'ode',33.333,1),(212,7446761,7446755,'del',33.333,1),(212,7446762,7446759,'lun',100,1),(212,7446763,7446762,'cmo',33.333,1),(212,7446764,7446762,'mod',33.333,1),(212,7446765,7446762,'ode',33.333,1),(212,7446766,7446763,'rev',16.667,1),(212,7446767,7446763,'evi',16.667,1),(212,7446768,7446763,'vis',16.667,1),(212,7446769,7446763,'isi',16.667,1),(212,7446770,7446763,'sio',16.667,1),(212,7446771,7446763,'ion',16.667,1),(212,7446772,7446766,'810',50,1),(212,7446773,7446766,'100',50,1),(212,7446774,7446772,'scs',50,1),(212,7446775,7446772,'csi',50,1),(212,7446776,7446774,'lev',33.333,1),(212,7446777,7446774,'eve',33.333,1),(212,7446778,7446774,'vel',33.333,1),(212,7446779,7446776,'pse',25,1),(212,7446780,7446776,'seu',25,1),(212,7446781,7446776,'eud',25,1),(212,7446782,7446776,'udo',25,1),(212,7446783,7446779,'fal',33.333,6),(212,7446784,7446779,'als',33.333,6),(212,7446785,7446779,'lse',33.333,6),(212,7446786,7446783,'sta',25,3),(212,7446787,7446783,'tat',25,3),(212,7446788,7446783,'atu',25,3),(212,7446789,7446783,'tus',25,3),(212,7446790,7446786,'rdm',100,1),(212,7446791,7446790,'cap',20,1),(212,7446792,7446790,'apa',20,1),(212,7446793,7446790,'pab',20,1),(212,7446794,7446790,'abl',20,1),(212,7446795,7446790,'ble',20,1),(212,7446796,7446791,'tru',50,1),(212,7446797,7446791,'rue',50,1),(212,7446798,7446796,'loc',33.333,1),(212,7446799,7446796,'oca',33.333,1),(212,7446800,7446796,'cal',33.333,1),(212,7446801,7446798,'rem',14.286,1),(212,7446802,7446798,'emo',14.286,1),(212,7446803,7446798,'mov',14.286,1),(212,7446804,7446798,'ova',14.286,1),(212,7446805,7446798,'vab',14.286,1),(212,7446806,7446798,'abl',14.286,1),(212,7446807,7446798,'ble',14.286,1),(212,7446808,7446801,'ssd',100,1),(212,7446809,7446808,'off',20,1),(212,7446810,7446808,'ffl',20,1),(212,7446811,7446808,'fli',20,1),(212,7446812,7446808,'lin',20,1),(212,7446813,7446808,'ine',20,1),(212,7446814,7446809,'per',11.111,1),(212,7446815,7446809,'ere',11.111,1),(212,7446816,7446809,'ren',11.111,1),(212,7446817,7446809,'enn',11.111,1),(212,7446818,7446809,'nni',11.111,1),(212,7446819,7446809,'nia',11.111,1),(212,7446820,7446809,'ial',11.111,1),(212,7446821,7446809,'all',11.111,1),(212,7446822,7446809,'lly',11.111,1),(212,7446823,7446814,'res',16.667,1),(212,7446824,7446814,'ese',16.667,1),(212,7446825,7446814,'ser',16.667,1),(212,7446826,7446814,'erv',16.667,1),(212,7446827,7446814,'rve',16.667,1),(212,7446828,7446814,'ved',16.667,1),(212,7446829,7446823,'thi',50,1),(212,7446830,7446823,'hin',50,1),(212,7446831,7446829,'pro',10,1),(212,7446832,7446829,'rov',10,1),(212,7446833,7446829,'ovi',10,1),(212,7446834,7446829,'vis',10,1),(212,7446835,7446829,'isi',10,1),(212,7446836,7446829,'sio',10,1),(212,7446837,7446829,'ion',10,1),(212,7446838,7446829,'oni',10,1),(212,7446839,7446829,'nin',10,1),(212,7446840,7446829,'ing',10,1),(212,7446841,7446831,'yes',100,1),(212,7446842,7446841,'att',16.667,1),(212,7446843,7446841,'tta',16.667,1),(212,7446844,7446841,'tac',16.667,1),(212,7446845,7446841,'ach',16.667,1),(212,7446846,7446841,'che',16.667,1),(212,7446847,7446841,'hed',16.667,1),(212,7446848,7446842,'fil',20,1),(212,7446849,7446842,'ilt',20,1),(212,7446850,7446842,'lte',20,1),(212,7446851,7446842,'ter',20,1),(212,7446852,7446842,'ers',20,1),(212,7446853,7446848,'vaa',50,1),(212,7446854,7446848,'aai',50,1),(212,7446855,7446853,'unk',20,1),(212,7446856,7446853,'nkn',20,1),(212,7446857,7446853,'kno',20,1),(212,7446858,7446853,'now',20,1),(212,7446859,7446853,'own',20,1),(212,7446860,7446855,'oth',33.333,1),(212,7446861,7446855,'the',33.333,1),(212,7446862,7446855,'her',33.333,1),(212,7446863,7446860,'uid',50,1),(212,7446864,7446860,'ids',50,1),(212,7446865,7446863,'vml',100,1),(212,7446866,7446865,'dis',20,1),(212,7446867,7446865,'isp',20,1),(212,7446868,7446865,'spl',20,1),(212,7446869,7446865,'pla',20,1),(212,7446870,7446865,'lay',20,1),(212,7446871,7446866,'nam',50,1),(212,7446872,7446866,'ame',50,1),(213,7446874,7446873,'net',25,3),(213,7446875,7446873,'eta',25,3),(213,7446876,7446873,'tap',25,3),(213,7446877,7446873,'app',25,3),(213,7446878,7446874,'ser',25,3),(213,7446879,7446874,'eri',25,3),(213,7446880,7446874,'ria',25,3),(213,7446881,7446874,'ial',25,3),(213,7446882,7446878,'att',16.667,3),(213,7446883,7446878,'tta',16.667,3),(213,7446884,7446878,'tac',16.667,3),(213,7446885,7446878,'ach',16.667,3),(213,7446886,7446878,'che',16.667,3),(213,7446887,7446878,'hed',16.667,3),(213,7446888,7446882,'scs',50,3),(213,7446889,7446882,'csi',50,3),(213,7446890,7446888,'dis',50,2),(213,7446891,7446888,'isk',50,2),(213,7446892,7446890,'naa',100,4),(213,7446893,7446892,'600',3.333,4),(213,7446894,7446892,'00a',3.333,4),(213,7446895,7446892,'0a0',3.333,4),(213,7446896,7446892,'a09',3.333,4),(213,7446897,7446892,'098',3.333,4),(213,7446898,7446892,'980',3.333,4),(213,7446899,7446892,'80d',3.333,4),(213,7446900,7446892,'0d8',3.333,4),(213,7446901,7446892,'d83',3.333,4),(213,7446902,7446892,'83a',3.333,4),(213,7446903,7446892,'3a8',3.333,4),(213,7446904,7446892,'a84',3.333,4),(213,7446905,7446892,'84e',3.333,4),(213,7446906,7446892,'4ee',3.333,4),(213,7446907,7446892,'ee9',3.333,4),(213,7446908,7446892,'e93',3.333,4),(213,7446909,7446892,'930',3.333,4),(213,7446910,7446892,'305',3.333,4),(213,7446911,7446892,'054',3.333,4),(213,7446912,7446892,'545',3.333,4),(213,7446913,7446892,'451',3.333,4),(213,7446914,7446892,'511',3.333,4),(213,7446915,7446892,'117',3.333,4),(213,7446916,7446892,'17b',3.333,4),(213,7446917,7446892,'7b0',3.333,4),(213,7446918,7446892,'b03',3.333,4),(213,7446919,7446892,'03a',3.333,4),(213,7446920,7446892,'3ab',3.333,4),(213,7446921,7446892,'aba',3.333,4),(213,7446922,7446892,'ba2',3.333,4),(213,7446923,7446893,'siz',50,1),(213,7446924,7446893,'ize',50,1),(213,7446925,7446923,'163',33.333,1),(213,7446926,7446923,'638',33.333,1),(213,7446927,7446923,'384',33.333,1),(213,7446928,7446925,'dev',25,1),(213,7446929,7446925,'evi',25,1),(213,7446930,7446925,'vic',25,1),(213,7446931,7446925,'ice',25,1),(213,7446932,7446928,'typ',50,1),(213,7446933,7446928,'ype',50,1),(213,7446934,7446932,'dir',10,1),(213,7446935,7446932,'ire',10,1),(213,7446936,7446932,'rec',10,1),(213,7446937,7446932,'ect',10,1),(213,7446938,7446932,'cta',10,1),(213,7446939,7446932,'tac',10,1),(213,7446940,7446932,'acc',10,1),(213,7446941,7446932,'cce',10,1),(213,7446942,7446932,'ces',10,1),(213,7446943,7446932,'ess',10,1),(213,7446944,7446934,'mul',14.286,1),(213,7446945,7446934,'ult',14.286,1),(213,7446946,7446934,'lti',14.286,1),(213,7446947,7446934,'tip',14.286,1),(213,7446948,7446934,'ipa',14.286,1),(213,7446949,7446934,'pat',14.286,1),(213,7446950,7446934,'ath',14.286,1),(213,7446951,7446944,'plu',25,1),(213,7446952,7446944,'lug',25,1),(213,7446953,7446944,'ugi',25,1),(213,7446954,7446944,'gin',25,1),(213,7446955,7446951,'nmp',100,1),(213,7446956,7446955,'dev',33.333,1),(213,7446957,7446955,'evf',33.333,1),(213,7446958,7446955,'vfs',33.333,1),(213,7446959,7446956,'pat',50,1),(213,7446960,7446956,'ath',50,1),(213,7446961,7446959,'vmf',50,1),(213,7446962,7446959,'mfs',50,1),(213,7446963,7446961,'dev',20,1),(213,7446964,7446961,'evi',20,1),(213,7446965,7446961,'vic',20,1),(213,7446966,7446961,'ice',20,1),(213,7446967,7446961,'ces',20,1),(213,7446968,7446963,'dis',33.333,1),(213,7446969,7446963,'isk',33.333,1),(213,7446970,7446963,'sks',33.333,1),(213,7446971,7446968,'ven',25,1),(213,7446972,7446968,'end',25,1),(213,7446973,7446968,'ndo',25,1),(213,7446974,7446968,'dor',25,1),(213,7446975,7446971,'mod',33.333,1),(213,7446976,7446971,'ode',33.333,1),(213,7446977,7446971,'del',33.333,1),(213,7446978,7446975,'fla',33.333,1),(213,7446979,7446975,'las',33.333,1),(213,7446980,7446975,'ash',33.333,1),(213,7446981,7446978,'acc',33.333,1),(213,7446982,7446978,'cce',33.333,1),(213,7446983,7446978,'cel',33.333,1),(213,7446984,7446981,'rev',16.667,1),(213,7446985,7446981,'evi',16.667,1),(213,7446986,7446981,'vis',16.667,1),(213,7446987,7446981,'isi',16.667,1),(213,7446988,7446981,'sio',16.667,1),(213,7446989,7446981,'ion',16.667,1),(213,7446990,7446984,'lev',33.333,1),(213,7446991,7446984,'eve',33.333,1),(213,7446992,7446984,'vel',33.333,1),(213,7446993,7446990,'pse',25,1),(213,7446994,7446990,'seu',25,1),(213,7446995,7446990,'eud',25,1),(213,7446996,7446990,'udo',25,1),(213,7446997,7446993,'fal',33.333,5),(213,7446998,7446993,'als',33.333,5),(213,7446999,7446993,'lse',33.333,5),(213,7447000,7446997,'sta',25,3),(213,7447001,7446997,'tat',25,3),(213,7447002,7446997,'atu',25,3),(213,7447003,7446997,'tus',25,3),(213,7447004,7447000,'deg',16.667,1),(213,7447005,7447000,'egr',16.667,1),(213,7447006,7447000,'gra',16.667,1),(213,7447007,7447000,'rad',16.667,1),(213,7447008,7447000,'ade',16.667,1),(213,7447009,7447000,'ded',16.667,1),(213,7447010,7447004,'rdm',100,1),(213,7447011,7447010,'cap',20,1),(213,7447012,7447010,'apa',20,1),(213,7447013,7447010,'pab',20,1),(213,7447014,7447010,'abl',20,1),(213,7447015,7447010,'ble',20,1),(213,7447016,7447011,'tru',50,2),(213,7447017,7447011,'rue',50,2),(213,7447018,7447016,'loc',33.333,1),(213,7447019,7447016,'oca',33.333,1),(213,7447020,7447016,'cal',33.333,1),(213,7447021,7447018,'rem',14.286,1),(213,7447022,7447018,'emo',14.286,1),(213,7447023,7447018,'mov',14.286,1),(213,7447024,7447018,'ova',14.286,1),(213,7447025,7447018,'vab',14.286,1),(213,7447026,7447018,'abl',14.286,1),(213,7447027,7447018,'ble',14.286,1),(213,7447028,7447021,'ssd',100,1),(213,7447029,7447028,'off',20,1),(213,7447030,7447028,'ffl',20,1),(213,7447031,7447028,'fli',20,1),(213,7447032,7447028,'lin',20,1),(213,7447033,7447028,'ine',20,1),(213,7447034,7447029,'per',11.111,1),(213,7447035,7447029,'ere',11.111,1),(213,7447036,7447029,'ren',11.111,1),(213,7447037,7447029,'enn',11.111,1),(213,7447038,7447029,'nni',11.111,1),(213,7447039,7447029,'nia',11.111,1),(213,7447040,7447029,'ial',11.111,1),(213,7447041,7447029,'all',11.111,1),(213,7447042,7447029,'lly',11.111,1),(213,7447043,7447034,'res',16.667,1),(213,7447044,7447034,'ese',16.667,1),(213,7447045,7447034,'ser',16.667,1),(213,7447046,7447034,'erv',16.667,1),(213,7447047,7447034,'rve',16.667,1),(213,7447048,7447034,'ved',16.667,1),(213,7447049,7447043,'thi',50,1),(213,7447050,7447043,'hin',50,1),(213,7447051,7447049,'pro',10,1),(213,7447052,7447049,'rov',10,1),(213,7447053,7447049,'ovi',10,1),(213,7447054,7447049,'vis',10,1),(213,7447055,7447049,'isi',10,1),(213,7447056,7447049,'sio',10,1),(213,7447057,7447049,'ion',10,1),(213,7447058,7447049,'oni',10,1),(213,7447059,7447049,'nin',10,1),(213,7447060,7447049,'ing',10,1),(213,7447061,7447051,'unk',20,1),(213,7447062,7447051,'nkn',20,1),(213,7447063,7447051,'kno',20,1),(213,7447064,7447051,'now',20,1),(213,7447065,7447051,'own',20,1),(213,7447066,7447061,'fil',20,1),(213,7447067,7447061,'ilt',20,1),(213,7447068,7447061,'lte',20,1),(213,7447069,7447061,'ter',20,1),(213,7447070,7447061,'ers',20,1),(213,7447071,7447066,'vaa',50,1),(213,7447072,7447066,'aai',50,1),(213,7447073,7447071,'uns',11.111,1),(213,7447074,7447071,'nsu',11.111,1),(213,7447075,7447071,'sup',11.111,1),(213,7447076,7447071,'upp',11.111,1),(213,7447077,7447071,'ppo',11.111,1),(213,7447078,7447071,'por',11.111,1),(213,7447079,7447071,'ort',11.111,1),(213,7447080,7447071,'rte',11.111,1),(213,7447081,7447071,'ted',11.111,1),(213,7447082,7447073,'oth',33.333,1),(213,7447083,7447073,'the',33.333,1),(213,7447084,7447073,'her',33.333,1),(213,7447085,7447082,'uid',50,1),(213,7447086,7447082,'ids',50,1),(213,7447087,7447085,'vml',100,1),(213,7447088,7447087,'dis',20,1),(213,7447089,7447087,'isp',20,1),(213,7447090,7447087,'spl',20,1),(213,7447091,7447087,'pla',20,1),(213,7447092,7447087,'lay',20,1),(213,7447093,7447088,'nam',50,1),(213,7447094,7447088,'ame',50,1),(214,7447096,7447095,'net',25,3),(214,7447097,7447095,'eta',25,3),(214,7447098,7447095,'tap',25,3),(214,7447099,7447095,'app',25,3),(214,7447100,7447096,'fib',33.333,2),(214,7447101,7447096,'ibr',33.333,2),(214,7447102,7447096,'bre',33.333,2),(214,7447103,7447100,'cha',20,2),(214,7447104,7447100,'han',20,2),(214,7447105,7447100,'ann',20,2),(214,7447106,7447100,'nne',20,2),(214,7447107,7447100,'nel',20,2),(214,7447108,7447103,'dis',50,2),(214,7447109,7447103,'isk',50,2),(214,7447110,7447108,'naa',100,4),(214,7447111,7447110,'600',3.333,4),(214,7447112,7447110,'00a',3.333,4),(214,7447113,7447110,'0a0',3.333,4),(214,7447114,7447110,'a09',3.333,4),(214,7447115,7447110,'098',3.333,4),(214,7447116,7447110,'980',3.333,4),(214,7447117,7447110,'804',3.333,4),(214,7447118,7447110,'044',3.333,4),(214,7447119,7447110,'443',3.333,4),(214,7447120,7447110,'430',3.333,4),(214,7447121,7447110,'307',3.333,4),(214,7447122,7447110,'075',3.333,4),(214,7447123,7447110,'753',3.333,4),(214,7447124,7447110,'535',3.333,4),(214,7447125,7447110,'357',3.333,4),(214,7447126,7447110,'573',3.333,4),(214,7447127,7447110,'732',3.333,4),(214,7447128,7447110,'32b',3.333,4),(214,7447129,7447110,'2b3',3.333,4),(214,7447130,7447110,'b33',3.333,4),(214,7447131,7447110,'334',3.333,4),(214,7447132,7447110,'345',3.333,4),(214,7447133,7447110,'457',3.333,4),(214,7447134,7447110,'571',3.333,4),(214,7447135,7447110,'715',3.333,4),(214,7447136,7447110,'153',3.333,4),(214,7447137,7447110,'533',3.333,4),(214,7447138,7447110,'336',3.333,4),(214,7447139,7447110,'366',3.333,4),(214,7447140,7447110,'66c',3.333,4),(214,7447141,7447111,'ser',25,1),(214,7447142,7447111,'eri',25,1),(214,7447143,7447111,'ria',25,1),(214,7447144,7447111,'ial',25,1),(214,7447145,7447141,'siz',50,1),(214,7447146,7447141,'ize',50,1),(214,7447147,7447145,'321',100,1),(214,7447148,7447147,'dev',25,1),(214,7447149,7447147,'evi',25,1),(214,7447150,7447147,'vic',25,1),(214,7447151,7447147,'ice',25,1),(214,7447152,7447148,'typ',50,1),(214,7447153,7447148,'ype',50,1),(214,7447154,7447152,'dir',10,1),(214,7447155,7447152,'ire',10,1),(214,7447156,7447152,'rec',10,1),(214,7447157,7447152,'ect',10,1),(214,7447158,7447152,'cta',10,1),(214,7447159,7447152,'tac',10,1),(214,7447160,7447152,'acc',10,1),(214,7447161,7447152,'cce',10,1),(214,7447162,7447152,'ces',10,1),(214,7447163,7447152,'ess',10,1),(214,7447164,7447154,'mul',14.286,1),(214,7447165,7447154,'ult',14.286,1),(214,7447166,7447154,'lti',14.286,1),(214,7447167,7447154,'tip',14.286,1),(214,7447168,7447154,'ipa',14.286,1),(214,7447169,7447154,'pat',14.286,1),(214,7447170,7447154,'ath',14.286,1),(214,7447171,7447164,'plu',25,1),(214,7447172,7447164,'lug',25,1),(214,7447173,7447164,'ugi',25,1),(214,7447174,7447164,'gin',25,1),(214,7447175,7447171,'nmp',100,1),(214,7447176,7447175,'dev',33.333,1),(214,7447177,7447175,'evf',33.333,1),(214,7447178,7447175,'vfs',33.333,1),(214,7447179,7447176,'pat',50,1),(214,7447180,7447176,'ath',50,1),(214,7447181,7447179,'vmf',50,1),(214,7447182,7447179,'mfs',50,1),(214,7447183,7447181,'dev',20,1),(214,7447184,7447181,'evi',20,1),(214,7447185,7447181,'vic',20,1),(214,7447186,7447181,'ice',20,1),(214,7447187,7447181,'ces',20,1),(214,7447188,7447183,'dis',33.333,1),(214,7447189,7447183,'isk',33.333,1),(214,7447190,7447183,'sks',33.333,1),(214,7447191,7447188,'ven',25,1),(214,7447192,7447188,'end',25,1),(214,7447193,7447188,'ndo',25,1),(214,7447194,7447188,'dor',25,1),(214,7447195,7447191,'mod',33.333,1),(214,7447196,7447191,'ode',33.333,1),(214,7447197,7447191,'del',33.333,1),(214,7447198,7447195,'lun',100,1),(214,7447199,7447198,'cmo',33.333,1),(214,7447200,7447198,'mod',33.333,1),(214,7447201,7447198,'ode',33.333,1),(214,7447202,7447199,'rev',16.667,1),(214,7447203,7447199,'evi',16.667,1),(214,7447204,7447199,'vis',16.667,1),(214,7447205,7447199,'isi',16.667,1),(214,7447206,7447199,'sio',16.667,1),(214,7447207,7447199,'ion',16.667,1),(214,7447208,7447202,'810',50,1),(214,7447209,7447202,'100',50,1),(214,7447210,7447208,'scs',50,1),(214,7447211,7447208,'csi',50,1),(214,7447212,7447210,'lev',33.333,1),(214,7447213,7447210,'eve',33.333,1),(214,7447214,7447210,'vel',33.333,1),(214,7447215,7447212,'pse',25,1),(214,7447216,7447212,'seu',25,1),(214,7447217,7447212,'eud',25,1),(214,7447218,7447212,'udo',25,1),(214,7447219,7447215,'fal',33.333,6),(214,7447220,7447215,'als',33.333,6),(214,7447221,7447215,'lse',33.333,6),(214,7447222,7447219,'sta',25,3),(214,7447223,7447219,'tat',25,3),(214,7447224,7447219,'atu',25,3),(214,7447225,7447219,'tus',25,3),(214,7447226,7447222,'rdm',100,1),(214,7447227,7447226,'cap',20,1),(214,7447228,7447226,'apa',20,1),(214,7447229,7447226,'pab',20,1),(214,7447230,7447226,'abl',20,1),(214,7447231,7447226,'ble',20,1),(214,7447232,7447227,'tru',50,1),(214,7447233,7447227,'rue',50,1),(214,7447234,7447232,'loc',33.333,1),(214,7447235,7447232,'oca',33.333,1),(214,7447236,7447232,'cal',33.333,1),(214,7447237,7447234,'rem',14.286,1),(214,7447238,7447234,'emo',14.286,1),(214,7447239,7447234,'mov',14.286,1),(214,7447240,7447234,'ova',14.286,1),(214,7447241,7447234,'vab',14.286,1),(214,7447242,7447234,'abl',14.286,1),(214,7447243,7447234,'ble',14.286,1),(214,7447244,7447237,'ssd',100,1),(214,7447245,7447244,'off',20,1),(214,7447246,7447244,'ffl',20,1),(214,7447247,7447244,'fli',20,1),(214,7447248,7447244,'lin',20,1),(214,7447249,7447244,'ine',20,1),(214,7447250,7447245,'per',11.111,1),(214,7447251,7447245,'ere',11.111,1),(214,7447252,7447245,'ren',11.111,1),(214,7447253,7447245,'enn',11.111,1),(214,7447254,7447245,'nni',11.111,1),(214,7447255,7447245,'nia',11.111,1),(214,7447256,7447245,'ial',11.111,1),(214,7447257,7447245,'all',11.111,1),(214,7447258,7447245,'lly',11.111,1),(214,7447259,7447250,'res',16.667,1),(214,7447260,7447250,'ese',16.667,1),(214,7447261,7447250,'ser',16.667,1),(214,7447262,7447250,'erv',16.667,1),(214,7447263,7447250,'rve',16.667,1),(214,7447264,7447250,'ved',16.667,1),(214,7447265,7447259,'thi',50,1),(214,7447266,7447259,'hin',50,1),(214,7447267,7447265,'pro',10,1),(214,7447268,7447265,'rov',10,1),(214,7447269,7447265,'ovi',10,1),(214,7447270,7447265,'vis',10,1),(214,7447271,7447265,'isi',10,1),(214,7447272,7447265,'sio',10,1),(214,7447273,7447265,'ion',10,1),(214,7447274,7447265,'oni',10,1),(214,7447275,7447265,'nin',10,1),(214,7447276,7447265,'ing',10,1),(214,7447277,7447267,'yes',100,1),(214,7447278,7447277,'att',16.667,1),(214,7447279,7447277,'tta',16.667,1),(214,7447280,7447277,'tac',16.667,1),(214,7447281,7447277,'ach',16.667,1),(214,7447282,7447277,'che',16.667,1),(214,7447283,7447277,'hed',16.667,1),(214,7447284,7447278,'fil',20,1),(214,7447285,7447278,'ilt',20,1),(214,7447286,7447278,'lte',20,1),(214,7447287,7447278,'ter',20,1),(214,7447288,7447278,'ers',20,1),(214,7447289,7447284,'vaa',50,1),(214,7447290,7447284,'aai',50,1),(214,7447291,7447289,'unk',20,1),(214,7447292,7447289,'nkn',20,1),(214,7447293,7447289,'kno',20,1),(214,7447294,7447289,'now',20,1),(214,7447295,7447289,'own',20,1),(214,7447296,7447291,'oth',33.333,1),(214,7447297,7447291,'the',33.333,1),(214,7447298,7447291,'her',33.333,1),(214,7447299,7447296,'uid',50,1),(214,7447300,7447296,'ids',50,1),(214,7447301,7447299,'vml',100,1),(214,7447302,7447301,'dis',20,1),(214,7447303,7447301,'isp',20,1),(214,7447304,7447301,'spl',20,1),(214,7447305,7447301,'pla',20,1),(214,7447306,7447301,'lay',20,1),(214,7447307,7447302,'nam',50,1),(214,7447308,7447302,'ame',50,1),(215,7447310,7447309,'net',25,3),(215,7447311,7447309,'eta',25,3),(215,7447312,7447309,'tap',25,3),(215,7447313,7447309,'app',25,3),(215,7447314,7447310,'fib',33.333,2),(215,7447315,7447310,'ibr',33.333,2),(215,7447316,7447310,'bre',33.333,2),(215,7447317,7447314,'cha',20,2),(215,7447318,7447314,'han',20,2),(215,7447319,7447314,'ann',20,2),(215,7447320,7447314,'nne',20,2),(215,7447321,7447314,'nel',20,2),(215,7447322,7447317,'dis',50,2),(215,7447323,7447317,'isk',50,2),(215,7447324,7447322,'naa',100,4),(215,7447325,7447324,'600',3.333,4),(215,7447326,7447324,'00a',3.333,4),(215,7447327,7447324,'0a0',3.333,4),(215,7447328,7447324,'a09',3.333,4),(215,7447329,7447324,'098',3.333,4),(215,7447330,7447324,'980',3.333,4),(215,7447331,7447324,'804',3.333,4),(215,7447332,7447324,'044',3.333,4),(215,7447333,7447324,'443',3.333,4),(215,7447334,7447324,'430',3.333,4),(215,7447335,7447324,'307',3.333,4),(215,7447336,7447324,'075',3.333,4),(215,7447337,7447324,'753',3.333,4),(215,7447338,7447324,'535',3.333,4),(215,7447339,7447324,'357',3.333,4),(215,7447340,7447324,'573',3.333,4),(215,7447341,7447324,'732',3.333,4),(215,7447342,7447324,'32b',3.333,4),(215,7447343,7447324,'2b3',3.333,4),(215,7447344,7447324,'b33',3.333,4),(215,7447345,7447324,'334',3.333,4),(215,7447346,7447324,'345',3.333,4),(215,7447347,7447324,'457',3.333,4),(215,7447348,7447324,'571',3.333,4),(215,7447349,7447324,'715',3.333,4),(215,7447350,7447324,'153',3.333,4),(215,7447351,7447324,'533',3.333,4),(215,7447352,7447324,'336',3.333,4),(215,7447353,7447324,'366',3.333,4),(215,7447354,7447324,'66d',3.333,4),(215,7447355,7447325,'ser',25,1),(215,7447356,7447325,'eri',25,1),(215,7447357,7447325,'ria',25,1),(215,7447358,7447325,'ial',25,1),(215,7447359,7447355,'siz',50,1),(215,7447360,7447355,'ize',50,1),(215,7447361,7447359,'321',100,1),(215,7447362,7447361,'dev',25,1),(215,7447363,7447361,'evi',25,1),(215,7447364,7447361,'vic',25,1),(215,7447365,7447361,'ice',25,1),(215,7447366,7447362,'typ',50,1),(215,7447367,7447362,'ype',50,1),(215,7447368,7447366,'dir',10,1),(215,7447369,7447366,'ire',10,1),(215,7447370,7447366,'rec',10,1),(215,7447371,7447366,'ect',10,1),(215,7447372,7447366,'cta',10,1),(215,7447373,7447366,'tac',10,1),(215,7447374,7447366,'acc',10,1),(215,7447375,7447366,'cce',10,1),(215,7447376,7447366,'ces',10,1),(215,7447377,7447366,'ess',10,1),(215,7447378,7447368,'mul',14.286,1),(215,7447379,7447368,'ult',14.286,1),(215,7447380,7447368,'lti',14.286,1),(215,7447381,7447368,'tip',14.286,1),(215,7447382,7447368,'ipa',14.286,1),(215,7447383,7447368,'pat',14.286,1),(215,7447384,7447368,'ath',14.286,1),(215,7447385,7447378,'plu',25,1),(215,7447386,7447378,'lug',25,1),(215,7447387,7447378,'ugi',25,1),(215,7447388,7447378,'gin',25,1),(215,7447389,7447385,'nmp',100,1),(215,7447390,7447389,'dev',33.333,1),(215,7447391,7447389,'evf',33.333,1),(215,7447392,7447389,'vfs',33.333,1),(215,7447393,7447390,'pat',50,1),(215,7447394,7447390,'ath',50,1),(215,7447395,7447393,'vmf',50,1),(215,7447396,7447393,'mfs',50,1),(215,7447397,7447395,'dev',20,1),(215,7447398,7447395,'evi',20,1),(215,7447399,7447395,'vic',20,1),(215,7447400,7447395,'ice',20,1),(215,7447401,7447395,'ces',20,1),(215,7447402,7447397,'dis',33.333,1),(215,7447403,7447397,'isk',33.333,1),(215,7447404,7447397,'sks',33.333,1),(215,7447405,7447402,'ven',25,1),(215,7447406,7447402,'end',25,1),(215,7447407,7447402,'ndo',25,1),(215,7447408,7447402,'dor',25,1),(215,7447409,7447405,'mod',33.333,1),(215,7447410,7447405,'ode',33.333,1),(215,7447411,7447405,'del',33.333,1),(215,7447412,7447409,'lun',100,1),(215,7447413,7447412,'cmo',33.333,1),(215,7447414,7447412,'mod',33.333,1),(215,7447415,7447412,'ode',33.333,1),(215,7447416,7447413,'rev',16.667,1),(215,7447417,7447413,'evi',16.667,1),(215,7447418,7447413,'vis',16.667,1),(215,7447419,7447413,'isi',16.667,1),(215,7447420,7447413,'sio',16.667,1),(215,7447421,7447413,'ion',16.667,1),(215,7447422,7447416,'810',50,1),(215,7447423,7447416,'100',50,1),(215,7447424,7447422,'scs',50,1),(215,7447425,7447422,'csi',50,1),(215,7447426,7447424,'lev',33.333,1),(215,7447427,7447424,'eve',33.333,1),(215,7447428,7447424,'vel',33.333,1),(215,7447429,7447426,'pse',25,1),(215,7447430,7447426,'seu',25,1),(215,7447431,7447426,'eud',25,1),(215,7447432,7447426,'udo',25,1),(215,7447433,7447429,'fal',33.333,6),(215,7447434,7447429,'als',33.333,6),(215,7447435,7447429,'lse',33.333,6),(215,7447436,7447433,'sta',25,3),(215,7447437,7447433,'tat',25,3),(215,7447438,7447433,'atu',25,3),(215,7447439,7447433,'tus',25,3),(215,7447440,7447436,'rdm',100,1),(215,7447441,7447440,'cap',20,1),(215,7447442,7447440,'apa',20,1),(215,7447443,7447440,'pab',20,1),(215,7447444,7447440,'abl',20,1),(215,7447445,7447440,'ble',20,1),(215,7447446,7447441,'tru',50,1),(215,7447447,7447441,'rue',50,1),(215,7447448,7447446,'loc',33.333,1),(215,7447449,7447446,'oca',33.333,1),(215,7447450,7447446,'cal',33.333,1),(215,7447451,7447448,'rem',14.286,1),(215,7447452,7447448,'emo',14.286,1),(215,7447453,7447448,'mov',14.286,1),(215,7447454,7447448,'ova',14.286,1),(215,7447455,7447448,'vab',14.286,1),(215,7447456,7447448,'abl',14.286,1),(215,7447457,7447448,'ble',14.286,1),(215,7447458,7447451,'ssd',100,1),(215,7447459,7447458,'off',20,1),(215,7447460,7447458,'ffl',20,1),(215,7447461,7447458,'fli',20,1),(215,7447462,7447458,'lin',20,1),(215,7447463,7447458,'ine',20,1),(215,7447464,7447459,'per',11.111,1),(215,7447465,7447459,'ere',11.111,1),(215,7447466,7447459,'ren',11.111,1),(215,7447467,7447459,'enn',11.111,1),(215,7447468,7447459,'nni',11.111,1),(215,7447469,7447459,'nia',11.111,1),(215,7447470,7447459,'ial',11.111,1),(215,7447471,7447459,'all',11.111,1),(215,7447472,7447459,'lly',11.111,1),(215,7447473,7447464,'res',16.667,1),(215,7447474,7447464,'ese',16.667,1),(215,7447475,7447464,'ser',16.667,1),(215,7447476,7447464,'erv',16.667,1),(215,7447477,7447464,'rve',16.667,1),(215,7447478,7447464,'ved',16.667,1),(215,7447479,7447473,'thi',50,1),(215,7447480,7447473,'hin',50,1),(215,7447481,7447479,'pro',10,1),(215,7447482,7447479,'rov',10,1),(215,7447483,7447479,'ovi',10,1),(215,7447484,7447479,'vis',10,1),(215,7447485,7447479,'isi',10,1),(215,7447486,7447479,'sio',10,1),(215,7447487,7447479,'ion',10,1),(215,7447488,7447479,'oni',10,1),(215,7447489,7447479,'nin',10,1),(215,7447490,7447479,'ing',10,1),(215,7447491,7447481,'yes',100,1),(215,7447492,7447491,'att',16.667,1),(215,7447493,7447491,'tta',16.667,1),(215,7447494,7447491,'tac',16.667,1),(215,7447495,7447491,'ach',16.667,1),(215,7447496,7447491,'che',16.667,1),(215,7447497,7447491,'hed',16.667,1),(215,7447498,7447492,'fil',20,1),(215,7447499,7447492,'ilt',20,1),(215,7447500,7447492,'lte',20,1),(215,7447501,7447492,'ter',20,1),(215,7447502,7447492,'ers',20,1),(215,7447503,7447498,'vaa',50,1),(215,7447504,7447498,'aai',50,1),(215,7447505,7447503,'unk',20,1),(215,7447506,7447503,'nkn',20,1),(215,7447507,7447503,'kno',20,1),(215,7447508,7447503,'now',20,1),(215,7447509,7447503,'own',20,1),(215,7447510,7447505,'oth',33.333,1),(215,7447511,7447505,'the',33.333,1),(215,7447512,7447505,'her',33.333,1),(215,7447513,7447510,'uid',50,1),(215,7447514,7447510,'ids',50,1),(215,7447515,7447513,'vml',100,1),(215,7447516,7447515,'dis',20,1),(215,7447517,7447515,'isp',20,1),(215,7447518,7447515,'spl',20,1),(215,7447519,7447515,'pla',20,1),(215,7447520,7447515,'lay',20,1),(215,7447521,7447516,'nam',50,1),(215,7447522,7447516,'ame',50,1),(216,7447524,7447523,'net',25,3),(216,7447525,7447523,'eta',25,3),(216,7447526,7447523,'tap',25,3),(216,7447527,7447523,'app',25,3),(216,7447528,7447524,'fib',33.333,2),(216,7447529,7447524,'ibr',33.333,2),(216,7447530,7447524,'bre',33.333,2),(216,7447531,7447528,'cha',20,2),(216,7447532,7447528,'han',20,2),(216,7447533,7447528,'ann',20,2),(216,7447534,7447528,'nne',20,2),(216,7447535,7447528,'nel',20,2),(216,7447536,7447531,'dis',50,2),(216,7447537,7447531,'isk',50,2),(216,7447538,7447536,'naa',100,4),(216,7447539,7447538,'600',3.333,4),(216,7447540,7447538,'00a',3.333,4),(216,7447541,7447538,'0a0',3.333,4),(216,7447542,7447538,'a09',3.333,4),(216,7447543,7447538,'098',3.333,4),(216,7447544,7447538,'980',3.333,4),(216,7447545,7447538,'804',3.333,4),(216,7447546,7447538,'044',3.333,4),(216,7447547,7447538,'443',3.333,4),(216,7447548,7447538,'430',3.333,4),(216,7447549,7447538,'307',3.333,4),(216,7447550,7447538,'075',3.333,4),(216,7447551,7447538,'753',3.333,4),(216,7447552,7447538,'535',3.333,4),(216,7447553,7447538,'357',3.333,4),(216,7447554,7447538,'573',3.333,4),(216,7447555,7447538,'732',3.333,4),(216,7447556,7447538,'32b',3.333,4),(216,7447557,7447538,'2b3',3.333,4),(216,7447558,7447538,'b33',3.333,4),(216,7447559,7447538,'334',3.333,4),(216,7447560,7447538,'345',3.333,4),(216,7447561,7447538,'457',3.333,4),(216,7447562,7447538,'571',3.333,4),(216,7447563,7447538,'715',3.333,4),(216,7447564,7447538,'153',3.333,4),(216,7447565,7447538,'533',3.333,4),(216,7447566,7447538,'336',3.333,4),(216,7447567,7447538,'366',3.333,4),(216,7447568,7447538,'66e',3.333,4),(216,7447569,7447539,'ser',25,1),(216,7447570,7447539,'eri',25,1),(216,7447571,7447539,'ria',25,1),(216,7447572,7447539,'ial',25,1),(216,7447573,7447569,'siz',50,1),(216,7447574,7447569,'ize',50,1),(216,7447575,7447573,'321',100,1),(216,7447576,7447575,'dev',25,1),(216,7447577,7447575,'evi',25,1),(216,7447578,7447575,'vic',25,1),(216,7447579,7447575,'ice',25,1),(216,7447580,7447576,'typ',50,1),(216,7447581,7447576,'ype',50,1),(216,7447582,7447580,'dir',10,1),(216,7447583,7447580,'ire',10,1),(216,7447584,7447580,'rec',10,1),(216,7447585,7447580,'ect',10,1),(216,7447586,7447580,'cta',10,1),(216,7447587,7447580,'tac',10,1),(216,7447588,7447580,'acc',10,1),(216,7447589,7447580,'cce',10,1),(216,7447590,7447580,'ces',10,1),(216,7447591,7447580,'ess',10,1),(216,7447592,7447582,'mul',14.286,1),(216,7447593,7447582,'ult',14.286,1),(216,7447594,7447582,'lti',14.286,1),(216,7447595,7447582,'tip',14.286,1),(216,7447596,7447582,'ipa',14.286,1),(216,7447597,7447582,'pat',14.286,1),(216,7447598,7447582,'ath',14.286,1),(216,7447599,7447592,'plu',25,1),(216,7447600,7447592,'lug',25,1),(216,7447601,7447592,'ugi',25,1),(216,7447602,7447592,'gin',25,1),(216,7447603,7447599,'nmp',100,1),(216,7447604,7447603,'dev',33.333,1),(216,7447605,7447603,'evf',33.333,1),(216,7447606,7447603,'vfs',33.333,1),(216,7447607,7447604,'pat',50,1),(216,7447608,7447604,'ath',50,1),(216,7447609,7447607,'vmf',50,1),(216,7447610,7447607,'mfs',50,1),(216,7447611,7447609,'dev',20,1),(216,7447612,7447609,'evi',20,1),(216,7447613,7447609,'vic',20,1),(216,7447614,7447609,'ice',20,1),(216,7447615,7447609,'ces',20,1),(216,7447616,7447611,'dis',33.333,1),(216,7447617,7447611,'isk',33.333,1),(216,7447618,7447611,'sks',33.333,1),(216,7447619,7447616,'ven',25,1),(216,7447620,7447616,'end',25,1),(216,7447621,7447616,'ndo',25,1),(216,7447622,7447616,'dor',25,1),(216,7447623,7447619,'mod',33.333,1),(216,7447624,7447619,'ode',33.333,1),(216,7447625,7447619,'del',33.333,1),(216,7447626,7447623,'lun',100,1),(216,7447627,7447626,'cmo',33.333,1),(216,7447628,7447626,'mod',33.333,1),(216,7447629,7447626,'ode',33.333,1),(216,7447630,7447627,'rev',16.667,1),(216,7447631,7447627,'evi',16.667,1),(216,7447632,7447627,'vis',16.667,1),(216,7447633,7447627,'isi',16.667,1),(216,7447634,7447627,'sio',16.667,1),(216,7447635,7447627,'ion',16.667,1),(216,7447636,7447630,'810',50,1),(216,7447637,7447630,'100',50,1),(216,7447638,7447636,'scs',50,1),(216,7447639,7447636,'csi',50,1),(216,7447640,7447638,'lev',33.333,1),(216,7447641,7447638,'eve',33.333,1),(216,7447642,7447638,'vel',33.333,1),(216,7447643,7447640,'pse',25,1),(216,7447644,7447640,'seu',25,1),(216,7447645,7447640,'eud',25,1),(216,7447646,7447640,'udo',25,1),(216,7447647,7447643,'fal',33.333,6),(216,7447648,7447643,'als',33.333,6),(216,7447649,7447643,'lse',33.333,6),(216,7447650,7447647,'sta',25,3),(216,7447651,7447647,'tat',25,3),(216,7447652,7447647,'atu',25,3),(216,7447653,7447647,'tus',25,3),(216,7447654,7447650,'rdm',100,1),(216,7447655,7447654,'cap',20,1),(216,7447656,7447654,'apa',20,1),(216,7447657,7447654,'pab',20,1),(216,7447658,7447654,'abl',20,1),(216,7447659,7447654,'ble',20,1),(216,7447660,7447655,'tru',50,1),(216,7447661,7447655,'rue',50,1),(216,7447662,7447660,'loc',33.333,1),(216,7447663,7447660,'oca',33.333,1),(216,7447664,7447660,'cal',33.333,1),(216,7447665,7447662,'rem',14.286,1),(216,7447666,7447662,'emo',14.286,1),(216,7447667,7447662,'mov',14.286,1),(216,7447668,7447662,'ova',14.286,1),(216,7447669,7447662,'vab',14.286,1),(216,7447670,7447662,'abl',14.286,1),(216,7447671,7447662,'ble',14.286,1),(216,7447672,7447665,'ssd',100,1),(216,7447673,7447672,'off',20,1),(216,7447674,7447672,'ffl',20,1),(216,7447675,7447672,'fli',20,1),(216,7447676,7447672,'lin',20,1),(216,7447677,7447672,'ine',20,1),(216,7447678,7447673,'per',11.111,1),(216,7447679,7447673,'ere',11.111,1),(216,7447680,7447673,'ren',11.111,1),(216,7447681,7447673,'enn',11.111,1),(216,7447682,7447673,'nni',11.111,1),(216,7447683,7447673,'nia',11.111,1),(216,7447684,7447673,'ial',11.111,1),(216,7447685,7447673,'all',11.111,1),(216,7447686,7447673,'lly',11.111,1),(216,7447687,7447678,'res',16.667,1),(216,7447688,7447678,'ese',16.667,1),(216,7447689,7447678,'ser',16.667,1),(216,7447690,7447678,'erv',16.667,1),(216,7447691,7447678,'rve',16.667,1),(216,7447692,7447678,'ved',16.667,1),(216,7447693,7447687,'thi',50,1),(216,7447694,7447687,'hin',50,1),(216,7447695,7447693,'pro',10,1),(216,7447696,7447693,'rov',10,1),(216,7447697,7447693,'ovi',10,1),(216,7447698,7447693,'vis',10,1),(216,7447699,7447693,'isi',10,1),(216,7447700,7447693,'sio',10,1),(216,7447701,7447693,'ion',10,1),(216,7447702,7447693,'oni',10,1),(216,7447703,7447693,'nin',10,1),(216,7447704,7447693,'ing',10,1),(216,7447705,7447695,'yes',100,1),(216,7447706,7447705,'att',16.667,1),(216,7447707,7447705,'tta',16.667,1),(216,7447708,7447705,'tac',16.667,1),(216,7447709,7447705,'ach',16.667,1),(216,7447710,7447705,'che',16.667,1),(216,7447711,7447705,'hed',16.667,1),(216,7447712,7447706,'fil',20,1),(216,7447713,7447706,'ilt',20,1),(216,7447714,7447706,'lte',20,1),(216,7447715,7447706,'ter',20,1),(216,7447716,7447706,'ers',20,1),(216,7447717,7447712,'vaa',50,1),(216,7447718,7447712,'aai',50,1),(216,7447719,7447717,'unk',20,1),(216,7447720,7447717,'nkn',20,1),(216,7447721,7447717,'kno',20,1),(216,7447722,7447717,'now',20,1),(216,7447723,7447717,'own',20,1),(216,7447724,7447719,'oth',33.333,1),(216,7447725,7447719,'the',33.333,1),(216,7447726,7447719,'her',33.333,1),(216,7447727,7447724,'uid',50,1),(216,7447728,7447724,'ids',50,1),(216,7447729,7447727,'vml',100,1),(216,7447730,7447729,'dis',20,1),(216,7447731,7447729,'isp',20,1),(216,7447732,7447729,'spl',20,1),(216,7447733,7447729,'pla',20,1),(216,7447734,7447729,'lay',20,1),(216,7447735,7447730,'nam',50,1),(216,7447736,7447730,'ame',50,1),(217,7447738,7447737,'net',25,3),(217,7447739,7447737,'eta',25,3),(217,7447740,7447737,'tap',25,3),(217,7447741,7447737,'app',25,3),(217,7447742,7447738,'fib',33.333,2),(217,7447743,7447738,'ibr',33.333,2),(217,7447744,7447738,'bre',33.333,2),(217,7447745,7447742,'cha',20,2),(217,7447746,7447742,'han',20,2),(217,7447747,7447742,'ann',20,2),(217,7447748,7447742,'nne',20,2),(217,7447749,7447742,'nel',20,2),(217,7447750,7447745,'dis',50,2),(217,7447751,7447745,'isk',50,2),(217,7447752,7447750,'naa',100,4),(217,7447753,7447752,'600',3.333,4),(217,7447754,7447752,'00a',3.333,4),(217,7447755,7447752,'0a0',3.333,4),(217,7447756,7447752,'a09',3.333,4),(217,7447757,7447752,'098',3.333,4),(217,7447758,7447752,'980',3.333,4),(217,7447759,7447752,'804',3.333,4),(217,7447760,7447752,'044',3.333,4),(217,7447761,7447752,'443',3.333,4),(217,7447762,7447752,'430',3.333,4),(217,7447763,7447752,'307',3.333,4),(217,7447764,7447752,'075',3.333,4),(217,7447765,7447752,'753',3.333,4),(217,7447766,7447752,'535',3.333,4),(217,7447767,7447752,'357',3.333,4),(217,7447768,7447752,'573',3.333,4),(217,7447769,7447752,'732',3.333,4),(217,7447770,7447752,'32b',3.333,4),(217,7447771,7447752,'2b3',3.333,4),(217,7447772,7447752,'b33',3.333,4),(217,7447773,7447752,'334',3.333,4),(217,7447774,7447752,'345',3.333,4),(217,7447775,7447752,'457',3.333,4),(217,7447776,7447752,'571',3.333,4),(217,7447777,7447752,'715',3.333,4),(217,7447778,7447752,'153',3.333,4),(217,7447779,7447752,'533',3.333,4),(217,7447780,7447752,'336',3.333,4),(217,7447781,7447752,'366',3.333,4),(217,7447782,7447752,'66f',3.333,4),(217,7447783,7447753,'ser',25,1),(217,7447784,7447753,'eri',25,1),(217,7447785,7447753,'ria',25,1),(217,7447786,7447753,'ial',25,1),(217,7447787,7447783,'siz',50,1),(217,7447788,7447783,'ize',50,1),(217,7447789,7447787,'321',100,1),(217,7447790,7447789,'dev',25,1),(217,7447791,7447789,'evi',25,1),(217,7447792,7447789,'vic',25,1),(217,7447793,7447789,'ice',25,1),(217,7447794,7447790,'typ',50,1),(217,7447795,7447790,'ype',50,1),(217,7447796,7447794,'dir',10,1),(217,7447797,7447794,'ire',10,1),(217,7447798,7447794,'rec',10,1),(217,7447799,7447794,'ect',10,1),(217,7447800,7447794,'cta',10,1),(217,7447801,7447794,'tac',10,1),(217,7447802,7447794,'acc',10,1),(217,7447803,7447794,'cce',10,1),(217,7447804,7447794,'ces',10,1),(217,7447805,7447794,'ess',10,1),(217,7447806,7447796,'mul',14.286,1),(217,7447807,7447796,'ult',14.286,1),(217,7447808,7447796,'lti',14.286,1),(217,7447809,7447796,'tip',14.286,1),(217,7447810,7447796,'ipa',14.286,1),(217,7447811,7447796,'pat',14.286,1),(217,7447812,7447796,'ath',14.286,1),(217,7447813,7447806,'plu',25,1),(217,7447814,7447806,'lug',25,1),(217,7447815,7447806,'ugi',25,1),(217,7447816,7447806,'gin',25,1),(217,7447817,7447813,'nmp',100,1),(217,7447818,7447817,'dev',33.333,1),(217,7447819,7447817,'evf',33.333,1),(217,7447820,7447817,'vfs',33.333,1),(217,7447821,7447818,'pat',50,1),(217,7447822,7447818,'ath',50,1),(217,7447823,7447821,'vmf',50,1),(217,7447824,7447821,'mfs',50,1),(217,7447825,7447823,'dev',20,1),(217,7447826,7447823,'evi',20,1),(217,7447827,7447823,'vic',20,1),(217,7447828,7447823,'ice',20,1),(217,7447829,7447823,'ces',20,1),(217,7447830,7447825,'dis',33.333,1),(217,7447831,7447825,'isk',33.333,1),(217,7447832,7447825,'sks',33.333,1),(217,7447833,7447830,'ven',25,1),(217,7447834,7447830,'end',25,1),(217,7447835,7447830,'ndo',25,1),(217,7447836,7447830,'dor',25,1),(217,7447837,7447833,'mod',33.333,1),(217,7447838,7447833,'ode',33.333,1),(217,7447839,7447833,'del',33.333,1),(217,7447840,7447837,'lun',100,1),(217,7447841,7447840,'cmo',33.333,1),(217,7447842,7447840,'mod',33.333,1),(217,7447843,7447840,'ode',33.333,1),(217,7447844,7447841,'rev',16.667,1),(217,7447845,7447841,'evi',16.667,1),(217,7447846,7447841,'vis',16.667,1),(217,7447847,7447841,'isi',16.667,1),(217,7447848,7447841,'sio',16.667,1),(217,7447849,7447841,'ion',16.667,1),(217,7447850,7447844,'810',50,1),(217,7447851,7447844,'100',50,1),(217,7447852,7447850,'scs',50,1),(217,7447853,7447850,'csi',50,1),(217,7447854,7447852,'lev',33.333,1),(217,7447855,7447852,'eve',33.333,1),(217,7447856,7447852,'vel',33.333,1),(217,7447857,7447854,'pse',25,1),(217,7447858,7447854,'seu',25,1),(217,7447859,7447854,'eud',25,1),(217,7447860,7447854,'udo',25,1),(217,7447861,7447857,'fal',33.333,6),(217,7447862,7447857,'als',33.333,6),(217,7447863,7447857,'lse',33.333,6),(217,7447864,7447861,'sta',25,3),(217,7447865,7447861,'tat',25,3),(217,7447866,7447861,'atu',25,3),(217,7447867,7447861,'tus',25,3),(217,7447868,7447864,'rdm',100,1),(217,7447869,7447868,'cap',20,1),(217,7447870,7447868,'apa',20,1),(217,7447871,7447868,'pab',20,1),(217,7447872,7447868,'abl',20,1),(217,7447873,7447868,'ble',20,1),(217,7447874,7447869,'tru',50,1),(217,7447875,7447869,'rue',50,1),(217,7447876,7447874,'loc',33.333,1),(217,7447877,7447874,'oca',33.333,1),(217,7447878,7447874,'cal',33.333,1),(217,7447879,7447876,'rem',14.286,1),(217,7447880,7447876,'emo',14.286,1),(217,7447881,7447876,'mov',14.286,1),(217,7447882,7447876,'ova',14.286,1),(217,7447883,7447876,'vab',14.286,1),(217,7447884,7447876,'abl',14.286,1),(217,7447885,7447876,'ble',14.286,1),(217,7447886,7447879,'ssd',100,1),(217,7447887,7447886,'off',20,1),(217,7447888,7447886,'ffl',20,1),(217,7447889,7447886,'fli',20,1),(217,7447890,7447886,'lin',20,1),(217,7447891,7447886,'ine',20,1),(217,7447892,7447887,'per',11.111,1),(217,7447893,7447887,'ere',11.111,1),(217,7447894,7447887,'ren',11.111,1),(217,7447895,7447887,'enn',11.111,1),(217,7447896,7447887,'nni',11.111,1),(217,7447897,7447887,'nia',11.111,1),(217,7447898,7447887,'ial',11.111,1),(217,7447899,7447887,'all',11.111,1),(217,7447900,7447887,'lly',11.111,1),(217,7447901,7447892,'res',16.667,1),(217,7447902,7447892,'ese',16.667,1),(217,7447903,7447892,'ser',16.667,1),(217,7447904,7447892,'erv',16.667,1),(217,7447905,7447892,'rve',16.667,1),(217,7447906,7447892,'ved',16.667,1),(217,7447907,7447901,'thi',50,1),(217,7447908,7447901,'hin',50,1),(217,7447909,7447907,'pro',10,1),(217,7447910,7447907,'rov',10,1),(217,7447911,7447907,'ovi',10,1),(217,7447912,7447907,'vis',10,1),(217,7447913,7447907,'isi',10,1),(217,7447914,7447907,'sio',10,1),(217,7447915,7447907,'ion',10,1),(217,7447916,7447907,'oni',10,1),(217,7447917,7447907,'nin',10,1),(217,7447918,7447907,'ing',10,1),(217,7447919,7447909,'yes',100,1),(217,7447920,7447919,'att',16.667,1),(217,7447921,7447919,'tta',16.667,1),(217,7447922,7447919,'tac',16.667,1),(217,7447923,7447919,'ach',16.667,1),(217,7447924,7447919,'che',16.667,1),(217,7447925,7447919,'hed',16.667,1),(217,7447926,7447920,'fil',20,1),(217,7447927,7447920,'ilt',20,1),(217,7447928,7447920,'lte',20,1),(217,7447929,7447920,'ter',20,1),(217,7447930,7447920,'ers',20,1),(217,7447931,7447926,'vaa',50,1),(217,7447932,7447926,'aai',50,1),(217,7447933,7447931,'unk',20,1),(217,7447934,7447931,'nkn',20,1),(217,7447935,7447931,'kno',20,1),(217,7447936,7447931,'now',20,1),(217,7447937,7447931,'own',20,1),(217,7447938,7447933,'oth',33.333,1),(217,7447939,7447933,'the',33.333,1),(217,7447940,7447933,'her',33.333,1),(217,7447941,7447938,'uid',50,1),(217,7447942,7447938,'ids',50,1),(217,7447943,7447941,'vml',100,1),(217,7447944,7447943,'dis',20,1),(217,7447945,7447943,'isp',20,1),(217,7447946,7447943,'spl',20,1),(217,7447947,7447943,'pla',20,1),(217,7447948,7447943,'lay',20,1),(217,7447949,7447944,'nam',50,1),(217,7447950,7447944,'ame',50,1),(218,7447952,7447951,'net',25,3),(218,7447953,7447951,'eta',25,3),(218,7447954,7447951,'tap',25,3),(218,7447955,7447951,'app',25,3),(218,7447956,7447952,'fib',33.333,2),(218,7447957,7447952,'ibr',33.333,2),(218,7447958,7447952,'bre',33.333,2),(218,7447959,7447956,'cha',20,2),(218,7447960,7447956,'han',20,2),(218,7447961,7447956,'ann',20,2),(218,7447962,7447956,'nne',20,2),(218,7447963,7447956,'nel',20,2),(218,7447964,7447959,'dis',50,2),(218,7447965,7447959,'isk',50,2),(218,7447966,7447964,'naa',100,4),(218,7447967,7447966,'600',3.333,4),(218,7447968,7447966,'00a',3.333,4),(218,7447969,7447966,'0a0',3.333,4),(218,7447970,7447966,'a09',3.333,4),(218,7447971,7447966,'098',3.333,4),(218,7447972,7447966,'980',3.333,4),(218,7447973,7447966,'804',3.333,4),(218,7447974,7447966,'044',3.333,4),(218,7447975,7447966,'443',3.333,4),(218,7447976,7447966,'430',3.333,4),(218,7447977,7447966,'307',3.333,4),(218,7447978,7447966,'075',3.333,4),(218,7447979,7447966,'753',3.333,4),(218,7447980,7447966,'535',3.333,4),(218,7447981,7447966,'357',3.333,4),(218,7447982,7447966,'573',3.333,4),(218,7447983,7447966,'732',3.333,4),(218,7447984,7447966,'32b',3.333,4),(218,7447985,7447966,'2b3',3.333,4),(218,7447986,7447966,'b33',3.333,4),(218,7447987,7447966,'334',3.333,4),(218,7447988,7447966,'345',3.333,4),(218,7447989,7447966,'457',3.333,4),(218,7447990,7447966,'571',3.333,4),(218,7447991,7447966,'715',3.333,4),(218,7447992,7447966,'152',3.333,4),(218,7447993,7447966,'527',3.333,4),(218,7447994,7447966,'275',3.333,4),(218,7447995,7447966,'754',3.333,4),(218,7447996,7447966,'54a',3.333,4),(218,7447997,7447967,'ser',25,1),(218,7447998,7447967,'eri',25,1),(218,7447999,7447967,'ria',25,1),(218,7448000,7447967,'ial',25,1),(218,7448001,7447997,'siz',50,1),(218,7448002,7447997,'ize',50,1),(218,7448003,7448001,'460',33.333,1),(218,7448004,7448001,'608',33.333,1),(218,7448005,7448001,'080',33.333,1),(218,7448006,7448003,'dev',25,1),(218,7448007,7448003,'evi',25,1),(218,7448008,7448003,'vic',25,1),(218,7448009,7448003,'ice',25,1),(218,7448010,7448006,'typ',50,1),(218,7448011,7448006,'ype',50,1),(218,7448012,7448010,'dir',10,1),(218,7448013,7448010,'ire',10,1),(218,7448014,7448010,'rec',10,1),(218,7448015,7448010,'ect',10,1),(218,7448016,7448010,'cta',10,1),(218,7448017,7448010,'tac',10,1),(218,7448018,7448010,'acc',10,1),(218,7448019,7448010,'cce',10,1),(218,7448020,7448010,'ces',10,1),(218,7448021,7448010,'ess',10,1),(218,7448022,7448012,'mul',14.286,1),(218,7448023,7448012,'ult',14.286,1),(218,7448024,7448012,'lti',14.286,1),(218,7448025,7448012,'tip',14.286,1),(218,7448026,7448012,'ipa',14.286,1),(218,7448027,7448012,'pat',14.286,1),(218,7448028,7448012,'ath',14.286,1),(218,7448029,7448022,'plu',25,1),(218,7448030,7448022,'lug',25,1),(218,7448031,7448022,'ugi',25,1),(218,7448032,7448022,'gin',25,1),(218,7448033,7448029,'nmp',100,1),(218,7448034,7448033,'dev',33.333,1),(218,7448035,7448033,'evf',33.333,1),(218,7448036,7448033,'vfs',33.333,1),(218,7448037,7448034,'pat',50,1),(218,7448038,7448034,'ath',50,1),(218,7448039,7448037,'vmf',50,1),(218,7448040,7448037,'mfs',50,1),(218,7448041,7448039,'dev',20,1),(218,7448042,7448039,'evi',20,1),(218,7448043,7448039,'vic',20,1),(218,7448044,7448039,'ice',20,1),(218,7448045,7448039,'ces',20,1),(218,7448046,7448041,'dis',33.333,1),(218,7448047,7448041,'isk',33.333,1),(218,7448048,7448041,'sks',33.333,1),(218,7448049,7448046,'ven',25,1),(218,7448050,7448046,'end',25,1),(218,7448051,7448046,'ndo',25,1),(218,7448052,7448046,'dor',25,1),(218,7448053,7448049,'mod',33.333,1),(218,7448054,7448049,'ode',33.333,1),(218,7448055,7448049,'del',33.333,1),(218,7448056,7448053,'lun',100,1),(218,7448057,7448056,'cmo',33.333,1),(218,7448058,7448056,'mod',33.333,1),(218,7448059,7448056,'ode',33.333,1),(218,7448060,7448057,'rev',16.667,1),(218,7448061,7448057,'evi',16.667,1),(218,7448062,7448057,'vis',16.667,1),(218,7448063,7448057,'isi',16.667,1),(218,7448064,7448057,'sio',16.667,1),(218,7448065,7448057,'ion',16.667,1),(218,7448066,7448060,'810',50,1),(218,7448067,7448060,'100',50,1),(218,7448068,7448066,'scs',50,1),(218,7448069,7448066,'csi',50,1),(218,7448070,7448068,'lev',33.333,1),(218,7448071,7448068,'eve',33.333,1),(218,7448072,7448068,'vel',33.333,1),(218,7448073,7448070,'pse',25,1),(218,7448074,7448070,'seu',25,1),(218,7448075,7448070,'eud',25,1),(218,7448076,7448070,'udo',25,1),(218,7448077,7448073,'fal',33.333,6),(218,7448078,7448073,'als',33.333,6),(218,7448079,7448073,'lse',33.333,6),(218,7448080,7448077,'sta',25,3),(218,7448081,7448077,'tat',25,3),(218,7448082,7448077,'atu',25,3),(218,7448083,7448077,'tus',25,3),(218,7448084,7448080,'rdm',100,1),(218,7448085,7448084,'cap',20,1),(218,7448086,7448084,'apa',20,1),(218,7448087,7448084,'pab',20,1),(218,7448088,7448084,'abl',20,1),(218,7448089,7448084,'ble',20,1),(218,7448090,7448085,'tru',50,1),(218,7448091,7448085,'rue',50,1),(218,7448092,7448090,'loc',33.333,1),(218,7448093,7448090,'oca',33.333,1),(218,7448094,7448090,'cal',33.333,1),(218,7448095,7448092,'rem',14.286,1),(218,7448096,7448092,'emo',14.286,1),(218,7448097,7448092,'mov',14.286,1),(218,7448098,7448092,'ova',14.286,1),(218,7448099,7448092,'vab',14.286,1),(218,7448100,7448092,'abl',14.286,1),(218,7448101,7448092,'ble',14.286,1),(218,7448102,7448095,'ssd',100,1),(218,7448103,7448102,'off',20,1),(218,7448104,7448102,'ffl',20,1),(218,7448105,7448102,'fli',20,1),(218,7448106,7448102,'lin',20,1),(218,7448107,7448102,'ine',20,1),(218,7448108,7448103,'per',11.111,1),(218,7448109,7448103,'ere',11.111,1),(218,7448110,7448103,'ren',11.111,1),(218,7448111,7448103,'enn',11.111,1),(218,7448112,7448103,'nni',11.111,1),(218,7448113,7448103,'nia',11.111,1),(218,7448114,7448103,'ial',11.111,1),(218,7448115,7448103,'all',11.111,1),(218,7448116,7448103,'lly',11.111,1),(218,7448117,7448108,'res',16.667,1),(218,7448118,7448108,'ese',16.667,1),(218,7448119,7448108,'ser',16.667,1),(218,7448120,7448108,'erv',16.667,1),(218,7448121,7448108,'rve',16.667,1),(218,7448122,7448108,'ved',16.667,1),(218,7448123,7448117,'thi',50,1),(218,7448124,7448117,'hin',50,1),(218,7448125,7448123,'pro',10,1),(218,7448126,7448123,'rov',10,1),(218,7448127,7448123,'ovi',10,1),(218,7448128,7448123,'vis',10,1),(218,7448129,7448123,'isi',10,1),(218,7448130,7448123,'sio',10,1),(218,7448131,7448123,'ion',10,1),(218,7448132,7448123,'oni',10,1),(218,7448133,7448123,'nin',10,1),(218,7448134,7448123,'ing',10,1),(218,7448135,7448125,'yes',100,1),(218,7448136,7448135,'att',16.667,1),(218,7448137,7448135,'tta',16.667,1),(218,7448138,7448135,'tac',16.667,1),(218,7448139,7448135,'ach',16.667,1),(218,7448140,7448135,'che',16.667,1),(218,7448141,7448135,'hed',16.667,1),(218,7448142,7448136,'fil',20,1),(218,7448143,7448136,'ilt',20,1),(218,7448144,7448136,'lte',20,1),(218,7448145,7448136,'ter',20,1),(218,7448146,7448136,'ers',20,1),(218,7448147,7448142,'vaa',50,1),(218,7448148,7448142,'aai',50,1),(218,7448149,7448147,'unk',20,1),(218,7448150,7448147,'nkn',20,1),(218,7448151,7448147,'kno',20,1),(218,7448152,7448147,'now',20,1),(218,7448153,7448147,'own',20,1),(218,7448154,7448149,'oth',33.333,1),(218,7448155,7448149,'the',33.333,1),(218,7448156,7448149,'her',33.333,1),(218,7448157,7448154,'uid',50,1),(218,7448158,7448154,'ids',50,1),(218,7448159,7448157,'vml',100,1),(218,7448160,7448159,'dis',20,1),(218,7448161,7448159,'isp',20,1),(218,7448162,7448159,'spl',20,1),(218,7448163,7448159,'pla',20,1),(218,7448164,7448159,'lay',20,1),(218,7448165,7448160,'nam',50,1),(218,7448166,7448160,'ame',50,1),(219,7448168,7448167,'net',25,3),(219,7448169,7448167,'eta',25,3),(219,7448170,7448167,'tap',25,3),(219,7448171,7448167,'app',25,3),(219,7448172,7448168,'fib',33.333,2),(219,7448173,7448168,'ibr',33.333,2),(219,7448174,7448168,'bre',33.333,2),(219,7448175,7448172,'cha',20,2),(219,7448176,7448172,'han',20,2),(219,7448177,7448172,'ann',20,2),(219,7448178,7448172,'nne',20,2),(219,7448179,7448172,'nel',20,2),(219,7448180,7448175,'dis',50,2),(219,7448181,7448175,'isk',50,2),(219,7448182,7448180,'naa',100,4),(219,7448183,7448182,'600',3.333,4),(219,7448184,7448182,'00a',3.333,4),(219,7448185,7448182,'0a0',3.333,4),(219,7448186,7448182,'a09',3.333,4),(219,7448187,7448182,'098',3.333,4),(219,7448188,7448182,'980',3.333,4),(219,7448189,7448182,'804',3.333,4),(219,7448190,7448182,'044',3.333,4),(219,7448191,7448182,'443',3.333,4),(219,7448192,7448182,'430',3.333,4),(219,7448193,7448182,'307',3.333,4),(219,7448194,7448182,'072',3.333,4),(219,7448195,7448182,'725',3.333,4),(219,7448196,7448182,'259',3.333,4),(219,7448197,7448182,'593',3.333,4),(219,7448198,7448182,'931',3.333,4),(219,7448199,7448182,'313',3.333,4),(219,7448200,7448182,'13f',3.333,4),(219,7448201,7448182,'3f3',3.333,4),(219,7448202,7448182,'f33',3.333,4),(219,7448203,7448182,'334',3.333,4),(219,7448204,7448182,'345',3.333,4),(219,7448205,7448182,'455',3.333,4),(219,7448206,7448182,'556',3.333,4),(219,7448207,7448182,'563',3.333,4),(219,7448208,7448182,'639',3.333,4),(219,7448209,7448182,'393',3.333,4),(219,7448210,7448182,'934',3.333,4),(219,7448211,7448182,'346',3.333,4),(219,7448212,7448182,'461',3.333,4),(219,7448213,7448183,'ser',25,1),(219,7448214,7448183,'eri',25,1),(219,7448215,7448183,'ria',25,1),(219,7448216,7448183,'ial',25,1),(219,7448217,7448213,'siz',50,1),(219,7448218,7448213,'ize',50,1),(219,7448219,7448217,'321',100,1),(219,7448220,7448219,'dev',25,1),(219,7448221,7448219,'evi',25,1),(219,7448222,7448219,'vic',25,1),(219,7448223,7448219,'ice',25,1),(219,7448224,7448220,'typ',50,1),(219,7448225,7448220,'ype',50,1),(219,7448226,7448224,'dir',10,1),(219,7448227,7448224,'ire',10,1),(219,7448228,7448224,'rec',10,1),(219,7448229,7448224,'ect',10,1),(219,7448230,7448224,'cta',10,1),(219,7448231,7448224,'tac',10,1),(219,7448232,7448224,'acc',10,1),(219,7448233,7448224,'cce',10,1),(219,7448234,7448224,'ces',10,1),(219,7448235,7448224,'ess',10,1),(219,7448236,7448226,'mul',14.286,1),(219,7448237,7448226,'ult',14.286,1),(219,7448238,7448226,'lti',14.286,1),(219,7448239,7448226,'tip',14.286,1),(219,7448240,7448226,'ipa',14.286,1),(219,7448241,7448226,'pat',14.286,1),(219,7448242,7448226,'ath',14.286,1),(219,7448243,7448236,'plu',25,1),(219,7448244,7448236,'lug',25,1),(219,7448245,7448236,'ugi',25,1),(219,7448246,7448236,'gin',25,1),(219,7448247,7448243,'nmp',100,1),(219,7448248,7448247,'dev',33.333,1),(219,7448249,7448247,'evf',33.333,1),(219,7448250,7448247,'vfs',33.333,1),(219,7448251,7448248,'pat',50,1),(219,7448252,7448248,'ath',50,1),(219,7448253,7448251,'vmf',50,1),(219,7448254,7448251,'mfs',50,1),(219,7448255,7448253,'dev',20,1),(219,7448256,7448253,'evi',20,1),(219,7448257,7448253,'vic',20,1),(219,7448258,7448253,'ice',20,1),(219,7448259,7448253,'ces',20,1),(219,7448260,7448255,'dis',33.333,1),(219,7448261,7448255,'isk',33.333,1),(219,7448262,7448255,'sks',33.333,1),(219,7448263,7448260,'ven',25,1),(219,7448264,7448260,'end',25,1),(219,7448265,7448260,'ndo',25,1),(219,7448266,7448260,'dor',25,1),(219,7448267,7448263,'mod',33.333,1),(219,7448268,7448263,'ode',33.333,1),(219,7448269,7448263,'del',33.333,1),(219,7448270,7448267,'lun',100,1),(219,7448271,7448270,'cmo',33.333,1),(219,7448272,7448270,'mod',33.333,1),(219,7448273,7448270,'ode',33.333,1),(219,7448274,7448271,'rev',16.667,1),(219,7448275,7448271,'evi',16.667,1),(219,7448276,7448271,'vis',16.667,1),(219,7448277,7448271,'isi',16.667,1),(219,7448278,7448271,'sio',16.667,1),(219,7448279,7448271,'ion',16.667,1),(219,7448280,7448274,'810',50,1),(219,7448281,7448274,'100',50,1),(219,7448282,7448280,'scs',50,1),(219,7448283,7448280,'csi',50,1),(219,7448284,7448282,'lev',33.333,1),(219,7448285,7448282,'eve',33.333,1),(219,7448286,7448282,'vel',33.333,1),(219,7448287,7448284,'pse',25,1),(219,7448288,7448284,'seu',25,1),(219,7448289,7448284,'eud',25,1),(219,7448290,7448284,'udo',25,1),(219,7448291,7448287,'fal',33.333,6),(219,7448292,7448287,'als',33.333,6),(219,7448293,7448287,'lse',33.333,6),(219,7448294,7448291,'sta',25,3),(219,7448295,7448291,'tat',25,3),(219,7448296,7448291,'atu',25,3),(219,7448297,7448291,'tus',25,3),(219,7448298,7448294,'rdm',100,1),(219,7448299,7448298,'cap',20,1),(219,7448300,7448298,'apa',20,1),(219,7448301,7448298,'pab',20,1),(219,7448302,7448298,'abl',20,1),(219,7448303,7448298,'ble',20,1),(219,7448304,7448299,'tru',50,1),(219,7448305,7448299,'rue',50,1),(219,7448306,7448304,'loc',33.333,1),(219,7448307,7448304,'oca',33.333,1),(219,7448308,7448304,'cal',33.333,1),(219,7448309,7448306,'rem',14.286,1),(219,7448310,7448306,'emo',14.286,1),(219,7448311,7448306,'mov',14.286,1),(219,7448312,7448306,'ova',14.286,1),(219,7448313,7448306,'vab',14.286,1),(219,7448314,7448306,'abl',14.286,1),(219,7448315,7448306,'ble',14.286,1),(219,7448316,7448309,'ssd',100,1),(219,7448317,7448316,'off',20,1),(219,7448318,7448316,'ffl',20,1),(219,7448319,7448316,'fli',20,1),(219,7448320,7448316,'lin',20,1),(219,7448321,7448316,'ine',20,1),(219,7448322,7448317,'per',11.111,1),(219,7448323,7448317,'ere',11.111,1),(219,7448324,7448317,'ren',11.111,1),(219,7448325,7448317,'enn',11.111,1),(219,7448326,7448317,'nni',11.111,1),(219,7448327,7448317,'nia',11.111,1),(219,7448328,7448317,'ial',11.111,1),(219,7448329,7448317,'all',11.111,1),(219,7448330,7448317,'lly',11.111,1),(219,7448331,7448322,'res',16.667,1),(219,7448332,7448322,'ese',16.667,1),(219,7448333,7448322,'ser',16.667,1),(219,7448334,7448322,'erv',16.667,1),(219,7448335,7448322,'rve',16.667,1),(219,7448336,7448322,'ved',16.667,1),(219,7448337,7448331,'thi',50,1),(219,7448338,7448331,'hin',50,1),(219,7448339,7448337,'pro',10,1),(219,7448340,7448337,'rov',10,1),(219,7448341,7448337,'ovi',10,1),(219,7448342,7448337,'vis',10,1),(219,7448343,7448337,'isi',10,1),(219,7448344,7448337,'sio',10,1),(219,7448345,7448337,'ion',10,1),(219,7448346,7448337,'oni',10,1),(219,7448347,7448337,'nin',10,1),(219,7448348,7448337,'ing',10,1),(219,7448349,7448339,'yes',100,1),(219,7448350,7448349,'att',16.667,1),(219,7448351,7448349,'tta',16.667,1),(219,7448352,7448349,'tac',16.667,1),(219,7448353,7448349,'ach',16.667,1),(219,7448354,7448349,'che',16.667,1),(219,7448355,7448349,'hed',16.667,1),(219,7448356,7448350,'fil',20,1),(219,7448357,7448350,'ilt',20,1),(219,7448358,7448350,'lte',20,1),(219,7448359,7448350,'ter',20,1),(219,7448360,7448350,'ers',20,1),(219,7448361,7448356,'vaa',50,1),(219,7448362,7448356,'aai',50,1),(219,7448363,7448361,'unk',20,1),(219,7448364,7448361,'nkn',20,1),(219,7448365,7448361,'kno',20,1),(219,7448366,7448361,'now',20,1),(219,7448367,7448361,'own',20,1),(219,7448368,7448363,'oth',33.333,1),(219,7448369,7448363,'the',33.333,1),(219,7448370,7448363,'her',33.333,1),(219,7448371,7448368,'uid',50,1),(219,7448372,7448368,'ids',50,1),(219,7448373,7448371,'vml',100,1),(219,7448374,7448373,'dis',20,1),(219,7448375,7448373,'isp',20,1),(219,7448376,7448373,'spl',20,1),(219,7448377,7448373,'pla',20,1),(219,7448378,7448373,'lay',20,1),(219,7448379,7448374,'nam',50,1),(219,7448380,7448374,'ame',50,1),(220,7448382,7448381,'net',25,3),(220,7448383,7448381,'eta',25,3),(220,7448384,7448381,'tap',25,3),(220,7448385,7448381,'app',25,3),(220,7448386,7448382,'fib',33.333,2),(220,7448387,7448382,'ibr',33.333,2),(220,7448388,7448382,'bre',33.333,2),(220,7448389,7448386,'cha',20,2),(220,7448390,7448386,'han',20,2),(220,7448391,7448386,'ann',20,2),(220,7448392,7448386,'nne',20,2),(220,7448393,7448386,'nel',20,2),(220,7448394,7448389,'dis',50,2),(220,7448395,7448389,'isk',50,2),(220,7448396,7448394,'naa',100,4),(220,7448397,7448396,'600',3.333,4),(220,7448398,7448396,'00a',3.333,4),(220,7448399,7448396,'0a0',3.333,4),(220,7448400,7448396,'a09',3.333,4),(220,7448401,7448396,'098',3.333,4),(220,7448402,7448396,'980',3.333,4),(220,7448403,7448396,'804',3.333,4),(220,7448404,7448396,'044',3.333,4),(220,7448405,7448396,'443',3.333,4),(220,7448406,7448396,'430',3.333,4),(220,7448407,7448396,'307',3.333,4),(220,7448408,7448396,'075',3.333,4),(220,7448409,7448396,'753',3.333,4),(220,7448410,7448396,'535',3.333,4),(220,7448411,7448396,'357',3.333,4),(220,7448412,7448396,'573',3.333,4),(220,7448413,7448396,'732',3.333,4),(220,7448414,7448396,'32b',3.333,4),(220,7448415,7448396,'2b3',3.333,4),(220,7448416,7448396,'b33',3.333,4),(220,7448417,7448396,'334',3.333,4),(220,7448418,7448396,'345',3.333,4),(220,7448419,7448396,'457',3.333,4),(220,7448420,7448396,'571',3.333,4),(220,7448421,7448396,'715',3.333,4),(220,7448422,7448396,'152',3.333,4),(220,7448423,7448396,'527',3.333,4),(220,7448424,7448396,'275',3.333,4),(220,7448425,7448396,'754',3.333,4),(220,7448426,7448396,'54b',3.333,4),(220,7448427,7448397,'ser',25,1),(220,7448428,7448397,'eri',25,1),(220,7448429,7448397,'ria',25,1),(220,7448430,7448397,'ial',25,1),(220,7448431,7448427,'siz',50,1),(220,7448432,7448427,'ize',50,1),(220,7448433,7448431,'174',25,1),(220,7448434,7448431,'740',25,1),(220,7448435,7448431,'409',25,1),(220,7448436,7448431,'096',25,1),(220,7448437,7448433,'dev',25,1),(220,7448438,7448433,'evi',25,1),(220,7448439,7448433,'vic',25,1),(220,7448440,7448433,'ice',25,1),(220,7448441,7448437,'typ',50,1),(220,7448442,7448437,'ype',50,1),(220,7448443,7448441,'dir',10,1),(220,7448444,7448441,'ire',10,1),(220,7448445,7448441,'rec',10,1),(220,7448446,7448441,'ect',10,1),(220,7448447,7448441,'cta',10,1),(220,7448448,7448441,'tac',10,1),(220,7448449,7448441,'acc',10,1),(220,7448450,7448441,'cce',10,1),(220,7448451,7448441,'ces',10,1),(220,7448452,7448441,'ess',10,1),(220,7448453,7448443,'mul',14.286,1),(220,7448454,7448443,'ult',14.286,1),(220,7448455,7448443,'lti',14.286,1),(220,7448456,7448443,'tip',14.286,1),(220,7448457,7448443,'ipa',14.286,1),(220,7448458,7448443,'pat',14.286,1),(220,7448459,7448443,'ath',14.286,1),(220,7448460,7448453,'plu',25,1),(220,7448461,7448453,'lug',25,1),(220,7448462,7448453,'ugi',25,1),(220,7448463,7448453,'gin',25,1),(220,7448464,7448460,'nmp',100,1),(220,7448465,7448464,'dev',33.333,1),(220,7448466,7448464,'evf',33.333,1),(220,7448467,7448464,'vfs',33.333,1),(220,7448468,7448465,'pat',50,1),(220,7448469,7448465,'ath',50,1),(220,7448470,7448468,'vmf',50,1),(220,7448471,7448468,'mfs',50,1),(220,7448472,7448470,'dev',20,1),(220,7448473,7448470,'evi',20,1),(220,7448474,7448470,'vic',20,1),(220,7448475,7448470,'ice',20,1),(220,7448476,7448470,'ces',20,1),(220,7448477,7448472,'dis',33.333,1),(220,7448478,7448472,'isk',33.333,1),(220,7448479,7448472,'sks',33.333,1),(220,7448480,7448477,'ven',25,1),(220,7448481,7448477,'end',25,1),(220,7448482,7448477,'ndo',25,1),(220,7448483,7448477,'dor',25,1),(220,7448484,7448480,'mod',33.333,1),(220,7448485,7448480,'ode',33.333,1),(220,7448486,7448480,'del',33.333,1),(220,7448487,7448484,'lun',100,1),(220,7448488,7448487,'cmo',33.333,1),(220,7448489,7448487,'mod',33.333,1),(220,7448490,7448487,'ode',33.333,1),(220,7448491,7448488,'rev',16.667,1),(220,7448492,7448488,'evi',16.667,1),(220,7448493,7448488,'vis',16.667,1),(220,7448494,7448488,'isi',16.667,1),(220,7448495,7448488,'sio',16.667,1),(220,7448496,7448488,'ion',16.667,1),(220,7448497,7448491,'810',50,1),(220,7448498,7448491,'100',50,1),(220,7448499,7448497,'scs',50,1),(220,7448500,7448497,'csi',50,1),(220,7448501,7448499,'lev',33.333,1),(220,7448502,7448499,'eve',33.333,1),(220,7448503,7448499,'vel',33.333,1),(220,7448504,7448501,'pse',25,1),(220,7448505,7448501,'seu',25,1),(220,7448506,7448501,'eud',25,1),(220,7448507,7448501,'udo',25,1),(220,7448508,7448504,'fal',33.333,6),(220,7448509,7448504,'als',33.333,6),(220,7448510,7448504,'lse',33.333,6),(220,7448511,7448508,'sta',25,3),(220,7448512,7448508,'tat',25,3),(220,7448513,7448508,'atu',25,3),(220,7448514,7448508,'tus',25,3),(220,7448515,7448511,'rdm',100,1),(220,7448516,7448515,'cap',20,1),(220,7448517,7448515,'apa',20,1),(220,7448518,7448515,'pab',20,1),(220,7448519,7448515,'abl',20,1),(220,7448520,7448515,'ble',20,1),(220,7448521,7448516,'tru',50,1),(220,7448522,7448516,'rue',50,1),(220,7448523,7448521,'loc',33.333,1),(220,7448524,7448521,'oca',33.333,1),(220,7448525,7448521,'cal',33.333,1),(220,7448526,7448523,'rem',14.286,1),(220,7448527,7448523,'emo',14.286,1),(220,7448528,7448523,'mov',14.286,1),(220,7448529,7448523,'ova',14.286,1),(220,7448530,7448523,'vab',14.286,1),(220,7448531,7448523,'abl',14.286,1),(220,7448532,7448523,'ble',14.286,1),(220,7448533,7448526,'ssd',100,1),(220,7448534,7448533,'off',20,1),(220,7448535,7448533,'ffl',20,1),(220,7448536,7448533,'fli',20,1),(220,7448537,7448533,'lin',20,1),(220,7448538,7448533,'ine',20,1),(220,7448539,7448534,'per',11.111,1),(220,7448540,7448534,'ere',11.111,1),(220,7448541,7448534,'ren',11.111,1),(220,7448542,7448534,'enn',11.111,1),(220,7448543,7448534,'nni',11.111,1),(220,7448544,7448534,'nia',11.111,1),(220,7448545,7448534,'ial',11.111,1),(220,7448546,7448534,'all',11.111,1),(220,7448547,7448534,'lly',11.111,1),(220,7448548,7448539,'res',16.667,1),(220,7448549,7448539,'ese',16.667,1),(220,7448550,7448539,'ser',16.667,1),(220,7448551,7448539,'erv',16.667,1),(220,7448552,7448539,'rve',16.667,1),(220,7448553,7448539,'ved',16.667,1),(220,7448554,7448548,'thi',50,1),(220,7448555,7448548,'hin',50,1),(220,7448556,7448554,'pro',10,1),(220,7448557,7448554,'rov',10,1),(220,7448558,7448554,'ovi',10,1),(220,7448559,7448554,'vis',10,1),(220,7448560,7448554,'isi',10,1),(220,7448561,7448554,'sio',10,1),(220,7448562,7448554,'ion',10,1),(220,7448563,7448554,'oni',10,1),(220,7448564,7448554,'nin',10,1),(220,7448565,7448554,'ing',10,1),(220,7448566,7448556,'yes',100,1),(220,7448567,7448566,'att',16.667,1),(220,7448568,7448566,'tta',16.667,1),(220,7448569,7448566,'tac',16.667,1),(220,7448570,7448566,'ach',16.667,1),(220,7448571,7448566,'che',16.667,1),(220,7448572,7448566,'hed',16.667,1),(220,7448573,7448567,'fil',20,1),(220,7448574,7448567,'ilt',20,1),(220,7448575,7448567,'lte',20,1),(220,7448576,7448567,'ter',20,1),(220,7448577,7448567,'ers',20,1),(220,7448578,7448573,'vaa',50,1),(220,7448579,7448573,'aai',50,1),(220,7448580,7448578,'unk',20,1),(220,7448581,7448578,'nkn',20,1),(220,7448582,7448578,'kno',20,1),(220,7448583,7448578,'now',20,1),(220,7448584,7448578,'own',20,1),(220,7448585,7448580,'oth',33.333,1),(220,7448586,7448580,'the',33.333,1),(220,7448587,7448580,'her',33.333,1),(220,7448588,7448585,'uid',50,1),(220,7448589,7448585,'ids',50,1),(220,7448590,7448588,'vml',100,1),(220,7448591,7448590,'dis',20,1),(220,7448592,7448590,'isp',20,1),(220,7448593,7448590,'spl',20,1),(220,7448594,7448590,'pla',20,1),(220,7448595,7448590,'lay',20,1),(220,7448596,7448591,'nam',50,1),(220,7448597,7448591,'ame',50,1),(221,7448599,7448598,'net',25,3),(221,7448600,7448598,'eta',25,3),(221,7448601,7448598,'tap',25,3),(221,7448602,7448598,'app',25,3),(221,7448603,7448599,'fib',33.333,2),(221,7448604,7448599,'ibr',33.333,2),(221,7448605,7448599,'bre',33.333,2),(221,7448606,7448603,'cha',20,2),(221,7448607,7448603,'han',20,2),(221,7448608,7448603,'ann',20,2),(221,7448609,7448603,'nne',20,2),(221,7448610,7448603,'nel',20,2),(221,7448611,7448606,'dis',50,2),(221,7448612,7448606,'isk',50,2),(221,7448613,7448611,'naa',100,4),(221,7448614,7448613,'600',3.333,4),(221,7448615,7448613,'00a',3.333,4),(221,7448616,7448613,'0a0',3.333,4),(221,7448617,7448613,'a09',3.333,4),(221,7448618,7448613,'098',3.333,4),(221,7448619,7448613,'980',3.333,4),(221,7448620,7448613,'804',3.333,4),(221,7448621,7448613,'044',3.333,4),(221,7448622,7448613,'443',3.333,4),(221,7448623,7448613,'430',3.333,4),(221,7448624,7448613,'307',3.333,4),(221,7448625,7448613,'072',3.333,4),(221,7448626,7448613,'725',3.333,4),(221,7448627,7448613,'259',3.333,4),(221,7448628,7448613,'593',3.333,4),(221,7448629,7448613,'931',3.333,4),(221,7448630,7448613,'313',3.333,4),(221,7448631,7448613,'13f',3.333,4),(221,7448632,7448613,'3f3',3.333,4),(221,7448633,7448613,'f33',3.333,4),(221,7448634,7448613,'334',3.333,4),(221,7448635,7448613,'345',3.333,4),(221,7448636,7448613,'455',3.333,4),(221,7448637,7448613,'556',3.333,4),(221,7448638,7448613,'563',3.333,4),(221,7448639,7448613,'639',3.333,4),(221,7448640,7448613,'393',3.333,4),(221,7448641,7448613,'934',3.333,4),(221,7448642,7448613,'346',3.333,4),(221,7448643,7448613,'462',3.333,4),(221,7448644,7448614,'ser',25,1),(221,7448645,7448614,'eri',25,1),(221,7448646,7448614,'ria',25,1),(221,7448647,7448614,'ial',25,1),(221,7448648,7448644,'siz',50,1),(221,7448649,7448644,'ize',50,1),(221,7448650,7448648,'321',100,1),(221,7448651,7448650,'dev',25,1),(221,7448652,7448650,'evi',25,1),(221,7448653,7448650,'vic',25,1),(221,7448654,7448650,'ice',25,1),(221,7448655,7448651,'typ',50,1),(221,7448656,7448651,'ype',50,1),(221,7448657,7448655,'dir',10,1),(221,7448658,7448655,'ire',10,1),(221,7448659,7448655,'rec',10,1),(221,7448660,7448655,'ect',10,1),(221,7448661,7448655,'cta',10,1),(221,7448662,7448655,'tac',10,1),(221,7448663,7448655,'acc',10,1),(221,7448664,7448655,'cce',10,1),(221,7448665,7448655,'ces',10,1),(221,7448666,7448655,'ess',10,1),(221,7448667,7448657,'mul',14.286,1),(221,7448668,7448657,'ult',14.286,1),(221,7448669,7448657,'lti',14.286,1),(221,7448670,7448657,'tip',14.286,1),(221,7448671,7448657,'ipa',14.286,1),(221,7448672,7448657,'pat',14.286,1),(221,7448673,7448657,'ath',14.286,1),(221,7448674,7448667,'plu',25,1),(221,7448675,7448667,'lug',25,1),(221,7448676,7448667,'ugi',25,1),(221,7448677,7448667,'gin',25,1),(221,7448678,7448674,'nmp',100,1),(221,7448679,7448678,'dev',33.333,1),(221,7448680,7448678,'evf',33.333,1),(221,7448681,7448678,'vfs',33.333,1),(221,7448682,7448679,'pat',50,1),(221,7448683,7448679,'ath',50,1),(221,7448684,7448682,'vmf',50,1),(221,7448685,7448682,'mfs',50,1),(221,7448686,7448684,'dev',20,1),(221,7448687,7448684,'evi',20,1),(221,7448688,7448684,'vic',20,1),(221,7448689,7448684,'ice',20,1),(221,7448690,7448684,'ces',20,1),(221,7448691,7448686,'dis',33.333,1),(221,7448692,7448686,'isk',33.333,1),(221,7448693,7448686,'sks',33.333,1),(221,7448694,7448691,'ven',25,1),(221,7448695,7448691,'end',25,1),(221,7448696,7448691,'ndo',25,1),(221,7448697,7448691,'dor',25,1),(221,7448698,7448694,'mod',33.333,1),(221,7448699,7448694,'ode',33.333,1),(221,7448700,7448694,'del',33.333,1),(221,7448701,7448698,'lun',100,1),(221,7448702,7448701,'cmo',33.333,1),(221,7448703,7448701,'mod',33.333,1),(221,7448704,7448701,'ode',33.333,1),(221,7448705,7448702,'rev',16.667,1),(221,7448706,7448702,'evi',16.667,1),(221,7448707,7448702,'vis',16.667,1),(221,7448708,7448702,'isi',16.667,1),(221,7448709,7448702,'sio',16.667,1),(221,7448710,7448702,'ion',16.667,1),(221,7448711,7448705,'810',50,1),(221,7448712,7448705,'100',50,1),(221,7448713,7448711,'scs',50,1),(221,7448714,7448711,'csi',50,1),(221,7448715,7448713,'lev',33.333,1),(221,7448716,7448713,'eve',33.333,1),(221,7448717,7448713,'vel',33.333,1),(221,7448718,7448715,'pse',25,1),(221,7448719,7448715,'seu',25,1),(221,7448720,7448715,'eud',25,1),(221,7448721,7448715,'udo',25,1),(221,7448722,7448718,'fal',33.333,6),(221,7448723,7448718,'als',33.333,6),(221,7448724,7448718,'lse',33.333,6),(221,7448725,7448722,'sta',25,3),(221,7448726,7448722,'tat',25,3),(221,7448727,7448722,'atu',25,3),(221,7448728,7448722,'tus',25,3),(221,7448729,7448725,'rdm',100,1),(221,7448730,7448729,'cap',20,1),(221,7448731,7448729,'apa',20,1),(221,7448732,7448729,'pab',20,1),(221,7448733,7448729,'abl',20,1),(221,7448734,7448729,'ble',20,1),(221,7448735,7448730,'tru',50,1),(221,7448736,7448730,'rue',50,1),(221,7448737,7448735,'loc',33.333,1),(221,7448738,7448735,'oca',33.333,1),(221,7448739,7448735,'cal',33.333,1),(221,7448740,7448737,'rem',14.286,1),(221,7448741,7448737,'emo',14.286,1),(221,7448742,7448737,'mov',14.286,1),(221,7448743,7448737,'ova',14.286,1),(221,7448744,7448737,'vab',14.286,1),(221,7448745,7448737,'abl',14.286,1),(221,7448746,7448737,'ble',14.286,1),(221,7448747,7448740,'ssd',100,1),(221,7448748,7448747,'off',20,1),(221,7448749,7448747,'ffl',20,1),(221,7448750,7448747,'fli',20,1),(221,7448751,7448747,'lin',20,1),(221,7448752,7448747,'ine',20,1),(221,7448753,7448748,'per',11.111,1),(221,7448754,7448748,'ere',11.111,1),(221,7448755,7448748,'ren',11.111,1),(221,7448756,7448748,'enn',11.111,1),(221,7448757,7448748,'nni',11.111,1),(221,7448758,7448748,'nia',11.111,1),(221,7448759,7448748,'ial',11.111,1),(221,7448760,7448748,'all',11.111,1),(221,7448761,7448748,'lly',11.111,1),(221,7448762,7448753,'res',16.667,1),(221,7448763,7448753,'ese',16.667,1),(221,7448764,7448753,'ser',16.667,1),(221,7448765,7448753,'erv',16.667,1),(221,7448766,7448753,'rve',16.667,1),(221,7448767,7448753,'ved',16.667,1),(221,7448768,7448762,'thi',50,1),(221,7448769,7448762,'hin',50,1),(221,7448770,7448768,'pro',10,1),(221,7448771,7448768,'rov',10,1),(221,7448772,7448768,'ovi',10,1),(221,7448773,7448768,'vis',10,1),(221,7448774,7448768,'isi',10,1),(221,7448775,7448768,'sio',10,1),(221,7448776,7448768,'ion',10,1),(221,7448777,7448768,'oni',10,1),(221,7448778,7448768,'nin',10,1),(221,7448779,7448768,'ing',10,1),(221,7448780,7448770,'yes',100,1),(221,7448781,7448780,'att',16.667,1),(221,7448782,7448780,'tta',16.667,1),(221,7448783,7448780,'tac',16.667,1),(221,7448784,7448780,'ach',16.667,1),(221,7448785,7448780,'che',16.667,1),(221,7448786,7448780,'hed',16.667,1),(221,7448787,7448781,'fil',20,1),(221,7448788,7448781,'ilt',20,1),(221,7448789,7448781,'lte',20,1),(221,7448790,7448781,'ter',20,1),(221,7448791,7448781,'ers',20,1),(221,7448792,7448787,'vaa',50,1),(221,7448793,7448787,'aai',50,1),(221,7448794,7448792,'unk',20,1),(221,7448795,7448792,'nkn',20,1),(221,7448796,7448792,'kno',20,1),(221,7448797,7448792,'now',20,1),(221,7448798,7448792,'own',20,1),(221,7448799,7448794,'oth',33.333,1),(221,7448800,7448794,'the',33.333,1),(221,7448801,7448794,'her',33.333,1),(221,7448802,7448799,'uid',50,1),(221,7448803,7448799,'ids',50,1),(221,7448804,7448802,'vml',100,1),(221,7448805,7448804,'dis',20,1),(221,7448806,7448804,'isp',20,1),(221,7448807,7448804,'spl',20,1),(221,7448808,7448804,'pla',20,1),(221,7448809,7448804,'lay',20,1),(221,7448810,7448805,'nam',50,1),(221,7448811,7448805,'ame',50,1),(222,7448813,7448812,'net',25,3),(222,7448814,7448812,'eta',25,3),(222,7448815,7448812,'tap',25,3),(222,7448816,7448812,'app',25,3),(222,7448817,7448813,'fib',33.333,2),(222,7448818,7448813,'ibr',33.333,2),(222,7448819,7448813,'bre',33.333,2),(222,7448820,7448817,'cha',20,2),(222,7448821,7448817,'han',20,2),(222,7448822,7448817,'ann',20,2),(222,7448823,7448817,'nne',20,2),(222,7448824,7448817,'nel',20,2),(222,7448825,7448820,'dis',50,2),(222,7448826,7448820,'isk',50,2),(222,7448827,7448825,'naa',100,4),(222,7448828,7448827,'600',3.333,4),(222,7448829,7448827,'00a',3.333,4),(222,7448830,7448827,'0a0',3.333,4),(222,7448831,7448827,'a09',3.333,4),(222,7448832,7448827,'098',3.333,4),(222,7448833,7448827,'980',3.333,4),(222,7448834,7448827,'804',3.333,4),(222,7448835,7448827,'044',3.333,4),(222,7448836,7448827,'443',3.333,4),(222,7448837,7448827,'430',3.333,4),(222,7448838,7448827,'307',3.333,4),(222,7448839,7448827,'072',3.333,4),(222,7448840,7448827,'725',3.333,4),(222,7448841,7448827,'259',3.333,4),(222,7448842,7448827,'593',3.333,4),(222,7448843,7448827,'931',3.333,4),(222,7448844,7448827,'313',3.333,4),(222,7448845,7448827,'13f',3.333,4),(222,7448846,7448827,'3f3',3.333,4),(222,7448847,7448827,'f33',3.333,4),(222,7448848,7448827,'334',3.333,4),(222,7448849,7448827,'345',3.333,4),(222,7448850,7448827,'455',3.333,4),(222,7448851,7448827,'556',3.333,4),(222,7448852,7448827,'563',3.333,4),(222,7448853,7448827,'639',3.333,4),(222,7448854,7448827,'393',3.333,4),(222,7448855,7448827,'934',3.333,4),(222,7448856,7448827,'346',3.333,4),(222,7448857,7448827,'463',3.333,4),(222,7448858,7448828,'ser',25,1),(222,7448859,7448828,'eri',25,1),(222,7448860,7448828,'ria',25,1),(222,7448861,7448828,'ial',25,1),(222,7448862,7448858,'siz',50,1),(222,7448863,7448858,'ize',50,1),(222,7448864,7448862,'321',100,1),(222,7448865,7448864,'dev',25,1),(222,7448866,7448864,'evi',25,1),(222,7448867,7448864,'vic',25,1),(222,7448868,7448864,'ice',25,1),(222,7448869,7448865,'typ',50,1),(222,7448870,7448865,'ype',50,1),(222,7448871,7448869,'dir',10,1),(222,7448872,7448869,'ire',10,1),(222,7448873,7448869,'rec',10,1),(222,7448874,7448869,'ect',10,1),(222,7448875,7448869,'cta',10,1),(222,7448876,7448869,'tac',10,1),(222,7448877,7448869,'acc',10,1),(222,7448878,7448869,'cce',10,1),(222,7448879,7448869,'ces',10,1),(222,7448880,7448869,'ess',10,1),(222,7448881,7448871,'mul',14.286,1),(222,7448882,7448871,'ult',14.286,1),(222,7448883,7448871,'lti',14.286,1),(222,7448884,7448871,'tip',14.286,1),(222,7448885,7448871,'ipa',14.286,1),(222,7448886,7448871,'pat',14.286,1),(222,7448887,7448871,'ath',14.286,1),(222,7448888,7448881,'plu',25,1),(222,7448889,7448881,'lug',25,1),(222,7448890,7448881,'ugi',25,1),(222,7448891,7448881,'gin',25,1),(222,7448892,7448888,'nmp',100,1),(222,7448893,7448892,'dev',33.333,1),(222,7448894,7448892,'evf',33.333,1),(222,7448895,7448892,'vfs',33.333,1),(222,7448896,7448893,'pat',50,1),(222,7448897,7448893,'ath',50,1),(222,7448898,7448896,'vmf',50,1),(222,7448899,7448896,'mfs',50,1),(222,7448900,7448898,'dev',20,1),(222,7448901,7448898,'evi',20,1),(222,7448902,7448898,'vic',20,1),(222,7448903,7448898,'ice',20,1),(222,7448904,7448898,'ces',20,1),(222,7448905,7448900,'dis',33.333,1),(222,7448906,7448900,'isk',33.333,1),(222,7448907,7448900,'sks',33.333,1),(222,7448908,7448905,'ven',25,1),(222,7448909,7448905,'end',25,1),(222,7448910,7448905,'ndo',25,1),(222,7448911,7448905,'dor',25,1),(222,7448912,7448908,'mod',33.333,1),(222,7448913,7448908,'ode',33.333,1),(222,7448914,7448908,'del',33.333,1),(222,7448915,7448912,'lun',100,1),(222,7448916,7448915,'cmo',33.333,1),(222,7448917,7448915,'mod',33.333,1),(222,7448918,7448915,'ode',33.333,1),(222,7448919,7448916,'rev',16.667,1),(222,7448920,7448916,'evi',16.667,1),(222,7448921,7448916,'vis',16.667,1),(222,7448922,7448916,'isi',16.667,1),(222,7448923,7448916,'sio',16.667,1),(222,7448924,7448916,'ion',16.667,1),(222,7448925,7448919,'810',50,1),(222,7448926,7448919,'100',50,1),(222,7448927,7448925,'scs',50,1),(222,7448928,7448925,'csi',50,1),(222,7448929,7448927,'lev',33.333,1),(222,7448930,7448927,'eve',33.333,1),(222,7448931,7448927,'vel',33.333,1),(222,7448932,7448929,'pse',25,1),(222,7448933,7448929,'seu',25,1),(222,7448934,7448929,'eud',25,1),(222,7448935,7448929,'udo',25,1),(222,7448936,7448932,'fal',33.333,6),(222,7448937,7448932,'als',33.333,6),(222,7448938,7448932,'lse',33.333,6),(222,7448939,7448936,'sta',25,3),(222,7448940,7448936,'tat',25,3),(222,7448941,7448936,'atu',25,3),(222,7448942,7448936,'tus',25,3),(222,7448943,7448939,'rdm',100,1),(222,7448944,7448943,'cap',20,1),(222,7448945,7448943,'apa',20,1),(222,7448946,7448943,'pab',20,1),(222,7448947,7448943,'abl',20,1),(222,7448948,7448943,'ble',20,1),(222,7448949,7448944,'tru',50,1),(222,7448950,7448944,'rue',50,1),(222,7448951,7448949,'loc',33.333,1),(222,7448952,7448949,'oca',33.333,1),(222,7448953,7448949,'cal',33.333,1),(222,7448954,7448951,'rem',14.286,1),(222,7448955,7448951,'emo',14.286,1),(222,7448956,7448951,'mov',14.286,1),(222,7448957,7448951,'ova',14.286,1),(222,7448958,7448951,'vab',14.286,1),(222,7448959,7448951,'abl',14.286,1),(222,7448960,7448951,'ble',14.286,1),(222,7448961,7448954,'ssd',100,1),(222,7448962,7448961,'off',20,1),(222,7448963,7448961,'ffl',20,1),(222,7448964,7448961,'fli',20,1),(222,7448965,7448961,'lin',20,1),(222,7448966,7448961,'ine',20,1),(222,7448967,7448962,'per',11.111,1),(222,7448968,7448962,'ere',11.111,1),(222,7448969,7448962,'ren',11.111,1),(222,7448970,7448962,'enn',11.111,1),(222,7448971,7448962,'nni',11.111,1),(222,7448972,7448962,'nia',11.111,1),(222,7448973,7448962,'ial',11.111,1),(222,7448974,7448962,'all',11.111,1),(222,7448975,7448962,'lly',11.111,1),(222,7448976,7448967,'res',16.667,1),(222,7448977,7448967,'ese',16.667,1),(222,7448978,7448967,'ser',16.667,1),(222,7448979,7448967,'erv',16.667,1),(222,7448980,7448967,'rve',16.667,1),(222,7448981,7448967,'ved',16.667,1),(222,7448982,7448976,'thi',50,1),(222,7448983,7448976,'hin',50,1),(222,7448984,7448982,'pro',10,1),(222,7448985,7448982,'rov',10,1),(222,7448986,7448982,'ovi',10,1),(222,7448987,7448982,'vis',10,1),(222,7448988,7448982,'isi',10,1),(222,7448989,7448982,'sio',10,1),(222,7448990,7448982,'ion',10,1),(222,7448991,7448982,'oni',10,1),(222,7448992,7448982,'nin',10,1),(222,7448993,7448982,'ing',10,1),(222,7448994,7448984,'yes',100,1),(222,7448995,7448994,'att',16.667,1),(222,7448996,7448994,'tta',16.667,1),(222,7448997,7448994,'tac',16.667,1),(222,7448998,7448994,'ach',16.667,1),(222,7448999,7448994,'che',16.667,1),(222,7449000,7448994,'hed',16.667,1),(222,7449001,7448995,'fil',20,1),(222,7449002,7448995,'ilt',20,1),(222,7449003,7448995,'lte',20,1),(222,7449004,7448995,'ter',20,1),(222,7449005,7448995,'ers',20,1),(222,7449006,7449001,'vaa',50,1),(222,7449007,7449001,'aai',50,1),(222,7449008,7449006,'unk',20,1),(222,7449009,7449006,'nkn',20,1),(222,7449010,7449006,'kno',20,1),(222,7449011,7449006,'now',20,1),(222,7449012,7449006,'own',20,1),(222,7449013,7449008,'oth',33.333,1),(222,7449014,7449008,'the',33.333,1),(222,7449015,7449008,'her',33.333,1),(222,7449016,7449013,'uid',50,1),(222,7449017,7449013,'ids',50,1),(222,7449018,7449016,'vml',100,1),(222,7449019,7449018,'dis',20,1),(222,7449020,7449018,'isp',20,1),(222,7449021,7449018,'spl',20,1),(222,7449022,7449018,'pla',20,1),(222,7449023,7449018,'lay',20,1),(222,7449024,7449019,'nam',50,1),(222,7449025,7449019,'ame',50,1),(223,7449027,7449026,'att',12.5,1),(223,7449028,7449026,'ttr',12.5,1),(223,7449029,7449026,'tri',12.5,1),(223,7449030,7449026,'rib',12.5,1),(223,7449031,7449026,'ibu',12.5,1),(223,7449032,7449026,'but',12.5,1),(223,7449033,7449026,'ute',12.5,1),(223,7449034,7449026,'tes',12.5,1),(223,7449035,7449027,'ref',20,3),(223,7449036,7449027,'efr',20,3),(223,7449037,7449027,'fre',20,3),(223,7449038,7449027,'res',20,3),(223,7449039,7449027,'esh',20,3),(223,7449040,7449035,'hos',50,2),(223,7449041,7449035,'ost',50,2),(223,7449042,7449040,'nam',50,2),(223,7449043,7449040,'ame',50,2),(223,7449044,7449042,'hg3',9.091,1),(223,7449045,7449042,'g32',9.091,1),(223,7449046,7449042,'32v',9.091,1),(223,7449047,7449042,'2vm',9.091,1),(223,7449048,7449042,'vm2',9.091,1),(223,7449049,7449042,'m2w',9.091,1),(223,7449050,7449042,'2w2',9.091,1),(223,7449051,7449042,'w2k',9.091,1),(223,7449052,7449042,'2k8',9.091,1),(223,7449053,7449042,'k8r',9.091,1),(223,7449054,7449042,'8r2',9.091,1),(223,7449055,7449044,'gdl',100,1),(223,7449056,7449055,'eng',25,1),(223,7449057,7449055,'ngl',25,1),(223,7449058,7449055,'gla',25,1),(223,7449059,7449055,'lab',25,1),(223,7449060,7449056,'net',25,1),(223,7449061,7449056,'eta',25,1),(223,7449062,7449056,'tap',25,1),(223,7449063,7449056,'app',25,1),(223,7449064,7449060,'com',100,1),(223,7449065,7449064,'mem',25,3),(223,7449066,7449064,'emo',25,3),(223,7449067,7449064,'mor',25,3),(223,7449068,7449064,'ory',25,3),(223,7449069,7449065,'siz',50,2),(223,7449070,7449065,'ize',50,2),(223,7449071,7449069,'614',50,1),(223,7449072,7449069,'144',50,1),(223,7449073,7449071,'cpu',100,1),(223,7449074,7449073,'usa',33.333,3),(223,7449075,7449073,'sag',33.333,3),(223,7449076,7449073,'age',33.333,3),(223,7449077,7449074,'mhz',100,1),(223,7449078,7449077,'add',20,1),(223,7449079,7449077,'ddr',20,1),(223,7449080,7449077,'dre',20,1),(223,7449081,7449077,'res',20,1),(223,7449082,7449077,'ess',20,1),(223,7449083,7449078,'226',100,1),(223,7449084,7449083,'147',100,1),(223,7449085,7449084,'204',100,1),(223,7449086,7449085,'620',50,1),(223,7449087,7449085,'206',50,1),(223,7449088,7449086,'gue',33.333,2),(223,7449089,7449086,'ues',33.333,2),(223,7449090,7449086,'est',33.333,2),(223,7449091,7449088,'vmw',25,2),(223,7449092,7449088,'mwa',25,2),(223,7449093,7449088,'war',25,2),(223,7449094,7449088,'are',25,2),(223,7449095,7449091,'too',33.333,2),(223,7449096,7449091,'ool',33.333,2),(223,7449097,7449091,'ols',33.333,2),(223,7449098,7449095,'run',20,1),(223,7449099,7449095,'unn',20,1),(223,7449100,7449095,'nni',20,1),(223,7449101,7449095,'nin',20,1),(223,7449102,7449095,'ing',20,1),(223,7449103,7449098,'and',100,1),(223,7449104,7449103,'the',100,1),(223,7449105,7449104,'ver',20,2),(223,7449106,7449104,'ers',20,2),(223,7449107,7449104,'rsi',20,2),(223,7449108,7449104,'sio',20,2),(223,7449109,7449104,'ion',20,2),(223,7449110,7449105,'cur',20,1),(223,7449111,7449105,'urr',20,1),(223,7449112,7449105,'rre',20,1),(223,7449113,7449105,'ren',20,1),(223,7449114,7449105,'ent',20,1),(223,7449115,7449110,'mic',14.286,1),(223,7449116,7449110,'icr',14.286,1),(223,7449117,7449110,'cro',14.286,1),(223,7449118,7449110,'ros',14.286,1),(223,7449119,7449110,'oso',14.286,1),(223,7449120,7449110,'sof',14.286,1),(223,7449121,7449110,'oft',14.286,1),(223,7449122,7449115,'win',20,1),(223,7449123,7449115,'ind',20,1),(223,7449124,7449115,'ndo',20,1),(223,7449125,7449115,'dow',20,1),(223,7449126,7449115,'ows',20,1),(223,7449127,7449122,'ser',25,1),(223,7449128,7449122,'erv',25,1),(223,7449129,7449122,'rve',25,1),(223,7449130,7449122,'ver',25,1),(223,7449131,7449127,'200',50,1),(223,7449132,7449127,'008',50,1),(223,7449133,7449131,'64b',33.333,1),(223,7449134,7449131,'4bi',33.333,1),(223,7449135,7449131,'bit',33.333,1),(223,7449136,7449133,'pat',50,1),(223,7449137,7449133,'ath',50,1),(223,7449138,7449136,'rx6',33.333,1),(223,7449139,7449136,'x60',33.333,1),(223,7449140,7449136,'600',33.333,1),(223,7449141,7449138,'vmf',20,1),(223,7449142,7449138,'mfi',20,1),(223,7449143,7449138,'fil',20,1),(223,7449144,7449138,'ile',20,1),(223,7449145,7449138,'les',20,1),(223,7449146,7449141,'hgw',9.091,2),(223,7449147,7449141,'gw2',9.091,2),(223,7449148,7449141,'w2k',9.091,2),(223,7449149,7449141,'2k8',9.091,2),(223,7449150,7449141,'k8r',9.091,2),(223,7449151,7449141,'8r2',9.091,2),(223,7449152,7449141,'r23',9.091,2),(223,7449153,7449141,'232',9.091,2),(223,7449154,7449141,'32v',9.091,2),(223,7449155,7449141,'2vm',9.091,2),(223,7449156,7449141,'vm2',9.091,2),(223,7449157,7449146,'vmx',100,1),(223,7449158,7449157,'fla',33.333,1),(223,7449159,7449157,'las',33.333,1),(223,7449160,7449157,'ash',33.333,1),(223,7449161,7449158,'acc',33.333,1),(223,7449162,7449158,'cce',33.333,1),(223,7449163,7449158,'cel',33.333,1),(223,7449164,7449161,'con',9.091,1),(223,7449165,7449161,'onf',9.091,1),(223,7449166,7449161,'nfi',9.091,1),(223,7449167,7449161,'fig',9.091,1),(223,7449168,7449161,'igu',9.091,1),(223,7449169,7449161,'gur',9.091,1),(223,7449170,7449161,'ura',9.091,1),(223,7449171,7449161,'rat',9.091,1),(223,7449172,7449161,'ati',9.091,1),(223,7449173,7449161,'tio',9.091,1),(223,7449174,7449161,'ion',9.091,1),(223,7449175,7449164,'age',33.333,1),(223,7449176,7449164,'gen',33.333,1),(223,7449177,7449164,'ent',33.333,1),(223,7449178,7449175,'193',16.667,1),(223,7449179,7449175,'938',16.667,1),(223,7449180,7449175,'380',16.667,1),(223,7449181,7449175,'809',16.667,1),(223,7449182,7449175,'097',16.667,1),(223,7449183,7449175,'979',16.667,1),(223,7449184,7449178,'cac',33.333,3),(223,7449185,7449178,'ach',33.333,3),(223,7449186,7449178,'che',33.333,3),(223,7449187,7449184,'sta',33.333,2),(223,7449188,7449184,'tat',33.333,2),(223,7449189,7449184,'ate',33.333,2),(223,7449190,7449187,'ena',20,2),(223,7449191,7449187,'nab',20,2),(223,7449192,7449187,'abl',20,2),(223,7449193,7449187,'ble',20,2),(223,7449194,7449187,'led',20,2),(223,7449195,7449190,'ope',11.111,2),(223,7449196,7449190,'per',11.111,2),(223,7449197,7449190,'era',11.111,2),(223,7449198,7449190,'rat',11.111,2),(223,7449199,7449190,'ati',11.111,2),(223,7449200,7449190,'tio',11.111,2),(223,7449201,7449190,'ion',11.111,2),(223,7449202,7449190,'ona',11.111,2),(223,7449203,7449190,'nal',11.111,2),(223,7449204,7449195,'nor',25,1),(223,7449205,7449195,'orm',25,1),(223,7449206,7449195,'rma',25,1),(223,7449207,7449195,'mal',25,1),(223,7449208,7449204,'mod',50,2),(223,7449209,7449204,'ode',50,2),(223,7449210,7449208,'wri',14.286,2),(223,7449211,7449208,'rit',14.286,2),(223,7449212,7449208,'ite',14.286,2),(223,7449213,7449208,'tet',14.286,2),(223,7449214,7449208,'eth',14.286,2),(223,7449215,7449208,'thr',14.286,2),(223,7449216,7449208,'hru',14.286,2),(223,7449217,7449210,'mes',20,1),(223,7449218,7449210,'ess',20,1),(223,7449219,7449210,'ssa',20,1),(223,7449220,7449210,'sag',20,1),(223,7449221,7449210,'age',20,1),(223,7449222,7449217,'met',20,3),(223,7449223,7449217,'etr',20,3),(223,7449224,7449217,'tri',20,3),(223,7449225,7449217,'ric',20,3),(223,7449226,7449217,'ics',20,3),(223,7449227,7449222,'vir',20,1),(223,7449228,7449222,'irt',20,1),(223,7449229,7449222,'rtu',20,1),(223,7449230,7449222,'tua',20,1),(223,7449231,7449222,'ual',20,1),(223,7449232,7449227,'dis',50,1),(223,7449233,7449227,'isk',50,1),(224,7449235,7449234,'naa',100,2),(224,7449236,7449235,'600',3.333,3),(224,7449237,7449235,'000',3.333,3),(224,7449238,7449235,'00c',3.333,3),(224,7449239,7449235,'0c2',3.333,3),(224,7449240,7449235,'c29',3.333,3),(224,7449241,7449235,'299',3.333,3),(224,7449242,7449235,'992',3.333,3),(224,7449243,7449235,'924',3.333,3),(224,7449244,7449235,'242',3.333,3),(224,7449245,7449235,'42f',3.333,3),(224,7449246,7449235,'2f2',3.333,3),(224,7449247,7449235,'f2f',3.333,3),(224,7449248,7449235,'2fc',3.333,3),(224,7449249,7449235,'fcb',3.333,3),(224,7449250,7449235,'cb2',3.333,3),(224,7449251,7449235,'b24',3.333,3),(224,7449252,7449235,'24b',3.333,3),(224,7449253,7449235,'4b7',3.333,3),(224,7449254,7449235,'b70',3.333,3),(224,7449255,7449235,'70a',3.333,3),(224,7449256,7449235,'0a8',3.333,3),(224,7449257,7449235,'a80',3.333,3),(224,7449258,7449235,'806',3.333,3),(224,7449259,7449235,'06c',3.333,3),(224,7449260,7449235,'6cf',3.333,3),(224,7449261,7449235,'cfd',3.333,3),(224,7449262,7449235,'fd6',3.333,3),(224,7449263,7449235,'d64',3.333,3),(224,7449264,7449235,'648',3.333,3),(224,7449265,7449235,'483',3.333,3),(224,7449266,7449236,'mon',100,1),(224,7449267,7449266,'201',50,1),(224,7449268,7449266,'013',50,1),(224,7449269,7449267,'adm',33.333,3),(224,7449270,7449267,'dmi',33.333,3),(224,7449271,7449267,'min',33.333,3),(224,7449272,7449269,'cap',16.667,1),(224,7449273,7449269,'apa',16.667,1),(224,7449274,7449269,'pac',16.667,1),(224,7449275,7449269,'aci',16.667,1),(224,7449276,7449269,'cit',16.667,1),(224,7449277,7449269,'ity',16.667,1),(224,7449278,7449272,'pat',50,1),(224,7449279,7449272,'ath',50,1),(224,7449280,7449278,'vol',25,1),(224,7449281,7449278,'olu',25,1),(224,7449282,7449278,'lum',25,1),(224,7449283,7449278,'ume',25,1),(224,7449284,7449280,'78e',3.333,1),(224,7449285,7449280,'8e3',3.333,1),(224,7449286,7449280,'e3f',3.333,1),(224,7449287,7449280,'3f1',3.333,1),(224,7449288,7449280,'f18',3.333,1),(224,7449289,7449280,'188',3.333,1),(224,7449290,7449280,'886',3.333,1),(224,7449291,7449280,'86d',3.333,1),(224,7449292,7449280,'6d8',3.333,1),(224,7449293,7449280,'d87',3.333,1),(224,7449294,7449280,'871',3.333,1),(224,7449295,7449280,'711',3.333,1),(224,7449296,7449280,'11e',3.333,1),(224,7449297,7449280,'1e1',3.333,1),(224,7449298,7449280,'e19',3.333,1),(224,7449299,7449280,'192',3.333,1),(224,7449300,7449280,'927',3.333,1),(224,7449301,7449280,'277',3.333,1),(224,7449302,7449280,'778',3.333,1),(224,7449303,7449280,'780',3.333,1),(224,7449304,7449280,'806',3.333,1),(224,7449305,7449280,'06e',3.333,1),(224,7449306,7449280,'6e6',3.333,1),(224,7449307,7449280,'e6f',3.333,1),(224,7449308,7449280,'6f6',3.333,1),(224,7449309,7449280,'f6e',3.333,1),(224,7449310,7449280,'6e6',3.333,1),(224,7449311,7449280,'e69',3.333,1),(224,7449312,7449280,'696',3.333,1),(224,7449313,7449280,'963',3.333,1),(224,7449314,7449284,'fre',14.286,1),(224,7449315,7449284,'ree',14.286,1),(224,7449316,7449284,'ees',14.286,1),(224,7449317,7449284,'esp',14.286,1),(224,7449318,7449284,'spa',14.286,1),(224,7449319,7449284,'pac',14.286,1),(224,7449320,7449284,'ace',14.286,1),(224,7449321,7449314,'dis',50,1),(224,7449322,7449314,'isk',50,1),(224,7449323,7449321,'ind',33.333,1),(224,7449324,7449321,'nde',33.333,1),(224,7449325,7449321,'dex',33.333,1),(224,7449326,7449323,'adm',8.333,1),(224,7449327,7449323,'dmi',8.333,1),(224,7449328,7449323,'min',8.333,1),(224,7449329,7449323,'ini',8.333,1),(224,7449330,7449323,'nis',8.333,1),(224,7449331,7449323,'ist',8.333,1),(224,7449332,7449323,'str',8.333,1),(224,7449333,7449323,'tra',8.333,1),(224,7449334,7449323,'rat',8.333,1),(224,7449335,7449323,'ati',8.333,1),(224,7449336,7449323,'tio',8.333,1),(224,7449337,7449323,'ion',8.333,1),(224,7449338,7449326,'sta',33.333,3),(224,7449339,7449326,'tat',33.333,3),(224,7449340,7449326,'ate',33.333,3),(224,7449341,7449338,'ena',20,2),(224,7449342,7449338,'nab',20,2),(224,7449343,7449338,'abl',20,2),(224,7449344,7449338,'ble',20,2),(224,7449345,7449338,'led',20,2),(224,7449346,7449341,'cac',33.333,1),(224,7449347,7449341,'ach',33.333,1),(224,7449348,7449341,'che',33.333,1),(224,7449349,7449346,'mod',50,2),(224,7449350,7449346,'ode',50,2),(224,7449351,7449349,'wri',14.286,2),(224,7449352,7449349,'rit',14.286,2),(224,7449353,7449349,'ite',14.286,2),(224,7449354,7449349,'tet',14.286,2),(224,7449355,7449349,'eth',14.286,2),(224,7449356,7449349,'thr',14.286,2),(224,7449357,7449349,'hru',14.286,2),(224,7449358,7449351,'ope',11.111,2),(224,7449359,7449351,'per',11.111,2),(224,7449360,7449351,'era',11.111,2),(224,7449361,7449351,'rat',11.111,2),(224,7449362,7449351,'ati',11.111,2),(224,7449363,7449351,'tio',11.111,2),(224,7449364,7449351,'ion',11.111,2),(224,7449365,7449351,'ona',11.111,2),(224,7449366,7449351,'nal',11.111,2),(224,7449367,7449358,'nor',25,1),(224,7449368,7449358,'orm',25,1),(224,7449369,7449358,'rma',25,1),(224,7449370,7449358,'mal',25,1),(224,7449371,7449367,'mes',20,1),(224,7449372,7449367,'ess',20,1),(224,7449373,7449367,'ssa',20,1),(224,7449374,7449367,'sag',20,1),(224,7449375,7449367,'age',20,1),(224,7449376,7449371,'per',11.111,1),(224,7449377,7449371,'erf',11.111,1),(224,7449378,7449371,'rfo',11.111,1),(224,7449379,7449371,'for',11.111,1),(224,7449380,7449371,'orm',11.111,1),(224,7449381,7449371,'rma',11.111,1),(224,7449382,7449371,'man',11.111,1),(224,7449383,7449371,'anc',11.111,1),(224,7449384,7449371,'nce',11.111,1),(224,7449385,7449376,'ide',12.5,1),(224,7449386,7449376,'den',12.5,1),(224,7449387,7449376,'ent',12.5,1),(224,7449388,7449376,'nti',12.5,1),(224,7449389,7449376,'tif',12.5,1),(224,7449390,7449376,'ifi',12.5,1),(224,7449391,7449376,'fie',12.5,1),(224,7449392,7449376,'ier',12.5,1),(224,7449393,7449385,'vdi',33.333,3),(224,7449394,7449385,'dis',33.333,3),(224,7449395,7449385,'isk',33.333,3),(224,7449396,7449393,'nam',50,1),(224,7449397,7449393,'ame',50,1),(224,7449398,7449396,'typ',50,1),(224,7449399,7449396,'ype',50,1),(224,7449400,7449398,'dir',25,1),(224,7449401,7449398,'ire',25,1),(224,7449402,7449398,'rec',25,1),(224,7449403,7449398,'ect',25,1),(225,7449405,7449404,'naa',100,2),(225,7449406,7449405,'600',3.333,3),(225,7449407,7449405,'00a',3.333,3),(225,7449408,7449405,'0a0',3.333,3),(225,7449409,7449405,'a09',3.333,3),(225,7449410,7449405,'098',3.333,3),(225,7449411,7449405,'980',3.333,3),(225,7449412,7449405,'804',3.333,3),(225,7449413,7449405,'044',3.333,3),(225,7449414,7449405,'443',3.333,3),(225,7449415,7449405,'430',3.333,3),(225,7449416,7449405,'307',3.333,3),(225,7449417,7449405,'072',3.333,3),(225,7449418,7449405,'725',3.333,3),(225,7449419,7449405,'259',3.333,3),(225,7449420,7449405,'593',3.333,3),(225,7449421,7449405,'931',3.333,3),(225,7449422,7449405,'313',3.333,3),(225,7449423,7449405,'13f',3.333,3),(225,7449424,7449405,'3f3',3.333,3),(225,7449425,7449405,'f33',3.333,3),(225,7449426,7449405,'334',3.333,3),(225,7449427,7449405,'345',3.333,3),(225,7449428,7449405,'455',3.333,3),(225,7449429,7449405,'556',3.333,3),(225,7449430,7449405,'563',3.333,3),(225,7449431,7449405,'639',3.333,3),(225,7449432,7449405,'393',3.333,3),(225,7449433,7449405,'934',3.333,3),(225,7449434,7449405,'343',3.333,3),(225,7449435,7449405,'437',3.333,3),(225,7449436,7449406,'mon',100,1),(225,7449437,7449436,'201',50,1),(225,7449438,7449436,'013',50,1),(225,7449439,7449437,'adm',33.333,3),(225,7449440,7449437,'dmi',33.333,3),(225,7449441,7449437,'min',33.333,3),(225,7449442,7449439,'cap',16.667,1),(225,7449443,7449439,'apa',16.667,1),(225,7449444,7449439,'pac',16.667,1),(225,7449445,7449439,'aci',16.667,1),(225,7449446,7449439,'cit',16.667,1),(225,7449447,7449439,'ity',16.667,1),(225,7449448,7449442,'pat',50,1),(225,7449449,7449442,'ath',50,1),(225,7449450,7449448,'fre',14.286,1),(225,7449451,7449448,'ree',14.286,1),(225,7449452,7449448,'ees',14.286,1),(225,7449453,7449448,'esp',14.286,1),(225,7449454,7449448,'spa',14.286,1),(225,7449455,7449448,'pac',14.286,1),(225,7449456,7449448,'ace',14.286,1),(225,7449457,7449450,'dis',50,1),(225,7449458,7449450,'isk',50,1),(225,7449459,7449457,'ind',33.333,1),(225,7449460,7449457,'nde',33.333,1),(225,7449461,7449457,'dex',33.333,1),(225,7449462,7449459,'adm',8.333,1),(225,7449463,7449459,'dmi',8.333,1),(225,7449464,7449459,'min',8.333,1),(225,7449465,7449459,'ini',8.333,1),(225,7449466,7449459,'nis',8.333,1),(225,7449467,7449459,'ist',8.333,1),(225,7449468,7449459,'str',8.333,1),(225,7449469,7449459,'tra',8.333,1),(225,7449470,7449459,'rat',8.333,1),(225,7449471,7449459,'ati',8.333,1),(225,7449472,7449459,'tio',8.333,1),(225,7449473,7449459,'ion',8.333,1),(225,7449474,7449462,'sta',33.333,3),(225,7449475,7449462,'tat',33.333,3),(225,7449476,7449462,'ate',33.333,3),(225,7449477,7449474,'ena',20,2),(225,7449478,7449474,'nab',20,2),(225,7449479,7449474,'abl',20,2),(225,7449480,7449474,'ble',20,2),(225,7449481,7449474,'led',20,2),(225,7449482,7449477,'cac',33.333,1),(225,7449483,7449477,'ach',33.333,1),(225,7449484,7449477,'che',33.333,1),(225,7449485,7449482,'mod',50,2),(225,7449486,7449482,'ode',50,2),(225,7449487,7449485,'wri',14.286,2),(225,7449488,7449485,'rit',14.286,2),(225,7449489,7449485,'ite',14.286,2),(225,7449490,7449485,'tet',14.286,2),(225,7449491,7449485,'eth',14.286,2),(225,7449492,7449485,'thr',14.286,2),(225,7449493,7449485,'hru',14.286,2),(225,7449494,7449487,'ope',11.111,2),(225,7449495,7449487,'per',11.111,2),(225,7449496,7449487,'era',11.111,2),(225,7449497,7449487,'rat',11.111,2),(225,7449498,7449487,'ati',11.111,2),(225,7449499,7449487,'tio',11.111,2),(225,7449500,7449487,'ion',11.111,2),(225,7449501,7449487,'ona',11.111,2),(225,7449502,7449487,'nal',11.111,2),(225,7449503,7449494,'nor',25,1),(225,7449504,7449494,'orm',25,1),(225,7449505,7449494,'rma',25,1),(225,7449506,7449494,'mal',25,1),(225,7449507,7449503,'mes',20,1),(225,7449508,7449503,'ess',20,1),(225,7449509,7449503,'ssa',20,1),(225,7449510,7449503,'sag',20,1),(225,7449511,7449503,'age',20,1),(225,7449512,7449507,'per',11.111,1),(225,7449513,7449507,'erf',11.111,1),(225,7449514,7449507,'rfo',11.111,1),(225,7449515,7449507,'for',11.111,1),(225,7449516,7449507,'orm',11.111,1),(225,7449517,7449507,'rma',11.111,1),(225,7449518,7449507,'man',11.111,1),(225,7449519,7449507,'anc',11.111,1),(225,7449520,7449507,'nce',11.111,1),(225,7449521,7449512,'ide',12.5,1),(225,7449522,7449512,'den',12.5,1),(225,7449523,7449512,'ent',12.5,1),(225,7449524,7449512,'nti',12.5,1),(225,7449525,7449512,'tif',12.5,1),(225,7449526,7449512,'ifi',12.5,1),(225,7449527,7449512,'fie',12.5,1),(225,7449528,7449512,'ier',12.5,1),(225,7449529,7449521,'vdi',33.333,3),(225,7449530,7449521,'dis',33.333,3),(225,7449531,7449521,'isk',33.333,3),(225,7449532,7449529,'nam',50,1),(225,7449533,7449529,'ame',50,1),(225,7449534,7449532,'typ',50,1),(225,7449535,7449532,'ype',50,1),(225,7449536,7449534,'dir',25,1),(225,7449537,7449534,'ire',25,1),(225,7449538,7449534,'rec',25,1),(225,7449539,7449534,'ect',25,1),(226,7449541,7449540,'naa',100,2),(226,7449542,7449541,'600',3.333,3),(226,7449543,7449541,'00a',3.333,3),(226,7449544,7449541,'0a0',3.333,3),(226,7449545,7449541,'a09',3.333,3),(226,7449546,7449541,'098',3.333,3),(226,7449547,7449541,'980',3.333,3),(226,7449548,7449541,'804',3.333,3),(226,7449549,7449541,'044',3.333,3),(226,7449550,7449541,'443',3.333,3),(226,7449551,7449541,'430',3.333,3),(226,7449552,7449541,'307',3.333,3),(226,7449553,7449541,'075',3.333,3),(226,7449554,7449541,'753',3.333,3),(226,7449555,7449541,'535',3.333,3),(226,7449556,7449541,'357',3.333,3),(226,7449557,7449541,'573',3.333,3),(226,7449558,7449541,'732',3.333,3),(226,7449559,7449541,'32b',3.333,3),(226,7449560,7449541,'2b3',3.333,3),(226,7449561,7449541,'b33',3.333,3),(226,7449562,7449541,'334',3.333,3),(226,7449563,7449541,'345',3.333,3),(226,7449564,7449541,'457',3.333,3),(226,7449565,7449541,'571',3.333,3),(226,7449566,7449541,'715',3.333,3),(226,7449567,7449541,'153',3.333,3),(226,7449568,7449541,'533',3.333,3),(226,7449569,7449541,'335',3.333,3),(226,7449570,7449541,'357',3.333,3),(226,7449571,7449541,'573',3.333,3),(226,7449572,7449542,'mon',100,1),(226,7449573,7449572,'201',50,1),(226,7449574,7449572,'013',50,1),(226,7449575,7449573,'adm',33.333,3),(226,7449576,7449573,'dmi',33.333,3),(226,7449577,7449573,'min',33.333,3),(226,7449578,7449575,'cap',16.667,1),(226,7449579,7449575,'apa',16.667,1),(226,7449580,7449575,'pac',16.667,1),(226,7449581,7449575,'aci',16.667,1),(226,7449582,7449575,'cit',16.667,1),(226,7449583,7449575,'ity',16.667,1),(226,7449584,7449578,'pat',50,1),(226,7449585,7449578,'ath',50,1),(226,7449586,7449584,'fre',14.286,1),(226,7449587,7449584,'ree',14.286,1),(226,7449588,7449584,'ees',14.286,1),(226,7449589,7449584,'esp',14.286,1),(226,7449590,7449584,'spa',14.286,1),(226,7449591,7449584,'pac',14.286,1),(226,7449592,7449584,'ace',14.286,1),(226,7449593,7449586,'dis',50,1),(226,7449594,7449586,'isk',50,1),(226,7449595,7449593,'ind',33.333,1),(226,7449596,7449593,'nde',33.333,1),(226,7449597,7449593,'dex',33.333,1),(226,7449598,7449595,'adm',8.333,1),(226,7449599,7449595,'dmi',8.333,1),(226,7449600,7449595,'min',8.333,1),(226,7449601,7449595,'ini',8.333,1),(226,7449602,7449595,'nis',8.333,1),(226,7449603,7449595,'ist',8.333,1),(226,7449604,7449595,'str',8.333,1),(226,7449605,7449595,'tra',8.333,1),(226,7449606,7449595,'rat',8.333,1),(226,7449607,7449595,'ati',8.333,1),(226,7449608,7449595,'tio',8.333,1),(226,7449609,7449595,'ion',8.333,1),(226,7449610,7449598,'sta',33.333,3),(226,7449611,7449598,'tat',33.333,3),(226,7449612,7449598,'ate',33.333,3),(226,7449613,7449610,'ena',20,2),(226,7449614,7449610,'nab',20,2),(226,7449615,7449610,'abl',20,2),(226,7449616,7449610,'ble',20,2),(226,7449617,7449610,'led',20,2),(226,7449618,7449613,'cac',33.333,1),(226,7449619,7449613,'ach',33.333,1),(226,7449620,7449613,'che',33.333,1),(226,7449621,7449618,'mod',50,2),(226,7449622,7449618,'ode',50,2),(226,7449623,7449621,'wri',14.286,2),(226,7449624,7449621,'rit',14.286,2),(226,7449625,7449621,'ite',14.286,2),(226,7449626,7449621,'tet',14.286,2),(226,7449627,7449621,'eth',14.286,2),(226,7449628,7449621,'thr',14.286,2),(226,7449629,7449621,'hru',14.286,2),(226,7449630,7449623,'ope',11.111,2),(226,7449631,7449623,'per',11.111,2),(226,7449632,7449623,'era',11.111,2),(226,7449633,7449623,'rat',11.111,2),(226,7449634,7449623,'ati',11.111,2),(226,7449635,7449623,'tio',11.111,2),(226,7449636,7449623,'ion',11.111,2),(226,7449637,7449623,'ona',11.111,2),(226,7449638,7449623,'nal',11.111,2),(226,7449639,7449630,'nor',25,1),(226,7449640,7449630,'orm',25,1),(226,7449641,7449630,'rma',25,1),(226,7449642,7449630,'mal',25,1),(226,7449643,7449639,'mes',20,1),(226,7449644,7449639,'ess',20,1),(226,7449645,7449639,'ssa',20,1),(226,7449646,7449639,'sag',20,1),(226,7449647,7449639,'age',20,1),(226,7449648,7449643,'per',11.111,1),(226,7449649,7449643,'erf',11.111,1),(226,7449650,7449643,'rfo',11.111,1),(226,7449651,7449643,'for',11.111,1),(226,7449652,7449643,'orm',11.111,1),(226,7449653,7449643,'rma',11.111,1),(226,7449654,7449643,'man',11.111,1),(226,7449655,7449643,'anc',11.111,1),(226,7449656,7449643,'nce',11.111,1),(226,7449657,7449648,'ide',12.5,1),(226,7449658,7449648,'den',12.5,1),(226,7449659,7449648,'ent',12.5,1),(226,7449660,7449648,'nti',12.5,1),(226,7449661,7449648,'tif',12.5,1),(226,7449662,7449648,'ifi',12.5,1),(226,7449663,7449648,'fie',12.5,1),(226,7449664,7449648,'ier',12.5,1),(226,7449665,7449657,'vdi',33.333,3),(226,7449666,7449657,'dis',33.333,3),(226,7449667,7449657,'isk',33.333,3),(226,7449668,7449665,'nam',50,1),(226,7449669,7449665,'ame',50,1),(226,7449670,7449668,'typ',50,1),(226,7449671,7449668,'ype',50,1),(226,7449672,7449670,'dir',25,1),(226,7449673,7449670,'ire',25,1),(226,7449674,7449670,'rec',25,1),(226,7449675,7449670,'ect',25,1),(227,7449677,7449676,'naa',100,2),(227,7449678,7449677,'600',3.333,3),(227,7449679,7449677,'00a',3.333,3),(227,7449680,7449677,'0a0',3.333,3),(227,7449681,7449677,'a09',3.333,3),(227,7449682,7449677,'098',3.333,3),(227,7449683,7449677,'980',3.333,3),(227,7449684,7449677,'804',3.333,3),(227,7449685,7449677,'044',3.333,3),(227,7449686,7449677,'443',3.333,3),(227,7449687,7449677,'430',3.333,3),(227,7449688,7449677,'307',3.333,3),(227,7449689,7449677,'072',3.333,3),(227,7449690,7449677,'725',3.333,3),(227,7449691,7449677,'259',3.333,3),(227,7449692,7449677,'593',3.333,3),(227,7449693,7449677,'931',3.333,3),(227,7449694,7449677,'313',3.333,3),(227,7449695,7449677,'13f',3.333,3),(227,7449696,7449677,'3f3',3.333,3),(227,7449697,7449677,'f33',3.333,3),(227,7449698,7449677,'334',3.333,3),(227,7449699,7449677,'345',3.333,3),(227,7449700,7449677,'455',3.333,3),(227,7449701,7449677,'556',3.333,3),(227,7449702,7449677,'563',3.333,3),(227,7449703,7449677,'639',3.333,3),(227,7449704,7449677,'393',3.333,3),(227,7449705,7449677,'934',3.333,3),(227,7449706,7449677,'343',3.333,3),(227,7449707,7449677,'438',3.333,3),(227,7449708,7449678,'mon',100,1),(227,7449709,7449708,'201',50,1),(227,7449710,7449708,'013',50,1),(227,7449711,7449709,'adm',33.333,3),(227,7449712,7449709,'dmi',33.333,3),(227,7449713,7449709,'min',33.333,3),(227,7449714,7449711,'cap',16.667,1),(227,7449715,7449711,'apa',16.667,1),(227,7449716,7449711,'pac',16.667,1),(227,7449717,7449711,'aci',16.667,1),(227,7449718,7449711,'cit',16.667,1),(227,7449719,7449711,'ity',16.667,1),(227,7449720,7449714,'pat',50,1),(227,7449721,7449714,'ath',50,1),(227,7449722,7449720,'fre',14.286,1),(227,7449723,7449720,'ree',14.286,1),(227,7449724,7449720,'ees',14.286,1),(227,7449725,7449720,'esp',14.286,1),(227,7449726,7449720,'spa',14.286,1),(227,7449727,7449720,'pac',14.286,1),(227,7449728,7449720,'ace',14.286,1),(227,7449729,7449722,'dis',50,1),(227,7449730,7449722,'isk',50,1),(227,7449731,7449729,'ind',33.333,1),(227,7449732,7449729,'nde',33.333,1),(227,7449733,7449729,'dex',33.333,1),(227,7449734,7449731,'adm',8.333,1),(227,7449735,7449731,'dmi',8.333,1),(227,7449736,7449731,'min',8.333,1),(227,7449737,7449731,'ini',8.333,1),(227,7449738,7449731,'nis',8.333,1),(227,7449739,7449731,'ist',8.333,1),(227,7449740,7449731,'str',8.333,1),(227,7449741,7449731,'tra',8.333,1),(227,7449742,7449731,'rat',8.333,1),(227,7449743,7449731,'ati',8.333,1),(227,7449744,7449731,'tio',8.333,1),(227,7449745,7449731,'ion',8.333,1),(227,7449746,7449734,'sta',33.333,3),(227,7449747,7449734,'tat',33.333,3),(227,7449748,7449734,'ate',33.333,3),(227,7449749,7449746,'ena',20,2),(227,7449750,7449746,'nab',20,2),(227,7449751,7449746,'abl',20,2),(227,7449752,7449746,'ble',20,2),(227,7449753,7449746,'led',20,2),(227,7449754,7449749,'cac',33.333,1),(227,7449755,7449749,'ach',33.333,1),(227,7449756,7449749,'che',33.333,1),(227,7449757,7449754,'mod',50,2),(227,7449758,7449754,'ode',50,2),(227,7449759,7449757,'wri',14.286,2),(227,7449760,7449757,'rit',14.286,2),(227,7449761,7449757,'ite',14.286,2),(227,7449762,7449757,'tet',14.286,2),(227,7449763,7449757,'eth',14.286,2),(227,7449764,7449757,'thr',14.286,2),(227,7449765,7449757,'hru',14.286,2),(227,7449766,7449759,'ope',11.111,2),(227,7449767,7449759,'per',11.111,2),(227,7449768,7449759,'era',11.111,2),(227,7449769,7449759,'rat',11.111,2),(227,7449770,7449759,'ati',11.111,2),(227,7449771,7449759,'tio',11.111,2),(227,7449772,7449759,'ion',11.111,2),(227,7449773,7449759,'ona',11.111,2),(227,7449774,7449759,'nal',11.111,2),(227,7449775,7449766,'nor',25,1),(227,7449776,7449766,'orm',25,1),(227,7449777,7449766,'rma',25,1),(227,7449778,7449766,'mal',25,1),(227,7449779,7449775,'mes',20,1),(227,7449780,7449775,'ess',20,1),(227,7449781,7449775,'ssa',20,1),(227,7449782,7449775,'sag',20,1),(227,7449783,7449775,'age',20,1),(227,7449784,7449779,'per',11.111,1),(227,7449785,7449779,'erf',11.111,1),(227,7449786,7449779,'rfo',11.111,1),(227,7449787,7449779,'for',11.111,1),(227,7449788,7449779,'orm',11.111,1),(227,7449789,7449779,'rma',11.111,1),(227,7449790,7449779,'man',11.111,1),(227,7449791,7449779,'anc',11.111,1),(227,7449792,7449779,'nce',11.111,1),(227,7449793,7449784,'ide',12.5,1),(227,7449794,7449784,'den',12.5,1),(227,7449795,7449784,'ent',12.5,1),(227,7449796,7449784,'nti',12.5,1),(227,7449797,7449784,'tif',12.5,1),(227,7449798,7449784,'ifi',12.5,1),(227,7449799,7449784,'fie',12.5,1),(227,7449800,7449784,'ier',12.5,1),(227,7449801,7449793,'vdi',33.333,3),(227,7449802,7449793,'dis',33.333,3),(227,7449803,7449793,'isk',33.333,3),(227,7449804,7449801,'nam',50,1),(227,7449805,7449801,'ame',50,1),(227,7449806,7449804,'typ',50,1),(227,7449807,7449804,'ype',50,1),(227,7449808,7449806,'dir',25,1),(227,7449809,7449806,'ire',25,1),(227,7449810,7449806,'rec',25,1),(227,7449811,7449806,'ect',25,1),(228,7449813,7449812,'naa',100,2),(228,7449814,7449813,'600',3.333,3),(228,7449815,7449813,'00a',3.333,3),(228,7449816,7449813,'0a0',3.333,3),(228,7449817,7449813,'a09',3.333,3),(228,7449818,7449813,'098',3.333,3),(228,7449819,7449813,'980',3.333,3),(228,7449820,7449813,'804',3.333,3),(228,7449821,7449813,'044',3.333,3),(228,7449822,7449813,'443',3.333,3),(228,7449823,7449813,'430',3.333,3),(228,7449824,7449813,'307',3.333,3),(228,7449825,7449813,'075',3.333,3),(228,7449826,7449813,'753',3.333,3),(228,7449827,7449813,'535',3.333,3),(228,7449828,7449813,'357',3.333,3),(228,7449829,7449813,'573',3.333,3),(228,7449830,7449813,'732',3.333,3),(228,7449831,7449813,'32b',3.333,3),(228,7449832,7449813,'2b3',3.333,3),(228,7449833,7449813,'b33',3.333,3),(228,7449834,7449813,'334',3.333,3),(228,7449835,7449813,'345',3.333,3),(228,7449836,7449813,'457',3.333,3),(228,7449837,7449813,'571',3.333,3),(228,7449838,7449813,'715',3.333,3),(228,7449839,7449813,'153',3.333,3),(228,7449840,7449813,'533',3.333,3),(228,7449841,7449813,'335',3.333,3),(228,7449842,7449813,'357',3.333,3),(228,7449843,7449813,'574',3.333,3),(228,7449844,7449814,'mon',100,1),(228,7449845,7449844,'201',50,1),(228,7449846,7449844,'013',50,1),(228,7449847,7449845,'adm',33.333,3),(228,7449848,7449845,'dmi',33.333,3),(228,7449849,7449845,'min',33.333,3),(228,7449850,7449847,'cap',16.667,1),(228,7449851,7449847,'apa',16.667,1),(228,7449852,7449847,'pac',16.667,1),(228,7449853,7449847,'aci',16.667,1),(228,7449854,7449847,'cit',16.667,1),(228,7449855,7449847,'ity',16.667,1),(228,7449856,7449850,'pat',50,1),(228,7449857,7449850,'ath',50,1),(228,7449858,7449856,'fre',14.286,1),(228,7449859,7449856,'ree',14.286,1),(228,7449860,7449856,'ees',14.286,1),(228,7449861,7449856,'esp',14.286,1),(228,7449862,7449856,'spa',14.286,1),(228,7449863,7449856,'pac',14.286,1),(228,7449864,7449856,'ace',14.286,1),(228,7449865,7449858,'dis',50,1),(228,7449866,7449858,'isk',50,1),(228,7449867,7449865,'ind',33.333,1),(228,7449868,7449865,'nde',33.333,1),(228,7449869,7449865,'dex',33.333,1),(228,7449870,7449867,'adm',8.333,1),(228,7449871,7449867,'dmi',8.333,1),(228,7449872,7449867,'min',8.333,1),(228,7449873,7449867,'ini',8.333,1),(228,7449874,7449867,'nis',8.333,1),(228,7449875,7449867,'ist',8.333,1),(228,7449876,7449867,'str',8.333,1),(228,7449877,7449867,'tra',8.333,1),(228,7449878,7449867,'rat',8.333,1),(228,7449879,7449867,'ati',8.333,1),(228,7449880,7449867,'tio',8.333,1),(228,7449881,7449867,'ion',8.333,1),(228,7449882,7449870,'sta',33.333,3),(228,7449883,7449870,'tat',33.333,3),(228,7449884,7449870,'ate',33.333,3),(228,7449885,7449882,'ena',20,2),(228,7449886,7449882,'nab',20,2),(228,7449887,7449882,'abl',20,2),(228,7449888,7449882,'ble',20,2),(228,7449889,7449882,'led',20,2),(228,7449890,7449885,'cac',33.333,1),(228,7449891,7449885,'ach',33.333,1),(228,7449892,7449885,'che',33.333,1),(228,7449893,7449890,'mod',50,2),(228,7449894,7449890,'ode',50,2),(228,7449895,7449893,'wri',14.286,2),(228,7449896,7449893,'rit',14.286,2),(228,7449897,7449893,'ite',14.286,2),(228,7449898,7449893,'tet',14.286,2),(228,7449899,7449893,'eth',14.286,2),(228,7449900,7449893,'thr',14.286,2),(228,7449901,7449893,'hru',14.286,2),(228,7449902,7449895,'ope',11.111,2),(228,7449903,7449895,'per',11.111,2),(228,7449904,7449895,'era',11.111,2),(228,7449905,7449895,'rat',11.111,2),(228,7449906,7449895,'ati',11.111,2),(228,7449907,7449895,'tio',11.111,2),(228,7449908,7449895,'ion',11.111,2),(228,7449909,7449895,'ona',11.111,2),(228,7449910,7449895,'nal',11.111,2),(228,7449911,7449902,'nor',25,1),(228,7449912,7449902,'orm',25,1),(228,7449913,7449902,'rma',25,1),(228,7449914,7449902,'mal',25,1),(228,7449915,7449911,'mes',20,1),(228,7449916,7449911,'ess',20,1),(228,7449917,7449911,'ssa',20,1),(228,7449918,7449911,'sag',20,1),(228,7449919,7449911,'age',20,1),(228,7449920,7449915,'per',11.111,1),(228,7449921,7449915,'erf',11.111,1),(228,7449922,7449915,'rfo',11.111,1),(228,7449923,7449915,'for',11.111,1),(228,7449924,7449915,'orm',11.111,1),(228,7449925,7449915,'rma',11.111,1),(228,7449926,7449915,'man',11.111,1),(228,7449927,7449915,'anc',11.111,1),(228,7449928,7449915,'nce',11.111,1),(228,7449929,7449920,'ide',12.5,1),(228,7449930,7449920,'den',12.5,1),(228,7449931,7449920,'ent',12.5,1),(228,7449932,7449920,'nti',12.5,1),(228,7449933,7449920,'tif',12.5,1),(228,7449934,7449920,'ifi',12.5,1),(228,7449935,7449920,'fie',12.5,1),(228,7449936,7449920,'ier',12.5,1),(228,7449937,7449929,'vdi',33.333,3),(228,7449938,7449929,'dis',33.333,3),(228,7449939,7449929,'isk',33.333,3),(228,7449940,7449937,'nam',50,1),(228,7449941,7449937,'ame',50,1),(228,7449942,7449940,'typ',50,1),(228,7449943,7449940,'ype',50,1),(228,7449944,7449942,'dir',25,1),(228,7449945,7449942,'ire',25,1),(228,7449946,7449942,'rec',25,1),(228,7449947,7449942,'ect',25,1),(229,7449949,7449948,'naa',100,2),(229,7449950,7449949,'600',3.333,3),(229,7449951,7449949,'000',3.333,3),(229,7449952,7449949,'00c',3.333,3),(229,7449953,7449949,'0c2',3.333,3),(229,7449954,7449949,'c29',3.333,3),(229,7449955,7449949,'296',3.333,3),(229,7449956,7449949,'96b',3.333,3),(229,7449957,7449949,'6b3',3.333,3),(229,7449958,7449949,'b36',3.333,3),(229,7449959,7449949,'36c',3.333,3),(229,7449960,7449949,'6c8',3.333,3),(229,7449961,7449949,'c88',3.333,3),(229,7449962,7449949,'887',3.333,3),(229,7449963,7449949,'87c',3.333,3),(229,7449964,7449949,'7ce',3.333,3),(229,7449965,7449949,'cee',3.333,3),(229,7449966,7449949,'eec',3.333,3),(229,7449967,7449949,'ec4',3.333,3),(229,7449968,7449949,'c41',3.333,3),(229,7449969,7449949,'41b',3.333,3),(229,7449970,7449949,'1b5',3.333,3),(229,7449971,7449949,'b5e',3.333,3),(229,7449972,7449949,'5e4',3.333,3),(229,7449973,7449949,'e40',3.333,3),(229,7449974,7449949,'405',3.333,3),(229,7449975,7449949,'054',3.333,3),(229,7449976,7449949,'543',3.333,3),(229,7449977,7449949,'43c',3.333,3),(229,7449978,7449949,'3c6',3.333,3),(229,7449979,7449949,'c63',3.333,3),(229,7449980,7449950,'mon',100,1),(229,7449981,7449980,'201',50,1),(229,7449982,7449980,'013',50,1),(229,7449983,7449981,'adm',33.333,3),(229,7449984,7449981,'dmi',33.333,3),(229,7449985,7449981,'min',33.333,3),(229,7449986,7449983,'cap',16.667,1),(229,7449987,7449983,'apa',16.667,1),(229,7449988,7449983,'pac',16.667,1),(229,7449989,7449983,'aci',16.667,1),(229,7449990,7449983,'cit',16.667,1),(229,7449991,7449983,'ity',16.667,1),(229,7449992,7449986,'pat',50,1),(229,7449993,7449986,'ath',50,1),(229,7449994,7449992,'fre',14.286,1),(229,7449995,7449992,'ree',14.286,1),(229,7449996,7449992,'ees',14.286,1),(229,7449997,7449992,'esp',14.286,1),(229,7449998,7449992,'spa',14.286,1),(229,7449999,7449992,'pac',14.286,1),(229,7450000,7449992,'ace',14.286,1),(229,7450001,7449994,'dis',50,1),(229,7450002,7449994,'isk',50,1),(229,7450003,7450001,'ind',33.333,1),(229,7450004,7450001,'nde',33.333,1),(229,7450005,7450001,'dex',33.333,1),(229,7450006,7450003,'adm',8.333,1),(229,7450007,7450003,'dmi',8.333,1),(229,7450008,7450003,'min',8.333,1),(229,7450009,7450003,'ini',8.333,1),(229,7450010,7450003,'nis',8.333,1),(229,7450011,7450003,'ist',8.333,1),(229,7450012,7450003,'str',8.333,1),(229,7450013,7450003,'tra',8.333,1),(229,7450014,7450003,'rat',8.333,1),(229,7450015,7450003,'ati',8.333,1),(229,7450016,7450003,'tio',8.333,1),(229,7450017,7450003,'ion',8.333,1),(229,7450018,7450006,'sta',33.333,3),(229,7450019,7450006,'tat',33.333,3),(229,7450020,7450006,'ate',33.333,3),(229,7450021,7450018,'ena',20,2),(229,7450022,7450018,'nab',20,2),(229,7450023,7450018,'abl',20,2),(229,7450024,7450018,'ble',20,2),(229,7450025,7450018,'led',20,2),(229,7450026,7450021,'cac',33.333,1),(229,7450027,7450021,'ach',33.333,1),(229,7450028,7450021,'che',33.333,1),(229,7450029,7450026,'mod',50,2),(229,7450030,7450026,'ode',50,2),(229,7450031,7450029,'wri',14.286,2),(229,7450032,7450029,'rit',14.286,2),(229,7450033,7450029,'ite',14.286,2),(229,7450034,7450029,'tet',14.286,2),(229,7450035,7450029,'eth',14.286,2),(229,7450036,7450029,'thr',14.286,2),(229,7450037,7450029,'hru',14.286,2),(229,7450038,7450031,'ope',11.111,2),(229,7450039,7450031,'per',11.111,2),(229,7450040,7450031,'era',11.111,2),(229,7450041,7450031,'rat',11.111,2),(229,7450042,7450031,'ati',11.111,2),(229,7450043,7450031,'tio',11.111,2),(229,7450044,7450031,'ion',11.111,2),(229,7450045,7450031,'ona',11.111,2),(229,7450046,7450031,'nal',11.111,2),(229,7450047,7450038,'nor',25,1),(229,7450048,7450038,'orm',25,1),(229,7450049,7450038,'rma',25,1),(229,7450050,7450038,'mal',25,1),(229,7450051,7450047,'mes',20,1),(229,7450052,7450047,'ess',20,1),(229,7450053,7450047,'ssa',20,1),(229,7450054,7450047,'sag',20,1),(229,7450055,7450047,'age',20,1),(229,7450056,7450051,'per',11.111,1),(229,7450057,7450051,'erf',11.111,1),(229,7450058,7450051,'rfo',11.111,1),(229,7450059,7450051,'for',11.111,1),(229,7450060,7450051,'orm',11.111,1),(229,7450061,7450051,'rma',11.111,1),(229,7450062,7450051,'man',11.111,1),(229,7450063,7450051,'anc',11.111,1),(229,7450064,7450051,'nce',11.111,1),(229,7450065,7450056,'ide',12.5,1),(229,7450066,7450056,'den',12.5,1),(229,7450067,7450056,'ent',12.5,1),(229,7450068,7450056,'nti',12.5,1),(229,7450069,7450056,'tif',12.5,1),(229,7450070,7450056,'ifi',12.5,1),(229,7450071,7450056,'fie',12.5,1),(229,7450072,7450056,'ier',12.5,1),(229,7450073,7450065,'vdi',33.333,3),(229,7450074,7450065,'dis',33.333,3),(229,7450075,7450065,'isk',33.333,3),(229,7450076,7450073,'nam',50,1),(229,7450077,7450073,'ame',50,1),(229,7450078,7450076,'typ',50,1),(229,7450079,7450076,'ype',50,1),(229,7450080,7450078,'dir',25,1),(229,7450081,7450078,'ire',25,1),(229,7450082,7450078,'rec',25,1),(229,7450083,7450078,'ect',25,1),(230,7450085,7450084,'naa',100,2),(230,7450086,7450085,'600',3.333,3),(230,7450087,7450085,'000',3.333,3),(230,7450088,7450085,'00c',3.333,3),(230,7450089,7450085,'0c2',3.333,3),(230,7450090,7450085,'c29',3.333,3),(230,7450091,7450085,'29a',3.333,3),(230,7450092,7450085,'9a7',3.333,3),(230,7450093,7450085,'a76',3.333,3),(230,7450094,7450085,'765',3.333,3),(230,7450095,7450085,'65b',3.333,3),(230,7450096,7450085,'5bf',3.333,3),(230,7450097,7450085,'bf9',3.333,3),(230,7450098,7450085,'f9d',3.333,3),(230,7450099,7450085,'9dd',3.333,3),(230,7450100,7450085,'dd2',3.333,3),(230,7450101,7450085,'d27',3.333,3),(230,7450102,7450085,'273',3.333,3),(230,7450103,7450085,'734',3.333,3),(230,7450104,7450085,'349',3.333,3),(230,7450105,7450085,'49f',3.333,3),(230,7450106,7450085,'9f0',3.333,3),(230,7450107,7450085,'f08',3.333,3),(230,7450108,7450085,'08f',3.333,3),(230,7450109,7450085,'8fc',3.333,3),(230,7450110,7450085,'fcc',3.333,3),(230,7450111,7450085,'ccc',3.333,3),(230,7450112,7450085,'cc8',3.333,3),(230,7450113,7450085,'c80',3.333,3),(230,7450114,7450085,'80c',3.333,3),(230,7450115,7450085,'0c9',3.333,3),(230,7450116,7450086,'mon',100,1),(230,7450117,7450116,'201',50,1),(230,7450118,7450116,'013',50,1),(230,7450119,7450117,'adm',33.333,3),(230,7450120,7450117,'dmi',33.333,3),(230,7450121,7450117,'min',33.333,3),(230,7450122,7450119,'cap',16.667,1),(230,7450123,7450119,'apa',16.667,1),(230,7450124,7450119,'pac',16.667,1),(230,7450125,7450119,'aci',16.667,1),(230,7450126,7450119,'cit',16.667,1),(230,7450127,7450119,'ity',16.667,1),(230,7450128,7450122,'pat',50,1),(230,7450129,7450122,'ath',50,1),(230,7450130,7450128,'fre',14.286,1),(230,7450131,7450128,'ree',14.286,1),(230,7450132,7450128,'ees',14.286,1),(230,7450133,7450128,'esp',14.286,1),(230,7450134,7450128,'spa',14.286,1),(230,7450135,7450128,'pac',14.286,1),(230,7450136,7450128,'ace',14.286,1),(230,7450137,7450130,'dis',50,1),(230,7450138,7450130,'isk',50,1),(230,7450139,7450137,'ind',33.333,1),(230,7450140,7450137,'nde',33.333,1),(230,7450141,7450137,'dex',33.333,1),(230,7450142,7450139,'adm',8.333,1),(230,7450143,7450139,'dmi',8.333,1),(230,7450144,7450139,'min',8.333,1),(230,7450145,7450139,'ini',8.333,1),(230,7450146,7450139,'nis',8.333,1),(230,7450147,7450139,'ist',8.333,1),(230,7450148,7450139,'str',8.333,1),(230,7450149,7450139,'tra',8.333,1),(230,7450150,7450139,'rat',8.333,1),(230,7450151,7450139,'ati',8.333,1),(230,7450152,7450139,'tio',8.333,1),(230,7450153,7450139,'ion',8.333,1),(230,7450154,7450142,'sta',33.333,3),(230,7450155,7450142,'tat',33.333,3),(230,7450156,7450142,'ate',33.333,3),(230,7450157,7450154,'ena',20,2),(230,7450158,7450154,'nab',20,2),(230,7450159,7450154,'abl',20,2),(230,7450160,7450154,'ble',20,2),(230,7450161,7450154,'led',20,2),(230,7450162,7450157,'cac',33.333,1),(230,7450163,7450157,'ach',33.333,1),(230,7450164,7450157,'che',33.333,1),(230,7450165,7450162,'mod',50,2),(230,7450166,7450162,'ode',50,2),(230,7450167,7450165,'wri',14.286,2),(230,7450168,7450165,'rit',14.286,2),(230,7450169,7450165,'ite',14.286,2),(230,7450170,7450165,'tet',14.286,2),(230,7450171,7450165,'eth',14.286,2),(230,7450172,7450165,'thr',14.286,2),(230,7450173,7450165,'hru',14.286,2),(230,7450174,7450167,'ope',11.111,2),(230,7450175,7450167,'per',11.111,2),(230,7450176,7450167,'era',11.111,2),(230,7450177,7450167,'rat',11.111,2),(230,7450178,7450167,'ati',11.111,2),(230,7450179,7450167,'tio',11.111,2),(230,7450180,7450167,'ion',11.111,2),(230,7450181,7450167,'ona',11.111,2),(230,7450182,7450167,'nal',11.111,2),(230,7450183,7450174,'nor',25,1),(230,7450184,7450174,'orm',25,1),(230,7450185,7450174,'rma',25,1),(230,7450186,7450174,'mal',25,1),(230,7450187,7450183,'mes',20,1),(230,7450188,7450183,'ess',20,1),(230,7450189,7450183,'ssa',20,1),(230,7450190,7450183,'sag',20,1),(230,7450191,7450183,'age',20,1),(230,7450192,7450187,'per',11.111,1),(230,7450193,7450187,'erf',11.111,1),(230,7450194,7450187,'rfo',11.111,1),(230,7450195,7450187,'for',11.111,1),(230,7450196,7450187,'orm',11.111,1),(230,7450197,7450187,'rma',11.111,1),(230,7450198,7450187,'man',11.111,1),(230,7450199,7450187,'anc',11.111,1),(230,7450200,7450187,'nce',11.111,1),(230,7450201,7450192,'ide',12.5,1),(230,7450202,7450192,'den',12.5,1),(230,7450203,7450192,'ent',12.5,1),(230,7450204,7450192,'nti',12.5,1),(230,7450205,7450192,'tif',12.5,1),(230,7450206,7450192,'ifi',12.5,1),(230,7450207,7450192,'fie',12.5,1),(230,7450208,7450192,'ier',12.5,1),(230,7450209,7450201,'vdi',33.333,3),(230,7450210,7450201,'dis',33.333,3),(230,7450211,7450201,'isk',33.333,3),(230,7450212,7450209,'nam',50,1),(230,7450213,7450209,'ame',50,1),(230,7450214,7450212,'typ',50,1),(230,7450215,7450212,'ype',50,1),(230,7450216,7450214,'dir',25,1),(230,7450217,7450214,'ire',25,1),(230,7450218,7450214,'rec',25,1),(230,7450219,7450214,'ect',25,1),(231,7450221,7450220,'naa',100,2),(231,7450222,7450221,'600',3.333,3),(231,7450223,7450221,'000',3.333,3),(231,7450224,7450221,'00c',3.333,3),(231,7450225,7450221,'0c2',3.333,3),(231,7450226,7450221,'c29',3.333,3),(231,7450227,7450221,'29b',3.333,3),(231,7450228,7450221,'9b3',3.333,3),(231,7450229,7450221,'b32',3.333,3),(231,7450230,7450221,'322',3.333,3),(231,7450231,7450221,'222',3.333,3),(231,7450232,7450221,'229',3.333,3),(231,7450233,7450221,'295',3.333,3),(231,7450234,7450221,'956',3.333,3),(231,7450235,7450221,'568',3.333,3),(231,7450236,7450221,'685',3.333,3),(231,7450237,7450221,'854',3.333,3),(231,7450238,7450221,'548',3.333,3),(231,7450239,7450221,'487',3.333,3),(231,7450240,7450221,'879',3.333,3),(231,7450241,7450221,'794',3.333,3),(231,7450242,7450221,'946',3.333,3),(231,7450243,7450221,'461',3.333,3),(231,7450244,7450221,'61d',3.333,3),(231,7450245,7450221,'1dd',3.333,3),(231,7450246,7450221,'dd9',3.333,3),(231,7450247,7450221,'d96',3.333,3),(231,7450248,7450221,'964',3.333,3),(231,7450249,7450221,'64e',3.333,3),(231,7450250,7450221,'4e8',3.333,3),(231,7450251,7450221,'e80',3.333,3),(231,7450252,7450222,'mon',100,1),(231,7450253,7450252,'201',50,1),(231,7450254,7450252,'013',50,1),(231,7450255,7450253,'adm',33.333,3),(231,7450256,7450253,'dmi',33.333,3),(231,7450257,7450253,'min',33.333,3),(231,7450258,7450255,'cap',16.667,1),(231,7450259,7450255,'apa',16.667,1),(231,7450260,7450255,'pac',16.667,1),(231,7450261,7450255,'aci',16.667,1),(231,7450262,7450255,'cit',16.667,1),(231,7450263,7450255,'ity',16.667,1),(231,7450264,7450258,'pat',50,1),(231,7450265,7450258,'ath',50,1),(231,7450266,7450264,'fre',14.286,1),(231,7450267,7450264,'ree',14.286,1),(231,7450268,7450264,'ees',14.286,1),(231,7450269,7450264,'esp',14.286,1),(231,7450270,7450264,'spa',14.286,1),(231,7450271,7450264,'pac',14.286,1),(231,7450272,7450264,'ace',14.286,1),(231,7450273,7450266,'dis',50,1),(231,7450274,7450266,'isk',50,1),(231,7450275,7450273,'ind',33.333,1),(231,7450276,7450273,'nde',33.333,1),(231,7450277,7450273,'dex',33.333,1),(231,7450278,7450275,'adm',8.333,1),(231,7450279,7450275,'dmi',8.333,1),(231,7450280,7450275,'min',8.333,1),(231,7450281,7450275,'ini',8.333,1),(231,7450282,7450275,'nis',8.333,1),(231,7450283,7450275,'ist',8.333,1),(231,7450284,7450275,'str',8.333,1),(231,7450285,7450275,'tra',8.333,1),(231,7450286,7450275,'rat',8.333,1),(231,7450287,7450275,'ati',8.333,1),(231,7450288,7450275,'tio',8.333,1),(231,7450289,7450275,'ion',8.333,1),(231,7450290,7450278,'sta',33.333,3),(231,7450291,7450278,'tat',33.333,3),(231,7450292,7450278,'ate',33.333,3),(231,7450293,7450290,'ena',20,2),(231,7450294,7450290,'nab',20,2),(231,7450295,7450290,'abl',20,2),(231,7450296,7450290,'ble',20,2),(231,7450297,7450290,'led',20,2),(231,7450298,7450293,'cac',33.333,1),(231,7450299,7450293,'ach',33.333,1),(231,7450300,7450293,'che',33.333,1),(231,7450301,7450298,'mod',50,2),(231,7450302,7450298,'ode',50,2),(231,7450303,7450301,'wri',14.286,2),(231,7450304,7450301,'rit',14.286,2),(231,7450305,7450301,'ite',14.286,2),(231,7450306,7450301,'tet',14.286,2),(231,7450307,7450301,'eth',14.286,2),(231,7450308,7450301,'thr',14.286,2),(231,7450309,7450301,'hru',14.286,2),(231,7450310,7450303,'ope',11.111,2),(231,7450311,7450303,'per',11.111,2),(231,7450312,7450303,'era',11.111,2),(231,7450313,7450303,'rat',11.111,2),(231,7450314,7450303,'ati',11.111,2),(231,7450315,7450303,'tio',11.111,2),(231,7450316,7450303,'ion',11.111,2),(231,7450317,7450303,'ona',11.111,2),(231,7450318,7450303,'nal',11.111,2),(231,7450319,7450310,'nor',25,1),(231,7450320,7450310,'orm',25,1),(231,7450321,7450310,'rma',25,1),(231,7450322,7450310,'mal',25,1),(231,7450323,7450319,'mes',20,1),(231,7450324,7450319,'ess',20,1),(231,7450325,7450319,'ssa',20,1),(231,7450326,7450319,'sag',20,1),(231,7450327,7450319,'age',20,1),(231,7450328,7450323,'per',11.111,1),(231,7450329,7450323,'erf',11.111,1),(231,7450330,7450323,'rfo',11.111,1),(231,7450331,7450323,'for',11.111,1),(231,7450332,7450323,'orm',11.111,1),(231,7450333,7450323,'rma',11.111,1),(231,7450334,7450323,'man',11.111,1),(231,7450335,7450323,'anc',11.111,1),(231,7450336,7450323,'nce',11.111,1),(231,7450337,7450328,'ide',12.5,1),(231,7450338,7450328,'den',12.5,1),(231,7450339,7450328,'ent',12.5,1),(231,7450340,7450328,'nti',12.5,1),(231,7450341,7450328,'tif',12.5,1),(231,7450342,7450328,'ifi',12.5,1),(231,7450343,7450328,'fie',12.5,1),(231,7450344,7450328,'ier',12.5,1),(231,7450345,7450337,'vdi',33.333,3),(231,7450346,7450337,'dis',33.333,3),(231,7450347,7450337,'isk',33.333,3),(231,7450348,7450345,'nam',50,1),(231,7450349,7450345,'ame',50,1),(231,7450350,7450348,'typ',50,1),(231,7450351,7450348,'ype',50,1),(231,7450352,7450350,'dir',25,1),(231,7450353,7450350,'ire',25,1),(231,7450354,7450350,'rec',25,1),(231,7450355,7450350,'ect',25,1),(232,7450357,7450356,'naa',100,2),(232,7450358,7450357,'600',3.333,3),(232,7450359,7450357,'000',3.333,3),(232,7450360,7450357,'00c',3.333,3),(232,7450361,7450357,'0c2',3.333,3),(232,7450362,7450357,'c29',3.333,3),(232,7450363,7450357,'292',3.333,3),(232,7450364,7450357,'92e',3.333,3),(232,7450365,7450357,'2e0',3.333,3),(232,7450366,7450357,'e06',3.333,3),(232,7450367,7450357,'063',3.333,3),(232,7450368,7450357,'633',3.333,3),(232,7450369,7450357,'33d',3.333,3),(232,7450370,7450357,'3db',3.333,3),(232,7450371,7450357,'db9',3.333,3),(232,7450372,7450357,'b9e',3.333,3),(232,7450373,7450357,'9e8',3.333,3),(232,7450374,7450357,'e8f',3.333,3),(232,7450375,7450357,'8f9',3.333,3),(232,7450376,7450357,'f95',3.333,3),(232,7450377,7450357,'955',3.333,3),(232,7450378,7450357,'555',3.333,3),(232,7450379,7450357,'55d',3.333,3),(232,7450380,7450357,'5d6',3.333,3),(232,7450381,7450357,'d65',3.333,3),(232,7450382,7450357,'658',3.333,3),(232,7450383,7450357,'58a',3.333,3),(232,7450384,7450357,'8ad',3.333,3),(232,7450385,7450357,'ad2',3.333,3),(232,7450386,7450357,'d2c',3.333,3),(232,7450387,7450357,'2ca',3.333,3),(232,7450388,7450358,'mon',100,1),(232,7450389,7450388,'201',50,1),(232,7450390,7450388,'013',50,1),(232,7450391,7450389,'adm',33.333,3),(232,7450392,7450389,'dmi',33.333,3),(232,7450393,7450389,'min',33.333,3),(232,7450394,7450391,'cap',16.667,1),(232,7450395,7450391,'apa',16.667,1),(232,7450396,7450391,'pac',16.667,1),(232,7450397,7450391,'aci',16.667,1),(232,7450398,7450391,'cit',16.667,1),(232,7450399,7450391,'ity',16.667,1),(232,7450400,7450394,'pat',50,1),(232,7450401,7450394,'ath',50,1),(232,7450402,7450400,'fre',14.286,1),(232,7450403,7450400,'ree',14.286,1),(232,7450404,7450400,'ees',14.286,1),(232,7450405,7450400,'esp',14.286,1),(232,7450406,7450400,'spa',14.286,1),(232,7450407,7450400,'pac',14.286,1),(232,7450408,7450400,'ace',14.286,1),(232,7450409,7450402,'dis',50,1),(232,7450410,7450402,'isk',50,1),(232,7450411,7450409,'ind',33.333,1),(232,7450412,7450409,'nde',33.333,1),(232,7450413,7450409,'dex',33.333,1),(232,7450414,7450411,'adm',8.333,1),(232,7450415,7450411,'dmi',8.333,1),(232,7450416,7450411,'min',8.333,1),(232,7450417,7450411,'ini',8.333,1),(232,7450418,7450411,'nis',8.333,1),(232,7450419,7450411,'ist',8.333,1),(232,7450420,7450411,'str',8.333,1),(232,7450421,7450411,'tra',8.333,1),(232,7450422,7450411,'rat',8.333,1),(232,7450423,7450411,'ati',8.333,1),(232,7450424,7450411,'tio',8.333,1),(232,7450425,7450411,'ion',8.333,1),(232,7450426,7450414,'sta',33.333,3),(232,7450427,7450414,'tat',33.333,3),(232,7450428,7450414,'ate',33.333,3),(232,7450429,7450426,'ena',20,2),(232,7450430,7450426,'nab',20,2),(232,7450431,7450426,'abl',20,2),(232,7450432,7450426,'ble',20,2),(232,7450433,7450426,'led',20,2),(232,7450434,7450429,'cac',33.333,1),(232,7450435,7450429,'ach',33.333,1),(232,7450436,7450429,'che',33.333,1),(232,7450437,7450434,'mod',50,2),(232,7450438,7450434,'ode',50,2),(232,7450439,7450437,'wri',14.286,2),(232,7450440,7450437,'rit',14.286,2),(232,7450441,7450437,'ite',14.286,2),(232,7450442,7450437,'tet',14.286,2),(232,7450443,7450437,'eth',14.286,2),(232,7450444,7450437,'thr',14.286,2),(232,7450445,7450437,'hru',14.286,2),(232,7450446,7450439,'ope',11.111,2),(232,7450447,7450439,'per',11.111,2),(232,7450448,7450439,'era',11.111,2),(232,7450449,7450439,'rat',11.111,2),(232,7450450,7450439,'ati',11.111,2),(232,7450451,7450439,'tio',11.111,2),(232,7450452,7450439,'ion',11.111,2),(232,7450453,7450439,'ona',11.111,2),(232,7450454,7450439,'nal',11.111,2),(232,7450455,7450446,'nor',25,1),(232,7450456,7450446,'orm',25,1),(232,7450457,7450446,'rma',25,1),(232,7450458,7450446,'mal',25,1),(232,7450459,7450455,'mes',20,1),(232,7450460,7450455,'ess',20,1),(232,7450461,7450455,'ssa',20,1),(232,7450462,7450455,'sag',20,1),(232,7450463,7450455,'age',20,1),(232,7450464,7450459,'per',11.111,1),(232,7450465,7450459,'erf',11.111,1),(232,7450466,7450459,'rfo',11.111,1),(232,7450467,7450459,'for',11.111,1),(232,7450468,7450459,'orm',11.111,1),(232,7450469,7450459,'rma',11.111,1),(232,7450470,7450459,'man',11.111,1),(232,7450471,7450459,'anc',11.111,1),(232,7450472,7450459,'nce',11.111,1),(232,7450473,7450464,'ide',12.5,1),(232,7450474,7450464,'den',12.5,1),(232,7450475,7450464,'ent',12.5,1),(232,7450476,7450464,'nti',12.5,1),(232,7450477,7450464,'tif',12.5,1),(232,7450478,7450464,'ifi',12.5,1),(232,7450479,7450464,'fie',12.5,1),(232,7450480,7450464,'ier',12.5,1),(232,7450481,7450473,'vdi',33.333,3),(232,7450482,7450473,'dis',33.333,3),(232,7450483,7450473,'isk',33.333,3),(232,7450484,7450481,'nam',50,1),(232,7450485,7450481,'ame',50,1),(232,7450486,7450484,'typ',50,1),(232,7450487,7450484,'ype',50,1),(232,7450488,7450486,'dir',25,1),(232,7450489,7450486,'ire',25,1),(232,7450490,7450486,'rec',25,1),(232,7450491,7450486,'ect',25,1),(233,7450493,7450492,'naa',100,2),(233,7450494,7450493,'600',3.333,3),(233,7450495,7450493,'000',3.333,3),(233,7450496,7450493,'00c',3.333,3),(233,7450497,7450493,'0c2',3.333,3),(233,7450498,7450493,'c29',3.333,3),(233,7450499,7450493,'293',3.333,3),(233,7450500,7450493,'936',3.333,3),(233,7450501,7450493,'362',3.333,3),(233,7450502,7450493,'62e',3.333,3),(233,7450503,7450493,'2e5',3.333,3),(233,7450504,7450493,'e53',3.333,3),(233,7450505,7450493,'532',3.333,3),(233,7450506,7450493,'32d',3.333,3),(233,7450507,7450493,'2d0',3.333,3),(233,7450508,7450493,'d04',3.333,3),(233,7450509,7450493,'043',3.333,3),(233,7450510,7450493,'433',3.333,3),(233,7450511,7450493,'33c',3.333,3),(233,7450512,7450493,'3c7',3.333,3),(233,7450513,7450493,'c7b',3.333,3),(233,7450514,7450493,'7b0',3.333,3),(233,7450515,7450493,'b0f',3.333,3),(233,7450516,7450493,'0f3',3.333,3),(233,7450517,7450493,'f3f',3.333,3),(233,7450518,7450493,'3f4',3.333,3),(233,7450519,7450493,'f44',3.333,3),(233,7450520,7450493,'444',3.333,3),(233,7450521,7450493,'448',3.333,3),(233,7450522,7450493,'480',3.333,3),(233,7450523,7450493,'807',3.333,3),(233,7450524,7450494,'mon',100,1),(233,7450525,7450524,'201',50,1),(233,7450526,7450524,'013',50,1),(233,7450527,7450525,'adm',33.333,3),(233,7450528,7450525,'dmi',33.333,3),(233,7450529,7450525,'min',33.333,3),(233,7450530,7450527,'cap',16.667,1),(233,7450531,7450527,'apa',16.667,1),(233,7450532,7450527,'pac',16.667,1),(233,7450533,7450527,'aci',16.667,1),(233,7450534,7450527,'cit',16.667,1),(233,7450535,7450527,'ity',16.667,1),(233,7450536,7450530,'pat',50,1),(233,7450537,7450530,'ath',50,1),(233,7450538,7450536,'fre',14.286,1),(233,7450539,7450536,'ree',14.286,1),(233,7450540,7450536,'ees',14.286,1),(233,7450541,7450536,'esp',14.286,1),(233,7450542,7450536,'spa',14.286,1),(233,7450543,7450536,'pac',14.286,1),(233,7450544,7450536,'ace',14.286,1),(233,7450545,7450538,'dis',50,1),(233,7450546,7450538,'isk',50,1),(233,7450547,7450545,'ind',33.333,1),(233,7450548,7450545,'nde',33.333,1),(233,7450549,7450545,'dex',33.333,1),(233,7450550,7450547,'adm',8.333,1),(233,7450551,7450547,'dmi',8.333,1),(233,7450552,7450547,'min',8.333,1),(233,7450553,7450547,'ini',8.333,1),(233,7450554,7450547,'nis',8.333,1),(233,7450555,7450547,'ist',8.333,1),(233,7450556,7450547,'str',8.333,1),(233,7450557,7450547,'tra',8.333,1),(233,7450558,7450547,'rat',8.333,1),(233,7450559,7450547,'ati',8.333,1),(233,7450560,7450547,'tio',8.333,1),(233,7450561,7450547,'ion',8.333,1),(233,7450562,7450550,'sta',33.333,3),(233,7450563,7450550,'tat',33.333,3),(233,7450564,7450550,'ate',33.333,3),(233,7450565,7450562,'ena',20,2),(233,7450566,7450562,'nab',20,2),(233,7450567,7450562,'abl',20,2),(233,7450568,7450562,'ble',20,2),(233,7450569,7450562,'led',20,2),(233,7450570,7450565,'cac',33.333,1),(233,7450571,7450565,'ach',33.333,1),(233,7450572,7450565,'che',33.333,1),(233,7450573,7450570,'mod',50,2),(233,7450574,7450570,'ode',50,2),(233,7450575,7450573,'wri',14.286,2),(233,7450576,7450573,'rit',14.286,2),(233,7450577,7450573,'ite',14.286,2),(233,7450578,7450573,'tet',14.286,2),(233,7450579,7450573,'eth',14.286,2),(233,7450580,7450573,'thr',14.286,2),(233,7450581,7450573,'hru',14.286,2),(233,7450582,7450575,'ope',11.111,2),(233,7450583,7450575,'per',11.111,2),(233,7450584,7450575,'era',11.111,2),(233,7450585,7450575,'rat',11.111,2),(233,7450586,7450575,'ati',11.111,2),(233,7450587,7450575,'tio',11.111,2),(233,7450588,7450575,'ion',11.111,2),(233,7450589,7450575,'ona',11.111,2),(233,7450590,7450575,'nal',11.111,2),(233,7450591,7450582,'nor',25,1),(233,7450592,7450582,'orm',25,1),(233,7450593,7450582,'rma',25,1),(233,7450594,7450582,'mal',25,1),(233,7450595,7450591,'mes',20,1),(233,7450596,7450591,'ess',20,1),(233,7450597,7450591,'ssa',20,1),(233,7450598,7450591,'sag',20,1),(233,7450599,7450591,'age',20,1),(233,7450600,7450595,'per',11.111,1),(233,7450601,7450595,'erf',11.111,1),(233,7450602,7450595,'rfo',11.111,1),(233,7450603,7450595,'for',11.111,1),(233,7450604,7450595,'orm',11.111,1),(233,7450605,7450595,'rma',11.111,1),(233,7450606,7450595,'man',11.111,1),(233,7450607,7450595,'anc',11.111,1),(233,7450608,7450595,'nce',11.111,1),(233,7450609,7450600,'ide',12.5,1),(233,7450610,7450600,'den',12.5,1),(233,7450611,7450600,'ent',12.5,1),(233,7450612,7450600,'nti',12.5,1),(233,7450613,7450600,'tif',12.5,1),(233,7450614,7450600,'ifi',12.5,1),(233,7450615,7450600,'fie',12.5,1),(233,7450616,7450600,'ier',12.5,1),(233,7450617,7450609,'vdi',33.333,3),(233,7450618,7450609,'dis',33.333,3),(233,7450619,7450609,'isk',33.333,3),(233,7450620,7450617,'nam',50,1),(233,7450621,7450617,'ame',50,1),(233,7450622,7450620,'typ',50,1),(233,7450623,7450620,'ype',50,1),(233,7450624,7450622,'dir',25,1),(233,7450625,7450622,'ire',25,1),(233,7450626,7450622,'rec',25,1),(233,7450627,7450622,'ect',25,1),(234,7450629,7450628,'naa',100,2),(234,7450630,7450629,'600',3.333,3),(234,7450631,7450629,'000',3.333,3),(234,7450632,7450629,'00c',3.333,3),(234,7450633,7450629,'0c2',3.333,3),(234,7450634,7450629,'c29',3.333,3),(234,7450635,7450629,'295',3.333,3),(234,7450636,7450629,'953',3.333,3),(234,7450637,7450629,'532',3.333,3),(234,7450638,7450629,'32d',3.333,3),(234,7450639,7450629,'2d9',3.333,3),(234,7450640,7450629,'d9e',3.333,3),(234,7450641,7450629,'9e7',3.333,3),(234,7450642,7450629,'e75',3.333,3),(234,7450643,7450629,'757',3.333,3),(234,7450644,7450629,'575',3.333,3),(234,7450645,7450629,'758',3.333,3),(234,7450646,7450629,'580',3.333,3),(234,7450647,7450629,'806',3.333,3),(234,7450648,7450629,'061',3.333,3),(234,7450649,7450629,'61c',3.333,3),(234,7450650,7450629,'1ca',3.333,3),(234,7450651,7450629,'ca5',3.333,3),(234,7450652,7450629,'a5a',3.333,3),(234,7450653,7450629,'5a9',3.333,3),(234,7450654,7450629,'a90',3.333,3),(234,7450655,7450629,'90c',3.333,3),(234,7450656,7450629,'0c3',3.333,3),(234,7450657,7450629,'c37',3.333,3),(234,7450658,7450629,'374',3.333,3),(234,7450659,7450629,'743',3.333,3),(234,7450660,7450630,'mon',100,1),(234,7450661,7450660,'201',50,1),(234,7450662,7450660,'013',50,1),(234,7450663,7450661,'adm',33.333,3),(234,7450664,7450661,'dmi',33.333,3),(234,7450665,7450661,'min',33.333,3),(234,7450666,7450663,'cap',16.667,1),(234,7450667,7450663,'apa',16.667,1),(234,7450668,7450663,'pac',16.667,1),(234,7450669,7450663,'aci',16.667,1),(234,7450670,7450663,'cit',16.667,1),(234,7450671,7450663,'ity',16.667,1),(234,7450672,7450666,'pat',50,1),(234,7450673,7450666,'ath',50,1),(234,7450674,7450672,'fre',14.286,1),(234,7450675,7450672,'ree',14.286,1),(234,7450676,7450672,'ees',14.286,1),(234,7450677,7450672,'esp',14.286,1),(234,7450678,7450672,'spa',14.286,1),(234,7450679,7450672,'pac',14.286,1),(234,7450680,7450672,'ace',14.286,1),(234,7450681,7450674,'dis',50,1),(234,7450682,7450674,'isk',50,1),(234,7450683,7450681,'ind',33.333,1),(234,7450684,7450681,'nde',33.333,1),(234,7450685,7450681,'dex',33.333,1),(234,7450686,7450683,'adm',8.333,1),(234,7450687,7450683,'dmi',8.333,1),(234,7450688,7450683,'min',8.333,1),(234,7450689,7450683,'ini',8.333,1),(234,7450690,7450683,'nis',8.333,1),(234,7450691,7450683,'ist',8.333,1),(234,7450692,7450683,'str',8.333,1),(234,7450693,7450683,'tra',8.333,1),(234,7450694,7450683,'rat',8.333,1),(234,7450695,7450683,'ati',8.333,1),(234,7450696,7450683,'tio',8.333,1),(234,7450697,7450683,'ion',8.333,1),(234,7450698,7450686,'sta',33.333,3),(234,7450699,7450686,'tat',33.333,3),(234,7450700,7450686,'ate',33.333,3),(234,7450701,7450698,'ena',20,2),(234,7450702,7450698,'nab',20,2),(234,7450703,7450698,'abl',20,2),(234,7450704,7450698,'ble',20,2),(234,7450705,7450698,'led',20,2),(234,7450706,7450701,'cac',33.333,1),(234,7450707,7450701,'ach',33.333,1),(234,7450708,7450701,'che',33.333,1),(234,7450709,7450706,'mod',50,2),(234,7450710,7450706,'ode',50,2),(234,7450711,7450709,'wri',14.286,2),(234,7450712,7450709,'rit',14.286,2),(234,7450713,7450709,'ite',14.286,2),(234,7450714,7450709,'tet',14.286,2),(234,7450715,7450709,'eth',14.286,2),(234,7450716,7450709,'thr',14.286,2),(234,7450717,7450709,'hru',14.286,2),(234,7450718,7450711,'ope',11.111,2),(234,7450719,7450711,'per',11.111,2),(234,7450720,7450711,'era',11.111,2),(234,7450721,7450711,'rat',11.111,2),(234,7450722,7450711,'ati',11.111,2),(234,7450723,7450711,'tio',11.111,2),(234,7450724,7450711,'ion',11.111,2),(234,7450725,7450711,'ona',11.111,2),(234,7450726,7450711,'nal',11.111,2),(234,7450727,7450718,'nor',25,1),(234,7450728,7450718,'orm',25,1),(234,7450729,7450718,'rma',25,1),(234,7450730,7450718,'mal',25,1),(234,7450731,7450727,'mes',20,1),(234,7450732,7450727,'ess',20,1),(234,7450733,7450727,'ssa',20,1),(234,7450734,7450727,'sag',20,1),(234,7450735,7450727,'age',20,1),(234,7450736,7450731,'per',11.111,1),(234,7450737,7450731,'erf',11.111,1),(234,7450738,7450731,'rfo',11.111,1),(234,7450739,7450731,'for',11.111,1),(234,7450740,7450731,'orm',11.111,1),(234,7450741,7450731,'rma',11.111,1),(234,7450742,7450731,'man',11.111,1),(234,7450743,7450731,'anc',11.111,1),(234,7450744,7450731,'nce',11.111,1),(234,7450745,7450736,'ide',12.5,1),(234,7450746,7450736,'den',12.5,1),(234,7450747,7450736,'ent',12.5,1),(234,7450748,7450736,'nti',12.5,1),(234,7450749,7450736,'tif',12.5,1),(234,7450750,7450736,'ifi',12.5,1),(234,7450751,7450736,'fie',12.5,1),(234,7450752,7450736,'ier',12.5,1),(234,7450753,7450745,'vdi',33.333,3),(234,7450754,7450745,'dis',33.333,3),(234,7450755,7450745,'isk',33.333,3),(234,7450756,7450753,'nam',50,1),(234,7450757,7450753,'ame',50,1),(234,7450758,7450756,'typ',50,1),(234,7450759,7450756,'ype',50,1),(234,7450760,7450758,'dir',25,1),(234,7450761,7450758,'ire',25,1),(234,7450762,7450758,'rec',25,1),(234,7450763,7450758,'ect',25,1),(235,7450765,7450764,'naa',100,2),(235,7450766,7450765,'600',3.333,3),(235,7450767,7450765,'000',3.333,3),(235,7450768,7450765,'00c',3.333,3),(235,7450769,7450765,'0c2',3.333,3),(235,7450770,7450765,'c29',3.333,3),(235,7450771,7450765,'290',3.333,3),(235,7450772,7450765,'902',3.333,3),(235,7450773,7450765,'02d',3.333,3),(235,7450774,7450765,'2d5',3.333,3),(235,7450775,7450765,'d5b',3.333,3),(235,7450776,7450765,'5ba',3.333,3),(235,7450777,7450765,'ba8',3.333,3),(235,7450778,7450765,'a8b',3.333,3),(235,7450779,7450765,'8be',3.333,3),(235,7450780,7450765,'be5',3.333,3),(235,7450781,7450765,'e59',3.333,3),(235,7450782,7450765,'596',3.333,3),(235,7450783,7450765,'966',3.333,3),(235,7450784,7450765,'660',3.333,3),(235,7450785,7450765,'605',3.333,3),(235,7450786,7450765,'051',3.333,3),(235,7450787,7450765,'517',3.333,3),(235,7450788,7450765,'177',3.333,3),(235,7450789,7450765,'779',3.333,3),(235,7450790,7450765,'79f',3.333,3),(235,7450791,7450765,'9f7',3.333,3),(235,7450792,7450765,'f73',3.333,3),(235,7450793,7450765,'739',3.333,3),(235,7450794,7450765,'394',3.333,3),(235,7450795,7450765,'945',3.333,3),(235,7450796,7450766,'mon',100,1),(235,7450797,7450796,'201',50,1),(235,7450798,7450796,'013',50,1),(235,7450799,7450797,'adm',33.333,3),(235,7450800,7450797,'dmi',33.333,3),(235,7450801,7450797,'min',33.333,3),(235,7450802,7450799,'cap',16.667,1),(235,7450803,7450799,'apa',16.667,1),(235,7450804,7450799,'pac',16.667,1),(235,7450805,7450799,'aci',16.667,1),(235,7450806,7450799,'cit',16.667,1),(235,7450807,7450799,'ity',16.667,1),(235,7450808,7450802,'pat',50,1),(235,7450809,7450802,'ath',50,1),(235,7450810,7450808,'fre',14.286,1),(235,7450811,7450808,'ree',14.286,1),(235,7450812,7450808,'ees',14.286,1),(235,7450813,7450808,'esp',14.286,1),(235,7450814,7450808,'spa',14.286,1),(235,7450815,7450808,'pac',14.286,1),(235,7450816,7450808,'ace',14.286,1),(235,7450817,7450810,'dis',50,1),(235,7450818,7450810,'isk',50,1),(235,7450819,7450817,'ind',33.333,1),(235,7450820,7450817,'nde',33.333,1),(235,7450821,7450817,'dex',33.333,1),(235,7450822,7450819,'adm',8.333,1),(235,7450823,7450819,'dmi',8.333,1),(235,7450824,7450819,'min',8.333,1),(235,7450825,7450819,'ini',8.333,1),(235,7450826,7450819,'nis',8.333,1),(235,7450827,7450819,'ist',8.333,1),(235,7450828,7450819,'str',8.333,1),(235,7450829,7450819,'tra',8.333,1),(235,7450830,7450819,'rat',8.333,1),(235,7450831,7450819,'ati',8.333,1),(235,7450832,7450819,'tio',8.333,1),(235,7450833,7450819,'ion',8.333,1),(235,7450834,7450822,'sta',33.333,3),(235,7450835,7450822,'tat',33.333,3),(235,7450836,7450822,'ate',33.333,3),(235,7450837,7450834,'ena',20,2),(235,7450838,7450834,'nab',20,2),(235,7450839,7450834,'abl',20,2),(235,7450840,7450834,'ble',20,2),(235,7450841,7450834,'led',20,2),(235,7450842,7450837,'cac',33.333,1),(235,7450843,7450837,'ach',33.333,1),(235,7450844,7450837,'che',33.333,1),(235,7450845,7450842,'mod',50,2),(235,7450846,7450842,'ode',50,2),(235,7450847,7450845,'wri',14.286,2),(235,7450848,7450845,'rit',14.286,2),(235,7450849,7450845,'ite',14.286,2),(235,7450850,7450845,'tet',14.286,2),(235,7450851,7450845,'eth',14.286,2),(235,7450852,7450845,'thr',14.286,2),(235,7450853,7450845,'hru',14.286,2),(235,7450854,7450847,'ope',11.111,2),(235,7450855,7450847,'per',11.111,2),(235,7450856,7450847,'era',11.111,2),(235,7450857,7450847,'rat',11.111,2),(235,7450858,7450847,'ati',11.111,2),(235,7450859,7450847,'tio',11.111,2),(235,7450860,7450847,'ion',11.111,2),(235,7450861,7450847,'ona',11.111,2),(235,7450862,7450847,'nal',11.111,2),(235,7450863,7450854,'nor',25,1),(235,7450864,7450854,'orm',25,1),(235,7450865,7450854,'rma',25,1),(235,7450866,7450854,'mal',25,1),(235,7450867,7450863,'mes',20,1),(235,7450868,7450863,'ess',20,1),(235,7450869,7450863,'ssa',20,1),(235,7450870,7450863,'sag',20,1),(235,7450871,7450863,'age',20,1),(235,7450872,7450867,'per',11.111,1),(235,7450873,7450867,'erf',11.111,1),(235,7450874,7450867,'rfo',11.111,1),(235,7450875,7450867,'for',11.111,1),(235,7450876,7450867,'orm',11.111,1),(235,7450877,7450867,'rma',11.111,1),(235,7450878,7450867,'man',11.111,1),(235,7450879,7450867,'anc',11.111,1),(235,7450880,7450867,'nce',11.111,1),(235,7450881,7450872,'ide',12.5,1),(235,7450882,7450872,'den',12.5,1),(235,7450883,7450872,'ent',12.5,1),(235,7450884,7450872,'nti',12.5,1),(235,7450885,7450872,'tif',12.5,1),(235,7450886,7450872,'ifi',12.5,1),(235,7450887,7450872,'fie',12.5,1),(235,7450888,7450872,'ier',12.5,1),(235,7450889,7450881,'vdi',33.333,3),(235,7450890,7450881,'dis',33.333,3),(235,7450891,7450881,'isk',33.333,3),(235,7450892,7450889,'nam',50,1),(235,7450893,7450889,'ame',50,1),(235,7450894,7450892,'typ',50,1),(235,7450895,7450892,'ype',50,1),(235,7450896,7450894,'dir',25,1),(235,7450897,7450894,'ire',25,1),(235,7450898,7450894,'rec',25,1),(235,7450899,7450894,'ect',25,1),(236,7450901,7450900,'naa',100,2),(236,7450902,7450901,'600',3.333,3),(236,7450903,7450901,'000',3.333,3),(236,7450904,7450901,'00c',3.333,3),(236,7450905,7450901,'0c2',3.333,3),(236,7450906,7450901,'c29',3.333,3),(236,7450907,7450901,'293',3.333,3),(236,7450908,7450901,'93d',3.333,3),(236,7450909,7450901,'3d2',3.333,3),(236,7450910,7450901,'d27',3.333,3),(236,7450911,7450901,'272',3.333,3),(236,7450912,7450901,'725',3.333,3),(236,7450913,7450901,'251',3.333,3),(236,7450914,7450901,'51a',3.333,3),(236,7450915,7450901,'1a8',3.333,3),(236,7450916,7450901,'a8a',3.333,3),(236,7450917,7450901,'8a3',3.333,3),(236,7450918,7450901,'a3f',3.333,3),(236,7450919,7450901,'3f1',3.333,3),(236,7450920,7450901,'f12',3.333,3),(236,7450921,7450901,'12a',3.333,3),(236,7450922,7450901,'2ac',3.333,3),(236,7450923,7450901,'acc',3.333,3),(236,7450924,7450901,'ccf',3.333,3),(236,7450925,7450901,'cfb',3.333,3),(236,7450926,7450901,'fb9',3.333,3),(236,7450927,7450901,'b90',3.333,3),(236,7450928,7450901,'90b',3.333,3),(236,7450929,7450901,'0bf',3.333,3),(236,7450930,7450901,'bfc',3.333,3),(236,7450931,7450901,'fc3',3.333,3),(236,7450932,7450902,'mon',100,1),(236,7450933,7450932,'201',50,1),(236,7450934,7450932,'013',50,1),(236,7450935,7450933,'adm',33.333,3),(236,7450936,7450933,'dmi',33.333,3),(236,7450937,7450933,'min',33.333,3),(236,7450938,7450935,'cap',16.667,1),(236,7450939,7450935,'apa',16.667,1),(236,7450940,7450935,'pac',16.667,1),(236,7450941,7450935,'aci',16.667,1),(236,7450942,7450935,'cit',16.667,1),(236,7450943,7450935,'ity',16.667,1),(236,7450944,7450938,'pat',50,1),(236,7450945,7450938,'ath',50,1),(236,7450946,7450944,'fre',14.286,1),(236,7450947,7450944,'ree',14.286,1),(236,7450948,7450944,'ees',14.286,1),(236,7450949,7450944,'esp',14.286,1),(236,7450950,7450944,'spa',14.286,1),(236,7450951,7450944,'pac',14.286,1),(236,7450952,7450944,'ace',14.286,1),(236,7450953,7450946,'dis',50,1),(236,7450954,7450946,'isk',50,1),(236,7450955,7450953,'ind',33.333,1),(236,7450956,7450953,'nde',33.333,1),(236,7450957,7450953,'dex',33.333,1),(236,7450958,7450955,'adm',8.333,1),(236,7450959,7450955,'dmi',8.333,1),(236,7450960,7450955,'min',8.333,1),(236,7450961,7450955,'ini',8.333,1),(236,7450962,7450955,'nis',8.333,1),(236,7450963,7450955,'ist',8.333,1),(236,7450964,7450955,'str',8.333,1),(236,7450965,7450955,'tra',8.333,1),(236,7450966,7450955,'rat',8.333,1),(236,7450967,7450955,'ati',8.333,1),(236,7450968,7450955,'tio',8.333,1),(236,7450969,7450955,'ion',8.333,1),(236,7450970,7450958,'sta',33.333,3),(236,7450971,7450958,'tat',33.333,3),(236,7450972,7450958,'ate',33.333,3),(236,7450973,7450970,'ena',20,2),(236,7450974,7450970,'nab',20,2),(236,7450975,7450970,'abl',20,2),(236,7450976,7450970,'ble',20,2),(236,7450977,7450970,'led',20,2),(236,7450978,7450973,'cac',33.333,1),(236,7450979,7450973,'ach',33.333,1),(236,7450980,7450973,'che',33.333,1),(236,7450981,7450978,'mod',50,2),(236,7450982,7450978,'ode',50,2),(236,7450983,7450981,'wri',14.286,2),(236,7450984,7450981,'rit',14.286,2),(236,7450985,7450981,'ite',14.286,2),(236,7450986,7450981,'tet',14.286,2),(236,7450987,7450981,'eth',14.286,2),(236,7450988,7450981,'thr',14.286,2),(236,7450989,7450981,'hru',14.286,2),(236,7450990,7450983,'ope',11.111,2),(236,7450991,7450983,'per',11.111,2),(236,7450992,7450983,'era',11.111,2),(236,7450993,7450983,'rat',11.111,2),(236,7450994,7450983,'ati',11.111,2),(236,7450995,7450983,'tio',11.111,2),(236,7450996,7450983,'ion',11.111,2),(236,7450997,7450983,'ona',11.111,2),(236,7450998,7450983,'nal',11.111,2),(236,7450999,7450990,'nor',25,1),(236,7451000,7450990,'orm',25,1),(236,7451001,7450990,'rma',25,1),(236,7451002,7450990,'mal',25,1),(236,7451003,7450999,'mes',20,1),(236,7451004,7450999,'ess',20,1),(236,7451005,7450999,'ssa',20,1),(236,7451006,7450999,'sag',20,1),(236,7451007,7450999,'age',20,1),(236,7451008,7451003,'per',11.111,1),(236,7451009,7451003,'erf',11.111,1),(236,7451010,7451003,'rfo',11.111,1),(236,7451011,7451003,'for',11.111,1),(236,7451012,7451003,'orm',11.111,1),(236,7451013,7451003,'rma',11.111,1),(236,7451014,7451003,'man',11.111,1),(236,7451015,7451003,'anc',11.111,1),(236,7451016,7451003,'nce',11.111,1),(236,7451017,7451008,'ide',12.5,1),(236,7451018,7451008,'den',12.5,1),(236,7451019,7451008,'ent',12.5,1),(236,7451020,7451008,'nti',12.5,1),(236,7451021,7451008,'tif',12.5,1),(236,7451022,7451008,'ifi',12.5,1),(236,7451023,7451008,'fie',12.5,1),(236,7451024,7451008,'ier',12.5,1),(236,7451025,7451017,'vdi',33.333,3),(236,7451026,7451017,'dis',33.333,3),(236,7451027,7451017,'isk',33.333,3),(236,7451028,7451025,'nam',50,1),(236,7451029,7451025,'ame',50,1),(236,7451030,7451028,'typ',50,1),(236,7451031,7451028,'ype',50,1),(236,7451032,7451030,'dir',25,1),(236,7451033,7451030,'ire',25,1),(236,7451034,7451030,'rec',25,1),(236,7451035,7451030,'ect',25,1),(237,7451037,7451036,'naa',100,2),(237,7451038,7451037,'600',3.333,3),(237,7451039,7451037,'000',3.333,3),(237,7451040,7451037,'00c',3.333,3),(237,7451041,7451037,'0c2',3.333,3),(237,7451042,7451037,'c29',3.333,3),(237,7451043,7451037,'29a',3.333,3),(237,7451044,7451037,'9a2',3.333,3),(237,7451045,7451037,'a2e',3.333,3),(237,7451046,7451037,'2ed',3.333,3),(237,7451047,7451037,'eda',3.333,3),(237,7451048,7451037,'dac',3.333,3),(237,7451049,7451037,'ac2',3.333,3),(237,7451050,7451037,'c2d',3.333,3),(237,7451051,7451037,'2d4',3.333,3),(237,7451052,7451037,'d4e',3.333,3),(237,7451053,7451037,'4e7',3.333,3),(237,7451054,7451037,'e7c',3.333,3),(237,7451055,7451037,'7c2',3.333,3),(237,7451056,7451037,'c2f',3.333,3),(237,7451057,7451037,'2f0',3.333,3),(237,7451058,7451037,'f01',3.333,3),(237,7451059,7451037,'015',3.333,3),(237,7451060,7451037,'15c',3.333,3),(237,7451061,7451037,'5ce',3.333,3),(237,7451062,7451037,'ced',3.333,3),(237,7451063,7451037,'ed5',3.333,3),(237,7451064,7451037,'d57',3.333,3),(237,7451065,7451037,'57b',3.333,3),(237,7451066,7451037,'7b6',3.333,3),(237,7451067,7451037,'b68',3.333,3),(237,7451068,7451038,'mon',100,1),(237,7451069,7451068,'201',50,1),(237,7451070,7451068,'013',50,1),(237,7451071,7451069,'adm',33.333,3),(237,7451072,7451069,'dmi',33.333,3),(237,7451073,7451069,'min',33.333,3),(237,7451074,7451071,'cap',16.667,1),(237,7451075,7451071,'apa',16.667,1),(237,7451076,7451071,'pac',16.667,1),(237,7451077,7451071,'aci',16.667,1),(237,7451078,7451071,'cit',16.667,1),(237,7451079,7451071,'ity',16.667,1),(237,7451080,7451074,'pat',50,1),(237,7451081,7451074,'ath',50,1),(237,7451082,7451080,'fre',14.286,1),(237,7451083,7451080,'ree',14.286,1),(237,7451084,7451080,'ees',14.286,1),(237,7451085,7451080,'esp',14.286,1),(237,7451086,7451080,'spa',14.286,1),(237,7451087,7451080,'pac',14.286,1),(237,7451088,7451080,'ace',14.286,1),(237,7451089,7451082,'dis',50,1),(237,7451090,7451082,'isk',50,1),(237,7451091,7451089,'ind',33.333,1),(237,7451092,7451089,'nde',33.333,1),(237,7451093,7451089,'dex',33.333,1),(237,7451094,7451091,'adm',8.333,1),(237,7451095,7451091,'dmi',8.333,1),(237,7451096,7451091,'min',8.333,1),(237,7451097,7451091,'ini',8.333,1),(237,7451098,7451091,'nis',8.333,1),(237,7451099,7451091,'ist',8.333,1),(237,7451100,7451091,'str',8.333,1),(237,7451101,7451091,'tra',8.333,1),(237,7451102,7451091,'rat',8.333,1),(237,7451103,7451091,'ati',8.333,1),(237,7451104,7451091,'tio',8.333,1),(237,7451105,7451091,'ion',8.333,1),(237,7451106,7451094,'sta',33.333,3),(237,7451107,7451094,'tat',33.333,3),(237,7451108,7451094,'ate',33.333,3),(237,7451109,7451106,'ena',20,2),(237,7451110,7451106,'nab',20,2),(237,7451111,7451106,'abl',20,2),(237,7451112,7451106,'ble',20,2),(237,7451113,7451106,'led',20,2),(237,7451114,7451109,'cac',33.333,1),(237,7451115,7451109,'ach',33.333,1),(237,7451116,7451109,'che',33.333,1),(237,7451117,7451114,'mod',50,2),(237,7451118,7451114,'ode',50,2),(237,7451119,7451117,'wri',14.286,2),(237,7451120,7451117,'rit',14.286,2),(237,7451121,7451117,'ite',14.286,2),(237,7451122,7451117,'tet',14.286,2),(237,7451123,7451117,'eth',14.286,2),(237,7451124,7451117,'thr',14.286,2),(237,7451125,7451117,'hru',14.286,2),(237,7451126,7451119,'ope',11.111,2),(237,7451127,7451119,'per',11.111,2),(237,7451128,7451119,'era',11.111,2),(237,7451129,7451119,'rat',11.111,2),(237,7451130,7451119,'ati',11.111,2),(237,7451131,7451119,'tio',11.111,2),(237,7451132,7451119,'ion',11.111,2),(237,7451133,7451119,'ona',11.111,2),(237,7451134,7451119,'nal',11.111,2),(237,7451135,7451126,'nor',25,1),(237,7451136,7451126,'orm',25,1),(237,7451137,7451126,'rma',25,1),(237,7451138,7451126,'mal',25,1),(237,7451139,7451135,'mes',20,1),(237,7451140,7451135,'ess',20,1),(237,7451141,7451135,'ssa',20,1),(237,7451142,7451135,'sag',20,1),(237,7451143,7451135,'age',20,1),(237,7451144,7451139,'per',11.111,1),(237,7451145,7451139,'erf',11.111,1),(237,7451146,7451139,'rfo',11.111,1),(237,7451147,7451139,'for',11.111,1),(237,7451148,7451139,'orm',11.111,1),(237,7451149,7451139,'rma',11.111,1),(237,7451150,7451139,'man',11.111,1),(237,7451151,7451139,'anc',11.111,1),(237,7451152,7451139,'nce',11.111,1),(237,7451153,7451144,'ide',12.5,1),(237,7451154,7451144,'den',12.5,1),(237,7451155,7451144,'ent',12.5,1),(237,7451156,7451144,'nti',12.5,1),(237,7451157,7451144,'tif',12.5,1),(237,7451158,7451144,'ifi',12.5,1),(237,7451159,7451144,'fie',12.5,1),(237,7451160,7451144,'ier',12.5,1),(237,7451161,7451153,'vdi',33.333,3),(237,7451162,7451153,'dis',33.333,3),(237,7451163,7451153,'isk',33.333,3),(237,7451164,7451161,'nam',50,1),(237,7451165,7451161,'ame',50,1),(237,7451166,7451164,'typ',50,1),(237,7451167,7451164,'ype',50,1),(237,7451168,7451166,'dir',25,1),(237,7451169,7451166,'ire',25,1),(237,7451170,7451166,'rec',25,1),(237,7451171,7451166,'ect',25,1),(238,7451173,7451172,'naa',100,2),(238,7451174,7451173,'600',3.333,3),(238,7451175,7451173,'000',3.333,3),(238,7451176,7451173,'00c',3.333,3),(238,7451177,7451173,'0c2',3.333,3),(238,7451178,7451173,'c29',3.333,3),(238,7451179,7451173,'29d',3.333,3),(238,7451180,7451173,'9dc',3.333,3),(238,7451181,7451173,'dc6',3.333,3),(238,7451182,7451173,'c66',3.333,3),(238,7451183,7451173,'66f',3.333,3),(238,7451184,7451173,'6f1',3.333,3),(238,7451185,7451173,'f18',3.333,3),(238,7451186,7451173,'186',3.333,3),(238,7451187,7451173,'867',3.333,3),(238,7451188,7451173,'679',3.333,3),(238,7451189,7451173,'790',3.333,3),(238,7451190,7451173,'90f',3.333,3),(238,7451191,7451173,'0f6',3.333,3),(238,7451192,7451173,'f6c',3.333,3),(238,7451193,7451173,'6c6',3.333,3),(238,7451194,7451173,'c65',3.333,3),(238,7451195,7451173,'654',3.333,3),(238,7451196,7451173,'544',3.333,3),(238,7451197,7451173,'449',3.333,3),(238,7451198,7451173,'494',3.333,3),(238,7451199,7451173,'94f',3.333,3),(238,7451200,7451173,'4fe',3.333,3),(238,7451201,7451173,'feb',3.333,3),(238,7451202,7451173,'eb0',3.333,3),(238,7451203,7451173,'b0f',3.333,3),(238,7451204,7451174,'mon',100,1),(238,7451205,7451204,'201',50,1),(238,7451206,7451204,'013',50,1),(238,7451207,7451205,'adm',33.333,3),(238,7451208,7451205,'dmi',33.333,3),(238,7451209,7451205,'min',33.333,3),(238,7451210,7451207,'cap',16.667,1),(238,7451211,7451207,'apa',16.667,1),(238,7451212,7451207,'pac',16.667,1),(238,7451213,7451207,'aci',16.667,1),(238,7451214,7451207,'cit',16.667,1),(238,7451215,7451207,'ity',16.667,1),(238,7451216,7451210,'pat',50,1),(238,7451217,7451210,'ath',50,1),(238,7451218,7451216,'fre',14.286,1),(238,7451219,7451216,'ree',14.286,1),(238,7451220,7451216,'ees',14.286,1),(238,7451221,7451216,'esp',14.286,1),(238,7451222,7451216,'spa',14.286,1),(238,7451223,7451216,'pac',14.286,1),(238,7451224,7451216,'ace',14.286,1),(238,7451225,7451218,'dis',50,1),(238,7451226,7451218,'isk',50,1),(238,7451227,7451225,'ind',33.333,1),(238,7451228,7451225,'nde',33.333,1),(238,7451229,7451225,'dex',33.333,1),(238,7451230,7451227,'adm',8.333,1),(238,7451231,7451227,'dmi',8.333,1),(238,7451232,7451227,'min',8.333,1),(238,7451233,7451227,'ini',8.333,1),(238,7451234,7451227,'nis',8.333,1),(238,7451235,7451227,'ist',8.333,1),(238,7451236,7451227,'str',8.333,1),(238,7451237,7451227,'tra',8.333,1),(238,7451238,7451227,'rat',8.333,1),(238,7451239,7451227,'ati',8.333,1),(238,7451240,7451227,'tio',8.333,1),(238,7451241,7451227,'ion',8.333,1),(238,7451242,7451230,'sta',33.333,3),(238,7451243,7451230,'tat',33.333,3),(238,7451244,7451230,'ate',33.333,3),(238,7451245,7451242,'ena',20,2),(238,7451246,7451242,'nab',20,2),(238,7451247,7451242,'abl',20,2),(238,7451248,7451242,'ble',20,2),(238,7451249,7451242,'led',20,2),(238,7451250,7451245,'cac',33.333,1),(238,7451251,7451245,'ach',33.333,1),(238,7451252,7451245,'che',33.333,1),(238,7451253,7451250,'mod',50,2),(238,7451254,7451250,'ode',50,2),(238,7451255,7451253,'wri',14.286,2),(238,7451256,7451253,'rit',14.286,2),(238,7451257,7451253,'ite',14.286,2),(238,7451258,7451253,'tet',14.286,2),(238,7451259,7451253,'eth',14.286,2),(238,7451260,7451253,'thr',14.286,2),(238,7451261,7451253,'hru',14.286,2),(238,7451262,7451255,'ope',11.111,2),(238,7451263,7451255,'per',11.111,2),(238,7451264,7451255,'era',11.111,2),(238,7451265,7451255,'rat',11.111,2),(238,7451266,7451255,'ati',11.111,2),(238,7451267,7451255,'tio',11.111,2),(238,7451268,7451255,'ion',11.111,2),(238,7451269,7451255,'ona',11.111,2),(238,7451270,7451255,'nal',11.111,2),(238,7451271,7451262,'nor',25,1),(238,7451272,7451262,'orm',25,1),(238,7451273,7451262,'rma',25,1),(238,7451274,7451262,'mal',25,1),(238,7451275,7451271,'mes',20,1),(238,7451276,7451271,'ess',20,1),(238,7451277,7451271,'ssa',20,1),(238,7451278,7451271,'sag',20,1),(238,7451279,7451271,'age',20,1),(238,7451280,7451275,'per',11.111,1),(238,7451281,7451275,'erf',11.111,1),(238,7451282,7451275,'rfo',11.111,1),(238,7451283,7451275,'for',11.111,1),(238,7451284,7451275,'orm',11.111,1),(238,7451285,7451275,'rma',11.111,1),(238,7451286,7451275,'man',11.111,1),(238,7451287,7451275,'anc',11.111,1),(238,7451288,7451275,'nce',11.111,1),(238,7451289,7451280,'ide',12.5,1),(238,7451290,7451280,'den',12.5,1),(238,7451291,7451280,'ent',12.5,1),(238,7451292,7451280,'nti',12.5,1),(238,7451293,7451280,'tif',12.5,1),(238,7451294,7451280,'ifi',12.5,1),(238,7451295,7451280,'fie',12.5,1),(238,7451296,7451280,'ier',12.5,1),(238,7451297,7451289,'vdi',33.333,3),(238,7451298,7451289,'dis',33.333,3),(238,7451299,7451289,'isk',33.333,3),(238,7451300,7451297,'nam',50,1),(238,7451301,7451297,'ame',50,1),(238,7451302,7451300,'typ',50,1),(238,7451303,7451300,'ype',50,1),(238,7451304,7451302,'dir',25,1),(238,7451305,7451302,'ire',25,1),(238,7451306,7451302,'rec',25,1),(238,7451307,7451302,'ect',25,1),(239,7451309,7451308,'naa',100,2),(239,7451310,7451309,'600',3.333,3),(239,7451311,7451309,'000',3.333,3),(239,7451312,7451309,'00c',3.333,3),(239,7451313,7451309,'0c2',3.333,3),(239,7451314,7451309,'c29',3.333,3),(239,7451315,7451309,'298',3.333,3),(239,7451316,7451309,'983',3.333,3),(239,7451317,7451309,'83a',3.333,3),(239,7451318,7451309,'3a5',3.333,3),(239,7451319,7451309,'a52',3.333,3),(239,7451320,7451309,'528',3.333,3),(239,7451321,7451309,'286',3.333,3),(239,7451322,7451309,'862',3.333,3),(239,7451323,7451309,'624',3.333,3),(239,7451324,7451309,'249',3.333,3),(239,7451325,7451309,'49c',3.333,3),(239,7451326,7451309,'9c3',3.333,3),(239,7451327,7451309,'c37',3.333,3),(239,7451328,7451309,'37e',3.333,3),(239,7451329,7451309,'7e5',3.333,3),(239,7451330,7451309,'e5d',3.333,3),(239,7451331,7451309,'5d0',3.333,3),(239,7451332,7451309,'d02',3.333,3),(239,7451333,7451309,'021',3.333,3),(239,7451334,7451309,'219',3.333,3),(239,7451335,7451309,'190',3.333,3),(239,7451336,7451309,'904',3.333,3),(239,7451337,7451309,'04a',3.333,3),(239,7451338,7451309,'4aa',3.333,3),(239,7451339,7451309,'aaa',3.333,3),(239,7451340,7451310,'mon',100,1),(239,7451341,7451340,'201',50,1),(239,7451342,7451340,'013',50,1),(239,7451343,7451341,'adm',33.333,3),(239,7451344,7451341,'dmi',33.333,3),(239,7451345,7451341,'min',33.333,3),(239,7451346,7451343,'cap',16.667,1),(239,7451347,7451343,'apa',16.667,1),(239,7451348,7451343,'pac',16.667,1),(239,7451349,7451343,'aci',16.667,1),(239,7451350,7451343,'cit',16.667,1),(239,7451351,7451343,'ity',16.667,1),(239,7451352,7451346,'pat',50,1),(239,7451353,7451346,'ath',50,1),(239,7451354,7451352,'fre',14.286,1),(239,7451355,7451352,'ree',14.286,1),(239,7451356,7451352,'ees',14.286,1),(239,7451357,7451352,'esp',14.286,1),(239,7451358,7451352,'spa',14.286,1),(239,7451359,7451352,'pac',14.286,1),(239,7451360,7451352,'ace',14.286,1),(239,7451361,7451354,'dis',50,1),(239,7451362,7451354,'isk',50,1),(239,7451363,7451361,'ind',33.333,1),(239,7451364,7451361,'nde',33.333,1),(239,7451365,7451361,'dex',33.333,1),(239,7451366,7451363,'adm',8.333,1),(239,7451367,7451363,'dmi',8.333,1),(239,7451368,7451363,'min',8.333,1),(239,7451369,7451363,'ini',8.333,1),(239,7451370,7451363,'nis',8.333,1),(239,7451371,7451363,'ist',8.333,1),(239,7451372,7451363,'str',8.333,1),(239,7451373,7451363,'tra',8.333,1),(239,7451374,7451363,'rat',8.333,1),(239,7451375,7451363,'ati',8.333,1),(239,7451376,7451363,'tio',8.333,1),(239,7451377,7451363,'ion',8.333,1),(239,7451378,7451366,'sta',33.333,3),(239,7451379,7451366,'tat',33.333,3),(239,7451380,7451366,'ate',33.333,3),(239,7451381,7451378,'ena',20,2),(239,7451382,7451378,'nab',20,2),(239,7451383,7451378,'abl',20,2),(239,7451384,7451378,'ble',20,2),(239,7451385,7451378,'led',20,2),(239,7451386,7451381,'cac',33.333,1),(239,7451387,7451381,'ach',33.333,1),(239,7451388,7451381,'che',33.333,1),(239,7451389,7451386,'mod',50,2),(239,7451390,7451386,'ode',50,2),(239,7451391,7451389,'wri',14.286,2),(239,7451392,7451389,'rit',14.286,2),(239,7451393,7451389,'ite',14.286,2),(239,7451394,7451389,'tet',14.286,2),(239,7451395,7451389,'eth',14.286,2),(239,7451396,7451389,'thr',14.286,2),(239,7451397,7451389,'hru',14.286,2),(239,7451398,7451391,'ope',11.111,2),(239,7451399,7451391,'per',11.111,2),(239,7451400,7451391,'era',11.111,2),(239,7451401,7451391,'rat',11.111,2),(239,7451402,7451391,'ati',11.111,2),(239,7451403,7451391,'tio',11.111,2),(239,7451404,7451391,'ion',11.111,2),(239,7451405,7451391,'ona',11.111,2),(239,7451406,7451391,'nal',11.111,2),(239,7451407,7451398,'nor',25,1),(239,7451408,7451398,'orm',25,1),(239,7451409,7451398,'rma',25,1),(239,7451410,7451398,'mal',25,1),(239,7451411,7451407,'mes',20,1),(239,7451412,7451407,'ess',20,1),(239,7451413,7451407,'ssa',20,1),(239,7451414,7451407,'sag',20,1),(239,7451415,7451407,'age',20,1),(239,7451416,7451411,'per',11.111,1),(239,7451417,7451411,'erf',11.111,1),(239,7451418,7451411,'rfo',11.111,1),(239,7451419,7451411,'for',11.111,1),(239,7451420,7451411,'orm',11.111,1),(239,7451421,7451411,'rma',11.111,1),(239,7451422,7451411,'man',11.111,1),(239,7451423,7451411,'anc',11.111,1),(239,7451424,7451411,'nce',11.111,1),(239,7451425,7451416,'ide',12.5,1),(239,7451426,7451416,'den',12.5,1),(239,7451427,7451416,'ent',12.5,1),(239,7451428,7451416,'nti',12.5,1),(239,7451429,7451416,'tif',12.5,1),(239,7451430,7451416,'ifi',12.5,1),(239,7451431,7451416,'fie',12.5,1),(239,7451432,7451416,'ier',12.5,1),(239,7451433,7451425,'vdi',33.333,3),(239,7451434,7451425,'dis',33.333,3),(239,7451435,7451425,'isk',33.333,3),(239,7451436,7451433,'nam',50,1),(239,7451437,7451433,'ame',50,1),(239,7451438,7451436,'typ',50,1),(239,7451439,7451436,'ype',50,1),(239,7451440,7451438,'dir',25,1),(239,7451441,7451438,'ire',25,1),(239,7451442,7451438,'rec',25,1),(239,7451443,7451438,'ect',25,1),(240,7451445,7451444,'naa',100,2),(240,7451446,7451445,'600',3.333,3),(240,7451447,7451445,'000',3.333,3),(240,7451448,7451445,'00c',3.333,3),(240,7451449,7451445,'0c2',3.333,3),(240,7451450,7451445,'c29',3.333,3),(240,7451451,7451445,'294',3.333,3),(240,7451452,7451445,'94e',3.333,3),(240,7451453,7451445,'4e3',3.333,3),(240,7451454,7451445,'e3b',3.333,3),(240,7451455,7451445,'3b5',3.333,3),(240,7451456,7451445,'b59',3.333,3),(240,7451457,7451445,'594',3.333,3),(240,7451458,7451445,'94e',3.333,3),(240,7451459,7451445,'4ec',3.333,3),(240,7451460,7451445,'ec7',3.333,3),(240,7451461,7451445,'c72',3.333,3),(240,7451462,7451445,'724',3.333,3),(240,7451463,7451445,'24e',3.333,3),(240,7451464,7451445,'4e3',3.333,3),(240,7451465,7451445,'e3a',3.333,3),(240,7451466,7451445,'3a4',3.333,3),(240,7451467,7451445,'a4d',3.333,3),(240,7451468,7451445,'4db',3.333,3),(240,7451469,7451445,'db1',3.333,3),(240,7451470,7451445,'b1a',3.333,3),(240,7451471,7451445,'1a4',3.333,3),(240,7451472,7451445,'a45',3.333,3),(240,7451473,7451445,'451',3.333,3),(240,7451474,7451445,'516',3.333,3),(240,7451475,7451445,'16c',3.333,3),(240,7451476,7451446,'mon',100,1),(240,7451477,7451476,'201',50,1),(240,7451478,7451476,'013',50,1),(240,7451479,7451477,'adm',33.333,3),(240,7451480,7451477,'dmi',33.333,3),(240,7451481,7451477,'min',33.333,3),(240,7451482,7451479,'cap',16.667,1),(240,7451483,7451479,'apa',16.667,1),(240,7451484,7451479,'pac',16.667,1),(240,7451485,7451479,'aci',16.667,1),(240,7451486,7451479,'cit',16.667,1),(240,7451487,7451479,'ity',16.667,1),(240,7451488,7451482,'pat',50,1),(240,7451489,7451482,'ath',50,1),(240,7451490,7451488,'fre',14.286,1),(240,7451491,7451488,'ree',14.286,1),(240,7451492,7451488,'ees',14.286,1),(240,7451493,7451488,'esp',14.286,1),(240,7451494,7451488,'spa',14.286,1),(240,7451495,7451488,'pac',14.286,1),(240,7451496,7451488,'ace',14.286,1),(240,7451497,7451490,'dis',50,1),(240,7451498,7451490,'isk',50,1),(240,7451499,7451497,'ind',33.333,1),(240,7451500,7451497,'nde',33.333,1),(240,7451501,7451497,'dex',33.333,1),(240,7451502,7451499,'adm',8.333,1),(240,7451503,7451499,'dmi',8.333,1),(240,7451504,7451499,'min',8.333,1),(240,7451505,7451499,'ini',8.333,1),(240,7451506,7451499,'nis',8.333,1),(240,7451507,7451499,'ist',8.333,1),(240,7451508,7451499,'str',8.333,1),(240,7451509,7451499,'tra',8.333,1),(240,7451510,7451499,'rat',8.333,1),(240,7451511,7451499,'ati',8.333,1),(240,7451512,7451499,'tio',8.333,1),(240,7451513,7451499,'ion',8.333,1),(240,7451514,7451502,'sta',33.333,3),(240,7451515,7451502,'tat',33.333,3),(240,7451516,7451502,'ate',33.333,3),(240,7451517,7451514,'ena',20,2),(240,7451518,7451514,'nab',20,2),(240,7451519,7451514,'abl',20,2),(240,7451520,7451514,'ble',20,2),(240,7451521,7451514,'led',20,2),(240,7451522,7451517,'cac',33.333,1),(240,7451523,7451517,'ach',33.333,1),(240,7451524,7451517,'che',33.333,1),(240,7451525,7451522,'mod',50,2),(240,7451526,7451522,'ode',50,2),(240,7451527,7451525,'wri',14.286,2),(240,7451528,7451525,'rit',14.286,2),(240,7451529,7451525,'ite',14.286,2),(240,7451530,7451525,'tet',14.286,2),(240,7451531,7451525,'eth',14.286,2),(240,7451532,7451525,'thr',14.286,2),(240,7451533,7451525,'hru',14.286,2),(240,7451534,7451527,'ope',11.111,2),(240,7451535,7451527,'per',11.111,2),(240,7451536,7451527,'era',11.111,2),(240,7451537,7451527,'rat',11.111,2),(240,7451538,7451527,'ati',11.111,2),(240,7451539,7451527,'tio',11.111,2),(240,7451540,7451527,'ion',11.111,2),(240,7451541,7451527,'ona',11.111,2),(240,7451542,7451527,'nal',11.111,2),(240,7451543,7451534,'nor',25,1),(240,7451544,7451534,'orm',25,1),(240,7451545,7451534,'rma',25,1),(240,7451546,7451534,'mal',25,1),(240,7451547,7451543,'mes',20,1),(240,7451548,7451543,'ess',20,1),(240,7451549,7451543,'ssa',20,1),(240,7451550,7451543,'sag',20,1),(240,7451551,7451543,'age',20,1),(240,7451552,7451547,'per',11.111,1),(240,7451553,7451547,'erf',11.111,1),(240,7451554,7451547,'rfo',11.111,1),(240,7451555,7451547,'for',11.111,1),(240,7451556,7451547,'orm',11.111,1),(240,7451557,7451547,'rma',11.111,1),(240,7451558,7451547,'man',11.111,1),(240,7451559,7451547,'anc',11.111,1),(240,7451560,7451547,'nce',11.111,1),(240,7451561,7451552,'ide',12.5,1),(240,7451562,7451552,'den',12.5,1),(240,7451563,7451552,'ent',12.5,1),(240,7451564,7451552,'nti',12.5,1),(240,7451565,7451552,'tif',12.5,1),(240,7451566,7451552,'ifi',12.5,1),(240,7451567,7451552,'fie',12.5,1),(240,7451568,7451552,'ier',12.5,1),(240,7451569,7451561,'vdi',33.333,3),(240,7451570,7451561,'dis',33.333,3),(240,7451571,7451561,'isk',33.333,3),(240,7451572,7451569,'nam',50,1),(240,7451573,7451569,'ame',50,1),(240,7451574,7451572,'typ',50,1),(240,7451575,7451572,'ype',50,1),(240,7451576,7451574,'dir',25,1),(240,7451577,7451574,'ire',25,1),(240,7451578,7451574,'rec',25,1),(240,7451579,7451574,'ect',25,1),(241,7451581,7451580,'naa',100,2),(241,7451582,7451581,'600',3.333,3),(241,7451583,7451581,'000',3.333,3),(241,7451584,7451581,'00c',3.333,3),(241,7451585,7451581,'0c2',3.333,3),(241,7451586,7451581,'c29',3.333,3),(241,7451587,7451581,'290',3.333,3),(241,7451588,7451581,'90a',3.333,3),(241,7451589,7451581,'0a1',3.333,3),(241,7451590,7451581,'a1e',3.333,3),(241,7451591,7451581,'1e6',3.333,3),(241,7451592,7451581,'e6f',3.333,3),(241,7451593,7451581,'6f7',3.333,3),(241,7451594,7451581,'f7d',3.333,3),(241,7451595,7451581,'7dc',3.333,3),(241,7451596,7451581,'dcd',3.333,3),(241,7451597,7451581,'cd6',3.333,3),(241,7451598,7451581,'d64',3.333,3),(241,7451599,7451581,'64b',3.333,3),(241,7451600,7451581,'4ba',3.333,3),(241,7451601,7451581,'bad',3.333,3),(241,7451602,7451581,'ad2',3.333,3),(241,7451603,7451581,'d2f',3.333,3),(241,7451604,7451581,'2f0',3.333,3),(241,7451605,7451581,'f05',3.333,3),(241,7451606,7451581,'050',3.333,3),(241,7451607,7451581,'508',3.333,3),(241,7451608,7451581,'08e',3.333,3),(241,7451609,7451581,'8e1',3.333,3),(241,7451610,7451581,'e1e',3.333,3),(241,7451611,7451581,'1ea',3.333,3),(241,7451612,7451582,'mon',100,1),(241,7451613,7451612,'201',50,1),(241,7451614,7451612,'013',50,1),(241,7451615,7451613,'adm',33.333,3),(241,7451616,7451613,'dmi',33.333,3),(241,7451617,7451613,'min',33.333,3),(241,7451618,7451615,'cap',16.667,1),(241,7451619,7451615,'apa',16.667,1),(241,7451620,7451615,'pac',16.667,1),(241,7451621,7451615,'aci',16.667,1),(241,7451622,7451615,'cit',16.667,1),(241,7451623,7451615,'ity',16.667,1),(241,7451624,7451618,'pat',50,1),(241,7451625,7451618,'ath',50,1),(241,7451626,7451624,'fre',14.286,1),(241,7451627,7451624,'ree',14.286,1),(241,7451628,7451624,'ees',14.286,1),(241,7451629,7451624,'esp',14.286,1),(241,7451630,7451624,'spa',14.286,1),(241,7451631,7451624,'pac',14.286,1),(241,7451632,7451624,'ace',14.286,1),(241,7451633,7451626,'dis',50,1),(241,7451634,7451626,'isk',50,1),(241,7451635,7451633,'ind',33.333,1),(241,7451636,7451633,'nde',33.333,1),(241,7451637,7451633,'dex',33.333,1),(241,7451638,7451635,'adm',8.333,1),(241,7451639,7451635,'dmi',8.333,1),(241,7451640,7451635,'min',8.333,1),(241,7451641,7451635,'ini',8.333,1),(241,7451642,7451635,'nis',8.333,1),(241,7451643,7451635,'ist',8.333,1),(241,7451644,7451635,'str',8.333,1),(241,7451645,7451635,'tra',8.333,1),(241,7451646,7451635,'rat',8.333,1),(241,7451647,7451635,'ati',8.333,1),(241,7451648,7451635,'tio',8.333,1),(241,7451649,7451635,'ion',8.333,1),(241,7451650,7451638,'sta',33.333,3),(241,7451651,7451638,'tat',33.333,3),(241,7451652,7451638,'ate',33.333,3),(241,7451653,7451650,'ena',20,2),(241,7451654,7451650,'nab',20,2),(241,7451655,7451650,'abl',20,2),(241,7451656,7451650,'ble',20,2),(241,7451657,7451650,'led',20,2),(241,7451658,7451653,'cac',33.333,1),(241,7451659,7451653,'ach',33.333,1),(241,7451660,7451653,'che',33.333,1),(241,7451661,7451658,'mod',50,2),(241,7451662,7451658,'ode',50,2),(241,7451663,7451661,'wri',14.286,2),(241,7451664,7451661,'rit',14.286,2),(241,7451665,7451661,'ite',14.286,2),(241,7451666,7451661,'tet',14.286,2),(241,7451667,7451661,'eth',14.286,2),(241,7451668,7451661,'thr',14.286,2),(241,7451669,7451661,'hru',14.286,2),(241,7451670,7451663,'ope',11.111,2),(241,7451671,7451663,'per',11.111,2),(241,7451672,7451663,'era',11.111,2),(241,7451673,7451663,'rat',11.111,2),(241,7451674,7451663,'ati',11.111,2),(241,7451675,7451663,'tio',11.111,2),(241,7451676,7451663,'ion',11.111,2),(241,7451677,7451663,'ona',11.111,2),(241,7451678,7451663,'nal',11.111,2),(241,7451679,7451670,'nor',25,1),(241,7451680,7451670,'orm',25,1),(241,7451681,7451670,'rma',25,1),(241,7451682,7451670,'mal',25,1),(241,7451683,7451679,'mes',20,1),(241,7451684,7451679,'ess',20,1),(241,7451685,7451679,'ssa',20,1),(241,7451686,7451679,'sag',20,1),(241,7451687,7451679,'age',20,1),(241,7451688,7451683,'per',11.111,1),(241,7451689,7451683,'erf',11.111,1),(241,7451690,7451683,'rfo',11.111,1),(241,7451691,7451683,'for',11.111,1),(241,7451692,7451683,'orm',11.111,1),(241,7451693,7451683,'rma',11.111,1),(241,7451694,7451683,'man',11.111,1),(241,7451695,7451683,'anc',11.111,1),(241,7451696,7451683,'nce',11.111,1),(241,7451697,7451688,'ide',12.5,1),(241,7451698,7451688,'den',12.5,1),(241,7451699,7451688,'ent',12.5,1),(241,7451700,7451688,'nti',12.5,1),(241,7451701,7451688,'tif',12.5,1),(241,7451702,7451688,'ifi',12.5,1),(241,7451703,7451688,'fie',12.5,1),(241,7451704,7451688,'ier',12.5,1),(241,7451705,7451697,'vdi',33.333,3),(241,7451706,7451697,'dis',33.333,3),(241,7451707,7451697,'isk',33.333,3),(241,7451708,7451705,'nam',50,1),(241,7451709,7451705,'ame',50,1),(241,7451710,7451708,'typ',50,1),(241,7451711,7451708,'ype',50,1),(241,7451712,7451710,'dir',25,1),(241,7451713,7451710,'ire',25,1),(241,7451714,7451710,'rec',25,1),(241,7451715,7451710,'ect',25,1),(242,7451717,7451716,'naa',100,2),(242,7451718,7451717,'600',3.333,3),(242,7451719,7451717,'000',3.333,3),(242,7451720,7451717,'00c',3.333,3),(242,7451721,7451717,'0c2',3.333,3),(242,7451722,7451717,'c29',3.333,3),(242,7451723,7451717,'294',3.333,3),(242,7451724,7451717,'947',3.333,3),(242,7451725,7451717,'475',3.333,3),(242,7451726,7451717,'75b',3.333,3),(242,7451727,7451717,'5b9',3.333,3),(242,7451728,7451717,'b97',3.333,3),(242,7451729,7451717,'97b',3.333,3),(242,7451730,7451717,'7b7',3.333,3),(242,7451731,7451717,'b7e',3.333,3),(242,7451732,7451717,'7e2',3.333,3),(242,7451733,7451717,'e2d',3.333,3),(242,7451734,7451717,'2d7',3.333,3),(242,7451735,7451717,'d72',3.333,3),(242,7451736,7451717,'72a',3.333,3),(242,7451737,7451717,'2ab',3.333,3),(242,7451738,7451717,'ab1',3.333,3),(242,7451739,7451717,'b1a',3.333,3),(242,7451740,7451717,'1a2',3.333,3),(242,7451741,7451717,'a29',3.333,3),(242,7451742,7451717,'29b',3.333,3),(242,7451743,7451717,'9ba',3.333,3),(242,7451744,7451717,'ba0',3.333,3),(242,7451745,7451717,'a04',3.333,3),(242,7451746,7451717,'04a',3.333,3),(242,7451747,7451717,'4a0',3.333,3),(242,7451748,7451718,'mon',100,1),(242,7451749,7451748,'201',50,1),(242,7451750,7451748,'013',50,1),(242,7451751,7451749,'adm',33.333,3),(242,7451752,7451749,'dmi',33.333,3),(242,7451753,7451749,'min',33.333,3),(242,7451754,7451751,'cap',16.667,1),(242,7451755,7451751,'apa',16.667,1),(242,7451756,7451751,'pac',16.667,1),(242,7451757,7451751,'aci',16.667,1),(242,7451758,7451751,'cit',16.667,1),(242,7451759,7451751,'ity',16.667,1),(242,7451760,7451754,'pat',50,1),(242,7451761,7451754,'ath',50,1),(242,7451762,7451760,'fre',14.286,1),(242,7451763,7451760,'ree',14.286,1),(242,7451764,7451760,'ees',14.286,1),(242,7451765,7451760,'esp',14.286,1),(242,7451766,7451760,'spa',14.286,1),(242,7451767,7451760,'pac',14.286,1),(242,7451768,7451760,'ace',14.286,1),(242,7451769,7451762,'dis',50,1),(242,7451770,7451762,'isk',50,1),(242,7451771,7451769,'ind',33.333,1),(242,7451772,7451769,'nde',33.333,1),(242,7451773,7451769,'dex',33.333,1),(242,7451774,7451771,'adm',8.333,1),(242,7451775,7451771,'dmi',8.333,1),(242,7451776,7451771,'min',8.333,1),(242,7451777,7451771,'ini',8.333,1),(242,7451778,7451771,'nis',8.333,1),(242,7451779,7451771,'ist',8.333,1),(242,7451780,7451771,'str',8.333,1),(242,7451781,7451771,'tra',8.333,1),(242,7451782,7451771,'rat',8.333,1),(242,7451783,7451771,'ati',8.333,1),(242,7451784,7451771,'tio',8.333,1),(242,7451785,7451771,'ion',8.333,1),(242,7451786,7451774,'sta',33.333,3),(242,7451787,7451774,'tat',33.333,3),(242,7451788,7451774,'ate',33.333,3),(242,7451789,7451786,'ena',20,2),(242,7451790,7451786,'nab',20,2),(242,7451791,7451786,'abl',20,2),(242,7451792,7451786,'ble',20,2),(242,7451793,7451786,'led',20,2),(242,7451794,7451789,'cac',33.333,1),(242,7451795,7451789,'ach',33.333,1),(242,7451796,7451789,'che',33.333,1),(242,7451797,7451794,'mod',50,2),(242,7451798,7451794,'ode',50,2),(242,7451799,7451797,'wri',14.286,2),(242,7451800,7451797,'rit',14.286,2),(242,7451801,7451797,'ite',14.286,2),(242,7451802,7451797,'tet',14.286,2),(242,7451803,7451797,'eth',14.286,2),(242,7451804,7451797,'thr',14.286,2),(242,7451805,7451797,'hru',14.286,2),(242,7451806,7451799,'ope',11.111,2),(242,7451807,7451799,'per',11.111,2),(242,7451808,7451799,'era',11.111,2),(242,7451809,7451799,'rat',11.111,2),(242,7451810,7451799,'ati',11.111,2),(242,7451811,7451799,'tio',11.111,2),(242,7451812,7451799,'ion',11.111,2),(242,7451813,7451799,'ona',11.111,2),(242,7451814,7451799,'nal',11.111,2),(242,7451815,7451806,'nor',25,1),(242,7451816,7451806,'orm',25,1),(242,7451817,7451806,'rma',25,1),(242,7451818,7451806,'mal',25,1),(242,7451819,7451815,'mes',20,1),(242,7451820,7451815,'ess',20,1),(242,7451821,7451815,'ssa',20,1),(242,7451822,7451815,'sag',20,1),(242,7451823,7451815,'age',20,1),(242,7451824,7451819,'per',11.111,1),(242,7451825,7451819,'erf',11.111,1),(242,7451826,7451819,'rfo',11.111,1),(242,7451827,7451819,'for',11.111,1),(242,7451828,7451819,'orm',11.111,1),(242,7451829,7451819,'rma',11.111,1),(242,7451830,7451819,'man',11.111,1),(242,7451831,7451819,'anc',11.111,1),(242,7451832,7451819,'nce',11.111,1),(242,7451833,7451824,'ide',12.5,1),(242,7451834,7451824,'den',12.5,1),(242,7451835,7451824,'ent',12.5,1),(242,7451836,7451824,'nti',12.5,1),(242,7451837,7451824,'tif',12.5,1),(242,7451838,7451824,'ifi',12.5,1),(242,7451839,7451824,'fie',12.5,1),(242,7451840,7451824,'ier',12.5,1),(242,7451841,7451833,'vdi',33.333,3),(242,7451842,7451833,'dis',33.333,3),(242,7451843,7451833,'isk',33.333,3),(242,7451844,7451841,'nam',50,1),(242,7451845,7451841,'ame',50,1),(242,7451846,7451844,'typ',50,1),(242,7451847,7451844,'ype',50,1),(242,7451848,7451846,'dir',25,1),(242,7451849,7451846,'ire',25,1),(242,7451850,7451846,'rec',25,1),(242,7451851,7451846,'ect',25,1),(243,7451853,7451852,'naa',100,2),(243,7451854,7451853,'600',3.333,3),(243,7451855,7451853,'000',3.333,3),(243,7451856,7451853,'00c',3.333,3),(243,7451857,7451853,'0c2',3.333,3),(243,7451858,7451853,'c29',3.333,3),(243,7451859,7451853,'291',3.333,3),(243,7451860,7451853,'916',3.333,3),(243,7451861,7451853,'163',3.333,3),(243,7451862,7451853,'630',3.333,3),(243,7451863,7451853,'30b',3.333,3),(243,7451864,7451853,'0bf',3.333,3),(243,7451865,7451853,'bfd',3.333,3),(243,7451866,7451853,'fde',3.333,3),(243,7451867,7451853,'de3',3.333,3),(243,7451868,7451853,'e37',3.333,3),(243,7451869,7451853,'372',3.333,3),(243,7451870,7451853,'725',3.333,3),(243,7451871,7451853,'25b',3.333,3),(243,7451872,7451853,'5bb',3.333,3),(243,7451873,7451853,'bb0',3.333,3),(243,7451874,7451853,'b05',3.333,3),(243,7451875,7451853,'058',3.333,3),(243,7451876,7451853,'588',3.333,3),(243,7451877,7451853,'887',3.333,3),(243,7451878,7451853,'877',3.333,3),(243,7451879,7451853,'773',3.333,3),(243,7451880,7451853,'739',3.333,3),(243,7451881,7451853,'39b',3.333,3),(243,7451882,7451853,'9ba',3.333,3),(243,7451883,7451853,'ba8',3.333,3),(243,7451884,7451854,'mon',100,1),(243,7451885,7451884,'201',50,1),(243,7451886,7451884,'013',50,1),(243,7451887,7451885,'adm',33.333,3),(243,7451888,7451885,'dmi',33.333,3),(243,7451889,7451885,'min',33.333,3),(243,7451890,7451887,'cap',16.667,1),(243,7451891,7451887,'apa',16.667,1),(243,7451892,7451887,'pac',16.667,1),(243,7451893,7451887,'aci',16.667,1),(243,7451894,7451887,'cit',16.667,1),(243,7451895,7451887,'ity',16.667,1),(243,7451896,7451890,'pat',50,1),(243,7451897,7451890,'ath',50,1),(243,7451898,7451896,'fre',14.286,1),(243,7451899,7451896,'ree',14.286,1),(243,7451900,7451896,'ees',14.286,1),(243,7451901,7451896,'esp',14.286,1),(243,7451902,7451896,'spa',14.286,1),(243,7451903,7451896,'pac',14.286,1),(243,7451904,7451896,'ace',14.286,1),(243,7451905,7451898,'dis',50,1),(243,7451906,7451898,'isk',50,1),(243,7451907,7451905,'ind',33.333,1),(243,7451908,7451905,'nde',33.333,1),(243,7451909,7451905,'dex',33.333,1),(243,7451910,7451907,'adm',8.333,1),(243,7451911,7451907,'dmi',8.333,1),(243,7451912,7451907,'min',8.333,1),(243,7451913,7451907,'ini',8.333,1),(243,7451914,7451907,'nis',8.333,1),(243,7451915,7451907,'ist',8.333,1),(243,7451916,7451907,'str',8.333,1),(243,7451917,7451907,'tra',8.333,1),(243,7451918,7451907,'rat',8.333,1),(243,7451919,7451907,'ati',8.333,1),(243,7451920,7451907,'tio',8.333,1),(243,7451921,7451907,'ion',8.333,1),(243,7451922,7451910,'sta',33.333,3),(243,7451923,7451910,'tat',33.333,3),(243,7451924,7451910,'ate',33.333,3),(243,7451925,7451922,'ena',20,2),(243,7451926,7451922,'nab',20,2),(243,7451927,7451922,'abl',20,2),(243,7451928,7451922,'ble',20,2),(243,7451929,7451922,'led',20,2),(243,7451930,7451925,'cac',33.333,1),(243,7451931,7451925,'ach',33.333,1),(243,7451932,7451925,'che',33.333,1),(243,7451933,7451930,'mod',50,2),(243,7451934,7451930,'ode',50,2),(243,7451935,7451933,'wri',14.286,2),(243,7451936,7451933,'rit',14.286,2),(243,7451937,7451933,'ite',14.286,2),(243,7451938,7451933,'tet',14.286,2),(243,7451939,7451933,'eth',14.286,2),(243,7451940,7451933,'thr',14.286,2),(243,7451941,7451933,'hru',14.286,2),(243,7451942,7451935,'ope',11.111,2),(243,7451943,7451935,'per',11.111,2),(243,7451944,7451935,'era',11.111,2),(243,7451945,7451935,'rat',11.111,2),(243,7451946,7451935,'ati',11.111,2),(243,7451947,7451935,'tio',11.111,2),(243,7451948,7451935,'ion',11.111,2),(243,7451949,7451935,'ona',11.111,2),(243,7451950,7451935,'nal',11.111,2),(243,7451951,7451942,'nor',25,1),(243,7451952,7451942,'orm',25,1),(243,7451953,7451942,'rma',25,1),(243,7451954,7451942,'mal',25,1),(243,7451955,7451951,'mes',20,1),(243,7451956,7451951,'ess',20,1),(243,7451957,7451951,'ssa',20,1),(243,7451958,7451951,'sag',20,1),(243,7451959,7451951,'age',20,1),(243,7451960,7451955,'per',11.111,1),(243,7451961,7451955,'erf',11.111,1),(243,7451962,7451955,'rfo',11.111,1),(243,7451963,7451955,'for',11.111,1),(243,7451964,7451955,'orm',11.111,1),(243,7451965,7451955,'rma',11.111,1),(243,7451966,7451955,'man',11.111,1),(243,7451967,7451955,'anc',11.111,1),(243,7451968,7451955,'nce',11.111,1),(243,7451969,7451960,'ide',12.5,1),(243,7451970,7451960,'den',12.5,1),(243,7451971,7451960,'ent',12.5,1),(243,7451972,7451960,'nti',12.5,1),(243,7451973,7451960,'tif',12.5,1),(243,7451974,7451960,'ifi',12.5,1),(243,7451975,7451960,'fie',12.5,1),(243,7451976,7451960,'ier',12.5,1),(243,7451977,7451969,'vdi',33.333,3),(243,7451978,7451969,'dis',33.333,3),(243,7451979,7451969,'isk',33.333,3),(243,7451980,7451977,'nam',50,1),(243,7451981,7451977,'ame',50,1),(243,7451982,7451980,'typ',50,1),(243,7451983,7451980,'ype',50,1),(243,7451984,7451982,'dir',25,1),(243,7451985,7451982,'ire',25,1),(243,7451986,7451982,'rec',25,1),(243,7451987,7451982,'ect',25,1),(244,7451989,7451988,'naa',100,2),(244,7451990,7451989,'600',3.333,3),(244,7451991,7451989,'000',3.333,3),(244,7451992,7451989,'00c',3.333,3),(244,7451993,7451989,'0c2',3.333,3),(244,7451994,7451989,'c29',3.333,3),(244,7451995,7451989,'299',3.333,3),(244,7451996,7451989,'990',3.333,3),(244,7451997,7451989,'909',3.333,3),(244,7451998,7451989,'09b',3.333,3),(244,7451999,7451989,'9ba',3.333,3),(244,7452000,7451989,'baa',3.333,3),(244,7452001,7451989,'aac',3.333,3),(244,7452002,7451989,'ac3',3.333,3),(244,7452003,7451989,'c34',3.333,3),(244,7452004,7451989,'34d',3.333,3),(244,7452005,7451989,'4d1',3.333,3),(244,7452006,7451989,'d17',3.333,3),(244,7452007,7451989,'177',3.333,3),(244,7452008,7451989,'77a',3.333,3),(244,7452009,7451989,'7a4',3.333,3),(244,7452010,7451989,'a4a',3.333,3),(244,7452011,7451989,'4a3',3.333,3),(244,7452012,7451989,'a38',3.333,3),(244,7452013,7451989,'384',3.333,3),(244,7452014,7451989,'840',3.333,3),(244,7452015,7451989,'403',3.333,3),(244,7452016,7451989,'032',3.333,3),(244,7452017,7451989,'328',3.333,3),(244,7452018,7451989,'28b',3.333,3),(244,7452019,7451989,'8b8',3.333,3),(244,7452020,7451990,'mon',100,1),(244,7452021,7452020,'201',50,1),(244,7452022,7452020,'013',50,1),(244,7452023,7452021,'adm',33.333,3),(244,7452024,7452021,'dmi',33.333,3),(244,7452025,7452021,'min',33.333,3),(244,7452026,7452023,'cap',16.667,1),(244,7452027,7452023,'apa',16.667,1),(244,7452028,7452023,'pac',16.667,1),(244,7452029,7452023,'aci',16.667,1),(244,7452030,7452023,'cit',16.667,1),(244,7452031,7452023,'ity',16.667,1),(244,7452032,7452026,'pat',50,1),(244,7452033,7452026,'ath',50,1),(244,7452034,7452032,'fre',14.286,1),(244,7452035,7452032,'ree',14.286,1),(244,7452036,7452032,'ees',14.286,1),(244,7452037,7452032,'esp',14.286,1),(244,7452038,7452032,'spa',14.286,1),(244,7452039,7452032,'pac',14.286,1),(244,7452040,7452032,'ace',14.286,1),(244,7452041,7452034,'dis',50,1),(244,7452042,7452034,'isk',50,1),(244,7452043,7452041,'ind',33.333,1),(244,7452044,7452041,'nde',33.333,1),(244,7452045,7452041,'dex',33.333,1),(244,7452046,7452043,'adm',8.333,1),(244,7452047,7452043,'dmi',8.333,1),(244,7452048,7452043,'min',8.333,1),(244,7452049,7452043,'ini',8.333,1),(244,7452050,7452043,'nis',8.333,1),(244,7452051,7452043,'ist',8.333,1),(244,7452052,7452043,'str',8.333,1),(244,7452053,7452043,'tra',8.333,1),(244,7452054,7452043,'rat',8.333,1),(244,7452055,7452043,'ati',8.333,1),(244,7452056,7452043,'tio',8.333,1),(244,7452057,7452043,'ion',8.333,1),(244,7452058,7452046,'sta',33.333,3),(244,7452059,7452046,'tat',33.333,3),(244,7452060,7452046,'ate',33.333,3),(244,7452061,7452058,'ena',20,2),(244,7452062,7452058,'nab',20,2),(244,7452063,7452058,'abl',20,2),(244,7452064,7452058,'ble',20,2),(244,7452065,7452058,'led',20,2),(244,7452066,7452061,'cac',33.333,1),(244,7452067,7452061,'ach',33.333,1),(244,7452068,7452061,'che',33.333,1),(244,7452069,7452066,'mod',50,2),(244,7452070,7452066,'ode',50,2),(244,7452071,7452069,'wri',14.286,2),(244,7452072,7452069,'rit',14.286,2),(244,7452073,7452069,'ite',14.286,2),(244,7452074,7452069,'tet',14.286,2),(244,7452075,7452069,'eth',14.286,2),(244,7452076,7452069,'thr',14.286,2),(244,7452077,7452069,'hru',14.286,2),(244,7452078,7452071,'ope',11.111,2),(244,7452079,7452071,'per',11.111,2),(244,7452080,7452071,'era',11.111,2),(244,7452081,7452071,'rat',11.111,2),(244,7452082,7452071,'ati',11.111,2),(244,7452083,7452071,'tio',11.111,2),(244,7452084,7452071,'ion',11.111,2),(244,7452085,7452071,'ona',11.111,2),(244,7452086,7452071,'nal',11.111,2),(244,7452087,7452078,'nor',25,1),(244,7452088,7452078,'orm',25,1),(244,7452089,7452078,'rma',25,1),(244,7452090,7452078,'mal',25,1),(244,7452091,7452087,'mes',20,1),(244,7452092,7452087,'ess',20,1),(244,7452093,7452087,'ssa',20,1),(244,7452094,7452087,'sag',20,1),(244,7452095,7452087,'age',20,1),(244,7452096,7452091,'per',11.111,1),(244,7452097,7452091,'erf',11.111,1),(244,7452098,7452091,'rfo',11.111,1),(244,7452099,7452091,'for',11.111,1),(244,7452100,7452091,'orm',11.111,1),(244,7452101,7452091,'rma',11.111,1),(244,7452102,7452091,'man',11.111,1),(244,7452103,7452091,'anc',11.111,1),(244,7452104,7452091,'nce',11.111,1),(244,7452105,7452096,'ide',12.5,1),(244,7452106,7452096,'den',12.5,1),(244,7452107,7452096,'ent',12.5,1),(244,7452108,7452096,'nti',12.5,1),(244,7452109,7452096,'tif',12.5,1),(244,7452110,7452096,'ifi',12.5,1),(244,7452111,7452096,'fie',12.5,1),(244,7452112,7452096,'ier',12.5,1),(244,7452113,7452105,'vdi',33.333,3),(244,7452114,7452105,'dis',33.333,3),(244,7452115,7452105,'isk',33.333,3),(244,7452116,7452113,'nam',50,1),(244,7452117,7452113,'ame',50,1),(244,7452118,7452116,'typ',50,1),(244,7452119,7452116,'ype',50,1),(244,7452120,7452118,'dir',25,1),(244,7452121,7452118,'ire',25,1),(244,7452122,7452118,'rec',25,1),(244,7452123,7452118,'ect',25,1),(245,7452125,7452124,'naa',100,2),(245,7452126,7452125,'600',3.333,3),(245,7452127,7452125,'000',3.333,3),(245,7452128,7452125,'00c',3.333,3),(245,7452129,7452125,'0c2',3.333,3),(245,7452130,7452125,'c29',3.333,3),(245,7452131,7452125,'292',3.333,3),(245,7452132,7452125,'925',3.333,3),(245,7452133,7452125,'25e',3.333,3),(245,7452134,7452125,'5e6',3.333,3),(245,7452135,7452125,'e67',3.333,3),(245,7452136,7452125,'675',3.333,3),(245,7452137,7452125,'758',3.333,3),(245,7452138,7452125,'588',3.333,3),(245,7452139,7452125,'888',3.333,3),(245,7452140,7452125,'884',3.333,3),(245,7452141,7452125,'84a',3.333,3),(245,7452142,7452125,'4ac',3.333,3),(245,7452143,7452125,'ac5',3.333,3),(245,7452144,7452125,'c57',3.333,3),(245,7452145,7452125,'57c',3.333,3),(245,7452146,7452125,'7c7',3.333,3),(245,7452147,7452125,'c7a',3.333,3),(245,7452148,7452125,'7ae',3.333,3),(245,7452149,7452125,'ae8',3.333,3),(245,7452150,7452125,'e89',3.333,3),(245,7452151,7452125,'894',3.333,3),(245,7452152,7452125,'94e',3.333,3),(245,7452153,7452125,'4ee',3.333,3),(245,7452154,7452125,'ee8',3.333,3),(245,7452155,7452125,'e86',3.333,3),(245,7452156,7452126,'mon',100,1),(245,7452157,7452156,'201',50,1),(245,7452158,7452156,'013',50,1),(245,7452159,7452157,'adm',33.333,3),(245,7452160,7452157,'dmi',33.333,3),(245,7452161,7452157,'min',33.333,3),(245,7452162,7452159,'cap',16.667,1),(245,7452163,7452159,'apa',16.667,1),(245,7452164,7452159,'pac',16.667,1),(245,7452165,7452159,'aci',16.667,1),(245,7452166,7452159,'cit',16.667,1),(245,7452167,7452159,'ity',16.667,1),(245,7452168,7452162,'pat',50,1),(245,7452169,7452162,'ath',50,1),(245,7452170,7452168,'fre',14.286,1),(245,7452171,7452168,'ree',14.286,1),(245,7452172,7452168,'ees',14.286,1),(245,7452173,7452168,'esp',14.286,1),(245,7452174,7452168,'spa',14.286,1),(245,7452175,7452168,'pac',14.286,1),(245,7452176,7452168,'ace',14.286,1),(245,7452177,7452170,'dis',50,1),(245,7452178,7452170,'isk',50,1),(245,7452179,7452177,'ind',33.333,1),(245,7452180,7452177,'nde',33.333,1),(245,7452181,7452177,'dex',33.333,1),(245,7452182,7452179,'adm',8.333,1),(245,7452183,7452179,'dmi',8.333,1),(245,7452184,7452179,'min',8.333,1),(245,7452185,7452179,'ini',8.333,1),(245,7452186,7452179,'nis',8.333,1),(245,7452187,7452179,'ist',8.333,1),(245,7452188,7452179,'str',8.333,1),(245,7452189,7452179,'tra',8.333,1),(245,7452190,7452179,'rat',8.333,1),(245,7452191,7452179,'ati',8.333,1),(245,7452192,7452179,'tio',8.333,1),(245,7452193,7452179,'ion',8.333,1),(245,7452194,7452182,'sta',33.333,3),(245,7452195,7452182,'tat',33.333,3),(245,7452196,7452182,'ate',33.333,3),(245,7452197,7452194,'ena',20,2),(245,7452198,7452194,'nab',20,2),(245,7452199,7452194,'abl',20,2),(245,7452200,7452194,'ble',20,2),(245,7452201,7452194,'led',20,2),(245,7452202,7452197,'cac',33.333,1),(245,7452203,7452197,'ach',33.333,1),(245,7452204,7452197,'che',33.333,1),(245,7452205,7452202,'mod',50,2),(245,7452206,7452202,'ode',50,2),(245,7452207,7452205,'wri',14.286,2),(245,7452208,7452205,'rit',14.286,2),(245,7452209,7452205,'ite',14.286,2),(245,7452210,7452205,'tet',14.286,2),(245,7452211,7452205,'eth',14.286,2),(245,7452212,7452205,'thr',14.286,2),(245,7452213,7452205,'hru',14.286,2),(245,7452214,7452207,'ope',11.111,2),(245,7452215,7452207,'per',11.111,2),(245,7452216,7452207,'era',11.111,2),(245,7452217,7452207,'rat',11.111,2),(245,7452218,7452207,'ati',11.111,2),(245,7452219,7452207,'tio',11.111,2),(245,7452220,7452207,'ion',11.111,2),(245,7452221,7452207,'ona',11.111,2),(245,7452222,7452207,'nal',11.111,2),(245,7452223,7452214,'nor',25,1),(245,7452224,7452214,'orm',25,1),(245,7452225,7452214,'rma',25,1),(245,7452226,7452214,'mal',25,1),(245,7452227,7452223,'mes',20,1),(245,7452228,7452223,'ess',20,1),(245,7452229,7452223,'ssa',20,1),(245,7452230,7452223,'sag',20,1),(245,7452231,7452223,'age',20,1),(245,7452232,7452227,'per',11.111,1),(245,7452233,7452227,'erf',11.111,1),(245,7452234,7452227,'rfo',11.111,1),(245,7452235,7452227,'for',11.111,1),(245,7452236,7452227,'orm',11.111,1),(245,7452237,7452227,'rma',11.111,1),(245,7452238,7452227,'man',11.111,1),(245,7452239,7452227,'anc',11.111,1),(245,7452240,7452227,'nce',11.111,1),(245,7452241,7452232,'ide',12.5,1),(245,7452242,7452232,'den',12.5,1),(245,7452243,7452232,'ent',12.5,1),(245,7452244,7452232,'nti',12.5,1),(245,7452245,7452232,'tif',12.5,1),(245,7452246,7452232,'ifi',12.5,1),(245,7452247,7452232,'fie',12.5,1),(245,7452248,7452232,'ier',12.5,1),(245,7452249,7452241,'vdi',33.333,3),(245,7452250,7452241,'dis',33.333,3),(245,7452251,7452241,'isk',33.333,3),(245,7452252,7452249,'nam',50,1),(245,7452253,7452249,'ame',50,1),(245,7452254,7452252,'typ',50,1),(245,7452255,7452252,'ype',50,1),(245,7452256,7452254,'dir',25,1),(245,7452257,7452254,'ire',25,1),(245,7452258,7452254,'rec',25,1),(245,7452259,7452254,'ect',25,1),(246,7452261,7452260,'naa',100,2),(246,7452262,7452261,'600',3.333,3),(246,7452263,7452261,'000',3.333,3),(246,7452264,7452261,'00c',3.333,3),(246,7452265,7452261,'0c2',3.333,3),(246,7452266,7452261,'c29',3.333,3),(246,7452267,7452261,'295',3.333,3),(246,7452268,7452261,'950',3.333,3),(246,7452269,7452261,'509',3.333,3),(246,7452270,7452261,'09f',3.333,3),(246,7452271,7452261,'9fa',3.333,3),(246,7452272,7452261,'fa9',3.333,3),(246,7452273,7452261,'a9a',3.333,3),(246,7452274,7452261,'9ac',3.333,3),(246,7452275,7452261,'ac4',3.333,3),(246,7452276,7452261,'c43',3.333,3),(246,7452277,7452261,'43e',3.333,3),(246,7452278,7452261,'3eb',3.333,3),(246,7452279,7452261,'eb7',3.333,3),(246,7452280,7452261,'b73',3.333,3),(246,7452281,7452261,'732',3.333,3),(246,7452282,7452261,'32b',3.333,3),(246,7452283,7452261,'2b1',3.333,3),(246,7452284,7452261,'b1b',3.333,3),(246,7452285,7452261,'1b2',3.333,3),(246,7452286,7452261,'b2d',3.333,3),(246,7452287,7452261,'2d9',3.333,3),(246,7452288,7452261,'d9a',3.333,3),(246,7452289,7452261,'9a0',3.333,3),(246,7452290,7452261,'a0f',3.333,3),(246,7452291,7452261,'0f4',3.333,3),(246,7452292,7452262,'mon',100,1),(246,7452293,7452292,'201',50,1),(246,7452294,7452292,'013',50,1),(246,7452295,7452293,'adm',33.333,3),(246,7452296,7452293,'dmi',33.333,3),(246,7452297,7452293,'min',33.333,3),(246,7452298,7452295,'cap',16.667,1),(246,7452299,7452295,'apa',16.667,1),(246,7452300,7452295,'pac',16.667,1),(246,7452301,7452295,'aci',16.667,1),(246,7452302,7452295,'cit',16.667,1),(246,7452303,7452295,'ity',16.667,1),(246,7452304,7452298,'pat',50,1),(246,7452305,7452298,'ath',50,1),(246,7452306,7452304,'one',100,1),(246,7452307,7452306,'fre',14.286,1),(246,7452308,7452306,'ree',14.286,1),(246,7452309,7452306,'ees',14.286,1),(246,7452310,7452306,'esp',14.286,1),(246,7452311,7452306,'spa',14.286,1),(246,7452312,7452306,'pac',14.286,1),(246,7452313,7452306,'ace',14.286,1),(246,7452314,7452307,'dis',50,1),(246,7452315,7452307,'isk',50,1),(246,7452316,7452314,'ind',33.333,1),(246,7452317,7452314,'nde',33.333,1),(246,7452318,7452314,'dex',33.333,1),(246,7452319,7452316,'adm',8.333,1),(246,7452320,7452316,'dmi',8.333,1),(246,7452321,7452316,'min',8.333,1),(246,7452322,7452316,'ini',8.333,1),(246,7452323,7452316,'nis',8.333,1),(246,7452324,7452316,'ist',8.333,1),(246,7452325,7452316,'str',8.333,1),(246,7452326,7452316,'tra',8.333,1),(246,7452327,7452316,'rat',8.333,1),(246,7452328,7452316,'ati',8.333,1),(246,7452329,7452316,'tio',8.333,1),(246,7452330,7452316,'ion',8.333,1),(246,7452331,7452319,'sta',33.333,3),(246,7452332,7452319,'tat',33.333,3),(246,7452333,7452319,'ate',33.333,3),(246,7452334,7452331,'ena',20,2),(246,7452335,7452331,'nab',20,2),(246,7452336,7452331,'abl',20,2),(246,7452337,7452331,'ble',20,2),(246,7452338,7452331,'led',20,2),(246,7452339,7452334,'cac',33.333,1),(246,7452340,7452334,'ach',33.333,1),(246,7452341,7452334,'che',33.333,1),(246,7452342,7452339,'mod',50,2),(246,7452343,7452339,'ode',50,2),(246,7452344,7452342,'wri',14.286,2),(246,7452345,7452342,'rit',14.286,2),(246,7452346,7452342,'ite',14.286,2),(246,7452347,7452342,'tet',14.286,2),(246,7452348,7452342,'eth',14.286,2),(246,7452349,7452342,'thr',14.286,2),(246,7452350,7452342,'hru',14.286,2),(246,7452351,7452344,'ope',11.111,2),(246,7452352,7452344,'per',11.111,2),(246,7452353,7452344,'era',11.111,2),(246,7452354,7452344,'rat',11.111,2),(246,7452355,7452344,'ati',11.111,2),(246,7452356,7452344,'tio',11.111,2),(246,7452357,7452344,'ion',11.111,2),(246,7452358,7452344,'ona',11.111,2),(246,7452359,7452344,'nal',11.111,2),(246,7452360,7452351,'nor',25,1),(246,7452361,7452351,'orm',25,1),(246,7452362,7452351,'rma',25,1),(246,7452363,7452351,'mal',25,1),(246,7452364,7452360,'mes',20,1),(246,7452365,7452360,'ess',20,1),(246,7452366,7452360,'ssa',20,1),(246,7452367,7452360,'sag',20,1),(246,7452368,7452360,'age',20,1),(246,7452369,7452364,'per',11.111,1),(246,7452370,7452364,'erf',11.111,1),(246,7452371,7452364,'rfo',11.111,1),(246,7452372,7452364,'for',11.111,1),(246,7452373,7452364,'orm',11.111,1),(246,7452374,7452364,'rma',11.111,1),(246,7452375,7452364,'man',11.111,1),(246,7452376,7452364,'anc',11.111,1),(246,7452377,7452364,'nce',11.111,1),(246,7452378,7452369,'ide',12.5,1),(246,7452379,7452369,'den',12.5,1),(246,7452380,7452369,'ent',12.5,1),(246,7452381,7452369,'nti',12.5,1),(246,7452382,7452369,'tif',12.5,1),(246,7452383,7452369,'ifi',12.5,1),(246,7452384,7452369,'fie',12.5,1),(246,7452385,7452369,'ier',12.5,1),(246,7452386,7452378,'vdi',33.333,3),(246,7452387,7452378,'dis',33.333,3),(246,7452388,7452378,'isk',33.333,3),(246,7452389,7452386,'nam',50,1),(246,7452390,7452386,'ame',50,1),(246,7452391,7452389,'typ',50,1),(246,7452392,7452389,'ype',50,1),(246,7452393,7452391,'dir',25,1),(246,7452394,7452391,'ire',25,1),(246,7452395,7452391,'rec',25,1),(246,7452396,7452391,'ect',25,1),(247,7452398,7452397,'naa',100,2),(247,7452399,7452398,'600',3.333,3),(247,7452400,7452398,'000',3.333,3),(247,7452401,7452398,'00c',3.333,3),(247,7452402,7452398,'0c2',3.333,3),(247,7452403,7452398,'c29',3.333,3),(247,7452404,7452398,'296',3.333,3),(247,7452405,7452398,'965',3.333,3),(247,7452406,7452398,'659',3.333,3),(247,7452407,7452398,'59d',3.333,3),(247,7452408,7452398,'9d5',3.333,3),(247,7452409,7452398,'d5e',3.333,3),(247,7452410,7452398,'5ed',3.333,3),(247,7452411,7452398,'ed1',3.333,3),(247,7452412,7452398,'d1d',3.333,3),(247,7452413,7452398,'1d9',3.333,3),(247,7452414,7452398,'d99',3.333,3),(247,7452415,7452398,'994',3.333,3),(247,7452416,7452398,'94f',3.333,3),(247,7452417,7452398,'4fe',3.333,3),(247,7452418,7452398,'feb',3.333,3),(247,7452419,7452398,'eb8',3.333,3),(247,7452420,7452398,'b86',3.333,3),(247,7452421,7452398,'862',3.333,3),(247,7452422,7452398,'62b',3.333,3),(247,7452423,7452398,'2b3',3.333,3),(247,7452424,7452398,'b35',3.333,3),(247,7452425,7452398,'35f',3.333,3),(247,7452426,7452398,'5f5',3.333,3),(247,7452427,7452398,'f56',3.333,3),(247,7452428,7452398,'563',3.333,3),(247,7452429,7452399,'mon',100,1),(247,7452430,7452429,'201',50,1),(247,7452431,7452429,'013',50,1),(247,7452432,7452430,'adm',33.333,3),(247,7452433,7452430,'dmi',33.333,3),(247,7452434,7452430,'min',33.333,3),(247,7452435,7452432,'cap',16.667,1),(247,7452436,7452432,'apa',16.667,1),(247,7452437,7452432,'pac',16.667,1),(247,7452438,7452432,'aci',16.667,1),(247,7452439,7452432,'cit',16.667,1),(247,7452440,7452432,'ity',16.667,1),(247,7452441,7452435,'pat',50,1),(247,7452442,7452435,'ath',50,1),(247,7452443,7452441,'thr',33.333,1),(247,7452444,7452441,'hre',33.333,1),(247,7452445,7452441,'ree',33.333,1),(247,7452446,7452443,'fre',14.286,1),(247,7452447,7452443,'ree',14.286,1),(247,7452448,7452443,'ees',14.286,1),(247,7452449,7452443,'esp',14.286,1),(247,7452450,7452443,'spa',14.286,1),(247,7452451,7452443,'pac',14.286,1),(247,7452452,7452443,'ace',14.286,1),(247,7452453,7452446,'dis',50,1),(247,7452454,7452446,'isk',50,1),(247,7452455,7452453,'ind',33.333,1),(247,7452456,7452453,'nde',33.333,1),(247,7452457,7452453,'dex',33.333,1),(247,7452458,7452455,'adm',8.333,1),(247,7452459,7452455,'dmi',8.333,1),(247,7452460,7452455,'min',8.333,1),(247,7452461,7452455,'ini',8.333,1),(247,7452462,7452455,'nis',8.333,1),(247,7452463,7452455,'ist',8.333,1),(247,7452464,7452455,'str',8.333,1),(247,7452465,7452455,'tra',8.333,1),(247,7452466,7452455,'rat',8.333,1),(247,7452467,7452455,'ati',8.333,1),(247,7452468,7452455,'tio',8.333,1),(247,7452469,7452455,'ion',8.333,1),(247,7452470,7452458,'sta',33.333,3),(247,7452471,7452458,'tat',33.333,3),(247,7452472,7452458,'ate',33.333,3),(247,7452473,7452470,'ena',20,2),(247,7452474,7452470,'nab',20,2),(247,7452475,7452470,'abl',20,2),(247,7452476,7452470,'ble',20,2),(247,7452477,7452470,'led',20,2),(247,7452478,7452473,'cac',33.333,1),(247,7452479,7452473,'ach',33.333,1),(247,7452480,7452473,'che',33.333,1),(247,7452481,7452478,'mod',50,2),(247,7452482,7452478,'ode',50,2),(247,7452483,7452481,'wri',14.286,2),(247,7452484,7452481,'rit',14.286,2),(247,7452485,7452481,'ite',14.286,2),(247,7452486,7452481,'tet',14.286,2),(247,7452487,7452481,'eth',14.286,2),(247,7452488,7452481,'thr',14.286,2),(247,7452489,7452481,'hru',14.286,2),(247,7452490,7452483,'ope',11.111,2),(247,7452491,7452483,'per',11.111,2),(247,7452492,7452483,'era',11.111,2),(247,7452493,7452483,'rat',11.111,2),(247,7452494,7452483,'ati',11.111,2),(247,7452495,7452483,'tio',11.111,2),(247,7452496,7452483,'ion',11.111,2),(247,7452497,7452483,'ona',11.111,2),(247,7452498,7452483,'nal',11.111,2),(247,7452499,7452490,'nor',25,1),(247,7452500,7452490,'orm',25,1),(247,7452501,7452490,'rma',25,1),(247,7452502,7452490,'mal',25,1),(247,7452503,7452499,'mes',20,1),(247,7452504,7452499,'ess',20,1),(247,7452505,7452499,'ssa',20,1),(247,7452506,7452499,'sag',20,1),(247,7452507,7452499,'age',20,1),(247,7452508,7452503,'per',11.111,1),(247,7452509,7452503,'erf',11.111,1),(247,7452510,7452503,'rfo',11.111,1),(247,7452511,7452503,'for',11.111,1),(247,7452512,7452503,'orm',11.111,1),(247,7452513,7452503,'rma',11.111,1),(247,7452514,7452503,'man',11.111,1),(247,7452515,7452503,'anc',11.111,1),(247,7452516,7452503,'nce',11.111,1),(247,7452517,7452508,'ide',12.5,1),(247,7452518,7452508,'den',12.5,1),(247,7452519,7452508,'ent',12.5,1),(247,7452520,7452508,'nti',12.5,1),(247,7452521,7452508,'tif',12.5,1),(247,7452522,7452508,'ifi',12.5,1),(247,7452523,7452508,'fie',12.5,1),(247,7452524,7452508,'ier',12.5,1),(247,7452525,7452517,'vdi',33.333,3),(247,7452526,7452517,'dis',33.333,3),(247,7452527,7452517,'isk',33.333,3),(247,7452528,7452525,'nam',50,1),(247,7452529,7452525,'ame',50,1),(247,7452530,7452528,'typ',50,1),(247,7452531,7452528,'ype',50,1),(247,7452532,7452530,'dir',25,1),(247,7452533,7452530,'ire',25,1),(247,7452534,7452530,'rec',25,1),(247,7452535,7452530,'ect',25,1),(248,7452537,7452536,'naa',100,2),(248,7452538,7452537,'600',3.333,3),(248,7452539,7452537,'000',3.333,3),(248,7452540,7452537,'00c',3.333,3),(248,7452541,7452537,'0c2',3.333,3),(248,7452542,7452537,'c29',3.333,3),(248,7452543,7452537,'297',3.333,3),(248,7452544,7452537,'97f',3.333,3),(248,7452545,7452537,'7f0',3.333,3),(248,7452546,7452537,'f07',3.333,3),(248,7452547,7452537,'078',3.333,3),(248,7452548,7452537,'78b',3.333,3),(248,7452549,7452537,'8b4',3.333,3),(248,7452550,7452537,'b46',3.333,3),(248,7452551,7452537,'46c',3.333,3),(248,7452552,7452537,'6cc',3.333,3),(248,7452553,7452537,'cc9',3.333,3),(248,7452554,7452537,'c95',3.333,3),(248,7452555,7452537,'95f',3.333,3),(248,7452556,7452537,'5f6',3.333,3),(248,7452557,7452537,'f68',3.333,3),(248,7452558,7452537,'683',3.333,3),(248,7452559,7452537,'83d',3.333,3),(248,7452560,7452537,'3d3',3.333,3),(248,7452561,7452537,'d3f',3.333,3),(248,7452562,7452537,'3fa',3.333,3),(248,7452563,7452537,'fad',3.333,3),(248,7452564,7452537,'ad2',3.333,3),(248,7452565,7452537,'d23',3.333,3),(248,7452566,7452537,'230',3.333,3),(248,7452567,7452537,'304',3.333,3),(248,7452568,7452538,'mon',100,1),(248,7452569,7452568,'201',50,1),(248,7452570,7452568,'013',50,1),(248,7452571,7452569,'adm',33.333,3),(248,7452572,7452569,'dmi',33.333,3),(248,7452573,7452569,'min',33.333,3),(248,7452574,7452571,'cap',16.667,1),(248,7452575,7452571,'apa',16.667,1),(248,7452576,7452571,'pac',16.667,1),(248,7452577,7452571,'aci',16.667,1),(248,7452578,7452571,'cit',16.667,1),(248,7452579,7452571,'ity',16.667,1),(248,7452580,7452574,'pat',50,1),(248,7452581,7452574,'ath',50,1),(248,7452582,7452580,'fou',50,1),(248,7452583,7452580,'our',50,1),(248,7452584,7452582,'fre',14.286,1),(248,7452585,7452582,'ree',14.286,1),(248,7452586,7452582,'ees',14.286,1),(248,7452587,7452582,'esp',14.286,1),(248,7452588,7452582,'spa',14.286,1),(248,7452589,7452582,'pac',14.286,1),(248,7452590,7452582,'ace',14.286,1),(248,7452591,7452584,'dis',50,1),(248,7452592,7452584,'isk',50,1),(248,7452593,7452591,'ind',33.333,1),(248,7452594,7452591,'nde',33.333,1),(248,7452595,7452591,'dex',33.333,1),(248,7452596,7452593,'adm',8.333,1),(248,7452597,7452593,'dmi',8.333,1),(248,7452598,7452593,'min',8.333,1),(248,7452599,7452593,'ini',8.333,1),(248,7452600,7452593,'nis',8.333,1),(248,7452601,7452593,'ist',8.333,1),(248,7452602,7452593,'str',8.333,1),(248,7452603,7452593,'tra',8.333,1),(248,7452604,7452593,'rat',8.333,1),(248,7452605,7452593,'ati',8.333,1),(248,7452606,7452593,'tio',8.333,1),(248,7452607,7452593,'ion',8.333,1),(248,7452608,7452596,'sta',33.333,3),(248,7452609,7452596,'tat',33.333,3),(248,7452610,7452596,'ate',33.333,3),(248,7452611,7452608,'ena',20,2),(248,7452612,7452608,'nab',20,2),(248,7452613,7452608,'abl',20,2),(248,7452614,7452608,'ble',20,2),(248,7452615,7452608,'led',20,2),(248,7452616,7452611,'cac',33.333,1),(248,7452617,7452611,'ach',33.333,1),(248,7452618,7452611,'che',33.333,1),(248,7452619,7452616,'mod',50,2),(248,7452620,7452616,'ode',50,2),(248,7452621,7452619,'wri',14.286,2),(248,7452622,7452619,'rit',14.286,2),(248,7452623,7452619,'ite',14.286,2),(248,7452624,7452619,'tet',14.286,2),(248,7452625,7452619,'eth',14.286,2),(248,7452626,7452619,'thr',14.286,2),(248,7452627,7452619,'hru',14.286,2),(248,7452628,7452621,'ope',11.111,2),(248,7452629,7452621,'per',11.111,2),(248,7452630,7452621,'era',11.111,2),(248,7452631,7452621,'rat',11.111,2),(248,7452632,7452621,'ati',11.111,2),(248,7452633,7452621,'tio',11.111,2),(248,7452634,7452621,'ion',11.111,2),(248,7452635,7452621,'ona',11.111,2),(248,7452636,7452621,'nal',11.111,2),(248,7452637,7452628,'nor',25,1),(248,7452638,7452628,'orm',25,1),(248,7452639,7452628,'rma',25,1),(248,7452640,7452628,'mal',25,1),(248,7452641,7452637,'mes',20,1),(248,7452642,7452637,'ess',20,1),(248,7452643,7452637,'ssa',20,1),(248,7452644,7452637,'sag',20,1),(248,7452645,7452637,'age',20,1),(248,7452646,7452641,'per',11.111,1),(248,7452647,7452641,'erf',11.111,1),(248,7452648,7452641,'rfo',11.111,1),(248,7452649,7452641,'for',11.111,1),(248,7452650,7452641,'orm',11.111,1),(248,7452651,7452641,'rma',11.111,1),(248,7452652,7452641,'man',11.111,1),(248,7452653,7452641,'anc',11.111,1),(248,7452654,7452641,'nce',11.111,1),(248,7452655,7452646,'ide',12.5,1),(248,7452656,7452646,'den',12.5,1),(248,7452657,7452646,'ent',12.5,1),(248,7452658,7452646,'nti',12.5,1),(248,7452659,7452646,'tif',12.5,1),(248,7452660,7452646,'ifi',12.5,1),(248,7452661,7452646,'fie',12.5,1),(248,7452662,7452646,'ier',12.5,1),(248,7452663,7452655,'vdi',33.333,3),(248,7452664,7452655,'dis',33.333,3),(248,7452665,7452655,'isk',33.333,3),(248,7452666,7452663,'nam',50,1),(248,7452667,7452663,'ame',50,1),(248,7452668,7452666,'typ',50,1),(248,7452669,7452666,'ype',50,1),(248,7452670,7452668,'dir',25,1),(248,7452671,7452668,'ire',25,1),(248,7452672,7452668,'rec',25,1),(248,7452673,7452668,'ect',25,1),(249,7452675,7452674,'naa',100,2),(249,7452676,7452675,'600',3.333,3),(249,7452677,7452675,'000',3.333,3),(249,7452678,7452675,'00c',3.333,3),(249,7452679,7452675,'0c2',3.333,3),(249,7452680,7452675,'c29',3.333,3),(249,7452681,7452675,'292',3.333,3),(249,7452682,7452675,'92d',3.333,3),(249,7452683,7452675,'2da',3.333,3),(249,7452684,7452675,'da5',3.333,3),(249,7452685,7452675,'a51',3.333,3),(249,7452686,7452675,'51f',3.333,3),(249,7452687,7452675,'1f1',3.333,3),(249,7452688,7452675,'f1a',3.333,3),(249,7452689,7452675,'1aa',3.333,3),(249,7452690,7452675,'aa3',3.333,3),(249,7452691,7452675,'a36',3.333,3),(249,7452692,7452675,'36a',3.333,3),(249,7452693,7452675,'6aa',3.333,3),(249,7452694,7452675,'aa0',3.333,3),(249,7452695,7452675,'a0f',3.333,3),(249,7452696,7452675,'0f8',3.333,3),(249,7452697,7452675,'f8f',3.333,3),(249,7452698,7452675,'8f3',3.333,3),(249,7452699,7452675,'f36',3.333,3),(249,7452700,7452675,'36a',3.333,3),(249,7452701,7452675,'6ab',3.333,3),(249,7452702,7452675,'ab6',3.333,3),(249,7452703,7452675,'b63',3.333,3),(249,7452704,7452675,'63a',3.333,3),(249,7452705,7452675,'3a1',3.333,3),(249,7452706,7452676,'mon',100,1),(249,7452707,7452706,'201',50,1),(249,7452708,7452706,'013',50,1),(249,7452709,7452707,'adm',33.333,3),(249,7452710,7452707,'dmi',33.333,3),(249,7452711,7452707,'min',33.333,3),(249,7452712,7452709,'cap',16.667,1),(249,7452713,7452709,'apa',16.667,1),(249,7452714,7452709,'pac',16.667,1),(249,7452715,7452709,'aci',16.667,1),(249,7452716,7452709,'cit',16.667,1),(249,7452717,7452709,'ity',16.667,1),(249,7452718,7452712,'pat',50,1),(249,7452719,7452712,'ath',50,1),(249,7452720,7452718,'fiv',50,1),(249,7452721,7452718,'ive',50,1),(249,7452722,7452720,'fre',14.286,1),(249,7452723,7452720,'ree',14.286,1),(249,7452724,7452720,'ees',14.286,1),(249,7452725,7452720,'esp',14.286,1),(249,7452726,7452720,'spa',14.286,1),(249,7452727,7452720,'pac',14.286,1),(249,7452728,7452720,'ace',14.286,1),(249,7452729,7452722,'dis',50,1),(249,7452730,7452722,'isk',50,1),(249,7452731,7452729,'ind',33.333,1),(249,7452732,7452729,'nde',33.333,1),(249,7452733,7452729,'dex',33.333,1),(249,7452734,7452731,'adm',8.333,1),(249,7452735,7452731,'dmi',8.333,1),(249,7452736,7452731,'min',8.333,1),(249,7452737,7452731,'ini',8.333,1),(249,7452738,7452731,'nis',8.333,1),(249,7452739,7452731,'ist',8.333,1),(249,7452740,7452731,'str',8.333,1),(249,7452741,7452731,'tra',8.333,1),(249,7452742,7452731,'rat',8.333,1),(249,7452743,7452731,'ati',8.333,1),(249,7452744,7452731,'tio',8.333,1),(249,7452745,7452731,'ion',8.333,1),(249,7452746,7452734,'sta',33.333,3),(249,7452747,7452734,'tat',33.333,3),(249,7452748,7452734,'ate',33.333,3),(249,7452749,7452746,'ena',20,2),(249,7452750,7452746,'nab',20,2),(249,7452751,7452746,'abl',20,2),(249,7452752,7452746,'ble',20,2),(249,7452753,7452746,'led',20,2),(249,7452754,7452749,'cac',33.333,1),(249,7452755,7452749,'ach',33.333,1),(249,7452756,7452749,'che',33.333,1),(249,7452757,7452754,'mod',50,2),(249,7452758,7452754,'ode',50,2),(249,7452759,7452757,'wri',14.286,2),(249,7452760,7452757,'rit',14.286,2),(249,7452761,7452757,'ite',14.286,2),(249,7452762,7452757,'tet',14.286,2),(249,7452763,7452757,'eth',14.286,2),(249,7452764,7452757,'thr',14.286,2),(249,7452765,7452757,'hru',14.286,2),(249,7452766,7452759,'ope',11.111,2),(249,7452767,7452759,'per',11.111,2),(249,7452768,7452759,'era',11.111,2),(249,7452769,7452759,'rat',11.111,2),(249,7452770,7452759,'ati',11.111,2),(249,7452771,7452759,'tio',11.111,2),(249,7452772,7452759,'ion',11.111,2),(249,7452773,7452759,'ona',11.111,2),(249,7452774,7452759,'nal',11.111,2),(249,7452775,7452766,'nor',25,1),(249,7452776,7452766,'orm',25,1),(249,7452777,7452766,'rma',25,1),(249,7452778,7452766,'mal',25,1),(249,7452779,7452775,'mes',20,1),(249,7452780,7452775,'ess',20,1),(249,7452781,7452775,'ssa',20,1),(249,7452782,7452775,'sag',20,1),(249,7452783,7452775,'age',20,1),(249,7452784,7452779,'per',11.111,1),(249,7452785,7452779,'erf',11.111,1),(249,7452786,7452779,'rfo',11.111,1),(249,7452787,7452779,'for',11.111,1),(249,7452788,7452779,'orm',11.111,1),(249,7452789,7452779,'rma',11.111,1),(249,7452790,7452779,'man',11.111,1),(249,7452791,7452779,'anc',11.111,1),(249,7452792,7452779,'nce',11.111,1),(249,7452793,7452784,'ide',12.5,1),(249,7452794,7452784,'den',12.5,1),(249,7452795,7452784,'ent',12.5,1),(249,7452796,7452784,'nti',12.5,1),(249,7452797,7452784,'tif',12.5,1),(249,7452798,7452784,'ifi',12.5,1),(249,7452799,7452784,'fie',12.5,1),(249,7452800,7452784,'ier',12.5,1),(249,7452801,7452793,'vdi',33.333,3),(249,7452802,7452793,'dis',33.333,3),(249,7452803,7452793,'isk',33.333,3),(249,7452804,7452801,'nam',50,1),(249,7452805,7452801,'ame',50,1),(249,7452806,7452804,'typ',50,1),(249,7452807,7452804,'ype',50,1),(249,7452808,7452806,'dir',25,1),(249,7452809,7452806,'ire',25,1),(249,7452810,7452806,'rec',25,1),(249,7452811,7452806,'ect',25,1),(250,7452813,7452812,'naa',100,2),(250,7452814,7452813,'600',3.333,3),(250,7452815,7452813,'000',3.333,3),(250,7452816,7452813,'00c',3.333,3),(250,7452817,7452813,'0c2',3.333,3),(250,7452818,7452813,'c29',3.333,3),(250,7452819,7452813,'290',3.333,3),(250,7452820,7452813,'90b',3.333,3),(250,7452821,7452813,'0b4',3.333,3),(250,7452822,7452813,'b44',3.333,3),(250,7452823,7452813,'447',3.333,3),(250,7452824,7452813,'472',3.333,3),(250,7452825,7452813,'722',3.333,3),(250,7452826,7452813,'224',3.333,3),(250,7452827,7452813,'24a',3.333,3),(250,7452828,7452813,'4a3',3.333,3),(250,7452829,7452813,'a36',3.333,3),(250,7452830,7452813,'367',3.333,3),(250,7452831,7452813,'67a',3.333,3),(250,7452832,7452813,'7ae',3.333,3),(250,7452833,7452813,'ae8',3.333,3),(250,7452834,7452813,'e88',3.333,3),(250,7452835,7452813,'887',3.333,3),(250,7452836,7452813,'872',3.333,3),(250,7452837,7452813,'729',3.333,3),(250,7452838,7452813,'29a',3.333,3),(250,7452839,7452813,'9a1',3.333,3),(250,7452840,7452813,'a10',3.333,3),(250,7452841,7452813,'104',3.333,3),(250,7452842,7452813,'048',3.333,3),(250,7452843,7452813,'481',3.333,3),(250,7452844,7452814,'mon',100,1),(250,7452845,7452844,'201',50,1),(250,7452846,7452844,'013',50,1),(250,7452847,7452845,'adm',33.333,3),(250,7452848,7452845,'dmi',33.333,3),(250,7452849,7452845,'min',33.333,3),(250,7452850,7452847,'cap',16.667,1),(250,7452851,7452847,'apa',16.667,1),(250,7452852,7452847,'pac',16.667,1),(250,7452853,7452847,'aci',16.667,1),(250,7452854,7452847,'cit',16.667,1),(250,7452855,7452847,'ity',16.667,1),(250,7452856,7452850,'pat',50,1),(250,7452857,7452850,'ath',50,1),(250,7452858,7452856,'six',100,1),(250,7452859,7452858,'fre',14.286,1),(250,7452860,7452858,'ree',14.286,1),(250,7452861,7452858,'ees',14.286,1),(250,7452862,7452858,'esp',14.286,1),(250,7452863,7452858,'spa',14.286,1),(250,7452864,7452858,'pac',14.286,1),(250,7452865,7452858,'ace',14.286,1),(250,7452866,7452859,'dis',50,1),(250,7452867,7452859,'isk',50,1),(250,7452868,7452866,'ind',33.333,1),(250,7452869,7452866,'nde',33.333,1),(250,7452870,7452866,'dex',33.333,1),(250,7452871,7452868,'adm',8.333,1),(250,7452872,7452868,'dmi',8.333,1),(250,7452873,7452868,'min',8.333,1),(250,7452874,7452868,'ini',8.333,1),(250,7452875,7452868,'nis',8.333,1),(250,7452876,7452868,'ist',8.333,1),(250,7452877,7452868,'str',8.333,1),(250,7452878,7452868,'tra',8.333,1),(250,7452879,7452868,'rat',8.333,1),(250,7452880,7452868,'ati',8.333,1),(250,7452881,7452868,'tio',8.333,1),(250,7452882,7452868,'ion',8.333,1),(250,7452883,7452871,'sta',33.333,3),(250,7452884,7452871,'tat',33.333,3),(250,7452885,7452871,'ate',33.333,3),(250,7452886,7452883,'ena',20,2),(250,7452887,7452883,'nab',20,2),(250,7452888,7452883,'abl',20,2),(250,7452889,7452883,'ble',20,2),(250,7452890,7452883,'led',20,2),(250,7452891,7452886,'cac',33.333,1),(250,7452892,7452886,'ach',33.333,1),(250,7452893,7452886,'che',33.333,1),(250,7452894,7452891,'mod',50,2),(250,7452895,7452891,'ode',50,2),(250,7452896,7452894,'wri',14.286,2),(250,7452897,7452894,'rit',14.286,2),(250,7452898,7452894,'ite',14.286,2),(250,7452899,7452894,'tet',14.286,2),(250,7452900,7452894,'eth',14.286,2),(250,7452901,7452894,'thr',14.286,2),(250,7452902,7452894,'hru',14.286,2),(250,7452903,7452896,'ope',11.111,2),(250,7452904,7452896,'per',11.111,2),(250,7452905,7452896,'era',11.111,2),(250,7452906,7452896,'rat',11.111,2),(250,7452907,7452896,'ati',11.111,2),(250,7452908,7452896,'tio',11.111,2),(250,7452909,7452896,'ion',11.111,2),(250,7452910,7452896,'ona',11.111,2),(250,7452911,7452896,'nal',11.111,2),(250,7452912,7452903,'nor',25,1),(250,7452913,7452903,'orm',25,1),(250,7452914,7452903,'rma',25,1),(250,7452915,7452903,'mal',25,1),(250,7452916,7452912,'mes',20,1),(250,7452917,7452912,'ess',20,1),(250,7452918,7452912,'ssa',20,1),(250,7452919,7452912,'sag',20,1),(250,7452920,7452912,'age',20,1),(250,7452921,7452916,'per',11.111,1),(250,7452922,7452916,'erf',11.111,1),(250,7452923,7452916,'rfo',11.111,1),(250,7452924,7452916,'for',11.111,1),(250,7452925,7452916,'orm',11.111,1),(250,7452926,7452916,'rma',11.111,1),(250,7452927,7452916,'man',11.111,1),(250,7452928,7452916,'anc',11.111,1),(250,7452929,7452916,'nce',11.111,1),(250,7452930,7452921,'ide',12.5,1),(250,7452931,7452921,'den',12.5,1),(250,7452932,7452921,'ent',12.5,1),(250,7452933,7452921,'nti',12.5,1),(250,7452934,7452921,'tif',12.5,1),(250,7452935,7452921,'ifi',12.5,1),(250,7452936,7452921,'fie',12.5,1),(250,7452937,7452921,'ier',12.5,1),(250,7452938,7452930,'vdi',33.333,3),(250,7452939,7452930,'dis',33.333,3),(250,7452940,7452930,'isk',33.333,3),(250,7452941,7452938,'nam',50,1),(250,7452942,7452938,'ame',50,1),(250,7452943,7452941,'typ',50,1),(250,7452944,7452941,'ype',50,1),(250,7452945,7452943,'dir',25,1),(250,7452946,7452943,'ire',25,1),(250,7452947,7452943,'rec',25,1),(250,7452948,7452943,'ect',25,1),(251,7452950,7452949,'naa',100,2),(251,7452951,7452950,'600',3.333,3),(251,7452952,7452950,'000',3.333,3),(251,7452953,7452950,'00c',3.333,3),(251,7452954,7452950,'0c2',3.333,3),(251,7452955,7452950,'c29',3.333,3),(251,7452956,7452950,'295',3.333,3),(251,7452957,7452950,'95e',3.333,3),(251,7452958,7452950,'5e3',3.333,3),(251,7452959,7452950,'e3f',3.333,3),(251,7452960,7452950,'3f8',3.333,3),(251,7452961,7452950,'f8a',3.333,3),(251,7452962,7452950,'8a5',3.333,3),(251,7452963,7452950,'a5d',3.333,3),(251,7452964,7452950,'5d4',3.333,3),(251,7452965,7452950,'d41',3.333,3),(251,7452966,7452950,'411',3.333,3),(251,7452967,7452950,'112',3.333,3),(251,7452968,7452950,'12e',3.333,3),(251,7452969,7452950,'2ee',3.333,3),(251,7452970,7452950,'eea',3.333,3),(251,7452971,7452950,'ea7',3.333,3),(251,7452972,7452950,'a72',3.333,3),(251,7452973,7452950,'727',3.333,3),(251,7452974,7452950,'271',3.333,3),(251,7452975,7452950,'713',3.333,3),(251,7452976,7452950,'13d',3.333,3),(251,7452977,7452950,'3da',3.333,3),(251,7452978,7452950,'daf',3.333,3),(251,7452979,7452950,'afc',3.333,3),(251,7452980,7452950,'fc7',3.333,3),(251,7452981,7452951,'mon',100,1),(251,7452982,7452981,'201',50,1),(251,7452983,7452981,'013',50,1),(251,7452984,7452982,'adm',33.333,3),(251,7452985,7452982,'dmi',33.333,3),(251,7452986,7452982,'min',33.333,3),(251,7452987,7452984,'cap',16.667,1),(251,7452988,7452984,'apa',16.667,1),(251,7452989,7452984,'pac',16.667,1),(251,7452990,7452984,'aci',16.667,1),(251,7452991,7452984,'cit',16.667,1),(251,7452992,7452984,'ity',16.667,1),(251,7452993,7452987,'pat',50,1),(251,7452994,7452987,'ath',50,1),(251,7452995,7452993,'sev',33.333,1),(251,7452996,7452993,'eve',33.333,1),(251,7452997,7452993,'ven',33.333,1),(251,7452998,7452995,'fre',14.286,1),(251,7452999,7452995,'ree',14.286,1),(251,7453000,7452995,'ees',14.286,1),(251,7453001,7452995,'esp',14.286,1),(251,7453002,7452995,'spa',14.286,1),(251,7453003,7452995,'pac',14.286,1),(251,7453004,7452995,'ace',14.286,1),(251,7453005,7452998,'dis',50,1),(251,7453006,7452998,'isk',50,1),(251,7453007,7453005,'ind',33.333,1),(251,7453008,7453005,'nde',33.333,1),(251,7453009,7453005,'dex',33.333,1),(251,7453010,7453007,'adm',8.333,1),(251,7453011,7453007,'dmi',8.333,1),(251,7453012,7453007,'min',8.333,1),(251,7453013,7453007,'ini',8.333,1),(251,7453014,7453007,'nis',8.333,1),(251,7453015,7453007,'ist',8.333,1),(251,7453016,7453007,'str',8.333,1),(251,7453017,7453007,'tra',8.333,1),(251,7453018,7453007,'rat',8.333,1),(251,7453019,7453007,'ati',8.333,1),(251,7453020,7453007,'tio',8.333,1),(251,7453021,7453007,'ion',8.333,1),(251,7453022,7453010,'sta',33.333,3),(251,7453023,7453010,'tat',33.333,3),(251,7453024,7453010,'ate',33.333,3),(251,7453025,7453022,'ena',20,2),(251,7453026,7453022,'nab',20,2),(251,7453027,7453022,'abl',20,2),(251,7453028,7453022,'ble',20,2),(251,7453029,7453022,'led',20,2),(251,7453030,7453025,'cac',33.333,1),(251,7453031,7453025,'ach',33.333,1),(251,7453032,7453025,'che',33.333,1),(251,7453033,7453030,'mod',50,2),(251,7453034,7453030,'ode',50,2),(251,7453035,7453033,'wri',14.286,2),(251,7453036,7453033,'rit',14.286,2),(251,7453037,7453033,'ite',14.286,2),(251,7453038,7453033,'tet',14.286,2),(251,7453039,7453033,'eth',14.286,2),(251,7453040,7453033,'thr',14.286,2),(251,7453041,7453033,'hru',14.286,2),(251,7453042,7453035,'ope',11.111,2),(251,7453043,7453035,'per',11.111,2),(251,7453044,7453035,'era',11.111,2),(251,7453045,7453035,'rat',11.111,2),(251,7453046,7453035,'ati',11.111,2),(251,7453047,7453035,'tio',11.111,2),(251,7453048,7453035,'ion',11.111,2),(251,7453049,7453035,'ona',11.111,2),(251,7453050,7453035,'nal',11.111,2),(251,7453051,7453042,'nor',25,1),(251,7453052,7453042,'orm',25,1),(251,7453053,7453042,'rma',25,1),(251,7453054,7453042,'mal',25,1),(251,7453055,7453051,'mes',20,1),(251,7453056,7453051,'ess',20,1),(251,7453057,7453051,'ssa',20,1),(251,7453058,7453051,'sag',20,1),(251,7453059,7453051,'age',20,1),(251,7453060,7453055,'per',11.111,1),(251,7453061,7453055,'erf',11.111,1),(251,7453062,7453055,'rfo',11.111,1),(251,7453063,7453055,'for',11.111,1),(251,7453064,7453055,'orm',11.111,1),(251,7453065,7453055,'rma',11.111,1),(251,7453066,7453055,'man',11.111,1),(251,7453067,7453055,'anc',11.111,1),(251,7453068,7453055,'nce',11.111,1),(251,7453069,7453060,'ide',12.5,1),(251,7453070,7453060,'den',12.5,1),(251,7453071,7453060,'ent',12.5,1),(251,7453072,7453060,'nti',12.5,1),(251,7453073,7453060,'tif',12.5,1),(251,7453074,7453060,'ifi',12.5,1),(251,7453075,7453060,'fie',12.5,1),(251,7453076,7453060,'ier',12.5,1),(251,7453077,7453069,'vdi',33.333,3),(251,7453078,7453069,'dis',33.333,3),(251,7453079,7453069,'isk',33.333,3),(251,7453080,7453077,'nam',50,1),(251,7453081,7453077,'ame',50,1),(251,7453082,7453080,'typ',50,1),(251,7453083,7453080,'ype',50,1),(251,7453084,7453082,'dir',25,1),(251,7453085,7453082,'ire',25,1),(251,7453086,7453082,'rec',25,1),(251,7453087,7453082,'ect',25,1),(252,7453089,7453088,'naa',100,2),(252,7453090,7453089,'600',3.333,3),(252,7453091,7453089,'000',3.333,3),(252,7453092,7453089,'00c',3.333,3),(252,7453093,7453089,'0c2',3.333,3),(252,7453094,7453089,'c29',3.333,3),(252,7453095,7453089,'292',3.333,3),(252,7453096,7453089,'928',3.333,3),(252,7453097,7453089,'28d',3.333,3),(252,7453098,7453089,'8d3',3.333,3),(252,7453099,7453089,'d38',3.333,3),(252,7453100,7453089,'384',3.333,3),(252,7453101,7453089,'847',3.333,3),(252,7453102,7453089,'47d',3.333,3),(252,7453103,7453089,'7de',3.333,3),(252,7453104,7453089,'de8',3.333,3),(252,7453105,7453089,'e8b',3.333,3),(252,7453106,7453089,'8b7',3.333,3),(252,7453107,7453089,'b71',3.333,3),(252,7453108,7453089,'714',3.333,3),(252,7453109,7453089,'149',3.333,3),(252,7453110,7453089,'494',3.333,3),(252,7453111,7453089,'947',3.333,3),(252,7453112,7453089,'47e',3.333,3),(252,7453113,7453089,'7eb',3.333,3),(252,7453114,7453089,'ebe',3.333,3),(252,7453115,7453089,'be8',3.333,3),(252,7453116,7453089,'e88',3.333,3),(252,7453117,7453089,'881',3.333,3),(252,7453118,7453089,'813',3.333,3),(252,7453119,7453089,'135',3.333,3),(252,7453120,7453090,'mon',100,1),(252,7453121,7453120,'201',50,1),(252,7453122,7453120,'013',50,1),(252,7453123,7453121,'adm',33.333,3),(252,7453124,7453121,'dmi',33.333,3),(252,7453125,7453121,'min',33.333,3),(252,7453126,7453123,'cap',16.667,1),(252,7453127,7453123,'apa',16.667,1),(252,7453128,7453123,'pac',16.667,1),(252,7453129,7453123,'aci',16.667,1),(252,7453130,7453123,'cit',16.667,1),(252,7453131,7453123,'ity',16.667,1),(252,7453132,7453126,'pat',50,1),(252,7453133,7453126,'ath',50,1),(252,7453134,7453132,'eig',33.333,1),(252,7453135,7453132,'igh',33.333,1),(252,7453136,7453132,'ght',33.333,1),(252,7453137,7453134,'fre',14.286,1),(252,7453138,7453134,'ree',14.286,1),(252,7453139,7453134,'ees',14.286,1),(252,7453140,7453134,'esp',14.286,1),(252,7453141,7453134,'spa',14.286,1),(252,7453142,7453134,'pac',14.286,1),(252,7453143,7453134,'ace',14.286,1),(252,7453144,7453137,'dis',50,1),(252,7453145,7453137,'isk',50,1),(252,7453146,7453144,'ind',33.333,1),(252,7453147,7453144,'nde',33.333,1),(252,7453148,7453144,'dex',33.333,1),(252,7453149,7453146,'adm',8.333,1),(252,7453150,7453146,'dmi',8.333,1),(252,7453151,7453146,'min',8.333,1),(252,7453152,7453146,'ini',8.333,1),(252,7453153,7453146,'nis',8.333,1),(252,7453154,7453146,'ist',8.333,1),(252,7453155,7453146,'str',8.333,1),(252,7453156,7453146,'tra',8.333,1),(252,7453157,7453146,'rat',8.333,1),(252,7453158,7453146,'ati',8.333,1),(252,7453159,7453146,'tio',8.333,1),(252,7453160,7453146,'ion',8.333,1),(252,7453161,7453149,'sta',33.333,3),(252,7453162,7453149,'tat',33.333,3),(252,7453163,7453149,'ate',33.333,3),(252,7453164,7453161,'ena',20,2),(252,7453165,7453161,'nab',20,2),(252,7453166,7453161,'abl',20,2),(252,7453167,7453161,'ble',20,2),(252,7453168,7453161,'led',20,2),(252,7453169,7453164,'cac',33.333,1),(252,7453170,7453164,'ach',33.333,1),(252,7453171,7453164,'che',33.333,1),(252,7453172,7453169,'mod',50,2),(252,7453173,7453169,'ode',50,2),(252,7453174,7453172,'wri',14.286,2),(252,7453175,7453172,'rit',14.286,2),(252,7453176,7453172,'ite',14.286,2),(252,7453177,7453172,'tet',14.286,2),(252,7453178,7453172,'eth',14.286,2),(252,7453179,7453172,'thr',14.286,2),(252,7453180,7453172,'hru',14.286,2),(252,7453181,7453174,'ope',11.111,2),(252,7453182,7453174,'per',11.111,2),(252,7453183,7453174,'era',11.111,2),(252,7453184,7453174,'rat',11.111,2),(252,7453185,7453174,'ati',11.111,2),(252,7453186,7453174,'tio',11.111,2),(252,7453187,7453174,'ion',11.111,2),(252,7453188,7453174,'ona',11.111,2),(252,7453189,7453174,'nal',11.111,2),(252,7453190,7453181,'nor',25,1),(252,7453191,7453181,'orm',25,1),(252,7453192,7453181,'rma',25,1),(252,7453193,7453181,'mal',25,1),(252,7453194,7453190,'mes',20,1),(252,7453195,7453190,'ess',20,1),(252,7453196,7453190,'ssa',20,1),(252,7453197,7453190,'sag',20,1),(252,7453198,7453190,'age',20,1),(252,7453199,7453194,'per',11.111,1),(252,7453200,7453194,'erf',11.111,1),(252,7453201,7453194,'rfo',11.111,1),(252,7453202,7453194,'for',11.111,1),(252,7453203,7453194,'orm',11.111,1),(252,7453204,7453194,'rma',11.111,1),(252,7453205,7453194,'man',11.111,1),(252,7453206,7453194,'anc',11.111,1),(252,7453207,7453194,'nce',11.111,1),(252,7453208,7453199,'ide',12.5,1),(252,7453209,7453199,'den',12.5,1),(252,7453210,7453199,'ent',12.5,1),(252,7453211,7453199,'nti',12.5,1),(252,7453212,7453199,'tif',12.5,1),(252,7453213,7453199,'ifi',12.5,1),(252,7453214,7453199,'fie',12.5,1),(252,7453215,7453199,'ier',12.5,1),(252,7453216,7453208,'vdi',33.333,3),(252,7453217,7453208,'dis',33.333,3),(252,7453218,7453208,'isk',33.333,3),(252,7453219,7453216,'nam',50,1),(252,7453220,7453216,'ame',50,1),(252,7453221,7453219,'typ',50,1),(252,7453222,7453219,'ype',50,1),(252,7453223,7453221,'dir',25,1),(252,7453224,7453221,'ire',25,1),(252,7453225,7453221,'rec',25,1),(252,7453226,7453221,'ect',25,1),(253,7453228,7453227,'naa',100,2),(253,7453229,7453228,'600',3.333,3),(253,7453230,7453228,'000',3.333,3),(253,7453231,7453228,'00c',3.333,3),(253,7453232,7453228,'0c2',3.333,3),(253,7453233,7453228,'c29',3.333,3),(253,7453234,7453228,'296',3.333,3),(253,7453235,7453228,'962',3.333,3),(253,7453236,7453228,'625',3.333,3),(253,7453237,7453228,'25d',3.333,3),(253,7453238,7453228,'5d8',3.333,3),(253,7453239,7453228,'d80',3.333,3),(253,7453240,7453228,'808',3.333,3),(253,7453241,7453228,'08e',3.333,3),(253,7453242,7453228,'8ed',3.333,3),(253,7453243,7453228,'ede',3.333,3),(253,7453244,7453228,'de9',3.333,3),(253,7453245,7453228,'e95',3.333,3),(253,7453246,7453228,'952',3.333,3),(253,7453247,7453228,'52e',3.333,3),(253,7453248,7453228,'2e2',3.333,3),(253,7453249,7453228,'e2c',3.333,3),(253,7453250,7453228,'2c0',3.333,3),(253,7453251,7453228,'c05',3.333,3),(253,7453252,7453228,'058',3.333,3),(253,7453253,7453228,'58c',3.333,3),(253,7453254,7453228,'8cf',3.333,3),(253,7453255,7453228,'cf1',3.333,3),(253,7453256,7453228,'f1a',3.333,3),(253,7453257,7453228,'1a3',3.333,3),(253,7453258,7453228,'a34',3.333,3),(253,7453259,7453229,'mon',100,1),(253,7453260,7453259,'201',50,1),(253,7453261,7453259,'013',50,1),(253,7453262,7453260,'adm',33.333,3),(253,7453263,7453260,'dmi',33.333,3),(253,7453264,7453260,'min',33.333,3),(253,7453265,7453262,'cap',16.667,1),(253,7453266,7453262,'apa',16.667,1),(253,7453267,7453262,'pac',16.667,1),(253,7453268,7453262,'aci',16.667,1),(253,7453269,7453262,'cit',16.667,1),(253,7453270,7453262,'ity',16.667,1),(253,7453271,7453265,'pat',50,1),(253,7453272,7453265,'ath',50,1),(253,7453273,7453271,'nin',50,1),(253,7453274,7453271,'ine',50,1),(253,7453275,7453273,'fre',14.286,1),(253,7453276,7453273,'ree',14.286,1),(253,7453277,7453273,'ees',14.286,1),(253,7453278,7453273,'esp',14.286,1),(253,7453279,7453273,'spa',14.286,1),(253,7453280,7453273,'pac',14.286,1),(253,7453281,7453273,'ace',14.286,1),(253,7453282,7453275,'dis',50,1),(253,7453283,7453275,'isk',50,1),(253,7453284,7453282,'ind',33.333,1),(253,7453285,7453282,'nde',33.333,1),(253,7453286,7453282,'dex',33.333,1),(253,7453287,7453284,'adm',8.333,1),(253,7453288,7453284,'dmi',8.333,1),(253,7453289,7453284,'min',8.333,1),(253,7453290,7453284,'ini',8.333,1),(253,7453291,7453284,'nis',8.333,1),(253,7453292,7453284,'ist',8.333,1),(253,7453293,7453284,'str',8.333,1),(253,7453294,7453284,'tra',8.333,1),(253,7453295,7453284,'rat',8.333,1),(253,7453296,7453284,'ati',8.333,1),(253,7453297,7453284,'tio',8.333,1),(253,7453298,7453284,'ion',8.333,1),(253,7453299,7453287,'sta',33.333,3),(253,7453300,7453287,'tat',33.333,3),(253,7453301,7453287,'ate',33.333,3),(253,7453302,7453299,'ena',20,2),(253,7453303,7453299,'nab',20,2),(253,7453304,7453299,'abl',20,2),(253,7453305,7453299,'ble',20,2),(253,7453306,7453299,'led',20,2),(253,7453307,7453302,'cac',33.333,1),(253,7453308,7453302,'ach',33.333,1),(253,7453309,7453302,'che',33.333,1),(253,7453310,7453307,'mod',50,2),(253,7453311,7453307,'ode',50,2),(253,7453312,7453310,'wri',14.286,2),(253,7453313,7453310,'rit',14.286,2),(253,7453314,7453310,'ite',14.286,2),(253,7453315,7453310,'tet',14.286,2),(253,7453316,7453310,'eth',14.286,2),(253,7453317,7453310,'thr',14.286,2),(253,7453318,7453310,'hru',14.286,2),(253,7453319,7453312,'ope',11.111,2),(253,7453320,7453312,'per',11.111,2),(253,7453321,7453312,'era',11.111,2),(253,7453322,7453312,'rat',11.111,2),(253,7453323,7453312,'ati',11.111,2),(253,7453324,7453312,'tio',11.111,2),(253,7453325,7453312,'ion',11.111,2),(253,7453326,7453312,'ona',11.111,2),(253,7453327,7453312,'nal',11.111,2),(253,7453328,7453319,'nor',25,1),(253,7453329,7453319,'orm',25,1),(253,7453330,7453319,'rma',25,1),(253,7453331,7453319,'mal',25,1),(253,7453332,7453328,'mes',20,1),(253,7453333,7453328,'ess',20,1),(253,7453334,7453328,'ssa',20,1),(253,7453335,7453328,'sag',20,1),(253,7453336,7453328,'age',20,1),(253,7453337,7453332,'per',11.111,1),(253,7453338,7453332,'erf',11.111,1),(253,7453339,7453332,'rfo',11.111,1),(253,7453340,7453332,'for',11.111,1),(253,7453341,7453332,'orm',11.111,1),(253,7453342,7453332,'rma',11.111,1),(253,7453343,7453332,'man',11.111,1),(253,7453344,7453332,'anc',11.111,1),(253,7453345,7453332,'nce',11.111,1),(253,7453346,7453337,'ide',12.5,1),(253,7453347,7453337,'den',12.5,1),(253,7453348,7453337,'ent',12.5,1),(253,7453349,7453337,'nti',12.5,1),(253,7453350,7453337,'tif',12.5,1),(253,7453351,7453337,'ifi',12.5,1),(253,7453352,7453337,'fie',12.5,1),(253,7453353,7453337,'ier',12.5,1),(253,7453354,7453346,'vdi',33.333,3),(253,7453355,7453346,'dis',33.333,3),(253,7453356,7453346,'isk',33.333,3),(253,7453357,7453354,'nam',50,1),(253,7453358,7453354,'ame',50,1),(253,7453359,7453357,'typ',50,1),(253,7453360,7453357,'ype',50,1),(253,7453361,7453359,'dir',25,1),(253,7453362,7453359,'ire',25,1),(253,7453363,7453359,'rec',25,1),(253,7453364,7453359,'ect',25,1),(254,7453366,7453365,'naa',100,2),(254,7453367,7453366,'600',3.333,3),(254,7453368,7453366,'000',3.333,3),(254,7453369,7453366,'00c',3.333,3),(254,7453370,7453366,'0c2',3.333,3),(254,7453371,7453366,'c29',3.333,3),(254,7453372,7453366,'297',3.333,3),(254,7453373,7453366,'973',3.333,3),(254,7453374,7453366,'73f',3.333,3),(254,7453375,7453366,'3fc',3.333,3),(254,7453376,7453366,'fc3',3.333,3),(254,7453377,7453366,'c35',3.333,3),(254,7453378,7453366,'357',3.333,3),(254,7453379,7453366,'578',3.333,3),(254,7453380,7453366,'786',3.333,3),(254,7453381,7453366,'862',3.333,3),(254,7453382,7453366,'62a',3.333,3),(254,7453383,7453366,'2a1',3.333,3),(254,7453384,7453366,'a1d',3.333,3),(254,7453385,7453366,'1d1',3.333,3),(254,7453386,7453366,'d1f',3.333,3),(254,7453387,7453366,'1f9',3.333,3),(254,7453388,7453366,'f9a',3.333,3),(254,7453389,7453366,'9aa',3.333,3),(254,7453390,7453366,'aad',3.333,3),(254,7453391,7453366,'ad0',3.333,3),(254,7453392,7453366,'d0e',3.333,3),(254,7453393,7453366,'0ee',3.333,3),(254,7453394,7453366,'ee3',3.333,3),(254,7453395,7453366,'e35',3.333,3),(254,7453396,7453366,'35d',3.333,3),(254,7453397,7453367,'mon',100,1),(254,7453398,7453397,'201',50,1),(254,7453399,7453397,'013',50,1),(254,7453400,7453398,'adm',33.333,3),(254,7453401,7453398,'dmi',33.333,3),(254,7453402,7453398,'min',33.333,3),(254,7453403,7453400,'cap',16.667,1),(254,7453404,7453400,'apa',16.667,1),(254,7453405,7453400,'pac',16.667,1),(254,7453406,7453400,'aci',16.667,1),(254,7453407,7453400,'cit',16.667,1),(254,7453408,7453400,'ity',16.667,1),(254,7453409,7453403,'pat',50,1),(254,7453410,7453403,'ath',50,1),(254,7453411,7453409,'ten',100,1),(254,7453412,7453411,'fre',14.286,1),(254,7453413,7453411,'ree',14.286,1),(254,7453414,7453411,'ees',14.286,1),(254,7453415,7453411,'esp',14.286,1),(254,7453416,7453411,'spa',14.286,1),(254,7453417,7453411,'pac',14.286,1),(254,7453418,7453411,'ace',14.286,1),(254,7453419,7453412,'dis',50,1),(254,7453420,7453412,'isk',50,1),(254,7453421,7453419,'ind',33.333,1),(254,7453422,7453419,'nde',33.333,1),(254,7453423,7453419,'dex',33.333,1),(254,7453424,7453421,'adm',8.333,1),(254,7453425,7453421,'dmi',8.333,1),(254,7453426,7453421,'min',8.333,1),(254,7453427,7453421,'ini',8.333,1),(254,7453428,7453421,'nis',8.333,1),(254,7453429,7453421,'ist',8.333,1),(254,7453430,7453421,'str',8.333,1),(254,7453431,7453421,'tra',8.333,1),(254,7453432,7453421,'rat',8.333,1),(254,7453433,7453421,'ati',8.333,1),(254,7453434,7453421,'tio',8.333,1),(254,7453435,7453421,'ion',8.333,1),(254,7453436,7453424,'sta',33.333,3),(254,7453437,7453424,'tat',33.333,3),(254,7453438,7453424,'ate',33.333,3),(254,7453439,7453436,'ena',20,2),(254,7453440,7453436,'nab',20,2),(254,7453441,7453436,'abl',20,2),(254,7453442,7453436,'ble',20,2),(254,7453443,7453436,'led',20,2),(254,7453444,7453439,'cac',33.333,1),(254,7453445,7453439,'ach',33.333,1),(254,7453446,7453439,'che',33.333,1),(254,7453447,7453444,'mod',50,2),(254,7453448,7453444,'ode',50,2),(254,7453449,7453447,'wri',14.286,2),(254,7453450,7453447,'rit',14.286,2),(254,7453451,7453447,'ite',14.286,2),(254,7453452,7453447,'tet',14.286,2),(254,7453453,7453447,'eth',14.286,2),(254,7453454,7453447,'thr',14.286,2),(254,7453455,7453447,'hru',14.286,2),(254,7453456,7453449,'ope',11.111,2),(254,7453457,7453449,'per',11.111,2),(254,7453458,7453449,'era',11.111,2),(254,7453459,7453449,'rat',11.111,2),(254,7453460,7453449,'ati',11.111,2),(254,7453461,7453449,'tio',11.111,2),(254,7453462,7453449,'ion',11.111,2),(254,7453463,7453449,'ona',11.111,2),(254,7453464,7453449,'nal',11.111,2),(254,7453465,7453456,'nor',25,1),(254,7453466,7453456,'orm',25,1),(254,7453467,7453456,'rma',25,1),(254,7453468,7453456,'mal',25,1),(254,7453469,7453465,'mes',20,1),(254,7453470,7453465,'ess',20,1),(254,7453471,7453465,'ssa',20,1),(254,7453472,7453465,'sag',20,1),(254,7453473,7453465,'age',20,1),(254,7453474,7453469,'per',11.111,1),(254,7453475,7453469,'erf',11.111,1),(254,7453476,7453469,'rfo',11.111,1),(254,7453477,7453469,'for',11.111,1),(254,7453478,7453469,'orm',11.111,1),(254,7453479,7453469,'rma',11.111,1),(254,7453480,7453469,'man',11.111,1),(254,7453481,7453469,'anc',11.111,1),(254,7453482,7453469,'nce',11.111,1),(254,7453483,7453474,'ide',12.5,1),(254,7453484,7453474,'den',12.5,1),(254,7453485,7453474,'ent',12.5,1),(254,7453486,7453474,'nti',12.5,1),(254,7453487,7453474,'tif',12.5,1),(254,7453488,7453474,'ifi',12.5,1),(254,7453489,7453474,'fie',12.5,1),(254,7453490,7453474,'ier',12.5,1),(254,7453491,7453483,'vdi',33.333,3),(254,7453492,7453483,'dis',33.333,3),(254,7453493,7453483,'isk',33.333,3),(254,7453494,7453491,'nam',50,1),(254,7453495,7453491,'ame',50,1),(254,7453496,7453494,'typ',50,1),(254,7453497,7453494,'ype',50,1),(254,7453498,7453496,'dir',25,1),(254,7453499,7453496,'ire',25,1),(254,7453500,7453496,'rec',25,1),(254,7453501,7453496,'ect',25,1),(255,7453503,7453502,'naa',100,2),(255,7453504,7453503,'600',3.333,3),(255,7453505,7453503,'000',3.333,3),(255,7453506,7453503,'00c',3.333,3),(255,7453507,7453503,'0c2',3.333,3),(255,7453508,7453503,'c29',3.333,3),(255,7453509,7453503,'292',3.333,3),(255,7453510,7453503,'92d',3.333,3),(255,7453511,7453503,'2dc',3.333,3),(255,7453512,7453503,'dc5',3.333,3),(255,7453513,7453503,'c5b',3.333,3),(255,7453514,7453503,'5b7',3.333,3),(255,7453515,7453503,'b74',3.333,3),(255,7453516,7453503,'74e',3.333,3),(255,7453517,7453503,'4ee',3.333,3),(255,7453518,7453503,'eee',3.333,3),(255,7453519,7453503,'eed',3.333,3),(255,7453520,7453503,'ed4',3.333,3),(255,7453521,7453503,'d4b',3.333,3),(255,7453522,7453503,'4bd',3.333,3),(255,7453523,7453503,'bd4',3.333,3),(255,7453524,7453503,'d44',3.333,3),(255,7453525,7453503,'445',3.333,3),(255,7453526,7453503,'459',3.333,3),(255,7453527,7453503,'591',3.333,3),(255,7453528,7453503,'913',3.333,3),(255,7453529,7453503,'134',3.333,3),(255,7453530,7453503,'340',3.333,3),(255,7453531,7453503,'40e',3.333,3),(255,7453532,7453503,'0e1',3.333,3),(255,7453533,7453503,'e16',3.333,3),(255,7453534,7453504,'mon',100,1),(255,7453535,7453534,'201',50,1),(255,7453536,7453534,'013',50,1),(255,7453537,7453535,'adm',33.333,3),(255,7453538,7453535,'dmi',33.333,3),(255,7453539,7453535,'min',33.333,3),(255,7453540,7453537,'cap',16.667,1),(255,7453541,7453537,'apa',16.667,1),(255,7453542,7453537,'pac',16.667,1),(255,7453543,7453537,'aci',16.667,1),(255,7453544,7453537,'cit',16.667,1),(255,7453545,7453537,'ity',16.667,1),(255,7453546,7453540,'pat',50,1),(255,7453547,7453540,'ath',50,1),(255,7453548,7453546,'ele',25,1),(255,7453549,7453546,'lev',25,1),(255,7453550,7453546,'eve',25,1),(255,7453551,7453546,'ven',25,1),(255,7453552,7453548,'fre',14.286,1),(255,7453553,7453548,'ree',14.286,1),(255,7453554,7453548,'ees',14.286,1),(255,7453555,7453548,'esp',14.286,1),(255,7453556,7453548,'spa',14.286,1),(255,7453557,7453548,'pac',14.286,1),(255,7453558,7453548,'ace',14.286,1),(255,7453559,7453552,'dis',50,1),(255,7453560,7453552,'isk',50,1),(255,7453561,7453559,'ind',33.333,1),(255,7453562,7453559,'nde',33.333,1),(255,7453563,7453559,'dex',33.333,1),(255,7453564,7453561,'adm',8.333,1),(255,7453565,7453561,'dmi',8.333,1),(255,7453566,7453561,'min',8.333,1),(255,7453567,7453561,'ini',8.333,1),(255,7453568,7453561,'nis',8.333,1),(255,7453569,7453561,'ist',8.333,1),(255,7453570,7453561,'str',8.333,1),(255,7453571,7453561,'tra',8.333,1),(255,7453572,7453561,'rat',8.333,1),(255,7453573,7453561,'ati',8.333,1),(255,7453574,7453561,'tio',8.333,1),(255,7453575,7453561,'ion',8.333,1),(255,7453576,7453564,'sta',33.333,3),(255,7453577,7453564,'tat',33.333,3),(255,7453578,7453564,'ate',33.333,3),(255,7453579,7453576,'ena',20,2),(255,7453580,7453576,'nab',20,2),(255,7453581,7453576,'abl',20,2),(255,7453582,7453576,'ble',20,2),(255,7453583,7453576,'led',20,2),(255,7453584,7453579,'cac',33.333,1),(255,7453585,7453579,'ach',33.333,1),(255,7453586,7453579,'che',33.333,1),(255,7453587,7453584,'mod',50,2),(255,7453588,7453584,'ode',50,2),(255,7453589,7453587,'wri',14.286,2),(255,7453590,7453587,'rit',14.286,2),(255,7453591,7453587,'ite',14.286,2),(255,7453592,7453587,'tet',14.286,2),(255,7453593,7453587,'eth',14.286,2),(255,7453594,7453587,'thr',14.286,2),(255,7453595,7453587,'hru',14.286,2),(255,7453596,7453589,'ope',11.111,2),(255,7453597,7453589,'per',11.111,2),(255,7453598,7453589,'era',11.111,2),(255,7453599,7453589,'rat',11.111,2),(255,7453600,7453589,'ati',11.111,2),(255,7453601,7453589,'tio',11.111,2),(255,7453602,7453589,'ion',11.111,2),(255,7453603,7453589,'ona',11.111,2),(255,7453604,7453589,'nal',11.111,2),(255,7453605,7453596,'nor',25,1),(255,7453606,7453596,'orm',25,1),(255,7453607,7453596,'rma',25,1),(255,7453608,7453596,'mal',25,1),(255,7453609,7453605,'mes',20,1),(255,7453610,7453605,'ess',20,1),(255,7453611,7453605,'ssa',20,1),(255,7453612,7453605,'sag',20,1),(255,7453613,7453605,'age',20,1),(255,7453614,7453609,'per',11.111,1),(255,7453615,7453609,'erf',11.111,1),(255,7453616,7453609,'rfo',11.111,1),(255,7453617,7453609,'for',11.111,1),(255,7453618,7453609,'orm',11.111,1),(255,7453619,7453609,'rma',11.111,1),(255,7453620,7453609,'man',11.111,1),(255,7453621,7453609,'anc',11.111,1),(255,7453622,7453609,'nce',11.111,1),(255,7453623,7453614,'ide',12.5,1),(255,7453624,7453614,'den',12.5,1),(255,7453625,7453614,'ent',12.5,1),(255,7453626,7453614,'nti',12.5,1),(255,7453627,7453614,'tif',12.5,1),(255,7453628,7453614,'ifi',12.5,1),(255,7453629,7453614,'fie',12.5,1),(255,7453630,7453614,'ier',12.5,1),(255,7453631,7453623,'vdi',33.333,3),(255,7453632,7453623,'dis',33.333,3),(255,7453633,7453623,'isk',33.333,3),(255,7453634,7453631,'nam',50,1),(255,7453635,7453631,'ame',50,1),(255,7453636,7453634,'typ',50,1),(255,7453637,7453634,'ype',50,1),(255,7453638,7453636,'dir',25,1),(255,7453639,7453636,'ire',25,1),(255,7453640,7453636,'rec',25,1),(255,7453641,7453636,'ect',25,1),(256,7453643,7453642,'naa',100,2),(256,7453644,7453643,'600',3.333,3),(256,7453645,7453643,'000',3.333,3),(256,7453646,7453643,'00c',3.333,3),(256,7453647,7453643,'0c2',3.333,3),(256,7453648,7453643,'c29',3.333,3),(256,7453649,7453643,'29c',3.333,3),(256,7453650,7453643,'9c2',3.333,3),(256,7453651,7453643,'c21',3.333,3),(256,7453652,7453643,'21b',3.333,3),(256,7453653,7453643,'1bb',3.333,3),(256,7453654,7453643,'bb9',3.333,3),(256,7453655,7453643,'b97',3.333,3),(256,7453656,7453643,'973',3.333,3),(256,7453657,7453643,'73e',3.333,3),(256,7453658,7453643,'3e9',3.333,3),(256,7453659,7453643,'e92',3.333,3),(256,7453660,7453643,'92f',3.333,3),(256,7453661,7453643,'2f9',3.333,3),(256,7453662,7453643,'f99',3.333,3),(256,7453663,7453643,'998',3.333,3),(256,7453664,7453643,'98b',3.333,3),(256,7453665,7453643,'8be',3.333,3),(256,7453666,7453643,'bea',3.333,3),(256,7453667,7453643,'ea1',3.333,3),(256,7453668,7453643,'a19',3.333,3),(256,7453669,7453643,'193',3.333,3),(256,7453670,7453643,'93d',3.333,3),(256,7453671,7453643,'3dd',3.333,3),(256,7453672,7453643,'dd1',3.333,3),(256,7453673,7453643,'d18',3.333,3),(256,7453674,7453644,'mon',100,1),(256,7453675,7453674,'201',50,1),(256,7453676,7453674,'013',50,1),(256,7453677,7453675,'adm',33.333,3),(256,7453678,7453675,'dmi',33.333,3),(256,7453679,7453675,'min',33.333,3),(256,7453680,7453677,'cap',16.667,1),(256,7453681,7453677,'apa',16.667,1),(256,7453682,7453677,'pac',16.667,1),(256,7453683,7453677,'aci',16.667,1),(256,7453684,7453677,'cit',16.667,1),(256,7453685,7453677,'ity',16.667,1),(256,7453686,7453680,'pat',50,1),(256,7453687,7453680,'ath',50,1),(256,7453688,7453686,'twe',25,1),(256,7453689,7453686,'wel',25,1),(256,7453690,7453686,'elv',25,1),(256,7453691,7453686,'lve',25,1),(256,7453692,7453688,'fre',14.286,1),(256,7453693,7453688,'ree',14.286,1),(256,7453694,7453688,'ees',14.286,1),(256,7453695,7453688,'esp',14.286,1),(256,7453696,7453688,'spa',14.286,1),(256,7453697,7453688,'pac',14.286,1),(256,7453698,7453688,'ace',14.286,1),(256,7453699,7453692,'dis',50,1),(256,7453700,7453692,'isk',50,1),(256,7453701,7453699,'ind',33.333,1),(256,7453702,7453699,'nde',33.333,1),(256,7453703,7453699,'dex',33.333,1),(256,7453704,7453701,'adm',8.333,1),(256,7453705,7453701,'dmi',8.333,1),(256,7453706,7453701,'min',8.333,1),(256,7453707,7453701,'ini',8.333,1),(256,7453708,7453701,'nis',8.333,1),(256,7453709,7453701,'ist',8.333,1),(256,7453710,7453701,'str',8.333,1),(256,7453711,7453701,'tra',8.333,1),(256,7453712,7453701,'rat',8.333,1),(256,7453713,7453701,'ati',8.333,1),(256,7453714,7453701,'tio',8.333,1),(256,7453715,7453701,'ion',8.333,1),(256,7453716,7453704,'sta',33.333,3),(256,7453717,7453704,'tat',33.333,3),(256,7453718,7453704,'ate',33.333,3),(256,7453719,7453716,'ena',20,2),(256,7453720,7453716,'nab',20,2),(256,7453721,7453716,'abl',20,2),(256,7453722,7453716,'ble',20,2),(256,7453723,7453716,'led',20,2),(256,7453724,7453719,'cac',33.333,1),(256,7453725,7453719,'ach',33.333,1),(256,7453726,7453719,'che',33.333,1),(256,7453727,7453724,'mod',50,2),(256,7453728,7453724,'ode',50,2),(256,7453729,7453727,'wri',14.286,2),(256,7453730,7453727,'rit',14.286,2),(256,7453731,7453727,'ite',14.286,2),(256,7453732,7453727,'tet',14.286,2),(256,7453733,7453727,'eth',14.286,2),(256,7453734,7453727,'thr',14.286,2),(256,7453735,7453727,'hru',14.286,2),(256,7453736,7453729,'ope',11.111,2),(256,7453737,7453729,'per',11.111,2),(256,7453738,7453729,'era',11.111,2),(256,7453739,7453729,'rat',11.111,2),(256,7453740,7453729,'ati',11.111,2),(256,7453741,7453729,'tio',11.111,2),(256,7453742,7453729,'ion',11.111,2),(256,7453743,7453729,'ona',11.111,2),(256,7453744,7453729,'nal',11.111,2),(256,7453745,7453736,'nor',25,1),(256,7453746,7453736,'orm',25,1),(256,7453747,7453736,'rma',25,1),(256,7453748,7453736,'mal',25,1),(256,7453749,7453745,'mes',20,1),(256,7453750,7453745,'ess',20,1),(256,7453751,7453745,'ssa',20,1),(256,7453752,7453745,'sag',20,1),(256,7453753,7453745,'age',20,1),(256,7453754,7453749,'per',11.111,1),(256,7453755,7453749,'erf',11.111,1),(256,7453756,7453749,'rfo',11.111,1),(256,7453757,7453749,'for',11.111,1),(256,7453758,7453749,'orm',11.111,1),(256,7453759,7453749,'rma',11.111,1),(256,7453760,7453749,'man',11.111,1),(256,7453761,7453749,'anc',11.111,1),(256,7453762,7453749,'nce',11.111,1),(256,7453763,7453754,'ide',12.5,1),(256,7453764,7453754,'den',12.5,1),(256,7453765,7453754,'ent',12.5,1),(256,7453766,7453754,'nti',12.5,1),(256,7453767,7453754,'tif',12.5,1),(256,7453768,7453754,'ifi',12.5,1),(256,7453769,7453754,'fie',12.5,1),(256,7453770,7453754,'ier',12.5,1),(256,7453771,7453763,'vdi',33.333,3),(256,7453772,7453763,'dis',33.333,3),(256,7453773,7453763,'isk',33.333,3),(256,7453774,7453771,'nam',50,1),(256,7453775,7453771,'ame',50,1),(256,7453776,7453774,'typ',50,1),(256,7453777,7453774,'ype',50,1),(256,7453778,7453776,'dir',25,1),(256,7453779,7453776,'ire',25,1),(256,7453780,7453776,'rec',25,1),(256,7453781,7453776,'ect',25,1),(257,7453783,7453782,'naa',100,2),(257,7453784,7453783,'600',3.333,3),(257,7453785,7453783,'000',3.333,3),(257,7453786,7453783,'00c',3.333,3),(257,7453787,7453783,'0c2',3.333,3),(257,7453788,7453783,'c29',3.333,3),(257,7453789,7453783,'291',3.333,3),(257,7453790,7453783,'91a',3.333,3),(257,7453791,7453783,'1ad',3.333,3),(257,7453792,7453783,'ad1',3.333,3),(257,7453793,7453783,'d1e',3.333,3),(257,7453794,7453783,'1e4',3.333,3),(257,7453795,7453783,'e48',3.333,3),(257,7453796,7453783,'480',3.333,3),(257,7453797,7453783,'80e',3.333,3),(257,7453798,7453783,'0ea',3.333,3),(257,7453799,7453783,'ea3',3.333,3),(257,7453800,7453783,'a3b',3.333,3),(257,7453801,7453783,'3b8',3.333,3),(257,7453802,7453783,'b8d',3.333,3),(257,7453803,7453783,'8d7',3.333,3),(257,7453804,7453783,'d79',3.333,3),(257,7453805,7453783,'793',3.333,3),(257,7453806,7453783,'93f',3.333,3),(257,7453807,7453783,'3ff',3.333,3),(257,7453808,7453783,'ff8',3.333,3),(257,7453809,7453783,'f80',3.333,3),(257,7453810,7453783,'800',3.333,3),(257,7453811,7453783,'001',3.333,3),(257,7453812,7453783,'01c',3.333,3),(257,7453813,7453783,'1cd',3.333,3),(257,7453814,7453784,'mon',100,1),(257,7453815,7453814,'201',50,1),(257,7453816,7453814,'013',50,1),(257,7453817,7453815,'adm',33.333,3),(257,7453818,7453815,'dmi',33.333,3),(257,7453819,7453815,'min',33.333,3),(257,7453820,7453817,'cap',16.667,1),(257,7453821,7453817,'apa',16.667,1),(257,7453822,7453817,'pac',16.667,1),(257,7453823,7453817,'aci',16.667,1),(257,7453824,7453817,'cit',16.667,1),(257,7453825,7453817,'ity',16.667,1),(257,7453826,7453820,'pat',50,1),(257,7453827,7453820,'ath',50,1),(257,7453828,7453826,'thi',16.667,1),(257,7453829,7453826,'hir',16.667,1),(257,7453830,7453826,'irt',16.667,1),(257,7453831,7453826,'rte',16.667,1),(257,7453832,7453826,'tee',16.667,1),(257,7453833,7453826,'een',16.667,1),(257,7453834,7453828,'fre',14.286,1),(257,7453835,7453828,'ree',14.286,1),(257,7453836,7453828,'ees',14.286,1),(257,7453837,7453828,'esp',14.286,1),(257,7453838,7453828,'spa',14.286,1),(257,7453839,7453828,'pac',14.286,1),(257,7453840,7453828,'ace',14.286,1),(257,7453841,7453834,'dis',50,1),(257,7453842,7453834,'isk',50,1),(257,7453843,7453841,'ind',33.333,1),(257,7453844,7453841,'nde',33.333,1),(257,7453845,7453841,'dex',33.333,1),(257,7453846,7453843,'adm',8.333,1),(257,7453847,7453843,'dmi',8.333,1),(257,7453848,7453843,'min',8.333,1),(257,7453849,7453843,'ini',8.333,1),(257,7453850,7453843,'nis',8.333,1),(257,7453851,7453843,'ist',8.333,1),(257,7453852,7453843,'str',8.333,1),(257,7453853,7453843,'tra',8.333,1),(257,7453854,7453843,'rat',8.333,1),(257,7453855,7453843,'ati',8.333,1),(257,7453856,7453843,'tio',8.333,1),(257,7453857,7453843,'ion',8.333,1),(257,7453858,7453846,'sta',33.333,3),(257,7453859,7453846,'tat',33.333,3),(257,7453860,7453846,'ate',33.333,3),(257,7453861,7453858,'ena',20,2),(257,7453862,7453858,'nab',20,2),(257,7453863,7453858,'abl',20,2),(257,7453864,7453858,'ble',20,2),(257,7453865,7453858,'led',20,2),(257,7453866,7453861,'cac',33.333,1),(257,7453867,7453861,'ach',33.333,1),(257,7453868,7453861,'che',33.333,1),(257,7453869,7453866,'mod',50,2),(257,7453870,7453866,'ode',50,2),(257,7453871,7453869,'wri',14.286,2),(257,7453872,7453869,'rit',14.286,2),(257,7453873,7453869,'ite',14.286,2),(257,7453874,7453869,'tet',14.286,2),(257,7453875,7453869,'eth',14.286,2),(257,7453876,7453869,'thr',14.286,2),(257,7453877,7453869,'hru',14.286,2),(257,7453878,7453871,'ope',11.111,2),(257,7453879,7453871,'per',11.111,2),(257,7453880,7453871,'era',11.111,2),(257,7453881,7453871,'rat',11.111,2),(257,7453882,7453871,'ati',11.111,2),(257,7453883,7453871,'tio',11.111,2),(257,7453884,7453871,'ion',11.111,2),(257,7453885,7453871,'ona',11.111,2),(257,7453886,7453871,'nal',11.111,2),(257,7453887,7453878,'nor',25,1),(257,7453888,7453878,'orm',25,1),(257,7453889,7453878,'rma',25,1),(257,7453890,7453878,'mal',25,1),(257,7453891,7453887,'mes',20,1),(257,7453892,7453887,'ess',20,1),(257,7453893,7453887,'ssa',20,1),(257,7453894,7453887,'sag',20,1),(257,7453895,7453887,'age',20,1),(257,7453896,7453891,'per',11.111,1),(257,7453897,7453891,'erf',11.111,1),(257,7453898,7453891,'rfo',11.111,1),(257,7453899,7453891,'for',11.111,1),(257,7453900,7453891,'orm',11.111,1),(257,7453901,7453891,'rma',11.111,1),(257,7453902,7453891,'man',11.111,1),(257,7453903,7453891,'anc',11.111,1),(257,7453904,7453891,'nce',11.111,1),(257,7453905,7453896,'ide',12.5,1),(257,7453906,7453896,'den',12.5,1),(257,7453907,7453896,'ent',12.5,1),(257,7453908,7453896,'nti',12.5,1),(257,7453909,7453896,'tif',12.5,1),(257,7453910,7453896,'ifi',12.5,1),(257,7453911,7453896,'fie',12.5,1),(257,7453912,7453896,'ier',12.5,1),(257,7453913,7453905,'vdi',33.333,3),(257,7453914,7453905,'dis',33.333,3),(257,7453915,7453905,'isk',33.333,3),(257,7453916,7453913,'nam',50,1),(257,7453917,7453913,'ame',50,1),(257,7453918,7453916,'typ',50,1),(257,7453919,7453916,'ype',50,1),(257,7453920,7453918,'dir',25,1),(257,7453921,7453918,'ire',25,1),(257,7453922,7453918,'rec',25,1),(257,7453923,7453918,'ect',25,1),(258,7453925,7453924,'naa',100,2),(258,7453926,7453925,'600',3.333,3),(258,7453927,7453925,'000',3.333,3),(258,7453928,7453925,'00c',3.333,3),(258,7453929,7453925,'0c2',3.333,3),(258,7453930,7453925,'c29',3.333,3),(258,7453931,7453925,'29b',3.333,3),(258,7453932,7453925,'9b9',3.333,3),(258,7453933,7453925,'b9d',3.333,3),(258,7453934,7453925,'9d2',3.333,3),(258,7453935,7453925,'d27',3.333,3),(258,7453936,7453925,'272',3.333,3),(258,7453937,7453925,'725',3.333,3),(258,7453938,7453925,'250',3.333,3),(258,7453939,7453925,'503',3.333,3),(258,7453940,7453925,'034',3.333,3),(258,7453941,7453925,'346',3.333,3),(258,7453942,7453925,'46d',3.333,3),(258,7453943,7453925,'6d3',3.333,3),(258,7453944,7453925,'d3e',3.333,3),(258,7453945,7453925,'3e0',3.333,3),(258,7453946,7453925,'e02',3.333,3),(258,7453947,7453925,'028',3.333,3),(258,7453948,7453925,'286',3.333,3),(258,7453949,7453925,'86e',3.333,3),(258,7453950,7453925,'6ee',3.333,3),(258,7453951,7453925,'ee2',3.333,3),(258,7453952,7453925,'e28',3.333,3),(258,7453953,7453925,'28a',3.333,3),(258,7453954,7453925,'8a4',3.333,3),(258,7453955,7453925,'a49',3.333,3),(258,7453956,7453926,'mon',100,1),(258,7453957,7453956,'201',50,1),(258,7453958,7453956,'013',50,1),(258,7453959,7453957,'adm',33.333,3),(258,7453960,7453957,'dmi',33.333,3),(258,7453961,7453957,'min',33.333,3),(258,7453962,7453959,'cap',16.667,1),(258,7453963,7453959,'apa',16.667,1),(258,7453964,7453959,'pac',16.667,1),(258,7453965,7453959,'aci',16.667,1),(258,7453966,7453959,'cit',16.667,1),(258,7453967,7453959,'ity',16.667,1),(258,7453968,7453962,'pat',50,1),(258,7453969,7453962,'ath',50,1),(258,7453970,7453968,'fre',14.286,1),(258,7453971,7453968,'ree',14.286,1),(258,7453972,7453968,'ees',14.286,1),(258,7453973,7453968,'esp',14.286,1),(258,7453974,7453968,'spa',14.286,1),(258,7453975,7453968,'pac',14.286,1),(258,7453976,7453968,'ace',14.286,1),(258,7453977,7453970,'dis',50,1),(258,7453978,7453970,'isk',50,1),(258,7453979,7453977,'ind',33.333,1),(258,7453980,7453977,'nde',33.333,1),(258,7453981,7453977,'dex',33.333,1),(258,7453982,7453979,'adm',8.333,1),(258,7453983,7453979,'dmi',8.333,1),(258,7453984,7453979,'min',8.333,1),(258,7453985,7453979,'ini',8.333,1),(258,7453986,7453979,'nis',8.333,1),(258,7453987,7453979,'ist',8.333,1),(258,7453988,7453979,'str',8.333,1),(258,7453989,7453979,'tra',8.333,1),(258,7453990,7453979,'rat',8.333,1),(258,7453991,7453979,'ati',8.333,1),(258,7453992,7453979,'tio',8.333,1),(258,7453993,7453979,'ion',8.333,1),(258,7453994,7453982,'sta',33.333,3),(258,7453995,7453982,'tat',33.333,3),(258,7453996,7453982,'ate',33.333,3),(258,7453997,7453994,'ena',20,2),(258,7453998,7453994,'nab',20,2),(258,7453999,7453994,'abl',20,2),(258,7454000,7453994,'ble',20,2),(258,7454001,7453994,'led',20,2),(258,7454002,7453997,'cac',33.333,1),(258,7454003,7453997,'ach',33.333,1),(258,7454004,7453997,'che',33.333,1),(258,7454005,7454002,'mod',50,2),(258,7454006,7454002,'ode',50,2),(258,7454007,7454005,'wri',14.286,2),(258,7454008,7454005,'rit',14.286,2),(258,7454009,7454005,'ite',14.286,2),(258,7454010,7454005,'tet',14.286,2),(258,7454011,7454005,'eth',14.286,2),(258,7454012,7454005,'thr',14.286,2),(258,7454013,7454005,'hru',14.286,2),(258,7454014,7454007,'ope',11.111,2),(258,7454015,7454007,'per',11.111,2),(258,7454016,7454007,'era',11.111,2),(258,7454017,7454007,'rat',11.111,2),(258,7454018,7454007,'ati',11.111,2),(258,7454019,7454007,'tio',11.111,2),(258,7454020,7454007,'ion',11.111,2),(258,7454021,7454007,'ona',11.111,2),(258,7454022,7454007,'nal',11.111,2),(258,7454023,7454014,'nor',25,1),(258,7454024,7454014,'orm',25,1),(258,7454025,7454014,'rma',25,1),(258,7454026,7454014,'mal',25,1),(258,7454027,7454023,'mes',20,1),(258,7454028,7454023,'ess',20,1),(258,7454029,7454023,'ssa',20,1),(258,7454030,7454023,'sag',20,1),(258,7454031,7454023,'age',20,1),(258,7454032,7454027,'per',11.111,1),(258,7454033,7454027,'erf',11.111,1),(258,7454034,7454027,'rfo',11.111,1),(258,7454035,7454027,'for',11.111,1),(258,7454036,7454027,'orm',11.111,1),(258,7454037,7454027,'rma',11.111,1),(258,7454038,7454027,'man',11.111,1),(258,7454039,7454027,'anc',11.111,1),(258,7454040,7454027,'nce',11.111,1),(258,7454041,7454032,'ide',12.5,1),(258,7454042,7454032,'den',12.5,1),(258,7454043,7454032,'ent',12.5,1),(258,7454044,7454032,'nti',12.5,1),(258,7454045,7454032,'tif',12.5,1),(258,7454046,7454032,'ifi',12.5,1),(258,7454047,7454032,'fie',12.5,1),(258,7454048,7454032,'ier',12.5,1),(258,7454049,7454041,'vdi',33.333,3),(258,7454050,7454041,'dis',33.333,3),(258,7454051,7454041,'isk',33.333,3),(258,7454052,7454049,'nam',50,1),(258,7454053,7454049,'ame',50,1),(258,7454054,7454052,'typ',50,1),(258,7454055,7454052,'ype',50,1),(258,7454056,7454054,'dir',25,1),(258,7454057,7454054,'ire',25,1),(258,7454058,7454054,'rec',25,1),(258,7454059,7454054,'ect',25,1),(259,7454061,7454060,'naa',100,2),(259,7454062,7454061,'600',3.333,3),(259,7454063,7454061,'000',3.333,3),(259,7454064,7454061,'00c',3.333,3),(259,7454065,7454061,'0c2',3.333,3),(259,7454066,7454061,'c29',3.333,3),(259,7454067,7454061,'29b',3.333,3),(259,7454068,7454061,'9b4',3.333,3),(259,7454069,7454061,'b45',3.333,3),(259,7454070,7454061,'45f',3.333,3),(259,7454071,7454061,'5fb',3.333,3),(259,7454072,7454061,'fb5',3.333,3),(259,7454073,7454061,'b59',3.333,3),(259,7454074,7454061,'593',3.333,3),(259,7454075,7454061,'930',3.333,3),(259,7454076,7454061,'308',3.333,3),(259,7454077,7454061,'085',3.333,3),(259,7454078,7454061,'85a',3.333,3),(259,7454079,7454061,'5a2',3.333,3),(259,7454080,7454061,'a2c',3.333,3),(259,7454081,7454061,'2c4',3.333,3),(259,7454082,7454061,'c48',3.333,3),(259,7454083,7454061,'487',3.333,3),(259,7454084,7454061,'878',3.333,3),(259,7454085,7454061,'782',3.333,3),(259,7454086,7454061,'82b',3.333,3),(259,7454087,7454061,'2b0',3.333,3),(259,7454088,7454061,'b02',3.333,3),(259,7454089,7454061,'020',3.333,3),(259,7454090,7454061,'204',3.333,3),(259,7454091,7454061,'044',3.333,3),(259,7454092,7454062,'mon',100,1),(259,7454093,7454092,'201',50,1),(259,7454094,7454092,'013',50,1),(259,7454095,7454093,'adm',33.333,3),(259,7454096,7454093,'dmi',33.333,3),(259,7454097,7454093,'min',33.333,3),(259,7454098,7454095,'cap',16.667,1),(259,7454099,7454095,'apa',16.667,1),(259,7454100,7454095,'pac',16.667,1),(259,7454101,7454095,'aci',16.667,1),(259,7454102,7454095,'cit',16.667,1),(259,7454103,7454095,'ity',16.667,1),(259,7454104,7454098,'pat',50,1),(259,7454105,7454098,'ath',50,1),(259,7454106,7454104,'fre',14.286,1),(259,7454107,7454104,'ree',14.286,1),(259,7454108,7454104,'ees',14.286,1),(259,7454109,7454104,'esp',14.286,1),(259,7454110,7454104,'spa',14.286,1),(259,7454111,7454104,'pac',14.286,1),(259,7454112,7454104,'ace',14.286,1),(259,7454113,7454106,'dis',50,1),(259,7454114,7454106,'isk',50,1),(259,7454115,7454113,'ind',33.333,1),(259,7454116,7454113,'nde',33.333,1),(259,7454117,7454113,'dex',33.333,1),(259,7454118,7454115,'adm',8.333,1),(259,7454119,7454115,'dmi',8.333,1),(259,7454120,7454115,'min',8.333,1),(259,7454121,7454115,'ini',8.333,1),(259,7454122,7454115,'nis',8.333,1),(259,7454123,7454115,'ist',8.333,1),(259,7454124,7454115,'str',8.333,1),(259,7454125,7454115,'tra',8.333,1),(259,7454126,7454115,'rat',8.333,1),(259,7454127,7454115,'ati',8.333,1),(259,7454128,7454115,'tio',8.333,1),(259,7454129,7454115,'ion',8.333,1),(259,7454130,7454118,'sta',33.333,3),(259,7454131,7454118,'tat',33.333,3),(259,7454132,7454118,'ate',33.333,3),(259,7454133,7454130,'ena',20,2),(259,7454134,7454130,'nab',20,2),(259,7454135,7454130,'abl',20,2),(259,7454136,7454130,'ble',20,2),(259,7454137,7454130,'led',20,2),(259,7454138,7454133,'cac',33.333,1),(259,7454139,7454133,'ach',33.333,1),(259,7454140,7454133,'che',33.333,1),(259,7454141,7454138,'mod',50,2),(259,7454142,7454138,'ode',50,2),(259,7454143,7454141,'wri',14.286,2),(259,7454144,7454141,'rit',14.286,2),(259,7454145,7454141,'ite',14.286,2),(259,7454146,7454141,'tet',14.286,2),(259,7454147,7454141,'eth',14.286,2),(259,7454148,7454141,'thr',14.286,2),(259,7454149,7454141,'hru',14.286,2),(259,7454150,7454143,'ope',11.111,2),(259,7454151,7454143,'per',11.111,2),(259,7454152,7454143,'era',11.111,2),(259,7454153,7454143,'rat',11.111,2),(259,7454154,7454143,'ati',11.111,2),(259,7454155,7454143,'tio',11.111,2),(259,7454156,7454143,'ion',11.111,2),(259,7454157,7454143,'ona',11.111,2),(259,7454158,7454143,'nal',11.111,2),(259,7454159,7454150,'nor',25,1),(259,7454160,7454150,'orm',25,1),(259,7454161,7454150,'rma',25,1),(259,7454162,7454150,'mal',25,1),(259,7454163,7454159,'mes',20,1),(259,7454164,7454159,'ess',20,1),(259,7454165,7454159,'ssa',20,1),(259,7454166,7454159,'sag',20,1),(259,7454167,7454159,'age',20,1),(259,7454168,7454163,'per',11.111,1),(259,7454169,7454163,'erf',11.111,1),(259,7454170,7454163,'rfo',11.111,1),(259,7454171,7454163,'for',11.111,1),(259,7454172,7454163,'orm',11.111,1),(259,7454173,7454163,'rma',11.111,1),(259,7454174,7454163,'man',11.111,1),(259,7454175,7454163,'anc',11.111,1),(259,7454176,7454163,'nce',11.111,1),(259,7454177,7454168,'ide',12.5,1),(259,7454178,7454168,'den',12.5,1),(259,7454179,7454168,'ent',12.5,1),(259,7454180,7454168,'nti',12.5,1),(259,7454181,7454168,'tif',12.5,1),(259,7454182,7454168,'ifi',12.5,1),(259,7454183,7454168,'fie',12.5,1),(259,7454184,7454168,'ier',12.5,1),(259,7454185,7454177,'vdi',33.333,3),(259,7454186,7454177,'dis',33.333,3),(259,7454187,7454177,'isk',33.333,3),(259,7454188,7454185,'nam',50,1),(259,7454189,7454185,'ame',50,1),(259,7454190,7454188,'typ',50,1),(259,7454191,7454188,'ype',50,1),(259,7454192,7454190,'dir',25,1),(259,7454193,7454190,'ire',25,1),(259,7454194,7454190,'rec',25,1),(259,7454195,7454190,'ect',25,1),(260,7454197,7454196,'naa',100,2),(260,7454198,7454197,'600',3.333,3),(260,7454199,7454197,'000',3.333,3),(260,7454200,7454197,'00c',3.333,3),(260,7454201,7454197,'0c2',3.333,3),(260,7454202,7454197,'c29',3.333,3),(260,7454203,7454197,'29a',3.333,3),(260,7454204,7454197,'9a5',3.333,3),(260,7454205,7454197,'a50',3.333,3),(260,7454206,7454197,'50c',3.333,3),(260,7454207,7454197,'0c7',3.333,3),(260,7454208,7454197,'c74',3.333,3),(260,7454209,7454197,'74f',3.333,3),(260,7454210,7454197,'4f6',3.333,3),(260,7454211,7454197,'f6a',3.333,3),(260,7454212,7454197,'6a4',3.333,3),(260,7454213,7454197,'a44',3.333,3),(260,7454214,7454197,'449',3.333,3),(260,7454215,7454197,'499',3.333,3),(260,7454216,7454197,'99c',3.333,3),(260,7454217,7454197,'9cc',3.333,3),(260,7454218,7454197,'cc6',3.333,3),(260,7454219,7454197,'c61',3.333,3),(260,7454220,7454197,'613',3.333,3),(260,7454221,7454197,'13e',3.333,3),(260,7454222,7454197,'3e4',3.333,3),(260,7454223,7454197,'e47',3.333,3),(260,7454224,7454197,'475',3.333,3),(260,7454225,7454197,'75e',3.333,3),(260,7454226,7454197,'5ef',3.333,3),(260,7454227,7454197,'ef4',3.333,3),(260,7454228,7454198,'mon',100,1),(260,7454229,7454228,'201',50,1),(260,7454230,7454228,'013',50,1),(260,7454231,7454229,'adm',33.333,3),(260,7454232,7454229,'dmi',33.333,3),(260,7454233,7454229,'min',33.333,3),(260,7454234,7454231,'cap',16.667,1),(260,7454235,7454231,'apa',16.667,1),(260,7454236,7454231,'pac',16.667,1),(260,7454237,7454231,'aci',16.667,1),(260,7454238,7454231,'cit',16.667,1),(260,7454239,7454231,'ity',16.667,1),(260,7454240,7454234,'pat',50,1),(260,7454241,7454234,'ath',50,1),(260,7454242,7454240,'fre',14.286,1),(260,7454243,7454240,'ree',14.286,1),(260,7454244,7454240,'ees',14.286,1),(260,7454245,7454240,'esp',14.286,1),(260,7454246,7454240,'spa',14.286,1),(260,7454247,7454240,'pac',14.286,1),(260,7454248,7454240,'ace',14.286,1),(260,7454249,7454242,'dis',50,1),(260,7454250,7454242,'isk',50,1),(260,7454251,7454249,'ind',33.333,1),(260,7454252,7454249,'nde',33.333,1),(260,7454253,7454249,'dex',33.333,1),(260,7454254,7454251,'adm',8.333,1),(260,7454255,7454251,'dmi',8.333,1),(260,7454256,7454251,'min',8.333,1),(260,7454257,7454251,'ini',8.333,1),(260,7454258,7454251,'nis',8.333,1),(260,7454259,7454251,'ist',8.333,1),(260,7454260,7454251,'str',8.333,1),(260,7454261,7454251,'tra',8.333,1),(260,7454262,7454251,'rat',8.333,1),(260,7454263,7454251,'ati',8.333,1),(260,7454264,7454251,'tio',8.333,1),(260,7454265,7454251,'ion',8.333,1),(260,7454266,7454254,'sta',33.333,3),(260,7454267,7454254,'tat',33.333,3),(260,7454268,7454254,'ate',33.333,3),(260,7454269,7454266,'ena',20,2),(260,7454270,7454266,'nab',20,2),(260,7454271,7454266,'abl',20,2),(260,7454272,7454266,'ble',20,2),(260,7454273,7454266,'led',20,2),(260,7454274,7454269,'cac',33.333,1),(260,7454275,7454269,'ach',33.333,1),(260,7454276,7454269,'che',33.333,1),(260,7454277,7454274,'mod',50,2),(260,7454278,7454274,'ode',50,2),(260,7454279,7454277,'wri',14.286,2),(260,7454280,7454277,'rit',14.286,2),(260,7454281,7454277,'ite',14.286,2),(260,7454282,7454277,'tet',14.286,2),(260,7454283,7454277,'eth',14.286,2),(260,7454284,7454277,'thr',14.286,2),(260,7454285,7454277,'hru',14.286,2),(260,7454286,7454279,'ope',11.111,2),(260,7454287,7454279,'per',11.111,2),(260,7454288,7454279,'era',11.111,2),(260,7454289,7454279,'rat',11.111,2),(260,7454290,7454279,'ati',11.111,2),(260,7454291,7454279,'tio',11.111,2),(260,7454292,7454279,'ion',11.111,2),(260,7454293,7454279,'ona',11.111,2),(260,7454294,7454279,'nal',11.111,2),(260,7454295,7454286,'nor',25,1),(260,7454296,7454286,'orm',25,1),(260,7454297,7454286,'rma',25,1),(260,7454298,7454286,'mal',25,1),(260,7454299,7454295,'mes',20,1),(260,7454300,7454295,'ess',20,1),(260,7454301,7454295,'ssa',20,1),(260,7454302,7454295,'sag',20,1),(260,7454303,7454295,'age',20,1),(260,7454304,7454299,'per',11.111,1),(260,7454305,7454299,'erf',11.111,1),(260,7454306,7454299,'rfo',11.111,1),(260,7454307,7454299,'for',11.111,1),(260,7454308,7454299,'orm',11.111,1),(260,7454309,7454299,'rma',11.111,1),(260,7454310,7454299,'man',11.111,1),(260,7454311,7454299,'anc',11.111,1),(260,7454312,7454299,'nce',11.111,1),(260,7454313,7454304,'ide',12.5,1),(260,7454314,7454304,'den',12.5,1),(260,7454315,7454304,'ent',12.5,1),(260,7454316,7454304,'nti',12.5,1),(260,7454317,7454304,'tif',12.5,1),(260,7454318,7454304,'ifi',12.5,1),(260,7454319,7454304,'fie',12.5,1),(260,7454320,7454304,'ier',12.5,1),(260,7454321,7454313,'vdi',33.333,3),(260,7454322,7454313,'dis',33.333,3),(260,7454323,7454313,'isk',33.333,3),(260,7454324,7454321,'nam',50,1),(260,7454325,7454321,'ame',50,1),(260,7454326,7454324,'typ',50,1),(260,7454327,7454324,'ype',50,1),(260,7454328,7454326,'dir',25,1),(260,7454329,7454326,'ire',25,1),(260,7454330,7454326,'rec',25,1),(260,7454331,7454326,'ect',25,1),(261,7454333,7454332,'naa',100,2),(261,7454334,7454333,'600',3.333,3),(261,7454335,7454333,'000',3.333,3),(261,7454336,7454333,'00c',3.333,3),(261,7454337,7454333,'0c2',3.333,3),(261,7454338,7454333,'c29',3.333,3),(261,7454339,7454333,'294',3.333,3),(261,7454340,7454333,'94c',3.333,3),(261,7454341,7454333,'4c5',3.333,3),(261,7454342,7454333,'c58',3.333,3),(261,7454343,7454333,'580',3.333,3),(261,7454344,7454333,'800',3.333,3),(261,7454345,7454333,'007',3.333,3),(261,7454346,7454333,'070',3.333,3),(261,7454347,7454333,'706',3.333,3),(261,7454348,7454333,'06f',3.333,3),(261,7454349,7454333,'6fe',3.333,3),(261,7454350,7454333,'fe0',3.333,3),(261,7454351,7454333,'e07',3.333,3),(261,7454352,7454333,'07f',3.333,3),(261,7454353,7454333,'7fe',3.333,3),(261,7454354,7454333,'fe7',3.333,3),(261,7454355,7454333,'e7b',3.333,3),(261,7454356,7454333,'7bd',3.333,3),(261,7454357,7454333,'bde',3.333,3),(261,7454358,7454333,'dec',3.333,3),(261,7454359,7454333,'ec0',3.333,3),(261,7454360,7454333,'c0b',3.333,3),(261,7454361,7454333,'0b5',3.333,3),(261,7454362,7454333,'b54',3.333,3),(261,7454363,7454333,'542',3.333,3),(261,7454364,7454334,'mon',100,1),(261,7454365,7454364,'201',50,1),(261,7454366,7454364,'013',50,1),(261,7454367,7454365,'adm',33.333,3),(261,7454368,7454365,'dmi',33.333,3),(261,7454369,7454365,'min',33.333,3),(261,7454370,7454367,'cap',16.667,1),(261,7454371,7454367,'apa',16.667,1),(261,7454372,7454367,'pac',16.667,1),(261,7454373,7454367,'aci',16.667,1),(261,7454374,7454367,'cit',16.667,1),(261,7454375,7454367,'ity',16.667,1),(261,7454376,7454370,'pat',50,1),(261,7454377,7454370,'ath',50,1),(261,7454378,7454376,'fre',14.286,1),(261,7454379,7454376,'ree',14.286,1),(261,7454380,7454376,'ees',14.286,1),(261,7454381,7454376,'esp',14.286,1),(261,7454382,7454376,'spa',14.286,1),(261,7454383,7454376,'pac',14.286,1),(261,7454384,7454376,'ace',14.286,1),(261,7454385,7454378,'dis',50,1),(261,7454386,7454378,'isk',50,1),(261,7454387,7454385,'ind',33.333,1),(261,7454388,7454385,'nde',33.333,1),(261,7454389,7454385,'dex',33.333,1),(261,7454390,7454387,'adm',8.333,1),(261,7454391,7454387,'dmi',8.333,1),(261,7454392,7454387,'min',8.333,1),(261,7454393,7454387,'ini',8.333,1),(261,7454394,7454387,'nis',8.333,1),(261,7454395,7454387,'ist',8.333,1),(261,7454396,7454387,'str',8.333,1),(261,7454397,7454387,'tra',8.333,1),(261,7454398,7454387,'rat',8.333,1),(261,7454399,7454387,'ati',8.333,1),(261,7454400,7454387,'tio',8.333,1),(261,7454401,7454387,'ion',8.333,1),(261,7454402,7454390,'sta',33.333,3),(261,7454403,7454390,'tat',33.333,3),(261,7454404,7454390,'ate',33.333,3),(261,7454405,7454402,'ena',20,2),(261,7454406,7454402,'nab',20,2),(261,7454407,7454402,'abl',20,2),(261,7454408,7454402,'ble',20,2),(261,7454409,7454402,'led',20,2),(261,7454410,7454405,'cac',33.333,1),(261,7454411,7454405,'ach',33.333,1),(261,7454412,7454405,'che',33.333,1),(261,7454413,7454410,'mod',50,2),(261,7454414,7454410,'ode',50,2),(261,7454415,7454413,'wri',14.286,2),(261,7454416,7454413,'rit',14.286,2),(261,7454417,7454413,'ite',14.286,2),(261,7454418,7454413,'tet',14.286,2),(261,7454419,7454413,'eth',14.286,2),(261,7454420,7454413,'thr',14.286,2),(261,7454421,7454413,'hru',14.286,2),(261,7454422,7454415,'ope',11.111,2),(261,7454423,7454415,'per',11.111,2),(261,7454424,7454415,'era',11.111,2),(261,7454425,7454415,'rat',11.111,2),(261,7454426,7454415,'ati',11.111,2),(261,7454427,7454415,'tio',11.111,2),(261,7454428,7454415,'ion',11.111,2),(261,7454429,7454415,'ona',11.111,2),(261,7454430,7454415,'nal',11.111,2),(261,7454431,7454422,'nor',25,1),(261,7454432,7454422,'orm',25,1),(261,7454433,7454422,'rma',25,1),(261,7454434,7454422,'mal',25,1),(261,7454435,7454431,'mes',20,1),(261,7454436,7454431,'ess',20,1),(261,7454437,7454431,'ssa',20,1),(261,7454438,7454431,'sag',20,1),(261,7454439,7454431,'age',20,1),(261,7454440,7454435,'per',11.111,1),(261,7454441,7454435,'erf',11.111,1),(261,7454442,7454435,'rfo',11.111,1),(261,7454443,7454435,'for',11.111,1),(261,7454444,7454435,'orm',11.111,1),(261,7454445,7454435,'rma',11.111,1),(261,7454446,7454435,'man',11.111,1),(261,7454447,7454435,'anc',11.111,1),(261,7454448,7454435,'nce',11.111,1),(261,7454449,7454440,'ide',12.5,1),(261,7454450,7454440,'den',12.5,1),(261,7454451,7454440,'ent',12.5,1),(261,7454452,7454440,'nti',12.5,1),(261,7454453,7454440,'tif',12.5,1),(261,7454454,7454440,'ifi',12.5,1),(261,7454455,7454440,'fie',12.5,1),(261,7454456,7454440,'ier',12.5,1),(261,7454457,7454449,'vdi',33.333,3),(261,7454458,7454449,'dis',33.333,3),(261,7454459,7454449,'isk',33.333,3),(261,7454460,7454457,'nam',50,1),(261,7454461,7454457,'ame',50,1),(261,7454462,7454460,'typ',50,1),(261,7454463,7454460,'ype',50,1),(261,7454464,7454462,'dir',25,1),(261,7454465,7454462,'ire',25,1),(261,7454466,7454462,'rec',25,1),(261,7454467,7454462,'ect',25,1),(262,7454469,7454468,'naa',100,2),(262,7454470,7454469,'600',3.333,3),(262,7454471,7454469,'000',3.333,3),(262,7454472,7454469,'00c',3.333,3),(262,7454473,7454469,'0c2',3.333,3),(262,7454474,7454469,'c29',3.333,3),(262,7454475,7454469,'296',3.333,3),(262,7454476,7454469,'965',3.333,3),(262,7454477,7454469,'65c',3.333,3),(262,7454478,7454469,'5ca',3.333,3),(262,7454479,7454469,'ca4',3.333,3),(262,7454480,7454469,'a4c',3.333,3),(262,7454481,7454469,'4cd',3.333,3),(262,7454482,7454469,'cd7',3.333,3),(262,7454483,7454469,'d7c',3.333,3),(262,7454484,7454469,'7c5',3.333,3),(262,7454485,7454469,'c53',3.333,3),(262,7454486,7454469,'538',3.333,3),(262,7454487,7454469,'381',3.333,3),(262,7454488,7454469,'811',3.333,3),(262,7454489,7454469,'117',3.333,3),(262,7454490,7454469,'170',3.333,3),(262,7454491,7454469,'704',3.333,3),(262,7454492,7454469,'04f',3.333,3),(262,7454493,7454469,'4f7',3.333,3),(262,7454494,7454469,'f77',3.333,3),(262,7454495,7454469,'77b',3.333,3),(262,7454496,7454469,'7b5',3.333,3),(262,7454497,7454469,'b5d',3.333,3),(262,7454498,7454469,'5d6',3.333,3),(262,7454499,7454469,'d65',3.333,3),(262,7454500,7454470,'mon',100,1),(262,7454501,7454500,'201',50,1),(262,7454502,7454500,'013',50,1),(262,7454503,7454501,'adm',33.333,3),(262,7454504,7454501,'dmi',33.333,3),(262,7454505,7454501,'min',33.333,3),(262,7454506,7454503,'cap',16.667,1),(262,7454507,7454503,'apa',16.667,1),(262,7454508,7454503,'pac',16.667,1),(262,7454509,7454503,'aci',16.667,1),(262,7454510,7454503,'cit',16.667,1),(262,7454511,7454503,'ity',16.667,1),(262,7454512,7454506,'pat',50,1),(262,7454513,7454506,'ath',50,1),(262,7454514,7454512,'fre',14.286,1),(262,7454515,7454512,'ree',14.286,1),(262,7454516,7454512,'ees',14.286,1),(262,7454517,7454512,'esp',14.286,1),(262,7454518,7454512,'spa',14.286,1),(262,7454519,7454512,'pac',14.286,1),(262,7454520,7454512,'ace',14.286,1),(262,7454521,7454514,'dis',50,1),(262,7454522,7454514,'isk',50,1),(262,7454523,7454521,'ind',33.333,1),(262,7454524,7454521,'nde',33.333,1),(262,7454525,7454521,'dex',33.333,1),(262,7454526,7454523,'adm',8.333,1),(262,7454527,7454523,'dmi',8.333,1),(262,7454528,7454523,'min',8.333,1),(262,7454529,7454523,'ini',8.333,1),(262,7454530,7454523,'nis',8.333,1),(262,7454531,7454523,'ist',8.333,1),(262,7454532,7454523,'str',8.333,1),(262,7454533,7454523,'tra',8.333,1),(262,7454534,7454523,'rat',8.333,1),(262,7454535,7454523,'ati',8.333,1),(262,7454536,7454523,'tio',8.333,1),(262,7454537,7454523,'ion',8.333,1),(262,7454538,7454526,'sta',33.333,3),(262,7454539,7454526,'tat',33.333,3),(262,7454540,7454526,'ate',33.333,3),(262,7454541,7454538,'ena',20,2),(262,7454542,7454538,'nab',20,2),(262,7454543,7454538,'abl',20,2),(262,7454544,7454538,'ble',20,2),(262,7454545,7454538,'led',20,2),(262,7454546,7454541,'cac',33.333,1),(262,7454547,7454541,'ach',33.333,1),(262,7454548,7454541,'che',33.333,1),(262,7454549,7454546,'mod',50,2),(262,7454550,7454546,'ode',50,2),(262,7454551,7454549,'wri',14.286,2),(262,7454552,7454549,'rit',14.286,2),(262,7454553,7454549,'ite',14.286,2),(262,7454554,7454549,'tet',14.286,2),(262,7454555,7454549,'eth',14.286,2),(262,7454556,7454549,'thr',14.286,2),(262,7454557,7454549,'hru',14.286,2),(262,7454558,7454551,'ope',11.111,2),(262,7454559,7454551,'per',11.111,2),(262,7454560,7454551,'era',11.111,2),(262,7454561,7454551,'rat',11.111,2),(262,7454562,7454551,'ati',11.111,2),(262,7454563,7454551,'tio',11.111,2),(262,7454564,7454551,'ion',11.111,2),(262,7454565,7454551,'ona',11.111,2),(262,7454566,7454551,'nal',11.111,2),(262,7454567,7454558,'nor',25,1),(262,7454568,7454558,'orm',25,1),(262,7454569,7454558,'rma',25,1),(262,7454570,7454558,'mal',25,1),(262,7454571,7454567,'mes',20,1),(262,7454572,7454567,'ess',20,1),(262,7454573,7454567,'ssa',20,1),(262,7454574,7454567,'sag',20,1),(262,7454575,7454567,'age',20,1),(262,7454576,7454571,'per',11.111,1),(262,7454577,7454571,'erf',11.111,1),(262,7454578,7454571,'rfo',11.111,1),(262,7454579,7454571,'for',11.111,1),(262,7454580,7454571,'orm',11.111,1),(262,7454581,7454571,'rma',11.111,1),(262,7454582,7454571,'man',11.111,1),(262,7454583,7454571,'anc',11.111,1),(262,7454584,7454571,'nce',11.111,1),(262,7454585,7454576,'ide',12.5,1),(262,7454586,7454576,'den',12.5,1),(262,7454587,7454576,'ent',12.5,1),(262,7454588,7454576,'nti',12.5,1),(262,7454589,7454576,'tif',12.5,1),(262,7454590,7454576,'ifi',12.5,1),(262,7454591,7454576,'fie',12.5,1),(262,7454592,7454576,'ier',12.5,1),(262,7454593,7454585,'vdi',33.333,3),(262,7454594,7454585,'dis',33.333,3),(262,7454595,7454585,'isk',33.333,3),(262,7454596,7454593,'nam',50,1),(262,7454597,7454593,'ame',50,1),(262,7454598,7454596,'typ',50,1),(262,7454599,7454596,'ype',50,1),(262,7454600,7454598,'dir',25,1),(262,7454601,7454598,'ire',25,1),(262,7454602,7454598,'rec',25,1),(262,7454603,7454598,'ect',25,1),(263,7454605,7454604,'naa',100,2),(263,7454606,7454605,'600',3.333,3),(263,7454607,7454605,'000',3.333,3),(263,7454608,7454605,'00c',3.333,3),(263,7454609,7454605,'0c2',3.333,3),(263,7454610,7454605,'c29',3.333,3),(263,7454611,7454605,'299',3.333,3),(263,7454612,7454605,'992',3.333,3),(263,7454613,7454605,'929',3.333,3),(263,7454614,7454605,'29c',3.333,3),(263,7454615,7454605,'9cb',3.333,3),(263,7454616,7454605,'cb6',3.333,3),(263,7454617,7454605,'b62',3.333,3),(263,7454618,7454605,'627',3.333,3),(263,7454619,7454605,'278',3.333,3),(263,7454620,7454605,'783',3.333,3),(263,7454621,7454605,'838',3.333,3),(263,7454622,7454605,'386',3.333,3),(263,7454623,7454605,'86c',3.333,3),(263,7454624,7454605,'6c2',3.333,3),(263,7454625,7454605,'c23',3.333,3),(263,7454626,7454605,'231',3.333,3),(263,7454627,7454605,'319',3.333,3),(263,7454628,7454605,'19e',3.333,3),(263,7454629,7454605,'9ec',3.333,3),(263,7454630,7454605,'ec3',3.333,3),(263,7454631,7454605,'c3c',3.333,3),(263,7454632,7454605,'3c3',3.333,3),(263,7454633,7454605,'c3b',3.333,3),(263,7454634,7454605,'3b6',3.333,3),(263,7454635,7454605,'b6e',3.333,3),(263,7454636,7454606,'mon',100,1),(263,7454637,7454636,'201',50,1),(263,7454638,7454636,'013',50,1),(263,7454639,7454637,'adm',33.333,3),(263,7454640,7454637,'dmi',33.333,3),(263,7454641,7454637,'min',33.333,3),(263,7454642,7454639,'cap',16.667,1),(263,7454643,7454639,'apa',16.667,1),(263,7454644,7454639,'pac',16.667,1),(263,7454645,7454639,'aci',16.667,1),(263,7454646,7454639,'cit',16.667,1),(263,7454647,7454639,'ity',16.667,1),(263,7454648,7454642,'pat',50,1),(263,7454649,7454642,'ath',50,1),(263,7454650,7454648,'fre',14.286,1),(263,7454651,7454648,'ree',14.286,1),(263,7454652,7454648,'ees',14.286,1),(263,7454653,7454648,'esp',14.286,1),(263,7454654,7454648,'spa',14.286,1),(263,7454655,7454648,'pac',14.286,1),(263,7454656,7454648,'ace',14.286,1),(263,7454657,7454650,'dis',50,1),(263,7454658,7454650,'isk',50,1),(263,7454659,7454657,'ind',33.333,1),(263,7454660,7454657,'nde',33.333,1),(263,7454661,7454657,'dex',33.333,1),(263,7454662,7454659,'adm',8.333,1),(263,7454663,7454659,'dmi',8.333,1),(263,7454664,7454659,'min',8.333,1),(263,7454665,7454659,'ini',8.333,1),(263,7454666,7454659,'nis',8.333,1),(263,7454667,7454659,'ist',8.333,1),(263,7454668,7454659,'str',8.333,1),(263,7454669,7454659,'tra',8.333,1),(263,7454670,7454659,'rat',8.333,1),(263,7454671,7454659,'ati',8.333,1),(263,7454672,7454659,'tio',8.333,1),(263,7454673,7454659,'ion',8.333,1),(263,7454674,7454662,'sta',33.333,3),(263,7454675,7454662,'tat',33.333,3),(263,7454676,7454662,'ate',33.333,3),(263,7454677,7454674,'ena',20,2),(263,7454678,7454674,'nab',20,2),(263,7454679,7454674,'abl',20,2),(263,7454680,7454674,'ble',20,2),(263,7454681,7454674,'led',20,2),(263,7454682,7454677,'cac',33.333,1),(263,7454683,7454677,'ach',33.333,1),(263,7454684,7454677,'che',33.333,1),(263,7454685,7454682,'mod',50,2),(263,7454686,7454682,'ode',50,2),(263,7454687,7454685,'wri',14.286,2),(263,7454688,7454685,'rit',14.286,2),(263,7454689,7454685,'ite',14.286,2),(263,7454690,7454685,'tet',14.286,2),(263,7454691,7454685,'eth',14.286,2),(263,7454692,7454685,'thr',14.286,2),(263,7454693,7454685,'hru',14.286,2),(263,7454694,7454687,'ope',11.111,2),(263,7454695,7454687,'per',11.111,2),(263,7454696,7454687,'era',11.111,2),(263,7454697,7454687,'rat',11.111,2),(263,7454698,7454687,'ati',11.111,2),(263,7454699,7454687,'tio',11.111,2),(263,7454700,7454687,'ion',11.111,2),(263,7454701,7454687,'ona',11.111,2),(263,7454702,7454687,'nal',11.111,2),(263,7454703,7454694,'nor',25,1),(263,7454704,7454694,'orm',25,1),(263,7454705,7454694,'rma',25,1),(263,7454706,7454694,'mal',25,1),(263,7454707,7454703,'mes',20,1),(263,7454708,7454703,'ess',20,1),(263,7454709,7454703,'ssa',20,1),(263,7454710,7454703,'sag',20,1),(263,7454711,7454703,'age',20,1),(263,7454712,7454707,'per',11.111,1),(263,7454713,7454707,'erf',11.111,1),(263,7454714,7454707,'rfo',11.111,1),(263,7454715,7454707,'for',11.111,1),(263,7454716,7454707,'orm',11.111,1),(263,7454717,7454707,'rma',11.111,1),(263,7454718,7454707,'man',11.111,1),(263,7454719,7454707,'anc',11.111,1),(263,7454720,7454707,'nce',11.111,1),(263,7454721,7454712,'ide',12.5,1),(263,7454722,7454712,'den',12.5,1),(263,7454723,7454712,'ent',12.5,1),(263,7454724,7454712,'nti',12.5,1),(263,7454725,7454712,'tif',12.5,1),(263,7454726,7454712,'ifi',12.5,1),(263,7454727,7454712,'fie',12.5,1),(263,7454728,7454712,'ier',12.5,1),(263,7454729,7454721,'vdi',33.333,3),(263,7454730,7454721,'dis',33.333,3),(263,7454731,7454721,'isk',33.333,3),(263,7454732,7454729,'nam',50,1),(263,7454733,7454729,'ame',50,1),(263,7454734,7454732,'typ',50,1),(263,7454735,7454732,'ype',50,1),(263,7454736,7454734,'dir',25,1),(263,7454737,7454734,'ire',25,1),(263,7454738,7454734,'rec',25,1),(263,7454739,7454734,'ect',25,1),(264,7454741,7454740,'naa',100,2),(264,7454742,7454741,'600',3.333,3),(264,7454743,7454741,'000',3.333,3),(264,7454744,7454741,'00c',3.333,3),(264,7454745,7454741,'0c2',3.333,3),(264,7454746,7454741,'c29',3.333,3),(264,7454747,7454741,'295',3.333,3),(264,7454748,7454741,'958',3.333,3),(264,7454749,7454741,'581',3.333,3),(264,7454750,7454741,'81a',3.333,3),(264,7454751,7454741,'1ab',3.333,3),(264,7454752,7454741,'ab8',3.333,3),(264,7454753,7454741,'b8a',3.333,3),(264,7454754,7454741,'8a2',3.333,3),(264,7454755,7454741,'a2d',3.333,3),(264,7454756,7454741,'2d1',3.333,3),(264,7454757,7454741,'d1e',3.333,3),(264,7454758,7454741,'1e2',3.333,3),(264,7454759,7454741,'e21',3.333,3),(264,7454760,7454741,'213',3.333,3),(264,7454761,7454741,'13a',3.333,3),(264,7454762,7454741,'3ab',3.333,3),(264,7454763,7454741,'ab7',3.333,3),(264,7454764,7454741,'b7a',3.333,3),(264,7454765,7454741,'7a5',3.333,3),(264,7454766,7454741,'a50',3.333,3),(264,7454767,7454741,'509',3.333,3),(264,7454768,7454741,'097',3.333,3),(264,7454769,7454741,'97f',3.333,3),(264,7454770,7454741,'7f2',3.333,3),(264,7454771,7454741,'f25',3.333,3),(264,7454772,7454742,'mon',100,1),(264,7454773,7454772,'201',50,1),(264,7454774,7454772,'013',50,1),(264,7454775,7454773,'adm',33.333,3),(264,7454776,7454773,'dmi',33.333,3),(264,7454777,7454773,'min',33.333,3),(264,7454778,7454775,'cap',16.667,1),(264,7454779,7454775,'apa',16.667,1),(264,7454780,7454775,'pac',16.667,1),(264,7454781,7454775,'aci',16.667,1),(264,7454782,7454775,'cit',16.667,1),(264,7454783,7454775,'ity',16.667,1),(264,7454784,7454778,'pat',50,1),(264,7454785,7454778,'ath',50,1),(264,7454786,7454784,'fre',14.286,1),(264,7454787,7454784,'ree',14.286,1),(264,7454788,7454784,'ees',14.286,1),(264,7454789,7454784,'esp',14.286,1),(264,7454790,7454784,'spa',14.286,1),(264,7454791,7454784,'pac',14.286,1),(264,7454792,7454784,'ace',14.286,1),(264,7454793,7454786,'dis',50,1),(264,7454794,7454786,'isk',50,1),(264,7454795,7454793,'ind',33.333,1),(264,7454796,7454793,'nde',33.333,1),(264,7454797,7454793,'dex',33.333,1),(264,7454798,7454795,'adm',8.333,1),(264,7454799,7454795,'dmi',8.333,1),(264,7454800,7454795,'min',8.333,1),(264,7454801,7454795,'ini',8.333,1),(264,7454802,7454795,'nis',8.333,1),(264,7454803,7454795,'ist',8.333,1),(264,7454804,7454795,'str',8.333,1),(264,7454805,7454795,'tra',8.333,1),(264,7454806,7454795,'rat',8.333,1),(264,7454807,7454795,'ati',8.333,1),(264,7454808,7454795,'tio',8.333,1),(264,7454809,7454795,'ion',8.333,1),(264,7454810,7454798,'sta',33.333,3),(264,7454811,7454798,'tat',33.333,3),(264,7454812,7454798,'ate',33.333,3),(264,7454813,7454810,'ena',20,2),(264,7454814,7454810,'nab',20,2),(264,7454815,7454810,'abl',20,2),(264,7454816,7454810,'ble',20,2),(264,7454817,7454810,'led',20,2),(264,7454818,7454813,'cac',33.333,1),(264,7454819,7454813,'ach',33.333,1),(264,7454820,7454813,'che',33.333,1),(264,7454821,7454818,'mod',50,2),(264,7454822,7454818,'ode',50,2),(264,7454823,7454821,'wri',14.286,2),(264,7454824,7454821,'rit',14.286,2),(264,7454825,7454821,'ite',14.286,2),(264,7454826,7454821,'tet',14.286,2),(264,7454827,7454821,'eth',14.286,2),(264,7454828,7454821,'thr',14.286,2),(264,7454829,7454821,'hru',14.286,2),(264,7454830,7454823,'ope',11.111,2),(264,7454831,7454823,'per',11.111,2),(264,7454832,7454823,'era',11.111,2),(264,7454833,7454823,'rat',11.111,2),(264,7454834,7454823,'ati',11.111,2),(264,7454835,7454823,'tio',11.111,2),(264,7454836,7454823,'ion',11.111,2),(264,7454837,7454823,'ona',11.111,2),(264,7454838,7454823,'nal',11.111,2),(264,7454839,7454830,'nor',25,1),(264,7454840,7454830,'orm',25,1),(264,7454841,7454830,'rma',25,1),(264,7454842,7454830,'mal',25,1),(264,7454843,7454839,'mes',20,1),(264,7454844,7454839,'ess',20,1),(264,7454845,7454839,'ssa',20,1),(264,7454846,7454839,'sag',20,1),(264,7454847,7454839,'age',20,1),(264,7454848,7454843,'per',11.111,1),(264,7454849,7454843,'erf',11.111,1),(264,7454850,7454843,'rfo',11.111,1),(264,7454851,7454843,'for',11.111,1),(264,7454852,7454843,'orm',11.111,1),(264,7454853,7454843,'rma',11.111,1),(264,7454854,7454843,'man',11.111,1),(264,7454855,7454843,'anc',11.111,1),(264,7454856,7454843,'nce',11.111,1),(264,7454857,7454848,'ide',12.5,1),(264,7454858,7454848,'den',12.5,1),(264,7454859,7454848,'ent',12.5,1),(264,7454860,7454848,'nti',12.5,1),(264,7454861,7454848,'tif',12.5,1),(264,7454862,7454848,'ifi',12.5,1),(264,7454863,7454848,'fie',12.5,1),(264,7454864,7454848,'ier',12.5,1),(264,7454865,7454857,'vdi',33.333,3),(264,7454866,7454857,'dis',33.333,3),(264,7454867,7454857,'isk',33.333,3),(264,7454868,7454865,'nam',50,1),(264,7454869,7454865,'ame',50,1),(264,7454870,7454868,'typ',50,1),(264,7454871,7454868,'ype',50,1),(264,7454872,7454870,'dir',25,1),(264,7454873,7454870,'ire',25,1),(264,7454874,7454870,'rec',25,1),(264,7454875,7454870,'ect',25,1),(265,7454877,7454876,'naa',100,2),(265,7454878,7454877,'600',3.333,3),(265,7454879,7454877,'000',3.333,3),(265,7454880,7454877,'00c',3.333,3),(265,7454881,7454877,'0c2',3.333,3),(265,7454882,7454877,'c29',3.333,3),(265,7454883,7454877,'297',3.333,3),(265,7454884,7454877,'979',3.333,3),(265,7454885,7454877,'79d',3.333,3),(265,7454886,7454877,'9d4',3.333,3),(265,7454887,7454877,'d4a',3.333,3),(265,7454888,7454877,'4a2',3.333,3),(265,7454889,7454877,'a26',3.333,3),(265,7454890,7454877,'269',3.333,3),(265,7454891,7454877,'69d',3.333,3),(265,7454892,7454877,'9d6',3.333,3),(265,7454893,7454877,'d68',3.333,3),(265,7454894,7454877,'687',3.333,3),(265,7454895,7454877,'872',3.333,3),(265,7454896,7454877,'725',3.333,3),(265,7454897,7454877,'256',3.333,3),(265,7454898,7454877,'562',3.333,3),(265,7454899,7454877,'625',3.333,3),(265,7454900,7454877,'255',3.333,3),(265,7454901,7454877,'552',3.333,3),(265,7454902,7454877,'529',3.333,3),(265,7454903,7454877,'295',3.333,3),(265,7454904,7454877,'952',3.333,3),(265,7454905,7454877,'52c',3.333,3),(265,7454906,7454877,'2c8',3.333,3),(265,7454907,7454877,'c80',3.333,3),(265,7454908,7454878,'mon',100,1),(265,7454909,7454908,'201',50,1),(265,7454910,7454908,'013',50,1),(265,7454911,7454909,'adm',33.333,3),(265,7454912,7454909,'dmi',33.333,3),(265,7454913,7454909,'min',33.333,3),(265,7454914,7454911,'cap',16.667,1),(265,7454915,7454911,'apa',16.667,1),(265,7454916,7454911,'pac',16.667,1),(265,7454917,7454911,'aci',16.667,1),(265,7454918,7454911,'cit',16.667,1),(265,7454919,7454911,'ity',16.667,1),(265,7454920,7454914,'pat',50,1),(265,7454921,7454914,'ath',50,1),(265,7454922,7454920,'fre',14.286,1),(265,7454923,7454920,'ree',14.286,1),(265,7454924,7454920,'ees',14.286,1),(265,7454925,7454920,'esp',14.286,1),(265,7454926,7454920,'spa',14.286,1),(265,7454927,7454920,'pac',14.286,1),(265,7454928,7454920,'ace',14.286,1),(265,7454929,7454922,'dis',50,1),(265,7454930,7454922,'isk',50,1),(265,7454931,7454929,'ind',33.333,1),(265,7454932,7454929,'nde',33.333,1),(265,7454933,7454929,'dex',33.333,1),(265,7454934,7454931,'adm',8.333,1),(265,7454935,7454931,'dmi',8.333,1),(265,7454936,7454931,'min',8.333,1),(265,7454937,7454931,'ini',8.333,1),(265,7454938,7454931,'nis',8.333,1),(265,7454939,7454931,'ist',8.333,1),(265,7454940,7454931,'str',8.333,1),(265,7454941,7454931,'tra',8.333,1),(265,7454942,7454931,'rat',8.333,1),(265,7454943,7454931,'ati',8.333,1),(265,7454944,7454931,'tio',8.333,1),(265,7454945,7454931,'ion',8.333,1),(265,7454946,7454934,'sta',33.333,3),(265,7454947,7454934,'tat',33.333,3),(265,7454948,7454934,'ate',33.333,3),(265,7454949,7454946,'ena',20,2),(265,7454950,7454946,'nab',20,2),(265,7454951,7454946,'abl',20,2),(265,7454952,7454946,'ble',20,2),(265,7454953,7454946,'led',20,2),(265,7454954,7454949,'cac',33.333,1),(265,7454955,7454949,'ach',33.333,1),(265,7454956,7454949,'che',33.333,1),(265,7454957,7454954,'mod',50,2),(265,7454958,7454954,'ode',50,2),(265,7454959,7454957,'wri',14.286,2),(265,7454960,7454957,'rit',14.286,2),(265,7454961,7454957,'ite',14.286,2),(265,7454962,7454957,'tet',14.286,2),(265,7454963,7454957,'eth',14.286,2),(265,7454964,7454957,'thr',14.286,2),(265,7454965,7454957,'hru',14.286,2),(265,7454966,7454959,'ope',11.111,2),(265,7454967,7454959,'per',11.111,2),(265,7454968,7454959,'era',11.111,2),(265,7454969,7454959,'rat',11.111,2),(265,7454970,7454959,'ati',11.111,2),(265,7454971,7454959,'tio',11.111,2),(265,7454972,7454959,'ion',11.111,2),(265,7454973,7454959,'ona',11.111,2),(265,7454974,7454959,'nal',11.111,2),(265,7454975,7454966,'nor',25,1),(265,7454976,7454966,'orm',25,1),(265,7454977,7454966,'rma',25,1),(265,7454978,7454966,'mal',25,1),(265,7454979,7454975,'mes',20,1),(265,7454980,7454975,'ess',20,1),(265,7454981,7454975,'ssa',20,1),(265,7454982,7454975,'sag',20,1),(265,7454983,7454975,'age',20,1),(265,7454984,7454979,'per',11.111,1),(265,7454985,7454979,'erf',11.111,1),(265,7454986,7454979,'rfo',11.111,1),(265,7454987,7454979,'for',11.111,1),(265,7454988,7454979,'orm',11.111,1),(265,7454989,7454979,'rma',11.111,1),(265,7454990,7454979,'man',11.111,1),(265,7454991,7454979,'anc',11.111,1),(265,7454992,7454979,'nce',11.111,1),(265,7454993,7454984,'ide',12.5,1),(265,7454994,7454984,'den',12.5,1),(265,7454995,7454984,'ent',12.5,1),(265,7454996,7454984,'nti',12.5,1),(265,7454997,7454984,'tif',12.5,1),(265,7454998,7454984,'ifi',12.5,1),(265,7454999,7454984,'fie',12.5,1),(265,7455000,7454984,'ier',12.5,1),(265,7455001,7454993,'vdi',33.333,3),(265,7455002,7454993,'dis',33.333,3),(265,7455003,7454993,'isk',33.333,3),(265,7455004,7455001,'nam',50,1),(265,7455005,7455001,'ame',50,1),(265,7455006,7455004,'typ',50,1),(265,7455007,7455004,'ype',50,1),(265,7455008,7455006,'dir',25,1),(265,7455009,7455006,'ire',25,1),(265,7455010,7455006,'rec',25,1),(265,7455011,7455006,'ect',25,1),(266,7455013,7455012,'naa',100,2),(266,7455014,7455013,'600',3.333,3),(266,7455015,7455013,'000',3.333,3),(266,7455016,7455013,'00c',3.333,3),(266,7455017,7455013,'0c2',3.333,3),(266,7455018,7455013,'c29',3.333,3),(266,7455019,7455013,'29f',3.333,3),(266,7455020,7455013,'9f6',3.333,3),(266,7455021,7455013,'f67',3.333,3),(266,7455022,7455013,'674',3.333,3),(266,7455023,7455013,'74e',3.333,3),(266,7455024,7455013,'4e5',3.333,3),(266,7455025,7455013,'e59',3.333,3),(266,7455026,7455013,'592',3.333,3),(266,7455027,7455013,'927',3.333,3),(266,7455028,7455013,'273',3.333,3),(266,7455029,7455013,'736',3.333,3),(266,7455030,7455013,'363',3.333,3),(266,7455031,7455013,'634',3.333,3),(266,7455032,7455013,'34e',3.333,3),(266,7455033,7455013,'4ef',3.333,3),(266,7455034,7455013,'ef0',3.333,3),(266,7455035,7455013,'f0b',3.333,3),(266,7455036,7455013,'0b5',3.333,3),(266,7455037,7455013,'b57',3.333,3),(266,7455038,7455013,'579',3.333,3),(266,7455039,7455013,'79e',3.333,3),(266,7455040,7455013,'9e3',3.333,3),(266,7455041,7455013,'e36',3.333,3),(266,7455042,7455013,'36b',3.333,3),(266,7455043,7455013,'6b7',3.333,3),(266,7455044,7455014,'mon',100,1),(266,7455045,7455044,'201',50,1),(266,7455046,7455044,'013',50,1),(266,7455047,7455045,'adm',33.333,3),(266,7455048,7455045,'dmi',33.333,3),(266,7455049,7455045,'min',33.333,3),(266,7455050,7455047,'cap',16.667,1),(266,7455051,7455047,'apa',16.667,1),(266,7455052,7455047,'pac',16.667,1),(266,7455053,7455047,'aci',16.667,1),(266,7455054,7455047,'cit',16.667,1),(266,7455055,7455047,'ity',16.667,1),(266,7455056,7455050,'pat',50,1),(266,7455057,7455050,'ath',50,1),(266,7455058,7455056,'fre',14.286,1),(266,7455059,7455056,'ree',14.286,1),(266,7455060,7455056,'ees',14.286,1),(266,7455061,7455056,'esp',14.286,1),(266,7455062,7455056,'spa',14.286,1),(266,7455063,7455056,'pac',14.286,1),(266,7455064,7455056,'ace',14.286,1),(266,7455065,7455058,'dis',50,1),(266,7455066,7455058,'isk',50,1),(266,7455067,7455065,'ind',33.333,1),(266,7455068,7455065,'nde',33.333,1),(266,7455069,7455065,'dex',33.333,1),(266,7455070,7455067,'adm',8.333,1),(266,7455071,7455067,'dmi',8.333,1),(266,7455072,7455067,'min',8.333,1),(266,7455073,7455067,'ini',8.333,1),(266,7455074,7455067,'nis',8.333,1),(266,7455075,7455067,'ist',8.333,1),(266,7455076,7455067,'str',8.333,1),(266,7455077,7455067,'tra',8.333,1),(266,7455078,7455067,'rat',8.333,1),(266,7455079,7455067,'ati',8.333,1),(266,7455080,7455067,'tio',8.333,1),(266,7455081,7455067,'ion',8.333,1),(266,7455082,7455070,'sta',33.333,3),(266,7455083,7455070,'tat',33.333,3),(266,7455084,7455070,'ate',33.333,3),(266,7455085,7455082,'ena',20,2),(266,7455086,7455082,'nab',20,2),(266,7455087,7455082,'abl',20,2),(266,7455088,7455082,'ble',20,2),(266,7455089,7455082,'led',20,2),(266,7455090,7455085,'cac',33.333,1),(266,7455091,7455085,'ach',33.333,1),(266,7455092,7455085,'che',33.333,1),(266,7455093,7455090,'mod',50,2),(266,7455094,7455090,'ode',50,2),(266,7455095,7455093,'wri',14.286,2),(266,7455096,7455093,'rit',14.286,2),(266,7455097,7455093,'ite',14.286,2),(266,7455098,7455093,'tet',14.286,2),(266,7455099,7455093,'eth',14.286,2),(266,7455100,7455093,'thr',14.286,2),(266,7455101,7455093,'hru',14.286,2),(266,7455102,7455095,'ope',11.111,2),(266,7455103,7455095,'per',11.111,2),(266,7455104,7455095,'era',11.111,2),(266,7455105,7455095,'rat',11.111,2),(266,7455106,7455095,'ati',11.111,2),(266,7455107,7455095,'tio',11.111,2),(266,7455108,7455095,'ion',11.111,2),(266,7455109,7455095,'ona',11.111,2),(266,7455110,7455095,'nal',11.111,2),(266,7455111,7455102,'nor',25,1),(266,7455112,7455102,'orm',25,1),(266,7455113,7455102,'rma',25,1),(266,7455114,7455102,'mal',25,1),(266,7455115,7455111,'mes',20,1),(266,7455116,7455111,'ess',20,1),(266,7455117,7455111,'ssa',20,1),(266,7455118,7455111,'sag',20,1),(266,7455119,7455111,'age',20,1),(266,7455120,7455115,'per',11.111,1),(266,7455121,7455115,'erf',11.111,1),(266,7455122,7455115,'rfo',11.111,1),(266,7455123,7455115,'for',11.111,1),(266,7455124,7455115,'orm',11.111,1),(266,7455125,7455115,'rma',11.111,1),(266,7455126,7455115,'man',11.111,1),(266,7455127,7455115,'anc',11.111,1),(266,7455128,7455115,'nce',11.111,1),(266,7455129,7455120,'ide',12.5,1),(266,7455130,7455120,'den',12.5,1),(266,7455131,7455120,'ent',12.5,1),(266,7455132,7455120,'nti',12.5,1),(266,7455133,7455120,'tif',12.5,1),(266,7455134,7455120,'ifi',12.5,1),(266,7455135,7455120,'fie',12.5,1),(266,7455136,7455120,'ier',12.5,1),(266,7455137,7455129,'vdi',33.333,3),(266,7455138,7455129,'dis',33.333,3),(266,7455139,7455129,'isk',33.333,3),(266,7455140,7455137,'nam',50,1),(266,7455141,7455137,'ame',50,1),(266,7455142,7455140,'typ',50,1),(266,7455143,7455140,'ype',50,1),(266,7455144,7455142,'dir',25,1),(266,7455145,7455142,'ire',25,1),(266,7455146,7455142,'rec',25,1),(266,7455147,7455142,'ect',25,1),(267,7455149,7455148,'naa',100,2),(267,7455150,7455149,'600',3.333,3),(267,7455151,7455149,'000',3.333,3),(267,7455152,7455149,'00c',3.333,3),(267,7455153,7455149,'0c2',3.333,3),(267,7455154,7455149,'c29',3.333,3),(267,7455155,7455149,'29e',3.333,3),(267,7455156,7455149,'9e2',3.333,3),(267,7455157,7455149,'e26',3.333,3),(267,7455158,7455149,'268',3.333,3),(267,7455159,7455149,'682',3.333,3),(267,7455160,7455149,'82f',3.333,3),(267,7455161,7455149,'2f4',3.333,3),(267,7455162,7455149,'f4d',3.333,3),(267,7455163,7455149,'4db',3.333,3),(267,7455164,7455149,'db1',3.333,3),(267,7455165,7455149,'b15',3.333,3),(267,7455166,7455149,'151',3.333,3),(267,7455167,7455149,'511',3.333,3),(267,7455168,7455149,'114',3.333,3),(267,7455169,7455149,'14d',3.333,3),(267,7455170,7455149,'4dd',3.333,3),(267,7455171,7455149,'dd9',3.333,3),(267,7455172,7455149,'d94',3.333,3),(267,7455173,7455149,'944',3.333,3),(267,7455174,7455149,'441',3.333,3),(267,7455175,7455149,'41e',3.333,3),(267,7455176,7455149,'1e9',3.333,3),(267,7455177,7455149,'e9c',3.333,3),(267,7455178,7455149,'9c1',3.333,3),(267,7455179,7455149,'c15',3.333,3),(267,7455180,7455150,'mon',100,1),(267,7455181,7455180,'201',50,1),(267,7455182,7455180,'013',50,1),(267,7455183,7455181,'adm',33.333,3),(267,7455184,7455181,'dmi',33.333,3),(267,7455185,7455181,'min',33.333,3),(267,7455186,7455183,'cap',16.667,1),(267,7455187,7455183,'apa',16.667,1),(267,7455188,7455183,'pac',16.667,1),(267,7455189,7455183,'aci',16.667,1),(267,7455190,7455183,'cit',16.667,1),(267,7455191,7455183,'ity',16.667,1),(267,7455192,7455186,'pat',50,1),(267,7455193,7455186,'ath',50,1),(267,7455194,7455192,'fre',14.286,1),(267,7455195,7455192,'ree',14.286,1),(267,7455196,7455192,'ees',14.286,1),(267,7455197,7455192,'esp',14.286,1),(267,7455198,7455192,'spa',14.286,1),(267,7455199,7455192,'pac',14.286,1),(267,7455200,7455192,'ace',14.286,1),(267,7455201,7455194,'dis',50,1),(267,7455202,7455194,'isk',50,1),(267,7455203,7455201,'ind',33.333,1),(267,7455204,7455201,'nde',33.333,1),(267,7455205,7455201,'dex',33.333,1),(267,7455206,7455203,'adm',8.333,1),(267,7455207,7455203,'dmi',8.333,1),(267,7455208,7455203,'min',8.333,1),(267,7455209,7455203,'ini',8.333,1),(267,7455210,7455203,'nis',8.333,1),(267,7455211,7455203,'ist',8.333,1),(267,7455212,7455203,'str',8.333,1),(267,7455213,7455203,'tra',8.333,1),(267,7455214,7455203,'rat',8.333,1),(267,7455215,7455203,'ati',8.333,1),(267,7455216,7455203,'tio',8.333,1),(267,7455217,7455203,'ion',8.333,1),(267,7455218,7455206,'sta',33.333,3),(267,7455219,7455206,'tat',33.333,3),(267,7455220,7455206,'ate',33.333,3),(267,7455221,7455218,'ena',20,2),(267,7455222,7455218,'nab',20,2),(267,7455223,7455218,'abl',20,2),(267,7455224,7455218,'ble',20,2),(267,7455225,7455218,'led',20,2),(267,7455226,7455221,'cac',33.333,1),(267,7455227,7455221,'ach',33.333,1),(267,7455228,7455221,'che',33.333,1),(267,7455229,7455226,'mod',50,2),(267,7455230,7455226,'ode',50,2),(267,7455231,7455229,'wri',14.286,2),(267,7455232,7455229,'rit',14.286,2),(267,7455233,7455229,'ite',14.286,2),(267,7455234,7455229,'tet',14.286,2),(267,7455235,7455229,'eth',14.286,2),(267,7455236,7455229,'thr',14.286,2),(267,7455237,7455229,'hru',14.286,2),(267,7455238,7455231,'ope',11.111,2),(267,7455239,7455231,'per',11.111,2),(267,7455240,7455231,'era',11.111,2),(267,7455241,7455231,'rat',11.111,2),(267,7455242,7455231,'ati',11.111,2),(267,7455243,7455231,'tio',11.111,2),(267,7455244,7455231,'ion',11.111,2),(267,7455245,7455231,'ona',11.111,2),(267,7455246,7455231,'nal',11.111,2),(267,7455247,7455238,'nor',25,1),(267,7455248,7455238,'orm',25,1),(267,7455249,7455238,'rma',25,1),(267,7455250,7455238,'mal',25,1),(267,7455251,7455247,'mes',20,1),(267,7455252,7455247,'ess',20,1),(267,7455253,7455247,'ssa',20,1),(267,7455254,7455247,'sag',20,1),(267,7455255,7455247,'age',20,1),(267,7455256,7455251,'per',11.111,1),(267,7455257,7455251,'erf',11.111,1),(267,7455258,7455251,'rfo',11.111,1),(267,7455259,7455251,'for',11.111,1),(267,7455260,7455251,'orm',11.111,1),(267,7455261,7455251,'rma',11.111,1),(267,7455262,7455251,'man',11.111,1),(267,7455263,7455251,'anc',11.111,1),(267,7455264,7455251,'nce',11.111,1),(267,7455265,7455256,'ide',12.5,1),(267,7455266,7455256,'den',12.5,1),(267,7455267,7455256,'ent',12.5,1),(267,7455268,7455256,'nti',12.5,1),(267,7455269,7455256,'tif',12.5,1),(267,7455270,7455256,'ifi',12.5,1),(267,7455271,7455256,'fie',12.5,1),(267,7455272,7455256,'ier',12.5,1),(267,7455273,7455265,'vdi',33.333,3),(267,7455274,7455265,'dis',33.333,3),(267,7455275,7455265,'isk',33.333,3),(267,7455276,7455273,'nam',50,1),(267,7455277,7455273,'ame',50,1),(267,7455278,7455276,'typ',50,1),(267,7455279,7455276,'ype',50,1),(267,7455280,7455278,'dir',25,1),(267,7455281,7455278,'ire',25,1),(267,7455282,7455278,'rec',25,1),(267,7455283,7455278,'ect',25,1),(268,7455285,7455284,'naa',100,2),(268,7455286,7455285,'600',3.333,3),(268,7455287,7455285,'000',3.333,3),(268,7455288,7455285,'00c',3.333,3),(268,7455289,7455285,'0c2',3.333,3),(268,7455290,7455285,'c29',3.333,3),(268,7455291,7455285,'290',3.333,3),(268,7455292,7455285,'904',3.333,3),(268,7455293,7455285,'047',3.333,3),(268,7455294,7455285,'478',3.333,3),(268,7455295,7455285,'789',3.333,3),(268,7455296,7455285,'896',3.333,3),(268,7455297,7455285,'96a',3.333,3),(268,7455298,7455285,'6a9',3.333,3),(268,7455299,7455285,'a98',3.333,3),(268,7455300,7455285,'98a',3.333,3),(268,7455301,7455285,'8ad',3.333,3),(268,7455302,7455285,'adc',3.333,3),(268,7455303,7455285,'dc8',3.333,3),(268,7455304,7455285,'c87',3.333,3),(268,7455305,7455285,'870',3.333,3),(268,7455306,7455285,'70d',3.333,3),(268,7455307,7455285,'0df',3.333,3),(268,7455308,7455285,'dfb',3.333,3),(268,7455309,7455285,'fbe',3.333,3),(268,7455310,7455285,'beb',3.333,3),(268,7455311,7455285,'eba',3.333,3),(268,7455312,7455285,'bae',3.333,3),(268,7455313,7455285,'aea',3.333,3),(268,7455314,7455285,'eac',3.333,3),(268,7455315,7455285,'ac2',3.333,3),(268,7455316,7455286,'mon',100,1),(268,7455317,7455316,'201',50,1),(268,7455318,7455316,'013',50,1),(268,7455319,7455317,'adm',33.333,3),(268,7455320,7455317,'dmi',33.333,3),(268,7455321,7455317,'min',33.333,3),(268,7455322,7455319,'cap',16.667,1),(268,7455323,7455319,'apa',16.667,1),(268,7455324,7455319,'pac',16.667,1),(268,7455325,7455319,'aci',16.667,1),(268,7455326,7455319,'cit',16.667,1),(268,7455327,7455319,'ity',16.667,1),(268,7455328,7455322,'pat',50,1),(268,7455329,7455322,'ath',50,1),(268,7455330,7455328,'fre',14.286,1),(268,7455331,7455328,'ree',14.286,1),(268,7455332,7455328,'ees',14.286,1),(268,7455333,7455328,'esp',14.286,1),(268,7455334,7455328,'spa',14.286,1),(268,7455335,7455328,'pac',14.286,1),(268,7455336,7455328,'ace',14.286,1),(268,7455337,7455330,'dis',50,1),(268,7455338,7455330,'isk',50,1),(268,7455339,7455337,'ind',33.333,1),(268,7455340,7455337,'nde',33.333,1),(268,7455341,7455337,'dex',33.333,1),(268,7455342,7455339,'adm',8.333,1),(268,7455343,7455339,'dmi',8.333,1),(268,7455344,7455339,'min',8.333,1),(268,7455345,7455339,'ini',8.333,1),(268,7455346,7455339,'nis',8.333,1),(268,7455347,7455339,'ist',8.333,1),(268,7455348,7455339,'str',8.333,1),(268,7455349,7455339,'tra',8.333,1),(268,7455350,7455339,'rat',8.333,1),(268,7455351,7455339,'ati',8.333,1),(268,7455352,7455339,'tio',8.333,1),(268,7455353,7455339,'ion',8.333,1),(268,7455354,7455342,'sta',33.333,3),(268,7455355,7455342,'tat',33.333,3),(268,7455356,7455342,'ate',33.333,3),(268,7455357,7455354,'ena',20,2),(268,7455358,7455354,'nab',20,2),(268,7455359,7455354,'abl',20,2),(268,7455360,7455354,'ble',20,2),(268,7455361,7455354,'led',20,2),(268,7455362,7455357,'cac',33.333,1),(268,7455363,7455357,'ach',33.333,1),(268,7455364,7455357,'che',33.333,1),(268,7455365,7455362,'mod',50,2),(268,7455366,7455362,'ode',50,2),(268,7455367,7455365,'wri',14.286,2),(268,7455368,7455365,'rit',14.286,2),(268,7455369,7455365,'ite',14.286,2),(268,7455370,7455365,'tet',14.286,2),(268,7455371,7455365,'eth',14.286,2),(268,7455372,7455365,'thr',14.286,2),(268,7455373,7455365,'hru',14.286,2),(268,7455374,7455367,'ope',11.111,2),(268,7455375,7455367,'per',11.111,2),(268,7455376,7455367,'era',11.111,2),(268,7455377,7455367,'rat',11.111,2),(268,7455378,7455367,'ati',11.111,2),(268,7455379,7455367,'tio',11.111,2),(268,7455380,7455367,'ion',11.111,2),(268,7455381,7455367,'ona',11.111,2),(268,7455382,7455367,'nal',11.111,2),(268,7455383,7455374,'nor',25,1),(268,7455384,7455374,'orm',25,1),(268,7455385,7455374,'rma',25,1),(268,7455386,7455374,'mal',25,1),(268,7455387,7455383,'mes',20,1),(268,7455388,7455383,'ess',20,1),(268,7455389,7455383,'ssa',20,1),(268,7455390,7455383,'sag',20,1),(268,7455391,7455383,'age',20,1),(268,7455392,7455387,'per',11.111,1),(268,7455393,7455387,'erf',11.111,1),(268,7455394,7455387,'rfo',11.111,1),(268,7455395,7455387,'for',11.111,1),(268,7455396,7455387,'orm',11.111,1),(268,7455397,7455387,'rma',11.111,1),(268,7455398,7455387,'man',11.111,1),(268,7455399,7455387,'anc',11.111,1),(268,7455400,7455387,'nce',11.111,1),(268,7455401,7455392,'ide',12.5,1),(268,7455402,7455392,'den',12.5,1),(268,7455403,7455392,'ent',12.5,1),(268,7455404,7455392,'nti',12.5,1),(268,7455405,7455392,'tif',12.5,1),(268,7455406,7455392,'ifi',12.5,1),(268,7455407,7455392,'fie',12.5,1),(268,7455408,7455392,'ier',12.5,1),(268,7455409,7455401,'vdi',33.333,3),(268,7455410,7455401,'dis',33.333,3),(268,7455411,7455401,'isk',33.333,3),(268,7455412,7455409,'nam',50,1),(268,7455413,7455409,'ame',50,1),(268,7455414,7455412,'typ',50,1),(268,7455415,7455412,'ype',50,1),(268,7455416,7455414,'dir',25,1),(268,7455417,7455414,'ire',25,1),(268,7455418,7455414,'rec',25,1),(268,7455419,7455414,'ect',25,1),(269,7455421,7455420,'naa',100,2),(269,7455422,7455421,'600',3.333,3),(269,7455423,7455421,'000',3.333,3),(269,7455424,7455421,'00c',3.333,3),(269,7455425,7455421,'0c2',3.333,3),(269,7455426,7455421,'c29',3.333,3),(269,7455427,7455421,'293',3.333,3),(269,7455428,7455421,'930',3.333,3),(269,7455429,7455421,'306',3.333,3),(269,7455430,7455421,'069',3.333,3),(269,7455431,7455421,'690',3.333,3),(269,7455432,7455421,'908',3.333,3),(269,7455433,7455421,'084',3.333,3),(269,7455434,7455421,'849',3.333,3),(269,7455435,7455421,'49f',3.333,3),(269,7455436,7455421,'9f0',3.333,3),(269,7455437,7455421,'f0f',3.333,3),(269,7455438,7455421,'0f0',3.333,3),(269,7455439,7455421,'f02',3.333,3),(269,7455440,7455421,'027',3.333,3),(269,7455441,7455421,'27e',3.333,3),(269,7455442,7455421,'7e2',3.333,3),(269,7455443,7455421,'e2b',3.333,3),(269,7455444,7455421,'2bd',3.333,3),(269,7455445,7455421,'bde',3.333,3),(269,7455446,7455421,'dea',3.333,3),(269,7455447,7455421,'ea1',3.333,3),(269,7455448,7455421,'a15',3.333,3),(269,7455449,7455421,'159',3.333,3),(269,7455450,7455421,'597',3.333,3),(269,7455451,7455421,'971',3.333,3),(269,7455452,7455422,'mon',100,1),(269,7455453,7455452,'201',50,1),(269,7455454,7455452,'013',50,1),(269,7455455,7455453,'adm',33.333,3),(269,7455456,7455453,'dmi',33.333,3),(269,7455457,7455453,'min',33.333,3),(269,7455458,7455455,'cap',16.667,1),(269,7455459,7455455,'apa',16.667,1),(269,7455460,7455455,'pac',16.667,1),(269,7455461,7455455,'aci',16.667,1),(269,7455462,7455455,'cit',16.667,1),(269,7455463,7455455,'ity',16.667,1),(269,7455464,7455458,'pat',50,1),(269,7455465,7455458,'ath',50,1),(269,7455466,7455464,'fre',14.286,1),(269,7455467,7455464,'ree',14.286,1),(269,7455468,7455464,'ees',14.286,1),(269,7455469,7455464,'esp',14.286,1),(269,7455470,7455464,'spa',14.286,1),(269,7455471,7455464,'pac',14.286,1),(269,7455472,7455464,'ace',14.286,1),(269,7455473,7455466,'dis',50,1),(269,7455474,7455466,'isk',50,1),(269,7455475,7455473,'ind',33.333,1),(269,7455476,7455473,'nde',33.333,1),(269,7455477,7455473,'dex',33.333,1),(269,7455478,7455475,'adm',8.333,1),(269,7455479,7455475,'dmi',8.333,1),(269,7455480,7455475,'min',8.333,1),(269,7455481,7455475,'ini',8.333,1),(269,7455482,7455475,'nis',8.333,1),(269,7455483,7455475,'ist',8.333,1),(269,7455484,7455475,'str',8.333,1),(269,7455485,7455475,'tra',8.333,1),(269,7455486,7455475,'rat',8.333,1),(269,7455487,7455475,'ati',8.333,1),(269,7455488,7455475,'tio',8.333,1),(269,7455489,7455475,'ion',8.333,1),(269,7455490,7455478,'sta',33.333,3),(269,7455491,7455478,'tat',33.333,3),(269,7455492,7455478,'ate',33.333,3),(269,7455493,7455490,'ena',20,2),(269,7455494,7455490,'nab',20,2),(269,7455495,7455490,'abl',20,2),(269,7455496,7455490,'ble',20,2),(269,7455497,7455490,'led',20,2),(269,7455498,7455493,'cac',33.333,1),(269,7455499,7455493,'ach',33.333,1),(269,7455500,7455493,'che',33.333,1),(269,7455501,7455498,'mod',50,2),(269,7455502,7455498,'ode',50,2),(269,7455503,7455501,'wri',14.286,2),(269,7455504,7455501,'rit',14.286,2),(269,7455505,7455501,'ite',14.286,2),(269,7455506,7455501,'tet',14.286,2),(269,7455507,7455501,'eth',14.286,2),(269,7455508,7455501,'thr',14.286,2),(269,7455509,7455501,'hru',14.286,2),(269,7455510,7455503,'ope',11.111,2),(269,7455511,7455503,'per',11.111,2),(269,7455512,7455503,'era',11.111,2),(269,7455513,7455503,'rat',11.111,2),(269,7455514,7455503,'ati',11.111,2),(269,7455515,7455503,'tio',11.111,2),(269,7455516,7455503,'ion',11.111,2),(269,7455517,7455503,'ona',11.111,2),(269,7455518,7455503,'nal',11.111,2),(269,7455519,7455510,'nor',25,1),(269,7455520,7455510,'orm',25,1),(269,7455521,7455510,'rma',25,1),(269,7455522,7455510,'mal',25,1),(269,7455523,7455519,'mes',20,1),(269,7455524,7455519,'ess',20,1),(269,7455525,7455519,'ssa',20,1),(269,7455526,7455519,'sag',20,1),(269,7455527,7455519,'age',20,1),(269,7455528,7455523,'per',11.111,1),(269,7455529,7455523,'erf',11.111,1),(269,7455530,7455523,'rfo',11.111,1),(269,7455531,7455523,'for',11.111,1),(269,7455532,7455523,'orm',11.111,1),(269,7455533,7455523,'rma',11.111,1),(269,7455534,7455523,'man',11.111,1),(269,7455535,7455523,'anc',11.111,1),(269,7455536,7455523,'nce',11.111,1),(269,7455537,7455528,'ide',12.5,1),(269,7455538,7455528,'den',12.5,1),(269,7455539,7455528,'ent',12.5,1),(269,7455540,7455528,'nti',12.5,1),(269,7455541,7455528,'tif',12.5,1),(269,7455542,7455528,'ifi',12.5,1),(269,7455543,7455528,'fie',12.5,1),(269,7455544,7455528,'ier',12.5,1),(269,7455545,7455537,'vdi',33.333,3),(269,7455546,7455537,'dis',33.333,3),(269,7455547,7455537,'isk',33.333,3),(269,7455548,7455545,'nam',50,1),(269,7455549,7455545,'ame',50,1),(269,7455550,7455548,'typ',50,1),(269,7455551,7455548,'ype',50,1),(269,7455552,7455550,'dir',25,1),(269,7455553,7455550,'ire',25,1),(269,7455554,7455550,'rec',25,1),(269,7455555,7455550,'ect',25,1),(270,7455557,7455556,'naa',100,2),(270,7455558,7455557,'600',3.333,3),(270,7455559,7455557,'000',3.333,3),(270,7455560,7455557,'00c',3.333,3),(270,7455561,7455557,'0c2',3.333,3),(270,7455562,7455557,'c29',3.333,3),(270,7455563,7455557,'29f',3.333,3),(270,7455564,7455557,'9f5',3.333,3),(270,7455565,7455557,'f57',3.333,3),(270,7455566,7455557,'57c',3.333,3),(270,7455567,7455557,'7cc',3.333,3),(270,7455568,7455557,'cc9',3.333,3),(270,7455569,7455557,'c96',3.333,3),(270,7455570,7455557,'968',3.333,3),(270,7455571,7455557,'68b',3.333,3),(270,7455572,7455557,'8bf',3.333,3),(270,7455573,7455557,'bfb',3.333,3),(270,7455574,7455557,'fbb',3.333,3),(270,7455575,7455557,'bb5',3.333,3),(270,7455576,7455557,'b54',3.333,3),(270,7455577,7455557,'545',3.333,3),(270,7455578,7455557,'45d',3.333,3),(270,7455579,7455557,'5db',3.333,3),(270,7455580,7455557,'dbf',3.333,3),(270,7455581,7455557,'bf2',3.333,3),(270,7455582,7455557,'f20',3.333,3),(270,7455583,7455557,'20a',3.333,3),(270,7455584,7455557,'0a1',3.333,3),(270,7455585,7455557,'a18',3.333,3),(270,7455586,7455557,'188',3.333,3),(270,7455587,7455557,'886',3.333,3),(270,7455588,7455558,'mon',100,1),(270,7455589,7455588,'201',50,1),(270,7455590,7455588,'013',50,1),(270,7455591,7455589,'adm',33.333,3),(270,7455592,7455589,'dmi',33.333,3),(270,7455593,7455589,'min',33.333,3),(270,7455594,7455591,'cap',16.667,1),(270,7455595,7455591,'apa',16.667,1),(270,7455596,7455591,'pac',16.667,1),(270,7455597,7455591,'aci',16.667,1),(270,7455598,7455591,'cit',16.667,1),(270,7455599,7455591,'ity',16.667,1),(270,7455600,7455594,'pat',50,1),(270,7455601,7455594,'ath',50,1),(270,7455602,7455600,'fre',14.286,1),(270,7455603,7455600,'ree',14.286,1),(270,7455604,7455600,'ees',14.286,1),(270,7455605,7455600,'esp',14.286,1),(270,7455606,7455600,'spa',14.286,1),(270,7455607,7455600,'pac',14.286,1),(270,7455608,7455600,'ace',14.286,1),(270,7455609,7455602,'dis',50,1),(270,7455610,7455602,'isk',50,1),(270,7455611,7455609,'ind',33.333,1),(270,7455612,7455609,'nde',33.333,1),(270,7455613,7455609,'dex',33.333,1),(270,7455614,7455611,'adm',8.333,1),(270,7455615,7455611,'dmi',8.333,1),(270,7455616,7455611,'min',8.333,1),(270,7455617,7455611,'ini',8.333,1),(270,7455618,7455611,'nis',8.333,1),(270,7455619,7455611,'ist',8.333,1),(270,7455620,7455611,'str',8.333,1),(270,7455621,7455611,'tra',8.333,1),(270,7455622,7455611,'rat',8.333,1),(270,7455623,7455611,'ati',8.333,1),(270,7455624,7455611,'tio',8.333,1),(270,7455625,7455611,'ion',8.333,1),(270,7455626,7455614,'sta',33.333,3),(270,7455627,7455614,'tat',33.333,3),(270,7455628,7455614,'ate',33.333,3),(270,7455629,7455626,'ena',20,2),(270,7455630,7455626,'nab',20,2),(270,7455631,7455626,'abl',20,2),(270,7455632,7455626,'ble',20,2),(270,7455633,7455626,'led',20,2),(270,7455634,7455629,'cac',33.333,1),(270,7455635,7455629,'ach',33.333,1),(270,7455636,7455629,'che',33.333,1),(270,7455637,7455634,'mod',50,2),(270,7455638,7455634,'ode',50,2),(270,7455639,7455637,'wri',14.286,2),(270,7455640,7455637,'rit',14.286,2),(270,7455641,7455637,'ite',14.286,2),(270,7455642,7455637,'tet',14.286,2),(270,7455643,7455637,'eth',14.286,2),(270,7455644,7455637,'thr',14.286,2),(270,7455645,7455637,'hru',14.286,2),(270,7455646,7455639,'ope',11.111,2),(270,7455647,7455639,'per',11.111,2),(270,7455648,7455639,'era',11.111,2),(270,7455649,7455639,'rat',11.111,2),(270,7455650,7455639,'ati',11.111,2),(270,7455651,7455639,'tio',11.111,2),(270,7455652,7455639,'ion',11.111,2),(270,7455653,7455639,'ona',11.111,2),(270,7455654,7455639,'nal',11.111,2),(270,7455655,7455646,'nor',25,1),(270,7455656,7455646,'orm',25,1),(270,7455657,7455646,'rma',25,1),(270,7455658,7455646,'mal',25,1),(270,7455659,7455655,'mes',20,1),(270,7455660,7455655,'ess',20,1),(270,7455661,7455655,'ssa',20,1),(270,7455662,7455655,'sag',20,1),(270,7455663,7455655,'age',20,1),(270,7455664,7455659,'per',11.111,1),(270,7455665,7455659,'erf',11.111,1),(270,7455666,7455659,'rfo',11.111,1),(270,7455667,7455659,'for',11.111,1),(270,7455668,7455659,'orm',11.111,1),(270,7455669,7455659,'rma',11.111,1),(270,7455670,7455659,'man',11.111,1),(270,7455671,7455659,'anc',11.111,1),(270,7455672,7455659,'nce',11.111,1),(270,7455673,7455664,'ide',12.5,1),(270,7455674,7455664,'den',12.5,1),(270,7455675,7455664,'ent',12.5,1),(270,7455676,7455664,'nti',12.5,1),(270,7455677,7455664,'tif',12.5,1),(270,7455678,7455664,'ifi',12.5,1),(270,7455679,7455664,'fie',12.5,1),(270,7455680,7455664,'ier',12.5,1),(270,7455681,7455673,'vdi',33.333,3),(270,7455682,7455673,'dis',33.333,3),(270,7455683,7455673,'isk',33.333,3),(270,7455684,7455681,'nam',50,1),(270,7455685,7455681,'ame',50,1),(270,7455686,7455684,'typ',50,1),(270,7455687,7455684,'ype',50,1),(270,7455688,7455686,'dir',25,1),(270,7455689,7455686,'ire',25,1),(270,7455690,7455686,'rec',25,1),(270,7455691,7455686,'ect',25,1),(271,7455693,7455692,'naa',100,2),(271,7455694,7455693,'600',3.333,3),(271,7455695,7455693,'000',3.333,3),(271,7455696,7455693,'00c',3.333,3),(271,7455697,7455693,'0c2',3.333,3),(271,7455698,7455693,'c29',3.333,3),(271,7455699,7455693,'296',3.333,3),(271,7455700,7455693,'96c',3.333,3),(271,7455701,7455693,'6c4',3.333,3),(271,7455702,7455693,'c4b',3.333,3),(271,7455703,7455693,'4b8',3.333,3),(271,7455704,7455693,'b84',3.333,3),(271,7455705,7455693,'84c',3.333,3),(271,7455706,7455693,'4cf',3.333,3),(271,7455707,7455693,'cf9',3.333,3),(271,7455708,7455693,'f9c',3.333,3),(271,7455709,7455693,'9c0',3.333,3),(271,7455710,7455693,'c02',3.333,3),(271,7455711,7455693,'023',3.333,3),(271,7455712,7455693,'23f',3.333,3),(271,7455713,7455693,'3f5',3.333,3),(271,7455714,7455693,'f5b',3.333,3),(271,7455715,7455693,'5bd',3.333,3),(271,7455716,7455693,'bd4',3.333,3),(271,7455717,7455693,'d4f',3.333,3),(271,7455718,7455693,'4f7',3.333,3),(271,7455719,7455693,'f7e',3.333,3),(271,7455720,7455693,'7ed',3.333,3),(271,7455721,7455693,'ed0',3.333,3),(271,7455722,7455693,'d00',3.333,3),(271,7455723,7455693,'00f',3.333,3),(271,7455724,7455694,'mon',100,1),(271,7455725,7455724,'201',50,1),(271,7455726,7455724,'013',50,1),(271,7455727,7455725,'adm',33.333,3),(271,7455728,7455725,'dmi',33.333,3),(271,7455729,7455725,'min',33.333,3),(271,7455730,7455727,'cap',16.667,1),(271,7455731,7455727,'apa',16.667,1),(271,7455732,7455727,'pac',16.667,1),(271,7455733,7455727,'aci',16.667,1),(271,7455734,7455727,'cit',16.667,1),(271,7455735,7455727,'ity',16.667,1),(271,7455736,7455730,'pat',50,1),(271,7455737,7455730,'ath',50,1),(271,7455738,7455736,'fre',14.286,1),(271,7455739,7455736,'ree',14.286,1),(271,7455740,7455736,'ees',14.286,1),(271,7455741,7455736,'esp',14.286,1),(271,7455742,7455736,'spa',14.286,1),(271,7455743,7455736,'pac',14.286,1),(271,7455744,7455736,'ace',14.286,1),(271,7455745,7455738,'dis',50,1),(271,7455746,7455738,'isk',50,1),(271,7455747,7455745,'ind',33.333,1),(271,7455748,7455745,'nde',33.333,1),(271,7455749,7455745,'dex',33.333,1),(271,7455750,7455747,'adm',8.333,1),(271,7455751,7455747,'dmi',8.333,1),(271,7455752,7455747,'min',8.333,1),(271,7455753,7455747,'ini',8.333,1),(271,7455754,7455747,'nis',8.333,1),(271,7455755,7455747,'ist',8.333,1),(271,7455756,7455747,'str',8.333,1),(271,7455757,7455747,'tra',8.333,1),(271,7455758,7455747,'rat',8.333,1),(271,7455759,7455747,'ati',8.333,1),(271,7455760,7455747,'tio',8.333,1),(271,7455761,7455747,'ion',8.333,1),(271,7455762,7455750,'sta',33.333,3),(271,7455763,7455750,'tat',33.333,3),(271,7455764,7455750,'ate',33.333,3),(271,7455765,7455762,'ena',20,2),(271,7455766,7455762,'nab',20,2),(271,7455767,7455762,'abl',20,2),(271,7455768,7455762,'ble',20,2),(271,7455769,7455762,'led',20,2),(271,7455770,7455765,'cac',33.333,1),(271,7455771,7455765,'ach',33.333,1),(271,7455772,7455765,'che',33.333,1),(271,7455773,7455770,'mod',50,2),(271,7455774,7455770,'ode',50,2),(271,7455775,7455773,'wri',14.286,2),(271,7455776,7455773,'rit',14.286,2),(271,7455777,7455773,'ite',14.286,2),(271,7455778,7455773,'tet',14.286,2),(271,7455779,7455773,'eth',14.286,2),(271,7455780,7455773,'thr',14.286,2),(271,7455781,7455773,'hru',14.286,2),(271,7455782,7455775,'ope',11.111,2),(271,7455783,7455775,'per',11.111,2),(271,7455784,7455775,'era',11.111,2),(271,7455785,7455775,'rat',11.111,2),(271,7455786,7455775,'ati',11.111,2),(271,7455787,7455775,'tio',11.111,2),(271,7455788,7455775,'ion',11.111,2),(271,7455789,7455775,'ona',11.111,2),(271,7455790,7455775,'nal',11.111,2),(271,7455791,7455782,'nor',25,1),(271,7455792,7455782,'orm',25,1),(271,7455793,7455782,'rma',25,1),(271,7455794,7455782,'mal',25,1),(271,7455795,7455791,'mes',20,1),(271,7455796,7455791,'ess',20,1),(271,7455797,7455791,'ssa',20,1),(271,7455798,7455791,'sag',20,1),(271,7455799,7455791,'age',20,1),(271,7455800,7455795,'per',11.111,1),(271,7455801,7455795,'erf',11.111,1),(271,7455802,7455795,'rfo',11.111,1),(271,7455803,7455795,'for',11.111,1),(271,7455804,7455795,'orm',11.111,1),(271,7455805,7455795,'rma',11.111,1),(271,7455806,7455795,'man',11.111,1),(271,7455807,7455795,'anc',11.111,1),(271,7455808,7455795,'nce',11.111,1),(271,7455809,7455800,'ide',12.5,1),(271,7455810,7455800,'den',12.5,1),(271,7455811,7455800,'ent',12.5,1),(271,7455812,7455800,'nti',12.5,1),(271,7455813,7455800,'tif',12.5,1),(271,7455814,7455800,'ifi',12.5,1),(271,7455815,7455800,'fie',12.5,1),(271,7455816,7455800,'ier',12.5,1),(271,7455817,7455809,'vdi',33.333,3),(271,7455818,7455809,'dis',33.333,3),(271,7455819,7455809,'isk',33.333,3),(271,7455820,7455817,'nam',50,1),(271,7455821,7455817,'ame',50,1),(271,7455822,7455820,'typ',50,1),(271,7455823,7455820,'ype',50,1),(271,7455824,7455822,'dir',25,1),(271,7455825,7455822,'ire',25,1),(271,7455826,7455822,'rec',25,1),(271,7455827,7455822,'ect',25,1),(272,7455829,7455828,'naa',100,2),(272,7455830,7455829,'600',3.333,3),(272,7455831,7455829,'000',3.333,3),(272,7455832,7455829,'00c',3.333,3),(272,7455833,7455829,'0c2',3.333,3),(272,7455834,7455829,'c29',3.333,3),(272,7455835,7455829,'295',3.333,3),(272,7455836,7455829,'954',3.333,3),(272,7455837,7455829,'548',3.333,3),(272,7455838,7455829,'48b',3.333,3),(272,7455839,7455829,'8b2',3.333,3),(272,7455840,7455829,'b21',3.333,3),(272,7455841,7455829,'21a',3.333,3),(272,7455842,7455829,'1a5',3.333,3),(272,7455843,7455829,'a50',3.333,3),(272,7455844,7455829,'50f',3.333,3),(272,7455845,7455829,'0f8',3.333,3),(272,7455846,7455829,'f85',3.333,3),(272,7455847,7455829,'856',3.333,3),(272,7455848,7455829,'567',3.333,3),(272,7455849,7455829,'67f',3.333,3),(272,7455850,7455829,'7f2',3.333,3),(272,7455851,7455829,'f2f',3.333,3),(272,7455852,7455829,'2f9',3.333,3),(272,7455853,7455829,'f98',3.333,3),(272,7455854,7455829,'98d',3.333,3),(272,7455855,7455829,'8d6',3.333,3),(272,7455856,7455829,'d65',3.333,3),(272,7455857,7455829,'657',3.333,3),(272,7455858,7455829,'570',3.333,3),(272,7455859,7455829,'703',3.333,3),(272,7455860,7455830,'mon',100,1),(272,7455861,7455860,'201',50,1),(272,7455862,7455860,'013',50,1),(272,7455863,7455861,'adm',33.333,3),(272,7455864,7455861,'dmi',33.333,3),(272,7455865,7455861,'min',33.333,3),(272,7455866,7455863,'cap',16.667,1),(272,7455867,7455863,'apa',16.667,1),(272,7455868,7455863,'pac',16.667,1),(272,7455869,7455863,'aci',16.667,1),(272,7455870,7455863,'cit',16.667,1),(272,7455871,7455863,'ity',16.667,1),(272,7455872,7455866,'pat',50,1),(272,7455873,7455866,'ath',50,1),(272,7455874,7455872,'fre',14.286,1),(272,7455875,7455872,'ree',14.286,1),(272,7455876,7455872,'ees',14.286,1),(272,7455877,7455872,'esp',14.286,1),(272,7455878,7455872,'spa',14.286,1),(272,7455879,7455872,'pac',14.286,1),(272,7455880,7455872,'ace',14.286,1),(272,7455881,7455874,'dis',50,1),(272,7455882,7455874,'isk',50,1),(272,7455883,7455881,'ind',33.333,1),(272,7455884,7455881,'nde',33.333,1),(272,7455885,7455881,'dex',33.333,1),(272,7455886,7455883,'adm',8.333,1),(272,7455887,7455883,'dmi',8.333,1),(272,7455888,7455883,'min',8.333,1),(272,7455889,7455883,'ini',8.333,1),(272,7455890,7455883,'nis',8.333,1),(272,7455891,7455883,'ist',8.333,1),(272,7455892,7455883,'str',8.333,1),(272,7455893,7455883,'tra',8.333,1),(272,7455894,7455883,'rat',8.333,1),(272,7455895,7455883,'ati',8.333,1),(272,7455896,7455883,'tio',8.333,1),(272,7455897,7455883,'ion',8.333,1),(272,7455898,7455886,'sta',33.333,3),(272,7455899,7455886,'tat',33.333,3),(272,7455900,7455886,'ate',33.333,3),(272,7455901,7455898,'ena',20,2),(272,7455902,7455898,'nab',20,2),(272,7455903,7455898,'abl',20,2),(272,7455904,7455898,'ble',20,2),(272,7455905,7455898,'led',20,2),(272,7455906,7455901,'cac',33.333,1),(272,7455907,7455901,'ach',33.333,1),(272,7455908,7455901,'che',33.333,1),(272,7455909,7455906,'mod',50,2),(272,7455910,7455906,'ode',50,2),(272,7455911,7455909,'wri',14.286,2),(272,7455912,7455909,'rit',14.286,2),(272,7455913,7455909,'ite',14.286,2),(272,7455914,7455909,'tet',14.286,2),(272,7455915,7455909,'eth',14.286,2),(272,7455916,7455909,'thr',14.286,2),(272,7455917,7455909,'hru',14.286,2),(272,7455918,7455911,'ope',11.111,2),(272,7455919,7455911,'per',11.111,2),(272,7455920,7455911,'era',11.111,2),(272,7455921,7455911,'rat',11.111,2),(272,7455922,7455911,'ati',11.111,2),(272,7455923,7455911,'tio',11.111,2),(272,7455924,7455911,'ion',11.111,2),(272,7455925,7455911,'ona',11.111,2),(272,7455926,7455911,'nal',11.111,2),(272,7455927,7455918,'nor',25,1),(272,7455928,7455918,'orm',25,1),(272,7455929,7455918,'rma',25,1),(272,7455930,7455918,'mal',25,1),(272,7455931,7455927,'mes',20,1),(272,7455932,7455927,'ess',20,1),(272,7455933,7455927,'ssa',20,1),(272,7455934,7455927,'sag',20,1),(272,7455935,7455927,'age',20,1),(272,7455936,7455931,'per',11.111,1),(272,7455937,7455931,'erf',11.111,1),(272,7455938,7455931,'rfo',11.111,1),(272,7455939,7455931,'for',11.111,1),(272,7455940,7455931,'orm',11.111,1),(272,7455941,7455931,'rma',11.111,1),(272,7455942,7455931,'man',11.111,1),(272,7455943,7455931,'anc',11.111,1),(272,7455944,7455931,'nce',11.111,1),(272,7455945,7455936,'ide',12.5,1),(272,7455946,7455936,'den',12.5,1),(272,7455947,7455936,'ent',12.5,1),(272,7455948,7455936,'nti',12.5,1),(272,7455949,7455936,'tif',12.5,1),(272,7455950,7455936,'ifi',12.5,1),(272,7455951,7455936,'fie',12.5,1),(272,7455952,7455936,'ier',12.5,1),(272,7455953,7455945,'vdi',33.333,3),(272,7455954,7455945,'dis',33.333,3),(272,7455955,7455945,'isk',33.333,3),(272,7455956,7455953,'nam',50,1),(272,7455957,7455953,'ame',50,1),(272,7455958,7455956,'typ',50,1),(272,7455959,7455956,'ype',50,1),(272,7455960,7455958,'dir',25,1),(272,7455961,7455958,'ire',25,1),(272,7455962,7455958,'rec',25,1),(272,7455963,7455958,'ect',25,1),(273,7455965,7455964,'naa',100,2),(273,7455966,7455965,'600',3.333,3),(273,7455967,7455965,'000',3.333,3),(273,7455968,7455965,'00c',3.333,3),(273,7455969,7455965,'0c2',3.333,3),(273,7455970,7455965,'c29',3.333,3),(273,7455971,7455965,'29c',3.333,3),(273,7455972,7455965,'9ca',3.333,3),(273,7455973,7455965,'ca9',3.333,3),(273,7455974,7455965,'a95',3.333,3),(273,7455975,7455965,'954',3.333,3),(273,7455976,7455965,'543',3.333,3),(273,7455977,7455965,'433',3.333,3),(273,7455978,7455965,'33a',3.333,3),(273,7455979,7455965,'3a3',3.333,3),(273,7455980,7455965,'a3c',3.333,3),(273,7455981,7455965,'3c2',3.333,3),(273,7455982,7455965,'c26',3.333,3),(273,7455983,7455965,'26a',3.333,3),(273,7455984,7455965,'6ac',3.333,3),(273,7455985,7455965,'ac5',3.333,3),(273,7455986,7455965,'c50',3.333,3),(273,7455987,7455965,'500',3.333,3),(273,7455988,7455965,'006',3.333,3),(273,7455989,7455965,'06f',3.333,3),(273,7455990,7455965,'6f2',3.333,3),(273,7455991,7455965,'f2c',3.333,3),(273,7455992,7455965,'2c6',3.333,3),(273,7455993,7455965,'c6b',3.333,3),(273,7455994,7455965,'6bb',3.333,3),(273,7455995,7455965,'bbf',3.333,3),(273,7455996,7455966,'mon',100,1),(273,7455997,7455996,'201',50,1),(273,7455998,7455996,'013',50,1),(273,7455999,7455997,'adm',33.333,3),(273,7456000,7455997,'dmi',33.333,3),(273,7456001,7455997,'min',33.333,3),(273,7456002,7455999,'cap',16.667,1),(273,7456003,7455999,'apa',16.667,1),(273,7456004,7455999,'pac',16.667,1),(273,7456005,7455999,'aci',16.667,1),(273,7456006,7455999,'cit',16.667,1),(273,7456007,7455999,'ity',16.667,1),(273,7456008,7456002,'pat',50,1),(273,7456009,7456002,'ath',50,1),(273,7456010,7456008,'fre',14.286,1),(273,7456011,7456008,'ree',14.286,1),(273,7456012,7456008,'ees',14.286,1),(273,7456013,7456008,'esp',14.286,1),(273,7456014,7456008,'spa',14.286,1),(273,7456015,7456008,'pac',14.286,1),(273,7456016,7456008,'ace',14.286,1),(273,7456017,7456010,'dis',50,1),(273,7456018,7456010,'isk',50,1),(273,7456019,7456017,'ind',33.333,1),(273,7456020,7456017,'nde',33.333,1),(273,7456021,7456017,'dex',33.333,1),(273,7456022,7456019,'adm',8.333,1),(273,7456023,7456019,'dmi',8.333,1),(273,7456024,7456019,'min',8.333,1),(273,7456025,7456019,'ini',8.333,1),(273,7456026,7456019,'nis',8.333,1),(273,7456027,7456019,'ist',8.333,1),(273,7456028,7456019,'str',8.333,1),(273,7456029,7456019,'tra',8.333,1),(273,7456030,7456019,'rat',8.333,1),(273,7456031,7456019,'ati',8.333,1),(273,7456032,7456019,'tio',8.333,1),(273,7456033,7456019,'ion',8.333,1),(273,7456034,7456022,'sta',33.333,3),(273,7456035,7456022,'tat',33.333,3),(273,7456036,7456022,'ate',33.333,3),(273,7456037,7456034,'ena',20,2),(273,7456038,7456034,'nab',20,2),(273,7456039,7456034,'abl',20,2),(273,7456040,7456034,'ble',20,2),(273,7456041,7456034,'led',20,2),(273,7456042,7456037,'cac',33.333,1),(273,7456043,7456037,'ach',33.333,1),(273,7456044,7456037,'che',33.333,1),(273,7456045,7456042,'mod',50,2),(273,7456046,7456042,'ode',50,2),(273,7456047,7456045,'wri',14.286,2),(273,7456048,7456045,'rit',14.286,2),(273,7456049,7456045,'ite',14.286,2),(273,7456050,7456045,'tet',14.286,2),(273,7456051,7456045,'eth',14.286,2),(273,7456052,7456045,'thr',14.286,2),(273,7456053,7456045,'hru',14.286,2),(273,7456054,7456047,'ope',11.111,2),(273,7456055,7456047,'per',11.111,2),(273,7456056,7456047,'era',11.111,2),(273,7456057,7456047,'rat',11.111,2),(273,7456058,7456047,'ati',11.111,2),(273,7456059,7456047,'tio',11.111,2),(273,7456060,7456047,'ion',11.111,2),(273,7456061,7456047,'ona',11.111,2),(273,7456062,7456047,'nal',11.111,2),(273,7456063,7456054,'nor',25,1),(273,7456064,7456054,'orm',25,1),(273,7456065,7456054,'rma',25,1),(273,7456066,7456054,'mal',25,1),(273,7456067,7456063,'mes',20,1),(273,7456068,7456063,'ess',20,1),(273,7456069,7456063,'ssa',20,1),(273,7456070,7456063,'sag',20,1),(273,7456071,7456063,'age',20,1),(273,7456072,7456067,'per',11.111,1),(273,7456073,7456067,'erf',11.111,1),(273,7456074,7456067,'rfo',11.111,1),(273,7456075,7456067,'for',11.111,1),(273,7456076,7456067,'orm',11.111,1),(273,7456077,7456067,'rma',11.111,1),(273,7456078,7456067,'man',11.111,1),(273,7456079,7456067,'anc',11.111,1),(273,7456080,7456067,'nce',11.111,1),(273,7456081,7456072,'ide',12.5,1),(273,7456082,7456072,'den',12.5,1),(273,7456083,7456072,'ent',12.5,1),(273,7456084,7456072,'nti',12.5,1),(273,7456085,7456072,'tif',12.5,1),(273,7456086,7456072,'ifi',12.5,1),(273,7456087,7456072,'fie',12.5,1),(273,7456088,7456072,'ier',12.5,1),(273,7456089,7456081,'vdi',33.333,3),(273,7456090,7456081,'dis',33.333,3),(273,7456091,7456081,'isk',33.333,3),(273,7456092,7456089,'nam',50,1),(273,7456093,7456089,'ame',50,1),(273,7456094,7456092,'typ',50,1),(273,7456095,7456092,'ype',50,1),(273,7456096,7456094,'dir',25,1),(273,7456097,7456094,'ire',25,1),(273,7456098,7456094,'rec',25,1),(273,7456099,7456094,'ect',25,1),(274,7456101,7456100,'naa',100,2),(274,7456102,7456101,'600',3.333,3),(274,7456103,7456101,'000',3.333,3),(274,7456104,7456101,'00c',3.333,3),(274,7456105,7456101,'0c2',3.333,3),(274,7456106,7456101,'c29',3.333,3),(274,7456107,7456101,'298',3.333,3),(274,7456108,7456101,'985',3.333,3),(274,7456109,7456101,'859',3.333,3),(274,7456110,7456101,'59f',3.333,3),(274,7456111,7456101,'9fd',3.333,3),(274,7456112,7456101,'fd5',3.333,3),(274,7456113,7456101,'d51',3.333,3),(274,7456114,7456101,'519',3.333,3),(274,7456115,7456101,'19d',3.333,3),(274,7456116,7456101,'9d8',3.333,3),(274,7456117,7456101,'d86',3.333,3),(274,7456118,7456101,'867',3.333,3),(274,7456119,7456101,'672',3.333,3),(274,7456120,7456101,'729',3.333,3),(274,7456121,7456101,'292',3.333,3),(274,7456122,7456101,'92b',3.333,3),(274,7456123,7456101,'2b2',3.333,3),(274,7456124,7456101,'b2a',3.333,3),(274,7456125,7456101,'2a2',3.333,3),(274,7456126,7456101,'a20',3.333,3),(274,7456127,7456101,'206',3.333,3),(274,7456128,7456101,'06e',3.333,3),(274,7456129,7456101,'6e3',3.333,3),(274,7456130,7456101,'e33',3.333,3),(274,7456131,7456101,'338',3.333,3),(274,7456132,7456102,'mon',100,1),(274,7456133,7456132,'201',50,1),(274,7456134,7456132,'013',50,1),(274,7456135,7456133,'adm',33.333,3),(274,7456136,7456133,'dmi',33.333,3),(274,7456137,7456133,'min',33.333,3),(274,7456138,7456135,'cap',16.667,1),(274,7456139,7456135,'apa',16.667,1),(274,7456140,7456135,'pac',16.667,1),(274,7456141,7456135,'aci',16.667,1),(274,7456142,7456135,'cit',16.667,1),(274,7456143,7456135,'ity',16.667,1),(274,7456144,7456138,'pat',50,1),(274,7456145,7456138,'ath',50,1),(274,7456146,7456144,'fre',14.286,1),(274,7456147,7456144,'ree',14.286,1),(274,7456148,7456144,'ees',14.286,1),(274,7456149,7456144,'esp',14.286,1),(274,7456150,7456144,'spa',14.286,1),(274,7456151,7456144,'pac',14.286,1),(274,7456152,7456144,'ace',14.286,1),(274,7456153,7456146,'dis',50,1),(274,7456154,7456146,'isk',50,1),(274,7456155,7456153,'ind',33.333,1),(274,7456156,7456153,'nde',33.333,1),(274,7456157,7456153,'dex',33.333,1),(274,7456158,7456155,'adm',8.333,1),(274,7456159,7456155,'dmi',8.333,1),(274,7456160,7456155,'min',8.333,1),(274,7456161,7456155,'ini',8.333,1),(274,7456162,7456155,'nis',8.333,1),(274,7456163,7456155,'ist',8.333,1),(274,7456164,7456155,'str',8.333,1),(274,7456165,7456155,'tra',8.333,1),(274,7456166,7456155,'rat',8.333,1),(274,7456167,7456155,'ati',8.333,1),(274,7456168,7456155,'tio',8.333,1),(274,7456169,7456155,'ion',8.333,1),(274,7456170,7456158,'sta',33.333,3),(274,7456171,7456158,'tat',33.333,3),(274,7456172,7456158,'ate',33.333,3),(274,7456173,7456170,'ena',20,2),(274,7456174,7456170,'nab',20,2),(274,7456175,7456170,'abl',20,2),(274,7456176,7456170,'ble',20,2),(274,7456177,7456170,'led',20,2),(274,7456178,7456173,'cac',33.333,1),(274,7456179,7456173,'ach',33.333,1),(274,7456180,7456173,'che',33.333,1),(274,7456181,7456178,'mod',50,2),(274,7456182,7456178,'ode',50,2),(274,7456183,7456181,'wri',14.286,2),(274,7456184,7456181,'rit',14.286,2),(274,7456185,7456181,'ite',14.286,2),(274,7456186,7456181,'tet',14.286,2),(274,7456187,7456181,'eth',14.286,2),(274,7456188,7456181,'thr',14.286,2),(274,7456189,7456181,'hru',14.286,2),(274,7456190,7456183,'ope',11.111,2),(274,7456191,7456183,'per',11.111,2),(274,7456192,7456183,'era',11.111,2),(274,7456193,7456183,'rat',11.111,2),(274,7456194,7456183,'ati',11.111,2),(274,7456195,7456183,'tio',11.111,2),(274,7456196,7456183,'ion',11.111,2),(274,7456197,7456183,'ona',11.111,2),(274,7456198,7456183,'nal',11.111,2),(274,7456199,7456190,'nor',25,1),(274,7456200,7456190,'orm',25,1),(274,7456201,7456190,'rma',25,1),(274,7456202,7456190,'mal',25,1),(274,7456203,7456199,'mes',20,1),(274,7456204,7456199,'ess',20,1),(274,7456205,7456199,'ssa',20,1),(274,7456206,7456199,'sag',20,1),(274,7456207,7456199,'age',20,1),(274,7456208,7456203,'per',11.111,1),(274,7456209,7456203,'erf',11.111,1),(274,7456210,7456203,'rfo',11.111,1),(274,7456211,7456203,'for',11.111,1),(274,7456212,7456203,'orm',11.111,1),(274,7456213,7456203,'rma',11.111,1),(274,7456214,7456203,'man',11.111,1),(274,7456215,7456203,'anc',11.111,1),(274,7456216,7456203,'nce',11.111,1),(274,7456217,7456208,'ide',12.5,1),(274,7456218,7456208,'den',12.5,1),(274,7456219,7456208,'ent',12.5,1),(274,7456220,7456208,'nti',12.5,1),(274,7456221,7456208,'tif',12.5,1),(274,7456222,7456208,'ifi',12.5,1),(274,7456223,7456208,'fie',12.5,1),(274,7456224,7456208,'ier',12.5,1),(274,7456225,7456217,'vdi',33.333,3),(274,7456226,7456217,'dis',33.333,3),(274,7456227,7456217,'isk',33.333,3),(274,7456228,7456225,'nam',50,1),(274,7456229,7456225,'ame',50,1),(274,7456230,7456228,'typ',50,1),(274,7456231,7456228,'ype',50,1),(274,7456232,7456230,'dir',25,1),(274,7456233,7456230,'ire',25,1),(274,7456234,7456230,'rec',25,1),(274,7456235,7456230,'ect',25,1),(275,7456237,7456236,'naa',100,2),(275,7456238,7456237,'600',3.333,3),(275,7456239,7456237,'000',3.333,3),(275,7456240,7456237,'00c',3.333,3),(275,7456241,7456237,'0c2',3.333,3),(275,7456242,7456237,'c29',3.333,3),(275,7456243,7456237,'294',3.333,3),(275,7456244,7456237,'94b',3.333,3),(275,7456245,7456237,'4b2',3.333,3),(275,7456246,7456237,'b2c',3.333,3),(275,7456247,7456237,'2c5',3.333,3),(275,7456248,7456237,'c52',3.333,3),(275,7456249,7456237,'528',3.333,3),(275,7456250,7456237,'28e',3.333,3),(275,7456251,7456237,'8ee',3.333,3),(275,7456252,7456237,'ee4',3.333,3),(275,7456253,7456237,'e47',3.333,3),(275,7456254,7456237,'471',3.333,3),(275,7456255,7456237,'718',3.333,3),(275,7456256,7456237,'189',3.333,3),(275,7456257,7456237,'899',3.333,3),(275,7456258,7456237,'99a',3.333,3),(275,7456259,7456237,'9a0',3.333,3),(275,7456260,7456237,'a0c',3.333,3),(275,7456261,7456237,'0c8',3.333,3),(275,7456262,7456237,'c83',3.333,3),(275,7456263,7456237,'832',3.333,3),(275,7456264,7456237,'328',3.333,3),(275,7456265,7456237,'28b',3.333,3),(275,7456266,7456237,'8b4',3.333,3),(275,7456267,7456237,'b4b',3.333,3),(275,7456268,7456238,'mon',100,1),(275,7456269,7456268,'201',50,1),(275,7456270,7456268,'013',50,1),(275,7456271,7456269,'adm',33.333,3),(275,7456272,7456269,'dmi',33.333,3),(275,7456273,7456269,'min',33.333,3),(275,7456274,7456271,'cap',16.667,1),(275,7456275,7456271,'apa',16.667,1),(275,7456276,7456271,'pac',16.667,1),(275,7456277,7456271,'aci',16.667,1),(275,7456278,7456271,'cit',16.667,1),(275,7456279,7456271,'ity',16.667,1),(275,7456280,7456274,'pat',50,1),(275,7456281,7456274,'ath',50,1),(275,7456282,7456280,'fre',14.286,1),(275,7456283,7456280,'ree',14.286,1),(275,7456284,7456280,'ees',14.286,1),(275,7456285,7456280,'esp',14.286,1),(275,7456286,7456280,'spa',14.286,1),(275,7456287,7456280,'pac',14.286,1),(275,7456288,7456280,'ace',14.286,1),(275,7456289,7456282,'dis',50,1),(275,7456290,7456282,'isk',50,1),(275,7456291,7456289,'ind',33.333,1),(275,7456292,7456289,'nde',33.333,1),(275,7456293,7456289,'dex',33.333,1),(275,7456294,7456291,'adm',8.333,1),(275,7456295,7456291,'dmi',8.333,1),(275,7456296,7456291,'min',8.333,1),(275,7456297,7456291,'ini',8.333,1),(275,7456298,7456291,'nis',8.333,1),(275,7456299,7456291,'ist',8.333,1),(275,7456300,7456291,'str',8.333,1),(275,7456301,7456291,'tra',8.333,1),(275,7456302,7456291,'rat',8.333,1),(275,7456303,7456291,'ati',8.333,1),(275,7456304,7456291,'tio',8.333,1),(275,7456305,7456291,'ion',8.333,1),(275,7456306,7456294,'sta',33.333,3),(275,7456307,7456294,'tat',33.333,3),(275,7456308,7456294,'ate',33.333,3),(275,7456309,7456306,'ena',20,2),(275,7456310,7456306,'nab',20,2),(275,7456311,7456306,'abl',20,2),(275,7456312,7456306,'ble',20,2),(275,7456313,7456306,'led',20,2),(275,7456314,7456309,'cac',33.333,1),(275,7456315,7456309,'ach',33.333,1),(275,7456316,7456309,'che',33.333,1),(275,7456317,7456314,'mod',50,2),(275,7456318,7456314,'ode',50,2),(275,7456319,7456317,'wri',14.286,2),(275,7456320,7456317,'rit',14.286,2),(275,7456321,7456317,'ite',14.286,2),(275,7456322,7456317,'tet',14.286,2),(275,7456323,7456317,'eth',14.286,2),(275,7456324,7456317,'thr',14.286,2),(275,7456325,7456317,'hru',14.286,2),(275,7456326,7456319,'ope',11.111,2),(275,7456327,7456319,'per',11.111,2),(275,7456328,7456319,'era',11.111,2),(275,7456329,7456319,'rat',11.111,2),(275,7456330,7456319,'ati',11.111,2),(275,7456331,7456319,'tio',11.111,2),(275,7456332,7456319,'ion',11.111,2),(275,7456333,7456319,'ona',11.111,2),(275,7456334,7456319,'nal',11.111,2),(275,7456335,7456326,'nor',25,1),(275,7456336,7456326,'orm',25,1),(275,7456337,7456326,'rma',25,1),(275,7456338,7456326,'mal',25,1),(275,7456339,7456335,'mes',20,1),(275,7456340,7456335,'ess',20,1),(275,7456341,7456335,'ssa',20,1),(275,7456342,7456335,'sag',20,1),(275,7456343,7456335,'age',20,1),(275,7456344,7456339,'per',11.111,1),(275,7456345,7456339,'erf',11.111,1),(275,7456346,7456339,'rfo',11.111,1),(275,7456347,7456339,'for',11.111,1),(275,7456348,7456339,'orm',11.111,1),(275,7456349,7456339,'rma',11.111,1),(275,7456350,7456339,'man',11.111,1),(275,7456351,7456339,'anc',11.111,1),(275,7456352,7456339,'nce',11.111,1),(275,7456353,7456344,'ide',12.5,1),(275,7456354,7456344,'den',12.5,1),(275,7456355,7456344,'ent',12.5,1),(275,7456356,7456344,'nti',12.5,1),(275,7456357,7456344,'tif',12.5,1),(275,7456358,7456344,'ifi',12.5,1),(275,7456359,7456344,'fie',12.5,1),(275,7456360,7456344,'ier',12.5,1),(275,7456361,7456353,'vdi',33.333,3),(275,7456362,7456353,'dis',33.333,3),(275,7456363,7456353,'isk',33.333,3),(275,7456364,7456361,'nam',50,1),(275,7456365,7456361,'ame',50,1),(275,7456366,7456364,'typ',50,1),(275,7456367,7456364,'ype',50,1),(275,7456368,7456366,'dir',25,1),(275,7456369,7456366,'ire',25,1),(275,7456370,7456366,'rec',25,1),(275,7456371,7456366,'ect',25,1),(276,7456373,7456372,'naa',100,2),(276,7456374,7456373,'600',3.333,3),(276,7456375,7456373,'000',3.333,3),(276,7456376,7456373,'00c',3.333,3),(276,7456377,7456373,'0c2',3.333,3),(276,7456378,7456373,'c29',3.333,3),(276,7456379,7456373,'29b',3.333,3),(276,7456380,7456373,'9be',3.333,3),(276,7456381,7456373,'be9',3.333,3),(276,7456382,7456373,'e9c',3.333,3),(276,7456383,7456373,'9c8',3.333,3),(276,7456384,7456373,'c8a',3.333,3),(276,7456385,7456373,'8af',3.333,3),(276,7456386,7456373,'af4',3.333,3),(276,7456387,7456373,'f40',3.333,3),(276,7456388,7456373,'40d',3.333,3),(276,7456389,7456373,'0d3',3.333,3),(276,7456390,7456373,'d3e',3.333,3),(276,7456391,7456373,'3e0',3.333,3),(276,7456392,7456373,'e0d',3.333,3),(276,7456393,7456373,'0d5',3.333,3),(276,7456394,7456373,'d59',3.333,3),(276,7456395,7456373,'593',3.333,3),(276,7456396,7456373,'938',3.333,3),(276,7456397,7456373,'38c',3.333,3),(276,7456398,7456373,'8c1',3.333,3),(276,7456399,7456373,'c1f',3.333,3),(276,7456400,7456373,'1f9',3.333,3),(276,7456401,7456373,'f98',3.333,3),(276,7456402,7456373,'980',3.333,3),(276,7456403,7456373,'80e',3.333,3),(276,7456404,7456374,'mon',100,1),(276,7456405,7456404,'201',50,1),(276,7456406,7456404,'013',50,1),(276,7456407,7456405,'adm',33.333,3),(276,7456408,7456405,'dmi',33.333,3),(276,7456409,7456405,'min',33.333,3),(276,7456410,7456407,'cap',16.667,1),(276,7456411,7456407,'apa',16.667,1),(276,7456412,7456407,'pac',16.667,1),(276,7456413,7456407,'aci',16.667,1),(276,7456414,7456407,'cit',16.667,1),(276,7456415,7456407,'ity',16.667,1),(276,7456416,7456410,'pat',50,1),(276,7456417,7456410,'ath',50,1),(276,7456418,7456416,'fre',14.286,1),(276,7456419,7456416,'ree',14.286,1),(276,7456420,7456416,'ees',14.286,1),(276,7456421,7456416,'esp',14.286,1),(276,7456422,7456416,'spa',14.286,1),(276,7456423,7456416,'pac',14.286,1),(276,7456424,7456416,'ace',14.286,1),(276,7456425,7456418,'dis',50,1),(276,7456426,7456418,'isk',50,1),(276,7456427,7456425,'ind',33.333,1),(276,7456428,7456425,'nde',33.333,1),(276,7456429,7456425,'dex',33.333,1),(276,7456430,7456427,'adm',8.333,1),(276,7456431,7456427,'dmi',8.333,1),(276,7456432,7456427,'min',8.333,1),(276,7456433,7456427,'ini',8.333,1),(276,7456434,7456427,'nis',8.333,1),(276,7456435,7456427,'ist',8.333,1),(276,7456436,7456427,'str',8.333,1),(276,7456437,7456427,'tra',8.333,1),(276,7456438,7456427,'rat',8.333,1),(276,7456439,7456427,'ati',8.333,1),(276,7456440,7456427,'tio',8.333,1),(276,7456441,7456427,'ion',8.333,1),(276,7456442,7456430,'sta',33.333,3),(276,7456443,7456430,'tat',33.333,3),(276,7456444,7456430,'ate',33.333,3),(276,7456445,7456442,'ena',20,2),(276,7456446,7456442,'nab',20,2),(276,7456447,7456442,'abl',20,2),(276,7456448,7456442,'ble',20,2),(276,7456449,7456442,'led',20,2),(276,7456450,7456445,'cac',33.333,1),(276,7456451,7456445,'ach',33.333,1),(276,7456452,7456445,'che',33.333,1),(276,7456453,7456450,'mod',50,2),(276,7456454,7456450,'ode',50,2),(276,7456455,7456453,'wri',14.286,2),(276,7456456,7456453,'rit',14.286,2),(276,7456457,7456453,'ite',14.286,2),(276,7456458,7456453,'tet',14.286,2),(276,7456459,7456453,'eth',14.286,2),(276,7456460,7456453,'thr',14.286,2),(276,7456461,7456453,'hru',14.286,2),(276,7456462,7456455,'ope',11.111,2),(276,7456463,7456455,'per',11.111,2),(276,7456464,7456455,'era',11.111,2),(276,7456465,7456455,'rat',11.111,2),(276,7456466,7456455,'ati',11.111,2),(276,7456467,7456455,'tio',11.111,2),(276,7456468,7456455,'ion',11.111,2),(276,7456469,7456455,'ona',11.111,2),(276,7456470,7456455,'nal',11.111,2),(276,7456471,7456462,'nor',25,1),(276,7456472,7456462,'orm',25,1),(276,7456473,7456462,'rma',25,1),(276,7456474,7456462,'mal',25,1),(276,7456475,7456471,'mes',20,1),(276,7456476,7456471,'ess',20,1),(276,7456477,7456471,'ssa',20,1),(276,7456478,7456471,'sag',20,1),(276,7456479,7456471,'age',20,1),(276,7456480,7456475,'per',11.111,1),(276,7456481,7456475,'erf',11.111,1),(276,7456482,7456475,'rfo',11.111,1),(276,7456483,7456475,'for',11.111,1),(276,7456484,7456475,'orm',11.111,1),(276,7456485,7456475,'rma',11.111,1),(276,7456486,7456475,'man',11.111,1),(276,7456487,7456475,'anc',11.111,1),(276,7456488,7456475,'nce',11.111,1),(276,7456489,7456480,'ide',12.5,1),(276,7456490,7456480,'den',12.5,1),(276,7456491,7456480,'ent',12.5,1),(276,7456492,7456480,'nti',12.5,1),(276,7456493,7456480,'tif',12.5,1),(276,7456494,7456480,'ifi',12.5,1),(276,7456495,7456480,'fie',12.5,1),(276,7456496,7456480,'ier',12.5,1),(276,7456497,7456489,'vdi',33.333,3),(276,7456498,7456489,'dis',33.333,3),(276,7456499,7456489,'isk',33.333,3),(276,7456500,7456497,'nam',50,1),(276,7456501,7456497,'ame',50,1),(276,7456502,7456500,'typ',50,1),(276,7456503,7456500,'ype',50,1),(276,7456504,7456502,'dir',25,1),(276,7456505,7456502,'ire',25,1),(276,7456506,7456502,'rec',25,1),(276,7456507,7456502,'ect',25,1),(277,7456509,7456508,'naa',100,2),(277,7456510,7456509,'600',3.333,3),(277,7456511,7456509,'000',3.333,3),(277,7456512,7456509,'00c',3.333,3),(277,7456513,7456509,'0c2',3.333,3),(277,7456514,7456509,'c29',3.333,3),(277,7456515,7456509,'29e',3.333,3),(277,7456516,7456509,'9ef',3.333,3),(277,7456517,7456509,'efd',3.333,3),(277,7456518,7456509,'fde',3.333,3),(277,7456519,7456509,'dea',3.333,3),(277,7456520,7456509,'ea6',3.333,3),(277,7456521,7456509,'a63',3.333,3),(277,7456522,7456509,'638',3.333,3),(277,7456523,7456509,'383',3.333,3),(277,7456524,7456509,'83c',3.333,3),(277,7456525,7456509,'3c6',3.333,3),(277,7456526,7456509,'c63',3.333,3),(277,7456527,7456509,'636',3.333,3),(277,7456528,7456509,'36e',3.333,3),(277,7456529,7456509,'6eb',3.333,3),(277,7456530,7456509,'eb6',3.333,3),(277,7456531,7456509,'b6f',3.333,3),(277,7456532,7456509,'6f5',3.333,3),(277,7456533,7456509,'f52',3.333,3),(277,7456534,7456509,'529',3.333,3),(277,7456535,7456509,'293',3.333,3),(277,7456536,7456509,'93b',3.333,3),(277,7456537,7456509,'3bb',3.333,3),(277,7456538,7456509,'bb1',3.333,3),(277,7456539,7456509,'b18',3.333,3),(277,7456540,7456510,'mon',100,1),(277,7456541,7456540,'201',50,1),(277,7456542,7456540,'013',50,1),(277,7456543,7456541,'adm',33.333,3),(277,7456544,7456541,'dmi',33.333,3),(277,7456545,7456541,'min',33.333,3),(277,7456546,7456543,'cap',16.667,1),(277,7456547,7456543,'apa',16.667,1),(277,7456548,7456543,'pac',16.667,1),(277,7456549,7456543,'aci',16.667,1),(277,7456550,7456543,'cit',16.667,1),(277,7456551,7456543,'ity',16.667,1),(277,7456552,7456546,'pat',50,1),(277,7456553,7456546,'ath',50,1),(277,7456554,7456552,'fre',14.286,1),(277,7456555,7456552,'ree',14.286,1),(277,7456556,7456552,'ees',14.286,1),(277,7456557,7456552,'esp',14.286,1),(277,7456558,7456552,'spa',14.286,1),(277,7456559,7456552,'pac',14.286,1),(277,7456560,7456552,'ace',14.286,1),(277,7456561,7456554,'dis',50,1),(277,7456562,7456554,'isk',50,1),(277,7456563,7456561,'ind',33.333,1),(277,7456564,7456561,'nde',33.333,1),(277,7456565,7456561,'dex',33.333,1),(277,7456566,7456563,'adm',8.333,1),(277,7456567,7456563,'dmi',8.333,1),(277,7456568,7456563,'min',8.333,1),(277,7456569,7456563,'ini',8.333,1),(277,7456570,7456563,'nis',8.333,1),(277,7456571,7456563,'ist',8.333,1),(277,7456572,7456563,'str',8.333,1),(277,7456573,7456563,'tra',8.333,1),(277,7456574,7456563,'rat',8.333,1),(277,7456575,7456563,'ati',8.333,1),(277,7456576,7456563,'tio',8.333,1),(277,7456577,7456563,'ion',8.333,1),(277,7456578,7456566,'sta',33.333,3),(277,7456579,7456566,'tat',33.333,3),(277,7456580,7456566,'ate',33.333,3),(277,7456581,7456578,'ena',20,2),(277,7456582,7456578,'nab',20,2),(277,7456583,7456578,'abl',20,2),(277,7456584,7456578,'ble',20,2),(277,7456585,7456578,'led',20,2),(277,7456586,7456581,'cac',33.333,1),(277,7456587,7456581,'ach',33.333,1),(277,7456588,7456581,'che',33.333,1),(277,7456589,7456586,'mod',50,2),(277,7456590,7456586,'ode',50,2),(277,7456591,7456589,'wri',14.286,2),(277,7456592,7456589,'rit',14.286,2),(277,7456593,7456589,'ite',14.286,2),(277,7456594,7456589,'tet',14.286,2),(277,7456595,7456589,'eth',14.286,2),(277,7456596,7456589,'thr',14.286,2),(277,7456597,7456589,'hru',14.286,2),(277,7456598,7456591,'ope',11.111,2),(277,7456599,7456591,'per',11.111,2),(277,7456600,7456591,'era',11.111,2),(277,7456601,7456591,'rat',11.111,2),(277,7456602,7456591,'ati',11.111,2),(277,7456603,7456591,'tio',11.111,2),(277,7456604,7456591,'ion',11.111,2),(277,7456605,7456591,'ona',11.111,2),(277,7456606,7456591,'nal',11.111,2),(277,7456607,7456598,'nor',25,1),(277,7456608,7456598,'orm',25,1),(277,7456609,7456598,'rma',25,1),(277,7456610,7456598,'mal',25,1),(277,7456611,7456607,'mes',20,1),(277,7456612,7456607,'ess',20,1),(277,7456613,7456607,'ssa',20,1),(277,7456614,7456607,'sag',20,1),(277,7456615,7456607,'age',20,1),(277,7456616,7456611,'per',11.111,1),(277,7456617,7456611,'erf',11.111,1),(277,7456618,7456611,'rfo',11.111,1),(277,7456619,7456611,'for',11.111,1),(277,7456620,7456611,'orm',11.111,1),(277,7456621,7456611,'rma',11.111,1),(277,7456622,7456611,'man',11.111,1),(277,7456623,7456611,'anc',11.111,1),(277,7456624,7456611,'nce',11.111,1),(277,7456625,7456616,'ide',12.5,1),(277,7456626,7456616,'den',12.5,1),(277,7456627,7456616,'ent',12.5,1),(277,7456628,7456616,'nti',12.5,1),(277,7456629,7456616,'tif',12.5,1),(277,7456630,7456616,'ifi',12.5,1),(277,7456631,7456616,'fie',12.5,1),(277,7456632,7456616,'ier',12.5,1),(277,7456633,7456625,'vdi',33.333,3),(277,7456634,7456625,'dis',33.333,3),(277,7456635,7456625,'isk',33.333,3),(277,7456636,7456633,'nam',50,1),(277,7456637,7456633,'ame',50,1),(277,7456638,7456636,'typ',50,1),(277,7456639,7456636,'ype',50,1),(277,7456640,7456638,'dir',25,1),(277,7456641,7456638,'ire',25,1),(277,7456642,7456638,'rec',25,1),(277,7456643,7456638,'ect',25,1),(278,7456645,7456644,'naa',100,2),(278,7456646,7456645,'600',3.333,3),(278,7456647,7456645,'000',3.333,3),(278,7456648,7456645,'00c',3.333,3),(278,7456649,7456645,'0c2',3.333,3),(278,7456650,7456645,'c29',3.333,3),(278,7456651,7456645,'299',3.333,3),(278,7456652,7456645,'99f',3.333,3),(278,7456653,7456645,'9fb',3.333,3),(278,7456654,7456645,'fb2',3.333,3),(278,7456655,7456645,'b24',3.333,3),(278,7456656,7456645,'242',3.333,3),(278,7456657,7456645,'42f',3.333,3),(278,7456658,7456645,'2f2',3.333,3),(278,7456659,7456645,'f20',3.333,3),(278,7456660,7456645,'20b',3.333,3),(278,7456661,7456645,'0bd',3.333,3),(278,7456662,7456645,'bd0',3.333,3),(278,7456663,7456645,'d0d',3.333,3),(278,7456664,7456645,'0dc',3.333,3),(278,7456665,7456645,'dcb',3.333,3),(278,7456666,7456645,'cbf',3.333,3),(278,7456667,7456645,'bf8',3.333,3),(278,7456668,7456645,'f87',3.333,3),(278,7456669,7456645,'875',3.333,3),(278,7456670,7456645,'751',3.333,3),(278,7456671,7456645,'512',3.333,3),(278,7456672,7456645,'123',3.333,3),(278,7456673,7456645,'233',3.333,3),(278,7456674,7456645,'336',3.333,3),(278,7456675,7456645,'360',3.333,3),(278,7456676,7456646,'mon',100,1),(278,7456677,7456676,'201',50,1),(278,7456678,7456676,'013',50,1),(278,7456679,7456677,'adm',33.333,3),(278,7456680,7456677,'dmi',33.333,3),(278,7456681,7456677,'min',33.333,3),(278,7456682,7456679,'cap',16.667,1),(278,7456683,7456679,'apa',16.667,1),(278,7456684,7456679,'pac',16.667,1),(278,7456685,7456679,'aci',16.667,1),(278,7456686,7456679,'cit',16.667,1),(278,7456687,7456679,'ity',16.667,1),(278,7456688,7456682,'pat',50,1),(278,7456689,7456682,'ath',50,1),(278,7456690,7456688,'fre',14.286,1),(278,7456691,7456688,'ree',14.286,1),(278,7456692,7456688,'ees',14.286,1),(278,7456693,7456688,'esp',14.286,1),(278,7456694,7456688,'spa',14.286,1),(278,7456695,7456688,'pac',14.286,1),(278,7456696,7456688,'ace',14.286,1),(278,7456697,7456690,'dis',50,1),(278,7456698,7456690,'isk',50,1),(278,7456699,7456697,'ind',33.333,1),(278,7456700,7456697,'nde',33.333,1),(278,7456701,7456697,'dex',33.333,1),(278,7456702,7456699,'adm',8.333,1),(278,7456703,7456699,'dmi',8.333,1),(278,7456704,7456699,'min',8.333,1),(278,7456705,7456699,'ini',8.333,1),(278,7456706,7456699,'nis',8.333,1),(278,7456707,7456699,'ist',8.333,1),(278,7456708,7456699,'str',8.333,1),(278,7456709,7456699,'tra',8.333,1),(278,7456710,7456699,'rat',8.333,1),(278,7456711,7456699,'ati',8.333,1),(278,7456712,7456699,'tio',8.333,1),(278,7456713,7456699,'ion',8.333,1),(278,7456714,7456702,'sta',33.333,3),(278,7456715,7456702,'tat',33.333,3),(278,7456716,7456702,'ate',33.333,3),(278,7456717,7456714,'ena',20,2),(278,7456718,7456714,'nab',20,2),(278,7456719,7456714,'abl',20,2),(278,7456720,7456714,'ble',20,2),(278,7456721,7456714,'led',20,2),(278,7456722,7456717,'cac',33.333,1),(278,7456723,7456717,'ach',33.333,1),(278,7456724,7456717,'che',33.333,1),(278,7456725,7456722,'mod',50,2),(278,7456726,7456722,'ode',50,2),(278,7456727,7456725,'wri',14.286,2),(278,7456728,7456725,'rit',14.286,2),(278,7456729,7456725,'ite',14.286,2),(278,7456730,7456725,'tet',14.286,2),(278,7456731,7456725,'eth',14.286,2),(278,7456732,7456725,'thr',14.286,2),(278,7456733,7456725,'hru',14.286,2),(278,7456734,7456727,'ope',11.111,2),(278,7456735,7456727,'per',11.111,2),(278,7456736,7456727,'era',11.111,2),(278,7456737,7456727,'rat',11.111,2),(278,7456738,7456727,'ati',11.111,2),(278,7456739,7456727,'tio',11.111,2),(278,7456740,7456727,'ion',11.111,2),(278,7456741,7456727,'ona',11.111,2),(278,7456742,7456727,'nal',11.111,2),(278,7456743,7456734,'nor',25,1),(278,7456744,7456734,'orm',25,1),(278,7456745,7456734,'rma',25,1),(278,7456746,7456734,'mal',25,1),(278,7456747,7456743,'mes',20,1),(278,7456748,7456743,'ess',20,1),(278,7456749,7456743,'ssa',20,1),(278,7456750,7456743,'sag',20,1),(278,7456751,7456743,'age',20,1),(278,7456752,7456747,'per',11.111,1),(278,7456753,7456747,'erf',11.111,1),(278,7456754,7456747,'rfo',11.111,1),(278,7456755,7456747,'for',11.111,1),(278,7456756,7456747,'orm',11.111,1),(278,7456757,7456747,'rma',11.111,1),(278,7456758,7456747,'man',11.111,1),(278,7456759,7456747,'anc',11.111,1),(278,7456760,7456747,'nce',11.111,1),(278,7456761,7456752,'ide',12.5,1),(278,7456762,7456752,'den',12.5,1),(278,7456763,7456752,'ent',12.5,1),(278,7456764,7456752,'nti',12.5,1),(278,7456765,7456752,'tif',12.5,1),(278,7456766,7456752,'ifi',12.5,1),(278,7456767,7456752,'fie',12.5,1),(278,7456768,7456752,'ier',12.5,1),(278,7456769,7456761,'vdi',33.333,3),(278,7456770,7456761,'dis',33.333,3),(278,7456771,7456761,'isk',33.333,3),(278,7456772,7456769,'nam',50,1),(278,7456773,7456769,'ame',50,1),(278,7456774,7456772,'typ',50,1),(278,7456775,7456772,'ype',50,1),(278,7456776,7456774,'dir',25,1),(278,7456777,7456774,'ire',25,1),(278,7456778,7456774,'rec',25,1),(278,7456779,7456774,'ect',25,1),(279,7456781,7456780,'naa',100,2),(279,7456782,7456781,'600',3.333,3),(279,7456783,7456781,'000',3.333,3),(279,7456784,7456781,'00c',3.333,3),(279,7456785,7456781,'0c2',3.333,3),(279,7456786,7456781,'c29',3.333,3),(279,7456787,7456781,'29c',3.333,3),(279,7456788,7456781,'9c5',3.333,3),(279,7456789,7456781,'c50',3.333,3),(279,7456790,7456781,'50c',3.333,3),(279,7456791,7456781,'0c1',3.333,3),(279,7456792,7456781,'c16',3.333,3),(279,7456793,7456781,'162',3.333,3),(279,7456794,7456781,'627',3.333,3),(279,7456795,7456781,'277',3.333,3),(279,7456796,7456781,'77f',3.333,3),(279,7456797,7456781,'7f5',3.333,3),(279,7456798,7456781,'f5b',3.333,3),(279,7456799,7456781,'5b8',3.333,3),(279,7456800,7456781,'b82',3.333,3),(279,7456801,7456781,'82e',3.333,3),(279,7456802,7456781,'2ee',3.333,3),(279,7456803,7456781,'ee5',3.333,3),(279,7456804,7456781,'e57',3.333,3),(279,7456805,7456781,'573',3.333,3),(279,7456806,7456781,'733',3.333,3),(279,7456807,7456781,'335',3.333,3),(279,7456808,7456781,'35f',3.333,3),(279,7456809,7456781,'5fc',3.333,3),(279,7456810,7456781,'fc8',3.333,3),(279,7456811,7456781,'c8a',3.333,3),(279,7456812,7456782,'mon',100,1),(279,7456813,7456812,'201',50,1),(279,7456814,7456812,'013',50,1),(279,7456815,7456813,'adm',33.333,3),(279,7456816,7456813,'dmi',33.333,3),(279,7456817,7456813,'min',33.333,3),(279,7456818,7456815,'cap',16.667,1),(279,7456819,7456815,'apa',16.667,1),(279,7456820,7456815,'pac',16.667,1),(279,7456821,7456815,'aci',16.667,1),(279,7456822,7456815,'cit',16.667,1),(279,7456823,7456815,'ity',16.667,1),(279,7456824,7456818,'pat',50,1),(279,7456825,7456818,'ath',50,1),(279,7456826,7456824,'fre',14.286,1),(279,7456827,7456824,'ree',14.286,1),(279,7456828,7456824,'ees',14.286,1),(279,7456829,7456824,'esp',14.286,1),(279,7456830,7456824,'spa',14.286,1),(279,7456831,7456824,'pac',14.286,1),(279,7456832,7456824,'ace',14.286,1),(279,7456833,7456826,'dis',50,1),(279,7456834,7456826,'isk',50,1),(279,7456835,7456833,'ind',33.333,1),(279,7456836,7456833,'nde',33.333,1),(279,7456837,7456833,'dex',33.333,1),(279,7456838,7456835,'adm',8.333,1),(279,7456839,7456835,'dmi',8.333,1),(279,7456840,7456835,'min',8.333,1),(279,7456841,7456835,'ini',8.333,1),(279,7456842,7456835,'nis',8.333,1),(279,7456843,7456835,'ist',8.333,1),(279,7456844,7456835,'str',8.333,1),(279,7456845,7456835,'tra',8.333,1),(279,7456846,7456835,'rat',8.333,1),(279,7456847,7456835,'ati',8.333,1),(279,7456848,7456835,'tio',8.333,1),(279,7456849,7456835,'ion',8.333,1),(279,7456850,7456838,'sta',33.333,3),(279,7456851,7456838,'tat',33.333,3),(279,7456852,7456838,'ate',33.333,3),(279,7456853,7456850,'ena',20,2),(279,7456854,7456850,'nab',20,2),(279,7456855,7456850,'abl',20,2),(279,7456856,7456850,'ble',20,2),(279,7456857,7456850,'led',20,2),(279,7456858,7456853,'cac',33.333,1),(279,7456859,7456853,'ach',33.333,1),(279,7456860,7456853,'che',33.333,1),(279,7456861,7456858,'mod',50,2),(279,7456862,7456858,'ode',50,2),(279,7456863,7456861,'wri',14.286,2),(279,7456864,7456861,'rit',14.286,2),(279,7456865,7456861,'ite',14.286,2),(279,7456866,7456861,'tet',14.286,2),(279,7456867,7456861,'eth',14.286,2),(279,7456868,7456861,'thr',14.286,2),(279,7456869,7456861,'hru',14.286,2),(279,7456870,7456863,'ope',11.111,2),(279,7456871,7456863,'per',11.111,2),(279,7456872,7456863,'era',11.111,2),(279,7456873,7456863,'rat',11.111,2),(279,7456874,7456863,'ati',11.111,2),(279,7456875,7456863,'tio',11.111,2),(279,7456876,7456863,'ion',11.111,2),(279,7456877,7456863,'ona',11.111,2),(279,7456878,7456863,'nal',11.111,2),(279,7456879,7456870,'nor',25,1),(279,7456880,7456870,'orm',25,1),(279,7456881,7456870,'rma',25,1),(279,7456882,7456870,'mal',25,1),(279,7456883,7456879,'mes',20,1),(279,7456884,7456879,'ess',20,1),(279,7456885,7456879,'ssa',20,1),(279,7456886,7456879,'sag',20,1),(279,7456887,7456879,'age',20,1),(279,7456888,7456883,'per',11.111,1),(279,7456889,7456883,'erf',11.111,1),(279,7456890,7456883,'rfo',11.111,1),(279,7456891,7456883,'for',11.111,1),(279,7456892,7456883,'orm',11.111,1),(279,7456893,7456883,'rma',11.111,1),(279,7456894,7456883,'man',11.111,1),(279,7456895,7456883,'anc',11.111,1),(279,7456896,7456883,'nce',11.111,1),(279,7456897,7456888,'ide',12.5,1),(279,7456898,7456888,'den',12.5,1),(279,7456899,7456888,'ent',12.5,1),(279,7456900,7456888,'nti',12.5,1),(279,7456901,7456888,'tif',12.5,1),(279,7456902,7456888,'ifi',12.5,1),(279,7456903,7456888,'fie',12.5,1),(279,7456904,7456888,'ier',12.5,1),(279,7456905,7456897,'vdi',33.333,3),(279,7456906,7456897,'dis',33.333,3),(279,7456907,7456897,'isk',33.333,3),(279,7456908,7456905,'nam',50,1),(279,7456909,7456905,'ame',50,1),(279,7456910,7456908,'typ',50,1),(279,7456911,7456908,'ype',50,1),(279,7456912,7456910,'dir',25,1),(279,7456913,7456910,'ire',25,1),(279,7456914,7456910,'rec',25,1),(279,7456915,7456910,'ect',25,1),(280,7456917,7456916,'naa',100,2),(280,7456918,7456917,'600',3.333,3),(280,7456919,7456917,'000',3.333,3),(280,7456920,7456917,'00c',3.333,3),(280,7456921,7456917,'0c2',3.333,3),(280,7456922,7456917,'c29',3.333,3),(280,7456923,7456917,'29d',3.333,3),(280,7456924,7456917,'9d7',3.333,3),(280,7456925,7456917,'d7c',3.333,3),(280,7456926,7456917,'7c3',3.333,3),(280,7456927,7456917,'c36',3.333,3),(280,7456928,7456917,'364',3.333,3),(280,7456929,7456917,'64b',3.333,3),(280,7456930,7456917,'4b0',3.333,3),(280,7456931,7456917,'b06',3.333,3),(280,7456932,7456917,'06d',3.333,3),(280,7456933,7456917,'6de',3.333,3),(280,7456934,7456917,'ded',3.333,3),(280,7456935,7456917,'ed4',3.333,3),(280,7456936,7456917,'d47',3.333,3),(280,7456937,7456917,'47c',3.333,3),(280,7456938,7456917,'7c1',3.333,3),(280,7456939,7456917,'c1f',3.333,3),(280,7456940,7456917,'1f5',3.333,3),(280,7456941,7456917,'f57',3.333,3),(280,7456942,7456917,'570',3.333,3),(280,7456943,7456917,'70b',3.333,3),(280,7456944,7456917,'0bc',3.333,3),(280,7456945,7456917,'bc2',3.333,3),(280,7456946,7456917,'c2e',3.333,3),(280,7456947,7456917,'2e3',3.333,3),(280,7456948,7456918,'mon',100,1),(280,7456949,7456948,'201',50,1),(280,7456950,7456948,'013',50,1),(280,7456951,7456949,'adm',33.333,3),(280,7456952,7456949,'dmi',33.333,3),(280,7456953,7456949,'min',33.333,3),(280,7456954,7456951,'cap',16.667,1),(280,7456955,7456951,'apa',16.667,1),(280,7456956,7456951,'pac',16.667,1),(280,7456957,7456951,'aci',16.667,1),(280,7456958,7456951,'cit',16.667,1),(280,7456959,7456951,'ity',16.667,1),(280,7456960,7456954,'pat',50,1),(280,7456961,7456954,'ath',50,1),(280,7456962,7456960,'fre',14.286,1),(280,7456963,7456960,'ree',14.286,1),(280,7456964,7456960,'ees',14.286,1),(280,7456965,7456960,'esp',14.286,1),(280,7456966,7456960,'spa',14.286,1),(280,7456967,7456960,'pac',14.286,1),(280,7456968,7456960,'ace',14.286,1),(280,7456969,7456962,'dis',50,1),(280,7456970,7456962,'isk',50,1),(280,7456971,7456969,'ind',33.333,1),(280,7456972,7456969,'nde',33.333,1),(280,7456973,7456969,'dex',33.333,1),(280,7456974,7456971,'adm',8.333,1),(280,7456975,7456971,'dmi',8.333,1),(280,7456976,7456971,'min',8.333,1),(280,7456977,7456971,'ini',8.333,1),(280,7456978,7456971,'nis',8.333,1),(280,7456979,7456971,'ist',8.333,1),(280,7456980,7456971,'str',8.333,1),(280,7456981,7456971,'tra',8.333,1),(280,7456982,7456971,'rat',8.333,1),(280,7456983,7456971,'ati',8.333,1),(280,7456984,7456971,'tio',8.333,1),(280,7456985,7456971,'ion',8.333,1),(280,7456986,7456974,'sta',33.333,3),(280,7456987,7456974,'tat',33.333,3),(280,7456988,7456974,'ate',33.333,3),(280,7456989,7456986,'ena',20,2),(280,7456990,7456986,'nab',20,2),(280,7456991,7456986,'abl',20,2),(280,7456992,7456986,'ble',20,2),(280,7456993,7456986,'led',20,2),(280,7456994,7456989,'cac',33.333,1),(280,7456995,7456989,'ach',33.333,1),(280,7456996,7456989,'che',33.333,1),(280,7456997,7456994,'mod',50,2),(280,7456998,7456994,'ode',50,2),(280,7456999,7456997,'wri',14.286,2),(280,7457000,7456997,'rit',14.286,2),(280,7457001,7456997,'ite',14.286,2),(280,7457002,7456997,'tet',14.286,2),(280,7457003,7456997,'eth',14.286,2),(280,7457004,7456997,'thr',14.286,2),(280,7457005,7456997,'hru',14.286,2),(280,7457006,7456999,'ope',11.111,2),(280,7457007,7456999,'per',11.111,2),(280,7457008,7456999,'era',11.111,2),(280,7457009,7456999,'rat',11.111,2),(280,7457010,7456999,'ati',11.111,2),(280,7457011,7456999,'tio',11.111,2),(280,7457012,7456999,'ion',11.111,2),(280,7457013,7456999,'ona',11.111,2),(280,7457014,7456999,'nal',11.111,2),(280,7457015,7457006,'nor',25,1),(280,7457016,7457006,'orm',25,1),(280,7457017,7457006,'rma',25,1),(280,7457018,7457006,'mal',25,1),(280,7457019,7457015,'mes',20,1),(280,7457020,7457015,'ess',20,1),(280,7457021,7457015,'ssa',20,1),(280,7457022,7457015,'sag',20,1),(280,7457023,7457015,'age',20,1),(280,7457024,7457019,'per',11.111,1),(280,7457025,7457019,'erf',11.111,1),(280,7457026,7457019,'rfo',11.111,1),(280,7457027,7457019,'for',11.111,1),(280,7457028,7457019,'orm',11.111,1),(280,7457029,7457019,'rma',11.111,1),(280,7457030,7457019,'man',11.111,1),(280,7457031,7457019,'anc',11.111,1),(280,7457032,7457019,'nce',11.111,1),(280,7457033,7457024,'ide',12.5,1),(280,7457034,7457024,'den',12.5,1),(280,7457035,7457024,'ent',12.5,1),(280,7457036,7457024,'nti',12.5,1),(280,7457037,7457024,'tif',12.5,1),(280,7457038,7457024,'ifi',12.5,1),(280,7457039,7457024,'fie',12.5,1),(280,7457040,7457024,'ier',12.5,1),(280,7457041,7457033,'vdi',33.333,3),(280,7457042,7457033,'dis',33.333,3),(280,7457043,7457033,'isk',33.333,3),(280,7457044,7457041,'nam',50,1),(280,7457045,7457041,'ame',50,1),(280,7457046,7457044,'typ',50,1),(280,7457047,7457044,'ype',50,1),(280,7457048,7457046,'dir',25,1),(280,7457049,7457046,'ire',25,1),(280,7457050,7457046,'rec',25,1),(280,7457051,7457046,'ect',25,1),(281,7457053,7457052,'naa',100,2),(281,7457054,7457053,'600',3.333,3),(281,7457055,7457053,'000',3.333,3),(281,7457056,7457053,'00c',3.333,3),(281,7457057,7457053,'0c2',3.333,3),(281,7457058,7457053,'c29',3.333,3),(281,7457059,7457053,'294',3.333,3),(281,7457060,7457053,'94d',3.333,3),(281,7457061,7457053,'4d1',3.333,3),(281,7457062,7457053,'d1d',3.333,3),(281,7457063,7457053,'1df',3.333,3),(281,7457064,7457053,'df8',3.333,3),(281,7457065,7457053,'f89',3.333,3),(281,7457066,7457053,'893',3.333,3),(281,7457067,7457053,'93c',3.333,3),(281,7457068,7457053,'3cf',3.333,3),(281,7457069,7457053,'cff',3.333,3),(281,7457070,7457053,'ff4',3.333,3),(281,7457071,7457053,'f41',3.333,3),(281,7457072,7457053,'413',3.333,3),(281,7457073,7457053,'138',3.333,3),(281,7457074,7457053,'38d',3.333,3),(281,7457075,7457053,'8d2',3.333,3),(281,7457076,7457053,'d2e',3.333,3),(281,7457077,7457053,'2e4',3.333,3),(281,7457078,7457053,'e47',3.333,3),(281,7457079,7457053,'478',3.333,3),(281,7457080,7457053,'78e',3.333,3),(281,7457081,7457053,'8e2',3.333,3),(281,7457082,7457053,'e29',3.333,3),(281,7457083,7457053,'299',3.333,3),(281,7457084,7457054,'mon',100,1),(281,7457085,7457084,'201',50,1),(281,7457086,7457084,'013',50,1),(281,7457087,7457085,'adm',33.333,3),(281,7457088,7457085,'dmi',33.333,3),(281,7457089,7457085,'min',33.333,3),(281,7457090,7457087,'cap',16.667,1),(281,7457091,7457087,'apa',16.667,1),(281,7457092,7457087,'pac',16.667,1),(281,7457093,7457087,'aci',16.667,1),(281,7457094,7457087,'cit',16.667,1),(281,7457095,7457087,'ity',16.667,1),(281,7457096,7457090,'pat',50,1),(281,7457097,7457090,'ath',50,1),(281,7457098,7457096,'fre',14.286,1),(281,7457099,7457096,'ree',14.286,1),(281,7457100,7457096,'ees',14.286,1),(281,7457101,7457096,'esp',14.286,1),(281,7457102,7457096,'spa',14.286,1),(281,7457103,7457096,'pac',14.286,1),(281,7457104,7457096,'ace',14.286,1),(281,7457105,7457098,'dis',50,1),(281,7457106,7457098,'isk',50,1),(281,7457107,7457105,'ind',33.333,1),(281,7457108,7457105,'nde',33.333,1),(281,7457109,7457105,'dex',33.333,1),(281,7457110,7457107,'adm',8.333,1),(281,7457111,7457107,'dmi',8.333,1),(281,7457112,7457107,'min',8.333,1),(281,7457113,7457107,'ini',8.333,1),(281,7457114,7457107,'nis',8.333,1),(281,7457115,7457107,'ist',8.333,1),(281,7457116,7457107,'str',8.333,1),(281,7457117,7457107,'tra',8.333,1),(281,7457118,7457107,'rat',8.333,1),(281,7457119,7457107,'ati',8.333,1),(281,7457120,7457107,'tio',8.333,1),(281,7457121,7457107,'ion',8.333,1),(281,7457122,7457110,'sta',33.333,3),(281,7457123,7457110,'tat',33.333,3),(281,7457124,7457110,'ate',33.333,3),(281,7457125,7457122,'ena',20,2),(281,7457126,7457122,'nab',20,2),(281,7457127,7457122,'abl',20,2),(281,7457128,7457122,'ble',20,2),(281,7457129,7457122,'led',20,2),(281,7457130,7457125,'cac',33.333,1),(281,7457131,7457125,'ach',33.333,1),(281,7457132,7457125,'che',33.333,1),(281,7457133,7457130,'mod',50,2),(281,7457134,7457130,'ode',50,2),(281,7457135,7457133,'wri',14.286,2),(281,7457136,7457133,'rit',14.286,2),(281,7457137,7457133,'ite',14.286,2),(281,7457138,7457133,'tet',14.286,2),(281,7457139,7457133,'eth',14.286,2),(281,7457140,7457133,'thr',14.286,2),(281,7457141,7457133,'hru',14.286,2),(281,7457142,7457135,'ope',11.111,2),(281,7457143,7457135,'per',11.111,2),(281,7457144,7457135,'era',11.111,2),(281,7457145,7457135,'rat',11.111,2),(281,7457146,7457135,'ati',11.111,2),(281,7457147,7457135,'tio',11.111,2),(281,7457148,7457135,'ion',11.111,2),(281,7457149,7457135,'ona',11.111,2),(281,7457150,7457135,'nal',11.111,2),(281,7457151,7457142,'nor',25,1),(281,7457152,7457142,'orm',25,1),(281,7457153,7457142,'rma',25,1),(281,7457154,7457142,'mal',25,1),(281,7457155,7457151,'mes',20,1),(281,7457156,7457151,'ess',20,1),(281,7457157,7457151,'ssa',20,1),(281,7457158,7457151,'sag',20,1),(281,7457159,7457151,'age',20,1),(281,7457160,7457155,'per',11.111,1),(281,7457161,7457155,'erf',11.111,1),(281,7457162,7457155,'rfo',11.111,1),(281,7457163,7457155,'for',11.111,1),(281,7457164,7457155,'orm',11.111,1),(281,7457165,7457155,'rma',11.111,1),(281,7457166,7457155,'man',11.111,1),(281,7457167,7457155,'anc',11.111,1),(281,7457168,7457155,'nce',11.111,1),(281,7457169,7457160,'ide',12.5,1),(281,7457170,7457160,'den',12.5,1),(281,7457171,7457160,'ent',12.5,1),(281,7457172,7457160,'nti',12.5,1),(281,7457173,7457160,'tif',12.5,1),(281,7457174,7457160,'ifi',12.5,1),(281,7457175,7457160,'fie',12.5,1),(281,7457176,7457160,'ier',12.5,1),(281,7457177,7457169,'vdi',33.333,3),(281,7457178,7457169,'dis',33.333,3),(281,7457179,7457169,'isk',33.333,3),(281,7457180,7457177,'nam',50,1),(281,7457181,7457177,'ame',50,1),(281,7457182,7457180,'typ',50,1),(281,7457183,7457180,'ype',50,1),(281,7457184,7457182,'dir',25,1),(281,7457185,7457182,'ire',25,1),(281,7457186,7457182,'rec',25,1),(281,7457187,7457182,'ect',25,1),(282,7457189,7457188,'naa',100,2),(282,7457190,7457189,'600',3.333,3),(282,7457191,7457189,'000',3.333,3),(282,7457192,7457189,'00c',3.333,3),(282,7457193,7457189,'0c2',3.333,3),(282,7457194,7457189,'c29',3.333,3),(282,7457195,7457189,'296',3.333,3),(282,7457196,7457189,'962',3.333,3),(282,7457197,7457189,'62f',3.333,3),(282,7457198,7457189,'2f4',3.333,3),(282,7457199,7457189,'f4f',3.333,3),(282,7457200,7457189,'4f2',3.333,3),(282,7457201,7457189,'f2e',3.333,3),(282,7457202,7457189,'2ea',3.333,3),(282,7457203,7457189,'ea1',3.333,3),(282,7457204,7457189,'a11',3.333,3),(282,7457205,7457189,'11e',3.333,3),(282,7457206,7457189,'1e8',3.333,3),(282,7457207,7457189,'e83',3.333,3),(282,7457208,7457189,'838',3.333,3),(282,7457209,7457189,'380',3.333,3),(282,7457210,7457189,'80e',3.333,3),(282,7457211,7457189,'0e9',3.333,3),(282,7457212,7457189,'e97',3.333,3),(282,7457213,7457189,'978',3.333,3),(282,7457214,7457189,'78d',3.333,3),(282,7457215,7457189,'8da',3.333,3),(282,7457216,7457189,'daf',3.333,3),(282,7457217,7457189,'af5',3.333,3),(282,7457218,7457189,'f56',3.333,3),(282,7457219,7457189,'567',3.333,3),(282,7457220,7457190,'mon',100,1),(282,7457221,7457220,'201',50,1),(282,7457222,7457220,'013',50,1),(282,7457223,7457221,'adm',33.333,3),(282,7457224,7457221,'dmi',33.333,3),(282,7457225,7457221,'min',33.333,3),(282,7457226,7457223,'cap',16.667,1),(282,7457227,7457223,'apa',16.667,1),(282,7457228,7457223,'pac',16.667,1),(282,7457229,7457223,'aci',16.667,1),(282,7457230,7457223,'cit',16.667,1),(282,7457231,7457223,'ity',16.667,1),(282,7457232,7457226,'pat',50,1),(282,7457233,7457226,'ath',50,1),(282,7457234,7457232,'two',100,1),(282,7457235,7457234,'fre',14.286,1),(282,7457236,7457234,'ree',14.286,1),(282,7457237,7457234,'ees',14.286,1),(282,7457238,7457234,'esp',14.286,1),(282,7457239,7457234,'spa',14.286,1),(282,7457240,7457234,'pac',14.286,1),(282,7457241,7457234,'ace',14.286,1),(282,7457242,7457235,'dis',50,1),(282,7457243,7457235,'isk',50,1),(282,7457244,7457242,'ind',33.333,1),(282,7457245,7457242,'nde',33.333,1),(282,7457246,7457242,'dex',33.333,1),(282,7457247,7457244,'adm',8.333,1),(282,7457248,7457244,'dmi',8.333,1),(282,7457249,7457244,'min',8.333,1),(282,7457250,7457244,'ini',8.333,1),(282,7457251,7457244,'nis',8.333,1),(282,7457252,7457244,'ist',8.333,1),(282,7457253,7457244,'str',8.333,1),(282,7457254,7457244,'tra',8.333,1),(282,7457255,7457244,'rat',8.333,1),(282,7457256,7457244,'ati',8.333,1),(282,7457257,7457244,'tio',8.333,1),(282,7457258,7457244,'ion',8.333,1),(282,7457259,7457247,'sta',33.333,3),(282,7457260,7457247,'tat',33.333,3),(282,7457261,7457247,'ate',33.333,3),(282,7457262,7457259,'ena',20,2),(282,7457263,7457259,'nab',20,2),(282,7457264,7457259,'abl',20,2),(282,7457265,7457259,'ble',20,2),(282,7457266,7457259,'led',20,2),(282,7457267,7457262,'cac',33.333,1),(282,7457268,7457262,'ach',33.333,1),(282,7457269,7457262,'che',33.333,1),(282,7457270,7457267,'mod',50,2),(282,7457271,7457267,'ode',50,2),(282,7457272,7457270,'wri',14.286,2),(282,7457273,7457270,'rit',14.286,2),(282,7457274,7457270,'ite',14.286,2),(282,7457275,7457270,'tet',14.286,2),(282,7457276,7457270,'eth',14.286,2),(282,7457277,7457270,'thr',14.286,2),(282,7457278,7457270,'hru',14.286,2),(282,7457279,7457272,'ope',11.111,2),(282,7457280,7457272,'per',11.111,2),(282,7457281,7457272,'era',11.111,2),(282,7457282,7457272,'rat',11.111,2),(282,7457283,7457272,'ati',11.111,2),(282,7457284,7457272,'tio',11.111,2),(282,7457285,7457272,'ion',11.111,2),(282,7457286,7457272,'ona',11.111,2),(282,7457287,7457272,'nal',11.111,2),(282,7457288,7457279,'nor',25,1),(282,7457289,7457279,'orm',25,1),(282,7457290,7457279,'rma',25,1),(282,7457291,7457279,'mal',25,1),(282,7457292,7457288,'mes',20,1),(282,7457293,7457288,'ess',20,1),(282,7457294,7457288,'ssa',20,1),(282,7457295,7457288,'sag',20,1),(282,7457296,7457288,'age',20,1),(282,7457297,7457292,'per',11.111,1),(282,7457298,7457292,'erf',11.111,1),(282,7457299,7457292,'rfo',11.111,1),(282,7457300,7457292,'for',11.111,1),(282,7457301,7457292,'orm',11.111,1),(282,7457302,7457292,'rma',11.111,1),(282,7457303,7457292,'man',11.111,1),(282,7457304,7457292,'anc',11.111,1),(282,7457305,7457292,'nce',11.111,1),(282,7457306,7457297,'ide',12.5,1),(282,7457307,7457297,'den',12.5,1),(282,7457308,7457297,'ent',12.5,1),(282,7457309,7457297,'nti',12.5,1),(282,7457310,7457297,'tif',12.5,1),(282,7457311,7457297,'ifi',12.5,1),(282,7457312,7457297,'fie',12.5,1),(282,7457313,7457297,'ier',12.5,1),(282,7457314,7457306,'vdi',33.333,3),(282,7457315,7457306,'dis',33.333,3),(282,7457316,7457306,'isk',33.333,3),(282,7457317,7457314,'nam',50,1),(282,7457318,7457314,'ame',50,1),(282,7457319,7457317,'typ',50,1),(282,7457320,7457317,'ype',50,1),(282,7457321,7457319,'dir',25,1),(282,7457322,7457319,'ire',25,1),(282,7457323,7457319,'rec',25,1),(282,7457324,7457319,'ect',25,1),(283,7457326,7457325,'att',12.5,1),(283,7457327,7457325,'ttr',12.5,1),(283,7457328,7457325,'tri',12.5,1),(283,7457329,7457325,'rib',12.5,1),(283,7457330,7457325,'ibu',12.5,1),(283,7457331,7457325,'but',12.5,1),(283,7457332,7457325,'ute',12.5,1),(283,7457333,7457325,'tes',12.5,1),(283,7457334,7457326,'ref',20,3),(283,7457335,7457326,'efr',20,3),(283,7457336,7457326,'fre',20,3),(283,7457337,7457326,'res',20,3),(283,7457338,7457326,'esh',20,3),(283,7457339,7457334,'hos',50,2),(283,7457340,7457334,'ost',50,2),(283,7457341,7457339,'nam',50,2),(283,7457342,7457339,'ame',50,2),(283,7457343,7457341,'hg3',9.091,1),(283,7457344,7457341,'g32',9.091,1),(283,7457345,7457341,'32v',9.091,1),(283,7457346,7457341,'2vm',9.091,1),(283,7457347,7457341,'vm3',9.091,1),(283,7457348,7457341,'m3w',9.091,1),(283,7457349,7457341,'3w2',9.091,1),(283,7457350,7457341,'w2k',9.091,1),(283,7457351,7457341,'2k8',9.091,1),(283,7457352,7457341,'k8r',9.091,1),(283,7457353,7457341,'8r2',9.091,1),(283,7457354,7457343,'gdl',100,1),(283,7457355,7457354,'eng',25,1),(283,7457356,7457354,'ngl',25,1),(283,7457357,7457354,'gla',25,1),(283,7457358,7457354,'lab',25,1),(283,7457359,7457355,'net',25,1),(283,7457360,7457355,'eta',25,1),(283,7457361,7457355,'tap',25,1),(283,7457362,7457355,'app',25,1),(283,7457363,7457359,'com',100,1),(283,7457364,7457363,'mem',25,3),(283,7457365,7457363,'emo',25,3),(283,7457366,7457363,'mor',25,3),(283,7457367,7457363,'ory',25,3),(283,7457368,7457364,'siz',50,2),(283,7457369,7457364,'ize',50,2),(283,7457370,7457368,'614',50,1),(283,7457371,7457368,'144',50,1),(283,7457372,7457370,'cpu',100,1),(283,7457373,7457372,'usa',33.333,3),(283,7457374,7457372,'sag',33.333,3),(283,7457375,7457372,'age',33.333,3),(283,7457376,7457373,'mhz',100,1),(283,7457377,7457376,'add',20,1),(283,7457378,7457376,'ddr',20,1),(283,7457379,7457376,'dre',20,1),(283,7457380,7457376,'res',20,1),(283,7457381,7457376,'ess',20,1),(283,7457382,7457377,'226',100,1),(283,7457383,7457382,'147',100,1),(283,7457384,7457383,'205',100,1),(283,7457385,7457384,'620',50,1),(283,7457386,7457384,'206',50,1),(283,7457387,7457385,'gue',33.333,2),(283,7457388,7457385,'ues',33.333,2),(283,7457389,7457385,'est',33.333,2),(283,7457390,7457387,'vmw',25,2),(283,7457391,7457387,'mwa',25,2),(283,7457392,7457387,'war',25,2),(283,7457393,7457387,'are',25,2),(283,7457394,7457390,'too',33.333,2),(283,7457395,7457390,'ool',33.333,2),(283,7457396,7457390,'ols',33.333,2),(283,7457397,7457394,'run',20,1),(283,7457398,7457394,'unn',20,1),(283,7457399,7457394,'nni',20,1),(283,7457400,7457394,'nin',20,1),(283,7457401,7457394,'ing',20,1),(283,7457402,7457397,'and',100,1),(283,7457403,7457402,'the',100,1),(283,7457404,7457403,'ver',20,2),(283,7457405,7457403,'ers',20,2),(283,7457406,7457403,'rsi',20,2),(283,7457407,7457403,'sio',20,2),(283,7457408,7457403,'ion',20,2),(283,7457409,7457404,'cur',20,1),(283,7457410,7457404,'urr',20,1),(283,7457411,7457404,'rre',20,1),(283,7457412,7457404,'ren',20,1),(283,7457413,7457404,'ent',20,1),(283,7457414,7457409,'mic',14.286,1),(283,7457415,7457409,'icr',14.286,1),(283,7457416,7457409,'cro',14.286,1),(283,7457417,7457409,'ros',14.286,1),(283,7457418,7457409,'oso',14.286,1),(283,7457419,7457409,'sof',14.286,1),(283,7457420,7457409,'oft',14.286,1),(283,7457421,7457414,'win',20,1),(283,7457422,7457414,'ind',20,1),(283,7457423,7457414,'ndo',20,1),(283,7457424,7457414,'dow',20,1),(283,7457425,7457414,'ows',20,1),(283,7457426,7457421,'ser',25,1),(283,7457427,7457421,'erv',25,1),(283,7457428,7457421,'rve',25,1),(283,7457429,7457421,'ver',25,1),(283,7457430,7457426,'200',50,1),(283,7457431,7457426,'008',50,1),(283,7457432,7457430,'64b',33.333,1),(283,7457433,7457430,'4bi',33.333,1),(283,7457434,7457430,'bit',33.333,1),(283,7457435,7457432,'pat',50,1),(283,7457436,7457432,'ath',50,1),(283,7457437,7457435,'rx6',33.333,1),(283,7457438,7457435,'x60',33.333,1),(283,7457439,7457435,'600',33.333,1),(283,7457440,7457437,'vmf',20,1),(283,7457441,7457437,'mfi',20,1),(283,7457442,7457437,'fil',20,1),(283,7457443,7457437,'ile',20,1),(283,7457444,7457437,'les',20,1),(283,7457445,7457440,'hgw',9.091,2),(283,7457446,7457440,'gw2',9.091,2),(283,7457447,7457440,'w2k',9.091,2),(283,7457448,7457440,'2k8',9.091,2),(283,7457449,7457440,'k8r',9.091,2),(283,7457450,7457440,'8r2',9.091,2),(283,7457451,7457440,'r23',9.091,2),(283,7457452,7457440,'232',9.091,2),(283,7457453,7457440,'32v',9.091,2),(283,7457454,7457440,'2vm',9.091,2),(283,7457455,7457440,'vm3',9.091,2),(283,7457456,7457445,'vmx',100,1),(283,7457457,7457456,'fla',33.333,1),(283,7457458,7457456,'las',33.333,1),(283,7457459,7457456,'ash',33.333,1),(283,7457460,7457457,'acc',33.333,1),(283,7457461,7457457,'cce',33.333,1),(283,7457462,7457457,'cel',33.333,1),(283,7457463,7457460,'con',9.091,1),(283,7457464,7457460,'onf',9.091,1),(283,7457465,7457460,'nfi',9.091,1),(283,7457466,7457460,'fig',9.091,1),(283,7457467,7457460,'igu',9.091,1),(283,7457468,7457460,'gur',9.091,1),(283,7457469,7457460,'ura',9.091,1),(283,7457470,7457460,'rat',9.091,1),(283,7457471,7457460,'ati',9.091,1),(283,7457472,7457460,'tio',9.091,1),(283,7457473,7457460,'ion',9.091,1),(283,7457474,7457463,'age',33.333,1),(283,7457475,7457463,'gen',33.333,1),(283,7457476,7457463,'ent',33.333,1),(283,7457477,7457474,'193',16.667,1),(283,7457478,7457474,'938',16.667,1),(283,7457479,7457474,'380',16.667,1),(283,7457480,7457474,'809',16.667,1),(283,7457481,7457474,'097',16.667,1),(283,7457482,7457474,'979',16.667,1),(283,7457483,7457477,'cac',33.333,3),(283,7457484,7457477,'ach',33.333,3),(283,7457485,7457477,'che',33.333,3),(283,7457486,7457483,'sta',33.333,2),(283,7457487,7457483,'tat',33.333,2),(283,7457488,7457483,'ate',33.333,2),(283,7457489,7457486,'ena',20,2),(283,7457490,7457486,'nab',20,2),(283,7457491,7457486,'abl',20,2),(283,7457492,7457486,'ble',20,2),(283,7457493,7457486,'led',20,2),(283,7457494,7457489,'ope',11.111,2),(283,7457495,7457489,'per',11.111,2),(283,7457496,7457489,'era',11.111,2),(283,7457497,7457489,'rat',11.111,2),(283,7457498,7457489,'ati',11.111,2),(283,7457499,7457489,'tio',11.111,2),(283,7457500,7457489,'ion',11.111,2),(283,7457501,7457489,'ona',11.111,2),(283,7457502,7457489,'nal',11.111,2),(283,7457503,7457494,'nor',25,1),(283,7457504,7457494,'orm',25,1),(283,7457505,7457494,'rma',25,1),(283,7457506,7457494,'mal',25,1),(283,7457507,7457503,'mod',50,2),(283,7457508,7457503,'ode',50,2),(283,7457509,7457507,'wri',14.286,2),(283,7457510,7457507,'rit',14.286,2),(283,7457511,7457507,'ite',14.286,2),(283,7457512,7457507,'tet',14.286,2),(283,7457513,7457507,'eth',14.286,2),(283,7457514,7457507,'thr',14.286,2),(283,7457515,7457507,'hru',14.286,2),(283,7457516,7457509,'mes',20,1),(283,7457517,7457509,'ess',20,1),(283,7457518,7457509,'ssa',20,1),(283,7457519,7457509,'sag',20,1),(283,7457520,7457509,'age',20,1),(283,7457521,7457516,'met',20,3),(283,7457522,7457516,'etr',20,3),(283,7457523,7457516,'tri',20,3),(283,7457524,7457516,'ric',20,3),(283,7457525,7457516,'ics',20,3),(283,7457526,7457521,'vir',20,1),(283,7457527,7457521,'irt',20,1),(283,7457528,7457521,'rtu',20,1),(283,7457529,7457521,'tua',20,1),(283,7457530,7457521,'ual',20,1),(283,7457531,7457526,'dis',50,1),(283,7457532,7457526,'isk',50,1),(284,7457534,7457533,'naa',100,2),(284,7457535,7457534,'600',3.333,3),(284,7457536,7457534,'000',3.333,3),(284,7457537,7457534,'00c',3.333,3),(284,7457538,7457534,'0c2',3.333,3),(284,7457539,7457534,'c29',3.333,3),(284,7457540,7457534,'29a',3.333,3),(284,7457541,7457534,'9a9',3.333,3),(284,7457542,7457534,'a9b',3.333,3),(284,7457543,7457534,'9b1',3.333,3),(284,7457544,7457534,'b11',3.333,3),(284,7457545,7457534,'113',3.333,3),(284,7457546,7457534,'130',3.333,3),(284,7457547,7457534,'305',3.333,3),(284,7457548,7457534,'056',3.333,3),(284,7457549,7457534,'567',3.333,3),(284,7457550,7457534,'673',3.333,3),(284,7457551,7457534,'731',3.333,3),(284,7457552,7457534,'314',3.333,3),(284,7457553,7457534,'146',3.333,3),(284,7457554,7457534,'46d',3.333,3),(284,7457555,7457534,'6d9',3.333,3),(284,7457556,7457534,'d99',3.333,3),(284,7457557,7457534,'99b',3.333,3),(284,7457558,7457534,'9b4',3.333,3),(284,7457559,7457534,'b45',3.333,3),(284,7457560,7457534,'450',3.333,3),(284,7457561,7457534,'507',3.333,3),(284,7457562,7457534,'072',3.333,3),(284,7457563,7457534,'723',3.333,3),(284,7457564,7457534,'23c',3.333,3),(284,7457565,7457535,'mon',100,1),(284,7457566,7457565,'201',50,1),(284,7457567,7457565,'013',50,1),(284,7457568,7457566,'adm',33.333,3),(284,7457569,7457566,'dmi',33.333,3),(284,7457570,7457566,'min',33.333,3),(284,7457571,7457568,'cap',16.667,1),(284,7457572,7457568,'apa',16.667,1),(284,7457573,7457568,'pac',16.667,1),(284,7457574,7457568,'aci',16.667,1),(284,7457575,7457568,'cit',16.667,1),(284,7457576,7457568,'ity',16.667,1),(284,7457577,7457571,'pat',50,1),(284,7457578,7457571,'ath',50,1),(284,7457579,7457577,'vol',25,1),(284,7457580,7457577,'olu',25,1),(284,7457581,7457577,'lum',25,1),(284,7457582,7457577,'ume',25,1),(284,7457583,7457579,'78e',3.333,1),(284,7457584,7457579,'8e3',3.333,1),(284,7457585,7457579,'e3f',3.333,1),(284,7457586,7457579,'3f1',3.333,1),(284,7457587,7457579,'f18',3.333,1),(284,7457588,7457579,'188',3.333,1),(284,7457589,7457579,'886',3.333,1),(284,7457590,7457579,'86d',3.333,1),(284,7457591,7457579,'6d8',3.333,1),(284,7457592,7457579,'d87',3.333,1),(284,7457593,7457579,'871',3.333,1),(284,7457594,7457579,'711',3.333,1),(284,7457595,7457579,'11e',3.333,1),(284,7457596,7457579,'1e1',3.333,1),(284,7457597,7457579,'e19',3.333,1),(284,7457598,7457579,'192',3.333,1),(284,7457599,7457579,'927',3.333,1),(284,7457600,7457579,'277',3.333,1),(284,7457601,7457579,'778',3.333,1),(284,7457602,7457579,'780',3.333,1),(284,7457603,7457579,'806',3.333,1),(284,7457604,7457579,'06e',3.333,1),(284,7457605,7457579,'6e6',3.333,1),(284,7457606,7457579,'e6f',3.333,1),(284,7457607,7457579,'6f6',3.333,1),(284,7457608,7457579,'f6e',3.333,1),(284,7457609,7457579,'6e6',3.333,1),(284,7457610,7457579,'e69',3.333,1),(284,7457611,7457579,'696',3.333,1),(284,7457612,7457579,'963',3.333,1),(284,7457613,7457583,'fre',14.286,1),(284,7457614,7457583,'ree',14.286,1),(284,7457615,7457583,'ees',14.286,1),(284,7457616,7457583,'esp',14.286,1),(284,7457617,7457583,'spa',14.286,1),(284,7457618,7457583,'pac',14.286,1),(284,7457619,7457583,'ace',14.286,1),(284,7457620,7457613,'dis',50,1),(284,7457621,7457613,'isk',50,1),(284,7457622,7457620,'ind',33.333,1),(284,7457623,7457620,'nde',33.333,1),(284,7457624,7457620,'dex',33.333,1),(284,7457625,7457622,'adm',8.333,1),(284,7457626,7457622,'dmi',8.333,1),(284,7457627,7457622,'min',8.333,1),(284,7457628,7457622,'ini',8.333,1),(284,7457629,7457622,'nis',8.333,1),(284,7457630,7457622,'ist',8.333,1),(284,7457631,7457622,'str',8.333,1),(284,7457632,7457622,'tra',8.333,1),(284,7457633,7457622,'rat',8.333,1),(284,7457634,7457622,'ati',8.333,1),(284,7457635,7457622,'tio',8.333,1),(284,7457636,7457622,'ion',8.333,1),(284,7457637,7457625,'sta',33.333,3),(284,7457638,7457625,'tat',33.333,3),(284,7457639,7457625,'ate',33.333,3),(284,7457640,7457637,'ena',20,2),(284,7457641,7457637,'nab',20,2),(284,7457642,7457637,'abl',20,2),(284,7457643,7457637,'ble',20,2),(284,7457644,7457637,'led',20,2),(284,7457645,7457640,'cac',33.333,1),(284,7457646,7457640,'ach',33.333,1),(284,7457647,7457640,'che',33.333,1),(284,7457648,7457645,'mod',50,2),(284,7457649,7457645,'ode',50,2),(284,7457650,7457648,'wri',14.286,2),(284,7457651,7457648,'rit',14.286,2),(284,7457652,7457648,'ite',14.286,2),(284,7457653,7457648,'tet',14.286,2),(284,7457654,7457648,'eth',14.286,2),(284,7457655,7457648,'thr',14.286,2),(284,7457656,7457648,'hru',14.286,2),(284,7457657,7457650,'ope',11.111,2),(284,7457658,7457650,'per',11.111,2),(284,7457659,7457650,'era',11.111,2),(284,7457660,7457650,'rat',11.111,2),(284,7457661,7457650,'ati',11.111,2),(284,7457662,7457650,'tio',11.111,2),(284,7457663,7457650,'ion',11.111,2),(284,7457664,7457650,'ona',11.111,2),(284,7457665,7457650,'nal',11.111,2),(284,7457666,7457657,'nor',25,1),(284,7457667,7457657,'orm',25,1),(284,7457668,7457657,'rma',25,1),(284,7457669,7457657,'mal',25,1),(284,7457670,7457666,'mes',20,1),(284,7457671,7457666,'ess',20,1),(284,7457672,7457666,'ssa',20,1),(284,7457673,7457666,'sag',20,1),(284,7457674,7457666,'age',20,1),(284,7457675,7457670,'per',11.111,1),(284,7457676,7457670,'erf',11.111,1),(284,7457677,7457670,'rfo',11.111,1),(284,7457678,7457670,'for',11.111,1),(284,7457679,7457670,'orm',11.111,1),(284,7457680,7457670,'rma',11.111,1),(284,7457681,7457670,'man',11.111,1),(284,7457682,7457670,'anc',11.111,1),(284,7457683,7457670,'nce',11.111,1),(284,7457684,7457675,'ide',12.5,1),(284,7457685,7457675,'den',12.5,1),(284,7457686,7457675,'ent',12.5,1),(284,7457687,7457675,'nti',12.5,1),(284,7457688,7457675,'tif',12.5,1),(284,7457689,7457675,'ifi',12.5,1),(284,7457690,7457675,'fie',12.5,1),(284,7457691,7457675,'ier',12.5,1),(284,7457692,7457684,'vdi',33.333,3),(284,7457693,7457684,'dis',33.333,3),(284,7457694,7457684,'isk',33.333,3),(284,7457695,7457692,'nam',50,1),(284,7457696,7457692,'ame',50,1),(284,7457697,7457695,'typ',50,1),(284,7457698,7457695,'ype',50,1),(284,7457699,7457697,'dir',25,1),(284,7457700,7457697,'ire',25,1),(284,7457701,7457697,'rec',25,1),(284,7457702,7457697,'ect',25,1),(285,7457704,7457703,'naa',100,2),(285,7457705,7457704,'600',3.333,3),(285,7457706,7457704,'00a',3.333,3),(285,7457707,7457704,'0a0',3.333,3),(285,7457708,7457704,'a09',3.333,3),(285,7457709,7457704,'098',3.333,3),(285,7457710,7457704,'980',3.333,3),(285,7457711,7457704,'804',3.333,3),(285,7457712,7457704,'044',3.333,3),(285,7457713,7457704,'443',3.333,3),(285,7457714,7457704,'430',3.333,3),(285,7457715,7457704,'307',3.333,3),(285,7457716,7457704,'075',3.333,3),(285,7457717,7457704,'753',3.333,3),(285,7457718,7457704,'535',3.333,3),(285,7457719,7457704,'357',3.333,3),(285,7457720,7457704,'573',3.333,3),(285,7457721,7457704,'732',3.333,3),(285,7457722,7457704,'32b',3.333,3),(285,7457723,7457704,'2b3',3.333,3),(285,7457724,7457704,'b33',3.333,3),(285,7457725,7457704,'334',3.333,3),(285,7457726,7457704,'345',3.333,3),(285,7457727,7457704,'457',3.333,3),(285,7457728,7457704,'571',3.333,3),(285,7457729,7457704,'715',3.333,3),(285,7457730,7457704,'153',3.333,3),(285,7457731,7457704,'533',3.333,3),(285,7457732,7457704,'335',3.333,3),(285,7457733,7457704,'357',3.333,3),(285,7457734,7457704,'575',3.333,3),(285,7457735,7457705,'mon',100,1),(285,7457736,7457735,'201',50,1),(285,7457737,7457735,'013',50,1),(285,7457738,7457736,'adm',33.333,3),(285,7457739,7457736,'dmi',33.333,3),(285,7457740,7457736,'min',33.333,3),(285,7457741,7457738,'cap',16.667,1),(285,7457742,7457738,'apa',16.667,1),(285,7457743,7457738,'pac',16.667,1),(285,7457744,7457738,'aci',16.667,1),(285,7457745,7457738,'cit',16.667,1),(285,7457746,7457738,'ity',16.667,1),(285,7457747,7457741,'pat',50,1),(285,7457748,7457741,'ath',50,1),(285,7457749,7457747,'fre',14.286,1),(285,7457750,7457747,'ree',14.286,1),(285,7457751,7457747,'ees',14.286,1),(285,7457752,7457747,'esp',14.286,1),(285,7457753,7457747,'spa',14.286,1),(285,7457754,7457747,'pac',14.286,1),(285,7457755,7457747,'ace',14.286,1),(285,7457756,7457749,'dis',50,1),(285,7457757,7457749,'isk',50,1),(285,7457758,7457756,'ind',33.333,1),(285,7457759,7457756,'nde',33.333,1),(285,7457760,7457756,'dex',33.333,1),(285,7457761,7457758,'adm',8.333,1),(285,7457762,7457758,'dmi',8.333,1),(285,7457763,7457758,'min',8.333,1),(285,7457764,7457758,'ini',8.333,1),(285,7457765,7457758,'nis',8.333,1),(285,7457766,7457758,'ist',8.333,1),(285,7457767,7457758,'str',8.333,1),(285,7457768,7457758,'tra',8.333,1),(285,7457769,7457758,'rat',8.333,1),(285,7457770,7457758,'ati',8.333,1),(285,7457771,7457758,'tio',8.333,1),(285,7457772,7457758,'ion',8.333,1),(285,7457773,7457761,'sta',33.333,3),(285,7457774,7457761,'tat',33.333,3),(285,7457775,7457761,'ate',33.333,3),(285,7457776,7457773,'ena',20,2),(285,7457777,7457773,'nab',20,2),(285,7457778,7457773,'abl',20,2),(285,7457779,7457773,'ble',20,2),(285,7457780,7457773,'led',20,2),(285,7457781,7457776,'cac',33.333,1),(285,7457782,7457776,'ach',33.333,1),(285,7457783,7457776,'che',33.333,1),(285,7457784,7457781,'mod',50,2),(285,7457785,7457781,'ode',50,2),(285,7457786,7457784,'wri',14.286,2),(285,7457787,7457784,'rit',14.286,2),(285,7457788,7457784,'ite',14.286,2),(285,7457789,7457784,'tet',14.286,2),(285,7457790,7457784,'eth',14.286,2),(285,7457791,7457784,'thr',14.286,2),(285,7457792,7457784,'hru',14.286,2),(285,7457793,7457786,'ope',11.111,2),(285,7457794,7457786,'per',11.111,2),(285,7457795,7457786,'era',11.111,2),(285,7457796,7457786,'rat',11.111,2),(285,7457797,7457786,'ati',11.111,2),(285,7457798,7457786,'tio',11.111,2),(285,7457799,7457786,'ion',11.111,2),(285,7457800,7457786,'ona',11.111,2),(285,7457801,7457786,'nal',11.111,2),(285,7457802,7457793,'nor',25,1),(285,7457803,7457793,'orm',25,1),(285,7457804,7457793,'rma',25,1),(285,7457805,7457793,'mal',25,1),(285,7457806,7457802,'mes',20,1),(285,7457807,7457802,'ess',20,1),(285,7457808,7457802,'ssa',20,1),(285,7457809,7457802,'sag',20,1),(285,7457810,7457802,'age',20,1),(285,7457811,7457806,'per',11.111,1),(285,7457812,7457806,'erf',11.111,1),(285,7457813,7457806,'rfo',11.111,1),(285,7457814,7457806,'for',11.111,1),(285,7457815,7457806,'orm',11.111,1),(285,7457816,7457806,'rma',11.111,1),(285,7457817,7457806,'man',11.111,1),(285,7457818,7457806,'anc',11.111,1),(285,7457819,7457806,'nce',11.111,1),(285,7457820,7457811,'ide',12.5,1),(285,7457821,7457811,'den',12.5,1),(285,7457822,7457811,'ent',12.5,1),(285,7457823,7457811,'nti',12.5,1),(285,7457824,7457811,'tif',12.5,1),(285,7457825,7457811,'ifi',12.5,1),(285,7457826,7457811,'fie',12.5,1),(285,7457827,7457811,'ier',12.5,1),(285,7457828,7457820,'vdi',33.333,3),(285,7457829,7457820,'dis',33.333,3),(285,7457830,7457820,'isk',33.333,3),(285,7457831,7457828,'nam',50,1),(285,7457832,7457828,'ame',50,1),(285,7457833,7457831,'typ',50,1),(285,7457834,7457831,'ype',50,1),(285,7457835,7457833,'dir',25,1),(285,7457836,7457833,'ire',25,1),(285,7457837,7457833,'rec',25,1),(285,7457838,7457833,'ect',25,1),(286,7457840,7457839,'naa',100,2),(286,7457841,7457840,'600',3.333,3),(286,7457842,7457840,'00a',3.333,3),(286,7457843,7457840,'0a0',3.333,3),(286,7457844,7457840,'a09',3.333,3),(286,7457845,7457840,'098',3.333,3),(286,7457846,7457840,'980',3.333,3),(286,7457847,7457840,'804',3.333,3),(286,7457848,7457840,'044',3.333,3),(286,7457849,7457840,'443',3.333,3),(286,7457850,7457840,'430',3.333,3),(286,7457851,7457840,'307',3.333,3),(286,7457852,7457840,'072',3.333,3),(286,7457853,7457840,'725',3.333,3),(286,7457854,7457840,'259',3.333,3),(286,7457855,7457840,'593',3.333,3),(286,7457856,7457840,'931',3.333,3),(286,7457857,7457840,'313',3.333,3),(286,7457858,7457840,'13f',3.333,3),(286,7457859,7457840,'3f3',3.333,3),(286,7457860,7457840,'f33',3.333,3),(286,7457861,7457840,'334',3.333,3),(286,7457862,7457840,'345',3.333,3),(286,7457863,7457840,'455',3.333,3),(286,7457864,7457840,'556',3.333,3),(286,7457865,7457840,'563',3.333,3),(286,7457866,7457840,'639',3.333,3),(286,7457867,7457840,'393',3.333,3),(286,7457868,7457840,'934',3.333,3),(286,7457869,7457840,'342',3.333,3),(286,7457870,7457840,'42d',3.333,3),(286,7457871,7457841,'mon',100,1),(286,7457872,7457871,'201',50,1),(286,7457873,7457871,'013',50,1),(286,7457874,7457872,'adm',33.333,3),(286,7457875,7457872,'dmi',33.333,3),(286,7457876,7457872,'min',33.333,3),(286,7457877,7457874,'cap',16.667,1),(286,7457878,7457874,'apa',16.667,1),(286,7457879,7457874,'pac',16.667,1),(286,7457880,7457874,'aci',16.667,1),(286,7457881,7457874,'cit',16.667,1),(286,7457882,7457874,'ity',16.667,1),(286,7457883,7457877,'pat',50,1),(286,7457884,7457877,'ath',50,1),(286,7457885,7457883,'fre',14.286,1),(286,7457886,7457883,'ree',14.286,1),(286,7457887,7457883,'ees',14.286,1),(286,7457888,7457883,'esp',14.286,1),(286,7457889,7457883,'spa',14.286,1),(286,7457890,7457883,'pac',14.286,1),(286,7457891,7457883,'ace',14.286,1),(286,7457892,7457885,'dis',50,1),(286,7457893,7457885,'isk',50,1),(286,7457894,7457892,'ind',33.333,1),(286,7457895,7457892,'nde',33.333,1),(286,7457896,7457892,'dex',33.333,1),(286,7457897,7457894,'adm',8.333,1),(286,7457898,7457894,'dmi',8.333,1),(286,7457899,7457894,'min',8.333,1),(286,7457900,7457894,'ini',8.333,1),(286,7457901,7457894,'nis',8.333,1),(286,7457902,7457894,'ist',8.333,1),(286,7457903,7457894,'str',8.333,1),(286,7457904,7457894,'tra',8.333,1),(286,7457905,7457894,'rat',8.333,1),(286,7457906,7457894,'ati',8.333,1),(286,7457907,7457894,'tio',8.333,1),(286,7457908,7457894,'ion',8.333,1),(286,7457909,7457897,'sta',33.333,3),(286,7457910,7457897,'tat',33.333,3),(286,7457911,7457897,'ate',33.333,3),(286,7457912,7457909,'ena',20,2),(286,7457913,7457909,'nab',20,2),(286,7457914,7457909,'abl',20,2),(286,7457915,7457909,'ble',20,2),(286,7457916,7457909,'led',20,2),(286,7457917,7457912,'cac',33.333,1),(286,7457918,7457912,'ach',33.333,1),(286,7457919,7457912,'che',33.333,1),(286,7457920,7457917,'mod',50,2),(286,7457921,7457917,'ode',50,2),(286,7457922,7457920,'wri',14.286,2),(286,7457923,7457920,'rit',14.286,2),(286,7457924,7457920,'ite',14.286,2),(286,7457925,7457920,'tet',14.286,2),(286,7457926,7457920,'eth',14.286,2),(286,7457927,7457920,'thr',14.286,2),(286,7457928,7457920,'hru',14.286,2),(286,7457929,7457922,'ope',11.111,2),(286,7457930,7457922,'per',11.111,2),(286,7457931,7457922,'era',11.111,2),(286,7457932,7457922,'rat',11.111,2),(286,7457933,7457922,'ati',11.111,2),(286,7457934,7457922,'tio',11.111,2),(286,7457935,7457922,'ion',11.111,2),(286,7457936,7457922,'ona',11.111,2),(286,7457937,7457922,'nal',11.111,2),(286,7457938,7457929,'nor',25,1),(286,7457939,7457929,'orm',25,1),(286,7457940,7457929,'rma',25,1),(286,7457941,7457929,'mal',25,1),(286,7457942,7457938,'mes',20,1),(286,7457943,7457938,'ess',20,1),(286,7457944,7457938,'ssa',20,1),(286,7457945,7457938,'sag',20,1),(286,7457946,7457938,'age',20,1),(286,7457947,7457942,'per',11.111,1),(286,7457948,7457942,'erf',11.111,1),(286,7457949,7457942,'rfo',11.111,1),(286,7457950,7457942,'for',11.111,1),(286,7457951,7457942,'orm',11.111,1),(286,7457952,7457942,'rma',11.111,1),(286,7457953,7457942,'man',11.111,1),(286,7457954,7457942,'anc',11.111,1),(286,7457955,7457942,'nce',11.111,1),(286,7457956,7457947,'ide',12.5,1),(286,7457957,7457947,'den',12.5,1),(286,7457958,7457947,'ent',12.5,1),(286,7457959,7457947,'nti',12.5,1),(286,7457960,7457947,'tif',12.5,1),(286,7457961,7457947,'ifi',12.5,1),(286,7457962,7457947,'fie',12.5,1),(286,7457963,7457947,'ier',12.5,1),(286,7457964,7457956,'vdi',33.333,3),(286,7457965,7457956,'dis',33.333,3),(286,7457966,7457956,'isk',33.333,3),(286,7457967,7457964,'nam',50,1),(286,7457968,7457964,'ame',50,1),(286,7457969,7457967,'typ',50,1),(286,7457970,7457967,'ype',50,1),(286,7457971,7457969,'dir',25,1),(286,7457972,7457969,'ire',25,1),(286,7457973,7457969,'rec',25,1),(286,7457974,7457969,'ect',25,1),(287,7457976,7457975,'naa',100,2),(287,7457977,7457976,'600',3.333,3),(287,7457978,7457976,'00a',3.333,3),(287,7457979,7457976,'0a0',3.333,3),(287,7457980,7457976,'a09',3.333,3),(287,7457981,7457976,'098',3.333,3),(287,7457982,7457976,'980',3.333,3),(287,7457983,7457976,'804',3.333,3),(287,7457984,7457976,'044',3.333,3),(287,7457985,7457976,'443',3.333,3),(287,7457986,7457976,'430',3.333,3),(287,7457987,7457976,'307',3.333,3),(287,7457988,7457976,'075',3.333,3),(287,7457989,7457976,'753',3.333,3),(287,7457990,7457976,'535',3.333,3),(287,7457991,7457976,'357',3.333,3),(287,7457992,7457976,'573',3.333,3),(287,7457993,7457976,'732',3.333,3),(287,7457994,7457976,'32b',3.333,3),(287,7457995,7457976,'2b3',3.333,3),(287,7457996,7457976,'b33',3.333,3),(287,7457997,7457976,'334',3.333,3),(287,7457998,7457976,'345',3.333,3),(287,7457999,7457976,'457',3.333,3),(287,7458000,7457976,'571',3.333,3),(287,7458001,7457976,'715',3.333,3),(287,7458002,7457976,'153',3.333,3),(287,7458003,7457976,'533',3.333,3),(287,7458004,7457976,'335',3.333,3),(287,7458005,7457976,'357',3.333,3),(287,7458006,7457976,'576',3.333,3),(287,7458007,7457977,'mon',100,1),(287,7458008,7458007,'201',50,1),(287,7458009,7458007,'013',50,1),(287,7458010,7458008,'adm',33.333,3),(287,7458011,7458008,'dmi',33.333,3),(287,7458012,7458008,'min',33.333,3),(287,7458013,7458010,'cap',16.667,1),(287,7458014,7458010,'apa',16.667,1),(287,7458015,7458010,'pac',16.667,1),(287,7458016,7458010,'aci',16.667,1),(287,7458017,7458010,'cit',16.667,1),(287,7458018,7458010,'ity',16.667,1),(287,7458019,7458013,'pat',50,1),(287,7458020,7458013,'ath',50,1),(287,7458021,7458019,'fre',14.286,1),(287,7458022,7458019,'ree',14.286,1),(287,7458023,7458019,'ees',14.286,1),(287,7458024,7458019,'esp',14.286,1),(287,7458025,7458019,'spa',14.286,1),(287,7458026,7458019,'pac',14.286,1),(287,7458027,7458019,'ace',14.286,1),(287,7458028,7458021,'dis',50,1),(287,7458029,7458021,'isk',50,1),(287,7458030,7458028,'ind',33.333,1),(287,7458031,7458028,'nde',33.333,1),(287,7458032,7458028,'dex',33.333,1),(287,7458033,7458030,'adm',8.333,1),(287,7458034,7458030,'dmi',8.333,1),(287,7458035,7458030,'min',8.333,1),(287,7458036,7458030,'ini',8.333,1),(287,7458037,7458030,'nis',8.333,1),(287,7458038,7458030,'ist',8.333,1),(287,7458039,7458030,'str',8.333,1),(287,7458040,7458030,'tra',8.333,1),(287,7458041,7458030,'rat',8.333,1),(287,7458042,7458030,'ati',8.333,1),(287,7458043,7458030,'tio',8.333,1),(287,7458044,7458030,'ion',8.333,1),(287,7458045,7458033,'sta',33.333,3),(287,7458046,7458033,'tat',33.333,3),(287,7458047,7458033,'ate',33.333,3),(287,7458048,7458045,'ena',20,2),(287,7458049,7458045,'nab',20,2),(287,7458050,7458045,'abl',20,2),(287,7458051,7458045,'ble',20,2),(287,7458052,7458045,'led',20,2),(287,7458053,7458048,'cac',33.333,1),(287,7458054,7458048,'ach',33.333,1),(287,7458055,7458048,'che',33.333,1),(287,7458056,7458053,'mod',50,2),(287,7458057,7458053,'ode',50,2),(287,7458058,7458056,'wri',14.286,2),(287,7458059,7458056,'rit',14.286,2),(287,7458060,7458056,'ite',14.286,2),(287,7458061,7458056,'tet',14.286,2),(287,7458062,7458056,'eth',14.286,2),(287,7458063,7458056,'thr',14.286,2),(287,7458064,7458056,'hru',14.286,2),(287,7458065,7458058,'ope',11.111,2),(287,7458066,7458058,'per',11.111,2),(287,7458067,7458058,'era',11.111,2),(287,7458068,7458058,'rat',11.111,2),(287,7458069,7458058,'ati',11.111,2),(287,7458070,7458058,'tio',11.111,2),(287,7458071,7458058,'ion',11.111,2),(287,7458072,7458058,'ona',11.111,2),(287,7458073,7458058,'nal',11.111,2),(287,7458074,7458065,'nor',25,1),(287,7458075,7458065,'orm',25,1),(287,7458076,7458065,'rma',25,1),(287,7458077,7458065,'mal',25,1),(287,7458078,7458074,'mes',20,1),(287,7458079,7458074,'ess',20,1),(287,7458080,7458074,'ssa',20,1),(287,7458081,7458074,'sag',20,1),(287,7458082,7458074,'age',20,1),(287,7458083,7458078,'per',11.111,1),(287,7458084,7458078,'erf',11.111,1),(287,7458085,7458078,'rfo',11.111,1),(287,7458086,7458078,'for',11.111,1),(287,7458087,7458078,'orm',11.111,1),(287,7458088,7458078,'rma',11.111,1),(287,7458089,7458078,'man',11.111,1),(287,7458090,7458078,'anc',11.111,1),(287,7458091,7458078,'nce',11.111,1),(287,7458092,7458083,'ide',12.5,1),(287,7458093,7458083,'den',12.5,1),(287,7458094,7458083,'ent',12.5,1),(287,7458095,7458083,'nti',12.5,1),(287,7458096,7458083,'tif',12.5,1),(287,7458097,7458083,'ifi',12.5,1),(287,7458098,7458083,'fie',12.5,1),(287,7458099,7458083,'ier',12.5,1),(287,7458100,7458092,'vdi',33.333,3),(287,7458101,7458092,'dis',33.333,3),(287,7458102,7458092,'isk',33.333,3),(287,7458103,7458100,'nam',50,1),(287,7458104,7458100,'ame',50,1),(287,7458105,7458103,'typ',50,1),(287,7458106,7458103,'ype',50,1),(287,7458107,7458105,'dir',25,1),(287,7458108,7458105,'ire',25,1),(287,7458109,7458105,'rec',25,1),(287,7458110,7458105,'ect',25,1),(288,7458112,7458111,'naa',100,2),(288,7458113,7458112,'600',3.333,3),(288,7458114,7458112,'00a',3.333,3),(288,7458115,7458112,'0a0',3.333,3),(288,7458116,7458112,'a09',3.333,3),(288,7458117,7458112,'098',3.333,3),(288,7458118,7458112,'980',3.333,3),(288,7458119,7458112,'804',3.333,3),(288,7458120,7458112,'044',3.333,3),(288,7458121,7458112,'443',3.333,3),(288,7458122,7458112,'430',3.333,3),(288,7458123,7458112,'307',3.333,3),(288,7458124,7458112,'072',3.333,3),(288,7458125,7458112,'725',3.333,3),(288,7458126,7458112,'259',3.333,3),(288,7458127,7458112,'593',3.333,3),(288,7458128,7458112,'931',3.333,3),(288,7458129,7458112,'313',3.333,3),(288,7458130,7458112,'13f',3.333,3),(288,7458131,7458112,'3f3',3.333,3),(288,7458132,7458112,'f33',3.333,3),(288,7458133,7458112,'334',3.333,3),(288,7458134,7458112,'345',3.333,3),(288,7458135,7458112,'455',3.333,3),(288,7458136,7458112,'556',3.333,3),(288,7458137,7458112,'563',3.333,3),(288,7458138,7458112,'639',3.333,3),(288,7458139,7458112,'393',3.333,3),(288,7458140,7458112,'934',3.333,3),(288,7458141,7458112,'343',3.333,3),(288,7458142,7458112,'439',3.333,3),(288,7458143,7458113,'mon',100,1),(288,7458144,7458143,'201',50,1),(288,7458145,7458143,'013',50,1),(288,7458146,7458144,'adm',33.333,3),(288,7458147,7458144,'dmi',33.333,3),(288,7458148,7458144,'min',33.333,3),(288,7458149,7458146,'cap',16.667,1),(288,7458150,7458146,'apa',16.667,1),(288,7458151,7458146,'pac',16.667,1),(288,7458152,7458146,'aci',16.667,1),(288,7458153,7458146,'cit',16.667,1),(288,7458154,7458146,'ity',16.667,1),(288,7458155,7458149,'pat',50,1),(288,7458156,7458149,'ath',50,1),(288,7458157,7458155,'fre',14.286,1),(288,7458158,7458155,'ree',14.286,1),(288,7458159,7458155,'ees',14.286,1),(288,7458160,7458155,'esp',14.286,1),(288,7458161,7458155,'spa',14.286,1),(288,7458162,7458155,'pac',14.286,1),(288,7458163,7458155,'ace',14.286,1),(288,7458164,7458157,'dis',50,1),(288,7458165,7458157,'isk',50,1),(288,7458166,7458164,'ind',33.333,1),(288,7458167,7458164,'nde',33.333,1),(288,7458168,7458164,'dex',33.333,1),(288,7458169,7458166,'adm',8.333,1),(288,7458170,7458166,'dmi',8.333,1),(288,7458171,7458166,'min',8.333,1),(288,7458172,7458166,'ini',8.333,1),(288,7458173,7458166,'nis',8.333,1),(288,7458174,7458166,'ist',8.333,1),(288,7458175,7458166,'str',8.333,1),(288,7458176,7458166,'tra',8.333,1),(288,7458177,7458166,'rat',8.333,1),(288,7458178,7458166,'ati',8.333,1),(288,7458179,7458166,'tio',8.333,1),(288,7458180,7458166,'ion',8.333,1),(288,7458181,7458169,'sta',33.333,3),(288,7458182,7458169,'tat',33.333,3),(288,7458183,7458169,'ate',33.333,3),(288,7458184,7458181,'ena',20,2),(288,7458185,7458181,'nab',20,2),(288,7458186,7458181,'abl',20,2),(288,7458187,7458181,'ble',20,2),(288,7458188,7458181,'led',20,2),(288,7458189,7458184,'cac',33.333,1),(288,7458190,7458184,'ach',33.333,1),(288,7458191,7458184,'che',33.333,1),(288,7458192,7458189,'mod',50,2),(288,7458193,7458189,'ode',50,2),(288,7458194,7458192,'wri',14.286,2),(288,7458195,7458192,'rit',14.286,2),(288,7458196,7458192,'ite',14.286,2),(288,7458197,7458192,'tet',14.286,2),(288,7458198,7458192,'eth',14.286,2),(288,7458199,7458192,'thr',14.286,2),(288,7458200,7458192,'hru',14.286,2),(288,7458201,7458194,'ope',11.111,2),(288,7458202,7458194,'per',11.111,2),(288,7458203,7458194,'era',11.111,2),(288,7458204,7458194,'rat',11.111,2),(288,7458205,7458194,'ati',11.111,2),(288,7458206,7458194,'tio',11.111,2),(288,7458207,7458194,'ion',11.111,2),(288,7458208,7458194,'ona',11.111,2),(288,7458209,7458194,'nal',11.111,2),(288,7458210,7458201,'nor',25,1),(288,7458211,7458201,'orm',25,1),(288,7458212,7458201,'rma',25,1),(288,7458213,7458201,'mal',25,1),(288,7458214,7458210,'mes',20,1),(288,7458215,7458210,'ess',20,1),(288,7458216,7458210,'ssa',20,1),(288,7458217,7458210,'sag',20,1),(288,7458218,7458210,'age',20,1),(288,7458219,7458214,'per',11.111,1),(288,7458220,7458214,'erf',11.111,1),(288,7458221,7458214,'rfo',11.111,1),(288,7458222,7458214,'for',11.111,1),(288,7458223,7458214,'orm',11.111,1),(288,7458224,7458214,'rma',11.111,1),(288,7458225,7458214,'man',11.111,1),(288,7458226,7458214,'anc',11.111,1),(288,7458227,7458214,'nce',11.111,1),(288,7458228,7458219,'ide',12.5,1),(288,7458229,7458219,'den',12.5,1),(288,7458230,7458219,'ent',12.5,1),(288,7458231,7458219,'nti',12.5,1),(288,7458232,7458219,'tif',12.5,1),(288,7458233,7458219,'ifi',12.5,1),(288,7458234,7458219,'fie',12.5,1),(288,7458235,7458219,'ier',12.5,1),(288,7458236,7458228,'vdi',33.333,3),(288,7458237,7458228,'dis',33.333,3),(288,7458238,7458228,'isk',33.333,3),(288,7458239,7458236,'nam',50,1),(288,7458240,7458236,'ame',50,1),(288,7458241,7458239,'typ',50,1),(288,7458242,7458239,'ype',50,1),(288,7458243,7458241,'dir',25,1),(288,7458244,7458241,'ire',25,1),(288,7458245,7458241,'rec',25,1),(288,7458246,7458241,'ect',25,1),(289,7458248,7458247,'naa',100,2),(289,7458249,7458248,'600',3.333,3),(289,7458250,7458248,'000',3.333,3),(289,7458251,7458248,'00c',3.333,3),(289,7458252,7458248,'0c2',3.333,3),(289,7458253,7458248,'c29',3.333,3),(289,7458254,7458248,'29d',3.333,3),(289,7458255,7458248,'9dd',3.333,3),(289,7458256,7458248,'dd1',3.333,3),(289,7458257,7458248,'d17',3.333,3),(289,7458258,7458248,'17f',3.333,3),(289,7458259,7458248,'7f5',3.333,3),(289,7458260,7458248,'f56',3.333,3),(289,7458261,7458248,'56e',3.333,3),(289,7458262,7458248,'6e3',3.333,3),(289,7458263,7458248,'e30',3.333,3),(289,7458264,7458248,'30f',3.333,3),(289,7458265,7458248,'0f1',3.333,3),(289,7458266,7458248,'f12',3.333,3),(289,7458267,7458248,'12a',3.333,3),(289,7458268,7458248,'2a8',3.333,3),(289,7458269,7458248,'a86',3.333,3),(289,7458270,7458248,'86a',3.333,3),(289,7458271,7458248,'6aa',3.333,3),(289,7458272,7458248,'aa0',3.333,3),(289,7458273,7458248,'a07',3.333,3),(289,7458274,7458248,'07e',3.333,3),(289,7458275,7458248,'7ef',3.333,3),(289,7458276,7458248,'ef6',3.333,3),(289,7458277,7458248,'f6d',3.333,3),(289,7458278,7458248,'6da',3.333,3),(289,7458279,7458249,'mon',100,1),(289,7458280,7458279,'201',50,1),(289,7458281,7458279,'013',50,1),(289,7458282,7458280,'adm',33.333,3),(289,7458283,7458280,'dmi',33.333,3),(289,7458284,7458280,'min',33.333,3),(289,7458285,7458282,'cap',16.667,1),(289,7458286,7458282,'apa',16.667,1),(289,7458287,7458282,'pac',16.667,1),(289,7458288,7458282,'aci',16.667,1),(289,7458289,7458282,'cit',16.667,1),(289,7458290,7458282,'ity',16.667,1),(289,7458291,7458285,'pat',50,1),(289,7458292,7458285,'ath',50,1),(289,7458293,7458291,'fre',14.286,1),(289,7458294,7458291,'ree',14.286,1),(289,7458295,7458291,'ees',14.286,1),(289,7458296,7458291,'esp',14.286,1),(289,7458297,7458291,'spa',14.286,1),(289,7458298,7458291,'pac',14.286,1),(289,7458299,7458291,'ace',14.286,1),(289,7458300,7458293,'dis',50,1),(289,7458301,7458293,'isk',50,1),(289,7458302,7458300,'ind',33.333,1),(289,7458303,7458300,'nde',33.333,1),(289,7458304,7458300,'dex',33.333,1),(289,7458305,7458302,'adm',8.333,1),(289,7458306,7458302,'dmi',8.333,1),(289,7458307,7458302,'min',8.333,1),(289,7458308,7458302,'ini',8.333,1),(289,7458309,7458302,'nis',8.333,1),(289,7458310,7458302,'ist',8.333,1),(289,7458311,7458302,'str',8.333,1),(289,7458312,7458302,'tra',8.333,1),(289,7458313,7458302,'rat',8.333,1),(289,7458314,7458302,'ati',8.333,1),(289,7458315,7458302,'tio',8.333,1),(289,7458316,7458302,'ion',8.333,1),(289,7458317,7458305,'sta',33.333,3),(289,7458318,7458305,'tat',33.333,3),(289,7458319,7458305,'ate',33.333,3),(289,7458320,7458317,'ena',20,2),(289,7458321,7458317,'nab',20,2),(289,7458322,7458317,'abl',20,2),(289,7458323,7458317,'ble',20,2),(289,7458324,7458317,'led',20,2),(289,7458325,7458320,'cac',33.333,1),(289,7458326,7458320,'ach',33.333,1),(289,7458327,7458320,'che',33.333,1),(289,7458328,7458325,'mod',50,2),(289,7458329,7458325,'ode',50,2),(289,7458330,7458328,'wri',14.286,2),(289,7458331,7458328,'rit',14.286,2),(289,7458332,7458328,'ite',14.286,2),(289,7458333,7458328,'tet',14.286,2),(289,7458334,7458328,'eth',14.286,2),(289,7458335,7458328,'thr',14.286,2),(289,7458336,7458328,'hru',14.286,2),(289,7458337,7458330,'ope',11.111,2),(289,7458338,7458330,'per',11.111,2),(289,7458339,7458330,'era',11.111,2),(289,7458340,7458330,'rat',11.111,2),(289,7458341,7458330,'ati',11.111,2),(289,7458342,7458330,'tio',11.111,2),(289,7458343,7458330,'ion',11.111,2),(289,7458344,7458330,'ona',11.111,2),(289,7458345,7458330,'nal',11.111,2),(289,7458346,7458337,'nor',25,1),(289,7458347,7458337,'orm',25,1),(289,7458348,7458337,'rma',25,1),(289,7458349,7458337,'mal',25,1),(289,7458350,7458346,'mes',20,1),(289,7458351,7458346,'ess',20,1),(289,7458352,7458346,'ssa',20,1),(289,7458353,7458346,'sag',20,1),(289,7458354,7458346,'age',20,1),(289,7458355,7458350,'per',11.111,1),(289,7458356,7458350,'erf',11.111,1),(289,7458357,7458350,'rfo',11.111,1),(289,7458358,7458350,'for',11.111,1),(289,7458359,7458350,'orm',11.111,1),(289,7458360,7458350,'rma',11.111,1),(289,7458361,7458350,'man',11.111,1),(289,7458362,7458350,'anc',11.111,1),(289,7458363,7458350,'nce',11.111,1),(289,7458364,7458355,'ide',12.5,1),(289,7458365,7458355,'den',12.5,1),(289,7458366,7458355,'ent',12.5,1),(289,7458367,7458355,'nti',12.5,1),(289,7458368,7458355,'tif',12.5,1),(289,7458369,7458355,'ifi',12.5,1),(289,7458370,7458355,'fie',12.5,1),(289,7458371,7458355,'ier',12.5,1),(289,7458372,7458364,'vdi',33.333,3),(289,7458373,7458364,'dis',33.333,3),(289,7458374,7458364,'isk',33.333,3),(289,7458375,7458372,'nam',50,1),(289,7458376,7458372,'ame',50,1),(289,7458377,7458375,'typ',50,1),(289,7458378,7458375,'ype',50,1),(289,7458379,7458377,'dir',25,1),(289,7458380,7458377,'ire',25,1),(289,7458381,7458377,'rec',25,1),(289,7458382,7458377,'ect',25,1),(290,7458384,7458383,'naa',100,2),(290,7458385,7458384,'600',3.333,3),(290,7458386,7458384,'000',3.333,3),(290,7458387,7458384,'00c',3.333,3),(290,7458388,7458384,'0c2',3.333,3),(290,7458389,7458384,'c29',3.333,3),(290,7458390,7458384,'29e',3.333,3),(290,7458391,7458384,'9e3',3.333,3),(290,7458392,7458384,'e33',3.333,3),(290,7458393,7458384,'337',3.333,3),(290,7458394,7458384,'371',3.333,3),(290,7458395,7458384,'71e',3.333,3),(290,7458396,7458384,'1e5',3.333,3),(290,7458397,7458384,'e54',3.333,3),(290,7458398,7458384,'54a',3.333,3),(290,7458399,7458384,'4aa',3.333,3),(290,7458400,7458384,'aa5',3.333,3),(290,7458401,7458384,'a56',3.333,3),(290,7458402,7458384,'56b',3.333,3),(290,7458403,7458384,'6bb',3.333,3),(290,7458404,7458384,'bb0',3.333,3),(290,7458405,7458384,'b09',3.333,3),(290,7458406,7458384,'097',3.333,3),(290,7458407,7458384,'971',3.333,3),(290,7458408,7458384,'710',3.333,3),(290,7458409,7458384,'103',3.333,3),(290,7458410,7458384,'032',3.333,3),(290,7458411,7458384,'32e',3.333,3),(290,7458412,7458384,'2e0',3.333,3),(290,7458413,7458384,'e08',3.333,3),(290,7458414,7458384,'089',3.333,3),(290,7458415,7458385,'mon',100,1),(290,7458416,7458415,'201',50,1),(290,7458417,7458415,'013',50,1),(290,7458418,7458416,'adm',33.333,3),(290,7458419,7458416,'dmi',33.333,3),(290,7458420,7458416,'min',33.333,3),(290,7458421,7458418,'cap',16.667,1),(290,7458422,7458418,'apa',16.667,1),(290,7458423,7458418,'pac',16.667,1),(290,7458424,7458418,'aci',16.667,1),(290,7458425,7458418,'cit',16.667,1),(290,7458426,7458418,'ity',16.667,1),(290,7458427,7458421,'pat',50,1),(290,7458428,7458421,'ath',50,1),(290,7458429,7458427,'fre',14.286,1),(290,7458430,7458427,'ree',14.286,1),(290,7458431,7458427,'ees',14.286,1),(290,7458432,7458427,'esp',14.286,1),(290,7458433,7458427,'spa',14.286,1),(290,7458434,7458427,'pac',14.286,1),(290,7458435,7458427,'ace',14.286,1),(290,7458436,7458429,'dis',50,1),(290,7458437,7458429,'isk',50,1),(290,7458438,7458436,'ind',33.333,1),(290,7458439,7458436,'nde',33.333,1),(290,7458440,7458436,'dex',33.333,1),(290,7458441,7458438,'adm',8.333,1),(290,7458442,7458438,'dmi',8.333,1),(290,7458443,7458438,'min',8.333,1),(290,7458444,7458438,'ini',8.333,1),(290,7458445,7458438,'nis',8.333,1),(290,7458446,7458438,'ist',8.333,1),(290,7458447,7458438,'str',8.333,1),(290,7458448,7458438,'tra',8.333,1),(290,7458449,7458438,'rat',8.333,1),(290,7458450,7458438,'ati',8.333,1),(290,7458451,7458438,'tio',8.333,1),(290,7458452,7458438,'ion',8.333,1),(290,7458453,7458441,'sta',33.333,3),(290,7458454,7458441,'tat',33.333,3),(290,7458455,7458441,'ate',33.333,3),(290,7458456,7458453,'ena',20,2),(290,7458457,7458453,'nab',20,2),(290,7458458,7458453,'abl',20,2),(290,7458459,7458453,'ble',20,2),(290,7458460,7458453,'led',20,2),(290,7458461,7458456,'cac',33.333,1),(290,7458462,7458456,'ach',33.333,1),(290,7458463,7458456,'che',33.333,1),(290,7458464,7458461,'mod',50,2),(290,7458465,7458461,'ode',50,2),(290,7458466,7458464,'wri',14.286,2),(290,7458467,7458464,'rit',14.286,2),(290,7458468,7458464,'ite',14.286,2),(290,7458469,7458464,'tet',14.286,2),(290,7458470,7458464,'eth',14.286,2),(290,7458471,7458464,'thr',14.286,2),(290,7458472,7458464,'hru',14.286,2),(290,7458473,7458466,'ope',11.111,2),(290,7458474,7458466,'per',11.111,2),(290,7458475,7458466,'era',11.111,2),(290,7458476,7458466,'rat',11.111,2),(290,7458477,7458466,'ati',11.111,2),(290,7458478,7458466,'tio',11.111,2),(290,7458479,7458466,'ion',11.111,2),(290,7458480,7458466,'ona',11.111,2),(290,7458481,7458466,'nal',11.111,2),(290,7458482,7458473,'nor',25,1),(290,7458483,7458473,'orm',25,1),(290,7458484,7458473,'rma',25,1),(290,7458485,7458473,'mal',25,1),(290,7458486,7458482,'mes',20,1),(290,7458487,7458482,'ess',20,1),(290,7458488,7458482,'ssa',20,1),(290,7458489,7458482,'sag',20,1),(290,7458490,7458482,'age',20,1),(290,7458491,7458486,'per',11.111,1),(290,7458492,7458486,'erf',11.111,1),(290,7458493,7458486,'rfo',11.111,1),(290,7458494,7458486,'for',11.111,1),(290,7458495,7458486,'orm',11.111,1),(290,7458496,7458486,'rma',11.111,1),(290,7458497,7458486,'man',11.111,1),(290,7458498,7458486,'anc',11.111,1),(290,7458499,7458486,'nce',11.111,1),(290,7458500,7458491,'ide',12.5,1),(290,7458501,7458491,'den',12.5,1),(290,7458502,7458491,'ent',12.5,1),(290,7458503,7458491,'nti',12.5,1),(290,7458504,7458491,'tif',12.5,1),(290,7458505,7458491,'ifi',12.5,1),(290,7458506,7458491,'fie',12.5,1),(290,7458507,7458491,'ier',12.5,1),(290,7458508,7458500,'vdi',33.333,3),(290,7458509,7458500,'dis',33.333,3),(290,7458510,7458500,'isk',33.333,3),(290,7458511,7458508,'nam',50,1),(290,7458512,7458508,'ame',50,1),(290,7458513,7458511,'typ',50,1),(290,7458514,7458511,'ype',50,1),(290,7458515,7458513,'dir',25,1),(290,7458516,7458513,'ire',25,1),(290,7458517,7458513,'rec',25,1),(290,7458518,7458513,'ect',25,1),(291,7458520,7458519,'naa',100,2),(291,7458521,7458520,'600',3.333,3),(291,7458522,7458520,'000',3.333,3),(291,7458523,7458520,'00c',3.333,3),(291,7458524,7458520,'0c2',3.333,3),(291,7458525,7458520,'c29',3.333,3),(291,7458526,7458520,'29e',3.333,3),(291,7458527,7458520,'9e3',3.333,3),(291,7458528,7458520,'e35',3.333,3),(291,7458529,7458520,'353',3.333,3),(291,7458530,7458520,'53d',3.333,3),(291,7458531,7458520,'3d1',3.333,3),(291,7458532,7458520,'d1d',3.333,3),(291,7458533,7458520,'1df',3.333,3),(291,7458534,7458520,'df4',3.333,3),(291,7458535,7458520,'f47',3.333,3),(291,7458536,7458520,'472',3.333,3),(291,7458537,7458520,'72e',3.333,3),(291,7458538,7458520,'2e2',3.333,3),(291,7458539,7458520,'e29',3.333,3),(291,7458540,7458520,'290',3.333,3),(291,7458541,7458520,'908',3.333,3),(291,7458542,7458520,'083',3.333,3),(291,7458543,7458520,'83d',3.333,3),(291,7458544,7458520,'3d0',3.333,3),(291,7458545,7458520,'d0d',3.333,3),(291,7458546,7458520,'0de',3.333,3),(291,7458547,7458520,'de0',3.333,3),(291,7458548,7458520,'e00',3.333,3),(291,7458549,7458520,'007',3.333,3),(291,7458550,7458520,'077',3.333,3),(291,7458551,7458521,'mon',100,1),(291,7458552,7458551,'201',50,1),(291,7458553,7458551,'013',50,1),(291,7458554,7458552,'adm',33.333,3),(291,7458555,7458552,'dmi',33.333,3),(291,7458556,7458552,'min',33.333,3),(291,7458557,7458554,'cap',16.667,1),(291,7458558,7458554,'apa',16.667,1),(291,7458559,7458554,'pac',16.667,1),(291,7458560,7458554,'aci',16.667,1),(291,7458561,7458554,'cit',16.667,1),(291,7458562,7458554,'ity',16.667,1),(291,7458563,7458557,'pat',50,1),(291,7458564,7458557,'ath',50,1),(291,7458565,7458563,'fre',14.286,1),(291,7458566,7458563,'ree',14.286,1),(291,7458567,7458563,'ees',14.286,1),(291,7458568,7458563,'esp',14.286,1),(291,7458569,7458563,'spa',14.286,1),(291,7458570,7458563,'pac',14.286,1),(291,7458571,7458563,'ace',14.286,1),(291,7458572,7458565,'dis',50,1),(291,7458573,7458565,'isk',50,1),(291,7458574,7458572,'ind',33.333,1),(291,7458575,7458572,'nde',33.333,1),(291,7458576,7458572,'dex',33.333,1),(291,7458577,7458574,'adm',8.333,1),(291,7458578,7458574,'dmi',8.333,1),(291,7458579,7458574,'min',8.333,1),(291,7458580,7458574,'ini',8.333,1),(291,7458581,7458574,'nis',8.333,1),(291,7458582,7458574,'ist',8.333,1),(291,7458583,7458574,'str',8.333,1),(291,7458584,7458574,'tra',8.333,1),(291,7458585,7458574,'rat',8.333,1),(291,7458586,7458574,'ati',8.333,1),(291,7458587,7458574,'tio',8.333,1),(291,7458588,7458574,'ion',8.333,1),(291,7458589,7458577,'sta',33.333,3),(291,7458590,7458577,'tat',33.333,3),(291,7458591,7458577,'ate',33.333,3),(291,7458592,7458589,'ena',20,2),(291,7458593,7458589,'nab',20,2),(291,7458594,7458589,'abl',20,2),(291,7458595,7458589,'ble',20,2),(291,7458596,7458589,'led',20,2),(291,7458597,7458592,'cac',33.333,1),(291,7458598,7458592,'ach',33.333,1),(291,7458599,7458592,'che',33.333,1),(291,7458600,7458597,'mod',50,2),(291,7458601,7458597,'ode',50,2),(291,7458602,7458600,'wri',14.286,2),(291,7458603,7458600,'rit',14.286,2),(291,7458604,7458600,'ite',14.286,2),(291,7458605,7458600,'tet',14.286,2),(291,7458606,7458600,'eth',14.286,2),(291,7458607,7458600,'thr',14.286,2),(291,7458608,7458600,'hru',14.286,2),(291,7458609,7458602,'ope',11.111,2),(291,7458610,7458602,'per',11.111,2),(291,7458611,7458602,'era',11.111,2),(291,7458612,7458602,'rat',11.111,2),(291,7458613,7458602,'ati',11.111,2),(291,7458614,7458602,'tio',11.111,2),(291,7458615,7458602,'ion',11.111,2),(291,7458616,7458602,'ona',11.111,2),(291,7458617,7458602,'nal',11.111,2),(291,7458618,7458609,'nor',25,1),(291,7458619,7458609,'orm',25,1),(291,7458620,7458609,'rma',25,1),(291,7458621,7458609,'mal',25,1),(291,7458622,7458618,'mes',20,1),(291,7458623,7458618,'ess',20,1),(291,7458624,7458618,'ssa',20,1),(291,7458625,7458618,'sag',20,1),(291,7458626,7458618,'age',20,1),(291,7458627,7458622,'per',11.111,1),(291,7458628,7458622,'erf',11.111,1),(291,7458629,7458622,'rfo',11.111,1),(291,7458630,7458622,'for',11.111,1),(291,7458631,7458622,'orm',11.111,1),(291,7458632,7458622,'rma',11.111,1),(291,7458633,7458622,'man',11.111,1),(291,7458634,7458622,'anc',11.111,1),(291,7458635,7458622,'nce',11.111,1),(291,7458636,7458627,'ide',12.5,1),(291,7458637,7458627,'den',12.5,1),(291,7458638,7458627,'ent',12.5,1),(291,7458639,7458627,'nti',12.5,1),(291,7458640,7458627,'tif',12.5,1),(291,7458641,7458627,'ifi',12.5,1),(291,7458642,7458627,'fie',12.5,1),(291,7458643,7458627,'ier',12.5,1),(291,7458644,7458636,'vdi',33.333,3),(291,7458645,7458636,'dis',33.333,3),(291,7458646,7458636,'isk',33.333,3),(291,7458647,7458644,'nam',50,1),(291,7458648,7458644,'ame',50,1),(291,7458649,7458647,'typ',50,1),(291,7458650,7458647,'ype',50,1),(291,7458651,7458649,'dir',25,1),(291,7458652,7458649,'ire',25,1),(291,7458653,7458649,'rec',25,1),(291,7458654,7458649,'ect',25,1),(292,7458656,7458655,'naa',100,2),(292,7458657,7458656,'600',3.333,3),(292,7458658,7458656,'000',3.333,3),(292,7458659,7458656,'00c',3.333,3),(292,7458660,7458656,'0c2',3.333,3),(292,7458661,7458656,'c29',3.333,3),(292,7458662,7458656,'296',3.333,3),(292,7458663,7458656,'960',3.333,3),(292,7458664,7458656,'60b',3.333,3),(292,7458665,7458656,'0b0',3.333,3),(292,7458666,7458656,'b02',3.333,3),(292,7458667,7458656,'02c',3.333,3),(292,7458668,7458656,'2c3',3.333,3),(292,7458669,7458656,'c3a',3.333,3),(292,7458670,7458656,'3a9',3.333,3),(292,7458671,7458656,'a9e',3.333,3),(292,7458672,7458656,'9e5',3.333,3),(292,7458673,7458656,'e54',3.333,3),(292,7458674,7458656,'54e',3.333,3),(292,7458675,7458656,'4ed',3.333,3),(292,7458676,7458656,'eda',3.333,3),(292,7458677,7458656,'da5',3.333,3),(292,7458678,7458656,'a5f',3.333,3),(292,7458679,7458656,'5f3',3.333,3),(292,7458680,7458656,'f39',3.333,3),(292,7458681,7458656,'394',3.333,3),(292,7458682,7458656,'94a',3.333,3),(292,7458683,7458656,'4a8',3.333,3),(292,7458684,7458656,'a83',3.333,3),(292,7458685,7458656,'838',3.333,3),(292,7458686,7458656,'38a',3.333,3),(292,7458687,7458657,'mon',100,1),(292,7458688,7458687,'201',50,1),(292,7458689,7458687,'013',50,1),(292,7458690,7458688,'adm',33.333,3),(292,7458691,7458688,'dmi',33.333,3),(292,7458692,7458688,'min',33.333,3),(292,7458693,7458690,'cap',16.667,1),(292,7458694,7458690,'apa',16.667,1),(292,7458695,7458690,'pac',16.667,1),(292,7458696,7458690,'aci',16.667,1),(292,7458697,7458690,'cit',16.667,1),(292,7458698,7458690,'ity',16.667,1),(292,7458699,7458693,'pat',50,1),(292,7458700,7458693,'ath',50,1),(292,7458701,7458699,'fre',14.286,1),(292,7458702,7458699,'ree',14.286,1),(292,7458703,7458699,'ees',14.286,1),(292,7458704,7458699,'esp',14.286,1),(292,7458705,7458699,'spa',14.286,1),(292,7458706,7458699,'pac',14.286,1),(292,7458707,7458699,'ace',14.286,1),(292,7458708,7458701,'dis',50,1),(292,7458709,7458701,'isk',50,1),(292,7458710,7458708,'ind',33.333,1),(292,7458711,7458708,'nde',33.333,1),(292,7458712,7458708,'dex',33.333,1),(292,7458713,7458710,'adm',8.333,1),(292,7458714,7458710,'dmi',8.333,1),(292,7458715,7458710,'min',8.333,1),(292,7458716,7458710,'ini',8.333,1),(292,7458717,7458710,'nis',8.333,1),(292,7458718,7458710,'ist',8.333,1),(292,7458719,7458710,'str',8.333,1),(292,7458720,7458710,'tra',8.333,1),(292,7458721,7458710,'rat',8.333,1),(292,7458722,7458710,'ati',8.333,1),(292,7458723,7458710,'tio',8.333,1),(292,7458724,7458710,'ion',8.333,1),(292,7458725,7458713,'sta',33.333,3),(292,7458726,7458713,'tat',33.333,3),(292,7458727,7458713,'ate',33.333,3),(292,7458728,7458725,'ena',20,2),(292,7458729,7458725,'nab',20,2),(292,7458730,7458725,'abl',20,2),(292,7458731,7458725,'ble',20,2),(292,7458732,7458725,'led',20,2),(292,7458733,7458728,'cac',33.333,1),(292,7458734,7458728,'ach',33.333,1),(292,7458735,7458728,'che',33.333,1),(292,7458736,7458733,'mod',50,2),(292,7458737,7458733,'ode',50,2),(292,7458738,7458736,'wri',14.286,2),(292,7458739,7458736,'rit',14.286,2),(292,7458740,7458736,'ite',14.286,2),(292,7458741,7458736,'tet',14.286,2),(292,7458742,7458736,'eth',14.286,2),(292,7458743,7458736,'thr',14.286,2),(292,7458744,7458736,'hru',14.286,2),(292,7458745,7458738,'ope',11.111,2),(292,7458746,7458738,'per',11.111,2),(292,7458747,7458738,'era',11.111,2),(292,7458748,7458738,'rat',11.111,2),(292,7458749,7458738,'ati',11.111,2),(292,7458750,7458738,'tio',11.111,2),(292,7458751,7458738,'ion',11.111,2),(292,7458752,7458738,'ona',11.111,2),(292,7458753,7458738,'nal',11.111,2),(292,7458754,7458745,'nor',25,1),(292,7458755,7458745,'orm',25,1),(292,7458756,7458745,'rma',25,1),(292,7458757,7458745,'mal',25,1),(292,7458758,7458754,'mes',20,1),(292,7458759,7458754,'ess',20,1),(292,7458760,7458754,'ssa',20,1),(292,7458761,7458754,'sag',20,1),(292,7458762,7458754,'age',20,1),(292,7458763,7458758,'per',11.111,1),(292,7458764,7458758,'erf',11.111,1),(292,7458765,7458758,'rfo',11.111,1),(292,7458766,7458758,'for',11.111,1),(292,7458767,7458758,'orm',11.111,1),(292,7458768,7458758,'rma',11.111,1),(292,7458769,7458758,'man',11.111,1),(292,7458770,7458758,'anc',11.111,1),(292,7458771,7458758,'nce',11.111,1),(292,7458772,7458763,'ide',12.5,1),(292,7458773,7458763,'den',12.5,1),(292,7458774,7458763,'ent',12.5,1),(292,7458775,7458763,'nti',12.5,1),(292,7458776,7458763,'tif',12.5,1),(292,7458777,7458763,'ifi',12.5,1),(292,7458778,7458763,'fie',12.5,1),(292,7458779,7458763,'ier',12.5,1),(292,7458780,7458772,'vdi',33.333,3),(292,7458781,7458772,'dis',33.333,3),(292,7458782,7458772,'isk',33.333,3),(292,7458783,7458780,'nam',50,1),(292,7458784,7458780,'ame',50,1),(292,7458785,7458783,'typ',50,1),(292,7458786,7458783,'ype',50,1),(292,7458787,7458785,'dir',25,1),(292,7458788,7458785,'ire',25,1),(292,7458789,7458785,'rec',25,1),(292,7458790,7458785,'ect',25,1),(293,7458792,7458791,'naa',100,2),(293,7458793,7458792,'600',3.333,3),(293,7458794,7458792,'000',3.333,3),(293,7458795,7458792,'00c',3.333,3),(293,7458796,7458792,'0c2',3.333,3),(293,7458797,7458792,'c29',3.333,3),(293,7458798,7458792,'298',3.333,3),(293,7458799,7458792,'989',3.333,3),(293,7458800,7458792,'891',3.333,3),(293,7458801,7458792,'91c',3.333,3),(293,7458802,7458792,'1c7',3.333,3),(293,7458803,7458792,'c7b',3.333,3),(293,7458804,7458792,'7bf',3.333,3),(293,7458805,7458792,'bfb',3.333,3),(293,7458806,7458792,'fbf',3.333,3),(293,7458807,7458792,'bf1',3.333,3),(293,7458808,7458792,'f1d',3.333,3),(293,7458809,7458792,'1d5',3.333,3),(293,7458810,7458792,'d5b',3.333,3),(293,7458811,7458792,'5b5',3.333,3),(293,7458812,7458792,'b50',3.333,3),(293,7458813,7458792,'509',3.333,3),(293,7458814,7458792,'094',3.333,3),(293,7458815,7458792,'941',3.333,3),(293,7458816,7458792,'415',3.333,3),(293,7458817,7458792,'15e',3.333,3),(293,7458818,7458792,'5e5',3.333,3),(293,7458819,7458792,'e5e',3.333,3),(293,7458820,7458792,'5e8',3.333,3),(293,7458821,7458792,'e8e',3.333,3),(293,7458822,7458792,'8e9',3.333,3),(293,7458823,7458793,'mon',100,1),(293,7458824,7458823,'201',50,1),(293,7458825,7458823,'013',50,1),(293,7458826,7458824,'adm',33.333,3),(293,7458827,7458824,'dmi',33.333,3),(293,7458828,7458824,'min',33.333,3),(293,7458829,7458826,'cap',16.667,1),(293,7458830,7458826,'apa',16.667,1),(293,7458831,7458826,'pac',16.667,1),(293,7458832,7458826,'aci',16.667,1),(293,7458833,7458826,'cit',16.667,1),(293,7458834,7458826,'ity',16.667,1),(293,7458835,7458829,'pat',50,1),(293,7458836,7458829,'ath',50,1),(293,7458837,7458835,'fre',14.286,1),(293,7458838,7458835,'ree',14.286,1),(293,7458839,7458835,'ees',14.286,1),(293,7458840,7458835,'esp',14.286,1),(293,7458841,7458835,'spa',14.286,1),(293,7458842,7458835,'pac',14.286,1),(293,7458843,7458835,'ace',14.286,1),(293,7458844,7458837,'dis',50,1),(293,7458845,7458837,'isk',50,1),(293,7458846,7458844,'ind',33.333,1),(293,7458847,7458844,'nde',33.333,1),(293,7458848,7458844,'dex',33.333,1),(293,7458849,7458846,'adm',8.333,1),(293,7458850,7458846,'dmi',8.333,1),(293,7458851,7458846,'min',8.333,1),(293,7458852,7458846,'ini',8.333,1),(293,7458853,7458846,'nis',8.333,1),(293,7458854,7458846,'ist',8.333,1),(293,7458855,7458846,'str',8.333,1),(293,7458856,7458846,'tra',8.333,1),(293,7458857,7458846,'rat',8.333,1),(293,7458858,7458846,'ati',8.333,1),(293,7458859,7458846,'tio',8.333,1),(293,7458860,7458846,'ion',8.333,1),(293,7458861,7458849,'sta',33.333,3),(293,7458862,7458849,'tat',33.333,3),(293,7458863,7458849,'ate',33.333,3),(293,7458864,7458861,'ena',20,2),(293,7458865,7458861,'nab',20,2),(293,7458866,7458861,'abl',20,2),(293,7458867,7458861,'ble',20,2),(293,7458868,7458861,'led',20,2),(293,7458869,7458864,'cac',33.333,1),(293,7458870,7458864,'ach',33.333,1),(293,7458871,7458864,'che',33.333,1),(293,7458872,7458869,'mod',50,2),(293,7458873,7458869,'ode',50,2),(293,7458874,7458872,'wri',14.286,2),(293,7458875,7458872,'rit',14.286,2),(293,7458876,7458872,'ite',14.286,2),(293,7458877,7458872,'tet',14.286,2),(293,7458878,7458872,'eth',14.286,2),(293,7458879,7458872,'thr',14.286,2),(293,7458880,7458872,'hru',14.286,2),(293,7458881,7458874,'ope',11.111,2),(293,7458882,7458874,'per',11.111,2),(293,7458883,7458874,'era',11.111,2),(293,7458884,7458874,'rat',11.111,2),(293,7458885,7458874,'ati',11.111,2),(293,7458886,7458874,'tio',11.111,2),(293,7458887,7458874,'ion',11.111,2),(293,7458888,7458874,'ona',11.111,2),(293,7458889,7458874,'nal',11.111,2),(293,7458890,7458881,'nor',25,1),(293,7458891,7458881,'orm',25,1),(293,7458892,7458881,'rma',25,1),(293,7458893,7458881,'mal',25,1),(293,7458894,7458890,'mes',20,1),(293,7458895,7458890,'ess',20,1),(293,7458896,7458890,'ssa',20,1),(293,7458897,7458890,'sag',20,1),(293,7458898,7458890,'age',20,1),(293,7458899,7458894,'per',11.111,1),(293,7458900,7458894,'erf',11.111,1),(293,7458901,7458894,'rfo',11.111,1),(293,7458902,7458894,'for',11.111,1),(293,7458903,7458894,'orm',11.111,1),(293,7458904,7458894,'rma',11.111,1),(293,7458905,7458894,'man',11.111,1),(293,7458906,7458894,'anc',11.111,1),(293,7458907,7458894,'nce',11.111,1),(293,7458908,7458899,'ide',12.5,1),(293,7458909,7458899,'den',12.5,1),(293,7458910,7458899,'ent',12.5,1),(293,7458911,7458899,'nti',12.5,1),(293,7458912,7458899,'tif',12.5,1),(293,7458913,7458899,'ifi',12.5,1),(293,7458914,7458899,'fie',12.5,1),(293,7458915,7458899,'ier',12.5,1),(293,7458916,7458908,'vdi',33.333,3),(293,7458917,7458908,'dis',33.333,3),(293,7458918,7458908,'isk',33.333,3),(293,7458919,7458916,'nam',50,1),(293,7458920,7458916,'ame',50,1),(293,7458921,7458919,'typ',50,1),(293,7458922,7458919,'ype',50,1),(293,7458923,7458921,'dir',25,1),(293,7458924,7458921,'ire',25,1),(293,7458925,7458921,'rec',25,1),(293,7458926,7458921,'ect',25,1),(294,7458928,7458927,'naa',100,2),(294,7458929,7458928,'600',3.333,3),(294,7458930,7458928,'000',3.333,3),(294,7458931,7458928,'00c',3.333,3),(294,7458932,7458928,'0c2',3.333,3),(294,7458933,7458928,'c29',3.333,3),(294,7458934,7458928,'291',3.333,3),(294,7458935,7458928,'917',3.333,3),(294,7458936,7458928,'173',3.333,3),(294,7458937,7458928,'737',3.333,3),(294,7458938,7458928,'37b',3.333,3),(294,7458939,7458928,'7bb',3.333,3),(294,7458940,7458928,'bb4',3.333,3),(294,7458941,7458928,'b4c',3.333,3),(294,7458942,7458928,'4cb',3.333,3),(294,7458943,7458928,'cb6',3.333,3),(294,7458944,7458928,'b6f',3.333,3),(294,7458945,7458928,'6f8',3.333,3),(294,7458946,7458928,'f8e',3.333,3),(294,7458947,7458928,'8e9',3.333,3),(294,7458948,7458928,'e9f',3.333,3),(294,7458949,7458928,'9f8',3.333,3),(294,7458950,7458928,'f8e',3.333,3),(294,7458951,7458928,'8eb',3.333,3),(294,7458952,7458928,'eb5',3.333,3),(294,7458953,7458928,'b55',3.333,3),(294,7458954,7458928,'55f',3.333,3),(294,7458955,7458928,'5ff',3.333,3),(294,7458956,7458928,'ff3',3.333,3),(294,7458957,7458928,'f3f',3.333,3),(294,7458958,7458928,'3fe',3.333,3),(294,7458959,7458929,'mon',100,1),(294,7458960,7458959,'201',50,1),(294,7458961,7458959,'013',50,1),(294,7458962,7458960,'adm',33.333,3),(294,7458963,7458960,'dmi',33.333,3),(294,7458964,7458960,'min',33.333,3),(294,7458965,7458962,'cap',16.667,1),(294,7458966,7458962,'apa',16.667,1),(294,7458967,7458962,'pac',16.667,1),(294,7458968,7458962,'aci',16.667,1),(294,7458969,7458962,'cit',16.667,1),(294,7458970,7458962,'ity',16.667,1),(294,7458971,7458965,'pat',50,1),(294,7458972,7458965,'ath',50,1),(294,7458973,7458971,'fre',14.286,1),(294,7458974,7458971,'ree',14.286,1),(294,7458975,7458971,'ees',14.286,1),(294,7458976,7458971,'esp',14.286,1),(294,7458977,7458971,'spa',14.286,1),(294,7458978,7458971,'pac',14.286,1),(294,7458979,7458971,'ace',14.286,1),(294,7458980,7458973,'dis',50,1),(294,7458981,7458973,'isk',50,1),(294,7458982,7458980,'ind',33.333,1),(294,7458983,7458980,'nde',33.333,1),(294,7458984,7458980,'dex',33.333,1),(294,7458985,7458982,'adm',8.333,1),(294,7458986,7458982,'dmi',8.333,1),(294,7458987,7458982,'min',8.333,1),(294,7458988,7458982,'ini',8.333,1),(294,7458989,7458982,'nis',8.333,1),(294,7458990,7458982,'ist',8.333,1),(294,7458991,7458982,'str',8.333,1),(294,7458992,7458982,'tra',8.333,1),(294,7458993,7458982,'rat',8.333,1),(294,7458994,7458982,'ati',8.333,1),(294,7458995,7458982,'tio',8.333,1),(294,7458996,7458982,'ion',8.333,1),(294,7458997,7458985,'sta',33.333,3),(294,7458998,7458985,'tat',33.333,3),(294,7458999,7458985,'ate',33.333,3),(294,7459000,7458997,'ena',20,2),(294,7459001,7458997,'nab',20,2),(294,7459002,7458997,'abl',20,2),(294,7459003,7458997,'ble',20,2),(294,7459004,7458997,'led',20,2),(294,7459005,7459000,'cac',33.333,1),(294,7459006,7459000,'ach',33.333,1),(294,7459007,7459000,'che',33.333,1),(294,7459008,7459005,'mod',50,2),(294,7459009,7459005,'ode',50,2),(294,7459010,7459008,'wri',14.286,2),(294,7459011,7459008,'rit',14.286,2),(294,7459012,7459008,'ite',14.286,2),(294,7459013,7459008,'tet',14.286,2),(294,7459014,7459008,'eth',14.286,2),(294,7459015,7459008,'thr',14.286,2),(294,7459016,7459008,'hru',14.286,2),(294,7459017,7459010,'ope',11.111,2),(294,7459018,7459010,'per',11.111,2),(294,7459019,7459010,'era',11.111,2),(294,7459020,7459010,'rat',11.111,2),(294,7459021,7459010,'ati',11.111,2),(294,7459022,7459010,'tio',11.111,2),(294,7459023,7459010,'ion',11.111,2),(294,7459024,7459010,'ona',11.111,2),(294,7459025,7459010,'nal',11.111,2),(294,7459026,7459017,'nor',25,1),(294,7459027,7459017,'orm',25,1),(294,7459028,7459017,'rma',25,1),(294,7459029,7459017,'mal',25,1),(294,7459030,7459026,'mes',20,1),(294,7459031,7459026,'ess',20,1),(294,7459032,7459026,'ssa',20,1),(294,7459033,7459026,'sag',20,1),(294,7459034,7459026,'age',20,1),(294,7459035,7459030,'per',11.111,1),(294,7459036,7459030,'erf',11.111,1),(294,7459037,7459030,'rfo',11.111,1),(294,7459038,7459030,'for',11.111,1),(294,7459039,7459030,'orm',11.111,1),(294,7459040,7459030,'rma',11.111,1),(294,7459041,7459030,'man',11.111,1),(294,7459042,7459030,'anc',11.111,1),(294,7459043,7459030,'nce',11.111,1),(294,7459044,7459035,'ide',12.5,1),(294,7459045,7459035,'den',12.5,1),(294,7459046,7459035,'ent',12.5,1),(294,7459047,7459035,'nti',12.5,1),(294,7459048,7459035,'tif',12.5,1),(294,7459049,7459035,'ifi',12.5,1),(294,7459050,7459035,'fie',12.5,1),(294,7459051,7459035,'ier',12.5,1),(294,7459052,7459044,'vdi',33.333,3),(294,7459053,7459044,'dis',33.333,3),(294,7459054,7459044,'isk',33.333,3),(294,7459055,7459052,'nam',50,1),(294,7459056,7459052,'ame',50,1),(294,7459057,7459055,'typ',50,1),(294,7459058,7459055,'ype',50,1),(294,7459059,7459057,'dir',25,1),(294,7459060,7459057,'ire',25,1),(294,7459061,7459057,'rec',25,1),(294,7459062,7459057,'ect',25,1),(295,7459064,7459063,'naa',100,2),(295,7459065,7459064,'600',3.333,3),(295,7459066,7459064,'000',3.333,3),(295,7459067,7459064,'00c',3.333,3),(295,7459068,7459064,'0c2',3.333,3),(295,7459069,7459064,'c29',3.333,3),(295,7459070,7459064,'291',3.333,3),(295,7459071,7459064,'917',3.333,3),(295,7459072,7459064,'17d',3.333,3),(295,7459073,7459064,'7d5',3.333,3),(295,7459074,7459064,'d55',3.333,3),(295,7459075,7459064,'55d',3.333,3),(295,7459076,7459064,'5d8',3.333,3),(295,7459077,7459064,'d87',3.333,3),(295,7459078,7459064,'870',3.333,3),(295,7459079,7459064,'704',3.333,3),(295,7459080,7459064,'040',3.333,3),(295,7459081,7459064,'400',3.333,3),(295,7459082,7459064,'00e',3.333,3),(295,7459083,7459064,'0ec',3.333,3),(295,7459084,7459064,'ecc',3.333,3),(295,7459085,7459064,'cc0',3.333,3),(295,7459086,7459064,'c07',3.333,3),(295,7459087,7459064,'070',3.333,3),(295,7459088,7459064,'701',3.333,3),(295,7459089,7459064,'01a',3.333,3),(295,7459090,7459064,'1ae',3.333,3),(295,7459091,7459064,'aec',3.333,3),(295,7459092,7459064,'ece',3.333,3),(295,7459093,7459064,'ce3',3.333,3),(295,7459094,7459064,'e3c',3.333,3),(295,7459095,7459065,'mon',100,1),(295,7459096,7459095,'201',50,1),(295,7459097,7459095,'013',50,1),(295,7459098,7459096,'adm',33.333,3),(295,7459099,7459096,'dmi',33.333,3),(295,7459100,7459096,'min',33.333,3),(295,7459101,7459098,'cap',16.667,1),(295,7459102,7459098,'apa',16.667,1),(295,7459103,7459098,'pac',16.667,1),(295,7459104,7459098,'aci',16.667,1),(295,7459105,7459098,'cit',16.667,1),(295,7459106,7459098,'ity',16.667,1),(295,7459107,7459101,'pat',50,1),(295,7459108,7459101,'ath',50,1),(295,7459109,7459107,'fre',14.286,1),(295,7459110,7459107,'ree',14.286,1),(295,7459111,7459107,'ees',14.286,1),(295,7459112,7459107,'esp',14.286,1),(295,7459113,7459107,'spa',14.286,1),(295,7459114,7459107,'pac',14.286,1),(295,7459115,7459107,'ace',14.286,1),(295,7459116,7459109,'dis',50,1),(295,7459117,7459109,'isk',50,1),(295,7459118,7459116,'ind',33.333,1),(295,7459119,7459116,'nde',33.333,1),(295,7459120,7459116,'dex',33.333,1),(295,7459121,7459118,'adm',8.333,1),(295,7459122,7459118,'dmi',8.333,1),(295,7459123,7459118,'min',8.333,1),(295,7459124,7459118,'ini',8.333,1),(295,7459125,7459118,'nis',8.333,1),(295,7459126,7459118,'ist',8.333,1),(295,7459127,7459118,'str',8.333,1),(295,7459128,7459118,'tra',8.333,1),(295,7459129,7459118,'rat',8.333,1),(295,7459130,7459118,'ati',8.333,1),(295,7459131,7459118,'tio',8.333,1),(295,7459132,7459118,'ion',8.333,1),(295,7459133,7459121,'sta',33.333,3),(295,7459134,7459121,'tat',33.333,3),(295,7459135,7459121,'ate',33.333,3),(295,7459136,7459133,'ena',20,2),(295,7459137,7459133,'nab',20,2),(295,7459138,7459133,'abl',20,2),(295,7459139,7459133,'ble',20,2),(295,7459140,7459133,'led',20,2),(295,7459141,7459136,'cac',33.333,1),(295,7459142,7459136,'ach',33.333,1),(295,7459143,7459136,'che',33.333,1),(295,7459144,7459141,'mod',50,2),(295,7459145,7459141,'ode',50,2),(295,7459146,7459144,'wri',14.286,2),(295,7459147,7459144,'rit',14.286,2),(295,7459148,7459144,'ite',14.286,2),(295,7459149,7459144,'tet',14.286,2),(295,7459150,7459144,'eth',14.286,2),(295,7459151,7459144,'thr',14.286,2),(295,7459152,7459144,'hru',14.286,2),(295,7459153,7459146,'ope',11.111,2),(295,7459154,7459146,'per',11.111,2),(295,7459155,7459146,'era',11.111,2),(295,7459156,7459146,'rat',11.111,2),(295,7459157,7459146,'ati',11.111,2),(295,7459158,7459146,'tio',11.111,2),(295,7459159,7459146,'ion',11.111,2),(295,7459160,7459146,'ona',11.111,2),(295,7459161,7459146,'nal',11.111,2),(295,7459162,7459153,'nor',25,1),(295,7459163,7459153,'orm',25,1),(295,7459164,7459153,'rma',25,1),(295,7459165,7459153,'mal',25,1),(295,7459166,7459162,'mes',20,1),(295,7459167,7459162,'ess',20,1),(295,7459168,7459162,'ssa',20,1),(295,7459169,7459162,'sag',20,1),(295,7459170,7459162,'age',20,1),(295,7459171,7459166,'per',11.111,1),(295,7459172,7459166,'erf',11.111,1),(295,7459173,7459166,'rfo',11.111,1),(295,7459174,7459166,'for',11.111,1),(295,7459175,7459166,'orm',11.111,1),(295,7459176,7459166,'rma',11.111,1),(295,7459177,7459166,'man',11.111,1),(295,7459178,7459166,'anc',11.111,1),(295,7459179,7459166,'nce',11.111,1),(295,7459180,7459171,'ide',12.5,1),(295,7459181,7459171,'den',12.5,1),(295,7459182,7459171,'ent',12.5,1),(295,7459183,7459171,'nti',12.5,1),(295,7459184,7459171,'tif',12.5,1),(295,7459185,7459171,'ifi',12.5,1),(295,7459186,7459171,'fie',12.5,1),(295,7459187,7459171,'ier',12.5,1),(295,7459188,7459180,'vdi',33.333,3),(295,7459189,7459180,'dis',33.333,3),(295,7459190,7459180,'isk',33.333,3),(295,7459191,7459188,'nam',50,1),(295,7459192,7459188,'ame',50,1),(295,7459193,7459191,'typ',50,1),(295,7459194,7459191,'ype',50,1),(295,7459195,7459193,'dir',25,1),(295,7459196,7459193,'ire',25,1),(295,7459197,7459193,'rec',25,1),(295,7459198,7459193,'ect',25,1),(296,7459200,7459199,'naa',100,2),(296,7459201,7459200,'600',3.333,3),(296,7459202,7459200,'000',3.333,3),(296,7459203,7459200,'00c',3.333,3),(296,7459204,7459200,'0c2',3.333,3),(296,7459205,7459200,'c29',3.333,3),(296,7459206,7459200,'293',3.333,3),(296,7459207,7459200,'93b',3.333,3),(296,7459208,7459200,'3b0',3.333,3),(296,7459209,7459200,'b01',3.333,3),(296,7459210,7459200,'01b',3.333,3),(296,7459211,7459200,'1b8',3.333,3),(296,7459212,7459200,'b8a',3.333,3),(296,7459213,7459200,'8a3',3.333,3),(296,7459214,7459200,'a37',3.333,3),(296,7459215,7459200,'378',3.333,3),(296,7459216,7459200,'782',3.333,3),(296,7459217,7459200,'82a',3.333,3),(296,7459218,7459200,'2ae',3.333,3),(296,7459219,7459200,'aed',3.333,3),(296,7459220,7459200,'ed2',3.333,3),(296,7459221,7459200,'d28',3.333,3),(296,7459222,7459200,'28f',3.333,3),(296,7459223,7459200,'8fa',3.333,3),(296,7459224,7459200,'fa5',3.333,3),(296,7459225,7459200,'a50',3.333,3),(296,7459226,7459200,'505',3.333,3),(296,7459227,7459200,'05d',3.333,3),(296,7459228,7459200,'5d3',3.333,3),(296,7459229,7459200,'d31',3.333,3),(296,7459230,7459200,'311',3.333,3),(296,7459231,7459201,'mon',100,1),(296,7459232,7459231,'201',50,1),(296,7459233,7459231,'013',50,1),(296,7459234,7459232,'adm',33.333,3),(296,7459235,7459232,'dmi',33.333,3),(296,7459236,7459232,'min',33.333,3),(296,7459237,7459234,'cap',16.667,1),(296,7459238,7459234,'apa',16.667,1),(296,7459239,7459234,'pac',16.667,1),(296,7459240,7459234,'aci',16.667,1),(296,7459241,7459234,'cit',16.667,1),(296,7459242,7459234,'ity',16.667,1),(296,7459243,7459237,'pat',50,1),(296,7459244,7459237,'ath',50,1),(296,7459245,7459243,'fre',14.286,1),(296,7459246,7459243,'ree',14.286,1),(296,7459247,7459243,'ees',14.286,1),(296,7459248,7459243,'esp',14.286,1),(296,7459249,7459243,'spa',14.286,1),(296,7459250,7459243,'pac',14.286,1),(296,7459251,7459243,'ace',14.286,1),(296,7459252,7459245,'dis',50,1),(296,7459253,7459245,'isk',50,1),(296,7459254,7459252,'ind',33.333,1),(296,7459255,7459252,'nde',33.333,1),(296,7459256,7459252,'dex',33.333,1),(296,7459257,7459254,'adm',8.333,1),(296,7459258,7459254,'dmi',8.333,1),(296,7459259,7459254,'min',8.333,1),(296,7459260,7459254,'ini',8.333,1),(296,7459261,7459254,'nis',8.333,1),(296,7459262,7459254,'ist',8.333,1),(296,7459263,7459254,'str',8.333,1),(296,7459264,7459254,'tra',8.333,1),(296,7459265,7459254,'rat',8.333,1),(296,7459266,7459254,'ati',8.333,1),(296,7459267,7459254,'tio',8.333,1),(296,7459268,7459254,'ion',8.333,1),(296,7459269,7459257,'sta',33.333,3),(296,7459270,7459257,'tat',33.333,3),(296,7459271,7459257,'ate',33.333,3),(296,7459272,7459269,'ena',20,2),(296,7459273,7459269,'nab',20,2),(296,7459274,7459269,'abl',20,2),(296,7459275,7459269,'ble',20,2),(296,7459276,7459269,'led',20,2),(296,7459277,7459272,'cac',33.333,1),(296,7459278,7459272,'ach',33.333,1),(296,7459279,7459272,'che',33.333,1),(296,7459280,7459277,'mod',50,2),(296,7459281,7459277,'ode',50,2),(296,7459282,7459280,'wri',14.286,2),(296,7459283,7459280,'rit',14.286,2),(296,7459284,7459280,'ite',14.286,2),(296,7459285,7459280,'tet',14.286,2),(296,7459286,7459280,'eth',14.286,2),(296,7459287,7459280,'thr',14.286,2),(296,7459288,7459280,'hru',14.286,2),(296,7459289,7459282,'ope',11.111,2),(296,7459290,7459282,'per',11.111,2),(296,7459291,7459282,'era',11.111,2),(296,7459292,7459282,'rat',11.111,2),(296,7459293,7459282,'ati',11.111,2),(296,7459294,7459282,'tio',11.111,2),(296,7459295,7459282,'ion',11.111,2),(296,7459296,7459282,'ona',11.111,2),(296,7459297,7459282,'nal',11.111,2),(296,7459298,7459289,'nor',25,1),(296,7459299,7459289,'orm',25,1),(296,7459300,7459289,'rma',25,1),(296,7459301,7459289,'mal',25,1),(296,7459302,7459298,'mes',20,1),(296,7459303,7459298,'ess',20,1),(296,7459304,7459298,'ssa',20,1),(296,7459305,7459298,'sag',20,1),(296,7459306,7459298,'age',20,1),(296,7459307,7459302,'per',11.111,1),(296,7459308,7459302,'erf',11.111,1),(296,7459309,7459302,'rfo',11.111,1),(296,7459310,7459302,'for',11.111,1),(296,7459311,7459302,'orm',11.111,1),(296,7459312,7459302,'rma',11.111,1),(296,7459313,7459302,'man',11.111,1),(296,7459314,7459302,'anc',11.111,1),(296,7459315,7459302,'nce',11.111,1),(296,7459316,7459307,'ide',12.5,1),(296,7459317,7459307,'den',12.5,1),(296,7459318,7459307,'ent',12.5,1),(296,7459319,7459307,'nti',12.5,1),(296,7459320,7459307,'tif',12.5,1),(296,7459321,7459307,'ifi',12.5,1),(296,7459322,7459307,'fie',12.5,1),(296,7459323,7459307,'ier',12.5,1),(296,7459324,7459316,'vdi',33.333,3),(296,7459325,7459316,'dis',33.333,3),(296,7459326,7459316,'isk',33.333,3),(296,7459327,7459324,'nam',50,1),(296,7459328,7459324,'ame',50,1),(296,7459329,7459327,'typ',50,1),(296,7459330,7459327,'ype',50,1),(296,7459331,7459329,'dir',25,1),(296,7459332,7459329,'ire',25,1),(296,7459333,7459329,'rec',25,1),(296,7459334,7459329,'ect',25,1),(297,7459336,7459335,'naa',100,2),(297,7459337,7459336,'600',3.333,3),(297,7459338,7459336,'000',3.333,3),(297,7459339,7459336,'00c',3.333,3),(297,7459340,7459336,'0c2',3.333,3),(297,7459341,7459336,'c29',3.333,3),(297,7459342,7459336,'294',3.333,3),(297,7459343,7459336,'942',3.333,3),(297,7459344,7459336,'422',3.333,3),(297,7459345,7459336,'223',3.333,3),(297,7459346,7459336,'23f',3.333,3),(297,7459347,7459336,'3f0',3.333,3),(297,7459348,7459336,'f07',3.333,3),(297,7459349,7459336,'07c',3.333,3),(297,7459350,7459336,'7cf',3.333,3),(297,7459351,7459336,'cf9',3.333,3),(297,7459352,7459336,'f93',3.333,3),(297,7459353,7459336,'933',3.333,3),(297,7459354,7459336,'331',3.333,3),(297,7459355,7459336,'31c',3.333,3),(297,7459356,7459336,'1c3',3.333,3),(297,7459357,7459336,'c3f',3.333,3),(297,7459358,7459336,'3fa',3.333,3),(297,7459359,7459336,'fa7',3.333,3),(297,7459360,7459336,'a76',3.333,3),(297,7459361,7459336,'766',3.333,3),(297,7459362,7459336,'664',3.333,3),(297,7459363,7459336,'649',3.333,3),(297,7459364,7459336,'49f',3.333,3),(297,7459365,7459336,'9fc',3.333,3),(297,7459366,7459336,'fc0',3.333,3),(297,7459367,7459337,'mon',100,1),(297,7459368,7459367,'201',50,1),(297,7459369,7459367,'013',50,1),(297,7459370,7459368,'adm',33.333,3),(297,7459371,7459368,'dmi',33.333,3),(297,7459372,7459368,'min',33.333,3),(297,7459373,7459370,'cap',16.667,1),(297,7459374,7459370,'apa',16.667,1),(297,7459375,7459370,'pac',16.667,1),(297,7459376,7459370,'aci',16.667,1),(297,7459377,7459370,'cit',16.667,1),(297,7459378,7459370,'ity',16.667,1),(297,7459379,7459373,'pat',50,1),(297,7459380,7459373,'ath',50,1),(297,7459381,7459379,'fre',14.286,1),(297,7459382,7459379,'ree',14.286,1),(297,7459383,7459379,'ees',14.286,1),(297,7459384,7459379,'esp',14.286,1),(297,7459385,7459379,'spa',14.286,1),(297,7459386,7459379,'pac',14.286,1),(297,7459387,7459379,'ace',14.286,1),(297,7459388,7459381,'dis',50,1),(297,7459389,7459381,'isk',50,1),(297,7459390,7459388,'ind',33.333,1),(297,7459391,7459388,'nde',33.333,1),(297,7459392,7459388,'dex',33.333,1),(297,7459393,7459390,'adm',8.333,1),(297,7459394,7459390,'dmi',8.333,1),(297,7459395,7459390,'min',8.333,1),(297,7459396,7459390,'ini',8.333,1),(297,7459397,7459390,'nis',8.333,1),(297,7459398,7459390,'ist',8.333,1),(297,7459399,7459390,'str',8.333,1),(297,7459400,7459390,'tra',8.333,1),(297,7459401,7459390,'rat',8.333,1),(297,7459402,7459390,'ati',8.333,1),(297,7459403,7459390,'tio',8.333,1),(297,7459404,7459390,'ion',8.333,1),(297,7459405,7459393,'sta',33.333,3),(297,7459406,7459393,'tat',33.333,3),(297,7459407,7459393,'ate',33.333,3),(297,7459408,7459405,'ena',20,2),(297,7459409,7459405,'nab',20,2),(297,7459410,7459405,'abl',20,2),(297,7459411,7459405,'ble',20,2),(297,7459412,7459405,'led',20,2),(297,7459413,7459408,'cac',33.333,1),(297,7459414,7459408,'ach',33.333,1),(297,7459415,7459408,'che',33.333,1),(297,7459416,7459413,'mod',50,2),(297,7459417,7459413,'ode',50,2),(297,7459418,7459416,'wri',14.286,2),(297,7459419,7459416,'rit',14.286,2),(297,7459420,7459416,'ite',14.286,2),(297,7459421,7459416,'tet',14.286,2),(297,7459422,7459416,'eth',14.286,2),(297,7459423,7459416,'thr',14.286,2),(297,7459424,7459416,'hru',14.286,2),(297,7459425,7459418,'ope',11.111,2),(297,7459426,7459418,'per',11.111,2),(297,7459427,7459418,'era',11.111,2),(297,7459428,7459418,'rat',11.111,2),(297,7459429,7459418,'ati',11.111,2),(297,7459430,7459418,'tio',11.111,2),(297,7459431,7459418,'ion',11.111,2),(297,7459432,7459418,'ona',11.111,2),(297,7459433,7459418,'nal',11.111,2),(297,7459434,7459425,'nor',25,1),(297,7459435,7459425,'orm',25,1),(297,7459436,7459425,'rma',25,1),(297,7459437,7459425,'mal',25,1),(297,7459438,7459434,'mes',20,1),(297,7459439,7459434,'ess',20,1),(297,7459440,7459434,'ssa',20,1),(297,7459441,7459434,'sag',20,1),(297,7459442,7459434,'age',20,1),(297,7459443,7459438,'per',11.111,1),(297,7459444,7459438,'erf',11.111,1),(297,7459445,7459438,'rfo',11.111,1),(297,7459446,7459438,'for',11.111,1),(297,7459447,7459438,'orm',11.111,1),(297,7459448,7459438,'rma',11.111,1),(297,7459449,7459438,'man',11.111,1),(297,7459450,7459438,'anc',11.111,1),(297,7459451,7459438,'nce',11.111,1),(297,7459452,7459443,'ide',12.5,1),(297,7459453,7459443,'den',12.5,1),(297,7459454,7459443,'ent',12.5,1),(297,7459455,7459443,'nti',12.5,1),(297,7459456,7459443,'tif',12.5,1),(297,7459457,7459443,'ifi',12.5,1),(297,7459458,7459443,'fie',12.5,1),(297,7459459,7459443,'ier',12.5,1),(297,7459460,7459452,'vdi',33.333,3),(297,7459461,7459452,'dis',33.333,3),(297,7459462,7459452,'isk',33.333,3),(297,7459463,7459460,'nam',50,1),(297,7459464,7459460,'ame',50,1),(297,7459465,7459463,'typ',50,1),(297,7459466,7459463,'ype',50,1),(297,7459467,7459465,'dir',25,1),(297,7459468,7459465,'ire',25,1),(297,7459469,7459465,'rec',25,1),(297,7459470,7459465,'ect',25,1),(298,7459472,7459471,'naa',100,2),(298,7459473,7459472,'600',3.333,3),(298,7459474,7459472,'000',3.333,3),(298,7459475,7459472,'00c',3.333,3),(298,7459476,7459472,'0c2',3.333,3),(298,7459477,7459472,'c29',3.333,3),(298,7459478,7459472,'29a',3.333,3),(298,7459479,7459472,'9aa',3.333,3),(298,7459480,7459472,'aac',3.333,3),(298,7459481,7459472,'ac0',3.333,3),(298,7459482,7459472,'c08',3.333,3),(298,7459483,7459472,'086',3.333,3),(298,7459484,7459472,'864',3.333,3),(298,7459485,7459472,'648',3.333,3),(298,7459486,7459472,'487',3.333,3),(298,7459487,7459472,'875',3.333,3),(298,7459488,7459472,'754',3.333,3),(298,7459489,7459472,'546',3.333,3),(298,7459490,7459472,'46a',3.333,3),(298,7459491,7459472,'6a2',3.333,3),(298,7459492,7459472,'a2c',3.333,3),(298,7459493,7459472,'2ca',3.333,3),(298,7459494,7459472,'ca8',3.333,3),(298,7459495,7459472,'a8d',3.333,3),(298,7459496,7459472,'8dd',3.333,3),(298,7459497,7459472,'dd2',3.333,3),(298,7459498,7459472,'d2e',3.333,3),(298,7459499,7459472,'2eb',3.333,3),(298,7459500,7459472,'ebd',3.333,3),(298,7459501,7459472,'bd5',3.333,3),(298,7459502,7459472,'d5a',3.333,3),(298,7459503,7459473,'mon',100,1),(298,7459504,7459503,'201',50,1),(298,7459505,7459503,'013',50,1),(298,7459506,7459504,'adm',33.333,3),(298,7459507,7459504,'dmi',33.333,3),(298,7459508,7459504,'min',33.333,3),(298,7459509,7459506,'cap',16.667,1),(298,7459510,7459506,'apa',16.667,1),(298,7459511,7459506,'pac',16.667,1),(298,7459512,7459506,'aci',16.667,1),(298,7459513,7459506,'cit',16.667,1),(298,7459514,7459506,'ity',16.667,1),(298,7459515,7459509,'pat',50,1),(298,7459516,7459509,'ath',50,1),(298,7459517,7459515,'fre',14.286,1),(298,7459518,7459515,'ree',14.286,1),(298,7459519,7459515,'ees',14.286,1),(298,7459520,7459515,'esp',14.286,1),(298,7459521,7459515,'spa',14.286,1),(298,7459522,7459515,'pac',14.286,1),(298,7459523,7459515,'ace',14.286,1),(298,7459524,7459517,'dis',50,1),(298,7459525,7459517,'isk',50,1),(298,7459526,7459524,'ind',33.333,1),(298,7459527,7459524,'nde',33.333,1),(298,7459528,7459524,'dex',33.333,1),(298,7459529,7459526,'adm',8.333,1),(298,7459530,7459526,'dmi',8.333,1),(298,7459531,7459526,'min',8.333,1),(298,7459532,7459526,'ini',8.333,1),(298,7459533,7459526,'nis',8.333,1),(298,7459534,7459526,'ist',8.333,1),(298,7459535,7459526,'str',8.333,1),(298,7459536,7459526,'tra',8.333,1),(298,7459537,7459526,'rat',8.333,1),(298,7459538,7459526,'ati',8.333,1),(298,7459539,7459526,'tio',8.333,1),(298,7459540,7459526,'ion',8.333,1),(298,7459541,7459529,'sta',33.333,3),(298,7459542,7459529,'tat',33.333,3),(298,7459543,7459529,'ate',33.333,3),(298,7459544,7459541,'ena',20,2),(298,7459545,7459541,'nab',20,2),(298,7459546,7459541,'abl',20,2),(298,7459547,7459541,'ble',20,2),(298,7459548,7459541,'led',20,2),(298,7459549,7459544,'cac',33.333,1),(298,7459550,7459544,'ach',33.333,1),(298,7459551,7459544,'che',33.333,1),(298,7459552,7459549,'mod',50,2),(298,7459553,7459549,'ode',50,2),(298,7459554,7459552,'wri',14.286,2),(298,7459555,7459552,'rit',14.286,2),(298,7459556,7459552,'ite',14.286,2),(298,7459557,7459552,'tet',14.286,2),(298,7459558,7459552,'eth',14.286,2),(298,7459559,7459552,'thr',14.286,2),(298,7459560,7459552,'hru',14.286,2),(298,7459561,7459554,'ope',11.111,2),(298,7459562,7459554,'per',11.111,2),(298,7459563,7459554,'era',11.111,2),(298,7459564,7459554,'rat',11.111,2),(298,7459565,7459554,'ati',11.111,2),(298,7459566,7459554,'tio',11.111,2),(298,7459567,7459554,'ion',11.111,2),(298,7459568,7459554,'ona',11.111,2),(298,7459569,7459554,'nal',11.111,2),(298,7459570,7459561,'nor',25,1),(298,7459571,7459561,'orm',25,1),(298,7459572,7459561,'rma',25,1),(298,7459573,7459561,'mal',25,1),(298,7459574,7459570,'mes',20,1),(298,7459575,7459570,'ess',20,1),(298,7459576,7459570,'ssa',20,1),(298,7459577,7459570,'sag',20,1),(298,7459578,7459570,'age',20,1),(298,7459579,7459574,'per',11.111,1),(298,7459580,7459574,'erf',11.111,1),(298,7459581,7459574,'rfo',11.111,1),(298,7459582,7459574,'for',11.111,1),(298,7459583,7459574,'orm',11.111,1),(298,7459584,7459574,'rma',11.111,1),(298,7459585,7459574,'man',11.111,1),(298,7459586,7459574,'anc',11.111,1),(298,7459587,7459574,'nce',11.111,1),(298,7459588,7459579,'ide',12.5,1),(298,7459589,7459579,'den',12.5,1),(298,7459590,7459579,'ent',12.5,1),(298,7459591,7459579,'nti',12.5,1),(298,7459592,7459579,'tif',12.5,1),(298,7459593,7459579,'ifi',12.5,1),(298,7459594,7459579,'fie',12.5,1),(298,7459595,7459579,'ier',12.5,1),(298,7459596,7459588,'vdi',33.333,3),(298,7459597,7459588,'dis',33.333,3),(298,7459598,7459588,'isk',33.333,3),(298,7459599,7459596,'nam',50,1),(298,7459600,7459596,'ame',50,1),(298,7459601,7459599,'typ',50,1),(298,7459602,7459599,'ype',50,1),(298,7459603,7459601,'dir',25,1),(298,7459604,7459601,'ire',25,1),(298,7459605,7459601,'rec',25,1),(298,7459606,7459601,'ect',25,1),(299,7459608,7459607,'naa',100,2),(299,7459609,7459608,'600',3.333,3),(299,7459610,7459608,'000',3.333,3),(299,7459611,7459608,'00c',3.333,3),(299,7459612,7459608,'0c2',3.333,3),(299,7459613,7459608,'c29',3.333,3),(299,7459614,7459608,'29e',3.333,3),(299,7459615,7459608,'9e2',3.333,3),(299,7459616,7459608,'e20',3.333,3),(299,7459617,7459608,'200',3.333,3),(299,7459618,7459608,'00b',3.333,3),(299,7459619,7459608,'0b5',3.333,3),(299,7459620,7459608,'b55',3.333,3),(299,7459621,7459608,'558',3.333,3),(299,7459622,7459608,'58b',3.333,3),(299,7459623,7459608,'8b2',3.333,3),(299,7459624,7459608,'b2c',3.333,3),(299,7459625,7459608,'2cc',3.333,3),(299,7459626,7459608,'cc9',3.333,3),(299,7459627,7459608,'c9c',3.333,3),(299,7459628,7459608,'9c3',3.333,3),(299,7459629,7459608,'c39',3.333,3),(299,7459630,7459608,'39c',3.333,3),(299,7459631,7459608,'9ce',3.333,3),(299,7459632,7459608,'ced',3.333,3),(299,7459633,7459608,'ed4',3.333,3),(299,7459634,7459608,'d49',3.333,3),(299,7459635,7459608,'495',3.333,3),(299,7459636,7459608,'952',3.333,3),(299,7459637,7459608,'529',3.333,3),(299,7459638,7459608,'29c',3.333,3),(299,7459639,7459609,'mon',100,1),(299,7459640,7459639,'201',50,1),(299,7459641,7459639,'013',50,1),(299,7459642,7459640,'adm',33.333,3),(299,7459643,7459640,'dmi',33.333,3),(299,7459644,7459640,'min',33.333,3),(299,7459645,7459642,'cap',16.667,1),(299,7459646,7459642,'apa',16.667,1),(299,7459647,7459642,'pac',16.667,1),(299,7459648,7459642,'aci',16.667,1),(299,7459649,7459642,'cit',16.667,1),(299,7459650,7459642,'ity',16.667,1),(299,7459651,7459645,'pat',50,1),(299,7459652,7459645,'ath',50,1),(299,7459653,7459651,'fre',14.286,1),(299,7459654,7459651,'ree',14.286,1),(299,7459655,7459651,'ees',14.286,1),(299,7459656,7459651,'esp',14.286,1),(299,7459657,7459651,'spa',14.286,1),(299,7459658,7459651,'pac',14.286,1),(299,7459659,7459651,'ace',14.286,1),(299,7459660,7459653,'dis',50,1),(299,7459661,7459653,'isk',50,1),(299,7459662,7459660,'ind',33.333,1),(299,7459663,7459660,'nde',33.333,1),(299,7459664,7459660,'dex',33.333,1),(299,7459665,7459662,'adm',8.333,1),(299,7459666,7459662,'dmi',8.333,1),(299,7459667,7459662,'min',8.333,1),(299,7459668,7459662,'ini',8.333,1),(299,7459669,7459662,'nis',8.333,1),(299,7459670,7459662,'ist',8.333,1),(299,7459671,7459662,'str',8.333,1),(299,7459672,7459662,'tra',8.333,1),(299,7459673,7459662,'rat',8.333,1),(299,7459674,7459662,'ati',8.333,1),(299,7459675,7459662,'tio',8.333,1),(299,7459676,7459662,'ion',8.333,1),(299,7459677,7459665,'sta',33.333,3),(299,7459678,7459665,'tat',33.333,3),(299,7459679,7459665,'ate',33.333,3),(299,7459680,7459677,'ena',20,2),(299,7459681,7459677,'nab',20,2),(299,7459682,7459677,'abl',20,2),(299,7459683,7459677,'ble',20,2),(299,7459684,7459677,'led',20,2),(299,7459685,7459680,'cac',33.333,1),(299,7459686,7459680,'ach',33.333,1),(299,7459687,7459680,'che',33.333,1),(299,7459688,7459685,'mod',50,2),(299,7459689,7459685,'ode',50,2),(299,7459690,7459688,'wri',14.286,2),(299,7459691,7459688,'rit',14.286,2),(299,7459692,7459688,'ite',14.286,2),(299,7459693,7459688,'tet',14.286,2),(299,7459694,7459688,'eth',14.286,2),(299,7459695,7459688,'thr',14.286,2),(299,7459696,7459688,'hru',14.286,2),(299,7459697,7459690,'ope',11.111,2),(299,7459698,7459690,'per',11.111,2),(299,7459699,7459690,'era',11.111,2),(299,7459700,7459690,'rat',11.111,2),(299,7459701,7459690,'ati',11.111,2),(299,7459702,7459690,'tio',11.111,2),(299,7459703,7459690,'ion',11.111,2),(299,7459704,7459690,'ona',11.111,2),(299,7459705,7459690,'nal',11.111,2),(299,7459706,7459697,'nor',25,1),(299,7459707,7459697,'orm',25,1),(299,7459708,7459697,'rma',25,1),(299,7459709,7459697,'mal',25,1),(299,7459710,7459706,'mes',20,1),(299,7459711,7459706,'ess',20,1),(299,7459712,7459706,'ssa',20,1),(299,7459713,7459706,'sag',20,1),(299,7459714,7459706,'age',20,1),(299,7459715,7459710,'per',11.111,1),(299,7459716,7459710,'erf',11.111,1),(299,7459717,7459710,'rfo',11.111,1),(299,7459718,7459710,'for',11.111,1),(299,7459719,7459710,'orm',11.111,1),(299,7459720,7459710,'rma',11.111,1),(299,7459721,7459710,'man',11.111,1),(299,7459722,7459710,'anc',11.111,1),(299,7459723,7459710,'nce',11.111,1),(299,7459724,7459715,'ide',12.5,1),(299,7459725,7459715,'den',12.5,1),(299,7459726,7459715,'ent',12.5,1),(299,7459727,7459715,'nti',12.5,1),(299,7459728,7459715,'tif',12.5,1),(299,7459729,7459715,'ifi',12.5,1),(299,7459730,7459715,'fie',12.5,1),(299,7459731,7459715,'ier',12.5,1),(299,7459732,7459724,'vdi',33.333,3),(299,7459733,7459724,'dis',33.333,3),(299,7459734,7459724,'isk',33.333,3),(299,7459735,7459732,'nam',50,1),(299,7459736,7459732,'ame',50,1),(299,7459737,7459735,'typ',50,1),(299,7459738,7459735,'ype',50,1),(299,7459739,7459737,'dir',25,1),(299,7459740,7459737,'ire',25,1),(299,7459741,7459737,'rec',25,1),(299,7459742,7459737,'ect',25,1),(300,7459744,7459743,'naa',100,2),(300,7459745,7459744,'600',3.333,3),(300,7459746,7459744,'000',3.333,3),(300,7459747,7459744,'00c',3.333,3),(300,7459748,7459744,'0c2',3.333,3),(300,7459749,7459744,'c29',3.333,3),(300,7459750,7459744,'29f',3.333,3),(300,7459751,7459744,'9fe',3.333,3),(300,7459752,7459744,'fe3',3.333,3),(300,7459753,7459744,'e33',3.333,3),(300,7459754,7459744,'339',3.333,3),(300,7459755,7459744,'390',3.333,3),(300,7459756,7459744,'90e',3.333,3),(300,7459757,7459744,'0e7',3.333,3),(300,7459758,7459744,'e79',3.333,3),(300,7459759,7459744,'795',3.333,3),(300,7459760,7459744,'95d',3.333,3),(300,7459761,7459744,'5d8',3.333,3),(300,7459762,7459744,'d8c',3.333,3),(300,7459763,7459744,'8c5',3.333,3),(300,7459764,7459744,'c59',3.333,3),(300,7459765,7459744,'591',3.333,3),(300,7459766,7459744,'911',3.333,3),(300,7459767,7459744,'113',3.333,3),(300,7459768,7459744,'136',3.333,3),(300,7459769,7459744,'360',3.333,3),(300,7459770,7459744,'608',3.333,3),(300,7459771,7459744,'084',3.333,3),(300,7459772,7459744,'848',3.333,3),(300,7459773,7459744,'489',3.333,3),(300,7459774,7459744,'897',3.333,3),(300,7459775,7459745,'mon',100,1),(300,7459776,7459775,'201',50,1),(300,7459777,7459775,'013',50,1),(300,7459778,7459776,'adm',33.333,3),(300,7459779,7459776,'dmi',33.333,3),(300,7459780,7459776,'min',33.333,3),(300,7459781,7459778,'cap',16.667,1),(300,7459782,7459778,'apa',16.667,1),(300,7459783,7459778,'pac',16.667,1),(300,7459784,7459778,'aci',16.667,1),(300,7459785,7459778,'cit',16.667,1),(300,7459786,7459778,'ity',16.667,1),(300,7459787,7459781,'pat',50,1),(300,7459788,7459781,'ath',50,1),(300,7459789,7459787,'fre',14.286,1),(300,7459790,7459787,'ree',14.286,1),(300,7459791,7459787,'ees',14.286,1),(300,7459792,7459787,'esp',14.286,1),(300,7459793,7459787,'spa',14.286,1),(300,7459794,7459787,'pac',14.286,1),(300,7459795,7459787,'ace',14.286,1),(300,7459796,7459789,'dis',50,1),(300,7459797,7459789,'isk',50,1),(300,7459798,7459796,'ind',33.333,1),(300,7459799,7459796,'nde',33.333,1),(300,7459800,7459796,'dex',33.333,1),(300,7459801,7459798,'adm',8.333,1),(300,7459802,7459798,'dmi',8.333,1),(300,7459803,7459798,'min',8.333,1),(300,7459804,7459798,'ini',8.333,1),(300,7459805,7459798,'nis',8.333,1),(300,7459806,7459798,'ist',8.333,1),(300,7459807,7459798,'str',8.333,1),(300,7459808,7459798,'tra',8.333,1),(300,7459809,7459798,'rat',8.333,1),(300,7459810,7459798,'ati',8.333,1),(300,7459811,7459798,'tio',8.333,1),(300,7459812,7459798,'ion',8.333,1),(300,7459813,7459801,'sta',33.333,3),(300,7459814,7459801,'tat',33.333,3),(300,7459815,7459801,'ate',33.333,3),(300,7459816,7459813,'ena',20,2),(300,7459817,7459813,'nab',20,2),(300,7459818,7459813,'abl',20,2),(300,7459819,7459813,'ble',20,2),(300,7459820,7459813,'led',20,2),(300,7459821,7459816,'cac',33.333,1),(300,7459822,7459816,'ach',33.333,1),(300,7459823,7459816,'che',33.333,1),(300,7459824,7459821,'mod',50,2),(300,7459825,7459821,'ode',50,2),(300,7459826,7459824,'wri',14.286,2),(300,7459827,7459824,'rit',14.286,2),(300,7459828,7459824,'ite',14.286,2),(300,7459829,7459824,'tet',14.286,2),(300,7459830,7459824,'eth',14.286,2),(300,7459831,7459824,'thr',14.286,2),(300,7459832,7459824,'hru',14.286,2),(300,7459833,7459826,'ope',11.111,2),(300,7459834,7459826,'per',11.111,2),(300,7459835,7459826,'era',11.111,2),(300,7459836,7459826,'rat',11.111,2),(300,7459837,7459826,'ati',11.111,2),(300,7459838,7459826,'tio',11.111,2),(300,7459839,7459826,'ion',11.111,2),(300,7459840,7459826,'ona',11.111,2),(300,7459841,7459826,'nal',11.111,2),(300,7459842,7459833,'nor',25,1),(300,7459843,7459833,'orm',25,1),(300,7459844,7459833,'rma',25,1),(300,7459845,7459833,'mal',25,1),(300,7459846,7459842,'mes',20,1),(300,7459847,7459842,'ess',20,1),(300,7459848,7459842,'ssa',20,1),(300,7459849,7459842,'sag',20,1),(300,7459850,7459842,'age',20,1),(300,7459851,7459846,'per',11.111,1),(300,7459852,7459846,'erf',11.111,1),(300,7459853,7459846,'rfo',11.111,1),(300,7459854,7459846,'for',11.111,1),(300,7459855,7459846,'orm',11.111,1),(300,7459856,7459846,'rma',11.111,1),(300,7459857,7459846,'man',11.111,1),(300,7459858,7459846,'anc',11.111,1),(300,7459859,7459846,'nce',11.111,1),(300,7459860,7459851,'ide',12.5,1),(300,7459861,7459851,'den',12.5,1),(300,7459862,7459851,'ent',12.5,1),(300,7459863,7459851,'nti',12.5,1),(300,7459864,7459851,'tif',12.5,1),(300,7459865,7459851,'ifi',12.5,1),(300,7459866,7459851,'fie',12.5,1),(300,7459867,7459851,'ier',12.5,1),(300,7459868,7459860,'vdi',33.333,3),(300,7459869,7459860,'dis',33.333,3),(300,7459870,7459860,'isk',33.333,3),(300,7459871,7459868,'nam',50,1),(300,7459872,7459868,'ame',50,1),(300,7459873,7459871,'typ',50,1),(300,7459874,7459871,'ype',50,1),(300,7459875,7459873,'dir',25,1),(300,7459876,7459873,'ire',25,1),(300,7459877,7459873,'rec',25,1),(300,7459878,7459873,'ect',25,1),(301,7459880,7459879,'naa',100,2),(301,7459881,7459880,'600',3.333,3),(301,7459882,7459880,'000',3.333,3),(301,7459883,7459880,'00c',3.333,3),(301,7459884,7459880,'0c2',3.333,3),(301,7459885,7459880,'c29',3.333,3),(301,7459886,7459880,'29a',3.333,3),(301,7459887,7459880,'9a1',3.333,3),(301,7459888,7459880,'a13',3.333,3),(301,7459889,7459880,'137',3.333,3),(301,7459890,7459880,'37b',3.333,3),(301,7459891,7459880,'7ba',3.333,3),(301,7459892,7459880,'ba8',3.333,3),(301,7459893,7459880,'a86',3.333,3),(301,7459894,7459880,'86b',3.333,3),(301,7459895,7459880,'6b5',3.333,3),(301,7459896,7459880,'b53',3.333,3),(301,7459897,7459880,'534',3.333,3),(301,7459898,7459880,'349',3.333,3),(301,7459899,7459880,'498',3.333,3),(301,7459900,7459880,'98f',3.333,3),(301,7459901,7459880,'8f0',3.333,3),(301,7459902,7459880,'f02',3.333,3),(301,7459903,7459880,'023',3.333,3),(301,7459904,7459880,'230',3.333,3),(301,7459905,7459880,'301',3.333,3),(301,7459906,7459880,'015',3.333,3),(301,7459907,7459880,'152',3.333,3),(301,7459908,7459880,'52b',3.333,3),(301,7459909,7459880,'2ba',3.333,3),(301,7459910,7459880,'ba2',3.333,3),(301,7459911,7459881,'mon',100,1),(301,7459912,7459911,'201',50,1),(301,7459913,7459911,'013',50,1),(301,7459914,7459912,'adm',33.333,3),(301,7459915,7459912,'dmi',33.333,3),(301,7459916,7459912,'min',33.333,3),(301,7459917,7459914,'cap',16.667,1),(301,7459918,7459914,'apa',16.667,1),(301,7459919,7459914,'pac',16.667,1),(301,7459920,7459914,'aci',16.667,1),(301,7459921,7459914,'cit',16.667,1),(301,7459922,7459914,'ity',16.667,1),(301,7459923,7459917,'pat',50,1),(301,7459924,7459917,'ath',50,1),(301,7459925,7459923,'fre',14.286,1),(301,7459926,7459923,'ree',14.286,1),(301,7459927,7459923,'ees',14.286,1),(301,7459928,7459923,'esp',14.286,1),(301,7459929,7459923,'spa',14.286,1),(301,7459930,7459923,'pac',14.286,1),(301,7459931,7459923,'ace',14.286,1),(301,7459932,7459925,'dis',50,1),(301,7459933,7459925,'isk',50,1),(301,7459934,7459932,'ind',33.333,1),(301,7459935,7459932,'nde',33.333,1),(301,7459936,7459932,'dex',33.333,1),(301,7459937,7459934,'adm',8.333,1),(301,7459938,7459934,'dmi',8.333,1),(301,7459939,7459934,'min',8.333,1),(301,7459940,7459934,'ini',8.333,1),(301,7459941,7459934,'nis',8.333,1),(301,7459942,7459934,'ist',8.333,1),(301,7459943,7459934,'str',8.333,1),(301,7459944,7459934,'tra',8.333,1),(301,7459945,7459934,'rat',8.333,1),(301,7459946,7459934,'ati',8.333,1),(301,7459947,7459934,'tio',8.333,1),(301,7459948,7459934,'ion',8.333,1),(301,7459949,7459937,'sta',33.333,3),(301,7459950,7459937,'tat',33.333,3),(301,7459951,7459937,'ate',33.333,3),(301,7459952,7459949,'ena',20,2),(301,7459953,7459949,'nab',20,2),(301,7459954,7459949,'abl',20,2),(301,7459955,7459949,'ble',20,2),(301,7459956,7459949,'led',20,2),(301,7459957,7459952,'cac',33.333,1),(301,7459958,7459952,'ach',33.333,1),(301,7459959,7459952,'che',33.333,1),(301,7459960,7459957,'mod',50,2),(301,7459961,7459957,'ode',50,2),(301,7459962,7459960,'wri',14.286,2),(301,7459963,7459960,'rit',14.286,2),(301,7459964,7459960,'ite',14.286,2),(301,7459965,7459960,'tet',14.286,2),(301,7459966,7459960,'eth',14.286,2),(301,7459967,7459960,'thr',14.286,2),(301,7459968,7459960,'hru',14.286,2),(301,7459969,7459962,'ope',11.111,2),(301,7459970,7459962,'per',11.111,2),(301,7459971,7459962,'era',11.111,2),(301,7459972,7459962,'rat',11.111,2),(301,7459973,7459962,'ati',11.111,2),(301,7459974,7459962,'tio',11.111,2),(301,7459975,7459962,'ion',11.111,2),(301,7459976,7459962,'ona',11.111,2),(301,7459977,7459962,'nal',11.111,2),(301,7459978,7459969,'nor',25,1),(301,7459979,7459969,'orm',25,1),(301,7459980,7459969,'rma',25,1),(301,7459981,7459969,'mal',25,1),(301,7459982,7459978,'mes',20,1),(301,7459983,7459978,'ess',20,1),(301,7459984,7459978,'ssa',20,1),(301,7459985,7459978,'sag',20,1),(301,7459986,7459978,'age',20,1),(301,7459987,7459982,'per',11.111,1),(301,7459988,7459982,'erf',11.111,1),(301,7459989,7459982,'rfo',11.111,1),(301,7459990,7459982,'for',11.111,1),(301,7459991,7459982,'orm',11.111,1),(301,7459992,7459982,'rma',11.111,1),(301,7459993,7459982,'man',11.111,1),(301,7459994,7459982,'anc',11.111,1),(301,7459995,7459982,'nce',11.111,1),(301,7459996,7459987,'ide',12.5,1),(301,7459997,7459987,'den',12.5,1),(301,7459998,7459987,'ent',12.5,1),(301,7459999,7459987,'nti',12.5,1),(301,7460000,7459987,'tif',12.5,1),(301,7460001,7459987,'ifi',12.5,1),(301,7460002,7459987,'fie',12.5,1),(301,7460003,7459987,'ier',12.5,1),(301,7460004,7459996,'vdi',33.333,3),(301,7460005,7459996,'dis',33.333,3),(301,7460006,7459996,'isk',33.333,3),(301,7460007,7460004,'nam',50,1),(301,7460008,7460004,'ame',50,1),(301,7460009,7460007,'typ',50,1),(301,7460010,7460007,'ype',50,1),(301,7460011,7460009,'dir',25,1),(301,7460012,7460009,'ire',25,1),(301,7460013,7460009,'rec',25,1),(301,7460014,7460009,'ect',25,1),(302,7460016,7460015,'naa',100,2),(302,7460017,7460016,'600',3.333,3),(302,7460018,7460016,'000',3.333,3),(302,7460019,7460016,'00c',3.333,3),(302,7460020,7460016,'0c2',3.333,3),(302,7460021,7460016,'c29',3.333,3),(302,7460022,7460016,'29b',3.333,3),(302,7460023,7460016,'9b4',3.333,3),(302,7460024,7460016,'b45',3.333,3),(302,7460025,7460016,'454',3.333,3),(302,7460026,7460016,'543',3.333,3),(302,7460027,7460016,'43f',3.333,3),(302,7460028,7460016,'3f3',3.333,3),(302,7460029,7460016,'f3d',3.333,3),(302,7460030,7460016,'3d3',3.333,3),(302,7460031,7460016,'d3e',3.333,3),(302,7460032,7460016,'3e3',3.333,3),(302,7460033,7460016,'e3e',3.333,3),(302,7460034,7460016,'3ec',3.333,3),(302,7460035,7460016,'ecb',3.333,3),(302,7460036,7460016,'cbe',3.333,3),(302,7460037,7460016,'bea',3.333,3),(302,7460038,7460016,'ea6',3.333,3),(302,7460039,7460016,'a61',3.333,3),(302,7460040,7460016,'612',3.333,3),(302,7460041,7460016,'126',3.333,3),(302,7460042,7460016,'26c',3.333,3),(302,7460043,7460016,'6ce',3.333,3),(302,7460044,7460016,'ce7',3.333,3),(302,7460045,7460016,'e7a',3.333,3),(302,7460046,7460016,'7a5',3.333,3),(302,7460047,7460017,'mon',100,1),(302,7460048,7460047,'201',50,1),(302,7460049,7460047,'013',50,1),(302,7460050,7460048,'adm',33.333,3),(302,7460051,7460048,'dmi',33.333,3),(302,7460052,7460048,'min',33.333,3),(302,7460053,7460050,'cap',16.667,1),(302,7460054,7460050,'apa',16.667,1),(302,7460055,7460050,'pac',16.667,1),(302,7460056,7460050,'aci',16.667,1),(302,7460057,7460050,'cit',16.667,1),(302,7460058,7460050,'ity',16.667,1),(302,7460059,7460053,'pat',50,1),(302,7460060,7460053,'ath',50,1),(302,7460061,7460059,'fre',14.286,1),(302,7460062,7460059,'ree',14.286,1),(302,7460063,7460059,'ees',14.286,1),(302,7460064,7460059,'esp',14.286,1),(302,7460065,7460059,'spa',14.286,1),(302,7460066,7460059,'pac',14.286,1),(302,7460067,7460059,'ace',14.286,1),(302,7460068,7460061,'dis',50,1),(302,7460069,7460061,'isk',50,1),(302,7460070,7460068,'ind',33.333,1),(302,7460071,7460068,'nde',33.333,1),(302,7460072,7460068,'dex',33.333,1),(302,7460073,7460070,'adm',8.333,1),(302,7460074,7460070,'dmi',8.333,1),(302,7460075,7460070,'min',8.333,1),(302,7460076,7460070,'ini',8.333,1),(302,7460077,7460070,'nis',8.333,1),(302,7460078,7460070,'ist',8.333,1),(302,7460079,7460070,'str',8.333,1),(302,7460080,7460070,'tra',8.333,1),(302,7460081,7460070,'rat',8.333,1),(302,7460082,7460070,'ati',8.333,1),(302,7460083,7460070,'tio',8.333,1),(302,7460084,7460070,'ion',8.333,1),(302,7460085,7460073,'sta',33.333,3),(302,7460086,7460073,'tat',33.333,3),(302,7460087,7460073,'ate',33.333,3),(302,7460088,7460085,'ena',20,2),(302,7460089,7460085,'nab',20,2),(302,7460090,7460085,'abl',20,2),(302,7460091,7460085,'ble',20,2),(302,7460092,7460085,'led',20,2),(302,7460093,7460088,'cac',33.333,1),(302,7460094,7460088,'ach',33.333,1),(302,7460095,7460088,'che',33.333,1),(302,7460096,7460093,'mod',50,2),(302,7460097,7460093,'ode',50,2),(302,7460098,7460096,'wri',14.286,2),(302,7460099,7460096,'rit',14.286,2),(302,7460100,7460096,'ite',14.286,2),(302,7460101,7460096,'tet',14.286,2),(302,7460102,7460096,'eth',14.286,2),(302,7460103,7460096,'thr',14.286,2),(302,7460104,7460096,'hru',14.286,2),(302,7460105,7460098,'ope',11.111,2),(302,7460106,7460098,'per',11.111,2),(302,7460107,7460098,'era',11.111,2),(302,7460108,7460098,'rat',11.111,2),(302,7460109,7460098,'ati',11.111,2),(302,7460110,7460098,'tio',11.111,2),(302,7460111,7460098,'ion',11.111,2),(302,7460112,7460098,'ona',11.111,2),(302,7460113,7460098,'nal',11.111,2),(302,7460114,7460105,'nor',25,1),(302,7460115,7460105,'orm',25,1),(302,7460116,7460105,'rma',25,1),(302,7460117,7460105,'mal',25,1),(302,7460118,7460114,'mes',20,1),(302,7460119,7460114,'ess',20,1),(302,7460120,7460114,'ssa',20,1),(302,7460121,7460114,'sag',20,1),(302,7460122,7460114,'age',20,1),(302,7460123,7460118,'per',11.111,1),(302,7460124,7460118,'erf',11.111,1),(302,7460125,7460118,'rfo',11.111,1),(302,7460126,7460118,'for',11.111,1),(302,7460127,7460118,'orm',11.111,1),(302,7460128,7460118,'rma',11.111,1),(302,7460129,7460118,'man',11.111,1),(302,7460130,7460118,'anc',11.111,1),(302,7460131,7460118,'nce',11.111,1),(302,7460132,7460123,'ide',12.5,1),(302,7460133,7460123,'den',12.5,1),(302,7460134,7460123,'ent',12.5,1),(302,7460135,7460123,'nti',12.5,1),(302,7460136,7460123,'tif',12.5,1),(302,7460137,7460123,'ifi',12.5,1),(302,7460138,7460123,'fie',12.5,1),(302,7460139,7460123,'ier',12.5,1),(302,7460140,7460132,'vdi',33.333,3),(302,7460141,7460132,'dis',33.333,3),(302,7460142,7460132,'isk',33.333,3),(302,7460143,7460140,'nam',50,1),(302,7460144,7460140,'ame',50,1),(302,7460145,7460143,'typ',50,1),(302,7460146,7460143,'ype',50,1),(302,7460147,7460145,'dir',25,1),(302,7460148,7460145,'ire',25,1),(302,7460149,7460145,'rec',25,1),(302,7460150,7460145,'ect',25,1),(303,7460152,7460151,'naa',100,2),(303,7460153,7460152,'600',3.333,3),(303,7460154,7460152,'000',3.333,3),(303,7460155,7460152,'00c',3.333,3),(303,7460156,7460152,'0c2',3.333,3),(303,7460157,7460152,'c29',3.333,3),(303,7460158,7460152,'291',3.333,3),(303,7460159,7460152,'91d',3.333,3),(303,7460160,7460152,'1dd',3.333,3),(303,7460161,7460152,'dd7',3.333,3),(303,7460162,7460152,'d7f',3.333,3),(303,7460163,7460152,'7f6',3.333,3),(303,7460164,7460152,'f6a',3.333,3),(303,7460165,7460152,'6a5',3.333,3),(303,7460166,7460152,'a5d',3.333,3),(303,7460167,7460152,'5d9',3.333,3),(303,7460168,7460152,'d94',3.333,3),(303,7460169,7460152,'940',3.333,3),(303,7460170,7460152,'401',3.333,3),(303,7460171,7460152,'01f',3.333,3),(303,7460172,7460152,'1fc',3.333,3),(303,7460173,7460152,'fc7',3.333,3),(303,7460174,7460152,'c71',3.333,3),(303,7460175,7460152,'71d',3.333,3),(303,7460176,7460152,'1d5',3.333,3),(303,7460177,7460152,'d54',3.333,3),(303,7460178,7460152,'54a',3.333,3),(303,7460179,7460152,'4ad',3.333,3),(303,7460180,7460152,'adb',3.333,3),(303,7460181,7460152,'dbb',3.333,3),(303,7460182,7460152,'bb6',3.333,3),(303,7460183,7460153,'mon',100,1),(303,7460184,7460183,'201',50,1),(303,7460185,7460183,'013',50,1),(303,7460186,7460184,'adm',33.333,3),(303,7460187,7460184,'dmi',33.333,3),(303,7460188,7460184,'min',33.333,3),(303,7460189,7460186,'cap',16.667,1),(303,7460190,7460186,'apa',16.667,1),(303,7460191,7460186,'pac',16.667,1),(303,7460192,7460186,'aci',16.667,1),(303,7460193,7460186,'cit',16.667,1),(303,7460194,7460186,'ity',16.667,1),(303,7460195,7460189,'pat',50,1),(303,7460196,7460189,'ath',50,1),(303,7460197,7460195,'fre',14.286,1),(303,7460198,7460195,'ree',14.286,1),(303,7460199,7460195,'ees',14.286,1),(303,7460200,7460195,'esp',14.286,1),(303,7460201,7460195,'spa',14.286,1),(303,7460202,7460195,'pac',14.286,1),(303,7460203,7460195,'ace',14.286,1),(303,7460204,7460197,'dis',50,1),(303,7460205,7460197,'isk',50,1),(303,7460206,7460204,'ind',33.333,1),(303,7460207,7460204,'nde',33.333,1),(303,7460208,7460204,'dex',33.333,1),(303,7460209,7460206,'adm',8.333,1),(303,7460210,7460206,'dmi',8.333,1),(303,7460211,7460206,'min',8.333,1),(303,7460212,7460206,'ini',8.333,1),(303,7460213,7460206,'nis',8.333,1),(303,7460214,7460206,'ist',8.333,1),(303,7460215,7460206,'str',8.333,1),(303,7460216,7460206,'tra',8.333,1),(303,7460217,7460206,'rat',8.333,1),(303,7460218,7460206,'ati',8.333,1),(303,7460219,7460206,'tio',8.333,1),(303,7460220,7460206,'ion',8.333,1),(303,7460221,7460209,'sta',33.333,3),(303,7460222,7460209,'tat',33.333,3),(303,7460223,7460209,'ate',33.333,3),(303,7460224,7460221,'ena',20,2),(303,7460225,7460221,'nab',20,2),(303,7460226,7460221,'abl',20,2),(303,7460227,7460221,'ble',20,2),(303,7460228,7460221,'led',20,2),(303,7460229,7460224,'cac',33.333,1),(303,7460230,7460224,'ach',33.333,1),(303,7460231,7460224,'che',33.333,1),(303,7460232,7460229,'mod',50,2),(303,7460233,7460229,'ode',50,2),(303,7460234,7460232,'wri',14.286,2),(303,7460235,7460232,'rit',14.286,2),(303,7460236,7460232,'ite',14.286,2),(303,7460237,7460232,'tet',14.286,2),(303,7460238,7460232,'eth',14.286,2),(303,7460239,7460232,'thr',14.286,2),(303,7460240,7460232,'hru',14.286,2),(303,7460241,7460234,'ope',11.111,2),(303,7460242,7460234,'per',11.111,2),(303,7460243,7460234,'era',11.111,2),(303,7460244,7460234,'rat',11.111,2),(303,7460245,7460234,'ati',11.111,2),(303,7460246,7460234,'tio',11.111,2),(303,7460247,7460234,'ion',11.111,2),(303,7460248,7460234,'ona',11.111,2),(303,7460249,7460234,'nal',11.111,2),(303,7460250,7460241,'nor',25,1),(303,7460251,7460241,'orm',25,1),(303,7460252,7460241,'rma',25,1),(303,7460253,7460241,'mal',25,1),(303,7460254,7460250,'mes',20,1),(303,7460255,7460250,'ess',20,1),(303,7460256,7460250,'ssa',20,1),(303,7460257,7460250,'sag',20,1),(303,7460258,7460250,'age',20,1),(303,7460259,7460254,'per',11.111,1),(303,7460260,7460254,'erf',11.111,1),(303,7460261,7460254,'rfo',11.111,1),(303,7460262,7460254,'for',11.111,1),(303,7460263,7460254,'orm',11.111,1),(303,7460264,7460254,'rma',11.111,1),(303,7460265,7460254,'man',11.111,1),(303,7460266,7460254,'anc',11.111,1),(303,7460267,7460254,'nce',11.111,1),(303,7460268,7460259,'ide',12.5,1),(303,7460269,7460259,'den',12.5,1),(303,7460270,7460259,'ent',12.5,1),(303,7460271,7460259,'nti',12.5,1),(303,7460272,7460259,'tif',12.5,1),(303,7460273,7460259,'ifi',12.5,1),(303,7460274,7460259,'fie',12.5,1),(303,7460275,7460259,'ier',12.5,1),(303,7460276,7460268,'vdi',33.333,3),(303,7460277,7460268,'dis',33.333,3),(303,7460278,7460268,'isk',33.333,3),(303,7460279,7460276,'nam',50,1),(303,7460280,7460276,'ame',50,1),(303,7460281,7460279,'typ',50,1),(303,7460282,7460279,'ype',50,1),(303,7460283,7460281,'dir',25,1),(303,7460284,7460281,'ire',25,1),(303,7460285,7460281,'rec',25,1),(303,7460286,7460281,'ect',25,1),(304,7460288,7460287,'naa',100,2),(304,7460289,7460288,'600',3.333,3),(304,7460290,7460288,'000',3.333,3),(304,7460291,7460288,'00c',3.333,3),(304,7460292,7460288,'0c2',3.333,3),(304,7460293,7460288,'c29',3.333,3),(304,7460294,7460288,'29b',3.333,3),(304,7460295,7460288,'9b6',3.333,3),(304,7460296,7460288,'b6e',3.333,3),(304,7460297,7460288,'6e7',3.333,3),(304,7460298,7460288,'e74',3.333,3),(304,7460299,7460288,'740',3.333,3),(304,7460300,7460288,'404',3.333,3),(304,7460301,7460288,'04d',3.333,3),(304,7460302,7460288,'4dd',3.333,3),(304,7460303,7460288,'ddd',3.333,3),(304,7460304,7460288,'dd6',3.333,3),(304,7460305,7460288,'d6b',3.333,3),(304,7460306,7460288,'6b6',3.333,3),(304,7460307,7460288,'b61',3.333,3),(304,7460308,7460288,'61e',3.333,3),(304,7460309,7460288,'1e5',3.333,3),(304,7460310,7460288,'e58',3.333,3),(304,7460311,7460288,'58e',3.333,3),(304,7460312,7460288,'8e7',3.333,3),(304,7460313,7460288,'e78',3.333,3),(304,7460314,7460288,'787',3.333,3),(304,7460315,7460288,'87d',3.333,3),(304,7460316,7460288,'7d9',3.333,3),(304,7460317,7460288,'d9d',3.333,3),(304,7460318,7460288,'9d9',3.333,3),(304,7460319,7460289,'mon',100,1),(304,7460320,7460319,'201',50,1),(304,7460321,7460319,'013',50,1),(304,7460322,7460320,'adm',33.333,3),(304,7460323,7460320,'dmi',33.333,3),(304,7460324,7460320,'min',33.333,3),(304,7460325,7460322,'cap',16.667,1),(304,7460326,7460322,'apa',16.667,1),(304,7460327,7460322,'pac',16.667,1),(304,7460328,7460322,'aci',16.667,1),(304,7460329,7460322,'cit',16.667,1),(304,7460330,7460322,'ity',16.667,1),(304,7460331,7460325,'pat',50,1),(304,7460332,7460325,'ath',50,1),(304,7460333,7460331,'fre',14.286,1),(304,7460334,7460331,'ree',14.286,1),(304,7460335,7460331,'ees',14.286,1),(304,7460336,7460331,'esp',14.286,1),(304,7460337,7460331,'spa',14.286,1),(304,7460338,7460331,'pac',14.286,1),(304,7460339,7460331,'ace',14.286,1),(304,7460340,7460333,'dis',50,1),(304,7460341,7460333,'isk',50,1),(304,7460342,7460340,'ind',33.333,1),(304,7460343,7460340,'nde',33.333,1),(304,7460344,7460340,'dex',33.333,1),(304,7460345,7460342,'adm',8.333,1),(304,7460346,7460342,'dmi',8.333,1),(304,7460347,7460342,'min',8.333,1),(304,7460348,7460342,'ini',8.333,1),(304,7460349,7460342,'nis',8.333,1),(304,7460350,7460342,'ist',8.333,1),(304,7460351,7460342,'str',8.333,1),(304,7460352,7460342,'tra',8.333,1),(304,7460353,7460342,'rat',8.333,1),(304,7460354,7460342,'ati',8.333,1),(304,7460355,7460342,'tio',8.333,1),(304,7460356,7460342,'ion',8.333,1),(304,7460357,7460345,'sta',33.333,3),(304,7460358,7460345,'tat',33.333,3),(304,7460359,7460345,'ate',33.333,3),(304,7460360,7460357,'ena',20,2),(304,7460361,7460357,'nab',20,2),(304,7460362,7460357,'abl',20,2),(304,7460363,7460357,'ble',20,2),(304,7460364,7460357,'led',20,2),(304,7460365,7460360,'cac',33.333,1),(304,7460366,7460360,'ach',33.333,1),(304,7460367,7460360,'che',33.333,1),(304,7460368,7460365,'mod',50,2),(304,7460369,7460365,'ode',50,2),(304,7460370,7460368,'wri',14.286,2),(304,7460371,7460368,'rit',14.286,2),(304,7460372,7460368,'ite',14.286,2),(304,7460373,7460368,'tet',14.286,2),(304,7460374,7460368,'eth',14.286,2),(304,7460375,7460368,'thr',14.286,2),(304,7460376,7460368,'hru',14.286,2),(304,7460377,7460370,'ope',11.111,2),(304,7460378,7460370,'per',11.111,2),(304,7460379,7460370,'era',11.111,2),(304,7460380,7460370,'rat',11.111,2),(304,7460381,7460370,'ati',11.111,2),(304,7460382,7460370,'tio',11.111,2),(304,7460383,7460370,'ion',11.111,2),(304,7460384,7460370,'ona',11.111,2),(304,7460385,7460370,'nal',11.111,2),(304,7460386,7460377,'nor',25,1),(304,7460387,7460377,'orm',25,1),(304,7460388,7460377,'rma',25,1),(304,7460389,7460377,'mal',25,1),(304,7460390,7460386,'mes',20,1),(304,7460391,7460386,'ess',20,1),(304,7460392,7460386,'ssa',20,1),(304,7460393,7460386,'sag',20,1),(304,7460394,7460386,'age',20,1),(304,7460395,7460390,'per',11.111,1),(304,7460396,7460390,'erf',11.111,1),(304,7460397,7460390,'rfo',11.111,1),(304,7460398,7460390,'for',11.111,1),(304,7460399,7460390,'orm',11.111,1),(304,7460400,7460390,'rma',11.111,1),(304,7460401,7460390,'man',11.111,1),(304,7460402,7460390,'anc',11.111,1),(304,7460403,7460390,'nce',11.111,1),(304,7460404,7460395,'ide',12.5,1),(304,7460405,7460395,'den',12.5,1),(304,7460406,7460395,'ent',12.5,1),(304,7460407,7460395,'nti',12.5,1),(304,7460408,7460395,'tif',12.5,1),(304,7460409,7460395,'ifi',12.5,1),(304,7460410,7460395,'fie',12.5,1),(304,7460411,7460395,'ier',12.5,1),(304,7460412,7460404,'vdi',33.333,3),(304,7460413,7460404,'dis',33.333,3),(304,7460414,7460404,'isk',33.333,3),(304,7460415,7460412,'nam',50,1),(304,7460416,7460412,'ame',50,1),(304,7460417,7460415,'typ',50,1),(304,7460418,7460415,'ype',50,1),(304,7460419,7460417,'dir',25,1),(304,7460420,7460417,'ire',25,1),(304,7460421,7460417,'rec',25,1),(304,7460422,7460417,'ect',25,1),(305,7460424,7460423,'naa',100,2),(305,7460425,7460424,'600',3.333,3),(305,7460426,7460424,'000',3.333,3),(305,7460427,7460424,'00c',3.333,3),(305,7460428,7460424,'0c2',3.333,3),(305,7460429,7460424,'c29',3.333,3),(305,7460430,7460424,'29d',3.333,3),(305,7460431,7460424,'9dd',3.333,3),(305,7460432,7460424,'dd4',3.333,3),(305,7460433,7460424,'d43',3.333,3),(305,7460434,7460424,'436',3.333,3),(305,7460435,7460424,'369',3.333,3),(305,7460436,7460424,'697',3.333,3),(305,7460437,7460424,'978',3.333,3),(305,7460438,7460424,'787',3.333,3),(305,7460439,7460424,'87c',3.333,3),(305,7460440,7460424,'7c5',3.333,3),(305,7460441,7460424,'c56',3.333,3),(305,7460442,7460424,'560',3.333,3),(305,7460443,7460424,'60b',3.333,3),(305,7460444,7460424,'0bd',3.333,3),(305,7460445,7460424,'bd4',3.333,3),(305,7460446,7460424,'d4b',3.333,3),(305,7460447,7460424,'4be',3.333,3),(305,7460448,7460424,'bea',3.333,3),(305,7460449,7460424,'eac',3.333,3),(305,7460450,7460424,'acc',3.333,3),(305,7460451,7460424,'cce',3.333,3),(305,7460452,7460424,'ce1',3.333,3),(305,7460453,7460424,'e11',3.333,3),(305,7460454,7460424,'114',3.333,3),(305,7460455,7460425,'mon',100,1),(305,7460456,7460455,'201',50,1),(305,7460457,7460455,'013',50,1),(305,7460458,7460456,'adm',33.333,3),(305,7460459,7460456,'dmi',33.333,3),(305,7460460,7460456,'min',33.333,3),(305,7460461,7460458,'cap',16.667,1),(305,7460462,7460458,'apa',16.667,1),(305,7460463,7460458,'pac',16.667,1),(305,7460464,7460458,'aci',16.667,1),(305,7460465,7460458,'cit',16.667,1),(305,7460466,7460458,'ity',16.667,1),(305,7460467,7460461,'pat',50,1),(305,7460468,7460461,'ath',50,1),(305,7460469,7460467,'fre',14.286,1),(305,7460470,7460467,'ree',14.286,1),(305,7460471,7460467,'ees',14.286,1),(305,7460472,7460467,'esp',14.286,1),(305,7460473,7460467,'spa',14.286,1),(305,7460474,7460467,'pac',14.286,1),(305,7460475,7460467,'ace',14.286,1),(305,7460476,7460469,'dis',50,1),(305,7460477,7460469,'isk',50,1),(305,7460478,7460476,'ind',33.333,1),(305,7460479,7460476,'nde',33.333,1),(305,7460480,7460476,'dex',33.333,1),(305,7460481,7460478,'adm',8.333,1),(305,7460482,7460478,'dmi',8.333,1),(305,7460483,7460478,'min',8.333,1),(305,7460484,7460478,'ini',8.333,1),(305,7460485,7460478,'nis',8.333,1),(305,7460486,7460478,'ist',8.333,1),(305,7460487,7460478,'str',8.333,1),(305,7460488,7460478,'tra',8.333,1),(305,7460489,7460478,'rat',8.333,1),(305,7460490,7460478,'ati',8.333,1),(305,7460491,7460478,'tio',8.333,1),(305,7460492,7460478,'ion',8.333,1),(305,7460493,7460481,'sta',33.333,3),(305,7460494,7460481,'tat',33.333,3),(305,7460495,7460481,'ate',33.333,3),(305,7460496,7460493,'ena',20,2),(305,7460497,7460493,'nab',20,2),(305,7460498,7460493,'abl',20,2),(305,7460499,7460493,'ble',20,2),(305,7460500,7460493,'led',20,2),(305,7460501,7460496,'cac',33.333,1),(305,7460502,7460496,'ach',33.333,1),(305,7460503,7460496,'che',33.333,1),(305,7460504,7460501,'mod',50,2),(305,7460505,7460501,'ode',50,2),(305,7460506,7460504,'wri',14.286,2),(305,7460507,7460504,'rit',14.286,2),(305,7460508,7460504,'ite',14.286,2),(305,7460509,7460504,'tet',14.286,2),(305,7460510,7460504,'eth',14.286,2),(305,7460511,7460504,'thr',14.286,2),(305,7460512,7460504,'hru',14.286,2),(305,7460513,7460506,'ope',11.111,2),(305,7460514,7460506,'per',11.111,2),(305,7460515,7460506,'era',11.111,2),(305,7460516,7460506,'rat',11.111,2),(305,7460517,7460506,'ati',11.111,2),(305,7460518,7460506,'tio',11.111,2),(305,7460519,7460506,'ion',11.111,2),(305,7460520,7460506,'ona',11.111,2),(305,7460521,7460506,'nal',11.111,2),(305,7460522,7460513,'nor',25,1),(305,7460523,7460513,'orm',25,1),(305,7460524,7460513,'rma',25,1),(305,7460525,7460513,'mal',25,1),(305,7460526,7460522,'mes',20,1),(305,7460527,7460522,'ess',20,1),(305,7460528,7460522,'ssa',20,1),(305,7460529,7460522,'sag',20,1),(305,7460530,7460522,'age',20,1),(305,7460531,7460526,'per',11.111,1),(305,7460532,7460526,'erf',11.111,1),(305,7460533,7460526,'rfo',11.111,1),(305,7460534,7460526,'for',11.111,1),(305,7460535,7460526,'orm',11.111,1),(305,7460536,7460526,'rma',11.111,1),(305,7460537,7460526,'man',11.111,1),(305,7460538,7460526,'anc',11.111,1),(305,7460539,7460526,'nce',11.111,1),(305,7460540,7460531,'ide',12.5,1),(305,7460541,7460531,'den',12.5,1),(305,7460542,7460531,'ent',12.5,1),(305,7460543,7460531,'nti',12.5,1),(305,7460544,7460531,'tif',12.5,1),(305,7460545,7460531,'ifi',12.5,1),(305,7460546,7460531,'fie',12.5,1),(305,7460547,7460531,'ier',12.5,1),(305,7460548,7460540,'vdi',33.333,3),(305,7460549,7460540,'dis',33.333,3),(305,7460550,7460540,'isk',33.333,3),(305,7460551,7460548,'nam',50,1),(305,7460552,7460548,'ame',50,1),(305,7460553,7460551,'typ',50,1),(305,7460554,7460551,'ype',50,1),(305,7460555,7460553,'dir',25,1),(305,7460556,7460553,'ire',25,1),(305,7460557,7460553,'rec',25,1),(305,7460558,7460553,'ect',25,1),(306,7460560,7460559,'naa',100,2),(306,7460561,7460560,'600',3.333,3),(306,7460562,7460560,'000',3.333,3),(306,7460563,7460560,'00c',3.333,3),(306,7460564,7460560,'0c2',3.333,3),(306,7460565,7460560,'c29',3.333,3),(306,7460566,7460560,'296',3.333,3),(306,7460567,7460560,'964',3.333,3),(306,7460568,7460560,'642',3.333,3),(306,7460569,7460560,'427',3.333,3),(306,7460570,7460560,'274',3.333,3),(306,7460571,7460560,'741',3.333,3),(306,7460572,7460560,'418',3.333,3),(306,7460573,7460560,'185',3.333,3),(306,7460574,7460560,'85b',3.333,3),(306,7460575,7460560,'5ba',3.333,3),(306,7460576,7460560,'ba9',3.333,3),(306,7460577,7460560,'a96',3.333,3),(306,7460578,7460560,'96c',3.333,3),(306,7460579,7460560,'6cd',3.333,3),(306,7460580,7460560,'cd4',3.333,3),(306,7460581,7460560,'d4d',3.333,3),(306,7460582,7460560,'4db',3.333,3),(306,7460583,7460560,'dbf',3.333,3),(306,7460584,7460560,'bf8',3.333,3),(306,7460585,7460560,'f8e',3.333,3),(306,7460586,7460560,'8ef',3.333,3),(306,7460587,7460560,'ef5',3.333,3),(306,7460588,7460560,'f50',3.333,3),(306,7460589,7460560,'50e',3.333,3),(306,7460590,7460560,'0eb',3.333,3),(306,7460591,7460561,'mon',100,1),(306,7460592,7460591,'201',50,1),(306,7460593,7460591,'013',50,1),(306,7460594,7460592,'adm',33.333,3),(306,7460595,7460592,'dmi',33.333,3),(306,7460596,7460592,'min',33.333,3),(306,7460597,7460594,'cap',16.667,1),(306,7460598,7460594,'apa',16.667,1),(306,7460599,7460594,'pac',16.667,1),(306,7460600,7460594,'aci',16.667,1),(306,7460601,7460594,'cit',16.667,1),(306,7460602,7460594,'ity',16.667,1),(306,7460603,7460597,'pat',50,1),(306,7460604,7460597,'ath',50,1),(306,7460605,7460603,'one',100,1),(306,7460606,7460605,'fre',14.286,1),(306,7460607,7460605,'ree',14.286,1),(306,7460608,7460605,'ees',14.286,1),(306,7460609,7460605,'esp',14.286,1),(306,7460610,7460605,'spa',14.286,1),(306,7460611,7460605,'pac',14.286,1),(306,7460612,7460605,'ace',14.286,1),(306,7460613,7460606,'dis',50,1),(306,7460614,7460606,'isk',50,1),(306,7460615,7460613,'ind',33.333,1),(306,7460616,7460613,'nde',33.333,1),(306,7460617,7460613,'dex',33.333,1),(306,7460618,7460615,'adm',8.333,1),(306,7460619,7460615,'dmi',8.333,1),(306,7460620,7460615,'min',8.333,1),(306,7460621,7460615,'ini',8.333,1),(306,7460622,7460615,'nis',8.333,1),(306,7460623,7460615,'ist',8.333,1),(306,7460624,7460615,'str',8.333,1),(306,7460625,7460615,'tra',8.333,1),(306,7460626,7460615,'rat',8.333,1),(306,7460627,7460615,'ati',8.333,1),(306,7460628,7460615,'tio',8.333,1),(306,7460629,7460615,'ion',8.333,1),(306,7460630,7460618,'sta',33.333,3),(306,7460631,7460618,'tat',33.333,3),(306,7460632,7460618,'ate',33.333,3),(306,7460633,7460630,'ena',20,2),(306,7460634,7460630,'nab',20,2),(306,7460635,7460630,'abl',20,2),(306,7460636,7460630,'ble',20,2),(306,7460637,7460630,'led',20,2),(306,7460638,7460633,'cac',33.333,1),(306,7460639,7460633,'ach',33.333,1),(306,7460640,7460633,'che',33.333,1),(306,7460641,7460638,'mod',50,2),(306,7460642,7460638,'ode',50,2),(306,7460643,7460641,'wri',14.286,2),(306,7460644,7460641,'rit',14.286,2),(306,7460645,7460641,'ite',14.286,2),(306,7460646,7460641,'tet',14.286,2),(306,7460647,7460641,'eth',14.286,2),(306,7460648,7460641,'thr',14.286,2),(306,7460649,7460641,'hru',14.286,2),(306,7460650,7460643,'ope',11.111,2),(306,7460651,7460643,'per',11.111,2),(306,7460652,7460643,'era',11.111,2),(306,7460653,7460643,'rat',11.111,2),(306,7460654,7460643,'ati',11.111,2),(306,7460655,7460643,'tio',11.111,2),(306,7460656,7460643,'ion',11.111,2),(306,7460657,7460643,'ona',11.111,2),(306,7460658,7460643,'nal',11.111,2),(306,7460659,7460650,'nor',25,1),(306,7460660,7460650,'orm',25,1),(306,7460661,7460650,'rma',25,1),(306,7460662,7460650,'mal',25,1),(306,7460663,7460659,'mes',20,1),(306,7460664,7460659,'ess',20,1),(306,7460665,7460659,'ssa',20,1),(306,7460666,7460659,'sag',20,1),(306,7460667,7460659,'age',20,1),(306,7460668,7460663,'per',11.111,1),(306,7460669,7460663,'erf',11.111,1),(306,7460670,7460663,'rfo',11.111,1),(306,7460671,7460663,'for',11.111,1),(306,7460672,7460663,'orm',11.111,1),(306,7460673,7460663,'rma',11.111,1),(306,7460674,7460663,'man',11.111,1),(306,7460675,7460663,'anc',11.111,1),(306,7460676,7460663,'nce',11.111,1),(306,7460677,7460668,'ide',12.5,1),(306,7460678,7460668,'den',12.5,1),(306,7460679,7460668,'ent',12.5,1),(306,7460680,7460668,'nti',12.5,1),(306,7460681,7460668,'tif',12.5,1),(306,7460682,7460668,'ifi',12.5,1),(306,7460683,7460668,'fie',12.5,1),(306,7460684,7460668,'ier',12.5,1),(306,7460685,7460677,'vdi',33.333,3),(306,7460686,7460677,'dis',33.333,3),(306,7460687,7460677,'isk',33.333,3),(306,7460688,7460685,'nam',50,1),(306,7460689,7460685,'ame',50,1),(306,7460690,7460688,'typ',50,1),(306,7460691,7460688,'ype',50,1),(306,7460692,7460690,'dir',25,1),(306,7460693,7460690,'ire',25,1),(306,7460694,7460690,'rec',25,1),(306,7460695,7460690,'ect',25,1),(307,7460697,7460696,'naa',100,2),(307,7460698,7460697,'600',3.333,3),(307,7460699,7460697,'000',3.333,3),(307,7460700,7460697,'00c',3.333,3),(307,7460701,7460697,'0c2',3.333,3),(307,7460702,7460697,'c29',3.333,3),(307,7460703,7460697,'292',3.333,3),(307,7460704,7460697,'929',3.333,3),(307,7460705,7460697,'295',3.333,3),(307,7460706,7460697,'953',3.333,3),(307,7460707,7460697,'533',3.333,3),(307,7460708,7460697,'33f',3.333,3),(307,7460709,7460697,'3fd',3.333,3),(307,7460710,7460697,'fd5',3.333,3),(307,7460711,7460697,'d5b',3.333,3),(307,7460712,7460697,'5be',3.333,3),(307,7460713,7460697,'be2',3.333,3),(307,7460714,7460697,'e20',3.333,3),(307,7460715,7460697,'20e',3.333,3),(307,7460716,7460697,'0eb',3.333,3),(307,7460717,7460697,'eb5',3.333,3),(307,7460718,7460697,'b5c',3.333,3),(307,7460719,7460697,'5cc',3.333,3),(307,7460720,7460697,'cc8',3.333,3),(307,7460721,7460697,'c84',3.333,3),(307,7460722,7460697,'847',3.333,3),(307,7460723,7460697,'47a',3.333,3),(307,7460724,7460697,'7a1',3.333,3),(307,7460725,7460697,'a13',3.333,3),(307,7460726,7460697,'13e',3.333,3),(307,7460727,7460697,'3ed',3.333,3),(307,7460728,7460698,'mon',100,1),(307,7460729,7460728,'201',50,1),(307,7460730,7460728,'013',50,1),(307,7460731,7460729,'adm',33.333,3),(307,7460732,7460729,'dmi',33.333,3),(307,7460733,7460729,'min',33.333,3),(307,7460734,7460731,'cap',16.667,1),(307,7460735,7460731,'apa',16.667,1),(307,7460736,7460731,'pac',16.667,1),(307,7460737,7460731,'aci',16.667,1),(307,7460738,7460731,'cit',16.667,1),(307,7460739,7460731,'ity',16.667,1),(307,7460740,7460734,'pat',50,1),(307,7460741,7460734,'ath',50,1),(307,7460742,7460740,'thr',33.333,1),(307,7460743,7460740,'hre',33.333,1),(307,7460744,7460740,'ree',33.333,1),(307,7460745,7460742,'fre',14.286,1),(307,7460746,7460742,'ree',14.286,1),(307,7460747,7460742,'ees',14.286,1),(307,7460748,7460742,'esp',14.286,1),(307,7460749,7460742,'spa',14.286,1),(307,7460750,7460742,'pac',14.286,1),(307,7460751,7460742,'ace',14.286,1),(307,7460752,7460745,'dis',50,1),(307,7460753,7460745,'isk',50,1),(307,7460754,7460752,'ind',33.333,1),(307,7460755,7460752,'nde',33.333,1),(307,7460756,7460752,'dex',33.333,1),(307,7460757,7460754,'adm',8.333,1),(307,7460758,7460754,'dmi',8.333,1),(307,7460759,7460754,'min',8.333,1),(307,7460760,7460754,'ini',8.333,1),(307,7460761,7460754,'nis',8.333,1),(307,7460762,7460754,'ist',8.333,1),(307,7460763,7460754,'str',8.333,1),(307,7460764,7460754,'tra',8.333,1),(307,7460765,7460754,'rat',8.333,1),(307,7460766,7460754,'ati',8.333,1),(307,7460767,7460754,'tio',8.333,1),(307,7460768,7460754,'ion',8.333,1),(307,7460769,7460757,'sta',33.333,3),(307,7460770,7460757,'tat',33.333,3),(307,7460771,7460757,'ate',33.333,3),(307,7460772,7460769,'ena',20,2),(307,7460773,7460769,'nab',20,2),(307,7460774,7460769,'abl',20,2),(307,7460775,7460769,'ble',20,2),(307,7460776,7460769,'led',20,2),(307,7460777,7460772,'cac',33.333,1),(307,7460778,7460772,'ach',33.333,1),(307,7460779,7460772,'che',33.333,1),(307,7460780,7460777,'mod',50,2),(307,7460781,7460777,'ode',50,2),(307,7460782,7460780,'wri',14.286,2),(307,7460783,7460780,'rit',14.286,2),(307,7460784,7460780,'ite',14.286,2),(307,7460785,7460780,'tet',14.286,2),(307,7460786,7460780,'eth',14.286,2),(307,7460787,7460780,'thr',14.286,2),(307,7460788,7460780,'hru',14.286,2),(307,7460789,7460782,'ope',11.111,2),(307,7460790,7460782,'per',11.111,2),(307,7460791,7460782,'era',11.111,2),(307,7460792,7460782,'rat',11.111,2),(307,7460793,7460782,'ati',11.111,2),(307,7460794,7460782,'tio',11.111,2),(307,7460795,7460782,'ion',11.111,2),(307,7460796,7460782,'ona',11.111,2),(307,7460797,7460782,'nal',11.111,2),(307,7460798,7460789,'nor',25,1),(307,7460799,7460789,'orm',25,1),(307,7460800,7460789,'rma',25,1),(307,7460801,7460789,'mal',25,1),(307,7460802,7460798,'mes',20,1),(307,7460803,7460798,'ess',20,1),(307,7460804,7460798,'ssa',20,1),(307,7460805,7460798,'sag',20,1),(307,7460806,7460798,'age',20,1),(307,7460807,7460802,'per',11.111,1),(307,7460808,7460802,'erf',11.111,1),(307,7460809,7460802,'rfo',11.111,1),(307,7460810,7460802,'for',11.111,1),(307,7460811,7460802,'orm',11.111,1),(307,7460812,7460802,'rma',11.111,1),(307,7460813,7460802,'man',11.111,1),(307,7460814,7460802,'anc',11.111,1),(307,7460815,7460802,'nce',11.111,1),(307,7460816,7460807,'ide',12.5,1),(307,7460817,7460807,'den',12.5,1),(307,7460818,7460807,'ent',12.5,1),(307,7460819,7460807,'nti',12.5,1),(307,7460820,7460807,'tif',12.5,1),(307,7460821,7460807,'ifi',12.5,1),(307,7460822,7460807,'fie',12.5,1),(307,7460823,7460807,'ier',12.5,1),(307,7460824,7460816,'vdi',33.333,3),(307,7460825,7460816,'dis',33.333,3),(307,7460826,7460816,'isk',33.333,3),(307,7460827,7460824,'nam',50,1),(307,7460828,7460824,'ame',50,1),(307,7460829,7460827,'typ',50,1),(307,7460830,7460827,'ype',50,1),(307,7460831,7460829,'dir',25,1),(307,7460832,7460829,'ire',25,1),(307,7460833,7460829,'rec',25,1),(307,7460834,7460829,'ect',25,1),(308,7460836,7460835,'naa',100,2),(308,7460837,7460836,'600',3.333,3),(308,7460838,7460836,'000',3.333,3),(308,7460839,7460836,'00c',3.333,3),(308,7460840,7460836,'0c2',3.333,3),(308,7460841,7460836,'c29',3.333,3),(308,7460842,7460836,'298',3.333,3),(308,7460843,7460836,'98a',3.333,3),(308,7460844,7460836,'8a3',3.333,3),(308,7460845,7460836,'a30',3.333,3),(308,7460846,7460836,'30b',3.333,3),(308,7460847,7460836,'0b9',3.333,3),(308,7460848,7460836,'b94',3.333,3),(308,7460849,7460836,'947',3.333,3),(308,7460850,7460836,'471',3.333,3),(308,7460851,7460836,'717',3.333,3),(308,7460852,7460836,'17e',3.333,3),(308,7460853,7460836,'7e0',3.333,3),(308,7460854,7460836,'e0a',3.333,3),(308,7460855,7460836,'0a7',3.333,3),(308,7460856,7460836,'a7b',3.333,3),(308,7460857,7460836,'7b8',3.333,3),(308,7460858,7460836,'b89',3.333,3),(308,7460859,7460836,'89a',3.333,3),(308,7460860,7460836,'9a2',3.333,3),(308,7460861,7460836,'a24',3.333,3),(308,7460862,7460836,'247',3.333,3),(308,7460863,7460836,'473',3.333,3),(308,7460864,7460836,'73c',3.333,3),(308,7460865,7460836,'3c2',3.333,3),(308,7460866,7460836,'c29',3.333,3),(308,7460867,7460837,'mon',100,1),(308,7460868,7460867,'201',50,1),(308,7460869,7460867,'013',50,1),(308,7460870,7460868,'adm',33.333,3),(308,7460871,7460868,'dmi',33.333,3),(308,7460872,7460868,'min',33.333,3),(308,7460873,7460870,'cap',16.667,1),(308,7460874,7460870,'apa',16.667,1),(308,7460875,7460870,'pac',16.667,1),(308,7460876,7460870,'aci',16.667,1),(308,7460877,7460870,'cit',16.667,1),(308,7460878,7460870,'ity',16.667,1),(308,7460879,7460873,'pat',50,1),(308,7460880,7460873,'ath',50,1),(308,7460881,7460879,'fou',50,1),(308,7460882,7460879,'our',50,1),(308,7460883,7460881,'fre',14.286,1),(308,7460884,7460881,'ree',14.286,1),(308,7460885,7460881,'ees',14.286,1),(308,7460886,7460881,'esp',14.286,1),(308,7460887,7460881,'spa',14.286,1),(308,7460888,7460881,'pac',14.286,1),(308,7460889,7460881,'ace',14.286,1),(308,7460890,7460883,'dis',50,1),(308,7460891,7460883,'isk',50,1),(308,7460892,7460890,'ind',33.333,1),(308,7460893,7460890,'nde',33.333,1),(308,7460894,7460890,'dex',33.333,1),(308,7460895,7460892,'adm',8.333,1),(308,7460896,7460892,'dmi',8.333,1),(308,7460897,7460892,'min',8.333,1),(308,7460898,7460892,'ini',8.333,1),(308,7460899,7460892,'nis',8.333,1),(308,7460900,7460892,'ist',8.333,1),(308,7460901,7460892,'str',8.333,1),(308,7460902,7460892,'tra',8.333,1),(308,7460903,7460892,'rat',8.333,1),(308,7460904,7460892,'ati',8.333,1),(308,7460905,7460892,'tio',8.333,1),(308,7460906,7460892,'ion',8.333,1),(308,7460907,7460895,'sta',33.333,3),(308,7460908,7460895,'tat',33.333,3),(308,7460909,7460895,'ate',33.333,3),(308,7460910,7460907,'ena',20,2),(308,7460911,7460907,'nab',20,2),(308,7460912,7460907,'abl',20,2),(308,7460913,7460907,'ble',20,2),(308,7460914,7460907,'led',20,2),(308,7460915,7460910,'cac',33.333,1),(308,7460916,7460910,'ach',33.333,1),(308,7460917,7460910,'che',33.333,1),(308,7460918,7460915,'mod',50,2),(308,7460919,7460915,'ode',50,2),(308,7460920,7460918,'wri',14.286,2),(308,7460921,7460918,'rit',14.286,2),(308,7460922,7460918,'ite',14.286,2),(308,7460923,7460918,'tet',14.286,2),(308,7460924,7460918,'eth',14.286,2),(308,7460925,7460918,'thr',14.286,2),(308,7460926,7460918,'hru',14.286,2),(308,7460927,7460920,'ope',11.111,2),(308,7460928,7460920,'per',11.111,2),(308,7460929,7460920,'era',11.111,2),(308,7460930,7460920,'rat',11.111,2),(308,7460931,7460920,'ati',11.111,2),(308,7460932,7460920,'tio',11.111,2),(308,7460933,7460920,'ion',11.111,2),(308,7460934,7460920,'ona',11.111,2),(308,7460935,7460920,'nal',11.111,2),(308,7460936,7460927,'nor',25,1),(308,7460937,7460927,'orm',25,1),(308,7460938,7460927,'rma',25,1),(308,7460939,7460927,'mal',25,1),(308,7460940,7460936,'mes',20,1),(308,7460941,7460936,'ess',20,1),(308,7460942,7460936,'ssa',20,1),(308,7460943,7460936,'sag',20,1),(308,7460944,7460936,'age',20,1),(308,7460945,7460940,'per',11.111,1),(308,7460946,7460940,'erf',11.111,1),(308,7460947,7460940,'rfo',11.111,1),(308,7460948,7460940,'for',11.111,1),(308,7460949,7460940,'orm',11.111,1),(308,7460950,7460940,'rma',11.111,1),(308,7460951,7460940,'man',11.111,1),(308,7460952,7460940,'anc',11.111,1),(308,7460953,7460940,'nce',11.111,1),(308,7460954,7460945,'ide',12.5,1),(308,7460955,7460945,'den',12.5,1),(308,7460956,7460945,'ent',12.5,1),(308,7460957,7460945,'nti',12.5,1),(308,7460958,7460945,'tif',12.5,1),(308,7460959,7460945,'ifi',12.5,1),(308,7460960,7460945,'fie',12.5,1),(308,7460961,7460945,'ier',12.5,1),(308,7460962,7460954,'vdi',33.333,3),(308,7460963,7460954,'dis',33.333,3),(308,7460964,7460954,'isk',33.333,3),(308,7460965,7460962,'nam',50,1),(308,7460966,7460962,'ame',50,1),(308,7460967,7460965,'typ',50,1),(308,7460968,7460965,'ype',50,1),(308,7460969,7460967,'dir',25,1),(308,7460970,7460967,'ire',25,1),(308,7460971,7460967,'rec',25,1),(308,7460972,7460967,'ect',25,1),(309,7460974,7460973,'naa',100,2),(309,7460975,7460974,'600',3.333,3),(309,7460976,7460974,'000',3.333,3),(309,7460977,7460974,'00c',3.333,3),(309,7460978,7460974,'0c2',3.333,3),(309,7460979,7460974,'c29',3.333,3),(309,7460980,7460974,'29b',3.333,3),(309,7460981,7460974,'9ba',3.333,3),(309,7460982,7460974,'ba4',3.333,3),(309,7460983,7460974,'a45',3.333,3),(309,7460984,7460974,'450',3.333,3),(309,7460985,7460974,'507',3.333,3),(309,7460986,7460974,'079',3.333,3),(309,7460987,7460974,'796',3.333,3),(309,7460988,7460974,'964',3.333,3),(309,7460989,7460974,'64d',3.333,3),(309,7460990,7460974,'4df',3.333,3),(309,7460991,7460974,'dff',3.333,3),(309,7460992,7460974,'ff0',3.333,3),(309,7460993,7460974,'f0a',3.333,3),(309,7460994,7460974,'0ad',3.333,3),(309,7460995,7460974,'ad7',3.333,3),(309,7460996,7460974,'d72',3.333,3),(309,7460997,7460974,'72b',3.333,3),(309,7460998,7460974,'2b7',3.333,3),(309,7460999,7460974,'b70',3.333,3),(309,7461000,7460974,'70a',3.333,3),(309,7461001,7460974,'0af',3.333,3),(309,7461002,7460974,'afb',3.333,3),(309,7461003,7460974,'fbb',3.333,3),(309,7461004,7460974,'bbe',3.333,3),(309,7461005,7460975,'mon',100,1),(309,7461006,7461005,'201',50,1),(309,7461007,7461005,'013',50,1),(309,7461008,7461006,'adm',33.333,3),(309,7461009,7461006,'dmi',33.333,3),(309,7461010,7461006,'min',33.333,3),(309,7461011,7461008,'cap',16.667,1),(309,7461012,7461008,'apa',16.667,1),(309,7461013,7461008,'pac',16.667,1),(309,7461014,7461008,'aci',16.667,1),(309,7461015,7461008,'cit',16.667,1),(309,7461016,7461008,'ity',16.667,1),(309,7461017,7461011,'pat',50,1),(309,7461018,7461011,'ath',50,1),(309,7461019,7461017,'fiv',50,1),(309,7461020,7461017,'ive',50,1),(309,7461021,7461019,'fre',14.286,1),(309,7461022,7461019,'ree',14.286,1),(309,7461023,7461019,'ees',14.286,1),(309,7461024,7461019,'esp',14.286,1),(309,7461025,7461019,'spa',14.286,1),(309,7461026,7461019,'pac',14.286,1),(309,7461027,7461019,'ace',14.286,1),(309,7461028,7461021,'dis',50,1),(309,7461029,7461021,'isk',50,1),(309,7461030,7461028,'ind',33.333,1),(309,7461031,7461028,'nde',33.333,1),(309,7461032,7461028,'dex',33.333,1),(309,7461033,7461030,'adm',8.333,1),(309,7461034,7461030,'dmi',8.333,1),(309,7461035,7461030,'min',8.333,1),(309,7461036,7461030,'ini',8.333,1),(309,7461037,7461030,'nis',8.333,1),(309,7461038,7461030,'ist',8.333,1),(309,7461039,7461030,'str',8.333,1),(309,7461040,7461030,'tra',8.333,1),(309,7461041,7461030,'rat',8.333,1),(309,7461042,7461030,'ati',8.333,1),(309,7461043,7461030,'tio',8.333,1),(309,7461044,7461030,'ion',8.333,1),(309,7461045,7461033,'sta',33.333,3),(309,7461046,7461033,'tat',33.333,3),(309,7461047,7461033,'ate',33.333,3),(309,7461048,7461045,'ena',20,2),(309,7461049,7461045,'nab',20,2),(309,7461050,7461045,'abl',20,2),(309,7461051,7461045,'ble',20,2),(309,7461052,7461045,'led',20,2),(309,7461053,7461048,'cac',33.333,1),(309,7461054,7461048,'ach',33.333,1),(309,7461055,7461048,'che',33.333,1),(309,7461056,7461053,'mod',50,2),(309,7461057,7461053,'ode',50,2),(309,7461058,7461056,'wri',14.286,2),(309,7461059,7461056,'rit',14.286,2),(309,7461060,7461056,'ite',14.286,2),(309,7461061,7461056,'tet',14.286,2),(309,7461062,7461056,'eth',14.286,2),(309,7461063,7461056,'thr',14.286,2),(309,7461064,7461056,'hru',14.286,2),(309,7461065,7461058,'ope',11.111,2),(309,7461066,7461058,'per',11.111,2),(309,7461067,7461058,'era',11.111,2),(309,7461068,7461058,'rat',11.111,2),(309,7461069,7461058,'ati',11.111,2),(309,7461070,7461058,'tio',11.111,2),(309,7461071,7461058,'ion',11.111,2),(309,7461072,7461058,'ona',11.111,2),(309,7461073,7461058,'nal',11.111,2),(309,7461074,7461065,'nor',25,1),(309,7461075,7461065,'orm',25,1),(309,7461076,7461065,'rma',25,1),(309,7461077,7461065,'mal',25,1),(309,7461078,7461074,'mes',20,1),(309,7461079,7461074,'ess',20,1),(309,7461080,7461074,'ssa',20,1),(309,7461081,7461074,'sag',20,1),(309,7461082,7461074,'age',20,1),(309,7461083,7461078,'per',11.111,1),(309,7461084,7461078,'erf',11.111,1),(309,7461085,7461078,'rfo',11.111,1),(309,7461086,7461078,'for',11.111,1),(309,7461087,7461078,'orm',11.111,1),(309,7461088,7461078,'rma',11.111,1),(309,7461089,7461078,'man',11.111,1),(309,7461090,7461078,'anc',11.111,1),(309,7461091,7461078,'nce',11.111,1),(309,7461092,7461083,'ide',12.5,1),(309,7461093,7461083,'den',12.5,1),(309,7461094,7461083,'ent',12.5,1),(309,7461095,7461083,'nti',12.5,1),(309,7461096,7461083,'tif',12.5,1),(309,7461097,7461083,'ifi',12.5,1),(309,7461098,7461083,'fie',12.5,1),(309,7461099,7461083,'ier',12.5,1),(309,7461100,7461092,'vdi',33.333,3),(309,7461101,7461092,'dis',33.333,3),(309,7461102,7461092,'isk',33.333,3),(309,7461103,7461100,'nam',50,1),(309,7461104,7461100,'ame',50,1),(309,7461105,7461103,'typ',50,1),(309,7461106,7461103,'ype',50,1),(309,7461107,7461105,'dir',25,1),(309,7461108,7461105,'ire',25,1),(309,7461109,7461105,'rec',25,1),(309,7461110,7461105,'ect',25,1),(310,7461112,7461111,'naa',100,2),(310,7461113,7461112,'600',3.333,3),(310,7461114,7461112,'000',3.333,3),(310,7461115,7461112,'00c',3.333,3),(310,7461116,7461112,'0c2',3.333,3),(310,7461117,7461112,'c29',3.333,3),(310,7461118,7461112,'298',3.333,3),(310,7461119,7461112,'98d',3.333,3),(310,7461120,7461112,'8d5',3.333,3),(310,7461121,7461112,'d5e',3.333,3),(310,7461122,7461112,'5ef',3.333,3),(310,7461123,7461112,'ef3',3.333,3),(310,7461124,7461112,'f35',3.333,3),(310,7461125,7461112,'350',3.333,3),(310,7461126,7461112,'507',3.333,3),(310,7461127,7461112,'077',3.333,3),(310,7461128,7461112,'777',3.333,3),(310,7461129,7461112,'77b',3.333,3),(310,7461130,7461112,'7b9',3.333,3),(310,7461131,7461112,'b9f',3.333,3),(310,7461132,7461112,'9f2',3.333,3),(310,7461133,7461112,'f2b',3.333,3),(310,7461134,7461112,'2be',3.333,3),(310,7461135,7461112,'be8',3.333,3),(310,7461136,7461112,'e8b',3.333,3),(310,7461137,7461112,'8ba',3.333,3),(310,7461138,7461112,'ba3',3.333,3),(310,7461139,7461112,'a3e',3.333,3),(310,7461140,7461112,'3ef',3.333,3),(310,7461141,7461112,'ef9',3.333,3),(310,7461142,7461112,'f94',3.333,3),(310,7461143,7461113,'mon',100,1),(310,7461144,7461143,'201',50,1),(310,7461145,7461143,'013',50,1),(310,7461146,7461144,'adm',33.333,3),(310,7461147,7461144,'dmi',33.333,3),(310,7461148,7461144,'min',33.333,3),(310,7461149,7461146,'cap',16.667,1),(310,7461150,7461146,'apa',16.667,1),(310,7461151,7461146,'pac',16.667,1),(310,7461152,7461146,'aci',16.667,1),(310,7461153,7461146,'cit',16.667,1),(310,7461154,7461146,'ity',16.667,1),(310,7461155,7461149,'pat',50,1),(310,7461156,7461149,'ath',50,1),(310,7461157,7461155,'six',100,1),(310,7461158,7461157,'fre',14.286,1),(310,7461159,7461157,'ree',14.286,1),(310,7461160,7461157,'ees',14.286,1),(310,7461161,7461157,'esp',14.286,1),(310,7461162,7461157,'spa',14.286,1),(310,7461163,7461157,'pac',14.286,1),(310,7461164,7461157,'ace',14.286,1),(310,7461165,7461158,'dis',50,1),(310,7461166,7461158,'isk',50,1),(310,7461167,7461165,'ind',33.333,1),(310,7461168,7461165,'nde',33.333,1),(310,7461169,7461165,'dex',33.333,1),(310,7461170,7461167,'adm',8.333,1),(310,7461171,7461167,'dmi',8.333,1),(310,7461172,7461167,'min',8.333,1),(310,7461173,7461167,'ini',8.333,1),(310,7461174,7461167,'nis',8.333,1),(310,7461175,7461167,'ist',8.333,1),(310,7461176,7461167,'str',8.333,1),(310,7461177,7461167,'tra',8.333,1),(310,7461178,7461167,'rat',8.333,1),(310,7461179,7461167,'ati',8.333,1),(310,7461180,7461167,'tio',8.333,1),(310,7461181,7461167,'ion',8.333,1),(310,7461182,7461170,'sta',33.333,3),(310,7461183,7461170,'tat',33.333,3),(310,7461184,7461170,'ate',33.333,3),(310,7461185,7461182,'ena',20,2),(310,7461186,7461182,'nab',20,2),(310,7461187,7461182,'abl',20,2),(310,7461188,7461182,'ble',20,2),(310,7461189,7461182,'led',20,2),(310,7461190,7461185,'cac',33.333,1),(310,7461191,7461185,'ach',33.333,1),(310,7461192,7461185,'che',33.333,1),(310,7461193,7461190,'mod',50,2),(310,7461194,7461190,'ode',50,2),(310,7461195,7461193,'wri',14.286,2),(310,7461196,7461193,'rit',14.286,2),(310,7461197,7461193,'ite',14.286,2),(310,7461198,7461193,'tet',14.286,2),(310,7461199,7461193,'eth',14.286,2),(310,7461200,7461193,'thr',14.286,2),(310,7461201,7461193,'hru',14.286,2),(310,7461202,7461195,'ope',11.111,2),(310,7461203,7461195,'per',11.111,2),(310,7461204,7461195,'era',11.111,2),(310,7461205,7461195,'rat',11.111,2),(310,7461206,7461195,'ati',11.111,2),(310,7461207,7461195,'tio',11.111,2),(310,7461208,7461195,'ion',11.111,2),(310,7461209,7461195,'ona',11.111,2),(310,7461210,7461195,'nal',11.111,2),(310,7461211,7461202,'nor',25,1),(310,7461212,7461202,'orm',25,1),(310,7461213,7461202,'rma',25,1),(310,7461214,7461202,'mal',25,1),(310,7461215,7461211,'mes',20,1),(310,7461216,7461211,'ess',20,1),(310,7461217,7461211,'ssa',20,1),(310,7461218,7461211,'sag',20,1),(310,7461219,7461211,'age',20,1),(310,7461220,7461215,'per',11.111,1),(310,7461221,7461215,'erf',11.111,1),(310,7461222,7461215,'rfo',11.111,1),(310,7461223,7461215,'for',11.111,1),(310,7461224,7461215,'orm',11.111,1),(310,7461225,7461215,'rma',11.111,1),(310,7461226,7461215,'man',11.111,1),(310,7461227,7461215,'anc',11.111,1),(310,7461228,7461215,'nce',11.111,1),(310,7461229,7461220,'ide',12.5,1),(310,7461230,7461220,'den',12.5,1),(310,7461231,7461220,'ent',12.5,1),(310,7461232,7461220,'nti',12.5,1),(310,7461233,7461220,'tif',12.5,1),(310,7461234,7461220,'ifi',12.5,1),(310,7461235,7461220,'fie',12.5,1),(310,7461236,7461220,'ier',12.5,1),(310,7461237,7461229,'vdi',33.333,3),(310,7461238,7461229,'dis',33.333,3),(310,7461239,7461229,'isk',33.333,3),(310,7461240,7461237,'nam',50,1),(310,7461241,7461237,'ame',50,1),(310,7461242,7461240,'typ',50,1),(310,7461243,7461240,'ype',50,1),(310,7461244,7461242,'dir',25,1),(310,7461245,7461242,'ire',25,1),(310,7461246,7461242,'rec',25,1),(310,7461247,7461242,'ect',25,1),(311,7461249,7461248,'naa',100,2),(311,7461250,7461249,'600',3.333,3),(311,7461251,7461249,'000',3.333,3),(311,7461252,7461249,'00c',3.333,3),(311,7461253,7461249,'0c2',3.333,3),(311,7461254,7461249,'c29',3.333,3),(311,7461255,7461249,'294',3.333,3),(311,7461256,7461249,'941',3.333,3),(311,7461257,7461249,'41f',3.333,3),(311,7461258,7461249,'1f9',3.333,3),(311,7461259,7461249,'f98',3.333,3),(311,7461260,7461249,'98a',3.333,3),(311,7461261,7461249,'8a8',3.333,3),(311,7461262,7461249,'a8f',3.333,3),(311,7461263,7461249,'8f5',3.333,3),(311,7461264,7461249,'f55',3.333,3),(311,7461265,7461249,'551',3.333,3),(311,7461266,7461249,'513',3.333,3),(311,7461267,7461249,'137',3.333,3),(311,7461268,7461249,'379',3.333,3),(311,7461269,7461249,'79b',3.333,3),(311,7461270,7461249,'9b3',3.333,3),(311,7461271,7461249,'b37',3.333,3),(311,7461272,7461249,'37f',3.333,3),(311,7461273,7461249,'7f7',3.333,3),(311,7461274,7461249,'f77',3.333,3),(311,7461275,7461249,'771',3.333,3),(311,7461276,7461249,'715',3.333,3),(311,7461277,7461249,'15f',3.333,3),(311,7461278,7461249,'5f1',3.333,3),(311,7461279,7461249,'f14',3.333,3),(311,7461280,7461250,'mon',100,1),(311,7461281,7461280,'201',50,1),(311,7461282,7461280,'013',50,1),(311,7461283,7461281,'adm',33.333,3),(311,7461284,7461281,'dmi',33.333,3),(311,7461285,7461281,'min',33.333,3),(311,7461286,7461283,'cap',16.667,1),(311,7461287,7461283,'apa',16.667,1),(311,7461288,7461283,'pac',16.667,1),(311,7461289,7461283,'aci',16.667,1),(311,7461290,7461283,'cit',16.667,1),(311,7461291,7461283,'ity',16.667,1),(311,7461292,7461286,'pat',50,1),(311,7461293,7461286,'ath',50,1),(311,7461294,7461292,'sev',33.333,1),(311,7461295,7461292,'eve',33.333,1),(311,7461296,7461292,'ven',33.333,1),(311,7461297,7461294,'fre',14.286,1),(311,7461298,7461294,'ree',14.286,1),(311,7461299,7461294,'ees',14.286,1),(311,7461300,7461294,'esp',14.286,1),(311,7461301,7461294,'spa',14.286,1),(311,7461302,7461294,'pac',14.286,1),(311,7461303,7461294,'ace',14.286,1),(311,7461304,7461297,'dis',50,1),(311,7461305,7461297,'isk',50,1),(311,7461306,7461304,'ind',33.333,1),(311,7461307,7461304,'nde',33.333,1),(311,7461308,7461304,'dex',33.333,1),(311,7461309,7461306,'adm',8.333,1),(311,7461310,7461306,'dmi',8.333,1),(311,7461311,7461306,'min',8.333,1),(311,7461312,7461306,'ini',8.333,1),(311,7461313,7461306,'nis',8.333,1),(311,7461314,7461306,'ist',8.333,1),(311,7461315,7461306,'str',8.333,1),(311,7461316,7461306,'tra',8.333,1),(311,7461317,7461306,'rat',8.333,1),(311,7461318,7461306,'ati',8.333,1),(311,7461319,7461306,'tio',8.333,1),(311,7461320,7461306,'ion',8.333,1),(311,7461321,7461309,'sta',33.333,3),(311,7461322,7461309,'tat',33.333,3),(311,7461323,7461309,'ate',33.333,3),(311,7461324,7461321,'ena',20,2),(311,7461325,7461321,'nab',20,2),(311,7461326,7461321,'abl',20,2),(311,7461327,7461321,'ble',20,2),(311,7461328,7461321,'led',20,2),(311,7461329,7461324,'cac',33.333,1),(311,7461330,7461324,'ach',33.333,1),(311,7461331,7461324,'che',33.333,1),(311,7461332,7461329,'mod',50,2),(311,7461333,7461329,'ode',50,2),(311,7461334,7461332,'wri',14.286,2),(311,7461335,7461332,'rit',14.286,2),(311,7461336,7461332,'ite',14.286,2),(311,7461337,7461332,'tet',14.286,2),(311,7461338,7461332,'eth',14.286,2),(311,7461339,7461332,'thr',14.286,2),(311,7461340,7461332,'hru',14.286,2),(311,7461341,7461334,'ope',11.111,2),(311,7461342,7461334,'per',11.111,2),(311,7461343,7461334,'era',11.111,2),(311,7461344,7461334,'rat',11.111,2),(311,7461345,7461334,'ati',11.111,2),(311,7461346,7461334,'tio',11.111,2),(311,7461347,7461334,'ion',11.111,2),(311,7461348,7461334,'ona',11.111,2),(311,7461349,7461334,'nal',11.111,2),(311,7461350,7461341,'nor',25,1),(311,7461351,7461341,'orm',25,1),(311,7461352,7461341,'rma',25,1),(311,7461353,7461341,'mal',25,1),(311,7461354,7461350,'mes',20,1),(311,7461355,7461350,'ess',20,1),(311,7461356,7461350,'ssa',20,1),(311,7461357,7461350,'sag',20,1),(311,7461358,7461350,'age',20,1),(311,7461359,7461354,'per',11.111,1),(311,7461360,7461354,'erf',11.111,1),(311,7461361,7461354,'rfo',11.111,1),(311,7461362,7461354,'for',11.111,1),(311,7461363,7461354,'orm',11.111,1),(311,7461364,7461354,'rma',11.111,1),(311,7461365,7461354,'man',11.111,1),(311,7461366,7461354,'anc',11.111,1),(311,7461367,7461354,'nce',11.111,1),(311,7461368,7461359,'ide',12.5,1),(311,7461369,7461359,'den',12.5,1),(311,7461370,7461359,'ent',12.5,1),(311,7461371,7461359,'nti',12.5,1),(311,7461372,7461359,'tif',12.5,1),(311,7461373,7461359,'ifi',12.5,1),(311,7461374,7461359,'fie',12.5,1),(311,7461375,7461359,'ier',12.5,1),(311,7461376,7461368,'vdi',33.333,3),(311,7461377,7461368,'dis',33.333,3),(311,7461378,7461368,'isk',33.333,3),(311,7461379,7461376,'nam',50,1),(311,7461380,7461376,'ame',50,1),(311,7461381,7461379,'typ',50,1),(311,7461382,7461379,'ype',50,1),(311,7461383,7461381,'dir',25,1),(311,7461384,7461381,'ire',25,1),(311,7461385,7461381,'rec',25,1),(311,7461386,7461381,'ect',25,1),(312,7461388,7461387,'naa',100,2),(312,7461389,7461388,'600',3.333,3),(312,7461390,7461388,'000',3.333,3),(312,7461391,7461388,'00c',3.333,3),(312,7461392,7461388,'0c2',3.333,3),(312,7461393,7461388,'c29',3.333,3),(312,7461394,7461388,'296',3.333,3),(312,7461395,7461388,'96e',3.333,3),(312,7461396,7461388,'6ef',3.333,3),(312,7461397,7461388,'efb',3.333,3),(312,7461398,7461388,'fb8',3.333,3),(312,7461399,7461388,'b83',3.333,3),(312,7461400,7461388,'831',3.333,3),(312,7461401,7461388,'31d',3.333,3),(312,7461402,7461388,'1d1',3.333,3),(312,7461403,7461388,'d18',3.333,3),(312,7461404,7461388,'187',3.333,3),(312,7461405,7461388,'874',3.333,3),(312,7461406,7461388,'740',3.333,3),(312,7461407,7461388,'40d',3.333,3),(312,7461408,7461388,'0de',3.333,3),(312,7461409,7461388,'de6',3.333,3),(312,7461410,7461388,'e67',3.333,3),(312,7461411,7461388,'67a',3.333,3),(312,7461412,7461388,'7a8',3.333,3),(312,7461413,7461388,'a82',3.333,3),(312,7461414,7461388,'821',3.333,3),(312,7461415,7461388,'212',3.333,3),(312,7461416,7461388,'12b',3.333,3),(312,7461417,7461388,'2ba',3.333,3),(312,7461418,7461388,'ba3',3.333,3),(312,7461419,7461389,'mon',100,1),(312,7461420,7461419,'201',50,1),(312,7461421,7461419,'013',50,1),(312,7461422,7461420,'adm',33.333,3),(312,7461423,7461420,'dmi',33.333,3),(312,7461424,7461420,'min',33.333,3),(312,7461425,7461422,'cap',16.667,1),(312,7461426,7461422,'apa',16.667,1),(312,7461427,7461422,'pac',16.667,1),(312,7461428,7461422,'aci',16.667,1),(312,7461429,7461422,'cit',16.667,1),(312,7461430,7461422,'ity',16.667,1),(312,7461431,7461425,'pat',50,1),(312,7461432,7461425,'ath',50,1),(312,7461433,7461431,'eig',33.333,1),(312,7461434,7461431,'igh',33.333,1),(312,7461435,7461431,'ght',33.333,1),(312,7461436,7461433,'fre',14.286,1),(312,7461437,7461433,'ree',14.286,1),(312,7461438,7461433,'ees',14.286,1),(312,7461439,7461433,'esp',14.286,1),(312,7461440,7461433,'spa',14.286,1),(312,7461441,7461433,'pac',14.286,1),(312,7461442,7461433,'ace',14.286,1),(312,7461443,7461436,'dis',50,1),(312,7461444,7461436,'isk',50,1),(312,7461445,7461443,'ind',33.333,1),(312,7461446,7461443,'nde',33.333,1),(312,7461447,7461443,'dex',33.333,1),(312,7461448,7461445,'adm',8.333,1),(312,7461449,7461445,'dmi',8.333,1),(312,7461450,7461445,'min',8.333,1),(312,7461451,7461445,'ini',8.333,1),(312,7461452,7461445,'nis',8.333,1),(312,7461453,7461445,'ist',8.333,1),(312,7461454,7461445,'str',8.333,1),(312,7461455,7461445,'tra',8.333,1),(312,7461456,7461445,'rat',8.333,1),(312,7461457,7461445,'ati',8.333,1),(312,7461458,7461445,'tio',8.333,1),(312,7461459,7461445,'ion',8.333,1),(312,7461460,7461448,'sta',33.333,3),(312,7461461,7461448,'tat',33.333,3),(312,7461462,7461448,'ate',33.333,3),(312,7461463,7461460,'ena',20,2),(312,7461464,7461460,'nab',20,2),(312,7461465,7461460,'abl',20,2),(312,7461466,7461460,'ble',20,2),(312,7461467,7461460,'led',20,2),(312,7461468,7461463,'cac',33.333,1),(312,7461469,7461463,'ach',33.333,1),(312,7461470,7461463,'che',33.333,1),(312,7461471,7461468,'mod',50,2),(312,7461472,7461468,'ode',50,2),(312,7461473,7461471,'wri',14.286,2),(312,7461474,7461471,'rit',14.286,2),(312,7461475,7461471,'ite',14.286,2),(312,7461476,7461471,'tet',14.286,2),(312,7461477,7461471,'eth',14.286,2),(312,7461478,7461471,'thr',14.286,2),(312,7461479,7461471,'hru',14.286,2),(312,7461480,7461473,'ope',11.111,2),(312,7461481,7461473,'per',11.111,2),(312,7461482,7461473,'era',11.111,2),(312,7461483,7461473,'rat',11.111,2),(312,7461484,7461473,'ati',11.111,2),(312,7461485,7461473,'tio',11.111,2),(312,7461486,7461473,'ion',11.111,2),(312,7461487,7461473,'ona',11.111,2),(312,7461488,7461473,'nal',11.111,2),(312,7461489,7461480,'nor',25,1),(312,7461490,7461480,'orm',25,1),(312,7461491,7461480,'rma',25,1),(312,7461492,7461480,'mal',25,1),(312,7461493,7461489,'mes',20,1),(312,7461494,7461489,'ess',20,1),(312,7461495,7461489,'ssa',20,1),(312,7461496,7461489,'sag',20,1),(312,7461497,7461489,'age',20,1),(312,7461498,7461493,'per',11.111,1),(312,7461499,7461493,'erf',11.111,1),(312,7461500,7461493,'rfo',11.111,1),(312,7461501,7461493,'for',11.111,1),(312,7461502,7461493,'orm',11.111,1),(312,7461503,7461493,'rma',11.111,1),(312,7461504,7461493,'man',11.111,1),(312,7461505,7461493,'anc',11.111,1),(312,7461506,7461493,'nce',11.111,1),(312,7461507,7461498,'ide',12.5,1),(312,7461508,7461498,'den',12.5,1),(312,7461509,7461498,'ent',12.5,1),(312,7461510,7461498,'nti',12.5,1),(312,7461511,7461498,'tif',12.5,1),(312,7461512,7461498,'ifi',12.5,1),(312,7461513,7461498,'fie',12.5,1),(312,7461514,7461498,'ier',12.5,1),(312,7461515,7461507,'vdi',33.333,3),(312,7461516,7461507,'dis',33.333,3),(312,7461517,7461507,'isk',33.333,3),(312,7461518,7461515,'nam',50,1),(312,7461519,7461515,'ame',50,1),(312,7461520,7461518,'typ',50,1),(312,7461521,7461518,'ype',50,1),(312,7461522,7461520,'dir',25,1),(312,7461523,7461520,'ire',25,1),(312,7461524,7461520,'rec',25,1),(312,7461525,7461520,'ect',25,1),(313,7461527,7461526,'naa',100,2),(313,7461528,7461527,'600',3.333,3),(313,7461529,7461527,'000',3.333,3),(313,7461530,7461527,'00c',3.333,3),(313,7461531,7461527,'0c2',3.333,3),(313,7461532,7461527,'c29',3.333,3),(313,7461533,7461527,'29e',3.333,3),(313,7461534,7461527,'9ef',3.333,3),(313,7461535,7461527,'ef7',3.333,3),(313,7461536,7461527,'f7c',3.333,3),(313,7461537,7461527,'7c7',3.333,3),(313,7461538,7461527,'c74',3.333,3),(313,7461539,7461527,'743',3.333,3),(313,7461540,7461527,'43e',3.333,3),(313,7461541,7461527,'3ec',3.333,3),(313,7461542,7461527,'ec1',3.333,3),(313,7461543,7461527,'c1f',3.333,3),(313,7461544,7461527,'1f1',3.333,3),(313,7461545,7461527,'f1a',3.333,3),(313,7461546,7461527,'1ae',3.333,3),(313,7461547,7461527,'ae7',3.333,3),(313,7461548,7461527,'e77',3.333,3),(313,7461549,7461527,'77f',3.333,3),(313,7461550,7461527,'7fc',3.333,3),(313,7461551,7461527,'fc0',3.333,3),(313,7461552,7461527,'c08',3.333,3),(313,7461553,7461527,'08b',3.333,3),(313,7461554,7461527,'8b4',3.333,3),(313,7461555,7461527,'b4c',3.333,3),(313,7461556,7461527,'4c8',3.333,3),(313,7461557,7461527,'c8a',3.333,3),(313,7461558,7461528,'mon',100,1),(313,7461559,7461558,'201',50,1),(313,7461560,7461558,'013',50,1),(313,7461561,7461559,'adm',33.333,3),(313,7461562,7461559,'dmi',33.333,3),(313,7461563,7461559,'min',33.333,3),(313,7461564,7461561,'cap',16.667,1),(313,7461565,7461561,'apa',16.667,1),(313,7461566,7461561,'pac',16.667,1),(313,7461567,7461561,'aci',16.667,1),(313,7461568,7461561,'cit',16.667,1),(313,7461569,7461561,'ity',16.667,1),(313,7461570,7461564,'pat',50,1),(313,7461571,7461564,'ath',50,1),(313,7461572,7461570,'nin',50,1),(313,7461573,7461570,'ine',50,1),(313,7461574,7461572,'fre',14.286,1),(313,7461575,7461572,'ree',14.286,1),(313,7461576,7461572,'ees',14.286,1),(313,7461577,7461572,'esp',14.286,1),(313,7461578,7461572,'spa',14.286,1),(313,7461579,7461572,'pac',14.286,1),(313,7461580,7461572,'ace',14.286,1),(313,7461581,7461574,'dis',50,1),(313,7461582,7461574,'isk',50,1),(313,7461583,7461581,'ind',33.333,1),(313,7461584,7461581,'nde',33.333,1),(313,7461585,7461581,'dex',33.333,1),(313,7461586,7461583,'adm',8.333,1),(313,7461587,7461583,'dmi',8.333,1),(313,7461588,7461583,'min',8.333,1),(313,7461589,7461583,'ini',8.333,1),(313,7461590,7461583,'nis',8.333,1),(313,7461591,7461583,'ist',8.333,1),(313,7461592,7461583,'str',8.333,1),(313,7461593,7461583,'tra',8.333,1),(313,7461594,7461583,'rat',8.333,1),(313,7461595,7461583,'ati',8.333,1),(313,7461596,7461583,'tio',8.333,1),(313,7461597,7461583,'ion',8.333,1),(313,7461598,7461586,'sta',33.333,3),(313,7461599,7461586,'tat',33.333,3),(313,7461600,7461586,'ate',33.333,3),(313,7461601,7461598,'ena',20,2),(313,7461602,7461598,'nab',20,2),(313,7461603,7461598,'abl',20,2),(313,7461604,7461598,'ble',20,2),(313,7461605,7461598,'led',20,2),(313,7461606,7461601,'cac',33.333,1),(313,7461607,7461601,'ach',33.333,1),(313,7461608,7461601,'che',33.333,1),(313,7461609,7461606,'mod',50,2),(313,7461610,7461606,'ode',50,2),(313,7461611,7461609,'wri',14.286,2),(313,7461612,7461609,'rit',14.286,2),(313,7461613,7461609,'ite',14.286,2),(313,7461614,7461609,'tet',14.286,2),(313,7461615,7461609,'eth',14.286,2),(313,7461616,7461609,'thr',14.286,2),(313,7461617,7461609,'hru',14.286,2),(313,7461618,7461611,'ope',11.111,2),(313,7461619,7461611,'per',11.111,2),(313,7461620,7461611,'era',11.111,2),(313,7461621,7461611,'rat',11.111,2),(313,7461622,7461611,'ati',11.111,2),(313,7461623,7461611,'tio',11.111,2),(313,7461624,7461611,'ion',11.111,2),(313,7461625,7461611,'ona',11.111,2),(313,7461626,7461611,'nal',11.111,2),(313,7461627,7461618,'nor',25,1),(313,7461628,7461618,'orm',25,1),(313,7461629,7461618,'rma',25,1),(313,7461630,7461618,'mal',25,1),(313,7461631,7461627,'mes',20,1),(313,7461632,7461627,'ess',20,1),(313,7461633,7461627,'ssa',20,1),(313,7461634,7461627,'sag',20,1),(313,7461635,7461627,'age',20,1),(313,7461636,7461631,'per',11.111,1),(313,7461637,7461631,'erf',11.111,1),(313,7461638,7461631,'rfo',11.111,1);
INSERT INTO `fuzzysearch_default_fuzzysearch_index_search_api_viewed` VALUES (313,7461639,7461631,'for',11.111,1),(313,7461640,7461631,'orm',11.111,1),(313,7461641,7461631,'rma',11.111,1),(313,7461642,7461631,'man',11.111,1),(313,7461643,7461631,'anc',11.111,1),(313,7461644,7461631,'nce',11.111,1),(313,7461645,7461636,'ide',12.5,1),(313,7461646,7461636,'den',12.5,1),(313,7461647,7461636,'ent',12.5,1),(313,7461648,7461636,'nti',12.5,1),(313,7461649,7461636,'tif',12.5,1),(313,7461650,7461636,'ifi',12.5,1),(313,7461651,7461636,'fie',12.5,1),(313,7461652,7461636,'ier',12.5,1),(313,7461653,7461645,'vdi',33.333,3),(313,7461654,7461645,'dis',33.333,3),(313,7461655,7461645,'isk',33.333,3),(313,7461656,7461653,'nam',50,1),(313,7461657,7461653,'ame',50,1),(313,7461658,7461656,'typ',50,1),(313,7461659,7461656,'ype',50,1),(313,7461660,7461658,'dir',25,1),(313,7461661,7461658,'ire',25,1),(313,7461662,7461658,'rec',25,1),(313,7461663,7461658,'ect',25,1),(314,7461665,7461664,'naa',100,2),(314,7461666,7461665,'600',3.333,3),(314,7461667,7461665,'000',3.333,3),(314,7461668,7461665,'00c',3.333,3),(314,7461669,7461665,'0c2',3.333,3),(314,7461670,7461665,'c29',3.333,3),(314,7461671,7461665,'299',3.333,3),(314,7461672,7461665,'99c',3.333,3),(314,7461673,7461665,'9cd',3.333,3),(314,7461674,7461665,'cde',3.333,3),(314,7461675,7461665,'ded',3.333,3),(314,7461676,7461665,'ed2',3.333,3),(314,7461677,7461665,'d2c',3.333,3),(314,7461678,7461665,'2c9',3.333,3),(314,7461679,7461665,'c9a',3.333,3),(314,7461680,7461665,'9ad',3.333,3),(314,7461681,7461665,'adf',3.333,3),(314,7461682,7461665,'df6',3.333,3),(314,7461683,7461665,'f69',3.333,3),(314,7461684,7461665,'690',3.333,3),(314,7461685,7461665,'90a',3.333,3),(314,7461686,7461665,'0ae',3.333,3),(314,7461687,7461665,'ae5',3.333,3),(314,7461688,7461665,'e5b',3.333,3),(314,7461689,7461665,'5be',3.333,3),(314,7461690,7461665,'be3',3.333,3),(314,7461691,7461665,'e38',3.333,3),(314,7461692,7461665,'386',3.333,3),(314,7461693,7461665,'86c',3.333,3),(314,7461694,7461665,'6c2',3.333,3),(314,7461695,7461665,'c24',3.333,3),(314,7461696,7461666,'mon',100,1),(314,7461697,7461696,'201',50,1),(314,7461698,7461696,'013',50,1),(314,7461699,7461697,'adm',33.333,3),(314,7461700,7461697,'dmi',33.333,3),(314,7461701,7461697,'min',33.333,3),(314,7461702,7461699,'cap',16.667,1),(314,7461703,7461699,'apa',16.667,1),(314,7461704,7461699,'pac',16.667,1),(314,7461705,7461699,'aci',16.667,1),(314,7461706,7461699,'cit',16.667,1),(314,7461707,7461699,'ity',16.667,1),(314,7461708,7461702,'pat',50,1),(314,7461709,7461702,'ath',50,1),(314,7461710,7461708,'ten',100,1),(314,7461711,7461710,'fre',14.286,1),(314,7461712,7461710,'ree',14.286,1),(314,7461713,7461710,'ees',14.286,1),(314,7461714,7461710,'esp',14.286,1),(314,7461715,7461710,'spa',14.286,1),(314,7461716,7461710,'pac',14.286,1),(314,7461717,7461710,'ace',14.286,1),(314,7461718,7461711,'dis',50,1),(314,7461719,7461711,'isk',50,1),(314,7461720,7461718,'ind',33.333,1),(314,7461721,7461718,'nde',33.333,1),(314,7461722,7461718,'dex',33.333,1),(314,7461723,7461720,'adm',8.333,1),(314,7461724,7461720,'dmi',8.333,1),(314,7461725,7461720,'min',8.333,1),(314,7461726,7461720,'ini',8.333,1),(314,7461727,7461720,'nis',8.333,1),(314,7461728,7461720,'ist',8.333,1),(314,7461729,7461720,'str',8.333,1),(314,7461730,7461720,'tra',8.333,1),(314,7461731,7461720,'rat',8.333,1),(314,7461732,7461720,'ati',8.333,1),(314,7461733,7461720,'tio',8.333,1),(314,7461734,7461720,'ion',8.333,1),(314,7461735,7461723,'sta',33.333,3),(314,7461736,7461723,'tat',33.333,3),(314,7461737,7461723,'ate',33.333,3),(314,7461738,7461735,'ena',20,2),(314,7461739,7461735,'nab',20,2),(314,7461740,7461735,'abl',20,2),(314,7461741,7461735,'ble',20,2),(314,7461742,7461735,'led',20,2),(314,7461743,7461738,'cac',33.333,1),(314,7461744,7461738,'ach',33.333,1),(314,7461745,7461738,'che',33.333,1),(314,7461746,7461743,'mod',50,2),(314,7461747,7461743,'ode',50,2),(314,7461748,7461746,'wri',14.286,2),(314,7461749,7461746,'rit',14.286,2),(314,7461750,7461746,'ite',14.286,2),(314,7461751,7461746,'tet',14.286,2),(314,7461752,7461746,'eth',14.286,2),(314,7461753,7461746,'thr',14.286,2),(314,7461754,7461746,'hru',14.286,2),(314,7461755,7461748,'ope',11.111,2),(314,7461756,7461748,'per',11.111,2),(314,7461757,7461748,'era',11.111,2),(314,7461758,7461748,'rat',11.111,2),(314,7461759,7461748,'ati',11.111,2),(314,7461760,7461748,'tio',11.111,2),(314,7461761,7461748,'ion',11.111,2),(314,7461762,7461748,'ona',11.111,2),(314,7461763,7461748,'nal',11.111,2),(314,7461764,7461755,'nor',25,1),(314,7461765,7461755,'orm',25,1),(314,7461766,7461755,'rma',25,1),(314,7461767,7461755,'mal',25,1),(314,7461768,7461764,'mes',20,1),(314,7461769,7461764,'ess',20,1),(314,7461770,7461764,'ssa',20,1),(314,7461771,7461764,'sag',20,1),(314,7461772,7461764,'age',20,1),(314,7461773,7461768,'per',11.111,1),(314,7461774,7461768,'erf',11.111,1),(314,7461775,7461768,'rfo',11.111,1),(314,7461776,7461768,'for',11.111,1),(314,7461777,7461768,'orm',11.111,1),(314,7461778,7461768,'rma',11.111,1),(314,7461779,7461768,'man',11.111,1),(314,7461780,7461768,'anc',11.111,1),(314,7461781,7461768,'nce',11.111,1),(314,7461782,7461773,'ide',12.5,1),(314,7461783,7461773,'den',12.5,1),(314,7461784,7461773,'ent',12.5,1),(314,7461785,7461773,'nti',12.5,1),(314,7461786,7461773,'tif',12.5,1),(314,7461787,7461773,'ifi',12.5,1),(314,7461788,7461773,'fie',12.5,1),(314,7461789,7461773,'ier',12.5,1),(314,7461790,7461782,'vdi',33.333,3),(314,7461791,7461782,'dis',33.333,3),(314,7461792,7461782,'isk',33.333,3),(314,7461793,7461790,'nam',50,1),(314,7461794,7461790,'ame',50,1),(314,7461795,7461793,'typ',50,1),(314,7461796,7461793,'ype',50,1),(314,7461797,7461795,'dir',25,1),(314,7461798,7461795,'ire',25,1),(314,7461799,7461795,'rec',25,1),(314,7461800,7461795,'ect',25,1),(315,7461802,7461801,'naa',100,2),(315,7461803,7461802,'600',3.333,3),(315,7461804,7461802,'000',3.333,3),(315,7461805,7461802,'00c',3.333,3),(315,7461806,7461802,'0c2',3.333,3),(315,7461807,7461802,'c29',3.333,3),(315,7461808,7461802,'29a',3.333,3),(315,7461809,7461802,'9a8',3.333,3),(315,7461810,7461802,'a85',3.333,3),(315,7461811,7461802,'85c',3.333,3),(315,7461812,7461802,'5ce',3.333,3),(315,7461813,7461802,'ce1',3.333,3),(315,7461814,7461802,'e16',3.333,3),(315,7461815,7461802,'165',3.333,3),(315,7461816,7461802,'65a',3.333,3),(315,7461817,7461802,'5a8',3.333,3),(315,7461818,7461802,'a8d',3.333,3),(315,7461819,7461802,'8d9',3.333,3),(315,7461820,7461802,'d96',3.333,3),(315,7461821,7461802,'96c',3.333,3),(315,7461822,7461802,'6ca',3.333,3),(315,7461823,7461802,'caf',3.333,3),(315,7461824,7461802,'af4',3.333,3),(315,7461825,7461802,'f46',3.333,3),(315,7461826,7461802,'467',3.333,3),(315,7461827,7461802,'67e',3.333,3),(315,7461828,7461802,'7e2',3.333,3),(315,7461829,7461802,'e2b',3.333,3),(315,7461830,7461802,'2b8',3.333,3),(315,7461831,7461802,'b8c',3.333,3),(315,7461832,7461802,'8c2',3.333,3),(315,7461833,7461803,'mon',100,1),(315,7461834,7461833,'201',50,1),(315,7461835,7461833,'013',50,1),(315,7461836,7461834,'adm',33.333,3),(315,7461837,7461834,'dmi',33.333,3),(315,7461838,7461834,'min',33.333,3),(315,7461839,7461836,'cap',16.667,1),(315,7461840,7461836,'apa',16.667,1),(315,7461841,7461836,'pac',16.667,1),(315,7461842,7461836,'aci',16.667,1),(315,7461843,7461836,'cit',16.667,1),(315,7461844,7461836,'ity',16.667,1),(315,7461845,7461839,'pat',50,1),(315,7461846,7461839,'ath',50,1),(315,7461847,7461845,'ele',25,1),(315,7461848,7461845,'lev',25,1),(315,7461849,7461845,'eve',25,1),(315,7461850,7461845,'ven',25,1),(315,7461851,7461847,'fre',14.286,1),(315,7461852,7461847,'ree',14.286,1),(315,7461853,7461847,'ees',14.286,1),(315,7461854,7461847,'esp',14.286,1),(315,7461855,7461847,'spa',14.286,1),(315,7461856,7461847,'pac',14.286,1),(315,7461857,7461847,'ace',14.286,1),(315,7461858,7461851,'dis',50,1),(315,7461859,7461851,'isk',50,1),(315,7461860,7461858,'ind',33.333,1),(315,7461861,7461858,'nde',33.333,1),(315,7461862,7461858,'dex',33.333,1),(315,7461863,7461860,'adm',8.333,1),(315,7461864,7461860,'dmi',8.333,1),(315,7461865,7461860,'min',8.333,1),(315,7461866,7461860,'ini',8.333,1),(315,7461867,7461860,'nis',8.333,1),(315,7461868,7461860,'ist',8.333,1),(315,7461869,7461860,'str',8.333,1),(315,7461870,7461860,'tra',8.333,1),(315,7461871,7461860,'rat',8.333,1),(315,7461872,7461860,'ati',8.333,1),(315,7461873,7461860,'tio',8.333,1),(315,7461874,7461860,'ion',8.333,1),(315,7461875,7461863,'sta',33.333,3),(315,7461876,7461863,'tat',33.333,3),(315,7461877,7461863,'ate',33.333,3),(315,7461878,7461875,'ena',20,2),(315,7461879,7461875,'nab',20,2),(315,7461880,7461875,'abl',20,2),(315,7461881,7461875,'ble',20,2),(315,7461882,7461875,'led',20,2),(315,7461883,7461878,'cac',33.333,1),(315,7461884,7461878,'ach',33.333,1),(315,7461885,7461878,'che',33.333,1),(315,7461886,7461883,'mod',50,2),(315,7461887,7461883,'ode',50,2),(315,7461888,7461886,'wri',14.286,2),(315,7461889,7461886,'rit',14.286,2),(315,7461890,7461886,'ite',14.286,2),(315,7461891,7461886,'tet',14.286,2),(315,7461892,7461886,'eth',14.286,2),(315,7461893,7461886,'thr',14.286,2),(315,7461894,7461886,'hru',14.286,2),(315,7461895,7461888,'ope',11.111,2),(315,7461896,7461888,'per',11.111,2),(315,7461897,7461888,'era',11.111,2),(315,7461898,7461888,'rat',11.111,2),(315,7461899,7461888,'ati',11.111,2),(315,7461900,7461888,'tio',11.111,2),(315,7461901,7461888,'ion',11.111,2),(315,7461902,7461888,'ona',11.111,2),(315,7461903,7461888,'nal',11.111,2),(315,7461904,7461895,'nor',25,1),(315,7461905,7461895,'orm',25,1),(315,7461906,7461895,'rma',25,1),(315,7461907,7461895,'mal',25,1),(315,7461908,7461904,'mes',20,1),(315,7461909,7461904,'ess',20,1),(315,7461910,7461904,'ssa',20,1),(315,7461911,7461904,'sag',20,1),(315,7461912,7461904,'age',20,1),(315,7461913,7461908,'per',11.111,1),(315,7461914,7461908,'erf',11.111,1),(315,7461915,7461908,'rfo',11.111,1),(315,7461916,7461908,'for',11.111,1),(315,7461917,7461908,'orm',11.111,1),(315,7461918,7461908,'rma',11.111,1),(315,7461919,7461908,'man',11.111,1),(315,7461920,7461908,'anc',11.111,1),(315,7461921,7461908,'nce',11.111,1),(315,7461922,7461913,'ide',12.5,1),(315,7461923,7461913,'den',12.5,1),(315,7461924,7461913,'ent',12.5,1),(315,7461925,7461913,'nti',12.5,1),(315,7461926,7461913,'tif',12.5,1),(315,7461927,7461913,'ifi',12.5,1),(315,7461928,7461913,'fie',12.5,1),(315,7461929,7461913,'ier',12.5,1),(315,7461930,7461922,'vdi',33.333,3),(315,7461931,7461922,'dis',33.333,3),(315,7461932,7461922,'isk',33.333,3),(315,7461933,7461930,'nam',50,1),(315,7461934,7461930,'ame',50,1),(315,7461935,7461933,'typ',50,1),(315,7461936,7461933,'ype',50,1),(315,7461937,7461935,'dir',25,1),(315,7461938,7461935,'ire',25,1),(315,7461939,7461935,'rec',25,1),(315,7461940,7461935,'ect',25,1),(316,7461942,7461941,'naa',100,2),(316,7461943,7461942,'600',3.333,3),(316,7461944,7461942,'000',3.333,3),(316,7461945,7461942,'00c',3.333,3),(316,7461946,7461942,'0c2',3.333,3),(316,7461947,7461942,'c29',3.333,3),(316,7461948,7461942,'29f',3.333,3),(316,7461949,7461942,'9f3',3.333,3),(316,7461950,7461942,'f3e',3.333,3),(316,7461951,7461942,'3eb',3.333,3),(316,7461952,7461942,'ebb',3.333,3),(316,7461953,7461942,'bb0',3.333,3),(316,7461954,7461942,'b0d',3.333,3),(316,7461955,7461942,'0d5',3.333,3),(316,7461956,7461942,'d58',3.333,3),(316,7461957,7461942,'585',3.333,3),(316,7461958,7461942,'85f',3.333,3),(316,7461959,7461942,'5f0',3.333,3),(316,7461960,7461942,'f0e',3.333,3),(316,7461961,7461942,'0ed',3.333,3),(316,7461962,7461942,'ed9',3.333,3),(316,7461963,7461942,'d94',3.333,3),(316,7461964,7461942,'942',3.333,3),(316,7461965,7461942,'422',3.333,3),(316,7461966,7461942,'22d',3.333,3),(316,7461967,7461942,'2d6',3.333,3),(316,7461968,7461942,'d66',3.333,3),(316,7461969,7461942,'664',3.333,3),(316,7461970,7461942,'640',3.333,3),(316,7461971,7461942,'405',3.333,3),(316,7461972,7461942,'057',3.333,3),(316,7461973,7461943,'mon',100,1),(316,7461974,7461973,'201',50,1),(316,7461975,7461973,'013',50,1),(316,7461976,7461974,'adm',33.333,3),(316,7461977,7461974,'dmi',33.333,3),(316,7461978,7461974,'min',33.333,3),(316,7461979,7461976,'cap',16.667,1),(316,7461980,7461976,'apa',16.667,1),(316,7461981,7461976,'pac',16.667,1),(316,7461982,7461976,'aci',16.667,1),(316,7461983,7461976,'cit',16.667,1),(316,7461984,7461976,'ity',16.667,1),(316,7461985,7461979,'pat',50,1),(316,7461986,7461979,'ath',50,1),(316,7461987,7461985,'twe',25,1),(316,7461988,7461985,'wel',25,1),(316,7461989,7461985,'elv',25,1),(316,7461990,7461985,'lve',25,1),(316,7461991,7461987,'fre',14.286,1),(316,7461992,7461987,'ree',14.286,1),(316,7461993,7461987,'ees',14.286,1),(316,7461994,7461987,'esp',14.286,1),(316,7461995,7461987,'spa',14.286,1),(316,7461996,7461987,'pac',14.286,1),(316,7461997,7461987,'ace',14.286,1),(316,7461998,7461991,'dis',50,1),(316,7461999,7461991,'isk',50,1),(316,7462000,7461998,'ind',33.333,1),(316,7462001,7461998,'nde',33.333,1),(316,7462002,7461998,'dex',33.333,1),(316,7462003,7462000,'adm',8.333,1),(316,7462004,7462000,'dmi',8.333,1),(316,7462005,7462000,'min',8.333,1),(316,7462006,7462000,'ini',8.333,1),(316,7462007,7462000,'nis',8.333,1),(316,7462008,7462000,'ist',8.333,1),(316,7462009,7462000,'str',8.333,1),(316,7462010,7462000,'tra',8.333,1),(316,7462011,7462000,'rat',8.333,1),(316,7462012,7462000,'ati',8.333,1),(316,7462013,7462000,'tio',8.333,1),(316,7462014,7462000,'ion',8.333,1),(316,7462015,7462003,'sta',33.333,3),(316,7462016,7462003,'tat',33.333,3),(316,7462017,7462003,'ate',33.333,3),(316,7462018,7462015,'ena',20,2),(316,7462019,7462015,'nab',20,2),(316,7462020,7462015,'abl',20,2),(316,7462021,7462015,'ble',20,2),(316,7462022,7462015,'led',20,2),(316,7462023,7462018,'cac',33.333,1),(316,7462024,7462018,'ach',33.333,1),(316,7462025,7462018,'che',33.333,1),(316,7462026,7462023,'mod',50,2),(316,7462027,7462023,'ode',50,2),(316,7462028,7462026,'wri',14.286,2),(316,7462029,7462026,'rit',14.286,2),(316,7462030,7462026,'ite',14.286,2),(316,7462031,7462026,'tet',14.286,2),(316,7462032,7462026,'eth',14.286,2),(316,7462033,7462026,'thr',14.286,2),(316,7462034,7462026,'hru',14.286,2),(316,7462035,7462028,'ope',11.111,2),(316,7462036,7462028,'per',11.111,2),(316,7462037,7462028,'era',11.111,2),(316,7462038,7462028,'rat',11.111,2),(316,7462039,7462028,'ati',11.111,2),(316,7462040,7462028,'tio',11.111,2),(316,7462041,7462028,'ion',11.111,2),(316,7462042,7462028,'ona',11.111,2),(316,7462043,7462028,'nal',11.111,2),(316,7462044,7462035,'nor',25,1),(316,7462045,7462035,'orm',25,1),(316,7462046,7462035,'rma',25,1),(316,7462047,7462035,'mal',25,1),(316,7462048,7462044,'mes',20,1),(316,7462049,7462044,'ess',20,1),(316,7462050,7462044,'ssa',20,1),(316,7462051,7462044,'sag',20,1),(316,7462052,7462044,'age',20,1),(316,7462053,7462048,'per',11.111,1),(316,7462054,7462048,'erf',11.111,1),(316,7462055,7462048,'rfo',11.111,1),(316,7462056,7462048,'for',11.111,1),(316,7462057,7462048,'orm',11.111,1),(316,7462058,7462048,'rma',11.111,1),(316,7462059,7462048,'man',11.111,1),(316,7462060,7462048,'anc',11.111,1),(316,7462061,7462048,'nce',11.111,1),(316,7462062,7462053,'ide',12.5,1),(316,7462063,7462053,'den',12.5,1),(316,7462064,7462053,'ent',12.5,1),(316,7462065,7462053,'nti',12.5,1),(316,7462066,7462053,'tif',12.5,1),(316,7462067,7462053,'ifi',12.5,1),(316,7462068,7462053,'fie',12.5,1),(316,7462069,7462053,'ier',12.5,1),(316,7462070,7462062,'vdi',33.333,3),(316,7462071,7462062,'dis',33.333,3),(316,7462072,7462062,'isk',33.333,3),(316,7462073,7462070,'nam',50,1),(316,7462074,7462070,'ame',50,1),(316,7462075,7462073,'typ',50,1),(316,7462076,7462073,'ype',50,1),(316,7462077,7462075,'dir',25,1),(316,7462078,7462075,'ire',25,1),(316,7462079,7462075,'rec',25,1),(316,7462080,7462075,'ect',25,1),(317,7462082,7462081,'naa',100,2),(317,7462083,7462082,'600',3.333,3),(317,7462084,7462082,'000',3.333,3),(317,7462085,7462082,'00c',3.333,3),(317,7462086,7462082,'0c2',3.333,3),(317,7462087,7462082,'c29',3.333,3),(317,7462088,7462082,'292',3.333,3),(317,7462089,7462082,'921',3.333,3),(317,7462090,7462082,'210',3.333,3),(317,7462091,7462082,'106',3.333,3),(317,7462092,7462082,'063',3.333,3),(317,7462093,7462082,'632',3.333,3),(317,7462094,7462082,'325',3.333,3),(317,7462095,7462082,'252',3.333,3),(317,7462096,7462082,'526',3.333,3),(317,7462097,7462082,'267',3.333,3),(317,7462098,7462082,'676',3.333,3),(317,7462099,7462082,'769',3.333,3),(317,7462100,7462082,'69e',3.333,3),(317,7462101,7462082,'9e2',3.333,3),(317,7462102,7462082,'e22',3.333,3),(317,7462103,7462082,'22c',3.333,3),(317,7462104,7462082,'2c7',3.333,3),(317,7462105,7462082,'c7c',3.333,3),(317,7462106,7462082,'7c3',3.333,3),(317,7462107,7462082,'c31',3.333,3),(317,7462108,7462082,'31f',3.333,3),(317,7462109,7462082,'1ff',3.333,3),(317,7462110,7462082,'ff3',3.333,3),(317,7462111,7462082,'f32',3.333,3),(317,7462112,7462082,'326',3.333,3),(317,7462113,7462083,'mon',100,1),(317,7462114,7462113,'201',50,1),(317,7462115,7462113,'013',50,1),(317,7462116,7462114,'adm',33.333,3),(317,7462117,7462114,'dmi',33.333,3),(317,7462118,7462114,'min',33.333,3),(317,7462119,7462116,'cap',16.667,1),(317,7462120,7462116,'apa',16.667,1),(317,7462121,7462116,'pac',16.667,1),(317,7462122,7462116,'aci',16.667,1),(317,7462123,7462116,'cit',16.667,1),(317,7462124,7462116,'ity',16.667,1),(317,7462125,7462119,'pat',50,1),(317,7462126,7462119,'ath',50,1),(317,7462127,7462125,'thi',16.667,1),(317,7462128,7462125,'hir',16.667,1),(317,7462129,7462125,'irt',16.667,1),(317,7462130,7462125,'rte',16.667,1),(317,7462131,7462125,'tee',16.667,1),(317,7462132,7462125,'een',16.667,1),(317,7462133,7462127,'fre',14.286,1),(317,7462134,7462127,'ree',14.286,1),(317,7462135,7462127,'ees',14.286,1),(317,7462136,7462127,'esp',14.286,1),(317,7462137,7462127,'spa',14.286,1),(317,7462138,7462127,'pac',14.286,1),(317,7462139,7462127,'ace',14.286,1),(317,7462140,7462133,'dis',50,1),(317,7462141,7462133,'isk',50,1),(317,7462142,7462140,'ind',33.333,1),(317,7462143,7462140,'nde',33.333,1),(317,7462144,7462140,'dex',33.333,1),(317,7462145,7462142,'adm',8.333,1),(317,7462146,7462142,'dmi',8.333,1),(317,7462147,7462142,'min',8.333,1),(317,7462148,7462142,'ini',8.333,1),(317,7462149,7462142,'nis',8.333,1),(317,7462150,7462142,'ist',8.333,1),(317,7462151,7462142,'str',8.333,1),(317,7462152,7462142,'tra',8.333,1),(317,7462153,7462142,'rat',8.333,1),(317,7462154,7462142,'ati',8.333,1),(317,7462155,7462142,'tio',8.333,1),(317,7462156,7462142,'ion',8.333,1),(317,7462157,7462145,'sta',33.333,3),(317,7462158,7462145,'tat',33.333,3),(317,7462159,7462145,'ate',33.333,3),(317,7462160,7462157,'ena',20,2),(317,7462161,7462157,'nab',20,2),(317,7462162,7462157,'abl',20,2),(317,7462163,7462157,'ble',20,2),(317,7462164,7462157,'led',20,2),(317,7462165,7462160,'cac',33.333,1),(317,7462166,7462160,'ach',33.333,1),(317,7462167,7462160,'che',33.333,1),(317,7462168,7462165,'mod',50,2),(317,7462169,7462165,'ode',50,2),(317,7462170,7462168,'wri',14.286,2),(317,7462171,7462168,'rit',14.286,2),(317,7462172,7462168,'ite',14.286,2),(317,7462173,7462168,'tet',14.286,2),(317,7462174,7462168,'eth',14.286,2),(317,7462175,7462168,'thr',14.286,2),(317,7462176,7462168,'hru',14.286,2),(317,7462177,7462170,'ope',11.111,2),(317,7462178,7462170,'per',11.111,2),(317,7462179,7462170,'era',11.111,2),(317,7462180,7462170,'rat',11.111,2),(317,7462181,7462170,'ati',11.111,2),(317,7462182,7462170,'tio',11.111,2),(317,7462183,7462170,'ion',11.111,2),(317,7462184,7462170,'ona',11.111,2),(317,7462185,7462170,'nal',11.111,2),(317,7462186,7462177,'nor',25,1),(317,7462187,7462177,'orm',25,1),(317,7462188,7462177,'rma',25,1),(317,7462189,7462177,'mal',25,1),(317,7462190,7462186,'mes',20,1),(317,7462191,7462186,'ess',20,1),(317,7462192,7462186,'ssa',20,1),(317,7462193,7462186,'sag',20,1),(317,7462194,7462186,'age',20,1),(317,7462195,7462190,'per',11.111,1),(317,7462196,7462190,'erf',11.111,1),(317,7462197,7462190,'rfo',11.111,1),(317,7462198,7462190,'for',11.111,1),(317,7462199,7462190,'orm',11.111,1),(317,7462200,7462190,'rma',11.111,1),(317,7462201,7462190,'man',11.111,1),(317,7462202,7462190,'anc',11.111,1),(317,7462203,7462190,'nce',11.111,1),(317,7462204,7462195,'ide',12.5,1),(317,7462205,7462195,'den',12.5,1),(317,7462206,7462195,'ent',12.5,1),(317,7462207,7462195,'nti',12.5,1),(317,7462208,7462195,'tif',12.5,1),(317,7462209,7462195,'ifi',12.5,1),(317,7462210,7462195,'fie',12.5,1),(317,7462211,7462195,'ier',12.5,1),(317,7462212,7462204,'vdi',33.333,3),(317,7462213,7462204,'dis',33.333,3),(317,7462214,7462204,'isk',33.333,3),(317,7462215,7462212,'nam',50,1),(317,7462216,7462212,'ame',50,1),(317,7462217,7462215,'typ',50,1),(317,7462218,7462215,'ype',50,1),(317,7462219,7462217,'dir',25,1),(317,7462220,7462217,'ire',25,1),(317,7462221,7462217,'rec',25,1),(317,7462222,7462217,'ect',25,1),(318,7462224,7462223,'naa',100,2),(318,7462225,7462224,'600',3.333,3),(318,7462226,7462224,'000',3.333,3),(318,7462227,7462224,'00c',3.333,3),(318,7462228,7462224,'0c2',3.333,3),(318,7462229,7462224,'c29',3.333,3),(318,7462230,7462224,'293',3.333,3),(318,7462231,7462224,'935',3.333,3),(318,7462232,7462224,'350',3.333,3),(318,7462233,7462224,'508',3.333,3),(318,7462234,7462224,'081',3.333,3),(318,7462235,7462224,'81e',3.333,3),(318,7462236,7462224,'1e5',3.333,3),(318,7462237,7462224,'e51',3.333,3),(318,7462238,7462224,'51a',3.333,3),(318,7462239,7462224,'1a2',3.333,3),(318,7462240,7462224,'a22',3.333,3),(318,7462241,7462224,'220',3.333,3),(318,7462242,7462224,'200',3.333,3),(318,7462243,7462224,'00a',3.333,3),(318,7462244,7462224,'0a7',3.333,3),(318,7462245,7462224,'a7f',3.333,3),(318,7462246,7462224,'7f5',3.333,3),(318,7462247,7462224,'f51',3.333,3),(318,7462248,7462224,'512',3.333,3),(318,7462249,7462224,'126',3.333,3),(318,7462250,7462224,'268',3.333,3),(318,7462251,7462224,'68b',3.333,3),(318,7462252,7462224,'8b8',3.333,3),(318,7462253,7462224,'b89',3.333,3),(318,7462254,7462224,'899',3.333,3),(318,7462255,7462225,'mon',100,1),(318,7462256,7462255,'201',50,1),(318,7462257,7462255,'013',50,1),(318,7462258,7462256,'adm',33.333,3),(318,7462259,7462256,'dmi',33.333,3),(318,7462260,7462256,'min',33.333,3),(318,7462261,7462258,'cap',16.667,1),(318,7462262,7462258,'apa',16.667,1),(318,7462263,7462258,'pac',16.667,1),(318,7462264,7462258,'aci',16.667,1),(318,7462265,7462258,'cit',16.667,1),(318,7462266,7462258,'ity',16.667,1),(318,7462267,7462261,'pat',50,1),(318,7462268,7462261,'ath',50,1),(318,7462269,7462267,'fre',14.286,1),(318,7462270,7462267,'ree',14.286,1),(318,7462271,7462267,'ees',14.286,1),(318,7462272,7462267,'esp',14.286,1),(318,7462273,7462267,'spa',14.286,1),(318,7462274,7462267,'pac',14.286,1),(318,7462275,7462267,'ace',14.286,1),(318,7462276,7462269,'dis',50,1),(318,7462277,7462269,'isk',50,1),(318,7462278,7462276,'ind',33.333,1),(318,7462279,7462276,'nde',33.333,1),(318,7462280,7462276,'dex',33.333,1),(318,7462281,7462278,'adm',8.333,1),(318,7462282,7462278,'dmi',8.333,1),(318,7462283,7462278,'min',8.333,1),(318,7462284,7462278,'ini',8.333,1),(318,7462285,7462278,'nis',8.333,1),(318,7462286,7462278,'ist',8.333,1),(318,7462287,7462278,'str',8.333,1),(318,7462288,7462278,'tra',8.333,1),(318,7462289,7462278,'rat',8.333,1),(318,7462290,7462278,'ati',8.333,1),(318,7462291,7462278,'tio',8.333,1),(318,7462292,7462278,'ion',8.333,1),(318,7462293,7462281,'sta',33.333,3),(318,7462294,7462281,'tat',33.333,3),(318,7462295,7462281,'ate',33.333,3),(318,7462296,7462293,'ena',20,2),(318,7462297,7462293,'nab',20,2),(318,7462298,7462293,'abl',20,2),(318,7462299,7462293,'ble',20,2),(318,7462300,7462293,'led',20,2),(318,7462301,7462296,'cac',33.333,1),(318,7462302,7462296,'ach',33.333,1),(318,7462303,7462296,'che',33.333,1),(318,7462304,7462301,'mod',50,2),(318,7462305,7462301,'ode',50,2),(318,7462306,7462304,'wri',14.286,2),(318,7462307,7462304,'rit',14.286,2),(318,7462308,7462304,'ite',14.286,2),(318,7462309,7462304,'tet',14.286,2),(318,7462310,7462304,'eth',14.286,2),(318,7462311,7462304,'thr',14.286,2),(318,7462312,7462304,'hru',14.286,2),(318,7462313,7462306,'ope',11.111,2),(318,7462314,7462306,'per',11.111,2),(318,7462315,7462306,'era',11.111,2),(318,7462316,7462306,'rat',11.111,2),(318,7462317,7462306,'ati',11.111,2),(318,7462318,7462306,'tio',11.111,2),(318,7462319,7462306,'ion',11.111,2),(318,7462320,7462306,'ona',11.111,2),(318,7462321,7462306,'nal',11.111,2),(318,7462322,7462313,'nor',25,1),(318,7462323,7462313,'orm',25,1),(318,7462324,7462313,'rma',25,1),(318,7462325,7462313,'mal',25,1),(318,7462326,7462322,'mes',20,1),(318,7462327,7462322,'ess',20,1),(318,7462328,7462322,'ssa',20,1),(318,7462329,7462322,'sag',20,1),(318,7462330,7462322,'age',20,1),(318,7462331,7462326,'per',11.111,1),(318,7462332,7462326,'erf',11.111,1),(318,7462333,7462326,'rfo',11.111,1),(318,7462334,7462326,'for',11.111,1),(318,7462335,7462326,'orm',11.111,1),(318,7462336,7462326,'rma',11.111,1),(318,7462337,7462326,'man',11.111,1),(318,7462338,7462326,'anc',11.111,1),(318,7462339,7462326,'nce',11.111,1),(318,7462340,7462331,'ide',12.5,1),(318,7462341,7462331,'den',12.5,1),(318,7462342,7462331,'ent',12.5,1),(318,7462343,7462331,'nti',12.5,1),(318,7462344,7462331,'tif',12.5,1),(318,7462345,7462331,'ifi',12.5,1),(318,7462346,7462331,'fie',12.5,1),(318,7462347,7462331,'ier',12.5,1),(318,7462348,7462340,'vdi',33.333,3),(318,7462349,7462340,'dis',33.333,3),(318,7462350,7462340,'isk',33.333,3),(318,7462351,7462348,'nam',50,1),(318,7462352,7462348,'ame',50,1),(318,7462353,7462351,'typ',50,1),(318,7462354,7462351,'ype',50,1),(318,7462355,7462353,'dir',25,1),(318,7462356,7462353,'ire',25,1),(318,7462357,7462353,'rec',25,1),(318,7462358,7462353,'ect',25,1),(319,7462360,7462359,'naa',100,2),(319,7462361,7462360,'600',3.333,3),(319,7462362,7462360,'000',3.333,3),(319,7462363,7462360,'00c',3.333,3),(319,7462364,7462360,'0c2',3.333,3),(319,7462365,7462360,'c29',3.333,3),(319,7462366,7462360,'29a',3.333,3),(319,7462367,7462360,'9a9',3.333,3),(319,7462368,7462360,'a98',3.333,3),(319,7462369,7462360,'98d',3.333,3),(319,7462370,7462360,'8d1',3.333,3),(319,7462371,7462360,'d15',3.333,3),(319,7462372,7462360,'150',3.333,3),(319,7462373,7462360,'500',3.333,3),(319,7462374,7462360,'00a',3.333,3),(319,7462375,7462360,'0a7',3.333,3),(319,7462376,7462360,'a78',3.333,3),(319,7462377,7462360,'789',3.333,3),(319,7462378,7462360,'899',3.333,3),(319,7462379,7462360,'993',3.333,3),(319,7462380,7462360,'935',3.333,3),(319,7462381,7462360,'35c',3.333,3),(319,7462382,7462360,'5c2',3.333,3),(319,7462383,7462360,'c21',3.333,3),(319,7462384,7462360,'211',3.333,3),(319,7462385,7462360,'11a',3.333,3),(319,7462386,7462360,'1af',3.333,3),(319,7462387,7462360,'afc',3.333,3),(319,7462388,7462360,'fcf',3.333,3),(319,7462389,7462360,'cfa',3.333,3),(319,7462390,7462360,'fa4',3.333,3),(319,7462391,7462361,'mon',100,1),(319,7462392,7462391,'201',50,1),(319,7462393,7462391,'013',50,1),(319,7462394,7462392,'adm',33.333,3),(319,7462395,7462392,'dmi',33.333,3),(319,7462396,7462392,'min',33.333,3),(319,7462397,7462394,'cap',16.667,1),(319,7462398,7462394,'apa',16.667,1),(319,7462399,7462394,'pac',16.667,1),(319,7462400,7462394,'aci',16.667,1),(319,7462401,7462394,'cit',16.667,1),(319,7462402,7462394,'ity',16.667,1),(319,7462403,7462397,'pat',50,1),(319,7462404,7462397,'ath',50,1),(319,7462405,7462403,'fre',14.286,1),(319,7462406,7462403,'ree',14.286,1),(319,7462407,7462403,'ees',14.286,1),(319,7462408,7462403,'esp',14.286,1),(319,7462409,7462403,'spa',14.286,1),(319,7462410,7462403,'pac',14.286,1),(319,7462411,7462403,'ace',14.286,1),(319,7462412,7462405,'dis',50,1),(319,7462413,7462405,'isk',50,1),(319,7462414,7462412,'ind',33.333,1),(319,7462415,7462412,'nde',33.333,1),(319,7462416,7462412,'dex',33.333,1),(319,7462417,7462414,'adm',8.333,1),(319,7462418,7462414,'dmi',8.333,1),(319,7462419,7462414,'min',8.333,1),(319,7462420,7462414,'ini',8.333,1),(319,7462421,7462414,'nis',8.333,1),(319,7462422,7462414,'ist',8.333,1),(319,7462423,7462414,'str',8.333,1),(319,7462424,7462414,'tra',8.333,1),(319,7462425,7462414,'rat',8.333,1),(319,7462426,7462414,'ati',8.333,1),(319,7462427,7462414,'tio',8.333,1),(319,7462428,7462414,'ion',8.333,1),(319,7462429,7462417,'sta',33.333,3),(319,7462430,7462417,'tat',33.333,3),(319,7462431,7462417,'ate',33.333,3),(319,7462432,7462429,'ena',20,2),(319,7462433,7462429,'nab',20,2),(319,7462434,7462429,'abl',20,2),(319,7462435,7462429,'ble',20,2),(319,7462436,7462429,'led',20,2),(319,7462437,7462432,'cac',33.333,1),(319,7462438,7462432,'ach',33.333,1),(319,7462439,7462432,'che',33.333,1),(319,7462440,7462437,'mod',50,2),(319,7462441,7462437,'ode',50,2),(319,7462442,7462440,'wri',14.286,2),(319,7462443,7462440,'rit',14.286,2),(319,7462444,7462440,'ite',14.286,2),(319,7462445,7462440,'tet',14.286,2),(319,7462446,7462440,'eth',14.286,2),(319,7462447,7462440,'thr',14.286,2),(319,7462448,7462440,'hru',14.286,2),(319,7462449,7462442,'ope',11.111,2),(319,7462450,7462442,'per',11.111,2),(319,7462451,7462442,'era',11.111,2),(319,7462452,7462442,'rat',11.111,2),(319,7462453,7462442,'ati',11.111,2),(319,7462454,7462442,'tio',11.111,2),(319,7462455,7462442,'ion',11.111,2),(319,7462456,7462442,'ona',11.111,2),(319,7462457,7462442,'nal',11.111,2),(319,7462458,7462449,'nor',25,1),(319,7462459,7462449,'orm',25,1),(319,7462460,7462449,'rma',25,1),(319,7462461,7462449,'mal',25,1),(319,7462462,7462458,'mes',20,1),(319,7462463,7462458,'ess',20,1),(319,7462464,7462458,'ssa',20,1),(319,7462465,7462458,'sag',20,1),(319,7462466,7462458,'age',20,1),(319,7462467,7462462,'per',11.111,1),(319,7462468,7462462,'erf',11.111,1),(319,7462469,7462462,'rfo',11.111,1),(319,7462470,7462462,'for',11.111,1),(319,7462471,7462462,'orm',11.111,1),(319,7462472,7462462,'rma',11.111,1),(319,7462473,7462462,'man',11.111,1),(319,7462474,7462462,'anc',11.111,1),(319,7462475,7462462,'nce',11.111,1),(319,7462476,7462467,'ide',12.5,1),(319,7462477,7462467,'den',12.5,1),(319,7462478,7462467,'ent',12.5,1),(319,7462479,7462467,'nti',12.5,1),(319,7462480,7462467,'tif',12.5,1),(319,7462481,7462467,'ifi',12.5,1),(319,7462482,7462467,'fie',12.5,1),(319,7462483,7462467,'ier',12.5,1),(319,7462484,7462476,'vdi',33.333,3),(319,7462485,7462476,'dis',33.333,3),(319,7462486,7462476,'isk',33.333,3),(319,7462487,7462484,'nam',50,1),(319,7462488,7462484,'ame',50,1),(319,7462489,7462487,'typ',50,1),(319,7462490,7462487,'ype',50,1),(319,7462491,7462489,'dir',25,1),(319,7462492,7462489,'ire',25,1),(319,7462493,7462489,'rec',25,1),(319,7462494,7462489,'ect',25,1),(320,7462496,7462495,'naa',100,2),(320,7462497,7462496,'600',3.333,3),(320,7462498,7462496,'000',3.333,3),(320,7462499,7462496,'00c',3.333,3),(320,7462500,7462496,'0c2',3.333,3),(320,7462501,7462496,'c29',3.333,3),(320,7462502,7462496,'293',3.333,3),(320,7462503,7462496,'93f',3.333,3),(320,7462504,7462496,'3f2',3.333,3),(320,7462505,7462496,'f22',3.333,3),(320,7462506,7462496,'222',3.333,3),(320,7462507,7462496,'224',3.333,3),(320,7462508,7462496,'245',3.333,3),(320,7462509,7462496,'457',3.333,3),(320,7462510,7462496,'57d',3.333,3),(320,7462511,7462496,'7d8',3.333,3),(320,7462512,7462496,'d87',3.333,3),(320,7462513,7462496,'87a',3.333,3),(320,7462514,7462496,'7ad',3.333,3),(320,7462515,7462496,'adc',3.333,3),(320,7462516,7462496,'dc2',3.333,3),(320,7462517,7462496,'c26',3.333,3),(320,7462518,7462496,'267',3.333,3),(320,7462519,7462496,'67e',3.333,3),(320,7462520,7462496,'7ec',3.333,3),(320,7462521,7462496,'ecc',3.333,3),(320,7462522,7462496,'cca',3.333,3),(320,7462523,7462496,'cab',3.333,3),(320,7462524,7462496,'abf',3.333,3),(320,7462525,7462496,'bf1',3.333,3),(320,7462526,7462496,'f11',3.333,3),(320,7462527,7462497,'mon',100,1),(320,7462528,7462527,'201',50,1),(320,7462529,7462527,'013',50,1),(320,7462530,7462528,'adm',33.333,3),(320,7462531,7462528,'dmi',33.333,3),(320,7462532,7462528,'min',33.333,3),(320,7462533,7462530,'cap',16.667,1),(320,7462534,7462530,'apa',16.667,1),(320,7462535,7462530,'pac',16.667,1),(320,7462536,7462530,'aci',16.667,1),(320,7462537,7462530,'cit',16.667,1),(320,7462538,7462530,'ity',16.667,1),(320,7462539,7462533,'pat',50,1),(320,7462540,7462533,'ath',50,1),(320,7462541,7462539,'fre',14.286,1),(320,7462542,7462539,'ree',14.286,1),(320,7462543,7462539,'ees',14.286,1),(320,7462544,7462539,'esp',14.286,1),(320,7462545,7462539,'spa',14.286,1),(320,7462546,7462539,'pac',14.286,1),(320,7462547,7462539,'ace',14.286,1),(320,7462548,7462541,'dis',50,1),(320,7462549,7462541,'isk',50,1),(320,7462550,7462548,'ind',33.333,1),(320,7462551,7462548,'nde',33.333,1),(320,7462552,7462548,'dex',33.333,1),(320,7462553,7462550,'adm',8.333,1),(320,7462554,7462550,'dmi',8.333,1),(320,7462555,7462550,'min',8.333,1),(320,7462556,7462550,'ini',8.333,1),(320,7462557,7462550,'nis',8.333,1),(320,7462558,7462550,'ist',8.333,1),(320,7462559,7462550,'str',8.333,1),(320,7462560,7462550,'tra',8.333,1),(320,7462561,7462550,'rat',8.333,1),(320,7462562,7462550,'ati',8.333,1),(320,7462563,7462550,'tio',8.333,1),(320,7462564,7462550,'ion',8.333,1),(320,7462565,7462553,'sta',33.333,3),(320,7462566,7462553,'tat',33.333,3),(320,7462567,7462553,'ate',33.333,3),(320,7462568,7462565,'ena',20,2),(320,7462569,7462565,'nab',20,2),(320,7462570,7462565,'abl',20,2),(320,7462571,7462565,'ble',20,2),(320,7462572,7462565,'led',20,2),(320,7462573,7462568,'cac',33.333,1),(320,7462574,7462568,'ach',33.333,1),(320,7462575,7462568,'che',33.333,1),(320,7462576,7462573,'mod',50,2),(320,7462577,7462573,'ode',50,2),(320,7462578,7462576,'wri',14.286,2),(320,7462579,7462576,'rit',14.286,2),(320,7462580,7462576,'ite',14.286,2),(320,7462581,7462576,'tet',14.286,2),(320,7462582,7462576,'eth',14.286,2),(320,7462583,7462576,'thr',14.286,2),(320,7462584,7462576,'hru',14.286,2),(320,7462585,7462578,'ope',11.111,2),(320,7462586,7462578,'per',11.111,2),(320,7462587,7462578,'era',11.111,2),(320,7462588,7462578,'rat',11.111,2),(320,7462589,7462578,'ati',11.111,2),(320,7462590,7462578,'tio',11.111,2),(320,7462591,7462578,'ion',11.111,2),(320,7462592,7462578,'ona',11.111,2),(320,7462593,7462578,'nal',11.111,2),(320,7462594,7462585,'nor',25,1),(320,7462595,7462585,'orm',25,1),(320,7462596,7462585,'rma',25,1),(320,7462597,7462585,'mal',25,1),(320,7462598,7462594,'mes',20,1),(320,7462599,7462594,'ess',20,1),(320,7462600,7462594,'ssa',20,1),(320,7462601,7462594,'sag',20,1),(320,7462602,7462594,'age',20,1),(320,7462603,7462598,'per',11.111,1),(320,7462604,7462598,'erf',11.111,1),(320,7462605,7462598,'rfo',11.111,1),(320,7462606,7462598,'for',11.111,1),(320,7462607,7462598,'orm',11.111,1),(320,7462608,7462598,'rma',11.111,1),(320,7462609,7462598,'man',11.111,1),(320,7462610,7462598,'anc',11.111,1),(320,7462611,7462598,'nce',11.111,1),(320,7462612,7462603,'ide',12.5,1),(320,7462613,7462603,'den',12.5,1),(320,7462614,7462603,'ent',12.5,1),(320,7462615,7462603,'nti',12.5,1),(320,7462616,7462603,'tif',12.5,1),(320,7462617,7462603,'ifi',12.5,1),(320,7462618,7462603,'fie',12.5,1),(320,7462619,7462603,'ier',12.5,1),(320,7462620,7462612,'vdi',33.333,3),(320,7462621,7462612,'dis',33.333,3),(320,7462622,7462612,'isk',33.333,3),(320,7462623,7462620,'nam',50,1),(320,7462624,7462620,'ame',50,1),(320,7462625,7462623,'typ',50,1),(320,7462626,7462623,'ype',50,1),(320,7462627,7462625,'dir',25,1),(320,7462628,7462625,'ire',25,1),(320,7462629,7462625,'rec',25,1),(320,7462630,7462625,'ect',25,1),(321,7462632,7462631,'naa',100,2),(321,7462633,7462632,'600',3.333,3),(321,7462634,7462632,'000',3.333,3),(321,7462635,7462632,'00c',3.333,3),(321,7462636,7462632,'0c2',3.333,3),(321,7462637,7462632,'c29',3.333,3),(321,7462638,7462632,'297',3.333,3),(321,7462639,7462632,'97c',3.333,3),(321,7462640,7462632,'7ce',3.333,3),(321,7462641,7462632,'ce2',3.333,3),(321,7462642,7462632,'e25',3.333,3),(321,7462643,7462632,'254',3.333,3),(321,7462644,7462632,'54a',3.333,3),(321,7462645,7462632,'4a9',3.333,3),(321,7462646,7462632,'a93',3.333,3),(321,7462647,7462632,'93f',3.333,3),(321,7462648,7462632,'3f0',3.333,3),(321,7462649,7462632,'f01',3.333,3),(321,7462650,7462632,'01e',3.333,3),(321,7462651,7462632,'1e4',3.333,3),(321,7462652,7462632,'e4b',3.333,3),(321,7462653,7462632,'4bd',3.333,3),(321,7462654,7462632,'bda',3.333,3),(321,7462655,7462632,'da7',3.333,3),(321,7462656,7462632,'a77',3.333,3),(321,7462657,7462632,'775',3.333,3),(321,7462658,7462632,'755',3.333,3),(321,7462659,7462632,'55f',3.333,3),(321,7462660,7462632,'5f8',3.333,3),(321,7462661,7462632,'f8b',3.333,3),(321,7462662,7462632,'8b1',3.333,3),(321,7462663,7462633,'mon',100,1),(321,7462664,7462663,'201',50,1),(321,7462665,7462663,'013',50,1),(321,7462666,7462664,'adm',33.333,3),(321,7462667,7462664,'dmi',33.333,3),(321,7462668,7462664,'min',33.333,3),(321,7462669,7462666,'cap',16.667,1),(321,7462670,7462666,'apa',16.667,1),(321,7462671,7462666,'pac',16.667,1),(321,7462672,7462666,'aci',16.667,1),(321,7462673,7462666,'cit',16.667,1),(321,7462674,7462666,'ity',16.667,1),(321,7462675,7462669,'pat',50,1),(321,7462676,7462669,'ath',50,1),(321,7462677,7462675,'fre',14.286,1),(321,7462678,7462675,'ree',14.286,1),(321,7462679,7462675,'ees',14.286,1),(321,7462680,7462675,'esp',14.286,1),(321,7462681,7462675,'spa',14.286,1),(321,7462682,7462675,'pac',14.286,1),(321,7462683,7462675,'ace',14.286,1),(321,7462684,7462677,'dis',50,1),(321,7462685,7462677,'isk',50,1),(321,7462686,7462684,'ind',33.333,1),(321,7462687,7462684,'nde',33.333,1),(321,7462688,7462684,'dex',33.333,1),(321,7462689,7462686,'adm',8.333,1),(321,7462690,7462686,'dmi',8.333,1),(321,7462691,7462686,'min',8.333,1),(321,7462692,7462686,'ini',8.333,1),(321,7462693,7462686,'nis',8.333,1),(321,7462694,7462686,'ist',8.333,1),(321,7462695,7462686,'str',8.333,1),(321,7462696,7462686,'tra',8.333,1),(321,7462697,7462686,'rat',8.333,1),(321,7462698,7462686,'ati',8.333,1),(321,7462699,7462686,'tio',8.333,1),(321,7462700,7462686,'ion',8.333,1),(321,7462701,7462689,'sta',33.333,3),(321,7462702,7462689,'tat',33.333,3),(321,7462703,7462689,'ate',33.333,3),(321,7462704,7462701,'ena',20,2),(321,7462705,7462701,'nab',20,2),(321,7462706,7462701,'abl',20,2),(321,7462707,7462701,'ble',20,2),(321,7462708,7462701,'led',20,2),(321,7462709,7462704,'cac',33.333,1),(321,7462710,7462704,'ach',33.333,1),(321,7462711,7462704,'che',33.333,1),(321,7462712,7462709,'mod',50,2),(321,7462713,7462709,'ode',50,2),(321,7462714,7462712,'wri',14.286,2),(321,7462715,7462712,'rit',14.286,2),(321,7462716,7462712,'ite',14.286,2),(321,7462717,7462712,'tet',14.286,2),(321,7462718,7462712,'eth',14.286,2),(321,7462719,7462712,'thr',14.286,2),(321,7462720,7462712,'hru',14.286,2),(321,7462721,7462714,'ope',11.111,2),(321,7462722,7462714,'per',11.111,2),(321,7462723,7462714,'era',11.111,2),(321,7462724,7462714,'rat',11.111,2),(321,7462725,7462714,'ati',11.111,2),(321,7462726,7462714,'tio',11.111,2),(321,7462727,7462714,'ion',11.111,2),(321,7462728,7462714,'ona',11.111,2),(321,7462729,7462714,'nal',11.111,2),(321,7462730,7462721,'nor',25,1),(321,7462731,7462721,'orm',25,1),(321,7462732,7462721,'rma',25,1),(321,7462733,7462721,'mal',25,1),(321,7462734,7462730,'mes',20,1),(321,7462735,7462730,'ess',20,1),(321,7462736,7462730,'ssa',20,1),(321,7462737,7462730,'sag',20,1),(321,7462738,7462730,'age',20,1),(321,7462739,7462734,'per',11.111,1),(321,7462740,7462734,'erf',11.111,1),(321,7462741,7462734,'rfo',11.111,1),(321,7462742,7462734,'for',11.111,1),(321,7462743,7462734,'orm',11.111,1),(321,7462744,7462734,'rma',11.111,1),(321,7462745,7462734,'man',11.111,1),(321,7462746,7462734,'anc',11.111,1),(321,7462747,7462734,'nce',11.111,1),(321,7462748,7462739,'ide',12.5,1),(321,7462749,7462739,'den',12.5,1),(321,7462750,7462739,'ent',12.5,1),(321,7462751,7462739,'nti',12.5,1),(321,7462752,7462739,'tif',12.5,1),(321,7462753,7462739,'ifi',12.5,1),(321,7462754,7462739,'fie',12.5,1),(321,7462755,7462739,'ier',12.5,1),(321,7462756,7462748,'vdi',33.333,3),(321,7462757,7462748,'dis',33.333,3),(321,7462758,7462748,'isk',33.333,3),(321,7462759,7462756,'nam',50,1),(321,7462760,7462756,'ame',50,1),(321,7462761,7462759,'typ',50,1),(321,7462762,7462759,'ype',50,1),(321,7462763,7462761,'dir',25,1),(321,7462764,7462761,'ire',25,1),(321,7462765,7462761,'rec',25,1),(321,7462766,7462761,'ect',25,1),(322,7462768,7462767,'naa',100,2),(322,7462769,7462768,'600',3.333,3),(322,7462770,7462768,'000',3.333,3),(322,7462771,7462768,'00c',3.333,3),(322,7462772,7462768,'0c2',3.333,3),(322,7462773,7462768,'c29',3.333,3),(322,7462774,7462768,'294',3.333,3),(322,7462775,7462768,'94c',3.333,3),(322,7462776,7462768,'4cc',3.333,3),(322,7462777,7462768,'cc7',3.333,3),(322,7462778,7462768,'c74',3.333,3),(322,7462779,7462768,'74c',3.333,3),(322,7462780,7462768,'4c7',3.333,3),(322,7462781,7462768,'c70',3.333,3),(322,7462782,7462768,'700',3.333,3),(322,7462783,7462768,'000',3.333,3),(322,7462784,7462768,'006',3.333,3),(322,7462785,7462768,'060',3.333,3),(322,7462786,7462768,'608',3.333,3),(322,7462787,7462768,'08f',3.333,3),(322,7462788,7462768,'8f5',3.333,3),(322,7462789,7462768,'f59',3.333,3),(322,7462790,7462768,'59a',3.333,3),(322,7462791,7462768,'9a1',3.333,3),(322,7462792,7462768,'a1e',3.333,3),(322,7462793,7462768,'1e6',3.333,3),(322,7462794,7462768,'e6e',3.333,3),(322,7462795,7462768,'6e6',3.333,3),(322,7462796,7462768,'e6c',3.333,3),(322,7462797,7462768,'6cc',3.333,3),(322,7462798,7462768,'cc5',3.333,3),(322,7462799,7462769,'mon',100,1),(322,7462800,7462799,'201',50,1),(322,7462801,7462799,'013',50,1),(322,7462802,7462800,'adm',33.333,3),(322,7462803,7462800,'dmi',33.333,3),(322,7462804,7462800,'min',33.333,3),(322,7462805,7462802,'cap',16.667,1),(322,7462806,7462802,'apa',16.667,1),(322,7462807,7462802,'pac',16.667,1),(322,7462808,7462802,'aci',16.667,1),(322,7462809,7462802,'cit',16.667,1),(322,7462810,7462802,'ity',16.667,1),(322,7462811,7462805,'pat',50,1),(322,7462812,7462805,'ath',50,1),(322,7462813,7462811,'fre',14.286,1),(322,7462814,7462811,'ree',14.286,1),(322,7462815,7462811,'ees',14.286,1),(322,7462816,7462811,'esp',14.286,1),(322,7462817,7462811,'spa',14.286,1),(322,7462818,7462811,'pac',14.286,1),(322,7462819,7462811,'ace',14.286,1),(322,7462820,7462813,'dis',50,1),(322,7462821,7462813,'isk',50,1),(322,7462822,7462820,'ind',33.333,1),(322,7462823,7462820,'nde',33.333,1),(322,7462824,7462820,'dex',33.333,1),(322,7462825,7462822,'adm',8.333,1),(322,7462826,7462822,'dmi',8.333,1),(322,7462827,7462822,'min',8.333,1),(322,7462828,7462822,'ini',8.333,1),(322,7462829,7462822,'nis',8.333,1),(322,7462830,7462822,'ist',8.333,1),(322,7462831,7462822,'str',8.333,1),(322,7462832,7462822,'tra',8.333,1),(322,7462833,7462822,'rat',8.333,1),(322,7462834,7462822,'ati',8.333,1),(322,7462835,7462822,'tio',8.333,1),(322,7462836,7462822,'ion',8.333,1),(322,7462837,7462825,'sta',33.333,3),(322,7462838,7462825,'tat',33.333,3),(322,7462839,7462825,'ate',33.333,3),(322,7462840,7462837,'ena',20,2),(322,7462841,7462837,'nab',20,2),(322,7462842,7462837,'abl',20,2),(322,7462843,7462837,'ble',20,2),(322,7462844,7462837,'led',20,2),(322,7462845,7462840,'cac',33.333,1),(322,7462846,7462840,'ach',33.333,1),(322,7462847,7462840,'che',33.333,1),(322,7462848,7462845,'mod',50,2),(322,7462849,7462845,'ode',50,2),(322,7462850,7462848,'wri',14.286,2),(322,7462851,7462848,'rit',14.286,2),(322,7462852,7462848,'ite',14.286,2),(322,7462853,7462848,'tet',14.286,2),(322,7462854,7462848,'eth',14.286,2),(322,7462855,7462848,'thr',14.286,2),(322,7462856,7462848,'hru',14.286,2),(322,7462857,7462850,'ope',11.111,2),(322,7462858,7462850,'per',11.111,2),(322,7462859,7462850,'era',11.111,2),(322,7462860,7462850,'rat',11.111,2),(322,7462861,7462850,'ati',11.111,2),(322,7462862,7462850,'tio',11.111,2),(322,7462863,7462850,'ion',11.111,2),(322,7462864,7462850,'ona',11.111,2),(322,7462865,7462850,'nal',11.111,2),(322,7462866,7462857,'nor',25,1),(322,7462867,7462857,'orm',25,1),(322,7462868,7462857,'rma',25,1),(322,7462869,7462857,'mal',25,1),(322,7462870,7462866,'mes',20,1),(322,7462871,7462866,'ess',20,1),(322,7462872,7462866,'ssa',20,1),(322,7462873,7462866,'sag',20,1),(322,7462874,7462866,'age',20,1),(322,7462875,7462870,'per',11.111,1),(322,7462876,7462870,'erf',11.111,1),(322,7462877,7462870,'rfo',11.111,1),(322,7462878,7462870,'for',11.111,1),(322,7462879,7462870,'orm',11.111,1),(322,7462880,7462870,'rma',11.111,1),(322,7462881,7462870,'man',11.111,1),(322,7462882,7462870,'anc',11.111,1),(322,7462883,7462870,'nce',11.111,1),(322,7462884,7462875,'ide',12.5,1),(322,7462885,7462875,'den',12.5,1),(322,7462886,7462875,'ent',12.5,1),(322,7462887,7462875,'nti',12.5,1),(322,7462888,7462875,'tif',12.5,1),(322,7462889,7462875,'ifi',12.5,1),(322,7462890,7462875,'fie',12.5,1),(322,7462891,7462875,'ier',12.5,1),(322,7462892,7462884,'vdi',33.333,3),(322,7462893,7462884,'dis',33.333,3),(322,7462894,7462884,'isk',33.333,3),(322,7462895,7462892,'nam',50,1),(322,7462896,7462892,'ame',50,1),(322,7462897,7462895,'typ',50,1),(322,7462898,7462895,'ype',50,1),(322,7462899,7462897,'dir',25,1),(322,7462900,7462897,'ire',25,1),(322,7462901,7462897,'rec',25,1),(322,7462902,7462897,'ect',25,1),(323,7462904,7462903,'naa',100,2),(323,7462905,7462904,'600',3.333,3),(323,7462906,7462904,'000',3.333,3),(323,7462907,7462904,'00c',3.333,3),(323,7462908,7462904,'0c2',3.333,3),(323,7462909,7462904,'c29',3.333,3),(323,7462910,7462904,'29b',3.333,3),(323,7462911,7462904,'9bd',3.333,3),(323,7462912,7462904,'bd7',3.333,3),(323,7462913,7462904,'d75',3.333,3),(323,7462914,7462904,'75f',3.333,3),(323,7462915,7462904,'5f2',3.333,3),(323,7462916,7462904,'f23',3.333,3),(323,7462917,7462904,'23c',3.333,3),(323,7462918,7462904,'3cc',3.333,3),(323,7462919,7462904,'cc1',3.333,3),(323,7462920,7462904,'c16',3.333,3),(323,7462921,7462904,'168',3.333,3),(323,7462922,7462904,'68d',3.333,3),(323,7462923,7462904,'8d1',3.333,3),(323,7462924,7462904,'d13',3.333,3),(323,7462925,7462904,'132',3.333,3),(323,7462926,7462904,'322',3.333,3),(323,7462927,7462904,'228',3.333,3),(323,7462928,7462904,'28c',3.333,3),(323,7462929,7462904,'8cf',3.333,3),(323,7462930,7462904,'cfd',3.333,3),(323,7462931,7462904,'fd1',3.333,3),(323,7462932,7462904,'d11',3.333,3),(323,7462933,7462904,'118',3.333,3),(323,7462934,7462904,'188',3.333,3),(323,7462935,7462905,'mon',100,1),(323,7462936,7462935,'201',50,1),(323,7462937,7462935,'013',50,1),(323,7462938,7462936,'adm',33.333,3),(323,7462939,7462936,'dmi',33.333,3),(323,7462940,7462936,'min',33.333,3),(323,7462941,7462938,'cap',16.667,1),(323,7462942,7462938,'apa',16.667,1),(323,7462943,7462938,'pac',16.667,1),(323,7462944,7462938,'aci',16.667,1),(323,7462945,7462938,'cit',16.667,1),(323,7462946,7462938,'ity',16.667,1),(323,7462947,7462941,'pat',50,1),(323,7462948,7462941,'ath',50,1),(323,7462949,7462947,'fre',14.286,1),(323,7462950,7462947,'ree',14.286,1),(323,7462951,7462947,'ees',14.286,1),(323,7462952,7462947,'esp',14.286,1),(323,7462953,7462947,'spa',14.286,1),(323,7462954,7462947,'pac',14.286,1),(323,7462955,7462947,'ace',14.286,1),(323,7462956,7462949,'dis',50,1),(323,7462957,7462949,'isk',50,1),(323,7462958,7462956,'ind',33.333,1),(323,7462959,7462956,'nde',33.333,1),(323,7462960,7462956,'dex',33.333,1),(323,7462961,7462958,'adm',8.333,1),(323,7462962,7462958,'dmi',8.333,1),(323,7462963,7462958,'min',8.333,1),(323,7462964,7462958,'ini',8.333,1),(323,7462965,7462958,'nis',8.333,1),(323,7462966,7462958,'ist',8.333,1),(323,7462967,7462958,'str',8.333,1),(323,7462968,7462958,'tra',8.333,1),(323,7462969,7462958,'rat',8.333,1),(323,7462970,7462958,'ati',8.333,1),(323,7462971,7462958,'tio',8.333,1),(323,7462972,7462958,'ion',8.333,1),(323,7462973,7462961,'sta',33.333,3),(323,7462974,7462961,'tat',33.333,3),(323,7462975,7462961,'ate',33.333,3),(323,7462976,7462973,'ena',20,2),(323,7462977,7462973,'nab',20,2),(323,7462978,7462973,'abl',20,2),(323,7462979,7462973,'ble',20,2),(323,7462980,7462973,'led',20,2),(323,7462981,7462976,'cac',33.333,1),(323,7462982,7462976,'ach',33.333,1),(323,7462983,7462976,'che',33.333,1),(323,7462984,7462981,'mod',50,2),(323,7462985,7462981,'ode',50,2),(323,7462986,7462984,'wri',14.286,2),(323,7462987,7462984,'rit',14.286,2),(323,7462988,7462984,'ite',14.286,2),(323,7462989,7462984,'tet',14.286,2),(323,7462990,7462984,'eth',14.286,2),(323,7462991,7462984,'thr',14.286,2),(323,7462992,7462984,'hru',14.286,2),(323,7462993,7462986,'ope',11.111,2),(323,7462994,7462986,'per',11.111,2),(323,7462995,7462986,'era',11.111,2),(323,7462996,7462986,'rat',11.111,2),(323,7462997,7462986,'ati',11.111,2),(323,7462998,7462986,'tio',11.111,2),(323,7462999,7462986,'ion',11.111,2),(323,7463000,7462986,'ona',11.111,2),(323,7463001,7462986,'nal',11.111,2),(323,7463002,7462993,'nor',25,1),(323,7463003,7462993,'orm',25,1),(323,7463004,7462993,'rma',25,1),(323,7463005,7462993,'mal',25,1),(323,7463006,7463002,'mes',20,1),(323,7463007,7463002,'ess',20,1),(323,7463008,7463002,'ssa',20,1),(323,7463009,7463002,'sag',20,1),(323,7463010,7463002,'age',20,1),(323,7463011,7463006,'per',11.111,1),(323,7463012,7463006,'erf',11.111,1),(323,7463013,7463006,'rfo',11.111,1),(323,7463014,7463006,'for',11.111,1),(323,7463015,7463006,'orm',11.111,1),(323,7463016,7463006,'rma',11.111,1),(323,7463017,7463006,'man',11.111,1),(323,7463018,7463006,'anc',11.111,1),(323,7463019,7463006,'nce',11.111,1),(323,7463020,7463011,'ide',12.5,1),(323,7463021,7463011,'den',12.5,1),(323,7463022,7463011,'ent',12.5,1),(323,7463023,7463011,'nti',12.5,1),(323,7463024,7463011,'tif',12.5,1),(323,7463025,7463011,'ifi',12.5,1),(323,7463026,7463011,'fie',12.5,1),(323,7463027,7463011,'ier',12.5,1),(323,7463028,7463020,'vdi',33.333,3),(323,7463029,7463020,'dis',33.333,3),(323,7463030,7463020,'isk',33.333,3),(323,7463031,7463028,'nam',50,1),(323,7463032,7463028,'ame',50,1),(323,7463033,7463031,'typ',50,1),(323,7463034,7463031,'ype',50,1),(323,7463035,7463033,'dir',25,1),(323,7463036,7463033,'ire',25,1),(323,7463037,7463033,'rec',25,1),(323,7463038,7463033,'ect',25,1),(324,7463040,7463039,'naa',100,2),(324,7463041,7463040,'600',3.333,3),(324,7463042,7463040,'000',3.333,3),(324,7463043,7463040,'00c',3.333,3),(324,7463044,7463040,'0c2',3.333,3),(324,7463045,7463040,'c29',3.333,3),(324,7463046,7463040,'294',3.333,3),(324,7463047,7463040,'944',3.333,3),(324,7463048,7463040,'449',3.333,3),(324,7463049,7463040,'49c',3.333,3),(324,7463050,7463040,'9c9',3.333,3),(324,7463051,7463040,'c9f',3.333,3),(324,7463052,7463040,'9f7',3.333,3),(324,7463053,7463040,'f7c',3.333,3),(324,7463054,7463040,'7c6',3.333,3),(324,7463055,7463040,'c6c',3.333,3),(324,7463056,7463040,'6cc',3.333,3),(324,7463057,7463040,'cce',3.333,3),(324,7463058,7463040,'cee',3.333,3),(324,7463059,7463040,'ee2',3.333,3),(324,7463060,7463040,'e27',3.333,3),(324,7463061,7463040,'27d',3.333,3),(324,7463062,7463040,'7d6',3.333,3),(324,7463063,7463040,'d61',3.333,3),(324,7463064,7463040,'61d',3.333,3),(324,7463065,7463040,'1d6',3.333,3),(324,7463066,7463040,'d6b',3.333,3),(324,7463067,7463040,'6b5',3.333,3),(324,7463068,7463040,'b54',3.333,3),(324,7463069,7463040,'548',3.333,3),(324,7463070,7463040,'48a',3.333,3),(324,7463071,7463041,'mon',100,1),(324,7463072,7463071,'201',50,1),(324,7463073,7463071,'013',50,1),(324,7463074,7463072,'adm',33.333,3),(324,7463075,7463072,'dmi',33.333,3),(324,7463076,7463072,'min',33.333,3),(324,7463077,7463074,'cap',16.667,1),(324,7463078,7463074,'apa',16.667,1),(324,7463079,7463074,'pac',16.667,1),(324,7463080,7463074,'aci',16.667,1),(324,7463081,7463074,'cit',16.667,1),(324,7463082,7463074,'ity',16.667,1),(324,7463083,7463077,'pat',50,1),(324,7463084,7463077,'ath',50,1),(324,7463085,7463083,'fre',14.286,1),(324,7463086,7463083,'ree',14.286,1),(324,7463087,7463083,'ees',14.286,1),(324,7463088,7463083,'esp',14.286,1),(324,7463089,7463083,'spa',14.286,1),(324,7463090,7463083,'pac',14.286,1),(324,7463091,7463083,'ace',14.286,1),(324,7463092,7463085,'dis',50,1),(324,7463093,7463085,'isk',50,1),(324,7463094,7463092,'ind',33.333,1),(324,7463095,7463092,'nde',33.333,1),(324,7463096,7463092,'dex',33.333,1),(324,7463097,7463094,'adm',8.333,1),(324,7463098,7463094,'dmi',8.333,1),(324,7463099,7463094,'min',8.333,1),(324,7463100,7463094,'ini',8.333,1),(324,7463101,7463094,'nis',8.333,1),(324,7463102,7463094,'ist',8.333,1),(324,7463103,7463094,'str',8.333,1),(324,7463104,7463094,'tra',8.333,1),(324,7463105,7463094,'rat',8.333,1),(324,7463106,7463094,'ati',8.333,1),(324,7463107,7463094,'tio',8.333,1),(324,7463108,7463094,'ion',8.333,1),(324,7463109,7463097,'sta',33.333,3),(324,7463110,7463097,'tat',33.333,3),(324,7463111,7463097,'ate',33.333,3),(324,7463112,7463109,'ena',20,2),(324,7463113,7463109,'nab',20,2),(324,7463114,7463109,'abl',20,2),(324,7463115,7463109,'ble',20,2),(324,7463116,7463109,'led',20,2),(324,7463117,7463112,'cac',33.333,1),(324,7463118,7463112,'ach',33.333,1),(324,7463119,7463112,'che',33.333,1),(324,7463120,7463117,'mod',50,2),(324,7463121,7463117,'ode',50,2),(324,7463122,7463120,'wri',14.286,2),(324,7463123,7463120,'rit',14.286,2),(324,7463124,7463120,'ite',14.286,2),(324,7463125,7463120,'tet',14.286,2),(324,7463126,7463120,'eth',14.286,2),(324,7463127,7463120,'thr',14.286,2),(324,7463128,7463120,'hru',14.286,2),(324,7463129,7463122,'ope',11.111,2),(324,7463130,7463122,'per',11.111,2),(324,7463131,7463122,'era',11.111,2),(324,7463132,7463122,'rat',11.111,2),(324,7463133,7463122,'ati',11.111,2),(324,7463134,7463122,'tio',11.111,2),(324,7463135,7463122,'ion',11.111,2),(324,7463136,7463122,'ona',11.111,2),(324,7463137,7463122,'nal',11.111,2),(324,7463138,7463129,'nor',25,1),(324,7463139,7463129,'orm',25,1),(324,7463140,7463129,'rma',25,1),(324,7463141,7463129,'mal',25,1),(324,7463142,7463138,'mes',20,1),(324,7463143,7463138,'ess',20,1),(324,7463144,7463138,'ssa',20,1),(324,7463145,7463138,'sag',20,1),(324,7463146,7463138,'age',20,1),(324,7463147,7463142,'per',11.111,1),(324,7463148,7463142,'erf',11.111,1),(324,7463149,7463142,'rfo',11.111,1),(324,7463150,7463142,'for',11.111,1),(324,7463151,7463142,'orm',11.111,1),(324,7463152,7463142,'rma',11.111,1),(324,7463153,7463142,'man',11.111,1),(324,7463154,7463142,'anc',11.111,1),(324,7463155,7463142,'nce',11.111,1),(324,7463156,7463147,'ide',12.5,1),(324,7463157,7463147,'den',12.5,1),(324,7463158,7463147,'ent',12.5,1),(324,7463159,7463147,'nti',12.5,1),(324,7463160,7463147,'tif',12.5,1),(324,7463161,7463147,'ifi',12.5,1),(324,7463162,7463147,'fie',12.5,1),(324,7463163,7463147,'ier',12.5,1),(324,7463164,7463156,'vdi',33.333,3),(324,7463165,7463156,'dis',33.333,3),(324,7463166,7463156,'isk',33.333,3),(324,7463167,7463164,'nam',50,1),(324,7463168,7463164,'ame',50,1),(324,7463169,7463167,'typ',50,1),(324,7463170,7463167,'ype',50,1),(324,7463171,7463169,'dir',25,1),(324,7463172,7463169,'ire',25,1),(324,7463173,7463169,'rec',25,1),(324,7463174,7463169,'ect',25,1),(325,7463176,7463175,'naa',100,2),(325,7463177,7463176,'600',3.333,3),(325,7463178,7463176,'000',3.333,3),(325,7463179,7463176,'00c',3.333,3),(325,7463180,7463176,'0c2',3.333,3),(325,7463181,7463176,'c29',3.333,3),(325,7463182,7463176,'299',3.333,3),(325,7463183,7463176,'99c',3.333,3),(325,7463184,7463176,'9cd',3.333,3),(325,7463185,7463176,'cd2',3.333,3),(325,7463186,7463176,'d2c',3.333,3),(325,7463187,7463176,'2c7',3.333,3),(325,7463188,7463176,'c79',3.333,3),(325,7463189,7463176,'79e',3.333,3),(325,7463190,7463176,'9e0',3.333,3),(325,7463191,7463176,'e03',3.333,3),(325,7463192,7463176,'031',3.333,3),(325,7463193,7463176,'319',3.333,3),(325,7463194,7463176,'192',3.333,3),(325,7463195,7463176,'925',3.333,3),(325,7463196,7463176,'25c',3.333,3),(325,7463197,7463176,'5c1',3.333,3),(325,7463198,7463176,'c13',3.333,3),(325,7463199,7463176,'135',3.333,3),(325,7463200,7463176,'358',3.333,3),(325,7463201,7463176,'58c',3.333,3),(325,7463202,7463176,'8c4',3.333,3),(325,7463203,7463176,'c47',3.333,3),(325,7463204,7463176,'473',3.333,3),(325,7463205,7463176,'73e',3.333,3),(325,7463206,7463176,'3e6',3.333,3),(325,7463207,7463177,'mon',100,1),(325,7463208,7463207,'201',50,1),(325,7463209,7463207,'013',50,1),(325,7463210,7463208,'adm',33.333,3),(325,7463211,7463208,'dmi',33.333,3),(325,7463212,7463208,'min',33.333,3),(325,7463213,7463210,'cap',16.667,1),(325,7463214,7463210,'apa',16.667,1),(325,7463215,7463210,'pac',16.667,1),(325,7463216,7463210,'aci',16.667,1),(325,7463217,7463210,'cit',16.667,1),(325,7463218,7463210,'ity',16.667,1),(325,7463219,7463213,'pat',50,1),(325,7463220,7463213,'ath',50,1),(325,7463221,7463219,'fre',14.286,1),(325,7463222,7463219,'ree',14.286,1),(325,7463223,7463219,'ees',14.286,1),(325,7463224,7463219,'esp',14.286,1),(325,7463225,7463219,'spa',14.286,1),(325,7463226,7463219,'pac',14.286,1),(325,7463227,7463219,'ace',14.286,1),(325,7463228,7463221,'dis',50,1),(325,7463229,7463221,'isk',50,1),(325,7463230,7463228,'ind',33.333,1),(325,7463231,7463228,'nde',33.333,1),(325,7463232,7463228,'dex',33.333,1),(325,7463233,7463230,'adm',8.333,1),(325,7463234,7463230,'dmi',8.333,1),(325,7463235,7463230,'min',8.333,1),(325,7463236,7463230,'ini',8.333,1),(325,7463237,7463230,'nis',8.333,1),(325,7463238,7463230,'ist',8.333,1),(325,7463239,7463230,'str',8.333,1),(325,7463240,7463230,'tra',8.333,1),(325,7463241,7463230,'rat',8.333,1),(325,7463242,7463230,'ati',8.333,1),(325,7463243,7463230,'tio',8.333,1),(325,7463244,7463230,'ion',8.333,1),(325,7463245,7463233,'sta',33.333,3),(325,7463246,7463233,'tat',33.333,3),(325,7463247,7463233,'ate',33.333,3),(325,7463248,7463245,'ena',20,2),(325,7463249,7463245,'nab',20,2),(325,7463250,7463245,'abl',20,2),(325,7463251,7463245,'ble',20,2),(325,7463252,7463245,'led',20,2),(325,7463253,7463248,'cac',33.333,1),(325,7463254,7463248,'ach',33.333,1),(325,7463255,7463248,'che',33.333,1),(325,7463256,7463253,'mod',50,2),(325,7463257,7463253,'ode',50,2),(325,7463258,7463256,'wri',14.286,2),(325,7463259,7463256,'rit',14.286,2),(325,7463260,7463256,'ite',14.286,2),(325,7463261,7463256,'tet',14.286,2),(325,7463262,7463256,'eth',14.286,2),(325,7463263,7463256,'thr',14.286,2),(325,7463264,7463256,'hru',14.286,2),(325,7463265,7463258,'ope',11.111,2),(325,7463266,7463258,'per',11.111,2),(325,7463267,7463258,'era',11.111,2),(325,7463268,7463258,'rat',11.111,2),(325,7463269,7463258,'ati',11.111,2),(325,7463270,7463258,'tio',11.111,2),(325,7463271,7463258,'ion',11.111,2),(325,7463272,7463258,'ona',11.111,2),(325,7463273,7463258,'nal',11.111,2),(325,7463274,7463265,'nor',25,1),(325,7463275,7463265,'orm',25,1),(325,7463276,7463265,'rma',25,1),(325,7463277,7463265,'mal',25,1),(325,7463278,7463274,'mes',20,1),(325,7463279,7463274,'ess',20,1),(325,7463280,7463274,'ssa',20,1),(325,7463281,7463274,'sag',20,1),(325,7463282,7463274,'age',20,1),(325,7463283,7463278,'per',11.111,1),(325,7463284,7463278,'erf',11.111,1),(325,7463285,7463278,'rfo',11.111,1),(325,7463286,7463278,'for',11.111,1),(325,7463287,7463278,'orm',11.111,1),(325,7463288,7463278,'rma',11.111,1),(325,7463289,7463278,'man',11.111,1),(325,7463290,7463278,'anc',11.111,1),(325,7463291,7463278,'nce',11.111,1),(325,7463292,7463283,'ide',12.5,1),(325,7463293,7463283,'den',12.5,1),(325,7463294,7463283,'ent',12.5,1),(325,7463295,7463283,'nti',12.5,1),(325,7463296,7463283,'tif',12.5,1),(325,7463297,7463283,'ifi',12.5,1),(325,7463298,7463283,'fie',12.5,1),(325,7463299,7463283,'ier',12.5,1),(325,7463300,7463292,'vdi',33.333,3),(325,7463301,7463292,'dis',33.333,3),(325,7463302,7463292,'isk',33.333,3),(325,7463303,7463300,'nam',50,1),(325,7463304,7463300,'ame',50,1),(325,7463305,7463303,'typ',50,1),(325,7463306,7463303,'ype',50,1),(325,7463307,7463305,'dir',25,1),(325,7463308,7463305,'ire',25,1),(325,7463309,7463305,'rec',25,1),(325,7463310,7463305,'ect',25,1),(326,7463312,7463311,'naa',100,2),(326,7463313,7463312,'600',3.333,3),(326,7463314,7463312,'000',3.333,3),(326,7463315,7463312,'00c',3.333,3),(326,7463316,7463312,'0c2',3.333,3),(326,7463317,7463312,'c29',3.333,3),(326,7463318,7463312,'297',3.333,3),(326,7463319,7463312,'973',3.333,3),(326,7463320,7463312,'733',3.333,3),(326,7463321,7463312,'33b',3.333,3),(326,7463322,7463312,'3b0',3.333,3),(326,7463323,7463312,'b03',3.333,3),(326,7463324,7463312,'036',3.333,3),(326,7463325,7463312,'365',3.333,3),(326,7463326,7463312,'657',3.333,3),(326,7463327,7463312,'570',3.333,3),(326,7463328,7463312,'706',3.333,3),(326,7463329,7463312,'06a',3.333,3),(326,7463330,7463312,'6a5',3.333,3),(326,7463331,7463312,'a54',3.333,3),(326,7463332,7463312,'54a',3.333,3),(326,7463333,7463312,'4a9',3.333,3),(326,7463334,7463312,'a9a',3.333,3),(326,7463335,7463312,'9a5',3.333,3),(326,7463336,7463312,'a5c',3.333,3),(326,7463337,7463312,'5c2',3.333,3),(326,7463338,7463312,'c24',3.333,3),(326,7463339,7463312,'247',3.333,3),(326,7463340,7463312,'471',3.333,3),(326,7463341,7463312,'71d',3.333,3),(326,7463342,7463312,'1db',3.333,3),(326,7463343,7463313,'mon',100,1),(326,7463344,7463343,'201',50,1),(326,7463345,7463343,'013',50,1),(326,7463346,7463344,'adm',33.333,3),(326,7463347,7463344,'dmi',33.333,3),(326,7463348,7463344,'min',33.333,3),(326,7463349,7463346,'cap',16.667,1),(326,7463350,7463346,'apa',16.667,1),(326,7463351,7463346,'pac',16.667,1),(326,7463352,7463346,'aci',16.667,1),(326,7463353,7463346,'cit',16.667,1),(326,7463354,7463346,'ity',16.667,1),(326,7463355,7463349,'pat',50,1),(326,7463356,7463349,'ath',50,1),(326,7463357,7463355,'fre',14.286,1),(326,7463358,7463355,'ree',14.286,1),(326,7463359,7463355,'ees',14.286,1),(326,7463360,7463355,'esp',14.286,1),(326,7463361,7463355,'spa',14.286,1),(326,7463362,7463355,'pac',14.286,1),(326,7463363,7463355,'ace',14.286,1),(326,7463364,7463357,'dis',50,1),(326,7463365,7463357,'isk',50,1),(326,7463366,7463364,'ind',33.333,1),(326,7463367,7463364,'nde',33.333,1),(326,7463368,7463364,'dex',33.333,1),(326,7463369,7463366,'adm',8.333,1),(326,7463370,7463366,'dmi',8.333,1),(326,7463371,7463366,'min',8.333,1),(326,7463372,7463366,'ini',8.333,1),(326,7463373,7463366,'nis',8.333,1),(326,7463374,7463366,'ist',8.333,1),(326,7463375,7463366,'str',8.333,1),(326,7463376,7463366,'tra',8.333,1),(326,7463377,7463366,'rat',8.333,1),(326,7463378,7463366,'ati',8.333,1),(326,7463379,7463366,'tio',8.333,1),(326,7463380,7463366,'ion',8.333,1),(326,7463381,7463369,'sta',33.333,3),(326,7463382,7463369,'tat',33.333,3),(326,7463383,7463369,'ate',33.333,3),(326,7463384,7463381,'ena',20,2),(326,7463385,7463381,'nab',20,2),(326,7463386,7463381,'abl',20,2),(326,7463387,7463381,'ble',20,2),(326,7463388,7463381,'led',20,2),(326,7463389,7463384,'cac',33.333,1),(326,7463390,7463384,'ach',33.333,1),(326,7463391,7463384,'che',33.333,1),(326,7463392,7463389,'mod',50,2),(326,7463393,7463389,'ode',50,2),(326,7463394,7463392,'wri',14.286,2),(326,7463395,7463392,'rit',14.286,2),(326,7463396,7463392,'ite',14.286,2),(326,7463397,7463392,'tet',14.286,2),(326,7463398,7463392,'eth',14.286,2),(326,7463399,7463392,'thr',14.286,2),(326,7463400,7463392,'hru',14.286,2),(326,7463401,7463394,'ope',11.111,2),(326,7463402,7463394,'per',11.111,2),(326,7463403,7463394,'era',11.111,2),(326,7463404,7463394,'rat',11.111,2),(326,7463405,7463394,'ati',11.111,2),(326,7463406,7463394,'tio',11.111,2),(326,7463407,7463394,'ion',11.111,2),(326,7463408,7463394,'ona',11.111,2),(326,7463409,7463394,'nal',11.111,2),(326,7463410,7463401,'nor',25,1),(326,7463411,7463401,'orm',25,1),(326,7463412,7463401,'rma',25,1),(326,7463413,7463401,'mal',25,1),(326,7463414,7463410,'mes',20,1),(326,7463415,7463410,'ess',20,1),(326,7463416,7463410,'ssa',20,1),(326,7463417,7463410,'sag',20,1),(326,7463418,7463410,'age',20,1),(326,7463419,7463414,'per',11.111,1),(326,7463420,7463414,'erf',11.111,1),(326,7463421,7463414,'rfo',11.111,1),(326,7463422,7463414,'for',11.111,1),(326,7463423,7463414,'orm',11.111,1),(326,7463424,7463414,'rma',11.111,1),(326,7463425,7463414,'man',11.111,1),(326,7463426,7463414,'anc',11.111,1),(326,7463427,7463414,'nce',11.111,1),(326,7463428,7463419,'ide',12.5,1),(326,7463429,7463419,'den',12.5,1),(326,7463430,7463419,'ent',12.5,1),(326,7463431,7463419,'nti',12.5,1),(326,7463432,7463419,'tif',12.5,1),(326,7463433,7463419,'ifi',12.5,1),(326,7463434,7463419,'fie',12.5,1),(326,7463435,7463419,'ier',12.5,1),(326,7463436,7463428,'vdi',33.333,3),(326,7463437,7463428,'dis',33.333,3),(326,7463438,7463428,'isk',33.333,3),(326,7463439,7463436,'nam',50,1),(326,7463440,7463436,'ame',50,1),(326,7463441,7463439,'typ',50,1),(326,7463442,7463439,'ype',50,1),(326,7463443,7463441,'dir',25,1),(326,7463444,7463441,'ire',25,1),(326,7463445,7463441,'rec',25,1),(326,7463446,7463441,'ect',25,1),(327,7463448,7463447,'naa',100,2),(327,7463449,7463448,'600',3.333,3),(327,7463450,7463448,'000',3.333,3),(327,7463451,7463448,'00c',3.333,3),(327,7463452,7463448,'0c2',3.333,3),(327,7463453,7463448,'c29',3.333,3),(327,7463454,7463448,'291',3.333,3),(327,7463455,7463448,'91c',3.333,3),(327,7463456,7463448,'1c6',3.333,3),(327,7463457,7463448,'c6a',3.333,3),(327,7463458,7463448,'6a3',3.333,3),(327,7463459,7463448,'a36',3.333,3),(327,7463460,7463448,'366',3.333,3),(327,7463461,7463448,'669',3.333,3),(327,7463462,7463448,'69e',3.333,3),(327,7463463,7463448,'9ea',3.333,3),(327,7463464,7463448,'ea9',3.333,3),(327,7463465,7463448,'a9c',3.333,3),(327,7463466,7463448,'9c1',3.333,3),(327,7463467,7463448,'c11',3.333,3),(327,7463468,7463448,'11a',3.333,3),(327,7463469,7463448,'1a4',3.333,3),(327,7463470,7463448,'a42',3.333,3),(327,7463471,7463448,'428',3.333,3),(327,7463472,7463448,'284',3.333,3),(327,7463473,7463448,'842',3.333,3),(327,7463474,7463448,'428',3.333,3),(327,7463475,7463448,'28f',3.333,3),(327,7463476,7463448,'8f0',3.333,3),(327,7463477,7463448,'f0c',3.333,3),(327,7463478,7463448,'0c0',3.333,3),(327,7463479,7463449,'mon',100,1),(327,7463480,7463479,'201',50,1),(327,7463481,7463479,'013',50,1),(327,7463482,7463480,'adm',33.333,3),(327,7463483,7463480,'dmi',33.333,3),(327,7463484,7463480,'min',33.333,3),(327,7463485,7463482,'cap',16.667,1),(327,7463486,7463482,'apa',16.667,1),(327,7463487,7463482,'pac',16.667,1),(327,7463488,7463482,'aci',16.667,1),(327,7463489,7463482,'cit',16.667,1),(327,7463490,7463482,'ity',16.667,1),(327,7463491,7463485,'pat',50,1),(327,7463492,7463485,'ath',50,1),(327,7463493,7463491,'fre',14.286,1),(327,7463494,7463491,'ree',14.286,1),(327,7463495,7463491,'ees',14.286,1),(327,7463496,7463491,'esp',14.286,1),(327,7463497,7463491,'spa',14.286,1),(327,7463498,7463491,'pac',14.286,1),(327,7463499,7463491,'ace',14.286,1),(327,7463500,7463493,'dis',50,1),(327,7463501,7463493,'isk',50,1),(327,7463502,7463500,'ind',33.333,1),(327,7463503,7463500,'nde',33.333,1),(327,7463504,7463500,'dex',33.333,1),(327,7463505,7463502,'adm',8.333,1),(327,7463506,7463502,'dmi',8.333,1),(327,7463507,7463502,'min',8.333,1),(327,7463508,7463502,'ini',8.333,1),(327,7463509,7463502,'nis',8.333,1),(327,7463510,7463502,'ist',8.333,1),(327,7463511,7463502,'str',8.333,1),(327,7463512,7463502,'tra',8.333,1),(327,7463513,7463502,'rat',8.333,1),(327,7463514,7463502,'ati',8.333,1),(327,7463515,7463502,'tio',8.333,1),(327,7463516,7463502,'ion',8.333,1),(327,7463517,7463505,'sta',33.333,3),(327,7463518,7463505,'tat',33.333,3),(327,7463519,7463505,'ate',33.333,3),(327,7463520,7463517,'ena',20,2),(327,7463521,7463517,'nab',20,2),(327,7463522,7463517,'abl',20,2),(327,7463523,7463517,'ble',20,2),(327,7463524,7463517,'led',20,2),(327,7463525,7463520,'cac',33.333,1),(327,7463526,7463520,'ach',33.333,1),(327,7463527,7463520,'che',33.333,1),(327,7463528,7463525,'mod',50,2),(327,7463529,7463525,'ode',50,2),(327,7463530,7463528,'wri',14.286,2),(327,7463531,7463528,'rit',14.286,2),(327,7463532,7463528,'ite',14.286,2),(327,7463533,7463528,'tet',14.286,2),(327,7463534,7463528,'eth',14.286,2),(327,7463535,7463528,'thr',14.286,2),(327,7463536,7463528,'hru',14.286,2),(327,7463537,7463530,'ope',11.111,2),(327,7463538,7463530,'per',11.111,2),(327,7463539,7463530,'era',11.111,2),(327,7463540,7463530,'rat',11.111,2),(327,7463541,7463530,'ati',11.111,2),(327,7463542,7463530,'tio',11.111,2),(327,7463543,7463530,'ion',11.111,2),(327,7463544,7463530,'ona',11.111,2),(327,7463545,7463530,'nal',11.111,2),(327,7463546,7463537,'nor',25,1),(327,7463547,7463537,'orm',25,1),(327,7463548,7463537,'rma',25,1),(327,7463549,7463537,'mal',25,1),(327,7463550,7463546,'mes',20,1),(327,7463551,7463546,'ess',20,1),(327,7463552,7463546,'ssa',20,1),(327,7463553,7463546,'sag',20,1),(327,7463554,7463546,'age',20,1),(327,7463555,7463550,'per',11.111,1),(327,7463556,7463550,'erf',11.111,1),(327,7463557,7463550,'rfo',11.111,1),(327,7463558,7463550,'for',11.111,1),(327,7463559,7463550,'orm',11.111,1),(327,7463560,7463550,'rma',11.111,1),(327,7463561,7463550,'man',11.111,1),(327,7463562,7463550,'anc',11.111,1),(327,7463563,7463550,'nce',11.111,1),(327,7463564,7463555,'ide',12.5,1),(327,7463565,7463555,'den',12.5,1),(327,7463566,7463555,'ent',12.5,1),(327,7463567,7463555,'nti',12.5,1),(327,7463568,7463555,'tif',12.5,1),(327,7463569,7463555,'ifi',12.5,1),(327,7463570,7463555,'fie',12.5,1),(327,7463571,7463555,'ier',12.5,1),(327,7463572,7463564,'vdi',33.333,3),(327,7463573,7463564,'dis',33.333,3),(327,7463574,7463564,'isk',33.333,3),(327,7463575,7463572,'nam',50,1),(327,7463576,7463572,'ame',50,1),(327,7463577,7463575,'typ',50,1),(327,7463578,7463575,'ype',50,1),(327,7463579,7463577,'dir',25,1),(327,7463580,7463577,'ire',25,1),(327,7463581,7463577,'rec',25,1),(327,7463582,7463577,'ect',25,1),(328,7463584,7463583,'naa',100,2),(328,7463585,7463584,'600',3.333,3),(328,7463586,7463584,'000',3.333,3),(328,7463587,7463584,'00c',3.333,3),(328,7463588,7463584,'0c2',3.333,3),(328,7463589,7463584,'c29',3.333,3),(328,7463590,7463584,'29a',3.333,3),(328,7463591,7463584,'9ae',3.333,3),(328,7463592,7463584,'ae3',3.333,3),(328,7463593,7463584,'e3e',3.333,3),(328,7463594,7463584,'3e1',3.333,3),(328,7463595,7463584,'e10',3.333,3),(328,7463596,7463584,'105',3.333,3),(328,7463597,7463584,'05b',3.333,3),(328,7463598,7463584,'5be',3.333,3),(328,7463599,7463584,'bef',3.333,3),(328,7463600,7463584,'ef4',3.333,3),(328,7463601,7463584,'f45',3.333,3),(328,7463602,7463584,'458',3.333,3),(328,7463603,7463584,'581',3.333,3),(328,7463604,7463584,'810',3.333,3),(328,7463605,7463584,'100',3.333,3),(328,7463606,7463584,'00c',3.333,3),(328,7463607,7463584,'0c4',3.333,3),(328,7463608,7463584,'c41',3.333,3),(328,7463609,7463584,'41d',3.333,3),(328,7463610,7463584,'1d9',3.333,3),(328,7463611,7463584,'d96',3.333,3),(328,7463612,7463584,'96e',3.333,3),(328,7463613,7463584,'6e5',3.333,3),(328,7463614,7463584,'e5e',3.333,3),(328,7463615,7463585,'mon',100,1),(328,7463616,7463615,'201',50,1),(328,7463617,7463615,'013',50,1),(328,7463618,7463616,'adm',33.333,3),(328,7463619,7463616,'dmi',33.333,3),(328,7463620,7463616,'min',33.333,3),(328,7463621,7463618,'cap',16.667,1),(328,7463622,7463618,'apa',16.667,1),(328,7463623,7463618,'pac',16.667,1),(328,7463624,7463618,'aci',16.667,1),(328,7463625,7463618,'cit',16.667,1),(328,7463626,7463618,'ity',16.667,1),(328,7463627,7463621,'pat',50,1),(328,7463628,7463621,'ath',50,1),(328,7463629,7463627,'fre',14.286,1),(328,7463630,7463627,'ree',14.286,1),(328,7463631,7463627,'ees',14.286,1),(328,7463632,7463627,'esp',14.286,1),(328,7463633,7463627,'spa',14.286,1),(328,7463634,7463627,'pac',14.286,1),(328,7463635,7463627,'ace',14.286,1),(328,7463636,7463629,'dis',50,1),(328,7463637,7463629,'isk',50,1),(328,7463638,7463636,'ind',33.333,1),(328,7463639,7463636,'nde',33.333,1),(328,7463640,7463636,'dex',33.333,1),(328,7463641,7463638,'adm',8.333,1),(328,7463642,7463638,'dmi',8.333,1),(328,7463643,7463638,'min',8.333,1),(328,7463644,7463638,'ini',8.333,1),(328,7463645,7463638,'nis',8.333,1),(328,7463646,7463638,'ist',8.333,1),(328,7463647,7463638,'str',8.333,1),(328,7463648,7463638,'tra',8.333,1),(328,7463649,7463638,'rat',8.333,1),(328,7463650,7463638,'ati',8.333,1),(328,7463651,7463638,'tio',8.333,1),(328,7463652,7463638,'ion',8.333,1),(328,7463653,7463641,'sta',33.333,3),(328,7463654,7463641,'tat',33.333,3),(328,7463655,7463641,'ate',33.333,3),(328,7463656,7463653,'ena',20,2),(328,7463657,7463653,'nab',20,2),(328,7463658,7463653,'abl',20,2),(328,7463659,7463653,'ble',20,2),(328,7463660,7463653,'led',20,2),(328,7463661,7463656,'cac',33.333,1),(328,7463662,7463656,'ach',33.333,1),(328,7463663,7463656,'che',33.333,1),(328,7463664,7463661,'mod',50,2),(328,7463665,7463661,'ode',50,2),(328,7463666,7463664,'wri',14.286,2),(328,7463667,7463664,'rit',14.286,2),(328,7463668,7463664,'ite',14.286,2),(328,7463669,7463664,'tet',14.286,2),(328,7463670,7463664,'eth',14.286,2),(328,7463671,7463664,'thr',14.286,2),(328,7463672,7463664,'hru',14.286,2),(328,7463673,7463666,'ope',11.111,2),(328,7463674,7463666,'per',11.111,2),(328,7463675,7463666,'era',11.111,2),(328,7463676,7463666,'rat',11.111,2),(328,7463677,7463666,'ati',11.111,2),(328,7463678,7463666,'tio',11.111,2),(328,7463679,7463666,'ion',11.111,2),(328,7463680,7463666,'ona',11.111,2),(328,7463681,7463666,'nal',11.111,2),(328,7463682,7463673,'nor',25,1),(328,7463683,7463673,'orm',25,1),(328,7463684,7463673,'rma',25,1),(328,7463685,7463673,'mal',25,1),(328,7463686,7463682,'mes',20,1),(328,7463687,7463682,'ess',20,1),(328,7463688,7463682,'ssa',20,1),(328,7463689,7463682,'sag',20,1),(328,7463690,7463682,'age',20,1),(328,7463691,7463686,'per',11.111,1),(328,7463692,7463686,'erf',11.111,1),(328,7463693,7463686,'rfo',11.111,1),(328,7463694,7463686,'for',11.111,1),(328,7463695,7463686,'orm',11.111,1),(328,7463696,7463686,'rma',11.111,1),(328,7463697,7463686,'man',11.111,1),(328,7463698,7463686,'anc',11.111,1),(328,7463699,7463686,'nce',11.111,1),(328,7463700,7463691,'ide',12.5,1),(328,7463701,7463691,'den',12.5,1),(328,7463702,7463691,'ent',12.5,1),(328,7463703,7463691,'nti',12.5,1),(328,7463704,7463691,'tif',12.5,1),(328,7463705,7463691,'ifi',12.5,1),(328,7463706,7463691,'fie',12.5,1),(328,7463707,7463691,'ier',12.5,1),(328,7463708,7463700,'vdi',33.333,3),(328,7463709,7463700,'dis',33.333,3),(328,7463710,7463700,'isk',33.333,3),(328,7463711,7463708,'nam',50,1),(328,7463712,7463708,'ame',50,1),(328,7463713,7463711,'typ',50,1),(328,7463714,7463711,'ype',50,1),(328,7463715,7463713,'dir',25,1),(328,7463716,7463713,'ire',25,1),(328,7463717,7463713,'rec',25,1),(328,7463718,7463713,'ect',25,1),(329,7463720,7463719,'naa',100,2),(329,7463721,7463720,'600',3.333,3),(329,7463722,7463720,'000',3.333,3),(329,7463723,7463720,'00c',3.333,3),(329,7463724,7463720,'0c2',3.333,3),(329,7463725,7463720,'c29',3.333,3),(329,7463726,7463720,'29d',3.333,3),(329,7463727,7463720,'9d4',3.333,3),(329,7463728,7463720,'d41',3.333,3),(329,7463729,7463720,'410',3.333,3),(329,7463730,7463720,'104',3.333,3),(329,7463731,7463720,'04d',3.333,3),(329,7463732,7463720,'4df',3.333,3),(329,7463733,7463720,'df0',3.333,3),(329,7463734,7463720,'f0c',3.333,3),(329,7463735,7463720,'0cf',3.333,3),(329,7463736,7463720,'cf1',3.333,3),(329,7463737,7463720,'f1b',3.333,3),(329,7463738,7463720,'1b6',3.333,3),(329,7463739,7463720,'b6e',3.333,3),(329,7463740,7463720,'6eb',3.333,3),(329,7463741,7463720,'ebc',3.333,3),(329,7463742,7463720,'bc4',3.333,3),(329,7463743,7463720,'c4f',3.333,3),(329,7463744,7463720,'4fb',3.333,3),(329,7463745,7463720,'fb7',3.333,3),(329,7463746,7463720,'b7e',3.333,3),(329,7463747,7463720,'7e6',3.333,3),(329,7463748,7463720,'e62',3.333,3),(329,7463749,7463720,'62e',3.333,3),(329,7463750,7463720,'2ea',3.333,3),(329,7463751,7463721,'mon',100,1),(329,7463752,7463751,'201',50,1),(329,7463753,7463751,'013',50,1),(329,7463754,7463752,'adm',33.333,3),(329,7463755,7463752,'dmi',33.333,3),(329,7463756,7463752,'min',33.333,3),(329,7463757,7463754,'cap',16.667,1),(329,7463758,7463754,'apa',16.667,1),(329,7463759,7463754,'pac',16.667,1),(329,7463760,7463754,'aci',16.667,1),(329,7463761,7463754,'cit',16.667,1),(329,7463762,7463754,'ity',16.667,1),(329,7463763,7463757,'pat',50,1),(329,7463764,7463757,'ath',50,1),(329,7463765,7463763,'fre',14.286,1),(329,7463766,7463763,'ree',14.286,1),(329,7463767,7463763,'ees',14.286,1),(329,7463768,7463763,'esp',14.286,1),(329,7463769,7463763,'spa',14.286,1),(329,7463770,7463763,'pac',14.286,1),(329,7463771,7463763,'ace',14.286,1),(329,7463772,7463765,'dis',50,1),(329,7463773,7463765,'isk',50,1),(329,7463774,7463772,'ind',33.333,1),(329,7463775,7463772,'nde',33.333,1),(329,7463776,7463772,'dex',33.333,1),(329,7463777,7463774,'adm',8.333,1),(329,7463778,7463774,'dmi',8.333,1),(329,7463779,7463774,'min',8.333,1),(329,7463780,7463774,'ini',8.333,1),(329,7463781,7463774,'nis',8.333,1),(329,7463782,7463774,'ist',8.333,1),(329,7463783,7463774,'str',8.333,1),(329,7463784,7463774,'tra',8.333,1),(329,7463785,7463774,'rat',8.333,1),(329,7463786,7463774,'ati',8.333,1),(329,7463787,7463774,'tio',8.333,1),(329,7463788,7463774,'ion',8.333,1),(329,7463789,7463777,'sta',33.333,3),(329,7463790,7463777,'tat',33.333,3),(329,7463791,7463777,'ate',33.333,3),(329,7463792,7463789,'ena',20,2),(329,7463793,7463789,'nab',20,2),(329,7463794,7463789,'abl',20,2),(329,7463795,7463789,'ble',20,2),(329,7463796,7463789,'led',20,2),(329,7463797,7463792,'cac',33.333,1),(329,7463798,7463792,'ach',33.333,1),(329,7463799,7463792,'che',33.333,1),(329,7463800,7463797,'mod',50,2),(329,7463801,7463797,'ode',50,2),(329,7463802,7463800,'wri',14.286,2),(329,7463803,7463800,'rit',14.286,2),(329,7463804,7463800,'ite',14.286,2),(329,7463805,7463800,'tet',14.286,2),(329,7463806,7463800,'eth',14.286,2),(329,7463807,7463800,'thr',14.286,2),(329,7463808,7463800,'hru',14.286,2),(329,7463809,7463802,'ope',11.111,2),(329,7463810,7463802,'per',11.111,2),(329,7463811,7463802,'era',11.111,2),(329,7463812,7463802,'rat',11.111,2),(329,7463813,7463802,'ati',11.111,2),(329,7463814,7463802,'tio',11.111,2),(329,7463815,7463802,'ion',11.111,2),(329,7463816,7463802,'ona',11.111,2),(329,7463817,7463802,'nal',11.111,2),(329,7463818,7463809,'nor',25,1),(329,7463819,7463809,'orm',25,1),(329,7463820,7463809,'rma',25,1),(329,7463821,7463809,'mal',25,1),(329,7463822,7463818,'mes',20,1),(329,7463823,7463818,'ess',20,1),(329,7463824,7463818,'ssa',20,1),(329,7463825,7463818,'sag',20,1),(329,7463826,7463818,'age',20,1),(329,7463827,7463822,'per',11.111,1),(329,7463828,7463822,'erf',11.111,1),(329,7463829,7463822,'rfo',11.111,1),(329,7463830,7463822,'for',11.111,1),(329,7463831,7463822,'orm',11.111,1),(329,7463832,7463822,'rma',11.111,1),(329,7463833,7463822,'man',11.111,1),(329,7463834,7463822,'anc',11.111,1),(329,7463835,7463822,'nce',11.111,1),(329,7463836,7463827,'ide',12.5,1),(329,7463837,7463827,'den',12.5,1),(329,7463838,7463827,'ent',12.5,1),(329,7463839,7463827,'nti',12.5,1),(329,7463840,7463827,'tif',12.5,1),(329,7463841,7463827,'ifi',12.5,1),(329,7463842,7463827,'fie',12.5,1),(329,7463843,7463827,'ier',12.5,1),(329,7463844,7463836,'vdi',33.333,3),(329,7463845,7463836,'dis',33.333,3),(329,7463846,7463836,'isk',33.333,3),(329,7463847,7463844,'nam',50,1),(329,7463848,7463844,'ame',50,1),(329,7463849,7463847,'typ',50,1),(329,7463850,7463847,'ype',50,1),(329,7463851,7463849,'dir',25,1),(329,7463852,7463849,'ire',25,1),(329,7463853,7463849,'rec',25,1),(329,7463854,7463849,'ect',25,1),(330,7463856,7463855,'naa',100,2),(330,7463857,7463856,'600',3.333,3),(330,7463858,7463856,'000',3.333,3),(330,7463859,7463856,'00c',3.333,3),(330,7463860,7463856,'0c2',3.333,3),(330,7463861,7463856,'c29',3.333,3),(330,7463862,7463856,'298',3.333,3),(330,7463863,7463856,'980',3.333,3),(330,7463864,7463856,'801',3.333,3),(330,7463865,7463856,'015',3.333,3),(330,7463866,7463856,'15b',3.333,3),(330,7463867,7463856,'5b7',3.333,3),(330,7463868,7463856,'b74',3.333,3),(330,7463869,7463856,'746',3.333,3),(330,7463870,7463856,'467',3.333,3),(330,7463871,7463856,'673',3.333,3),(330,7463872,7463856,'737',3.333,3),(330,7463873,7463856,'377',3.333,3),(330,7463874,7463856,'771',3.333,3),(330,7463875,7463856,'71e',3.333,3),(330,7463876,7463856,'1ea',3.333,3),(330,7463877,7463856,'ea3',3.333,3),(330,7463878,7463856,'a38',3.333,3),(330,7463879,7463856,'38b',3.333,3),(330,7463880,7463856,'8b8',3.333,3),(330,7463881,7463856,'b87',3.333,3),(330,7463882,7463856,'876',3.333,3),(330,7463883,7463856,'763',3.333,3),(330,7463884,7463856,'63c',3.333,3),(330,7463885,7463856,'3c6',3.333,3),(330,7463886,7463856,'c63',3.333,3),(330,7463887,7463857,'mon',100,1),(330,7463888,7463887,'201',50,1),(330,7463889,7463887,'013',50,1),(330,7463890,7463888,'adm',33.333,3),(330,7463891,7463888,'dmi',33.333,3),(330,7463892,7463888,'min',33.333,3),(330,7463893,7463890,'cap',16.667,1),(330,7463894,7463890,'apa',16.667,1),(330,7463895,7463890,'pac',16.667,1),(330,7463896,7463890,'aci',16.667,1),(330,7463897,7463890,'cit',16.667,1),(330,7463898,7463890,'ity',16.667,1),(330,7463899,7463893,'pat',50,1),(330,7463900,7463893,'ath',50,1),(330,7463901,7463899,'fre',14.286,1),(330,7463902,7463899,'ree',14.286,1),(330,7463903,7463899,'ees',14.286,1),(330,7463904,7463899,'esp',14.286,1),(330,7463905,7463899,'spa',14.286,1),(330,7463906,7463899,'pac',14.286,1),(330,7463907,7463899,'ace',14.286,1),(330,7463908,7463901,'dis',50,1),(330,7463909,7463901,'isk',50,1),(330,7463910,7463908,'ind',33.333,1),(330,7463911,7463908,'nde',33.333,1),(330,7463912,7463908,'dex',33.333,1),(330,7463913,7463910,'adm',8.333,1),(330,7463914,7463910,'dmi',8.333,1),(330,7463915,7463910,'min',8.333,1),(330,7463916,7463910,'ini',8.333,1),(330,7463917,7463910,'nis',8.333,1),(330,7463918,7463910,'ist',8.333,1),(330,7463919,7463910,'str',8.333,1),(330,7463920,7463910,'tra',8.333,1),(330,7463921,7463910,'rat',8.333,1),(330,7463922,7463910,'ati',8.333,1),(330,7463923,7463910,'tio',8.333,1),(330,7463924,7463910,'ion',8.333,1),(330,7463925,7463913,'sta',33.333,3),(330,7463926,7463913,'tat',33.333,3),(330,7463927,7463913,'ate',33.333,3),(330,7463928,7463925,'ena',20,2),(330,7463929,7463925,'nab',20,2),(330,7463930,7463925,'abl',20,2),(330,7463931,7463925,'ble',20,2),(330,7463932,7463925,'led',20,2),(330,7463933,7463928,'cac',33.333,1),(330,7463934,7463928,'ach',33.333,1),(330,7463935,7463928,'che',33.333,1),(330,7463936,7463933,'mod',50,2),(330,7463937,7463933,'ode',50,2),(330,7463938,7463936,'wri',14.286,2),(330,7463939,7463936,'rit',14.286,2),(330,7463940,7463936,'ite',14.286,2),(330,7463941,7463936,'tet',14.286,2),(330,7463942,7463936,'eth',14.286,2),(330,7463943,7463936,'thr',14.286,2),(330,7463944,7463936,'hru',14.286,2),(330,7463945,7463938,'ope',11.111,2),(330,7463946,7463938,'per',11.111,2),(330,7463947,7463938,'era',11.111,2),(330,7463948,7463938,'rat',11.111,2),(330,7463949,7463938,'ati',11.111,2),(330,7463950,7463938,'tio',11.111,2),(330,7463951,7463938,'ion',11.111,2),(330,7463952,7463938,'ona',11.111,2),(330,7463953,7463938,'nal',11.111,2),(330,7463954,7463945,'nor',25,1),(330,7463955,7463945,'orm',25,1),(330,7463956,7463945,'rma',25,1),(330,7463957,7463945,'mal',25,1),(330,7463958,7463954,'mes',20,1),(330,7463959,7463954,'ess',20,1),(330,7463960,7463954,'ssa',20,1),(330,7463961,7463954,'sag',20,1),(330,7463962,7463954,'age',20,1),(330,7463963,7463958,'per',11.111,1),(330,7463964,7463958,'erf',11.111,1),(330,7463965,7463958,'rfo',11.111,1),(330,7463966,7463958,'for',11.111,1),(330,7463967,7463958,'orm',11.111,1),(330,7463968,7463958,'rma',11.111,1),(330,7463969,7463958,'man',11.111,1),(330,7463970,7463958,'anc',11.111,1),(330,7463971,7463958,'nce',11.111,1),(330,7463972,7463963,'ide',12.5,1),(330,7463973,7463963,'den',12.5,1),(330,7463974,7463963,'ent',12.5,1),(330,7463975,7463963,'nti',12.5,1),(330,7463976,7463963,'tif',12.5,1),(330,7463977,7463963,'ifi',12.5,1),(330,7463978,7463963,'fie',12.5,1),(330,7463979,7463963,'ier',12.5,1),(330,7463980,7463972,'vdi',33.333,3),(330,7463981,7463972,'dis',33.333,3),(330,7463982,7463972,'isk',33.333,3),(330,7463983,7463980,'nam',50,1),(330,7463984,7463980,'ame',50,1),(330,7463985,7463983,'typ',50,1),(330,7463986,7463983,'ype',50,1),(330,7463987,7463985,'dir',25,1),(330,7463988,7463985,'ire',25,1),(330,7463989,7463985,'rec',25,1),(330,7463990,7463985,'ect',25,1),(331,7463992,7463991,'naa',100,2),(331,7463993,7463992,'600',3.333,3),(331,7463994,7463992,'000',3.333,3),(331,7463995,7463992,'00c',3.333,3),(331,7463996,7463992,'0c2',3.333,3),(331,7463997,7463992,'c29',3.333,3),(331,7463998,7463992,'29a',3.333,3),(331,7463999,7463992,'9aa',3.333,3),(331,7464000,7463992,'aa5',3.333,3),(331,7464001,7463992,'a56',3.333,3),(331,7464002,7463992,'563',3.333,3),(331,7464003,7463992,'634',3.333,3),(331,7464004,7463992,'348',3.333,3),(331,7464005,7463992,'48f',3.333,3),(331,7464006,7463992,'8f8',3.333,3),(331,7464007,7463992,'f8c',3.333,3),(331,7464008,7463992,'8c5',3.333,3),(331,7464009,7463992,'c52',3.333,3),(331,7464010,7463992,'52a',3.333,3),(331,7464011,7463992,'2aa',3.333,3),(331,7464012,7463992,'aa9',3.333,3),(331,7464013,7463992,'a98',3.333,3),(331,7464014,7463992,'982',3.333,3),(331,7464015,7463992,'82d',3.333,3),(331,7464016,7463992,'2d6',3.333,3),(331,7464017,7463992,'d67',3.333,3),(331,7464018,7463992,'67a',3.333,3),(331,7464019,7463992,'7a4',3.333,3),(331,7464020,7463992,'a43',3.333,3),(331,7464021,7463992,'435',3.333,3),(331,7464022,7463992,'35c',3.333,3),(331,7464023,7463993,'mon',100,1),(331,7464024,7464023,'201',50,1),(331,7464025,7464023,'013',50,1),(331,7464026,7464024,'adm',33.333,3),(331,7464027,7464024,'dmi',33.333,3),(331,7464028,7464024,'min',33.333,3),(331,7464029,7464026,'cap',16.667,1),(331,7464030,7464026,'apa',16.667,1),(331,7464031,7464026,'pac',16.667,1),(331,7464032,7464026,'aci',16.667,1),(331,7464033,7464026,'cit',16.667,1),(331,7464034,7464026,'ity',16.667,1),(331,7464035,7464029,'pat',50,1),(331,7464036,7464029,'ath',50,1),(331,7464037,7464035,'fre',14.286,1),(331,7464038,7464035,'ree',14.286,1),(331,7464039,7464035,'ees',14.286,1),(331,7464040,7464035,'esp',14.286,1),(331,7464041,7464035,'spa',14.286,1),(331,7464042,7464035,'pac',14.286,1),(331,7464043,7464035,'ace',14.286,1),(331,7464044,7464037,'dis',50,1),(331,7464045,7464037,'isk',50,1),(331,7464046,7464044,'ind',33.333,1),(331,7464047,7464044,'nde',33.333,1),(331,7464048,7464044,'dex',33.333,1),(331,7464049,7464046,'adm',8.333,1),(331,7464050,7464046,'dmi',8.333,1),(331,7464051,7464046,'min',8.333,1),(331,7464052,7464046,'ini',8.333,1),(331,7464053,7464046,'nis',8.333,1),(331,7464054,7464046,'ist',8.333,1),(331,7464055,7464046,'str',8.333,1),(331,7464056,7464046,'tra',8.333,1),(331,7464057,7464046,'rat',8.333,1),(331,7464058,7464046,'ati',8.333,1),(331,7464059,7464046,'tio',8.333,1),(331,7464060,7464046,'ion',8.333,1),(331,7464061,7464049,'sta',33.333,3),(331,7464062,7464049,'tat',33.333,3),(331,7464063,7464049,'ate',33.333,3),(331,7464064,7464061,'ena',20,2),(331,7464065,7464061,'nab',20,2),(331,7464066,7464061,'abl',20,2),(331,7464067,7464061,'ble',20,2),(331,7464068,7464061,'led',20,2),(331,7464069,7464064,'cac',33.333,1),(331,7464070,7464064,'ach',33.333,1),(331,7464071,7464064,'che',33.333,1),(331,7464072,7464069,'mod',50,2),(331,7464073,7464069,'ode',50,2),(331,7464074,7464072,'wri',14.286,2),(331,7464075,7464072,'rit',14.286,2),(331,7464076,7464072,'ite',14.286,2),(331,7464077,7464072,'tet',14.286,2),(331,7464078,7464072,'eth',14.286,2),(331,7464079,7464072,'thr',14.286,2),(331,7464080,7464072,'hru',14.286,2),(331,7464081,7464074,'ope',11.111,2),(331,7464082,7464074,'per',11.111,2),(331,7464083,7464074,'era',11.111,2),(331,7464084,7464074,'rat',11.111,2),(331,7464085,7464074,'ati',11.111,2),(331,7464086,7464074,'tio',11.111,2),(331,7464087,7464074,'ion',11.111,2),(331,7464088,7464074,'ona',11.111,2),(331,7464089,7464074,'nal',11.111,2),(331,7464090,7464081,'nor',25,1),(331,7464091,7464081,'orm',25,1),(331,7464092,7464081,'rma',25,1),(331,7464093,7464081,'mal',25,1),(331,7464094,7464090,'mes',20,1),(331,7464095,7464090,'ess',20,1),(331,7464096,7464090,'ssa',20,1),(331,7464097,7464090,'sag',20,1),(331,7464098,7464090,'age',20,1),(331,7464099,7464094,'per',11.111,1),(331,7464100,7464094,'erf',11.111,1),(331,7464101,7464094,'rfo',11.111,1),(331,7464102,7464094,'for',11.111,1),(331,7464103,7464094,'orm',11.111,1),(331,7464104,7464094,'rma',11.111,1),(331,7464105,7464094,'man',11.111,1),(331,7464106,7464094,'anc',11.111,1),(331,7464107,7464094,'nce',11.111,1),(331,7464108,7464099,'ide',12.5,1),(331,7464109,7464099,'den',12.5,1),(331,7464110,7464099,'ent',12.5,1),(331,7464111,7464099,'nti',12.5,1),(331,7464112,7464099,'tif',12.5,1),(331,7464113,7464099,'ifi',12.5,1),(331,7464114,7464099,'fie',12.5,1),(331,7464115,7464099,'ier',12.5,1),(331,7464116,7464108,'vdi',33.333,3),(331,7464117,7464108,'dis',33.333,3),(331,7464118,7464108,'isk',33.333,3),(331,7464119,7464116,'nam',50,1),(331,7464120,7464116,'ame',50,1),(331,7464121,7464119,'typ',50,1),(331,7464122,7464119,'ype',50,1),(331,7464123,7464121,'dir',25,1),(331,7464124,7464121,'ire',25,1),(331,7464125,7464121,'rec',25,1),(331,7464126,7464121,'ect',25,1),(332,7464128,7464127,'naa',100,2),(332,7464129,7464128,'600',3.333,3),(332,7464130,7464128,'000',3.333,3),(332,7464131,7464128,'00c',3.333,3),(332,7464132,7464128,'0c2',3.333,3),(332,7464133,7464128,'c29',3.333,3),(332,7464134,7464128,'295',3.333,3),(332,7464135,7464128,'950',3.333,3),(332,7464136,7464128,'50d',3.333,3),(332,7464137,7464128,'0d6',3.333,3),(332,7464138,7464128,'d69',3.333,3),(332,7464139,7464128,'69f',3.333,3),(332,7464140,7464128,'9f6',3.333,3),(332,7464141,7464128,'f69',3.333,3),(332,7464142,7464128,'69a',3.333,3),(332,7464143,7464128,'9a7',3.333,3),(332,7464144,7464128,'a7e',3.333,3),(332,7464145,7464128,'7e0',3.333,3),(332,7464146,7464128,'e00',3.333,3),(332,7464147,7464128,'008',3.333,3),(332,7464148,7464128,'086',3.333,3),(332,7464149,7464128,'862',3.333,3),(332,7464150,7464128,'627',3.333,3),(332,7464151,7464128,'277',3.333,3),(332,7464152,7464128,'77a',3.333,3),(332,7464153,7464128,'7a1',3.333,3),(332,7464154,7464128,'a15',3.333,3),(332,7464155,7464128,'153',3.333,3),(332,7464156,7464128,'537',3.333,3),(332,7464157,7464128,'37b',3.333,3),(332,7464158,7464128,'7b6',3.333,3),(332,7464159,7464129,'mon',100,1),(332,7464160,7464159,'201',50,1),(332,7464161,7464159,'013',50,1),(332,7464162,7464160,'adm',33.333,3),(332,7464163,7464160,'dmi',33.333,3),(332,7464164,7464160,'min',33.333,3),(332,7464165,7464162,'cap',16.667,1),(332,7464166,7464162,'apa',16.667,1),(332,7464167,7464162,'pac',16.667,1),(332,7464168,7464162,'aci',16.667,1),(332,7464169,7464162,'cit',16.667,1),(332,7464170,7464162,'ity',16.667,1),(332,7464171,7464165,'pat',50,1),(332,7464172,7464165,'ath',50,1),(332,7464173,7464171,'fre',14.286,1),(332,7464174,7464171,'ree',14.286,1),(332,7464175,7464171,'ees',14.286,1),(332,7464176,7464171,'esp',14.286,1),(332,7464177,7464171,'spa',14.286,1),(332,7464178,7464171,'pac',14.286,1),(332,7464179,7464171,'ace',14.286,1),(332,7464180,7464173,'dis',50,1),(332,7464181,7464173,'isk',50,1),(332,7464182,7464180,'ind',33.333,1),(332,7464183,7464180,'nde',33.333,1),(332,7464184,7464180,'dex',33.333,1),(332,7464185,7464182,'adm',8.333,1),(332,7464186,7464182,'dmi',8.333,1),(332,7464187,7464182,'min',8.333,1),(332,7464188,7464182,'ini',8.333,1),(332,7464189,7464182,'nis',8.333,1),(332,7464190,7464182,'ist',8.333,1),(332,7464191,7464182,'str',8.333,1),(332,7464192,7464182,'tra',8.333,1),(332,7464193,7464182,'rat',8.333,1),(332,7464194,7464182,'ati',8.333,1),(332,7464195,7464182,'tio',8.333,1),(332,7464196,7464182,'ion',8.333,1),(332,7464197,7464185,'sta',33.333,3),(332,7464198,7464185,'tat',33.333,3),(332,7464199,7464185,'ate',33.333,3),(332,7464200,7464197,'ena',20,2),(332,7464201,7464197,'nab',20,2),(332,7464202,7464197,'abl',20,2),(332,7464203,7464197,'ble',20,2),(332,7464204,7464197,'led',20,2),(332,7464205,7464200,'cac',33.333,1),(332,7464206,7464200,'ach',33.333,1),(332,7464207,7464200,'che',33.333,1),(332,7464208,7464205,'mod',50,2),(332,7464209,7464205,'ode',50,2),(332,7464210,7464208,'wri',14.286,2),(332,7464211,7464208,'rit',14.286,2),(332,7464212,7464208,'ite',14.286,2),(332,7464213,7464208,'tet',14.286,2),(332,7464214,7464208,'eth',14.286,2),(332,7464215,7464208,'thr',14.286,2),(332,7464216,7464208,'hru',14.286,2),(332,7464217,7464210,'ope',11.111,2),(332,7464218,7464210,'per',11.111,2),(332,7464219,7464210,'era',11.111,2),(332,7464220,7464210,'rat',11.111,2),(332,7464221,7464210,'ati',11.111,2),(332,7464222,7464210,'tio',11.111,2),(332,7464223,7464210,'ion',11.111,2),(332,7464224,7464210,'ona',11.111,2),(332,7464225,7464210,'nal',11.111,2),(332,7464226,7464217,'nor',25,1),(332,7464227,7464217,'orm',25,1),(332,7464228,7464217,'rma',25,1),(332,7464229,7464217,'mal',25,1),(332,7464230,7464226,'mes',20,1),(332,7464231,7464226,'ess',20,1),(332,7464232,7464226,'ssa',20,1),(332,7464233,7464226,'sag',20,1),(332,7464234,7464226,'age',20,1),(332,7464235,7464230,'per',11.111,1),(332,7464236,7464230,'erf',11.111,1),(332,7464237,7464230,'rfo',11.111,1),(332,7464238,7464230,'for',11.111,1),(332,7464239,7464230,'orm',11.111,1),(332,7464240,7464230,'rma',11.111,1),(332,7464241,7464230,'man',11.111,1),(332,7464242,7464230,'anc',11.111,1),(332,7464243,7464230,'nce',11.111,1),(332,7464244,7464235,'ide',12.5,1),(332,7464245,7464235,'den',12.5,1),(332,7464246,7464235,'ent',12.5,1),(332,7464247,7464235,'nti',12.5,1),(332,7464248,7464235,'tif',12.5,1),(332,7464249,7464235,'ifi',12.5,1),(332,7464250,7464235,'fie',12.5,1),(332,7464251,7464235,'ier',12.5,1),(332,7464252,7464244,'vdi',33.333,3),(332,7464253,7464244,'dis',33.333,3),(332,7464254,7464244,'isk',33.333,3),(332,7464255,7464252,'nam',50,1),(332,7464256,7464252,'ame',50,1),(332,7464257,7464255,'typ',50,1),(332,7464258,7464255,'ype',50,1),(332,7464259,7464257,'dir',25,1),(332,7464260,7464257,'ire',25,1),(332,7464261,7464257,'rec',25,1),(332,7464262,7464257,'ect',25,1),(333,7464264,7464263,'naa',100,2),(333,7464265,7464264,'600',3.333,3),(333,7464266,7464264,'000',3.333,3),(333,7464267,7464264,'00c',3.333,3),(333,7464268,7464264,'0c2',3.333,3),(333,7464269,7464264,'c29',3.333,3),(333,7464270,7464264,'29a',3.333,3),(333,7464271,7464264,'9a5',3.333,3),(333,7464272,7464264,'a54',3.333,3),(333,7464273,7464264,'54a',3.333,3),(333,7464274,7464264,'4a9',3.333,3),(333,7464275,7464264,'a9d',3.333,3),(333,7464276,7464264,'9df',3.333,3),(333,7464277,7464264,'df1',3.333,3),(333,7464278,7464264,'f10',3.333,3),(333,7464279,7464264,'10c',3.333,3),(333,7464280,7464264,'0c1',3.333,3),(333,7464281,7464264,'c14',3.333,3),(333,7464282,7464264,'149',3.333,3),(333,7464283,7464264,'490',3.333,3),(333,7464284,7464264,'901',3.333,3),(333,7464285,7464264,'01a',3.333,3),(333,7464286,7464264,'1ab',3.333,3),(333,7464287,7464264,'abe',3.333,3),(333,7464288,7464264,'be2',3.333,3),(333,7464289,7464264,'e20',3.333,3),(333,7464290,7464264,'20b',3.333,3),(333,7464291,7464264,'0b4',3.333,3),(333,7464292,7464264,'b48',3.333,3),(333,7464293,7464264,'484',3.333,3),(333,7464294,7464264,'848',3.333,3),(333,7464295,7464265,'mon',100,1),(333,7464296,7464295,'201',50,1),(333,7464297,7464295,'013',50,1),(333,7464298,7464296,'adm',33.333,3),(333,7464299,7464296,'dmi',33.333,3),(333,7464300,7464296,'min',33.333,3),(333,7464301,7464298,'cap',16.667,1),(333,7464302,7464298,'apa',16.667,1),(333,7464303,7464298,'pac',16.667,1),(333,7464304,7464298,'aci',16.667,1),(333,7464305,7464298,'cit',16.667,1),(333,7464306,7464298,'ity',16.667,1),(333,7464307,7464301,'pat',50,1),(333,7464308,7464301,'ath',50,1),(333,7464309,7464307,'fre',14.286,1),(333,7464310,7464307,'ree',14.286,1),(333,7464311,7464307,'ees',14.286,1),(333,7464312,7464307,'esp',14.286,1),(333,7464313,7464307,'spa',14.286,1),(333,7464314,7464307,'pac',14.286,1),(333,7464315,7464307,'ace',14.286,1),(333,7464316,7464309,'dis',50,1),(333,7464317,7464309,'isk',50,1),(333,7464318,7464316,'ind',33.333,1),(333,7464319,7464316,'nde',33.333,1),(333,7464320,7464316,'dex',33.333,1),(333,7464321,7464318,'adm',8.333,1),(333,7464322,7464318,'dmi',8.333,1),(333,7464323,7464318,'min',8.333,1),(333,7464324,7464318,'ini',8.333,1),(333,7464325,7464318,'nis',8.333,1),(333,7464326,7464318,'ist',8.333,1),(333,7464327,7464318,'str',8.333,1),(333,7464328,7464318,'tra',8.333,1),(333,7464329,7464318,'rat',8.333,1),(333,7464330,7464318,'ati',8.333,1),(333,7464331,7464318,'tio',8.333,1),(333,7464332,7464318,'ion',8.333,1),(333,7464333,7464321,'sta',33.333,3),(333,7464334,7464321,'tat',33.333,3),(333,7464335,7464321,'ate',33.333,3),(333,7464336,7464333,'ena',20,2),(333,7464337,7464333,'nab',20,2),(333,7464338,7464333,'abl',20,2),(333,7464339,7464333,'ble',20,2),(333,7464340,7464333,'led',20,2),(333,7464341,7464336,'cac',33.333,1),(333,7464342,7464336,'ach',33.333,1),(333,7464343,7464336,'che',33.333,1),(333,7464344,7464341,'mod',50,2),(333,7464345,7464341,'ode',50,2),(333,7464346,7464344,'wri',14.286,2),(333,7464347,7464344,'rit',14.286,2),(333,7464348,7464344,'ite',14.286,2),(333,7464349,7464344,'tet',14.286,2),(333,7464350,7464344,'eth',14.286,2),(333,7464351,7464344,'thr',14.286,2),(333,7464352,7464344,'hru',14.286,2),(333,7464353,7464346,'ope',11.111,2),(333,7464354,7464346,'per',11.111,2),(333,7464355,7464346,'era',11.111,2),(333,7464356,7464346,'rat',11.111,2),(333,7464357,7464346,'ati',11.111,2),(333,7464358,7464346,'tio',11.111,2),(333,7464359,7464346,'ion',11.111,2),(333,7464360,7464346,'ona',11.111,2),(333,7464361,7464346,'nal',11.111,2),(333,7464362,7464353,'nor',25,1),(333,7464363,7464353,'orm',25,1),(333,7464364,7464353,'rma',25,1),(333,7464365,7464353,'mal',25,1),(333,7464366,7464362,'mes',20,1),(333,7464367,7464362,'ess',20,1),(333,7464368,7464362,'ssa',20,1),(333,7464369,7464362,'sag',20,1),(333,7464370,7464362,'age',20,1),(333,7464371,7464366,'per',11.111,1),(333,7464372,7464366,'erf',11.111,1),(333,7464373,7464366,'rfo',11.111,1),(333,7464374,7464366,'for',11.111,1),(333,7464375,7464366,'orm',11.111,1),(333,7464376,7464366,'rma',11.111,1),(333,7464377,7464366,'man',11.111,1),(333,7464378,7464366,'anc',11.111,1),(333,7464379,7464366,'nce',11.111,1),(333,7464380,7464371,'ide',12.5,1),(333,7464381,7464371,'den',12.5,1),(333,7464382,7464371,'ent',12.5,1),(333,7464383,7464371,'nti',12.5,1),(333,7464384,7464371,'tif',12.5,1),(333,7464385,7464371,'ifi',12.5,1),(333,7464386,7464371,'fie',12.5,1),(333,7464387,7464371,'ier',12.5,1),(333,7464388,7464380,'vdi',33.333,3),(333,7464389,7464380,'dis',33.333,3),(333,7464390,7464380,'isk',33.333,3),(333,7464391,7464388,'nam',50,1),(333,7464392,7464388,'ame',50,1),(333,7464393,7464391,'typ',50,1),(333,7464394,7464391,'ype',50,1),(333,7464395,7464393,'dir',25,1),(333,7464396,7464393,'ire',25,1),(333,7464397,7464393,'rec',25,1),(333,7464398,7464393,'ect',25,1),(334,7464400,7464399,'naa',100,2),(334,7464401,7464400,'600',3.333,3),(334,7464402,7464400,'000',3.333,3),(334,7464403,7464400,'00c',3.333,3),(334,7464404,7464400,'0c2',3.333,3),(334,7464405,7464400,'c29',3.333,3),(334,7464406,7464400,'293',3.333,3),(334,7464407,7464400,'93d',3.333,3),(334,7464408,7464400,'3d4',3.333,3),(334,7464409,7464400,'d46',3.333,3),(334,7464410,7464400,'46d',3.333,3),(334,7464411,7464400,'6dc',3.333,3),(334,7464412,7464400,'dcd',3.333,3),(334,7464413,7464400,'cde',3.333,3),(334,7464414,7464400,'def',3.333,3),(334,7464415,7464400,'ef1',3.333,3),(334,7464416,7464400,'f17',3.333,3),(334,7464417,7464400,'171',3.333,3),(334,7464418,7464400,'713',3.333,3),(334,7464419,7464400,'137',3.333,3),(334,7464420,7464400,'37a',3.333,3),(334,7464421,7464400,'7ae',3.333,3),(334,7464422,7464400,'ae4',3.333,3),(334,7464423,7464400,'e44',3.333,3),(334,7464424,7464400,'44b',3.333,3),(334,7464425,7464400,'4b3',3.333,3),(334,7464426,7464400,'b3e',3.333,3),(334,7464427,7464400,'3e6',3.333,3),(334,7464428,7464400,'e63',3.333,3),(334,7464429,7464400,'63b',3.333,3),(334,7464430,7464400,'3b3',3.333,3),(334,7464431,7464401,'mon',100,1),(334,7464432,7464431,'201',50,1),(334,7464433,7464431,'013',50,1),(334,7464434,7464432,'adm',33.333,3),(334,7464435,7464432,'dmi',33.333,3),(334,7464436,7464432,'min',33.333,3),(334,7464437,7464434,'cap',16.667,1),(334,7464438,7464434,'apa',16.667,1),(334,7464439,7464434,'pac',16.667,1),(334,7464440,7464434,'aci',16.667,1),(334,7464441,7464434,'cit',16.667,1),(334,7464442,7464434,'ity',16.667,1),(334,7464443,7464437,'pat',50,1),(334,7464444,7464437,'ath',50,1),(334,7464445,7464443,'fre',14.286,1),(334,7464446,7464443,'ree',14.286,1),(334,7464447,7464443,'ees',14.286,1),(334,7464448,7464443,'esp',14.286,1),(334,7464449,7464443,'spa',14.286,1),(334,7464450,7464443,'pac',14.286,1),(334,7464451,7464443,'ace',14.286,1),(334,7464452,7464445,'dis',50,1),(334,7464453,7464445,'isk',50,1),(334,7464454,7464452,'ind',33.333,1),(334,7464455,7464452,'nde',33.333,1),(334,7464456,7464452,'dex',33.333,1),(334,7464457,7464454,'adm',8.333,1),(334,7464458,7464454,'dmi',8.333,1),(334,7464459,7464454,'min',8.333,1),(334,7464460,7464454,'ini',8.333,1),(334,7464461,7464454,'nis',8.333,1),(334,7464462,7464454,'ist',8.333,1),(334,7464463,7464454,'str',8.333,1),(334,7464464,7464454,'tra',8.333,1),(334,7464465,7464454,'rat',8.333,1),(334,7464466,7464454,'ati',8.333,1),(334,7464467,7464454,'tio',8.333,1),(334,7464468,7464454,'ion',8.333,1),(334,7464469,7464457,'sta',33.333,3),(334,7464470,7464457,'tat',33.333,3),(334,7464471,7464457,'ate',33.333,3),(334,7464472,7464469,'ena',20,2),(334,7464473,7464469,'nab',20,2),(334,7464474,7464469,'abl',20,2),(334,7464475,7464469,'ble',20,2),(334,7464476,7464469,'led',20,2),(334,7464477,7464472,'cac',33.333,1),(334,7464478,7464472,'ach',33.333,1),(334,7464479,7464472,'che',33.333,1),(334,7464480,7464477,'mod',50,2),(334,7464481,7464477,'ode',50,2),(334,7464482,7464480,'wri',14.286,2),(334,7464483,7464480,'rit',14.286,2),(334,7464484,7464480,'ite',14.286,2),(334,7464485,7464480,'tet',14.286,2),(334,7464486,7464480,'eth',14.286,2),(334,7464487,7464480,'thr',14.286,2),(334,7464488,7464480,'hru',14.286,2),(334,7464489,7464482,'ope',11.111,2),(334,7464490,7464482,'per',11.111,2),(334,7464491,7464482,'era',11.111,2),(334,7464492,7464482,'rat',11.111,2),(334,7464493,7464482,'ati',11.111,2),(334,7464494,7464482,'tio',11.111,2),(334,7464495,7464482,'ion',11.111,2),(334,7464496,7464482,'ona',11.111,2),(334,7464497,7464482,'nal',11.111,2),(334,7464498,7464489,'nor',25,1),(334,7464499,7464489,'orm',25,1),(334,7464500,7464489,'rma',25,1),(334,7464501,7464489,'mal',25,1),(334,7464502,7464498,'mes',20,1),(334,7464503,7464498,'ess',20,1),(334,7464504,7464498,'ssa',20,1),(334,7464505,7464498,'sag',20,1),(334,7464506,7464498,'age',20,1),(334,7464507,7464502,'per',11.111,1),(334,7464508,7464502,'erf',11.111,1),(334,7464509,7464502,'rfo',11.111,1),(334,7464510,7464502,'for',11.111,1),(334,7464511,7464502,'orm',11.111,1),(334,7464512,7464502,'rma',11.111,1),(334,7464513,7464502,'man',11.111,1),(334,7464514,7464502,'anc',11.111,1),(334,7464515,7464502,'nce',11.111,1),(334,7464516,7464507,'ide',12.5,1),(334,7464517,7464507,'den',12.5,1),(334,7464518,7464507,'ent',12.5,1),(334,7464519,7464507,'nti',12.5,1),(334,7464520,7464507,'tif',12.5,1),(334,7464521,7464507,'ifi',12.5,1),(334,7464522,7464507,'fie',12.5,1),(334,7464523,7464507,'ier',12.5,1),(334,7464524,7464516,'vdi',33.333,3),(334,7464525,7464516,'dis',33.333,3),(334,7464526,7464516,'isk',33.333,3),(334,7464527,7464524,'nam',50,1),(334,7464528,7464524,'ame',50,1),(334,7464529,7464527,'typ',50,1),(334,7464530,7464527,'ype',50,1),(334,7464531,7464529,'dir',25,1),(334,7464532,7464529,'ire',25,1),(334,7464533,7464529,'rec',25,1),(334,7464534,7464529,'ect',25,1),(335,7464536,7464535,'naa',100,2),(335,7464537,7464536,'600',3.333,3),(335,7464538,7464536,'000',3.333,3),(335,7464539,7464536,'00c',3.333,3),(335,7464540,7464536,'0c2',3.333,3),(335,7464541,7464536,'c29',3.333,3),(335,7464542,7464536,'298',3.333,3),(335,7464543,7464536,'987',3.333,3),(335,7464544,7464536,'879',3.333,3),(335,7464545,7464536,'79c',3.333,3),(335,7464546,7464536,'9c5',3.333,3),(335,7464547,7464536,'c54',3.333,3),(335,7464548,7464536,'542',3.333,3),(335,7464549,7464536,'426',3.333,3),(335,7464550,7464536,'262',3.333,3),(335,7464551,7464536,'625',3.333,3),(335,7464552,7464536,'25d',3.333,3),(335,7464553,7464536,'5d4',3.333,3),(335,7464554,7464536,'d4b',3.333,3),(335,7464555,7464536,'4b6',3.333,3),(335,7464556,7464536,'b60',3.333,3),(335,7464557,7464536,'608',3.333,3),(335,7464558,7464536,'088',3.333,3),(335,7464559,7464536,'88c',3.333,3),(335,7464560,7464536,'8cd',3.333,3),(335,7464561,7464536,'cdc',3.333,3),(335,7464562,7464536,'dc6',3.333,3),(335,7464563,7464536,'c6d',3.333,3),(335,7464564,7464536,'6db',3.333,3),(335,7464565,7464536,'db0',3.333,3),(335,7464566,7464536,'b0d',3.333,3),(335,7464567,7464537,'mon',100,1),(335,7464568,7464567,'201',50,1),(335,7464569,7464567,'013',50,1),(335,7464570,7464568,'adm',33.333,3),(335,7464571,7464568,'dmi',33.333,3),(335,7464572,7464568,'min',33.333,3),(335,7464573,7464570,'cap',16.667,1),(335,7464574,7464570,'apa',16.667,1),(335,7464575,7464570,'pac',16.667,1),(335,7464576,7464570,'aci',16.667,1),(335,7464577,7464570,'cit',16.667,1),(335,7464578,7464570,'ity',16.667,1),(335,7464579,7464573,'pat',50,1),(335,7464580,7464573,'ath',50,1),(335,7464581,7464579,'fre',14.286,1),(335,7464582,7464579,'ree',14.286,1),(335,7464583,7464579,'ees',14.286,1),(335,7464584,7464579,'esp',14.286,1),(335,7464585,7464579,'spa',14.286,1),(335,7464586,7464579,'pac',14.286,1),(335,7464587,7464579,'ace',14.286,1),(335,7464588,7464581,'dis',50,1),(335,7464589,7464581,'isk',50,1),(335,7464590,7464588,'ind',33.333,1),(335,7464591,7464588,'nde',33.333,1),(335,7464592,7464588,'dex',33.333,1),(335,7464593,7464590,'adm',8.333,1),(335,7464594,7464590,'dmi',8.333,1),(335,7464595,7464590,'min',8.333,1),(335,7464596,7464590,'ini',8.333,1),(335,7464597,7464590,'nis',8.333,1),(335,7464598,7464590,'ist',8.333,1),(335,7464599,7464590,'str',8.333,1),(335,7464600,7464590,'tra',8.333,1),(335,7464601,7464590,'rat',8.333,1),(335,7464602,7464590,'ati',8.333,1),(335,7464603,7464590,'tio',8.333,1),(335,7464604,7464590,'ion',8.333,1),(335,7464605,7464593,'sta',33.333,3),(335,7464606,7464593,'tat',33.333,3),(335,7464607,7464593,'ate',33.333,3),(335,7464608,7464605,'ena',20,2),(335,7464609,7464605,'nab',20,2),(335,7464610,7464605,'abl',20,2),(335,7464611,7464605,'ble',20,2),(335,7464612,7464605,'led',20,2),(335,7464613,7464608,'cac',33.333,1),(335,7464614,7464608,'ach',33.333,1),(335,7464615,7464608,'che',33.333,1),(335,7464616,7464613,'mod',50,2),(335,7464617,7464613,'ode',50,2),(335,7464618,7464616,'wri',14.286,2),(335,7464619,7464616,'rit',14.286,2),(335,7464620,7464616,'ite',14.286,2),(335,7464621,7464616,'tet',14.286,2),(335,7464622,7464616,'eth',14.286,2),(335,7464623,7464616,'thr',14.286,2),(335,7464624,7464616,'hru',14.286,2),(335,7464625,7464618,'ope',11.111,2),(335,7464626,7464618,'per',11.111,2),(335,7464627,7464618,'era',11.111,2),(335,7464628,7464618,'rat',11.111,2),(335,7464629,7464618,'ati',11.111,2),(335,7464630,7464618,'tio',11.111,2),(335,7464631,7464618,'ion',11.111,2),(335,7464632,7464618,'ona',11.111,2),(335,7464633,7464618,'nal',11.111,2),(335,7464634,7464625,'nor',25,1),(335,7464635,7464625,'orm',25,1),(335,7464636,7464625,'rma',25,1),(335,7464637,7464625,'mal',25,1),(335,7464638,7464634,'mes',20,1),(335,7464639,7464634,'ess',20,1),(335,7464640,7464634,'ssa',20,1),(335,7464641,7464634,'sag',20,1),(335,7464642,7464634,'age',20,1),(335,7464643,7464638,'per',11.111,1),(335,7464644,7464638,'erf',11.111,1),(335,7464645,7464638,'rfo',11.111,1),(335,7464646,7464638,'for',11.111,1),(335,7464647,7464638,'orm',11.111,1),(335,7464648,7464638,'rma',11.111,1),(335,7464649,7464638,'man',11.111,1),(335,7464650,7464638,'anc',11.111,1),(335,7464651,7464638,'nce',11.111,1),(335,7464652,7464643,'ide',12.5,1),(335,7464653,7464643,'den',12.5,1),(335,7464654,7464643,'ent',12.5,1),(335,7464655,7464643,'nti',12.5,1),(335,7464656,7464643,'tif',12.5,1),(335,7464657,7464643,'ifi',12.5,1),(335,7464658,7464643,'fie',12.5,1),(335,7464659,7464643,'ier',12.5,1),(335,7464660,7464652,'vdi',33.333,3),(335,7464661,7464652,'dis',33.333,3),(335,7464662,7464652,'isk',33.333,3),(335,7464663,7464660,'nam',50,1),(335,7464664,7464660,'ame',50,1),(335,7464665,7464663,'typ',50,1),(335,7464666,7464663,'ype',50,1),(335,7464667,7464665,'dir',25,1),(335,7464668,7464665,'ire',25,1),(335,7464669,7464665,'rec',25,1),(335,7464670,7464665,'ect',25,1),(336,7464672,7464671,'naa',100,2),(336,7464673,7464672,'600',3.333,3),(336,7464674,7464672,'000',3.333,3),(336,7464675,7464672,'00c',3.333,3),(336,7464676,7464672,'0c2',3.333,3),(336,7464677,7464672,'c29',3.333,3),(336,7464678,7464672,'299',3.333,3),(336,7464679,7464672,'997',3.333,3),(336,7464680,7464672,'97e',3.333,3),(336,7464681,7464672,'7ed',3.333,3),(336,7464682,7464672,'ed7',3.333,3),(336,7464683,7464672,'d7e',3.333,3),(336,7464684,7464672,'7ef',3.333,3),(336,7464685,7464672,'efd',3.333,3),(336,7464686,7464672,'fd8',3.333,3),(336,7464687,7464672,'d8c',3.333,3),(336,7464688,7464672,'8c6',3.333,3),(336,7464689,7464672,'c63',3.333,3),(336,7464690,7464672,'63e',3.333,3),(336,7464691,7464672,'3e8',3.333,3),(336,7464692,7464672,'e88',3.333,3),(336,7464693,7464672,'88f',3.333,3),(336,7464694,7464672,'8f7',3.333,3),(336,7464695,7464672,'f76',3.333,3),(336,7464696,7464672,'767',3.333,3),(336,7464697,7464672,'671',3.333,3),(336,7464698,7464672,'714',3.333,3),(336,7464699,7464672,'14c',3.333,3),(336,7464700,7464672,'4c2',3.333,3),(336,7464701,7464672,'c24',3.333,3),(336,7464702,7464672,'242',3.333,3),(336,7464703,7464673,'mon',100,1),(336,7464704,7464703,'201',50,1),(336,7464705,7464703,'013',50,1),(336,7464706,7464704,'adm',33.333,3),(336,7464707,7464704,'dmi',33.333,3),(336,7464708,7464704,'min',33.333,3),(336,7464709,7464706,'cap',16.667,1),(336,7464710,7464706,'apa',16.667,1),(336,7464711,7464706,'pac',16.667,1),(336,7464712,7464706,'aci',16.667,1),(336,7464713,7464706,'cit',16.667,1),(336,7464714,7464706,'ity',16.667,1),(336,7464715,7464709,'pat',50,1),(336,7464716,7464709,'ath',50,1),(336,7464717,7464715,'fre',14.286,1),(336,7464718,7464715,'ree',14.286,1),(336,7464719,7464715,'ees',14.286,1),(336,7464720,7464715,'esp',14.286,1),(336,7464721,7464715,'spa',14.286,1),(336,7464722,7464715,'pac',14.286,1),(336,7464723,7464715,'ace',14.286,1),(336,7464724,7464717,'dis',50,1),(336,7464725,7464717,'isk',50,1),(336,7464726,7464724,'ind',33.333,1),(336,7464727,7464724,'nde',33.333,1),(336,7464728,7464724,'dex',33.333,1),(336,7464729,7464726,'adm',8.333,1),(336,7464730,7464726,'dmi',8.333,1),(336,7464731,7464726,'min',8.333,1),(336,7464732,7464726,'ini',8.333,1),(336,7464733,7464726,'nis',8.333,1),(336,7464734,7464726,'ist',8.333,1),(336,7464735,7464726,'str',8.333,1),(336,7464736,7464726,'tra',8.333,1),(336,7464737,7464726,'rat',8.333,1),(336,7464738,7464726,'ati',8.333,1),(336,7464739,7464726,'tio',8.333,1),(336,7464740,7464726,'ion',8.333,1),(336,7464741,7464729,'sta',33.333,3),(336,7464742,7464729,'tat',33.333,3),(336,7464743,7464729,'ate',33.333,3),(336,7464744,7464741,'ena',20,2),(336,7464745,7464741,'nab',20,2),(336,7464746,7464741,'abl',20,2),(336,7464747,7464741,'ble',20,2),(336,7464748,7464741,'led',20,2),(336,7464749,7464744,'cac',33.333,1),(336,7464750,7464744,'ach',33.333,1),(336,7464751,7464744,'che',33.333,1),(336,7464752,7464749,'mod',50,2),(336,7464753,7464749,'ode',50,2),(336,7464754,7464752,'wri',14.286,2),(336,7464755,7464752,'rit',14.286,2),(336,7464756,7464752,'ite',14.286,2),(336,7464757,7464752,'tet',14.286,2),(336,7464758,7464752,'eth',14.286,2),(336,7464759,7464752,'thr',14.286,2),(336,7464760,7464752,'hru',14.286,2),(336,7464761,7464754,'ope',11.111,2),(336,7464762,7464754,'per',11.111,2),(336,7464763,7464754,'era',11.111,2),(336,7464764,7464754,'rat',11.111,2),(336,7464765,7464754,'ati',11.111,2),(336,7464766,7464754,'tio',11.111,2),(336,7464767,7464754,'ion',11.111,2),(336,7464768,7464754,'ona',11.111,2),(336,7464769,7464754,'nal',11.111,2),(336,7464770,7464761,'nor',25,1),(336,7464771,7464761,'orm',25,1),(336,7464772,7464761,'rma',25,1),(336,7464773,7464761,'mal',25,1),(336,7464774,7464770,'mes',20,1),(336,7464775,7464770,'ess',20,1),(336,7464776,7464770,'ssa',20,1),(336,7464777,7464770,'sag',20,1),(336,7464778,7464770,'age',20,1),(336,7464779,7464774,'per',11.111,1),(336,7464780,7464774,'erf',11.111,1),(336,7464781,7464774,'rfo',11.111,1),(336,7464782,7464774,'for',11.111,1),(336,7464783,7464774,'orm',11.111,1),(336,7464784,7464774,'rma',11.111,1),(336,7464785,7464774,'man',11.111,1),(336,7464786,7464774,'anc',11.111,1),(336,7464787,7464774,'nce',11.111,1),(336,7464788,7464779,'ide',12.5,1),(336,7464789,7464779,'den',12.5,1),(336,7464790,7464779,'ent',12.5,1),(336,7464791,7464779,'nti',12.5,1),(336,7464792,7464779,'tif',12.5,1),(336,7464793,7464779,'ifi',12.5,1),(336,7464794,7464779,'fie',12.5,1),(336,7464795,7464779,'ier',12.5,1),(336,7464796,7464788,'vdi',33.333,3),(336,7464797,7464788,'dis',33.333,3),(336,7464798,7464788,'isk',33.333,3),(336,7464799,7464796,'nam',50,1),(336,7464800,7464796,'ame',50,1),(336,7464801,7464799,'typ',50,1),(336,7464802,7464799,'ype',50,1),(336,7464803,7464801,'dir',25,1),(336,7464804,7464801,'ire',25,1),(336,7464805,7464801,'rec',25,1),(336,7464806,7464801,'ect',25,1),(337,7464808,7464807,'naa',100,2),(337,7464809,7464808,'600',3.333,3),(337,7464810,7464808,'000',3.333,3),(337,7464811,7464808,'00c',3.333,3),(337,7464812,7464808,'0c2',3.333,3),(337,7464813,7464808,'c29',3.333,3),(337,7464814,7464808,'294',3.333,3),(337,7464815,7464808,'942',3.333,3),(337,7464816,7464808,'42d',3.333,3),(337,7464817,7464808,'2d7',3.333,3),(337,7464818,7464808,'d74',3.333,3),(337,7464819,7464808,'742',3.333,3),(337,7464820,7464808,'42d',3.333,3),(337,7464821,7464808,'2da',3.333,3),(337,7464822,7464808,'dac',3.333,3),(337,7464823,7464808,'ac8',3.333,3),(337,7464824,7464808,'c85',3.333,3),(337,7464825,7464808,'850',3.333,3),(337,7464826,7464808,'505',3.333,3),(337,7464827,7464808,'058',3.333,3),(337,7464828,7464808,'584',3.333,3),(337,7464829,7464808,'84b',3.333,3),(337,7464830,7464808,'4b0',3.333,3),(337,7464831,7464808,'b05',3.333,3),(337,7464832,7464808,'052',3.333,3),(337,7464833,7464808,'525',3.333,3),(337,7464834,7464808,'255',3.333,3),(337,7464835,7464808,'554',3.333,3),(337,7464836,7464808,'54e',3.333,3),(337,7464837,7464808,'4ee',3.333,3),(337,7464838,7464808,'ee1',3.333,3),(337,7464839,7464809,'mon',100,1),(337,7464840,7464839,'201',50,1),(337,7464841,7464839,'013',50,1),(337,7464842,7464840,'adm',33.333,3),(337,7464843,7464840,'dmi',33.333,3),(337,7464844,7464840,'min',33.333,3),(337,7464845,7464842,'cap',16.667,1),(337,7464846,7464842,'apa',16.667,1),(337,7464847,7464842,'pac',16.667,1),(337,7464848,7464842,'aci',16.667,1),(337,7464849,7464842,'cit',16.667,1),(337,7464850,7464842,'ity',16.667,1),(337,7464851,7464845,'pat',50,1),(337,7464852,7464845,'ath',50,1),(337,7464853,7464851,'fre',14.286,1),(337,7464854,7464851,'ree',14.286,1),(337,7464855,7464851,'ees',14.286,1),(337,7464856,7464851,'esp',14.286,1),(337,7464857,7464851,'spa',14.286,1),(337,7464858,7464851,'pac',14.286,1),(337,7464859,7464851,'ace',14.286,1),(337,7464860,7464853,'dis',50,1),(337,7464861,7464853,'isk',50,1),(337,7464862,7464860,'ind',33.333,1),(337,7464863,7464860,'nde',33.333,1),(337,7464864,7464860,'dex',33.333,1),(337,7464865,7464862,'adm',8.333,1),(337,7464866,7464862,'dmi',8.333,1),(337,7464867,7464862,'min',8.333,1),(337,7464868,7464862,'ini',8.333,1),(337,7464869,7464862,'nis',8.333,1),(337,7464870,7464862,'ist',8.333,1),(337,7464871,7464862,'str',8.333,1),(337,7464872,7464862,'tra',8.333,1),(337,7464873,7464862,'rat',8.333,1),(337,7464874,7464862,'ati',8.333,1),(337,7464875,7464862,'tio',8.333,1),(337,7464876,7464862,'ion',8.333,1),(337,7464877,7464865,'sta',33.333,3),(337,7464878,7464865,'tat',33.333,3),(337,7464879,7464865,'ate',33.333,3),(337,7464880,7464877,'ena',20,2),(337,7464881,7464877,'nab',20,2),(337,7464882,7464877,'abl',20,2),(337,7464883,7464877,'ble',20,2),(337,7464884,7464877,'led',20,2),(337,7464885,7464880,'cac',33.333,1),(337,7464886,7464880,'ach',33.333,1),(337,7464887,7464880,'che',33.333,1),(337,7464888,7464885,'mod',50,2),(337,7464889,7464885,'ode',50,2),(337,7464890,7464888,'wri',14.286,2),(337,7464891,7464888,'rit',14.286,2),(337,7464892,7464888,'ite',14.286,2),(337,7464893,7464888,'tet',14.286,2),(337,7464894,7464888,'eth',14.286,2),(337,7464895,7464888,'thr',14.286,2),(337,7464896,7464888,'hru',14.286,2),(337,7464897,7464890,'ope',11.111,2),(337,7464898,7464890,'per',11.111,2),(337,7464899,7464890,'era',11.111,2),(337,7464900,7464890,'rat',11.111,2),(337,7464901,7464890,'ati',11.111,2),(337,7464902,7464890,'tio',11.111,2),(337,7464903,7464890,'ion',11.111,2),(337,7464904,7464890,'ona',11.111,2),(337,7464905,7464890,'nal',11.111,2),(337,7464906,7464897,'nor',25,1),(337,7464907,7464897,'orm',25,1),(337,7464908,7464897,'rma',25,1),(337,7464909,7464897,'mal',25,1),(337,7464910,7464906,'mes',20,1),(337,7464911,7464906,'ess',20,1),(337,7464912,7464906,'ssa',20,1),(337,7464913,7464906,'sag',20,1),(337,7464914,7464906,'age',20,1),(337,7464915,7464910,'per',11.111,1),(337,7464916,7464910,'erf',11.111,1),(337,7464917,7464910,'rfo',11.111,1),(337,7464918,7464910,'for',11.111,1),(337,7464919,7464910,'orm',11.111,1),(337,7464920,7464910,'rma',11.111,1),(337,7464921,7464910,'man',11.111,1),(337,7464922,7464910,'anc',11.111,1),(337,7464923,7464910,'nce',11.111,1),(337,7464924,7464915,'ide',12.5,1),(337,7464925,7464915,'den',12.5,1),(337,7464926,7464915,'ent',12.5,1),(337,7464927,7464915,'nti',12.5,1),(337,7464928,7464915,'tif',12.5,1),(337,7464929,7464915,'ifi',12.5,1),(337,7464930,7464915,'fie',12.5,1),(337,7464931,7464915,'ier',12.5,1),(337,7464932,7464924,'vdi',33.333,3),(337,7464933,7464924,'dis',33.333,3),(337,7464934,7464924,'isk',33.333,3),(337,7464935,7464932,'nam',50,1),(337,7464936,7464932,'ame',50,1),(337,7464937,7464935,'typ',50,1),(337,7464938,7464935,'ype',50,1),(337,7464939,7464937,'dir',25,1),(337,7464940,7464937,'ire',25,1),(337,7464941,7464937,'rec',25,1),(337,7464942,7464937,'ect',25,1),(338,7464944,7464943,'naa',100,2),(338,7464945,7464944,'600',3.333,3),(338,7464946,7464944,'000',3.333,3),(338,7464947,7464944,'00c',3.333,3),(338,7464948,7464944,'0c2',3.333,3),(338,7464949,7464944,'c29',3.333,3),(338,7464950,7464944,'290',3.333,3),(338,7464951,7464944,'901',3.333,3),(338,7464952,7464944,'01a',3.333,3),(338,7464953,7464944,'1a3',3.333,3),(338,7464954,7464944,'a38',3.333,3),(338,7464955,7464944,'38e',3.333,3),(338,7464956,7464944,'8e7',3.333,3),(338,7464957,7464944,'e75',3.333,3),(338,7464958,7464944,'752',3.333,3),(338,7464959,7464944,'528',3.333,3),(338,7464960,7464944,'283',3.333,3),(338,7464961,7464944,'833',3.333,3),(338,7464962,7464944,'335',3.333,3),(338,7464963,7464944,'35d',3.333,3),(338,7464964,7464944,'5db',3.333,3),(338,7464965,7464944,'db9',3.333,3),(338,7464966,7464944,'b9a',3.333,3),(338,7464967,7464944,'9a8',3.333,3),(338,7464968,7464944,'a8d',3.333,3),(338,7464969,7464944,'8d1',3.333,3),(338,7464970,7464944,'d1b',3.333,3),(338,7464971,7464944,'1b5',3.333,3),(338,7464972,7464944,'b55',3.333,3),(338,7464973,7464944,'55a',3.333,3),(338,7464974,7464944,'5a9',3.333,3),(338,7464975,7464945,'mon',100,1),(338,7464976,7464975,'201',50,1),(338,7464977,7464975,'013',50,1),(338,7464978,7464976,'adm',33.333,3),(338,7464979,7464976,'dmi',33.333,3),(338,7464980,7464976,'min',33.333,3),(338,7464981,7464978,'cap',16.667,1),(338,7464982,7464978,'apa',16.667,1),(338,7464983,7464978,'pac',16.667,1),(338,7464984,7464978,'aci',16.667,1),(338,7464985,7464978,'cit',16.667,1),(338,7464986,7464978,'ity',16.667,1),(338,7464987,7464981,'pat',50,1),(338,7464988,7464981,'ath',50,1),(338,7464989,7464987,'fre',14.286,1),(338,7464990,7464987,'ree',14.286,1),(338,7464991,7464987,'ees',14.286,1),(338,7464992,7464987,'esp',14.286,1),(338,7464993,7464987,'spa',14.286,1),(338,7464994,7464987,'pac',14.286,1),(338,7464995,7464987,'ace',14.286,1),(338,7464996,7464989,'dis',50,1),(338,7464997,7464989,'isk',50,1),(338,7464998,7464996,'ind',33.333,1),(338,7464999,7464996,'nde',33.333,1),(338,7465000,7464996,'dex',33.333,1),(338,7465001,7464998,'adm',8.333,1),(338,7465002,7464998,'dmi',8.333,1),(338,7465003,7464998,'min',8.333,1),(338,7465004,7464998,'ini',8.333,1),(338,7465005,7464998,'nis',8.333,1),(338,7465006,7464998,'ist',8.333,1),(338,7465007,7464998,'str',8.333,1),(338,7465008,7464998,'tra',8.333,1),(338,7465009,7464998,'rat',8.333,1),(338,7465010,7464998,'ati',8.333,1),(338,7465011,7464998,'tio',8.333,1),(338,7465012,7464998,'ion',8.333,1),(338,7465013,7465001,'sta',33.333,3),(338,7465014,7465001,'tat',33.333,3),(338,7465015,7465001,'ate',33.333,3),(338,7465016,7465013,'ena',20,2),(338,7465017,7465013,'nab',20,2),(338,7465018,7465013,'abl',20,2),(338,7465019,7465013,'ble',20,2),(338,7465020,7465013,'led',20,2),(338,7465021,7465016,'cac',33.333,1),(338,7465022,7465016,'ach',33.333,1),(338,7465023,7465016,'che',33.333,1),(338,7465024,7465021,'mod',50,2),(338,7465025,7465021,'ode',50,2),(338,7465026,7465024,'wri',14.286,2),(338,7465027,7465024,'rit',14.286,2),(338,7465028,7465024,'ite',14.286,2),(338,7465029,7465024,'tet',14.286,2),(338,7465030,7465024,'eth',14.286,2),(338,7465031,7465024,'thr',14.286,2),(338,7465032,7465024,'hru',14.286,2),(338,7465033,7465026,'ope',11.111,2),(338,7465034,7465026,'per',11.111,2),(338,7465035,7465026,'era',11.111,2),(338,7465036,7465026,'rat',11.111,2),(338,7465037,7465026,'ati',11.111,2),(338,7465038,7465026,'tio',11.111,2),(338,7465039,7465026,'ion',11.111,2),(338,7465040,7465026,'ona',11.111,2),(338,7465041,7465026,'nal',11.111,2),(338,7465042,7465033,'nor',25,1),(338,7465043,7465033,'orm',25,1),(338,7465044,7465033,'rma',25,1),(338,7465045,7465033,'mal',25,1),(338,7465046,7465042,'mes',20,1),(338,7465047,7465042,'ess',20,1),(338,7465048,7465042,'ssa',20,1),(338,7465049,7465042,'sag',20,1),(338,7465050,7465042,'age',20,1),(338,7465051,7465046,'per',11.111,1),(338,7465052,7465046,'erf',11.111,1),(338,7465053,7465046,'rfo',11.111,1),(338,7465054,7465046,'for',11.111,1),(338,7465055,7465046,'orm',11.111,1),(338,7465056,7465046,'rma',11.111,1),(338,7465057,7465046,'man',11.111,1),(338,7465058,7465046,'anc',11.111,1),(338,7465059,7465046,'nce',11.111,1),(338,7465060,7465051,'ide',12.5,1),(338,7465061,7465051,'den',12.5,1),(338,7465062,7465051,'ent',12.5,1),(338,7465063,7465051,'nti',12.5,1),(338,7465064,7465051,'tif',12.5,1),(338,7465065,7465051,'ifi',12.5,1),(338,7465066,7465051,'fie',12.5,1),(338,7465067,7465051,'ier',12.5,1),(338,7465068,7465060,'vdi',33.333,3),(338,7465069,7465060,'dis',33.333,3),(338,7465070,7465060,'isk',33.333,3),(338,7465071,7465068,'nam',50,1),(338,7465072,7465068,'ame',50,1),(338,7465073,7465071,'typ',50,1),(338,7465074,7465071,'ype',50,1),(338,7465075,7465073,'dir',25,1),(338,7465076,7465073,'ire',25,1),(338,7465077,7465073,'rec',25,1),(338,7465078,7465073,'ect',25,1),(339,7465080,7465079,'naa',100,2),(339,7465081,7465080,'600',3.333,3),(339,7465082,7465080,'000',3.333,3),(339,7465083,7465080,'00c',3.333,3),(339,7465084,7465080,'0c2',3.333,3),(339,7465085,7465080,'c29',3.333,3),(339,7465086,7465080,'293',3.333,3),(339,7465087,7465080,'93a',3.333,3),(339,7465088,7465080,'3a3',3.333,3),(339,7465089,7465080,'a34',3.333,3),(339,7465090,7465080,'34e',3.333,3),(339,7465091,7465080,'4e4',3.333,3),(339,7465092,7465080,'e4f',3.333,3),(339,7465093,7465080,'4ff',3.333,3),(339,7465094,7465080,'ff9',3.333,3),(339,7465095,7465080,'f97',3.333,3),(339,7465096,7465080,'971',3.333,3),(339,7465097,7465080,'71e',3.333,3),(339,7465098,7465080,'1e1',3.333,3),(339,7465099,7465080,'e1b',3.333,3),(339,7465100,7465080,'1b1',3.333,3),(339,7465101,7465080,'b11',3.333,3),(339,7465102,7465080,'11d',3.333,3),(339,7465103,7465080,'1d4',3.333,3),(339,7465104,7465080,'d44',3.333,3),(339,7465105,7465080,'447',3.333,3),(339,7465106,7465080,'47e',3.333,3),(339,7465107,7465080,'7e4',3.333,3),(339,7465108,7465080,'e4a',3.333,3),(339,7465109,7465080,'4a4',3.333,3),(339,7465110,7465080,'a42',3.333,3),(339,7465111,7465081,'mon',100,1),(339,7465112,7465111,'201',50,1),(339,7465113,7465111,'013',50,1),(339,7465114,7465112,'adm',33.333,3),(339,7465115,7465112,'dmi',33.333,3),(339,7465116,7465112,'min',33.333,3),(339,7465117,7465114,'cap',16.667,1),(339,7465118,7465114,'apa',16.667,1),(339,7465119,7465114,'pac',16.667,1),(339,7465120,7465114,'aci',16.667,1),(339,7465121,7465114,'cit',16.667,1),(339,7465122,7465114,'ity',16.667,1),(339,7465123,7465117,'pat',50,1),(339,7465124,7465117,'ath',50,1),(339,7465125,7465123,'fre',14.286,1),(339,7465126,7465123,'ree',14.286,1),(339,7465127,7465123,'ees',14.286,1),(339,7465128,7465123,'esp',14.286,1),(339,7465129,7465123,'spa',14.286,1),(339,7465130,7465123,'pac',14.286,1),(339,7465131,7465123,'ace',14.286,1),(339,7465132,7465125,'dis',50,1),(339,7465133,7465125,'isk',50,1),(339,7465134,7465132,'ind',33.333,1),(339,7465135,7465132,'nde',33.333,1),(339,7465136,7465132,'dex',33.333,1),(339,7465137,7465134,'adm',8.333,1),(339,7465138,7465134,'dmi',8.333,1),(339,7465139,7465134,'min',8.333,1),(339,7465140,7465134,'ini',8.333,1),(339,7465141,7465134,'nis',8.333,1),(339,7465142,7465134,'ist',8.333,1),(339,7465143,7465134,'str',8.333,1),(339,7465144,7465134,'tra',8.333,1),(339,7465145,7465134,'rat',8.333,1),(339,7465146,7465134,'ati',8.333,1),(339,7465147,7465134,'tio',8.333,1),(339,7465148,7465134,'ion',8.333,1),(339,7465149,7465137,'sta',33.333,3),(339,7465150,7465137,'tat',33.333,3),(339,7465151,7465137,'ate',33.333,3),(339,7465152,7465149,'ena',20,2),(339,7465153,7465149,'nab',20,2),(339,7465154,7465149,'abl',20,2),(339,7465155,7465149,'ble',20,2),(339,7465156,7465149,'led',20,2),(339,7465157,7465152,'cac',33.333,1),(339,7465158,7465152,'ach',33.333,1),(339,7465159,7465152,'che',33.333,1),(339,7465160,7465157,'mod',50,2),(339,7465161,7465157,'ode',50,2),(339,7465162,7465160,'wri',14.286,2),(339,7465163,7465160,'rit',14.286,2),(339,7465164,7465160,'ite',14.286,2),(339,7465165,7465160,'tet',14.286,2),(339,7465166,7465160,'eth',14.286,2),(339,7465167,7465160,'thr',14.286,2),(339,7465168,7465160,'hru',14.286,2),(339,7465169,7465162,'ope',11.111,2),(339,7465170,7465162,'per',11.111,2),(339,7465171,7465162,'era',11.111,2),(339,7465172,7465162,'rat',11.111,2),(339,7465173,7465162,'ati',11.111,2),(339,7465174,7465162,'tio',11.111,2),(339,7465175,7465162,'ion',11.111,2),(339,7465176,7465162,'ona',11.111,2),(339,7465177,7465162,'nal',11.111,2),(339,7465178,7465169,'nor',25,1),(339,7465179,7465169,'orm',25,1),(339,7465180,7465169,'rma',25,1),(339,7465181,7465169,'mal',25,1),(339,7465182,7465178,'mes',20,1),(339,7465183,7465178,'ess',20,1),(339,7465184,7465178,'ssa',20,1),(339,7465185,7465178,'sag',20,1),(339,7465186,7465178,'age',20,1),(339,7465187,7465182,'per',11.111,1),(339,7465188,7465182,'erf',11.111,1),(339,7465189,7465182,'rfo',11.111,1),(339,7465190,7465182,'for',11.111,1),(339,7465191,7465182,'orm',11.111,1),(339,7465192,7465182,'rma',11.111,1),(339,7465193,7465182,'man',11.111,1),(339,7465194,7465182,'anc',11.111,1),(339,7465195,7465182,'nce',11.111,1),(339,7465196,7465187,'ide',12.5,1),(339,7465197,7465187,'den',12.5,1),(339,7465198,7465187,'ent',12.5,1),(339,7465199,7465187,'nti',12.5,1),(339,7465200,7465187,'tif',12.5,1),(339,7465201,7465187,'ifi',12.5,1),(339,7465202,7465187,'fie',12.5,1),(339,7465203,7465187,'ier',12.5,1),(339,7465204,7465196,'vdi',33.333,3),(339,7465205,7465196,'dis',33.333,3),(339,7465206,7465196,'isk',33.333,3),(339,7465207,7465204,'nam',50,1),(339,7465208,7465204,'ame',50,1),(339,7465209,7465207,'typ',50,1),(339,7465210,7465207,'ype',50,1),(339,7465211,7465209,'dir',25,1),(339,7465212,7465209,'ire',25,1),(339,7465213,7465209,'rec',25,1),(339,7465214,7465209,'ect',25,1),(340,7465216,7465215,'naa',100,2),(340,7465217,7465216,'600',3.333,3),(340,7465218,7465216,'000',3.333,3),(340,7465219,7465216,'00c',3.333,3),(340,7465220,7465216,'0c2',3.333,3),(340,7465221,7465216,'c29',3.333,3),(340,7465222,7465216,'293',3.333,3),(340,7465223,7465216,'932',3.333,3),(340,7465224,7465216,'327',3.333,3),(340,7465225,7465216,'272',3.333,3),(340,7465226,7465216,'722',3.333,3),(340,7465227,7465216,'22f',3.333,3),(340,7465228,7465216,'2fb',3.333,3),(340,7465229,7465216,'fba',3.333,3),(340,7465230,7465216,'ba5',3.333,3),(340,7465231,7465216,'a55',3.333,3),(340,7465232,7465216,'553',3.333,3),(340,7465233,7465216,'532',3.333,3),(340,7465234,7465216,'32a',3.333,3),(340,7465235,7465216,'2a5',3.333,3),(340,7465236,7465216,'a5b',3.333,3),(340,7465237,7465216,'5b3',3.333,3),(340,7465238,7465216,'b3c',3.333,3),(340,7465239,7465216,'3cd',3.333,3),(340,7465240,7465216,'cde',3.333,3),(340,7465241,7465216,'de7',3.333,3),(340,7465242,7465216,'e7c',3.333,3),(340,7465243,7465216,'7c0',3.333,3),(340,7465244,7465216,'c0c',3.333,3),(340,7465245,7465216,'0c6',3.333,3),(340,7465246,7465216,'c63',3.333,3),(340,7465247,7465217,'mon',100,1),(340,7465248,7465247,'201',50,1),(340,7465249,7465247,'013',50,1),(340,7465250,7465248,'adm',33.333,3),(340,7465251,7465248,'dmi',33.333,3),(340,7465252,7465248,'min',33.333,3),(340,7465253,7465250,'cap',16.667,1),(340,7465254,7465250,'apa',16.667,1),(340,7465255,7465250,'pac',16.667,1),(340,7465256,7465250,'aci',16.667,1),(340,7465257,7465250,'cit',16.667,1),(340,7465258,7465250,'ity',16.667,1),(340,7465259,7465253,'pat',50,1),(340,7465260,7465253,'ath',50,1),(340,7465261,7465259,'fre',14.286,1),(340,7465262,7465259,'ree',14.286,1),(340,7465263,7465259,'ees',14.286,1),(340,7465264,7465259,'esp',14.286,1),(340,7465265,7465259,'spa',14.286,1),(340,7465266,7465259,'pac',14.286,1),(340,7465267,7465259,'ace',14.286,1),(340,7465268,7465261,'dis',50,1),(340,7465269,7465261,'isk',50,1),(340,7465270,7465268,'ind',33.333,1),(340,7465271,7465268,'nde',33.333,1),(340,7465272,7465268,'dex',33.333,1),(340,7465273,7465270,'adm',8.333,1),(340,7465274,7465270,'dmi',8.333,1),(340,7465275,7465270,'min',8.333,1),(340,7465276,7465270,'ini',8.333,1),(340,7465277,7465270,'nis',8.333,1),(340,7465278,7465270,'ist',8.333,1),(340,7465279,7465270,'str',8.333,1),(340,7465280,7465270,'tra',8.333,1),(340,7465281,7465270,'rat',8.333,1),(340,7465282,7465270,'ati',8.333,1),(340,7465283,7465270,'tio',8.333,1),(340,7465284,7465270,'ion',8.333,1),(340,7465285,7465273,'sta',33.333,3),(340,7465286,7465273,'tat',33.333,3),(340,7465287,7465273,'ate',33.333,3),(340,7465288,7465285,'ena',20,2),(340,7465289,7465285,'nab',20,2),(340,7465290,7465285,'abl',20,2),(340,7465291,7465285,'ble',20,2),(340,7465292,7465285,'led',20,2),(340,7465293,7465288,'cac',33.333,1),(340,7465294,7465288,'ach',33.333,1),(340,7465295,7465288,'che',33.333,1),(340,7465296,7465293,'mod',50,2),(340,7465297,7465293,'ode',50,2),(340,7465298,7465296,'wri',14.286,2),(340,7465299,7465296,'rit',14.286,2),(340,7465300,7465296,'ite',14.286,2),(340,7465301,7465296,'tet',14.286,2),(340,7465302,7465296,'eth',14.286,2),(340,7465303,7465296,'thr',14.286,2),(340,7465304,7465296,'hru',14.286,2),(340,7465305,7465298,'ope',11.111,2),(340,7465306,7465298,'per',11.111,2),(340,7465307,7465298,'era',11.111,2),(340,7465308,7465298,'rat',11.111,2),(340,7465309,7465298,'ati',11.111,2),(340,7465310,7465298,'tio',11.111,2),(340,7465311,7465298,'ion',11.111,2),(340,7465312,7465298,'ona',11.111,2),(340,7465313,7465298,'nal',11.111,2),(340,7465314,7465305,'nor',25,1),(340,7465315,7465305,'orm',25,1),(340,7465316,7465305,'rma',25,1),(340,7465317,7465305,'mal',25,1),(340,7465318,7465314,'mes',20,1),(340,7465319,7465314,'ess',20,1),(340,7465320,7465314,'ssa',20,1),(340,7465321,7465314,'sag',20,1),(340,7465322,7465314,'age',20,1),(340,7465323,7465318,'per',11.111,1),(340,7465324,7465318,'erf',11.111,1),(340,7465325,7465318,'rfo',11.111,1),(340,7465326,7465318,'for',11.111,1),(340,7465327,7465318,'orm',11.111,1),(340,7465328,7465318,'rma',11.111,1),(340,7465329,7465318,'man',11.111,1),(340,7465330,7465318,'anc',11.111,1),(340,7465331,7465318,'nce',11.111,1),(340,7465332,7465323,'ide',12.5,1),(340,7465333,7465323,'den',12.5,1),(340,7465334,7465323,'ent',12.5,1),(340,7465335,7465323,'nti',12.5,1),(340,7465336,7465323,'tif',12.5,1),(340,7465337,7465323,'ifi',12.5,1),(340,7465338,7465323,'fie',12.5,1),(340,7465339,7465323,'ier',12.5,1),(340,7465340,7465332,'vdi',33.333,3),(340,7465341,7465332,'dis',33.333,3),(340,7465342,7465332,'isk',33.333,3),(340,7465343,7465340,'nam',50,1),(340,7465344,7465340,'ame',50,1),(340,7465345,7465343,'typ',50,1),(340,7465346,7465343,'ype',50,1),(340,7465347,7465345,'dir',25,1),(340,7465348,7465345,'ire',25,1),(340,7465349,7465345,'rec',25,1),(340,7465350,7465345,'ect',25,1),(341,7465352,7465351,'naa',100,2),(341,7465353,7465352,'600',3.333,3),(341,7465354,7465352,'000',3.333,3),(341,7465355,7465352,'00c',3.333,3),(341,7465356,7465352,'0c2',3.333,3),(341,7465357,7465352,'c29',3.333,3),(341,7465358,7465352,'29c',3.333,3),(341,7465359,7465352,'9c2',3.333,3),(341,7465360,7465352,'c2a',3.333,3),(341,7465361,7465352,'2a0',3.333,3),(341,7465362,7465352,'a03',3.333,3),(341,7465363,7465352,'035',3.333,3),(341,7465364,7465352,'35d',3.333,3),(341,7465365,7465352,'5de',3.333,3),(341,7465366,7465352,'dec',3.333,3),(341,7465367,7465352,'ec0',3.333,3),(341,7465368,7465352,'c0c',3.333,3),(341,7465369,7465352,'0cb',3.333,3),(341,7465370,7465352,'cb7',3.333,3),(341,7465371,7465352,'b7c',3.333,3),(341,7465372,7465352,'7cf',3.333,3),(341,7465373,7465352,'cf2',3.333,3),(341,7465374,7465352,'f21',3.333,3),(341,7465375,7465352,'218',3.333,3),(341,7465376,7465352,'184',3.333,3),(341,7465377,7465352,'841',3.333,3),(341,7465378,7465352,'419',3.333,3),(341,7465379,7465352,'192',3.333,3),(341,7465380,7465352,'926',3.333,3),(341,7465381,7465352,'267',3.333,3),(341,7465382,7465352,'67b',3.333,3),(341,7465383,7465353,'mon',100,1),(341,7465384,7465383,'201',50,1),(341,7465385,7465383,'013',50,1),(341,7465386,7465384,'adm',33.333,3),(341,7465387,7465384,'dmi',33.333,3),(341,7465388,7465384,'min',33.333,3),(341,7465389,7465386,'cap',16.667,1),(341,7465390,7465386,'apa',16.667,1),(341,7465391,7465386,'pac',16.667,1),(341,7465392,7465386,'aci',16.667,1),(341,7465393,7465386,'cit',16.667,1),(341,7465394,7465386,'ity',16.667,1),(341,7465395,7465389,'pat',50,1),(341,7465396,7465389,'ath',50,1),(341,7465397,7465395,'fre',14.286,1),(341,7465398,7465395,'ree',14.286,1),(341,7465399,7465395,'ees',14.286,1),(341,7465400,7465395,'esp',14.286,1),(341,7465401,7465395,'spa',14.286,1),(341,7465402,7465395,'pac',14.286,1),(341,7465403,7465395,'ace',14.286,1),(341,7465404,7465397,'dis',50,1),(341,7465405,7465397,'isk',50,1),(341,7465406,7465404,'ind',33.333,1),(341,7465407,7465404,'nde',33.333,1),(341,7465408,7465404,'dex',33.333,1),(341,7465409,7465406,'adm',8.333,1),(341,7465410,7465406,'dmi',8.333,1),(341,7465411,7465406,'min',8.333,1),(341,7465412,7465406,'ini',8.333,1),(341,7465413,7465406,'nis',8.333,1),(341,7465414,7465406,'ist',8.333,1),(341,7465415,7465406,'str',8.333,1),(341,7465416,7465406,'tra',8.333,1),(341,7465417,7465406,'rat',8.333,1),(341,7465418,7465406,'ati',8.333,1),(341,7465419,7465406,'tio',8.333,1),(341,7465420,7465406,'ion',8.333,1),(341,7465421,7465409,'sta',33.333,3),(341,7465422,7465409,'tat',33.333,3),(341,7465423,7465409,'ate',33.333,3),(341,7465424,7465421,'ena',20,2),(341,7465425,7465421,'nab',20,2),(341,7465426,7465421,'abl',20,2),(341,7465427,7465421,'ble',20,2),(341,7465428,7465421,'led',20,2),(341,7465429,7465424,'cac',33.333,1),(341,7465430,7465424,'ach',33.333,1),(341,7465431,7465424,'che',33.333,1),(341,7465432,7465429,'mod',50,2),(341,7465433,7465429,'ode',50,2),(341,7465434,7465432,'wri',14.286,2),(341,7465435,7465432,'rit',14.286,2),(341,7465436,7465432,'ite',14.286,2),(341,7465437,7465432,'tet',14.286,2),(341,7465438,7465432,'eth',14.286,2),(341,7465439,7465432,'thr',14.286,2),(341,7465440,7465432,'hru',14.286,2),(341,7465441,7465434,'ope',11.111,2),(341,7465442,7465434,'per',11.111,2),(341,7465443,7465434,'era',11.111,2),(341,7465444,7465434,'rat',11.111,2),(341,7465445,7465434,'ati',11.111,2),(341,7465446,7465434,'tio',11.111,2),(341,7465447,7465434,'ion',11.111,2),(341,7465448,7465434,'ona',11.111,2),(341,7465449,7465434,'nal',11.111,2),(341,7465450,7465441,'nor',25,1),(341,7465451,7465441,'orm',25,1),(341,7465452,7465441,'rma',25,1),(341,7465453,7465441,'mal',25,1),(341,7465454,7465450,'mes',20,1),(341,7465455,7465450,'ess',20,1),(341,7465456,7465450,'ssa',20,1),(341,7465457,7465450,'sag',20,1),(341,7465458,7465450,'age',20,1),(341,7465459,7465454,'per',11.111,1),(341,7465460,7465454,'erf',11.111,1),(341,7465461,7465454,'rfo',11.111,1),(341,7465462,7465454,'for',11.111,1),(341,7465463,7465454,'orm',11.111,1),(341,7465464,7465454,'rma',11.111,1),(341,7465465,7465454,'man',11.111,1),(341,7465466,7465454,'anc',11.111,1),(341,7465467,7465454,'nce',11.111,1),(341,7465468,7465459,'ide',12.5,1),(341,7465469,7465459,'den',12.5,1),(341,7465470,7465459,'ent',12.5,1),(341,7465471,7465459,'nti',12.5,1),(341,7465472,7465459,'tif',12.5,1),(341,7465473,7465459,'ifi',12.5,1),(341,7465474,7465459,'fie',12.5,1),(341,7465475,7465459,'ier',12.5,1),(341,7465476,7465468,'vdi',33.333,3),(341,7465477,7465468,'dis',33.333,3),(341,7465478,7465468,'isk',33.333,3),(341,7465479,7465476,'nam',50,1),(341,7465480,7465476,'ame',50,1),(341,7465481,7465479,'typ',50,1),(341,7465482,7465479,'ype',50,1),(341,7465483,7465481,'dir',25,1),(341,7465484,7465481,'ire',25,1),(341,7465485,7465481,'rec',25,1),(341,7465486,7465481,'ect',25,1),(342,7465488,7465487,'naa',100,2),(342,7465489,7465488,'600',3.333,3),(342,7465490,7465488,'000',3.333,3),(342,7465491,7465488,'00c',3.333,3),(342,7465492,7465488,'0c2',3.333,3),(342,7465493,7465488,'c29',3.333,3),(342,7465494,7465488,'29d',3.333,3),(342,7465495,7465488,'9db',3.333,3),(342,7465496,7465488,'db0',3.333,3),(342,7465497,7465488,'b0b',3.333,3),(342,7465498,7465488,'0b2',3.333,3),(342,7465499,7465488,'b2f',3.333,3),(342,7465500,7465488,'2f9',3.333,3),(342,7465501,7465488,'f97',3.333,3),(342,7465502,7465488,'97b',3.333,3),(342,7465503,7465488,'7bc',3.333,3),(342,7465504,7465488,'bc7',3.333,3),(342,7465505,7465488,'c78',3.333,3),(342,7465506,7465488,'785',3.333,3),(342,7465507,7465488,'852',3.333,3),(342,7465508,7465488,'52b',3.333,3),(342,7465509,7465488,'2ba',3.333,3),(342,7465510,7465488,'ba8',3.333,3),(342,7465511,7465488,'a85',3.333,3),(342,7465512,7465488,'854',3.333,3),(342,7465513,7465488,'54b',3.333,3),(342,7465514,7465488,'4bc',3.333,3),(342,7465515,7465488,'bc5',3.333,3),(342,7465516,7465488,'c5a',3.333,3),(342,7465517,7465488,'5a0',3.333,3),(342,7465518,7465488,'a0f',3.333,3),(342,7465519,7465489,'mon',100,1),(342,7465520,7465519,'201',50,1),(342,7465521,7465519,'013',50,1),(342,7465522,7465520,'adm',33.333,3),(342,7465523,7465520,'dmi',33.333,3),(342,7465524,7465520,'min',33.333,3),(342,7465525,7465522,'cap',16.667,1),(342,7465526,7465522,'apa',16.667,1),(342,7465527,7465522,'pac',16.667,1),(342,7465528,7465522,'aci',16.667,1),(342,7465529,7465522,'cit',16.667,1),(342,7465530,7465522,'ity',16.667,1),(342,7465531,7465525,'pat',50,1),(342,7465532,7465525,'ath',50,1),(342,7465533,7465531,'two',100,1),(342,7465534,7465533,'fre',14.286,1),(342,7465535,7465533,'ree',14.286,1),(342,7465536,7465533,'ees',14.286,1),(342,7465537,7465533,'esp',14.286,1),(342,7465538,7465533,'spa',14.286,1),(342,7465539,7465533,'pac',14.286,1),(342,7465540,7465533,'ace',14.286,1),(342,7465541,7465534,'dis',50,1),(342,7465542,7465534,'isk',50,1),(342,7465543,7465541,'ind',33.333,1),(342,7465544,7465541,'nde',33.333,1),(342,7465545,7465541,'dex',33.333,1),(342,7465546,7465543,'adm',8.333,1),(342,7465547,7465543,'dmi',8.333,1),(342,7465548,7465543,'min',8.333,1),(342,7465549,7465543,'ini',8.333,1),(342,7465550,7465543,'nis',8.333,1),(342,7465551,7465543,'ist',8.333,1),(342,7465552,7465543,'str',8.333,1),(342,7465553,7465543,'tra',8.333,1),(342,7465554,7465543,'rat',8.333,1),(342,7465555,7465543,'ati',8.333,1),(342,7465556,7465543,'tio',8.333,1),(342,7465557,7465543,'ion',8.333,1),(342,7465558,7465546,'sta',33.333,3),(342,7465559,7465546,'tat',33.333,3),(342,7465560,7465546,'ate',33.333,3),(342,7465561,7465558,'ena',20,2),(342,7465562,7465558,'nab',20,2),(342,7465563,7465558,'abl',20,2),(342,7465564,7465558,'ble',20,2),(342,7465565,7465558,'led',20,2),(342,7465566,7465561,'cac',33.333,1),(342,7465567,7465561,'ach',33.333,1),(342,7465568,7465561,'che',33.333,1),(342,7465569,7465566,'mod',50,2),(342,7465570,7465566,'ode',50,2),(342,7465571,7465569,'wri',14.286,2),(342,7465572,7465569,'rit',14.286,2),(342,7465573,7465569,'ite',14.286,2),(342,7465574,7465569,'tet',14.286,2),(342,7465575,7465569,'eth',14.286,2),(342,7465576,7465569,'thr',14.286,2),(342,7465577,7465569,'hru',14.286,2),(342,7465578,7465571,'ope',11.111,2),(342,7465579,7465571,'per',11.111,2),(342,7465580,7465571,'era',11.111,2),(342,7465581,7465571,'rat',11.111,2),(342,7465582,7465571,'ati',11.111,2),(342,7465583,7465571,'tio',11.111,2),(342,7465584,7465571,'ion',11.111,2),(342,7465585,7465571,'ona',11.111,2),(342,7465586,7465571,'nal',11.111,2),(342,7465587,7465578,'nor',25,1),(342,7465588,7465578,'orm',25,1),(342,7465589,7465578,'rma',25,1),(342,7465590,7465578,'mal',25,1),(342,7465591,7465587,'mes',20,1),(342,7465592,7465587,'ess',20,1),(342,7465593,7465587,'ssa',20,1),(342,7465594,7465587,'sag',20,1),(342,7465595,7465587,'age',20,1),(342,7465596,7465591,'per',11.111,1),(342,7465597,7465591,'erf',11.111,1),(342,7465598,7465591,'rfo',11.111,1),(342,7465599,7465591,'for',11.111,1),(342,7465600,7465591,'orm',11.111,1),(342,7465601,7465591,'rma',11.111,1),(342,7465602,7465591,'man',11.111,1),(342,7465603,7465591,'anc',11.111,1),(342,7465604,7465591,'nce',11.111,1),(342,7465605,7465596,'ide',12.5,1),(342,7465606,7465596,'den',12.5,1),(342,7465607,7465596,'ent',12.5,1),(342,7465608,7465596,'nti',12.5,1),(342,7465609,7465596,'tif',12.5,1),(342,7465610,7465596,'ifi',12.5,1),(342,7465611,7465596,'fie',12.5,1),(342,7465612,7465596,'ier',12.5,1),(342,7465613,7465605,'vdi',33.333,3),(342,7465614,7465605,'dis',33.333,3),(342,7465615,7465605,'isk',33.333,3),(342,7465616,7465613,'nam',50,1),(342,7465617,7465613,'ame',50,1),(342,7465618,7465616,'typ',50,1),(342,7465619,7465616,'ype',50,1),(342,7465620,7465618,'dir',25,1),(342,7465621,7465618,'ire',25,1),(342,7465622,7465618,'rec',25,1),(342,7465623,7465618,'ect',25,1),(343,7465625,7465624,'att',12.5,1),(343,7465626,7465624,'ttr',12.5,1),(343,7465627,7465624,'tri',12.5,1),(343,7465628,7465624,'rib',12.5,1),(343,7465629,7465624,'ibu',12.5,1),(343,7465630,7465624,'but',12.5,1),(343,7465631,7465624,'ute',12.5,1),(343,7465632,7465624,'tes',12.5,1),(343,7465633,7465625,'ref',20,3),(343,7465634,7465625,'efr',20,3),(343,7465635,7465625,'fre',20,3),(343,7465636,7465625,'res',20,3),(343,7465637,7465625,'esh',20,3),(343,7465638,7465633,'hos',50,2),(343,7465639,7465633,'ost',50,2),(343,7465640,7465638,'nam',50,2),(343,7465641,7465638,'ame',50,2),(343,7465642,7465640,'hg3',9.091,1),(343,7465643,7465640,'g32',9.091,1),(343,7465644,7465640,'32v',9.091,1),(343,7465645,7465640,'2vm',9.091,1),(343,7465646,7465640,'vm4',9.091,1),(343,7465647,7465640,'m4w',9.091,1),(343,7465648,7465640,'4w2',9.091,1),(343,7465649,7465640,'w2k',9.091,1),(343,7465650,7465640,'2k8',9.091,1),(343,7465651,7465640,'k8r',9.091,1),(343,7465652,7465640,'8r2',9.091,1),(343,7465653,7465642,'gdl',100,1),(343,7465654,7465653,'eng',25,1),(343,7465655,7465653,'ngl',25,1),(343,7465656,7465653,'gla',25,1),(343,7465657,7465653,'lab',25,1),(343,7465658,7465654,'net',25,1),(343,7465659,7465654,'eta',25,1),(343,7465660,7465654,'tap',25,1),(343,7465661,7465654,'app',25,1),(343,7465662,7465658,'com',100,1),(343,7465663,7465662,'mem',25,3),(343,7465664,7465662,'emo',25,3),(343,7465665,7465662,'mor',25,3),(343,7465666,7465662,'ory',25,3),(343,7465667,7465663,'siz',50,2),(343,7465668,7465663,'ize',50,2),(343,7465669,7465667,'614',50,1),(343,7465670,7465667,'144',50,1),(343,7465671,7465669,'cpu',100,1),(343,7465672,7465671,'usa',33.333,3),(343,7465673,7465671,'sag',33.333,3),(343,7465674,7465671,'age',33.333,3),(343,7465675,7465672,'mhz',100,1),(343,7465676,7465675,'add',20,1),(343,7465677,7465675,'ddr',20,1),(343,7465678,7465675,'dre',20,1),(343,7465679,7465675,'res',20,1),(343,7465680,7465675,'ess',20,1),(343,7465681,7465676,'226',100,1),(343,7465682,7465681,'147',100,1),(343,7465683,7465682,'206',100,1),(343,7465684,7465683,'620',50,1),(343,7465685,7465683,'206',50,1),(343,7465686,7465684,'gue',33.333,2),(343,7465687,7465684,'ues',33.333,2),(343,7465688,7465684,'est',33.333,2),(343,7465689,7465686,'vmw',25,2),(343,7465690,7465686,'mwa',25,2),(343,7465691,7465686,'war',25,2),(343,7465692,7465686,'are',25,2),(343,7465693,7465689,'too',33.333,2),(343,7465694,7465689,'ool',33.333,2),(343,7465695,7465689,'ols',33.333,2),(343,7465696,7465693,'run',20,1),(343,7465697,7465693,'unn',20,1),(343,7465698,7465693,'nni',20,1),(343,7465699,7465693,'nin',20,1),(343,7465700,7465693,'ing',20,1),(343,7465701,7465696,'and',100,1),(343,7465702,7465701,'the',100,1),(343,7465703,7465702,'ver',20,2),(343,7465704,7465702,'ers',20,2),(343,7465705,7465702,'rsi',20,2),(343,7465706,7465702,'sio',20,2),(343,7465707,7465702,'ion',20,2),(343,7465708,7465703,'cur',20,1),(343,7465709,7465703,'urr',20,1),(343,7465710,7465703,'rre',20,1),(343,7465711,7465703,'ren',20,1),(343,7465712,7465703,'ent',20,1),(343,7465713,7465708,'mic',14.286,1),(343,7465714,7465708,'icr',14.286,1),(343,7465715,7465708,'cro',14.286,1),(343,7465716,7465708,'ros',14.286,1),(343,7465717,7465708,'oso',14.286,1),(343,7465718,7465708,'sof',14.286,1),(343,7465719,7465708,'oft',14.286,1),(343,7465720,7465713,'win',20,1),(343,7465721,7465713,'ind',20,1),(343,7465722,7465713,'ndo',20,1),(343,7465723,7465713,'dow',20,1),(343,7465724,7465713,'ows',20,1),(343,7465725,7465720,'ser',25,1),(343,7465726,7465720,'erv',25,1),(343,7465727,7465720,'rve',25,1),(343,7465728,7465720,'ver',25,1),(343,7465729,7465725,'200',50,1),(343,7465730,7465725,'008',50,1),(343,7465731,7465729,'64b',33.333,1),(343,7465732,7465729,'4bi',33.333,1),(343,7465733,7465729,'bit',33.333,1),(343,7465734,7465731,'pat',50,1),(343,7465735,7465731,'ath',50,1),(343,7465736,7465734,'rx6',33.333,1),(343,7465737,7465734,'x60',33.333,1),(343,7465738,7465734,'600',33.333,1),(343,7465739,7465736,'vmf',20,1),(343,7465740,7465736,'mfi',20,1),(343,7465741,7465736,'fil',20,1),(343,7465742,7465736,'ile',20,1),(343,7465743,7465736,'les',20,1),(343,7465744,7465739,'hgw',9.091,2),(343,7465745,7465739,'gw2',9.091,2),(343,7465746,7465739,'w2k',9.091,2),(343,7465747,7465739,'2k8',9.091,2),(343,7465748,7465739,'k8r',9.091,2),(343,7465749,7465739,'8r2',9.091,2),(343,7465750,7465739,'r23',9.091,2),(343,7465751,7465739,'232',9.091,2),(343,7465752,7465739,'32v',9.091,2),(343,7465753,7465739,'2vm',9.091,2),(343,7465754,7465739,'vm4',9.091,2),(343,7465755,7465744,'vmx',100,1),(343,7465756,7465755,'fla',33.333,1),(343,7465757,7465755,'las',33.333,1),(343,7465758,7465755,'ash',33.333,1),(343,7465759,7465756,'acc',33.333,1),(343,7465760,7465756,'cce',33.333,1),(343,7465761,7465756,'cel',33.333,1),(343,7465762,7465759,'con',9.091,1),(343,7465763,7465759,'onf',9.091,1),(343,7465764,7465759,'nfi',9.091,1),(343,7465765,7465759,'fig',9.091,1),(343,7465766,7465759,'igu',9.091,1),(343,7465767,7465759,'gur',9.091,1),(343,7465768,7465759,'ura',9.091,1),(343,7465769,7465759,'rat',9.091,1),(343,7465770,7465759,'ati',9.091,1),(343,7465771,7465759,'tio',9.091,1),(343,7465772,7465759,'ion',9.091,1),(343,7465773,7465762,'age',33.333,1),(343,7465774,7465762,'gen',33.333,1),(343,7465775,7465762,'ent',33.333,1),(343,7465776,7465773,'193',16.667,1),(343,7465777,7465773,'938',16.667,1),(343,7465778,7465773,'380',16.667,1),(343,7465779,7465773,'809',16.667,1),(343,7465780,7465773,'097',16.667,1),(343,7465781,7465773,'979',16.667,1),(343,7465782,7465776,'cac',33.333,3),(343,7465783,7465776,'ach',33.333,3),(343,7465784,7465776,'che',33.333,3),(343,7465785,7465782,'sta',33.333,2),(343,7465786,7465782,'tat',33.333,2),(343,7465787,7465782,'ate',33.333,2),(343,7465788,7465785,'ena',20,2),(343,7465789,7465785,'nab',20,2),(343,7465790,7465785,'abl',20,2),(343,7465791,7465785,'ble',20,2),(343,7465792,7465785,'led',20,2),(343,7465793,7465788,'ope',11.111,2),(343,7465794,7465788,'per',11.111,2),(343,7465795,7465788,'era',11.111,2),(343,7465796,7465788,'rat',11.111,2),(343,7465797,7465788,'ati',11.111,2),(343,7465798,7465788,'tio',11.111,2),(343,7465799,7465788,'ion',11.111,2),(343,7465800,7465788,'ona',11.111,2),(343,7465801,7465788,'nal',11.111,2),(343,7465802,7465793,'nor',25,1),(343,7465803,7465793,'orm',25,1),(343,7465804,7465793,'rma',25,1),(343,7465805,7465793,'mal',25,1),(343,7465806,7465802,'mod',50,2),(343,7465807,7465802,'ode',50,2),(343,7465808,7465806,'wri',14.286,2),(343,7465809,7465806,'rit',14.286,2),(343,7465810,7465806,'ite',14.286,2),(343,7465811,7465806,'tet',14.286,2),(343,7465812,7465806,'eth',14.286,2),(343,7465813,7465806,'thr',14.286,2),(343,7465814,7465806,'hru',14.286,2),(343,7465815,7465808,'mes',20,1),(343,7465816,7465808,'ess',20,1),(343,7465817,7465808,'ssa',20,1),(343,7465818,7465808,'sag',20,1),(343,7465819,7465808,'age',20,1),(343,7465820,7465815,'met',20,3),(343,7465821,7465815,'etr',20,3),(343,7465822,7465815,'tri',20,3),(343,7465823,7465815,'ric',20,3),(343,7465824,7465815,'ics',20,3),(343,7465825,7465820,'vir',20,1),(343,7465826,7465820,'irt',20,1),(343,7465827,7465820,'rtu',20,1),(343,7465828,7465820,'tua',20,1),(343,7465829,7465820,'ual',20,1),(343,7465830,7465825,'dis',50,1),(343,7465831,7465825,'isk',50,1),(344,7465833,7465832,'naa',100,2),(344,7465834,7465833,'600',3.333,3),(344,7465835,7465833,'000',3.333,3),(344,7465836,7465833,'00c',3.333,3),(344,7465837,7465833,'0c2',3.333,3),(344,7465838,7465833,'c29',3.333,3),(344,7465839,7465833,'29f',3.333,3),(344,7465840,7465833,'9f6',3.333,3),(344,7465841,7465833,'f6f',3.333,3),(344,7465842,7465833,'6fd',3.333,3),(344,7465843,7465833,'fd3',3.333,3),(344,7465844,7465833,'d3e',3.333,3),(344,7465845,7465833,'3eb',3.333,3),(344,7465846,7465833,'eb9',3.333,3),(344,7465847,7465833,'b98',3.333,3),(344,7465848,7465833,'986',3.333,3),(344,7465849,7465833,'866',3.333,3),(344,7465850,7465833,'66c',3.333,3),(344,7465851,7465833,'6c0',3.333,3),(344,7465852,7465833,'c05',3.333,3),(344,7465853,7465833,'057',3.333,3),(344,7465854,7465833,'578',3.333,3),(344,7465855,7465833,'783',3.333,3),(344,7465856,7465833,'835',3.333,3),(344,7465857,7465833,'35e',3.333,3),(344,7465858,7465833,'5e2',3.333,3),(344,7465859,7465833,'e2b',3.333,3),(344,7465860,7465833,'2bc',3.333,3),(344,7465861,7465833,'bc5',3.333,3),(344,7465862,7465833,'c58',3.333,3),(344,7465863,7465833,'58a',3.333,3),(344,7465864,7465834,'mon',100,1),(344,7465865,7465864,'201',50,1),(344,7465866,7465864,'013',50,1),(344,7465867,7465865,'adm',33.333,3),(344,7465868,7465865,'dmi',33.333,3),(344,7465869,7465865,'min',33.333,3),(344,7465870,7465867,'cap',16.667,1),(344,7465871,7465867,'apa',16.667,1),(344,7465872,7465867,'pac',16.667,1),(344,7465873,7465867,'aci',16.667,1),(344,7465874,7465867,'cit',16.667,1),(344,7465875,7465867,'ity',16.667,1),(344,7465876,7465870,'pat',50,1),(344,7465877,7465870,'ath',50,1),(344,7465878,7465876,'vol',25,1),(344,7465879,7465876,'olu',25,1),(344,7465880,7465876,'lum',25,1),(344,7465881,7465876,'ume',25,1),(344,7465882,7465878,'78e',3.333,1),(344,7465883,7465878,'8e3',3.333,1),(344,7465884,7465878,'e3f',3.333,1),(344,7465885,7465878,'3f1',3.333,1),(344,7465886,7465878,'f18',3.333,1),(344,7465887,7465878,'188',3.333,1),(344,7465888,7465878,'886',3.333,1),(344,7465889,7465878,'86d',3.333,1),(344,7465890,7465878,'6d8',3.333,1),(344,7465891,7465878,'d87',3.333,1),(344,7465892,7465878,'871',3.333,1),(344,7465893,7465878,'711',3.333,1),(344,7465894,7465878,'11e',3.333,1),(344,7465895,7465878,'1e1',3.333,1),(344,7465896,7465878,'e19',3.333,1),(344,7465897,7465878,'192',3.333,1),(344,7465898,7465878,'927',3.333,1),(344,7465899,7465878,'277',3.333,1),(344,7465900,7465878,'778',3.333,1),(344,7465901,7465878,'780',3.333,1),(344,7465902,7465878,'806',3.333,1),(344,7465903,7465878,'06e',3.333,1),(344,7465904,7465878,'6e6',3.333,1),(344,7465905,7465878,'e6f',3.333,1),(344,7465906,7465878,'6f6',3.333,1),(344,7465907,7465878,'f6e',3.333,1),(344,7465908,7465878,'6e6',3.333,1),(344,7465909,7465878,'e69',3.333,1),(344,7465910,7465878,'696',3.333,1),(344,7465911,7465878,'963',3.333,1),(344,7465912,7465882,'fre',14.286,1),(344,7465913,7465882,'ree',14.286,1),(344,7465914,7465882,'ees',14.286,1),(344,7465915,7465882,'esp',14.286,1),(344,7465916,7465882,'spa',14.286,1),(344,7465917,7465882,'pac',14.286,1),(344,7465918,7465882,'ace',14.286,1),(344,7465919,7465912,'dis',50,1),(344,7465920,7465912,'isk',50,1),(344,7465921,7465919,'ind',33.333,1),(344,7465922,7465919,'nde',33.333,1),(344,7465923,7465919,'dex',33.333,1),(344,7465924,7465921,'adm',8.333,1),(344,7465925,7465921,'dmi',8.333,1),(344,7465926,7465921,'min',8.333,1),(344,7465927,7465921,'ini',8.333,1),(344,7465928,7465921,'nis',8.333,1),(344,7465929,7465921,'ist',8.333,1),(344,7465930,7465921,'str',8.333,1),(344,7465931,7465921,'tra',8.333,1),(344,7465932,7465921,'rat',8.333,1),(344,7465933,7465921,'ati',8.333,1),(344,7465934,7465921,'tio',8.333,1),(344,7465935,7465921,'ion',8.333,1),(344,7465936,7465924,'sta',33.333,3),(344,7465937,7465924,'tat',33.333,3),(344,7465938,7465924,'ate',33.333,3),(344,7465939,7465936,'ena',20,2),(344,7465940,7465936,'nab',20,2),(344,7465941,7465936,'abl',20,2),(344,7465942,7465936,'ble',20,2),(344,7465943,7465936,'led',20,2),(344,7465944,7465939,'cac',33.333,1),(344,7465945,7465939,'ach',33.333,1),(344,7465946,7465939,'che',33.333,1),(344,7465947,7465944,'mod',50,2),(344,7465948,7465944,'ode',50,2),(344,7465949,7465947,'wri',14.286,2),(344,7465950,7465947,'rit',14.286,2),(344,7465951,7465947,'ite',14.286,2),(344,7465952,7465947,'tet',14.286,2),(344,7465953,7465947,'eth',14.286,2),(344,7465954,7465947,'thr',14.286,2),(344,7465955,7465947,'hru',14.286,2),(344,7465956,7465949,'ope',11.111,2),(344,7465957,7465949,'per',11.111,2),(344,7465958,7465949,'era',11.111,2),(344,7465959,7465949,'rat',11.111,2),(344,7465960,7465949,'ati',11.111,2),(344,7465961,7465949,'tio',11.111,2),(344,7465962,7465949,'ion',11.111,2),(344,7465963,7465949,'ona',11.111,2),(344,7465964,7465949,'nal',11.111,2),(344,7465965,7465956,'nor',25,1),(344,7465966,7465956,'orm',25,1),(344,7465967,7465956,'rma',25,1),(344,7465968,7465956,'mal',25,1),(344,7465969,7465965,'mes',20,1),(344,7465970,7465965,'ess',20,1),(344,7465971,7465965,'ssa',20,1),(344,7465972,7465965,'sag',20,1),(344,7465973,7465965,'age',20,1),(344,7465974,7465969,'per',11.111,1),(344,7465975,7465969,'erf',11.111,1),(344,7465976,7465969,'rfo',11.111,1),(344,7465977,7465969,'for',11.111,1),(344,7465978,7465969,'orm',11.111,1),(344,7465979,7465969,'rma',11.111,1),(344,7465980,7465969,'man',11.111,1),(344,7465981,7465969,'anc',11.111,1),(344,7465982,7465969,'nce',11.111,1),(344,7465983,7465974,'ide',12.5,1),(344,7465984,7465974,'den',12.5,1),(344,7465985,7465974,'ent',12.5,1),(344,7465986,7465974,'nti',12.5,1),(344,7465987,7465974,'tif',12.5,1),(344,7465988,7465974,'ifi',12.5,1),(344,7465989,7465974,'fie',12.5,1),(344,7465990,7465974,'ier',12.5,1),(344,7465991,7465983,'vdi',33.333,3),(344,7465992,7465983,'dis',33.333,3),(344,7465993,7465983,'isk',33.333,3),(344,7465994,7465991,'nam',50,1),(344,7465995,7465991,'ame',50,1),(344,7465996,7465994,'typ',50,1),(344,7465997,7465994,'ype',50,1),(344,7465998,7465996,'dir',25,1),(344,7465999,7465996,'ire',25,1),(344,7466000,7465996,'rec',25,1),(344,7466001,7465996,'ect',25,1),(345,7466003,7466002,'naa',100,2),(345,7466004,7466003,'600',3.333,3),(345,7466005,7466003,'00a',3.333,3),(345,7466006,7466003,'0a0',3.333,3),(345,7466007,7466003,'a09',3.333,3),(345,7466008,7466003,'098',3.333,3),(345,7466009,7466003,'980',3.333,3),(345,7466010,7466003,'804',3.333,3),(345,7466011,7466003,'044',3.333,3),(345,7466012,7466003,'443',3.333,3),(345,7466013,7466003,'430',3.333,3),(345,7466014,7466003,'307',3.333,3),(345,7466015,7466003,'072',3.333,3),(345,7466016,7466003,'725',3.333,3),(345,7466017,7466003,'259',3.333,3),(345,7466018,7466003,'593',3.333,3),(345,7466019,7466003,'931',3.333,3),(345,7466020,7466003,'313',3.333,3),(345,7466021,7466003,'13f',3.333,3),(345,7466022,7466003,'3f3',3.333,3),(345,7466023,7466003,'f33',3.333,3),(345,7466024,7466003,'334',3.333,3),(345,7466025,7466003,'345',3.333,3),(345,7466026,7466003,'455',3.333,3),(345,7466027,7466003,'556',3.333,3),(345,7466028,7466003,'563',3.333,3),(345,7466029,7466003,'639',3.333,3),(345,7466030,7466003,'393',3.333,3),(345,7466031,7466003,'934',3.333,3),(345,7466032,7466003,'344',3.333,3),(345,7466033,7466003,'441',3.333,3),(345,7466034,7466004,'mon',100,1),(345,7466035,7466034,'201',50,1),(345,7466036,7466034,'013',50,1),(345,7466037,7466035,'adm',33.333,3),(345,7466038,7466035,'dmi',33.333,3),(345,7466039,7466035,'min',33.333,3),(345,7466040,7466037,'cap',16.667,1),(345,7466041,7466037,'apa',16.667,1),(345,7466042,7466037,'pac',16.667,1),(345,7466043,7466037,'aci',16.667,1),(345,7466044,7466037,'cit',16.667,1),(345,7466045,7466037,'ity',16.667,1),(345,7466046,7466040,'pat',50,1),(345,7466047,7466040,'ath',50,1),(345,7466048,7466046,'fre',14.286,1),(345,7466049,7466046,'ree',14.286,1),(345,7466050,7466046,'ees',14.286,1),(345,7466051,7466046,'esp',14.286,1),(345,7466052,7466046,'spa',14.286,1),(345,7466053,7466046,'pac',14.286,1),(345,7466054,7466046,'ace',14.286,1),(345,7466055,7466048,'dis',50,1),(345,7466056,7466048,'isk',50,1),(345,7466057,7466055,'ind',33.333,1),(345,7466058,7466055,'nde',33.333,1),(345,7466059,7466055,'dex',33.333,1),(345,7466060,7466057,'adm',8.333,1),(345,7466061,7466057,'dmi',8.333,1),(345,7466062,7466057,'min',8.333,1),(345,7466063,7466057,'ini',8.333,1),(345,7466064,7466057,'nis',8.333,1),(345,7466065,7466057,'ist',8.333,1),(345,7466066,7466057,'str',8.333,1),(345,7466067,7466057,'tra',8.333,1),(345,7466068,7466057,'rat',8.333,1),(345,7466069,7466057,'ati',8.333,1),(345,7466070,7466057,'tio',8.333,1),(345,7466071,7466057,'ion',8.333,1),(345,7466072,7466060,'sta',33.333,3),(345,7466073,7466060,'tat',33.333,3),(345,7466074,7466060,'ate',33.333,3),(345,7466075,7466072,'ena',20,2),(345,7466076,7466072,'nab',20,2),(345,7466077,7466072,'abl',20,2),(345,7466078,7466072,'ble',20,2),(345,7466079,7466072,'led',20,2),(345,7466080,7466075,'cac',33.333,1),(345,7466081,7466075,'ach',33.333,1),(345,7466082,7466075,'che',33.333,1),(345,7466083,7466080,'mod',50,2),(345,7466084,7466080,'ode',50,2),(345,7466085,7466083,'wri',14.286,2),(345,7466086,7466083,'rit',14.286,2),(345,7466087,7466083,'ite',14.286,2),(345,7466088,7466083,'tet',14.286,2),(345,7466089,7466083,'eth',14.286,2),(345,7466090,7466083,'thr',14.286,2),(345,7466091,7466083,'hru',14.286,2),(345,7466092,7466085,'ope',11.111,2),(345,7466093,7466085,'per',11.111,2),(345,7466094,7466085,'era',11.111,2),(345,7466095,7466085,'rat',11.111,2),(345,7466096,7466085,'ati',11.111,2),(345,7466097,7466085,'tio',11.111,2),(345,7466098,7466085,'ion',11.111,2),(345,7466099,7466085,'ona',11.111,2),(345,7466100,7466085,'nal',11.111,2),(345,7466101,7466092,'nor',25,1),(345,7466102,7466092,'orm',25,1),(345,7466103,7466092,'rma',25,1),(345,7466104,7466092,'mal',25,1),(345,7466105,7466101,'mes',20,1),(345,7466106,7466101,'ess',20,1),(345,7466107,7466101,'ssa',20,1),(345,7466108,7466101,'sag',20,1),(345,7466109,7466101,'age',20,1),(345,7466110,7466105,'per',11.111,1),(345,7466111,7466105,'erf',11.111,1),(345,7466112,7466105,'rfo',11.111,1),(345,7466113,7466105,'for',11.111,1),(345,7466114,7466105,'orm',11.111,1),(345,7466115,7466105,'rma',11.111,1),(345,7466116,7466105,'man',11.111,1),(345,7466117,7466105,'anc',11.111,1),(345,7466118,7466105,'nce',11.111,1),(345,7466119,7466110,'ide',12.5,1),(345,7466120,7466110,'den',12.5,1),(345,7466121,7466110,'ent',12.5,1),(345,7466122,7466110,'nti',12.5,1),(345,7466123,7466110,'tif',12.5,1),(345,7466124,7466110,'ifi',12.5,1),(345,7466125,7466110,'fie',12.5,1),(345,7466126,7466110,'ier',12.5,1),(345,7466127,7466119,'vdi',33.333,3),(345,7466128,7466119,'dis',33.333,3),(345,7466129,7466119,'isk',33.333,3),(345,7466130,7466127,'nam',50,1),(345,7466131,7466127,'ame',50,1),(345,7466132,7466130,'typ',50,1),(345,7466133,7466130,'ype',50,1),(345,7466134,7466132,'dir',25,1),(345,7466135,7466132,'ire',25,1),(345,7466136,7466132,'rec',25,1),(345,7466137,7466132,'ect',25,1),(346,7466139,7466138,'naa',100,2),(346,7466140,7466139,'600',3.333,3),(346,7466141,7466139,'00a',3.333,3),(346,7466142,7466139,'0a0',3.333,3),(346,7466143,7466139,'a09',3.333,3),(346,7466144,7466139,'098',3.333,3),(346,7466145,7466139,'980',3.333,3),(346,7466146,7466139,'804',3.333,3),(346,7466147,7466139,'044',3.333,3),(346,7466148,7466139,'443',3.333,3),(346,7466149,7466139,'430',3.333,3),(346,7466150,7466139,'307',3.333,3),(346,7466151,7466139,'072',3.333,3),(346,7466152,7466139,'725',3.333,3),(346,7466153,7466139,'259',3.333,3),(346,7466154,7466139,'593',3.333,3),(346,7466155,7466139,'931',3.333,3),(346,7466156,7466139,'313',3.333,3),(346,7466157,7466139,'13f',3.333,3),(346,7466158,7466139,'3f3',3.333,3),(346,7466159,7466139,'f33',3.333,3),(346,7466160,7466139,'334',3.333,3),(346,7466161,7466139,'345',3.333,3),(346,7466162,7466139,'455',3.333,3),(346,7466163,7466139,'556',3.333,3),(346,7466164,7466139,'563',3.333,3),(346,7466165,7466139,'639',3.333,3),(346,7466166,7466139,'393',3.333,3),(346,7466167,7466139,'934',3.333,3),(346,7466168,7466139,'344',3.333,3),(346,7466169,7466139,'442',3.333,3),(346,7466170,7466140,'mon',100,1),(346,7466171,7466170,'201',50,1),(346,7466172,7466170,'013',50,1),(346,7466173,7466171,'adm',33.333,3),(346,7466174,7466171,'dmi',33.333,3),(346,7466175,7466171,'min',33.333,3),(346,7466176,7466173,'cap',16.667,1),(346,7466177,7466173,'apa',16.667,1),(346,7466178,7466173,'pac',16.667,1),(346,7466179,7466173,'aci',16.667,1),(346,7466180,7466173,'cit',16.667,1),(346,7466181,7466173,'ity',16.667,1),(346,7466182,7466176,'pat',50,1),(346,7466183,7466176,'ath',50,1),(346,7466184,7466182,'fre',14.286,1),(346,7466185,7466182,'ree',14.286,1),(346,7466186,7466182,'ees',14.286,1),(346,7466187,7466182,'esp',14.286,1),(346,7466188,7466182,'spa',14.286,1),(346,7466189,7466182,'pac',14.286,1),(346,7466190,7466182,'ace',14.286,1),(346,7466191,7466184,'dis',50,1),(346,7466192,7466184,'isk',50,1),(346,7466193,7466191,'ind',33.333,1),(346,7466194,7466191,'nde',33.333,1),(346,7466195,7466191,'dex',33.333,1),(346,7466196,7466193,'adm',8.333,1),(346,7466197,7466193,'dmi',8.333,1),(346,7466198,7466193,'min',8.333,1),(346,7466199,7466193,'ini',8.333,1),(346,7466200,7466193,'nis',8.333,1),(346,7466201,7466193,'ist',8.333,1),(346,7466202,7466193,'str',8.333,1),(346,7466203,7466193,'tra',8.333,1),(346,7466204,7466193,'rat',8.333,1),(346,7466205,7466193,'ati',8.333,1),(346,7466206,7466193,'tio',8.333,1),(346,7466207,7466193,'ion',8.333,1),(346,7466208,7466196,'sta',33.333,3),(346,7466209,7466196,'tat',33.333,3),(346,7466210,7466196,'ate',33.333,3),(346,7466211,7466208,'ena',20,2),(346,7466212,7466208,'nab',20,2),(346,7466213,7466208,'abl',20,2),(346,7466214,7466208,'ble',20,2),(346,7466215,7466208,'led',20,2),(346,7466216,7466211,'cac',33.333,1),(346,7466217,7466211,'ach',33.333,1),(346,7466218,7466211,'che',33.333,1),(346,7466219,7466216,'mod',50,2),(346,7466220,7466216,'ode',50,2),(346,7466221,7466219,'wri',14.286,2),(346,7466222,7466219,'rit',14.286,2),(346,7466223,7466219,'ite',14.286,2),(346,7466224,7466219,'tet',14.286,2),(346,7466225,7466219,'eth',14.286,2),(346,7466226,7466219,'thr',14.286,2),(346,7466227,7466219,'hru',14.286,2),(346,7466228,7466221,'ope',11.111,2),(346,7466229,7466221,'per',11.111,2),(346,7466230,7466221,'era',11.111,2),(346,7466231,7466221,'rat',11.111,2),(346,7466232,7466221,'ati',11.111,2),(346,7466233,7466221,'tio',11.111,2),(346,7466234,7466221,'ion',11.111,2),(346,7466235,7466221,'ona',11.111,2),(346,7466236,7466221,'nal',11.111,2),(346,7466237,7466228,'nor',25,1),(346,7466238,7466228,'orm',25,1),(346,7466239,7466228,'rma',25,1),(346,7466240,7466228,'mal',25,1),(346,7466241,7466237,'mes',20,1),(346,7466242,7466237,'ess',20,1),(346,7466243,7466237,'ssa',20,1),(346,7466244,7466237,'sag',20,1),(346,7466245,7466237,'age',20,1),(346,7466246,7466241,'per',11.111,1),(346,7466247,7466241,'erf',11.111,1),(346,7466248,7466241,'rfo',11.111,1),(346,7466249,7466241,'for',11.111,1),(346,7466250,7466241,'orm',11.111,1),(346,7466251,7466241,'rma',11.111,1),(346,7466252,7466241,'man',11.111,1),(346,7466253,7466241,'anc',11.111,1),(346,7466254,7466241,'nce',11.111,1),(346,7466255,7466246,'ide',12.5,1),(346,7466256,7466246,'den',12.5,1),(346,7466257,7466246,'ent',12.5,1),(346,7466258,7466246,'nti',12.5,1),(346,7466259,7466246,'tif',12.5,1),(346,7466260,7466246,'ifi',12.5,1),(346,7466261,7466246,'fie',12.5,1),(346,7466262,7466246,'ier',12.5,1),(346,7466263,7466255,'vdi',33.333,3),(346,7466264,7466255,'dis',33.333,3),(346,7466265,7466255,'isk',33.333,3),(346,7466266,7466263,'nam',50,1),(346,7466267,7466263,'ame',50,1),(346,7466268,7466266,'typ',50,1),(346,7466269,7466266,'ype',50,1),(346,7466270,7466268,'dir',25,1),(346,7466271,7466268,'ire',25,1),(346,7466272,7466268,'rec',25,1),(346,7466273,7466268,'ect',25,1),(347,7466275,7466274,'naa',100,2),(347,7466276,7466275,'600',3.333,3),(347,7466277,7466275,'00a',3.333,3),(347,7466278,7466275,'0a0',3.333,3),(347,7466279,7466275,'a09',3.333,3),(347,7466280,7466275,'098',3.333,3),(347,7466281,7466275,'980',3.333,3),(347,7466282,7466275,'804',3.333,3),(347,7466283,7466275,'044',3.333,3),(347,7466284,7466275,'443',3.333,3),(347,7466285,7466275,'430',3.333,3),(347,7466286,7466275,'307',3.333,3),(347,7466287,7466275,'075',3.333,3),(347,7466288,7466275,'753',3.333,3),(347,7466289,7466275,'535',3.333,3),(347,7466290,7466275,'357',3.333,3),(347,7466291,7466275,'573',3.333,3),(347,7466292,7466275,'732',3.333,3),(347,7466293,7466275,'32b',3.333,3),(347,7466294,7466275,'2b3',3.333,3),(347,7466295,7466275,'b33',3.333,3),(347,7466296,7466275,'334',3.333,3),(347,7466297,7466275,'345',3.333,3),(347,7466298,7466275,'457',3.333,3),(347,7466299,7466275,'571',3.333,3),(347,7466300,7466275,'715',3.333,3),(347,7466301,7466275,'153',3.333,3),(347,7466302,7466275,'533',3.333,3),(347,7466303,7466275,'335',3.333,3),(347,7466304,7466275,'357',3.333,3),(347,7466305,7466275,'577',3.333,3),(347,7466306,7466276,'mon',100,1),(347,7466307,7466306,'201',50,1),(347,7466308,7466306,'013',50,1),(347,7466309,7466307,'adm',33.333,3),(347,7466310,7466307,'dmi',33.333,3),(347,7466311,7466307,'min',33.333,3),(347,7466312,7466309,'cap',16.667,1),(347,7466313,7466309,'apa',16.667,1),(347,7466314,7466309,'pac',16.667,1),(347,7466315,7466309,'aci',16.667,1),(347,7466316,7466309,'cit',16.667,1),(347,7466317,7466309,'ity',16.667,1),(347,7466318,7466312,'pat',50,1),(347,7466319,7466312,'ath',50,1),(347,7466320,7466318,'fre',14.286,1),(347,7466321,7466318,'ree',14.286,1),(347,7466322,7466318,'ees',14.286,1),(347,7466323,7466318,'esp',14.286,1),(347,7466324,7466318,'spa',14.286,1),(347,7466325,7466318,'pac',14.286,1),(347,7466326,7466318,'ace',14.286,1),(347,7466327,7466320,'dis',50,1),(347,7466328,7466320,'isk',50,1),(347,7466329,7466327,'ind',33.333,1),(347,7466330,7466327,'nde',33.333,1),(347,7466331,7466327,'dex',33.333,1),(347,7466332,7466329,'adm',8.333,1),(347,7466333,7466329,'dmi',8.333,1),(347,7466334,7466329,'min',8.333,1),(347,7466335,7466329,'ini',8.333,1),(347,7466336,7466329,'nis',8.333,1),(347,7466337,7466329,'ist',8.333,1),(347,7466338,7466329,'str',8.333,1),(347,7466339,7466329,'tra',8.333,1),(347,7466340,7466329,'rat',8.333,1),(347,7466341,7466329,'ati',8.333,1),(347,7466342,7466329,'tio',8.333,1),(347,7466343,7466329,'ion',8.333,1),(347,7466344,7466332,'sta',33.333,3),(347,7466345,7466332,'tat',33.333,3),(347,7466346,7466332,'ate',33.333,3),(347,7466347,7466344,'ena',20,2),(347,7466348,7466344,'nab',20,2),(347,7466349,7466344,'abl',20,2),(347,7466350,7466344,'ble',20,2),(347,7466351,7466344,'led',20,2),(347,7466352,7466347,'cac',33.333,1),(347,7466353,7466347,'ach',33.333,1),(347,7466354,7466347,'che',33.333,1),(347,7466355,7466352,'mod',50,2),(347,7466356,7466352,'ode',50,2),(347,7466357,7466355,'wri',14.286,2),(347,7466358,7466355,'rit',14.286,2),(347,7466359,7466355,'ite',14.286,2),(347,7466360,7466355,'tet',14.286,2),(347,7466361,7466355,'eth',14.286,2),(347,7466362,7466355,'thr',14.286,2),(347,7466363,7466355,'hru',14.286,2),(347,7466364,7466357,'ope',11.111,2),(347,7466365,7466357,'per',11.111,2),(347,7466366,7466357,'era',11.111,2),(347,7466367,7466357,'rat',11.111,2),(347,7466368,7466357,'ati',11.111,2),(347,7466369,7466357,'tio',11.111,2),(347,7466370,7466357,'ion',11.111,2),(347,7466371,7466357,'ona',11.111,2),(347,7466372,7466357,'nal',11.111,2),(347,7466373,7466364,'nor',25,1),(347,7466374,7466364,'orm',25,1),(347,7466375,7466364,'rma',25,1),(347,7466376,7466364,'mal',25,1),(347,7466377,7466373,'mes',20,1),(347,7466378,7466373,'ess',20,1),(347,7466379,7466373,'ssa',20,1),(347,7466380,7466373,'sag',20,1),(347,7466381,7466373,'age',20,1),(347,7466382,7466377,'per',11.111,1),(347,7466383,7466377,'erf',11.111,1),(347,7466384,7466377,'rfo',11.111,1),(347,7466385,7466377,'for',11.111,1),(347,7466386,7466377,'orm',11.111,1),(347,7466387,7466377,'rma',11.111,1),(347,7466388,7466377,'man',11.111,1),(347,7466389,7466377,'anc',11.111,1),(347,7466390,7466377,'nce',11.111,1),(347,7466391,7466382,'ide',12.5,1),(347,7466392,7466382,'den',12.5,1),(347,7466393,7466382,'ent',12.5,1),(347,7466394,7466382,'nti',12.5,1),(347,7466395,7466382,'tif',12.5,1),(347,7466396,7466382,'ifi',12.5,1),(347,7466397,7466382,'fie',12.5,1),(347,7466398,7466382,'ier',12.5,1),(347,7466399,7466391,'vdi',33.333,3),(347,7466400,7466391,'dis',33.333,3),(347,7466401,7466391,'isk',33.333,3),(347,7466402,7466399,'nam',50,1),(347,7466403,7466399,'ame',50,1),(347,7466404,7466402,'typ',50,1),(347,7466405,7466402,'ype',50,1),(347,7466406,7466404,'dir',25,1),(347,7466407,7466404,'ire',25,1),(347,7466408,7466404,'rec',25,1),(347,7466409,7466404,'ect',25,1),(348,7466411,7466410,'naa',100,2),(348,7466412,7466411,'600',3.333,3),(348,7466413,7466411,'00a',3.333,3),(348,7466414,7466411,'0a0',3.333,3),(348,7466415,7466411,'a09',3.333,3),(348,7466416,7466411,'098',3.333,3),(348,7466417,7466411,'980',3.333,3),(348,7466418,7466411,'804',3.333,3),(348,7466419,7466411,'044',3.333,3),(348,7466420,7466411,'443',3.333,3),(348,7466421,7466411,'430',3.333,3),(348,7466422,7466411,'307',3.333,3),(348,7466423,7466411,'075',3.333,3),(348,7466424,7466411,'753',3.333,3),(348,7466425,7466411,'535',3.333,3),(348,7466426,7466411,'357',3.333,3),(348,7466427,7466411,'573',3.333,3),(348,7466428,7466411,'732',3.333,3),(348,7466429,7466411,'32b',3.333,3),(348,7466430,7466411,'2b3',3.333,3),(348,7466431,7466411,'b33',3.333,3),(348,7466432,7466411,'334',3.333,3),(348,7466433,7466411,'345',3.333,3),(348,7466434,7466411,'457',3.333,3),(348,7466435,7466411,'571',3.333,3),(348,7466436,7466411,'715',3.333,3),(348,7466437,7466411,'153',3.333,3),(348,7466438,7466411,'533',3.333,3),(348,7466439,7466411,'335',3.333,3),(348,7466440,7466411,'357',3.333,3),(348,7466441,7466411,'578',3.333,3),(348,7466442,7466412,'mon',100,1),(348,7466443,7466442,'201',50,1),(348,7466444,7466442,'013',50,1),(348,7466445,7466443,'adm',33.333,3),(348,7466446,7466443,'dmi',33.333,3),(348,7466447,7466443,'min',33.333,3),(348,7466448,7466445,'cap',16.667,1),(348,7466449,7466445,'apa',16.667,1),(348,7466450,7466445,'pac',16.667,1),(348,7466451,7466445,'aci',16.667,1),(348,7466452,7466445,'cit',16.667,1),(348,7466453,7466445,'ity',16.667,1),(348,7466454,7466448,'pat',50,1),(348,7466455,7466448,'ath',50,1),(348,7466456,7466454,'fre',14.286,1),(348,7466457,7466454,'ree',14.286,1),(348,7466458,7466454,'ees',14.286,1),(348,7466459,7466454,'esp',14.286,1),(348,7466460,7466454,'spa',14.286,1),(348,7466461,7466454,'pac',14.286,1),(348,7466462,7466454,'ace',14.286,1),(348,7466463,7466456,'dis',50,1),(348,7466464,7466456,'isk',50,1),(348,7466465,7466463,'ind',33.333,1),(348,7466466,7466463,'nde',33.333,1),(348,7466467,7466463,'dex',33.333,1),(348,7466468,7466465,'adm',8.333,1),(348,7466469,7466465,'dmi',8.333,1),(348,7466470,7466465,'min',8.333,1),(348,7466471,7466465,'ini',8.333,1),(348,7466472,7466465,'nis',8.333,1),(348,7466473,7466465,'ist',8.333,1),(348,7466474,7466465,'str',8.333,1),(348,7466475,7466465,'tra',8.333,1),(348,7466476,7466465,'rat',8.333,1),(348,7466477,7466465,'ati',8.333,1),(348,7466478,7466465,'tio',8.333,1),(348,7466479,7466465,'ion',8.333,1),(348,7466480,7466468,'sta',33.333,3),(348,7466481,7466468,'tat',33.333,3),(348,7466482,7466468,'ate',33.333,3),(348,7466483,7466480,'ena',20,2),(348,7466484,7466480,'nab',20,2),(348,7466485,7466480,'abl',20,2),(348,7466486,7466480,'ble',20,2),(348,7466487,7466480,'led',20,2),(348,7466488,7466483,'cac',33.333,1),(348,7466489,7466483,'ach',33.333,1),(348,7466490,7466483,'che',33.333,1),(348,7466491,7466488,'mod',50,2),(348,7466492,7466488,'ode',50,2),(348,7466493,7466491,'wri',14.286,2),(348,7466494,7466491,'rit',14.286,2),(348,7466495,7466491,'ite',14.286,2),(348,7466496,7466491,'tet',14.286,2),(348,7466497,7466491,'eth',14.286,2),(348,7466498,7466491,'thr',14.286,2),(348,7466499,7466491,'hru',14.286,2),(348,7466500,7466493,'ope',11.111,2),(348,7466501,7466493,'per',11.111,2),(348,7466502,7466493,'era',11.111,2),(348,7466503,7466493,'rat',11.111,2),(348,7466504,7466493,'ati',11.111,2),(348,7466505,7466493,'tio',11.111,2),(348,7466506,7466493,'ion',11.111,2),(348,7466507,7466493,'ona',11.111,2),(348,7466508,7466493,'nal',11.111,2),(348,7466509,7466500,'nor',25,1),(348,7466510,7466500,'orm',25,1),(348,7466511,7466500,'rma',25,1),(348,7466512,7466500,'mal',25,1),(348,7466513,7466509,'mes',20,1),(348,7466514,7466509,'ess',20,1),(348,7466515,7466509,'ssa',20,1),(348,7466516,7466509,'sag',20,1),(348,7466517,7466509,'age',20,1),(348,7466518,7466513,'per',11.111,1),(348,7466519,7466513,'erf',11.111,1),(348,7466520,7466513,'rfo',11.111,1),(348,7466521,7466513,'for',11.111,1),(348,7466522,7466513,'orm',11.111,1),(348,7466523,7466513,'rma',11.111,1),(348,7466524,7466513,'man',11.111,1),(348,7466525,7466513,'anc',11.111,1),(348,7466526,7466513,'nce',11.111,1),(348,7466527,7466518,'ide',12.5,1),(348,7466528,7466518,'den',12.5,1),(348,7466529,7466518,'ent',12.5,1),(348,7466530,7466518,'nti',12.5,1),(348,7466531,7466518,'tif',12.5,1),(348,7466532,7466518,'ifi',12.5,1),(348,7466533,7466518,'fie',12.5,1),(348,7466534,7466518,'ier',12.5,1),(348,7466535,7466527,'vdi',33.333,3),(348,7466536,7466527,'dis',33.333,3),(348,7466537,7466527,'isk',33.333,3),(348,7466538,7466535,'nam',50,1),(348,7466539,7466535,'ame',50,1),(348,7466540,7466538,'typ',50,1),(348,7466541,7466538,'ype',50,1),(348,7466542,7466540,'dir',25,1),(348,7466543,7466540,'ire',25,1),(348,7466544,7466540,'rec',25,1),(348,7466545,7466540,'ect',25,1),(349,7466547,7466546,'naa',100,2),(349,7466548,7466547,'600',3.333,3),(349,7466549,7466547,'000',3.333,3),(349,7466550,7466547,'00c',3.333,3),(349,7466551,7466547,'0c2',3.333,3),(349,7466552,7466547,'c29',3.333,3),(349,7466553,7466547,'292',3.333,3),(349,7466554,7466547,'92e',3.333,3),(349,7466555,7466547,'2e0',3.333,3),(349,7466556,7466547,'e02',3.333,3),(349,7466557,7466547,'02e',3.333,3),(349,7466558,7466547,'2e6',3.333,3),(349,7466559,7466547,'e62',3.333,3),(349,7466560,7466547,'62a',3.333,3),(349,7466561,7466547,'2a7',3.333,3),(349,7466562,7466547,'a7e',3.333,3),(349,7466563,7466547,'7ea',3.333,3),(349,7466564,7466547,'ea5',3.333,3),(349,7466565,7466547,'a5f',3.333,3),(349,7466566,7466547,'5fc',3.333,3),(349,7466567,7466547,'fcc',3.333,3),(349,7466568,7466547,'cc7',3.333,3),(349,7466569,7466547,'c7e',3.333,3),(349,7466570,7466547,'7e2',3.333,3),(349,7466571,7466547,'e2a',3.333,3),(349,7466572,7466547,'2ac',3.333,3),(349,7466573,7466547,'ac6',3.333,3),(349,7466574,7466547,'c6d',3.333,3),(349,7466575,7466547,'6da',3.333,3),(349,7466576,7466547,'dac',3.333,3),(349,7466577,7466547,'ac2',3.333,3),(349,7466578,7466548,'mon',100,1),(349,7466579,7466578,'201',50,1),(349,7466580,7466578,'013',50,1),(349,7466581,7466579,'adm',33.333,3),(349,7466582,7466579,'dmi',33.333,3),(349,7466583,7466579,'min',33.333,3),(349,7466584,7466581,'cap',16.667,1),(349,7466585,7466581,'apa',16.667,1),(349,7466586,7466581,'pac',16.667,1),(349,7466587,7466581,'aci',16.667,1),(349,7466588,7466581,'cit',16.667,1),(349,7466589,7466581,'ity',16.667,1),(349,7466590,7466584,'pat',50,1),(349,7466591,7466584,'ath',50,1),(349,7466592,7466590,'fre',14.286,1),(349,7466593,7466590,'ree',14.286,1),(349,7466594,7466590,'ees',14.286,1),(349,7466595,7466590,'esp',14.286,1),(349,7466596,7466590,'spa',14.286,1),(349,7466597,7466590,'pac',14.286,1),(349,7466598,7466590,'ace',14.286,1),(349,7466599,7466592,'dis',50,1),(349,7466600,7466592,'isk',50,1),(349,7466601,7466599,'ind',33.333,1),(349,7466602,7466599,'nde',33.333,1),(349,7466603,7466599,'dex',33.333,1),(349,7466604,7466601,'adm',8.333,1),(349,7466605,7466601,'dmi',8.333,1),(349,7466606,7466601,'min',8.333,1),(349,7466607,7466601,'ini',8.333,1),(349,7466608,7466601,'nis',8.333,1),(349,7466609,7466601,'ist',8.333,1),(349,7466610,7466601,'str',8.333,1),(349,7466611,7466601,'tra',8.333,1),(349,7466612,7466601,'rat',8.333,1),(349,7466613,7466601,'ati',8.333,1),(349,7466614,7466601,'tio',8.333,1),(349,7466615,7466601,'ion',8.333,1),(349,7466616,7466604,'sta',33.333,3),(349,7466617,7466604,'tat',33.333,3),(349,7466618,7466604,'ate',33.333,3),(349,7466619,7466616,'ena',20,2),(349,7466620,7466616,'nab',20,2),(349,7466621,7466616,'abl',20,2),(349,7466622,7466616,'ble',20,2),(349,7466623,7466616,'led',20,2),(349,7466624,7466619,'cac',33.333,1),(349,7466625,7466619,'ach',33.333,1),(349,7466626,7466619,'che',33.333,1),(349,7466627,7466624,'mod',50,2),(349,7466628,7466624,'ode',50,2),(349,7466629,7466627,'wri',14.286,2),(349,7466630,7466627,'rit',14.286,2),(349,7466631,7466627,'ite',14.286,2),(349,7466632,7466627,'tet',14.286,2),(349,7466633,7466627,'eth',14.286,2),(349,7466634,7466627,'thr',14.286,2),(349,7466635,7466627,'hru',14.286,2),(349,7466636,7466629,'ope',11.111,2),(349,7466637,7466629,'per',11.111,2),(349,7466638,7466629,'era',11.111,2),(349,7466639,7466629,'rat',11.111,2),(349,7466640,7466629,'ati',11.111,2),(349,7466641,7466629,'tio',11.111,2),(349,7466642,7466629,'ion',11.111,2),(349,7466643,7466629,'ona',11.111,2),(349,7466644,7466629,'nal',11.111,2),(349,7466645,7466636,'nor',25,1),(349,7466646,7466636,'orm',25,1),(349,7466647,7466636,'rma',25,1),(349,7466648,7466636,'mal',25,1),(349,7466649,7466645,'mes',20,1),(349,7466650,7466645,'ess',20,1),(349,7466651,7466645,'ssa',20,1),(349,7466652,7466645,'sag',20,1),(349,7466653,7466645,'age',20,1),(349,7466654,7466649,'per',11.111,1),(349,7466655,7466649,'erf',11.111,1),(349,7466656,7466649,'rfo',11.111,1),(349,7466657,7466649,'for',11.111,1),(349,7466658,7466649,'orm',11.111,1),(349,7466659,7466649,'rma',11.111,1),(349,7466660,7466649,'man',11.111,1),(349,7466661,7466649,'anc',11.111,1),(349,7466662,7466649,'nce',11.111,1),(349,7466663,7466654,'ide',12.5,1),(349,7466664,7466654,'den',12.5,1),(349,7466665,7466654,'ent',12.5,1),(349,7466666,7466654,'nti',12.5,1),(349,7466667,7466654,'tif',12.5,1),(349,7466668,7466654,'ifi',12.5,1),(349,7466669,7466654,'fie',12.5,1),(349,7466670,7466654,'ier',12.5,1),(349,7466671,7466663,'vdi',33.333,3),(349,7466672,7466663,'dis',33.333,3),(349,7466673,7466663,'isk',33.333,3),(349,7466674,7466671,'nam',50,1),(349,7466675,7466671,'ame',50,1),(349,7466676,7466674,'typ',50,1),(349,7466677,7466674,'ype',50,1),(349,7466678,7466676,'dir',25,1),(349,7466679,7466676,'ire',25,1),(349,7466680,7466676,'rec',25,1),(349,7466681,7466676,'ect',25,1),(350,7466683,7466682,'naa',100,2),(350,7466684,7466683,'600',3.333,3),(350,7466685,7466683,'000',3.333,3),(350,7466686,7466683,'00c',3.333,3),(350,7466687,7466683,'0c2',3.333,3),(350,7466688,7466683,'c29',3.333,3),(350,7466689,7466683,'293',3.333,3),(350,7466690,7466683,'933',3.333,3),(350,7466691,7466683,'33e',3.333,3),(350,7466692,7466683,'3e3',3.333,3),(350,7466693,7466683,'e34',3.333,3),(350,7466694,7466683,'34e',3.333,3),(350,7466695,7466683,'4e6',3.333,3),(350,7466696,7466683,'e61',3.333,3),(350,7466697,7466683,'611',3.333,3),(350,7466698,7466683,'114',3.333,3),(350,7466699,7466683,'14d',3.333,3),(350,7466700,7466683,'4d0',3.333,3),(350,7466701,7466683,'d05',3.333,3),(350,7466702,7466683,'05c',3.333,3),(350,7466703,7466683,'5cd',3.333,3),(350,7466704,7466683,'cd5',3.333,3),(350,7466705,7466683,'d55',3.333,3),(350,7466706,7466683,'550',3.333,3),(350,7466707,7466683,'50d',3.333,3),(350,7466708,7466683,'0d6',3.333,3),(350,7466709,7466683,'d62',3.333,3),(350,7466710,7466683,'620',3.333,3),(350,7466711,7466683,'203',3.333,3),(350,7466712,7466683,'03a',3.333,3),(350,7466713,7466683,'3a2',3.333,3),(350,7466714,7466684,'mon',100,1),(350,7466715,7466714,'201',50,1),(350,7466716,7466714,'013',50,1),(350,7466717,7466715,'adm',33.333,3),(350,7466718,7466715,'dmi',33.333,3),(350,7466719,7466715,'min',33.333,3),(350,7466720,7466717,'cap',16.667,1),(350,7466721,7466717,'apa',16.667,1),(350,7466722,7466717,'pac',16.667,1),(350,7466723,7466717,'aci',16.667,1),(350,7466724,7466717,'cit',16.667,1),(350,7466725,7466717,'ity',16.667,1),(350,7466726,7466720,'pat',50,1),(350,7466727,7466720,'ath',50,1),(350,7466728,7466726,'fre',14.286,1),(350,7466729,7466726,'ree',14.286,1),(350,7466730,7466726,'ees',14.286,1),(350,7466731,7466726,'esp',14.286,1),(350,7466732,7466726,'spa',14.286,1),(350,7466733,7466726,'pac',14.286,1),(350,7466734,7466726,'ace',14.286,1),(350,7466735,7466728,'dis',50,1),(350,7466736,7466728,'isk',50,1),(350,7466737,7466735,'ind',33.333,1),(350,7466738,7466735,'nde',33.333,1),(350,7466739,7466735,'dex',33.333,1),(350,7466740,7466737,'adm',8.333,1),(350,7466741,7466737,'dmi',8.333,1),(350,7466742,7466737,'min',8.333,1),(350,7466743,7466737,'ini',8.333,1),(350,7466744,7466737,'nis',8.333,1),(350,7466745,7466737,'ist',8.333,1),(350,7466746,7466737,'str',8.333,1),(350,7466747,7466737,'tra',8.333,1),(350,7466748,7466737,'rat',8.333,1),(350,7466749,7466737,'ati',8.333,1),(350,7466750,7466737,'tio',8.333,1),(350,7466751,7466737,'ion',8.333,1),(350,7466752,7466740,'sta',33.333,3),(350,7466753,7466740,'tat',33.333,3),(350,7466754,7466740,'ate',33.333,3),(350,7466755,7466752,'ena',20,2),(350,7466756,7466752,'nab',20,2),(350,7466757,7466752,'abl',20,2),(350,7466758,7466752,'ble',20,2),(350,7466759,7466752,'led',20,2),(350,7466760,7466755,'cac',33.333,1),(350,7466761,7466755,'ach',33.333,1),(350,7466762,7466755,'che',33.333,1),(350,7466763,7466760,'mod',50,2),(350,7466764,7466760,'ode',50,2),(350,7466765,7466763,'wri',14.286,2),(350,7466766,7466763,'rit',14.286,2),(350,7466767,7466763,'ite',14.286,2),(350,7466768,7466763,'tet',14.286,2),(350,7466769,7466763,'eth',14.286,2),(350,7466770,7466763,'thr',14.286,2),(350,7466771,7466763,'hru',14.286,2),(350,7466772,7466765,'ope',11.111,2),(350,7466773,7466765,'per',11.111,2),(350,7466774,7466765,'era',11.111,2),(350,7466775,7466765,'rat',11.111,2),(350,7466776,7466765,'ati',11.111,2),(350,7466777,7466765,'tio',11.111,2),(350,7466778,7466765,'ion',11.111,2),(350,7466779,7466765,'ona',11.111,2),(350,7466780,7466765,'nal',11.111,2),(350,7466781,7466772,'nor',25,1),(350,7466782,7466772,'orm',25,1),(350,7466783,7466772,'rma',25,1),(350,7466784,7466772,'mal',25,1),(350,7466785,7466781,'mes',20,1),(350,7466786,7466781,'ess',20,1),(350,7466787,7466781,'ssa',20,1),(350,7466788,7466781,'sag',20,1),(350,7466789,7466781,'age',20,1),(350,7466790,7466785,'per',11.111,1),(350,7466791,7466785,'erf',11.111,1),(350,7466792,7466785,'rfo',11.111,1),(350,7466793,7466785,'for',11.111,1),(350,7466794,7466785,'orm',11.111,1),(350,7466795,7466785,'rma',11.111,1),(350,7466796,7466785,'man',11.111,1),(350,7466797,7466785,'anc',11.111,1),(350,7466798,7466785,'nce',11.111,1),(350,7466799,7466790,'ide',12.5,1),(350,7466800,7466790,'den',12.5,1),(350,7466801,7466790,'ent',12.5,1),(350,7466802,7466790,'nti',12.5,1),(350,7466803,7466790,'tif',12.5,1),(350,7466804,7466790,'ifi',12.5,1),(350,7466805,7466790,'fie',12.5,1),(350,7466806,7466790,'ier',12.5,1),(350,7466807,7466799,'vdi',33.333,3),(350,7466808,7466799,'dis',33.333,3),(350,7466809,7466799,'isk',33.333,3),(350,7466810,7466807,'nam',50,1),(350,7466811,7466807,'ame',50,1),(350,7466812,7466810,'typ',50,1),(350,7466813,7466810,'ype',50,1),(350,7466814,7466812,'dir',25,1),(350,7466815,7466812,'ire',25,1),(350,7466816,7466812,'rec',25,1),(350,7466817,7466812,'ect',25,1),(351,7466819,7466818,'naa',100,2),(351,7466820,7466819,'600',3.333,3),(351,7466821,7466819,'000',3.333,3),(351,7466822,7466819,'00c',3.333,3),(351,7466823,7466819,'0c2',3.333,3),(351,7466824,7466819,'c29',3.333,3),(351,7466825,7466819,'299',3.333,3),(351,7466826,7466819,'993',3.333,3),(351,7466827,7466819,'932',3.333,3),(351,7466828,7466819,'32d',3.333,3),(351,7466829,7466819,'2d1',3.333,3),(351,7466830,7466819,'d18',3.333,3),(351,7466831,7466819,'18c',3.333,3),(351,7466832,7466819,'8cc',3.333,3),(351,7466833,7466819,'cc5',3.333,3),(351,7466834,7466819,'c52',3.333,3),(351,7466835,7466819,'52a',3.333,3),(351,7466836,7466819,'2aa',3.333,3),(351,7466837,7466819,'aa4',3.333,3),(351,7466838,7466819,'a43',3.333,3),(351,7466839,7466819,'430',3.333,3),(351,7466840,7466819,'303',3.333,3),(351,7466841,7466819,'03f',3.333,3),(351,7466842,7466819,'3fb',3.333,3),(351,7466843,7466819,'fbb',3.333,3),(351,7466844,7466819,'bb5',3.333,3),(351,7466845,7466819,'b5e',3.333,3),(351,7466846,7466819,'5eb',3.333,3),(351,7466847,7466819,'eb3',3.333,3),(351,7466848,7466819,'b3c',3.333,3),(351,7466849,7466819,'3c8',3.333,3),(351,7466850,7466820,'mon',100,1),(351,7466851,7466850,'201',50,1),(351,7466852,7466850,'013',50,1),(351,7466853,7466851,'adm',33.333,3),(351,7466854,7466851,'dmi',33.333,3),(351,7466855,7466851,'min',33.333,3),(351,7466856,7466853,'cap',16.667,1),(351,7466857,7466853,'apa',16.667,1),(351,7466858,7466853,'pac',16.667,1),(351,7466859,7466853,'aci',16.667,1),(351,7466860,7466853,'cit',16.667,1),(351,7466861,7466853,'ity',16.667,1),(351,7466862,7466856,'pat',50,1),(351,7466863,7466856,'ath',50,1),(351,7466864,7466862,'fre',14.286,1),(351,7466865,7466862,'ree',14.286,1),(351,7466866,7466862,'ees',14.286,1),(351,7466867,7466862,'esp',14.286,1),(351,7466868,7466862,'spa',14.286,1),(351,7466869,7466862,'pac',14.286,1),(351,7466870,7466862,'ace',14.286,1),(351,7466871,7466864,'dis',50,1),(351,7466872,7466864,'isk',50,1),(351,7466873,7466871,'ind',33.333,1),(351,7466874,7466871,'nde',33.333,1),(351,7466875,7466871,'dex',33.333,1),(351,7466876,7466873,'adm',8.333,1),(351,7466877,7466873,'dmi',8.333,1),(351,7466878,7466873,'min',8.333,1),(351,7466879,7466873,'ini',8.333,1),(351,7466880,7466873,'nis',8.333,1),(351,7466881,7466873,'ist',8.333,1),(351,7466882,7466873,'str',8.333,1),(351,7466883,7466873,'tra',8.333,1),(351,7466884,7466873,'rat',8.333,1),(351,7466885,7466873,'ati',8.333,1),(351,7466886,7466873,'tio',8.333,1),(351,7466887,7466873,'ion',8.333,1),(351,7466888,7466876,'sta',33.333,3),(351,7466889,7466876,'tat',33.333,3),(351,7466890,7466876,'ate',33.333,3),(351,7466891,7466888,'ena',20,2),(351,7466892,7466888,'nab',20,2),(351,7466893,7466888,'abl',20,2),(351,7466894,7466888,'ble',20,2),(351,7466895,7466888,'led',20,2),(351,7466896,7466891,'cac',33.333,1),(351,7466897,7466891,'ach',33.333,1),(351,7466898,7466891,'che',33.333,1),(351,7466899,7466896,'mod',50,2),(351,7466900,7466896,'ode',50,2),(351,7466901,7466899,'wri',14.286,2),(351,7466902,7466899,'rit',14.286,2),(351,7466903,7466899,'ite',14.286,2),(351,7466904,7466899,'tet',14.286,2),(351,7466905,7466899,'eth',14.286,2),(351,7466906,7466899,'thr',14.286,2),(351,7466907,7466899,'hru',14.286,2),(351,7466908,7466901,'ope',11.111,2),(351,7466909,7466901,'per',11.111,2),(351,7466910,7466901,'era',11.111,2),(351,7466911,7466901,'rat',11.111,2),(351,7466912,7466901,'ati',11.111,2),(351,7466913,7466901,'tio',11.111,2),(351,7466914,7466901,'ion',11.111,2),(351,7466915,7466901,'ona',11.111,2),(351,7466916,7466901,'nal',11.111,2),(351,7466917,7466908,'nor',25,1),(351,7466918,7466908,'orm',25,1),(351,7466919,7466908,'rma',25,1),(351,7466920,7466908,'mal',25,1),(351,7466921,7466917,'mes',20,1),(351,7466922,7466917,'ess',20,1),(351,7466923,7466917,'ssa',20,1),(351,7466924,7466917,'sag',20,1),(351,7466925,7466917,'age',20,1),(351,7466926,7466921,'per',11.111,1),(351,7466927,7466921,'erf',11.111,1),(351,7466928,7466921,'rfo',11.111,1),(351,7466929,7466921,'for',11.111,1),(351,7466930,7466921,'orm',11.111,1),(351,7466931,7466921,'rma',11.111,1),(351,7466932,7466921,'man',11.111,1),(351,7466933,7466921,'anc',11.111,1),(351,7466934,7466921,'nce',11.111,1),(351,7466935,7466926,'ide',12.5,1),(351,7466936,7466926,'den',12.5,1),(351,7466937,7466926,'ent',12.5,1),(351,7466938,7466926,'nti',12.5,1),(351,7466939,7466926,'tif',12.5,1),(351,7466940,7466926,'ifi',12.5,1),(351,7466941,7466926,'fie',12.5,1),(351,7466942,7466926,'ier',12.5,1),(351,7466943,7466935,'vdi',33.333,3),(351,7466944,7466935,'dis',33.333,3),(351,7466945,7466935,'isk',33.333,3),(351,7466946,7466943,'nam',50,1),(351,7466947,7466943,'ame',50,1),(351,7466948,7466946,'typ',50,1),(351,7466949,7466946,'ype',50,1),(351,7466950,7466948,'dir',25,1),(351,7466951,7466948,'ire',25,1),(351,7466952,7466948,'rec',25,1),(351,7466953,7466948,'ect',25,1),(352,7466955,7466954,'naa',100,2),(352,7466956,7466955,'600',3.333,3),(352,7466957,7466955,'000',3.333,3),(352,7466958,7466955,'00c',3.333,3),(352,7466959,7466955,'0c2',3.333,3),(352,7466960,7466955,'c29',3.333,3),(352,7466961,7466955,'29f',3.333,3),(352,7466962,7466955,'9ff',3.333,3),(352,7466963,7466955,'ffd',3.333,3),(352,7466964,7466955,'fdb',3.333,3),(352,7466965,7466955,'dbb',3.333,3),(352,7466966,7466955,'bb1',3.333,3),(352,7466967,7466955,'b14',3.333,3),(352,7466968,7466955,'148',3.333,3),(352,7466969,7466955,'481',3.333,3),(352,7466970,7466955,'815',3.333,3),(352,7466971,7466955,'155',3.333,3),(352,7466972,7466955,'55d',3.333,3),(352,7466973,7466955,'5d0',3.333,3),(352,7466974,7466955,'d03',3.333,3),(352,7466975,7466955,'03e',3.333,3),(352,7466976,7466955,'3e2',3.333,3),(352,7466977,7466955,'e24',3.333,3),(352,7466978,7466955,'247',3.333,3),(352,7466979,7466955,'476',3.333,3),(352,7466980,7466955,'761',3.333,3),(352,7466981,7466955,'616',3.333,3),(352,7466982,7466955,'161',3.333,3),(352,7466983,7466955,'61c',3.333,3),(352,7466984,7466955,'1cb',3.333,3),(352,7466985,7466955,'cb4',3.333,3),(352,7466986,7466956,'mon',100,1),(352,7466987,7466986,'201',50,1),(352,7466988,7466986,'013',50,1),(352,7466989,7466987,'adm',33.333,3),(352,7466990,7466987,'dmi',33.333,3),(352,7466991,7466987,'min',33.333,3),(352,7466992,7466989,'cap',16.667,1),(352,7466993,7466989,'apa',16.667,1),(352,7466994,7466989,'pac',16.667,1),(352,7466995,7466989,'aci',16.667,1),(352,7466996,7466989,'cit',16.667,1),(352,7466997,7466989,'ity',16.667,1),(352,7466998,7466992,'pat',50,1),(352,7466999,7466992,'ath',50,1),(352,7467000,7466998,'fre',14.286,1),(352,7467001,7466998,'ree',14.286,1),(352,7467002,7466998,'ees',14.286,1),(352,7467003,7466998,'esp',14.286,1),(352,7467004,7466998,'spa',14.286,1),(352,7467005,7466998,'pac',14.286,1),(352,7467006,7466998,'ace',14.286,1),(352,7467007,7467000,'dis',50,1),(352,7467008,7467000,'isk',50,1),(352,7467009,7467007,'ind',33.333,1),(352,7467010,7467007,'nde',33.333,1),(352,7467011,7467007,'dex',33.333,1),(352,7467012,7467009,'adm',8.333,1),(352,7467013,7467009,'dmi',8.333,1),(352,7467014,7467009,'min',8.333,1),(352,7467015,7467009,'ini',8.333,1),(352,7467016,7467009,'nis',8.333,1),(352,7467017,7467009,'ist',8.333,1),(352,7467018,7467009,'str',8.333,1),(352,7467019,7467009,'tra',8.333,1),(352,7467020,7467009,'rat',8.333,1),(352,7467021,7467009,'ati',8.333,1),(352,7467022,7467009,'tio',8.333,1),(352,7467023,7467009,'ion',8.333,1),(352,7467024,7467012,'sta',33.333,3),(352,7467025,7467012,'tat',33.333,3),(352,7467026,7467012,'ate',33.333,3),(352,7467027,7467024,'ena',20,2),(352,7467028,7467024,'nab',20,2),(352,7467029,7467024,'abl',20,2),(352,7467030,7467024,'ble',20,2),(352,7467031,7467024,'led',20,2),(352,7467032,7467027,'cac',33.333,1),(352,7467033,7467027,'ach',33.333,1),(352,7467034,7467027,'che',33.333,1),(352,7467035,7467032,'mod',50,2),(352,7467036,7467032,'ode',50,2),(352,7467037,7467035,'wri',14.286,2),(352,7467038,7467035,'rit',14.286,2),(352,7467039,7467035,'ite',14.286,2),(352,7467040,7467035,'tet',14.286,2),(352,7467041,7467035,'eth',14.286,2),(352,7467042,7467035,'thr',14.286,2),(352,7467043,7467035,'hru',14.286,2),(352,7467044,7467037,'ope',11.111,2),(352,7467045,7467037,'per',11.111,2),(352,7467046,7467037,'era',11.111,2),(352,7467047,7467037,'rat',11.111,2),(352,7467048,7467037,'ati',11.111,2),(352,7467049,7467037,'tio',11.111,2),(352,7467050,7467037,'ion',11.111,2),(352,7467051,7467037,'ona',11.111,2),(352,7467052,7467037,'nal',11.111,2),(352,7467053,7467044,'nor',25,1),(352,7467054,7467044,'orm',25,1),(352,7467055,7467044,'rma',25,1),(352,7467056,7467044,'mal',25,1),(352,7467057,7467053,'mes',20,1),(352,7467058,7467053,'ess',20,1),(352,7467059,7467053,'ssa',20,1),(352,7467060,7467053,'sag',20,1),(352,7467061,7467053,'age',20,1),(352,7467062,7467057,'per',11.111,1),(352,7467063,7467057,'erf',11.111,1),(352,7467064,7467057,'rfo',11.111,1),(352,7467065,7467057,'for',11.111,1),(352,7467066,7467057,'orm',11.111,1),(352,7467067,7467057,'rma',11.111,1),(352,7467068,7467057,'man',11.111,1),(352,7467069,7467057,'anc',11.111,1),(352,7467070,7467057,'nce',11.111,1),(352,7467071,7467062,'ide',12.5,1),(352,7467072,7467062,'den',12.5,1),(352,7467073,7467062,'ent',12.5,1),(352,7467074,7467062,'nti',12.5,1),(352,7467075,7467062,'tif',12.5,1),(352,7467076,7467062,'ifi',12.5,1),(352,7467077,7467062,'fie',12.5,1),(352,7467078,7467062,'ier',12.5,1),(352,7467079,7467071,'vdi',33.333,3),(352,7467080,7467071,'dis',33.333,3),(352,7467081,7467071,'isk',33.333,3),(352,7467082,7467079,'nam',50,1),(352,7467083,7467079,'ame',50,1),(352,7467084,7467082,'typ',50,1),(352,7467085,7467082,'ype',50,1),(352,7467086,7467084,'dir',25,1),(352,7467087,7467084,'ire',25,1),(352,7467088,7467084,'rec',25,1),(352,7467089,7467084,'ect',25,1),(353,7467091,7467090,'naa',100,2),(353,7467092,7467091,'600',3.333,3),(353,7467093,7467091,'000',3.333,3),(353,7467094,7467091,'00c',3.333,3),(353,7467095,7467091,'0c2',3.333,3),(353,7467096,7467091,'c29',3.333,3),(353,7467097,7467091,'29b',3.333,3),(353,7467098,7467091,'9b6',3.333,3),(353,7467099,7467091,'b66',3.333,3),(353,7467100,7467091,'66d',3.333,3),(353,7467101,7467091,'6d5',3.333,3),(353,7467102,7467091,'d5f',3.333,3),(353,7467103,7467091,'5ff',3.333,3),(353,7467104,7467091,'ffd',3.333,3),(353,7467105,7467091,'fd2',3.333,3),(353,7467106,7467091,'d22',3.333,3),(353,7467107,7467091,'22d',3.333,3),(353,7467108,7467091,'2d0',3.333,3),(353,7467109,7467091,'d0d',3.333,3),(353,7467110,7467091,'0dd',3.333,3),(353,7467111,7467091,'dd7',3.333,3),(353,7467112,7467091,'d7c',3.333,3),(353,7467113,7467091,'7c0',3.333,3),(353,7467114,7467091,'c09',3.333,3),(353,7467115,7467091,'09b',3.333,3),(353,7467116,7467091,'9b5',3.333,3),(353,7467117,7467091,'b51',3.333,3),(353,7467118,7467091,'517',3.333,3),(353,7467119,7467091,'17e',3.333,3),(353,7467120,7467091,'7e5',3.333,3),(353,7467121,7467091,'e52',3.333,3),(353,7467122,7467092,'mon',100,1),(353,7467123,7467122,'201',50,1),(353,7467124,7467122,'013',50,1),(353,7467125,7467123,'adm',33.333,3),(353,7467126,7467123,'dmi',33.333,3),(353,7467127,7467123,'min',33.333,3),(353,7467128,7467125,'cap',16.667,1),(353,7467129,7467125,'apa',16.667,1),(353,7467130,7467125,'pac',16.667,1),(353,7467131,7467125,'aci',16.667,1),(353,7467132,7467125,'cit',16.667,1),(353,7467133,7467125,'ity',16.667,1),(353,7467134,7467128,'pat',50,1),(353,7467135,7467128,'ath',50,1),(353,7467136,7467134,'fre',14.286,1),(353,7467137,7467134,'ree',14.286,1),(353,7467138,7467134,'ees',14.286,1),(353,7467139,7467134,'esp',14.286,1),(353,7467140,7467134,'spa',14.286,1),(353,7467141,7467134,'pac',14.286,1),(353,7467142,7467134,'ace',14.286,1),(353,7467143,7467136,'dis',50,1),(353,7467144,7467136,'isk',50,1),(353,7467145,7467143,'ind',33.333,1),(353,7467146,7467143,'nde',33.333,1),(353,7467147,7467143,'dex',33.333,1),(353,7467148,7467145,'adm',8.333,1),(353,7467149,7467145,'dmi',8.333,1),(353,7467150,7467145,'min',8.333,1),(353,7467151,7467145,'ini',8.333,1),(353,7467152,7467145,'nis',8.333,1),(353,7467153,7467145,'ist',8.333,1),(353,7467154,7467145,'str',8.333,1),(353,7467155,7467145,'tra',8.333,1),(353,7467156,7467145,'rat',8.333,1),(353,7467157,7467145,'ati',8.333,1),(353,7467158,7467145,'tio',8.333,1),(353,7467159,7467145,'ion',8.333,1),(353,7467160,7467148,'sta',33.333,3),(353,7467161,7467148,'tat',33.333,3),(353,7467162,7467148,'ate',33.333,3),(353,7467163,7467160,'ena',20,2),(353,7467164,7467160,'nab',20,2),(353,7467165,7467160,'abl',20,2),(353,7467166,7467160,'ble',20,2),(353,7467167,7467160,'led',20,2),(353,7467168,7467163,'cac',33.333,1),(353,7467169,7467163,'ach',33.333,1),(353,7467170,7467163,'che',33.333,1),(353,7467171,7467168,'mod',50,2),(353,7467172,7467168,'ode',50,2),(353,7467173,7467171,'wri',14.286,2),(353,7467174,7467171,'rit',14.286,2),(353,7467175,7467171,'ite',14.286,2),(353,7467176,7467171,'tet',14.286,2),(353,7467177,7467171,'eth',14.286,2),(353,7467178,7467171,'thr',14.286,2),(353,7467179,7467171,'hru',14.286,2),(353,7467180,7467173,'ope',11.111,2),(353,7467181,7467173,'per',11.111,2),(353,7467182,7467173,'era',11.111,2),(353,7467183,7467173,'rat',11.111,2),(353,7467184,7467173,'ati',11.111,2),(353,7467185,7467173,'tio',11.111,2),(353,7467186,7467173,'ion',11.111,2),(353,7467187,7467173,'ona',11.111,2),(353,7467188,7467173,'nal',11.111,2),(353,7467189,7467180,'nor',25,1),(353,7467190,7467180,'orm',25,1),(353,7467191,7467180,'rma',25,1),(353,7467192,7467180,'mal',25,1),(353,7467193,7467189,'mes',20,1),(353,7467194,7467189,'ess',20,1),(353,7467195,7467189,'ssa',20,1),(353,7467196,7467189,'sag',20,1),(353,7467197,7467189,'age',20,1),(353,7467198,7467193,'per',11.111,1),(353,7467199,7467193,'erf',11.111,1),(353,7467200,7467193,'rfo',11.111,1),(353,7467201,7467193,'for',11.111,1),(353,7467202,7467193,'orm',11.111,1),(353,7467203,7467193,'rma',11.111,1),(353,7467204,7467193,'man',11.111,1),(353,7467205,7467193,'anc',11.111,1),(353,7467206,7467193,'nce',11.111,1),(353,7467207,7467198,'ide',12.5,1),(353,7467208,7467198,'den',12.5,1),(353,7467209,7467198,'ent',12.5,1),(353,7467210,7467198,'nti',12.5,1),(353,7467211,7467198,'tif',12.5,1),(353,7467212,7467198,'ifi',12.5,1),(353,7467213,7467198,'fie',12.5,1),(353,7467214,7467198,'ier',12.5,1),(353,7467215,7467207,'vdi',33.333,3),(353,7467216,7467207,'dis',33.333,3),(353,7467217,7467207,'isk',33.333,3),(353,7467218,7467215,'nam',50,1),(353,7467219,7467215,'ame',50,1),(353,7467220,7467218,'typ',50,1),(353,7467221,7467218,'ype',50,1),(353,7467222,7467220,'dir',25,1),(353,7467223,7467220,'ire',25,1),(353,7467224,7467220,'rec',25,1),(353,7467225,7467220,'ect',25,1),(354,7467227,7467226,'naa',100,2),(354,7467228,7467227,'600',3.333,3),(354,7467229,7467227,'000',3.333,3),(354,7467230,7467227,'00c',3.333,3),(354,7467231,7467227,'0c2',3.333,3),(354,7467232,7467227,'c29',3.333,3),(354,7467233,7467227,'298',3.333,3),(354,7467234,7467227,'98c',3.333,3),(354,7467235,7467227,'8cc',3.333,3),(354,7467236,7467227,'ccb',3.333,3),(354,7467237,7467227,'cbc',3.333,3),(354,7467238,7467227,'bcb',3.333,3),(354,7467239,7467227,'cb8',3.333,3),(354,7467240,7467227,'b85',3.333,3),(354,7467241,7467227,'856',3.333,3),(354,7467242,7467227,'562',3.333,3),(354,7467243,7467227,'621',3.333,3),(354,7467244,7467227,'219',3.333,3),(354,7467245,7467227,'196',3.333,3),(354,7467246,7467227,'96b',3.333,3),(354,7467247,7467227,'6ba',3.333,3),(354,7467248,7467227,'baa',3.333,3),(354,7467249,7467227,'aab',3.333,3),(354,7467250,7467227,'ab2',3.333,3),(354,7467251,7467227,'b20',3.333,3),(354,7467252,7467227,'201',3.333,3),(354,7467253,7467227,'010',3.333,3),(354,7467254,7467227,'10f',3.333,3),(354,7467255,7467227,'0f8',3.333,3),(354,7467256,7467227,'f8f',3.333,3),(354,7467257,7467227,'8ff',3.333,3),(354,7467258,7467228,'mon',100,1),(354,7467259,7467258,'201',50,1),(354,7467260,7467258,'013',50,1),(354,7467261,7467259,'adm',33.333,3),(354,7467262,7467259,'dmi',33.333,3),(354,7467263,7467259,'min',33.333,3),(354,7467264,7467261,'cap',16.667,1),(354,7467265,7467261,'apa',16.667,1),(354,7467266,7467261,'pac',16.667,1),(354,7467267,7467261,'aci',16.667,1),(354,7467268,7467261,'cit',16.667,1),(354,7467269,7467261,'ity',16.667,1),(354,7467270,7467264,'pat',50,1),(354,7467271,7467264,'ath',50,1),(354,7467272,7467270,'fre',14.286,1),(354,7467273,7467270,'ree',14.286,1),(354,7467274,7467270,'ees',14.286,1),(354,7467275,7467270,'esp',14.286,1),(354,7467276,7467270,'spa',14.286,1),(354,7467277,7467270,'pac',14.286,1),(354,7467278,7467270,'ace',14.286,1),(354,7467279,7467272,'dis',50,1),(354,7467280,7467272,'isk',50,1),(354,7467281,7467279,'ind',33.333,1),(354,7467282,7467279,'nde',33.333,1),(354,7467283,7467279,'dex',33.333,1),(354,7467284,7467281,'adm',8.333,1),(354,7467285,7467281,'dmi',8.333,1),(354,7467286,7467281,'min',8.333,1),(354,7467287,7467281,'ini',8.333,1),(354,7467288,7467281,'nis',8.333,1),(354,7467289,7467281,'ist',8.333,1),(354,7467290,7467281,'str',8.333,1),(354,7467291,7467281,'tra',8.333,1),(354,7467292,7467281,'rat',8.333,1),(354,7467293,7467281,'ati',8.333,1),(354,7467294,7467281,'tio',8.333,1),(354,7467295,7467281,'ion',8.333,1),(354,7467296,7467284,'sta',33.333,3),(354,7467297,7467284,'tat',33.333,3),(354,7467298,7467284,'ate',33.333,3),(354,7467299,7467296,'ena',20,2),(354,7467300,7467296,'nab',20,2),(354,7467301,7467296,'abl',20,2),(354,7467302,7467296,'ble',20,2),(354,7467303,7467296,'led',20,2),(354,7467304,7467299,'cac',33.333,1),(354,7467305,7467299,'ach',33.333,1),(354,7467306,7467299,'che',33.333,1),(354,7467307,7467304,'mod',50,2),(354,7467308,7467304,'ode',50,2),(354,7467309,7467307,'wri',14.286,2),(354,7467310,7467307,'rit',14.286,2),(354,7467311,7467307,'ite',14.286,2),(354,7467312,7467307,'tet',14.286,2),(354,7467313,7467307,'eth',14.286,2),(354,7467314,7467307,'thr',14.286,2),(354,7467315,7467307,'hru',14.286,2),(354,7467316,7467309,'ope',11.111,2),(354,7467317,7467309,'per',11.111,2),(354,7467318,7467309,'era',11.111,2),(354,7467319,7467309,'rat',11.111,2),(354,7467320,7467309,'ati',11.111,2),(354,7467321,7467309,'tio',11.111,2),(354,7467322,7467309,'ion',11.111,2),(354,7467323,7467309,'ona',11.111,2),(354,7467324,7467309,'nal',11.111,2),(354,7467325,7467316,'nor',25,1),(354,7467326,7467316,'orm',25,1),(354,7467327,7467316,'rma',25,1),(354,7467328,7467316,'mal',25,1),(354,7467329,7467325,'mes',20,1),(354,7467330,7467325,'ess',20,1),(354,7467331,7467325,'ssa',20,1),(354,7467332,7467325,'sag',20,1),(354,7467333,7467325,'age',20,1),(354,7467334,7467329,'per',11.111,1),(354,7467335,7467329,'erf',11.111,1),(354,7467336,7467329,'rfo',11.111,1),(354,7467337,7467329,'for',11.111,1),(354,7467338,7467329,'orm',11.111,1),(354,7467339,7467329,'rma',11.111,1),(354,7467340,7467329,'man',11.111,1),(354,7467341,7467329,'anc',11.111,1),(354,7467342,7467329,'nce',11.111,1),(354,7467343,7467334,'ide',12.5,1),(354,7467344,7467334,'den',12.5,1),(354,7467345,7467334,'ent',12.5,1),(354,7467346,7467334,'nti',12.5,1),(354,7467347,7467334,'tif',12.5,1),(354,7467348,7467334,'ifi',12.5,1),(354,7467349,7467334,'fie',12.5,1),(354,7467350,7467334,'ier',12.5,1),(354,7467351,7467343,'vdi',33.333,3),(354,7467352,7467343,'dis',33.333,3),(354,7467353,7467343,'isk',33.333,3),(354,7467354,7467351,'nam',50,1),(354,7467355,7467351,'ame',50,1),(354,7467356,7467354,'typ',50,1),(354,7467357,7467354,'ype',50,1),(354,7467358,7467356,'dir',25,1),(354,7467359,7467356,'ire',25,1),(354,7467360,7467356,'rec',25,1),(354,7467361,7467356,'ect',25,1),(355,7467363,7467362,'naa',100,2),(355,7467364,7467363,'600',3.333,3),(355,7467365,7467363,'000',3.333,3),(355,7467366,7467363,'00c',3.333,3),(355,7467367,7467363,'0c2',3.333,3),(355,7467368,7467363,'c29',3.333,3),(355,7467369,7467363,'293',3.333,3),(355,7467370,7467363,'935',3.333,3),(355,7467371,7467363,'35d',3.333,3),(355,7467372,7467363,'5dd',3.333,3),(355,7467373,7467363,'ddc',3.333,3),(355,7467374,7467363,'dc9',3.333,3),(355,7467375,7467363,'c92',3.333,3),(355,7467376,7467363,'92f',3.333,3),(355,7467377,7467363,'2f1',3.333,3),(355,7467378,7467363,'f10',3.333,3),(355,7467379,7467363,'104',3.333,3),(355,7467380,7467363,'043',3.333,3),(355,7467381,7467363,'433',3.333,3),(355,7467382,7467363,'33d',3.333,3),(355,7467383,7467363,'3d1',3.333,3),(355,7467384,7467363,'d19',3.333,3),(355,7467385,7467363,'19f',3.333,3),(355,7467386,7467363,'9f2',3.333,3),(355,7467387,7467363,'f2b',3.333,3),(355,7467388,7467363,'2bb',3.333,3),(355,7467389,7467363,'bb8',3.333,3),(355,7467390,7467363,'b80',3.333,3),(355,7467391,7467363,'80a',3.333,3),(355,7467392,7467363,'0a9',3.333,3),(355,7467393,7467363,'a9b',3.333,3),(355,7467394,7467364,'mon',100,1),(355,7467395,7467394,'201',50,1),(355,7467396,7467394,'013',50,1),(355,7467397,7467395,'adm',33.333,3),(355,7467398,7467395,'dmi',33.333,3),(355,7467399,7467395,'min',33.333,3),(355,7467400,7467397,'cap',16.667,1),(355,7467401,7467397,'apa',16.667,1),(355,7467402,7467397,'pac',16.667,1),(355,7467403,7467397,'aci',16.667,1),(355,7467404,7467397,'cit',16.667,1),(355,7467405,7467397,'ity',16.667,1),(355,7467406,7467400,'pat',50,1),(355,7467407,7467400,'ath',50,1),(355,7467408,7467406,'fre',14.286,1),(355,7467409,7467406,'ree',14.286,1),(355,7467410,7467406,'ees',14.286,1),(355,7467411,7467406,'esp',14.286,1),(355,7467412,7467406,'spa',14.286,1),(355,7467413,7467406,'pac',14.286,1),(355,7467414,7467406,'ace',14.286,1),(355,7467415,7467408,'dis',50,1),(355,7467416,7467408,'isk',50,1),(355,7467417,7467415,'ind',33.333,1),(355,7467418,7467415,'nde',33.333,1),(355,7467419,7467415,'dex',33.333,1),(355,7467420,7467417,'adm',8.333,1),(355,7467421,7467417,'dmi',8.333,1),(355,7467422,7467417,'min',8.333,1),(355,7467423,7467417,'ini',8.333,1),(355,7467424,7467417,'nis',8.333,1),(355,7467425,7467417,'ist',8.333,1),(355,7467426,7467417,'str',8.333,1),(355,7467427,7467417,'tra',8.333,1),(355,7467428,7467417,'rat',8.333,1),(355,7467429,7467417,'ati',8.333,1),(355,7467430,7467417,'tio',8.333,1),(355,7467431,7467417,'ion',8.333,1),(355,7467432,7467420,'sta',33.333,3),(355,7467433,7467420,'tat',33.333,3),(355,7467434,7467420,'ate',33.333,3),(355,7467435,7467432,'ena',20,2),(355,7467436,7467432,'nab',20,2),(355,7467437,7467432,'abl',20,2),(355,7467438,7467432,'ble',20,2),(355,7467439,7467432,'led',20,2),(355,7467440,7467435,'cac',33.333,1),(355,7467441,7467435,'ach',33.333,1),(355,7467442,7467435,'che',33.333,1),(355,7467443,7467440,'mod',50,2),(355,7467444,7467440,'ode',50,2),(355,7467445,7467443,'wri',14.286,2),(355,7467446,7467443,'rit',14.286,2),(355,7467447,7467443,'ite',14.286,2),(355,7467448,7467443,'tet',14.286,2),(355,7467449,7467443,'eth',14.286,2),(355,7467450,7467443,'thr',14.286,2),(355,7467451,7467443,'hru',14.286,2),(355,7467452,7467445,'ope',11.111,2),(355,7467453,7467445,'per',11.111,2),(355,7467454,7467445,'era',11.111,2),(355,7467455,7467445,'rat',11.111,2),(355,7467456,7467445,'ati',11.111,2),(355,7467457,7467445,'tio',11.111,2),(355,7467458,7467445,'ion',11.111,2),(355,7467459,7467445,'ona',11.111,2),(355,7467460,7467445,'nal',11.111,2),(355,7467461,7467452,'nor',25,1),(355,7467462,7467452,'orm',25,1),(355,7467463,7467452,'rma',25,1),(355,7467464,7467452,'mal',25,1),(355,7467465,7467461,'mes',20,1),(355,7467466,7467461,'ess',20,1),(355,7467467,7467461,'ssa',20,1),(355,7467468,7467461,'sag',20,1),(355,7467469,7467461,'age',20,1),(355,7467470,7467465,'per',11.111,1),(355,7467471,7467465,'erf',11.111,1),(355,7467472,7467465,'rfo',11.111,1),(355,7467473,7467465,'for',11.111,1),(355,7467474,7467465,'orm',11.111,1),(355,7467475,7467465,'rma',11.111,1),(355,7467476,7467465,'man',11.111,1),(355,7467477,7467465,'anc',11.111,1),(355,7467478,7467465,'nce',11.111,1),(355,7467479,7467470,'ide',12.5,1),(355,7467480,7467470,'den',12.5,1),(355,7467481,7467470,'ent',12.5,1),(355,7467482,7467470,'nti',12.5,1),(355,7467483,7467470,'tif',12.5,1),(355,7467484,7467470,'ifi',12.5,1),(355,7467485,7467470,'fie',12.5,1),(355,7467486,7467470,'ier',12.5,1),(355,7467487,7467479,'vdi',33.333,3),(355,7467488,7467479,'dis',33.333,3),(355,7467489,7467479,'isk',33.333,3),(355,7467490,7467487,'nam',50,1),(355,7467491,7467487,'ame',50,1),(355,7467492,7467490,'typ',50,1),(355,7467493,7467490,'ype',50,1),(355,7467494,7467492,'dir',25,1),(355,7467495,7467492,'ire',25,1),(355,7467496,7467492,'rec',25,1),(355,7467497,7467492,'ect',25,1),(356,7467499,7467498,'naa',100,2),(356,7467500,7467499,'600',3.333,3),(356,7467501,7467499,'000',3.333,3),(356,7467502,7467499,'00c',3.333,3),(356,7467503,7467499,'0c2',3.333,3),(356,7467504,7467499,'c29',3.333,3),(356,7467505,7467499,'293',3.333,3),(356,7467506,7467499,'93d',3.333,3),(356,7467507,7467499,'3d4',3.333,3),(356,7467508,7467499,'d49',3.333,3),(356,7467509,7467499,'496',3.333,3),(356,7467510,7467499,'96c',3.333,3),(356,7467511,7467499,'6c4',3.333,3),(356,7467512,7467499,'c4a',3.333,3),(356,7467513,7467499,'4a7',3.333,3),(356,7467514,7467499,'a7d',3.333,3),(356,7467515,7467499,'7d9',3.333,3),(356,7467516,7467499,'d9a',3.333,3),(356,7467517,7467499,'9a1',3.333,3),(356,7467518,7467499,'a1f',3.333,3),(356,7467519,7467499,'1f8',3.333,3),(356,7467520,7467499,'f8a',3.333,3),(356,7467521,7467499,'8af',3.333,3),(356,7467522,7467499,'af3',3.333,3),(356,7467523,7467499,'f3d',3.333,3),(356,7467524,7467499,'3d2',3.333,3),(356,7467525,7467499,'d22',3.333,3),(356,7467526,7467499,'22e',3.333,3),(356,7467527,7467499,'2ef',3.333,3),(356,7467528,7467499,'ef1',3.333,3),(356,7467529,7467499,'f12',3.333,3),(356,7467530,7467500,'mon',100,1),(356,7467531,7467530,'201',50,1),(356,7467532,7467530,'013',50,1),(356,7467533,7467531,'adm',33.333,3),(356,7467534,7467531,'dmi',33.333,3),(356,7467535,7467531,'min',33.333,3),(356,7467536,7467533,'cap',16.667,1),(356,7467537,7467533,'apa',16.667,1),(356,7467538,7467533,'pac',16.667,1),(356,7467539,7467533,'aci',16.667,1),(356,7467540,7467533,'cit',16.667,1),(356,7467541,7467533,'ity',16.667,1),(356,7467542,7467536,'pat',50,1),(356,7467543,7467536,'ath',50,1),(356,7467544,7467542,'fre',14.286,1),(356,7467545,7467542,'ree',14.286,1),(356,7467546,7467542,'ees',14.286,1),(356,7467547,7467542,'esp',14.286,1),(356,7467548,7467542,'spa',14.286,1),(356,7467549,7467542,'pac',14.286,1),(356,7467550,7467542,'ace',14.286,1),(356,7467551,7467544,'dis',50,1),(356,7467552,7467544,'isk',50,1),(356,7467553,7467551,'ind',33.333,1),(356,7467554,7467551,'nde',33.333,1),(356,7467555,7467551,'dex',33.333,1),(356,7467556,7467553,'adm',8.333,1),(356,7467557,7467553,'dmi',8.333,1),(356,7467558,7467553,'min',8.333,1),(356,7467559,7467553,'ini',8.333,1),(356,7467560,7467553,'nis',8.333,1),(356,7467561,7467553,'ist',8.333,1),(356,7467562,7467553,'str',8.333,1),(356,7467563,7467553,'tra',8.333,1),(356,7467564,7467553,'rat',8.333,1),(356,7467565,7467553,'ati',8.333,1),(356,7467566,7467553,'tio',8.333,1),(356,7467567,7467553,'ion',8.333,1),(356,7467568,7467556,'sta',33.333,3),(356,7467569,7467556,'tat',33.333,3),(356,7467570,7467556,'ate',33.333,3),(356,7467571,7467568,'ena',20,2),(356,7467572,7467568,'nab',20,2),(356,7467573,7467568,'abl',20,2),(356,7467574,7467568,'ble',20,2),(356,7467575,7467568,'led',20,2),(356,7467576,7467571,'cac',33.333,1),(356,7467577,7467571,'ach',33.333,1),(356,7467578,7467571,'che',33.333,1),(356,7467579,7467576,'mod',50,2),(356,7467580,7467576,'ode',50,2),(356,7467581,7467579,'wri',14.286,2),(356,7467582,7467579,'rit',14.286,2),(356,7467583,7467579,'ite',14.286,2),(356,7467584,7467579,'tet',14.286,2),(356,7467585,7467579,'eth',14.286,2),(356,7467586,7467579,'thr',14.286,2),(356,7467587,7467579,'hru',14.286,2),(356,7467588,7467581,'ope',11.111,2),(356,7467589,7467581,'per',11.111,2),(356,7467590,7467581,'era',11.111,2),(356,7467591,7467581,'rat',11.111,2),(356,7467592,7467581,'ati',11.111,2),(356,7467593,7467581,'tio',11.111,2),(356,7467594,7467581,'ion',11.111,2),(356,7467595,7467581,'ona',11.111,2),(356,7467596,7467581,'nal',11.111,2),(356,7467597,7467588,'nor',25,1),(356,7467598,7467588,'orm',25,1),(356,7467599,7467588,'rma',25,1),(356,7467600,7467588,'mal',25,1),(356,7467601,7467597,'mes',20,1),(356,7467602,7467597,'ess',20,1),(356,7467603,7467597,'ssa',20,1),(356,7467604,7467597,'sag',20,1),(356,7467605,7467597,'age',20,1),(356,7467606,7467601,'per',11.111,1),(356,7467607,7467601,'erf',11.111,1),(356,7467608,7467601,'rfo',11.111,1),(356,7467609,7467601,'for',11.111,1),(356,7467610,7467601,'orm',11.111,1),(356,7467611,7467601,'rma',11.111,1),(356,7467612,7467601,'man',11.111,1),(356,7467613,7467601,'anc',11.111,1),(356,7467614,7467601,'nce',11.111,1),(356,7467615,7467606,'ide',12.5,1),(356,7467616,7467606,'den',12.5,1),(356,7467617,7467606,'ent',12.5,1),(356,7467618,7467606,'nti',12.5,1),(356,7467619,7467606,'tif',12.5,1),(356,7467620,7467606,'ifi',12.5,1),(356,7467621,7467606,'fie',12.5,1),(356,7467622,7467606,'ier',12.5,1),(356,7467623,7467615,'vdi',33.333,3),(356,7467624,7467615,'dis',33.333,3),(356,7467625,7467615,'isk',33.333,3),(356,7467626,7467623,'nam',50,1),(356,7467627,7467623,'ame',50,1),(356,7467628,7467626,'typ',50,1),(356,7467629,7467626,'ype',50,1),(356,7467630,7467628,'dir',25,1),(356,7467631,7467628,'ire',25,1),(356,7467632,7467628,'rec',25,1),(356,7467633,7467628,'ect',25,1),(357,7467635,7467634,'naa',100,2),(357,7467636,7467635,'600',3.333,3),(357,7467637,7467635,'000',3.333,3),(357,7467638,7467635,'00c',3.333,3),(357,7467639,7467635,'0c2',3.333,3),(357,7467640,7467635,'c29',3.333,3),(357,7467641,7467635,'296',3.333,3),(357,7467642,7467635,'960',3.333,3),(357,7467643,7467635,'60a',3.333,3),(357,7467644,7467635,'0ac',3.333,3),(357,7467645,7467635,'acd',3.333,3),(357,7467646,7467635,'cd1',3.333,3),(357,7467647,7467635,'d1e',3.333,3),(357,7467648,7467635,'1e4',3.333,3),(357,7467649,7467635,'e40',3.333,3),(357,7467650,7467635,'402',3.333,3),(357,7467651,7467635,'028',3.333,3),(357,7467652,7467635,'28a',3.333,3),(357,7467653,7467635,'8a9',3.333,3),(357,7467654,7467635,'a94',3.333,3),(357,7467655,7467635,'94d',3.333,3),(357,7467656,7467635,'4d4',3.333,3),(357,7467657,7467635,'d47',3.333,3),(357,7467658,7467635,'476',3.333,3),(357,7467659,7467635,'76e',3.333,3),(357,7467660,7467635,'6ec',3.333,3),(357,7467661,7467635,'ecd',3.333,3),(357,7467662,7467635,'cdc',3.333,3),(357,7467663,7467635,'dc6',3.333,3),(357,7467664,7467635,'c66',3.333,3),(357,7467665,7467635,'668',3.333,3),(357,7467666,7467636,'mon',100,1),(357,7467667,7467666,'201',50,1),(357,7467668,7467666,'013',50,1),(357,7467669,7467667,'adm',33.333,3),(357,7467670,7467667,'dmi',33.333,3),(357,7467671,7467667,'min',33.333,3),(357,7467672,7467669,'cap',16.667,1),(357,7467673,7467669,'apa',16.667,1),(357,7467674,7467669,'pac',16.667,1),(357,7467675,7467669,'aci',16.667,1),(357,7467676,7467669,'cit',16.667,1),(357,7467677,7467669,'ity',16.667,1),(357,7467678,7467672,'pat',50,1),(357,7467679,7467672,'ath',50,1),(357,7467680,7467678,'fre',14.286,1),(357,7467681,7467678,'ree',14.286,1),(357,7467682,7467678,'ees',14.286,1),(357,7467683,7467678,'esp',14.286,1),(357,7467684,7467678,'spa',14.286,1),(357,7467685,7467678,'pac',14.286,1),(357,7467686,7467678,'ace',14.286,1),(357,7467687,7467680,'dis',50,1),(357,7467688,7467680,'isk',50,1),(357,7467689,7467687,'ind',33.333,1),(357,7467690,7467687,'nde',33.333,1),(357,7467691,7467687,'dex',33.333,1),(357,7467692,7467689,'adm',8.333,1),(357,7467693,7467689,'dmi',8.333,1),(357,7467694,7467689,'min',8.333,1),(357,7467695,7467689,'ini',8.333,1),(357,7467696,7467689,'nis',8.333,1),(357,7467697,7467689,'ist',8.333,1),(357,7467698,7467689,'str',8.333,1),(357,7467699,7467689,'tra',8.333,1),(357,7467700,7467689,'rat',8.333,1),(357,7467701,7467689,'ati',8.333,1),(357,7467702,7467689,'tio',8.333,1),(357,7467703,7467689,'ion',8.333,1),(357,7467704,7467692,'sta',33.333,3),(357,7467705,7467692,'tat',33.333,3),(357,7467706,7467692,'ate',33.333,3),(357,7467707,7467704,'ena',20,2),(357,7467708,7467704,'nab',20,2),(357,7467709,7467704,'abl',20,2),(357,7467710,7467704,'ble',20,2),(357,7467711,7467704,'led',20,2),(357,7467712,7467707,'cac',33.333,1),(357,7467713,7467707,'ach',33.333,1),(357,7467714,7467707,'che',33.333,1),(357,7467715,7467712,'mod',50,2),(357,7467716,7467712,'ode',50,2),(357,7467717,7467715,'wri',14.286,2),(357,7467718,7467715,'rit',14.286,2),(357,7467719,7467715,'ite',14.286,2),(357,7467720,7467715,'tet',14.286,2),(357,7467721,7467715,'eth',14.286,2),(357,7467722,7467715,'thr',14.286,2),(357,7467723,7467715,'hru',14.286,2),(357,7467724,7467717,'ope',11.111,2),(357,7467725,7467717,'per',11.111,2),(357,7467726,7467717,'era',11.111,2),(357,7467727,7467717,'rat',11.111,2),(357,7467728,7467717,'ati',11.111,2),(357,7467729,7467717,'tio',11.111,2),(357,7467730,7467717,'ion',11.111,2),(357,7467731,7467717,'ona',11.111,2),(357,7467732,7467717,'nal',11.111,2),(357,7467733,7467724,'nor',25,1),(357,7467734,7467724,'orm',25,1),(357,7467735,7467724,'rma',25,1),(357,7467736,7467724,'mal',25,1),(357,7467737,7467733,'mes',20,1),(357,7467738,7467733,'ess',20,1),(357,7467739,7467733,'ssa',20,1),(357,7467740,7467733,'sag',20,1),(357,7467741,7467733,'age',20,1),(357,7467742,7467737,'per',11.111,1),(357,7467743,7467737,'erf',11.111,1),(357,7467744,7467737,'rfo',11.111,1),(357,7467745,7467737,'for',11.111,1),(357,7467746,7467737,'orm',11.111,1),(357,7467747,7467737,'rma',11.111,1),(357,7467748,7467737,'man',11.111,1),(357,7467749,7467737,'anc',11.111,1),(357,7467750,7467737,'nce',11.111,1),(357,7467751,7467742,'ide',12.5,1),(357,7467752,7467742,'den',12.5,1),(357,7467753,7467742,'ent',12.5,1),(357,7467754,7467742,'nti',12.5,1),(357,7467755,7467742,'tif',12.5,1),(357,7467756,7467742,'ifi',12.5,1),(357,7467757,7467742,'fie',12.5,1),(357,7467758,7467742,'ier',12.5,1),(357,7467759,7467751,'vdi',33.333,3),(357,7467760,7467751,'dis',33.333,3),(357,7467761,7467751,'isk',33.333,3),(357,7467762,7467759,'nam',50,1),(357,7467763,7467759,'ame',50,1),(357,7467764,7467762,'typ',50,1),(357,7467765,7467762,'ype',50,1),(357,7467766,7467764,'dir',25,1),(357,7467767,7467764,'ire',25,1),(357,7467768,7467764,'rec',25,1),(357,7467769,7467764,'ect',25,1),(358,7467771,7467770,'naa',100,2),(358,7467772,7467771,'600',3.333,3),(358,7467773,7467771,'000',3.333,3),(358,7467774,7467771,'00c',3.333,3),(358,7467775,7467771,'0c2',3.333,3),(358,7467776,7467771,'c29',3.333,3),(358,7467777,7467771,'299',3.333,3),(358,7467778,7467771,'995',3.333,3),(358,7467779,7467771,'957',3.333,3),(358,7467780,7467771,'57b',3.333,3),(358,7467781,7467771,'7b3',3.333,3),(358,7467782,7467771,'b3d',3.333,3),(358,7467783,7467771,'3d5',3.333,3),(358,7467784,7467771,'d5f',3.333,3),(358,7467785,7467771,'5f5',3.333,3),(358,7467786,7467771,'f52',3.333,3),(358,7467787,7467771,'525',3.333,3),(358,7467788,7467771,'25e',3.333,3),(358,7467789,7467771,'5e3',3.333,3),(358,7467790,7467771,'e35',3.333,3),(358,7467791,7467771,'35e',3.333,3),(358,7467792,7467771,'5e7',3.333,3),(358,7467793,7467771,'e73',3.333,3),(358,7467794,7467771,'73b',3.333,3),(358,7467795,7467771,'3b0',3.333,3),(358,7467796,7467771,'b01',3.333,3),(358,7467797,7467771,'014',3.333,3),(358,7467798,7467771,'141',3.333,3),(358,7467799,7467771,'41a',3.333,3),(358,7467800,7467771,'1a8',3.333,3),(358,7467801,7467771,'a8e',3.333,3),(358,7467802,7467772,'mon',100,1),(358,7467803,7467802,'201',50,1),(358,7467804,7467802,'013',50,1),(358,7467805,7467803,'adm',33.333,3),(358,7467806,7467803,'dmi',33.333,3),(358,7467807,7467803,'min',33.333,3),(358,7467808,7467805,'cap',16.667,1),(358,7467809,7467805,'apa',16.667,1),(358,7467810,7467805,'pac',16.667,1),(358,7467811,7467805,'aci',16.667,1),(358,7467812,7467805,'cit',16.667,1),(358,7467813,7467805,'ity',16.667,1),(358,7467814,7467808,'pat',50,1),(358,7467815,7467808,'ath',50,1),(358,7467816,7467814,'fre',14.286,1),(358,7467817,7467814,'ree',14.286,1),(358,7467818,7467814,'ees',14.286,1),(358,7467819,7467814,'esp',14.286,1),(358,7467820,7467814,'spa',14.286,1),(358,7467821,7467814,'pac',14.286,1),(358,7467822,7467814,'ace',14.286,1),(358,7467823,7467816,'dis',50,1),(358,7467824,7467816,'isk',50,1),(358,7467825,7467823,'ind',33.333,1),(358,7467826,7467823,'nde',33.333,1),(358,7467827,7467823,'dex',33.333,1),(358,7467828,7467825,'adm',8.333,1),(358,7467829,7467825,'dmi',8.333,1),(358,7467830,7467825,'min',8.333,1),(358,7467831,7467825,'ini',8.333,1),(358,7467832,7467825,'nis',8.333,1),(358,7467833,7467825,'ist',8.333,1),(358,7467834,7467825,'str',8.333,1),(358,7467835,7467825,'tra',8.333,1),(358,7467836,7467825,'rat',8.333,1),(358,7467837,7467825,'ati',8.333,1),(358,7467838,7467825,'tio',8.333,1),(358,7467839,7467825,'ion',8.333,1),(358,7467840,7467828,'sta',33.333,3),(358,7467841,7467828,'tat',33.333,3),(358,7467842,7467828,'ate',33.333,3),(358,7467843,7467840,'ena',20,2),(358,7467844,7467840,'nab',20,2),(358,7467845,7467840,'abl',20,2),(358,7467846,7467840,'ble',20,2),(358,7467847,7467840,'led',20,2),(358,7467848,7467843,'cac',33.333,1),(358,7467849,7467843,'ach',33.333,1),(358,7467850,7467843,'che',33.333,1),(358,7467851,7467848,'mod',50,2),(358,7467852,7467848,'ode',50,2),(358,7467853,7467851,'wri',14.286,2),(358,7467854,7467851,'rit',14.286,2),(358,7467855,7467851,'ite',14.286,2),(358,7467856,7467851,'tet',14.286,2),(358,7467857,7467851,'eth',14.286,2),(358,7467858,7467851,'thr',14.286,2),(358,7467859,7467851,'hru',14.286,2),(358,7467860,7467853,'ope',11.111,2),(358,7467861,7467853,'per',11.111,2),(358,7467862,7467853,'era',11.111,2),(358,7467863,7467853,'rat',11.111,2),(358,7467864,7467853,'ati',11.111,2),(358,7467865,7467853,'tio',11.111,2),(358,7467866,7467853,'ion',11.111,2),(358,7467867,7467853,'ona',11.111,2),(358,7467868,7467853,'nal',11.111,2),(358,7467869,7467860,'nor',25,1),(358,7467870,7467860,'orm',25,1),(358,7467871,7467860,'rma',25,1),(358,7467872,7467860,'mal',25,1),(358,7467873,7467869,'mes',20,1),(358,7467874,7467869,'ess',20,1),(358,7467875,7467869,'ssa',20,1),(358,7467876,7467869,'sag',20,1),(358,7467877,7467869,'age',20,1),(358,7467878,7467873,'per',11.111,1),(358,7467879,7467873,'erf',11.111,1),(358,7467880,7467873,'rfo',11.111,1),(358,7467881,7467873,'for',11.111,1),(358,7467882,7467873,'orm',11.111,1),(358,7467883,7467873,'rma',11.111,1),(358,7467884,7467873,'man',11.111,1),(358,7467885,7467873,'anc',11.111,1),(358,7467886,7467873,'nce',11.111,1),(358,7467887,7467878,'ide',12.5,1),(358,7467888,7467878,'den',12.5,1),(358,7467889,7467878,'ent',12.5,1),(358,7467890,7467878,'nti',12.5,1),(358,7467891,7467878,'tif',12.5,1),(358,7467892,7467878,'ifi',12.5,1),(358,7467893,7467878,'fie',12.5,1),(358,7467894,7467878,'ier',12.5,1),(358,7467895,7467887,'vdi',33.333,3),(358,7467896,7467887,'dis',33.333,3),(358,7467897,7467887,'isk',33.333,3),(358,7467898,7467895,'nam',50,1),(358,7467899,7467895,'ame',50,1),(358,7467900,7467898,'typ',50,1),(358,7467901,7467898,'ype',50,1),(358,7467902,7467900,'dir',25,1),(358,7467903,7467900,'ire',25,1),(358,7467904,7467900,'rec',25,1),(358,7467905,7467900,'ect',25,1),(359,7467907,7467906,'naa',100,2),(359,7467908,7467907,'600',3.333,3),(359,7467909,7467907,'000',3.333,3),(359,7467910,7467907,'00c',3.333,3),(359,7467911,7467907,'0c2',3.333,3),(359,7467912,7467907,'c29',3.333,3),(359,7467913,7467907,'29d',3.333,3),(359,7467914,7467907,'9d4',3.333,3),(359,7467915,7467907,'d49',3.333,3),(359,7467916,7467907,'497',3.333,3),(359,7467917,7467907,'979',3.333,3),(359,7467918,7467907,'798',3.333,3),(359,7467919,7467907,'984',3.333,3),(359,7467920,7467907,'84f',3.333,3),(359,7467921,7467907,'4f4',3.333,3),(359,7467922,7467907,'f47',3.333,3),(359,7467923,7467907,'472',3.333,3),(359,7467924,7467907,'722',3.333,3),(359,7467925,7467907,'22f',3.333,3),(359,7467926,7467907,'2f3',3.333,3),(359,7467927,7467907,'f3a',3.333,3),(359,7467928,7467907,'3ac',3.333,3),(359,7467929,7467907,'ac9',3.333,3),(359,7467930,7467907,'c9d',3.333,3),(359,7467931,7467907,'9dd',3.333,3),(359,7467932,7467907,'dd4',3.333,3),(359,7467933,7467907,'d47',3.333,3),(359,7467934,7467907,'476',3.333,3),(359,7467935,7467907,'76b',3.333,3),(359,7467936,7467907,'6b1',3.333,3),(359,7467937,7467907,'b19',3.333,3),(359,7467938,7467908,'mon',100,1),(359,7467939,7467938,'201',50,1),(359,7467940,7467938,'013',50,1),(359,7467941,7467939,'adm',33.333,3),(359,7467942,7467939,'dmi',33.333,3),(359,7467943,7467939,'min',33.333,3),(359,7467944,7467941,'cap',16.667,1),(359,7467945,7467941,'apa',16.667,1),(359,7467946,7467941,'pac',16.667,1),(359,7467947,7467941,'aci',16.667,1),(359,7467948,7467941,'cit',16.667,1),(359,7467949,7467941,'ity',16.667,1),(359,7467950,7467944,'pat',50,1),(359,7467951,7467944,'ath',50,1),(359,7467952,7467950,'fre',14.286,1),(359,7467953,7467950,'ree',14.286,1),(359,7467954,7467950,'ees',14.286,1),(359,7467955,7467950,'esp',14.286,1),(359,7467956,7467950,'spa',14.286,1),(359,7467957,7467950,'pac',14.286,1),(359,7467958,7467950,'ace',14.286,1),(359,7467959,7467952,'dis',50,1),(359,7467960,7467952,'isk',50,1),(359,7467961,7467959,'ind',33.333,1),(359,7467962,7467959,'nde',33.333,1),(359,7467963,7467959,'dex',33.333,1),(359,7467964,7467961,'adm',8.333,1),(359,7467965,7467961,'dmi',8.333,1),(359,7467966,7467961,'min',8.333,1),(359,7467967,7467961,'ini',8.333,1),(359,7467968,7467961,'nis',8.333,1),(359,7467969,7467961,'ist',8.333,1),(359,7467970,7467961,'str',8.333,1),(359,7467971,7467961,'tra',8.333,1),(359,7467972,7467961,'rat',8.333,1),(359,7467973,7467961,'ati',8.333,1),(359,7467974,7467961,'tio',8.333,1),(359,7467975,7467961,'ion',8.333,1),(359,7467976,7467964,'sta',33.333,3),(359,7467977,7467964,'tat',33.333,3),(359,7467978,7467964,'ate',33.333,3),(359,7467979,7467976,'ena',20,2),(359,7467980,7467976,'nab',20,2),(359,7467981,7467976,'abl',20,2),(359,7467982,7467976,'ble',20,2),(359,7467983,7467976,'led',20,2),(359,7467984,7467979,'cac',33.333,1),(359,7467985,7467979,'ach',33.333,1),(359,7467986,7467979,'che',33.333,1),(359,7467987,7467984,'mod',50,2),(359,7467988,7467984,'ode',50,2),(359,7467989,7467987,'wri',14.286,2),(359,7467990,7467987,'rit',14.286,2),(359,7467991,7467987,'ite',14.286,2),(359,7467992,7467987,'tet',14.286,2),(359,7467993,7467987,'eth',14.286,2),(359,7467994,7467987,'thr',14.286,2),(359,7467995,7467987,'hru',14.286,2),(359,7467996,7467989,'ope',11.111,2),(359,7467997,7467989,'per',11.111,2),(359,7467998,7467989,'era',11.111,2),(359,7467999,7467989,'rat',11.111,2),(359,7468000,7467989,'ati',11.111,2),(359,7468001,7467989,'tio',11.111,2),(359,7468002,7467989,'ion',11.111,2),(359,7468003,7467989,'ona',11.111,2),(359,7468004,7467989,'nal',11.111,2),(359,7468005,7467996,'nor',25,1),(359,7468006,7467996,'orm',25,1),(359,7468007,7467996,'rma',25,1),(359,7468008,7467996,'mal',25,1),(359,7468009,7468005,'mes',20,1),(359,7468010,7468005,'ess',20,1),(359,7468011,7468005,'ssa',20,1),(359,7468012,7468005,'sag',20,1),(359,7468013,7468005,'age',20,1),(359,7468014,7468009,'per',11.111,1),(359,7468015,7468009,'erf',11.111,1),(359,7468016,7468009,'rfo',11.111,1),(359,7468017,7468009,'for',11.111,1),(359,7468018,7468009,'orm',11.111,1),(359,7468019,7468009,'rma',11.111,1),(359,7468020,7468009,'man',11.111,1),(359,7468021,7468009,'anc',11.111,1),(359,7468022,7468009,'nce',11.111,1),(359,7468023,7468014,'ide',12.5,1),(359,7468024,7468014,'den',12.5,1),(359,7468025,7468014,'ent',12.5,1),(359,7468026,7468014,'nti',12.5,1),(359,7468027,7468014,'tif',12.5,1),(359,7468028,7468014,'ifi',12.5,1),(359,7468029,7468014,'fie',12.5,1),(359,7468030,7468014,'ier',12.5,1),(359,7468031,7468023,'vdi',33.333,3),(359,7468032,7468023,'dis',33.333,3),(359,7468033,7468023,'isk',33.333,3),(359,7468034,7468031,'nam',50,1),(359,7468035,7468031,'ame',50,1),(359,7468036,7468034,'typ',50,1),(359,7468037,7468034,'ype',50,1),(359,7468038,7468036,'dir',25,1),(359,7468039,7468036,'ire',25,1),(359,7468040,7468036,'rec',25,1),(359,7468041,7468036,'ect',25,1),(360,7468043,7468042,'naa',100,2),(360,7468044,7468043,'600',3.333,3),(360,7468045,7468043,'000',3.333,3),(360,7468046,7468043,'00c',3.333,3),(360,7468047,7468043,'0c2',3.333,3),(360,7468048,7468043,'c29',3.333,3),(360,7468049,7468043,'298',3.333,3),(360,7468050,7468043,'98c',3.333,3),(360,7468051,7468043,'8c4',3.333,3),(360,7468052,7468043,'c48',3.333,3),(360,7468053,7468043,'485',3.333,3),(360,7468054,7468043,'851',3.333,3),(360,7468055,7468043,'515',3.333,3),(360,7468056,7468043,'15e',3.333,3),(360,7468057,7468043,'5e7',3.333,3),(360,7468058,7468043,'e76',3.333,3),(360,7468059,7468043,'76c',3.333,3),(360,7468060,7468043,'6cb',3.333,3),(360,7468061,7468043,'cb4',3.333,3),(360,7468062,7468043,'b42',3.333,3),(360,7468063,7468043,'427',3.333,3),(360,7468064,7468043,'276',3.333,3),(360,7468065,7468043,'76a',3.333,3),(360,7468066,7468043,'6ac',3.333,3),(360,7468067,7468043,'acf',3.333,3),(360,7468068,7468043,'cf0',3.333,3),(360,7468069,7468043,'f0d',3.333,3),(360,7468070,7468043,'0d2',3.333,3),(360,7468071,7468043,'d25',3.333,3),(360,7468072,7468043,'25a',3.333,3),(360,7468073,7468043,'5ab',3.333,3),(360,7468074,7468044,'mon',100,1),(360,7468075,7468074,'201',50,1),(360,7468076,7468074,'013',50,1),(360,7468077,7468075,'adm',33.333,3),(360,7468078,7468075,'dmi',33.333,3),(360,7468079,7468075,'min',33.333,3),(360,7468080,7468077,'cap',16.667,1),(360,7468081,7468077,'apa',16.667,1),(360,7468082,7468077,'pac',16.667,1),(360,7468083,7468077,'aci',16.667,1),(360,7468084,7468077,'cit',16.667,1),(360,7468085,7468077,'ity',16.667,1),(360,7468086,7468080,'pat',50,1),(360,7468087,7468080,'ath',50,1),(360,7468088,7468086,'fre',14.286,1),(360,7468089,7468086,'ree',14.286,1),(360,7468090,7468086,'ees',14.286,1),(360,7468091,7468086,'esp',14.286,1),(360,7468092,7468086,'spa',14.286,1),(360,7468093,7468086,'pac',14.286,1),(360,7468094,7468086,'ace',14.286,1),(360,7468095,7468088,'dis',50,1),(360,7468096,7468088,'isk',50,1),(360,7468097,7468095,'ind',33.333,1),(360,7468098,7468095,'nde',33.333,1),(360,7468099,7468095,'dex',33.333,1),(360,7468100,7468097,'adm',8.333,1),(360,7468101,7468097,'dmi',8.333,1),(360,7468102,7468097,'min',8.333,1),(360,7468103,7468097,'ini',8.333,1),(360,7468104,7468097,'nis',8.333,1),(360,7468105,7468097,'ist',8.333,1),(360,7468106,7468097,'str',8.333,1),(360,7468107,7468097,'tra',8.333,1),(360,7468108,7468097,'rat',8.333,1),(360,7468109,7468097,'ati',8.333,1),(360,7468110,7468097,'tio',8.333,1),(360,7468111,7468097,'ion',8.333,1),(360,7468112,7468100,'sta',33.333,3),(360,7468113,7468100,'tat',33.333,3),(360,7468114,7468100,'ate',33.333,3),(360,7468115,7468112,'ena',20,2),(360,7468116,7468112,'nab',20,2),(360,7468117,7468112,'abl',20,2),(360,7468118,7468112,'ble',20,2),(360,7468119,7468112,'led',20,2),(360,7468120,7468115,'cac',33.333,1),(360,7468121,7468115,'ach',33.333,1),(360,7468122,7468115,'che',33.333,1),(360,7468123,7468120,'mod',50,2),(360,7468124,7468120,'ode',50,2),(360,7468125,7468123,'wri',14.286,2),(360,7468126,7468123,'rit',14.286,2),(360,7468127,7468123,'ite',14.286,2),(360,7468128,7468123,'tet',14.286,2),(360,7468129,7468123,'eth',14.286,2),(360,7468130,7468123,'thr',14.286,2),(360,7468131,7468123,'hru',14.286,2),(360,7468132,7468125,'ope',11.111,2),(360,7468133,7468125,'per',11.111,2),(360,7468134,7468125,'era',11.111,2),(360,7468135,7468125,'rat',11.111,2),(360,7468136,7468125,'ati',11.111,2),(360,7468137,7468125,'tio',11.111,2),(360,7468138,7468125,'ion',11.111,2),(360,7468139,7468125,'ona',11.111,2),(360,7468140,7468125,'nal',11.111,2),(360,7468141,7468132,'nor',25,1),(360,7468142,7468132,'orm',25,1),(360,7468143,7468132,'rma',25,1),(360,7468144,7468132,'mal',25,1),(360,7468145,7468141,'mes',20,1),(360,7468146,7468141,'ess',20,1),(360,7468147,7468141,'ssa',20,1),(360,7468148,7468141,'sag',20,1),(360,7468149,7468141,'age',20,1),(360,7468150,7468145,'per',11.111,1),(360,7468151,7468145,'erf',11.111,1),(360,7468152,7468145,'rfo',11.111,1),(360,7468153,7468145,'for',11.111,1),(360,7468154,7468145,'orm',11.111,1),(360,7468155,7468145,'rma',11.111,1),(360,7468156,7468145,'man',11.111,1),(360,7468157,7468145,'anc',11.111,1),(360,7468158,7468145,'nce',11.111,1),(360,7468159,7468150,'ide',12.5,1),(360,7468160,7468150,'den',12.5,1),(360,7468161,7468150,'ent',12.5,1),(360,7468162,7468150,'nti',12.5,1),(360,7468163,7468150,'tif',12.5,1),(360,7468164,7468150,'ifi',12.5,1),(360,7468165,7468150,'fie',12.5,1),(360,7468166,7468150,'ier',12.5,1),(360,7468167,7468159,'vdi',33.333,3),(360,7468168,7468159,'dis',33.333,3),(360,7468169,7468159,'isk',33.333,3),(360,7468170,7468167,'nam',50,1),(360,7468171,7468167,'ame',50,1),(360,7468172,7468170,'typ',50,1),(360,7468173,7468170,'ype',50,1),(360,7468174,7468172,'dir',25,1),(360,7468175,7468172,'ire',25,1),(360,7468176,7468172,'rec',25,1),(360,7468177,7468172,'ect',25,1),(361,7468179,7468178,'naa',100,2),(361,7468180,7468179,'600',3.333,3),(361,7468181,7468179,'000',3.333,3),(361,7468182,7468179,'00c',3.333,3),(361,7468183,7468179,'0c2',3.333,3),(361,7468184,7468179,'c29',3.333,3),(361,7468185,7468179,'29c',3.333,3),(361,7468186,7468179,'9cb',3.333,3),(361,7468187,7468179,'cb5',3.333,3),(361,7468188,7468179,'b55',3.333,3),(361,7468189,7468179,'55e',3.333,3),(361,7468190,7468179,'5e1',3.333,3),(361,7468191,7468179,'e1f',3.333,3),(361,7468192,7468179,'1f2',3.333,3),(361,7468193,7468179,'f2d',3.333,3),(361,7468194,7468179,'2d2',3.333,3),(361,7468195,7468179,'d29',3.333,3),(361,7468196,7468179,'29a',3.333,3),(361,7468197,7468179,'9a6',3.333,3),(361,7468198,7468179,'a6e',3.333,3),(361,7468199,7468179,'6ef',3.333,3),(361,7468200,7468179,'efd',3.333,3),(361,7468201,7468179,'fd5',3.333,3),(361,7468202,7468179,'d5f',3.333,3),(361,7468203,7468179,'5f2',3.333,3),(361,7468204,7468179,'f2d',3.333,3),(361,7468205,7468179,'2d4',3.333,3),(361,7468206,7468179,'d46',3.333,3),(361,7468207,7468179,'468',3.333,3),(361,7468208,7468179,'689',3.333,3),(361,7468209,7468179,'898',3.333,3),(361,7468210,7468180,'mon',100,1),(361,7468211,7468210,'201',50,1),(361,7468212,7468210,'013',50,1),(361,7468213,7468211,'adm',33.333,3),(361,7468214,7468211,'dmi',33.333,3),(361,7468215,7468211,'min',33.333,3),(361,7468216,7468213,'cap',16.667,1),(361,7468217,7468213,'apa',16.667,1),(361,7468218,7468213,'pac',16.667,1),(361,7468219,7468213,'aci',16.667,1),(361,7468220,7468213,'cit',16.667,1),(361,7468221,7468213,'ity',16.667,1),(361,7468222,7468216,'pat',50,1),(361,7468223,7468216,'ath',50,1),(361,7468224,7468222,'fre',14.286,1),(361,7468225,7468222,'ree',14.286,1),(361,7468226,7468222,'ees',14.286,1),(361,7468227,7468222,'esp',14.286,1),(361,7468228,7468222,'spa',14.286,1),(361,7468229,7468222,'pac',14.286,1),(361,7468230,7468222,'ace',14.286,1),(361,7468231,7468224,'dis',50,1),(361,7468232,7468224,'isk',50,1),(361,7468233,7468231,'ind',33.333,1),(361,7468234,7468231,'nde',33.333,1),(361,7468235,7468231,'dex',33.333,1),(361,7468236,7468233,'adm',8.333,1),(361,7468237,7468233,'dmi',8.333,1),(361,7468238,7468233,'min',8.333,1),(361,7468239,7468233,'ini',8.333,1),(361,7468240,7468233,'nis',8.333,1),(361,7468241,7468233,'ist',8.333,1),(361,7468242,7468233,'str',8.333,1),(361,7468243,7468233,'tra',8.333,1),(361,7468244,7468233,'rat',8.333,1),(361,7468245,7468233,'ati',8.333,1),(361,7468246,7468233,'tio',8.333,1),(361,7468247,7468233,'ion',8.333,1),(361,7468248,7468236,'sta',33.333,3),(361,7468249,7468236,'tat',33.333,3),(361,7468250,7468236,'ate',33.333,3),(361,7468251,7468248,'ena',20,2),(361,7468252,7468248,'nab',20,2),(361,7468253,7468248,'abl',20,2),(361,7468254,7468248,'ble',20,2),(361,7468255,7468248,'led',20,2),(361,7468256,7468251,'cac',33.333,1),(361,7468257,7468251,'ach',33.333,1),(361,7468258,7468251,'che',33.333,1),(361,7468259,7468256,'mod',50,2),(361,7468260,7468256,'ode',50,2),(361,7468261,7468259,'wri',14.286,2),(361,7468262,7468259,'rit',14.286,2),(361,7468263,7468259,'ite',14.286,2),(361,7468264,7468259,'tet',14.286,2),(361,7468265,7468259,'eth',14.286,2),(361,7468266,7468259,'thr',14.286,2),(361,7468267,7468259,'hru',14.286,2),(361,7468268,7468261,'ope',11.111,2),(361,7468269,7468261,'per',11.111,2),(361,7468270,7468261,'era',11.111,2),(361,7468271,7468261,'rat',11.111,2),(361,7468272,7468261,'ati',11.111,2),(361,7468273,7468261,'tio',11.111,2),(361,7468274,7468261,'ion',11.111,2),(361,7468275,7468261,'ona',11.111,2),(361,7468276,7468261,'nal',11.111,2),(361,7468277,7468268,'nor',25,1),(361,7468278,7468268,'orm',25,1),(361,7468279,7468268,'rma',25,1),(361,7468280,7468268,'mal',25,1),(361,7468281,7468277,'mes',20,1),(361,7468282,7468277,'ess',20,1),(361,7468283,7468277,'ssa',20,1),(361,7468284,7468277,'sag',20,1),(361,7468285,7468277,'age',20,1),(361,7468286,7468281,'per',11.111,1),(361,7468287,7468281,'erf',11.111,1),(361,7468288,7468281,'rfo',11.111,1),(361,7468289,7468281,'for',11.111,1),(361,7468290,7468281,'orm',11.111,1),(361,7468291,7468281,'rma',11.111,1),(361,7468292,7468281,'man',11.111,1),(361,7468293,7468281,'anc',11.111,1),(361,7468294,7468281,'nce',11.111,1),(361,7468295,7468286,'ide',12.5,1),(361,7468296,7468286,'den',12.5,1),(361,7468297,7468286,'ent',12.5,1),(361,7468298,7468286,'nti',12.5,1),(361,7468299,7468286,'tif',12.5,1),(361,7468300,7468286,'ifi',12.5,1),(361,7468301,7468286,'fie',12.5,1),(361,7468302,7468286,'ier',12.5,1),(361,7468303,7468295,'vdi',33.333,3),(361,7468304,7468295,'dis',33.333,3),(361,7468305,7468295,'isk',33.333,3),(361,7468306,7468303,'nam',50,1),(361,7468307,7468303,'ame',50,1),(361,7468308,7468306,'typ',50,1),(361,7468309,7468306,'ype',50,1),(361,7468310,7468308,'dir',25,1),(361,7468311,7468308,'ire',25,1),(361,7468312,7468308,'rec',25,1),(361,7468313,7468308,'ect',25,1),(362,7468315,7468314,'naa',100,2),(362,7468316,7468315,'600',3.333,3),(362,7468317,7468315,'000',3.333,3),(362,7468318,7468315,'00c',3.333,3),(362,7468319,7468315,'0c2',3.333,3),(362,7468320,7468315,'c29',3.333,3),(362,7468321,7468315,'29d',3.333,3),(362,7468322,7468315,'9d3',3.333,3),(362,7468323,7468315,'d3d',3.333,3),(362,7468324,7468315,'3d2',3.333,3),(362,7468325,7468315,'d23',3.333,3),(362,7468326,7468315,'23a',3.333,3),(362,7468327,7468315,'3a1',3.333,3),(362,7468328,7468315,'a13',3.333,3),(362,7468329,7468315,'134',3.333,3),(362,7468330,7468315,'343',3.333,3),(362,7468331,7468315,'432',3.333,3),(362,7468332,7468315,'327',3.333,3),(362,7468333,7468315,'27e',3.333,3),(362,7468334,7468315,'7ee',3.333,3),(362,7468335,7468315,'ee8',3.333,3),(362,7468336,7468315,'e85',3.333,3),(362,7468337,7468315,'853',3.333,3),(362,7468338,7468315,'536',3.333,3),(362,7468339,7468315,'362',3.333,3),(362,7468340,7468315,'627',3.333,3),(362,7468341,7468315,'278',3.333,3),(362,7468342,7468315,'78c',3.333,3),(362,7468343,7468315,'8c1',3.333,3),(362,7468344,7468315,'c13',3.333,3),(362,7468345,7468315,'134',3.333,3),(362,7468346,7468316,'mon',100,1),(362,7468347,7468346,'201',50,1),(362,7468348,7468346,'013',50,1),(362,7468349,7468347,'adm',33.333,3),(362,7468350,7468347,'dmi',33.333,3),(362,7468351,7468347,'min',33.333,3),(362,7468352,7468349,'cap',16.667,1),(362,7468353,7468349,'apa',16.667,1),(362,7468354,7468349,'pac',16.667,1),(362,7468355,7468349,'aci',16.667,1),(362,7468356,7468349,'cit',16.667,1),(362,7468357,7468349,'ity',16.667,1),(362,7468358,7468352,'pat',50,1),(362,7468359,7468352,'ath',50,1),(362,7468360,7468358,'fre',14.286,1),(362,7468361,7468358,'ree',14.286,1),(362,7468362,7468358,'ees',14.286,1),(362,7468363,7468358,'esp',14.286,1),(362,7468364,7468358,'spa',14.286,1),(362,7468365,7468358,'pac',14.286,1),(362,7468366,7468358,'ace',14.286,1),(362,7468367,7468360,'dis',50,1),(362,7468368,7468360,'isk',50,1),(362,7468369,7468367,'ind',33.333,1),(362,7468370,7468367,'nde',33.333,1),(362,7468371,7468367,'dex',33.333,1),(362,7468372,7468369,'adm',8.333,1),(362,7468373,7468369,'dmi',8.333,1),(362,7468374,7468369,'min',8.333,1),(362,7468375,7468369,'ini',8.333,1),(362,7468376,7468369,'nis',8.333,1),(362,7468377,7468369,'ist',8.333,1),(362,7468378,7468369,'str',8.333,1),(362,7468379,7468369,'tra',8.333,1),(362,7468380,7468369,'rat',8.333,1),(362,7468381,7468369,'ati',8.333,1),(362,7468382,7468369,'tio',8.333,1),(362,7468383,7468369,'ion',8.333,1),(362,7468384,7468372,'sta',33.333,3),(362,7468385,7468372,'tat',33.333,3),(362,7468386,7468372,'ate',33.333,3),(362,7468387,7468384,'ena',20,2),(362,7468388,7468384,'nab',20,2),(362,7468389,7468384,'abl',20,2),(362,7468390,7468384,'ble',20,2),(362,7468391,7468384,'led',20,2),(362,7468392,7468387,'cac',33.333,1),(362,7468393,7468387,'ach',33.333,1),(362,7468394,7468387,'che',33.333,1),(362,7468395,7468392,'mod',50,2),(362,7468396,7468392,'ode',50,2),(362,7468397,7468395,'wri',14.286,2),(362,7468398,7468395,'rit',14.286,2),(362,7468399,7468395,'ite',14.286,2),(362,7468400,7468395,'tet',14.286,2),(362,7468401,7468395,'eth',14.286,2),(362,7468402,7468395,'thr',14.286,2),(362,7468403,7468395,'hru',14.286,2),(362,7468404,7468397,'ope',11.111,2),(362,7468405,7468397,'per',11.111,2),(362,7468406,7468397,'era',11.111,2),(362,7468407,7468397,'rat',11.111,2),(362,7468408,7468397,'ati',11.111,2),(362,7468409,7468397,'tio',11.111,2),(362,7468410,7468397,'ion',11.111,2),(362,7468411,7468397,'ona',11.111,2),(362,7468412,7468397,'nal',11.111,2),(362,7468413,7468404,'nor',25,1),(362,7468414,7468404,'orm',25,1),(362,7468415,7468404,'rma',25,1),(362,7468416,7468404,'mal',25,1),(362,7468417,7468413,'mes',20,1),(362,7468418,7468413,'ess',20,1),(362,7468419,7468413,'ssa',20,1),(362,7468420,7468413,'sag',20,1),(362,7468421,7468413,'age',20,1),(362,7468422,7468417,'per',11.111,1),(362,7468423,7468417,'erf',11.111,1),(362,7468424,7468417,'rfo',11.111,1),(362,7468425,7468417,'for',11.111,1),(362,7468426,7468417,'orm',11.111,1),(362,7468427,7468417,'rma',11.111,1),(362,7468428,7468417,'man',11.111,1),(362,7468429,7468417,'anc',11.111,1),(362,7468430,7468417,'nce',11.111,1),(362,7468431,7468422,'ide',12.5,1),(362,7468432,7468422,'den',12.5,1),(362,7468433,7468422,'ent',12.5,1),(362,7468434,7468422,'nti',12.5,1),(362,7468435,7468422,'tif',12.5,1),(362,7468436,7468422,'ifi',12.5,1),(362,7468437,7468422,'fie',12.5,1),(362,7468438,7468422,'ier',12.5,1),(362,7468439,7468431,'vdi',33.333,3),(362,7468440,7468431,'dis',33.333,3),(362,7468441,7468431,'isk',33.333,3),(362,7468442,7468439,'nam',50,1),(362,7468443,7468439,'ame',50,1),(362,7468444,7468442,'typ',50,1),(362,7468445,7468442,'ype',50,1),(362,7468446,7468444,'dir',25,1),(362,7468447,7468444,'ire',25,1),(362,7468448,7468444,'rec',25,1),(362,7468449,7468444,'ect',25,1),(363,7468451,7468450,'naa',100,2),(363,7468452,7468451,'600',3.333,3),(363,7468453,7468451,'000',3.333,3),(363,7468454,7468451,'00c',3.333,3),(363,7468455,7468451,'0c2',3.333,3),(363,7468456,7468451,'c29',3.333,3),(363,7468457,7468451,'294',3.333,3),(363,7468458,7468451,'94b',3.333,3),(363,7468459,7468451,'4b1',3.333,3),(363,7468460,7468451,'b16',3.333,3),(363,7468461,7468451,'160',3.333,3),(363,7468462,7468451,'60f',3.333,3),(363,7468463,7468451,'0ff',3.333,3),(363,7468464,7468451,'ff1',3.333,3),(363,7468465,7468451,'f10',3.333,3),(363,7468466,7468451,'10b',3.333,3),(363,7468467,7468451,'0b8',3.333,3),(363,7468468,7468451,'b82',3.333,3),(363,7468469,7468451,'82c',3.333,3),(363,7468470,7468451,'2c3',3.333,3),(363,7468471,7468451,'c3b',3.333,3),(363,7468472,7468451,'3b3',3.333,3),(363,7468473,7468451,'b31',3.333,3),(363,7468474,7468451,'316',3.333,3),(363,7468475,7468451,'164',3.333,3),(363,7468476,7468451,'645',3.333,3),(363,7468477,7468451,'453',3.333,3),(363,7468478,7468451,'532',3.333,3),(363,7468479,7468451,'32f',3.333,3),(363,7468480,7468451,'2f5',3.333,3),(363,7468481,7468451,'f5c',3.333,3),(363,7468482,7468452,'mon',100,1),(363,7468483,7468482,'201',50,1),(363,7468484,7468482,'013',50,1),(363,7468485,7468483,'adm',33.333,3),(363,7468486,7468483,'dmi',33.333,3),(363,7468487,7468483,'min',33.333,3),(363,7468488,7468485,'cap',16.667,1),(363,7468489,7468485,'apa',16.667,1),(363,7468490,7468485,'pac',16.667,1),(363,7468491,7468485,'aci',16.667,1),(363,7468492,7468485,'cit',16.667,1),(363,7468493,7468485,'ity',16.667,1),(363,7468494,7468488,'pat',50,1),(363,7468495,7468488,'ath',50,1),(363,7468496,7468494,'fre',14.286,1),(363,7468497,7468494,'ree',14.286,1),(363,7468498,7468494,'ees',14.286,1),(363,7468499,7468494,'esp',14.286,1),(363,7468500,7468494,'spa',14.286,1),(363,7468501,7468494,'pac',14.286,1),(363,7468502,7468494,'ace',14.286,1),(363,7468503,7468496,'dis',50,1),(363,7468504,7468496,'isk',50,1),(363,7468505,7468503,'ind',33.333,1),(363,7468506,7468503,'nde',33.333,1),(363,7468507,7468503,'dex',33.333,1),(363,7468508,7468505,'adm',8.333,1),(363,7468509,7468505,'dmi',8.333,1),(363,7468510,7468505,'min',8.333,1),(363,7468511,7468505,'ini',8.333,1),(363,7468512,7468505,'nis',8.333,1),(363,7468513,7468505,'ist',8.333,1),(363,7468514,7468505,'str',8.333,1),(363,7468515,7468505,'tra',8.333,1),(363,7468516,7468505,'rat',8.333,1),(363,7468517,7468505,'ati',8.333,1),(363,7468518,7468505,'tio',8.333,1),(363,7468519,7468505,'ion',8.333,1),(363,7468520,7468508,'sta',33.333,3),(363,7468521,7468508,'tat',33.333,3),(363,7468522,7468508,'ate',33.333,3),(363,7468523,7468520,'ena',20,2),(363,7468524,7468520,'nab',20,2),(363,7468525,7468520,'abl',20,2),(363,7468526,7468520,'ble',20,2),(363,7468527,7468520,'led',20,2),(363,7468528,7468523,'cac',33.333,1),(363,7468529,7468523,'ach',33.333,1),(363,7468530,7468523,'che',33.333,1),(363,7468531,7468528,'mod',50,2),(363,7468532,7468528,'ode',50,2),(363,7468533,7468531,'wri',14.286,2),(363,7468534,7468531,'rit',14.286,2),(363,7468535,7468531,'ite',14.286,2),(363,7468536,7468531,'tet',14.286,2),(363,7468537,7468531,'eth',14.286,2),(363,7468538,7468531,'thr',14.286,2),(363,7468539,7468531,'hru',14.286,2),(363,7468540,7468533,'ope',11.111,2),(363,7468541,7468533,'per',11.111,2),(363,7468542,7468533,'era',11.111,2),(363,7468543,7468533,'rat',11.111,2),(363,7468544,7468533,'ati',11.111,2),(363,7468545,7468533,'tio',11.111,2),(363,7468546,7468533,'ion',11.111,2),(363,7468547,7468533,'ona',11.111,2),(363,7468548,7468533,'nal',11.111,2),(363,7468549,7468540,'nor',25,1),(363,7468550,7468540,'orm',25,1),(363,7468551,7468540,'rma',25,1),(363,7468552,7468540,'mal',25,1),(363,7468553,7468549,'mes',20,1),(363,7468554,7468549,'ess',20,1),(363,7468555,7468549,'ssa',20,1),(363,7468556,7468549,'sag',20,1),(363,7468557,7468549,'age',20,1),(363,7468558,7468553,'per',11.111,1),(363,7468559,7468553,'erf',11.111,1),(363,7468560,7468553,'rfo',11.111,1),(363,7468561,7468553,'for',11.111,1),(363,7468562,7468553,'orm',11.111,1),(363,7468563,7468553,'rma',11.111,1),(363,7468564,7468553,'man',11.111,1),(363,7468565,7468553,'anc',11.111,1),(363,7468566,7468553,'nce',11.111,1),(363,7468567,7468558,'ide',12.5,1),(363,7468568,7468558,'den',12.5,1),(363,7468569,7468558,'ent',12.5,1),(363,7468570,7468558,'nti',12.5,1),(363,7468571,7468558,'tif',12.5,1),(363,7468572,7468558,'ifi',12.5,1),(363,7468573,7468558,'fie',12.5,1),(363,7468574,7468558,'ier',12.5,1),(363,7468575,7468567,'vdi',33.333,3),(363,7468576,7468567,'dis',33.333,3),(363,7468577,7468567,'isk',33.333,3),(363,7468578,7468575,'nam',50,1),(363,7468579,7468575,'ame',50,1),(363,7468580,7468578,'typ',50,1),(363,7468581,7468578,'ype',50,1),(363,7468582,7468580,'dir',25,1),(363,7468583,7468580,'ire',25,1),(363,7468584,7468580,'rec',25,1),(363,7468585,7468580,'ect',25,1),(364,7468587,7468586,'naa',100,2),(364,7468588,7468587,'600',3.333,3),(364,7468589,7468587,'000',3.333,3),(364,7468590,7468587,'00c',3.333,3),(364,7468591,7468587,'0c2',3.333,3),(364,7468592,7468587,'c29',3.333,3),(364,7468593,7468587,'297',3.333,3),(364,7468594,7468587,'97c',3.333,3),(364,7468595,7468587,'7cd',3.333,3),(364,7468596,7468587,'cdc',3.333,3),(364,7468597,7468587,'dc7',3.333,3),(364,7468598,7468587,'c78',3.333,3),(364,7468599,7468587,'780',3.333,3),(364,7468600,7468587,'80e',3.333,3),(364,7468601,7468587,'0e3',3.333,3),(364,7468602,7468587,'e3c',3.333,3),(364,7468603,7468587,'3c1',3.333,3),(364,7468604,7468587,'c13',3.333,3),(364,7468605,7468587,'13e',3.333,3),(364,7468606,7468587,'3ee',3.333,3),(364,7468607,7468587,'ee5',3.333,3),(364,7468608,7468587,'e56',3.333,3),(364,7468609,7468587,'563',3.333,3),(364,7468610,7468587,'63f',3.333,3),(364,7468611,7468587,'3f2',3.333,3),(364,7468612,7468587,'f29',3.333,3),(364,7468613,7468587,'29d',3.333,3),(364,7468614,7468587,'9dc',3.333,3),(364,7468615,7468587,'dc5',3.333,3),(364,7468616,7468587,'c51',3.333,3),(364,7468617,7468587,'515',3.333,3),(364,7468618,7468588,'mon',100,1),(364,7468619,7468618,'201',50,1),(364,7468620,7468618,'013',50,1),(364,7468621,7468619,'adm',33.333,3),(364,7468622,7468619,'dmi',33.333,3),(364,7468623,7468619,'min',33.333,3),(364,7468624,7468621,'cap',16.667,1),(364,7468625,7468621,'apa',16.667,1),(364,7468626,7468621,'pac',16.667,1),(364,7468627,7468621,'aci',16.667,1),(364,7468628,7468621,'cit',16.667,1),(364,7468629,7468621,'ity',16.667,1),(364,7468630,7468624,'pat',50,1),(364,7468631,7468624,'ath',50,1),(364,7468632,7468630,'fre',14.286,1),(364,7468633,7468630,'ree',14.286,1),(364,7468634,7468630,'ees',14.286,1),(364,7468635,7468630,'esp',14.286,1),(364,7468636,7468630,'spa',14.286,1),(364,7468637,7468630,'pac',14.286,1),(364,7468638,7468630,'ace',14.286,1),(364,7468639,7468632,'dis',50,1),(364,7468640,7468632,'isk',50,1),(364,7468641,7468639,'ind',33.333,1),(364,7468642,7468639,'nde',33.333,1),(364,7468643,7468639,'dex',33.333,1),(364,7468644,7468641,'adm',8.333,1),(364,7468645,7468641,'dmi',8.333,1),(364,7468646,7468641,'min',8.333,1),(364,7468647,7468641,'ini',8.333,1),(364,7468648,7468641,'nis',8.333,1),(364,7468649,7468641,'ist',8.333,1),(364,7468650,7468641,'str',8.333,1),(364,7468651,7468641,'tra',8.333,1),(364,7468652,7468641,'rat',8.333,1),(364,7468653,7468641,'ati',8.333,1),(364,7468654,7468641,'tio',8.333,1),(364,7468655,7468641,'ion',8.333,1),(364,7468656,7468644,'sta',33.333,3),(364,7468657,7468644,'tat',33.333,3),(364,7468658,7468644,'ate',33.333,3),(364,7468659,7468656,'ena',20,2),(364,7468660,7468656,'nab',20,2),(364,7468661,7468656,'abl',20,2),(364,7468662,7468656,'ble',20,2),(364,7468663,7468656,'led',20,2),(364,7468664,7468659,'cac',33.333,1),(364,7468665,7468659,'ach',33.333,1),(364,7468666,7468659,'che',33.333,1),(364,7468667,7468664,'mod',50,2),(364,7468668,7468664,'ode',50,2),(364,7468669,7468667,'wri',14.286,2),(364,7468670,7468667,'rit',14.286,2),(364,7468671,7468667,'ite',14.286,2),(364,7468672,7468667,'tet',14.286,2),(364,7468673,7468667,'eth',14.286,2),(364,7468674,7468667,'thr',14.286,2),(364,7468675,7468667,'hru',14.286,2),(364,7468676,7468669,'ope',11.111,2),(364,7468677,7468669,'per',11.111,2),(364,7468678,7468669,'era',11.111,2),(364,7468679,7468669,'rat',11.111,2),(364,7468680,7468669,'ati',11.111,2),(364,7468681,7468669,'tio',11.111,2),(364,7468682,7468669,'ion',11.111,2),(364,7468683,7468669,'ona',11.111,2),(364,7468684,7468669,'nal',11.111,2),(364,7468685,7468676,'nor',25,1),(364,7468686,7468676,'orm',25,1),(364,7468687,7468676,'rma',25,1),(364,7468688,7468676,'mal',25,1),(364,7468689,7468685,'mes',20,1),(364,7468690,7468685,'ess',20,1),(364,7468691,7468685,'ssa',20,1),(364,7468692,7468685,'sag',20,1),(364,7468693,7468685,'age',20,1),(364,7468694,7468689,'per',11.111,1),(364,7468695,7468689,'erf',11.111,1),(364,7468696,7468689,'rfo',11.111,1),(364,7468697,7468689,'for',11.111,1),(364,7468698,7468689,'orm',11.111,1),(364,7468699,7468689,'rma',11.111,1),(364,7468700,7468689,'man',11.111,1),(364,7468701,7468689,'anc',11.111,1),(364,7468702,7468689,'nce',11.111,1),(364,7468703,7468694,'ide',12.5,1),(364,7468704,7468694,'den',12.5,1),(364,7468705,7468694,'ent',12.5,1),(364,7468706,7468694,'nti',12.5,1),(364,7468707,7468694,'tif',12.5,1),(364,7468708,7468694,'ifi',12.5,1),(364,7468709,7468694,'fie',12.5,1),(364,7468710,7468694,'ier',12.5,1),(364,7468711,7468703,'vdi',33.333,3),(364,7468712,7468703,'dis',33.333,3),(364,7468713,7468703,'isk',33.333,3),(364,7468714,7468711,'nam',50,1),(364,7468715,7468711,'ame',50,1),(364,7468716,7468714,'typ',50,1),(364,7468717,7468714,'ype',50,1),(364,7468718,7468716,'dir',25,1),(364,7468719,7468716,'ire',25,1),(364,7468720,7468716,'rec',25,1),(364,7468721,7468716,'ect',25,1),(365,7468723,7468722,'naa',100,2),(365,7468724,7468723,'600',3.333,3),(365,7468725,7468723,'000',3.333,3),(365,7468726,7468723,'00c',3.333,3),(365,7468727,7468723,'0c2',3.333,3),(365,7468728,7468723,'c29',3.333,3),(365,7468729,7468723,'29f',3.333,3),(365,7468730,7468723,'9fe',3.333,3),(365,7468731,7468723,'fe7',3.333,3),(365,7468732,7468723,'e77',3.333,3),(365,7468733,7468723,'774',3.333,3),(365,7468734,7468723,'749',3.333,3),(365,7468735,7468723,'494',3.333,3),(365,7468736,7468723,'94a',3.333,3),(365,7468737,7468723,'4a3',3.333,3),(365,7468738,7468723,'a31',3.333,3),(365,7468739,7468723,'31a',3.333,3),(365,7468740,7468723,'1a5',3.333,3),(365,7468741,7468723,'a50',3.333,3),(365,7468742,7468723,'50f',3.333,3),(365,7468743,7468723,'0f7',3.333,3),(365,7468744,7468723,'f7f',3.333,3),(365,7468745,7468723,'7fb',3.333,3),(365,7468746,7468723,'fb7',3.333,3),(365,7468747,7468723,'b70',3.333,3),(365,7468748,7468723,'700',3.333,3),(365,7468749,7468723,'00f',3.333,3),(365,7468750,7468723,'0fd',3.333,3),(365,7468751,7468723,'fd7',3.333,3),(365,7468752,7468723,'d79',3.333,3),(365,7468753,7468723,'794',3.333,3),(365,7468754,7468724,'mon',100,1),(365,7468755,7468754,'201',50,1),(365,7468756,7468754,'013',50,1),(365,7468757,7468755,'adm',33.333,3),(365,7468758,7468755,'dmi',33.333,3),(365,7468759,7468755,'min',33.333,3),(365,7468760,7468757,'cap',16.667,1),(365,7468761,7468757,'apa',16.667,1),(365,7468762,7468757,'pac',16.667,1),(365,7468763,7468757,'aci',16.667,1),(365,7468764,7468757,'cit',16.667,1),(365,7468765,7468757,'ity',16.667,1),(365,7468766,7468760,'pat',50,1),(365,7468767,7468760,'ath',50,1),(365,7468768,7468766,'fre',14.286,1),(365,7468769,7468766,'ree',14.286,1),(365,7468770,7468766,'ees',14.286,1),(365,7468771,7468766,'esp',14.286,1),(365,7468772,7468766,'spa',14.286,1),(365,7468773,7468766,'pac',14.286,1),(365,7468774,7468766,'ace',14.286,1),(365,7468775,7468768,'dis',50,1),(365,7468776,7468768,'isk',50,1),(365,7468777,7468775,'ind',33.333,1),(365,7468778,7468775,'nde',33.333,1),(365,7468779,7468775,'dex',33.333,1),(365,7468780,7468777,'adm',8.333,1),(365,7468781,7468777,'dmi',8.333,1),(365,7468782,7468777,'min',8.333,1),(365,7468783,7468777,'ini',8.333,1),(365,7468784,7468777,'nis',8.333,1),(365,7468785,7468777,'ist',8.333,1),(365,7468786,7468777,'str',8.333,1),(365,7468787,7468777,'tra',8.333,1),(365,7468788,7468777,'rat',8.333,1),(365,7468789,7468777,'ati',8.333,1),(365,7468790,7468777,'tio',8.333,1),(365,7468791,7468777,'ion',8.333,1),(365,7468792,7468780,'sta',33.333,3),(365,7468793,7468780,'tat',33.333,3),(365,7468794,7468780,'ate',33.333,3),(365,7468795,7468792,'ena',20,2),(365,7468796,7468792,'nab',20,2),(365,7468797,7468792,'abl',20,2),(365,7468798,7468792,'ble',20,2),(365,7468799,7468792,'led',20,2),(365,7468800,7468795,'cac',33.333,1),(365,7468801,7468795,'ach',33.333,1),(365,7468802,7468795,'che',33.333,1),(365,7468803,7468800,'mod',50,2),(365,7468804,7468800,'ode',50,2),(365,7468805,7468803,'wri',14.286,2),(365,7468806,7468803,'rit',14.286,2),(365,7468807,7468803,'ite',14.286,2),(365,7468808,7468803,'tet',14.286,2),(365,7468809,7468803,'eth',14.286,2),(365,7468810,7468803,'thr',14.286,2),(365,7468811,7468803,'hru',14.286,2),(365,7468812,7468805,'ope',11.111,2),(365,7468813,7468805,'per',11.111,2),(365,7468814,7468805,'era',11.111,2),(365,7468815,7468805,'rat',11.111,2),(365,7468816,7468805,'ati',11.111,2),(365,7468817,7468805,'tio',11.111,2),(365,7468818,7468805,'ion',11.111,2),(365,7468819,7468805,'ona',11.111,2),(365,7468820,7468805,'nal',11.111,2),(365,7468821,7468812,'nor',25,1),(365,7468822,7468812,'orm',25,1),(365,7468823,7468812,'rma',25,1),(365,7468824,7468812,'mal',25,1),(365,7468825,7468821,'mes',20,1),(365,7468826,7468821,'ess',20,1),(365,7468827,7468821,'ssa',20,1),(365,7468828,7468821,'sag',20,1),(365,7468829,7468821,'age',20,1),(365,7468830,7468825,'per',11.111,1),(365,7468831,7468825,'erf',11.111,1),(365,7468832,7468825,'rfo',11.111,1),(365,7468833,7468825,'for',11.111,1),(365,7468834,7468825,'orm',11.111,1),(365,7468835,7468825,'rma',11.111,1),(365,7468836,7468825,'man',11.111,1),(365,7468837,7468825,'anc',11.111,1),(365,7468838,7468825,'nce',11.111,1),(365,7468839,7468830,'ide',12.5,1),(365,7468840,7468830,'den',12.5,1),(365,7468841,7468830,'ent',12.5,1),(365,7468842,7468830,'nti',12.5,1),(365,7468843,7468830,'tif',12.5,1),(365,7468844,7468830,'ifi',12.5,1),(365,7468845,7468830,'fie',12.5,1),(365,7468846,7468830,'ier',12.5,1),(365,7468847,7468839,'vdi',33.333,3),(365,7468848,7468839,'dis',33.333,3),(365,7468849,7468839,'isk',33.333,3),(365,7468850,7468847,'nam',50,1),(365,7468851,7468847,'ame',50,1),(365,7468852,7468850,'typ',50,1),(365,7468853,7468850,'ype',50,1),(365,7468854,7468852,'dir',25,1),(365,7468855,7468852,'ire',25,1),(365,7468856,7468852,'rec',25,1),(365,7468857,7468852,'ect',25,1),(366,7468859,7468858,'naa',100,2),(366,7468860,7468859,'600',3.333,3),(366,7468861,7468859,'000',3.333,3),(366,7468862,7468859,'00c',3.333,3),(366,7468863,7468859,'0c2',3.333,3),(366,7468864,7468859,'c29',3.333,3),(366,7468865,7468859,'296',3.333,3),(366,7468866,7468859,'961',3.333,3),(366,7468867,7468859,'61a',3.333,3),(366,7468868,7468859,'1aa',3.333,3),(366,7468869,7468859,'aac',3.333,3),(366,7468870,7468859,'ac2',3.333,3),(366,7468871,7468859,'c25',3.333,3),(366,7468872,7468859,'254',3.333,3),(366,7468873,7468859,'54c',3.333,3),(366,7468874,7468859,'4c5',3.333,3),(366,7468875,7468859,'c50',3.333,3),(366,7468876,7468859,'504',3.333,3),(366,7468877,7468859,'04c',3.333,3),(366,7468878,7468859,'4c6',3.333,3),(366,7468879,7468859,'c6d',3.333,3),(366,7468880,7468859,'6d6',3.333,3),(366,7468881,7468859,'d67',3.333,3),(366,7468882,7468859,'67e',3.333,3),(366,7468883,7468859,'7ec',3.333,3),(366,7468884,7468859,'ecb',3.333,3),(366,7468885,7468859,'cb5',3.333,3),(366,7468886,7468859,'b5f',3.333,3),(366,7468887,7468859,'5f8',3.333,3),(366,7468888,7468859,'f8a',3.333,3),(366,7468889,7468859,'8ac',3.333,3),(366,7468890,7468860,'mon',100,1),(366,7468891,7468890,'201',50,1),(366,7468892,7468890,'013',50,1),(366,7468893,7468891,'adm',33.333,3),(366,7468894,7468891,'dmi',33.333,3),(366,7468895,7468891,'min',33.333,3),(366,7468896,7468893,'cap',16.667,1),(366,7468897,7468893,'apa',16.667,1),(366,7468898,7468893,'pac',16.667,1),(366,7468899,7468893,'aci',16.667,1),(366,7468900,7468893,'cit',16.667,1),(366,7468901,7468893,'ity',16.667,1),(366,7468902,7468896,'pat',50,1),(366,7468903,7468896,'ath',50,1),(366,7468904,7468902,'one',100,1),(366,7468905,7468904,'fre',14.286,1),(366,7468906,7468904,'ree',14.286,1),(366,7468907,7468904,'ees',14.286,1),(366,7468908,7468904,'esp',14.286,1),(366,7468909,7468904,'spa',14.286,1),(366,7468910,7468904,'pac',14.286,1),(366,7468911,7468904,'ace',14.286,1),(366,7468912,7468905,'dis',50,1),(366,7468913,7468905,'isk',50,1),(366,7468914,7468912,'ind',33.333,1),(366,7468915,7468912,'nde',33.333,1),(366,7468916,7468912,'dex',33.333,1),(366,7468917,7468914,'adm',8.333,1),(366,7468918,7468914,'dmi',8.333,1),(366,7468919,7468914,'min',8.333,1),(366,7468920,7468914,'ini',8.333,1),(366,7468921,7468914,'nis',8.333,1),(366,7468922,7468914,'ist',8.333,1),(366,7468923,7468914,'str',8.333,1),(366,7468924,7468914,'tra',8.333,1),(366,7468925,7468914,'rat',8.333,1),(366,7468926,7468914,'ati',8.333,1),(366,7468927,7468914,'tio',8.333,1),(366,7468928,7468914,'ion',8.333,1),(366,7468929,7468917,'sta',33.333,3),(366,7468930,7468917,'tat',33.333,3),(366,7468931,7468917,'ate',33.333,3),(366,7468932,7468929,'ena',20,2),(366,7468933,7468929,'nab',20,2),(366,7468934,7468929,'abl',20,2),(366,7468935,7468929,'ble',20,2),(366,7468936,7468929,'led',20,2),(366,7468937,7468932,'cac',33.333,1),(366,7468938,7468932,'ach',33.333,1),(366,7468939,7468932,'che',33.333,1),(366,7468940,7468937,'mod',50,2),(366,7468941,7468937,'ode',50,2),(366,7468942,7468940,'wri',14.286,2),(366,7468943,7468940,'rit',14.286,2),(366,7468944,7468940,'ite',14.286,2),(366,7468945,7468940,'tet',14.286,2),(366,7468946,7468940,'eth',14.286,2),(366,7468947,7468940,'thr',14.286,2),(366,7468948,7468940,'hru',14.286,2),(366,7468949,7468942,'ope',11.111,2),(366,7468950,7468942,'per',11.111,2),(366,7468951,7468942,'era',11.111,2),(366,7468952,7468942,'rat',11.111,2),(366,7468953,7468942,'ati',11.111,2),(366,7468954,7468942,'tio',11.111,2),(366,7468955,7468942,'ion',11.111,2),(366,7468956,7468942,'ona',11.111,2),(366,7468957,7468942,'nal',11.111,2),(366,7468958,7468949,'nor',25,1),(366,7468959,7468949,'orm',25,1),(366,7468960,7468949,'rma',25,1),(366,7468961,7468949,'mal',25,1),(366,7468962,7468958,'mes',20,1),(366,7468963,7468958,'ess',20,1),(366,7468964,7468958,'ssa',20,1),(366,7468965,7468958,'sag',20,1),(366,7468966,7468958,'age',20,1),(366,7468967,7468962,'per',11.111,1),(366,7468968,7468962,'erf',11.111,1),(366,7468969,7468962,'rfo',11.111,1),(366,7468970,7468962,'for',11.111,1),(366,7468971,7468962,'orm',11.111,1),(366,7468972,7468962,'rma',11.111,1),(366,7468973,7468962,'man',11.111,1),(366,7468974,7468962,'anc',11.111,1),(366,7468975,7468962,'nce',11.111,1),(366,7468976,7468967,'ide',12.5,1),(366,7468977,7468967,'den',12.5,1),(366,7468978,7468967,'ent',12.5,1),(366,7468979,7468967,'nti',12.5,1),(366,7468980,7468967,'tif',12.5,1),(366,7468981,7468967,'ifi',12.5,1),(366,7468982,7468967,'fie',12.5,1),(366,7468983,7468967,'ier',12.5,1),(366,7468984,7468976,'vdi',33.333,3),(366,7468985,7468976,'dis',33.333,3),(366,7468986,7468976,'isk',33.333,3),(366,7468987,7468984,'nam',50,1),(366,7468988,7468984,'ame',50,1),(366,7468989,7468987,'typ',50,1),(366,7468990,7468987,'ype',50,1),(366,7468991,7468989,'dir',25,1),(366,7468992,7468989,'ire',25,1),(366,7468993,7468989,'rec',25,1),(366,7468994,7468989,'ect',25,1),(367,7468996,7468995,'naa',100,2),(367,7468997,7468996,'600',3.333,3),(367,7468998,7468996,'000',3.333,3),(367,7468999,7468996,'00c',3.333,3),(367,7469000,7468996,'0c2',3.333,3),(367,7469001,7468996,'c29',3.333,3),(367,7469002,7468996,'29e',3.333,3),(367,7469003,7468996,'9e2',3.333,3),(367,7469004,7468996,'e27',3.333,3),(367,7469005,7468996,'279',3.333,3),(367,7469006,7468996,'79d',3.333,3),(367,7469007,7468996,'9da',3.333,3),(367,7469008,7468996,'da2',3.333,3),(367,7469009,7468996,'a2c',3.333,3),(367,7469010,7468996,'2c2',3.333,3),(367,7469011,7468996,'c2e',3.333,3),(367,7469012,7468996,'2ed',3.333,3),(367,7469013,7468996,'ed1',3.333,3),(367,7469014,7468996,'d11',3.333,3),(367,7469015,7468996,'11b',3.333,3),(367,7469016,7468996,'1b7',3.333,3),(367,7469017,7468996,'b70',3.333,3),(367,7469018,7468996,'70e',3.333,3),(367,7469019,7468996,'0ea',3.333,3),(367,7469020,7468996,'ea5',3.333,3),(367,7469021,7468996,'a5d',3.333,3),(367,7469022,7468996,'5d8',3.333,3),(367,7469023,7468996,'d8c',3.333,3),(367,7469024,7468996,'8c5',3.333,3),(367,7469025,7468996,'c56',3.333,3),(367,7469026,7468996,'56a',3.333,3),(367,7469027,7468997,'mon',100,1),(367,7469028,7469027,'201',50,1),(367,7469029,7469027,'013',50,1),(367,7469030,7469028,'adm',33.333,3),(367,7469031,7469028,'dmi',33.333,3),(367,7469032,7469028,'min',33.333,3),(367,7469033,7469030,'cap',16.667,1),(367,7469034,7469030,'apa',16.667,1),(367,7469035,7469030,'pac',16.667,1),(367,7469036,7469030,'aci',16.667,1),(367,7469037,7469030,'cit',16.667,1),(367,7469038,7469030,'ity',16.667,1),(367,7469039,7469033,'pat',50,1),(367,7469040,7469033,'ath',50,1),(367,7469041,7469039,'thr',33.333,1),(367,7469042,7469039,'hre',33.333,1),(367,7469043,7469039,'ree',33.333,1),(367,7469044,7469041,'fre',14.286,1),(367,7469045,7469041,'ree',14.286,1),(367,7469046,7469041,'ees',14.286,1),(367,7469047,7469041,'esp',14.286,1),(367,7469048,7469041,'spa',14.286,1),(367,7469049,7469041,'pac',14.286,1),(367,7469050,7469041,'ace',14.286,1),(367,7469051,7469044,'dis',50,1),(367,7469052,7469044,'isk',50,1),(367,7469053,7469051,'ind',33.333,1),(367,7469054,7469051,'nde',33.333,1),(367,7469055,7469051,'dex',33.333,1),(367,7469056,7469053,'adm',8.333,1),(367,7469057,7469053,'dmi',8.333,1),(367,7469058,7469053,'min',8.333,1),(367,7469059,7469053,'ini',8.333,1),(367,7469060,7469053,'nis',8.333,1),(367,7469061,7469053,'ist',8.333,1),(367,7469062,7469053,'str',8.333,1),(367,7469063,7469053,'tra',8.333,1),(367,7469064,7469053,'rat',8.333,1),(367,7469065,7469053,'ati',8.333,1),(367,7469066,7469053,'tio',8.333,1),(367,7469067,7469053,'ion',8.333,1),(367,7469068,7469056,'sta',33.333,3),(367,7469069,7469056,'tat',33.333,3),(367,7469070,7469056,'ate',33.333,3),(367,7469071,7469068,'ena',20,2),(367,7469072,7469068,'nab',20,2),(367,7469073,7469068,'abl',20,2),(367,7469074,7469068,'ble',20,2),(367,7469075,7469068,'led',20,2),(367,7469076,7469071,'cac',33.333,1),(367,7469077,7469071,'ach',33.333,1),(367,7469078,7469071,'che',33.333,1),(367,7469079,7469076,'mod',50,2),(367,7469080,7469076,'ode',50,2),(367,7469081,7469079,'wri',14.286,2),(367,7469082,7469079,'rit',14.286,2),(367,7469083,7469079,'ite',14.286,2),(367,7469084,7469079,'tet',14.286,2),(367,7469085,7469079,'eth',14.286,2),(367,7469086,7469079,'thr',14.286,2),(367,7469087,7469079,'hru',14.286,2),(367,7469088,7469081,'ope',11.111,2),(367,7469089,7469081,'per',11.111,2),(367,7469090,7469081,'era',11.111,2),(367,7469091,7469081,'rat',11.111,2),(367,7469092,7469081,'ati',11.111,2),(367,7469093,7469081,'tio',11.111,2),(367,7469094,7469081,'ion',11.111,2),(367,7469095,7469081,'ona',11.111,2),(367,7469096,7469081,'nal',11.111,2),(367,7469097,7469088,'nor',25,1),(367,7469098,7469088,'orm',25,1),(367,7469099,7469088,'rma',25,1),(367,7469100,7469088,'mal',25,1),(367,7469101,7469097,'mes',20,1),(367,7469102,7469097,'ess',20,1),(367,7469103,7469097,'ssa',20,1),(367,7469104,7469097,'sag',20,1),(367,7469105,7469097,'age',20,1),(367,7469106,7469101,'per',11.111,1),(367,7469107,7469101,'erf',11.111,1),(367,7469108,7469101,'rfo',11.111,1),(367,7469109,7469101,'for',11.111,1),(367,7469110,7469101,'orm',11.111,1),(367,7469111,7469101,'rma',11.111,1),(367,7469112,7469101,'man',11.111,1),(367,7469113,7469101,'anc',11.111,1),(367,7469114,7469101,'nce',11.111,1),(367,7469115,7469106,'ide',12.5,1),(367,7469116,7469106,'den',12.5,1),(367,7469117,7469106,'ent',12.5,1),(367,7469118,7469106,'nti',12.5,1),(367,7469119,7469106,'tif',12.5,1),(367,7469120,7469106,'ifi',12.5,1),(367,7469121,7469106,'fie',12.5,1),(367,7469122,7469106,'ier',12.5,1),(367,7469123,7469115,'vdi',33.333,3),(367,7469124,7469115,'dis',33.333,3),(367,7469125,7469115,'isk',33.333,3),(367,7469126,7469123,'nam',50,1),(367,7469127,7469123,'ame',50,1),(367,7469128,7469126,'typ',50,1),(367,7469129,7469126,'ype',50,1),(367,7469130,7469128,'dir',25,1),(367,7469131,7469128,'ire',25,1),(367,7469132,7469128,'rec',25,1),(367,7469133,7469128,'ect',25,1),(368,7469135,7469134,'naa',100,2),(368,7469136,7469135,'600',3.333,3),(368,7469137,7469135,'000',3.333,3),(368,7469138,7469135,'00c',3.333,3),(368,7469139,7469135,'0c2',3.333,3),(368,7469140,7469135,'c29',3.333,3),(368,7469141,7469135,'296',3.333,3),(368,7469142,7469135,'966',3.333,3),(368,7469143,7469135,'660',3.333,3),(368,7469144,7469135,'600',3.333,3),(368,7469145,7469135,'00c',3.333,3),(368,7469146,7469135,'0c8',3.333,3),(368,7469147,7469135,'c8d',3.333,3),(368,7469148,7469135,'8da',3.333,3),(368,7469149,7469135,'dae',3.333,3),(368,7469150,7469135,'ae9',3.333,3),(368,7469151,7469135,'e9d',3.333,3),(368,7469152,7469135,'9d7',3.333,3),(368,7469153,7469135,'d74',3.333,3),(368,7469154,7469135,'742',3.333,3),(368,7469155,7469135,'42e',3.333,3),(368,7469156,7469135,'2ee',3.333,3),(368,7469157,7469135,'ee0',3.333,3),(368,7469158,7469135,'e0c',3.333,3),(368,7469159,7469135,'0c1',3.333,3),(368,7469160,7469135,'c1b',3.333,3),(368,7469161,7469135,'1bd',3.333,3),(368,7469162,7469135,'bdc',3.333,3),(368,7469163,7469135,'dc4',3.333,3),(368,7469164,7469135,'c4e',3.333,3),(368,7469165,7469135,'4e9',3.333,3),(368,7469166,7469136,'mon',100,1),(368,7469167,7469166,'201',50,1),(368,7469168,7469166,'013',50,1),(368,7469169,7469167,'adm',33.333,3),(368,7469170,7469167,'dmi',33.333,3),(368,7469171,7469167,'min',33.333,3),(368,7469172,7469169,'cap',16.667,1),(368,7469173,7469169,'apa',16.667,1),(368,7469174,7469169,'pac',16.667,1),(368,7469175,7469169,'aci',16.667,1),(368,7469176,7469169,'cit',16.667,1),(368,7469177,7469169,'ity',16.667,1),(368,7469178,7469172,'pat',50,1),(368,7469179,7469172,'ath',50,1),(368,7469180,7469178,'fou',50,1),(368,7469181,7469178,'our',50,1),(368,7469182,7469180,'fre',14.286,1),(368,7469183,7469180,'ree',14.286,1),(368,7469184,7469180,'ees',14.286,1),(368,7469185,7469180,'esp',14.286,1),(368,7469186,7469180,'spa',14.286,1),(368,7469187,7469180,'pac',14.286,1),(368,7469188,7469180,'ace',14.286,1),(368,7469189,7469182,'dis',50,1),(368,7469190,7469182,'isk',50,1),(368,7469191,7469189,'ind',33.333,1),(368,7469192,7469189,'nde',33.333,1),(368,7469193,7469189,'dex',33.333,1),(368,7469194,7469191,'adm',8.333,1),(368,7469195,7469191,'dmi',8.333,1),(368,7469196,7469191,'min',8.333,1),(368,7469197,7469191,'ini',8.333,1),(368,7469198,7469191,'nis',8.333,1),(368,7469199,7469191,'ist',8.333,1),(368,7469200,7469191,'str',8.333,1),(368,7469201,7469191,'tra',8.333,1),(368,7469202,7469191,'rat',8.333,1),(368,7469203,7469191,'ati',8.333,1),(368,7469204,7469191,'tio',8.333,1),(368,7469205,7469191,'ion',8.333,1),(368,7469206,7469194,'sta',33.333,3),(368,7469207,7469194,'tat',33.333,3),(368,7469208,7469194,'ate',33.333,3),(368,7469209,7469206,'ena',20,2),(368,7469210,7469206,'nab',20,2),(368,7469211,7469206,'abl',20,2),(368,7469212,7469206,'ble',20,2),(368,7469213,7469206,'led',20,2),(368,7469214,7469209,'cac',33.333,1),(368,7469215,7469209,'ach',33.333,1),(368,7469216,7469209,'che',33.333,1),(368,7469217,7469214,'mod',50,2),(368,7469218,7469214,'ode',50,2),(368,7469219,7469217,'wri',14.286,2),(368,7469220,7469217,'rit',14.286,2),(368,7469221,7469217,'ite',14.286,2),(368,7469222,7469217,'tet',14.286,2),(368,7469223,7469217,'eth',14.286,2),(368,7469224,7469217,'thr',14.286,2),(368,7469225,7469217,'hru',14.286,2),(368,7469226,7469219,'ope',11.111,2),(368,7469227,7469219,'per',11.111,2),(368,7469228,7469219,'era',11.111,2),(368,7469229,7469219,'rat',11.111,2),(368,7469230,7469219,'ati',11.111,2),(368,7469231,7469219,'tio',11.111,2),(368,7469232,7469219,'ion',11.111,2),(368,7469233,7469219,'ona',11.111,2),(368,7469234,7469219,'nal',11.111,2),(368,7469235,7469226,'nor',25,1),(368,7469236,7469226,'orm',25,1),(368,7469237,7469226,'rma',25,1),(368,7469238,7469226,'mal',25,1),(368,7469239,7469235,'mes',20,1),(368,7469240,7469235,'ess',20,1),(368,7469241,7469235,'ssa',20,1),(368,7469242,7469235,'sag',20,1),(368,7469243,7469235,'age',20,1),(368,7469244,7469239,'per',11.111,1),(368,7469245,7469239,'erf',11.111,1),(368,7469246,7469239,'rfo',11.111,1),(368,7469247,7469239,'for',11.111,1),(368,7469248,7469239,'orm',11.111,1),(368,7469249,7469239,'rma',11.111,1),(368,7469250,7469239,'man',11.111,1),(368,7469251,7469239,'anc',11.111,1),(368,7469252,7469239,'nce',11.111,1),(368,7469253,7469244,'ide',12.5,1),(368,7469254,7469244,'den',12.5,1),(368,7469255,7469244,'ent',12.5,1),(368,7469256,7469244,'nti',12.5,1),(368,7469257,7469244,'tif',12.5,1),(368,7469258,7469244,'ifi',12.5,1),(368,7469259,7469244,'fie',12.5,1),(368,7469260,7469244,'ier',12.5,1),(368,7469261,7469253,'vdi',33.333,3),(368,7469262,7469253,'dis',33.333,3),(368,7469263,7469253,'isk',33.333,3),(368,7469264,7469261,'nam',50,1),(368,7469265,7469261,'ame',50,1),(368,7469266,7469264,'typ',50,1),(368,7469267,7469264,'ype',50,1),(368,7469268,7469266,'dir',25,1),(368,7469269,7469266,'ire',25,1),(368,7469270,7469266,'rec',25,1),(368,7469271,7469266,'ect',25,1),(369,7469273,7469272,'naa',100,2),(369,7469274,7469273,'600',3.333,3),(369,7469275,7469273,'000',3.333,3),(369,7469276,7469273,'00c',3.333,3),(369,7469277,7469273,'0c2',3.333,3),(369,7469278,7469273,'c29',3.333,3),(369,7469279,7469273,'293',3.333,3),(369,7469280,7469273,'931',3.333,3),(369,7469281,7469273,'31b',3.333,3),(369,7469282,7469273,'1b0',3.333,3),(369,7469283,7469273,'b0f',3.333,3),(369,7469284,7469273,'0ff',3.333,3),(369,7469285,7469273,'ffc',3.333,3),(369,7469286,7469273,'fc6',3.333,3),(369,7469287,7469273,'c67',3.333,3),(369,7469288,7469273,'674',3.333,3),(369,7469289,7469273,'74d',3.333,3),(369,7469290,7469273,'4dc',3.333,3),(369,7469291,7469273,'dcc',3.333,3),(369,7469292,7469273,'cc8',3.333,3),(369,7469293,7469273,'c8e',3.333,3),(369,7469294,7469273,'8e3',3.333,3),(369,7469295,7469273,'e35',3.333,3),(369,7469296,7469273,'359',3.333,3),(369,7469297,7469273,'598',3.333,3),(369,7469298,7469273,'981',3.333,3),(369,7469299,7469273,'817',3.333,3),(369,7469300,7469273,'171',3.333,3),(369,7469301,7469273,'71d',3.333,3),(369,7469302,7469273,'1da',3.333,3),(369,7469303,7469273,'dad',3.333,3),(369,7469304,7469274,'mon',100,1),(369,7469305,7469304,'201',50,1),(369,7469306,7469304,'013',50,1),(369,7469307,7469305,'adm',33.333,3),(369,7469308,7469305,'dmi',33.333,3),(369,7469309,7469305,'min',33.333,3),(369,7469310,7469307,'cap',16.667,1),(369,7469311,7469307,'apa',16.667,1),(369,7469312,7469307,'pac',16.667,1),(369,7469313,7469307,'aci',16.667,1),(369,7469314,7469307,'cit',16.667,1),(369,7469315,7469307,'ity',16.667,1),(369,7469316,7469310,'pat',50,1),(369,7469317,7469310,'ath',50,1),(369,7469318,7469316,'fiv',50,1),(369,7469319,7469316,'ive',50,1),(369,7469320,7469318,'fre',14.286,1),(369,7469321,7469318,'ree',14.286,1),(369,7469322,7469318,'ees',14.286,1),(369,7469323,7469318,'esp',14.286,1),(369,7469324,7469318,'spa',14.286,1),(369,7469325,7469318,'pac',14.286,1),(369,7469326,7469318,'ace',14.286,1),(369,7469327,7469320,'dis',50,1),(369,7469328,7469320,'isk',50,1),(369,7469329,7469327,'ind',33.333,1),(369,7469330,7469327,'nde',33.333,1),(369,7469331,7469327,'dex',33.333,1),(369,7469332,7469329,'adm',8.333,1),(369,7469333,7469329,'dmi',8.333,1),(369,7469334,7469329,'min',8.333,1),(369,7469335,7469329,'ini',8.333,1),(369,7469336,7469329,'nis',8.333,1),(369,7469337,7469329,'ist',8.333,1),(369,7469338,7469329,'str',8.333,1),(369,7469339,7469329,'tra',8.333,1),(369,7469340,7469329,'rat',8.333,1),(369,7469341,7469329,'ati',8.333,1),(369,7469342,7469329,'tio',8.333,1),(369,7469343,7469329,'ion',8.333,1),(369,7469344,7469332,'sta',33.333,3),(369,7469345,7469332,'tat',33.333,3),(369,7469346,7469332,'ate',33.333,3),(369,7469347,7469344,'ena',20,2),(369,7469348,7469344,'nab',20,2),(369,7469349,7469344,'abl',20,2),(369,7469350,7469344,'ble',20,2),(369,7469351,7469344,'led',20,2),(369,7469352,7469347,'cac',33.333,1),(369,7469353,7469347,'ach',33.333,1),(369,7469354,7469347,'che',33.333,1),(369,7469355,7469352,'mod',50,2),(369,7469356,7469352,'ode',50,2),(369,7469357,7469355,'wri',14.286,2),(369,7469358,7469355,'rit',14.286,2),(369,7469359,7469355,'ite',14.286,2),(369,7469360,7469355,'tet',14.286,2),(369,7469361,7469355,'eth',14.286,2),(369,7469362,7469355,'thr',14.286,2),(369,7469363,7469355,'hru',14.286,2),(369,7469364,7469357,'ope',11.111,2),(369,7469365,7469357,'per',11.111,2),(369,7469366,7469357,'era',11.111,2),(369,7469367,7469357,'rat',11.111,2),(369,7469368,7469357,'ati',11.111,2),(369,7469369,7469357,'tio',11.111,2),(369,7469370,7469357,'ion',11.111,2),(369,7469371,7469357,'ona',11.111,2),(369,7469372,7469357,'nal',11.111,2),(369,7469373,7469364,'nor',25,1),(369,7469374,7469364,'orm',25,1),(369,7469375,7469364,'rma',25,1),(369,7469376,7469364,'mal',25,1),(369,7469377,7469373,'mes',20,1),(369,7469378,7469373,'ess',20,1),(369,7469379,7469373,'ssa',20,1),(369,7469380,7469373,'sag',20,1),(369,7469381,7469373,'age',20,1),(369,7469382,7469377,'per',11.111,1),(369,7469383,7469377,'erf',11.111,1),(369,7469384,7469377,'rfo',11.111,1),(369,7469385,7469377,'for',11.111,1),(369,7469386,7469377,'orm',11.111,1),(369,7469387,7469377,'rma',11.111,1),(369,7469388,7469377,'man',11.111,1),(369,7469389,7469377,'anc',11.111,1),(369,7469390,7469377,'nce',11.111,1),(369,7469391,7469382,'ide',12.5,1),(369,7469392,7469382,'den',12.5,1),(369,7469393,7469382,'ent',12.5,1),(369,7469394,7469382,'nti',12.5,1),(369,7469395,7469382,'tif',12.5,1),(369,7469396,7469382,'ifi',12.5,1),(369,7469397,7469382,'fie',12.5,1),(369,7469398,7469382,'ier',12.5,1),(369,7469399,7469391,'vdi',33.333,3),(369,7469400,7469391,'dis',33.333,3),(369,7469401,7469391,'isk',33.333,3),(369,7469402,7469399,'nam',50,1),(369,7469403,7469399,'ame',50,1),(369,7469404,7469402,'typ',50,1),(369,7469405,7469402,'ype',50,1),(369,7469406,7469404,'dir',25,1),(369,7469407,7469404,'ire',25,1),(369,7469408,7469404,'rec',25,1),(369,7469409,7469404,'ect',25,1),(370,7469411,7469410,'naa',100,2),(370,7469412,7469411,'600',3.333,3),(370,7469413,7469411,'000',3.333,3),(370,7469414,7469411,'00c',3.333,3),(370,7469415,7469411,'0c2',3.333,3),(370,7469416,7469411,'c29',3.333,3),(370,7469417,7469411,'29d',3.333,3),(370,7469418,7469411,'9d4',3.333,3),(370,7469419,7469411,'d46',3.333,3),(370,7469420,7469411,'46d',3.333,3),(370,7469421,7469411,'6de',3.333,3),(370,7469422,7469411,'de4',3.333,3),(370,7469423,7469411,'e48',3.333,3),(370,7469424,7469411,'489',3.333,3),(370,7469425,7469411,'895',3.333,3),(370,7469426,7469411,'951',3.333,3),(370,7469427,7469411,'51f',3.333,3),(370,7469428,7469411,'1fc',3.333,3),(370,7469429,7469411,'fc5',3.333,3),(370,7469430,7469411,'c58',3.333,3),(370,7469431,7469411,'586',3.333,3),(370,7469432,7469411,'86e',3.333,3),(370,7469433,7469411,'6e9',3.333,3),(370,7469434,7469411,'e98',3.333,3),(370,7469435,7469411,'982',3.333,3),(370,7469436,7469411,'822',3.333,3),(370,7469437,7469411,'226',3.333,3),(370,7469438,7469411,'26d',3.333,3),(370,7469439,7469411,'6d5',3.333,3),(370,7469440,7469411,'d5e',3.333,3),(370,7469441,7469411,'5ec',3.333,3),(370,7469442,7469412,'mon',100,1),(370,7469443,7469442,'201',50,1),(370,7469444,7469442,'013',50,1),(370,7469445,7469443,'adm',33.333,3),(370,7469446,7469443,'dmi',33.333,3),(370,7469447,7469443,'min',33.333,3),(370,7469448,7469445,'cap',16.667,1),(370,7469449,7469445,'apa',16.667,1),(370,7469450,7469445,'pac',16.667,1),(370,7469451,7469445,'aci',16.667,1),(370,7469452,7469445,'cit',16.667,1),(370,7469453,7469445,'ity',16.667,1),(370,7469454,7469448,'pat',50,1),(370,7469455,7469448,'ath',50,1),(370,7469456,7469454,'six',100,1),(370,7469457,7469456,'fre',14.286,1),(370,7469458,7469456,'ree',14.286,1),(370,7469459,7469456,'ees',14.286,1),(370,7469460,7469456,'esp',14.286,1),(370,7469461,7469456,'spa',14.286,1),(370,7469462,7469456,'pac',14.286,1),(370,7469463,7469456,'ace',14.286,1),(370,7469464,7469457,'dis',50,1),(370,7469465,7469457,'isk',50,1),(370,7469466,7469464,'ind',33.333,1),(370,7469467,7469464,'nde',33.333,1),(370,7469468,7469464,'dex',33.333,1),(370,7469469,7469466,'adm',8.333,1),(370,7469470,7469466,'dmi',8.333,1),(370,7469471,7469466,'min',8.333,1),(370,7469472,7469466,'ini',8.333,1),(370,7469473,7469466,'nis',8.333,1),(370,7469474,7469466,'ist',8.333,1),(370,7469475,7469466,'str',8.333,1),(370,7469476,7469466,'tra',8.333,1),(370,7469477,7469466,'rat',8.333,1),(370,7469478,7469466,'ati',8.333,1),(370,7469479,7469466,'tio',8.333,1),(370,7469480,7469466,'ion',8.333,1),(370,7469481,7469469,'sta',33.333,3),(370,7469482,7469469,'tat',33.333,3),(370,7469483,7469469,'ate',33.333,3),(370,7469484,7469481,'ena',20,2),(370,7469485,7469481,'nab',20,2),(370,7469486,7469481,'abl',20,2),(370,7469487,7469481,'ble',20,2),(370,7469488,7469481,'led',20,2),(370,7469489,7469484,'cac',33.333,1),(370,7469490,7469484,'ach',33.333,1),(370,7469491,7469484,'che',33.333,1),(370,7469492,7469489,'mod',50,2),(370,7469493,7469489,'ode',50,2),(370,7469494,7469492,'wri',14.286,2),(370,7469495,7469492,'rit',14.286,2),(370,7469496,7469492,'ite',14.286,2),(370,7469497,7469492,'tet',14.286,2),(370,7469498,7469492,'eth',14.286,2),(370,7469499,7469492,'thr',14.286,2),(370,7469500,7469492,'hru',14.286,2),(370,7469501,7469494,'ope',11.111,2),(370,7469502,7469494,'per',11.111,2),(370,7469503,7469494,'era',11.111,2),(370,7469504,7469494,'rat',11.111,2),(370,7469505,7469494,'ati',11.111,2),(370,7469506,7469494,'tio',11.111,2),(370,7469507,7469494,'ion',11.111,2),(370,7469508,7469494,'ona',11.111,2),(370,7469509,7469494,'nal',11.111,2),(370,7469510,7469501,'nor',25,1),(370,7469511,7469501,'orm',25,1),(370,7469512,7469501,'rma',25,1),(370,7469513,7469501,'mal',25,1),(370,7469514,7469510,'mes',20,1),(370,7469515,7469510,'ess',20,1),(370,7469516,7469510,'ssa',20,1),(370,7469517,7469510,'sag',20,1),(370,7469518,7469510,'age',20,1),(370,7469519,7469514,'per',11.111,1),(370,7469520,7469514,'erf',11.111,1),(370,7469521,7469514,'rfo',11.111,1),(370,7469522,7469514,'for',11.111,1),(370,7469523,7469514,'orm',11.111,1),(370,7469524,7469514,'rma',11.111,1),(370,7469525,7469514,'man',11.111,1),(370,7469526,7469514,'anc',11.111,1),(370,7469527,7469514,'nce',11.111,1),(370,7469528,7469519,'ide',12.5,1),(370,7469529,7469519,'den',12.5,1),(370,7469530,7469519,'ent',12.5,1),(370,7469531,7469519,'nti',12.5,1),(370,7469532,7469519,'tif',12.5,1),(370,7469533,7469519,'ifi',12.5,1),(370,7469534,7469519,'fie',12.5,1),(370,7469535,7469519,'ier',12.5,1),(370,7469536,7469528,'vdi',33.333,3),(370,7469537,7469528,'dis',33.333,3),(370,7469538,7469528,'isk',33.333,3),(370,7469539,7469536,'nam',50,1),(370,7469540,7469536,'ame',50,1),(370,7469541,7469539,'typ',50,1),(370,7469542,7469539,'ype',50,1),(370,7469543,7469541,'dir',25,1),(370,7469544,7469541,'ire',25,1),(370,7469545,7469541,'rec',25,1),(370,7469546,7469541,'ect',25,1),(371,7469548,7469547,'naa',100,2),(371,7469549,7469548,'600',3.333,3),(371,7469550,7469548,'000',3.333,3),(371,7469551,7469548,'00c',3.333,3),(371,7469552,7469548,'0c2',3.333,3),(371,7469553,7469548,'c29',3.333,3),(371,7469554,7469548,'29e',3.333,3),(371,7469555,7469548,'9e3',3.333,3),(371,7469556,7469548,'e33',3.333,3),(371,7469557,7469548,'335',3.333,3),(371,7469558,7469548,'350',3.333,3),(371,7469559,7469548,'501',3.333,3),(371,7469560,7469548,'014',3.333,3),(371,7469561,7469548,'14b',3.333,3),(371,7469562,7469548,'4bb',3.333,3),(371,7469563,7469548,'bb1',3.333,3),(371,7469564,7469548,'b17',3.333,3),(371,7469565,7469548,'174',3.333,3),(371,7469566,7469548,'741',3.333,3),(371,7469567,7469548,'415',3.333,3),(371,7469568,7469548,'151',3.333,3),(371,7469569,7469548,'51c',3.333,3),(371,7469570,7469548,'1c6',3.333,3),(371,7469571,7469548,'c6f',3.333,3),(371,7469572,7469548,'6fe',3.333,3),(371,7469573,7469548,'fef',3.333,3),(371,7469574,7469548,'ef6',3.333,3),(371,7469575,7469548,'f61',3.333,3),(371,7469576,7469548,'619',3.333,3),(371,7469577,7469548,'196',3.333,3),(371,7469578,7469548,'968',3.333,3),(371,7469579,7469549,'mon',100,1),(371,7469580,7469579,'201',50,1),(371,7469581,7469579,'013',50,1),(371,7469582,7469580,'adm',33.333,3),(371,7469583,7469580,'dmi',33.333,3),(371,7469584,7469580,'min',33.333,3),(371,7469585,7469582,'cap',16.667,1),(371,7469586,7469582,'apa',16.667,1),(371,7469587,7469582,'pac',16.667,1),(371,7469588,7469582,'aci',16.667,1),(371,7469589,7469582,'cit',16.667,1),(371,7469590,7469582,'ity',16.667,1),(371,7469591,7469585,'pat',50,1),(371,7469592,7469585,'ath',50,1),(371,7469593,7469591,'sev',33.333,1),(371,7469594,7469591,'eve',33.333,1),(371,7469595,7469591,'ven',33.333,1),(371,7469596,7469593,'fre',14.286,1),(371,7469597,7469593,'ree',14.286,1),(371,7469598,7469593,'ees',14.286,1),(371,7469599,7469593,'esp',14.286,1),(371,7469600,7469593,'spa',14.286,1),(371,7469601,7469593,'pac',14.286,1),(371,7469602,7469593,'ace',14.286,1),(371,7469603,7469596,'dis',50,1),(371,7469604,7469596,'isk',50,1),(371,7469605,7469603,'ind',33.333,1),(371,7469606,7469603,'nde',33.333,1),(371,7469607,7469603,'dex',33.333,1),(371,7469608,7469605,'adm',8.333,1),(371,7469609,7469605,'dmi',8.333,1),(371,7469610,7469605,'min',8.333,1),(371,7469611,7469605,'ini',8.333,1),(371,7469612,7469605,'nis',8.333,1),(371,7469613,7469605,'ist',8.333,1),(371,7469614,7469605,'str',8.333,1),(371,7469615,7469605,'tra',8.333,1),(371,7469616,7469605,'rat',8.333,1),(371,7469617,7469605,'ati',8.333,1),(371,7469618,7469605,'tio',8.333,1),(371,7469619,7469605,'ion',8.333,1),(371,7469620,7469608,'sta',33.333,3),(371,7469621,7469608,'tat',33.333,3),(371,7469622,7469608,'ate',33.333,3),(371,7469623,7469620,'ena',20,2),(371,7469624,7469620,'nab',20,2),(371,7469625,7469620,'abl',20,2),(371,7469626,7469620,'ble',20,2),(371,7469627,7469620,'led',20,2),(371,7469628,7469623,'cac',33.333,1),(371,7469629,7469623,'ach',33.333,1),(371,7469630,7469623,'che',33.333,1),(371,7469631,7469628,'mod',50,2),(371,7469632,7469628,'ode',50,2),(371,7469633,7469631,'wri',14.286,2),(371,7469634,7469631,'rit',14.286,2),(371,7469635,7469631,'ite',14.286,2),(371,7469636,7469631,'tet',14.286,2),(371,7469637,7469631,'eth',14.286,2),(371,7469638,7469631,'thr',14.286,2),(371,7469639,7469631,'hru',14.286,2),(371,7469640,7469633,'ope',11.111,2),(371,7469641,7469633,'per',11.111,2),(371,7469642,7469633,'era',11.111,2),(371,7469643,7469633,'rat',11.111,2),(371,7469644,7469633,'ati',11.111,2),(371,7469645,7469633,'tio',11.111,2),(371,7469646,7469633,'ion',11.111,2),(371,7469647,7469633,'ona',11.111,2),(371,7469648,7469633,'nal',11.111,2),(371,7469649,7469640,'nor',25,1),(371,7469650,7469640,'orm',25,1),(371,7469651,7469640,'rma',25,1),(371,7469652,7469640,'mal',25,1),(371,7469653,7469649,'mes',20,1),(371,7469654,7469649,'ess',20,1),(371,7469655,7469649,'ssa',20,1),(371,7469656,7469649,'sag',20,1),(371,7469657,7469649,'age',20,1),(371,7469658,7469653,'per',11.111,1),(371,7469659,7469653,'erf',11.111,1),(371,7469660,7469653,'rfo',11.111,1),(371,7469661,7469653,'for',11.111,1),(371,7469662,7469653,'orm',11.111,1),(371,7469663,7469653,'rma',11.111,1),(371,7469664,7469653,'man',11.111,1),(371,7469665,7469653,'anc',11.111,1),(371,7469666,7469653,'nce',11.111,1),(371,7469667,7469658,'ide',12.5,1),(371,7469668,7469658,'den',12.5,1),(371,7469669,7469658,'ent',12.5,1),(371,7469670,7469658,'nti',12.5,1),(371,7469671,7469658,'tif',12.5,1),(371,7469672,7469658,'ifi',12.5,1),(371,7469673,7469658,'fie',12.5,1),(371,7469674,7469658,'ier',12.5,1),(371,7469675,7469667,'vdi',33.333,3),(371,7469676,7469667,'dis',33.333,3),(371,7469677,7469667,'isk',33.333,3),(371,7469678,7469675,'nam',50,1),(371,7469679,7469675,'ame',50,1),(371,7469680,7469678,'typ',50,1),(371,7469681,7469678,'ype',50,1),(371,7469682,7469680,'dir',25,1),(371,7469683,7469680,'ire',25,1),(371,7469684,7469680,'rec',25,1),(371,7469685,7469680,'ect',25,1),(372,7469687,7469686,'naa',100,2),(372,7469688,7469687,'600',3.333,3),(372,7469689,7469687,'000',3.333,3),(372,7469690,7469687,'00c',3.333,3),(372,7469691,7469687,'0c2',3.333,3),(372,7469692,7469687,'c29',3.333,3),(372,7469693,7469687,'29e',3.333,3),(372,7469694,7469687,'9e5',3.333,3),(372,7469695,7469687,'e54',3.333,3),(372,7469696,7469687,'543',3.333,3),(372,7469697,7469687,'433',3.333,3),(372,7469698,7469687,'336',3.333,3),(372,7469699,7469687,'36b',3.333,3),(372,7469700,7469687,'6b5',3.333,3),(372,7469701,7469687,'b52',3.333,3),(372,7469702,7469687,'52a',3.333,3),(372,7469703,7469687,'2aa',3.333,3),(372,7469704,7469687,'aa7',3.333,3),(372,7469705,7469687,'a76',3.333,3),(372,7469706,7469687,'766',3.333,3),(372,7469707,7469687,'66c',3.333,3),(372,7469708,7469687,'6cc',3.333,3),(372,7469709,7469687,'cc0',3.333,3),(372,7469710,7469687,'c06',3.333,3),(372,7469711,7469687,'061',3.333,3),(372,7469712,7469687,'618',3.333,3),(372,7469713,7469687,'180',3.333,3),(372,7469714,7469687,'802',3.333,3),(372,7469715,7469687,'02e',3.333,3),(372,7469716,7469687,'2e5',3.333,3),(372,7469717,7469687,'e54',3.333,3),(372,7469718,7469688,'mon',100,1),(372,7469719,7469718,'201',50,1),(372,7469720,7469718,'013',50,1),(372,7469721,7469719,'adm',33.333,3),(372,7469722,7469719,'dmi',33.333,3),(372,7469723,7469719,'min',33.333,3),(372,7469724,7469721,'cap',16.667,1),(372,7469725,7469721,'apa',16.667,1),(372,7469726,7469721,'pac',16.667,1),(372,7469727,7469721,'aci',16.667,1),(372,7469728,7469721,'cit',16.667,1),(372,7469729,7469721,'ity',16.667,1),(372,7469730,7469724,'pat',50,1),(372,7469731,7469724,'ath',50,1),(372,7469732,7469730,'eig',33.333,1),(372,7469733,7469730,'igh',33.333,1),(372,7469734,7469730,'ght',33.333,1),(372,7469735,7469732,'fre',14.286,1),(372,7469736,7469732,'ree',14.286,1),(372,7469737,7469732,'ees',14.286,1),(372,7469738,7469732,'esp',14.286,1),(372,7469739,7469732,'spa',14.286,1),(372,7469740,7469732,'pac',14.286,1),(372,7469741,7469732,'ace',14.286,1),(372,7469742,7469735,'dis',50,1),(372,7469743,7469735,'isk',50,1),(372,7469744,7469742,'ind',33.333,1),(372,7469745,7469742,'nde',33.333,1),(372,7469746,7469742,'dex',33.333,1),(372,7469747,7469744,'adm',8.333,1),(372,7469748,7469744,'dmi',8.333,1),(372,7469749,7469744,'min',8.333,1),(372,7469750,7469744,'ini',8.333,1),(372,7469751,7469744,'nis',8.333,1),(372,7469752,7469744,'ist',8.333,1),(372,7469753,7469744,'str',8.333,1),(372,7469754,7469744,'tra',8.333,1),(372,7469755,7469744,'rat',8.333,1),(372,7469756,7469744,'ati',8.333,1),(372,7469757,7469744,'tio',8.333,1),(372,7469758,7469744,'ion',8.333,1),(372,7469759,7469747,'sta',33.333,3),(372,7469760,7469747,'tat',33.333,3),(372,7469761,7469747,'ate',33.333,3),(372,7469762,7469759,'ena',20,2),(372,7469763,7469759,'nab',20,2),(372,7469764,7469759,'abl',20,2),(372,7469765,7469759,'ble',20,2),(372,7469766,7469759,'led',20,2),(372,7469767,7469762,'cac',33.333,1),(372,7469768,7469762,'ach',33.333,1),(372,7469769,7469762,'che',33.333,1),(372,7469770,7469767,'mod',50,2),(372,7469771,7469767,'ode',50,2),(372,7469772,7469770,'wri',14.286,2),(372,7469773,7469770,'rit',14.286,2),(372,7469774,7469770,'ite',14.286,2),(372,7469775,7469770,'tet',14.286,2),(372,7469776,7469770,'eth',14.286,2),(372,7469777,7469770,'thr',14.286,2),(372,7469778,7469770,'hru',14.286,2),(372,7469779,7469772,'ope',11.111,2),(372,7469780,7469772,'per',11.111,2),(372,7469781,7469772,'era',11.111,2),(372,7469782,7469772,'rat',11.111,2),(372,7469783,7469772,'ati',11.111,2),(372,7469784,7469772,'tio',11.111,2),(372,7469785,7469772,'ion',11.111,2),(372,7469786,7469772,'ona',11.111,2),(372,7469787,7469772,'nal',11.111,2),(372,7469788,7469779,'nor',25,1),(372,7469789,7469779,'orm',25,1),(372,7469790,7469779,'rma',25,1),(372,7469791,7469779,'mal',25,1),(372,7469792,7469788,'mes',20,1),(372,7469793,7469788,'ess',20,1),(372,7469794,7469788,'ssa',20,1),(372,7469795,7469788,'sag',20,1),(372,7469796,7469788,'age',20,1),(372,7469797,7469792,'per',11.111,1),(372,7469798,7469792,'erf',11.111,1),(372,7469799,7469792,'rfo',11.111,1),(372,7469800,7469792,'for',11.111,1),(372,7469801,7469792,'orm',11.111,1),(372,7469802,7469792,'rma',11.111,1),(372,7469803,7469792,'man',11.111,1),(372,7469804,7469792,'anc',11.111,1),(372,7469805,7469792,'nce',11.111,1),(372,7469806,7469797,'ide',12.5,1),(372,7469807,7469797,'den',12.5,1),(372,7469808,7469797,'ent',12.5,1),(372,7469809,7469797,'nti',12.5,1),(372,7469810,7469797,'tif',12.5,1),(372,7469811,7469797,'ifi',12.5,1),(372,7469812,7469797,'fie',12.5,1),(372,7469813,7469797,'ier',12.5,1),(372,7469814,7469806,'vdi',33.333,3),(372,7469815,7469806,'dis',33.333,3),(372,7469816,7469806,'isk',33.333,3),(372,7469817,7469814,'nam',50,1),(372,7469818,7469814,'ame',50,1),(372,7469819,7469817,'typ',50,1),(372,7469820,7469817,'ype',50,1),(372,7469821,7469819,'dir',25,1),(372,7469822,7469819,'ire',25,1),(372,7469823,7469819,'rec',25,1),(372,7469824,7469819,'ect',25,1),(373,7469826,7469825,'naa',100,2),(373,7469827,7469826,'600',3.333,3),(373,7469828,7469826,'000',3.333,3),(373,7469829,7469826,'00c',3.333,3),(373,7469830,7469826,'0c2',3.333,3),(373,7469831,7469826,'c29',3.333,3),(373,7469832,7469826,'294',3.333,3),(373,7469833,7469826,'945',3.333,3),(373,7469834,7469826,'459',3.333,3),(373,7469835,7469826,'59e',3.333,3),(373,7469836,7469826,'9e8',3.333,3),(373,7469837,7469826,'e8c',3.333,3),(373,7469838,7469826,'8c5',3.333,3),(373,7469839,7469826,'c5d',3.333,3),(373,7469840,7469826,'5d4',3.333,3),(373,7469841,7469826,'d43',3.333,3),(373,7469842,7469826,'431',3.333,3),(373,7469843,7469826,'31d',3.333,3),(373,7469844,7469826,'1d1',3.333,3),(373,7469845,7469826,'d18',3.333,3),(373,7469846,7469826,'188',3.333,3),(373,7469847,7469826,'887',3.333,3),(373,7469848,7469826,'870',3.333,3),(373,7469849,7469826,'70e',3.333,3),(373,7469850,7469826,'0e9',3.333,3),(373,7469851,7469826,'e9e',3.333,3),(373,7469852,7469826,'9eb',3.333,3),(373,7469853,7469826,'eba',3.333,3),(373,7469854,7469826,'ba0',3.333,3),(373,7469855,7469826,'a06',3.333,3),(373,7469856,7469826,'06f',3.333,3),(373,7469857,7469827,'mon',100,1),(373,7469858,7469857,'201',50,1),(373,7469859,7469857,'013',50,1),(373,7469860,7469858,'adm',33.333,3),(373,7469861,7469858,'dmi',33.333,3),(373,7469862,7469858,'min',33.333,3),(373,7469863,7469860,'cap',16.667,1),(373,7469864,7469860,'apa',16.667,1),(373,7469865,7469860,'pac',16.667,1),(373,7469866,7469860,'aci',16.667,1),(373,7469867,7469860,'cit',16.667,1),(373,7469868,7469860,'ity',16.667,1),(373,7469869,7469863,'pat',50,1),(373,7469870,7469863,'ath',50,1),(373,7469871,7469869,'nin',50,1),(373,7469872,7469869,'ine',50,1),(373,7469873,7469871,'fre',14.286,1),(373,7469874,7469871,'ree',14.286,1),(373,7469875,7469871,'ees',14.286,1),(373,7469876,7469871,'esp',14.286,1),(373,7469877,7469871,'spa',14.286,1),(373,7469878,7469871,'pac',14.286,1),(373,7469879,7469871,'ace',14.286,1),(373,7469880,7469873,'dis',50,1),(373,7469881,7469873,'isk',50,1),(373,7469882,7469880,'ind',33.333,1),(373,7469883,7469880,'nde',33.333,1),(373,7469884,7469880,'dex',33.333,1),(373,7469885,7469882,'adm',8.333,1),(373,7469886,7469882,'dmi',8.333,1),(373,7469887,7469882,'min',8.333,1),(373,7469888,7469882,'ini',8.333,1),(373,7469889,7469882,'nis',8.333,1),(373,7469890,7469882,'ist',8.333,1),(373,7469891,7469882,'str',8.333,1),(373,7469892,7469882,'tra',8.333,1),(373,7469893,7469882,'rat',8.333,1),(373,7469894,7469882,'ati',8.333,1),(373,7469895,7469882,'tio',8.333,1),(373,7469896,7469882,'ion',8.333,1),(373,7469897,7469885,'sta',33.333,3),(373,7469898,7469885,'tat',33.333,3),(373,7469899,7469885,'ate',33.333,3),(373,7469900,7469897,'ena',20,2),(373,7469901,7469897,'nab',20,2),(373,7469902,7469897,'abl',20,2),(373,7469903,7469897,'ble',20,2),(373,7469904,7469897,'led',20,2),(373,7469905,7469900,'cac',33.333,1),(373,7469906,7469900,'ach',33.333,1),(373,7469907,7469900,'che',33.333,1),(373,7469908,7469905,'mod',50,2),(373,7469909,7469905,'ode',50,2),(373,7469910,7469908,'wri',14.286,2),(373,7469911,7469908,'rit',14.286,2),(373,7469912,7469908,'ite',14.286,2),(373,7469913,7469908,'tet',14.286,2),(373,7469914,7469908,'eth',14.286,2),(373,7469915,7469908,'thr',14.286,2),(373,7469916,7469908,'hru',14.286,2),(373,7469917,7469910,'ope',11.111,2),(373,7469918,7469910,'per',11.111,2),(373,7469919,7469910,'era',11.111,2),(373,7469920,7469910,'rat',11.111,2),(373,7469921,7469910,'ati',11.111,2),(373,7469922,7469910,'tio',11.111,2),(373,7469923,7469910,'ion',11.111,2),(373,7469924,7469910,'ona',11.111,2),(373,7469925,7469910,'nal',11.111,2),(373,7469926,7469917,'nor',25,1),(373,7469927,7469917,'orm',25,1),(373,7469928,7469917,'rma',25,1),(373,7469929,7469917,'mal',25,1),(373,7469930,7469926,'mes',20,1),(373,7469931,7469926,'ess',20,1),(373,7469932,7469926,'ssa',20,1),(373,7469933,7469926,'sag',20,1),(373,7469934,7469926,'age',20,1),(373,7469935,7469930,'per',11.111,1),(373,7469936,7469930,'erf',11.111,1),(373,7469937,7469930,'rfo',11.111,1),(373,7469938,7469930,'for',11.111,1),(373,7469939,7469930,'orm',11.111,1),(373,7469940,7469930,'rma',11.111,1),(373,7469941,7469930,'man',11.111,1),(373,7469942,7469930,'anc',11.111,1),(373,7469943,7469930,'nce',11.111,1),(373,7469944,7469935,'ide',12.5,1),(373,7469945,7469935,'den',12.5,1),(373,7469946,7469935,'ent',12.5,1),(373,7469947,7469935,'nti',12.5,1),(373,7469948,7469935,'tif',12.5,1),(373,7469949,7469935,'ifi',12.5,1),(373,7469950,7469935,'fie',12.5,1),(373,7469951,7469935,'ier',12.5,1),(373,7469952,7469944,'vdi',33.333,3),(373,7469953,7469944,'dis',33.333,3),(373,7469954,7469944,'isk',33.333,3),(373,7469955,7469952,'nam',50,1),(373,7469956,7469952,'ame',50,1),(373,7469957,7469955,'typ',50,1),(373,7469958,7469955,'ype',50,1),(373,7469959,7469957,'dir',25,1),(373,7469960,7469957,'ire',25,1),(373,7469961,7469957,'rec',25,1),(373,7469962,7469957,'ect',25,1),(374,7469964,7469963,'naa',100,2),(374,7469965,7469964,'600',3.333,3),(374,7469966,7469964,'000',3.333,3),(374,7469967,7469964,'00c',3.333,3),(374,7469968,7469964,'0c2',3.333,3),(374,7469969,7469964,'c29',3.333,3),(374,7469970,7469964,'296',3.333,3),(374,7469971,7469964,'961',3.333,3),(374,7469972,7469964,'614',3.333,3),(374,7469973,7469964,'145',3.333,3),(374,7469974,7469964,'459',3.333,3),(374,7469975,7469964,'597',3.333,3),(374,7469976,7469964,'978',3.333,3),(374,7469977,7469964,'78d',3.333,3),(374,7469978,7469964,'8d1',3.333,3),(374,7469979,7469964,'d11',3.333,3),(374,7469980,7469964,'116',3.333,3),(374,7469981,7469964,'16a',3.333,3),(374,7469982,7469964,'6a1',3.333,3),(374,7469983,7469964,'a1d',3.333,3),(374,7469984,7469964,'1da',3.333,3),(374,7469985,7469964,'dad',3.333,3),(374,7469986,7469964,'adb',3.333,3),(374,7469987,7469964,'db3',3.333,3),(374,7469988,7469964,'b39',3.333,3),(374,7469989,7469964,'39c',3.333,3),(374,7469990,7469964,'9ca',3.333,3),(374,7469991,7469964,'cae',3.333,3),(374,7469992,7469964,'ae9',3.333,3),(374,7469993,7469964,'e94',3.333,3),(374,7469994,7469964,'949',3.333,3),(374,7469995,7469965,'mon',100,1),(374,7469996,7469995,'201',50,1),(374,7469997,7469995,'013',50,1),(374,7469998,7469996,'adm',33.333,3),(374,7469999,7469996,'dmi',33.333,3),(374,7470000,7469996,'min',33.333,3),(374,7470001,7469998,'cap',16.667,1),(374,7470002,7469998,'apa',16.667,1),(374,7470003,7469998,'pac',16.667,1),(374,7470004,7469998,'aci',16.667,1),(374,7470005,7469998,'cit',16.667,1),(374,7470006,7469998,'ity',16.667,1),(374,7470007,7470001,'pat',50,1),(374,7470008,7470001,'ath',50,1),(374,7470009,7470007,'ten',100,1),(374,7470010,7470009,'fre',14.286,1),(374,7470011,7470009,'ree',14.286,1),(374,7470012,7470009,'ees',14.286,1),(374,7470013,7470009,'esp',14.286,1),(374,7470014,7470009,'spa',14.286,1),(374,7470015,7470009,'pac',14.286,1),(374,7470016,7470009,'ace',14.286,1),(374,7470017,7470010,'dis',50,1),(374,7470018,7470010,'isk',50,1),(374,7470019,7470017,'ind',33.333,1),(374,7470020,7470017,'nde',33.333,1),(374,7470021,7470017,'dex',33.333,1),(374,7470022,7470019,'adm',8.333,1),(374,7470023,7470019,'dmi',8.333,1),(374,7470024,7470019,'min',8.333,1),(374,7470025,7470019,'ini',8.333,1),(374,7470026,7470019,'nis',8.333,1),(374,7470027,7470019,'ist',8.333,1),(374,7470028,7470019,'str',8.333,1),(374,7470029,7470019,'tra',8.333,1),(374,7470030,7470019,'rat',8.333,1),(374,7470031,7470019,'ati',8.333,1),(374,7470032,7470019,'tio',8.333,1),(374,7470033,7470019,'ion',8.333,1),(374,7470034,7470022,'sta',33.333,3),(374,7470035,7470022,'tat',33.333,3),(374,7470036,7470022,'ate',33.333,3),(374,7470037,7470034,'ena',20,2),(374,7470038,7470034,'nab',20,2),(374,7470039,7470034,'abl',20,2),(374,7470040,7470034,'ble',20,2),(374,7470041,7470034,'led',20,2),(374,7470042,7470037,'cac',33.333,1),(374,7470043,7470037,'ach',33.333,1),(374,7470044,7470037,'che',33.333,1),(374,7470045,7470042,'mod',50,2),(374,7470046,7470042,'ode',50,2),(374,7470047,7470045,'wri',14.286,2),(374,7470048,7470045,'rit',14.286,2),(374,7470049,7470045,'ite',14.286,2),(374,7470050,7470045,'tet',14.286,2),(374,7470051,7470045,'eth',14.286,2),(374,7470052,7470045,'thr',14.286,2),(374,7470053,7470045,'hru',14.286,2),(374,7470054,7470047,'ope',11.111,2),(374,7470055,7470047,'per',11.111,2),(374,7470056,7470047,'era',11.111,2),(374,7470057,7470047,'rat',11.111,2),(374,7470058,7470047,'ati',11.111,2),(374,7470059,7470047,'tio',11.111,2),(374,7470060,7470047,'ion',11.111,2),(374,7470061,7470047,'ona',11.111,2),(374,7470062,7470047,'nal',11.111,2),(374,7470063,7470054,'nor',25,1),(374,7470064,7470054,'orm',25,1),(374,7470065,7470054,'rma',25,1),(374,7470066,7470054,'mal',25,1),(374,7470067,7470063,'mes',20,1),(374,7470068,7470063,'ess',20,1),(374,7470069,7470063,'ssa',20,1),(374,7470070,7470063,'sag',20,1),(374,7470071,7470063,'age',20,1),(374,7470072,7470067,'per',11.111,1),(374,7470073,7470067,'erf',11.111,1),(374,7470074,7470067,'rfo',11.111,1),(374,7470075,7470067,'for',11.111,1),(374,7470076,7470067,'orm',11.111,1),(374,7470077,7470067,'rma',11.111,1),(374,7470078,7470067,'man',11.111,1),(374,7470079,7470067,'anc',11.111,1),(374,7470080,7470067,'nce',11.111,1),(374,7470081,7470072,'ide',12.5,1),(374,7470082,7470072,'den',12.5,1),(374,7470083,7470072,'ent',12.5,1),(374,7470084,7470072,'nti',12.5,1),(374,7470085,7470072,'tif',12.5,1),(374,7470086,7470072,'ifi',12.5,1),(374,7470087,7470072,'fie',12.5,1),(374,7470088,7470072,'ier',12.5,1),(374,7470089,7470081,'vdi',33.333,3),(374,7470090,7470081,'dis',33.333,3),(374,7470091,7470081,'isk',33.333,3),(374,7470092,7470089,'nam',50,1),(374,7470093,7470089,'ame',50,1),(374,7470094,7470092,'typ',50,1),(374,7470095,7470092,'ype',50,1),(374,7470096,7470094,'dir',25,1),(374,7470097,7470094,'ire',25,1),(374,7470098,7470094,'rec',25,1),(374,7470099,7470094,'ect',25,1),(375,7470101,7470100,'naa',100,2),(375,7470102,7470101,'600',3.333,3),(375,7470103,7470101,'000',3.333,3),(375,7470104,7470101,'00c',3.333,3),(375,7470105,7470101,'0c2',3.333,3),(375,7470106,7470101,'c29',3.333,3),(375,7470107,7470101,'297',3.333,3),(375,7470108,7470101,'979',3.333,3),(375,7470109,7470101,'790',3.333,3),(375,7470110,7470101,'907',3.333,3),(375,7470111,7470101,'079',3.333,3),(375,7470112,7470101,'79a',3.333,3),(375,7470113,7470101,'9a8',3.333,3),(375,7470114,7470101,'a87',3.333,3),(375,7470115,7470101,'872',3.333,3),(375,7470116,7470101,'72b',3.333,3),(375,7470117,7470101,'2bc',3.333,3),(375,7470118,7470101,'bc7',3.333,3),(375,7470119,7470101,'c7b',3.333,3),(375,7470120,7470101,'7b0',3.333,3),(375,7470121,7470101,'b01',3.333,3),(375,7470122,7470101,'010',3.333,3),(375,7470123,7470101,'10e',3.333,3),(375,7470124,7470101,'0e0',3.333,3),(375,7470125,7470101,'e09',3.333,3),(375,7470126,7470101,'099',3.333,3),(375,7470127,7470101,'990',3.333,3),(375,7470128,7470101,'903',3.333,3),(375,7470129,7470101,'038',3.333,3),(375,7470130,7470101,'382',3.333,3),(375,7470131,7470101,'82e',3.333,3),(375,7470132,7470102,'mon',100,1),(375,7470133,7470132,'201',50,1),(375,7470134,7470132,'013',50,1),(375,7470135,7470133,'adm',33.333,3),(375,7470136,7470133,'dmi',33.333,3),(375,7470137,7470133,'min',33.333,3),(375,7470138,7470135,'cap',16.667,1),(375,7470139,7470135,'apa',16.667,1),(375,7470140,7470135,'pac',16.667,1),(375,7470141,7470135,'aci',16.667,1),(375,7470142,7470135,'cit',16.667,1),(375,7470143,7470135,'ity',16.667,1),(375,7470144,7470138,'pat',50,1),(375,7470145,7470138,'ath',50,1),(375,7470146,7470144,'ele',25,1),(375,7470147,7470144,'lev',25,1),(375,7470148,7470144,'eve',25,1),(375,7470149,7470144,'ven',25,1),(375,7470150,7470146,'fre',14.286,1),(375,7470151,7470146,'ree',14.286,1),(375,7470152,7470146,'ees',14.286,1),(375,7470153,7470146,'esp',14.286,1),(375,7470154,7470146,'spa',14.286,1),(375,7470155,7470146,'pac',14.286,1),(375,7470156,7470146,'ace',14.286,1),(375,7470157,7470150,'dis',50,1),(375,7470158,7470150,'isk',50,1),(375,7470159,7470157,'ind',33.333,1),(375,7470160,7470157,'nde',33.333,1),(375,7470161,7470157,'dex',33.333,1),(375,7470162,7470159,'adm',8.333,1),(375,7470163,7470159,'dmi',8.333,1),(375,7470164,7470159,'min',8.333,1),(375,7470165,7470159,'ini',8.333,1),(375,7470166,7470159,'nis',8.333,1),(375,7470167,7470159,'ist',8.333,1),(375,7470168,7470159,'str',8.333,1),(375,7470169,7470159,'tra',8.333,1),(375,7470170,7470159,'rat',8.333,1),(375,7470171,7470159,'ati',8.333,1),(375,7470172,7470159,'tio',8.333,1),(375,7470173,7470159,'ion',8.333,1),(375,7470174,7470162,'sta',33.333,3),(375,7470175,7470162,'tat',33.333,3),(375,7470176,7470162,'ate',33.333,3),(375,7470177,7470174,'ena',20,2),(375,7470178,7470174,'nab',20,2),(375,7470179,7470174,'abl',20,2),(375,7470180,7470174,'ble',20,2),(375,7470181,7470174,'led',20,2),(375,7470182,7470177,'cac',33.333,1),(375,7470183,7470177,'ach',33.333,1),(375,7470184,7470177,'che',33.333,1),(375,7470185,7470182,'mod',50,2),(375,7470186,7470182,'ode',50,2),(375,7470187,7470185,'wri',14.286,2),(375,7470188,7470185,'rit',14.286,2),(375,7470189,7470185,'ite',14.286,2),(375,7470190,7470185,'tet',14.286,2),(375,7470191,7470185,'eth',14.286,2),(375,7470192,7470185,'thr',14.286,2),(375,7470193,7470185,'hru',14.286,2),(375,7470194,7470187,'ope',11.111,2),(375,7470195,7470187,'per',11.111,2),(375,7470196,7470187,'era',11.111,2),(375,7470197,7470187,'rat',11.111,2),(375,7470198,7470187,'ati',11.111,2),(375,7470199,7470187,'tio',11.111,2),(375,7470200,7470187,'ion',11.111,2),(375,7470201,7470187,'ona',11.111,2),(375,7470202,7470187,'nal',11.111,2),(375,7470203,7470194,'nor',25,1),(375,7470204,7470194,'orm',25,1),(375,7470205,7470194,'rma',25,1),(375,7470206,7470194,'mal',25,1),(375,7470207,7470203,'mes',20,1),(375,7470208,7470203,'ess',20,1),(375,7470209,7470203,'ssa',20,1),(375,7470210,7470203,'sag',20,1),(375,7470211,7470203,'age',20,1),(375,7470212,7470207,'per',11.111,1),(375,7470213,7470207,'erf',11.111,1),(375,7470214,7470207,'rfo',11.111,1),(375,7470215,7470207,'for',11.111,1),(375,7470216,7470207,'orm',11.111,1),(375,7470217,7470207,'rma',11.111,1),(375,7470218,7470207,'man',11.111,1),(375,7470219,7470207,'anc',11.111,1),(375,7470220,7470207,'nce',11.111,1),(375,7470221,7470212,'ide',12.5,1),(375,7470222,7470212,'den',12.5,1),(375,7470223,7470212,'ent',12.5,1),(375,7470224,7470212,'nti',12.5,1),(375,7470225,7470212,'tif',12.5,1),(375,7470226,7470212,'ifi',12.5,1),(375,7470227,7470212,'fie',12.5,1),(375,7470228,7470212,'ier',12.5,1),(375,7470229,7470221,'vdi',33.333,3),(375,7470230,7470221,'dis',33.333,3),(375,7470231,7470221,'isk',33.333,3),(375,7470232,7470229,'nam',50,1),(375,7470233,7470229,'ame',50,1),(375,7470234,7470232,'typ',50,1),(375,7470235,7470232,'ype',50,1),(375,7470236,7470234,'dir',25,1),(375,7470237,7470234,'ire',25,1),(375,7470238,7470234,'rec',25,1),(375,7470239,7470234,'ect',25,1),(376,7470241,7470240,'naa',100,2),(376,7470242,7470241,'600',3.333,3),(376,7470243,7470241,'000',3.333,3),(376,7470244,7470241,'00c',3.333,3),(376,7470245,7470241,'0c2',3.333,3),(376,7470246,7470241,'c29',3.333,3),(376,7470247,7470241,'299',3.333,3),(376,7470248,7470241,'99a',3.333,3),(376,7470249,7470241,'9a4',3.333,3),(376,7470250,7470241,'a4e',3.333,3),(376,7470251,7470241,'4eb',3.333,3),(376,7470252,7470241,'eb2',3.333,3),(376,7470253,7470241,'b2d',3.333,3),(376,7470254,7470241,'2d1',3.333,3),(376,7470255,7470241,'d1a',3.333,3),(376,7470256,7470241,'1ab',3.333,3),(376,7470257,7470241,'abc',3.333,3),(376,7470258,7470241,'bcf',3.333,3),(376,7470259,7470241,'cfd',3.333,3),(376,7470260,7470241,'fd9',3.333,3),(376,7470261,7470241,'d91',3.333,3),(376,7470262,7470241,'916',3.333,3),(376,7470263,7470241,'161',3.333,3),(376,7470264,7470241,'611',3.333,3),(376,7470265,7470241,'114',3.333,3),(376,7470266,7470241,'14b',3.333,3),(376,7470267,7470241,'4b8',3.333,3),(376,7470268,7470241,'b89',3.333,3),(376,7470269,7470241,'897',3.333,3),(376,7470270,7470241,'97a',3.333,3),(376,7470271,7470241,'7a2',3.333,3),(376,7470272,7470242,'mon',100,1),(376,7470273,7470272,'201',50,1),(376,7470274,7470272,'013',50,1),(376,7470275,7470273,'adm',33.333,3),(376,7470276,7470273,'dmi',33.333,3),(376,7470277,7470273,'min',33.333,3),(376,7470278,7470275,'cap',16.667,1),(376,7470279,7470275,'apa',16.667,1),(376,7470280,7470275,'pac',16.667,1),(376,7470281,7470275,'aci',16.667,1),(376,7470282,7470275,'cit',16.667,1),(376,7470283,7470275,'ity',16.667,1),(376,7470284,7470278,'pat',50,1),(376,7470285,7470278,'ath',50,1),(376,7470286,7470284,'twe',25,1),(376,7470287,7470284,'wel',25,1),(376,7470288,7470284,'elv',25,1),(376,7470289,7470284,'lve',25,1),(376,7470290,7470286,'fre',14.286,1),(376,7470291,7470286,'ree',14.286,1),(376,7470292,7470286,'ees',14.286,1),(376,7470293,7470286,'esp',14.286,1),(376,7470294,7470286,'spa',14.286,1),(376,7470295,7470286,'pac',14.286,1),(376,7470296,7470286,'ace',14.286,1),(376,7470297,7470290,'dis',50,1),(376,7470298,7470290,'isk',50,1),(376,7470299,7470297,'ind',33.333,1),(376,7470300,7470297,'nde',33.333,1),(376,7470301,7470297,'dex',33.333,1),(376,7470302,7470299,'adm',8.333,1),(376,7470303,7470299,'dmi',8.333,1),(376,7470304,7470299,'min',8.333,1),(376,7470305,7470299,'ini',8.333,1),(376,7470306,7470299,'nis',8.333,1),(376,7470307,7470299,'ist',8.333,1),(376,7470308,7470299,'str',8.333,1),(376,7470309,7470299,'tra',8.333,1),(376,7470310,7470299,'rat',8.333,1),(376,7470311,7470299,'ati',8.333,1),(376,7470312,7470299,'tio',8.333,1),(376,7470313,7470299,'ion',8.333,1),(376,7470314,7470302,'sta',33.333,3),(376,7470315,7470302,'tat',33.333,3),(376,7470316,7470302,'ate',33.333,3),(376,7470317,7470314,'ena',20,2),(376,7470318,7470314,'nab',20,2),(376,7470319,7470314,'abl',20,2),(376,7470320,7470314,'ble',20,2),(376,7470321,7470314,'led',20,2),(376,7470322,7470317,'cac',33.333,1),(376,7470323,7470317,'ach',33.333,1),(376,7470324,7470317,'che',33.333,1),(376,7470325,7470322,'mod',50,2),(376,7470326,7470322,'ode',50,2),(376,7470327,7470325,'wri',14.286,2),(376,7470328,7470325,'rit',14.286,2),(376,7470329,7470325,'ite',14.286,2),(376,7470330,7470325,'tet',14.286,2),(376,7470331,7470325,'eth',14.286,2),(376,7470332,7470325,'thr',14.286,2),(376,7470333,7470325,'hru',14.286,2),(376,7470334,7470327,'ope',11.111,2),(376,7470335,7470327,'per',11.111,2),(376,7470336,7470327,'era',11.111,2),(376,7470337,7470327,'rat',11.111,2),(376,7470338,7470327,'ati',11.111,2),(376,7470339,7470327,'tio',11.111,2),(376,7470340,7470327,'ion',11.111,2),(376,7470341,7470327,'ona',11.111,2),(376,7470342,7470327,'nal',11.111,2),(376,7470343,7470334,'nor',25,1),(376,7470344,7470334,'orm',25,1),(376,7470345,7470334,'rma',25,1),(376,7470346,7470334,'mal',25,1),(376,7470347,7470343,'mes',20,1),(376,7470348,7470343,'ess',20,1),(376,7470349,7470343,'ssa',20,1),(376,7470350,7470343,'sag',20,1),(376,7470351,7470343,'age',20,1),(376,7470352,7470347,'per',11.111,1),(376,7470353,7470347,'erf',11.111,1),(376,7470354,7470347,'rfo',11.111,1),(376,7470355,7470347,'for',11.111,1),(376,7470356,7470347,'orm',11.111,1),(376,7470357,7470347,'rma',11.111,1),(376,7470358,7470347,'man',11.111,1),(376,7470359,7470347,'anc',11.111,1),(376,7470360,7470347,'nce',11.111,1),(376,7470361,7470352,'ide',12.5,1),(376,7470362,7470352,'den',12.5,1),(376,7470363,7470352,'ent',12.5,1),(376,7470364,7470352,'nti',12.5,1),(376,7470365,7470352,'tif',12.5,1),(376,7470366,7470352,'ifi',12.5,1),(376,7470367,7470352,'fie',12.5,1),(376,7470368,7470352,'ier',12.5,1),(376,7470369,7470361,'vdi',33.333,3),(376,7470370,7470361,'dis',33.333,3),(376,7470371,7470361,'isk',33.333,3),(376,7470372,7470369,'nam',50,1),(376,7470373,7470369,'ame',50,1),(376,7470374,7470372,'typ',50,1),(376,7470375,7470372,'ype',50,1),(376,7470376,7470374,'dir',25,1),(376,7470377,7470374,'ire',25,1),(376,7470378,7470374,'rec',25,1),(376,7470379,7470374,'ect',25,1),(377,7470381,7470380,'naa',100,2),(377,7470382,7470381,'600',3.333,3),(377,7470383,7470381,'000',3.333,3),(377,7470384,7470381,'00c',3.333,3),(377,7470385,7470381,'0c2',3.333,3),(377,7470386,7470381,'c29',3.333,3),(377,7470387,7470381,'293',3.333,3),(377,7470388,7470381,'932',3.333,3),(377,7470389,7470381,'325',3.333,3),(377,7470390,7470381,'253',3.333,3),(377,7470391,7470381,'53c',3.333,3),(377,7470392,7470381,'3c4',3.333,3),(377,7470393,7470381,'c45',3.333,3),(377,7470394,7470381,'456',3.333,3),(377,7470395,7470381,'56e',3.333,3),(377,7470396,7470381,'6ea',3.333,3),(377,7470397,7470381,'ea7',3.333,3),(377,7470398,7470381,'a75',3.333,3),(377,7470399,7470381,'75b',3.333,3),(377,7470400,7470381,'5b9',3.333,3),(377,7470401,7470381,'b96',3.333,3),(377,7470402,7470381,'96f',3.333,3),(377,7470403,7470381,'6f9',3.333,3),(377,7470404,7470381,'f93',3.333,3),(377,7470405,7470381,'934',3.333,3),(377,7470406,7470381,'347',3.333,3),(377,7470407,7470381,'473',3.333,3),(377,7470408,7470381,'730',3.333,3),(377,7470409,7470381,'30b',3.333,3),(377,7470410,7470381,'0b7',3.333,3),(377,7470411,7470381,'b77',3.333,3),(377,7470412,7470382,'mon',100,1),(377,7470413,7470412,'201',50,1),(377,7470414,7470412,'013',50,1),(377,7470415,7470413,'adm',33.333,3),(377,7470416,7470413,'dmi',33.333,3),(377,7470417,7470413,'min',33.333,3),(377,7470418,7470415,'cap',16.667,1),(377,7470419,7470415,'apa',16.667,1),(377,7470420,7470415,'pac',16.667,1),(377,7470421,7470415,'aci',16.667,1),(377,7470422,7470415,'cit',16.667,1),(377,7470423,7470415,'ity',16.667,1),(377,7470424,7470418,'pat',50,1),(377,7470425,7470418,'ath',50,1),(377,7470426,7470424,'thi',16.667,1),(377,7470427,7470424,'hir',16.667,1),(377,7470428,7470424,'irt',16.667,1),(377,7470429,7470424,'rte',16.667,1),(377,7470430,7470424,'tee',16.667,1),(377,7470431,7470424,'een',16.667,1),(377,7470432,7470426,'fre',14.286,1),(377,7470433,7470426,'ree',14.286,1),(377,7470434,7470426,'ees',14.286,1),(377,7470435,7470426,'esp',14.286,1),(377,7470436,7470426,'spa',14.286,1),(377,7470437,7470426,'pac',14.286,1),(377,7470438,7470426,'ace',14.286,1),(377,7470439,7470432,'dis',50,1),(377,7470440,7470432,'isk',50,1),(377,7470441,7470439,'ind',33.333,1),(377,7470442,7470439,'nde',33.333,1),(377,7470443,7470439,'dex',33.333,1),(377,7470444,7470441,'adm',8.333,1),(377,7470445,7470441,'dmi',8.333,1),(377,7470446,7470441,'min',8.333,1),(377,7470447,7470441,'ini',8.333,1),(377,7470448,7470441,'nis',8.333,1),(377,7470449,7470441,'ist',8.333,1),(377,7470450,7470441,'str',8.333,1),(377,7470451,7470441,'tra',8.333,1),(377,7470452,7470441,'rat',8.333,1),(377,7470453,7470441,'ati',8.333,1),(377,7470454,7470441,'tio',8.333,1),(377,7470455,7470441,'ion',8.333,1),(377,7470456,7470444,'sta',33.333,3),(377,7470457,7470444,'tat',33.333,3),(377,7470458,7470444,'ate',33.333,3),(377,7470459,7470456,'ena',20,2),(377,7470460,7470456,'nab',20,2),(377,7470461,7470456,'abl',20,2),(377,7470462,7470456,'ble',20,2),(377,7470463,7470456,'led',20,2),(377,7470464,7470459,'cac',33.333,1),(377,7470465,7470459,'ach',33.333,1),(377,7470466,7470459,'che',33.333,1),(377,7470467,7470464,'mod',50,2),(377,7470468,7470464,'ode',50,2),(377,7470469,7470467,'wri',14.286,2),(377,7470470,7470467,'rit',14.286,2),(377,7470471,7470467,'ite',14.286,2),(377,7470472,7470467,'tet',14.286,2),(377,7470473,7470467,'eth',14.286,2),(377,7470474,7470467,'thr',14.286,2),(377,7470475,7470467,'hru',14.286,2),(377,7470476,7470469,'ope',11.111,2),(377,7470477,7470469,'per',11.111,2),(377,7470478,7470469,'era',11.111,2),(377,7470479,7470469,'rat',11.111,2),(377,7470480,7470469,'ati',11.111,2),(377,7470481,7470469,'tio',11.111,2),(377,7470482,7470469,'ion',11.111,2),(377,7470483,7470469,'ona',11.111,2),(377,7470484,7470469,'nal',11.111,2),(377,7470485,7470476,'nor',25,1),(377,7470486,7470476,'orm',25,1),(377,7470487,7470476,'rma',25,1),(377,7470488,7470476,'mal',25,1),(377,7470489,7470485,'mes',20,1),(377,7470490,7470485,'ess',20,1),(377,7470491,7470485,'ssa',20,1),(377,7470492,7470485,'sag',20,1),(377,7470493,7470485,'age',20,1),(377,7470494,7470489,'per',11.111,1),(377,7470495,7470489,'erf',11.111,1),(377,7470496,7470489,'rfo',11.111,1),(377,7470497,7470489,'for',11.111,1),(377,7470498,7470489,'orm',11.111,1),(377,7470499,7470489,'rma',11.111,1),(377,7470500,7470489,'man',11.111,1),(377,7470501,7470489,'anc',11.111,1),(377,7470502,7470489,'nce',11.111,1),(377,7470503,7470494,'ide',12.5,1),(377,7470504,7470494,'den',12.5,1),(377,7470505,7470494,'ent',12.5,1),(377,7470506,7470494,'nti',12.5,1),(377,7470507,7470494,'tif',12.5,1),(377,7470508,7470494,'ifi',12.5,1),(377,7470509,7470494,'fie',12.5,1),(377,7470510,7470494,'ier',12.5,1),(377,7470511,7470503,'vdi',33.333,3),(377,7470512,7470503,'dis',33.333,3),(377,7470513,7470503,'isk',33.333,3),(377,7470514,7470511,'nam',50,1),(377,7470515,7470511,'ame',50,1),(377,7470516,7470514,'typ',50,1),(377,7470517,7470514,'ype',50,1),(377,7470518,7470516,'dir',25,1),(377,7470519,7470516,'ire',25,1),(377,7470520,7470516,'rec',25,1),(377,7470521,7470516,'ect',25,1),(378,7470523,7470522,'naa',100,2),(378,7470524,7470523,'600',3.333,3),(378,7470525,7470523,'000',3.333,3),(378,7470526,7470523,'00c',3.333,3),(378,7470527,7470523,'0c2',3.333,3),(378,7470528,7470523,'c29',3.333,3),(378,7470529,7470523,'292',3.333,3),(378,7470530,7470523,'929',3.333,3),(378,7470531,7470523,'293',3.333,3),(378,7470532,7470523,'93d',3.333,3),(378,7470533,7470523,'3df',3.333,3),(378,7470534,7470523,'df6',3.333,3),(378,7470535,7470523,'f62',3.333,3),(378,7470536,7470523,'626',3.333,3),(378,7470537,7470523,'26e',3.333,3),(378,7470538,7470523,'6e2',3.333,3),(378,7470539,7470523,'e23',3.333,3),(378,7470540,7470523,'239',3.333,3),(378,7470541,7470523,'39b',3.333,3),(378,7470542,7470523,'9be',3.333,3),(378,7470543,7470523,'bea',3.333,3),(378,7470544,7470523,'ea9',3.333,3),(378,7470545,7470523,'a90',3.333,3),(378,7470546,7470523,'90f',3.333,3),(378,7470547,7470523,'0f3',3.333,3),(378,7470548,7470523,'f33',3.333,3),(378,7470549,7470523,'331',3.333,3),(378,7470550,7470523,'31f',3.333,3),(378,7470551,7470523,'1fb',3.333,3),(378,7470552,7470523,'fbf',3.333,3),(378,7470553,7470523,'bff',3.333,3),(378,7470554,7470524,'mon',100,1),(378,7470555,7470554,'201',50,1),(378,7470556,7470554,'013',50,1),(378,7470557,7470555,'adm',33.333,3),(378,7470558,7470555,'dmi',33.333,3),(378,7470559,7470555,'min',33.333,3),(378,7470560,7470557,'cap',16.667,1),(378,7470561,7470557,'apa',16.667,1),(378,7470562,7470557,'pac',16.667,1),(378,7470563,7470557,'aci',16.667,1),(378,7470564,7470557,'cit',16.667,1),(378,7470565,7470557,'ity',16.667,1),(378,7470566,7470560,'pat',50,1),(378,7470567,7470560,'ath',50,1),(378,7470568,7470566,'fre',14.286,1),(378,7470569,7470566,'ree',14.286,1),(378,7470570,7470566,'ees',14.286,1),(378,7470571,7470566,'esp',14.286,1),(378,7470572,7470566,'spa',14.286,1),(378,7470573,7470566,'pac',14.286,1),(378,7470574,7470566,'ace',14.286,1),(378,7470575,7470568,'dis',50,1),(378,7470576,7470568,'isk',50,1),(378,7470577,7470575,'ind',33.333,1),(378,7470578,7470575,'nde',33.333,1),(378,7470579,7470575,'dex',33.333,1),(378,7470580,7470577,'adm',8.333,1),(378,7470581,7470577,'dmi',8.333,1),(378,7470582,7470577,'min',8.333,1),(378,7470583,7470577,'ini',8.333,1),(378,7470584,7470577,'nis',8.333,1),(378,7470585,7470577,'ist',8.333,1),(378,7470586,7470577,'str',8.333,1),(378,7470587,7470577,'tra',8.333,1),(378,7470588,7470577,'rat',8.333,1),(378,7470589,7470577,'ati',8.333,1),(378,7470590,7470577,'tio',8.333,1),(378,7470591,7470577,'ion',8.333,1),(378,7470592,7470580,'sta',33.333,3),(378,7470593,7470580,'tat',33.333,3),(378,7470594,7470580,'ate',33.333,3),(378,7470595,7470592,'ena',20,2),(378,7470596,7470592,'nab',20,2),(378,7470597,7470592,'abl',20,2),(378,7470598,7470592,'ble',20,2),(378,7470599,7470592,'led',20,2),(378,7470600,7470595,'cac',33.333,1),(378,7470601,7470595,'ach',33.333,1),(378,7470602,7470595,'che',33.333,1),(378,7470603,7470600,'mod',50,2),(378,7470604,7470600,'ode',50,2),(378,7470605,7470603,'wri',14.286,2),(378,7470606,7470603,'rit',14.286,2),(378,7470607,7470603,'ite',14.286,2),(378,7470608,7470603,'tet',14.286,2),(378,7470609,7470603,'eth',14.286,2),(378,7470610,7470603,'thr',14.286,2),(378,7470611,7470603,'hru',14.286,2),(378,7470612,7470605,'ope',11.111,2),(378,7470613,7470605,'per',11.111,2),(378,7470614,7470605,'era',11.111,2),(378,7470615,7470605,'rat',11.111,2),(378,7470616,7470605,'ati',11.111,2),(378,7470617,7470605,'tio',11.111,2),(378,7470618,7470605,'ion',11.111,2),(378,7470619,7470605,'ona',11.111,2),(378,7470620,7470605,'nal',11.111,2),(378,7470621,7470612,'nor',25,1),(378,7470622,7470612,'orm',25,1),(378,7470623,7470612,'rma',25,1),(378,7470624,7470612,'mal',25,1),(378,7470625,7470621,'mes',20,1),(378,7470626,7470621,'ess',20,1),(378,7470627,7470621,'ssa',20,1),(378,7470628,7470621,'sag',20,1),(378,7470629,7470621,'age',20,1),(378,7470630,7470625,'per',11.111,1),(378,7470631,7470625,'erf',11.111,1),(378,7470632,7470625,'rfo',11.111,1),(378,7470633,7470625,'for',11.111,1),(378,7470634,7470625,'orm',11.111,1),(378,7470635,7470625,'rma',11.111,1),(378,7470636,7470625,'man',11.111,1),(378,7470637,7470625,'anc',11.111,1),(378,7470638,7470625,'nce',11.111,1),(378,7470639,7470630,'ide',12.5,1),(378,7470640,7470630,'den',12.5,1),(378,7470641,7470630,'ent',12.5,1),(378,7470642,7470630,'nti',12.5,1),(378,7470643,7470630,'tif',12.5,1),(378,7470644,7470630,'ifi',12.5,1),(378,7470645,7470630,'fie',12.5,1),(378,7470646,7470630,'ier',12.5,1),(378,7470647,7470639,'vdi',33.333,3),(378,7470648,7470639,'dis',33.333,3),(378,7470649,7470639,'isk',33.333,3),(378,7470650,7470647,'nam',50,1),(378,7470651,7470647,'ame',50,1),(378,7470652,7470650,'typ',50,1),(378,7470653,7470650,'ype',50,1),(378,7470654,7470652,'dir',25,1),(378,7470655,7470652,'ire',25,1),(378,7470656,7470652,'rec',25,1),(378,7470657,7470652,'ect',25,1),(379,7470659,7470658,'naa',100,2),(379,7470660,7470659,'600',3.333,3),(379,7470661,7470659,'000',3.333,3),(379,7470662,7470659,'00c',3.333,3),(379,7470663,7470659,'0c2',3.333,3),(379,7470664,7470659,'c29',3.333,3),(379,7470665,7470659,'29e',3.333,3),(379,7470666,7470659,'9e0',3.333,3),(379,7470667,7470659,'e04',3.333,3),(379,7470668,7470659,'046',3.333,3),(379,7470669,7470659,'464',3.333,3),(379,7470670,7470659,'64e',3.333,3),(379,7470671,7470659,'4e5',3.333,3),(379,7470672,7470659,'e56',3.333,3),(379,7470673,7470659,'562',3.333,3),(379,7470674,7470659,'62d',3.333,3),(379,7470675,7470659,'2dc',3.333,3),(379,7470676,7470659,'dcc',3.333,3),(379,7470677,7470659,'ccd',3.333,3),(379,7470678,7470659,'cd3',3.333,3),(379,7470679,7470659,'d37',3.333,3),(379,7470680,7470659,'37a',3.333,3),(379,7470681,7470659,'7ac',3.333,3),(379,7470682,7470659,'ac9',3.333,3),(379,7470683,7470659,'c96',3.333,3),(379,7470684,7470659,'96b',3.333,3),(379,7470685,7470659,'6b0',3.333,3),(379,7470686,7470659,'b0e',3.333,3),(379,7470687,7470659,'0e1',3.333,3),(379,7470688,7470659,'e1d',3.333,3),(379,7470689,7470659,'1dd',3.333,3),(379,7470690,7470660,'mon',100,1),(379,7470691,7470690,'201',50,1),(379,7470692,7470690,'013',50,1),(379,7470693,7470691,'adm',33.333,3),(379,7470694,7470691,'dmi',33.333,3),(379,7470695,7470691,'min',33.333,3),(379,7470696,7470693,'cap',16.667,1),(379,7470697,7470693,'apa',16.667,1),(379,7470698,7470693,'pac',16.667,1),(379,7470699,7470693,'aci',16.667,1),(379,7470700,7470693,'cit',16.667,1),(379,7470701,7470693,'ity',16.667,1),(379,7470702,7470696,'pat',50,1),(379,7470703,7470696,'ath',50,1),(379,7470704,7470702,'fre',14.286,1),(379,7470705,7470702,'ree',14.286,1),(379,7470706,7470702,'ees',14.286,1),(379,7470707,7470702,'esp',14.286,1),(379,7470708,7470702,'spa',14.286,1),(379,7470709,7470702,'pac',14.286,1),(379,7470710,7470702,'ace',14.286,1),(379,7470711,7470704,'dis',50,1),(379,7470712,7470704,'isk',50,1),(379,7470713,7470711,'ind',33.333,1),(379,7470714,7470711,'nde',33.333,1),(379,7470715,7470711,'dex',33.333,1),(379,7470716,7470713,'adm',8.333,1),(379,7470717,7470713,'dmi',8.333,1),(379,7470718,7470713,'min',8.333,1),(379,7470719,7470713,'ini',8.333,1),(379,7470720,7470713,'nis',8.333,1),(379,7470721,7470713,'ist',8.333,1),(379,7470722,7470713,'str',8.333,1),(379,7470723,7470713,'tra',8.333,1),(379,7470724,7470713,'rat',8.333,1),(379,7470725,7470713,'ati',8.333,1),(379,7470726,7470713,'tio',8.333,1),(379,7470727,7470713,'ion',8.333,1),(379,7470728,7470716,'sta',33.333,3),(379,7470729,7470716,'tat',33.333,3),(379,7470730,7470716,'ate',33.333,3),(379,7470731,7470728,'ena',20,2),(379,7470732,7470728,'nab',20,2),(379,7470733,7470728,'abl',20,2),(379,7470734,7470728,'ble',20,2),(379,7470735,7470728,'led',20,2),(379,7470736,7470731,'cac',33.333,1),(379,7470737,7470731,'ach',33.333,1),(379,7470738,7470731,'che',33.333,1),(379,7470739,7470736,'mod',50,2),(379,7470740,7470736,'ode',50,2),(379,7470741,7470739,'wri',14.286,2),(379,7470742,7470739,'rit',14.286,2),(379,7470743,7470739,'ite',14.286,2),(379,7470744,7470739,'tet',14.286,2),(379,7470745,7470739,'eth',14.286,2),(379,7470746,7470739,'thr',14.286,2),(379,7470747,7470739,'hru',14.286,2),(379,7470748,7470741,'ope',11.111,2),(379,7470749,7470741,'per',11.111,2),(379,7470750,7470741,'era',11.111,2),(379,7470751,7470741,'rat',11.111,2),(379,7470752,7470741,'ati',11.111,2),(379,7470753,7470741,'tio',11.111,2),(379,7470754,7470741,'ion',11.111,2),(379,7470755,7470741,'ona',11.111,2),(379,7470756,7470741,'nal',11.111,2),(379,7470757,7470748,'nor',25,1),(379,7470758,7470748,'orm',25,1),(379,7470759,7470748,'rma',25,1),(379,7470760,7470748,'mal',25,1),(379,7470761,7470757,'mes',20,1),(379,7470762,7470757,'ess',20,1),(379,7470763,7470757,'ssa',20,1),(379,7470764,7470757,'sag',20,1),(379,7470765,7470757,'age',20,1),(379,7470766,7470761,'per',11.111,1),(379,7470767,7470761,'erf',11.111,1),(379,7470768,7470761,'rfo',11.111,1),(379,7470769,7470761,'for',11.111,1),(379,7470770,7470761,'orm',11.111,1),(379,7470771,7470761,'rma',11.111,1),(379,7470772,7470761,'man',11.111,1),(379,7470773,7470761,'anc',11.111,1),(379,7470774,7470761,'nce',11.111,1),(379,7470775,7470766,'ide',12.5,1),(379,7470776,7470766,'den',12.5,1),(379,7470777,7470766,'ent',12.5,1),(379,7470778,7470766,'nti',12.5,1),(379,7470779,7470766,'tif',12.5,1),(379,7470780,7470766,'ifi',12.5,1),(379,7470781,7470766,'fie',12.5,1),(379,7470782,7470766,'ier',12.5,1),(379,7470783,7470775,'vdi',33.333,3),(379,7470784,7470775,'dis',33.333,3),(379,7470785,7470775,'isk',33.333,3),(379,7470786,7470783,'nam',50,1),(379,7470787,7470783,'ame',50,1),(379,7470788,7470786,'typ',50,1),(379,7470789,7470786,'ype',50,1),(379,7470790,7470788,'dir',25,1),(379,7470791,7470788,'ire',25,1),(379,7470792,7470788,'rec',25,1),(379,7470793,7470788,'ect',25,1),(380,7470795,7470794,'naa',100,2),(380,7470796,7470795,'600',3.333,3),(380,7470797,7470795,'000',3.333,3),(380,7470798,7470795,'00c',3.333,3),(380,7470799,7470795,'0c2',3.333,3),(380,7470800,7470795,'c29',3.333,3),(380,7470801,7470795,'291',3.333,3),(380,7470802,7470795,'916',3.333,3),(380,7470803,7470795,'16a',3.333,3),(380,7470804,7470795,'6a2',3.333,3),(380,7470805,7470795,'a26',3.333,3),(380,7470806,7470795,'269',3.333,3),(380,7470807,7470795,'69a',3.333,3),(380,7470808,7470795,'9a0',3.333,3),(380,7470809,7470795,'a0a',3.333,3),(380,7470810,7470795,'0ab',3.333,3),(380,7470811,7470795,'abd',3.333,3),(380,7470812,7470795,'bd1',3.333,3),(380,7470813,7470795,'d15',3.333,3),(380,7470814,7470795,'152',3.333,3),(380,7470815,7470795,'525',3.333,3),(380,7470816,7470795,'25c',3.333,3),(380,7470817,7470795,'5c1',3.333,3),(380,7470818,7470795,'c15',3.333,3),(380,7470819,7470795,'152',3.333,3),(380,7470820,7470795,'524',3.333,3),(380,7470821,7470795,'24c',3.333,3),(380,7470822,7470795,'4ce',3.333,3),(380,7470823,7470795,'ce6',3.333,3),(380,7470824,7470795,'e67',3.333,3),(380,7470825,7470795,'67c',3.333,3),(380,7470826,7470796,'mon',100,1),(380,7470827,7470826,'201',50,1),(380,7470828,7470826,'013',50,1),(380,7470829,7470827,'adm',33.333,3),(380,7470830,7470827,'dmi',33.333,3),(380,7470831,7470827,'min',33.333,3),(380,7470832,7470829,'cap',16.667,1),(380,7470833,7470829,'apa',16.667,1),(380,7470834,7470829,'pac',16.667,1),(380,7470835,7470829,'aci',16.667,1),(380,7470836,7470829,'cit',16.667,1),(380,7470837,7470829,'ity',16.667,1),(380,7470838,7470832,'pat',50,1),(380,7470839,7470832,'ath',50,1),(380,7470840,7470838,'fre',14.286,1),(380,7470841,7470838,'ree',14.286,1),(380,7470842,7470838,'ees',14.286,1),(380,7470843,7470838,'esp',14.286,1),(380,7470844,7470838,'spa',14.286,1),(380,7470845,7470838,'pac',14.286,1),(380,7470846,7470838,'ace',14.286,1),(380,7470847,7470840,'dis',50,1),(380,7470848,7470840,'isk',50,1),(380,7470849,7470847,'ind',33.333,1),(380,7470850,7470847,'nde',33.333,1),(380,7470851,7470847,'dex',33.333,1),(380,7470852,7470849,'adm',8.333,1),(380,7470853,7470849,'dmi',8.333,1),(380,7470854,7470849,'min',8.333,1),(380,7470855,7470849,'ini',8.333,1),(380,7470856,7470849,'nis',8.333,1),(380,7470857,7470849,'ist',8.333,1),(380,7470858,7470849,'str',8.333,1),(380,7470859,7470849,'tra',8.333,1),(380,7470860,7470849,'rat',8.333,1),(380,7470861,7470849,'ati',8.333,1),(380,7470862,7470849,'tio',8.333,1),(380,7470863,7470849,'ion',8.333,1),(380,7470864,7470852,'sta',33.333,3),(380,7470865,7470852,'tat',33.333,3),(380,7470866,7470852,'ate',33.333,3),(380,7470867,7470864,'ena',20,2),(380,7470868,7470864,'nab',20,2),(380,7470869,7470864,'abl',20,2),(380,7470870,7470864,'ble',20,2),(380,7470871,7470864,'led',20,2),(380,7470872,7470867,'cac',33.333,1),(380,7470873,7470867,'ach',33.333,1),(380,7470874,7470867,'che',33.333,1),(380,7470875,7470872,'mod',50,2),(380,7470876,7470872,'ode',50,2),(380,7470877,7470875,'wri',14.286,2),(380,7470878,7470875,'rit',14.286,2),(380,7470879,7470875,'ite',14.286,2),(380,7470880,7470875,'tet',14.286,2),(380,7470881,7470875,'eth',14.286,2),(380,7470882,7470875,'thr',14.286,2),(380,7470883,7470875,'hru',14.286,2),(380,7470884,7470877,'ope',11.111,2),(380,7470885,7470877,'per',11.111,2),(380,7470886,7470877,'era',11.111,2),(380,7470887,7470877,'rat',11.111,2),(380,7470888,7470877,'ati',11.111,2),(380,7470889,7470877,'tio',11.111,2),(380,7470890,7470877,'ion',11.111,2),(380,7470891,7470877,'ona',11.111,2),(380,7470892,7470877,'nal',11.111,2),(380,7470893,7470884,'nor',25,1),(380,7470894,7470884,'orm',25,1),(380,7470895,7470884,'rma',25,1),(380,7470896,7470884,'mal',25,1),(380,7470897,7470893,'mes',20,1),(380,7470898,7470893,'ess',20,1),(380,7470899,7470893,'ssa',20,1),(380,7470900,7470893,'sag',20,1),(380,7470901,7470893,'age',20,1),(380,7470902,7470897,'per',11.111,1),(380,7470903,7470897,'erf',11.111,1),(380,7470904,7470897,'rfo',11.111,1),(380,7470905,7470897,'for',11.111,1),(380,7470906,7470897,'orm',11.111,1),(380,7470907,7470897,'rma',11.111,1),(380,7470908,7470897,'man',11.111,1),(380,7470909,7470897,'anc',11.111,1),(380,7470910,7470897,'nce',11.111,1),(380,7470911,7470902,'ide',12.5,1),(380,7470912,7470902,'den',12.5,1),(380,7470913,7470902,'ent',12.5,1),(380,7470914,7470902,'nti',12.5,1),(380,7470915,7470902,'tif',12.5,1),(380,7470916,7470902,'ifi',12.5,1),(380,7470917,7470902,'fie',12.5,1),(380,7470918,7470902,'ier',12.5,1),(380,7470919,7470911,'vdi',33.333,3),(380,7470920,7470911,'dis',33.333,3),(380,7470921,7470911,'isk',33.333,3),(380,7470922,7470919,'nam',50,1),(380,7470923,7470919,'ame',50,1),(380,7470924,7470922,'typ',50,1),(380,7470925,7470922,'ype',50,1),(380,7470926,7470924,'dir',25,1),(380,7470927,7470924,'ire',25,1),(380,7470928,7470924,'rec',25,1),(380,7470929,7470924,'ect',25,1),(381,7470931,7470930,'naa',100,2),(381,7470932,7470931,'600',3.333,3),(381,7470933,7470931,'000',3.333,3),(381,7470934,7470931,'00c',3.333,3),(381,7470935,7470931,'0c2',3.333,3),(381,7470936,7470931,'c29',3.333,3),(381,7470937,7470931,'29c',3.333,3),(381,7470938,7470931,'9c2',3.333,3),(381,7470939,7470931,'c25',3.333,3),(381,7470940,7470931,'258',3.333,3),(381,7470941,7470931,'58d',3.333,3),(381,7470942,7470931,'8d0',3.333,3),(381,7470943,7470931,'d04',3.333,3),(381,7470944,7470931,'048',3.333,3),(381,7470945,7470931,'48d',3.333,3),(381,7470946,7470931,'8db',3.333,3),(381,7470947,7470931,'db9',3.333,3),(381,7470948,7470931,'b92',3.333,3),(381,7470949,7470931,'925',3.333,3),(381,7470950,7470931,'253',3.333,3),(381,7470951,7470931,'532',3.333,3),(381,7470952,7470931,'326',3.333,3),(381,7470953,7470931,'260',3.333,3),(381,7470954,7470931,'600',3.333,3),(381,7470955,7470931,'003',3.333,3),(381,7470956,7470931,'039',3.333,3),(381,7470957,7470931,'399',3.333,3),(381,7470958,7470931,'99c',3.333,3),(381,7470959,7470931,'9cc',3.333,3),(381,7470960,7470931,'cc4',3.333,3),(381,7470961,7470931,'c4f',3.333,3),(381,7470962,7470932,'mon',100,1),(381,7470963,7470962,'201',50,1),(381,7470964,7470962,'013',50,1),(381,7470965,7470963,'adm',33.333,3),(381,7470966,7470963,'dmi',33.333,3),(381,7470967,7470963,'min',33.333,3),(381,7470968,7470965,'cap',16.667,1),(381,7470969,7470965,'apa',16.667,1),(381,7470970,7470965,'pac',16.667,1),(381,7470971,7470965,'aci',16.667,1),(381,7470972,7470965,'cit',16.667,1),(381,7470973,7470965,'ity',16.667,1),(381,7470974,7470968,'pat',50,1),(381,7470975,7470968,'ath',50,1),(381,7470976,7470974,'fre',14.286,1),(381,7470977,7470974,'ree',14.286,1),(381,7470978,7470974,'ees',14.286,1),(381,7470979,7470974,'esp',14.286,1),(381,7470980,7470974,'spa',14.286,1),(381,7470981,7470974,'pac',14.286,1),(381,7470982,7470974,'ace',14.286,1),(381,7470983,7470976,'dis',50,1),(381,7470984,7470976,'isk',50,1),(381,7470985,7470983,'ind',33.333,1),(381,7470986,7470983,'nde',33.333,1),(381,7470987,7470983,'dex',33.333,1),(381,7470988,7470985,'adm',8.333,1),(381,7470989,7470985,'dmi',8.333,1),(381,7470990,7470985,'min',8.333,1),(381,7470991,7470985,'ini',8.333,1),(381,7470992,7470985,'nis',8.333,1),(381,7470993,7470985,'ist',8.333,1),(381,7470994,7470985,'str',8.333,1),(381,7470995,7470985,'tra',8.333,1),(381,7470996,7470985,'rat',8.333,1),(381,7470997,7470985,'ati',8.333,1),(381,7470998,7470985,'tio',8.333,1),(381,7470999,7470985,'ion',8.333,1),(381,7471000,7470988,'sta',33.333,3),(381,7471001,7470988,'tat',33.333,3),(381,7471002,7470988,'ate',33.333,3),(381,7471003,7471000,'ena',20,2),(381,7471004,7471000,'nab',20,2),(381,7471005,7471000,'abl',20,2),(381,7471006,7471000,'ble',20,2),(381,7471007,7471000,'led',20,2),(381,7471008,7471003,'cac',33.333,1),(381,7471009,7471003,'ach',33.333,1),(381,7471010,7471003,'che',33.333,1),(381,7471011,7471008,'mod',50,2),(381,7471012,7471008,'ode',50,2),(381,7471013,7471011,'wri',14.286,2),(381,7471014,7471011,'rit',14.286,2),(381,7471015,7471011,'ite',14.286,2),(381,7471016,7471011,'tet',14.286,2),(381,7471017,7471011,'eth',14.286,2),(381,7471018,7471011,'thr',14.286,2),(381,7471019,7471011,'hru',14.286,2),(381,7471020,7471013,'ope',11.111,2),(381,7471021,7471013,'per',11.111,2),(381,7471022,7471013,'era',11.111,2),(381,7471023,7471013,'rat',11.111,2),(381,7471024,7471013,'ati',11.111,2),(381,7471025,7471013,'tio',11.111,2),(381,7471026,7471013,'ion',11.111,2),(381,7471027,7471013,'ona',11.111,2),(381,7471028,7471013,'nal',11.111,2),(381,7471029,7471020,'nor',25,1),(381,7471030,7471020,'orm',25,1),(381,7471031,7471020,'rma',25,1),(381,7471032,7471020,'mal',25,1),(381,7471033,7471029,'mes',20,1),(381,7471034,7471029,'ess',20,1),(381,7471035,7471029,'ssa',20,1),(381,7471036,7471029,'sag',20,1),(381,7471037,7471029,'age',20,1),(381,7471038,7471033,'per',11.111,1),(381,7471039,7471033,'erf',11.111,1),(381,7471040,7471033,'rfo',11.111,1),(381,7471041,7471033,'for',11.111,1),(381,7471042,7471033,'orm',11.111,1),(381,7471043,7471033,'rma',11.111,1),(381,7471044,7471033,'man',11.111,1),(381,7471045,7471033,'anc',11.111,1),(381,7471046,7471033,'nce',11.111,1),(381,7471047,7471038,'ide',12.5,1),(381,7471048,7471038,'den',12.5,1),(381,7471049,7471038,'ent',12.5,1),(381,7471050,7471038,'nti',12.5,1),(381,7471051,7471038,'tif',12.5,1),(381,7471052,7471038,'ifi',12.5,1),(381,7471053,7471038,'fie',12.5,1),(381,7471054,7471038,'ier',12.5,1),(381,7471055,7471047,'vdi',33.333,3),(381,7471056,7471047,'dis',33.333,3),(381,7471057,7471047,'isk',33.333,3),(381,7471058,7471055,'nam',50,1),(381,7471059,7471055,'ame',50,1),(381,7471060,7471058,'typ',50,1),(381,7471061,7471058,'ype',50,1),(381,7471062,7471060,'dir',25,1),(381,7471063,7471060,'ire',25,1),(381,7471064,7471060,'rec',25,1),(381,7471065,7471060,'ect',25,1),(382,7471067,7471066,'naa',100,2),(382,7471068,7471067,'600',3.333,3),(382,7471069,7471067,'000',3.333,3),(382,7471070,7471067,'00c',3.333,3),(382,7471071,7471067,'0c2',3.333,3),(382,7471072,7471067,'c29',3.333,3),(382,7471073,7471067,'297',3.333,3),(382,7471074,7471067,'97b',3.333,3),(382,7471075,7471067,'7b7',3.333,3),(382,7471076,7471067,'b71',3.333,3),(382,7471077,7471067,'719',3.333,3),(382,7471078,7471067,'195',3.333,3),(382,7471079,7471067,'957',3.333,3),(382,7471080,7471067,'579',3.333,3),(382,7471081,7471067,'790',3.333,3),(382,7471082,7471067,'901',3.333,3),(382,7471083,7471067,'011',3.333,3),(382,7471084,7471067,'11f',3.333,3),(382,7471085,7471067,'1fa',3.333,3),(382,7471086,7471067,'fa5',3.333,3),(382,7471087,7471067,'a5a',3.333,3),(382,7471088,7471067,'5a7',3.333,3),(382,7471089,7471067,'a72',3.333,3),(382,7471090,7471067,'723',3.333,3),(382,7471091,7471067,'23f',3.333,3),(382,7471092,7471067,'3f8',3.333,3),(382,7471093,7471067,'f8e',3.333,3),(382,7471094,7471067,'8e0',3.333,3),(382,7471095,7471067,'e00',3.333,3),(382,7471096,7471067,'006',3.333,3),(382,7471097,7471067,'066',3.333,3),(382,7471098,7471068,'mon',100,1),(382,7471099,7471098,'201',50,1),(382,7471100,7471098,'013',50,1),(382,7471101,7471099,'adm',33.333,3),(382,7471102,7471099,'dmi',33.333,3),(382,7471103,7471099,'min',33.333,3),(382,7471104,7471101,'cap',16.667,1),(382,7471105,7471101,'apa',16.667,1),(382,7471106,7471101,'pac',16.667,1),(382,7471107,7471101,'aci',16.667,1),(382,7471108,7471101,'cit',16.667,1),(382,7471109,7471101,'ity',16.667,1),(382,7471110,7471104,'pat',50,1),(382,7471111,7471104,'ath',50,1),(382,7471112,7471110,'fre',14.286,1),(382,7471113,7471110,'ree',14.286,1),(382,7471114,7471110,'ees',14.286,1),(382,7471115,7471110,'esp',14.286,1),(382,7471116,7471110,'spa',14.286,1),(382,7471117,7471110,'pac',14.286,1),(382,7471118,7471110,'ace',14.286,1),(382,7471119,7471112,'dis',50,1),(382,7471120,7471112,'isk',50,1),(382,7471121,7471119,'ind',33.333,1),(382,7471122,7471119,'nde',33.333,1),(382,7471123,7471119,'dex',33.333,1),(382,7471124,7471121,'adm',8.333,1),(382,7471125,7471121,'dmi',8.333,1),(382,7471126,7471121,'min',8.333,1),(382,7471127,7471121,'ini',8.333,1),(382,7471128,7471121,'nis',8.333,1),(382,7471129,7471121,'ist',8.333,1),(382,7471130,7471121,'str',8.333,1),(382,7471131,7471121,'tra',8.333,1),(382,7471132,7471121,'rat',8.333,1),(382,7471133,7471121,'ati',8.333,1),(382,7471134,7471121,'tio',8.333,1),(382,7471135,7471121,'ion',8.333,1),(382,7471136,7471124,'sta',33.333,3),(382,7471137,7471124,'tat',33.333,3),(382,7471138,7471124,'ate',33.333,3),(382,7471139,7471136,'ena',20,2),(382,7471140,7471136,'nab',20,2),(382,7471141,7471136,'abl',20,2),(382,7471142,7471136,'ble',20,2),(382,7471143,7471136,'led',20,2),(382,7471144,7471139,'cac',33.333,1),(382,7471145,7471139,'ach',33.333,1),(382,7471146,7471139,'che',33.333,1),(382,7471147,7471144,'mod',50,2),(382,7471148,7471144,'ode',50,2),(382,7471149,7471147,'wri',14.286,2),(382,7471150,7471147,'rit',14.286,2),(382,7471151,7471147,'ite',14.286,2),(382,7471152,7471147,'tet',14.286,2),(382,7471153,7471147,'eth',14.286,2),(382,7471154,7471147,'thr',14.286,2),(382,7471155,7471147,'hru',14.286,2),(382,7471156,7471149,'ope',11.111,2),(382,7471157,7471149,'per',11.111,2),(382,7471158,7471149,'era',11.111,2),(382,7471159,7471149,'rat',11.111,2),(382,7471160,7471149,'ati',11.111,2),(382,7471161,7471149,'tio',11.111,2),(382,7471162,7471149,'ion',11.111,2),(382,7471163,7471149,'ona',11.111,2),(382,7471164,7471149,'nal',11.111,2),(382,7471165,7471156,'nor',25,1),(382,7471166,7471156,'orm',25,1),(382,7471167,7471156,'rma',25,1),(382,7471168,7471156,'mal',25,1),(382,7471169,7471165,'mes',20,1),(382,7471170,7471165,'ess',20,1),(382,7471171,7471165,'ssa',20,1),(382,7471172,7471165,'sag',20,1),(382,7471173,7471165,'age',20,1),(382,7471174,7471169,'per',11.111,1),(382,7471175,7471169,'erf',11.111,1),(382,7471176,7471169,'rfo',11.111,1),(382,7471177,7471169,'for',11.111,1),(382,7471178,7471169,'orm',11.111,1),(382,7471179,7471169,'rma',11.111,1),(382,7471180,7471169,'man',11.111,1),(382,7471181,7471169,'anc',11.111,1),(382,7471182,7471169,'nce',11.111,1),(382,7471183,7471174,'ide',12.5,1),(382,7471184,7471174,'den',12.5,1),(382,7471185,7471174,'ent',12.5,1),(382,7471186,7471174,'nti',12.5,1),(382,7471187,7471174,'tif',12.5,1),(382,7471188,7471174,'ifi',12.5,1),(382,7471189,7471174,'fie',12.5,1),(382,7471190,7471174,'ier',12.5,1),(382,7471191,7471183,'vdi',33.333,3),(382,7471192,7471183,'dis',33.333,3),(382,7471193,7471183,'isk',33.333,3),(382,7471194,7471191,'nam',50,1),(382,7471195,7471191,'ame',50,1),(382,7471196,7471194,'typ',50,1),(382,7471197,7471194,'ype',50,1),(382,7471198,7471196,'dir',25,1),(382,7471199,7471196,'ire',25,1),(382,7471200,7471196,'rec',25,1),(382,7471201,7471196,'ect',25,1),(383,7471203,7471202,'naa',100,2),(383,7471204,7471203,'600',3.333,3),(383,7471205,7471203,'000',3.333,3),(383,7471206,7471203,'00c',3.333,3),(383,7471207,7471203,'0c2',3.333,3),(383,7471208,7471203,'c29',3.333,3),(383,7471209,7471203,'29f',3.333,3),(383,7471210,7471203,'9fe',3.333,3),(383,7471211,7471203,'fe6',3.333,3),(383,7471212,7471203,'e6b',3.333,3),(383,7471213,7471203,'6b1',3.333,3),(383,7471214,7471203,'b17',3.333,3),(383,7471215,7471203,'177',3.333,3),(383,7471216,7471203,'775',3.333,3),(383,7471217,7471203,'759',3.333,3),(383,7471218,7471203,'596',3.333,3),(383,7471219,7471203,'96c',3.333,3),(383,7471220,7471203,'6c1',3.333,3),(383,7471221,7471203,'c1c',3.333,3),(383,7471222,7471203,'1c4',3.333,3),(383,7471223,7471203,'c4b',3.333,3),(383,7471224,7471203,'4b5',3.333,3),(383,7471225,7471203,'b55',3.333,3),(383,7471226,7471203,'553',3.333,3),(383,7471227,7471203,'53c',3.333,3),(383,7471228,7471203,'3ca',3.333,3),(383,7471229,7471203,'ca4',3.333,3),(383,7471230,7471203,'a45',3.333,3),(383,7471231,7471203,'45a',3.333,3),(383,7471232,7471203,'5a3',3.333,3),(383,7471233,7471203,'a3f',3.333,3),(383,7471234,7471204,'mon',100,1),(383,7471235,7471234,'201',50,1),(383,7471236,7471234,'013',50,1),(383,7471237,7471235,'adm',33.333,3),(383,7471238,7471235,'dmi',33.333,3),(383,7471239,7471235,'min',33.333,3),(383,7471240,7471237,'cap',16.667,1),(383,7471241,7471237,'apa',16.667,1),(383,7471242,7471237,'pac',16.667,1),(383,7471243,7471237,'aci',16.667,1),(383,7471244,7471237,'cit',16.667,1),(383,7471245,7471237,'ity',16.667,1),(383,7471246,7471240,'pat',50,1),(383,7471247,7471240,'ath',50,1),(383,7471248,7471246,'fre',14.286,1),(383,7471249,7471246,'ree',14.286,1),(383,7471250,7471246,'ees',14.286,1),(383,7471251,7471246,'esp',14.286,1),(383,7471252,7471246,'spa',14.286,1),(383,7471253,7471246,'pac',14.286,1),(383,7471254,7471246,'ace',14.286,1),(383,7471255,7471248,'dis',50,1),(383,7471256,7471248,'isk',50,1),(383,7471257,7471255,'ind',33.333,1),(383,7471258,7471255,'nde',33.333,1),(383,7471259,7471255,'dex',33.333,1),(383,7471260,7471257,'adm',8.333,1),(383,7471261,7471257,'dmi',8.333,1),(383,7471262,7471257,'min',8.333,1),(383,7471263,7471257,'ini',8.333,1),(383,7471264,7471257,'nis',8.333,1),(383,7471265,7471257,'ist',8.333,1),(383,7471266,7471257,'str',8.333,1),(383,7471267,7471257,'tra',8.333,1),(383,7471268,7471257,'rat',8.333,1),(383,7471269,7471257,'ati',8.333,1),(383,7471270,7471257,'tio',8.333,1),(383,7471271,7471257,'ion',8.333,1),(383,7471272,7471260,'sta',33.333,3),(383,7471273,7471260,'tat',33.333,3),(383,7471274,7471260,'ate',33.333,3),(383,7471275,7471272,'ena',20,2),(383,7471276,7471272,'nab',20,2),(383,7471277,7471272,'abl',20,2),(383,7471278,7471272,'ble',20,2),(383,7471279,7471272,'led',20,2),(383,7471280,7471275,'cac',33.333,1),(383,7471281,7471275,'ach',33.333,1),(383,7471282,7471275,'che',33.333,1),(383,7471283,7471280,'mod',50,2),(383,7471284,7471280,'ode',50,2),(383,7471285,7471283,'wri',14.286,2),(383,7471286,7471283,'rit',14.286,2),(383,7471287,7471283,'ite',14.286,2),(383,7471288,7471283,'tet',14.286,2),(383,7471289,7471283,'eth',14.286,2),(383,7471290,7471283,'thr',14.286,2),(383,7471291,7471283,'hru',14.286,2),(383,7471292,7471285,'ope',11.111,2),(383,7471293,7471285,'per',11.111,2),(383,7471294,7471285,'era',11.111,2),(383,7471295,7471285,'rat',11.111,2),(383,7471296,7471285,'ati',11.111,2),(383,7471297,7471285,'tio',11.111,2),(383,7471298,7471285,'ion',11.111,2),(383,7471299,7471285,'ona',11.111,2),(383,7471300,7471285,'nal',11.111,2),(383,7471301,7471292,'nor',25,1),(383,7471302,7471292,'orm',25,1),(383,7471303,7471292,'rma',25,1),(383,7471304,7471292,'mal',25,1),(383,7471305,7471301,'mes',20,1),(383,7471306,7471301,'ess',20,1),(383,7471307,7471301,'ssa',20,1),(383,7471308,7471301,'sag',20,1),(383,7471309,7471301,'age',20,1),(383,7471310,7471305,'per',11.111,1),(383,7471311,7471305,'erf',11.111,1),(383,7471312,7471305,'rfo',11.111,1),(383,7471313,7471305,'for',11.111,1),(383,7471314,7471305,'orm',11.111,1),(383,7471315,7471305,'rma',11.111,1),(383,7471316,7471305,'man',11.111,1),(383,7471317,7471305,'anc',11.111,1),(383,7471318,7471305,'nce',11.111,1),(383,7471319,7471310,'ide',12.5,1),(383,7471320,7471310,'den',12.5,1),(383,7471321,7471310,'ent',12.5,1),(383,7471322,7471310,'nti',12.5,1),(383,7471323,7471310,'tif',12.5,1),(383,7471324,7471310,'ifi',12.5,1),(383,7471325,7471310,'fie',12.5,1),(383,7471326,7471310,'ier',12.5,1),(383,7471327,7471319,'vdi',33.333,3),(383,7471328,7471319,'dis',33.333,3),(383,7471329,7471319,'isk',33.333,3),(383,7471330,7471327,'nam',50,1),(383,7471331,7471327,'ame',50,1),(383,7471332,7471330,'typ',50,1),(383,7471333,7471330,'ype',50,1),(383,7471334,7471332,'dir',25,1),(383,7471335,7471332,'ire',25,1),(383,7471336,7471332,'rec',25,1),(383,7471337,7471332,'ect',25,1),(384,7471339,7471338,'naa',100,2),(384,7471340,7471339,'600',3.333,3),(384,7471341,7471339,'000',3.333,3),(384,7471342,7471339,'00c',3.333,3),(384,7471343,7471339,'0c2',3.333,3),(384,7471344,7471339,'c29',3.333,3),(384,7471345,7471339,'293',3.333,3),(384,7471346,7471339,'93a',3.333,3),(384,7471347,7471339,'3a7',3.333,3),(384,7471348,7471339,'a79',3.333,3),(384,7471349,7471339,'796',3.333,3),(384,7471350,7471339,'965',3.333,3),(384,7471351,7471339,'653',3.333,3),(384,7471352,7471339,'53f',3.333,3),(384,7471353,7471339,'3f2',3.333,3),(384,7471354,7471339,'f23',3.333,3),(384,7471355,7471339,'23a',3.333,3),(384,7471356,7471339,'3ad',3.333,3),(384,7471357,7471339,'ada',3.333,3),(384,7471358,7471339,'dac',3.333,3),(384,7471359,7471339,'aca',3.333,3),(384,7471360,7471339,'cab',3.333,3),(384,7471361,7471339,'ab3',3.333,3),(384,7471362,7471339,'b30',3.333,3),(384,7471363,7471339,'302',3.333,3),(384,7471364,7471339,'02a',3.333,3),(384,7471365,7471339,'2a3',3.333,3),(384,7471366,7471339,'a35',3.333,3),(384,7471367,7471339,'35b',3.333,3),(384,7471368,7471339,'5b4',3.333,3),(384,7471369,7471339,'b4c',3.333,3),(384,7471370,7471340,'mon',100,1),(384,7471371,7471370,'201',50,1),(384,7471372,7471370,'013',50,1),(384,7471373,7471371,'adm',33.333,3),(384,7471374,7471371,'dmi',33.333,3),(384,7471375,7471371,'min',33.333,3),(384,7471376,7471373,'cap',16.667,1),(384,7471377,7471373,'apa',16.667,1),(384,7471378,7471373,'pac',16.667,1),(384,7471379,7471373,'aci',16.667,1),(384,7471380,7471373,'cit',16.667,1),(384,7471381,7471373,'ity',16.667,1),(384,7471382,7471376,'pat',50,1),(384,7471383,7471376,'ath',50,1),(384,7471384,7471382,'fre',14.286,1),(384,7471385,7471382,'ree',14.286,1),(384,7471386,7471382,'ees',14.286,1),(384,7471387,7471382,'esp',14.286,1),(384,7471388,7471382,'spa',14.286,1),(384,7471389,7471382,'pac',14.286,1),(384,7471390,7471382,'ace',14.286,1),(384,7471391,7471384,'dis',50,1),(384,7471392,7471384,'isk',50,1),(384,7471393,7471391,'ind',33.333,1),(384,7471394,7471391,'nde',33.333,1),(384,7471395,7471391,'dex',33.333,1),(384,7471396,7471393,'adm',8.333,1),(384,7471397,7471393,'dmi',8.333,1),(384,7471398,7471393,'min',8.333,1),(384,7471399,7471393,'ini',8.333,1),(384,7471400,7471393,'nis',8.333,1),(384,7471401,7471393,'ist',8.333,1),(384,7471402,7471393,'str',8.333,1),(384,7471403,7471393,'tra',8.333,1),(384,7471404,7471393,'rat',8.333,1),(384,7471405,7471393,'ati',8.333,1),(384,7471406,7471393,'tio',8.333,1),(384,7471407,7471393,'ion',8.333,1),(384,7471408,7471396,'sta',33.333,3),(384,7471409,7471396,'tat',33.333,3),(384,7471410,7471396,'ate',33.333,3),(384,7471411,7471408,'ena',20,2),(384,7471412,7471408,'nab',20,2),(384,7471413,7471408,'abl',20,2),(384,7471414,7471408,'ble',20,2),(384,7471415,7471408,'led',20,2),(384,7471416,7471411,'cac',33.333,1),(384,7471417,7471411,'ach',33.333,1),(384,7471418,7471411,'che',33.333,1),(384,7471419,7471416,'mod',50,2),(384,7471420,7471416,'ode',50,2),(384,7471421,7471419,'wri',14.286,2),(384,7471422,7471419,'rit',14.286,2),(384,7471423,7471419,'ite',14.286,2),(384,7471424,7471419,'tet',14.286,2),(384,7471425,7471419,'eth',14.286,2),(384,7471426,7471419,'thr',14.286,2),(384,7471427,7471419,'hru',14.286,2),(384,7471428,7471421,'ope',11.111,2),(384,7471429,7471421,'per',11.111,2),(384,7471430,7471421,'era',11.111,2),(384,7471431,7471421,'rat',11.111,2),(384,7471432,7471421,'ati',11.111,2),(384,7471433,7471421,'tio',11.111,2),(384,7471434,7471421,'ion',11.111,2),(384,7471435,7471421,'ona',11.111,2),(384,7471436,7471421,'nal',11.111,2),(384,7471437,7471428,'nor',25,1),(384,7471438,7471428,'orm',25,1),(384,7471439,7471428,'rma',25,1),(384,7471440,7471428,'mal',25,1),(384,7471441,7471437,'mes',20,1),(384,7471442,7471437,'ess',20,1),(384,7471443,7471437,'ssa',20,1),(384,7471444,7471437,'sag',20,1),(384,7471445,7471437,'age',20,1),(384,7471446,7471441,'per',11.111,1),(384,7471447,7471441,'erf',11.111,1),(384,7471448,7471441,'rfo',11.111,1),(384,7471449,7471441,'for',11.111,1),(384,7471450,7471441,'orm',11.111,1),(384,7471451,7471441,'rma',11.111,1),(384,7471452,7471441,'man',11.111,1),(384,7471453,7471441,'anc',11.111,1),(384,7471454,7471441,'nce',11.111,1),(384,7471455,7471446,'ide',12.5,1),(384,7471456,7471446,'den',12.5,1),(384,7471457,7471446,'ent',12.5,1),(384,7471458,7471446,'nti',12.5,1),(384,7471459,7471446,'tif',12.5,1),(384,7471460,7471446,'ifi',12.5,1),(384,7471461,7471446,'fie',12.5,1),(384,7471462,7471446,'ier',12.5,1),(384,7471463,7471455,'vdi',33.333,3),(384,7471464,7471455,'dis',33.333,3),(384,7471465,7471455,'isk',33.333,3),(384,7471466,7471463,'nam',50,1),(384,7471467,7471463,'ame',50,1),(384,7471468,7471466,'typ',50,1),(384,7471469,7471466,'ype',50,1),(384,7471470,7471468,'dir',25,1),(384,7471471,7471468,'ire',25,1),(384,7471472,7471468,'rec',25,1),(384,7471473,7471468,'ect',25,1),(385,7471475,7471474,'naa',100,2),(385,7471476,7471475,'600',3.333,3),(385,7471477,7471475,'000',3.333,3),(385,7471478,7471475,'00c',3.333,3),(385,7471479,7471475,'0c2',3.333,3),(385,7471480,7471475,'c29',3.333,3),(385,7471481,7471475,'293',3.333,3),(385,7471482,7471475,'938',3.333,3),(385,7471483,7471475,'38d',3.333,3),(385,7471484,7471475,'8d6',3.333,3),(385,7471485,7471475,'d61',3.333,3),(385,7471486,7471475,'61e',3.333,3),(385,7471487,7471475,'1e7',3.333,3),(385,7471488,7471475,'e77',3.333,3),(385,7471489,7471475,'772',3.333,3),(385,7471490,7471475,'72e',3.333,3),(385,7471491,7471475,'2e9',3.333,3),(385,7471492,7471475,'e92',3.333,3),(385,7471493,7471475,'92d',3.333,3),(385,7471494,7471475,'2d2',3.333,3),(385,7471495,7471475,'d24',3.333,3),(385,7471496,7471475,'242',3.333,3),(385,7471497,7471475,'42e',3.333,3),(385,7471498,7471475,'2e8',3.333,3),(385,7471499,7471475,'e8f',3.333,3),(385,7471500,7471475,'8f6',3.333,3),(385,7471501,7471475,'f61',3.333,3),(385,7471502,7471475,'616',3.333,3),(385,7471503,7471475,'16b',3.333,3),(385,7471504,7471475,'6bc',3.333,3),(385,7471505,7471475,'bc8',3.333,3),(385,7471506,7471476,'mon',100,1),(385,7471507,7471506,'201',50,1),(385,7471508,7471506,'013',50,1),(385,7471509,7471507,'adm',33.333,3),(385,7471510,7471507,'dmi',33.333,3),(385,7471511,7471507,'min',33.333,3),(385,7471512,7471509,'cap',16.667,1),(385,7471513,7471509,'apa',16.667,1),(385,7471514,7471509,'pac',16.667,1),(385,7471515,7471509,'aci',16.667,1),(385,7471516,7471509,'cit',16.667,1),(385,7471517,7471509,'ity',16.667,1),(385,7471518,7471512,'pat',50,1),(385,7471519,7471512,'ath',50,1),(385,7471520,7471518,'fre',14.286,1),(385,7471521,7471518,'ree',14.286,1),(385,7471522,7471518,'ees',14.286,1),(385,7471523,7471518,'esp',14.286,1),(385,7471524,7471518,'spa',14.286,1),(385,7471525,7471518,'pac',14.286,1),(385,7471526,7471518,'ace',14.286,1),(385,7471527,7471520,'dis',50,1),(385,7471528,7471520,'isk',50,1),(385,7471529,7471527,'ind',33.333,1),(385,7471530,7471527,'nde',33.333,1),(385,7471531,7471527,'dex',33.333,1),(385,7471532,7471529,'adm',8.333,1),(385,7471533,7471529,'dmi',8.333,1),(385,7471534,7471529,'min',8.333,1),(385,7471535,7471529,'ini',8.333,1),(385,7471536,7471529,'nis',8.333,1),(385,7471537,7471529,'ist',8.333,1),(385,7471538,7471529,'str',8.333,1),(385,7471539,7471529,'tra',8.333,1),(385,7471540,7471529,'rat',8.333,1),(385,7471541,7471529,'ati',8.333,1),(385,7471542,7471529,'tio',8.333,1),(385,7471543,7471529,'ion',8.333,1),(385,7471544,7471532,'sta',33.333,3),(385,7471545,7471532,'tat',33.333,3),(385,7471546,7471532,'ate',33.333,3),(385,7471547,7471544,'ena',20,2),(385,7471548,7471544,'nab',20,2),(385,7471549,7471544,'abl',20,2),(385,7471550,7471544,'ble',20,2),(385,7471551,7471544,'led',20,2),(385,7471552,7471547,'cac',33.333,1),(385,7471553,7471547,'ach',33.333,1),(385,7471554,7471547,'che',33.333,1),(385,7471555,7471552,'mod',50,2),(385,7471556,7471552,'ode',50,2),(385,7471557,7471555,'wri',14.286,2),(385,7471558,7471555,'rit',14.286,2),(385,7471559,7471555,'ite',14.286,2),(385,7471560,7471555,'tet',14.286,2),(385,7471561,7471555,'eth',14.286,2),(385,7471562,7471555,'thr',14.286,2),(385,7471563,7471555,'hru',14.286,2),(385,7471564,7471557,'ope',11.111,2),(385,7471565,7471557,'per',11.111,2),(385,7471566,7471557,'era',11.111,2),(385,7471567,7471557,'rat',11.111,2),(385,7471568,7471557,'ati',11.111,2),(385,7471569,7471557,'tio',11.111,2),(385,7471570,7471557,'ion',11.111,2),(385,7471571,7471557,'ona',11.111,2),(385,7471572,7471557,'nal',11.111,2),(385,7471573,7471564,'nor',25,1),(385,7471574,7471564,'orm',25,1),(385,7471575,7471564,'rma',25,1),(385,7471576,7471564,'mal',25,1),(385,7471577,7471573,'mes',20,1),(385,7471578,7471573,'ess',20,1),(385,7471579,7471573,'ssa',20,1),(385,7471580,7471573,'sag',20,1),(385,7471581,7471573,'age',20,1),(385,7471582,7471577,'per',11.111,1),(385,7471583,7471577,'erf',11.111,1),(385,7471584,7471577,'rfo',11.111,1),(385,7471585,7471577,'for',11.111,1),(385,7471586,7471577,'orm',11.111,1),(385,7471587,7471577,'rma',11.111,1),(385,7471588,7471577,'man',11.111,1),(385,7471589,7471577,'anc',11.111,1),(385,7471590,7471577,'nce',11.111,1),(385,7471591,7471582,'ide',12.5,1),(385,7471592,7471582,'den',12.5,1),(385,7471593,7471582,'ent',12.5,1),(385,7471594,7471582,'nti',12.5,1),(385,7471595,7471582,'tif',12.5,1),(385,7471596,7471582,'ifi',12.5,1),(385,7471597,7471582,'fie',12.5,1),(385,7471598,7471582,'ier',12.5,1),(385,7471599,7471591,'vdi',33.333,3),(385,7471600,7471591,'dis',33.333,3),(385,7471601,7471591,'isk',33.333,3),(385,7471602,7471599,'nam',50,1),(385,7471603,7471599,'ame',50,1),(385,7471604,7471602,'typ',50,1),(385,7471605,7471602,'ype',50,1),(385,7471606,7471604,'dir',25,1),(385,7471607,7471604,'ire',25,1),(385,7471608,7471604,'rec',25,1),(385,7471609,7471604,'ect',25,1),(386,7471611,7471610,'naa',100,2),(386,7471612,7471611,'600',3.333,3),(386,7471613,7471611,'000',3.333,3),(386,7471614,7471611,'00c',3.333,3),(386,7471615,7471611,'0c2',3.333,3),(386,7471616,7471611,'c29',3.333,3),(386,7471617,7471611,'295',3.333,3),(386,7471618,7471611,'954',3.333,3),(386,7471619,7471611,'547',3.333,3),(386,7471620,7471611,'475',3.333,3),(386,7471621,7471611,'75d',3.333,3),(386,7471622,7471611,'5d0',3.333,3),(386,7471623,7471611,'d09',3.333,3),(386,7471624,7471611,'09a',3.333,3),(386,7471625,7471611,'9ab',3.333,3),(386,7471626,7471611,'ab8',3.333,3),(386,7471627,7471611,'b8a',3.333,3),(386,7471628,7471611,'8ae',3.333,3),(386,7471629,7471611,'ae1',3.333,3),(386,7471630,7471611,'e1d',3.333,3),(386,7471631,7471611,'1de',3.333,3),(386,7471632,7471611,'de9',3.333,3),(386,7471633,7471611,'e90',3.333,3),(386,7471634,7471611,'90a',3.333,3),(386,7471635,7471611,'0a7',3.333,3),(386,7471636,7471611,'a71',3.333,3),(386,7471637,7471611,'71d',3.333,3),(386,7471638,7471611,'1de',3.333,3),(386,7471639,7471611,'dec',3.333,3),(386,7471640,7471611,'ec6',3.333,3),(386,7471641,7471611,'c6f',3.333,3),(386,7471642,7471612,'mon',100,1),(386,7471643,7471642,'201',50,1),(386,7471644,7471642,'013',50,1),(386,7471645,7471643,'adm',33.333,3),(386,7471646,7471643,'dmi',33.333,3),(386,7471647,7471643,'min',33.333,3),(386,7471648,7471645,'cap',16.667,1),(386,7471649,7471645,'apa',16.667,1),(386,7471650,7471645,'pac',16.667,1),(386,7471651,7471645,'aci',16.667,1),(386,7471652,7471645,'cit',16.667,1),(386,7471653,7471645,'ity',16.667,1),(386,7471654,7471648,'pat',50,1),(386,7471655,7471648,'ath',50,1),(386,7471656,7471654,'fre',14.286,1),(386,7471657,7471654,'ree',14.286,1),(386,7471658,7471654,'ees',14.286,1),(386,7471659,7471654,'esp',14.286,1),(386,7471660,7471654,'spa',14.286,1),(386,7471661,7471654,'pac',14.286,1),(386,7471662,7471654,'ace',14.286,1),(386,7471663,7471656,'dis',50,1),(386,7471664,7471656,'isk',50,1),(386,7471665,7471663,'ind',33.333,1),(386,7471666,7471663,'nde',33.333,1),(386,7471667,7471663,'dex',33.333,1),(386,7471668,7471665,'adm',8.333,1),(386,7471669,7471665,'dmi',8.333,1),(386,7471670,7471665,'min',8.333,1),(386,7471671,7471665,'ini',8.333,1),(386,7471672,7471665,'nis',8.333,1),(386,7471673,7471665,'ist',8.333,1),(386,7471674,7471665,'str',8.333,1),(386,7471675,7471665,'tra',8.333,1),(386,7471676,7471665,'rat',8.333,1),(386,7471677,7471665,'ati',8.333,1),(386,7471678,7471665,'tio',8.333,1),(386,7471679,7471665,'ion',8.333,1),(386,7471680,7471668,'sta',33.333,3),(386,7471681,7471668,'tat',33.333,3),(386,7471682,7471668,'ate',33.333,3),(386,7471683,7471680,'ena',20,2),(386,7471684,7471680,'nab',20,2),(386,7471685,7471680,'abl',20,2),(386,7471686,7471680,'ble',20,2),(386,7471687,7471680,'led',20,2),(386,7471688,7471683,'cac',33.333,1),(386,7471689,7471683,'ach',33.333,1),(386,7471690,7471683,'che',33.333,1),(386,7471691,7471688,'mod',50,2),(386,7471692,7471688,'ode',50,2),(386,7471693,7471691,'wri',14.286,2),(386,7471694,7471691,'rit',14.286,2),(386,7471695,7471691,'ite',14.286,2),(386,7471696,7471691,'tet',14.286,2),(386,7471697,7471691,'eth',14.286,2),(386,7471698,7471691,'thr',14.286,2),(386,7471699,7471691,'hru',14.286,2),(386,7471700,7471693,'ope',11.111,2),(386,7471701,7471693,'per',11.111,2),(386,7471702,7471693,'era',11.111,2),(386,7471703,7471693,'rat',11.111,2),(386,7471704,7471693,'ati',11.111,2),(386,7471705,7471693,'tio',11.111,2),(386,7471706,7471693,'ion',11.111,2),(386,7471707,7471693,'ona',11.111,2),(386,7471708,7471693,'nal',11.111,2),(386,7471709,7471700,'nor',25,1),(386,7471710,7471700,'orm',25,1),(386,7471711,7471700,'rma',25,1),(386,7471712,7471700,'mal',25,1),(386,7471713,7471709,'mes',20,1),(386,7471714,7471709,'ess',20,1),(386,7471715,7471709,'ssa',20,1),(386,7471716,7471709,'sag',20,1),(386,7471717,7471709,'age',20,1),(386,7471718,7471713,'per',11.111,1),(386,7471719,7471713,'erf',11.111,1),(386,7471720,7471713,'rfo',11.111,1),(386,7471721,7471713,'for',11.111,1),(386,7471722,7471713,'orm',11.111,1),(386,7471723,7471713,'rma',11.111,1),(386,7471724,7471713,'man',11.111,1),(386,7471725,7471713,'anc',11.111,1),(386,7471726,7471713,'nce',11.111,1),(386,7471727,7471718,'ide',12.5,1),(386,7471728,7471718,'den',12.5,1),(386,7471729,7471718,'ent',12.5,1),(386,7471730,7471718,'nti',12.5,1),(386,7471731,7471718,'tif',12.5,1),(386,7471732,7471718,'ifi',12.5,1),(386,7471733,7471718,'fie',12.5,1),(386,7471734,7471718,'ier',12.5,1),(386,7471735,7471727,'vdi',33.333,3),(386,7471736,7471727,'dis',33.333,3),(386,7471737,7471727,'isk',33.333,3),(386,7471738,7471735,'nam',50,1),(386,7471739,7471735,'ame',50,1),(386,7471740,7471738,'typ',50,1),(386,7471741,7471738,'ype',50,1),(386,7471742,7471740,'dir',25,1),(386,7471743,7471740,'ire',25,1),(386,7471744,7471740,'rec',25,1),(386,7471745,7471740,'ect',25,1),(387,7471747,7471746,'naa',100,2),(387,7471748,7471747,'600',3.333,3),(387,7471749,7471747,'000',3.333,3),(387,7471750,7471747,'00c',3.333,3),(387,7471751,7471747,'0c2',3.333,3),(387,7471752,7471747,'c29',3.333,3),(387,7471753,7471747,'294',3.333,3),(387,7471754,7471747,'948',3.333,3),(387,7471755,7471747,'48c',3.333,3),(387,7471756,7471747,'8ce',3.333,3),(387,7471757,7471747,'cee',3.333,3),(387,7471758,7471747,'ee8',3.333,3),(387,7471759,7471747,'e8e',3.333,3),(387,7471760,7471747,'8e3',3.333,3),(387,7471761,7471747,'e30',3.333,3),(387,7471762,7471747,'308',3.333,3),(387,7471763,7471747,'082',3.333,3),(387,7471764,7471747,'822',3.333,3),(387,7471765,7471747,'227',3.333,3),(387,7471766,7471747,'27c',3.333,3),(387,7471767,7471747,'7c1',3.333,3),(387,7471768,7471747,'c11',3.333,3),(387,7471769,7471747,'117',3.333,3),(387,7471770,7471747,'172',3.333,3),(387,7471771,7471747,'728',3.333,3),(387,7471772,7471747,'28d',3.333,3),(387,7471773,7471747,'8d1',3.333,3),(387,7471774,7471747,'d12',3.333,3),(387,7471775,7471747,'129',3.333,3),(387,7471776,7471747,'299',3.333,3),(387,7471777,7471747,'994',3.333,3),(387,7471778,7471748,'mon',100,1),(387,7471779,7471778,'201',50,1),(387,7471780,7471778,'013',50,1),(387,7471781,7471779,'adm',33.333,3),(387,7471782,7471779,'dmi',33.333,3),(387,7471783,7471779,'min',33.333,3),(387,7471784,7471781,'cap',16.667,1),(387,7471785,7471781,'apa',16.667,1),(387,7471786,7471781,'pac',16.667,1),(387,7471787,7471781,'aci',16.667,1),(387,7471788,7471781,'cit',16.667,1),(387,7471789,7471781,'ity',16.667,1),(387,7471790,7471784,'pat',50,1),(387,7471791,7471784,'ath',50,1),(387,7471792,7471790,'fre',14.286,1),(387,7471793,7471790,'ree',14.286,1),(387,7471794,7471790,'ees',14.286,1),(387,7471795,7471790,'esp',14.286,1),(387,7471796,7471790,'spa',14.286,1),(387,7471797,7471790,'pac',14.286,1),(387,7471798,7471790,'ace',14.286,1),(387,7471799,7471792,'dis',50,1),(387,7471800,7471792,'isk',50,1),(387,7471801,7471799,'ind',33.333,1),(387,7471802,7471799,'nde',33.333,1),(387,7471803,7471799,'dex',33.333,1),(387,7471804,7471801,'adm',8.333,1),(387,7471805,7471801,'dmi',8.333,1),(387,7471806,7471801,'min',8.333,1),(387,7471807,7471801,'ini',8.333,1),(387,7471808,7471801,'nis',8.333,1),(387,7471809,7471801,'ist',8.333,1),(387,7471810,7471801,'str',8.333,1),(387,7471811,7471801,'tra',8.333,1),(387,7471812,7471801,'rat',8.333,1),(387,7471813,7471801,'ati',8.333,1),(387,7471814,7471801,'tio',8.333,1),(387,7471815,7471801,'ion',8.333,1),(387,7471816,7471804,'sta',33.333,3),(387,7471817,7471804,'tat',33.333,3),(387,7471818,7471804,'ate',33.333,3),(387,7471819,7471816,'ena',20,2),(387,7471820,7471816,'nab',20,2),(387,7471821,7471816,'abl',20,2),(387,7471822,7471816,'ble',20,2),(387,7471823,7471816,'led',20,2),(387,7471824,7471819,'cac',33.333,1),(387,7471825,7471819,'ach',33.333,1),(387,7471826,7471819,'che',33.333,1),(387,7471827,7471824,'mod',50,2),(387,7471828,7471824,'ode',50,2),(387,7471829,7471827,'wri',14.286,2),(387,7471830,7471827,'rit',14.286,2),(387,7471831,7471827,'ite',14.286,2),(387,7471832,7471827,'tet',14.286,2),(387,7471833,7471827,'eth',14.286,2),(387,7471834,7471827,'thr',14.286,2),(387,7471835,7471827,'hru',14.286,2),(387,7471836,7471829,'ope',11.111,2),(387,7471837,7471829,'per',11.111,2),(387,7471838,7471829,'era',11.111,2),(387,7471839,7471829,'rat',11.111,2),(387,7471840,7471829,'ati',11.111,2),(387,7471841,7471829,'tio',11.111,2),(387,7471842,7471829,'ion',11.111,2),(387,7471843,7471829,'ona',11.111,2),(387,7471844,7471829,'nal',11.111,2),(387,7471845,7471836,'nor',25,1),(387,7471846,7471836,'orm',25,1),(387,7471847,7471836,'rma',25,1),(387,7471848,7471836,'mal',25,1),(387,7471849,7471845,'mes',20,1),(387,7471850,7471845,'ess',20,1),(387,7471851,7471845,'ssa',20,1),(387,7471852,7471845,'sag',20,1),(387,7471853,7471845,'age',20,1),(387,7471854,7471849,'per',11.111,1),(387,7471855,7471849,'erf',11.111,1),(387,7471856,7471849,'rfo',11.111,1),(387,7471857,7471849,'for',11.111,1),(387,7471858,7471849,'orm',11.111,1),(387,7471859,7471849,'rma',11.111,1),(387,7471860,7471849,'man',11.111,1),(387,7471861,7471849,'anc',11.111,1),(387,7471862,7471849,'nce',11.111,1),(387,7471863,7471854,'ide',12.5,1),(387,7471864,7471854,'den',12.5,1),(387,7471865,7471854,'ent',12.5,1),(387,7471866,7471854,'nti',12.5,1),(387,7471867,7471854,'tif',12.5,1),(387,7471868,7471854,'ifi',12.5,1),(387,7471869,7471854,'fie',12.5,1),(387,7471870,7471854,'ier',12.5,1),(387,7471871,7471863,'vdi',33.333,3),(387,7471872,7471863,'dis',33.333,3),(387,7471873,7471863,'isk',33.333,3),(387,7471874,7471871,'nam',50,1),(387,7471875,7471871,'ame',50,1),(387,7471876,7471874,'typ',50,1),(387,7471877,7471874,'ype',50,1),(387,7471878,7471876,'dir',25,1),(387,7471879,7471876,'ire',25,1),(387,7471880,7471876,'rec',25,1),(387,7471881,7471876,'ect',25,1),(388,7471883,7471882,'naa',100,2),(388,7471884,7471883,'600',3.333,3),(388,7471885,7471883,'000',3.333,3),(388,7471886,7471883,'00c',3.333,3),(388,7471887,7471883,'0c2',3.333,3),(388,7471888,7471883,'c29',3.333,3),(388,7471889,7471883,'291',3.333,3),(388,7471890,7471883,'91e',3.333,3),(388,7471891,7471883,'1e7',3.333,3),(388,7471892,7471883,'e76',3.333,3),(388,7471893,7471883,'766',3.333,3),(388,7471894,7471883,'664',3.333,3),(388,7471895,7471883,'64b',3.333,3),(388,7471896,7471883,'4b3',3.333,3),(388,7471897,7471883,'b34',3.333,3),(388,7471898,7471883,'34d',3.333,3),(388,7471899,7471883,'4dc',3.333,3),(388,7471900,7471883,'dc2',3.333,3),(388,7471901,7471883,'c23',3.333,3),(388,7471902,7471883,'236',3.333,3),(388,7471903,7471883,'36a',3.333,3),(388,7471904,7471883,'6a7',3.333,3),(388,7471905,7471883,'a78',3.333,3),(388,7471906,7471883,'785',3.333,3),(388,7471907,7471883,'85a',3.333,3),(388,7471908,7471883,'5a1',3.333,3),(388,7471909,7471883,'a15',3.333,3),(388,7471910,7471883,'15a',3.333,3),(388,7471911,7471883,'5a7',3.333,3),(388,7471912,7471883,'a71',3.333,3),(388,7471913,7471883,'710',3.333,3),(388,7471914,7471884,'mon',100,1),(388,7471915,7471914,'201',50,1),(388,7471916,7471914,'013',50,1),(388,7471917,7471915,'adm',33.333,3),(388,7471918,7471915,'dmi',33.333,3),(388,7471919,7471915,'min',33.333,3),(388,7471920,7471917,'cap',16.667,1),(388,7471921,7471917,'apa',16.667,1),(388,7471922,7471917,'pac',16.667,1),(388,7471923,7471917,'aci',16.667,1),(388,7471924,7471917,'cit',16.667,1),(388,7471925,7471917,'ity',16.667,1),(388,7471926,7471920,'pat',50,1),(388,7471927,7471920,'ath',50,1),(388,7471928,7471926,'fre',14.286,1),(388,7471929,7471926,'ree',14.286,1),(388,7471930,7471926,'ees',14.286,1),(388,7471931,7471926,'esp',14.286,1),(388,7471932,7471926,'spa',14.286,1),(388,7471933,7471926,'pac',14.286,1),(388,7471934,7471926,'ace',14.286,1),(388,7471935,7471928,'dis',50,1),(388,7471936,7471928,'isk',50,1),(388,7471937,7471935,'ind',33.333,1),(388,7471938,7471935,'nde',33.333,1),(388,7471939,7471935,'dex',33.333,1),(388,7471940,7471937,'adm',8.333,1),(388,7471941,7471937,'dmi',8.333,1),(388,7471942,7471937,'min',8.333,1),(388,7471943,7471937,'ini',8.333,1),(388,7471944,7471937,'nis',8.333,1),(388,7471945,7471937,'ist',8.333,1),(388,7471946,7471937,'str',8.333,1),(388,7471947,7471937,'tra',8.333,1),(388,7471948,7471937,'rat',8.333,1),(388,7471949,7471937,'ati',8.333,1),(388,7471950,7471937,'tio',8.333,1),(388,7471951,7471937,'ion',8.333,1),(388,7471952,7471940,'sta',33.333,3),(388,7471953,7471940,'tat',33.333,3),(388,7471954,7471940,'ate',33.333,3),(388,7471955,7471952,'ena',20,2),(388,7471956,7471952,'nab',20,2),(388,7471957,7471952,'abl',20,2),(388,7471958,7471952,'ble',20,2),(388,7471959,7471952,'led',20,2),(388,7471960,7471955,'cac',33.333,1),(388,7471961,7471955,'ach',33.333,1),(388,7471962,7471955,'che',33.333,1),(388,7471963,7471960,'mod',50,2),(388,7471964,7471960,'ode',50,2),(388,7471965,7471963,'wri',14.286,2),(388,7471966,7471963,'rit',14.286,2),(388,7471967,7471963,'ite',14.286,2),(388,7471968,7471963,'tet',14.286,2),(388,7471969,7471963,'eth',14.286,2),(388,7471970,7471963,'thr',14.286,2),(388,7471971,7471963,'hru',14.286,2),(388,7471972,7471965,'ope',11.111,2),(388,7471973,7471965,'per',11.111,2),(388,7471974,7471965,'era',11.111,2),(388,7471975,7471965,'rat',11.111,2),(388,7471976,7471965,'ati',11.111,2),(388,7471977,7471965,'tio',11.111,2),(388,7471978,7471965,'ion',11.111,2),(388,7471979,7471965,'ona',11.111,2),(388,7471980,7471965,'nal',11.111,2),(388,7471981,7471972,'nor',25,1),(388,7471982,7471972,'orm',25,1),(388,7471983,7471972,'rma',25,1),(388,7471984,7471972,'mal',25,1),(388,7471985,7471981,'mes',20,1),(388,7471986,7471981,'ess',20,1),(388,7471987,7471981,'ssa',20,1),(388,7471988,7471981,'sag',20,1),(388,7471989,7471981,'age',20,1),(388,7471990,7471985,'per',11.111,1),(388,7471991,7471985,'erf',11.111,1),(388,7471992,7471985,'rfo',11.111,1),(388,7471993,7471985,'for',11.111,1),(388,7471994,7471985,'orm',11.111,1),(388,7471995,7471985,'rma',11.111,1),(388,7471996,7471985,'man',11.111,1),(388,7471997,7471985,'anc',11.111,1),(388,7471998,7471985,'nce',11.111,1),(388,7471999,7471990,'ide',12.5,1),(388,7472000,7471990,'den',12.5,1),(388,7472001,7471990,'ent',12.5,1),(388,7472002,7471990,'nti',12.5,1),(388,7472003,7471990,'tif',12.5,1),(388,7472004,7471990,'ifi',12.5,1),(388,7472005,7471990,'fie',12.5,1),(388,7472006,7471990,'ier',12.5,1),(388,7472007,7471999,'vdi',33.333,3),(388,7472008,7471999,'dis',33.333,3),(388,7472009,7471999,'isk',33.333,3),(388,7472010,7472007,'nam',50,1),(388,7472011,7472007,'ame',50,1),(388,7472012,7472010,'typ',50,1),(388,7472013,7472010,'ype',50,1),(388,7472014,7472012,'dir',25,1),(388,7472015,7472012,'ire',25,1),(388,7472016,7472012,'rec',25,1),(388,7472017,7472012,'ect',25,1),(389,7472019,7472018,'naa',100,2),(389,7472020,7472019,'600',3.333,3),(389,7472021,7472019,'000',3.333,3),(389,7472022,7472019,'00c',3.333,3),(389,7472023,7472019,'0c2',3.333,3),(389,7472024,7472019,'c29',3.333,3),(389,7472025,7472019,'297',3.333,3),(389,7472026,7472019,'978',3.333,3),(389,7472027,7472019,'783',3.333,3),(389,7472028,7472019,'83f',3.333,3),(389,7472029,7472019,'3fc',3.333,3),(389,7472030,7472019,'fc4',3.333,3),(389,7472031,7472019,'c4f',3.333,3),(389,7472032,7472019,'4f9',3.333,3),(389,7472033,7472019,'f97',3.333,3),(389,7472034,7472019,'972',3.333,3),(389,7472035,7472019,'72a',3.333,3),(389,7472036,7472019,'2a0',3.333,3),(389,7472037,7472019,'a0e',3.333,3),(389,7472038,7472019,'0e2',3.333,3),(389,7472039,7472019,'e2a',3.333,3),(389,7472040,7472019,'2aa',3.333,3),(389,7472041,7472019,'aa7',3.333,3),(389,7472042,7472019,'a7a',3.333,3),(389,7472043,7472019,'7af',3.333,3),(389,7472044,7472019,'af5',3.333,3),(389,7472045,7472019,'f5c',3.333,3),(389,7472046,7472019,'5c9',3.333,3),(389,7472047,7472019,'c9e',3.333,3),(389,7472048,7472019,'9eb',3.333,3),(389,7472049,7472019,'ebc',3.333,3),(389,7472050,7472020,'mon',100,1),(389,7472051,7472050,'201',50,1),(389,7472052,7472050,'013',50,1),(389,7472053,7472051,'adm',33.333,3),(389,7472054,7472051,'dmi',33.333,3),(389,7472055,7472051,'min',33.333,3),(389,7472056,7472053,'cap',16.667,1),(389,7472057,7472053,'apa',16.667,1),(389,7472058,7472053,'pac',16.667,1),(389,7472059,7472053,'aci',16.667,1),(389,7472060,7472053,'cit',16.667,1),(389,7472061,7472053,'ity',16.667,1),(389,7472062,7472056,'pat',50,1),(389,7472063,7472056,'ath',50,1),(389,7472064,7472062,'fre',14.286,1),(389,7472065,7472062,'ree',14.286,1),(389,7472066,7472062,'ees',14.286,1),(389,7472067,7472062,'esp',14.286,1),(389,7472068,7472062,'spa',14.286,1),(389,7472069,7472062,'pac',14.286,1),(389,7472070,7472062,'ace',14.286,1),(389,7472071,7472064,'dis',50,1),(389,7472072,7472064,'isk',50,1),(389,7472073,7472071,'ind',33.333,1),(389,7472074,7472071,'nde',33.333,1),(389,7472075,7472071,'dex',33.333,1),(389,7472076,7472073,'adm',8.333,1),(389,7472077,7472073,'dmi',8.333,1),(389,7472078,7472073,'min',8.333,1),(389,7472079,7472073,'ini',8.333,1),(389,7472080,7472073,'nis',8.333,1),(389,7472081,7472073,'ist',8.333,1),(389,7472082,7472073,'str',8.333,1),(389,7472083,7472073,'tra',8.333,1),(389,7472084,7472073,'rat',8.333,1),(389,7472085,7472073,'ati',8.333,1),(389,7472086,7472073,'tio',8.333,1),(389,7472087,7472073,'ion',8.333,1),(389,7472088,7472076,'sta',33.333,3),(389,7472089,7472076,'tat',33.333,3),(389,7472090,7472076,'ate',33.333,3),(389,7472091,7472088,'ena',20,2),(389,7472092,7472088,'nab',20,2),(389,7472093,7472088,'abl',20,2),(389,7472094,7472088,'ble',20,2),(389,7472095,7472088,'led',20,2),(389,7472096,7472091,'cac',33.333,1),(389,7472097,7472091,'ach',33.333,1),(389,7472098,7472091,'che',33.333,1),(389,7472099,7472096,'mod',50,2),(389,7472100,7472096,'ode',50,2),(389,7472101,7472099,'wri',14.286,2),(389,7472102,7472099,'rit',14.286,2),(389,7472103,7472099,'ite',14.286,2),(389,7472104,7472099,'tet',14.286,2),(389,7472105,7472099,'eth',14.286,2),(389,7472106,7472099,'thr',14.286,2),(389,7472107,7472099,'hru',14.286,2),(389,7472108,7472101,'ope',11.111,2),(389,7472109,7472101,'per',11.111,2),(389,7472110,7472101,'era',11.111,2),(389,7472111,7472101,'rat',11.111,2),(389,7472112,7472101,'ati',11.111,2),(389,7472113,7472101,'tio',11.111,2),(389,7472114,7472101,'ion',11.111,2),(389,7472115,7472101,'ona',11.111,2),(389,7472116,7472101,'nal',11.111,2),(389,7472117,7472108,'nor',25,1),(389,7472118,7472108,'orm',25,1),(389,7472119,7472108,'rma',25,1),(389,7472120,7472108,'mal',25,1),(389,7472121,7472117,'mes',20,1),(389,7472122,7472117,'ess',20,1),(389,7472123,7472117,'ssa',20,1),(389,7472124,7472117,'sag',20,1),(389,7472125,7472117,'age',20,1),(389,7472126,7472121,'per',11.111,1),(389,7472127,7472121,'erf',11.111,1),(389,7472128,7472121,'rfo',11.111,1),(389,7472129,7472121,'for',11.111,1),(389,7472130,7472121,'orm',11.111,1),(389,7472131,7472121,'rma',11.111,1),(389,7472132,7472121,'man',11.111,1),(389,7472133,7472121,'anc',11.111,1),(389,7472134,7472121,'nce',11.111,1),(389,7472135,7472126,'ide',12.5,1),(389,7472136,7472126,'den',12.5,1),(389,7472137,7472126,'ent',12.5,1),(389,7472138,7472126,'nti',12.5,1),(389,7472139,7472126,'tif',12.5,1),(389,7472140,7472126,'ifi',12.5,1),(389,7472141,7472126,'fie',12.5,1),(389,7472142,7472126,'ier',12.5,1),(389,7472143,7472135,'vdi',33.333,3),(389,7472144,7472135,'dis',33.333,3),(389,7472145,7472135,'isk',33.333,3),(389,7472146,7472143,'nam',50,1),(389,7472147,7472143,'ame',50,1),(389,7472148,7472146,'typ',50,1),(389,7472149,7472146,'ype',50,1),(389,7472150,7472148,'dir',25,1),(389,7472151,7472148,'ire',25,1),(389,7472152,7472148,'rec',25,1),(389,7472153,7472148,'ect',25,1),(390,7472155,7472154,'naa',100,2),(390,7472156,7472155,'600',3.333,3),(390,7472157,7472155,'000',3.333,3),(390,7472158,7472155,'00c',3.333,3),(390,7472159,7472155,'0c2',3.333,3),(390,7472160,7472155,'c29',3.333,3),(390,7472161,7472155,'29d',3.333,3),(390,7472162,7472155,'9de',3.333,3),(390,7472163,7472155,'de2',3.333,3),(390,7472164,7472155,'e23',3.333,3),(390,7472165,7472155,'233',3.333,3),(390,7472166,7472155,'33a',3.333,3),(390,7472167,7472155,'3a6',3.333,3),(390,7472168,7472155,'a6c',3.333,3),(390,7472169,7472155,'6cb',3.333,3),(390,7472170,7472155,'cbb',3.333,3),(390,7472171,7472155,'bb6',3.333,3),(390,7472172,7472155,'b6e',3.333,3),(390,7472173,7472155,'6e5',3.333,3),(390,7472174,7472155,'e5b',3.333,3),(390,7472175,7472155,'5b7',3.333,3),(390,7472176,7472155,'b79',3.333,3),(390,7472177,7472155,'795',3.333,3),(390,7472178,7472155,'951',3.333,3),(390,7472179,7472155,'519',3.333,3),(390,7472180,7472155,'19e',3.333,3),(390,7472181,7472155,'9ee',3.333,3),(390,7472182,7472155,'ee3',3.333,3),(390,7472183,7472155,'e35',3.333,3),(390,7472184,7472155,'353',3.333,3),(390,7472185,7472155,'53a',3.333,3),(390,7472186,7472156,'mon',100,1),(390,7472187,7472186,'201',50,1),(390,7472188,7472186,'013',50,1),(390,7472189,7472187,'adm',33.333,3),(390,7472190,7472187,'dmi',33.333,3),(390,7472191,7472187,'min',33.333,3),(390,7472192,7472189,'cap',16.667,1),(390,7472193,7472189,'apa',16.667,1),(390,7472194,7472189,'pac',16.667,1),(390,7472195,7472189,'aci',16.667,1),(390,7472196,7472189,'cit',16.667,1),(390,7472197,7472189,'ity',16.667,1),(390,7472198,7472192,'pat',50,1),(390,7472199,7472192,'ath',50,1),(390,7472200,7472198,'fre',14.286,1),(390,7472201,7472198,'ree',14.286,1),(390,7472202,7472198,'ees',14.286,1),(390,7472203,7472198,'esp',14.286,1),(390,7472204,7472198,'spa',14.286,1),(390,7472205,7472198,'pac',14.286,1),(390,7472206,7472198,'ace',14.286,1),(390,7472207,7472200,'dis',50,1),(390,7472208,7472200,'isk',50,1),(390,7472209,7472207,'ind',33.333,1),(390,7472210,7472207,'nde',33.333,1),(390,7472211,7472207,'dex',33.333,1),(390,7472212,7472209,'adm',8.333,1),(390,7472213,7472209,'dmi',8.333,1),(390,7472214,7472209,'min',8.333,1),(390,7472215,7472209,'ini',8.333,1),(390,7472216,7472209,'nis',8.333,1),(390,7472217,7472209,'ist',8.333,1),(390,7472218,7472209,'str',8.333,1),(390,7472219,7472209,'tra',8.333,1),(390,7472220,7472209,'rat',8.333,1),(390,7472221,7472209,'ati',8.333,1),(390,7472222,7472209,'tio',8.333,1),(390,7472223,7472209,'ion',8.333,1),(390,7472224,7472212,'sta',33.333,3),(390,7472225,7472212,'tat',33.333,3),(390,7472226,7472212,'ate',33.333,3),(390,7472227,7472224,'ena',20,2),(390,7472228,7472224,'nab',20,2),(390,7472229,7472224,'abl',20,2),(390,7472230,7472224,'ble',20,2),(390,7472231,7472224,'led',20,2),(390,7472232,7472227,'cac',33.333,1),(390,7472233,7472227,'ach',33.333,1),(390,7472234,7472227,'che',33.333,1),(390,7472235,7472232,'mod',50,2),(390,7472236,7472232,'ode',50,2),(390,7472237,7472235,'wri',14.286,2),(390,7472238,7472235,'rit',14.286,2),(390,7472239,7472235,'ite',14.286,2),(390,7472240,7472235,'tet',14.286,2),(390,7472241,7472235,'eth',14.286,2),(390,7472242,7472235,'thr',14.286,2),(390,7472243,7472235,'hru',14.286,2),(390,7472244,7472237,'ope',11.111,2),(390,7472245,7472237,'per',11.111,2),(390,7472246,7472237,'era',11.111,2),(390,7472247,7472237,'rat',11.111,2),(390,7472248,7472237,'ati',11.111,2),(390,7472249,7472237,'tio',11.111,2),(390,7472250,7472237,'ion',11.111,2),(390,7472251,7472237,'ona',11.111,2),(390,7472252,7472237,'nal',11.111,2),(390,7472253,7472244,'nor',25,1),(390,7472254,7472244,'orm',25,1),(390,7472255,7472244,'rma',25,1),(390,7472256,7472244,'mal',25,1),(390,7472257,7472253,'mes',20,1),(390,7472258,7472253,'ess',20,1),(390,7472259,7472253,'ssa',20,1),(390,7472260,7472253,'sag',20,1),(390,7472261,7472253,'age',20,1),(390,7472262,7472257,'per',11.111,1),(390,7472263,7472257,'erf',11.111,1),(390,7472264,7472257,'rfo',11.111,1),(390,7472265,7472257,'for',11.111,1),(390,7472266,7472257,'orm',11.111,1),(390,7472267,7472257,'rma',11.111,1),(390,7472268,7472257,'man',11.111,1),(390,7472269,7472257,'anc',11.111,1),(390,7472270,7472257,'nce',11.111,1),(390,7472271,7472262,'ide',12.5,1),(390,7472272,7472262,'den',12.5,1),(390,7472273,7472262,'ent',12.5,1),(390,7472274,7472262,'nti',12.5,1),(390,7472275,7472262,'tif',12.5,1),(390,7472276,7472262,'ifi',12.5,1),(390,7472277,7472262,'fie',12.5,1),(390,7472278,7472262,'ier',12.5,1),(390,7472279,7472271,'vdi',33.333,3),(390,7472280,7472271,'dis',33.333,3),(390,7472281,7472271,'isk',33.333,3),(390,7472282,7472279,'nam',50,1),(390,7472283,7472279,'ame',50,1),(390,7472284,7472282,'typ',50,1),(390,7472285,7472282,'ype',50,1),(390,7472286,7472284,'dir',25,1),(390,7472287,7472284,'ire',25,1),(390,7472288,7472284,'rec',25,1),(390,7472289,7472284,'ect',25,1),(391,7472291,7472290,'naa',100,2),(391,7472292,7472291,'600',3.333,3),(391,7472293,7472291,'000',3.333,3),(391,7472294,7472291,'00c',3.333,3),(391,7472295,7472291,'0c2',3.333,3),(391,7472296,7472291,'c29',3.333,3),(391,7472297,7472291,'29b',3.333,3),(391,7472298,7472291,'9b2',3.333,3),(391,7472299,7472291,'b26',3.333,3),(391,7472300,7472291,'26a',3.333,3),(391,7472301,7472291,'6a3',3.333,3),(391,7472302,7472291,'a38',3.333,3),(391,7472303,7472291,'383',3.333,3),(391,7472304,7472291,'835',3.333,3),(391,7472305,7472291,'35e',3.333,3),(391,7472306,7472291,'5e0',3.333,3),(391,7472307,7472291,'e07',3.333,3),(391,7472308,7472291,'07a',3.333,3),(391,7472309,7472291,'7a5',3.333,3),(391,7472310,7472291,'a5d',3.333,3),(391,7472311,7472291,'5d3',3.333,3),(391,7472312,7472291,'d36',3.333,3),(391,7472313,7472291,'36f',3.333,3),(391,7472314,7472291,'6f5',3.333,3),(391,7472315,7472291,'f58',3.333,3),(391,7472316,7472291,'583',3.333,3),(391,7472317,7472291,'837',3.333,3),(391,7472318,7472291,'37b',3.333,3),(391,7472319,7472291,'7bb',3.333,3),(391,7472320,7472291,'bba',3.333,3),(391,7472321,7472291,'ba5',3.333,3),(391,7472322,7472292,'mon',100,1),(391,7472323,7472322,'201',50,1),(391,7472324,7472322,'013',50,1),(391,7472325,7472323,'adm',33.333,3),(391,7472326,7472323,'dmi',33.333,3),(391,7472327,7472323,'min',33.333,3),(391,7472328,7472325,'cap',16.667,1),(391,7472329,7472325,'apa',16.667,1),(391,7472330,7472325,'pac',16.667,1),(391,7472331,7472325,'aci',16.667,1),(391,7472332,7472325,'cit',16.667,1),(391,7472333,7472325,'ity',16.667,1),(391,7472334,7472328,'pat',50,1),(391,7472335,7472328,'ath',50,1),(391,7472336,7472334,'fre',14.286,1),(391,7472337,7472334,'ree',14.286,1),(391,7472338,7472334,'ees',14.286,1),(391,7472339,7472334,'esp',14.286,1),(391,7472340,7472334,'spa',14.286,1),(391,7472341,7472334,'pac',14.286,1),(391,7472342,7472334,'ace',14.286,1),(391,7472343,7472336,'dis',50,1),(391,7472344,7472336,'isk',50,1),(391,7472345,7472343,'ind',33.333,1),(391,7472346,7472343,'nde',33.333,1),(391,7472347,7472343,'dex',33.333,1),(391,7472348,7472345,'adm',8.333,1),(391,7472349,7472345,'dmi',8.333,1),(391,7472350,7472345,'min',8.333,1),(391,7472351,7472345,'ini',8.333,1),(391,7472352,7472345,'nis',8.333,1),(391,7472353,7472345,'ist',8.333,1),(391,7472354,7472345,'str',8.333,1),(391,7472355,7472345,'tra',8.333,1),(391,7472356,7472345,'rat',8.333,1),(391,7472357,7472345,'ati',8.333,1),(391,7472358,7472345,'tio',8.333,1),(391,7472359,7472345,'ion',8.333,1),(391,7472360,7472348,'sta',33.333,3),(391,7472361,7472348,'tat',33.333,3),(391,7472362,7472348,'ate',33.333,3),(391,7472363,7472360,'ena',20,2),(391,7472364,7472360,'nab',20,2),(391,7472365,7472360,'abl',20,2),(391,7472366,7472360,'ble',20,2),(391,7472367,7472360,'led',20,2),(391,7472368,7472363,'cac',33.333,1),(391,7472369,7472363,'ach',33.333,1),(391,7472370,7472363,'che',33.333,1),(391,7472371,7472368,'mod',50,2),(391,7472372,7472368,'ode',50,2),(391,7472373,7472371,'wri',14.286,2),(391,7472374,7472371,'rit',14.286,2),(391,7472375,7472371,'ite',14.286,2),(391,7472376,7472371,'tet',14.286,2),(391,7472377,7472371,'eth',14.286,2),(391,7472378,7472371,'thr',14.286,2),(391,7472379,7472371,'hru',14.286,2),(391,7472380,7472373,'ope',11.111,2),(391,7472381,7472373,'per',11.111,2),(391,7472382,7472373,'era',11.111,2),(391,7472383,7472373,'rat',11.111,2),(391,7472384,7472373,'ati',11.111,2),(391,7472385,7472373,'tio',11.111,2),(391,7472386,7472373,'ion',11.111,2),(391,7472387,7472373,'ona',11.111,2),(391,7472388,7472373,'nal',11.111,2),(391,7472389,7472380,'nor',25,1),(391,7472390,7472380,'orm',25,1),(391,7472391,7472380,'rma',25,1),(391,7472392,7472380,'mal',25,1),(391,7472393,7472389,'mes',20,1),(391,7472394,7472389,'ess',20,1),(391,7472395,7472389,'ssa',20,1),(391,7472396,7472389,'sag',20,1),(391,7472397,7472389,'age',20,1),(391,7472398,7472393,'per',11.111,1),(391,7472399,7472393,'erf',11.111,1),(391,7472400,7472393,'rfo',11.111,1),(391,7472401,7472393,'for',11.111,1),(391,7472402,7472393,'orm',11.111,1),(391,7472403,7472393,'rma',11.111,1),(391,7472404,7472393,'man',11.111,1),(391,7472405,7472393,'anc',11.111,1),(391,7472406,7472393,'nce',11.111,1),(391,7472407,7472398,'ide',12.5,1),(391,7472408,7472398,'den',12.5,1),(391,7472409,7472398,'ent',12.5,1),(391,7472410,7472398,'nti',12.5,1),(391,7472411,7472398,'tif',12.5,1),(391,7472412,7472398,'ifi',12.5,1),(391,7472413,7472398,'fie',12.5,1),(391,7472414,7472398,'ier',12.5,1),(391,7472415,7472407,'vdi',33.333,3),(391,7472416,7472407,'dis',33.333,3),(391,7472417,7472407,'isk',33.333,3),(391,7472418,7472415,'nam',50,1),(391,7472419,7472415,'ame',50,1),(391,7472420,7472418,'typ',50,1),(391,7472421,7472418,'ype',50,1),(391,7472422,7472420,'dir',25,1),(391,7472423,7472420,'ire',25,1),(391,7472424,7472420,'rec',25,1),(391,7472425,7472420,'ect',25,1),(392,7472427,7472426,'naa',100,2),(392,7472428,7472427,'600',3.333,3),(392,7472429,7472427,'000',3.333,3),(392,7472430,7472427,'00c',3.333,3),(392,7472431,7472427,'0c2',3.333,3),(392,7472432,7472427,'c29',3.333,3),(392,7472433,7472427,'29a',3.333,3),(392,7472434,7472427,'9a1',3.333,3),(392,7472435,7472427,'a1f',3.333,3),(392,7472436,7472427,'1f5',3.333,3),(392,7472437,7472427,'f5f',3.333,3),(392,7472438,7472427,'5f7',3.333,3),(392,7472439,7472427,'f7d',3.333,3),(392,7472440,7472427,'7d2',3.333,3),(392,7472441,7472427,'d26',3.333,3),(392,7472442,7472427,'26f',3.333,3),(392,7472443,7472427,'6f2',3.333,3),(392,7472444,7472427,'f2a',3.333,3),(392,7472445,7472427,'2a7',3.333,3),(392,7472446,7472427,'a75',3.333,3),(392,7472447,7472427,'75f',3.333,3),(392,7472448,7472427,'5fb',3.333,3),(392,7472449,7472427,'fb1',3.333,3),(392,7472450,7472427,'b16',3.333,3),(392,7472451,7472427,'162',3.333,3),(392,7472452,7472427,'621',3.333,3),(392,7472453,7472427,'217',3.333,3),(392,7472454,7472427,'17d',3.333,3),(392,7472455,7472427,'7d5',3.333,3),(392,7472456,7472427,'d54',3.333,3),(392,7472457,7472427,'54e',3.333,3),(392,7472458,7472428,'mon',100,1),(392,7472459,7472458,'201',50,1),(392,7472460,7472458,'013',50,1),(392,7472461,7472459,'adm',33.333,3),(392,7472462,7472459,'dmi',33.333,3),(392,7472463,7472459,'min',33.333,3),(392,7472464,7472461,'cap',16.667,1),(392,7472465,7472461,'apa',16.667,1),(392,7472466,7472461,'pac',16.667,1),(392,7472467,7472461,'aci',16.667,1),(392,7472468,7472461,'cit',16.667,1),(392,7472469,7472461,'ity',16.667,1),(392,7472470,7472464,'pat',50,1),(392,7472471,7472464,'ath',50,1),(392,7472472,7472470,'fre',14.286,1),(392,7472473,7472470,'ree',14.286,1),(392,7472474,7472470,'ees',14.286,1),(392,7472475,7472470,'esp',14.286,1),(392,7472476,7472470,'spa',14.286,1),(392,7472477,7472470,'pac',14.286,1),(392,7472478,7472470,'ace',14.286,1),(392,7472479,7472472,'dis',50,1),(392,7472480,7472472,'isk',50,1),(392,7472481,7472479,'ind',33.333,1),(392,7472482,7472479,'nde',33.333,1),(392,7472483,7472479,'dex',33.333,1),(392,7472484,7472481,'adm',8.333,1),(392,7472485,7472481,'dmi',8.333,1),(392,7472486,7472481,'min',8.333,1),(392,7472487,7472481,'ini',8.333,1),(392,7472488,7472481,'nis',8.333,1),(392,7472489,7472481,'ist',8.333,1),(392,7472490,7472481,'str',8.333,1),(392,7472491,7472481,'tra',8.333,1),(392,7472492,7472481,'rat',8.333,1),(392,7472493,7472481,'ati',8.333,1),(392,7472494,7472481,'tio',8.333,1),(392,7472495,7472481,'ion',8.333,1),(392,7472496,7472484,'sta',33.333,3),(392,7472497,7472484,'tat',33.333,3),(392,7472498,7472484,'ate',33.333,3),(392,7472499,7472496,'ena',20,2),(392,7472500,7472496,'nab',20,2),(392,7472501,7472496,'abl',20,2),(392,7472502,7472496,'ble',20,2),(392,7472503,7472496,'led',20,2),(392,7472504,7472499,'cac',33.333,1),(392,7472505,7472499,'ach',33.333,1),(392,7472506,7472499,'che',33.333,1),(392,7472507,7472504,'mod',50,2),(392,7472508,7472504,'ode',50,2),(392,7472509,7472507,'wri',14.286,2),(392,7472510,7472507,'rit',14.286,2),(392,7472511,7472507,'ite',14.286,2),(392,7472512,7472507,'tet',14.286,2),(392,7472513,7472507,'eth',14.286,2),(392,7472514,7472507,'thr',14.286,2),(392,7472515,7472507,'hru',14.286,2),(392,7472516,7472509,'ope',11.111,2),(392,7472517,7472509,'per',11.111,2),(392,7472518,7472509,'era',11.111,2),(392,7472519,7472509,'rat',11.111,2),(392,7472520,7472509,'ati',11.111,2),(392,7472521,7472509,'tio',11.111,2),(392,7472522,7472509,'ion',11.111,2),(392,7472523,7472509,'ona',11.111,2),(392,7472524,7472509,'nal',11.111,2),(392,7472525,7472516,'nor',25,1),(392,7472526,7472516,'orm',25,1),(392,7472527,7472516,'rma',25,1),(392,7472528,7472516,'mal',25,1),(392,7472529,7472525,'mes',20,1),(392,7472530,7472525,'ess',20,1),(392,7472531,7472525,'ssa',20,1),(392,7472532,7472525,'sag',20,1),(392,7472533,7472525,'age',20,1),(392,7472534,7472529,'per',11.111,1),(392,7472535,7472529,'erf',11.111,1),(392,7472536,7472529,'rfo',11.111,1),(392,7472537,7472529,'for',11.111,1),(392,7472538,7472529,'orm',11.111,1),(392,7472539,7472529,'rma',11.111,1),(392,7472540,7472529,'man',11.111,1),(392,7472541,7472529,'anc',11.111,1),(392,7472542,7472529,'nce',11.111,1),(392,7472543,7472534,'ide',12.5,1),(392,7472544,7472534,'den',12.5,1),(392,7472545,7472534,'ent',12.5,1),(392,7472546,7472534,'nti',12.5,1),(392,7472547,7472534,'tif',12.5,1),(392,7472548,7472534,'ifi',12.5,1),(392,7472549,7472534,'fie',12.5,1),(392,7472550,7472534,'ier',12.5,1),(392,7472551,7472543,'vdi',33.333,3),(392,7472552,7472543,'dis',33.333,3),(392,7472553,7472543,'isk',33.333,3),(392,7472554,7472551,'nam',50,1),(392,7472555,7472551,'ame',50,1),(392,7472556,7472554,'typ',50,1),(392,7472557,7472554,'ype',50,1),(392,7472558,7472556,'dir',25,1),(392,7472559,7472556,'ire',25,1),(392,7472560,7472556,'rec',25,1),(392,7472561,7472556,'ect',25,1),(393,7472563,7472562,'naa',100,2),(393,7472564,7472563,'600',3.333,3),(393,7472565,7472563,'000',3.333,3),(393,7472566,7472563,'00c',3.333,3),(393,7472567,7472563,'0c2',3.333,3),(393,7472568,7472563,'c29',3.333,3),(393,7472569,7472563,'292',3.333,3),(393,7472570,7472563,'927',3.333,3),(393,7472571,7472563,'277',3.333,3),(393,7472572,7472563,'77c',3.333,3),(393,7472573,7472563,'7c4',3.333,3),(393,7472574,7472563,'c45',3.333,3),(393,7472575,7472563,'458',3.333,3),(393,7472576,7472563,'580',3.333,3),(393,7472577,7472563,'809',3.333,3),(393,7472578,7472563,'094',3.333,3),(393,7472579,7472563,'946',3.333,3),(393,7472580,7472563,'46c',3.333,3),(393,7472581,7472563,'6c7',3.333,3),(393,7472582,7472563,'c7a',3.333,3),(393,7472583,7472563,'7ad',3.333,3),(393,7472584,7472563,'add',3.333,3),(393,7472585,7472563,'dda',3.333,3),(393,7472586,7472563,'da2',3.333,3),(393,7472587,7472563,'a24',3.333,3),(393,7472588,7472563,'249',3.333,3),(393,7472589,7472563,'497',3.333,3),(393,7472590,7472563,'978',3.333,3),(393,7472591,7472563,'783',3.333,3),(393,7472592,7472563,'83a',3.333,3),(393,7472593,7472563,'3a0',3.333,3),(393,7472594,7472564,'mon',100,1),(393,7472595,7472594,'201',50,1),(393,7472596,7472594,'013',50,1),(393,7472597,7472595,'adm',33.333,3),(393,7472598,7472595,'dmi',33.333,3),(393,7472599,7472595,'min',33.333,3),(393,7472600,7472597,'cap',16.667,1),(393,7472601,7472597,'apa',16.667,1),(393,7472602,7472597,'pac',16.667,1),(393,7472603,7472597,'aci',16.667,1),(393,7472604,7472597,'cit',16.667,1),(393,7472605,7472597,'ity',16.667,1),(393,7472606,7472600,'pat',50,1),(393,7472607,7472600,'ath',50,1),(393,7472608,7472606,'fre',14.286,1),(393,7472609,7472606,'ree',14.286,1),(393,7472610,7472606,'ees',14.286,1),(393,7472611,7472606,'esp',14.286,1),(393,7472612,7472606,'spa',14.286,1),(393,7472613,7472606,'pac',14.286,1),(393,7472614,7472606,'ace',14.286,1),(393,7472615,7472608,'dis',50,1),(393,7472616,7472608,'isk',50,1),(393,7472617,7472615,'ind',33.333,1),(393,7472618,7472615,'nde',33.333,1),(393,7472619,7472615,'dex',33.333,1),(393,7472620,7472617,'adm',8.333,1),(393,7472621,7472617,'dmi',8.333,1),(393,7472622,7472617,'min',8.333,1),(393,7472623,7472617,'ini',8.333,1),(393,7472624,7472617,'nis',8.333,1),(393,7472625,7472617,'ist',8.333,1),(393,7472626,7472617,'str',8.333,1),(393,7472627,7472617,'tra',8.333,1),(393,7472628,7472617,'rat',8.333,1),(393,7472629,7472617,'ati',8.333,1),(393,7472630,7472617,'tio',8.333,1),(393,7472631,7472617,'ion',8.333,1),(393,7472632,7472620,'sta',33.333,3),(393,7472633,7472620,'tat',33.333,3),(393,7472634,7472620,'ate',33.333,3),(393,7472635,7472632,'ena',20,2),(393,7472636,7472632,'nab',20,2),(393,7472637,7472632,'abl',20,2),(393,7472638,7472632,'ble',20,2),(393,7472639,7472632,'led',20,2),(393,7472640,7472635,'cac',33.333,1),(393,7472641,7472635,'ach',33.333,1),(393,7472642,7472635,'che',33.333,1),(393,7472643,7472640,'mod',50,2),(393,7472644,7472640,'ode',50,2),(393,7472645,7472643,'wri',14.286,2),(393,7472646,7472643,'rit',14.286,2),(393,7472647,7472643,'ite',14.286,2),(393,7472648,7472643,'tet',14.286,2),(393,7472649,7472643,'eth',14.286,2),(393,7472650,7472643,'thr',14.286,2),(393,7472651,7472643,'hru',14.286,2),(393,7472652,7472645,'ope',11.111,2),(393,7472653,7472645,'per',11.111,2),(393,7472654,7472645,'era',11.111,2),(393,7472655,7472645,'rat',11.111,2),(393,7472656,7472645,'ati',11.111,2),(393,7472657,7472645,'tio',11.111,2),(393,7472658,7472645,'ion',11.111,2),(393,7472659,7472645,'ona',11.111,2),(393,7472660,7472645,'nal',11.111,2),(393,7472661,7472652,'nor',25,1),(393,7472662,7472652,'orm',25,1),(393,7472663,7472652,'rma',25,1),(393,7472664,7472652,'mal',25,1),(393,7472665,7472661,'mes',20,1),(393,7472666,7472661,'ess',20,1),(393,7472667,7472661,'ssa',20,1),(393,7472668,7472661,'sag',20,1),(393,7472669,7472661,'age',20,1),(393,7472670,7472665,'per',11.111,1),(393,7472671,7472665,'erf',11.111,1),(393,7472672,7472665,'rfo',11.111,1),(393,7472673,7472665,'for',11.111,1),(393,7472674,7472665,'orm',11.111,1),(393,7472675,7472665,'rma',11.111,1),(393,7472676,7472665,'man',11.111,1),(393,7472677,7472665,'anc',11.111,1),(393,7472678,7472665,'nce',11.111,1),(393,7472679,7472670,'ide',12.5,1),(393,7472680,7472670,'den',12.5,1),(393,7472681,7472670,'ent',12.5,1),(393,7472682,7472670,'nti',12.5,1),(393,7472683,7472670,'tif',12.5,1),(393,7472684,7472670,'ifi',12.5,1),(393,7472685,7472670,'fie',12.5,1),(393,7472686,7472670,'ier',12.5,1),(393,7472687,7472679,'vdi',33.333,3),(393,7472688,7472679,'dis',33.333,3),(393,7472689,7472679,'isk',33.333,3),(393,7472690,7472687,'nam',50,1),(393,7472691,7472687,'ame',50,1),(393,7472692,7472690,'typ',50,1),(393,7472693,7472690,'ype',50,1),(393,7472694,7472692,'dir',25,1),(393,7472695,7472692,'ire',25,1),(393,7472696,7472692,'rec',25,1),(393,7472697,7472692,'ect',25,1),(394,7472699,7472698,'naa',100,2),(394,7472700,7472699,'600',3.333,3),(394,7472701,7472699,'000',3.333,3),(394,7472702,7472699,'00c',3.333,3),(394,7472703,7472699,'0c2',3.333,3),(394,7472704,7472699,'c29',3.333,3),(394,7472705,7472699,'299',3.333,3),(394,7472706,7472699,'998',3.333,3),(394,7472707,7472699,'980',3.333,3),(394,7472708,7472699,'80b',3.333,3),(394,7472709,7472699,'0b8',3.333,3),(394,7472710,7472699,'b86',3.333,3),(394,7472711,7472699,'861',3.333,3),(394,7472712,7472699,'614',3.333,3),(394,7472713,7472699,'140',3.333,3),(394,7472714,7472699,'40c',3.333,3),(394,7472715,7472699,'0cc',3.333,3),(394,7472716,7472699,'cc0',3.333,3),(394,7472717,7472699,'c05',3.333,3),(394,7472718,7472699,'05e',3.333,3),(394,7472719,7472699,'5e5',3.333,3),(394,7472720,7472699,'e5c',3.333,3),(394,7472721,7472699,'5ce',3.333,3),(394,7472722,7472699,'ce0',3.333,3),(394,7472723,7472699,'e0e',3.333,3),(394,7472724,7472699,'0e9',3.333,3),(394,7472725,7472699,'e9e',3.333,3),(394,7472726,7472699,'9e4',3.333,3),(394,7472727,7472699,'e43',3.333,3),(394,7472728,7472699,'43b',3.333,3),(394,7472729,7472699,'3b1',3.333,3),(394,7472730,7472700,'mon',100,1),(394,7472731,7472730,'201',50,1),(394,7472732,7472730,'013',50,1),(394,7472733,7472731,'adm',33.333,3),(394,7472734,7472731,'dmi',33.333,3),(394,7472735,7472731,'min',33.333,3),(394,7472736,7472733,'cap',16.667,1),(394,7472737,7472733,'apa',16.667,1),(394,7472738,7472733,'pac',16.667,1),(394,7472739,7472733,'aci',16.667,1),(394,7472740,7472733,'cit',16.667,1),(394,7472741,7472733,'ity',16.667,1),(394,7472742,7472736,'pat',50,1),(394,7472743,7472736,'ath',50,1),(394,7472744,7472742,'fre',14.286,1),(394,7472745,7472742,'ree',14.286,1),(394,7472746,7472742,'ees',14.286,1),(394,7472747,7472742,'esp',14.286,1),(394,7472748,7472742,'spa',14.286,1),(394,7472749,7472742,'pac',14.286,1),(394,7472750,7472742,'ace',14.286,1),(394,7472751,7472744,'dis',50,1),(394,7472752,7472744,'isk',50,1),(394,7472753,7472751,'ind',33.333,1),(394,7472754,7472751,'nde',33.333,1),(394,7472755,7472751,'dex',33.333,1),(394,7472756,7472753,'adm',8.333,1),(394,7472757,7472753,'dmi',8.333,1),(394,7472758,7472753,'min',8.333,1),(394,7472759,7472753,'ini',8.333,1),(394,7472760,7472753,'nis',8.333,1),(394,7472761,7472753,'ist',8.333,1),(394,7472762,7472753,'str',8.333,1),(394,7472763,7472753,'tra',8.333,1),(394,7472764,7472753,'rat',8.333,1),(394,7472765,7472753,'ati',8.333,1),(394,7472766,7472753,'tio',8.333,1),(394,7472767,7472753,'ion',8.333,1),(394,7472768,7472756,'sta',33.333,3),(394,7472769,7472756,'tat',33.333,3),(394,7472770,7472756,'ate',33.333,3),(394,7472771,7472768,'ena',20,2),(394,7472772,7472768,'nab',20,2),(394,7472773,7472768,'abl',20,2),(394,7472774,7472768,'ble',20,2),(394,7472775,7472768,'led',20,2),(394,7472776,7472771,'cac',33.333,1),(394,7472777,7472771,'ach',33.333,1),(394,7472778,7472771,'che',33.333,1),(394,7472779,7472776,'mod',50,2),(394,7472780,7472776,'ode',50,2),(394,7472781,7472779,'wri',14.286,2),(394,7472782,7472779,'rit',14.286,2),(394,7472783,7472779,'ite',14.286,2),(394,7472784,7472779,'tet',14.286,2),(394,7472785,7472779,'eth',14.286,2),(394,7472786,7472779,'thr',14.286,2),(394,7472787,7472779,'hru',14.286,2),(394,7472788,7472781,'ope',11.111,2),(394,7472789,7472781,'per',11.111,2),(394,7472790,7472781,'era',11.111,2),(394,7472791,7472781,'rat',11.111,2),(394,7472792,7472781,'ati',11.111,2),(394,7472793,7472781,'tio',11.111,2),(394,7472794,7472781,'ion',11.111,2),(394,7472795,7472781,'ona',11.111,2),(394,7472796,7472781,'nal',11.111,2),(394,7472797,7472788,'nor',25,1),(394,7472798,7472788,'orm',25,1),(394,7472799,7472788,'rma',25,1),(394,7472800,7472788,'mal',25,1),(394,7472801,7472797,'mes',20,1),(394,7472802,7472797,'ess',20,1),(394,7472803,7472797,'ssa',20,1),(394,7472804,7472797,'sag',20,1),(394,7472805,7472797,'age',20,1),(394,7472806,7472801,'per',11.111,1),(394,7472807,7472801,'erf',11.111,1),(394,7472808,7472801,'rfo',11.111,1),(394,7472809,7472801,'for',11.111,1),(394,7472810,7472801,'orm',11.111,1),(394,7472811,7472801,'rma',11.111,1),(394,7472812,7472801,'man',11.111,1),(394,7472813,7472801,'anc',11.111,1),(394,7472814,7472801,'nce',11.111,1),(394,7472815,7472806,'ide',12.5,1),(394,7472816,7472806,'den',12.5,1),(394,7472817,7472806,'ent',12.5,1),(394,7472818,7472806,'nti',12.5,1),(394,7472819,7472806,'tif',12.5,1),(394,7472820,7472806,'ifi',12.5,1),(394,7472821,7472806,'fie',12.5,1),(394,7472822,7472806,'ier',12.5,1),(394,7472823,7472815,'vdi',33.333,3),(394,7472824,7472815,'dis',33.333,3),(394,7472825,7472815,'isk',33.333,3),(394,7472826,7472823,'nam',50,1),(394,7472827,7472823,'ame',50,1),(394,7472828,7472826,'typ',50,1),(394,7472829,7472826,'ype',50,1),(394,7472830,7472828,'dir',25,1),(394,7472831,7472828,'ire',25,1),(394,7472832,7472828,'rec',25,1),(394,7472833,7472828,'ect',25,1),(395,7472835,7472834,'naa',100,2),(395,7472836,7472835,'600',3.333,3),(395,7472837,7472835,'000',3.333,3),(395,7472838,7472835,'00c',3.333,3),(395,7472839,7472835,'0c2',3.333,3),(395,7472840,7472835,'c29',3.333,3),(395,7472841,7472835,'291',3.333,3),(395,7472842,7472835,'918',3.333,3),(395,7472843,7472835,'18b',3.333,3),(395,7472844,7472835,'8b7',3.333,3),(395,7472845,7472835,'b7a',3.333,3),(395,7472846,7472835,'7a0',3.333,3),(395,7472847,7472835,'a0a',3.333,3),(395,7472848,7472835,'0a8',3.333,3),(395,7472849,7472835,'a89',3.333,3),(395,7472850,7472835,'89b',3.333,3),(395,7472851,7472835,'9bc',3.333,3),(395,7472852,7472835,'bc9',3.333,3),(395,7472853,7472835,'c9c',3.333,3),(395,7472854,7472835,'9c6',3.333,3),(395,7472855,7472835,'c6f',3.333,3),(395,7472856,7472835,'6ff',3.333,3),(395,7472857,7472835,'ffe',3.333,3),(395,7472858,7472835,'fe1',3.333,3),(395,7472859,7472835,'e16',3.333,3),(395,7472860,7472835,'16e',3.333,3),(395,7472861,7472835,'6eb',3.333,3),(395,7472862,7472835,'eb9',3.333,3),(395,7472863,7472835,'b98',3.333,3),(395,7472864,7472835,'987',3.333,3),(395,7472865,7472835,'871',3.333,3),(395,7472866,7472836,'mon',100,1),(395,7472867,7472866,'201',50,1),(395,7472868,7472866,'013',50,1),(395,7472869,7472867,'adm',33.333,3),(395,7472870,7472867,'dmi',33.333,3),(395,7472871,7472867,'min',33.333,3),(395,7472872,7472869,'cap',16.667,1),(395,7472873,7472869,'apa',16.667,1),(395,7472874,7472869,'pac',16.667,1),(395,7472875,7472869,'aci',16.667,1),(395,7472876,7472869,'cit',16.667,1),(395,7472877,7472869,'ity',16.667,1),(395,7472878,7472872,'pat',50,1),(395,7472879,7472872,'ath',50,1),(395,7472880,7472878,'fre',14.286,1),(395,7472881,7472878,'ree',14.286,1),(395,7472882,7472878,'ees',14.286,1),(395,7472883,7472878,'esp',14.286,1),(395,7472884,7472878,'spa',14.286,1),(395,7472885,7472878,'pac',14.286,1),(395,7472886,7472878,'ace',14.286,1),(395,7472887,7472880,'dis',50,1),(395,7472888,7472880,'isk',50,1),(395,7472889,7472887,'ind',33.333,1),(395,7472890,7472887,'nde',33.333,1),(395,7472891,7472887,'dex',33.333,1),(395,7472892,7472889,'adm',8.333,1),(395,7472893,7472889,'dmi',8.333,1),(395,7472894,7472889,'min',8.333,1),(395,7472895,7472889,'ini',8.333,1),(395,7472896,7472889,'nis',8.333,1),(395,7472897,7472889,'ist',8.333,1),(395,7472898,7472889,'str',8.333,1),(395,7472899,7472889,'tra',8.333,1),(395,7472900,7472889,'rat',8.333,1),(395,7472901,7472889,'ati',8.333,1),(395,7472902,7472889,'tio',8.333,1),(395,7472903,7472889,'ion',8.333,1),(395,7472904,7472892,'sta',33.333,3),(395,7472905,7472892,'tat',33.333,3),(395,7472906,7472892,'ate',33.333,3),(395,7472907,7472904,'ena',20,2),(395,7472908,7472904,'nab',20,2),(395,7472909,7472904,'abl',20,2),(395,7472910,7472904,'ble',20,2),(395,7472911,7472904,'led',20,2),(395,7472912,7472907,'cac',33.333,1),(395,7472913,7472907,'ach',33.333,1),(395,7472914,7472907,'che',33.333,1),(395,7472915,7472912,'mod',50,2),(395,7472916,7472912,'ode',50,2),(395,7472917,7472915,'wri',14.286,2),(395,7472918,7472915,'rit',14.286,2),(395,7472919,7472915,'ite',14.286,2),(395,7472920,7472915,'tet',14.286,2),(395,7472921,7472915,'eth',14.286,2),(395,7472922,7472915,'thr',14.286,2),(395,7472923,7472915,'hru',14.286,2),(395,7472924,7472917,'ope',11.111,2),(395,7472925,7472917,'per',11.111,2),(395,7472926,7472917,'era',11.111,2),(395,7472927,7472917,'rat',11.111,2),(395,7472928,7472917,'ati',11.111,2),(395,7472929,7472917,'tio',11.111,2),(395,7472930,7472917,'ion',11.111,2),(395,7472931,7472917,'ona',11.111,2),(395,7472932,7472917,'nal',11.111,2),(395,7472933,7472924,'nor',25,1),(395,7472934,7472924,'orm',25,1),(395,7472935,7472924,'rma',25,1),(395,7472936,7472924,'mal',25,1),(395,7472937,7472933,'mes',20,1),(395,7472938,7472933,'ess',20,1),(395,7472939,7472933,'ssa',20,1),(395,7472940,7472933,'sag',20,1),(395,7472941,7472933,'age',20,1),(395,7472942,7472937,'per',11.111,1),(395,7472943,7472937,'erf',11.111,1),(395,7472944,7472937,'rfo',11.111,1),(395,7472945,7472937,'for',11.111,1),(395,7472946,7472937,'orm',11.111,1),(395,7472947,7472937,'rma',11.111,1),(395,7472948,7472937,'man',11.111,1),(395,7472949,7472937,'anc',11.111,1),(395,7472950,7472937,'nce',11.111,1),(395,7472951,7472942,'ide',12.5,1),(395,7472952,7472942,'den',12.5,1),(395,7472953,7472942,'ent',12.5,1),(395,7472954,7472942,'nti',12.5,1),(395,7472955,7472942,'tif',12.5,1),(395,7472956,7472942,'ifi',12.5,1),(395,7472957,7472942,'fie',12.5,1),(395,7472958,7472942,'ier',12.5,1),(395,7472959,7472951,'vdi',33.333,3),(395,7472960,7472951,'dis',33.333,3),(395,7472961,7472951,'isk',33.333,3),(395,7472962,7472959,'nam',50,1),(395,7472963,7472959,'ame',50,1),(395,7472964,7472962,'typ',50,1),(395,7472965,7472962,'ype',50,1),(395,7472966,7472964,'dir',25,1),(395,7472967,7472964,'ire',25,1),(395,7472968,7472964,'rec',25,1),(395,7472969,7472964,'ect',25,1),(396,7472971,7472970,'naa',100,2),(396,7472972,7472971,'600',3.333,3),(396,7472973,7472971,'000',3.333,3),(396,7472974,7472971,'00c',3.333,3),(396,7472975,7472971,'0c2',3.333,3),(396,7472976,7472971,'c29',3.333,3),(396,7472977,7472971,'299',3.333,3),(396,7472978,7472971,'99d',3.333,3),(396,7472979,7472971,'9d3',3.333,3),(396,7472980,7472971,'d3a',3.333,3),(396,7472981,7472971,'3ae',3.333,3),(396,7472982,7472971,'ae3',3.333,3),(396,7472983,7472971,'e33',3.333,3),(396,7472984,7472971,'339',3.333,3),(396,7472985,7472971,'39d',3.333,3),(396,7472986,7472971,'9df',3.333,3),(396,7472987,7472971,'df8',3.333,3),(396,7472988,7472971,'f86',3.333,3),(396,7472989,7472971,'867',3.333,3),(396,7472990,7472971,'67c',3.333,3),(396,7472991,7472971,'7c0',3.333,3),(396,7472992,7472971,'c0d',3.333,3),(396,7472993,7472971,'0de',3.333,3),(396,7472994,7472971,'de4',3.333,3),(396,7472995,7472971,'e47',3.333,3),(396,7472996,7472971,'47a',3.333,3),(396,7472997,7472971,'7a2',3.333,3),(396,7472998,7472971,'a27',3.333,3),(396,7472999,7472971,'27d',3.333,3),(396,7473000,7472971,'7d8',3.333,3),(396,7473001,7472971,'d80',3.333,3),(396,7473002,7472972,'mon',100,1),(396,7473003,7473002,'201',50,1),(396,7473004,7473002,'013',50,1),(396,7473005,7473003,'adm',33.333,3),(396,7473006,7473003,'dmi',33.333,3),(396,7473007,7473003,'min',33.333,3),(396,7473008,7473005,'cap',16.667,1),(396,7473009,7473005,'apa',16.667,1),(396,7473010,7473005,'pac',16.667,1),(396,7473011,7473005,'aci',16.667,1),(396,7473012,7473005,'cit',16.667,1),(396,7473013,7473005,'ity',16.667,1),(396,7473014,7473008,'pat',50,1),(396,7473015,7473008,'ath',50,1),(396,7473016,7473014,'fre',14.286,1),(396,7473017,7473014,'ree',14.286,1),(396,7473018,7473014,'ees',14.286,1),(396,7473019,7473014,'esp',14.286,1),(396,7473020,7473014,'spa',14.286,1),(396,7473021,7473014,'pac',14.286,1),(396,7473022,7473014,'ace',14.286,1),(396,7473023,7473016,'dis',50,1),(396,7473024,7473016,'isk',50,1),(396,7473025,7473023,'ind',33.333,1),(396,7473026,7473023,'nde',33.333,1),(396,7473027,7473023,'dex',33.333,1),(396,7473028,7473025,'adm',8.333,1),(396,7473029,7473025,'dmi',8.333,1),(396,7473030,7473025,'min',8.333,1),(396,7473031,7473025,'ini',8.333,1),(396,7473032,7473025,'nis',8.333,1),(396,7473033,7473025,'ist',8.333,1),(396,7473034,7473025,'str',8.333,1),(396,7473035,7473025,'tra',8.333,1),(396,7473036,7473025,'rat',8.333,1),(396,7473037,7473025,'ati',8.333,1),(396,7473038,7473025,'tio',8.333,1),(396,7473039,7473025,'ion',8.333,1),(396,7473040,7473028,'sta',33.333,3),(396,7473041,7473028,'tat',33.333,3),(396,7473042,7473028,'ate',33.333,3),(396,7473043,7473040,'ena',20,2),(396,7473044,7473040,'nab',20,2),(396,7473045,7473040,'abl',20,2),(396,7473046,7473040,'ble',20,2),(396,7473047,7473040,'led',20,2),(396,7473048,7473043,'cac',33.333,1),(396,7473049,7473043,'ach',33.333,1),(396,7473050,7473043,'che',33.333,1),(396,7473051,7473048,'mod',50,2),(396,7473052,7473048,'ode',50,2),(396,7473053,7473051,'wri',14.286,2),(396,7473054,7473051,'rit',14.286,2),(396,7473055,7473051,'ite',14.286,2),(396,7473056,7473051,'tet',14.286,2),(396,7473057,7473051,'eth',14.286,2),(396,7473058,7473051,'thr',14.286,2),(396,7473059,7473051,'hru',14.286,2),(396,7473060,7473053,'ope',11.111,2),(396,7473061,7473053,'per',11.111,2),(396,7473062,7473053,'era',11.111,2),(396,7473063,7473053,'rat',11.111,2),(396,7473064,7473053,'ati',11.111,2),(396,7473065,7473053,'tio',11.111,2),(396,7473066,7473053,'ion',11.111,2),(396,7473067,7473053,'ona',11.111,2),(396,7473068,7473053,'nal',11.111,2),(396,7473069,7473060,'nor',25,1),(396,7473070,7473060,'orm',25,1),(396,7473071,7473060,'rma',25,1),(396,7473072,7473060,'mal',25,1),(396,7473073,7473069,'mes',20,1),(396,7473074,7473069,'ess',20,1),(396,7473075,7473069,'ssa',20,1),(396,7473076,7473069,'sag',20,1),(396,7473077,7473069,'age',20,1),(396,7473078,7473073,'per',11.111,1),(396,7473079,7473073,'erf',11.111,1),(396,7473080,7473073,'rfo',11.111,1),(396,7473081,7473073,'for',11.111,1),(396,7473082,7473073,'orm',11.111,1),(396,7473083,7473073,'rma',11.111,1),(396,7473084,7473073,'man',11.111,1),(396,7473085,7473073,'anc',11.111,1),(396,7473086,7473073,'nce',11.111,1),(396,7473087,7473078,'ide',12.5,1),(396,7473088,7473078,'den',12.5,1),(396,7473089,7473078,'ent',12.5,1),(396,7473090,7473078,'nti',12.5,1),(396,7473091,7473078,'tif',12.5,1),(396,7473092,7473078,'ifi',12.5,1),(396,7473093,7473078,'fie',12.5,1),(396,7473094,7473078,'ier',12.5,1),(396,7473095,7473087,'vdi',33.333,3),(396,7473096,7473087,'dis',33.333,3),(396,7473097,7473087,'isk',33.333,3),(396,7473098,7473095,'nam',50,1),(396,7473099,7473095,'ame',50,1),(396,7473100,7473098,'typ',50,1),(396,7473101,7473098,'ype',50,1),(396,7473102,7473100,'dir',25,1),(396,7473103,7473100,'ire',25,1),(396,7473104,7473100,'rec',25,1),(396,7473105,7473100,'ect',25,1),(397,7473107,7473106,'naa',100,2),(397,7473108,7473107,'600',3.333,3),(397,7473109,7473107,'000',3.333,3),(397,7473110,7473107,'00c',3.333,3),(397,7473111,7473107,'0c2',3.333,3),(397,7473112,7473107,'c29',3.333,3),(397,7473113,7473107,'29a',3.333,3),(397,7473114,7473107,'9a5',3.333,3),(397,7473115,7473107,'a5e',3.333,3),(397,7473116,7473107,'5e8',3.333,3),(397,7473117,7473107,'e87',3.333,3),(397,7473118,7473107,'879',3.333,3),(397,7473119,7473107,'79b',3.333,3),(397,7473120,7473107,'9be',3.333,3),(397,7473121,7473107,'be9',3.333,3),(397,7473122,7473107,'e9a',3.333,3),(397,7473123,7473107,'9ae',3.333,3),(397,7473124,7473107,'aef',3.333,3),(397,7473125,7473107,'eff',3.333,3),(397,7473126,7473107,'ff8',3.333,3),(397,7473127,7473107,'f82',3.333,3),(397,7473128,7473107,'82e',3.333,3),(397,7473129,7473107,'2ec',3.333,3),(397,7473130,7473107,'ec4',3.333,3),(397,7473131,7473107,'c40',3.333,3),(397,7473132,7473107,'407',3.333,3),(397,7473133,7473107,'073',3.333,3),(397,7473134,7473107,'734',3.333,3),(397,7473135,7473107,'348',3.333,3),(397,7473136,7473107,'485',3.333,3),(397,7473137,7473107,'85e',3.333,3),(397,7473138,7473108,'mon',100,1),(397,7473139,7473138,'201',50,1),(397,7473140,7473138,'013',50,1),(397,7473141,7473139,'adm',33.333,3),(397,7473142,7473139,'dmi',33.333,3),(397,7473143,7473139,'min',33.333,3),(397,7473144,7473141,'cap',16.667,1),(397,7473145,7473141,'apa',16.667,1),(397,7473146,7473141,'pac',16.667,1),(397,7473147,7473141,'aci',16.667,1),(397,7473148,7473141,'cit',16.667,1),(397,7473149,7473141,'ity',16.667,1),(397,7473150,7473144,'pat',50,1),(397,7473151,7473144,'ath',50,1),(397,7473152,7473150,'fre',14.286,1),(397,7473153,7473150,'ree',14.286,1),(397,7473154,7473150,'ees',14.286,1),(397,7473155,7473150,'esp',14.286,1),(397,7473156,7473150,'spa',14.286,1),(397,7473157,7473150,'pac',14.286,1),(397,7473158,7473150,'ace',14.286,1),(397,7473159,7473152,'dis',50,1),(397,7473160,7473152,'isk',50,1),(397,7473161,7473159,'ind',33.333,1),(397,7473162,7473159,'nde',33.333,1),(397,7473163,7473159,'dex',33.333,1),(397,7473164,7473161,'adm',8.333,1),(397,7473165,7473161,'dmi',8.333,1),(397,7473166,7473161,'min',8.333,1),(397,7473167,7473161,'ini',8.333,1),(397,7473168,7473161,'nis',8.333,1),(397,7473169,7473161,'ist',8.333,1),(397,7473170,7473161,'str',8.333,1),(397,7473171,7473161,'tra',8.333,1),(397,7473172,7473161,'rat',8.333,1),(397,7473173,7473161,'ati',8.333,1),(397,7473174,7473161,'tio',8.333,1),(397,7473175,7473161,'ion',8.333,1),(397,7473176,7473164,'sta',33.333,3),(397,7473177,7473164,'tat',33.333,3),(397,7473178,7473164,'ate',33.333,3),(397,7473179,7473176,'ena',20,2),(397,7473180,7473176,'nab',20,2),(397,7473181,7473176,'abl',20,2),(397,7473182,7473176,'ble',20,2),(397,7473183,7473176,'led',20,2),(397,7473184,7473179,'cac',33.333,1),(397,7473185,7473179,'ach',33.333,1),(397,7473186,7473179,'che',33.333,1),(397,7473187,7473184,'mod',50,2),(397,7473188,7473184,'ode',50,2),(397,7473189,7473187,'wri',14.286,2),(397,7473190,7473187,'rit',14.286,2),(397,7473191,7473187,'ite',14.286,2),(397,7473192,7473187,'tet',14.286,2),(397,7473193,7473187,'eth',14.286,2),(397,7473194,7473187,'thr',14.286,2),(397,7473195,7473187,'hru',14.286,2),(397,7473196,7473189,'ope',11.111,2),(397,7473197,7473189,'per',11.111,2),(397,7473198,7473189,'era',11.111,2),(397,7473199,7473189,'rat',11.111,2),(397,7473200,7473189,'ati',11.111,2),(397,7473201,7473189,'tio',11.111,2),(397,7473202,7473189,'ion',11.111,2),(397,7473203,7473189,'ona',11.111,2),(397,7473204,7473189,'nal',11.111,2),(397,7473205,7473196,'nor',25,1),(397,7473206,7473196,'orm',25,1),(397,7473207,7473196,'rma',25,1),(397,7473208,7473196,'mal',25,1),(397,7473209,7473205,'mes',20,1),(397,7473210,7473205,'ess',20,1),(397,7473211,7473205,'ssa',20,1),(397,7473212,7473205,'sag',20,1),(397,7473213,7473205,'age',20,1),(397,7473214,7473209,'per',11.111,1),(397,7473215,7473209,'erf',11.111,1),(397,7473216,7473209,'rfo',11.111,1),(397,7473217,7473209,'for',11.111,1),(397,7473218,7473209,'orm',11.111,1),(397,7473219,7473209,'rma',11.111,1),(397,7473220,7473209,'man',11.111,1),(397,7473221,7473209,'anc',11.111,1),(397,7473222,7473209,'nce',11.111,1),(397,7473223,7473214,'ide',12.5,1),(397,7473224,7473214,'den',12.5,1),(397,7473225,7473214,'ent',12.5,1),(397,7473226,7473214,'nti',12.5,1),(397,7473227,7473214,'tif',12.5,1),(397,7473228,7473214,'ifi',12.5,1),(397,7473229,7473214,'fie',12.5,1),(397,7473230,7473214,'ier',12.5,1),(397,7473231,7473223,'vdi',33.333,3),(397,7473232,7473223,'dis',33.333,3),(397,7473233,7473223,'isk',33.333,3),(397,7473234,7473231,'nam',50,1),(397,7473235,7473231,'ame',50,1),(397,7473236,7473234,'typ',50,1),(397,7473237,7473234,'ype',50,1),(397,7473238,7473236,'dir',25,1),(397,7473239,7473236,'ire',25,1),(397,7473240,7473236,'rec',25,1),(397,7473241,7473236,'ect',25,1),(398,7473243,7473242,'naa',100,2),(398,7473244,7473243,'600',3.333,3),(398,7473245,7473243,'000',3.333,3),(398,7473246,7473243,'00c',3.333,3),(398,7473247,7473243,'0c2',3.333,3),(398,7473248,7473243,'c29',3.333,3),(398,7473249,7473243,'295',3.333,3),(398,7473250,7473243,'950',3.333,3),(398,7473251,7473243,'50a',3.333,3),(398,7473252,7473243,'0a1',3.333,3),(398,7473253,7473243,'a1a',3.333,3),(398,7473254,7473243,'1a5',3.333,3),(398,7473255,7473243,'a5a',3.333,3),(398,7473256,7473243,'5ab',3.333,3),(398,7473257,7473243,'ab3',3.333,3),(398,7473258,7473243,'b36',3.333,3),(398,7473259,7473243,'366',3.333,3),(398,7473260,7473243,'66b',3.333,3),(398,7473261,7473243,'6bf',3.333,3),(398,7473262,7473243,'bf0',3.333,3),(398,7473263,7473243,'f05',3.333,3),(398,7473264,7473243,'05b',3.333,3),(398,7473265,7473243,'5b6',3.333,3),(398,7473266,7473243,'b66',3.333,3),(398,7473267,7473243,'669',3.333,3),(398,7473268,7473243,'692',3.333,3),(398,7473269,7473243,'92f',3.333,3),(398,7473270,7473243,'2f2',3.333,3),(398,7473271,7473243,'f20',3.333,3),(398,7473272,7473243,'207',3.333,3),(398,7473273,7473243,'079',3.333,3),(398,7473274,7473244,'mon',100,1),(398,7473275,7473274,'201',50,1),(398,7473276,7473274,'013',50,1),(398,7473277,7473275,'adm',33.333,3),(398,7473278,7473275,'dmi',33.333,3),(398,7473279,7473275,'min',33.333,3),(398,7473280,7473277,'cap',16.667,1),(398,7473281,7473277,'apa',16.667,1),(398,7473282,7473277,'pac',16.667,1),(398,7473283,7473277,'aci',16.667,1),(398,7473284,7473277,'cit',16.667,1),(398,7473285,7473277,'ity',16.667,1),(398,7473286,7473280,'pat',50,1),(398,7473287,7473280,'ath',50,1),(398,7473288,7473286,'fre',14.286,1),(398,7473289,7473286,'ree',14.286,1),(398,7473290,7473286,'ees',14.286,1),(398,7473291,7473286,'esp',14.286,1),(398,7473292,7473286,'spa',14.286,1),(398,7473293,7473286,'pac',14.286,1),(398,7473294,7473286,'ace',14.286,1),(398,7473295,7473288,'dis',50,1),(398,7473296,7473288,'isk',50,1),(398,7473297,7473295,'ind',33.333,1),(398,7473298,7473295,'nde',33.333,1),(398,7473299,7473295,'dex',33.333,1),(398,7473300,7473297,'adm',8.333,1),(398,7473301,7473297,'dmi',8.333,1),(398,7473302,7473297,'min',8.333,1),(398,7473303,7473297,'ini',8.333,1),(398,7473304,7473297,'nis',8.333,1),(398,7473305,7473297,'ist',8.333,1),(398,7473306,7473297,'str',8.333,1),(398,7473307,7473297,'tra',8.333,1),(398,7473308,7473297,'rat',8.333,1),(398,7473309,7473297,'ati',8.333,1),(398,7473310,7473297,'tio',8.333,1),(398,7473311,7473297,'ion',8.333,1),(398,7473312,7473300,'sta',33.333,3),(398,7473313,7473300,'tat',33.333,3),(398,7473314,7473300,'ate',33.333,3),(398,7473315,7473312,'ena',20,2),(398,7473316,7473312,'nab',20,2),(398,7473317,7473312,'abl',20,2),(398,7473318,7473312,'ble',20,2),(398,7473319,7473312,'led',20,2),(398,7473320,7473315,'cac',33.333,1),(398,7473321,7473315,'ach',33.333,1),(398,7473322,7473315,'che',33.333,1),(398,7473323,7473320,'mod',50,2),(398,7473324,7473320,'ode',50,2),(398,7473325,7473323,'wri',14.286,2),(398,7473326,7473323,'rit',14.286,2),(398,7473327,7473323,'ite',14.286,2),(398,7473328,7473323,'tet',14.286,2),(398,7473329,7473323,'eth',14.286,2),(398,7473330,7473323,'thr',14.286,2),(398,7473331,7473323,'hru',14.286,2),(398,7473332,7473325,'ope',11.111,2),(398,7473333,7473325,'per',11.111,2),(398,7473334,7473325,'era',11.111,2),(398,7473335,7473325,'rat',11.111,2),(398,7473336,7473325,'ati',11.111,2),(398,7473337,7473325,'tio',11.111,2),(398,7473338,7473325,'ion',11.111,2),(398,7473339,7473325,'ona',11.111,2),(398,7473340,7473325,'nal',11.111,2),(398,7473341,7473332,'nor',25,1),(398,7473342,7473332,'orm',25,1),(398,7473343,7473332,'rma',25,1),(398,7473344,7473332,'mal',25,1),(398,7473345,7473341,'mes',20,1),(398,7473346,7473341,'ess',20,1),(398,7473347,7473341,'ssa',20,1),(398,7473348,7473341,'sag',20,1),(398,7473349,7473341,'age',20,1),(398,7473350,7473345,'per',11.111,1),(398,7473351,7473345,'erf',11.111,1),(398,7473352,7473345,'rfo',11.111,1),(398,7473353,7473345,'for',11.111,1),(398,7473354,7473345,'orm',11.111,1),(398,7473355,7473345,'rma',11.111,1),(398,7473356,7473345,'man',11.111,1),(398,7473357,7473345,'anc',11.111,1),(398,7473358,7473345,'nce',11.111,1),(398,7473359,7473350,'ide',12.5,1),(398,7473360,7473350,'den',12.5,1),(398,7473361,7473350,'ent',12.5,1),(398,7473362,7473350,'nti',12.5,1),(398,7473363,7473350,'tif',12.5,1),(398,7473364,7473350,'ifi',12.5,1),(398,7473365,7473350,'fie',12.5,1),(398,7473366,7473350,'ier',12.5,1),(398,7473367,7473359,'vdi',33.333,3),(398,7473368,7473359,'dis',33.333,3),(398,7473369,7473359,'isk',33.333,3),(398,7473370,7473367,'nam',50,1),(398,7473371,7473367,'ame',50,1),(398,7473372,7473370,'typ',50,1),(398,7473373,7473370,'ype',50,1),(398,7473374,7473372,'dir',25,1),(398,7473375,7473372,'ire',25,1),(398,7473376,7473372,'rec',25,1),(398,7473377,7473372,'ect',25,1),(399,7473379,7473378,'naa',100,2),(399,7473380,7473379,'600',3.333,3),(399,7473381,7473379,'000',3.333,3),(399,7473382,7473379,'00c',3.333,3),(399,7473383,7473379,'0c2',3.333,3),(399,7473384,7473379,'c29',3.333,3),(399,7473385,7473379,'293',3.333,3),(399,7473386,7473379,'938',3.333,3),(399,7473387,7473379,'38b',3.333,3),(399,7473388,7473379,'8bb',3.333,3),(399,7473389,7473379,'bb4',3.333,3),(399,7473390,7473379,'b49',3.333,3),(399,7473391,7473379,'49a',3.333,3),(399,7473392,7473379,'9a8',3.333,3),(399,7473393,7473379,'a8d',3.333,3),(399,7473394,7473379,'8d2',3.333,3),(399,7473395,7473379,'d2e',3.333,3),(399,7473396,7473379,'2e5',3.333,3),(399,7473397,7473379,'e5d',3.333,3),(399,7473398,7473379,'5d4',3.333,3),(399,7473399,7473379,'d49',3.333,3),(399,7473400,7473379,'49b',3.333,3),(399,7473401,7473379,'9b4',3.333,3),(399,7473402,7473379,'b47',3.333,3),(399,7473403,7473379,'476',3.333,3),(399,7473404,7473379,'76c',3.333,3),(399,7473405,7473379,'6c9',3.333,3),(399,7473406,7473379,'c92',3.333,3),(399,7473407,7473379,'92c',3.333,3),(399,7473408,7473379,'2cf',3.333,3),(399,7473409,7473379,'cf9',3.333,3),(399,7473410,7473380,'mon',100,1),(399,7473411,7473410,'201',50,1),(399,7473412,7473410,'013',50,1),(399,7473413,7473411,'adm',33.333,3),(399,7473414,7473411,'dmi',33.333,3),(399,7473415,7473411,'min',33.333,3),(399,7473416,7473413,'cap',16.667,1),(399,7473417,7473413,'apa',16.667,1),(399,7473418,7473413,'pac',16.667,1),(399,7473419,7473413,'aci',16.667,1),(399,7473420,7473413,'cit',16.667,1),(399,7473421,7473413,'ity',16.667,1),(399,7473422,7473416,'pat',50,1),(399,7473423,7473416,'ath',50,1),(399,7473424,7473422,'fre',14.286,1),(399,7473425,7473422,'ree',14.286,1),(399,7473426,7473422,'ees',14.286,1),(399,7473427,7473422,'esp',14.286,1),(399,7473428,7473422,'spa',14.286,1),(399,7473429,7473422,'pac',14.286,1),(399,7473430,7473422,'ace',14.286,1),(399,7473431,7473424,'dis',50,1),(399,7473432,7473424,'isk',50,1),(399,7473433,7473431,'ind',33.333,1),(399,7473434,7473431,'nde',33.333,1),(399,7473435,7473431,'dex',33.333,1),(399,7473436,7473433,'adm',8.333,1),(399,7473437,7473433,'dmi',8.333,1),(399,7473438,7473433,'min',8.333,1),(399,7473439,7473433,'ini',8.333,1),(399,7473440,7473433,'nis',8.333,1),(399,7473441,7473433,'ist',8.333,1),(399,7473442,7473433,'str',8.333,1),(399,7473443,7473433,'tra',8.333,1),(399,7473444,7473433,'rat',8.333,1),(399,7473445,7473433,'ati',8.333,1),(399,7473446,7473433,'tio',8.333,1),(399,7473447,7473433,'ion',8.333,1),(399,7473448,7473436,'sta',33.333,3),(399,7473449,7473436,'tat',33.333,3),(399,7473450,7473436,'ate',33.333,3),(399,7473451,7473448,'ena',20,2),(399,7473452,7473448,'nab',20,2),(399,7473453,7473448,'abl',20,2),(399,7473454,7473448,'ble',20,2),(399,7473455,7473448,'led',20,2),(399,7473456,7473451,'cac',33.333,1),(399,7473457,7473451,'ach',33.333,1),(399,7473458,7473451,'che',33.333,1),(399,7473459,7473456,'mod',50,2),(399,7473460,7473456,'ode',50,2),(399,7473461,7473459,'wri',14.286,2),(399,7473462,7473459,'rit',14.286,2),(399,7473463,7473459,'ite',14.286,2),(399,7473464,7473459,'tet',14.286,2),(399,7473465,7473459,'eth',14.286,2),(399,7473466,7473459,'thr',14.286,2),(399,7473467,7473459,'hru',14.286,2),(399,7473468,7473461,'ope',11.111,2),(399,7473469,7473461,'per',11.111,2),(399,7473470,7473461,'era',11.111,2),(399,7473471,7473461,'rat',11.111,2),(399,7473472,7473461,'ati',11.111,2),(399,7473473,7473461,'tio',11.111,2),(399,7473474,7473461,'ion',11.111,2),(399,7473475,7473461,'ona',11.111,2),(399,7473476,7473461,'nal',11.111,2),(399,7473477,7473468,'nor',25,1),(399,7473478,7473468,'orm',25,1),(399,7473479,7473468,'rma',25,1),(399,7473480,7473468,'mal',25,1),(399,7473481,7473477,'mes',20,1),(399,7473482,7473477,'ess',20,1),(399,7473483,7473477,'ssa',20,1),(399,7473484,7473477,'sag',20,1),(399,7473485,7473477,'age',20,1),(399,7473486,7473481,'per',11.111,1),(399,7473487,7473481,'erf',11.111,1),(399,7473488,7473481,'rfo',11.111,1),(399,7473489,7473481,'for',11.111,1),(399,7473490,7473481,'orm',11.111,1),(399,7473491,7473481,'rma',11.111,1),(399,7473492,7473481,'man',11.111,1),(399,7473493,7473481,'anc',11.111,1),(399,7473494,7473481,'nce',11.111,1),(399,7473495,7473486,'ide',12.5,1),(399,7473496,7473486,'den',12.5,1),(399,7473497,7473486,'ent',12.5,1),(399,7473498,7473486,'nti',12.5,1),(399,7473499,7473486,'tif',12.5,1),(399,7473500,7473486,'ifi',12.5,1),(399,7473501,7473486,'fie',12.5,1),(399,7473502,7473486,'ier',12.5,1),(399,7473503,7473495,'vdi',33.333,3),(399,7473504,7473495,'dis',33.333,3),(399,7473505,7473495,'isk',33.333,3),(399,7473506,7473503,'nam',50,1),(399,7473507,7473503,'ame',50,1),(399,7473508,7473506,'typ',50,1),(399,7473509,7473506,'ype',50,1),(399,7473510,7473508,'dir',25,1),(399,7473511,7473508,'ire',25,1),(399,7473512,7473508,'rec',25,1),(399,7473513,7473508,'ect',25,1),(400,7473515,7473514,'naa',100,2),(400,7473516,7473515,'600',3.333,3),(400,7473517,7473515,'000',3.333,3),(400,7473518,7473515,'00c',3.333,3),(400,7473519,7473515,'0c2',3.333,3),(400,7473520,7473515,'c29',3.333,3),(400,7473521,7473515,'29b',3.333,3),(400,7473522,7473515,'9b2',3.333,3),(400,7473523,7473515,'b23',3.333,3),(400,7473524,7473515,'235',3.333,3),(400,7473525,7473515,'356',3.333,3),(400,7473526,7473515,'567',3.333,3),(400,7473527,7473515,'672',3.333,3),(400,7473528,7473515,'727',3.333,3),(400,7473529,7473515,'272',3.333,3),(400,7473530,7473515,'72d',3.333,3),(400,7473531,7473515,'2d0',3.333,3),(400,7473532,7473515,'d0e',3.333,3),(400,7473533,7473515,'0e5',3.333,3),(400,7473534,7473515,'e58',3.333,3),(400,7473535,7473515,'586',3.333,3),(400,7473536,7473515,'862',3.333,3),(400,7473537,7473515,'620',3.333,3),(400,7473538,7473515,'205',3.333,3),(400,7473539,7473515,'05d',3.333,3),(400,7473540,7473515,'5dc',3.333,3),(400,7473541,7473515,'dcc',3.333,3),(400,7473542,7473515,'cc3',3.333,3),(400,7473543,7473515,'c32',3.333,3),(400,7473544,7473515,'32c',3.333,3),(400,7473545,7473515,'2cf',3.333,3),(400,7473546,7473516,'mon',100,1),(400,7473547,7473546,'201',50,1),(400,7473548,7473546,'013',50,1),(400,7473549,7473547,'adm',33.333,3),(400,7473550,7473547,'dmi',33.333,3),(400,7473551,7473547,'min',33.333,3),(400,7473552,7473549,'cap',16.667,1),(400,7473553,7473549,'apa',16.667,1),(400,7473554,7473549,'pac',16.667,1),(400,7473555,7473549,'aci',16.667,1),(400,7473556,7473549,'cit',16.667,1),(400,7473557,7473549,'ity',16.667,1),(400,7473558,7473552,'pat',50,1),(400,7473559,7473552,'ath',50,1),(400,7473560,7473558,'fre',14.286,1),(400,7473561,7473558,'ree',14.286,1),(400,7473562,7473558,'ees',14.286,1),(400,7473563,7473558,'esp',14.286,1),(400,7473564,7473558,'spa',14.286,1),(400,7473565,7473558,'pac',14.286,1),(400,7473566,7473558,'ace',14.286,1),(400,7473567,7473560,'dis',50,1),(400,7473568,7473560,'isk',50,1),(400,7473569,7473567,'ind',33.333,1),(400,7473570,7473567,'nde',33.333,1),(400,7473571,7473567,'dex',33.333,1),(400,7473572,7473569,'adm',8.333,1),(400,7473573,7473569,'dmi',8.333,1),(400,7473574,7473569,'min',8.333,1),(400,7473575,7473569,'ini',8.333,1),(400,7473576,7473569,'nis',8.333,1),(400,7473577,7473569,'ist',8.333,1),(400,7473578,7473569,'str',8.333,1),(400,7473579,7473569,'tra',8.333,1),(400,7473580,7473569,'rat',8.333,1),(400,7473581,7473569,'ati',8.333,1),(400,7473582,7473569,'tio',8.333,1),(400,7473583,7473569,'ion',8.333,1),(400,7473584,7473572,'sta',33.333,3),(400,7473585,7473572,'tat',33.333,3),(400,7473586,7473572,'ate',33.333,3),(400,7473587,7473584,'ena',20,2),(400,7473588,7473584,'nab',20,2),(400,7473589,7473584,'abl',20,2),(400,7473590,7473584,'ble',20,2),(400,7473591,7473584,'led',20,2),(400,7473592,7473587,'cac',33.333,1),(400,7473593,7473587,'ach',33.333,1),(400,7473594,7473587,'che',33.333,1),(400,7473595,7473592,'mod',50,2),(400,7473596,7473592,'ode',50,2),(400,7473597,7473595,'wri',14.286,2),(400,7473598,7473595,'rit',14.286,2),(400,7473599,7473595,'ite',14.286,2),(400,7473600,7473595,'tet',14.286,2),(400,7473601,7473595,'eth',14.286,2),(400,7473602,7473595,'thr',14.286,2),(400,7473603,7473595,'hru',14.286,2),(400,7473604,7473597,'ope',11.111,2),(400,7473605,7473597,'per',11.111,2),(400,7473606,7473597,'era',11.111,2),(400,7473607,7473597,'rat',11.111,2),(400,7473608,7473597,'ati',11.111,2),(400,7473609,7473597,'tio',11.111,2),(400,7473610,7473597,'ion',11.111,2),(400,7473611,7473597,'ona',11.111,2),(400,7473612,7473597,'nal',11.111,2),(400,7473613,7473604,'nor',25,1),(400,7473614,7473604,'orm',25,1),(400,7473615,7473604,'rma',25,1),(400,7473616,7473604,'mal',25,1),(400,7473617,7473613,'mes',20,1),(400,7473618,7473613,'ess',20,1),(400,7473619,7473613,'ssa',20,1),(400,7473620,7473613,'sag',20,1),(400,7473621,7473613,'age',20,1),(400,7473622,7473617,'per',11.111,1),(400,7473623,7473617,'erf',11.111,1),(400,7473624,7473617,'rfo',11.111,1),(400,7473625,7473617,'for',11.111,1),(400,7473626,7473617,'orm',11.111,1),(400,7473627,7473617,'rma',11.111,1),(400,7473628,7473617,'man',11.111,1),(400,7473629,7473617,'anc',11.111,1),(400,7473630,7473617,'nce',11.111,1),(400,7473631,7473622,'ide',12.5,1),(400,7473632,7473622,'den',12.5,1),(400,7473633,7473622,'ent',12.5,1),(400,7473634,7473622,'nti',12.5,1),(400,7473635,7473622,'tif',12.5,1),(400,7473636,7473622,'ifi',12.5,1),(400,7473637,7473622,'fie',12.5,1),(400,7473638,7473622,'ier',12.5,1),(400,7473639,7473631,'vdi',33.333,3),(400,7473640,7473631,'dis',33.333,3),(400,7473641,7473631,'isk',33.333,3),(400,7473642,7473639,'nam',50,1),(400,7473643,7473639,'ame',50,1),(400,7473644,7473642,'typ',50,1),(400,7473645,7473642,'ype',50,1),(400,7473646,7473644,'dir',25,1),(400,7473647,7473644,'ire',25,1),(400,7473648,7473644,'rec',25,1),(400,7473649,7473644,'ect',25,1),(401,7473651,7473650,'naa',100,2),(401,7473652,7473651,'600',3.333,3),(401,7473653,7473651,'000',3.333,3),(401,7473654,7473651,'00c',3.333,3),(401,7473655,7473651,'0c2',3.333,3),(401,7473656,7473651,'c29',3.333,3),(401,7473657,7473651,'295',3.333,3),(401,7473658,7473651,'95e',3.333,3),(401,7473659,7473651,'5e8',3.333,3),(401,7473660,7473651,'e8b',3.333,3),(401,7473661,7473651,'8b4',3.333,3),(401,7473662,7473651,'b49',3.333,3),(401,7473663,7473651,'49c',3.333,3),(401,7473664,7473651,'9c5',3.333,3),(401,7473665,7473651,'c56',3.333,3),(401,7473666,7473651,'56d',3.333,3),(401,7473667,7473651,'6dd',3.333,3),(401,7473668,7473651,'dd6',3.333,3),(401,7473669,7473651,'d68',3.333,3),(401,7473670,7473651,'682',3.333,3),(401,7473671,7473651,'827',3.333,3),(401,7473672,7473651,'27f',3.333,3),(401,7473673,7473651,'7fe',3.333,3),(401,7473674,7473651,'fe4',3.333,3),(401,7473675,7473651,'e41',3.333,3),(401,7473676,7473651,'418',3.333,3),(401,7473677,7473651,'18e',3.333,3),(401,7473678,7473651,'8ea',3.333,3),(401,7473679,7473651,'ea7',3.333,3),(401,7473680,7473651,'a71',3.333,3),(401,7473681,7473651,'715',3.333,3),(401,7473682,7473652,'mon',100,1),(401,7473683,7473682,'201',50,1),(401,7473684,7473682,'013',50,1),(401,7473685,7473683,'adm',33.333,3),(401,7473686,7473683,'dmi',33.333,3),(401,7473687,7473683,'min',33.333,3),(401,7473688,7473685,'cap',16.667,1),(401,7473689,7473685,'apa',16.667,1),(401,7473690,7473685,'pac',16.667,1),(401,7473691,7473685,'aci',16.667,1),(401,7473692,7473685,'cit',16.667,1),(401,7473693,7473685,'ity',16.667,1),(401,7473694,7473688,'pat',50,1),(401,7473695,7473688,'ath',50,1),(401,7473696,7473694,'fre',14.286,1),(401,7473697,7473694,'ree',14.286,1),(401,7473698,7473694,'ees',14.286,1),(401,7473699,7473694,'esp',14.286,1),(401,7473700,7473694,'spa',14.286,1),(401,7473701,7473694,'pac',14.286,1),(401,7473702,7473694,'ace',14.286,1),(401,7473703,7473696,'dis',50,1),(401,7473704,7473696,'isk',50,1),(401,7473705,7473703,'ind',33.333,1),(401,7473706,7473703,'nde',33.333,1),(401,7473707,7473703,'dex',33.333,1),(401,7473708,7473705,'adm',8.333,1),(401,7473709,7473705,'dmi',8.333,1),(401,7473710,7473705,'min',8.333,1),(401,7473711,7473705,'ini',8.333,1),(401,7473712,7473705,'nis',8.333,1),(401,7473713,7473705,'ist',8.333,1),(401,7473714,7473705,'str',8.333,1),(401,7473715,7473705,'tra',8.333,1),(401,7473716,7473705,'rat',8.333,1),(401,7473717,7473705,'ati',8.333,1),(401,7473718,7473705,'tio',8.333,1),(401,7473719,7473705,'ion',8.333,1),(401,7473720,7473708,'sta',33.333,3),(401,7473721,7473708,'tat',33.333,3),(401,7473722,7473708,'ate',33.333,3),(401,7473723,7473720,'ena',20,2),(401,7473724,7473720,'nab',20,2),(401,7473725,7473720,'abl',20,2),(401,7473726,7473720,'ble',20,2),(401,7473727,7473720,'led',20,2),(401,7473728,7473723,'cac',33.333,1),(401,7473729,7473723,'ach',33.333,1),(401,7473730,7473723,'che',33.333,1),(401,7473731,7473728,'mod',50,2),(401,7473732,7473728,'ode',50,2),(401,7473733,7473731,'wri',14.286,2),(401,7473734,7473731,'rit',14.286,2),(401,7473735,7473731,'ite',14.286,2),(401,7473736,7473731,'tet',14.286,2),(401,7473737,7473731,'eth',14.286,2),(401,7473738,7473731,'thr',14.286,2),(401,7473739,7473731,'hru',14.286,2),(401,7473740,7473733,'ope',11.111,2),(401,7473741,7473733,'per',11.111,2),(401,7473742,7473733,'era',11.111,2),(401,7473743,7473733,'rat',11.111,2),(401,7473744,7473733,'ati',11.111,2),(401,7473745,7473733,'tio',11.111,2),(401,7473746,7473733,'ion',11.111,2),(401,7473747,7473733,'ona',11.111,2),(401,7473748,7473733,'nal',11.111,2),(401,7473749,7473740,'nor',25,1),(401,7473750,7473740,'orm',25,1),(401,7473751,7473740,'rma',25,1),(401,7473752,7473740,'mal',25,1),(401,7473753,7473749,'mes',20,1),(401,7473754,7473749,'ess',20,1),(401,7473755,7473749,'ssa',20,1),(401,7473756,7473749,'sag',20,1),(401,7473757,7473749,'age',20,1),(401,7473758,7473753,'per',11.111,1),(401,7473759,7473753,'erf',11.111,1),(401,7473760,7473753,'rfo',11.111,1),(401,7473761,7473753,'for',11.111,1),(401,7473762,7473753,'orm',11.111,1),(401,7473763,7473753,'rma',11.111,1),(401,7473764,7473753,'man',11.111,1),(401,7473765,7473753,'anc',11.111,1),(401,7473766,7473753,'nce',11.111,1),(401,7473767,7473758,'ide',12.5,1),(401,7473768,7473758,'den',12.5,1),(401,7473769,7473758,'ent',12.5,1),(401,7473770,7473758,'nti',12.5,1),(401,7473771,7473758,'tif',12.5,1),(401,7473772,7473758,'ifi',12.5,1),(401,7473773,7473758,'fie',12.5,1),(401,7473774,7473758,'ier',12.5,1),(401,7473775,7473767,'vdi',33.333,3),(401,7473776,7473767,'dis',33.333,3),(401,7473777,7473767,'isk',33.333,3),(401,7473778,7473775,'nam',50,1),(401,7473779,7473775,'ame',50,1),(401,7473780,7473778,'typ',50,1),(401,7473781,7473778,'ype',50,1),(401,7473782,7473780,'dir',25,1),(401,7473783,7473780,'ire',25,1),(401,7473784,7473780,'rec',25,1),(401,7473785,7473780,'ect',25,1),(402,7473787,7473786,'naa',100,2),(402,7473788,7473787,'600',3.333,3),(402,7473789,7473787,'000',3.333,3),(402,7473790,7473787,'00c',3.333,3),(402,7473791,7473787,'0c2',3.333,3),(402,7473792,7473787,'c29',3.333,3),(402,7473793,7473787,'298',3.333,3),(402,7473794,7473787,'981',3.333,3),(402,7473795,7473787,'81d',3.333,3),(402,7473796,7473787,'1d5',3.333,3),(402,7473797,7473787,'d55',3.333,3),(402,7473798,7473787,'553',3.333,3),(402,7473799,7473787,'53a',3.333,3),(402,7473800,7473787,'3aa',3.333,3),(402,7473801,7473787,'aa2',3.333,3),(402,7473802,7473787,'a25',3.333,3),(402,7473803,7473787,'25c',3.333,3),(402,7473804,7473787,'5cf',3.333,3),(402,7473805,7473787,'cfe',3.333,3),(402,7473806,7473787,'fef',3.333,3),(402,7473807,7473787,'efe',3.333,3),(402,7473808,7473787,'fee',3.333,3),(402,7473809,7473787,'eeb',3.333,3),(402,7473810,7473787,'eb7',3.333,3),(402,7473811,7473787,'b7b',3.333,3),(402,7473812,7473787,'7b4',3.333,3),(402,7473813,7473787,'b4b',3.333,3),(402,7473814,7473787,'4bc',3.333,3),(402,7473815,7473787,'bc2',3.333,3),(402,7473816,7473787,'c25',3.333,3),(402,7473817,7473787,'25e',3.333,3),(402,7473818,7473788,'mon',100,1),(402,7473819,7473818,'201',50,1),(402,7473820,7473818,'013',50,1),(402,7473821,7473819,'adm',33.333,3),(402,7473822,7473819,'dmi',33.333,3),(402,7473823,7473819,'min',33.333,3),(402,7473824,7473821,'cap',16.667,1),(402,7473825,7473821,'apa',16.667,1),(402,7473826,7473821,'pac',16.667,1),(402,7473827,7473821,'aci',16.667,1),(402,7473828,7473821,'cit',16.667,1),(402,7473829,7473821,'ity',16.667,1),(402,7473830,7473824,'pat',50,1),(402,7473831,7473824,'ath',50,1),(402,7473832,7473830,'two',100,1),(402,7473833,7473832,'fre',14.286,1),(402,7473834,7473832,'ree',14.286,1),(402,7473835,7473832,'ees',14.286,1),(402,7473836,7473832,'esp',14.286,1),(402,7473837,7473832,'spa',14.286,1),(402,7473838,7473832,'pac',14.286,1),(402,7473839,7473832,'ace',14.286,1),(402,7473840,7473833,'dis',50,1),(402,7473841,7473833,'isk',50,1),(402,7473842,7473840,'ind',33.333,1),(402,7473843,7473840,'nde',33.333,1),(402,7473844,7473840,'dex',33.333,1),(402,7473845,7473842,'adm',8.333,1),(402,7473846,7473842,'dmi',8.333,1),(402,7473847,7473842,'min',8.333,1),(402,7473848,7473842,'ini',8.333,1),(402,7473849,7473842,'nis',8.333,1),(402,7473850,7473842,'ist',8.333,1),(402,7473851,7473842,'str',8.333,1),(402,7473852,7473842,'tra',8.333,1),(402,7473853,7473842,'rat',8.333,1),(402,7473854,7473842,'ati',8.333,1),(402,7473855,7473842,'tio',8.333,1),(402,7473856,7473842,'ion',8.333,1),(402,7473857,7473845,'sta',33.333,3),(402,7473858,7473845,'tat',33.333,3),(402,7473859,7473845,'ate',33.333,3),(402,7473860,7473857,'ena',20,2),(402,7473861,7473857,'nab',20,2),(402,7473862,7473857,'abl',20,2),(402,7473863,7473857,'ble',20,2),(402,7473864,7473857,'led',20,2),(402,7473865,7473860,'cac',33.333,1),(402,7473866,7473860,'ach',33.333,1),(402,7473867,7473860,'che',33.333,1),(402,7473868,7473865,'mod',50,2),(402,7473869,7473865,'ode',50,2),(402,7473870,7473868,'wri',14.286,2),(402,7473871,7473868,'rit',14.286,2),(402,7473872,7473868,'ite',14.286,2),(402,7473873,7473868,'tet',14.286,2),(402,7473874,7473868,'eth',14.286,2),(402,7473875,7473868,'thr',14.286,2),(402,7473876,7473868,'hru',14.286,2),(402,7473877,7473870,'ope',11.111,2),(402,7473878,7473870,'per',11.111,2),(402,7473879,7473870,'era',11.111,2),(402,7473880,7473870,'rat',11.111,2),(402,7473881,7473870,'ati',11.111,2),(402,7473882,7473870,'tio',11.111,2),(402,7473883,7473870,'ion',11.111,2),(402,7473884,7473870,'ona',11.111,2),(402,7473885,7473870,'nal',11.111,2),(402,7473886,7473877,'nor',25,1),(402,7473887,7473877,'orm',25,1),(402,7473888,7473877,'rma',25,1),(402,7473889,7473877,'mal',25,1),(402,7473890,7473886,'mes',20,1),(402,7473891,7473886,'ess',20,1),(402,7473892,7473886,'ssa',20,1),(402,7473893,7473886,'sag',20,1),(402,7473894,7473886,'age',20,1),(402,7473895,7473890,'per',11.111,1),(402,7473896,7473890,'erf',11.111,1),(402,7473897,7473890,'rfo',11.111,1),(402,7473898,7473890,'for',11.111,1),(402,7473899,7473890,'orm',11.111,1),(402,7473900,7473890,'rma',11.111,1),(402,7473901,7473890,'man',11.111,1),(402,7473902,7473890,'anc',11.111,1),(402,7473903,7473890,'nce',11.111,1),(402,7473904,7473895,'ide',12.5,1),(402,7473905,7473895,'den',12.5,1),(402,7473906,7473895,'ent',12.5,1),(402,7473907,7473895,'nti',12.5,1),(402,7473908,7473895,'tif',12.5,1),(402,7473909,7473895,'ifi',12.5,1),(402,7473910,7473895,'fie',12.5,1),(402,7473911,7473895,'ier',12.5,1),(402,7473912,7473904,'vdi',33.333,3),(402,7473913,7473904,'dis',33.333,3),(402,7473914,7473904,'isk',33.333,3),(402,7473915,7473912,'nam',50,1),(402,7473916,7473912,'ame',50,1),(402,7473917,7473915,'typ',50,1),(402,7473918,7473915,'ype',50,1),(402,7473919,7473917,'dir',25,1),(402,7473920,7473917,'ire',25,1),(402,7473921,7473917,'rec',25,1),(402,7473922,7473917,'ect',25,1),(404,7474114,7474113,'naa',100,2),(404,7474115,7474114,'600',3.333,3),(404,7474116,7474114,'000',3.333,3),(404,7474117,7474114,'00c',3.333,3),(404,7474118,7474114,'0c2',3.333,3),(404,7474119,7474114,'c29',3.333,3),(404,7474120,7474114,'293',3.333,3),(404,7474121,7474114,'937',3.333,3),(404,7474122,7474114,'37a',3.333,3),(404,7474123,7474114,'7ae',3.333,3),(404,7474124,7474114,'aed',3.333,3),(404,7474125,7474114,'edb',3.333,3),(404,7474126,7474114,'dbf',3.333,3),(404,7474127,7474114,'bf2',3.333,3),(404,7474128,7474114,'f22',3.333,3),(404,7474129,7474114,'22b',3.333,3),(404,7474130,7474114,'2b1',3.333,3),(404,7474131,7474114,'b1b',3.333,3),(404,7474132,7474114,'1bf',3.333,3),(404,7474133,7474114,'bf4',3.333,3),(404,7474134,7474114,'f4f',3.333,3),(404,7474135,7474114,'4f8',3.333,3),(404,7474136,7474114,'f87',3.333,3),(404,7474137,7474114,'872',3.333,3),(404,7474138,7474114,'72c',3.333,3),(404,7474139,7474114,'2c4',3.333,3),(404,7474140,7474114,'c47',3.333,3),(404,7474141,7474114,'476',3.333,3),(404,7474142,7474114,'765',3.333,3),(404,7474143,7474114,'65d',3.333,3),(404,7474144,7474114,'5df',3.333,3),(404,7474145,7474115,'mon',100,1),(404,7474146,7474145,'201',50,1),(404,7474147,7474145,'013',50,1),(404,7474148,7474146,'adm',33.333,3),(404,7474149,7474146,'dmi',33.333,3),(404,7474150,7474146,'min',33.333,3),(404,7474151,7474148,'cap',16.667,1),(404,7474152,7474148,'apa',16.667,1),(404,7474153,7474148,'pac',16.667,1),(404,7474154,7474148,'aci',16.667,1),(404,7474155,7474148,'cit',16.667,1),(404,7474156,7474148,'ity',16.667,1),(404,7474157,7474151,'pat',50,1),(404,7474158,7474151,'ath',50,1),(404,7474159,7474157,'fre',14.286,1),(404,7474160,7474157,'ree',14.286,1),(404,7474161,7474157,'ees',14.286,1),(404,7474162,7474157,'esp',14.286,1),(404,7474163,7474157,'spa',14.286,1),(404,7474164,7474157,'pac',14.286,1),(404,7474165,7474157,'ace',14.286,1),(404,7474166,7474159,'dis',50,1),(404,7474167,7474159,'isk',50,1),(404,7474168,7474166,'ind',33.333,1),(404,7474169,7474166,'nde',33.333,1),(404,7474170,7474166,'dex',33.333,1),(404,7474171,7474168,'adm',8.333,1),(404,7474172,7474168,'dmi',8.333,1),(404,7474173,7474168,'min',8.333,1),(404,7474174,7474168,'ini',8.333,1),(404,7474175,7474168,'nis',8.333,1),(404,7474176,7474168,'ist',8.333,1),(404,7474177,7474168,'str',8.333,1),(404,7474178,7474168,'tra',8.333,1),(404,7474179,7474168,'rat',8.333,1),(404,7474180,7474168,'ati',8.333,1),(404,7474181,7474168,'tio',8.333,1),(404,7474182,7474168,'ion',8.333,1),(404,7474183,7474171,'sta',33.333,3),(404,7474184,7474171,'tat',33.333,3),(404,7474185,7474171,'ate',33.333,3),(404,7474186,7474183,'ena',20,2),(404,7474187,7474183,'nab',20,2),(404,7474188,7474183,'abl',20,2),(404,7474189,7474183,'ble',20,2),(404,7474190,7474183,'led',20,2),(404,7474191,7474186,'cac',33.333,2),(404,7474192,7474186,'ach',33.333,2),(404,7474193,7474186,'che',33.333,2),(404,7474194,7474191,'mod',50,1),(404,7474195,7474191,'ode',50,1),(404,7474196,7474194,'wri',14.286,1),(404,7474197,7474194,'rit',14.286,1),(404,7474198,7474194,'ite',14.286,1),(404,7474199,7474194,'tet',14.286,1),(404,7474200,7474194,'eth',14.286,1),(404,7474201,7474194,'thr',14.286,1),(404,7474202,7474194,'hru',14.286,1),(404,7474203,7474196,'ope',11.111,2),(404,7474204,7474196,'per',11.111,2),(404,7474205,7474196,'era',11.111,2),(404,7474206,7474196,'rat',11.111,2),(404,7474207,7474196,'ati',11.111,2),(404,7474208,7474196,'tio',11.111,2),(404,7474209,7474196,'ion',11.111,2),(404,7474210,7474196,'ona',11.111,2),(404,7474211,7474196,'nal',11.111,2),(404,7474212,7474203,'pen',20,1),(404,7474213,7474203,'end',20,1),(404,7474214,7474203,'ndi',20,1),(404,7474215,7474203,'din',20,1),(404,7474216,7474203,'ing',20,1),(404,7474217,7474212,'mes',20,1),(404,7474218,7474212,'ess',20,1),(404,7474219,7474212,'ssa',20,1),(404,7474220,7474212,'sag',20,1),(404,7474221,7474212,'age',20,1),(404,7474222,7474217,'wai',20,1),(404,7474223,7474217,'ait',20,1),(404,7474224,7474217,'iti',20,1),(404,7474225,7474217,'tin',20,1),(404,7474226,7474217,'ing',20,1),(404,7474227,7474222,'for',100,1),(404,7474228,7474227,'per',11.111,1),(404,7474229,7474227,'erf',11.111,1),(404,7474230,7474227,'rfo',11.111,1),(404,7474231,7474227,'for',11.111,1),(404,7474232,7474227,'orm',11.111,1),(404,7474233,7474227,'rma',11.111,1),(404,7474234,7474227,'man',11.111,1),(404,7474235,7474227,'anc',11.111,1),(404,7474236,7474227,'nce',11.111,1),(404,7474237,7474228,'ide',12.5,1),(404,7474238,7474228,'den',12.5,1),(404,7474239,7474228,'ent',12.5,1),(404,7474240,7474228,'nti',12.5,1),(404,7474241,7474228,'tif',12.5,1),(404,7474242,7474228,'ifi',12.5,1),(404,7474243,7474228,'fie',12.5,1),(404,7474244,7474228,'ier',12.5,1),(404,7474245,7474237,'vdi',33.333,3),(404,7474246,7474237,'dis',33.333,3),(404,7474247,7474237,'isk',33.333,3),(404,7474248,7474245,'nam',50,1),(404,7474249,7474245,'ame',50,1),(404,7474250,7474248,'typ',50,1),(404,7474251,7474248,'ype',50,1),(404,7474252,7474250,'dir',25,1),(404,7474253,7474250,'ire',25,1),(404,7474254,7474250,'rec',25,1),(404,7474255,7474250,'ect',25,1),(405,7474257,7474256,'naa',100,2),(405,7474258,7474257,'600',3.333,3),(405,7474259,7474257,'00a',3.333,3),(405,7474260,7474257,'0a0',3.333,3),(405,7474261,7474257,'a09',3.333,3),(405,7474262,7474257,'098',3.333,3),(405,7474263,7474257,'980',3.333,3),(405,7474264,7474257,'804',3.333,3),(405,7474265,7474257,'044',3.333,3),(405,7474266,7474257,'443',3.333,3),(405,7474267,7474257,'430',3.333,3),(405,7474268,7474257,'307',3.333,3),(405,7474269,7474257,'072',3.333,3),(405,7474270,7474257,'725',3.333,3),(405,7474271,7474257,'259',3.333,3),(405,7474272,7474257,'593',3.333,3),(405,7474273,7474257,'931',3.333,3),(405,7474274,7474257,'313',3.333,3),(405,7474275,7474257,'13f',3.333,3),(405,7474276,7474257,'3f3',3.333,3),(405,7474277,7474257,'f33',3.333,3),(405,7474278,7474257,'334',3.333,3),(405,7474279,7474257,'345',3.333,3),(405,7474280,7474257,'455',3.333,3),(405,7474281,7474257,'556',3.333,3),(405,7474282,7474257,'563',3.333,3),(405,7474283,7474257,'639',3.333,3),(405,7474284,7474257,'393',3.333,3),(405,7474285,7474257,'934',3.333,3),(405,7474286,7474257,'344',3.333,3),(405,7474287,7474257,'443',3.333,3),(405,7474288,7474258,'mon',100,1),(405,7474289,7474288,'201',50,1),(405,7474290,7474288,'013',50,1),(405,7474291,7474289,'adm',33.333,3),(405,7474292,7474289,'dmi',33.333,3),(405,7474293,7474289,'min',33.333,3),(405,7474294,7474291,'cap',16.667,1),(405,7474295,7474291,'apa',16.667,1),(405,7474296,7474291,'pac',16.667,1),(405,7474297,7474291,'aci',16.667,1),(405,7474298,7474291,'cit',16.667,1),(405,7474299,7474291,'ity',16.667,1),(405,7474300,7474294,'pat',50,1),(405,7474301,7474294,'ath',50,1),(405,7474302,7474300,'fre',14.286,1),(405,7474303,7474300,'ree',14.286,1),(405,7474304,7474300,'ees',14.286,1),(405,7474305,7474300,'esp',14.286,1),(405,7474306,7474300,'spa',14.286,1),(405,7474307,7474300,'pac',14.286,1),(405,7474308,7474300,'ace',14.286,1),(405,7474309,7474302,'dis',50,1),(405,7474310,7474302,'isk',50,1),(405,7474311,7474309,'ind',33.333,1),(405,7474312,7474309,'nde',33.333,1),(405,7474313,7474309,'dex',33.333,1),(405,7474314,7474311,'adm',8.333,1),(405,7474315,7474311,'dmi',8.333,1),(405,7474316,7474311,'min',8.333,1),(405,7474317,7474311,'ini',8.333,1),(405,7474318,7474311,'nis',8.333,1),(405,7474319,7474311,'ist',8.333,1),(405,7474320,7474311,'str',8.333,1),(405,7474321,7474311,'tra',8.333,1),(405,7474322,7474311,'rat',8.333,1),(405,7474323,7474311,'ati',8.333,1),(405,7474324,7474311,'tio',8.333,1),(405,7474325,7474311,'ion',8.333,1),(405,7474326,7474314,'sta',33.333,3),(405,7474327,7474314,'tat',33.333,3),(405,7474328,7474314,'ate',33.333,3),(405,7474329,7474326,'ena',20,2),(405,7474330,7474326,'nab',20,2),(405,7474331,7474326,'abl',20,2),(405,7474332,7474326,'ble',20,2),(405,7474333,7474326,'led',20,2),(405,7474334,7474329,'cac',33.333,2),(405,7474335,7474329,'ach',33.333,2),(405,7474336,7474329,'che',33.333,2),(405,7474337,7474334,'mod',50,1),(405,7474338,7474334,'ode',50,1),(405,7474339,7474337,'wri',14.286,1),(405,7474340,7474337,'rit',14.286,1),(405,7474341,7474337,'ite',14.286,1),(405,7474342,7474337,'tet',14.286,1),(405,7474343,7474337,'eth',14.286,1),(405,7474344,7474337,'thr',14.286,1),(405,7474345,7474337,'hru',14.286,1),(405,7474346,7474339,'ope',11.111,2),(405,7474347,7474339,'per',11.111,2),(405,7474348,7474339,'era',11.111,2),(405,7474349,7474339,'rat',11.111,2),(405,7474350,7474339,'ati',11.111,2),(405,7474351,7474339,'tio',11.111,2),(405,7474352,7474339,'ion',11.111,2),(405,7474353,7474339,'ona',11.111,2),(405,7474354,7474339,'nal',11.111,2),(405,7474355,7474346,'pen',20,1),(405,7474356,7474346,'end',20,1),(405,7474357,7474346,'ndi',20,1),(405,7474358,7474346,'din',20,1),(405,7474359,7474346,'ing',20,1),(405,7474360,7474355,'mes',20,1),(405,7474361,7474355,'ess',20,1),(405,7474362,7474355,'ssa',20,1),(405,7474363,7474355,'sag',20,1),(405,7474364,7474355,'age',20,1),(405,7474365,7474360,'wai',20,1),(405,7474366,7474360,'ait',20,1),(405,7474367,7474360,'iti',20,1),(405,7474368,7474360,'tin',20,1),(405,7474369,7474360,'ing',20,1),(405,7474370,7474365,'for',100,1),(405,7474371,7474370,'per',11.111,1),(405,7474372,7474370,'erf',11.111,1),(405,7474373,7474370,'rfo',11.111,1),(405,7474374,7474370,'for',11.111,1),(405,7474375,7474370,'orm',11.111,1),(405,7474376,7474370,'rma',11.111,1),(405,7474377,7474370,'man',11.111,1),(405,7474378,7474370,'anc',11.111,1),(405,7474379,7474370,'nce',11.111,1),(405,7474380,7474371,'ide',12.5,1),(405,7474381,7474371,'den',12.5,1),(405,7474382,7474371,'ent',12.5,1),(405,7474383,7474371,'nti',12.5,1),(405,7474384,7474371,'tif',12.5,1),(405,7474385,7474371,'ifi',12.5,1),(405,7474386,7474371,'fie',12.5,1),(405,7474387,7474371,'ier',12.5,1),(405,7474388,7474380,'vdi',33.333,3),(405,7474389,7474380,'dis',33.333,3),(405,7474390,7474380,'isk',33.333,3),(405,7474391,7474388,'nam',50,1),(405,7474392,7474388,'ame',50,1),(405,7474393,7474391,'typ',50,1),(405,7474394,7474391,'ype',50,1),(405,7474395,7474393,'dir',25,1),(405,7474396,7474393,'ire',25,1),(405,7474397,7474393,'rec',25,1),(405,7474398,7474393,'ect',25,1),(406,7474400,7474399,'naa',100,2),(406,7474401,7474400,'600',3.333,3),(406,7474402,7474400,'00a',3.333,3),(406,7474403,7474400,'0a0',3.333,3),(406,7474404,7474400,'a09',3.333,3),(406,7474405,7474400,'098',3.333,3),(406,7474406,7474400,'980',3.333,3),(406,7474407,7474400,'804',3.333,3),(406,7474408,7474400,'044',3.333,3),(406,7474409,7474400,'443',3.333,3),(406,7474410,7474400,'430',3.333,3),(406,7474411,7474400,'307',3.333,3),(406,7474412,7474400,'072',3.333,3),(406,7474413,7474400,'725',3.333,3),(406,7474414,7474400,'259',3.333,3),(406,7474415,7474400,'593',3.333,3),(406,7474416,7474400,'931',3.333,3),(406,7474417,7474400,'313',3.333,3),(406,7474418,7474400,'13f',3.333,3),(406,7474419,7474400,'3f3',3.333,3),(406,7474420,7474400,'f33',3.333,3),(406,7474421,7474400,'334',3.333,3),(406,7474422,7474400,'345',3.333,3),(406,7474423,7474400,'455',3.333,3),(406,7474424,7474400,'556',3.333,3),(406,7474425,7474400,'563',3.333,3),(406,7474426,7474400,'639',3.333,3),(406,7474427,7474400,'393',3.333,3),(406,7474428,7474400,'934',3.333,3),(406,7474429,7474400,'344',3.333,3),(406,7474430,7474400,'444',3.333,3),(406,7474431,7474401,'mon',100,1),(406,7474432,7474431,'201',50,1),(406,7474433,7474431,'013',50,1),(406,7474434,7474432,'adm',33.333,3),(406,7474435,7474432,'dmi',33.333,3),(406,7474436,7474432,'min',33.333,3),(406,7474437,7474434,'cap',16.667,1),(406,7474438,7474434,'apa',16.667,1),(406,7474439,7474434,'pac',16.667,1),(406,7474440,7474434,'aci',16.667,1),(406,7474441,7474434,'cit',16.667,1),(406,7474442,7474434,'ity',16.667,1),(406,7474443,7474437,'pat',50,1),(406,7474444,7474437,'ath',50,1),(406,7474445,7474443,'fre',14.286,1),(406,7474446,7474443,'ree',14.286,1),(406,7474447,7474443,'ees',14.286,1),(406,7474448,7474443,'esp',14.286,1),(406,7474449,7474443,'spa',14.286,1),(406,7474450,7474443,'pac',14.286,1),(406,7474451,7474443,'ace',14.286,1),(406,7474452,7474445,'dis',50,1),(406,7474453,7474445,'isk',50,1),(406,7474454,7474452,'ind',33.333,1),(406,7474455,7474452,'nde',33.333,1),(406,7474456,7474452,'dex',33.333,1),(406,7474457,7474454,'adm',8.333,1),(406,7474458,7474454,'dmi',8.333,1),(406,7474459,7474454,'min',8.333,1),(406,7474460,7474454,'ini',8.333,1),(406,7474461,7474454,'nis',8.333,1),(406,7474462,7474454,'ist',8.333,1),(406,7474463,7474454,'str',8.333,1),(406,7474464,7474454,'tra',8.333,1),(406,7474465,7474454,'rat',8.333,1),(406,7474466,7474454,'ati',8.333,1),(406,7474467,7474454,'tio',8.333,1),(406,7474468,7474454,'ion',8.333,1),(406,7474469,7474457,'sta',33.333,3),(406,7474470,7474457,'tat',33.333,3),(406,7474471,7474457,'ate',33.333,3),(406,7474472,7474469,'ena',20,2),(406,7474473,7474469,'nab',20,2),(406,7474474,7474469,'abl',20,2),(406,7474475,7474469,'ble',20,2),(406,7474476,7474469,'led',20,2),(406,7474477,7474472,'cac',33.333,2),(406,7474478,7474472,'ach',33.333,2),(406,7474479,7474472,'che',33.333,2),(406,7474480,7474477,'mod',50,1),(406,7474481,7474477,'ode',50,1),(406,7474482,7474480,'wri',14.286,1),(406,7474483,7474480,'rit',14.286,1),(406,7474484,7474480,'ite',14.286,1),(406,7474485,7474480,'tet',14.286,1),(406,7474486,7474480,'eth',14.286,1),(406,7474487,7474480,'thr',14.286,1),(406,7474488,7474480,'hru',14.286,1),(406,7474489,7474482,'ope',11.111,2),(406,7474490,7474482,'per',11.111,2),(406,7474491,7474482,'era',11.111,2),(406,7474492,7474482,'rat',11.111,2),(406,7474493,7474482,'ati',11.111,2),(406,7474494,7474482,'tio',11.111,2),(406,7474495,7474482,'ion',11.111,2),(406,7474496,7474482,'ona',11.111,2),(406,7474497,7474482,'nal',11.111,2),(406,7474498,7474489,'pen',20,1),(406,7474499,7474489,'end',20,1),(406,7474500,7474489,'ndi',20,1),(406,7474501,7474489,'din',20,1),(406,7474502,7474489,'ing',20,1),(406,7474503,7474498,'mes',20,1),(406,7474504,7474498,'ess',20,1),(406,7474505,7474498,'ssa',20,1),(406,7474506,7474498,'sag',20,1),(406,7474507,7474498,'age',20,1),(406,7474508,7474503,'wai',20,1),(406,7474509,7474503,'ait',20,1),(406,7474510,7474503,'iti',20,1),(406,7474511,7474503,'tin',20,1),(406,7474512,7474503,'ing',20,1),(406,7474513,7474508,'for',100,1),(406,7474514,7474513,'per',11.111,1),(406,7474515,7474513,'erf',11.111,1),(406,7474516,7474513,'rfo',11.111,1),(406,7474517,7474513,'for',11.111,1),(406,7474518,7474513,'orm',11.111,1),(406,7474519,7474513,'rma',11.111,1),(406,7474520,7474513,'man',11.111,1),(406,7474521,7474513,'anc',11.111,1),(406,7474522,7474513,'nce',11.111,1),(406,7474523,7474514,'ide',12.5,1),(406,7474524,7474514,'den',12.5,1),(406,7474525,7474514,'ent',12.5,1),(406,7474526,7474514,'nti',12.5,1),(406,7474527,7474514,'tif',12.5,1),(406,7474528,7474514,'ifi',12.5,1),(406,7474529,7474514,'fie',12.5,1),(406,7474530,7474514,'ier',12.5,1),(406,7474531,7474523,'vdi',33.333,3),(406,7474532,7474523,'dis',33.333,3),(406,7474533,7474523,'isk',33.333,3),(406,7474534,7474531,'nam',50,1),(406,7474535,7474531,'ame',50,1),(406,7474536,7474534,'typ',50,1),(406,7474537,7474534,'ype',50,1),(406,7474538,7474536,'dir',25,1),(406,7474539,7474536,'ire',25,1),(406,7474540,7474536,'rec',25,1),(406,7474541,7474536,'ect',25,1),(407,7474543,7474542,'naa',100,2),(407,7474544,7474543,'600',3.333,3),(407,7474545,7474543,'00a',3.333,3),(407,7474546,7474543,'0a0',3.333,3),(407,7474547,7474543,'a09',3.333,3),(407,7474548,7474543,'098',3.333,3),(407,7474549,7474543,'980',3.333,3),(407,7474550,7474543,'804',3.333,3),(407,7474551,7474543,'044',3.333,3),(407,7474552,7474543,'443',3.333,3),(407,7474553,7474543,'430',3.333,3),(407,7474554,7474543,'307',3.333,3),(407,7474555,7474543,'075',3.333,3),(407,7474556,7474543,'753',3.333,3),(407,7474557,7474543,'535',3.333,3),(407,7474558,7474543,'357',3.333,3),(407,7474559,7474543,'573',3.333,3),(407,7474560,7474543,'732',3.333,3),(407,7474561,7474543,'32b',3.333,3),(407,7474562,7474543,'2b3',3.333,3),(407,7474563,7474543,'b33',3.333,3),(407,7474564,7474543,'334',3.333,3),(407,7474565,7474543,'345',3.333,3),(407,7474566,7474543,'457',3.333,3),(407,7474567,7474543,'571',3.333,3),(407,7474568,7474543,'715',3.333,3),(407,7474569,7474543,'153',3.333,3),(407,7474570,7474543,'533',3.333,3),(407,7474571,7474543,'335',3.333,3),(407,7474572,7474543,'357',3.333,3),(407,7474573,7474543,'579',3.333,3),(407,7474574,7474544,'mon',100,1),(407,7474575,7474574,'201',50,1),(407,7474576,7474574,'013',50,1),(407,7474577,7474575,'adm',33.333,3),(407,7474578,7474575,'dmi',33.333,3),(407,7474579,7474575,'min',33.333,3),(407,7474580,7474577,'cap',16.667,1),(407,7474581,7474577,'apa',16.667,1),(407,7474582,7474577,'pac',16.667,1),(407,7474583,7474577,'aci',16.667,1),(407,7474584,7474577,'cit',16.667,1),(407,7474585,7474577,'ity',16.667,1),(407,7474586,7474580,'pat',50,1),(407,7474587,7474580,'ath',50,1),(407,7474588,7474586,'fre',14.286,1),(407,7474589,7474586,'ree',14.286,1),(407,7474590,7474586,'ees',14.286,1),(407,7474591,7474586,'esp',14.286,1),(407,7474592,7474586,'spa',14.286,1),(407,7474593,7474586,'pac',14.286,1),(407,7474594,7474586,'ace',14.286,1),(407,7474595,7474588,'dis',50,1),(407,7474596,7474588,'isk',50,1),(407,7474597,7474595,'ind',33.333,1),(407,7474598,7474595,'nde',33.333,1),(407,7474599,7474595,'dex',33.333,1),(407,7474600,7474597,'adm',8.333,1),(407,7474601,7474597,'dmi',8.333,1),(407,7474602,7474597,'min',8.333,1),(407,7474603,7474597,'ini',8.333,1),(407,7474604,7474597,'nis',8.333,1),(407,7474605,7474597,'ist',8.333,1),(407,7474606,7474597,'str',8.333,1),(407,7474607,7474597,'tra',8.333,1),(407,7474608,7474597,'rat',8.333,1),(407,7474609,7474597,'ati',8.333,1),(407,7474610,7474597,'tio',8.333,1),(407,7474611,7474597,'ion',8.333,1),(407,7474612,7474600,'sta',33.333,3),(407,7474613,7474600,'tat',33.333,3),(407,7474614,7474600,'ate',33.333,3),(407,7474615,7474612,'ena',20,2),(407,7474616,7474612,'nab',20,2),(407,7474617,7474612,'abl',20,2),(407,7474618,7474612,'ble',20,2),(407,7474619,7474612,'led',20,2),(407,7474620,7474615,'cac',33.333,2),(407,7474621,7474615,'ach',33.333,2),(407,7474622,7474615,'che',33.333,2),(407,7474623,7474620,'mod',50,1),(407,7474624,7474620,'ode',50,1),(407,7474625,7474623,'wri',14.286,1),(407,7474626,7474623,'rit',14.286,1),(407,7474627,7474623,'ite',14.286,1),(407,7474628,7474623,'tet',14.286,1),(407,7474629,7474623,'eth',14.286,1),(407,7474630,7474623,'thr',14.286,1),(407,7474631,7474623,'hru',14.286,1),(407,7474632,7474625,'ope',11.111,2),(407,7474633,7474625,'per',11.111,2),(407,7474634,7474625,'era',11.111,2),(407,7474635,7474625,'rat',11.111,2),(407,7474636,7474625,'ati',11.111,2),(407,7474637,7474625,'tio',11.111,2),(407,7474638,7474625,'ion',11.111,2),(407,7474639,7474625,'ona',11.111,2),(407,7474640,7474625,'nal',11.111,2),(407,7474641,7474632,'pen',20,1),(407,7474642,7474632,'end',20,1),(407,7474643,7474632,'ndi',20,1),(407,7474644,7474632,'din',20,1),(407,7474645,7474632,'ing',20,1),(407,7474646,7474641,'mes',20,1),(407,7474647,7474641,'ess',20,1),(407,7474648,7474641,'ssa',20,1),(407,7474649,7474641,'sag',20,1),(407,7474650,7474641,'age',20,1),(407,7474651,7474646,'wai',20,1),(407,7474652,7474646,'ait',20,1),(407,7474653,7474646,'iti',20,1),(407,7474654,7474646,'tin',20,1),(407,7474655,7474646,'ing',20,1),(407,7474656,7474651,'for',100,1),(407,7474657,7474656,'per',11.111,1),(407,7474658,7474656,'erf',11.111,1),(407,7474659,7474656,'rfo',11.111,1),(407,7474660,7474656,'for',11.111,1),(407,7474661,7474656,'orm',11.111,1),(407,7474662,7474656,'rma',11.111,1),(407,7474663,7474656,'man',11.111,1),(407,7474664,7474656,'anc',11.111,1),(407,7474665,7474656,'nce',11.111,1),(407,7474666,7474657,'ide',12.5,1),(407,7474667,7474657,'den',12.5,1),(407,7474668,7474657,'ent',12.5,1),(407,7474669,7474657,'nti',12.5,1),(407,7474670,7474657,'tif',12.5,1),(407,7474671,7474657,'ifi',12.5,1),(407,7474672,7474657,'fie',12.5,1),(407,7474673,7474657,'ier',12.5,1),(407,7474674,7474666,'vdi',33.333,3),(407,7474675,7474666,'dis',33.333,3),(407,7474676,7474666,'isk',33.333,3),(407,7474677,7474674,'nam',50,1),(407,7474678,7474674,'ame',50,1),(407,7474679,7474677,'typ',50,1),(407,7474680,7474677,'ype',50,1),(407,7474681,7474679,'dir',25,1),(407,7474682,7474679,'ire',25,1),(407,7474683,7474679,'rec',25,1),(407,7474684,7474679,'ect',25,1),(408,7474686,7474685,'naa',100,2),(408,7474687,7474686,'600',3.333,3),(408,7474688,7474686,'00a',3.333,3),(408,7474689,7474686,'0a0',3.333,3),(408,7474690,7474686,'a09',3.333,3),(408,7474691,7474686,'098',3.333,3),(408,7474692,7474686,'980',3.333,3),(408,7474693,7474686,'804',3.333,3),(408,7474694,7474686,'044',3.333,3),(408,7474695,7474686,'443',3.333,3),(408,7474696,7474686,'430',3.333,3),(408,7474697,7474686,'307',3.333,3),(408,7474698,7474686,'075',3.333,3),(408,7474699,7474686,'753',3.333,3),(408,7474700,7474686,'535',3.333,3),(408,7474701,7474686,'357',3.333,3),(408,7474702,7474686,'573',3.333,3),(408,7474703,7474686,'732',3.333,3),(408,7474704,7474686,'32b',3.333,3),(408,7474705,7474686,'2b3',3.333,3),(408,7474706,7474686,'b33',3.333,3),(408,7474707,7474686,'334',3.333,3),(408,7474708,7474686,'345',3.333,3),(408,7474709,7474686,'457',3.333,3),(408,7474710,7474686,'571',3.333,3),(408,7474711,7474686,'715',3.333,3),(408,7474712,7474686,'153',3.333,3),(408,7474713,7474686,'533',3.333,3),(408,7474714,7474686,'335',3.333,3),(408,7474715,7474686,'357',3.333,3),(408,7474716,7474686,'57a',3.333,3),(408,7474717,7474687,'mon',100,1),(408,7474718,7474717,'201',50,1),(408,7474719,7474717,'013',50,1),(408,7474720,7474718,'adm',33.333,3),(408,7474721,7474718,'dmi',33.333,3),(408,7474722,7474718,'min',33.333,3),(408,7474723,7474720,'cap',16.667,1),(408,7474724,7474720,'apa',16.667,1),(408,7474725,7474720,'pac',16.667,1),(408,7474726,7474720,'aci',16.667,1),(408,7474727,7474720,'cit',16.667,1),(408,7474728,7474720,'ity',16.667,1),(408,7474729,7474723,'pat',50,1),(408,7474730,7474723,'ath',50,1),(408,7474731,7474729,'fre',14.286,1),(408,7474732,7474729,'ree',14.286,1),(408,7474733,7474729,'ees',14.286,1),(408,7474734,7474729,'esp',14.286,1),(408,7474735,7474729,'spa',14.286,1),(408,7474736,7474729,'pac',14.286,1),(408,7474737,7474729,'ace',14.286,1),(408,7474738,7474731,'dis',50,1),(408,7474739,7474731,'isk',50,1),(408,7474740,7474738,'ind',33.333,1),(408,7474741,7474738,'nde',33.333,1),(408,7474742,7474738,'dex',33.333,1),(408,7474743,7474740,'adm',8.333,1),(408,7474744,7474740,'dmi',8.333,1),(408,7474745,7474740,'min',8.333,1),(408,7474746,7474740,'ini',8.333,1),(408,7474747,7474740,'nis',8.333,1),(408,7474748,7474740,'ist',8.333,1),(408,7474749,7474740,'str',8.333,1),(408,7474750,7474740,'tra',8.333,1),(408,7474751,7474740,'rat',8.333,1),(408,7474752,7474740,'ati',8.333,1),(408,7474753,7474740,'tio',8.333,1),(408,7474754,7474740,'ion',8.333,1),(408,7474755,7474743,'sta',33.333,3),(408,7474756,7474743,'tat',33.333,3),(408,7474757,7474743,'ate',33.333,3),(408,7474758,7474755,'ena',20,2),(408,7474759,7474755,'nab',20,2),(408,7474760,7474755,'abl',20,2),(408,7474761,7474755,'ble',20,2),(408,7474762,7474755,'led',20,2),(408,7474763,7474758,'cac',33.333,2),(408,7474764,7474758,'ach',33.333,2),(408,7474765,7474758,'che',33.333,2),(408,7474766,7474763,'mod',50,1),(408,7474767,7474763,'ode',50,1),(408,7474768,7474766,'wri',14.286,1),(408,7474769,7474766,'rit',14.286,1),(408,7474770,7474766,'ite',14.286,1),(408,7474771,7474766,'tet',14.286,1),(408,7474772,7474766,'eth',14.286,1),(408,7474773,7474766,'thr',14.286,1),(408,7474774,7474766,'hru',14.286,1),(408,7474775,7474768,'ope',11.111,2),(408,7474776,7474768,'per',11.111,2),(408,7474777,7474768,'era',11.111,2),(408,7474778,7474768,'rat',11.111,2),(408,7474779,7474768,'ati',11.111,2),(408,7474780,7474768,'tio',11.111,2),(408,7474781,7474768,'ion',11.111,2),(408,7474782,7474768,'ona',11.111,2),(408,7474783,7474768,'nal',11.111,2),(408,7474784,7474775,'pen',20,1),(408,7474785,7474775,'end',20,1),(408,7474786,7474775,'ndi',20,1),(408,7474787,7474775,'din',20,1),(408,7474788,7474775,'ing',20,1),(408,7474789,7474784,'mes',20,1),(408,7474790,7474784,'ess',20,1),(408,7474791,7474784,'ssa',20,1),(408,7474792,7474784,'sag',20,1),(408,7474793,7474784,'age',20,1),(408,7474794,7474789,'wai',20,1),(408,7474795,7474789,'ait',20,1),(408,7474796,7474789,'iti',20,1),(408,7474797,7474789,'tin',20,1),(408,7474798,7474789,'ing',20,1),(408,7474799,7474794,'for',100,1),(408,7474800,7474799,'per',11.111,1),(408,7474801,7474799,'erf',11.111,1),(408,7474802,7474799,'rfo',11.111,1),(408,7474803,7474799,'for',11.111,1),(408,7474804,7474799,'orm',11.111,1),(408,7474805,7474799,'rma',11.111,1),(408,7474806,7474799,'man',11.111,1),(408,7474807,7474799,'anc',11.111,1),(408,7474808,7474799,'nce',11.111,1),(408,7474809,7474800,'ide',12.5,1),(408,7474810,7474800,'den',12.5,1),(408,7474811,7474800,'ent',12.5,1),(408,7474812,7474800,'nti',12.5,1),(408,7474813,7474800,'tif',12.5,1),(408,7474814,7474800,'ifi',12.5,1),(408,7474815,7474800,'fie',12.5,1),(408,7474816,7474800,'ier',12.5,1),(408,7474817,7474809,'vdi',33.333,3),(408,7474818,7474809,'dis',33.333,3),(408,7474819,7474809,'isk',33.333,3),(408,7474820,7474817,'nam',50,1),(408,7474821,7474817,'ame',50,1),(408,7474822,7474820,'typ',50,1),(408,7474823,7474820,'ype',50,1),(408,7474824,7474822,'dir',25,1),(408,7474825,7474822,'ire',25,1),(408,7474826,7474822,'rec',25,1),(408,7474827,7474822,'ect',25,1),(409,7474829,7474828,'naa',100,2),(409,7474830,7474829,'600',3.333,3),(409,7474831,7474829,'000',3.333,3),(409,7474832,7474829,'00c',3.333,3),(409,7474833,7474829,'0c2',3.333,3),(409,7474834,7474829,'c29',3.333,3),(409,7474835,7474829,'29d',3.333,3),(409,7474836,7474829,'9d1',3.333,3),(409,7474837,7474829,'d1b',3.333,3),(409,7474838,7474829,'1b1',3.333,3),(409,7474839,7474829,'b17',3.333,3),(409,7474840,7474829,'174',3.333,3),(409,7474841,7474829,'743',3.333,3),(409,7474842,7474829,'437',3.333,3),(409,7474843,7474829,'37c',3.333,3),(409,7474844,7474829,'7c7',3.333,3),(409,7474845,7474829,'c7a',3.333,3),(409,7474846,7474829,'7a0',3.333,3),(409,7474847,7474829,'a01',3.333,3),(409,7474848,7474829,'014',3.333,3),(409,7474849,7474829,'141',3.333,3),(409,7474850,7474829,'41d',3.333,3),(409,7474851,7474829,'1d3',3.333,3),(409,7474852,7474829,'d38',3.333,3),(409,7474853,7474829,'38f',3.333,3),(409,7474854,7474829,'8fc',3.333,3),(409,7474855,7474829,'fca',3.333,3),(409,7474856,7474829,'ca7',3.333,3),(409,7474857,7474829,'a7c',3.333,3),(409,7474858,7474829,'7c0',3.333,3),(409,7474859,7474829,'c0e',3.333,3),(409,7474860,7474830,'mon',100,1),(409,7474861,7474860,'201',50,1),(409,7474862,7474860,'013',50,1),(409,7474863,7474861,'adm',33.333,3),(409,7474864,7474861,'dmi',33.333,3),(409,7474865,7474861,'min',33.333,3),(409,7474866,7474863,'cap',16.667,1),(409,7474867,7474863,'apa',16.667,1),(409,7474868,7474863,'pac',16.667,1),(409,7474869,7474863,'aci',16.667,1),(409,7474870,7474863,'cit',16.667,1),(409,7474871,7474863,'ity',16.667,1),(409,7474872,7474866,'pat',50,1),(409,7474873,7474866,'ath',50,1),(409,7474874,7474872,'fre',14.286,1),(409,7474875,7474872,'ree',14.286,1),(409,7474876,7474872,'ees',14.286,1),(409,7474877,7474872,'esp',14.286,1),(409,7474878,7474872,'spa',14.286,1),(409,7474879,7474872,'pac',14.286,1),(409,7474880,7474872,'ace',14.286,1),(409,7474881,7474874,'dis',50,1),(409,7474882,7474874,'isk',50,1),(409,7474883,7474881,'ind',33.333,1),(409,7474884,7474881,'nde',33.333,1),(409,7474885,7474881,'dex',33.333,1),(409,7474886,7474883,'adm',8.333,1),(409,7474887,7474883,'dmi',8.333,1),(409,7474888,7474883,'min',8.333,1),(409,7474889,7474883,'ini',8.333,1),(409,7474890,7474883,'nis',8.333,1),(409,7474891,7474883,'ist',8.333,1),(409,7474892,7474883,'str',8.333,1),(409,7474893,7474883,'tra',8.333,1),(409,7474894,7474883,'rat',8.333,1),(409,7474895,7474883,'ati',8.333,1),(409,7474896,7474883,'tio',8.333,1),(409,7474897,7474883,'ion',8.333,1),(409,7474898,7474886,'sta',33.333,3),(409,7474899,7474886,'tat',33.333,3),(409,7474900,7474886,'ate',33.333,3),(409,7474901,7474898,'ena',20,2),(409,7474902,7474898,'nab',20,2),(409,7474903,7474898,'abl',20,2),(409,7474904,7474898,'ble',20,2),(409,7474905,7474898,'led',20,2),(409,7474906,7474901,'cac',33.333,2),(409,7474907,7474901,'ach',33.333,2),(409,7474908,7474901,'che',33.333,2),(409,7474909,7474906,'mod',50,1),(409,7474910,7474906,'ode',50,1),(409,7474911,7474909,'wri',14.286,1),(409,7474912,7474909,'rit',14.286,1),(409,7474913,7474909,'ite',14.286,1),(409,7474914,7474909,'tet',14.286,1),(409,7474915,7474909,'eth',14.286,1),(409,7474916,7474909,'thr',14.286,1),(409,7474917,7474909,'hru',14.286,1),(409,7474918,7474911,'ope',11.111,2),(409,7474919,7474911,'per',11.111,2),(409,7474920,7474911,'era',11.111,2),(409,7474921,7474911,'rat',11.111,2),(409,7474922,7474911,'ati',11.111,2),(409,7474923,7474911,'tio',11.111,2),(409,7474924,7474911,'ion',11.111,2),(409,7474925,7474911,'ona',11.111,2),(409,7474926,7474911,'nal',11.111,2),(409,7474927,7474918,'pen',20,1),(409,7474928,7474918,'end',20,1),(409,7474929,7474918,'ndi',20,1),(409,7474930,7474918,'din',20,1),(409,7474931,7474918,'ing',20,1),(409,7474932,7474927,'mes',20,1),(409,7474933,7474927,'ess',20,1),(409,7474934,7474927,'ssa',20,1),(409,7474935,7474927,'sag',20,1),(409,7474936,7474927,'age',20,1),(409,7474937,7474932,'wai',20,1),(409,7474938,7474932,'ait',20,1),(409,7474939,7474932,'iti',20,1),(409,7474940,7474932,'tin',20,1),(409,7474941,7474932,'ing',20,1),(409,7474942,7474937,'for',100,1),(409,7474943,7474942,'per',11.111,1),(409,7474944,7474942,'erf',11.111,1),(409,7474945,7474942,'rfo',11.111,1),(409,7474946,7474942,'for',11.111,1),(409,7474947,7474942,'orm',11.111,1),(409,7474948,7474942,'rma',11.111,1),(409,7474949,7474942,'man',11.111,1),(409,7474950,7474942,'anc',11.111,1),(409,7474951,7474942,'nce',11.111,1),(409,7474952,7474943,'ide',12.5,1),(409,7474953,7474943,'den',12.5,1),(409,7474954,7474943,'ent',12.5,1),(409,7474955,7474943,'nti',12.5,1),(409,7474956,7474943,'tif',12.5,1),(409,7474957,7474943,'ifi',12.5,1),(409,7474958,7474943,'fie',12.5,1),(409,7474959,7474943,'ier',12.5,1),(409,7474960,7474952,'vdi',33.333,3),(409,7474961,7474952,'dis',33.333,3),(409,7474962,7474952,'isk',33.333,3),(409,7474963,7474960,'nam',50,1),(409,7474964,7474960,'ame',50,1),(409,7474965,7474963,'typ',50,1),(409,7474966,7474963,'ype',50,1),(409,7474967,7474965,'dir',25,1),(409,7474968,7474965,'ire',25,1),(409,7474969,7474965,'rec',25,1),(409,7474970,7474965,'ect',25,1),(410,7474972,7474971,'naa',100,2),(410,7474973,7474972,'600',3.333,3),(410,7474974,7474972,'000',3.333,3),(410,7474975,7474972,'00c',3.333,3),(410,7474976,7474972,'0c2',3.333,3),(410,7474977,7474972,'c29',3.333,3),(410,7474978,7474972,'295',3.333,3),(410,7474979,7474972,'959',3.333,3),(410,7474980,7474972,'59a',3.333,3),(410,7474981,7474972,'9aa',3.333,3),(410,7474982,7474972,'aa2',3.333,3),(410,7474983,7474972,'a2b',3.333,3),(410,7474984,7474972,'2b0',3.333,3),(410,7474985,7474972,'b05',3.333,3),(410,7474986,7474972,'054',3.333,3),(410,7474987,7474972,'543',3.333,3),(410,7474988,7474972,'435',3.333,3),(410,7474989,7474972,'351',3.333,3),(410,7474990,7474972,'51c',3.333,3),(410,7474991,7474972,'1c4',3.333,3),(410,7474992,7474972,'c42',3.333,3),(410,7474993,7474972,'424',3.333,3),(410,7474994,7474972,'24d',3.333,3),(410,7474995,7474972,'4d3',3.333,3),(410,7474996,7474972,'d30',3.333,3),(410,7474997,7474972,'309',3.333,3),(410,7474998,7474972,'096',3.333,3),(410,7474999,7474972,'964',3.333,3),(410,7475000,7474972,'64b',3.333,3),(410,7475001,7474972,'4b0',3.333,3),(410,7475002,7474972,'b08',3.333,3),(410,7475003,7474973,'mon',100,1),(410,7475004,7475003,'201',50,1),(410,7475005,7475003,'013',50,1),(410,7475006,7475004,'adm',33.333,3),(410,7475007,7475004,'dmi',33.333,3),(410,7475008,7475004,'min',33.333,3),(410,7475009,7475006,'cap',16.667,1),(410,7475010,7475006,'apa',16.667,1),(410,7475011,7475006,'pac',16.667,1),(410,7475012,7475006,'aci',16.667,1),(410,7475013,7475006,'cit',16.667,1),(410,7475014,7475006,'ity',16.667,1),(410,7475015,7475009,'pat',50,1),(410,7475016,7475009,'ath',50,1),(410,7475017,7475015,'fre',14.286,1),(410,7475018,7475015,'ree',14.286,1),(410,7475019,7475015,'ees',14.286,1),(410,7475020,7475015,'esp',14.286,1),(410,7475021,7475015,'spa',14.286,1),(410,7475022,7475015,'pac',14.286,1),(410,7475023,7475015,'ace',14.286,1),(410,7475024,7475017,'dis',50,1),(410,7475025,7475017,'isk',50,1),(410,7475026,7475024,'ind',33.333,1),(410,7475027,7475024,'nde',33.333,1),(410,7475028,7475024,'dex',33.333,1),(410,7475029,7475026,'adm',8.333,1),(410,7475030,7475026,'dmi',8.333,1),(410,7475031,7475026,'min',8.333,1),(410,7475032,7475026,'ini',8.333,1),(410,7475033,7475026,'nis',8.333,1),(410,7475034,7475026,'ist',8.333,1),(410,7475035,7475026,'str',8.333,1),(410,7475036,7475026,'tra',8.333,1),(410,7475037,7475026,'rat',8.333,1),(410,7475038,7475026,'ati',8.333,1),(410,7475039,7475026,'tio',8.333,1),(410,7475040,7475026,'ion',8.333,1),(410,7475041,7475029,'sta',33.333,3),(410,7475042,7475029,'tat',33.333,3),(410,7475043,7475029,'ate',33.333,3),(410,7475044,7475041,'ena',20,2),(410,7475045,7475041,'nab',20,2),(410,7475046,7475041,'abl',20,2),(410,7475047,7475041,'ble',20,2),(410,7475048,7475041,'led',20,2),(410,7475049,7475044,'cac',33.333,2),(410,7475050,7475044,'ach',33.333,2),(410,7475051,7475044,'che',33.333,2),(410,7475052,7475049,'mod',50,1),(410,7475053,7475049,'ode',50,1),(410,7475054,7475052,'wri',14.286,1),(410,7475055,7475052,'rit',14.286,1),(410,7475056,7475052,'ite',14.286,1),(410,7475057,7475052,'tet',14.286,1),(410,7475058,7475052,'eth',14.286,1),(410,7475059,7475052,'thr',14.286,1),(410,7475060,7475052,'hru',14.286,1),(410,7475061,7475054,'ope',11.111,2),(410,7475062,7475054,'per',11.111,2),(410,7475063,7475054,'era',11.111,2),(410,7475064,7475054,'rat',11.111,2),(410,7475065,7475054,'ati',11.111,2),(410,7475066,7475054,'tio',11.111,2),(410,7475067,7475054,'ion',11.111,2),(410,7475068,7475054,'ona',11.111,2),(410,7475069,7475054,'nal',11.111,2),(410,7475070,7475061,'pen',20,1),(410,7475071,7475061,'end',20,1),(410,7475072,7475061,'ndi',20,1),(410,7475073,7475061,'din',20,1),(410,7475074,7475061,'ing',20,1),(410,7475075,7475070,'mes',20,1),(410,7475076,7475070,'ess',20,1),(410,7475077,7475070,'ssa',20,1),(410,7475078,7475070,'sag',20,1),(410,7475079,7475070,'age',20,1),(410,7475080,7475075,'wai',20,1),(410,7475081,7475075,'ait',20,1),(410,7475082,7475075,'iti',20,1),(410,7475083,7475075,'tin',20,1),(410,7475084,7475075,'ing',20,1),(410,7475085,7475080,'for',100,1),(410,7475086,7475085,'per',11.111,1),(410,7475087,7475085,'erf',11.111,1),(410,7475088,7475085,'rfo',11.111,1),(410,7475089,7475085,'for',11.111,1),(410,7475090,7475085,'orm',11.111,1),(410,7475091,7475085,'rma',11.111,1),(410,7475092,7475085,'man',11.111,1),(410,7475093,7475085,'anc',11.111,1),(410,7475094,7475085,'nce',11.111,1),(410,7475095,7475086,'ide',12.5,1),(410,7475096,7475086,'den',12.5,1),(410,7475097,7475086,'ent',12.5,1),(410,7475098,7475086,'nti',12.5,1),(410,7475099,7475086,'tif',12.5,1),(410,7475100,7475086,'ifi',12.5,1),(410,7475101,7475086,'fie',12.5,1),(410,7475102,7475086,'ier',12.5,1),(410,7475103,7475095,'vdi',33.333,3),(410,7475104,7475095,'dis',33.333,3),(410,7475105,7475095,'isk',33.333,3),(410,7475106,7475103,'nam',50,1),(410,7475107,7475103,'ame',50,1),(410,7475108,7475106,'typ',50,1),(410,7475109,7475106,'ype',50,1),(410,7475110,7475108,'dir',25,1),(410,7475111,7475108,'ire',25,1),(410,7475112,7475108,'rec',25,1),(410,7475113,7475108,'ect',25,1),(411,7475115,7475114,'naa',100,2),(411,7475116,7475115,'600',3.333,3),(411,7475117,7475115,'000',3.333,3),(411,7475118,7475115,'00c',3.333,3),(411,7475119,7475115,'0c2',3.333,3),(411,7475120,7475115,'c29',3.333,3),(411,7475121,7475115,'294',3.333,3),(411,7475122,7475115,'94f',3.333,3),(411,7475123,7475115,'4f1',3.333,3),(411,7475124,7475115,'f1c',3.333,3),(411,7475125,7475115,'1ce',3.333,3),(411,7475126,7475115,'cee',3.333,3),(411,7475127,7475115,'eee',3.333,3),(411,7475128,7475115,'eef',3.333,3),(411,7475129,7475115,'efa',3.333,3),(411,7475130,7475115,'fa4',3.333,3),(411,7475131,7475115,'a4a',3.333,3),(411,7475132,7475115,'4a2',3.333,3),(411,7475133,7475115,'a2b',3.333,3),(411,7475134,7475115,'2be',3.333,3),(411,7475135,7475115,'bef',3.333,3),(411,7475136,7475115,'eff',3.333,3),(411,7475137,7475115,'ff5',3.333,3),(411,7475138,7475115,'f5f',3.333,3),(411,7475139,7475115,'5f5',3.333,3),(411,7475140,7475115,'f55',3.333,3),(411,7475141,7475115,'555',3.333,3),(411,7475142,7475115,'558',3.333,3),(411,7475143,7475115,'584',3.333,3),(411,7475144,7475115,'84f',3.333,3),(411,7475145,7475115,'4fc',3.333,3),(411,7475146,7475116,'mon',100,1),(411,7475147,7475146,'201',50,1),(411,7475148,7475146,'013',50,1),(411,7475149,7475147,'adm',33.333,3),(411,7475150,7475147,'dmi',33.333,3),(411,7475151,7475147,'min',33.333,3),(411,7475152,7475149,'cap',16.667,1),(411,7475153,7475149,'apa',16.667,1),(411,7475154,7475149,'pac',16.667,1),(411,7475155,7475149,'aci',16.667,1),(411,7475156,7475149,'cit',16.667,1),(411,7475157,7475149,'ity',16.667,1),(411,7475158,7475152,'pat',50,1),(411,7475159,7475152,'ath',50,1),(411,7475160,7475158,'fre',14.286,1),(411,7475161,7475158,'ree',14.286,1),(411,7475162,7475158,'ees',14.286,1),(411,7475163,7475158,'esp',14.286,1),(411,7475164,7475158,'spa',14.286,1),(411,7475165,7475158,'pac',14.286,1),(411,7475166,7475158,'ace',14.286,1),(411,7475167,7475160,'dis',50,1),(411,7475168,7475160,'isk',50,1),(411,7475169,7475167,'ind',33.333,1),(411,7475170,7475167,'nde',33.333,1),(411,7475171,7475167,'dex',33.333,1),(411,7475172,7475169,'adm',8.333,1),(411,7475173,7475169,'dmi',8.333,1),(411,7475174,7475169,'min',8.333,1),(411,7475175,7475169,'ini',8.333,1),(411,7475176,7475169,'nis',8.333,1),(411,7475177,7475169,'ist',8.333,1),(411,7475178,7475169,'str',8.333,1),(411,7475179,7475169,'tra',8.333,1),(411,7475180,7475169,'rat',8.333,1),(411,7475181,7475169,'ati',8.333,1),(411,7475182,7475169,'tio',8.333,1),(411,7475183,7475169,'ion',8.333,1),(411,7475184,7475172,'sta',33.333,3),(411,7475185,7475172,'tat',33.333,3),(411,7475186,7475172,'ate',33.333,3),(411,7475187,7475184,'ena',20,2),(411,7475188,7475184,'nab',20,2),(411,7475189,7475184,'abl',20,2),(411,7475190,7475184,'ble',20,2),(411,7475191,7475184,'led',20,2),(411,7475192,7475187,'cac',33.333,2),(411,7475193,7475187,'ach',33.333,2),(411,7475194,7475187,'che',33.333,2),(411,7475195,7475192,'mod',50,1),(411,7475196,7475192,'ode',50,1),(411,7475197,7475195,'wri',14.286,1),(411,7475198,7475195,'rit',14.286,1),(411,7475199,7475195,'ite',14.286,1),(411,7475200,7475195,'tet',14.286,1),(411,7475201,7475195,'eth',14.286,1),(411,7475202,7475195,'thr',14.286,1),(411,7475203,7475195,'hru',14.286,1),(411,7475204,7475197,'ope',11.111,2),(411,7475205,7475197,'per',11.111,2),(411,7475206,7475197,'era',11.111,2),(411,7475207,7475197,'rat',11.111,2),(411,7475208,7475197,'ati',11.111,2),(411,7475209,7475197,'tio',11.111,2),(411,7475210,7475197,'ion',11.111,2),(411,7475211,7475197,'ona',11.111,2),(411,7475212,7475197,'nal',11.111,2),(411,7475213,7475204,'pen',20,1),(411,7475214,7475204,'end',20,1),(411,7475215,7475204,'ndi',20,1),(411,7475216,7475204,'din',20,1),(411,7475217,7475204,'ing',20,1),(411,7475218,7475213,'mes',20,1),(411,7475219,7475213,'ess',20,1),(411,7475220,7475213,'ssa',20,1),(411,7475221,7475213,'sag',20,1),(411,7475222,7475213,'age',20,1),(411,7475223,7475218,'wai',20,1),(411,7475224,7475218,'ait',20,1),(411,7475225,7475218,'iti',20,1),(411,7475226,7475218,'tin',20,1),(411,7475227,7475218,'ing',20,1),(411,7475228,7475223,'for',100,1),(411,7475229,7475228,'per',11.111,1),(411,7475230,7475228,'erf',11.111,1),(411,7475231,7475228,'rfo',11.111,1),(411,7475232,7475228,'for',11.111,1),(411,7475233,7475228,'orm',11.111,1),(411,7475234,7475228,'rma',11.111,1),(411,7475235,7475228,'man',11.111,1),(411,7475236,7475228,'anc',11.111,1),(411,7475237,7475228,'nce',11.111,1),(411,7475238,7475229,'ide',12.5,1),(411,7475239,7475229,'den',12.5,1),(411,7475240,7475229,'ent',12.5,1),(411,7475241,7475229,'nti',12.5,1),(411,7475242,7475229,'tif',12.5,1),(411,7475243,7475229,'ifi',12.5,1),(411,7475244,7475229,'fie',12.5,1),(411,7475245,7475229,'ier',12.5,1),(411,7475246,7475238,'vdi',33.333,3),(411,7475247,7475238,'dis',33.333,3),(411,7475248,7475238,'isk',33.333,3),(411,7475249,7475246,'nam',50,1),(411,7475250,7475246,'ame',50,1),(411,7475251,7475249,'typ',50,1),(411,7475252,7475249,'ype',50,1),(411,7475253,7475251,'dir',25,1),(411,7475254,7475251,'ire',25,1),(411,7475255,7475251,'rec',25,1),(411,7475256,7475251,'ect',25,1),(412,7475258,7475257,'naa',100,2),(412,7475259,7475258,'600',3.333,3),(412,7475260,7475258,'000',3.333,3),(412,7475261,7475258,'00c',3.333,3),(412,7475262,7475258,'0c2',3.333,3),(412,7475263,7475258,'c29',3.333,3),(412,7475264,7475258,'297',3.333,3),(412,7475265,7475258,'976',3.333,3),(412,7475266,7475258,'768',3.333,3),(412,7475267,7475258,'683',3.333,3),(412,7475268,7475258,'833',3.333,3),(412,7475269,7475258,'334',3.333,3),(412,7475270,7475258,'34a',3.333,3),(412,7475271,7475258,'4a8',3.333,3),(412,7475272,7475258,'a86',3.333,3),(412,7475273,7475258,'860',3.333,3),(412,7475274,7475258,'60a',3.333,3),(412,7475275,7475258,'0ab',3.333,3),(412,7475276,7475258,'ab2',3.333,3),(412,7475277,7475258,'b2d',3.333,3),(412,7475278,7475258,'2d4',3.333,3),(412,7475279,7475258,'d40',3.333,3),(412,7475280,7475258,'408',3.333,3),(412,7475281,7475258,'08c',3.333,3),(412,7475282,7475258,'8c8',3.333,3),(412,7475283,7475258,'c83',3.333,3),(412,7475284,7475258,'832',3.333,3),(412,7475285,7475258,'32c',3.333,3),(412,7475286,7475258,'2c1',3.333,3),(412,7475287,7475258,'c17',3.333,3),(412,7475288,7475258,'177',3.333,3),(412,7475289,7475259,'mon',100,1),(412,7475290,7475289,'201',50,1),(412,7475291,7475289,'013',50,1),(412,7475292,7475290,'adm',33.333,3),(412,7475293,7475290,'dmi',33.333,3),(412,7475294,7475290,'min',33.333,3),(412,7475295,7475292,'cap',16.667,1),(412,7475296,7475292,'apa',16.667,1),(412,7475297,7475292,'pac',16.667,1),(412,7475298,7475292,'aci',16.667,1),(412,7475299,7475292,'cit',16.667,1),(412,7475300,7475292,'ity',16.667,1),(412,7475301,7475295,'pat',50,1),(412,7475302,7475295,'ath',50,1),(412,7475303,7475301,'fre',14.286,1),(412,7475304,7475301,'ree',14.286,1),(412,7475305,7475301,'ees',14.286,1),(412,7475306,7475301,'esp',14.286,1),(412,7475307,7475301,'spa',14.286,1),(412,7475308,7475301,'pac',14.286,1),(412,7475309,7475301,'ace',14.286,1),(412,7475310,7475303,'dis',50,1),(412,7475311,7475303,'isk',50,1),(412,7475312,7475310,'ind',33.333,1),(412,7475313,7475310,'nde',33.333,1),(412,7475314,7475310,'dex',33.333,1),(412,7475315,7475312,'adm',8.333,1),(412,7475316,7475312,'dmi',8.333,1),(412,7475317,7475312,'min',8.333,1),(412,7475318,7475312,'ini',8.333,1),(412,7475319,7475312,'nis',8.333,1),(412,7475320,7475312,'ist',8.333,1),(412,7475321,7475312,'str',8.333,1),(412,7475322,7475312,'tra',8.333,1),(412,7475323,7475312,'rat',8.333,1),(412,7475324,7475312,'ati',8.333,1),(412,7475325,7475312,'tio',8.333,1),(412,7475326,7475312,'ion',8.333,1),(412,7475327,7475315,'sta',33.333,3),(412,7475328,7475315,'tat',33.333,3),(412,7475329,7475315,'ate',33.333,3),(412,7475330,7475327,'ena',20,2),(412,7475331,7475327,'nab',20,2),(412,7475332,7475327,'abl',20,2),(412,7475333,7475327,'ble',20,2),(412,7475334,7475327,'led',20,2),(412,7475335,7475330,'cac',33.333,2),(412,7475336,7475330,'ach',33.333,2),(412,7475337,7475330,'che',33.333,2),(412,7475338,7475335,'mod',50,1),(412,7475339,7475335,'ode',50,1),(412,7475340,7475338,'wri',14.286,1),(412,7475341,7475338,'rit',14.286,1),(412,7475342,7475338,'ite',14.286,1),(412,7475343,7475338,'tet',14.286,1),(412,7475344,7475338,'eth',14.286,1),(412,7475345,7475338,'thr',14.286,1),(412,7475346,7475338,'hru',14.286,1),(412,7475347,7475340,'ope',11.111,2),(412,7475348,7475340,'per',11.111,2),(412,7475349,7475340,'era',11.111,2),(412,7475350,7475340,'rat',11.111,2),(412,7475351,7475340,'ati',11.111,2),(412,7475352,7475340,'tio',11.111,2),(412,7475353,7475340,'ion',11.111,2),(412,7475354,7475340,'ona',11.111,2),(412,7475355,7475340,'nal',11.111,2),(412,7475356,7475347,'pen',20,1),(412,7475357,7475347,'end',20,1),(412,7475358,7475347,'ndi',20,1),(412,7475359,7475347,'din',20,1),(412,7475360,7475347,'ing',20,1),(412,7475361,7475356,'mes',20,1),(412,7475362,7475356,'ess',20,1),(412,7475363,7475356,'ssa',20,1),(412,7475364,7475356,'sag',20,1),(412,7475365,7475356,'age',20,1),(412,7475366,7475361,'wai',20,1),(412,7475367,7475361,'ait',20,1),(412,7475368,7475361,'iti',20,1),(412,7475369,7475361,'tin',20,1),(412,7475370,7475361,'ing',20,1),(412,7475371,7475366,'for',100,1),(412,7475372,7475371,'per',11.111,1),(412,7475373,7475371,'erf',11.111,1),(412,7475374,7475371,'rfo',11.111,1),(412,7475375,7475371,'for',11.111,1),(412,7475376,7475371,'orm',11.111,1),(412,7475377,7475371,'rma',11.111,1),(412,7475378,7475371,'man',11.111,1),(412,7475379,7475371,'anc',11.111,1),(412,7475380,7475371,'nce',11.111,1),(412,7475381,7475372,'ide',12.5,1),(412,7475382,7475372,'den',12.5,1),(412,7475383,7475372,'ent',12.5,1),(412,7475384,7475372,'nti',12.5,1),(412,7475385,7475372,'tif',12.5,1),(412,7475386,7475372,'ifi',12.5,1),(412,7475387,7475372,'fie',12.5,1),(412,7475388,7475372,'ier',12.5,1),(412,7475389,7475381,'vdi',33.333,3),(412,7475390,7475381,'dis',33.333,3),(412,7475391,7475381,'isk',33.333,3),(412,7475392,7475389,'nam',50,1),(412,7475393,7475389,'ame',50,1),(412,7475394,7475392,'typ',50,1),(412,7475395,7475392,'ype',50,1),(412,7475396,7475394,'dir',25,1),(412,7475397,7475394,'ire',25,1),(412,7475398,7475394,'rec',25,1),(412,7475399,7475394,'ect',25,1),(413,7475401,7475400,'naa',100,2),(413,7475402,7475401,'600',3.333,3),(413,7475403,7475401,'000',3.333,3),(413,7475404,7475401,'00c',3.333,3),(413,7475405,7475401,'0c2',3.333,3),(413,7475406,7475401,'c29',3.333,3),(413,7475407,7475401,'294',3.333,3),(413,7475408,7475401,'94d',3.333,3),(413,7475409,7475401,'4db',3.333,3),(413,7475410,7475401,'dbd',3.333,3),(413,7475411,7475401,'bda',3.333,3),(413,7475412,7475401,'da2',3.333,3),(413,7475413,7475401,'a2a',3.333,3),(413,7475414,7475401,'2a3',3.333,3),(413,7475415,7475401,'a3d',3.333,3),(413,7475416,7475401,'3d6',3.333,3),(413,7475417,7475401,'d6a',3.333,3),(413,7475418,7475401,'6a7',3.333,3),(413,7475419,7475401,'a78',3.333,3),(413,7475420,7475401,'789',3.333,3),(413,7475421,7475401,'892',3.333,3),(413,7475422,7475401,'92f',3.333,3),(413,7475423,7475401,'2f1',3.333,3),(413,7475424,7475401,'f17',3.333,3),(413,7475425,7475401,'173',3.333,3),(413,7475426,7475401,'734',3.333,3),(413,7475427,7475401,'34c',3.333,3),(413,7475428,7475401,'4c7',3.333,3),(413,7475429,7475401,'c71',3.333,3),(413,7475430,7475401,'71f',3.333,3),(413,7475431,7475401,'1fe',3.333,3),(413,7475432,7475402,'mon',100,1),(413,7475433,7475432,'201',50,1),(413,7475434,7475432,'013',50,1),(413,7475435,7475433,'adm',33.333,3),(413,7475436,7475433,'dmi',33.333,3),(413,7475437,7475433,'min',33.333,3),(413,7475438,7475435,'cap',16.667,1),(413,7475439,7475435,'apa',16.667,1),(413,7475440,7475435,'pac',16.667,1),(413,7475441,7475435,'aci',16.667,1),(413,7475442,7475435,'cit',16.667,1),(413,7475443,7475435,'ity',16.667,1),(413,7475444,7475438,'pat',50,1),(413,7475445,7475438,'ath',50,1),(413,7475446,7475444,'fre',14.286,1),(413,7475447,7475444,'ree',14.286,1),(413,7475448,7475444,'ees',14.286,1),(413,7475449,7475444,'esp',14.286,1),(413,7475450,7475444,'spa',14.286,1),(413,7475451,7475444,'pac',14.286,1),(413,7475452,7475444,'ace',14.286,1),(413,7475453,7475446,'dis',50,1),(413,7475454,7475446,'isk',50,1),(413,7475455,7475453,'ind',33.333,1),(413,7475456,7475453,'nde',33.333,1),(413,7475457,7475453,'dex',33.333,1),(413,7475458,7475455,'adm',8.333,1),(413,7475459,7475455,'dmi',8.333,1),(413,7475460,7475455,'min',8.333,1),(413,7475461,7475455,'ini',8.333,1),(413,7475462,7475455,'nis',8.333,1),(413,7475463,7475455,'ist',8.333,1),(413,7475464,7475455,'str',8.333,1),(413,7475465,7475455,'tra',8.333,1),(413,7475466,7475455,'rat',8.333,1),(413,7475467,7475455,'ati',8.333,1),(413,7475468,7475455,'tio',8.333,1),(413,7475469,7475455,'ion',8.333,1),(413,7475470,7475458,'sta',33.333,3),(413,7475471,7475458,'tat',33.333,3),(413,7475472,7475458,'ate',33.333,3),(413,7475473,7475470,'ena',20,2),(413,7475474,7475470,'nab',20,2),(413,7475475,7475470,'abl',20,2),(413,7475476,7475470,'ble',20,2),(413,7475477,7475470,'led',20,2),(413,7475478,7475473,'cac',33.333,2),(413,7475479,7475473,'ach',33.333,2),(413,7475480,7475473,'che',33.333,2),(413,7475481,7475478,'mod',50,1),(413,7475482,7475478,'ode',50,1),(413,7475483,7475481,'wri',14.286,1),(413,7475484,7475481,'rit',14.286,1),(413,7475485,7475481,'ite',14.286,1),(413,7475486,7475481,'tet',14.286,1),(413,7475487,7475481,'eth',14.286,1),(413,7475488,7475481,'thr',14.286,1),(413,7475489,7475481,'hru',14.286,1),(413,7475490,7475483,'ope',11.111,2),(413,7475491,7475483,'per',11.111,2),(413,7475492,7475483,'era',11.111,2),(413,7475493,7475483,'rat',11.111,2),(413,7475494,7475483,'ati',11.111,2),(413,7475495,7475483,'tio',11.111,2),(413,7475496,7475483,'ion',11.111,2),(413,7475497,7475483,'ona',11.111,2),(413,7475498,7475483,'nal',11.111,2),(413,7475499,7475490,'pen',20,1),(413,7475500,7475490,'end',20,1),(413,7475501,7475490,'ndi',20,1),(413,7475502,7475490,'din',20,1),(413,7475503,7475490,'ing',20,1),(413,7475504,7475499,'mes',20,1),(413,7475505,7475499,'ess',20,1),(413,7475506,7475499,'ssa',20,1),(413,7475507,7475499,'sag',20,1),(413,7475508,7475499,'age',20,1),(413,7475509,7475504,'wai',20,1),(413,7475510,7475504,'ait',20,1),(413,7475511,7475504,'iti',20,1),(413,7475512,7475504,'tin',20,1),(413,7475513,7475504,'ing',20,1),(413,7475514,7475509,'for',100,1),(413,7475515,7475514,'per',11.111,1),(413,7475516,7475514,'erf',11.111,1),(413,7475517,7475514,'rfo',11.111,1),(413,7475518,7475514,'for',11.111,1),(413,7475519,7475514,'orm',11.111,1),(413,7475520,7475514,'rma',11.111,1),(413,7475521,7475514,'man',11.111,1),(413,7475522,7475514,'anc',11.111,1),(413,7475523,7475514,'nce',11.111,1),(413,7475524,7475515,'ide',12.5,1),(413,7475525,7475515,'den',12.5,1),(413,7475526,7475515,'ent',12.5,1),(413,7475527,7475515,'nti',12.5,1),(413,7475528,7475515,'tif',12.5,1),(413,7475529,7475515,'ifi',12.5,1),(413,7475530,7475515,'fie',12.5,1),(413,7475531,7475515,'ier',12.5,1),(413,7475532,7475524,'vdi',33.333,3),(413,7475533,7475524,'dis',33.333,3),(413,7475534,7475524,'isk',33.333,3),(413,7475535,7475532,'nam',50,1),(413,7475536,7475532,'ame',50,1),(413,7475537,7475535,'typ',50,1),(413,7475538,7475535,'ype',50,1),(413,7475539,7475537,'dir',25,1),(413,7475540,7475537,'ire',25,1),(413,7475541,7475537,'rec',25,1),(413,7475542,7475537,'ect',25,1),(414,7475544,7475543,'naa',100,2),(414,7475545,7475544,'600',3.333,3),(414,7475546,7475544,'000',3.333,3),(414,7475547,7475544,'00c',3.333,3),(414,7475548,7475544,'0c2',3.333,3),(414,7475549,7475544,'c29',3.333,3),(414,7475550,7475544,'292',3.333,3),(414,7475551,7475544,'92c',3.333,3),(414,7475552,7475544,'2c1',3.333,3),(414,7475553,7475544,'c14',3.333,3),(414,7475554,7475544,'148',3.333,3),(414,7475555,7475544,'48a',3.333,3),(414,7475556,7475544,'8a7',3.333,3),(414,7475557,7475544,'a7d',3.333,3),(414,7475558,7475544,'7d3',3.333,3),(414,7475559,7475544,'d33',3.333,3),(414,7475560,7475544,'33c',3.333,3),(414,7475561,7475544,'3c2',3.333,3),(414,7475562,7475544,'c25',3.333,3),(414,7475563,7475544,'254',3.333,3),(414,7475564,7475544,'540',3.333,3),(414,7475565,7475544,'40a',3.333,3),(414,7475566,7475544,'0a9',3.333,3),(414,7475567,7475544,'a97',3.333,3),(414,7475568,7475544,'976',3.333,3),(414,7475569,7475544,'767',3.333,3),(414,7475570,7475544,'67a',3.333,3),(414,7475571,7475544,'7aa',3.333,3),(414,7475572,7475544,'aa8',3.333,3),(414,7475573,7475544,'a82',3.333,3),(414,7475574,7475544,'824',3.333,3),(414,7475575,7475545,'mon',100,1),(414,7475576,7475575,'201',50,1),(414,7475577,7475575,'013',50,1),(414,7475578,7475576,'adm',33.333,3),(414,7475579,7475576,'dmi',33.333,3),(414,7475580,7475576,'min',33.333,3),(414,7475581,7475578,'cap',16.667,1),(414,7475582,7475578,'apa',16.667,1),(414,7475583,7475578,'pac',16.667,1),(414,7475584,7475578,'aci',16.667,1),(414,7475585,7475578,'cit',16.667,1),(414,7475586,7475578,'ity',16.667,1),(414,7475587,7475581,'pat',50,1),(414,7475588,7475581,'ath',50,1),(414,7475589,7475587,'fre',14.286,1),(414,7475590,7475587,'ree',14.286,1),(414,7475591,7475587,'ees',14.286,1),(414,7475592,7475587,'esp',14.286,1),(414,7475593,7475587,'spa',14.286,1),(414,7475594,7475587,'pac',14.286,1),(414,7475595,7475587,'ace',14.286,1),(414,7475596,7475589,'dis',50,1),(414,7475597,7475589,'isk',50,1),(414,7475598,7475596,'ind',33.333,1),(414,7475599,7475596,'nde',33.333,1),(414,7475600,7475596,'dex',33.333,1),(414,7475601,7475598,'adm',8.333,1),(414,7475602,7475598,'dmi',8.333,1),(414,7475603,7475598,'min',8.333,1),(414,7475604,7475598,'ini',8.333,1),(414,7475605,7475598,'nis',8.333,1),(414,7475606,7475598,'ist',8.333,1),(414,7475607,7475598,'str',8.333,1),(414,7475608,7475598,'tra',8.333,1),(414,7475609,7475598,'rat',8.333,1),(414,7475610,7475598,'ati',8.333,1),(414,7475611,7475598,'tio',8.333,1),(414,7475612,7475598,'ion',8.333,1),(414,7475613,7475601,'sta',33.333,3),(414,7475614,7475601,'tat',33.333,3),(414,7475615,7475601,'ate',33.333,3),(414,7475616,7475613,'ena',20,2),(414,7475617,7475613,'nab',20,2),(414,7475618,7475613,'abl',20,2),(414,7475619,7475613,'ble',20,2),(414,7475620,7475613,'led',20,2),(414,7475621,7475616,'cac',33.333,2),(414,7475622,7475616,'ach',33.333,2),(414,7475623,7475616,'che',33.333,2),(414,7475624,7475621,'mod',50,1),(414,7475625,7475621,'ode',50,1),(414,7475626,7475624,'wri',14.286,1),(414,7475627,7475624,'rit',14.286,1),(414,7475628,7475624,'ite',14.286,1),(414,7475629,7475624,'tet',14.286,1),(414,7475630,7475624,'eth',14.286,1),(414,7475631,7475624,'thr',14.286,1),(414,7475632,7475624,'hru',14.286,1),(414,7475633,7475626,'ope',11.111,2),(414,7475634,7475626,'per',11.111,2),(414,7475635,7475626,'era',11.111,2),(414,7475636,7475626,'rat',11.111,2),(414,7475637,7475626,'ati',11.111,2),(414,7475638,7475626,'tio',11.111,2),(414,7475639,7475626,'ion',11.111,2),(414,7475640,7475626,'ona',11.111,2),(414,7475641,7475626,'nal',11.111,2),(414,7475642,7475633,'pen',20,1),(414,7475643,7475633,'end',20,1),(414,7475644,7475633,'ndi',20,1),(414,7475645,7475633,'din',20,1),(414,7475646,7475633,'ing',20,1),(414,7475647,7475642,'mes',20,1),(414,7475648,7475642,'ess',20,1),(414,7475649,7475642,'ssa',20,1),(414,7475650,7475642,'sag',20,1),(414,7475651,7475642,'age',20,1),(414,7475652,7475647,'wai',20,1),(414,7475653,7475647,'ait',20,1),(414,7475654,7475647,'iti',20,1),(414,7475655,7475647,'tin',20,1),(414,7475656,7475647,'ing',20,1),(414,7475657,7475652,'for',100,1),(414,7475658,7475657,'per',11.111,1),(414,7475659,7475657,'erf',11.111,1),(414,7475660,7475657,'rfo',11.111,1),(414,7475661,7475657,'for',11.111,1),(414,7475662,7475657,'orm',11.111,1),(414,7475663,7475657,'rma',11.111,1),(414,7475664,7475657,'man',11.111,1),(414,7475665,7475657,'anc',11.111,1),(414,7475666,7475657,'nce',11.111,1),(414,7475667,7475658,'ide',12.5,1),(414,7475668,7475658,'den',12.5,1),(414,7475669,7475658,'ent',12.5,1),(414,7475670,7475658,'nti',12.5,1),(414,7475671,7475658,'tif',12.5,1),(414,7475672,7475658,'ifi',12.5,1),(414,7475673,7475658,'fie',12.5,1),(414,7475674,7475658,'ier',12.5,1),(414,7475675,7475667,'vdi',33.333,3),(414,7475676,7475667,'dis',33.333,3),(414,7475677,7475667,'isk',33.333,3),(414,7475678,7475675,'nam',50,1),(414,7475679,7475675,'ame',50,1),(414,7475680,7475678,'typ',50,1),(414,7475681,7475678,'ype',50,1),(414,7475682,7475680,'dir',25,1),(414,7475683,7475680,'ire',25,1),(414,7475684,7475680,'rec',25,1),(414,7475685,7475680,'ect',25,1),(415,7475687,7475686,'naa',100,2),(415,7475688,7475687,'600',3.333,3),(415,7475689,7475687,'000',3.333,3),(415,7475690,7475687,'00c',3.333,3),(415,7475691,7475687,'0c2',3.333,3),(415,7475692,7475687,'c29',3.333,3),(415,7475693,7475687,'290',3.333,3),(415,7475694,7475687,'900',3.333,3),(415,7475695,7475687,'00b',3.333,3),(415,7475696,7475687,'0ba',3.333,3),(415,7475697,7475687,'ba3',3.333,3),(415,7475698,7475687,'a30',3.333,3),(415,7475699,7475687,'30f',3.333,3),(415,7475700,7475687,'0f9',3.333,3),(415,7475701,7475687,'f9c',3.333,3),(415,7475702,7475687,'9c0',3.333,3),(415,7475703,7475687,'c04',3.333,3),(415,7475704,7475687,'047',3.333,3),(415,7475705,7475687,'476',3.333,3),(415,7475706,7475687,'761',3.333,3),(415,7475707,7475687,'61e',3.333,3),(415,7475708,7475687,'1e6',3.333,3),(415,7475709,7475687,'e67',3.333,3),(415,7475710,7475687,'67e',3.333,3),(415,7475711,7475687,'7e7',3.333,3),(415,7475712,7475687,'e7b',3.333,3),(415,7475713,7475687,'7ba',3.333,3),(415,7475714,7475687,'ba6',3.333,3),(415,7475715,7475687,'a6c',3.333,3),(415,7475716,7475687,'6cc',3.333,3),(415,7475717,7475687,'cce',3.333,3),(415,7475718,7475688,'mon',100,1),(415,7475719,7475718,'201',50,1),(415,7475720,7475718,'013',50,1),(415,7475721,7475719,'adm',33.333,3),(415,7475722,7475719,'dmi',33.333,3),(415,7475723,7475719,'min',33.333,3),(415,7475724,7475721,'cap',16.667,1),(415,7475725,7475721,'apa',16.667,1),(415,7475726,7475721,'pac',16.667,1),(415,7475727,7475721,'aci',16.667,1),(415,7475728,7475721,'cit',16.667,1),(415,7475729,7475721,'ity',16.667,1),(415,7475730,7475724,'pat',50,1),(415,7475731,7475724,'ath',50,1),(415,7475732,7475730,'fre',14.286,1),(415,7475733,7475730,'ree',14.286,1),(415,7475734,7475730,'ees',14.286,1),(415,7475735,7475730,'esp',14.286,1),(415,7475736,7475730,'spa',14.286,1),(415,7475737,7475730,'pac',14.286,1),(415,7475738,7475730,'ace',14.286,1),(415,7475739,7475732,'dis',50,1),(415,7475740,7475732,'isk',50,1),(415,7475741,7475739,'ind',33.333,1),(415,7475742,7475739,'nde',33.333,1),(415,7475743,7475739,'dex',33.333,1),(415,7475744,7475741,'adm',8.333,1),(415,7475745,7475741,'dmi',8.333,1),(415,7475746,7475741,'min',8.333,1),(415,7475747,7475741,'ini',8.333,1),(415,7475748,7475741,'nis',8.333,1),(415,7475749,7475741,'ist',8.333,1),(415,7475750,7475741,'str',8.333,1),(415,7475751,7475741,'tra',8.333,1),(415,7475752,7475741,'rat',8.333,1),(415,7475753,7475741,'ati',8.333,1),(415,7475754,7475741,'tio',8.333,1),(415,7475755,7475741,'ion',8.333,1),(415,7475756,7475744,'sta',33.333,3),(415,7475757,7475744,'tat',33.333,3),(415,7475758,7475744,'ate',33.333,3),(415,7475759,7475756,'ena',20,2),(415,7475760,7475756,'nab',20,2),(415,7475761,7475756,'abl',20,2),(415,7475762,7475756,'ble',20,2),(415,7475763,7475756,'led',20,2),(415,7475764,7475759,'cac',33.333,2),(415,7475765,7475759,'ach',33.333,2),(415,7475766,7475759,'che',33.333,2),(415,7475767,7475764,'mod',50,1),(415,7475768,7475764,'ode',50,1),(415,7475769,7475767,'wri',14.286,1),(415,7475770,7475767,'rit',14.286,1),(415,7475771,7475767,'ite',14.286,1),(415,7475772,7475767,'tet',14.286,1),(415,7475773,7475767,'eth',14.286,1),(415,7475774,7475767,'thr',14.286,1),(415,7475775,7475767,'hru',14.286,1),(415,7475776,7475769,'ope',11.111,2),(415,7475777,7475769,'per',11.111,2),(415,7475778,7475769,'era',11.111,2),(415,7475779,7475769,'rat',11.111,2),(415,7475780,7475769,'ati',11.111,2),(415,7475781,7475769,'tio',11.111,2),(415,7475782,7475769,'ion',11.111,2),(415,7475783,7475769,'ona',11.111,2),(415,7475784,7475769,'nal',11.111,2),(415,7475785,7475776,'pen',20,1),(415,7475786,7475776,'end',20,1),(415,7475787,7475776,'ndi',20,1),(415,7475788,7475776,'din',20,1),(415,7475789,7475776,'ing',20,1),(415,7475790,7475785,'mes',20,1),(415,7475791,7475785,'ess',20,1),(415,7475792,7475785,'ssa',20,1),(415,7475793,7475785,'sag',20,1),(415,7475794,7475785,'age',20,1),(415,7475795,7475790,'wai',20,1),(415,7475796,7475790,'ait',20,1),(415,7475797,7475790,'iti',20,1),(415,7475798,7475790,'tin',20,1),(415,7475799,7475790,'ing',20,1),(415,7475800,7475795,'for',100,1),(415,7475801,7475800,'per',11.111,1),(415,7475802,7475800,'erf',11.111,1),(415,7475803,7475800,'rfo',11.111,1),(415,7475804,7475800,'for',11.111,1),(415,7475805,7475800,'orm',11.111,1),(415,7475806,7475800,'rma',11.111,1),(415,7475807,7475800,'man',11.111,1),(415,7475808,7475800,'anc',11.111,1),(415,7475809,7475800,'nce',11.111,1),(415,7475810,7475801,'ide',12.5,1),(415,7475811,7475801,'den',12.5,1),(415,7475812,7475801,'ent',12.5,1),(415,7475813,7475801,'nti',12.5,1),(415,7475814,7475801,'tif',12.5,1),(415,7475815,7475801,'ifi',12.5,1),(415,7475816,7475801,'fie',12.5,1),(415,7475817,7475801,'ier',12.5,1),(415,7475818,7475810,'vdi',33.333,3),(415,7475819,7475810,'dis',33.333,3),(415,7475820,7475810,'isk',33.333,3),(415,7475821,7475818,'nam',50,1),(415,7475822,7475818,'ame',50,1),(415,7475823,7475821,'typ',50,1),(415,7475824,7475821,'ype',50,1),(415,7475825,7475823,'dir',25,1),(415,7475826,7475823,'ire',25,1),(415,7475827,7475823,'rec',25,1),(415,7475828,7475823,'ect',25,1),(416,7475830,7475829,'naa',100,2),(416,7475831,7475830,'600',3.333,3),(416,7475832,7475830,'000',3.333,3),(416,7475833,7475830,'00c',3.333,3),(416,7475834,7475830,'0c2',3.333,3),(416,7475835,7475830,'c29',3.333,3),(416,7475836,7475830,'290',3.333,3),(416,7475837,7475830,'908',3.333,3),(416,7475838,7475830,'083',3.333,3),(416,7475839,7475830,'839',3.333,3),(416,7475840,7475830,'395',3.333,3),(416,7475841,7475830,'952',3.333,3),(416,7475842,7475830,'52d',3.333,3),(416,7475843,7475830,'2de',3.333,3),(416,7475844,7475830,'def',3.333,3),(416,7475845,7475830,'ef6',3.333,3),(416,7475846,7475830,'f68',3.333,3),(416,7475847,7475830,'68e',3.333,3),(416,7475848,7475830,'8e3',3.333,3),(416,7475849,7475830,'e3e',3.333,3),(416,7475850,7475830,'3e9',3.333,3),(416,7475851,7475830,'e9f',3.333,3),(416,7475852,7475830,'9ff',3.333,3),(416,7475853,7475830,'ffd',3.333,3),(416,7475854,7475830,'fd1',3.333,3),(416,7475855,7475830,'d16',3.333,3),(416,7475856,7475830,'165',3.333,3),(416,7475857,7475830,'651',3.333,3),(416,7475858,7475830,'517',3.333,3),(416,7475859,7475830,'17b',3.333,3),(416,7475860,7475830,'7b9',3.333,3),(416,7475861,7475831,'mon',100,1),(416,7475862,7475861,'201',50,1),(416,7475863,7475861,'013',50,1),(416,7475864,7475862,'adm',33.333,3),(416,7475865,7475862,'dmi',33.333,3),(416,7475866,7475862,'min',33.333,3),(416,7475867,7475864,'cap',16.667,1),(416,7475868,7475864,'apa',16.667,1),(416,7475869,7475864,'pac',16.667,1),(416,7475870,7475864,'aci',16.667,1),(416,7475871,7475864,'cit',16.667,1),(416,7475872,7475864,'ity',16.667,1),(416,7475873,7475867,'pat',50,1),(416,7475874,7475867,'ath',50,1),(416,7475875,7475873,'fre',14.286,1),(416,7475876,7475873,'ree',14.286,1),(416,7475877,7475873,'ees',14.286,1),(416,7475878,7475873,'esp',14.286,1),(416,7475879,7475873,'spa',14.286,1),(416,7475880,7475873,'pac',14.286,1),(416,7475881,7475873,'ace',14.286,1),(416,7475882,7475875,'dis',50,1),(416,7475883,7475875,'isk',50,1),(416,7475884,7475882,'ind',33.333,1),(416,7475885,7475882,'nde',33.333,1),(416,7475886,7475882,'dex',33.333,1),(416,7475887,7475884,'adm',8.333,1),(416,7475888,7475884,'dmi',8.333,1),(416,7475889,7475884,'min',8.333,1),(416,7475890,7475884,'ini',8.333,1),(416,7475891,7475884,'nis',8.333,1),(416,7475892,7475884,'ist',8.333,1),(416,7475893,7475884,'str',8.333,1),(416,7475894,7475884,'tra',8.333,1),(416,7475895,7475884,'rat',8.333,1),(416,7475896,7475884,'ati',8.333,1),(416,7475897,7475884,'tio',8.333,1),(416,7475898,7475884,'ion',8.333,1),(416,7475899,7475887,'sta',33.333,3),(416,7475900,7475887,'tat',33.333,3),(416,7475901,7475887,'ate',33.333,3),(416,7475902,7475899,'ena',20,2),(416,7475903,7475899,'nab',20,2),(416,7475904,7475899,'abl',20,2),(416,7475905,7475899,'ble',20,2),(416,7475906,7475899,'led',20,2),(416,7475907,7475902,'cac',33.333,2),(416,7475908,7475902,'ach',33.333,2),(416,7475909,7475902,'che',33.333,2),(416,7475910,7475907,'mod',50,1),(416,7475911,7475907,'ode',50,1),(416,7475912,7475910,'wri',14.286,1),(416,7475913,7475910,'rit',14.286,1),(416,7475914,7475910,'ite',14.286,1),(416,7475915,7475910,'tet',14.286,1),(416,7475916,7475910,'eth',14.286,1),(416,7475917,7475910,'thr',14.286,1),(416,7475918,7475910,'hru',14.286,1),(416,7475919,7475912,'ope',11.111,2),(416,7475920,7475912,'per',11.111,2),(416,7475921,7475912,'era',11.111,2),(416,7475922,7475912,'rat',11.111,2),(416,7475923,7475912,'ati',11.111,2),(416,7475924,7475912,'tio',11.111,2),(416,7475925,7475912,'ion',11.111,2),(416,7475926,7475912,'ona',11.111,2),(416,7475927,7475912,'nal',11.111,2),(416,7475928,7475919,'pen',20,1),(416,7475929,7475919,'end',20,1),(416,7475930,7475919,'ndi',20,1),(416,7475931,7475919,'din',20,1),(416,7475932,7475919,'ing',20,1),(416,7475933,7475928,'mes',20,1),(416,7475934,7475928,'ess',20,1),(416,7475935,7475928,'ssa',20,1),(416,7475936,7475928,'sag',20,1),(416,7475937,7475928,'age',20,1),(416,7475938,7475933,'wai',20,1),(416,7475939,7475933,'ait',20,1),(416,7475940,7475933,'iti',20,1),(416,7475941,7475933,'tin',20,1),(416,7475942,7475933,'ing',20,1),(416,7475943,7475938,'for',100,1),(416,7475944,7475943,'per',11.111,1),(416,7475945,7475943,'erf',11.111,1),(416,7475946,7475943,'rfo',11.111,1),(416,7475947,7475943,'for',11.111,1),(416,7475948,7475943,'orm',11.111,1),(416,7475949,7475943,'rma',11.111,1),(416,7475950,7475943,'man',11.111,1),(416,7475951,7475943,'anc',11.111,1),(416,7475952,7475943,'nce',11.111,1),(416,7475953,7475944,'ide',12.5,1),(416,7475954,7475944,'den',12.5,1),(416,7475955,7475944,'ent',12.5,1),(416,7475956,7475944,'nti',12.5,1),(416,7475957,7475944,'tif',12.5,1),(416,7475958,7475944,'ifi',12.5,1),(416,7475959,7475944,'fie',12.5,1),(416,7475960,7475944,'ier',12.5,1),(416,7475961,7475953,'vdi',33.333,3),(416,7475962,7475953,'dis',33.333,3),(416,7475963,7475953,'isk',33.333,3),(416,7475964,7475961,'nam',50,1),(416,7475965,7475961,'ame',50,1),(416,7475966,7475964,'typ',50,1),(416,7475967,7475964,'ype',50,1),(416,7475968,7475966,'dir',25,1),(416,7475969,7475966,'ire',25,1),(416,7475970,7475966,'rec',25,1),(416,7475971,7475966,'ect',25,1),(417,7475973,7475972,'naa',100,2),(417,7475974,7475973,'600',3.333,3),(417,7475975,7475973,'000',3.333,3),(417,7475976,7475973,'00c',3.333,3),(417,7475977,7475973,'0c2',3.333,3),(417,7475978,7475973,'c29',3.333,3),(417,7475979,7475973,'291',3.333,3),(417,7475980,7475973,'91d',3.333,3),(417,7475981,7475973,'1d7',3.333,3),(417,7475982,7475973,'d75',3.333,3),(417,7475983,7475973,'75a',3.333,3),(417,7475984,7475973,'5a3',3.333,3),(417,7475985,7475973,'a37',3.333,3),(417,7475986,7475973,'370',3.333,3),(417,7475987,7475973,'708',3.333,3),(417,7475988,7475973,'08a',3.333,3),(417,7475989,7475973,'8a8',3.333,3),(417,7475990,7475973,'a84',3.333,3),(417,7475991,7475973,'841',3.333,3),(417,7475992,7475973,'41e',3.333,3),(417,7475993,7475973,'1e1',3.333,3),(417,7475994,7475973,'e1e',3.333,3),(417,7475995,7475973,'1ee',3.333,3),(417,7475996,7475973,'ee0',3.333,3),(417,7475997,7475973,'e07',3.333,3),(417,7475998,7475973,'07a',3.333,3),(417,7475999,7475973,'7a0',3.333,3),(417,7476000,7475973,'a01',3.333,3),(417,7476001,7475973,'014',3.333,3),(417,7476002,7475973,'14f',3.333,3),(417,7476003,7475973,'4f1',3.333,3),(417,7476004,7475974,'mon',100,1),(417,7476005,7476004,'201',50,1),(417,7476006,7476004,'013',50,1),(417,7476007,7476005,'adm',33.333,3),(417,7476008,7476005,'dmi',33.333,3),(417,7476009,7476005,'min',33.333,3),(417,7476010,7476007,'cap',16.667,1),(417,7476011,7476007,'apa',16.667,1),(417,7476012,7476007,'pac',16.667,1),(417,7476013,7476007,'aci',16.667,1),(417,7476014,7476007,'cit',16.667,1),(417,7476015,7476007,'ity',16.667,1),(417,7476016,7476010,'pat',50,1),(417,7476017,7476010,'ath',50,1),(417,7476018,7476016,'fre',14.286,1),(417,7476019,7476016,'ree',14.286,1),(417,7476020,7476016,'ees',14.286,1),(417,7476021,7476016,'esp',14.286,1),(417,7476022,7476016,'spa',14.286,1),(417,7476023,7476016,'pac',14.286,1),(417,7476024,7476016,'ace',14.286,1),(417,7476025,7476018,'dis',50,1),(417,7476026,7476018,'isk',50,1),(417,7476027,7476025,'ind',33.333,1),(417,7476028,7476025,'nde',33.333,1),(417,7476029,7476025,'dex',33.333,1),(417,7476030,7476027,'adm',8.333,1),(417,7476031,7476027,'dmi',8.333,1),(417,7476032,7476027,'min',8.333,1),(417,7476033,7476027,'ini',8.333,1),(417,7476034,7476027,'nis',8.333,1),(417,7476035,7476027,'ist',8.333,1),(417,7476036,7476027,'str',8.333,1),(417,7476037,7476027,'tra',8.333,1),(417,7476038,7476027,'rat',8.333,1),(417,7476039,7476027,'ati',8.333,1),(417,7476040,7476027,'tio',8.333,1),(417,7476041,7476027,'ion',8.333,1),(417,7476042,7476030,'sta',33.333,3),(417,7476043,7476030,'tat',33.333,3),(417,7476044,7476030,'ate',33.333,3),(417,7476045,7476042,'ena',20,2),(417,7476046,7476042,'nab',20,2),(417,7476047,7476042,'abl',20,2),(417,7476048,7476042,'ble',20,2),(417,7476049,7476042,'led',20,2),(417,7476050,7476045,'cac',33.333,2),(417,7476051,7476045,'ach',33.333,2),(417,7476052,7476045,'che',33.333,2),(417,7476053,7476050,'mod',50,1),(417,7476054,7476050,'ode',50,1),(417,7476055,7476053,'wri',14.286,1),(417,7476056,7476053,'rit',14.286,1),(417,7476057,7476053,'ite',14.286,1),(417,7476058,7476053,'tet',14.286,1),(417,7476059,7476053,'eth',14.286,1),(417,7476060,7476053,'thr',14.286,1),(417,7476061,7476053,'hru',14.286,1),(417,7476062,7476055,'ope',11.111,2),(417,7476063,7476055,'per',11.111,2),(417,7476064,7476055,'era',11.111,2),(417,7476065,7476055,'rat',11.111,2),(417,7476066,7476055,'ati',11.111,2),(417,7476067,7476055,'tio',11.111,2),(417,7476068,7476055,'ion',11.111,2),(417,7476069,7476055,'ona',11.111,2),(417,7476070,7476055,'nal',11.111,2),(417,7476071,7476062,'pen',20,1),(417,7476072,7476062,'end',20,1),(417,7476073,7476062,'ndi',20,1),(417,7476074,7476062,'din',20,1),(417,7476075,7476062,'ing',20,1),(417,7476076,7476071,'mes',20,1),(417,7476077,7476071,'ess',20,1),(417,7476078,7476071,'ssa',20,1),(417,7476079,7476071,'sag',20,1),(417,7476080,7476071,'age',20,1),(417,7476081,7476076,'wai',20,1),(417,7476082,7476076,'ait',20,1),(417,7476083,7476076,'iti',20,1),(417,7476084,7476076,'tin',20,1),(417,7476085,7476076,'ing',20,1),(417,7476086,7476081,'for',100,1),(417,7476087,7476086,'per',11.111,1),(417,7476088,7476086,'erf',11.111,1),(417,7476089,7476086,'rfo',11.111,1),(417,7476090,7476086,'for',11.111,1),(417,7476091,7476086,'orm',11.111,1),(417,7476092,7476086,'rma',11.111,1),(417,7476093,7476086,'man',11.111,1),(417,7476094,7476086,'anc',11.111,1),(417,7476095,7476086,'nce',11.111,1),(417,7476096,7476087,'ide',12.5,1),(417,7476097,7476087,'den',12.5,1),(417,7476098,7476087,'ent',12.5,1),(417,7476099,7476087,'nti',12.5,1),(417,7476100,7476087,'tif',12.5,1),(417,7476101,7476087,'ifi',12.5,1),(417,7476102,7476087,'fie',12.5,1),(417,7476103,7476087,'ier',12.5,1),(417,7476104,7476096,'vdi',33.333,3),(417,7476105,7476096,'dis',33.333,3),(417,7476106,7476096,'isk',33.333,3),(417,7476107,7476104,'nam',50,1),(417,7476108,7476104,'ame',50,1),(417,7476109,7476107,'typ',50,1),(417,7476110,7476107,'ype',50,1),(417,7476111,7476109,'dir',25,1),(417,7476112,7476109,'ire',25,1),(417,7476113,7476109,'rec',25,1),(417,7476114,7476109,'ect',25,1),(418,7476116,7476115,'naa',100,2),(418,7476117,7476116,'600',3.333,3),(418,7476118,7476116,'000',3.333,3),(418,7476119,7476116,'00c',3.333,3),(418,7476120,7476116,'0c2',3.333,3),(418,7476121,7476116,'c29',3.333,3),(418,7476122,7476116,'29d',3.333,3),(418,7476123,7476116,'9d4',3.333,3),(418,7476124,7476116,'d47',3.333,3),(418,7476125,7476116,'47d',3.333,3),(418,7476126,7476116,'7d7',3.333,3),(418,7476127,7476116,'d77',3.333,3),(418,7476128,7476116,'77c',3.333,3),(418,7476129,7476116,'7c0',3.333,3),(418,7476130,7476116,'c0c',3.333,3),(418,7476131,7476116,'0cd',3.333,3),(418,7476132,7476116,'cd2',3.333,3),(418,7476133,7476116,'d20',3.333,3),(418,7476134,7476116,'202',3.333,3),(418,7476135,7476116,'025',3.333,3),(418,7476136,7476116,'25e',3.333,3),(418,7476137,7476116,'5e1',3.333,3),(418,7476138,7476116,'e19',3.333,3),(418,7476139,7476116,'197',3.333,3),(418,7476140,7476116,'971',3.333,3),(418,7476141,7476116,'711',3.333,3),(418,7476142,7476116,'110',3.333,3),(418,7476143,7476116,'109',3.333,3),(418,7476144,7476116,'09d',3.333,3),(418,7476145,7476116,'9dd',3.333,3),(418,7476146,7476116,'dd6',3.333,3),(418,7476147,7476117,'mon',100,1),(418,7476148,7476147,'201',50,1),(418,7476149,7476147,'013',50,1),(418,7476150,7476148,'adm',33.333,3),(418,7476151,7476148,'dmi',33.333,3),(418,7476152,7476148,'min',33.333,3),(418,7476153,7476150,'cap',16.667,1),(418,7476154,7476150,'apa',16.667,1),(418,7476155,7476150,'pac',16.667,1),(418,7476156,7476150,'aci',16.667,1),(418,7476157,7476150,'cit',16.667,1),(418,7476158,7476150,'ity',16.667,1),(418,7476159,7476153,'pat',50,1),(418,7476160,7476153,'ath',50,1),(418,7476161,7476159,'fre',14.286,1),(418,7476162,7476159,'ree',14.286,1),(418,7476163,7476159,'ees',14.286,1),(418,7476164,7476159,'esp',14.286,1),(418,7476165,7476159,'spa',14.286,1),(418,7476166,7476159,'pac',14.286,1),(418,7476167,7476159,'ace',14.286,1),(418,7476168,7476161,'dis',50,1),(418,7476169,7476161,'isk',50,1),(418,7476170,7476168,'ind',33.333,1),(418,7476171,7476168,'nde',33.333,1),(418,7476172,7476168,'dex',33.333,1),(418,7476173,7476170,'adm',8.333,1),(418,7476174,7476170,'dmi',8.333,1),(418,7476175,7476170,'min',8.333,1),(418,7476176,7476170,'ini',8.333,1),(418,7476177,7476170,'nis',8.333,1),(418,7476178,7476170,'ist',8.333,1),(418,7476179,7476170,'str',8.333,1),(418,7476180,7476170,'tra',8.333,1),(418,7476181,7476170,'rat',8.333,1),(418,7476182,7476170,'ati',8.333,1),(418,7476183,7476170,'tio',8.333,1),(418,7476184,7476170,'ion',8.333,1),(418,7476185,7476173,'sta',33.333,3),(418,7476186,7476173,'tat',33.333,3),(418,7476187,7476173,'ate',33.333,3),(418,7476188,7476185,'ena',20,2),(418,7476189,7476185,'nab',20,2),(418,7476190,7476185,'abl',20,2),(418,7476191,7476185,'ble',20,2),(418,7476192,7476185,'led',20,2),(418,7476193,7476188,'cac',33.333,2),(418,7476194,7476188,'ach',33.333,2),(418,7476195,7476188,'che',33.333,2),(418,7476196,7476193,'mod',50,1),(418,7476197,7476193,'ode',50,1),(418,7476198,7476196,'wri',14.286,1),(418,7476199,7476196,'rit',14.286,1),(418,7476200,7476196,'ite',14.286,1),(418,7476201,7476196,'tet',14.286,1),(418,7476202,7476196,'eth',14.286,1),(418,7476203,7476196,'thr',14.286,1),(418,7476204,7476196,'hru',14.286,1),(418,7476205,7476198,'ope',11.111,2),(418,7476206,7476198,'per',11.111,2),(418,7476207,7476198,'era',11.111,2),(418,7476208,7476198,'rat',11.111,2),(418,7476209,7476198,'ati',11.111,2),(418,7476210,7476198,'tio',11.111,2),(418,7476211,7476198,'ion',11.111,2),(418,7476212,7476198,'ona',11.111,2),(418,7476213,7476198,'nal',11.111,2),(418,7476214,7476205,'pen',20,1),(418,7476215,7476205,'end',20,1),(418,7476216,7476205,'ndi',20,1),(418,7476217,7476205,'din',20,1),(418,7476218,7476205,'ing',20,1),(418,7476219,7476214,'mes',20,1),(418,7476220,7476214,'ess',20,1),(418,7476221,7476214,'ssa',20,1),(418,7476222,7476214,'sag',20,1),(418,7476223,7476214,'age',20,1),(418,7476224,7476219,'wai',20,1),(418,7476225,7476219,'ait',20,1),(418,7476226,7476219,'iti',20,1),(418,7476227,7476219,'tin',20,1),(418,7476228,7476219,'ing',20,1),(418,7476229,7476224,'for',100,1),(418,7476230,7476229,'per',11.111,1),(418,7476231,7476229,'erf',11.111,1),(418,7476232,7476229,'rfo',11.111,1),(418,7476233,7476229,'for',11.111,1),(418,7476234,7476229,'orm',11.111,1),(418,7476235,7476229,'rma',11.111,1),(418,7476236,7476229,'man',11.111,1),(418,7476237,7476229,'anc',11.111,1),(418,7476238,7476229,'nce',11.111,1),(418,7476239,7476230,'ide',12.5,1),(418,7476240,7476230,'den',12.5,1),(418,7476241,7476230,'ent',12.5,1),(418,7476242,7476230,'nti',12.5,1),(418,7476243,7476230,'tif',12.5,1),(418,7476244,7476230,'ifi',12.5,1),(418,7476245,7476230,'fie',12.5,1),(418,7476246,7476230,'ier',12.5,1),(418,7476247,7476239,'vdi',33.333,3),(418,7476248,7476239,'dis',33.333,3),(418,7476249,7476239,'isk',33.333,3),(418,7476250,7476247,'nam',50,1),(418,7476251,7476247,'ame',50,1),(418,7476252,7476250,'typ',50,1),(418,7476253,7476250,'ype',50,1),(418,7476254,7476252,'dir',25,1),(418,7476255,7476252,'ire',25,1),(418,7476256,7476252,'rec',25,1),(418,7476257,7476252,'ect',25,1),(419,7476259,7476258,'naa',100,2),(419,7476260,7476259,'600',3.333,3),(419,7476261,7476259,'000',3.333,3),(419,7476262,7476259,'00c',3.333,3),(419,7476263,7476259,'0c2',3.333,3),(419,7476264,7476259,'c29',3.333,3),(419,7476265,7476259,'29d',3.333,3),(419,7476266,7476259,'9dd',3.333,3),(419,7476267,7476259,'dd0',3.333,3),(419,7476268,7476259,'d01',3.333,3),(419,7476269,7476259,'01e',3.333,3),(419,7476270,7476259,'1ef',3.333,3),(419,7476271,7476259,'ef3',3.333,3),(419,7476272,7476259,'f31',3.333,3),(419,7476273,7476259,'319',3.333,3),(419,7476274,7476259,'192',3.333,3),(419,7476275,7476259,'92b',3.333,3),(419,7476276,7476259,'2bf',3.333,3),(419,7476277,7476259,'bf1',3.333,3),(419,7476278,7476259,'f1f',3.333,3),(419,7476279,7476259,'1ff',3.333,3),(419,7476280,7476259,'ffa',3.333,3),(419,7476281,7476259,'fa1',3.333,3),(419,7476282,7476259,'a13',3.333,3),(419,7476283,7476259,'13e',3.333,3),(419,7476284,7476259,'3e5',3.333,3),(419,7476285,7476259,'e5c',3.333,3),(419,7476286,7476259,'5c7',3.333,3),(419,7476287,7476259,'c71',3.333,3),(419,7476288,7476259,'71a',3.333,3),(419,7476289,7476259,'1a2',3.333,3),(419,7476290,7476260,'mon',100,1),(419,7476291,7476290,'201',50,1),(419,7476292,7476290,'013',50,1),(419,7476293,7476291,'adm',33.333,3),(419,7476294,7476291,'dmi',33.333,3),(419,7476295,7476291,'min',33.333,3),(419,7476296,7476293,'cap',16.667,1),(419,7476297,7476293,'apa',16.667,1),(419,7476298,7476293,'pac',16.667,1),(419,7476299,7476293,'aci',16.667,1),(419,7476300,7476293,'cit',16.667,1),(419,7476301,7476293,'ity',16.667,1),(419,7476302,7476296,'pat',50,1),(419,7476303,7476296,'ath',50,1),(419,7476304,7476302,'fre',14.286,1),(419,7476305,7476302,'ree',14.286,1),(419,7476306,7476302,'ees',14.286,1),(419,7476307,7476302,'esp',14.286,1),(419,7476308,7476302,'spa',14.286,1),(419,7476309,7476302,'pac',14.286,1),(419,7476310,7476302,'ace',14.286,1),(419,7476311,7476304,'dis',50,1),(419,7476312,7476304,'isk',50,1),(419,7476313,7476311,'ind',33.333,1),(419,7476314,7476311,'nde',33.333,1),(419,7476315,7476311,'dex',33.333,1),(419,7476316,7476313,'adm',8.333,1),(419,7476317,7476313,'dmi',8.333,1),(419,7476318,7476313,'min',8.333,1),(419,7476319,7476313,'ini',8.333,1),(419,7476320,7476313,'nis',8.333,1),(419,7476321,7476313,'ist',8.333,1),(419,7476322,7476313,'str',8.333,1),(419,7476323,7476313,'tra',8.333,1),(419,7476324,7476313,'rat',8.333,1),(419,7476325,7476313,'ati',8.333,1),(419,7476326,7476313,'tio',8.333,1),(419,7476327,7476313,'ion',8.333,1),(419,7476328,7476316,'sta',33.333,3),(419,7476329,7476316,'tat',33.333,3),(419,7476330,7476316,'ate',33.333,3),(419,7476331,7476328,'ena',20,2),(419,7476332,7476328,'nab',20,2),(419,7476333,7476328,'abl',20,2),(419,7476334,7476328,'ble',20,2),(419,7476335,7476328,'led',20,2),(419,7476336,7476331,'cac',33.333,2),(419,7476337,7476331,'ach',33.333,2),(419,7476338,7476331,'che',33.333,2),(419,7476339,7476336,'mod',50,1),(419,7476340,7476336,'ode',50,1),(419,7476341,7476339,'wri',14.286,1),(419,7476342,7476339,'rit',14.286,1),(419,7476343,7476339,'ite',14.286,1),(419,7476344,7476339,'tet',14.286,1),(419,7476345,7476339,'eth',14.286,1),(419,7476346,7476339,'thr',14.286,1),(419,7476347,7476339,'hru',14.286,1),(419,7476348,7476341,'ope',11.111,2),(419,7476349,7476341,'per',11.111,2),(419,7476350,7476341,'era',11.111,2),(419,7476351,7476341,'rat',11.111,2),(419,7476352,7476341,'ati',11.111,2),(419,7476353,7476341,'tio',11.111,2),(419,7476354,7476341,'ion',11.111,2),(419,7476355,7476341,'ona',11.111,2),(419,7476356,7476341,'nal',11.111,2),(419,7476357,7476348,'pen',20,1),(419,7476358,7476348,'end',20,1),(419,7476359,7476348,'ndi',20,1),(419,7476360,7476348,'din',20,1),(419,7476361,7476348,'ing',20,1),(419,7476362,7476357,'mes',20,1),(419,7476363,7476357,'ess',20,1),(419,7476364,7476357,'ssa',20,1),(419,7476365,7476357,'sag',20,1),(419,7476366,7476357,'age',20,1),(419,7476367,7476362,'wai',20,1),(419,7476368,7476362,'ait',20,1),(419,7476369,7476362,'iti',20,1),(419,7476370,7476362,'tin',20,1),(419,7476371,7476362,'ing',20,1),(419,7476372,7476367,'for',100,1),(419,7476373,7476372,'per',11.111,1),(419,7476374,7476372,'erf',11.111,1),(419,7476375,7476372,'rfo',11.111,1),(419,7476376,7476372,'for',11.111,1),(419,7476377,7476372,'orm',11.111,1),(419,7476378,7476372,'rma',11.111,1),(419,7476379,7476372,'man',11.111,1),(419,7476380,7476372,'anc',11.111,1),(419,7476381,7476372,'nce',11.111,1),(419,7476382,7476373,'ide',12.5,1),(419,7476383,7476373,'den',12.5,1),(419,7476384,7476373,'ent',12.5,1),(419,7476385,7476373,'nti',12.5,1),(419,7476386,7476373,'tif',12.5,1),(419,7476387,7476373,'ifi',12.5,1),(419,7476388,7476373,'fie',12.5,1),(419,7476389,7476373,'ier',12.5,1),(419,7476390,7476382,'vdi',33.333,3),(419,7476391,7476382,'dis',33.333,3),(419,7476392,7476382,'isk',33.333,3),(419,7476393,7476390,'nam',50,1),(419,7476394,7476390,'ame',50,1),(419,7476395,7476393,'typ',50,1),(419,7476396,7476393,'ype',50,1),(419,7476397,7476395,'dir',25,1),(419,7476398,7476395,'ire',25,1),(419,7476399,7476395,'rec',25,1),(419,7476400,7476395,'ect',25,1),(420,7476402,7476401,'naa',100,2),(420,7476403,7476402,'600',3.333,3),(420,7476404,7476402,'000',3.333,3),(420,7476405,7476402,'00c',3.333,3),(420,7476406,7476402,'0c2',3.333,3),(420,7476407,7476402,'c29',3.333,3),(420,7476408,7476402,'294',3.333,3),(420,7476409,7476402,'94c',3.333,3),(420,7476410,7476402,'4c7',3.333,3),(420,7476411,7476402,'c70',3.333,3),(420,7476412,7476402,'701',3.333,3),(420,7476413,7476402,'019',3.333,3),(420,7476414,7476402,'199',3.333,3),(420,7476415,7476402,'996',3.333,3),(420,7476416,7476402,'963',3.333,3),(420,7476417,7476402,'63f',3.333,3),(420,7476418,7476402,'3f0',3.333,3),(420,7476419,7476402,'f07',3.333,3),(420,7476420,7476402,'076',3.333,3),(420,7476421,7476402,'760',3.333,3),(420,7476422,7476402,'607',3.333,3),(420,7476423,7476402,'07c',3.333,3),(420,7476424,7476402,'7c8',3.333,3),(420,7476425,7476402,'c89',3.333,3),(420,7476426,7476402,'89d',3.333,3),(420,7476427,7476402,'9dc',3.333,3),(420,7476428,7476402,'dc4',3.333,3),(420,7476429,7476402,'c46',3.333,3),(420,7476430,7476402,'466',3.333,3),(420,7476431,7476402,'666',3.333,3),(420,7476432,7476402,'66a',3.333,3),(420,7476433,7476403,'mon',100,1),(420,7476434,7476433,'201',50,1),(420,7476435,7476433,'013',50,1),(420,7476436,7476434,'adm',33.333,3),(420,7476437,7476434,'dmi',33.333,3),(420,7476438,7476434,'min',33.333,3),(420,7476439,7476436,'cap',16.667,1),(420,7476440,7476436,'apa',16.667,1),(420,7476441,7476436,'pac',16.667,1),(420,7476442,7476436,'aci',16.667,1),(420,7476443,7476436,'cit',16.667,1),(420,7476444,7476436,'ity',16.667,1),(420,7476445,7476439,'pat',50,1),(420,7476446,7476439,'ath',50,1),(420,7476447,7476445,'fre',14.286,1),(420,7476448,7476445,'ree',14.286,1),(420,7476449,7476445,'ees',14.286,1),(420,7476450,7476445,'esp',14.286,1),(420,7476451,7476445,'spa',14.286,1),(420,7476452,7476445,'pac',14.286,1),(420,7476453,7476445,'ace',14.286,1),(420,7476454,7476447,'dis',50,1),(420,7476455,7476447,'isk',50,1),(420,7476456,7476454,'ind',33.333,1),(420,7476457,7476454,'nde',33.333,1),(420,7476458,7476454,'dex',33.333,1),(420,7476459,7476456,'adm',8.333,1),(420,7476460,7476456,'dmi',8.333,1),(420,7476461,7476456,'min',8.333,1),(420,7476462,7476456,'ini',8.333,1),(420,7476463,7476456,'nis',8.333,1),(420,7476464,7476456,'ist',8.333,1),(420,7476465,7476456,'str',8.333,1),(420,7476466,7476456,'tra',8.333,1),(420,7476467,7476456,'rat',8.333,1),(420,7476468,7476456,'ati',8.333,1),(420,7476469,7476456,'tio',8.333,1),(420,7476470,7476456,'ion',8.333,1),(420,7476471,7476459,'sta',33.333,3),(420,7476472,7476459,'tat',33.333,3),(420,7476473,7476459,'ate',33.333,3),(420,7476474,7476471,'ena',20,2),(420,7476475,7476471,'nab',20,2),(420,7476476,7476471,'abl',20,2),(420,7476477,7476471,'ble',20,2),(420,7476478,7476471,'led',20,2),(420,7476479,7476474,'cac',33.333,2),(420,7476480,7476474,'ach',33.333,2),(420,7476481,7476474,'che',33.333,2),(420,7476482,7476479,'mod',50,1),(420,7476483,7476479,'ode',50,1),(420,7476484,7476482,'wri',14.286,1),(420,7476485,7476482,'rit',14.286,1),(420,7476486,7476482,'ite',14.286,1),(420,7476487,7476482,'tet',14.286,1),(420,7476488,7476482,'eth',14.286,1),(420,7476489,7476482,'thr',14.286,1),(420,7476490,7476482,'hru',14.286,1),(420,7476491,7476484,'ope',11.111,2),(420,7476492,7476484,'per',11.111,2),(420,7476493,7476484,'era',11.111,2),(420,7476494,7476484,'rat',11.111,2),(420,7476495,7476484,'ati',11.111,2),(420,7476496,7476484,'tio',11.111,2),(420,7476497,7476484,'ion',11.111,2),(420,7476498,7476484,'ona',11.111,2),(420,7476499,7476484,'nal',11.111,2),(420,7476500,7476491,'pen',20,1),(420,7476501,7476491,'end',20,1),(420,7476502,7476491,'ndi',20,1),(420,7476503,7476491,'din',20,1),(420,7476504,7476491,'ing',20,1),(420,7476505,7476500,'mes',20,1),(420,7476506,7476500,'ess',20,1),(420,7476507,7476500,'ssa',20,1),(420,7476508,7476500,'sag',20,1),(420,7476509,7476500,'age',20,1),(420,7476510,7476505,'wai',20,1),(420,7476511,7476505,'ait',20,1),(420,7476512,7476505,'iti',20,1),(420,7476513,7476505,'tin',20,1),(420,7476514,7476505,'ing',20,1),(420,7476515,7476510,'for',100,1),(420,7476516,7476515,'per',11.111,1),(420,7476517,7476515,'erf',11.111,1),(420,7476518,7476515,'rfo',11.111,1),(420,7476519,7476515,'for',11.111,1),(420,7476520,7476515,'orm',11.111,1),(420,7476521,7476515,'rma',11.111,1),(420,7476522,7476515,'man',11.111,1),(420,7476523,7476515,'anc',11.111,1),(420,7476524,7476515,'nce',11.111,1),(420,7476525,7476516,'ide',12.5,1),(420,7476526,7476516,'den',12.5,1),(420,7476527,7476516,'ent',12.5,1),(420,7476528,7476516,'nti',12.5,1),(420,7476529,7476516,'tif',12.5,1),(420,7476530,7476516,'ifi',12.5,1),(420,7476531,7476516,'fie',12.5,1),(420,7476532,7476516,'ier',12.5,1),(420,7476533,7476525,'vdi',33.333,3),(420,7476534,7476525,'dis',33.333,3),(420,7476535,7476525,'isk',33.333,3),(420,7476536,7476533,'nam',50,1),(420,7476537,7476533,'ame',50,1),(420,7476538,7476536,'typ',50,1),(420,7476539,7476536,'ype',50,1),(420,7476540,7476538,'dir',25,1),(420,7476541,7476538,'ire',25,1),(420,7476542,7476538,'rec',25,1),(420,7476543,7476538,'ect',25,1),(421,7476545,7476544,'naa',100,2),(421,7476546,7476545,'600',3.333,3),(421,7476547,7476545,'000',3.333,3),(421,7476548,7476545,'00c',3.333,3),(421,7476549,7476545,'0c2',3.333,3),(421,7476550,7476545,'c29',3.333,3),(421,7476551,7476545,'29b',3.333,3),(421,7476552,7476545,'9bf',3.333,3),(421,7476553,7476545,'bf5',3.333,3),(421,7476554,7476545,'f50',3.333,3),(421,7476555,7476545,'50a',3.333,3),(421,7476556,7476545,'0a0',3.333,3),(421,7476557,7476545,'a0e',3.333,3),(421,7476558,7476545,'0ed',3.333,3),(421,7476559,7476545,'ed8',3.333,3),(421,7476560,7476545,'d84',3.333,3),(421,7476561,7476545,'840',3.333,3),(421,7476562,7476545,'408',3.333,3),(421,7476563,7476545,'087',3.333,3),(421,7476564,7476545,'870',3.333,3),(421,7476565,7476545,'706',3.333,3),(421,7476566,7476545,'062',3.333,3),(421,7476567,7476545,'620',3.333,3),(421,7476568,7476545,'208',3.333,3),(421,7476569,7476545,'08f',3.333,3),(421,7476570,7476545,'8f3',3.333,3),(421,7476571,7476545,'f3a',3.333,3),(421,7476572,7476545,'3ae',3.333,3),(421,7476573,7476545,'ae8',3.333,3),(421,7476574,7476545,'e81',3.333,3),(421,7476575,7476545,'812',3.333,3),(421,7476576,7476546,'mon',100,1),(421,7476577,7476576,'201',50,1),(421,7476578,7476576,'013',50,1),(421,7476579,7476577,'adm',33.333,3),(421,7476580,7476577,'dmi',33.333,3),(421,7476581,7476577,'min',33.333,3),(421,7476582,7476579,'cap',16.667,1),(421,7476583,7476579,'apa',16.667,1),(421,7476584,7476579,'pac',16.667,1),(421,7476585,7476579,'aci',16.667,1),(421,7476586,7476579,'cit',16.667,1),(421,7476587,7476579,'ity',16.667,1),(421,7476588,7476582,'pat',50,1),(421,7476589,7476582,'ath',50,1),(421,7476590,7476588,'fre',14.286,1),(421,7476591,7476588,'ree',14.286,1),(421,7476592,7476588,'ees',14.286,1),(421,7476593,7476588,'esp',14.286,1),(421,7476594,7476588,'spa',14.286,1),(421,7476595,7476588,'pac',14.286,1),(421,7476596,7476588,'ace',14.286,1),(421,7476597,7476590,'dis',50,1),(421,7476598,7476590,'isk',50,1),(421,7476599,7476597,'ind',33.333,1),(421,7476600,7476597,'nde',33.333,1),(421,7476601,7476597,'dex',33.333,1),(421,7476602,7476599,'adm',8.333,1),(421,7476603,7476599,'dmi',8.333,1),(421,7476604,7476599,'min',8.333,1),(421,7476605,7476599,'ini',8.333,1),(421,7476606,7476599,'nis',8.333,1),(421,7476607,7476599,'ist',8.333,1),(421,7476608,7476599,'str',8.333,1),(421,7476609,7476599,'tra',8.333,1),(421,7476610,7476599,'rat',8.333,1),(421,7476611,7476599,'ati',8.333,1),(421,7476612,7476599,'tio',8.333,1),(421,7476613,7476599,'ion',8.333,1),(421,7476614,7476602,'sta',33.333,3),(421,7476615,7476602,'tat',33.333,3),(421,7476616,7476602,'ate',33.333,3),(421,7476617,7476614,'ena',20,2),(421,7476618,7476614,'nab',20,2),(421,7476619,7476614,'abl',20,2),(421,7476620,7476614,'ble',20,2),(421,7476621,7476614,'led',20,2),(421,7476622,7476617,'cac',33.333,2),(421,7476623,7476617,'ach',33.333,2),(421,7476624,7476617,'che',33.333,2),(421,7476625,7476622,'mod',50,1),(421,7476626,7476622,'ode',50,1),(421,7476627,7476625,'wri',14.286,1),(421,7476628,7476625,'rit',14.286,1),(421,7476629,7476625,'ite',14.286,1),(421,7476630,7476625,'tet',14.286,1),(421,7476631,7476625,'eth',14.286,1),(421,7476632,7476625,'thr',14.286,1),(421,7476633,7476625,'hru',14.286,1),(421,7476634,7476627,'ope',11.111,2),(421,7476635,7476627,'per',11.111,2),(421,7476636,7476627,'era',11.111,2),(421,7476637,7476627,'rat',11.111,2),(421,7476638,7476627,'ati',11.111,2),(421,7476639,7476627,'tio',11.111,2),(421,7476640,7476627,'ion',11.111,2),(421,7476641,7476627,'ona',11.111,2),(421,7476642,7476627,'nal',11.111,2),(421,7476643,7476634,'pen',20,1),(421,7476644,7476634,'end',20,1),(421,7476645,7476634,'ndi',20,1),(421,7476646,7476634,'din',20,1),(421,7476647,7476634,'ing',20,1),(421,7476648,7476643,'mes',20,1),(421,7476649,7476643,'ess',20,1),(421,7476650,7476643,'ssa',20,1),(421,7476651,7476643,'sag',20,1),(421,7476652,7476643,'age',20,1),(421,7476653,7476648,'wai',20,1),(421,7476654,7476648,'ait',20,1),(421,7476655,7476648,'iti',20,1),(421,7476656,7476648,'tin',20,1),(421,7476657,7476648,'ing',20,1),(421,7476658,7476653,'for',100,1),(421,7476659,7476658,'per',11.111,1),(421,7476660,7476658,'erf',11.111,1),(421,7476661,7476658,'rfo',11.111,1),(421,7476662,7476658,'for',11.111,1),(421,7476663,7476658,'orm',11.111,1),(421,7476664,7476658,'rma',11.111,1),(421,7476665,7476658,'man',11.111,1),(421,7476666,7476658,'anc',11.111,1),(421,7476667,7476658,'nce',11.111,1),(421,7476668,7476659,'ide',12.5,1),(421,7476669,7476659,'den',12.5,1),(421,7476670,7476659,'ent',12.5,1),(421,7476671,7476659,'nti',12.5,1),(421,7476672,7476659,'tif',12.5,1),(421,7476673,7476659,'ifi',12.5,1),(421,7476674,7476659,'fie',12.5,1),(421,7476675,7476659,'ier',12.5,1),(421,7476676,7476668,'vdi',33.333,3),(421,7476677,7476668,'dis',33.333,3),(421,7476678,7476668,'isk',33.333,3),(421,7476679,7476676,'nam',50,1),(421,7476680,7476676,'ame',50,1),(421,7476681,7476679,'typ',50,1),(421,7476682,7476679,'ype',50,1),(421,7476683,7476681,'dir',25,1),(421,7476684,7476681,'ire',25,1),(421,7476685,7476681,'rec',25,1),(421,7476686,7476681,'ect',25,1),(422,7476688,7476687,'naa',100,2),(422,7476689,7476688,'600',3.333,3),(422,7476690,7476688,'000',3.333,3),(422,7476691,7476688,'00c',3.333,3),(422,7476692,7476688,'0c2',3.333,3),(422,7476693,7476688,'c29',3.333,3),(422,7476694,7476688,'29a',3.333,3),(422,7476695,7476688,'9a4',3.333,3),(422,7476696,7476688,'a43',3.333,3),(422,7476697,7476688,'437',3.333,3),(422,7476698,7476688,'374',3.333,3),(422,7476699,7476688,'74a',3.333,3),(422,7476700,7476688,'4a6',3.333,3),(422,7476701,7476688,'a6f',3.333,3),(422,7476702,7476688,'6fc',3.333,3),(422,7476703,7476688,'fc9',3.333,3),(422,7476704,7476688,'c98',3.333,3),(422,7476705,7476688,'984',3.333,3),(422,7476706,7476688,'84c',3.333,3),(422,7476707,7476688,'4cc',3.333,3),(422,7476708,7476688,'cc3',3.333,3),(422,7476709,7476688,'c3d',3.333,3),(422,7476710,7476688,'3df',3.333,3),(422,7476711,7476688,'df4',3.333,3),(422,7476712,7476688,'f42',3.333,3),(422,7476713,7476688,'423',3.333,3),(422,7476714,7476688,'23d',3.333,3),(422,7476715,7476688,'3d7',3.333,3),(422,7476716,7476688,'d78',3.333,3),(422,7476717,7476688,'782',3.333,3),(422,7476718,7476688,'826',3.333,3),(422,7476719,7476689,'mon',100,1),(422,7476720,7476719,'201',50,1),(422,7476721,7476719,'013',50,1),(422,7476722,7476720,'adm',33.333,3),(422,7476723,7476720,'dmi',33.333,3),(422,7476724,7476720,'min',33.333,3),(422,7476725,7476722,'cap',16.667,1),(422,7476726,7476722,'apa',16.667,1),(422,7476727,7476722,'pac',16.667,1),(422,7476728,7476722,'aci',16.667,1),(422,7476729,7476722,'cit',16.667,1),(422,7476730,7476722,'ity',16.667,1),(422,7476731,7476725,'pat',50,1),(422,7476732,7476725,'ath',50,1),(422,7476733,7476731,'fre',14.286,1),(422,7476734,7476731,'ree',14.286,1),(422,7476735,7476731,'ees',14.286,1),(422,7476736,7476731,'esp',14.286,1),(422,7476737,7476731,'spa',14.286,1),(422,7476738,7476731,'pac',14.286,1),(422,7476739,7476731,'ace',14.286,1),(422,7476740,7476733,'dis',50,1),(422,7476741,7476733,'isk',50,1),(422,7476742,7476740,'ind',33.333,1),(422,7476743,7476740,'nde',33.333,1),(422,7476744,7476740,'dex',33.333,1),(422,7476745,7476742,'adm',8.333,1),(422,7476746,7476742,'dmi',8.333,1),(422,7476747,7476742,'min',8.333,1),(422,7476748,7476742,'ini',8.333,1),(422,7476749,7476742,'nis',8.333,1),(422,7476750,7476742,'ist',8.333,1),(422,7476751,7476742,'str',8.333,1),(422,7476752,7476742,'tra',8.333,1),(422,7476753,7476742,'rat',8.333,1),(422,7476754,7476742,'ati',8.333,1),(422,7476755,7476742,'tio',8.333,1),(422,7476756,7476742,'ion',8.333,1),(422,7476757,7476745,'sta',33.333,3),(422,7476758,7476745,'tat',33.333,3),(422,7476759,7476745,'ate',33.333,3),(422,7476760,7476757,'ena',20,2),(422,7476761,7476757,'nab',20,2),(422,7476762,7476757,'abl',20,2),(422,7476763,7476757,'ble',20,2),(422,7476764,7476757,'led',20,2),(422,7476765,7476760,'cac',33.333,2),(422,7476766,7476760,'ach',33.333,2),(422,7476767,7476760,'che',33.333,2),(422,7476768,7476765,'mod',50,1),(422,7476769,7476765,'ode',50,1),(422,7476770,7476768,'wri',14.286,1),(422,7476771,7476768,'rit',14.286,1),(422,7476772,7476768,'ite',14.286,1),(422,7476773,7476768,'tet',14.286,1),(422,7476774,7476768,'eth',14.286,1),(422,7476775,7476768,'thr',14.286,1),(422,7476776,7476768,'hru',14.286,1),(422,7476777,7476770,'ope',11.111,2),(422,7476778,7476770,'per',11.111,2),(422,7476779,7476770,'era',11.111,2),(422,7476780,7476770,'rat',11.111,2),(422,7476781,7476770,'ati',11.111,2),(422,7476782,7476770,'tio',11.111,2),(422,7476783,7476770,'ion',11.111,2),(422,7476784,7476770,'ona',11.111,2),(422,7476785,7476770,'nal',11.111,2),(422,7476786,7476777,'pen',20,1),(422,7476787,7476777,'end',20,1),(422,7476788,7476777,'ndi',20,1),(422,7476789,7476777,'din',20,1),(422,7476790,7476777,'ing',20,1),(422,7476791,7476786,'mes',20,1),(422,7476792,7476786,'ess',20,1),(422,7476793,7476786,'ssa',20,1),(422,7476794,7476786,'sag',20,1),(422,7476795,7476786,'age',20,1),(422,7476796,7476791,'wai',20,1),(422,7476797,7476791,'ait',20,1),(422,7476798,7476791,'iti',20,1),(422,7476799,7476791,'tin',20,1),(422,7476800,7476791,'ing',20,1),(422,7476801,7476796,'for',100,1),(422,7476802,7476801,'per',11.111,1),(422,7476803,7476801,'erf',11.111,1),(422,7476804,7476801,'rfo',11.111,1),(422,7476805,7476801,'for',11.111,1),(422,7476806,7476801,'orm',11.111,1),(422,7476807,7476801,'rma',11.111,1),(422,7476808,7476801,'man',11.111,1),(422,7476809,7476801,'anc',11.111,1),(422,7476810,7476801,'nce',11.111,1),(422,7476811,7476802,'ide',12.5,1),(422,7476812,7476802,'den',12.5,1),(422,7476813,7476802,'ent',12.5,1),(422,7476814,7476802,'nti',12.5,1),(422,7476815,7476802,'tif',12.5,1),(422,7476816,7476802,'ifi',12.5,1),(422,7476817,7476802,'fie',12.5,1),(422,7476818,7476802,'ier',12.5,1),(422,7476819,7476811,'vdi',33.333,3),(422,7476820,7476811,'dis',33.333,3),(422,7476821,7476811,'isk',33.333,3),(422,7476822,7476819,'nam',50,1),(422,7476823,7476819,'ame',50,1),(422,7476824,7476822,'typ',50,1),(422,7476825,7476822,'ype',50,1),(422,7476826,7476824,'dir',25,1),(422,7476827,7476824,'ire',25,1),(422,7476828,7476824,'rec',25,1),(422,7476829,7476824,'ect',25,1),(423,7476831,7476830,'naa',100,2),(423,7476832,7476831,'600',3.333,3),(423,7476833,7476831,'000',3.333,3),(423,7476834,7476831,'00c',3.333,3),(423,7476835,7476831,'0c2',3.333,3),(423,7476836,7476831,'c29',3.333,3),(423,7476837,7476831,'294',3.333,3),(423,7476838,7476831,'94d',3.333,3),(423,7476839,7476831,'4dd',3.333,3),(423,7476840,7476831,'dd9',3.333,3),(423,7476841,7476831,'d93',3.333,3),(423,7476842,7476831,'93e',3.333,3),(423,7476843,7476831,'3e7',3.333,3),(423,7476844,7476831,'e79',3.333,3),(423,7476845,7476831,'797',3.333,3),(423,7476846,7476831,'979',3.333,3),(423,7476847,7476831,'791',3.333,3),(423,7476848,7476831,'915',3.333,3),(423,7476849,7476831,'152',3.333,3),(423,7476850,7476831,'523',3.333,3),(423,7476851,7476831,'23a',3.333,3),(423,7476852,7476831,'3ad',3.333,3),(423,7476853,7476831,'ad9',3.333,3),(423,7476854,7476831,'d94',3.333,3),(423,7476855,7476831,'946',3.333,3),(423,7476856,7476831,'469',3.333,3),(423,7476857,7476831,'69f',3.333,3),(423,7476858,7476831,'9f1',3.333,3),(423,7476859,7476831,'f15',3.333,3),(423,7476860,7476831,'153',3.333,3),(423,7476861,7476831,'531',3.333,3),(423,7476862,7476832,'mon',100,1),(423,7476863,7476862,'201',50,1),(423,7476864,7476862,'013',50,1),(423,7476865,7476863,'adm',33.333,3),(423,7476866,7476863,'dmi',33.333,3),(423,7476867,7476863,'min',33.333,3),(423,7476868,7476865,'cap',16.667,1),(423,7476869,7476865,'apa',16.667,1),(423,7476870,7476865,'pac',16.667,1),(423,7476871,7476865,'aci',16.667,1),(423,7476872,7476865,'cit',16.667,1),(423,7476873,7476865,'ity',16.667,1),(423,7476874,7476868,'pat',50,1),(423,7476875,7476868,'ath',50,1),(423,7476876,7476874,'fre',14.286,1),(423,7476877,7476874,'ree',14.286,1),(423,7476878,7476874,'ees',14.286,1),(423,7476879,7476874,'esp',14.286,1),(423,7476880,7476874,'spa',14.286,1),(423,7476881,7476874,'pac',14.286,1),(423,7476882,7476874,'ace',14.286,1),(423,7476883,7476876,'dis',50,1),(423,7476884,7476876,'isk',50,1),(423,7476885,7476883,'ind',33.333,1),(423,7476886,7476883,'nde',33.333,1),(423,7476887,7476883,'dex',33.333,1),(423,7476888,7476885,'adm',8.333,1),(423,7476889,7476885,'dmi',8.333,1),(423,7476890,7476885,'min',8.333,1),(423,7476891,7476885,'ini',8.333,1),(423,7476892,7476885,'nis',8.333,1),(423,7476893,7476885,'ist',8.333,1),(423,7476894,7476885,'str',8.333,1),(423,7476895,7476885,'tra',8.333,1),(423,7476896,7476885,'rat',8.333,1),(423,7476897,7476885,'ati',8.333,1),(423,7476898,7476885,'tio',8.333,1),(423,7476899,7476885,'ion',8.333,1),(423,7476900,7476888,'sta',33.333,3),(423,7476901,7476888,'tat',33.333,3),(423,7476902,7476888,'ate',33.333,3),(423,7476903,7476900,'ena',20,2),(423,7476904,7476900,'nab',20,2),(423,7476905,7476900,'abl',20,2),(423,7476906,7476900,'ble',20,2),(423,7476907,7476900,'led',20,2),(423,7476908,7476903,'cac',33.333,2),(423,7476909,7476903,'ach',33.333,2),(423,7476910,7476903,'che',33.333,2),(423,7476911,7476908,'mod',50,1),(423,7476912,7476908,'ode',50,1),(423,7476913,7476911,'wri',14.286,1),(423,7476914,7476911,'rit',14.286,1),(423,7476915,7476911,'ite',14.286,1),(423,7476916,7476911,'tet',14.286,1),(423,7476917,7476911,'eth',14.286,1),(423,7476918,7476911,'thr',14.286,1),(423,7476919,7476911,'hru',14.286,1),(423,7476920,7476913,'ope',11.111,2),(423,7476921,7476913,'per',11.111,2),(423,7476922,7476913,'era',11.111,2),(423,7476923,7476913,'rat',11.111,2),(423,7476924,7476913,'ati',11.111,2),(423,7476925,7476913,'tio',11.111,2),(423,7476926,7476913,'ion',11.111,2),(423,7476927,7476913,'ona',11.111,2),(423,7476928,7476913,'nal',11.111,2),(423,7476929,7476920,'pen',20,1),(423,7476930,7476920,'end',20,1),(423,7476931,7476920,'ndi',20,1),(423,7476932,7476920,'din',20,1),(423,7476933,7476920,'ing',20,1),(423,7476934,7476929,'mes',20,1),(423,7476935,7476929,'ess',20,1),(423,7476936,7476929,'ssa',20,1),(423,7476937,7476929,'sag',20,1),(423,7476938,7476929,'age',20,1),(423,7476939,7476934,'wai',20,1),(423,7476940,7476934,'ait',20,1),(423,7476941,7476934,'iti',20,1),(423,7476942,7476934,'tin',20,1),(423,7476943,7476934,'ing',20,1),(423,7476944,7476939,'for',100,1),(423,7476945,7476944,'per',11.111,1),(423,7476946,7476944,'erf',11.111,1),(423,7476947,7476944,'rfo',11.111,1),(423,7476948,7476944,'for',11.111,1),(423,7476949,7476944,'orm',11.111,1),(423,7476950,7476944,'rma',11.111,1),(423,7476951,7476944,'man',11.111,1),(423,7476952,7476944,'anc',11.111,1),(423,7476953,7476944,'nce',11.111,1),(423,7476954,7476945,'ide',12.5,1),(423,7476955,7476945,'den',12.5,1),(423,7476956,7476945,'ent',12.5,1),(423,7476957,7476945,'nti',12.5,1),(423,7476958,7476945,'tif',12.5,1),(423,7476959,7476945,'ifi',12.5,1),(423,7476960,7476945,'fie',12.5,1),(423,7476961,7476945,'ier',12.5,1),(423,7476962,7476954,'vdi',33.333,3),(423,7476963,7476954,'dis',33.333,3),(423,7476964,7476954,'isk',33.333,3),(423,7476965,7476962,'nam',50,1),(423,7476966,7476962,'ame',50,1),(423,7476967,7476965,'typ',50,1),(423,7476968,7476965,'ype',50,1),(423,7476969,7476967,'dir',25,1),(423,7476970,7476967,'ire',25,1),(423,7476971,7476967,'rec',25,1),(423,7476972,7476967,'ect',25,1),(424,7476974,7476973,'naa',100,2),(424,7476975,7476974,'600',3.333,3),(424,7476976,7476974,'000',3.333,3),(424,7476977,7476974,'00c',3.333,3),(424,7476978,7476974,'0c2',3.333,3),(424,7476979,7476974,'c29',3.333,3),(424,7476980,7476974,'296',3.333,3),(424,7476981,7476974,'967',3.333,3),(424,7476982,7476974,'678',3.333,3),(424,7476983,7476974,'784',3.333,3),(424,7476984,7476974,'84e',3.333,3),(424,7476985,7476974,'4e9',3.333,3),(424,7476986,7476974,'e9d',3.333,3),(424,7476987,7476974,'9dc',3.333,3),(424,7476988,7476974,'dc1',3.333,3),(424,7476989,7476974,'c12',3.333,3),(424,7476990,7476974,'125',3.333,3),(424,7476991,7476974,'250',3.333,3),(424,7476992,7476974,'50b',3.333,3),(424,7476993,7476974,'0b3',3.333,3),(424,7476994,7476974,'b32',3.333,3),(424,7476995,7476974,'321',3.333,3),(424,7476996,7476974,'216',3.333,3),(424,7476997,7476974,'167',3.333,3),(424,7476998,7476974,'678',3.333,3),(424,7476999,7476974,'789',3.333,3),(424,7477000,7476974,'896',3.333,3),(424,7477001,7476974,'969',3.333,3),(424,7477002,7476974,'698',3.333,3),(424,7477003,7476974,'98b',3.333,3),(424,7477004,7476974,'8b6',3.333,3),(424,7477005,7476975,'mon',100,1),(424,7477006,7477005,'201',50,1),(424,7477007,7477005,'013',50,1),(424,7477008,7477006,'adm',33.333,3),(424,7477009,7477006,'dmi',33.333,3),(424,7477010,7477006,'min',33.333,3),(424,7477011,7477008,'cap',16.667,1),(424,7477012,7477008,'apa',16.667,1),(424,7477013,7477008,'pac',16.667,1),(424,7477014,7477008,'aci',16.667,1),(424,7477015,7477008,'cit',16.667,1),(424,7477016,7477008,'ity',16.667,1),(424,7477017,7477011,'pat',50,1),(424,7477018,7477011,'ath',50,1),(424,7477019,7477017,'fre',14.286,1),(424,7477020,7477017,'ree',14.286,1),(424,7477021,7477017,'ees',14.286,1),(424,7477022,7477017,'esp',14.286,1),(424,7477023,7477017,'spa',14.286,1),(424,7477024,7477017,'pac',14.286,1),(424,7477025,7477017,'ace',14.286,1),(424,7477026,7477019,'dis',50,1),(424,7477027,7477019,'isk',50,1),(424,7477028,7477026,'ind',33.333,1),(424,7477029,7477026,'nde',33.333,1),(424,7477030,7477026,'dex',33.333,1),(424,7477031,7477028,'adm',8.333,1),(424,7477032,7477028,'dmi',8.333,1),(424,7477033,7477028,'min',8.333,1),(424,7477034,7477028,'ini',8.333,1),(424,7477035,7477028,'nis',8.333,1),(424,7477036,7477028,'ist',8.333,1),(424,7477037,7477028,'str',8.333,1),(424,7477038,7477028,'tra',8.333,1),(424,7477039,7477028,'rat',8.333,1),(424,7477040,7477028,'ati',8.333,1),(424,7477041,7477028,'tio',8.333,1),(424,7477042,7477028,'ion',8.333,1),(424,7477043,7477031,'sta',33.333,3),(424,7477044,7477031,'tat',33.333,3),(424,7477045,7477031,'ate',33.333,3),(424,7477046,7477043,'ena',20,2),(424,7477047,7477043,'nab',20,2),(424,7477048,7477043,'abl',20,2),(424,7477049,7477043,'ble',20,2),(424,7477050,7477043,'led',20,2),(424,7477051,7477046,'cac',33.333,2),(424,7477052,7477046,'ach',33.333,2),(424,7477053,7477046,'che',33.333,2),(424,7477054,7477051,'mod',50,1),(424,7477055,7477051,'ode',50,1),(424,7477056,7477054,'wri',14.286,1),(424,7477057,7477054,'rit',14.286,1),(424,7477058,7477054,'ite',14.286,1),(424,7477059,7477054,'tet',14.286,1),(424,7477060,7477054,'eth',14.286,1),(424,7477061,7477054,'thr',14.286,1),(424,7477062,7477054,'hru',14.286,1),(424,7477063,7477056,'ope',11.111,2),(424,7477064,7477056,'per',11.111,2),(424,7477065,7477056,'era',11.111,2),(424,7477066,7477056,'rat',11.111,2),(424,7477067,7477056,'ati',11.111,2),(424,7477068,7477056,'tio',11.111,2),(424,7477069,7477056,'ion',11.111,2),(424,7477070,7477056,'ona',11.111,2),(424,7477071,7477056,'nal',11.111,2),(424,7477072,7477063,'pen',20,1),(424,7477073,7477063,'end',20,1),(424,7477074,7477063,'ndi',20,1),(424,7477075,7477063,'din',20,1),(424,7477076,7477063,'ing',20,1),(424,7477077,7477072,'mes',20,1),(424,7477078,7477072,'ess',20,1),(424,7477079,7477072,'ssa',20,1),(424,7477080,7477072,'sag',20,1),(424,7477081,7477072,'age',20,1),(424,7477082,7477077,'wai',20,1),(424,7477083,7477077,'ait',20,1),(424,7477084,7477077,'iti',20,1),(424,7477085,7477077,'tin',20,1),(424,7477086,7477077,'ing',20,1),(424,7477087,7477082,'for',100,1),(424,7477088,7477087,'per',11.111,1),(424,7477089,7477087,'erf',11.111,1),(424,7477090,7477087,'rfo',11.111,1),(424,7477091,7477087,'for',11.111,1),(424,7477092,7477087,'orm',11.111,1),(424,7477093,7477087,'rma',11.111,1),(424,7477094,7477087,'man',11.111,1),(424,7477095,7477087,'anc',11.111,1),(424,7477096,7477087,'nce',11.111,1),(424,7477097,7477088,'ide',12.5,1),(424,7477098,7477088,'den',12.5,1),(424,7477099,7477088,'ent',12.5,1),(424,7477100,7477088,'nti',12.5,1),(424,7477101,7477088,'tif',12.5,1),(424,7477102,7477088,'ifi',12.5,1),(424,7477103,7477088,'fie',12.5,1),(424,7477104,7477088,'ier',12.5,1),(424,7477105,7477097,'vdi',33.333,3),(424,7477106,7477097,'dis',33.333,3),(424,7477107,7477097,'isk',33.333,3),(424,7477108,7477105,'nam',50,1),(424,7477109,7477105,'ame',50,1),(424,7477110,7477108,'typ',50,1),(424,7477111,7477108,'ype',50,1),(424,7477112,7477110,'dir',25,1),(424,7477113,7477110,'ire',25,1),(424,7477114,7477110,'rec',25,1),(424,7477115,7477110,'ect',25,1),(425,7477117,7477116,'naa',100,2),(425,7477118,7477117,'600',3.333,3),(425,7477119,7477117,'000',3.333,3),(425,7477120,7477117,'00c',3.333,3),(425,7477121,7477117,'0c2',3.333,3),(425,7477122,7477117,'c29',3.333,3),(425,7477123,7477117,'296',3.333,3),(425,7477124,7477117,'963',3.333,3),(425,7477125,7477117,'630',3.333,3),(425,7477126,7477117,'30b',3.333,3),(425,7477127,7477117,'0b2',3.333,3),(425,7477128,7477117,'b20',3.333,3),(425,7477129,7477117,'208',3.333,3),(425,7477130,7477117,'08c',3.333,3),(425,7477131,7477117,'8cc',3.333,3),(425,7477132,7477117,'cce',3.333,3),(425,7477133,7477117,'cee',3.333,3),(425,7477134,7477117,'ee2',3.333,3),(425,7477135,7477117,'e2b',3.333,3),(425,7477136,7477117,'2b1',3.333,3),(425,7477137,7477117,'b19',3.333,3),(425,7477138,7477117,'19c',3.333,3),(425,7477139,7477117,'9c7',3.333,3),(425,7477140,7477117,'c70',3.333,3),(425,7477141,7477117,'705',3.333,3),(425,7477142,7477117,'051',3.333,3),(425,7477143,7477117,'51c',3.333,3),(425,7477144,7477117,'1c2',3.333,3),(425,7477145,7477117,'c21',3.333,3),(425,7477146,7477117,'217',3.333,3),(425,7477147,7477117,'179',3.333,3),(425,7477148,7477118,'mon',100,1),(425,7477149,7477148,'201',50,1),(425,7477150,7477148,'013',50,1),(425,7477151,7477149,'adm',33.333,3),(425,7477152,7477149,'dmi',33.333,3),(425,7477153,7477149,'min',33.333,3),(425,7477154,7477151,'cap',16.667,1),(425,7477155,7477151,'apa',16.667,1),(425,7477156,7477151,'pac',16.667,1),(425,7477157,7477151,'aci',16.667,1),(425,7477158,7477151,'cit',16.667,1),(425,7477159,7477151,'ity',16.667,1),(425,7477160,7477154,'pat',50,1),(425,7477161,7477154,'ath',50,1),(425,7477162,7477160,'fre',14.286,1),(425,7477163,7477160,'ree',14.286,1),(425,7477164,7477160,'ees',14.286,1),(425,7477165,7477160,'esp',14.286,1),(425,7477166,7477160,'spa',14.286,1),(425,7477167,7477160,'pac',14.286,1),(425,7477168,7477160,'ace',14.286,1),(425,7477169,7477162,'dis',50,1),(425,7477170,7477162,'isk',50,1),(425,7477171,7477169,'ind',33.333,1),(425,7477172,7477169,'nde',33.333,1),(425,7477173,7477169,'dex',33.333,1),(425,7477174,7477171,'adm',8.333,1),(425,7477175,7477171,'dmi',8.333,1),(425,7477176,7477171,'min',8.333,1),(425,7477177,7477171,'ini',8.333,1),(425,7477178,7477171,'nis',8.333,1),(425,7477179,7477171,'ist',8.333,1),(425,7477180,7477171,'str',8.333,1),(425,7477181,7477171,'tra',8.333,1),(425,7477182,7477171,'rat',8.333,1),(425,7477183,7477171,'ati',8.333,1),(425,7477184,7477171,'tio',8.333,1),(425,7477185,7477171,'ion',8.333,1),(425,7477186,7477174,'sta',33.333,3),(425,7477187,7477174,'tat',33.333,3),(425,7477188,7477174,'ate',33.333,3),(425,7477189,7477186,'ena',20,2),(425,7477190,7477186,'nab',20,2),(425,7477191,7477186,'abl',20,2),(425,7477192,7477186,'ble',20,2),(425,7477193,7477186,'led',20,2),(425,7477194,7477189,'cac',33.333,2),(425,7477195,7477189,'ach',33.333,2),(425,7477196,7477189,'che',33.333,2),(425,7477197,7477194,'mod',50,1),(425,7477198,7477194,'ode',50,1),(425,7477199,7477197,'wri',14.286,1),(425,7477200,7477197,'rit',14.286,1),(425,7477201,7477197,'ite',14.286,1),(425,7477202,7477197,'tet',14.286,1),(425,7477203,7477197,'eth',14.286,1),(425,7477204,7477197,'thr',14.286,1),(425,7477205,7477197,'hru',14.286,1),(425,7477206,7477199,'ope',11.111,2),(425,7477207,7477199,'per',11.111,2),(425,7477208,7477199,'era',11.111,2),(425,7477209,7477199,'rat',11.111,2),(425,7477210,7477199,'ati',11.111,2),(425,7477211,7477199,'tio',11.111,2),(425,7477212,7477199,'ion',11.111,2),(425,7477213,7477199,'ona',11.111,2),(425,7477214,7477199,'nal',11.111,2),(425,7477215,7477206,'pen',20,1),(425,7477216,7477206,'end',20,1),(425,7477217,7477206,'ndi',20,1),(425,7477218,7477206,'din',20,1),(425,7477219,7477206,'ing',20,1),(425,7477220,7477215,'mes',20,1),(425,7477221,7477215,'ess',20,1),(425,7477222,7477215,'ssa',20,1),(425,7477223,7477215,'sag',20,1),(425,7477224,7477215,'age',20,1),(425,7477225,7477220,'wai',20,1),(425,7477226,7477220,'ait',20,1),(425,7477227,7477220,'iti',20,1),(425,7477228,7477220,'tin',20,1),(425,7477229,7477220,'ing',20,1),(425,7477230,7477225,'for',100,1),(425,7477231,7477230,'per',11.111,1),(425,7477232,7477230,'erf',11.111,1),(425,7477233,7477230,'rfo',11.111,1),(425,7477234,7477230,'for',11.111,1),(425,7477235,7477230,'orm',11.111,1),(425,7477236,7477230,'rma',11.111,1),(425,7477237,7477230,'man',11.111,1),(425,7477238,7477230,'anc',11.111,1),(425,7477239,7477230,'nce',11.111,1),(425,7477240,7477231,'ide',12.5,1),(425,7477241,7477231,'den',12.5,1),(425,7477242,7477231,'ent',12.5,1),(425,7477243,7477231,'nti',12.5,1),(425,7477244,7477231,'tif',12.5,1),(425,7477245,7477231,'ifi',12.5,1),(425,7477246,7477231,'fie',12.5,1),(425,7477247,7477231,'ier',12.5,1),(425,7477248,7477240,'vdi',33.333,3),(425,7477249,7477240,'dis',33.333,3),(425,7477250,7477240,'isk',33.333,3),(425,7477251,7477248,'nam',50,1),(425,7477252,7477248,'ame',50,1),(425,7477253,7477251,'typ',50,1),(425,7477254,7477251,'ype',50,1),(425,7477255,7477253,'dir',25,1),(425,7477256,7477253,'ire',25,1),(425,7477257,7477253,'rec',25,1),(425,7477258,7477253,'ect',25,1),(426,7477260,7477259,'naa',100,2),(426,7477261,7477260,'600',3.333,3),(426,7477262,7477260,'000',3.333,3),(426,7477263,7477260,'00c',3.333,3),(426,7477264,7477260,'0c2',3.333,3),(426,7477265,7477260,'c29',3.333,3),(426,7477266,7477260,'29a',3.333,3),(426,7477267,7477260,'9a8',3.333,3),(426,7477268,7477260,'a8f',3.333,3),(426,7477269,7477260,'8fe',3.333,3),(426,7477270,7477260,'feb',3.333,3),(426,7477271,7477260,'eb6',3.333,3),(426,7477272,7477260,'b68',3.333,3),(426,7477273,7477260,'685',3.333,3),(426,7477274,7477260,'850',3.333,3),(426,7477275,7477260,'507',3.333,3),(426,7477276,7477260,'079',3.333,3),(426,7477277,7477260,'799',3.333,3),(426,7477278,7477260,'998',3.333,3),(426,7477279,7477260,'98c',3.333,3),(426,7477280,7477260,'8c1',3.333,3),(426,7477281,7477260,'c1e',3.333,3),(426,7477282,7477260,'1e5',3.333,3),(426,7477283,7477260,'e50',3.333,3),(426,7477284,7477260,'500',3.333,3),(426,7477285,7477260,'005',3.333,3),(426,7477286,7477260,'05c',3.333,3),(426,7477287,7477260,'5c8',3.333,3),(426,7477288,7477260,'c8d',3.333,3),(426,7477289,7477260,'8d6',3.333,3),(426,7477290,7477260,'d6a',3.333,3),(426,7477291,7477261,'mon',100,1),(426,7477292,7477291,'201',50,1),(426,7477293,7477291,'013',50,1),(426,7477294,7477292,'adm',33.333,3),(426,7477295,7477292,'dmi',33.333,3),(426,7477296,7477292,'min',33.333,3),(426,7477297,7477294,'cap',16.667,1),(426,7477298,7477294,'apa',16.667,1),(426,7477299,7477294,'pac',16.667,1),(426,7477300,7477294,'aci',16.667,1),(426,7477301,7477294,'cit',16.667,1),(426,7477302,7477294,'ity',16.667,1),(426,7477303,7477297,'pat',50,1),(426,7477304,7477297,'ath',50,1),(426,7477305,7477303,'fre',14.286,1),(426,7477306,7477303,'ree',14.286,1),(426,7477307,7477303,'ees',14.286,1),(426,7477308,7477303,'esp',14.286,1),(426,7477309,7477303,'spa',14.286,1),(426,7477310,7477303,'pac',14.286,1),(426,7477311,7477303,'ace',14.286,1),(426,7477312,7477305,'dis',50,1),(426,7477313,7477305,'isk',50,1),(426,7477314,7477312,'ind',33.333,1),(426,7477315,7477312,'nde',33.333,1),(426,7477316,7477312,'dex',33.333,1),(426,7477317,7477314,'adm',8.333,1),(426,7477318,7477314,'dmi',8.333,1),(426,7477319,7477314,'min',8.333,1),(426,7477320,7477314,'ini',8.333,1),(426,7477321,7477314,'nis',8.333,1),(426,7477322,7477314,'ist',8.333,1),(426,7477323,7477314,'str',8.333,1),(426,7477324,7477314,'tra',8.333,1),(426,7477325,7477314,'rat',8.333,1),(426,7477326,7477314,'ati',8.333,1),(426,7477327,7477314,'tio',8.333,1),(426,7477328,7477314,'ion',8.333,1),(426,7477329,7477317,'sta',33.333,3),(426,7477330,7477317,'tat',33.333,3),(426,7477331,7477317,'ate',33.333,3),(426,7477332,7477329,'ena',20,2),(426,7477333,7477329,'nab',20,2),(426,7477334,7477329,'abl',20,2),(426,7477335,7477329,'ble',20,2),(426,7477336,7477329,'led',20,2),(426,7477337,7477332,'cac',33.333,2),(426,7477338,7477332,'ach',33.333,2),(426,7477339,7477332,'che',33.333,2),(426,7477340,7477337,'mod',50,1),(426,7477341,7477337,'ode',50,1),(426,7477342,7477340,'wri',14.286,1),(426,7477343,7477340,'rit',14.286,1),(426,7477344,7477340,'ite',14.286,1),(426,7477345,7477340,'tet',14.286,1),(426,7477346,7477340,'eth',14.286,1),(426,7477347,7477340,'thr',14.286,1),(426,7477348,7477340,'hru',14.286,1),(426,7477349,7477342,'ope',11.111,2),(426,7477350,7477342,'per',11.111,2),(426,7477351,7477342,'era',11.111,2),(426,7477352,7477342,'rat',11.111,2),(426,7477353,7477342,'ati',11.111,2),(426,7477354,7477342,'tio',11.111,2),(426,7477355,7477342,'ion',11.111,2),(426,7477356,7477342,'ona',11.111,2),(426,7477357,7477342,'nal',11.111,2),(426,7477358,7477349,'pen',20,1),(426,7477359,7477349,'end',20,1),(426,7477360,7477349,'ndi',20,1),(426,7477361,7477349,'din',20,1),(426,7477362,7477349,'ing',20,1),(426,7477363,7477358,'mes',20,1),(426,7477364,7477358,'ess',20,1),(426,7477365,7477358,'ssa',20,1),(426,7477366,7477358,'sag',20,1),(426,7477367,7477358,'age',20,1),(426,7477368,7477363,'wai',20,1),(426,7477369,7477363,'ait',20,1),(426,7477370,7477363,'iti',20,1),(426,7477371,7477363,'tin',20,1),(426,7477372,7477363,'ing',20,1),(426,7477373,7477368,'for',100,1),(426,7477374,7477373,'per',11.111,1),(426,7477375,7477373,'erf',11.111,1),(426,7477376,7477373,'rfo',11.111,1),(426,7477377,7477373,'for',11.111,1),(426,7477378,7477373,'orm',11.111,1),(426,7477379,7477373,'rma',11.111,1),(426,7477380,7477373,'man',11.111,1),(426,7477381,7477373,'anc',11.111,1),(426,7477382,7477373,'nce',11.111,1),(426,7477383,7477374,'ide',12.5,1),(426,7477384,7477374,'den',12.5,1),(426,7477385,7477374,'ent',12.5,1),(426,7477386,7477374,'nti',12.5,1),(426,7477387,7477374,'tif',12.5,1),(426,7477388,7477374,'ifi',12.5,1),(426,7477389,7477374,'fie',12.5,1),(426,7477390,7477374,'ier',12.5,1),(426,7477391,7477383,'vdi',33.333,3),(426,7477392,7477383,'dis',33.333,3),(426,7477393,7477383,'isk',33.333,3),(426,7477394,7477391,'nam',50,1),(426,7477395,7477391,'ame',50,1),(426,7477396,7477394,'typ',50,1),(426,7477397,7477394,'ype',50,1),(426,7477398,7477396,'dir',25,1),(426,7477399,7477396,'ire',25,1),(426,7477400,7477396,'rec',25,1),(426,7477401,7477396,'ect',25,1),(427,7477403,7477402,'naa',100,2),(427,7477404,7477403,'600',3.333,3),(427,7477405,7477403,'000',3.333,3),(427,7477406,7477403,'00c',3.333,3),(427,7477407,7477403,'0c2',3.333,3),(427,7477408,7477403,'c29',3.333,3),(427,7477409,7477403,'294',3.333,3),(427,7477410,7477403,'942',3.333,3),(427,7477411,7477403,'428',3.333,3),(427,7477412,7477403,'28a',3.333,3),(427,7477413,7477403,'8a9',3.333,3),(427,7477414,7477403,'a92',3.333,3),(427,7477415,7477403,'929',3.333,3),(427,7477416,7477403,'292',3.333,3),(427,7477417,7477403,'925',3.333,3),(427,7477418,7477403,'259',3.333,3),(427,7477419,7477403,'59b',3.333,3),(427,7477420,7477403,'9bd',3.333,3),(427,7477421,7477403,'bdf',3.333,3),(427,7477422,7477403,'df1',3.333,3),(427,7477423,7477403,'f1e',3.333,3),(427,7477424,7477403,'1e3',3.333,3),(427,7477425,7477403,'e33',3.333,3),(427,7477426,7477403,'335',3.333,3),(427,7477427,7477403,'35a',3.333,3),(427,7477428,7477403,'5a6',3.333,3),(427,7477429,7477403,'a6a',3.333,3),(427,7477430,7477403,'6a0',3.333,3),(427,7477431,7477403,'a0c',3.333,3),(427,7477432,7477403,'0cf',3.333,3),(427,7477433,7477403,'cf3',3.333,3),(427,7477434,7477404,'mon',100,1),(427,7477435,7477434,'201',50,1),(427,7477436,7477434,'013',50,1),(427,7477437,7477435,'adm',33.333,3),(427,7477438,7477435,'dmi',33.333,3),(427,7477439,7477435,'min',33.333,3),(427,7477440,7477437,'cap',16.667,1),(427,7477441,7477437,'apa',16.667,1),(427,7477442,7477437,'pac',16.667,1),(427,7477443,7477437,'aci',16.667,1),(427,7477444,7477437,'cit',16.667,1),(427,7477445,7477437,'ity',16.667,1),(427,7477446,7477440,'pat',50,1),(427,7477447,7477440,'ath',50,1),(427,7477448,7477446,'fre',14.286,1),(427,7477449,7477446,'ree',14.286,1),(427,7477450,7477446,'ees',14.286,1),(427,7477451,7477446,'esp',14.286,1),(427,7477452,7477446,'spa',14.286,1),(427,7477453,7477446,'pac',14.286,1),(427,7477454,7477446,'ace',14.286,1),(427,7477455,7477448,'dis',50,1),(427,7477456,7477448,'isk',50,1),(427,7477457,7477455,'ind',33.333,1),(427,7477458,7477455,'nde',33.333,1),(427,7477459,7477455,'dex',33.333,1),(427,7477460,7477457,'adm',8.333,1),(427,7477461,7477457,'dmi',8.333,1),(427,7477462,7477457,'min',8.333,1),(427,7477463,7477457,'ini',8.333,1),(427,7477464,7477457,'nis',8.333,1),(427,7477465,7477457,'ist',8.333,1),(427,7477466,7477457,'str',8.333,1),(427,7477467,7477457,'tra',8.333,1),(427,7477468,7477457,'rat',8.333,1),(427,7477469,7477457,'ati',8.333,1),(427,7477470,7477457,'tio',8.333,1),(427,7477471,7477457,'ion',8.333,1),(427,7477472,7477460,'sta',33.333,3),(427,7477473,7477460,'tat',33.333,3),(427,7477474,7477460,'ate',33.333,3),(427,7477475,7477472,'ena',20,2),(427,7477476,7477472,'nab',20,2),(427,7477477,7477472,'abl',20,2),(427,7477478,7477472,'ble',20,2),(427,7477479,7477472,'led',20,2),(427,7477480,7477475,'cac',33.333,2),(427,7477481,7477475,'ach',33.333,2),(427,7477482,7477475,'che',33.333,2),(427,7477483,7477480,'mod',50,1),(427,7477484,7477480,'ode',50,1),(427,7477485,7477483,'wri',14.286,1),(427,7477486,7477483,'rit',14.286,1),(427,7477487,7477483,'ite',14.286,1),(427,7477488,7477483,'tet',14.286,1),(427,7477489,7477483,'eth',14.286,1),(427,7477490,7477483,'thr',14.286,1),(427,7477491,7477483,'hru',14.286,1),(427,7477492,7477485,'ope',11.111,2),(427,7477493,7477485,'per',11.111,2),(427,7477494,7477485,'era',11.111,2),(427,7477495,7477485,'rat',11.111,2),(427,7477496,7477485,'ati',11.111,2),(427,7477497,7477485,'tio',11.111,2),(427,7477498,7477485,'ion',11.111,2),(427,7477499,7477485,'ona',11.111,2),(427,7477500,7477485,'nal',11.111,2),(427,7477501,7477492,'pen',20,1),(427,7477502,7477492,'end',20,1),(427,7477503,7477492,'ndi',20,1),(427,7477504,7477492,'din',20,1),(427,7477505,7477492,'ing',20,1),(427,7477506,7477501,'mes',20,1),(427,7477507,7477501,'ess',20,1),(427,7477508,7477501,'ssa',20,1),(427,7477509,7477501,'sag',20,1),(427,7477510,7477501,'age',20,1),(427,7477511,7477506,'wai',20,1),(427,7477512,7477506,'ait',20,1),(427,7477513,7477506,'iti',20,1),(427,7477514,7477506,'tin',20,1),(427,7477515,7477506,'ing',20,1),(427,7477516,7477511,'for',100,1),(427,7477517,7477516,'per',11.111,1),(427,7477518,7477516,'erf',11.111,1),(427,7477519,7477516,'rfo',11.111,1),(427,7477520,7477516,'for',11.111,1),(427,7477521,7477516,'orm',11.111,1),(427,7477522,7477516,'rma',11.111,1),(427,7477523,7477516,'man',11.111,1),(427,7477524,7477516,'anc',11.111,1),(427,7477525,7477516,'nce',11.111,1),(427,7477526,7477517,'ide',12.5,1),(427,7477527,7477517,'den',12.5,1),(427,7477528,7477517,'ent',12.5,1),(427,7477529,7477517,'nti',12.5,1),(427,7477530,7477517,'tif',12.5,1),(427,7477531,7477517,'ifi',12.5,1),(427,7477532,7477517,'fie',12.5,1),(427,7477533,7477517,'ier',12.5,1),(427,7477534,7477526,'vdi',33.333,3),(427,7477535,7477526,'dis',33.333,3),(427,7477536,7477526,'isk',33.333,3),(427,7477537,7477534,'nam',50,1),(427,7477538,7477534,'ame',50,1),(427,7477539,7477537,'typ',50,1),(427,7477540,7477537,'ype',50,1),(427,7477541,7477539,'dir',25,1),(427,7477542,7477539,'ire',25,1),(427,7477543,7477539,'rec',25,1),(427,7477544,7477539,'ect',25,1),(428,7477546,7477545,'naa',100,2),(428,7477547,7477546,'600',3.333,3),(428,7477548,7477546,'000',3.333,3),(428,7477549,7477546,'00c',3.333,3),(428,7477550,7477546,'0c2',3.333,3),(428,7477551,7477546,'c29',3.333,3),(428,7477552,7477546,'29f',3.333,3),(428,7477553,7477546,'9f5',3.333,3),(428,7477554,7477546,'f51',3.333,3),(428,7477555,7477546,'518',3.333,3),(428,7477556,7477546,'18a',3.333,3),(428,7477557,7477546,'8a6',3.333,3),(428,7477558,7477546,'a6b',3.333,3),(428,7477559,7477546,'6ba',3.333,3),(428,7477560,7477546,'ba4',3.333,3),(428,7477561,7477546,'a4c',3.333,3),(428,7477562,7477546,'4ce',3.333,3),(428,7477563,7477546,'ce7',3.333,3),(428,7477564,7477546,'e7d',3.333,3),(428,7477565,7477546,'7d3',3.333,3),(428,7477566,7477546,'d35',3.333,3),(428,7477567,7477546,'35a',3.333,3),(428,7477568,7477546,'5ae',3.333,3),(428,7477569,7477546,'ae9',3.333,3),(428,7477570,7477546,'e9a',3.333,3),(428,7477571,7477546,'9a5',3.333,3),(428,7477572,7477546,'a59',3.333,3),(428,7477573,7477546,'59d',3.333,3),(428,7477574,7477546,'9df',3.333,3),(428,7477575,7477546,'df2',3.333,3),(428,7477576,7477546,'f2f',3.333,3),(428,7477577,7477547,'mon',100,1),(428,7477578,7477577,'201',50,1),(428,7477579,7477577,'013',50,1),(428,7477580,7477578,'adm',33.333,3),(428,7477581,7477578,'dmi',33.333,3),(428,7477582,7477578,'min',33.333,3),(428,7477583,7477580,'cap',16.667,1),(428,7477584,7477580,'apa',16.667,1),(428,7477585,7477580,'pac',16.667,1),(428,7477586,7477580,'aci',16.667,1),(428,7477587,7477580,'cit',16.667,1),(428,7477588,7477580,'ity',16.667,1),(428,7477589,7477583,'pat',50,1),(428,7477590,7477583,'ath',50,1),(428,7477591,7477589,'fre',14.286,1),(428,7477592,7477589,'ree',14.286,1),(428,7477593,7477589,'ees',14.286,1),(428,7477594,7477589,'esp',14.286,1),(428,7477595,7477589,'spa',14.286,1),(428,7477596,7477589,'pac',14.286,1),(428,7477597,7477589,'ace',14.286,1),(428,7477598,7477591,'dis',50,1),(428,7477599,7477591,'isk',50,1),(428,7477600,7477598,'ind',33.333,1),(428,7477601,7477598,'nde',33.333,1),(428,7477602,7477598,'dex',33.333,1),(428,7477603,7477600,'adm',8.333,1),(428,7477604,7477600,'dmi',8.333,1),(428,7477605,7477600,'min',8.333,1),(428,7477606,7477600,'ini',8.333,1),(428,7477607,7477600,'nis',8.333,1),(428,7477608,7477600,'ist',8.333,1),(428,7477609,7477600,'str',8.333,1),(428,7477610,7477600,'tra',8.333,1),(428,7477611,7477600,'rat',8.333,1),(428,7477612,7477600,'ati',8.333,1),(428,7477613,7477600,'tio',8.333,1),(428,7477614,7477600,'ion',8.333,1),(428,7477615,7477603,'sta',33.333,3),(428,7477616,7477603,'tat',33.333,3),(428,7477617,7477603,'ate',33.333,3),(428,7477618,7477615,'ena',20,2),(428,7477619,7477615,'nab',20,2),(428,7477620,7477615,'abl',20,2),(428,7477621,7477615,'ble',20,2),(428,7477622,7477615,'led',20,2),(428,7477623,7477618,'cac',33.333,2),(428,7477624,7477618,'ach',33.333,2),(428,7477625,7477618,'che',33.333,2),(428,7477626,7477623,'mod',50,1),(428,7477627,7477623,'ode',50,1),(428,7477628,7477626,'wri',14.286,1),(428,7477629,7477626,'rit',14.286,1),(428,7477630,7477626,'ite',14.286,1),(428,7477631,7477626,'tet',14.286,1),(428,7477632,7477626,'eth',14.286,1),(428,7477633,7477626,'thr',14.286,1),(428,7477634,7477626,'hru',14.286,1),(428,7477635,7477628,'ope',11.111,2),(428,7477636,7477628,'per',11.111,2),(428,7477637,7477628,'era',11.111,2),(428,7477638,7477628,'rat',11.111,2),(428,7477639,7477628,'ati',11.111,2),(428,7477640,7477628,'tio',11.111,2),(428,7477641,7477628,'ion',11.111,2),(428,7477642,7477628,'ona',11.111,2),(428,7477643,7477628,'nal',11.111,2),(428,7477644,7477635,'pen',20,1),(428,7477645,7477635,'end',20,1),(428,7477646,7477635,'ndi',20,1),(428,7477647,7477635,'din',20,1),(428,7477648,7477635,'ing',20,1),(428,7477649,7477644,'mes',20,1),(428,7477650,7477644,'ess',20,1),(428,7477651,7477644,'ssa',20,1),(428,7477652,7477644,'sag',20,1),(428,7477653,7477644,'age',20,1),(428,7477654,7477649,'wai',20,1),(428,7477655,7477649,'ait',20,1),(428,7477656,7477649,'iti',20,1),(428,7477657,7477649,'tin',20,1),(428,7477658,7477649,'ing',20,1),(428,7477659,7477654,'for',100,1),(428,7477660,7477659,'per',11.111,1),(428,7477661,7477659,'erf',11.111,1),(428,7477662,7477659,'rfo',11.111,1),(428,7477663,7477659,'for',11.111,1),(428,7477664,7477659,'orm',11.111,1),(428,7477665,7477659,'rma',11.111,1),(428,7477666,7477659,'man',11.111,1),(428,7477667,7477659,'anc',11.111,1),(428,7477668,7477659,'nce',11.111,1),(428,7477669,7477660,'ide',12.5,1),(428,7477670,7477660,'den',12.5,1),(428,7477671,7477660,'ent',12.5,1),(428,7477672,7477660,'nti',12.5,1),(428,7477673,7477660,'tif',12.5,1),(428,7477674,7477660,'ifi',12.5,1),(428,7477675,7477660,'fie',12.5,1),(428,7477676,7477660,'ier',12.5,1),(428,7477677,7477669,'vdi',33.333,3),(428,7477678,7477669,'dis',33.333,3),(428,7477679,7477669,'isk',33.333,3),(428,7477680,7477677,'nam',50,1),(428,7477681,7477677,'ame',50,1),(428,7477682,7477680,'typ',50,1),(428,7477683,7477680,'ype',50,1),(428,7477684,7477682,'dir',25,1),(428,7477685,7477682,'ire',25,1),(428,7477686,7477682,'rec',25,1),(428,7477687,7477682,'ect',25,1),(429,7477689,7477688,'naa',100,2),(429,7477690,7477689,'600',3.333,3),(429,7477691,7477689,'000',3.333,3),(429,7477692,7477689,'00c',3.333,3),(429,7477693,7477689,'0c2',3.333,3),(429,7477694,7477689,'c29',3.333,3),(429,7477695,7477689,'295',3.333,3),(429,7477696,7477689,'95a',3.333,3),(429,7477697,7477689,'5a0',3.333,3),(429,7477698,7477689,'a0e',3.333,3),(429,7477699,7477689,'0ee',3.333,3),(429,7477700,7477689,'eeb',3.333,3),(429,7477701,7477689,'eb2',3.333,3),(429,7477702,7477689,'b2a',3.333,3),(429,7477703,7477689,'2a3',3.333,3),(429,7477704,7477689,'a32',3.333,3),(429,7477705,7477689,'325',3.333,3),(429,7477706,7477689,'25c',3.333,3),(429,7477707,7477689,'5ce',3.333,3),(429,7477708,7477689,'ce8',3.333,3),(429,7477709,7477689,'e87',3.333,3),(429,7477710,7477689,'87c',3.333,3),(429,7477711,7477689,'7cb',3.333,3),(429,7477712,7477689,'cb2',3.333,3),(429,7477713,7477689,'b26',3.333,3),(429,7477714,7477689,'26a',3.333,3),(429,7477715,7477689,'6a5',3.333,3),(429,7477716,7477689,'a56',3.333,3),(429,7477717,7477689,'569',3.333,3),(429,7477718,7477689,'69c',3.333,3),(429,7477719,7477689,'9cc',3.333,3),(429,7477720,7477690,'mon',100,1),(429,7477721,7477720,'201',50,1),(429,7477722,7477720,'013',50,1),(429,7477723,7477721,'adm',33.333,3),(429,7477724,7477721,'dmi',33.333,3),(429,7477725,7477721,'min',33.333,3),(429,7477726,7477723,'cap',16.667,1),(429,7477727,7477723,'apa',16.667,1),(429,7477728,7477723,'pac',16.667,1),(429,7477729,7477723,'aci',16.667,1),(429,7477730,7477723,'cit',16.667,1),(429,7477731,7477723,'ity',16.667,1),(429,7477732,7477726,'pat',50,1),(429,7477733,7477726,'ath',50,1),(429,7477734,7477732,'fre',14.286,1),(429,7477735,7477732,'ree',14.286,1),(429,7477736,7477732,'ees',14.286,1),(429,7477737,7477732,'esp',14.286,1),(429,7477738,7477732,'spa',14.286,1),(429,7477739,7477732,'pac',14.286,1),(429,7477740,7477732,'ace',14.286,1),(429,7477741,7477734,'dis',50,1),(429,7477742,7477734,'isk',50,1),(429,7477743,7477741,'ind',33.333,1),(429,7477744,7477741,'nde',33.333,1),(429,7477745,7477741,'dex',33.333,1),(429,7477746,7477743,'adm',8.333,1),(429,7477747,7477743,'dmi',8.333,1),(429,7477748,7477743,'min',8.333,1),(429,7477749,7477743,'ini',8.333,1),(429,7477750,7477743,'nis',8.333,1),(429,7477751,7477743,'ist',8.333,1),(429,7477752,7477743,'str',8.333,1),(429,7477753,7477743,'tra',8.333,1),(429,7477754,7477743,'rat',8.333,1),(429,7477755,7477743,'ati',8.333,1),(429,7477756,7477743,'tio',8.333,1),(429,7477757,7477743,'ion',8.333,1),(429,7477758,7477746,'sta',33.333,3),(429,7477759,7477746,'tat',33.333,3),(429,7477760,7477746,'ate',33.333,3),(429,7477761,7477758,'ena',20,2),(429,7477762,7477758,'nab',20,2),(429,7477763,7477758,'abl',20,2),(429,7477764,7477758,'ble',20,2),(429,7477765,7477758,'led',20,2),(429,7477766,7477761,'cac',33.333,2),(429,7477767,7477761,'ach',33.333,2),(429,7477768,7477761,'che',33.333,2),(429,7477769,7477766,'mod',50,1),(429,7477770,7477766,'ode',50,1),(429,7477771,7477769,'wri',14.286,1),(429,7477772,7477769,'rit',14.286,1),(429,7477773,7477769,'ite',14.286,1),(429,7477774,7477769,'tet',14.286,1),(429,7477775,7477769,'eth',14.286,1),(429,7477776,7477769,'thr',14.286,1),(429,7477777,7477769,'hru',14.286,1),(429,7477778,7477771,'ope',11.111,2),(429,7477779,7477771,'per',11.111,2),(429,7477780,7477771,'era',11.111,2),(429,7477781,7477771,'rat',11.111,2),(429,7477782,7477771,'ati',11.111,2),(429,7477783,7477771,'tio',11.111,2),(429,7477784,7477771,'ion',11.111,2),(429,7477785,7477771,'ona',11.111,2),(429,7477786,7477771,'nal',11.111,2),(429,7477787,7477778,'pen',20,1),(429,7477788,7477778,'end',20,1),(429,7477789,7477778,'ndi',20,1),(429,7477790,7477778,'din',20,1),(429,7477791,7477778,'ing',20,1),(429,7477792,7477787,'mes',20,1),(429,7477793,7477787,'ess',20,1),(429,7477794,7477787,'ssa',20,1),(429,7477795,7477787,'sag',20,1),(429,7477796,7477787,'age',20,1),(429,7477797,7477792,'wai',20,1),(429,7477798,7477792,'ait',20,1),(429,7477799,7477792,'iti',20,1),(429,7477800,7477792,'tin',20,1),(429,7477801,7477792,'ing',20,1),(429,7477802,7477797,'for',100,1),(429,7477803,7477802,'per',11.111,1),(429,7477804,7477802,'erf',11.111,1),(429,7477805,7477802,'rfo',11.111,1),(429,7477806,7477802,'for',11.111,1),(429,7477807,7477802,'orm',11.111,1),(429,7477808,7477802,'rma',11.111,1),(429,7477809,7477802,'man',11.111,1),(429,7477810,7477802,'anc',11.111,1),(429,7477811,7477802,'nce',11.111,1),(429,7477812,7477803,'ide',12.5,1),(429,7477813,7477803,'den',12.5,1),(429,7477814,7477803,'ent',12.5,1),(429,7477815,7477803,'nti',12.5,1),(429,7477816,7477803,'tif',12.5,1),(429,7477817,7477803,'ifi',12.5,1),(429,7477818,7477803,'fie',12.5,1),(429,7477819,7477803,'ier',12.5,1),(429,7477820,7477812,'vdi',33.333,3),(429,7477821,7477812,'dis',33.333,3),(429,7477822,7477812,'isk',33.333,3),(429,7477823,7477820,'nam',50,1),(429,7477824,7477820,'ame',50,1),(429,7477825,7477823,'typ',50,1),(429,7477826,7477823,'ype',50,1),(429,7477827,7477825,'dir',25,1),(429,7477828,7477825,'ire',25,1),(429,7477829,7477825,'rec',25,1),(429,7477830,7477825,'ect',25,1),(430,7477832,7477831,'naa',100,2),(430,7477833,7477832,'600',3.333,3),(430,7477834,7477832,'000',3.333,3),(430,7477835,7477832,'00c',3.333,3),(430,7477836,7477832,'0c2',3.333,3),(430,7477837,7477832,'c29',3.333,3),(430,7477838,7477832,'29f',3.333,3),(430,7477839,7477832,'9f0',3.333,3),(430,7477840,7477832,'f0e',3.333,3),(430,7477841,7477832,'0e1',3.333,3),(430,7477842,7477832,'e12',3.333,3),(430,7477843,7477832,'122',3.333,3),(430,7477844,7477832,'22c',3.333,3),(430,7477845,7477832,'2c0',3.333,3),(430,7477846,7477832,'c0c',3.333,3),(430,7477847,7477832,'0c6',3.333,3),(430,7477848,7477832,'c69',3.333,3),(430,7477849,7477832,'693',3.333,3),(430,7477850,7477832,'93e',3.333,3),(430,7477851,7477832,'3e1',3.333,3),(430,7477852,7477832,'e1a',3.333,3),(430,7477853,7477832,'1a1',3.333,3),(430,7477854,7477832,'a11',3.333,3),(430,7477855,7477832,'11e',3.333,3),(430,7477856,7477832,'1e5',3.333,3),(430,7477857,7477832,'e56',3.333,3),(430,7477858,7477832,'56d',3.333,3),(430,7477859,7477832,'6d3',3.333,3),(430,7477860,7477832,'d3b',3.333,3),(430,7477861,7477832,'3b5',3.333,3),(430,7477862,7477832,'b50',3.333,3),(430,7477863,7477833,'mon',100,1),(430,7477864,7477863,'201',50,1),(430,7477865,7477863,'013',50,1),(430,7477866,7477864,'adm',33.333,3),(430,7477867,7477864,'dmi',33.333,3),(430,7477868,7477864,'min',33.333,3),(430,7477869,7477866,'cap',16.667,1),(430,7477870,7477866,'apa',16.667,1),(430,7477871,7477866,'pac',16.667,1),(430,7477872,7477866,'aci',16.667,1),(430,7477873,7477866,'cit',16.667,1),(430,7477874,7477866,'ity',16.667,1),(430,7477875,7477869,'pat',50,1),(430,7477876,7477869,'ath',50,1),(430,7477877,7477875,'fre',14.286,1),(430,7477878,7477875,'ree',14.286,1),(430,7477879,7477875,'ees',14.286,1),(430,7477880,7477875,'esp',14.286,1),(430,7477881,7477875,'spa',14.286,1),(430,7477882,7477875,'pac',14.286,1),(430,7477883,7477875,'ace',14.286,1),(430,7477884,7477877,'dis',50,1),(430,7477885,7477877,'isk',50,1),(430,7477886,7477884,'ind',33.333,1),(430,7477887,7477884,'nde',33.333,1),(430,7477888,7477884,'dex',33.333,1),(430,7477889,7477886,'adm',8.333,1),(430,7477890,7477886,'dmi',8.333,1),(430,7477891,7477886,'min',8.333,1),(430,7477892,7477886,'ini',8.333,1),(430,7477893,7477886,'nis',8.333,1),(430,7477894,7477886,'ist',8.333,1),(430,7477895,7477886,'str',8.333,1),(430,7477896,7477886,'tra',8.333,1),(430,7477897,7477886,'rat',8.333,1),(430,7477898,7477886,'ati',8.333,1),(430,7477899,7477886,'tio',8.333,1),(430,7477900,7477886,'ion',8.333,1),(430,7477901,7477889,'sta',33.333,3),(430,7477902,7477889,'tat',33.333,3),(430,7477903,7477889,'ate',33.333,3),(430,7477904,7477901,'ena',20,2),(430,7477905,7477901,'nab',20,2),(430,7477906,7477901,'abl',20,2),(430,7477907,7477901,'ble',20,2),(430,7477908,7477901,'led',20,2),(430,7477909,7477904,'cac',33.333,2),(430,7477910,7477904,'ach',33.333,2),(430,7477911,7477904,'che',33.333,2),(430,7477912,7477909,'mod',50,1),(430,7477913,7477909,'ode',50,1),(430,7477914,7477912,'wri',14.286,1),(430,7477915,7477912,'rit',14.286,1),(430,7477916,7477912,'ite',14.286,1),(430,7477917,7477912,'tet',14.286,1),(430,7477918,7477912,'eth',14.286,1),(430,7477919,7477912,'thr',14.286,1),(430,7477920,7477912,'hru',14.286,1),(430,7477921,7477914,'ope',11.111,2),(430,7477922,7477914,'per',11.111,2),(430,7477923,7477914,'era',11.111,2),(430,7477924,7477914,'rat',11.111,2),(430,7477925,7477914,'ati',11.111,2),(430,7477926,7477914,'tio',11.111,2),(430,7477927,7477914,'ion',11.111,2),(430,7477928,7477914,'ona',11.111,2),(430,7477929,7477914,'nal',11.111,2),(430,7477930,7477921,'pen',20,1),(430,7477931,7477921,'end',20,1),(430,7477932,7477921,'ndi',20,1),(430,7477933,7477921,'din',20,1),(430,7477934,7477921,'ing',20,1),(430,7477935,7477930,'mes',20,1),(430,7477936,7477930,'ess',20,1),(430,7477937,7477930,'ssa',20,1),(430,7477938,7477930,'sag',20,1),(430,7477939,7477930,'age',20,1),(430,7477940,7477935,'wai',20,1),(430,7477941,7477935,'ait',20,1),(430,7477942,7477935,'iti',20,1),(430,7477943,7477935,'tin',20,1),(430,7477944,7477935,'ing',20,1),(430,7477945,7477940,'for',100,1),(430,7477946,7477945,'per',11.111,1),(430,7477947,7477945,'erf',11.111,1),(430,7477948,7477945,'rfo',11.111,1),(430,7477949,7477945,'for',11.111,1),(430,7477950,7477945,'orm',11.111,1),(430,7477951,7477945,'rma',11.111,1),(430,7477952,7477945,'man',11.111,1),(430,7477953,7477945,'anc',11.111,1),(430,7477954,7477945,'nce',11.111,1),(430,7477955,7477946,'ide',12.5,1),(430,7477956,7477946,'den',12.5,1),(430,7477957,7477946,'ent',12.5,1),(430,7477958,7477946,'nti',12.5,1),(430,7477959,7477946,'tif',12.5,1),(430,7477960,7477946,'ifi',12.5,1),(430,7477961,7477946,'fie',12.5,1),(430,7477962,7477946,'ier',12.5,1),(430,7477963,7477955,'vdi',33.333,3),(430,7477964,7477955,'dis',33.333,3),(430,7477965,7477955,'isk',33.333,3),(430,7477966,7477963,'nam',50,1),(430,7477967,7477963,'ame',50,1),(430,7477968,7477966,'typ',50,1),(430,7477969,7477966,'ype',50,1),(430,7477970,7477968,'dir',25,1),(430,7477971,7477968,'ire',25,1),(430,7477972,7477968,'rec',25,1),(430,7477973,7477968,'ect',25,1),(431,7477975,7477974,'naa',100,2),(431,7477976,7477975,'600',3.333,3),(431,7477977,7477975,'000',3.333,3),(431,7477978,7477975,'00c',3.333,3),(431,7477979,7477975,'0c2',3.333,3),(431,7477980,7477975,'c29',3.333,3),(431,7477981,7477975,'296',3.333,3),(431,7477982,7477975,'968',3.333,3),(431,7477983,7477975,'68e',3.333,3),(431,7477984,7477975,'8e8',3.333,3),(431,7477985,7477975,'e87',3.333,3),(431,7477986,7477975,'87a',3.333,3),(431,7477987,7477975,'7a4',3.333,3),(431,7477988,7477975,'a40',3.333,3),(431,7477989,7477975,'405',3.333,3),(431,7477990,7477975,'052',3.333,3),(431,7477991,7477975,'52e',3.333,3),(431,7477992,7477975,'2ea',3.333,3),(431,7477993,7477975,'eae',3.333,3),(431,7477994,7477975,'aeb',3.333,3),(431,7477995,7477975,'ebe',3.333,3),(431,7477996,7477975,'be9',3.333,3),(431,7477997,7477975,'e93',3.333,3),(431,7477998,7477975,'934',3.333,3),(431,7477999,7477975,'34c',3.333,3),(431,7478000,7477975,'4cd',3.333,3),(431,7478001,7477975,'cd1',3.333,3),(431,7478002,7477975,'d10',3.333,3),(431,7478003,7477975,'108',3.333,3),(431,7478004,7477975,'08c',3.333,3),(431,7478005,7477975,'8c9',3.333,3),(431,7478006,7477976,'mon',100,1),(431,7478007,7478006,'201',50,1),(431,7478008,7478006,'013',50,1),(431,7478009,7478007,'adm',33.333,3),(431,7478010,7478007,'dmi',33.333,3),(431,7478011,7478007,'min',33.333,3),(431,7478012,7478009,'cap',16.667,1),(431,7478013,7478009,'apa',16.667,1),(431,7478014,7478009,'pac',16.667,1),(431,7478015,7478009,'aci',16.667,1),(431,7478016,7478009,'cit',16.667,1),(431,7478017,7478009,'ity',16.667,1),(431,7478018,7478012,'pat',50,1),(431,7478019,7478012,'ath',50,1),(431,7478020,7478018,'fre',14.286,1),(431,7478021,7478018,'ree',14.286,1),(431,7478022,7478018,'ees',14.286,1),(431,7478023,7478018,'esp',14.286,1),(431,7478024,7478018,'spa',14.286,1),(431,7478025,7478018,'pac',14.286,1),(431,7478026,7478018,'ace',14.286,1),(431,7478027,7478020,'dis',50,1),(431,7478028,7478020,'isk',50,1),(431,7478029,7478027,'ind',33.333,1),(431,7478030,7478027,'nde',33.333,1),(431,7478031,7478027,'dex',33.333,1),(431,7478032,7478029,'adm',8.333,1),(431,7478033,7478029,'dmi',8.333,1),(431,7478034,7478029,'min',8.333,1),(431,7478035,7478029,'ini',8.333,1),(431,7478036,7478029,'nis',8.333,1),(431,7478037,7478029,'ist',8.333,1),(431,7478038,7478029,'str',8.333,1),(431,7478039,7478029,'tra',8.333,1),(431,7478040,7478029,'rat',8.333,1),(431,7478041,7478029,'ati',8.333,1),(431,7478042,7478029,'tio',8.333,1),(431,7478043,7478029,'ion',8.333,1),(431,7478044,7478032,'sta',33.333,3),(431,7478045,7478032,'tat',33.333,3),(431,7478046,7478032,'ate',33.333,3),(431,7478047,7478044,'ena',20,2),(431,7478048,7478044,'nab',20,2),(431,7478049,7478044,'abl',20,2),(431,7478050,7478044,'ble',20,2),(431,7478051,7478044,'led',20,2),(431,7478052,7478047,'cac',33.333,2),(431,7478053,7478047,'ach',33.333,2),(431,7478054,7478047,'che',33.333,2),(431,7478055,7478052,'mod',50,1),(431,7478056,7478052,'ode',50,1),(431,7478057,7478055,'wri',14.286,1),(431,7478058,7478055,'rit',14.286,1),(431,7478059,7478055,'ite',14.286,1),(431,7478060,7478055,'tet',14.286,1),(431,7478061,7478055,'eth',14.286,1),(431,7478062,7478055,'thr',14.286,1),(431,7478063,7478055,'hru',14.286,1),(431,7478064,7478057,'ope',11.111,2),(431,7478065,7478057,'per',11.111,2),(431,7478066,7478057,'era',11.111,2),(431,7478067,7478057,'rat',11.111,2),(431,7478068,7478057,'ati',11.111,2),(431,7478069,7478057,'tio',11.111,2),(431,7478070,7478057,'ion',11.111,2),(431,7478071,7478057,'ona',11.111,2),(431,7478072,7478057,'nal',11.111,2),(431,7478073,7478064,'pen',20,1),(431,7478074,7478064,'end',20,1),(431,7478075,7478064,'ndi',20,1),(431,7478076,7478064,'din',20,1),(431,7478077,7478064,'ing',20,1),(431,7478078,7478073,'mes',20,1),(431,7478079,7478073,'ess',20,1),(431,7478080,7478073,'ssa',20,1),(431,7478081,7478073,'sag',20,1),(431,7478082,7478073,'age',20,1),(431,7478083,7478078,'wai',20,1),(431,7478084,7478078,'ait',20,1),(431,7478085,7478078,'iti',20,1),(431,7478086,7478078,'tin',20,1),(431,7478087,7478078,'ing',20,1),(431,7478088,7478083,'for',100,1),(431,7478089,7478088,'per',11.111,1),(431,7478090,7478088,'erf',11.111,1),(431,7478091,7478088,'rfo',11.111,1),(431,7478092,7478088,'for',11.111,1),(431,7478093,7478088,'orm',11.111,1),(431,7478094,7478088,'rma',11.111,1),(431,7478095,7478088,'man',11.111,1),(431,7478096,7478088,'anc',11.111,1),(431,7478097,7478088,'nce',11.111,1),(431,7478098,7478089,'ide',12.5,1),(431,7478099,7478089,'den',12.5,1),(431,7478100,7478089,'ent',12.5,1),(431,7478101,7478089,'nti',12.5,1),(431,7478102,7478089,'tif',12.5,1),(431,7478103,7478089,'ifi',12.5,1),(431,7478104,7478089,'fie',12.5,1),(431,7478105,7478089,'ier',12.5,1),(431,7478106,7478098,'vdi',33.333,3),(431,7478107,7478098,'dis',33.333,3),(431,7478108,7478098,'isk',33.333,3),(431,7478109,7478106,'nam',50,1),(431,7478110,7478106,'ame',50,1),(431,7478111,7478109,'typ',50,1),(431,7478112,7478109,'ype',50,1),(431,7478113,7478111,'dir',25,1),(431,7478114,7478111,'ire',25,1),(431,7478115,7478111,'rec',25,1),(431,7478116,7478111,'ect',25,1),(432,7478118,7478117,'naa',100,2),(432,7478119,7478118,'600',3.333,3),(432,7478120,7478118,'000',3.333,3),(432,7478121,7478118,'00c',3.333,3),(432,7478122,7478118,'0c2',3.333,3),(432,7478123,7478118,'c29',3.333,3),(432,7478124,7478118,'29a',3.333,3),(432,7478125,7478118,'9ac',3.333,3),(432,7478126,7478118,'acd',3.333,3),(432,7478127,7478118,'cdc',3.333,3),(432,7478128,7478118,'dcf',3.333,3),(432,7478129,7478118,'cfc',3.333,3),(432,7478130,7478118,'fc3',3.333,3),(432,7478131,7478118,'c37',3.333,3),(432,7478132,7478118,'373',3.333,3),(432,7478133,7478118,'731',3.333,3),(432,7478134,7478118,'310',3.333,3),(432,7478135,7478118,'106',3.333,3),(432,7478136,7478118,'068',3.333,3),(432,7478137,7478118,'68d',3.333,3),(432,7478138,7478118,'8d1',3.333,3),(432,7478139,7478118,'d11',3.333,3),(432,7478140,7478118,'112',3.333,3),(432,7478141,7478118,'12b',3.333,3),(432,7478142,7478118,'2b9',3.333,3),(432,7478143,7478118,'b92',3.333,3),(432,7478144,7478118,'925',3.333,3),(432,7478145,7478118,'25c',3.333,3),(432,7478146,7478118,'5c1',3.333,3),(432,7478147,7478118,'c11',3.333,3),(432,7478148,7478118,'117',3.333,3),(432,7478149,7478119,'mon',100,1),(432,7478150,7478149,'201',50,1),(432,7478151,7478149,'013',50,1),(432,7478152,7478150,'adm',33.333,3),(432,7478153,7478150,'dmi',33.333,3),(432,7478154,7478150,'min',33.333,3),(432,7478155,7478152,'cap',16.667,1),(432,7478156,7478152,'apa',16.667,1),(432,7478157,7478152,'pac',16.667,1),(432,7478158,7478152,'aci',16.667,1),(432,7478159,7478152,'cit',16.667,1),(432,7478160,7478152,'ity',16.667,1),(432,7478161,7478155,'pat',50,1),(432,7478162,7478155,'ath',50,1),(432,7478163,7478161,'fre',14.286,1),(432,7478164,7478161,'ree',14.286,1),(432,7478165,7478161,'ees',14.286,1),(432,7478166,7478161,'esp',14.286,1),(432,7478167,7478161,'spa',14.286,1),(432,7478168,7478161,'pac',14.286,1),(432,7478169,7478161,'ace',14.286,1),(432,7478170,7478163,'dis',50,1),(432,7478171,7478163,'isk',50,1),(432,7478172,7478170,'ind',33.333,1),(432,7478173,7478170,'nde',33.333,1),(432,7478174,7478170,'dex',33.333,1),(432,7478175,7478172,'adm',8.333,1),(432,7478176,7478172,'dmi',8.333,1),(432,7478177,7478172,'min',8.333,1),(432,7478178,7478172,'ini',8.333,1),(432,7478179,7478172,'nis',8.333,1),(432,7478180,7478172,'ist',8.333,1),(432,7478181,7478172,'str',8.333,1),(432,7478182,7478172,'tra',8.333,1),(432,7478183,7478172,'rat',8.333,1),(432,7478184,7478172,'ati',8.333,1),(432,7478185,7478172,'tio',8.333,1),(432,7478186,7478172,'ion',8.333,1),(432,7478187,7478175,'sta',33.333,3),(432,7478188,7478175,'tat',33.333,3),(432,7478189,7478175,'ate',33.333,3),(432,7478190,7478187,'ena',20,2),(432,7478191,7478187,'nab',20,2),(432,7478192,7478187,'abl',20,2),(432,7478193,7478187,'ble',20,2),(432,7478194,7478187,'led',20,2),(432,7478195,7478190,'cac',33.333,2),(432,7478196,7478190,'ach',33.333,2),(432,7478197,7478190,'che',33.333,2),(432,7478198,7478195,'mod',50,1),(432,7478199,7478195,'ode',50,1),(432,7478200,7478198,'wri',14.286,1),(432,7478201,7478198,'rit',14.286,1),(432,7478202,7478198,'ite',14.286,1),(432,7478203,7478198,'tet',14.286,1),(432,7478204,7478198,'eth',14.286,1),(432,7478205,7478198,'thr',14.286,1),(432,7478206,7478198,'hru',14.286,1),(432,7478207,7478200,'ope',11.111,2),(432,7478208,7478200,'per',11.111,2),(432,7478209,7478200,'era',11.111,2),(432,7478210,7478200,'rat',11.111,2),(432,7478211,7478200,'ati',11.111,2),(432,7478212,7478200,'tio',11.111,2),(432,7478213,7478200,'ion',11.111,2),(432,7478214,7478200,'ona',11.111,2),(432,7478215,7478200,'nal',11.111,2),(432,7478216,7478207,'pen',20,1),(432,7478217,7478207,'end',20,1),(432,7478218,7478207,'ndi',20,1),(432,7478219,7478207,'din',20,1),(432,7478220,7478207,'ing',20,1),(432,7478221,7478216,'mes',20,1),(432,7478222,7478216,'ess',20,1),(432,7478223,7478216,'ssa',20,1),(432,7478224,7478216,'sag',20,1),(432,7478225,7478216,'age',20,1),(432,7478226,7478221,'wai',20,1),(432,7478227,7478221,'ait',20,1),(432,7478228,7478221,'iti',20,1),(432,7478229,7478221,'tin',20,1),(432,7478230,7478221,'ing',20,1),(432,7478231,7478226,'for',100,1),(432,7478232,7478231,'per',11.111,1),(432,7478233,7478231,'erf',11.111,1),(432,7478234,7478231,'rfo',11.111,1),(432,7478235,7478231,'for',11.111,1),(432,7478236,7478231,'orm',11.111,1),(432,7478237,7478231,'rma',11.111,1),(432,7478238,7478231,'man',11.111,1),(432,7478239,7478231,'anc',11.111,1),(432,7478240,7478231,'nce',11.111,1),(432,7478241,7478232,'ide',12.5,1),(432,7478242,7478232,'den',12.5,1),(432,7478243,7478232,'ent',12.5,1),(432,7478244,7478232,'nti',12.5,1),(432,7478245,7478232,'tif',12.5,1),(432,7478246,7478232,'ifi',12.5,1),(432,7478247,7478232,'fie',12.5,1),(432,7478248,7478232,'ier',12.5,1),(432,7478249,7478241,'vdi',33.333,3),(432,7478250,7478241,'dis',33.333,3),(432,7478251,7478241,'isk',33.333,3),(432,7478252,7478249,'nam',50,1),(432,7478253,7478249,'ame',50,1),(432,7478254,7478252,'typ',50,1),(432,7478255,7478252,'ype',50,1),(432,7478256,7478254,'dir',25,1),(432,7478257,7478254,'ire',25,1),(432,7478258,7478254,'rec',25,1),(432,7478259,7478254,'ect',25,1),(433,7478261,7478260,'naa',100,2),(433,7478262,7478261,'600',3.333,3),(433,7478263,7478261,'000',3.333,3),(433,7478264,7478261,'00c',3.333,3),(433,7478265,7478261,'0c2',3.333,3),(433,7478266,7478261,'c29',3.333,3),(433,7478267,7478261,'299',3.333,3),(433,7478268,7478261,'992',3.333,3),(433,7478269,7478261,'927',3.333,3),(433,7478270,7478261,'273',3.333,3),(433,7478271,7478261,'73f',3.333,3),(433,7478272,7478261,'3ff',3.333,3),(433,7478273,7478261,'ff0',3.333,3),(433,7478274,7478261,'f09',3.333,3),(433,7478275,7478261,'095',3.333,3),(433,7478276,7478261,'958',3.333,3),(433,7478277,7478261,'587',3.333,3),(433,7478278,7478261,'87c',3.333,3),(433,7478279,7478261,'7c8',3.333,3),(433,7478280,7478261,'c8a',3.333,3),(433,7478281,7478261,'8a7',3.333,3),(433,7478282,7478261,'a7d',3.333,3),(433,7478283,7478261,'7d7',3.333,3),(433,7478284,7478261,'d75',3.333,3),(433,7478285,7478261,'753',3.333,3),(433,7478286,7478261,'53e',3.333,3),(433,7478287,7478261,'3e6',3.333,3),(433,7478288,7478261,'e6c',3.333,3),(433,7478289,7478261,'6cb',3.333,3),(433,7478290,7478261,'cba',3.333,3),(433,7478291,7478261,'bad',3.333,3),(433,7478292,7478262,'mon',100,1),(433,7478293,7478292,'201',50,1),(433,7478294,7478292,'013',50,1),(433,7478295,7478293,'adm',33.333,3),(433,7478296,7478293,'dmi',33.333,3),(433,7478297,7478293,'min',33.333,3),(433,7478298,7478295,'cap',16.667,1),(433,7478299,7478295,'apa',16.667,1),(433,7478300,7478295,'pac',16.667,1),(433,7478301,7478295,'aci',16.667,1),(433,7478302,7478295,'cit',16.667,1),(433,7478303,7478295,'ity',16.667,1),(433,7478304,7478298,'pat',50,1),(433,7478305,7478298,'ath',50,1),(433,7478306,7478304,'fre',14.286,1),(433,7478307,7478304,'ree',14.286,1),(433,7478308,7478304,'ees',14.286,1),(433,7478309,7478304,'esp',14.286,1),(433,7478310,7478304,'spa',14.286,1),(433,7478311,7478304,'pac',14.286,1),(433,7478312,7478304,'ace',14.286,1),(433,7478313,7478306,'dis',50,1),(433,7478314,7478306,'isk',50,1),(433,7478315,7478313,'ind',33.333,1),(433,7478316,7478313,'nde',33.333,1),(433,7478317,7478313,'dex',33.333,1),(433,7478318,7478315,'adm',8.333,1),(433,7478319,7478315,'dmi',8.333,1),(433,7478320,7478315,'min',8.333,1),(433,7478321,7478315,'ini',8.333,1),(433,7478322,7478315,'nis',8.333,1),(433,7478323,7478315,'ist',8.333,1),(433,7478324,7478315,'str',8.333,1),(433,7478325,7478315,'tra',8.333,1),(433,7478326,7478315,'rat',8.333,1),(433,7478327,7478315,'ati',8.333,1),(433,7478328,7478315,'tio',8.333,1),(433,7478329,7478315,'ion',8.333,1),(433,7478330,7478318,'sta',33.333,3),(433,7478331,7478318,'tat',33.333,3),(433,7478332,7478318,'ate',33.333,3),(433,7478333,7478330,'ena',20,2),(433,7478334,7478330,'nab',20,2),(433,7478335,7478330,'abl',20,2),(433,7478336,7478330,'ble',20,2),(433,7478337,7478330,'led',20,2),(433,7478338,7478333,'cac',33.333,2),(433,7478339,7478333,'ach',33.333,2),(433,7478340,7478333,'che',33.333,2),(433,7478341,7478338,'mod',50,1),(433,7478342,7478338,'ode',50,1),(433,7478343,7478341,'wri',14.286,1),(433,7478344,7478341,'rit',14.286,1),(433,7478345,7478341,'ite',14.286,1),(433,7478346,7478341,'tet',14.286,1),(433,7478347,7478341,'eth',14.286,1),(433,7478348,7478341,'thr',14.286,1),(433,7478349,7478341,'hru',14.286,1),(433,7478350,7478343,'ope',11.111,2),(433,7478351,7478343,'per',11.111,2),(433,7478352,7478343,'era',11.111,2),(433,7478353,7478343,'rat',11.111,2),(433,7478354,7478343,'ati',11.111,2),(433,7478355,7478343,'tio',11.111,2),(433,7478356,7478343,'ion',11.111,2),(433,7478357,7478343,'ona',11.111,2),(433,7478358,7478343,'nal',11.111,2),(433,7478359,7478350,'pen',20,1),(433,7478360,7478350,'end',20,1),(433,7478361,7478350,'ndi',20,1),(433,7478362,7478350,'din',20,1),(433,7478363,7478350,'ing',20,1),(433,7478364,7478359,'mes',20,1),(433,7478365,7478359,'ess',20,1),(433,7478366,7478359,'ssa',20,1),(433,7478367,7478359,'sag',20,1),(433,7478368,7478359,'age',20,1),(433,7478369,7478364,'wai',20,1),(433,7478370,7478364,'ait',20,1),(433,7478371,7478364,'iti',20,1),(433,7478372,7478364,'tin',20,1),(433,7478373,7478364,'ing',20,1),(433,7478374,7478369,'for',100,1),(433,7478375,7478374,'per',11.111,1),(433,7478376,7478374,'erf',11.111,1),(433,7478377,7478374,'rfo',11.111,1),(433,7478378,7478374,'for',11.111,1),(433,7478379,7478374,'orm',11.111,1),(433,7478380,7478374,'rma',11.111,1),(433,7478381,7478374,'man',11.111,1),(433,7478382,7478374,'anc',11.111,1),(433,7478383,7478374,'nce',11.111,1),(433,7478384,7478375,'ide',12.5,1),(433,7478385,7478375,'den',12.5,1),(433,7478386,7478375,'ent',12.5,1),(433,7478387,7478375,'nti',12.5,1),(433,7478388,7478375,'tif',12.5,1),(433,7478389,7478375,'ifi',12.5,1),(433,7478390,7478375,'fie',12.5,1),(433,7478391,7478375,'ier',12.5,1),(433,7478392,7478384,'vdi',33.333,3),(433,7478393,7478384,'dis',33.333,3),(433,7478394,7478384,'isk',33.333,3),(433,7478395,7478392,'nam',50,1),(433,7478396,7478392,'ame',50,1),(433,7478397,7478395,'typ',50,1),(433,7478398,7478395,'ype',50,1),(433,7478399,7478397,'dir',25,1),(433,7478400,7478397,'ire',25,1),(433,7478401,7478397,'rec',25,1),(433,7478402,7478397,'ect',25,1),(434,7478404,7478403,'naa',100,2),(434,7478405,7478404,'600',3.333,3),(434,7478406,7478404,'000',3.333,3),(434,7478407,7478404,'00c',3.333,3),(434,7478408,7478404,'0c2',3.333,3),(434,7478409,7478404,'c29',3.333,3),(434,7478410,7478404,'299',3.333,3),(434,7478411,7478404,'99f',3.333,3),(434,7478412,7478404,'9fd',3.333,3),(434,7478413,7478404,'fd4',3.333,3),(434,7478414,7478404,'d49',3.333,3),(434,7478415,7478404,'491',3.333,3),(434,7478416,7478404,'914',3.333,3),(434,7478417,7478404,'141',3.333,3),(434,7478418,7478404,'414',3.333,3),(434,7478419,7478404,'145',3.333,3),(434,7478420,7478404,'45c',3.333,3),(434,7478421,7478404,'5c4',3.333,3),(434,7478422,7478404,'c44',3.333,3),(434,7478423,7478404,'44d',3.333,3),(434,7478424,7478404,'4d7',3.333,3),(434,7478425,7478404,'d7f',3.333,3),(434,7478426,7478404,'7f0',3.333,3),(434,7478427,7478404,'f0c',3.333,3),(434,7478428,7478404,'0cb',3.333,3),(434,7478429,7478404,'cb9',3.333,3),(434,7478430,7478404,'b9b',3.333,3),(434,7478431,7478404,'9bb',3.333,3),(434,7478432,7478404,'bbb',3.333,3),(434,7478433,7478404,'bb6',3.333,3),(434,7478434,7478404,'b61',3.333,3),(434,7478435,7478405,'mon',100,1),(434,7478436,7478435,'201',50,1),(434,7478437,7478435,'013',50,1),(434,7478438,7478436,'adm',33.333,3),(434,7478439,7478436,'dmi',33.333,3),(434,7478440,7478436,'min',33.333,3),(434,7478441,7478438,'cap',16.667,1),(434,7478442,7478438,'apa',16.667,1),(434,7478443,7478438,'pac',16.667,1),(434,7478444,7478438,'aci',16.667,1),(434,7478445,7478438,'cit',16.667,1),(434,7478446,7478438,'ity',16.667,1),(434,7478447,7478441,'pat',50,1),(434,7478448,7478441,'ath',50,1),(434,7478449,7478447,'fre',14.286,1),(434,7478450,7478447,'ree',14.286,1),(434,7478451,7478447,'ees',14.286,1),(434,7478452,7478447,'esp',14.286,1),(434,7478453,7478447,'spa',14.286,1),(434,7478454,7478447,'pac',14.286,1),(434,7478455,7478447,'ace',14.286,1),(434,7478456,7478449,'dis',50,1),(434,7478457,7478449,'isk',50,1),(434,7478458,7478456,'ind',33.333,1),(434,7478459,7478456,'nde',33.333,1),(434,7478460,7478456,'dex',33.333,1),(434,7478461,7478458,'adm',8.333,1),(434,7478462,7478458,'dmi',8.333,1),(434,7478463,7478458,'min',8.333,1),(434,7478464,7478458,'ini',8.333,1),(434,7478465,7478458,'nis',8.333,1),(434,7478466,7478458,'ist',8.333,1),(434,7478467,7478458,'str',8.333,1),(434,7478468,7478458,'tra',8.333,1),(434,7478469,7478458,'rat',8.333,1),(434,7478470,7478458,'ati',8.333,1),(434,7478471,7478458,'tio',8.333,1),(434,7478472,7478458,'ion',8.333,1),(434,7478473,7478461,'sta',33.333,3),(434,7478474,7478461,'tat',33.333,3),(434,7478475,7478461,'ate',33.333,3),(434,7478476,7478473,'ena',20,2),(434,7478477,7478473,'nab',20,2),(434,7478478,7478473,'abl',20,2),(434,7478479,7478473,'ble',20,2),(434,7478480,7478473,'led',20,2),(434,7478481,7478476,'cac',33.333,2),(434,7478482,7478476,'ach',33.333,2),(434,7478483,7478476,'che',33.333,2),(434,7478484,7478481,'mod',50,1),(434,7478485,7478481,'ode',50,1),(434,7478486,7478484,'wri',14.286,1),(434,7478487,7478484,'rit',14.286,1),(434,7478488,7478484,'ite',14.286,1),(434,7478489,7478484,'tet',14.286,1),(434,7478490,7478484,'eth',14.286,1),(434,7478491,7478484,'thr',14.286,1),(434,7478492,7478484,'hru',14.286,1),(434,7478493,7478486,'ope',11.111,2),(434,7478494,7478486,'per',11.111,2),(434,7478495,7478486,'era',11.111,2),(434,7478496,7478486,'rat',11.111,2),(434,7478497,7478486,'ati',11.111,2),(434,7478498,7478486,'tio',11.111,2),(434,7478499,7478486,'ion',11.111,2),(434,7478500,7478486,'ona',11.111,2),(434,7478501,7478486,'nal',11.111,2),(434,7478502,7478493,'pen',20,1),(434,7478503,7478493,'end',20,1),(434,7478504,7478493,'ndi',20,1),(434,7478505,7478493,'din',20,1),(434,7478506,7478493,'ing',20,1),(434,7478507,7478502,'mes',20,1),(434,7478508,7478502,'ess',20,1),(434,7478509,7478502,'ssa',20,1),(434,7478510,7478502,'sag',20,1),(434,7478511,7478502,'age',20,1),(434,7478512,7478507,'wai',20,1),(434,7478513,7478507,'ait',20,1),(434,7478514,7478507,'iti',20,1),(434,7478515,7478507,'tin',20,1),(434,7478516,7478507,'ing',20,1),(434,7478517,7478512,'for',100,1),(434,7478518,7478517,'per',11.111,1),(434,7478519,7478517,'erf',11.111,1),(434,7478520,7478517,'rfo',11.111,1),(434,7478521,7478517,'for',11.111,1),(434,7478522,7478517,'orm',11.111,1),(434,7478523,7478517,'rma',11.111,1),(434,7478524,7478517,'man',11.111,1),(434,7478525,7478517,'anc',11.111,1),(434,7478526,7478517,'nce',11.111,1),(434,7478527,7478518,'ide',12.5,1),(434,7478528,7478518,'den',12.5,1),(434,7478529,7478518,'ent',12.5,1),(434,7478530,7478518,'nti',12.5,1),(434,7478531,7478518,'tif',12.5,1),(434,7478532,7478518,'ifi',12.5,1),(434,7478533,7478518,'fie',12.5,1),(434,7478534,7478518,'ier',12.5,1),(434,7478535,7478527,'vdi',33.333,3),(434,7478536,7478527,'dis',33.333,3),(434,7478537,7478527,'isk',33.333,3),(434,7478538,7478535,'nam',50,1),(434,7478539,7478535,'ame',50,1),(434,7478540,7478538,'typ',50,1),(434,7478541,7478538,'ype',50,1),(434,7478542,7478540,'dir',25,1),(434,7478543,7478540,'ire',25,1),(434,7478544,7478540,'rec',25,1),(434,7478545,7478540,'ect',25,1),(435,7478547,7478546,'naa',100,2),(435,7478548,7478547,'600',3.333,3),(435,7478549,7478547,'000',3.333,3),(435,7478550,7478547,'00c',3.333,3),(435,7478551,7478547,'0c2',3.333,3),(435,7478552,7478547,'c29',3.333,3),(435,7478553,7478547,'298',3.333,3),(435,7478554,7478547,'989',3.333,3),(435,7478555,7478547,'89e',3.333,3),(435,7478556,7478547,'9e0',3.333,3),(435,7478557,7478547,'e01',3.333,3),(435,7478558,7478547,'012',3.333,3),(435,7478559,7478547,'12f',3.333,3),(435,7478560,7478547,'2f7',3.333,3),(435,7478561,7478547,'f7d',3.333,3),(435,7478562,7478547,'7d7',3.333,3),(435,7478563,7478547,'d70',3.333,3),(435,7478564,7478547,'700',3.333,3),(435,7478565,7478547,'003',3.333,3),(435,7478566,7478547,'034',3.333,3),(435,7478567,7478547,'34f',3.333,3),(435,7478568,7478547,'4f5',3.333,3),(435,7478569,7478547,'f59',3.333,3),(435,7478570,7478547,'596',3.333,3),(435,7478571,7478547,'968',3.333,3),(435,7478572,7478547,'682',3.333,3),(435,7478573,7478547,'82d',3.333,3),(435,7478574,7478547,'2da',3.333,3),(435,7478575,7478547,'da7',3.333,3),(435,7478576,7478547,'a73',3.333,3),(435,7478577,7478547,'73f',3.333,3),(435,7478578,7478548,'mon',100,1),(435,7478579,7478578,'201',50,1),(435,7478580,7478578,'013',50,1),(435,7478581,7478579,'adm',33.333,3),(435,7478582,7478579,'dmi',33.333,3),(435,7478583,7478579,'min',33.333,3),(435,7478584,7478581,'cap',16.667,1),(435,7478585,7478581,'apa',16.667,1),(435,7478586,7478581,'pac',16.667,1),(435,7478587,7478581,'aci',16.667,1),(435,7478588,7478581,'cit',16.667,1),(435,7478589,7478581,'ity',16.667,1),(435,7478590,7478584,'pat',50,1),(435,7478591,7478584,'ath',50,1),(435,7478592,7478590,'fre',14.286,1),(435,7478593,7478590,'ree',14.286,1),(435,7478594,7478590,'ees',14.286,1),(435,7478595,7478590,'esp',14.286,1),(435,7478596,7478590,'spa',14.286,1),(435,7478597,7478590,'pac',14.286,1),(435,7478598,7478590,'ace',14.286,1),(435,7478599,7478592,'dis',50,1),(435,7478600,7478592,'isk',50,1),(435,7478601,7478599,'ind',33.333,1),(435,7478602,7478599,'nde',33.333,1),(435,7478603,7478599,'dex',33.333,1),(435,7478604,7478601,'adm',8.333,1),(435,7478605,7478601,'dmi',8.333,1),(435,7478606,7478601,'min',8.333,1),(435,7478607,7478601,'ini',8.333,1),(435,7478608,7478601,'nis',8.333,1),(435,7478609,7478601,'ist',8.333,1),(435,7478610,7478601,'str',8.333,1),(435,7478611,7478601,'tra',8.333,1),(435,7478612,7478601,'rat',8.333,1),(435,7478613,7478601,'ati',8.333,1),(435,7478614,7478601,'tio',8.333,1),(435,7478615,7478601,'ion',8.333,1),(435,7478616,7478604,'sta',33.333,3),(435,7478617,7478604,'tat',33.333,3),(435,7478618,7478604,'ate',33.333,3),(435,7478619,7478616,'ena',20,2),(435,7478620,7478616,'nab',20,2),(435,7478621,7478616,'abl',20,2),(435,7478622,7478616,'ble',20,2),(435,7478623,7478616,'led',20,2),(435,7478624,7478619,'cac',33.333,2),(435,7478625,7478619,'ach',33.333,2),(435,7478626,7478619,'che',33.333,2),(435,7478627,7478624,'mod',50,1),(435,7478628,7478624,'ode',50,1),(435,7478629,7478627,'wri',14.286,1),(435,7478630,7478627,'rit',14.286,1),(435,7478631,7478627,'ite',14.286,1),(435,7478632,7478627,'tet',14.286,1),(435,7478633,7478627,'eth',14.286,1),(435,7478634,7478627,'thr',14.286,1),(435,7478635,7478627,'hru',14.286,1),(435,7478636,7478629,'ope',11.111,2),(435,7478637,7478629,'per',11.111,2),(435,7478638,7478629,'era',11.111,2),(435,7478639,7478629,'rat',11.111,2),(435,7478640,7478629,'ati',11.111,2),(435,7478641,7478629,'tio',11.111,2),(435,7478642,7478629,'ion',11.111,2),(435,7478643,7478629,'ona',11.111,2),(435,7478644,7478629,'nal',11.111,2),(435,7478645,7478636,'pen',20,1),(435,7478646,7478636,'end',20,1),(435,7478647,7478636,'ndi',20,1),(435,7478648,7478636,'din',20,1),(435,7478649,7478636,'ing',20,1),(435,7478650,7478645,'mes',20,1),(435,7478651,7478645,'ess',20,1),(435,7478652,7478645,'ssa',20,1),(435,7478653,7478645,'sag',20,1),(435,7478654,7478645,'age',20,1),(435,7478655,7478650,'wai',20,1),(435,7478656,7478650,'ait',20,1),(435,7478657,7478650,'iti',20,1),(435,7478658,7478650,'tin',20,1),(435,7478659,7478650,'ing',20,1),(435,7478660,7478655,'for',100,1),(435,7478661,7478660,'per',11.111,1),(435,7478662,7478660,'erf',11.111,1),(435,7478663,7478660,'rfo',11.111,1),(435,7478664,7478660,'for',11.111,1),(435,7478665,7478660,'orm',11.111,1),(435,7478666,7478660,'rma',11.111,1),(435,7478667,7478660,'man',11.111,1),(435,7478668,7478660,'anc',11.111,1),(435,7478669,7478660,'nce',11.111,1),(435,7478670,7478661,'ide',12.5,1),(435,7478671,7478661,'den',12.5,1),(435,7478672,7478661,'ent',12.5,1),(435,7478673,7478661,'nti',12.5,1),(435,7478674,7478661,'tif',12.5,1),(435,7478675,7478661,'ifi',12.5,1),(435,7478676,7478661,'fie',12.5,1),(435,7478677,7478661,'ier',12.5,1),(435,7478678,7478670,'vdi',33.333,3),(435,7478679,7478670,'dis',33.333,3),(435,7478680,7478670,'isk',33.333,3),(435,7478681,7478678,'nam',50,1),(435,7478682,7478678,'ame',50,1),(435,7478683,7478681,'typ',50,1),(435,7478684,7478681,'ype',50,1),(435,7478685,7478683,'dir',25,1),(435,7478686,7478683,'ire',25,1),(435,7478687,7478683,'rec',25,1),(435,7478688,7478683,'ect',25,1),(436,7478690,7478689,'naa',100,2),(436,7478691,7478690,'600',3.333,3),(436,7478692,7478690,'000',3.333,3),(436,7478693,7478690,'00c',3.333,3),(436,7478694,7478690,'0c2',3.333,3),(436,7478695,7478690,'c29',3.333,3),(436,7478696,7478690,'29b',3.333,3),(436,7478697,7478690,'9b8',3.333,3),(436,7478698,7478690,'b82',3.333,3),(436,7478699,7478690,'829',3.333,3),(436,7478700,7478690,'296',3.333,3),(436,7478701,7478690,'965',3.333,3),(436,7478702,7478690,'653',3.333,3),(436,7478703,7478690,'536',3.333,3),(436,7478704,7478690,'36e',3.333,3),(436,7478705,7478690,'6ec',3.333,3),(436,7478706,7478690,'ec7',3.333,3),(436,7478707,7478690,'c78',3.333,3),(436,7478708,7478690,'781',3.333,3),(436,7478709,7478690,'810',3.333,3),(436,7478710,7478690,'10e',3.333,3),(436,7478711,7478690,'0e7',3.333,3),(436,7478712,7478690,'e73',3.333,3),(436,7478713,7478690,'73a',3.333,3),(436,7478714,7478690,'3af',3.333,3),(436,7478715,7478690,'af9',3.333,3),(436,7478716,7478690,'f9e',3.333,3),(436,7478717,7478690,'9e6',3.333,3),(436,7478718,7478690,'e6c',3.333,3),(436,7478719,7478690,'6c3',3.333,3),(436,7478720,7478690,'c3a',3.333,3),(436,7478721,7478691,'mon',100,1),(436,7478722,7478721,'201',50,1),(436,7478723,7478721,'013',50,1),(436,7478724,7478722,'adm',33.333,3),(436,7478725,7478722,'dmi',33.333,3),(436,7478726,7478722,'min',33.333,3),(436,7478727,7478724,'cap',16.667,1),(436,7478728,7478724,'apa',16.667,1),(436,7478729,7478724,'pac',16.667,1),(436,7478730,7478724,'aci',16.667,1),(436,7478731,7478724,'cit',16.667,1),(436,7478732,7478724,'ity',16.667,1),(436,7478733,7478727,'pat',50,1),(436,7478734,7478727,'ath',50,1),(436,7478735,7478733,'fre',14.286,1),(436,7478736,7478733,'ree',14.286,1),(436,7478737,7478733,'ees',14.286,1),(436,7478738,7478733,'esp',14.286,1),(436,7478739,7478733,'spa',14.286,1),(436,7478740,7478733,'pac',14.286,1),(436,7478741,7478733,'ace',14.286,1),(436,7478742,7478735,'dis',50,1),(436,7478743,7478735,'isk',50,1),(436,7478744,7478742,'ind',33.333,1),(436,7478745,7478742,'nde',33.333,1),(436,7478746,7478742,'dex',33.333,1),(436,7478747,7478744,'adm',8.333,1),(436,7478748,7478744,'dmi',8.333,1),(436,7478749,7478744,'min',8.333,1),(436,7478750,7478744,'ini',8.333,1),(436,7478751,7478744,'nis',8.333,1),(436,7478752,7478744,'ist',8.333,1),(436,7478753,7478744,'str',8.333,1),(436,7478754,7478744,'tra',8.333,1),(436,7478755,7478744,'rat',8.333,1),(436,7478756,7478744,'ati',8.333,1),(436,7478757,7478744,'tio',8.333,1),(436,7478758,7478744,'ion',8.333,1),(436,7478759,7478747,'sta',33.333,3),(436,7478760,7478747,'tat',33.333,3),(436,7478761,7478747,'ate',33.333,3),(436,7478762,7478759,'ena',20,2),(436,7478763,7478759,'nab',20,2),(436,7478764,7478759,'abl',20,2),(436,7478765,7478759,'ble',20,2),(436,7478766,7478759,'led',20,2),(436,7478767,7478762,'cac',33.333,2),(436,7478768,7478762,'ach',33.333,2),(436,7478769,7478762,'che',33.333,2),(436,7478770,7478767,'mod',50,1),(436,7478771,7478767,'ode',50,1),(436,7478772,7478770,'wri',14.286,1),(436,7478773,7478770,'rit',14.286,1),(436,7478774,7478770,'ite',14.286,1),(436,7478775,7478770,'tet',14.286,1),(436,7478776,7478770,'eth',14.286,1),(436,7478777,7478770,'thr',14.286,1),(436,7478778,7478770,'hru',14.286,1),(436,7478779,7478772,'ope',11.111,2),(436,7478780,7478772,'per',11.111,2),(436,7478781,7478772,'era',11.111,2),(436,7478782,7478772,'rat',11.111,2),(436,7478783,7478772,'ati',11.111,2),(436,7478784,7478772,'tio',11.111,2),(436,7478785,7478772,'ion',11.111,2),(436,7478786,7478772,'ona',11.111,2),(436,7478787,7478772,'nal',11.111,2),(436,7478788,7478779,'pen',20,1),(436,7478789,7478779,'end',20,1),(436,7478790,7478779,'ndi',20,1),(436,7478791,7478779,'din',20,1),(436,7478792,7478779,'ing',20,1),(436,7478793,7478788,'mes',20,1),(436,7478794,7478788,'ess',20,1),(436,7478795,7478788,'ssa',20,1),(436,7478796,7478788,'sag',20,1),(436,7478797,7478788,'age',20,1),(436,7478798,7478793,'wai',20,1),(436,7478799,7478793,'ait',20,1),(436,7478800,7478793,'iti',20,1),(436,7478801,7478793,'tin',20,1),(436,7478802,7478793,'ing',20,1),(436,7478803,7478798,'for',100,1),(436,7478804,7478803,'per',11.111,1),(436,7478805,7478803,'erf',11.111,1),(436,7478806,7478803,'rfo',11.111,1),(436,7478807,7478803,'for',11.111,1),(436,7478808,7478803,'orm',11.111,1),(436,7478809,7478803,'rma',11.111,1),(436,7478810,7478803,'man',11.111,1),(436,7478811,7478803,'anc',11.111,1),(436,7478812,7478803,'nce',11.111,1),(436,7478813,7478804,'ide',12.5,1),(436,7478814,7478804,'den',12.5,1),(436,7478815,7478804,'ent',12.5,1),(436,7478816,7478804,'nti',12.5,1),(436,7478817,7478804,'tif',12.5,1),(436,7478818,7478804,'ifi',12.5,1),(436,7478819,7478804,'fie',12.5,1),(436,7478820,7478804,'ier',12.5,1),(436,7478821,7478813,'vdi',33.333,3),(436,7478822,7478813,'dis',33.333,3),(436,7478823,7478813,'isk',33.333,3),(436,7478824,7478821,'nam',50,1),(436,7478825,7478821,'ame',50,1),(436,7478826,7478824,'typ',50,1),(436,7478827,7478824,'ype',50,1),(436,7478828,7478826,'dir',25,1),(436,7478829,7478826,'ire',25,1),(436,7478830,7478826,'rec',25,1),(436,7478831,7478826,'ect',25,1),(437,7478833,7478832,'naa',100,2),(437,7478834,7478833,'600',3.333,3),(437,7478835,7478833,'000',3.333,3),(437,7478836,7478833,'00c',3.333,3),(437,7478837,7478833,'0c2',3.333,3),(437,7478838,7478833,'c29',3.333,3),(437,7478839,7478833,'294',3.333,3),(437,7478840,7478833,'94b',3.333,3),(437,7478841,7478833,'4bb',3.333,3),(437,7478842,7478833,'bb4',3.333,3),(437,7478843,7478833,'b43',3.333,3),(437,7478844,7478833,'435',3.333,3),(437,7478845,7478833,'353',3.333,3),(437,7478846,7478833,'532',3.333,3),(437,7478847,7478833,'32c',3.333,3),(437,7478848,7478833,'2c8',3.333,3),(437,7478849,7478833,'c86',3.333,3),(437,7478850,7478833,'863',3.333,3),(437,7478851,7478833,'63a',3.333,3),(437,7478852,7478833,'3ae',3.333,3),(437,7478853,7478833,'aee',3.333,3),(437,7478854,7478833,'ee4',3.333,3),(437,7478855,7478833,'e47',3.333,3),(437,7478856,7478833,'47b',3.333,3),(437,7478857,7478833,'7b5',3.333,3),(437,7478858,7478833,'b5f',3.333,3),(437,7478859,7478833,'5f5',3.333,3),(437,7478860,7478833,'f50',3.333,3),(437,7478861,7478833,'504',3.333,3),(437,7478862,7478833,'049',3.333,3),(437,7478863,7478833,'49f',3.333,3),(437,7478864,7478834,'mon',100,1),(437,7478865,7478864,'201',50,1),(437,7478866,7478864,'013',50,1),(437,7478867,7478865,'adm',33.333,3),(437,7478868,7478865,'dmi',33.333,3),(437,7478869,7478865,'min',33.333,3),(437,7478870,7478867,'cap',16.667,1),(437,7478871,7478867,'apa',16.667,1),(437,7478872,7478867,'pac',16.667,1),(437,7478873,7478867,'aci',16.667,1),(437,7478874,7478867,'cit',16.667,1),(437,7478875,7478867,'ity',16.667,1),(437,7478876,7478870,'pat',50,1),(437,7478877,7478870,'ath',50,1),(437,7478878,7478876,'fre',14.286,1),(437,7478879,7478876,'ree',14.286,1),(437,7478880,7478876,'ees',14.286,1),(437,7478881,7478876,'esp',14.286,1),(437,7478882,7478876,'spa',14.286,1),(437,7478883,7478876,'pac',14.286,1),(437,7478884,7478876,'ace',14.286,1),(437,7478885,7478878,'dis',50,1),(437,7478886,7478878,'isk',50,1),(437,7478887,7478885,'ind',33.333,1),(437,7478888,7478885,'nde',33.333,1),(437,7478889,7478885,'dex',33.333,1),(437,7478890,7478887,'adm',8.333,1),(437,7478891,7478887,'dmi',8.333,1),(437,7478892,7478887,'min',8.333,1),(437,7478893,7478887,'ini',8.333,1),(437,7478894,7478887,'nis',8.333,1),(437,7478895,7478887,'ist',8.333,1),(437,7478896,7478887,'str',8.333,1),(437,7478897,7478887,'tra',8.333,1),(437,7478898,7478887,'rat',8.333,1),(437,7478899,7478887,'ati',8.333,1),(437,7478900,7478887,'tio',8.333,1),(437,7478901,7478887,'ion',8.333,1),(437,7478902,7478890,'sta',33.333,3),(437,7478903,7478890,'tat',33.333,3),(437,7478904,7478890,'ate',33.333,3),(437,7478905,7478902,'ena',20,2),(437,7478906,7478902,'nab',20,2),(437,7478907,7478902,'abl',20,2),(437,7478908,7478902,'ble',20,2),(437,7478909,7478902,'led',20,2),(437,7478910,7478905,'cac',33.333,2),(437,7478911,7478905,'ach',33.333,2),(437,7478912,7478905,'che',33.333,2),(437,7478913,7478910,'mod',50,1),(437,7478914,7478910,'ode',50,1),(437,7478915,7478913,'wri',14.286,1),(437,7478916,7478913,'rit',14.286,1),(437,7478917,7478913,'ite',14.286,1),(437,7478918,7478913,'tet',14.286,1),(437,7478919,7478913,'eth',14.286,1),(437,7478920,7478913,'thr',14.286,1),(437,7478921,7478913,'hru',14.286,1),(437,7478922,7478915,'ope',11.111,2),(437,7478923,7478915,'per',11.111,2),(437,7478924,7478915,'era',11.111,2),(437,7478925,7478915,'rat',11.111,2),(437,7478926,7478915,'ati',11.111,2),(437,7478927,7478915,'tio',11.111,2),(437,7478928,7478915,'ion',11.111,2),(437,7478929,7478915,'ona',11.111,2),(437,7478930,7478915,'nal',11.111,2),(437,7478931,7478922,'pen',20,1),(437,7478932,7478922,'end',20,1),(437,7478933,7478922,'ndi',20,1),(437,7478934,7478922,'din',20,1),(437,7478935,7478922,'ing',20,1),(437,7478936,7478931,'mes',20,1),(437,7478937,7478931,'ess',20,1),(437,7478938,7478931,'ssa',20,1),(437,7478939,7478931,'sag',20,1),(437,7478940,7478931,'age',20,1),(437,7478941,7478936,'wai',20,1),(437,7478942,7478936,'ait',20,1),(437,7478943,7478936,'iti',20,1),(437,7478944,7478936,'tin',20,1),(437,7478945,7478936,'ing',20,1),(437,7478946,7478941,'for',100,1),(437,7478947,7478946,'per',11.111,1),(437,7478948,7478946,'erf',11.111,1),(437,7478949,7478946,'rfo',11.111,1),(437,7478950,7478946,'for',11.111,1),(437,7478951,7478946,'orm',11.111,1),(437,7478952,7478946,'rma',11.111,1),(437,7478953,7478946,'man',11.111,1),(437,7478954,7478946,'anc',11.111,1),(437,7478955,7478946,'nce',11.111,1),(437,7478956,7478947,'ide',12.5,1),(437,7478957,7478947,'den',12.5,1),(437,7478958,7478947,'ent',12.5,1),(437,7478959,7478947,'nti',12.5,1),(437,7478960,7478947,'tif',12.5,1),(437,7478961,7478947,'ifi',12.5,1),(437,7478962,7478947,'fie',12.5,1),(437,7478963,7478947,'ier',12.5,1),(437,7478964,7478956,'vdi',33.333,3),(437,7478965,7478956,'dis',33.333,3),(437,7478966,7478956,'isk',33.333,3),(437,7478967,7478964,'nam',50,1),(437,7478968,7478964,'ame',50,1),(437,7478969,7478967,'typ',50,1),(437,7478970,7478967,'ype',50,1),(437,7478971,7478969,'dir',25,1),(437,7478972,7478969,'ire',25,1),(437,7478973,7478969,'rec',25,1),(437,7478974,7478969,'ect',25,1),(438,7478976,7478975,'naa',100,2),(438,7478977,7478976,'600',3.333,3),(438,7478978,7478976,'000',3.333,3),(438,7478979,7478976,'00c',3.333,3),(438,7478980,7478976,'0c2',3.333,3),(438,7478981,7478976,'c29',3.333,3),(438,7478982,7478976,'29f',3.333,3),(438,7478983,7478976,'9f1',3.333,3),(438,7478984,7478976,'f15',3.333,3),(438,7478985,7478976,'155',3.333,3),(438,7478986,7478976,'55e',3.333,3),(438,7478987,7478976,'5ed',3.333,3),(438,7478988,7478976,'edb',3.333,3),(438,7478989,7478976,'dba',3.333,3),(438,7478990,7478976,'ba6',3.333,3),(438,7478991,7478976,'a69',3.333,3),(438,7478992,7478976,'699',3.333,3),(438,7478993,7478976,'99a',3.333,3),(438,7478994,7478976,'9af',3.333,3),(438,7478995,7478976,'afe',3.333,3),(438,7478996,7478976,'fe8',3.333,3),(438,7478997,7478976,'e8c',3.333,3),(438,7478998,7478976,'8c5',3.333,3),(438,7478999,7478976,'c5a',3.333,3),(438,7479000,7478976,'5ae',3.333,3),(438,7479001,7478976,'ae9',3.333,3),(438,7479002,7478976,'e93',3.333,3),(438,7479003,7478976,'930',3.333,3),(438,7479004,7478976,'301',3.333,3),(438,7479005,7478976,'014',3.333,3),(438,7479006,7478976,'141',3.333,3),(438,7479007,7478977,'mon',100,1),(438,7479008,7479007,'201',50,1),(438,7479009,7479007,'013',50,1),(438,7479010,7479008,'adm',33.333,3),(438,7479011,7479008,'dmi',33.333,3),(438,7479012,7479008,'min',33.333,3),(438,7479013,7479010,'cap',16.667,1),(438,7479014,7479010,'apa',16.667,1),(438,7479015,7479010,'pac',16.667,1),(438,7479016,7479010,'aci',16.667,1),(438,7479017,7479010,'cit',16.667,1),(438,7479018,7479010,'ity',16.667,1),(438,7479019,7479013,'pat',50,1),(438,7479020,7479013,'ath',50,1),(438,7479021,7479019,'fre',14.286,1),(438,7479022,7479019,'ree',14.286,1),(438,7479023,7479019,'ees',14.286,1),(438,7479024,7479019,'esp',14.286,1),(438,7479025,7479019,'spa',14.286,1),(438,7479026,7479019,'pac',14.286,1),(438,7479027,7479019,'ace',14.286,1),(438,7479028,7479021,'dis',50,1),(438,7479029,7479021,'isk',50,1),(438,7479030,7479028,'ind',33.333,1),(438,7479031,7479028,'nde',33.333,1),(438,7479032,7479028,'dex',33.333,1),(438,7479033,7479030,'adm',8.333,1),(438,7479034,7479030,'dmi',8.333,1),(438,7479035,7479030,'min',8.333,1),(438,7479036,7479030,'ini',8.333,1),(438,7479037,7479030,'nis',8.333,1),(438,7479038,7479030,'ist',8.333,1),(438,7479039,7479030,'str',8.333,1),(438,7479040,7479030,'tra',8.333,1),(438,7479041,7479030,'rat',8.333,1),(438,7479042,7479030,'ati',8.333,1),(438,7479043,7479030,'tio',8.333,1),(438,7479044,7479030,'ion',8.333,1),(438,7479045,7479033,'sta',33.333,3),(438,7479046,7479033,'tat',33.333,3),(438,7479047,7479033,'ate',33.333,3),(438,7479048,7479045,'ena',20,2),(438,7479049,7479045,'nab',20,2),(438,7479050,7479045,'abl',20,2),(438,7479051,7479045,'ble',20,2),(438,7479052,7479045,'led',20,2),(438,7479053,7479048,'cac',33.333,2),(438,7479054,7479048,'ach',33.333,2),(438,7479055,7479048,'che',33.333,2),(438,7479056,7479053,'mod',50,1),(438,7479057,7479053,'ode',50,1),(438,7479058,7479056,'wri',14.286,1),(438,7479059,7479056,'rit',14.286,1),(438,7479060,7479056,'ite',14.286,1),(438,7479061,7479056,'tet',14.286,1),(438,7479062,7479056,'eth',14.286,1),(438,7479063,7479056,'thr',14.286,1),(438,7479064,7479056,'hru',14.286,1),(438,7479065,7479058,'ope',11.111,2),(438,7479066,7479058,'per',11.111,2),(438,7479067,7479058,'era',11.111,2),(438,7479068,7479058,'rat',11.111,2),(438,7479069,7479058,'ati',11.111,2),(438,7479070,7479058,'tio',11.111,2),(438,7479071,7479058,'ion',11.111,2),(438,7479072,7479058,'ona',11.111,2),(438,7479073,7479058,'nal',11.111,2),(438,7479074,7479065,'pen',20,1),(438,7479075,7479065,'end',20,1),(438,7479076,7479065,'ndi',20,1),(438,7479077,7479065,'din',20,1),(438,7479078,7479065,'ing',20,1),(438,7479079,7479074,'mes',20,1),(438,7479080,7479074,'ess',20,1),(438,7479081,7479074,'ssa',20,1),(438,7479082,7479074,'sag',20,1),(438,7479083,7479074,'age',20,1),(438,7479084,7479079,'wai',20,1),(438,7479085,7479079,'ait',20,1),(438,7479086,7479079,'iti',20,1),(438,7479087,7479079,'tin',20,1),(438,7479088,7479079,'ing',20,1),(438,7479089,7479084,'for',100,1),(438,7479090,7479089,'per',11.111,1),(438,7479091,7479089,'erf',11.111,1),(438,7479092,7479089,'rfo',11.111,1),(438,7479093,7479089,'for',11.111,1),(438,7479094,7479089,'orm',11.111,1),(438,7479095,7479089,'rma',11.111,1),(438,7479096,7479089,'man',11.111,1),(438,7479097,7479089,'anc',11.111,1),(438,7479098,7479089,'nce',11.111,1),(438,7479099,7479090,'ide',12.5,1),(438,7479100,7479090,'den',12.5,1),(438,7479101,7479090,'ent',12.5,1),(438,7479102,7479090,'nti',12.5,1),(438,7479103,7479090,'tif',12.5,1),(438,7479104,7479090,'ifi',12.5,1),(438,7479105,7479090,'fie',12.5,1),(438,7479106,7479090,'ier',12.5,1),(438,7479107,7479099,'vdi',33.333,3),(438,7479108,7479099,'dis',33.333,3),(438,7479109,7479099,'isk',33.333,3),(438,7479110,7479107,'nam',50,1),(438,7479111,7479107,'ame',50,1),(438,7479112,7479110,'typ',50,1),(438,7479113,7479110,'ype',50,1),(438,7479114,7479112,'dir',25,1),(438,7479115,7479112,'ire',25,1),(438,7479116,7479112,'rec',25,1),(438,7479117,7479112,'ect',25,1),(439,7479119,7479118,'naa',100,2),(439,7479120,7479119,'600',3.333,3),(439,7479121,7479119,'000',3.333,3),(439,7479122,7479119,'00c',3.333,3),(439,7479123,7479119,'0c2',3.333,3),(439,7479124,7479119,'c29',3.333,3),(439,7479125,7479119,'296',3.333,3),(439,7479126,7479119,'96c',3.333,3),(439,7479127,7479119,'6cc',3.333,3),(439,7479128,7479119,'ccd',3.333,3),(439,7479129,7479119,'cde',3.333,3),(439,7479130,7479119,'deb',3.333,3),(439,7479131,7479119,'eb9',3.333,3),(439,7479132,7479119,'b94',3.333,3),(439,7479133,7479119,'945',3.333,3),(439,7479134,7479119,'458',3.333,3),(439,7479135,7479119,'58e',3.333,3),(439,7479136,7479119,'8e6',3.333,3),(439,7479137,7479119,'e68',3.333,3),(439,7479138,7479119,'68e',3.333,3),(439,7479139,7479119,'8e3',3.333,3),(439,7479140,7479119,'e33',3.333,3),(439,7479141,7479119,'338',3.333,3),(439,7479142,7479119,'38f',3.333,3),(439,7479143,7479119,'8f3',3.333,3),(439,7479144,7479119,'f3c',3.333,3),(439,7479145,7479119,'3cd',3.333,3),(439,7479146,7479119,'cd6',3.333,3),(439,7479147,7479119,'d6a',3.333,3),(439,7479148,7479119,'6a8',3.333,3),(439,7479149,7479119,'a82',3.333,3),(439,7479150,7479120,'mon',100,1),(439,7479151,7479150,'201',50,1),(439,7479152,7479150,'013',50,1),(439,7479153,7479151,'adm',33.333,3),(439,7479154,7479151,'dmi',33.333,3),(439,7479155,7479151,'min',33.333,3),(439,7479156,7479153,'cap',16.667,1),(439,7479157,7479153,'apa',16.667,1),(439,7479158,7479153,'pac',16.667,1),(439,7479159,7479153,'aci',16.667,1),(439,7479160,7479153,'cit',16.667,1),(439,7479161,7479153,'ity',16.667,1),(439,7479162,7479156,'pat',50,1),(439,7479163,7479156,'ath',50,1),(439,7479164,7479162,'fre',14.286,1),(439,7479165,7479162,'ree',14.286,1),(439,7479166,7479162,'ees',14.286,1),(439,7479167,7479162,'esp',14.286,1),(439,7479168,7479162,'spa',14.286,1),(439,7479169,7479162,'pac',14.286,1),(439,7479170,7479162,'ace',14.286,1),(439,7479171,7479164,'dis',50,1),(439,7479172,7479164,'isk',50,1),(439,7479173,7479171,'ind',33.333,1),(439,7479174,7479171,'nde',33.333,1),(439,7479175,7479171,'dex',33.333,1),(439,7479176,7479173,'adm',8.333,1),(439,7479177,7479173,'dmi',8.333,1),(439,7479178,7479173,'min',8.333,1),(439,7479179,7479173,'ini',8.333,1),(439,7479180,7479173,'nis',8.333,1),(439,7479181,7479173,'ist',8.333,1),(439,7479182,7479173,'str',8.333,1),(439,7479183,7479173,'tra',8.333,1),(439,7479184,7479173,'rat',8.333,1),(439,7479185,7479173,'ati',8.333,1),(439,7479186,7479173,'tio',8.333,1),(439,7479187,7479173,'ion',8.333,1),(439,7479188,7479176,'sta',33.333,3),(439,7479189,7479176,'tat',33.333,3),(439,7479190,7479176,'ate',33.333,3),(439,7479191,7479188,'ena',20,2),(439,7479192,7479188,'nab',20,2),(439,7479193,7479188,'abl',20,2),(439,7479194,7479188,'ble',20,2),(439,7479195,7479188,'led',20,2),(439,7479196,7479191,'cac',33.333,2),(439,7479197,7479191,'ach',33.333,2),(439,7479198,7479191,'che',33.333,2),(439,7479199,7479196,'mod',50,1),(439,7479200,7479196,'ode',50,1),(439,7479201,7479199,'wri',14.286,1),(439,7479202,7479199,'rit',14.286,1),(439,7479203,7479199,'ite',14.286,1),(439,7479204,7479199,'tet',14.286,1),(439,7479205,7479199,'eth',14.286,1),(439,7479206,7479199,'thr',14.286,1),(439,7479207,7479199,'hru',14.286,1),(439,7479208,7479201,'ope',11.111,2),(439,7479209,7479201,'per',11.111,2),(439,7479210,7479201,'era',11.111,2),(439,7479211,7479201,'rat',11.111,2),(439,7479212,7479201,'ati',11.111,2),(439,7479213,7479201,'tio',11.111,2),(439,7479214,7479201,'ion',11.111,2),(439,7479215,7479201,'ona',11.111,2),(439,7479216,7479201,'nal',11.111,2),(439,7479217,7479208,'pen',20,1),(439,7479218,7479208,'end',20,1),(439,7479219,7479208,'ndi',20,1),(439,7479220,7479208,'din',20,1),(439,7479221,7479208,'ing',20,1),(439,7479222,7479217,'mes',20,1),(439,7479223,7479217,'ess',20,1),(439,7479224,7479217,'ssa',20,1),(439,7479225,7479217,'sag',20,1),(439,7479226,7479217,'age',20,1),(439,7479227,7479222,'wai',20,1),(439,7479228,7479222,'ait',20,1),(439,7479229,7479222,'iti',20,1),(439,7479230,7479222,'tin',20,1),(439,7479231,7479222,'ing',20,1),(439,7479232,7479227,'for',100,1),(439,7479233,7479232,'per',11.111,1),(439,7479234,7479232,'erf',11.111,1),(439,7479235,7479232,'rfo',11.111,1),(439,7479236,7479232,'for',11.111,1),(439,7479237,7479232,'orm',11.111,1),(439,7479238,7479232,'rma',11.111,1),(439,7479239,7479232,'man',11.111,1),(439,7479240,7479232,'anc',11.111,1),(439,7479241,7479232,'nce',11.111,1),(439,7479242,7479233,'ide',12.5,1),(439,7479243,7479233,'den',12.5,1),(439,7479244,7479233,'ent',12.5,1),(439,7479245,7479233,'nti',12.5,1),(439,7479246,7479233,'tif',12.5,1),(439,7479247,7479233,'ifi',12.5,1),(439,7479248,7479233,'fie',12.5,1),(439,7479249,7479233,'ier',12.5,1),(439,7479250,7479242,'vdi',33.333,3),(439,7479251,7479242,'dis',33.333,3),(439,7479252,7479242,'isk',33.333,3),(439,7479253,7479250,'nam',50,1),(439,7479254,7479250,'ame',50,1),(439,7479255,7479253,'typ',50,1),(439,7479256,7479253,'ype',50,1),(439,7479257,7479255,'dir',25,1),(439,7479258,7479255,'ire',25,1),(439,7479259,7479255,'rec',25,1),(439,7479260,7479255,'ect',25,1),(440,7479262,7479261,'naa',100,2),(440,7479263,7479262,'600',3.333,3),(440,7479264,7479262,'000',3.333,3),(440,7479265,7479262,'00c',3.333,3),(440,7479266,7479262,'0c2',3.333,3),(440,7479267,7479262,'c29',3.333,3),(440,7479268,7479262,'29f',3.333,3),(440,7479269,7479262,'9fb',3.333,3),(440,7479270,7479262,'fb5',3.333,3),(440,7479271,7479262,'b54',3.333,3),(440,7479272,7479262,'547',3.333,3),(440,7479273,7479262,'474',3.333,3),(440,7479274,7479262,'74c',3.333,3),(440,7479275,7479262,'4c2',3.333,3),(440,7479276,7479262,'c24',3.333,3),(440,7479277,7479262,'246',3.333,3),(440,7479278,7479262,'46b',3.333,3),(440,7479279,7479262,'6b5',3.333,3),(440,7479280,7479262,'b50',3.333,3),(440,7479281,7479262,'501',3.333,3),(440,7479282,7479262,'01f',3.333,3),(440,7479283,7479262,'1f6',3.333,3),(440,7479284,7479262,'f64',3.333,3),(440,7479285,7479262,'641',3.333,3),(440,7479286,7479262,'412',3.333,3),(440,7479287,7479262,'126',3.333,3),(440,7479288,7479262,'260',3.333,3),(440,7479289,7479262,'606',3.333,3),(440,7479290,7479262,'061',3.333,3),(440,7479291,7479262,'617',3.333,3),(440,7479292,7479262,'177',3.333,3),(440,7479293,7479263,'mon',100,1),(440,7479294,7479293,'201',50,1),(440,7479295,7479293,'013',50,1),(440,7479296,7479294,'adm',33.333,3),(440,7479297,7479294,'dmi',33.333,3),(440,7479298,7479294,'min',33.333,3),(440,7479299,7479296,'cap',16.667,1),(440,7479300,7479296,'apa',16.667,1),(440,7479301,7479296,'pac',16.667,1),(440,7479302,7479296,'aci',16.667,1),(440,7479303,7479296,'cit',16.667,1),(440,7479304,7479296,'ity',16.667,1),(440,7479305,7479299,'pat',50,1),(440,7479306,7479299,'ath',50,1),(440,7479307,7479305,'fre',14.286,1),(440,7479308,7479305,'ree',14.286,1),(440,7479309,7479305,'ees',14.286,1),(440,7479310,7479305,'esp',14.286,1),(440,7479311,7479305,'spa',14.286,1),(440,7479312,7479305,'pac',14.286,1),(440,7479313,7479305,'ace',14.286,1),(440,7479314,7479307,'dis',50,1),(440,7479315,7479307,'isk',50,1),(440,7479316,7479314,'ind',33.333,1),(440,7479317,7479314,'nde',33.333,1),(440,7479318,7479314,'dex',33.333,1),(440,7479319,7479316,'adm',8.333,1),(440,7479320,7479316,'dmi',8.333,1),(440,7479321,7479316,'min',8.333,1),(440,7479322,7479316,'ini',8.333,1),(440,7479323,7479316,'nis',8.333,1),(440,7479324,7479316,'ist',8.333,1),(440,7479325,7479316,'str',8.333,1),(440,7479326,7479316,'tra',8.333,1),(440,7479327,7479316,'rat',8.333,1),(440,7479328,7479316,'ati',8.333,1),(440,7479329,7479316,'tio',8.333,1),(440,7479330,7479316,'ion',8.333,1),(440,7479331,7479319,'sta',33.333,3),(440,7479332,7479319,'tat',33.333,3),(440,7479333,7479319,'ate',33.333,3),(440,7479334,7479331,'ena',20,2),(440,7479335,7479331,'nab',20,2),(440,7479336,7479331,'abl',20,2),(440,7479337,7479331,'ble',20,2),(440,7479338,7479331,'led',20,2),(440,7479339,7479334,'cac',33.333,2),(440,7479340,7479334,'ach',33.333,2),(440,7479341,7479334,'che',33.333,2),(440,7479342,7479339,'mod',50,1),(440,7479343,7479339,'ode',50,1),(440,7479344,7479342,'wri',14.286,1),(440,7479345,7479342,'rit',14.286,1),(440,7479346,7479342,'ite',14.286,1),(440,7479347,7479342,'tet',14.286,1),(440,7479348,7479342,'eth',14.286,1),(440,7479349,7479342,'thr',14.286,1),(440,7479350,7479342,'hru',14.286,1),(440,7479351,7479344,'ope',11.111,2),(440,7479352,7479344,'per',11.111,2),(440,7479353,7479344,'era',11.111,2),(440,7479354,7479344,'rat',11.111,2),(440,7479355,7479344,'ati',11.111,2),(440,7479356,7479344,'tio',11.111,2),(440,7479357,7479344,'ion',11.111,2),(440,7479358,7479344,'ona',11.111,2),(440,7479359,7479344,'nal',11.111,2),(440,7479360,7479351,'pen',20,1),(440,7479361,7479351,'end',20,1),(440,7479362,7479351,'ndi',20,1),(440,7479363,7479351,'din',20,1),(440,7479364,7479351,'ing',20,1),(440,7479365,7479360,'mes',20,1),(440,7479366,7479360,'ess',20,1),(440,7479367,7479360,'ssa',20,1),(440,7479368,7479360,'sag',20,1),(440,7479369,7479360,'age',20,1),(440,7479370,7479365,'wai',20,1),(440,7479371,7479365,'ait',20,1),(440,7479372,7479365,'iti',20,1),(440,7479373,7479365,'tin',20,1),(440,7479374,7479365,'ing',20,1),(440,7479375,7479370,'for',100,1),(440,7479376,7479375,'per',11.111,1),(440,7479377,7479375,'erf',11.111,1),(440,7479378,7479375,'rfo',11.111,1),(440,7479379,7479375,'for',11.111,1),(440,7479380,7479375,'orm',11.111,1),(440,7479381,7479375,'rma',11.111,1),(440,7479382,7479375,'man',11.111,1),(440,7479383,7479375,'anc',11.111,1),(440,7479384,7479375,'nce',11.111,1),(440,7479385,7479376,'ide',12.5,1),(440,7479386,7479376,'den',12.5,1),(440,7479387,7479376,'ent',12.5,1),(440,7479388,7479376,'nti',12.5,1),(440,7479389,7479376,'tif',12.5,1),(440,7479390,7479376,'ifi',12.5,1),(440,7479391,7479376,'fie',12.5,1),(440,7479392,7479376,'ier',12.5,1),(440,7479393,7479385,'vdi',33.333,3),(440,7479394,7479385,'dis',33.333,3),(440,7479395,7479385,'isk',33.333,3),(440,7479396,7479393,'nam',50,1),(440,7479397,7479393,'ame',50,1),(440,7479398,7479396,'typ',50,1),(440,7479399,7479396,'ype',50,1),(440,7479400,7479398,'dir',25,1),(440,7479401,7479398,'ire',25,1),(440,7479402,7479398,'rec',25,1),(440,7479403,7479398,'ect',25,1),(441,7479405,7479404,'naa',100,2),(441,7479406,7479405,'600',3.333,3),(441,7479407,7479405,'000',3.333,3),(441,7479408,7479405,'00c',3.333,3),(441,7479409,7479405,'0c2',3.333,3),(441,7479410,7479405,'c29',3.333,3),(441,7479411,7479405,'29e',3.333,3),(441,7479412,7479405,'9e9',3.333,3),(441,7479413,7479405,'e90',3.333,3),(441,7479414,7479405,'902',3.333,3),(441,7479415,7479405,'026',3.333,3),(441,7479416,7479405,'267',3.333,3),(441,7479417,7479405,'67a',3.333,3),(441,7479418,7479405,'7af',3.333,3),(441,7479419,7479405,'af7',3.333,3),(441,7479420,7479405,'f74',3.333,3),(441,7479421,7479405,'746',3.333,3),(441,7479422,7479405,'461',3.333,3),(441,7479423,7479405,'612',3.333,3),(441,7479424,7479405,'12b',3.333,3),(441,7479425,7479405,'2bf',3.333,3),(441,7479426,7479405,'bf0',3.333,3),(441,7479427,7479405,'f02',3.333,3),(441,7479428,7479405,'02c',3.333,3),(441,7479429,7479405,'2c8',3.333,3),(441,7479430,7479405,'c86',3.333,3),(441,7479431,7479405,'867',3.333,3),(441,7479432,7479405,'67a',3.333,3),(441,7479433,7479405,'7a8',3.333,3),(441,7479434,7479405,'a8a',3.333,3),(441,7479435,7479405,'8a9',3.333,3),(441,7479436,7479406,'mon',100,1),(441,7479437,7479436,'201',50,1),(441,7479438,7479436,'013',50,1),(441,7479439,7479437,'adm',33.333,3),(441,7479440,7479437,'dmi',33.333,3),(441,7479441,7479437,'min',33.333,3),(441,7479442,7479439,'cap',16.667,1),(441,7479443,7479439,'apa',16.667,1),(441,7479444,7479439,'pac',16.667,1),(441,7479445,7479439,'aci',16.667,1),(441,7479446,7479439,'cit',16.667,1),(441,7479447,7479439,'ity',16.667,1),(441,7479448,7479442,'pat',50,1),(441,7479449,7479442,'ath',50,1),(441,7479450,7479448,'fre',14.286,1),(441,7479451,7479448,'ree',14.286,1),(441,7479452,7479448,'ees',14.286,1),(441,7479453,7479448,'esp',14.286,1),(441,7479454,7479448,'spa',14.286,1),(441,7479455,7479448,'pac',14.286,1),(441,7479456,7479448,'ace',14.286,1),(441,7479457,7479450,'dis',50,1),(441,7479458,7479450,'isk',50,1),(441,7479459,7479457,'ind',33.333,1),(441,7479460,7479457,'nde',33.333,1),(441,7479461,7479457,'dex',33.333,1),(441,7479462,7479459,'adm',8.333,1),(441,7479463,7479459,'dmi',8.333,1),(441,7479464,7479459,'min',8.333,1),(441,7479465,7479459,'ini',8.333,1),(441,7479466,7479459,'nis',8.333,1),(441,7479467,7479459,'ist',8.333,1),(441,7479468,7479459,'str',8.333,1),(441,7479469,7479459,'tra',8.333,1),(441,7479470,7479459,'rat',8.333,1),(441,7479471,7479459,'ati',8.333,1),(441,7479472,7479459,'tio',8.333,1),(441,7479473,7479459,'ion',8.333,1),(441,7479474,7479462,'sta',33.333,3),(441,7479475,7479462,'tat',33.333,3),(441,7479476,7479462,'ate',33.333,3),(441,7479477,7479474,'ena',20,2),(441,7479478,7479474,'nab',20,2),(441,7479479,7479474,'abl',20,2),(441,7479480,7479474,'ble',20,2),(441,7479481,7479474,'led',20,2),(441,7479482,7479477,'cac',33.333,2),(441,7479483,7479477,'ach',33.333,2),(441,7479484,7479477,'che',33.333,2),(441,7479485,7479482,'mod',50,1),(441,7479486,7479482,'ode',50,1),(441,7479487,7479485,'wri',14.286,1),(441,7479488,7479485,'rit',14.286,1),(441,7479489,7479485,'ite',14.286,1),(441,7479490,7479485,'tet',14.286,1),(441,7479491,7479485,'eth',14.286,1),(441,7479492,7479485,'thr',14.286,1),(441,7479493,7479485,'hru',14.286,1),(441,7479494,7479487,'ope',11.111,2),(441,7479495,7479487,'per',11.111,2),(441,7479496,7479487,'era',11.111,2),(441,7479497,7479487,'rat',11.111,2),(441,7479498,7479487,'ati',11.111,2),(441,7479499,7479487,'tio',11.111,2),(441,7479500,7479487,'ion',11.111,2),(441,7479501,7479487,'ona',11.111,2),(441,7479502,7479487,'nal',11.111,2),(441,7479503,7479494,'pen',20,1),(441,7479504,7479494,'end',20,1),(441,7479505,7479494,'ndi',20,1),(441,7479506,7479494,'din',20,1),(441,7479507,7479494,'ing',20,1),(441,7479508,7479503,'mes',20,1),(441,7479509,7479503,'ess',20,1),(441,7479510,7479503,'ssa',20,1),(441,7479511,7479503,'sag',20,1),(441,7479512,7479503,'age',20,1),(441,7479513,7479508,'wai',20,1),(441,7479514,7479508,'ait',20,1),(441,7479515,7479508,'iti',20,1),(441,7479516,7479508,'tin',20,1),(441,7479517,7479508,'ing',20,1),(441,7479518,7479513,'for',100,1),(441,7479519,7479518,'per',11.111,1),(441,7479520,7479518,'erf',11.111,1),(441,7479521,7479518,'rfo',11.111,1),(441,7479522,7479518,'for',11.111,1),(441,7479523,7479518,'orm',11.111,1),(441,7479524,7479518,'rma',11.111,1),(441,7479525,7479518,'man',11.111,1),(441,7479526,7479518,'anc',11.111,1),(441,7479527,7479518,'nce',11.111,1),(441,7479528,7479519,'ide',12.5,1),(441,7479529,7479519,'den',12.5,1),(441,7479530,7479519,'ent',12.5,1),(441,7479531,7479519,'nti',12.5,1),(441,7479532,7479519,'tif',12.5,1),(441,7479533,7479519,'ifi',12.5,1),(441,7479534,7479519,'fie',12.5,1),(441,7479535,7479519,'ier',12.5,1),(441,7479536,7479528,'vdi',33.333,3),(441,7479537,7479528,'dis',33.333,3),(441,7479538,7479528,'isk',33.333,3),(441,7479539,7479536,'nam',50,1),(441,7479540,7479536,'ame',50,1),(441,7479541,7479539,'typ',50,1),(441,7479542,7479539,'ype',50,1),(441,7479543,7479541,'dir',25,1),(441,7479544,7479541,'ire',25,1),(441,7479545,7479541,'rec',25,1),(441,7479546,7479541,'ect',25,1),(442,7479548,7479547,'naa',100,2),(442,7479549,7479548,'600',3.333,3),(442,7479550,7479548,'000',3.333,3),(442,7479551,7479548,'00c',3.333,3),(442,7479552,7479548,'0c2',3.333,3),(442,7479553,7479548,'c29',3.333,3),(442,7479554,7479548,'29b',3.333,3),(442,7479555,7479548,'9bf',3.333,3),(442,7479556,7479548,'bf7',3.333,3),(442,7479557,7479548,'f70',3.333,3),(442,7479558,7479548,'708',3.333,3),(442,7479559,7479548,'087',3.333,3),(442,7479560,7479548,'877',3.333,3),(442,7479561,7479548,'777',3.333,3),(442,7479562,7479548,'777',3.333,3),(442,7479563,7479548,'77c',3.333,3),(442,7479564,7479548,'7c6',3.333,3),(442,7479565,7479548,'c6b',3.333,3),(442,7479566,7479548,'6b1',3.333,3),(442,7479567,7479548,'b1a',3.333,3),(442,7479568,7479548,'1a0',3.333,3),(442,7479569,7479548,'a06',3.333,3),(442,7479570,7479548,'06a',3.333,3),(442,7479571,7479548,'6aa',3.333,3),(442,7479572,7479548,'aa3',3.333,3),(442,7479573,7479548,'a36',3.333,3),(442,7479574,7479548,'36a',3.333,3),(442,7479575,7479548,'6aa',3.333,3),(442,7479576,7479548,'aa0',3.333,3),(442,7479577,7479548,'a01',3.333,3),(442,7479578,7479548,'01b',3.333,3),(442,7479579,7479549,'mon',100,1),(442,7479580,7479579,'201',50,1),(442,7479581,7479579,'013',50,1),(442,7479582,7479580,'adm',33.333,3),(442,7479583,7479580,'dmi',33.333,3),(442,7479584,7479580,'min',33.333,3),(442,7479585,7479582,'cap',16.667,1),(442,7479586,7479582,'apa',16.667,1),(442,7479587,7479582,'pac',16.667,1),(442,7479588,7479582,'aci',16.667,1),(442,7479589,7479582,'cit',16.667,1),(442,7479590,7479582,'ity',16.667,1),(442,7479591,7479585,'pat',50,1),(442,7479592,7479585,'ath',50,1),(442,7479593,7479591,'fre',14.286,1),(442,7479594,7479591,'ree',14.286,1),(442,7479595,7479591,'ees',14.286,1),(442,7479596,7479591,'esp',14.286,1),(442,7479597,7479591,'spa',14.286,1),(442,7479598,7479591,'pac',14.286,1),(442,7479599,7479591,'ace',14.286,1),(442,7479600,7479593,'dis',50,1),(442,7479601,7479593,'isk',50,1),(442,7479602,7479600,'ind',33.333,1),(442,7479603,7479600,'nde',33.333,1),(442,7479604,7479600,'dex',33.333,1),(442,7479605,7479602,'adm',8.333,1),(442,7479606,7479602,'dmi',8.333,1),(442,7479607,7479602,'min',8.333,1),(442,7479608,7479602,'ini',8.333,1),(442,7479609,7479602,'nis',8.333,1),(442,7479610,7479602,'ist',8.333,1),(442,7479611,7479602,'str',8.333,1),(442,7479612,7479602,'tra',8.333,1),(442,7479613,7479602,'rat',8.333,1),(442,7479614,7479602,'ati',8.333,1),(442,7479615,7479602,'tio',8.333,1),(442,7479616,7479602,'ion',8.333,1),(442,7479617,7479605,'sta',33.333,3),(442,7479618,7479605,'tat',33.333,3),(442,7479619,7479605,'ate',33.333,3),(442,7479620,7479617,'ena',20,2),(442,7479621,7479617,'nab',20,2),(442,7479622,7479617,'abl',20,2),(442,7479623,7479617,'ble',20,2),(442,7479624,7479617,'led',20,2),(442,7479625,7479620,'cac',33.333,2),(442,7479626,7479620,'ach',33.333,2),(442,7479627,7479620,'che',33.333,2),(442,7479628,7479625,'mod',50,1),(442,7479629,7479625,'ode',50,1),(442,7479630,7479628,'wri',14.286,1),(442,7479631,7479628,'rit',14.286,1),(442,7479632,7479628,'ite',14.286,1),(442,7479633,7479628,'tet',14.286,1),(442,7479634,7479628,'eth',14.286,1),(442,7479635,7479628,'thr',14.286,1),(442,7479636,7479628,'hru',14.286,1),(442,7479637,7479630,'ope',11.111,2),(442,7479638,7479630,'per',11.111,2),(442,7479639,7479630,'era',11.111,2),(442,7479640,7479630,'rat',11.111,2),(442,7479641,7479630,'ati',11.111,2),(442,7479642,7479630,'tio',11.111,2),(442,7479643,7479630,'ion',11.111,2),(442,7479644,7479630,'ona',11.111,2),(442,7479645,7479630,'nal',11.111,2),(442,7479646,7479637,'pen',20,1),(442,7479647,7479637,'end',20,1),(442,7479648,7479637,'ndi',20,1),(442,7479649,7479637,'din',20,1),(442,7479650,7479637,'ing',20,1),(442,7479651,7479646,'mes',20,1),(442,7479652,7479646,'ess',20,1),(442,7479653,7479646,'ssa',20,1),(442,7479654,7479646,'sag',20,1),(442,7479655,7479646,'age',20,1),(442,7479656,7479651,'wai',20,1),(442,7479657,7479651,'ait',20,1),(442,7479658,7479651,'iti',20,1),(442,7479659,7479651,'tin',20,1),(442,7479660,7479651,'ing',20,1),(442,7479661,7479656,'for',100,1),(442,7479662,7479661,'per',11.111,1),(442,7479663,7479661,'erf',11.111,1),(442,7479664,7479661,'rfo',11.111,1),(442,7479665,7479661,'for',11.111,1),(442,7479666,7479661,'orm',11.111,1),(442,7479667,7479661,'rma',11.111,1),(442,7479668,7479661,'man',11.111,1),(442,7479669,7479661,'anc',11.111,1),(442,7479670,7479661,'nce',11.111,1),(442,7479671,7479662,'ide',12.5,1),(442,7479672,7479662,'den',12.5,1),(442,7479673,7479662,'ent',12.5,1),(442,7479674,7479662,'nti',12.5,1),(442,7479675,7479662,'tif',12.5,1),(442,7479676,7479662,'ifi',12.5,1),(442,7479677,7479662,'fie',12.5,1),(442,7479678,7479662,'ier',12.5,1),(442,7479679,7479671,'vdi',33.333,3),(442,7479680,7479671,'dis',33.333,3),(442,7479681,7479671,'isk',33.333,3),(442,7479682,7479679,'nam',50,1),(442,7479683,7479679,'ame',50,1),(442,7479684,7479682,'typ',50,1),(442,7479685,7479682,'ype',50,1),(442,7479686,7479684,'dir',25,1),(442,7479687,7479684,'ire',25,1),(442,7479688,7479684,'rec',25,1),(442,7479689,7479684,'ect',25,1),(443,7479691,7479690,'naa',100,2),(443,7479692,7479691,'600',3.333,3),(443,7479693,7479691,'000',3.333,3),(443,7479694,7479691,'00c',3.333,3),(443,7479695,7479691,'0c2',3.333,3),(443,7479696,7479691,'c29',3.333,3),(443,7479697,7479691,'296',3.333,3),(443,7479698,7479691,'96d',3.333,3),(443,7479699,7479691,'6d6',3.333,3),(443,7479700,7479691,'d61',3.333,3),(443,7479701,7479691,'616',3.333,3),(443,7479702,7479691,'16c',3.333,3),(443,7479703,7479691,'6c2',3.333,3),(443,7479704,7479691,'c27',3.333,3),(443,7479705,7479691,'278',3.333,3),(443,7479706,7479691,'780',3.333,3),(443,7479707,7479691,'808',3.333,3),(443,7479708,7479691,'083',3.333,3),(443,7479709,7479691,'83d',3.333,3),(443,7479710,7479691,'3d4',3.333,3),(443,7479711,7479691,'d43',3.333,3),(443,7479712,7479691,'439',3.333,3),(443,7479713,7479691,'392',3.333,3),(443,7479714,7479691,'923',3.333,3),(443,7479715,7479691,'231',3.333,3),(443,7479716,7479691,'319',3.333,3),(443,7479717,7479691,'197',3.333,3),(443,7479718,7479691,'976',3.333,3),(443,7479719,7479691,'761',3.333,3),(443,7479720,7479691,'613',3.333,3),(443,7479721,7479691,'13d',3.333,3),(443,7479722,7479692,'mon',100,1),(443,7479723,7479722,'201',50,1),(443,7479724,7479722,'013',50,1),(443,7479725,7479723,'adm',33.333,3),(443,7479726,7479723,'dmi',33.333,3),(443,7479727,7479723,'min',33.333,3),(443,7479728,7479725,'cap',16.667,1),(443,7479729,7479725,'apa',16.667,1),(443,7479730,7479725,'pac',16.667,1),(443,7479731,7479725,'aci',16.667,1),(443,7479732,7479725,'cit',16.667,1),(443,7479733,7479725,'ity',16.667,1),(443,7479734,7479728,'pat',50,1),(443,7479735,7479728,'ath',50,1),(443,7479736,7479734,'fre',14.286,1),(443,7479737,7479734,'ree',14.286,1),(443,7479738,7479734,'ees',14.286,1),(443,7479739,7479734,'esp',14.286,1),(443,7479740,7479734,'spa',14.286,1),(443,7479741,7479734,'pac',14.286,1),(443,7479742,7479734,'ace',14.286,1),(443,7479743,7479736,'dis',50,1),(443,7479744,7479736,'isk',50,1),(443,7479745,7479743,'ind',33.333,1),(443,7479746,7479743,'nde',33.333,1),(443,7479747,7479743,'dex',33.333,1),(443,7479748,7479745,'adm',8.333,1),(443,7479749,7479745,'dmi',8.333,1),(443,7479750,7479745,'min',8.333,1),(443,7479751,7479745,'ini',8.333,1),(443,7479752,7479745,'nis',8.333,1),(443,7479753,7479745,'ist',8.333,1),(443,7479754,7479745,'str',8.333,1),(443,7479755,7479745,'tra',8.333,1),(443,7479756,7479745,'rat',8.333,1),(443,7479757,7479745,'ati',8.333,1),(443,7479758,7479745,'tio',8.333,1),(443,7479759,7479745,'ion',8.333,1),(443,7479760,7479748,'sta',33.333,3),(443,7479761,7479748,'tat',33.333,3),(443,7479762,7479748,'ate',33.333,3),(443,7479763,7479760,'ena',20,2),(443,7479764,7479760,'nab',20,2),(443,7479765,7479760,'abl',20,2),(443,7479766,7479760,'ble',20,2),(443,7479767,7479760,'led',20,2),(443,7479768,7479763,'cac',33.333,2),(443,7479769,7479763,'ach',33.333,2),(443,7479770,7479763,'che',33.333,2),(443,7479771,7479768,'mod',50,1),(443,7479772,7479768,'ode',50,1),(443,7479773,7479771,'wri',14.286,1),(443,7479774,7479771,'rit',14.286,1),(443,7479775,7479771,'ite',14.286,1),(443,7479776,7479771,'tet',14.286,1),(443,7479777,7479771,'eth',14.286,1),(443,7479778,7479771,'thr',14.286,1),(443,7479779,7479771,'hru',14.286,1),(443,7479780,7479773,'ope',11.111,2),(443,7479781,7479773,'per',11.111,2),(443,7479782,7479773,'era',11.111,2),(443,7479783,7479773,'rat',11.111,2),(443,7479784,7479773,'ati',11.111,2),(443,7479785,7479773,'tio',11.111,2),(443,7479786,7479773,'ion',11.111,2),(443,7479787,7479773,'ona',11.111,2),(443,7479788,7479773,'nal',11.111,2),(443,7479789,7479780,'pen',20,1),(443,7479790,7479780,'end',20,1),(443,7479791,7479780,'ndi',20,1),(443,7479792,7479780,'din',20,1),(443,7479793,7479780,'ing',20,1),(443,7479794,7479789,'mes',20,1),(443,7479795,7479789,'ess',20,1),(443,7479796,7479789,'ssa',20,1),(443,7479797,7479789,'sag',20,1),(443,7479798,7479789,'age',20,1),(443,7479799,7479794,'wai',20,1),(443,7479800,7479794,'ait',20,1),(443,7479801,7479794,'iti',20,1),(443,7479802,7479794,'tin',20,1),(443,7479803,7479794,'ing',20,1),(443,7479804,7479799,'for',100,1),(443,7479805,7479804,'per',11.111,1),(443,7479806,7479804,'erf',11.111,1),(443,7479807,7479804,'rfo',11.111,1),(443,7479808,7479804,'for',11.111,1),(443,7479809,7479804,'orm',11.111,1),(443,7479810,7479804,'rma',11.111,1),(443,7479811,7479804,'man',11.111,1),(443,7479812,7479804,'anc',11.111,1),(443,7479813,7479804,'nce',11.111,1),(443,7479814,7479805,'ide',12.5,1),(443,7479815,7479805,'den',12.5,1),(443,7479816,7479805,'ent',12.5,1),(443,7479817,7479805,'nti',12.5,1),(443,7479818,7479805,'tif',12.5,1),(443,7479819,7479805,'ifi',12.5,1),(443,7479820,7479805,'fie',12.5,1),(443,7479821,7479805,'ier',12.5,1),(443,7479822,7479814,'vdi',33.333,3),(443,7479823,7479814,'dis',33.333,3),(443,7479824,7479814,'isk',33.333,3),(443,7479825,7479822,'nam',50,1),(443,7479826,7479822,'ame',50,1),(443,7479827,7479825,'typ',50,1),(443,7479828,7479825,'ype',50,1),(443,7479829,7479827,'dir',25,1),(443,7479830,7479827,'ire',25,1),(443,7479831,7479827,'rec',25,1),(443,7479832,7479827,'ect',25,1),(444,7479834,7479833,'naa',100,2),(444,7479835,7479834,'600',3.333,3),(444,7479836,7479834,'000',3.333,3),(444,7479837,7479834,'00c',3.333,3),(444,7479838,7479834,'0c2',3.333,3),(444,7479839,7479834,'c29',3.333,3),(444,7479840,7479834,'292',3.333,3),(444,7479841,7479834,'92e',3.333,3),(444,7479842,7479834,'2e5',3.333,3),(444,7479843,7479834,'e52',3.333,3),(444,7479844,7479834,'526',3.333,3),(444,7479845,7479834,'269',3.333,3),(444,7479846,7479834,'69f',3.333,3),(444,7479847,7479834,'9fc',3.333,3),(444,7479848,7479834,'fcf',3.333,3),(444,7479849,7479834,'cf7',3.333,3),(444,7479850,7479834,'f7b',3.333,3),(444,7479851,7479834,'7b9',3.333,3),(444,7479852,7479834,'b9a',3.333,3),(444,7479853,7479834,'9ac',3.333,3),(444,7479854,7479834,'ac9',3.333,3),(444,7479855,7479834,'c98',3.333,3),(444,7479856,7479834,'98f',3.333,3),(444,7479857,7479834,'8f5',3.333,3),(444,7479858,7479834,'f5a',3.333,3),(444,7479859,7479834,'5a5',3.333,3),(444,7479860,7479834,'a58',3.333,3),(444,7479861,7479834,'58d',3.333,3),(444,7479862,7479834,'8d9',3.333,3),(444,7479863,7479834,'d98',3.333,3),(444,7479864,7479834,'98d',3.333,3),(444,7479865,7479835,'mon',100,1),(444,7479866,7479865,'201',50,1),(444,7479867,7479865,'013',50,1),(444,7479868,7479866,'adm',33.333,3),(444,7479869,7479866,'dmi',33.333,3),(444,7479870,7479866,'min',33.333,3),(444,7479871,7479868,'cap',16.667,1),(444,7479872,7479868,'apa',16.667,1),(444,7479873,7479868,'pac',16.667,1),(444,7479874,7479868,'aci',16.667,1),(444,7479875,7479868,'cit',16.667,1),(444,7479876,7479868,'ity',16.667,1),(444,7479877,7479871,'pat',50,1),(444,7479878,7479871,'ath',50,1),(444,7479879,7479877,'fre',14.286,1),(444,7479880,7479877,'ree',14.286,1),(444,7479881,7479877,'ees',14.286,1),(444,7479882,7479877,'esp',14.286,1),(444,7479883,7479877,'spa',14.286,1),(444,7479884,7479877,'pac',14.286,1),(444,7479885,7479877,'ace',14.286,1),(444,7479886,7479879,'dis',50,1),(444,7479887,7479879,'isk',50,1),(444,7479888,7479886,'ind',33.333,1),(444,7479889,7479886,'nde',33.333,1),(444,7479890,7479886,'dex',33.333,1),(444,7479891,7479888,'adm',8.333,1),(444,7479892,7479888,'dmi',8.333,1),(444,7479893,7479888,'min',8.333,1),(444,7479894,7479888,'ini',8.333,1),(444,7479895,7479888,'nis',8.333,1),(444,7479896,7479888,'ist',8.333,1),(444,7479897,7479888,'str',8.333,1),(444,7479898,7479888,'tra',8.333,1),(444,7479899,7479888,'rat',8.333,1),(444,7479900,7479888,'ati',8.333,1),(444,7479901,7479888,'tio',8.333,1),(444,7479902,7479888,'ion',8.333,1),(444,7479903,7479891,'sta',33.333,3),(444,7479904,7479891,'tat',33.333,3),(444,7479905,7479891,'ate',33.333,3),(444,7479906,7479903,'ena',20,2),(444,7479907,7479903,'nab',20,2),(444,7479908,7479903,'abl',20,2),(444,7479909,7479903,'ble',20,2),(444,7479910,7479903,'led',20,2),(444,7479911,7479906,'cac',33.333,2),(444,7479912,7479906,'ach',33.333,2),(444,7479913,7479906,'che',33.333,2),(444,7479914,7479911,'mod',50,1),(444,7479915,7479911,'ode',50,1),(444,7479916,7479914,'wri',14.286,1),(444,7479917,7479914,'rit',14.286,1),(444,7479918,7479914,'ite',14.286,1),(444,7479919,7479914,'tet',14.286,1),(444,7479920,7479914,'eth',14.286,1),(444,7479921,7479914,'thr',14.286,1),(444,7479922,7479914,'hru',14.286,1),(444,7479923,7479916,'ope',11.111,2),(444,7479924,7479916,'per',11.111,2),(444,7479925,7479916,'era',11.111,2),(444,7479926,7479916,'rat',11.111,2),(444,7479927,7479916,'ati',11.111,2),(444,7479928,7479916,'tio',11.111,2),(444,7479929,7479916,'ion',11.111,2),(444,7479930,7479916,'ona',11.111,2),(444,7479931,7479916,'nal',11.111,2),(444,7479932,7479923,'pen',20,1),(444,7479933,7479923,'end',20,1),(444,7479934,7479923,'ndi',20,1),(444,7479935,7479923,'din',20,1),(444,7479936,7479923,'ing',20,1),(444,7479937,7479932,'mes',20,1),(444,7479938,7479932,'ess',20,1),(444,7479939,7479932,'ssa',20,1),(444,7479940,7479932,'sag',20,1),(444,7479941,7479932,'age',20,1),(444,7479942,7479937,'wai',20,1),(444,7479943,7479937,'ait',20,1),(444,7479944,7479937,'iti',20,1),(444,7479945,7479937,'tin',20,1),(444,7479946,7479937,'ing',20,1),(444,7479947,7479942,'for',100,1),(444,7479948,7479947,'per',11.111,1),(444,7479949,7479947,'erf',11.111,1),(444,7479950,7479947,'rfo',11.111,1),(444,7479951,7479947,'for',11.111,1),(444,7479952,7479947,'orm',11.111,1),(444,7479953,7479947,'rma',11.111,1),(444,7479954,7479947,'man',11.111,1),(444,7479955,7479947,'anc',11.111,1),(444,7479956,7479947,'nce',11.111,1),(444,7479957,7479948,'ide',12.5,1),(444,7479958,7479948,'den',12.5,1),(444,7479959,7479948,'ent',12.5,1),(444,7479960,7479948,'nti',12.5,1),(444,7479961,7479948,'tif',12.5,1),(444,7479962,7479948,'ifi',12.5,1),(444,7479963,7479948,'fie',12.5,1),(444,7479964,7479948,'ier',12.5,1),(444,7479965,7479957,'vdi',33.333,3),(444,7479966,7479957,'dis',33.333,3),(444,7479967,7479957,'isk',33.333,3),(444,7479968,7479965,'nam',50,1),(444,7479969,7479965,'ame',50,1),(444,7479970,7479968,'typ',50,1),(444,7479971,7479968,'ype',50,1),(444,7479972,7479970,'dir',25,1),(444,7479973,7479970,'ire',25,1),(444,7479974,7479970,'rec',25,1),(444,7479975,7479970,'ect',25,1),(445,7479977,7479976,'naa',100,2),(445,7479978,7479977,'600',3.333,3),(445,7479979,7479977,'000',3.333,3),(445,7479980,7479977,'00c',3.333,3),(445,7479981,7479977,'0c2',3.333,3),(445,7479982,7479977,'c29',3.333,3),(445,7479983,7479977,'294',3.333,3),(445,7479984,7479977,'948',3.333,3),(445,7479985,7479977,'487',3.333,3),(445,7479986,7479977,'87a',3.333,3),(445,7479987,7479977,'7a8',3.333,3),(445,7479988,7479977,'a81',3.333,3),(445,7479989,7479977,'818',3.333,3),(445,7479990,7479977,'181',3.333,3),(445,7479991,7479977,'812',3.333,3),(445,7479992,7479977,'12d',3.333,3),(445,7479993,7479977,'2d7',3.333,3),(445,7479994,7479977,'d7f',3.333,3),(445,7479995,7479977,'7fc',3.333,3),(445,7479996,7479977,'fcd',3.333,3),(445,7479997,7479977,'cd4',3.333,3),(445,7479998,7479977,'d47',3.333,3),(445,7479999,7479977,'470',3.333,3),(445,7480000,7479977,'70b',3.333,3),(445,7480001,7479977,'0b1',3.333,3),(445,7480002,7479977,'b1f',3.333,3),(445,7480003,7479977,'1f0',3.333,3),(445,7480004,7479977,'f05',3.333,3),(445,7480005,7479977,'05b',3.333,3),(445,7480006,7479977,'5b9',3.333,3),(445,7480007,7479977,'b92',3.333,3),(445,7480008,7479978,'mon',100,1),(445,7480009,7480008,'201',50,1),(445,7480010,7480008,'013',50,1),(445,7480011,7480009,'adm',33.333,3),(445,7480012,7480009,'dmi',33.333,3),(445,7480013,7480009,'min',33.333,3),(445,7480014,7480011,'cap',16.667,1),(445,7480015,7480011,'apa',16.667,1),(445,7480016,7480011,'pac',16.667,1),(445,7480017,7480011,'aci',16.667,1),(445,7480018,7480011,'cit',16.667,1),(445,7480019,7480011,'ity',16.667,1),(445,7480020,7480014,'pat',50,1),(445,7480021,7480014,'ath',50,1),(445,7480022,7480020,'fre',14.286,1),(445,7480023,7480020,'ree',14.286,1),(445,7480024,7480020,'ees',14.286,1),(445,7480025,7480020,'esp',14.286,1),(445,7480026,7480020,'spa',14.286,1),(445,7480027,7480020,'pac',14.286,1),(445,7480028,7480020,'ace',14.286,1),(445,7480029,7480022,'dis',50,1),(445,7480030,7480022,'isk',50,1),(445,7480031,7480029,'ind',33.333,1),(445,7480032,7480029,'nde',33.333,1),(445,7480033,7480029,'dex',33.333,1),(445,7480034,7480031,'adm',8.333,1),(445,7480035,7480031,'dmi',8.333,1),(445,7480036,7480031,'min',8.333,1),(445,7480037,7480031,'ini',8.333,1),(445,7480038,7480031,'nis',8.333,1),(445,7480039,7480031,'ist',8.333,1),(445,7480040,7480031,'str',8.333,1),(445,7480041,7480031,'tra',8.333,1),(445,7480042,7480031,'rat',8.333,1),(445,7480043,7480031,'ati',8.333,1),(445,7480044,7480031,'tio',8.333,1),(445,7480045,7480031,'ion',8.333,1),(445,7480046,7480034,'sta',33.333,3),(445,7480047,7480034,'tat',33.333,3),(445,7480048,7480034,'ate',33.333,3),(445,7480049,7480046,'ena',20,2),(445,7480050,7480046,'nab',20,2),(445,7480051,7480046,'abl',20,2),(445,7480052,7480046,'ble',20,2),(445,7480053,7480046,'led',20,2),(445,7480054,7480049,'cac',33.333,2),(445,7480055,7480049,'ach',33.333,2),(445,7480056,7480049,'che',33.333,2),(445,7480057,7480054,'mod',50,1),(445,7480058,7480054,'ode',50,1),(445,7480059,7480057,'wri',14.286,1),(445,7480060,7480057,'rit',14.286,1),(445,7480061,7480057,'ite',14.286,1),(445,7480062,7480057,'tet',14.286,1),(445,7480063,7480057,'eth',14.286,1),(445,7480064,7480057,'thr',14.286,1),(445,7480065,7480057,'hru',14.286,1),(445,7480066,7480059,'ope',11.111,2),(445,7480067,7480059,'per',11.111,2),(445,7480068,7480059,'era',11.111,2),(445,7480069,7480059,'rat',11.111,2),(445,7480070,7480059,'ati',11.111,2),(445,7480071,7480059,'tio',11.111,2),(445,7480072,7480059,'ion',11.111,2),(445,7480073,7480059,'ona',11.111,2),(445,7480074,7480059,'nal',11.111,2),(445,7480075,7480066,'pen',20,1),(445,7480076,7480066,'end',20,1),(445,7480077,7480066,'ndi',20,1),(445,7480078,7480066,'din',20,1),(445,7480079,7480066,'ing',20,1),(445,7480080,7480075,'mes',20,1),(445,7480081,7480075,'ess',20,1),(445,7480082,7480075,'ssa',20,1),(445,7480083,7480075,'sag',20,1),(445,7480084,7480075,'age',20,1),(445,7480085,7480080,'wai',20,1),(445,7480086,7480080,'ait',20,1),(445,7480087,7480080,'iti',20,1),(445,7480088,7480080,'tin',20,1),(445,7480089,7480080,'ing',20,1),(445,7480090,7480085,'for',100,1),(445,7480091,7480090,'per',11.111,1),(445,7480092,7480090,'erf',11.111,1),(445,7480093,7480090,'rfo',11.111,1),(445,7480094,7480090,'for',11.111,1),(445,7480095,7480090,'orm',11.111,1),(445,7480096,7480090,'rma',11.111,1),(445,7480097,7480090,'man',11.111,1),(445,7480098,7480090,'anc',11.111,1),(445,7480099,7480090,'nce',11.111,1),(445,7480100,7480091,'ide',12.5,1),(445,7480101,7480091,'den',12.5,1),(445,7480102,7480091,'ent',12.5,1),(445,7480103,7480091,'nti',12.5,1),(445,7480104,7480091,'tif',12.5,1),(445,7480105,7480091,'ifi',12.5,1),(445,7480106,7480091,'fie',12.5,1),(445,7480107,7480091,'ier',12.5,1),(445,7480108,7480100,'vdi',33.333,3),(445,7480109,7480100,'dis',33.333,3),(445,7480110,7480100,'isk',33.333,3),(445,7480111,7480108,'nam',50,1),(445,7480112,7480108,'ame',50,1),(445,7480113,7480111,'typ',50,1),(445,7480114,7480111,'ype',50,1),(445,7480115,7480113,'dir',25,1),(445,7480116,7480113,'ire',25,1),(445,7480117,7480113,'rec',25,1),(445,7480118,7480113,'ect',25,1),(446,7480120,7480119,'naa',100,2),(446,7480121,7480120,'600',3.333,3),(446,7480122,7480120,'000',3.333,3),(446,7480123,7480120,'00c',3.333,3),(446,7480124,7480120,'0c2',3.333,3),(446,7480125,7480120,'c29',3.333,3),(446,7480126,7480120,'29b',3.333,3),(446,7480127,7480120,'9bf',3.333,3),(446,7480128,7480120,'bf6',3.333,3),(446,7480129,7480120,'f6e',3.333,3),(446,7480130,7480120,'6e0',3.333,3),(446,7480131,7480120,'e0f',3.333,3),(446,7480132,7480120,'0f4',3.333,3),(446,7480133,7480120,'f4f',3.333,3),(446,7480134,7480120,'4fe',3.333,3),(446,7480135,7480120,'fed',3.333,3),(446,7480136,7480120,'edb',3.333,3),(446,7480137,7480120,'dbe',3.333,3),(446,7480138,7480120,'be7',3.333,3),(446,7480139,7480120,'e7d',3.333,3),(446,7480140,7480120,'7da',3.333,3),(446,7480141,7480120,'daf',3.333,3),(446,7480142,7480120,'af1',3.333,3),(446,7480143,7480120,'f1e',3.333,3),(446,7480144,7480120,'1e1',3.333,3),(446,7480145,7480120,'e17',3.333,3),(446,7480146,7480120,'175',3.333,3),(446,7480147,7480120,'752',3.333,3),(446,7480148,7480120,'528',3.333,3),(446,7480149,7480120,'285',3.333,3),(446,7480150,7480120,'859',3.333,3),(446,7480151,7480121,'mon',100,1),(446,7480152,7480151,'201',50,1),(446,7480153,7480151,'013',50,1),(446,7480154,7480152,'adm',33.333,3),(446,7480155,7480152,'dmi',33.333,3),(446,7480156,7480152,'min',33.333,3),(446,7480157,7480154,'cap',16.667,1),(446,7480158,7480154,'apa',16.667,1),(446,7480159,7480154,'pac',16.667,1),(446,7480160,7480154,'aci',16.667,1),(446,7480161,7480154,'cit',16.667,1),(446,7480162,7480154,'ity',16.667,1),(446,7480163,7480157,'pat',50,1),(446,7480164,7480157,'ath',50,1),(446,7480165,7480163,'fre',14.286,1),(446,7480166,7480163,'ree',14.286,1),(446,7480167,7480163,'ees',14.286,1),(446,7480168,7480163,'esp',14.286,1),(446,7480169,7480163,'spa',14.286,1),(446,7480170,7480163,'pac',14.286,1),(446,7480171,7480163,'ace',14.286,1),(446,7480172,7480165,'dis',50,1),(446,7480173,7480165,'isk',50,1),(446,7480174,7480172,'ind',33.333,1),(446,7480175,7480172,'nde',33.333,1),(446,7480176,7480172,'dex',33.333,1),(446,7480177,7480174,'adm',8.333,1),(446,7480178,7480174,'dmi',8.333,1),(446,7480179,7480174,'min',8.333,1),(446,7480180,7480174,'ini',8.333,1),(446,7480181,7480174,'nis',8.333,1),(446,7480182,7480174,'ist',8.333,1),(446,7480183,7480174,'str',8.333,1),(446,7480184,7480174,'tra',8.333,1),(446,7480185,7480174,'rat',8.333,1),(446,7480186,7480174,'ati',8.333,1),(446,7480187,7480174,'tio',8.333,1),(446,7480188,7480174,'ion',8.333,1),(446,7480189,7480177,'sta',33.333,3),(446,7480190,7480177,'tat',33.333,3),(446,7480191,7480177,'ate',33.333,3),(446,7480192,7480189,'ena',20,2),(446,7480193,7480189,'nab',20,2),(446,7480194,7480189,'abl',20,2),(446,7480195,7480189,'ble',20,2),(446,7480196,7480189,'led',20,2),(446,7480197,7480192,'cac',33.333,2),(446,7480198,7480192,'ach',33.333,2),(446,7480199,7480192,'che',33.333,2),(446,7480200,7480197,'mod',50,1),(446,7480201,7480197,'ode',50,1),(446,7480202,7480200,'wri',14.286,1),(446,7480203,7480200,'rit',14.286,1),(446,7480204,7480200,'ite',14.286,1),(446,7480205,7480200,'tet',14.286,1),(446,7480206,7480200,'eth',14.286,1),(446,7480207,7480200,'thr',14.286,1),(446,7480208,7480200,'hru',14.286,1),(446,7480209,7480202,'ope',11.111,2),(446,7480210,7480202,'per',11.111,2),(446,7480211,7480202,'era',11.111,2),(446,7480212,7480202,'rat',11.111,2),(446,7480213,7480202,'ati',11.111,2),(446,7480214,7480202,'tio',11.111,2),(446,7480215,7480202,'ion',11.111,2),(446,7480216,7480202,'ona',11.111,2),(446,7480217,7480202,'nal',11.111,2),(446,7480218,7480209,'pen',20,1),(446,7480219,7480209,'end',20,1),(446,7480220,7480209,'ndi',20,1),(446,7480221,7480209,'din',20,1),(446,7480222,7480209,'ing',20,1),(446,7480223,7480218,'mes',20,1),(446,7480224,7480218,'ess',20,1),(446,7480225,7480218,'ssa',20,1),(446,7480226,7480218,'sag',20,1),(446,7480227,7480218,'age',20,1),(446,7480228,7480223,'wai',20,1),(446,7480229,7480223,'ait',20,1),(446,7480230,7480223,'iti',20,1),(446,7480231,7480223,'tin',20,1),(446,7480232,7480223,'ing',20,1),(446,7480233,7480228,'for',100,1),(446,7480234,7480233,'per',11.111,1),(446,7480235,7480233,'erf',11.111,1),(446,7480236,7480233,'rfo',11.111,1),(446,7480237,7480233,'for',11.111,1),(446,7480238,7480233,'orm',11.111,1),(446,7480239,7480233,'rma',11.111,1),(446,7480240,7480233,'man',11.111,1),(446,7480241,7480233,'anc',11.111,1),(446,7480242,7480233,'nce',11.111,1),(446,7480243,7480234,'ide',12.5,1),(446,7480244,7480234,'den',12.5,1),(446,7480245,7480234,'ent',12.5,1),(446,7480246,7480234,'nti',12.5,1),(446,7480247,7480234,'tif',12.5,1),(446,7480248,7480234,'ifi',12.5,1),(446,7480249,7480234,'fie',12.5,1),(446,7480250,7480234,'ier',12.5,1),(446,7480251,7480243,'vdi',33.333,3),(446,7480252,7480243,'dis',33.333,3),(446,7480253,7480243,'isk',33.333,3),(446,7480254,7480251,'nam',50,1),(446,7480255,7480251,'ame',50,1),(446,7480256,7480254,'typ',50,1),(446,7480257,7480254,'ype',50,1),(446,7480258,7480256,'dir',25,1),(446,7480259,7480256,'ire',25,1),(446,7480260,7480256,'rec',25,1),(446,7480261,7480256,'ect',25,1),(447,7480263,7480262,'naa',100,2),(447,7480264,7480263,'600',3.333,3),(447,7480265,7480263,'000',3.333,3),(447,7480266,7480263,'00c',3.333,3),(447,7480267,7480263,'0c2',3.333,3),(447,7480268,7480263,'c29',3.333,3),(447,7480269,7480263,'29e',3.333,3),(447,7480270,7480263,'9e7',3.333,3),(447,7480271,7480263,'e72',3.333,3),(447,7480272,7480263,'72b',3.333,3),(447,7480273,7480263,'2b2',3.333,3),(447,7480274,7480263,'b20',3.333,3),(447,7480275,7480263,'201',3.333,3),(447,7480276,7480263,'01a',3.333,3),(447,7480277,7480263,'1ae',3.333,3),(447,7480278,7480263,'aed',3.333,3),(447,7480279,7480263,'edf',3.333,3),(447,7480280,7480263,'dfc',3.333,3),(447,7480281,7480263,'fc8',3.333,3),(447,7480282,7480263,'c8a',3.333,3),(447,7480283,7480263,'8a9',3.333,3),(447,7480284,7480263,'a95',3.333,3),(447,7480285,7480263,'958',3.333,3),(447,7480286,7480263,'589',3.333,3),(447,7480287,7480263,'897',3.333,3),(447,7480288,7480263,'975',3.333,3),(447,7480289,7480263,'75f',3.333,3),(447,7480290,7480263,'5f2',3.333,3),(447,7480291,7480263,'f29',3.333,3),(447,7480292,7480263,'29c',3.333,3),(447,7480293,7480263,'9c5',3.333,3),(447,7480294,7480264,'mon',100,1),(447,7480295,7480294,'201',50,1),(447,7480296,7480294,'013',50,1),(447,7480297,7480295,'adm',33.333,3),(447,7480298,7480295,'dmi',33.333,3),(447,7480299,7480295,'min',33.333,3),(447,7480300,7480297,'cap',16.667,1),(447,7480301,7480297,'apa',16.667,1),(447,7480302,7480297,'pac',16.667,1),(447,7480303,7480297,'aci',16.667,1),(447,7480304,7480297,'cit',16.667,1),(447,7480305,7480297,'ity',16.667,1),(447,7480306,7480300,'pat',50,1),(447,7480307,7480300,'ath',50,1),(447,7480308,7480306,'fre',14.286,1),(447,7480309,7480306,'ree',14.286,1),(447,7480310,7480306,'ees',14.286,1),(447,7480311,7480306,'esp',14.286,1),(447,7480312,7480306,'spa',14.286,1),(447,7480313,7480306,'pac',14.286,1),(447,7480314,7480306,'ace',14.286,1),(447,7480315,7480308,'dis',50,1),(447,7480316,7480308,'isk',50,1),(447,7480317,7480315,'ind',33.333,1),(447,7480318,7480315,'nde',33.333,1),(447,7480319,7480315,'dex',33.333,1),(447,7480320,7480317,'adm',8.333,1),(447,7480321,7480317,'dmi',8.333,1),(447,7480322,7480317,'min',8.333,1),(447,7480323,7480317,'ini',8.333,1),(447,7480324,7480317,'nis',8.333,1),(447,7480325,7480317,'ist',8.333,1),(447,7480326,7480317,'str',8.333,1),(447,7480327,7480317,'tra',8.333,1),(447,7480328,7480317,'rat',8.333,1),(447,7480329,7480317,'ati',8.333,1),(447,7480330,7480317,'tio',8.333,1),(447,7480331,7480317,'ion',8.333,1),(447,7480332,7480320,'sta',33.333,3),(447,7480333,7480320,'tat',33.333,3),(447,7480334,7480320,'ate',33.333,3),(447,7480335,7480332,'ena',20,2),(447,7480336,7480332,'nab',20,2),(447,7480337,7480332,'abl',20,2),(447,7480338,7480332,'ble',20,2),(447,7480339,7480332,'led',20,2),(447,7480340,7480335,'cac',33.333,2),(447,7480341,7480335,'ach',33.333,2),(447,7480342,7480335,'che',33.333,2),(447,7480343,7480340,'mod',50,1),(447,7480344,7480340,'ode',50,1),(447,7480345,7480343,'wri',14.286,1),(447,7480346,7480343,'rit',14.286,1),(447,7480347,7480343,'ite',14.286,1),(447,7480348,7480343,'tet',14.286,1),(447,7480349,7480343,'eth',14.286,1),(447,7480350,7480343,'thr',14.286,1),(447,7480351,7480343,'hru',14.286,1),(447,7480352,7480345,'ope',11.111,2),(447,7480353,7480345,'per',11.111,2),(447,7480354,7480345,'era',11.111,2),(447,7480355,7480345,'rat',11.111,2),(447,7480356,7480345,'ati',11.111,2),(447,7480357,7480345,'tio',11.111,2),(447,7480358,7480345,'ion',11.111,2),(447,7480359,7480345,'ona',11.111,2),(447,7480360,7480345,'nal',11.111,2),(447,7480361,7480352,'pen',20,1),(447,7480362,7480352,'end',20,1),(447,7480363,7480352,'ndi',20,1),(447,7480364,7480352,'din',20,1),(447,7480365,7480352,'ing',20,1),(447,7480366,7480361,'mes',20,1),(447,7480367,7480361,'ess',20,1),(447,7480368,7480361,'ssa',20,1),(447,7480369,7480361,'sag',20,1),(447,7480370,7480361,'age',20,1),(447,7480371,7480366,'wai',20,1),(447,7480372,7480366,'ait',20,1),(447,7480373,7480366,'iti',20,1),(447,7480374,7480366,'tin',20,1),(447,7480375,7480366,'ing',20,1),(447,7480376,7480371,'for',100,1),(447,7480377,7480376,'per',11.111,1),(447,7480378,7480376,'erf',11.111,1),(447,7480379,7480376,'rfo',11.111,1),(447,7480380,7480376,'for',11.111,1),(447,7480381,7480376,'orm',11.111,1),(447,7480382,7480376,'rma',11.111,1),(447,7480383,7480376,'man',11.111,1),(447,7480384,7480376,'anc',11.111,1),(447,7480385,7480376,'nce',11.111,1),(447,7480386,7480377,'ide',12.5,1),(447,7480387,7480377,'den',12.5,1),(447,7480388,7480377,'ent',12.5,1),(447,7480389,7480377,'nti',12.5,1),(447,7480390,7480377,'tif',12.5,1),(447,7480391,7480377,'ifi',12.5,1),(447,7480392,7480377,'fie',12.5,1),(447,7480393,7480377,'ier',12.5,1),(447,7480394,7480386,'vdi',33.333,3),(447,7480395,7480386,'dis',33.333,3),(447,7480396,7480386,'isk',33.333,3),(447,7480397,7480394,'nam',50,1),(447,7480398,7480394,'ame',50,1),(447,7480399,7480397,'typ',50,1),(447,7480400,7480397,'ype',50,1),(447,7480401,7480399,'dir',25,1),(447,7480402,7480399,'ire',25,1),(447,7480403,7480399,'rec',25,1),(447,7480404,7480399,'ect',25,1),(448,7480406,7480405,'naa',100,2),(448,7480407,7480406,'600',3.333,3),(448,7480408,7480406,'000',3.333,3),(448,7480409,7480406,'00c',3.333,3),(448,7480410,7480406,'0c2',3.333,3),(448,7480411,7480406,'c29',3.333,3),(448,7480412,7480406,'298',3.333,3),(448,7480413,7480406,'98b',3.333,3),(448,7480414,7480406,'8ba',3.333,3),(448,7480415,7480406,'bad',3.333,3),(448,7480416,7480406,'add',3.333,3),(448,7480417,7480406,'dd9',3.333,3),(448,7480418,7480406,'d99',3.333,3),(448,7480419,7480406,'992',3.333,3),(448,7480420,7480406,'92c',3.333,3),(448,7480421,7480406,'2c7',3.333,3),(448,7480422,7480406,'c7d',3.333,3),(448,7480423,7480406,'7df',3.333,3),(448,7480424,7480406,'dfa',3.333,3),(448,7480425,7480406,'fa3',3.333,3),(448,7480426,7480406,'a3d',3.333,3),(448,7480427,7480406,'3d3',3.333,3),(448,7480428,7480406,'d31',3.333,3),(448,7480429,7480406,'313',3.333,3),(448,7480430,7480406,'13a',3.333,3),(448,7480431,7480406,'3aa',3.333,3),(448,7480432,7480406,'aaf',3.333,3),(448,7480433,7480406,'af4',3.333,3),(448,7480434,7480406,'f43',3.333,3),(448,7480435,7480406,'430',3.333,3),(448,7480436,7480406,'308',3.333,3),(448,7480437,7480407,'mon',100,1),(448,7480438,7480437,'201',50,1),(448,7480439,7480437,'013',50,1),(448,7480440,7480438,'adm',33.333,3),(448,7480441,7480438,'dmi',33.333,3),(448,7480442,7480438,'min',33.333,3),(448,7480443,7480440,'cap',16.667,1),(448,7480444,7480440,'apa',16.667,1),(448,7480445,7480440,'pac',16.667,1),(448,7480446,7480440,'aci',16.667,1),(448,7480447,7480440,'cit',16.667,1),(448,7480448,7480440,'ity',16.667,1),(448,7480449,7480443,'pat',50,1),(448,7480450,7480443,'ath',50,1),(448,7480451,7480449,'fre',14.286,1),(448,7480452,7480449,'ree',14.286,1),(448,7480453,7480449,'ees',14.286,1),(448,7480454,7480449,'esp',14.286,1),(448,7480455,7480449,'spa',14.286,1),(448,7480456,7480449,'pac',14.286,1),(448,7480457,7480449,'ace',14.286,1),(448,7480458,7480451,'dis',50,1),(448,7480459,7480451,'isk',50,1),(448,7480460,7480458,'ind',33.333,1),(448,7480461,7480458,'nde',33.333,1),(448,7480462,7480458,'dex',33.333,1),(448,7480463,7480460,'adm',8.333,1),(448,7480464,7480460,'dmi',8.333,1),(448,7480465,7480460,'min',8.333,1),(448,7480466,7480460,'ini',8.333,1),(448,7480467,7480460,'nis',8.333,1),(448,7480468,7480460,'ist',8.333,1),(448,7480469,7480460,'str',8.333,1),(448,7480470,7480460,'tra',8.333,1),(448,7480471,7480460,'rat',8.333,1),(448,7480472,7480460,'ati',8.333,1),(448,7480473,7480460,'tio',8.333,1),(448,7480474,7480460,'ion',8.333,1),(448,7480475,7480463,'sta',33.333,3),(448,7480476,7480463,'tat',33.333,3),(448,7480477,7480463,'ate',33.333,3),(448,7480478,7480475,'ena',20,2),(448,7480479,7480475,'nab',20,2),(448,7480480,7480475,'abl',20,2),(448,7480481,7480475,'ble',20,2),(448,7480482,7480475,'led',20,2),(448,7480483,7480478,'cac',33.333,2),(448,7480484,7480478,'ach',33.333,2),(448,7480485,7480478,'che',33.333,2),(448,7480486,7480483,'mod',50,1),(448,7480487,7480483,'ode',50,1),(448,7480488,7480486,'wri',14.286,1),(448,7480489,7480486,'rit',14.286,1),(448,7480490,7480486,'ite',14.286,1),(448,7480491,7480486,'tet',14.286,1),(448,7480492,7480486,'eth',14.286,1),(448,7480493,7480486,'thr',14.286,1),(448,7480494,7480486,'hru',14.286,1),(448,7480495,7480488,'ope',11.111,2),(448,7480496,7480488,'per',11.111,2),(448,7480497,7480488,'era',11.111,2),(448,7480498,7480488,'rat',11.111,2),(448,7480499,7480488,'ati',11.111,2),(448,7480500,7480488,'tio',11.111,2),(448,7480501,7480488,'ion',11.111,2),(448,7480502,7480488,'ona',11.111,2),(448,7480503,7480488,'nal',11.111,2),(448,7480504,7480495,'pen',20,1),(448,7480505,7480495,'end',20,1),(448,7480506,7480495,'ndi',20,1),(448,7480507,7480495,'din',20,1),(448,7480508,7480495,'ing',20,1),(448,7480509,7480504,'mes',20,1),(448,7480510,7480504,'ess',20,1),(448,7480511,7480504,'ssa',20,1),(448,7480512,7480504,'sag',20,1),(448,7480513,7480504,'age',20,1),(448,7480514,7480509,'wai',20,1),(448,7480515,7480509,'ait',20,1),(448,7480516,7480509,'iti',20,1),(448,7480517,7480509,'tin',20,1),(448,7480518,7480509,'ing',20,1),(448,7480519,7480514,'for',100,1),(448,7480520,7480519,'per',11.111,1),(448,7480521,7480519,'erf',11.111,1),(448,7480522,7480519,'rfo',11.111,1),(448,7480523,7480519,'for',11.111,1),(448,7480524,7480519,'orm',11.111,1),(448,7480525,7480519,'rma',11.111,1),(448,7480526,7480519,'man',11.111,1),(448,7480527,7480519,'anc',11.111,1),(448,7480528,7480519,'nce',11.111,1),(448,7480529,7480520,'ide',12.5,1),(448,7480530,7480520,'den',12.5,1),(448,7480531,7480520,'ent',12.5,1),(448,7480532,7480520,'nti',12.5,1),(448,7480533,7480520,'tif',12.5,1),(448,7480534,7480520,'ifi',12.5,1),(448,7480535,7480520,'fie',12.5,1),(448,7480536,7480520,'ier',12.5,1),(448,7480537,7480529,'vdi',33.333,3),(448,7480538,7480529,'dis',33.333,3),(448,7480539,7480529,'isk',33.333,3),(448,7480540,7480537,'nam',50,1),(448,7480541,7480537,'ame',50,1),(448,7480542,7480540,'typ',50,1),(448,7480543,7480540,'ype',50,1),(448,7480544,7480542,'dir',25,1),(448,7480545,7480542,'ire',25,1),(448,7480546,7480542,'rec',25,1),(448,7480547,7480542,'ect',25,1),(449,7480549,7480548,'naa',100,2),(449,7480550,7480549,'600',3.333,3),(449,7480551,7480549,'000',3.333,3),(449,7480552,7480549,'00c',3.333,3),(449,7480553,7480549,'0c2',3.333,3),(449,7480554,7480549,'c29',3.333,3),(449,7480555,7480549,'29a',3.333,3),(449,7480556,7480549,'9a5',3.333,3),(449,7480557,7480549,'a55',3.333,3),(449,7480558,7480549,'551',3.333,3),(449,7480559,7480549,'514',3.333,3),(449,7480560,7480549,'144',3.333,3),(449,7480561,7480549,'44d',3.333,3),(449,7480562,7480549,'4da',3.333,3),(449,7480563,7480549,'da0',3.333,3),(449,7480564,7480549,'a0c',3.333,3),(449,7480565,7480549,'0ca',3.333,3),(449,7480566,7480549,'ca5',3.333,3),(449,7480567,7480549,'a59',3.333,3),(449,7480568,7480549,'59b',3.333,3),(449,7480569,7480549,'9bf',3.333,3),(449,7480570,7480549,'bf6',3.333,3),(449,7480571,7480549,'f68',3.333,3),(449,7480572,7480549,'685',3.333,3),(449,7480573,7480549,'854',3.333,3),(449,7480574,7480549,'548',3.333,3),(449,7480575,7480549,'487',3.333,3),(449,7480576,7480549,'874',3.333,3),(449,7480577,7480549,'743',3.333,3),(449,7480578,7480549,'43f',3.333,3),(449,7480579,7480549,'3f1',3.333,3),(449,7480580,7480550,'mon',100,1),(449,7480581,7480580,'201',50,1),(449,7480582,7480580,'013',50,1),(449,7480583,7480581,'adm',33.333,3),(449,7480584,7480581,'dmi',33.333,3),(449,7480585,7480581,'min',33.333,3),(449,7480586,7480583,'cap',16.667,1),(449,7480587,7480583,'apa',16.667,1),(449,7480588,7480583,'pac',16.667,1),(449,7480589,7480583,'aci',16.667,1),(449,7480590,7480583,'cit',16.667,1),(449,7480591,7480583,'ity',16.667,1),(449,7480592,7480586,'pat',50,1),(449,7480593,7480586,'ath',50,1),(449,7480594,7480592,'fre',14.286,1),(449,7480595,7480592,'ree',14.286,1),(449,7480596,7480592,'ees',14.286,1),(449,7480597,7480592,'esp',14.286,1),(449,7480598,7480592,'spa',14.286,1),(449,7480599,7480592,'pac',14.286,1),(449,7480600,7480592,'ace',14.286,1),(449,7480601,7480594,'dis',50,1),(449,7480602,7480594,'isk',50,1),(449,7480603,7480601,'ind',33.333,1),(449,7480604,7480601,'nde',33.333,1),(449,7480605,7480601,'dex',33.333,1),(449,7480606,7480603,'adm',8.333,1),(449,7480607,7480603,'dmi',8.333,1),(449,7480608,7480603,'min',8.333,1),(449,7480609,7480603,'ini',8.333,1),(449,7480610,7480603,'nis',8.333,1),(449,7480611,7480603,'ist',8.333,1),(449,7480612,7480603,'str',8.333,1),(449,7480613,7480603,'tra',8.333,1),(449,7480614,7480603,'rat',8.333,1),(449,7480615,7480603,'ati',8.333,1),(449,7480616,7480603,'tio',8.333,1),(449,7480617,7480603,'ion',8.333,1),(449,7480618,7480606,'sta',33.333,3),(449,7480619,7480606,'tat',33.333,3),(449,7480620,7480606,'ate',33.333,3),(449,7480621,7480618,'ena',20,2),(449,7480622,7480618,'nab',20,2),(449,7480623,7480618,'abl',20,2),(449,7480624,7480618,'ble',20,2),(449,7480625,7480618,'led',20,2),(449,7480626,7480621,'cac',33.333,2),(449,7480627,7480621,'ach',33.333,2),(449,7480628,7480621,'che',33.333,2),(449,7480629,7480626,'mod',50,1),(449,7480630,7480626,'ode',50,1),(449,7480631,7480629,'wri',14.286,1),(449,7480632,7480629,'rit',14.286,1),(449,7480633,7480629,'ite',14.286,1),(449,7480634,7480629,'tet',14.286,1),(449,7480635,7480629,'eth',14.286,1),(449,7480636,7480629,'thr',14.286,1),(449,7480637,7480629,'hru',14.286,1),(449,7480638,7480631,'ope',11.111,2),(449,7480639,7480631,'per',11.111,2),(449,7480640,7480631,'era',11.111,2),(449,7480641,7480631,'rat',11.111,2),(449,7480642,7480631,'ati',11.111,2),(449,7480643,7480631,'tio',11.111,2),(449,7480644,7480631,'ion',11.111,2),(449,7480645,7480631,'ona',11.111,2),(449,7480646,7480631,'nal',11.111,2),(449,7480647,7480638,'pen',20,1),(449,7480648,7480638,'end',20,1),(449,7480649,7480638,'ndi',20,1),(449,7480650,7480638,'din',20,1),(449,7480651,7480638,'ing',20,1),(449,7480652,7480647,'mes',20,1),(449,7480653,7480647,'ess',20,1),(449,7480654,7480647,'ssa',20,1),(449,7480655,7480647,'sag',20,1),(449,7480656,7480647,'age',20,1),(449,7480657,7480652,'wai',20,1),(449,7480658,7480652,'ait',20,1),(449,7480659,7480652,'iti',20,1),(449,7480660,7480652,'tin',20,1),(449,7480661,7480652,'ing',20,1),(449,7480662,7480657,'for',100,1),(449,7480663,7480662,'per',11.111,1),(449,7480664,7480662,'erf',11.111,1),(449,7480665,7480662,'rfo',11.111,1),(449,7480666,7480662,'for',11.111,1),(449,7480667,7480662,'orm',11.111,1),(449,7480668,7480662,'rma',11.111,1),(449,7480669,7480662,'man',11.111,1),(449,7480670,7480662,'anc',11.111,1),(449,7480671,7480662,'nce',11.111,1),(449,7480672,7480663,'ide',12.5,1),(449,7480673,7480663,'den',12.5,1),(449,7480674,7480663,'ent',12.5,1),(449,7480675,7480663,'nti',12.5,1),(449,7480676,7480663,'tif',12.5,1),(449,7480677,7480663,'ifi',12.5,1),(449,7480678,7480663,'fie',12.5,1),(449,7480679,7480663,'ier',12.5,1),(449,7480680,7480672,'vdi',33.333,3),(449,7480681,7480672,'dis',33.333,3),(449,7480682,7480672,'isk',33.333,3),(449,7480683,7480680,'nam',50,1),(449,7480684,7480680,'ame',50,1),(449,7480685,7480683,'typ',50,1),(449,7480686,7480683,'ype',50,1),(449,7480687,7480685,'dir',25,1),(449,7480688,7480685,'ire',25,1),(449,7480689,7480685,'rec',25,1),(449,7480690,7480685,'ect',25,1),(450,7480692,7480691,'naa',100,2),(450,7480693,7480692,'600',3.333,3),(450,7480694,7480692,'000',3.333,3),(450,7480695,7480692,'00c',3.333,3),(450,7480696,7480692,'0c2',3.333,3),(450,7480697,7480692,'c29',3.333,3),(450,7480698,7480692,'292',3.333,3),(450,7480699,7480692,'92d',3.333,3),(450,7480700,7480692,'2d1',3.333,3),(450,7480701,7480692,'d1e',3.333,3),(450,7480702,7480692,'1e0',3.333,3),(450,7480703,7480692,'e0b',3.333,3),(450,7480704,7480692,'0ba',3.333,3),(450,7480705,7480692,'ba3',3.333,3),(450,7480706,7480692,'a34',3.333,3),(450,7480707,7480692,'34f',3.333,3),(450,7480708,7480692,'4fc',3.333,3),(450,7480709,7480692,'fcd',3.333,3),(450,7480710,7480692,'cd6',3.333,3),(450,7480711,7480692,'d69',3.333,3),(450,7480712,7480692,'69f',3.333,3),(450,7480713,7480692,'9f4',3.333,3),(450,7480714,7480692,'f4a',3.333,3),(450,7480715,7480692,'4a7',3.333,3),(450,7480716,7480692,'a7d',3.333,3),(450,7480717,7480692,'7dd',3.333,3),(450,7480718,7480692,'ddb',3.333,3),(450,7480719,7480692,'db7',3.333,3),(450,7480720,7480692,'b79',3.333,3),(450,7480721,7480692,'796',3.333,3),(450,7480722,7480692,'966',3.333,3),(450,7480723,7480693,'mon',100,1),(450,7480724,7480723,'201',50,1),(450,7480725,7480723,'013',50,1),(450,7480726,7480724,'adm',33.333,3),(450,7480727,7480724,'dmi',33.333,3),(450,7480728,7480724,'min',33.333,3),(450,7480729,7480726,'cap',16.667,1),(450,7480730,7480726,'apa',16.667,1),(450,7480731,7480726,'pac',16.667,1),(450,7480732,7480726,'aci',16.667,1),(450,7480733,7480726,'cit',16.667,1),(450,7480734,7480726,'ity',16.667,1),(450,7480735,7480729,'pat',50,1),(450,7480736,7480729,'ath',50,1),(450,7480737,7480735,'fre',14.286,1),(450,7480738,7480735,'ree',14.286,1),(450,7480739,7480735,'ees',14.286,1),(450,7480740,7480735,'esp',14.286,1),(450,7480741,7480735,'spa',14.286,1),(450,7480742,7480735,'pac',14.286,1),(450,7480743,7480735,'ace',14.286,1),(450,7480744,7480737,'dis',50,1),(450,7480745,7480737,'isk',50,1),(450,7480746,7480744,'ind',33.333,1),(450,7480747,7480744,'nde',33.333,1),(450,7480748,7480744,'dex',33.333,1),(450,7480749,7480746,'adm',8.333,1),(450,7480750,7480746,'dmi',8.333,1),(450,7480751,7480746,'min',8.333,1),(450,7480752,7480746,'ini',8.333,1),(450,7480753,7480746,'nis',8.333,1),(450,7480754,7480746,'ist',8.333,1),(450,7480755,7480746,'str',8.333,1),(450,7480756,7480746,'tra',8.333,1),(450,7480757,7480746,'rat',8.333,1),(450,7480758,7480746,'ati',8.333,1),(450,7480759,7480746,'tio',8.333,1),(450,7480760,7480746,'ion',8.333,1),(450,7480761,7480749,'sta',33.333,3),(450,7480762,7480749,'tat',33.333,3),(450,7480763,7480749,'ate',33.333,3),(450,7480764,7480761,'ena',20,2),(450,7480765,7480761,'nab',20,2),(450,7480766,7480761,'abl',20,2),(450,7480767,7480761,'ble',20,2),(450,7480768,7480761,'led',20,2),(450,7480769,7480764,'cac',33.333,2),(450,7480770,7480764,'ach',33.333,2),(450,7480771,7480764,'che',33.333,2),(450,7480772,7480769,'mod',50,1),(450,7480773,7480769,'ode',50,1),(450,7480774,7480772,'wri',14.286,1),(450,7480775,7480772,'rit',14.286,1),(450,7480776,7480772,'ite',14.286,1),(450,7480777,7480772,'tet',14.286,1),(450,7480778,7480772,'eth',14.286,1),(450,7480779,7480772,'thr',14.286,1),(450,7480780,7480772,'hru',14.286,1),(450,7480781,7480774,'ope',11.111,2),(450,7480782,7480774,'per',11.111,2),(450,7480783,7480774,'era',11.111,2),(450,7480784,7480774,'rat',11.111,2),(450,7480785,7480774,'ati',11.111,2),(450,7480786,7480774,'tio',11.111,2),(450,7480787,7480774,'ion',11.111,2),(450,7480788,7480774,'ona',11.111,2),(450,7480789,7480774,'nal',11.111,2),(450,7480790,7480781,'pen',20,1),(450,7480791,7480781,'end',20,1),(450,7480792,7480781,'ndi',20,1),(450,7480793,7480781,'din',20,1),(450,7480794,7480781,'ing',20,1),(450,7480795,7480790,'mes',20,1),(450,7480796,7480790,'ess',20,1),(450,7480797,7480790,'ssa',20,1),(450,7480798,7480790,'sag',20,1),(450,7480799,7480790,'age',20,1),(450,7480800,7480795,'wai',20,1),(450,7480801,7480795,'ait',20,1),(450,7480802,7480795,'iti',20,1),(450,7480803,7480795,'tin',20,1),(450,7480804,7480795,'ing',20,1),(450,7480805,7480800,'for',100,1),(450,7480806,7480805,'per',11.111,1),(450,7480807,7480805,'erf',11.111,1),(450,7480808,7480805,'rfo',11.111,1),(450,7480809,7480805,'for',11.111,1),(450,7480810,7480805,'orm',11.111,1),(450,7480811,7480805,'rma',11.111,1),(450,7480812,7480805,'man',11.111,1),(450,7480813,7480805,'anc',11.111,1),(450,7480814,7480805,'nce',11.111,1),(450,7480815,7480806,'ide',12.5,1),(450,7480816,7480806,'den',12.5,1),(450,7480817,7480806,'ent',12.5,1),(450,7480818,7480806,'nti',12.5,1),(450,7480819,7480806,'tif',12.5,1),(450,7480820,7480806,'ifi',12.5,1),(450,7480821,7480806,'fie',12.5,1),(450,7480822,7480806,'ier',12.5,1),(450,7480823,7480815,'vdi',33.333,3),(450,7480824,7480815,'dis',33.333,3),(450,7480825,7480815,'isk',33.333,3),(450,7480826,7480823,'nam',50,1),(450,7480827,7480823,'ame',50,1),(450,7480828,7480826,'typ',50,1),(450,7480829,7480826,'ype',50,1),(450,7480830,7480828,'dir',25,1),(450,7480831,7480828,'ire',25,1),(450,7480832,7480828,'rec',25,1),(450,7480833,7480828,'ect',25,1),(451,7480835,7480834,'naa',100,2),(451,7480836,7480835,'600',3.333,3),(451,7480837,7480835,'000',3.333,3),(451,7480838,7480835,'00c',3.333,3),(451,7480839,7480835,'0c2',3.333,3),(451,7480840,7480835,'c29',3.333,3),(451,7480841,7480835,'292',3.333,3),(451,7480842,7480835,'92b',3.333,3),(451,7480843,7480835,'2b3',3.333,3),(451,7480844,7480835,'b38',3.333,3),(451,7480845,7480835,'387',3.333,3),(451,7480846,7480835,'871',3.333,3),(451,7480847,7480835,'715',3.333,3),(451,7480848,7480835,'15a',3.333,3),(451,7480849,7480835,'5a4',3.333,3),(451,7480850,7480835,'a4b',3.333,3),(451,7480851,7480835,'4bf',3.333,3),(451,7480852,7480835,'bf5',3.333,3),(451,7480853,7480835,'f5d',3.333,3),(451,7480854,7480835,'5db',3.333,3),(451,7480855,7480835,'db1',3.333,3),(451,7480856,7480835,'b11',3.333,3),(451,7480857,7480835,'11a',3.333,3),(451,7480858,7480835,'1a0',3.333,3),(451,7480859,7480835,'a06',3.333,3),(451,7480860,7480835,'06a',3.333,3),(451,7480861,7480835,'6a6',3.333,3),(451,7480862,7480835,'a63',3.333,3),(451,7480863,7480835,'63e',3.333,3),(451,7480864,7480835,'3e3',3.333,3),(451,7480865,7480835,'e31',3.333,3),(451,7480866,7480836,'mon',100,1),(451,7480867,7480866,'201',50,1),(451,7480868,7480866,'013',50,1),(451,7480869,7480867,'adm',33.333,3),(451,7480870,7480867,'dmi',33.333,3),(451,7480871,7480867,'min',33.333,3),(451,7480872,7480869,'cap',16.667,1),(451,7480873,7480869,'apa',16.667,1),(451,7480874,7480869,'pac',16.667,1),(451,7480875,7480869,'aci',16.667,1),(451,7480876,7480869,'cit',16.667,1),(451,7480877,7480869,'ity',16.667,1),(451,7480878,7480872,'pat',50,1),(451,7480879,7480872,'ath',50,1),(451,7480880,7480878,'fre',14.286,1),(451,7480881,7480878,'ree',14.286,1),(451,7480882,7480878,'ees',14.286,1),(451,7480883,7480878,'esp',14.286,1),(451,7480884,7480878,'spa',14.286,1),(451,7480885,7480878,'pac',14.286,1),(451,7480886,7480878,'ace',14.286,1),(451,7480887,7480880,'dis',50,1),(451,7480888,7480880,'isk',50,1),(451,7480889,7480887,'ind',33.333,1),(451,7480890,7480887,'nde',33.333,1),(451,7480891,7480887,'dex',33.333,1),(451,7480892,7480889,'adm',8.333,1),(451,7480893,7480889,'dmi',8.333,1),(451,7480894,7480889,'min',8.333,1),(451,7480895,7480889,'ini',8.333,1),(451,7480896,7480889,'nis',8.333,1),(451,7480897,7480889,'ist',8.333,1),(451,7480898,7480889,'str',8.333,1),(451,7480899,7480889,'tra',8.333,1),(451,7480900,7480889,'rat',8.333,1),(451,7480901,7480889,'ati',8.333,1),(451,7480902,7480889,'tio',8.333,1),(451,7480903,7480889,'ion',8.333,1),(451,7480904,7480892,'sta',33.333,3),(451,7480905,7480892,'tat',33.333,3),(451,7480906,7480892,'ate',33.333,3),(451,7480907,7480904,'ena',20,2),(451,7480908,7480904,'nab',20,2),(451,7480909,7480904,'abl',20,2),(451,7480910,7480904,'ble',20,2),(451,7480911,7480904,'led',20,2),(451,7480912,7480907,'cac',33.333,2),(451,7480913,7480907,'ach',33.333,2),(451,7480914,7480907,'che',33.333,2),(451,7480915,7480912,'mod',50,1),(451,7480916,7480912,'ode',50,1),(451,7480917,7480915,'wri',14.286,1),(451,7480918,7480915,'rit',14.286,1),(451,7480919,7480915,'ite',14.286,1),(451,7480920,7480915,'tet',14.286,1),(451,7480921,7480915,'eth',14.286,1),(451,7480922,7480915,'thr',14.286,1),(451,7480923,7480915,'hru',14.286,1),(451,7480924,7480917,'ope',11.111,2),(451,7480925,7480917,'per',11.111,2),(451,7480926,7480917,'era',11.111,2),(451,7480927,7480917,'rat',11.111,2),(451,7480928,7480917,'ati',11.111,2),(451,7480929,7480917,'tio',11.111,2),(451,7480930,7480917,'ion',11.111,2),(451,7480931,7480917,'ona',11.111,2),(451,7480932,7480917,'nal',11.111,2),(451,7480933,7480924,'pen',20,1),(451,7480934,7480924,'end',20,1),(451,7480935,7480924,'ndi',20,1),(451,7480936,7480924,'din',20,1),(451,7480937,7480924,'ing',20,1),(451,7480938,7480933,'mes',20,1),(451,7480939,7480933,'ess',20,1),(451,7480940,7480933,'ssa',20,1),(451,7480941,7480933,'sag',20,1),(451,7480942,7480933,'age',20,1),(451,7480943,7480938,'wai',20,1),(451,7480944,7480938,'ait',20,1),(451,7480945,7480938,'iti',20,1),(451,7480946,7480938,'tin',20,1),(451,7480947,7480938,'ing',20,1),(451,7480948,7480943,'for',100,1),(451,7480949,7480948,'per',11.111,1),(451,7480950,7480948,'erf',11.111,1),(451,7480951,7480948,'rfo',11.111,1),(451,7480952,7480948,'for',11.111,1),(451,7480953,7480948,'orm',11.111,1),(451,7480954,7480948,'rma',11.111,1),(451,7480955,7480948,'man',11.111,1),(451,7480956,7480948,'anc',11.111,1),(451,7480957,7480948,'nce',11.111,1),(451,7480958,7480949,'ide',12.5,1),(451,7480959,7480949,'den',12.5,1),(451,7480960,7480949,'ent',12.5,1),(451,7480961,7480949,'nti',12.5,1),(451,7480962,7480949,'tif',12.5,1),(451,7480963,7480949,'ifi',12.5,1),(451,7480964,7480949,'fie',12.5,1),(451,7480965,7480949,'ier',12.5,1),(451,7480966,7480958,'vdi',33.333,3),(451,7480967,7480958,'dis',33.333,3),(451,7480968,7480958,'isk',33.333,3),(451,7480969,7480966,'nam',50,1),(451,7480970,7480966,'ame',50,1),(451,7480971,7480969,'typ',50,1),(451,7480972,7480969,'ype',50,1),(451,7480973,7480971,'dir',25,1),(451,7480974,7480971,'ire',25,1),(451,7480975,7480971,'rec',25,1),(451,7480976,7480971,'ect',25,1),(452,7480978,7480977,'naa',100,2),(452,7480979,7480978,'600',3.333,3),(452,7480980,7480978,'000',3.333,3),(452,7480981,7480978,'00c',3.333,3),(452,7480982,7480978,'0c2',3.333,3),(452,7480983,7480978,'c29',3.333,3),(452,7480984,7480978,'297',3.333,3),(452,7480985,7480978,'972',3.333,3),(452,7480986,7480978,'72f',3.333,3),(452,7480987,7480978,'2f5',3.333,3),(452,7480988,7480978,'f5e',3.333,3),(452,7480989,7480978,'5eb',3.333,3),(452,7480990,7480978,'eb0',3.333,3),(452,7480991,7480978,'b0f',3.333,3),(452,7480992,7480978,'0f1',3.333,3),(452,7480993,7480978,'f1a',3.333,3),(452,7480994,7480978,'1ac',3.333,3),(452,7480995,7480978,'aca',3.333,3),(452,7480996,7480978,'cad',3.333,3),(452,7480997,7480978,'ad2',3.333,3),(452,7480998,7480978,'d26',3.333,3),(452,7480999,7480978,'260',3.333,3),(452,7481000,7480978,'605',3.333,3),(452,7481001,7480978,'055',3.333,3),(452,7481002,7480978,'55f',3.333,3),(452,7481003,7480978,'5f5',3.333,3),(452,7481004,7480978,'f51',3.333,3),(452,7481005,7480978,'514',3.333,3),(452,7481006,7480978,'14f',3.333,3),(452,7481007,7480978,'4f6',3.333,3),(452,7481008,7480978,'f6d',3.333,3),(452,7481009,7480979,'mon',100,1),(452,7481010,7481009,'201',50,1),(452,7481011,7481009,'013',50,1),(452,7481012,7481010,'adm',33.333,3),(452,7481013,7481010,'dmi',33.333,3),(452,7481014,7481010,'min',33.333,3),(452,7481015,7481012,'cap',16.667,1),(452,7481016,7481012,'apa',16.667,1),(452,7481017,7481012,'pac',16.667,1),(452,7481018,7481012,'aci',16.667,1),(452,7481019,7481012,'cit',16.667,1),(452,7481020,7481012,'ity',16.667,1),(452,7481021,7481015,'pat',50,1),(452,7481022,7481015,'ath',50,1),(452,7481023,7481021,'fre',14.286,1),(452,7481024,7481021,'ree',14.286,1),(452,7481025,7481021,'ees',14.286,1),(452,7481026,7481021,'esp',14.286,1),(452,7481027,7481021,'spa',14.286,1),(452,7481028,7481021,'pac',14.286,1),(452,7481029,7481021,'ace',14.286,1),(452,7481030,7481023,'dis',50,1),(452,7481031,7481023,'isk',50,1),(452,7481032,7481030,'ind',33.333,1),(452,7481033,7481030,'nde',33.333,1),(452,7481034,7481030,'dex',33.333,1),(452,7481035,7481032,'adm',8.333,1),(452,7481036,7481032,'dmi',8.333,1),(452,7481037,7481032,'min',8.333,1),(452,7481038,7481032,'ini',8.333,1),(452,7481039,7481032,'nis',8.333,1),(452,7481040,7481032,'ist',8.333,1),(452,7481041,7481032,'str',8.333,1),(452,7481042,7481032,'tra',8.333,1),(452,7481043,7481032,'rat',8.333,1),(452,7481044,7481032,'ati',8.333,1),(452,7481045,7481032,'tio',8.333,1),(452,7481046,7481032,'ion',8.333,1),(452,7481047,7481035,'sta',33.333,3),(452,7481048,7481035,'tat',33.333,3),(452,7481049,7481035,'ate',33.333,3),(452,7481050,7481047,'ena',20,2),(452,7481051,7481047,'nab',20,2),(452,7481052,7481047,'abl',20,2),(452,7481053,7481047,'ble',20,2),(452,7481054,7481047,'led',20,2),(452,7481055,7481050,'cac',33.333,2),(452,7481056,7481050,'ach',33.333,2),(452,7481057,7481050,'che',33.333,2),(452,7481058,7481055,'mod',50,1),(452,7481059,7481055,'ode',50,1),(452,7481060,7481058,'wri',14.286,1),(452,7481061,7481058,'rit',14.286,1),(452,7481062,7481058,'ite',14.286,1),(452,7481063,7481058,'tet',14.286,1),(452,7481064,7481058,'eth',14.286,1),(452,7481065,7481058,'thr',14.286,1),(452,7481066,7481058,'hru',14.286,1),(452,7481067,7481060,'ope',11.111,2),(452,7481068,7481060,'per',11.111,2),(452,7481069,7481060,'era',11.111,2),(452,7481070,7481060,'rat',11.111,2),(452,7481071,7481060,'ati',11.111,2),(452,7481072,7481060,'tio',11.111,2),(452,7481073,7481060,'ion',11.111,2),(452,7481074,7481060,'ona',11.111,2),(452,7481075,7481060,'nal',11.111,2),(452,7481076,7481067,'pen',20,1),(452,7481077,7481067,'end',20,1),(452,7481078,7481067,'ndi',20,1),(452,7481079,7481067,'din',20,1),(452,7481080,7481067,'ing',20,1),(452,7481081,7481076,'mes',20,1),(452,7481082,7481076,'ess',20,1),(452,7481083,7481076,'ssa',20,1),(452,7481084,7481076,'sag',20,1),(452,7481085,7481076,'age',20,1),(452,7481086,7481081,'wai',20,1),(452,7481087,7481081,'ait',20,1),(452,7481088,7481081,'iti',20,1),(452,7481089,7481081,'tin',20,1),(452,7481090,7481081,'ing',20,1),(452,7481091,7481086,'for',100,1),(452,7481092,7481091,'per',11.111,1),(452,7481093,7481091,'erf',11.111,1),(452,7481094,7481091,'rfo',11.111,1),(452,7481095,7481091,'for',11.111,1),(452,7481096,7481091,'orm',11.111,1),(452,7481097,7481091,'rma',11.111,1),(452,7481098,7481091,'man',11.111,1),(452,7481099,7481091,'anc',11.111,1),(452,7481100,7481091,'nce',11.111,1),(452,7481101,7481092,'ide',12.5,1),(452,7481102,7481092,'den',12.5,1),(452,7481103,7481092,'ent',12.5,1),(452,7481104,7481092,'nti',12.5,1),(452,7481105,7481092,'tif',12.5,1),(452,7481106,7481092,'ifi',12.5,1),(452,7481107,7481092,'fie',12.5,1),(452,7481108,7481092,'ier',12.5,1),(452,7481109,7481101,'vdi',33.333,3),(452,7481110,7481101,'dis',33.333,3),(452,7481111,7481101,'isk',33.333,3),(452,7481112,7481109,'nam',50,1),(452,7481113,7481109,'ame',50,1),(452,7481114,7481112,'typ',50,1),(452,7481115,7481112,'ype',50,1),(452,7481116,7481114,'dir',25,1),(452,7481117,7481114,'ire',25,1),(452,7481118,7481114,'rec',25,1),(452,7481119,7481114,'ect',25,1),(453,7481121,7481120,'naa',100,2),(453,7481122,7481121,'600',3.333,3),(453,7481123,7481121,'000',3.333,3),(453,7481124,7481121,'00c',3.333,3),(453,7481125,7481121,'0c2',3.333,3),(453,7481126,7481121,'c29',3.333,3),(453,7481127,7481121,'29c',3.333,3),(453,7481128,7481121,'9ce',3.333,3),(453,7481129,7481121,'ce3',3.333,3),(453,7481130,7481121,'e39',3.333,3),(453,7481131,7481121,'399',3.333,3),(453,7481132,7481121,'999',3.333,3),(453,7481133,7481121,'995',3.333,3),(453,7481134,7481121,'95d',3.333,3),(453,7481135,7481121,'5d2',3.333,3),(453,7481136,7481121,'d21',3.333,3),(453,7481137,7481121,'215',3.333,3),(453,7481138,7481121,'15b',3.333,3),(453,7481139,7481121,'5bd',3.333,3),(453,7481140,7481121,'bdb',3.333,3),(453,7481141,7481121,'dbe',3.333,3),(453,7481142,7481121,'be8',3.333,3),(453,7481143,7481121,'e84',3.333,3),(453,7481144,7481121,'84b',3.333,3),(453,7481145,7481121,'4b1',3.333,3),(453,7481146,7481121,'b1a',3.333,3),(453,7481147,7481121,'1a5',3.333,3),(453,7481148,7481121,'a58',3.333,3),(453,7481149,7481121,'58c',3.333,3),(453,7481150,7481121,'8c1',3.333,3),(453,7481151,7481121,'c17',3.333,3),(453,7481152,7481122,'mon',100,1),(453,7481153,7481152,'201',50,1),(453,7481154,7481152,'013',50,1),(453,7481155,7481153,'adm',33.333,3),(453,7481156,7481153,'dmi',33.333,3),(453,7481157,7481153,'min',33.333,3),(453,7481158,7481155,'cap',16.667,1),(453,7481159,7481155,'apa',16.667,1),(453,7481160,7481155,'pac',16.667,1),(453,7481161,7481155,'aci',16.667,1),(453,7481162,7481155,'cit',16.667,1),(453,7481163,7481155,'ity',16.667,1),(453,7481164,7481158,'pat',50,1),(453,7481165,7481158,'ath',50,1),(453,7481166,7481164,'fre',14.286,1),(453,7481167,7481164,'ree',14.286,1),(453,7481168,7481164,'ees',14.286,1),(453,7481169,7481164,'esp',14.286,1),(453,7481170,7481164,'spa',14.286,1),(453,7481171,7481164,'pac',14.286,1),(453,7481172,7481164,'ace',14.286,1),(453,7481173,7481166,'dis',50,1),(453,7481174,7481166,'isk',50,1),(453,7481175,7481173,'ind',33.333,1),(453,7481176,7481173,'nde',33.333,1),(453,7481177,7481173,'dex',33.333,1),(453,7481178,7481175,'adm',8.333,1),(453,7481179,7481175,'dmi',8.333,1),(453,7481180,7481175,'min',8.333,1),(453,7481181,7481175,'ini',8.333,1),(453,7481182,7481175,'nis',8.333,1),(453,7481183,7481175,'ist',8.333,1),(453,7481184,7481175,'str',8.333,1),(453,7481185,7481175,'tra',8.333,1),(453,7481186,7481175,'rat',8.333,1),(453,7481187,7481175,'ati',8.333,1),(453,7481188,7481175,'tio',8.333,1),(453,7481189,7481175,'ion',8.333,1),(453,7481190,7481178,'sta',33.333,3),(453,7481191,7481178,'tat',33.333,3),(453,7481192,7481178,'ate',33.333,3),(453,7481193,7481190,'ena',20,2),(453,7481194,7481190,'nab',20,2),(453,7481195,7481190,'abl',20,2),(453,7481196,7481190,'ble',20,2),(453,7481197,7481190,'led',20,2),(453,7481198,7481193,'cac',33.333,2),(453,7481199,7481193,'ach',33.333,2),(453,7481200,7481193,'che',33.333,2),(453,7481201,7481198,'mod',50,1),(453,7481202,7481198,'ode',50,1),(453,7481203,7481201,'wri',14.286,1),(453,7481204,7481201,'rit',14.286,1),(453,7481205,7481201,'ite',14.286,1),(453,7481206,7481201,'tet',14.286,1),(453,7481207,7481201,'eth',14.286,1),(453,7481208,7481201,'thr',14.286,1),(453,7481209,7481201,'hru',14.286,1),(453,7481210,7481203,'ope',11.111,2),(453,7481211,7481203,'per',11.111,2),(453,7481212,7481203,'era',11.111,2),(453,7481213,7481203,'rat',11.111,2),(453,7481214,7481203,'ati',11.111,2),(453,7481215,7481203,'tio',11.111,2),(453,7481216,7481203,'ion',11.111,2),(453,7481217,7481203,'ona',11.111,2),(453,7481218,7481203,'nal',11.111,2),(453,7481219,7481210,'pen',20,1),(453,7481220,7481210,'end',20,1),(453,7481221,7481210,'ndi',20,1),(453,7481222,7481210,'din',20,1),(453,7481223,7481210,'ing',20,1),(453,7481224,7481219,'mes',20,1),(453,7481225,7481219,'ess',20,1),(453,7481226,7481219,'ssa',20,1),(453,7481227,7481219,'sag',20,1),(453,7481228,7481219,'age',20,1),(453,7481229,7481224,'wai',20,1),(453,7481230,7481224,'ait',20,1),(453,7481231,7481224,'iti',20,1),(453,7481232,7481224,'tin',20,1),(453,7481233,7481224,'ing',20,1),(453,7481234,7481229,'for',100,1),(453,7481235,7481234,'per',11.111,1),(453,7481236,7481234,'erf',11.111,1),(453,7481237,7481234,'rfo',11.111,1),(453,7481238,7481234,'for',11.111,1),(453,7481239,7481234,'orm',11.111,1),(453,7481240,7481234,'rma',11.111,1),(453,7481241,7481234,'man',11.111,1),(453,7481242,7481234,'anc',11.111,1),(453,7481243,7481234,'nce',11.111,1),(453,7481244,7481235,'ide',12.5,1),(453,7481245,7481235,'den',12.5,1),(453,7481246,7481235,'ent',12.5,1),(453,7481247,7481235,'nti',12.5,1),(453,7481248,7481235,'tif',12.5,1),(453,7481249,7481235,'ifi',12.5,1),(453,7481250,7481235,'fie',12.5,1),(453,7481251,7481235,'ier',12.5,1),(453,7481252,7481244,'vdi',33.333,3),(453,7481253,7481244,'dis',33.333,3),(453,7481254,7481244,'isk',33.333,3),(453,7481255,7481252,'nam',50,1),(453,7481256,7481252,'ame',50,1),(453,7481257,7481255,'typ',50,1),(453,7481258,7481255,'ype',50,1),(453,7481259,7481257,'dir',25,1),(453,7481260,7481257,'ire',25,1),(453,7481261,7481257,'rec',25,1),(453,7481262,7481257,'ect',25,1),(454,7481264,7481263,'naa',100,2),(454,7481265,7481264,'600',3.333,3),(454,7481266,7481264,'000',3.333,3),(454,7481267,7481264,'00c',3.333,3),(454,7481268,7481264,'0c2',3.333,3),(454,7481269,7481264,'c29',3.333,3),(454,7481270,7481264,'29a',3.333,3),(454,7481271,7481264,'9a8',3.333,3),(454,7481272,7481264,'a87',3.333,3),(454,7481273,7481264,'877',3.333,3),(454,7481274,7481264,'772',3.333,3),(454,7481275,7481264,'723',3.333,3),(454,7481276,7481264,'23e',3.333,3),(454,7481277,7481264,'3ee',3.333,3),(454,7481278,7481264,'ee3',3.333,3),(454,7481279,7481264,'e33',3.333,3),(454,7481280,7481264,'338',3.333,3),(454,7481281,7481264,'383',3.333,3),(454,7481282,7481264,'835',3.333,3),(454,7481283,7481264,'351',3.333,3),(454,7481284,7481264,'51b',3.333,3),(454,7481285,7481264,'1be',3.333,3),(454,7481286,7481264,'bee',3.333,3),(454,7481287,7481264,'eef',3.333,3),(454,7481288,7481264,'eff',3.333,3),(454,7481289,7481264,'fff',3.333,3),(454,7481290,7481264,'ff3',3.333,3),(454,7481291,7481264,'f3a',3.333,3),(454,7481292,7481264,'3a7',3.333,3),(454,7481293,7481264,'a76',3.333,3),(454,7481294,7481264,'76a',3.333,3),(454,7481295,7481265,'mon',100,1),(454,7481296,7481295,'201',50,1),(454,7481297,7481295,'013',50,1),(454,7481298,7481296,'adm',33.333,3),(454,7481299,7481296,'dmi',33.333,3),(454,7481300,7481296,'min',33.333,3),(454,7481301,7481298,'cap',16.667,1),(454,7481302,7481298,'apa',16.667,1),(454,7481303,7481298,'pac',16.667,1),(454,7481304,7481298,'aci',16.667,1),(454,7481305,7481298,'cit',16.667,1),(454,7481306,7481298,'ity',16.667,1),(454,7481307,7481301,'pat',50,1),(454,7481308,7481301,'ath',50,1),(454,7481309,7481307,'fre',14.286,1),(454,7481310,7481307,'ree',14.286,1),(454,7481311,7481307,'ees',14.286,1),(454,7481312,7481307,'esp',14.286,1),(454,7481313,7481307,'spa',14.286,1),(454,7481314,7481307,'pac',14.286,1),(454,7481315,7481307,'ace',14.286,1),(454,7481316,7481309,'dis',50,1),(454,7481317,7481309,'isk',50,1),(454,7481318,7481316,'ind',33.333,1),(454,7481319,7481316,'nde',33.333,1),(454,7481320,7481316,'dex',33.333,1),(454,7481321,7481318,'adm',8.333,1),(454,7481322,7481318,'dmi',8.333,1),(454,7481323,7481318,'min',8.333,1),(454,7481324,7481318,'ini',8.333,1),(454,7481325,7481318,'nis',8.333,1),(454,7481326,7481318,'ist',8.333,1),(454,7481327,7481318,'str',8.333,1),(454,7481328,7481318,'tra',8.333,1),(454,7481329,7481318,'rat',8.333,1),(454,7481330,7481318,'ati',8.333,1),(454,7481331,7481318,'tio',8.333,1),(454,7481332,7481318,'ion',8.333,1),(454,7481333,7481321,'sta',33.333,3),(454,7481334,7481321,'tat',33.333,3),(454,7481335,7481321,'ate',33.333,3),(454,7481336,7481333,'ena',20,2),(454,7481337,7481333,'nab',20,2),(454,7481338,7481333,'abl',20,2),(454,7481339,7481333,'ble',20,2),(454,7481340,7481333,'led',20,2),(454,7481341,7481336,'cac',33.333,2),(454,7481342,7481336,'ach',33.333,2),(454,7481343,7481336,'che',33.333,2),(454,7481344,7481341,'mod',50,1),(454,7481345,7481341,'ode',50,1),(454,7481346,7481344,'wri',14.286,1),(454,7481347,7481344,'rit',14.286,1),(454,7481348,7481344,'ite',14.286,1),(454,7481349,7481344,'tet',14.286,1),(454,7481350,7481344,'eth',14.286,1),(454,7481351,7481344,'thr',14.286,1),(454,7481352,7481344,'hru',14.286,1),(454,7481353,7481346,'ope',11.111,2),(454,7481354,7481346,'per',11.111,2),(454,7481355,7481346,'era',11.111,2),(454,7481356,7481346,'rat',11.111,2),(454,7481357,7481346,'ati',11.111,2),(454,7481358,7481346,'tio',11.111,2),(454,7481359,7481346,'ion',11.111,2),(454,7481360,7481346,'ona',11.111,2),(454,7481361,7481346,'nal',11.111,2),(454,7481362,7481353,'pen',20,1),(454,7481363,7481353,'end',20,1),(454,7481364,7481353,'ndi',20,1),(454,7481365,7481353,'din',20,1),(454,7481366,7481353,'ing',20,1),(454,7481367,7481362,'mes',20,1),(454,7481368,7481362,'ess',20,1),(454,7481369,7481362,'ssa',20,1),(454,7481370,7481362,'sag',20,1),(454,7481371,7481362,'age',20,1),(454,7481372,7481367,'wai',20,1),(454,7481373,7481367,'ait',20,1),(454,7481374,7481367,'iti',20,1),(454,7481375,7481367,'tin',20,1),(454,7481376,7481367,'ing',20,1),(454,7481377,7481372,'for',100,1),(454,7481378,7481377,'per',11.111,1),(454,7481379,7481377,'erf',11.111,1),(454,7481380,7481377,'rfo',11.111,1),(454,7481381,7481377,'for',11.111,1),(454,7481382,7481377,'orm',11.111,1),(454,7481383,7481377,'rma',11.111,1),(454,7481384,7481377,'man',11.111,1),(454,7481385,7481377,'anc',11.111,1),(454,7481386,7481377,'nce',11.111,1),(454,7481387,7481378,'ide',12.5,1),(454,7481388,7481378,'den',12.5,1),(454,7481389,7481378,'ent',12.5,1),(454,7481390,7481378,'nti',12.5,1),(454,7481391,7481378,'tif',12.5,1),(454,7481392,7481378,'ifi',12.5,1),(454,7481393,7481378,'fie',12.5,1),(454,7481394,7481378,'ier',12.5,1),(454,7481395,7481387,'vdi',33.333,3),(454,7481396,7481387,'dis',33.333,3),(454,7481397,7481387,'isk',33.333,3),(454,7481398,7481395,'nam',50,1),(454,7481399,7481395,'ame',50,1),(454,7481400,7481398,'typ',50,1),(454,7481401,7481398,'ype',50,1),(454,7481402,7481400,'dir',25,1),(454,7481403,7481400,'ire',25,1),(454,7481404,7481400,'rec',25,1),(454,7481405,7481400,'ect',25,1),(455,7481407,7481406,'naa',100,2),(455,7481408,7481407,'600',3.333,3),(455,7481409,7481407,'000',3.333,3),(455,7481410,7481407,'00c',3.333,3),(455,7481411,7481407,'0c2',3.333,3),(455,7481412,7481407,'c29',3.333,3),(455,7481413,7481407,'29b',3.333,3),(455,7481414,7481407,'9be',3.333,3),(455,7481415,7481407,'be9',3.333,3),(455,7481416,7481407,'e91',3.333,3),(455,7481417,7481407,'91a',3.333,3),(455,7481418,7481407,'1af',3.333,3),(455,7481419,7481407,'afe',3.333,3),(455,7481420,7481407,'fe4',3.333,3),(455,7481421,7481407,'e40',3.333,3),(455,7481422,7481407,'402',3.333,3),(455,7481423,7481407,'02a',3.333,3),(455,7481424,7481407,'2ae',3.333,3),(455,7481425,7481407,'ae9',3.333,3),(455,7481426,7481407,'e96',3.333,3),(455,7481427,7481407,'96f',3.333,3),(455,7481428,7481407,'6fe',3.333,3),(455,7481429,7481407,'fef',3.333,3),(455,7481430,7481407,'ef3',3.333,3),(455,7481431,7481407,'f3a',3.333,3),(455,7481432,7481407,'3af',3.333,3),(455,7481433,7481407,'aff',3.333,3),(455,7481434,7481407,'ffb',3.333,3),(455,7481435,7481407,'fb2',3.333,3),(455,7481436,7481407,'b26',3.333,3),(455,7481437,7481407,'26e',3.333,3),(455,7481438,7481408,'mon',100,1),(455,7481439,7481438,'201',50,1),(455,7481440,7481438,'013',50,1),(455,7481441,7481439,'adm',33.333,3),(455,7481442,7481439,'dmi',33.333,3),(455,7481443,7481439,'min',33.333,3),(455,7481444,7481441,'cap',16.667,1),(455,7481445,7481441,'apa',16.667,1),(455,7481446,7481441,'pac',16.667,1),(455,7481447,7481441,'aci',16.667,1),(455,7481448,7481441,'cit',16.667,1),(455,7481449,7481441,'ity',16.667,1),(455,7481450,7481444,'pat',50,1),(455,7481451,7481444,'ath',50,1),(455,7481452,7481450,'fre',14.286,1),(455,7481453,7481450,'ree',14.286,1),(455,7481454,7481450,'ees',14.286,1),(455,7481455,7481450,'esp',14.286,1),(455,7481456,7481450,'spa',14.286,1),(455,7481457,7481450,'pac',14.286,1),(455,7481458,7481450,'ace',14.286,1),(455,7481459,7481452,'dis',50,1),(455,7481460,7481452,'isk',50,1),(455,7481461,7481459,'ind',33.333,1),(455,7481462,7481459,'nde',33.333,1),(455,7481463,7481459,'dex',33.333,1),(455,7481464,7481461,'adm',8.333,1),(455,7481465,7481461,'dmi',8.333,1),(455,7481466,7481461,'min',8.333,1),(455,7481467,7481461,'ini',8.333,1),(455,7481468,7481461,'nis',8.333,1),(455,7481469,7481461,'ist',8.333,1),(455,7481470,7481461,'str',8.333,1),(455,7481471,7481461,'tra',8.333,1),(455,7481472,7481461,'rat',8.333,1),(455,7481473,7481461,'ati',8.333,1),(455,7481474,7481461,'tio',8.333,1),(455,7481475,7481461,'ion',8.333,1),(455,7481476,7481464,'sta',33.333,3),(455,7481477,7481464,'tat',33.333,3),(455,7481478,7481464,'ate',33.333,3),(455,7481479,7481476,'ena',20,2),(455,7481480,7481476,'nab',20,2),(455,7481481,7481476,'abl',20,2),(455,7481482,7481476,'ble',20,2),(455,7481483,7481476,'led',20,2),(455,7481484,7481479,'cac',33.333,2),(455,7481485,7481479,'ach',33.333,2),(455,7481486,7481479,'che',33.333,2),(455,7481487,7481484,'mod',50,1),(455,7481488,7481484,'ode',50,1),(455,7481489,7481487,'wri',14.286,1),(455,7481490,7481487,'rit',14.286,1),(455,7481491,7481487,'ite',14.286,1),(455,7481492,7481487,'tet',14.286,1),(455,7481493,7481487,'eth',14.286,1),(455,7481494,7481487,'thr',14.286,1),(455,7481495,7481487,'hru',14.286,1),(455,7481496,7481489,'ope',11.111,2),(455,7481497,7481489,'per',11.111,2),(455,7481498,7481489,'era',11.111,2),(455,7481499,7481489,'rat',11.111,2),(455,7481500,7481489,'ati',11.111,2),(455,7481501,7481489,'tio',11.111,2),(455,7481502,7481489,'ion',11.111,2),(455,7481503,7481489,'ona',11.111,2),(455,7481504,7481489,'nal',11.111,2),(455,7481505,7481496,'pen',20,1),(455,7481506,7481496,'end',20,1),(455,7481507,7481496,'ndi',20,1),(455,7481508,7481496,'din',20,1),(455,7481509,7481496,'ing',20,1),(455,7481510,7481505,'mes',20,1),(455,7481511,7481505,'ess',20,1),(455,7481512,7481505,'ssa',20,1),(455,7481513,7481505,'sag',20,1),(455,7481514,7481505,'age',20,1),(455,7481515,7481510,'wai',20,1),(455,7481516,7481510,'ait',20,1),(455,7481517,7481510,'iti',20,1),(455,7481518,7481510,'tin',20,1),(455,7481519,7481510,'ing',20,1),(455,7481520,7481515,'for',100,1),(455,7481521,7481520,'per',11.111,1),(455,7481522,7481520,'erf',11.111,1),(455,7481523,7481520,'rfo',11.111,1),(455,7481524,7481520,'for',11.111,1),(455,7481525,7481520,'orm',11.111,1),(455,7481526,7481520,'rma',11.111,1),(455,7481527,7481520,'man',11.111,1),(455,7481528,7481520,'anc',11.111,1),(455,7481529,7481520,'nce',11.111,1),(455,7481530,7481521,'ide',12.5,1),(455,7481531,7481521,'den',12.5,1),(455,7481532,7481521,'ent',12.5,1),(455,7481533,7481521,'nti',12.5,1),(455,7481534,7481521,'tif',12.5,1),(455,7481535,7481521,'ifi',12.5,1),(455,7481536,7481521,'fie',12.5,1),(455,7481537,7481521,'ier',12.5,1),(455,7481538,7481530,'vdi',33.333,3),(455,7481539,7481530,'dis',33.333,3),(455,7481540,7481530,'isk',33.333,3),(455,7481541,7481538,'nam',50,1),(455,7481542,7481538,'ame',50,1),(455,7481543,7481541,'typ',50,1),(455,7481544,7481541,'ype',50,1),(455,7481545,7481543,'dir',25,1),(455,7481546,7481543,'ire',25,1),(455,7481547,7481543,'rec',25,1),(455,7481548,7481543,'ect',25,1),(456,7481550,7481549,'naa',100,2),(456,7481551,7481550,'600',3.333,3),(456,7481552,7481550,'000',3.333,3),(456,7481553,7481550,'00c',3.333,3),(456,7481554,7481550,'0c2',3.333,3),(456,7481555,7481550,'c29',3.333,3),(456,7481556,7481550,'298',3.333,3),(456,7481557,7481550,'984',3.333,3),(456,7481558,7481550,'843',3.333,3),(456,7481559,7481550,'434',3.333,3),(456,7481560,7481550,'349',3.333,3),(456,7481561,7481550,'495',3.333,3),(456,7481562,7481550,'95e',3.333,3),(456,7481563,7481550,'5e0',3.333,3),(456,7481564,7481550,'e04',3.333,3),(456,7481565,7481550,'04f',3.333,3),(456,7481566,7481550,'4fb',3.333,3),(456,7481567,7481550,'fb9',3.333,3),(456,7481568,7481550,'b98',3.333,3),(456,7481569,7481550,'98b',3.333,3),(456,7481570,7481550,'8bb',3.333,3),(456,7481571,7481550,'bb2',3.333,3),(456,7481572,7481550,'b2a',3.333,3),(456,7481573,7481550,'2a0',3.333,3),(456,7481574,7481550,'a0d',3.333,3),(456,7481575,7481550,'0dc',3.333,3),(456,7481576,7481550,'dc2',3.333,3),(456,7481577,7481550,'c23',3.333,3),(456,7481578,7481550,'233',3.333,3),(456,7481579,7481550,'332',3.333,3),(456,7481580,7481550,'32c',3.333,3),(456,7481581,7481551,'mon',100,1),(456,7481582,7481581,'201',50,1),(456,7481583,7481581,'013',50,1),(456,7481584,7481582,'adm',33.333,3),(456,7481585,7481582,'dmi',33.333,3),(456,7481586,7481582,'min',33.333,3),(456,7481587,7481584,'cap',16.667,1),(456,7481588,7481584,'apa',16.667,1),(456,7481589,7481584,'pac',16.667,1),(456,7481590,7481584,'aci',16.667,1),(456,7481591,7481584,'cit',16.667,1),(456,7481592,7481584,'ity',16.667,1),(456,7481593,7481587,'pat',50,1),(456,7481594,7481587,'ath',50,1),(456,7481595,7481593,'fre',14.286,1),(456,7481596,7481593,'ree',14.286,1),(456,7481597,7481593,'ees',14.286,1),(456,7481598,7481593,'esp',14.286,1),(456,7481599,7481593,'spa',14.286,1),(456,7481600,7481593,'pac',14.286,1),(456,7481601,7481593,'ace',14.286,1),(456,7481602,7481595,'dis',50,1),(456,7481603,7481595,'isk',50,1),(456,7481604,7481602,'ind',33.333,1),(456,7481605,7481602,'nde',33.333,1),(456,7481606,7481602,'dex',33.333,1),(456,7481607,7481604,'adm',8.333,1),(456,7481608,7481604,'dmi',8.333,1),(456,7481609,7481604,'min',8.333,1),(456,7481610,7481604,'ini',8.333,1),(456,7481611,7481604,'nis',8.333,1),(456,7481612,7481604,'ist',8.333,1),(456,7481613,7481604,'str',8.333,1),(456,7481614,7481604,'tra',8.333,1),(456,7481615,7481604,'rat',8.333,1),(456,7481616,7481604,'ati',8.333,1),(456,7481617,7481604,'tio',8.333,1),(456,7481618,7481604,'ion',8.333,1),(456,7481619,7481607,'sta',33.333,3),(456,7481620,7481607,'tat',33.333,3),(456,7481621,7481607,'ate',33.333,3),(456,7481622,7481619,'ena',20,2),(456,7481623,7481619,'nab',20,2),(456,7481624,7481619,'abl',20,2),(456,7481625,7481619,'ble',20,2),(456,7481626,7481619,'led',20,2),(456,7481627,7481622,'cac',33.333,2),(456,7481628,7481622,'ach',33.333,2),(456,7481629,7481622,'che',33.333,2),(456,7481630,7481627,'mod',50,1),(456,7481631,7481627,'ode',50,1),(456,7481632,7481630,'wri',14.286,1),(456,7481633,7481630,'rit',14.286,1),(456,7481634,7481630,'ite',14.286,1),(456,7481635,7481630,'tet',14.286,1),(456,7481636,7481630,'eth',14.286,1),(456,7481637,7481630,'thr',14.286,1),(456,7481638,7481630,'hru',14.286,1),(456,7481639,7481632,'ope',11.111,2),(456,7481640,7481632,'per',11.111,2),(456,7481641,7481632,'era',11.111,2),(456,7481642,7481632,'rat',11.111,2),(456,7481643,7481632,'ati',11.111,2),(456,7481644,7481632,'tio',11.111,2),(456,7481645,7481632,'ion',11.111,2),(456,7481646,7481632,'ona',11.111,2),(456,7481647,7481632,'nal',11.111,2),(456,7481648,7481639,'pen',20,1),(456,7481649,7481639,'end',20,1),(456,7481650,7481639,'ndi',20,1),(456,7481651,7481639,'din',20,1),(456,7481652,7481639,'ing',20,1),(456,7481653,7481648,'mes',20,1),(456,7481654,7481648,'ess',20,1),(456,7481655,7481648,'ssa',20,1),(456,7481656,7481648,'sag',20,1),(456,7481657,7481648,'age',20,1),(456,7481658,7481653,'wai',20,1),(456,7481659,7481653,'ait',20,1),(456,7481660,7481653,'iti',20,1),(456,7481661,7481653,'tin',20,1),(456,7481662,7481653,'ing',20,1),(456,7481663,7481658,'for',100,1),(456,7481664,7481663,'per',11.111,1),(456,7481665,7481663,'erf',11.111,1),(456,7481666,7481663,'rfo',11.111,1),(456,7481667,7481663,'for',11.111,1),(456,7481668,7481663,'orm',11.111,1),(456,7481669,7481663,'rma',11.111,1),(456,7481670,7481663,'man',11.111,1),(456,7481671,7481663,'anc',11.111,1),(456,7481672,7481663,'nce',11.111,1),(456,7481673,7481664,'ide',12.5,1),(456,7481674,7481664,'den',12.5,1),(456,7481675,7481664,'ent',12.5,1),(456,7481676,7481664,'nti',12.5,1),(456,7481677,7481664,'tif',12.5,1),(456,7481678,7481664,'ifi',12.5,1),(456,7481679,7481664,'fie',12.5,1),(456,7481680,7481664,'ier',12.5,1),(456,7481681,7481673,'vdi',33.333,3),(456,7481682,7481673,'dis',33.333,3),(456,7481683,7481673,'isk',33.333,3),(456,7481684,7481681,'nam',50,1),(456,7481685,7481681,'ame',50,1),(456,7481686,7481684,'typ',50,1),(456,7481687,7481684,'ype',50,1),(456,7481688,7481686,'dir',25,1),(456,7481689,7481686,'ire',25,1),(456,7481690,7481686,'rec',25,1),(456,7481691,7481686,'ect',25,1),(457,7481693,7481692,'naa',100,2),(457,7481694,7481693,'600',3.333,3),(457,7481695,7481693,'000',3.333,3),(457,7481696,7481693,'00c',3.333,3),(457,7481697,7481693,'0c2',3.333,3),(457,7481698,7481693,'c29',3.333,3),(457,7481699,7481693,'29b',3.333,3),(457,7481700,7481693,'9b8',3.333,3),(457,7481701,7481693,'b80',3.333,3),(457,7481702,7481693,'807',3.333,3),(457,7481703,7481693,'07b',3.333,3),(457,7481704,7481693,'7b8',3.333,3),(457,7481705,7481693,'b80',3.333,3),(457,7481706,7481693,'80b',3.333,3),(457,7481707,7481693,'0b7',3.333,3),(457,7481708,7481693,'b72',3.333,3),(457,7481709,7481693,'721',3.333,3),(457,7481710,7481693,'213',3.333,3),(457,7481711,7481693,'131',3.333,3),(457,7481712,7481693,'310',3.333,3),(457,7481713,7481693,'104',3.333,3),(457,7481714,7481693,'045',3.333,3),(457,7481715,7481693,'459',3.333,3),(457,7481716,7481693,'591',3.333,3),(457,7481717,7481693,'915',3.333,3),(457,7481718,7481693,'15c',3.333,3),(457,7481719,7481693,'5c5',3.333,3),(457,7481720,7481693,'c52',3.333,3),(457,7481721,7481693,'52f',3.333,3),(457,7481722,7481693,'2ff',3.333,3),(457,7481723,7481693,'ffc',3.333,3),(457,7481724,7481694,'mon',100,1),(457,7481725,7481724,'201',50,1),(457,7481726,7481724,'013',50,1),(457,7481727,7481725,'adm',33.333,3),(457,7481728,7481725,'dmi',33.333,3),(457,7481729,7481725,'min',33.333,3),(457,7481730,7481727,'cap',16.667,1),(457,7481731,7481727,'apa',16.667,1),(457,7481732,7481727,'pac',16.667,1),(457,7481733,7481727,'aci',16.667,1),(457,7481734,7481727,'cit',16.667,1),(457,7481735,7481727,'ity',16.667,1),(457,7481736,7481730,'pat',50,1),(457,7481737,7481730,'ath',50,1),(457,7481738,7481736,'fre',14.286,1),(457,7481739,7481736,'ree',14.286,1),(457,7481740,7481736,'ees',14.286,1),(457,7481741,7481736,'esp',14.286,1),(457,7481742,7481736,'spa',14.286,1),(457,7481743,7481736,'pac',14.286,1),(457,7481744,7481736,'ace',14.286,1),(457,7481745,7481738,'dis',50,1),(457,7481746,7481738,'isk',50,1),(457,7481747,7481745,'ind',33.333,1),(457,7481748,7481745,'nde',33.333,1),(457,7481749,7481745,'dex',33.333,1),(457,7481750,7481747,'adm',8.333,1),(457,7481751,7481747,'dmi',8.333,1),(457,7481752,7481747,'min',8.333,1),(457,7481753,7481747,'ini',8.333,1),(457,7481754,7481747,'nis',8.333,1),(457,7481755,7481747,'ist',8.333,1),(457,7481756,7481747,'str',8.333,1),(457,7481757,7481747,'tra',8.333,1),(457,7481758,7481747,'rat',8.333,1),(457,7481759,7481747,'ati',8.333,1),(457,7481760,7481747,'tio',8.333,1),(457,7481761,7481747,'ion',8.333,1),(457,7481762,7481750,'sta',33.333,3),(457,7481763,7481750,'tat',33.333,3),(457,7481764,7481750,'ate',33.333,3),(457,7481765,7481762,'ena',20,2),(457,7481766,7481762,'nab',20,2),(457,7481767,7481762,'abl',20,2),(457,7481768,7481762,'ble',20,2),(457,7481769,7481762,'led',20,2),(457,7481770,7481765,'cac',33.333,2),(457,7481771,7481765,'ach',33.333,2),(457,7481772,7481765,'che',33.333,2),(457,7481773,7481770,'mod',50,1),(457,7481774,7481770,'ode',50,1),(457,7481775,7481773,'wri',14.286,1),(457,7481776,7481773,'rit',14.286,1),(457,7481777,7481773,'ite',14.286,1),(457,7481778,7481773,'tet',14.286,1),(457,7481779,7481773,'eth',14.286,1),(457,7481780,7481773,'thr',14.286,1),(457,7481781,7481773,'hru',14.286,1),(457,7481782,7481775,'ope',11.111,2),(457,7481783,7481775,'per',11.111,2),(457,7481784,7481775,'era',11.111,2),(457,7481785,7481775,'rat',11.111,2),(457,7481786,7481775,'ati',11.111,2),(457,7481787,7481775,'tio',11.111,2),(457,7481788,7481775,'ion',11.111,2),(457,7481789,7481775,'ona',11.111,2),(457,7481790,7481775,'nal',11.111,2),(457,7481791,7481782,'pen',20,1),(457,7481792,7481782,'end',20,1),(457,7481793,7481782,'ndi',20,1),(457,7481794,7481782,'din',20,1),(457,7481795,7481782,'ing',20,1),(457,7481796,7481791,'mes',20,1),(457,7481797,7481791,'ess',20,1),(457,7481798,7481791,'ssa',20,1),(457,7481799,7481791,'sag',20,1),(457,7481800,7481791,'age',20,1),(457,7481801,7481796,'wai',20,1),(457,7481802,7481796,'ait',20,1),(457,7481803,7481796,'iti',20,1),(457,7481804,7481796,'tin',20,1),(457,7481805,7481796,'ing',20,1),(457,7481806,7481801,'for',100,1),(457,7481807,7481806,'per',11.111,1),(457,7481808,7481806,'erf',11.111,1),(457,7481809,7481806,'rfo',11.111,1),(457,7481810,7481806,'for',11.111,1),(457,7481811,7481806,'orm',11.111,1),(457,7481812,7481806,'rma',11.111,1),(457,7481813,7481806,'man',11.111,1),(457,7481814,7481806,'anc',11.111,1),(457,7481815,7481806,'nce',11.111,1),(457,7481816,7481807,'ide',12.5,1),(457,7481817,7481807,'den',12.5,1),(457,7481818,7481807,'ent',12.5,1),(457,7481819,7481807,'nti',12.5,1),(457,7481820,7481807,'tif',12.5,1),(457,7481821,7481807,'ifi',12.5,1),(457,7481822,7481807,'fie',12.5,1),(457,7481823,7481807,'ier',12.5,1),(457,7481824,7481816,'vdi',33.333,3),(457,7481825,7481816,'dis',33.333,3),(457,7481826,7481816,'isk',33.333,3),(457,7481827,7481824,'nam',50,1),(457,7481828,7481824,'ame',50,1),(457,7481829,7481827,'typ',50,1),(457,7481830,7481827,'ype',50,1),(457,7481831,7481829,'dir',25,1),(457,7481832,7481829,'ire',25,1),(457,7481833,7481829,'rec',25,1),(457,7481834,7481829,'ect',25,1),(458,7481836,7481835,'naa',100,2),(458,7481837,7481836,'600',3.333,3),(458,7481838,7481836,'000',3.333,3),(458,7481839,7481836,'00c',3.333,3),(458,7481840,7481836,'0c2',3.333,3),(458,7481841,7481836,'c29',3.333,3),(458,7481842,7481836,'29f',3.333,3),(458,7481843,7481836,'9fc',3.333,3),(458,7481844,7481836,'fc9',3.333,3),(458,7481845,7481836,'c92',3.333,3),(458,7481846,7481836,'92d',3.333,3),(458,7481847,7481836,'2dc',3.333,3),(458,7481848,7481836,'dc7',3.333,3),(458,7481849,7481836,'c78',3.333,3),(458,7481850,7481836,'78e',3.333,3),(458,7481851,7481836,'8e1',3.333,3),(458,7481852,7481836,'e10',3.333,3),(458,7481853,7481836,'108',3.333,3),(458,7481854,7481836,'084',3.333,3),(458,7481855,7481836,'840',3.333,3),(458,7481856,7481836,'403',3.333,3),(458,7481857,7481836,'03d',3.333,3),(458,7481858,7481836,'3df',3.333,3),(458,7481859,7481836,'dfc',3.333,3),(458,7481860,7481836,'fc0',3.333,3),(458,7481861,7481836,'c0d',3.333,3),(458,7481862,7481836,'0dc',3.333,3),(458,7481863,7481836,'dc5',3.333,3),(458,7481864,7481836,'c50',3.333,3),(458,7481865,7481836,'500',3.333,3),(458,7481866,7481836,'004',3.333,3),(458,7481867,7481837,'mon',100,1),(458,7481868,7481867,'201',50,1),(458,7481869,7481867,'013',50,1),(458,7481870,7481868,'adm',33.333,3),(458,7481871,7481868,'dmi',33.333,3),(458,7481872,7481868,'min',33.333,3),(458,7481873,7481870,'cap',16.667,1),(458,7481874,7481870,'apa',16.667,1),(458,7481875,7481870,'pac',16.667,1),(458,7481876,7481870,'aci',16.667,1),(458,7481877,7481870,'cit',16.667,1),(458,7481878,7481870,'ity',16.667,1),(458,7481879,7481873,'pat',50,1),(458,7481880,7481873,'ath',50,1),(458,7481881,7481879,'fre',14.286,1),(458,7481882,7481879,'ree',14.286,1),(458,7481883,7481879,'ees',14.286,1),(458,7481884,7481879,'esp',14.286,1),(458,7481885,7481879,'spa',14.286,1),(458,7481886,7481879,'pac',14.286,1),(458,7481887,7481879,'ace',14.286,1),(458,7481888,7481881,'dis',50,1),(458,7481889,7481881,'isk',50,1),(458,7481890,7481888,'ind',33.333,1),(458,7481891,7481888,'nde',33.333,1),(458,7481892,7481888,'dex',33.333,1),(458,7481893,7481890,'adm',8.333,1),(458,7481894,7481890,'dmi',8.333,1),(458,7481895,7481890,'min',8.333,1),(458,7481896,7481890,'ini',8.333,1),(458,7481897,7481890,'nis',8.333,1),(458,7481898,7481890,'ist',8.333,1),(458,7481899,7481890,'str',8.333,1),(458,7481900,7481890,'tra',8.333,1),(458,7481901,7481890,'rat',8.333,1),(458,7481902,7481890,'ati',8.333,1),(458,7481903,7481890,'tio',8.333,1),(458,7481904,7481890,'ion',8.333,1),(458,7481905,7481893,'sta',33.333,3),(458,7481906,7481893,'tat',33.333,3),(458,7481907,7481893,'ate',33.333,3),(458,7481908,7481905,'ena',20,2),(458,7481909,7481905,'nab',20,2),(458,7481910,7481905,'abl',20,2),(458,7481911,7481905,'ble',20,2),(458,7481912,7481905,'led',20,2),(458,7481913,7481908,'cac',33.333,2),(458,7481914,7481908,'ach',33.333,2),(458,7481915,7481908,'che',33.333,2),(458,7481916,7481913,'mod',50,1),(458,7481917,7481913,'ode',50,1),(458,7481918,7481916,'wri',14.286,1),(458,7481919,7481916,'rit',14.286,1),(458,7481920,7481916,'ite',14.286,1),(458,7481921,7481916,'tet',14.286,1),(458,7481922,7481916,'eth',14.286,1),(458,7481923,7481916,'thr',14.286,1),(458,7481924,7481916,'hru',14.286,1),(458,7481925,7481918,'ope',11.111,2),(458,7481926,7481918,'per',11.111,2),(458,7481927,7481918,'era',11.111,2),(458,7481928,7481918,'rat',11.111,2),(458,7481929,7481918,'ati',11.111,2),(458,7481930,7481918,'tio',11.111,2),(458,7481931,7481918,'ion',11.111,2),(458,7481932,7481918,'ona',11.111,2),(458,7481933,7481918,'nal',11.111,2),(458,7481934,7481925,'pen',20,1),(458,7481935,7481925,'end',20,1),(458,7481936,7481925,'ndi',20,1),(458,7481937,7481925,'din',20,1),(458,7481938,7481925,'ing',20,1),(458,7481939,7481934,'mes',20,1),(458,7481940,7481934,'ess',20,1),(458,7481941,7481934,'ssa',20,1),(458,7481942,7481934,'sag',20,1),(458,7481943,7481934,'age',20,1),(458,7481944,7481939,'wai',20,1),(458,7481945,7481939,'ait',20,1),(458,7481946,7481939,'iti',20,1),(458,7481947,7481939,'tin',20,1),(458,7481948,7481939,'ing',20,1),(458,7481949,7481944,'for',100,1),(458,7481950,7481949,'per',11.111,1),(458,7481951,7481949,'erf',11.111,1),(458,7481952,7481949,'rfo',11.111,1),(458,7481953,7481949,'for',11.111,1),(458,7481954,7481949,'orm',11.111,1),(458,7481955,7481949,'rma',11.111,1),(458,7481956,7481949,'man',11.111,1),(458,7481957,7481949,'anc',11.111,1),(458,7481958,7481949,'nce',11.111,1),(458,7481959,7481950,'ide',12.5,1),(458,7481960,7481950,'den',12.5,1),(458,7481961,7481950,'ent',12.5,1),(458,7481962,7481950,'nti',12.5,1),(458,7481963,7481950,'tif',12.5,1),(458,7481964,7481950,'ifi',12.5,1),(458,7481965,7481950,'fie',12.5,1),(458,7481966,7481950,'ier',12.5,1),(458,7481967,7481959,'vdi',33.333,3),(458,7481968,7481959,'dis',33.333,3),(458,7481969,7481959,'isk',33.333,3),(458,7481970,7481967,'nam',50,1),(458,7481971,7481967,'ame',50,1),(458,7481972,7481970,'typ',50,1),(458,7481973,7481970,'ype',50,1),(458,7481974,7481972,'dir',25,1),(458,7481975,7481972,'ire',25,1),(458,7481976,7481972,'rec',25,1),(458,7481977,7481972,'ect',25,1),(459,7481979,7481978,'naa',100,2),(459,7481980,7481979,'600',3.333,3),(459,7481981,7481979,'000',3.333,3),(459,7481982,7481979,'00c',3.333,3),(459,7481983,7481979,'0c2',3.333,3),(459,7481984,7481979,'c29',3.333,3),(459,7481985,7481979,'29e',3.333,3),(459,7481986,7481979,'9e6',3.333,3),(459,7481987,7481979,'e6c',3.333,3),(459,7481988,7481979,'6c8',3.333,3),(459,7481989,7481979,'c82',3.333,3),(459,7481990,7481979,'826',3.333,3),(459,7481991,7481979,'266',3.333,3),(459,7481992,7481979,'66f',3.333,3),(459,7481993,7481979,'6f8',3.333,3),(459,7481994,7481979,'f8f',3.333,3),(459,7481995,7481979,'8ff',3.333,3),(459,7481996,7481979,'ff0',3.333,3),(459,7481997,7481979,'f0e',3.333,3),(459,7481998,7481979,'0e9',3.333,3),(459,7481999,7481979,'e9d',3.333,3),(459,7482000,7481979,'9dd',3.333,3),(459,7482001,7481979,'ddc',3.333,3),(459,7482002,7481979,'dc2',3.333,3),(459,7482003,7481979,'c23',3.333,3),(459,7482004,7481979,'236',3.333,3),(459,7482005,7481979,'367',3.333,3),(459,7482006,7481979,'67c',3.333,3),(459,7482007,7481979,'7c5',3.333,3),(459,7482008,7481979,'c59',3.333,3),(459,7482009,7481979,'593',3.333,3),(459,7482010,7481980,'mon',100,1),(459,7482011,7482010,'201',50,1),(459,7482012,7482010,'013',50,1),(459,7482013,7482011,'adm',33.333,3),(459,7482014,7482011,'dmi',33.333,3),(459,7482015,7482011,'min',33.333,3),(459,7482016,7482013,'cap',16.667,1),(459,7482017,7482013,'apa',16.667,1),(459,7482018,7482013,'pac',16.667,1),(459,7482019,7482013,'aci',16.667,1),(459,7482020,7482013,'cit',16.667,1),(459,7482021,7482013,'ity',16.667,1),(459,7482022,7482016,'pat',50,1),(459,7482023,7482016,'ath',50,1),(459,7482024,7482022,'fre',14.286,1),(459,7482025,7482022,'ree',14.286,1),(459,7482026,7482022,'ees',14.286,1),(459,7482027,7482022,'esp',14.286,1),(459,7482028,7482022,'spa',14.286,1),(459,7482029,7482022,'pac',14.286,1),(459,7482030,7482022,'ace',14.286,1),(459,7482031,7482024,'dis',50,1),(459,7482032,7482024,'isk',50,1),(459,7482033,7482031,'ind',33.333,1),(459,7482034,7482031,'nde',33.333,1),(459,7482035,7482031,'dex',33.333,1),(459,7482036,7482033,'adm',8.333,1),(459,7482037,7482033,'dmi',8.333,1),(459,7482038,7482033,'min',8.333,1),(459,7482039,7482033,'ini',8.333,1),(459,7482040,7482033,'nis',8.333,1),(459,7482041,7482033,'ist',8.333,1),(459,7482042,7482033,'str',8.333,1),(459,7482043,7482033,'tra',8.333,1),(459,7482044,7482033,'rat',8.333,1),(459,7482045,7482033,'ati',8.333,1),(459,7482046,7482033,'tio',8.333,1),(459,7482047,7482033,'ion',8.333,1),(459,7482048,7482036,'sta',33.333,3),(459,7482049,7482036,'tat',33.333,3),(459,7482050,7482036,'ate',33.333,3),(459,7482051,7482048,'ena',20,2),(459,7482052,7482048,'nab',20,2),(459,7482053,7482048,'abl',20,2),(459,7482054,7482048,'ble',20,2),(459,7482055,7482048,'led',20,2),(459,7482056,7482051,'cac',33.333,2),(459,7482057,7482051,'ach',33.333,2),(459,7482058,7482051,'che',33.333,2),(459,7482059,7482056,'mod',50,1),(459,7482060,7482056,'ode',50,1),(459,7482061,7482059,'wri',14.286,1),(459,7482062,7482059,'rit',14.286,1),(459,7482063,7482059,'ite',14.286,1),(459,7482064,7482059,'tet',14.286,1),(459,7482065,7482059,'eth',14.286,1),(459,7482066,7482059,'thr',14.286,1),(459,7482067,7482059,'hru',14.286,1),(459,7482068,7482061,'ope',11.111,2),(459,7482069,7482061,'per',11.111,2),(459,7482070,7482061,'era',11.111,2),(459,7482071,7482061,'rat',11.111,2),(459,7482072,7482061,'ati',11.111,2),(459,7482073,7482061,'tio',11.111,2),(459,7482074,7482061,'ion',11.111,2),(459,7482075,7482061,'ona',11.111,2),(459,7482076,7482061,'nal',11.111,2),(459,7482077,7482068,'pen',20,1),(459,7482078,7482068,'end',20,1),(459,7482079,7482068,'ndi',20,1),(459,7482080,7482068,'din',20,1),(459,7482081,7482068,'ing',20,1),(459,7482082,7482077,'mes',20,1),(459,7482083,7482077,'ess',20,1),(459,7482084,7482077,'ssa',20,1),(459,7482085,7482077,'sag',20,1),(459,7482086,7482077,'age',20,1),(459,7482087,7482082,'wai',20,1),(459,7482088,7482082,'ait',20,1),(459,7482089,7482082,'iti',20,1),(459,7482090,7482082,'tin',20,1),(459,7482091,7482082,'ing',20,1),(459,7482092,7482087,'for',100,1),(459,7482093,7482092,'per',11.111,1),(459,7482094,7482092,'erf',11.111,1),(459,7482095,7482092,'rfo',11.111,1),(459,7482096,7482092,'for',11.111,1),(459,7482097,7482092,'orm',11.111,1),(459,7482098,7482092,'rma',11.111,1),(459,7482099,7482092,'man',11.111,1),(459,7482100,7482092,'anc',11.111,1),(459,7482101,7482092,'nce',11.111,1),(459,7482102,7482093,'ide',12.5,1),(459,7482103,7482093,'den',12.5,1),(459,7482104,7482093,'ent',12.5,1),(459,7482105,7482093,'nti',12.5,1),(459,7482106,7482093,'tif',12.5,1),(459,7482107,7482093,'ifi',12.5,1),(459,7482108,7482093,'fie',12.5,1),(459,7482109,7482093,'ier',12.5,1),(459,7482110,7482102,'vdi',33.333,3),(459,7482111,7482102,'dis',33.333,3),(459,7482112,7482102,'isk',33.333,3),(459,7482113,7482110,'nam',50,1),(459,7482114,7482110,'ame',50,1),(459,7482115,7482113,'typ',50,1),(459,7482116,7482113,'ype',50,1),(459,7482117,7482115,'dir',25,1),(459,7482118,7482115,'ire',25,1),(459,7482119,7482115,'rec',25,1),(459,7482120,7482115,'ect',25,1),(460,7482122,7482121,'naa',100,2),(460,7482123,7482122,'600',3.333,3),(460,7482124,7482122,'000',3.333,3),(460,7482125,7482122,'00c',3.333,3),(460,7482126,7482122,'0c2',3.333,3),(460,7482127,7482122,'c29',3.333,3),(460,7482128,7482122,'297',3.333,3),(460,7482129,7482122,'978',3.333,3),(460,7482130,7482122,'780',3.333,3),(460,7482131,7482122,'805',3.333,3),(460,7482132,7482122,'055',3.333,3),(460,7482133,7482122,'558',3.333,3),(460,7482134,7482122,'587',3.333,3),(460,7482135,7482122,'874',3.333,3),(460,7482136,7482122,'74f',3.333,3),(460,7482137,7482122,'4f2',3.333,3),(460,7482138,7482122,'f2d',3.333,3),(460,7482139,7482122,'2dc',3.333,3),(460,7482140,7482122,'dce',3.333,3),(460,7482141,7482122,'ceb',3.333,3),(460,7482142,7482122,'eb2',3.333,3),(460,7482143,7482122,'b27',3.333,3),(460,7482144,7482122,'272',3.333,3),(460,7482145,7482122,'72e',3.333,3),(460,7482146,7482122,'2e9',3.333,3),(460,7482147,7482122,'e9b',3.333,3),(460,7482148,7482122,'9b8',3.333,3),(460,7482149,7482122,'b89',3.333,3),(460,7482150,7482122,'891',3.333,3),(460,7482151,7482122,'910',3.333,3),(460,7482152,7482122,'104',3.333,3),(460,7482153,7482123,'mon',100,1),(460,7482154,7482153,'201',50,1),(460,7482155,7482153,'013',50,1),(460,7482156,7482154,'adm',33.333,3),(460,7482157,7482154,'dmi',33.333,3),(460,7482158,7482154,'min',33.333,3),(460,7482159,7482156,'cap',16.667,1),(460,7482160,7482156,'apa',16.667,1),(460,7482161,7482156,'pac',16.667,1),(460,7482162,7482156,'aci',16.667,1),(460,7482163,7482156,'cit',16.667,1),(460,7482164,7482156,'ity',16.667,1),(460,7482165,7482159,'pat',50,1),(460,7482166,7482159,'ath',50,1),(460,7482167,7482165,'fre',14.286,1),(460,7482168,7482165,'ree',14.286,1),(460,7482169,7482165,'ees',14.286,1),(460,7482170,7482165,'esp',14.286,1),(460,7482171,7482165,'spa',14.286,1),(460,7482172,7482165,'pac',14.286,1),(460,7482173,7482165,'ace',14.286,1),(460,7482174,7482167,'dis',50,1),(460,7482175,7482167,'isk',50,1),(460,7482176,7482174,'ind',33.333,1),(460,7482177,7482174,'nde',33.333,1),(460,7482178,7482174,'dex',33.333,1),(460,7482179,7482176,'adm',8.333,1),(460,7482180,7482176,'dmi',8.333,1),(460,7482181,7482176,'min',8.333,1),(460,7482182,7482176,'ini',8.333,1),(460,7482183,7482176,'nis',8.333,1),(460,7482184,7482176,'ist',8.333,1),(460,7482185,7482176,'str',8.333,1),(460,7482186,7482176,'tra',8.333,1),(460,7482187,7482176,'rat',8.333,1),(460,7482188,7482176,'ati',8.333,1),(460,7482189,7482176,'tio',8.333,1),(460,7482190,7482176,'ion',8.333,1),(460,7482191,7482179,'sta',33.333,3),(460,7482192,7482179,'tat',33.333,3),(460,7482193,7482179,'ate',33.333,3),(460,7482194,7482191,'ena',20,2),(460,7482195,7482191,'nab',20,2),(460,7482196,7482191,'abl',20,2),(460,7482197,7482191,'ble',20,2),(460,7482198,7482191,'led',20,2),(460,7482199,7482194,'cac',33.333,2),(460,7482200,7482194,'ach',33.333,2),(460,7482201,7482194,'che',33.333,2),(460,7482202,7482199,'mod',50,1),(460,7482203,7482199,'ode',50,1),(460,7482204,7482202,'wri',14.286,1),(460,7482205,7482202,'rit',14.286,1),(460,7482206,7482202,'ite',14.286,1),(460,7482207,7482202,'tet',14.286,1),(460,7482208,7482202,'eth',14.286,1),(460,7482209,7482202,'thr',14.286,1),(460,7482210,7482202,'hru',14.286,1),(460,7482211,7482204,'ope',11.111,2),(460,7482212,7482204,'per',11.111,2),(460,7482213,7482204,'era',11.111,2),(460,7482214,7482204,'rat',11.111,2),(460,7482215,7482204,'ati',11.111,2),(460,7482216,7482204,'tio',11.111,2),(460,7482217,7482204,'ion',11.111,2),(460,7482218,7482204,'ona',11.111,2),(460,7482219,7482204,'nal',11.111,2),(460,7482220,7482211,'pen',20,1),(460,7482221,7482211,'end',20,1),(460,7482222,7482211,'ndi',20,1),(460,7482223,7482211,'din',20,1),(460,7482224,7482211,'ing',20,1),(460,7482225,7482220,'mes',20,1),(460,7482226,7482220,'ess',20,1),(460,7482227,7482220,'ssa',20,1),(460,7482228,7482220,'sag',20,1),(460,7482229,7482220,'age',20,1),(460,7482230,7482225,'wai',20,1),(460,7482231,7482225,'ait',20,1),(460,7482232,7482225,'iti',20,1),(460,7482233,7482225,'tin',20,1),(460,7482234,7482225,'ing',20,1),(460,7482235,7482230,'for',100,1),(460,7482236,7482235,'per',11.111,1),(460,7482237,7482235,'erf',11.111,1),(460,7482238,7482235,'rfo',11.111,1),(460,7482239,7482235,'for',11.111,1),(460,7482240,7482235,'orm',11.111,1),(460,7482241,7482235,'rma',11.111,1),(460,7482242,7482235,'man',11.111,1),(460,7482243,7482235,'anc',11.111,1),(460,7482244,7482235,'nce',11.111,1),(460,7482245,7482236,'ide',12.5,1),(460,7482246,7482236,'den',12.5,1),(460,7482247,7482236,'ent',12.5,1),(460,7482248,7482236,'nti',12.5,1),(460,7482249,7482236,'tif',12.5,1),(460,7482250,7482236,'ifi',12.5,1),(460,7482251,7482236,'fie',12.5,1),(460,7482252,7482236,'ier',12.5,1),(460,7482253,7482245,'vdi',33.333,3),(460,7482254,7482245,'dis',33.333,3),(460,7482255,7482245,'isk',33.333,3),(460,7482256,7482253,'nam',50,1),(460,7482257,7482253,'ame',50,1),(460,7482258,7482256,'typ',50,1),(460,7482259,7482256,'ype',50,1),(460,7482260,7482258,'dir',25,1),(460,7482261,7482258,'ire',25,1),(460,7482262,7482258,'rec',25,1),(460,7482263,7482258,'ect',25,1),(461,7482265,7482264,'naa',100,2),(461,7482266,7482265,'600',3.333,3),(461,7482267,7482265,'000',3.333,3),(461,7482268,7482265,'00c',3.333,3),(461,7482269,7482265,'0c2',3.333,3),(461,7482270,7482265,'c29',3.333,3),(461,7482271,7482265,'297',3.333,3),(461,7482272,7482265,'97e',3.333,3),(461,7482273,7482265,'7ed',3.333,3),(461,7482274,7482265,'ed5',3.333,3),(461,7482275,7482265,'d59',3.333,3),(461,7482276,7482265,'59d',3.333,3),(461,7482277,7482265,'9db',3.333,3),(461,7482278,7482265,'dbc',3.333,3),(461,7482279,7482265,'bc3',3.333,3),(461,7482280,7482265,'c39',3.333,3),(461,7482281,7482265,'39a',3.333,3),(461,7482282,7482265,'9a6',3.333,3),(461,7482283,7482265,'a6b',3.333,3),(461,7482284,7482265,'6bb',3.333,3),(461,7482285,7482265,'bbb',3.333,3),(461,7482286,7482265,'bb8',3.333,3),(461,7482287,7482265,'b80',3.333,3),(461,7482288,7482265,'805',3.333,3),(461,7482289,7482265,'05c',3.333,3),(461,7482290,7482265,'5c2',3.333,3),(461,7482291,7482265,'c2f',3.333,3),(461,7482292,7482265,'2fb',3.333,3),(461,7482293,7482265,'fb8',3.333,3),(461,7482294,7482265,'b80',3.333,3),(461,7482295,7482265,'800',3.333,3),(461,7482296,7482266,'mon',100,1),(461,7482297,7482296,'201',50,1),(461,7482298,7482296,'013',50,1),(461,7482299,7482297,'adm',33.333,3),(461,7482300,7482297,'dmi',33.333,3),(461,7482301,7482297,'min',33.333,3),(461,7482302,7482299,'cap',16.667,1),(461,7482303,7482299,'apa',16.667,1),(461,7482304,7482299,'pac',16.667,1),(461,7482305,7482299,'aci',16.667,1),(461,7482306,7482299,'cit',16.667,1),(461,7482307,7482299,'ity',16.667,1),(461,7482308,7482302,'pat',50,1),(461,7482309,7482302,'ath',50,1),(461,7482310,7482308,'fre',14.286,1),(461,7482311,7482308,'ree',14.286,1),(461,7482312,7482308,'ees',14.286,1),(461,7482313,7482308,'esp',14.286,1),(461,7482314,7482308,'spa',14.286,1),(461,7482315,7482308,'pac',14.286,1),(461,7482316,7482308,'ace',14.286,1),(461,7482317,7482310,'dis',50,1),(461,7482318,7482310,'isk',50,1),(461,7482319,7482317,'ind',33.333,1),(461,7482320,7482317,'nde',33.333,1),(461,7482321,7482317,'dex',33.333,1),(461,7482322,7482319,'adm',8.333,1),(461,7482323,7482319,'dmi',8.333,1),(461,7482324,7482319,'min',8.333,1),(461,7482325,7482319,'ini',8.333,1),(461,7482326,7482319,'nis',8.333,1),(461,7482327,7482319,'ist',8.333,1),(461,7482328,7482319,'str',8.333,1),(461,7482329,7482319,'tra',8.333,1),(461,7482330,7482319,'rat',8.333,1),(461,7482331,7482319,'ati',8.333,1),(461,7482332,7482319,'tio',8.333,1),(461,7482333,7482319,'ion',8.333,1),(461,7482334,7482322,'sta',33.333,3),(461,7482335,7482322,'tat',33.333,3),(461,7482336,7482322,'ate',33.333,3),(461,7482337,7482334,'ena',20,2),(461,7482338,7482334,'nab',20,2),(461,7482339,7482334,'abl',20,2),(461,7482340,7482334,'ble',20,2),(461,7482341,7482334,'led',20,2),(461,7482342,7482337,'cac',33.333,2),(461,7482343,7482337,'ach',33.333,2),(461,7482344,7482337,'che',33.333,2),(461,7482345,7482342,'mod',50,1),(461,7482346,7482342,'ode',50,1),(461,7482347,7482345,'wri',14.286,1),(461,7482348,7482345,'rit',14.286,1),(461,7482349,7482345,'ite',14.286,1),(461,7482350,7482345,'tet',14.286,1),(461,7482351,7482345,'eth',14.286,1),(461,7482352,7482345,'thr',14.286,1),(461,7482353,7482345,'hru',14.286,1),(461,7482354,7482347,'ope',11.111,2),(461,7482355,7482347,'per',11.111,2),(461,7482356,7482347,'era',11.111,2),(461,7482357,7482347,'rat',11.111,2),(461,7482358,7482347,'ati',11.111,2),(461,7482359,7482347,'tio',11.111,2),(461,7482360,7482347,'ion',11.111,2),(461,7482361,7482347,'ona',11.111,2),(461,7482362,7482347,'nal',11.111,2),(461,7482363,7482354,'pen',20,1),(461,7482364,7482354,'end',20,1),(461,7482365,7482354,'ndi',20,1),(461,7482366,7482354,'din',20,1),(461,7482367,7482354,'ing',20,1),(461,7482368,7482363,'mes',20,1),(461,7482369,7482363,'ess',20,1),(461,7482370,7482363,'ssa',20,1),(461,7482371,7482363,'sag',20,1),(461,7482372,7482363,'age',20,1),(461,7482373,7482368,'wai',20,1),(461,7482374,7482368,'ait',20,1),(461,7482375,7482368,'iti',20,1),(461,7482376,7482368,'tin',20,1),(461,7482377,7482368,'ing',20,1),(461,7482378,7482373,'for',100,1),(461,7482379,7482378,'per',11.111,1),(461,7482380,7482378,'erf',11.111,1),(461,7482381,7482378,'rfo',11.111,1),(461,7482382,7482378,'for',11.111,1),(461,7482383,7482378,'orm',11.111,1),(461,7482384,7482378,'rma',11.111,1),(461,7482385,7482378,'man',11.111,1),(461,7482386,7482378,'anc',11.111,1),(461,7482387,7482378,'nce',11.111,1),(461,7482388,7482379,'ide',12.5,1),(461,7482389,7482379,'den',12.5,1),(461,7482390,7482379,'ent',12.5,1),(461,7482391,7482379,'nti',12.5,1),(461,7482392,7482379,'tif',12.5,1),(461,7482393,7482379,'ifi',12.5,1),(461,7482394,7482379,'fie',12.5,1),(461,7482395,7482379,'ier',12.5,1),(461,7482396,7482388,'vdi',33.333,3),(461,7482397,7482388,'dis',33.333,3),(461,7482398,7482388,'isk',33.333,3),(461,7482399,7482396,'nam',50,1),(461,7482400,7482396,'ame',50,1),(461,7482401,7482399,'typ',50,1),(461,7482402,7482399,'ype',50,1),(461,7482403,7482401,'dir',25,1),(461,7482404,7482401,'ire',25,1),(461,7482405,7482401,'rec',25,1),(461,7482406,7482401,'ect',25,1),(462,7482408,7482407,'naa',100,2),(462,7482409,7482408,'600',3.333,3),(462,7482410,7482408,'000',3.333,3),(462,7482411,7482408,'00c',3.333,3),(462,7482412,7482408,'0c2',3.333,3),(462,7482413,7482408,'c29',3.333,3),(462,7482414,7482408,'293',3.333,3),(462,7482415,7482408,'939',3.333,3),(462,7482416,7482408,'39e',3.333,3),(462,7482417,7482408,'9ea',3.333,3),(462,7482418,7482408,'eab',3.333,3),(462,7482419,7482408,'abe',3.333,3),(462,7482420,7482408,'be4',3.333,3),(462,7482421,7482408,'e43',3.333,3),(462,7482422,7482408,'43e',3.333,3),(462,7482423,7482408,'3ec',3.333,3),(462,7482424,7482408,'ec0',3.333,3),(462,7482425,7482408,'c04',3.333,3),(462,7482426,7482408,'040',3.333,3),(462,7482427,7482408,'406',3.333,3),(462,7482428,7482408,'06d',3.333,3),(462,7482429,7482408,'6da',3.333,3),(462,7482430,7482408,'da8',3.333,3),(462,7482431,7482408,'a8c',3.333,3),(462,7482432,7482408,'8cf',3.333,3),(462,7482433,7482408,'cf7',3.333,3),(462,7482434,7482408,'f74',3.333,3),(462,7482435,7482408,'74e',3.333,3),(462,7482436,7482408,'4e5',3.333,3),(462,7482437,7482408,'e5f',3.333,3),(462,7482438,7482408,'5fd',3.333,3),(462,7482439,7482409,'mon',100,1),(462,7482440,7482439,'201',50,1),(462,7482441,7482439,'013',50,1),(462,7482442,7482440,'adm',33.333,3),(462,7482443,7482440,'dmi',33.333,3),(462,7482444,7482440,'min',33.333,3),(462,7482445,7482442,'cap',16.667,1),(462,7482446,7482442,'apa',16.667,1),(462,7482447,7482442,'pac',16.667,1),(462,7482448,7482442,'aci',16.667,1),(462,7482449,7482442,'cit',16.667,1),(462,7482450,7482442,'ity',16.667,1),(462,7482451,7482445,'pat',50,1),(462,7482452,7482445,'ath',50,1),(462,7482453,7482451,'fre',14.286,1),(462,7482454,7482451,'ree',14.286,1),(462,7482455,7482451,'ees',14.286,1),(462,7482456,7482451,'esp',14.286,1),(462,7482457,7482451,'spa',14.286,1),(462,7482458,7482451,'pac',14.286,1),(462,7482459,7482451,'ace',14.286,1),(462,7482460,7482453,'dis',50,1),(462,7482461,7482453,'isk',50,1),(462,7482462,7482460,'ind',33.333,1),(462,7482463,7482460,'nde',33.333,1),(462,7482464,7482460,'dex',33.333,1),(462,7482465,7482462,'adm',8.333,1),(462,7482466,7482462,'dmi',8.333,1),(462,7482467,7482462,'min',8.333,1),(462,7482468,7482462,'ini',8.333,1),(462,7482469,7482462,'nis',8.333,1),(462,7482470,7482462,'ist',8.333,1),(462,7482471,7482462,'str',8.333,1),(462,7482472,7482462,'tra',8.333,1),(462,7482473,7482462,'rat',8.333,1),(462,7482474,7482462,'ati',8.333,1),(462,7482475,7482462,'tio',8.333,1),(462,7482476,7482462,'ion',8.333,1),(462,7482477,7482465,'sta',33.333,3),(462,7482478,7482465,'tat',33.333,3),(462,7482479,7482465,'ate',33.333,3),(462,7482480,7482477,'ena',20,2),(462,7482481,7482477,'nab',20,2),(462,7482482,7482477,'abl',20,2),(462,7482483,7482477,'ble',20,2),(462,7482484,7482477,'led',20,2),(462,7482485,7482480,'cac',33.333,2),(462,7482486,7482480,'ach',33.333,2),(462,7482487,7482480,'che',33.333,2),(462,7482488,7482485,'mod',50,1),(462,7482489,7482485,'ode',50,1),(462,7482490,7482488,'wri',14.286,1),(462,7482491,7482488,'rit',14.286,1),(462,7482492,7482488,'ite',14.286,1),(462,7482493,7482488,'tet',14.286,1),(462,7482494,7482488,'eth',14.286,1),(462,7482495,7482488,'thr',14.286,1),(462,7482496,7482488,'hru',14.286,1),(462,7482497,7482490,'ope',11.111,2),(462,7482498,7482490,'per',11.111,2),(462,7482499,7482490,'era',11.111,2),(462,7482500,7482490,'rat',11.111,2),(462,7482501,7482490,'ati',11.111,2),(462,7482502,7482490,'tio',11.111,2),(462,7482503,7482490,'ion',11.111,2),(462,7482504,7482490,'ona',11.111,2),(462,7482505,7482490,'nal',11.111,2),(462,7482506,7482497,'pen',20,1),(462,7482507,7482497,'end',20,1),(462,7482508,7482497,'ndi',20,1),(462,7482509,7482497,'din',20,1),(462,7482510,7482497,'ing',20,1),(462,7482511,7482506,'mes',20,1),(462,7482512,7482506,'ess',20,1),(462,7482513,7482506,'ssa',20,1),(462,7482514,7482506,'sag',20,1),(462,7482515,7482506,'age',20,1),(462,7482516,7482511,'wai',20,1),(462,7482517,7482511,'ait',20,1),(462,7482518,7482511,'iti',20,1),(462,7482519,7482511,'tin',20,1),(462,7482520,7482511,'ing',20,1),(462,7482521,7482516,'for',100,1),(462,7482522,7482521,'per',11.111,1),(462,7482523,7482521,'erf',11.111,1),(462,7482524,7482521,'rfo',11.111,1),(462,7482525,7482521,'for',11.111,1),(462,7482526,7482521,'orm',11.111,1),(462,7482527,7482521,'rma',11.111,1),(462,7482528,7482521,'man',11.111,1),(462,7482529,7482521,'anc',11.111,1),(462,7482530,7482521,'nce',11.111,1),(462,7482531,7482522,'ide',12.5,1),(462,7482532,7482522,'den',12.5,1),(462,7482533,7482522,'ent',12.5,1),(462,7482534,7482522,'nti',12.5,1),(462,7482535,7482522,'tif',12.5,1),(462,7482536,7482522,'ifi',12.5,1),(462,7482537,7482522,'fie',12.5,1),(462,7482538,7482522,'ier',12.5,1),(462,7482539,7482531,'vdi',33.333,3),(462,7482540,7482531,'dis',33.333,3),(462,7482541,7482531,'isk',33.333,3),(462,7482542,7482539,'nam',50,1),(462,7482543,7482539,'ame',50,1),(462,7482544,7482542,'typ',50,1),(462,7482545,7482542,'ype',50,1),(462,7482546,7482544,'dir',25,1),(462,7482547,7482544,'ire',25,1),(462,7482548,7482544,'rec',25,1),(462,7482549,7482544,'ect',25,1),(403,7482741,7482740,'att',12.5,1),(403,7482742,7482740,'ttr',12.5,1),(403,7482743,7482740,'tri',12.5,1),(403,7482744,7482740,'rib',12.5,1),(403,7482745,7482740,'ibu',12.5,1),(403,7482746,7482740,'but',12.5,1),(403,7482747,7482740,'ute',12.5,1),(403,7482748,7482740,'tes',12.5,1),(403,7482749,7482741,'ref',20,3),(403,7482750,7482741,'efr',20,3),(403,7482751,7482741,'fre',20,3),(403,7482752,7482741,'res',20,3),(403,7482753,7482741,'esh',20,3),(403,7482754,7482749,'hos',50,2),(403,7482755,7482749,'ost',50,2),(403,7482756,7482754,'nam',50,2),(403,7482757,7482754,'ame',50,2),(403,7482758,7482756,'hg3',9.091,1),(403,7482759,7482756,'g32',9.091,1),(403,7482760,7482756,'32v',9.091,1),(403,7482761,7482756,'2vm',9.091,1),(403,7482762,7482756,'vm5',9.091,1),(403,7482763,7482756,'m5w',9.091,1),(403,7482764,7482756,'5w2',9.091,1),(403,7482765,7482756,'w2k',9.091,1),(403,7482766,7482756,'2k8',9.091,1),(403,7482767,7482756,'k8r',9.091,1),(403,7482768,7482756,'8r2',9.091,1),(403,7482769,7482758,'gdl',100,1),(403,7482770,7482769,'eng',25,1),(403,7482771,7482769,'ngl',25,1),(403,7482772,7482769,'gla',25,1),(403,7482773,7482769,'lab',25,1),(403,7482774,7482770,'net',25,1),(403,7482775,7482770,'eta',25,1),(403,7482776,7482770,'tap',25,1),(403,7482777,7482770,'app',25,1),(403,7482778,7482774,'com',100,1),(403,7482779,7482778,'mem',25,3),(403,7482780,7482778,'emo',25,3),(403,7482781,7482778,'mor',25,3),(403,7482782,7482778,'ory',25,3),(403,7482783,7482779,'siz',50,2),(403,7482784,7482779,'ize',50,2),(403,7482785,7482783,'614',50,1),(403,7482786,7482783,'144',50,1),(403,7482787,7482785,'cpu',100,1),(403,7482788,7482787,'usa',33.333,3),(403,7482789,7482787,'sag',33.333,3),(403,7482790,7482787,'age',33.333,3),(403,7482791,7482788,'mhz',100,1),(403,7482792,7482791,'add',20,1),(403,7482793,7482791,'ddr',20,1),(403,7482794,7482791,'dre',20,1),(403,7482795,7482791,'res',20,1),(403,7482796,7482791,'ess',20,1),(403,7482797,7482792,'226',100,1),(403,7482798,7482797,'147',100,1),(403,7482799,7482798,'207',100,1),(403,7482800,7482799,'383',50,1),(403,7482801,7482799,'832',50,1),(403,7482802,7482800,'gue',33.333,2),(403,7482803,7482800,'ues',33.333,2),(403,7482804,7482800,'est',33.333,2),(403,7482805,7482802,'vmw',25,2),(403,7482806,7482802,'mwa',25,2),(403,7482807,7482802,'war',25,2),(403,7482808,7482802,'are',25,2),(403,7482809,7482805,'too',33.333,2),(403,7482810,7482805,'ool',33.333,2),(403,7482811,7482805,'ols',33.333,2),(403,7482812,7482809,'run',20,1),(403,7482813,7482809,'unn',20,1),(403,7482814,7482809,'nni',20,1),(403,7482815,7482809,'nin',20,1),(403,7482816,7482809,'ing',20,1),(403,7482817,7482812,'and',100,1),(403,7482818,7482817,'the',100,1),(403,7482819,7482818,'ver',20,2),(403,7482820,7482818,'ers',20,2),(403,7482821,7482818,'rsi',20,2),(403,7482822,7482818,'sio',20,2),(403,7482823,7482818,'ion',20,2),(403,7482824,7482819,'cur',20,1),(403,7482825,7482819,'urr',20,1),(403,7482826,7482819,'rre',20,1),(403,7482827,7482819,'ren',20,1),(403,7482828,7482819,'ent',20,1),(403,7482829,7482824,'mic',14.286,1),(403,7482830,7482824,'icr',14.286,1),(403,7482831,7482824,'cro',14.286,1),(403,7482832,7482824,'ros',14.286,1),(403,7482833,7482824,'oso',14.286,1),(403,7482834,7482824,'sof',14.286,1),(403,7482835,7482824,'oft',14.286,1),(403,7482836,7482829,'win',20,1),(403,7482837,7482829,'ind',20,1),(403,7482838,7482829,'ndo',20,1),(403,7482839,7482829,'dow',20,1),(403,7482840,7482829,'ows',20,1),(403,7482841,7482836,'ser',25,1),(403,7482842,7482836,'erv',25,1),(403,7482843,7482836,'rve',25,1),(403,7482844,7482836,'ver',25,1),(403,7482845,7482841,'200',50,1),(403,7482846,7482841,'008',50,1),(403,7482847,7482845,'64b',33.333,1),(403,7482848,7482845,'4bi',33.333,1),(403,7482849,7482845,'bit',33.333,1),(403,7482850,7482847,'pat',50,1),(403,7482851,7482847,'ath',50,1),(403,7482852,7482850,'rx6',33.333,1),(403,7482853,7482850,'x60',33.333,1),(403,7482854,7482850,'600',33.333,1),(403,7482855,7482852,'vmf',20,1),(403,7482856,7482852,'mfi',20,1),(403,7482857,7482852,'fil',20,1),(403,7482858,7482852,'ile',20,1),(403,7482859,7482852,'les',20,1),(403,7482860,7482855,'hgw',9.091,2),(403,7482861,7482855,'gw2',9.091,2),(403,7482862,7482855,'w2k',9.091,2),(403,7482863,7482855,'2k8',9.091,2),(403,7482864,7482855,'k8r',9.091,2),(403,7482865,7482855,'8r2',9.091,2),(403,7482866,7482855,'r23',9.091,2),(403,7482867,7482855,'232',9.091,2),(403,7482868,7482855,'32v',9.091,2),(403,7482869,7482855,'2vm',9.091,2),(403,7482870,7482855,'vm5',9.091,2),(403,7482871,7482860,'vmx',100,1),(403,7482872,7482871,'fla',33.333,1),(403,7482873,7482871,'las',33.333,1),(403,7482874,7482871,'ash',33.333,1),(403,7482875,7482872,'acc',33.333,1),(403,7482876,7482872,'cce',33.333,1),(403,7482877,7482872,'cel',33.333,1),(403,7482878,7482875,'con',9.091,1),(403,7482879,7482875,'onf',9.091,1),(403,7482880,7482875,'nfi',9.091,1),(403,7482881,7482875,'fig',9.091,1),(403,7482882,7482875,'igu',9.091,1),(403,7482883,7482875,'gur',9.091,1),(403,7482884,7482875,'ura',9.091,1),(403,7482885,7482875,'rat',9.091,1),(403,7482886,7482875,'ati',9.091,1),(403,7482887,7482875,'tio',9.091,1),(403,7482888,7482875,'ion',9.091,1),(403,7482889,7482878,'age',33.333,1),(403,7482890,7482878,'gen',33.333,1),(403,7482891,7482878,'ent',33.333,1),(403,7482892,7482889,'193',16.667,1),(403,7482893,7482889,'932',16.667,1),(403,7482894,7482889,'320',16.667,1),(403,7482895,7482889,'204',16.667,1),(403,7482896,7482889,'044',16.667,1),(403,7482897,7482889,'449',16.667,1),(403,7482898,7482892,'cac',33.333,3),(403,7482899,7482892,'ach',33.333,3),(403,7482900,7482892,'che',33.333,3),(403,7482901,7482898,'sta',33.333,2),(403,7482902,7482898,'tat',33.333,2),(403,7482903,7482898,'ate',33.333,2),(403,7482904,7482901,'dis',16.667,3),(403,7482905,7482901,'isa',16.667,3),(403,7482906,7482901,'sab',16.667,3),(403,7482907,7482901,'abl',16.667,3),(403,7482908,7482901,'ble',16.667,3),(403,7482909,7482901,'led',16.667,3),(403,7482910,7482904,'ope',11.111,2),(403,7482911,7482904,'per',11.111,2),(403,7482912,7482904,'era',11.111,2),(403,7482913,7482904,'rat',11.111,2),(403,7482914,7482904,'ati',11.111,2),(403,7482915,7482904,'tio',11.111,2),(403,7482916,7482904,'ion',11.111,2),(403,7482917,7482904,'ona',11.111,2),(403,7482918,7482904,'nal',11.111,2),(403,7482919,7482910,'mod',50,1),(403,7482920,7482910,'ode',50,1),(403,7482921,7482919,'wri',14.286,1),(403,7482922,7482919,'rit',14.286,1),(403,7482923,7482919,'ite',14.286,1),(403,7482924,7482919,'tet',14.286,1),(403,7482925,7482919,'eth',14.286,1),(403,7482926,7482919,'thr',14.286,1),(403,7482927,7482919,'hru',14.286,1),(403,7482928,7482921,'mes',20,1),(403,7482929,7482921,'ess',20,1),(403,7482930,7482921,'ssa',20,1),(403,7482931,7482921,'sag',20,1),(403,7482932,7482921,'age',20,1),(403,7482933,7482928,'adm',33.333,1),(403,7482934,7482928,'dmi',33.333,1),(403,7482935,7482928,'min',33.333,1),(403,7482936,7482933,'met',20,3),(403,7482937,7482933,'etr',20,3),(403,7482938,7482933,'tri',20,3),(403,7482939,7482933,'ric',20,3),(403,7482940,7482933,'ics',20,3),(403,7482941,7482936,'ena',20,1),(403,7482942,7482936,'nab',20,1),(403,7482943,7482936,'abl',20,1),(403,7482944,7482936,'ble',20,1),(403,7482945,7482936,'led',20,1),(403,7482946,7482941,'vir',20,1),(403,7482947,7482941,'irt',20,1),(403,7482948,7482941,'rtu',20,1),(403,7482949,7482941,'tua',20,1),(403,7482950,7482941,'ual',20,1),(403,7482951,7482946,'dis',50,1),(403,7482952,7482946,'isk',50,1),(464,7482954,7482953,'naa',100,2),(464,7482955,7482954,'600',3.333,3),(464,7482956,7482954,'000',3.333,3),(464,7482957,7482954,'00c',3.333,3),(464,7482958,7482954,'0c2',3.333,3),(464,7482959,7482954,'c29',3.333,3),(464,7482960,7482954,'290',3.333,3),(464,7482961,7482954,'905',3.333,3),(464,7482962,7482954,'050',3.333,3),(464,7482963,7482954,'50a',3.333,3),(464,7482964,7482954,'0aa',3.333,3),(464,7482965,7482954,'aa8',3.333,3),(464,7482966,7482954,'a8b',3.333,3),(464,7482967,7482954,'8bf',3.333,3),(464,7482968,7482954,'bf9',3.333,3),(464,7482969,7482954,'f9c',3.333,3),(464,7482970,7482954,'9c1',3.333,3),(464,7482971,7482954,'c16',3.333,3),(464,7482972,7482954,'160',3.333,3),(464,7482973,7482954,'605',3.333,3),(464,7482974,7482954,'05e',3.333,3),(464,7482975,7482954,'5e8',3.333,3),(464,7482976,7482954,'e83',3.333,3),(464,7482977,7482954,'834',3.333,3),(464,7482978,7482954,'349',3.333,3),(464,7482979,7482954,'49c',3.333,3),(464,7482980,7482954,'9c1',3.333,3),(464,7482981,7482954,'c1a',3.333,3),(464,7482982,7482954,'1a1',3.333,3),(464,7482983,7482954,'a18',3.333,3),(464,7482984,7482954,'183',3.333,3),(464,7482985,7482955,'mon',100,1),(464,7482986,7482985,'201',50,1),(464,7482987,7482985,'013',50,1),(464,7482988,7482986,'adm',33.333,3),(464,7482989,7482986,'dmi',33.333,3),(464,7482990,7482986,'min',33.333,3),(464,7482991,7482988,'cap',16.667,1),(464,7482992,7482988,'apa',16.667,1),(464,7482993,7482988,'pac',16.667,1),(464,7482994,7482988,'aci',16.667,1),(464,7482995,7482988,'cit',16.667,1),(464,7482996,7482988,'ity',16.667,1),(464,7482997,7482991,'pat',50,1),(464,7482998,7482991,'ath',50,1),(464,7482999,7482997,'fre',14.286,1),(464,7483000,7482997,'ree',14.286,1),(464,7483001,7482997,'ees',14.286,1),(464,7483002,7482997,'esp',14.286,1),(464,7483003,7482997,'spa',14.286,1),(464,7483004,7482997,'pac',14.286,1),(464,7483005,7482997,'ace',14.286,1),(464,7483006,7482999,'dis',50,1),(464,7483007,7482999,'isk',50,1),(464,7483008,7483006,'ind',33.333,1),(464,7483009,7483006,'nde',33.333,1),(464,7483010,7483006,'dex',33.333,1),(464,7483011,7483008,'adm',8.333,1),(464,7483012,7483008,'dmi',8.333,1),(464,7483013,7483008,'min',8.333,1),(464,7483014,7483008,'ini',8.333,1),(464,7483015,7483008,'nis',8.333,1),(464,7483016,7483008,'ist',8.333,1),(464,7483017,7483008,'str',8.333,1),(464,7483018,7483008,'tra',8.333,1),(464,7483019,7483008,'rat',8.333,1),(464,7483020,7483008,'ati',8.333,1),(464,7483021,7483008,'tio',8.333,1),(464,7483022,7483008,'ion',8.333,1),(464,7483023,7483011,'sta',33.333,3),(464,7483024,7483011,'tat',33.333,3),(464,7483025,7483011,'ate',33.333,3),(464,7483026,7483023,'ena',20,2),(464,7483027,7483023,'nab',20,2),(464,7483028,7483023,'abl',20,2),(464,7483029,7483023,'ble',20,2),(464,7483030,7483023,'led',20,2),(464,7483031,7483026,'cac',33.333,2),(464,7483032,7483026,'ach',33.333,2),(464,7483033,7483026,'che',33.333,2),(464,7483034,7483031,'mod',50,1),(464,7483035,7483031,'ode',50,1),(464,7483036,7483034,'wri',14.286,1),(464,7483037,7483034,'rit',14.286,1),(464,7483038,7483034,'ite',14.286,1),(464,7483039,7483034,'tet',14.286,1),(464,7483040,7483034,'eth',14.286,1),(464,7483041,7483034,'thr',14.286,1),(464,7483042,7483034,'hru',14.286,1),(464,7483043,7483036,'ope',11.111,2),(464,7483044,7483036,'per',11.111,2),(464,7483045,7483036,'era',11.111,2),(464,7483046,7483036,'rat',11.111,2),(464,7483047,7483036,'ati',11.111,2),(464,7483048,7483036,'tio',11.111,2),(464,7483049,7483036,'ion',11.111,2),(464,7483050,7483036,'ona',11.111,2),(464,7483051,7483036,'nal',11.111,2),(464,7483052,7483043,'pen',20,1),(464,7483053,7483043,'end',20,1),(464,7483054,7483043,'ndi',20,1),(464,7483055,7483043,'din',20,1),(464,7483056,7483043,'ing',20,1),(464,7483057,7483052,'mes',20,1),(464,7483058,7483052,'ess',20,1),(464,7483059,7483052,'ssa',20,1),(464,7483060,7483052,'sag',20,1),(464,7483061,7483052,'age',20,1),(464,7483062,7483057,'wai',20,1),(464,7483063,7483057,'ait',20,1),(464,7483064,7483057,'iti',20,1),(464,7483065,7483057,'tin',20,1),(464,7483066,7483057,'ing',20,1),(464,7483067,7483062,'for',100,1),(464,7483068,7483067,'per',11.111,1),(464,7483069,7483067,'erf',11.111,1),(464,7483070,7483067,'rfo',11.111,1),(464,7483071,7483067,'for',11.111,1),(464,7483072,7483067,'orm',11.111,1),(464,7483073,7483067,'rma',11.111,1),(464,7483074,7483067,'man',11.111,1),(464,7483075,7483067,'anc',11.111,1),(464,7483076,7483067,'nce',11.111,1),(464,7483077,7483068,'ide',12.5,1),(464,7483078,7483068,'den',12.5,1),(464,7483079,7483068,'ent',12.5,1),(464,7483080,7483068,'nti',12.5,1),(464,7483081,7483068,'tif',12.5,1),(464,7483082,7483068,'ifi',12.5,1),(464,7483083,7483068,'fie',12.5,1),(464,7483084,7483068,'ier',12.5,1),(464,7483085,7483077,'vdi',33.333,3),(464,7483086,7483077,'dis',33.333,3),(464,7483087,7483077,'isk',33.333,3),(464,7483088,7483085,'nam',50,1),(464,7483089,7483085,'ame',50,1),(464,7483090,7483088,'typ',50,1),(464,7483091,7483088,'ype',50,1),(464,7483092,7483090,'dir',25,1),(464,7483093,7483090,'ire',25,1),(464,7483094,7483090,'rec',25,1),(464,7483095,7483090,'ect',25,1),(465,7483097,7483096,'naa',100,2),(465,7483098,7483097,'600',3.333,3),(465,7483099,7483097,'00a',3.333,3),(465,7483100,7483097,'0a0',3.333,3),(465,7483101,7483097,'a09',3.333,3),(465,7483102,7483097,'098',3.333,3),(465,7483103,7483097,'980',3.333,3),(465,7483104,7483097,'804',3.333,3),(465,7483105,7483097,'044',3.333,3),(465,7483106,7483097,'443',3.333,3),(465,7483107,7483097,'430',3.333,3),(465,7483108,7483097,'307',3.333,3),(465,7483109,7483097,'072',3.333,3),(465,7483110,7483097,'725',3.333,3),(465,7483111,7483097,'259',3.333,3),(465,7483112,7483097,'593',3.333,3),(465,7483113,7483097,'931',3.333,3),(465,7483114,7483097,'313',3.333,3),(465,7483115,7483097,'13f',3.333,3),(465,7483116,7483097,'3f3',3.333,3),(465,7483117,7483097,'f33',3.333,3),(465,7483118,7483097,'334',3.333,3),(465,7483119,7483097,'345',3.333,3),(465,7483120,7483097,'455',3.333,3),(465,7483121,7483097,'556',3.333,3),(465,7483122,7483097,'563',3.333,3),(465,7483123,7483097,'639',3.333,3),(465,7483124,7483097,'393',3.333,3),(465,7483125,7483097,'934',3.333,3),(465,7483126,7483097,'344',3.333,3),(465,7483127,7483097,'445',3.333,3),(465,7483128,7483098,'mon',100,1),(465,7483129,7483128,'201',50,1),(465,7483130,7483128,'013',50,1),(465,7483131,7483129,'adm',33.333,3),(465,7483132,7483129,'dmi',33.333,3),(465,7483133,7483129,'min',33.333,3),(465,7483134,7483131,'cap',16.667,1),(465,7483135,7483131,'apa',16.667,1),(465,7483136,7483131,'pac',16.667,1),(465,7483137,7483131,'aci',16.667,1),(465,7483138,7483131,'cit',16.667,1),(465,7483139,7483131,'ity',16.667,1),(465,7483140,7483134,'pat',50,1),(465,7483141,7483134,'ath',50,1),(465,7483142,7483140,'fre',14.286,1),(465,7483143,7483140,'ree',14.286,1),(465,7483144,7483140,'ees',14.286,1),(465,7483145,7483140,'esp',14.286,1),(465,7483146,7483140,'spa',14.286,1),(465,7483147,7483140,'pac',14.286,1),(465,7483148,7483140,'ace',14.286,1),(465,7483149,7483142,'dis',50,1),(465,7483150,7483142,'isk',50,1),(465,7483151,7483149,'ind',33.333,1),(465,7483152,7483149,'nde',33.333,1),(465,7483153,7483149,'dex',33.333,1),(465,7483154,7483151,'adm',8.333,1),(465,7483155,7483151,'dmi',8.333,1),(465,7483156,7483151,'min',8.333,1),(465,7483157,7483151,'ini',8.333,1),(465,7483158,7483151,'nis',8.333,1),(465,7483159,7483151,'ist',8.333,1),(465,7483160,7483151,'str',8.333,1),(465,7483161,7483151,'tra',8.333,1),(465,7483162,7483151,'rat',8.333,1),(465,7483163,7483151,'ati',8.333,1),(465,7483164,7483151,'tio',8.333,1),(465,7483165,7483151,'ion',8.333,1),(465,7483166,7483154,'sta',33.333,3),(465,7483167,7483154,'tat',33.333,3),(465,7483168,7483154,'ate',33.333,3),(465,7483169,7483166,'ena',20,2),(465,7483170,7483166,'nab',20,2),(465,7483171,7483166,'abl',20,2),(465,7483172,7483166,'ble',20,2),(465,7483173,7483166,'led',20,2),(465,7483174,7483169,'cac',33.333,2),(465,7483175,7483169,'ach',33.333,2),(465,7483176,7483169,'che',33.333,2),(465,7483177,7483174,'mod',50,1),(465,7483178,7483174,'ode',50,1),(465,7483179,7483177,'wri',14.286,1),(465,7483180,7483177,'rit',14.286,1),(465,7483181,7483177,'ite',14.286,1),(465,7483182,7483177,'tet',14.286,1),(465,7483183,7483177,'eth',14.286,1),(465,7483184,7483177,'thr',14.286,1),(465,7483185,7483177,'hru',14.286,1),(465,7483186,7483179,'ope',11.111,2),(465,7483187,7483179,'per',11.111,2),(465,7483188,7483179,'era',11.111,2),(465,7483189,7483179,'rat',11.111,2),(465,7483190,7483179,'ati',11.111,2),(465,7483191,7483179,'tio',11.111,2),(465,7483192,7483179,'ion',11.111,2),(465,7483193,7483179,'ona',11.111,2),(465,7483194,7483179,'nal',11.111,2),(465,7483195,7483186,'pen',20,1),(465,7483196,7483186,'end',20,1),(465,7483197,7483186,'ndi',20,1),(465,7483198,7483186,'din',20,1),(465,7483199,7483186,'ing',20,1),(465,7483200,7483195,'mes',20,1),(465,7483201,7483195,'ess',20,1),(465,7483202,7483195,'ssa',20,1),(465,7483203,7483195,'sag',20,1),(465,7483204,7483195,'age',20,1),(465,7483205,7483200,'wai',20,1),(465,7483206,7483200,'ait',20,1),(465,7483207,7483200,'iti',20,1),(465,7483208,7483200,'tin',20,1),(465,7483209,7483200,'ing',20,1),(465,7483210,7483205,'for',100,1),(465,7483211,7483210,'per',11.111,1),(465,7483212,7483210,'erf',11.111,1),(465,7483213,7483210,'rfo',11.111,1),(465,7483214,7483210,'for',11.111,1),(465,7483215,7483210,'orm',11.111,1),(465,7483216,7483210,'rma',11.111,1),(465,7483217,7483210,'man',11.111,1),(465,7483218,7483210,'anc',11.111,1),(465,7483219,7483210,'nce',11.111,1),(465,7483220,7483211,'ide',12.5,1),(465,7483221,7483211,'den',12.5,1),(465,7483222,7483211,'ent',12.5,1),(465,7483223,7483211,'nti',12.5,1),(465,7483224,7483211,'tif',12.5,1),(465,7483225,7483211,'ifi',12.5,1),(465,7483226,7483211,'fie',12.5,1),(465,7483227,7483211,'ier',12.5,1),(465,7483228,7483220,'vdi',33.333,3),(465,7483229,7483220,'dis',33.333,3),(465,7483230,7483220,'isk',33.333,3),(465,7483231,7483228,'nam',50,1),(465,7483232,7483228,'ame',50,1),(465,7483233,7483231,'typ',50,1),(465,7483234,7483231,'ype',50,1),(465,7483235,7483233,'dir',25,1),(465,7483236,7483233,'ire',25,1),(465,7483237,7483233,'rec',25,1),(465,7483238,7483233,'ect',25,1),(466,7483240,7483239,'naa',100,2),(466,7483241,7483240,'600',3.333,3),(466,7483242,7483240,'00a',3.333,3),(466,7483243,7483240,'0a0',3.333,3),(466,7483244,7483240,'a09',3.333,3),(466,7483245,7483240,'098',3.333,3),(466,7483246,7483240,'980',3.333,3),(466,7483247,7483240,'804',3.333,3),(466,7483248,7483240,'044',3.333,3),(466,7483249,7483240,'443',3.333,3),(466,7483250,7483240,'430',3.333,3),(466,7483251,7483240,'307',3.333,3),(466,7483252,7483240,'072',3.333,3),(466,7483253,7483240,'725',3.333,3),(466,7483254,7483240,'259',3.333,3),(466,7483255,7483240,'593',3.333,3),(466,7483256,7483240,'931',3.333,3),(466,7483257,7483240,'313',3.333,3),(466,7483258,7483240,'13f',3.333,3),(466,7483259,7483240,'3f3',3.333,3),(466,7483260,7483240,'f33',3.333,3),(466,7483261,7483240,'334',3.333,3),(466,7483262,7483240,'345',3.333,3),(466,7483263,7483240,'455',3.333,3),(466,7483264,7483240,'556',3.333,3),(466,7483265,7483240,'563',3.333,3),(466,7483266,7483240,'639',3.333,3),(466,7483267,7483240,'393',3.333,3),(466,7483268,7483240,'934',3.333,3),(466,7483269,7483240,'344',3.333,3),(466,7483270,7483240,'446',3.333,3),(466,7483271,7483241,'mon',100,1),(466,7483272,7483271,'201',50,1),(466,7483273,7483271,'013',50,1),(466,7483274,7483272,'adm',33.333,3),(466,7483275,7483272,'dmi',33.333,3),(466,7483276,7483272,'min',33.333,3),(466,7483277,7483274,'cap',16.667,1),(466,7483278,7483274,'apa',16.667,1),(466,7483279,7483274,'pac',16.667,1),(466,7483280,7483274,'aci',16.667,1),(466,7483281,7483274,'cit',16.667,1),(466,7483282,7483274,'ity',16.667,1),(466,7483283,7483277,'pat',50,1),(466,7483284,7483277,'ath',50,1),(466,7483285,7483283,'fre',14.286,1),(466,7483286,7483283,'ree',14.286,1),(466,7483287,7483283,'ees',14.286,1),(466,7483288,7483283,'esp',14.286,1),(466,7483289,7483283,'spa',14.286,1),(466,7483290,7483283,'pac',14.286,1),(466,7483291,7483283,'ace',14.286,1),(466,7483292,7483285,'dis',50,1),(466,7483293,7483285,'isk',50,1),(466,7483294,7483292,'ind',33.333,1),(466,7483295,7483292,'nde',33.333,1),(466,7483296,7483292,'dex',33.333,1),(466,7483297,7483294,'adm',8.333,1),(466,7483298,7483294,'dmi',8.333,1),(466,7483299,7483294,'min',8.333,1),(466,7483300,7483294,'ini',8.333,1),(466,7483301,7483294,'nis',8.333,1),(466,7483302,7483294,'ist',8.333,1),(466,7483303,7483294,'str',8.333,1),(466,7483304,7483294,'tra',8.333,1),(466,7483305,7483294,'rat',8.333,1),(466,7483306,7483294,'ati',8.333,1),(466,7483307,7483294,'tio',8.333,1),(466,7483308,7483294,'ion',8.333,1),(466,7483309,7483297,'sta',33.333,3),(466,7483310,7483297,'tat',33.333,3),(466,7483311,7483297,'ate',33.333,3),(466,7483312,7483309,'ena',20,2),(466,7483313,7483309,'nab',20,2),(466,7483314,7483309,'abl',20,2),(466,7483315,7483309,'ble',20,2),(466,7483316,7483309,'led',20,2),(466,7483317,7483312,'cac',33.333,2),(466,7483318,7483312,'ach',33.333,2),(466,7483319,7483312,'che',33.333,2),(466,7483320,7483317,'mod',50,1),(466,7483321,7483317,'ode',50,1),(466,7483322,7483320,'wri',14.286,1),(466,7483323,7483320,'rit',14.286,1),(466,7483324,7483320,'ite',14.286,1),(466,7483325,7483320,'tet',14.286,1),(466,7483326,7483320,'eth',14.286,1),(466,7483327,7483320,'thr',14.286,1),(466,7483328,7483320,'hru',14.286,1),(466,7483329,7483322,'ope',11.111,2),(466,7483330,7483322,'per',11.111,2),(466,7483331,7483322,'era',11.111,2),(466,7483332,7483322,'rat',11.111,2),(466,7483333,7483322,'ati',11.111,2),(466,7483334,7483322,'tio',11.111,2),(466,7483335,7483322,'ion',11.111,2),(466,7483336,7483322,'ona',11.111,2),(466,7483337,7483322,'nal',11.111,2),(466,7483338,7483329,'pen',20,1),(466,7483339,7483329,'end',20,1),(466,7483340,7483329,'ndi',20,1),(466,7483341,7483329,'din',20,1),(466,7483342,7483329,'ing',20,1),(466,7483343,7483338,'mes',20,1),(466,7483344,7483338,'ess',20,1),(466,7483345,7483338,'ssa',20,1),(466,7483346,7483338,'sag',20,1),(466,7483347,7483338,'age',20,1),(466,7483348,7483343,'wai',20,1),(466,7483349,7483343,'ait',20,1),(466,7483350,7483343,'iti',20,1),(466,7483351,7483343,'tin',20,1),(466,7483352,7483343,'ing',20,1),(466,7483353,7483348,'for',100,1),(466,7483354,7483353,'per',11.111,1),(466,7483355,7483353,'erf',11.111,1),(466,7483356,7483353,'rfo',11.111,1),(466,7483357,7483353,'for',11.111,1),(466,7483358,7483353,'orm',11.111,1),(466,7483359,7483353,'rma',11.111,1),(466,7483360,7483353,'man',11.111,1),(466,7483361,7483353,'anc',11.111,1),(466,7483362,7483353,'nce',11.111,1),(466,7483363,7483354,'ide',12.5,1),(466,7483364,7483354,'den',12.5,1),(466,7483365,7483354,'ent',12.5,1),(466,7483366,7483354,'nti',12.5,1),(466,7483367,7483354,'tif',12.5,1),(466,7483368,7483354,'ifi',12.5,1),(466,7483369,7483354,'fie',12.5,1),(466,7483370,7483354,'ier',12.5,1),(466,7483371,7483363,'vdi',33.333,3),(466,7483372,7483363,'dis',33.333,3),(466,7483373,7483363,'isk',33.333,3),(466,7483374,7483371,'nam',50,1),(466,7483375,7483371,'ame',50,1),(466,7483376,7483374,'typ',50,1),(466,7483377,7483374,'ype',50,1),(466,7483378,7483376,'dir',25,1),(466,7483379,7483376,'ire',25,1),(466,7483380,7483376,'rec',25,1),(466,7483381,7483376,'ect',25,1),(467,7483383,7483382,'naa',100,2),(467,7483384,7483383,'600',3.333,3),(467,7483385,7483383,'00a',3.333,3),(467,7483386,7483383,'0a0',3.333,3),(467,7483387,7483383,'a09',3.333,3),(467,7483388,7483383,'098',3.333,3),(467,7483389,7483383,'980',3.333,3),(467,7483390,7483383,'804',3.333,3),(467,7483391,7483383,'044',3.333,3),(467,7483392,7483383,'443',3.333,3),(467,7483393,7483383,'430',3.333,3),(467,7483394,7483383,'307',3.333,3),(467,7483395,7483383,'075',3.333,3),(467,7483396,7483383,'753',3.333,3),(467,7483397,7483383,'535',3.333,3),(467,7483398,7483383,'357',3.333,3),(467,7483399,7483383,'573',3.333,3),(467,7483400,7483383,'732',3.333,3),(467,7483401,7483383,'32b',3.333,3),(467,7483402,7483383,'2b3',3.333,3),(467,7483403,7483383,'b33',3.333,3),(467,7483404,7483383,'334',3.333,3),(467,7483405,7483383,'345',3.333,3),(467,7483406,7483383,'457',3.333,3),(467,7483407,7483383,'571',3.333,3),(467,7483408,7483383,'715',3.333,3),(467,7483409,7483383,'153',3.333,3),(467,7483410,7483383,'533',3.333,3),(467,7483411,7483383,'336',3.333,3),(467,7483412,7483383,'363',3.333,3),(467,7483413,7483383,'630',3.333,3),(467,7483414,7483384,'mon',100,1),(467,7483415,7483414,'201',50,1),(467,7483416,7483414,'013',50,1),(467,7483417,7483415,'adm',33.333,3),(467,7483418,7483415,'dmi',33.333,3),(467,7483419,7483415,'min',33.333,3),(467,7483420,7483417,'cap',16.667,1),(467,7483421,7483417,'apa',16.667,1),(467,7483422,7483417,'pac',16.667,1),(467,7483423,7483417,'aci',16.667,1),(467,7483424,7483417,'cit',16.667,1),(467,7483425,7483417,'ity',16.667,1),(467,7483426,7483420,'pat',50,1),(467,7483427,7483420,'ath',50,1),(467,7483428,7483426,'fre',14.286,1),(467,7483429,7483426,'ree',14.286,1),(467,7483430,7483426,'ees',14.286,1),(467,7483431,7483426,'esp',14.286,1),(467,7483432,7483426,'spa',14.286,1),(467,7483433,7483426,'pac',14.286,1),(467,7483434,7483426,'ace',14.286,1),(467,7483435,7483428,'dis',50,1),(467,7483436,7483428,'isk',50,1),(467,7483437,7483435,'ind',33.333,1),(467,7483438,7483435,'nde',33.333,1),(467,7483439,7483435,'dex',33.333,1),(467,7483440,7483437,'adm',8.333,1),(467,7483441,7483437,'dmi',8.333,1),(467,7483442,7483437,'min',8.333,1),(467,7483443,7483437,'ini',8.333,1),(467,7483444,7483437,'nis',8.333,1),(467,7483445,7483437,'ist',8.333,1),(467,7483446,7483437,'str',8.333,1),(467,7483447,7483437,'tra',8.333,1),(467,7483448,7483437,'rat',8.333,1),(467,7483449,7483437,'ati',8.333,1),(467,7483450,7483437,'tio',8.333,1),(467,7483451,7483437,'ion',8.333,1),(467,7483452,7483440,'sta',33.333,3),(467,7483453,7483440,'tat',33.333,3),(467,7483454,7483440,'ate',33.333,3),(467,7483455,7483452,'ena',20,2),(467,7483456,7483452,'nab',20,2),(467,7483457,7483452,'abl',20,2),(467,7483458,7483452,'ble',20,2),(467,7483459,7483452,'led',20,2),(467,7483460,7483455,'cac',33.333,2),(467,7483461,7483455,'ach',33.333,2),(467,7483462,7483455,'che',33.333,2),(467,7483463,7483460,'mod',50,1),(467,7483464,7483460,'ode',50,1),(467,7483465,7483463,'wri',14.286,1),(467,7483466,7483463,'rit',14.286,1),(467,7483467,7483463,'ite',14.286,1),(467,7483468,7483463,'tet',14.286,1),(467,7483469,7483463,'eth',14.286,1),(467,7483470,7483463,'thr',14.286,1),(467,7483471,7483463,'hru',14.286,1),(467,7483472,7483465,'ope',11.111,2),(467,7483473,7483465,'per',11.111,2),(467,7483474,7483465,'era',11.111,2),(467,7483475,7483465,'rat',11.111,2),(467,7483476,7483465,'ati',11.111,2),(467,7483477,7483465,'tio',11.111,2),(467,7483478,7483465,'ion',11.111,2),(467,7483479,7483465,'ona',11.111,2),(467,7483480,7483465,'nal',11.111,2),(467,7483481,7483472,'pen',20,1),(467,7483482,7483472,'end',20,1),(467,7483483,7483472,'ndi',20,1),(467,7483484,7483472,'din',20,1),(467,7483485,7483472,'ing',20,1),(467,7483486,7483481,'mes',20,1),(467,7483487,7483481,'ess',20,1),(467,7483488,7483481,'ssa',20,1),(467,7483489,7483481,'sag',20,1),(467,7483490,7483481,'age',20,1),(467,7483491,7483486,'wai',20,1),(467,7483492,7483486,'ait',20,1),(467,7483493,7483486,'iti',20,1),(467,7483494,7483486,'tin',20,1),(467,7483495,7483486,'ing',20,1),(467,7483496,7483491,'for',100,1),(467,7483497,7483496,'per',11.111,1),(467,7483498,7483496,'erf',11.111,1),(467,7483499,7483496,'rfo',11.111,1),(467,7483500,7483496,'for',11.111,1),(467,7483501,7483496,'orm',11.111,1),(467,7483502,7483496,'rma',11.111,1),(467,7483503,7483496,'man',11.111,1),(467,7483504,7483496,'anc',11.111,1),(467,7483505,7483496,'nce',11.111,1),(467,7483506,7483497,'ide',12.5,1),(467,7483507,7483497,'den',12.5,1),(467,7483508,7483497,'ent',12.5,1),(467,7483509,7483497,'nti',12.5,1),(467,7483510,7483497,'tif',12.5,1),(467,7483511,7483497,'ifi',12.5,1),(467,7483512,7483497,'fie',12.5,1),(467,7483513,7483497,'ier',12.5,1),(467,7483514,7483506,'vdi',33.333,3),(467,7483515,7483506,'dis',33.333,3),(467,7483516,7483506,'isk',33.333,3),(467,7483517,7483514,'nam',50,1),(467,7483518,7483514,'ame',50,1),(467,7483519,7483517,'typ',50,1),(467,7483520,7483517,'ype',50,1),(467,7483521,7483519,'dir',25,1),(467,7483522,7483519,'ire',25,1),(467,7483523,7483519,'rec',25,1),(467,7483524,7483519,'ect',25,1),(468,7483526,7483525,'naa',100,2),(468,7483527,7483526,'600',3.333,3),(468,7483528,7483526,'00a',3.333,3),(468,7483529,7483526,'0a0',3.333,3),(468,7483530,7483526,'a09',3.333,3),(468,7483531,7483526,'098',3.333,3),(468,7483532,7483526,'980',3.333,3),(468,7483533,7483526,'804',3.333,3),(468,7483534,7483526,'044',3.333,3),(468,7483535,7483526,'443',3.333,3),(468,7483536,7483526,'430',3.333,3),(468,7483537,7483526,'307',3.333,3),(468,7483538,7483526,'075',3.333,3),(468,7483539,7483526,'753',3.333,3),(468,7483540,7483526,'535',3.333,3),(468,7483541,7483526,'357',3.333,3),(468,7483542,7483526,'573',3.333,3),(468,7483543,7483526,'732',3.333,3),(468,7483544,7483526,'32b',3.333,3),(468,7483545,7483526,'2b3',3.333,3),(468,7483546,7483526,'b33',3.333,3),(468,7483547,7483526,'334',3.333,3),(468,7483548,7483526,'345',3.333,3),(468,7483549,7483526,'457',3.333,3),(468,7483550,7483526,'571',3.333,3),(468,7483551,7483526,'715',3.333,3),(468,7483552,7483526,'153',3.333,3),(468,7483553,7483526,'533',3.333,3),(468,7483554,7483526,'336',3.333,3),(468,7483555,7483526,'363',3.333,3),(468,7483556,7483526,'631',3.333,3),(468,7483557,7483527,'mon',100,1),(468,7483558,7483557,'201',50,1),(468,7483559,7483557,'013',50,1),(468,7483560,7483558,'adm',33.333,3),(468,7483561,7483558,'dmi',33.333,3),(468,7483562,7483558,'min',33.333,3),(468,7483563,7483560,'cap',16.667,1),(468,7483564,7483560,'apa',16.667,1),(468,7483565,7483560,'pac',16.667,1),(468,7483566,7483560,'aci',16.667,1),(468,7483567,7483560,'cit',16.667,1),(468,7483568,7483560,'ity',16.667,1),(468,7483569,7483563,'pat',50,1),(468,7483570,7483563,'ath',50,1),(468,7483571,7483569,'fre',14.286,1),(468,7483572,7483569,'ree',14.286,1),(468,7483573,7483569,'ees',14.286,1),(468,7483574,7483569,'esp',14.286,1),(468,7483575,7483569,'spa',14.286,1),(468,7483576,7483569,'pac',14.286,1),(468,7483577,7483569,'ace',14.286,1),(468,7483578,7483571,'dis',50,1),(468,7483579,7483571,'isk',50,1),(468,7483580,7483578,'ind',33.333,1),(468,7483581,7483578,'nde',33.333,1),(468,7483582,7483578,'dex',33.333,1),(468,7483583,7483580,'adm',8.333,1),(468,7483584,7483580,'dmi',8.333,1),(468,7483585,7483580,'min',8.333,1),(468,7483586,7483580,'ini',8.333,1),(468,7483587,7483580,'nis',8.333,1),(468,7483588,7483580,'ist',8.333,1),(468,7483589,7483580,'str',8.333,1),(468,7483590,7483580,'tra',8.333,1),(468,7483591,7483580,'rat',8.333,1),(468,7483592,7483580,'ati',8.333,1),(468,7483593,7483580,'tio',8.333,1),(468,7483594,7483580,'ion',8.333,1),(468,7483595,7483583,'sta',33.333,3),(468,7483596,7483583,'tat',33.333,3),(468,7483597,7483583,'ate',33.333,3),(468,7483598,7483595,'ena',20,2),(468,7483599,7483595,'nab',20,2),(468,7483600,7483595,'abl',20,2),(468,7483601,7483595,'ble',20,2),(468,7483602,7483595,'led',20,2),(468,7483603,7483598,'cac',33.333,2),(468,7483604,7483598,'ach',33.333,2),(468,7483605,7483598,'che',33.333,2),(468,7483606,7483603,'mod',50,1),(468,7483607,7483603,'ode',50,1),(468,7483608,7483606,'wri',14.286,1),(468,7483609,7483606,'rit',14.286,1),(468,7483610,7483606,'ite',14.286,1),(468,7483611,7483606,'tet',14.286,1),(468,7483612,7483606,'eth',14.286,1),(468,7483613,7483606,'thr',14.286,1),(468,7483614,7483606,'hru',14.286,1),(468,7483615,7483608,'ope',11.111,2),(468,7483616,7483608,'per',11.111,2),(468,7483617,7483608,'era',11.111,2),(468,7483618,7483608,'rat',11.111,2),(468,7483619,7483608,'ati',11.111,2),(468,7483620,7483608,'tio',11.111,2),(468,7483621,7483608,'ion',11.111,2),(468,7483622,7483608,'ona',11.111,2),(468,7483623,7483608,'nal',11.111,2),(468,7483624,7483615,'pen',20,1),(468,7483625,7483615,'end',20,1),(468,7483626,7483615,'ndi',20,1),(468,7483627,7483615,'din',20,1),(468,7483628,7483615,'ing',20,1),(468,7483629,7483624,'mes',20,1),(468,7483630,7483624,'ess',20,1),(468,7483631,7483624,'ssa',20,1),(468,7483632,7483624,'sag',20,1),(468,7483633,7483624,'age',20,1),(468,7483634,7483629,'wai',20,1),(468,7483635,7483629,'ait',20,1),(468,7483636,7483629,'iti',20,1),(468,7483637,7483629,'tin',20,1),(468,7483638,7483629,'ing',20,1),(468,7483639,7483634,'for',100,1),(468,7483640,7483639,'per',11.111,1),(468,7483641,7483639,'erf',11.111,1),(468,7483642,7483639,'rfo',11.111,1),(468,7483643,7483639,'for',11.111,1),(468,7483644,7483639,'orm',11.111,1),(468,7483645,7483639,'rma',11.111,1),(468,7483646,7483639,'man',11.111,1),(468,7483647,7483639,'anc',11.111,1),(468,7483648,7483639,'nce',11.111,1),(468,7483649,7483640,'ide',12.5,1),(468,7483650,7483640,'den',12.5,1),(468,7483651,7483640,'ent',12.5,1),(468,7483652,7483640,'nti',12.5,1),(468,7483653,7483640,'tif',12.5,1),(468,7483654,7483640,'ifi',12.5,1),(468,7483655,7483640,'fie',12.5,1),(468,7483656,7483640,'ier',12.5,1),(468,7483657,7483649,'vdi',33.333,3),(468,7483658,7483649,'dis',33.333,3),(468,7483659,7483649,'isk',33.333,3),(468,7483660,7483657,'nam',50,1),(468,7483661,7483657,'ame',50,1),(468,7483662,7483660,'typ',50,1),(468,7483663,7483660,'ype',50,1),(468,7483664,7483662,'dir',25,1),(468,7483665,7483662,'ire',25,1),(468,7483666,7483662,'rec',25,1),(468,7483667,7483662,'ect',25,1),(469,7483669,7483668,'naa',100,2),(469,7483670,7483669,'600',3.333,3),(469,7483671,7483669,'000',3.333,3),(469,7483672,7483669,'00c',3.333,3),(469,7483673,7483669,'0c2',3.333,3),(469,7483674,7483669,'c29',3.333,3),(469,7483675,7483669,'29d',3.333,3),(469,7483676,7483669,'9de',3.333,3),(469,7483677,7483669,'de6',3.333,3),(469,7483678,7483669,'e6e',3.333,3),(469,7483679,7483669,'6ea',3.333,3),(469,7483680,7483669,'ead',3.333,3),(469,7483681,7483669,'ad9',3.333,3),(469,7483682,7483669,'d96',3.333,3),(469,7483683,7483669,'965',3.333,3),(469,7483684,7483669,'658',3.333,3),(469,7483685,7483669,'581',3.333,3),(469,7483686,7483669,'81a',3.333,3),(469,7483687,7483669,'1a1',3.333,3),(469,7483688,7483669,'a14',3.333,3),(469,7483689,7483669,'142',3.333,3),(469,7483690,7483669,'429',3.333,3),(469,7483691,7483669,'299',3.333,3),(469,7483692,7483669,'99a',3.333,3),(469,7483693,7483669,'9ae',3.333,3),(469,7483694,7483669,'ae7',3.333,3),(469,7483695,7483669,'e7f',3.333,3),(469,7483696,7483669,'7f1',3.333,3),(469,7483697,7483669,'f1a',3.333,3),(469,7483698,7483669,'1ac',3.333,3),(469,7483699,7483669,'acf',3.333,3),(469,7483700,7483670,'mon',100,1),(469,7483701,7483700,'201',50,1),(469,7483702,7483700,'013',50,1),(469,7483703,7483701,'adm',33.333,3),(469,7483704,7483701,'dmi',33.333,3),(469,7483705,7483701,'min',33.333,3),(469,7483706,7483703,'cap',16.667,1),(469,7483707,7483703,'apa',16.667,1),(469,7483708,7483703,'pac',16.667,1),(469,7483709,7483703,'aci',16.667,1),(469,7483710,7483703,'cit',16.667,1),(469,7483711,7483703,'ity',16.667,1),(469,7483712,7483706,'pat',50,1),(469,7483713,7483706,'ath',50,1),(469,7483714,7483712,'fre',14.286,1),(469,7483715,7483712,'ree',14.286,1),(469,7483716,7483712,'ees',14.286,1),(469,7483717,7483712,'esp',14.286,1),(469,7483718,7483712,'spa',14.286,1),(469,7483719,7483712,'pac',14.286,1),(469,7483720,7483712,'ace',14.286,1),(469,7483721,7483714,'dis',50,1),(469,7483722,7483714,'isk',50,1),(469,7483723,7483721,'ind',33.333,1),(469,7483724,7483721,'nde',33.333,1),(469,7483725,7483721,'dex',33.333,1),(469,7483726,7483723,'adm',8.333,1),(469,7483727,7483723,'dmi',8.333,1),(469,7483728,7483723,'min',8.333,1),(469,7483729,7483723,'ini',8.333,1),(469,7483730,7483723,'nis',8.333,1),(469,7483731,7483723,'ist',8.333,1),(469,7483732,7483723,'str',8.333,1),(469,7483733,7483723,'tra',8.333,1),(469,7483734,7483723,'rat',8.333,1),(469,7483735,7483723,'ati',8.333,1),(469,7483736,7483723,'tio',8.333,1),(469,7483737,7483723,'ion',8.333,1),(469,7483738,7483726,'sta',33.333,3),(469,7483739,7483726,'tat',33.333,3),(469,7483740,7483726,'ate',33.333,3),(469,7483741,7483738,'ena',20,2),(469,7483742,7483738,'nab',20,2),(469,7483743,7483738,'abl',20,2),(469,7483744,7483738,'ble',20,2),(469,7483745,7483738,'led',20,2),(469,7483746,7483741,'cac',33.333,2),(469,7483747,7483741,'ach',33.333,2),(469,7483748,7483741,'che',33.333,2),(469,7483749,7483746,'mod',50,1),(469,7483750,7483746,'ode',50,1),(469,7483751,7483749,'wri',14.286,1),(469,7483752,7483749,'rit',14.286,1),(469,7483753,7483749,'ite',14.286,1),(469,7483754,7483749,'tet',14.286,1),(469,7483755,7483749,'eth',14.286,1),(469,7483756,7483749,'thr',14.286,1),(469,7483757,7483749,'hru',14.286,1),(469,7483758,7483751,'ope',11.111,2),(469,7483759,7483751,'per',11.111,2),(469,7483760,7483751,'era',11.111,2),(469,7483761,7483751,'rat',11.111,2),(469,7483762,7483751,'ati',11.111,2),(469,7483763,7483751,'tio',11.111,2),(469,7483764,7483751,'ion',11.111,2),(469,7483765,7483751,'ona',11.111,2),(469,7483766,7483751,'nal',11.111,2),(469,7483767,7483758,'pen',20,1),(469,7483768,7483758,'end',20,1),(469,7483769,7483758,'ndi',20,1),(469,7483770,7483758,'din',20,1),(469,7483771,7483758,'ing',20,1),(469,7483772,7483767,'mes',20,1),(469,7483773,7483767,'ess',20,1),(469,7483774,7483767,'ssa',20,1),(469,7483775,7483767,'sag',20,1),(469,7483776,7483767,'age',20,1),(469,7483777,7483772,'wai',20,1),(469,7483778,7483772,'ait',20,1),(469,7483779,7483772,'iti',20,1),(469,7483780,7483772,'tin',20,1),(469,7483781,7483772,'ing',20,1),(469,7483782,7483777,'for',100,1),(469,7483783,7483782,'per',11.111,1),(469,7483784,7483782,'erf',11.111,1),(469,7483785,7483782,'rfo',11.111,1),(469,7483786,7483782,'for',11.111,1),(469,7483787,7483782,'orm',11.111,1),(469,7483788,7483782,'rma',11.111,1),(469,7483789,7483782,'man',11.111,1),(469,7483790,7483782,'anc',11.111,1),(469,7483791,7483782,'nce',11.111,1),(469,7483792,7483783,'ide',12.5,1),(469,7483793,7483783,'den',12.5,1),(469,7483794,7483783,'ent',12.5,1),(469,7483795,7483783,'nti',12.5,1),(469,7483796,7483783,'tif',12.5,1),(469,7483797,7483783,'ifi',12.5,1),(469,7483798,7483783,'fie',12.5,1),(469,7483799,7483783,'ier',12.5,1),(469,7483800,7483792,'vdi',33.333,3),(469,7483801,7483792,'dis',33.333,3),(469,7483802,7483792,'isk',33.333,3),(469,7483803,7483800,'nam',50,1),(469,7483804,7483800,'ame',50,1),(469,7483805,7483803,'typ',50,1),(469,7483806,7483803,'ype',50,1),(469,7483807,7483805,'dir',25,1),(469,7483808,7483805,'ire',25,1),(469,7483809,7483805,'rec',25,1),(469,7483810,7483805,'ect',25,1),(470,7483812,7483811,'naa',100,2),(470,7483813,7483812,'600',3.333,3),(470,7483814,7483812,'000',3.333,3),(470,7483815,7483812,'00c',3.333,3),(470,7483816,7483812,'0c2',3.333,3),(470,7483817,7483812,'c29',3.333,3),(470,7483818,7483812,'294',3.333,3),(470,7483819,7483812,'945',3.333,3),(470,7483820,7483812,'45e',3.333,3),(470,7483821,7483812,'5e8',3.333,3),(470,7483822,7483812,'e8e',3.333,3),(470,7483823,7483812,'8e9',3.333,3),(470,7483824,7483812,'e98',3.333,3),(470,7483825,7483812,'988',3.333,3),(470,7483826,7483812,'884',3.333,3),(470,7483827,7483812,'84e',3.333,3),(470,7483828,7483812,'4e0',3.333,3),(470,7483829,7483812,'e0f',3.333,3),(470,7483830,7483812,'0ff',3.333,3),(470,7483831,7483812,'ff5',3.333,3),(470,7483832,7483812,'f5f',3.333,3),(470,7483833,7483812,'5f1',3.333,3),(470,7483834,7483812,'f1a',3.333,3),(470,7483835,7483812,'1ae',3.333,3),(470,7483836,7483812,'aed',3.333,3),(470,7483837,7483812,'ed5',3.333,3),(470,7483838,7483812,'d59',3.333,3),(470,7483839,7483812,'59e',3.333,3),(470,7483840,7483812,'9e8',3.333,3),(470,7483841,7483812,'e8a',3.333,3),(470,7483842,7483812,'8a8',3.333,3),(470,7483843,7483813,'mon',100,1),(470,7483844,7483843,'201',50,1),(470,7483845,7483843,'013',50,1),(470,7483846,7483844,'adm',33.333,3),(470,7483847,7483844,'dmi',33.333,3),(470,7483848,7483844,'min',33.333,3),(470,7483849,7483846,'cap',16.667,1),(470,7483850,7483846,'apa',16.667,1),(470,7483851,7483846,'pac',16.667,1),(470,7483852,7483846,'aci',16.667,1),(470,7483853,7483846,'cit',16.667,1),(470,7483854,7483846,'ity',16.667,1),(470,7483855,7483849,'pat',50,1),(470,7483856,7483849,'ath',50,1),(470,7483857,7483855,'fre',14.286,1),(470,7483858,7483855,'ree',14.286,1),(470,7483859,7483855,'ees',14.286,1),(470,7483860,7483855,'esp',14.286,1),(470,7483861,7483855,'spa',14.286,1),(470,7483862,7483855,'pac',14.286,1),(470,7483863,7483855,'ace',14.286,1),(470,7483864,7483857,'dis',50,1),(470,7483865,7483857,'isk',50,1),(470,7483866,7483864,'ind',33.333,1),(470,7483867,7483864,'nde',33.333,1),(470,7483868,7483864,'dex',33.333,1),(470,7483869,7483866,'adm',8.333,1),(470,7483870,7483866,'dmi',8.333,1),(470,7483871,7483866,'min',8.333,1),(470,7483872,7483866,'ini',8.333,1),(470,7483873,7483866,'nis',8.333,1),(470,7483874,7483866,'ist',8.333,1),(470,7483875,7483866,'str',8.333,1),(470,7483876,7483866,'tra',8.333,1),(470,7483877,7483866,'rat',8.333,1),(470,7483878,7483866,'ati',8.333,1),(470,7483879,7483866,'tio',8.333,1),(470,7483880,7483866,'ion',8.333,1),(470,7483881,7483869,'sta',33.333,3),(470,7483882,7483869,'tat',33.333,3),(470,7483883,7483869,'ate',33.333,3),(470,7483884,7483881,'ena',20,2),(470,7483885,7483881,'nab',20,2),(470,7483886,7483881,'abl',20,2),(470,7483887,7483881,'ble',20,2),(470,7483888,7483881,'led',20,2),(470,7483889,7483884,'cac',33.333,2),(470,7483890,7483884,'ach',33.333,2),(470,7483891,7483884,'che',33.333,2),(470,7483892,7483889,'mod',50,1),(470,7483893,7483889,'ode',50,1),(470,7483894,7483892,'wri',14.286,1),(470,7483895,7483892,'rit',14.286,1),(470,7483896,7483892,'ite',14.286,1),(470,7483897,7483892,'tet',14.286,1),(470,7483898,7483892,'eth',14.286,1),(470,7483899,7483892,'thr',14.286,1),(470,7483900,7483892,'hru',14.286,1),(470,7483901,7483894,'ope',11.111,2),(470,7483902,7483894,'per',11.111,2),(470,7483903,7483894,'era',11.111,2),(470,7483904,7483894,'rat',11.111,2),(470,7483905,7483894,'ati',11.111,2),(470,7483906,7483894,'tio',11.111,2),(470,7483907,7483894,'ion',11.111,2),(470,7483908,7483894,'ona',11.111,2),(470,7483909,7483894,'nal',11.111,2),(470,7483910,7483901,'pen',20,1),(470,7483911,7483901,'end',20,1),(470,7483912,7483901,'ndi',20,1),(470,7483913,7483901,'din',20,1),(470,7483914,7483901,'ing',20,1),(470,7483915,7483910,'mes',20,1),(470,7483916,7483910,'ess',20,1),(470,7483917,7483910,'ssa',20,1),(470,7483918,7483910,'sag',20,1),(470,7483919,7483910,'age',20,1),(470,7483920,7483915,'wai',20,1),(470,7483921,7483915,'ait',20,1),(470,7483922,7483915,'iti',20,1),(470,7483923,7483915,'tin',20,1),(470,7483924,7483915,'ing',20,1),(470,7483925,7483920,'for',100,1),(470,7483926,7483925,'per',11.111,1),(470,7483927,7483925,'erf',11.111,1),(470,7483928,7483925,'rfo',11.111,1),(470,7483929,7483925,'for',11.111,1),(470,7483930,7483925,'orm',11.111,1),(470,7483931,7483925,'rma',11.111,1),(470,7483932,7483925,'man',11.111,1),(470,7483933,7483925,'anc',11.111,1),(470,7483934,7483925,'nce',11.111,1),(470,7483935,7483926,'ide',12.5,1),(470,7483936,7483926,'den',12.5,1),(470,7483937,7483926,'ent',12.5,1),(470,7483938,7483926,'nti',12.5,1),(470,7483939,7483926,'tif',12.5,1),(470,7483940,7483926,'ifi',12.5,1),(470,7483941,7483926,'fie',12.5,1),(470,7483942,7483926,'ier',12.5,1),(470,7483943,7483935,'vdi',33.333,3),(470,7483944,7483935,'dis',33.333,3),(470,7483945,7483935,'isk',33.333,3),(470,7483946,7483943,'nam',50,1),(470,7483947,7483943,'ame',50,1),(470,7483948,7483946,'typ',50,1),(470,7483949,7483946,'ype',50,1),(470,7483950,7483948,'dir',25,1),(470,7483951,7483948,'ire',25,1),(470,7483952,7483948,'rec',25,1),(470,7483953,7483948,'ect',25,1),(471,7483955,7483954,'naa',100,2),(471,7483956,7483955,'600',3.333,3),(471,7483957,7483955,'000',3.333,3),(471,7483958,7483955,'00c',3.333,3),(471,7483959,7483955,'0c2',3.333,3),(471,7483960,7483955,'c29',3.333,3),(471,7483961,7483955,'29b',3.333,3),(471,7483962,7483955,'9b4',3.333,3),(471,7483963,7483955,'b4d',3.333,3),(471,7483964,7483955,'4dc',3.333,3),(471,7483965,7483955,'dcf',3.333,3),(471,7483966,7483955,'cf0',3.333,3),(471,7483967,7483955,'f00',3.333,3),(471,7483968,7483955,'00e',3.333,3),(471,7483969,7483955,'0e0',3.333,3),(471,7483970,7483955,'e00',3.333,3),(471,7483971,7483955,'003',3.333,3),(471,7483972,7483955,'03c',3.333,3),(471,7483973,7483955,'3cb',3.333,3),(471,7483974,7483955,'cba',3.333,3),(471,7483975,7483955,'ba8',3.333,3),(471,7483976,7483955,'a87',3.333,3),(471,7483977,7483955,'875',3.333,3),(471,7483978,7483955,'75c',3.333,3),(471,7483979,7483955,'5cc',3.333,3),(471,7483980,7483955,'cc3',3.333,3),(471,7483981,7483955,'c3e',3.333,3),(471,7483982,7483955,'3e4',3.333,3),(471,7483983,7483955,'e4a',3.333,3),(471,7483984,7483955,'4ac',3.333,3),(471,7483985,7483955,'ac6',3.333,3),(471,7483986,7483956,'mon',100,1),(471,7483987,7483986,'201',50,1),(471,7483988,7483986,'013',50,1),(471,7483989,7483987,'adm',33.333,3),(471,7483990,7483987,'dmi',33.333,3),(471,7483991,7483987,'min',33.333,3),(471,7483992,7483989,'cap',16.667,1),(471,7483993,7483989,'apa',16.667,1),(471,7483994,7483989,'pac',16.667,1),(471,7483995,7483989,'aci',16.667,1),(471,7483996,7483989,'cit',16.667,1),(471,7483997,7483989,'ity',16.667,1),(471,7483998,7483992,'pat',50,1),(471,7483999,7483992,'ath',50,1),(471,7484000,7483998,'fre',14.286,1),(471,7484001,7483998,'ree',14.286,1),(471,7484002,7483998,'ees',14.286,1),(471,7484003,7483998,'esp',14.286,1),(471,7484004,7483998,'spa',14.286,1),(471,7484005,7483998,'pac',14.286,1),(471,7484006,7483998,'ace',14.286,1),(471,7484007,7484000,'dis',50,1),(471,7484008,7484000,'isk',50,1),(471,7484009,7484007,'ind',33.333,1),(471,7484010,7484007,'nde',33.333,1),(471,7484011,7484007,'dex',33.333,1),(471,7484012,7484009,'adm',8.333,1),(471,7484013,7484009,'dmi',8.333,1),(471,7484014,7484009,'min',8.333,1),(471,7484015,7484009,'ini',8.333,1),(471,7484016,7484009,'nis',8.333,1),(471,7484017,7484009,'ist',8.333,1),(471,7484018,7484009,'str',8.333,1),(471,7484019,7484009,'tra',8.333,1),(471,7484020,7484009,'rat',8.333,1),(471,7484021,7484009,'ati',8.333,1),(471,7484022,7484009,'tio',8.333,1),(471,7484023,7484009,'ion',8.333,1),(471,7484024,7484012,'sta',33.333,3),(471,7484025,7484012,'tat',33.333,3),(471,7484026,7484012,'ate',33.333,3),(471,7484027,7484024,'ena',20,2),(471,7484028,7484024,'nab',20,2),(471,7484029,7484024,'abl',20,2),(471,7484030,7484024,'ble',20,2),(471,7484031,7484024,'led',20,2),(471,7484032,7484027,'cac',33.333,2),(471,7484033,7484027,'ach',33.333,2),(471,7484034,7484027,'che',33.333,2),(471,7484035,7484032,'mod',50,1),(471,7484036,7484032,'ode',50,1),(471,7484037,7484035,'wri',14.286,1),(471,7484038,7484035,'rit',14.286,1),(471,7484039,7484035,'ite',14.286,1),(471,7484040,7484035,'tet',14.286,1),(471,7484041,7484035,'eth',14.286,1),(471,7484042,7484035,'thr',14.286,1),(471,7484043,7484035,'hru',14.286,1),(471,7484044,7484037,'ope',11.111,2),(471,7484045,7484037,'per',11.111,2),(471,7484046,7484037,'era',11.111,2),(471,7484047,7484037,'rat',11.111,2),(471,7484048,7484037,'ati',11.111,2),(471,7484049,7484037,'tio',11.111,2),(471,7484050,7484037,'ion',11.111,2),(471,7484051,7484037,'ona',11.111,2),(471,7484052,7484037,'nal',11.111,2),(471,7484053,7484044,'pen',20,1),(471,7484054,7484044,'end',20,1),(471,7484055,7484044,'ndi',20,1),(471,7484056,7484044,'din',20,1),(471,7484057,7484044,'ing',20,1),(471,7484058,7484053,'mes',20,1),(471,7484059,7484053,'ess',20,1),(471,7484060,7484053,'ssa',20,1),(471,7484061,7484053,'sag',20,1),(471,7484062,7484053,'age',20,1),(471,7484063,7484058,'wai',20,1),(471,7484064,7484058,'ait',20,1),(471,7484065,7484058,'iti',20,1),(471,7484066,7484058,'tin',20,1),(471,7484067,7484058,'ing',20,1),(471,7484068,7484063,'for',100,1),(471,7484069,7484068,'per',11.111,1),(471,7484070,7484068,'erf',11.111,1),(471,7484071,7484068,'rfo',11.111,1),(471,7484072,7484068,'for',11.111,1),(471,7484073,7484068,'orm',11.111,1),(471,7484074,7484068,'rma',11.111,1),(471,7484075,7484068,'man',11.111,1),(471,7484076,7484068,'anc',11.111,1),(471,7484077,7484068,'nce',11.111,1),(471,7484078,7484069,'ide',12.5,1),(471,7484079,7484069,'den',12.5,1),(471,7484080,7484069,'ent',12.5,1),(471,7484081,7484069,'nti',12.5,1),(471,7484082,7484069,'tif',12.5,1),(471,7484083,7484069,'ifi',12.5,1),(471,7484084,7484069,'fie',12.5,1),(471,7484085,7484069,'ier',12.5,1),(471,7484086,7484078,'vdi',33.333,3),(471,7484087,7484078,'dis',33.333,3),(471,7484088,7484078,'isk',33.333,3),(471,7484089,7484086,'nam',50,1),(471,7484090,7484086,'ame',50,1),(471,7484091,7484089,'typ',50,1),(471,7484092,7484089,'ype',50,1),(471,7484093,7484091,'dir',25,1),(471,7484094,7484091,'ire',25,1),(471,7484095,7484091,'rec',25,1),(471,7484096,7484091,'ect',25,1),(472,7484098,7484097,'naa',100,2),(472,7484099,7484098,'600',3.333,3),(472,7484100,7484098,'000',3.333,3),(472,7484101,7484098,'00c',3.333,3),(472,7484102,7484098,'0c2',3.333,3),(472,7484103,7484098,'c29',3.333,3),(472,7484104,7484098,'29f',3.333,3),(472,7484105,7484098,'9f0',3.333,3),(472,7484106,7484098,'f06',3.333,3),(472,7484107,7484098,'064',3.333,3),(472,7484108,7484098,'648',3.333,3),(472,7484109,7484098,'482',3.333,3),(472,7484110,7484098,'82d',3.333,3),(472,7484111,7484098,'2dd',3.333,3),(472,7484112,7484098,'dd8',3.333,3),(472,7484113,7484098,'d83',3.333,3),(472,7484114,7484098,'83b',3.333,3),(472,7484115,7484098,'3b3',3.333,3),(472,7484116,7484098,'b3a',3.333,3),(472,7484117,7484098,'3a6',3.333,3),(472,7484118,7484098,'a64',3.333,3),(472,7484119,7484098,'643',3.333,3),(472,7484120,7484098,'43b',3.333,3),(472,7484121,7484098,'3b6',3.333,3),(472,7484122,7484098,'b64',3.333,3),(472,7484123,7484098,'645',3.333,3),(472,7484124,7484098,'451',3.333,3),(472,7484125,7484098,'51a',3.333,3),(472,7484126,7484098,'1af',3.333,3),(472,7484127,7484098,'af2',3.333,3),(472,7484128,7484098,'f27',3.333,3),(472,7484129,7484099,'mon',100,1),(472,7484130,7484129,'201',50,1),(472,7484131,7484129,'013',50,1),(472,7484132,7484130,'adm',33.333,3),(472,7484133,7484130,'dmi',33.333,3),(472,7484134,7484130,'min',33.333,3),(472,7484135,7484132,'cap',16.667,1),(472,7484136,7484132,'apa',16.667,1),(472,7484137,7484132,'pac',16.667,1),(472,7484138,7484132,'aci',16.667,1),(472,7484139,7484132,'cit',16.667,1),(472,7484140,7484132,'ity',16.667,1),(472,7484141,7484135,'pat',50,1),(472,7484142,7484135,'ath',50,1),(472,7484143,7484141,'fre',14.286,1),(472,7484144,7484141,'ree',14.286,1),(472,7484145,7484141,'ees',14.286,1),(472,7484146,7484141,'esp',14.286,1),(472,7484147,7484141,'spa',14.286,1),(472,7484148,7484141,'pac',14.286,1),(472,7484149,7484141,'ace',14.286,1),(472,7484150,7484143,'dis',50,1),(472,7484151,7484143,'isk',50,1),(472,7484152,7484150,'ind',33.333,1),(472,7484153,7484150,'nde',33.333,1),(472,7484154,7484150,'dex',33.333,1),(472,7484155,7484152,'adm',8.333,1),(472,7484156,7484152,'dmi',8.333,1),(472,7484157,7484152,'min',8.333,1),(472,7484158,7484152,'ini',8.333,1),(472,7484159,7484152,'nis',8.333,1),(472,7484160,7484152,'ist',8.333,1),(472,7484161,7484152,'str',8.333,1),(472,7484162,7484152,'tra',8.333,1),(472,7484163,7484152,'rat',8.333,1),(472,7484164,7484152,'ati',8.333,1),(472,7484165,7484152,'tio',8.333,1),(472,7484166,7484152,'ion',8.333,1),(472,7484167,7484155,'sta',33.333,3),(472,7484168,7484155,'tat',33.333,3),(472,7484169,7484155,'ate',33.333,3),(472,7484170,7484167,'ena',20,2),(472,7484171,7484167,'nab',20,2),(472,7484172,7484167,'abl',20,2),(472,7484173,7484167,'ble',20,2),(472,7484174,7484167,'led',20,2),(472,7484175,7484170,'cac',33.333,2),(472,7484176,7484170,'ach',33.333,2),(472,7484177,7484170,'che',33.333,2),(472,7484178,7484175,'mod',50,1),(472,7484179,7484175,'ode',50,1),(472,7484180,7484178,'wri',14.286,1),(472,7484181,7484178,'rit',14.286,1),(472,7484182,7484178,'ite',14.286,1),(472,7484183,7484178,'tet',14.286,1),(472,7484184,7484178,'eth',14.286,1),(472,7484185,7484178,'thr',14.286,1),(472,7484186,7484178,'hru',14.286,1),(472,7484187,7484180,'ope',11.111,2),(472,7484188,7484180,'per',11.111,2),(472,7484189,7484180,'era',11.111,2),(472,7484190,7484180,'rat',11.111,2),(472,7484191,7484180,'ati',11.111,2),(472,7484192,7484180,'tio',11.111,2),(472,7484193,7484180,'ion',11.111,2),(472,7484194,7484180,'ona',11.111,2),(472,7484195,7484180,'nal',11.111,2),(472,7484196,7484187,'pen',20,1),(472,7484197,7484187,'end',20,1),(472,7484198,7484187,'ndi',20,1),(472,7484199,7484187,'din',20,1),(472,7484200,7484187,'ing',20,1),(472,7484201,7484196,'mes',20,1),(472,7484202,7484196,'ess',20,1),(472,7484203,7484196,'ssa',20,1),(472,7484204,7484196,'sag',20,1),(472,7484205,7484196,'age',20,1),(472,7484206,7484201,'wai',20,1),(472,7484207,7484201,'ait',20,1),(472,7484208,7484201,'iti',20,1),(472,7484209,7484201,'tin',20,1),(472,7484210,7484201,'ing',20,1),(472,7484211,7484206,'for',100,1),(472,7484212,7484211,'per',11.111,1),(472,7484213,7484211,'erf',11.111,1),(472,7484214,7484211,'rfo',11.111,1),(472,7484215,7484211,'for',11.111,1),(472,7484216,7484211,'orm',11.111,1),(472,7484217,7484211,'rma',11.111,1),(472,7484218,7484211,'man',11.111,1),(472,7484219,7484211,'anc',11.111,1),(472,7484220,7484211,'nce',11.111,1),(472,7484221,7484212,'ide',12.5,1),(472,7484222,7484212,'den',12.5,1),(472,7484223,7484212,'ent',12.5,1),(472,7484224,7484212,'nti',12.5,1),(472,7484225,7484212,'tif',12.5,1),(472,7484226,7484212,'ifi',12.5,1),(472,7484227,7484212,'fie',12.5,1),(472,7484228,7484212,'ier',12.5,1),(472,7484229,7484221,'vdi',33.333,3),(472,7484230,7484221,'dis',33.333,3),(472,7484231,7484221,'isk',33.333,3),(472,7484232,7484229,'nam',50,1),(472,7484233,7484229,'ame',50,1),(472,7484234,7484232,'typ',50,1),(472,7484235,7484232,'ype',50,1),(472,7484236,7484234,'dir',25,1),(472,7484237,7484234,'ire',25,1),(472,7484238,7484234,'rec',25,1),(472,7484239,7484234,'ect',25,1),(473,7484241,7484240,'naa',100,2),(473,7484242,7484241,'600',3.333,3),(473,7484243,7484241,'000',3.333,3),(473,7484244,7484241,'00c',3.333,3),(473,7484245,7484241,'0c2',3.333,3),(473,7484246,7484241,'c29',3.333,3),(473,7484247,7484241,'29a',3.333,3),(473,7484248,7484241,'9a5',3.333,3),(473,7484249,7484241,'a5c',3.333,3),(473,7484250,7484241,'5c5',3.333,3),(473,7484251,7484241,'c51',3.333,3),(473,7484252,7484241,'519',3.333,3),(473,7484253,7484241,'19d',3.333,3),(473,7484254,7484241,'9d5',3.333,3),(473,7484255,7484241,'d58',3.333,3),(473,7484256,7484241,'58f',3.333,3),(473,7484257,7484241,'8f8',3.333,3),(473,7484258,7484241,'f81',3.333,3),(473,7484259,7484241,'812',3.333,3),(473,7484260,7484241,'121',3.333,3),(473,7484261,7484241,'21f',3.333,3),(473,7484262,7484241,'1fb',3.333,3),(473,7484263,7484241,'fb9',3.333,3),(473,7484264,7484241,'b96',3.333,3),(473,7484265,7484241,'964',3.333,3),(473,7484266,7484241,'64f',3.333,3),(473,7484267,7484241,'4ff',3.333,3),(473,7484268,7484241,'ffe',3.333,3),(473,7484269,7484241,'feb',3.333,3),(473,7484270,7484241,'ebd',3.333,3),(473,7484271,7484241,'bd0',3.333,3),(473,7484272,7484242,'mon',100,1),(473,7484273,7484272,'201',50,1),(473,7484274,7484272,'013',50,1),(473,7484275,7484273,'adm',33.333,3),(473,7484276,7484273,'dmi',33.333,3),(473,7484277,7484273,'min',33.333,3),(473,7484278,7484275,'cap',16.667,1),(473,7484279,7484275,'apa',16.667,1),(473,7484280,7484275,'pac',16.667,1),(473,7484281,7484275,'aci',16.667,1),(473,7484282,7484275,'cit',16.667,1),(473,7484283,7484275,'ity',16.667,1),(473,7484284,7484278,'pat',50,1),(473,7484285,7484278,'ath',50,1),(473,7484286,7484284,'fre',14.286,1),(473,7484287,7484284,'ree',14.286,1),(473,7484288,7484284,'ees',14.286,1),(473,7484289,7484284,'esp',14.286,1),(473,7484290,7484284,'spa',14.286,1),(473,7484291,7484284,'pac',14.286,1),(473,7484292,7484284,'ace',14.286,1),(473,7484293,7484286,'dis',50,1),(473,7484294,7484286,'isk',50,1),(473,7484295,7484293,'ind',33.333,1),(473,7484296,7484293,'nde',33.333,1),(473,7484297,7484293,'dex',33.333,1),(473,7484298,7484295,'adm',8.333,1),(473,7484299,7484295,'dmi',8.333,1),(473,7484300,7484295,'min',8.333,1),(473,7484301,7484295,'ini',8.333,1),(473,7484302,7484295,'nis',8.333,1),(473,7484303,7484295,'ist',8.333,1),(473,7484304,7484295,'str',8.333,1),(473,7484305,7484295,'tra',8.333,1),(473,7484306,7484295,'rat',8.333,1),(473,7484307,7484295,'ati',8.333,1),(473,7484308,7484295,'tio',8.333,1),(473,7484309,7484295,'ion',8.333,1),(473,7484310,7484298,'sta',33.333,3),(473,7484311,7484298,'tat',33.333,3),(473,7484312,7484298,'ate',33.333,3),(473,7484313,7484310,'ena',20,2),(473,7484314,7484310,'nab',20,2),(473,7484315,7484310,'abl',20,2),(473,7484316,7484310,'ble',20,2),(473,7484317,7484310,'led',20,2),(473,7484318,7484313,'cac',33.333,2),(473,7484319,7484313,'ach',33.333,2),(473,7484320,7484313,'che',33.333,2),(473,7484321,7484318,'mod',50,1),(473,7484322,7484318,'ode',50,1),(473,7484323,7484321,'wri',14.286,1),(473,7484324,7484321,'rit',14.286,1),(473,7484325,7484321,'ite',14.286,1),(473,7484326,7484321,'tet',14.286,1),(473,7484327,7484321,'eth',14.286,1),(473,7484328,7484321,'thr',14.286,1),(473,7484329,7484321,'hru',14.286,1),(473,7484330,7484323,'ope',11.111,2),(473,7484331,7484323,'per',11.111,2),(473,7484332,7484323,'era',11.111,2),(473,7484333,7484323,'rat',11.111,2),(473,7484334,7484323,'ati',11.111,2),(473,7484335,7484323,'tio',11.111,2),(473,7484336,7484323,'ion',11.111,2),(473,7484337,7484323,'ona',11.111,2),(473,7484338,7484323,'nal',11.111,2),(473,7484339,7484330,'pen',20,1),(473,7484340,7484330,'end',20,1),(473,7484341,7484330,'ndi',20,1),(473,7484342,7484330,'din',20,1),(473,7484343,7484330,'ing',20,1),(473,7484344,7484339,'mes',20,1),(473,7484345,7484339,'ess',20,1),(473,7484346,7484339,'ssa',20,1),(473,7484347,7484339,'sag',20,1),(473,7484348,7484339,'age',20,1),(473,7484349,7484344,'wai',20,1),(473,7484350,7484344,'ait',20,1),(473,7484351,7484344,'iti',20,1),(473,7484352,7484344,'tin',20,1),(473,7484353,7484344,'ing',20,1),(473,7484354,7484349,'for',100,1),(473,7484355,7484354,'per',11.111,1),(473,7484356,7484354,'erf',11.111,1),(473,7484357,7484354,'rfo',11.111,1),(473,7484358,7484354,'for',11.111,1),(473,7484359,7484354,'orm',11.111,1),(473,7484360,7484354,'rma',11.111,1),(473,7484361,7484354,'man',11.111,1),(473,7484362,7484354,'anc',11.111,1),(473,7484363,7484354,'nce',11.111,1),(473,7484364,7484355,'ide',12.5,1),(473,7484365,7484355,'den',12.5,1),(473,7484366,7484355,'ent',12.5,1),(473,7484367,7484355,'nti',12.5,1),(473,7484368,7484355,'tif',12.5,1),(473,7484369,7484355,'ifi',12.5,1),(473,7484370,7484355,'fie',12.5,1),(473,7484371,7484355,'ier',12.5,1),(473,7484372,7484364,'vdi',33.333,3),(473,7484373,7484364,'dis',33.333,3),(473,7484374,7484364,'isk',33.333,3),(473,7484375,7484372,'nam',50,1),(473,7484376,7484372,'ame',50,1),(473,7484377,7484375,'typ',50,1),(473,7484378,7484375,'ype',50,1),(473,7484379,7484377,'dir',25,1),(473,7484380,7484377,'ire',25,1),(473,7484381,7484377,'rec',25,1),(473,7484382,7484377,'ect',25,1),(474,7484384,7484383,'naa',100,2),(474,7484385,7484384,'600',3.333,3),(474,7484386,7484384,'000',3.333,3),(474,7484387,7484384,'00c',3.333,3),(474,7484388,7484384,'0c2',3.333,3),(474,7484389,7484384,'c29',3.333,3),(474,7484390,7484384,'294',3.333,3),(474,7484391,7484384,'949',3.333,3),(474,7484392,7484384,'490',3.333,3),(474,7484393,7484384,'903',3.333,3),(474,7484394,7484384,'030',3.333,3),(474,7484395,7484384,'301',3.333,3),(474,7484396,7484384,'01b',3.333,3),(474,7484397,7484384,'1b4',3.333,3),(474,7484398,7484384,'b4e',3.333,3),(474,7484399,7484384,'4e6',3.333,3),(474,7484400,7484384,'e60',3.333,3),(474,7484401,7484384,'605',3.333,3),(474,7484402,7484384,'052',3.333,3),(474,7484403,7484384,'524',3.333,3),(474,7484404,7484384,'24d',3.333,3),(474,7484405,7484384,'4df',3.333,3),(474,7484406,7484384,'df4',3.333,3),(474,7484407,7484384,'f46',3.333,3),(474,7484408,7484384,'467',3.333,3),(474,7484409,7484384,'67f',3.333,3),(474,7484410,7484384,'7fb',3.333,3),(474,7484411,7484384,'fb6',3.333,3),(474,7484412,7484384,'b65',3.333,3),(474,7484413,7484384,'65f',3.333,3),(474,7484414,7484384,'5f9',3.333,3),(474,7484415,7484385,'mon',100,1),(474,7484416,7484415,'201',50,1),(474,7484417,7484415,'013',50,1),(474,7484418,7484416,'adm',33.333,3),(474,7484419,7484416,'dmi',33.333,3),(474,7484420,7484416,'min',33.333,3),(474,7484421,7484418,'cap',16.667,1),(474,7484422,7484418,'apa',16.667,1),(474,7484423,7484418,'pac',16.667,1),(474,7484424,7484418,'aci',16.667,1),(474,7484425,7484418,'cit',16.667,1),(474,7484426,7484418,'ity',16.667,1),(474,7484427,7484421,'pat',50,1),(474,7484428,7484421,'ath',50,1),(474,7484429,7484427,'fre',14.286,1),(474,7484430,7484427,'ree',14.286,1),(474,7484431,7484427,'ees',14.286,1),(474,7484432,7484427,'esp',14.286,1),(474,7484433,7484427,'spa',14.286,1),(474,7484434,7484427,'pac',14.286,1),(474,7484435,7484427,'ace',14.286,1),(474,7484436,7484429,'dis',50,1),(474,7484437,7484429,'isk',50,1),(474,7484438,7484436,'ind',33.333,1),(474,7484439,7484436,'nde',33.333,1),(474,7484440,7484436,'dex',33.333,1),(474,7484441,7484438,'adm',8.333,1),(474,7484442,7484438,'dmi',8.333,1),(474,7484443,7484438,'min',8.333,1),(474,7484444,7484438,'ini',8.333,1),(474,7484445,7484438,'nis',8.333,1),(474,7484446,7484438,'ist',8.333,1),(474,7484447,7484438,'str',8.333,1),(474,7484448,7484438,'tra',8.333,1),(474,7484449,7484438,'rat',8.333,1),(474,7484450,7484438,'ati',8.333,1),(474,7484451,7484438,'tio',8.333,1),(474,7484452,7484438,'ion',8.333,1),(474,7484453,7484441,'sta',33.333,3),(474,7484454,7484441,'tat',33.333,3),(474,7484455,7484441,'ate',33.333,3),(474,7484456,7484453,'ena',20,2),(474,7484457,7484453,'nab',20,2),(474,7484458,7484453,'abl',20,2),(474,7484459,7484453,'ble',20,2),(474,7484460,7484453,'led',20,2),(474,7484461,7484456,'cac',33.333,2),(474,7484462,7484456,'ach',33.333,2),(474,7484463,7484456,'che',33.333,2),(474,7484464,7484461,'mod',50,1),(474,7484465,7484461,'ode',50,1),(474,7484466,7484464,'wri',14.286,1),(474,7484467,7484464,'rit',14.286,1),(474,7484468,7484464,'ite',14.286,1),(474,7484469,7484464,'tet',14.286,1),(474,7484470,7484464,'eth',14.286,1),(474,7484471,7484464,'thr',14.286,1),(474,7484472,7484464,'hru',14.286,1),(474,7484473,7484466,'ope',11.111,2),(474,7484474,7484466,'per',11.111,2),(474,7484475,7484466,'era',11.111,2),(474,7484476,7484466,'rat',11.111,2),(474,7484477,7484466,'ati',11.111,2),(474,7484478,7484466,'tio',11.111,2),(474,7484479,7484466,'ion',11.111,2),(474,7484480,7484466,'ona',11.111,2),(474,7484481,7484466,'nal',11.111,2),(474,7484482,7484473,'pen',20,1),(474,7484483,7484473,'end',20,1),(474,7484484,7484473,'ndi',20,1),(474,7484485,7484473,'din',20,1),(474,7484486,7484473,'ing',20,1),(474,7484487,7484482,'mes',20,1),(474,7484488,7484482,'ess',20,1),(474,7484489,7484482,'ssa',20,1),(474,7484490,7484482,'sag',20,1),(474,7484491,7484482,'age',20,1),(474,7484492,7484487,'wai',20,1),(474,7484493,7484487,'ait',20,1),(474,7484494,7484487,'iti',20,1),(474,7484495,7484487,'tin',20,1),(474,7484496,7484487,'ing',20,1),(474,7484497,7484492,'for',100,1),(474,7484498,7484497,'per',11.111,1),(474,7484499,7484497,'erf',11.111,1),(474,7484500,7484497,'rfo',11.111,1),(474,7484501,7484497,'for',11.111,1),(474,7484502,7484497,'orm',11.111,1),(474,7484503,7484497,'rma',11.111,1),(474,7484504,7484497,'man',11.111,1),(474,7484505,7484497,'anc',11.111,1),(474,7484506,7484497,'nce',11.111,1),(474,7484507,7484498,'ide',12.5,1),(474,7484508,7484498,'den',12.5,1),(474,7484509,7484498,'ent',12.5,1),(474,7484510,7484498,'nti',12.5,1),(474,7484511,7484498,'tif',12.5,1),(474,7484512,7484498,'ifi',12.5,1),(474,7484513,7484498,'fie',12.5,1),(474,7484514,7484498,'ier',12.5,1),(474,7484515,7484507,'vdi',33.333,3),(474,7484516,7484507,'dis',33.333,3),(474,7484517,7484507,'isk',33.333,3),(474,7484518,7484515,'nam',50,1),(474,7484519,7484515,'ame',50,1),(474,7484520,7484518,'typ',50,1),(474,7484521,7484518,'ype',50,1),(474,7484522,7484520,'dir',25,1),(474,7484523,7484520,'ire',25,1),(474,7484524,7484520,'rec',25,1),(474,7484525,7484520,'ect',25,1),(475,7484527,7484526,'naa',100,2),(475,7484528,7484527,'600',3.333,3),(475,7484529,7484527,'000',3.333,3),(475,7484530,7484527,'00c',3.333,3),(475,7484531,7484527,'0c2',3.333,3),(475,7484532,7484527,'c29',3.333,3),(475,7484533,7484527,'29b',3.333,3),(475,7484534,7484527,'9ba',3.333,3),(475,7484535,7484527,'bae',3.333,3),(475,7484536,7484527,'ae5',3.333,3),(475,7484537,7484527,'e59',3.333,3),(475,7484538,7484527,'590',3.333,3),(475,7484539,7484527,'90d',3.333,3),(475,7484540,7484527,'0d6',3.333,3),(475,7484541,7484527,'d69',3.333,3),(475,7484542,7484527,'69a',3.333,3),(475,7484543,7484527,'9a5',3.333,3),(475,7484544,7484527,'a5a',3.333,3),(475,7484545,7484527,'5ad',3.333,3),(475,7484546,7484527,'ad7',3.333,3),(475,7484547,7484527,'d76',3.333,3),(475,7484548,7484527,'76d',3.333,3),(475,7484549,7484527,'6d9',3.333,3),(475,7484550,7484527,'d94',3.333,3),(475,7484551,7484527,'948',3.333,3),(475,7484552,7484527,'482',3.333,3),(475,7484553,7484527,'82d',3.333,3),(475,7484554,7484527,'2d6',3.333,3),(475,7484555,7484527,'d68',3.333,3),(475,7484556,7484527,'682',3.333,3),(475,7484557,7484527,'823',3.333,3),(475,7484558,7484528,'mon',100,1),(475,7484559,7484558,'201',50,1),(475,7484560,7484558,'013',50,1),(475,7484561,7484559,'adm',33.333,3),(475,7484562,7484559,'dmi',33.333,3),(475,7484563,7484559,'min',33.333,3),(475,7484564,7484561,'cap',16.667,1),(475,7484565,7484561,'apa',16.667,1),(475,7484566,7484561,'pac',16.667,1),(475,7484567,7484561,'aci',16.667,1),(475,7484568,7484561,'cit',16.667,1),(475,7484569,7484561,'ity',16.667,1),(475,7484570,7484564,'pat',50,1),(475,7484571,7484564,'ath',50,1),(475,7484572,7484570,'fre',14.286,1),(475,7484573,7484570,'ree',14.286,1),(475,7484574,7484570,'ees',14.286,1),(475,7484575,7484570,'esp',14.286,1),(475,7484576,7484570,'spa',14.286,1),(475,7484577,7484570,'pac',14.286,1),(475,7484578,7484570,'ace',14.286,1),(475,7484579,7484572,'dis',50,1),(475,7484580,7484572,'isk',50,1),(475,7484581,7484579,'ind',33.333,1),(475,7484582,7484579,'nde',33.333,1),(475,7484583,7484579,'dex',33.333,1),(475,7484584,7484581,'adm',8.333,1),(475,7484585,7484581,'dmi',8.333,1),(475,7484586,7484581,'min',8.333,1),(475,7484587,7484581,'ini',8.333,1),(475,7484588,7484581,'nis',8.333,1),(475,7484589,7484581,'ist',8.333,1),(475,7484590,7484581,'str',8.333,1),(475,7484591,7484581,'tra',8.333,1),(475,7484592,7484581,'rat',8.333,1),(475,7484593,7484581,'ati',8.333,1),(475,7484594,7484581,'tio',8.333,1),(475,7484595,7484581,'ion',8.333,1),(475,7484596,7484584,'sta',33.333,3),(475,7484597,7484584,'tat',33.333,3),(475,7484598,7484584,'ate',33.333,3),(475,7484599,7484596,'ena',20,2),(475,7484600,7484596,'nab',20,2),(475,7484601,7484596,'abl',20,2),(475,7484602,7484596,'ble',20,2),(475,7484603,7484596,'led',20,2),(475,7484604,7484599,'cac',33.333,2),(475,7484605,7484599,'ach',33.333,2),(475,7484606,7484599,'che',33.333,2),(475,7484607,7484604,'mod',50,1),(475,7484608,7484604,'ode',50,1),(475,7484609,7484607,'wri',14.286,1),(475,7484610,7484607,'rit',14.286,1),(475,7484611,7484607,'ite',14.286,1),(475,7484612,7484607,'tet',14.286,1),(475,7484613,7484607,'eth',14.286,1),(475,7484614,7484607,'thr',14.286,1),(475,7484615,7484607,'hru',14.286,1),(475,7484616,7484609,'ope',11.111,2),(475,7484617,7484609,'per',11.111,2),(475,7484618,7484609,'era',11.111,2),(475,7484619,7484609,'rat',11.111,2),(475,7484620,7484609,'ati',11.111,2),(475,7484621,7484609,'tio',11.111,2),(475,7484622,7484609,'ion',11.111,2),(475,7484623,7484609,'ona',11.111,2),(475,7484624,7484609,'nal',11.111,2),(475,7484625,7484616,'pen',20,1),(475,7484626,7484616,'end',20,1),(475,7484627,7484616,'ndi',20,1),(475,7484628,7484616,'din',20,1),(475,7484629,7484616,'ing',20,1),(475,7484630,7484625,'mes',20,1),(475,7484631,7484625,'ess',20,1),(475,7484632,7484625,'ssa',20,1),(475,7484633,7484625,'sag',20,1),(475,7484634,7484625,'age',20,1),(475,7484635,7484630,'wai',20,1),(475,7484636,7484630,'ait',20,1),(475,7484637,7484630,'iti',20,1),(475,7484638,7484630,'tin',20,1),(475,7484639,7484630,'ing',20,1),(475,7484640,7484635,'for',100,1),(475,7484641,7484640,'per',11.111,1),(475,7484642,7484640,'erf',11.111,1),(475,7484643,7484640,'rfo',11.111,1),(475,7484644,7484640,'for',11.111,1),(475,7484645,7484640,'orm',11.111,1),(475,7484646,7484640,'rma',11.111,1),(475,7484647,7484640,'man',11.111,1),(475,7484648,7484640,'anc',11.111,1),(475,7484649,7484640,'nce',11.111,1),(475,7484650,7484641,'ide',12.5,1),(475,7484651,7484641,'den',12.5,1),(475,7484652,7484641,'ent',12.5,1),(475,7484653,7484641,'nti',12.5,1),(475,7484654,7484641,'tif',12.5,1),(475,7484655,7484641,'ifi',12.5,1),(475,7484656,7484641,'fie',12.5,1),(475,7484657,7484641,'ier',12.5,1),(475,7484658,7484650,'vdi',33.333,3),(475,7484659,7484650,'dis',33.333,3),(475,7484660,7484650,'isk',33.333,3),(475,7484661,7484658,'nam',50,1),(475,7484662,7484658,'ame',50,1),(475,7484663,7484661,'typ',50,1),(475,7484664,7484661,'ype',50,1),(475,7484665,7484663,'dir',25,1),(475,7484666,7484663,'ire',25,1),(475,7484667,7484663,'rec',25,1),(475,7484668,7484663,'ect',25,1),(476,7484670,7484669,'naa',100,2),(476,7484671,7484670,'600',3.333,3),(476,7484672,7484670,'000',3.333,3),(476,7484673,7484670,'00c',3.333,3),(476,7484674,7484670,'0c2',3.333,3),(476,7484675,7484670,'c29',3.333,3),(476,7484676,7484670,'297',3.333,3),(476,7484677,7484670,'976',3.333,3),(476,7484678,7484670,'766',3.333,3),(476,7484679,7484670,'661',3.333,3),(476,7484680,7484670,'618',3.333,3),(476,7484681,7484670,'184',3.333,3),(476,7484682,7484670,'848',3.333,3),(476,7484683,7484670,'483',3.333,3),(476,7484684,7484670,'835',3.333,3),(476,7484685,7484670,'358',3.333,3),(476,7484686,7484670,'584',3.333,3),(476,7484687,7484670,'845',3.333,3),(476,7484688,7484670,'457',3.333,3),(476,7484689,7484670,'57a',3.333,3),(476,7484690,7484670,'7a9',3.333,3),(476,7484691,7484670,'a9e',3.333,3),(476,7484692,7484670,'9ec',3.333,3),(476,7484693,7484670,'ec6',3.333,3),(476,7484694,7484670,'c69',3.333,3),(476,7484695,7484670,'697',3.333,3),(476,7484696,7484670,'97c',3.333,3),(476,7484697,7484670,'7c1',3.333,3),(476,7484698,7484670,'c16',3.333,3),(476,7484699,7484670,'166',3.333,3),(476,7484700,7484670,'661',3.333,3),(476,7484701,7484671,'mon',100,1),(476,7484702,7484701,'201',50,1),(476,7484703,7484701,'013',50,1),(476,7484704,7484702,'adm',33.333,3),(476,7484705,7484702,'dmi',33.333,3),(476,7484706,7484702,'min',33.333,3),(476,7484707,7484704,'cap',16.667,1),(476,7484708,7484704,'apa',16.667,1),(476,7484709,7484704,'pac',16.667,1),(476,7484710,7484704,'aci',16.667,1),(476,7484711,7484704,'cit',16.667,1),(476,7484712,7484704,'ity',16.667,1),(476,7484713,7484707,'pat',50,1),(476,7484714,7484707,'ath',50,1),(476,7484715,7484713,'fre',14.286,1),(476,7484716,7484713,'ree',14.286,1),(476,7484717,7484713,'ees',14.286,1),(476,7484718,7484713,'esp',14.286,1),(476,7484719,7484713,'spa',14.286,1),(476,7484720,7484713,'pac',14.286,1),(476,7484721,7484713,'ace',14.286,1),(476,7484722,7484715,'dis',50,1),(476,7484723,7484715,'isk',50,1),(476,7484724,7484722,'ind',33.333,1),(476,7484725,7484722,'nde',33.333,1),(476,7484726,7484722,'dex',33.333,1),(476,7484727,7484724,'adm',8.333,1),(476,7484728,7484724,'dmi',8.333,1),(476,7484729,7484724,'min',8.333,1),(476,7484730,7484724,'ini',8.333,1),(476,7484731,7484724,'nis',8.333,1),(476,7484732,7484724,'ist',8.333,1),(476,7484733,7484724,'str',8.333,1),(476,7484734,7484724,'tra',8.333,1),(476,7484735,7484724,'rat',8.333,1),(476,7484736,7484724,'ati',8.333,1),(476,7484737,7484724,'tio',8.333,1),(476,7484738,7484724,'ion',8.333,1),(476,7484739,7484727,'sta',33.333,3),(476,7484740,7484727,'tat',33.333,3),(476,7484741,7484727,'ate',33.333,3),(476,7484742,7484739,'ena',20,2),(476,7484743,7484739,'nab',20,2),(476,7484744,7484739,'abl',20,2),(476,7484745,7484739,'ble',20,2),(476,7484746,7484739,'led',20,2),(476,7484747,7484742,'cac',33.333,2),(476,7484748,7484742,'ach',33.333,2),(476,7484749,7484742,'che',33.333,2),(476,7484750,7484747,'mod',50,1),(476,7484751,7484747,'ode',50,1),(476,7484752,7484750,'wri',14.286,1),(476,7484753,7484750,'rit',14.286,1),(476,7484754,7484750,'ite',14.286,1),(476,7484755,7484750,'tet',14.286,1),(476,7484756,7484750,'eth',14.286,1),(476,7484757,7484750,'thr',14.286,1),(476,7484758,7484750,'hru',14.286,1),(476,7484759,7484752,'ope',11.111,2),(476,7484760,7484752,'per',11.111,2),(476,7484761,7484752,'era',11.111,2),(476,7484762,7484752,'rat',11.111,2),(476,7484763,7484752,'ati',11.111,2),(476,7484764,7484752,'tio',11.111,2),(476,7484765,7484752,'ion',11.111,2),(476,7484766,7484752,'ona',11.111,2),(476,7484767,7484752,'nal',11.111,2),(476,7484768,7484759,'pen',20,1),(476,7484769,7484759,'end',20,1),(476,7484770,7484759,'ndi',20,1),(476,7484771,7484759,'din',20,1),(476,7484772,7484759,'ing',20,1),(476,7484773,7484768,'mes',20,1),(476,7484774,7484768,'ess',20,1),(476,7484775,7484768,'ssa',20,1),(476,7484776,7484768,'sag',20,1),(476,7484777,7484768,'age',20,1),(476,7484778,7484773,'wai',20,1),(476,7484779,7484773,'ait',20,1),(476,7484780,7484773,'iti',20,1),(476,7484781,7484773,'tin',20,1),(476,7484782,7484773,'ing',20,1),(476,7484783,7484778,'for',100,1),(476,7484784,7484783,'per',11.111,1),(476,7484785,7484783,'erf',11.111,1),(476,7484786,7484783,'rfo',11.111,1),(476,7484787,7484783,'for',11.111,1),(476,7484788,7484783,'orm',11.111,1),(476,7484789,7484783,'rma',11.111,1),(476,7484790,7484783,'man',11.111,1),(476,7484791,7484783,'anc',11.111,1),(476,7484792,7484783,'nce',11.111,1),(476,7484793,7484784,'ide',12.5,1),(476,7484794,7484784,'den',12.5,1),(476,7484795,7484784,'ent',12.5,1),(476,7484796,7484784,'nti',12.5,1),(476,7484797,7484784,'tif',12.5,1),(476,7484798,7484784,'ifi',12.5,1),(476,7484799,7484784,'fie',12.5,1),(476,7484800,7484784,'ier',12.5,1),(476,7484801,7484793,'vdi',33.333,3),(476,7484802,7484793,'dis',33.333,3),(476,7484803,7484793,'isk',33.333,3),(476,7484804,7484801,'nam',50,1),(476,7484805,7484801,'ame',50,1),(476,7484806,7484804,'typ',50,1),(476,7484807,7484804,'ype',50,1),(476,7484808,7484806,'dir',25,1),(476,7484809,7484806,'ire',25,1),(476,7484810,7484806,'rec',25,1),(476,7484811,7484806,'ect',25,1),(477,7484813,7484812,'naa',100,2),(477,7484814,7484813,'600',3.333,3),(477,7484815,7484813,'000',3.333,3),(477,7484816,7484813,'00c',3.333,3),(477,7484817,7484813,'0c2',3.333,3),(477,7484818,7484813,'c29',3.333,3),(477,7484819,7484813,'295',3.333,3),(477,7484820,7484813,'958',3.333,3),(477,7484821,7484813,'584',3.333,3),(477,7484822,7484813,'849',3.333,3),(477,7484823,7484813,'495',3.333,3),(477,7484824,7484813,'955',3.333,3),(477,7484825,7484813,'553',3.333,3),(477,7484826,7484813,'536',3.333,3),(477,7484827,7484813,'36a',3.333,3),(477,7484828,7484813,'6a5',3.333,3),(477,7484829,7484813,'a5b',3.333,3),(477,7484830,7484813,'5b0',3.333,3),(477,7484831,7484813,'b02',3.333,3),(477,7484832,7484813,'026',3.333,3),(477,7484833,7484813,'261',3.333,3),(477,7484834,7484813,'614',3.333,3),(477,7484835,7484813,'14f',3.333,3),(477,7484836,7484813,'4f0',3.333,3),(477,7484837,7484813,'f0b',3.333,3),(477,7484838,7484813,'0b1',3.333,3),(477,7484839,7484813,'b11',3.333,3),(477,7484840,7484813,'11a',3.333,3),(477,7484841,7484813,'1a1',3.333,3),(477,7484842,7484813,'a10',3.333,3),(477,7484843,7484813,'10f',3.333,3),(477,7484844,7484814,'mon',100,1),(477,7484845,7484844,'201',50,1),(477,7484846,7484844,'013',50,1),(477,7484847,7484845,'adm',33.333,3),(477,7484848,7484845,'dmi',33.333,3),(477,7484849,7484845,'min',33.333,3),(477,7484850,7484847,'cap',16.667,1),(477,7484851,7484847,'apa',16.667,1),(477,7484852,7484847,'pac',16.667,1),(477,7484853,7484847,'aci',16.667,1),(477,7484854,7484847,'cit',16.667,1),(477,7484855,7484847,'ity',16.667,1),(477,7484856,7484850,'pat',50,1),(477,7484857,7484850,'ath',50,1),(477,7484858,7484856,'fre',14.286,1),(477,7484859,7484856,'ree',14.286,1),(477,7484860,7484856,'ees',14.286,1),(477,7484861,7484856,'esp',14.286,1),(477,7484862,7484856,'spa',14.286,1),(477,7484863,7484856,'pac',14.286,1),(477,7484864,7484856,'ace',14.286,1),(477,7484865,7484858,'dis',50,1),(477,7484866,7484858,'isk',50,1),(477,7484867,7484865,'ind',33.333,1),(477,7484868,7484865,'nde',33.333,1),(477,7484869,7484865,'dex',33.333,1),(477,7484870,7484867,'adm',8.333,1),(477,7484871,7484867,'dmi',8.333,1),(477,7484872,7484867,'min',8.333,1),(477,7484873,7484867,'ini',8.333,1),(477,7484874,7484867,'nis',8.333,1),(477,7484875,7484867,'ist',8.333,1),(477,7484876,7484867,'str',8.333,1),(477,7484877,7484867,'tra',8.333,1),(477,7484878,7484867,'rat',8.333,1),(477,7484879,7484867,'ati',8.333,1),(477,7484880,7484867,'tio',8.333,1),(477,7484881,7484867,'ion',8.333,1),(477,7484882,7484870,'sta',33.333,3),(477,7484883,7484870,'tat',33.333,3),(477,7484884,7484870,'ate',33.333,3),(477,7484885,7484882,'ena',20,2),(477,7484886,7484882,'nab',20,2),(477,7484887,7484882,'abl',20,2),(477,7484888,7484882,'ble',20,2),(477,7484889,7484882,'led',20,2),(477,7484890,7484885,'cac',33.333,2),(477,7484891,7484885,'ach',33.333,2),(477,7484892,7484885,'che',33.333,2),(477,7484893,7484890,'mod',50,1),(477,7484894,7484890,'ode',50,1),(477,7484895,7484893,'wri',14.286,1),(477,7484896,7484893,'rit',14.286,1),(477,7484897,7484893,'ite',14.286,1),(477,7484898,7484893,'tet',14.286,1),(477,7484899,7484893,'eth',14.286,1),(477,7484900,7484893,'thr',14.286,1),(477,7484901,7484893,'hru',14.286,1),(477,7484902,7484895,'ope',11.111,2),(477,7484903,7484895,'per',11.111,2),(477,7484904,7484895,'era',11.111,2),(477,7484905,7484895,'rat',11.111,2),(477,7484906,7484895,'ati',11.111,2),(477,7484907,7484895,'tio',11.111,2),(477,7484908,7484895,'ion',11.111,2),(477,7484909,7484895,'ona',11.111,2),(477,7484910,7484895,'nal',11.111,2),(477,7484911,7484902,'pen',20,1),(477,7484912,7484902,'end',20,1),(477,7484913,7484902,'ndi',20,1),(477,7484914,7484902,'din',20,1),(477,7484915,7484902,'ing',20,1),(477,7484916,7484911,'mes',20,1),(477,7484917,7484911,'ess',20,1),(477,7484918,7484911,'ssa',20,1),(477,7484919,7484911,'sag',20,1),(477,7484920,7484911,'age',20,1),(477,7484921,7484916,'wai',20,1),(477,7484922,7484916,'ait',20,1),(477,7484923,7484916,'iti',20,1),(477,7484924,7484916,'tin',20,1),(477,7484925,7484916,'ing',20,1),(477,7484926,7484921,'for',100,1),(477,7484927,7484926,'per',11.111,1),(477,7484928,7484926,'erf',11.111,1),(477,7484929,7484926,'rfo',11.111,1),(477,7484930,7484926,'for',11.111,1),(477,7484931,7484926,'orm',11.111,1),(477,7484932,7484926,'rma',11.111,1),(477,7484933,7484926,'man',11.111,1),(477,7484934,7484926,'anc',11.111,1),(477,7484935,7484926,'nce',11.111,1),(477,7484936,7484927,'ide',12.5,1),(477,7484937,7484927,'den',12.5,1),(477,7484938,7484927,'ent',12.5,1),(477,7484939,7484927,'nti',12.5,1),(477,7484940,7484927,'tif',12.5,1),(477,7484941,7484927,'ifi',12.5,1),(477,7484942,7484927,'fie',12.5,1),(477,7484943,7484927,'ier',12.5,1),(477,7484944,7484936,'vdi',33.333,3),(477,7484945,7484936,'dis',33.333,3),(477,7484946,7484936,'isk',33.333,3),(477,7484947,7484944,'nam',50,1),(477,7484948,7484944,'ame',50,1),(477,7484949,7484947,'typ',50,1),(477,7484950,7484947,'ype',50,1),(477,7484951,7484949,'dir',25,1),(477,7484952,7484949,'ire',25,1),(477,7484953,7484949,'rec',25,1),(477,7484954,7484949,'ect',25,1),(478,7484956,7484955,'naa',100,2),(478,7484957,7484956,'600',3.333,3),(478,7484958,7484956,'000',3.333,3),(478,7484959,7484956,'00c',3.333,3),(478,7484960,7484956,'0c2',3.333,3),(478,7484961,7484956,'c29',3.333,3),(478,7484962,7484956,'293',3.333,3),(478,7484963,7484956,'936',3.333,3),(478,7484964,7484956,'36c',3.333,3),(478,7484965,7484956,'6c6',3.333,3),(478,7484966,7484956,'c67',3.333,3),(478,7484967,7484956,'67b',3.333,3),(478,7484968,7484956,'7b6',3.333,3),(478,7484969,7484956,'b6d',3.333,3),(478,7484970,7484956,'6d6',3.333,3),(478,7484971,7484956,'d6d',3.333,3),(478,7484972,7484956,'6d7',3.333,3),(478,7484973,7484956,'d73',3.333,3),(478,7484974,7484956,'73a',3.333,3),(478,7484975,7484956,'3a6',3.333,3),(478,7484976,7484956,'a62',3.333,3),(478,7484977,7484956,'62e',3.333,3),(478,7484978,7484956,'2e5',3.333,3),(478,7484979,7484956,'e5c',3.333,3),(478,7484980,7484956,'5c5',3.333,3),(478,7484981,7484956,'c58',3.333,3),(478,7484982,7484956,'58a',3.333,3),(478,7484983,7484956,'8a4',3.333,3),(478,7484984,7484956,'a4e',3.333,3),(478,7484985,7484956,'4e6',3.333,3),(478,7484986,7484956,'e67',3.333,3),(478,7484987,7484957,'mon',100,1),(478,7484988,7484987,'201',50,1),(478,7484989,7484987,'013',50,1),(478,7484990,7484988,'adm',33.333,3),(478,7484991,7484988,'dmi',33.333,3),(478,7484992,7484988,'min',33.333,3),(478,7484993,7484990,'cap',16.667,1),(478,7484994,7484990,'apa',16.667,1),(478,7484995,7484990,'pac',16.667,1),(478,7484996,7484990,'aci',16.667,1),(478,7484997,7484990,'cit',16.667,1),(478,7484998,7484990,'ity',16.667,1),(478,7484999,7484993,'pat',50,1),(478,7485000,7484993,'ath',50,1),(478,7485001,7484999,'fre',14.286,1),(478,7485002,7484999,'ree',14.286,1),(478,7485003,7484999,'ees',14.286,1),(478,7485004,7484999,'esp',14.286,1),(478,7485005,7484999,'spa',14.286,1),(478,7485006,7484999,'pac',14.286,1),(478,7485007,7484999,'ace',14.286,1),(478,7485008,7485001,'dis',50,1),(478,7485009,7485001,'isk',50,1),(478,7485010,7485008,'ind',33.333,1),(478,7485011,7485008,'nde',33.333,1),(478,7485012,7485008,'dex',33.333,1),(478,7485013,7485010,'adm',8.333,1),(478,7485014,7485010,'dmi',8.333,1),(478,7485015,7485010,'min',8.333,1),(478,7485016,7485010,'ini',8.333,1),(478,7485017,7485010,'nis',8.333,1),(478,7485018,7485010,'ist',8.333,1),(478,7485019,7485010,'str',8.333,1),(478,7485020,7485010,'tra',8.333,1),(478,7485021,7485010,'rat',8.333,1),(478,7485022,7485010,'ati',8.333,1),(478,7485023,7485010,'tio',8.333,1),(478,7485024,7485010,'ion',8.333,1),(478,7485025,7485013,'sta',33.333,3),(478,7485026,7485013,'tat',33.333,3),(478,7485027,7485013,'ate',33.333,3),(478,7485028,7485025,'ena',20,2),(478,7485029,7485025,'nab',20,2),(478,7485030,7485025,'abl',20,2),(478,7485031,7485025,'ble',20,2),(478,7485032,7485025,'led',20,2),(478,7485033,7485028,'cac',33.333,2),(478,7485034,7485028,'ach',33.333,2),(478,7485035,7485028,'che',33.333,2),(478,7485036,7485033,'mod',50,1),(478,7485037,7485033,'ode',50,1),(478,7485038,7485036,'wri',14.286,1),(478,7485039,7485036,'rit',14.286,1),(478,7485040,7485036,'ite',14.286,1),(478,7485041,7485036,'tet',14.286,1),(478,7485042,7485036,'eth',14.286,1),(478,7485043,7485036,'thr',14.286,1),(478,7485044,7485036,'hru',14.286,1),(478,7485045,7485038,'ope',11.111,2),(478,7485046,7485038,'per',11.111,2),(478,7485047,7485038,'era',11.111,2),(478,7485048,7485038,'rat',11.111,2),(478,7485049,7485038,'ati',11.111,2),(478,7485050,7485038,'tio',11.111,2),(478,7485051,7485038,'ion',11.111,2),(478,7485052,7485038,'ona',11.111,2),(478,7485053,7485038,'nal',11.111,2),(478,7485054,7485045,'pen',20,1),(478,7485055,7485045,'end',20,1),(478,7485056,7485045,'ndi',20,1),(478,7485057,7485045,'din',20,1),(478,7485058,7485045,'ing',20,1),(478,7485059,7485054,'mes',20,1),(478,7485060,7485054,'ess',20,1),(478,7485061,7485054,'ssa',20,1),(478,7485062,7485054,'sag',20,1),(478,7485063,7485054,'age',20,1),(478,7485064,7485059,'wai',20,1),(478,7485065,7485059,'ait',20,1),(478,7485066,7485059,'iti',20,1),(478,7485067,7485059,'tin',20,1),(478,7485068,7485059,'ing',20,1),(478,7485069,7485064,'for',100,1),(478,7485070,7485069,'per',11.111,1),(478,7485071,7485069,'erf',11.111,1),(478,7485072,7485069,'rfo',11.111,1),(478,7485073,7485069,'for',11.111,1),(478,7485074,7485069,'orm',11.111,1),(478,7485075,7485069,'rma',11.111,1),(478,7485076,7485069,'man',11.111,1),(478,7485077,7485069,'anc',11.111,1),(478,7485078,7485069,'nce',11.111,1),(478,7485079,7485070,'ide',12.5,1),(478,7485080,7485070,'den',12.5,1),(478,7485081,7485070,'ent',12.5,1),(478,7485082,7485070,'nti',12.5,1),(478,7485083,7485070,'tif',12.5,1),(478,7485084,7485070,'ifi',12.5,1),(478,7485085,7485070,'fie',12.5,1),(478,7485086,7485070,'ier',12.5,1),(478,7485087,7485079,'vdi',33.333,3),(478,7485088,7485079,'dis',33.333,3),(478,7485089,7485079,'isk',33.333,3),(478,7485090,7485087,'nam',50,1),(478,7485091,7485087,'ame',50,1),(478,7485092,7485090,'typ',50,1),(478,7485093,7485090,'ype',50,1),(478,7485094,7485092,'dir',25,1),(478,7485095,7485092,'ire',25,1),(478,7485096,7485092,'rec',25,1),(478,7485097,7485092,'ect',25,1),(479,7485099,7485098,'naa',100,2),(479,7485100,7485099,'600',3.333,3),(479,7485101,7485099,'000',3.333,3),(479,7485102,7485099,'00c',3.333,3),(479,7485103,7485099,'0c2',3.333,3),(479,7485104,7485099,'c29',3.333,3),(479,7485105,7485099,'29a',3.333,3),(479,7485106,7485099,'9af',3.333,3),(479,7485107,7485099,'afc',3.333,3),(479,7485108,7485099,'fce',3.333,3),(479,7485109,7485099,'cef',3.333,3),(479,7485110,7485099,'efe',3.333,3),(479,7485111,7485099,'fec',3.333,3),(479,7485112,7485099,'ecb',3.333,3),(479,7485113,7485099,'cb7',3.333,3),(479,7485114,7485099,'b7a',3.333,3),(479,7485115,7485099,'7a5',3.333,3),(479,7485116,7485099,'a5e',3.333,3),(479,7485117,7485099,'5e8',3.333,3),(479,7485118,7485099,'e84',3.333,3),(479,7485119,7485099,'84f',3.333,3),(479,7485120,7485099,'4f9',3.333,3),(479,7485121,7485099,'f9e',3.333,3),(479,7485122,7485099,'9ec',3.333,3),(479,7485123,7485099,'ecd',3.333,3),(479,7485124,7485099,'cd9',3.333,3),(479,7485125,7485099,'d9c',3.333,3),(479,7485126,7485099,'9c4',3.333,3),(479,7485127,7485099,'c40',3.333,3),(479,7485128,7485099,'40e',3.333,3),(479,7485129,7485099,'0ea',3.333,3),(479,7485130,7485100,'mon',100,1),(479,7485131,7485130,'201',50,1),(479,7485132,7485130,'013',50,1),(479,7485133,7485131,'adm',33.333,3),(479,7485134,7485131,'dmi',33.333,3),(479,7485135,7485131,'min',33.333,3),(479,7485136,7485133,'cap',16.667,1),(479,7485137,7485133,'apa',16.667,1),(479,7485138,7485133,'pac',16.667,1),(479,7485139,7485133,'aci',16.667,1),(479,7485140,7485133,'cit',16.667,1),(479,7485141,7485133,'ity',16.667,1),(479,7485142,7485136,'pat',50,1),(479,7485143,7485136,'ath',50,1),(479,7485144,7485142,'fre',14.286,1),(479,7485145,7485142,'ree',14.286,1),(479,7485146,7485142,'ees',14.286,1),(479,7485147,7485142,'esp',14.286,1),(479,7485148,7485142,'spa',14.286,1),(479,7485149,7485142,'pac',14.286,1),(479,7485150,7485142,'ace',14.286,1),(479,7485151,7485144,'dis',50,1),(479,7485152,7485144,'isk',50,1),(479,7485153,7485151,'ind',33.333,1),(479,7485154,7485151,'nde',33.333,1),(479,7485155,7485151,'dex',33.333,1),(479,7485156,7485153,'adm',8.333,1),(479,7485157,7485153,'dmi',8.333,1),(479,7485158,7485153,'min',8.333,1),(479,7485159,7485153,'ini',8.333,1),(479,7485160,7485153,'nis',8.333,1),(479,7485161,7485153,'ist',8.333,1),(479,7485162,7485153,'str',8.333,1),(479,7485163,7485153,'tra',8.333,1),(479,7485164,7485153,'rat',8.333,1),(479,7485165,7485153,'ati',8.333,1),(479,7485166,7485153,'tio',8.333,1),(479,7485167,7485153,'ion',8.333,1),(479,7485168,7485156,'sta',33.333,3),(479,7485169,7485156,'tat',33.333,3),(479,7485170,7485156,'ate',33.333,3),(479,7485171,7485168,'ena',20,2),(479,7485172,7485168,'nab',20,2),(479,7485173,7485168,'abl',20,2),(479,7485174,7485168,'ble',20,2),(479,7485175,7485168,'led',20,2),(479,7485176,7485171,'cac',33.333,2),(479,7485177,7485171,'ach',33.333,2),(479,7485178,7485171,'che',33.333,2),(479,7485179,7485176,'mod',50,1),(479,7485180,7485176,'ode',50,1),(479,7485181,7485179,'wri',14.286,1),(479,7485182,7485179,'rit',14.286,1),(479,7485183,7485179,'ite',14.286,1),(479,7485184,7485179,'tet',14.286,1),(479,7485185,7485179,'eth',14.286,1),(479,7485186,7485179,'thr',14.286,1),(479,7485187,7485179,'hru',14.286,1),(479,7485188,7485181,'ope',11.111,2),(479,7485189,7485181,'per',11.111,2),(479,7485190,7485181,'era',11.111,2),(479,7485191,7485181,'rat',11.111,2),(479,7485192,7485181,'ati',11.111,2),(479,7485193,7485181,'tio',11.111,2),(479,7485194,7485181,'ion',11.111,2),(479,7485195,7485181,'ona',11.111,2),(479,7485196,7485181,'nal',11.111,2),(479,7485197,7485188,'pen',20,1),(479,7485198,7485188,'end',20,1),(479,7485199,7485188,'ndi',20,1),(479,7485200,7485188,'din',20,1),(479,7485201,7485188,'ing',20,1),(479,7485202,7485197,'mes',20,1),(479,7485203,7485197,'ess',20,1),(479,7485204,7485197,'ssa',20,1),(479,7485205,7485197,'sag',20,1),(479,7485206,7485197,'age',20,1),(479,7485207,7485202,'wai',20,1),(479,7485208,7485202,'ait',20,1),(479,7485209,7485202,'iti',20,1),(479,7485210,7485202,'tin',20,1),(479,7485211,7485202,'ing',20,1),(479,7485212,7485207,'for',100,1),(479,7485213,7485212,'per',11.111,1),(479,7485214,7485212,'erf',11.111,1),(479,7485215,7485212,'rfo',11.111,1),(479,7485216,7485212,'for',11.111,1),(479,7485217,7485212,'orm',11.111,1),(479,7485218,7485212,'rma',11.111,1),(479,7485219,7485212,'man',11.111,1),(479,7485220,7485212,'anc',11.111,1),(479,7485221,7485212,'nce',11.111,1),(479,7485222,7485213,'ide',12.5,1),(479,7485223,7485213,'den',12.5,1),(479,7485224,7485213,'ent',12.5,1),(479,7485225,7485213,'nti',12.5,1),(479,7485226,7485213,'tif',12.5,1),(479,7485227,7485213,'ifi',12.5,1),(479,7485228,7485213,'fie',12.5,1),(479,7485229,7485213,'ier',12.5,1),(479,7485230,7485222,'vdi',33.333,3),(479,7485231,7485222,'dis',33.333,3),(479,7485232,7485222,'isk',33.333,3),(479,7485233,7485230,'nam',50,1),(479,7485234,7485230,'ame',50,1),(479,7485235,7485233,'typ',50,1),(479,7485236,7485233,'ype',50,1),(479,7485237,7485235,'dir',25,1),(479,7485238,7485235,'ire',25,1),(479,7485239,7485235,'rec',25,1),(479,7485240,7485235,'ect',25,1),(480,7485242,7485241,'naa',100,2),(480,7485243,7485242,'600',3.333,3),(480,7485244,7485242,'000',3.333,3),(480,7485245,7485242,'00c',3.333,3),(480,7485246,7485242,'0c2',3.333,3),(480,7485247,7485242,'c29',3.333,3),(480,7485248,7485242,'296',3.333,3),(480,7485249,7485242,'967',3.333,3),(480,7485250,7485242,'67d',3.333,3),(480,7485251,7485242,'7dc',3.333,3),(480,7485252,7485242,'dc3',3.333,3),(480,7485253,7485242,'c3a',3.333,3),(480,7485254,7485242,'3ab',3.333,3),(480,7485255,7485242,'ab7',3.333,3),(480,7485256,7485242,'b79',3.333,3),(480,7485257,7485242,'79d',3.333,3),(480,7485258,7485242,'9d3',3.333,3),(480,7485259,7485242,'d33',3.333,3),(480,7485260,7485242,'33d',3.333,3),(480,7485261,7485242,'3dc',3.333,3),(480,7485262,7485242,'dc7',3.333,3),(480,7485263,7485242,'c79',3.333,3),(480,7485264,7485242,'793',3.333,3),(480,7485265,7485242,'93d',3.333,3),(480,7485266,7485242,'3d0',3.333,3),(480,7485267,7485242,'d03',3.333,3),(480,7485268,7485242,'037',3.333,3),(480,7485269,7485242,'379',3.333,3),(480,7485270,7485242,'79f',3.333,3),(480,7485271,7485242,'9fc',3.333,3),(480,7485272,7485242,'fc6',3.333,3),(480,7485273,7485243,'mon',100,1),(480,7485274,7485273,'201',50,1),(480,7485275,7485273,'013',50,1),(480,7485276,7485274,'adm',33.333,3),(480,7485277,7485274,'dmi',33.333,3),(480,7485278,7485274,'min',33.333,3),(480,7485279,7485276,'cap',16.667,1),(480,7485280,7485276,'apa',16.667,1),(480,7485281,7485276,'pac',16.667,1),(480,7485282,7485276,'aci',16.667,1),(480,7485283,7485276,'cit',16.667,1),(480,7485284,7485276,'ity',16.667,1),(480,7485285,7485279,'pat',50,1),(480,7485286,7485279,'ath',50,1),(480,7485287,7485285,'fre',14.286,1),(480,7485288,7485285,'ree',14.286,1),(480,7485289,7485285,'ees',14.286,1),(480,7485290,7485285,'esp',14.286,1),(480,7485291,7485285,'spa',14.286,1),(480,7485292,7485285,'pac',14.286,1),(480,7485293,7485285,'ace',14.286,1),(480,7485294,7485287,'dis',50,1),(480,7485295,7485287,'isk',50,1),(480,7485296,7485294,'ind',33.333,1),(480,7485297,7485294,'nde',33.333,1),(480,7485298,7485294,'dex',33.333,1),(480,7485299,7485296,'adm',8.333,1),(480,7485300,7485296,'dmi',8.333,1),(480,7485301,7485296,'min',8.333,1),(480,7485302,7485296,'ini',8.333,1),(480,7485303,7485296,'nis',8.333,1),(480,7485304,7485296,'ist',8.333,1),(480,7485305,7485296,'str',8.333,1),(480,7485306,7485296,'tra',8.333,1),(480,7485307,7485296,'rat',8.333,1),(480,7485308,7485296,'ati',8.333,1),(480,7485309,7485296,'tio',8.333,1),(480,7485310,7485296,'ion',8.333,1),(480,7485311,7485299,'sta',33.333,3),(480,7485312,7485299,'tat',33.333,3),(480,7485313,7485299,'ate',33.333,3),(480,7485314,7485311,'ena',20,2),(480,7485315,7485311,'nab',20,2),(480,7485316,7485311,'abl',20,2),(480,7485317,7485311,'ble',20,2),(480,7485318,7485311,'led',20,2),(480,7485319,7485314,'cac',33.333,2),(480,7485320,7485314,'ach',33.333,2),(480,7485321,7485314,'che',33.333,2),(480,7485322,7485319,'mod',50,1),(480,7485323,7485319,'ode',50,1),(480,7485324,7485322,'wri',14.286,1),(480,7485325,7485322,'rit',14.286,1),(480,7485326,7485322,'ite',14.286,1),(480,7485327,7485322,'tet',14.286,1),(480,7485328,7485322,'eth',14.286,1),(480,7485329,7485322,'thr',14.286,1),(480,7485330,7485322,'hru',14.286,1),(480,7485331,7485324,'ope',11.111,2),(480,7485332,7485324,'per',11.111,2),(480,7485333,7485324,'era',11.111,2),(480,7485334,7485324,'rat',11.111,2),(480,7485335,7485324,'ati',11.111,2),(480,7485336,7485324,'tio',11.111,2),(480,7485337,7485324,'ion',11.111,2),(480,7485338,7485324,'ona',11.111,2),(480,7485339,7485324,'nal',11.111,2),(480,7485340,7485331,'pen',20,1),(480,7485341,7485331,'end',20,1),(480,7485342,7485331,'ndi',20,1),(480,7485343,7485331,'din',20,1),(480,7485344,7485331,'ing',20,1),(480,7485345,7485340,'mes',20,1),(480,7485346,7485340,'ess',20,1),(480,7485347,7485340,'ssa',20,1),(480,7485348,7485340,'sag',20,1),(480,7485349,7485340,'age',20,1),(480,7485350,7485345,'wai',20,1),(480,7485351,7485345,'ait',20,1),(480,7485352,7485345,'iti',20,1),(480,7485353,7485345,'tin',20,1),(480,7485354,7485345,'ing',20,1),(480,7485355,7485350,'for',100,1),(480,7485356,7485355,'per',11.111,1),(480,7485357,7485355,'erf',11.111,1),(480,7485358,7485355,'rfo',11.111,1),(480,7485359,7485355,'for',11.111,1),(480,7485360,7485355,'orm',11.111,1),(480,7485361,7485355,'rma',11.111,1),(480,7485362,7485355,'man',11.111,1),(480,7485363,7485355,'anc',11.111,1),(480,7485364,7485355,'nce',11.111,1),(480,7485365,7485356,'ide',12.5,1),(480,7485366,7485356,'den',12.5,1),(480,7485367,7485356,'ent',12.5,1),(480,7485368,7485356,'nti',12.5,1),(480,7485369,7485356,'tif',12.5,1),(480,7485370,7485356,'ifi',12.5,1),(480,7485371,7485356,'fie',12.5,1),(480,7485372,7485356,'ier',12.5,1),(480,7485373,7485365,'vdi',33.333,3),(480,7485374,7485365,'dis',33.333,3),(480,7485375,7485365,'isk',33.333,3),(480,7485376,7485373,'nam',50,1),(480,7485377,7485373,'ame',50,1),(480,7485378,7485376,'typ',50,1),(480,7485379,7485376,'ype',50,1),(480,7485380,7485378,'dir',25,1),(480,7485381,7485378,'ire',25,1),(480,7485382,7485378,'rec',25,1),(480,7485383,7485378,'ect',25,1),(481,7485385,7485384,'naa',100,2),(481,7485386,7485385,'600',3.333,3),(481,7485387,7485385,'000',3.333,3),(481,7485388,7485385,'00c',3.333,3),(481,7485389,7485385,'0c2',3.333,3),(481,7485390,7485385,'c29',3.333,3),(481,7485391,7485385,'295',3.333,3),(481,7485392,7485385,'95c',3.333,3),(481,7485393,7485385,'5c8',3.333,3),(481,7485394,7485385,'c86',3.333,3),(481,7485395,7485385,'862',3.333,3),(481,7485396,7485385,'622',3.333,3),(481,7485397,7485385,'222',3.333,3),(481,7485398,7485385,'22f',3.333,3),(481,7485399,7485385,'2f4',3.333,3),(481,7485400,7485385,'f42',3.333,3),(481,7485401,7485385,'426',3.333,3),(481,7485402,7485385,'260',3.333,3),(481,7485403,7485385,'604',3.333,3),(481,7485404,7485385,'042',3.333,3),(481,7485405,7485385,'427',3.333,3),(481,7485406,7485385,'27b',3.333,3),(481,7485407,7485385,'7b7',3.333,3),(481,7485408,7485385,'b7b',3.333,3),(481,7485409,7485385,'7b7',3.333,3),(481,7485410,7485385,'b75',3.333,3),(481,7485411,7485385,'752',3.333,3),(481,7485412,7485385,'521',3.333,3),(481,7485413,7485385,'214',3.333,3),(481,7485414,7485385,'14f',3.333,3),(481,7485415,7485385,'4fd',3.333,3),(481,7485416,7485386,'mon',100,1),(481,7485417,7485416,'201',50,1),(481,7485418,7485416,'013',50,1),(481,7485419,7485417,'adm',33.333,3),(481,7485420,7485417,'dmi',33.333,3),(481,7485421,7485417,'min',33.333,3),(481,7485422,7485419,'cap',16.667,1),(481,7485423,7485419,'apa',16.667,1),(481,7485424,7485419,'pac',16.667,1),(481,7485425,7485419,'aci',16.667,1),(481,7485426,7485419,'cit',16.667,1),(481,7485427,7485419,'ity',16.667,1),(481,7485428,7485422,'pat',50,1),(481,7485429,7485422,'ath',50,1),(481,7485430,7485428,'fre',14.286,1),(481,7485431,7485428,'ree',14.286,1),(481,7485432,7485428,'ees',14.286,1),(481,7485433,7485428,'esp',14.286,1),(481,7485434,7485428,'spa',14.286,1),(481,7485435,7485428,'pac',14.286,1),(481,7485436,7485428,'ace',14.286,1),(481,7485437,7485430,'dis',50,1),(481,7485438,7485430,'isk',50,1),(481,7485439,7485437,'ind',33.333,1),(481,7485440,7485437,'nde',33.333,1),(481,7485441,7485437,'dex',33.333,1),(481,7485442,7485439,'adm',8.333,1),(481,7485443,7485439,'dmi',8.333,1),(481,7485444,7485439,'min',8.333,1),(481,7485445,7485439,'ini',8.333,1),(481,7485446,7485439,'nis',8.333,1),(481,7485447,7485439,'ist',8.333,1),(481,7485448,7485439,'str',8.333,1),(481,7485449,7485439,'tra',8.333,1),(481,7485450,7485439,'rat',8.333,1),(481,7485451,7485439,'ati',8.333,1),(481,7485452,7485439,'tio',8.333,1),(481,7485453,7485439,'ion',8.333,1),(481,7485454,7485442,'sta',33.333,3),(481,7485455,7485442,'tat',33.333,3),(481,7485456,7485442,'ate',33.333,3),(481,7485457,7485454,'ena',20,2),(481,7485458,7485454,'nab',20,2),(481,7485459,7485454,'abl',20,2),(481,7485460,7485454,'ble',20,2),(481,7485461,7485454,'led',20,2),(481,7485462,7485457,'cac',33.333,2),(481,7485463,7485457,'ach',33.333,2),(481,7485464,7485457,'che',33.333,2),(481,7485465,7485462,'mod',50,1),(481,7485466,7485462,'ode',50,1),(481,7485467,7485465,'wri',14.286,1),(481,7485468,7485465,'rit',14.286,1),(481,7485469,7485465,'ite',14.286,1),(481,7485470,7485465,'tet',14.286,1),(481,7485471,7485465,'eth',14.286,1),(481,7485472,7485465,'thr',14.286,1),(481,7485473,7485465,'hru',14.286,1),(481,7485474,7485467,'ope',11.111,2),(481,7485475,7485467,'per',11.111,2),(481,7485476,7485467,'era',11.111,2),(481,7485477,7485467,'rat',11.111,2),(481,7485478,7485467,'ati',11.111,2),(481,7485479,7485467,'tio',11.111,2),(481,7485480,7485467,'ion',11.111,2),(481,7485481,7485467,'ona',11.111,2),(481,7485482,7485467,'nal',11.111,2),(481,7485483,7485474,'pen',20,1),(481,7485484,7485474,'end',20,1),(481,7485485,7485474,'ndi',20,1),(481,7485486,7485474,'din',20,1),(481,7485487,7485474,'ing',20,1),(481,7485488,7485483,'mes',20,1),(481,7485489,7485483,'ess',20,1),(481,7485490,7485483,'ssa',20,1),(481,7485491,7485483,'sag',20,1),(481,7485492,7485483,'age',20,1),(481,7485493,7485488,'wai',20,1),(481,7485494,7485488,'ait',20,1),(481,7485495,7485488,'iti',20,1),(481,7485496,7485488,'tin',20,1),(481,7485497,7485488,'ing',20,1),(481,7485498,7485493,'for',100,1),(481,7485499,7485498,'per',11.111,1),(481,7485500,7485498,'erf',11.111,1),(481,7485501,7485498,'rfo',11.111,1),(481,7485502,7485498,'for',11.111,1),(481,7485503,7485498,'orm',11.111,1),(481,7485504,7485498,'rma',11.111,1),(481,7485505,7485498,'man',11.111,1),(481,7485506,7485498,'anc',11.111,1),(481,7485507,7485498,'nce',11.111,1),(481,7485508,7485499,'ide',12.5,1),(481,7485509,7485499,'den',12.5,1),(481,7485510,7485499,'ent',12.5,1),(481,7485511,7485499,'nti',12.5,1),(481,7485512,7485499,'tif',12.5,1),(481,7485513,7485499,'ifi',12.5,1),(481,7485514,7485499,'fie',12.5,1),(481,7485515,7485499,'ier',12.5,1),(481,7485516,7485508,'vdi',33.333,3),(481,7485517,7485508,'dis',33.333,3),(481,7485518,7485508,'isk',33.333,3),(481,7485519,7485516,'nam',50,1),(481,7485520,7485516,'ame',50,1),(481,7485521,7485519,'typ',50,1),(481,7485522,7485519,'ype',50,1),(481,7485523,7485521,'dir',25,1),(481,7485524,7485521,'ire',25,1),(481,7485525,7485521,'rec',25,1),(481,7485526,7485521,'ect',25,1),(482,7485528,7485527,'naa',100,2),(482,7485529,7485528,'600',3.333,3),(482,7485530,7485528,'000',3.333,3),(482,7485531,7485528,'00c',3.333,3),(482,7485532,7485528,'0c2',3.333,3),(482,7485533,7485528,'c29',3.333,3),(482,7485534,7485528,'29b',3.333,3),(482,7485535,7485528,'9b1',3.333,3),(482,7485536,7485528,'b14',3.333,3),(482,7485537,7485528,'14f',3.333,3),(482,7485538,7485528,'4ff',3.333,3),(482,7485539,7485528,'ffb',3.333,3),(482,7485540,7485528,'fb8',3.333,3),(482,7485541,7485528,'b86',3.333,3),(482,7485542,7485528,'866',3.333,3),(482,7485543,7485528,'666',3.333,3),(482,7485544,7485528,'669',3.333,3),(482,7485545,7485528,'697',3.333,3),(482,7485546,7485528,'976',3.333,3),(482,7485547,7485528,'769',3.333,3),(482,7485548,7485528,'691',3.333,3),(482,7485549,7485528,'915',3.333,3),(482,7485550,7485528,'15f',3.333,3),(482,7485551,7485528,'5fe',3.333,3),(482,7485552,7485528,'fed',3.333,3),(482,7485553,7485528,'ed3',3.333,3),(482,7485554,7485528,'d34',3.333,3),(482,7485555,7485528,'342',3.333,3),(482,7485556,7485528,'421',3.333,3),(482,7485557,7485528,'21d',3.333,3),(482,7485558,7485528,'1d9',3.333,3),(482,7485559,7485529,'mon',100,1),(482,7485560,7485559,'201',50,1),(482,7485561,7485559,'013',50,1),(482,7485562,7485560,'adm',33.333,3),(482,7485563,7485560,'dmi',33.333,3),(482,7485564,7485560,'min',33.333,3),(482,7485565,7485562,'cap',16.667,1),(482,7485566,7485562,'apa',16.667,1),(482,7485567,7485562,'pac',16.667,1),(482,7485568,7485562,'aci',16.667,1),(482,7485569,7485562,'cit',16.667,1),(482,7485570,7485562,'ity',16.667,1),(482,7485571,7485565,'pat',50,1),(482,7485572,7485565,'ath',50,1),(482,7485573,7485571,'fre',14.286,1),(482,7485574,7485571,'ree',14.286,1),(482,7485575,7485571,'ees',14.286,1),(482,7485576,7485571,'esp',14.286,1),(482,7485577,7485571,'spa',14.286,1),(482,7485578,7485571,'pac',14.286,1),(482,7485579,7485571,'ace',14.286,1),(482,7485580,7485573,'dis',50,1),(482,7485581,7485573,'isk',50,1),(482,7485582,7485580,'ind',33.333,1),(482,7485583,7485580,'nde',33.333,1),(482,7485584,7485580,'dex',33.333,1),(482,7485585,7485582,'adm',8.333,1),(482,7485586,7485582,'dmi',8.333,1),(482,7485587,7485582,'min',8.333,1),(482,7485588,7485582,'ini',8.333,1),(482,7485589,7485582,'nis',8.333,1),(482,7485590,7485582,'ist',8.333,1),(482,7485591,7485582,'str',8.333,1),(482,7485592,7485582,'tra',8.333,1),(482,7485593,7485582,'rat',8.333,1),(482,7485594,7485582,'ati',8.333,1),(482,7485595,7485582,'tio',8.333,1),(482,7485596,7485582,'ion',8.333,1),(482,7485597,7485585,'sta',33.333,3),(482,7485598,7485585,'tat',33.333,3),(482,7485599,7485585,'ate',33.333,3),(482,7485600,7485597,'ena',20,2),(482,7485601,7485597,'nab',20,2),(482,7485602,7485597,'abl',20,2),(482,7485603,7485597,'ble',20,2),(482,7485604,7485597,'led',20,2),(482,7485605,7485600,'cac',33.333,2),(482,7485606,7485600,'ach',33.333,2),(482,7485607,7485600,'che',33.333,2),(482,7485608,7485605,'mod',50,1),(482,7485609,7485605,'ode',50,1),(482,7485610,7485608,'wri',14.286,1),(482,7485611,7485608,'rit',14.286,1),(482,7485612,7485608,'ite',14.286,1),(482,7485613,7485608,'tet',14.286,1),(482,7485614,7485608,'eth',14.286,1),(482,7485615,7485608,'thr',14.286,1),(482,7485616,7485608,'hru',14.286,1),(482,7485617,7485610,'ope',11.111,2),(482,7485618,7485610,'per',11.111,2),(482,7485619,7485610,'era',11.111,2),(482,7485620,7485610,'rat',11.111,2),(482,7485621,7485610,'ati',11.111,2),(482,7485622,7485610,'tio',11.111,2),(482,7485623,7485610,'ion',11.111,2),(482,7485624,7485610,'ona',11.111,2),(482,7485625,7485610,'nal',11.111,2),(482,7485626,7485617,'pen',20,1),(482,7485627,7485617,'end',20,1),(482,7485628,7485617,'ndi',20,1),(482,7485629,7485617,'din',20,1),(482,7485630,7485617,'ing',20,1),(482,7485631,7485626,'mes',20,1),(482,7485632,7485626,'ess',20,1),(482,7485633,7485626,'ssa',20,1),(482,7485634,7485626,'sag',20,1),(482,7485635,7485626,'age',20,1),(482,7485636,7485631,'wai',20,1),(482,7485637,7485631,'ait',20,1),(482,7485638,7485631,'iti',20,1),(482,7485639,7485631,'tin',20,1),(482,7485640,7485631,'ing',20,1),(482,7485641,7485636,'for',100,1),(482,7485642,7485641,'per',11.111,1),(482,7485643,7485641,'erf',11.111,1),(482,7485644,7485641,'rfo',11.111,1),(482,7485645,7485641,'for',11.111,1),(482,7485646,7485641,'orm',11.111,1),(482,7485647,7485641,'rma',11.111,1),(482,7485648,7485641,'man',11.111,1),(482,7485649,7485641,'anc',11.111,1),(482,7485650,7485641,'nce',11.111,1),(482,7485651,7485642,'ide',12.5,1),(482,7485652,7485642,'den',12.5,1),(482,7485653,7485642,'ent',12.5,1),(482,7485654,7485642,'nti',12.5,1),(482,7485655,7485642,'tif',12.5,1),(482,7485656,7485642,'ifi',12.5,1),(482,7485657,7485642,'fie',12.5,1),(482,7485658,7485642,'ier',12.5,1),(482,7485659,7485651,'vdi',33.333,3),(482,7485660,7485651,'dis',33.333,3),(482,7485661,7485651,'isk',33.333,3),(482,7485662,7485659,'nam',50,1),(482,7485663,7485659,'ame',50,1),(482,7485664,7485662,'typ',50,1),(482,7485665,7485662,'ype',50,1),(482,7485666,7485664,'dir',25,1),(482,7485667,7485664,'ire',25,1),(482,7485668,7485664,'rec',25,1),(482,7485669,7485664,'ect',25,1),(483,7485671,7485670,'naa',100,2),(483,7485672,7485671,'600',3.333,3),(483,7485673,7485671,'000',3.333,3),(483,7485674,7485671,'00c',3.333,3),(483,7485675,7485671,'0c2',3.333,3),(483,7485676,7485671,'c29',3.333,3),(483,7485677,7485671,'293',3.333,3),(483,7485678,7485671,'93f',3.333,3),(483,7485679,7485671,'3f3',3.333,3),(483,7485680,7485671,'f3c',3.333,3),(483,7485681,7485671,'3ce',3.333,3),(483,7485682,7485671,'cea',3.333,3),(483,7485683,7485671,'ead',3.333,3),(483,7485684,7485671,'ad6',3.333,3),(483,7485685,7485671,'d67',3.333,3),(483,7485686,7485671,'675',3.333,3),(483,7485687,7485671,'75c',3.333,3),(483,7485688,7485671,'5c0',3.333,3),(483,7485689,7485671,'c0b',3.333,3),(483,7485690,7485671,'0b6',3.333,3),(483,7485691,7485671,'b69',3.333,3),(483,7485692,7485671,'694',3.333,3),(483,7485693,7485671,'945',3.333,3),(483,7485694,7485671,'45c',3.333,3),(483,7485695,7485671,'5c6',3.333,3),(483,7485696,7485671,'c6f',3.333,3),(483,7485697,7485671,'6f8',3.333,3),(483,7485698,7485671,'f8b',3.333,3),(483,7485699,7485671,'8b7',3.333,3),(483,7485700,7485671,'b7a',3.333,3),(483,7485701,7485671,'7a1',3.333,3),(483,7485702,7485672,'mon',100,1),(483,7485703,7485702,'201',50,1),(483,7485704,7485702,'013',50,1),(483,7485705,7485703,'adm',33.333,3),(483,7485706,7485703,'dmi',33.333,3),(483,7485707,7485703,'min',33.333,3),(483,7485708,7485705,'cap',16.667,1),(483,7485709,7485705,'apa',16.667,1),(483,7485710,7485705,'pac',16.667,1),(483,7485711,7485705,'aci',16.667,1),(483,7485712,7485705,'cit',16.667,1),(483,7485713,7485705,'ity',16.667,1),(483,7485714,7485708,'pat',50,1),(483,7485715,7485708,'ath',50,1),(483,7485716,7485714,'fre',14.286,1),(483,7485717,7485714,'ree',14.286,1),(483,7485718,7485714,'ees',14.286,1),(483,7485719,7485714,'esp',14.286,1),(483,7485720,7485714,'spa',14.286,1),(483,7485721,7485714,'pac',14.286,1),(483,7485722,7485714,'ace',14.286,1),(483,7485723,7485716,'dis',50,1),(483,7485724,7485716,'isk',50,1),(483,7485725,7485723,'ind',33.333,1),(483,7485726,7485723,'nde',33.333,1),(483,7485727,7485723,'dex',33.333,1),(483,7485728,7485725,'adm',8.333,1),(483,7485729,7485725,'dmi',8.333,1),(483,7485730,7485725,'min',8.333,1),(483,7485731,7485725,'ini',8.333,1),(483,7485732,7485725,'nis',8.333,1),(483,7485733,7485725,'ist',8.333,1),(483,7485734,7485725,'str',8.333,1),(483,7485735,7485725,'tra',8.333,1),(483,7485736,7485725,'rat',8.333,1),(483,7485737,7485725,'ati',8.333,1),(483,7485738,7485725,'tio',8.333,1),(483,7485739,7485725,'ion',8.333,1),(483,7485740,7485728,'sta',33.333,3),(483,7485741,7485728,'tat',33.333,3),(483,7485742,7485728,'ate',33.333,3),(483,7485743,7485740,'ena',20,2),(483,7485744,7485740,'nab',20,2),(483,7485745,7485740,'abl',20,2),(483,7485746,7485740,'ble',20,2),(483,7485747,7485740,'led',20,2),(483,7485748,7485743,'cac',33.333,2),(483,7485749,7485743,'ach',33.333,2),(483,7485750,7485743,'che',33.333,2),(483,7485751,7485748,'mod',50,1),(483,7485752,7485748,'ode',50,1),(483,7485753,7485751,'wri',14.286,1),(483,7485754,7485751,'rit',14.286,1),(483,7485755,7485751,'ite',14.286,1),(483,7485756,7485751,'tet',14.286,1),(483,7485757,7485751,'eth',14.286,1),(483,7485758,7485751,'thr',14.286,1),(483,7485759,7485751,'hru',14.286,1),(483,7485760,7485753,'ope',11.111,2),(483,7485761,7485753,'per',11.111,2),(483,7485762,7485753,'era',11.111,2),(483,7485763,7485753,'rat',11.111,2),(483,7485764,7485753,'ati',11.111,2),(483,7485765,7485753,'tio',11.111,2),(483,7485766,7485753,'ion',11.111,2),(483,7485767,7485753,'ona',11.111,2),(483,7485768,7485753,'nal',11.111,2),(483,7485769,7485760,'pen',20,1),(483,7485770,7485760,'end',20,1),(483,7485771,7485760,'ndi',20,1),(483,7485772,7485760,'din',20,1),(483,7485773,7485760,'ing',20,1),(483,7485774,7485769,'mes',20,1),(483,7485775,7485769,'ess',20,1),(483,7485776,7485769,'ssa',20,1),(483,7485777,7485769,'sag',20,1),(483,7485778,7485769,'age',20,1),(483,7485779,7485774,'wai',20,1),(483,7485780,7485774,'ait',20,1),(483,7485781,7485774,'iti',20,1),(483,7485782,7485774,'tin',20,1),(483,7485783,7485774,'ing',20,1),(483,7485784,7485779,'for',100,1),(483,7485785,7485784,'per',11.111,1),(483,7485786,7485784,'erf',11.111,1),(483,7485787,7485784,'rfo',11.111,1),(483,7485788,7485784,'for',11.111,1),(483,7485789,7485784,'orm',11.111,1),(483,7485790,7485784,'rma',11.111,1),(483,7485791,7485784,'man',11.111,1),(483,7485792,7485784,'anc',11.111,1),(483,7485793,7485784,'nce',11.111,1),(483,7485794,7485785,'ide',12.5,1),(483,7485795,7485785,'den',12.5,1),(483,7485796,7485785,'ent',12.5,1),(483,7485797,7485785,'nti',12.5,1),(483,7485798,7485785,'tif',12.5,1),(483,7485799,7485785,'ifi',12.5,1),(483,7485800,7485785,'fie',12.5,1),(483,7485801,7485785,'ier',12.5,1),(483,7485802,7485794,'vdi',33.333,3),(483,7485803,7485794,'dis',33.333,3),(483,7485804,7485794,'isk',33.333,3),(483,7485805,7485802,'nam',50,1),(483,7485806,7485802,'ame',50,1),(483,7485807,7485805,'typ',50,1),(483,7485808,7485805,'ype',50,1),(483,7485809,7485807,'dir',25,1),(483,7485810,7485807,'ire',25,1),(483,7485811,7485807,'rec',25,1),(483,7485812,7485807,'ect',25,1),(484,7485814,7485813,'naa',100,2),(484,7485815,7485814,'600',3.333,3),(484,7485816,7485814,'000',3.333,3),(484,7485817,7485814,'00c',3.333,3),(484,7485818,7485814,'0c2',3.333,3),(484,7485819,7485814,'c29',3.333,3),(484,7485820,7485814,'297',3.333,3),(484,7485821,7485814,'97d',3.333,3),(484,7485822,7485814,'7db',3.333,3),(484,7485823,7485814,'db8',3.333,3),(484,7485824,7485814,'b85',3.333,3),(484,7485825,7485814,'857',3.333,3),(484,7485826,7485814,'572',3.333,3),(484,7485827,7485814,'72f',3.333,3),(484,7485828,7485814,'2f2',3.333,3),(484,7485829,7485814,'f20',3.333,3),(484,7485830,7485814,'20f',3.333,3),(484,7485831,7485814,'0fe',3.333,3),(484,7485832,7485814,'fe1',3.333,3),(484,7485833,7485814,'e1b',3.333,3),(484,7485834,7485814,'1b8',3.333,3),(484,7485835,7485814,'b87',3.333,3),(484,7485836,7485814,'87b',3.333,3),(484,7485837,7485814,'7b0',3.333,3),(484,7485838,7485814,'b09',3.333,3),(484,7485839,7485814,'09b',3.333,3),(484,7485840,7485814,'9b0',3.333,3),(484,7485841,7485814,'b0e',3.333,3),(484,7485842,7485814,'0ea',3.333,3),(484,7485843,7485814,'ea2',3.333,3),(484,7485844,7485814,'a2e',3.333,3),(484,7485845,7485815,'mon',100,1),(484,7485846,7485845,'201',50,1),(484,7485847,7485845,'013',50,1),(484,7485848,7485846,'adm',33.333,3),(484,7485849,7485846,'dmi',33.333,3),(484,7485850,7485846,'min',33.333,3),(484,7485851,7485848,'cap',16.667,1),(484,7485852,7485848,'apa',16.667,1),(484,7485853,7485848,'pac',16.667,1),(484,7485854,7485848,'aci',16.667,1),(484,7485855,7485848,'cit',16.667,1),(484,7485856,7485848,'ity',16.667,1),(484,7485857,7485851,'pat',50,1),(484,7485858,7485851,'ath',50,1),(484,7485859,7485857,'fre',14.286,1),(484,7485860,7485857,'ree',14.286,1),(484,7485861,7485857,'ees',14.286,1),(484,7485862,7485857,'esp',14.286,1),(484,7485863,7485857,'spa',14.286,1),(484,7485864,7485857,'pac',14.286,1),(484,7485865,7485857,'ace',14.286,1),(484,7485866,7485859,'dis',50,1),(484,7485867,7485859,'isk',50,1),(484,7485868,7485866,'ind',33.333,1),(484,7485869,7485866,'nde',33.333,1),(484,7485870,7485866,'dex',33.333,1),(484,7485871,7485868,'adm',8.333,1),(484,7485872,7485868,'dmi',8.333,1),(484,7485873,7485868,'min',8.333,1),(484,7485874,7485868,'ini',8.333,1),(484,7485875,7485868,'nis',8.333,1),(484,7485876,7485868,'ist',8.333,1),(484,7485877,7485868,'str',8.333,1),(484,7485878,7485868,'tra',8.333,1),(484,7485879,7485868,'rat',8.333,1),(484,7485880,7485868,'ati',8.333,1),(484,7485881,7485868,'tio',8.333,1),(484,7485882,7485868,'ion',8.333,1),(484,7485883,7485871,'sta',33.333,3),(484,7485884,7485871,'tat',33.333,3),(484,7485885,7485871,'ate',33.333,3),(484,7485886,7485883,'ena',20,2),(484,7485887,7485883,'nab',20,2),(484,7485888,7485883,'abl',20,2),(484,7485889,7485883,'ble',20,2),(484,7485890,7485883,'led',20,2),(484,7485891,7485886,'cac',33.333,2),(484,7485892,7485886,'ach',33.333,2),(484,7485893,7485886,'che',33.333,2),(484,7485894,7485891,'mod',50,1),(484,7485895,7485891,'ode',50,1),(484,7485896,7485894,'wri',14.286,1),(484,7485897,7485894,'rit',14.286,1),(484,7485898,7485894,'ite',14.286,1),(484,7485899,7485894,'tet',14.286,1),(484,7485900,7485894,'eth',14.286,1),(484,7485901,7485894,'thr',14.286,1),(484,7485902,7485894,'hru',14.286,1),(484,7485903,7485896,'ope',11.111,2),(484,7485904,7485896,'per',11.111,2),(484,7485905,7485896,'era',11.111,2),(484,7485906,7485896,'rat',11.111,2),(484,7485907,7485896,'ati',11.111,2),(484,7485908,7485896,'tio',11.111,2),(484,7485909,7485896,'ion',11.111,2),(484,7485910,7485896,'ona',11.111,2),(484,7485911,7485896,'nal',11.111,2),(484,7485912,7485903,'pen',20,1),(484,7485913,7485903,'end',20,1),(484,7485914,7485903,'ndi',20,1),(484,7485915,7485903,'din',20,1),(484,7485916,7485903,'ing',20,1),(484,7485917,7485912,'mes',20,1),(484,7485918,7485912,'ess',20,1),(484,7485919,7485912,'ssa',20,1),(484,7485920,7485912,'sag',20,1),(484,7485921,7485912,'age',20,1),(484,7485922,7485917,'wai',20,1),(484,7485923,7485917,'ait',20,1),(484,7485924,7485917,'iti',20,1),(484,7485925,7485917,'tin',20,1),(484,7485926,7485917,'ing',20,1),(484,7485927,7485922,'for',100,1),(484,7485928,7485927,'per',11.111,1),(484,7485929,7485927,'erf',11.111,1),(484,7485930,7485927,'rfo',11.111,1),(484,7485931,7485927,'for',11.111,1),(484,7485932,7485927,'orm',11.111,1),(484,7485933,7485927,'rma',11.111,1),(484,7485934,7485927,'man',11.111,1),(484,7485935,7485927,'anc',11.111,1),(484,7485936,7485927,'nce',11.111,1),(484,7485937,7485928,'ide',12.5,1),(484,7485938,7485928,'den',12.5,1),(484,7485939,7485928,'ent',12.5,1),(484,7485940,7485928,'nti',12.5,1),(484,7485941,7485928,'tif',12.5,1),(484,7485942,7485928,'ifi',12.5,1),(484,7485943,7485928,'fie',12.5,1),(484,7485944,7485928,'ier',12.5,1),(484,7485945,7485937,'vdi',33.333,3),(484,7485946,7485937,'dis',33.333,3),(484,7485947,7485937,'isk',33.333,3),(484,7485948,7485945,'nam',50,1),(484,7485949,7485945,'ame',50,1),(484,7485950,7485948,'typ',50,1),(484,7485951,7485948,'ype',50,1),(484,7485952,7485950,'dir',25,1),(484,7485953,7485950,'ire',25,1),(484,7485954,7485950,'rec',25,1),(484,7485955,7485950,'ect',25,1),(485,7485957,7485956,'naa',100,2),(485,7485958,7485957,'600',3.333,3),(485,7485959,7485957,'000',3.333,3),(485,7485960,7485957,'00c',3.333,3),(485,7485961,7485957,'0c2',3.333,3),(485,7485962,7485957,'c29',3.333,3),(485,7485963,7485957,'29a',3.333,3),(485,7485964,7485957,'9a1',3.333,3),(485,7485965,7485957,'a1b',3.333,3),(485,7485966,7485957,'1b2',3.333,3),(485,7485967,7485957,'b25',3.333,3),(485,7485968,7485957,'256',3.333,3),(485,7485969,7485957,'56e',3.333,3),(485,7485970,7485957,'6ef',3.333,3),(485,7485971,7485957,'ef4',3.333,3),(485,7485972,7485957,'f44',3.333,3),(485,7485973,7485957,'440',3.333,3),(485,7485974,7485957,'400',3.333,3),(485,7485975,7485957,'000',3.333,3),(485,7485976,7485957,'00e',3.333,3),(485,7485977,7485957,'0e6',3.333,3),(485,7485978,7485957,'e6c',3.333,3),(485,7485979,7485957,'6c4',3.333,3),(485,7485980,7485957,'c4e',3.333,3),(485,7485981,7485957,'4ed',3.333,3),(485,7485982,7485957,'edc',3.333,3),(485,7485983,7485957,'dc9',3.333,3),(485,7485984,7485957,'c94',3.333,3),(485,7485985,7485957,'94e',3.333,3),(485,7485986,7485957,'4e6',3.333,3),(485,7485987,7485957,'e65',3.333,3),(485,7485988,7485958,'mon',100,1),(485,7485989,7485988,'201',50,1),(485,7485990,7485988,'013',50,1),(485,7485991,7485989,'adm',33.333,3),(485,7485992,7485989,'dmi',33.333,3),(485,7485993,7485989,'min',33.333,3),(485,7485994,7485991,'cap',16.667,1),(485,7485995,7485991,'apa',16.667,1),(485,7485996,7485991,'pac',16.667,1),(485,7485997,7485991,'aci',16.667,1),(485,7485998,7485991,'cit',16.667,1),(485,7485999,7485991,'ity',16.667,1),(485,7486000,7485994,'pat',50,1),(485,7486001,7485994,'ath',50,1),(485,7486002,7486000,'fre',14.286,1),(485,7486003,7486000,'ree',14.286,1),(485,7486004,7486000,'ees',14.286,1),(485,7486005,7486000,'esp',14.286,1),(485,7486006,7486000,'spa',14.286,1),(485,7486007,7486000,'pac',14.286,1),(485,7486008,7486000,'ace',14.286,1),(485,7486009,7486002,'dis',50,1),(485,7486010,7486002,'isk',50,1),(485,7486011,7486009,'ind',33.333,1),(485,7486012,7486009,'nde',33.333,1),(485,7486013,7486009,'dex',33.333,1),(485,7486014,7486011,'adm',8.333,1),(485,7486015,7486011,'dmi',8.333,1),(485,7486016,7486011,'min',8.333,1),(485,7486017,7486011,'ini',8.333,1),(485,7486018,7486011,'nis',8.333,1),(485,7486019,7486011,'ist',8.333,1),(485,7486020,7486011,'str',8.333,1),(485,7486021,7486011,'tra',8.333,1),(485,7486022,7486011,'rat',8.333,1),(485,7486023,7486011,'ati',8.333,1),(485,7486024,7486011,'tio',8.333,1),(485,7486025,7486011,'ion',8.333,1),(485,7486026,7486014,'sta',33.333,3),(485,7486027,7486014,'tat',33.333,3),(485,7486028,7486014,'ate',33.333,3),(485,7486029,7486026,'ena',20,2),(485,7486030,7486026,'nab',20,2),(485,7486031,7486026,'abl',20,2),(485,7486032,7486026,'ble',20,2),(485,7486033,7486026,'led',20,2),(485,7486034,7486029,'cac',33.333,2),(485,7486035,7486029,'ach',33.333,2),(485,7486036,7486029,'che',33.333,2),(485,7486037,7486034,'mod',50,1),(485,7486038,7486034,'ode',50,1),(485,7486039,7486037,'wri',14.286,1),(485,7486040,7486037,'rit',14.286,1),(485,7486041,7486037,'ite',14.286,1),(485,7486042,7486037,'tet',14.286,1),(485,7486043,7486037,'eth',14.286,1),(485,7486044,7486037,'thr',14.286,1),(485,7486045,7486037,'hru',14.286,1),(485,7486046,7486039,'ope',11.111,2),(485,7486047,7486039,'per',11.111,2),(485,7486048,7486039,'era',11.111,2),(485,7486049,7486039,'rat',11.111,2),(485,7486050,7486039,'ati',11.111,2),(485,7486051,7486039,'tio',11.111,2),(485,7486052,7486039,'ion',11.111,2),(485,7486053,7486039,'ona',11.111,2),(485,7486054,7486039,'nal',11.111,2),(485,7486055,7486046,'pen',20,1),(485,7486056,7486046,'end',20,1),(485,7486057,7486046,'ndi',20,1),(485,7486058,7486046,'din',20,1),(485,7486059,7486046,'ing',20,1),(485,7486060,7486055,'mes',20,1),(485,7486061,7486055,'ess',20,1),(485,7486062,7486055,'ssa',20,1),(485,7486063,7486055,'sag',20,1),(485,7486064,7486055,'age',20,1),(485,7486065,7486060,'wai',20,1),(485,7486066,7486060,'ait',20,1),(485,7486067,7486060,'iti',20,1),(485,7486068,7486060,'tin',20,1),(485,7486069,7486060,'ing',20,1),(485,7486070,7486065,'for',100,1),(485,7486071,7486070,'per',11.111,1),(485,7486072,7486070,'erf',11.111,1),(485,7486073,7486070,'rfo',11.111,1),(485,7486074,7486070,'for',11.111,1),(485,7486075,7486070,'orm',11.111,1),(485,7486076,7486070,'rma',11.111,1),(485,7486077,7486070,'man',11.111,1),(485,7486078,7486070,'anc',11.111,1),(485,7486079,7486070,'nce',11.111,1),(485,7486080,7486071,'ide',12.5,1),(485,7486081,7486071,'den',12.5,1),(485,7486082,7486071,'ent',12.5,1),(485,7486083,7486071,'nti',12.5,1),(485,7486084,7486071,'tif',12.5,1),(485,7486085,7486071,'ifi',12.5,1),(485,7486086,7486071,'fie',12.5,1),(485,7486087,7486071,'ier',12.5,1),(485,7486088,7486080,'vdi',33.333,3),(485,7486089,7486080,'dis',33.333,3),(485,7486090,7486080,'isk',33.333,3),(485,7486091,7486088,'nam',50,1),(485,7486092,7486088,'ame',50,1),(485,7486093,7486091,'typ',50,1),(485,7486094,7486091,'ype',50,1),(485,7486095,7486093,'dir',25,1),(485,7486096,7486093,'ire',25,1),(485,7486097,7486093,'rec',25,1),(485,7486098,7486093,'ect',25,1),(486,7486100,7486099,'naa',100,2),(486,7486101,7486100,'600',3.333,3),(486,7486102,7486100,'000',3.333,3),(486,7486103,7486100,'00c',3.333,3),(486,7486104,7486100,'0c2',3.333,3),(486,7486105,7486100,'c29',3.333,3),(486,7486106,7486100,'29b',3.333,3),(486,7486107,7486100,'9b1',3.333,3),(486,7486108,7486100,'b1a',3.333,3),(486,7486109,7486100,'1ab',3.333,3),(486,7486110,7486100,'ab4',3.333,3),(486,7486111,7486100,'b45',3.333,3),(486,7486112,7486100,'452',3.333,3),(486,7486113,7486100,'52b',3.333,3),(486,7486114,7486100,'2b7',3.333,3),(486,7486115,7486100,'b7b',3.333,3),(486,7486116,7486100,'7bc',3.333,3),(486,7486117,7486100,'bca',3.333,3),(486,7486118,7486100,'caf',3.333,3),(486,7486119,7486100,'af1',3.333,3),(486,7486120,7486100,'f12',3.333,3),(486,7486121,7486100,'124',3.333,3),(486,7486122,7486100,'24f',3.333,3),(486,7486123,7486100,'4fa',3.333,3),(486,7486124,7486100,'faf',3.333,3),(486,7486125,7486100,'afc',3.333,3),(486,7486126,7486100,'fc1',3.333,3),(486,7486127,7486100,'c17',3.333,3),(486,7486128,7486100,'178',3.333,3),(486,7486129,7486100,'78d',3.333,3),(486,7486130,7486100,'8d9',3.333,3),(486,7486131,7486101,'mon',100,1),(486,7486132,7486131,'201',50,1),(486,7486133,7486131,'013',50,1),(486,7486134,7486132,'adm',33.333,3),(486,7486135,7486132,'dmi',33.333,3),(486,7486136,7486132,'min',33.333,3),(486,7486137,7486134,'cap',16.667,1),(486,7486138,7486134,'apa',16.667,1),(486,7486139,7486134,'pac',16.667,1),(486,7486140,7486134,'aci',16.667,1),(486,7486141,7486134,'cit',16.667,1),(486,7486142,7486134,'ity',16.667,1),(486,7486143,7486137,'pat',50,1),(486,7486144,7486137,'ath',50,1),(486,7486145,7486143,'fre',14.286,1),(486,7486146,7486143,'ree',14.286,1),(486,7486147,7486143,'ees',14.286,1),(486,7486148,7486143,'esp',14.286,1),(486,7486149,7486143,'spa',14.286,1),(486,7486150,7486143,'pac',14.286,1),(486,7486151,7486143,'ace',14.286,1),(486,7486152,7486145,'dis',50,1),(486,7486153,7486145,'isk',50,1),(486,7486154,7486152,'ind',33.333,1),(486,7486155,7486152,'nde',33.333,1),(486,7486156,7486152,'dex',33.333,1),(486,7486157,7486154,'adm',8.333,1),(486,7486158,7486154,'dmi',8.333,1),(486,7486159,7486154,'min',8.333,1),(486,7486160,7486154,'ini',8.333,1),(486,7486161,7486154,'nis',8.333,1),(486,7486162,7486154,'ist',8.333,1),(486,7486163,7486154,'str',8.333,1),(486,7486164,7486154,'tra',8.333,1),(486,7486165,7486154,'rat',8.333,1),(486,7486166,7486154,'ati',8.333,1),(486,7486167,7486154,'tio',8.333,1),(486,7486168,7486154,'ion',8.333,1),(486,7486169,7486157,'sta',33.333,3),(486,7486170,7486157,'tat',33.333,3),(486,7486171,7486157,'ate',33.333,3),(486,7486172,7486169,'ena',20,2),(486,7486173,7486169,'nab',20,2),(486,7486174,7486169,'abl',20,2),(486,7486175,7486169,'ble',20,2),(486,7486176,7486169,'led',20,2),(486,7486177,7486172,'cac',33.333,2),(486,7486178,7486172,'ach',33.333,2),(486,7486179,7486172,'che',33.333,2),(486,7486180,7486177,'mod',50,1),(486,7486181,7486177,'ode',50,1),(486,7486182,7486180,'wri',14.286,1),(486,7486183,7486180,'rit',14.286,1),(486,7486184,7486180,'ite',14.286,1),(486,7486185,7486180,'tet',14.286,1),(486,7486186,7486180,'eth',14.286,1),(486,7486187,7486180,'thr',14.286,1),(486,7486188,7486180,'hru',14.286,1),(486,7486189,7486182,'ope',11.111,2),(486,7486190,7486182,'per',11.111,2),(486,7486191,7486182,'era',11.111,2),(486,7486192,7486182,'rat',11.111,2),(486,7486193,7486182,'ati',11.111,2),(486,7486194,7486182,'tio',11.111,2),(486,7486195,7486182,'ion',11.111,2),(486,7486196,7486182,'ona',11.111,2),(486,7486197,7486182,'nal',11.111,2),(486,7486198,7486189,'pen',20,1),(486,7486199,7486189,'end',20,1),(486,7486200,7486189,'ndi',20,1),(486,7486201,7486189,'din',20,1),(486,7486202,7486189,'ing',20,1),(486,7486203,7486198,'mes',20,1),(486,7486204,7486198,'ess',20,1),(486,7486205,7486198,'ssa',20,1),(486,7486206,7486198,'sag',20,1),(486,7486207,7486198,'age',20,1),(486,7486208,7486203,'wai',20,1),(486,7486209,7486203,'ait',20,1),(486,7486210,7486203,'iti',20,1),(486,7486211,7486203,'tin',20,1),(486,7486212,7486203,'ing',20,1),(486,7486213,7486208,'for',100,1),(486,7486214,7486213,'per',11.111,1),(486,7486215,7486213,'erf',11.111,1),(486,7486216,7486213,'rfo',11.111,1),(486,7486217,7486213,'for',11.111,1),(486,7486218,7486213,'orm',11.111,1),(486,7486219,7486213,'rma',11.111,1),(486,7486220,7486213,'man',11.111,1),(486,7486221,7486213,'anc',11.111,1),(486,7486222,7486213,'nce',11.111,1),(486,7486223,7486214,'ide',12.5,1),(486,7486224,7486214,'den',12.5,1),(486,7486225,7486214,'ent',12.5,1),(486,7486226,7486214,'nti',12.5,1),(486,7486227,7486214,'tif',12.5,1),(486,7486228,7486214,'ifi',12.5,1),(486,7486229,7486214,'fie',12.5,1),(486,7486230,7486214,'ier',12.5,1),(486,7486231,7486223,'vdi',33.333,3),(486,7486232,7486223,'dis',33.333,3),(486,7486233,7486223,'isk',33.333,3),(486,7486234,7486231,'nam',50,1),(486,7486235,7486231,'ame',50,1),(486,7486236,7486234,'typ',50,1),(486,7486237,7486234,'ype',50,1),(486,7486238,7486236,'dir',25,1),(486,7486239,7486236,'ire',25,1),(486,7486240,7486236,'rec',25,1),(486,7486241,7486236,'ect',25,1),(487,7486243,7486242,'naa',100,2),(487,7486244,7486243,'600',3.333,3),(487,7486245,7486243,'000',3.333,3),(487,7486246,7486243,'00c',3.333,3),(487,7486247,7486243,'0c2',3.333,3),(487,7486248,7486243,'c29',3.333,3),(487,7486249,7486243,'29d',3.333,3),(487,7486250,7486243,'9d0',3.333,3),(487,7486251,7486243,'d04',3.333,3),(487,7486252,7486243,'04e',3.333,3),(487,7486253,7486243,'4ef',3.333,3),(487,7486254,7486243,'efa',3.333,3),(487,7486255,7486243,'fa8',3.333,3),(487,7486256,7486243,'a8f',3.333,3),(487,7486257,7486243,'8f2',3.333,3),(487,7486258,7486243,'f21',3.333,3),(487,7486259,7486243,'211',3.333,3),(487,7486260,7486243,'118',3.333,3),(487,7486261,7486243,'182',3.333,3),(487,7486262,7486243,'82c',3.333,3),(487,7486263,7486243,'2c9',3.333,3),(487,7486264,7486243,'c94',3.333,3),(487,7486265,7486243,'941',3.333,3),(487,7486266,7486243,'416',3.333,3),(487,7486267,7486243,'16e',3.333,3),(487,7486268,7486243,'6e1',3.333,3),(487,7486269,7486243,'e17',3.333,3),(487,7486270,7486243,'176',3.333,3),(487,7486271,7486243,'767',3.333,3),(487,7486272,7486243,'67c',3.333,3),(487,7486273,7486243,'7c0',3.333,3),(487,7486274,7486244,'mon',100,1),(487,7486275,7486274,'201',50,1),(487,7486276,7486274,'013',50,1),(487,7486277,7486275,'adm',33.333,3),(487,7486278,7486275,'dmi',33.333,3),(487,7486279,7486275,'min',33.333,3),(487,7486280,7486277,'cap',16.667,1),(487,7486281,7486277,'apa',16.667,1),(487,7486282,7486277,'pac',16.667,1),(487,7486283,7486277,'aci',16.667,1),(487,7486284,7486277,'cit',16.667,1),(487,7486285,7486277,'ity',16.667,1),(487,7486286,7486280,'pat',50,1),(487,7486287,7486280,'ath',50,1),(487,7486288,7486286,'fre',14.286,1),(487,7486289,7486286,'ree',14.286,1),(487,7486290,7486286,'ees',14.286,1),(487,7486291,7486286,'esp',14.286,1),(487,7486292,7486286,'spa',14.286,1),(487,7486293,7486286,'pac',14.286,1),(487,7486294,7486286,'ace',14.286,1),(487,7486295,7486288,'dis',50,1),(487,7486296,7486288,'isk',50,1),(487,7486297,7486295,'ind',33.333,1),(487,7486298,7486295,'nde',33.333,1),(487,7486299,7486295,'dex',33.333,1),(487,7486300,7486297,'adm',8.333,1),(487,7486301,7486297,'dmi',8.333,1),(487,7486302,7486297,'min',8.333,1),(487,7486303,7486297,'ini',8.333,1),(487,7486304,7486297,'nis',8.333,1),(487,7486305,7486297,'ist',8.333,1),(487,7486306,7486297,'str',8.333,1),(487,7486307,7486297,'tra',8.333,1),(487,7486308,7486297,'rat',8.333,1),(487,7486309,7486297,'ati',8.333,1),(487,7486310,7486297,'tio',8.333,1),(487,7486311,7486297,'ion',8.333,1),(487,7486312,7486300,'sta',33.333,3),(487,7486313,7486300,'tat',33.333,3),(487,7486314,7486300,'ate',33.333,3),(487,7486315,7486312,'ena',20,2),(487,7486316,7486312,'nab',20,2),(487,7486317,7486312,'abl',20,2),(487,7486318,7486312,'ble',20,2),(487,7486319,7486312,'led',20,2),(487,7486320,7486315,'cac',33.333,2),(487,7486321,7486315,'ach',33.333,2),(487,7486322,7486315,'che',33.333,2),(487,7486323,7486320,'mod',50,1),(487,7486324,7486320,'ode',50,1),(487,7486325,7486323,'wri',14.286,1),(487,7486326,7486323,'rit',14.286,1),(487,7486327,7486323,'ite',14.286,1),(487,7486328,7486323,'tet',14.286,1),(487,7486329,7486323,'eth',14.286,1),(487,7486330,7486323,'thr',14.286,1),(487,7486331,7486323,'hru',14.286,1),(487,7486332,7486325,'ope',11.111,2),(487,7486333,7486325,'per',11.111,2),(487,7486334,7486325,'era',11.111,2),(487,7486335,7486325,'rat',11.111,2),(487,7486336,7486325,'ati',11.111,2),(487,7486337,7486325,'tio',11.111,2),(487,7486338,7486325,'ion',11.111,2),(487,7486339,7486325,'ona',11.111,2),(487,7486340,7486325,'nal',11.111,2),(487,7486341,7486332,'pen',20,1),(487,7486342,7486332,'end',20,1),(487,7486343,7486332,'ndi',20,1),(487,7486344,7486332,'din',20,1),(487,7486345,7486332,'ing',20,1),(487,7486346,7486341,'mes',20,1),(487,7486347,7486341,'ess',20,1),(487,7486348,7486341,'ssa',20,1),(487,7486349,7486341,'sag',20,1),(487,7486350,7486341,'age',20,1),(487,7486351,7486346,'wai',20,1),(487,7486352,7486346,'ait',20,1),(487,7486353,7486346,'iti',20,1),(487,7486354,7486346,'tin',20,1),(487,7486355,7486346,'ing',20,1),(487,7486356,7486351,'for',100,1),(487,7486357,7486356,'per',11.111,1),(487,7486358,7486356,'erf',11.111,1),(487,7486359,7486356,'rfo',11.111,1),(487,7486360,7486356,'for',11.111,1),(487,7486361,7486356,'orm',11.111,1),(487,7486362,7486356,'rma',11.111,1),(487,7486363,7486356,'man',11.111,1),(487,7486364,7486356,'anc',11.111,1),(487,7486365,7486356,'nce',11.111,1),(487,7486366,7486357,'ide',12.5,1),(487,7486367,7486357,'den',12.5,1),(487,7486368,7486357,'ent',12.5,1),(487,7486369,7486357,'nti',12.5,1),(487,7486370,7486357,'tif',12.5,1),(487,7486371,7486357,'ifi',12.5,1),(487,7486372,7486357,'fie',12.5,1),(487,7486373,7486357,'ier',12.5,1),(487,7486374,7486366,'vdi',33.333,3),(487,7486375,7486366,'dis',33.333,3),(487,7486376,7486366,'isk',33.333,3),(487,7486377,7486374,'nam',50,1),(487,7486378,7486374,'ame',50,1),(487,7486379,7486377,'typ',50,1),(487,7486380,7486377,'ype',50,1),(487,7486381,7486379,'dir',25,1),(487,7486382,7486379,'ire',25,1),(487,7486383,7486379,'rec',25,1),(487,7486384,7486379,'ect',25,1),(488,7486386,7486385,'naa',100,2),(488,7486387,7486386,'600',3.333,3),(488,7486388,7486386,'000',3.333,3),(488,7486389,7486386,'00c',3.333,3),(488,7486390,7486386,'0c2',3.333,3),(488,7486391,7486386,'c29',3.333,3),(488,7486392,7486386,'295',3.333,3),(488,7486393,7486386,'950',3.333,3),(488,7486394,7486386,'50c',3.333,3),(488,7486395,7486386,'0c1',3.333,3),(488,7486396,7486386,'c17',3.333,3),(488,7486397,7486386,'176',3.333,3),(488,7486398,7486386,'76d',3.333,3),(488,7486399,7486386,'6da',3.333,3),(488,7486400,7486386,'dac',3.333,3),(488,7486401,7486386,'ace',3.333,3),(488,7486402,7486386,'ced',3.333,3),(488,7486403,7486386,'ed3',3.333,3),(488,7486404,7486386,'d39',3.333,3),(488,7486405,7486386,'39c',3.333,3),(488,7486406,7486386,'9cb',3.333,3),(488,7486407,7486386,'cb8',3.333,3),(488,7486408,7486386,'b8e',3.333,3),(488,7486409,7486386,'8e1',3.333,3),(488,7486410,7486386,'e19',3.333,3),(488,7486411,7486386,'19a',3.333,3),(488,7486412,7486386,'9a5',3.333,3),(488,7486413,7486386,'a55',3.333,3),(488,7486414,7486386,'55c',3.333,3),(488,7486415,7486386,'5cc',3.333,3),(488,7486416,7486386,'cce',3.333,3),(488,7486417,7486387,'mon',100,1),(488,7486418,7486417,'201',50,1),(488,7486419,7486417,'013',50,1),(488,7486420,7486418,'adm',33.333,3),(488,7486421,7486418,'dmi',33.333,3),(488,7486422,7486418,'min',33.333,3),(488,7486423,7486420,'cap',16.667,1),(488,7486424,7486420,'apa',16.667,1),(488,7486425,7486420,'pac',16.667,1),(488,7486426,7486420,'aci',16.667,1),(488,7486427,7486420,'cit',16.667,1),(488,7486428,7486420,'ity',16.667,1),(488,7486429,7486423,'pat',50,1),(488,7486430,7486423,'ath',50,1),(488,7486431,7486429,'fre',14.286,1),(488,7486432,7486429,'ree',14.286,1),(488,7486433,7486429,'ees',14.286,1),(488,7486434,7486429,'esp',14.286,1),(488,7486435,7486429,'spa',14.286,1),(488,7486436,7486429,'pac',14.286,1),(488,7486437,7486429,'ace',14.286,1),(488,7486438,7486431,'dis',50,1),(488,7486439,7486431,'isk',50,1),(488,7486440,7486438,'ind',33.333,1),(488,7486441,7486438,'nde',33.333,1),(488,7486442,7486438,'dex',33.333,1),(488,7486443,7486440,'adm',8.333,1),(488,7486444,7486440,'dmi',8.333,1),(488,7486445,7486440,'min',8.333,1),(488,7486446,7486440,'ini',8.333,1),(488,7486447,7486440,'nis',8.333,1),(488,7486448,7486440,'ist',8.333,1),(488,7486449,7486440,'str',8.333,1),(488,7486450,7486440,'tra',8.333,1),(488,7486451,7486440,'rat',8.333,1),(488,7486452,7486440,'ati',8.333,1),(488,7486453,7486440,'tio',8.333,1),(488,7486454,7486440,'ion',8.333,1),(488,7486455,7486443,'sta',33.333,3),(488,7486456,7486443,'tat',33.333,3),(488,7486457,7486443,'ate',33.333,3),(488,7486458,7486455,'ena',20,2),(488,7486459,7486455,'nab',20,2),(488,7486460,7486455,'abl',20,2),(488,7486461,7486455,'ble',20,2),(488,7486462,7486455,'led',20,2),(488,7486463,7486458,'cac',33.333,2),(488,7486464,7486458,'ach',33.333,2),(488,7486465,7486458,'che',33.333,2),(488,7486466,7486463,'mod',50,1),(488,7486467,7486463,'ode',50,1),(488,7486468,7486466,'wri',14.286,1),(488,7486469,7486466,'rit',14.286,1),(488,7486470,7486466,'ite',14.286,1),(488,7486471,7486466,'tet',14.286,1),(488,7486472,7486466,'eth',14.286,1),(488,7486473,7486466,'thr',14.286,1),(488,7486474,7486466,'hru',14.286,1),(488,7486475,7486468,'ope',11.111,2),(488,7486476,7486468,'per',11.111,2),(488,7486477,7486468,'era',11.111,2),(488,7486478,7486468,'rat',11.111,2),(488,7486479,7486468,'ati',11.111,2),(488,7486480,7486468,'tio',11.111,2),(488,7486481,7486468,'ion',11.111,2),(488,7486482,7486468,'ona',11.111,2),(488,7486483,7486468,'nal',11.111,2),(488,7486484,7486475,'pen',20,1),(488,7486485,7486475,'end',20,1),(488,7486486,7486475,'ndi',20,1),(488,7486487,7486475,'din',20,1),(488,7486488,7486475,'ing',20,1),(488,7486489,7486484,'mes',20,1),(488,7486490,7486484,'ess',20,1),(488,7486491,7486484,'ssa',20,1),(488,7486492,7486484,'sag',20,1),(488,7486493,7486484,'age',20,1),(488,7486494,7486489,'wai',20,1),(488,7486495,7486489,'ait',20,1),(488,7486496,7486489,'iti',20,1),(488,7486497,7486489,'tin',20,1),(488,7486498,7486489,'ing',20,1),(488,7486499,7486494,'for',100,1),(488,7486500,7486499,'per',11.111,1),(488,7486501,7486499,'erf',11.111,1),(488,7486502,7486499,'rfo',11.111,1),(488,7486503,7486499,'for',11.111,1),(488,7486504,7486499,'orm',11.111,1),(488,7486505,7486499,'rma',11.111,1),(488,7486506,7486499,'man',11.111,1),(488,7486507,7486499,'anc',11.111,1),(488,7486508,7486499,'nce',11.111,1),(488,7486509,7486500,'ide',12.5,1),(488,7486510,7486500,'den',12.5,1),(488,7486511,7486500,'ent',12.5,1),(488,7486512,7486500,'nti',12.5,1),(488,7486513,7486500,'tif',12.5,1),(488,7486514,7486500,'ifi',12.5,1),(488,7486515,7486500,'fie',12.5,1),(488,7486516,7486500,'ier',12.5,1),(488,7486517,7486509,'vdi',33.333,3),(488,7486518,7486509,'dis',33.333,3),(488,7486519,7486509,'isk',33.333,3),(488,7486520,7486517,'nam',50,1),(488,7486521,7486517,'ame',50,1),(488,7486522,7486520,'typ',50,1),(488,7486523,7486520,'ype',50,1),(488,7486524,7486522,'dir',25,1),(488,7486525,7486522,'ire',25,1),(488,7486526,7486522,'rec',25,1),(488,7486527,7486522,'ect',25,1),(489,7486529,7486528,'naa',100,2),(489,7486530,7486529,'600',3.333,3),(489,7486531,7486529,'000',3.333,3),(489,7486532,7486529,'00c',3.333,3),(489,7486533,7486529,'0c2',3.333,3),(489,7486534,7486529,'c29',3.333,3),(489,7486535,7486529,'29d',3.333,3),(489,7486536,7486529,'9dc',3.333,3),(489,7486537,7486529,'dc5',3.333,3),(489,7486538,7486529,'c5f',3.333,3),(489,7486539,7486529,'5fc',3.333,3),(489,7486540,7486529,'fc4',3.333,3),(489,7486541,7486529,'c46',3.333,3),(489,7486542,7486529,'46b',3.333,3),(489,7486543,7486529,'6b4',3.333,3),(489,7486544,7486529,'b44',3.333,3),(489,7486545,7486529,'447',3.333,3),(489,7486546,7486529,'479',3.333,3),(489,7486547,7486529,'795',3.333,3),(489,7486548,7486529,'95b',3.333,3),(489,7486549,7486529,'5bd',3.333,3),(489,7486550,7486529,'bde',3.333,3),(489,7486551,7486529,'deb',3.333,3),(489,7486552,7486529,'eb2',3.333,3),(489,7486553,7486529,'b24',3.333,3),(489,7486554,7486529,'241',3.333,3),(489,7486555,7486529,'41c',3.333,3),(489,7486556,7486529,'1c2',3.333,3),(489,7486557,7486529,'c2b',3.333,3),(489,7486558,7486529,'2bc',3.333,3),(489,7486559,7486529,'bcb',3.333,3),(489,7486560,7486530,'mon',100,1),(489,7486561,7486560,'201',50,1),(489,7486562,7486560,'013',50,1),(489,7486563,7486561,'adm',33.333,3),(489,7486564,7486561,'dmi',33.333,3),(489,7486565,7486561,'min',33.333,3),(489,7486566,7486563,'cap',16.667,1),(489,7486567,7486563,'apa',16.667,1),(489,7486568,7486563,'pac',16.667,1),(489,7486569,7486563,'aci',16.667,1),(489,7486570,7486563,'cit',16.667,1),(489,7486571,7486563,'ity',16.667,1),(489,7486572,7486566,'pat',50,1),(489,7486573,7486566,'ath',50,1),(489,7486574,7486572,'fre',14.286,1),(489,7486575,7486572,'ree',14.286,1),(489,7486576,7486572,'ees',14.286,1),(489,7486577,7486572,'esp',14.286,1),(489,7486578,7486572,'spa',14.286,1),(489,7486579,7486572,'pac',14.286,1),(489,7486580,7486572,'ace',14.286,1),(489,7486581,7486574,'dis',50,1),(489,7486582,7486574,'isk',50,1),(489,7486583,7486581,'ind',33.333,1),(489,7486584,7486581,'nde',33.333,1),(489,7486585,7486581,'dex',33.333,1),(489,7486586,7486583,'adm',8.333,1),(489,7486587,7486583,'dmi',8.333,1),(489,7486588,7486583,'min',8.333,1),(489,7486589,7486583,'ini',8.333,1),(489,7486590,7486583,'nis',8.333,1),(489,7486591,7486583,'ist',8.333,1),(489,7486592,7486583,'str',8.333,1),(489,7486593,7486583,'tra',8.333,1),(489,7486594,7486583,'rat',8.333,1),(489,7486595,7486583,'ati',8.333,1),(489,7486596,7486583,'tio',8.333,1),(489,7486597,7486583,'ion',8.333,1),(489,7486598,7486586,'sta',33.333,3),(489,7486599,7486586,'tat',33.333,3),(489,7486600,7486586,'ate',33.333,3),(489,7486601,7486598,'ena',20,2),(489,7486602,7486598,'nab',20,2),(489,7486603,7486598,'abl',20,2),(489,7486604,7486598,'ble',20,2),(489,7486605,7486598,'led',20,2),(489,7486606,7486601,'cac',33.333,2),(489,7486607,7486601,'ach',33.333,2),(489,7486608,7486601,'che',33.333,2),(489,7486609,7486606,'mod',50,1),(489,7486610,7486606,'ode',50,1),(489,7486611,7486609,'wri',14.286,1),(489,7486612,7486609,'rit',14.286,1),(489,7486613,7486609,'ite',14.286,1),(489,7486614,7486609,'tet',14.286,1),(489,7486615,7486609,'eth',14.286,1),(489,7486616,7486609,'thr',14.286,1),(489,7486617,7486609,'hru',14.286,1),(489,7486618,7486611,'ope',11.111,2),(489,7486619,7486611,'per',11.111,2),(489,7486620,7486611,'era',11.111,2),(489,7486621,7486611,'rat',11.111,2),(489,7486622,7486611,'ati',11.111,2),(489,7486623,7486611,'tio',11.111,2),(489,7486624,7486611,'ion',11.111,2),(489,7486625,7486611,'ona',11.111,2),(489,7486626,7486611,'nal',11.111,2),(489,7486627,7486618,'pen',20,1),(489,7486628,7486618,'end',20,1),(489,7486629,7486618,'ndi',20,1),(489,7486630,7486618,'din',20,1),(489,7486631,7486618,'ing',20,1),(489,7486632,7486627,'mes',20,1),(489,7486633,7486627,'ess',20,1),(489,7486634,7486627,'ssa',20,1),(489,7486635,7486627,'sag',20,1),(489,7486636,7486627,'age',20,1),(489,7486637,7486632,'wai',20,1),(489,7486638,7486632,'ait',20,1),(489,7486639,7486632,'iti',20,1),(489,7486640,7486632,'tin',20,1),(489,7486641,7486632,'ing',20,1),(489,7486642,7486637,'for',100,1),(489,7486643,7486642,'per',11.111,1),(489,7486644,7486642,'erf',11.111,1),(489,7486645,7486642,'rfo',11.111,1),(489,7486646,7486642,'for',11.111,1),(489,7486647,7486642,'orm',11.111,1),(489,7486648,7486642,'rma',11.111,1),(489,7486649,7486642,'man',11.111,1),(489,7486650,7486642,'anc',11.111,1),(489,7486651,7486642,'nce',11.111,1),(489,7486652,7486643,'ide',12.5,1),(489,7486653,7486643,'den',12.5,1),(489,7486654,7486643,'ent',12.5,1),(489,7486655,7486643,'nti',12.5,1),(489,7486656,7486643,'tif',12.5,1),(489,7486657,7486643,'ifi',12.5,1),(489,7486658,7486643,'fie',12.5,1),(489,7486659,7486643,'ier',12.5,1),(489,7486660,7486652,'vdi',33.333,3),(489,7486661,7486652,'dis',33.333,3),(489,7486662,7486652,'isk',33.333,3),(489,7486663,7486660,'nam',50,1),(489,7486664,7486660,'ame',50,1),(489,7486665,7486663,'typ',50,1),(489,7486666,7486663,'ype',50,1),(489,7486667,7486665,'dir',25,1),(489,7486668,7486665,'ire',25,1),(489,7486669,7486665,'rec',25,1),(489,7486670,7486665,'ect',25,1),(490,7486672,7486671,'naa',100,2),(490,7486673,7486672,'600',3.333,3),(490,7486674,7486672,'000',3.333,3),(490,7486675,7486672,'00c',3.333,3),(490,7486676,7486672,'0c2',3.333,3),(490,7486677,7486672,'c29',3.333,3),(490,7486678,7486672,'298',3.333,3),(490,7486679,7486672,'980',3.333,3),(490,7486680,7486672,'807',3.333,3),(490,7486681,7486672,'071',3.333,3),(490,7486682,7486672,'718',3.333,3),(490,7486683,7486672,'18d',3.333,3),(490,7486684,7486672,'8d4',3.333,3),(490,7486685,7486672,'d46',3.333,3),(490,7486686,7486672,'464',3.333,3),(490,7486687,7486672,'640',3.333,3),(490,7486688,7486672,'40b',3.333,3),(490,7486689,7486672,'0b8',3.333,3),(490,7486690,7486672,'b87',3.333,3),(490,7486691,7486672,'87f',3.333,3),(490,7486692,7486672,'7ff',3.333,3),(490,7486693,7486672,'ff8',3.333,3),(490,7486694,7486672,'f80',3.333,3),(490,7486695,7486672,'805',3.333,3),(490,7486696,7486672,'05b',3.333,3),(490,7486697,7486672,'5b1',3.333,3),(490,7486698,7486672,'b1b',3.333,3),(490,7486699,7486672,'1ba',3.333,3),(490,7486700,7486672,'baa',3.333,3),(490,7486701,7486672,'aae',3.333,3),(490,7486702,7486672,'ae5',3.333,3),(490,7486703,7486673,'mon',100,1),(490,7486704,7486703,'201',50,1),(490,7486705,7486703,'013',50,1),(490,7486706,7486704,'adm',33.333,3),(490,7486707,7486704,'dmi',33.333,3),(490,7486708,7486704,'min',33.333,3),(490,7486709,7486706,'cap',16.667,1),(490,7486710,7486706,'apa',16.667,1),(490,7486711,7486706,'pac',16.667,1),(490,7486712,7486706,'aci',16.667,1),(490,7486713,7486706,'cit',16.667,1),(490,7486714,7486706,'ity',16.667,1),(490,7486715,7486709,'pat',50,1),(490,7486716,7486709,'ath',50,1),(490,7486717,7486715,'fre',14.286,1),(490,7486718,7486715,'ree',14.286,1),(490,7486719,7486715,'ees',14.286,1),(490,7486720,7486715,'esp',14.286,1),(490,7486721,7486715,'spa',14.286,1),(490,7486722,7486715,'pac',14.286,1),(490,7486723,7486715,'ace',14.286,1),(490,7486724,7486717,'dis',50,1),(490,7486725,7486717,'isk',50,1),(490,7486726,7486724,'ind',33.333,1),(490,7486727,7486724,'nde',33.333,1),(490,7486728,7486724,'dex',33.333,1),(490,7486729,7486726,'adm',8.333,1),(490,7486730,7486726,'dmi',8.333,1),(490,7486731,7486726,'min',8.333,1),(490,7486732,7486726,'ini',8.333,1),(490,7486733,7486726,'nis',8.333,1),(490,7486734,7486726,'ist',8.333,1),(490,7486735,7486726,'str',8.333,1),(490,7486736,7486726,'tra',8.333,1),(490,7486737,7486726,'rat',8.333,1),(490,7486738,7486726,'ati',8.333,1),(490,7486739,7486726,'tio',8.333,1),(490,7486740,7486726,'ion',8.333,1),(490,7486741,7486729,'sta',33.333,3),(490,7486742,7486729,'tat',33.333,3),(490,7486743,7486729,'ate',33.333,3),(490,7486744,7486741,'ena',20,2),(490,7486745,7486741,'nab',20,2),(490,7486746,7486741,'abl',20,2),(490,7486747,7486741,'ble',20,2),(490,7486748,7486741,'led',20,2),(490,7486749,7486744,'cac',33.333,2),(490,7486750,7486744,'ach',33.333,2),(490,7486751,7486744,'che',33.333,2),(490,7486752,7486749,'mod',50,1),(490,7486753,7486749,'ode',50,1),(490,7486754,7486752,'wri',14.286,1),(490,7486755,7486752,'rit',14.286,1),(490,7486756,7486752,'ite',14.286,1),(490,7486757,7486752,'tet',14.286,1),(490,7486758,7486752,'eth',14.286,1),(490,7486759,7486752,'thr',14.286,1),(490,7486760,7486752,'hru',14.286,1),(490,7486761,7486754,'ope',11.111,2),(490,7486762,7486754,'per',11.111,2),(490,7486763,7486754,'era',11.111,2),(490,7486764,7486754,'rat',11.111,2),(490,7486765,7486754,'ati',11.111,2),(490,7486766,7486754,'tio',11.111,2),(490,7486767,7486754,'ion',11.111,2),(490,7486768,7486754,'ona',11.111,2),(490,7486769,7486754,'nal',11.111,2),(490,7486770,7486761,'pen',20,1),(490,7486771,7486761,'end',20,1),(490,7486772,7486761,'ndi',20,1),(490,7486773,7486761,'din',20,1),(490,7486774,7486761,'ing',20,1),(490,7486775,7486770,'mes',20,1),(490,7486776,7486770,'ess',20,1),(490,7486777,7486770,'ssa',20,1),(490,7486778,7486770,'sag',20,1),(490,7486779,7486770,'age',20,1),(490,7486780,7486775,'wai',20,1),(490,7486781,7486775,'ait',20,1),(490,7486782,7486775,'iti',20,1),(490,7486783,7486775,'tin',20,1),(490,7486784,7486775,'ing',20,1),(490,7486785,7486780,'for',100,1),(490,7486786,7486785,'per',11.111,1),(490,7486787,7486785,'erf',11.111,1),(490,7486788,7486785,'rfo',11.111,1),(490,7486789,7486785,'for',11.111,1),(490,7486790,7486785,'orm',11.111,1),(490,7486791,7486785,'rma',11.111,1),(490,7486792,7486785,'man',11.111,1),(490,7486793,7486785,'anc',11.111,1),(490,7486794,7486785,'nce',11.111,1),(490,7486795,7486786,'ide',12.5,1),(490,7486796,7486786,'den',12.5,1),(490,7486797,7486786,'ent',12.5,1),(490,7486798,7486786,'nti',12.5,1),(490,7486799,7486786,'tif',12.5,1),(490,7486800,7486786,'ifi',12.5,1),(490,7486801,7486786,'fie',12.5,1),(490,7486802,7486786,'ier',12.5,1),(490,7486803,7486795,'vdi',33.333,3),(490,7486804,7486795,'dis',33.333,3),(490,7486805,7486795,'isk',33.333,3),(490,7486806,7486803,'nam',50,1),(490,7486807,7486803,'ame',50,1),(490,7486808,7486806,'typ',50,1),(490,7486809,7486806,'ype',50,1),(490,7486810,7486808,'dir',25,1),(490,7486811,7486808,'ire',25,1),(490,7486812,7486808,'rec',25,1),(490,7486813,7486808,'ect',25,1),(491,7486815,7486814,'naa',100,2),(491,7486816,7486815,'600',3.333,3),(491,7486817,7486815,'000',3.333,3),(491,7486818,7486815,'00c',3.333,3),(491,7486819,7486815,'0c2',3.333,3),(491,7486820,7486815,'c29',3.333,3),(491,7486821,7486815,'295',3.333,3),(491,7486822,7486815,'952',3.333,3),(491,7486823,7486815,'52a',3.333,3),(491,7486824,7486815,'2af',3.333,3),(491,7486825,7486815,'aff',3.333,3),(491,7486826,7486815,'ff7',3.333,3),(491,7486827,7486815,'f74',3.333,3),(491,7486828,7486815,'74f',3.333,3),(491,7486829,7486815,'4f3',3.333,3),(491,7486830,7486815,'f31',3.333,3),(491,7486831,7486815,'310',3.333,3),(491,7486832,7486815,'10e',3.333,3),(491,7486833,7486815,'0e6',3.333,3),(491,7486834,7486815,'e69',3.333,3),(491,7486835,7486815,'69d',3.333,3),(491,7486836,7486815,'9dc',3.333,3),(491,7486837,7486815,'dca',3.333,3),(491,7486838,7486815,'cac',3.333,3),(491,7486839,7486815,'acb',3.333,3),(491,7486840,7486815,'cb9',3.333,3),(491,7486841,7486815,'b93',3.333,3),(491,7486842,7486815,'938',3.333,3),(491,7486843,7486815,'38d',3.333,3),(491,7486844,7486815,'8d2',3.333,3),(491,7486845,7486815,'d2f',3.333,3),(491,7486846,7486816,'mon',100,1),(491,7486847,7486846,'201',50,1),(491,7486848,7486846,'013',50,1),(491,7486849,7486847,'adm',33.333,3),(491,7486850,7486847,'dmi',33.333,3),(491,7486851,7486847,'min',33.333,3),(491,7486852,7486849,'cap',16.667,1),(491,7486853,7486849,'apa',16.667,1),(491,7486854,7486849,'pac',16.667,1),(491,7486855,7486849,'aci',16.667,1),(491,7486856,7486849,'cit',16.667,1),(491,7486857,7486849,'ity',16.667,1),(491,7486858,7486852,'pat',50,1),(491,7486859,7486852,'ath',50,1),(491,7486860,7486858,'fre',14.286,1),(491,7486861,7486858,'ree',14.286,1),(491,7486862,7486858,'ees',14.286,1),(491,7486863,7486858,'esp',14.286,1),(491,7486864,7486858,'spa',14.286,1),(491,7486865,7486858,'pac',14.286,1),(491,7486866,7486858,'ace',14.286,1),(491,7486867,7486860,'dis',50,1),(491,7486868,7486860,'isk',50,1),(491,7486869,7486867,'ind',33.333,1),(491,7486870,7486867,'nde',33.333,1),(491,7486871,7486867,'dex',33.333,1),(491,7486872,7486869,'adm',8.333,1),(491,7486873,7486869,'dmi',8.333,1),(491,7486874,7486869,'min',8.333,1),(491,7486875,7486869,'ini',8.333,1),(491,7486876,7486869,'nis',8.333,1),(491,7486877,7486869,'ist',8.333,1),(491,7486878,7486869,'str',8.333,1),(491,7486879,7486869,'tra',8.333,1),(491,7486880,7486869,'rat',8.333,1),(491,7486881,7486869,'ati',8.333,1),(491,7486882,7486869,'tio',8.333,1),(491,7486883,7486869,'ion',8.333,1),(491,7486884,7486872,'sta',33.333,3),(491,7486885,7486872,'tat',33.333,3),(491,7486886,7486872,'ate',33.333,3),(491,7486887,7486884,'ena',20,2),(491,7486888,7486884,'nab',20,2),(491,7486889,7486884,'abl',20,2),(491,7486890,7486884,'ble',20,2),(491,7486891,7486884,'led',20,2),(491,7486892,7486887,'cac',33.333,2),(491,7486893,7486887,'ach',33.333,2),(491,7486894,7486887,'che',33.333,2),(491,7486895,7486892,'mod',50,1),(491,7486896,7486892,'ode',50,1),(491,7486897,7486895,'wri',14.286,1),(491,7486898,7486895,'rit',14.286,1),(491,7486899,7486895,'ite',14.286,1),(491,7486900,7486895,'tet',14.286,1),(491,7486901,7486895,'eth',14.286,1),(491,7486902,7486895,'thr',14.286,1),(491,7486903,7486895,'hru',14.286,1),(491,7486904,7486897,'ope',11.111,2),(491,7486905,7486897,'per',11.111,2),(491,7486906,7486897,'era',11.111,2),(491,7486907,7486897,'rat',11.111,2),(491,7486908,7486897,'ati',11.111,2),(491,7486909,7486897,'tio',11.111,2),(491,7486910,7486897,'ion',11.111,2),(491,7486911,7486897,'ona',11.111,2),(491,7486912,7486897,'nal',11.111,2),(491,7486913,7486904,'pen',20,1),(491,7486914,7486904,'end',20,1),(491,7486915,7486904,'ndi',20,1),(491,7486916,7486904,'din',20,1),(491,7486917,7486904,'ing',20,1),(491,7486918,7486913,'mes',20,1),(491,7486919,7486913,'ess',20,1),(491,7486920,7486913,'ssa',20,1),(491,7486921,7486913,'sag',20,1),(491,7486922,7486913,'age',20,1),(491,7486923,7486918,'wai',20,1),(491,7486924,7486918,'ait',20,1),(491,7486925,7486918,'iti',20,1),(491,7486926,7486918,'tin',20,1),(491,7486927,7486918,'ing',20,1),(491,7486928,7486923,'for',100,1),(491,7486929,7486928,'per',11.111,1),(491,7486930,7486928,'erf',11.111,1),(491,7486931,7486928,'rfo',11.111,1),(491,7486932,7486928,'for',11.111,1),(491,7486933,7486928,'orm',11.111,1),(491,7486934,7486928,'rma',11.111,1),(491,7486935,7486928,'man',11.111,1),(491,7486936,7486928,'anc',11.111,1),(491,7486937,7486928,'nce',11.111,1),(491,7486938,7486929,'ide',12.5,1),(491,7486939,7486929,'den',12.5,1),(491,7486940,7486929,'ent',12.5,1),(491,7486941,7486929,'nti',12.5,1),(491,7486942,7486929,'tif',12.5,1),(491,7486943,7486929,'ifi',12.5,1),(491,7486944,7486929,'fie',12.5,1),(491,7486945,7486929,'ier',12.5,1),(491,7486946,7486938,'vdi',33.333,3),(491,7486947,7486938,'dis',33.333,3),(491,7486948,7486938,'isk',33.333,3),(491,7486949,7486946,'nam',50,1),(491,7486950,7486946,'ame',50,1),(491,7486951,7486949,'typ',50,1),(491,7486952,7486949,'ype',50,1),(491,7486953,7486951,'dir',25,1),(491,7486954,7486951,'ire',25,1),(491,7486955,7486951,'rec',25,1),(491,7486956,7486951,'ect',25,1),(492,7486958,7486957,'naa',100,2),(492,7486959,7486958,'600',3.333,3),(492,7486960,7486958,'000',3.333,3),(492,7486961,7486958,'00c',3.333,3),(492,7486962,7486958,'0c2',3.333,3),(492,7486963,7486958,'c29',3.333,3),(492,7486964,7486958,'292',3.333,3),(492,7486965,7486958,'92e',3.333,3),(492,7486966,7486958,'2e7',3.333,3),(492,7486967,7486958,'e7e',3.333,3),(492,7486968,7486958,'7ea',3.333,3),(492,7486969,7486958,'ea6',3.333,3),(492,7486970,7486958,'a6d',3.333,3),(492,7486971,7486958,'6d7',3.333,3),(492,7486972,7486958,'d75',3.333,3),(492,7486973,7486958,'754',3.333,3),(492,7486974,7486958,'54e',3.333,3),(492,7486975,7486958,'4e9',3.333,3),(492,7486976,7486958,'e93',3.333,3),(492,7486977,7486958,'936',3.333,3),(492,7486978,7486958,'364',3.333,3),(492,7486979,7486958,'64a',3.333,3),(492,7486980,7486958,'4ab',3.333,3),(492,7486981,7486958,'aba',3.333,3),(492,7486982,7486958,'ba8',3.333,3),(492,7486983,7486958,'a88',3.333,3),(492,7486984,7486958,'882',3.333,3),(492,7486985,7486958,'825',3.333,3),(492,7486986,7486958,'257',3.333,3),(492,7486987,7486958,'57d',3.333,3),(492,7486988,7486958,'7d6',3.333,3),(492,7486989,7486959,'mon',100,1),(492,7486990,7486989,'201',50,1),(492,7486991,7486989,'013',50,1),(492,7486992,7486990,'adm',33.333,3),(492,7486993,7486990,'dmi',33.333,3),(492,7486994,7486990,'min',33.333,3),(492,7486995,7486992,'cap',16.667,1),(492,7486996,7486992,'apa',16.667,1),(492,7486997,7486992,'pac',16.667,1),(492,7486998,7486992,'aci',16.667,1),(492,7486999,7486992,'cit',16.667,1),(492,7487000,7486992,'ity',16.667,1),(492,7487001,7486995,'pat',50,1),(492,7487002,7486995,'ath',50,1),(492,7487003,7487001,'fre',14.286,1),(492,7487004,7487001,'ree',14.286,1),(492,7487005,7487001,'ees',14.286,1),(492,7487006,7487001,'esp',14.286,1),(492,7487007,7487001,'spa',14.286,1),(492,7487008,7487001,'pac',14.286,1),(492,7487009,7487001,'ace',14.286,1),(492,7487010,7487003,'dis',50,1),(492,7487011,7487003,'isk',50,1),(492,7487012,7487010,'ind',33.333,1),(492,7487013,7487010,'nde',33.333,1),(492,7487014,7487010,'dex',33.333,1),(492,7487015,7487012,'adm',8.333,1),(492,7487016,7487012,'dmi',8.333,1),(492,7487017,7487012,'min',8.333,1),(492,7487018,7487012,'ini',8.333,1),(492,7487019,7487012,'nis',8.333,1),(492,7487020,7487012,'ist',8.333,1),(492,7487021,7487012,'str',8.333,1),(492,7487022,7487012,'tra',8.333,1),(492,7487023,7487012,'rat',8.333,1),(492,7487024,7487012,'ati',8.333,1),(492,7487025,7487012,'tio',8.333,1),(492,7487026,7487012,'ion',8.333,1),(492,7487027,7487015,'sta',33.333,3),(492,7487028,7487015,'tat',33.333,3),(492,7487029,7487015,'ate',33.333,3),(492,7487030,7487027,'ena',20,2),(492,7487031,7487027,'nab',20,2),(492,7487032,7487027,'abl',20,2),(492,7487033,7487027,'ble',20,2),(492,7487034,7487027,'led',20,2),(492,7487035,7487030,'cac',33.333,2),(492,7487036,7487030,'ach',33.333,2),(492,7487037,7487030,'che',33.333,2),(492,7487038,7487035,'mod',50,1),(492,7487039,7487035,'ode',50,1),(492,7487040,7487038,'wri',14.286,1),(492,7487041,7487038,'rit',14.286,1),(492,7487042,7487038,'ite',14.286,1),(492,7487043,7487038,'tet',14.286,1),(492,7487044,7487038,'eth',14.286,1),(492,7487045,7487038,'thr',14.286,1),(492,7487046,7487038,'hru',14.286,1),(492,7487047,7487040,'ope',11.111,2),(492,7487048,7487040,'per',11.111,2),(492,7487049,7487040,'era',11.111,2),(492,7487050,7487040,'rat',11.111,2),(492,7487051,7487040,'ati',11.111,2),(492,7487052,7487040,'tio',11.111,2),(492,7487053,7487040,'ion',11.111,2),(492,7487054,7487040,'ona',11.111,2),(492,7487055,7487040,'nal',11.111,2),(492,7487056,7487047,'pen',20,1),(492,7487057,7487047,'end',20,1),(492,7487058,7487047,'ndi',20,1),(492,7487059,7487047,'din',20,1),(492,7487060,7487047,'ing',20,1),(492,7487061,7487056,'mes',20,1),(492,7487062,7487056,'ess',20,1),(492,7487063,7487056,'ssa',20,1),(492,7487064,7487056,'sag',20,1),(492,7487065,7487056,'age',20,1),(492,7487066,7487061,'wai',20,1),(492,7487067,7487061,'ait',20,1),(492,7487068,7487061,'iti',20,1),(492,7487069,7487061,'tin',20,1),(492,7487070,7487061,'ing',20,1),(492,7487071,7487066,'for',100,1),(492,7487072,7487071,'per',11.111,1),(492,7487073,7487071,'erf',11.111,1),(492,7487074,7487071,'rfo',11.111,1),(492,7487075,7487071,'for',11.111,1),(492,7487076,7487071,'orm',11.111,1),(492,7487077,7487071,'rma',11.111,1),(492,7487078,7487071,'man',11.111,1),(492,7487079,7487071,'anc',11.111,1),(492,7487080,7487071,'nce',11.111,1),(492,7487081,7487072,'ide',12.5,1),(492,7487082,7487072,'den',12.5,1),(492,7487083,7487072,'ent',12.5,1),(492,7487084,7487072,'nti',12.5,1),(492,7487085,7487072,'tif',12.5,1),(492,7487086,7487072,'ifi',12.5,1),(492,7487087,7487072,'fie',12.5,1),(492,7487088,7487072,'ier',12.5,1),(492,7487089,7487081,'vdi',33.333,3),(492,7487090,7487081,'dis',33.333,3),(492,7487091,7487081,'isk',33.333,3),(492,7487092,7487089,'nam',50,1),(492,7487093,7487089,'ame',50,1),(492,7487094,7487092,'typ',50,1),(492,7487095,7487092,'ype',50,1),(492,7487096,7487094,'dir',25,1),(492,7487097,7487094,'ire',25,1),(492,7487098,7487094,'rec',25,1),(492,7487099,7487094,'ect',25,1),(493,7487101,7487100,'naa',100,2),(493,7487102,7487101,'600',3.333,3),(493,7487103,7487101,'000',3.333,3),(493,7487104,7487101,'00c',3.333,3),(493,7487105,7487101,'0c2',3.333,3),(493,7487106,7487101,'c29',3.333,3),(493,7487107,7487101,'29e',3.333,3),(493,7487108,7487101,'9ea',3.333,3),(493,7487109,7487101,'eaf',3.333,3),(493,7487110,7487101,'afe',3.333,3),(493,7487111,7487101,'fe4',3.333,3),(493,7487112,7487101,'e4b',3.333,3),(493,7487113,7487101,'4b7',3.333,3),(493,7487114,7487101,'b71',3.333,3),(493,7487115,7487101,'71c',3.333,3),(493,7487116,7487101,'1cf',3.333,3),(493,7487117,7487101,'cf7',3.333,3),(493,7487118,7487101,'f73',3.333,3),(493,7487119,7487101,'739',3.333,3),(493,7487120,7487101,'397',3.333,3),(493,7487121,7487101,'979',3.333,3),(493,7487122,7487101,'794',3.333,3),(493,7487123,7487101,'947',3.333,3),(493,7487124,7487101,'472',3.333,3),(493,7487125,7487101,'727',3.333,3),(493,7487126,7487101,'274',3.333,3),(493,7487127,7487101,'745',3.333,3),(493,7487128,7487101,'45f',3.333,3),(493,7487129,7487101,'5f9',3.333,3),(493,7487130,7487101,'f9e',3.333,3),(493,7487131,7487101,'9e1',3.333,3),(493,7487132,7487102,'mon',100,1),(493,7487133,7487132,'201',50,1),(493,7487134,7487132,'013',50,1),(493,7487135,7487133,'adm',33.333,3),(493,7487136,7487133,'dmi',33.333,3),(493,7487137,7487133,'min',33.333,3),(493,7487138,7487135,'cap',16.667,1),(493,7487139,7487135,'apa',16.667,1),(493,7487140,7487135,'pac',16.667,1),(493,7487141,7487135,'aci',16.667,1),(493,7487142,7487135,'cit',16.667,1),(493,7487143,7487135,'ity',16.667,1),(493,7487144,7487138,'pat',50,1),(493,7487145,7487138,'ath',50,1),(493,7487146,7487144,'fre',14.286,1),(493,7487147,7487144,'ree',14.286,1),(493,7487148,7487144,'ees',14.286,1),(493,7487149,7487144,'esp',14.286,1),(493,7487150,7487144,'spa',14.286,1),(493,7487151,7487144,'pac',14.286,1),(493,7487152,7487144,'ace',14.286,1),(493,7487153,7487146,'dis',50,1),(493,7487154,7487146,'isk',50,1),(493,7487155,7487153,'ind',33.333,1),(493,7487156,7487153,'nde',33.333,1),(493,7487157,7487153,'dex',33.333,1),(493,7487158,7487155,'adm',8.333,1),(493,7487159,7487155,'dmi',8.333,1),(493,7487160,7487155,'min',8.333,1),(493,7487161,7487155,'ini',8.333,1),(493,7487162,7487155,'nis',8.333,1),(493,7487163,7487155,'ist',8.333,1),(493,7487164,7487155,'str',8.333,1),(493,7487165,7487155,'tra',8.333,1),(493,7487166,7487155,'rat',8.333,1),(493,7487167,7487155,'ati',8.333,1),(493,7487168,7487155,'tio',8.333,1),(493,7487169,7487155,'ion',8.333,1),(493,7487170,7487158,'sta',33.333,3),(493,7487171,7487158,'tat',33.333,3),(493,7487172,7487158,'ate',33.333,3),(493,7487173,7487170,'ena',20,2),(493,7487174,7487170,'nab',20,2),(493,7487175,7487170,'abl',20,2),(493,7487176,7487170,'ble',20,2),(493,7487177,7487170,'led',20,2),(493,7487178,7487173,'cac',33.333,2),(493,7487179,7487173,'ach',33.333,2),(493,7487180,7487173,'che',33.333,2),(493,7487181,7487178,'mod',50,1),(493,7487182,7487178,'ode',50,1),(493,7487183,7487181,'wri',14.286,1),(493,7487184,7487181,'rit',14.286,1),(493,7487185,7487181,'ite',14.286,1),(493,7487186,7487181,'tet',14.286,1),(493,7487187,7487181,'eth',14.286,1),(493,7487188,7487181,'thr',14.286,1),(493,7487189,7487181,'hru',14.286,1),(493,7487190,7487183,'ope',11.111,2),(493,7487191,7487183,'per',11.111,2),(493,7487192,7487183,'era',11.111,2),(493,7487193,7487183,'rat',11.111,2),(493,7487194,7487183,'ati',11.111,2),(493,7487195,7487183,'tio',11.111,2),(493,7487196,7487183,'ion',11.111,2),(493,7487197,7487183,'ona',11.111,2),(493,7487198,7487183,'nal',11.111,2),(493,7487199,7487190,'pen',20,1),(493,7487200,7487190,'end',20,1),(493,7487201,7487190,'ndi',20,1),(493,7487202,7487190,'din',20,1),(493,7487203,7487190,'ing',20,1),(493,7487204,7487199,'mes',20,1),(493,7487205,7487199,'ess',20,1),(493,7487206,7487199,'ssa',20,1),(493,7487207,7487199,'sag',20,1),(493,7487208,7487199,'age',20,1),(493,7487209,7487204,'wai',20,1),(493,7487210,7487204,'ait',20,1),(493,7487211,7487204,'iti',20,1),(493,7487212,7487204,'tin',20,1),(493,7487213,7487204,'ing',20,1),(493,7487214,7487209,'for',100,1),(493,7487215,7487214,'per',11.111,1),(493,7487216,7487214,'erf',11.111,1),(493,7487217,7487214,'rfo',11.111,1),(493,7487218,7487214,'for',11.111,1),(493,7487219,7487214,'orm',11.111,1),(493,7487220,7487214,'rma',11.111,1),(493,7487221,7487214,'man',11.111,1),(493,7487222,7487214,'anc',11.111,1),(493,7487223,7487214,'nce',11.111,1),(493,7487224,7487215,'ide',12.5,1),(493,7487225,7487215,'den',12.5,1),(493,7487226,7487215,'ent',12.5,1),(493,7487227,7487215,'nti',12.5,1),(493,7487228,7487215,'tif',12.5,1),(493,7487229,7487215,'ifi',12.5,1),(493,7487230,7487215,'fie',12.5,1),(493,7487231,7487215,'ier',12.5,1),(493,7487232,7487224,'vdi',33.333,3),(493,7487233,7487224,'dis',33.333,3),(493,7487234,7487224,'isk',33.333,3),(493,7487235,7487232,'nam',50,1),(493,7487236,7487232,'ame',50,1),(493,7487237,7487235,'typ',50,1),(493,7487238,7487235,'ype',50,1),(493,7487239,7487237,'dir',25,1),(493,7487240,7487237,'ire',25,1),(493,7487241,7487237,'rec',25,1),(493,7487242,7487237,'ect',25,1),(494,7487244,7487243,'naa',100,2),(494,7487245,7487244,'600',3.333,3),(494,7487246,7487244,'000',3.333,3),(494,7487247,7487244,'00c',3.333,3),(494,7487248,7487244,'0c2',3.333,3),(494,7487249,7487244,'c29',3.333,3),(494,7487250,7487244,'297',3.333,3),(494,7487251,7487244,'976',3.333,3),(494,7487252,7487244,'769',3.333,3),(494,7487253,7487244,'695',3.333,3),(494,7487254,7487244,'95f',3.333,3),(494,7487255,7487244,'5f9',3.333,3),(494,7487256,7487244,'f97',3.333,3),(494,7487257,7487244,'97f',3.333,3),(494,7487258,7487244,'7f9',3.333,3),(494,7487259,7487244,'f9b',3.333,3),(494,7487260,7487244,'9bc',3.333,3),(494,7487261,7487244,'bc5',3.333,3),(494,7487262,7487244,'c51',3.333,3),(494,7487263,7487244,'51e',3.333,3),(494,7487264,7487244,'1e6',3.333,3),(494,7487265,7487244,'e6a',3.333,3),(494,7487266,7487244,'6ab',3.333,3),(494,7487267,7487244,'ab3',3.333,3),(494,7487268,7487244,'b3b',3.333,3),(494,7487269,7487244,'3bc',3.333,3),(494,7487270,7487244,'bcf',3.333,3),(494,7487271,7487244,'cfb',3.333,3),(494,7487272,7487244,'fb5',3.333,3),(494,7487273,7487244,'b55',3.333,3),(494,7487274,7487244,'556',3.333,3),(494,7487275,7487245,'mon',100,1),(494,7487276,7487275,'201',50,1),(494,7487277,7487275,'013',50,1),(494,7487278,7487276,'adm',33.333,3),(494,7487279,7487276,'dmi',33.333,3),(494,7487280,7487276,'min',33.333,3),(494,7487281,7487278,'cap',16.667,1),(494,7487282,7487278,'apa',16.667,1),(494,7487283,7487278,'pac',16.667,1),(494,7487284,7487278,'aci',16.667,1),(494,7487285,7487278,'cit',16.667,1),(494,7487286,7487278,'ity',16.667,1),(494,7487287,7487281,'pat',50,1),(494,7487288,7487281,'ath',50,1),(494,7487289,7487287,'fre',14.286,1),(494,7487290,7487287,'ree',14.286,1),(494,7487291,7487287,'ees',14.286,1),(494,7487292,7487287,'esp',14.286,1),(494,7487293,7487287,'spa',14.286,1),(494,7487294,7487287,'pac',14.286,1),(494,7487295,7487287,'ace',14.286,1),(494,7487296,7487289,'dis',50,1),(494,7487297,7487289,'isk',50,1),(494,7487298,7487296,'ind',33.333,1),(494,7487299,7487296,'nde',33.333,1),(494,7487300,7487296,'dex',33.333,1),(494,7487301,7487298,'adm',8.333,1),(494,7487302,7487298,'dmi',8.333,1),(494,7487303,7487298,'min',8.333,1),(494,7487304,7487298,'ini',8.333,1),(494,7487305,7487298,'nis',8.333,1),(494,7487306,7487298,'ist',8.333,1),(494,7487307,7487298,'str',8.333,1),(494,7487308,7487298,'tra',8.333,1),(494,7487309,7487298,'rat',8.333,1),(494,7487310,7487298,'ati',8.333,1),(494,7487311,7487298,'tio',8.333,1),(494,7487312,7487298,'ion',8.333,1),(494,7487313,7487301,'sta',33.333,3),(494,7487314,7487301,'tat',33.333,3),(494,7487315,7487301,'ate',33.333,3),(494,7487316,7487313,'ena',20,2),(494,7487317,7487313,'nab',20,2),(494,7487318,7487313,'abl',20,2),(494,7487319,7487313,'ble',20,2),(494,7487320,7487313,'led',20,2),(494,7487321,7487316,'cac',33.333,2),(494,7487322,7487316,'ach',33.333,2),(494,7487323,7487316,'che',33.333,2),(494,7487324,7487321,'mod',50,1),(494,7487325,7487321,'ode',50,1),(494,7487326,7487324,'wri',14.286,1),(494,7487327,7487324,'rit',14.286,1),(494,7487328,7487324,'ite',14.286,1),(494,7487329,7487324,'tet',14.286,1),(494,7487330,7487324,'eth',14.286,1),(494,7487331,7487324,'thr',14.286,1),(494,7487332,7487324,'hru',14.286,1),(494,7487333,7487326,'ope',11.111,2),(494,7487334,7487326,'per',11.111,2),(494,7487335,7487326,'era',11.111,2),(494,7487336,7487326,'rat',11.111,2),(494,7487337,7487326,'ati',11.111,2),(494,7487338,7487326,'tio',11.111,2),(494,7487339,7487326,'ion',11.111,2),(494,7487340,7487326,'ona',11.111,2),(494,7487341,7487326,'nal',11.111,2),(494,7487342,7487333,'pen',20,1),(494,7487343,7487333,'end',20,1),(494,7487344,7487333,'ndi',20,1),(494,7487345,7487333,'din',20,1),(494,7487346,7487333,'ing',20,1),(494,7487347,7487342,'mes',20,1),(494,7487348,7487342,'ess',20,1),(494,7487349,7487342,'ssa',20,1),(494,7487350,7487342,'sag',20,1),(494,7487351,7487342,'age',20,1),(494,7487352,7487347,'wai',20,1),(494,7487353,7487347,'ait',20,1),(494,7487354,7487347,'iti',20,1),(494,7487355,7487347,'tin',20,1),(494,7487356,7487347,'ing',20,1),(494,7487357,7487352,'for',100,1),(494,7487358,7487357,'per',11.111,1),(494,7487359,7487357,'erf',11.111,1),(494,7487360,7487357,'rfo',11.111,1),(494,7487361,7487357,'for',11.111,1),(494,7487362,7487357,'orm',11.111,1),(494,7487363,7487357,'rma',11.111,1),(494,7487364,7487357,'man',11.111,1),(494,7487365,7487357,'anc',11.111,1),(494,7487366,7487357,'nce',11.111,1),(494,7487367,7487358,'ide',12.5,1),(494,7487368,7487358,'den',12.5,1),(494,7487369,7487358,'ent',12.5,1),(494,7487370,7487358,'nti',12.5,1),(494,7487371,7487358,'tif',12.5,1),(494,7487372,7487358,'ifi',12.5,1),(494,7487373,7487358,'fie',12.5,1),(494,7487374,7487358,'ier',12.5,1),(494,7487375,7487367,'vdi',33.333,3),(494,7487376,7487367,'dis',33.333,3),(494,7487377,7487367,'isk',33.333,3),(494,7487378,7487375,'nam',50,1),(494,7487379,7487375,'ame',50,1),(494,7487380,7487378,'typ',50,1),(494,7487381,7487378,'ype',50,1),(494,7487382,7487380,'dir',25,1),(494,7487383,7487380,'ire',25,1),(494,7487384,7487380,'rec',25,1),(494,7487385,7487380,'ect',25,1),(495,7487387,7487386,'naa',100,2),(495,7487388,7487387,'600',3.333,3),(495,7487389,7487387,'000',3.333,3),(495,7487390,7487387,'00c',3.333,3),(495,7487391,7487387,'0c2',3.333,3),(495,7487392,7487387,'c29',3.333,3),(495,7487393,7487387,'299',3.333,3),(495,7487394,7487387,'998',3.333,3),(495,7487395,7487387,'98f',3.333,3),(495,7487396,7487387,'8f8',3.333,3),(495,7487397,7487387,'f84',3.333,3),(495,7487398,7487387,'840',3.333,3),(495,7487399,7487387,'402',3.333,3),(495,7487400,7487387,'024',3.333,3),(495,7487401,7487387,'242',3.333,3),(495,7487402,7487387,'422',3.333,3),(495,7487403,7487387,'228',3.333,3),(495,7487404,7487387,'280',3.333,3),(495,7487405,7487387,'80b',3.333,3),(495,7487406,7487387,'0b6',3.333,3),(495,7487407,7487387,'b6e',3.333,3),(495,7487408,7487387,'6e3',3.333,3),(495,7487409,7487387,'e35',3.333,3),(495,7487410,7487387,'35d',3.333,3),(495,7487411,7487387,'5d0',3.333,3),(495,7487412,7487387,'d08',3.333,3),(495,7487413,7487387,'084',3.333,3),(495,7487414,7487387,'840',3.333,3),(495,7487415,7487387,'405',3.333,3),(495,7487416,7487387,'050',3.333,3),(495,7487417,7487387,'505',3.333,3),(495,7487418,7487388,'mon',100,1),(495,7487419,7487418,'201',50,1),(495,7487420,7487418,'013',50,1),(495,7487421,7487419,'adm',33.333,3),(495,7487422,7487419,'dmi',33.333,3),(495,7487423,7487419,'min',33.333,3),(495,7487424,7487421,'cap',16.667,1),(495,7487425,7487421,'apa',16.667,1),(495,7487426,7487421,'pac',16.667,1),(495,7487427,7487421,'aci',16.667,1),(495,7487428,7487421,'cit',16.667,1),(495,7487429,7487421,'ity',16.667,1),(495,7487430,7487424,'pat',50,1),(495,7487431,7487424,'ath',50,1),(495,7487432,7487430,'fre',14.286,1),(495,7487433,7487430,'ree',14.286,1),(495,7487434,7487430,'ees',14.286,1),(495,7487435,7487430,'esp',14.286,1),(495,7487436,7487430,'spa',14.286,1),(495,7487437,7487430,'pac',14.286,1),(495,7487438,7487430,'ace',14.286,1),(495,7487439,7487432,'dis',50,1),(495,7487440,7487432,'isk',50,1),(495,7487441,7487439,'ind',33.333,1),(495,7487442,7487439,'nde',33.333,1),(495,7487443,7487439,'dex',33.333,1),(495,7487444,7487441,'adm',8.333,1),(495,7487445,7487441,'dmi',8.333,1),(495,7487446,7487441,'min',8.333,1),(495,7487447,7487441,'ini',8.333,1),(495,7487448,7487441,'nis',8.333,1),(495,7487449,7487441,'ist',8.333,1),(495,7487450,7487441,'str',8.333,1),(495,7487451,7487441,'tra',8.333,1),(495,7487452,7487441,'rat',8.333,1),(495,7487453,7487441,'ati',8.333,1),(495,7487454,7487441,'tio',8.333,1),(495,7487455,7487441,'ion',8.333,1),(495,7487456,7487444,'sta',33.333,3),(495,7487457,7487444,'tat',33.333,3),(495,7487458,7487444,'ate',33.333,3),(495,7487459,7487456,'ena',20,2),(495,7487460,7487456,'nab',20,2),(495,7487461,7487456,'abl',20,2),(495,7487462,7487456,'ble',20,2),(495,7487463,7487456,'led',20,2),(495,7487464,7487459,'cac',33.333,2),(495,7487465,7487459,'ach',33.333,2),(495,7487466,7487459,'che',33.333,2),(495,7487467,7487464,'mod',50,1),(495,7487468,7487464,'ode',50,1),(495,7487469,7487467,'wri',14.286,1),(495,7487470,7487467,'rit',14.286,1),(495,7487471,7487467,'ite',14.286,1),(495,7487472,7487467,'tet',14.286,1),(495,7487473,7487467,'eth',14.286,1),(495,7487474,7487467,'thr',14.286,1),(495,7487475,7487467,'hru',14.286,1),(495,7487476,7487469,'ope',11.111,2),(495,7487477,7487469,'per',11.111,2),(495,7487478,7487469,'era',11.111,2),(495,7487479,7487469,'rat',11.111,2),(495,7487480,7487469,'ati',11.111,2),(495,7487481,7487469,'tio',11.111,2),(495,7487482,7487469,'ion',11.111,2),(495,7487483,7487469,'ona',11.111,2),(495,7487484,7487469,'nal',11.111,2),(495,7487485,7487476,'pen',20,1),(495,7487486,7487476,'end',20,1),(495,7487487,7487476,'ndi',20,1),(495,7487488,7487476,'din',20,1),(495,7487489,7487476,'ing',20,1),(495,7487490,7487485,'mes',20,1),(495,7487491,7487485,'ess',20,1),(495,7487492,7487485,'ssa',20,1),(495,7487493,7487485,'sag',20,1),(495,7487494,7487485,'age',20,1),(495,7487495,7487490,'wai',20,1),(495,7487496,7487490,'ait',20,1),(495,7487497,7487490,'iti',20,1),(495,7487498,7487490,'tin',20,1),(495,7487499,7487490,'ing',20,1),(495,7487500,7487495,'for',100,1),(495,7487501,7487500,'per',11.111,1),(495,7487502,7487500,'erf',11.111,1),(495,7487503,7487500,'rfo',11.111,1),(495,7487504,7487500,'for',11.111,1),(495,7487505,7487500,'orm',11.111,1),(495,7487506,7487500,'rma',11.111,1),(495,7487507,7487500,'man',11.111,1),(495,7487508,7487500,'anc',11.111,1),(495,7487509,7487500,'nce',11.111,1),(495,7487510,7487501,'ide',12.5,1),(495,7487511,7487501,'den',12.5,1),(495,7487512,7487501,'ent',12.5,1),(495,7487513,7487501,'nti',12.5,1),(495,7487514,7487501,'tif',12.5,1),(495,7487515,7487501,'ifi',12.5,1),(495,7487516,7487501,'fie',12.5,1),(495,7487517,7487501,'ier',12.5,1),(495,7487518,7487510,'vdi',33.333,3),(495,7487519,7487510,'dis',33.333,3),(495,7487520,7487510,'isk',33.333,3),(495,7487521,7487518,'nam',50,1),(495,7487522,7487518,'ame',50,1),(495,7487523,7487521,'typ',50,1),(495,7487524,7487521,'ype',50,1),(495,7487525,7487523,'dir',25,1),(495,7487526,7487523,'ire',25,1),(495,7487527,7487523,'rec',25,1),(495,7487528,7487523,'ect',25,1),(496,7487530,7487529,'naa',100,2),(496,7487531,7487530,'600',3.333,3),(496,7487532,7487530,'000',3.333,3),(496,7487533,7487530,'00c',3.333,3),(496,7487534,7487530,'0c2',3.333,3),(496,7487535,7487530,'c29',3.333,3),(496,7487536,7487530,'292',3.333,3),(496,7487537,7487530,'92e',3.333,3),(496,7487538,7487530,'2ef',3.333,3),(496,7487539,7487530,'eff',3.333,3),(496,7487540,7487530,'ff8',3.333,3),(496,7487541,7487530,'f8c',3.333,3),(496,7487542,7487530,'8ce',3.333,3),(496,7487543,7487530,'cec',3.333,3),(496,7487544,7487530,'eca',3.333,3),(496,7487545,7487530,'cad',3.333,3),(496,7487546,7487530,'ad5',3.333,3),(496,7487547,7487530,'d50',3.333,3),(496,7487548,7487530,'500',3.333,3),(496,7487549,7487530,'001',3.333,3),(496,7487550,7487530,'01c',3.333,3),(496,7487551,7487530,'1c0',3.333,3),(496,7487552,7487530,'c09',3.333,3),(496,7487553,7487530,'090',3.333,3),(496,7487554,7487530,'906',3.333,3),(496,7487555,7487530,'068',3.333,3),(496,7487556,7487530,'684',3.333,3),(496,7487557,7487530,'842',3.333,3),(496,7487558,7487530,'42e',3.333,3),(496,7487559,7487530,'2e8',3.333,3),(496,7487560,7487530,'e87',3.333,3),(496,7487561,7487531,'mon',100,1),(496,7487562,7487561,'201',50,1),(496,7487563,7487561,'013',50,1),(496,7487564,7487562,'adm',33.333,3),(496,7487565,7487562,'dmi',33.333,3),(496,7487566,7487562,'min',33.333,3),(496,7487567,7487564,'cap',16.667,1),(496,7487568,7487564,'apa',16.667,1),(496,7487569,7487564,'pac',16.667,1),(496,7487570,7487564,'aci',16.667,1),(496,7487571,7487564,'cit',16.667,1),(496,7487572,7487564,'ity',16.667,1),(496,7487573,7487567,'pat',50,1),(496,7487574,7487567,'ath',50,1),(496,7487575,7487573,'fre',14.286,1),(496,7487576,7487573,'ree',14.286,1),(496,7487577,7487573,'ees',14.286,1),(496,7487578,7487573,'esp',14.286,1),(496,7487579,7487573,'spa',14.286,1),(496,7487580,7487573,'pac',14.286,1),(496,7487581,7487573,'ace',14.286,1),(496,7487582,7487575,'dis',50,1),(496,7487583,7487575,'isk',50,1),(496,7487584,7487582,'ind',33.333,1),(496,7487585,7487582,'nde',33.333,1),(496,7487586,7487582,'dex',33.333,1),(496,7487587,7487584,'adm',8.333,1),(496,7487588,7487584,'dmi',8.333,1),(496,7487589,7487584,'min',8.333,1),(496,7487590,7487584,'ini',8.333,1),(496,7487591,7487584,'nis',8.333,1),(496,7487592,7487584,'ist',8.333,1),(496,7487593,7487584,'str',8.333,1),(496,7487594,7487584,'tra',8.333,1),(496,7487595,7487584,'rat',8.333,1),(496,7487596,7487584,'ati',8.333,1),(496,7487597,7487584,'tio',8.333,1),(496,7487598,7487584,'ion',8.333,1),(496,7487599,7487587,'sta',33.333,3),(496,7487600,7487587,'tat',33.333,3),(496,7487601,7487587,'ate',33.333,3),(496,7487602,7487599,'ena',20,2),(496,7487603,7487599,'nab',20,2),(496,7487604,7487599,'abl',20,2),(496,7487605,7487599,'ble',20,2),(496,7487606,7487599,'led',20,2),(496,7487607,7487602,'cac',33.333,2),(496,7487608,7487602,'ach',33.333,2),(496,7487609,7487602,'che',33.333,2),(496,7487610,7487607,'mod',50,1),(496,7487611,7487607,'ode',50,1),(496,7487612,7487610,'wri',14.286,1),(496,7487613,7487610,'rit',14.286,1),(496,7487614,7487610,'ite',14.286,1),(496,7487615,7487610,'tet',14.286,1),(496,7487616,7487610,'eth',14.286,1),(496,7487617,7487610,'thr',14.286,1),(496,7487618,7487610,'hru',14.286,1),(496,7487619,7487612,'ope',11.111,2),(496,7487620,7487612,'per',11.111,2),(496,7487621,7487612,'era',11.111,2),(496,7487622,7487612,'rat',11.111,2),(496,7487623,7487612,'ati',11.111,2),(496,7487624,7487612,'tio',11.111,2),(496,7487625,7487612,'ion',11.111,2),(496,7487626,7487612,'ona',11.111,2),(496,7487627,7487612,'nal',11.111,2),(496,7487628,7487619,'pen',20,1),(496,7487629,7487619,'end',20,1),(496,7487630,7487619,'ndi',20,1),(496,7487631,7487619,'din',20,1),(496,7487632,7487619,'ing',20,1),(496,7487633,7487628,'mes',20,1),(496,7487634,7487628,'ess',20,1),(496,7487635,7487628,'ssa',20,1),(496,7487636,7487628,'sag',20,1),(496,7487637,7487628,'age',20,1),(496,7487638,7487633,'wai',20,1),(496,7487639,7487633,'ait',20,1),(496,7487640,7487633,'iti',20,1),(496,7487641,7487633,'tin',20,1),(496,7487642,7487633,'ing',20,1),(496,7487643,7487638,'for',100,1),(496,7487644,7487643,'per',11.111,1),(496,7487645,7487643,'erf',11.111,1),(496,7487646,7487643,'rfo',11.111,1),(496,7487647,7487643,'for',11.111,1),(496,7487648,7487643,'orm',11.111,1),(496,7487649,7487643,'rma',11.111,1),(496,7487650,7487643,'man',11.111,1),(496,7487651,7487643,'anc',11.111,1),(496,7487652,7487643,'nce',11.111,1),(496,7487653,7487644,'ide',12.5,1),(496,7487654,7487644,'den',12.5,1),(496,7487655,7487644,'ent',12.5,1),(496,7487656,7487644,'nti',12.5,1),(496,7487657,7487644,'tif',12.5,1),(496,7487658,7487644,'ifi',12.5,1),(496,7487659,7487644,'fie',12.5,1),(496,7487660,7487644,'ier',12.5,1),(496,7487661,7487653,'vdi',33.333,3),(496,7487662,7487653,'dis',33.333,3),(496,7487663,7487653,'isk',33.333,3),(496,7487664,7487661,'nam',50,1),(496,7487665,7487661,'ame',50,1),(496,7487666,7487664,'typ',50,1),(496,7487667,7487664,'ype',50,1),(496,7487668,7487666,'dir',25,1),(496,7487669,7487666,'ire',25,1),(496,7487670,7487666,'rec',25,1),(496,7487671,7487666,'ect',25,1),(497,7487673,7487672,'naa',100,2),(497,7487674,7487673,'600',3.333,3),(497,7487675,7487673,'000',3.333,3),(497,7487676,7487673,'00c',3.333,3),(497,7487677,7487673,'0c2',3.333,3),(497,7487678,7487673,'c29',3.333,3),(497,7487679,7487673,'29a',3.333,3),(497,7487680,7487673,'9a3',3.333,3),(497,7487681,7487673,'a39',3.333,3),(497,7487682,7487673,'39d',3.333,3),(497,7487683,7487673,'9de',3.333,3),(497,7487684,7487673,'ded',3.333,3),(497,7487685,7487673,'ed4',3.333,3),(497,7487686,7487673,'d41',3.333,3),(497,7487687,7487673,'41d',3.333,3),(497,7487688,7487673,'1de',3.333,3),(497,7487689,7487673,'de2',3.333,3),(497,7487690,7487673,'e2e',3.333,3),(497,7487691,7487673,'2ea',3.333,3),(497,7487692,7487673,'eac',3.333,3),(497,7487693,7487673,'ac7',3.333,3),(497,7487694,7487673,'c70',3.333,3),(497,7487695,7487673,'701',3.333,3),(497,7487696,7487673,'019',3.333,3),(497,7487697,7487673,'19e',3.333,3),(497,7487698,7487673,'9e3',3.333,3),(497,7487699,7487673,'e34',3.333,3),(497,7487700,7487673,'34e',3.333,3),(497,7487701,7487673,'4e4',3.333,3),(497,7487702,7487673,'e42',3.333,3),(497,7487703,7487673,'426',3.333,3),(497,7487704,7487674,'mon',100,1),(497,7487705,7487704,'201',50,1),(497,7487706,7487704,'013',50,1),(497,7487707,7487705,'adm',33.333,3),(497,7487708,7487705,'dmi',33.333,3),(497,7487709,7487705,'min',33.333,3),(497,7487710,7487707,'cap',16.667,1),(497,7487711,7487707,'apa',16.667,1),(497,7487712,7487707,'pac',16.667,1),(497,7487713,7487707,'aci',16.667,1),(497,7487714,7487707,'cit',16.667,1),(497,7487715,7487707,'ity',16.667,1),(497,7487716,7487710,'pat',50,1),(497,7487717,7487710,'ath',50,1),(497,7487718,7487716,'fre',14.286,1),(497,7487719,7487716,'ree',14.286,1),(497,7487720,7487716,'ees',14.286,1),(497,7487721,7487716,'esp',14.286,1),(497,7487722,7487716,'spa',14.286,1),(497,7487723,7487716,'pac',14.286,1),(497,7487724,7487716,'ace',14.286,1),(497,7487725,7487718,'dis',50,1),(497,7487726,7487718,'isk',50,1),(497,7487727,7487725,'ind',33.333,1),(497,7487728,7487725,'nde',33.333,1),(497,7487729,7487725,'dex',33.333,1),(497,7487730,7487727,'adm',8.333,1),(497,7487731,7487727,'dmi',8.333,1),(497,7487732,7487727,'min',8.333,1),(497,7487733,7487727,'ini',8.333,1),(497,7487734,7487727,'nis',8.333,1),(497,7487735,7487727,'ist',8.333,1),(497,7487736,7487727,'str',8.333,1),(497,7487737,7487727,'tra',8.333,1),(497,7487738,7487727,'rat',8.333,1),(497,7487739,7487727,'ati',8.333,1),(497,7487740,7487727,'tio',8.333,1),(497,7487741,7487727,'ion',8.333,1),(497,7487742,7487730,'sta',33.333,3),(497,7487743,7487730,'tat',33.333,3),(497,7487744,7487730,'ate',33.333,3),(497,7487745,7487742,'ena',20,2),(497,7487746,7487742,'nab',20,2),(497,7487747,7487742,'abl',20,2),(497,7487748,7487742,'ble',20,2),(497,7487749,7487742,'led',20,2),(497,7487750,7487745,'cac',33.333,2),(497,7487751,7487745,'ach',33.333,2),(497,7487752,7487745,'che',33.333,2),(497,7487753,7487750,'mod',50,1),(497,7487754,7487750,'ode',50,1),(497,7487755,7487753,'wri',14.286,1),(497,7487756,7487753,'rit',14.286,1),(497,7487757,7487753,'ite',14.286,1),(497,7487758,7487753,'tet',14.286,1),(497,7487759,7487753,'eth',14.286,1),(497,7487760,7487753,'thr',14.286,1),(497,7487761,7487753,'hru',14.286,1),(497,7487762,7487755,'ope',11.111,2),(497,7487763,7487755,'per',11.111,2),(497,7487764,7487755,'era',11.111,2),(497,7487765,7487755,'rat',11.111,2),(497,7487766,7487755,'ati',11.111,2),(497,7487767,7487755,'tio',11.111,2),(497,7487768,7487755,'ion',11.111,2),(497,7487769,7487755,'ona',11.111,2),(497,7487770,7487755,'nal',11.111,2),(497,7487771,7487762,'pen',20,1),(497,7487772,7487762,'end',20,1),(497,7487773,7487762,'ndi',20,1),(497,7487774,7487762,'din',20,1),(497,7487775,7487762,'ing',20,1),(497,7487776,7487771,'mes',20,1),(497,7487777,7487771,'ess',20,1),(497,7487778,7487771,'ssa',20,1),(497,7487779,7487771,'sag',20,1),(497,7487780,7487771,'age',20,1),(497,7487781,7487776,'wai',20,1),(497,7487782,7487776,'ait',20,1),(497,7487783,7487776,'iti',20,1),(497,7487784,7487776,'tin',20,1),(497,7487785,7487776,'ing',20,1),(497,7487786,7487781,'for',100,1),(497,7487787,7487786,'per',11.111,1),(497,7487788,7487786,'erf',11.111,1),(497,7487789,7487786,'rfo',11.111,1),(497,7487790,7487786,'for',11.111,1),(497,7487791,7487786,'orm',11.111,1),(497,7487792,7487786,'rma',11.111,1),(497,7487793,7487786,'man',11.111,1),(497,7487794,7487786,'anc',11.111,1),(497,7487795,7487786,'nce',11.111,1),(497,7487796,7487787,'ide',12.5,1),(497,7487797,7487787,'den',12.5,1),(497,7487798,7487787,'ent',12.5,1),(497,7487799,7487787,'nti',12.5,1),(497,7487800,7487787,'tif',12.5,1),(497,7487801,7487787,'ifi',12.5,1),(497,7487802,7487787,'fie',12.5,1),(497,7487803,7487787,'ier',12.5,1),(497,7487804,7487796,'vdi',33.333,3),(497,7487805,7487796,'dis',33.333,3),(497,7487806,7487796,'isk',33.333,3),(497,7487807,7487804,'nam',50,1),(497,7487808,7487804,'ame',50,1),(497,7487809,7487807,'typ',50,1),(497,7487810,7487807,'ype',50,1),(497,7487811,7487809,'dir',25,1),(497,7487812,7487809,'ire',25,1),(497,7487813,7487809,'rec',25,1),(497,7487814,7487809,'ect',25,1),(498,7487816,7487815,'naa',100,2),(498,7487817,7487816,'600',3.333,3),(498,7487818,7487816,'000',3.333,3),(498,7487819,7487816,'00c',3.333,3),(498,7487820,7487816,'0c2',3.333,3),(498,7487821,7487816,'c29',3.333,3),(498,7487822,7487816,'298',3.333,3),(498,7487823,7487816,'988',3.333,3),(498,7487824,7487816,'889',3.333,3),(498,7487825,7487816,'89b',3.333,3),(498,7487826,7487816,'9b8',3.333,3),(498,7487827,7487816,'b8c',3.333,3),(498,7487828,7487816,'8ce',3.333,3),(498,7487829,7487816,'ce3',3.333,3),(498,7487830,7487816,'e3a',3.333,3),(498,7487831,7487816,'3ab',3.333,3),(498,7487832,7487816,'ab8',3.333,3),(498,7487833,7487816,'b87',3.333,3),(498,7487834,7487816,'879',3.333,3),(498,7487835,7487816,'791',3.333,3),(498,7487836,7487816,'913',3.333,3),(498,7487837,7487816,'132',3.333,3),(498,7487838,7487816,'32f',3.333,3),(498,7487839,7487816,'2fb',3.333,3),(498,7487840,7487816,'fb2',3.333,3),(498,7487841,7487816,'b22',3.333,3),(498,7487842,7487816,'22a',3.333,3),(498,7487843,7487816,'2ab',3.333,3),(498,7487844,7487816,'ab3',3.333,3),(498,7487845,7487816,'b3a',3.333,3),(498,7487846,7487816,'3ae',3.333,3),(498,7487847,7487817,'mon',100,1),(498,7487848,7487847,'201',50,1),(498,7487849,7487847,'013',50,1),(498,7487850,7487848,'adm',33.333,3),(498,7487851,7487848,'dmi',33.333,3),(498,7487852,7487848,'min',33.333,3),(498,7487853,7487850,'cap',16.667,1),(498,7487854,7487850,'apa',16.667,1),(498,7487855,7487850,'pac',16.667,1),(498,7487856,7487850,'aci',16.667,1),(498,7487857,7487850,'cit',16.667,1),(498,7487858,7487850,'ity',16.667,1),(498,7487859,7487853,'pat',50,1),(498,7487860,7487853,'ath',50,1),(498,7487861,7487859,'fre',14.286,1),(498,7487862,7487859,'ree',14.286,1),(498,7487863,7487859,'ees',14.286,1),(498,7487864,7487859,'esp',14.286,1),(498,7487865,7487859,'spa',14.286,1),(498,7487866,7487859,'pac',14.286,1),(498,7487867,7487859,'ace',14.286,1),(498,7487868,7487861,'dis',50,1),(498,7487869,7487861,'isk',50,1),(498,7487870,7487868,'ind',33.333,1),(498,7487871,7487868,'nde',33.333,1),(498,7487872,7487868,'dex',33.333,1),(498,7487873,7487870,'adm',8.333,1),(498,7487874,7487870,'dmi',8.333,1),(498,7487875,7487870,'min',8.333,1),(498,7487876,7487870,'ini',8.333,1),(498,7487877,7487870,'nis',8.333,1),(498,7487878,7487870,'ist',8.333,1),(498,7487879,7487870,'str',8.333,1),(498,7487880,7487870,'tra',8.333,1),(498,7487881,7487870,'rat',8.333,1),(498,7487882,7487870,'ati',8.333,1),(498,7487883,7487870,'tio',8.333,1),(498,7487884,7487870,'ion',8.333,1),(498,7487885,7487873,'sta',33.333,3),(498,7487886,7487873,'tat',33.333,3),(498,7487887,7487873,'ate',33.333,3),(498,7487888,7487885,'ena',20,2),(498,7487889,7487885,'nab',20,2),(498,7487890,7487885,'abl',20,2),(498,7487891,7487885,'ble',20,2),(498,7487892,7487885,'led',20,2),(498,7487893,7487888,'cac',33.333,2),(498,7487894,7487888,'ach',33.333,2),(498,7487895,7487888,'che',33.333,2),(498,7487896,7487893,'mod',50,1),(498,7487897,7487893,'ode',50,1),(498,7487898,7487896,'wri',14.286,1),(498,7487899,7487896,'rit',14.286,1),(498,7487900,7487896,'ite',14.286,1),(498,7487901,7487896,'tet',14.286,1),(498,7487902,7487896,'eth',14.286,1),(498,7487903,7487896,'thr',14.286,1),(498,7487904,7487896,'hru',14.286,1),(498,7487905,7487898,'ope',11.111,2),(498,7487906,7487898,'per',11.111,2),(498,7487907,7487898,'era',11.111,2),(498,7487908,7487898,'rat',11.111,2),(498,7487909,7487898,'ati',11.111,2),(498,7487910,7487898,'tio',11.111,2),(498,7487911,7487898,'ion',11.111,2),(498,7487912,7487898,'ona',11.111,2),(498,7487913,7487898,'nal',11.111,2),(498,7487914,7487905,'pen',20,1),(498,7487915,7487905,'end',20,1),(498,7487916,7487905,'ndi',20,1),(498,7487917,7487905,'din',20,1),(498,7487918,7487905,'ing',20,1),(498,7487919,7487914,'mes',20,1),(498,7487920,7487914,'ess',20,1),(498,7487921,7487914,'ssa',20,1),(498,7487922,7487914,'sag',20,1),(498,7487923,7487914,'age',20,1),(498,7487924,7487919,'wai',20,1),(498,7487925,7487919,'ait',20,1),(498,7487926,7487919,'iti',20,1),(498,7487927,7487919,'tin',20,1),(498,7487928,7487919,'ing',20,1),(498,7487929,7487924,'for',100,1),(498,7487930,7487929,'per',11.111,1),(498,7487931,7487929,'erf',11.111,1),(498,7487932,7487929,'rfo',11.111,1),(498,7487933,7487929,'for',11.111,1),(498,7487934,7487929,'orm',11.111,1),(498,7487935,7487929,'rma',11.111,1),(498,7487936,7487929,'man',11.111,1),(498,7487937,7487929,'anc',11.111,1),(498,7487938,7487929,'nce',11.111,1),(498,7487939,7487930,'ide',12.5,1),(498,7487940,7487930,'den',12.5,1),(498,7487941,7487930,'ent',12.5,1),(498,7487942,7487930,'nti',12.5,1),(498,7487943,7487930,'tif',12.5,1),(498,7487944,7487930,'ifi',12.5,1),(498,7487945,7487930,'fie',12.5,1),(498,7487946,7487930,'ier',12.5,1),(498,7487947,7487939,'vdi',33.333,3),(498,7487948,7487939,'dis',33.333,3),(498,7487949,7487939,'isk',33.333,3),(498,7487950,7487947,'nam',50,1),(498,7487951,7487947,'ame',50,1),(498,7487952,7487950,'typ',50,1),(498,7487953,7487950,'ype',50,1),(498,7487954,7487952,'dir',25,1),(498,7487955,7487952,'ire',25,1),(498,7487956,7487952,'rec',25,1),(498,7487957,7487952,'ect',25,1),(499,7487959,7487958,'naa',100,2),(499,7487960,7487959,'600',3.333,3),(499,7487961,7487959,'000',3.333,3),(499,7487962,7487959,'00c',3.333,3),(499,7487963,7487959,'0c2',3.333,3),(499,7487964,7487959,'c29',3.333,3),(499,7487965,7487959,'293',3.333,3),(499,7487966,7487959,'93b',3.333,3),(499,7487967,7487959,'3bd',3.333,3),(499,7487968,7487959,'bd0',3.333,3),(499,7487969,7487959,'d0a',3.333,3),(499,7487970,7487959,'0ae',3.333,3),(499,7487971,7487959,'ae1',3.333,3),(499,7487972,7487959,'e13',3.333,3),(499,7487973,7487959,'133',3.333,3),(499,7487974,7487959,'330',3.333,3),(499,7487975,7487959,'306',3.333,3),(499,7487976,7487959,'063',3.333,3),(499,7487977,7487959,'633',3.333,3),(499,7487978,7487959,'339',3.333,3),(499,7487979,7487959,'395',3.333,3),(499,7487980,7487959,'95b',3.333,3),(499,7487981,7487959,'5b9',3.333,3),(499,7487982,7487959,'b98',3.333,3),(499,7487983,7487959,'985',3.333,3),(499,7487984,7487959,'852',3.333,3),(499,7487985,7487959,'525',3.333,3),(499,7487986,7487959,'259',3.333,3),(499,7487987,7487959,'599',3.333,3),(499,7487988,7487959,'99d',3.333,3),(499,7487989,7487959,'9d9',3.333,3),(499,7487990,7487960,'mon',100,1),(499,7487991,7487990,'201',50,1),(499,7487992,7487990,'013',50,1),(499,7487993,7487991,'adm',33.333,3),(499,7487994,7487991,'dmi',33.333,3),(499,7487995,7487991,'min',33.333,3),(499,7487996,7487993,'cap',16.667,1),(499,7487997,7487993,'apa',16.667,1),(499,7487998,7487993,'pac',16.667,1),(499,7487999,7487993,'aci',16.667,1),(499,7488000,7487993,'cit',16.667,1),(499,7488001,7487993,'ity',16.667,1),(499,7488002,7487996,'pat',50,1),(499,7488003,7487996,'ath',50,1),(499,7488004,7488002,'fre',14.286,1),(499,7488005,7488002,'ree',14.286,1),(499,7488006,7488002,'ees',14.286,1),(499,7488007,7488002,'esp',14.286,1),(499,7488008,7488002,'spa',14.286,1),(499,7488009,7488002,'pac',14.286,1),(499,7488010,7488002,'ace',14.286,1),(499,7488011,7488004,'dis',50,1),(499,7488012,7488004,'isk',50,1),(499,7488013,7488011,'ind',33.333,1),(499,7488014,7488011,'nde',33.333,1),(499,7488015,7488011,'dex',33.333,1),(499,7488016,7488013,'adm',8.333,1),(499,7488017,7488013,'dmi',8.333,1),(499,7488018,7488013,'min',8.333,1),(499,7488019,7488013,'ini',8.333,1),(499,7488020,7488013,'nis',8.333,1),(499,7488021,7488013,'ist',8.333,1),(499,7488022,7488013,'str',8.333,1),(499,7488023,7488013,'tra',8.333,1),(499,7488024,7488013,'rat',8.333,1),(499,7488025,7488013,'ati',8.333,1),(499,7488026,7488013,'tio',8.333,1),(499,7488027,7488013,'ion',8.333,1),(499,7488028,7488016,'sta',33.333,3),(499,7488029,7488016,'tat',33.333,3),(499,7488030,7488016,'ate',33.333,3),(499,7488031,7488028,'ena',20,2),(499,7488032,7488028,'nab',20,2),(499,7488033,7488028,'abl',20,2),(499,7488034,7488028,'ble',20,2),(499,7488035,7488028,'led',20,2),(499,7488036,7488031,'cac',33.333,2),(499,7488037,7488031,'ach',33.333,2),(499,7488038,7488031,'che',33.333,2),(499,7488039,7488036,'mod',50,1),(499,7488040,7488036,'ode',50,1),(499,7488041,7488039,'wri',14.286,1),(499,7488042,7488039,'rit',14.286,1),(499,7488043,7488039,'ite',14.286,1),(499,7488044,7488039,'tet',14.286,1),(499,7488045,7488039,'eth',14.286,1),(499,7488046,7488039,'thr',14.286,1),(499,7488047,7488039,'hru',14.286,1),(499,7488048,7488041,'ope',11.111,2),(499,7488049,7488041,'per',11.111,2),(499,7488050,7488041,'era',11.111,2),(499,7488051,7488041,'rat',11.111,2),(499,7488052,7488041,'ati',11.111,2),(499,7488053,7488041,'tio',11.111,2),(499,7488054,7488041,'ion',11.111,2),(499,7488055,7488041,'ona',11.111,2),(499,7488056,7488041,'nal',11.111,2),(499,7488057,7488048,'pen',20,1),(499,7488058,7488048,'end',20,1),(499,7488059,7488048,'ndi',20,1),(499,7488060,7488048,'din',20,1),(499,7488061,7488048,'ing',20,1),(499,7488062,7488057,'mes',20,1),(499,7488063,7488057,'ess',20,1),(499,7488064,7488057,'ssa',20,1),(499,7488065,7488057,'sag',20,1),(499,7488066,7488057,'age',20,1),(499,7488067,7488062,'wai',20,1),(499,7488068,7488062,'ait',20,1),(499,7488069,7488062,'iti',20,1),(499,7488070,7488062,'tin',20,1),(499,7488071,7488062,'ing',20,1),(499,7488072,7488067,'for',100,1),(499,7488073,7488072,'per',11.111,1),(499,7488074,7488072,'erf',11.111,1),(499,7488075,7488072,'rfo',11.111,1),(499,7488076,7488072,'for',11.111,1),(499,7488077,7488072,'orm',11.111,1),(499,7488078,7488072,'rma',11.111,1),(499,7488079,7488072,'man',11.111,1),(499,7488080,7488072,'anc',11.111,1),(499,7488081,7488072,'nce',11.111,1),(499,7488082,7488073,'ide',12.5,1),(499,7488083,7488073,'den',12.5,1),(499,7488084,7488073,'ent',12.5,1),(499,7488085,7488073,'nti',12.5,1),(499,7488086,7488073,'tif',12.5,1),(499,7488087,7488073,'ifi',12.5,1),(499,7488088,7488073,'fie',12.5,1),(499,7488089,7488073,'ier',12.5,1),(499,7488090,7488082,'vdi',33.333,3),(499,7488091,7488082,'dis',33.333,3),(499,7488092,7488082,'isk',33.333,3),(499,7488093,7488090,'nam',50,1),(499,7488094,7488090,'ame',50,1),(499,7488095,7488093,'typ',50,1),(499,7488096,7488093,'ype',50,1),(499,7488097,7488095,'dir',25,1),(499,7488098,7488095,'ire',25,1),(499,7488099,7488095,'rec',25,1),(499,7488100,7488095,'ect',25,1),(500,7488102,7488101,'naa',100,2),(500,7488103,7488102,'600',3.333,3),(500,7488104,7488102,'000',3.333,3),(500,7488105,7488102,'00c',3.333,3),(500,7488106,7488102,'0c2',3.333,3),(500,7488107,7488102,'c29',3.333,3),(500,7488108,7488102,'29f',3.333,3),(500,7488109,7488102,'9fe',3.333,3),(500,7488110,7488102,'fe6',3.333,3),(500,7488111,7488102,'e6a',3.333,3),(500,7488112,7488102,'6af',3.333,3),(500,7488113,7488102,'af6',3.333,3),(500,7488114,7488102,'f6e',3.333,3),(500,7488115,7488102,'6e6',3.333,3),(500,7488116,7488102,'e68',3.333,3),(500,7488117,7488102,'689',3.333,3),(500,7488118,7488102,'89f',3.333,3),(500,7488119,7488102,'9fe',3.333,3),(500,7488120,7488102,'fe2',3.333,3),(500,7488121,7488102,'e22',3.333,3),(500,7488122,7488102,'223',3.333,3),(500,7488123,7488102,'23d',3.333,3),(500,7488124,7488102,'3d0',3.333,3),(500,7488125,7488102,'d09',3.333,3),(500,7488126,7488102,'09a',3.333,3),(500,7488127,7488102,'9a2',3.333,3),(500,7488128,7488102,'a26',3.333,3),(500,7488129,7488102,'26c',3.333,3),(500,7488130,7488102,'6cb',3.333,3),(500,7488131,7488102,'cb3',3.333,3),(500,7488132,7488102,'b3b',3.333,3),(500,7488133,7488103,'mon',100,1),(500,7488134,7488133,'201',50,1),(500,7488135,7488133,'013',50,1),(500,7488136,7488134,'adm',33.333,3),(500,7488137,7488134,'dmi',33.333,3),(500,7488138,7488134,'min',33.333,3),(500,7488139,7488136,'cap',16.667,1),(500,7488140,7488136,'apa',16.667,1),(500,7488141,7488136,'pac',16.667,1),(500,7488142,7488136,'aci',16.667,1),(500,7488143,7488136,'cit',16.667,1),(500,7488144,7488136,'ity',16.667,1),(500,7488145,7488139,'pat',50,1),(500,7488146,7488139,'ath',50,1),(500,7488147,7488145,'fre',14.286,1),(500,7488148,7488145,'ree',14.286,1),(500,7488149,7488145,'ees',14.286,1),(500,7488150,7488145,'esp',14.286,1),(500,7488151,7488145,'spa',14.286,1),(500,7488152,7488145,'pac',14.286,1),(500,7488153,7488145,'ace',14.286,1),(500,7488154,7488147,'dis',50,1),(500,7488155,7488147,'isk',50,1),(500,7488156,7488154,'ind',33.333,1),(500,7488157,7488154,'nde',33.333,1),(500,7488158,7488154,'dex',33.333,1),(500,7488159,7488156,'adm',8.333,1),(500,7488160,7488156,'dmi',8.333,1),(500,7488161,7488156,'min',8.333,1),(500,7488162,7488156,'ini',8.333,1),(500,7488163,7488156,'nis',8.333,1),(500,7488164,7488156,'ist',8.333,1),(500,7488165,7488156,'str',8.333,1),(500,7488166,7488156,'tra',8.333,1),(500,7488167,7488156,'rat',8.333,1),(500,7488168,7488156,'ati',8.333,1),(500,7488169,7488156,'tio',8.333,1),(500,7488170,7488156,'ion',8.333,1),(500,7488171,7488159,'sta',33.333,3),(500,7488172,7488159,'tat',33.333,3),(500,7488173,7488159,'ate',33.333,3),(500,7488174,7488171,'ena',20,2),(500,7488175,7488171,'nab',20,2),(500,7488176,7488171,'abl',20,2),(500,7488177,7488171,'ble',20,2),(500,7488178,7488171,'led',20,2),(500,7488179,7488174,'cac',33.333,2),(500,7488180,7488174,'ach',33.333,2),(500,7488181,7488174,'che',33.333,2),(500,7488182,7488179,'mod',50,1),(500,7488183,7488179,'ode',50,1),(500,7488184,7488182,'wri',14.286,1),(500,7488185,7488182,'rit',14.286,1),(500,7488186,7488182,'ite',14.286,1),(500,7488187,7488182,'tet',14.286,1),(500,7488188,7488182,'eth',14.286,1),(500,7488189,7488182,'thr',14.286,1),(500,7488190,7488182,'hru',14.286,1),(500,7488191,7488184,'ope',11.111,2),(500,7488192,7488184,'per',11.111,2),(500,7488193,7488184,'era',11.111,2),(500,7488194,7488184,'rat',11.111,2),(500,7488195,7488184,'ati',11.111,2),(500,7488196,7488184,'tio',11.111,2),(500,7488197,7488184,'ion',11.111,2),(500,7488198,7488184,'ona',11.111,2),(500,7488199,7488184,'nal',11.111,2),(500,7488200,7488191,'pen',20,1),(500,7488201,7488191,'end',20,1),(500,7488202,7488191,'ndi',20,1),(500,7488203,7488191,'din',20,1),(500,7488204,7488191,'ing',20,1),(500,7488205,7488200,'mes',20,1),(500,7488206,7488200,'ess',20,1),(500,7488207,7488200,'ssa',20,1),(500,7488208,7488200,'sag',20,1),(500,7488209,7488200,'age',20,1),(500,7488210,7488205,'wai',20,1),(500,7488211,7488205,'ait',20,1),(500,7488212,7488205,'iti',20,1),(500,7488213,7488205,'tin',20,1),(500,7488214,7488205,'ing',20,1),(500,7488215,7488210,'for',100,1),(500,7488216,7488215,'per',11.111,1),(500,7488217,7488215,'erf',11.111,1),(500,7488218,7488215,'rfo',11.111,1),(500,7488219,7488215,'for',11.111,1),(500,7488220,7488215,'orm',11.111,1),(500,7488221,7488215,'rma',11.111,1),(500,7488222,7488215,'man',11.111,1),(500,7488223,7488215,'anc',11.111,1),(500,7488224,7488215,'nce',11.111,1),(500,7488225,7488216,'ide',12.5,1),(500,7488226,7488216,'den',12.5,1),(500,7488227,7488216,'ent',12.5,1),(500,7488228,7488216,'nti',12.5,1),(500,7488229,7488216,'tif',12.5,1),(500,7488230,7488216,'ifi',12.5,1),(500,7488231,7488216,'fie',12.5,1),(500,7488232,7488216,'ier',12.5,1),(500,7488233,7488225,'vdi',33.333,3),(500,7488234,7488225,'dis',33.333,3),(500,7488235,7488225,'isk',33.333,3),(500,7488236,7488233,'nam',50,1),(500,7488237,7488233,'ame',50,1),(500,7488238,7488236,'typ',50,1),(500,7488239,7488236,'ype',50,1),(500,7488240,7488238,'dir',25,1),(500,7488241,7488238,'ire',25,1),(500,7488242,7488238,'rec',25,1),(500,7488243,7488238,'ect',25,1),(501,7488245,7488244,'naa',100,2),(501,7488246,7488245,'600',3.333,3),(501,7488247,7488245,'000',3.333,3),(501,7488248,7488245,'00c',3.333,3),(501,7488249,7488245,'0c2',3.333,3),(501,7488250,7488245,'c29',3.333,3),(501,7488251,7488245,'298',3.333,3),(501,7488252,7488245,'98f',3.333,3),(501,7488253,7488245,'8f8',3.333,3),(501,7488254,7488245,'f88',3.333,3),(501,7488255,7488245,'880',3.333,3),(501,7488256,7488245,'809',3.333,3),(501,7488257,7488245,'094',3.333,3),(501,7488258,7488245,'945',3.333,3),(501,7488259,7488245,'453',3.333,3),(501,7488260,7488245,'53b',3.333,3),(501,7488261,7488245,'3b3',3.333,3),(501,7488262,7488245,'b3b',3.333,3),(501,7488263,7488245,'3bb',3.333,3),(501,7488264,7488245,'bb1',3.333,3),(501,7488265,7488245,'b18',3.333,3),(501,7488266,7488245,'188',3.333,3),(501,7488267,7488245,'886',3.333,3),(501,7488268,7488245,'86f',3.333,3),(501,7488269,7488245,'6f1',3.333,3),(501,7488270,7488245,'f1d',3.333,3),(501,7488271,7488245,'1dd',3.333,3),(501,7488272,7488245,'dd1',3.333,3),(501,7488273,7488245,'d1a',3.333,3),(501,7488274,7488245,'1a1',3.333,3),(501,7488275,7488245,'a1f',3.333,3),(501,7488276,7488246,'mon',100,1),(501,7488277,7488276,'201',50,1),(501,7488278,7488276,'013',50,1),(501,7488279,7488277,'adm',33.333,3),(501,7488280,7488277,'dmi',33.333,3),(501,7488281,7488277,'min',33.333,3),(501,7488282,7488279,'cap',16.667,1),(501,7488283,7488279,'apa',16.667,1),(501,7488284,7488279,'pac',16.667,1),(501,7488285,7488279,'aci',16.667,1),(501,7488286,7488279,'cit',16.667,1),(501,7488287,7488279,'ity',16.667,1),(501,7488288,7488282,'pat',50,1),(501,7488289,7488282,'ath',50,1),(501,7488290,7488288,'fre',14.286,1),(501,7488291,7488288,'ree',14.286,1),(501,7488292,7488288,'ees',14.286,1),(501,7488293,7488288,'esp',14.286,1),(501,7488294,7488288,'spa',14.286,1),(501,7488295,7488288,'pac',14.286,1),(501,7488296,7488288,'ace',14.286,1),(501,7488297,7488290,'dis',50,1),(501,7488298,7488290,'isk',50,1),(501,7488299,7488297,'ind',33.333,1),(501,7488300,7488297,'nde',33.333,1),(501,7488301,7488297,'dex',33.333,1),(501,7488302,7488299,'adm',8.333,1),(501,7488303,7488299,'dmi',8.333,1),(501,7488304,7488299,'min',8.333,1),(501,7488305,7488299,'ini',8.333,1),(501,7488306,7488299,'nis',8.333,1),(501,7488307,7488299,'ist',8.333,1),(501,7488308,7488299,'str',8.333,1),(501,7488309,7488299,'tra',8.333,1),(501,7488310,7488299,'rat',8.333,1),(501,7488311,7488299,'ati',8.333,1),(501,7488312,7488299,'tio',8.333,1),(501,7488313,7488299,'ion',8.333,1),(501,7488314,7488302,'sta',33.333,3),(501,7488315,7488302,'tat',33.333,3),(501,7488316,7488302,'ate',33.333,3),(501,7488317,7488314,'ena',20,2),(501,7488318,7488314,'nab',20,2),(501,7488319,7488314,'abl',20,2),(501,7488320,7488314,'ble',20,2),(501,7488321,7488314,'led',20,2),(501,7488322,7488317,'cac',33.333,2),(501,7488323,7488317,'ach',33.333,2),(501,7488324,7488317,'che',33.333,2),(501,7488325,7488322,'mod',50,1),(501,7488326,7488322,'ode',50,1),(501,7488327,7488325,'wri',14.286,1),(501,7488328,7488325,'rit',14.286,1),(501,7488329,7488325,'ite',14.286,1),(501,7488330,7488325,'tet',14.286,1),(501,7488331,7488325,'eth',14.286,1),(501,7488332,7488325,'thr',14.286,1),(501,7488333,7488325,'hru',14.286,1),(501,7488334,7488327,'ope',11.111,2),(501,7488335,7488327,'per',11.111,2),(501,7488336,7488327,'era',11.111,2),(501,7488337,7488327,'rat',11.111,2),(501,7488338,7488327,'ati',11.111,2),(501,7488339,7488327,'tio',11.111,2),(501,7488340,7488327,'ion',11.111,2),(501,7488341,7488327,'ona',11.111,2),(501,7488342,7488327,'nal',11.111,2),(501,7488343,7488334,'pen',20,1),(501,7488344,7488334,'end',20,1),(501,7488345,7488334,'ndi',20,1),(501,7488346,7488334,'din',20,1),(501,7488347,7488334,'ing',20,1),(501,7488348,7488343,'mes',20,1),(501,7488349,7488343,'ess',20,1),(501,7488350,7488343,'ssa',20,1),(501,7488351,7488343,'sag',20,1),(501,7488352,7488343,'age',20,1),(501,7488353,7488348,'wai',20,1),(501,7488354,7488348,'ait',20,1),(501,7488355,7488348,'iti',20,1),(501,7488356,7488348,'tin',20,1),(501,7488357,7488348,'ing',20,1),(501,7488358,7488353,'for',100,1),(501,7488359,7488358,'per',11.111,1),(501,7488360,7488358,'erf',11.111,1),(501,7488361,7488358,'rfo',11.111,1),(501,7488362,7488358,'for',11.111,1),(501,7488363,7488358,'orm',11.111,1),(501,7488364,7488358,'rma',11.111,1),(501,7488365,7488358,'man',11.111,1),(501,7488366,7488358,'anc',11.111,1),(501,7488367,7488358,'nce',11.111,1),(501,7488368,7488359,'ide',12.5,1),(501,7488369,7488359,'den',12.5,1),(501,7488370,7488359,'ent',12.5,1),(501,7488371,7488359,'nti',12.5,1),(501,7488372,7488359,'tif',12.5,1),(501,7488373,7488359,'ifi',12.5,1),(501,7488374,7488359,'fie',12.5,1),(501,7488375,7488359,'ier',12.5,1),(501,7488376,7488368,'vdi',33.333,3),(501,7488377,7488368,'dis',33.333,3),(501,7488378,7488368,'isk',33.333,3),(501,7488379,7488376,'nam',50,1),(501,7488380,7488376,'ame',50,1),(501,7488381,7488379,'typ',50,1),(501,7488382,7488379,'ype',50,1),(501,7488383,7488381,'dir',25,1),(501,7488384,7488381,'ire',25,1),(501,7488385,7488381,'rec',25,1),(501,7488386,7488381,'ect',25,1),(502,7488388,7488387,'naa',100,2),(502,7488389,7488388,'600',3.333,3),(502,7488390,7488388,'000',3.333,3),(502,7488391,7488388,'00c',3.333,3),(502,7488392,7488388,'0c2',3.333,3),(502,7488393,7488388,'c29',3.333,3),(502,7488394,7488388,'296',3.333,3),(502,7488395,7488388,'962',3.333,3),(502,7488396,7488388,'625',3.333,3),(502,7488397,7488388,'254',3.333,3),(502,7488398,7488388,'542',3.333,3),(502,7488399,7488388,'427',3.333,3),(502,7488400,7488388,'27a',3.333,3),(502,7488401,7488388,'7a3',3.333,3),(502,7488402,7488388,'a3e',3.333,3),(502,7488403,7488388,'3e2',3.333,3),(502,7488404,7488388,'e24',3.333,3),(502,7488405,7488388,'243',3.333,3),(502,7488406,7488388,'437',3.333,3),(502,7488407,7488388,'372',3.333,3),(502,7488408,7488388,'721',3.333,3),(502,7488409,7488388,'217',3.333,3),(502,7488410,7488388,'176',3.333,3),(502,7488411,7488388,'760',3.333,3),(502,7488412,7488388,'60c',3.333,3),(502,7488413,7488388,'0c8',3.333,3),(502,7488414,7488388,'c88',3.333,3),(502,7488415,7488388,'88d',3.333,3),(502,7488416,7488388,'8d3',3.333,3),(502,7488417,7488388,'d30',3.333,3),(502,7488418,7488388,'306',3.333,3),(502,7488419,7488389,'mon',100,1),(502,7488420,7488419,'201',50,1),(502,7488421,7488419,'013',50,1),(502,7488422,7488420,'adm',33.333,3),(502,7488423,7488420,'dmi',33.333,3),(502,7488424,7488420,'min',33.333,3),(502,7488425,7488422,'cap',16.667,1),(502,7488426,7488422,'apa',16.667,1),(502,7488427,7488422,'pac',16.667,1),(502,7488428,7488422,'aci',16.667,1),(502,7488429,7488422,'cit',16.667,1),(502,7488430,7488422,'ity',16.667,1),(502,7488431,7488425,'pat',50,1),(502,7488432,7488425,'ath',50,1),(502,7488433,7488431,'fre',14.286,1),(502,7488434,7488431,'ree',14.286,1),(502,7488435,7488431,'ees',14.286,1),(502,7488436,7488431,'esp',14.286,1),(502,7488437,7488431,'spa',14.286,1),(502,7488438,7488431,'pac',14.286,1),(502,7488439,7488431,'ace',14.286,1),(502,7488440,7488433,'dis',50,1),(502,7488441,7488433,'isk',50,1),(502,7488442,7488440,'ind',33.333,1),(502,7488443,7488440,'nde',33.333,1),(502,7488444,7488440,'dex',33.333,1),(502,7488445,7488442,'adm',8.333,1),(502,7488446,7488442,'dmi',8.333,1),(502,7488447,7488442,'min',8.333,1),(502,7488448,7488442,'ini',8.333,1),(502,7488449,7488442,'nis',8.333,1),(502,7488450,7488442,'ist',8.333,1),(502,7488451,7488442,'str',8.333,1),(502,7488452,7488442,'tra',8.333,1),(502,7488453,7488442,'rat',8.333,1),(502,7488454,7488442,'ati',8.333,1),(502,7488455,7488442,'tio',8.333,1),(502,7488456,7488442,'ion',8.333,1),(502,7488457,7488445,'sta',33.333,3),(502,7488458,7488445,'tat',33.333,3),(502,7488459,7488445,'ate',33.333,3),(502,7488460,7488457,'ena',20,2),(502,7488461,7488457,'nab',20,2),(502,7488462,7488457,'abl',20,2),(502,7488463,7488457,'ble',20,2),(502,7488464,7488457,'led',20,2),(502,7488465,7488460,'cac',33.333,2),(502,7488466,7488460,'ach',33.333,2),(502,7488467,7488460,'che',33.333,2),(502,7488468,7488465,'mod',50,1),(502,7488469,7488465,'ode',50,1),(502,7488470,7488468,'wri',14.286,1),(502,7488471,7488468,'rit',14.286,1),(502,7488472,7488468,'ite',14.286,1),(502,7488473,7488468,'tet',14.286,1),(502,7488474,7488468,'eth',14.286,1),(502,7488475,7488468,'thr',14.286,1),(502,7488476,7488468,'hru',14.286,1),(502,7488477,7488470,'ope',11.111,2),(502,7488478,7488470,'per',11.111,2),(502,7488479,7488470,'era',11.111,2),(502,7488480,7488470,'rat',11.111,2),(502,7488481,7488470,'ati',11.111,2),(502,7488482,7488470,'tio',11.111,2),(502,7488483,7488470,'ion',11.111,2),(502,7488484,7488470,'ona',11.111,2),(502,7488485,7488470,'nal',11.111,2),(502,7488486,7488477,'pen',20,1),(502,7488487,7488477,'end',20,1),(502,7488488,7488477,'ndi',20,1),(502,7488489,7488477,'din',20,1),(502,7488490,7488477,'ing',20,1),(502,7488491,7488486,'mes',20,1),(502,7488492,7488486,'ess',20,1),(502,7488493,7488486,'ssa',20,1),(502,7488494,7488486,'sag',20,1),(502,7488495,7488486,'age',20,1),(502,7488496,7488491,'wai',20,1),(502,7488497,7488491,'ait',20,1),(502,7488498,7488491,'iti',20,1),(502,7488499,7488491,'tin',20,1),(502,7488500,7488491,'ing',20,1),(502,7488501,7488496,'for',100,1),(502,7488502,7488501,'per',11.111,1),(502,7488503,7488501,'erf',11.111,1),(502,7488504,7488501,'rfo',11.111,1),(502,7488505,7488501,'for',11.111,1),(502,7488506,7488501,'orm',11.111,1),(502,7488507,7488501,'rma',11.111,1),(502,7488508,7488501,'man',11.111,1),(502,7488509,7488501,'anc',11.111,1),(502,7488510,7488501,'nce',11.111,1),(502,7488511,7488502,'ide',12.5,1),(502,7488512,7488502,'den',12.5,1),(502,7488513,7488502,'ent',12.5,1),(502,7488514,7488502,'nti',12.5,1),(502,7488515,7488502,'tif',12.5,1),(502,7488516,7488502,'ifi',12.5,1),(502,7488517,7488502,'fie',12.5,1),(502,7488518,7488502,'ier',12.5,1),(502,7488519,7488511,'vdi',33.333,3),(502,7488520,7488511,'dis',33.333,3),(502,7488521,7488511,'isk',33.333,3),(502,7488522,7488519,'nam',50,1),(502,7488523,7488519,'ame',50,1),(502,7488524,7488522,'typ',50,1),(502,7488525,7488522,'ype',50,1),(502,7488526,7488524,'dir',25,1),(502,7488527,7488524,'ire',25,1),(502,7488528,7488524,'rec',25,1),(502,7488529,7488524,'ect',25,1),(503,7488531,7488530,'naa',100,2),(503,7488532,7488531,'600',3.333,3),(503,7488533,7488531,'000',3.333,3),(503,7488534,7488531,'00c',3.333,3),(503,7488535,7488531,'0c2',3.333,3),(503,7488536,7488531,'c29',3.333,3),(503,7488537,7488531,'298',3.333,3),(503,7488538,7488531,'98e',3.333,3),(503,7488539,7488531,'8e6',3.333,3),(503,7488540,7488531,'e66',3.333,3),(503,7488541,7488531,'66d',3.333,3),(503,7488542,7488531,'6d0',3.333,3),(503,7488543,7488531,'d04',3.333,3),(503,7488544,7488531,'040',3.333,3),(503,7488545,7488531,'40f',3.333,3),(503,7488546,7488531,'0f6',3.333,3),(503,7488547,7488531,'f64',3.333,3),(503,7488548,7488531,'640',3.333,3),(503,7488549,7488531,'407',3.333,3),(503,7488550,7488531,'07b',3.333,3),(503,7488551,7488531,'7b6',3.333,3),(503,7488552,7488531,'b68',3.333,3),(503,7488553,7488531,'68e',3.333,3),(503,7488554,7488531,'8e0',3.333,3),(503,7488555,7488531,'e09',3.333,3),(503,7488556,7488531,'099',3.333,3),(503,7488557,7488531,'99c',3.333,3),(503,7488558,7488531,'9c7',3.333,3),(503,7488559,7488531,'c7c',3.333,3),(503,7488560,7488531,'7cc',3.333,3),(503,7488561,7488531,'cc2',3.333,3),(503,7488562,7488532,'mon',100,1),(503,7488563,7488562,'201',50,1),(503,7488564,7488562,'013',50,1),(503,7488565,7488563,'adm',33.333,3),(503,7488566,7488563,'dmi',33.333,3),(503,7488567,7488563,'min',33.333,3),(503,7488568,7488565,'cap',16.667,1),(503,7488569,7488565,'apa',16.667,1),(503,7488570,7488565,'pac',16.667,1),(503,7488571,7488565,'aci',16.667,1),(503,7488572,7488565,'cit',16.667,1),(503,7488573,7488565,'ity',16.667,1),(503,7488574,7488568,'pat',50,1),(503,7488575,7488568,'ath',50,1),(503,7488576,7488574,'fre',14.286,1),(503,7488577,7488574,'ree',14.286,1),(503,7488578,7488574,'ees',14.286,1),(503,7488579,7488574,'esp',14.286,1),(503,7488580,7488574,'spa',14.286,1),(503,7488581,7488574,'pac',14.286,1),(503,7488582,7488574,'ace',14.286,1),(503,7488583,7488576,'dis',50,1),(503,7488584,7488576,'isk',50,1),(503,7488585,7488583,'ind',33.333,1),(503,7488586,7488583,'nde',33.333,1),(503,7488587,7488583,'dex',33.333,1),(503,7488588,7488585,'adm',8.333,1),(503,7488589,7488585,'dmi',8.333,1),(503,7488590,7488585,'min',8.333,1),(503,7488591,7488585,'ini',8.333,1),(503,7488592,7488585,'nis',8.333,1),(503,7488593,7488585,'ist',8.333,1),(503,7488594,7488585,'str',8.333,1),(503,7488595,7488585,'tra',8.333,1),(503,7488596,7488585,'rat',8.333,1),(503,7488597,7488585,'ati',8.333,1),(503,7488598,7488585,'tio',8.333,1),(503,7488599,7488585,'ion',8.333,1),(503,7488600,7488588,'sta',33.333,3),(503,7488601,7488588,'tat',33.333,3),(503,7488602,7488588,'ate',33.333,3),(503,7488603,7488600,'ena',20,2),(503,7488604,7488600,'nab',20,2),(503,7488605,7488600,'abl',20,2),(503,7488606,7488600,'ble',20,2),(503,7488607,7488600,'led',20,2),(503,7488608,7488603,'cac',33.333,2),(503,7488609,7488603,'ach',33.333,2),(503,7488610,7488603,'che',33.333,2),(503,7488611,7488608,'mod',50,1),(503,7488612,7488608,'ode',50,1),(503,7488613,7488611,'wri',14.286,1),(503,7488614,7488611,'rit',14.286,1),(503,7488615,7488611,'ite',14.286,1),(503,7488616,7488611,'tet',14.286,1),(503,7488617,7488611,'eth',14.286,1),(503,7488618,7488611,'thr',14.286,1),(503,7488619,7488611,'hru',14.286,1),(503,7488620,7488613,'ope',11.111,2),(503,7488621,7488613,'per',11.111,2),(503,7488622,7488613,'era',11.111,2),(503,7488623,7488613,'rat',11.111,2),(503,7488624,7488613,'ati',11.111,2),(503,7488625,7488613,'tio',11.111,2),(503,7488626,7488613,'ion',11.111,2),(503,7488627,7488613,'ona',11.111,2),(503,7488628,7488613,'nal',11.111,2),(503,7488629,7488620,'pen',20,1),(503,7488630,7488620,'end',20,1),(503,7488631,7488620,'ndi',20,1),(503,7488632,7488620,'din',20,1),(503,7488633,7488620,'ing',20,1),(503,7488634,7488629,'mes',20,1),(503,7488635,7488629,'ess',20,1),(503,7488636,7488629,'ssa',20,1),(503,7488637,7488629,'sag',20,1),(503,7488638,7488629,'age',20,1),(503,7488639,7488634,'wai',20,1),(503,7488640,7488634,'ait',20,1),(503,7488641,7488634,'iti',20,1),(503,7488642,7488634,'tin',20,1),(503,7488643,7488634,'ing',20,1),(503,7488644,7488639,'for',100,1),(503,7488645,7488644,'per',11.111,1),(503,7488646,7488644,'erf',11.111,1),(503,7488647,7488644,'rfo',11.111,1),(503,7488648,7488644,'for',11.111,1),(503,7488649,7488644,'orm',11.111,1),(503,7488650,7488644,'rma',11.111,1),(503,7488651,7488644,'man',11.111,1),(503,7488652,7488644,'anc',11.111,1),(503,7488653,7488644,'nce',11.111,1),(503,7488654,7488645,'ide',12.5,1),(503,7488655,7488645,'den',12.5,1),(503,7488656,7488645,'ent',12.5,1),(503,7488657,7488645,'nti',12.5,1),(503,7488658,7488645,'tif',12.5,1),(503,7488659,7488645,'ifi',12.5,1),(503,7488660,7488645,'fie',12.5,1),(503,7488661,7488645,'ier',12.5,1),(503,7488662,7488654,'vdi',33.333,3),(503,7488663,7488654,'dis',33.333,3),(503,7488664,7488654,'isk',33.333,3),(503,7488665,7488662,'nam',50,1),(503,7488666,7488662,'ame',50,1),(503,7488667,7488665,'typ',50,1),(503,7488668,7488665,'ype',50,1),(503,7488669,7488667,'dir',25,1),(503,7488670,7488667,'ire',25,1),(503,7488671,7488667,'rec',25,1),(503,7488672,7488667,'ect',25,1),(504,7488674,7488673,'naa',100,2),(504,7488675,7488674,'600',3.333,3),(504,7488676,7488674,'000',3.333,3),(504,7488677,7488674,'00c',3.333,3),(504,7488678,7488674,'0c2',3.333,3),(504,7488679,7488674,'c29',3.333,3),(504,7488680,7488674,'298',3.333,3),(504,7488681,7488674,'98a',3.333,3),(504,7488682,7488674,'8a2',3.333,3),(504,7488683,7488674,'a25',3.333,3),(504,7488684,7488674,'254',3.333,3),(504,7488685,7488674,'541',3.333,3),(504,7488686,7488674,'412',3.333,3),(504,7488687,7488674,'123',3.333,3),(504,7488688,7488674,'238',3.333,3),(504,7488689,7488674,'38d',3.333,3),(504,7488690,7488674,'8d7',3.333,3),(504,7488691,7488674,'d78',3.333,3),(504,7488692,7488674,'788',3.333,3),(504,7488693,7488674,'88c',3.333,3),(504,7488694,7488674,'8cb',3.333,3),(504,7488695,7488674,'cbb',3.333,3),(504,7488696,7488674,'bb9',3.333,3),(504,7488697,7488674,'b96',3.333,3),(504,7488698,7488674,'96c',3.333,3),(504,7488699,7488674,'6c8',3.333,3),(504,7488700,7488674,'c8f',3.333,3),(504,7488701,7488674,'8fe',3.333,3),(504,7488702,7488674,'fe7',3.333,3),(504,7488703,7488674,'e7f',3.333,3),(504,7488704,7488674,'7f0',3.333,3),(504,7488705,7488675,'mon',100,1),(504,7488706,7488705,'201',50,1),(504,7488707,7488705,'013',50,1),(504,7488708,7488706,'adm',33.333,3),(504,7488709,7488706,'dmi',33.333,3),(504,7488710,7488706,'min',33.333,3),(504,7488711,7488708,'cap',16.667,1),(504,7488712,7488708,'apa',16.667,1),(504,7488713,7488708,'pac',16.667,1),(504,7488714,7488708,'aci',16.667,1),(504,7488715,7488708,'cit',16.667,1),(504,7488716,7488708,'ity',16.667,1),(504,7488717,7488711,'pat',50,1),(504,7488718,7488711,'ath',50,1),(504,7488719,7488717,'fre',14.286,1),(504,7488720,7488717,'ree',14.286,1),(504,7488721,7488717,'ees',14.286,1),(504,7488722,7488717,'esp',14.286,1),(504,7488723,7488717,'spa',14.286,1),(504,7488724,7488717,'pac',14.286,1),(504,7488725,7488717,'ace',14.286,1),(504,7488726,7488719,'dis',50,1),(504,7488727,7488719,'isk',50,1),(504,7488728,7488726,'ind',33.333,1),(504,7488729,7488726,'nde',33.333,1),(504,7488730,7488726,'dex',33.333,1),(504,7488731,7488728,'adm',8.333,1),(504,7488732,7488728,'dmi',8.333,1),(504,7488733,7488728,'min',8.333,1),(504,7488734,7488728,'ini',8.333,1),(504,7488735,7488728,'nis',8.333,1),(504,7488736,7488728,'ist',8.333,1),(504,7488737,7488728,'str',8.333,1),(504,7488738,7488728,'tra',8.333,1),(504,7488739,7488728,'rat',8.333,1),(504,7488740,7488728,'ati',8.333,1),(504,7488741,7488728,'tio',8.333,1),(504,7488742,7488728,'ion',8.333,1),(504,7488743,7488731,'sta',33.333,3),(504,7488744,7488731,'tat',33.333,3),(504,7488745,7488731,'ate',33.333,3),(504,7488746,7488743,'ena',20,2),(504,7488747,7488743,'nab',20,2),(504,7488748,7488743,'abl',20,2),(504,7488749,7488743,'ble',20,2),(504,7488750,7488743,'led',20,2),(504,7488751,7488746,'cac',33.333,2),(504,7488752,7488746,'ach',33.333,2),(504,7488753,7488746,'che',33.333,2),(504,7488754,7488751,'mod',50,1),(504,7488755,7488751,'ode',50,1),(504,7488756,7488754,'wri',14.286,1),(504,7488757,7488754,'rit',14.286,1),(504,7488758,7488754,'ite',14.286,1),(504,7488759,7488754,'tet',14.286,1),(504,7488760,7488754,'eth',14.286,1),(504,7488761,7488754,'thr',14.286,1),(504,7488762,7488754,'hru',14.286,1),(504,7488763,7488756,'ope',11.111,2),(504,7488764,7488756,'per',11.111,2),(504,7488765,7488756,'era',11.111,2),(504,7488766,7488756,'rat',11.111,2),(504,7488767,7488756,'ati',11.111,2),(504,7488768,7488756,'tio',11.111,2),(504,7488769,7488756,'ion',11.111,2),(504,7488770,7488756,'ona',11.111,2),(504,7488771,7488756,'nal',11.111,2),(504,7488772,7488763,'pen',20,1),(504,7488773,7488763,'end',20,1),(504,7488774,7488763,'ndi',20,1),(504,7488775,7488763,'din',20,1),(504,7488776,7488763,'ing',20,1),(504,7488777,7488772,'mes',20,1),(504,7488778,7488772,'ess',20,1),(504,7488779,7488772,'ssa',20,1),(504,7488780,7488772,'sag',20,1),(504,7488781,7488772,'age',20,1),(504,7488782,7488777,'wai',20,1),(504,7488783,7488777,'ait',20,1),(504,7488784,7488777,'iti',20,1),(504,7488785,7488777,'tin',20,1),(504,7488786,7488777,'ing',20,1),(504,7488787,7488782,'for',100,1),(504,7488788,7488787,'per',11.111,1),(504,7488789,7488787,'erf',11.111,1),(504,7488790,7488787,'rfo',11.111,1),(504,7488791,7488787,'for',11.111,1),(504,7488792,7488787,'orm',11.111,1),(504,7488793,7488787,'rma',11.111,1),(504,7488794,7488787,'man',11.111,1),(504,7488795,7488787,'anc',11.111,1),(504,7488796,7488787,'nce',11.111,1),(504,7488797,7488788,'ide',12.5,1),(504,7488798,7488788,'den',12.5,1),(504,7488799,7488788,'ent',12.5,1),(504,7488800,7488788,'nti',12.5,1),(504,7488801,7488788,'tif',12.5,1),(504,7488802,7488788,'ifi',12.5,1),(504,7488803,7488788,'fie',12.5,1),(504,7488804,7488788,'ier',12.5,1),(504,7488805,7488797,'vdi',33.333,3),(504,7488806,7488797,'dis',33.333,3),(504,7488807,7488797,'isk',33.333,3),(504,7488808,7488805,'nam',50,1),(504,7488809,7488805,'ame',50,1),(504,7488810,7488808,'typ',50,1),(504,7488811,7488808,'ype',50,1),(504,7488812,7488810,'dir',25,1),(504,7488813,7488810,'ire',25,1),(504,7488814,7488810,'rec',25,1),(504,7488815,7488810,'ect',25,1),(505,7488817,7488816,'naa',100,2),(505,7488818,7488817,'600',3.333,3),(505,7488819,7488817,'000',3.333,3),(505,7488820,7488817,'00c',3.333,3),(505,7488821,7488817,'0c2',3.333,3),(505,7488822,7488817,'c29',3.333,3),(505,7488823,7488817,'295',3.333,3),(505,7488824,7488817,'95a',3.333,3),(505,7488825,7488817,'5ad',3.333,3),(505,7488826,7488817,'adc',3.333,3),(505,7488827,7488817,'dcf',3.333,3),(505,7488828,7488817,'cf4',3.333,3),(505,7488829,7488817,'f47',3.333,3),(505,7488830,7488817,'475',3.333,3),(505,7488831,7488817,'751',3.333,3),(505,7488832,7488817,'515',3.333,3),(505,7488833,7488817,'15b',3.333,3),(505,7488834,7488817,'5bb',3.333,3),(505,7488835,7488817,'bb2',3.333,3),(505,7488836,7488817,'b2a',3.333,3),(505,7488837,7488817,'2ac',3.333,3),(505,7488838,7488817,'ac6',3.333,3),(505,7488839,7488817,'c64',3.333,3),(505,7488840,7488817,'64a',3.333,3),(505,7488841,7488817,'4aa',3.333,3),(505,7488842,7488817,'aa6',3.333,3),(505,7488843,7488817,'a68',3.333,3),(505,7488844,7488817,'689',3.333,3),(505,7488845,7488817,'894',3.333,3),(505,7488846,7488817,'943',3.333,3),(505,7488847,7488817,'437',3.333,3),(505,7488848,7488818,'mon',100,1),(505,7488849,7488848,'201',50,1),(505,7488850,7488848,'013',50,1),(505,7488851,7488849,'adm',33.333,3),(505,7488852,7488849,'dmi',33.333,3),(505,7488853,7488849,'min',33.333,3),(505,7488854,7488851,'cap',16.667,1),(505,7488855,7488851,'apa',16.667,1),(505,7488856,7488851,'pac',16.667,1),(505,7488857,7488851,'aci',16.667,1),(505,7488858,7488851,'cit',16.667,1),(505,7488859,7488851,'ity',16.667,1),(505,7488860,7488854,'pat',50,1),(505,7488861,7488854,'ath',50,1),(505,7488862,7488860,'fre',14.286,1),(505,7488863,7488860,'ree',14.286,1),(505,7488864,7488860,'ees',14.286,1),(505,7488865,7488860,'esp',14.286,1),(505,7488866,7488860,'spa',14.286,1),(505,7488867,7488860,'pac',14.286,1),(505,7488868,7488860,'ace',14.286,1),(505,7488869,7488862,'dis',50,1),(505,7488870,7488862,'isk',50,1),(505,7488871,7488869,'ind',33.333,1),(505,7488872,7488869,'nde',33.333,1),(505,7488873,7488869,'dex',33.333,1),(505,7488874,7488871,'adm',8.333,1),(505,7488875,7488871,'dmi',8.333,1),(505,7488876,7488871,'min',8.333,1),(505,7488877,7488871,'ini',8.333,1),(505,7488878,7488871,'nis',8.333,1),(505,7488879,7488871,'ist',8.333,1),(505,7488880,7488871,'str',8.333,1),(505,7488881,7488871,'tra',8.333,1),(505,7488882,7488871,'rat',8.333,1),(505,7488883,7488871,'ati',8.333,1),(505,7488884,7488871,'tio',8.333,1),(505,7488885,7488871,'ion',8.333,1),(505,7488886,7488874,'sta',33.333,3),(505,7488887,7488874,'tat',33.333,3),(505,7488888,7488874,'ate',33.333,3),(505,7488889,7488886,'ena',20,2),(505,7488890,7488886,'nab',20,2),(505,7488891,7488886,'abl',20,2),(505,7488892,7488886,'ble',20,2),(505,7488893,7488886,'led',20,2),(505,7488894,7488889,'cac',33.333,2),(505,7488895,7488889,'ach',33.333,2),(505,7488896,7488889,'che',33.333,2),(505,7488897,7488894,'mod',50,1),(505,7488898,7488894,'ode',50,1),(505,7488899,7488897,'wri',14.286,1),(505,7488900,7488897,'rit',14.286,1),(505,7488901,7488897,'ite',14.286,1),(505,7488902,7488897,'tet',14.286,1),(505,7488903,7488897,'eth',14.286,1),(505,7488904,7488897,'thr',14.286,1),(505,7488905,7488897,'hru',14.286,1),(505,7488906,7488899,'ope',11.111,2),(505,7488907,7488899,'per',11.111,2),(505,7488908,7488899,'era',11.111,2),(505,7488909,7488899,'rat',11.111,2),(505,7488910,7488899,'ati',11.111,2),(505,7488911,7488899,'tio',11.111,2),(505,7488912,7488899,'ion',11.111,2),(505,7488913,7488899,'ona',11.111,2),(505,7488914,7488899,'nal',11.111,2),(505,7488915,7488906,'pen',20,1),(505,7488916,7488906,'end',20,1),(505,7488917,7488906,'ndi',20,1),(505,7488918,7488906,'din',20,1),(505,7488919,7488906,'ing',20,1),(505,7488920,7488915,'mes',20,1),(505,7488921,7488915,'ess',20,1),(505,7488922,7488915,'ssa',20,1),(505,7488923,7488915,'sag',20,1),(505,7488924,7488915,'age',20,1),(505,7488925,7488920,'wai',20,1),(505,7488926,7488920,'ait',20,1),(505,7488927,7488920,'iti',20,1),(505,7488928,7488920,'tin',20,1),(505,7488929,7488920,'ing',20,1),(505,7488930,7488925,'for',100,1),(505,7488931,7488930,'per',11.111,1),(505,7488932,7488930,'erf',11.111,1),(505,7488933,7488930,'rfo',11.111,1),(505,7488934,7488930,'for',11.111,1),(505,7488935,7488930,'orm',11.111,1),(505,7488936,7488930,'rma',11.111,1),(505,7488937,7488930,'man',11.111,1),(505,7488938,7488930,'anc',11.111,1),(505,7488939,7488930,'nce',11.111,1),(505,7488940,7488931,'ide',12.5,1),(505,7488941,7488931,'den',12.5,1),(505,7488942,7488931,'ent',12.5,1),(505,7488943,7488931,'nti',12.5,1),(505,7488944,7488931,'tif',12.5,1),(505,7488945,7488931,'ifi',12.5,1),(505,7488946,7488931,'fie',12.5,1),(505,7488947,7488931,'ier',12.5,1),(505,7488948,7488940,'vdi',33.333,3),(505,7488949,7488940,'dis',33.333,3),(505,7488950,7488940,'isk',33.333,3),(505,7488951,7488948,'nam',50,1),(505,7488952,7488948,'ame',50,1),(505,7488953,7488951,'typ',50,1),(505,7488954,7488951,'ype',50,1),(505,7488955,7488953,'dir',25,1),(505,7488956,7488953,'ire',25,1),(505,7488957,7488953,'rec',25,1),(505,7488958,7488953,'ect',25,1),(506,7488960,7488959,'naa',100,2),(506,7488961,7488960,'600',3.333,3),(506,7488962,7488960,'000',3.333,3),(506,7488963,7488960,'00c',3.333,3),(506,7488964,7488960,'0c2',3.333,3),(506,7488965,7488960,'c29',3.333,3),(506,7488966,7488960,'296',3.333,3),(506,7488967,7488960,'966',3.333,3),(506,7488968,7488960,'664',3.333,3),(506,7488969,7488960,'644',3.333,3),(506,7488970,7488960,'44a',3.333,3),(506,7488971,7488960,'4a5',3.333,3),(506,7488972,7488960,'a5b',3.333,3),(506,7488973,7488960,'5bb',3.333,3),(506,7488974,7488960,'bb9',3.333,3),(506,7488975,7488960,'b97',3.333,3),(506,7488976,7488960,'970',3.333,3),(506,7488977,7488960,'70e',3.333,3),(506,7488978,7488960,'0eb',3.333,3),(506,7488979,7488960,'eba',3.333,3),(506,7488980,7488960,'ba9',3.333,3),(506,7488981,7488960,'a98',3.333,3),(506,7488982,7488960,'985',3.333,3),(506,7488983,7488960,'850',3.333,3),(506,7488984,7488960,'50a',3.333,3),(506,7488985,7488960,'0a0',3.333,3),(506,7488986,7488960,'a03',3.333,3),(506,7488987,7488960,'035',3.333,3),(506,7488988,7488960,'35b',3.333,3),(506,7488989,7488960,'5b0',3.333,3),(506,7488990,7488960,'b0a',3.333,3),(506,7488991,7488961,'mon',100,1),(506,7488992,7488991,'201',50,1),(506,7488993,7488991,'013',50,1),(506,7488994,7488992,'adm',33.333,3),(506,7488995,7488992,'dmi',33.333,3),(506,7488996,7488992,'min',33.333,3),(506,7488997,7488994,'cap',16.667,1),(506,7488998,7488994,'apa',16.667,1),(506,7488999,7488994,'pac',16.667,1),(506,7489000,7488994,'aci',16.667,1),(506,7489001,7488994,'cit',16.667,1),(506,7489002,7488994,'ity',16.667,1),(506,7489003,7488997,'pat',50,1),(506,7489004,7488997,'ath',50,1),(506,7489005,7489003,'fre',14.286,1),(506,7489006,7489003,'ree',14.286,1),(506,7489007,7489003,'ees',14.286,1),(506,7489008,7489003,'esp',14.286,1),(506,7489009,7489003,'spa',14.286,1),(506,7489010,7489003,'pac',14.286,1),(506,7489011,7489003,'ace',14.286,1),(506,7489012,7489005,'dis',50,1),(506,7489013,7489005,'isk',50,1),(506,7489014,7489012,'ind',33.333,1),(506,7489015,7489012,'nde',33.333,1),(506,7489016,7489012,'dex',33.333,1),(506,7489017,7489014,'adm',8.333,1),(506,7489018,7489014,'dmi',8.333,1),(506,7489019,7489014,'min',8.333,1),(506,7489020,7489014,'ini',8.333,1),(506,7489021,7489014,'nis',8.333,1),(506,7489022,7489014,'ist',8.333,1),(506,7489023,7489014,'str',8.333,1),(506,7489024,7489014,'tra',8.333,1),(506,7489025,7489014,'rat',8.333,1),(506,7489026,7489014,'ati',8.333,1),(506,7489027,7489014,'tio',8.333,1),(506,7489028,7489014,'ion',8.333,1),(506,7489029,7489017,'sta',33.333,3),(506,7489030,7489017,'tat',33.333,3),(506,7489031,7489017,'ate',33.333,3),(506,7489032,7489029,'ena',20,2),(506,7489033,7489029,'nab',20,2),(506,7489034,7489029,'abl',20,2),(506,7489035,7489029,'ble',20,2),(506,7489036,7489029,'led',20,2),(506,7489037,7489032,'cac',33.333,2),(506,7489038,7489032,'ach',33.333,2),(506,7489039,7489032,'che',33.333,2),(506,7489040,7489037,'mod',50,1),(506,7489041,7489037,'ode',50,1),(506,7489042,7489040,'wri',14.286,1),(506,7489043,7489040,'rit',14.286,1),(506,7489044,7489040,'ite',14.286,1),(506,7489045,7489040,'tet',14.286,1),(506,7489046,7489040,'eth',14.286,1),(506,7489047,7489040,'thr',14.286,1),(506,7489048,7489040,'hru',14.286,1),(506,7489049,7489042,'ope',11.111,2),(506,7489050,7489042,'per',11.111,2),(506,7489051,7489042,'era',11.111,2),(506,7489052,7489042,'rat',11.111,2),(506,7489053,7489042,'ati',11.111,2),(506,7489054,7489042,'tio',11.111,2),(506,7489055,7489042,'ion',11.111,2),(506,7489056,7489042,'ona',11.111,2),(506,7489057,7489042,'nal',11.111,2),(506,7489058,7489049,'pen',20,1),(506,7489059,7489049,'end',20,1),(506,7489060,7489049,'ndi',20,1),(506,7489061,7489049,'din',20,1),(506,7489062,7489049,'ing',20,1),(506,7489063,7489058,'mes',20,1),(506,7489064,7489058,'ess',20,1),(506,7489065,7489058,'ssa',20,1),(506,7489066,7489058,'sag',20,1),(506,7489067,7489058,'age',20,1),(506,7489068,7489063,'wai',20,1),(506,7489069,7489063,'ait',20,1),(506,7489070,7489063,'iti',20,1),(506,7489071,7489063,'tin',20,1),(506,7489072,7489063,'ing',20,1),(506,7489073,7489068,'for',100,1),(506,7489074,7489073,'per',11.111,1),(506,7489075,7489073,'erf',11.111,1),(506,7489076,7489073,'rfo',11.111,1),(506,7489077,7489073,'for',11.111,1),(506,7489078,7489073,'orm',11.111,1),(506,7489079,7489073,'rma',11.111,1),(506,7489080,7489073,'man',11.111,1),(506,7489081,7489073,'anc',11.111,1),(506,7489082,7489073,'nce',11.111,1),(506,7489083,7489074,'ide',12.5,1),(506,7489084,7489074,'den',12.5,1),(506,7489085,7489074,'ent',12.5,1),(506,7489086,7489074,'nti',12.5,1),(506,7489087,7489074,'tif',12.5,1),(506,7489088,7489074,'ifi',12.5,1),(506,7489089,7489074,'fie',12.5,1),(506,7489090,7489074,'ier',12.5,1),(506,7489091,7489083,'vdi',33.333,3),(506,7489092,7489083,'dis',33.333,3),(506,7489093,7489083,'isk',33.333,3),(506,7489094,7489091,'nam',50,1),(506,7489095,7489091,'ame',50,1),(506,7489096,7489094,'typ',50,1),(506,7489097,7489094,'ype',50,1),(506,7489098,7489096,'dir',25,1),(506,7489099,7489096,'ire',25,1),(506,7489100,7489096,'rec',25,1),(506,7489101,7489096,'ect',25,1),(507,7489103,7489102,'naa',100,2),(507,7489104,7489103,'600',3.333,3),(507,7489105,7489103,'000',3.333,3),(507,7489106,7489103,'00c',3.333,3),(507,7489107,7489103,'0c2',3.333,3),(507,7489108,7489103,'c29',3.333,3),(507,7489109,7489103,'292',3.333,3),(507,7489110,7489103,'928',3.333,3),(507,7489111,7489103,'288',3.333,3),(507,7489112,7489103,'889',3.333,3),(507,7489113,7489103,'899',3.333,3),(507,7489114,7489103,'997',3.333,3),(507,7489115,7489103,'97a',3.333,3),(507,7489116,7489103,'7a1',3.333,3),(507,7489117,7489103,'a1a',3.333,3),(507,7489118,7489103,'1a6',3.333,3),(507,7489119,7489103,'a68',3.333,3),(507,7489120,7489103,'686',3.333,3),(507,7489121,7489103,'86f',3.333,3),(507,7489122,7489103,'6f8',3.333,3),(507,7489123,7489103,'f82',3.333,3),(507,7489124,7489103,'826',3.333,3),(507,7489125,7489103,'263',3.333,3),(507,7489126,7489103,'632',3.333,3),(507,7489127,7489103,'326',3.333,3),(507,7489128,7489103,'26d',3.333,3),(507,7489129,7489103,'6df',3.333,3),(507,7489130,7489103,'dff',3.333,3),(507,7489131,7489103,'ffa',3.333,3),(507,7489132,7489103,'fac',3.333,3),(507,7489133,7489103,'acd',3.333,3),(507,7489134,7489104,'mon',100,1),(507,7489135,7489134,'201',50,1),(507,7489136,7489134,'013',50,1),(507,7489137,7489135,'adm',33.333,3),(507,7489138,7489135,'dmi',33.333,3),(507,7489139,7489135,'min',33.333,3),(507,7489140,7489137,'cap',16.667,1),(507,7489141,7489137,'apa',16.667,1),(507,7489142,7489137,'pac',16.667,1),(507,7489143,7489137,'aci',16.667,1),(507,7489144,7489137,'cit',16.667,1),(507,7489145,7489137,'ity',16.667,1),(507,7489146,7489140,'pat',50,1),(507,7489147,7489140,'ath',50,1),(507,7489148,7489146,'fre',14.286,1),(507,7489149,7489146,'ree',14.286,1),(507,7489150,7489146,'ees',14.286,1),(507,7489151,7489146,'esp',14.286,1),(507,7489152,7489146,'spa',14.286,1),(507,7489153,7489146,'pac',14.286,1),(507,7489154,7489146,'ace',14.286,1),(507,7489155,7489148,'dis',50,1),(507,7489156,7489148,'isk',50,1),(507,7489157,7489155,'ind',33.333,1),(507,7489158,7489155,'nde',33.333,1),(507,7489159,7489155,'dex',33.333,1),(507,7489160,7489157,'adm',8.333,1),(507,7489161,7489157,'dmi',8.333,1),(507,7489162,7489157,'min',8.333,1),(507,7489163,7489157,'ini',8.333,1),(507,7489164,7489157,'nis',8.333,1),(507,7489165,7489157,'ist',8.333,1),(507,7489166,7489157,'str',8.333,1),(507,7489167,7489157,'tra',8.333,1),(507,7489168,7489157,'rat',8.333,1),(507,7489169,7489157,'ati',8.333,1),(507,7489170,7489157,'tio',8.333,1),(507,7489171,7489157,'ion',8.333,1),(507,7489172,7489160,'sta',33.333,3),(507,7489173,7489160,'tat',33.333,3),(507,7489174,7489160,'ate',33.333,3),(507,7489175,7489172,'ena',20,2),(507,7489176,7489172,'nab',20,2),(507,7489177,7489172,'abl',20,2),(507,7489178,7489172,'ble',20,2),(507,7489179,7489172,'led',20,2),(507,7489180,7489175,'cac',33.333,2),(507,7489181,7489175,'ach',33.333,2),(507,7489182,7489175,'che',33.333,2),(507,7489183,7489180,'mod',50,1),(507,7489184,7489180,'ode',50,1),(507,7489185,7489183,'wri',14.286,1),(507,7489186,7489183,'rit',14.286,1),(507,7489187,7489183,'ite',14.286,1),(507,7489188,7489183,'tet',14.286,1),(507,7489189,7489183,'eth',14.286,1),(507,7489190,7489183,'thr',14.286,1),(507,7489191,7489183,'hru',14.286,1),(507,7489192,7489185,'ope',11.111,2),(507,7489193,7489185,'per',11.111,2),(507,7489194,7489185,'era',11.111,2),(507,7489195,7489185,'rat',11.111,2),(507,7489196,7489185,'ati',11.111,2),(507,7489197,7489185,'tio',11.111,2),(507,7489198,7489185,'ion',11.111,2),(507,7489199,7489185,'ona',11.111,2),(507,7489200,7489185,'nal',11.111,2),(507,7489201,7489192,'pen',20,1),(507,7489202,7489192,'end',20,1),(507,7489203,7489192,'ndi',20,1),(507,7489204,7489192,'din',20,1),(507,7489205,7489192,'ing',20,1),(507,7489206,7489201,'mes',20,1),(507,7489207,7489201,'ess',20,1),(507,7489208,7489201,'ssa',20,1),(507,7489209,7489201,'sag',20,1),(507,7489210,7489201,'age',20,1),(507,7489211,7489206,'wai',20,1),(507,7489212,7489206,'ait',20,1),(507,7489213,7489206,'iti',20,1),(507,7489214,7489206,'tin',20,1),(507,7489215,7489206,'ing',20,1),(507,7489216,7489211,'for',100,1),(507,7489217,7489216,'per',11.111,1),(507,7489218,7489216,'erf',11.111,1),(507,7489219,7489216,'rfo',11.111,1),(507,7489220,7489216,'for',11.111,1),(507,7489221,7489216,'orm',11.111,1),(507,7489222,7489216,'rma',11.111,1),(507,7489223,7489216,'man',11.111,1),(507,7489224,7489216,'anc',11.111,1),(507,7489225,7489216,'nce',11.111,1),(507,7489226,7489217,'ide',12.5,1),(507,7489227,7489217,'den',12.5,1),(507,7489228,7489217,'ent',12.5,1),(507,7489229,7489217,'nti',12.5,1),(507,7489230,7489217,'tif',12.5,1),(507,7489231,7489217,'ifi',12.5,1),(507,7489232,7489217,'fie',12.5,1),(507,7489233,7489217,'ier',12.5,1),(507,7489234,7489226,'vdi',33.333,3),(507,7489235,7489226,'dis',33.333,3),(507,7489236,7489226,'isk',33.333,3),(507,7489237,7489234,'nam',50,1),(507,7489238,7489234,'ame',50,1),(507,7489239,7489237,'typ',50,1),(507,7489240,7489237,'ype',50,1),(507,7489241,7489239,'dir',25,1),(507,7489242,7489239,'ire',25,1),(507,7489243,7489239,'rec',25,1),(507,7489244,7489239,'ect',25,1),(508,7489246,7489245,'naa',100,2),(508,7489247,7489246,'600',3.333,3),(508,7489248,7489246,'000',3.333,3),(508,7489249,7489246,'00c',3.333,3),(508,7489250,7489246,'0c2',3.333,3),(508,7489251,7489246,'c29',3.333,3),(508,7489252,7489246,'295',3.333,3),(508,7489253,7489246,'959',3.333,3),(508,7489254,7489246,'597',3.333,3),(508,7489255,7489246,'972',3.333,3),(508,7489256,7489246,'72e',3.333,3),(508,7489257,7489246,'2ed',3.333,3),(508,7489258,7489246,'ed7',3.333,3),(508,7489259,7489246,'d7c',3.333,3),(508,7489260,7489246,'7c6',3.333,3),(508,7489261,7489246,'c64',3.333,3),(508,7489262,7489246,'64e',3.333,3),(508,7489263,7489246,'4eb',3.333,3),(508,7489264,7489246,'eb4',3.333,3),(508,7489265,7489246,'b4e',3.333,3),(508,7489266,7489246,'4e8',3.333,3),(508,7489267,7489246,'e80',3.333,3),(508,7489268,7489246,'809',3.333,3),(508,7489269,7489246,'09d',3.333,3),(508,7489270,7489246,'9d4',3.333,3),(508,7489271,7489246,'d43',3.333,3),(508,7489272,7489246,'435',3.333,3),(508,7489273,7489246,'355',3.333,3),(508,7489274,7489246,'55e',3.333,3),(508,7489275,7489246,'5e9',3.333,3),(508,7489276,7489246,'e91',3.333,3),(508,7489277,7489247,'mon',100,1),(508,7489278,7489277,'201',50,1),(508,7489279,7489277,'013',50,1),(508,7489280,7489278,'adm',33.333,3),(508,7489281,7489278,'dmi',33.333,3),(508,7489282,7489278,'min',33.333,3),(508,7489283,7489280,'cap',16.667,1),(508,7489284,7489280,'apa',16.667,1),(508,7489285,7489280,'pac',16.667,1),(508,7489286,7489280,'aci',16.667,1),(508,7489287,7489280,'cit',16.667,1),(508,7489288,7489280,'ity',16.667,1),(508,7489289,7489283,'pat',50,1),(508,7489290,7489283,'ath',50,1),(508,7489291,7489289,'fre',14.286,1),(508,7489292,7489289,'ree',14.286,1),(508,7489293,7489289,'ees',14.286,1),(508,7489294,7489289,'esp',14.286,1),(508,7489295,7489289,'spa',14.286,1),(508,7489296,7489289,'pac',14.286,1),(508,7489297,7489289,'ace',14.286,1),(508,7489298,7489291,'dis',50,1),(508,7489299,7489291,'isk',50,1),(508,7489300,7489298,'ind',33.333,1),(508,7489301,7489298,'nde',33.333,1),(508,7489302,7489298,'dex',33.333,1),(508,7489303,7489300,'adm',8.333,1),(508,7489304,7489300,'dmi',8.333,1),(508,7489305,7489300,'min',8.333,1),(508,7489306,7489300,'ini',8.333,1),(508,7489307,7489300,'nis',8.333,1),(508,7489308,7489300,'ist',8.333,1),(508,7489309,7489300,'str',8.333,1),(508,7489310,7489300,'tra',8.333,1),(508,7489311,7489300,'rat',8.333,1),(508,7489312,7489300,'ati',8.333,1),(508,7489313,7489300,'tio',8.333,1),(508,7489314,7489300,'ion',8.333,1),(508,7489315,7489303,'sta',33.333,3),(508,7489316,7489303,'tat',33.333,3),(508,7489317,7489303,'ate',33.333,3),(508,7489318,7489315,'ena',20,2),(508,7489319,7489315,'nab',20,2),(508,7489320,7489315,'abl',20,2),(508,7489321,7489315,'ble',20,2),(508,7489322,7489315,'led',20,2),(508,7489323,7489318,'cac',33.333,2),(508,7489324,7489318,'ach',33.333,2),(508,7489325,7489318,'che',33.333,2),(508,7489326,7489323,'mod',50,1),(508,7489327,7489323,'ode',50,1),(508,7489328,7489326,'wri',14.286,1),(508,7489329,7489326,'rit',14.286,1),(508,7489330,7489326,'ite',14.286,1),(508,7489331,7489326,'tet',14.286,1),(508,7489332,7489326,'eth',14.286,1),(508,7489333,7489326,'thr',14.286,1),(508,7489334,7489326,'hru',14.286,1),(508,7489335,7489328,'ope',11.111,2),(508,7489336,7489328,'per',11.111,2),(508,7489337,7489328,'era',11.111,2),(508,7489338,7489328,'rat',11.111,2),(508,7489339,7489328,'ati',11.111,2),(508,7489340,7489328,'tio',11.111,2),(508,7489341,7489328,'ion',11.111,2),(508,7489342,7489328,'ona',11.111,2),(508,7489343,7489328,'nal',11.111,2),(508,7489344,7489335,'pen',20,1),(508,7489345,7489335,'end',20,1),(508,7489346,7489335,'ndi',20,1),(508,7489347,7489335,'din',20,1),(508,7489348,7489335,'ing',20,1),(508,7489349,7489344,'mes',20,1),(508,7489350,7489344,'ess',20,1),(508,7489351,7489344,'ssa',20,1),(508,7489352,7489344,'sag',20,1),(508,7489353,7489344,'age',20,1),(508,7489354,7489349,'wai',20,1),(508,7489355,7489349,'ait',20,1),(508,7489356,7489349,'iti',20,1),(508,7489357,7489349,'tin',20,1),(508,7489358,7489349,'ing',20,1),(508,7489359,7489354,'for',100,1),(508,7489360,7489359,'per',11.111,1),(508,7489361,7489359,'erf',11.111,1),(508,7489362,7489359,'rfo',11.111,1),(508,7489363,7489359,'for',11.111,1),(508,7489364,7489359,'orm',11.111,1),(508,7489365,7489359,'rma',11.111,1),(508,7489366,7489359,'man',11.111,1),(508,7489367,7489359,'anc',11.111,1),(508,7489368,7489359,'nce',11.111,1),(508,7489369,7489360,'ide',12.5,1),(508,7489370,7489360,'den',12.5,1),(508,7489371,7489360,'ent',12.5,1),(508,7489372,7489360,'nti',12.5,1),(508,7489373,7489360,'tif',12.5,1),(508,7489374,7489360,'ifi',12.5,1),(508,7489375,7489360,'fie',12.5,1),(508,7489376,7489360,'ier',12.5,1),(508,7489377,7489369,'vdi',33.333,3),(508,7489378,7489369,'dis',33.333,3),(508,7489379,7489369,'isk',33.333,3),(508,7489380,7489377,'nam',50,1),(508,7489381,7489377,'ame',50,1),(508,7489382,7489380,'typ',50,1),(508,7489383,7489380,'ype',50,1),(508,7489384,7489382,'dir',25,1),(508,7489385,7489382,'ire',25,1),(508,7489386,7489382,'rec',25,1),(508,7489387,7489382,'ect',25,1),(509,7489389,7489388,'naa',100,2),(509,7489390,7489389,'600',3.333,3),(509,7489391,7489389,'000',3.333,3),(509,7489392,7489389,'00c',3.333,3),(509,7489393,7489389,'0c2',3.333,3),(509,7489394,7489389,'c29',3.333,3),(509,7489395,7489389,'291',3.333,3),(509,7489396,7489389,'91e',3.333,3),(509,7489397,7489389,'1e4',3.333,3),(509,7489398,7489389,'e46',3.333,3),(509,7489399,7489389,'46b',3.333,3),(509,7489400,7489389,'6b1',3.333,3),(509,7489401,7489389,'b12',3.333,3),(509,7489402,7489389,'125',3.333,3),(509,7489403,7489389,'25f',3.333,3),(509,7489404,7489389,'5f9',3.333,3),(509,7489405,7489389,'f9f',3.333,3),(509,7489406,7489389,'9f1',3.333,3),(509,7489407,7489389,'f16',3.333,3),(509,7489408,7489389,'16b',3.333,3),(509,7489409,7489389,'6b3',3.333,3),(509,7489410,7489389,'b31',3.333,3),(509,7489411,7489389,'314',3.333,3),(509,7489412,7489389,'14d',3.333,3),(509,7489413,7489389,'4d0',3.333,3),(509,7489414,7489389,'d0e',3.333,3),(509,7489415,7489389,'0ee',3.333,3),(509,7489416,7489389,'ee4',3.333,3),(509,7489417,7489389,'e46',3.333,3),(509,7489418,7489389,'46f',3.333,3),(509,7489419,7489389,'6fa',3.333,3),(509,7489420,7489390,'mon',100,1),(509,7489421,7489420,'201',50,1),(509,7489422,7489420,'013',50,1),(509,7489423,7489421,'adm',33.333,3),(509,7489424,7489421,'dmi',33.333,3),(509,7489425,7489421,'min',33.333,3),(509,7489426,7489423,'cap',16.667,1),(509,7489427,7489423,'apa',16.667,1),(509,7489428,7489423,'pac',16.667,1),(509,7489429,7489423,'aci',16.667,1),(509,7489430,7489423,'cit',16.667,1),(509,7489431,7489423,'ity',16.667,1),(509,7489432,7489426,'pat',50,1),(509,7489433,7489426,'ath',50,1),(509,7489434,7489432,'fre',14.286,1),(509,7489435,7489432,'ree',14.286,1),(509,7489436,7489432,'ees',14.286,1),(509,7489437,7489432,'esp',14.286,1),(509,7489438,7489432,'spa',14.286,1),(509,7489439,7489432,'pac',14.286,1),(509,7489440,7489432,'ace',14.286,1),(509,7489441,7489434,'dis',50,1),(509,7489442,7489434,'isk',50,1),(509,7489443,7489441,'ind',33.333,1),(509,7489444,7489441,'nde',33.333,1),(509,7489445,7489441,'dex',33.333,1),(509,7489446,7489443,'adm',8.333,1),(509,7489447,7489443,'dmi',8.333,1),(509,7489448,7489443,'min',8.333,1),(509,7489449,7489443,'ini',8.333,1),(509,7489450,7489443,'nis',8.333,1),(509,7489451,7489443,'ist',8.333,1),(509,7489452,7489443,'str',8.333,1),(509,7489453,7489443,'tra',8.333,1),(509,7489454,7489443,'rat',8.333,1),(509,7489455,7489443,'ati',8.333,1),(509,7489456,7489443,'tio',8.333,1),(509,7489457,7489443,'ion',8.333,1),(509,7489458,7489446,'sta',33.333,3),(509,7489459,7489446,'tat',33.333,3),(509,7489460,7489446,'ate',33.333,3),(509,7489461,7489458,'ena',20,2),(509,7489462,7489458,'nab',20,2),(509,7489463,7489458,'abl',20,2),(509,7489464,7489458,'ble',20,2),(509,7489465,7489458,'led',20,2),(509,7489466,7489461,'cac',33.333,2),(509,7489467,7489461,'ach',33.333,2),(509,7489468,7489461,'che',33.333,2),(509,7489469,7489466,'mod',50,1),(509,7489470,7489466,'ode',50,1),(509,7489471,7489469,'wri',14.286,1),(509,7489472,7489469,'rit',14.286,1),(509,7489473,7489469,'ite',14.286,1),(509,7489474,7489469,'tet',14.286,1),(509,7489475,7489469,'eth',14.286,1),(509,7489476,7489469,'thr',14.286,1),(509,7489477,7489469,'hru',14.286,1),(509,7489478,7489471,'ope',11.111,2),(509,7489479,7489471,'per',11.111,2),(509,7489480,7489471,'era',11.111,2),(509,7489481,7489471,'rat',11.111,2),(509,7489482,7489471,'ati',11.111,2),(509,7489483,7489471,'tio',11.111,2),(509,7489484,7489471,'ion',11.111,2),(509,7489485,7489471,'ona',11.111,2),(509,7489486,7489471,'nal',11.111,2),(509,7489487,7489478,'pen',20,1),(509,7489488,7489478,'end',20,1),(509,7489489,7489478,'ndi',20,1),(509,7489490,7489478,'din',20,1),(509,7489491,7489478,'ing',20,1),(509,7489492,7489487,'mes',20,1),(509,7489493,7489487,'ess',20,1),(509,7489494,7489487,'ssa',20,1),(509,7489495,7489487,'sag',20,1),(509,7489496,7489487,'age',20,1),(509,7489497,7489492,'wai',20,1),(509,7489498,7489492,'ait',20,1),(509,7489499,7489492,'iti',20,1),(509,7489500,7489492,'tin',20,1),(509,7489501,7489492,'ing',20,1),(509,7489502,7489497,'for',100,1),(509,7489503,7489502,'per',11.111,1),(509,7489504,7489502,'erf',11.111,1),(509,7489505,7489502,'rfo',11.111,1),(509,7489506,7489502,'for',11.111,1),(509,7489507,7489502,'orm',11.111,1),(509,7489508,7489502,'rma',11.111,1),(509,7489509,7489502,'man',11.111,1),(509,7489510,7489502,'anc',11.111,1),(509,7489511,7489502,'nce',11.111,1),(509,7489512,7489503,'ide',12.5,1),(509,7489513,7489503,'den',12.5,1),(509,7489514,7489503,'ent',12.5,1),(509,7489515,7489503,'nti',12.5,1),(509,7489516,7489503,'tif',12.5,1),(509,7489517,7489503,'ifi',12.5,1),(509,7489518,7489503,'fie',12.5,1),(509,7489519,7489503,'ier',12.5,1),(509,7489520,7489512,'vdi',33.333,3),(509,7489521,7489512,'dis',33.333,3),(509,7489522,7489512,'isk',33.333,3),(509,7489523,7489520,'nam',50,1),(509,7489524,7489520,'ame',50,1),(509,7489525,7489523,'typ',50,1),(509,7489526,7489523,'ype',50,1),(509,7489527,7489525,'dir',25,1),(509,7489528,7489525,'ire',25,1),(509,7489529,7489525,'rec',25,1),(509,7489530,7489525,'ect',25,1),(510,7489532,7489531,'naa',100,2),(510,7489533,7489532,'600',3.333,3),(510,7489534,7489532,'000',3.333,3),(510,7489535,7489532,'00c',3.333,3),(510,7489536,7489532,'0c2',3.333,3),(510,7489537,7489532,'c29',3.333,3),(510,7489538,7489532,'298',3.333,3),(510,7489539,7489532,'980',3.333,3),(510,7489540,7489532,'801',3.333,3),(510,7489541,7489532,'015',3.333,3),(510,7489542,7489532,'151',3.333,3),(510,7489543,7489532,'51d',3.333,3),(510,7489544,7489532,'1d0',3.333,3),(510,7489545,7489532,'d0a',3.333,3),(510,7489546,7489532,'0a1',3.333,3),(510,7489547,7489532,'a19',3.333,3),(510,7489548,7489532,'19a',3.333,3),(510,7489549,7489532,'9a5',3.333,3),(510,7489550,7489532,'a59',3.333,3),(510,7489551,7489532,'59e',3.333,3),(510,7489552,7489532,'9e8',3.333,3),(510,7489553,7489532,'e81',3.333,3),(510,7489554,7489532,'81d',3.333,3),(510,7489555,7489532,'1d7',3.333,3),(510,7489556,7489532,'d7d',3.333,3),(510,7489557,7489532,'7d5',3.333,3),(510,7489558,7489532,'d58',3.333,3),(510,7489559,7489532,'589',3.333,3),(510,7489560,7489532,'892',3.333,3),(510,7489561,7489532,'92e',3.333,3),(510,7489562,7489532,'2eb',3.333,3),(510,7489563,7489533,'mon',100,1),(510,7489564,7489563,'201',50,1),(510,7489565,7489563,'013',50,1),(510,7489566,7489564,'adm',33.333,3),(510,7489567,7489564,'dmi',33.333,3),(510,7489568,7489564,'min',33.333,3),(510,7489569,7489566,'cap',16.667,1),(510,7489570,7489566,'apa',16.667,1),(510,7489571,7489566,'pac',16.667,1),(510,7489572,7489566,'aci',16.667,1),(510,7489573,7489566,'cit',16.667,1),(510,7489574,7489566,'ity',16.667,1),(510,7489575,7489569,'pat',50,1),(510,7489576,7489569,'ath',50,1),(510,7489577,7489575,'fre',14.286,1),(510,7489578,7489575,'ree',14.286,1),(510,7489579,7489575,'ees',14.286,1),(510,7489580,7489575,'esp',14.286,1),(510,7489581,7489575,'spa',14.286,1),(510,7489582,7489575,'pac',14.286,1),(510,7489583,7489575,'ace',14.286,1),(510,7489584,7489577,'dis',50,1),(510,7489585,7489577,'isk',50,1),(510,7489586,7489584,'ind',33.333,1),(510,7489587,7489584,'nde',33.333,1),(510,7489588,7489584,'dex',33.333,1),(510,7489589,7489586,'adm',8.333,1),(510,7489590,7489586,'dmi',8.333,1),(510,7489591,7489586,'min',8.333,1),(510,7489592,7489586,'ini',8.333,1),(510,7489593,7489586,'nis',8.333,1),(510,7489594,7489586,'ist',8.333,1),(510,7489595,7489586,'str',8.333,1),(510,7489596,7489586,'tra',8.333,1),(510,7489597,7489586,'rat',8.333,1),(510,7489598,7489586,'ati',8.333,1),(510,7489599,7489586,'tio',8.333,1),(510,7489600,7489586,'ion',8.333,1),(510,7489601,7489589,'sta',33.333,3),(510,7489602,7489589,'tat',33.333,3),(510,7489603,7489589,'ate',33.333,3),(510,7489604,7489601,'ena',20,2),(510,7489605,7489601,'nab',20,2),(510,7489606,7489601,'abl',20,2),(510,7489607,7489601,'ble',20,2),(510,7489608,7489601,'led',20,2),(510,7489609,7489604,'cac',33.333,2),(510,7489610,7489604,'ach',33.333,2),(510,7489611,7489604,'che',33.333,2),(510,7489612,7489609,'mod',50,1),(510,7489613,7489609,'ode',50,1),(510,7489614,7489612,'wri',14.286,1),(510,7489615,7489612,'rit',14.286,1),(510,7489616,7489612,'ite',14.286,1),(510,7489617,7489612,'tet',14.286,1),(510,7489618,7489612,'eth',14.286,1),(510,7489619,7489612,'thr',14.286,1),(510,7489620,7489612,'hru',14.286,1),(510,7489621,7489614,'ope',11.111,2),(510,7489622,7489614,'per',11.111,2),(510,7489623,7489614,'era',11.111,2),(510,7489624,7489614,'rat',11.111,2),(510,7489625,7489614,'ati',11.111,2),(510,7489626,7489614,'tio',11.111,2),(510,7489627,7489614,'ion',11.111,2),(510,7489628,7489614,'ona',11.111,2),(510,7489629,7489614,'nal',11.111,2),(510,7489630,7489621,'pen',20,1),(510,7489631,7489621,'end',20,1),(510,7489632,7489621,'ndi',20,1),(510,7489633,7489621,'din',20,1),(510,7489634,7489621,'ing',20,1),(510,7489635,7489630,'mes',20,1),(510,7489636,7489630,'ess',20,1),(510,7489637,7489630,'ssa',20,1),(510,7489638,7489630,'sag',20,1),(510,7489639,7489630,'age',20,1),(510,7489640,7489635,'wai',20,1),(510,7489641,7489635,'ait',20,1),(510,7489642,7489635,'iti',20,1),(510,7489643,7489635,'tin',20,1),(510,7489644,7489635,'ing',20,1),(510,7489645,7489640,'for',100,1),(510,7489646,7489645,'per',11.111,1),(510,7489647,7489645,'erf',11.111,1),(510,7489648,7489645,'rfo',11.111,1),(510,7489649,7489645,'for',11.111,1),(510,7489650,7489645,'orm',11.111,1),(510,7489651,7489645,'rma',11.111,1),(510,7489652,7489645,'man',11.111,1),(510,7489653,7489645,'anc',11.111,1),(510,7489654,7489645,'nce',11.111,1),(510,7489655,7489646,'ide',12.5,1),(510,7489656,7489646,'den',12.5,1),(510,7489657,7489646,'ent',12.5,1),(510,7489658,7489646,'nti',12.5,1),(510,7489659,7489646,'tif',12.5,1),(510,7489660,7489646,'ifi',12.5,1),(510,7489661,7489646,'fie',12.5,1),(510,7489662,7489646,'ier',12.5,1),(510,7489663,7489655,'vdi',33.333,3),(510,7489664,7489655,'dis',33.333,3),(510,7489665,7489655,'isk',33.333,3),(510,7489666,7489663,'nam',50,1),(510,7489667,7489663,'ame',50,1),(510,7489668,7489666,'typ',50,1),(510,7489669,7489666,'ype',50,1),(510,7489670,7489668,'dir',25,1),(510,7489671,7489668,'ire',25,1),(510,7489672,7489668,'rec',25,1),(510,7489673,7489668,'ect',25,1),(511,7489675,7489674,'naa',100,2),(511,7489676,7489675,'600',3.333,3),(511,7489677,7489675,'000',3.333,3),(511,7489678,7489675,'00c',3.333,3),(511,7489679,7489675,'0c2',3.333,3),(511,7489680,7489675,'c29',3.333,3),(511,7489681,7489675,'29c',3.333,3),(511,7489682,7489675,'9cc',3.333,3),(511,7489683,7489675,'cc9',3.333,3),(511,7489684,7489675,'c9e',3.333,3),(511,7489685,7489675,'9ef',3.333,3),(511,7489686,7489675,'efd',3.333,3),(511,7489687,7489675,'fda',3.333,3),(511,7489688,7489675,'dad',3.333,3),(511,7489689,7489675,'ad2',3.333,3),(511,7489690,7489675,'d27',3.333,3),(511,7489691,7489675,'275',3.333,3),(511,7489692,7489675,'755',3.333,3),(511,7489693,7489675,'55b',3.333,3),(511,7489694,7489675,'5b3',3.333,3),(511,7489695,7489675,'b31',3.333,3),(511,7489696,7489675,'311',3.333,3),(511,7489697,7489675,'117',3.333,3),(511,7489698,7489675,'178',3.333,3),(511,7489699,7489675,'785',3.333,3),(511,7489700,7489675,'854',3.333,3),(511,7489701,7489675,'54b',3.333,3),(511,7489702,7489675,'4b1',3.333,3),(511,7489703,7489675,'b10',3.333,3),(511,7489704,7489675,'10b',3.333,3),(511,7489705,7489675,'0be',3.333,3),(511,7489706,7489676,'mon',100,1),(511,7489707,7489706,'201',50,1),(511,7489708,7489706,'013',50,1),(511,7489709,7489707,'adm',33.333,3),(511,7489710,7489707,'dmi',33.333,3),(511,7489711,7489707,'min',33.333,3),(511,7489712,7489709,'cap',16.667,1),(511,7489713,7489709,'apa',16.667,1),(511,7489714,7489709,'pac',16.667,1),(511,7489715,7489709,'aci',16.667,1),(511,7489716,7489709,'cit',16.667,1),(511,7489717,7489709,'ity',16.667,1),(511,7489718,7489712,'pat',50,1),(511,7489719,7489712,'ath',50,1),(511,7489720,7489718,'fre',14.286,1),(511,7489721,7489718,'ree',14.286,1),(511,7489722,7489718,'ees',14.286,1),(511,7489723,7489718,'esp',14.286,1),(511,7489724,7489718,'spa',14.286,1),(511,7489725,7489718,'pac',14.286,1),(511,7489726,7489718,'ace',14.286,1),(511,7489727,7489720,'dis',50,1),(511,7489728,7489720,'isk',50,1),(511,7489729,7489727,'ind',33.333,1),(511,7489730,7489727,'nde',33.333,1),(511,7489731,7489727,'dex',33.333,1),(511,7489732,7489729,'adm',8.333,1),(511,7489733,7489729,'dmi',8.333,1),(511,7489734,7489729,'min',8.333,1),(511,7489735,7489729,'ini',8.333,1),(511,7489736,7489729,'nis',8.333,1),(511,7489737,7489729,'ist',8.333,1),(511,7489738,7489729,'str',8.333,1),(511,7489739,7489729,'tra',8.333,1),(511,7489740,7489729,'rat',8.333,1),(511,7489741,7489729,'ati',8.333,1),(511,7489742,7489729,'tio',8.333,1),(511,7489743,7489729,'ion',8.333,1),(511,7489744,7489732,'sta',33.333,3),(511,7489745,7489732,'tat',33.333,3),(511,7489746,7489732,'ate',33.333,3),(511,7489747,7489744,'ena',20,2),(511,7489748,7489744,'nab',20,2),(511,7489749,7489744,'abl',20,2),(511,7489750,7489744,'ble',20,2),(511,7489751,7489744,'led',20,2),(511,7489752,7489747,'cac',33.333,2),(511,7489753,7489747,'ach',33.333,2),(511,7489754,7489747,'che',33.333,2),(511,7489755,7489752,'mod',50,1),(511,7489756,7489752,'ode',50,1),(511,7489757,7489755,'wri',14.286,1),(511,7489758,7489755,'rit',14.286,1),(511,7489759,7489755,'ite',14.286,1),(511,7489760,7489755,'tet',14.286,1),(511,7489761,7489755,'eth',14.286,1),(511,7489762,7489755,'thr',14.286,1),(511,7489763,7489755,'hru',14.286,1),(511,7489764,7489757,'ope',11.111,2),(511,7489765,7489757,'per',11.111,2),(511,7489766,7489757,'era',11.111,2),(511,7489767,7489757,'rat',11.111,2),(511,7489768,7489757,'ati',11.111,2),(511,7489769,7489757,'tio',11.111,2),(511,7489770,7489757,'ion',11.111,2),(511,7489771,7489757,'ona',11.111,2),(511,7489772,7489757,'nal',11.111,2),(511,7489773,7489764,'pen',20,1),(511,7489774,7489764,'end',20,1),(511,7489775,7489764,'ndi',20,1),(511,7489776,7489764,'din',20,1),(511,7489777,7489764,'ing',20,1),(511,7489778,7489773,'mes',20,1),(511,7489779,7489773,'ess',20,1),(511,7489780,7489773,'ssa',20,1),(511,7489781,7489773,'sag',20,1),(511,7489782,7489773,'age',20,1),(511,7489783,7489778,'wai',20,1),(511,7489784,7489778,'ait',20,1),(511,7489785,7489778,'iti',20,1),(511,7489786,7489778,'tin',20,1),(511,7489787,7489778,'ing',20,1),(511,7489788,7489783,'for',100,1),(511,7489789,7489788,'per',11.111,1),(511,7489790,7489788,'erf',11.111,1),(511,7489791,7489788,'rfo',11.111,1),(511,7489792,7489788,'for',11.111,1),(511,7489793,7489788,'orm',11.111,1),(511,7489794,7489788,'rma',11.111,1),(511,7489795,7489788,'man',11.111,1),(511,7489796,7489788,'anc',11.111,1),(511,7489797,7489788,'nce',11.111,1),(511,7489798,7489789,'ide',12.5,1),(511,7489799,7489789,'den',12.5,1),(511,7489800,7489789,'ent',12.5,1),(511,7489801,7489789,'nti',12.5,1),(511,7489802,7489789,'tif',12.5,1),(511,7489803,7489789,'ifi',12.5,1),(511,7489804,7489789,'fie',12.5,1),(511,7489805,7489789,'ier',12.5,1),(511,7489806,7489798,'vdi',33.333,3),(511,7489807,7489798,'dis',33.333,3),(511,7489808,7489798,'isk',33.333,3),(511,7489809,7489806,'nam',50,1),(511,7489810,7489806,'ame',50,1),(511,7489811,7489809,'typ',50,1),(511,7489812,7489809,'ype',50,1),(511,7489813,7489811,'dir',25,1),(511,7489814,7489811,'ire',25,1),(511,7489815,7489811,'rec',25,1),(511,7489816,7489811,'ect',25,1),(512,7489818,7489817,'naa',100,2),(512,7489819,7489818,'600',3.333,3),(512,7489820,7489818,'000',3.333,3),(512,7489821,7489818,'00c',3.333,3),(512,7489822,7489818,'0c2',3.333,3),(512,7489823,7489818,'c29',3.333,3),(512,7489824,7489818,'29f',3.333,3),(512,7489825,7489818,'9fd',3.333,3),(512,7489826,7489818,'fda',3.333,3),(512,7489827,7489818,'dad',3.333,3),(512,7489828,7489818,'ad1',3.333,3),(512,7489829,7489818,'d13',3.333,3),(512,7489830,7489818,'130',3.333,3),(512,7489831,7489818,'300',3.333,3),(512,7489832,7489818,'000',3.333,3),(512,7489833,7489818,'009',3.333,3),(512,7489834,7489818,'09d',3.333,3),(512,7489835,7489818,'9d0',3.333,3),(512,7489836,7489818,'d07',3.333,3),(512,7489837,7489818,'07a',3.333,3),(512,7489838,7489818,'7ab',3.333,3),(512,7489839,7489818,'ab0',3.333,3),(512,7489840,7489818,'b02',3.333,3),(512,7489841,7489818,'021',3.333,3),(512,7489842,7489818,'21f',3.333,3),(512,7489843,7489818,'1f2',3.333,3),(512,7489844,7489818,'f2f',3.333,3),(512,7489845,7489818,'2f3',3.333,3),(512,7489846,7489818,'f39',3.333,3),(512,7489847,7489818,'390',3.333,3),(512,7489848,7489818,'90b',3.333,3),(512,7489849,7489819,'mon',100,1),(512,7489850,7489849,'201',50,1),(512,7489851,7489849,'013',50,1),(512,7489852,7489850,'adm',33.333,3),(512,7489853,7489850,'dmi',33.333,3),(512,7489854,7489850,'min',33.333,3),(512,7489855,7489852,'cap',16.667,1),(512,7489856,7489852,'apa',16.667,1),(512,7489857,7489852,'pac',16.667,1),(512,7489858,7489852,'aci',16.667,1),(512,7489859,7489852,'cit',16.667,1),(512,7489860,7489852,'ity',16.667,1),(512,7489861,7489855,'pat',50,1),(512,7489862,7489855,'ath',50,1),(512,7489863,7489861,'fre',14.286,1),(512,7489864,7489861,'ree',14.286,1),(512,7489865,7489861,'ees',14.286,1),(512,7489866,7489861,'esp',14.286,1),(512,7489867,7489861,'spa',14.286,1),(512,7489868,7489861,'pac',14.286,1),(512,7489869,7489861,'ace',14.286,1),(512,7489870,7489863,'dis',50,1),(512,7489871,7489863,'isk',50,1),(512,7489872,7489870,'ind',33.333,1),(512,7489873,7489870,'nde',33.333,1),(512,7489874,7489870,'dex',33.333,1),(512,7489875,7489872,'adm',8.333,1),(512,7489876,7489872,'dmi',8.333,1),(512,7489877,7489872,'min',8.333,1),(512,7489878,7489872,'ini',8.333,1),(512,7489879,7489872,'nis',8.333,1),(512,7489880,7489872,'ist',8.333,1),(512,7489881,7489872,'str',8.333,1),(512,7489882,7489872,'tra',8.333,1),(512,7489883,7489872,'rat',8.333,1),(512,7489884,7489872,'ati',8.333,1),(512,7489885,7489872,'tio',8.333,1),(512,7489886,7489872,'ion',8.333,1),(512,7489887,7489875,'sta',33.333,3),(512,7489888,7489875,'tat',33.333,3),(512,7489889,7489875,'ate',33.333,3),(512,7489890,7489887,'ena',20,2),(512,7489891,7489887,'nab',20,2),(512,7489892,7489887,'abl',20,2),(512,7489893,7489887,'ble',20,2),(512,7489894,7489887,'led',20,2),(512,7489895,7489890,'cac',33.333,2),(512,7489896,7489890,'ach',33.333,2),(512,7489897,7489890,'che',33.333,2),(512,7489898,7489895,'mod',50,1),(512,7489899,7489895,'ode',50,1),(512,7489900,7489898,'wri',14.286,1),(512,7489901,7489898,'rit',14.286,1),(512,7489902,7489898,'ite',14.286,1),(512,7489903,7489898,'tet',14.286,1),(512,7489904,7489898,'eth',14.286,1),(512,7489905,7489898,'thr',14.286,1),(512,7489906,7489898,'hru',14.286,1),(512,7489907,7489900,'ope',11.111,2),(512,7489908,7489900,'per',11.111,2),(512,7489909,7489900,'era',11.111,2),(512,7489910,7489900,'rat',11.111,2),(512,7489911,7489900,'ati',11.111,2),(512,7489912,7489900,'tio',11.111,2),(512,7489913,7489900,'ion',11.111,2),(512,7489914,7489900,'ona',11.111,2),(512,7489915,7489900,'nal',11.111,2),(512,7489916,7489907,'pen',20,1),(512,7489917,7489907,'end',20,1),(512,7489918,7489907,'ndi',20,1),(512,7489919,7489907,'din',20,1),(512,7489920,7489907,'ing',20,1),(512,7489921,7489916,'mes',20,1),(512,7489922,7489916,'ess',20,1),(512,7489923,7489916,'ssa',20,1),(512,7489924,7489916,'sag',20,1),(512,7489925,7489916,'age',20,1),(512,7489926,7489921,'wai',20,1),(512,7489927,7489921,'ait',20,1),(512,7489928,7489921,'iti',20,1),(512,7489929,7489921,'tin',20,1),(512,7489930,7489921,'ing',20,1),(512,7489931,7489926,'for',100,1),(512,7489932,7489931,'per',11.111,1),(512,7489933,7489931,'erf',11.111,1),(512,7489934,7489931,'rfo',11.111,1),(512,7489935,7489931,'for',11.111,1),(512,7489936,7489931,'orm',11.111,1),(512,7489937,7489931,'rma',11.111,1),(512,7489938,7489931,'man',11.111,1),(512,7489939,7489931,'anc',11.111,1),(512,7489940,7489931,'nce',11.111,1),(512,7489941,7489932,'ide',12.5,1),(512,7489942,7489932,'den',12.5,1),(512,7489943,7489932,'ent',12.5,1),(512,7489944,7489932,'nti',12.5,1),(512,7489945,7489932,'tif',12.5,1),(512,7489946,7489932,'ifi',12.5,1),(512,7489947,7489932,'fie',12.5,1),(512,7489948,7489932,'ier',12.5,1),(512,7489949,7489941,'vdi',33.333,3),(512,7489950,7489941,'dis',33.333,3),(512,7489951,7489941,'isk',33.333,3),(512,7489952,7489949,'nam',50,1),(512,7489953,7489949,'ame',50,1),(512,7489954,7489952,'typ',50,1),(512,7489955,7489952,'ype',50,1),(512,7489956,7489954,'dir',25,1),(512,7489957,7489954,'ire',25,1),(512,7489958,7489954,'rec',25,1),(512,7489959,7489954,'ect',25,1),(513,7489961,7489960,'naa',100,2),(513,7489962,7489961,'600',3.333,3),(513,7489963,7489961,'000',3.333,3),(513,7489964,7489961,'00c',3.333,3),(513,7489965,7489961,'0c2',3.333,3),(513,7489966,7489961,'c29',3.333,3),(513,7489967,7489961,'297',3.333,3),(513,7489968,7489961,'977',3.333,3),(513,7489969,7489961,'774',3.333,3),(513,7489970,7489961,'74d',3.333,3),(513,7489971,7489961,'4da',3.333,3),(513,7489972,7489961,'dac',3.333,3),(513,7489973,7489961,'ac9',3.333,3),(513,7489974,7489961,'c90',3.333,3),(513,7489975,7489961,'904',3.333,3),(513,7489976,7489961,'047',3.333,3),(513,7489977,7489961,'471',3.333,3),(513,7489978,7489961,'714',3.333,3),(513,7489979,7489961,'14d',3.333,3),(513,7489980,7489961,'4dc',3.333,3),(513,7489981,7489961,'dce',3.333,3),(513,7489982,7489961,'cee',3.333,3),(513,7489983,7489961,'eef',3.333,3),(513,7489984,7489961,'ef0',3.333,3),(513,7489985,7489961,'f03',3.333,3),(513,7489986,7489961,'034',3.333,3),(513,7489987,7489961,'34d',3.333,3),(513,7489988,7489961,'4d2',3.333,3),(513,7489989,7489961,'d2e',3.333,3),(513,7489990,7489961,'2e3',3.333,3),(513,7489991,7489961,'e3e',3.333,3),(513,7489992,7489962,'mon',100,1),(513,7489993,7489992,'201',50,1),(513,7489994,7489992,'013',50,1),(513,7489995,7489993,'adm',33.333,3),(513,7489996,7489993,'dmi',33.333,3),(513,7489997,7489993,'min',33.333,3),(513,7489998,7489995,'cap',16.667,1),(513,7489999,7489995,'apa',16.667,1),(513,7490000,7489995,'pac',16.667,1),(513,7490001,7489995,'aci',16.667,1),(513,7490002,7489995,'cit',16.667,1),(513,7490003,7489995,'ity',16.667,1),(513,7490004,7489998,'pat',50,1),(513,7490005,7489998,'ath',50,1),(513,7490006,7490004,'fre',14.286,1),(513,7490007,7490004,'ree',14.286,1),(513,7490008,7490004,'ees',14.286,1),(513,7490009,7490004,'esp',14.286,1),(513,7490010,7490004,'spa',14.286,1),(513,7490011,7490004,'pac',14.286,1),(513,7490012,7490004,'ace',14.286,1),(513,7490013,7490006,'dis',50,1),(513,7490014,7490006,'isk',50,1),(513,7490015,7490013,'ind',33.333,1),(513,7490016,7490013,'nde',33.333,1),(513,7490017,7490013,'dex',33.333,1),(513,7490018,7490015,'adm',8.333,1),(513,7490019,7490015,'dmi',8.333,1),(513,7490020,7490015,'min',8.333,1),(513,7490021,7490015,'ini',8.333,1),(513,7490022,7490015,'nis',8.333,1),(513,7490023,7490015,'ist',8.333,1),(513,7490024,7490015,'str',8.333,1),(513,7490025,7490015,'tra',8.333,1),(513,7490026,7490015,'rat',8.333,1),(513,7490027,7490015,'ati',8.333,1),(513,7490028,7490015,'tio',8.333,1),(513,7490029,7490015,'ion',8.333,1),(513,7490030,7490018,'sta',33.333,3),(513,7490031,7490018,'tat',33.333,3),(513,7490032,7490018,'ate',33.333,3),(513,7490033,7490030,'ena',20,2),(513,7490034,7490030,'nab',20,2),(513,7490035,7490030,'abl',20,2),(513,7490036,7490030,'ble',20,2),(513,7490037,7490030,'led',20,2),(513,7490038,7490033,'cac',33.333,2),(513,7490039,7490033,'ach',33.333,2),(513,7490040,7490033,'che',33.333,2),(513,7490041,7490038,'mod',50,1),(513,7490042,7490038,'ode',50,1),(513,7490043,7490041,'wri',14.286,1),(513,7490044,7490041,'rit',14.286,1),(513,7490045,7490041,'ite',14.286,1),(513,7490046,7490041,'tet',14.286,1),(513,7490047,7490041,'eth',14.286,1),(513,7490048,7490041,'thr',14.286,1),(513,7490049,7490041,'hru',14.286,1),(513,7490050,7490043,'ope',11.111,2),(513,7490051,7490043,'per',11.111,2),(513,7490052,7490043,'era',11.111,2),(513,7490053,7490043,'rat',11.111,2),(513,7490054,7490043,'ati',11.111,2),(513,7490055,7490043,'tio',11.111,2),(513,7490056,7490043,'ion',11.111,2),(513,7490057,7490043,'ona',11.111,2),(513,7490058,7490043,'nal',11.111,2),(513,7490059,7490050,'pen',20,1),(513,7490060,7490050,'end',20,1),(513,7490061,7490050,'ndi',20,1),(513,7490062,7490050,'din',20,1),(513,7490063,7490050,'ing',20,1),(513,7490064,7490059,'mes',20,1),(513,7490065,7490059,'ess',20,1),(513,7490066,7490059,'ssa',20,1),(513,7490067,7490059,'sag',20,1),(513,7490068,7490059,'age',20,1),(513,7490069,7490064,'wai',20,1),(513,7490070,7490064,'ait',20,1),(513,7490071,7490064,'iti',20,1),(513,7490072,7490064,'tin',20,1),(513,7490073,7490064,'ing',20,1),(513,7490074,7490069,'for',100,1),(513,7490075,7490074,'per',11.111,1),(513,7490076,7490074,'erf',11.111,1),(513,7490077,7490074,'rfo',11.111,1),(513,7490078,7490074,'for',11.111,1),(513,7490079,7490074,'orm',11.111,1),(513,7490080,7490074,'rma',11.111,1),(513,7490081,7490074,'man',11.111,1),(513,7490082,7490074,'anc',11.111,1),(513,7490083,7490074,'nce',11.111,1),(513,7490084,7490075,'ide',12.5,1),(513,7490085,7490075,'den',12.5,1),(513,7490086,7490075,'ent',12.5,1),(513,7490087,7490075,'nti',12.5,1),(513,7490088,7490075,'tif',12.5,1),(513,7490089,7490075,'ifi',12.5,1),(513,7490090,7490075,'fie',12.5,1),(513,7490091,7490075,'ier',12.5,1),(513,7490092,7490084,'vdi',33.333,3),(513,7490093,7490084,'dis',33.333,3),(513,7490094,7490084,'isk',33.333,3),(513,7490095,7490092,'nam',50,1),(513,7490096,7490092,'ame',50,1),(513,7490097,7490095,'typ',50,1),(513,7490098,7490095,'ype',50,1),(513,7490099,7490097,'dir',25,1),(513,7490100,7490097,'ire',25,1),(513,7490101,7490097,'rec',25,1),(513,7490102,7490097,'ect',25,1),(514,7490104,7490103,'naa',100,2),(514,7490105,7490104,'600',3.333,3),(514,7490106,7490104,'000',3.333,3),(514,7490107,7490104,'00c',3.333,3),(514,7490108,7490104,'0c2',3.333,3),(514,7490109,7490104,'c29',3.333,3),(514,7490110,7490104,'29c',3.333,3),(514,7490111,7490104,'9c8',3.333,3),(514,7490112,7490104,'c89',3.333,3),(514,7490113,7490104,'89d',3.333,3),(514,7490114,7490104,'9d4',3.333,3),(514,7490115,7490104,'d41',3.333,3),(514,7490116,7490104,'416',3.333,3),(514,7490117,7490104,'168',3.333,3),(514,7490118,7490104,'689',3.333,3),(514,7490119,7490104,'898',3.333,3),(514,7490120,7490104,'984',3.333,3),(514,7490121,7490104,'845',3.333,3),(514,7490122,7490104,'450',3.333,3),(514,7490123,7490104,'50d',3.333,3),(514,7490124,7490104,'0da',3.333,3),(514,7490125,7490104,'dab',3.333,3),(514,7490126,7490104,'abe',3.333,3),(514,7490127,7490104,'be9',3.333,3),(514,7490128,7490104,'e98',3.333,3),(514,7490129,7490104,'986',3.333,3),(514,7490130,7490104,'86f',3.333,3),(514,7490131,7490104,'6f0',3.333,3),(514,7490132,7490104,'f0e',3.333,3),(514,7490133,7490104,'0e9',3.333,3),(514,7490134,7490104,'e9b',3.333,3),(514,7490135,7490105,'mon',100,1),(514,7490136,7490135,'201',50,1),(514,7490137,7490135,'013',50,1),(514,7490138,7490136,'adm',33.333,3),(514,7490139,7490136,'dmi',33.333,3),(514,7490140,7490136,'min',33.333,3),(514,7490141,7490138,'cap',16.667,1),(514,7490142,7490138,'apa',16.667,1),(514,7490143,7490138,'pac',16.667,1),(514,7490144,7490138,'aci',16.667,1),(514,7490145,7490138,'cit',16.667,1),(514,7490146,7490138,'ity',16.667,1),(514,7490147,7490141,'pat',50,1),(514,7490148,7490141,'ath',50,1),(514,7490149,7490147,'fre',14.286,1),(514,7490150,7490147,'ree',14.286,1),(514,7490151,7490147,'ees',14.286,1),(514,7490152,7490147,'esp',14.286,1),(514,7490153,7490147,'spa',14.286,1),(514,7490154,7490147,'pac',14.286,1),(514,7490155,7490147,'ace',14.286,1),(514,7490156,7490149,'dis',50,1),(514,7490157,7490149,'isk',50,1),(514,7490158,7490156,'ind',33.333,1),(514,7490159,7490156,'nde',33.333,1),(514,7490160,7490156,'dex',33.333,1),(514,7490161,7490158,'adm',8.333,1),(514,7490162,7490158,'dmi',8.333,1),(514,7490163,7490158,'min',8.333,1),(514,7490164,7490158,'ini',8.333,1),(514,7490165,7490158,'nis',8.333,1),(514,7490166,7490158,'ist',8.333,1),(514,7490167,7490158,'str',8.333,1),(514,7490168,7490158,'tra',8.333,1),(514,7490169,7490158,'rat',8.333,1),(514,7490170,7490158,'ati',8.333,1),(514,7490171,7490158,'tio',8.333,1),(514,7490172,7490158,'ion',8.333,1),(514,7490173,7490161,'sta',33.333,3),(514,7490174,7490161,'tat',33.333,3),(514,7490175,7490161,'ate',33.333,3),(514,7490176,7490173,'ena',20,2),(514,7490177,7490173,'nab',20,2),(514,7490178,7490173,'abl',20,2),(514,7490179,7490173,'ble',20,2),(514,7490180,7490173,'led',20,2),(514,7490181,7490176,'cac',33.333,2),(514,7490182,7490176,'ach',33.333,2),(514,7490183,7490176,'che',33.333,2),(514,7490184,7490181,'mod',50,1),(514,7490185,7490181,'ode',50,1),(514,7490186,7490184,'wri',14.286,1),(514,7490187,7490184,'rit',14.286,1),(514,7490188,7490184,'ite',14.286,1),(514,7490189,7490184,'tet',14.286,1),(514,7490190,7490184,'eth',14.286,1),(514,7490191,7490184,'thr',14.286,1),(514,7490192,7490184,'hru',14.286,1),(514,7490193,7490186,'ope',11.111,2),(514,7490194,7490186,'per',11.111,2),(514,7490195,7490186,'era',11.111,2),(514,7490196,7490186,'rat',11.111,2),(514,7490197,7490186,'ati',11.111,2),(514,7490198,7490186,'tio',11.111,2),(514,7490199,7490186,'ion',11.111,2),(514,7490200,7490186,'ona',11.111,2),(514,7490201,7490186,'nal',11.111,2),(514,7490202,7490193,'pen',20,1),(514,7490203,7490193,'end',20,1),(514,7490204,7490193,'ndi',20,1),(514,7490205,7490193,'din',20,1),(514,7490206,7490193,'ing',20,1),(514,7490207,7490202,'mes',20,1),(514,7490208,7490202,'ess',20,1),(514,7490209,7490202,'ssa',20,1),(514,7490210,7490202,'sag',20,1),(514,7490211,7490202,'age',20,1),(514,7490212,7490207,'wai',20,1),(514,7490213,7490207,'ait',20,1),(514,7490214,7490207,'iti',20,1),(514,7490215,7490207,'tin',20,1),(514,7490216,7490207,'ing',20,1),(514,7490217,7490212,'for',100,1),(514,7490218,7490217,'per',11.111,1),(514,7490219,7490217,'erf',11.111,1),(514,7490220,7490217,'rfo',11.111,1),(514,7490221,7490217,'for',11.111,1),(514,7490222,7490217,'orm',11.111,1),(514,7490223,7490217,'rma',11.111,1),(514,7490224,7490217,'man',11.111,1),(514,7490225,7490217,'anc',11.111,1),(514,7490226,7490217,'nce',11.111,1),(514,7490227,7490218,'ide',12.5,1),(514,7490228,7490218,'den',12.5,1),(514,7490229,7490218,'ent',12.5,1),(514,7490230,7490218,'nti',12.5,1),(514,7490231,7490218,'tif',12.5,1),(514,7490232,7490218,'ifi',12.5,1),(514,7490233,7490218,'fie',12.5,1),(514,7490234,7490218,'ier',12.5,1),(514,7490235,7490227,'vdi',33.333,3),(514,7490236,7490227,'dis',33.333,3),(514,7490237,7490227,'isk',33.333,3),(514,7490238,7490235,'nam',50,1),(514,7490239,7490235,'ame',50,1),(514,7490240,7490238,'typ',50,1),(514,7490241,7490238,'ype',50,1),(514,7490242,7490240,'dir',25,1),(514,7490243,7490240,'ire',25,1),(514,7490244,7490240,'rec',25,1),(514,7490245,7490240,'ect',25,1),(515,7490247,7490246,'naa',100,2),(515,7490248,7490247,'600',3.333,3),(515,7490249,7490247,'000',3.333,3),(515,7490250,7490247,'00c',3.333,3),(515,7490251,7490247,'0c2',3.333,3),(515,7490252,7490247,'c29',3.333,3),(515,7490253,7490247,'292',3.333,3),(515,7490254,7490247,'925',3.333,3),(515,7490255,7490247,'255',3.333,3),(515,7490256,7490247,'55d',3.333,3),(515,7490257,7490247,'5da',3.333,3),(515,7490258,7490247,'da6',3.333,3),(515,7490259,7490247,'a6e',3.333,3),(515,7490260,7490247,'6e4',3.333,3),(515,7490261,7490247,'e49',3.333,3),(515,7490262,7490247,'492',3.333,3),(515,7490263,7490247,'92b',3.333,3),(515,7490264,7490247,'2bc',3.333,3),(515,7490265,7490247,'bc9',3.333,3),(515,7490266,7490247,'c9d',3.333,3),(515,7490267,7490247,'9d5',3.333,3),(515,7490268,7490247,'d55',3.333,3),(515,7490269,7490247,'551',3.333,3),(515,7490270,7490247,'51b',3.333,3),(515,7490271,7490247,'1bd',3.333,3),(515,7490272,7490247,'bdf',3.333,3),(515,7490273,7490247,'dfe',3.333,3),(515,7490274,7490247,'fe1',3.333,3),(515,7490275,7490247,'e17',3.333,3),(515,7490276,7490247,'174',3.333,3),(515,7490277,7490247,'748',3.333,3),(515,7490278,7490248,'mon',100,1),(515,7490279,7490278,'201',50,1),(515,7490280,7490278,'013',50,1),(515,7490281,7490279,'adm',33.333,3),(515,7490282,7490279,'dmi',33.333,3),(515,7490283,7490279,'min',33.333,3),(515,7490284,7490281,'cap',16.667,1),(515,7490285,7490281,'apa',16.667,1),(515,7490286,7490281,'pac',16.667,1),(515,7490287,7490281,'aci',16.667,1),(515,7490288,7490281,'cit',16.667,1),(515,7490289,7490281,'ity',16.667,1),(515,7490290,7490284,'pat',50,1),(515,7490291,7490284,'ath',50,1),(515,7490292,7490290,'fre',14.286,1),(515,7490293,7490290,'ree',14.286,1),(515,7490294,7490290,'ees',14.286,1),(515,7490295,7490290,'esp',14.286,1),(515,7490296,7490290,'spa',14.286,1),(515,7490297,7490290,'pac',14.286,1),(515,7490298,7490290,'ace',14.286,1),(515,7490299,7490292,'dis',50,1),(515,7490300,7490292,'isk',50,1),(515,7490301,7490299,'ind',33.333,1),(515,7490302,7490299,'nde',33.333,1),(515,7490303,7490299,'dex',33.333,1),(515,7490304,7490301,'adm',8.333,1),(515,7490305,7490301,'dmi',8.333,1),(515,7490306,7490301,'min',8.333,1),(515,7490307,7490301,'ini',8.333,1),(515,7490308,7490301,'nis',8.333,1),(515,7490309,7490301,'ist',8.333,1),(515,7490310,7490301,'str',8.333,1),(515,7490311,7490301,'tra',8.333,1),(515,7490312,7490301,'rat',8.333,1),(515,7490313,7490301,'ati',8.333,1),(515,7490314,7490301,'tio',8.333,1),(515,7490315,7490301,'ion',8.333,1),(515,7490316,7490304,'sta',33.333,3),(515,7490317,7490304,'tat',33.333,3),(515,7490318,7490304,'ate',33.333,3),(515,7490319,7490316,'ena',20,2),(515,7490320,7490316,'nab',20,2),(515,7490321,7490316,'abl',20,2),(515,7490322,7490316,'ble',20,2),(515,7490323,7490316,'led',20,2),(515,7490324,7490319,'cac',33.333,2),(515,7490325,7490319,'ach',33.333,2),(515,7490326,7490319,'che',33.333,2),(515,7490327,7490324,'mod',50,1),(515,7490328,7490324,'ode',50,1),(515,7490329,7490327,'wri',14.286,1),(515,7490330,7490327,'rit',14.286,1),(515,7490331,7490327,'ite',14.286,1),(515,7490332,7490327,'tet',14.286,1),(515,7490333,7490327,'eth',14.286,1),(515,7490334,7490327,'thr',14.286,1),(515,7490335,7490327,'hru',14.286,1),(515,7490336,7490329,'ope',11.111,2),(515,7490337,7490329,'per',11.111,2),(515,7490338,7490329,'era',11.111,2),(515,7490339,7490329,'rat',11.111,2),(515,7490340,7490329,'ati',11.111,2),(515,7490341,7490329,'tio',11.111,2),(515,7490342,7490329,'ion',11.111,2),(515,7490343,7490329,'ona',11.111,2),(515,7490344,7490329,'nal',11.111,2),(515,7490345,7490336,'pen',20,1),(515,7490346,7490336,'end',20,1),(515,7490347,7490336,'ndi',20,1),(515,7490348,7490336,'din',20,1),(515,7490349,7490336,'ing',20,1),(515,7490350,7490345,'mes',20,1),(515,7490351,7490345,'ess',20,1),(515,7490352,7490345,'ssa',20,1),(515,7490353,7490345,'sag',20,1),(515,7490354,7490345,'age',20,1),(515,7490355,7490350,'wai',20,1),(515,7490356,7490350,'ait',20,1),(515,7490357,7490350,'iti',20,1),(515,7490358,7490350,'tin',20,1),(515,7490359,7490350,'ing',20,1),(515,7490360,7490355,'for',100,1),(515,7490361,7490360,'per',11.111,1),(515,7490362,7490360,'erf',11.111,1),(515,7490363,7490360,'rfo',11.111,1),(515,7490364,7490360,'for',11.111,1),(515,7490365,7490360,'orm',11.111,1),(515,7490366,7490360,'rma',11.111,1),(515,7490367,7490360,'man',11.111,1),(515,7490368,7490360,'anc',11.111,1),(515,7490369,7490360,'nce',11.111,1),(515,7490370,7490361,'ide',12.5,1),(515,7490371,7490361,'den',12.5,1),(515,7490372,7490361,'ent',12.5,1),(515,7490373,7490361,'nti',12.5,1),(515,7490374,7490361,'tif',12.5,1),(515,7490375,7490361,'ifi',12.5,1),(515,7490376,7490361,'fie',12.5,1),(515,7490377,7490361,'ier',12.5,1),(515,7490378,7490370,'vdi',33.333,3),(515,7490379,7490370,'dis',33.333,3),(515,7490380,7490370,'isk',33.333,3),(515,7490381,7490378,'nam',50,1),(515,7490382,7490378,'ame',50,1),(515,7490383,7490381,'typ',50,1),(515,7490384,7490381,'ype',50,1),(515,7490385,7490383,'dir',25,1),(515,7490386,7490383,'ire',25,1),(515,7490387,7490383,'rec',25,1),(515,7490388,7490383,'ect',25,1),(516,7490390,7490389,'naa',100,2),(516,7490391,7490390,'600',3.333,3),(516,7490392,7490390,'000',3.333,3),(516,7490393,7490390,'00c',3.333,3),(516,7490394,7490390,'0c2',3.333,3),(516,7490395,7490390,'c29',3.333,3),(516,7490396,7490390,'29c',3.333,3),(516,7490397,7490390,'9c1',3.333,3),(516,7490398,7490390,'c15',3.333,3),(516,7490399,7490390,'15f',3.333,3),(516,7490400,7490390,'5f9',3.333,3),(516,7490401,7490390,'f92',3.333,3),(516,7490402,7490390,'925',3.333,3),(516,7490403,7490390,'25f',3.333,3),(516,7490404,7490390,'5f4',3.333,3),(516,7490405,7490390,'f48',3.333,3),(516,7490406,7490390,'48f',3.333,3),(516,7490407,7490390,'8fa',3.333,3),(516,7490408,7490390,'fa9',3.333,3),(516,7490409,7490390,'a9b',3.333,3),(516,7490410,7490390,'9b3',3.333,3),(516,7490411,7490390,'b3e',3.333,3),(516,7490412,7490390,'3e4',3.333,3),(516,7490413,7490390,'e48',3.333,3),(516,7490414,7490390,'488',3.333,3),(516,7490415,7490390,'889',3.333,3),(516,7490416,7490390,'89c',3.333,3),(516,7490417,7490390,'9c0',3.333,3),(516,7490418,7490390,'c03',3.333,3),(516,7490419,7490390,'037',3.333,3),(516,7490420,7490390,'379',3.333,3),(516,7490421,7490391,'mon',100,1),(516,7490422,7490421,'201',50,1),(516,7490423,7490421,'013',50,1),(516,7490424,7490422,'adm',33.333,3),(516,7490425,7490422,'dmi',33.333,3),(516,7490426,7490422,'min',33.333,3),(516,7490427,7490424,'cap',16.667,1),(516,7490428,7490424,'apa',16.667,1),(516,7490429,7490424,'pac',16.667,1),(516,7490430,7490424,'aci',16.667,1),(516,7490431,7490424,'cit',16.667,1),(516,7490432,7490424,'ity',16.667,1),(516,7490433,7490427,'pat',50,1),(516,7490434,7490427,'ath',50,1),(516,7490435,7490433,'fre',14.286,1),(516,7490436,7490433,'ree',14.286,1),(516,7490437,7490433,'ees',14.286,1),(516,7490438,7490433,'esp',14.286,1),(516,7490439,7490433,'spa',14.286,1),(516,7490440,7490433,'pac',14.286,1),(516,7490441,7490433,'ace',14.286,1),(516,7490442,7490435,'dis',50,1),(516,7490443,7490435,'isk',50,1),(516,7490444,7490442,'ind',33.333,1),(516,7490445,7490442,'nde',33.333,1),(516,7490446,7490442,'dex',33.333,1),(516,7490447,7490444,'adm',8.333,1),(516,7490448,7490444,'dmi',8.333,1),(516,7490449,7490444,'min',8.333,1),(516,7490450,7490444,'ini',8.333,1),(516,7490451,7490444,'nis',8.333,1),(516,7490452,7490444,'ist',8.333,1),(516,7490453,7490444,'str',8.333,1),(516,7490454,7490444,'tra',8.333,1),(516,7490455,7490444,'rat',8.333,1),(516,7490456,7490444,'ati',8.333,1),(516,7490457,7490444,'tio',8.333,1),(516,7490458,7490444,'ion',8.333,1),(516,7490459,7490447,'sta',33.333,3),(516,7490460,7490447,'tat',33.333,3),(516,7490461,7490447,'ate',33.333,3),(516,7490462,7490459,'ena',20,2),(516,7490463,7490459,'nab',20,2),(516,7490464,7490459,'abl',20,2),(516,7490465,7490459,'ble',20,2),(516,7490466,7490459,'led',20,2),(516,7490467,7490462,'cac',33.333,2),(516,7490468,7490462,'ach',33.333,2),(516,7490469,7490462,'che',33.333,2),(516,7490470,7490467,'mod',50,1),(516,7490471,7490467,'ode',50,1),(516,7490472,7490470,'wri',14.286,1),(516,7490473,7490470,'rit',14.286,1),(516,7490474,7490470,'ite',14.286,1),(516,7490475,7490470,'tet',14.286,1),(516,7490476,7490470,'eth',14.286,1),(516,7490477,7490470,'thr',14.286,1),(516,7490478,7490470,'hru',14.286,1),(516,7490479,7490472,'ope',11.111,2),(516,7490480,7490472,'per',11.111,2),(516,7490481,7490472,'era',11.111,2),(516,7490482,7490472,'rat',11.111,2),(516,7490483,7490472,'ati',11.111,2),(516,7490484,7490472,'tio',11.111,2),(516,7490485,7490472,'ion',11.111,2),(516,7490486,7490472,'ona',11.111,2),(516,7490487,7490472,'nal',11.111,2),(516,7490488,7490479,'pen',20,1),(516,7490489,7490479,'end',20,1),(516,7490490,7490479,'ndi',20,1),(516,7490491,7490479,'din',20,1),(516,7490492,7490479,'ing',20,1),(516,7490493,7490488,'mes',20,1),(516,7490494,7490488,'ess',20,1),(516,7490495,7490488,'ssa',20,1),(516,7490496,7490488,'sag',20,1),(516,7490497,7490488,'age',20,1),(516,7490498,7490493,'wai',20,1),(516,7490499,7490493,'ait',20,1),(516,7490500,7490493,'iti',20,1),(516,7490501,7490493,'tin',20,1),(516,7490502,7490493,'ing',20,1),(516,7490503,7490498,'for',100,1),(516,7490504,7490503,'per',11.111,1),(516,7490505,7490503,'erf',11.111,1),(516,7490506,7490503,'rfo',11.111,1),(516,7490507,7490503,'for',11.111,1),(516,7490508,7490503,'orm',11.111,1),(516,7490509,7490503,'rma',11.111,1),(516,7490510,7490503,'man',11.111,1),(516,7490511,7490503,'anc',11.111,1),(516,7490512,7490503,'nce',11.111,1),(516,7490513,7490504,'ide',12.5,1),(516,7490514,7490504,'den',12.5,1),(516,7490515,7490504,'ent',12.5,1),(516,7490516,7490504,'nti',12.5,1),(516,7490517,7490504,'tif',12.5,1),(516,7490518,7490504,'ifi',12.5,1),(516,7490519,7490504,'fie',12.5,1),(516,7490520,7490504,'ier',12.5,1),(516,7490521,7490513,'vdi',33.333,3),(516,7490522,7490513,'dis',33.333,3),(516,7490523,7490513,'isk',33.333,3),(516,7490524,7490521,'nam',50,1),(516,7490525,7490521,'ame',50,1),(516,7490526,7490524,'typ',50,1),(516,7490527,7490524,'ype',50,1),(516,7490528,7490526,'dir',25,1),(516,7490529,7490526,'ire',25,1),(516,7490530,7490526,'rec',25,1),(516,7490531,7490526,'ect',25,1),(517,7490533,7490532,'naa',100,2),(517,7490534,7490533,'600',3.333,3),(517,7490535,7490533,'000',3.333,3),(517,7490536,7490533,'00c',3.333,3),(517,7490537,7490533,'0c2',3.333,3),(517,7490538,7490533,'c29',3.333,3),(517,7490539,7490533,'293',3.333,3),(517,7490540,7490533,'93f',3.333,3),(517,7490541,7490533,'3f8',3.333,3),(517,7490542,7490533,'f80',3.333,3),(517,7490543,7490533,'80f',3.333,3),(517,7490544,7490533,'0fe',3.333,3),(517,7490545,7490533,'fe9',3.333,3),(517,7490546,7490533,'e9e',3.333,3),(517,7490547,7490533,'9e8',3.333,3),(517,7490548,7490533,'e83',3.333,3),(517,7490549,7490533,'83d',3.333,3),(517,7490550,7490533,'3d5',3.333,3),(517,7490551,7490533,'d54',3.333,3),(517,7490552,7490533,'54e',3.333,3),(517,7490553,7490533,'4ec',3.333,3),(517,7490554,7490533,'ece',3.333,3),(517,7490555,7490533,'ce0',3.333,3),(517,7490556,7490533,'e0f',3.333,3),(517,7490557,7490533,'0fd',3.333,3),(517,7490558,7490533,'fd2',3.333,3),(517,7490559,7490533,'d2f',3.333,3),(517,7490560,7490533,'2fc',3.333,3),(517,7490561,7490533,'fc6',3.333,3),(517,7490562,7490533,'c6d',3.333,3),(517,7490563,7490533,'6d9',3.333,3),(517,7490564,7490534,'mon',100,1),(517,7490565,7490564,'201',50,1),(517,7490566,7490564,'013',50,1),(517,7490567,7490565,'adm',33.333,3),(517,7490568,7490565,'dmi',33.333,3),(517,7490569,7490565,'min',33.333,3),(517,7490570,7490567,'cap',16.667,1),(517,7490571,7490567,'apa',16.667,1),(517,7490572,7490567,'pac',16.667,1),(517,7490573,7490567,'aci',16.667,1),(517,7490574,7490567,'cit',16.667,1),(517,7490575,7490567,'ity',16.667,1),(517,7490576,7490570,'pat',50,1),(517,7490577,7490570,'ath',50,1),(517,7490578,7490576,'fre',14.286,1),(517,7490579,7490576,'ree',14.286,1),(517,7490580,7490576,'ees',14.286,1),(517,7490581,7490576,'esp',14.286,1),(517,7490582,7490576,'spa',14.286,1),(517,7490583,7490576,'pac',14.286,1),(517,7490584,7490576,'ace',14.286,1),(517,7490585,7490578,'dis',50,1),(517,7490586,7490578,'isk',50,1),(517,7490587,7490585,'ind',33.333,1),(517,7490588,7490585,'nde',33.333,1),(517,7490589,7490585,'dex',33.333,1),(517,7490590,7490587,'adm',8.333,1),(517,7490591,7490587,'dmi',8.333,1),(517,7490592,7490587,'min',8.333,1),(517,7490593,7490587,'ini',8.333,1),(517,7490594,7490587,'nis',8.333,1),(517,7490595,7490587,'ist',8.333,1),(517,7490596,7490587,'str',8.333,1),(517,7490597,7490587,'tra',8.333,1),(517,7490598,7490587,'rat',8.333,1),(517,7490599,7490587,'ati',8.333,1),(517,7490600,7490587,'tio',8.333,1),(517,7490601,7490587,'ion',8.333,1),(517,7490602,7490590,'sta',33.333,3),(517,7490603,7490590,'tat',33.333,3),(517,7490604,7490590,'ate',33.333,3),(517,7490605,7490602,'ena',20,2),(517,7490606,7490602,'nab',20,2),(517,7490607,7490602,'abl',20,2),(517,7490608,7490602,'ble',20,2),(517,7490609,7490602,'led',20,2),(517,7490610,7490605,'cac',33.333,2),(517,7490611,7490605,'ach',33.333,2),(517,7490612,7490605,'che',33.333,2),(517,7490613,7490610,'mod',50,1),(517,7490614,7490610,'ode',50,1),(517,7490615,7490613,'wri',14.286,1),(517,7490616,7490613,'rit',14.286,1),(517,7490617,7490613,'ite',14.286,1),(517,7490618,7490613,'tet',14.286,1),(517,7490619,7490613,'eth',14.286,1),(517,7490620,7490613,'thr',14.286,1),(517,7490621,7490613,'hru',14.286,1),(517,7490622,7490615,'ope',11.111,2),(517,7490623,7490615,'per',11.111,2),(517,7490624,7490615,'era',11.111,2),(517,7490625,7490615,'rat',11.111,2),(517,7490626,7490615,'ati',11.111,2),(517,7490627,7490615,'tio',11.111,2),(517,7490628,7490615,'ion',11.111,2),(517,7490629,7490615,'ona',11.111,2),(517,7490630,7490615,'nal',11.111,2),(517,7490631,7490622,'pen',20,1),(517,7490632,7490622,'end',20,1),(517,7490633,7490622,'ndi',20,1),(517,7490634,7490622,'din',20,1),(517,7490635,7490622,'ing',20,1),(517,7490636,7490631,'mes',20,1),(517,7490637,7490631,'ess',20,1),(517,7490638,7490631,'ssa',20,1),(517,7490639,7490631,'sag',20,1),(517,7490640,7490631,'age',20,1),(517,7490641,7490636,'wai',20,1),(517,7490642,7490636,'ait',20,1),(517,7490643,7490636,'iti',20,1),(517,7490644,7490636,'tin',20,1),(517,7490645,7490636,'ing',20,1),(517,7490646,7490641,'for',100,1),(517,7490647,7490646,'per',11.111,1),(517,7490648,7490646,'erf',11.111,1),(517,7490649,7490646,'rfo',11.111,1),(517,7490650,7490646,'for',11.111,1),(517,7490651,7490646,'orm',11.111,1),(517,7490652,7490646,'rma',11.111,1),(517,7490653,7490646,'man',11.111,1),(517,7490654,7490646,'anc',11.111,1),(517,7490655,7490646,'nce',11.111,1),(517,7490656,7490647,'ide',12.5,1),(517,7490657,7490647,'den',12.5,1),(517,7490658,7490647,'ent',12.5,1),(517,7490659,7490647,'nti',12.5,1),(517,7490660,7490647,'tif',12.5,1),(517,7490661,7490647,'ifi',12.5,1),(517,7490662,7490647,'fie',12.5,1),(517,7490663,7490647,'ier',12.5,1),(517,7490664,7490656,'vdi',33.333,3),(517,7490665,7490656,'dis',33.333,3),(517,7490666,7490656,'isk',33.333,3),(517,7490667,7490664,'nam',50,1),(517,7490668,7490664,'ame',50,1),(517,7490669,7490667,'typ',50,1),(517,7490670,7490667,'ype',50,1),(517,7490671,7490669,'dir',25,1),(517,7490672,7490669,'ire',25,1),(517,7490673,7490669,'rec',25,1),(517,7490674,7490669,'ect',25,1),(518,7490676,7490675,'naa',100,2),(518,7490677,7490676,'600',3.333,3),(518,7490678,7490676,'000',3.333,3),(518,7490679,7490676,'00c',3.333,3),(518,7490680,7490676,'0c2',3.333,3),(518,7490681,7490676,'c29',3.333,3),(518,7490682,7490676,'298',3.333,3),(518,7490683,7490676,'98e',3.333,3),(518,7490684,7490676,'8e3',3.333,3),(518,7490685,7490676,'e30',3.333,3),(518,7490686,7490676,'302',3.333,3),(518,7490687,7490676,'02b',3.333,3),(518,7490688,7490676,'2ba',3.333,3),(518,7490689,7490676,'ba4',3.333,3),(518,7490690,7490676,'a4c',3.333,3),(518,7490691,7490676,'4c2',3.333,3),(518,7490692,7490676,'c24',3.333,3),(518,7490693,7490676,'24c',3.333,3),(518,7490694,7490676,'4cc',3.333,3),(518,7490695,7490676,'cc8',3.333,3),(518,7490696,7490676,'c8f',3.333,3),(518,7490697,7490676,'8fb',3.333,3),(518,7490698,7490676,'fb7',3.333,3),(518,7490699,7490676,'b72',3.333,3),(518,7490700,7490676,'726',3.333,3),(518,7490701,7490676,'263',3.333,3),(518,7490702,7490676,'63a',3.333,3),(518,7490703,7490676,'3aa',3.333,3),(518,7490704,7490676,'aa4',3.333,3),(518,7490705,7490676,'a4c',3.333,3),(518,7490706,7490676,'4c6',3.333,3),(518,7490707,7490677,'mon',100,1),(518,7490708,7490707,'201',50,1),(518,7490709,7490707,'013',50,1),(518,7490710,7490708,'adm',33.333,3),(518,7490711,7490708,'dmi',33.333,3),(518,7490712,7490708,'min',33.333,3),(518,7490713,7490710,'cap',16.667,1),(518,7490714,7490710,'apa',16.667,1),(518,7490715,7490710,'pac',16.667,1),(518,7490716,7490710,'aci',16.667,1),(518,7490717,7490710,'cit',16.667,1),(518,7490718,7490710,'ity',16.667,1),(518,7490719,7490713,'pat',50,1),(518,7490720,7490713,'ath',50,1),(518,7490721,7490719,'fre',14.286,1),(518,7490722,7490719,'ree',14.286,1),(518,7490723,7490719,'ees',14.286,1),(518,7490724,7490719,'esp',14.286,1),(518,7490725,7490719,'spa',14.286,1),(518,7490726,7490719,'pac',14.286,1),(518,7490727,7490719,'ace',14.286,1),(518,7490728,7490721,'dis',50,1),(518,7490729,7490721,'isk',50,1),(518,7490730,7490728,'ind',33.333,1),(518,7490731,7490728,'nde',33.333,1),(518,7490732,7490728,'dex',33.333,1),(518,7490733,7490730,'adm',8.333,1),(518,7490734,7490730,'dmi',8.333,1),(518,7490735,7490730,'min',8.333,1),(518,7490736,7490730,'ini',8.333,1),(518,7490737,7490730,'nis',8.333,1),(518,7490738,7490730,'ist',8.333,1),(518,7490739,7490730,'str',8.333,1),(518,7490740,7490730,'tra',8.333,1),(518,7490741,7490730,'rat',8.333,1),(518,7490742,7490730,'ati',8.333,1),(518,7490743,7490730,'tio',8.333,1),(518,7490744,7490730,'ion',8.333,1),(518,7490745,7490733,'sta',33.333,3),(518,7490746,7490733,'tat',33.333,3),(518,7490747,7490733,'ate',33.333,3),(518,7490748,7490745,'ena',20,2),(518,7490749,7490745,'nab',20,2),(518,7490750,7490745,'abl',20,2),(518,7490751,7490745,'ble',20,2),(518,7490752,7490745,'led',20,2),(518,7490753,7490748,'cac',33.333,2),(518,7490754,7490748,'ach',33.333,2),(518,7490755,7490748,'che',33.333,2),(518,7490756,7490753,'mod',50,1),(518,7490757,7490753,'ode',50,1),(518,7490758,7490756,'wri',14.286,1),(518,7490759,7490756,'rit',14.286,1),(518,7490760,7490756,'ite',14.286,1),(518,7490761,7490756,'tet',14.286,1),(518,7490762,7490756,'eth',14.286,1),(518,7490763,7490756,'thr',14.286,1),(518,7490764,7490756,'hru',14.286,1),(518,7490765,7490758,'ope',11.111,2),(518,7490766,7490758,'per',11.111,2),(518,7490767,7490758,'era',11.111,2),(518,7490768,7490758,'rat',11.111,2),(518,7490769,7490758,'ati',11.111,2),(518,7490770,7490758,'tio',11.111,2),(518,7490771,7490758,'ion',11.111,2),(518,7490772,7490758,'ona',11.111,2),(518,7490773,7490758,'nal',11.111,2),(518,7490774,7490765,'pen',20,1),(518,7490775,7490765,'end',20,1),(518,7490776,7490765,'ndi',20,1),(518,7490777,7490765,'din',20,1),(518,7490778,7490765,'ing',20,1),(518,7490779,7490774,'mes',20,1),(518,7490780,7490774,'ess',20,1),(518,7490781,7490774,'ssa',20,1),(518,7490782,7490774,'sag',20,1),(518,7490783,7490774,'age',20,1),(518,7490784,7490779,'wai',20,1),(518,7490785,7490779,'ait',20,1),(518,7490786,7490779,'iti',20,1),(518,7490787,7490779,'tin',20,1),(518,7490788,7490779,'ing',20,1),(518,7490789,7490784,'for',100,1),(518,7490790,7490789,'per',11.111,1),(518,7490791,7490789,'erf',11.111,1),(518,7490792,7490789,'rfo',11.111,1),(518,7490793,7490789,'for',11.111,1),(518,7490794,7490789,'orm',11.111,1),(518,7490795,7490789,'rma',11.111,1),(518,7490796,7490789,'man',11.111,1),(518,7490797,7490789,'anc',11.111,1),(518,7490798,7490789,'nce',11.111,1),(518,7490799,7490790,'ide',12.5,1),(518,7490800,7490790,'den',12.5,1),(518,7490801,7490790,'ent',12.5,1),(518,7490802,7490790,'nti',12.5,1),(518,7490803,7490790,'tif',12.5,1),(518,7490804,7490790,'ifi',12.5,1),(518,7490805,7490790,'fie',12.5,1),(518,7490806,7490790,'ier',12.5,1),(518,7490807,7490799,'vdi',33.333,3),(518,7490808,7490799,'dis',33.333,3),(518,7490809,7490799,'isk',33.333,3),(518,7490810,7490807,'nam',50,1),(518,7490811,7490807,'ame',50,1),(518,7490812,7490810,'typ',50,1),(518,7490813,7490810,'ype',50,1),(518,7490814,7490812,'dir',25,1),(518,7490815,7490812,'ire',25,1),(518,7490816,7490812,'rec',25,1),(518,7490817,7490812,'ect',25,1),(519,7490819,7490818,'naa',100,2),(519,7490820,7490819,'600',3.333,3),(519,7490821,7490819,'000',3.333,3),(519,7490822,7490819,'00c',3.333,3),(519,7490823,7490819,'0c2',3.333,3),(519,7490824,7490819,'c29',3.333,3),(519,7490825,7490819,'29e',3.333,3),(519,7490826,7490819,'9e3',3.333,3),(519,7490827,7490819,'e3c',3.333,3),(519,7490828,7490819,'3c7',3.333,3),(519,7490829,7490819,'c70',3.333,3),(519,7490830,7490819,'70e',3.333,3),(519,7490831,7490819,'0e5',3.333,3),(519,7490832,7490819,'e53',3.333,3),(519,7490833,7490819,'53c',3.333,3),(519,7490834,7490819,'3cf',3.333,3),(519,7490835,7490819,'cf0',3.333,3),(519,7490836,7490819,'f01',3.333,3),(519,7490837,7490819,'012',3.333,3),(519,7490838,7490819,'121',3.333,3),(519,7490839,7490819,'215',3.333,3),(519,7490840,7490819,'15c',3.333,3),(519,7490841,7490819,'5cc',3.333,3),(519,7490842,7490819,'cc5',3.333,3),(519,7490843,7490819,'c52',3.333,3),(519,7490844,7490819,'524',3.333,3),(519,7490845,7490819,'243',3.333,3),(519,7490846,7490819,'433',3.333,3),(519,7490847,7490819,'331',3.333,3),(519,7490848,7490819,'31d',3.333,3),(519,7490849,7490819,'1d9',3.333,3),(519,7490850,7490820,'mon',100,1);
INSERT INTO `fuzzysearch_default_fuzzysearch_index_search_api_viewed` VALUES (519,7490851,7490850,'201',50,1),(519,7490852,7490850,'013',50,1),(519,7490853,7490851,'adm',33.333,3),(519,7490854,7490851,'dmi',33.333,3),(519,7490855,7490851,'min',33.333,3),(519,7490856,7490853,'cap',16.667,1),(519,7490857,7490853,'apa',16.667,1),(519,7490858,7490853,'pac',16.667,1),(519,7490859,7490853,'aci',16.667,1),(519,7490860,7490853,'cit',16.667,1),(519,7490861,7490853,'ity',16.667,1),(519,7490862,7490856,'pat',50,1),(519,7490863,7490856,'ath',50,1),(519,7490864,7490862,'fre',14.286,1),(519,7490865,7490862,'ree',14.286,1),(519,7490866,7490862,'ees',14.286,1),(519,7490867,7490862,'esp',14.286,1),(519,7490868,7490862,'spa',14.286,1),(519,7490869,7490862,'pac',14.286,1),(519,7490870,7490862,'ace',14.286,1),(519,7490871,7490864,'dis',50,1),(519,7490872,7490864,'isk',50,1),(519,7490873,7490871,'ind',33.333,1),(519,7490874,7490871,'nde',33.333,1),(519,7490875,7490871,'dex',33.333,1),(519,7490876,7490873,'adm',8.333,1),(519,7490877,7490873,'dmi',8.333,1),(519,7490878,7490873,'min',8.333,1),(519,7490879,7490873,'ini',8.333,1),(519,7490880,7490873,'nis',8.333,1),(519,7490881,7490873,'ist',8.333,1),(519,7490882,7490873,'str',8.333,1),(519,7490883,7490873,'tra',8.333,1),(519,7490884,7490873,'rat',8.333,1),(519,7490885,7490873,'ati',8.333,1),(519,7490886,7490873,'tio',8.333,1),(519,7490887,7490873,'ion',8.333,1),(519,7490888,7490876,'sta',33.333,3),(519,7490889,7490876,'tat',33.333,3),(519,7490890,7490876,'ate',33.333,3),(519,7490891,7490888,'ena',20,2),(519,7490892,7490888,'nab',20,2),(519,7490893,7490888,'abl',20,2),(519,7490894,7490888,'ble',20,2),(519,7490895,7490888,'led',20,2),(519,7490896,7490891,'cac',33.333,2),(519,7490897,7490891,'ach',33.333,2),(519,7490898,7490891,'che',33.333,2),(519,7490899,7490896,'mod',50,1),(519,7490900,7490896,'ode',50,1),(519,7490901,7490899,'wri',14.286,1),(519,7490902,7490899,'rit',14.286,1),(519,7490903,7490899,'ite',14.286,1),(519,7490904,7490899,'tet',14.286,1),(519,7490905,7490899,'eth',14.286,1),(519,7490906,7490899,'thr',14.286,1),(519,7490907,7490899,'hru',14.286,1),(519,7490908,7490901,'ope',11.111,2),(519,7490909,7490901,'per',11.111,2),(519,7490910,7490901,'era',11.111,2),(519,7490911,7490901,'rat',11.111,2),(519,7490912,7490901,'ati',11.111,2),(519,7490913,7490901,'tio',11.111,2),(519,7490914,7490901,'ion',11.111,2),(519,7490915,7490901,'ona',11.111,2),(519,7490916,7490901,'nal',11.111,2),(519,7490917,7490908,'pen',20,1),(519,7490918,7490908,'end',20,1),(519,7490919,7490908,'ndi',20,1),(519,7490920,7490908,'din',20,1),(519,7490921,7490908,'ing',20,1),(519,7490922,7490917,'mes',20,1),(519,7490923,7490917,'ess',20,1),(519,7490924,7490917,'ssa',20,1),(519,7490925,7490917,'sag',20,1),(519,7490926,7490917,'age',20,1),(519,7490927,7490922,'wai',20,1),(519,7490928,7490922,'ait',20,1),(519,7490929,7490922,'iti',20,1),(519,7490930,7490922,'tin',20,1),(519,7490931,7490922,'ing',20,1),(519,7490932,7490927,'for',100,1),(519,7490933,7490932,'per',11.111,1),(519,7490934,7490932,'erf',11.111,1),(519,7490935,7490932,'rfo',11.111,1),(519,7490936,7490932,'for',11.111,1),(519,7490937,7490932,'orm',11.111,1),(519,7490938,7490932,'rma',11.111,1),(519,7490939,7490932,'man',11.111,1),(519,7490940,7490932,'anc',11.111,1),(519,7490941,7490932,'nce',11.111,1),(519,7490942,7490933,'ide',12.5,1),(519,7490943,7490933,'den',12.5,1),(519,7490944,7490933,'ent',12.5,1),(519,7490945,7490933,'nti',12.5,1),(519,7490946,7490933,'tif',12.5,1),(519,7490947,7490933,'ifi',12.5,1),(519,7490948,7490933,'fie',12.5,1),(519,7490949,7490933,'ier',12.5,1),(519,7490950,7490942,'vdi',33.333,3),(519,7490951,7490942,'dis',33.333,3),(519,7490952,7490942,'isk',33.333,3),(519,7490953,7490950,'nam',50,1),(519,7490954,7490950,'ame',50,1),(519,7490955,7490953,'typ',50,1),(519,7490956,7490953,'ype',50,1),(519,7490957,7490955,'dir',25,1),(519,7490958,7490955,'ire',25,1),(519,7490959,7490955,'rec',25,1),(519,7490960,7490955,'ect',25,1),(520,7490962,7490961,'naa',100,2),(520,7490963,7490962,'600',3.333,3),(520,7490964,7490962,'000',3.333,3),(520,7490965,7490962,'00c',3.333,3),(520,7490966,7490962,'0c2',3.333,3),(520,7490967,7490962,'c29',3.333,3),(520,7490968,7490962,'294',3.333,3),(520,7490969,7490962,'949',3.333,3),(520,7490970,7490962,'49b',3.333,3),(520,7490971,7490962,'9bf',3.333,3),(520,7490972,7490962,'bf6',3.333,3),(520,7490973,7490962,'f61',3.333,3),(520,7490974,7490962,'61f',3.333,3),(520,7490975,7490962,'1f9',3.333,3),(520,7490976,7490962,'f97',3.333,3),(520,7490977,7490962,'978',3.333,3),(520,7490978,7490962,'78c',3.333,3),(520,7490979,7490962,'8c9',3.333,3),(520,7490980,7490962,'c9c',3.333,3),(520,7490981,7490962,'9cf',3.333,3),(520,7490982,7490962,'cf5',3.333,3),(520,7490983,7490962,'f55',3.333,3),(520,7490984,7490962,'559',3.333,3),(520,7490985,7490962,'594',3.333,3),(520,7490986,7490962,'947',3.333,3),(520,7490987,7490962,'474',3.333,3),(520,7490988,7490962,'74e',3.333,3),(520,7490989,7490962,'4ef',3.333,3),(520,7490990,7490962,'efa',3.333,3),(520,7490991,7490962,'faa',3.333,3),(520,7490992,7490962,'aaa',3.333,3),(520,7490993,7490963,'mon',100,1),(520,7490994,7490993,'201',50,1),(520,7490995,7490993,'013',50,1),(520,7490996,7490994,'adm',33.333,3),(520,7490997,7490994,'dmi',33.333,3),(520,7490998,7490994,'min',33.333,3),(520,7490999,7490996,'cap',16.667,1),(520,7491000,7490996,'apa',16.667,1),(520,7491001,7490996,'pac',16.667,1),(520,7491002,7490996,'aci',16.667,1),(520,7491003,7490996,'cit',16.667,1),(520,7491004,7490996,'ity',16.667,1),(520,7491005,7490999,'pat',50,1),(520,7491006,7490999,'ath',50,1),(520,7491007,7491005,'fre',14.286,1),(520,7491008,7491005,'ree',14.286,1),(520,7491009,7491005,'ees',14.286,1),(520,7491010,7491005,'esp',14.286,1),(520,7491011,7491005,'spa',14.286,1),(520,7491012,7491005,'pac',14.286,1),(520,7491013,7491005,'ace',14.286,1),(520,7491014,7491007,'dis',50,1),(520,7491015,7491007,'isk',50,1),(520,7491016,7491014,'ind',33.333,1),(520,7491017,7491014,'nde',33.333,1),(520,7491018,7491014,'dex',33.333,1),(520,7491019,7491016,'adm',8.333,1),(520,7491020,7491016,'dmi',8.333,1),(520,7491021,7491016,'min',8.333,1),(520,7491022,7491016,'ini',8.333,1),(520,7491023,7491016,'nis',8.333,1),(520,7491024,7491016,'ist',8.333,1),(520,7491025,7491016,'str',8.333,1),(520,7491026,7491016,'tra',8.333,1),(520,7491027,7491016,'rat',8.333,1),(520,7491028,7491016,'ati',8.333,1),(520,7491029,7491016,'tio',8.333,1),(520,7491030,7491016,'ion',8.333,1),(520,7491031,7491019,'sta',33.333,3),(520,7491032,7491019,'tat',33.333,3),(520,7491033,7491019,'ate',33.333,3),(520,7491034,7491031,'ena',20,2),(520,7491035,7491031,'nab',20,2),(520,7491036,7491031,'abl',20,2),(520,7491037,7491031,'ble',20,2),(520,7491038,7491031,'led',20,2),(520,7491039,7491034,'cac',33.333,2),(520,7491040,7491034,'ach',33.333,2),(520,7491041,7491034,'che',33.333,2),(520,7491042,7491039,'mod',50,1),(520,7491043,7491039,'ode',50,1),(520,7491044,7491042,'wri',14.286,1),(520,7491045,7491042,'rit',14.286,1),(520,7491046,7491042,'ite',14.286,1),(520,7491047,7491042,'tet',14.286,1),(520,7491048,7491042,'eth',14.286,1),(520,7491049,7491042,'thr',14.286,1),(520,7491050,7491042,'hru',14.286,1),(520,7491051,7491044,'ope',11.111,2),(520,7491052,7491044,'per',11.111,2),(520,7491053,7491044,'era',11.111,2),(520,7491054,7491044,'rat',11.111,2),(520,7491055,7491044,'ati',11.111,2),(520,7491056,7491044,'tio',11.111,2),(520,7491057,7491044,'ion',11.111,2),(520,7491058,7491044,'ona',11.111,2),(520,7491059,7491044,'nal',11.111,2),(520,7491060,7491051,'pen',20,1),(520,7491061,7491051,'end',20,1),(520,7491062,7491051,'ndi',20,1),(520,7491063,7491051,'din',20,1),(520,7491064,7491051,'ing',20,1),(520,7491065,7491060,'mes',20,1),(520,7491066,7491060,'ess',20,1),(520,7491067,7491060,'ssa',20,1),(520,7491068,7491060,'sag',20,1),(520,7491069,7491060,'age',20,1),(520,7491070,7491065,'wai',20,1),(520,7491071,7491065,'ait',20,1),(520,7491072,7491065,'iti',20,1),(520,7491073,7491065,'tin',20,1),(520,7491074,7491065,'ing',20,1),(520,7491075,7491070,'for',100,1),(520,7491076,7491075,'per',11.111,1),(520,7491077,7491075,'erf',11.111,1),(520,7491078,7491075,'rfo',11.111,1),(520,7491079,7491075,'for',11.111,1),(520,7491080,7491075,'orm',11.111,1),(520,7491081,7491075,'rma',11.111,1),(520,7491082,7491075,'man',11.111,1),(520,7491083,7491075,'anc',11.111,1),(520,7491084,7491075,'nce',11.111,1),(520,7491085,7491076,'ide',12.5,1),(520,7491086,7491076,'den',12.5,1),(520,7491087,7491076,'ent',12.5,1),(520,7491088,7491076,'nti',12.5,1),(520,7491089,7491076,'tif',12.5,1),(520,7491090,7491076,'ifi',12.5,1),(520,7491091,7491076,'fie',12.5,1),(520,7491092,7491076,'ier',12.5,1),(520,7491093,7491085,'vdi',33.333,3),(520,7491094,7491085,'dis',33.333,3),(520,7491095,7491085,'isk',33.333,3),(520,7491096,7491093,'nam',50,1),(520,7491097,7491093,'ame',50,1),(520,7491098,7491096,'typ',50,1),(520,7491099,7491096,'ype',50,1),(520,7491100,7491098,'dir',25,1),(520,7491101,7491098,'ire',25,1),(520,7491102,7491098,'rec',25,1),(520,7491103,7491098,'ect',25,1),(521,7491105,7491104,'naa',100,2),(521,7491106,7491105,'600',3.333,3),(521,7491107,7491105,'000',3.333,3),(521,7491108,7491105,'00c',3.333,3),(521,7491109,7491105,'0c2',3.333,3),(521,7491110,7491105,'c29',3.333,3),(521,7491111,7491105,'29b',3.333,3),(521,7491112,7491105,'9b4',3.333,3),(521,7491113,7491105,'b44',3.333,3),(521,7491114,7491105,'440',3.333,3),(521,7491115,7491105,'40b',3.333,3),(521,7491116,7491105,'0b8',3.333,3),(521,7491117,7491105,'b86',3.333,3),(521,7491118,7491105,'86f',3.333,3),(521,7491119,7491105,'6f4',3.333,3),(521,7491120,7491105,'f41',3.333,3),(521,7491121,7491105,'419',3.333,3),(521,7491122,7491105,'194',3.333,3),(521,7491123,7491105,'942',3.333,3),(521,7491124,7491105,'42c',3.333,3),(521,7491125,7491105,'2cb',3.333,3),(521,7491126,7491105,'cb1',3.333,3),(521,7491127,7491105,'b1a',3.333,3),(521,7491128,7491105,'1a8',3.333,3),(521,7491129,7491105,'a87',3.333,3),(521,7491130,7491105,'871',3.333,3),(521,7491131,7491105,'719',3.333,3),(521,7491132,7491105,'19b',3.333,3),(521,7491133,7491105,'9b7',3.333,3),(521,7491134,7491105,'b73',3.333,3),(521,7491135,7491105,'736',3.333,3),(521,7491136,7491106,'mon',100,1),(521,7491137,7491136,'201',50,1),(521,7491138,7491136,'013',50,1),(521,7491139,7491137,'adm',33.333,3),(521,7491140,7491137,'dmi',33.333,3),(521,7491141,7491137,'min',33.333,3),(521,7491142,7491139,'cap',16.667,1),(521,7491143,7491139,'apa',16.667,1),(521,7491144,7491139,'pac',16.667,1),(521,7491145,7491139,'aci',16.667,1),(521,7491146,7491139,'cit',16.667,1),(521,7491147,7491139,'ity',16.667,1),(521,7491148,7491142,'pat',50,1),(521,7491149,7491142,'ath',50,1),(521,7491150,7491148,'fre',14.286,1),(521,7491151,7491148,'ree',14.286,1),(521,7491152,7491148,'ees',14.286,1),(521,7491153,7491148,'esp',14.286,1),(521,7491154,7491148,'spa',14.286,1),(521,7491155,7491148,'pac',14.286,1),(521,7491156,7491148,'ace',14.286,1),(521,7491157,7491150,'dis',50,1),(521,7491158,7491150,'isk',50,1),(521,7491159,7491157,'ind',33.333,1),(521,7491160,7491157,'nde',33.333,1),(521,7491161,7491157,'dex',33.333,1),(521,7491162,7491159,'adm',8.333,1),(521,7491163,7491159,'dmi',8.333,1),(521,7491164,7491159,'min',8.333,1),(521,7491165,7491159,'ini',8.333,1),(521,7491166,7491159,'nis',8.333,1),(521,7491167,7491159,'ist',8.333,1),(521,7491168,7491159,'str',8.333,1),(521,7491169,7491159,'tra',8.333,1),(521,7491170,7491159,'rat',8.333,1),(521,7491171,7491159,'ati',8.333,1),(521,7491172,7491159,'tio',8.333,1),(521,7491173,7491159,'ion',8.333,1),(521,7491174,7491162,'sta',33.333,3),(521,7491175,7491162,'tat',33.333,3),(521,7491176,7491162,'ate',33.333,3),(521,7491177,7491174,'ena',20,2),(521,7491178,7491174,'nab',20,2),(521,7491179,7491174,'abl',20,2),(521,7491180,7491174,'ble',20,2),(521,7491181,7491174,'led',20,2),(521,7491182,7491177,'cac',33.333,2),(521,7491183,7491177,'ach',33.333,2),(521,7491184,7491177,'che',33.333,2),(521,7491185,7491182,'mod',50,1),(521,7491186,7491182,'ode',50,1),(521,7491187,7491185,'wri',14.286,1),(521,7491188,7491185,'rit',14.286,1),(521,7491189,7491185,'ite',14.286,1),(521,7491190,7491185,'tet',14.286,1),(521,7491191,7491185,'eth',14.286,1),(521,7491192,7491185,'thr',14.286,1),(521,7491193,7491185,'hru',14.286,1),(521,7491194,7491187,'ope',11.111,2),(521,7491195,7491187,'per',11.111,2),(521,7491196,7491187,'era',11.111,2),(521,7491197,7491187,'rat',11.111,2),(521,7491198,7491187,'ati',11.111,2),(521,7491199,7491187,'tio',11.111,2),(521,7491200,7491187,'ion',11.111,2),(521,7491201,7491187,'ona',11.111,2),(521,7491202,7491187,'nal',11.111,2),(521,7491203,7491194,'pen',20,1),(521,7491204,7491194,'end',20,1),(521,7491205,7491194,'ndi',20,1),(521,7491206,7491194,'din',20,1),(521,7491207,7491194,'ing',20,1),(521,7491208,7491203,'mes',20,1),(521,7491209,7491203,'ess',20,1),(521,7491210,7491203,'ssa',20,1),(521,7491211,7491203,'sag',20,1),(521,7491212,7491203,'age',20,1),(521,7491213,7491208,'wai',20,1),(521,7491214,7491208,'ait',20,1),(521,7491215,7491208,'iti',20,1),(521,7491216,7491208,'tin',20,1),(521,7491217,7491208,'ing',20,1),(521,7491218,7491213,'for',100,1),(521,7491219,7491218,'per',11.111,1),(521,7491220,7491218,'erf',11.111,1),(521,7491221,7491218,'rfo',11.111,1),(521,7491222,7491218,'for',11.111,1),(521,7491223,7491218,'orm',11.111,1),(521,7491224,7491218,'rma',11.111,1),(521,7491225,7491218,'man',11.111,1),(521,7491226,7491218,'anc',11.111,1),(521,7491227,7491218,'nce',11.111,1),(521,7491228,7491219,'ide',12.5,1),(521,7491229,7491219,'den',12.5,1),(521,7491230,7491219,'ent',12.5,1),(521,7491231,7491219,'nti',12.5,1),(521,7491232,7491219,'tif',12.5,1),(521,7491233,7491219,'ifi',12.5,1),(521,7491234,7491219,'fie',12.5,1),(521,7491235,7491219,'ier',12.5,1),(521,7491236,7491228,'vdi',33.333,3),(521,7491237,7491228,'dis',33.333,3),(521,7491238,7491228,'isk',33.333,3),(521,7491239,7491236,'nam',50,1),(521,7491240,7491236,'ame',50,1),(521,7491241,7491239,'typ',50,1),(521,7491242,7491239,'ype',50,1),(521,7491243,7491241,'dir',25,1),(521,7491244,7491241,'ire',25,1),(521,7491245,7491241,'rec',25,1),(521,7491246,7491241,'ect',25,1),(522,7491248,7491247,'naa',100,2),(522,7491249,7491248,'600',3.333,3),(522,7491250,7491248,'000',3.333,3),(522,7491251,7491248,'00c',3.333,3),(522,7491252,7491248,'0c2',3.333,3),(522,7491253,7491248,'c29',3.333,3),(522,7491254,7491248,'29c',3.333,3),(522,7491255,7491248,'9c2',3.333,3),(522,7491256,7491248,'c20',3.333,3),(522,7491257,7491248,'20b',3.333,3),(522,7491258,7491248,'0bb',3.333,3),(522,7491259,7491248,'bb6',3.333,3),(522,7491260,7491248,'b68',3.333,3),(522,7491261,7491248,'68b',3.333,3),(522,7491262,7491248,'8b2',3.333,3),(522,7491263,7491248,'b20',3.333,3),(522,7491264,7491248,'200',3.333,3),(522,7491265,7491248,'004',3.333,3),(522,7491266,7491248,'04d',3.333,3),(522,7491267,7491248,'4de',3.333,3),(522,7491268,7491248,'de0',3.333,3),(522,7491269,7491248,'e02',3.333,3),(522,7491270,7491248,'026',3.333,3),(522,7491271,7491248,'260',3.333,3),(522,7491272,7491248,'608',3.333,3),(522,7491273,7491248,'08b',3.333,3),(522,7491274,7491248,'8bd',3.333,3),(522,7491275,7491248,'bda',3.333,3),(522,7491276,7491248,'da3',3.333,3),(522,7491277,7491248,'a32',3.333,3),(522,7491278,7491248,'325',3.333,3),(522,7491279,7491249,'mon',100,1),(522,7491280,7491279,'201',50,1),(522,7491281,7491279,'013',50,1),(522,7491282,7491280,'adm',33.333,3),(522,7491283,7491280,'dmi',33.333,3),(522,7491284,7491280,'min',33.333,3),(522,7491285,7491282,'cap',16.667,1),(522,7491286,7491282,'apa',16.667,1),(522,7491287,7491282,'pac',16.667,1),(522,7491288,7491282,'aci',16.667,1),(522,7491289,7491282,'cit',16.667,1),(522,7491290,7491282,'ity',16.667,1),(522,7491291,7491285,'pat',50,1),(522,7491292,7491285,'ath',50,1),(522,7491293,7491291,'fre',14.286,1),(522,7491294,7491291,'ree',14.286,1),(522,7491295,7491291,'ees',14.286,1),(522,7491296,7491291,'esp',14.286,1),(522,7491297,7491291,'spa',14.286,1),(522,7491298,7491291,'pac',14.286,1),(522,7491299,7491291,'ace',14.286,1),(522,7491300,7491293,'dis',50,1),(522,7491301,7491293,'isk',50,1),(522,7491302,7491300,'ind',33.333,1),(522,7491303,7491300,'nde',33.333,1),(522,7491304,7491300,'dex',33.333,1),(522,7491305,7491302,'adm',8.333,1),(522,7491306,7491302,'dmi',8.333,1),(522,7491307,7491302,'min',8.333,1),(522,7491308,7491302,'ini',8.333,1),(522,7491309,7491302,'nis',8.333,1),(522,7491310,7491302,'ist',8.333,1),(522,7491311,7491302,'str',8.333,1),(522,7491312,7491302,'tra',8.333,1),(522,7491313,7491302,'rat',8.333,1),(522,7491314,7491302,'ati',8.333,1),(522,7491315,7491302,'tio',8.333,1),(522,7491316,7491302,'ion',8.333,1),(522,7491317,7491305,'sta',33.333,3),(522,7491318,7491305,'tat',33.333,3),(522,7491319,7491305,'ate',33.333,3),(522,7491320,7491317,'ena',20,2),(522,7491321,7491317,'nab',20,2),(522,7491322,7491317,'abl',20,2),(522,7491323,7491317,'ble',20,2),(522,7491324,7491317,'led',20,2),(522,7491325,7491320,'cac',33.333,2),(522,7491326,7491320,'ach',33.333,2),(522,7491327,7491320,'che',33.333,2),(522,7491328,7491325,'mod',50,1),(522,7491329,7491325,'ode',50,1),(522,7491330,7491328,'wri',14.286,1),(522,7491331,7491328,'rit',14.286,1),(522,7491332,7491328,'ite',14.286,1),(522,7491333,7491328,'tet',14.286,1),(522,7491334,7491328,'eth',14.286,1),(522,7491335,7491328,'thr',14.286,1),(522,7491336,7491328,'hru',14.286,1),(522,7491337,7491330,'ope',11.111,2),(522,7491338,7491330,'per',11.111,2),(522,7491339,7491330,'era',11.111,2),(522,7491340,7491330,'rat',11.111,2),(522,7491341,7491330,'ati',11.111,2),(522,7491342,7491330,'tio',11.111,2),(522,7491343,7491330,'ion',11.111,2),(522,7491344,7491330,'ona',11.111,2),(522,7491345,7491330,'nal',11.111,2),(522,7491346,7491337,'pen',20,1),(522,7491347,7491337,'end',20,1),(522,7491348,7491337,'ndi',20,1),(522,7491349,7491337,'din',20,1),(522,7491350,7491337,'ing',20,1),(522,7491351,7491346,'mes',20,1),(522,7491352,7491346,'ess',20,1),(522,7491353,7491346,'ssa',20,1),(522,7491354,7491346,'sag',20,1),(522,7491355,7491346,'age',20,1),(522,7491356,7491351,'wai',20,1),(522,7491357,7491351,'ait',20,1),(522,7491358,7491351,'iti',20,1),(522,7491359,7491351,'tin',20,1),(522,7491360,7491351,'ing',20,1),(522,7491361,7491356,'for',100,1),(522,7491362,7491361,'per',11.111,1),(522,7491363,7491361,'erf',11.111,1),(522,7491364,7491361,'rfo',11.111,1),(522,7491365,7491361,'for',11.111,1),(522,7491366,7491361,'orm',11.111,1),(522,7491367,7491361,'rma',11.111,1),(522,7491368,7491361,'man',11.111,1),(522,7491369,7491361,'anc',11.111,1),(522,7491370,7491361,'nce',11.111,1),(522,7491371,7491362,'ide',12.5,1),(522,7491372,7491362,'den',12.5,1),(522,7491373,7491362,'ent',12.5,1),(522,7491374,7491362,'nti',12.5,1),(522,7491375,7491362,'tif',12.5,1),(522,7491376,7491362,'ifi',12.5,1),(522,7491377,7491362,'fie',12.5,1),(522,7491378,7491362,'ier',12.5,1),(522,7491379,7491371,'vdi',33.333,3),(522,7491380,7491371,'dis',33.333,3),(522,7491381,7491371,'isk',33.333,3),(522,7491382,7491379,'nam',50,1),(522,7491383,7491379,'ame',50,1),(522,7491384,7491382,'typ',50,1),(522,7491385,7491382,'ype',50,1),(522,7491386,7491384,'dir',25,1),(522,7491387,7491384,'ire',25,1),(522,7491388,7491384,'rec',25,1),(522,7491389,7491384,'ect',25,1),(523,7491391,7491390,'att',12.5,1),(523,7491392,7491390,'ttr',12.5,1),(523,7491393,7491390,'tri',12.5,1),(523,7491394,7491390,'rib',12.5,1),(523,7491395,7491390,'ibu',12.5,1),(523,7491396,7491390,'but',12.5,1),(523,7491397,7491390,'ute',12.5,1),(523,7491398,7491390,'tes',12.5,1),(523,7491399,7491391,'ref',20,3),(523,7491400,7491391,'efr',20,3),(523,7491401,7491391,'fre',20,3),(523,7491402,7491391,'res',20,3),(523,7491403,7491391,'esh',20,3),(523,7491404,7491399,'hos',50,2),(523,7491405,7491399,'ost',50,2),(523,7491406,7491404,'nam',50,2),(523,7491407,7491404,'ame',50,2),(523,7491408,7491406,'hg3',9.091,1),(523,7491409,7491406,'g32',9.091,1),(523,7491410,7491406,'32v',9.091,1),(523,7491411,7491406,'2vm',9.091,1),(523,7491412,7491406,'vm1',9.091,1),(523,7491413,7491406,'m1w',9.091,1),(523,7491414,7491406,'1w2',9.091,1),(523,7491415,7491406,'w2k',9.091,1),(523,7491416,7491406,'2k8',9.091,1),(523,7491417,7491406,'k8r',9.091,1),(523,7491418,7491406,'8r2',9.091,1),(523,7491419,7491408,'gdl',100,1),(523,7491420,7491419,'eng',25,1),(523,7491421,7491419,'ngl',25,1),(523,7491422,7491419,'gla',25,1),(523,7491423,7491419,'lab',25,1),(523,7491424,7491420,'net',25,1),(523,7491425,7491420,'eta',25,1),(523,7491426,7491420,'tap',25,1),(523,7491427,7491420,'app',25,1),(523,7491428,7491424,'com',100,1),(523,7491429,7491428,'mem',25,3),(523,7491430,7491428,'emo',25,3),(523,7491431,7491428,'mor',25,3),(523,7491432,7491428,'ory',25,3),(523,7491433,7491429,'siz',50,2),(523,7491434,7491429,'ize',50,2),(523,7491435,7491433,'614',50,1),(523,7491436,7491433,'144',50,1),(523,7491437,7491435,'cpu',100,1),(523,7491438,7491437,'usa',33.333,3),(523,7491439,7491437,'sag',33.333,3),(523,7491440,7491437,'age',33.333,3),(523,7491441,7491438,'mhz',100,1),(523,7491442,7491441,'add',20,1),(523,7491443,7491441,'ddr',20,1),(523,7491444,7491441,'dre',20,1),(523,7491445,7491441,'res',20,1),(523,7491446,7491441,'ess',20,1),(523,7491447,7491442,'226',100,1),(523,7491448,7491447,'147',100,1),(523,7491449,7491448,'203',100,1),(523,7491450,7491449,'620',50,1),(523,7491451,7491449,'206',50,1),(523,7491452,7491450,'gue',33.333,2),(523,7491453,7491450,'ues',33.333,2),(523,7491454,7491450,'est',33.333,2),(523,7491455,7491452,'122',100,1),(523,7491456,7491455,'vmw',25,2),(523,7491457,7491455,'mwa',25,2),(523,7491458,7491455,'war',25,2),(523,7491459,7491455,'are',25,2),(523,7491460,7491456,'too',33.333,2),(523,7491461,7491456,'ool',33.333,2),(523,7491462,7491456,'ols',33.333,2),(523,7491463,7491460,'run',20,1),(523,7491464,7491460,'unn',20,1),(523,7491465,7491460,'nni',20,1),(523,7491466,7491460,'nin',20,1),(523,7491467,7491460,'ing',20,1),(523,7491468,7491463,'and',100,1),(523,7491469,7491468,'the',100,1),(523,7491470,7491469,'ver',20,2),(523,7491471,7491469,'ers',20,2),(523,7491472,7491469,'rsi',20,2),(523,7491473,7491469,'sio',20,2),(523,7491474,7491469,'ion',20,2),(523,7491475,7491470,'cur',20,1),(523,7491476,7491470,'urr',20,1),(523,7491477,7491470,'rre',20,1),(523,7491478,7491470,'ren',20,1),(523,7491479,7491470,'ent',20,1),(523,7491480,7491475,'mic',14.286,1),(523,7491481,7491475,'icr',14.286,1),(523,7491482,7491475,'cro',14.286,1),(523,7491483,7491475,'ros',14.286,1),(523,7491484,7491475,'oso',14.286,1),(523,7491485,7491475,'sof',14.286,1),(523,7491486,7491475,'oft',14.286,1),(523,7491487,7491480,'win',20,1),(523,7491488,7491480,'ind',20,1),(523,7491489,7491480,'ndo',20,1),(523,7491490,7491480,'dow',20,1),(523,7491491,7491480,'ows',20,1),(523,7491492,7491487,'ser',25,1),(523,7491493,7491487,'erv',25,1),(523,7491494,7491487,'rve',25,1),(523,7491495,7491487,'ver',25,1),(523,7491496,7491492,'200',50,1),(523,7491497,7491492,'008',50,1),(523,7491498,7491496,'64b',33.333,1),(523,7491499,7491496,'4bi',33.333,1),(523,7491500,7491496,'bit',33.333,1),(523,7491501,7491498,'pat',50,1),(523,7491502,7491498,'ath',50,1),(523,7491503,7491501,'rx6',33.333,1),(523,7491504,7491501,'x60',33.333,1),(523,7491505,7491501,'600',33.333,1),(523,7491506,7491503,'vmf',20,1),(523,7491507,7491503,'mfi',20,1),(523,7491508,7491503,'fil',20,1),(523,7491509,7491503,'ile',20,1),(523,7491510,7491503,'les',20,1),(523,7491511,7491506,'hgw',9.091,2),(523,7491512,7491506,'gw2',9.091,2),(523,7491513,7491506,'w2k',9.091,2),(523,7491514,7491506,'2k8',9.091,2),(523,7491515,7491506,'k8r',9.091,2),(523,7491516,7491506,'8r2',9.091,2),(523,7491517,7491506,'r23',9.091,2),(523,7491518,7491506,'232',9.091,2),(523,7491519,7491506,'32v',9.091,2),(523,7491520,7491506,'2vm',9.091,2),(523,7491521,7491506,'vm1',9.091,2),(523,7491522,7491511,'vmx',100,1),(523,7491523,7491522,'fla',33.333,1),(523,7491524,7491522,'las',33.333,1),(523,7491525,7491522,'ash',33.333,1),(523,7491526,7491523,'acc',33.333,1),(523,7491527,7491523,'cce',33.333,1),(523,7491528,7491523,'cel',33.333,1),(523,7491529,7491526,'con',9.091,1),(523,7491530,7491526,'onf',9.091,1),(523,7491531,7491526,'nfi',9.091,1),(523,7491532,7491526,'fig',9.091,1),(523,7491533,7491526,'igu',9.091,1),(523,7491534,7491526,'gur',9.091,1),(523,7491535,7491526,'ura',9.091,1),(523,7491536,7491526,'rat',9.091,1),(523,7491537,7491526,'ati',9.091,1),(523,7491538,7491526,'tio',9.091,1),(523,7491539,7491526,'ion',9.091,1),(523,7491540,7491529,'age',33.333,1),(523,7491541,7491529,'gen',33.333,1),(523,7491542,7491529,'ent',33.333,1),(523,7491543,7491540,'193',16.667,1),(523,7491544,7491540,'938',16.667,1),(523,7491545,7491540,'380',16.667,1),(523,7491546,7491540,'809',16.667,1),(523,7491547,7491540,'097',16.667,1),(523,7491548,7491540,'979',16.667,1),(523,7491549,7491543,'cac',33.333,3),(523,7491550,7491543,'ach',33.333,3),(523,7491551,7491543,'che',33.333,3),(523,7491552,7491549,'sta',33.333,2),(523,7491553,7491549,'tat',33.333,2),(523,7491554,7491549,'ate',33.333,2),(523,7491555,7491552,'ena',20,2),(523,7491556,7491552,'nab',20,2),(523,7491557,7491552,'abl',20,2),(523,7491558,7491552,'ble',20,2),(523,7491559,7491552,'led',20,2),(523,7491560,7491555,'ope',11.111,2),(523,7491561,7491555,'per',11.111,2),(523,7491562,7491555,'era',11.111,2),(523,7491563,7491555,'rat',11.111,2),(523,7491564,7491555,'ati',11.111,2),(523,7491565,7491555,'tio',11.111,2),(523,7491566,7491555,'ion',11.111,2),(523,7491567,7491555,'ona',11.111,2),(523,7491568,7491555,'nal',11.111,2),(523,7491569,7491560,'nor',25,1),(523,7491570,7491560,'orm',25,1),(523,7491571,7491560,'rma',25,1),(523,7491572,7491560,'mal',25,1),(523,7491573,7491569,'mod',50,2),(523,7491574,7491569,'ode',50,2),(523,7491575,7491573,'wri',14.286,2),(523,7491576,7491573,'rit',14.286,2),(523,7491577,7491573,'ite',14.286,2),(523,7491578,7491573,'tet',14.286,2),(523,7491579,7491573,'eth',14.286,2),(523,7491580,7491573,'thr',14.286,2),(523,7491581,7491573,'hru',14.286,2),(523,7491582,7491575,'mes',20,1),(523,7491583,7491575,'ess',20,1),(523,7491584,7491575,'ssa',20,1),(523,7491585,7491575,'sag',20,1),(523,7491586,7491575,'age',20,1),(523,7491587,7491582,'met',20,3),(523,7491588,7491582,'etr',20,3),(523,7491589,7491582,'tri',20,3),(523,7491590,7491582,'ric',20,3),(523,7491591,7491582,'ics',20,3),(523,7491592,7491587,'vir',20,1),(523,7491593,7491587,'irt',20,1),(523,7491594,7491587,'rtu',20,1),(523,7491595,7491587,'tua',20,1),(523,7491596,7491587,'ual',20,1),(523,7491597,7491592,'dis',50,1),(523,7491598,7491592,'isk',50,1),(524,7491600,7491599,'naa',100,2),(524,7491601,7491600,'600',3.333,3),(524,7491602,7491600,'000',3.333,3),(524,7491603,7491600,'00c',3.333,3),(524,7491604,7491600,'0c2',3.333,3),(524,7491605,7491600,'c29',3.333,3),(524,7491606,7491600,'293',3.333,3),(524,7491607,7491600,'93a',3.333,3),(524,7491608,7491600,'3a3',3.333,3),(524,7491609,7491600,'a33',3.333,3),(524,7491610,7491600,'337',3.333,3),(524,7491611,7491600,'37f',3.333,3),(524,7491612,7491600,'7fc',3.333,3),(524,7491613,7491600,'fcf',3.333,3),(524,7491614,7491600,'cf5',3.333,3),(524,7491615,7491600,'f57',3.333,3),(524,7491616,7491600,'57f',3.333,3),(524,7491617,7491600,'7f8',3.333,3),(524,7491618,7491600,'f8e',3.333,3),(524,7491619,7491600,'8ea',3.333,3),(524,7491620,7491600,'ea9',3.333,3),(524,7491621,7491600,'a97',3.333,3),(524,7491622,7491600,'976',3.333,3),(524,7491623,7491600,'762',3.333,3),(524,7491624,7491600,'623',3.333,3),(524,7491625,7491600,'230',3.333,3),(524,7491626,7491600,'309',3.333,3),(524,7491627,7491600,'09f',3.333,3),(524,7491628,7491600,'9fd',3.333,3),(524,7491629,7491600,'fd5',3.333,3),(524,7491630,7491600,'d54',3.333,3),(524,7491631,7491601,'mon',100,1),(524,7491632,7491631,'201',50,1),(524,7491633,7491631,'013',50,1),(524,7491634,7491632,'adm',33.333,3),(524,7491635,7491632,'dmi',33.333,3),(524,7491636,7491632,'min',33.333,3),(524,7491637,7491634,'cap',16.667,1),(524,7491638,7491634,'apa',16.667,1),(524,7491639,7491634,'pac',16.667,1),(524,7491640,7491634,'aci',16.667,1),(524,7491641,7491634,'cit',16.667,1),(524,7491642,7491634,'ity',16.667,1),(524,7491643,7491637,'pat',50,1),(524,7491644,7491637,'ath',50,1),(524,7491645,7491643,'vol',25,1),(524,7491646,7491643,'olu',25,1),(524,7491647,7491643,'lum',25,1),(524,7491648,7491643,'ume',25,1),(524,7491649,7491645,'78e',3.333,1),(524,7491650,7491645,'8e3',3.333,1),(524,7491651,7491645,'e3f',3.333,1),(524,7491652,7491645,'3f1',3.333,1),(524,7491653,7491645,'f18',3.333,1),(524,7491654,7491645,'188',3.333,1),(524,7491655,7491645,'886',3.333,1),(524,7491656,7491645,'86d',3.333,1),(524,7491657,7491645,'6d8',3.333,1),(524,7491658,7491645,'d87',3.333,1),(524,7491659,7491645,'871',3.333,1),(524,7491660,7491645,'711',3.333,1),(524,7491661,7491645,'11e',3.333,1),(524,7491662,7491645,'1e1',3.333,1),(524,7491663,7491645,'e19',3.333,1),(524,7491664,7491645,'192',3.333,1),(524,7491665,7491645,'927',3.333,1),(524,7491666,7491645,'277',3.333,1),(524,7491667,7491645,'778',3.333,1),(524,7491668,7491645,'780',3.333,1),(524,7491669,7491645,'806',3.333,1),(524,7491670,7491645,'06e',3.333,1),(524,7491671,7491645,'6e6',3.333,1),(524,7491672,7491645,'e6f',3.333,1),(524,7491673,7491645,'6f6',3.333,1),(524,7491674,7491645,'f6e',3.333,1),(524,7491675,7491645,'6e6',3.333,1),(524,7491676,7491645,'e69',3.333,1),(524,7491677,7491645,'696',3.333,1),(524,7491678,7491645,'963',3.333,1),(524,7491679,7491649,'fre',14.286,1),(524,7491680,7491649,'ree',14.286,1),(524,7491681,7491649,'ees',14.286,1),(524,7491682,7491649,'esp',14.286,1),(524,7491683,7491649,'spa',14.286,1),(524,7491684,7491649,'pac',14.286,1),(524,7491685,7491649,'ace',14.286,1),(524,7491686,7491679,'dis',50,1),(524,7491687,7491679,'isk',50,1),(524,7491688,7491686,'ind',33.333,1),(524,7491689,7491686,'nde',33.333,1),(524,7491690,7491686,'dex',33.333,1),(524,7491691,7491688,'adm',8.333,1),(524,7491692,7491688,'dmi',8.333,1),(524,7491693,7491688,'min',8.333,1),(524,7491694,7491688,'ini',8.333,1),(524,7491695,7491688,'nis',8.333,1),(524,7491696,7491688,'ist',8.333,1),(524,7491697,7491688,'str',8.333,1),(524,7491698,7491688,'tra',8.333,1),(524,7491699,7491688,'rat',8.333,1),(524,7491700,7491688,'ati',8.333,1),(524,7491701,7491688,'tio',8.333,1),(524,7491702,7491688,'ion',8.333,1),(524,7491703,7491691,'sta',33.333,3),(524,7491704,7491691,'tat',33.333,3),(524,7491705,7491691,'ate',33.333,3),(524,7491706,7491703,'ena',20,2),(524,7491707,7491703,'nab',20,2),(524,7491708,7491703,'abl',20,2),(524,7491709,7491703,'ble',20,2),(524,7491710,7491703,'led',20,2),(524,7491711,7491706,'cac',33.333,1),(524,7491712,7491706,'ach',33.333,1),(524,7491713,7491706,'che',33.333,1),(524,7491714,7491711,'mod',50,2),(524,7491715,7491711,'ode',50,2),(524,7491716,7491714,'wri',14.286,2),(524,7491717,7491714,'rit',14.286,2),(524,7491718,7491714,'ite',14.286,2),(524,7491719,7491714,'tet',14.286,2),(524,7491720,7491714,'eth',14.286,2),(524,7491721,7491714,'thr',14.286,2),(524,7491722,7491714,'hru',14.286,2),(524,7491723,7491716,'ope',11.111,2),(524,7491724,7491716,'per',11.111,2),(524,7491725,7491716,'era',11.111,2),(524,7491726,7491716,'rat',11.111,2),(524,7491727,7491716,'ati',11.111,2),(524,7491728,7491716,'tio',11.111,2),(524,7491729,7491716,'ion',11.111,2),(524,7491730,7491716,'ona',11.111,2),(524,7491731,7491716,'nal',11.111,2),(524,7491732,7491723,'nor',25,1),(524,7491733,7491723,'orm',25,1),(524,7491734,7491723,'rma',25,1),(524,7491735,7491723,'mal',25,1),(524,7491736,7491732,'mes',20,1),(524,7491737,7491732,'ess',20,1),(524,7491738,7491732,'ssa',20,1),(524,7491739,7491732,'sag',20,1),(524,7491740,7491732,'age',20,1),(524,7491741,7491736,'per',11.111,1),(524,7491742,7491736,'erf',11.111,1),(524,7491743,7491736,'rfo',11.111,1),(524,7491744,7491736,'for',11.111,1),(524,7491745,7491736,'orm',11.111,1),(524,7491746,7491736,'rma',11.111,1),(524,7491747,7491736,'man',11.111,1),(524,7491748,7491736,'anc',11.111,1),(524,7491749,7491736,'nce',11.111,1),(524,7491750,7491741,'ide',12.5,1),(524,7491751,7491741,'den',12.5,1),(524,7491752,7491741,'ent',12.5,1),(524,7491753,7491741,'nti',12.5,1),(524,7491754,7491741,'tif',12.5,1),(524,7491755,7491741,'ifi',12.5,1),(524,7491756,7491741,'fie',12.5,1),(524,7491757,7491741,'ier',12.5,1),(524,7491758,7491750,'vdi',33.333,3),(524,7491759,7491750,'dis',33.333,3),(524,7491760,7491750,'isk',33.333,3),(524,7491761,7491758,'nam',50,1),(524,7491762,7491758,'ame',50,1),(524,7491763,7491761,'typ',50,1),(524,7491764,7491761,'ype',50,1),(524,7491765,7491763,'dir',25,1),(524,7491766,7491763,'ire',25,1),(524,7491767,7491763,'rec',25,1),(524,7491768,7491763,'ect',25,1),(525,7491770,7491769,'naa',100,2),(525,7491771,7491770,'600',3.333,3),(525,7491772,7491770,'00a',3.333,3),(525,7491773,7491770,'0a0',3.333,3),(525,7491774,7491770,'a09',3.333,3),(525,7491775,7491770,'098',3.333,3),(525,7491776,7491770,'980',3.333,3),(525,7491777,7491770,'804',3.333,3),(525,7491778,7491770,'044',3.333,3),(525,7491779,7491770,'443',3.333,3),(525,7491780,7491770,'430',3.333,3),(525,7491781,7491770,'307',3.333,3),(525,7491782,7491770,'075',3.333,3),(525,7491783,7491770,'753',3.333,3),(525,7491784,7491770,'535',3.333,3),(525,7491785,7491770,'357',3.333,3),(525,7491786,7491770,'573',3.333,3),(525,7491787,7491770,'732',3.333,3),(525,7491788,7491770,'32b',3.333,3),(525,7491789,7491770,'2b3',3.333,3),(525,7491790,7491770,'b33',3.333,3),(525,7491791,7491770,'334',3.333,3),(525,7491792,7491770,'345',3.333,3),(525,7491793,7491770,'457',3.333,3),(525,7491794,7491770,'571',3.333,3),(525,7491795,7491770,'715',3.333,3),(525,7491796,7491770,'153',3.333,3),(525,7491797,7491770,'533',3.333,3),(525,7491798,7491770,'335',3.333,3),(525,7491799,7491770,'357',3.333,3),(525,7491800,7491770,'572',3.333,3),(525,7491801,7491771,'mon',100,1),(525,7491802,7491801,'201',50,1),(525,7491803,7491801,'013',50,1),(525,7491804,7491802,'adm',33.333,3),(525,7491805,7491802,'dmi',33.333,3),(525,7491806,7491802,'min',33.333,3),(525,7491807,7491804,'cap',16.667,1),(525,7491808,7491804,'apa',16.667,1),(525,7491809,7491804,'pac',16.667,1),(525,7491810,7491804,'aci',16.667,1),(525,7491811,7491804,'cit',16.667,1),(525,7491812,7491804,'ity',16.667,1),(525,7491813,7491807,'pat',50,1),(525,7491814,7491807,'ath',50,1),(525,7491815,7491813,'fre',14.286,1),(525,7491816,7491813,'ree',14.286,1),(525,7491817,7491813,'ees',14.286,1),(525,7491818,7491813,'esp',14.286,1),(525,7491819,7491813,'spa',14.286,1),(525,7491820,7491813,'pac',14.286,1),(525,7491821,7491813,'ace',14.286,1),(525,7491822,7491815,'dis',50,1),(525,7491823,7491815,'isk',50,1),(525,7491824,7491822,'ind',33.333,1),(525,7491825,7491822,'nde',33.333,1),(525,7491826,7491822,'dex',33.333,1),(525,7491827,7491824,'adm',8.333,1),(525,7491828,7491824,'dmi',8.333,1),(525,7491829,7491824,'min',8.333,1),(525,7491830,7491824,'ini',8.333,1),(525,7491831,7491824,'nis',8.333,1),(525,7491832,7491824,'ist',8.333,1),(525,7491833,7491824,'str',8.333,1),(525,7491834,7491824,'tra',8.333,1),(525,7491835,7491824,'rat',8.333,1),(525,7491836,7491824,'ati',8.333,1),(525,7491837,7491824,'tio',8.333,1),(525,7491838,7491824,'ion',8.333,1),(525,7491839,7491827,'sta',33.333,3),(525,7491840,7491827,'tat',33.333,3),(525,7491841,7491827,'ate',33.333,3),(525,7491842,7491839,'ena',20,2),(525,7491843,7491839,'nab',20,2),(525,7491844,7491839,'abl',20,2),(525,7491845,7491839,'ble',20,2),(525,7491846,7491839,'led',20,2),(525,7491847,7491842,'cac',33.333,1),(525,7491848,7491842,'ach',33.333,1),(525,7491849,7491842,'che',33.333,1),(525,7491850,7491847,'mod',50,2),(525,7491851,7491847,'ode',50,2),(525,7491852,7491850,'wri',14.286,2),(525,7491853,7491850,'rit',14.286,2),(525,7491854,7491850,'ite',14.286,2),(525,7491855,7491850,'tet',14.286,2),(525,7491856,7491850,'eth',14.286,2),(525,7491857,7491850,'thr',14.286,2),(525,7491858,7491850,'hru',14.286,2),(525,7491859,7491852,'ope',11.111,2),(525,7491860,7491852,'per',11.111,2),(525,7491861,7491852,'era',11.111,2),(525,7491862,7491852,'rat',11.111,2),(525,7491863,7491852,'ati',11.111,2),(525,7491864,7491852,'tio',11.111,2),(525,7491865,7491852,'ion',11.111,2),(525,7491866,7491852,'ona',11.111,2),(525,7491867,7491852,'nal',11.111,2),(525,7491868,7491859,'nor',25,1),(525,7491869,7491859,'orm',25,1),(525,7491870,7491859,'rma',25,1),(525,7491871,7491859,'mal',25,1),(525,7491872,7491868,'mes',20,1),(525,7491873,7491868,'ess',20,1),(525,7491874,7491868,'ssa',20,1),(525,7491875,7491868,'sag',20,1),(525,7491876,7491868,'age',20,1),(525,7491877,7491872,'per',11.111,1),(525,7491878,7491872,'erf',11.111,1),(525,7491879,7491872,'rfo',11.111,1),(525,7491880,7491872,'for',11.111,1),(525,7491881,7491872,'orm',11.111,1),(525,7491882,7491872,'rma',11.111,1),(525,7491883,7491872,'man',11.111,1),(525,7491884,7491872,'anc',11.111,1),(525,7491885,7491872,'nce',11.111,1),(525,7491886,7491877,'ide',12.5,1),(525,7491887,7491877,'den',12.5,1),(525,7491888,7491877,'ent',12.5,1),(525,7491889,7491877,'nti',12.5,1),(525,7491890,7491877,'tif',12.5,1),(525,7491891,7491877,'ifi',12.5,1),(525,7491892,7491877,'fie',12.5,1),(525,7491893,7491877,'ier',12.5,1),(525,7491894,7491886,'vdi',33.333,3),(525,7491895,7491886,'dis',33.333,3),(525,7491896,7491886,'isk',33.333,3),(525,7491897,7491894,'nam',50,1),(525,7491898,7491894,'ame',50,1),(525,7491899,7491897,'typ',50,1),(525,7491900,7491897,'ype',50,1),(525,7491901,7491899,'dir',25,1),(525,7491902,7491899,'ire',25,1),(525,7491903,7491899,'rec',25,1),(525,7491904,7491899,'ect',25,1),(526,7491906,7491905,'naa',100,2),(526,7491907,7491906,'600',3.333,3),(526,7491908,7491906,'00a',3.333,3),(526,7491909,7491906,'0a0',3.333,3),(526,7491910,7491906,'a09',3.333,3),(526,7491911,7491906,'098',3.333,3),(526,7491912,7491906,'980',3.333,3),(526,7491913,7491906,'804',3.333,3),(526,7491914,7491906,'044',3.333,3),(526,7491915,7491906,'443',3.333,3),(526,7491916,7491906,'430',3.333,3),(526,7491917,7491906,'307',3.333,3),(526,7491918,7491906,'072',3.333,3),(526,7491919,7491906,'725',3.333,3),(526,7491920,7491906,'259',3.333,3),(526,7491921,7491906,'593',3.333,3),(526,7491922,7491906,'931',3.333,3),(526,7491923,7491906,'313',3.333,3),(526,7491924,7491906,'13f',3.333,3),(526,7491925,7491906,'3f3',3.333,3),(526,7491926,7491906,'f33',3.333,3),(526,7491927,7491906,'334',3.333,3),(526,7491928,7491906,'345',3.333,3),(526,7491929,7491906,'455',3.333,3),(526,7491930,7491906,'556',3.333,3),(526,7491931,7491906,'563',3.333,3),(526,7491932,7491906,'639',3.333,3),(526,7491933,7491906,'393',3.333,3),(526,7491934,7491906,'934',3.333,3),(526,7491935,7491906,'343',3.333,3),(526,7491936,7491906,'436',3.333,3),(526,7491937,7491907,'mon',100,1),(526,7491938,7491937,'201',50,1),(526,7491939,7491937,'013',50,1),(526,7491940,7491938,'adm',33.333,3),(526,7491941,7491938,'dmi',33.333,3),(526,7491942,7491938,'min',33.333,3),(526,7491943,7491940,'cap',16.667,1),(526,7491944,7491940,'apa',16.667,1),(526,7491945,7491940,'pac',16.667,1),(526,7491946,7491940,'aci',16.667,1),(526,7491947,7491940,'cit',16.667,1),(526,7491948,7491940,'ity',16.667,1),(526,7491949,7491943,'pat',50,1),(526,7491950,7491943,'ath',50,1),(526,7491951,7491949,'fre',14.286,1),(526,7491952,7491949,'ree',14.286,1),(526,7491953,7491949,'ees',14.286,1),(526,7491954,7491949,'esp',14.286,1),(526,7491955,7491949,'spa',14.286,1),(526,7491956,7491949,'pac',14.286,1),(526,7491957,7491949,'ace',14.286,1),(526,7491958,7491951,'dis',50,1),(526,7491959,7491951,'isk',50,1),(526,7491960,7491958,'ind',33.333,1),(526,7491961,7491958,'nde',33.333,1),(526,7491962,7491958,'dex',33.333,1),(526,7491963,7491960,'adm',8.333,1),(526,7491964,7491960,'dmi',8.333,1),(526,7491965,7491960,'min',8.333,1),(526,7491966,7491960,'ini',8.333,1),(526,7491967,7491960,'nis',8.333,1),(526,7491968,7491960,'ist',8.333,1),(526,7491969,7491960,'str',8.333,1),(526,7491970,7491960,'tra',8.333,1),(526,7491971,7491960,'rat',8.333,1),(526,7491972,7491960,'ati',8.333,1),(526,7491973,7491960,'tio',8.333,1),(526,7491974,7491960,'ion',8.333,1),(526,7491975,7491963,'sta',33.333,3),(526,7491976,7491963,'tat',33.333,3),(526,7491977,7491963,'ate',33.333,3),(526,7491978,7491975,'ena',20,2),(526,7491979,7491975,'nab',20,2),(526,7491980,7491975,'abl',20,2),(526,7491981,7491975,'ble',20,2),(526,7491982,7491975,'led',20,2),(526,7491983,7491978,'cac',33.333,1),(526,7491984,7491978,'ach',33.333,1),(526,7491985,7491978,'che',33.333,1),(526,7491986,7491983,'mod',50,2),(526,7491987,7491983,'ode',50,2),(526,7491988,7491986,'wri',14.286,2),(526,7491989,7491986,'rit',14.286,2),(526,7491990,7491986,'ite',14.286,2),(526,7491991,7491986,'tet',14.286,2),(526,7491992,7491986,'eth',14.286,2),(526,7491993,7491986,'thr',14.286,2),(526,7491994,7491986,'hru',14.286,2),(526,7491995,7491988,'ope',11.111,2),(526,7491996,7491988,'per',11.111,2),(526,7491997,7491988,'era',11.111,2),(526,7491998,7491988,'rat',11.111,2),(526,7491999,7491988,'ati',11.111,2),(526,7492000,7491988,'tio',11.111,2),(526,7492001,7491988,'ion',11.111,2),(526,7492002,7491988,'ona',11.111,2),(526,7492003,7491988,'nal',11.111,2),(526,7492004,7491995,'nor',25,1),(526,7492005,7491995,'orm',25,1),(526,7492006,7491995,'rma',25,1),(526,7492007,7491995,'mal',25,1),(526,7492008,7492004,'mes',20,1),(526,7492009,7492004,'ess',20,1),(526,7492010,7492004,'ssa',20,1),(526,7492011,7492004,'sag',20,1),(526,7492012,7492004,'age',20,1),(526,7492013,7492008,'per',11.111,1),(526,7492014,7492008,'erf',11.111,1),(526,7492015,7492008,'rfo',11.111,1),(526,7492016,7492008,'for',11.111,1),(526,7492017,7492008,'orm',11.111,1),(526,7492018,7492008,'rma',11.111,1),(526,7492019,7492008,'man',11.111,1),(526,7492020,7492008,'anc',11.111,1),(526,7492021,7492008,'nce',11.111,1),(526,7492022,7492013,'ide',12.5,1),(526,7492023,7492013,'den',12.5,1),(526,7492024,7492013,'ent',12.5,1),(526,7492025,7492013,'nti',12.5,1),(526,7492026,7492013,'tif',12.5,1),(526,7492027,7492013,'ifi',12.5,1),(526,7492028,7492013,'fie',12.5,1),(526,7492029,7492013,'ier',12.5,1),(526,7492030,7492022,'vdi',33.333,3),(526,7492031,7492022,'dis',33.333,3),(526,7492032,7492022,'isk',33.333,3),(526,7492033,7492030,'nam',50,1),(526,7492034,7492030,'ame',50,1),(526,7492035,7492033,'typ',50,1),(526,7492036,7492033,'ype',50,1),(526,7492037,7492035,'dir',25,1),(526,7492038,7492035,'ire',25,1),(526,7492039,7492035,'rec',25,1),(526,7492040,7492035,'ect',25,1),(527,7492042,7492041,'naa',100,2),(527,7492043,7492042,'600',3.333,3),(527,7492044,7492042,'00a',3.333,3),(527,7492045,7492042,'0a0',3.333,3),(527,7492046,7492042,'a09',3.333,3),(527,7492047,7492042,'098',3.333,3),(527,7492048,7492042,'980',3.333,3),(527,7492049,7492042,'804',3.333,3),(527,7492050,7492042,'044',3.333,3),(527,7492051,7492042,'443',3.333,3),(527,7492052,7492042,'430',3.333,3),(527,7492053,7492042,'307',3.333,3),(527,7492054,7492042,'075',3.333,3),(527,7492055,7492042,'753',3.333,3),(527,7492056,7492042,'535',3.333,3),(527,7492057,7492042,'357',3.333,3),(527,7492058,7492042,'573',3.333,3),(527,7492059,7492042,'732',3.333,3),(527,7492060,7492042,'32b',3.333,3),(527,7492061,7492042,'2b3',3.333,3),(527,7492062,7492042,'b33',3.333,3),(527,7492063,7492042,'334',3.333,3),(527,7492064,7492042,'345',3.333,3),(527,7492065,7492042,'457',3.333,3),(527,7492066,7492042,'571',3.333,3),(527,7492067,7492042,'715',3.333,3),(527,7492068,7492042,'153',3.333,3),(527,7492069,7492042,'533',3.333,3),(527,7492070,7492042,'335',3.333,3),(527,7492071,7492042,'357',3.333,3),(527,7492072,7492042,'571',3.333,3),(527,7492073,7492043,'mon',100,1),(527,7492074,7492073,'201',50,1),(527,7492075,7492073,'013',50,1),(527,7492076,7492074,'adm',33.333,3),(527,7492077,7492074,'dmi',33.333,3),(527,7492078,7492074,'min',33.333,3),(527,7492079,7492076,'cap',16.667,1),(527,7492080,7492076,'apa',16.667,1),(527,7492081,7492076,'pac',16.667,1),(527,7492082,7492076,'aci',16.667,1),(527,7492083,7492076,'cit',16.667,1),(527,7492084,7492076,'ity',16.667,1),(527,7492085,7492079,'pat',50,1),(527,7492086,7492079,'ath',50,1),(527,7492087,7492085,'fre',14.286,1),(527,7492088,7492085,'ree',14.286,1),(527,7492089,7492085,'ees',14.286,1),(527,7492090,7492085,'esp',14.286,1),(527,7492091,7492085,'spa',14.286,1),(527,7492092,7492085,'pac',14.286,1),(527,7492093,7492085,'ace',14.286,1),(527,7492094,7492087,'dis',50,1),(527,7492095,7492087,'isk',50,1),(527,7492096,7492094,'ind',33.333,1),(527,7492097,7492094,'nde',33.333,1),(527,7492098,7492094,'dex',33.333,1),(527,7492099,7492096,'adm',8.333,1),(527,7492100,7492096,'dmi',8.333,1),(527,7492101,7492096,'min',8.333,1),(527,7492102,7492096,'ini',8.333,1),(527,7492103,7492096,'nis',8.333,1),(527,7492104,7492096,'ist',8.333,1),(527,7492105,7492096,'str',8.333,1),(527,7492106,7492096,'tra',8.333,1),(527,7492107,7492096,'rat',8.333,1),(527,7492108,7492096,'ati',8.333,1),(527,7492109,7492096,'tio',8.333,1),(527,7492110,7492096,'ion',8.333,1),(527,7492111,7492099,'sta',33.333,3),(527,7492112,7492099,'tat',33.333,3),(527,7492113,7492099,'ate',33.333,3),(527,7492114,7492111,'ena',20,2),(527,7492115,7492111,'nab',20,2),(527,7492116,7492111,'abl',20,2),(527,7492117,7492111,'ble',20,2),(527,7492118,7492111,'led',20,2),(527,7492119,7492114,'cac',33.333,1),(527,7492120,7492114,'ach',33.333,1),(527,7492121,7492114,'che',33.333,1),(527,7492122,7492119,'mod',50,2),(527,7492123,7492119,'ode',50,2),(527,7492124,7492122,'wri',14.286,2),(527,7492125,7492122,'rit',14.286,2),(527,7492126,7492122,'ite',14.286,2),(527,7492127,7492122,'tet',14.286,2),(527,7492128,7492122,'eth',14.286,2),(527,7492129,7492122,'thr',14.286,2),(527,7492130,7492122,'hru',14.286,2),(527,7492131,7492124,'ope',11.111,2),(527,7492132,7492124,'per',11.111,2),(527,7492133,7492124,'era',11.111,2),(527,7492134,7492124,'rat',11.111,2),(527,7492135,7492124,'ati',11.111,2),(527,7492136,7492124,'tio',11.111,2),(527,7492137,7492124,'ion',11.111,2),(527,7492138,7492124,'ona',11.111,2),(527,7492139,7492124,'nal',11.111,2),(527,7492140,7492131,'nor',25,1),(527,7492141,7492131,'orm',25,1),(527,7492142,7492131,'rma',25,1),(527,7492143,7492131,'mal',25,1),(527,7492144,7492140,'mes',20,1),(527,7492145,7492140,'ess',20,1),(527,7492146,7492140,'ssa',20,1),(527,7492147,7492140,'sag',20,1),(527,7492148,7492140,'age',20,1),(527,7492149,7492144,'per',11.111,1),(527,7492150,7492144,'erf',11.111,1),(527,7492151,7492144,'rfo',11.111,1),(527,7492152,7492144,'for',11.111,1),(527,7492153,7492144,'orm',11.111,1),(527,7492154,7492144,'rma',11.111,1),(527,7492155,7492144,'man',11.111,1),(527,7492156,7492144,'anc',11.111,1),(527,7492157,7492144,'nce',11.111,1),(527,7492158,7492149,'ide',12.5,1),(527,7492159,7492149,'den',12.5,1),(527,7492160,7492149,'ent',12.5,1),(527,7492161,7492149,'nti',12.5,1),(527,7492162,7492149,'tif',12.5,1),(527,7492163,7492149,'ifi',12.5,1),(527,7492164,7492149,'fie',12.5,1),(527,7492165,7492149,'ier',12.5,1),(527,7492166,7492158,'vdi',33.333,3),(527,7492167,7492158,'dis',33.333,3),(527,7492168,7492158,'isk',33.333,3),(527,7492169,7492166,'nam',50,1),(527,7492170,7492166,'ame',50,1),(527,7492171,7492169,'typ',50,1),(527,7492172,7492169,'ype',50,1),(527,7492173,7492171,'dir',25,1),(527,7492174,7492171,'ire',25,1),(527,7492175,7492171,'rec',25,1),(527,7492176,7492171,'ect',25,1),(528,7492178,7492177,'naa',100,2),(528,7492179,7492178,'600',3.333,3),(528,7492180,7492178,'00a',3.333,3),(528,7492181,7492178,'0a0',3.333,3),(528,7492182,7492178,'a09',3.333,3),(528,7492183,7492178,'098',3.333,3),(528,7492184,7492178,'980',3.333,3),(528,7492185,7492178,'804',3.333,3),(528,7492186,7492178,'044',3.333,3),(528,7492187,7492178,'443',3.333,3),(528,7492188,7492178,'430',3.333,3),(528,7492189,7492178,'307',3.333,3),(528,7492190,7492178,'072',3.333,3),(528,7492191,7492178,'725',3.333,3),(528,7492192,7492178,'259',3.333,3),(528,7492193,7492178,'593',3.333,3),(528,7492194,7492178,'931',3.333,3),(528,7492195,7492178,'313',3.333,3),(528,7492196,7492178,'13f',3.333,3),(528,7492197,7492178,'3f3',3.333,3),(528,7492198,7492178,'f33',3.333,3),(528,7492199,7492178,'334',3.333,3),(528,7492200,7492178,'345',3.333,3),(528,7492201,7492178,'455',3.333,3),(528,7492202,7492178,'556',3.333,3),(528,7492203,7492178,'563',3.333,3),(528,7492204,7492178,'639',3.333,3),(528,7492205,7492178,'393',3.333,3),(528,7492206,7492178,'934',3.333,3),(528,7492207,7492178,'343',3.333,3),(528,7492208,7492178,'435',3.333,3),(528,7492209,7492179,'mon',100,1),(528,7492210,7492209,'201',50,1),(528,7492211,7492209,'013',50,1),(528,7492212,7492210,'adm',33.333,3),(528,7492213,7492210,'dmi',33.333,3),(528,7492214,7492210,'min',33.333,3),(528,7492215,7492212,'cap',16.667,1),(528,7492216,7492212,'apa',16.667,1),(528,7492217,7492212,'pac',16.667,1),(528,7492218,7492212,'aci',16.667,1),(528,7492219,7492212,'cit',16.667,1),(528,7492220,7492212,'ity',16.667,1),(528,7492221,7492215,'pat',50,1),(528,7492222,7492215,'ath',50,1),(528,7492223,7492221,'fre',14.286,1),(528,7492224,7492221,'ree',14.286,1),(528,7492225,7492221,'ees',14.286,1),(528,7492226,7492221,'esp',14.286,1),(528,7492227,7492221,'spa',14.286,1),(528,7492228,7492221,'pac',14.286,1),(528,7492229,7492221,'ace',14.286,1),(528,7492230,7492223,'dis',50,1),(528,7492231,7492223,'isk',50,1),(528,7492232,7492230,'ind',33.333,1),(528,7492233,7492230,'nde',33.333,1),(528,7492234,7492230,'dex',33.333,1),(528,7492235,7492232,'adm',8.333,1),(528,7492236,7492232,'dmi',8.333,1),(528,7492237,7492232,'min',8.333,1),(528,7492238,7492232,'ini',8.333,1),(528,7492239,7492232,'nis',8.333,1),(528,7492240,7492232,'ist',8.333,1),(528,7492241,7492232,'str',8.333,1),(528,7492242,7492232,'tra',8.333,1),(528,7492243,7492232,'rat',8.333,1),(528,7492244,7492232,'ati',8.333,1),(528,7492245,7492232,'tio',8.333,1),(528,7492246,7492232,'ion',8.333,1),(528,7492247,7492235,'sta',33.333,3),(528,7492248,7492235,'tat',33.333,3),(528,7492249,7492235,'ate',33.333,3),(528,7492250,7492247,'ena',20,2),(528,7492251,7492247,'nab',20,2),(528,7492252,7492247,'abl',20,2),(528,7492253,7492247,'ble',20,2),(528,7492254,7492247,'led',20,2),(528,7492255,7492250,'cac',33.333,1),(528,7492256,7492250,'ach',33.333,1),(528,7492257,7492250,'che',33.333,1),(528,7492258,7492255,'mod',50,2),(528,7492259,7492255,'ode',50,2),(528,7492260,7492258,'wri',14.286,2),(528,7492261,7492258,'rit',14.286,2),(528,7492262,7492258,'ite',14.286,2),(528,7492263,7492258,'tet',14.286,2),(528,7492264,7492258,'eth',14.286,2),(528,7492265,7492258,'thr',14.286,2),(528,7492266,7492258,'hru',14.286,2),(528,7492267,7492260,'ope',11.111,2),(528,7492268,7492260,'per',11.111,2),(528,7492269,7492260,'era',11.111,2),(528,7492270,7492260,'rat',11.111,2),(528,7492271,7492260,'ati',11.111,2),(528,7492272,7492260,'tio',11.111,2),(528,7492273,7492260,'ion',11.111,2),(528,7492274,7492260,'ona',11.111,2),(528,7492275,7492260,'nal',11.111,2),(528,7492276,7492267,'nor',25,1),(528,7492277,7492267,'orm',25,1),(528,7492278,7492267,'rma',25,1),(528,7492279,7492267,'mal',25,1),(528,7492280,7492276,'mes',20,1),(528,7492281,7492276,'ess',20,1),(528,7492282,7492276,'ssa',20,1),(528,7492283,7492276,'sag',20,1),(528,7492284,7492276,'age',20,1),(528,7492285,7492280,'per',11.111,1),(528,7492286,7492280,'erf',11.111,1),(528,7492287,7492280,'rfo',11.111,1),(528,7492288,7492280,'for',11.111,1),(528,7492289,7492280,'orm',11.111,1),(528,7492290,7492280,'rma',11.111,1),(528,7492291,7492280,'man',11.111,1),(528,7492292,7492280,'anc',11.111,1),(528,7492293,7492280,'nce',11.111,1),(528,7492294,7492285,'ide',12.5,1),(528,7492295,7492285,'den',12.5,1),(528,7492296,7492285,'ent',12.5,1),(528,7492297,7492285,'nti',12.5,1),(528,7492298,7492285,'tif',12.5,1),(528,7492299,7492285,'ifi',12.5,1),(528,7492300,7492285,'fie',12.5,1),(528,7492301,7492285,'ier',12.5,1),(528,7492302,7492294,'vdi',33.333,3),(528,7492303,7492294,'dis',33.333,3),(528,7492304,7492294,'isk',33.333,3),(528,7492305,7492302,'nam',50,1),(528,7492306,7492302,'ame',50,1),(528,7492307,7492305,'typ',50,1),(528,7492308,7492305,'ype',50,1),(528,7492309,7492307,'dir',25,1),(528,7492310,7492307,'ire',25,1),(528,7492311,7492307,'rec',25,1),(528,7492312,7492307,'ect',25,1),(529,7492314,7492313,'naa',100,2),(529,7492315,7492314,'600',3.333,3),(529,7492316,7492314,'000',3.333,3),(529,7492317,7492314,'00c',3.333,3),(529,7492318,7492314,'0c2',3.333,3),(529,7492319,7492314,'c29',3.333,3),(529,7492320,7492314,'290',3.333,3),(529,7492321,7492314,'908',3.333,3),(529,7492322,7492314,'084',3.333,3),(529,7492323,7492314,'840',3.333,3),(529,7492324,7492314,'408',3.333,3),(529,7492325,7492314,'08d',3.333,3),(529,7492326,7492314,'8da',3.333,3),(529,7492327,7492314,'da1',3.333,3),(529,7492328,7492314,'a15',3.333,3),(529,7492329,7492314,'158',3.333,3),(529,7492330,7492314,'58a',3.333,3),(529,7492331,7492314,'8a5',3.333,3),(529,7492332,7492314,'a5c',3.333,3),(529,7492333,7492314,'5c3',3.333,3),(529,7492334,7492314,'c3b',3.333,3),(529,7492335,7492314,'3bf',3.333,3),(529,7492336,7492314,'bfb',3.333,3),(529,7492337,7492314,'fb6',3.333,3),(529,7492338,7492314,'b61',3.333,3),(529,7492339,7492314,'61c',3.333,3),(529,7492340,7492314,'1c0',3.333,3),(529,7492341,7492314,'c07',3.333,3),(529,7492342,7492314,'078',3.333,3),(529,7492343,7492314,'787',3.333,3),(529,7492344,7492314,'879',3.333,3),(529,7492345,7492315,'mon',100,1),(529,7492346,7492345,'201',50,1),(529,7492347,7492345,'013',50,1),(529,7492348,7492346,'adm',33.333,3),(529,7492349,7492346,'dmi',33.333,3),(529,7492350,7492346,'min',33.333,3),(529,7492351,7492348,'cap',16.667,1),(529,7492352,7492348,'apa',16.667,1),(529,7492353,7492348,'pac',16.667,1),(529,7492354,7492348,'aci',16.667,1),(529,7492355,7492348,'cit',16.667,1),(529,7492356,7492348,'ity',16.667,1),(529,7492357,7492351,'pat',50,1),(529,7492358,7492351,'ath',50,1),(529,7492359,7492357,'fre',14.286,1),(529,7492360,7492357,'ree',14.286,1),(529,7492361,7492357,'ees',14.286,1),(529,7492362,7492357,'esp',14.286,1),(529,7492363,7492357,'spa',14.286,1),(529,7492364,7492357,'pac',14.286,1),(529,7492365,7492357,'ace',14.286,1),(529,7492366,7492359,'dis',50,1),(529,7492367,7492359,'isk',50,1),(529,7492368,7492366,'ind',33.333,1),(529,7492369,7492366,'nde',33.333,1),(529,7492370,7492366,'dex',33.333,1),(529,7492371,7492368,'adm',8.333,1),(529,7492372,7492368,'dmi',8.333,1),(529,7492373,7492368,'min',8.333,1),(529,7492374,7492368,'ini',8.333,1),(529,7492375,7492368,'nis',8.333,1),(529,7492376,7492368,'ist',8.333,1),(529,7492377,7492368,'str',8.333,1),(529,7492378,7492368,'tra',8.333,1),(529,7492379,7492368,'rat',8.333,1),(529,7492380,7492368,'ati',8.333,1),(529,7492381,7492368,'tio',8.333,1),(529,7492382,7492368,'ion',8.333,1),(529,7492383,7492371,'sta',33.333,3),(529,7492384,7492371,'tat',33.333,3),(529,7492385,7492371,'ate',33.333,3),(529,7492386,7492383,'ena',20,2),(529,7492387,7492383,'nab',20,2),(529,7492388,7492383,'abl',20,2),(529,7492389,7492383,'ble',20,2),(529,7492390,7492383,'led',20,2),(529,7492391,7492386,'cac',33.333,1),(529,7492392,7492386,'ach',33.333,1),(529,7492393,7492386,'che',33.333,1),(529,7492394,7492391,'mod',50,2),(529,7492395,7492391,'ode',50,2),(529,7492396,7492394,'wri',14.286,2),(529,7492397,7492394,'rit',14.286,2),(529,7492398,7492394,'ite',14.286,2),(529,7492399,7492394,'tet',14.286,2),(529,7492400,7492394,'eth',14.286,2),(529,7492401,7492394,'thr',14.286,2),(529,7492402,7492394,'hru',14.286,2),(529,7492403,7492396,'ope',11.111,2),(529,7492404,7492396,'per',11.111,2),(529,7492405,7492396,'era',11.111,2),(529,7492406,7492396,'rat',11.111,2),(529,7492407,7492396,'ati',11.111,2),(529,7492408,7492396,'tio',11.111,2),(529,7492409,7492396,'ion',11.111,2),(529,7492410,7492396,'ona',11.111,2),(529,7492411,7492396,'nal',11.111,2),(529,7492412,7492403,'nor',25,1),(529,7492413,7492403,'orm',25,1),(529,7492414,7492403,'rma',25,1),(529,7492415,7492403,'mal',25,1),(529,7492416,7492412,'mes',20,1),(529,7492417,7492412,'ess',20,1),(529,7492418,7492412,'ssa',20,1),(529,7492419,7492412,'sag',20,1),(529,7492420,7492412,'age',20,1),(529,7492421,7492416,'per',11.111,1),(529,7492422,7492416,'erf',11.111,1),(529,7492423,7492416,'rfo',11.111,1),(529,7492424,7492416,'for',11.111,1),(529,7492425,7492416,'orm',11.111,1),(529,7492426,7492416,'rma',11.111,1),(529,7492427,7492416,'man',11.111,1),(529,7492428,7492416,'anc',11.111,1),(529,7492429,7492416,'nce',11.111,1),(529,7492430,7492421,'ide',12.5,1),(529,7492431,7492421,'den',12.5,1),(529,7492432,7492421,'ent',12.5,1),(529,7492433,7492421,'nti',12.5,1),(529,7492434,7492421,'tif',12.5,1),(529,7492435,7492421,'ifi',12.5,1),(529,7492436,7492421,'fie',12.5,1),(529,7492437,7492421,'ier',12.5,1),(529,7492438,7492430,'vdi',33.333,3),(529,7492439,7492430,'dis',33.333,3),(529,7492440,7492430,'isk',33.333,3),(529,7492441,7492438,'nam',50,1),(529,7492442,7492438,'ame',50,1),(529,7492443,7492441,'typ',50,1),(529,7492444,7492441,'ype',50,1),(529,7492445,7492443,'dir',25,1),(529,7492446,7492443,'ire',25,1),(529,7492447,7492443,'rec',25,1),(529,7492448,7492443,'ect',25,1),(530,7492450,7492449,'naa',100,2),(530,7492451,7492450,'600',3.333,3),(530,7492452,7492450,'000',3.333,3),(530,7492453,7492450,'00c',3.333,3),(530,7492454,7492450,'0c2',3.333,3),(530,7492455,7492450,'c29',3.333,3),(530,7492456,7492450,'29e',3.333,3),(530,7492457,7492450,'9ef',3.333,3),(530,7492458,7492450,'efa',3.333,3),(530,7492459,7492450,'faa',3.333,3),(530,7492460,7492450,'aa2',3.333,3),(530,7492461,7492450,'a27',3.333,3),(530,7492462,7492450,'27d',3.333,3),(530,7492463,7492450,'7da',3.333,3),(530,7492464,7492450,'da2',3.333,3),(530,7492465,7492450,'a23',3.333,3),(530,7492466,7492450,'235',3.333,3),(530,7492467,7492450,'35f',3.333,3),(530,7492468,7492450,'5fd',3.333,3),(530,7492469,7492450,'fda',3.333,3),(530,7492470,7492450,'da6',3.333,3),(530,7492471,7492450,'a64',3.333,3),(530,7492472,7492450,'642',3.333,3),(530,7492473,7492450,'42d',3.333,3),(530,7492474,7492450,'2d9',3.333,3),(530,7492475,7492450,'d90',3.333,3),(530,7492476,7492450,'90b',3.333,3),(530,7492477,7492450,'0b0',3.333,3),(530,7492478,7492450,'b09',3.333,3),(530,7492479,7492450,'098',3.333,3),(530,7492480,7492450,'98e',3.333,3),(530,7492481,7492451,'mon',100,1),(530,7492482,7492481,'201',50,1),(530,7492483,7492481,'013',50,1),(530,7492484,7492482,'adm',33.333,3),(530,7492485,7492482,'dmi',33.333,3),(530,7492486,7492482,'min',33.333,3),(530,7492487,7492484,'cap',16.667,1),(530,7492488,7492484,'apa',16.667,1),(530,7492489,7492484,'pac',16.667,1),(530,7492490,7492484,'aci',16.667,1),(530,7492491,7492484,'cit',16.667,1),(530,7492492,7492484,'ity',16.667,1),(530,7492493,7492487,'pat',50,1),(530,7492494,7492487,'ath',50,1),(530,7492495,7492493,'fre',14.286,1),(530,7492496,7492493,'ree',14.286,1),(530,7492497,7492493,'ees',14.286,1),(530,7492498,7492493,'esp',14.286,1),(530,7492499,7492493,'spa',14.286,1),(530,7492500,7492493,'pac',14.286,1),(530,7492501,7492493,'ace',14.286,1),(530,7492502,7492495,'dis',50,1),(530,7492503,7492495,'isk',50,1),(530,7492504,7492502,'ind',33.333,1),(530,7492505,7492502,'nde',33.333,1),(530,7492506,7492502,'dex',33.333,1),(530,7492507,7492504,'adm',8.333,1),(530,7492508,7492504,'dmi',8.333,1),(530,7492509,7492504,'min',8.333,1),(530,7492510,7492504,'ini',8.333,1),(530,7492511,7492504,'nis',8.333,1),(530,7492512,7492504,'ist',8.333,1),(530,7492513,7492504,'str',8.333,1),(530,7492514,7492504,'tra',8.333,1),(530,7492515,7492504,'rat',8.333,1),(530,7492516,7492504,'ati',8.333,1),(530,7492517,7492504,'tio',8.333,1),(530,7492518,7492504,'ion',8.333,1),(530,7492519,7492507,'sta',33.333,3),(530,7492520,7492507,'tat',33.333,3),(530,7492521,7492507,'ate',33.333,3),(530,7492522,7492519,'ena',20,2),(530,7492523,7492519,'nab',20,2),(530,7492524,7492519,'abl',20,2),(530,7492525,7492519,'ble',20,2),(530,7492526,7492519,'led',20,2),(530,7492527,7492522,'cac',33.333,1),(530,7492528,7492522,'ach',33.333,1),(530,7492529,7492522,'che',33.333,1),(530,7492530,7492527,'mod',50,2),(530,7492531,7492527,'ode',50,2),(530,7492532,7492530,'wri',14.286,2),(530,7492533,7492530,'rit',14.286,2),(530,7492534,7492530,'ite',14.286,2),(530,7492535,7492530,'tet',14.286,2),(530,7492536,7492530,'eth',14.286,2),(530,7492537,7492530,'thr',14.286,2),(530,7492538,7492530,'hru',14.286,2),(530,7492539,7492532,'ope',11.111,2),(530,7492540,7492532,'per',11.111,2),(530,7492541,7492532,'era',11.111,2),(530,7492542,7492532,'rat',11.111,2),(530,7492543,7492532,'ati',11.111,2),(530,7492544,7492532,'tio',11.111,2),(530,7492545,7492532,'ion',11.111,2),(530,7492546,7492532,'ona',11.111,2),(530,7492547,7492532,'nal',11.111,2),(530,7492548,7492539,'nor',25,1),(530,7492549,7492539,'orm',25,1),(530,7492550,7492539,'rma',25,1),(530,7492551,7492539,'mal',25,1),(530,7492552,7492548,'mes',20,1),(530,7492553,7492548,'ess',20,1),(530,7492554,7492548,'ssa',20,1),(530,7492555,7492548,'sag',20,1),(530,7492556,7492548,'age',20,1),(530,7492557,7492552,'per',11.111,1),(530,7492558,7492552,'erf',11.111,1),(530,7492559,7492552,'rfo',11.111,1),(530,7492560,7492552,'for',11.111,1),(530,7492561,7492552,'orm',11.111,1),(530,7492562,7492552,'rma',11.111,1),(530,7492563,7492552,'man',11.111,1),(530,7492564,7492552,'anc',11.111,1),(530,7492565,7492552,'nce',11.111,1),(530,7492566,7492557,'ide',12.5,1),(530,7492567,7492557,'den',12.5,1),(530,7492568,7492557,'ent',12.5,1),(530,7492569,7492557,'nti',12.5,1),(530,7492570,7492557,'tif',12.5,1),(530,7492571,7492557,'ifi',12.5,1),(530,7492572,7492557,'fie',12.5,1),(530,7492573,7492557,'ier',12.5,1),(530,7492574,7492566,'vdi',33.333,3),(530,7492575,7492566,'dis',33.333,3),(530,7492576,7492566,'isk',33.333,3),(530,7492577,7492574,'nam',50,1),(530,7492578,7492574,'ame',50,1),(530,7492579,7492577,'typ',50,1),(530,7492580,7492577,'ype',50,1),(530,7492581,7492579,'dir',25,1),(530,7492582,7492579,'ire',25,1),(530,7492583,7492579,'rec',25,1),(530,7492584,7492579,'ect',25,1),(531,7492586,7492585,'naa',100,2),(531,7492587,7492586,'600',3.333,3),(531,7492588,7492586,'000',3.333,3),(531,7492589,7492586,'00c',3.333,3),(531,7492590,7492586,'0c2',3.333,3),(531,7492591,7492586,'c29',3.333,3),(531,7492592,7492586,'298',3.333,3),(531,7492593,7492586,'984',3.333,3),(531,7492594,7492586,'84c',3.333,3),(531,7492595,7492586,'4c0',3.333,3),(531,7492596,7492586,'c02',3.333,3),(531,7492597,7492586,'024',3.333,3),(531,7492598,7492586,'245',3.333,3),(531,7492599,7492586,'45d',3.333,3),(531,7492600,7492586,'5d2',3.333,3),(531,7492601,7492586,'d26',3.333,3),(531,7492602,7492586,'266',3.333,3),(531,7492603,7492586,'661',3.333,3),(531,7492604,7492586,'616',3.333,3),(531,7492605,7492586,'169',3.333,3),(531,7492606,7492586,'69b',3.333,3),(531,7492607,7492586,'9b9',3.333,3),(531,7492608,7492586,'b96',3.333,3),(531,7492609,7492586,'968',3.333,3),(531,7492610,7492586,'686',3.333,3),(531,7492611,7492586,'86a',3.333,3),(531,7492612,7492586,'6a2',3.333,3),(531,7492613,7492586,'a2e',3.333,3),(531,7492614,7492586,'2e0',3.333,3),(531,7492615,7492586,'e0c',3.333,3),(531,7492616,7492586,'0c5',3.333,3),(531,7492617,7492587,'mon',100,1),(531,7492618,7492617,'201',50,1),(531,7492619,7492617,'013',50,1),(531,7492620,7492618,'adm',33.333,3),(531,7492621,7492618,'dmi',33.333,3),(531,7492622,7492618,'min',33.333,3),(531,7492623,7492620,'cap',16.667,1),(531,7492624,7492620,'apa',16.667,1),(531,7492625,7492620,'pac',16.667,1),(531,7492626,7492620,'aci',16.667,1),(531,7492627,7492620,'cit',16.667,1),(531,7492628,7492620,'ity',16.667,1),(531,7492629,7492623,'pat',50,1),(531,7492630,7492623,'ath',50,1),(531,7492631,7492629,'fre',14.286,1),(531,7492632,7492629,'ree',14.286,1),(531,7492633,7492629,'ees',14.286,1),(531,7492634,7492629,'esp',14.286,1),(531,7492635,7492629,'spa',14.286,1),(531,7492636,7492629,'pac',14.286,1),(531,7492637,7492629,'ace',14.286,1),(531,7492638,7492631,'dis',50,1),(531,7492639,7492631,'isk',50,1),(531,7492640,7492638,'ind',33.333,1),(531,7492641,7492638,'nde',33.333,1),(531,7492642,7492638,'dex',33.333,1),(531,7492643,7492640,'adm',8.333,1),(531,7492644,7492640,'dmi',8.333,1),(531,7492645,7492640,'min',8.333,1),(531,7492646,7492640,'ini',8.333,1),(531,7492647,7492640,'nis',8.333,1),(531,7492648,7492640,'ist',8.333,1),(531,7492649,7492640,'str',8.333,1),(531,7492650,7492640,'tra',8.333,1),(531,7492651,7492640,'rat',8.333,1),(531,7492652,7492640,'ati',8.333,1),(531,7492653,7492640,'tio',8.333,1),(531,7492654,7492640,'ion',8.333,1),(531,7492655,7492643,'sta',33.333,3),(531,7492656,7492643,'tat',33.333,3),(531,7492657,7492643,'ate',33.333,3),(531,7492658,7492655,'ena',20,2),(531,7492659,7492655,'nab',20,2),(531,7492660,7492655,'abl',20,2),(531,7492661,7492655,'ble',20,2),(531,7492662,7492655,'led',20,2),(531,7492663,7492658,'cac',33.333,1),(531,7492664,7492658,'ach',33.333,1),(531,7492665,7492658,'che',33.333,1),(531,7492666,7492663,'mod',50,2),(531,7492667,7492663,'ode',50,2),(531,7492668,7492666,'wri',14.286,2),(531,7492669,7492666,'rit',14.286,2),(531,7492670,7492666,'ite',14.286,2),(531,7492671,7492666,'tet',14.286,2),(531,7492672,7492666,'eth',14.286,2),(531,7492673,7492666,'thr',14.286,2),(531,7492674,7492666,'hru',14.286,2),(531,7492675,7492668,'ope',11.111,2),(531,7492676,7492668,'per',11.111,2),(531,7492677,7492668,'era',11.111,2),(531,7492678,7492668,'rat',11.111,2),(531,7492679,7492668,'ati',11.111,2),(531,7492680,7492668,'tio',11.111,2),(531,7492681,7492668,'ion',11.111,2),(531,7492682,7492668,'ona',11.111,2),(531,7492683,7492668,'nal',11.111,2),(531,7492684,7492675,'nor',25,1),(531,7492685,7492675,'orm',25,1),(531,7492686,7492675,'rma',25,1),(531,7492687,7492675,'mal',25,1),(531,7492688,7492684,'mes',20,1),(531,7492689,7492684,'ess',20,1),(531,7492690,7492684,'ssa',20,1),(531,7492691,7492684,'sag',20,1),(531,7492692,7492684,'age',20,1),(531,7492693,7492688,'per',11.111,1),(531,7492694,7492688,'erf',11.111,1),(531,7492695,7492688,'rfo',11.111,1),(531,7492696,7492688,'for',11.111,1),(531,7492697,7492688,'orm',11.111,1),(531,7492698,7492688,'rma',11.111,1),(531,7492699,7492688,'man',11.111,1),(531,7492700,7492688,'anc',11.111,1),(531,7492701,7492688,'nce',11.111,1),(531,7492702,7492693,'ide',12.5,1),(531,7492703,7492693,'den',12.5,1),(531,7492704,7492693,'ent',12.5,1),(531,7492705,7492693,'nti',12.5,1),(531,7492706,7492693,'tif',12.5,1),(531,7492707,7492693,'ifi',12.5,1),(531,7492708,7492693,'fie',12.5,1),(531,7492709,7492693,'ier',12.5,1),(531,7492710,7492702,'vdi',33.333,3),(531,7492711,7492702,'dis',33.333,3),(531,7492712,7492702,'isk',33.333,3),(531,7492713,7492710,'nam',50,1),(531,7492714,7492710,'ame',50,1),(531,7492715,7492713,'typ',50,1),(531,7492716,7492713,'ype',50,1),(531,7492717,7492715,'dir',25,1),(531,7492718,7492715,'ire',25,1),(531,7492719,7492715,'rec',25,1),(531,7492720,7492715,'ect',25,1),(532,7492722,7492721,'naa',100,2),(532,7492723,7492722,'600',3.333,3),(532,7492724,7492722,'000',3.333,3),(532,7492725,7492722,'00c',3.333,3),(532,7492726,7492722,'0c2',3.333,3),(532,7492727,7492722,'c29',3.333,3),(532,7492728,7492722,'296',3.333,3),(532,7492729,7492722,'968',3.333,3),(532,7492730,7492722,'682',3.333,3),(532,7492731,7492722,'82c',3.333,3),(532,7492732,7492722,'2c7',3.333,3),(532,7492733,7492722,'c74',3.333,3),(532,7492734,7492722,'740',3.333,3),(532,7492735,7492722,'40d',3.333,3),(532,7492736,7492722,'0d6',3.333,3),(532,7492737,7492722,'d63',3.333,3),(532,7492738,7492722,'63a',3.333,3),(532,7492739,7492722,'3af',3.333,3),(532,7492740,7492722,'afb',3.333,3),(532,7492741,7492722,'fb5',3.333,3),(532,7492742,7492722,'b53',3.333,3),(532,7492743,7492722,'534',3.333,3),(532,7492744,7492722,'346',3.333,3),(532,7492745,7492722,'463',3.333,3),(532,7492746,7492722,'636',3.333,3),(532,7492747,7492722,'367',3.333,3),(532,7492748,7492722,'670',3.333,3),(532,7492749,7492722,'704',3.333,3),(532,7492750,7492722,'046',3.333,3),(532,7492751,7492722,'466',3.333,3),(532,7492752,7492722,'664',3.333,3),(532,7492753,7492723,'mon',100,1),(532,7492754,7492753,'201',50,1),(532,7492755,7492753,'013',50,1),(532,7492756,7492754,'adm',33.333,3),(532,7492757,7492754,'dmi',33.333,3),(532,7492758,7492754,'min',33.333,3),(532,7492759,7492756,'cap',16.667,1),(532,7492760,7492756,'apa',16.667,1),(532,7492761,7492756,'pac',16.667,1),(532,7492762,7492756,'aci',16.667,1),(532,7492763,7492756,'cit',16.667,1),(532,7492764,7492756,'ity',16.667,1),(532,7492765,7492759,'pat',50,1),(532,7492766,7492759,'ath',50,1),(532,7492767,7492765,'fre',14.286,1),(532,7492768,7492765,'ree',14.286,1),(532,7492769,7492765,'ees',14.286,1),(532,7492770,7492765,'esp',14.286,1),(532,7492771,7492765,'spa',14.286,1),(532,7492772,7492765,'pac',14.286,1),(532,7492773,7492765,'ace',14.286,1),(532,7492774,7492767,'dis',50,1),(532,7492775,7492767,'isk',50,1),(532,7492776,7492774,'ind',33.333,1),(532,7492777,7492774,'nde',33.333,1),(532,7492778,7492774,'dex',33.333,1),(532,7492779,7492776,'adm',8.333,1),(532,7492780,7492776,'dmi',8.333,1),(532,7492781,7492776,'min',8.333,1),(532,7492782,7492776,'ini',8.333,1),(532,7492783,7492776,'nis',8.333,1),(532,7492784,7492776,'ist',8.333,1),(532,7492785,7492776,'str',8.333,1),(532,7492786,7492776,'tra',8.333,1),(532,7492787,7492776,'rat',8.333,1),(532,7492788,7492776,'ati',8.333,1),(532,7492789,7492776,'tio',8.333,1),(532,7492790,7492776,'ion',8.333,1),(532,7492791,7492779,'sta',33.333,3),(532,7492792,7492779,'tat',33.333,3),(532,7492793,7492779,'ate',33.333,3),(532,7492794,7492791,'ena',20,2),(532,7492795,7492791,'nab',20,2),(532,7492796,7492791,'abl',20,2),(532,7492797,7492791,'ble',20,2),(532,7492798,7492791,'led',20,2),(532,7492799,7492794,'cac',33.333,1),(532,7492800,7492794,'ach',33.333,1),(532,7492801,7492794,'che',33.333,1),(532,7492802,7492799,'mod',50,2),(532,7492803,7492799,'ode',50,2),(532,7492804,7492802,'wri',14.286,2),(532,7492805,7492802,'rit',14.286,2),(532,7492806,7492802,'ite',14.286,2),(532,7492807,7492802,'tet',14.286,2),(532,7492808,7492802,'eth',14.286,2),(532,7492809,7492802,'thr',14.286,2),(532,7492810,7492802,'hru',14.286,2),(532,7492811,7492804,'ope',11.111,2),(532,7492812,7492804,'per',11.111,2),(532,7492813,7492804,'era',11.111,2),(532,7492814,7492804,'rat',11.111,2),(532,7492815,7492804,'ati',11.111,2),(532,7492816,7492804,'tio',11.111,2),(532,7492817,7492804,'ion',11.111,2),(532,7492818,7492804,'ona',11.111,2),(532,7492819,7492804,'nal',11.111,2),(532,7492820,7492811,'nor',25,1),(532,7492821,7492811,'orm',25,1),(532,7492822,7492811,'rma',25,1),(532,7492823,7492811,'mal',25,1),(532,7492824,7492820,'mes',20,1),(532,7492825,7492820,'ess',20,1),(532,7492826,7492820,'ssa',20,1),(532,7492827,7492820,'sag',20,1),(532,7492828,7492820,'age',20,1),(532,7492829,7492824,'per',11.111,1),(532,7492830,7492824,'erf',11.111,1),(532,7492831,7492824,'rfo',11.111,1),(532,7492832,7492824,'for',11.111,1),(532,7492833,7492824,'orm',11.111,1),(532,7492834,7492824,'rma',11.111,1),(532,7492835,7492824,'man',11.111,1),(532,7492836,7492824,'anc',11.111,1),(532,7492837,7492824,'nce',11.111,1),(532,7492838,7492829,'ide',12.5,1),(532,7492839,7492829,'den',12.5,1),(532,7492840,7492829,'ent',12.5,1),(532,7492841,7492829,'nti',12.5,1),(532,7492842,7492829,'tif',12.5,1),(532,7492843,7492829,'ifi',12.5,1),(532,7492844,7492829,'fie',12.5,1),(532,7492845,7492829,'ier',12.5,1),(532,7492846,7492838,'vdi',33.333,3),(532,7492847,7492838,'dis',33.333,3),(532,7492848,7492838,'isk',33.333,3),(532,7492849,7492846,'nam',50,1),(532,7492850,7492846,'ame',50,1),(532,7492851,7492849,'typ',50,1),(532,7492852,7492849,'ype',50,1),(532,7492853,7492851,'dir',25,1),(532,7492854,7492851,'ire',25,1),(532,7492855,7492851,'rec',25,1),(532,7492856,7492851,'ect',25,1),(533,7492858,7492857,'naa',100,2),(533,7492859,7492858,'600',3.333,3),(533,7492860,7492858,'000',3.333,3),(533,7492861,7492858,'00c',3.333,3),(533,7492862,7492858,'0c2',3.333,3),(533,7492863,7492858,'c29',3.333,3),(533,7492864,7492858,'29c',3.333,3),(533,7492865,7492858,'9c7',3.333,3),(533,7492866,7492858,'c77',3.333,3),(533,7492867,7492858,'778',3.333,3),(533,7492868,7492858,'782',3.333,3),(533,7492869,7492858,'825',3.333,3),(533,7492870,7492858,'256',3.333,3),(533,7492871,7492858,'56e',3.333,3),(533,7492872,7492858,'6eb',3.333,3),(533,7492873,7492858,'eb8',3.333,3),(533,7492874,7492858,'b8f',3.333,3),(533,7492875,7492858,'8f4',3.333,3),(533,7492876,7492858,'f4b',3.333,3),(533,7492877,7492858,'4b6',3.333,3),(533,7492878,7492858,'b6c',3.333,3),(533,7492879,7492858,'6c1',3.333,3),(533,7492880,7492858,'c1a',3.333,3),(533,7492881,7492858,'1a1',3.333,3),(533,7492882,7492858,'a1d',3.333,3),(533,7492883,7492858,'1dc',3.333,3),(533,7492884,7492858,'dce',3.333,3),(533,7492885,7492858,'ce5',3.333,3),(533,7492886,7492858,'e5f',3.333,3),(533,7492887,7492858,'5fc',3.333,3),(533,7492888,7492858,'fcb',3.333,3),(533,7492889,7492859,'mon',100,1),(533,7492890,7492889,'201',50,1),(533,7492891,7492889,'013',50,1),(533,7492892,7492890,'adm',33.333,3),(533,7492893,7492890,'dmi',33.333,3),(533,7492894,7492890,'min',33.333,3),(533,7492895,7492892,'cap',16.667,1),(533,7492896,7492892,'apa',16.667,1),(533,7492897,7492892,'pac',16.667,1),(533,7492898,7492892,'aci',16.667,1),(533,7492899,7492892,'cit',16.667,1),(533,7492900,7492892,'ity',16.667,1),(533,7492901,7492895,'pat',50,1),(533,7492902,7492895,'ath',50,1),(533,7492903,7492901,'fre',14.286,1),(533,7492904,7492901,'ree',14.286,1),(533,7492905,7492901,'ees',14.286,1),(533,7492906,7492901,'esp',14.286,1),(533,7492907,7492901,'spa',14.286,1),(533,7492908,7492901,'pac',14.286,1),(533,7492909,7492901,'ace',14.286,1),(533,7492910,7492903,'dis',50,1),(533,7492911,7492903,'isk',50,1),(533,7492912,7492910,'ind',33.333,1),(533,7492913,7492910,'nde',33.333,1),(533,7492914,7492910,'dex',33.333,1),(533,7492915,7492912,'adm',8.333,1),(533,7492916,7492912,'dmi',8.333,1),(533,7492917,7492912,'min',8.333,1),(533,7492918,7492912,'ini',8.333,1),(533,7492919,7492912,'nis',8.333,1),(533,7492920,7492912,'ist',8.333,1),(533,7492921,7492912,'str',8.333,1),(533,7492922,7492912,'tra',8.333,1),(533,7492923,7492912,'rat',8.333,1),(533,7492924,7492912,'ati',8.333,1),(533,7492925,7492912,'tio',8.333,1),(533,7492926,7492912,'ion',8.333,1),(533,7492927,7492915,'sta',33.333,3),(533,7492928,7492915,'tat',33.333,3),(533,7492929,7492915,'ate',33.333,3),(533,7492930,7492927,'ena',20,2),(533,7492931,7492927,'nab',20,2),(533,7492932,7492927,'abl',20,2),(533,7492933,7492927,'ble',20,2),(533,7492934,7492927,'led',20,2),(533,7492935,7492930,'cac',33.333,1),(533,7492936,7492930,'ach',33.333,1),(533,7492937,7492930,'che',33.333,1),(533,7492938,7492935,'mod',50,2),(533,7492939,7492935,'ode',50,2),(533,7492940,7492938,'wri',14.286,2),(533,7492941,7492938,'rit',14.286,2),(533,7492942,7492938,'ite',14.286,2),(533,7492943,7492938,'tet',14.286,2),(533,7492944,7492938,'eth',14.286,2),(533,7492945,7492938,'thr',14.286,2),(533,7492946,7492938,'hru',14.286,2),(533,7492947,7492940,'ope',11.111,2),(533,7492948,7492940,'per',11.111,2),(533,7492949,7492940,'era',11.111,2),(533,7492950,7492940,'rat',11.111,2),(533,7492951,7492940,'ati',11.111,2),(533,7492952,7492940,'tio',11.111,2),(533,7492953,7492940,'ion',11.111,2),(533,7492954,7492940,'ona',11.111,2),(533,7492955,7492940,'nal',11.111,2),(533,7492956,7492947,'nor',25,1),(533,7492957,7492947,'orm',25,1),(533,7492958,7492947,'rma',25,1),(533,7492959,7492947,'mal',25,1),(533,7492960,7492956,'mes',20,1),(533,7492961,7492956,'ess',20,1),(533,7492962,7492956,'ssa',20,1),(533,7492963,7492956,'sag',20,1),(533,7492964,7492956,'age',20,1),(533,7492965,7492960,'per',11.111,1),(533,7492966,7492960,'erf',11.111,1),(533,7492967,7492960,'rfo',11.111,1),(533,7492968,7492960,'for',11.111,1),(533,7492969,7492960,'orm',11.111,1),(533,7492970,7492960,'rma',11.111,1),(533,7492971,7492960,'man',11.111,1),(533,7492972,7492960,'anc',11.111,1),(533,7492973,7492960,'nce',11.111,1),(533,7492974,7492965,'ide',12.5,1),(533,7492975,7492965,'den',12.5,1),(533,7492976,7492965,'ent',12.5,1),(533,7492977,7492965,'nti',12.5,1),(533,7492978,7492965,'tif',12.5,1),(533,7492979,7492965,'ifi',12.5,1),(533,7492980,7492965,'fie',12.5,1),(533,7492981,7492965,'ier',12.5,1),(533,7492982,7492974,'vdi',33.333,3),(533,7492983,7492974,'dis',33.333,3),(533,7492984,7492974,'isk',33.333,3),(533,7492985,7492982,'nam',50,1),(533,7492986,7492982,'ame',50,1),(533,7492987,7492985,'typ',50,1),(533,7492988,7492985,'ype',50,1),(533,7492989,7492987,'dir',25,1),(533,7492990,7492987,'ire',25,1),(533,7492991,7492987,'rec',25,1),(533,7492992,7492987,'ect',25,1),(534,7492994,7492993,'naa',100,2),(534,7492995,7492994,'600',3.333,3),(534,7492996,7492994,'000',3.333,3),(534,7492997,7492994,'00c',3.333,3),(534,7492998,7492994,'0c2',3.333,3),(534,7492999,7492994,'c29',3.333,3),(534,7493000,7492994,'296',3.333,3),(534,7493001,7492994,'968',3.333,3),(534,7493002,7492994,'683',3.333,3),(534,7493003,7492994,'839',3.333,3),(534,7493004,7492994,'39c',3.333,3),(534,7493005,7492994,'9ce',3.333,3),(534,7493006,7492994,'ce8',3.333,3),(534,7493007,7492994,'e8d',3.333,3),(534,7493008,7492994,'8de',3.333,3),(534,7493009,7492994,'de1',3.333,3),(534,7493010,7492994,'e1e',3.333,3),(534,7493011,7492994,'1e6',3.333,3),(534,7493012,7492994,'e69',3.333,3),(534,7493013,7492994,'698',3.333,3),(534,7493014,7492994,'98a',3.333,3),(534,7493015,7492994,'8a3',3.333,3),(534,7493016,7492994,'a38',3.333,3),(534,7493017,7492994,'38b',3.333,3),(534,7493018,7492994,'8b6',3.333,3),(534,7493019,7492994,'b6f',3.333,3),(534,7493020,7492994,'6fc',3.333,3),(534,7493021,7492994,'fc7',3.333,3),(534,7493022,7492994,'c71',3.333,3),(534,7493023,7492994,'717',3.333,3),(534,7493024,7492994,'173',3.333,3),(534,7493025,7492995,'mon',100,1),(534,7493026,7493025,'201',50,1),(534,7493027,7493025,'013',50,1),(534,7493028,7493026,'adm',33.333,3),(534,7493029,7493026,'dmi',33.333,3),(534,7493030,7493026,'min',33.333,3),(534,7493031,7493028,'cap',16.667,1),(534,7493032,7493028,'apa',16.667,1),(534,7493033,7493028,'pac',16.667,1),(534,7493034,7493028,'aci',16.667,1),(534,7493035,7493028,'cit',16.667,1),(534,7493036,7493028,'ity',16.667,1),(534,7493037,7493031,'pat',50,1),(534,7493038,7493031,'ath',50,1),(534,7493039,7493037,'fre',14.286,1),(534,7493040,7493037,'ree',14.286,1),(534,7493041,7493037,'ees',14.286,1),(534,7493042,7493037,'esp',14.286,1),(534,7493043,7493037,'spa',14.286,1),(534,7493044,7493037,'pac',14.286,1),(534,7493045,7493037,'ace',14.286,1),(534,7493046,7493039,'dis',50,1),(534,7493047,7493039,'isk',50,1),(534,7493048,7493046,'ind',33.333,1),(534,7493049,7493046,'nde',33.333,1),(534,7493050,7493046,'dex',33.333,1),(534,7493051,7493048,'adm',8.333,1),(534,7493052,7493048,'dmi',8.333,1),(534,7493053,7493048,'min',8.333,1),(534,7493054,7493048,'ini',8.333,1),(534,7493055,7493048,'nis',8.333,1),(534,7493056,7493048,'ist',8.333,1),(534,7493057,7493048,'str',8.333,1),(534,7493058,7493048,'tra',8.333,1),(534,7493059,7493048,'rat',8.333,1),(534,7493060,7493048,'ati',8.333,1),(534,7493061,7493048,'tio',8.333,1),(534,7493062,7493048,'ion',8.333,1),(534,7493063,7493051,'sta',33.333,3),(534,7493064,7493051,'tat',33.333,3),(534,7493065,7493051,'ate',33.333,3),(534,7493066,7493063,'ena',20,2),(534,7493067,7493063,'nab',20,2),(534,7493068,7493063,'abl',20,2),(534,7493069,7493063,'ble',20,2),(534,7493070,7493063,'led',20,2),(534,7493071,7493066,'cac',33.333,1),(534,7493072,7493066,'ach',33.333,1),(534,7493073,7493066,'che',33.333,1),(534,7493074,7493071,'mod',50,2),(534,7493075,7493071,'ode',50,2),(534,7493076,7493074,'wri',14.286,2),(534,7493077,7493074,'rit',14.286,2),(534,7493078,7493074,'ite',14.286,2),(534,7493079,7493074,'tet',14.286,2),(534,7493080,7493074,'eth',14.286,2),(534,7493081,7493074,'thr',14.286,2),(534,7493082,7493074,'hru',14.286,2),(534,7493083,7493076,'ope',11.111,2),(534,7493084,7493076,'per',11.111,2),(534,7493085,7493076,'era',11.111,2),(534,7493086,7493076,'rat',11.111,2),(534,7493087,7493076,'ati',11.111,2),(534,7493088,7493076,'tio',11.111,2),(534,7493089,7493076,'ion',11.111,2),(534,7493090,7493076,'ona',11.111,2),(534,7493091,7493076,'nal',11.111,2),(534,7493092,7493083,'nor',25,1),(534,7493093,7493083,'orm',25,1),(534,7493094,7493083,'rma',25,1),(534,7493095,7493083,'mal',25,1),(534,7493096,7493092,'mes',20,1),(534,7493097,7493092,'ess',20,1),(534,7493098,7493092,'ssa',20,1),(534,7493099,7493092,'sag',20,1),(534,7493100,7493092,'age',20,1),(534,7493101,7493096,'per',11.111,1),(534,7493102,7493096,'erf',11.111,1),(534,7493103,7493096,'rfo',11.111,1),(534,7493104,7493096,'for',11.111,1),(534,7493105,7493096,'orm',11.111,1),(534,7493106,7493096,'rma',11.111,1),(534,7493107,7493096,'man',11.111,1),(534,7493108,7493096,'anc',11.111,1),(534,7493109,7493096,'nce',11.111,1),(534,7493110,7493101,'ide',12.5,1),(534,7493111,7493101,'den',12.5,1),(534,7493112,7493101,'ent',12.5,1),(534,7493113,7493101,'nti',12.5,1),(534,7493114,7493101,'tif',12.5,1),(534,7493115,7493101,'ifi',12.5,1),(534,7493116,7493101,'fie',12.5,1),(534,7493117,7493101,'ier',12.5,1),(534,7493118,7493110,'vdi',33.333,3),(534,7493119,7493110,'dis',33.333,3),(534,7493120,7493110,'isk',33.333,3),(534,7493121,7493118,'nam',50,1),(534,7493122,7493118,'ame',50,1),(534,7493123,7493121,'typ',50,1),(534,7493124,7493121,'ype',50,1),(534,7493125,7493123,'dir',25,1),(534,7493126,7493123,'ire',25,1),(534,7493127,7493123,'rec',25,1),(534,7493128,7493123,'ect',25,1),(535,7493130,7493129,'naa',100,2),(535,7493131,7493130,'600',3.333,3),(535,7493132,7493130,'000',3.333,3),(535,7493133,7493130,'00c',3.333,3),(535,7493134,7493130,'0c2',3.333,3),(535,7493135,7493130,'c29',3.333,3),(535,7493136,7493130,'29b',3.333,3),(535,7493137,7493130,'9b1',3.333,3),(535,7493138,7493130,'b18',3.333,3),(535,7493139,7493130,'183',3.333,3),(535,7493140,7493130,'831',3.333,3),(535,7493141,7493130,'316',3.333,3),(535,7493142,7493130,'16a',3.333,3),(535,7493143,7493130,'6ab',3.333,3),(535,7493144,7493130,'ab1',3.333,3),(535,7493145,7493130,'b18',3.333,3),(535,7493146,7493130,'182',3.333,3),(535,7493147,7493130,'823',3.333,3),(535,7493148,7493130,'231',3.333,3),(535,7493149,7493130,'310',3.333,3),(535,7493150,7493130,'10d',3.333,3),(535,7493151,7493130,'0d0',3.333,3),(535,7493152,7493130,'d09',3.333,3),(535,7493153,7493130,'09e',3.333,3),(535,7493154,7493130,'9e0',3.333,3),(535,7493155,7493130,'e03',3.333,3),(535,7493156,7493130,'03d',3.333,3),(535,7493157,7493130,'3d2',3.333,3),(535,7493158,7493130,'d2b',3.333,3),(535,7493159,7493130,'2b2',3.333,3),(535,7493160,7493130,'b2a',3.333,3),(535,7493161,7493131,'mon',100,1),(535,7493162,7493161,'201',50,1),(535,7493163,7493161,'013',50,1),(535,7493164,7493162,'adm',33.333,3),(535,7493165,7493162,'dmi',33.333,3),(535,7493166,7493162,'min',33.333,3),(535,7493167,7493164,'cap',16.667,1),(535,7493168,7493164,'apa',16.667,1),(535,7493169,7493164,'pac',16.667,1),(535,7493170,7493164,'aci',16.667,1),(535,7493171,7493164,'cit',16.667,1),(535,7493172,7493164,'ity',16.667,1),(535,7493173,7493167,'pat',50,1),(535,7493174,7493167,'ath',50,1),(535,7493175,7493173,'fre',14.286,1),(535,7493176,7493173,'ree',14.286,1),(535,7493177,7493173,'ees',14.286,1),(535,7493178,7493173,'esp',14.286,1),(535,7493179,7493173,'spa',14.286,1),(535,7493180,7493173,'pac',14.286,1),(535,7493181,7493173,'ace',14.286,1),(535,7493182,7493175,'dis',50,1),(535,7493183,7493175,'isk',50,1),(535,7493184,7493182,'ind',33.333,1),(535,7493185,7493182,'nde',33.333,1),(535,7493186,7493182,'dex',33.333,1),(535,7493187,7493184,'adm',8.333,1),(535,7493188,7493184,'dmi',8.333,1),(535,7493189,7493184,'min',8.333,1),(535,7493190,7493184,'ini',8.333,1),(535,7493191,7493184,'nis',8.333,1),(535,7493192,7493184,'ist',8.333,1),(535,7493193,7493184,'str',8.333,1),(535,7493194,7493184,'tra',8.333,1),(535,7493195,7493184,'rat',8.333,1),(535,7493196,7493184,'ati',8.333,1),(535,7493197,7493184,'tio',8.333,1),(535,7493198,7493184,'ion',8.333,1),(535,7493199,7493187,'sta',33.333,3),(535,7493200,7493187,'tat',33.333,3),(535,7493201,7493187,'ate',33.333,3),(535,7493202,7493199,'ena',20,2),(535,7493203,7493199,'nab',20,2),(535,7493204,7493199,'abl',20,2),(535,7493205,7493199,'ble',20,2),(535,7493206,7493199,'led',20,2),(535,7493207,7493202,'cac',33.333,1),(535,7493208,7493202,'ach',33.333,1),(535,7493209,7493202,'che',33.333,1),(535,7493210,7493207,'mod',50,2),(535,7493211,7493207,'ode',50,2),(535,7493212,7493210,'wri',14.286,2),(535,7493213,7493210,'rit',14.286,2),(535,7493214,7493210,'ite',14.286,2),(535,7493215,7493210,'tet',14.286,2),(535,7493216,7493210,'eth',14.286,2),(535,7493217,7493210,'thr',14.286,2),(535,7493218,7493210,'hru',14.286,2),(535,7493219,7493212,'ope',11.111,2),(535,7493220,7493212,'per',11.111,2),(535,7493221,7493212,'era',11.111,2),(535,7493222,7493212,'rat',11.111,2),(535,7493223,7493212,'ati',11.111,2),(535,7493224,7493212,'tio',11.111,2),(535,7493225,7493212,'ion',11.111,2),(535,7493226,7493212,'ona',11.111,2),(535,7493227,7493212,'nal',11.111,2),(535,7493228,7493219,'nor',25,1),(535,7493229,7493219,'orm',25,1),(535,7493230,7493219,'rma',25,1),(535,7493231,7493219,'mal',25,1),(535,7493232,7493228,'mes',20,1),(535,7493233,7493228,'ess',20,1),(535,7493234,7493228,'ssa',20,1),(535,7493235,7493228,'sag',20,1),(535,7493236,7493228,'age',20,1),(535,7493237,7493232,'per',11.111,1),(535,7493238,7493232,'erf',11.111,1),(535,7493239,7493232,'rfo',11.111,1),(535,7493240,7493232,'for',11.111,1),(535,7493241,7493232,'orm',11.111,1),(535,7493242,7493232,'rma',11.111,1),(535,7493243,7493232,'man',11.111,1),(535,7493244,7493232,'anc',11.111,1),(535,7493245,7493232,'nce',11.111,1),(535,7493246,7493237,'ide',12.5,1),(535,7493247,7493237,'den',12.5,1),(535,7493248,7493237,'ent',12.5,1),(535,7493249,7493237,'nti',12.5,1),(535,7493250,7493237,'tif',12.5,1),(535,7493251,7493237,'ifi',12.5,1),(535,7493252,7493237,'fie',12.5,1),(535,7493253,7493237,'ier',12.5,1),(535,7493254,7493246,'vdi',33.333,3),(535,7493255,7493246,'dis',33.333,3),(535,7493256,7493246,'isk',33.333,3),(535,7493257,7493254,'nam',50,1),(535,7493258,7493254,'ame',50,1),(535,7493259,7493257,'typ',50,1),(535,7493260,7493257,'ype',50,1),(535,7493261,7493259,'dir',25,1),(535,7493262,7493259,'ire',25,1),(535,7493263,7493259,'rec',25,1),(535,7493264,7493259,'ect',25,1),(536,7493266,7493265,'naa',100,2),(536,7493267,7493266,'600',3.333,3),(536,7493268,7493266,'000',3.333,3),(536,7493269,7493266,'00c',3.333,3),(536,7493270,7493266,'0c2',3.333,3),(536,7493271,7493266,'c29',3.333,3),(536,7493272,7493266,'29f',3.333,3),(536,7493273,7493266,'9ff',3.333,3),(536,7493274,7493266,'ff0',3.333,3),(536,7493275,7493266,'f0e',3.333,3),(536,7493276,7493266,'0e8',3.333,3),(536,7493277,7493266,'e80',3.333,3),(536,7493278,7493266,'809',3.333,3),(536,7493279,7493266,'09d',3.333,3),(536,7493280,7493266,'9d5',3.333,3),(536,7493281,7493266,'d5b',3.333,3),(536,7493282,7493266,'5b2',3.333,3),(536,7493283,7493266,'b2a',3.333,3),(536,7493284,7493266,'2af',3.333,3),(536,7493285,7493266,'af0',3.333,3),(536,7493286,7493266,'f05',3.333,3),(536,7493287,7493266,'05c',3.333,3),(536,7493288,7493266,'5c5',3.333,3),(536,7493289,7493266,'c57',3.333,3),(536,7493290,7493266,'576',3.333,3),(536,7493291,7493266,'768',3.333,3),(536,7493292,7493266,'68c',3.333,3),(536,7493293,7493266,'8c5',3.333,3),(536,7493294,7493266,'c5c',3.333,3),(536,7493295,7493266,'5cf',3.333,3),(536,7493296,7493266,'cff',3.333,3),(536,7493297,7493267,'mon',100,1),(536,7493298,7493297,'201',50,1),(536,7493299,7493297,'013',50,1),(536,7493300,7493298,'adm',33.333,3),(536,7493301,7493298,'dmi',33.333,3),(536,7493302,7493298,'min',33.333,3),(536,7493303,7493300,'cap',16.667,1),(536,7493304,7493300,'apa',16.667,1),(536,7493305,7493300,'pac',16.667,1),(536,7493306,7493300,'aci',16.667,1),(536,7493307,7493300,'cit',16.667,1),(536,7493308,7493300,'ity',16.667,1),(536,7493309,7493303,'pat',50,1),(536,7493310,7493303,'ath',50,1),(536,7493311,7493309,'fre',14.286,1),(536,7493312,7493309,'ree',14.286,1),(536,7493313,7493309,'ees',14.286,1),(536,7493314,7493309,'esp',14.286,1),(536,7493315,7493309,'spa',14.286,1),(536,7493316,7493309,'pac',14.286,1),(536,7493317,7493309,'ace',14.286,1),(536,7493318,7493311,'dis',50,1),(536,7493319,7493311,'isk',50,1),(536,7493320,7493318,'ind',33.333,1),(536,7493321,7493318,'nde',33.333,1),(536,7493322,7493318,'dex',33.333,1),(536,7493323,7493320,'adm',8.333,1),(536,7493324,7493320,'dmi',8.333,1),(536,7493325,7493320,'min',8.333,1),(536,7493326,7493320,'ini',8.333,1),(536,7493327,7493320,'nis',8.333,1),(536,7493328,7493320,'ist',8.333,1),(536,7493329,7493320,'str',8.333,1),(536,7493330,7493320,'tra',8.333,1),(536,7493331,7493320,'rat',8.333,1),(536,7493332,7493320,'ati',8.333,1),(536,7493333,7493320,'tio',8.333,1),(536,7493334,7493320,'ion',8.333,1),(536,7493335,7493323,'sta',33.333,3),(536,7493336,7493323,'tat',33.333,3),(536,7493337,7493323,'ate',33.333,3),(536,7493338,7493335,'ena',20,2),(536,7493339,7493335,'nab',20,2),(536,7493340,7493335,'abl',20,2),(536,7493341,7493335,'ble',20,2),(536,7493342,7493335,'led',20,2),(536,7493343,7493338,'cac',33.333,1),(536,7493344,7493338,'ach',33.333,1),(536,7493345,7493338,'che',33.333,1),(536,7493346,7493343,'mod',50,2),(536,7493347,7493343,'ode',50,2),(536,7493348,7493346,'wri',14.286,2),(536,7493349,7493346,'rit',14.286,2),(536,7493350,7493346,'ite',14.286,2),(536,7493351,7493346,'tet',14.286,2),(536,7493352,7493346,'eth',14.286,2),(536,7493353,7493346,'thr',14.286,2),(536,7493354,7493346,'hru',14.286,2),(536,7493355,7493348,'ope',11.111,2),(536,7493356,7493348,'per',11.111,2),(536,7493357,7493348,'era',11.111,2),(536,7493358,7493348,'rat',11.111,2),(536,7493359,7493348,'ati',11.111,2),(536,7493360,7493348,'tio',11.111,2),(536,7493361,7493348,'ion',11.111,2),(536,7493362,7493348,'ona',11.111,2),(536,7493363,7493348,'nal',11.111,2),(536,7493364,7493355,'nor',25,1),(536,7493365,7493355,'orm',25,1),(536,7493366,7493355,'rma',25,1),(536,7493367,7493355,'mal',25,1),(536,7493368,7493364,'mes',20,1),(536,7493369,7493364,'ess',20,1),(536,7493370,7493364,'ssa',20,1),(536,7493371,7493364,'sag',20,1),(536,7493372,7493364,'age',20,1),(536,7493373,7493368,'per',11.111,1),(536,7493374,7493368,'erf',11.111,1),(536,7493375,7493368,'rfo',11.111,1),(536,7493376,7493368,'for',11.111,1),(536,7493377,7493368,'orm',11.111,1),(536,7493378,7493368,'rma',11.111,1),(536,7493379,7493368,'man',11.111,1),(536,7493380,7493368,'anc',11.111,1),(536,7493381,7493368,'nce',11.111,1),(536,7493382,7493373,'ide',12.5,1),(536,7493383,7493373,'den',12.5,1),(536,7493384,7493373,'ent',12.5,1),(536,7493385,7493373,'nti',12.5,1),(536,7493386,7493373,'tif',12.5,1),(536,7493387,7493373,'ifi',12.5,1),(536,7493388,7493373,'fie',12.5,1),(536,7493389,7493373,'ier',12.5,1),(536,7493390,7493382,'vdi',33.333,3),(536,7493391,7493382,'dis',33.333,3),(536,7493392,7493382,'isk',33.333,3),(536,7493393,7493390,'nam',50,1),(536,7493394,7493390,'ame',50,1),(536,7493395,7493393,'typ',50,1),(536,7493396,7493393,'ype',50,1),(536,7493397,7493395,'dir',25,1),(536,7493398,7493395,'ire',25,1),(536,7493399,7493395,'rec',25,1),(536,7493400,7493395,'ect',25,1),(537,7493402,7493401,'naa',100,2),(537,7493403,7493402,'600',3.333,3),(537,7493404,7493402,'000',3.333,3),(537,7493405,7493402,'00c',3.333,3),(537,7493406,7493402,'0c2',3.333,3),(537,7493407,7493402,'c29',3.333,3),(537,7493408,7493402,'299',3.333,3),(537,7493409,7493402,'997',3.333,3),(537,7493410,7493402,'97b',3.333,3),(537,7493411,7493402,'7b6',3.333,3),(537,7493412,7493402,'b69',3.333,3),(537,7493413,7493402,'696',3.333,3),(537,7493414,7493402,'962',3.333,3),(537,7493415,7493402,'62f',3.333,3),(537,7493416,7493402,'2f3',3.333,3),(537,7493417,7493402,'f32',3.333,3),(537,7493418,7493402,'32a',3.333,3),(537,7493419,7493402,'2a2',3.333,3),(537,7493420,7493402,'a26',3.333,3),(537,7493421,7493402,'26b',3.333,3),(537,7493422,7493402,'6b7',3.333,3),(537,7493423,7493402,'b73',3.333,3),(537,7493424,7493402,'73d',3.333,3),(537,7493425,7493402,'3da',3.333,3),(537,7493426,7493402,'da8',3.333,3),(537,7493427,7493402,'a8e',3.333,3),(537,7493428,7493402,'8e6',3.333,3),(537,7493429,7493402,'e61',3.333,3),(537,7493430,7493402,'611',3.333,3),(537,7493431,7493402,'111',3.333,3),(537,7493432,7493402,'119',3.333,3),(537,7493433,7493403,'mon',100,1),(537,7493434,7493433,'201',50,1),(537,7493435,7493433,'013',50,1),(537,7493436,7493434,'adm',33.333,3),(537,7493437,7493434,'dmi',33.333,3),(537,7493438,7493434,'min',33.333,3),(537,7493439,7493436,'cap',16.667,1),(537,7493440,7493436,'apa',16.667,1),(537,7493441,7493436,'pac',16.667,1),(537,7493442,7493436,'aci',16.667,1),(537,7493443,7493436,'cit',16.667,1),(537,7493444,7493436,'ity',16.667,1),(537,7493445,7493439,'pat',50,1),(537,7493446,7493439,'ath',50,1),(537,7493447,7493445,'fre',14.286,1),(537,7493448,7493445,'ree',14.286,1),(537,7493449,7493445,'ees',14.286,1),(537,7493450,7493445,'esp',14.286,1),(537,7493451,7493445,'spa',14.286,1),(537,7493452,7493445,'pac',14.286,1),(537,7493453,7493445,'ace',14.286,1),(537,7493454,7493447,'dis',50,1),(537,7493455,7493447,'isk',50,1),(537,7493456,7493454,'ind',33.333,1),(537,7493457,7493454,'nde',33.333,1),(537,7493458,7493454,'dex',33.333,1),(537,7493459,7493456,'adm',8.333,1),(537,7493460,7493456,'dmi',8.333,1),(537,7493461,7493456,'min',8.333,1),(537,7493462,7493456,'ini',8.333,1),(537,7493463,7493456,'nis',8.333,1),(537,7493464,7493456,'ist',8.333,1),(537,7493465,7493456,'str',8.333,1),(537,7493466,7493456,'tra',8.333,1),(537,7493467,7493456,'rat',8.333,1),(537,7493468,7493456,'ati',8.333,1),(537,7493469,7493456,'tio',8.333,1),(537,7493470,7493456,'ion',8.333,1),(537,7493471,7493459,'sta',33.333,3),(537,7493472,7493459,'tat',33.333,3),(537,7493473,7493459,'ate',33.333,3),(537,7493474,7493471,'ena',20,2),(537,7493475,7493471,'nab',20,2),(537,7493476,7493471,'abl',20,2),(537,7493477,7493471,'ble',20,2),(537,7493478,7493471,'led',20,2),(537,7493479,7493474,'cac',33.333,1),(537,7493480,7493474,'ach',33.333,1),(537,7493481,7493474,'che',33.333,1),(537,7493482,7493479,'mod',50,2),(537,7493483,7493479,'ode',50,2),(537,7493484,7493482,'wri',14.286,2),(537,7493485,7493482,'rit',14.286,2),(537,7493486,7493482,'ite',14.286,2),(537,7493487,7493482,'tet',14.286,2),(537,7493488,7493482,'eth',14.286,2),(537,7493489,7493482,'thr',14.286,2),(537,7493490,7493482,'hru',14.286,2),(537,7493491,7493484,'ope',11.111,2),(537,7493492,7493484,'per',11.111,2),(537,7493493,7493484,'era',11.111,2),(537,7493494,7493484,'rat',11.111,2),(537,7493495,7493484,'ati',11.111,2),(537,7493496,7493484,'tio',11.111,2),(537,7493497,7493484,'ion',11.111,2),(537,7493498,7493484,'ona',11.111,2),(537,7493499,7493484,'nal',11.111,2),(537,7493500,7493491,'nor',25,1),(537,7493501,7493491,'orm',25,1),(537,7493502,7493491,'rma',25,1),(537,7493503,7493491,'mal',25,1),(537,7493504,7493500,'mes',20,1),(537,7493505,7493500,'ess',20,1),(537,7493506,7493500,'ssa',20,1),(537,7493507,7493500,'sag',20,1),(537,7493508,7493500,'age',20,1),(537,7493509,7493504,'per',11.111,1),(537,7493510,7493504,'erf',11.111,1),(537,7493511,7493504,'rfo',11.111,1),(537,7493512,7493504,'for',11.111,1),(537,7493513,7493504,'orm',11.111,1),(537,7493514,7493504,'rma',11.111,1),(537,7493515,7493504,'man',11.111,1),(537,7493516,7493504,'anc',11.111,1),(537,7493517,7493504,'nce',11.111,1),(537,7493518,7493509,'ide',12.5,1),(537,7493519,7493509,'den',12.5,1),(537,7493520,7493509,'ent',12.5,1),(537,7493521,7493509,'nti',12.5,1),(537,7493522,7493509,'tif',12.5,1),(537,7493523,7493509,'ifi',12.5,1),(537,7493524,7493509,'fie',12.5,1),(537,7493525,7493509,'ier',12.5,1),(537,7493526,7493518,'vdi',33.333,3),(537,7493527,7493518,'dis',33.333,3),(537,7493528,7493518,'isk',33.333,3),(537,7493529,7493526,'nam',50,1),(537,7493530,7493526,'ame',50,1),(537,7493531,7493529,'typ',50,1),(537,7493532,7493529,'ype',50,1),(537,7493533,7493531,'dir',25,1),(537,7493534,7493531,'ire',25,1),(537,7493535,7493531,'rec',25,1),(537,7493536,7493531,'ect',25,1),(538,7493538,7493537,'naa',100,2),(538,7493539,7493538,'600',3.333,3),(538,7493540,7493538,'000',3.333,3),(538,7493541,7493538,'00c',3.333,3),(538,7493542,7493538,'0c2',3.333,3),(538,7493543,7493538,'c29',3.333,3),(538,7493544,7493538,'298',3.333,3),(538,7493545,7493538,'98c',3.333,3),(538,7493546,7493538,'8ce',3.333,3),(538,7493547,7493538,'ceb',3.333,3),(538,7493548,7493538,'eb3',3.333,3),(538,7493549,7493538,'b3a',3.333,3),(538,7493550,7493538,'3a9',3.333,3),(538,7493551,7493538,'a9e',3.333,3),(538,7493552,7493538,'9e5',3.333,3),(538,7493553,7493538,'e5a',3.333,3),(538,7493554,7493538,'5a4',3.333,3),(538,7493555,7493538,'a4b',3.333,3),(538,7493556,7493538,'4bd',3.333,3),(538,7493557,7493538,'bd6',3.333,3),(538,7493558,7493538,'d63',3.333,3),(538,7493559,7493538,'63b',3.333,3),(538,7493560,7493538,'3b8',3.333,3),(538,7493561,7493538,'b85',3.333,3),(538,7493562,7493538,'854',3.333,3),(538,7493563,7493538,'548',3.333,3),(538,7493564,7493538,'488',3.333,3),(538,7493565,7493538,'88b',3.333,3),(538,7493566,7493538,'8b9',3.333,3),(538,7493567,7493538,'b9e',3.333,3),(538,7493568,7493538,'9e6',3.333,3),(538,7493569,7493539,'mon',100,1),(538,7493570,7493569,'201',50,1),(538,7493571,7493569,'013',50,1),(538,7493572,7493570,'adm',33.333,3),(538,7493573,7493570,'dmi',33.333,3),(538,7493574,7493570,'min',33.333,3),(538,7493575,7493572,'cap',16.667,1),(538,7493576,7493572,'apa',16.667,1),(538,7493577,7493572,'pac',16.667,1),(538,7493578,7493572,'aci',16.667,1),(538,7493579,7493572,'cit',16.667,1),(538,7493580,7493572,'ity',16.667,1),(538,7493581,7493575,'pat',50,1),(538,7493582,7493575,'ath',50,1),(538,7493583,7493581,'fre',14.286,1),(538,7493584,7493581,'ree',14.286,1),(538,7493585,7493581,'ees',14.286,1),(538,7493586,7493581,'esp',14.286,1),(538,7493587,7493581,'spa',14.286,1),(538,7493588,7493581,'pac',14.286,1),(538,7493589,7493581,'ace',14.286,1),(538,7493590,7493583,'dis',50,1),(538,7493591,7493583,'isk',50,1),(538,7493592,7493590,'ind',33.333,1),(538,7493593,7493590,'nde',33.333,1),(538,7493594,7493590,'dex',33.333,1),(538,7493595,7493592,'adm',8.333,1),(538,7493596,7493592,'dmi',8.333,1),(538,7493597,7493592,'min',8.333,1),(538,7493598,7493592,'ini',8.333,1),(538,7493599,7493592,'nis',8.333,1),(538,7493600,7493592,'ist',8.333,1),(538,7493601,7493592,'str',8.333,1),(538,7493602,7493592,'tra',8.333,1),(538,7493603,7493592,'rat',8.333,1),(538,7493604,7493592,'ati',8.333,1),(538,7493605,7493592,'tio',8.333,1),(538,7493606,7493592,'ion',8.333,1),(538,7493607,7493595,'sta',33.333,3),(538,7493608,7493595,'tat',33.333,3),(538,7493609,7493595,'ate',33.333,3),(538,7493610,7493607,'ena',20,2),(538,7493611,7493607,'nab',20,2),(538,7493612,7493607,'abl',20,2),(538,7493613,7493607,'ble',20,2),(538,7493614,7493607,'led',20,2),(538,7493615,7493610,'cac',33.333,1),(538,7493616,7493610,'ach',33.333,1),(538,7493617,7493610,'che',33.333,1),(538,7493618,7493615,'mod',50,2),(538,7493619,7493615,'ode',50,2),(538,7493620,7493618,'wri',14.286,2),(538,7493621,7493618,'rit',14.286,2),(538,7493622,7493618,'ite',14.286,2),(538,7493623,7493618,'tet',14.286,2),(538,7493624,7493618,'eth',14.286,2),(538,7493625,7493618,'thr',14.286,2),(538,7493626,7493618,'hru',14.286,2),(538,7493627,7493620,'ope',11.111,2),(538,7493628,7493620,'per',11.111,2),(538,7493629,7493620,'era',11.111,2),(538,7493630,7493620,'rat',11.111,2),(538,7493631,7493620,'ati',11.111,2),(538,7493632,7493620,'tio',11.111,2),(538,7493633,7493620,'ion',11.111,2),(538,7493634,7493620,'ona',11.111,2),(538,7493635,7493620,'nal',11.111,2),(538,7493636,7493627,'nor',25,1),(538,7493637,7493627,'orm',25,1),(538,7493638,7493627,'rma',25,1),(538,7493639,7493627,'mal',25,1),(538,7493640,7493636,'mes',20,1),(538,7493641,7493636,'ess',20,1),(538,7493642,7493636,'ssa',20,1),(538,7493643,7493636,'sag',20,1),(538,7493644,7493636,'age',20,1),(538,7493645,7493640,'per',11.111,1),(538,7493646,7493640,'erf',11.111,1),(538,7493647,7493640,'rfo',11.111,1),(538,7493648,7493640,'for',11.111,1),(538,7493649,7493640,'orm',11.111,1),(538,7493650,7493640,'rma',11.111,1),(538,7493651,7493640,'man',11.111,1),(538,7493652,7493640,'anc',11.111,1),(538,7493653,7493640,'nce',11.111,1),(538,7493654,7493645,'ide',12.5,1),(538,7493655,7493645,'den',12.5,1),(538,7493656,7493645,'ent',12.5,1),(538,7493657,7493645,'nti',12.5,1),(538,7493658,7493645,'tif',12.5,1),(538,7493659,7493645,'ifi',12.5,1),(538,7493660,7493645,'fie',12.5,1),(538,7493661,7493645,'ier',12.5,1),(538,7493662,7493654,'vdi',33.333,3),(538,7493663,7493654,'dis',33.333,3),(538,7493664,7493654,'isk',33.333,3),(538,7493665,7493662,'nam',50,1),(538,7493666,7493662,'ame',50,1),(538,7493667,7493665,'typ',50,1),(538,7493668,7493665,'ype',50,1),(538,7493669,7493667,'dir',25,1),(538,7493670,7493667,'ire',25,1),(538,7493671,7493667,'rec',25,1),(538,7493672,7493667,'ect',25,1),(539,7493674,7493673,'naa',100,2),(539,7493675,7493674,'600',3.333,3),(539,7493676,7493674,'000',3.333,3),(539,7493677,7493674,'00c',3.333,3),(539,7493678,7493674,'0c2',3.333,3),(539,7493679,7493674,'c29',3.333,3),(539,7493680,7493674,'295',3.333,3),(539,7493681,7493674,'956',3.333,3),(539,7493682,7493674,'56b',3.333,3),(539,7493683,7493674,'6b7',3.333,3),(539,7493684,7493674,'b7d',3.333,3),(539,7493685,7493674,'7de',3.333,3),(539,7493686,7493674,'de2',3.333,3),(539,7493687,7493674,'e21',3.333,3),(539,7493688,7493674,'21f',3.333,3),(539,7493689,7493674,'1f1',3.333,3),(539,7493690,7493674,'f10',3.333,3),(539,7493691,7493674,'10d',3.333,3),(539,7493692,7493674,'0dd',3.333,3),(539,7493693,7493674,'dd9',3.333,3),(539,7493694,7493674,'d9f',3.333,3),(539,7493695,7493674,'9f2',3.333,3),(539,7493696,7493674,'f26',3.333,3),(539,7493697,7493674,'262',3.333,3),(539,7493698,7493674,'621',3.333,3),(539,7493699,7493674,'214',3.333,3),(539,7493700,7493674,'140',3.333,3),(539,7493701,7493674,'408',3.333,3),(539,7493702,7493674,'08e',3.333,3),(539,7493703,7493674,'8e5',3.333,3),(539,7493704,7493674,'e5a',3.333,3),(539,7493705,7493675,'mon',100,1),(539,7493706,7493705,'201',50,1),(539,7493707,7493705,'013',50,1),(539,7493708,7493706,'adm',33.333,3),(539,7493709,7493706,'dmi',33.333,3),(539,7493710,7493706,'min',33.333,3),(539,7493711,7493708,'cap',16.667,1),(539,7493712,7493708,'apa',16.667,1),(539,7493713,7493708,'pac',16.667,1),(539,7493714,7493708,'aci',16.667,1),(539,7493715,7493708,'cit',16.667,1),(539,7493716,7493708,'ity',16.667,1),(539,7493717,7493711,'pat',50,1),(539,7493718,7493711,'ath',50,1),(539,7493719,7493717,'fre',14.286,1),(539,7493720,7493717,'ree',14.286,1),(539,7493721,7493717,'ees',14.286,1),(539,7493722,7493717,'esp',14.286,1),(539,7493723,7493717,'spa',14.286,1),(539,7493724,7493717,'pac',14.286,1),(539,7493725,7493717,'ace',14.286,1),(539,7493726,7493719,'dis',50,1),(539,7493727,7493719,'isk',50,1),(539,7493728,7493726,'ind',33.333,1),(539,7493729,7493726,'nde',33.333,1),(539,7493730,7493726,'dex',33.333,1),(539,7493731,7493728,'adm',8.333,1),(539,7493732,7493728,'dmi',8.333,1),(539,7493733,7493728,'min',8.333,1),(539,7493734,7493728,'ini',8.333,1),(539,7493735,7493728,'nis',8.333,1),(539,7493736,7493728,'ist',8.333,1),(539,7493737,7493728,'str',8.333,1),(539,7493738,7493728,'tra',8.333,1),(539,7493739,7493728,'rat',8.333,1),(539,7493740,7493728,'ati',8.333,1),(539,7493741,7493728,'tio',8.333,1),(539,7493742,7493728,'ion',8.333,1),(539,7493743,7493731,'sta',33.333,3),(539,7493744,7493731,'tat',33.333,3),(539,7493745,7493731,'ate',33.333,3),(539,7493746,7493743,'ena',20,2),(539,7493747,7493743,'nab',20,2),(539,7493748,7493743,'abl',20,2),(539,7493749,7493743,'ble',20,2),(539,7493750,7493743,'led',20,2),(539,7493751,7493746,'cac',33.333,1),(539,7493752,7493746,'ach',33.333,1),(539,7493753,7493746,'che',33.333,1),(539,7493754,7493751,'mod',50,2),(539,7493755,7493751,'ode',50,2),(539,7493756,7493754,'wri',14.286,2),(539,7493757,7493754,'rit',14.286,2),(539,7493758,7493754,'ite',14.286,2),(539,7493759,7493754,'tet',14.286,2),(539,7493760,7493754,'eth',14.286,2),(539,7493761,7493754,'thr',14.286,2),(539,7493762,7493754,'hru',14.286,2),(539,7493763,7493756,'ope',11.111,2),(539,7493764,7493756,'per',11.111,2),(539,7493765,7493756,'era',11.111,2),(539,7493766,7493756,'rat',11.111,2),(539,7493767,7493756,'ati',11.111,2),(539,7493768,7493756,'tio',11.111,2),(539,7493769,7493756,'ion',11.111,2),(539,7493770,7493756,'ona',11.111,2),(539,7493771,7493756,'nal',11.111,2),(539,7493772,7493763,'nor',25,1),(539,7493773,7493763,'orm',25,1),(539,7493774,7493763,'rma',25,1),(539,7493775,7493763,'mal',25,1),(539,7493776,7493772,'mes',20,1),(539,7493777,7493772,'ess',20,1),(539,7493778,7493772,'ssa',20,1),(539,7493779,7493772,'sag',20,1),(539,7493780,7493772,'age',20,1),(539,7493781,7493776,'per',11.111,1),(539,7493782,7493776,'erf',11.111,1),(539,7493783,7493776,'rfo',11.111,1),(539,7493784,7493776,'for',11.111,1),(539,7493785,7493776,'orm',11.111,1),(539,7493786,7493776,'rma',11.111,1),(539,7493787,7493776,'man',11.111,1),(539,7493788,7493776,'anc',11.111,1),(539,7493789,7493776,'nce',11.111,1),(539,7493790,7493781,'ide',12.5,1),(539,7493791,7493781,'den',12.5,1),(539,7493792,7493781,'ent',12.5,1),(539,7493793,7493781,'nti',12.5,1),(539,7493794,7493781,'tif',12.5,1),(539,7493795,7493781,'ifi',12.5,1),(539,7493796,7493781,'fie',12.5,1),(539,7493797,7493781,'ier',12.5,1),(539,7493798,7493790,'vdi',33.333,3),(539,7493799,7493790,'dis',33.333,3),(539,7493800,7493790,'isk',33.333,3),(539,7493801,7493798,'nam',50,1),(539,7493802,7493798,'ame',50,1),(539,7493803,7493801,'typ',50,1),(539,7493804,7493801,'ype',50,1),(539,7493805,7493803,'dir',25,1),(539,7493806,7493803,'ire',25,1),(539,7493807,7493803,'rec',25,1),(539,7493808,7493803,'ect',25,1),(540,7493810,7493809,'naa',100,2),(540,7493811,7493810,'600',3.333,3),(540,7493812,7493810,'000',3.333,3),(540,7493813,7493810,'00c',3.333,3),(540,7493814,7493810,'0c2',3.333,3),(540,7493815,7493810,'c29',3.333,3),(540,7493816,7493810,'295',3.333,3),(540,7493817,7493810,'950',3.333,3),(540,7493818,7493810,'50d',3.333,3),(540,7493819,7493810,'0d4',3.333,3),(540,7493820,7493810,'d47',3.333,3),(540,7493821,7493810,'47c',3.333,3),(540,7493822,7493810,'7cd',3.333,3),(540,7493823,7493810,'cda',3.333,3),(540,7493824,7493810,'daa',3.333,3),(540,7493825,7493810,'aa9',3.333,3),(540,7493826,7493810,'a94',3.333,3),(540,7493827,7493810,'94a',3.333,3),(540,7493828,7493810,'4a6',3.333,3),(540,7493829,7493810,'a63',3.333,3),(540,7493830,7493810,'633',3.333,3),(540,7493831,7493810,'334',3.333,3),(540,7493832,7493810,'348',3.333,3),(540,7493833,7493810,'480',3.333,3),(540,7493834,7493810,'806',3.333,3),(540,7493835,7493810,'060',3.333,3),(540,7493836,7493810,'603',3.333,3),(540,7493837,7493810,'03d',3.333,3),(540,7493838,7493810,'3dd',3.333,3),(540,7493839,7493810,'dd7',3.333,3),(540,7493840,7493810,'d7e',3.333,3),(540,7493841,7493811,'mon',100,1),(540,7493842,7493841,'201',50,1),(540,7493843,7493841,'013',50,1),(540,7493844,7493842,'adm',33.333,3),(540,7493845,7493842,'dmi',33.333,3),(540,7493846,7493842,'min',33.333,3),(540,7493847,7493844,'cap',16.667,1),(540,7493848,7493844,'apa',16.667,1),(540,7493849,7493844,'pac',16.667,1),(540,7493850,7493844,'aci',16.667,1),(540,7493851,7493844,'cit',16.667,1),(540,7493852,7493844,'ity',16.667,1),(540,7493853,7493847,'pat',50,1),(540,7493854,7493847,'ath',50,1),(540,7493855,7493853,'fre',14.286,1),(540,7493856,7493853,'ree',14.286,1),(540,7493857,7493853,'ees',14.286,1),(540,7493858,7493853,'esp',14.286,1),(540,7493859,7493853,'spa',14.286,1),(540,7493860,7493853,'pac',14.286,1),(540,7493861,7493853,'ace',14.286,1),(540,7493862,7493855,'dis',50,1),(540,7493863,7493855,'isk',50,1),(540,7493864,7493862,'ind',33.333,1),(540,7493865,7493862,'nde',33.333,1),(540,7493866,7493862,'dex',33.333,1),(540,7493867,7493864,'adm',8.333,1),(540,7493868,7493864,'dmi',8.333,1),(540,7493869,7493864,'min',8.333,1),(540,7493870,7493864,'ini',8.333,1),(540,7493871,7493864,'nis',8.333,1),(540,7493872,7493864,'ist',8.333,1),(540,7493873,7493864,'str',8.333,1),(540,7493874,7493864,'tra',8.333,1),(540,7493875,7493864,'rat',8.333,1),(540,7493876,7493864,'ati',8.333,1),(540,7493877,7493864,'tio',8.333,1),(540,7493878,7493864,'ion',8.333,1),(540,7493879,7493867,'sta',33.333,3),(540,7493880,7493867,'tat',33.333,3),(540,7493881,7493867,'ate',33.333,3),(540,7493882,7493879,'ena',20,2),(540,7493883,7493879,'nab',20,2),(540,7493884,7493879,'abl',20,2),(540,7493885,7493879,'ble',20,2),(540,7493886,7493879,'led',20,2),(540,7493887,7493882,'cac',33.333,1),(540,7493888,7493882,'ach',33.333,1),(540,7493889,7493882,'che',33.333,1),(540,7493890,7493887,'mod',50,2),(540,7493891,7493887,'ode',50,2),(540,7493892,7493890,'wri',14.286,2),(540,7493893,7493890,'rit',14.286,2),(540,7493894,7493890,'ite',14.286,2),(540,7493895,7493890,'tet',14.286,2),(540,7493896,7493890,'eth',14.286,2),(540,7493897,7493890,'thr',14.286,2),(540,7493898,7493890,'hru',14.286,2),(540,7493899,7493892,'ope',11.111,2),(540,7493900,7493892,'per',11.111,2),(540,7493901,7493892,'era',11.111,2),(540,7493902,7493892,'rat',11.111,2),(540,7493903,7493892,'ati',11.111,2),(540,7493904,7493892,'tio',11.111,2),(540,7493905,7493892,'ion',11.111,2),(540,7493906,7493892,'ona',11.111,2),(540,7493907,7493892,'nal',11.111,2),(540,7493908,7493899,'nor',25,1),(540,7493909,7493899,'orm',25,1),(540,7493910,7493899,'rma',25,1),(540,7493911,7493899,'mal',25,1),(540,7493912,7493908,'mes',20,1),(540,7493913,7493908,'ess',20,1),(540,7493914,7493908,'ssa',20,1),(540,7493915,7493908,'sag',20,1),(540,7493916,7493908,'age',20,1),(540,7493917,7493912,'per',11.111,1),(540,7493918,7493912,'erf',11.111,1),(540,7493919,7493912,'rfo',11.111,1),(540,7493920,7493912,'for',11.111,1),(540,7493921,7493912,'orm',11.111,1),(540,7493922,7493912,'rma',11.111,1),(540,7493923,7493912,'man',11.111,1),(540,7493924,7493912,'anc',11.111,1),(540,7493925,7493912,'nce',11.111,1),(540,7493926,7493917,'ide',12.5,1),(540,7493927,7493917,'den',12.5,1),(540,7493928,7493917,'ent',12.5,1),(540,7493929,7493917,'nti',12.5,1),(540,7493930,7493917,'tif',12.5,1),(540,7493931,7493917,'ifi',12.5,1),(540,7493932,7493917,'fie',12.5,1),(540,7493933,7493917,'ier',12.5,1),(540,7493934,7493926,'vdi',33.333,3),(540,7493935,7493926,'dis',33.333,3),(540,7493936,7493926,'isk',33.333,3),(540,7493937,7493934,'nam',50,1),(540,7493938,7493934,'ame',50,1),(540,7493939,7493937,'typ',50,1),(540,7493940,7493937,'ype',50,1),(540,7493941,7493939,'dir',25,1),(540,7493942,7493939,'ire',25,1),(540,7493943,7493939,'rec',25,1),(540,7493944,7493939,'ect',25,1),(541,7493946,7493945,'naa',100,2),(541,7493947,7493946,'600',3.333,3),(541,7493948,7493946,'000',3.333,3),(541,7493949,7493946,'00c',3.333,3),(541,7493950,7493946,'0c2',3.333,3),(541,7493951,7493946,'c29',3.333,3),(541,7493952,7493946,'296',3.333,3),(541,7493953,7493946,'967',3.333,3),(541,7493954,7493946,'675',3.333,3),(541,7493955,7493946,'75d',3.333,3),(541,7493956,7493946,'5dd',3.333,3),(541,7493957,7493946,'dd7',3.333,3),(541,7493958,7493946,'d7a',3.333,3),(541,7493959,7493946,'7a7',3.333,3),(541,7493960,7493946,'a7e',3.333,3),(541,7493961,7493946,'7e9',3.333,3),(541,7493962,7493946,'e99',3.333,3),(541,7493963,7493946,'994',3.333,3),(541,7493964,7493946,'94b',3.333,3),(541,7493965,7493946,'4be',3.333,3),(541,7493966,7493946,'bee',3.333,3),(541,7493967,7493946,'eef',3.333,3),(541,7493968,7493946,'efc',3.333,3),(541,7493969,7493946,'fc8',3.333,3),(541,7493970,7493946,'c89',3.333,3),(541,7493971,7493946,'89f',3.333,3),(541,7493972,7493946,'9fb',3.333,3),(541,7493973,7493946,'fb5',3.333,3),(541,7493974,7493946,'b55',3.333,3),(541,7493975,7493946,'558',3.333,3),(541,7493976,7493946,'588',3.333,3),(541,7493977,7493947,'mon',100,1),(541,7493978,7493977,'201',50,1),(541,7493979,7493977,'013',50,1),(541,7493980,7493978,'adm',33.333,3),(541,7493981,7493978,'dmi',33.333,3),(541,7493982,7493978,'min',33.333,3),(541,7493983,7493980,'cap',16.667,1),(541,7493984,7493980,'apa',16.667,1),(541,7493985,7493980,'pac',16.667,1),(541,7493986,7493980,'aci',16.667,1),(541,7493987,7493980,'cit',16.667,1),(541,7493988,7493980,'ity',16.667,1),(541,7493989,7493983,'pat',50,1),(541,7493990,7493983,'ath',50,1),(541,7493991,7493989,'fre',14.286,1),(541,7493992,7493989,'ree',14.286,1),(541,7493993,7493989,'ees',14.286,1),(541,7493994,7493989,'esp',14.286,1),(541,7493995,7493989,'spa',14.286,1),(541,7493996,7493989,'pac',14.286,1),(541,7493997,7493989,'ace',14.286,1),(541,7493998,7493991,'dis',50,1),(541,7493999,7493991,'isk',50,1),(541,7494000,7493998,'ind',33.333,1),(541,7494001,7493998,'nde',33.333,1),(541,7494002,7493998,'dex',33.333,1),(541,7494003,7494000,'adm',8.333,1),(541,7494004,7494000,'dmi',8.333,1),(541,7494005,7494000,'min',8.333,1),(541,7494006,7494000,'ini',8.333,1),(541,7494007,7494000,'nis',8.333,1),(541,7494008,7494000,'ist',8.333,1),(541,7494009,7494000,'str',8.333,1),(541,7494010,7494000,'tra',8.333,1),(541,7494011,7494000,'rat',8.333,1),(541,7494012,7494000,'ati',8.333,1),(541,7494013,7494000,'tio',8.333,1),(541,7494014,7494000,'ion',8.333,1),(541,7494015,7494003,'sta',33.333,3),(541,7494016,7494003,'tat',33.333,3),(541,7494017,7494003,'ate',33.333,3),(541,7494018,7494015,'ena',20,2),(541,7494019,7494015,'nab',20,2),(541,7494020,7494015,'abl',20,2),(541,7494021,7494015,'ble',20,2),(541,7494022,7494015,'led',20,2),(541,7494023,7494018,'cac',33.333,1),(541,7494024,7494018,'ach',33.333,1),(541,7494025,7494018,'che',33.333,1),(541,7494026,7494023,'mod',50,2),(541,7494027,7494023,'ode',50,2),(541,7494028,7494026,'wri',14.286,2),(541,7494029,7494026,'rit',14.286,2),(541,7494030,7494026,'ite',14.286,2),(541,7494031,7494026,'tet',14.286,2),(541,7494032,7494026,'eth',14.286,2),(541,7494033,7494026,'thr',14.286,2),(541,7494034,7494026,'hru',14.286,2),(541,7494035,7494028,'ope',11.111,2),(541,7494036,7494028,'per',11.111,2),(541,7494037,7494028,'era',11.111,2),(541,7494038,7494028,'rat',11.111,2),(541,7494039,7494028,'ati',11.111,2),(541,7494040,7494028,'tio',11.111,2),(541,7494041,7494028,'ion',11.111,2),(541,7494042,7494028,'ona',11.111,2),(541,7494043,7494028,'nal',11.111,2),(541,7494044,7494035,'nor',25,1),(541,7494045,7494035,'orm',25,1),(541,7494046,7494035,'rma',25,1),(541,7494047,7494035,'mal',25,1),(541,7494048,7494044,'mes',20,1),(541,7494049,7494044,'ess',20,1),(541,7494050,7494044,'ssa',20,1),(541,7494051,7494044,'sag',20,1),(541,7494052,7494044,'age',20,1),(541,7494053,7494048,'per',11.111,1),(541,7494054,7494048,'erf',11.111,1),(541,7494055,7494048,'rfo',11.111,1),(541,7494056,7494048,'for',11.111,1),(541,7494057,7494048,'orm',11.111,1),(541,7494058,7494048,'rma',11.111,1),(541,7494059,7494048,'man',11.111,1),(541,7494060,7494048,'anc',11.111,1),(541,7494061,7494048,'nce',11.111,1),(541,7494062,7494053,'ide',12.5,1),(541,7494063,7494053,'den',12.5,1),(541,7494064,7494053,'ent',12.5,1),(541,7494065,7494053,'nti',12.5,1),(541,7494066,7494053,'tif',12.5,1),(541,7494067,7494053,'ifi',12.5,1),(541,7494068,7494053,'fie',12.5,1),(541,7494069,7494053,'ier',12.5,1),(541,7494070,7494062,'vdi',33.333,3),(541,7494071,7494062,'dis',33.333,3),(541,7494072,7494062,'isk',33.333,3),(541,7494073,7494070,'nam',50,1),(541,7494074,7494070,'ame',50,1),(541,7494075,7494073,'typ',50,1),(541,7494076,7494073,'ype',50,1),(541,7494077,7494075,'dir',25,1),(541,7494078,7494075,'ire',25,1),(541,7494079,7494075,'rec',25,1),(541,7494080,7494075,'ect',25,1),(542,7494082,7494081,'naa',100,2),(542,7494083,7494082,'600',3.333,3),(542,7494084,7494082,'000',3.333,3),(542,7494085,7494082,'00c',3.333,3),(542,7494086,7494082,'0c2',3.333,3),(542,7494087,7494082,'c29',3.333,3),(542,7494088,7494082,'29b',3.333,3),(542,7494089,7494082,'9bf',3.333,3),(542,7494090,7494082,'bf5',3.333,3),(542,7494091,7494082,'f5e',3.333,3),(542,7494092,7494082,'5e0',3.333,3),(542,7494093,7494082,'e02',3.333,3),(542,7494094,7494082,'027',3.333,3),(542,7494095,7494082,'27a',3.333,3),(542,7494096,7494082,'7a6',3.333,3),(542,7494097,7494082,'a66',3.333,3),(542,7494098,7494082,'66f',3.333,3),(542,7494099,7494082,'6f2',3.333,3),(542,7494100,7494082,'f21',3.333,3),(542,7494101,7494082,'21c',3.333,3),(542,7494102,7494082,'1c8',3.333,3),(542,7494103,7494082,'c82',3.333,3),(542,7494104,7494082,'82d',3.333,3),(542,7494105,7494082,'2dc',3.333,3),(542,7494106,7494082,'dcb',3.333,3),(542,7494107,7494082,'cb9',3.333,3),(542,7494108,7494082,'b90',3.333,3),(542,7494109,7494082,'90d',3.333,3),(542,7494110,7494082,'0d5',3.333,3),(542,7494111,7494082,'d5f',3.333,3),(542,7494112,7494082,'5f2',3.333,3),(542,7494113,7494083,'mon',100,1),(542,7494114,7494113,'201',50,1),(542,7494115,7494113,'013',50,1),(542,7494116,7494114,'adm',33.333,3),(542,7494117,7494114,'dmi',33.333,3),(542,7494118,7494114,'min',33.333,3),(542,7494119,7494116,'cap',16.667,1),(542,7494120,7494116,'apa',16.667,1),(542,7494121,7494116,'pac',16.667,1),(542,7494122,7494116,'aci',16.667,1),(542,7494123,7494116,'cit',16.667,1),(542,7494124,7494116,'ity',16.667,1),(542,7494125,7494119,'pat',50,1),(542,7494126,7494119,'ath',50,1),(542,7494127,7494125,'fre',14.286,1),(542,7494128,7494125,'ree',14.286,1),(542,7494129,7494125,'ees',14.286,1),(542,7494130,7494125,'esp',14.286,1),(542,7494131,7494125,'spa',14.286,1),(542,7494132,7494125,'pac',14.286,1),(542,7494133,7494125,'ace',14.286,1),(542,7494134,7494127,'dis',50,1),(542,7494135,7494127,'isk',50,1),(542,7494136,7494134,'ind',33.333,1),(542,7494137,7494134,'nde',33.333,1),(542,7494138,7494134,'dex',33.333,1),(542,7494139,7494136,'adm',8.333,1),(542,7494140,7494136,'dmi',8.333,1),(542,7494141,7494136,'min',8.333,1),(542,7494142,7494136,'ini',8.333,1),(542,7494143,7494136,'nis',8.333,1),(542,7494144,7494136,'ist',8.333,1),(542,7494145,7494136,'str',8.333,1),(542,7494146,7494136,'tra',8.333,1),(542,7494147,7494136,'rat',8.333,1),(542,7494148,7494136,'ati',8.333,1),(542,7494149,7494136,'tio',8.333,1),(542,7494150,7494136,'ion',8.333,1),(542,7494151,7494139,'sta',33.333,3),(542,7494152,7494139,'tat',33.333,3),(542,7494153,7494139,'ate',33.333,3),(542,7494154,7494151,'ena',20,2),(542,7494155,7494151,'nab',20,2),(542,7494156,7494151,'abl',20,2),(542,7494157,7494151,'ble',20,2),(542,7494158,7494151,'led',20,2),(542,7494159,7494154,'cac',33.333,1),(542,7494160,7494154,'ach',33.333,1),(542,7494161,7494154,'che',33.333,1),(542,7494162,7494159,'mod',50,2),(542,7494163,7494159,'ode',50,2),(542,7494164,7494162,'wri',14.286,2),(542,7494165,7494162,'rit',14.286,2),(542,7494166,7494162,'ite',14.286,2),(542,7494167,7494162,'tet',14.286,2),(542,7494168,7494162,'eth',14.286,2),(542,7494169,7494162,'thr',14.286,2),(542,7494170,7494162,'hru',14.286,2),(542,7494171,7494164,'ope',11.111,2),(542,7494172,7494164,'per',11.111,2),(542,7494173,7494164,'era',11.111,2),(542,7494174,7494164,'rat',11.111,2),(542,7494175,7494164,'ati',11.111,2),(542,7494176,7494164,'tio',11.111,2),(542,7494177,7494164,'ion',11.111,2),(542,7494178,7494164,'ona',11.111,2),(542,7494179,7494164,'nal',11.111,2),(542,7494180,7494171,'nor',25,1),(542,7494181,7494171,'orm',25,1),(542,7494182,7494171,'rma',25,1),(542,7494183,7494171,'mal',25,1),(542,7494184,7494180,'mes',20,1),(542,7494185,7494180,'ess',20,1),(542,7494186,7494180,'ssa',20,1),(542,7494187,7494180,'sag',20,1),(542,7494188,7494180,'age',20,1),(542,7494189,7494184,'per',11.111,1),(542,7494190,7494184,'erf',11.111,1),(542,7494191,7494184,'rfo',11.111,1),(542,7494192,7494184,'for',11.111,1),(542,7494193,7494184,'orm',11.111,1),(542,7494194,7494184,'rma',11.111,1),(542,7494195,7494184,'man',11.111,1),(542,7494196,7494184,'anc',11.111,1),(542,7494197,7494184,'nce',11.111,1),(542,7494198,7494189,'ide',12.5,1),(542,7494199,7494189,'den',12.5,1),(542,7494200,7494189,'ent',12.5,1),(542,7494201,7494189,'nti',12.5,1),(542,7494202,7494189,'tif',12.5,1),(542,7494203,7494189,'ifi',12.5,1),(542,7494204,7494189,'fie',12.5,1),(542,7494205,7494189,'ier',12.5,1),(542,7494206,7494198,'vdi',33.333,3),(542,7494207,7494198,'dis',33.333,3),(542,7494208,7494198,'isk',33.333,3),(542,7494209,7494206,'nam',50,1),(542,7494210,7494206,'ame',50,1),(542,7494211,7494209,'typ',50,1),(542,7494212,7494209,'ype',50,1),(542,7494213,7494211,'dir',25,1),(542,7494214,7494211,'ire',25,1),(542,7494215,7494211,'rec',25,1),(542,7494216,7494211,'ect',25,1),(543,7494218,7494217,'naa',100,2),(543,7494219,7494218,'600',3.333,3),(543,7494220,7494218,'000',3.333,3),(543,7494221,7494218,'00c',3.333,3),(543,7494222,7494218,'0c2',3.333,3),(543,7494223,7494218,'c29',3.333,3),(543,7494224,7494218,'290',3.333,3),(543,7494225,7494218,'909',3.333,3),(543,7494226,7494218,'095',3.333,3),(543,7494227,7494218,'953',3.333,3),(543,7494228,7494218,'53d',3.333,3),(543,7494229,7494218,'3db',3.333,3),(543,7494230,7494218,'dbf',3.333,3),(543,7494231,7494218,'bf4',3.333,3),(543,7494232,7494218,'f42',3.333,3),(543,7494233,7494218,'42f',3.333,3),(543,7494234,7494218,'2f2',3.333,3),(543,7494235,7494218,'f2b',3.333,3),(543,7494236,7494218,'2b9',3.333,3),(543,7494237,7494218,'b92',3.333,3),(543,7494238,7494218,'92e',3.333,3),(543,7494239,7494218,'2e4',3.333,3),(543,7494240,7494218,'e41',3.333,3),(543,7494241,7494218,'416',3.333,3),(543,7494242,7494218,'16d',3.333,3),(543,7494243,7494218,'6d9',3.333,3),(543,7494244,7494218,'d97',3.333,3),(543,7494245,7494218,'97f',3.333,3),(543,7494246,7494218,'7f3',3.333,3),(543,7494247,7494218,'f3d',3.333,3),(543,7494248,7494218,'3d6',3.333,3),(543,7494249,7494219,'mon',100,1),(543,7494250,7494249,'201',50,1),(543,7494251,7494249,'013',50,1),(543,7494252,7494250,'adm',33.333,3),(543,7494253,7494250,'dmi',33.333,3),(543,7494254,7494250,'min',33.333,3),(543,7494255,7494252,'cap',16.667,1),(543,7494256,7494252,'apa',16.667,1),(543,7494257,7494252,'pac',16.667,1),(543,7494258,7494252,'aci',16.667,1),(543,7494259,7494252,'cit',16.667,1),(543,7494260,7494252,'ity',16.667,1),(543,7494261,7494255,'pat',50,1),(543,7494262,7494255,'ath',50,1),(543,7494263,7494261,'fre',14.286,1),(543,7494264,7494261,'ree',14.286,1),(543,7494265,7494261,'ees',14.286,1),(543,7494266,7494261,'esp',14.286,1),(543,7494267,7494261,'spa',14.286,1),(543,7494268,7494261,'pac',14.286,1),(543,7494269,7494261,'ace',14.286,1),(543,7494270,7494263,'dis',50,1),(543,7494271,7494263,'isk',50,1),(543,7494272,7494270,'ind',33.333,1),(543,7494273,7494270,'nde',33.333,1),(543,7494274,7494270,'dex',33.333,1),(543,7494275,7494272,'adm',8.333,1),(543,7494276,7494272,'dmi',8.333,1),(543,7494277,7494272,'min',8.333,1),(543,7494278,7494272,'ini',8.333,1),(543,7494279,7494272,'nis',8.333,1),(543,7494280,7494272,'ist',8.333,1),(543,7494281,7494272,'str',8.333,1),(543,7494282,7494272,'tra',8.333,1),(543,7494283,7494272,'rat',8.333,1),(543,7494284,7494272,'ati',8.333,1),(543,7494285,7494272,'tio',8.333,1),(543,7494286,7494272,'ion',8.333,1),(543,7494287,7494275,'sta',33.333,3),(543,7494288,7494275,'tat',33.333,3),(543,7494289,7494275,'ate',33.333,3),(543,7494290,7494287,'ena',20,2),(543,7494291,7494287,'nab',20,2),(543,7494292,7494287,'abl',20,2),(543,7494293,7494287,'ble',20,2),(543,7494294,7494287,'led',20,2),(543,7494295,7494290,'cac',33.333,1),(543,7494296,7494290,'ach',33.333,1),(543,7494297,7494290,'che',33.333,1),(543,7494298,7494295,'mod',50,2),(543,7494299,7494295,'ode',50,2),(543,7494300,7494298,'wri',14.286,2),(543,7494301,7494298,'rit',14.286,2),(543,7494302,7494298,'ite',14.286,2),(543,7494303,7494298,'tet',14.286,2),(543,7494304,7494298,'eth',14.286,2),(543,7494305,7494298,'thr',14.286,2),(543,7494306,7494298,'hru',14.286,2),(543,7494307,7494300,'ope',11.111,2),(543,7494308,7494300,'per',11.111,2),(543,7494309,7494300,'era',11.111,2),(543,7494310,7494300,'rat',11.111,2),(543,7494311,7494300,'ati',11.111,2),(543,7494312,7494300,'tio',11.111,2),(543,7494313,7494300,'ion',11.111,2),(543,7494314,7494300,'ona',11.111,2),(543,7494315,7494300,'nal',11.111,2),(543,7494316,7494307,'nor',25,1),(543,7494317,7494307,'orm',25,1),(543,7494318,7494307,'rma',25,1),(543,7494319,7494307,'mal',25,1),(543,7494320,7494316,'mes',20,1),(543,7494321,7494316,'ess',20,1),(543,7494322,7494316,'ssa',20,1),(543,7494323,7494316,'sag',20,1),(543,7494324,7494316,'age',20,1),(543,7494325,7494320,'per',11.111,1),(543,7494326,7494320,'erf',11.111,1),(543,7494327,7494320,'rfo',11.111,1),(543,7494328,7494320,'for',11.111,1),(543,7494329,7494320,'orm',11.111,1),(543,7494330,7494320,'rma',11.111,1),(543,7494331,7494320,'man',11.111,1),(543,7494332,7494320,'anc',11.111,1),(543,7494333,7494320,'nce',11.111,1),(543,7494334,7494325,'ide',12.5,1),(543,7494335,7494325,'den',12.5,1),(543,7494336,7494325,'ent',12.5,1),(543,7494337,7494325,'nti',12.5,1),(543,7494338,7494325,'tif',12.5,1),(543,7494339,7494325,'ifi',12.5,1),(543,7494340,7494325,'fie',12.5,1),(543,7494341,7494325,'ier',12.5,1),(543,7494342,7494334,'vdi',33.333,3),(543,7494343,7494334,'dis',33.333,3),(543,7494344,7494334,'isk',33.333,3),(543,7494345,7494342,'nam',50,1),(543,7494346,7494342,'ame',50,1),(543,7494347,7494345,'typ',50,1),(543,7494348,7494345,'ype',50,1),(543,7494349,7494347,'dir',25,1),(543,7494350,7494347,'ire',25,1),(543,7494351,7494347,'rec',25,1),(543,7494352,7494347,'ect',25,1),(544,7494354,7494353,'naa',100,2),(544,7494355,7494354,'600',3.333,3),(544,7494356,7494354,'000',3.333,3),(544,7494357,7494354,'00c',3.333,3),(544,7494358,7494354,'0c2',3.333,3),(544,7494359,7494354,'c29',3.333,3),(544,7494360,7494354,'29d',3.333,3),(544,7494361,7494354,'9df',3.333,3),(544,7494362,7494354,'df6',3.333,3),(544,7494363,7494354,'f64',3.333,3),(544,7494364,7494354,'644',3.333,3),(544,7494365,7494354,'44d',3.333,3),(544,7494366,7494354,'4dc',3.333,3),(544,7494367,7494354,'dce',3.333,3),(544,7494368,7494354,'ce6',3.333,3),(544,7494369,7494354,'e63',3.333,3),(544,7494370,7494354,'63f',3.333,3),(544,7494371,7494354,'3fd',3.333,3),(544,7494372,7494354,'fd9',3.333,3),(544,7494373,7494354,'d96',3.333,3),(544,7494374,7494354,'960',3.333,3),(544,7494375,7494354,'60a',3.333,3),(544,7494376,7494354,'0a3',3.333,3),(544,7494377,7494354,'a3b',3.333,3),(544,7494378,7494354,'3bf',3.333,3),(544,7494379,7494354,'bf1',3.333,3),(544,7494380,7494354,'f12',3.333,3),(544,7494381,7494354,'12b',3.333,3),(544,7494382,7494354,'2b1',3.333,3),(544,7494383,7494354,'b1d',3.333,3),(544,7494384,7494354,'1d5',3.333,3),(544,7494385,7494355,'mon',100,1),(544,7494386,7494385,'201',50,1),(544,7494387,7494385,'013',50,1),(544,7494388,7494386,'adm',33.333,3),(544,7494389,7494386,'dmi',33.333,3),(544,7494390,7494386,'min',33.333,3),(544,7494391,7494388,'cap',16.667,1),(544,7494392,7494388,'apa',16.667,1),(544,7494393,7494388,'pac',16.667,1),(544,7494394,7494388,'aci',16.667,1),(544,7494395,7494388,'cit',16.667,1),(544,7494396,7494388,'ity',16.667,1),(544,7494397,7494391,'pat',50,1),(544,7494398,7494391,'ath',50,1),(544,7494399,7494397,'fre',14.286,1),(544,7494400,7494397,'ree',14.286,1),(544,7494401,7494397,'ees',14.286,1),(544,7494402,7494397,'esp',14.286,1),(544,7494403,7494397,'spa',14.286,1),(544,7494404,7494397,'pac',14.286,1),(544,7494405,7494397,'ace',14.286,1),(544,7494406,7494399,'dis',50,1),(544,7494407,7494399,'isk',50,1),(544,7494408,7494406,'ind',33.333,1),(544,7494409,7494406,'nde',33.333,1),(544,7494410,7494406,'dex',33.333,1),(544,7494411,7494408,'adm',8.333,1),(544,7494412,7494408,'dmi',8.333,1),(544,7494413,7494408,'min',8.333,1),(544,7494414,7494408,'ini',8.333,1),(544,7494415,7494408,'nis',8.333,1),(544,7494416,7494408,'ist',8.333,1),(544,7494417,7494408,'str',8.333,1),(544,7494418,7494408,'tra',8.333,1),(544,7494419,7494408,'rat',8.333,1),(544,7494420,7494408,'ati',8.333,1),(544,7494421,7494408,'tio',8.333,1),(544,7494422,7494408,'ion',8.333,1),(544,7494423,7494411,'sta',33.333,3),(544,7494424,7494411,'tat',33.333,3),(544,7494425,7494411,'ate',33.333,3),(544,7494426,7494423,'ena',20,2),(544,7494427,7494423,'nab',20,2),(544,7494428,7494423,'abl',20,2),(544,7494429,7494423,'ble',20,2),(544,7494430,7494423,'led',20,2),(544,7494431,7494426,'cac',33.333,1),(544,7494432,7494426,'ach',33.333,1),(544,7494433,7494426,'che',33.333,1),(544,7494434,7494431,'mod',50,2),(544,7494435,7494431,'ode',50,2),(544,7494436,7494434,'wri',14.286,2),(544,7494437,7494434,'rit',14.286,2),(544,7494438,7494434,'ite',14.286,2),(544,7494439,7494434,'tet',14.286,2),(544,7494440,7494434,'eth',14.286,2),(544,7494441,7494434,'thr',14.286,2),(544,7494442,7494434,'hru',14.286,2),(544,7494443,7494436,'ope',11.111,2),(544,7494444,7494436,'per',11.111,2),(544,7494445,7494436,'era',11.111,2),(544,7494446,7494436,'rat',11.111,2),(544,7494447,7494436,'ati',11.111,2),(544,7494448,7494436,'tio',11.111,2),(544,7494449,7494436,'ion',11.111,2),(544,7494450,7494436,'ona',11.111,2),(544,7494451,7494436,'nal',11.111,2),(544,7494452,7494443,'nor',25,1),(544,7494453,7494443,'orm',25,1),(544,7494454,7494443,'rma',25,1),(544,7494455,7494443,'mal',25,1),(544,7494456,7494452,'mes',20,1),(544,7494457,7494452,'ess',20,1),(544,7494458,7494452,'ssa',20,1),(544,7494459,7494452,'sag',20,1),(544,7494460,7494452,'age',20,1),(544,7494461,7494456,'per',11.111,1),(544,7494462,7494456,'erf',11.111,1),(544,7494463,7494456,'rfo',11.111,1),(544,7494464,7494456,'for',11.111,1),(544,7494465,7494456,'orm',11.111,1),(544,7494466,7494456,'rma',11.111,1),(544,7494467,7494456,'man',11.111,1),(544,7494468,7494456,'anc',11.111,1),(544,7494469,7494456,'nce',11.111,1),(544,7494470,7494461,'ide',12.5,1),(544,7494471,7494461,'den',12.5,1),(544,7494472,7494461,'ent',12.5,1),(544,7494473,7494461,'nti',12.5,1),(544,7494474,7494461,'tif',12.5,1),(544,7494475,7494461,'ifi',12.5,1),(544,7494476,7494461,'fie',12.5,1),(544,7494477,7494461,'ier',12.5,1),(544,7494478,7494470,'vdi',33.333,3),(544,7494479,7494470,'dis',33.333,3),(544,7494480,7494470,'isk',33.333,3),(544,7494481,7494478,'nam',50,1),(544,7494482,7494478,'ame',50,1),(544,7494483,7494481,'typ',50,1),(544,7494484,7494481,'ype',50,1),(544,7494485,7494483,'dir',25,1),(544,7494486,7494483,'ire',25,1),(544,7494487,7494483,'rec',25,1),(544,7494488,7494483,'ect',25,1),(545,7494490,7494489,'naa',100,2),(545,7494491,7494490,'600',3.333,3),(545,7494492,7494490,'000',3.333,3),(545,7494493,7494490,'00c',3.333,3),(545,7494494,7494490,'0c2',3.333,3),(545,7494495,7494490,'c29',3.333,3),(545,7494496,7494490,'294',3.333,3),(545,7494497,7494490,'94f',3.333,3),(545,7494498,7494490,'4f5',3.333,3),(545,7494499,7494490,'f5d',3.333,3),(545,7494500,7494490,'5dd',3.333,3),(545,7494501,7494490,'dd6',3.333,3),(545,7494502,7494490,'d6c',3.333,3),(545,7494503,7494490,'6c0',3.333,3),(545,7494504,7494490,'c07',3.333,3),(545,7494505,7494490,'075',3.333,3),(545,7494506,7494490,'75c',3.333,3),(545,7494507,7494490,'5c7',3.333,3),(545,7494508,7494490,'c76',3.333,3),(545,7494509,7494490,'769',3.333,3),(545,7494510,7494490,'69d',3.333,3),(545,7494511,7494490,'9db',3.333,3),(545,7494512,7494490,'db0',3.333,3),(545,7494513,7494490,'b03',3.333,3),(545,7494514,7494490,'031',3.333,3),(545,7494515,7494490,'311',3.333,3),(545,7494516,7494490,'11d',3.333,3),(545,7494517,7494490,'1d7',3.333,3),(545,7494518,7494490,'d79',3.333,3),(545,7494519,7494490,'791',3.333,3),(545,7494520,7494490,'918',3.333,3),(545,7494521,7494491,'mon',100,1),(545,7494522,7494521,'201',50,1),(545,7494523,7494521,'013',50,1),(545,7494524,7494522,'adm',33.333,3),(545,7494525,7494522,'dmi',33.333,3),(545,7494526,7494522,'min',33.333,3),(545,7494527,7494524,'cap',16.667,1),(545,7494528,7494524,'apa',16.667,1),(545,7494529,7494524,'pac',16.667,1),(545,7494530,7494524,'aci',16.667,1),(545,7494531,7494524,'cit',16.667,1),(545,7494532,7494524,'ity',16.667,1),(545,7494533,7494527,'pat',50,1),(545,7494534,7494527,'ath',50,1),(545,7494535,7494533,'fre',14.286,1),(545,7494536,7494533,'ree',14.286,1),(545,7494537,7494533,'ees',14.286,1),(545,7494538,7494533,'esp',14.286,1),(545,7494539,7494533,'spa',14.286,1),(545,7494540,7494533,'pac',14.286,1),(545,7494541,7494533,'ace',14.286,1),(545,7494542,7494535,'dis',50,1),(545,7494543,7494535,'isk',50,1),(545,7494544,7494542,'ind',33.333,1),(545,7494545,7494542,'nde',33.333,1),(545,7494546,7494542,'dex',33.333,1),(545,7494547,7494544,'adm',8.333,1),(545,7494548,7494544,'dmi',8.333,1),(545,7494549,7494544,'min',8.333,1),(545,7494550,7494544,'ini',8.333,1),(545,7494551,7494544,'nis',8.333,1),(545,7494552,7494544,'ist',8.333,1),(545,7494553,7494544,'str',8.333,1),(545,7494554,7494544,'tra',8.333,1),(545,7494555,7494544,'rat',8.333,1),(545,7494556,7494544,'ati',8.333,1),(545,7494557,7494544,'tio',8.333,1),(545,7494558,7494544,'ion',8.333,1),(545,7494559,7494547,'sta',33.333,3),(545,7494560,7494547,'tat',33.333,3),(545,7494561,7494547,'ate',33.333,3),(545,7494562,7494559,'ena',20,2),(545,7494563,7494559,'nab',20,2),(545,7494564,7494559,'abl',20,2),(545,7494565,7494559,'ble',20,2),(545,7494566,7494559,'led',20,2),(545,7494567,7494562,'cac',33.333,1),(545,7494568,7494562,'ach',33.333,1),(545,7494569,7494562,'che',33.333,1),(545,7494570,7494567,'mod',50,2),(545,7494571,7494567,'ode',50,2),(545,7494572,7494570,'wri',14.286,2),(545,7494573,7494570,'rit',14.286,2),(545,7494574,7494570,'ite',14.286,2),(545,7494575,7494570,'tet',14.286,2),(545,7494576,7494570,'eth',14.286,2),(545,7494577,7494570,'thr',14.286,2),(545,7494578,7494570,'hru',14.286,2),(545,7494579,7494572,'ope',11.111,2),(545,7494580,7494572,'per',11.111,2),(545,7494581,7494572,'era',11.111,2),(545,7494582,7494572,'rat',11.111,2),(545,7494583,7494572,'ati',11.111,2),(545,7494584,7494572,'tio',11.111,2),(545,7494585,7494572,'ion',11.111,2),(545,7494586,7494572,'ona',11.111,2),(545,7494587,7494572,'nal',11.111,2),(545,7494588,7494579,'nor',25,1),(545,7494589,7494579,'orm',25,1),(545,7494590,7494579,'rma',25,1),(545,7494591,7494579,'mal',25,1),(545,7494592,7494588,'mes',20,1),(545,7494593,7494588,'ess',20,1),(545,7494594,7494588,'ssa',20,1),(545,7494595,7494588,'sag',20,1),(545,7494596,7494588,'age',20,1),(545,7494597,7494592,'per',11.111,1),(545,7494598,7494592,'erf',11.111,1),(545,7494599,7494592,'rfo',11.111,1),(545,7494600,7494592,'for',11.111,1),(545,7494601,7494592,'orm',11.111,1),(545,7494602,7494592,'rma',11.111,1),(545,7494603,7494592,'man',11.111,1),(545,7494604,7494592,'anc',11.111,1),(545,7494605,7494592,'nce',11.111,1),(545,7494606,7494597,'ide',12.5,1),(545,7494607,7494597,'den',12.5,1),(545,7494608,7494597,'ent',12.5,1),(545,7494609,7494597,'nti',12.5,1),(545,7494610,7494597,'tif',12.5,1),(545,7494611,7494597,'ifi',12.5,1),(545,7494612,7494597,'fie',12.5,1),(545,7494613,7494597,'ier',12.5,1),(545,7494614,7494606,'vdi',33.333,3),(545,7494615,7494606,'dis',33.333,3),(545,7494616,7494606,'isk',33.333,3),(545,7494617,7494614,'nam',50,1),(545,7494618,7494614,'ame',50,1),(545,7494619,7494617,'typ',50,1),(545,7494620,7494617,'ype',50,1),(545,7494621,7494619,'dir',25,1),(545,7494622,7494619,'ire',25,1),(545,7494623,7494619,'rec',25,1),(545,7494624,7494619,'ect',25,1),(546,7494626,7494625,'naa',100,2),(546,7494627,7494626,'600',3.333,3),(546,7494628,7494626,'000',3.333,3),(546,7494629,7494626,'00c',3.333,3),(546,7494630,7494626,'0c2',3.333,3),(546,7494631,7494626,'c29',3.333,3),(546,7494632,7494626,'29e',3.333,3),(546,7494633,7494626,'9e9',3.333,3),(546,7494634,7494626,'e9e',3.333,3),(546,7494635,7494626,'9e8',3.333,3),(546,7494636,7494626,'e80',3.333,3),(546,7494637,7494626,'802',3.333,3),(546,7494638,7494626,'02f',3.333,3),(546,7494639,7494626,'2ff',3.333,3),(546,7494640,7494626,'ff9',3.333,3),(546,7494641,7494626,'f92',3.333,3),(546,7494642,7494626,'92a',3.333,3),(546,7494643,7494626,'2aa',3.333,3),(546,7494644,7494626,'aa3',3.333,3),(546,7494645,7494626,'a3e',3.333,3),(546,7494646,7494626,'3e9',3.333,3),(546,7494647,7494626,'e97',3.333,3),(546,7494648,7494626,'975',3.333,3),(546,7494649,7494626,'751',3.333,3),(546,7494650,7494626,'51b',3.333,3),(546,7494651,7494626,'1bb',3.333,3),(546,7494652,7494626,'bb1',3.333,3),(546,7494653,7494626,'b1c',3.333,3),(546,7494654,7494626,'1cc',3.333,3),(546,7494655,7494626,'ccf',3.333,3),(546,7494656,7494626,'cf8',3.333,3),(546,7494657,7494627,'mon',100,1),(546,7494658,7494657,'201',50,1),(546,7494659,7494657,'013',50,1),(546,7494660,7494658,'adm',33.333,3),(546,7494661,7494658,'dmi',33.333,3),(546,7494662,7494658,'min',33.333,3),(546,7494663,7494660,'cap',16.667,1),(546,7494664,7494660,'apa',16.667,1),(546,7494665,7494660,'pac',16.667,1),(546,7494666,7494660,'aci',16.667,1),(546,7494667,7494660,'cit',16.667,1),(546,7494668,7494660,'ity',16.667,1),(546,7494669,7494663,'pat',50,1),(546,7494670,7494663,'ath',50,1),(546,7494671,7494669,'one',100,1),(546,7494672,7494671,'fre',14.286,1),(546,7494673,7494671,'ree',14.286,1),(546,7494674,7494671,'ees',14.286,1),(546,7494675,7494671,'esp',14.286,1),(546,7494676,7494671,'spa',14.286,1),(546,7494677,7494671,'pac',14.286,1),(546,7494678,7494671,'ace',14.286,1),(546,7494679,7494672,'dis',50,1),(546,7494680,7494672,'isk',50,1),(546,7494681,7494679,'ind',33.333,1),(546,7494682,7494679,'nde',33.333,1),(546,7494683,7494679,'dex',33.333,1),(546,7494684,7494681,'adm',8.333,1),(546,7494685,7494681,'dmi',8.333,1),(546,7494686,7494681,'min',8.333,1),(546,7494687,7494681,'ini',8.333,1),(546,7494688,7494681,'nis',8.333,1),(546,7494689,7494681,'ist',8.333,1),(546,7494690,7494681,'str',8.333,1),(546,7494691,7494681,'tra',8.333,1),(546,7494692,7494681,'rat',8.333,1),(546,7494693,7494681,'ati',8.333,1),(546,7494694,7494681,'tio',8.333,1),(546,7494695,7494681,'ion',8.333,1),(546,7494696,7494684,'sta',33.333,3),(546,7494697,7494684,'tat',33.333,3),(546,7494698,7494684,'ate',33.333,3),(546,7494699,7494696,'ena',20,2),(546,7494700,7494696,'nab',20,2),(546,7494701,7494696,'abl',20,2),(546,7494702,7494696,'ble',20,2),(546,7494703,7494696,'led',20,2),(546,7494704,7494699,'cac',33.333,1),(546,7494705,7494699,'ach',33.333,1),(546,7494706,7494699,'che',33.333,1),(546,7494707,7494704,'mod',50,2),(546,7494708,7494704,'ode',50,2),(546,7494709,7494707,'wri',14.286,2),(546,7494710,7494707,'rit',14.286,2),(546,7494711,7494707,'ite',14.286,2),(546,7494712,7494707,'tet',14.286,2),(546,7494713,7494707,'eth',14.286,2),(546,7494714,7494707,'thr',14.286,2),(546,7494715,7494707,'hru',14.286,2),(546,7494716,7494709,'ope',11.111,2),(546,7494717,7494709,'per',11.111,2),(546,7494718,7494709,'era',11.111,2),(546,7494719,7494709,'rat',11.111,2),(546,7494720,7494709,'ati',11.111,2),(546,7494721,7494709,'tio',11.111,2),(546,7494722,7494709,'ion',11.111,2),(546,7494723,7494709,'ona',11.111,2),(546,7494724,7494709,'nal',11.111,2),(546,7494725,7494716,'nor',25,1),(546,7494726,7494716,'orm',25,1),(546,7494727,7494716,'rma',25,1),(546,7494728,7494716,'mal',25,1),(546,7494729,7494725,'mes',20,1),(546,7494730,7494725,'ess',20,1),(546,7494731,7494725,'ssa',20,1),(546,7494732,7494725,'sag',20,1),(546,7494733,7494725,'age',20,1),(546,7494734,7494729,'per',11.111,1),(546,7494735,7494729,'erf',11.111,1),(546,7494736,7494729,'rfo',11.111,1),(546,7494737,7494729,'for',11.111,1),(546,7494738,7494729,'orm',11.111,1),(546,7494739,7494729,'rma',11.111,1),(546,7494740,7494729,'man',11.111,1),(546,7494741,7494729,'anc',11.111,1),(546,7494742,7494729,'nce',11.111,1),(546,7494743,7494734,'ide',12.5,1),(546,7494744,7494734,'den',12.5,1),(546,7494745,7494734,'ent',12.5,1),(546,7494746,7494734,'nti',12.5,1),(546,7494747,7494734,'tif',12.5,1),(546,7494748,7494734,'ifi',12.5,1),(546,7494749,7494734,'fie',12.5,1),(546,7494750,7494734,'ier',12.5,1),(546,7494751,7494743,'vdi',33.333,3),(546,7494752,7494743,'dis',33.333,3),(546,7494753,7494743,'isk',33.333,3),(546,7494754,7494751,'nam',50,1),(546,7494755,7494751,'ame',50,1),(546,7494756,7494754,'typ',50,1),(546,7494757,7494754,'ype',50,1),(546,7494758,7494756,'dir',25,1),(546,7494759,7494756,'ire',25,1),(546,7494760,7494756,'rec',25,1),(546,7494761,7494756,'ect',25,1),(547,7494763,7494762,'naa',100,2),(547,7494764,7494763,'600',3.333,3),(547,7494765,7494763,'000',3.333,3),(547,7494766,7494763,'00c',3.333,3),(547,7494767,7494763,'0c2',3.333,3),(547,7494768,7494763,'c29',3.333,3),(547,7494769,7494763,'290',3.333,3),(547,7494770,7494763,'90d',3.333,3),(547,7494771,7494763,'0d6',3.333,3),(547,7494772,7494763,'d6a',3.333,3),(547,7494773,7494763,'6a7',3.333,3),(547,7494774,7494763,'a78',3.333,3),(547,7494775,7494763,'786',3.333,3),(547,7494776,7494763,'869',3.333,3),(547,7494777,7494763,'699',3.333,3),(547,7494778,7494763,'993',3.333,3),(547,7494779,7494763,'93a',3.333,3),(547,7494780,7494763,'3a2',3.333,3),(547,7494781,7494763,'a27',3.333,3),(547,7494782,7494763,'278',3.333,3),(547,7494783,7494763,'784',3.333,3),(547,7494784,7494763,'840',3.333,3),(547,7494785,7494763,'40b',3.333,3),(547,7494786,7494763,'0bc',3.333,3),(547,7494787,7494763,'bc7',3.333,3),(547,7494788,7494763,'c7e',3.333,3),(547,7494789,7494763,'7e7',3.333,3),(547,7494790,7494763,'e74',3.333,3),(547,7494791,7494763,'742',3.333,3),(547,7494792,7494763,'421',3.333,3),(547,7494793,7494763,'219',3.333,3),(547,7494794,7494764,'mon',100,1),(547,7494795,7494794,'201',50,1),(547,7494796,7494794,'013',50,1),(547,7494797,7494795,'adm',33.333,3),(547,7494798,7494795,'dmi',33.333,3),(547,7494799,7494795,'min',33.333,3),(547,7494800,7494797,'cap',16.667,1),(547,7494801,7494797,'apa',16.667,1),(547,7494802,7494797,'pac',16.667,1),(547,7494803,7494797,'aci',16.667,1),(547,7494804,7494797,'cit',16.667,1),(547,7494805,7494797,'ity',16.667,1),(547,7494806,7494800,'pat',50,1),(547,7494807,7494800,'ath',50,1),(547,7494808,7494806,'thr',33.333,1),(547,7494809,7494806,'hre',33.333,1),(547,7494810,7494806,'ree',33.333,1),(547,7494811,7494808,'fre',14.286,1),(547,7494812,7494808,'ree',14.286,1),(547,7494813,7494808,'ees',14.286,1),(547,7494814,7494808,'esp',14.286,1),(547,7494815,7494808,'spa',14.286,1),(547,7494816,7494808,'pac',14.286,1),(547,7494817,7494808,'ace',14.286,1),(547,7494818,7494811,'dis',50,1),(547,7494819,7494811,'isk',50,1),(547,7494820,7494818,'ind',33.333,1),(547,7494821,7494818,'nde',33.333,1),(547,7494822,7494818,'dex',33.333,1),(547,7494823,7494820,'adm',8.333,1),(547,7494824,7494820,'dmi',8.333,1),(547,7494825,7494820,'min',8.333,1),(547,7494826,7494820,'ini',8.333,1),(547,7494827,7494820,'nis',8.333,1),(547,7494828,7494820,'ist',8.333,1),(547,7494829,7494820,'str',8.333,1),(547,7494830,7494820,'tra',8.333,1),(547,7494831,7494820,'rat',8.333,1),(547,7494832,7494820,'ati',8.333,1),(547,7494833,7494820,'tio',8.333,1),(547,7494834,7494820,'ion',8.333,1),(547,7494835,7494823,'sta',33.333,3),(547,7494836,7494823,'tat',33.333,3),(547,7494837,7494823,'ate',33.333,3),(547,7494838,7494835,'ena',20,2),(547,7494839,7494835,'nab',20,2),(547,7494840,7494835,'abl',20,2),(547,7494841,7494835,'ble',20,2),(547,7494842,7494835,'led',20,2),(547,7494843,7494838,'cac',33.333,1),(547,7494844,7494838,'ach',33.333,1),(547,7494845,7494838,'che',33.333,1),(547,7494846,7494843,'mod',50,2),(547,7494847,7494843,'ode',50,2),(547,7494848,7494846,'wri',14.286,2),(547,7494849,7494846,'rit',14.286,2),(547,7494850,7494846,'ite',14.286,2),(547,7494851,7494846,'tet',14.286,2),(547,7494852,7494846,'eth',14.286,2),(547,7494853,7494846,'thr',14.286,2),(547,7494854,7494846,'hru',14.286,2),(547,7494855,7494848,'ope',11.111,2),(547,7494856,7494848,'per',11.111,2),(547,7494857,7494848,'era',11.111,2),(547,7494858,7494848,'rat',11.111,2),(547,7494859,7494848,'ati',11.111,2),(547,7494860,7494848,'tio',11.111,2),(547,7494861,7494848,'ion',11.111,2),(547,7494862,7494848,'ona',11.111,2),(547,7494863,7494848,'nal',11.111,2),(547,7494864,7494855,'nor',25,1),(547,7494865,7494855,'orm',25,1),(547,7494866,7494855,'rma',25,1),(547,7494867,7494855,'mal',25,1),(547,7494868,7494864,'mes',20,1),(547,7494869,7494864,'ess',20,1),(547,7494870,7494864,'ssa',20,1),(547,7494871,7494864,'sag',20,1),(547,7494872,7494864,'age',20,1),(547,7494873,7494868,'per',11.111,1),(547,7494874,7494868,'erf',11.111,1),(547,7494875,7494868,'rfo',11.111,1),(547,7494876,7494868,'for',11.111,1),(547,7494877,7494868,'orm',11.111,1),(547,7494878,7494868,'rma',11.111,1),(547,7494879,7494868,'man',11.111,1),(547,7494880,7494868,'anc',11.111,1),(547,7494881,7494868,'nce',11.111,1),(547,7494882,7494873,'ide',12.5,1),(547,7494883,7494873,'den',12.5,1),(547,7494884,7494873,'ent',12.5,1),(547,7494885,7494873,'nti',12.5,1),(547,7494886,7494873,'tif',12.5,1),(547,7494887,7494873,'ifi',12.5,1),(547,7494888,7494873,'fie',12.5,1),(547,7494889,7494873,'ier',12.5,1),(547,7494890,7494882,'vdi',33.333,3),(547,7494891,7494882,'dis',33.333,3),(547,7494892,7494882,'isk',33.333,3),(547,7494893,7494890,'nam',50,1),(547,7494894,7494890,'ame',50,1),(547,7494895,7494893,'typ',50,1),(547,7494896,7494893,'ype',50,1),(547,7494897,7494895,'dir',25,1),(547,7494898,7494895,'ire',25,1),(547,7494899,7494895,'rec',25,1),(547,7494900,7494895,'ect',25,1),(548,7494902,7494901,'naa',100,2),(548,7494903,7494902,'600',3.333,3),(548,7494904,7494902,'000',3.333,3),(548,7494905,7494902,'00c',3.333,3),(548,7494906,7494902,'0c2',3.333,3),(548,7494907,7494902,'c29',3.333,3),(548,7494908,7494902,'292',3.333,3),(548,7494909,7494902,'92f',3.333,3),(548,7494910,7494902,'2f6',3.333,3),(548,7494911,7494902,'f66',3.333,3),(548,7494912,7494902,'663',3.333,3),(548,7494913,7494902,'633',3.333,3),(548,7494914,7494902,'33b',3.333,3),(548,7494915,7494902,'3bc',3.333,3),(548,7494916,7494902,'bcf',3.333,3),(548,7494917,7494902,'cff',3.333,3),(548,7494918,7494902,'ff2',3.333,3),(548,7494919,7494902,'f21',3.333,3),(548,7494920,7494902,'218',3.333,3),(548,7494921,7494902,'180',3.333,3),(548,7494922,7494902,'80b',3.333,3),(548,7494923,7494902,'0b7',3.333,3),(548,7494924,7494902,'b75',3.333,3),(548,7494925,7494902,'752',3.333,3),(548,7494926,7494902,'520',3.333,3),(548,7494927,7494902,'206',3.333,3),(548,7494928,7494902,'06f',3.333,3),(548,7494929,7494902,'6f0',3.333,3),(548,7494930,7494902,'f06',3.333,3),(548,7494931,7494902,'066',3.333,3),(548,7494932,7494902,'661',3.333,3),(548,7494933,7494903,'mon',100,1),(548,7494934,7494933,'201',50,1),(548,7494935,7494933,'013',50,1),(548,7494936,7494934,'adm',33.333,3),(548,7494937,7494934,'dmi',33.333,3),(548,7494938,7494934,'min',33.333,3),(548,7494939,7494936,'cap',16.667,1),(548,7494940,7494936,'apa',16.667,1),(548,7494941,7494936,'pac',16.667,1),(548,7494942,7494936,'aci',16.667,1),(548,7494943,7494936,'cit',16.667,1),(548,7494944,7494936,'ity',16.667,1),(548,7494945,7494939,'pat',50,1),(548,7494946,7494939,'ath',50,1),(548,7494947,7494945,'fou',50,1),(548,7494948,7494945,'our',50,1),(548,7494949,7494947,'fre',14.286,1),(548,7494950,7494947,'ree',14.286,1),(548,7494951,7494947,'ees',14.286,1),(548,7494952,7494947,'esp',14.286,1),(548,7494953,7494947,'spa',14.286,1),(548,7494954,7494947,'pac',14.286,1),(548,7494955,7494947,'ace',14.286,1),(548,7494956,7494949,'dis',50,1),(548,7494957,7494949,'isk',50,1),(548,7494958,7494956,'ind',33.333,1),(548,7494959,7494956,'nde',33.333,1),(548,7494960,7494956,'dex',33.333,1),(548,7494961,7494958,'adm',8.333,1),(548,7494962,7494958,'dmi',8.333,1),(548,7494963,7494958,'min',8.333,1),(548,7494964,7494958,'ini',8.333,1),(548,7494965,7494958,'nis',8.333,1),(548,7494966,7494958,'ist',8.333,1),(548,7494967,7494958,'str',8.333,1),(548,7494968,7494958,'tra',8.333,1),(548,7494969,7494958,'rat',8.333,1),(548,7494970,7494958,'ati',8.333,1),(548,7494971,7494958,'tio',8.333,1),(548,7494972,7494958,'ion',8.333,1),(548,7494973,7494961,'sta',33.333,3),(548,7494974,7494961,'tat',33.333,3),(548,7494975,7494961,'ate',33.333,3),(548,7494976,7494973,'ena',20,2),(548,7494977,7494973,'nab',20,2),(548,7494978,7494973,'abl',20,2),(548,7494979,7494973,'ble',20,2),(548,7494980,7494973,'led',20,2),(548,7494981,7494976,'cac',33.333,1),(548,7494982,7494976,'ach',33.333,1),(548,7494983,7494976,'che',33.333,1),(548,7494984,7494981,'mod',50,2),(548,7494985,7494981,'ode',50,2),(548,7494986,7494984,'wri',14.286,2),(548,7494987,7494984,'rit',14.286,2),(548,7494988,7494984,'ite',14.286,2),(548,7494989,7494984,'tet',14.286,2),(548,7494990,7494984,'eth',14.286,2),(548,7494991,7494984,'thr',14.286,2),(548,7494992,7494984,'hru',14.286,2),(548,7494993,7494986,'ope',11.111,2),(548,7494994,7494986,'per',11.111,2),(548,7494995,7494986,'era',11.111,2),(548,7494996,7494986,'rat',11.111,2),(548,7494997,7494986,'ati',11.111,2),(548,7494998,7494986,'tio',11.111,2),(548,7494999,7494986,'ion',11.111,2),(548,7495000,7494986,'ona',11.111,2),(548,7495001,7494986,'nal',11.111,2),(548,7495002,7494993,'nor',25,1),(548,7495003,7494993,'orm',25,1),(548,7495004,7494993,'rma',25,1),(548,7495005,7494993,'mal',25,1),(548,7495006,7495002,'mes',20,1),(548,7495007,7495002,'ess',20,1),(548,7495008,7495002,'ssa',20,1),(548,7495009,7495002,'sag',20,1),(548,7495010,7495002,'age',20,1),(548,7495011,7495006,'per',11.111,1),(548,7495012,7495006,'erf',11.111,1),(548,7495013,7495006,'rfo',11.111,1),(548,7495014,7495006,'for',11.111,1),(548,7495015,7495006,'orm',11.111,1),(548,7495016,7495006,'rma',11.111,1),(548,7495017,7495006,'man',11.111,1),(548,7495018,7495006,'anc',11.111,1),(548,7495019,7495006,'nce',11.111,1),(548,7495020,7495011,'ide',12.5,1),(548,7495021,7495011,'den',12.5,1),(548,7495022,7495011,'ent',12.5,1),(548,7495023,7495011,'nti',12.5,1),(548,7495024,7495011,'tif',12.5,1),(548,7495025,7495011,'ifi',12.5,1),(548,7495026,7495011,'fie',12.5,1),(548,7495027,7495011,'ier',12.5,1),(548,7495028,7495020,'vdi',33.333,3),(548,7495029,7495020,'dis',33.333,3),(548,7495030,7495020,'isk',33.333,3),(548,7495031,7495028,'nam',50,1),(548,7495032,7495028,'ame',50,1),(548,7495033,7495031,'typ',50,1),(548,7495034,7495031,'ype',50,1),(548,7495035,7495033,'dir',25,1),(548,7495036,7495033,'ire',25,1),(548,7495037,7495033,'rec',25,1),(548,7495038,7495033,'ect',25,1),(549,7495040,7495039,'naa',100,2),(549,7495041,7495040,'600',3.333,3),(549,7495042,7495040,'000',3.333,3),(549,7495043,7495040,'00c',3.333,3),(549,7495044,7495040,'0c2',3.333,3),(549,7495045,7495040,'c29',3.333,3),(549,7495046,7495040,'296',3.333,3),(549,7495047,7495040,'961',3.333,3),(549,7495048,7495040,'61e',3.333,3),(549,7495049,7495040,'1e7',3.333,3),(549,7495050,7495040,'e79',3.333,3),(549,7495051,7495040,'793',3.333,3),(549,7495052,7495040,'93f',3.333,3),(549,7495053,7495040,'3fe',3.333,3),(549,7495054,7495040,'feb',3.333,3),(549,7495055,7495040,'ebf',3.333,3),(549,7495056,7495040,'bff',3.333,3),(549,7495057,7495040,'ff8',3.333,3),(549,7495058,7495040,'f84',3.333,3),(549,7495059,7495040,'84f',3.333,3),(549,7495060,7495040,'4f5',3.333,3),(549,7495061,7495040,'f5c',3.333,3),(549,7495062,7495040,'5ce',3.333,3),(549,7495063,7495040,'ced',3.333,3),(549,7495064,7495040,'ed5',3.333,3),(549,7495065,7495040,'d5c',3.333,3),(549,7495066,7495040,'5c5',3.333,3),(549,7495067,7495040,'c58',3.333,3),(549,7495068,7495040,'58b',3.333,3),(549,7495069,7495040,'8b2',3.333,3),(549,7495070,7495040,'b21',3.333,3),(549,7495071,7495041,'mon',100,1),(549,7495072,7495071,'201',50,1),(549,7495073,7495071,'013',50,1),(549,7495074,7495072,'adm',33.333,3),(549,7495075,7495072,'dmi',33.333,3),(549,7495076,7495072,'min',33.333,3),(549,7495077,7495074,'cap',16.667,1),(549,7495078,7495074,'apa',16.667,1),(549,7495079,7495074,'pac',16.667,1),(549,7495080,7495074,'aci',16.667,1),(549,7495081,7495074,'cit',16.667,1),(549,7495082,7495074,'ity',16.667,1),(549,7495083,7495077,'pat',50,1),(549,7495084,7495077,'ath',50,1),(549,7495085,7495083,'fiv',50,1),(549,7495086,7495083,'ive',50,1),(549,7495087,7495085,'fre',14.286,1),(549,7495088,7495085,'ree',14.286,1),(549,7495089,7495085,'ees',14.286,1),(549,7495090,7495085,'esp',14.286,1),(549,7495091,7495085,'spa',14.286,1),(549,7495092,7495085,'pac',14.286,1),(549,7495093,7495085,'ace',14.286,1),(549,7495094,7495087,'dis',50,1),(549,7495095,7495087,'isk',50,1),(549,7495096,7495094,'ind',33.333,1),(549,7495097,7495094,'nde',33.333,1),(549,7495098,7495094,'dex',33.333,1),(549,7495099,7495096,'adm',8.333,1),(549,7495100,7495096,'dmi',8.333,1),(549,7495101,7495096,'min',8.333,1),(549,7495102,7495096,'ini',8.333,1),(549,7495103,7495096,'nis',8.333,1),(549,7495104,7495096,'ist',8.333,1),(549,7495105,7495096,'str',8.333,1),(549,7495106,7495096,'tra',8.333,1),(549,7495107,7495096,'rat',8.333,1),(549,7495108,7495096,'ati',8.333,1),(549,7495109,7495096,'tio',8.333,1),(549,7495110,7495096,'ion',8.333,1),(549,7495111,7495099,'sta',33.333,3),(549,7495112,7495099,'tat',33.333,3),(549,7495113,7495099,'ate',33.333,3),(549,7495114,7495111,'ena',20,2),(549,7495115,7495111,'nab',20,2),(549,7495116,7495111,'abl',20,2),(549,7495117,7495111,'ble',20,2),(549,7495118,7495111,'led',20,2),(549,7495119,7495114,'cac',33.333,1),(549,7495120,7495114,'ach',33.333,1),(549,7495121,7495114,'che',33.333,1),(549,7495122,7495119,'mod',50,2),(549,7495123,7495119,'ode',50,2),(549,7495124,7495122,'wri',14.286,2),(549,7495125,7495122,'rit',14.286,2),(549,7495126,7495122,'ite',14.286,2),(549,7495127,7495122,'tet',14.286,2),(549,7495128,7495122,'eth',14.286,2),(549,7495129,7495122,'thr',14.286,2),(549,7495130,7495122,'hru',14.286,2),(549,7495131,7495124,'ope',11.111,2),(549,7495132,7495124,'per',11.111,2),(549,7495133,7495124,'era',11.111,2),(549,7495134,7495124,'rat',11.111,2),(549,7495135,7495124,'ati',11.111,2),(549,7495136,7495124,'tio',11.111,2),(549,7495137,7495124,'ion',11.111,2),(549,7495138,7495124,'ona',11.111,2),(549,7495139,7495124,'nal',11.111,2),(549,7495140,7495131,'nor',25,1),(549,7495141,7495131,'orm',25,1),(549,7495142,7495131,'rma',25,1),(549,7495143,7495131,'mal',25,1),(549,7495144,7495140,'mes',20,1),(549,7495145,7495140,'ess',20,1),(549,7495146,7495140,'ssa',20,1),(549,7495147,7495140,'sag',20,1),(549,7495148,7495140,'age',20,1),(549,7495149,7495144,'per',11.111,1),(549,7495150,7495144,'erf',11.111,1),(549,7495151,7495144,'rfo',11.111,1),(549,7495152,7495144,'for',11.111,1),(549,7495153,7495144,'orm',11.111,1),(549,7495154,7495144,'rma',11.111,1),(549,7495155,7495144,'man',11.111,1),(549,7495156,7495144,'anc',11.111,1),(549,7495157,7495144,'nce',11.111,1),(549,7495158,7495149,'ide',12.5,1),(549,7495159,7495149,'den',12.5,1),(549,7495160,7495149,'ent',12.5,1),(549,7495161,7495149,'nti',12.5,1),(549,7495162,7495149,'tif',12.5,1),(549,7495163,7495149,'ifi',12.5,1),(549,7495164,7495149,'fie',12.5,1),(549,7495165,7495149,'ier',12.5,1),(549,7495166,7495158,'vdi',33.333,3),(549,7495167,7495158,'dis',33.333,3),(549,7495168,7495158,'isk',33.333,3),(549,7495169,7495166,'nam',50,1),(549,7495170,7495166,'ame',50,1),(549,7495171,7495169,'typ',50,1),(549,7495172,7495169,'ype',50,1),(549,7495173,7495171,'dir',25,1),(549,7495174,7495171,'ire',25,1),(549,7495175,7495171,'rec',25,1),(549,7495176,7495171,'ect',25,1),(550,7495178,7495177,'naa',100,2),(550,7495179,7495178,'600',3.333,3),(550,7495180,7495178,'000',3.333,3),(550,7495181,7495178,'00c',3.333,3),(550,7495182,7495178,'0c2',3.333,3),(550,7495183,7495178,'c29',3.333,3),(550,7495184,7495178,'29b',3.333,3),(550,7495185,7495178,'9bc',3.333,3),(550,7495186,7495178,'bc4',3.333,3),(550,7495187,7495178,'c48',3.333,3),(550,7495188,7495178,'48a',3.333,3),(550,7495189,7495178,'8a1',3.333,3),(550,7495190,7495178,'a17',3.333,3),(550,7495191,7495178,'170',3.333,3),(550,7495192,7495178,'708',3.333,3),(550,7495193,7495178,'080',3.333,3),(550,7495194,7495178,'800',3.333,3),(550,7495195,7495178,'006',3.333,3),(550,7495196,7495178,'060',3.333,3),(550,7495197,7495178,'60b',3.333,3),(550,7495198,7495178,'0b2',3.333,3),(550,7495199,7495178,'b2a',3.333,3),(550,7495200,7495178,'2a7',3.333,3),(550,7495201,7495178,'a7a',3.333,3),(550,7495202,7495178,'7a0',3.333,3),(550,7495203,7495178,'a04',3.333,3),(550,7495204,7495178,'040',3.333,3),(550,7495205,7495178,'400',3.333,3),(550,7495206,7495178,'002',3.333,3),(550,7495207,7495178,'02f',3.333,3),(550,7495208,7495178,'2fc',3.333,3),(550,7495209,7495179,'mon',100,1),(550,7495210,7495209,'201',50,1),(550,7495211,7495209,'013',50,1),(550,7495212,7495210,'adm',33.333,3),(550,7495213,7495210,'dmi',33.333,3),(550,7495214,7495210,'min',33.333,3),(550,7495215,7495212,'cap',16.667,1),(550,7495216,7495212,'apa',16.667,1),(550,7495217,7495212,'pac',16.667,1),(550,7495218,7495212,'aci',16.667,1),(550,7495219,7495212,'cit',16.667,1),(550,7495220,7495212,'ity',16.667,1),(550,7495221,7495215,'pat',50,1),(550,7495222,7495215,'ath',50,1),(550,7495223,7495221,'six',100,1),(550,7495224,7495223,'fre',14.286,1),(550,7495225,7495223,'ree',14.286,1),(550,7495226,7495223,'ees',14.286,1),(550,7495227,7495223,'esp',14.286,1),(550,7495228,7495223,'spa',14.286,1),(550,7495229,7495223,'pac',14.286,1),(550,7495230,7495223,'ace',14.286,1),(550,7495231,7495224,'dis',50,1),(550,7495232,7495224,'isk',50,1),(550,7495233,7495231,'ind',33.333,1),(550,7495234,7495231,'nde',33.333,1),(550,7495235,7495231,'dex',33.333,1),(550,7495236,7495233,'adm',8.333,1),(550,7495237,7495233,'dmi',8.333,1),(550,7495238,7495233,'min',8.333,1),(550,7495239,7495233,'ini',8.333,1),(550,7495240,7495233,'nis',8.333,1),(550,7495241,7495233,'ist',8.333,1),(550,7495242,7495233,'str',8.333,1),(550,7495243,7495233,'tra',8.333,1),(550,7495244,7495233,'rat',8.333,1),(550,7495245,7495233,'ati',8.333,1),(550,7495246,7495233,'tio',8.333,1),(550,7495247,7495233,'ion',8.333,1),(550,7495248,7495236,'sta',33.333,3),(550,7495249,7495236,'tat',33.333,3),(550,7495250,7495236,'ate',33.333,3),(550,7495251,7495248,'ena',20,2),(550,7495252,7495248,'nab',20,2),(550,7495253,7495248,'abl',20,2),(550,7495254,7495248,'ble',20,2),(550,7495255,7495248,'led',20,2),(550,7495256,7495251,'cac',33.333,1),(550,7495257,7495251,'ach',33.333,1),(550,7495258,7495251,'che',33.333,1),(550,7495259,7495256,'mod',50,2),(550,7495260,7495256,'ode',50,2),(550,7495261,7495259,'wri',14.286,2),(550,7495262,7495259,'rit',14.286,2),(550,7495263,7495259,'ite',14.286,2),(550,7495264,7495259,'tet',14.286,2),(550,7495265,7495259,'eth',14.286,2),(550,7495266,7495259,'thr',14.286,2),(550,7495267,7495259,'hru',14.286,2),(550,7495268,7495261,'ope',11.111,2),(550,7495269,7495261,'per',11.111,2),(550,7495270,7495261,'era',11.111,2),(550,7495271,7495261,'rat',11.111,2),(550,7495272,7495261,'ati',11.111,2),(550,7495273,7495261,'tio',11.111,2),(550,7495274,7495261,'ion',11.111,2),(550,7495275,7495261,'ona',11.111,2),(550,7495276,7495261,'nal',11.111,2),(550,7495277,7495268,'nor',25,1),(550,7495278,7495268,'orm',25,1),(550,7495279,7495268,'rma',25,1),(550,7495280,7495268,'mal',25,1),(550,7495281,7495277,'mes',20,1),(550,7495282,7495277,'ess',20,1),(550,7495283,7495277,'ssa',20,1),(550,7495284,7495277,'sag',20,1),(550,7495285,7495277,'age',20,1),(550,7495286,7495281,'per',11.111,1),(550,7495287,7495281,'erf',11.111,1),(550,7495288,7495281,'rfo',11.111,1),(550,7495289,7495281,'for',11.111,1),(550,7495290,7495281,'orm',11.111,1),(550,7495291,7495281,'rma',11.111,1),(550,7495292,7495281,'man',11.111,1),(550,7495293,7495281,'anc',11.111,1),(550,7495294,7495281,'nce',11.111,1),(550,7495295,7495286,'ide',12.5,1),(550,7495296,7495286,'den',12.5,1),(550,7495297,7495286,'ent',12.5,1),(550,7495298,7495286,'nti',12.5,1),(550,7495299,7495286,'tif',12.5,1),(550,7495300,7495286,'ifi',12.5,1),(550,7495301,7495286,'fie',12.5,1),(550,7495302,7495286,'ier',12.5,1),(550,7495303,7495295,'vdi',33.333,3),(550,7495304,7495295,'dis',33.333,3),(550,7495305,7495295,'isk',33.333,3),(550,7495306,7495303,'nam',50,1),(550,7495307,7495303,'ame',50,1),(550,7495308,7495306,'typ',50,1),(550,7495309,7495306,'ype',50,1),(550,7495310,7495308,'dir',25,1),(550,7495311,7495308,'ire',25,1),(550,7495312,7495308,'rec',25,1),(550,7495313,7495308,'ect',25,1),(551,7495315,7495314,'naa',100,2),(551,7495316,7495315,'600',3.333,3),(551,7495317,7495315,'000',3.333,3),(551,7495318,7495315,'00c',3.333,3),(551,7495319,7495315,'0c2',3.333,3),(551,7495320,7495315,'c29',3.333,3),(551,7495321,7495315,'291',3.333,3),(551,7495322,7495315,'912',3.333,3),(551,7495323,7495315,'121',3.333,3),(551,7495324,7495315,'21e',3.333,3),(551,7495325,7495315,'1e6',3.333,3),(551,7495326,7495315,'e66',3.333,3),(551,7495327,7495315,'66c',3.333,3),(551,7495328,7495315,'6c0',3.333,3),(551,7495329,7495315,'c0d',3.333,3),(551,7495330,7495315,'0d7',3.333,3),(551,7495331,7495315,'d79',3.333,3),(551,7495332,7495315,'79b',3.333,3),(551,7495333,7495315,'9b6',3.333,3),(551,7495334,7495315,'b62',3.333,3),(551,7495335,7495315,'623',3.333,3),(551,7495336,7495315,'23d',3.333,3),(551,7495337,7495315,'3de',3.333,3),(551,7495338,7495315,'de3',3.333,3),(551,7495339,7495315,'e30',3.333,3),(551,7495340,7495315,'305',3.333,3),(551,7495341,7495315,'052',3.333,3),(551,7495342,7495315,'52d',3.333,3),(551,7495343,7495315,'2d4',3.333,3),(551,7495344,7495315,'d40',3.333,3),(551,7495345,7495315,'405',3.333,3),(551,7495346,7495316,'mon',100,1),(551,7495347,7495346,'201',50,1),(551,7495348,7495346,'013',50,1),(551,7495349,7495347,'adm',33.333,3),(551,7495350,7495347,'dmi',33.333,3),(551,7495351,7495347,'min',33.333,3),(551,7495352,7495349,'cap',16.667,1),(551,7495353,7495349,'apa',16.667,1),(551,7495354,7495349,'pac',16.667,1),(551,7495355,7495349,'aci',16.667,1),(551,7495356,7495349,'cit',16.667,1),(551,7495357,7495349,'ity',16.667,1),(551,7495358,7495352,'pat',50,1),(551,7495359,7495352,'ath',50,1),(551,7495360,7495358,'sev',33.333,1),(551,7495361,7495358,'eve',33.333,1),(551,7495362,7495358,'ven',33.333,1),(551,7495363,7495360,'fre',14.286,1),(551,7495364,7495360,'ree',14.286,1),(551,7495365,7495360,'ees',14.286,1),(551,7495366,7495360,'esp',14.286,1),(551,7495367,7495360,'spa',14.286,1),(551,7495368,7495360,'pac',14.286,1),(551,7495369,7495360,'ace',14.286,1),(551,7495370,7495363,'dis',50,1),(551,7495371,7495363,'isk',50,1),(551,7495372,7495370,'ind',33.333,1),(551,7495373,7495370,'nde',33.333,1),(551,7495374,7495370,'dex',33.333,1),(551,7495375,7495372,'adm',8.333,1),(551,7495376,7495372,'dmi',8.333,1),(551,7495377,7495372,'min',8.333,1),(551,7495378,7495372,'ini',8.333,1),(551,7495379,7495372,'nis',8.333,1),(551,7495380,7495372,'ist',8.333,1),(551,7495381,7495372,'str',8.333,1),(551,7495382,7495372,'tra',8.333,1),(551,7495383,7495372,'rat',8.333,1),(551,7495384,7495372,'ati',8.333,1),(551,7495385,7495372,'tio',8.333,1),(551,7495386,7495372,'ion',8.333,1),(551,7495387,7495375,'sta',33.333,3),(551,7495388,7495375,'tat',33.333,3),(551,7495389,7495375,'ate',33.333,3),(551,7495390,7495387,'ena',20,2),(551,7495391,7495387,'nab',20,2),(551,7495392,7495387,'abl',20,2),(551,7495393,7495387,'ble',20,2),(551,7495394,7495387,'led',20,2),(551,7495395,7495390,'cac',33.333,1),(551,7495396,7495390,'ach',33.333,1),(551,7495397,7495390,'che',33.333,1),(551,7495398,7495395,'mod',50,2),(551,7495399,7495395,'ode',50,2),(551,7495400,7495398,'wri',14.286,2),(551,7495401,7495398,'rit',14.286,2),(551,7495402,7495398,'ite',14.286,2),(551,7495403,7495398,'tet',14.286,2),(551,7495404,7495398,'eth',14.286,2),(551,7495405,7495398,'thr',14.286,2),(551,7495406,7495398,'hru',14.286,2),(551,7495407,7495400,'ope',11.111,2),(551,7495408,7495400,'per',11.111,2),(551,7495409,7495400,'era',11.111,2),(551,7495410,7495400,'rat',11.111,2),(551,7495411,7495400,'ati',11.111,2),(551,7495412,7495400,'tio',11.111,2),(551,7495413,7495400,'ion',11.111,2),(551,7495414,7495400,'ona',11.111,2),(551,7495415,7495400,'nal',11.111,2),(551,7495416,7495407,'nor',25,1),(551,7495417,7495407,'orm',25,1),(551,7495418,7495407,'rma',25,1),(551,7495419,7495407,'mal',25,1),(551,7495420,7495416,'mes',20,1),(551,7495421,7495416,'ess',20,1),(551,7495422,7495416,'ssa',20,1),(551,7495423,7495416,'sag',20,1),(551,7495424,7495416,'age',20,1),(551,7495425,7495420,'per',11.111,1),(551,7495426,7495420,'erf',11.111,1),(551,7495427,7495420,'rfo',11.111,1),(551,7495428,7495420,'for',11.111,1),(551,7495429,7495420,'orm',11.111,1),(551,7495430,7495420,'rma',11.111,1),(551,7495431,7495420,'man',11.111,1),(551,7495432,7495420,'anc',11.111,1),(551,7495433,7495420,'nce',11.111,1),(551,7495434,7495425,'ide',12.5,1),(551,7495435,7495425,'den',12.5,1),(551,7495436,7495425,'ent',12.5,1),(551,7495437,7495425,'nti',12.5,1),(551,7495438,7495425,'tif',12.5,1),(551,7495439,7495425,'ifi',12.5,1),(551,7495440,7495425,'fie',12.5,1),(551,7495441,7495425,'ier',12.5,1),(551,7495442,7495434,'vdi',33.333,3),(551,7495443,7495434,'dis',33.333,3),(551,7495444,7495434,'isk',33.333,3),(551,7495445,7495442,'nam',50,1),(551,7495446,7495442,'ame',50,1),(551,7495447,7495445,'typ',50,1),(551,7495448,7495445,'ype',50,1),(551,7495449,7495447,'dir',25,1),(551,7495450,7495447,'ire',25,1),(551,7495451,7495447,'rec',25,1),(551,7495452,7495447,'ect',25,1),(552,7495454,7495453,'naa',100,2),(552,7495455,7495454,'600',3.333,3),(552,7495456,7495454,'000',3.333,3),(552,7495457,7495454,'00c',3.333,3),(552,7495458,7495454,'0c2',3.333,3),(552,7495459,7495454,'c29',3.333,3),(552,7495460,7495454,'297',3.333,3),(552,7495461,7495454,'970',3.333,3),(552,7495462,7495454,'706',3.333,3),(552,7495463,7495454,'064',3.333,3),(552,7495464,7495454,'64a',3.333,3),(552,7495465,7495454,'4a1',3.333,3),(552,7495466,7495454,'a18',3.333,3),(552,7495467,7495454,'18d',3.333,3),(552,7495468,7495454,'8df',3.333,3),(552,7495469,7495454,'dfa',3.333,3),(552,7495470,7495454,'fa8',3.333,3),(552,7495471,7495454,'a88',3.333,3),(552,7495472,7495454,'88e',3.333,3),(552,7495473,7495454,'8ec',3.333,3),(552,7495474,7495454,'ece',3.333,3),(552,7495475,7495454,'ced',3.333,3),(552,7495476,7495454,'ed6',3.333,3),(552,7495477,7495454,'d6b',3.333,3),(552,7495478,7495454,'6be',3.333,3),(552,7495479,7495454,'be5',3.333,3),(552,7495480,7495454,'e50',3.333,3),(552,7495481,7495454,'50e',3.333,3),(552,7495482,7495454,'0e0',3.333,3),(552,7495483,7495454,'e05',3.333,3),(552,7495484,7495454,'057',3.333,3),(552,7495485,7495455,'mon',100,1),(552,7495486,7495485,'201',50,1),(552,7495487,7495485,'013',50,1),(552,7495488,7495486,'adm',33.333,3),(552,7495489,7495486,'dmi',33.333,3),(552,7495490,7495486,'min',33.333,3),(552,7495491,7495488,'cap',16.667,1),(552,7495492,7495488,'apa',16.667,1),(552,7495493,7495488,'pac',16.667,1),(552,7495494,7495488,'aci',16.667,1),(552,7495495,7495488,'cit',16.667,1),(552,7495496,7495488,'ity',16.667,1),(552,7495497,7495491,'pat',50,1),(552,7495498,7495491,'ath',50,1),(552,7495499,7495497,'eig',33.333,1),(552,7495500,7495497,'igh',33.333,1),(552,7495501,7495497,'ght',33.333,1),(552,7495502,7495499,'fre',14.286,1),(552,7495503,7495499,'ree',14.286,1),(552,7495504,7495499,'ees',14.286,1),(552,7495505,7495499,'esp',14.286,1),(552,7495506,7495499,'spa',14.286,1),(552,7495507,7495499,'pac',14.286,1),(552,7495508,7495499,'ace',14.286,1),(552,7495509,7495502,'dis',50,1),(552,7495510,7495502,'isk',50,1),(552,7495511,7495509,'ind',33.333,1),(552,7495512,7495509,'nde',33.333,1),(552,7495513,7495509,'dex',33.333,1),(552,7495514,7495511,'adm',8.333,1),(552,7495515,7495511,'dmi',8.333,1),(552,7495516,7495511,'min',8.333,1),(552,7495517,7495511,'ini',8.333,1),(552,7495518,7495511,'nis',8.333,1),(552,7495519,7495511,'ist',8.333,1),(552,7495520,7495511,'str',8.333,1),(552,7495521,7495511,'tra',8.333,1),(552,7495522,7495511,'rat',8.333,1),(552,7495523,7495511,'ati',8.333,1),(552,7495524,7495511,'tio',8.333,1),(552,7495525,7495511,'ion',8.333,1),(552,7495526,7495514,'sta',33.333,3),(552,7495527,7495514,'tat',33.333,3),(552,7495528,7495514,'ate',33.333,3),(552,7495529,7495526,'ena',20,2),(552,7495530,7495526,'nab',20,2),(552,7495531,7495526,'abl',20,2),(552,7495532,7495526,'ble',20,2),(552,7495533,7495526,'led',20,2),(552,7495534,7495529,'cac',33.333,1),(552,7495535,7495529,'ach',33.333,1),(552,7495536,7495529,'che',33.333,1),(552,7495537,7495534,'mod',50,2),(552,7495538,7495534,'ode',50,2),(552,7495539,7495537,'wri',14.286,2),(552,7495540,7495537,'rit',14.286,2),(552,7495541,7495537,'ite',14.286,2),(552,7495542,7495537,'tet',14.286,2),(552,7495543,7495537,'eth',14.286,2),(552,7495544,7495537,'thr',14.286,2),(552,7495545,7495537,'hru',14.286,2),(552,7495546,7495539,'ope',11.111,2),(552,7495547,7495539,'per',11.111,2),(552,7495548,7495539,'era',11.111,2),(552,7495549,7495539,'rat',11.111,2),(552,7495550,7495539,'ati',11.111,2),(552,7495551,7495539,'tio',11.111,2),(552,7495552,7495539,'ion',11.111,2),(552,7495553,7495539,'ona',11.111,2),(552,7495554,7495539,'nal',11.111,2),(552,7495555,7495546,'nor',25,1),(552,7495556,7495546,'orm',25,1),(552,7495557,7495546,'rma',25,1),(552,7495558,7495546,'mal',25,1),(552,7495559,7495555,'mes',20,1),(552,7495560,7495555,'ess',20,1),(552,7495561,7495555,'ssa',20,1),(552,7495562,7495555,'sag',20,1),(552,7495563,7495555,'age',20,1),(552,7495564,7495559,'per',11.111,1),(552,7495565,7495559,'erf',11.111,1),(552,7495566,7495559,'rfo',11.111,1),(552,7495567,7495559,'for',11.111,1),(552,7495568,7495559,'orm',11.111,1),(552,7495569,7495559,'rma',11.111,1),(552,7495570,7495559,'man',11.111,1),(552,7495571,7495559,'anc',11.111,1),(552,7495572,7495559,'nce',11.111,1),(552,7495573,7495564,'ide',12.5,1),(552,7495574,7495564,'den',12.5,1),(552,7495575,7495564,'ent',12.5,1),(552,7495576,7495564,'nti',12.5,1),(552,7495577,7495564,'tif',12.5,1),(552,7495578,7495564,'ifi',12.5,1),(552,7495579,7495564,'fie',12.5,1),(552,7495580,7495564,'ier',12.5,1),(552,7495581,7495573,'vdi',33.333,3),(552,7495582,7495573,'dis',33.333,3),(552,7495583,7495573,'isk',33.333,3),(552,7495584,7495581,'nam',50,1),(552,7495585,7495581,'ame',50,1),(552,7495586,7495584,'typ',50,1),(552,7495587,7495584,'ype',50,1),(552,7495588,7495586,'dir',25,1),(552,7495589,7495586,'ire',25,1),(552,7495590,7495586,'rec',25,1),(552,7495591,7495586,'ect',25,1),(553,7495593,7495592,'naa',100,2),(553,7495594,7495593,'600',3.333,3),(553,7495595,7495593,'000',3.333,3),(553,7495596,7495593,'00c',3.333,3),(553,7495597,7495593,'0c2',3.333,3),(553,7495598,7495593,'c29',3.333,3),(553,7495599,7495593,'295',3.333,3),(553,7495600,7495593,'950',3.333,3),(553,7495601,7495593,'50c',3.333,3),(553,7495602,7495593,'0ca',3.333,3),(553,7495603,7495593,'cab',3.333,3),(553,7495604,7495593,'abe',3.333,3),(553,7495605,7495593,'be6',3.333,3),(553,7495606,7495593,'e6e',3.333,3),(553,7495607,7495593,'6ec',3.333,3),(553,7495608,7495593,'ece',3.333,3),(553,7495609,7495593,'ce9',3.333,3),(553,7495610,7495593,'e93',3.333,3),(553,7495611,7495593,'937',3.333,3),(553,7495612,7495593,'37d',3.333,3),(553,7495613,7495593,'7dc',3.333,3),(553,7495614,7495593,'dc6',3.333,3),(553,7495615,7495593,'c69',3.333,3),(553,7495616,7495593,'69d',3.333,3),(553,7495617,7495593,'9d9',3.333,3),(553,7495618,7495593,'d95',3.333,3),(553,7495619,7495593,'952',3.333,3),(553,7495620,7495593,'52a',3.333,3),(553,7495621,7495593,'2ae',3.333,3),(553,7495622,7495593,'ae4',3.333,3),(553,7495623,7495593,'e4e',3.333,3),(553,7495624,7495594,'mon',100,1),(553,7495625,7495624,'201',50,1),(553,7495626,7495624,'013',50,1),(553,7495627,7495625,'adm',33.333,3),(553,7495628,7495625,'dmi',33.333,3),(553,7495629,7495625,'min',33.333,3),(553,7495630,7495627,'cap',16.667,1),(553,7495631,7495627,'apa',16.667,1),(553,7495632,7495627,'pac',16.667,1),(553,7495633,7495627,'aci',16.667,1),(553,7495634,7495627,'cit',16.667,1),(553,7495635,7495627,'ity',16.667,1),(553,7495636,7495630,'pat',50,1),(553,7495637,7495630,'ath',50,1),(553,7495638,7495636,'nin',50,1),(553,7495639,7495636,'ine',50,1),(553,7495640,7495638,'fre',14.286,1),(553,7495641,7495638,'ree',14.286,1),(553,7495642,7495638,'ees',14.286,1),(553,7495643,7495638,'esp',14.286,1),(553,7495644,7495638,'spa',14.286,1),(553,7495645,7495638,'pac',14.286,1),(553,7495646,7495638,'ace',14.286,1),(553,7495647,7495640,'dis',50,1),(553,7495648,7495640,'isk',50,1),(553,7495649,7495647,'ind',33.333,1),(553,7495650,7495647,'nde',33.333,1),(553,7495651,7495647,'dex',33.333,1),(553,7495652,7495649,'adm',8.333,1),(553,7495653,7495649,'dmi',8.333,1),(553,7495654,7495649,'min',8.333,1),(553,7495655,7495649,'ini',8.333,1),(553,7495656,7495649,'nis',8.333,1),(553,7495657,7495649,'ist',8.333,1),(553,7495658,7495649,'str',8.333,1),(553,7495659,7495649,'tra',8.333,1),(553,7495660,7495649,'rat',8.333,1),(553,7495661,7495649,'ati',8.333,1),(553,7495662,7495649,'tio',8.333,1),(553,7495663,7495649,'ion',8.333,1),(553,7495664,7495652,'sta',33.333,3),(553,7495665,7495652,'tat',33.333,3),(553,7495666,7495652,'ate',33.333,3),(553,7495667,7495664,'ena',20,2),(553,7495668,7495664,'nab',20,2),(553,7495669,7495664,'abl',20,2),(553,7495670,7495664,'ble',20,2),(553,7495671,7495664,'led',20,2),(553,7495672,7495667,'cac',33.333,1),(553,7495673,7495667,'ach',33.333,1),(553,7495674,7495667,'che',33.333,1),(553,7495675,7495672,'mod',50,2),(553,7495676,7495672,'ode',50,2),(553,7495677,7495675,'wri',14.286,2),(553,7495678,7495675,'rit',14.286,2),(553,7495679,7495675,'ite',14.286,2),(553,7495680,7495675,'tet',14.286,2),(553,7495681,7495675,'eth',14.286,2),(553,7495682,7495675,'thr',14.286,2),(553,7495683,7495675,'hru',14.286,2),(553,7495684,7495677,'ope',11.111,2),(553,7495685,7495677,'per',11.111,2),(553,7495686,7495677,'era',11.111,2),(553,7495687,7495677,'rat',11.111,2),(553,7495688,7495677,'ati',11.111,2),(553,7495689,7495677,'tio',11.111,2),(553,7495690,7495677,'ion',11.111,2),(553,7495691,7495677,'ona',11.111,2),(553,7495692,7495677,'nal',11.111,2),(553,7495693,7495684,'nor',25,1),(553,7495694,7495684,'orm',25,1),(553,7495695,7495684,'rma',25,1),(553,7495696,7495684,'mal',25,1),(553,7495697,7495693,'mes',20,1),(553,7495698,7495693,'ess',20,1),(553,7495699,7495693,'ssa',20,1),(553,7495700,7495693,'sag',20,1),(553,7495701,7495693,'age',20,1),(553,7495702,7495697,'per',11.111,1),(553,7495703,7495697,'erf',11.111,1),(553,7495704,7495697,'rfo',11.111,1),(553,7495705,7495697,'for',11.111,1),(553,7495706,7495697,'orm',11.111,1),(553,7495707,7495697,'rma',11.111,1),(553,7495708,7495697,'man',11.111,1),(553,7495709,7495697,'anc',11.111,1),(553,7495710,7495697,'nce',11.111,1),(553,7495711,7495702,'ide',12.5,1),(553,7495712,7495702,'den',12.5,1),(553,7495713,7495702,'ent',12.5,1),(553,7495714,7495702,'nti',12.5,1),(553,7495715,7495702,'tif',12.5,1),(553,7495716,7495702,'ifi',12.5,1),(553,7495717,7495702,'fie',12.5,1),(553,7495718,7495702,'ier',12.5,1),(553,7495719,7495711,'vdi',33.333,3),(553,7495720,7495711,'dis',33.333,3),(553,7495721,7495711,'isk',33.333,3),(553,7495722,7495719,'nam',50,1),(553,7495723,7495719,'ame',50,1),(553,7495724,7495722,'typ',50,1),(553,7495725,7495722,'ype',50,1),(553,7495726,7495724,'dir',25,1),(553,7495727,7495724,'ire',25,1),(553,7495728,7495724,'rec',25,1),(553,7495729,7495724,'ect',25,1),(554,7495731,7495730,'naa',100,2),(554,7495732,7495731,'600',3.333,3),(554,7495733,7495731,'000',3.333,3),(554,7495734,7495731,'00c',3.333,3),(554,7495735,7495731,'0c2',3.333,3),(554,7495736,7495731,'c29',3.333,3),(554,7495737,7495731,'29e',3.333,3),(554,7495738,7495731,'9ee',3.333,3),(554,7495739,7495731,'eec',3.333,3),(554,7495740,7495731,'ecc',3.333,3),(554,7495741,7495731,'cc6',3.333,3),(554,7495742,7495731,'c6e',3.333,3),(554,7495743,7495731,'6e9',3.333,3),(554,7495744,7495731,'e9a',3.333,3),(554,7495745,7495731,'9ad',3.333,3),(554,7495746,7495731,'adb',3.333,3),(554,7495747,7495731,'dbb',3.333,3),(554,7495748,7495731,'bb0',3.333,3),(554,7495749,7495731,'b01',3.333,3),(554,7495750,7495731,'013',3.333,3),(554,7495751,7495731,'132',3.333,3),(554,7495752,7495731,'32e',3.333,3),(554,7495753,7495731,'2e3',3.333,3),(554,7495754,7495731,'e3b',3.333,3),(554,7495755,7495731,'3b3',3.333,3),(554,7495756,7495731,'b3f',3.333,3),(554,7495757,7495731,'3ff',3.333,3),(554,7495758,7495731,'ff7',3.333,3),(554,7495759,7495731,'f7d',3.333,3),(554,7495760,7495731,'7d2',3.333,3),(554,7495761,7495731,'d22',3.333,3),(554,7495762,7495732,'mon',100,1),(554,7495763,7495762,'201',50,1),(554,7495764,7495762,'013',50,1),(554,7495765,7495763,'adm',33.333,3),(554,7495766,7495763,'dmi',33.333,3),(554,7495767,7495763,'min',33.333,3),(554,7495768,7495765,'cap',16.667,1),(554,7495769,7495765,'apa',16.667,1),(554,7495770,7495765,'pac',16.667,1),(554,7495771,7495765,'aci',16.667,1),(554,7495772,7495765,'cit',16.667,1),(554,7495773,7495765,'ity',16.667,1),(554,7495774,7495768,'pat',50,1),(554,7495775,7495768,'ath',50,1),(554,7495776,7495774,'ten',100,1),(554,7495777,7495776,'fre',14.286,1),(554,7495778,7495776,'ree',14.286,1),(554,7495779,7495776,'ees',14.286,1),(554,7495780,7495776,'esp',14.286,1),(554,7495781,7495776,'spa',14.286,1),(554,7495782,7495776,'pac',14.286,1),(554,7495783,7495776,'ace',14.286,1),(554,7495784,7495777,'dis',50,1),(554,7495785,7495777,'isk',50,1),(554,7495786,7495784,'ind',33.333,1),(554,7495787,7495784,'nde',33.333,1),(554,7495788,7495784,'dex',33.333,1),(554,7495789,7495786,'adm',8.333,1),(554,7495790,7495786,'dmi',8.333,1),(554,7495791,7495786,'min',8.333,1),(554,7495792,7495786,'ini',8.333,1),(554,7495793,7495786,'nis',8.333,1),(554,7495794,7495786,'ist',8.333,1),(554,7495795,7495786,'str',8.333,1),(554,7495796,7495786,'tra',8.333,1),(554,7495797,7495786,'rat',8.333,1),(554,7495798,7495786,'ati',8.333,1),(554,7495799,7495786,'tio',8.333,1),(554,7495800,7495786,'ion',8.333,1),(554,7495801,7495789,'sta',33.333,3),(554,7495802,7495789,'tat',33.333,3),(554,7495803,7495789,'ate',33.333,3),(554,7495804,7495801,'ena',20,2),(554,7495805,7495801,'nab',20,2),(554,7495806,7495801,'abl',20,2),(554,7495807,7495801,'ble',20,2),(554,7495808,7495801,'led',20,2),(554,7495809,7495804,'cac',33.333,1),(554,7495810,7495804,'ach',33.333,1),(554,7495811,7495804,'che',33.333,1),(554,7495812,7495809,'mod',50,2),(554,7495813,7495809,'ode',50,2),(554,7495814,7495812,'wri',14.286,2),(554,7495815,7495812,'rit',14.286,2),(554,7495816,7495812,'ite',14.286,2),(554,7495817,7495812,'tet',14.286,2),(554,7495818,7495812,'eth',14.286,2),(554,7495819,7495812,'thr',14.286,2),(554,7495820,7495812,'hru',14.286,2),(554,7495821,7495814,'ope',11.111,2),(554,7495822,7495814,'per',11.111,2),(554,7495823,7495814,'era',11.111,2),(554,7495824,7495814,'rat',11.111,2),(554,7495825,7495814,'ati',11.111,2),(554,7495826,7495814,'tio',11.111,2),(554,7495827,7495814,'ion',11.111,2),(554,7495828,7495814,'ona',11.111,2),(554,7495829,7495814,'nal',11.111,2),(554,7495830,7495821,'nor',25,1),(554,7495831,7495821,'orm',25,1),(554,7495832,7495821,'rma',25,1),(554,7495833,7495821,'mal',25,1),(554,7495834,7495830,'mes',20,1),(554,7495835,7495830,'ess',20,1),(554,7495836,7495830,'ssa',20,1),(554,7495837,7495830,'sag',20,1),(554,7495838,7495830,'age',20,1),(554,7495839,7495834,'per',11.111,1),(554,7495840,7495834,'erf',11.111,1),(554,7495841,7495834,'rfo',11.111,1),(554,7495842,7495834,'for',11.111,1),(554,7495843,7495834,'orm',11.111,1),(554,7495844,7495834,'rma',11.111,1),(554,7495845,7495834,'man',11.111,1),(554,7495846,7495834,'anc',11.111,1),(554,7495847,7495834,'nce',11.111,1),(554,7495848,7495839,'ide',12.5,1),(554,7495849,7495839,'den',12.5,1),(554,7495850,7495839,'ent',12.5,1),(554,7495851,7495839,'nti',12.5,1),(554,7495852,7495839,'tif',12.5,1),(554,7495853,7495839,'ifi',12.5,1),(554,7495854,7495839,'fie',12.5,1),(554,7495855,7495839,'ier',12.5,1),(554,7495856,7495848,'vdi',33.333,3),(554,7495857,7495848,'dis',33.333,3),(554,7495858,7495848,'isk',33.333,3),(554,7495859,7495856,'nam',50,1),(554,7495860,7495856,'ame',50,1),(554,7495861,7495859,'typ',50,1),(554,7495862,7495859,'ype',50,1),(554,7495863,7495861,'dir',25,1),(554,7495864,7495861,'ire',25,1),(554,7495865,7495861,'rec',25,1),(554,7495866,7495861,'ect',25,1),(555,7495868,7495867,'naa',100,2),(555,7495869,7495868,'600',3.333,3),(555,7495870,7495868,'000',3.333,3),(555,7495871,7495868,'00c',3.333,3),(555,7495872,7495868,'0c2',3.333,3),(555,7495873,7495868,'c29',3.333,3),(555,7495874,7495868,'291',3.333,3),(555,7495875,7495868,'91f',3.333,3),(555,7495876,7495868,'1fd',3.333,3),(555,7495877,7495868,'fd2',3.333,3),(555,7495878,7495868,'d23',3.333,3),(555,7495879,7495868,'239',3.333,3),(555,7495880,7495868,'395',3.333,3),(555,7495881,7495868,'95f',3.333,3),(555,7495882,7495868,'5fe',3.333,3),(555,7495883,7495868,'fe3',3.333,3),(555,7495884,7495868,'e3c',3.333,3),(555,7495885,7495868,'3c1',3.333,3),(555,7495886,7495868,'c19',3.333,3),(555,7495887,7495868,'199',3.333,3),(555,7495888,7495868,'997',3.333,3),(555,7495889,7495868,'979',3.333,3),(555,7495890,7495868,'795',3.333,3),(555,7495891,7495868,'950',3.333,3),(555,7495892,7495868,'50b',3.333,3),(555,7495893,7495868,'0b8',3.333,3),(555,7495894,7495868,'b8a',3.333,3),(555,7495895,7495868,'8a8',3.333,3),(555,7495896,7495868,'a8c',3.333,3),(555,7495897,7495868,'8c0',3.333,3),(555,7495898,7495868,'c0c',3.333,3),(555,7495899,7495869,'mon',100,1),(555,7495900,7495899,'201',50,1),(555,7495901,7495899,'013',50,1),(555,7495902,7495900,'adm',33.333,3),(555,7495903,7495900,'dmi',33.333,3),(555,7495904,7495900,'min',33.333,3),(555,7495905,7495902,'cap',16.667,1),(555,7495906,7495902,'apa',16.667,1),(555,7495907,7495902,'pac',16.667,1),(555,7495908,7495902,'aci',16.667,1),(555,7495909,7495902,'cit',16.667,1),(555,7495910,7495902,'ity',16.667,1),(555,7495911,7495905,'pat',50,1),(555,7495912,7495905,'ath',50,1),(555,7495913,7495911,'ele',25,1),(555,7495914,7495911,'lev',25,1),(555,7495915,7495911,'eve',25,1),(555,7495916,7495911,'ven',25,1),(555,7495917,7495913,'fre',14.286,1),(555,7495918,7495913,'ree',14.286,1),(555,7495919,7495913,'ees',14.286,1),(555,7495920,7495913,'esp',14.286,1),(555,7495921,7495913,'spa',14.286,1),(555,7495922,7495913,'pac',14.286,1),(555,7495923,7495913,'ace',14.286,1),(555,7495924,7495917,'dis',50,1),(555,7495925,7495917,'isk',50,1),(555,7495926,7495924,'ind',33.333,1),(555,7495927,7495924,'nde',33.333,1),(555,7495928,7495924,'dex',33.333,1),(555,7495929,7495926,'adm',8.333,1),(555,7495930,7495926,'dmi',8.333,1),(555,7495931,7495926,'min',8.333,1),(555,7495932,7495926,'ini',8.333,1),(555,7495933,7495926,'nis',8.333,1),(555,7495934,7495926,'ist',8.333,1),(555,7495935,7495926,'str',8.333,1),(555,7495936,7495926,'tra',8.333,1),(555,7495937,7495926,'rat',8.333,1),(555,7495938,7495926,'ati',8.333,1),(555,7495939,7495926,'tio',8.333,1),(555,7495940,7495926,'ion',8.333,1),(555,7495941,7495929,'sta',33.333,3),(555,7495942,7495929,'tat',33.333,3),(555,7495943,7495929,'ate',33.333,3),(555,7495944,7495941,'ena',20,2),(555,7495945,7495941,'nab',20,2),(555,7495946,7495941,'abl',20,2),(555,7495947,7495941,'ble',20,2),(555,7495948,7495941,'led',20,2),(555,7495949,7495944,'cac',33.333,1),(555,7495950,7495944,'ach',33.333,1),(555,7495951,7495944,'che',33.333,1),(555,7495952,7495949,'mod',50,2),(555,7495953,7495949,'ode',50,2),(555,7495954,7495952,'wri',14.286,2),(555,7495955,7495952,'rit',14.286,2),(555,7495956,7495952,'ite',14.286,2),(555,7495957,7495952,'tet',14.286,2),(555,7495958,7495952,'eth',14.286,2),(555,7495959,7495952,'thr',14.286,2),(555,7495960,7495952,'hru',14.286,2),(555,7495961,7495954,'ope',11.111,2),(555,7495962,7495954,'per',11.111,2),(555,7495963,7495954,'era',11.111,2),(555,7495964,7495954,'rat',11.111,2),(555,7495965,7495954,'ati',11.111,2),(555,7495966,7495954,'tio',11.111,2),(555,7495967,7495954,'ion',11.111,2),(555,7495968,7495954,'ona',11.111,2),(555,7495969,7495954,'nal',11.111,2),(555,7495970,7495961,'nor',25,1),(555,7495971,7495961,'orm',25,1),(555,7495972,7495961,'rma',25,1),(555,7495973,7495961,'mal',25,1),(555,7495974,7495970,'mes',20,1),(555,7495975,7495970,'ess',20,1),(555,7495976,7495970,'ssa',20,1),(555,7495977,7495970,'sag',20,1),(555,7495978,7495970,'age',20,1),(555,7495979,7495974,'per',11.111,1),(555,7495980,7495974,'erf',11.111,1),(555,7495981,7495974,'rfo',11.111,1),(555,7495982,7495974,'for',11.111,1),(555,7495983,7495974,'orm',11.111,1),(555,7495984,7495974,'rma',11.111,1),(555,7495985,7495974,'man',11.111,1),(555,7495986,7495974,'anc',11.111,1),(555,7495987,7495974,'nce',11.111,1),(555,7495988,7495979,'ide',12.5,1),(555,7495989,7495979,'den',12.5,1),(555,7495990,7495979,'ent',12.5,1),(555,7495991,7495979,'nti',12.5,1),(555,7495992,7495979,'tif',12.5,1),(555,7495993,7495979,'ifi',12.5,1),(555,7495994,7495979,'fie',12.5,1),(555,7495995,7495979,'ier',12.5,1),(555,7495996,7495988,'vdi',33.333,3),(555,7495997,7495988,'dis',33.333,3),(555,7495998,7495988,'isk',33.333,3),(555,7495999,7495996,'nam',50,1),(555,7496000,7495996,'ame',50,1),(555,7496001,7495999,'typ',50,1),(555,7496002,7495999,'ype',50,1),(555,7496003,7496001,'dir',25,1),(555,7496004,7496001,'ire',25,1),(555,7496005,7496001,'rec',25,1),(555,7496006,7496001,'ect',25,1),(556,7496008,7496007,'naa',100,2),(556,7496009,7496008,'600',3.333,3),(556,7496010,7496008,'000',3.333,3),(556,7496011,7496008,'00c',3.333,3),(556,7496012,7496008,'0c2',3.333,3),(556,7496013,7496008,'c29',3.333,3),(556,7496014,7496008,'296',3.333,3),(556,7496015,7496008,'967',3.333,3),(556,7496016,7496008,'674',3.333,3),(556,7496017,7496008,'743',3.333,3),(556,7496018,7496008,'439',3.333,3),(556,7496019,7496008,'398',3.333,3),(556,7496020,7496008,'988',3.333,3),(556,7496021,7496008,'883',3.333,3),(556,7496022,7496008,'83f',3.333,3),(556,7496023,7496008,'3ff',3.333,3),(556,7496024,7496008,'ffd',3.333,3),(556,7496025,7496008,'fd8',3.333,3),(556,7496026,7496008,'d8a',3.333,3),(556,7496027,7496008,'8ad',3.333,3),(556,7496028,7496008,'ad9',3.333,3),(556,7496029,7496008,'d92',3.333,3),(556,7496030,7496008,'92e',3.333,3),(556,7496031,7496008,'2ee',3.333,3),(556,7496032,7496008,'ee6',3.333,3),(556,7496033,7496008,'e6d',3.333,3),(556,7496034,7496008,'6de',3.333,3),(556,7496035,7496008,'de2',3.333,3),(556,7496036,7496008,'e2a',3.333,3),(556,7496037,7496008,'2a3',3.333,3),(556,7496038,7496008,'a3c',3.333,3),(556,7496039,7496009,'mon',100,1),(556,7496040,7496039,'201',50,1),(556,7496041,7496039,'013',50,1),(556,7496042,7496040,'adm',33.333,3),(556,7496043,7496040,'dmi',33.333,3),(556,7496044,7496040,'min',33.333,3),(556,7496045,7496042,'cap',16.667,1),(556,7496046,7496042,'apa',16.667,1),(556,7496047,7496042,'pac',16.667,1),(556,7496048,7496042,'aci',16.667,1),(556,7496049,7496042,'cit',16.667,1),(556,7496050,7496042,'ity',16.667,1),(556,7496051,7496045,'pat',50,1),(556,7496052,7496045,'ath',50,1),(556,7496053,7496051,'twe',25,1),(556,7496054,7496051,'wel',25,1),(556,7496055,7496051,'elv',25,1),(556,7496056,7496051,'lve',25,1),(556,7496057,7496053,'fre',14.286,1),(556,7496058,7496053,'ree',14.286,1),(556,7496059,7496053,'ees',14.286,1),(556,7496060,7496053,'esp',14.286,1),(556,7496061,7496053,'spa',14.286,1),(556,7496062,7496053,'pac',14.286,1),(556,7496063,7496053,'ace',14.286,1),(556,7496064,7496057,'dis',50,1),(556,7496065,7496057,'isk',50,1),(556,7496066,7496064,'ind',33.333,1),(556,7496067,7496064,'nde',33.333,1),(556,7496068,7496064,'dex',33.333,1),(556,7496069,7496066,'adm',8.333,1),(556,7496070,7496066,'dmi',8.333,1),(556,7496071,7496066,'min',8.333,1),(556,7496072,7496066,'ini',8.333,1),(556,7496073,7496066,'nis',8.333,1),(556,7496074,7496066,'ist',8.333,1),(556,7496075,7496066,'str',8.333,1),(556,7496076,7496066,'tra',8.333,1),(556,7496077,7496066,'rat',8.333,1),(556,7496078,7496066,'ati',8.333,1),(556,7496079,7496066,'tio',8.333,1),(556,7496080,7496066,'ion',8.333,1),(556,7496081,7496069,'sta',33.333,3),(556,7496082,7496069,'tat',33.333,3),(556,7496083,7496069,'ate',33.333,3),(556,7496084,7496081,'ena',20,2),(556,7496085,7496081,'nab',20,2),(556,7496086,7496081,'abl',20,2),(556,7496087,7496081,'ble',20,2),(556,7496088,7496081,'led',20,2),(556,7496089,7496084,'cac',33.333,1),(556,7496090,7496084,'ach',33.333,1),(556,7496091,7496084,'che',33.333,1),(556,7496092,7496089,'mod',50,2),(556,7496093,7496089,'ode',50,2),(556,7496094,7496092,'wri',14.286,2),(556,7496095,7496092,'rit',14.286,2),(556,7496096,7496092,'ite',14.286,2),(556,7496097,7496092,'tet',14.286,2),(556,7496098,7496092,'eth',14.286,2),(556,7496099,7496092,'thr',14.286,2),(556,7496100,7496092,'hru',14.286,2),(556,7496101,7496094,'ope',11.111,2),(556,7496102,7496094,'per',11.111,2),(556,7496103,7496094,'era',11.111,2),(556,7496104,7496094,'rat',11.111,2),(556,7496105,7496094,'ati',11.111,2),(556,7496106,7496094,'tio',11.111,2),(556,7496107,7496094,'ion',11.111,2),(556,7496108,7496094,'ona',11.111,2),(556,7496109,7496094,'nal',11.111,2),(556,7496110,7496101,'nor',25,1),(556,7496111,7496101,'orm',25,1),(556,7496112,7496101,'rma',25,1),(556,7496113,7496101,'mal',25,1),(556,7496114,7496110,'mes',20,1),(556,7496115,7496110,'ess',20,1),(556,7496116,7496110,'ssa',20,1),(556,7496117,7496110,'sag',20,1),(556,7496118,7496110,'age',20,1),(556,7496119,7496114,'per',11.111,1),(556,7496120,7496114,'erf',11.111,1),(556,7496121,7496114,'rfo',11.111,1),(556,7496122,7496114,'for',11.111,1),(556,7496123,7496114,'orm',11.111,1),(556,7496124,7496114,'rma',11.111,1),(556,7496125,7496114,'man',11.111,1),(556,7496126,7496114,'anc',11.111,1),(556,7496127,7496114,'nce',11.111,1),(556,7496128,7496119,'ide',12.5,1),(556,7496129,7496119,'den',12.5,1),(556,7496130,7496119,'ent',12.5,1),(556,7496131,7496119,'nti',12.5,1),(556,7496132,7496119,'tif',12.5,1),(556,7496133,7496119,'ifi',12.5,1),(556,7496134,7496119,'fie',12.5,1),(556,7496135,7496119,'ier',12.5,1),(556,7496136,7496128,'vdi',33.333,3),(556,7496137,7496128,'dis',33.333,3),(556,7496138,7496128,'isk',33.333,3),(556,7496139,7496136,'nam',50,1),(556,7496140,7496136,'ame',50,1),(556,7496141,7496139,'typ',50,1),(556,7496142,7496139,'ype',50,1),(556,7496143,7496141,'dir',25,1),(556,7496144,7496141,'ire',25,1),(556,7496145,7496141,'rec',25,1),(556,7496146,7496141,'ect',25,1),(557,7496148,7496147,'naa',100,2),(557,7496149,7496148,'600',3.333,3),(557,7496150,7496148,'000',3.333,3),(557,7496151,7496148,'00c',3.333,3),(557,7496152,7496148,'0c2',3.333,3),(557,7496153,7496148,'c29',3.333,3),(557,7496154,7496148,'29a',3.333,3),(557,7496155,7496148,'9a8',3.333,3),(557,7496156,7496148,'a8d',3.333,3),(557,7496157,7496148,'8d2',3.333,3),(557,7496158,7496148,'d23',3.333,3),(557,7496159,7496148,'234',3.333,3),(557,7496160,7496148,'346',3.333,3),(557,7496161,7496148,'467',3.333,3),(557,7496162,7496148,'67d',3.333,3),(557,7496163,7496148,'7de',3.333,3),(557,7496164,7496148,'ded',3.333,3),(557,7496165,7496148,'edb',3.333,3),(557,7496166,7496148,'db9',3.333,3),(557,7496167,7496148,'b9b',3.333,3),(557,7496168,7496148,'9b0',3.333,3),(557,7496169,7496148,'b0a',3.333,3),(557,7496170,7496148,'0a5',3.333,3),(557,7496171,7496148,'a50',3.333,3),(557,7496172,7496148,'508',3.333,3),(557,7496173,7496148,'08a',3.333,3),(557,7496174,7496148,'8ab',3.333,3),(557,7496175,7496148,'ab6',3.333,3),(557,7496176,7496148,'b6f',3.333,3),(557,7496177,7496148,'6f9',3.333,3),(557,7496178,7496148,'f92',3.333,3),(557,7496179,7496149,'mon',100,1),(557,7496180,7496179,'201',50,1),(557,7496181,7496179,'013',50,1),(557,7496182,7496180,'adm',33.333,3),(557,7496183,7496180,'dmi',33.333,3),(557,7496184,7496180,'min',33.333,3),(557,7496185,7496182,'cap',16.667,1),(557,7496186,7496182,'apa',16.667,1),(557,7496187,7496182,'pac',16.667,1),(557,7496188,7496182,'aci',16.667,1),(557,7496189,7496182,'cit',16.667,1),(557,7496190,7496182,'ity',16.667,1),(557,7496191,7496185,'pat',50,1),(557,7496192,7496185,'ath',50,1),(557,7496193,7496191,'thi',16.667,1),(557,7496194,7496191,'hir',16.667,1),(557,7496195,7496191,'irt',16.667,1),(557,7496196,7496191,'rte',16.667,1),(557,7496197,7496191,'tee',16.667,1),(557,7496198,7496191,'een',16.667,1),(557,7496199,7496193,'fre',14.286,1),(557,7496200,7496193,'ree',14.286,1),(557,7496201,7496193,'ees',14.286,1),(557,7496202,7496193,'esp',14.286,1),(557,7496203,7496193,'spa',14.286,1),(557,7496204,7496193,'pac',14.286,1),(557,7496205,7496193,'ace',14.286,1),(557,7496206,7496199,'dis',50,1),(557,7496207,7496199,'isk',50,1),(557,7496208,7496206,'ind',33.333,1),(557,7496209,7496206,'nde',33.333,1),(557,7496210,7496206,'dex',33.333,1),(557,7496211,7496208,'adm',8.333,1),(557,7496212,7496208,'dmi',8.333,1),(557,7496213,7496208,'min',8.333,1),(557,7496214,7496208,'ini',8.333,1),(557,7496215,7496208,'nis',8.333,1),(557,7496216,7496208,'ist',8.333,1),(557,7496217,7496208,'str',8.333,1),(557,7496218,7496208,'tra',8.333,1),(557,7496219,7496208,'rat',8.333,1),(557,7496220,7496208,'ati',8.333,1),(557,7496221,7496208,'tio',8.333,1),(557,7496222,7496208,'ion',8.333,1),(557,7496223,7496211,'sta',33.333,3),(557,7496224,7496211,'tat',33.333,3),(557,7496225,7496211,'ate',33.333,3),(557,7496226,7496223,'ena',20,2),(557,7496227,7496223,'nab',20,2),(557,7496228,7496223,'abl',20,2),(557,7496229,7496223,'ble',20,2),(557,7496230,7496223,'led',20,2),(557,7496231,7496226,'cac',33.333,1),(557,7496232,7496226,'ach',33.333,1),(557,7496233,7496226,'che',33.333,1),(557,7496234,7496231,'mod',50,2),(557,7496235,7496231,'ode',50,2),(557,7496236,7496234,'wri',14.286,2),(557,7496237,7496234,'rit',14.286,2),(557,7496238,7496234,'ite',14.286,2),(557,7496239,7496234,'tet',14.286,2),(557,7496240,7496234,'eth',14.286,2),(557,7496241,7496234,'thr',14.286,2),(557,7496242,7496234,'hru',14.286,2),(557,7496243,7496236,'ope',11.111,2),(557,7496244,7496236,'per',11.111,2),(557,7496245,7496236,'era',11.111,2),(557,7496246,7496236,'rat',11.111,2),(557,7496247,7496236,'ati',11.111,2),(557,7496248,7496236,'tio',11.111,2),(557,7496249,7496236,'ion',11.111,2),(557,7496250,7496236,'ona',11.111,2),(557,7496251,7496236,'nal',11.111,2),(557,7496252,7496243,'nor',25,1),(557,7496253,7496243,'orm',25,1),(557,7496254,7496243,'rma',25,1),(557,7496255,7496243,'mal',25,1),(557,7496256,7496252,'mes',20,1),(557,7496257,7496252,'ess',20,1),(557,7496258,7496252,'ssa',20,1),(557,7496259,7496252,'sag',20,1),(557,7496260,7496252,'age',20,1),(557,7496261,7496256,'per',11.111,1),(557,7496262,7496256,'erf',11.111,1),(557,7496263,7496256,'rfo',11.111,1),(557,7496264,7496256,'for',11.111,1),(557,7496265,7496256,'orm',11.111,1),(557,7496266,7496256,'rma',11.111,1),(557,7496267,7496256,'man',11.111,1),(557,7496268,7496256,'anc',11.111,1),(557,7496269,7496256,'nce',11.111,1),(557,7496270,7496261,'ide',12.5,1),(557,7496271,7496261,'den',12.5,1),(557,7496272,7496261,'ent',12.5,1),(557,7496273,7496261,'nti',12.5,1),(557,7496274,7496261,'tif',12.5,1),(557,7496275,7496261,'ifi',12.5,1),(557,7496276,7496261,'fie',12.5,1),(557,7496277,7496261,'ier',12.5,1),(557,7496278,7496270,'vdi',33.333,3),(557,7496279,7496270,'dis',33.333,3),(557,7496280,7496270,'isk',33.333,3),(557,7496281,7496278,'nam',50,1),(557,7496282,7496278,'ame',50,1),(557,7496283,7496281,'typ',50,1),(557,7496284,7496281,'ype',50,1),(557,7496285,7496283,'dir',25,1),(557,7496286,7496283,'ire',25,1),(557,7496287,7496283,'rec',25,1),(557,7496288,7496283,'ect',25,1),(558,7496290,7496289,'naa',100,2),(558,7496291,7496290,'600',3.333,3),(558,7496292,7496290,'000',3.333,3),(558,7496293,7496290,'00c',3.333,3),(558,7496294,7496290,'0c2',3.333,3),(558,7496295,7496290,'c29',3.333,3),(558,7496296,7496290,'290',3.333,3),(558,7496297,7496290,'90a',3.333,3),(558,7496298,7496290,'0ab',3.333,3),(558,7496299,7496290,'abf',3.333,3),(558,7496300,7496290,'bfa',3.333,3),(558,7496301,7496290,'faf',3.333,3),(558,7496302,7496290,'af5',3.333,3),(558,7496303,7496290,'f53',3.333,3),(558,7496304,7496290,'53c',3.333,3),(558,7496305,7496290,'3c3',3.333,3),(558,7496306,7496290,'c3b',3.333,3),(558,7496307,7496290,'3b2',3.333,3),(558,7496308,7496290,'b2c',3.333,3),(558,7496309,7496290,'2c6',3.333,3),(558,7496310,7496290,'c64',3.333,3),(558,7496311,7496290,'643',3.333,3),(558,7496312,7496290,'43b',3.333,3),(558,7496313,7496290,'3b6',3.333,3),(558,7496314,7496290,'b60',3.333,3),(558,7496315,7496290,'607',3.333,3),(558,7496316,7496290,'070',3.333,3),(558,7496317,7496290,'703',3.333,3),(558,7496318,7496290,'038',3.333,3),(558,7496319,7496290,'38b',3.333,3),(558,7496320,7496290,'8bf',3.333,3),(558,7496321,7496291,'mon',100,1),(558,7496322,7496321,'201',50,1),(558,7496323,7496321,'013',50,1),(558,7496324,7496322,'adm',33.333,3),(558,7496325,7496322,'dmi',33.333,3),(558,7496326,7496322,'min',33.333,3),(558,7496327,7496324,'cap',16.667,1),(558,7496328,7496324,'apa',16.667,1),(558,7496329,7496324,'pac',16.667,1),(558,7496330,7496324,'aci',16.667,1),(558,7496331,7496324,'cit',16.667,1),(558,7496332,7496324,'ity',16.667,1),(558,7496333,7496327,'pat',50,1),(558,7496334,7496327,'ath',50,1),(558,7496335,7496333,'fre',14.286,1),(558,7496336,7496333,'ree',14.286,1),(558,7496337,7496333,'ees',14.286,1),(558,7496338,7496333,'esp',14.286,1),(558,7496339,7496333,'spa',14.286,1),(558,7496340,7496333,'pac',14.286,1),(558,7496341,7496333,'ace',14.286,1),(558,7496342,7496335,'dis',50,1),(558,7496343,7496335,'isk',50,1),(558,7496344,7496342,'ind',33.333,1),(558,7496345,7496342,'nde',33.333,1),(558,7496346,7496342,'dex',33.333,1),(558,7496347,7496344,'adm',8.333,1),(558,7496348,7496344,'dmi',8.333,1),(558,7496349,7496344,'min',8.333,1),(558,7496350,7496344,'ini',8.333,1),(558,7496351,7496344,'nis',8.333,1),(558,7496352,7496344,'ist',8.333,1),(558,7496353,7496344,'str',8.333,1),(558,7496354,7496344,'tra',8.333,1),(558,7496355,7496344,'rat',8.333,1),(558,7496356,7496344,'ati',8.333,1),(558,7496357,7496344,'tio',8.333,1),(558,7496358,7496344,'ion',8.333,1),(558,7496359,7496347,'sta',33.333,3),(558,7496360,7496347,'tat',33.333,3),(558,7496361,7496347,'ate',33.333,3),(558,7496362,7496359,'ena',20,2),(558,7496363,7496359,'nab',20,2),(558,7496364,7496359,'abl',20,2),(558,7496365,7496359,'ble',20,2),(558,7496366,7496359,'led',20,2),(558,7496367,7496362,'cac',33.333,1),(558,7496368,7496362,'ach',33.333,1),(558,7496369,7496362,'che',33.333,1),(558,7496370,7496367,'mod',50,2),(558,7496371,7496367,'ode',50,2),(558,7496372,7496370,'wri',14.286,2),(558,7496373,7496370,'rit',14.286,2),(558,7496374,7496370,'ite',14.286,2),(558,7496375,7496370,'tet',14.286,2),(558,7496376,7496370,'eth',14.286,2),(558,7496377,7496370,'thr',14.286,2),(558,7496378,7496370,'hru',14.286,2),(558,7496379,7496372,'ope',11.111,2),(558,7496380,7496372,'per',11.111,2),(558,7496381,7496372,'era',11.111,2),(558,7496382,7496372,'rat',11.111,2),(558,7496383,7496372,'ati',11.111,2),(558,7496384,7496372,'tio',11.111,2),(558,7496385,7496372,'ion',11.111,2),(558,7496386,7496372,'ona',11.111,2),(558,7496387,7496372,'nal',11.111,2),(558,7496388,7496379,'nor',25,1),(558,7496389,7496379,'orm',25,1),(558,7496390,7496379,'rma',25,1),(558,7496391,7496379,'mal',25,1),(558,7496392,7496388,'mes',20,1),(558,7496393,7496388,'ess',20,1),(558,7496394,7496388,'ssa',20,1),(558,7496395,7496388,'sag',20,1),(558,7496396,7496388,'age',20,1),(558,7496397,7496392,'per',11.111,1),(558,7496398,7496392,'erf',11.111,1),(558,7496399,7496392,'rfo',11.111,1),(558,7496400,7496392,'for',11.111,1),(558,7496401,7496392,'orm',11.111,1),(558,7496402,7496392,'rma',11.111,1),(558,7496403,7496392,'man',11.111,1),(558,7496404,7496392,'anc',11.111,1),(558,7496405,7496392,'nce',11.111,1),(558,7496406,7496397,'ide',12.5,1),(558,7496407,7496397,'den',12.5,1),(558,7496408,7496397,'ent',12.5,1),(558,7496409,7496397,'nti',12.5,1),(558,7496410,7496397,'tif',12.5,1),(558,7496411,7496397,'ifi',12.5,1),(558,7496412,7496397,'fie',12.5,1),(558,7496413,7496397,'ier',12.5,1),(558,7496414,7496406,'vdi',33.333,3),(558,7496415,7496406,'dis',33.333,3),(558,7496416,7496406,'isk',33.333,3),(558,7496417,7496414,'nam',50,1),(558,7496418,7496414,'ame',50,1),(558,7496419,7496417,'typ',50,1),(558,7496420,7496417,'ype',50,1),(558,7496421,7496419,'dir',25,1),(558,7496422,7496419,'ire',25,1),(558,7496423,7496419,'rec',25,1),(558,7496424,7496419,'ect',25,1),(559,7496426,7496425,'naa',100,2),(559,7496427,7496426,'600',3.333,3),(559,7496428,7496426,'000',3.333,3),(559,7496429,7496426,'00c',3.333,3),(559,7496430,7496426,'0c2',3.333,3),(559,7496431,7496426,'c29',3.333,3),(559,7496432,7496426,'295',3.333,3),(559,7496433,7496426,'953',3.333,3),(559,7496434,7496426,'53e',3.333,3),(559,7496435,7496426,'3e4',3.333,3),(559,7496436,7496426,'e4b',3.333,3),(559,7496437,7496426,'4b5',3.333,3),(559,7496438,7496426,'b58',3.333,3),(559,7496439,7496426,'58e',3.333,3),(559,7496440,7496426,'8e3',3.333,3),(559,7496441,7496426,'e32',3.333,3),(559,7496442,7496426,'326',3.333,3),(559,7496443,7496426,'268',3.333,3),(559,7496444,7496426,'68b',3.333,3),(559,7496445,7496426,'8b2',3.333,3),(559,7496446,7496426,'b22',3.333,3),(559,7496447,7496426,'227',3.333,3),(559,7496448,7496426,'275',3.333,3),(559,7496449,7496426,'75f',3.333,3),(559,7496450,7496426,'5f6',3.333,3),(559,7496451,7496426,'f65',3.333,3),(559,7496452,7496426,'65c',3.333,3),(559,7496453,7496426,'5c0',3.333,3),(559,7496454,7496426,'c00',3.333,3),(559,7496455,7496426,'00b',3.333,3),(559,7496456,7496426,'0b3',3.333,3),(559,7496457,7496427,'mon',100,1),(559,7496458,7496457,'201',50,1),(559,7496459,7496457,'013',50,1),(559,7496460,7496458,'adm',33.333,3),(559,7496461,7496458,'dmi',33.333,3),(559,7496462,7496458,'min',33.333,3),(559,7496463,7496460,'cap',16.667,1),(559,7496464,7496460,'apa',16.667,1),(559,7496465,7496460,'pac',16.667,1),(559,7496466,7496460,'aci',16.667,1),(559,7496467,7496460,'cit',16.667,1),(559,7496468,7496460,'ity',16.667,1),(559,7496469,7496463,'pat',50,1),(559,7496470,7496463,'ath',50,1),(559,7496471,7496469,'fre',14.286,1),(559,7496472,7496469,'ree',14.286,1),(559,7496473,7496469,'ees',14.286,1),(559,7496474,7496469,'esp',14.286,1),(559,7496475,7496469,'spa',14.286,1),(559,7496476,7496469,'pac',14.286,1),(559,7496477,7496469,'ace',14.286,1),(559,7496478,7496471,'dis',50,1),(559,7496479,7496471,'isk',50,1),(559,7496480,7496478,'ind',33.333,1),(559,7496481,7496478,'nde',33.333,1),(559,7496482,7496478,'dex',33.333,1),(559,7496483,7496480,'adm',8.333,1),(559,7496484,7496480,'dmi',8.333,1),(559,7496485,7496480,'min',8.333,1),(559,7496486,7496480,'ini',8.333,1),(559,7496487,7496480,'nis',8.333,1),(559,7496488,7496480,'ist',8.333,1),(559,7496489,7496480,'str',8.333,1),(559,7496490,7496480,'tra',8.333,1),(559,7496491,7496480,'rat',8.333,1),(559,7496492,7496480,'ati',8.333,1),(559,7496493,7496480,'tio',8.333,1),(559,7496494,7496480,'ion',8.333,1),(559,7496495,7496483,'sta',33.333,3),(559,7496496,7496483,'tat',33.333,3),(559,7496497,7496483,'ate',33.333,3),(559,7496498,7496495,'ena',20,2),(559,7496499,7496495,'nab',20,2),(559,7496500,7496495,'abl',20,2),(559,7496501,7496495,'ble',20,2),(559,7496502,7496495,'led',20,2),(559,7496503,7496498,'cac',33.333,1),(559,7496504,7496498,'ach',33.333,1),(559,7496505,7496498,'che',33.333,1),(559,7496506,7496503,'mod',50,2),(559,7496507,7496503,'ode',50,2),(559,7496508,7496506,'wri',14.286,2),(559,7496509,7496506,'rit',14.286,2),(559,7496510,7496506,'ite',14.286,2),(559,7496511,7496506,'tet',14.286,2),(559,7496512,7496506,'eth',14.286,2),(559,7496513,7496506,'thr',14.286,2),(559,7496514,7496506,'hru',14.286,2),(559,7496515,7496508,'ope',11.111,2),(559,7496516,7496508,'per',11.111,2),(559,7496517,7496508,'era',11.111,2),(559,7496518,7496508,'rat',11.111,2),(559,7496519,7496508,'ati',11.111,2),(559,7496520,7496508,'tio',11.111,2),(559,7496521,7496508,'ion',11.111,2),(559,7496522,7496508,'ona',11.111,2),(559,7496523,7496508,'nal',11.111,2),(559,7496524,7496515,'nor',25,1),(559,7496525,7496515,'orm',25,1),(559,7496526,7496515,'rma',25,1),(559,7496527,7496515,'mal',25,1),(559,7496528,7496524,'mes',20,1),(559,7496529,7496524,'ess',20,1),(559,7496530,7496524,'ssa',20,1),(559,7496531,7496524,'sag',20,1),(559,7496532,7496524,'age',20,1),(559,7496533,7496528,'per',11.111,1),(559,7496534,7496528,'erf',11.111,1),(559,7496535,7496528,'rfo',11.111,1),(559,7496536,7496528,'for',11.111,1),(559,7496537,7496528,'orm',11.111,1),(559,7496538,7496528,'rma',11.111,1),(559,7496539,7496528,'man',11.111,1),(559,7496540,7496528,'anc',11.111,1),(559,7496541,7496528,'nce',11.111,1),(559,7496542,7496533,'ide',12.5,1),(559,7496543,7496533,'den',12.5,1),(559,7496544,7496533,'ent',12.5,1),(559,7496545,7496533,'nti',12.5,1),(559,7496546,7496533,'tif',12.5,1),(559,7496547,7496533,'ifi',12.5,1),(559,7496548,7496533,'fie',12.5,1),(559,7496549,7496533,'ier',12.5,1),(559,7496550,7496542,'vdi',33.333,3),(559,7496551,7496542,'dis',33.333,3),(559,7496552,7496542,'isk',33.333,3),(559,7496553,7496550,'nam',50,1),(559,7496554,7496550,'ame',50,1),(559,7496555,7496553,'typ',50,1),(559,7496556,7496553,'ype',50,1),(559,7496557,7496555,'dir',25,1),(559,7496558,7496555,'ire',25,1),(559,7496559,7496555,'rec',25,1),(559,7496560,7496555,'ect',25,1),(560,7496562,7496561,'naa',100,2),(560,7496563,7496562,'600',3.333,3),(560,7496564,7496562,'000',3.333,3),(560,7496565,7496562,'00c',3.333,3),(560,7496566,7496562,'0c2',3.333,3),(560,7496567,7496562,'c29',3.333,3),(560,7496568,7496562,'29a',3.333,3),(560,7496569,7496562,'9a0',3.333,3),(560,7496570,7496562,'a09',3.333,3),(560,7496571,7496562,'09f',3.333,3),(560,7496572,7496562,'9f2',3.333,3),(560,7496573,7496562,'f27',3.333,3),(560,7496574,7496562,'274',3.333,3),(560,7496575,7496562,'74b',3.333,3),(560,7496576,7496562,'4bc',3.333,3),(560,7496577,7496562,'bcd',3.333,3),(560,7496578,7496562,'cd4',3.333,3),(560,7496579,7496562,'d4b',3.333,3),(560,7496580,7496562,'4bb',3.333,3),(560,7496581,7496562,'bbf',3.333,3),(560,7496582,7496562,'bf3',3.333,3),(560,7496583,7496562,'f3a',3.333,3),(560,7496584,7496562,'3ae',3.333,3),(560,7496585,7496562,'ae4',3.333,3),(560,7496586,7496562,'e48',3.333,3),(560,7496587,7496562,'484',3.333,3),(560,7496588,7496562,'84e',3.333,3),(560,7496589,7496562,'4e5',3.333,3),(560,7496590,7496562,'e5e',3.333,3),(560,7496591,7496562,'5e7',3.333,3),(560,7496592,7496562,'e7a',3.333,3),(560,7496593,7496563,'mon',100,1),(560,7496594,7496593,'201',50,1),(560,7496595,7496593,'013',50,1),(560,7496596,7496594,'adm',33.333,3),(560,7496597,7496594,'dmi',33.333,3),(560,7496598,7496594,'min',33.333,3),(560,7496599,7496596,'cap',16.667,1),(560,7496600,7496596,'apa',16.667,1),(560,7496601,7496596,'pac',16.667,1),(560,7496602,7496596,'aci',16.667,1),(560,7496603,7496596,'cit',16.667,1),(560,7496604,7496596,'ity',16.667,1),(560,7496605,7496599,'pat',50,1),(560,7496606,7496599,'ath',50,1),(560,7496607,7496605,'fre',14.286,1),(560,7496608,7496605,'ree',14.286,1),(560,7496609,7496605,'ees',14.286,1),(560,7496610,7496605,'esp',14.286,1),(560,7496611,7496605,'spa',14.286,1),(560,7496612,7496605,'pac',14.286,1),(560,7496613,7496605,'ace',14.286,1),(560,7496614,7496607,'dis',50,1),(560,7496615,7496607,'isk',50,1),(560,7496616,7496614,'ind',33.333,1),(560,7496617,7496614,'nde',33.333,1),(560,7496618,7496614,'dex',33.333,1),(560,7496619,7496616,'adm',8.333,1),(560,7496620,7496616,'dmi',8.333,1),(560,7496621,7496616,'min',8.333,1),(560,7496622,7496616,'ini',8.333,1),(560,7496623,7496616,'nis',8.333,1),(560,7496624,7496616,'ist',8.333,1),(560,7496625,7496616,'str',8.333,1),(560,7496626,7496616,'tra',8.333,1),(560,7496627,7496616,'rat',8.333,1),(560,7496628,7496616,'ati',8.333,1),(560,7496629,7496616,'tio',8.333,1),(560,7496630,7496616,'ion',8.333,1),(560,7496631,7496619,'sta',33.333,3),(560,7496632,7496619,'tat',33.333,3),(560,7496633,7496619,'ate',33.333,3),(560,7496634,7496631,'ena',20,2),(560,7496635,7496631,'nab',20,2),(560,7496636,7496631,'abl',20,2),(560,7496637,7496631,'ble',20,2),(560,7496638,7496631,'led',20,2),(560,7496639,7496634,'cac',33.333,1),(560,7496640,7496634,'ach',33.333,1),(560,7496641,7496634,'che',33.333,1),(560,7496642,7496639,'mod',50,2),(560,7496643,7496639,'ode',50,2),(560,7496644,7496642,'wri',14.286,2),(560,7496645,7496642,'rit',14.286,2),(560,7496646,7496642,'ite',14.286,2),(560,7496647,7496642,'tet',14.286,2),(560,7496648,7496642,'eth',14.286,2),(560,7496649,7496642,'thr',14.286,2),(560,7496650,7496642,'hru',14.286,2),(560,7496651,7496644,'ope',11.111,2),(560,7496652,7496644,'per',11.111,2),(560,7496653,7496644,'era',11.111,2),(560,7496654,7496644,'rat',11.111,2),(560,7496655,7496644,'ati',11.111,2),(560,7496656,7496644,'tio',11.111,2),(560,7496657,7496644,'ion',11.111,2),(560,7496658,7496644,'ona',11.111,2),(560,7496659,7496644,'nal',11.111,2),(560,7496660,7496651,'nor',25,1),(560,7496661,7496651,'orm',25,1),(560,7496662,7496651,'rma',25,1),(560,7496663,7496651,'mal',25,1),(560,7496664,7496660,'mes',20,1),(560,7496665,7496660,'ess',20,1),(560,7496666,7496660,'ssa',20,1),(560,7496667,7496660,'sag',20,1),(560,7496668,7496660,'age',20,1),(560,7496669,7496664,'per',11.111,1),(560,7496670,7496664,'erf',11.111,1),(560,7496671,7496664,'rfo',11.111,1),(560,7496672,7496664,'for',11.111,1),(560,7496673,7496664,'orm',11.111,1),(560,7496674,7496664,'rma',11.111,1),(560,7496675,7496664,'man',11.111,1),(560,7496676,7496664,'anc',11.111,1),(560,7496677,7496664,'nce',11.111,1),(560,7496678,7496669,'ide',12.5,1),(560,7496679,7496669,'den',12.5,1),(560,7496680,7496669,'ent',12.5,1),(560,7496681,7496669,'nti',12.5,1),(560,7496682,7496669,'tif',12.5,1),(560,7496683,7496669,'ifi',12.5,1),(560,7496684,7496669,'fie',12.5,1),(560,7496685,7496669,'ier',12.5,1),(560,7496686,7496678,'vdi',33.333,3),(560,7496687,7496678,'dis',33.333,3),(560,7496688,7496678,'isk',33.333,3),(560,7496689,7496686,'nam',50,1),(560,7496690,7496686,'ame',50,1),(560,7496691,7496689,'typ',50,1),(560,7496692,7496689,'ype',50,1),(560,7496693,7496691,'dir',25,1),(560,7496694,7496691,'ire',25,1),(560,7496695,7496691,'rec',25,1),(560,7496696,7496691,'ect',25,1),(561,7496698,7496697,'naa',100,2),(561,7496699,7496698,'600',3.333,3),(561,7496700,7496698,'000',3.333,3),(561,7496701,7496698,'00c',3.333,3),(561,7496702,7496698,'0c2',3.333,3),(561,7496703,7496698,'c29',3.333,3),(561,7496704,7496698,'29a',3.333,3),(561,7496705,7496698,'9ac',3.333,3),(561,7496706,7496698,'ac8',3.333,3),(561,7496707,7496698,'c85',3.333,3),(561,7496708,7496698,'85e',3.333,3),(561,7496709,7496698,'5e6',3.333,3),(561,7496710,7496698,'e6f',3.333,3),(561,7496711,7496698,'6f8',3.333,3),(561,7496712,7496698,'f88',3.333,3),(561,7496713,7496698,'88a',3.333,3),(561,7496714,7496698,'8af',3.333,3),(561,7496715,7496698,'af7',3.333,3),(561,7496716,7496698,'f7b',3.333,3),(561,7496717,7496698,'7b4',3.333,3),(561,7496718,7496698,'b4f',3.333,3),(561,7496719,7496698,'4f6',3.333,3),(561,7496720,7496698,'f68',3.333,3),(561,7496721,7496698,'686',3.333,3),(561,7496722,7496698,'868',3.333,3),(561,7496723,7496698,'68f',3.333,3),(561,7496724,7496698,'8fb',3.333,3),(561,7496725,7496698,'fbe',3.333,3),(561,7496726,7496698,'be8',3.333,3),(561,7496727,7496698,'e87',3.333,3),(561,7496728,7496698,'87a',3.333,3),(561,7496729,7496699,'mon',100,1),(561,7496730,7496729,'201',50,1),(561,7496731,7496729,'013',50,1),(561,7496732,7496730,'adm',33.333,3),(561,7496733,7496730,'dmi',33.333,3),(561,7496734,7496730,'min',33.333,3),(561,7496735,7496732,'cap',16.667,1),(561,7496736,7496732,'apa',16.667,1),(561,7496737,7496732,'pac',16.667,1),(561,7496738,7496732,'aci',16.667,1),(561,7496739,7496732,'cit',16.667,1),(561,7496740,7496732,'ity',16.667,1),(561,7496741,7496735,'pat',50,1),(561,7496742,7496735,'ath',50,1),(561,7496743,7496741,'fre',14.286,1),(561,7496744,7496741,'ree',14.286,1),(561,7496745,7496741,'ees',14.286,1),(561,7496746,7496741,'esp',14.286,1),(561,7496747,7496741,'spa',14.286,1),(561,7496748,7496741,'pac',14.286,1),(561,7496749,7496741,'ace',14.286,1),(561,7496750,7496743,'dis',50,1),(561,7496751,7496743,'isk',50,1),(561,7496752,7496750,'ind',33.333,1),(561,7496753,7496750,'nde',33.333,1),(561,7496754,7496750,'dex',33.333,1),(561,7496755,7496752,'adm',8.333,1),(561,7496756,7496752,'dmi',8.333,1),(561,7496757,7496752,'min',8.333,1),(561,7496758,7496752,'ini',8.333,1),(561,7496759,7496752,'nis',8.333,1),(561,7496760,7496752,'ist',8.333,1),(561,7496761,7496752,'str',8.333,1),(561,7496762,7496752,'tra',8.333,1),(561,7496763,7496752,'rat',8.333,1),(561,7496764,7496752,'ati',8.333,1),(561,7496765,7496752,'tio',8.333,1),(561,7496766,7496752,'ion',8.333,1),(561,7496767,7496755,'sta',33.333,3),(561,7496768,7496755,'tat',33.333,3),(561,7496769,7496755,'ate',33.333,3),(561,7496770,7496767,'ena',20,2),(561,7496771,7496767,'nab',20,2),(561,7496772,7496767,'abl',20,2),(561,7496773,7496767,'ble',20,2),(561,7496774,7496767,'led',20,2),(561,7496775,7496770,'cac',33.333,1),(561,7496776,7496770,'ach',33.333,1),(561,7496777,7496770,'che',33.333,1),(561,7496778,7496775,'mod',50,2),(561,7496779,7496775,'ode',50,2),(561,7496780,7496778,'wri',14.286,2),(561,7496781,7496778,'rit',14.286,2),(561,7496782,7496778,'ite',14.286,2),(561,7496783,7496778,'tet',14.286,2),(561,7496784,7496778,'eth',14.286,2),(561,7496785,7496778,'thr',14.286,2),(561,7496786,7496778,'hru',14.286,2),(561,7496787,7496780,'ope',11.111,2),(561,7496788,7496780,'per',11.111,2),(561,7496789,7496780,'era',11.111,2),(561,7496790,7496780,'rat',11.111,2),(561,7496791,7496780,'ati',11.111,2),(561,7496792,7496780,'tio',11.111,2),(561,7496793,7496780,'ion',11.111,2),(561,7496794,7496780,'ona',11.111,2),(561,7496795,7496780,'nal',11.111,2),(561,7496796,7496787,'nor',25,1),(561,7496797,7496787,'orm',25,1),(561,7496798,7496787,'rma',25,1),(561,7496799,7496787,'mal',25,1),(561,7496800,7496796,'mes',20,1),(561,7496801,7496796,'ess',20,1),(561,7496802,7496796,'ssa',20,1),(561,7496803,7496796,'sag',20,1),(561,7496804,7496796,'age',20,1),(561,7496805,7496800,'per',11.111,1),(561,7496806,7496800,'erf',11.111,1),(561,7496807,7496800,'rfo',11.111,1),(561,7496808,7496800,'for',11.111,1),(561,7496809,7496800,'orm',11.111,1),(561,7496810,7496800,'rma',11.111,1),(561,7496811,7496800,'man',11.111,1),(561,7496812,7496800,'anc',11.111,1),(561,7496813,7496800,'nce',11.111,1),(561,7496814,7496805,'ide',12.5,1),(561,7496815,7496805,'den',12.5,1),(561,7496816,7496805,'ent',12.5,1),(561,7496817,7496805,'nti',12.5,1),(561,7496818,7496805,'tif',12.5,1),(561,7496819,7496805,'ifi',12.5,1),(561,7496820,7496805,'fie',12.5,1),(561,7496821,7496805,'ier',12.5,1),(561,7496822,7496814,'vdi',33.333,3),(561,7496823,7496814,'dis',33.333,3),(561,7496824,7496814,'isk',33.333,3),(561,7496825,7496822,'nam',50,1),(561,7496826,7496822,'ame',50,1),(561,7496827,7496825,'typ',50,1),(561,7496828,7496825,'ype',50,1),(561,7496829,7496827,'dir',25,1),(561,7496830,7496827,'ire',25,1),(561,7496831,7496827,'rec',25,1),(561,7496832,7496827,'ect',25,1),(562,7496834,7496833,'naa',100,2),(562,7496835,7496834,'600',3.333,3),(562,7496836,7496834,'000',3.333,3),(562,7496837,7496834,'00c',3.333,3),(562,7496838,7496834,'0c2',3.333,3),(562,7496839,7496834,'c29',3.333,3),(562,7496840,7496834,'294',3.333,3),(562,7496841,7496834,'940',3.333,3),(562,7496842,7496834,'40c',3.333,3),(562,7496843,7496834,'0cc',3.333,3),(562,7496844,7496834,'cc5',3.333,3),(562,7496845,7496834,'c5b',3.333,3),(562,7496846,7496834,'5bf',3.333,3),(562,7496847,7496834,'bf4',3.333,3),(562,7496848,7496834,'f41',3.333,3),(562,7496849,7496834,'413',3.333,3),(562,7496850,7496834,'131',3.333,3),(562,7496851,7496834,'316',3.333,3),(562,7496852,7496834,'16a',3.333,3),(562,7496853,7496834,'6a5',3.333,3),(562,7496854,7496834,'a55',3.333,3),(562,7496855,7496834,'55e',3.333,3),(562,7496856,7496834,'5e0',3.333,3),(562,7496857,7496834,'e0c',3.333,3),(562,7496858,7496834,'0c9',3.333,3),(562,7496859,7496834,'c94',3.333,3),(562,7496860,7496834,'949',3.333,3),(562,7496861,7496834,'495',3.333,3),(562,7496862,7496834,'957',3.333,3),(562,7496863,7496834,'57c',3.333,3),(562,7496864,7496834,'7c8',3.333,3),(562,7496865,7496835,'mon',100,1),(562,7496866,7496865,'201',50,1),(562,7496867,7496865,'013',50,1),(562,7496868,7496866,'adm',33.333,3),(562,7496869,7496866,'dmi',33.333,3),(562,7496870,7496866,'min',33.333,3),(562,7496871,7496868,'cap',16.667,1),(562,7496872,7496868,'apa',16.667,1),(562,7496873,7496868,'pac',16.667,1),(562,7496874,7496868,'aci',16.667,1),(562,7496875,7496868,'cit',16.667,1),(562,7496876,7496868,'ity',16.667,1),(562,7496877,7496871,'pat',50,1),(562,7496878,7496871,'ath',50,1),(562,7496879,7496877,'fre',14.286,1),(562,7496880,7496877,'ree',14.286,1),(562,7496881,7496877,'ees',14.286,1),(562,7496882,7496877,'esp',14.286,1),(562,7496883,7496877,'spa',14.286,1),(562,7496884,7496877,'pac',14.286,1),(562,7496885,7496877,'ace',14.286,1),(562,7496886,7496879,'dis',50,1),(562,7496887,7496879,'isk',50,1),(562,7496888,7496886,'ind',33.333,1),(562,7496889,7496886,'nde',33.333,1),(562,7496890,7496886,'dex',33.333,1),(562,7496891,7496888,'adm',8.333,1),(562,7496892,7496888,'dmi',8.333,1),(562,7496893,7496888,'min',8.333,1),(562,7496894,7496888,'ini',8.333,1),(562,7496895,7496888,'nis',8.333,1),(562,7496896,7496888,'ist',8.333,1),(562,7496897,7496888,'str',8.333,1),(562,7496898,7496888,'tra',8.333,1),(562,7496899,7496888,'rat',8.333,1),(562,7496900,7496888,'ati',8.333,1),(562,7496901,7496888,'tio',8.333,1),(562,7496902,7496888,'ion',8.333,1),(562,7496903,7496891,'sta',33.333,3),(562,7496904,7496891,'tat',33.333,3),(562,7496905,7496891,'ate',33.333,3),(562,7496906,7496903,'ena',20,2),(562,7496907,7496903,'nab',20,2),(562,7496908,7496903,'abl',20,2),(562,7496909,7496903,'ble',20,2),(562,7496910,7496903,'led',20,2),(562,7496911,7496906,'cac',33.333,1),(562,7496912,7496906,'ach',33.333,1),(562,7496913,7496906,'che',33.333,1),(562,7496914,7496911,'mod',50,2),(562,7496915,7496911,'ode',50,2),(562,7496916,7496914,'wri',14.286,2),(562,7496917,7496914,'rit',14.286,2),(562,7496918,7496914,'ite',14.286,2),(562,7496919,7496914,'tet',14.286,2),(562,7496920,7496914,'eth',14.286,2),(562,7496921,7496914,'thr',14.286,2),(562,7496922,7496914,'hru',14.286,2),(562,7496923,7496916,'ope',11.111,2),(562,7496924,7496916,'per',11.111,2),(562,7496925,7496916,'era',11.111,2),(562,7496926,7496916,'rat',11.111,2),(562,7496927,7496916,'ati',11.111,2),(562,7496928,7496916,'tio',11.111,2),(562,7496929,7496916,'ion',11.111,2),(562,7496930,7496916,'ona',11.111,2),(562,7496931,7496916,'nal',11.111,2),(562,7496932,7496923,'nor',25,1),(562,7496933,7496923,'orm',25,1),(562,7496934,7496923,'rma',25,1),(562,7496935,7496923,'mal',25,1),(562,7496936,7496932,'mes',20,1),(562,7496937,7496932,'ess',20,1),(562,7496938,7496932,'ssa',20,1),(562,7496939,7496932,'sag',20,1),(562,7496940,7496932,'age',20,1),(562,7496941,7496936,'per',11.111,1),(562,7496942,7496936,'erf',11.111,1),(562,7496943,7496936,'rfo',11.111,1),(562,7496944,7496936,'for',11.111,1),(562,7496945,7496936,'orm',11.111,1),(562,7496946,7496936,'rma',11.111,1),(562,7496947,7496936,'man',11.111,1),(562,7496948,7496936,'anc',11.111,1),(562,7496949,7496936,'nce',11.111,1),(562,7496950,7496941,'ide',12.5,1),(562,7496951,7496941,'den',12.5,1),(562,7496952,7496941,'ent',12.5,1),(562,7496953,7496941,'nti',12.5,1),(562,7496954,7496941,'tif',12.5,1),(562,7496955,7496941,'ifi',12.5,1),(562,7496956,7496941,'fie',12.5,1),(562,7496957,7496941,'ier',12.5,1),(562,7496958,7496950,'vdi',33.333,3),(562,7496959,7496950,'dis',33.333,3),(562,7496960,7496950,'isk',33.333,3),(562,7496961,7496958,'nam',50,1),(562,7496962,7496958,'ame',50,1),(562,7496963,7496961,'typ',50,1),(562,7496964,7496961,'ype',50,1),(562,7496965,7496963,'dir',25,1),(562,7496966,7496963,'ire',25,1),(562,7496967,7496963,'rec',25,1),(562,7496968,7496963,'ect',25,1),(563,7496970,7496969,'naa',100,2),(563,7496971,7496970,'600',3.333,3),(563,7496972,7496970,'000',3.333,3),(563,7496973,7496970,'00c',3.333,3),(563,7496974,7496970,'0c2',3.333,3),(563,7496975,7496970,'c29',3.333,3),(563,7496976,7496970,'29d',3.333,3),(563,7496977,7496970,'9d4',3.333,3),(563,7496978,7496970,'d4e',3.333,3),(563,7496979,7496970,'4e2',3.333,3),(563,7496980,7496970,'e2c',3.333,3),(563,7496981,7496970,'2ce',3.333,3),(563,7496982,7496970,'ce7',3.333,3),(563,7496983,7496970,'e7b',3.333,3),(563,7496984,7496970,'7b7',3.333,3),(563,7496985,7496970,'b70',3.333,3),(563,7496986,7496970,'705',3.333,3),(563,7496987,7496970,'05f',3.333,3),(563,7496988,7496970,'5f6',3.333,3),(563,7496989,7496970,'f66',3.333,3),(563,7496990,7496970,'66f',3.333,3),(563,7496991,7496970,'6fd',3.333,3),(563,7496992,7496970,'fdb',3.333,3),(563,7496993,7496970,'dbd',3.333,3),(563,7496994,7496970,'bdb',3.333,3),(563,7496995,7496970,'db4',3.333,3),(563,7496996,7496970,'b46',3.333,3),(563,7496997,7496970,'461',3.333,3),(563,7496998,7496970,'613',3.333,3),(563,7496999,7496970,'131',3.333,3),(563,7497000,7496970,'313',3.333,3),(563,7497001,7496971,'mon',100,1),(563,7497002,7497001,'201',50,1),(563,7497003,7497001,'013',50,1),(563,7497004,7497002,'adm',33.333,3),(563,7497005,7497002,'dmi',33.333,3),(563,7497006,7497002,'min',33.333,3),(563,7497007,7497004,'cap',16.667,1),(563,7497008,7497004,'apa',16.667,1),(563,7497009,7497004,'pac',16.667,1),(563,7497010,7497004,'aci',16.667,1),(563,7497011,7497004,'cit',16.667,1),(563,7497012,7497004,'ity',16.667,1),(563,7497013,7497007,'pat',50,1),(563,7497014,7497007,'ath',50,1),(563,7497015,7497013,'fre',14.286,1),(563,7497016,7497013,'ree',14.286,1),(563,7497017,7497013,'ees',14.286,1),(563,7497018,7497013,'esp',14.286,1),(563,7497019,7497013,'spa',14.286,1),(563,7497020,7497013,'pac',14.286,1),(563,7497021,7497013,'ace',14.286,1),(563,7497022,7497015,'dis',50,1),(563,7497023,7497015,'isk',50,1),(563,7497024,7497022,'ind',33.333,1),(563,7497025,7497022,'nde',33.333,1),(563,7497026,7497022,'dex',33.333,1),(563,7497027,7497024,'adm',8.333,1),(563,7497028,7497024,'dmi',8.333,1),(563,7497029,7497024,'min',8.333,1),(563,7497030,7497024,'ini',8.333,1),(563,7497031,7497024,'nis',8.333,1),(563,7497032,7497024,'ist',8.333,1),(563,7497033,7497024,'str',8.333,1),(563,7497034,7497024,'tra',8.333,1),(563,7497035,7497024,'rat',8.333,1),(563,7497036,7497024,'ati',8.333,1),(563,7497037,7497024,'tio',8.333,1),(563,7497038,7497024,'ion',8.333,1),(563,7497039,7497027,'sta',33.333,3),(563,7497040,7497027,'tat',33.333,3),(563,7497041,7497027,'ate',33.333,3),(563,7497042,7497039,'ena',20,2),(563,7497043,7497039,'nab',20,2),(563,7497044,7497039,'abl',20,2),(563,7497045,7497039,'ble',20,2),(563,7497046,7497039,'led',20,2),(563,7497047,7497042,'cac',33.333,1),(563,7497048,7497042,'ach',33.333,1),(563,7497049,7497042,'che',33.333,1),(563,7497050,7497047,'mod',50,2),(563,7497051,7497047,'ode',50,2),(563,7497052,7497050,'wri',14.286,2),(563,7497053,7497050,'rit',14.286,2),(563,7497054,7497050,'ite',14.286,2),(563,7497055,7497050,'tet',14.286,2),(563,7497056,7497050,'eth',14.286,2),(563,7497057,7497050,'thr',14.286,2),(563,7497058,7497050,'hru',14.286,2),(563,7497059,7497052,'ope',11.111,2),(563,7497060,7497052,'per',11.111,2),(563,7497061,7497052,'era',11.111,2),(563,7497062,7497052,'rat',11.111,2),(563,7497063,7497052,'ati',11.111,2),(563,7497064,7497052,'tio',11.111,2),(563,7497065,7497052,'ion',11.111,2),(563,7497066,7497052,'ona',11.111,2),(563,7497067,7497052,'nal',11.111,2),(563,7497068,7497059,'nor',25,1),(563,7497069,7497059,'orm',25,1),(563,7497070,7497059,'rma',25,1),(563,7497071,7497059,'mal',25,1),(563,7497072,7497068,'mes',20,1),(563,7497073,7497068,'ess',20,1),(563,7497074,7497068,'ssa',20,1),(563,7497075,7497068,'sag',20,1),(563,7497076,7497068,'age',20,1),(563,7497077,7497072,'per',11.111,1),(563,7497078,7497072,'erf',11.111,1),(563,7497079,7497072,'rfo',11.111,1),(563,7497080,7497072,'for',11.111,1),(563,7497081,7497072,'orm',11.111,1),(563,7497082,7497072,'rma',11.111,1),(563,7497083,7497072,'man',11.111,1),(563,7497084,7497072,'anc',11.111,1),(563,7497085,7497072,'nce',11.111,1),(563,7497086,7497077,'ide',12.5,1),(563,7497087,7497077,'den',12.5,1),(563,7497088,7497077,'ent',12.5,1),(563,7497089,7497077,'nti',12.5,1),(563,7497090,7497077,'tif',12.5,1),(563,7497091,7497077,'ifi',12.5,1),(563,7497092,7497077,'fie',12.5,1),(563,7497093,7497077,'ier',12.5,1),(563,7497094,7497086,'vdi',33.333,3),(563,7497095,7497086,'dis',33.333,3),(563,7497096,7497086,'isk',33.333,3),(563,7497097,7497094,'nam',50,1),(563,7497098,7497094,'ame',50,1),(563,7497099,7497097,'typ',50,1),(563,7497100,7497097,'ype',50,1),(563,7497101,7497099,'dir',25,1),(563,7497102,7497099,'ire',25,1),(563,7497103,7497099,'rec',25,1),(563,7497104,7497099,'ect',25,1),(564,7497106,7497105,'naa',100,2),(564,7497107,7497106,'600',3.333,3),(564,7497108,7497106,'000',3.333,3),(564,7497109,7497106,'00c',3.333,3),(564,7497110,7497106,'0c2',3.333,3),(564,7497111,7497106,'c29',3.333,3),(564,7497112,7497106,'29a',3.333,3),(564,7497113,7497106,'9aa',3.333,3),(564,7497114,7497106,'aab',3.333,3),(564,7497115,7497106,'ab2',3.333,3),(564,7497116,7497106,'b2e',3.333,3),(564,7497117,7497106,'2e0',3.333,3),(564,7497118,7497106,'e04',3.333,3),(564,7497119,7497106,'04f',3.333,3),(564,7497120,7497106,'4f2',3.333,3),(564,7497121,7497106,'f25',3.333,3),(564,7497122,7497106,'257',3.333,3),(564,7497123,7497106,'571',3.333,3),(564,7497124,7497106,'71c',3.333,3),(564,7497125,7497106,'1c7',3.333,3),(564,7497126,7497106,'c7c',3.333,3),(564,7497127,7497106,'7c6',3.333,3),(564,7497128,7497106,'c60',3.333,3),(564,7497129,7497106,'605',3.333,3),(564,7497130,7497106,'050',3.333,3),(564,7497131,7497106,'50e',3.333,3),(564,7497132,7497106,'0ee',3.333,3),(564,7497133,7497106,'ee8',3.333,3),(564,7497134,7497106,'e83',3.333,3),(564,7497135,7497106,'835',3.333,3),(564,7497136,7497106,'353',3.333,3),(564,7497137,7497107,'mon',100,1),(564,7497138,7497137,'201',50,1),(564,7497139,7497137,'013',50,1),(564,7497140,7497138,'adm',33.333,3),(564,7497141,7497138,'dmi',33.333,3),(564,7497142,7497138,'min',33.333,3),(564,7497143,7497140,'cap',16.667,1),(564,7497144,7497140,'apa',16.667,1),(564,7497145,7497140,'pac',16.667,1),(564,7497146,7497140,'aci',16.667,1),(564,7497147,7497140,'cit',16.667,1),(564,7497148,7497140,'ity',16.667,1),(564,7497149,7497143,'pat',50,1),(564,7497150,7497143,'ath',50,1),(564,7497151,7497149,'fre',14.286,1),(564,7497152,7497149,'ree',14.286,1),(564,7497153,7497149,'ees',14.286,1),(564,7497154,7497149,'esp',14.286,1),(564,7497155,7497149,'spa',14.286,1),(564,7497156,7497149,'pac',14.286,1),(564,7497157,7497149,'ace',14.286,1),(564,7497158,7497151,'dis',50,1),(564,7497159,7497151,'isk',50,1),(564,7497160,7497158,'ind',33.333,1),(564,7497161,7497158,'nde',33.333,1),(564,7497162,7497158,'dex',33.333,1),(564,7497163,7497160,'adm',8.333,1),(564,7497164,7497160,'dmi',8.333,1),(564,7497165,7497160,'min',8.333,1),(564,7497166,7497160,'ini',8.333,1),(564,7497167,7497160,'nis',8.333,1),(564,7497168,7497160,'ist',8.333,1),(564,7497169,7497160,'str',8.333,1),(564,7497170,7497160,'tra',8.333,1),(564,7497171,7497160,'rat',8.333,1),(564,7497172,7497160,'ati',8.333,1),(564,7497173,7497160,'tio',8.333,1),(564,7497174,7497160,'ion',8.333,1),(564,7497175,7497163,'sta',33.333,3),(564,7497176,7497163,'tat',33.333,3),(564,7497177,7497163,'ate',33.333,3),(564,7497178,7497175,'ena',20,2),(564,7497179,7497175,'nab',20,2),(564,7497180,7497175,'abl',20,2),(564,7497181,7497175,'ble',20,2),(564,7497182,7497175,'led',20,2),(564,7497183,7497178,'cac',33.333,1),(564,7497184,7497178,'ach',33.333,1),(564,7497185,7497178,'che',33.333,1),(564,7497186,7497183,'mod',50,2),(564,7497187,7497183,'ode',50,2),(564,7497188,7497186,'wri',14.286,2),(564,7497189,7497186,'rit',14.286,2),(564,7497190,7497186,'ite',14.286,2),(564,7497191,7497186,'tet',14.286,2),(564,7497192,7497186,'eth',14.286,2),(564,7497193,7497186,'thr',14.286,2),(564,7497194,7497186,'hru',14.286,2),(564,7497195,7497188,'ope',11.111,2),(564,7497196,7497188,'per',11.111,2),(564,7497197,7497188,'era',11.111,2),(564,7497198,7497188,'rat',11.111,2),(564,7497199,7497188,'ati',11.111,2),(564,7497200,7497188,'tio',11.111,2),(564,7497201,7497188,'ion',11.111,2),(564,7497202,7497188,'ona',11.111,2),(564,7497203,7497188,'nal',11.111,2),(564,7497204,7497195,'nor',25,1),(564,7497205,7497195,'orm',25,1),(564,7497206,7497195,'rma',25,1),(564,7497207,7497195,'mal',25,1),(564,7497208,7497204,'mes',20,1),(564,7497209,7497204,'ess',20,1),(564,7497210,7497204,'ssa',20,1),(564,7497211,7497204,'sag',20,1),(564,7497212,7497204,'age',20,1),(564,7497213,7497208,'per',11.111,1),(564,7497214,7497208,'erf',11.111,1),(564,7497215,7497208,'rfo',11.111,1),(564,7497216,7497208,'for',11.111,1),(564,7497217,7497208,'orm',11.111,1),(564,7497218,7497208,'rma',11.111,1),(564,7497219,7497208,'man',11.111,1),(564,7497220,7497208,'anc',11.111,1),(564,7497221,7497208,'nce',11.111,1),(564,7497222,7497213,'ide',12.5,1),(564,7497223,7497213,'den',12.5,1),(564,7497224,7497213,'ent',12.5,1),(564,7497225,7497213,'nti',12.5,1),(564,7497226,7497213,'tif',12.5,1),(564,7497227,7497213,'ifi',12.5,1),(564,7497228,7497213,'fie',12.5,1),(564,7497229,7497213,'ier',12.5,1),(564,7497230,7497222,'vdi',33.333,3),(564,7497231,7497222,'dis',33.333,3),(564,7497232,7497222,'isk',33.333,3),(564,7497233,7497230,'nam',50,1),(564,7497234,7497230,'ame',50,1),(564,7497235,7497233,'typ',50,1),(564,7497236,7497233,'ype',50,1),(564,7497237,7497235,'dir',25,1),(564,7497238,7497235,'ire',25,1),(564,7497239,7497235,'rec',25,1),(564,7497240,7497235,'ect',25,1),(565,7497242,7497241,'naa',100,2),(565,7497243,7497242,'600',3.333,3),(565,7497244,7497242,'000',3.333,3),(565,7497245,7497242,'00c',3.333,3),(565,7497246,7497242,'0c2',3.333,3),(565,7497247,7497242,'c29',3.333,3),(565,7497248,7497242,'294',3.333,3),(565,7497249,7497242,'940',3.333,3),(565,7497250,7497242,'406',3.333,3),(565,7497251,7497242,'064',3.333,3),(565,7497252,7497242,'64b',3.333,3),(565,7497253,7497242,'4b8',3.333,3),(565,7497254,7497242,'b8b',3.333,3),(565,7497255,7497242,'8b3',3.333,3),(565,7497256,7497242,'b30',3.333,3),(565,7497257,7497242,'30c',3.333,3),(565,7497258,7497242,'0c8',3.333,3),(565,7497259,7497242,'c84',3.333,3),(565,7497260,7497242,'845',3.333,3),(565,7497261,7497242,'452',3.333,3),(565,7497262,7497242,'52c',3.333,3),(565,7497263,7497242,'2ce',3.333,3),(565,7497264,7497242,'cef',3.333,3),(565,7497265,7497242,'ef9',3.333,3),(565,7497266,7497242,'f95',3.333,3),(565,7497267,7497242,'950',3.333,3),(565,7497268,7497242,'506',3.333,3),(565,7497269,7497242,'062',3.333,3),(565,7497270,7497242,'62d',3.333,3),(565,7497271,7497242,'2d7',3.333,3),(565,7497272,7497242,'d75',3.333,3),(565,7497273,7497243,'mon',100,1),(565,7497274,7497273,'201',50,1),(565,7497275,7497273,'013',50,1),(565,7497276,7497274,'adm',33.333,3),(565,7497277,7497274,'dmi',33.333,3),(565,7497278,7497274,'min',33.333,3),(565,7497279,7497276,'cap',16.667,1),(565,7497280,7497276,'apa',16.667,1),(565,7497281,7497276,'pac',16.667,1),(565,7497282,7497276,'aci',16.667,1),(565,7497283,7497276,'cit',16.667,1),(565,7497284,7497276,'ity',16.667,1),(565,7497285,7497279,'pat',50,1),(565,7497286,7497279,'ath',50,1),(565,7497287,7497285,'fre',14.286,1),(565,7497288,7497285,'ree',14.286,1),(565,7497289,7497285,'ees',14.286,1),(565,7497290,7497285,'esp',14.286,1),(565,7497291,7497285,'spa',14.286,1),(565,7497292,7497285,'pac',14.286,1),(565,7497293,7497285,'ace',14.286,1),(565,7497294,7497287,'dis',50,1),(565,7497295,7497287,'isk',50,1),(565,7497296,7497294,'ind',33.333,1),(565,7497297,7497294,'nde',33.333,1),(565,7497298,7497294,'dex',33.333,1),(565,7497299,7497296,'adm',8.333,1),(565,7497300,7497296,'dmi',8.333,1),(565,7497301,7497296,'min',8.333,1),(565,7497302,7497296,'ini',8.333,1),(565,7497303,7497296,'nis',8.333,1),(565,7497304,7497296,'ist',8.333,1),(565,7497305,7497296,'str',8.333,1),(565,7497306,7497296,'tra',8.333,1),(565,7497307,7497296,'rat',8.333,1),(565,7497308,7497296,'ati',8.333,1),(565,7497309,7497296,'tio',8.333,1),(565,7497310,7497296,'ion',8.333,1),(565,7497311,7497299,'sta',33.333,3),(565,7497312,7497299,'tat',33.333,3),(565,7497313,7497299,'ate',33.333,3),(565,7497314,7497311,'ena',20,2),(565,7497315,7497311,'nab',20,2),(565,7497316,7497311,'abl',20,2),(565,7497317,7497311,'ble',20,2),(565,7497318,7497311,'led',20,2),(565,7497319,7497314,'cac',33.333,1),(565,7497320,7497314,'ach',33.333,1),(565,7497321,7497314,'che',33.333,1),(565,7497322,7497319,'mod',50,2),(565,7497323,7497319,'ode',50,2),(565,7497324,7497322,'wri',14.286,2),(565,7497325,7497322,'rit',14.286,2),(565,7497326,7497322,'ite',14.286,2),(565,7497327,7497322,'tet',14.286,2),(565,7497328,7497322,'eth',14.286,2),(565,7497329,7497322,'thr',14.286,2),(565,7497330,7497322,'hru',14.286,2),(565,7497331,7497324,'ope',11.111,2),(565,7497332,7497324,'per',11.111,2),(565,7497333,7497324,'era',11.111,2),(565,7497334,7497324,'rat',11.111,2),(565,7497335,7497324,'ati',11.111,2),(565,7497336,7497324,'tio',11.111,2),(565,7497337,7497324,'ion',11.111,2),(565,7497338,7497324,'ona',11.111,2),(565,7497339,7497324,'nal',11.111,2),(565,7497340,7497331,'nor',25,1),(565,7497341,7497331,'orm',25,1),(565,7497342,7497331,'rma',25,1),(565,7497343,7497331,'mal',25,1),(565,7497344,7497340,'mes',20,1),(565,7497345,7497340,'ess',20,1),(565,7497346,7497340,'ssa',20,1),(565,7497347,7497340,'sag',20,1),(565,7497348,7497340,'age',20,1),(565,7497349,7497344,'per',11.111,1),(565,7497350,7497344,'erf',11.111,1),(565,7497351,7497344,'rfo',11.111,1),(565,7497352,7497344,'for',11.111,1),(565,7497353,7497344,'orm',11.111,1),(565,7497354,7497344,'rma',11.111,1),(565,7497355,7497344,'man',11.111,1),(565,7497356,7497344,'anc',11.111,1),(565,7497357,7497344,'nce',11.111,1),(565,7497358,7497349,'ide',12.5,1),(565,7497359,7497349,'den',12.5,1),(565,7497360,7497349,'ent',12.5,1),(565,7497361,7497349,'nti',12.5,1),(565,7497362,7497349,'tif',12.5,1),(565,7497363,7497349,'ifi',12.5,1),(565,7497364,7497349,'fie',12.5,1),(565,7497365,7497349,'ier',12.5,1),(565,7497366,7497358,'vdi',33.333,3),(565,7497367,7497358,'dis',33.333,3),(565,7497368,7497358,'isk',33.333,3),(565,7497369,7497366,'nam',50,1),(565,7497370,7497366,'ame',50,1),(565,7497371,7497369,'typ',50,1),(565,7497372,7497369,'ype',50,1),(565,7497373,7497371,'dir',25,1),(565,7497374,7497371,'ire',25,1),(565,7497375,7497371,'rec',25,1),(565,7497376,7497371,'ect',25,1),(566,7497378,7497377,'naa',100,2),(566,7497379,7497378,'600',3.333,3),(566,7497380,7497378,'000',3.333,3),(566,7497381,7497378,'00c',3.333,3),(566,7497382,7497378,'0c2',3.333,3),(566,7497383,7497378,'c29',3.333,3),(566,7497384,7497378,'29a',3.333,3),(566,7497385,7497378,'9a1',3.333,3),(566,7497386,7497378,'a1b',3.333,3),(566,7497387,7497378,'1b4',3.333,3),(566,7497388,7497378,'b45',3.333,3),(566,7497389,7497378,'45e',3.333,3),(566,7497390,7497378,'5ee',3.333,3),(566,7497391,7497378,'eea',3.333,3),(566,7497392,7497378,'eac',3.333,3),(566,7497393,7497378,'ace',3.333,3),(566,7497394,7497378,'ce0',3.333,3),(566,7497395,7497378,'e00',3.333,3),(566,7497396,7497378,'004',3.333,3),(566,7497397,7497378,'049',3.333,3),(566,7497398,7497378,'496',3.333,3),(566,7497399,7497378,'969',3.333,3),(566,7497400,7497378,'699',3.333,3),(566,7497401,7497378,'99f',3.333,3),(566,7497402,7497378,'9f7',3.333,3),(566,7497403,7497378,'f71',3.333,3),(566,7497404,7497378,'712',3.333,3),(566,7497405,7497378,'123',3.333,3),(566,7497406,7497378,'23c',3.333,3),(566,7497407,7497378,'3c2',3.333,3),(566,7497408,7497378,'c20',3.333,3),(566,7497409,7497379,'mon',100,1),(566,7497410,7497409,'201',50,1),(566,7497411,7497409,'013',50,1),(566,7497412,7497410,'adm',33.333,3),(566,7497413,7497410,'dmi',33.333,3),(566,7497414,7497410,'min',33.333,3),(566,7497415,7497412,'cap',16.667,1),(566,7497416,7497412,'apa',16.667,1),(566,7497417,7497412,'pac',16.667,1),(566,7497418,7497412,'aci',16.667,1),(566,7497419,7497412,'cit',16.667,1),(566,7497420,7497412,'ity',16.667,1),(566,7497421,7497415,'pat',50,1),(566,7497422,7497415,'ath',50,1),(566,7497423,7497421,'fre',14.286,1),(566,7497424,7497421,'ree',14.286,1),(566,7497425,7497421,'ees',14.286,1),(566,7497426,7497421,'esp',14.286,1),(566,7497427,7497421,'spa',14.286,1),(566,7497428,7497421,'pac',14.286,1),(566,7497429,7497421,'ace',14.286,1),(566,7497430,7497423,'dis',50,1),(566,7497431,7497423,'isk',50,1),(566,7497432,7497430,'ind',33.333,1),(566,7497433,7497430,'nde',33.333,1),(566,7497434,7497430,'dex',33.333,1),(566,7497435,7497432,'adm',8.333,1),(566,7497436,7497432,'dmi',8.333,1),(566,7497437,7497432,'min',8.333,1),(566,7497438,7497432,'ini',8.333,1),(566,7497439,7497432,'nis',8.333,1),(566,7497440,7497432,'ist',8.333,1),(566,7497441,7497432,'str',8.333,1),(566,7497442,7497432,'tra',8.333,1),(566,7497443,7497432,'rat',8.333,1),(566,7497444,7497432,'ati',8.333,1),(566,7497445,7497432,'tio',8.333,1),(566,7497446,7497432,'ion',8.333,1),(566,7497447,7497435,'sta',33.333,3),(566,7497448,7497435,'tat',33.333,3),(566,7497449,7497435,'ate',33.333,3),(566,7497450,7497447,'ena',20,2),(566,7497451,7497447,'nab',20,2),(566,7497452,7497447,'abl',20,2),(566,7497453,7497447,'ble',20,2),(566,7497454,7497447,'led',20,2),(566,7497455,7497450,'cac',33.333,1),(566,7497456,7497450,'ach',33.333,1),(566,7497457,7497450,'che',33.333,1),(566,7497458,7497455,'mod',50,2),(566,7497459,7497455,'ode',50,2),(566,7497460,7497458,'wri',14.286,2),(566,7497461,7497458,'rit',14.286,2),(566,7497462,7497458,'ite',14.286,2),(566,7497463,7497458,'tet',14.286,2),(566,7497464,7497458,'eth',14.286,2),(566,7497465,7497458,'thr',14.286,2),(566,7497466,7497458,'hru',14.286,2),(566,7497467,7497460,'ope',11.111,2),(566,7497468,7497460,'per',11.111,2),(566,7497469,7497460,'era',11.111,2),(566,7497470,7497460,'rat',11.111,2),(566,7497471,7497460,'ati',11.111,2),(566,7497472,7497460,'tio',11.111,2),(566,7497473,7497460,'ion',11.111,2),(566,7497474,7497460,'ona',11.111,2),(566,7497475,7497460,'nal',11.111,2),(566,7497476,7497467,'nor',25,1),(566,7497477,7497467,'orm',25,1),(566,7497478,7497467,'rma',25,1),(566,7497479,7497467,'mal',25,1),(566,7497480,7497476,'mes',20,1),(566,7497481,7497476,'ess',20,1),(566,7497482,7497476,'ssa',20,1),(566,7497483,7497476,'sag',20,1),(566,7497484,7497476,'age',20,1),(566,7497485,7497480,'per',11.111,1),(566,7497486,7497480,'erf',11.111,1),(566,7497487,7497480,'rfo',11.111,1),(566,7497488,7497480,'for',11.111,1),(566,7497489,7497480,'orm',11.111,1),(566,7497490,7497480,'rma',11.111,1),(566,7497491,7497480,'man',11.111,1),(566,7497492,7497480,'anc',11.111,1),(566,7497493,7497480,'nce',11.111,1),(566,7497494,7497485,'ide',12.5,1),(566,7497495,7497485,'den',12.5,1),(566,7497496,7497485,'ent',12.5,1),(566,7497497,7497485,'nti',12.5,1),(566,7497498,7497485,'tif',12.5,1),(566,7497499,7497485,'ifi',12.5,1),(566,7497500,7497485,'fie',12.5,1),(566,7497501,7497485,'ier',12.5,1),(566,7497502,7497494,'vdi',33.333,3),(566,7497503,7497494,'dis',33.333,3),(566,7497504,7497494,'isk',33.333,3),(566,7497505,7497502,'nam',50,1),(566,7497506,7497502,'ame',50,1),(566,7497507,7497505,'typ',50,1),(566,7497508,7497505,'ype',50,1),(566,7497509,7497507,'dir',25,1),(566,7497510,7497507,'ire',25,1),(566,7497511,7497507,'rec',25,1),(566,7497512,7497507,'ect',25,1),(567,7497514,7497513,'naa',100,2),(567,7497515,7497514,'600',3.333,3),(567,7497516,7497514,'000',3.333,3),(567,7497517,7497514,'00c',3.333,3),(567,7497518,7497514,'0c2',3.333,3),(567,7497519,7497514,'c29',3.333,3),(567,7497520,7497514,'296',3.333,3),(567,7497521,7497514,'96b',3.333,3),(567,7497522,7497514,'6b4',3.333,3),(567,7497523,7497514,'b48',3.333,3),(567,7497524,7497514,'486',3.333,3),(567,7497525,7497514,'86b',3.333,3),(567,7497526,7497514,'6ba',3.333,3),(567,7497527,7497514,'ba6',3.333,3),(567,7497528,7497514,'a69',3.333,3),(567,7497529,7497514,'69a',3.333,3),(567,7497530,7497514,'9a3',3.333,3),(567,7497531,7497514,'a3f',3.333,3),(567,7497532,7497514,'3f7',3.333,3),(567,7497533,7497514,'f71',3.333,3),(567,7497534,7497514,'71b',3.333,3),(567,7497535,7497514,'1bb',3.333,3),(567,7497536,7497514,'bba',3.333,3),(567,7497537,7497514,'baf',3.333,3),(567,7497538,7497514,'afc',3.333,3),(567,7497539,7497514,'fc3',3.333,3),(567,7497540,7497514,'c3e',3.333,3),(567,7497541,7497514,'3e5',3.333,3),(567,7497542,7497514,'e5f',3.333,3),(567,7497543,7497514,'5f1',3.333,3),(567,7497544,7497514,'f15',3.333,3),(567,7497545,7497515,'mon',100,1),(567,7497546,7497545,'201',50,1),(567,7497547,7497545,'013',50,1),(567,7497548,7497546,'adm',33.333,3),(567,7497549,7497546,'dmi',33.333,3),(567,7497550,7497546,'min',33.333,3),(567,7497551,7497548,'cap',16.667,1),(567,7497552,7497548,'apa',16.667,1),(567,7497553,7497548,'pac',16.667,1),(567,7497554,7497548,'aci',16.667,1),(567,7497555,7497548,'cit',16.667,1),(567,7497556,7497548,'ity',16.667,1),(567,7497557,7497551,'pat',50,1),(567,7497558,7497551,'ath',50,1),(567,7497559,7497557,'fre',14.286,1),(567,7497560,7497557,'ree',14.286,1),(567,7497561,7497557,'ees',14.286,1),(567,7497562,7497557,'esp',14.286,1),(567,7497563,7497557,'spa',14.286,1),(567,7497564,7497557,'pac',14.286,1),(567,7497565,7497557,'ace',14.286,1),(567,7497566,7497559,'dis',50,1),(567,7497567,7497559,'isk',50,1),(567,7497568,7497566,'ind',33.333,1),(567,7497569,7497566,'nde',33.333,1),(567,7497570,7497566,'dex',33.333,1),(567,7497571,7497568,'adm',8.333,1),(567,7497572,7497568,'dmi',8.333,1),(567,7497573,7497568,'min',8.333,1),(567,7497574,7497568,'ini',8.333,1),(567,7497575,7497568,'nis',8.333,1),(567,7497576,7497568,'ist',8.333,1),(567,7497577,7497568,'str',8.333,1),(567,7497578,7497568,'tra',8.333,1),(567,7497579,7497568,'rat',8.333,1),(567,7497580,7497568,'ati',8.333,1),(567,7497581,7497568,'tio',8.333,1),(567,7497582,7497568,'ion',8.333,1),(567,7497583,7497571,'sta',33.333,3),(567,7497584,7497571,'tat',33.333,3),(567,7497585,7497571,'ate',33.333,3),(567,7497586,7497583,'ena',20,2),(567,7497587,7497583,'nab',20,2),(567,7497588,7497583,'abl',20,2),(567,7497589,7497583,'ble',20,2),(567,7497590,7497583,'led',20,2),(567,7497591,7497586,'cac',33.333,1),(567,7497592,7497586,'ach',33.333,1),(567,7497593,7497586,'che',33.333,1),(567,7497594,7497591,'mod',50,2),(567,7497595,7497591,'ode',50,2),(567,7497596,7497594,'wri',14.286,2),(567,7497597,7497594,'rit',14.286,2),(567,7497598,7497594,'ite',14.286,2),(567,7497599,7497594,'tet',14.286,2),(567,7497600,7497594,'eth',14.286,2),(567,7497601,7497594,'thr',14.286,2),(567,7497602,7497594,'hru',14.286,2),(567,7497603,7497596,'ope',11.111,2),(567,7497604,7497596,'per',11.111,2),(567,7497605,7497596,'era',11.111,2),(567,7497606,7497596,'rat',11.111,2),(567,7497607,7497596,'ati',11.111,2),(567,7497608,7497596,'tio',11.111,2),(567,7497609,7497596,'ion',11.111,2),(567,7497610,7497596,'ona',11.111,2),(567,7497611,7497596,'nal',11.111,2),(567,7497612,7497603,'nor',25,1),(567,7497613,7497603,'orm',25,1),(567,7497614,7497603,'rma',25,1),(567,7497615,7497603,'mal',25,1),(567,7497616,7497612,'mes',20,1),(567,7497617,7497612,'ess',20,1),(567,7497618,7497612,'ssa',20,1),(567,7497619,7497612,'sag',20,1),(567,7497620,7497612,'age',20,1),(567,7497621,7497616,'per',11.111,1),(567,7497622,7497616,'erf',11.111,1),(567,7497623,7497616,'rfo',11.111,1),(567,7497624,7497616,'for',11.111,1),(567,7497625,7497616,'orm',11.111,1),(567,7497626,7497616,'rma',11.111,1),(567,7497627,7497616,'man',11.111,1),(567,7497628,7497616,'anc',11.111,1),(567,7497629,7497616,'nce',11.111,1),(567,7497630,7497621,'ide',12.5,1),(567,7497631,7497621,'den',12.5,1),(567,7497632,7497621,'ent',12.5,1),(567,7497633,7497621,'nti',12.5,1),(567,7497634,7497621,'tif',12.5,1),(567,7497635,7497621,'ifi',12.5,1),(567,7497636,7497621,'fie',12.5,1),(567,7497637,7497621,'ier',12.5,1),(567,7497638,7497630,'vdi',33.333,3),(567,7497639,7497630,'dis',33.333,3),(567,7497640,7497630,'isk',33.333,3),(567,7497641,7497638,'nam',50,1),(567,7497642,7497638,'ame',50,1),(567,7497643,7497641,'typ',50,1),(567,7497644,7497641,'ype',50,1),(567,7497645,7497643,'dir',25,1),(567,7497646,7497643,'ire',25,1),(567,7497647,7497643,'rec',25,1),(567,7497648,7497643,'ect',25,1),(568,7497650,7497649,'naa',100,2),(568,7497651,7497650,'600',3.333,3),(568,7497652,7497650,'000',3.333,3),(568,7497653,7497650,'00c',3.333,3),(568,7497654,7497650,'0c2',3.333,3),(568,7497655,7497650,'c29',3.333,3),(568,7497656,7497650,'298',3.333,3),(568,7497657,7497650,'986',3.333,3),(568,7497658,7497650,'869',3.333,3),(568,7497659,7497650,'693',3.333,3),(568,7497660,7497650,'93d',3.333,3),(568,7497661,7497650,'3d2',3.333,3),(568,7497662,7497650,'d22',3.333,3),(568,7497663,7497650,'22a',3.333,3),(568,7497664,7497650,'2a7',3.333,3),(568,7497665,7497650,'a71',3.333,3),(568,7497666,7497650,'716',3.333,3),(568,7497667,7497650,'166',3.333,3),(568,7497668,7497650,'664',3.333,3),(568,7497669,7497650,'644',3.333,3),(568,7497670,7497650,'446',3.333,3),(568,7497671,7497650,'466',3.333,3),(568,7497672,7497650,'668',3.333,3),(568,7497673,7497650,'68f',3.333,3),(568,7497674,7497650,'8f8',3.333,3),(568,7497675,7497650,'f80',3.333,3),(568,7497676,7497650,'808',3.333,3),(568,7497677,7497650,'08b',3.333,3),(568,7497678,7497650,'8bc',3.333,3),(568,7497679,7497650,'bc1',3.333,3),(568,7497680,7497650,'c18',3.333,3),(568,7497681,7497651,'mon',100,1),(568,7497682,7497681,'201',50,1),(568,7497683,7497681,'013',50,1),(568,7497684,7497682,'adm',33.333,3),(568,7497685,7497682,'dmi',33.333,3),(568,7497686,7497682,'min',33.333,3),(568,7497687,7497684,'cap',16.667,1),(568,7497688,7497684,'apa',16.667,1),(568,7497689,7497684,'pac',16.667,1),(568,7497690,7497684,'aci',16.667,1),(568,7497691,7497684,'cit',16.667,1),(568,7497692,7497684,'ity',16.667,1),(568,7497693,7497687,'pat',50,1),(568,7497694,7497687,'ath',50,1),(568,7497695,7497693,'fre',14.286,1),(568,7497696,7497693,'ree',14.286,1),(568,7497697,7497693,'ees',14.286,1),(568,7497698,7497693,'esp',14.286,1),(568,7497699,7497693,'spa',14.286,1),(568,7497700,7497693,'pac',14.286,1),(568,7497701,7497693,'ace',14.286,1),(568,7497702,7497695,'dis',50,1),(568,7497703,7497695,'isk',50,1),(568,7497704,7497702,'ind',33.333,1),(568,7497705,7497702,'nde',33.333,1),(568,7497706,7497702,'dex',33.333,1),(568,7497707,7497704,'adm',8.333,1),(568,7497708,7497704,'dmi',8.333,1),(568,7497709,7497704,'min',8.333,1),(568,7497710,7497704,'ini',8.333,1),(568,7497711,7497704,'nis',8.333,1),(568,7497712,7497704,'ist',8.333,1),(568,7497713,7497704,'str',8.333,1),(568,7497714,7497704,'tra',8.333,1),(568,7497715,7497704,'rat',8.333,1),(568,7497716,7497704,'ati',8.333,1),(568,7497717,7497704,'tio',8.333,1),(568,7497718,7497704,'ion',8.333,1),(568,7497719,7497707,'sta',33.333,3),(568,7497720,7497707,'tat',33.333,3),(568,7497721,7497707,'ate',33.333,3),(568,7497722,7497719,'ena',20,2),(568,7497723,7497719,'nab',20,2),(568,7497724,7497719,'abl',20,2),(568,7497725,7497719,'ble',20,2),(568,7497726,7497719,'led',20,2),(568,7497727,7497722,'cac',33.333,1),(568,7497728,7497722,'ach',33.333,1),(568,7497729,7497722,'che',33.333,1),(568,7497730,7497727,'mod',50,2),(568,7497731,7497727,'ode',50,2),(568,7497732,7497730,'wri',14.286,2),(568,7497733,7497730,'rit',14.286,2),(568,7497734,7497730,'ite',14.286,2),(568,7497735,7497730,'tet',14.286,2),(568,7497736,7497730,'eth',14.286,2),(568,7497737,7497730,'thr',14.286,2),(568,7497738,7497730,'hru',14.286,2),(568,7497739,7497732,'ope',11.111,2),(568,7497740,7497732,'per',11.111,2),(568,7497741,7497732,'era',11.111,2),(568,7497742,7497732,'rat',11.111,2),(568,7497743,7497732,'ati',11.111,2),(568,7497744,7497732,'tio',11.111,2),(568,7497745,7497732,'ion',11.111,2),(568,7497746,7497732,'ona',11.111,2),(568,7497747,7497732,'nal',11.111,2),(568,7497748,7497739,'nor',25,1),(568,7497749,7497739,'orm',25,1),(568,7497750,7497739,'rma',25,1),(568,7497751,7497739,'mal',25,1),(568,7497752,7497748,'mes',20,1),(568,7497753,7497748,'ess',20,1),(568,7497754,7497748,'ssa',20,1),(568,7497755,7497748,'sag',20,1),(568,7497756,7497748,'age',20,1),(568,7497757,7497752,'per',11.111,1),(568,7497758,7497752,'erf',11.111,1),(568,7497759,7497752,'rfo',11.111,1),(568,7497760,7497752,'for',11.111,1),(568,7497761,7497752,'orm',11.111,1),(568,7497762,7497752,'rma',11.111,1),(568,7497763,7497752,'man',11.111,1),(568,7497764,7497752,'anc',11.111,1),(568,7497765,7497752,'nce',11.111,1),(568,7497766,7497757,'ide',12.5,1),(568,7497767,7497757,'den',12.5,1),(568,7497768,7497757,'ent',12.5,1),(568,7497769,7497757,'nti',12.5,1),(568,7497770,7497757,'tif',12.5,1),(568,7497771,7497757,'ifi',12.5,1),(568,7497772,7497757,'fie',12.5,1),(568,7497773,7497757,'ier',12.5,1),(568,7497774,7497766,'vdi',33.333,3),(568,7497775,7497766,'dis',33.333,3),(568,7497776,7497766,'isk',33.333,3),(568,7497777,7497774,'nam',50,1),(568,7497778,7497774,'ame',50,1),(568,7497779,7497777,'typ',50,1),(568,7497780,7497777,'ype',50,1),(568,7497781,7497779,'dir',25,1),(568,7497782,7497779,'ire',25,1),(568,7497783,7497779,'rec',25,1),(568,7497784,7497779,'ect',25,1),(569,7497786,7497785,'naa',100,2),(569,7497787,7497786,'600',3.333,3),(569,7497788,7497786,'000',3.333,3),(569,7497789,7497786,'00c',3.333,3),(569,7497790,7497786,'0c2',3.333,3),(569,7497791,7497786,'c29',3.333,3),(569,7497792,7497786,'29a',3.333,3),(569,7497793,7497786,'9af',3.333,3),(569,7497794,7497786,'af0',3.333,3),(569,7497795,7497786,'f0b',3.333,3),(569,7497796,7497786,'0bf',3.333,3),(569,7497797,7497786,'bf9',3.333,3),(569,7497798,7497786,'f91',3.333,3),(569,7497799,7497786,'917',3.333,3),(569,7497800,7497786,'17f',3.333,3),(569,7497801,7497786,'7f4',3.333,3),(569,7497802,7497786,'f42',3.333,3),(569,7497803,7497786,'423',3.333,3),(569,7497804,7497786,'23b',3.333,3),(569,7497805,7497786,'3b0',3.333,3),(569,7497806,7497786,'b0f',3.333,3),(569,7497807,7497786,'0f7',3.333,3),(569,7497808,7497786,'f7b',3.333,3),(569,7497809,7497786,'7b4',3.333,3),(569,7497810,7497786,'b4d',3.333,3),(569,7497811,7497786,'4d5',3.333,3),(569,7497812,7497786,'d54',3.333,3),(569,7497813,7497786,'54e',3.333,3),(569,7497814,7497786,'4e7',3.333,3),(569,7497815,7497786,'e79',3.333,3),(569,7497816,7497786,'792',3.333,3),(569,7497817,7497787,'mon',100,1),(569,7497818,7497817,'201',50,1),(569,7497819,7497817,'013',50,1),(569,7497820,7497818,'adm',33.333,3),(569,7497821,7497818,'dmi',33.333,3),(569,7497822,7497818,'min',33.333,3),(569,7497823,7497820,'cap',16.667,1),(569,7497824,7497820,'apa',16.667,1),(569,7497825,7497820,'pac',16.667,1),(569,7497826,7497820,'aci',16.667,1),(569,7497827,7497820,'cit',16.667,1),(569,7497828,7497820,'ity',16.667,1),(569,7497829,7497823,'pat',50,1),(569,7497830,7497823,'ath',50,1),(569,7497831,7497829,'fre',14.286,1),(569,7497832,7497829,'ree',14.286,1),(569,7497833,7497829,'ees',14.286,1),(569,7497834,7497829,'esp',14.286,1),(569,7497835,7497829,'spa',14.286,1),(569,7497836,7497829,'pac',14.286,1),(569,7497837,7497829,'ace',14.286,1),(569,7497838,7497831,'dis',50,1),(569,7497839,7497831,'isk',50,1),(569,7497840,7497838,'ind',33.333,1),(569,7497841,7497838,'nde',33.333,1),(569,7497842,7497838,'dex',33.333,1),(569,7497843,7497840,'adm',8.333,1),(569,7497844,7497840,'dmi',8.333,1),(569,7497845,7497840,'min',8.333,1),(569,7497846,7497840,'ini',8.333,1),(569,7497847,7497840,'nis',8.333,1),(569,7497848,7497840,'ist',8.333,1),(569,7497849,7497840,'str',8.333,1),(569,7497850,7497840,'tra',8.333,1),(569,7497851,7497840,'rat',8.333,1),(569,7497852,7497840,'ati',8.333,1),(569,7497853,7497840,'tio',8.333,1),(569,7497854,7497840,'ion',8.333,1),(569,7497855,7497843,'sta',33.333,3),(569,7497856,7497843,'tat',33.333,3),(569,7497857,7497843,'ate',33.333,3),(569,7497858,7497855,'ena',20,2),(569,7497859,7497855,'nab',20,2),(569,7497860,7497855,'abl',20,2),(569,7497861,7497855,'ble',20,2),(569,7497862,7497855,'led',20,2),(569,7497863,7497858,'cac',33.333,1),(569,7497864,7497858,'ach',33.333,1),(569,7497865,7497858,'che',33.333,1),(569,7497866,7497863,'mod',50,2),(569,7497867,7497863,'ode',50,2),(569,7497868,7497866,'wri',14.286,2),(569,7497869,7497866,'rit',14.286,2),(569,7497870,7497866,'ite',14.286,2),(569,7497871,7497866,'tet',14.286,2),(569,7497872,7497866,'eth',14.286,2),(569,7497873,7497866,'thr',14.286,2),(569,7497874,7497866,'hru',14.286,2),(569,7497875,7497868,'ope',11.111,2),(569,7497876,7497868,'per',11.111,2),(569,7497877,7497868,'era',11.111,2),(569,7497878,7497868,'rat',11.111,2),(569,7497879,7497868,'ati',11.111,2),(569,7497880,7497868,'tio',11.111,2),(569,7497881,7497868,'ion',11.111,2),(569,7497882,7497868,'ona',11.111,2),(569,7497883,7497868,'nal',11.111,2),(569,7497884,7497875,'nor',25,1),(569,7497885,7497875,'orm',25,1),(569,7497886,7497875,'rma',25,1),(569,7497887,7497875,'mal',25,1),(569,7497888,7497884,'mes',20,1),(569,7497889,7497884,'ess',20,1),(569,7497890,7497884,'ssa',20,1),(569,7497891,7497884,'sag',20,1),(569,7497892,7497884,'age',20,1),(569,7497893,7497888,'per',11.111,1),(569,7497894,7497888,'erf',11.111,1),(569,7497895,7497888,'rfo',11.111,1),(569,7497896,7497888,'for',11.111,1),(569,7497897,7497888,'orm',11.111,1),(569,7497898,7497888,'rma',11.111,1),(569,7497899,7497888,'man',11.111,1),(569,7497900,7497888,'anc',11.111,1),(569,7497901,7497888,'nce',11.111,1),(569,7497902,7497893,'ide',12.5,1),(569,7497903,7497893,'den',12.5,1),(569,7497904,7497893,'ent',12.5,1),(569,7497905,7497893,'nti',12.5,1),(569,7497906,7497893,'tif',12.5,1),(569,7497907,7497893,'ifi',12.5,1),(569,7497908,7497893,'fie',12.5,1),(569,7497909,7497893,'ier',12.5,1),(569,7497910,7497902,'vdi',33.333,3),(569,7497911,7497902,'dis',33.333,3),(569,7497912,7497902,'isk',33.333,3),(569,7497913,7497910,'nam',50,1),(569,7497914,7497910,'ame',50,1),(569,7497915,7497913,'typ',50,1),(569,7497916,7497913,'ype',50,1),(569,7497917,7497915,'dir',25,1),(569,7497918,7497915,'ire',25,1),(569,7497919,7497915,'rec',25,1),(569,7497920,7497915,'ect',25,1),(570,7497922,7497921,'naa',100,2),(570,7497923,7497922,'600',3.333,3),(570,7497924,7497922,'000',3.333,3),(570,7497925,7497922,'00c',3.333,3),(570,7497926,7497922,'0c2',3.333,3),(570,7497927,7497922,'c29',3.333,3),(570,7497928,7497922,'299',3.333,3),(570,7497929,7497922,'99e',3.333,3),(570,7497930,7497922,'9e6',3.333,3),(570,7497931,7497922,'e65',3.333,3),(570,7497932,7497922,'656',3.333,3),(570,7497933,7497922,'567',3.333,3),(570,7497934,7497922,'677',3.333,3),(570,7497935,7497922,'777',3.333,3),(570,7497936,7497922,'770',3.333,3),(570,7497937,7497922,'701',3.333,3),(570,7497938,7497922,'01b',3.333,3),(570,7497939,7497922,'1b2',3.333,3),(570,7497940,7497922,'b27',3.333,3),(570,7497941,7497922,'273',3.333,3),(570,7497942,7497922,'73f',3.333,3),(570,7497943,7497922,'3f9',3.333,3),(570,7497944,7497922,'f92',3.333,3),(570,7497945,7497922,'929',3.333,3),(570,7497946,7497922,'29a',3.333,3),(570,7497947,7497922,'9ad',3.333,3),(570,7497948,7497922,'adb',3.333,3),(570,7497949,7497922,'dbc',3.333,3),(570,7497950,7497922,'bcc',3.333,3),(570,7497951,7497922,'cc1',3.333,3),(570,7497952,7497922,'c1f',3.333,3),(570,7497953,7497923,'mon',100,1),(570,7497954,7497953,'201',50,1),(570,7497955,7497953,'013',50,1),(570,7497956,7497954,'adm',33.333,3),(570,7497957,7497954,'dmi',33.333,3),(570,7497958,7497954,'min',33.333,3),(570,7497959,7497956,'cap',16.667,1),(570,7497960,7497956,'apa',16.667,1),(570,7497961,7497956,'pac',16.667,1),(570,7497962,7497956,'aci',16.667,1),(570,7497963,7497956,'cit',16.667,1),(570,7497964,7497956,'ity',16.667,1),(570,7497965,7497959,'pat',50,1),(570,7497966,7497959,'ath',50,1),(570,7497967,7497965,'fre',14.286,1),(570,7497968,7497965,'ree',14.286,1),(570,7497969,7497965,'ees',14.286,1),(570,7497970,7497965,'esp',14.286,1),(570,7497971,7497965,'spa',14.286,1),(570,7497972,7497965,'pac',14.286,1),(570,7497973,7497965,'ace',14.286,1),(570,7497974,7497967,'dis',50,1),(570,7497975,7497967,'isk',50,1),(570,7497976,7497974,'ind',33.333,1),(570,7497977,7497974,'nde',33.333,1),(570,7497978,7497974,'dex',33.333,1),(570,7497979,7497976,'adm',8.333,1),(570,7497980,7497976,'dmi',8.333,1),(570,7497981,7497976,'min',8.333,1),(570,7497982,7497976,'ini',8.333,1),(570,7497983,7497976,'nis',8.333,1),(570,7497984,7497976,'ist',8.333,1),(570,7497985,7497976,'str',8.333,1),(570,7497986,7497976,'tra',8.333,1),(570,7497987,7497976,'rat',8.333,1),(570,7497988,7497976,'ati',8.333,1),(570,7497989,7497976,'tio',8.333,1),(570,7497990,7497976,'ion',8.333,1),(570,7497991,7497979,'sta',33.333,3),(570,7497992,7497979,'tat',33.333,3),(570,7497993,7497979,'ate',33.333,3),(570,7497994,7497991,'ena',20,2),(570,7497995,7497991,'nab',20,2),(570,7497996,7497991,'abl',20,2),(570,7497997,7497991,'ble',20,2),(570,7497998,7497991,'led',20,2),(570,7497999,7497994,'cac',33.333,1),(570,7498000,7497994,'ach',33.333,1),(570,7498001,7497994,'che',33.333,1),(570,7498002,7497999,'mod',50,2),(570,7498003,7497999,'ode',50,2),(570,7498004,7498002,'wri',14.286,2),(570,7498005,7498002,'rit',14.286,2),(570,7498006,7498002,'ite',14.286,2),(570,7498007,7498002,'tet',14.286,2),(570,7498008,7498002,'eth',14.286,2),(570,7498009,7498002,'thr',14.286,2),(570,7498010,7498002,'hru',14.286,2),(570,7498011,7498004,'ope',11.111,2),(570,7498012,7498004,'per',11.111,2),(570,7498013,7498004,'era',11.111,2),(570,7498014,7498004,'rat',11.111,2),(570,7498015,7498004,'ati',11.111,2),(570,7498016,7498004,'tio',11.111,2),(570,7498017,7498004,'ion',11.111,2),(570,7498018,7498004,'ona',11.111,2),(570,7498019,7498004,'nal',11.111,2),(570,7498020,7498011,'nor',25,1),(570,7498021,7498011,'orm',25,1),(570,7498022,7498011,'rma',25,1),(570,7498023,7498011,'mal',25,1),(570,7498024,7498020,'mes',20,1),(570,7498025,7498020,'ess',20,1),(570,7498026,7498020,'ssa',20,1),(570,7498027,7498020,'sag',20,1),(570,7498028,7498020,'age',20,1),(570,7498029,7498024,'per',11.111,1),(570,7498030,7498024,'erf',11.111,1),(570,7498031,7498024,'rfo',11.111,1),(570,7498032,7498024,'for',11.111,1),(570,7498033,7498024,'orm',11.111,1),(570,7498034,7498024,'rma',11.111,1),(570,7498035,7498024,'man',11.111,1),(570,7498036,7498024,'anc',11.111,1),(570,7498037,7498024,'nce',11.111,1),(570,7498038,7498029,'ide',12.5,1),(570,7498039,7498029,'den',12.5,1),(570,7498040,7498029,'ent',12.5,1),(570,7498041,7498029,'nti',12.5,1),(570,7498042,7498029,'tif',12.5,1),(570,7498043,7498029,'ifi',12.5,1),(570,7498044,7498029,'fie',12.5,1),(570,7498045,7498029,'ier',12.5,1),(570,7498046,7498038,'vdi',33.333,3),(570,7498047,7498038,'dis',33.333,3),(570,7498048,7498038,'isk',33.333,3),(570,7498049,7498046,'nam',50,1),(570,7498050,7498046,'ame',50,1),(570,7498051,7498049,'typ',50,1),(570,7498052,7498049,'ype',50,1),(570,7498053,7498051,'dir',25,1),(570,7498054,7498051,'ire',25,1),(570,7498055,7498051,'rec',25,1),(570,7498056,7498051,'ect',25,1),(571,7498058,7498057,'naa',100,2),(571,7498059,7498058,'600',3.333,3),(571,7498060,7498058,'000',3.333,3),(571,7498061,7498058,'00c',3.333,3),(571,7498062,7498058,'0c2',3.333,3),(571,7498063,7498058,'c29',3.333,3),(571,7498064,7498058,'297',3.333,3),(571,7498065,7498058,'97b',3.333,3),(571,7498066,7498058,'7b4',3.333,3),(571,7498067,7498058,'b44',3.333,3),(571,7498068,7498058,'449',3.333,3),(571,7498069,7498058,'49a',3.333,3),(571,7498070,7498058,'9a2',3.333,3),(571,7498071,7498058,'a23',3.333,3),(571,7498072,7498058,'234',3.333,3),(571,7498073,7498058,'34f',3.333,3),(571,7498074,7498058,'4fa',3.333,3),(571,7498075,7498058,'fac',3.333,3),(571,7498076,7498058,'ac7',3.333,3),(571,7498077,7498058,'c7c',3.333,3),(571,7498078,7498058,'7c8',3.333,3),(571,7498079,7498058,'c88',3.333,3),(571,7498080,7498058,'88a',3.333,3),(571,7498081,7498058,'8a0',3.333,3),(571,7498082,7498058,'a0c',3.333,3),(571,7498083,7498058,'0cb',3.333,3),(571,7498084,7498058,'cbe',3.333,3),(571,7498085,7498058,'beb',3.333,3),(571,7498086,7498058,'eb7',3.333,3),(571,7498087,7498058,'b75',3.333,3),(571,7498088,7498058,'75e',3.333,3),(571,7498089,7498059,'mon',100,1),(571,7498090,7498089,'201',50,1),(571,7498091,7498089,'013',50,1),(571,7498092,7498090,'adm',33.333,3),(571,7498093,7498090,'dmi',33.333,3),(571,7498094,7498090,'min',33.333,3),(571,7498095,7498092,'cap',16.667,1),(571,7498096,7498092,'apa',16.667,1),(571,7498097,7498092,'pac',16.667,1),(571,7498098,7498092,'aci',16.667,1),(571,7498099,7498092,'cit',16.667,1),(571,7498100,7498092,'ity',16.667,1),(571,7498101,7498095,'pat',50,1),(571,7498102,7498095,'ath',50,1),(571,7498103,7498101,'fre',14.286,1),(571,7498104,7498101,'ree',14.286,1),(571,7498105,7498101,'ees',14.286,1),(571,7498106,7498101,'esp',14.286,1),(571,7498107,7498101,'spa',14.286,1),(571,7498108,7498101,'pac',14.286,1),(571,7498109,7498101,'ace',14.286,1),(571,7498110,7498103,'dis',50,1),(571,7498111,7498103,'isk',50,1),(571,7498112,7498110,'ind',33.333,1),(571,7498113,7498110,'nde',33.333,1),(571,7498114,7498110,'dex',33.333,1),(571,7498115,7498112,'adm',8.333,1),(571,7498116,7498112,'dmi',8.333,1),(571,7498117,7498112,'min',8.333,1),(571,7498118,7498112,'ini',8.333,1),(571,7498119,7498112,'nis',8.333,1),(571,7498120,7498112,'ist',8.333,1),(571,7498121,7498112,'str',8.333,1),(571,7498122,7498112,'tra',8.333,1),(571,7498123,7498112,'rat',8.333,1),(571,7498124,7498112,'ati',8.333,1),(571,7498125,7498112,'tio',8.333,1),(571,7498126,7498112,'ion',8.333,1),(571,7498127,7498115,'sta',33.333,3),(571,7498128,7498115,'tat',33.333,3),(571,7498129,7498115,'ate',33.333,3),(571,7498130,7498127,'ena',20,2),(571,7498131,7498127,'nab',20,2),(571,7498132,7498127,'abl',20,2),(571,7498133,7498127,'ble',20,2),(571,7498134,7498127,'led',20,2),(571,7498135,7498130,'cac',33.333,1),(571,7498136,7498130,'ach',33.333,1),(571,7498137,7498130,'che',33.333,1),(571,7498138,7498135,'mod',50,2),(571,7498139,7498135,'ode',50,2),(571,7498140,7498138,'wri',14.286,2),(571,7498141,7498138,'rit',14.286,2),(571,7498142,7498138,'ite',14.286,2),(571,7498143,7498138,'tet',14.286,2),(571,7498144,7498138,'eth',14.286,2),(571,7498145,7498138,'thr',14.286,2),(571,7498146,7498138,'hru',14.286,2),(571,7498147,7498140,'ope',11.111,2),(571,7498148,7498140,'per',11.111,2),(571,7498149,7498140,'era',11.111,2),(571,7498150,7498140,'rat',11.111,2),(571,7498151,7498140,'ati',11.111,2),(571,7498152,7498140,'tio',11.111,2),(571,7498153,7498140,'ion',11.111,2),(571,7498154,7498140,'ona',11.111,2),(571,7498155,7498140,'nal',11.111,2),(571,7498156,7498147,'nor',25,1),(571,7498157,7498147,'orm',25,1),(571,7498158,7498147,'rma',25,1),(571,7498159,7498147,'mal',25,1),(571,7498160,7498156,'mes',20,1),(571,7498161,7498156,'ess',20,1),(571,7498162,7498156,'ssa',20,1),(571,7498163,7498156,'sag',20,1),(571,7498164,7498156,'age',20,1),(571,7498165,7498160,'per',11.111,1),(571,7498166,7498160,'erf',11.111,1),(571,7498167,7498160,'rfo',11.111,1),(571,7498168,7498160,'for',11.111,1),(571,7498169,7498160,'orm',11.111,1),(571,7498170,7498160,'rma',11.111,1),(571,7498171,7498160,'man',11.111,1),(571,7498172,7498160,'anc',11.111,1),(571,7498173,7498160,'nce',11.111,1),(571,7498174,7498165,'ide',12.5,1),(571,7498175,7498165,'den',12.5,1),(571,7498176,7498165,'ent',12.5,1),(571,7498177,7498165,'nti',12.5,1),(571,7498178,7498165,'tif',12.5,1),(571,7498179,7498165,'ifi',12.5,1),(571,7498180,7498165,'fie',12.5,1),(571,7498181,7498165,'ier',12.5,1),(571,7498182,7498174,'vdi',33.333,3),(571,7498183,7498174,'dis',33.333,3),(571,7498184,7498174,'isk',33.333,3),(571,7498185,7498182,'nam',50,1),(571,7498186,7498182,'ame',50,1),(571,7498187,7498185,'typ',50,1),(571,7498188,7498185,'ype',50,1),(571,7498189,7498187,'dir',25,1),(571,7498190,7498187,'ire',25,1),(571,7498191,7498187,'rec',25,1),(571,7498192,7498187,'ect',25,1),(572,7498194,7498193,'naa',100,2),(572,7498195,7498194,'600',3.333,3),(572,7498196,7498194,'000',3.333,3),(572,7498197,7498194,'00c',3.333,3),(572,7498198,7498194,'0c2',3.333,3),(572,7498199,7498194,'c29',3.333,3),(572,7498200,7498194,'29c',3.333,3),(572,7498201,7498194,'9c8',3.333,3),(572,7498202,7498194,'c81',3.333,3),(572,7498203,7498194,'812',3.333,3),(572,7498204,7498194,'124',3.333,3),(572,7498205,7498194,'24b',3.333,3),(572,7498206,7498194,'4bd',3.333,3),(572,7498207,7498194,'bd2',3.333,3),(572,7498208,7498194,'d22',3.333,3),(572,7498209,7498194,'229',3.333,3),(572,7498210,7498194,'298',3.333,3),(572,7498211,7498194,'98e',3.333,3),(572,7498212,7498194,'8ec',3.333,3),(572,7498213,7498194,'ece',3.333,3),(572,7498214,7498194,'cec',3.333,3),(572,7498215,7498194,'ecb',3.333,3),(572,7498216,7498194,'cba',3.333,3),(572,7498217,7498194,'ba4',3.333,3),(572,7498218,7498194,'a4c',3.333,3),(572,7498219,7498194,'4c3',3.333,3),(572,7498220,7498194,'c37',3.333,3),(572,7498221,7498194,'378',3.333,3),(572,7498222,7498194,'782',3.333,3),(572,7498223,7498194,'82b',3.333,3),(572,7498224,7498194,'2b1',3.333,3),(572,7498225,7498195,'mon',100,1),(572,7498226,7498225,'201',50,1),(572,7498227,7498225,'013',50,1),(572,7498228,7498226,'adm',33.333,3),(572,7498229,7498226,'dmi',33.333,3),(572,7498230,7498226,'min',33.333,3),(572,7498231,7498228,'cap',16.667,1),(572,7498232,7498228,'apa',16.667,1),(572,7498233,7498228,'pac',16.667,1),(572,7498234,7498228,'aci',16.667,1),(572,7498235,7498228,'cit',16.667,1),(572,7498236,7498228,'ity',16.667,1),(572,7498237,7498231,'pat',50,1),(572,7498238,7498231,'ath',50,1),(572,7498239,7498237,'fre',14.286,1),(572,7498240,7498237,'ree',14.286,1),(572,7498241,7498237,'ees',14.286,1),(572,7498242,7498237,'esp',14.286,1),(572,7498243,7498237,'spa',14.286,1),(572,7498244,7498237,'pac',14.286,1),(572,7498245,7498237,'ace',14.286,1),(572,7498246,7498239,'dis',50,1),(572,7498247,7498239,'isk',50,1),(572,7498248,7498246,'ind',33.333,1),(572,7498249,7498246,'nde',33.333,1),(572,7498250,7498246,'dex',33.333,1),(572,7498251,7498248,'adm',8.333,1),(572,7498252,7498248,'dmi',8.333,1),(572,7498253,7498248,'min',8.333,1),(572,7498254,7498248,'ini',8.333,1),(572,7498255,7498248,'nis',8.333,1),(572,7498256,7498248,'ist',8.333,1),(572,7498257,7498248,'str',8.333,1),(572,7498258,7498248,'tra',8.333,1),(572,7498259,7498248,'rat',8.333,1),(572,7498260,7498248,'ati',8.333,1),(572,7498261,7498248,'tio',8.333,1),(572,7498262,7498248,'ion',8.333,1),(572,7498263,7498251,'sta',33.333,3),(572,7498264,7498251,'tat',33.333,3),(572,7498265,7498251,'ate',33.333,3),(572,7498266,7498263,'ena',20,2),(572,7498267,7498263,'nab',20,2),(572,7498268,7498263,'abl',20,2),(572,7498269,7498263,'ble',20,2),(572,7498270,7498263,'led',20,2),(572,7498271,7498266,'cac',33.333,1),(572,7498272,7498266,'ach',33.333,1),(572,7498273,7498266,'che',33.333,1),(572,7498274,7498271,'mod',50,2),(572,7498275,7498271,'ode',50,2),(572,7498276,7498274,'wri',14.286,2),(572,7498277,7498274,'rit',14.286,2),(572,7498278,7498274,'ite',14.286,2),(572,7498279,7498274,'tet',14.286,2),(572,7498280,7498274,'eth',14.286,2),(572,7498281,7498274,'thr',14.286,2),(572,7498282,7498274,'hru',14.286,2),(572,7498283,7498276,'ope',11.111,2),(572,7498284,7498276,'per',11.111,2),(572,7498285,7498276,'era',11.111,2),(572,7498286,7498276,'rat',11.111,2),(572,7498287,7498276,'ati',11.111,2),(572,7498288,7498276,'tio',11.111,2),(572,7498289,7498276,'ion',11.111,2),(572,7498290,7498276,'ona',11.111,2),(572,7498291,7498276,'nal',11.111,2),(572,7498292,7498283,'nor',25,1),(572,7498293,7498283,'orm',25,1),(572,7498294,7498283,'rma',25,1),(572,7498295,7498283,'mal',25,1),(572,7498296,7498292,'mes',20,1),(572,7498297,7498292,'ess',20,1),(572,7498298,7498292,'ssa',20,1),(572,7498299,7498292,'sag',20,1),(572,7498300,7498292,'age',20,1),(572,7498301,7498296,'per',11.111,1),(572,7498302,7498296,'erf',11.111,1),(572,7498303,7498296,'rfo',11.111,1),(572,7498304,7498296,'for',11.111,1),(572,7498305,7498296,'orm',11.111,1),(572,7498306,7498296,'rma',11.111,1),(572,7498307,7498296,'man',11.111,1),(572,7498308,7498296,'anc',11.111,1),(572,7498309,7498296,'nce',11.111,1),(572,7498310,7498301,'ide',12.5,1),(572,7498311,7498301,'den',12.5,1),(572,7498312,7498301,'ent',12.5,1),(572,7498313,7498301,'nti',12.5,1),(572,7498314,7498301,'tif',12.5,1),(572,7498315,7498301,'ifi',12.5,1),(572,7498316,7498301,'fie',12.5,1),(572,7498317,7498301,'ier',12.5,1),(572,7498318,7498310,'vdi',33.333,3),(572,7498319,7498310,'dis',33.333,3),(572,7498320,7498310,'isk',33.333,3),(572,7498321,7498318,'nam',50,1),(572,7498322,7498318,'ame',50,1),(572,7498323,7498321,'typ',50,1),(572,7498324,7498321,'ype',50,1),(572,7498325,7498323,'dir',25,1),(572,7498326,7498323,'ire',25,1),(572,7498327,7498323,'rec',25,1),(572,7498328,7498323,'ect',25,1),(573,7498330,7498329,'naa',100,2),(573,7498331,7498330,'600',3.333,3),(573,7498332,7498330,'000',3.333,3),(573,7498333,7498330,'00c',3.333,3),(573,7498334,7498330,'0c2',3.333,3),(573,7498335,7498330,'c29',3.333,3),(573,7498336,7498330,'29b',3.333,3),(573,7498337,7498330,'9b3',3.333,3),(573,7498338,7498330,'b3f',3.333,3),(573,7498339,7498330,'3fe',3.333,3),(573,7498340,7498330,'fec',3.333,3),(573,7498341,7498330,'ec7',3.333,3),(573,7498342,7498330,'c74',3.333,3),(573,7498343,7498330,'74f',3.333,3),(573,7498344,7498330,'4f2',3.333,3),(573,7498345,7498330,'f23',3.333,3),(573,7498346,7498330,'237',3.333,3),(573,7498347,7498330,'37a',3.333,3),(573,7498348,7498330,'7a6',3.333,3),(573,7498349,7498330,'a67',3.333,3),(573,7498350,7498330,'67a',3.333,3),(573,7498351,7498330,'7af',3.333,3),(573,7498352,7498330,'afa',3.333,3),(573,7498353,7498330,'fa7',3.333,3),(573,7498354,7498330,'a74',3.333,3),(573,7498355,7498330,'746',3.333,3),(573,7498356,7498330,'46f',3.333,3),(573,7498357,7498330,'6f5',3.333,3),(573,7498358,7498330,'f5d',3.333,3),(573,7498359,7498330,'5d5',3.333,3),(573,7498360,7498330,'d55',3.333,3),(573,7498361,7498331,'mon',100,1),(573,7498362,7498361,'201',50,1),(573,7498363,7498361,'013',50,1),(573,7498364,7498362,'adm',33.333,3),(573,7498365,7498362,'dmi',33.333,3),(573,7498366,7498362,'min',33.333,3),(573,7498367,7498364,'cap',16.667,1),(573,7498368,7498364,'apa',16.667,1),(573,7498369,7498364,'pac',16.667,1),(573,7498370,7498364,'aci',16.667,1),(573,7498371,7498364,'cit',16.667,1),(573,7498372,7498364,'ity',16.667,1),(573,7498373,7498367,'pat',50,1),(573,7498374,7498367,'ath',50,1),(573,7498375,7498373,'fre',14.286,1),(573,7498376,7498373,'ree',14.286,1),(573,7498377,7498373,'ees',14.286,1),(573,7498378,7498373,'esp',14.286,1),(573,7498379,7498373,'spa',14.286,1),(573,7498380,7498373,'pac',14.286,1),(573,7498381,7498373,'ace',14.286,1),(573,7498382,7498375,'dis',50,1),(573,7498383,7498375,'isk',50,1),(573,7498384,7498382,'ind',33.333,1),(573,7498385,7498382,'nde',33.333,1),(573,7498386,7498382,'dex',33.333,1),(573,7498387,7498384,'adm',8.333,1),(573,7498388,7498384,'dmi',8.333,1),(573,7498389,7498384,'min',8.333,1),(573,7498390,7498384,'ini',8.333,1),(573,7498391,7498384,'nis',8.333,1),(573,7498392,7498384,'ist',8.333,1),(573,7498393,7498384,'str',8.333,1),(573,7498394,7498384,'tra',8.333,1),(573,7498395,7498384,'rat',8.333,1),(573,7498396,7498384,'ati',8.333,1),(573,7498397,7498384,'tio',8.333,1),(573,7498398,7498384,'ion',8.333,1),(573,7498399,7498387,'sta',33.333,3),(573,7498400,7498387,'tat',33.333,3),(573,7498401,7498387,'ate',33.333,3),(573,7498402,7498399,'ena',20,2),(573,7498403,7498399,'nab',20,2),(573,7498404,7498399,'abl',20,2),(573,7498405,7498399,'ble',20,2),(573,7498406,7498399,'led',20,2),(573,7498407,7498402,'cac',33.333,1),(573,7498408,7498402,'ach',33.333,1),(573,7498409,7498402,'che',33.333,1),(573,7498410,7498407,'mod',50,2),(573,7498411,7498407,'ode',50,2),(573,7498412,7498410,'wri',14.286,2),(573,7498413,7498410,'rit',14.286,2),(573,7498414,7498410,'ite',14.286,2),(573,7498415,7498410,'tet',14.286,2),(573,7498416,7498410,'eth',14.286,2),(573,7498417,7498410,'thr',14.286,2),(573,7498418,7498410,'hru',14.286,2),(573,7498419,7498412,'ope',11.111,2),(573,7498420,7498412,'per',11.111,2),(573,7498421,7498412,'era',11.111,2),(573,7498422,7498412,'rat',11.111,2),(573,7498423,7498412,'ati',11.111,2),(573,7498424,7498412,'tio',11.111,2),(573,7498425,7498412,'ion',11.111,2),(573,7498426,7498412,'ona',11.111,2),(573,7498427,7498412,'nal',11.111,2),(573,7498428,7498419,'nor',25,1),(573,7498429,7498419,'orm',25,1),(573,7498430,7498419,'rma',25,1),(573,7498431,7498419,'mal',25,1),(573,7498432,7498428,'mes',20,1),(573,7498433,7498428,'ess',20,1),(573,7498434,7498428,'ssa',20,1),(573,7498435,7498428,'sag',20,1),(573,7498436,7498428,'age',20,1),(573,7498437,7498432,'per',11.111,1),(573,7498438,7498432,'erf',11.111,1),(573,7498439,7498432,'rfo',11.111,1),(573,7498440,7498432,'for',11.111,1),(573,7498441,7498432,'orm',11.111,1),(573,7498442,7498432,'rma',11.111,1),(573,7498443,7498432,'man',11.111,1),(573,7498444,7498432,'anc',11.111,1),(573,7498445,7498432,'nce',11.111,1),(573,7498446,7498437,'ide',12.5,1),(573,7498447,7498437,'den',12.5,1),(573,7498448,7498437,'ent',12.5,1),(573,7498449,7498437,'nti',12.5,1),(573,7498450,7498437,'tif',12.5,1),(573,7498451,7498437,'ifi',12.5,1),(573,7498452,7498437,'fie',12.5,1),(573,7498453,7498437,'ier',12.5,1),(573,7498454,7498446,'vdi',33.333,3),(573,7498455,7498446,'dis',33.333,3),(573,7498456,7498446,'isk',33.333,3),(573,7498457,7498454,'nam',50,1),(573,7498458,7498454,'ame',50,1),(573,7498459,7498457,'typ',50,1),(573,7498460,7498457,'ype',50,1),(573,7498461,7498459,'dir',25,1),(573,7498462,7498459,'ire',25,1),(573,7498463,7498459,'rec',25,1),(573,7498464,7498459,'ect',25,1),(574,7498466,7498465,'naa',100,2),(574,7498467,7498466,'600',3.333,3),(574,7498468,7498466,'000',3.333,3),(574,7498469,7498466,'00c',3.333,3),(574,7498470,7498466,'0c2',3.333,3),(574,7498471,7498466,'c29',3.333,3),(574,7498472,7498466,'293',3.333,3),(574,7498473,7498466,'935',3.333,3),(574,7498474,7498466,'35c',3.333,3),(574,7498475,7498466,'5c4',3.333,3),(574,7498476,7498466,'c4a',3.333,3),(574,7498477,7498466,'4a6',3.333,3),(574,7498478,7498466,'a69',3.333,3),(574,7498479,7498466,'694',3.333,3),(574,7498480,7498466,'942',3.333,3),(574,7498481,7498466,'42c',3.333,3),(574,7498482,7498466,'2cc',3.333,3),(574,7498483,7498466,'cc0',3.333,3),(574,7498484,7498466,'c0c',3.333,3),(574,7498485,7498466,'0cd',3.333,3),(574,7498486,7498466,'cd0',3.333,3),(574,7498487,7498466,'d05',3.333,3),(574,7498488,7498466,'05e',3.333,3),(574,7498489,7498466,'5e1',3.333,3),(574,7498490,7498466,'e18',3.333,3),(574,7498491,7498466,'188',3.333,3),(574,7498492,7498466,'88c',3.333,3),(574,7498493,7498466,'8cf',3.333,3),(574,7498494,7498466,'cf9',3.333,3),(574,7498495,7498466,'f9b',3.333,3),(574,7498496,7498466,'9ba',3.333,3),(574,7498497,7498467,'mon',100,1),(574,7498498,7498497,'201',50,1),(574,7498499,7498497,'013',50,1),(574,7498500,7498498,'adm',33.333,3),(574,7498501,7498498,'dmi',33.333,3),(574,7498502,7498498,'min',33.333,3),(574,7498503,7498500,'cap',16.667,1),(574,7498504,7498500,'apa',16.667,1),(574,7498505,7498500,'pac',16.667,1),(574,7498506,7498500,'aci',16.667,1),(574,7498507,7498500,'cit',16.667,1),(574,7498508,7498500,'ity',16.667,1),(574,7498509,7498503,'pat',50,1),(574,7498510,7498503,'ath',50,1),(574,7498511,7498509,'fre',14.286,1),(574,7498512,7498509,'ree',14.286,1),(574,7498513,7498509,'ees',14.286,1),(574,7498514,7498509,'esp',14.286,1),(574,7498515,7498509,'spa',14.286,1),(574,7498516,7498509,'pac',14.286,1),(574,7498517,7498509,'ace',14.286,1),(574,7498518,7498511,'dis',50,1),(574,7498519,7498511,'isk',50,1),(574,7498520,7498518,'ind',33.333,1),(574,7498521,7498518,'nde',33.333,1),(574,7498522,7498518,'dex',33.333,1),(574,7498523,7498520,'adm',8.333,1),(574,7498524,7498520,'dmi',8.333,1),(574,7498525,7498520,'min',8.333,1),(574,7498526,7498520,'ini',8.333,1),(574,7498527,7498520,'nis',8.333,1),(574,7498528,7498520,'ist',8.333,1),(574,7498529,7498520,'str',8.333,1),(574,7498530,7498520,'tra',8.333,1),(574,7498531,7498520,'rat',8.333,1),(574,7498532,7498520,'ati',8.333,1),(574,7498533,7498520,'tio',8.333,1),(574,7498534,7498520,'ion',8.333,1),(574,7498535,7498523,'sta',33.333,3),(574,7498536,7498523,'tat',33.333,3),(574,7498537,7498523,'ate',33.333,3),(574,7498538,7498535,'ena',20,2),(574,7498539,7498535,'nab',20,2),(574,7498540,7498535,'abl',20,2),(574,7498541,7498535,'ble',20,2),(574,7498542,7498535,'led',20,2),(574,7498543,7498538,'cac',33.333,1),(574,7498544,7498538,'ach',33.333,1),(574,7498545,7498538,'che',33.333,1),(574,7498546,7498543,'mod',50,2),(574,7498547,7498543,'ode',50,2),(574,7498548,7498546,'wri',14.286,2),(574,7498549,7498546,'rit',14.286,2),(574,7498550,7498546,'ite',14.286,2),(574,7498551,7498546,'tet',14.286,2),(574,7498552,7498546,'eth',14.286,2),(574,7498553,7498546,'thr',14.286,2),(574,7498554,7498546,'hru',14.286,2),(574,7498555,7498548,'ope',11.111,2),(574,7498556,7498548,'per',11.111,2),(574,7498557,7498548,'era',11.111,2),(574,7498558,7498548,'rat',11.111,2),(574,7498559,7498548,'ati',11.111,2),(574,7498560,7498548,'tio',11.111,2),(574,7498561,7498548,'ion',11.111,2),(574,7498562,7498548,'ona',11.111,2),(574,7498563,7498548,'nal',11.111,2),(574,7498564,7498555,'nor',25,1),(574,7498565,7498555,'orm',25,1),(574,7498566,7498555,'rma',25,1),(574,7498567,7498555,'mal',25,1),(574,7498568,7498564,'mes',20,1),(574,7498569,7498564,'ess',20,1),(574,7498570,7498564,'ssa',20,1),(574,7498571,7498564,'sag',20,1),(574,7498572,7498564,'age',20,1),(574,7498573,7498568,'per',11.111,1),(574,7498574,7498568,'erf',11.111,1),(574,7498575,7498568,'rfo',11.111,1),(574,7498576,7498568,'for',11.111,1),(574,7498577,7498568,'orm',11.111,1),(574,7498578,7498568,'rma',11.111,1),(574,7498579,7498568,'man',11.111,1),(574,7498580,7498568,'anc',11.111,1),(574,7498581,7498568,'nce',11.111,1),(574,7498582,7498573,'ide',12.5,1),(574,7498583,7498573,'den',12.5,1),(574,7498584,7498573,'ent',12.5,1),(574,7498585,7498573,'nti',12.5,1),(574,7498586,7498573,'tif',12.5,1),(574,7498587,7498573,'ifi',12.5,1),(574,7498588,7498573,'fie',12.5,1),(574,7498589,7498573,'ier',12.5,1),(574,7498590,7498582,'vdi',33.333,3),(574,7498591,7498582,'dis',33.333,3),(574,7498592,7498582,'isk',33.333,3),(574,7498593,7498590,'nam',50,1),(574,7498594,7498590,'ame',50,1),(574,7498595,7498593,'typ',50,1),(574,7498596,7498593,'ype',50,1),(574,7498597,7498595,'dir',25,1),(574,7498598,7498595,'ire',25,1),(574,7498599,7498595,'rec',25,1),(574,7498600,7498595,'ect',25,1),(575,7498602,7498601,'naa',100,2),(575,7498603,7498602,'600',3.333,3),(575,7498604,7498602,'000',3.333,3),(575,7498605,7498602,'00c',3.333,3),(575,7498606,7498602,'0c2',3.333,3),(575,7498607,7498602,'c29',3.333,3),(575,7498608,7498602,'29c',3.333,3),(575,7498609,7498602,'9c5',3.333,3),(575,7498610,7498602,'c58',3.333,3),(575,7498611,7498602,'58d',3.333,3),(575,7498612,7498602,'8d9',3.333,3),(575,7498613,7498602,'d9d',3.333,3),(575,7498614,7498602,'9db',3.333,3),(575,7498615,7498602,'db2',3.333,3),(575,7498616,7498602,'b25',3.333,3),(575,7498617,7498602,'25e',3.333,3),(575,7498618,7498602,'5ed',3.333,3),(575,7498619,7498602,'ed3',3.333,3),(575,7498620,7498602,'d3a',3.333,3),(575,7498621,7498602,'3a3',3.333,3),(575,7498622,7498602,'a37',3.333,3),(575,7498623,7498602,'37b',3.333,3),(575,7498624,7498602,'7b0',3.333,3),(575,7498625,7498602,'b02',3.333,3),(575,7498626,7498602,'024',3.333,3),(575,7498627,7498602,'24d',3.333,3),(575,7498628,7498602,'4d2',3.333,3),(575,7498629,7498602,'d23',3.333,3),(575,7498630,7498602,'238',3.333,3),(575,7498631,7498602,'384',3.333,3),(575,7498632,7498602,'841',3.333,3),(575,7498633,7498603,'mon',100,1),(575,7498634,7498633,'201',50,1),(575,7498635,7498633,'013',50,1),(575,7498636,7498634,'adm',33.333,3),(575,7498637,7498634,'dmi',33.333,3),(575,7498638,7498634,'min',33.333,3),(575,7498639,7498636,'cap',16.667,1),(575,7498640,7498636,'apa',16.667,1),(575,7498641,7498636,'pac',16.667,1),(575,7498642,7498636,'aci',16.667,1),(575,7498643,7498636,'cit',16.667,1),(575,7498644,7498636,'ity',16.667,1),(575,7498645,7498639,'pat',50,1),(575,7498646,7498639,'ath',50,1),(575,7498647,7498645,'fre',14.286,1),(575,7498648,7498645,'ree',14.286,1),(575,7498649,7498645,'ees',14.286,1),(575,7498650,7498645,'esp',14.286,1),(575,7498651,7498645,'spa',14.286,1),(575,7498652,7498645,'pac',14.286,1),(575,7498653,7498645,'ace',14.286,1),(575,7498654,7498647,'dis',50,1),(575,7498655,7498647,'isk',50,1),(575,7498656,7498654,'ind',33.333,1),(575,7498657,7498654,'nde',33.333,1),(575,7498658,7498654,'dex',33.333,1),(575,7498659,7498656,'adm',8.333,1),(575,7498660,7498656,'dmi',8.333,1),(575,7498661,7498656,'min',8.333,1),(575,7498662,7498656,'ini',8.333,1),(575,7498663,7498656,'nis',8.333,1),(575,7498664,7498656,'ist',8.333,1),(575,7498665,7498656,'str',8.333,1),(575,7498666,7498656,'tra',8.333,1),(575,7498667,7498656,'rat',8.333,1),(575,7498668,7498656,'ati',8.333,1),(575,7498669,7498656,'tio',8.333,1),(575,7498670,7498656,'ion',8.333,1),(575,7498671,7498659,'sta',33.333,3),(575,7498672,7498659,'tat',33.333,3),(575,7498673,7498659,'ate',33.333,3),(575,7498674,7498671,'ena',20,2),(575,7498675,7498671,'nab',20,2),(575,7498676,7498671,'abl',20,2),(575,7498677,7498671,'ble',20,2),(575,7498678,7498671,'led',20,2),(575,7498679,7498674,'cac',33.333,1),(575,7498680,7498674,'ach',33.333,1),(575,7498681,7498674,'che',33.333,1),(575,7498682,7498679,'mod',50,2),(575,7498683,7498679,'ode',50,2),(575,7498684,7498682,'wri',14.286,2),(575,7498685,7498682,'rit',14.286,2),(575,7498686,7498682,'ite',14.286,2),(575,7498687,7498682,'tet',14.286,2),(575,7498688,7498682,'eth',14.286,2),(575,7498689,7498682,'thr',14.286,2),(575,7498690,7498682,'hru',14.286,2),(575,7498691,7498684,'ope',11.111,2),(575,7498692,7498684,'per',11.111,2),(575,7498693,7498684,'era',11.111,2),(575,7498694,7498684,'rat',11.111,2),(575,7498695,7498684,'ati',11.111,2),(575,7498696,7498684,'tio',11.111,2),(575,7498697,7498684,'ion',11.111,2),(575,7498698,7498684,'ona',11.111,2),(575,7498699,7498684,'nal',11.111,2),(575,7498700,7498691,'nor',25,1),(575,7498701,7498691,'orm',25,1),(575,7498702,7498691,'rma',25,1),(575,7498703,7498691,'mal',25,1),(575,7498704,7498700,'mes',20,1),(575,7498705,7498700,'ess',20,1),(575,7498706,7498700,'ssa',20,1),(575,7498707,7498700,'sag',20,1),(575,7498708,7498700,'age',20,1),(575,7498709,7498704,'per',11.111,1),(575,7498710,7498704,'erf',11.111,1),(575,7498711,7498704,'rfo',11.111,1),(575,7498712,7498704,'for',11.111,1),(575,7498713,7498704,'orm',11.111,1),(575,7498714,7498704,'rma',11.111,1),(575,7498715,7498704,'man',11.111,1),(575,7498716,7498704,'anc',11.111,1),(575,7498717,7498704,'nce',11.111,1),(575,7498718,7498709,'ide',12.5,1),(575,7498719,7498709,'den',12.5,1),(575,7498720,7498709,'ent',12.5,1),(575,7498721,7498709,'nti',12.5,1),(575,7498722,7498709,'tif',12.5,1),(575,7498723,7498709,'ifi',12.5,1),(575,7498724,7498709,'fie',12.5,1),(575,7498725,7498709,'ier',12.5,1),(575,7498726,7498718,'vdi',33.333,3),(575,7498727,7498718,'dis',33.333,3),(575,7498728,7498718,'isk',33.333,3),(575,7498729,7498726,'nam',50,1),(575,7498730,7498726,'ame',50,1),(575,7498731,7498729,'typ',50,1),(575,7498732,7498729,'ype',50,1),(575,7498733,7498731,'dir',25,1),(575,7498734,7498731,'ire',25,1),(575,7498735,7498731,'rec',25,1),(575,7498736,7498731,'ect',25,1),(576,7498738,7498737,'naa',100,2),(576,7498739,7498738,'600',3.333,3),(576,7498740,7498738,'000',3.333,3),(576,7498741,7498738,'00c',3.333,3),(576,7498742,7498738,'0c2',3.333,3),(576,7498743,7498738,'c29',3.333,3),(576,7498744,7498738,'295',3.333,3),(576,7498745,7498738,'95e',3.333,3),(576,7498746,7498738,'5ea',3.333,3),(576,7498747,7498738,'eaa',3.333,3),(576,7498748,7498738,'aa5',3.333,3),(576,7498749,7498738,'a5d',3.333,3),(576,7498750,7498738,'5dc',3.333,3),(576,7498751,7498738,'dcc',3.333,3),(576,7498752,7498738,'ccf',3.333,3),(576,7498753,7498738,'cf4',3.333,3),(576,7498754,7498738,'f46',3.333,3),(576,7498755,7498738,'467',3.333,3),(576,7498756,7498738,'67b',3.333,3),(576,7498757,7498738,'7bb',3.333,3),(576,7498758,7498738,'bba',3.333,3),(576,7498759,7498738,'bae',3.333,3),(576,7498760,7498738,'ae8',3.333,3),(576,7498761,7498738,'e80',3.333,3),(576,7498762,7498738,'804',3.333,3),(576,7498763,7498738,'044',3.333,3),(576,7498764,7498738,'444',3.333,3),(576,7498765,7498738,'441',3.333,3),(576,7498766,7498738,'414',3.333,3),(576,7498767,7498738,'14c',3.333,3),(576,7498768,7498738,'4ce',3.333,3),(576,7498769,7498739,'mon',100,1),(576,7498770,7498769,'201',50,1),(576,7498771,7498769,'013',50,1),(576,7498772,7498770,'adm',33.333,3),(576,7498773,7498770,'dmi',33.333,3),(576,7498774,7498770,'min',33.333,3),(576,7498775,7498772,'cap',16.667,1),(576,7498776,7498772,'apa',16.667,1),(576,7498777,7498772,'pac',16.667,1),(576,7498778,7498772,'aci',16.667,1),(576,7498779,7498772,'cit',16.667,1),(576,7498780,7498772,'ity',16.667,1),(576,7498781,7498775,'pat',50,1),(576,7498782,7498775,'ath',50,1),(576,7498783,7498781,'fre',14.286,1),(576,7498784,7498781,'ree',14.286,1),(576,7498785,7498781,'ees',14.286,1),(576,7498786,7498781,'esp',14.286,1),(576,7498787,7498781,'spa',14.286,1),(576,7498788,7498781,'pac',14.286,1),(576,7498789,7498781,'ace',14.286,1),(576,7498790,7498783,'dis',50,1),(576,7498791,7498783,'isk',50,1),(576,7498792,7498790,'ind',33.333,1),(576,7498793,7498790,'nde',33.333,1),(576,7498794,7498790,'dex',33.333,1),(576,7498795,7498792,'adm',8.333,1),(576,7498796,7498792,'dmi',8.333,1),(576,7498797,7498792,'min',8.333,1),(576,7498798,7498792,'ini',8.333,1),(576,7498799,7498792,'nis',8.333,1),(576,7498800,7498792,'ist',8.333,1),(576,7498801,7498792,'str',8.333,1),(576,7498802,7498792,'tra',8.333,1),(576,7498803,7498792,'rat',8.333,1),(576,7498804,7498792,'ati',8.333,1),(576,7498805,7498792,'tio',8.333,1),(576,7498806,7498792,'ion',8.333,1),(576,7498807,7498795,'sta',33.333,3),(576,7498808,7498795,'tat',33.333,3),(576,7498809,7498795,'ate',33.333,3),(576,7498810,7498807,'ena',20,2),(576,7498811,7498807,'nab',20,2),(576,7498812,7498807,'abl',20,2),(576,7498813,7498807,'ble',20,2),(576,7498814,7498807,'led',20,2),(576,7498815,7498810,'cac',33.333,1),(576,7498816,7498810,'ach',33.333,1),(576,7498817,7498810,'che',33.333,1),(576,7498818,7498815,'mod',50,2),(576,7498819,7498815,'ode',50,2),(576,7498820,7498818,'wri',14.286,2),(576,7498821,7498818,'rit',14.286,2),(576,7498822,7498818,'ite',14.286,2),(576,7498823,7498818,'tet',14.286,2),(576,7498824,7498818,'eth',14.286,2),(576,7498825,7498818,'thr',14.286,2),(576,7498826,7498818,'hru',14.286,2),(576,7498827,7498820,'ope',11.111,2),(576,7498828,7498820,'per',11.111,2),(576,7498829,7498820,'era',11.111,2),(576,7498830,7498820,'rat',11.111,2),(576,7498831,7498820,'ati',11.111,2),(576,7498832,7498820,'tio',11.111,2),(576,7498833,7498820,'ion',11.111,2),(576,7498834,7498820,'ona',11.111,2),(576,7498835,7498820,'nal',11.111,2),(576,7498836,7498827,'nor',25,1),(576,7498837,7498827,'orm',25,1),(576,7498838,7498827,'rma',25,1),(576,7498839,7498827,'mal',25,1),(576,7498840,7498836,'mes',20,1),(576,7498841,7498836,'ess',20,1),(576,7498842,7498836,'ssa',20,1),(576,7498843,7498836,'sag',20,1),(576,7498844,7498836,'age',20,1),(576,7498845,7498840,'per',11.111,1),(576,7498846,7498840,'erf',11.111,1),(576,7498847,7498840,'rfo',11.111,1),(576,7498848,7498840,'for',11.111,1),(576,7498849,7498840,'orm',11.111,1),(576,7498850,7498840,'rma',11.111,1),(576,7498851,7498840,'man',11.111,1),(576,7498852,7498840,'anc',11.111,1),(576,7498853,7498840,'nce',11.111,1),(576,7498854,7498845,'ide',12.5,1),(576,7498855,7498845,'den',12.5,1),(576,7498856,7498845,'ent',12.5,1),(576,7498857,7498845,'nti',12.5,1),(576,7498858,7498845,'tif',12.5,1),(576,7498859,7498845,'ifi',12.5,1),(576,7498860,7498845,'fie',12.5,1),(576,7498861,7498845,'ier',12.5,1),(576,7498862,7498854,'vdi',33.333,3),(576,7498863,7498854,'dis',33.333,3),(576,7498864,7498854,'isk',33.333,3),(576,7498865,7498862,'nam',50,1),(576,7498866,7498862,'ame',50,1),(576,7498867,7498865,'typ',50,1),(576,7498868,7498865,'ype',50,1),(576,7498869,7498867,'dir',25,1),(576,7498870,7498867,'ire',25,1),(576,7498871,7498867,'rec',25,1),(576,7498872,7498867,'ect',25,1),(577,7498874,7498873,'naa',100,2),(577,7498875,7498874,'600',3.333,3),(577,7498876,7498874,'000',3.333,3),(577,7498877,7498874,'00c',3.333,3),(577,7498878,7498874,'0c2',3.333,3),(577,7498879,7498874,'c29',3.333,3),(577,7498880,7498874,'29b',3.333,3),(577,7498881,7498874,'9b2',3.333,3),(577,7498882,7498874,'b20',3.333,3),(577,7498883,7498874,'205',3.333,3),(577,7498884,7498874,'058',3.333,3),(577,7498885,7498874,'583',3.333,3),(577,7498886,7498874,'838',3.333,3),(577,7498887,7498874,'38c',3.333,3),(577,7498888,7498874,'8c4',3.333,3),(577,7498889,7498874,'c4c',3.333,3),(577,7498890,7498874,'4c5',3.333,3),(577,7498891,7498874,'c55',3.333,3),(577,7498892,7498874,'55a',3.333,3),(577,7498893,7498874,'5aa',3.333,3),(577,7498894,7498874,'aaa',3.333,3),(577,7498895,7498874,'aaf',3.333,3),(577,7498896,7498874,'afd',3.333,3),(577,7498897,7498874,'fda',3.333,3),(577,7498898,7498874,'da2',3.333,3),(577,7498899,7498874,'a23',3.333,3),(577,7498900,7498874,'23e',3.333,3),(577,7498901,7498874,'3ee',3.333,3),(577,7498902,7498874,'eed',3.333,3),(577,7498903,7498874,'ed7',3.333,3),(577,7498904,7498874,'d79',3.333,3),(577,7498905,7498875,'mon',100,1),(577,7498906,7498905,'201',50,1),(577,7498907,7498905,'013',50,1),(577,7498908,7498906,'adm',33.333,3),(577,7498909,7498906,'dmi',33.333,3),(577,7498910,7498906,'min',33.333,3),(577,7498911,7498908,'cap',16.667,1),(577,7498912,7498908,'apa',16.667,1),(577,7498913,7498908,'pac',16.667,1),(577,7498914,7498908,'aci',16.667,1),(577,7498915,7498908,'cit',16.667,1),(577,7498916,7498908,'ity',16.667,1),(577,7498917,7498911,'pat',50,1),(577,7498918,7498911,'ath',50,1),(577,7498919,7498917,'fre',14.286,1),(577,7498920,7498917,'ree',14.286,1),(577,7498921,7498917,'ees',14.286,1),(577,7498922,7498917,'esp',14.286,1),(577,7498923,7498917,'spa',14.286,1),(577,7498924,7498917,'pac',14.286,1),(577,7498925,7498917,'ace',14.286,1),(577,7498926,7498919,'dis',50,1),(577,7498927,7498919,'isk',50,1),(577,7498928,7498926,'ind',33.333,1),(577,7498929,7498926,'nde',33.333,1),(577,7498930,7498926,'dex',33.333,1),(577,7498931,7498928,'adm',8.333,1),(577,7498932,7498928,'dmi',8.333,1),(577,7498933,7498928,'min',8.333,1),(577,7498934,7498928,'ini',8.333,1),(577,7498935,7498928,'nis',8.333,1),(577,7498936,7498928,'ist',8.333,1),(577,7498937,7498928,'str',8.333,1),(577,7498938,7498928,'tra',8.333,1),(577,7498939,7498928,'rat',8.333,1),(577,7498940,7498928,'ati',8.333,1),(577,7498941,7498928,'tio',8.333,1),(577,7498942,7498928,'ion',8.333,1),(577,7498943,7498931,'sta',33.333,3),(577,7498944,7498931,'tat',33.333,3),(577,7498945,7498931,'ate',33.333,3),(577,7498946,7498943,'ena',20,2),(577,7498947,7498943,'nab',20,2),(577,7498948,7498943,'abl',20,2),(577,7498949,7498943,'ble',20,2),(577,7498950,7498943,'led',20,2),(577,7498951,7498946,'cac',33.333,1),(577,7498952,7498946,'ach',33.333,1),(577,7498953,7498946,'che',33.333,1),(577,7498954,7498951,'mod',50,2),(577,7498955,7498951,'ode',50,2),(577,7498956,7498954,'wri',14.286,2),(577,7498957,7498954,'rit',14.286,2),(577,7498958,7498954,'ite',14.286,2),(577,7498959,7498954,'tet',14.286,2),(577,7498960,7498954,'eth',14.286,2),(577,7498961,7498954,'thr',14.286,2),(577,7498962,7498954,'hru',14.286,2),(577,7498963,7498956,'ope',11.111,2),(577,7498964,7498956,'per',11.111,2),(577,7498965,7498956,'era',11.111,2),(577,7498966,7498956,'rat',11.111,2),(577,7498967,7498956,'ati',11.111,2),(577,7498968,7498956,'tio',11.111,2),(577,7498969,7498956,'ion',11.111,2),(577,7498970,7498956,'ona',11.111,2),(577,7498971,7498956,'nal',11.111,2),(577,7498972,7498963,'nor',25,1),(577,7498973,7498963,'orm',25,1),(577,7498974,7498963,'rma',25,1),(577,7498975,7498963,'mal',25,1),(577,7498976,7498972,'mes',20,1),(577,7498977,7498972,'ess',20,1),(577,7498978,7498972,'ssa',20,1),(577,7498979,7498972,'sag',20,1),(577,7498980,7498972,'age',20,1),(577,7498981,7498976,'per',11.111,1),(577,7498982,7498976,'erf',11.111,1),(577,7498983,7498976,'rfo',11.111,1),(577,7498984,7498976,'for',11.111,1),(577,7498985,7498976,'orm',11.111,1),(577,7498986,7498976,'rma',11.111,1),(577,7498987,7498976,'man',11.111,1),(577,7498988,7498976,'anc',11.111,1),(577,7498989,7498976,'nce',11.111,1),(577,7498990,7498981,'ide',12.5,1),(577,7498991,7498981,'den',12.5,1),(577,7498992,7498981,'ent',12.5,1),(577,7498993,7498981,'nti',12.5,1),(577,7498994,7498981,'tif',12.5,1),(577,7498995,7498981,'ifi',12.5,1),(577,7498996,7498981,'fie',12.5,1),(577,7498997,7498981,'ier',12.5,1),(577,7498998,7498990,'vdi',33.333,3),(577,7498999,7498990,'dis',33.333,3),(577,7499000,7498990,'isk',33.333,3),(577,7499001,7498998,'nam',50,1),(577,7499002,7498998,'ame',50,1),(577,7499003,7499001,'typ',50,1),(577,7499004,7499001,'ype',50,1),(577,7499005,7499003,'dir',25,1),(577,7499006,7499003,'ire',25,1),(577,7499007,7499003,'rec',25,1),(577,7499008,7499003,'ect',25,1),(578,7499010,7499009,'naa',100,2),(578,7499011,7499010,'600',3.333,3),(578,7499012,7499010,'000',3.333,3),(578,7499013,7499010,'00c',3.333,3),(578,7499014,7499010,'0c2',3.333,3),(578,7499015,7499010,'c29',3.333,3),(578,7499016,7499010,'29a',3.333,3),(578,7499017,7499010,'9a0',3.333,3),(578,7499018,7499010,'a03',3.333,3),(578,7499019,7499010,'03b',3.333,3),(578,7499020,7499010,'3b6',3.333,3),(578,7499021,7499010,'b63',3.333,3),(578,7499022,7499010,'63f',3.333,3),(578,7499023,7499010,'3f9',3.333,3),(578,7499024,7499010,'f95',3.333,3),(578,7499025,7499010,'95b',3.333,3),(578,7499026,7499010,'5b8',3.333,3),(578,7499027,7499010,'b8f',3.333,3),(578,7499028,7499010,'8f5',3.333,3),(578,7499029,7499010,'f59',3.333,3),(578,7499030,7499010,'592',3.333,3),(578,7499031,7499010,'92f',3.333,3),(578,7499032,7499010,'2f1',3.333,3),(578,7499033,7499010,'f18',3.333,3),(578,7499034,7499010,'18d',3.333,3),(578,7499035,7499010,'8d6',3.333,3),(578,7499036,7499010,'d63',3.333,3),(578,7499037,7499010,'630',3.333,3),(578,7499038,7499010,'30b',3.333,3),(578,7499039,7499010,'0b8',3.333,3),(578,7499040,7499010,'b86',3.333,3),(578,7499041,7499011,'mon',100,1),(578,7499042,7499041,'201',50,1),(578,7499043,7499041,'013',50,1),(578,7499044,7499042,'adm',33.333,3),(578,7499045,7499042,'dmi',33.333,3),(578,7499046,7499042,'min',33.333,3),(578,7499047,7499044,'cap',16.667,1),(578,7499048,7499044,'apa',16.667,1),(578,7499049,7499044,'pac',16.667,1),(578,7499050,7499044,'aci',16.667,1),(578,7499051,7499044,'cit',16.667,1),(578,7499052,7499044,'ity',16.667,1),(578,7499053,7499047,'pat',50,1),(578,7499054,7499047,'ath',50,1),(578,7499055,7499053,'fre',14.286,1),(578,7499056,7499053,'ree',14.286,1),(578,7499057,7499053,'ees',14.286,1),(578,7499058,7499053,'esp',14.286,1),(578,7499059,7499053,'spa',14.286,1),(578,7499060,7499053,'pac',14.286,1),(578,7499061,7499053,'ace',14.286,1),(578,7499062,7499055,'dis',50,1),(578,7499063,7499055,'isk',50,1),(578,7499064,7499062,'ind',33.333,1),(578,7499065,7499062,'nde',33.333,1),(578,7499066,7499062,'dex',33.333,1),(578,7499067,7499064,'adm',8.333,1),(578,7499068,7499064,'dmi',8.333,1),(578,7499069,7499064,'min',8.333,1),(578,7499070,7499064,'ini',8.333,1),(578,7499071,7499064,'nis',8.333,1),(578,7499072,7499064,'ist',8.333,1),(578,7499073,7499064,'str',8.333,1),(578,7499074,7499064,'tra',8.333,1),(578,7499075,7499064,'rat',8.333,1),(578,7499076,7499064,'ati',8.333,1),(578,7499077,7499064,'tio',8.333,1),(578,7499078,7499064,'ion',8.333,1),(578,7499079,7499067,'sta',33.333,3),(578,7499080,7499067,'tat',33.333,3),(578,7499081,7499067,'ate',33.333,3),(578,7499082,7499079,'ena',20,2),(578,7499083,7499079,'nab',20,2),(578,7499084,7499079,'abl',20,2),(578,7499085,7499079,'ble',20,2),(578,7499086,7499079,'led',20,2),(578,7499087,7499082,'cac',33.333,1),(578,7499088,7499082,'ach',33.333,1),(578,7499089,7499082,'che',33.333,1),(578,7499090,7499087,'mod',50,2),(578,7499091,7499087,'ode',50,2),(578,7499092,7499090,'wri',14.286,2),(578,7499093,7499090,'rit',14.286,2),(578,7499094,7499090,'ite',14.286,2),(578,7499095,7499090,'tet',14.286,2),(578,7499096,7499090,'eth',14.286,2),(578,7499097,7499090,'thr',14.286,2),(578,7499098,7499090,'hru',14.286,2),(578,7499099,7499092,'ope',11.111,2),(578,7499100,7499092,'per',11.111,2),(578,7499101,7499092,'era',11.111,2),(578,7499102,7499092,'rat',11.111,2),(578,7499103,7499092,'ati',11.111,2),(578,7499104,7499092,'tio',11.111,2),(578,7499105,7499092,'ion',11.111,2),(578,7499106,7499092,'ona',11.111,2),(578,7499107,7499092,'nal',11.111,2),(578,7499108,7499099,'nor',25,1),(578,7499109,7499099,'orm',25,1),(578,7499110,7499099,'rma',25,1),(578,7499111,7499099,'mal',25,1),(578,7499112,7499108,'mes',20,1),(578,7499113,7499108,'ess',20,1),(578,7499114,7499108,'ssa',20,1),(578,7499115,7499108,'sag',20,1),(578,7499116,7499108,'age',20,1),(578,7499117,7499112,'per',11.111,1),(578,7499118,7499112,'erf',11.111,1),(578,7499119,7499112,'rfo',11.111,1),(578,7499120,7499112,'for',11.111,1),(578,7499121,7499112,'orm',11.111,1),(578,7499122,7499112,'rma',11.111,1),(578,7499123,7499112,'man',11.111,1),(578,7499124,7499112,'anc',11.111,1),(578,7499125,7499112,'nce',11.111,1),(578,7499126,7499117,'ide',12.5,1),(578,7499127,7499117,'den',12.5,1),(578,7499128,7499117,'ent',12.5,1),(578,7499129,7499117,'nti',12.5,1),(578,7499130,7499117,'tif',12.5,1),(578,7499131,7499117,'ifi',12.5,1),(578,7499132,7499117,'fie',12.5,1),(578,7499133,7499117,'ier',12.5,1),(578,7499134,7499126,'vdi',33.333,3),(578,7499135,7499126,'dis',33.333,3),(578,7499136,7499126,'isk',33.333,3),(578,7499137,7499134,'nam',50,1),(578,7499138,7499134,'ame',50,1),(578,7499139,7499137,'typ',50,1),(578,7499140,7499137,'ype',50,1),(578,7499141,7499139,'dir',25,1),(578,7499142,7499139,'ire',25,1),(578,7499143,7499139,'rec',25,1),(578,7499144,7499139,'ect',25,1),(579,7499146,7499145,'naa',100,2),(579,7499147,7499146,'600',3.333,3),(579,7499148,7499146,'000',3.333,3),(579,7499149,7499146,'00c',3.333,3),(579,7499150,7499146,'0c2',3.333,3),(579,7499151,7499146,'c29',3.333,3),(579,7499152,7499146,'29b',3.333,3),(579,7499153,7499146,'9b4',3.333,3),(579,7499154,7499146,'b4b',3.333,3),(579,7499155,7499146,'4b8',3.333,3),(579,7499156,7499146,'b82',3.333,3),(579,7499157,7499146,'82c',3.333,3),(579,7499158,7499146,'2c4',3.333,3),(579,7499159,7499146,'c4c',3.333,3),(579,7499160,7499146,'4cc',3.333,3),(579,7499161,7499146,'cc1',3.333,3),(579,7499162,7499146,'c19',3.333,3),(579,7499163,7499146,'194',3.333,3),(579,7499164,7499146,'945',3.333,3),(579,7499165,7499146,'45e',3.333,3),(579,7499166,7499146,'5e2',3.333,3),(579,7499167,7499146,'e2d',3.333,3),(579,7499168,7499146,'2db',3.333,3),(579,7499169,7499146,'db1',3.333,3),(579,7499170,7499146,'b12',3.333,3),(579,7499171,7499146,'126',3.333,3),(579,7499172,7499146,'267',3.333,3),(579,7499173,7499146,'671',3.333,3),(579,7499174,7499146,'718',3.333,3),(579,7499175,7499146,'182',3.333,3),(579,7499176,7499146,'829',3.333,3),(579,7499177,7499147,'mon',100,1),(579,7499178,7499177,'201',50,1),(579,7499179,7499177,'013',50,1),(579,7499180,7499178,'adm',33.333,3),(579,7499181,7499178,'dmi',33.333,3),(579,7499182,7499178,'min',33.333,3),(579,7499183,7499180,'cap',16.667,1),(579,7499184,7499180,'apa',16.667,1),(579,7499185,7499180,'pac',16.667,1),(579,7499186,7499180,'aci',16.667,1),(579,7499187,7499180,'cit',16.667,1),(579,7499188,7499180,'ity',16.667,1),(579,7499189,7499183,'pat',50,1),(579,7499190,7499183,'ath',50,1),(579,7499191,7499189,'fre',14.286,1),(579,7499192,7499189,'ree',14.286,1),(579,7499193,7499189,'ees',14.286,1),(579,7499194,7499189,'esp',14.286,1),(579,7499195,7499189,'spa',14.286,1),(579,7499196,7499189,'pac',14.286,1),(579,7499197,7499189,'ace',14.286,1),(579,7499198,7499191,'dis',50,1),(579,7499199,7499191,'isk',50,1),(579,7499200,7499198,'ind',33.333,1),(579,7499201,7499198,'nde',33.333,1),(579,7499202,7499198,'dex',33.333,1),(579,7499203,7499200,'adm',8.333,1),(579,7499204,7499200,'dmi',8.333,1),(579,7499205,7499200,'min',8.333,1),(579,7499206,7499200,'ini',8.333,1),(579,7499207,7499200,'nis',8.333,1),(579,7499208,7499200,'ist',8.333,1),(579,7499209,7499200,'str',8.333,1),(579,7499210,7499200,'tra',8.333,1),(579,7499211,7499200,'rat',8.333,1),(579,7499212,7499200,'ati',8.333,1),(579,7499213,7499200,'tio',8.333,1),(579,7499214,7499200,'ion',8.333,1),(579,7499215,7499203,'sta',33.333,3),(579,7499216,7499203,'tat',33.333,3),(579,7499217,7499203,'ate',33.333,3),(579,7499218,7499215,'ena',20,2),(579,7499219,7499215,'nab',20,2),(579,7499220,7499215,'abl',20,2),(579,7499221,7499215,'ble',20,2),(579,7499222,7499215,'led',20,2),(579,7499223,7499218,'cac',33.333,1),(579,7499224,7499218,'ach',33.333,1),(579,7499225,7499218,'che',33.333,1),(579,7499226,7499223,'mod',50,2),(579,7499227,7499223,'ode',50,2),(579,7499228,7499226,'wri',14.286,2),(579,7499229,7499226,'rit',14.286,2),(579,7499230,7499226,'ite',14.286,2),(579,7499231,7499226,'tet',14.286,2),(579,7499232,7499226,'eth',14.286,2),(579,7499233,7499226,'thr',14.286,2),(579,7499234,7499226,'hru',14.286,2),(579,7499235,7499228,'ope',11.111,2),(579,7499236,7499228,'per',11.111,2),(579,7499237,7499228,'era',11.111,2),(579,7499238,7499228,'rat',11.111,2),(579,7499239,7499228,'ati',11.111,2),(579,7499240,7499228,'tio',11.111,2),(579,7499241,7499228,'ion',11.111,2),(579,7499242,7499228,'ona',11.111,2),(579,7499243,7499228,'nal',11.111,2),(579,7499244,7499235,'nor',25,1),(579,7499245,7499235,'orm',25,1),(579,7499246,7499235,'rma',25,1),(579,7499247,7499235,'mal',25,1),(579,7499248,7499244,'mes',20,1),(579,7499249,7499244,'ess',20,1),(579,7499250,7499244,'ssa',20,1),(579,7499251,7499244,'sag',20,1),(579,7499252,7499244,'age',20,1),(579,7499253,7499248,'per',11.111,1),(579,7499254,7499248,'erf',11.111,1),(579,7499255,7499248,'rfo',11.111,1),(579,7499256,7499248,'for',11.111,1),(579,7499257,7499248,'orm',11.111,1),(579,7499258,7499248,'rma',11.111,1),(579,7499259,7499248,'man',11.111,1),(579,7499260,7499248,'anc',11.111,1),(579,7499261,7499248,'nce',11.111,1),(579,7499262,7499253,'ide',12.5,1),(579,7499263,7499253,'den',12.5,1),(579,7499264,7499253,'ent',12.5,1),(579,7499265,7499253,'nti',12.5,1),(579,7499266,7499253,'tif',12.5,1),(579,7499267,7499253,'ifi',12.5,1),(579,7499268,7499253,'fie',12.5,1),(579,7499269,7499253,'ier',12.5,1),(579,7499270,7499262,'vdi',33.333,3),(579,7499271,7499262,'dis',33.333,3),(579,7499272,7499262,'isk',33.333,3),(579,7499273,7499270,'nam',50,1),(579,7499274,7499270,'ame',50,1),(579,7499275,7499273,'typ',50,1),(579,7499276,7499273,'ype',50,1),(579,7499277,7499275,'dir',25,1),(579,7499278,7499275,'ire',25,1),(579,7499279,7499275,'rec',25,1),(579,7499280,7499275,'ect',25,1),(580,7499282,7499281,'naa',100,2),(580,7499283,7499282,'600',3.333,3),(580,7499284,7499282,'000',3.333,3),(580,7499285,7499282,'00c',3.333,3),(580,7499286,7499282,'0c2',3.333,3),(580,7499287,7499282,'c29',3.333,3),(580,7499288,7499282,'29e',3.333,3),(580,7499289,7499282,'9e0',3.333,3),(580,7499290,7499282,'e08',3.333,3),(580,7499291,7499282,'08c',3.333,3),(580,7499292,7499282,'8ce',3.333,3),(580,7499293,7499282,'ce8',3.333,3),(580,7499294,7499282,'e8c',3.333,3),(580,7499295,7499282,'8c4',3.333,3),(580,7499296,7499282,'c49',3.333,3),(580,7499297,7499282,'49f',3.333,3),(580,7499298,7499282,'9f3',3.333,3),(580,7499299,7499282,'f38',3.333,3),(580,7499300,7499282,'388',3.333,3),(580,7499301,7499282,'881',3.333,3),(580,7499302,7499282,'81f',3.333,3),(580,7499303,7499282,'1f5',3.333,3),(580,7499304,7499282,'f5e',3.333,3),(580,7499305,7499282,'5e5',3.333,3),(580,7499306,7499282,'e54',3.333,3),(580,7499307,7499282,'545',3.333,3),(580,7499308,7499282,'458',3.333,3),(580,7499309,7499282,'58a',3.333,3),(580,7499310,7499282,'8ac',3.333,3),(580,7499311,7499282,'acd',3.333,3),(580,7499312,7499282,'cda',3.333,3),(580,7499313,7499283,'mon',100,1),(580,7499314,7499313,'201',50,1),(580,7499315,7499313,'013',50,1),(580,7499316,7499314,'adm',33.333,3),(580,7499317,7499314,'dmi',33.333,3),(580,7499318,7499314,'min',33.333,3),(580,7499319,7499316,'cap',16.667,1),(580,7499320,7499316,'apa',16.667,1),(580,7499321,7499316,'pac',16.667,1),(580,7499322,7499316,'aci',16.667,1),(580,7499323,7499316,'cit',16.667,1),(580,7499324,7499316,'ity',16.667,1),(580,7499325,7499319,'pat',50,1),(580,7499326,7499319,'ath',50,1),(580,7499327,7499325,'fre',14.286,1),(580,7499328,7499325,'ree',14.286,1),(580,7499329,7499325,'ees',14.286,1),(580,7499330,7499325,'esp',14.286,1),(580,7499331,7499325,'spa',14.286,1),(580,7499332,7499325,'pac',14.286,1),(580,7499333,7499325,'ace',14.286,1),(580,7499334,7499327,'dis',50,1),(580,7499335,7499327,'isk',50,1),(580,7499336,7499334,'ind',33.333,1),(580,7499337,7499334,'nde',33.333,1),(580,7499338,7499334,'dex',33.333,1),(580,7499339,7499336,'adm',8.333,1),(580,7499340,7499336,'dmi',8.333,1),(580,7499341,7499336,'min',8.333,1),(580,7499342,7499336,'ini',8.333,1),(580,7499343,7499336,'nis',8.333,1),(580,7499344,7499336,'ist',8.333,1),(580,7499345,7499336,'str',8.333,1),(580,7499346,7499336,'tra',8.333,1),(580,7499347,7499336,'rat',8.333,1),(580,7499348,7499336,'ati',8.333,1),(580,7499349,7499336,'tio',8.333,1),(580,7499350,7499336,'ion',8.333,1),(580,7499351,7499339,'sta',33.333,3),(580,7499352,7499339,'tat',33.333,3),(580,7499353,7499339,'ate',33.333,3),(580,7499354,7499351,'ena',20,2),(580,7499355,7499351,'nab',20,2),(580,7499356,7499351,'abl',20,2),(580,7499357,7499351,'ble',20,2),(580,7499358,7499351,'led',20,2),(580,7499359,7499354,'cac',33.333,1),(580,7499360,7499354,'ach',33.333,1),(580,7499361,7499354,'che',33.333,1),(580,7499362,7499359,'mod',50,2),(580,7499363,7499359,'ode',50,2),(580,7499364,7499362,'wri',14.286,2),(580,7499365,7499362,'rit',14.286,2),(580,7499366,7499362,'ite',14.286,2),(580,7499367,7499362,'tet',14.286,2),(580,7499368,7499362,'eth',14.286,2),(580,7499369,7499362,'thr',14.286,2),(580,7499370,7499362,'hru',14.286,2),(580,7499371,7499364,'ope',11.111,2),(580,7499372,7499364,'per',11.111,2),(580,7499373,7499364,'era',11.111,2),(580,7499374,7499364,'rat',11.111,2),(580,7499375,7499364,'ati',11.111,2),(580,7499376,7499364,'tio',11.111,2),(580,7499377,7499364,'ion',11.111,2),(580,7499378,7499364,'ona',11.111,2),(580,7499379,7499364,'nal',11.111,2),(580,7499380,7499371,'nor',25,1),(580,7499381,7499371,'orm',25,1),(580,7499382,7499371,'rma',25,1),(580,7499383,7499371,'mal',25,1),(580,7499384,7499380,'mes',20,1),(580,7499385,7499380,'ess',20,1),(580,7499386,7499380,'ssa',20,1),(580,7499387,7499380,'sag',20,1),(580,7499388,7499380,'age',20,1),(580,7499389,7499384,'per',11.111,1),(580,7499390,7499384,'erf',11.111,1),(580,7499391,7499384,'rfo',11.111,1),(580,7499392,7499384,'for',11.111,1),(580,7499393,7499384,'orm',11.111,1),(580,7499394,7499384,'rma',11.111,1),(580,7499395,7499384,'man',11.111,1),(580,7499396,7499384,'anc',11.111,1),(580,7499397,7499384,'nce',11.111,1),(580,7499398,7499389,'ide',12.5,1),(580,7499399,7499389,'den',12.5,1),(580,7499400,7499389,'ent',12.5,1),(580,7499401,7499389,'nti',12.5,1),(580,7499402,7499389,'tif',12.5,1),(580,7499403,7499389,'ifi',12.5,1),(580,7499404,7499389,'fie',12.5,1),(580,7499405,7499389,'ier',12.5,1),(580,7499406,7499398,'vdi',33.333,3),(580,7499407,7499398,'dis',33.333,3),(580,7499408,7499398,'isk',33.333,3),(580,7499409,7499406,'nam',50,1),(580,7499410,7499406,'ame',50,1),(580,7499411,7499409,'typ',50,1),(580,7499412,7499409,'ype',50,1),(580,7499413,7499411,'dir',25,1),(580,7499414,7499411,'ire',25,1),(580,7499415,7499411,'rec',25,1),(580,7499416,7499411,'ect',25,1),(581,7499418,7499417,'naa',100,2),(581,7499419,7499418,'600',3.333,3),(581,7499420,7499418,'000',3.333,3),(581,7499421,7499418,'00c',3.333,3),(581,7499422,7499418,'0c2',3.333,3),(581,7499423,7499418,'c29',3.333,3),(581,7499424,7499418,'29b',3.333,3),(581,7499425,7499418,'9be',3.333,3),(581,7499426,7499418,'beb',3.333,3),(581,7499427,7499418,'eb3',3.333,3),(581,7499428,7499418,'b32',3.333,3),(581,7499429,7499418,'328',3.333,3),(581,7499430,7499418,'28c',3.333,3),(581,7499431,7499418,'8cf',3.333,3),(581,7499432,7499418,'cfb',3.333,3),(581,7499433,7499418,'fb5',3.333,3),(581,7499434,7499418,'b51',3.333,3),(581,7499435,7499418,'51b',3.333,3),(581,7499436,7499418,'1bf',3.333,3),(581,7499437,7499418,'bf0',3.333,3),(581,7499438,7499418,'f06',3.333,3),(581,7499439,7499418,'068',3.333,3),(581,7499440,7499418,'683',3.333,3),(581,7499441,7499418,'835',3.333,3),(581,7499442,7499418,'35a',3.333,3),(581,7499443,7499418,'5ac',3.333,3),(581,7499444,7499418,'ac5',3.333,3),(581,7499445,7499418,'c5e',3.333,3),(581,7499446,7499418,'5ed',3.333,3),(581,7499447,7499418,'ed5',3.333,3),(581,7499448,7499418,'d52',3.333,3),(581,7499449,7499419,'mon',100,1),(581,7499450,7499449,'201',50,1),(581,7499451,7499449,'013',50,1),(581,7499452,7499450,'adm',33.333,3),(581,7499453,7499450,'dmi',33.333,3),(581,7499454,7499450,'min',33.333,3),(581,7499455,7499452,'cap',16.667,1),(581,7499456,7499452,'apa',16.667,1),(581,7499457,7499452,'pac',16.667,1),(581,7499458,7499452,'aci',16.667,1),(581,7499459,7499452,'cit',16.667,1),(581,7499460,7499452,'ity',16.667,1),(581,7499461,7499455,'pat',50,1),(581,7499462,7499455,'ath',50,1),(581,7499463,7499461,'fre',14.286,1),(581,7499464,7499461,'ree',14.286,1),(581,7499465,7499461,'ees',14.286,1),(581,7499466,7499461,'esp',14.286,1),(581,7499467,7499461,'spa',14.286,1),(581,7499468,7499461,'pac',14.286,1),(581,7499469,7499461,'ace',14.286,1),(581,7499470,7499463,'dis',50,1),(581,7499471,7499463,'isk',50,1),(581,7499472,7499470,'ind',33.333,1),(581,7499473,7499470,'nde',33.333,1),(581,7499474,7499470,'dex',33.333,1),(581,7499475,7499472,'adm',8.333,1),(581,7499476,7499472,'dmi',8.333,1),(581,7499477,7499472,'min',8.333,1),(581,7499478,7499472,'ini',8.333,1),(581,7499479,7499472,'nis',8.333,1),(581,7499480,7499472,'ist',8.333,1),(581,7499481,7499472,'str',8.333,1),(581,7499482,7499472,'tra',8.333,1),(581,7499483,7499472,'rat',8.333,1),(581,7499484,7499472,'ati',8.333,1),(581,7499485,7499472,'tio',8.333,1),(581,7499486,7499472,'ion',8.333,1),(581,7499487,7499475,'sta',33.333,3),(581,7499488,7499475,'tat',33.333,3),(581,7499489,7499475,'ate',33.333,3),(581,7499490,7499487,'ena',20,2),(581,7499491,7499487,'nab',20,2),(581,7499492,7499487,'abl',20,2),(581,7499493,7499487,'ble',20,2),(581,7499494,7499487,'led',20,2),(581,7499495,7499490,'cac',33.333,1),(581,7499496,7499490,'ach',33.333,1),(581,7499497,7499490,'che',33.333,1),(581,7499498,7499495,'mod',50,2),(581,7499499,7499495,'ode',50,2),(581,7499500,7499498,'wri',14.286,2),(581,7499501,7499498,'rit',14.286,2),(581,7499502,7499498,'ite',14.286,2),(581,7499503,7499498,'tet',14.286,2),(581,7499504,7499498,'eth',14.286,2),(581,7499505,7499498,'thr',14.286,2),(581,7499506,7499498,'hru',14.286,2),(581,7499507,7499500,'ope',11.111,2),(581,7499508,7499500,'per',11.111,2),(581,7499509,7499500,'era',11.111,2),(581,7499510,7499500,'rat',11.111,2),(581,7499511,7499500,'ati',11.111,2),(581,7499512,7499500,'tio',11.111,2),(581,7499513,7499500,'ion',11.111,2),(581,7499514,7499500,'ona',11.111,2),(581,7499515,7499500,'nal',11.111,2),(581,7499516,7499507,'nor',25,1),(581,7499517,7499507,'orm',25,1),(581,7499518,7499507,'rma',25,1),(581,7499519,7499507,'mal',25,1),(581,7499520,7499516,'mes',20,1),(581,7499521,7499516,'ess',20,1),(581,7499522,7499516,'ssa',20,1),(581,7499523,7499516,'sag',20,1),(581,7499524,7499516,'age',20,1),(581,7499525,7499520,'per',11.111,1),(581,7499526,7499520,'erf',11.111,1),(581,7499527,7499520,'rfo',11.111,1),(581,7499528,7499520,'for',11.111,1),(581,7499529,7499520,'orm',11.111,1),(581,7499530,7499520,'rma',11.111,1),(581,7499531,7499520,'man',11.111,1),(581,7499532,7499520,'anc',11.111,1),(581,7499533,7499520,'nce',11.111,1),(581,7499534,7499525,'ide',12.5,1),(581,7499535,7499525,'den',12.5,1),(581,7499536,7499525,'ent',12.5,1),(581,7499537,7499525,'nti',12.5,1),(581,7499538,7499525,'tif',12.5,1),(581,7499539,7499525,'ifi',12.5,1),(581,7499540,7499525,'fie',12.5,1),(581,7499541,7499525,'ier',12.5,1),(581,7499542,7499534,'vdi',33.333,3),(581,7499543,7499534,'dis',33.333,3),(581,7499544,7499534,'isk',33.333,3),(581,7499545,7499542,'nam',50,1),(581,7499546,7499542,'ame',50,1),(581,7499547,7499545,'typ',50,1),(581,7499548,7499545,'ype',50,1),(581,7499549,7499547,'dir',25,1),(581,7499550,7499547,'ire',25,1),(581,7499551,7499547,'rec',25,1),(581,7499552,7499547,'ect',25,1),(582,7499554,7499553,'naa',100,2),(582,7499555,7499554,'600',3.333,3),(582,7499556,7499554,'000',3.333,3),(582,7499557,7499554,'00c',3.333,3),(582,7499558,7499554,'0c2',3.333,3),(582,7499559,7499554,'c29',3.333,3),(582,7499560,7499554,'292',3.333,3),(582,7499561,7499554,'921',3.333,3),(582,7499562,7499554,'21d',3.333,3),(582,7499563,7499554,'1dd',3.333,3),(582,7499564,7499554,'dd7',3.333,3),(582,7499565,7499554,'d7b',3.333,3),(582,7499566,7499554,'7be',3.333,3),(582,7499567,7499554,'be4',3.333,3),(582,7499568,7499554,'e48',3.333,3),(582,7499569,7499554,'482',3.333,3),(582,7499570,7499554,'825',3.333,3),(582,7499571,7499554,'256',3.333,3),(582,7499572,7499554,'56a',3.333,3),(582,7499573,7499554,'6aa',3.333,3),(582,7499574,7499554,'aa0',3.333,3),(582,7499575,7499554,'a02',3.333,3),(582,7499576,7499554,'020',3.333,3),(582,7499577,7499554,'206',3.333,3),(582,7499578,7499554,'064',3.333,3),(582,7499579,7499554,'64b',3.333,3),(582,7499580,7499554,'4b5',3.333,3),(582,7499581,7499554,'b5d',3.333,3),(582,7499582,7499554,'5d0',3.333,3),(582,7499583,7499554,'d01',3.333,3),(582,7499584,7499554,'01d',3.333,3),(582,7499585,7499555,'mon',100,1),(582,7499586,7499585,'201',50,1),(582,7499587,7499585,'013',50,1),(582,7499588,7499586,'adm',33.333,3),(582,7499589,7499586,'dmi',33.333,3),(582,7499590,7499586,'min',33.333,3),(582,7499591,7499588,'cap',16.667,1),(582,7499592,7499588,'apa',16.667,1),(582,7499593,7499588,'pac',16.667,1),(582,7499594,7499588,'aci',16.667,1),(582,7499595,7499588,'cit',16.667,1),(582,7499596,7499588,'ity',16.667,1),(582,7499597,7499591,'pat',50,1),(582,7499598,7499591,'ath',50,1),(582,7499599,7499597,'two',100,1),(582,7499600,7499599,'fre',14.286,1),(582,7499601,7499599,'ree',14.286,1),(582,7499602,7499599,'ees',14.286,1),(582,7499603,7499599,'esp',14.286,1),(582,7499604,7499599,'spa',14.286,1),(582,7499605,7499599,'pac',14.286,1),(582,7499606,7499599,'ace',14.286,1),(582,7499607,7499600,'dis',50,1),(582,7499608,7499600,'isk',50,1),(582,7499609,7499607,'ind',33.333,1),(582,7499610,7499607,'nde',33.333,1),(582,7499611,7499607,'dex',33.333,1),(582,7499612,7499609,'adm',8.333,1),(582,7499613,7499609,'dmi',8.333,1),(582,7499614,7499609,'min',8.333,1),(582,7499615,7499609,'ini',8.333,1),(582,7499616,7499609,'nis',8.333,1),(582,7499617,7499609,'ist',8.333,1),(582,7499618,7499609,'str',8.333,1),(582,7499619,7499609,'tra',8.333,1),(582,7499620,7499609,'rat',8.333,1),(582,7499621,7499609,'ati',8.333,1),(582,7499622,7499609,'tio',8.333,1),(582,7499623,7499609,'ion',8.333,1),(582,7499624,7499612,'sta',33.333,3),(582,7499625,7499612,'tat',33.333,3),(582,7499626,7499612,'ate',33.333,3),(582,7499627,7499624,'ena',20,2),(582,7499628,7499624,'nab',20,2),(582,7499629,7499624,'abl',20,2),(582,7499630,7499624,'ble',20,2),(582,7499631,7499624,'led',20,2),(582,7499632,7499627,'cac',33.333,1),(582,7499633,7499627,'ach',33.333,1),(582,7499634,7499627,'che',33.333,1),(582,7499635,7499632,'mod',50,2),(582,7499636,7499632,'ode',50,2),(582,7499637,7499635,'wri',14.286,2),(582,7499638,7499635,'rit',14.286,2),(582,7499639,7499635,'ite',14.286,2),(582,7499640,7499635,'tet',14.286,2),(582,7499641,7499635,'eth',14.286,2),(582,7499642,7499635,'thr',14.286,2),(582,7499643,7499635,'hru',14.286,2),(582,7499644,7499637,'ope',11.111,2),(582,7499645,7499637,'per',11.111,2),(582,7499646,7499637,'era',11.111,2),(582,7499647,7499637,'rat',11.111,2),(582,7499648,7499637,'ati',11.111,2),(582,7499649,7499637,'tio',11.111,2),(582,7499650,7499637,'ion',11.111,2),(582,7499651,7499637,'ona',11.111,2),(582,7499652,7499637,'nal',11.111,2),(582,7499653,7499644,'nor',25,1),(582,7499654,7499644,'orm',25,1),(582,7499655,7499644,'rma',25,1),(582,7499656,7499644,'mal',25,1),(582,7499657,7499653,'mes',20,1),(582,7499658,7499653,'ess',20,1),(582,7499659,7499653,'ssa',20,1),(582,7499660,7499653,'sag',20,1),(582,7499661,7499653,'age',20,1),(582,7499662,7499657,'per',11.111,1),(582,7499663,7499657,'erf',11.111,1),(582,7499664,7499657,'rfo',11.111,1),(582,7499665,7499657,'for',11.111,1),(582,7499666,7499657,'orm',11.111,1),(582,7499667,7499657,'rma',11.111,1),(582,7499668,7499657,'man',11.111,1),(582,7499669,7499657,'anc',11.111,1),(582,7499670,7499657,'nce',11.111,1),(582,7499671,7499662,'ide',12.5,1),(582,7499672,7499662,'den',12.5,1),(582,7499673,7499662,'ent',12.5,1),(582,7499674,7499662,'nti',12.5,1),(582,7499675,7499662,'tif',12.5,1),(582,7499676,7499662,'ifi',12.5,1),(582,7499677,7499662,'fie',12.5,1),(582,7499678,7499662,'ier',12.5,1),(582,7499679,7499671,'vdi',33.333,3),(582,7499680,7499671,'dis',33.333,3),(582,7499681,7499671,'isk',33.333,3),(582,7499682,7499679,'nam',50,1),(582,7499683,7499679,'ame',50,1),(582,7499684,7499682,'typ',50,1),(582,7499685,7499682,'ype',50,1),(582,7499686,7499684,'dir',25,1),(582,7499687,7499684,'ire',25,1),(582,7499688,7499684,'rec',25,1),(582,7499689,7499684,'ect',25,1),(463,7499691,7499690,'att',12.5,1),(463,7499692,7499690,'ttr',12.5,1),(463,7499693,7499690,'tri',12.5,1),(463,7499694,7499690,'rib',12.5,1),(463,7499695,7499690,'ibu',12.5,1),(463,7499696,7499690,'but',12.5,1),(463,7499697,7499690,'ute',12.5,1),(463,7499698,7499690,'tes',12.5,1),(463,7499699,7499691,'ref',20,3),(463,7499700,7499691,'efr',20,3),(463,7499701,7499691,'fre',20,3),(463,7499702,7499691,'res',20,3),(463,7499703,7499691,'esh',20,3),(463,7499704,7499699,'hos',50,2),(463,7499705,7499699,'ost',50,2),(463,7499706,7499704,'nam',50,2),(463,7499707,7499704,'ame',50,2),(463,7499708,7499706,'hg3',9.091,1),(463,7499709,7499706,'g32',9.091,1),(463,7499710,7499706,'32v',9.091,1),(463,7499711,7499706,'2vm',9.091,1),(463,7499712,7499706,'vm6',9.091,1),(463,7499713,7499706,'m6w',9.091,1),(463,7499714,7499706,'6w2',9.091,1),(463,7499715,7499706,'w2k',9.091,1),(463,7499716,7499706,'2k8',9.091,1),(463,7499717,7499706,'k8r',9.091,1),(463,7499718,7499706,'8r2',9.091,1),(463,7499719,7499708,'gdl',100,1),(463,7499720,7499719,'eng',25,1),(463,7499721,7499719,'ngl',25,1),(463,7499722,7499719,'gla',25,1),(463,7499723,7499719,'lab',25,1),(463,7499724,7499720,'net',25,1),(463,7499725,7499720,'eta',25,1),(463,7499726,7499720,'tap',25,1),(463,7499727,7499720,'app',25,1),(463,7499728,7499724,'com',100,1),(463,7499729,7499728,'mem',25,3),(463,7499730,7499728,'emo',25,3),(463,7499731,7499728,'mor',25,3),(463,7499732,7499728,'ory',25,3),(463,7499733,7499729,'siz',50,2),(463,7499734,7499729,'ize',50,2),(463,7499735,7499733,'614',50,1),(463,7499736,7499733,'144',50,1),(463,7499737,7499735,'cpu',100,1),(463,7499738,7499737,'usa',33.333,3),(463,7499739,7499737,'sag',33.333,3),(463,7499740,7499737,'age',33.333,3),(463,7499741,7499738,'mhz',100,1),(463,7499742,7499741,'add',20,1),(463,7499743,7499741,'ddr',20,1),(463,7499744,7499741,'dre',20,1),(463,7499745,7499741,'res',20,1),(463,7499746,7499741,'ess',20,1),(463,7499747,7499742,'226',100,1),(463,7499748,7499747,'147',100,1),(463,7499749,7499748,'208',100,1),(463,7499750,7499749,'386',50,1),(463,7499751,7499749,'868',50,1),(463,7499752,7499750,'gue',33.333,2),(463,7499753,7499750,'ues',33.333,2),(463,7499754,7499750,'est',33.333,2),(463,7499755,7499752,'vmw',25,2),(463,7499756,7499752,'mwa',25,2),(463,7499757,7499752,'war',25,2),(463,7499758,7499752,'are',25,2),(463,7499759,7499755,'too',33.333,2),(463,7499760,7499755,'ool',33.333,2),(463,7499761,7499755,'ols',33.333,2),(463,7499762,7499759,'run',20,1),(463,7499763,7499759,'unn',20,1),(463,7499764,7499759,'nni',20,1),(463,7499765,7499759,'nin',20,1),(463,7499766,7499759,'ing',20,1),(463,7499767,7499762,'and',100,1),(463,7499768,7499767,'the',100,1),(463,7499769,7499768,'ver',20,2),(463,7499770,7499768,'ers',20,2),(463,7499771,7499768,'rsi',20,2),(463,7499772,7499768,'sio',20,2),(463,7499773,7499768,'ion',20,2),(463,7499774,7499769,'cur',20,1),(463,7499775,7499769,'urr',20,1),(463,7499776,7499769,'rre',20,1),(463,7499777,7499769,'ren',20,1),(463,7499778,7499769,'ent',20,1),(463,7499779,7499774,'mic',14.286,1),(463,7499780,7499774,'icr',14.286,1),(463,7499781,7499774,'cro',14.286,1),(463,7499782,7499774,'ros',14.286,1),(463,7499783,7499774,'oso',14.286,1),(463,7499784,7499774,'sof',14.286,1),(463,7499785,7499774,'oft',14.286,1),(463,7499786,7499779,'win',20,1),(463,7499787,7499779,'ind',20,1),(463,7499788,7499779,'ndo',20,1),(463,7499789,7499779,'dow',20,1),(463,7499790,7499779,'ows',20,1),(463,7499791,7499786,'ser',25,1),(463,7499792,7499786,'erv',25,1),(463,7499793,7499786,'rve',25,1),(463,7499794,7499786,'ver',25,1),(463,7499795,7499791,'200',50,1),(463,7499796,7499791,'008',50,1),(463,7499797,7499795,'64b',33.333,1),(463,7499798,7499795,'4bi',33.333,1),(463,7499799,7499795,'bit',33.333,1),(463,7499800,7499797,'pat',50,1),(463,7499801,7499797,'ath',50,1),(463,7499802,7499800,'rx6',33.333,1),(463,7499803,7499800,'x60',33.333,1),(463,7499804,7499800,'600',33.333,1),(463,7499805,7499802,'vmf',20,1),(463,7499806,7499802,'mfi',20,1),(463,7499807,7499802,'fil',20,1),(463,7499808,7499802,'ile',20,1),(463,7499809,7499802,'les',20,1),(463,7499810,7499805,'hgw',9.091,2),(463,7499811,7499805,'gw2',9.091,2),(463,7499812,7499805,'w2k',9.091,2),(463,7499813,7499805,'2k8',9.091,2),(463,7499814,7499805,'k8r',9.091,2),(463,7499815,7499805,'8r2',9.091,2),(463,7499816,7499805,'r23',9.091,2),(463,7499817,7499805,'232',9.091,2),(463,7499818,7499805,'32v',9.091,2),(463,7499819,7499805,'2vm',9.091,2),(463,7499820,7499805,'vm6',9.091,2),(463,7499821,7499810,'vmx',100,1),(463,7499822,7499821,'fla',33.333,1),(463,7499823,7499821,'las',33.333,1),(463,7499824,7499821,'ash',33.333,1),(463,7499825,7499822,'acc',33.333,1),(463,7499826,7499822,'cce',33.333,1),(463,7499827,7499822,'cel',33.333,1),(463,7499828,7499825,'con',9.091,1),(463,7499829,7499825,'onf',9.091,1),(463,7499830,7499825,'nfi',9.091,1),(463,7499831,7499825,'fig',9.091,1),(463,7499832,7499825,'igu',9.091,1),(463,7499833,7499825,'gur',9.091,1),(463,7499834,7499825,'ura',9.091,1),(463,7499835,7499825,'rat',9.091,1),(463,7499836,7499825,'ati',9.091,1),(463,7499837,7499825,'tio',9.091,1),(463,7499838,7499825,'ion',9.091,1),(463,7499839,7499828,'age',33.333,1),(463,7499840,7499828,'gen',33.333,1),(463,7499841,7499828,'ent',33.333,1),(463,7499842,7499839,'193',16.667,1),(463,7499843,7499839,'932',16.667,1),(463,7499844,7499839,'320',16.667,1),(463,7499845,7499839,'204',16.667,1),(463,7499846,7499839,'044',16.667,1),(463,7499847,7499839,'449',16.667,1),(463,7499848,7499842,'cac',33.333,3),(463,7499849,7499842,'ach',33.333,3),(463,7499850,7499842,'che',33.333,3),(463,7499851,7499848,'sta',33.333,2),(463,7499852,7499848,'tat',33.333,2),(463,7499853,7499848,'ate',33.333,2),(463,7499854,7499851,'dis',16.667,3),(463,7499855,7499851,'isa',16.667,3),(463,7499856,7499851,'sab',16.667,3),(463,7499857,7499851,'abl',16.667,3),(463,7499858,7499851,'ble',16.667,3),(463,7499859,7499851,'led',16.667,3),(463,7499860,7499854,'ope',11.111,2),(463,7499861,7499854,'per',11.111,2),(463,7499862,7499854,'era',11.111,2),(463,7499863,7499854,'rat',11.111,2),(463,7499864,7499854,'ati',11.111,2),(463,7499865,7499854,'tio',11.111,2),(463,7499866,7499854,'ion',11.111,2),(463,7499867,7499854,'ona',11.111,2),(463,7499868,7499854,'nal',11.111,2),(463,7499869,7499860,'mod',50,1),(463,7499870,7499860,'ode',50,1),(463,7499871,7499869,'wri',14.286,1),(463,7499872,7499869,'rit',14.286,1),(463,7499873,7499869,'ite',14.286,1),(463,7499874,7499869,'tet',14.286,1),(463,7499875,7499869,'eth',14.286,1),(463,7499876,7499869,'thr',14.286,1),(463,7499877,7499869,'hru',14.286,1),(463,7499878,7499871,'mes',20,1),(463,7499879,7499871,'ess',20,1),(463,7499880,7499871,'ssa',20,1),(463,7499881,7499871,'sag',20,1),(463,7499882,7499871,'age',20,1),(463,7499883,7499878,'adm',33.333,1),(463,7499884,7499878,'dmi',33.333,1),(463,7499885,7499878,'min',33.333,1),(463,7499886,7499883,'met',20,3),(463,7499887,7499883,'etr',20,3),(463,7499888,7499883,'tri',20,3),(463,7499889,7499883,'ric',20,3),(463,7499890,7499883,'ics',20,3),(463,7499891,7499886,'ena',20,1),(463,7499892,7499886,'nab',20,1),(463,7499893,7499886,'abl',20,1),(463,7499894,7499886,'ble',20,1),(463,7499895,7499886,'led',20,1),(463,7499896,7499891,'vir',20,1),(463,7499897,7499891,'irt',20,1),(463,7499898,7499891,'rtu',20,1),(463,7499899,7499891,'tua',20,1),(463,7499900,7499891,'ual',20,1),(463,7499901,7499896,'dis',50,1),(463,7499902,7499896,'isk',50,1),(584,7500095,7500094,'naa',100,2),(584,7500096,7500095,'600',3.333,3),(584,7500097,7500095,'000',3.333,3),(584,7500098,7500095,'00c',3.333,3),(584,7500099,7500095,'0c2',3.333,3),(584,7500100,7500095,'c29',3.333,3),(584,7500101,7500095,'292',3.333,3),(584,7500102,7500095,'926',3.333,3),(584,7500103,7500095,'26d',3.333,3),(584,7500104,7500095,'6da',3.333,3),(584,7500105,7500095,'daf',3.333,3),(584,7500106,7500095,'aff',3.333,3),(584,7500107,7500095,'ff7',3.333,3),(584,7500108,7500095,'f77',3.333,3),(584,7500109,7500095,'777',3.333,3),(584,7500110,7500095,'773',3.333,3),(584,7500111,7500095,'732',3.333,3),(584,7500112,7500095,'326',3.333,3),(584,7500113,7500095,'26a',3.333,3),(584,7500114,7500095,'6ac',3.333,3),(584,7500115,7500095,'ac2',3.333,3),(584,7500116,7500095,'c23',3.333,3),(584,7500117,7500095,'239',3.333,3),(584,7500118,7500095,'392',3.333,3),(584,7500119,7500095,'92e',3.333,3),(584,7500120,7500095,'2ef',3.333,3),(584,7500121,7500095,'ef5',3.333,3),(584,7500122,7500095,'f5b',3.333,3),(584,7500123,7500095,'5b8',3.333,3),(584,7500124,7500095,'b81',3.333,3),(584,7500125,7500095,'810',3.333,3),(584,7500126,7500096,'mon',100,1),(584,7500127,7500126,'201',50,1),(584,7500128,7500126,'013',50,1),(584,7500129,7500127,'adm',33.333,3),(584,7500130,7500127,'dmi',33.333,3),(584,7500131,7500127,'min',33.333,3),(584,7500132,7500129,'cap',16.667,1),(584,7500133,7500129,'apa',16.667,1),(584,7500134,7500129,'pac',16.667,1),(584,7500135,7500129,'aci',16.667,1),(584,7500136,7500129,'cit',16.667,1),(584,7500137,7500129,'ity',16.667,1),(584,7500138,7500132,'pat',50,1),(584,7500139,7500132,'ath',50,1),(584,7500140,7500138,'fre',14.286,1),(584,7500141,7500138,'ree',14.286,1),(584,7500142,7500138,'ees',14.286,1),(584,7500143,7500138,'esp',14.286,1),(584,7500144,7500138,'spa',14.286,1),(584,7500145,7500138,'pac',14.286,1),(584,7500146,7500138,'ace',14.286,1),(584,7500147,7500140,'dis',50,1),(584,7500148,7500140,'isk',50,1),(584,7500149,7500147,'ind',33.333,1),(584,7500150,7500147,'nde',33.333,1),(584,7500151,7500147,'dex',33.333,1),(584,7500152,7500149,'adm',8.333,1),(584,7500153,7500149,'dmi',8.333,1),(584,7500154,7500149,'min',8.333,1),(584,7500155,7500149,'ini',8.333,1),(584,7500156,7500149,'nis',8.333,1),(584,7500157,7500149,'ist',8.333,1),(584,7500158,7500149,'str',8.333,1),(584,7500159,7500149,'tra',8.333,1),(584,7500160,7500149,'rat',8.333,1),(584,7500161,7500149,'ati',8.333,1),(584,7500162,7500149,'tio',8.333,1),(584,7500163,7500149,'ion',8.333,1),(584,7500164,7500152,'sta',33.333,3),(584,7500165,7500152,'tat',33.333,3),(584,7500166,7500152,'ate',33.333,3),(584,7500167,7500164,'ena',20,2),(584,7500168,7500164,'nab',20,2),(584,7500169,7500164,'abl',20,2),(584,7500170,7500164,'ble',20,2),(584,7500171,7500164,'led',20,2),(584,7500172,7500167,'cac',33.333,2),(584,7500173,7500167,'ach',33.333,2),(584,7500174,7500167,'che',33.333,2),(584,7500175,7500172,'mod',50,1),(584,7500176,7500172,'ode',50,1),(584,7500177,7500175,'wri',14.286,1),(584,7500178,7500175,'rit',14.286,1),(584,7500179,7500175,'ite',14.286,1),(584,7500180,7500175,'tet',14.286,1),(584,7500181,7500175,'eth',14.286,1),(584,7500182,7500175,'thr',14.286,1),(584,7500183,7500175,'hru',14.286,1),(584,7500184,7500177,'ope',11.111,2),(584,7500185,7500177,'per',11.111,2),(584,7500186,7500177,'era',11.111,2),(584,7500187,7500177,'rat',11.111,2),(584,7500188,7500177,'ati',11.111,2),(584,7500189,7500177,'tio',11.111,2),(584,7500190,7500177,'ion',11.111,2),(584,7500191,7500177,'ona',11.111,2),(584,7500192,7500177,'nal',11.111,2),(584,7500193,7500184,'pen',20,1),(584,7500194,7500184,'end',20,1),(584,7500195,7500184,'ndi',20,1),(584,7500196,7500184,'din',20,1),(584,7500197,7500184,'ing',20,1),(584,7500198,7500193,'mes',20,1),(584,7500199,7500193,'ess',20,1),(584,7500200,7500193,'ssa',20,1),(584,7500201,7500193,'sag',20,1),(584,7500202,7500193,'age',20,1),(584,7500203,7500198,'wai',20,1),(584,7500204,7500198,'ait',20,1),(584,7500205,7500198,'iti',20,1),(584,7500206,7500198,'tin',20,1),(584,7500207,7500198,'ing',20,1),(584,7500208,7500203,'for',100,1),(584,7500209,7500208,'per',11.111,1),(584,7500210,7500208,'erf',11.111,1),(584,7500211,7500208,'rfo',11.111,1),(584,7500212,7500208,'for',11.111,1),(584,7500213,7500208,'orm',11.111,1),(584,7500214,7500208,'rma',11.111,1),(584,7500215,7500208,'man',11.111,1),(584,7500216,7500208,'anc',11.111,1),(584,7500217,7500208,'nce',11.111,1),(584,7500218,7500209,'ide',12.5,1),(584,7500219,7500209,'den',12.5,1),(584,7500220,7500209,'ent',12.5,1),(584,7500221,7500209,'nti',12.5,1),(584,7500222,7500209,'tif',12.5,1),(584,7500223,7500209,'ifi',12.5,1),(584,7500224,7500209,'fie',12.5,1),(584,7500225,7500209,'ier',12.5,1),(584,7500226,7500218,'vdi',33.333,3),(584,7500227,7500218,'dis',33.333,3),(584,7500228,7500218,'isk',33.333,3),(584,7500229,7500226,'nam',50,1),(584,7500230,7500226,'ame',50,1),(584,7500231,7500229,'typ',50,1),(584,7500232,7500229,'ype',50,1),(584,7500233,7500231,'dir',25,1),(584,7500234,7500231,'ire',25,1),(584,7500235,7500231,'rec',25,1),(584,7500236,7500231,'ect',25,1),(585,7500238,7500237,'naa',100,2),(585,7500239,7500238,'600',3.333,3),(585,7500240,7500238,'00a',3.333,3),(585,7500241,7500238,'0a0',3.333,3),(585,7500242,7500238,'a09',3.333,3),(585,7500243,7500238,'098',3.333,3),(585,7500244,7500238,'980',3.333,3),(585,7500245,7500238,'804',3.333,3),(585,7500246,7500238,'044',3.333,3),(585,7500247,7500238,'443',3.333,3),(585,7500248,7500238,'430',3.333,3),(585,7500249,7500238,'307',3.333,3),(585,7500250,7500238,'072',3.333,3),(585,7500251,7500238,'725',3.333,3),(585,7500252,7500238,'259',3.333,3),(585,7500253,7500238,'593',3.333,3),(585,7500254,7500238,'931',3.333,3),(585,7500255,7500238,'313',3.333,3),(585,7500256,7500238,'13f',3.333,3),(585,7500257,7500238,'3f3',3.333,3),(585,7500258,7500238,'f33',3.333,3),(585,7500259,7500238,'334',3.333,3),(585,7500260,7500238,'345',3.333,3),(585,7500261,7500238,'455',3.333,3),(585,7500262,7500238,'556',3.333,3),(585,7500263,7500238,'563',3.333,3),(585,7500264,7500238,'639',3.333,3),(585,7500265,7500238,'393',3.333,3),(585,7500266,7500238,'934',3.333,3),(585,7500267,7500238,'344',3.333,3),(585,7500268,7500238,'447',3.333,3),(585,7500269,7500239,'mon',100,1),(585,7500270,7500269,'201',50,1),(585,7500271,7500269,'013',50,1),(585,7500272,7500270,'adm',33.333,3),(585,7500273,7500270,'dmi',33.333,3),(585,7500274,7500270,'min',33.333,3),(585,7500275,7500272,'cap',16.667,1),(585,7500276,7500272,'apa',16.667,1),(585,7500277,7500272,'pac',16.667,1),(585,7500278,7500272,'aci',16.667,1),(585,7500279,7500272,'cit',16.667,1),(585,7500280,7500272,'ity',16.667,1),(585,7500281,7500275,'pat',50,1),(585,7500282,7500275,'ath',50,1),(585,7500283,7500281,'fre',14.286,1),(585,7500284,7500281,'ree',14.286,1),(585,7500285,7500281,'ees',14.286,1),(585,7500286,7500281,'esp',14.286,1),(585,7500287,7500281,'spa',14.286,1),(585,7500288,7500281,'pac',14.286,1),(585,7500289,7500281,'ace',14.286,1),(585,7500290,7500283,'dis',50,1),(585,7500291,7500283,'isk',50,1),(585,7500292,7500290,'ind',33.333,1),(585,7500293,7500290,'nde',33.333,1),(585,7500294,7500290,'dex',33.333,1),(585,7500295,7500292,'adm',8.333,1),(585,7500296,7500292,'dmi',8.333,1),(585,7500297,7500292,'min',8.333,1),(585,7500298,7500292,'ini',8.333,1),(585,7500299,7500292,'nis',8.333,1),(585,7500300,7500292,'ist',8.333,1),(585,7500301,7500292,'str',8.333,1),(585,7500302,7500292,'tra',8.333,1),(585,7500303,7500292,'rat',8.333,1),(585,7500304,7500292,'ati',8.333,1),(585,7500305,7500292,'tio',8.333,1),(585,7500306,7500292,'ion',8.333,1),(585,7500307,7500295,'sta',33.333,3),(585,7500308,7500295,'tat',33.333,3),(585,7500309,7500295,'ate',33.333,3),(585,7500310,7500307,'ena',20,2),(585,7500311,7500307,'nab',20,2),(585,7500312,7500307,'abl',20,2),(585,7500313,7500307,'ble',20,2),(585,7500314,7500307,'led',20,2),(585,7500315,7500310,'cac',33.333,2),(585,7500316,7500310,'ach',33.333,2),(585,7500317,7500310,'che',33.333,2),(585,7500318,7500315,'mod',50,1),(585,7500319,7500315,'ode',50,1),(585,7500320,7500318,'wri',14.286,1),(585,7500321,7500318,'rit',14.286,1),(585,7500322,7500318,'ite',14.286,1),(585,7500323,7500318,'tet',14.286,1),(585,7500324,7500318,'eth',14.286,1),(585,7500325,7500318,'thr',14.286,1),(585,7500326,7500318,'hru',14.286,1),(585,7500327,7500320,'ope',11.111,2),(585,7500328,7500320,'per',11.111,2),(585,7500329,7500320,'era',11.111,2),(585,7500330,7500320,'rat',11.111,2),(585,7500331,7500320,'ati',11.111,2),(585,7500332,7500320,'tio',11.111,2),(585,7500333,7500320,'ion',11.111,2),(585,7500334,7500320,'ona',11.111,2),(585,7500335,7500320,'nal',11.111,2),(585,7500336,7500327,'pen',20,1),(585,7500337,7500327,'end',20,1),(585,7500338,7500327,'ndi',20,1),(585,7500339,7500327,'din',20,1),(585,7500340,7500327,'ing',20,1),(585,7500341,7500336,'mes',20,1),(585,7500342,7500336,'ess',20,1),(585,7500343,7500336,'ssa',20,1),(585,7500344,7500336,'sag',20,1),(585,7500345,7500336,'age',20,1),(585,7500346,7500341,'wai',20,1),(585,7500347,7500341,'ait',20,1),(585,7500348,7500341,'iti',20,1),(585,7500349,7500341,'tin',20,1),(585,7500350,7500341,'ing',20,1),(585,7500351,7500346,'for',100,1),(585,7500352,7500351,'per',11.111,1),(585,7500353,7500351,'erf',11.111,1),(585,7500354,7500351,'rfo',11.111,1),(585,7500355,7500351,'for',11.111,1),(585,7500356,7500351,'orm',11.111,1),(585,7500357,7500351,'rma',11.111,1),(585,7500358,7500351,'man',11.111,1),(585,7500359,7500351,'anc',11.111,1),(585,7500360,7500351,'nce',11.111,1),(585,7500361,7500352,'ide',12.5,1),(585,7500362,7500352,'den',12.5,1),(585,7500363,7500352,'ent',12.5,1),(585,7500364,7500352,'nti',12.5,1),(585,7500365,7500352,'tif',12.5,1),(585,7500366,7500352,'ifi',12.5,1),(585,7500367,7500352,'fie',12.5,1),(585,7500368,7500352,'ier',12.5,1),(585,7500369,7500361,'vdi',33.333,3),(585,7500370,7500361,'dis',33.333,3),(585,7500371,7500361,'isk',33.333,3),(585,7500372,7500369,'nam',50,1),(585,7500373,7500369,'ame',50,1),(585,7500374,7500372,'typ',50,1),(585,7500375,7500372,'ype',50,1),(585,7500376,7500374,'dir',25,1),(585,7500377,7500374,'ire',25,1),(585,7500378,7500374,'rec',25,1),(585,7500379,7500374,'ect',25,1),(586,7500381,7500380,'naa',100,2),(586,7500382,7500381,'600',3.333,3),(586,7500383,7500381,'00a',3.333,3),(586,7500384,7500381,'0a0',3.333,3),(586,7500385,7500381,'a09',3.333,3),(586,7500386,7500381,'098',3.333,3),(586,7500387,7500381,'980',3.333,3),(586,7500388,7500381,'804',3.333,3),(586,7500389,7500381,'044',3.333,3),(586,7500390,7500381,'443',3.333,3),(586,7500391,7500381,'430',3.333,3),(586,7500392,7500381,'307',3.333,3),(586,7500393,7500381,'072',3.333,3),(586,7500394,7500381,'725',3.333,3),(586,7500395,7500381,'259',3.333,3),(586,7500396,7500381,'593',3.333,3),(586,7500397,7500381,'931',3.333,3),(586,7500398,7500381,'313',3.333,3),(586,7500399,7500381,'13f',3.333,3),(586,7500400,7500381,'3f3',3.333,3),(586,7500401,7500381,'f33',3.333,3),(586,7500402,7500381,'334',3.333,3),(586,7500403,7500381,'345',3.333,3),(586,7500404,7500381,'455',3.333,3),(586,7500405,7500381,'556',3.333,3),(586,7500406,7500381,'563',3.333,3),(586,7500407,7500381,'639',3.333,3),(586,7500408,7500381,'393',3.333,3),(586,7500409,7500381,'934',3.333,3),(586,7500410,7500381,'344',3.333,3),(586,7500411,7500381,'448',3.333,3),(586,7500412,7500382,'mon',100,1),(586,7500413,7500412,'201',50,1),(586,7500414,7500412,'013',50,1),(586,7500415,7500413,'adm',33.333,3),(586,7500416,7500413,'dmi',33.333,3),(586,7500417,7500413,'min',33.333,3),(586,7500418,7500415,'cap',16.667,1),(586,7500419,7500415,'apa',16.667,1),(586,7500420,7500415,'pac',16.667,1),(586,7500421,7500415,'aci',16.667,1),(586,7500422,7500415,'cit',16.667,1),(586,7500423,7500415,'ity',16.667,1),(586,7500424,7500418,'pat',50,1),(586,7500425,7500418,'ath',50,1),(586,7500426,7500424,'fre',14.286,1),(586,7500427,7500424,'ree',14.286,1),(586,7500428,7500424,'ees',14.286,1),(586,7500429,7500424,'esp',14.286,1),(586,7500430,7500424,'spa',14.286,1),(586,7500431,7500424,'pac',14.286,1),(586,7500432,7500424,'ace',14.286,1),(586,7500433,7500426,'dis',50,1),(586,7500434,7500426,'isk',50,1),(586,7500435,7500433,'ind',33.333,1),(586,7500436,7500433,'nde',33.333,1),(586,7500437,7500433,'dex',33.333,1),(586,7500438,7500435,'adm',8.333,1),(586,7500439,7500435,'dmi',8.333,1),(586,7500440,7500435,'min',8.333,1),(586,7500441,7500435,'ini',8.333,1),(586,7500442,7500435,'nis',8.333,1),(586,7500443,7500435,'ist',8.333,1),(586,7500444,7500435,'str',8.333,1),(586,7500445,7500435,'tra',8.333,1),(586,7500446,7500435,'rat',8.333,1),(586,7500447,7500435,'ati',8.333,1),(586,7500448,7500435,'tio',8.333,1),(586,7500449,7500435,'ion',8.333,1),(586,7500450,7500438,'sta',33.333,3),(586,7500451,7500438,'tat',33.333,3),(586,7500452,7500438,'ate',33.333,3),(586,7500453,7500450,'ena',20,2),(586,7500454,7500450,'nab',20,2),(586,7500455,7500450,'abl',20,2),(586,7500456,7500450,'ble',20,2),(586,7500457,7500450,'led',20,2),(586,7500458,7500453,'cac',33.333,2),(586,7500459,7500453,'ach',33.333,2),(586,7500460,7500453,'che',33.333,2),(586,7500461,7500458,'mod',50,1),(586,7500462,7500458,'ode',50,1),(586,7500463,7500461,'wri',14.286,1),(586,7500464,7500461,'rit',14.286,1),(586,7500465,7500461,'ite',14.286,1),(586,7500466,7500461,'tet',14.286,1),(586,7500467,7500461,'eth',14.286,1),(586,7500468,7500461,'thr',14.286,1),(586,7500469,7500461,'hru',14.286,1),(586,7500470,7500463,'ope',11.111,2),(586,7500471,7500463,'per',11.111,2),(586,7500472,7500463,'era',11.111,2),(586,7500473,7500463,'rat',11.111,2),(586,7500474,7500463,'ati',11.111,2),(586,7500475,7500463,'tio',11.111,2),(586,7500476,7500463,'ion',11.111,2),(586,7500477,7500463,'ona',11.111,2),(586,7500478,7500463,'nal',11.111,2),(586,7500479,7500470,'pen',20,1),(586,7500480,7500470,'end',20,1),(586,7500481,7500470,'ndi',20,1),(586,7500482,7500470,'din',20,1),(586,7500483,7500470,'ing',20,1),(586,7500484,7500479,'mes',20,1),(586,7500485,7500479,'ess',20,1),(586,7500486,7500479,'ssa',20,1),(586,7500487,7500479,'sag',20,1),(586,7500488,7500479,'age',20,1),(586,7500489,7500484,'wai',20,1),(586,7500490,7500484,'ait',20,1),(586,7500491,7500484,'iti',20,1),(586,7500492,7500484,'tin',20,1),(586,7500493,7500484,'ing',20,1),(586,7500494,7500489,'for',100,1),(586,7500495,7500494,'per',11.111,1),(586,7500496,7500494,'erf',11.111,1),(586,7500497,7500494,'rfo',11.111,1),(586,7500498,7500494,'for',11.111,1),(586,7500499,7500494,'orm',11.111,1),(586,7500500,7500494,'rma',11.111,1),(586,7500501,7500494,'man',11.111,1),(586,7500502,7500494,'anc',11.111,1),(586,7500503,7500494,'nce',11.111,1),(586,7500504,7500495,'ide',12.5,1),(586,7500505,7500495,'den',12.5,1),(586,7500506,7500495,'ent',12.5,1),(586,7500507,7500495,'nti',12.5,1),(586,7500508,7500495,'tif',12.5,1),(586,7500509,7500495,'ifi',12.5,1),(586,7500510,7500495,'fie',12.5,1),(586,7500511,7500495,'ier',12.5,1),(586,7500512,7500504,'vdi',33.333,3),(586,7500513,7500504,'dis',33.333,3),(586,7500514,7500504,'isk',33.333,3),(586,7500515,7500512,'nam',50,1),(586,7500516,7500512,'ame',50,1),(586,7500517,7500515,'typ',50,1),(586,7500518,7500515,'ype',50,1),(586,7500519,7500517,'dir',25,1),(586,7500520,7500517,'ire',25,1),(586,7500521,7500517,'rec',25,1),(586,7500522,7500517,'ect',25,1),(587,7500524,7500523,'naa',100,2),(587,7500525,7500524,'600',3.333,3),(587,7500526,7500524,'00a',3.333,3),(587,7500527,7500524,'0a0',3.333,3),(587,7500528,7500524,'a09',3.333,3),(587,7500529,7500524,'098',3.333,3),(587,7500530,7500524,'980',3.333,3),(587,7500531,7500524,'804',3.333,3),(587,7500532,7500524,'044',3.333,3),(587,7500533,7500524,'443',3.333,3),(587,7500534,7500524,'430',3.333,3),(587,7500535,7500524,'307',3.333,3),(587,7500536,7500524,'075',3.333,3),(587,7500537,7500524,'753',3.333,3),(587,7500538,7500524,'535',3.333,3),(587,7500539,7500524,'357',3.333,3),(587,7500540,7500524,'573',3.333,3),(587,7500541,7500524,'732',3.333,3),(587,7500542,7500524,'32b',3.333,3),(587,7500543,7500524,'2b3',3.333,3),(587,7500544,7500524,'b33',3.333,3),(587,7500545,7500524,'334',3.333,3),(587,7500546,7500524,'345',3.333,3),(587,7500547,7500524,'457',3.333,3),(587,7500548,7500524,'571',3.333,3),(587,7500549,7500524,'715',3.333,3),(587,7500550,7500524,'153',3.333,3),(587,7500551,7500524,'533',3.333,3),(587,7500552,7500524,'336',3.333,3),(587,7500553,7500524,'363',3.333,3),(587,7500554,7500524,'632',3.333,3),(587,7500555,7500525,'mon',100,1),(587,7500556,7500555,'201',50,1),(587,7500557,7500555,'013',50,1),(587,7500558,7500556,'adm',33.333,3),(587,7500559,7500556,'dmi',33.333,3),(587,7500560,7500556,'min',33.333,3),(587,7500561,7500558,'cap',16.667,1),(587,7500562,7500558,'apa',16.667,1),(587,7500563,7500558,'pac',16.667,1),(587,7500564,7500558,'aci',16.667,1),(587,7500565,7500558,'cit',16.667,1),(587,7500566,7500558,'ity',16.667,1),(587,7500567,7500561,'pat',50,1),(587,7500568,7500561,'ath',50,1),(587,7500569,7500567,'fre',14.286,1),(587,7500570,7500567,'ree',14.286,1),(587,7500571,7500567,'ees',14.286,1),(587,7500572,7500567,'esp',14.286,1),(587,7500573,7500567,'spa',14.286,1),(587,7500574,7500567,'pac',14.286,1),(587,7500575,7500567,'ace',14.286,1),(587,7500576,7500569,'dis',50,1),(587,7500577,7500569,'isk',50,1),(587,7500578,7500576,'ind',33.333,1),(587,7500579,7500576,'nde',33.333,1),(587,7500580,7500576,'dex',33.333,1),(587,7500581,7500578,'adm',8.333,1),(587,7500582,7500578,'dmi',8.333,1),(587,7500583,7500578,'min',8.333,1),(587,7500584,7500578,'ini',8.333,1),(587,7500585,7500578,'nis',8.333,1),(587,7500586,7500578,'ist',8.333,1),(587,7500587,7500578,'str',8.333,1),(587,7500588,7500578,'tra',8.333,1),(587,7500589,7500578,'rat',8.333,1),(587,7500590,7500578,'ati',8.333,1),(587,7500591,7500578,'tio',8.333,1),(587,7500592,7500578,'ion',8.333,1),(587,7500593,7500581,'sta',33.333,3),(587,7500594,7500581,'tat',33.333,3),(587,7500595,7500581,'ate',33.333,3),(587,7500596,7500593,'ena',20,2),(587,7500597,7500593,'nab',20,2),(587,7500598,7500593,'abl',20,2),(587,7500599,7500593,'ble',20,2),(587,7500600,7500593,'led',20,2),(587,7500601,7500596,'cac',33.333,2),(587,7500602,7500596,'ach',33.333,2),(587,7500603,7500596,'che',33.333,2),(587,7500604,7500601,'mod',50,1),(587,7500605,7500601,'ode',50,1),(587,7500606,7500604,'wri',14.286,1),(587,7500607,7500604,'rit',14.286,1),(587,7500608,7500604,'ite',14.286,1),(587,7500609,7500604,'tet',14.286,1),(587,7500610,7500604,'eth',14.286,1),(587,7500611,7500604,'thr',14.286,1),(587,7500612,7500604,'hru',14.286,1),(587,7500613,7500606,'ope',11.111,2),(587,7500614,7500606,'per',11.111,2),(587,7500615,7500606,'era',11.111,2),(587,7500616,7500606,'rat',11.111,2),(587,7500617,7500606,'ati',11.111,2),(587,7500618,7500606,'tio',11.111,2),(587,7500619,7500606,'ion',11.111,2),(587,7500620,7500606,'ona',11.111,2),(587,7500621,7500606,'nal',11.111,2),(587,7500622,7500613,'pen',20,1),(587,7500623,7500613,'end',20,1),(587,7500624,7500613,'ndi',20,1),(587,7500625,7500613,'din',20,1),(587,7500626,7500613,'ing',20,1),(587,7500627,7500622,'mes',20,1),(587,7500628,7500622,'ess',20,1),(587,7500629,7500622,'ssa',20,1),(587,7500630,7500622,'sag',20,1),(587,7500631,7500622,'age',20,1),(587,7500632,7500627,'wai',20,1),(587,7500633,7500627,'ait',20,1),(587,7500634,7500627,'iti',20,1),(587,7500635,7500627,'tin',20,1),(587,7500636,7500627,'ing',20,1),(587,7500637,7500632,'for',100,1),(587,7500638,7500637,'per',11.111,1),(587,7500639,7500637,'erf',11.111,1),(587,7500640,7500637,'rfo',11.111,1),(587,7500641,7500637,'for',11.111,1),(587,7500642,7500637,'orm',11.111,1),(587,7500643,7500637,'rma',11.111,1),(587,7500644,7500637,'man',11.111,1),(587,7500645,7500637,'anc',11.111,1),(587,7500646,7500637,'nce',11.111,1),(587,7500647,7500638,'ide',12.5,1),(587,7500648,7500638,'den',12.5,1),(587,7500649,7500638,'ent',12.5,1),(587,7500650,7500638,'nti',12.5,1),(587,7500651,7500638,'tif',12.5,1),(587,7500652,7500638,'ifi',12.5,1),(587,7500653,7500638,'fie',12.5,1),(587,7500654,7500638,'ier',12.5,1),(587,7500655,7500647,'vdi',33.333,3),(587,7500656,7500647,'dis',33.333,3),(587,7500657,7500647,'isk',33.333,3),(587,7500658,7500655,'nam',50,1),(587,7500659,7500655,'ame',50,1),(587,7500660,7500658,'typ',50,1),(587,7500661,7500658,'ype',50,1),(587,7500662,7500660,'dir',25,1),(587,7500663,7500660,'ire',25,1),(587,7500664,7500660,'rec',25,1),(587,7500665,7500660,'ect',25,1),(588,7500667,7500666,'naa',100,2),(588,7500668,7500667,'600',3.333,3),(588,7500669,7500667,'00a',3.333,3),(588,7500670,7500667,'0a0',3.333,3),(588,7500671,7500667,'a09',3.333,3),(588,7500672,7500667,'098',3.333,3),(588,7500673,7500667,'980',3.333,3),(588,7500674,7500667,'804',3.333,3),(588,7500675,7500667,'044',3.333,3),(588,7500676,7500667,'443',3.333,3),(588,7500677,7500667,'430',3.333,3),(588,7500678,7500667,'307',3.333,3),(588,7500679,7500667,'075',3.333,3),(588,7500680,7500667,'753',3.333,3),(588,7500681,7500667,'535',3.333,3),(588,7500682,7500667,'357',3.333,3),(588,7500683,7500667,'573',3.333,3),(588,7500684,7500667,'732',3.333,3),(588,7500685,7500667,'32b',3.333,3),(588,7500686,7500667,'2b3',3.333,3),(588,7500687,7500667,'b33',3.333,3),(588,7500688,7500667,'334',3.333,3),(588,7500689,7500667,'345',3.333,3),(588,7500690,7500667,'457',3.333,3),(588,7500691,7500667,'571',3.333,3),(588,7500692,7500667,'715',3.333,3),(588,7500693,7500667,'153',3.333,3),(588,7500694,7500667,'533',3.333,3),(588,7500695,7500667,'336',3.333,3),(588,7500696,7500667,'363',3.333,3),(588,7500697,7500667,'633',3.333,3),(588,7500698,7500668,'mon',100,1),(588,7500699,7500698,'201',50,1),(588,7500700,7500698,'013',50,1),(588,7500701,7500699,'adm',33.333,3),(588,7500702,7500699,'dmi',33.333,3),(588,7500703,7500699,'min',33.333,3),(588,7500704,7500701,'cap',16.667,1),(588,7500705,7500701,'apa',16.667,1),(588,7500706,7500701,'pac',16.667,1),(588,7500707,7500701,'aci',16.667,1),(588,7500708,7500701,'cit',16.667,1),(588,7500709,7500701,'ity',16.667,1),(588,7500710,7500704,'pat',50,1),(588,7500711,7500704,'ath',50,1),(588,7500712,7500710,'fre',14.286,1),(588,7500713,7500710,'ree',14.286,1),(588,7500714,7500710,'ees',14.286,1),(588,7500715,7500710,'esp',14.286,1),(588,7500716,7500710,'spa',14.286,1),(588,7500717,7500710,'pac',14.286,1),(588,7500718,7500710,'ace',14.286,1),(588,7500719,7500712,'dis',50,1),(588,7500720,7500712,'isk',50,1),(588,7500721,7500719,'ind',33.333,1),(588,7500722,7500719,'nde',33.333,1),(588,7500723,7500719,'dex',33.333,1),(588,7500724,7500721,'adm',8.333,1),(588,7500725,7500721,'dmi',8.333,1),(588,7500726,7500721,'min',8.333,1),(588,7500727,7500721,'ini',8.333,1),(588,7500728,7500721,'nis',8.333,1),(588,7500729,7500721,'ist',8.333,1),(588,7500730,7500721,'str',8.333,1),(588,7500731,7500721,'tra',8.333,1),(588,7500732,7500721,'rat',8.333,1),(588,7500733,7500721,'ati',8.333,1),(588,7500734,7500721,'tio',8.333,1),(588,7500735,7500721,'ion',8.333,1),(588,7500736,7500724,'sta',33.333,3),(588,7500737,7500724,'tat',33.333,3),(588,7500738,7500724,'ate',33.333,3),(588,7500739,7500736,'ena',20,2),(588,7500740,7500736,'nab',20,2),(588,7500741,7500736,'abl',20,2),(588,7500742,7500736,'ble',20,2),(588,7500743,7500736,'led',20,2),(588,7500744,7500739,'cac',33.333,2),(588,7500745,7500739,'ach',33.333,2),(588,7500746,7500739,'che',33.333,2),(588,7500747,7500744,'mod',50,1),(588,7500748,7500744,'ode',50,1),(588,7500749,7500747,'wri',14.286,1),(588,7500750,7500747,'rit',14.286,1),(588,7500751,7500747,'ite',14.286,1),(588,7500752,7500747,'tet',14.286,1),(588,7500753,7500747,'eth',14.286,1),(588,7500754,7500747,'thr',14.286,1),(588,7500755,7500747,'hru',14.286,1),(588,7500756,7500749,'ope',11.111,2),(588,7500757,7500749,'per',11.111,2),(588,7500758,7500749,'era',11.111,2),(588,7500759,7500749,'rat',11.111,2),(588,7500760,7500749,'ati',11.111,2),(588,7500761,7500749,'tio',11.111,2),(588,7500762,7500749,'ion',11.111,2),(588,7500763,7500749,'ona',11.111,2),(588,7500764,7500749,'nal',11.111,2),(588,7500765,7500756,'pen',20,1),(588,7500766,7500756,'end',20,1),(588,7500767,7500756,'ndi',20,1),(588,7500768,7500756,'din',20,1),(588,7500769,7500756,'ing',20,1),(588,7500770,7500765,'mes',20,1),(588,7500771,7500765,'ess',20,1),(588,7500772,7500765,'ssa',20,1),(588,7500773,7500765,'sag',20,1),(588,7500774,7500765,'age',20,1),(588,7500775,7500770,'wai',20,1),(588,7500776,7500770,'ait',20,1),(588,7500777,7500770,'iti',20,1),(588,7500778,7500770,'tin',20,1),(588,7500779,7500770,'ing',20,1),(588,7500780,7500775,'for',100,1),(588,7500781,7500780,'per',11.111,1),(588,7500782,7500780,'erf',11.111,1),(588,7500783,7500780,'rfo',11.111,1),(588,7500784,7500780,'for',11.111,1),(588,7500785,7500780,'orm',11.111,1),(588,7500786,7500780,'rma',11.111,1),(588,7500787,7500780,'man',11.111,1),(588,7500788,7500780,'anc',11.111,1),(588,7500789,7500780,'nce',11.111,1),(588,7500790,7500781,'ide',12.5,1),(588,7500791,7500781,'den',12.5,1),(588,7500792,7500781,'ent',12.5,1),(588,7500793,7500781,'nti',12.5,1),(588,7500794,7500781,'tif',12.5,1),(588,7500795,7500781,'ifi',12.5,1),(588,7500796,7500781,'fie',12.5,1),(588,7500797,7500781,'ier',12.5,1),(588,7500798,7500790,'vdi',33.333,3),(588,7500799,7500790,'dis',33.333,3),(588,7500800,7500790,'isk',33.333,3),(588,7500801,7500798,'nam',50,1),(588,7500802,7500798,'ame',50,1),(588,7500803,7500801,'typ',50,1),(588,7500804,7500801,'ype',50,1),(588,7500805,7500803,'dir',25,1),(588,7500806,7500803,'ire',25,1),(588,7500807,7500803,'rec',25,1),(588,7500808,7500803,'ect',25,1),(589,7500810,7500809,'naa',100,2),(589,7500811,7500810,'600',3.333,3),(589,7500812,7500810,'000',3.333,3),(589,7500813,7500810,'00c',3.333,3),(589,7500814,7500810,'0c2',3.333,3),(589,7500815,7500810,'c29',3.333,3),(589,7500816,7500810,'292',3.333,3),(589,7500817,7500810,'92e',3.333,3),(589,7500818,7500810,'2e0',3.333,3),(589,7500819,7500810,'e0c',3.333,3),(589,7500820,7500810,'0c8',3.333,3),(589,7500821,7500810,'c82',3.333,3),(589,7500822,7500810,'82d',3.333,3),(589,7500823,7500810,'2da',3.333,3),(589,7500824,7500810,'da5',3.333,3),(589,7500825,7500810,'a59',3.333,3),(589,7500826,7500810,'59d',3.333,3),(589,7500827,7500810,'9d9',3.333,3),(589,7500828,7500810,'d94',3.333,3),(589,7500829,7500810,'94c',3.333,3),(589,7500830,7500810,'4c8',3.333,3),(589,7500831,7500810,'c8f',3.333,3),(589,7500832,7500810,'8f6',3.333,3),(589,7500833,7500810,'f6e',3.333,3),(589,7500834,7500810,'6ec',3.333,3),(589,7500835,7500810,'ec8',3.333,3),(589,7500836,7500810,'c88',3.333,3),(589,7500837,7500810,'886',3.333,3),(589,7500838,7500810,'86f',3.333,3),(589,7500839,7500810,'6fe',3.333,3),(589,7500840,7500810,'fe2',3.333,3),(589,7500841,7500811,'mon',100,1),(589,7500842,7500841,'201',50,1),(589,7500843,7500841,'013',50,1),(589,7500844,7500842,'adm',33.333,3),(589,7500845,7500842,'dmi',33.333,3),(589,7500846,7500842,'min',33.333,3),(589,7500847,7500844,'cap',16.667,1),(589,7500848,7500844,'apa',16.667,1),(589,7500849,7500844,'pac',16.667,1),(589,7500850,7500844,'aci',16.667,1),(589,7500851,7500844,'cit',16.667,1),(589,7500852,7500844,'ity',16.667,1),(589,7500853,7500847,'pat',50,1),(589,7500854,7500847,'ath',50,1),(589,7500855,7500853,'fre',14.286,1),(589,7500856,7500853,'ree',14.286,1),(589,7500857,7500853,'ees',14.286,1),(589,7500858,7500853,'esp',14.286,1),(589,7500859,7500853,'spa',14.286,1),(589,7500860,7500853,'pac',14.286,1),(589,7500861,7500853,'ace',14.286,1),(589,7500862,7500855,'dis',50,1),(589,7500863,7500855,'isk',50,1),(589,7500864,7500862,'ind',33.333,1),(589,7500865,7500862,'nde',33.333,1),(589,7500866,7500862,'dex',33.333,1),(589,7500867,7500864,'adm',8.333,1),(589,7500868,7500864,'dmi',8.333,1),(589,7500869,7500864,'min',8.333,1),(589,7500870,7500864,'ini',8.333,1),(589,7500871,7500864,'nis',8.333,1),(589,7500872,7500864,'ist',8.333,1),(589,7500873,7500864,'str',8.333,1),(589,7500874,7500864,'tra',8.333,1),(589,7500875,7500864,'rat',8.333,1),(589,7500876,7500864,'ati',8.333,1),(589,7500877,7500864,'tio',8.333,1),(589,7500878,7500864,'ion',8.333,1),(589,7500879,7500867,'sta',33.333,3),(589,7500880,7500867,'tat',33.333,3),(589,7500881,7500867,'ate',33.333,3),(589,7500882,7500879,'ena',20,2),(589,7500883,7500879,'nab',20,2),(589,7500884,7500879,'abl',20,2),(589,7500885,7500879,'ble',20,2),(589,7500886,7500879,'led',20,2),(589,7500887,7500882,'cac',33.333,2),(589,7500888,7500882,'ach',33.333,2),(589,7500889,7500882,'che',33.333,2),(589,7500890,7500887,'mod',50,1),(589,7500891,7500887,'ode',50,1),(589,7500892,7500890,'wri',14.286,1),(589,7500893,7500890,'rit',14.286,1),(589,7500894,7500890,'ite',14.286,1),(589,7500895,7500890,'tet',14.286,1),(589,7500896,7500890,'eth',14.286,1),(589,7500897,7500890,'thr',14.286,1),(589,7500898,7500890,'hru',14.286,1),(589,7500899,7500892,'ope',11.111,2),(589,7500900,7500892,'per',11.111,2),(589,7500901,7500892,'era',11.111,2),(589,7500902,7500892,'rat',11.111,2),(589,7500903,7500892,'ati',11.111,2),(589,7500904,7500892,'tio',11.111,2),(589,7500905,7500892,'ion',11.111,2),(589,7500906,7500892,'ona',11.111,2),(589,7500907,7500892,'nal',11.111,2),(589,7500908,7500899,'pen',20,1),(589,7500909,7500899,'end',20,1),(589,7500910,7500899,'ndi',20,1),(589,7500911,7500899,'din',20,1),(589,7500912,7500899,'ing',20,1),(589,7500913,7500908,'mes',20,1),(589,7500914,7500908,'ess',20,1),(589,7500915,7500908,'ssa',20,1),(589,7500916,7500908,'sag',20,1),(589,7500917,7500908,'age',20,1),(589,7500918,7500913,'wai',20,1),(589,7500919,7500913,'ait',20,1),(589,7500920,7500913,'iti',20,1),(589,7500921,7500913,'tin',20,1),(589,7500922,7500913,'ing',20,1),(589,7500923,7500918,'for',100,1),(589,7500924,7500923,'per',11.111,1),(589,7500925,7500923,'erf',11.111,1),(589,7500926,7500923,'rfo',11.111,1),(589,7500927,7500923,'for',11.111,1),(589,7500928,7500923,'orm',11.111,1),(589,7500929,7500923,'rma',11.111,1),(589,7500930,7500923,'man',11.111,1),(589,7500931,7500923,'anc',11.111,1),(589,7500932,7500923,'nce',11.111,1),(589,7500933,7500924,'ide',12.5,1),(589,7500934,7500924,'den',12.5,1),(589,7500935,7500924,'ent',12.5,1),(589,7500936,7500924,'nti',12.5,1),(589,7500937,7500924,'tif',12.5,1),(589,7500938,7500924,'ifi',12.5,1),(589,7500939,7500924,'fie',12.5,1),(589,7500940,7500924,'ier',12.5,1),(589,7500941,7500933,'vdi',33.333,3),(589,7500942,7500933,'dis',33.333,3),(589,7500943,7500933,'isk',33.333,3),(589,7500944,7500941,'nam',50,1),(589,7500945,7500941,'ame',50,1),(589,7500946,7500944,'typ',50,1),(589,7500947,7500944,'ype',50,1),(589,7500948,7500946,'dir',25,1),(589,7500949,7500946,'ire',25,1),(589,7500950,7500946,'rec',25,1),(589,7500951,7500946,'ect',25,1),(590,7500953,7500952,'naa',100,2),(590,7500954,7500953,'600',3.333,3),(590,7500955,7500953,'000',3.333,3),(590,7500956,7500953,'00c',3.333,3),(590,7500957,7500953,'0c2',3.333,3),(590,7500958,7500953,'c29',3.333,3),(590,7500959,7500953,'297',3.333,3),(590,7500960,7500953,'97b',3.333,3),(590,7500961,7500953,'7bc',3.333,3),(590,7500962,7500953,'bce',3.333,3),(590,7500963,7500953,'ce6',3.333,3),(590,7500964,7500953,'e62',3.333,3),(590,7500965,7500953,'62b',3.333,3),(590,7500966,7500953,'2b3',3.333,3),(590,7500967,7500953,'b31',3.333,3),(590,7500968,7500953,'315',3.333,3),(590,7500969,7500953,'15a',3.333,3),(590,7500970,7500953,'5a5',3.333,3),(590,7500971,7500953,'a50',3.333,3),(590,7500972,7500953,'50c',3.333,3),(590,7500973,7500953,'0c4',3.333,3),(590,7500974,7500953,'c40',3.333,3),(590,7500975,7500953,'40d',3.333,3),(590,7500976,7500953,'0df',3.333,3),(590,7500977,7500953,'df1',3.333,3),(590,7500978,7500953,'f13',3.333,3),(590,7500979,7500953,'13c',3.333,3),(590,7500980,7500953,'3c2',3.333,3),(590,7500981,7500953,'c2d',3.333,3),(590,7500982,7500953,'2dd',3.333,3),(590,7500983,7500953,'dd6',3.333,3),(590,7500984,7500954,'mon',100,1),(590,7500985,7500984,'201',50,1),(590,7500986,7500984,'013',50,1),(590,7500987,7500985,'adm',33.333,3),(590,7500988,7500985,'dmi',33.333,3),(590,7500989,7500985,'min',33.333,3),(590,7500990,7500987,'cap',16.667,1),(590,7500991,7500987,'apa',16.667,1),(590,7500992,7500987,'pac',16.667,1),(590,7500993,7500987,'aci',16.667,1),(590,7500994,7500987,'cit',16.667,1),(590,7500995,7500987,'ity',16.667,1),(590,7500996,7500990,'pat',50,1),(590,7500997,7500990,'ath',50,1),(590,7500998,7500996,'fre',14.286,1),(590,7500999,7500996,'ree',14.286,1),(590,7501000,7500996,'ees',14.286,1),(590,7501001,7500996,'esp',14.286,1),(590,7501002,7500996,'spa',14.286,1),(590,7501003,7500996,'pac',14.286,1),(590,7501004,7500996,'ace',14.286,1),(590,7501005,7500998,'dis',50,1),(590,7501006,7500998,'isk',50,1),(590,7501007,7501005,'ind',33.333,1),(590,7501008,7501005,'nde',33.333,1),(590,7501009,7501005,'dex',33.333,1),(590,7501010,7501007,'adm',8.333,1),(590,7501011,7501007,'dmi',8.333,1),(590,7501012,7501007,'min',8.333,1),(590,7501013,7501007,'ini',8.333,1),(590,7501014,7501007,'nis',8.333,1),(590,7501015,7501007,'ist',8.333,1),(590,7501016,7501007,'str',8.333,1),(590,7501017,7501007,'tra',8.333,1),(590,7501018,7501007,'rat',8.333,1),(590,7501019,7501007,'ati',8.333,1),(590,7501020,7501007,'tio',8.333,1),(590,7501021,7501007,'ion',8.333,1),(590,7501022,7501010,'sta',33.333,3),(590,7501023,7501010,'tat',33.333,3),(590,7501024,7501010,'ate',33.333,3),(590,7501025,7501022,'ena',20,2),(590,7501026,7501022,'nab',20,2),(590,7501027,7501022,'abl',20,2),(590,7501028,7501022,'ble',20,2),(590,7501029,7501022,'led',20,2),(590,7501030,7501025,'cac',33.333,2),(590,7501031,7501025,'ach',33.333,2),(590,7501032,7501025,'che',33.333,2),(590,7501033,7501030,'mod',50,1),(590,7501034,7501030,'ode',50,1),(590,7501035,7501033,'wri',14.286,1),(590,7501036,7501033,'rit',14.286,1),(590,7501037,7501033,'ite',14.286,1),(590,7501038,7501033,'tet',14.286,1),(590,7501039,7501033,'eth',14.286,1),(590,7501040,7501033,'thr',14.286,1),(590,7501041,7501033,'hru',14.286,1),(590,7501042,7501035,'ope',11.111,2),(590,7501043,7501035,'per',11.111,2),(590,7501044,7501035,'era',11.111,2),(590,7501045,7501035,'rat',11.111,2),(590,7501046,7501035,'ati',11.111,2),(590,7501047,7501035,'tio',11.111,2),(590,7501048,7501035,'ion',11.111,2),(590,7501049,7501035,'ona',11.111,2),(590,7501050,7501035,'nal',11.111,2),(590,7501051,7501042,'pen',20,1),(590,7501052,7501042,'end',20,1),(590,7501053,7501042,'ndi',20,1),(590,7501054,7501042,'din',20,1),(590,7501055,7501042,'ing',20,1),(590,7501056,7501051,'mes',20,1),(590,7501057,7501051,'ess',20,1),(590,7501058,7501051,'ssa',20,1),(590,7501059,7501051,'sag',20,1),(590,7501060,7501051,'age',20,1),(590,7501061,7501056,'wai',20,1),(590,7501062,7501056,'ait',20,1),(590,7501063,7501056,'iti',20,1),(590,7501064,7501056,'tin',20,1),(590,7501065,7501056,'ing',20,1),(590,7501066,7501061,'for',100,1),(590,7501067,7501066,'per',11.111,1),(590,7501068,7501066,'erf',11.111,1),(590,7501069,7501066,'rfo',11.111,1),(590,7501070,7501066,'for',11.111,1),(590,7501071,7501066,'orm',11.111,1),(590,7501072,7501066,'rma',11.111,1),(590,7501073,7501066,'man',11.111,1),(590,7501074,7501066,'anc',11.111,1),(590,7501075,7501066,'nce',11.111,1),(590,7501076,7501067,'ide',12.5,1),(590,7501077,7501067,'den',12.5,1),(590,7501078,7501067,'ent',12.5,1),(590,7501079,7501067,'nti',12.5,1),(590,7501080,7501067,'tif',12.5,1),(590,7501081,7501067,'ifi',12.5,1),(590,7501082,7501067,'fie',12.5,1),(590,7501083,7501067,'ier',12.5,1),(590,7501084,7501076,'vdi',33.333,3),(590,7501085,7501076,'dis',33.333,3),(590,7501086,7501076,'isk',33.333,3),(590,7501087,7501084,'nam',50,1),(590,7501088,7501084,'ame',50,1),(590,7501089,7501087,'typ',50,1),(590,7501090,7501087,'ype',50,1),(590,7501091,7501089,'dir',25,1),(590,7501092,7501089,'ire',25,1),(590,7501093,7501089,'rec',25,1),(590,7501094,7501089,'ect',25,1),(591,7501096,7501095,'naa',100,2),(591,7501097,7501096,'600',3.333,3),(591,7501098,7501096,'000',3.333,3),(591,7501099,7501096,'00c',3.333,3),(591,7501100,7501096,'0c2',3.333,3),(591,7501101,7501096,'c29',3.333,3),(591,7501102,7501096,'298',3.333,3),(591,7501103,7501096,'985',3.333,3),(591,7501104,7501096,'85b',3.333,3),(591,7501105,7501096,'5bf',3.333,3),(591,7501106,7501096,'bfc',3.333,3),(591,7501107,7501096,'fcf',3.333,3),(591,7501108,7501096,'cf5',3.333,3),(591,7501109,7501096,'f5e',3.333,3),(591,7501110,7501096,'5ee',3.333,3),(591,7501111,7501096,'ee2',3.333,3),(591,7501112,7501096,'e2f',3.333,3),(591,7501113,7501096,'2f6',3.333,3),(591,7501114,7501096,'f63',3.333,3),(591,7501115,7501096,'634',3.333,3),(591,7501116,7501096,'34c',3.333,3),(591,7501117,7501096,'4c9',3.333,3),(591,7501118,7501096,'c9b',3.333,3),(591,7501119,7501096,'9ba',3.333,3),(591,7501120,7501096,'bae',3.333,3),(591,7501121,7501096,'ae5',3.333,3),(591,7501122,7501096,'e55',3.333,3),(591,7501123,7501096,'55d',3.333,3),(591,7501124,7501096,'5dd',3.333,3),(591,7501125,7501096,'ddc',3.333,3),(591,7501126,7501096,'dc5',3.333,3),(591,7501127,7501097,'mon',100,1),(591,7501128,7501127,'201',50,1),(591,7501129,7501127,'013',50,1),(591,7501130,7501128,'adm',33.333,3),(591,7501131,7501128,'dmi',33.333,3),(591,7501132,7501128,'min',33.333,3),(591,7501133,7501130,'cap',16.667,1),(591,7501134,7501130,'apa',16.667,1),(591,7501135,7501130,'pac',16.667,1),(591,7501136,7501130,'aci',16.667,1),(591,7501137,7501130,'cit',16.667,1),(591,7501138,7501130,'ity',16.667,1),(591,7501139,7501133,'pat',50,1),(591,7501140,7501133,'ath',50,1),(591,7501141,7501139,'fre',14.286,1),(591,7501142,7501139,'ree',14.286,1),(591,7501143,7501139,'ees',14.286,1),(591,7501144,7501139,'esp',14.286,1),(591,7501145,7501139,'spa',14.286,1),(591,7501146,7501139,'pac',14.286,1),(591,7501147,7501139,'ace',14.286,1),(591,7501148,7501141,'dis',50,1),(591,7501149,7501141,'isk',50,1),(591,7501150,7501148,'ind',33.333,1),(591,7501151,7501148,'nde',33.333,1),(591,7501152,7501148,'dex',33.333,1),(591,7501153,7501150,'adm',8.333,1),(591,7501154,7501150,'dmi',8.333,1),(591,7501155,7501150,'min',8.333,1),(591,7501156,7501150,'ini',8.333,1),(591,7501157,7501150,'nis',8.333,1),(591,7501158,7501150,'ist',8.333,1),(591,7501159,7501150,'str',8.333,1),(591,7501160,7501150,'tra',8.333,1),(591,7501161,7501150,'rat',8.333,1),(591,7501162,7501150,'ati',8.333,1),(591,7501163,7501150,'tio',8.333,1),(591,7501164,7501150,'ion',8.333,1),(591,7501165,7501153,'sta',33.333,3),(591,7501166,7501153,'tat',33.333,3),(591,7501167,7501153,'ate',33.333,3),(591,7501168,7501165,'ena',20,2),(591,7501169,7501165,'nab',20,2),(591,7501170,7501165,'abl',20,2),(591,7501171,7501165,'ble',20,2),(591,7501172,7501165,'led',20,2),(591,7501173,7501168,'cac',33.333,2),(591,7501174,7501168,'ach',33.333,2),(591,7501175,7501168,'che',33.333,2),(591,7501176,7501173,'mod',50,1),(591,7501177,7501173,'ode',50,1),(591,7501178,7501176,'wri',14.286,1),(591,7501179,7501176,'rit',14.286,1),(591,7501180,7501176,'ite',14.286,1),(591,7501181,7501176,'tet',14.286,1),(591,7501182,7501176,'eth',14.286,1),(591,7501183,7501176,'thr',14.286,1),(591,7501184,7501176,'hru',14.286,1),(591,7501185,7501178,'ope',11.111,2),(591,7501186,7501178,'per',11.111,2),(591,7501187,7501178,'era',11.111,2),(591,7501188,7501178,'rat',11.111,2),(591,7501189,7501178,'ati',11.111,2),(591,7501190,7501178,'tio',11.111,2),(591,7501191,7501178,'ion',11.111,2),(591,7501192,7501178,'ona',11.111,2),(591,7501193,7501178,'nal',11.111,2),(591,7501194,7501185,'pen',20,1),(591,7501195,7501185,'end',20,1),(591,7501196,7501185,'ndi',20,1),(591,7501197,7501185,'din',20,1),(591,7501198,7501185,'ing',20,1),(591,7501199,7501194,'mes',20,1),(591,7501200,7501194,'ess',20,1),(591,7501201,7501194,'ssa',20,1),(591,7501202,7501194,'sag',20,1),(591,7501203,7501194,'age',20,1),(591,7501204,7501199,'wai',20,1),(591,7501205,7501199,'ait',20,1),(591,7501206,7501199,'iti',20,1),(591,7501207,7501199,'tin',20,1),(591,7501208,7501199,'ing',20,1),(591,7501209,7501204,'for',100,1),(591,7501210,7501209,'per',11.111,1),(591,7501211,7501209,'erf',11.111,1),(591,7501212,7501209,'rfo',11.111,1),(591,7501213,7501209,'for',11.111,1),(591,7501214,7501209,'orm',11.111,1),(591,7501215,7501209,'rma',11.111,1),(591,7501216,7501209,'man',11.111,1),(591,7501217,7501209,'anc',11.111,1),(591,7501218,7501209,'nce',11.111,1),(591,7501219,7501210,'ide',12.5,1),(591,7501220,7501210,'den',12.5,1),(591,7501221,7501210,'ent',12.5,1),(591,7501222,7501210,'nti',12.5,1),(591,7501223,7501210,'tif',12.5,1),(591,7501224,7501210,'ifi',12.5,1),(591,7501225,7501210,'fie',12.5,1),(591,7501226,7501210,'ier',12.5,1),(591,7501227,7501219,'vdi',33.333,3),(591,7501228,7501219,'dis',33.333,3),(591,7501229,7501219,'isk',33.333,3),(591,7501230,7501227,'nam',50,1),(591,7501231,7501227,'ame',50,1),(591,7501232,7501230,'typ',50,1),(591,7501233,7501230,'ype',50,1),(591,7501234,7501232,'dir',25,1),(591,7501235,7501232,'ire',25,1),(591,7501236,7501232,'rec',25,1),(591,7501237,7501232,'ect',25,1),(592,7501239,7501238,'naa',100,2),(592,7501240,7501239,'600',3.333,3),(592,7501241,7501239,'000',3.333,3),(592,7501242,7501239,'00c',3.333,3),(592,7501243,7501239,'0c2',3.333,3),(592,7501244,7501239,'c29',3.333,3),(592,7501245,7501239,'295',3.333,3),(592,7501246,7501239,'953',3.333,3),(592,7501247,7501239,'539',3.333,3),(592,7501248,7501239,'39e',3.333,3),(592,7501249,7501239,'9e3',3.333,3),(592,7501250,7501239,'e34',3.333,3),(592,7501251,7501239,'341',3.333,3),(592,7501252,7501239,'41c',3.333,3),(592,7501253,7501239,'1cf',3.333,3),(592,7501254,7501239,'cf0',3.333,3),(592,7501255,7501239,'f08',3.333,3),(592,7501256,7501239,'088',3.333,3),(592,7501257,7501239,'88e',3.333,3),(592,7501258,7501239,'8ec',3.333,3),(592,7501259,7501239,'ec7',3.333,3),(592,7501260,7501239,'c7e',3.333,3),(592,7501261,7501239,'7e2',3.333,3),(592,7501262,7501239,'e27',3.333,3),(592,7501263,7501239,'27d',3.333,3),(592,7501264,7501239,'7dd',3.333,3),(592,7501265,7501239,'ddc',3.333,3),(592,7501266,7501239,'dc3',3.333,3),(592,7501267,7501239,'c37',3.333,3),(592,7501268,7501239,'371',3.333,3),(592,7501269,7501239,'719',3.333,3),(592,7501270,7501240,'mon',100,1),(592,7501271,7501270,'201',50,1),(592,7501272,7501270,'013',50,1),(592,7501273,7501271,'adm',33.333,3),(592,7501274,7501271,'dmi',33.333,3),(592,7501275,7501271,'min',33.333,3),(592,7501276,7501273,'cap',16.667,1),(592,7501277,7501273,'apa',16.667,1),(592,7501278,7501273,'pac',16.667,1),(592,7501279,7501273,'aci',16.667,1),(592,7501280,7501273,'cit',16.667,1),(592,7501281,7501273,'ity',16.667,1),(592,7501282,7501276,'pat',50,1),(592,7501283,7501276,'ath',50,1),(592,7501284,7501282,'fre',14.286,1),(592,7501285,7501282,'ree',14.286,1),(592,7501286,7501282,'ees',14.286,1),(592,7501287,7501282,'esp',14.286,1),(592,7501288,7501282,'spa',14.286,1),(592,7501289,7501282,'pac',14.286,1),(592,7501290,7501282,'ace',14.286,1),(592,7501291,7501284,'dis',50,1),(592,7501292,7501284,'isk',50,1),(592,7501293,7501291,'ind',33.333,1),(592,7501294,7501291,'nde',33.333,1),(592,7501295,7501291,'dex',33.333,1),(592,7501296,7501293,'adm',8.333,1),(592,7501297,7501293,'dmi',8.333,1),(592,7501298,7501293,'min',8.333,1),(592,7501299,7501293,'ini',8.333,1),(592,7501300,7501293,'nis',8.333,1),(592,7501301,7501293,'ist',8.333,1),(592,7501302,7501293,'str',8.333,1),(592,7501303,7501293,'tra',8.333,1),(592,7501304,7501293,'rat',8.333,1),(592,7501305,7501293,'ati',8.333,1),(592,7501306,7501293,'tio',8.333,1),(592,7501307,7501293,'ion',8.333,1),(592,7501308,7501296,'sta',33.333,3),(592,7501309,7501296,'tat',33.333,3),(592,7501310,7501296,'ate',33.333,3),(592,7501311,7501308,'ena',20,2),(592,7501312,7501308,'nab',20,2),(592,7501313,7501308,'abl',20,2),(592,7501314,7501308,'ble',20,2),(592,7501315,7501308,'led',20,2),(592,7501316,7501311,'cac',33.333,2),(592,7501317,7501311,'ach',33.333,2),(592,7501318,7501311,'che',33.333,2),(592,7501319,7501316,'mod',50,1),(592,7501320,7501316,'ode',50,1),(592,7501321,7501319,'wri',14.286,1),(592,7501322,7501319,'rit',14.286,1),(592,7501323,7501319,'ite',14.286,1),(592,7501324,7501319,'tet',14.286,1),(592,7501325,7501319,'eth',14.286,1),(592,7501326,7501319,'thr',14.286,1),(592,7501327,7501319,'hru',14.286,1),(592,7501328,7501321,'ope',11.111,2),(592,7501329,7501321,'per',11.111,2),(592,7501330,7501321,'era',11.111,2),(592,7501331,7501321,'rat',11.111,2),(592,7501332,7501321,'ati',11.111,2),(592,7501333,7501321,'tio',11.111,2),(592,7501334,7501321,'ion',11.111,2),(592,7501335,7501321,'ona',11.111,2),(592,7501336,7501321,'nal',11.111,2),(592,7501337,7501328,'pen',20,1),(592,7501338,7501328,'end',20,1),(592,7501339,7501328,'ndi',20,1),(592,7501340,7501328,'din',20,1),(592,7501341,7501328,'ing',20,1),(592,7501342,7501337,'mes',20,1),(592,7501343,7501337,'ess',20,1),(592,7501344,7501337,'ssa',20,1),(592,7501345,7501337,'sag',20,1),(592,7501346,7501337,'age',20,1),(592,7501347,7501342,'wai',20,1),(592,7501348,7501342,'ait',20,1),(592,7501349,7501342,'iti',20,1),(592,7501350,7501342,'tin',20,1),(592,7501351,7501342,'ing',20,1),(592,7501352,7501347,'for',100,1),(592,7501353,7501352,'per',11.111,1),(592,7501354,7501352,'erf',11.111,1),(592,7501355,7501352,'rfo',11.111,1),(592,7501356,7501352,'for',11.111,1),(592,7501357,7501352,'orm',11.111,1),(592,7501358,7501352,'rma',11.111,1),(592,7501359,7501352,'man',11.111,1),(592,7501360,7501352,'anc',11.111,1),(592,7501361,7501352,'nce',11.111,1),(592,7501362,7501353,'ide',12.5,1),(592,7501363,7501353,'den',12.5,1),(592,7501364,7501353,'ent',12.5,1),(592,7501365,7501353,'nti',12.5,1),(592,7501366,7501353,'tif',12.5,1),(592,7501367,7501353,'ifi',12.5,1),(592,7501368,7501353,'fie',12.5,1),(592,7501369,7501353,'ier',12.5,1),(592,7501370,7501362,'vdi',33.333,3),(592,7501371,7501362,'dis',33.333,3),(592,7501372,7501362,'isk',33.333,3),(592,7501373,7501370,'nam',50,1),(592,7501374,7501370,'ame',50,1),(592,7501375,7501373,'typ',50,1),(592,7501376,7501373,'ype',50,1),(592,7501377,7501375,'dir',25,1),(592,7501378,7501375,'ire',25,1),(592,7501379,7501375,'rec',25,1),(592,7501380,7501375,'ect',25,1),(593,7501382,7501381,'naa',100,2),(593,7501383,7501382,'600',3.333,3),(593,7501384,7501382,'000',3.333,3),(593,7501385,7501382,'00c',3.333,3),(593,7501386,7501382,'0c2',3.333,3),(593,7501387,7501382,'c29',3.333,3),(593,7501388,7501382,'29f',3.333,3),(593,7501389,7501382,'9fa',3.333,3),(593,7501390,7501382,'fad',3.333,3),(593,7501391,7501382,'ad6',3.333,3),(593,7501392,7501382,'d65',3.333,3),(593,7501393,7501382,'652',3.333,3),(593,7501394,7501382,'526',3.333,3),(593,7501395,7501382,'26e',3.333,3),(593,7501396,7501382,'6e1',3.333,3),(593,7501397,7501382,'e16',3.333,3),(593,7501398,7501382,'164',3.333,3),(593,7501399,7501382,'641',3.333,3),(593,7501400,7501382,'41f',3.333,3),(593,7501401,7501382,'1f7',3.333,3),(593,7501402,7501382,'f7d',3.333,3),(593,7501403,7501382,'7d2',3.333,3),(593,7501404,7501382,'d24',3.333,3),(593,7501405,7501382,'243',3.333,3),(593,7501406,7501382,'43c',3.333,3),(593,7501407,7501382,'3cb',3.333,3),(593,7501408,7501382,'cbf',3.333,3),(593,7501409,7501382,'bff',3.333,3),(593,7501410,7501382,'ff5',3.333,3),(593,7501411,7501382,'f55',3.333,3),(593,7501412,7501382,'553',3.333,3),(593,7501413,7501383,'mon',100,1),(593,7501414,7501413,'201',50,1),(593,7501415,7501413,'013',50,1),(593,7501416,7501414,'adm',33.333,3),(593,7501417,7501414,'dmi',33.333,3),(593,7501418,7501414,'min',33.333,3),(593,7501419,7501416,'cap',16.667,1),(593,7501420,7501416,'apa',16.667,1),(593,7501421,7501416,'pac',16.667,1),(593,7501422,7501416,'aci',16.667,1),(593,7501423,7501416,'cit',16.667,1),(593,7501424,7501416,'ity',16.667,1),(593,7501425,7501419,'pat',50,1),(593,7501426,7501419,'ath',50,1),(593,7501427,7501425,'fre',14.286,1),(593,7501428,7501425,'ree',14.286,1),(593,7501429,7501425,'ees',14.286,1),(593,7501430,7501425,'esp',14.286,1),(593,7501431,7501425,'spa',14.286,1),(593,7501432,7501425,'pac',14.286,1),(593,7501433,7501425,'ace',14.286,1),(593,7501434,7501427,'dis',50,1),(593,7501435,7501427,'isk',50,1),(593,7501436,7501434,'ind',33.333,1),(593,7501437,7501434,'nde',33.333,1),(593,7501438,7501434,'dex',33.333,1),(593,7501439,7501436,'adm',8.333,1),(593,7501440,7501436,'dmi',8.333,1),(593,7501441,7501436,'min',8.333,1),(593,7501442,7501436,'ini',8.333,1),(593,7501443,7501436,'nis',8.333,1),(593,7501444,7501436,'ist',8.333,1),(593,7501445,7501436,'str',8.333,1),(593,7501446,7501436,'tra',8.333,1),(593,7501447,7501436,'rat',8.333,1),(593,7501448,7501436,'ati',8.333,1),(593,7501449,7501436,'tio',8.333,1),(593,7501450,7501436,'ion',8.333,1),(593,7501451,7501439,'sta',33.333,3),(593,7501452,7501439,'tat',33.333,3),(593,7501453,7501439,'ate',33.333,3),(593,7501454,7501451,'ena',20,2),(593,7501455,7501451,'nab',20,2),(593,7501456,7501451,'abl',20,2),(593,7501457,7501451,'ble',20,2),(593,7501458,7501451,'led',20,2),(593,7501459,7501454,'cac',33.333,2),(593,7501460,7501454,'ach',33.333,2),(593,7501461,7501454,'che',33.333,2),(593,7501462,7501459,'mod',50,1),(593,7501463,7501459,'ode',50,1),(593,7501464,7501462,'wri',14.286,1),(593,7501465,7501462,'rit',14.286,1),(593,7501466,7501462,'ite',14.286,1),(593,7501467,7501462,'tet',14.286,1),(593,7501468,7501462,'eth',14.286,1),(593,7501469,7501462,'thr',14.286,1),(593,7501470,7501462,'hru',14.286,1),(593,7501471,7501464,'ope',11.111,2),(593,7501472,7501464,'per',11.111,2),(593,7501473,7501464,'era',11.111,2),(593,7501474,7501464,'rat',11.111,2),(593,7501475,7501464,'ati',11.111,2),(593,7501476,7501464,'tio',11.111,2),(593,7501477,7501464,'ion',11.111,2),(593,7501478,7501464,'ona',11.111,2),(593,7501479,7501464,'nal',11.111,2),(593,7501480,7501471,'pen',20,1),(593,7501481,7501471,'end',20,1),(593,7501482,7501471,'ndi',20,1),(593,7501483,7501471,'din',20,1),(593,7501484,7501471,'ing',20,1),(593,7501485,7501480,'mes',20,1),(593,7501486,7501480,'ess',20,1),(593,7501487,7501480,'ssa',20,1),(593,7501488,7501480,'sag',20,1),(593,7501489,7501480,'age',20,1),(593,7501490,7501485,'wai',20,1),(593,7501491,7501485,'ait',20,1),(593,7501492,7501485,'iti',20,1),(593,7501493,7501485,'tin',20,1),(593,7501494,7501485,'ing',20,1),(593,7501495,7501490,'for',100,1),(593,7501496,7501495,'per',11.111,1),(593,7501497,7501495,'erf',11.111,1),(593,7501498,7501495,'rfo',11.111,1),(593,7501499,7501495,'for',11.111,1),(593,7501500,7501495,'orm',11.111,1),(593,7501501,7501495,'rma',11.111,1),(593,7501502,7501495,'man',11.111,1),(593,7501503,7501495,'anc',11.111,1),(593,7501504,7501495,'nce',11.111,1),(593,7501505,7501496,'ide',12.5,1),(593,7501506,7501496,'den',12.5,1),(593,7501507,7501496,'ent',12.5,1),(593,7501508,7501496,'nti',12.5,1),(593,7501509,7501496,'tif',12.5,1),(593,7501510,7501496,'ifi',12.5,1),(593,7501511,7501496,'fie',12.5,1),(593,7501512,7501496,'ier',12.5,1),(593,7501513,7501505,'vdi',33.333,3),(593,7501514,7501505,'dis',33.333,3),(593,7501515,7501505,'isk',33.333,3),(593,7501516,7501513,'nam',50,1),(593,7501517,7501513,'ame',50,1),(593,7501518,7501516,'typ',50,1),(593,7501519,7501516,'ype',50,1),(593,7501520,7501518,'dir',25,1),(593,7501521,7501518,'ire',25,1),(593,7501522,7501518,'rec',25,1),(593,7501523,7501518,'ect',25,1),(594,7501525,7501524,'naa',100,2),(594,7501526,7501525,'600',3.333,3),(594,7501527,7501525,'000',3.333,3),(594,7501528,7501525,'00c',3.333,3),(594,7501529,7501525,'0c2',3.333,3),(594,7501530,7501525,'c29',3.333,3),(594,7501531,7501525,'29c',3.333,3),(594,7501532,7501525,'9cc',3.333,3),(594,7501533,7501525,'ccd',3.333,3),(594,7501534,7501525,'cdb',3.333,3),(594,7501535,7501525,'db2',3.333,3),(594,7501536,7501525,'b24',3.333,3),(594,7501537,7501525,'24e',3.333,3),(594,7501538,7501525,'4e2',3.333,3),(594,7501539,7501525,'e24',3.333,3),(594,7501540,7501525,'24d',3.333,3),(594,7501541,7501525,'4da',3.333,3),(594,7501542,7501525,'da4',3.333,3),(594,7501543,7501525,'a43',3.333,3),(594,7501544,7501525,'43e',3.333,3),(594,7501545,7501525,'3eb',3.333,3),(594,7501546,7501525,'ebd',3.333,3),(594,7501547,7501525,'bd4',3.333,3),(594,7501548,7501525,'d4a',3.333,3),(594,7501549,7501525,'4a5',3.333,3),(594,7501550,7501525,'a54',3.333,3),(594,7501551,7501525,'54f',3.333,3),(594,7501552,7501525,'4f1',3.333,3),(594,7501553,7501525,'f1c',3.333,3),(594,7501554,7501525,'1c7',3.333,3),(594,7501555,7501525,'c78',3.333,3),(594,7501556,7501526,'mon',100,1),(594,7501557,7501556,'201',50,1),(594,7501558,7501556,'013',50,1),(594,7501559,7501557,'adm',33.333,3),(594,7501560,7501557,'dmi',33.333,3),(594,7501561,7501557,'min',33.333,3),(594,7501562,7501559,'cap',16.667,1),(594,7501563,7501559,'apa',16.667,1),(594,7501564,7501559,'pac',16.667,1),(594,7501565,7501559,'aci',16.667,1),(594,7501566,7501559,'cit',16.667,1),(594,7501567,7501559,'ity',16.667,1),(594,7501568,7501562,'pat',50,1),(594,7501569,7501562,'ath',50,1),(594,7501570,7501568,'fre',14.286,1),(594,7501571,7501568,'ree',14.286,1),(594,7501572,7501568,'ees',14.286,1),(594,7501573,7501568,'esp',14.286,1),(594,7501574,7501568,'spa',14.286,1),(594,7501575,7501568,'pac',14.286,1),(594,7501576,7501568,'ace',14.286,1),(594,7501577,7501570,'dis',50,1),(594,7501578,7501570,'isk',50,1),(594,7501579,7501577,'ind',33.333,1),(594,7501580,7501577,'nde',33.333,1),(594,7501581,7501577,'dex',33.333,1),(594,7501582,7501579,'adm',8.333,1),(594,7501583,7501579,'dmi',8.333,1),(594,7501584,7501579,'min',8.333,1),(594,7501585,7501579,'ini',8.333,1),(594,7501586,7501579,'nis',8.333,1),(594,7501587,7501579,'ist',8.333,1),(594,7501588,7501579,'str',8.333,1),(594,7501589,7501579,'tra',8.333,1),(594,7501590,7501579,'rat',8.333,1),(594,7501591,7501579,'ati',8.333,1),(594,7501592,7501579,'tio',8.333,1),(594,7501593,7501579,'ion',8.333,1),(594,7501594,7501582,'sta',33.333,3),(594,7501595,7501582,'tat',33.333,3),(594,7501596,7501582,'ate',33.333,3),(594,7501597,7501594,'ena',20,2),(594,7501598,7501594,'nab',20,2),(594,7501599,7501594,'abl',20,2),(594,7501600,7501594,'ble',20,2),(594,7501601,7501594,'led',20,2),(594,7501602,7501597,'cac',33.333,2),(594,7501603,7501597,'ach',33.333,2),(594,7501604,7501597,'che',33.333,2),(594,7501605,7501602,'mod',50,1),(594,7501606,7501602,'ode',50,1),(594,7501607,7501605,'wri',14.286,1),(594,7501608,7501605,'rit',14.286,1),(594,7501609,7501605,'ite',14.286,1),(594,7501610,7501605,'tet',14.286,1),(594,7501611,7501605,'eth',14.286,1),(594,7501612,7501605,'thr',14.286,1),(594,7501613,7501605,'hru',14.286,1),(594,7501614,7501607,'ope',11.111,2),(594,7501615,7501607,'per',11.111,2),(594,7501616,7501607,'era',11.111,2),(594,7501617,7501607,'rat',11.111,2),(594,7501618,7501607,'ati',11.111,2),(594,7501619,7501607,'tio',11.111,2),(594,7501620,7501607,'ion',11.111,2),(594,7501621,7501607,'ona',11.111,2),(594,7501622,7501607,'nal',11.111,2),(594,7501623,7501614,'pen',20,1),(594,7501624,7501614,'end',20,1),(594,7501625,7501614,'ndi',20,1),(594,7501626,7501614,'din',20,1),(594,7501627,7501614,'ing',20,1),(594,7501628,7501623,'mes',20,1),(594,7501629,7501623,'ess',20,1),(594,7501630,7501623,'ssa',20,1),(594,7501631,7501623,'sag',20,1),(594,7501632,7501623,'age',20,1),(594,7501633,7501628,'wai',20,1),(594,7501634,7501628,'ait',20,1),(594,7501635,7501628,'iti',20,1),(594,7501636,7501628,'tin',20,1),(594,7501637,7501628,'ing',20,1),(594,7501638,7501633,'for',100,1),(594,7501639,7501638,'per',11.111,1),(594,7501640,7501638,'erf',11.111,1),(594,7501641,7501638,'rfo',11.111,1),(594,7501642,7501638,'for',11.111,1),(594,7501643,7501638,'orm',11.111,1),(594,7501644,7501638,'rma',11.111,1),(594,7501645,7501638,'man',11.111,1),(594,7501646,7501638,'anc',11.111,1),(594,7501647,7501638,'nce',11.111,1),(594,7501648,7501639,'ide',12.5,1),(594,7501649,7501639,'den',12.5,1),(594,7501650,7501639,'ent',12.5,1),(594,7501651,7501639,'nti',12.5,1),(594,7501652,7501639,'tif',12.5,1),(594,7501653,7501639,'ifi',12.5,1),(594,7501654,7501639,'fie',12.5,1),(594,7501655,7501639,'ier',12.5,1),(594,7501656,7501648,'vdi',33.333,3),(594,7501657,7501648,'dis',33.333,3),(594,7501658,7501648,'isk',33.333,3),(594,7501659,7501656,'nam',50,1),(594,7501660,7501656,'ame',50,1),(594,7501661,7501659,'typ',50,1),(594,7501662,7501659,'ype',50,1),(594,7501663,7501661,'dir',25,1),(594,7501664,7501661,'ire',25,1),(594,7501665,7501661,'rec',25,1),(594,7501666,7501661,'ect',25,1),(595,7501668,7501667,'naa',100,2),(595,7501669,7501668,'600',3.333,3),(595,7501670,7501668,'000',3.333,3),(595,7501671,7501668,'00c',3.333,3),(595,7501672,7501668,'0c2',3.333,3),(595,7501673,7501668,'c29',3.333,3),(595,7501674,7501668,'29b',3.333,3),(595,7501675,7501668,'9be',3.333,3),(595,7501676,7501668,'be6',3.333,3),(595,7501677,7501668,'e68',3.333,3),(595,7501678,7501668,'68a',3.333,3),(595,7501679,7501668,'8a7',3.333,3),(595,7501680,7501668,'a76',3.333,3),(595,7501681,7501668,'767',3.333,3),(595,7501682,7501668,'67f',3.333,3),(595,7501683,7501668,'7f4',3.333,3),(595,7501684,7501668,'f4f',3.333,3),(595,7501685,7501668,'4fe',3.333,3),(595,7501686,7501668,'fe5',3.333,3),(595,7501687,7501668,'e5f',3.333,3),(595,7501688,7501668,'5f4',3.333,3),(595,7501689,7501668,'f4c',3.333,3),(595,7501690,7501668,'4c7',3.333,3),(595,7501691,7501668,'c7a',3.333,3),(595,7501692,7501668,'7af',3.333,3),(595,7501693,7501668,'af1',3.333,3),(595,7501694,7501668,'f1d',3.333,3),(595,7501695,7501668,'1d7',3.333,3),(595,7501696,7501668,'d78',3.333,3),(595,7501697,7501668,'783',3.333,3),(595,7501698,7501668,'830',3.333,3),(595,7501699,7501669,'mon',100,1),(595,7501700,7501699,'201',50,1),(595,7501701,7501699,'013',50,1),(595,7501702,7501700,'adm',33.333,3),(595,7501703,7501700,'dmi',33.333,3),(595,7501704,7501700,'min',33.333,3),(595,7501705,7501702,'cap',16.667,1),(595,7501706,7501702,'apa',16.667,1),(595,7501707,7501702,'pac',16.667,1),(595,7501708,7501702,'aci',16.667,1),(595,7501709,7501702,'cit',16.667,1),(595,7501710,7501702,'ity',16.667,1),(595,7501711,7501705,'pat',50,1),(595,7501712,7501705,'ath',50,1),(595,7501713,7501711,'fre',14.286,1),(595,7501714,7501711,'ree',14.286,1),(595,7501715,7501711,'ees',14.286,1),(595,7501716,7501711,'esp',14.286,1),(595,7501717,7501711,'spa',14.286,1),(595,7501718,7501711,'pac',14.286,1),(595,7501719,7501711,'ace',14.286,1),(595,7501720,7501713,'dis',50,1),(595,7501721,7501713,'isk',50,1),(595,7501722,7501720,'ind',33.333,1),(595,7501723,7501720,'nde',33.333,1),(595,7501724,7501720,'dex',33.333,1),(595,7501725,7501722,'adm',8.333,1),(595,7501726,7501722,'dmi',8.333,1),(595,7501727,7501722,'min',8.333,1),(595,7501728,7501722,'ini',8.333,1),(595,7501729,7501722,'nis',8.333,1),(595,7501730,7501722,'ist',8.333,1),(595,7501731,7501722,'str',8.333,1),(595,7501732,7501722,'tra',8.333,1),(595,7501733,7501722,'rat',8.333,1),(595,7501734,7501722,'ati',8.333,1),(595,7501735,7501722,'tio',8.333,1),(595,7501736,7501722,'ion',8.333,1),(595,7501737,7501725,'sta',33.333,3),(595,7501738,7501725,'tat',33.333,3),(595,7501739,7501725,'ate',33.333,3),(595,7501740,7501737,'ena',20,2),(595,7501741,7501737,'nab',20,2),(595,7501742,7501737,'abl',20,2),(595,7501743,7501737,'ble',20,2),(595,7501744,7501737,'led',20,2),(595,7501745,7501740,'cac',33.333,2),(595,7501746,7501740,'ach',33.333,2),(595,7501747,7501740,'che',33.333,2),(595,7501748,7501745,'mod',50,1),(595,7501749,7501745,'ode',50,1),(595,7501750,7501748,'wri',14.286,1),(595,7501751,7501748,'rit',14.286,1),(595,7501752,7501748,'ite',14.286,1),(595,7501753,7501748,'tet',14.286,1),(595,7501754,7501748,'eth',14.286,1),(595,7501755,7501748,'thr',14.286,1),(595,7501756,7501748,'hru',14.286,1),(595,7501757,7501750,'ope',11.111,2),(595,7501758,7501750,'per',11.111,2),(595,7501759,7501750,'era',11.111,2),(595,7501760,7501750,'rat',11.111,2),(595,7501761,7501750,'ati',11.111,2),(595,7501762,7501750,'tio',11.111,2),(595,7501763,7501750,'ion',11.111,2),(595,7501764,7501750,'ona',11.111,2),(595,7501765,7501750,'nal',11.111,2),(595,7501766,7501757,'pen',20,1),(595,7501767,7501757,'end',20,1),(595,7501768,7501757,'ndi',20,1),(595,7501769,7501757,'din',20,1),(595,7501770,7501757,'ing',20,1),(595,7501771,7501766,'mes',20,1),(595,7501772,7501766,'ess',20,1),(595,7501773,7501766,'ssa',20,1),(595,7501774,7501766,'sag',20,1),(595,7501775,7501766,'age',20,1),(595,7501776,7501771,'wai',20,1),(595,7501777,7501771,'ait',20,1),(595,7501778,7501771,'iti',20,1),(595,7501779,7501771,'tin',20,1),(595,7501780,7501771,'ing',20,1),(595,7501781,7501776,'for',100,1),(595,7501782,7501781,'per',11.111,1),(595,7501783,7501781,'erf',11.111,1),(595,7501784,7501781,'rfo',11.111,1),(595,7501785,7501781,'for',11.111,1),(595,7501786,7501781,'orm',11.111,1),(595,7501787,7501781,'rma',11.111,1),(595,7501788,7501781,'man',11.111,1),(595,7501789,7501781,'anc',11.111,1),(595,7501790,7501781,'nce',11.111,1),(595,7501791,7501782,'ide',12.5,1),(595,7501792,7501782,'den',12.5,1),(595,7501793,7501782,'ent',12.5,1),(595,7501794,7501782,'nti',12.5,1),(595,7501795,7501782,'tif',12.5,1),(595,7501796,7501782,'ifi',12.5,1),(595,7501797,7501782,'fie',12.5,1),(595,7501798,7501782,'ier',12.5,1),(595,7501799,7501791,'vdi',33.333,3),(595,7501800,7501791,'dis',33.333,3),(595,7501801,7501791,'isk',33.333,3),(595,7501802,7501799,'nam',50,1),(595,7501803,7501799,'ame',50,1),(595,7501804,7501802,'typ',50,1),(595,7501805,7501802,'ype',50,1),(595,7501806,7501804,'dir',25,1),(595,7501807,7501804,'ire',25,1),(595,7501808,7501804,'rec',25,1),(595,7501809,7501804,'ect',25,1),(596,7501811,7501810,'naa',100,2),(596,7501812,7501811,'600',3.333,3),(596,7501813,7501811,'000',3.333,3),(596,7501814,7501811,'00c',3.333,3),(596,7501815,7501811,'0c2',3.333,3),(596,7501816,7501811,'c29',3.333,3),(596,7501817,7501811,'291',3.333,3),(596,7501818,7501811,'91d',3.333,3),(596,7501819,7501811,'1dc',3.333,3),(596,7501820,7501811,'dcc',3.333,3),(596,7501821,7501811,'cc5',3.333,3),(596,7501822,7501811,'c59',3.333,3),(596,7501823,7501811,'59a',3.333,3),(596,7501824,7501811,'9ac',3.333,3),(596,7501825,7501811,'ac0',3.333,3),(596,7501826,7501811,'c0b',3.333,3),(596,7501827,7501811,'0bb',3.333,3),(596,7501828,7501811,'bb9',3.333,3),(596,7501829,7501811,'b91',3.333,3),(596,7501830,7501811,'919',3.333,3),(596,7501831,7501811,'19a',3.333,3),(596,7501832,7501811,'9ac',3.333,3),(596,7501833,7501811,'aca',3.333,3),(596,7501834,7501811,'ca5',3.333,3),(596,7501835,7501811,'a5b',3.333,3),(596,7501836,7501811,'5b6',3.333,3),(596,7501837,7501811,'b69',3.333,3),(596,7501838,7501811,'69a',3.333,3),(596,7501839,7501811,'9a8',3.333,3),(596,7501840,7501811,'a81',3.333,3),(596,7501841,7501811,'810',3.333,3),(596,7501842,7501812,'mon',100,1),(596,7501843,7501842,'201',50,1),(596,7501844,7501842,'013',50,1),(596,7501845,7501843,'adm',33.333,3),(596,7501846,7501843,'dmi',33.333,3),(596,7501847,7501843,'min',33.333,3),(596,7501848,7501845,'cap',16.667,1),(596,7501849,7501845,'apa',16.667,1),(596,7501850,7501845,'pac',16.667,1),(596,7501851,7501845,'aci',16.667,1),(596,7501852,7501845,'cit',16.667,1),(596,7501853,7501845,'ity',16.667,1),(596,7501854,7501848,'pat',50,1),(596,7501855,7501848,'ath',50,1),(596,7501856,7501854,'fre',14.286,1),(596,7501857,7501854,'ree',14.286,1),(596,7501858,7501854,'ees',14.286,1),(596,7501859,7501854,'esp',14.286,1),(596,7501860,7501854,'spa',14.286,1),(596,7501861,7501854,'pac',14.286,1),(596,7501862,7501854,'ace',14.286,1),(596,7501863,7501856,'dis',50,1),(596,7501864,7501856,'isk',50,1),(596,7501865,7501863,'ind',33.333,1),(596,7501866,7501863,'nde',33.333,1),(596,7501867,7501863,'dex',33.333,1),(596,7501868,7501865,'adm',8.333,1),(596,7501869,7501865,'dmi',8.333,1),(596,7501870,7501865,'min',8.333,1),(596,7501871,7501865,'ini',8.333,1),(596,7501872,7501865,'nis',8.333,1),(596,7501873,7501865,'ist',8.333,1),(596,7501874,7501865,'str',8.333,1),(596,7501875,7501865,'tra',8.333,1),(596,7501876,7501865,'rat',8.333,1),(596,7501877,7501865,'ati',8.333,1),(596,7501878,7501865,'tio',8.333,1),(596,7501879,7501865,'ion',8.333,1),(596,7501880,7501868,'sta',33.333,3),(596,7501881,7501868,'tat',33.333,3),(596,7501882,7501868,'ate',33.333,3),(596,7501883,7501880,'ena',20,2),(596,7501884,7501880,'nab',20,2),(596,7501885,7501880,'abl',20,2),(596,7501886,7501880,'ble',20,2),(596,7501887,7501880,'led',20,2),(596,7501888,7501883,'cac',33.333,2),(596,7501889,7501883,'ach',33.333,2),(596,7501890,7501883,'che',33.333,2),(596,7501891,7501888,'mod',50,1),(596,7501892,7501888,'ode',50,1),(596,7501893,7501891,'wri',14.286,1),(596,7501894,7501891,'rit',14.286,1),(596,7501895,7501891,'ite',14.286,1),(596,7501896,7501891,'tet',14.286,1),(596,7501897,7501891,'eth',14.286,1),(596,7501898,7501891,'thr',14.286,1),(596,7501899,7501891,'hru',14.286,1),(596,7501900,7501893,'ope',11.111,2),(596,7501901,7501893,'per',11.111,2),(596,7501902,7501893,'era',11.111,2),(596,7501903,7501893,'rat',11.111,2),(596,7501904,7501893,'ati',11.111,2),(596,7501905,7501893,'tio',11.111,2),(596,7501906,7501893,'ion',11.111,2),(596,7501907,7501893,'ona',11.111,2),(596,7501908,7501893,'nal',11.111,2),(596,7501909,7501900,'pen',20,1),(596,7501910,7501900,'end',20,1),(596,7501911,7501900,'ndi',20,1),(596,7501912,7501900,'din',20,1),(596,7501913,7501900,'ing',20,1),(596,7501914,7501909,'mes',20,1),(596,7501915,7501909,'ess',20,1),(596,7501916,7501909,'ssa',20,1),(596,7501917,7501909,'sag',20,1),(596,7501918,7501909,'age',20,1),(596,7501919,7501914,'wai',20,1),(596,7501920,7501914,'ait',20,1),(596,7501921,7501914,'iti',20,1),(596,7501922,7501914,'tin',20,1),(596,7501923,7501914,'ing',20,1),(596,7501924,7501919,'for',100,1),(596,7501925,7501924,'per',11.111,1),(596,7501926,7501924,'erf',11.111,1),(596,7501927,7501924,'rfo',11.111,1),(596,7501928,7501924,'for',11.111,1),(596,7501929,7501924,'orm',11.111,1),(596,7501930,7501924,'rma',11.111,1),(596,7501931,7501924,'man',11.111,1),(596,7501932,7501924,'anc',11.111,1),(596,7501933,7501924,'nce',11.111,1),(596,7501934,7501925,'ide',12.5,1),(596,7501935,7501925,'den',12.5,1),(596,7501936,7501925,'ent',12.5,1),(596,7501937,7501925,'nti',12.5,1),(596,7501938,7501925,'tif',12.5,1),(596,7501939,7501925,'ifi',12.5,1),(596,7501940,7501925,'fie',12.5,1),(596,7501941,7501925,'ier',12.5,1),(596,7501942,7501934,'vdi',33.333,3),(596,7501943,7501934,'dis',33.333,3),(596,7501944,7501934,'isk',33.333,3),(596,7501945,7501942,'nam',50,1),(596,7501946,7501942,'ame',50,1),(596,7501947,7501945,'typ',50,1),(596,7501948,7501945,'ype',50,1),(596,7501949,7501947,'dir',25,1),(596,7501950,7501947,'ire',25,1),(596,7501951,7501947,'rec',25,1),(596,7501952,7501947,'ect',25,1),(597,7501954,7501953,'naa',100,2),(597,7501955,7501954,'600',3.333,3),(597,7501956,7501954,'000',3.333,3),(597,7501957,7501954,'00c',3.333,3),(597,7501958,7501954,'0c2',3.333,3),(597,7501959,7501954,'c29',3.333,3),(597,7501960,7501954,'292',3.333,3),(597,7501961,7501954,'92b',3.333,3),(597,7501962,7501954,'2b2',3.333,3),(597,7501963,7501954,'b26',3.333,3),(597,7501964,7501954,'265',3.333,3),(597,7501965,7501954,'655',3.333,3),(597,7501966,7501954,'556',3.333,3),(597,7501967,7501954,'560',3.333,3),(597,7501968,7501954,'605',3.333,3),(597,7501969,7501954,'05e',3.333,3),(597,7501970,7501954,'5e5',3.333,3),(597,7501971,7501954,'e50',3.333,3),(597,7501972,7501954,'504',3.333,3),(597,7501973,7501954,'04b',3.333,3),(597,7501974,7501954,'4b7',3.333,3),(597,7501975,7501954,'b79',3.333,3),(597,7501976,7501954,'790',3.333,3),(597,7501977,7501954,'90b',3.333,3),(597,7501978,7501954,'0b6',3.333,3),(597,7501979,7501954,'b6e',3.333,3),(597,7501980,7501954,'6e0',3.333,3),(597,7501981,7501954,'e0b',3.333,3),(597,7501982,7501954,'0b4',3.333,3),(597,7501983,7501954,'b43',3.333,3),(597,7501984,7501954,'437',3.333,3),(597,7501985,7501955,'mon',100,1),(597,7501986,7501985,'201',50,1),(597,7501987,7501985,'013',50,1),(597,7501988,7501986,'adm',33.333,3),(597,7501989,7501986,'dmi',33.333,3),(597,7501990,7501986,'min',33.333,3),(597,7501991,7501988,'cap',16.667,1),(597,7501992,7501988,'apa',16.667,1),(597,7501993,7501988,'pac',16.667,1),(597,7501994,7501988,'aci',16.667,1),(597,7501995,7501988,'cit',16.667,1),(597,7501996,7501988,'ity',16.667,1),(597,7501997,7501991,'pat',50,1),(597,7501998,7501991,'ath',50,1),(597,7501999,7501997,'fre',14.286,1),(597,7502000,7501997,'ree',14.286,1),(597,7502001,7501997,'ees',14.286,1),(597,7502002,7501997,'esp',14.286,1),(597,7502003,7501997,'spa',14.286,1),(597,7502004,7501997,'pac',14.286,1),(597,7502005,7501997,'ace',14.286,1),(597,7502006,7501999,'dis',50,1),(597,7502007,7501999,'isk',50,1),(597,7502008,7502006,'ind',33.333,1),(597,7502009,7502006,'nde',33.333,1),(597,7502010,7502006,'dex',33.333,1),(597,7502011,7502008,'adm',8.333,1),(597,7502012,7502008,'dmi',8.333,1),(597,7502013,7502008,'min',8.333,1),(597,7502014,7502008,'ini',8.333,1),(597,7502015,7502008,'nis',8.333,1),(597,7502016,7502008,'ist',8.333,1),(597,7502017,7502008,'str',8.333,1),(597,7502018,7502008,'tra',8.333,1),(597,7502019,7502008,'rat',8.333,1),(597,7502020,7502008,'ati',8.333,1),(597,7502021,7502008,'tio',8.333,1),(597,7502022,7502008,'ion',8.333,1),(597,7502023,7502011,'sta',33.333,3),(597,7502024,7502011,'tat',33.333,3),(597,7502025,7502011,'ate',33.333,3),(597,7502026,7502023,'ena',20,2),(597,7502027,7502023,'nab',20,2),(597,7502028,7502023,'abl',20,2),(597,7502029,7502023,'ble',20,2),(597,7502030,7502023,'led',20,2),(597,7502031,7502026,'cac',33.333,2),(597,7502032,7502026,'ach',33.333,2),(597,7502033,7502026,'che',33.333,2),(597,7502034,7502031,'mod',50,1),(597,7502035,7502031,'ode',50,1),(597,7502036,7502034,'wri',14.286,1),(597,7502037,7502034,'rit',14.286,1),(597,7502038,7502034,'ite',14.286,1),(597,7502039,7502034,'tet',14.286,1),(597,7502040,7502034,'eth',14.286,1),(597,7502041,7502034,'thr',14.286,1),(597,7502042,7502034,'hru',14.286,1),(597,7502043,7502036,'ope',11.111,2),(597,7502044,7502036,'per',11.111,2),(597,7502045,7502036,'era',11.111,2),(597,7502046,7502036,'rat',11.111,2),(597,7502047,7502036,'ati',11.111,2),(597,7502048,7502036,'tio',11.111,2),(597,7502049,7502036,'ion',11.111,2),(597,7502050,7502036,'ona',11.111,2),(597,7502051,7502036,'nal',11.111,2),(597,7502052,7502043,'pen',20,1),(597,7502053,7502043,'end',20,1),(597,7502054,7502043,'ndi',20,1),(597,7502055,7502043,'din',20,1),(597,7502056,7502043,'ing',20,1),(597,7502057,7502052,'mes',20,1),(597,7502058,7502052,'ess',20,1),(597,7502059,7502052,'ssa',20,1),(597,7502060,7502052,'sag',20,1),(597,7502061,7502052,'age',20,1),(597,7502062,7502057,'wai',20,1),(597,7502063,7502057,'ait',20,1),(597,7502064,7502057,'iti',20,1),(597,7502065,7502057,'tin',20,1),(597,7502066,7502057,'ing',20,1),(597,7502067,7502062,'for',100,1),(597,7502068,7502067,'per',11.111,1),(597,7502069,7502067,'erf',11.111,1),(597,7502070,7502067,'rfo',11.111,1),(597,7502071,7502067,'for',11.111,1),(597,7502072,7502067,'orm',11.111,1),(597,7502073,7502067,'rma',11.111,1),(597,7502074,7502067,'man',11.111,1),(597,7502075,7502067,'anc',11.111,1),(597,7502076,7502067,'nce',11.111,1),(597,7502077,7502068,'ide',12.5,1),(597,7502078,7502068,'den',12.5,1),(597,7502079,7502068,'ent',12.5,1),(597,7502080,7502068,'nti',12.5,1),(597,7502081,7502068,'tif',12.5,1),(597,7502082,7502068,'ifi',12.5,1),(597,7502083,7502068,'fie',12.5,1),(597,7502084,7502068,'ier',12.5,1),(597,7502085,7502077,'vdi',33.333,3),(597,7502086,7502077,'dis',33.333,3),(597,7502087,7502077,'isk',33.333,3),(597,7502088,7502085,'nam',50,1),(597,7502089,7502085,'ame',50,1),(597,7502090,7502088,'typ',50,1),(597,7502091,7502088,'ype',50,1),(597,7502092,7502090,'dir',25,1),(597,7502093,7502090,'ire',25,1),(597,7502094,7502090,'rec',25,1),(597,7502095,7502090,'ect',25,1),(598,7502097,7502096,'naa',100,2),(598,7502098,7502097,'600',3.333,3),(598,7502099,7502097,'000',3.333,3),(598,7502100,7502097,'00c',3.333,3),(598,7502101,7502097,'0c2',3.333,3),(598,7502102,7502097,'c29',3.333,3),(598,7502103,7502097,'290',3.333,3),(598,7502104,7502097,'905',3.333,3),(598,7502105,7502097,'05c',3.333,3),(598,7502106,7502097,'5c8',3.333,3),(598,7502107,7502097,'c8a',3.333,3),(598,7502108,7502097,'8ab',3.333,3),(598,7502109,7502097,'ab6',3.333,3),(598,7502110,7502097,'b63',3.333,3),(598,7502111,7502097,'634',3.333,3),(598,7502112,7502097,'341',3.333,3),(598,7502113,7502097,'411',3.333,3),(598,7502114,7502097,'112',3.333,3),(598,7502115,7502097,'127',3.333,3),(598,7502116,7502097,'274',3.333,3),(598,7502117,7502097,'748',3.333,3),(598,7502118,7502097,'48f',3.333,3),(598,7502119,7502097,'8f7',3.333,3),(598,7502120,7502097,'f71',3.333,3),(598,7502121,7502097,'71f',3.333,3),(598,7502122,7502097,'1f8',3.333,3),(598,7502123,7502097,'f8d',3.333,3),(598,7502124,7502097,'8db',3.333,3),(598,7502125,7502097,'db6',3.333,3),(598,7502126,7502097,'b6d',3.333,3),(598,7502127,7502097,'6df',3.333,3),(598,7502128,7502098,'mon',100,1),(598,7502129,7502128,'201',50,1),(598,7502130,7502128,'013',50,1),(598,7502131,7502129,'adm',33.333,3),(598,7502132,7502129,'dmi',33.333,3),(598,7502133,7502129,'min',33.333,3),(598,7502134,7502131,'cap',16.667,1),(598,7502135,7502131,'apa',16.667,1),(598,7502136,7502131,'pac',16.667,1),(598,7502137,7502131,'aci',16.667,1),(598,7502138,7502131,'cit',16.667,1),(598,7502139,7502131,'ity',16.667,1),(598,7502140,7502134,'pat',50,1),(598,7502141,7502134,'ath',50,1),(598,7502142,7502140,'fre',14.286,1),(598,7502143,7502140,'ree',14.286,1),(598,7502144,7502140,'ees',14.286,1),(598,7502145,7502140,'esp',14.286,1),(598,7502146,7502140,'spa',14.286,1),(598,7502147,7502140,'pac',14.286,1),(598,7502148,7502140,'ace',14.286,1),(598,7502149,7502142,'dis',50,1),(598,7502150,7502142,'isk',50,1),(598,7502151,7502149,'ind',33.333,1),(598,7502152,7502149,'nde',33.333,1),(598,7502153,7502149,'dex',33.333,1),(598,7502154,7502151,'adm',8.333,1),(598,7502155,7502151,'dmi',8.333,1),(598,7502156,7502151,'min',8.333,1),(598,7502157,7502151,'ini',8.333,1),(598,7502158,7502151,'nis',8.333,1),(598,7502159,7502151,'ist',8.333,1),(598,7502160,7502151,'str',8.333,1),(598,7502161,7502151,'tra',8.333,1),(598,7502162,7502151,'rat',8.333,1),(598,7502163,7502151,'ati',8.333,1),(598,7502164,7502151,'tio',8.333,1),(598,7502165,7502151,'ion',8.333,1),(598,7502166,7502154,'sta',33.333,3),(598,7502167,7502154,'tat',33.333,3),(598,7502168,7502154,'ate',33.333,3),(598,7502169,7502166,'ena',20,2),(598,7502170,7502166,'nab',20,2),(598,7502171,7502166,'abl',20,2),(598,7502172,7502166,'ble',20,2),(598,7502173,7502166,'led',20,2),(598,7502174,7502169,'cac',33.333,2),(598,7502175,7502169,'ach',33.333,2),(598,7502176,7502169,'che',33.333,2),(598,7502177,7502174,'mod',50,1),(598,7502178,7502174,'ode',50,1),(598,7502179,7502177,'wri',14.286,1),(598,7502180,7502177,'rit',14.286,1),(598,7502181,7502177,'ite',14.286,1),(598,7502182,7502177,'tet',14.286,1),(598,7502183,7502177,'eth',14.286,1),(598,7502184,7502177,'thr',14.286,1),(598,7502185,7502177,'hru',14.286,1),(598,7502186,7502179,'ope',11.111,2),(598,7502187,7502179,'per',11.111,2),(598,7502188,7502179,'era',11.111,2),(598,7502189,7502179,'rat',11.111,2),(598,7502190,7502179,'ati',11.111,2),(598,7502191,7502179,'tio',11.111,2),(598,7502192,7502179,'ion',11.111,2),(598,7502193,7502179,'ona',11.111,2),(598,7502194,7502179,'nal',11.111,2),(598,7502195,7502186,'pen',20,1),(598,7502196,7502186,'end',20,1),(598,7502197,7502186,'ndi',20,1),(598,7502198,7502186,'din',20,1),(598,7502199,7502186,'ing',20,1),(598,7502200,7502195,'mes',20,1),(598,7502201,7502195,'ess',20,1),(598,7502202,7502195,'ssa',20,1),(598,7502203,7502195,'sag',20,1),(598,7502204,7502195,'age',20,1),(598,7502205,7502200,'wai',20,1),(598,7502206,7502200,'ait',20,1),(598,7502207,7502200,'iti',20,1),(598,7502208,7502200,'tin',20,1),(598,7502209,7502200,'ing',20,1),(598,7502210,7502205,'for',100,1),(598,7502211,7502210,'per',11.111,1),(598,7502212,7502210,'erf',11.111,1),(598,7502213,7502210,'rfo',11.111,1),(598,7502214,7502210,'for',11.111,1),(598,7502215,7502210,'orm',11.111,1),(598,7502216,7502210,'rma',11.111,1),(598,7502217,7502210,'man',11.111,1),(598,7502218,7502210,'anc',11.111,1),(598,7502219,7502210,'nce',11.111,1),(598,7502220,7502211,'ide',12.5,1),(598,7502221,7502211,'den',12.5,1),(598,7502222,7502211,'ent',12.5,1),(598,7502223,7502211,'nti',12.5,1),(598,7502224,7502211,'tif',12.5,1),(598,7502225,7502211,'ifi',12.5,1),(598,7502226,7502211,'fie',12.5,1),(598,7502227,7502211,'ier',12.5,1),(598,7502228,7502220,'vdi',33.333,3),(598,7502229,7502220,'dis',33.333,3),(598,7502230,7502220,'isk',33.333,3),(598,7502231,7502228,'nam',50,1),(598,7502232,7502228,'ame',50,1),(598,7502233,7502231,'typ',50,1),(598,7502234,7502231,'ype',50,1),(598,7502235,7502233,'dir',25,1),(598,7502236,7502233,'ire',25,1),(598,7502237,7502233,'rec',25,1),(598,7502238,7502233,'ect',25,1),(599,7502240,7502239,'naa',100,2),(599,7502241,7502240,'600',3.333,3),(599,7502242,7502240,'000',3.333,3),(599,7502243,7502240,'00c',3.333,3),(599,7502244,7502240,'0c2',3.333,3),(599,7502245,7502240,'c29',3.333,3),(599,7502246,7502240,'29d',3.333,3),(599,7502247,7502240,'9de',3.333,3),(599,7502248,7502240,'dec',3.333,3),(599,7502249,7502240,'ec9',3.333,3),(599,7502250,7502240,'c91',3.333,3),(599,7502251,7502240,'91c',3.333,3),(599,7502252,7502240,'1ce',3.333,3),(599,7502253,7502240,'ceb',3.333,3),(599,7502254,7502240,'eb4',3.333,3),(599,7502255,7502240,'b40',3.333,3),(599,7502256,7502240,'40a',3.333,3),(599,7502257,7502240,'0a9',3.333,3),(599,7502258,7502240,'a9a',3.333,3),(599,7502259,7502240,'9a0',3.333,3),(599,7502260,7502240,'a04',3.333,3),(599,7502261,7502240,'04b',3.333,3),(599,7502262,7502240,'4b1',3.333,3),(599,7502263,7502240,'b1d',3.333,3),(599,7502264,7502240,'1d7',3.333,3),(599,7502265,7502240,'d7d',3.333,3),(599,7502266,7502240,'7d8',3.333,3),(599,7502267,7502240,'d8d',3.333,3),(599,7502268,7502240,'8d2',3.333,3),(599,7502269,7502240,'d2c',3.333,3),(599,7502270,7502240,'2c0',3.333,3),(599,7502271,7502241,'mon',100,1),(599,7502272,7502271,'201',50,1),(599,7502273,7502271,'013',50,1),(599,7502274,7502272,'adm',33.333,3),(599,7502275,7502272,'dmi',33.333,3),(599,7502276,7502272,'min',33.333,3),(599,7502277,7502274,'cap',16.667,1),(599,7502278,7502274,'apa',16.667,1),(599,7502279,7502274,'pac',16.667,1),(599,7502280,7502274,'aci',16.667,1),(599,7502281,7502274,'cit',16.667,1),(599,7502282,7502274,'ity',16.667,1),(599,7502283,7502277,'pat',50,1),(599,7502284,7502277,'ath',50,1),(599,7502285,7502283,'fre',14.286,1),(599,7502286,7502283,'ree',14.286,1),(599,7502287,7502283,'ees',14.286,1),(599,7502288,7502283,'esp',14.286,1),(599,7502289,7502283,'spa',14.286,1),(599,7502290,7502283,'pac',14.286,1),(599,7502291,7502283,'ace',14.286,1),(599,7502292,7502285,'dis',50,1),(599,7502293,7502285,'isk',50,1),(599,7502294,7502292,'ind',33.333,1),(599,7502295,7502292,'nde',33.333,1),(599,7502296,7502292,'dex',33.333,1),(599,7502297,7502294,'adm',8.333,1),(599,7502298,7502294,'dmi',8.333,1),(599,7502299,7502294,'min',8.333,1),(599,7502300,7502294,'ini',8.333,1),(599,7502301,7502294,'nis',8.333,1),(599,7502302,7502294,'ist',8.333,1),(599,7502303,7502294,'str',8.333,1),(599,7502304,7502294,'tra',8.333,1),(599,7502305,7502294,'rat',8.333,1),(599,7502306,7502294,'ati',8.333,1),(599,7502307,7502294,'tio',8.333,1),(599,7502308,7502294,'ion',8.333,1),(599,7502309,7502297,'sta',33.333,3),(599,7502310,7502297,'tat',33.333,3),(599,7502311,7502297,'ate',33.333,3),(599,7502312,7502309,'ena',20,2),(599,7502313,7502309,'nab',20,2),(599,7502314,7502309,'abl',20,2),(599,7502315,7502309,'ble',20,2),(599,7502316,7502309,'led',20,2),(599,7502317,7502312,'cac',33.333,2),(599,7502318,7502312,'ach',33.333,2),(599,7502319,7502312,'che',33.333,2),(599,7502320,7502317,'mod',50,1),(599,7502321,7502317,'ode',50,1),(599,7502322,7502320,'wri',14.286,1),(599,7502323,7502320,'rit',14.286,1),(599,7502324,7502320,'ite',14.286,1),(599,7502325,7502320,'tet',14.286,1),(599,7502326,7502320,'eth',14.286,1),(599,7502327,7502320,'thr',14.286,1),(599,7502328,7502320,'hru',14.286,1),(599,7502329,7502322,'ope',11.111,2),(599,7502330,7502322,'per',11.111,2),(599,7502331,7502322,'era',11.111,2),(599,7502332,7502322,'rat',11.111,2),(599,7502333,7502322,'ati',11.111,2),(599,7502334,7502322,'tio',11.111,2),(599,7502335,7502322,'ion',11.111,2),(599,7502336,7502322,'ona',11.111,2),(599,7502337,7502322,'nal',11.111,2),(599,7502338,7502329,'pen',20,1),(599,7502339,7502329,'end',20,1),(599,7502340,7502329,'ndi',20,1),(599,7502341,7502329,'din',20,1),(599,7502342,7502329,'ing',20,1),(599,7502343,7502338,'mes',20,1),(599,7502344,7502338,'ess',20,1),(599,7502345,7502338,'ssa',20,1),(599,7502346,7502338,'sag',20,1),(599,7502347,7502338,'age',20,1),(599,7502348,7502343,'wai',20,1),(599,7502349,7502343,'ait',20,1),(599,7502350,7502343,'iti',20,1),(599,7502351,7502343,'tin',20,1),(599,7502352,7502343,'ing',20,1),(599,7502353,7502348,'for',100,1),(599,7502354,7502353,'per',11.111,1),(599,7502355,7502353,'erf',11.111,1),(599,7502356,7502353,'rfo',11.111,1),(599,7502357,7502353,'for',11.111,1),(599,7502358,7502353,'orm',11.111,1),(599,7502359,7502353,'rma',11.111,1),(599,7502360,7502353,'man',11.111,1),(599,7502361,7502353,'anc',11.111,1),(599,7502362,7502353,'nce',11.111,1),(599,7502363,7502354,'ide',12.5,1),(599,7502364,7502354,'den',12.5,1),(599,7502365,7502354,'ent',12.5,1),(599,7502366,7502354,'nti',12.5,1),(599,7502367,7502354,'tif',12.5,1),(599,7502368,7502354,'ifi',12.5,1),(599,7502369,7502354,'fie',12.5,1),(599,7502370,7502354,'ier',12.5,1),(599,7502371,7502363,'vdi',33.333,3),(599,7502372,7502363,'dis',33.333,3),(599,7502373,7502363,'isk',33.333,3),(599,7502374,7502371,'nam',50,1),(599,7502375,7502371,'ame',50,1),(599,7502376,7502374,'typ',50,1),(599,7502377,7502374,'ype',50,1),(599,7502378,7502376,'dir',25,1),(599,7502379,7502376,'ire',25,1),(599,7502380,7502376,'rec',25,1),(599,7502381,7502376,'ect',25,1),(600,7502383,7502382,'naa',100,2),(600,7502384,7502383,'600',3.333,3),(600,7502385,7502383,'000',3.333,3),(600,7502386,7502383,'00c',3.333,3),(600,7502387,7502383,'0c2',3.333,3),(600,7502388,7502383,'c29',3.333,3),(600,7502389,7502383,'292',3.333,3),(600,7502390,7502383,'92a',3.333,3),(600,7502391,7502383,'2a3',3.333,3),(600,7502392,7502383,'a39',3.333,3),(600,7502393,7502383,'39d',3.333,3),(600,7502394,7502383,'9dc',3.333,3),(600,7502395,7502383,'dc2',3.333,3),(600,7502396,7502383,'c2d',3.333,3),(600,7502397,7502383,'2dc',3.333,3),(600,7502398,7502383,'dc4',3.333,3),(600,7502399,7502383,'c49',3.333,3),(600,7502400,7502383,'490',3.333,3),(600,7502401,7502383,'908',3.333,3),(600,7502402,7502383,'084',3.333,3),(600,7502403,7502383,'846',3.333,3),(600,7502404,7502383,'46e',3.333,3),(600,7502405,7502383,'6e2',3.333,3),(600,7502406,7502383,'e26',3.333,3),(600,7502407,7502383,'262',3.333,3),(600,7502408,7502383,'626',3.333,3),(600,7502409,7502383,'262',3.333,3),(600,7502410,7502383,'626',3.333,3),(600,7502411,7502383,'26f',3.333,3),(600,7502412,7502383,'6fe',3.333,3),(600,7502413,7502383,'fee',3.333,3),(600,7502414,7502384,'mon',100,1),(600,7502415,7502414,'201',50,1),(600,7502416,7502414,'013',50,1),(600,7502417,7502415,'adm',33.333,3),(600,7502418,7502415,'dmi',33.333,3),(600,7502419,7502415,'min',33.333,3),(600,7502420,7502417,'cap',16.667,1),(600,7502421,7502417,'apa',16.667,1),(600,7502422,7502417,'pac',16.667,1),(600,7502423,7502417,'aci',16.667,1),(600,7502424,7502417,'cit',16.667,1),(600,7502425,7502417,'ity',16.667,1),(600,7502426,7502420,'pat',50,1),(600,7502427,7502420,'ath',50,1),(600,7502428,7502426,'fre',14.286,1),(600,7502429,7502426,'ree',14.286,1),(600,7502430,7502426,'ees',14.286,1),(600,7502431,7502426,'esp',14.286,1),(600,7502432,7502426,'spa',14.286,1),(600,7502433,7502426,'pac',14.286,1),(600,7502434,7502426,'ace',14.286,1),(600,7502435,7502428,'dis',50,1),(600,7502436,7502428,'isk',50,1),(600,7502437,7502435,'ind',33.333,1),(600,7502438,7502435,'nde',33.333,1),(600,7502439,7502435,'dex',33.333,1),(600,7502440,7502437,'adm',8.333,1),(600,7502441,7502437,'dmi',8.333,1),(600,7502442,7502437,'min',8.333,1),(600,7502443,7502437,'ini',8.333,1),(600,7502444,7502437,'nis',8.333,1),(600,7502445,7502437,'ist',8.333,1),(600,7502446,7502437,'str',8.333,1),(600,7502447,7502437,'tra',8.333,1),(600,7502448,7502437,'rat',8.333,1),(600,7502449,7502437,'ati',8.333,1),(600,7502450,7502437,'tio',8.333,1),(600,7502451,7502437,'ion',8.333,1),(600,7502452,7502440,'sta',33.333,3),(600,7502453,7502440,'tat',33.333,3),(600,7502454,7502440,'ate',33.333,3),(600,7502455,7502452,'ena',20,2),(600,7502456,7502452,'nab',20,2),(600,7502457,7502452,'abl',20,2),(600,7502458,7502452,'ble',20,2),(600,7502459,7502452,'led',20,2),(600,7502460,7502455,'cac',33.333,2),(600,7502461,7502455,'ach',33.333,2),(600,7502462,7502455,'che',33.333,2),(600,7502463,7502460,'mod',50,1),(600,7502464,7502460,'ode',50,1),(600,7502465,7502463,'wri',14.286,1),(600,7502466,7502463,'rit',14.286,1),(600,7502467,7502463,'ite',14.286,1),(600,7502468,7502463,'tet',14.286,1),(600,7502469,7502463,'eth',14.286,1),(600,7502470,7502463,'thr',14.286,1),(600,7502471,7502463,'hru',14.286,1),(600,7502472,7502465,'ope',11.111,2),(600,7502473,7502465,'per',11.111,2),(600,7502474,7502465,'era',11.111,2),(600,7502475,7502465,'rat',11.111,2),(600,7502476,7502465,'ati',11.111,2),(600,7502477,7502465,'tio',11.111,2),(600,7502478,7502465,'ion',11.111,2),(600,7502479,7502465,'ona',11.111,2),(600,7502480,7502465,'nal',11.111,2),(600,7502481,7502472,'pen',20,1),(600,7502482,7502472,'end',20,1),(600,7502483,7502472,'ndi',20,1),(600,7502484,7502472,'din',20,1),(600,7502485,7502472,'ing',20,1),(600,7502486,7502481,'mes',20,1),(600,7502487,7502481,'ess',20,1),(600,7502488,7502481,'ssa',20,1),(600,7502489,7502481,'sag',20,1),(600,7502490,7502481,'age',20,1),(600,7502491,7502486,'wai',20,1),(600,7502492,7502486,'ait',20,1),(600,7502493,7502486,'iti',20,1),(600,7502494,7502486,'tin',20,1),(600,7502495,7502486,'ing',20,1),(600,7502496,7502491,'for',100,1),(600,7502497,7502496,'per',11.111,1),(600,7502498,7502496,'erf',11.111,1),(600,7502499,7502496,'rfo',11.111,1),(600,7502500,7502496,'for',11.111,1),(600,7502501,7502496,'orm',11.111,1),(600,7502502,7502496,'rma',11.111,1),(600,7502503,7502496,'man',11.111,1),(600,7502504,7502496,'anc',11.111,1),(600,7502505,7502496,'nce',11.111,1),(600,7502506,7502497,'ide',12.5,1),(600,7502507,7502497,'den',12.5,1),(600,7502508,7502497,'ent',12.5,1),(600,7502509,7502497,'nti',12.5,1),(600,7502510,7502497,'tif',12.5,1),(600,7502511,7502497,'ifi',12.5,1),(600,7502512,7502497,'fie',12.5,1),(600,7502513,7502497,'ier',12.5,1),(600,7502514,7502506,'vdi',33.333,3),(600,7502515,7502506,'dis',33.333,3),(600,7502516,7502506,'isk',33.333,3),(600,7502517,7502514,'nam',50,1),(600,7502518,7502514,'ame',50,1),(600,7502519,7502517,'typ',50,1),(600,7502520,7502517,'ype',50,1),(600,7502521,7502519,'dir',25,1),(600,7502522,7502519,'ire',25,1),(600,7502523,7502519,'rec',25,1),(600,7502524,7502519,'ect',25,1),(601,7502526,7502525,'naa',100,2),(601,7502527,7502526,'600',3.333,3),(601,7502528,7502526,'000',3.333,3),(601,7502529,7502526,'00c',3.333,3),(601,7502530,7502526,'0c2',3.333,3),(601,7502531,7502526,'c29',3.333,3),(601,7502532,7502526,'29d',3.333,3),(601,7502533,7502526,'9d9',3.333,3),(601,7502534,7502526,'d95',3.333,3),(601,7502535,7502526,'95b',3.333,3),(601,7502536,7502526,'5b6',3.333,3),(601,7502537,7502526,'b6f',3.333,3),(601,7502538,7502526,'6fa',3.333,3),(601,7502539,7502526,'fa4',3.333,3),(601,7502540,7502526,'a44',3.333,3),(601,7502541,7502526,'441',3.333,3),(601,7502542,7502526,'412',3.333,3),(601,7502543,7502526,'126',3.333,3),(601,7502544,7502526,'264',3.333,3),(601,7502545,7502526,'64f',3.333,3),(601,7502546,7502526,'4f6',3.333,3),(601,7502547,7502526,'f68',3.333,3),(601,7502548,7502526,'688',3.333,3),(601,7502549,7502526,'881',3.333,3),(601,7502550,7502526,'818',3.333,3),(601,7502551,7502526,'186',3.333,3),(601,7502552,7502526,'868',3.333,3),(601,7502553,7502526,'680',3.333,3),(601,7502554,7502526,'802',3.333,3),(601,7502555,7502526,'024',3.333,3),(601,7502556,7502526,'24e',3.333,3),(601,7502557,7502527,'mon',100,1),(601,7502558,7502557,'201',50,1),(601,7502559,7502557,'013',50,1),(601,7502560,7502558,'adm',33.333,3),(601,7502561,7502558,'dmi',33.333,3),(601,7502562,7502558,'min',33.333,3),(601,7502563,7502560,'cap',16.667,1),(601,7502564,7502560,'apa',16.667,1),(601,7502565,7502560,'pac',16.667,1),(601,7502566,7502560,'aci',16.667,1),(601,7502567,7502560,'cit',16.667,1),(601,7502568,7502560,'ity',16.667,1),(601,7502569,7502563,'pat',50,1),(601,7502570,7502563,'ath',50,1),(601,7502571,7502569,'fre',14.286,1),(601,7502572,7502569,'ree',14.286,1),(601,7502573,7502569,'ees',14.286,1),(601,7502574,7502569,'esp',14.286,1),(601,7502575,7502569,'spa',14.286,1),(601,7502576,7502569,'pac',14.286,1),(601,7502577,7502569,'ace',14.286,1),(601,7502578,7502571,'dis',50,1),(601,7502579,7502571,'isk',50,1),(601,7502580,7502578,'ind',33.333,1),(601,7502581,7502578,'nde',33.333,1),(601,7502582,7502578,'dex',33.333,1),(601,7502583,7502580,'adm',8.333,1),(601,7502584,7502580,'dmi',8.333,1),(601,7502585,7502580,'min',8.333,1),(601,7502586,7502580,'ini',8.333,1),(601,7502587,7502580,'nis',8.333,1),(601,7502588,7502580,'ist',8.333,1),(601,7502589,7502580,'str',8.333,1),(601,7502590,7502580,'tra',8.333,1),(601,7502591,7502580,'rat',8.333,1),(601,7502592,7502580,'ati',8.333,1),(601,7502593,7502580,'tio',8.333,1),(601,7502594,7502580,'ion',8.333,1),(601,7502595,7502583,'sta',33.333,3),(601,7502596,7502583,'tat',33.333,3),(601,7502597,7502583,'ate',33.333,3),(601,7502598,7502595,'ena',20,2),(601,7502599,7502595,'nab',20,2),(601,7502600,7502595,'abl',20,2),(601,7502601,7502595,'ble',20,2),(601,7502602,7502595,'led',20,2),(601,7502603,7502598,'cac',33.333,2),(601,7502604,7502598,'ach',33.333,2),(601,7502605,7502598,'che',33.333,2),(601,7502606,7502603,'mod',50,1),(601,7502607,7502603,'ode',50,1),(601,7502608,7502606,'wri',14.286,1),(601,7502609,7502606,'rit',14.286,1),(601,7502610,7502606,'ite',14.286,1),(601,7502611,7502606,'tet',14.286,1),(601,7502612,7502606,'eth',14.286,1),(601,7502613,7502606,'thr',14.286,1),(601,7502614,7502606,'hru',14.286,1),(601,7502615,7502608,'ope',11.111,2),(601,7502616,7502608,'per',11.111,2),(601,7502617,7502608,'era',11.111,2),(601,7502618,7502608,'rat',11.111,2),(601,7502619,7502608,'ati',11.111,2),(601,7502620,7502608,'tio',11.111,2),(601,7502621,7502608,'ion',11.111,2),(601,7502622,7502608,'ona',11.111,2),(601,7502623,7502608,'nal',11.111,2),(601,7502624,7502615,'pen',20,1),(601,7502625,7502615,'end',20,1),(601,7502626,7502615,'ndi',20,1),(601,7502627,7502615,'din',20,1),(601,7502628,7502615,'ing',20,1),(601,7502629,7502624,'mes',20,1),(601,7502630,7502624,'ess',20,1),(601,7502631,7502624,'ssa',20,1),(601,7502632,7502624,'sag',20,1),(601,7502633,7502624,'age',20,1),(601,7502634,7502629,'wai',20,1),(601,7502635,7502629,'ait',20,1),(601,7502636,7502629,'iti',20,1),(601,7502637,7502629,'tin',20,1),(601,7502638,7502629,'ing',20,1),(601,7502639,7502634,'for',100,1),(601,7502640,7502639,'per',11.111,1),(601,7502641,7502639,'erf',11.111,1),(601,7502642,7502639,'rfo',11.111,1),(601,7502643,7502639,'for',11.111,1),(601,7502644,7502639,'orm',11.111,1),(601,7502645,7502639,'rma',11.111,1),(601,7502646,7502639,'man',11.111,1),(601,7502647,7502639,'anc',11.111,1),(601,7502648,7502639,'nce',11.111,1),(601,7502649,7502640,'ide',12.5,1),(601,7502650,7502640,'den',12.5,1),(601,7502651,7502640,'ent',12.5,1),(601,7502652,7502640,'nti',12.5,1),(601,7502653,7502640,'tif',12.5,1),(601,7502654,7502640,'ifi',12.5,1),(601,7502655,7502640,'fie',12.5,1),(601,7502656,7502640,'ier',12.5,1),(601,7502657,7502649,'vdi',33.333,3),(601,7502658,7502649,'dis',33.333,3),(601,7502659,7502649,'isk',33.333,3),(601,7502660,7502657,'nam',50,1),(601,7502661,7502657,'ame',50,1),(601,7502662,7502660,'typ',50,1),(601,7502663,7502660,'ype',50,1),(601,7502664,7502662,'dir',25,1),(601,7502665,7502662,'ire',25,1),(601,7502666,7502662,'rec',25,1),(601,7502667,7502662,'ect',25,1),(602,7502669,7502668,'naa',100,2),(602,7502670,7502669,'600',3.333,3),(602,7502671,7502669,'000',3.333,3),(602,7502672,7502669,'00c',3.333,3),(602,7502673,7502669,'0c2',3.333,3),(602,7502674,7502669,'c29',3.333,3),(602,7502675,7502669,'296',3.333,3),(602,7502676,7502669,'96a',3.333,3),(602,7502677,7502669,'6ab',3.333,3),(602,7502678,7502669,'abe',3.333,3),(602,7502679,7502669,'be6',3.333,3),(602,7502680,7502669,'e69',3.333,3),(602,7502681,7502669,'696',3.333,3),(602,7502682,7502669,'96d',3.333,3),(602,7502683,7502669,'6dd',3.333,3),(602,7502684,7502669,'dd2',3.333,3),(602,7502685,7502669,'d22',3.333,3),(602,7502686,7502669,'22c',3.333,3),(602,7502687,7502669,'2c1',3.333,3),(602,7502688,7502669,'c14',3.333,3),(602,7502689,7502669,'14c',3.333,3),(602,7502690,7502669,'4cc',3.333,3),(602,7502691,7502669,'cc7',3.333,3),(602,7502692,7502669,'c77',3.333,3),(602,7502693,7502669,'776',3.333,3),(602,7502694,7502669,'767',3.333,3),(602,7502695,7502669,'672',3.333,3),(602,7502696,7502669,'72d',3.333,3),(602,7502697,7502669,'2d2',3.333,3),(602,7502698,7502669,'d24',3.333,3),(602,7502699,7502669,'24b',3.333,3),(602,7502700,7502670,'mon',100,1),(602,7502701,7502700,'201',50,1),(602,7502702,7502700,'013',50,1),(602,7502703,7502701,'adm',33.333,3),(602,7502704,7502701,'dmi',33.333,3),(602,7502705,7502701,'min',33.333,3),(602,7502706,7502703,'cap',16.667,1),(602,7502707,7502703,'apa',16.667,1),(602,7502708,7502703,'pac',16.667,1),(602,7502709,7502703,'aci',16.667,1),(602,7502710,7502703,'cit',16.667,1),(602,7502711,7502703,'ity',16.667,1),(602,7502712,7502706,'pat',50,1),(602,7502713,7502706,'ath',50,1),(602,7502714,7502712,'fre',14.286,1),(602,7502715,7502712,'ree',14.286,1),(602,7502716,7502712,'ees',14.286,1),(602,7502717,7502712,'esp',14.286,1),(602,7502718,7502712,'spa',14.286,1),(602,7502719,7502712,'pac',14.286,1),(602,7502720,7502712,'ace',14.286,1),(602,7502721,7502714,'dis',50,1),(602,7502722,7502714,'isk',50,1),(602,7502723,7502721,'ind',33.333,1),(602,7502724,7502721,'nde',33.333,1),(602,7502725,7502721,'dex',33.333,1),(602,7502726,7502723,'adm',8.333,1),(602,7502727,7502723,'dmi',8.333,1),(602,7502728,7502723,'min',8.333,1),(602,7502729,7502723,'ini',8.333,1),(602,7502730,7502723,'nis',8.333,1),(602,7502731,7502723,'ist',8.333,1),(602,7502732,7502723,'str',8.333,1),(602,7502733,7502723,'tra',8.333,1),(602,7502734,7502723,'rat',8.333,1),(602,7502735,7502723,'ati',8.333,1),(602,7502736,7502723,'tio',8.333,1),(602,7502737,7502723,'ion',8.333,1),(602,7502738,7502726,'sta',33.333,3),(602,7502739,7502726,'tat',33.333,3),(602,7502740,7502726,'ate',33.333,3),(602,7502741,7502738,'ena',20,2),(602,7502742,7502738,'nab',20,2),(602,7502743,7502738,'abl',20,2),(602,7502744,7502738,'ble',20,2),(602,7502745,7502738,'led',20,2),(602,7502746,7502741,'cac',33.333,2),(602,7502747,7502741,'ach',33.333,2),(602,7502748,7502741,'che',33.333,2),(602,7502749,7502746,'mod',50,1),(602,7502750,7502746,'ode',50,1),(602,7502751,7502749,'wri',14.286,1),(602,7502752,7502749,'rit',14.286,1),(602,7502753,7502749,'ite',14.286,1),(602,7502754,7502749,'tet',14.286,1),(602,7502755,7502749,'eth',14.286,1),(602,7502756,7502749,'thr',14.286,1),(602,7502757,7502749,'hru',14.286,1),(602,7502758,7502751,'ope',11.111,2),(602,7502759,7502751,'per',11.111,2),(602,7502760,7502751,'era',11.111,2),(602,7502761,7502751,'rat',11.111,2),(602,7502762,7502751,'ati',11.111,2),(602,7502763,7502751,'tio',11.111,2),(602,7502764,7502751,'ion',11.111,2),(602,7502765,7502751,'ona',11.111,2),(602,7502766,7502751,'nal',11.111,2),(602,7502767,7502758,'pen',20,1),(602,7502768,7502758,'end',20,1),(602,7502769,7502758,'ndi',20,1),(602,7502770,7502758,'din',20,1),(602,7502771,7502758,'ing',20,1),(602,7502772,7502767,'mes',20,1),(602,7502773,7502767,'ess',20,1),(602,7502774,7502767,'ssa',20,1),(602,7502775,7502767,'sag',20,1),(602,7502776,7502767,'age',20,1),(602,7502777,7502772,'wai',20,1),(602,7502778,7502772,'ait',20,1),(602,7502779,7502772,'iti',20,1),(602,7502780,7502772,'tin',20,1),(602,7502781,7502772,'ing',20,1),(602,7502782,7502777,'for',100,1),(602,7502783,7502782,'per',11.111,1),(602,7502784,7502782,'erf',11.111,1),(602,7502785,7502782,'rfo',11.111,1),(602,7502786,7502782,'for',11.111,1),(602,7502787,7502782,'orm',11.111,1),(602,7502788,7502782,'rma',11.111,1),(602,7502789,7502782,'man',11.111,1),(602,7502790,7502782,'anc',11.111,1),(602,7502791,7502782,'nce',11.111,1),(602,7502792,7502783,'ide',12.5,1),(602,7502793,7502783,'den',12.5,1),(602,7502794,7502783,'ent',12.5,1),(602,7502795,7502783,'nti',12.5,1),(602,7502796,7502783,'tif',12.5,1),(602,7502797,7502783,'ifi',12.5,1),(602,7502798,7502783,'fie',12.5,1),(602,7502799,7502783,'ier',12.5,1),(602,7502800,7502792,'vdi',33.333,3),(602,7502801,7502792,'dis',33.333,3),(602,7502802,7502792,'isk',33.333,3),(602,7502803,7502800,'nam',50,1),(602,7502804,7502800,'ame',50,1),(602,7502805,7502803,'typ',50,1),(602,7502806,7502803,'ype',50,1),(602,7502807,7502805,'dir',25,1),(602,7502808,7502805,'ire',25,1),(602,7502809,7502805,'rec',25,1),(602,7502810,7502805,'ect',25,1),(603,7502812,7502811,'naa',100,2),(603,7502813,7502812,'600',3.333,3),(603,7502814,7502812,'000',3.333,3),(603,7502815,7502812,'00c',3.333,3),(603,7502816,7502812,'0c2',3.333,3),(603,7502817,7502812,'c29',3.333,3),(603,7502818,7502812,'293',3.333,3),(603,7502819,7502812,'934',3.333,3),(603,7502820,7502812,'34d',3.333,3),(603,7502821,7502812,'4d3',3.333,3),(603,7502822,7502812,'d39',3.333,3),(603,7502823,7502812,'393',3.333,3),(603,7502824,7502812,'93e',3.333,3),(603,7502825,7502812,'3e4',3.333,3),(603,7502826,7502812,'e43',3.333,3),(603,7502827,7502812,'432',3.333,3),(603,7502828,7502812,'324',3.333,3),(603,7502829,7502812,'24b',3.333,3),(603,7502830,7502812,'4b6',3.333,3),(603,7502831,7502812,'b62',3.333,3),(603,7502832,7502812,'621',3.333,3),(603,7502833,7502812,'21b',3.333,3),(603,7502834,7502812,'1b2',3.333,3),(603,7502835,7502812,'b20',3.333,3),(603,7502836,7502812,'201',3.333,3),(603,7502837,7502812,'01a',3.333,3),(603,7502838,7502812,'1a4',3.333,3),(603,7502839,7502812,'a4c',3.333,3),(603,7502840,7502812,'4cc',3.333,3),(603,7502841,7502812,'cc0',3.333,3),(603,7502842,7502812,'c0a',3.333,3),(603,7502843,7502813,'mon',100,1),(603,7502844,7502843,'201',50,1),(603,7502845,7502843,'013',50,1),(603,7502846,7502844,'adm',33.333,3),(603,7502847,7502844,'dmi',33.333,3),(603,7502848,7502844,'min',33.333,3),(603,7502849,7502846,'cap',16.667,1),(603,7502850,7502846,'apa',16.667,1),(603,7502851,7502846,'pac',16.667,1),(603,7502852,7502846,'aci',16.667,1),(603,7502853,7502846,'cit',16.667,1),(603,7502854,7502846,'ity',16.667,1),(603,7502855,7502849,'pat',50,1),(603,7502856,7502849,'ath',50,1),(603,7502857,7502855,'fre',14.286,1),(603,7502858,7502855,'ree',14.286,1),(603,7502859,7502855,'ees',14.286,1),(603,7502860,7502855,'esp',14.286,1),(603,7502861,7502855,'spa',14.286,1),(603,7502862,7502855,'pac',14.286,1),(603,7502863,7502855,'ace',14.286,1),(603,7502864,7502857,'dis',50,1),(603,7502865,7502857,'isk',50,1),(603,7502866,7502864,'ind',33.333,1),(603,7502867,7502864,'nde',33.333,1),(603,7502868,7502864,'dex',33.333,1),(603,7502869,7502866,'adm',8.333,1),(603,7502870,7502866,'dmi',8.333,1),(603,7502871,7502866,'min',8.333,1),(603,7502872,7502866,'ini',8.333,1),(603,7502873,7502866,'nis',8.333,1),(603,7502874,7502866,'ist',8.333,1),(603,7502875,7502866,'str',8.333,1),(603,7502876,7502866,'tra',8.333,1),(603,7502877,7502866,'rat',8.333,1),(603,7502878,7502866,'ati',8.333,1),(603,7502879,7502866,'tio',8.333,1),(603,7502880,7502866,'ion',8.333,1),(603,7502881,7502869,'sta',33.333,3),(603,7502882,7502869,'tat',33.333,3),(603,7502883,7502869,'ate',33.333,3),(603,7502884,7502881,'ena',20,2),(603,7502885,7502881,'nab',20,2),(603,7502886,7502881,'abl',20,2),(603,7502887,7502881,'ble',20,2),(603,7502888,7502881,'led',20,2),(603,7502889,7502884,'cac',33.333,2),(603,7502890,7502884,'ach',33.333,2),(603,7502891,7502884,'che',33.333,2),(603,7502892,7502889,'mod',50,1),(603,7502893,7502889,'ode',50,1),(603,7502894,7502892,'wri',14.286,1),(603,7502895,7502892,'rit',14.286,1),(603,7502896,7502892,'ite',14.286,1),(603,7502897,7502892,'tet',14.286,1),(603,7502898,7502892,'eth',14.286,1),(603,7502899,7502892,'thr',14.286,1),(603,7502900,7502892,'hru',14.286,1),(603,7502901,7502894,'ope',11.111,2),(603,7502902,7502894,'per',11.111,2),(603,7502903,7502894,'era',11.111,2),(603,7502904,7502894,'rat',11.111,2),(603,7502905,7502894,'ati',11.111,2),(603,7502906,7502894,'tio',11.111,2),(603,7502907,7502894,'ion',11.111,2),(603,7502908,7502894,'ona',11.111,2),(603,7502909,7502894,'nal',11.111,2),(603,7502910,7502901,'pen',20,1),(603,7502911,7502901,'end',20,1),(603,7502912,7502901,'ndi',20,1),(603,7502913,7502901,'din',20,1),(603,7502914,7502901,'ing',20,1),(603,7502915,7502910,'mes',20,1),(603,7502916,7502910,'ess',20,1),(603,7502917,7502910,'ssa',20,1),(603,7502918,7502910,'sag',20,1),(603,7502919,7502910,'age',20,1),(603,7502920,7502915,'wai',20,1),(603,7502921,7502915,'ait',20,1),(603,7502922,7502915,'iti',20,1),(603,7502923,7502915,'tin',20,1),(603,7502924,7502915,'ing',20,1),(603,7502925,7502920,'for',100,1),(603,7502926,7502925,'per',11.111,1),(603,7502927,7502925,'erf',11.111,1),(603,7502928,7502925,'rfo',11.111,1),(603,7502929,7502925,'for',11.111,1),(603,7502930,7502925,'orm',11.111,1),(603,7502931,7502925,'rma',11.111,1),(603,7502932,7502925,'man',11.111,1),(603,7502933,7502925,'anc',11.111,1),(603,7502934,7502925,'nce',11.111,1),(603,7502935,7502926,'ide',12.5,1),(603,7502936,7502926,'den',12.5,1),(603,7502937,7502926,'ent',12.5,1),(603,7502938,7502926,'nti',12.5,1),(603,7502939,7502926,'tif',12.5,1),(603,7502940,7502926,'ifi',12.5,1),(603,7502941,7502926,'fie',12.5,1),(603,7502942,7502926,'ier',12.5,1),(603,7502943,7502935,'vdi',33.333,3),(603,7502944,7502935,'dis',33.333,3),(603,7502945,7502935,'isk',33.333,3),(603,7502946,7502943,'nam',50,1),(603,7502947,7502943,'ame',50,1),(603,7502948,7502946,'typ',50,1),(603,7502949,7502946,'ype',50,1),(603,7502950,7502948,'dir',25,1),(603,7502951,7502948,'ire',25,1),(603,7502952,7502948,'rec',25,1),(603,7502953,7502948,'ect',25,1),(604,7502955,7502954,'naa',100,2),(604,7502956,7502955,'600',3.333,3),(604,7502957,7502955,'000',3.333,3),(604,7502958,7502955,'00c',3.333,3),(604,7502959,7502955,'0c2',3.333,3),(604,7502960,7502955,'c29',3.333,3),(604,7502961,7502955,'290',3.333,3),(604,7502962,7502955,'907',3.333,3),(604,7502963,7502955,'07e',3.333,3),(604,7502964,7502955,'7e1',3.333,3),(604,7502965,7502955,'e15',3.333,3),(604,7502966,7502955,'157',3.333,3),(604,7502967,7502955,'57e',3.333,3),(604,7502968,7502955,'7e3',3.333,3),(604,7502969,7502955,'e33',3.333,3),(604,7502970,7502955,'338',3.333,3),(604,7502971,7502955,'381',3.333,3),(604,7502972,7502955,'814',3.333,3),(604,7502973,7502955,'143',3.333,3),(604,7502974,7502955,'43d',3.333,3),(604,7502975,7502955,'3dc',3.333,3),(604,7502976,7502955,'dc2',3.333,3),(604,7502977,7502955,'c24',3.333,3),(604,7502978,7502955,'248',3.333,3),(604,7502979,7502955,'48f',3.333,3),(604,7502980,7502955,'8f1',3.333,3),(604,7502981,7502955,'f1f',3.333,3),(604,7502982,7502955,'1f2',3.333,3),(604,7502983,7502955,'f27',3.333,3),(604,7502984,7502955,'278',3.333,3),(604,7502985,7502955,'78e',3.333,3),(604,7502986,7502956,'mon',100,1),(604,7502987,7502986,'201',50,1),(604,7502988,7502986,'013',50,1),(604,7502989,7502987,'adm',33.333,3),(604,7502990,7502987,'dmi',33.333,3),(604,7502991,7502987,'min',33.333,3),(604,7502992,7502989,'cap',16.667,1),(604,7502993,7502989,'apa',16.667,1),(604,7502994,7502989,'pac',16.667,1),(604,7502995,7502989,'aci',16.667,1),(604,7502996,7502989,'cit',16.667,1),(604,7502997,7502989,'ity',16.667,1),(604,7502998,7502992,'pat',50,1),(604,7502999,7502992,'ath',50,1),(604,7503000,7502998,'fre',14.286,1),(604,7503001,7502998,'ree',14.286,1),(604,7503002,7502998,'ees',14.286,1),(604,7503003,7502998,'esp',14.286,1),(604,7503004,7502998,'spa',14.286,1),(604,7503005,7502998,'pac',14.286,1),(604,7503006,7502998,'ace',14.286,1),(604,7503007,7503000,'dis',50,1),(604,7503008,7503000,'isk',50,1),(604,7503009,7503007,'ind',33.333,1),(604,7503010,7503007,'nde',33.333,1),(604,7503011,7503007,'dex',33.333,1),(604,7503012,7503009,'adm',8.333,1),(604,7503013,7503009,'dmi',8.333,1),(604,7503014,7503009,'min',8.333,1),(604,7503015,7503009,'ini',8.333,1),(604,7503016,7503009,'nis',8.333,1),(604,7503017,7503009,'ist',8.333,1),(604,7503018,7503009,'str',8.333,1),(604,7503019,7503009,'tra',8.333,1),(604,7503020,7503009,'rat',8.333,1),(604,7503021,7503009,'ati',8.333,1),(604,7503022,7503009,'tio',8.333,1),(604,7503023,7503009,'ion',8.333,1),(604,7503024,7503012,'sta',33.333,3),(604,7503025,7503012,'tat',33.333,3),(604,7503026,7503012,'ate',33.333,3),(604,7503027,7503024,'ena',20,2),(604,7503028,7503024,'nab',20,2),(604,7503029,7503024,'abl',20,2),(604,7503030,7503024,'ble',20,2),(604,7503031,7503024,'led',20,2),(604,7503032,7503027,'cac',33.333,2),(604,7503033,7503027,'ach',33.333,2),(604,7503034,7503027,'che',33.333,2),(604,7503035,7503032,'mod',50,1),(604,7503036,7503032,'ode',50,1),(604,7503037,7503035,'wri',14.286,1),(604,7503038,7503035,'rit',14.286,1),(604,7503039,7503035,'ite',14.286,1),(604,7503040,7503035,'tet',14.286,1),(604,7503041,7503035,'eth',14.286,1),(604,7503042,7503035,'thr',14.286,1),(604,7503043,7503035,'hru',14.286,1),(604,7503044,7503037,'ope',11.111,2),(604,7503045,7503037,'per',11.111,2),(604,7503046,7503037,'era',11.111,2),(604,7503047,7503037,'rat',11.111,2),(604,7503048,7503037,'ati',11.111,2),(604,7503049,7503037,'tio',11.111,2),(604,7503050,7503037,'ion',11.111,2),(604,7503051,7503037,'ona',11.111,2),(604,7503052,7503037,'nal',11.111,2),(604,7503053,7503044,'pen',20,1),(604,7503054,7503044,'end',20,1),(604,7503055,7503044,'ndi',20,1),(604,7503056,7503044,'din',20,1),(604,7503057,7503044,'ing',20,1),(604,7503058,7503053,'mes',20,1),(604,7503059,7503053,'ess',20,1),(604,7503060,7503053,'ssa',20,1),(604,7503061,7503053,'sag',20,1),(604,7503062,7503053,'age',20,1),(604,7503063,7503058,'wai',20,1),(604,7503064,7503058,'ait',20,1),(604,7503065,7503058,'iti',20,1),(604,7503066,7503058,'tin',20,1),(604,7503067,7503058,'ing',20,1),(604,7503068,7503063,'for',100,1),(604,7503069,7503068,'per',11.111,1),(604,7503070,7503068,'erf',11.111,1),(604,7503071,7503068,'rfo',11.111,1),(604,7503072,7503068,'for',11.111,1),(604,7503073,7503068,'orm',11.111,1),(604,7503074,7503068,'rma',11.111,1),(604,7503075,7503068,'man',11.111,1),(604,7503076,7503068,'anc',11.111,1),(604,7503077,7503068,'nce',11.111,1),(604,7503078,7503069,'ide',12.5,1),(604,7503079,7503069,'den',12.5,1),(604,7503080,7503069,'ent',12.5,1),(604,7503081,7503069,'nti',12.5,1),(604,7503082,7503069,'tif',12.5,1),(604,7503083,7503069,'ifi',12.5,1),(604,7503084,7503069,'fie',12.5,1),(604,7503085,7503069,'ier',12.5,1),(604,7503086,7503078,'vdi',33.333,3),(604,7503087,7503078,'dis',33.333,3),(604,7503088,7503078,'isk',33.333,3),(604,7503089,7503086,'nam',50,1),(604,7503090,7503086,'ame',50,1),(604,7503091,7503089,'typ',50,1),(604,7503092,7503089,'ype',50,1),(604,7503093,7503091,'dir',25,1),(604,7503094,7503091,'ire',25,1),(604,7503095,7503091,'rec',25,1),(604,7503096,7503091,'ect',25,1),(605,7503098,7503097,'naa',100,2),(605,7503099,7503098,'600',3.333,3),(605,7503100,7503098,'000',3.333,3),(605,7503101,7503098,'00c',3.333,3),(605,7503102,7503098,'0c2',3.333,3),(605,7503103,7503098,'c29',3.333,3),(605,7503104,7503098,'290',3.333,3),(605,7503105,7503098,'90b',3.333,3),(605,7503106,7503098,'0be',3.333,3),(605,7503107,7503098,'bec',3.333,3),(605,7503108,7503098,'ec0',3.333,3),(605,7503109,7503098,'c05',3.333,3),(605,7503110,7503098,'05e',3.333,3),(605,7503111,7503098,'5e4',3.333,3),(605,7503112,7503098,'e4c',3.333,3),(605,7503113,7503098,'4c5',3.333,3),(605,7503114,7503098,'c53',3.333,3),(605,7503115,7503098,'53d',3.333,3),(605,7503116,7503098,'3d2',3.333,3),(605,7503117,7503098,'d26',3.333,3),(605,7503118,7503098,'26c',3.333,3),(605,7503119,7503098,'6c5',3.333,3),(605,7503120,7503098,'c59',3.333,3),(605,7503121,7503098,'595',3.333,3),(605,7503122,7503098,'95a',3.333,3),(605,7503123,7503098,'5a4',3.333,3),(605,7503124,7503098,'a45',3.333,3),(605,7503125,7503098,'450',3.333,3),(605,7503126,7503098,'50b',3.333,3),(605,7503127,7503098,'0b6',3.333,3),(605,7503128,7503098,'b64',3.333,3),(605,7503129,7503099,'mon',100,1),(605,7503130,7503129,'201',50,1),(605,7503131,7503129,'013',50,1),(605,7503132,7503130,'adm',33.333,3),(605,7503133,7503130,'dmi',33.333,3),(605,7503134,7503130,'min',33.333,3),(605,7503135,7503132,'cap',16.667,1),(605,7503136,7503132,'apa',16.667,1),(605,7503137,7503132,'pac',16.667,1),(605,7503138,7503132,'aci',16.667,1),(605,7503139,7503132,'cit',16.667,1),(605,7503140,7503132,'ity',16.667,1),(605,7503141,7503135,'pat',50,1),(605,7503142,7503135,'ath',50,1),(605,7503143,7503141,'fre',14.286,1),(605,7503144,7503141,'ree',14.286,1),(605,7503145,7503141,'ees',14.286,1),(605,7503146,7503141,'esp',14.286,1),(605,7503147,7503141,'spa',14.286,1),(605,7503148,7503141,'pac',14.286,1),(605,7503149,7503141,'ace',14.286,1),(605,7503150,7503143,'dis',50,1),(605,7503151,7503143,'isk',50,1),(605,7503152,7503150,'ind',33.333,1),(605,7503153,7503150,'nde',33.333,1),(605,7503154,7503150,'dex',33.333,1),(605,7503155,7503152,'adm',8.333,1),(605,7503156,7503152,'dmi',8.333,1),(605,7503157,7503152,'min',8.333,1),(605,7503158,7503152,'ini',8.333,1),(605,7503159,7503152,'nis',8.333,1),(605,7503160,7503152,'ist',8.333,1),(605,7503161,7503152,'str',8.333,1),(605,7503162,7503152,'tra',8.333,1),(605,7503163,7503152,'rat',8.333,1),(605,7503164,7503152,'ati',8.333,1),(605,7503165,7503152,'tio',8.333,1),(605,7503166,7503152,'ion',8.333,1),(605,7503167,7503155,'sta',33.333,3),(605,7503168,7503155,'tat',33.333,3),(605,7503169,7503155,'ate',33.333,3),(605,7503170,7503167,'ena',20,2),(605,7503171,7503167,'nab',20,2),(605,7503172,7503167,'abl',20,2),(605,7503173,7503167,'ble',20,2),(605,7503174,7503167,'led',20,2),(605,7503175,7503170,'cac',33.333,2),(605,7503176,7503170,'ach',33.333,2),(605,7503177,7503170,'che',33.333,2),(605,7503178,7503175,'mod',50,1),(605,7503179,7503175,'ode',50,1),(605,7503180,7503178,'wri',14.286,1),(605,7503181,7503178,'rit',14.286,1),(605,7503182,7503178,'ite',14.286,1),(605,7503183,7503178,'tet',14.286,1),(605,7503184,7503178,'eth',14.286,1),(605,7503185,7503178,'thr',14.286,1),(605,7503186,7503178,'hru',14.286,1),(605,7503187,7503180,'ope',11.111,2),(605,7503188,7503180,'per',11.111,2),(605,7503189,7503180,'era',11.111,2),(605,7503190,7503180,'rat',11.111,2),(605,7503191,7503180,'ati',11.111,2),(605,7503192,7503180,'tio',11.111,2),(605,7503193,7503180,'ion',11.111,2),(605,7503194,7503180,'ona',11.111,2),(605,7503195,7503180,'nal',11.111,2),(605,7503196,7503187,'pen',20,1),(605,7503197,7503187,'end',20,1),(605,7503198,7503187,'ndi',20,1),(605,7503199,7503187,'din',20,1),(605,7503200,7503187,'ing',20,1),(605,7503201,7503196,'mes',20,1),(605,7503202,7503196,'ess',20,1),(605,7503203,7503196,'ssa',20,1),(605,7503204,7503196,'sag',20,1),(605,7503205,7503196,'age',20,1),(605,7503206,7503201,'wai',20,1),(605,7503207,7503201,'ait',20,1),(605,7503208,7503201,'iti',20,1),(605,7503209,7503201,'tin',20,1),(605,7503210,7503201,'ing',20,1),(605,7503211,7503206,'for',100,1),(605,7503212,7503211,'per',11.111,1),(605,7503213,7503211,'erf',11.111,1),(605,7503214,7503211,'rfo',11.111,1),(605,7503215,7503211,'for',11.111,1),(605,7503216,7503211,'orm',11.111,1),(605,7503217,7503211,'rma',11.111,1),(605,7503218,7503211,'man',11.111,1),(605,7503219,7503211,'anc',11.111,1),(605,7503220,7503211,'nce',11.111,1),(605,7503221,7503212,'ide',12.5,1),(605,7503222,7503212,'den',12.5,1),(605,7503223,7503212,'ent',12.5,1),(605,7503224,7503212,'nti',12.5,1),(605,7503225,7503212,'tif',12.5,1),(605,7503226,7503212,'ifi',12.5,1),(605,7503227,7503212,'fie',12.5,1),(605,7503228,7503212,'ier',12.5,1),(605,7503229,7503221,'vdi',33.333,3),(605,7503230,7503221,'dis',33.333,3),(605,7503231,7503221,'isk',33.333,3),(605,7503232,7503229,'nam',50,1),(605,7503233,7503229,'ame',50,1),(605,7503234,7503232,'typ',50,1),(605,7503235,7503232,'ype',50,1),(605,7503236,7503234,'dir',25,1),(605,7503237,7503234,'ire',25,1),(605,7503238,7503234,'rec',25,1),(605,7503239,7503234,'ect',25,1),(606,7503241,7503240,'naa',100,2),(606,7503242,7503241,'600',3.333,3),(606,7503243,7503241,'000',3.333,3),(606,7503244,7503241,'00c',3.333,3),(606,7503245,7503241,'0c2',3.333,3),(606,7503246,7503241,'c29',3.333,3),(606,7503247,7503241,'29b',3.333,3),(606,7503248,7503241,'9b5',3.333,3),(606,7503249,7503241,'b5c',3.333,3),(606,7503250,7503241,'5cc',3.333,3),(606,7503251,7503241,'cc8',3.333,3),(606,7503252,7503241,'c8a',3.333,3),(606,7503253,7503241,'8a1',3.333,3),(606,7503254,7503241,'a16',3.333,3),(606,7503255,7503241,'169',3.333,3),(606,7503256,7503241,'694',3.333,3),(606,7503257,7503241,'94c',3.333,3),(606,7503258,7503241,'4cb',3.333,3),(606,7503259,7503241,'cb9',3.333,3),(606,7503260,7503241,'b91',3.333,3),(606,7503261,7503241,'91e',3.333,3),(606,7503262,7503241,'1e7',3.333,3),(606,7503263,7503241,'e78',3.333,3),(606,7503264,7503241,'785',3.333,3),(606,7503265,7503241,'854',3.333,3),(606,7503266,7503241,'54d',3.333,3),(606,7503267,7503241,'4df',3.333,3),(606,7503268,7503241,'dfe',3.333,3),(606,7503269,7503241,'fe4',3.333,3),(606,7503270,7503241,'e46',3.333,3),(606,7503271,7503241,'465',3.333,3),(606,7503272,7503242,'mon',100,1),(606,7503273,7503272,'201',50,1),(606,7503274,7503272,'013',50,1),(606,7503275,7503273,'adm',33.333,3),(606,7503276,7503273,'dmi',33.333,3),(606,7503277,7503273,'min',33.333,3),(606,7503278,7503275,'cap',16.667,1),(606,7503279,7503275,'apa',16.667,1),(606,7503280,7503275,'pac',16.667,1),(606,7503281,7503275,'aci',16.667,1),(606,7503282,7503275,'cit',16.667,1),(606,7503283,7503275,'ity',16.667,1),(606,7503284,7503278,'pat',50,1),(606,7503285,7503278,'ath',50,1),(606,7503286,7503284,'fre',14.286,1),(606,7503287,7503284,'ree',14.286,1),(606,7503288,7503284,'ees',14.286,1),(606,7503289,7503284,'esp',14.286,1),(606,7503290,7503284,'spa',14.286,1),(606,7503291,7503284,'pac',14.286,1),(606,7503292,7503284,'ace',14.286,1),(606,7503293,7503286,'dis',50,1),(606,7503294,7503286,'isk',50,1),(606,7503295,7503293,'ind',33.333,1),(606,7503296,7503293,'nde',33.333,1),(606,7503297,7503293,'dex',33.333,1),(606,7503298,7503295,'adm',8.333,1),(606,7503299,7503295,'dmi',8.333,1),(606,7503300,7503295,'min',8.333,1),(606,7503301,7503295,'ini',8.333,1),(606,7503302,7503295,'nis',8.333,1),(606,7503303,7503295,'ist',8.333,1),(606,7503304,7503295,'str',8.333,1),(606,7503305,7503295,'tra',8.333,1),(606,7503306,7503295,'rat',8.333,1),(606,7503307,7503295,'ati',8.333,1),(606,7503308,7503295,'tio',8.333,1),(606,7503309,7503295,'ion',8.333,1),(606,7503310,7503298,'sta',33.333,3),(606,7503311,7503298,'tat',33.333,3),(606,7503312,7503298,'ate',33.333,3),(606,7503313,7503310,'ena',20,2),(606,7503314,7503310,'nab',20,2),(606,7503315,7503310,'abl',20,2),(606,7503316,7503310,'ble',20,2),(606,7503317,7503310,'led',20,2),(606,7503318,7503313,'cac',33.333,2),(606,7503319,7503313,'ach',33.333,2),(606,7503320,7503313,'che',33.333,2),(606,7503321,7503318,'mod',50,1),(606,7503322,7503318,'ode',50,1),(606,7503323,7503321,'wri',14.286,1),(606,7503324,7503321,'rit',14.286,1),(606,7503325,7503321,'ite',14.286,1),(606,7503326,7503321,'tet',14.286,1),(606,7503327,7503321,'eth',14.286,1),(606,7503328,7503321,'thr',14.286,1),(606,7503329,7503321,'hru',14.286,1),(606,7503330,7503323,'ope',11.111,2),(606,7503331,7503323,'per',11.111,2),(606,7503332,7503323,'era',11.111,2),(606,7503333,7503323,'rat',11.111,2),(606,7503334,7503323,'ati',11.111,2),(606,7503335,7503323,'tio',11.111,2),(606,7503336,7503323,'ion',11.111,2),(606,7503337,7503323,'ona',11.111,2),(606,7503338,7503323,'nal',11.111,2),(606,7503339,7503330,'pen',20,1),(606,7503340,7503330,'end',20,1),(606,7503341,7503330,'ndi',20,1),(606,7503342,7503330,'din',20,1),(606,7503343,7503330,'ing',20,1),(606,7503344,7503339,'mes',20,1),(606,7503345,7503339,'ess',20,1),(606,7503346,7503339,'ssa',20,1),(606,7503347,7503339,'sag',20,1),(606,7503348,7503339,'age',20,1),(606,7503349,7503344,'wai',20,1),(606,7503350,7503344,'ait',20,1),(606,7503351,7503344,'iti',20,1),(606,7503352,7503344,'tin',20,1),(606,7503353,7503344,'ing',20,1),(606,7503354,7503349,'for',100,1),(606,7503355,7503354,'per',11.111,1),(606,7503356,7503354,'erf',11.111,1),(606,7503357,7503354,'rfo',11.111,1),(606,7503358,7503354,'for',11.111,1),(606,7503359,7503354,'orm',11.111,1),(606,7503360,7503354,'rma',11.111,1),(606,7503361,7503354,'man',11.111,1),(606,7503362,7503354,'anc',11.111,1),(606,7503363,7503354,'nce',11.111,1),(606,7503364,7503355,'ide',12.5,1),(606,7503365,7503355,'den',12.5,1),(606,7503366,7503355,'ent',12.5,1),(606,7503367,7503355,'nti',12.5,1),(606,7503368,7503355,'tif',12.5,1),(606,7503369,7503355,'ifi',12.5,1),(606,7503370,7503355,'fie',12.5,1),(606,7503371,7503355,'ier',12.5,1),(606,7503372,7503364,'vdi',33.333,3),(606,7503373,7503364,'dis',33.333,3),(606,7503374,7503364,'isk',33.333,3),(606,7503375,7503372,'nam',50,1),(606,7503376,7503372,'ame',50,1),(606,7503377,7503375,'typ',50,1),(606,7503378,7503375,'ype',50,1),(606,7503379,7503377,'dir',25,1),(606,7503380,7503377,'ire',25,1),(606,7503381,7503377,'rec',25,1),(606,7503382,7503377,'ect',25,1),(607,7503384,7503383,'naa',100,2),(607,7503385,7503384,'600',3.333,3),(607,7503386,7503384,'000',3.333,3),(607,7503387,7503384,'00c',3.333,3),(607,7503388,7503384,'0c2',3.333,3),(607,7503389,7503384,'c29',3.333,3),(607,7503390,7503384,'29f',3.333,3),(607,7503391,7503384,'9f0',3.333,3),(607,7503392,7503384,'f0c',3.333,3),(607,7503393,7503384,'0c2',3.333,3),(607,7503394,7503384,'c28',3.333,3),(607,7503395,7503384,'28d',3.333,3),(607,7503396,7503384,'8dd',3.333,3),(607,7503397,7503384,'ddf',3.333,3),(607,7503398,7503384,'df2',3.333,3),(607,7503399,7503384,'f27',3.333,3),(607,7503400,7503384,'273',3.333,3),(607,7503401,7503384,'736',3.333,3),(607,7503402,7503384,'368',3.333,3),(607,7503403,7503384,'684',3.333,3),(607,7503404,7503384,'844',3.333,3),(607,7503405,7503384,'441',3.333,3),(607,7503406,7503384,'411',3.333,3),(607,7503407,7503384,'118',3.333,3),(607,7503408,7503384,'189',3.333,3),(607,7503409,7503384,'893',3.333,3),(607,7503410,7503384,'938',3.333,3),(607,7503411,7503384,'38f',3.333,3),(607,7503412,7503384,'8fd',3.333,3),(607,7503413,7503384,'fdf',3.333,3),(607,7503414,7503384,'dfd',3.333,3),(607,7503415,7503385,'mon',100,1),(607,7503416,7503415,'201',50,1),(607,7503417,7503415,'013',50,1),(607,7503418,7503416,'adm',33.333,3),(607,7503419,7503416,'dmi',33.333,3),(607,7503420,7503416,'min',33.333,3),(607,7503421,7503418,'cap',16.667,1),(607,7503422,7503418,'apa',16.667,1),(607,7503423,7503418,'pac',16.667,1),(607,7503424,7503418,'aci',16.667,1),(607,7503425,7503418,'cit',16.667,1),(607,7503426,7503418,'ity',16.667,1),(607,7503427,7503421,'pat',50,1),(607,7503428,7503421,'ath',50,1),(607,7503429,7503427,'fre',14.286,1),(607,7503430,7503427,'ree',14.286,1),(607,7503431,7503427,'ees',14.286,1),(607,7503432,7503427,'esp',14.286,1),(607,7503433,7503427,'spa',14.286,1),(607,7503434,7503427,'pac',14.286,1),(607,7503435,7503427,'ace',14.286,1),(607,7503436,7503429,'dis',50,1),(607,7503437,7503429,'isk',50,1),(607,7503438,7503436,'ind',33.333,1),(607,7503439,7503436,'nde',33.333,1),(607,7503440,7503436,'dex',33.333,1),(607,7503441,7503438,'adm',8.333,1),(607,7503442,7503438,'dmi',8.333,1),(607,7503443,7503438,'min',8.333,1),(607,7503444,7503438,'ini',8.333,1),(607,7503445,7503438,'nis',8.333,1),(607,7503446,7503438,'ist',8.333,1),(607,7503447,7503438,'str',8.333,1),(607,7503448,7503438,'tra',8.333,1),(607,7503449,7503438,'rat',8.333,1),(607,7503450,7503438,'ati',8.333,1),(607,7503451,7503438,'tio',8.333,1),(607,7503452,7503438,'ion',8.333,1),(607,7503453,7503441,'sta',33.333,3),(607,7503454,7503441,'tat',33.333,3),(607,7503455,7503441,'ate',33.333,3),(607,7503456,7503453,'ena',20,2),(607,7503457,7503453,'nab',20,2),(607,7503458,7503453,'abl',20,2),(607,7503459,7503453,'ble',20,2),(607,7503460,7503453,'led',20,2),(607,7503461,7503456,'cac',33.333,2),(607,7503462,7503456,'ach',33.333,2),(607,7503463,7503456,'che',33.333,2),(607,7503464,7503461,'mod',50,1),(607,7503465,7503461,'ode',50,1),(607,7503466,7503464,'wri',14.286,1),(607,7503467,7503464,'rit',14.286,1),(607,7503468,7503464,'ite',14.286,1),(607,7503469,7503464,'tet',14.286,1),(607,7503470,7503464,'eth',14.286,1),(607,7503471,7503464,'thr',14.286,1),(607,7503472,7503464,'hru',14.286,1),(607,7503473,7503466,'ope',11.111,2),(607,7503474,7503466,'per',11.111,2),(607,7503475,7503466,'era',11.111,2),(607,7503476,7503466,'rat',11.111,2),(607,7503477,7503466,'ati',11.111,2),(607,7503478,7503466,'tio',11.111,2),(607,7503479,7503466,'ion',11.111,2),(607,7503480,7503466,'ona',11.111,2),(607,7503481,7503466,'nal',11.111,2),(607,7503482,7503473,'pen',20,1),(607,7503483,7503473,'end',20,1),(607,7503484,7503473,'ndi',20,1),(607,7503485,7503473,'din',20,1),(607,7503486,7503473,'ing',20,1),(607,7503487,7503482,'mes',20,1),(607,7503488,7503482,'ess',20,1),(607,7503489,7503482,'ssa',20,1),(607,7503490,7503482,'sag',20,1),(607,7503491,7503482,'age',20,1),(607,7503492,7503487,'wai',20,1),(607,7503493,7503487,'ait',20,1),(607,7503494,7503487,'iti',20,1),(607,7503495,7503487,'tin',20,1),(607,7503496,7503487,'ing',20,1),(607,7503497,7503492,'for',100,1),(607,7503498,7503497,'per',11.111,1),(607,7503499,7503497,'erf',11.111,1),(607,7503500,7503497,'rfo',11.111,1),(607,7503501,7503497,'for',11.111,1),(607,7503502,7503497,'orm',11.111,1),(607,7503503,7503497,'rma',11.111,1),(607,7503504,7503497,'man',11.111,1),(607,7503505,7503497,'anc',11.111,1),(607,7503506,7503497,'nce',11.111,1),(607,7503507,7503498,'ide',12.5,1),(607,7503508,7503498,'den',12.5,1),(607,7503509,7503498,'ent',12.5,1),(607,7503510,7503498,'nti',12.5,1),(607,7503511,7503498,'tif',12.5,1),(607,7503512,7503498,'ifi',12.5,1),(607,7503513,7503498,'fie',12.5,1),(607,7503514,7503498,'ier',12.5,1),(607,7503515,7503507,'vdi',33.333,3),(607,7503516,7503507,'dis',33.333,3),(607,7503517,7503507,'isk',33.333,3),(607,7503518,7503515,'nam',50,1),(607,7503519,7503515,'ame',50,1),(607,7503520,7503518,'typ',50,1),(607,7503521,7503518,'ype',50,1),(607,7503522,7503520,'dir',25,1),(607,7503523,7503520,'ire',25,1),(607,7503524,7503520,'rec',25,1),(607,7503525,7503520,'ect',25,1),(608,7503527,7503526,'naa',100,2),(608,7503528,7503527,'600',3.333,3),(608,7503529,7503527,'000',3.333,3),(608,7503530,7503527,'00c',3.333,3),(608,7503531,7503527,'0c2',3.333,3),(608,7503532,7503527,'c29',3.333,3),(608,7503533,7503527,'29e',3.333,3),(608,7503534,7503527,'9eb',3.333,3),(608,7503535,7503527,'eb7',3.333,3),(608,7503536,7503527,'b7a',3.333,3),(608,7503537,7503527,'7a5',3.333,3),(608,7503538,7503527,'a58',3.333,3),(608,7503539,7503527,'58a',3.333,3),(608,7503540,7503527,'8aa',3.333,3),(608,7503541,7503527,'aa7',3.333,3),(608,7503542,7503527,'a71',3.333,3),(608,7503543,7503527,'710',3.333,3),(608,7503544,7503527,'101',3.333,3),(608,7503545,7503527,'016',3.333,3),(608,7503546,7503527,'16c',3.333,3),(608,7503547,7503527,'6c9',3.333,3),(608,7503548,7503527,'c95',3.333,3),(608,7503549,7503527,'952',3.333,3),(608,7503550,7503527,'521',3.333,3),(608,7503551,7503527,'21d',3.333,3),(608,7503552,7503527,'1db',3.333,3),(608,7503553,7503527,'db7',3.333,3),(608,7503554,7503527,'b7d',3.333,3),(608,7503555,7503527,'7d3',3.333,3),(608,7503556,7503527,'d3a',3.333,3),(608,7503557,7503527,'3a6',3.333,3),(608,7503558,7503528,'mon',100,1),(608,7503559,7503558,'201',50,1),(608,7503560,7503558,'013',50,1),(608,7503561,7503559,'adm',33.333,3),(608,7503562,7503559,'dmi',33.333,3),(608,7503563,7503559,'min',33.333,3),(608,7503564,7503561,'cap',16.667,1),(608,7503565,7503561,'apa',16.667,1),(608,7503566,7503561,'pac',16.667,1),(608,7503567,7503561,'aci',16.667,1),(608,7503568,7503561,'cit',16.667,1),(608,7503569,7503561,'ity',16.667,1),(608,7503570,7503564,'pat',50,1),(608,7503571,7503564,'ath',50,1),(608,7503572,7503570,'fre',14.286,1),(608,7503573,7503570,'ree',14.286,1),(608,7503574,7503570,'ees',14.286,1),(608,7503575,7503570,'esp',14.286,1),(608,7503576,7503570,'spa',14.286,1),(608,7503577,7503570,'pac',14.286,1),(608,7503578,7503570,'ace',14.286,1),(608,7503579,7503572,'dis',50,1),(608,7503580,7503572,'isk',50,1),(608,7503581,7503579,'ind',33.333,1),(608,7503582,7503579,'nde',33.333,1),(608,7503583,7503579,'dex',33.333,1),(608,7503584,7503581,'adm',8.333,1),(608,7503585,7503581,'dmi',8.333,1),(608,7503586,7503581,'min',8.333,1),(608,7503587,7503581,'ini',8.333,1),(608,7503588,7503581,'nis',8.333,1),(608,7503589,7503581,'ist',8.333,1),(608,7503590,7503581,'str',8.333,1),(608,7503591,7503581,'tra',8.333,1),(608,7503592,7503581,'rat',8.333,1),(608,7503593,7503581,'ati',8.333,1),(608,7503594,7503581,'tio',8.333,1),(608,7503595,7503581,'ion',8.333,1),(608,7503596,7503584,'sta',33.333,3),(608,7503597,7503584,'tat',33.333,3),(608,7503598,7503584,'ate',33.333,3),(608,7503599,7503596,'ena',20,2),(608,7503600,7503596,'nab',20,2),(608,7503601,7503596,'abl',20,2),(608,7503602,7503596,'ble',20,2),(608,7503603,7503596,'led',20,2),(608,7503604,7503599,'cac',33.333,2),(608,7503605,7503599,'ach',33.333,2),(608,7503606,7503599,'che',33.333,2),(608,7503607,7503604,'mod',50,1),(608,7503608,7503604,'ode',50,1),(608,7503609,7503607,'wri',14.286,1),(608,7503610,7503607,'rit',14.286,1),(608,7503611,7503607,'ite',14.286,1),(608,7503612,7503607,'tet',14.286,1),(608,7503613,7503607,'eth',14.286,1),(608,7503614,7503607,'thr',14.286,1),(608,7503615,7503607,'hru',14.286,1),(608,7503616,7503609,'ope',11.111,2),(608,7503617,7503609,'per',11.111,2),(608,7503618,7503609,'era',11.111,2),(608,7503619,7503609,'rat',11.111,2),(608,7503620,7503609,'ati',11.111,2),(608,7503621,7503609,'tio',11.111,2),(608,7503622,7503609,'ion',11.111,2),(608,7503623,7503609,'ona',11.111,2),(608,7503624,7503609,'nal',11.111,2),(608,7503625,7503616,'pen',20,1),(608,7503626,7503616,'end',20,1),(608,7503627,7503616,'ndi',20,1),(608,7503628,7503616,'din',20,1),(608,7503629,7503616,'ing',20,1),(608,7503630,7503625,'mes',20,1),(608,7503631,7503625,'ess',20,1),(608,7503632,7503625,'ssa',20,1),(608,7503633,7503625,'sag',20,1),(608,7503634,7503625,'age',20,1),(608,7503635,7503630,'wai',20,1),(608,7503636,7503630,'ait',20,1),(608,7503637,7503630,'iti',20,1),(608,7503638,7503630,'tin',20,1),(608,7503639,7503630,'ing',20,1),(608,7503640,7503635,'for',100,1),(608,7503641,7503640,'per',11.111,1),(608,7503642,7503640,'erf',11.111,1),(608,7503643,7503640,'rfo',11.111,1),(608,7503644,7503640,'for',11.111,1),(608,7503645,7503640,'orm',11.111,1),(608,7503646,7503640,'rma',11.111,1),(608,7503647,7503640,'man',11.111,1),(608,7503648,7503640,'anc',11.111,1),(608,7503649,7503640,'nce',11.111,1),(608,7503650,7503641,'ide',12.5,1),(608,7503651,7503641,'den',12.5,1),(608,7503652,7503641,'ent',12.5,1),(608,7503653,7503641,'nti',12.5,1),(608,7503654,7503641,'tif',12.5,1),(608,7503655,7503641,'ifi',12.5,1),(608,7503656,7503641,'fie',12.5,1),(608,7503657,7503641,'ier',12.5,1),(608,7503658,7503650,'vdi',33.333,3),(608,7503659,7503650,'dis',33.333,3),(608,7503660,7503650,'isk',33.333,3),(608,7503661,7503658,'nam',50,1),(608,7503662,7503658,'ame',50,1),(608,7503663,7503661,'typ',50,1),(608,7503664,7503661,'ype',50,1),(608,7503665,7503663,'dir',25,1),(608,7503666,7503663,'ire',25,1),(608,7503667,7503663,'rec',25,1),(608,7503668,7503663,'ect',25,1),(609,7503670,7503669,'naa',100,2),(609,7503671,7503670,'600',3.333,3),(609,7503672,7503670,'000',3.333,3),(609,7503673,7503670,'00c',3.333,3),(609,7503674,7503670,'0c2',3.333,3),(609,7503675,7503670,'c29',3.333,3),(609,7503676,7503670,'298',3.333,3),(609,7503677,7503670,'986',3.333,3),(609,7503678,7503670,'866',3.333,3),(609,7503679,7503670,'669',3.333,3),(609,7503680,7503670,'695',3.333,3),(609,7503681,7503670,'95b',3.333,3),(609,7503682,7503670,'5b7',3.333,3),(609,7503683,7503670,'b7f',3.333,3),(609,7503684,7503670,'7f1',3.333,3),(609,7503685,7503670,'f12',3.333,3),(609,7503686,7503670,'12f',3.333,3),(609,7503687,7503670,'2fd',3.333,3),(609,7503688,7503670,'fd4',3.333,3),(609,7503689,7503670,'d45',3.333,3),(609,7503690,7503670,'45d',3.333,3),(609,7503691,7503670,'5d2',3.333,3),(609,7503692,7503670,'d2c',3.333,3),(609,7503693,7503670,'2c6',3.333,3),(609,7503694,7503670,'c66',3.333,3),(609,7503695,7503670,'66d',3.333,3),(609,7503696,7503670,'6d9',3.333,3),(609,7503697,7503670,'d92',3.333,3),(609,7503698,7503670,'921',3.333,3),(609,7503699,7503670,'211',3.333,3),(609,7503700,7503670,'112',3.333,3),(609,7503701,7503671,'mon',100,1),(609,7503702,7503701,'201',50,1),(609,7503703,7503701,'013',50,1),(609,7503704,7503702,'adm',33.333,3),(609,7503705,7503702,'dmi',33.333,3),(609,7503706,7503702,'min',33.333,3),(609,7503707,7503704,'cap',16.667,1),(609,7503708,7503704,'apa',16.667,1),(609,7503709,7503704,'pac',16.667,1),(609,7503710,7503704,'aci',16.667,1),(609,7503711,7503704,'cit',16.667,1),(609,7503712,7503704,'ity',16.667,1),(609,7503713,7503707,'pat',50,1),(609,7503714,7503707,'ath',50,1),(609,7503715,7503713,'fre',14.286,1),(609,7503716,7503713,'ree',14.286,1),(609,7503717,7503713,'ees',14.286,1),(609,7503718,7503713,'esp',14.286,1),(609,7503719,7503713,'spa',14.286,1),(609,7503720,7503713,'pac',14.286,1),(609,7503721,7503713,'ace',14.286,1),(609,7503722,7503715,'dis',50,1),(609,7503723,7503715,'isk',50,1),(609,7503724,7503722,'ind',33.333,1),(609,7503725,7503722,'nde',33.333,1),(609,7503726,7503722,'dex',33.333,1),(609,7503727,7503724,'adm',8.333,1),(609,7503728,7503724,'dmi',8.333,1),(609,7503729,7503724,'min',8.333,1),(609,7503730,7503724,'ini',8.333,1),(609,7503731,7503724,'nis',8.333,1),(609,7503732,7503724,'ist',8.333,1),(609,7503733,7503724,'str',8.333,1),(609,7503734,7503724,'tra',8.333,1),(609,7503735,7503724,'rat',8.333,1),(609,7503736,7503724,'ati',8.333,1),(609,7503737,7503724,'tio',8.333,1),(609,7503738,7503724,'ion',8.333,1),(609,7503739,7503727,'sta',33.333,3),(609,7503740,7503727,'tat',33.333,3),(609,7503741,7503727,'ate',33.333,3),(609,7503742,7503739,'ena',20,2),(609,7503743,7503739,'nab',20,2),(609,7503744,7503739,'abl',20,2),(609,7503745,7503739,'ble',20,2),(609,7503746,7503739,'led',20,2),(609,7503747,7503742,'cac',33.333,2),(609,7503748,7503742,'ach',33.333,2),(609,7503749,7503742,'che',33.333,2),(609,7503750,7503747,'mod',50,1),(609,7503751,7503747,'ode',50,1),(609,7503752,7503750,'wri',14.286,1),(609,7503753,7503750,'rit',14.286,1),(609,7503754,7503750,'ite',14.286,1),(609,7503755,7503750,'tet',14.286,1),(609,7503756,7503750,'eth',14.286,1),(609,7503757,7503750,'thr',14.286,1),(609,7503758,7503750,'hru',14.286,1),(609,7503759,7503752,'ope',11.111,2),(609,7503760,7503752,'per',11.111,2),(609,7503761,7503752,'era',11.111,2),(609,7503762,7503752,'rat',11.111,2),(609,7503763,7503752,'ati',11.111,2),(609,7503764,7503752,'tio',11.111,2),(609,7503765,7503752,'ion',11.111,2),(609,7503766,7503752,'ona',11.111,2),(609,7503767,7503752,'nal',11.111,2),(609,7503768,7503759,'pen',20,1),(609,7503769,7503759,'end',20,1),(609,7503770,7503759,'ndi',20,1),(609,7503771,7503759,'din',20,1),(609,7503772,7503759,'ing',20,1),(609,7503773,7503768,'mes',20,1),(609,7503774,7503768,'ess',20,1),(609,7503775,7503768,'ssa',20,1),(609,7503776,7503768,'sag',20,1),(609,7503777,7503768,'age',20,1),(609,7503778,7503773,'wai',20,1),(609,7503779,7503773,'ait',20,1),(609,7503780,7503773,'iti',20,1),(609,7503781,7503773,'tin',20,1),(609,7503782,7503773,'ing',20,1),(609,7503783,7503778,'for',100,1),(609,7503784,7503783,'per',11.111,1),(609,7503785,7503783,'erf',11.111,1),(609,7503786,7503783,'rfo',11.111,1),(609,7503787,7503783,'for',11.111,1),(609,7503788,7503783,'orm',11.111,1),(609,7503789,7503783,'rma',11.111,1),(609,7503790,7503783,'man',11.111,1),(609,7503791,7503783,'anc',11.111,1),(609,7503792,7503783,'nce',11.111,1),(609,7503793,7503784,'ide',12.5,1),(609,7503794,7503784,'den',12.5,1),(609,7503795,7503784,'ent',12.5,1),(609,7503796,7503784,'nti',12.5,1),(609,7503797,7503784,'tif',12.5,1),(609,7503798,7503784,'ifi',12.5,1),(609,7503799,7503784,'fie',12.5,1),(609,7503800,7503784,'ier',12.5,1),(609,7503801,7503793,'vdi',33.333,3),(609,7503802,7503793,'dis',33.333,3),(609,7503803,7503793,'isk',33.333,3),(609,7503804,7503801,'nam',50,1),(609,7503805,7503801,'ame',50,1),(609,7503806,7503804,'typ',50,1),(609,7503807,7503804,'ype',50,1),(609,7503808,7503806,'dir',25,1),(609,7503809,7503806,'ire',25,1),(609,7503810,7503806,'rec',25,1),(609,7503811,7503806,'ect',25,1),(610,7503813,7503812,'naa',100,2),(610,7503814,7503813,'600',3.333,3),(610,7503815,7503813,'000',3.333,3),(610,7503816,7503813,'00c',3.333,3),(610,7503817,7503813,'0c2',3.333,3),(610,7503818,7503813,'c29',3.333,3),(610,7503819,7503813,'295',3.333,3),(610,7503820,7503813,'95e',3.333,3),(610,7503821,7503813,'5e4',3.333,3),(610,7503822,7503813,'e45',3.333,3),(610,7503823,7503813,'45c',3.333,3),(610,7503824,7503813,'5c7',3.333,3),(610,7503825,7503813,'c7f',3.333,3),(610,7503826,7503813,'7f9',3.333,3),(610,7503827,7503813,'f98',3.333,3),(610,7503828,7503813,'987',3.333,3),(610,7503829,7503813,'873',3.333,3),(610,7503830,7503813,'73f',3.333,3),(610,7503831,7503813,'3f4',3.333,3),(610,7503832,7503813,'f48',3.333,3),(610,7503833,7503813,'48b',3.333,3),(610,7503834,7503813,'8b1',3.333,3),(610,7503835,7503813,'b14',3.333,3),(610,7503836,7503813,'14f',3.333,3),(610,7503837,7503813,'4fa',3.333,3),(610,7503838,7503813,'fac',3.333,3),(610,7503839,7503813,'ac7',3.333,3),(610,7503840,7503813,'c7e',3.333,3),(610,7503841,7503813,'7eb',3.333,3),(610,7503842,7503813,'eb8',3.333,3),(610,7503843,7503813,'b8d',3.333,3),(610,7503844,7503814,'mon',100,1),(610,7503845,7503844,'201',50,1),(610,7503846,7503844,'013',50,1),(610,7503847,7503845,'adm',33.333,3),(610,7503848,7503845,'dmi',33.333,3),(610,7503849,7503845,'min',33.333,3),(610,7503850,7503847,'cap',16.667,1),(610,7503851,7503847,'apa',16.667,1),(610,7503852,7503847,'pac',16.667,1),(610,7503853,7503847,'aci',16.667,1),(610,7503854,7503847,'cit',16.667,1),(610,7503855,7503847,'ity',16.667,1),(610,7503856,7503850,'pat',50,1),(610,7503857,7503850,'ath',50,1),(610,7503858,7503856,'fre',14.286,1),(610,7503859,7503856,'ree',14.286,1),(610,7503860,7503856,'ees',14.286,1),(610,7503861,7503856,'esp',14.286,1),(610,7503862,7503856,'spa',14.286,1),(610,7503863,7503856,'pac',14.286,1),(610,7503864,7503856,'ace',14.286,1),(610,7503865,7503858,'dis',50,1),(610,7503866,7503858,'isk',50,1),(610,7503867,7503865,'ind',33.333,1),(610,7503868,7503865,'nde',33.333,1),(610,7503869,7503865,'dex',33.333,1),(610,7503870,7503867,'adm',8.333,1),(610,7503871,7503867,'dmi',8.333,1),(610,7503872,7503867,'min',8.333,1),(610,7503873,7503867,'ini',8.333,1),(610,7503874,7503867,'nis',8.333,1),(610,7503875,7503867,'ist',8.333,1),(610,7503876,7503867,'str',8.333,1),(610,7503877,7503867,'tra',8.333,1),(610,7503878,7503867,'rat',8.333,1),(610,7503879,7503867,'ati',8.333,1),(610,7503880,7503867,'tio',8.333,1),(610,7503881,7503867,'ion',8.333,1),(610,7503882,7503870,'sta',33.333,3),(610,7503883,7503870,'tat',33.333,3),(610,7503884,7503870,'ate',33.333,3),(610,7503885,7503882,'ena',20,2),(610,7503886,7503882,'nab',20,2),(610,7503887,7503882,'abl',20,2),(610,7503888,7503882,'ble',20,2),(610,7503889,7503882,'led',20,2),(610,7503890,7503885,'cac',33.333,2),(610,7503891,7503885,'ach',33.333,2),(610,7503892,7503885,'che',33.333,2),(610,7503893,7503890,'mod',50,1),(610,7503894,7503890,'ode',50,1),(610,7503895,7503893,'wri',14.286,1),(610,7503896,7503893,'rit',14.286,1),(610,7503897,7503893,'ite',14.286,1),(610,7503898,7503893,'tet',14.286,1),(610,7503899,7503893,'eth',14.286,1),(610,7503900,7503893,'thr',14.286,1),(610,7503901,7503893,'hru',14.286,1),(610,7503902,7503895,'ope',11.111,2),(610,7503903,7503895,'per',11.111,2),(610,7503904,7503895,'era',11.111,2),(610,7503905,7503895,'rat',11.111,2),(610,7503906,7503895,'ati',11.111,2),(610,7503907,7503895,'tio',11.111,2),(610,7503908,7503895,'ion',11.111,2),(610,7503909,7503895,'ona',11.111,2),(610,7503910,7503895,'nal',11.111,2),(610,7503911,7503902,'pen',20,1),(610,7503912,7503902,'end',20,1),(610,7503913,7503902,'ndi',20,1),(610,7503914,7503902,'din',20,1),(610,7503915,7503902,'ing',20,1),(610,7503916,7503911,'mes',20,1),(610,7503917,7503911,'ess',20,1),(610,7503918,7503911,'ssa',20,1),(610,7503919,7503911,'sag',20,1),(610,7503920,7503911,'age',20,1),(610,7503921,7503916,'wai',20,1),(610,7503922,7503916,'ait',20,1),(610,7503923,7503916,'iti',20,1),(610,7503924,7503916,'tin',20,1),(610,7503925,7503916,'ing',20,1),(610,7503926,7503921,'for',100,1),(610,7503927,7503926,'per',11.111,1),(610,7503928,7503926,'erf',11.111,1),(610,7503929,7503926,'rfo',11.111,1),(610,7503930,7503926,'for',11.111,1),(610,7503931,7503926,'orm',11.111,1),(610,7503932,7503926,'rma',11.111,1),(610,7503933,7503926,'man',11.111,1),(610,7503934,7503926,'anc',11.111,1),(610,7503935,7503926,'nce',11.111,1),(610,7503936,7503927,'ide',12.5,1),(610,7503937,7503927,'den',12.5,1),(610,7503938,7503927,'ent',12.5,1),(610,7503939,7503927,'nti',12.5,1),(610,7503940,7503927,'tif',12.5,1),(610,7503941,7503927,'ifi',12.5,1),(610,7503942,7503927,'fie',12.5,1),(610,7503943,7503927,'ier',12.5,1),(610,7503944,7503936,'vdi',33.333,3),(610,7503945,7503936,'dis',33.333,3),(610,7503946,7503936,'isk',33.333,3),(610,7503947,7503944,'nam',50,1),(610,7503948,7503944,'ame',50,1),(610,7503949,7503947,'typ',50,1),(610,7503950,7503947,'ype',50,1),(610,7503951,7503949,'dir',25,1),(610,7503952,7503949,'ire',25,1),(610,7503953,7503949,'rec',25,1),(610,7503954,7503949,'ect',25,1),(611,7503956,7503955,'naa',100,2),(611,7503957,7503956,'600',3.333,3),(611,7503958,7503956,'000',3.333,3),(611,7503959,7503956,'00c',3.333,3),(611,7503960,7503956,'0c2',3.333,3),(611,7503961,7503956,'c29',3.333,3),(611,7503962,7503956,'291',3.333,3),(611,7503963,7503956,'91b',3.333,3),(611,7503964,7503956,'1bf',3.333,3),(611,7503965,7503956,'bf4',3.333,3),(611,7503966,7503956,'f43',3.333,3),(611,7503967,7503956,'435',3.333,3),(611,7503968,7503956,'355',3.333,3),(611,7503969,7503956,'551',3.333,3),(611,7503970,7503956,'517',3.333,3),(611,7503971,7503956,'177',3.333,3),(611,7503972,7503956,'77d',3.333,3),(611,7503973,7503956,'7dd',3.333,3),(611,7503974,7503956,'dde',3.333,3),(611,7503975,7503956,'de9',3.333,3),(611,7503976,7503956,'e92',3.333,3),(611,7503977,7503956,'924',3.333,3),(611,7503978,7503956,'242',3.333,3),(611,7503979,7503956,'42a',3.333,3),(611,7503980,7503956,'2a6',3.333,3),(611,7503981,7503956,'a67',3.333,3),(611,7503982,7503956,'672',3.333,3),(611,7503983,7503956,'720',3.333,3),(611,7503984,7503956,'202',3.333,3),(611,7503985,7503956,'026',3.333,3),(611,7503986,7503956,'26c',3.333,3),(611,7503987,7503957,'mon',100,1),(611,7503988,7503987,'201',50,1),(611,7503989,7503987,'013',50,1),(611,7503990,7503988,'adm',33.333,3),(611,7503991,7503988,'dmi',33.333,3),(611,7503992,7503988,'min',33.333,3),(611,7503993,7503990,'cap',16.667,1),(611,7503994,7503990,'apa',16.667,1),(611,7503995,7503990,'pac',16.667,1),(611,7503996,7503990,'aci',16.667,1),(611,7503997,7503990,'cit',16.667,1),(611,7503998,7503990,'ity',16.667,1),(611,7503999,7503993,'pat',50,1),(611,7504000,7503993,'ath',50,1),(611,7504001,7503999,'fre',14.286,1),(611,7504002,7503999,'ree',14.286,1),(611,7504003,7503999,'ees',14.286,1),(611,7504004,7503999,'esp',14.286,1),(611,7504005,7503999,'spa',14.286,1),(611,7504006,7503999,'pac',14.286,1),(611,7504007,7503999,'ace',14.286,1),(611,7504008,7504001,'dis',50,1),(611,7504009,7504001,'isk',50,1),(611,7504010,7504008,'ind',33.333,1),(611,7504011,7504008,'nde',33.333,1),(611,7504012,7504008,'dex',33.333,1),(611,7504013,7504010,'adm',8.333,1),(611,7504014,7504010,'dmi',8.333,1),(611,7504015,7504010,'min',8.333,1),(611,7504016,7504010,'ini',8.333,1),(611,7504017,7504010,'nis',8.333,1),(611,7504018,7504010,'ist',8.333,1),(611,7504019,7504010,'str',8.333,1),(611,7504020,7504010,'tra',8.333,1),(611,7504021,7504010,'rat',8.333,1),(611,7504022,7504010,'ati',8.333,1),(611,7504023,7504010,'tio',8.333,1),(611,7504024,7504010,'ion',8.333,1),(611,7504025,7504013,'sta',33.333,3),(611,7504026,7504013,'tat',33.333,3),(611,7504027,7504013,'ate',33.333,3),(611,7504028,7504025,'ena',20,2),(611,7504029,7504025,'nab',20,2),(611,7504030,7504025,'abl',20,2),(611,7504031,7504025,'ble',20,2),(611,7504032,7504025,'led',20,2),(611,7504033,7504028,'cac',33.333,2),(611,7504034,7504028,'ach',33.333,2),(611,7504035,7504028,'che',33.333,2),(611,7504036,7504033,'mod',50,1),(611,7504037,7504033,'ode',50,1),(611,7504038,7504036,'wri',14.286,1),(611,7504039,7504036,'rit',14.286,1),(611,7504040,7504036,'ite',14.286,1),(611,7504041,7504036,'tet',14.286,1),(611,7504042,7504036,'eth',14.286,1),(611,7504043,7504036,'thr',14.286,1),(611,7504044,7504036,'hru',14.286,1),(611,7504045,7504038,'ope',11.111,2),(611,7504046,7504038,'per',11.111,2),(611,7504047,7504038,'era',11.111,2),(611,7504048,7504038,'rat',11.111,2),(611,7504049,7504038,'ati',11.111,2),(611,7504050,7504038,'tio',11.111,2),(611,7504051,7504038,'ion',11.111,2),(611,7504052,7504038,'ona',11.111,2),(611,7504053,7504038,'nal',11.111,2),(611,7504054,7504045,'pen',20,1),(611,7504055,7504045,'end',20,1),(611,7504056,7504045,'ndi',20,1),(611,7504057,7504045,'din',20,1),(611,7504058,7504045,'ing',20,1),(611,7504059,7504054,'mes',20,1),(611,7504060,7504054,'ess',20,1),(611,7504061,7504054,'ssa',20,1),(611,7504062,7504054,'sag',20,1),(611,7504063,7504054,'age',20,1),(611,7504064,7504059,'wai',20,1),(611,7504065,7504059,'ait',20,1),(611,7504066,7504059,'iti',20,1),(611,7504067,7504059,'tin',20,1),(611,7504068,7504059,'ing',20,1),(611,7504069,7504064,'for',100,1),(611,7504070,7504069,'per',11.111,1),(611,7504071,7504069,'erf',11.111,1),(611,7504072,7504069,'rfo',11.111,1),(611,7504073,7504069,'for',11.111,1),(611,7504074,7504069,'orm',11.111,1),(611,7504075,7504069,'rma',11.111,1),(611,7504076,7504069,'man',11.111,1),(611,7504077,7504069,'anc',11.111,1),(611,7504078,7504069,'nce',11.111,1),(611,7504079,7504070,'ide',12.5,1),(611,7504080,7504070,'den',12.5,1),(611,7504081,7504070,'ent',12.5,1),(611,7504082,7504070,'nti',12.5,1),(611,7504083,7504070,'tif',12.5,1),(611,7504084,7504070,'ifi',12.5,1),(611,7504085,7504070,'fie',12.5,1),(611,7504086,7504070,'ier',12.5,1),(611,7504087,7504079,'vdi',33.333,3),(611,7504088,7504079,'dis',33.333,3),(611,7504089,7504079,'isk',33.333,3),(611,7504090,7504087,'nam',50,1),(611,7504091,7504087,'ame',50,1),(611,7504092,7504090,'typ',50,1),(611,7504093,7504090,'ype',50,1),(611,7504094,7504092,'dir',25,1),(611,7504095,7504092,'ire',25,1),(611,7504096,7504092,'rec',25,1),(611,7504097,7504092,'ect',25,1),(612,7504099,7504098,'naa',100,2),(612,7504100,7504099,'600',3.333,3),(612,7504101,7504099,'000',3.333,3),(612,7504102,7504099,'00c',3.333,3),(612,7504103,7504099,'0c2',3.333,3),(612,7504104,7504099,'c29',3.333,3),(612,7504105,7504099,'29f',3.333,3),(612,7504106,7504099,'9f8',3.333,3),(612,7504107,7504099,'f80',3.333,3),(612,7504108,7504099,'800',3.333,3),(612,7504109,7504099,'008',3.333,3),(612,7504110,7504099,'084',3.333,3),(612,7504111,7504099,'84c',3.333,3),(612,7504112,7504099,'4ce',3.333,3),(612,7504113,7504099,'ce0',3.333,3),(612,7504114,7504099,'e07',3.333,3),(612,7504115,7504099,'07e',3.333,3),(612,7504116,7504099,'7ee',3.333,3),(612,7504117,7504099,'ee9',3.333,3),(612,7504118,7504099,'e9e',3.333,3),(612,7504119,7504099,'9e4',3.333,3),(612,7504120,7504099,'e40',3.333,3),(612,7504121,7504099,'40e',3.333,3),(612,7504122,7504099,'0e3',3.333,3),(612,7504123,7504099,'e3c',3.333,3),(612,7504124,7504099,'3c5',3.333,3),(612,7504125,7504099,'c5f',3.333,3),(612,7504126,7504099,'5fb',3.333,3),(612,7504127,7504099,'fb9',3.333,3),(612,7504128,7504099,'b98',3.333,3),(612,7504129,7504099,'988',3.333,3),(612,7504130,7504100,'mon',100,1),(612,7504131,7504130,'201',50,1),(612,7504132,7504130,'013',50,1),(612,7504133,7504131,'adm',33.333,3),(612,7504134,7504131,'dmi',33.333,3),(612,7504135,7504131,'min',33.333,3),(612,7504136,7504133,'cap',16.667,1),(612,7504137,7504133,'apa',16.667,1),(612,7504138,7504133,'pac',16.667,1),(612,7504139,7504133,'aci',16.667,1),(612,7504140,7504133,'cit',16.667,1),(612,7504141,7504133,'ity',16.667,1),(612,7504142,7504136,'pat',50,1),(612,7504143,7504136,'ath',50,1),(612,7504144,7504142,'fre',14.286,1),(612,7504145,7504142,'ree',14.286,1),(612,7504146,7504142,'ees',14.286,1),(612,7504147,7504142,'esp',14.286,1),(612,7504148,7504142,'spa',14.286,1),(612,7504149,7504142,'pac',14.286,1),(612,7504150,7504142,'ace',14.286,1),(612,7504151,7504144,'dis',50,1),(612,7504152,7504144,'isk',50,1),(612,7504153,7504151,'ind',33.333,1),(612,7504154,7504151,'nde',33.333,1),(612,7504155,7504151,'dex',33.333,1),(612,7504156,7504153,'adm',8.333,1),(612,7504157,7504153,'dmi',8.333,1),(612,7504158,7504153,'min',8.333,1),(612,7504159,7504153,'ini',8.333,1),(612,7504160,7504153,'nis',8.333,1),(612,7504161,7504153,'ist',8.333,1),(612,7504162,7504153,'str',8.333,1),(612,7504163,7504153,'tra',8.333,1),(612,7504164,7504153,'rat',8.333,1),(612,7504165,7504153,'ati',8.333,1),(612,7504166,7504153,'tio',8.333,1),(612,7504167,7504153,'ion',8.333,1),(612,7504168,7504156,'sta',33.333,3),(612,7504169,7504156,'tat',33.333,3),(612,7504170,7504156,'ate',33.333,3),(612,7504171,7504168,'ena',20,2),(612,7504172,7504168,'nab',20,2),(612,7504173,7504168,'abl',20,2),(612,7504174,7504168,'ble',20,2),(612,7504175,7504168,'led',20,2),(612,7504176,7504171,'cac',33.333,2),(612,7504177,7504171,'ach',33.333,2),(612,7504178,7504171,'che',33.333,2),(612,7504179,7504176,'mod',50,1),(612,7504180,7504176,'ode',50,1),(612,7504181,7504179,'wri',14.286,1),(612,7504182,7504179,'rit',14.286,1),(612,7504183,7504179,'ite',14.286,1),(612,7504184,7504179,'tet',14.286,1),(612,7504185,7504179,'eth',14.286,1),(612,7504186,7504179,'thr',14.286,1),(612,7504187,7504179,'hru',14.286,1),(612,7504188,7504181,'ope',11.111,2),(612,7504189,7504181,'per',11.111,2),(612,7504190,7504181,'era',11.111,2),(612,7504191,7504181,'rat',11.111,2),(612,7504192,7504181,'ati',11.111,2),(612,7504193,7504181,'tio',11.111,2),(612,7504194,7504181,'ion',11.111,2),(612,7504195,7504181,'ona',11.111,2),(612,7504196,7504181,'nal',11.111,2),(612,7504197,7504188,'pen',20,1),(612,7504198,7504188,'end',20,1),(612,7504199,7504188,'ndi',20,1),(612,7504200,7504188,'din',20,1),(612,7504201,7504188,'ing',20,1),(612,7504202,7504197,'mes',20,1),(612,7504203,7504197,'ess',20,1),(612,7504204,7504197,'ssa',20,1),(612,7504205,7504197,'sag',20,1),(612,7504206,7504197,'age',20,1),(612,7504207,7504202,'wai',20,1),(612,7504208,7504202,'ait',20,1),(612,7504209,7504202,'iti',20,1),(612,7504210,7504202,'tin',20,1),(612,7504211,7504202,'ing',20,1),(612,7504212,7504207,'for',100,1),(612,7504213,7504212,'per',11.111,1),(612,7504214,7504212,'erf',11.111,1),(612,7504215,7504212,'rfo',11.111,1),(612,7504216,7504212,'for',11.111,1),(612,7504217,7504212,'orm',11.111,1),(612,7504218,7504212,'rma',11.111,1),(612,7504219,7504212,'man',11.111,1),(612,7504220,7504212,'anc',11.111,1),(612,7504221,7504212,'nce',11.111,1),(612,7504222,7504213,'ide',12.5,1),(612,7504223,7504213,'den',12.5,1),(612,7504224,7504213,'ent',12.5,1),(612,7504225,7504213,'nti',12.5,1),(612,7504226,7504213,'tif',12.5,1),(612,7504227,7504213,'ifi',12.5,1),(612,7504228,7504213,'fie',12.5,1),(612,7504229,7504213,'ier',12.5,1),(612,7504230,7504222,'vdi',33.333,3),(612,7504231,7504222,'dis',33.333,3),(612,7504232,7504222,'isk',33.333,3),(612,7504233,7504230,'nam',50,1),(612,7504234,7504230,'ame',50,1),(612,7504235,7504233,'typ',50,1),(612,7504236,7504233,'ype',50,1),(612,7504237,7504235,'dir',25,1),(612,7504238,7504235,'ire',25,1),(612,7504239,7504235,'rec',25,1),(612,7504240,7504235,'ect',25,1),(613,7504242,7504241,'naa',100,2),(613,7504243,7504242,'600',3.333,3),(613,7504244,7504242,'000',3.333,3),(613,7504245,7504242,'00c',3.333,3),(613,7504246,7504242,'0c2',3.333,3),(613,7504247,7504242,'c29',3.333,3),(613,7504248,7504242,'29a',3.333,3),(613,7504249,7504242,'9ac',3.333,3),(613,7504250,7504242,'acf',3.333,3),(613,7504251,7504242,'cff',3.333,3),(613,7504252,7504242,'ff7',3.333,3),(613,7504253,7504242,'f78',3.333,3),(613,7504254,7504242,'780',3.333,3),(613,7504255,7504242,'800',3.333,3),(613,7504256,7504242,'002',3.333,3),(613,7504257,7504242,'028',3.333,3),(613,7504258,7504242,'281',3.333,3),(613,7504259,7504242,'81e',3.333,3),(613,7504260,7504242,'1eb',3.333,3),(613,7504261,7504242,'eb8',3.333,3),(613,7504262,7504242,'b8c',3.333,3),(613,7504263,7504242,'8c0',3.333,3),(613,7504264,7504242,'c0a',3.333,3),(613,7504265,7504242,'0a1',3.333,3),(613,7504266,7504242,'a19',3.333,3),(613,7504267,7504242,'19e',3.333,3),(613,7504268,7504242,'9ec',3.333,3),(613,7504269,7504242,'ec6',3.333,3),(613,7504270,7504242,'c64',3.333,3),(613,7504271,7504242,'64a',3.333,3),(613,7504272,7504242,'4a0',3.333,3),(613,7504273,7504243,'mon',100,1),(613,7504274,7504273,'201',50,1),(613,7504275,7504273,'013',50,1),(613,7504276,7504274,'adm',33.333,3),(613,7504277,7504274,'dmi',33.333,3),(613,7504278,7504274,'min',33.333,3),(613,7504279,7504276,'cap',16.667,1),(613,7504280,7504276,'apa',16.667,1),(613,7504281,7504276,'pac',16.667,1),(613,7504282,7504276,'aci',16.667,1),(613,7504283,7504276,'cit',16.667,1),(613,7504284,7504276,'ity',16.667,1),(613,7504285,7504279,'pat',50,1),(613,7504286,7504279,'ath',50,1),(613,7504287,7504285,'fre',14.286,1),(613,7504288,7504285,'ree',14.286,1),(613,7504289,7504285,'ees',14.286,1),(613,7504290,7504285,'esp',14.286,1),(613,7504291,7504285,'spa',14.286,1),(613,7504292,7504285,'pac',14.286,1),(613,7504293,7504285,'ace',14.286,1),(613,7504294,7504287,'dis',50,1),(613,7504295,7504287,'isk',50,1),(613,7504296,7504294,'ind',33.333,1),(613,7504297,7504294,'nde',33.333,1),(613,7504298,7504294,'dex',33.333,1),(613,7504299,7504296,'adm',8.333,1),(613,7504300,7504296,'dmi',8.333,1),(613,7504301,7504296,'min',8.333,1),(613,7504302,7504296,'ini',8.333,1),(613,7504303,7504296,'nis',8.333,1),(613,7504304,7504296,'ist',8.333,1),(613,7504305,7504296,'str',8.333,1),(613,7504306,7504296,'tra',8.333,1),(613,7504307,7504296,'rat',8.333,1),(613,7504308,7504296,'ati',8.333,1),(613,7504309,7504296,'tio',8.333,1),(613,7504310,7504296,'ion',8.333,1),(613,7504311,7504299,'sta',33.333,3),(613,7504312,7504299,'tat',33.333,3),(613,7504313,7504299,'ate',33.333,3),(613,7504314,7504311,'ena',20,2),(613,7504315,7504311,'nab',20,2),(613,7504316,7504311,'abl',20,2),(613,7504317,7504311,'ble',20,2),(613,7504318,7504311,'led',20,2),(613,7504319,7504314,'cac',33.333,2),(613,7504320,7504314,'ach',33.333,2),(613,7504321,7504314,'che',33.333,2),(613,7504322,7504319,'mod',50,1),(613,7504323,7504319,'ode',50,1),(613,7504324,7504322,'wri',14.286,1),(613,7504325,7504322,'rit',14.286,1),(613,7504326,7504322,'ite',14.286,1),(613,7504327,7504322,'tet',14.286,1),(613,7504328,7504322,'eth',14.286,1),(613,7504329,7504322,'thr',14.286,1),(613,7504330,7504322,'hru',14.286,1),(613,7504331,7504324,'ope',11.111,2),(613,7504332,7504324,'per',11.111,2),(613,7504333,7504324,'era',11.111,2),(613,7504334,7504324,'rat',11.111,2),(613,7504335,7504324,'ati',11.111,2),(613,7504336,7504324,'tio',11.111,2),(613,7504337,7504324,'ion',11.111,2),(613,7504338,7504324,'ona',11.111,2),(613,7504339,7504324,'nal',11.111,2),(613,7504340,7504331,'pen',20,1),(613,7504341,7504331,'end',20,1),(613,7504342,7504331,'ndi',20,1),(613,7504343,7504331,'din',20,1),(613,7504344,7504331,'ing',20,1),(613,7504345,7504340,'mes',20,1),(613,7504346,7504340,'ess',20,1),(613,7504347,7504340,'ssa',20,1),(613,7504348,7504340,'sag',20,1),(613,7504349,7504340,'age',20,1),(613,7504350,7504345,'wai',20,1),(613,7504351,7504345,'ait',20,1),(613,7504352,7504345,'iti',20,1),(613,7504353,7504345,'tin',20,1),(613,7504354,7504345,'ing',20,1),(613,7504355,7504350,'for',100,1),(613,7504356,7504355,'per',11.111,1),(613,7504357,7504355,'erf',11.111,1),(613,7504358,7504355,'rfo',11.111,1),(613,7504359,7504355,'for',11.111,1),(613,7504360,7504355,'orm',11.111,1),(613,7504361,7504355,'rma',11.111,1),(613,7504362,7504355,'man',11.111,1),(613,7504363,7504355,'anc',11.111,1),(613,7504364,7504355,'nce',11.111,1),(613,7504365,7504356,'ide',12.5,1),(613,7504366,7504356,'den',12.5,1),(613,7504367,7504356,'ent',12.5,1),(613,7504368,7504356,'nti',12.5,1),(613,7504369,7504356,'tif',12.5,1),(613,7504370,7504356,'ifi',12.5,1),(613,7504371,7504356,'fie',12.5,1),(613,7504372,7504356,'ier',12.5,1),(613,7504373,7504365,'vdi',33.333,3),(613,7504374,7504365,'dis',33.333,3),(613,7504375,7504365,'isk',33.333,3),(613,7504376,7504373,'nam',50,1),(613,7504377,7504373,'ame',50,1),(613,7504378,7504376,'typ',50,1),(613,7504379,7504376,'ype',50,1),(613,7504380,7504378,'dir',25,1),(613,7504381,7504378,'ire',25,1),(613,7504382,7504378,'rec',25,1),(613,7504383,7504378,'ect',25,1),(614,7504385,7504384,'naa',100,2),(614,7504386,7504385,'600',3.333,3),(614,7504387,7504385,'000',3.333,3),(614,7504388,7504385,'00c',3.333,3),(614,7504389,7504385,'0c2',3.333,3),(614,7504390,7504385,'c29',3.333,3),(614,7504391,7504385,'297',3.333,3),(614,7504392,7504385,'979',3.333,3),(614,7504393,7504385,'79b',3.333,3),(614,7504394,7504385,'9b8',3.333,3),(614,7504395,7504385,'b8c',3.333,3),(614,7504396,7504385,'8cd',3.333,3),(614,7504397,7504385,'cd0',3.333,3),(614,7504398,7504385,'d0e',3.333,3),(614,7504399,7504385,'0e5',3.333,3),(614,7504400,7504385,'e54',3.333,3),(614,7504401,7504385,'544',3.333,3),(614,7504402,7504385,'447',3.333,3),(614,7504403,7504385,'47d',3.333,3),(614,7504404,7504385,'7dd',3.333,3),(614,7504405,7504385,'dd2',3.333,3),(614,7504406,7504385,'d20',3.333,3),(614,7504407,7504385,'20a',3.333,3),(614,7504408,7504385,'0a5',3.333,3),(614,7504409,7504385,'a58',3.333,3),(614,7504410,7504385,'58c',3.333,3),(614,7504411,7504385,'8ca',3.333,3),(614,7504412,7504385,'ca6',3.333,3),(614,7504413,7504385,'a69',3.333,3),(614,7504414,7504385,'69b',3.333,3),(614,7504415,7504385,'9bc',3.333,3),(614,7504416,7504386,'mon',100,1),(614,7504417,7504416,'201',50,1),(614,7504418,7504416,'013',50,1),(614,7504419,7504417,'adm',33.333,3),(614,7504420,7504417,'dmi',33.333,3),(614,7504421,7504417,'min',33.333,3),(614,7504422,7504419,'cap',16.667,1),(614,7504423,7504419,'apa',16.667,1),(614,7504424,7504419,'pac',16.667,1),(614,7504425,7504419,'aci',16.667,1),(614,7504426,7504419,'cit',16.667,1),(614,7504427,7504419,'ity',16.667,1),(614,7504428,7504422,'pat',50,1),(614,7504429,7504422,'ath',50,1),(614,7504430,7504428,'fre',14.286,1),(614,7504431,7504428,'ree',14.286,1),(614,7504432,7504428,'ees',14.286,1),(614,7504433,7504428,'esp',14.286,1),(614,7504434,7504428,'spa',14.286,1),(614,7504435,7504428,'pac',14.286,1),(614,7504436,7504428,'ace',14.286,1),(614,7504437,7504430,'dis',50,1),(614,7504438,7504430,'isk',50,1),(614,7504439,7504437,'ind',33.333,1),(614,7504440,7504437,'nde',33.333,1),(614,7504441,7504437,'dex',33.333,1),(614,7504442,7504439,'adm',8.333,1),(614,7504443,7504439,'dmi',8.333,1),(614,7504444,7504439,'min',8.333,1),(614,7504445,7504439,'ini',8.333,1),(614,7504446,7504439,'nis',8.333,1),(614,7504447,7504439,'ist',8.333,1),(614,7504448,7504439,'str',8.333,1),(614,7504449,7504439,'tra',8.333,1),(614,7504450,7504439,'rat',8.333,1),(614,7504451,7504439,'ati',8.333,1),(614,7504452,7504439,'tio',8.333,1),(614,7504453,7504439,'ion',8.333,1),(614,7504454,7504442,'sta',33.333,3),(614,7504455,7504442,'tat',33.333,3),(614,7504456,7504442,'ate',33.333,3),(614,7504457,7504454,'ena',20,2),(614,7504458,7504454,'nab',20,2),(614,7504459,7504454,'abl',20,2),(614,7504460,7504454,'ble',20,2),(614,7504461,7504454,'led',20,2),(614,7504462,7504457,'cac',33.333,2),(614,7504463,7504457,'ach',33.333,2),(614,7504464,7504457,'che',33.333,2),(614,7504465,7504462,'mod',50,1),(614,7504466,7504462,'ode',50,1),(614,7504467,7504465,'wri',14.286,1),(614,7504468,7504465,'rit',14.286,1),(614,7504469,7504465,'ite',14.286,1),(614,7504470,7504465,'tet',14.286,1),(614,7504471,7504465,'eth',14.286,1),(614,7504472,7504465,'thr',14.286,1),(614,7504473,7504465,'hru',14.286,1),(614,7504474,7504467,'ope',11.111,2),(614,7504475,7504467,'per',11.111,2),(614,7504476,7504467,'era',11.111,2),(614,7504477,7504467,'rat',11.111,2),(614,7504478,7504467,'ati',11.111,2),(614,7504479,7504467,'tio',11.111,2),(614,7504480,7504467,'ion',11.111,2),(614,7504481,7504467,'ona',11.111,2),(614,7504482,7504467,'nal',11.111,2),(614,7504483,7504474,'pen',20,1),(614,7504484,7504474,'end',20,1),(614,7504485,7504474,'ndi',20,1),(614,7504486,7504474,'din',20,1),(614,7504487,7504474,'ing',20,1),(614,7504488,7504483,'mes',20,1),(614,7504489,7504483,'ess',20,1),(614,7504490,7504483,'ssa',20,1),(614,7504491,7504483,'sag',20,1),(614,7504492,7504483,'age',20,1),(614,7504493,7504488,'wai',20,1),(614,7504494,7504488,'ait',20,1),(614,7504495,7504488,'iti',20,1),(614,7504496,7504488,'tin',20,1),(614,7504497,7504488,'ing',20,1),(614,7504498,7504493,'for',100,1),(614,7504499,7504498,'per',11.111,1),(614,7504500,7504498,'erf',11.111,1),(614,7504501,7504498,'rfo',11.111,1),(614,7504502,7504498,'for',11.111,1),(614,7504503,7504498,'orm',11.111,1),(614,7504504,7504498,'rma',11.111,1),(614,7504505,7504498,'man',11.111,1),(614,7504506,7504498,'anc',11.111,1),(614,7504507,7504498,'nce',11.111,1),(614,7504508,7504499,'ide',12.5,1),(614,7504509,7504499,'den',12.5,1),(614,7504510,7504499,'ent',12.5,1),(614,7504511,7504499,'nti',12.5,1),(614,7504512,7504499,'tif',12.5,1),(614,7504513,7504499,'ifi',12.5,1),(614,7504514,7504499,'fie',12.5,1),(614,7504515,7504499,'ier',12.5,1),(614,7504516,7504508,'vdi',33.333,3),(614,7504517,7504508,'dis',33.333,3),(614,7504518,7504508,'isk',33.333,3),(614,7504519,7504516,'nam',50,1),(614,7504520,7504516,'ame',50,1),(614,7504521,7504519,'typ',50,1),(614,7504522,7504519,'ype',50,1),(614,7504523,7504521,'dir',25,1),(614,7504524,7504521,'ire',25,1),(614,7504525,7504521,'rec',25,1),(614,7504526,7504521,'ect',25,1),(615,7504528,7504527,'naa',100,2),(615,7504529,7504528,'600',3.333,3),(615,7504530,7504528,'000',3.333,3),(615,7504531,7504528,'00c',3.333,3),(615,7504532,7504528,'0c2',3.333,3),(615,7504533,7504528,'c29',3.333,3),(615,7504534,7504528,'295',3.333,3),(615,7504535,7504528,'958',3.333,3),(615,7504536,7504528,'58d',3.333,3),(615,7504537,7504528,'8de',3.333,3),(615,7504538,7504528,'de8',3.333,3),(615,7504539,7504528,'e89',3.333,3),(615,7504540,7504528,'897',3.333,3),(615,7504541,7504528,'978',3.333,3),(615,7504542,7504528,'78e',3.333,3),(615,7504543,7504528,'8e8',3.333,3),(615,7504544,7504528,'e82',3.333,3),(615,7504545,7504528,'829',3.333,3),(615,7504546,7504528,'299',3.333,3),(615,7504547,7504528,'99a',3.333,3),(615,7504548,7504528,'9ad',3.333,3),(615,7504549,7504528,'ad3',3.333,3),(615,7504550,7504528,'d35',3.333,3),(615,7504551,7504528,'357',3.333,3),(615,7504552,7504528,'573',3.333,3),(615,7504553,7504528,'739',3.333,3),(615,7504554,7504528,'39e',3.333,3),(615,7504555,7504528,'9ed',3.333,3),(615,7504556,7504528,'ed1',3.333,3),(615,7504557,7504528,'d1a',3.333,3),(615,7504558,7504528,'1ab',3.333,3),(615,7504559,7504529,'mon',100,1),(615,7504560,7504559,'201',50,1),(615,7504561,7504559,'013',50,1),(615,7504562,7504560,'adm',33.333,3),(615,7504563,7504560,'dmi',33.333,3),(615,7504564,7504560,'min',33.333,3),(615,7504565,7504562,'cap',16.667,1),(615,7504566,7504562,'apa',16.667,1),(615,7504567,7504562,'pac',16.667,1),(615,7504568,7504562,'aci',16.667,1),(615,7504569,7504562,'cit',16.667,1),(615,7504570,7504562,'ity',16.667,1),(615,7504571,7504565,'pat',50,1),(615,7504572,7504565,'ath',50,1),(615,7504573,7504571,'fre',14.286,1),(615,7504574,7504571,'ree',14.286,1),(615,7504575,7504571,'ees',14.286,1),(615,7504576,7504571,'esp',14.286,1),(615,7504577,7504571,'spa',14.286,1),(615,7504578,7504571,'pac',14.286,1),(615,7504579,7504571,'ace',14.286,1),(615,7504580,7504573,'dis',50,1),(615,7504581,7504573,'isk',50,1),(615,7504582,7504580,'ind',33.333,1),(615,7504583,7504580,'nde',33.333,1),(615,7504584,7504580,'dex',33.333,1),(615,7504585,7504582,'adm',8.333,1),(615,7504586,7504582,'dmi',8.333,1),(615,7504587,7504582,'min',8.333,1),(615,7504588,7504582,'ini',8.333,1),(615,7504589,7504582,'nis',8.333,1),(615,7504590,7504582,'ist',8.333,1),(615,7504591,7504582,'str',8.333,1),(615,7504592,7504582,'tra',8.333,1),(615,7504593,7504582,'rat',8.333,1),(615,7504594,7504582,'ati',8.333,1),(615,7504595,7504582,'tio',8.333,1),(615,7504596,7504582,'ion',8.333,1),(615,7504597,7504585,'sta',33.333,3),(615,7504598,7504585,'tat',33.333,3),(615,7504599,7504585,'ate',33.333,3),(615,7504600,7504597,'ena',20,2),(615,7504601,7504597,'nab',20,2),(615,7504602,7504597,'abl',20,2),(615,7504603,7504597,'ble',20,2),(615,7504604,7504597,'led',20,2),(615,7504605,7504600,'cac',33.333,2),(615,7504606,7504600,'ach',33.333,2),(615,7504607,7504600,'che',33.333,2),(615,7504608,7504605,'mod',50,1),(615,7504609,7504605,'ode',50,1),(615,7504610,7504608,'wri',14.286,1),(615,7504611,7504608,'rit',14.286,1),(615,7504612,7504608,'ite',14.286,1),(615,7504613,7504608,'tet',14.286,1),(615,7504614,7504608,'eth',14.286,1),(615,7504615,7504608,'thr',14.286,1),(615,7504616,7504608,'hru',14.286,1),(615,7504617,7504610,'ope',11.111,2),(615,7504618,7504610,'per',11.111,2),(615,7504619,7504610,'era',11.111,2),(615,7504620,7504610,'rat',11.111,2),(615,7504621,7504610,'ati',11.111,2),(615,7504622,7504610,'tio',11.111,2),(615,7504623,7504610,'ion',11.111,2),(615,7504624,7504610,'ona',11.111,2),(615,7504625,7504610,'nal',11.111,2),(615,7504626,7504617,'pen',20,1),(615,7504627,7504617,'end',20,1),(615,7504628,7504617,'ndi',20,1),(615,7504629,7504617,'din',20,1),(615,7504630,7504617,'ing',20,1),(615,7504631,7504626,'mes',20,1),(615,7504632,7504626,'ess',20,1),(615,7504633,7504626,'ssa',20,1),(615,7504634,7504626,'sag',20,1),(615,7504635,7504626,'age',20,1),(615,7504636,7504631,'wai',20,1),(615,7504637,7504631,'ait',20,1),(615,7504638,7504631,'iti',20,1),(615,7504639,7504631,'tin',20,1),(615,7504640,7504631,'ing',20,1),(615,7504641,7504636,'for',100,1),(615,7504642,7504641,'per',11.111,1),(615,7504643,7504641,'erf',11.111,1),(615,7504644,7504641,'rfo',11.111,1),(615,7504645,7504641,'for',11.111,1),(615,7504646,7504641,'orm',11.111,1),(615,7504647,7504641,'rma',11.111,1),(615,7504648,7504641,'man',11.111,1),(615,7504649,7504641,'anc',11.111,1),(615,7504650,7504641,'nce',11.111,1),(615,7504651,7504642,'ide',12.5,1),(615,7504652,7504642,'den',12.5,1),(615,7504653,7504642,'ent',12.5,1),(615,7504654,7504642,'nti',12.5,1),(615,7504655,7504642,'tif',12.5,1),(615,7504656,7504642,'ifi',12.5,1),(615,7504657,7504642,'fie',12.5,1),(615,7504658,7504642,'ier',12.5,1),(615,7504659,7504651,'vdi',33.333,3),(615,7504660,7504651,'dis',33.333,3),(615,7504661,7504651,'isk',33.333,3),(615,7504662,7504659,'nam',50,1),(615,7504663,7504659,'ame',50,1),(615,7504664,7504662,'typ',50,1),(615,7504665,7504662,'ype',50,1),(615,7504666,7504664,'dir',25,1),(615,7504667,7504664,'ire',25,1),(615,7504668,7504664,'rec',25,1),(615,7504669,7504664,'ect',25,1),(616,7504671,7504670,'naa',100,2),(616,7504672,7504671,'600',3.333,3),(616,7504673,7504671,'000',3.333,3),(616,7504674,7504671,'00c',3.333,3),(616,7504675,7504671,'0c2',3.333,3),(616,7504676,7504671,'c29',3.333,3),(616,7504677,7504671,'299',3.333,3),(616,7504678,7504671,'99b',3.333,3),(616,7504679,7504671,'9be',3.333,3),(616,7504680,7504671,'bed',3.333,3),(616,7504681,7504671,'edb',3.333,3),(616,7504682,7504671,'dbe',3.333,3),(616,7504683,7504671,'bed',3.333,3),(616,7504684,7504671,'edf',3.333,3),(616,7504685,7504671,'df7',3.333,3),(616,7504686,7504671,'f75',3.333,3),(616,7504687,7504671,'75a',3.333,3),(616,7504688,7504671,'5af',3.333,3),(616,7504689,7504671,'afc',3.333,3),(616,7504690,7504671,'fce',3.333,3),(616,7504691,7504671,'ce5',3.333,3),(616,7504692,7504671,'e59',3.333,3),(616,7504693,7504671,'591',3.333,3),(616,7504694,7504671,'913',3.333,3),(616,7504695,7504671,'132',3.333,3),(616,7504696,7504671,'32f',3.333,3),(616,7504697,7504671,'2f4',3.333,3),(616,7504698,7504671,'f4e',3.333,3),(616,7504699,7504671,'4eb',3.333,3),(616,7504700,7504671,'eb9',3.333,3),(616,7504701,7504671,'b96',3.333,3),(616,7504702,7504672,'mon',100,1),(616,7504703,7504702,'201',50,1),(616,7504704,7504702,'013',50,1),(616,7504705,7504703,'adm',33.333,3),(616,7504706,7504703,'dmi',33.333,3),(616,7504707,7504703,'min',33.333,3),(616,7504708,7504705,'cap',16.667,1),(616,7504709,7504705,'apa',16.667,1),(616,7504710,7504705,'pac',16.667,1),(616,7504711,7504705,'aci',16.667,1),(616,7504712,7504705,'cit',16.667,1),(616,7504713,7504705,'ity',16.667,1),(616,7504714,7504708,'pat',50,1),(616,7504715,7504708,'ath',50,1),(616,7504716,7504714,'fre',14.286,1),(616,7504717,7504714,'ree',14.286,1),(616,7504718,7504714,'ees',14.286,1),(616,7504719,7504714,'esp',14.286,1),(616,7504720,7504714,'spa',14.286,1),(616,7504721,7504714,'pac',14.286,1),(616,7504722,7504714,'ace',14.286,1),(616,7504723,7504716,'dis',50,1),(616,7504724,7504716,'isk',50,1),(616,7504725,7504723,'ind',33.333,1),(616,7504726,7504723,'nde',33.333,1),(616,7504727,7504723,'dex',33.333,1),(616,7504728,7504725,'adm',8.333,1),(616,7504729,7504725,'dmi',8.333,1),(616,7504730,7504725,'min',8.333,1),(616,7504731,7504725,'ini',8.333,1),(616,7504732,7504725,'nis',8.333,1),(616,7504733,7504725,'ist',8.333,1),(616,7504734,7504725,'str',8.333,1),(616,7504735,7504725,'tra',8.333,1),(616,7504736,7504725,'rat',8.333,1),(616,7504737,7504725,'ati',8.333,1),(616,7504738,7504725,'tio',8.333,1),(616,7504739,7504725,'ion',8.333,1),(616,7504740,7504728,'sta',33.333,3),(616,7504741,7504728,'tat',33.333,3),(616,7504742,7504728,'ate',33.333,3),(616,7504743,7504740,'ena',20,2),(616,7504744,7504740,'nab',20,2),(616,7504745,7504740,'abl',20,2),(616,7504746,7504740,'ble',20,2),(616,7504747,7504740,'led',20,2),(616,7504748,7504743,'cac',33.333,2),(616,7504749,7504743,'ach',33.333,2),(616,7504750,7504743,'che',33.333,2),(616,7504751,7504748,'mod',50,1),(616,7504752,7504748,'ode',50,1),(616,7504753,7504751,'wri',14.286,1),(616,7504754,7504751,'rit',14.286,1),(616,7504755,7504751,'ite',14.286,1),(616,7504756,7504751,'tet',14.286,1),(616,7504757,7504751,'eth',14.286,1),(616,7504758,7504751,'thr',14.286,1),(616,7504759,7504751,'hru',14.286,1),(616,7504760,7504753,'ope',11.111,2),(616,7504761,7504753,'per',11.111,2),(616,7504762,7504753,'era',11.111,2),(616,7504763,7504753,'rat',11.111,2),(616,7504764,7504753,'ati',11.111,2),(616,7504765,7504753,'tio',11.111,2),(616,7504766,7504753,'ion',11.111,2),(616,7504767,7504753,'ona',11.111,2),(616,7504768,7504753,'nal',11.111,2),(616,7504769,7504760,'pen',20,1),(616,7504770,7504760,'end',20,1),(616,7504771,7504760,'ndi',20,1),(616,7504772,7504760,'din',20,1),(616,7504773,7504760,'ing',20,1),(616,7504774,7504769,'mes',20,1),(616,7504775,7504769,'ess',20,1),(616,7504776,7504769,'ssa',20,1),(616,7504777,7504769,'sag',20,1),(616,7504778,7504769,'age',20,1),(616,7504779,7504774,'wai',20,1),(616,7504780,7504774,'ait',20,1),(616,7504781,7504774,'iti',20,1),(616,7504782,7504774,'tin',20,1),(616,7504783,7504774,'ing',20,1),(616,7504784,7504779,'for',100,1),(616,7504785,7504784,'per',11.111,1),(616,7504786,7504784,'erf',11.111,1),(616,7504787,7504784,'rfo',11.111,1),(616,7504788,7504784,'for',11.111,1),(616,7504789,7504784,'orm',11.111,1),(616,7504790,7504784,'rma',11.111,1),(616,7504791,7504784,'man',11.111,1),(616,7504792,7504784,'anc',11.111,1),(616,7504793,7504784,'nce',11.111,1),(616,7504794,7504785,'ide',12.5,1),(616,7504795,7504785,'den',12.5,1),(616,7504796,7504785,'ent',12.5,1),(616,7504797,7504785,'nti',12.5,1),(616,7504798,7504785,'tif',12.5,1),(616,7504799,7504785,'ifi',12.5,1),(616,7504800,7504785,'fie',12.5,1),(616,7504801,7504785,'ier',12.5,1),(616,7504802,7504794,'vdi',33.333,3),(616,7504803,7504794,'dis',33.333,3),(616,7504804,7504794,'isk',33.333,3),(616,7504805,7504802,'nam',50,1),(616,7504806,7504802,'ame',50,1),(616,7504807,7504805,'typ',50,1),(616,7504808,7504805,'ype',50,1),(616,7504809,7504807,'dir',25,1),(616,7504810,7504807,'ire',25,1),(616,7504811,7504807,'rec',25,1),(616,7504812,7504807,'ect',25,1),(617,7504814,7504813,'naa',100,2),(617,7504815,7504814,'600',3.333,3),(617,7504816,7504814,'000',3.333,3),(617,7504817,7504814,'00c',3.333,3),(617,7504818,7504814,'0c2',3.333,3),(617,7504819,7504814,'c29',3.333,3),(617,7504820,7504814,'298',3.333,3),(617,7504821,7504814,'987',3.333,3),(617,7504822,7504814,'873',3.333,3),(617,7504823,7504814,'734',3.333,3),(617,7504824,7504814,'347',3.333,3),(617,7504825,7504814,'47d',3.333,3),(617,7504826,7504814,'7db',3.333,3),(617,7504827,7504814,'db6',3.333,3),(617,7504828,7504814,'b64',3.333,3),(617,7504829,7504814,'64d',3.333,3),(617,7504830,7504814,'4d3',3.333,3),(617,7504831,7504814,'d3d',3.333,3),(617,7504832,7504814,'3d6',3.333,3),(617,7504833,7504814,'d63',3.333,3),(617,7504834,7504814,'63b',3.333,3),(617,7504835,7504814,'3bc',3.333,3),(617,7504836,7504814,'bca',3.333,3),(617,7504837,7504814,'ca6',3.333,3),(617,7504838,7504814,'a6e',3.333,3),(617,7504839,7504814,'6e6',3.333,3),(617,7504840,7504814,'e6f',3.333,3),(617,7504841,7504814,'6f5',3.333,3),(617,7504842,7504814,'f5b',3.333,3),(617,7504843,7504814,'5b2',3.333,3),(617,7504844,7504814,'b20',3.333,3),(617,7504845,7504815,'mon',100,1),(617,7504846,7504845,'201',50,1),(617,7504847,7504845,'013',50,1),(617,7504848,7504846,'adm',33.333,3),(617,7504849,7504846,'dmi',33.333,3),(617,7504850,7504846,'min',33.333,3),(617,7504851,7504848,'cap',16.667,1),(617,7504852,7504848,'apa',16.667,1),(617,7504853,7504848,'pac',16.667,1),(617,7504854,7504848,'aci',16.667,1),(617,7504855,7504848,'cit',16.667,1),(617,7504856,7504848,'ity',16.667,1),(617,7504857,7504851,'pat',50,1),(617,7504858,7504851,'ath',50,1),(617,7504859,7504857,'fre',14.286,1),(617,7504860,7504857,'ree',14.286,1),(617,7504861,7504857,'ees',14.286,1),(617,7504862,7504857,'esp',14.286,1),(617,7504863,7504857,'spa',14.286,1),(617,7504864,7504857,'pac',14.286,1),(617,7504865,7504857,'ace',14.286,1),(617,7504866,7504859,'dis',50,1),(617,7504867,7504859,'isk',50,1),(617,7504868,7504866,'ind',33.333,1),(617,7504869,7504866,'nde',33.333,1),(617,7504870,7504866,'dex',33.333,1),(617,7504871,7504868,'adm',8.333,1),(617,7504872,7504868,'dmi',8.333,1),(617,7504873,7504868,'min',8.333,1),(617,7504874,7504868,'ini',8.333,1),(617,7504875,7504868,'nis',8.333,1),(617,7504876,7504868,'ist',8.333,1),(617,7504877,7504868,'str',8.333,1),(617,7504878,7504868,'tra',8.333,1),(617,7504879,7504868,'rat',8.333,1),(617,7504880,7504868,'ati',8.333,1),(617,7504881,7504868,'tio',8.333,1),(617,7504882,7504868,'ion',8.333,1),(617,7504883,7504871,'sta',33.333,3),(617,7504884,7504871,'tat',33.333,3),(617,7504885,7504871,'ate',33.333,3),(617,7504886,7504883,'ena',20,2),(617,7504887,7504883,'nab',20,2),(617,7504888,7504883,'abl',20,2),(617,7504889,7504883,'ble',20,2),(617,7504890,7504883,'led',20,2),(617,7504891,7504886,'cac',33.333,2),(617,7504892,7504886,'ach',33.333,2),(617,7504893,7504886,'che',33.333,2),(617,7504894,7504891,'mod',50,1),(617,7504895,7504891,'ode',50,1),(617,7504896,7504894,'wri',14.286,1),(617,7504897,7504894,'rit',14.286,1),(617,7504898,7504894,'ite',14.286,1),(617,7504899,7504894,'tet',14.286,1),(617,7504900,7504894,'eth',14.286,1),(617,7504901,7504894,'thr',14.286,1),(617,7504902,7504894,'hru',14.286,1),(617,7504903,7504896,'ope',11.111,2),(617,7504904,7504896,'per',11.111,2),(617,7504905,7504896,'era',11.111,2),(617,7504906,7504896,'rat',11.111,2),(617,7504907,7504896,'ati',11.111,2),(617,7504908,7504896,'tio',11.111,2),(617,7504909,7504896,'ion',11.111,2),(617,7504910,7504896,'ona',11.111,2),(617,7504911,7504896,'nal',11.111,2),(617,7504912,7504903,'pen',20,1),(617,7504913,7504903,'end',20,1),(617,7504914,7504903,'ndi',20,1),(617,7504915,7504903,'din',20,1),(617,7504916,7504903,'ing',20,1),(617,7504917,7504912,'mes',20,1),(617,7504918,7504912,'ess',20,1),(617,7504919,7504912,'ssa',20,1),(617,7504920,7504912,'sag',20,1),(617,7504921,7504912,'age',20,1),(617,7504922,7504917,'wai',20,1),(617,7504923,7504917,'ait',20,1),(617,7504924,7504917,'iti',20,1),(617,7504925,7504917,'tin',20,1),(617,7504926,7504917,'ing',20,1),(617,7504927,7504922,'for',100,1),(617,7504928,7504927,'per',11.111,1),(617,7504929,7504927,'erf',11.111,1),(617,7504930,7504927,'rfo',11.111,1),(617,7504931,7504927,'for',11.111,1),(617,7504932,7504927,'orm',11.111,1),(617,7504933,7504927,'rma',11.111,1),(617,7504934,7504927,'man',11.111,1),(617,7504935,7504927,'anc',11.111,1),(617,7504936,7504927,'nce',11.111,1),(617,7504937,7504928,'ide',12.5,1),(617,7504938,7504928,'den',12.5,1),(617,7504939,7504928,'ent',12.5,1),(617,7504940,7504928,'nti',12.5,1),(617,7504941,7504928,'tif',12.5,1),(617,7504942,7504928,'ifi',12.5,1),(617,7504943,7504928,'fie',12.5,1),(617,7504944,7504928,'ier',12.5,1),(617,7504945,7504937,'vdi',33.333,3),(617,7504946,7504937,'dis',33.333,3),(617,7504947,7504937,'isk',33.333,3),(617,7504948,7504945,'nam',50,1),(617,7504949,7504945,'ame',50,1),(617,7504950,7504948,'typ',50,1),(617,7504951,7504948,'ype',50,1),(617,7504952,7504950,'dir',25,1),(617,7504953,7504950,'ire',25,1),(617,7504954,7504950,'rec',25,1),(617,7504955,7504950,'ect',25,1),(618,7504957,7504956,'naa',100,2),(618,7504958,7504957,'600',3.333,3),(618,7504959,7504957,'000',3.333,3),(618,7504960,7504957,'00c',3.333,3),(618,7504961,7504957,'0c2',3.333,3),(618,7504962,7504957,'c29',3.333,3),(618,7504963,7504957,'294',3.333,3),(618,7504964,7504957,'94d',3.333,3),(618,7504965,7504957,'4df',3.333,3),(618,7504966,7504957,'df3',3.333,3),(618,7504967,7504957,'f32',3.333,3),(618,7504968,7504957,'32d',3.333,3),(618,7504969,7504957,'2d5',3.333,3),(618,7504970,7504957,'d51',3.333,3),(618,7504971,7504957,'51c',3.333,3),(618,7504972,7504957,'1c4',3.333,3),(618,7504973,7504957,'c47',3.333,3),(618,7504974,7504957,'477',3.333,3),(618,7504975,7504957,'77f',3.333,3),(618,7504976,7504957,'7fe',3.333,3),(618,7504977,7504957,'fe2',3.333,3),(618,7504978,7504957,'e28',3.333,3),(618,7504979,7504957,'285',3.333,3),(618,7504980,7504957,'851',3.333,3),(618,7504981,7504957,'517',3.333,3),(618,7504982,7504957,'171',3.333,3),(618,7504983,7504957,'716',3.333,3),(618,7504984,7504957,'168',3.333,3),(618,7504985,7504957,'685',3.333,3),(618,7504986,7504957,'851',3.333,3),(618,7504987,7504957,'51c',3.333,3),(618,7504988,7504958,'mon',100,1),(618,7504989,7504988,'201',50,1),(618,7504990,7504988,'013',50,1),(618,7504991,7504989,'adm',33.333,3),(618,7504992,7504989,'dmi',33.333,3),(618,7504993,7504989,'min',33.333,3),(618,7504994,7504991,'cap',16.667,1),(618,7504995,7504991,'apa',16.667,1),(618,7504996,7504991,'pac',16.667,1),(618,7504997,7504991,'aci',16.667,1),(618,7504998,7504991,'cit',16.667,1),(618,7504999,7504991,'ity',16.667,1),(618,7505000,7504994,'pat',50,1),(618,7505001,7504994,'ath',50,1),(618,7505002,7505000,'fre',14.286,1),(618,7505003,7505000,'ree',14.286,1),(618,7505004,7505000,'ees',14.286,1),(618,7505005,7505000,'esp',14.286,1),(618,7505006,7505000,'spa',14.286,1),(618,7505007,7505000,'pac',14.286,1),(618,7505008,7505000,'ace',14.286,1),(618,7505009,7505002,'dis',50,1),(618,7505010,7505002,'isk',50,1),(618,7505011,7505009,'ind',33.333,1),(618,7505012,7505009,'nde',33.333,1),(618,7505013,7505009,'dex',33.333,1),(618,7505014,7505011,'adm',8.333,1),(618,7505015,7505011,'dmi',8.333,1),(618,7505016,7505011,'min',8.333,1),(618,7505017,7505011,'ini',8.333,1),(618,7505018,7505011,'nis',8.333,1),(618,7505019,7505011,'ist',8.333,1),(618,7505020,7505011,'str',8.333,1),(618,7505021,7505011,'tra',8.333,1),(618,7505022,7505011,'rat',8.333,1),(618,7505023,7505011,'ati',8.333,1),(618,7505024,7505011,'tio',8.333,1),(618,7505025,7505011,'ion',8.333,1),(618,7505026,7505014,'sta',33.333,3),(618,7505027,7505014,'tat',33.333,3),(618,7505028,7505014,'ate',33.333,3),(618,7505029,7505026,'ena',20,2),(618,7505030,7505026,'nab',20,2),(618,7505031,7505026,'abl',20,2),(618,7505032,7505026,'ble',20,2),(618,7505033,7505026,'led',20,2),(618,7505034,7505029,'cac',33.333,2),(618,7505035,7505029,'ach',33.333,2),(618,7505036,7505029,'che',33.333,2),(618,7505037,7505034,'mod',50,1),(618,7505038,7505034,'ode',50,1),(618,7505039,7505037,'wri',14.286,1),(618,7505040,7505037,'rit',14.286,1),(618,7505041,7505037,'ite',14.286,1),(618,7505042,7505037,'tet',14.286,1),(618,7505043,7505037,'eth',14.286,1),(618,7505044,7505037,'thr',14.286,1),(618,7505045,7505037,'hru',14.286,1),(618,7505046,7505039,'ope',11.111,2),(618,7505047,7505039,'per',11.111,2),(618,7505048,7505039,'era',11.111,2),(618,7505049,7505039,'rat',11.111,2),(618,7505050,7505039,'ati',11.111,2),(618,7505051,7505039,'tio',11.111,2),(618,7505052,7505039,'ion',11.111,2),(618,7505053,7505039,'ona',11.111,2),(618,7505054,7505039,'nal',11.111,2),(618,7505055,7505046,'pen',20,1),(618,7505056,7505046,'end',20,1),(618,7505057,7505046,'ndi',20,1),(618,7505058,7505046,'din',20,1),(618,7505059,7505046,'ing',20,1),(618,7505060,7505055,'mes',20,1),(618,7505061,7505055,'ess',20,1),(618,7505062,7505055,'ssa',20,1),(618,7505063,7505055,'sag',20,1),(618,7505064,7505055,'age',20,1),(618,7505065,7505060,'wai',20,1),(618,7505066,7505060,'ait',20,1),(618,7505067,7505060,'iti',20,1),(618,7505068,7505060,'tin',20,1),(618,7505069,7505060,'ing',20,1),(618,7505070,7505065,'for',100,1),(618,7505071,7505070,'per',11.111,1),(618,7505072,7505070,'erf',11.111,1),(618,7505073,7505070,'rfo',11.111,1),(618,7505074,7505070,'for',11.111,1),(618,7505075,7505070,'orm',11.111,1),(618,7505076,7505070,'rma',11.111,1),(618,7505077,7505070,'man',11.111,1),(618,7505078,7505070,'anc',11.111,1),(618,7505079,7505070,'nce',11.111,1),(618,7505080,7505071,'ide',12.5,1),(618,7505081,7505071,'den',12.5,1),(618,7505082,7505071,'ent',12.5,1),(618,7505083,7505071,'nti',12.5,1),(618,7505084,7505071,'tif',12.5,1),(618,7505085,7505071,'ifi',12.5,1),(618,7505086,7505071,'fie',12.5,1),(618,7505087,7505071,'ier',12.5,1),(618,7505088,7505080,'vdi',33.333,3),(618,7505089,7505080,'dis',33.333,3),(618,7505090,7505080,'isk',33.333,3),(618,7505091,7505088,'nam',50,1),(618,7505092,7505088,'ame',50,1),(618,7505093,7505091,'typ',50,1),(618,7505094,7505091,'ype',50,1),(618,7505095,7505093,'dir',25,1),(618,7505096,7505093,'ire',25,1),(618,7505097,7505093,'rec',25,1),(618,7505098,7505093,'ect',25,1),(619,7505100,7505099,'naa',100,2),(619,7505101,7505100,'600',3.333,3),(619,7505102,7505100,'000',3.333,3),(619,7505103,7505100,'00c',3.333,3),(619,7505104,7505100,'0c2',3.333,3),(619,7505105,7505100,'c29',3.333,3),(619,7505106,7505100,'293',3.333,3),(619,7505107,7505100,'931',3.333,3),(619,7505108,7505100,'31e',3.333,3),(619,7505109,7505100,'1ef',3.333,3),(619,7505110,7505100,'ef6',3.333,3),(619,7505111,7505100,'f6f',3.333,3),(619,7505112,7505100,'6fc',3.333,3),(619,7505113,7505100,'fc4',3.333,3),(619,7505114,7505100,'c47',3.333,3),(619,7505115,7505100,'475',3.333,3),(619,7505116,7505100,'75f',3.333,3),(619,7505117,7505100,'5f1',3.333,3),(619,7505118,7505100,'f1b',3.333,3),(619,7505119,7505100,'1bc',3.333,3),(619,7505120,7505100,'bcb',3.333,3),(619,7505121,7505100,'cb2',3.333,3),(619,7505122,7505100,'b2a',3.333,3),(619,7505123,7505100,'2a1',3.333,3),(619,7505124,7505100,'a17',3.333,3),(619,7505125,7505100,'17b',3.333,3),(619,7505126,7505100,'7b0',3.333,3),(619,7505127,7505100,'b07',3.333,3),(619,7505128,7505100,'07e',3.333,3),(619,7505129,7505100,'7e4',3.333,3),(619,7505130,7505100,'e44',3.333,3),(619,7505131,7505101,'mon',100,1),(619,7505132,7505131,'201',50,1),(619,7505133,7505131,'013',50,1),(619,7505134,7505132,'adm',33.333,3),(619,7505135,7505132,'dmi',33.333,3),(619,7505136,7505132,'min',33.333,3),(619,7505137,7505134,'cap',16.667,1),(619,7505138,7505134,'apa',16.667,1),(619,7505139,7505134,'pac',16.667,1),(619,7505140,7505134,'aci',16.667,1),(619,7505141,7505134,'cit',16.667,1),(619,7505142,7505134,'ity',16.667,1),(619,7505143,7505137,'pat',50,1),(619,7505144,7505137,'ath',50,1),(619,7505145,7505143,'fre',14.286,1),(619,7505146,7505143,'ree',14.286,1),(619,7505147,7505143,'ees',14.286,1),(619,7505148,7505143,'esp',14.286,1),(619,7505149,7505143,'spa',14.286,1),(619,7505150,7505143,'pac',14.286,1),(619,7505151,7505143,'ace',14.286,1),(619,7505152,7505145,'dis',50,1),(619,7505153,7505145,'isk',50,1),(619,7505154,7505152,'ind',33.333,1),(619,7505155,7505152,'nde',33.333,1),(619,7505156,7505152,'dex',33.333,1),(619,7505157,7505154,'adm',8.333,1),(619,7505158,7505154,'dmi',8.333,1),(619,7505159,7505154,'min',8.333,1),(619,7505160,7505154,'ini',8.333,1),(619,7505161,7505154,'nis',8.333,1),(619,7505162,7505154,'ist',8.333,1),(619,7505163,7505154,'str',8.333,1),(619,7505164,7505154,'tra',8.333,1),(619,7505165,7505154,'rat',8.333,1),(619,7505166,7505154,'ati',8.333,1),(619,7505167,7505154,'tio',8.333,1),(619,7505168,7505154,'ion',8.333,1),(619,7505169,7505157,'sta',33.333,3),(619,7505170,7505157,'tat',33.333,3),(619,7505171,7505157,'ate',33.333,3),(619,7505172,7505169,'ena',20,2),(619,7505173,7505169,'nab',20,2),(619,7505174,7505169,'abl',20,2),(619,7505175,7505169,'ble',20,2),(619,7505176,7505169,'led',20,2),(619,7505177,7505172,'cac',33.333,2),(619,7505178,7505172,'ach',33.333,2),(619,7505179,7505172,'che',33.333,2),(619,7505180,7505177,'mod',50,1),(619,7505181,7505177,'ode',50,1),(619,7505182,7505180,'wri',14.286,1),(619,7505183,7505180,'rit',14.286,1),(619,7505184,7505180,'ite',14.286,1),(619,7505185,7505180,'tet',14.286,1),(619,7505186,7505180,'eth',14.286,1),(619,7505187,7505180,'thr',14.286,1),(619,7505188,7505180,'hru',14.286,1),(619,7505189,7505182,'ope',11.111,2),(619,7505190,7505182,'per',11.111,2),(619,7505191,7505182,'era',11.111,2),(619,7505192,7505182,'rat',11.111,2),(619,7505193,7505182,'ati',11.111,2),(619,7505194,7505182,'tio',11.111,2),(619,7505195,7505182,'ion',11.111,2),(619,7505196,7505182,'ona',11.111,2),(619,7505197,7505182,'nal',11.111,2),(619,7505198,7505189,'pen',20,1),(619,7505199,7505189,'end',20,1),(619,7505200,7505189,'ndi',20,1),(619,7505201,7505189,'din',20,1),(619,7505202,7505189,'ing',20,1),(619,7505203,7505198,'mes',20,1),(619,7505204,7505198,'ess',20,1),(619,7505205,7505198,'ssa',20,1),(619,7505206,7505198,'sag',20,1),(619,7505207,7505198,'age',20,1),(619,7505208,7505203,'wai',20,1),(619,7505209,7505203,'ait',20,1),(619,7505210,7505203,'iti',20,1),(619,7505211,7505203,'tin',20,1),(619,7505212,7505203,'ing',20,1),(619,7505213,7505208,'for',100,1),(619,7505214,7505213,'per',11.111,1),(619,7505215,7505213,'erf',11.111,1),(619,7505216,7505213,'rfo',11.111,1),(619,7505217,7505213,'for',11.111,1),(619,7505218,7505213,'orm',11.111,1),(619,7505219,7505213,'rma',11.111,1),(619,7505220,7505213,'man',11.111,1),(619,7505221,7505213,'anc',11.111,1),(619,7505222,7505213,'nce',11.111,1),(619,7505223,7505214,'ide',12.5,1),(619,7505224,7505214,'den',12.5,1),(619,7505225,7505214,'ent',12.5,1),(619,7505226,7505214,'nti',12.5,1),(619,7505227,7505214,'tif',12.5,1),(619,7505228,7505214,'ifi',12.5,1),(619,7505229,7505214,'fie',12.5,1),(619,7505230,7505214,'ier',12.5,1),(619,7505231,7505223,'vdi',33.333,3),(619,7505232,7505223,'dis',33.333,3),(619,7505233,7505223,'isk',33.333,3),(619,7505234,7505231,'nam',50,1),(619,7505235,7505231,'ame',50,1),(619,7505236,7505234,'typ',50,1),(619,7505237,7505234,'ype',50,1),(619,7505238,7505236,'dir',25,1),(619,7505239,7505236,'ire',25,1),(619,7505240,7505236,'rec',25,1),(619,7505241,7505236,'ect',25,1),(620,7505243,7505242,'naa',100,2),(620,7505244,7505243,'600',3.333,3),(620,7505245,7505243,'000',3.333,3),(620,7505246,7505243,'00c',3.333,3),(620,7505247,7505243,'0c2',3.333,3),(620,7505248,7505243,'c29',3.333,3),(620,7505249,7505243,'293',3.333,3),(620,7505250,7505243,'937',3.333,3),(620,7505251,7505243,'37b',3.333,3),(620,7505252,7505243,'7bd',3.333,3),(620,7505253,7505243,'bdd',3.333,3),(620,7505254,7505243,'dde',3.333,3),(620,7505255,7505243,'de3',3.333,3),(620,7505256,7505243,'e3b',3.333,3),(620,7505257,7505243,'3bb',3.333,3),(620,7505258,7505243,'bb9',3.333,3),(620,7505259,7505243,'b9b',3.333,3),(620,7505260,7505243,'9bc',3.333,3),(620,7505261,7505243,'bc7',3.333,3),(620,7505262,7505243,'c75',3.333,3),(620,7505263,7505243,'757',3.333,3),(620,7505264,7505243,'576',3.333,3),(620,7505265,7505243,'76d',3.333,3),(620,7505266,7505243,'6d6',3.333,3),(620,7505267,7505243,'d6f',3.333,3),(620,7505268,7505243,'6f8',3.333,3),(620,7505269,7505243,'f82',3.333,3),(620,7505270,7505243,'82a',3.333,3),(620,7505271,7505243,'2af',3.333,3),(620,7505272,7505243,'af2',3.333,3),(620,7505273,7505243,'f2b',3.333,3),(620,7505274,7505244,'mon',100,1),(620,7505275,7505274,'201',50,1),(620,7505276,7505274,'013',50,1),(620,7505277,7505275,'adm',33.333,3),(620,7505278,7505275,'dmi',33.333,3),(620,7505279,7505275,'min',33.333,3),(620,7505280,7505277,'cap',16.667,1),(620,7505281,7505277,'apa',16.667,1),(620,7505282,7505277,'pac',16.667,1),(620,7505283,7505277,'aci',16.667,1),(620,7505284,7505277,'cit',16.667,1),(620,7505285,7505277,'ity',16.667,1),(620,7505286,7505280,'pat',50,1),(620,7505287,7505280,'ath',50,1),(620,7505288,7505286,'fre',14.286,1),(620,7505289,7505286,'ree',14.286,1),(620,7505290,7505286,'ees',14.286,1),(620,7505291,7505286,'esp',14.286,1),(620,7505292,7505286,'spa',14.286,1),(620,7505293,7505286,'pac',14.286,1),(620,7505294,7505286,'ace',14.286,1),(620,7505295,7505288,'dis',50,1),(620,7505296,7505288,'isk',50,1),(620,7505297,7505295,'ind',33.333,1),(620,7505298,7505295,'nde',33.333,1),(620,7505299,7505295,'dex',33.333,1),(620,7505300,7505297,'adm',8.333,1),(620,7505301,7505297,'dmi',8.333,1),(620,7505302,7505297,'min',8.333,1),(620,7505303,7505297,'ini',8.333,1),(620,7505304,7505297,'nis',8.333,1),(620,7505305,7505297,'ist',8.333,1),(620,7505306,7505297,'str',8.333,1),(620,7505307,7505297,'tra',8.333,1),(620,7505308,7505297,'rat',8.333,1),(620,7505309,7505297,'ati',8.333,1),(620,7505310,7505297,'tio',8.333,1),(620,7505311,7505297,'ion',8.333,1),(620,7505312,7505300,'sta',33.333,3),(620,7505313,7505300,'tat',33.333,3),(620,7505314,7505300,'ate',33.333,3),(620,7505315,7505312,'ena',20,2),(620,7505316,7505312,'nab',20,2),(620,7505317,7505312,'abl',20,2),(620,7505318,7505312,'ble',20,2),(620,7505319,7505312,'led',20,2),(620,7505320,7505315,'cac',33.333,2),(620,7505321,7505315,'ach',33.333,2),(620,7505322,7505315,'che',33.333,2),(620,7505323,7505320,'mod',50,1),(620,7505324,7505320,'ode',50,1),(620,7505325,7505323,'wri',14.286,1),(620,7505326,7505323,'rit',14.286,1),(620,7505327,7505323,'ite',14.286,1),(620,7505328,7505323,'tet',14.286,1),(620,7505329,7505323,'eth',14.286,1),(620,7505330,7505323,'thr',14.286,1),(620,7505331,7505323,'hru',14.286,1),(620,7505332,7505325,'ope',11.111,2),(620,7505333,7505325,'per',11.111,2),(620,7505334,7505325,'era',11.111,2),(620,7505335,7505325,'rat',11.111,2),(620,7505336,7505325,'ati',11.111,2),(620,7505337,7505325,'tio',11.111,2),(620,7505338,7505325,'ion',11.111,2),(620,7505339,7505325,'ona',11.111,2),(620,7505340,7505325,'nal',11.111,2),(620,7505341,7505332,'pen',20,1),(620,7505342,7505332,'end',20,1),(620,7505343,7505332,'ndi',20,1),(620,7505344,7505332,'din',20,1),(620,7505345,7505332,'ing',20,1),(620,7505346,7505341,'mes',20,1),(620,7505347,7505341,'ess',20,1),(620,7505348,7505341,'ssa',20,1),(620,7505349,7505341,'sag',20,1),(620,7505350,7505341,'age',20,1),(620,7505351,7505346,'wai',20,1),(620,7505352,7505346,'ait',20,1),(620,7505353,7505346,'iti',20,1),(620,7505354,7505346,'tin',20,1),(620,7505355,7505346,'ing',20,1),(620,7505356,7505351,'for',100,1),(620,7505357,7505356,'per',11.111,1),(620,7505358,7505356,'erf',11.111,1),(620,7505359,7505356,'rfo',11.111,1),(620,7505360,7505356,'for',11.111,1),(620,7505361,7505356,'orm',11.111,1),(620,7505362,7505356,'rma',11.111,1),(620,7505363,7505356,'man',11.111,1),(620,7505364,7505356,'anc',11.111,1),(620,7505365,7505356,'nce',11.111,1),(620,7505366,7505357,'ide',12.5,1),(620,7505367,7505357,'den',12.5,1),(620,7505368,7505357,'ent',12.5,1),(620,7505369,7505357,'nti',12.5,1),(620,7505370,7505357,'tif',12.5,1),(620,7505371,7505357,'ifi',12.5,1),(620,7505372,7505357,'fie',12.5,1),(620,7505373,7505357,'ier',12.5,1),(620,7505374,7505366,'vdi',33.333,3),(620,7505375,7505366,'dis',33.333,3),(620,7505376,7505366,'isk',33.333,3),(620,7505377,7505374,'nam',50,1),(620,7505378,7505374,'ame',50,1),(620,7505379,7505377,'typ',50,1),(620,7505380,7505377,'ype',50,1),(620,7505381,7505379,'dir',25,1),(620,7505382,7505379,'ire',25,1),(620,7505383,7505379,'rec',25,1),(620,7505384,7505379,'ect',25,1),(621,7505386,7505385,'naa',100,2),(621,7505387,7505386,'600',3.333,3),(621,7505388,7505386,'000',3.333,3),(621,7505389,7505386,'00c',3.333,3),(621,7505390,7505386,'0c2',3.333,3),(621,7505391,7505386,'c29',3.333,3),(621,7505392,7505386,'290',3.333,3),(621,7505393,7505386,'90c',3.333,3),(621,7505394,7505386,'0c1',3.333,3),(621,7505395,7505386,'c1b',3.333,3),(621,7505396,7505386,'1b4',3.333,3),(621,7505397,7505386,'b46',3.333,3),(621,7505398,7505386,'465',3.333,3),(621,7505399,7505386,'652',3.333,3),(621,7505400,7505386,'52f',3.333,3),(621,7505401,7505386,'2f4',3.333,3),(621,7505402,7505386,'f44',3.333,3),(621,7505403,7505386,'44d',3.333,3),(621,7505404,7505386,'4da',3.333,3),(621,7505405,7505386,'dae',3.333,3),(621,7505406,7505386,'aeb',3.333,3),(621,7505407,7505386,'eb7',3.333,3),(621,7505408,7505386,'b75',3.333,3),(621,7505409,7505386,'751',3.333,3),(621,7505410,7505386,'51a',3.333,3),(621,7505411,7505386,'1ad',3.333,3),(621,7505412,7505386,'ad9',3.333,3),(621,7505413,7505386,'d98',3.333,3),(621,7505414,7505386,'985',3.333,3),(621,7505415,7505386,'854',3.333,3),(621,7505416,7505386,'54d',3.333,3),(621,7505417,7505387,'mon',100,1),(621,7505418,7505417,'201',50,1),(621,7505419,7505417,'013',50,1),(621,7505420,7505418,'adm',33.333,3),(621,7505421,7505418,'dmi',33.333,3),(621,7505422,7505418,'min',33.333,3),(621,7505423,7505420,'cap',16.667,1),(621,7505424,7505420,'apa',16.667,1),(621,7505425,7505420,'pac',16.667,1),(621,7505426,7505420,'aci',16.667,1),(621,7505427,7505420,'cit',16.667,1),(621,7505428,7505420,'ity',16.667,1),(621,7505429,7505423,'pat',50,1),(621,7505430,7505423,'ath',50,1),(621,7505431,7505429,'fre',14.286,1),(621,7505432,7505429,'ree',14.286,1),(621,7505433,7505429,'ees',14.286,1),(621,7505434,7505429,'esp',14.286,1),(621,7505435,7505429,'spa',14.286,1),(621,7505436,7505429,'pac',14.286,1),(621,7505437,7505429,'ace',14.286,1),(621,7505438,7505431,'dis',50,1),(621,7505439,7505431,'isk',50,1),(621,7505440,7505438,'ind',33.333,1),(621,7505441,7505438,'nde',33.333,1),(621,7505442,7505438,'dex',33.333,1),(621,7505443,7505440,'adm',8.333,1),(621,7505444,7505440,'dmi',8.333,1),(621,7505445,7505440,'min',8.333,1),(621,7505446,7505440,'ini',8.333,1),(621,7505447,7505440,'nis',8.333,1),(621,7505448,7505440,'ist',8.333,1),(621,7505449,7505440,'str',8.333,1),(621,7505450,7505440,'tra',8.333,1),(621,7505451,7505440,'rat',8.333,1),(621,7505452,7505440,'ati',8.333,1),(621,7505453,7505440,'tio',8.333,1),(621,7505454,7505440,'ion',8.333,1),(621,7505455,7505443,'sta',33.333,3),(621,7505456,7505443,'tat',33.333,3),(621,7505457,7505443,'ate',33.333,3),(621,7505458,7505455,'ena',20,2),(621,7505459,7505455,'nab',20,2),(621,7505460,7505455,'abl',20,2),(621,7505461,7505455,'ble',20,2),(621,7505462,7505455,'led',20,2),(621,7505463,7505458,'cac',33.333,2),(621,7505464,7505458,'ach',33.333,2),(621,7505465,7505458,'che',33.333,2),(621,7505466,7505463,'mod',50,1),(621,7505467,7505463,'ode',50,1),(621,7505468,7505466,'wri',14.286,1),(621,7505469,7505466,'rit',14.286,1),(621,7505470,7505466,'ite',14.286,1),(621,7505471,7505466,'tet',14.286,1),(621,7505472,7505466,'eth',14.286,1),(621,7505473,7505466,'thr',14.286,1),(621,7505474,7505466,'hru',14.286,1),(621,7505475,7505468,'ope',11.111,2),(621,7505476,7505468,'per',11.111,2),(621,7505477,7505468,'era',11.111,2),(621,7505478,7505468,'rat',11.111,2),(621,7505479,7505468,'ati',11.111,2),(621,7505480,7505468,'tio',11.111,2),(621,7505481,7505468,'ion',11.111,2),(621,7505482,7505468,'ona',11.111,2),(621,7505483,7505468,'nal',11.111,2),(621,7505484,7505475,'pen',20,1),(621,7505485,7505475,'end',20,1),(621,7505486,7505475,'ndi',20,1),(621,7505487,7505475,'din',20,1),(621,7505488,7505475,'ing',20,1),(621,7505489,7505484,'mes',20,1),(621,7505490,7505484,'ess',20,1),(621,7505491,7505484,'ssa',20,1),(621,7505492,7505484,'sag',20,1),(621,7505493,7505484,'age',20,1),(621,7505494,7505489,'wai',20,1),(621,7505495,7505489,'ait',20,1),(621,7505496,7505489,'iti',20,1),(621,7505497,7505489,'tin',20,1),(621,7505498,7505489,'ing',20,1),(621,7505499,7505494,'for',100,1),(621,7505500,7505499,'per',11.111,1),(621,7505501,7505499,'erf',11.111,1),(621,7505502,7505499,'rfo',11.111,1),(621,7505503,7505499,'for',11.111,1),(621,7505504,7505499,'orm',11.111,1),(621,7505505,7505499,'rma',11.111,1),(621,7505506,7505499,'man',11.111,1),(621,7505507,7505499,'anc',11.111,1),(621,7505508,7505499,'nce',11.111,1),(621,7505509,7505500,'ide',12.5,1),(621,7505510,7505500,'den',12.5,1),(621,7505511,7505500,'ent',12.5,1),(621,7505512,7505500,'nti',12.5,1),(621,7505513,7505500,'tif',12.5,1),(621,7505514,7505500,'ifi',12.5,1),(621,7505515,7505500,'fie',12.5,1),(621,7505516,7505500,'ier',12.5,1),(621,7505517,7505509,'vdi',33.333,3),(621,7505518,7505509,'dis',33.333,3),(621,7505519,7505509,'isk',33.333,3),(621,7505520,7505517,'nam',50,1),(621,7505521,7505517,'ame',50,1),(621,7505522,7505520,'typ',50,1),(621,7505523,7505520,'ype',50,1),(621,7505524,7505522,'dir',25,1),(621,7505525,7505522,'ire',25,1),(621,7505526,7505522,'rec',25,1),(621,7505527,7505522,'ect',25,1),(622,7505529,7505528,'naa',100,2),(622,7505530,7505529,'600',3.333,3),(622,7505531,7505529,'000',3.333,3),(622,7505532,7505529,'00c',3.333,3),(622,7505533,7505529,'0c2',3.333,3),(622,7505534,7505529,'c29',3.333,3),(622,7505535,7505529,'29e',3.333,3),(622,7505536,7505529,'9ed',3.333,3),(622,7505537,7505529,'ed0',3.333,3),(622,7505538,7505529,'d0f',3.333,3),(622,7505539,7505529,'0f8',3.333,3),(622,7505540,7505529,'f81',3.333,3),(622,7505541,7505529,'819',3.333,3),(622,7505542,7505529,'19c',3.333,3),(622,7505543,7505529,'9ca',3.333,3),(622,7505544,7505529,'ca5',3.333,3),(622,7505545,7505529,'a5a',3.333,3),(622,7505546,7505529,'5a1',3.333,3),(622,7505547,7505529,'a1e',3.333,3),(622,7505548,7505529,'1e2',3.333,3),(622,7505549,7505529,'e23',3.333,3),(622,7505550,7505529,'23b',3.333,3),(622,7505551,7505529,'3b3',3.333,3),(622,7505552,7505529,'b3c',3.333,3),(622,7505553,7505529,'3c2',3.333,3),(622,7505554,7505529,'c25',3.333,3),(622,7505555,7505529,'254',3.333,3),(622,7505556,7505529,'54c',3.333,3),(622,7505557,7505529,'4cc',3.333,3),(622,7505558,7505529,'cc4',3.333,3),(622,7505559,7505529,'c4a',3.333,3),(622,7505560,7505530,'mon',100,1),(622,7505561,7505560,'201',50,1),(622,7505562,7505560,'013',50,1),(622,7505563,7505561,'adm',33.333,3),(622,7505564,7505561,'dmi',33.333,3),(622,7505565,7505561,'min',33.333,3),(622,7505566,7505563,'cap',16.667,1),(622,7505567,7505563,'apa',16.667,1),(622,7505568,7505563,'pac',16.667,1),(622,7505569,7505563,'aci',16.667,1),(622,7505570,7505563,'cit',16.667,1),(622,7505571,7505563,'ity',16.667,1),(622,7505572,7505566,'pat',50,1),(622,7505573,7505566,'ath',50,1),(622,7505574,7505572,'fre',14.286,1),(622,7505575,7505572,'ree',14.286,1),(622,7505576,7505572,'ees',14.286,1),(622,7505577,7505572,'esp',14.286,1),(622,7505578,7505572,'spa',14.286,1),(622,7505579,7505572,'pac',14.286,1),(622,7505580,7505572,'ace',14.286,1),(622,7505581,7505574,'dis',50,1),(622,7505582,7505574,'isk',50,1),(622,7505583,7505581,'ind',33.333,1),(622,7505584,7505581,'nde',33.333,1),(622,7505585,7505581,'dex',33.333,1),(622,7505586,7505583,'adm',8.333,1),(622,7505587,7505583,'dmi',8.333,1),(622,7505588,7505583,'min',8.333,1),(622,7505589,7505583,'ini',8.333,1),(622,7505590,7505583,'nis',8.333,1),(622,7505591,7505583,'ist',8.333,1),(622,7505592,7505583,'str',8.333,1),(622,7505593,7505583,'tra',8.333,1),(622,7505594,7505583,'rat',8.333,1),(622,7505595,7505583,'ati',8.333,1),(622,7505596,7505583,'tio',8.333,1),(622,7505597,7505583,'ion',8.333,1),(622,7505598,7505586,'sta',33.333,3),(622,7505599,7505586,'tat',33.333,3),(622,7505600,7505586,'ate',33.333,3),(622,7505601,7505598,'ena',20,2),(622,7505602,7505598,'nab',20,2),(622,7505603,7505598,'abl',20,2),(622,7505604,7505598,'ble',20,2),(622,7505605,7505598,'led',20,2),(622,7505606,7505601,'cac',33.333,2),(622,7505607,7505601,'ach',33.333,2),(622,7505608,7505601,'che',33.333,2),(622,7505609,7505606,'mod',50,1),(622,7505610,7505606,'ode',50,1),(622,7505611,7505609,'wri',14.286,1),(622,7505612,7505609,'rit',14.286,1),(622,7505613,7505609,'ite',14.286,1),(622,7505614,7505609,'tet',14.286,1),(622,7505615,7505609,'eth',14.286,1),(622,7505616,7505609,'thr',14.286,1),(622,7505617,7505609,'hru',14.286,1),(622,7505618,7505611,'ope',11.111,2),(622,7505619,7505611,'per',11.111,2),(622,7505620,7505611,'era',11.111,2),(622,7505621,7505611,'rat',11.111,2),(622,7505622,7505611,'ati',11.111,2),(622,7505623,7505611,'tio',11.111,2),(622,7505624,7505611,'ion',11.111,2),(622,7505625,7505611,'ona',11.111,2),(622,7505626,7505611,'nal',11.111,2),(622,7505627,7505618,'pen',20,1),(622,7505628,7505618,'end',20,1),(622,7505629,7505618,'ndi',20,1),(622,7505630,7505618,'din',20,1),(622,7505631,7505618,'ing',20,1),(622,7505632,7505627,'mes',20,1),(622,7505633,7505627,'ess',20,1),(622,7505634,7505627,'ssa',20,1),(622,7505635,7505627,'sag',20,1),(622,7505636,7505627,'age',20,1),(622,7505637,7505632,'wai',20,1),(622,7505638,7505632,'ait',20,1),(622,7505639,7505632,'iti',20,1),(622,7505640,7505632,'tin',20,1),(622,7505641,7505632,'ing',20,1),(622,7505642,7505637,'for',100,1),(622,7505643,7505642,'per',11.111,1),(622,7505644,7505642,'erf',11.111,1),(622,7505645,7505642,'rfo',11.111,1),(622,7505646,7505642,'for',11.111,1),(622,7505647,7505642,'orm',11.111,1),(622,7505648,7505642,'rma',11.111,1),(622,7505649,7505642,'man',11.111,1),(622,7505650,7505642,'anc',11.111,1),(622,7505651,7505642,'nce',11.111,1),(622,7505652,7505643,'ide',12.5,1),(622,7505653,7505643,'den',12.5,1),(622,7505654,7505643,'ent',12.5,1),(622,7505655,7505643,'nti',12.5,1),(622,7505656,7505643,'tif',12.5,1),(622,7505657,7505643,'ifi',12.5,1),(622,7505658,7505643,'fie',12.5,1),(622,7505659,7505643,'ier',12.5,1),(622,7505660,7505652,'vdi',33.333,3),(622,7505661,7505652,'dis',33.333,3),(622,7505662,7505652,'isk',33.333,3),(622,7505663,7505660,'nam',50,1),(622,7505664,7505660,'ame',50,1),(622,7505665,7505663,'typ',50,1),(622,7505666,7505663,'ype',50,1),(622,7505667,7505665,'dir',25,1),(622,7505668,7505665,'ire',25,1),(622,7505669,7505665,'rec',25,1),(622,7505670,7505665,'ect',25,1),(623,7505672,7505671,'naa',100,2),(623,7505673,7505672,'600',3.333,3),(623,7505674,7505672,'000',3.333,3),(623,7505675,7505672,'00c',3.333,3),(623,7505676,7505672,'0c2',3.333,3),(623,7505677,7505672,'c29',3.333,3),(623,7505678,7505672,'299',3.333,3),(623,7505679,7505672,'999',3.333,3),(623,7505680,7505672,'996',3.333,3),(623,7505681,7505672,'966',3.333,3),(623,7505682,7505672,'66a',3.333,3),(623,7505683,7505672,'6a3',3.333,3),(623,7505684,7505672,'a35',3.333,3),(623,7505685,7505672,'352',3.333,3),(623,7505686,7505672,'52c',3.333,3),(623,7505687,7505672,'2c5',3.333,3),(623,7505688,7505672,'c5b',3.333,3),(623,7505689,7505672,'5bf',3.333,3),(623,7505690,7505672,'bf2',3.333,3),(623,7505691,7505672,'f24',3.333,3),(623,7505692,7505672,'244',3.333,3),(623,7505693,7505672,'44e',3.333,3),(623,7505694,7505672,'4e5',3.333,3),(623,7505695,7505672,'e5a',3.333,3),(623,7505696,7505672,'5a2',3.333,3),(623,7505697,7505672,'a26',3.333,3),(623,7505698,7505672,'267',3.333,3),(623,7505699,7505672,'672',3.333,3),(623,7505700,7505672,'720',3.333,3),(623,7505701,7505672,'20a',3.333,3),(623,7505702,7505672,'0a7',3.333,3),(623,7505703,7505673,'mon',100,1),(623,7505704,7505703,'201',50,1),(623,7505705,7505703,'013',50,1),(623,7505706,7505704,'adm',33.333,3),(623,7505707,7505704,'dmi',33.333,3),(623,7505708,7505704,'min',33.333,3),(623,7505709,7505706,'cap',16.667,1),(623,7505710,7505706,'apa',16.667,1),(623,7505711,7505706,'pac',16.667,1),(623,7505712,7505706,'aci',16.667,1),(623,7505713,7505706,'cit',16.667,1),(623,7505714,7505706,'ity',16.667,1),(623,7505715,7505709,'pat',50,1),(623,7505716,7505709,'ath',50,1),(623,7505717,7505715,'fre',14.286,1),(623,7505718,7505715,'ree',14.286,1),(623,7505719,7505715,'ees',14.286,1),(623,7505720,7505715,'esp',14.286,1),(623,7505721,7505715,'spa',14.286,1),(623,7505722,7505715,'pac',14.286,1),(623,7505723,7505715,'ace',14.286,1),(623,7505724,7505717,'dis',50,1),(623,7505725,7505717,'isk',50,1),(623,7505726,7505724,'ind',33.333,1),(623,7505727,7505724,'nde',33.333,1),(623,7505728,7505724,'dex',33.333,1),(623,7505729,7505726,'adm',8.333,1),(623,7505730,7505726,'dmi',8.333,1),(623,7505731,7505726,'min',8.333,1),(623,7505732,7505726,'ini',8.333,1),(623,7505733,7505726,'nis',8.333,1),(623,7505734,7505726,'ist',8.333,1),(623,7505735,7505726,'str',8.333,1),(623,7505736,7505726,'tra',8.333,1),(623,7505737,7505726,'rat',8.333,1),(623,7505738,7505726,'ati',8.333,1),(623,7505739,7505726,'tio',8.333,1),(623,7505740,7505726,'ion',8.333,1),(623,7505741,7505729,'sta',33.333,3),(623,7505742,7505729,'tat',33.333,3),(623,7505743,7505729,'ate',33.333,3),(623,7505744,7505741,'ena',20,2),(623,7505745,7505741,'nab',20,2),(623,7505746,7505741,'abl',20,2),(623,7505747,7505741,'ble',20,2),(623,7505748,7505741,'led',20,2),(623,7505749,7505744,'cac',33.333,2),(623,7505750,7505744,'ach',33.333,2),(623,7505751,7505744,'che',33.333,2),(623,7505752,7505749,'mod',50,1),(623,7505753,7505749,'ode',50,1),(623,7505754,7505752,'wri',14.286,1),(623,7505755,7505752,'rit',14.286,1),(623,7505756,7505752,'ite',14.286,1),(623,7505757,7505752,'tet',14.286,1),(623,7505758,7505752,'eth',14.286,1),(623,7505759,7505752,'thr',14.286,1),(623,7505760,7505752,'hru',14.286,1),(623,7505761,7505754,'ope',11.111,2),(623,7505762,7505754,'per',11.111,2),(623,7505763,7505754,'era',11.111,2),(623,7505764,7505754,'rat',11.111,2),(623,7505765,7505754,'ati',11.111,2),(623,7505766,7505754,'tio',11.111,2),(623,7505767,7505754,'ion',11.111,2),(623,7505768,7505754,'ona',11.111,2),(623,7505769,7505754,'nal',11.111,2),(623,7505770,7505761,'pen',20,1),(623,7505771,7505761,'end',20,1),(623,7505772,7505761,'ndi',20,1),(623,7505773,7505761,'din',20,1),(623,7505774,7505761,'ing',20,1),(623,7505775,7505770,'mes',20,1),(623,7505776,7505770,'ess',20,1),(623,7505777,7505770,'ssa',20,1),(623,7505778,7505770,'sag',20,1),(623,7505779,7505770,'age',20,1),(623,7505780,7505775,'wai',20,1),(623,7505781,7505775,'ait',20,1),(623,7505782,7505775,'iti',20,1),(623,7505783,7505775,'tin',20,1),(623,7505784,7505775,'ing',20,1),(623,7505785,7505780,'for',100,1),(623,7505786,7505785,'per',11.111,1),(623,7505787,7505785,'erf',11.111,1),(623,7505788,7505785,'rfo',11.111,1),(623,7505789,7505785,'for',11.111,1),(623,7505790,7505785,'orm',11.111,1),(623,7505791,7505785,'rma',11.111,1),(623,7505792,7505785,'man',11.111,1),(623,7505793,7505785,'anc',11.111,1),(623,7505794,7505785,'nce',11.111,1),(623,7505795,7505786,'ide',12.5,1),(623,7505796,7505786,'den',12.5,1),(623,7505797,7505786,'ent',12.5,1),(623,7505798,7505786,'nti',12.5,1),(623,7505799,7505786,'tif',12.5,1),(623,7505800,7505786,'ifi',12.5,1),(623,7505801,7505786,'fie',12.5,1),(623,7505802,7505786,'ier',12.5,1),(623,7505803,7505795,'vdi',33.333,3),(623,7505804,7505795,'dis',33.333,3),(623,7505805,7505795,'isk',33.333,3),(623,7505806,7505803,'nam',50,1),(623,7505807,7505803,'ame',50,1),(623,7505808,7505806,'typ',50,1),(623,7505809,7505806,'ype',50,1),(623,7505810,7505808,'dir',25,1),(623,7505811,7505808,'ire',25,1),(623,7505812,7505808,'rec',25,1),(623,7505813,7505808,'ect',25,1),(624,7505815,7505814,'naa',100,2),(624,7505816,7505815,'600',3.333,3),(624,7505817,7505815,'000',3.333,3),(624,7505818,7505815,'00c',3.333,3),(624,7505819,7505815,'0c2',3.333,3),(624,7505820,7505815,'c29',3.333,3),(624,7505821,7505815,'291',3.333,3),(624,7505822,7505815,'916',3.333,3),(624,7505823,7505815,'16e',3.333,3),(624,7505824,7505815,'6ee',3.333,3),(624,7505825,7505815,'eea',3.333,3),(624,7505826,7505815,'ea5',3.333,3),(624,7505827,7505815,'a58',3.333,3),(624,7505828,7505815,'587',3.333,3),(624,7505829,7505815,'870',3.333,3),(624,7505830,7505815,'704',3.333,3),(624,7505831,7505815,'046',3.333,3),(624,7505832,7505815,'46f',3.333,3),(624,7505833,7505815,'6f1',3.333,3),(624,7505834,7505815,'f1c',3.333,3),(624,7505835,7505815,'1c7',3.333,3),(624,7505836,7505815,'c71',3.333,3),(624,7505837,7505815,'71a',3.333,3),(624,7505838,7505815,'1a3',3.333,3),(624,7505839,7505815,'a36',3.333,3),(624,7505840,7505815,'36b',3.333,3),(624,7505841,7505815,'6be',3.333,3),(624,7505842,7505815,'be3',3.333,3),(624,7505843,7505815,'e34',3.333,3),(624,7505844,7505815,'347',3.333,3),(624,7505845,7505815,'47e',3.333,3),(624,7505846,7505816,'mon',100,1),(624,7505847,7505846,'201',50,1),(624,7505848,7505846,'013',50,1),(624,7505849,7505847,'adm',33.333,3),(624,7505850,7505847,'dmi',33.333,3),(624,7505851,7505847,'min',33.333,3),(624,7505852,7505849,'cap',16.667,1),(624,7505853,7505849,'apa',16.667,1),(624,7505854,7505849,'pac',16.667,1),(624,7505855,7505849,'aci',16.667,1),(624,7505856,7505849,'cit',16.667,1),(624,7505857,7505849,'ity',16.667,1),(624,7505858,7505852,'pat',50,1),(624,7505859,7505852,'ath',50,1),(624,7505860,7505858,'fre',14.286,1),(624,7505861,7505858,'ree',14.286,1),(624,7505862,7505858,'ees',14.286,1),(624,7505863,7505858,'esp',14.286,1),(624,7505864,7505858,'spa',14.286,1),(624,7505865,7505858,'pac',14.286,1),(624,7505866,7505858,'ace',14.286,1),(624,7505867,7505860,'dis',50,1),(624,7505868,7505860,'isk',50,1),(624,7505869,7505867,'ind',33.333,1),(624,7505870,7505867,'nde',33.333,1),(624,7505871,7505867,'dex',33.333,1),(624,7505872,7505869,'adm',8.333,1),(624,7505873,7505869,'dmi',8.333,1),(624,7505874,7505869,'min',8.333,1),(624,7505875,7505869,'ini',8.333,1),(624,7505876,7505869,'nis',8.333,1),(624,7505877,7505869,'ist',8.333,1),(624,7505878,7505869,'str',8.333,1),(624,7505879,7505869,'tra',8.333,1),(624,7505880,7505869,'rat',8.333,1),(624,7505881,7505869,'ati',8.333,1),(624,7505882,7505869,'tio',8.333,1),(624,7505883,7505869,'ion',8.333,1),(624,7505884,7505872,'sta',33.333,3),(624,7505885,7505872,'tat',33.333,3),(624,7505886,7505872,'ate',33.333,3),(624,7505887,7505884,'ena',20,2),(624,7505888,7505884,'nab',20,2),(624,7505889,7505884,'abl',20,2),(624,7505890,7505884,'ble',20,2),(624,7505891,7505884,'led',20,2),(624,7505892,7505887,'cac',33.333,2),(624,7505893,7505887,'ach',33.333,2),(624,7505894,7505887,'che',33.333,2),(624,7505895,7505892,'mod',50,1),(624,7505896,7505892,'ode',50,1),(624,7505897,7505895,'wri',14.286,1),(624,7505898,7505895,'rit',14.286,1),(624,7505899,7505895,'ite',14.286,1),(624,7505900,7505895,'tet',14.286,1),(624,7505901,7505895,'eth',14.286,1),(624,7505902,7505895,'thr',14.286,1),(624,7505903,7505895,'hru',14.286,1),(624,7505904,7505897,'ope',11.111,2),(624,7505905,7505897,'per',11.111,2),(624,7505906,7505897,'era',11.111,2),(624,7505907,7505897,'rat',11.111,2),(624,7505908,7505897,'ati',11.111,2),(624,7505909,7505897,'tio',11.111,2),(624,7505910,7505897,'ion',11.111,2),(624,7505911,7505897,'ona',11.111,2),(624,7505912,7505897,'nal',11.111,2),(624,7505913,7505904,'pen',20,1),(624,7505914,7505904,'end',20,1),(624,7505915,7505904,'ndi',20,1),(624,7505916,7505904,'din',20,1),(624,7505917,7505904,'ing',20,1),(624,7505918,7505913,'mes',20,1),(624,7505919,7505913,'ess',20,1),(624,7505920,7505913,'ssa',20,1),(624,7505921,7505913,'sag',20,1),(624,7505922,7505913,'age',20,1),(624,7505923,7505918,'wai',20,1),(624,7505924,7505918,'ait',20,1),(624,7505925,7505918,'iti',20,1),(624,7505926,7505918,'tin',20,1),(624,7505927,7505918,'ing',20,1),(624,7505928,7505923,'for',100,1),(624,7505929,7505928,'per',11.111,1),(624,7505930,7505928,'erf',11.111,1),(624,7505931,7505928,'rfo',11.111,1),(624,7505932,7505928,'for',11.111,1),(624,7505933,7505928,'orm',11.111,1),(624,7505934,7505928,'rma',11.111,1),(624,7505935,7505928,'man',11.111,1),(624,7505936,7505928,'anc',11.111,1),(624,7505937,7505928,'nce',11.111,1),(624,7505938,7505929,'ide',12.5,1),(624,7505939,7505929,'den',12.5,1),(624,7505940,7505929,'ent',12.5,1),(624,7505941,7505929,'nti',12.5,1),(624,7505942,7505929,'tif',12.5,1),(624,7505943,7505929,'ifi',12.5,1),(624,7505944,7505929,'fie',12.5,1),(624,7505945,7505929,'ier',12.5,1),(624,7505946,7505938,'vdi',33.333,3),(624,7505947,7505938,'dis',33.333,3),(624,7505948,7505938,'isk',33.333,3),(624,7505949,7505946,'nam',50,1),(624,7505950,7505946,'ame',50,1),(624,7505951,7505949,'typ',50,1),(624,7505952,7505949,'ype',50,1),(624,7505953,7505951,'dir',25,1),(624,7505954,7505951,'ire',25,1),(624,7505955,7505951,'rec',25,1),(624,7505956,7505951,'ect',25,1),(625,7505958,7505957,'naa',100,2),(625,7505959,7505958,'600',3.333,3),(625,7505960,7505958,'000',3.333,3),(625,7505961,7505958,'00c',3.333,3),(625,7505962,7505958,'0c2',3.333,3),(625,7505963,7505958,'c29',3.333,3),(625,7505964,7505958,'29f',3.333,3),(625,7505965,7505958,'9f9',3.333,3),(625,7505966,7505958,'f9b',3.333,3),(625,7505967,7505958,'9b5',3.333,3),(625,7505968,7505958,'b54',3.333,3),(625,7505969,7505958,'545',3.333,3),(625,7505970,7505958,'455',3.333,3),(625,7505971,7505958,'550',3.333,3),(625,7505972,7505958,'508',3.333,3),(625,7505973,7505958,'08d',3.333,3),(625,7505974,7505958,'8d4',3.333,3),(625,7505975,7505958,'d43',3.333,3),(625,7505976,7505958,'434',3.333,3),(625,7505977,7505958,'347',3.333,3),(625,7505978,7505958,'479',3.333,3),(625,7505979,7505958,'79c',3.333,3),(625,7505980,7505958,'9ce',3.333,3),(625,7505981,7505958,'cef',3.333,3),(625,7505982,7505958,'ef2',3.333,3),(625,7505983,7505958,'f2a',3.333,3),(625,7505984,7505958,'2af',3.333,3),(625,7505985,7505958,'afd',3.333,3),(625,7505986,7505958,'fd0',3.333,3),(625,7505987,7505958,'d0e',3.333,3),(625,7505988,7505958,'0ec',3.333,3),(625,7505989,7505959,'mon',100,1),(625,7505990,7505989,'201',50,1),(625,7505991,7505989,'013',50,1),(625,7505992,7505990,'adm',33.333,3),(625,7505993,7505990,'dmi',33.333,3),(625,7505994,7505990,'min',33.333,3),(625,7505995,7505992,'cap',16.667,1),(625,7505996,7505992,'apa',16.667,1),(625,7505997,7505992,'pac',16.667,1),(625,7505998,7505992,'aci',16.667,1),(625,7505999,7505992,'cit',16.667,1),(625,7506000,7505992,'ity',16.667,1),(625,7506001,7505995,'pat',50,1),(625,7506002,7505995,'ath',50,1),(625,7506003,7506001,'fre',14.286,1),(625,7506004,7506001,'ree',14.286,1),(625,7506005,7506001,'ees',14.286,1),(625,7506006,7506001,'esp',14.286,1),(625,7506007,7506001,'spa',14.286,1),(625,7506008,7506001,'pac',14.286,1),(625,7506009,7506001,'ace',14.286,1),(625,7506010,7506003,'dis',50,1),(625,7506011,7506003,'isk',50,1),(625,7506012,7506010,'ind',33.333,1),(625,7506013,7506010,'nde',33.333,1),(625,7506014,7506010,'dex',33.333,1),(625,7506015,7506012,'adm',8.333,1),(625,7506016,7506012,'dmi',8.333,1),(625,7506017,7506012,'min',8.333,1),(625,7506018,7506012,'ini',8.333,1),(625,7506019,7506012,'nis',8.333,1),(625,7506020,7506012,'ist',8.333,1),(625,7506021,7506012,'str',8.333,1),(625,7506022,7506012,'tra',8.333,1),(625,7506023,7506012,'rat',8.333,1),(625,7506024,7506012,'ati',8.333,1),(625,7506025,7506012,'tio',8.333,1),(625,7506026,7506012,'ion',8.333,1),(625,7506027,7506015,'sta',33.333,3),(625,7506028,7506015,'tat',33.333,3),(625,7506029,7506015,'ate',33.333,3),(625,7506030,7506027,'ena',20,2),(625,7506031,7506027,'nab',20,2),(625,7506032,7506027,'abl',20,2),(625,7506033,7506027,'ble',20,2),(625,7506034,7506027,'led',20,2),(625,7506035,7506030,'cac',33.333,2),(625,7506036,7506030,'ach',33.333,2),(625,7506037,7506030,'che',33.333,2),(625,7506038,7506035,'mod',50,1),(625,7506039,7506035,'ode',50,1),(625,7506040,7506038,'wri',14.286,1),(625,7506041,7506038,'rit',14.286,1),(625,7506042,7506038,'ite',14.286,1),(625,7506043,7506038,'tet',14.286,1),(625,7506044,7506038,'eth',14.286,1),(625,7506045,7506038,'thr',14.286,1),(625,7506046,7506038,'hru',14.286,1),(625,7506047,7506040,'ope',11.111,2),(625,7506048,7506040,'per',11.111,2),(625,7506049,7506040,'era',11.111,2),(625,7506050,7506040,'rat',11.111,2),(625,7506051,7506040,'ati',11.111,2),(625,7506052,7506040,'tio',11.111,2),(625,7506053,7506040,'ion',11.111,2),(625,7506054,7506040,'ona',11.111,2),(625,7506055,7506040,'nal',11.111,2),(625,7506056,7506047,'pen',20,1),(625,7506057,7506047,'end',20,1),(625,7506058,7506047,'ndi',20,1),(625,7506059,7506047,'din',20,1),(625,7506060,7506047,'ing',20,1),(625,7506061,7506056,'mes',20,1),(625,7506062,7506056,'ess',20,1),(625,7506063,7506056,'ssa',20,1),(625,7506064,7506056,'sag',20,1),(625,7506065,7506056,'age',20,1),(625,7506066,7506061,'wai',20,1),(625,7506067,7506061,'ait',20,1),(625,7506068,7506061,'iti',20,1),(625,7506069,7506061,'tin',20,1),(625,7506070,7506061,'ing',20,1),(625,7506071,7506066,'for',100,1),(625,7506072,7506071,'per',11.111,1),(625,7506073,7506071,'erf',11.111,1),(625,7506074,7506071,'rfo',11.111,1),(625,7506075,7506071,'for',11.111,1),(625,7506076,7506071,'orm',11.111,1),(625,7506077,7506071,'rma',11.111,1),(625,7506078,7506071,'man',11.111,1),(625,7506079,7506071,'anc',11.111,1),(625,7506080,7506071,'nce',11.111,1),(625,7506081,7506072,'ide',12.5,1),(625,7506082,7506072,'den',12.5,1),(625,7506083,7506072,'ent',12.5,1),(625,7506084,7506072,'nti',12.5,1),(625,7506085,7506072,'tif',12.5,1),(625,7506086,7506072,'ifi',12.5,1),(625,7506087,7506072,'fie',12.5,1),(625,7506088,7506072,'ier',12.5,1),(625,7506089,7506081,'vdi',33.333,3),(625,7506090,7506081,'dis',33.333,3),(625,7506091,7506081,'isk',33.333,3),(625,7506092,7506089,'nam',50,1),(625,7506093,7506089,'ame',50,1),(625,7506094,7506092,'typ',50,1),(625,7506095,7506092,'ype',50,1),(625,7506096,7506094,'dir',25,1),(625,7506097,7506094,'ire',25,1),(625,7506098,7506094,'rec',25,1),(625,7506099,7506094,'ect',25,1),(626,7506101,7506100,'naa',100,2),(626,7506102,7506101,'600',3.333,3),(626,7506103,7506101,'000',3.333,3),(626,7506104,7506101,'00c',3.333,3),(626,7506105,7506101,'0c2',3.333,3),(626,7506106,7506101,'c29',3.333,3),(626,7506107,7506101,'294',3.333,3),(626,7506108,7506101,'946',3.333,3),(626,7506109,7506101,'467',3.333,3),(626,7506110,7506101,'674',3.333,3),(626,7506111,7506101,'740',3.333,3),(626,7506112,7506101,'40d',3.333,3),(626,7506113,7506101,'0d6',3.333,3),(626,7506114,7506101,'d63',3.333,3),(626,7506115,7506101,'632',3.333,3),(626,7506116,7506101,'32b',3.333,3),(626,7506117,7506101,'2b6',3.333,3),(626,7506118,7506101,'b60',3.333,3),(626,7506119,7506101,'606',3.333,3),(626,7506120,7506101,'069',3.333,3),(626,7506121,7506101,'696',3.333,3),(626,7506122,7506101,'96f',3.333,3),(626,7506123,7506101,'6f5',3.333,3),(626,7506124,7506101,'f5a',3.333,3),(626,7506125,7506101,'5a4',3.333,3),(626,7506126,7506101,'a46',3.333,3),(626,7506127,7506101,'46b',3.333,3),(626,7506128,7506101,'6b3',3.333,3),(626,7506129,7506101,'b35',3.333,3),(626,7506130,7506101,'359',3.333,3),(626,7506131,7506101,'596',3.333,3),(626,7506132,7506102,'mon',100,1),(626,7506133,7506132,'201',50,1),(626,7506134,7506132,'013',50,1),(626,7506135,7506133,'adm',33.333,3),(626,7506136,7506133,'dmi',33.333,3),(626,7506137,7506133,'min',33.333,3),(626,7506138,7506135,'cap',16.667,1),(626,7506139,7506135,'apa',16.667,1),(626,7506140,7506135,'pac',16.667,1),(626,7506141,7506135,'aci',16.667,1),(626,7506142,7506135,'cit',16.667,1),(626,7506143,7506135,'ity',16.667,1),(626,7506144,7506138,'pat',50,1),(626,7506145,7506138,'ath',50,1),(626,7506146,7506144,'fre',14.286,1),(626,7506147,7506144,'ree',14.286,1),(626,7506148,7506144,'ees',14.286,1),(626,7506149,7506144,'esp',14.286,1),(626,7506150,7506144,'spa',14.286,1),(626,7506151,7506144,'pac',14.286,1),(626,7506152,7506144,'ace',14.286,1),(626,7506153,7506146,'dis',50,1),(626,7506154,7506146,'isk',50,1),(626,7506155,7506153,'ind',33.333,1),(626,7506156,7506153,'nde',33.333,1),(626,7506157,7506153,'dex',33.333,1),(626,7506158,7506155,'adm',8.333,1),(626,7506159,7506155,'dmi',8.333,1),(626,7506160,7506155,'min',8.333,1),(626,7506161,7506155,'ini',8.333,1),(626,7506162,7506155,'nis',8.333,1),(626,7506163,7506155,'ist',8.333,1),(626,7506164,7506155,'str',8.333,1),(626,7506165,7506155,'tra',8.333,1),(626,7506166,7506155,'rat',8.333,1),(626,7506167,7506155,'ati',8.333,1),(626,7506168,7506155,'tio',8.333,1),(626,7506169,7506155,'ion',8.333,1),(626,7506170,7506158,'sta',33.333,3),(626,7506171,7506158,'tat',33.333,3),(626,7506172,7506158,'ate',33.333,3),(626,7506173,7506170,'ena',20,2),(626,7506174,7506170,'nab',20,2),(626,7506175,7506170,'abl',20,2),(626,7506176,7506170,'ble',20,2),(626,7506177,7506170,'led',20,2),(626,7506178,7506173,'cac',33.333,2),(626,7506179,7506173,'ach',33.333,2),(626,7506180,7506173,'che',33.333,2),(626,7506181,7506178,'mod',50,1),(626,7506182,7506178,'ode',50,1),(626,7506183,7506181,'wri',14.286,1),(626,7506184,7506181,'rit',14.286,1),(626,7506185,7506181,'ite',14.286,1),(626,7506186,7506181,'tet',14.286,1),(626,7506187,7506181,'eth',14.286,1),(626,7506188,7506181,'thr',14.286,1),(626,7506189,7506181,'hru',14.286,1),(626,7506190,7506183,'ope',11.111,2),(626,7506191,7506183,'per',11.111,2),(626,7506192,7506183,'era',11.111,2),(626,7506193,7506183,'rat',11.111,2),(626,7506194,7506183,'ati',11.111,2),(626,7506195,7506183,'tio',11.111,2),(626,7506196,7506183,'ion',11.111,2),(626,7506197,7506183,'ona',11.111,2),(626,7506198,7506183,'nal',11.111,2),(626,7506199,7506190,'pen',20,1),(626,7506200,7506190,'end',20,1),(626,7506201,7506190,'ndi',20,1),(626,7506202,7506190,'din',20,1),(626,7506203,7506190,'ing',20,1),(626,7506204,7506199,'mes',20,1),(626,7506205,7506199,'ess',20,1),(626,7506206,7506199,'ssa',20,1),(626,7506207,7506199,'sag',20,1),(626,7506208,7506199,'age',20,1),(626,7506209,7506204,'wai',20,1),(626,7506210,7506204,'ait',20,1),(626,7506211,7506204,'iti',20,1),(626,7506212,7506204,'tin',20,1),(626,7506213,7506204,'ing',20,1),(626,7506214,7506209,'for',100,1),(626,7506215,7506214,'per',11.111,1),(626,7506216,7506214,'erf',11.111,1),(626,7506217,7506214,'rfo',11.111,1),(626,7506218,7506214,'for',11.111,1),(626,7506219,7506214,'orm',11.111,1),(626,7506220,7506214,'rma',11.111,1),(626,7506221,7506214,'man',11.111,1),(626,7506222,7506214,'anc',11.111,1),(626,7506223,7506214,'nce',11.111,1),(626,7506224,7506215,'ide',12.5,1),(626,7506225,7506215,'den',12.5,1),(626,7506226,7506215,'ent',12.5,1),(626,7506227,7506215,'nti',12.5,1),(626,7506228,7506215,'tif',12.5,1),(626,7506229,7506215,'ifi',12.5,1),(626,7506230,7506215,'fie',12.5,1),(626,7506231,7506215,'ier',12.5,1),(626,7506232,7506224,'vdi',33.333,3),(626,7506233,7506224,'dis',33.333,3),(626,7506234,7506224,'isk',33.333,3),(626,7506235,7506232,'nam',50,1),(626,7506236,7506232,'ame',50,1),(626,7506237,7506235,'typ',50,1),(626,7506238,7506235,'ype',50,1),(626,7506239,7506237,'dir',25,1),(626,7506240,7506237,'ire',25,1),(626,7506241,7506237,'rec',25,1),(626,7506242,7506237,'ect',25,1),(627,7506244,7506243,'naa',100,2),(627,7506245,7506244,'600',3.333,3),(627,7506246,7506244,'000',3.333,3),(627,7506247,7506244,'00c',3.333,3),(627,7506248,7506244,'0c2',3.333,3),(627,7506249,7506244,'c29',3.333,3),(627,7506250,7506244,'291',3.333,3),(627,7506251,7506244,'911',3.333,3),(627,7506252,7506244,'119',3.333,3),(627,7506253,7506244,'190',3.333,3),(627,7506254,7506244,'900',3.333,3),(627,7506255,7506244,'00b',3.333,3),(627,7506256,7506244,'0b3',3.333,3),(627,7506257,7506244,'b3d',3.333,3),(627,7506258,7506244,'3de',3.333,3),(627,7506259,7506244,'de1',3.333,3),(627,7506260,7506244,'e1e',3.333,3),(627,7506261,7506244,'1ef',3.333,3),(627,7506262,7506244,'eff',3.333,3),(627,7506263,7506244,'ff8',3.333,3),(627,7506264,7506244,'f8a',3.333,3),(627,7506265,7506244,'8ae',3.333,3),(627,7506266,7506244,'ae7',3.333,3),(627,7506267,7506244,'e74',3.333,3),(627,7506268,7506244,'74b',3.333,3),(627,7506269,7506244,'4b1',3.333,3),(627,7506270,7506244,'b10',3.333,3),(627,7506271,7506244,'10f',3.333,3),(627,7506272,7506244,'0f1',3.333,3),(627,7506273,7506244,'f18',3.333,3),(627,7506274,7506244,'187',3.333,3),(627,7506275,7506245,'mon',100,1),(627,7506276,7506275,'201',50,1),(627,7506277,7506275,'013',50,1),(627,7506278,7506276,'adm',33.333,3),(627,7506279,7506276,'dmi',33.333,3),(627,7506280,7506276,'min',33.333,3),(627,7506281,7506278,'cap',16.667,1),(627,7506282,7506278,'apa',16.667,1),(627,7506283,7506278,'pac',16.667,1),(627,7506284,7506278,'aci',16.667,1),(627,7506285,7506278,'cit',16.667,1),(627,7506286,7506278,'ity',16.667,1),(627,7506287,7506281,'pat',50,1),(627,7506288,7506281,'ath',50,1),(627,7506289,7506287,'fre',14.286,1),(627,7506290,7506287,'ree',14.286,1),(627,7506291,7506287,'ees',14.286,1),(627,7506292,7506287,'esp',14.286,1),(627,7506293,7506287,'spa',14.286,1),(627,7506294,7506287,'pac',14.286,1),(627,7506295,7506287,'ace',14.286,1),(627,7506296,7506289,'dis',50,1),(627,7506297,7506289,'isk',50,1),(627,7506298,7506296,'ind',33.333,1),(627,7506299,7506296,'nde',33.333,1),(627,7506300,7506296,'dex',33.333,1),(627,7506301,7506298,'adm',8.333,1),(627,7506302,7506298,'dmi',8.333,1),(627,7506303,7506298,'min',8.333,1),(627,7506304,7506298,'ini',8.333,1),(627,7506305,7506298,'nis',8.333,1),(627,7506306,7506298,'ist',8.333,1),(627,7506307,7506298,'str',8.333,1),(627,7506308,7506298,'tra',8.333,1),(627,7506309,7506298,'rat',8.333,1),(627,7506310,7506298,'ati',8.333,1),(627,7506311,7506298,'tio',8.333,1),(627,7506312,7506298,'ion',8.333,1),(627,7506313,7506301,'sta',33.333,3),(627,7506314,7506301,'tat',33.333,3),(627,7506315,7506301,'ate',33.333,3),(627,7506316,7506313,'ena',20,2),(627,7506317,7506313,'nab',20,2),(627,7506318,7506313,'abl',20,2),(627,7506319,7506313,'ble',20,2),(627,7506320,7506313,'led',20,2),(627,7506321,7506316,'cac',33.333,2),(627,7506322,7506316,'ach',33.333,2),(627,7506323,7506316,'che',33.333,2),(627,7506324,7506321,'mod',50,1),(627,7506325,7506321,'ode',50,1),(627,7506326,7506324,'wri',14.286,1),(627,7506327,7506324,'rit',14.286,1),(627,7506328,7506324,'ite',14.286,1),(627,7506329,7506324,'tet',14.286,1),(627,7506330,7506324,'eth',14.286,1),(627,7506331,7506324,'thr',14.286,1),(627,7506332,7506324,'hru',14.286,1),(627,7506333,7506326,'ope',11.111,2),(627,7506334,7506326,'per',11.111,2),(627,7506335,7506326,'era',11.111,2),(627,7506336,7506326,'rat',11.111,2),(627,7506337,7506326,'ati',11.111,2),(627,7506338,7506326,'tio',11.111,2),(627,7506339,7506326,'ion',11.111,2),(627,7506340,7506326,'ona',11.111,2),(627,7506341,7506326,'nal',11.111,2),(627,7506342,7506333,'pen',20,1),(627,7506343,7506333,'end',20,1),(627,7506344,7506333,'ndi',20,1),(627,7506345,7506333,'din',20,1),(627,7506346,7506333,'ing',20,1),(627,7506347,7506342,'mes',20,1),(627,7506348,7506342,'ess',20,1),(627,7506349,7506342,'ssa',20,1),(627,7506350,7506342,'sag',20,1),(627,7506351,7506342,'age',20,1),(627,7506352,7506347,'wai',20,1),(627,7506353,7506347,'ait',20,1),(627,7506354,7506347,'iti',20,1),(627,7506355,7506347,'tin',20,1),(627,7506356,7506347,'ing',20,1),(627,7506357,7506352,'for',100,1),(627,7506358,7506357,'per',11.111,1),(627,7506359,7506357,'erf',11.111,1),(627,7506360,7506357,'rfo',11.111,1),(627,7506361,7506357,'for',11.111,1),(627,7506362,7506357,'orm',11.111,1),(627,7506363,7506357,'rma',11.111,1),(627,7506364,7506357,'man',11.111,1),(627,7506365,7506357,'anc',11.111,1),(627,7506366,7506357,'nce',11.111,1),(627,7506367,7506358,'ide',12.5,1),(627,7506368,7506358,'den',12.5,1),(627,7506369,7506358,'ent',12.5,1),(627,7506370,7506358,'nti',12.5,1),(627,7506371,7506358,'tif',12.5,1),(627,7506372,7506358,'ifi',12.5,1),(627,7506373,7506358,'fie',12.5,1),(627,7506374,7506358,'ier',12.5,1),(627,7506375,7506367,'vdi',33.333,3),(627,7506376,7506367,'dis',33.333,3),(627,7506377,7506367,'isk',33.333,3),(627,7506378,7506375,'nam',50,1),(627,7506379,7506375,'ame',50,1),(627,7506380,7506378,'typ',50,1),(627,7506381,7506378,'ype',50,1),(627,7506382,7506380,'dir',25,1),(627,7506383,7506380,'ire',25,1),(627,7506384,7506380,'rec',25,1),(627,7506385,7506380,'ect',25,1),(628,7506387,7506386,'naa',100,2),(628,7506388,7506387,'600',3.333,3),(628,7506389,7506387,'000',3.333,3),(628,7506390,7506387,'00c',3.333,3),(628,7506391,7506387,'0c2',3.333,3),(628,7506392,7506387,'c29',3.333,3),(628,7506393,7506387,'29a',3.333,3),(628,7506394,7506387,'9a1',3.333,3),(628,7506395,7506387,'a18',3.333,3),(628,7506396,7506387,'18c',3.333,3),(628,7506397,7506387,'8cd',3.333,3),(628,7506398,7506387,'cdf',3.333,3),(628,7506399,7506387,'df8',3.333,3),(628,7506400,7506387,'f86',3.333,3),(628,7506401,7506387,'868',3.333,3),(628,7506402,7506387,'683',3.333,3),(628,7506403,7506387,'83f',3.333,3),(628,7506404,7506387,'3f5',3.333,3),(628,7506405,7506387,'f58',3.333,3),(628,7506406,7506387,'585',3.333,3),(628,7506407,7506387,'853',3.333,3),(628,7506408,7506387,'532',3.333,3),(628,7506409,7506387,'323',3.333,3),(628,7506410,7506387,'237',3.333,3),(628,7506411,7506387,'377',3.333,3),(628,7506412,7506387,'772',3.333,3),(628,7506413,7506387,'728',3.333,3),(628,7506414,7506387,'284',3.333,3),(628,7506415,7506387,'842',3.333,3),(628,7506416,7506387,'427',3.333,3),(628,7506417,7506387,'275',3.333,3),(628,7506418,7506388,'mon',100,1),(628,7506419,7506418,'201',50,1),(628,7506420,7506418,'013',50,1),(628,7506421,7506419,'adm',33.333,3),(628,7506422,7506419,'dmi',33.333,3),(628,7506423,7506419,'min',33.333,3),(628,7506424,7506421,'cap',16.667,1),(628,7506425,7506421,'apa',16.667,1),(628,7506426,7506421,'pac',16.667,1),(628,7506427,7506421,'aci',16.667,1),(628,7506428,7506421,'cit',16.667,1),(628,7506429,7506421,'ity',16.667,1),(628,7506430,7506424,'pat',50,1),(628,7506431,7506424,'ath',50,1),(628,7506432,7506430,'fre',14.286,1),(628,7506433,7506430,'ree',14.286,1),(628,7506434,7506430,'ees',14.286,1),(628,7506435,7506430,'esp',14.286,1),(628,7506436,7506430,'spa',14.286,1),(628,7506437,7506430,'pac',14.286,1),(628,7506438,7506430,'ace',14.286,1),(628,7506439,7506432,'dis',50,1),(628,7506440,7506432,'isk',50,1),(628,7506441,7506439,'ind',33.333,1),(628,7506442,7506439,'nde',33.333,1),(628,7506443,7506439,'dex',33.333,1),(628,7506444,7506441,'adm',8.333,1),(628,7506445,7506441,'dmi',8.333,1),(628,7506446,7506441,'min',8.333,1),(628,7506447,7506441,'ini',8.333,1),(628,7506448,7506441,'nis',8.333,1),(628,7506449,7506441,'ist',8.333,1),(628,7506450,7506441,'str',8.333,1),(628,7506451,7506441,'tra',8.333,1),(628,7506452,7506441,'rat',8.333,1),(628,7506453,7506441,'ati',8.333,1),(628,7506454,7506441,'tio',8.333,1),(628,7506455,7506441,'ion',8.333,1),(628,7506456,7506444,'sta',33.333,3),(628,7506457,7506444,'tat',33.333,3),(628,7506458,7506444,'ate',33.333,3),(628,7506459,7506456,'ena',20,2),(628,7506460,7506456,'nab',20,2),(628,7506461,7506456,'abl',20,2),(628,7506462,7506456,'ble',20,2),(628,7506463,7506456,'led',20,2),(628,7506464,7506459,'cac',33.333,2),(628,7506465,7506459,'ach',33.333,2),(628,7506466,7506459,'che',33.333,2),(628,7506467,7506464,'mod',50,1),(628,7506468,7506464,'ode',50,1),(628,7506469,7506467,'wri',14.286,1),(628,7506470,7506467,'rit',14.286,1),(628,7506471,7506467,'ite',14.286,1),(628,7506472,7506467,'tet',14.286,1),(628,7506473,7506467,'eth',14.286,1),(628,7506474,7506467,'thr',14.286,1),(628,7506475,7506467,'hru',14.286,1),(628,7506476,7506469,'ope',11.111,2),(628,7506477,7506469,'per',11.111,2),(628,7506478,7506469,'era',11.111,2),(628,7506479,7506469,'rat',11.111,2),(628,7506480,7506469,'ati',11.111,2),(628,7506481,7506469,'tio',11.111,2),(628,7506482,7506469,'ion',11.111,2),(628,7506483,7506469,'ona',11.111,2),(628,7506484,7506469,'nal',11.111,2),(628,7506485,7506476,'pen',20,1),(628,7506486,7506476,'end',20,1),(628,7506487,7506476,'ndi',20,1),(628,7506488,7506476,'din',20,1),(628,7506489,7506476,'ing',20,1),(628,7506490,7506485,'mes',20,1),(628,7506491,7506485,'ess',20,1),(628,7506492,7506485,'ssa',20,1),(628,7506493,7506485,'sag',20,1),(628,7506494,7506485,'age',20,1),(628,7506495,7506490,'wai',20,1),(628,7506496,7506490,'ait',20,1),(628,7506497,7506490,'iti',20,1),(628,7506498,7506490,'tin',20,1),(628,7506499,7506490,'ing',20,1),(628,7506500,7506495,'for',100,1),(628,7506501,7506500,'per',11.111,1),(628,7506502,7506500,'erf',11.111,1),(628,7506503,7506500,'rfo',11.111,1),(628,7506504,7506500,'for',11.111,1),(628,7506505,7506500,'orm',11.111,1),(628,7506506,7506500,'rma',11.111,1),(628,7506507,7506500,'man',11.111,1),(628,7506508,7506500,'anc',11.111,1),(628,7506509,7506500,'nce',11.111,1),(628,7506510,7506501,'ide',12.5,1),(628,7506511,7506501,'den',12.5,1),(628,7506512,7506501,'ent',12.5,1),(628,7506513,7506501,'nti',12.5,1),(628,7506514,7506501,'tif',12.5,1),(628,7506515,7506501,'ifi',12.5,1),(628,7506516,7506501,'fie',12.5,1),(628,7506517,7506501,'ier',12.5,1),(628,7506518,7506510,'vdi',33.333,3),(628,7506519,7506510,'dis',33.333,3),(628,7506520,7506510,'isk',33.333,3),(628,7506521,7506518,'nam',50,1),(628,7506522,7506518,'ame',50,1),(628,7506523,7506521,'typ',50,1),(628,7506524,7506521,'ype',50,1),(628,7506525,7506523,'dir',25,1),(628,7506526,7506523,'ire',25,1),(628,7506527,7506523,'rec',25,1),(628,7506528,7506523,'ect',25,1),(629,7506530,7506529,'naa',100,2),(629,7506531,7506530,'600',3.333,3),(629,7506532,7506530,'000',3.333,3),(629,7506533,7506530,'00c',3.333,3),(629,7506534,7506530,'0c2',3.333,3),(629,7506535,7506530,'c29',3.333,3),(629,7506536,7506530,'294',3.333,3),(629,7506537,7506530,'945',3.333,3),(629,7506538,7506530,'458',3.333,3),(629,7506539,7506530,'584',3.333,3),(629,7506540,7506530,'84f',3.333,3),(629,7506541,7506530,'4fd',3.333,3),(629,7506542,7506530,'fdb',3.333,3),(629,7506543,7506530,'dbb',3.333,3),(629,7506544,7506530,'bbc',3.333,3),(629,7506545,7506530,'bcd',3.333,3),(629,7506546,7506530,'cd1',3.333,3),(629,7506547,7506530,'d1d',3.333,3),(629,7506548,7506530,'1d7',3.333,3),(629,7506549,7506530,'d71',3.333,3),(629,7506550,7506530,'71b',3.333,3),(629,7506551,7506530,'1b7',3.333,3),(629,7506552,7506530,'b79',3.333,3),(629,7506553,7506530,'792',3.333,3),(629,7506554,7506530,'923',3.333,3),(629,7506555,7506530,'236',3.333,3),(629,7506556,7506530,'36b',3.333,3),(629,7506557,7506530,'6b3',3.333,3),(629,7506558,7506530,'b37',3.333,3),(629,7506559,7506530,'37f',3.333,3),(629,7506560,7506530,'7f0',3.333,3),(629,7506561,7506531,'mon',100,1),(629,7506562,7506561,'201',50,1),(629,7506563,7506561,'013',50,1),(629,7506564,7506562,'adm',33.333,3),(629,7506565,7506562,'dmi',33.333,3),(629,7506566,7506562,'min',33.333,3),(629,7506567,7506564,'cap',16.667,1),(629,7506568,7506564,'apa',16.667,1),(629,7506569,7506564,'pac',16.667,1),(629,7506570,7506564,'aci',16.667,1),(629,7506571,7506564,'cit',16.667,1),(629,7506572,7506564,'ity',16.667,1),(629,7506573,7506567,'pat',50,1),(629,7506574,7506567,'ath',50,1),(629,7506575,7506573,'fre',14.286,1),(629,7506576,7506573,'ree',14.286,1),(629,7506577,7506573,'ees',14.286,1),(629,7506578,7506573,'esp',14.286,1),(629,7506579,7506573,'spa',14.286,1),(629,7506580,7506573,'pac',14.286,1),(629,7506581,7506573,'ace',14.286,1),(629,7506582,7506575,'dis',50,1),(629,7506583,7506575,'isk',50,1),(629,7506584,7506582,'ind',33.333,1),(629,7506585,7506582,'nde',33.333,1),(629,7506586,7506582,'dex',33.333,1),(629,7506587,7506584,'adm',8.333,1),(629,7506588,7506584,'dmi',8.333,1),(629,7506589,7506584,'min',8.333,1),(629,7506590,7506584,'ini',8.333,1),(629,7506591,7506584,'nis',8.333,1),(629,7506592,7506584,'ist',8.333,1),(629,7506593,7506584,'str',8.333,1),(629,7506594,7506584,'tra',8.333,1),(629,7506595,7506584,'rat',8.333,1),(629,7506596,7506584,'ati',8.333,1),(629,7506597,7506584,'tio',8.333,1),(629,7506598,7506584,'ion',8.333,1),(629,7506599,7506587,'sta',33.333,3),(629,7506600,7506587,'tat',33.333,3),(629,7506601,7506587,'ate',33.333,3),(629,7506602,7506599,'ena',20,2),(629,7506603,7506599,'nab',20,2),(629,7506604,7506599,'abl',20,2),(629,7506605,7506599,'ble',20,2),(629,7506606,7506599,'led',20,2),(629,7506607,7506602,'cac',33.333,2),(629,7506608,7506602,'ach',33.333,2),(629,7506609,7506602,'che',33.333,2),(629,7506610,7506607,'mod',50,1),(629,7506611,7506607,'ode',50,1),(629,7506612,7506610,'wri',14.286,1),(629,7506613,7506610,'rit',14.286,1),(629,7506614,7506610,'ite',14.286,1),(629,7506615,7506610,'tet',14.286,1),(629,7506616,7506610,'eth',14.286,1),(629,7506617,7506610,'thr',14.286,1),(629,7506618,7506610,'hru',14.286,1),(629,7506619,7506612,'ope',11.111,2),(629,7506620,7506612,'per',11.111,2),(629,7506621,7506612,'era',11.111,2),(629,7506622,7506612,'rat',11.111,2),(629,7506623,7506612,'ati',11.111,2),(629,7506624,7506612,'tio',11.111,2),(629,7506625,7506612,'ion',11.111,2),(629,7506626,7506612,'ona',11.111,2),(629,7506627,7506612,'nal',11.111,2),(629,7506628,7506619,'pen',20,1),(629,7506629,7506619,'end',20,1),(629,7506630,7506619,'ndi',20,1),(629,7506631,7506619,'din',20,1),(629,7506632,7506619,'ing',20,1),(629,7506633,7506628,'mes',20,1),(629,7506634,7506628,'ess',20,1),(629,7506635,7506628,'ssa',20,1),(629,7506636,7506628,'sag',20,1),(629,7506637,7506628,'age',20,1),(629,7506638,7506633,'wai',20,1),(629,7506639,7506633,'ait',20,1),(629,7506640,7506633,'iti',20,1),(629,7506641,7506633,'tin',20,1),(629,7506642,7506633,'ing',20,1),(629,7506643,7506638,'for',100,1),(629,7506644,7506643,'per',11.111,1),(629,7506645,7506643,'erf',11.111,1),(629,7506646,7506643,'rfo',11.111,1),(629,7506647,7506643,'for',11.111,1),(629,7506648,7506643,'orm',11.111,1),(629,7506649,7506643,'rma',11.111,1),(629,7506650,7506643,'man',11.111,1),(629,7506651,7506643,'anc',11.111,1),(629,7506652,7506643,'nce',11.111,1),(629,7506653,7506644,'ide',12.5,1),(629,7506654,7506644,'den',12.5,1),(629,7506655,7506644,'ent',12.5,1),(629,7506656,7506644,'nti',12.5,1),(629,7506657,7506644,'tif',12.5,1),(629,7506658,7506644,'ifi',12.5,1),(629,7506659,7506644,'fie',12.5,1),(629,7506660,7506644,'ier',12.5,1),(629,7506661,7506653,'vdi',33.333,3),(629,7506662,7506653,'dis',33.333,3),(629,7506663,7506653,'isk',33.333,3),(629,7506664,7506661,'nam',50,1),(629,7506665,7506661,'ame',50,1),(629,7506666,7506664,'typ',50,1),(629,7506667,7506664,'ype',50,1),(629,7506668,7506666,'dir',25,1),(629,7506669,7506666,'ire',25,1),(629,7506670,7506666,'rec',25,1),(629,7506671,7506666,'ect',25,1),(630,7506673,7506672,'naa',100,2),(630,7506674,7506673,'600',3.333,3),(630,7506675,7506673,'000',3.333,3),(630,7506676,7506673,'00c',3.333,3),(630,7506677,7506673,'0c2',3.333,3),(630,7506678,7506673,'c29',3.333,3),(630,7506679,7506673,'292',3.333,3),(630,7506680,7506673,'92d',3.333,3),(630,7506681,7506673,'2d7',3.333,3),(630,7506682,7506673,'d7e',3.333,3),(630,7506683,7506673,'7ed',3.333,3),(630,7506684,7506673,'ed5',3.333,3),(630,7506685,7506673,'d50',3.333,3),(630,7506686,7506673,'50d',3.333,3),(630,7506687,7506673,'0d6',3.333,3),(630,7506688,7506673,'d69',3.333,3),(630,7506689,7506673,'69a',3.333,3),(630,7506690,7506673,'9ae',3.333,3),(630,7506691,7506673,'ae5',3.333,3),(630,7506692,7506673,'e5d',3.333,3),(630,7506693,7506673,'5d7',3.333,3),(630,7506694,7506673,'d79',3.333,3),(630,7506695,7506673,'793',3.333,3),(630,7506696,7506673,'93e',3.333,3),(630,7506697,7506673,'3ef',3.333,3),(630,7506698,7506673,'ef3',3.333,3),(630,7506699,7506673,'f30',3.333,3),(630,7506700,7506673,'306',3.333,3),(630,7506701,7506673,'068',3.333,3),(630,7506702,7506673,'68a',3.333,3),(630,7506703,7506673,'8a0',3.333,3),(630,7506704,7506674,'mon',100,1),(630,7506705,7506704,'201',50,1),(630,7506706,7506704,'013',50,1),(630,7506707,7506705,'adm',33.333,3),(630,7506708,7506705,'dmi',33.333,3),(630,7506709,7506705,'min',33.333,3),(630,7506710,7506707,'cap',16.667,1),(630,7506711,7506707,'apa',16.667,1),(630,7506712,7506707,'pac',16.667,1),(630,7506713,7506707,'aci',16.667,1),(630,7506714,7506707,'cit',16.667,1),(630,7506715,7506707,'ity',16.667,1),(630,7506716,7506710,'pat',50,1),(630,7506717,7506710,'ath',50,1),(630,7506718,7506716,'fre',14.286,1),(630,7506719,7506716,'ree',14.286,1),(630,7506720,7506716,'ees',14.286,1),(630,7506721,7506716,'esp',14.286,1),(630,7506722,7506716,'spa',14.286,1),(630,7506723,7506716,'pac',14.286,1),(630,7506724,7506716,'ace',14.286,1),(630,7506725,7506718,'dis',50,1),(630,7506726,7506718,'isk',50,1),(630,7506727,7506725,'ind',33.333,1),(630,7506728,7506725,'nde',33.333,1),(630,7506729,7506725,'dex',33.333,1),(630,7506730,7506727,'adm',8.333,1),(630,7506731,7506727,'dmi',8.333,1),(630,7506732,7506727,'min',8.333,1),(630,7506733,7506727,'ini',8.333,1),(630,7506734,7506727,'nis',8.333,1),(630,7506735,7506727,'ist',8.333,1),(630,7506736,7506727,'str',8.333,1),(630,7506737,7506727,'tra',8.333,1),(630,7506738,7506727,'rat',8.333,1),(630,7506739,7506727,'ati',8.333,1),(630,7506740,7506727,'tio',8.333,1),(630,7506741,7506727,'ion',8.333,1),(630,7506742,7506730,'sta',33.333,3),(630,7506743,7506730,'tat',33.333,3),(630,7506744,7506730,'ate',33.333,3),(630,7506745,7506742,'ena',20,2),(630,7506746,7506742,'nab',20,2),(630,7506747,7506742,'abl',20,2),(630,7506748,7506742,'ble',20,2),(630,7506749,7506742,'led',20,2),(630,7506750,7506745,'cac',33.333,2),(630,7506751,7506745,'ach',33.333,2),(630,7506752,7506745,'che',33.333,2),(630,7506753,7506750,'mod',50,1),(630,7506754,7506750,'ode',50,1),(630,7506755,7506753,'wri',14.286,1),(630,7506756,7506753,'rit',14.286,1),(630,7506757,7506753,'ite',14.286,1),(630,7506758,7506753,'tet',14.286,1),(630,7506759,7506753,'eth',14.286,1),(630,7506760,7506753,'thr',14.286,1),(630,7506761,7506753,'hru',14.286,1),(630,7506762,7506755,'ope',11.111,2),(630,7506763,7506755,'per',11.111,2),(630,7506764,7506755,'era',11.111,2),(630,7506765,7506755,'rat',11.111,2),(630,7506766,7506755,'ati',11.111,2),(630,7506767,7506755,'tio',11.111,2),(630,7506768,7506755,'ion',11.111,2),(630,7506769,7506755,'ona',11.111,2),(630,7506770,7506755,'nal',11.111,2),(630,7506771,7506762,'pen',20,1),(630,7506772,7506762,'end',20,1),(630,7506773,7506762,'ndi',20,1),(630,7506774,7506762,'din',20,1),(630,7506775,7506762,'ing',20,1),(630,7506776,7506771,'mes',20,1),(630,7506777,7506771,'ess',20,1),(630,7506778,7506771,'ssa',20,1),(630,7506779,7506771,'sag',20,1),(630,7506780,7506771,'age',20,1),(630,7506781,7506776,'wai',20,1),(630,7506782,7506776,'ait',20,1),(630,7506783,7506776,'iti',20,1),(630,7506784,7506776,'tin',20,1),(630,7506785,7506776,'ing',20,1),(630,7506786,7506781,'for',100,1),(630,7506787,7506786,'per',11.111,1),(630,7506788,7506786,'erf',11.111,1),(630,7506789,7506786,'rfo',11.111,1),(630,7506790,7506786,'for',11.111,1),(630,7506791,7506786,'orm',11.111,1),(630,7506792,7506786,'rma',11.111,1),(630,7506793,7506786,'man',11.111,1),(630,7506794,7506786,'anc',11.111,1),(630,7506795,7506786,'nce',11.111,1),(630,7506796,7506787,'ide',12.5,1),(630,7506797,7506787,'den',12.5,1),(630,7506798,7506787,'ent',12.5,1),(630,7506799,7506787,'nti',12.5,1),(630,7506800,7506787,'tif',12.5,1),(630,7506801,7506787,'ifi',12.5,1),(630,7506802,7506787,'fie',12.5,1),(630,7506803,7506787,'ier',12.5,1),(630,7506804,7506796,'vdi',33.333,3),(630,7506805,7506796,'dis',33.333,3),(630,7506806,7506796,'isk',33.333,3),(630,7506807,7506804,'nam',50,1),(630,7506808,7506804,'ame',50,1),(630,7506809,7506807,'typ',50,1),(630,7506810,7506807,'ype',50,1),(630,7506811,7506809,'dir',25,1),(630,7506812,7506809,'ire',25,1),(630,7506813,7506809,'rec',25,1),(630,7506814,7506809,'ect',25,1),(631,7506816,7506815,'naa',100,2),(631,7506817,7506816,'600',3.333,3),(631,7506818,7506816,'000',3.333,3),(631,7506819,7506816,'00c',3.333,3),(631,7506820,7506816,'0c2',3.333,3),(631,7506821,7506816,'c29',3.333,3),(631,7506822,7506816,'297',3.333,3),(631,7506823,7506816,'972',3.333,3),(631,7506824,7506816,'720',3.333,3),(631,7506825,7506816,'206',3.333,3),(631,7506826,7506816,'06f',3.333,3),(631,7506827,7506816,'6fa',3.333,3),(631,7506828,7506816,'fa8',3.333,3),(631,7506829,7506816,'a8a',3.333,3),(631,7506830,7506816,'8af',3.333,3),(631,7506831,7506816,'af8',3.333,3),(631,7506832,7506816,'f8b',3.333,3),(631,7506833,7506816,'8b2',3.333,3),(631,7506834,7506816,'b2c',3.333,3),(631,7506835,7506816,'2c6',3.333,3),(631,7506836,7506816,'c6b',3.333,3),(631,7506837,7506816,'6bd',3.333,3),(631,7506838,7506816,'bdb',3.333,3),(631,7506839,7506816,'db5',3.333,3),(631,7506840,7506816,'b53',3.333,3),(631,7506841,7506816,'530',3.333,3),(631,7506842,7506816,'307',3.333,3),(631,7506843,7506816,'079',3.333,3),(631,7506844,7506816,'795',3.333,3),(631,7506845,7506816,'957',3.333,3),(631,7506846,7506816,'576',3.333,3),(631,7506847,7506817,'mon',100,1),(631,7506848,7506847,'201',50,1),(631,7506849,7506847,'013',50,1),(631,7506850,7506848,'adm',33.333,3),(631,7506851,7506848,'dmi',33.333,3),(631,7506852,7506848,'min',33.333,3),(631,7506853,7506850,'cap',16.667,1),(631,7506854,7506850,'apa',16.667,1),(631,7506855,7506850,'pac',16.667,1),(631,7506856,7506850,'aci',16.667,1),(631,7506857,7506850,'cit',16.667,1),(631,7506858,7506850,'ity',16.667,1),(631,7506859,7506853,'pat',50,1),(631,7506860,7506853,'ath',50,1),(631,7506861,7506859,'fre',14.286,1),(631,7506862,7506859,'ree',14.286,1),(631,7506863,7506859,'ees',14.286,1),(631,7506864,7506859,'esp',14.286,1),(631,7506865,7506859,'spa',14.286,1),(631,7506866,7506859,'pac',14.286,1),(631,7506867,7506859,'ace',14.286,1),(631,7506868,7506861,'dis',50,1),(631,7506869,7506861,'isk',50,1),(631,7506870,7506868,'ind',33.333,1),(631,7506871,7506868,'nde',33.333,1),(631,7506872,7506868,'dex',33.333,1),(631,7506873,7506870,'adm',8.333,1),(631,7506874,7506870,'dmi',8.333,1),(631,7506875,7506870,'min',8.333,1),(631,7506876,7506870,'ini',8.333,1),(631,7506877,7506870,'nis',8.333,1),(631,7506878,7506870,'ist',8.333,1),(631,7506879,7506870,'str',8.333,1),(631,7506880,7506870,'tra',8.333,1),(631,7506881,7506870,'rat',8.333,1),(631,7506882,7506870,'ati',8.333,1),(631,7506883,7506870,'tio',8.333,1),(631,7506884,7506870,'ion',8.333,1),(631,7506885,7506873,'sta',33.333,3),(631,7506886,7506873,'tat',33.333,3),(631,7506887,7506873,'ate',33.333,3),(631,7506888,7506885,'ena',20,2),(631,7506889,7506885,'nab',20,2),(631,7506890,7506885,'abl',20,2),(631,7506891,7506885,'ble',20,2),(631,7506892,7506885,'led',20,2),(631,7506893,7506888,'cac',33.333,2),(631,7506894,7506888,'ach',33.333,2),(631,7506895,7506888,'che',33.333,2),(631,7506896,7506893,'mod',50,1),(631,7506897,7506893,'ode',50,1),(631,7506898,7506896,'wri',14.286,1),(631,7506899,7506896,'rit',14.286,1),(631,7506900,7506896,'ite',14.286,1),(631,7506901,7506896,'tet',14.286,1),(631,7506902,7506896,'eth',14.286,1),(631,7506903,7506896,'thr',14.286,1),(631,7506904,7506896,'hru',14.286,1),(631,7506905,7506898,'ope',11.111,2),(631,7506906,7506898,'per',11.111,2),(631,7506907,7506898,'era',11.111,2),(631,7506908,7506898,'rat',11.111,2),(631,7506909,7506898,'ati',11.111,2),(631,7506910,7506898,'tio',11.111,2),(631,7506911,7506898,'ion',11.111,2),(631,7506912,7506898,'ona',11.111,2),(631,7506913,7506898,'nal',11.111,2),(631,7506914,7506905,'pen',20,1),(631,7506915,7506905,'end',20,1),(631,7506916,7506905,'ndi',20,1),(631,7506917,7506905,'din',20,1),(631,7506918,7506905,'ing',20,1),(631,7506919,7506914,'mes',20,1),(631,7506920,7506914,'ess',20,1),(631,7506921,7506914,'ssa',20,1),(631,7506922,7506914,'sag',20,1),(631,7506923,7506914,'age',20,1),(631,7506924,7506919,'wai',20,1),(631,7506925,7506919,'ait',20,1),(631,7506926,7506919,'iti',20,1),(631,7506927,7506919,'tin',20,1),(631,7506928,7506919,'ing',20,1),(631,7506929,7506924,'for',100,1),(631,7506930,7506929,'per',11.111,1),(631,7506931,7506929,'erf',11.111,1),(631,7506932,7506929,'rfo',11.111,1),(631,7506933,7506929,'for',11.111,1),(631,7506934,7506929,'orm',11.111,1),(631,7506935,7506929,'rma',11.111,1),(631,7506936,7506929,'man',11.111,1),(631,7506937,7506929,'anc',11.111,1),(631,7506938,7506929,'nce',11.111,1),(631,7506939,7506930,'ide',12.5,1),(631,7506940,7506930,'den',12.5,1),(631,7506941,7506930,'ent',12.5,1),(631,7506942,7506930,'nti',12.5,1),(631,7506943,7506930,'tif',12.5,1),(631,7506944,7506930,'ifi',12.5,1),(631,7506945,7506930,'fie',12.5,1),(631,7506946,7506930,'ier',12.5,1),(631,7506947,7506939,'vdi',33.333,3),(631,7506948,7506939,'dis',33.333,3),(631,7506949,7506939,'isk',33.333,3),(631,7506950,7506947,'nam',50,1),(631,7506951,7506947,'ame',50,1),(631,7506952,7506950,'typ',50,1),(631,7506953,7506950,'ype',50,1),(631,7506954,7506952,'dir',25,1),(631,7506955,7506952,'ire',25,1),(631,7506956,7506952,'rec',25,1),(631,7506957,7506952,'ect',25,1),(632,7506959,7506958,'naa',100,2),(632,7506960,7506959,'600',3.333,3),(632,7506961,7506959,'000',3.333,3),(632,7506962,7506959,'00c',3.333,3),(632,7506963,7506959,'0c2',3.333,3),(632,7506964,7506959,'c29',3.333,3),(632,7506965,7506959,'29e',3.333,3),(632,7506966,7506959,'9e9',3.333,3),(632,7506967,7506959,'e96',3.333,3),(632,7506968,7506959,'96c',3.333,3),(632,7506969,7506959,'6c8',3.333,3),(632,7506970,7506959,'c8e',3.333,3),(632,7506971,7506959,'8eb',3.333,3),(632,7506972,7506959,'eb9',3.333,3),(632,7506973,7506959,'b97',3.333,3),(632,7506974,7506959,'97d',3.333,3),(632,7506975,7506959,'7dd',3.333,3),(632,7506976,7506959,'ddc',3.333,3),(632,7506977,7506959,'dc1',3.333,3),(632,7506978,7506959,'c11',3.333,3),(632,7506979,7506959,'117',3.333,3),(632,7506980,7506959,'173',3.333,3),(632,7506981,7506959,'73c',3.333,3),(632,7506982,7506959,'3c2',3.333,3),(632,7506983,7506959,'c23',3.333,3),(632,7506984,7506959,'235',3.333,3),(632,7506985,7506959,'35d',3.333,3),(632,7506986,7506959,'5d3',3.333,3),(632,7506987,7506959,'d3a',3.333,3),(632,7506988,7506959,'3a8',3.333,3),(632,7506989,7506959,'a8b',3.333,3),(632,7506990,7506960,'mon',100,1),(632,7506991,7506990,'201',50,1),(632,7506992,7506990,'013',50,1),(632,7506993,7506991,'adm',33.333,3),(632,7506994,7506991,'dmi',33.333,3),(632,7506995,7506991,'min',33.333,3),(632,7506996,7506993,'cap',16.667,1),(632,7506997,7506993,'apa',16.667,1),(632,7506998,7506993,'pac',16.667,1),(632,7506999,7506993,'aci',16.667,1),(632,7507000,7506993,'cit',16.667,1),(632,7507001,7506993,'ity',16.667,1),(632,7507002,7506996,'pat',50,1),(632,7507003,7506996,'ath',50,1),(632,7507004,7507002,'fre',14.286,1),(632,7507005,7507002,'ree',14.286,1),(632,7507006,7507002,'ees',14.286,1),(632,7507007,7507002,'esp',14.286,1),(632,7507008,7507002,'spa',14.286,1),(632,7507009,7507002,'pac',14.286,1),(632,7507010,7507002,'ace',14.286,1),(632,7507011,7507004,'dis',50,1),(632,7507012,7507004,'isk',50,1),(632,7507013,7507011,'ind',33.333,1),(632,7507014,7507011,'nde',33.333,1),(632,7507015,7507011,'dex',33.333,1),(632,7507016,7507013,'adm',8.333,1),(632,7507017,7507013,'dmi',8.333,1),(632,7507018,7507013,'min',8.333,1),(632,7507019,7507013,'ini',8.333,1),(632,7507020,7507013,'nis',8.333,1),(632,7507021,7507013,'ist',8.333,1),(632,7507022,7507013,'str',8.333,1),(632,7507023,7507013,'tra',8.333,1),(632,7507024,7507013,'rat',8.333,1),(632,7507025,7507013,'ati',8.333,1),(632,7507026,7507013,'tio',8.333,1),(632,7507027,7507013,'ion',8.333,1),(632,7507028,7507016,'sta',33.333,3),(632,7507029,7507016,'tat',33.333,3),(632,7507030,7507016,'ate',33.333,3),(632,7507031,7507028,'ena',20,2),(632,7507032,7507028,'nab',20,2),(632,7507033,7507028,'abl',20,2),(632,7507034,7507028,'ble',20,2),(632,7507035,7507028,'led',20,2),(632,7507036,7507031,'cac',33.333,2),(632,7507037,7507031,'ach',33.333,2),(632,7507038,7507031,'che',33.333,2),(632,7507039,7507036,'mod',50,1),(632,7507040,7507036,'ode',50,1),(632,7507041,7507039,'wri',14.286,1),(632,7507042,7507039,'rit',14.286,1),(632,7507043,7507039,'ite',14.286,1),(632,7507044,7507039,'tet',14.286,1),(632,7507045,7507039,'eth',14.286,1),(632,7507046,7507039,'thr',14.286,1),(632,7507047,7507039,'hru',14.286,1),(632,7507048,7507041,'ope',11.111,2),(632,7507049,7507041,'per',11.111,2),(632,7507050,7507041,'era',11.111,2),(632,7507051,7507041,'rat',11.111,2),(632,7507052,7507041,'ati',11.111,2),(632,7507053,7507041,'tio',11.111,2),(632,7507054,7507041,'ion',11.111,2),(632,7507055,7507041,'ona',11.111,2),(632,7507056,7507041,'nal',11.111,2),(632,7507057,7507048,'pen',20,1),(632,7507058,7507048,'end',20,1),(632,7507059,7507048,'ndi',20,1),(632,7507060,7507048,'din',20,1),(632,7507061,7507048,'ing',20,1),(632,7507062,7507057,'mes',20,1),(632,7507063,7507057,'ess',20,1),(632,7507064,7507057,'ssa',20,1),(632,7507065,7507057,'sag',20,1),(632,7507066,7507057,'age',20,1),(632,7507067,7507062,'wai',20,1),(632,7507068,7507062,'ait',20,1),(632,7507069,7507062,'iti',20,1),(632,7507070,7507062,'tin',20,1),(632,7507071,7507062,'ing',20,1),(632,7507072,7507067,'for',100,1),(632,7507073,7507072,'per',11.111,1),(632,7507074,7507072,'erf',11.111,1),(632,7507075,7507072,'rfo',11.111,1),(632,7507076,7507072,'for',11.111,1),(632,7507077,7507072,'orm',11.111,1),(632,7507078,7507072,'rma',11.111,1),(632,7507079,7507072,'man',11.111,1),(632,7507080,7507072,'anc',11.111,1),(632,7507081,7507072,'nce',11.111,1),(632,7507082,7507073,'ide',12.5,1),(632,7507083,7507073,'den',12.5,1),(632,7507084,7507073,'ent',12.5,1),(632,7507085,7507073,'nti',12.5,1),(632,7507086,7507073,'tif',12.5,1),(632,7507087,7507073,'ifi',12.5,1),(632,7507088,7507073,'fie',12.5,1),(632,7507089,7507073,'ier',12.5,1),(632,7507090,7507082,'vdi',33.333,3),(632,7507091,7507082,'dis',33.333,3),(632,7507092,7507082,'isk',33.333,3),(632,7507093,7507090,'nam',50,1),(632,7507094,7507090,'ame',50,1),(632,7507095,7507093,'typ',50,1),(632,7507096,7507093,'ype',50,1),(632,7507097,7507095,'dir',25,1),(632,7507098,7507095,'ire',25,1),(632,7507099,7507095,'rec',25,1),(632,7507100,7507095,'ect',25,1),(633,7507102,7507101,'naa',100,2),(633,7507103,7507102,'600',3.333,3),(633,7507104,7507102,'000',3.333,3),(633,7507105,7507102,'00c',3.333,3),(633,7507106,7507102,'0c2',3.333,3),(633,7507107,7507102,'c29',3.333,3),(633,7507108,7507102,'298',3.333,3),(633,7507109,7507102,'98f',3.333,3),(633,7507110,7507102,'8f8',3.333,3),(633,7507111,7507102,'f8b',3.333,3),(633,7507112,7507102,'8bb',3.333,3),(633,7507113,7507102,'bb8',3.333,3),(633,7507114,7507102,'b89',3.333,3),(633,7507115,7507102,'894',3.333,3),(633,7507116,7507102,'94b',3.333,3),(633,7507117,7507102,'4b2',3.333,3),(633,7507118,7507102,'b2f',3.333,3),(633,7507119,7507102,'2f1',3.333,3),(633,7507120,7507102,'f1e',3.333,3),(633,7507121,7507102,'1e8',3.333,3),(633,7507122,7507102,'e84',3.333,3),(633,7507123,7507102,'84f',3.333,3),(633,7507124,7507102,'4fb',3.333,3),(633,7507125,7507102,'fb6',3.333,3),(633,7507126,7507102,'b63',3.333,3),(633,7507127,7507102,'630',3.333,3),(633,7507128,7507102,'30a',3.333,3),(633,7507129,7507102,'0a1',3.333,3),(633,7507130,7507102,'a1d',3.333,3),(633,7507131,7507102,'1dd',3.333,3),(633,7507132,7507102,'ddc',3.333,3),(633,7507133,7507103,'mon',100,1),(633,7507134,7507133,'201',50,1),(633,7507135,7507133,'013',50,1),(633,7507136,7507134,'adm',33.333,3),(633,7507137,7507134,'dmi',33.333,3),(633,7507138,7507134,'min',33.333,3),(633,7507139,7507136,'cap',16.667,1),(633,7507140,7507136,'apa',16.667,1),(633,7507141,7507136,'pac',16.667,1),(633,7507142,7507136,'aci',16.667,1),(633,7507143,7507136,'cit',16.667,1),(633,7507144,7507136,'ity',16.667,1),(633,7507145,7507139,'pat',50,1),(633,7507146,7507139,'ath',50,1),(633,7507147,7507145,'fre',14.286,1),(633,7507148,7507145,'ree',14.286,1),(633,7507149,7507145,'ees',14.286,1),(633,7507150,7507145,'esp',14.286,1),(633,7507151,7507145,'spa',14.286,1),(633,7507152,7507145,'pac',14.286,1),(633,7507153,7507145,'ace',14.286,1),(633,7507154,7507147,'dis',50,1),(633,7507155,7507147,'isk',50,1),(633,7507156,7507154,'ind',33.333,1),(633,7507157,7507154,'nde',33.333,1),(633,7507158,7507154,'dex',33.333,1),(633,7507159,7507156,'adm',8.333,1),(633,7507160,7507156,'dmi',8.333,1),(633,7507161,7507156,'min',8.333,1),(633,7507162,7507156,'ini',8.333,1),(633,7507163,7507156,'nis',8.333,1),(633,7507164,7507156,'ist',8.333,1),(633,7507165,7507156,'str',8.333,1),(633,7507166,7507156,'tra',8.333,1),(633,7507167,7507156,'rat',8.333,1),(633,7507168,7507156,'ati',8.333,1),(633,7507169,7507156,'tio',8.333,1),(633,7507170,7507156,'ion',8.333,1),(633,7507171,7507159,'sta',33.333,3),(633,7507172,7507159,'tat',33.333,3),(633,7507173,7507159,'ate',33.333,3),(633,7507174,7507171,'ena',20,2),(633,7507175,7507171,'nab',20,2),(633,7507176,7507171,'abl',20,2),(633,7507177,7507171,'ble',20,2),(633,7507178,7507171,'led',20,2),(633,7507179,7507174,'cac',33.333,2),(633,7507180,7507174,'ach',33.333,2),(633,7507181,7507174,'che',33.333,2),(633,7507182,7507179,'mod',50,1),(633,7507183,7507179,'ode',50,1),(633,7507184,7507182,'wri',14.286,1),(633,7507185,7507182,'rit',14.286,1),(633,7507186,7507182,'ite',14.286,1),(633,7507187,7507182,'tet',14.286,1),(633,7507188,7507182,'eth',14.286,1),(633,7507189,7507182,'thr',14.286,1),(633,7507190,7507182,'hru',14.286,1),(633,7507191,7507184,'ope',11.111,2),(633,7507192,7507184,'per',11.111,2),(633,7507193,7507184,'era',11.111,2),(633,7507194,7507184,'rat',11.111,2),(633,7507195,7507184,'ati',11.111,2),(633,7507196,7507184,'tio',11.111,2),(633,7507197,7507184,'ion',11.111,2),(633,7507198,7507184,'ona',11.111,2),(633,7507199,7507184,'nal',11.111,2),(633,7507200,7507191,'pen',20,1),(633,7507201,7507191,'end',20,1),(633,7507202,7507191,'ndi',20,1),(633,7507203,7507191,'din',20,1),(633,7507204,7507191,'ing',20,1),(633,7507205,7507200,'mes',20,1),(633,7507206,7507200,'ess',20,1),(633,7507207,7507200,'ssa',20,1),(633,7507208,7507200,'sag',20,1),(633,7507209,7507200,'age',20,1),(633,7507210,7507205,'wai',20,1),(633,7507211,7507205,'ait',20,1),(633,7507212,7507205,'iti',20,1),(633,7507213,7507205,'tin',20,1),(633,7507214,7507205,'ing',20,1),(633,7507215,7507210,'for',100,1),(633,7507216,7507215,'per',11.111,1),(633,7507217,7507215,'erf',11.111,1),(633,7507218,7507215,'rfo',11.111,1),(633,7507219,7507215,'for',11.111,1),(633,7507220,7507215,'orm',11.111,1),(633,7507221,7507215,'rma',11.111,1),(633,7507222,7507215,'man',11.111,1),(633,7507223,7507215,'anc',11.111,1),(633,7507224,7507215,'nce',11.111,1),(633,7507225,7507216,'ide',12.5,1),(633,7507226,7507216,'den',12.5,1),(633,7507227,7507216,'ent',12.5,1),(633,7507228,7507216,'nti',12.5,1),(633,7507229,7507216,'tif',12.5,1),(633,7507230,7507216,'ifi',12.5,1),(633,7507231,7507216,'fie',12.5,1),(633,7507232,7507216,'ier',12.5,1),(633,7507233,7507225,'vdi',33.333,3),(633,7507234,7507225,'dis',33.333,3),(633,7507235,7507225,'isk',33.333,3),(633,7507236,7507233,'nam',50,1),(633,7507237,7507233,'ame',50,1),(633,7507238,7507236,'typ',50,1),(633,7507239,7507236,'ype',50,1),(633,7507240,7507238,'dir',25,1),(633,7507241,7507238,'ire',25,1),(633,7507242,7507238,'rec',25,1),(633,7507243,7507238,'ect',25,1),(634,7507245,7507244,'naa',100,2),(634,7507246,7507245,'600',3.333,3),(634,7507247,7507245,'000',3.333,3),(634,7507248,7507245,'00c',3.333,3),(634,7507249,7507245,'0c2',3.333,3),(634,7507250,7507245,'c29',3.333,3),(634,7507251,7507245,'291',3.333,3),(634,7507252,7507245,'919',3.333,3),(634,7507253,7507245,'19a',3.333,3),(634,7507254,7507245,'9a7',3.333,3),(634,7507255,7507245,'a74',3.333,3),(634,7507256,7507245,'744',3.333,3),(634,7507257,7507245,'440',3.333,3),(634,7507258,7507245,'402',3.333,3),(634,7507259,7507245,'022',3.333,3),(634,7507260,7507245,'22d',3.333,3),(634,7507261,7507245,'2df',3.333,3),(634,7507262,7507245,'df5',3.333,3),(634,7507263,7507245,'f59',3.333,3),(634,7507264,7507245,'59d',3.333,3),(634,7507265,7507245,'9d4',3.333,3),(634,7507266,7507245,'d44',3.333,3),(634,7507267,7507245,'44c',3.333,3),(634,7507268,7507245,'4ca',3.333,3),(634,7507269,7507245,'ca5',3.333,3),(634,7507270,7507245,'a5c',3.333,3),(634,7507271,7507245,'5cc',3.333,3),(634,7507272,7507245,'cc2',3.333,3),(634,7507273,7507245,'c26',3.333,3),(634,7507274,7507245,'262',3.333,3),(634,7507275,7507245,'62c',3.333,3),(634,7507276,7507246,'mon',100,1),(634,7507277,7507276,'201',50,1),(634,7507278,7507276,'013',50,1),(634,7507279,7507277,'adm',33.333,3),(634,7507280,7507277,'dmi',33.333,3),(634,7507281,7507277,'min',33.333,3),(634,7507282,7507279,'cap',16.667,1),(634,7507283,7507279,'apa',16.667,1),(634,7507284,7507279,'pac',16.667,1),(634,7507285,7507279,'aci',16.667,1),(634,7507286,7507279,'cit',16.667,1),(634,7507287,7507279,'ity',16.667,1),(634,7507288,7507282,'pat',50,1),(634,7507289,7507282,'ath',50,1),(634,7507290,7507288,'fre',14.286,1),(634,7507291,7507288,'ree',14.286,1),(634,7507292,7507288,'ees',14.286,1),(634,7507293,7507288,'esp',14.286,1),(634,7507294,7507288,'spa',14.286,1),(634,7507295,7507288,'pac',14.286,1),(634,7507296,7507288,'ace',14.286,1),(634,7507297,7507290,'dis',50,1),(634,7507298,7507290,'isk',50,1),(634,7507299,7507297,'ind',33.333,1),(634,7507300,7507297,'nde',33.333,1),(634,7507301,7507297,'dex',33.333,1),(634,7507302,7507299,'adm',8.333,1),(634,7507303,7507299,'dmi',8.333,1),(634,7507304,7507299,'min',8.333,1),(634,7507305,7507299,'ini',8.333,1),(634,7507306,7507299,'nis',8.333,1),(634,7507307,7507299,'ist',8.333,1),(634,7507308,7507299,'str',8.333,1),(634,7507309,7507299,'tra',8.333,1),(634,7507310,7507299,'rat',8.333,1),(634,7507311,7507299,'ati',8.333,1),(634,7507312,7507299,'tio',8.333,1),(634,7507313,7507299,'ion',8.333,1),(634,7507314,7507302,'sta',33.333,3),(634,7507315,7507302,'tat',33.333,3),(634,7507316,7507302,'ate',33.333,3),(634,7507317,7507314,'ena',20,2),(634,7507318,7507314,'nab',20,2),(634,7507319,7507314,'abl',20,2),(634,7507320,7507314,'ble',20,2),(634,7507321,7507314,'led',20,2),(634,7507322,7507317,'cac',33.333,2),(634,7507323,7507317,'ach',33.333,2),(634,7507324,7507317,'che',33.333,2),(634,7507325,7507322,'mod',50,1),(634,7507326,7507322,'ode',50,1),(634,7507327,7507325,'wri',14.286,1),(634,7507328,7507325,'rit',14.286,1),(634,7507329,7507325,'ite',14.286,1),(634,7507330,7507325,'tet',14.286,1),(634,7507331,7507325,'eth',14.286,1),(634,7507332,7507325,'thr',14.286,1),(634,7507333,7507325,'hru',14.286,1),(634,7507334,7507327,'ope',11.111,2),(634,7507335,7507327,'per',11.111,2),(634,7507336,7507327,'era',11.111,2),(634,7507337,7507327,'rat',11.111,2),(634,7507338,7507327,'ati',11.111,2),(634,7507339,7507327,'tio',11.111,2),(634,7507340,7507327,'ion',11.111,2),(634,7507341,7507327,'ona',11.111,2),(634,7507342,7507327,'nal',11.111,2),(634,7507343,7507334,'pen',20,1),(634,7507344,7507334,'end',20,1),(634,7507345,7507334,'ndi',20,1),(634,7507346,7507334,'din',20,1),(634,7507347,7507334,'ing',20,1),(634,7507348,7507343,'mes',20,1),(634,7507349,7507343,'ess',20,1),(634,7507350,7507343,'ssa',20,1),(634,7507351,7507343,'sag',20,1),(634,7507352,7507343,'age',20,1),(634,7507353,7507348,'wai',20,1),(634,7507354,7507348,'ait',20,1),(634,7507355,7507348,'iti',20,1),(634,7507356,7507348,'tin',20,1),(634,7507357,7507348,'ing',20,1),(634,7507358,7507353,'for',100,1),(634,7507359,7507358,'per',11.111,1),(634,7507360,7507358,'erf',11.111,1),(634,7507361,7507358,'rfo',11.111,1),(634,7507362,7507358,'for',11.111,1),(634,7507363,7507358,'orm',11.111,1),(634,7507364,7507358,'rma',11.111,1),(634,7507365,7507358,'man',11.111,1),(634,7507366,7507358,'anc',11.111,1),(634,7507367,7507358,'nce',11.111,1),(634,7507368,7507359,'ide',12.5,1),(634,7507369,7507359,'den',12.5,1),(634,7507370,7507359,'ent',12.5,1),(634,7507371,7507359,'nti',12.5,1),(634,7507372,7507359,'tif',12.5,1),(634,7507373,7507359,'ifi',12.5,1),(634,7507374,7507359,'fie',12.5,1),(634,7507375,7507359,'ier',12.5,1),(634,7507376,7507368,'vdi',33.333,3),(634,7507377,7507368,'dis',33.333,3),(634,7507378,7507368,'isk',33.333,3),(634,7507379,7507376,'nam',50,1),(634,7507380,7507376,'ame',50,1),(634,7507381,7507379,'typ',50,1),(634,7507382,7507379,'ype',50,1),(634,7507383,7507381,'dir',25,1),(634,7507384,7507381,'ire',25,1),(634,7507385,7507381,'rec',25,1),(634,7507386,7507381,'ect',25,1),(635,7507388,7507387,'naa',100,2),(635,7507389,7507388,'600',3.333,3),(635,7507390,7507388,'000',3.333,3),(635,7507391,7507388,'00c',3.333,3),(635,7507392,7507388,'0c2',3.333,3),(635,7507393,7507388,'c29',3.333,3),(635,7507394,7507388,'296',3.333,3),(635,7507395,7507388,'967',3.333,3),(635,7507396,7507388,'670',3.333,3),(635,7507397,7507388,'70b',3.333,3),(635,7507398,7507388,'0b4',3.333,3),(635,7507399,7507388,'b45',3.333,3),(635,7507400,7507388,'45b',3.333,3),(635,7507401,7507388,'5b9',3.333,3),(635,7507402,7507388,'b96',3.333,3),(635,7507403,7507388,'960',3.333,3),(635,7507404,7507388,'600',3.333,3),(635,7507405,7507388,'003',3.333,3),(635,7507406,7507388,'036',3.333,3),(635,7507407,7507388,'367',3.333,3),(635,7507408,7507388,'670',3.333,3),(635,7507409,7507388,'70f',3.333,3),(635,7507410,7507388,'0f4',3.333,3),(635,7507411,7507388,'f42',3.333,3),(635,7507412,7507388,'424',3.333,3),(635,7507413,7507388,'246',3.333,3),(635,7507414,7507388,'461',3.333,3),(635,7507415,7507388,'61a',3.333,3),(635,7507416,7507388,'1a7',3.333,3),(635,7507417,7507388,'a75',3.333,3),(635,7507418,7507388,'757',3.333,3),(635,7507419,7507389,'mon',100,1),(635,7507420,7507419,'201',50,1),(635,7507421,7507419,'013',50,1),(635,7507422,7507420,'adm',33.333,3),(635,7507423,7507420,'dmi',33.333,3),(635,7507424,7507420,'min',33.333,3),(635,7507425,7507422,'cap',16.667,1),(635,7507426,7507422,'apa',16.667,1),(635,7507427,7507422,'pac',16.667,1),(635,7507428,7507422,'aci',16.667,1),(635,7507429,7507422,'cit',16.667,1),(635,7507430,7507422,'ity',16.667,1),(635,7507431,7507425,'pat',50,1),(635,7507432,7507425,'ath',50,1),(635,7507433,7507431,'fre',14.286,1),(635,7507434,7507431,'ree',14.286,1),(635,7507435,7507431,'ees',14.286,1),(635,7507436,7507431,'esp',14.286,1),(635,7507437,7507431,'spa',14.286,1),(635,7507438,7507431,'pac',14.286,1),(635,7507439,7507431,'ace',14.286,1),(635,7507440,7507433,'dis',50,1),(635,7507441,7507433,'isk',50,1),(635,7507442,7507440,'ind',33.333,1),(635,7507443,7507440,'nde',33.333,1),(635,7507444,7507440,'dex',33.333,1),(635,7507445,7507442,'adm',8.333,1),(635,7507446,7507442,'dmi',8.333,1),(635,7507447,7507442,'min',8.333,1),(635,7507448,7507442,'ini',8.333,1),(635,7507449,7507442,'nis',8.333,1),(635,7507450,7507442,'ist',8.333,1),(635,7507451,7507442,'str',8.333,1),(635,7507452,7507442,'tra',8.333,1),(635,7507453,7507442,'rat',8.333,1),(635,7507454,7507442,'ati',8.333,1),(635,7507455,7507442,'tio',8.333,1),(635,7507456,7507442,'ion',8.333,1),(635,7507457,7507445,'sta',33.333,3),(635,7507458,7507445,'tat',33.333,3),(635,7507459,7507445,'ate',33.333,3),(635,7507460,7507457,'ena',20,2),(635,7507461,7507457,'nab',20,2),(635,7507462,7507457,'abl',20,2),(635,7507463,7507457,'ble',20,2),(635,7507464,7507457,'led',20,2),(635,7507465,7507460,'cac',33.333,2),(635,7507466,7507460,'ach',33.333,2),(635,7507467,7507460,'che',33.333,2),(635,7507468,7507465,'mod',50,1),(635,7507469,7507465,'ode',50,1),(635,7507470,7507468,'wri',14.286,1),(635,7507471,7507468,'rit',14.286,1),(635,7507472,7507468,'ite',14.286,1),(635,7507473,7507468,'tet',14.286,1),(635,7507474,7507468,'eth',14.286,1),(635,7507475,7507468,'thr',14.286,1),(635,7507476,7507468,'hru',14.286,1),(635,7507477,7507470,'ope',11.111,2),(635,7507478,7507470,'per',11.111,2),(635,7507479,7507470,'era',11.111,2),(635,7507480,7507470,'rat',11.111,2),(635,7507481,7507470,'ati',11.111,2),(635,7507482,7507470,'tio',11.111,2),(635,7507483,7507470,'ion',11.111,2),(635,7507484,7507470,'ona',11.111,2),(635,7507485,7507470,'nal',11.111,2),(635,7507486,7507477,'pen',20,1),(635,7507487,7507477,'end',20,1),(635,7507488,7507477,'ndi',20,1),(635,7507489,7507477,'din',20,1),(635,7507490,7507477,'ing',20,1),(635,7507491,7507486,'mes',20,1),(635,7507492,7507486,'ess',20,1),(635,7507493,7507486,'ssa',20,1),(635,7507494,7507486,'sag',20,1),(635,7507495,7507486,'age',20,1),(635,7507496,7507491,'wai',20,1),(635,7507497,7507491,'ait',20,1),(635,7507498,7507491,'iti',20,1),(635,7507499,7507491,'tin',20,1),(635,7507500,7507491,'ing',20,1),(635,7507501,7507496,'for',100,1),(635,7507502,7507501,'per',11.111,1),(635,7507503,7507501,'erf',11.111,1),(635,7507504,7507501,'rfo',11.111,1),(635,7507505,7507501,'for',11.111,1),(635,7507506,7507501,'orm',11.111,1),(635,7507507,7507501,'rma',11.111,1),(635,7507508,7507501,'man',11.111,1),(635,7507509,7507501,'anc',11.111,1),(635,7507510,7507501,'nce',11.111,1),(635,7507511,7507502,'ide',12.5,1),(635,7507512,7507502,'den',12.5,1),(635,7507513,7507502,'ent',12.5,1),(635,7507514,7507502,'nti',12.5,1),(635,7507515,7507502,'tif',12.5,1),(635,7507516,7507502,'ifi',12.5,1),(635,7507517,7507502,'fie',12.5,1),(635,7507518,7507502,'ier',12.5,1),(635,7507519,7507511,'vdi',33.333,3),(635,7507520,7507511,'dis',33.333,3),(635,7507521,7507511,'isk',33.333,3),(635,7507522,7507519,'nam',50,1),(635,7507523,7507519,'ame',50,1),(635,7507524,7507522,'typ',50,1),(635,7507525,7507522,'ype',50,1),(635,7507526,7507524,'dir',25,1),(635,7507527,7507524,'ire',25,1),(635,7507528,7507524,'rec',25,1),(635,7507529,7507524,'ect',25,1),(636,7507531,7507530,'naa',100,2),(636,7507532,7507531,'600',3.333,3),(636,7507533,7507531,'000',3.333,3),(636,7507534,7507531,'00c',3.333,3),(636,7507535,7507531,'0c2',3.333,3),(636,7507536,7507531,'c29',3.333,3),(636,7507537,7507531,'293',3.333,3),(636,7507538,7507531,'936',3.333,3),(636,7507539,7507531,'36a',3.333,3),(636,7507540,7507531,'6a1',3.333,3),(636,7507541,7507531,'a1d',3.333,3),(636,7507542,7507531,'1d8',3.333,3),(636,7507543,7507531,'d8d',3.333,3),(636,7507544,7507531,'8d7',3.333,3),(636,7507545,7507531,'d75',3.333,3),(636,7507546,7507531,'750',3.333,3),(636,7507547,7507531,'502',3.333,3),(636,7507548,7507531,'023',3.333,3),(636,7507549,7507531,'23a',3.333,3),(636,7507550,7507531,'3a6',3.333,3),(636,7507551,7507531,'a67',3.333,3),(636,7507552,7507531,'672',3.333,3),(636,7507553,7507531,'72a',3.333,3),(636,7507554,7507531,'2ab',3.333,3),(636,7507555,7507531,'ab6',3.333,3),(636,7507556,7507531,'b6a',3.333,3),(636,7507557,7507531,'6ac',3.333,3),(636,7507558,7507531,'ac4',3.333,3),(636,7507559,7507531,'c4b',3.333,3),(636,7507560,7507531,'4bc',3.333,3),(636,7507561,7507531,'bc6',3.333,3),(636,7507562,7507532,'mon',100,1),(636,7507563,7507562,'201',50,1),(636,7507564,7507562,'013',50,1),(636,7507565,7507563,'adm',33.333,3),(636,7507566,7507563,'dmi',33.333,3),(636,7507567,7507563,'min',33.333,3),(636,7507568,7507565,'cap',16.667,1),(636,7507569,7507565,'apa',16.667,1),(636,7507570,7507565,'pac',16.667,1),(636,7507571,7507565,'aci',16.667,1),(636,7507572,7507565,'cit',16.667,1),(636,7507573,7507565,'ity',16.667,1),(636,7507574,7507568,'pat',50,1),(636,7507575,7507568,'ath',50,1),(636,7507576,7507574,'fre',14.286,1),(636,7507577,7507574,'ree',14.286,1),(636,7507578,7507574,'ees',14.286,1),(636,7507579,7507574,'esp',14.286,1),(636,7507580,7507574,'spa',14.286,1),(636,7507581,7507574,'pac',14.286,1),(636,7507582,7507574,'ace',14.286,1),(636,7507583,7507576,'dis',50,1),(636,7507584,7507576,'isk',50,1),(636,7507585,7507583,'ind',33.333,1),(636,7507586,7507583,'nde',33.333,1),(636,7507587,7507583,'dex',33.333,1),(636,7507588,7507585,'adm',8.333,1),(636,7507589,7507585,'dmi',8.333,1),(636,7507590,7507585,'min',8.333,1),(636,7507591,7507585,'ini',8.333,1),(636,7507592,7507585,'nis',8.333,1),(636,7507593,7507585,'ist',8.333,1),(636,7507594,7507585,'str',8.333,1),(636,7507595,7507585,'tra',8.333,1),(636,7507596,7507585,'rat',8.333,1),(636,7507597,7507585,'ati',8.333,1),(636,7507598,7507585,'tio',8.333,1),(636,7507599,7507585,'ion',8.333,1),(636,7507600,7507588,'sta',33.333,3),(636,7507601,7507588,'tat',33.333,3),(636,7507602,7507588,'ate',33.333,3),(636,7507603,7507600,'ena',20,2),(636,7507604,7507600,'nab',20,2),(636,7507605,7507600,'abl',20,2),(636,7507606,7507600,'ble',20,2),(636,7507607,7507600,'led',20,2),(636,7507608,7507603,'cac',33.333,2),(636,7507609,7507603,'ach',33.333,2),(636,7507610,7507603,'che',33.333,2),(636,7507611,7507608,'mod',50,1),(636,7507612,7507608,'ode',50,1),(636,7507613,7507611,'wri',14.286,1),(636,7507614,7507611,'rit',14.286,1),(636,7507615,7507611,'ite',14.286,1),(636,7507616,7507611,'tet',14.286,1),(636,7507617,7507611,'eth',14.286,1),(636,7507618,7507611,'thr',14.286,1),(636,7507619,7507611,'hru',14.286,1),(636,7507620,7507613,'ope',11.111,2),(636,7507621,7507613,'per',11.111,2),(636,7507622,7507613,'era',11.111,2),(636,7507623,7507613,'rat',11.111,2),(636,7507624,7507613,'ati',11.111,2),(636,7507625,7507613,'tio',11.111,2),(636,7507626,7507613,'ion',11.111,2),(636,7507627,7507613,'ona',11.111,2),(636,7507628,7507613,'nal',11.111,2),(636,7507629,7507620,'pen',20,1),(636,7507630,7507620,'end',20,1),(636,7507631,7507620,'ndi',20,1),(636,7507632,7507620,'din',20,1),(636,7507633,7507620,'ing',20,1),(636,7507634,7507629,'mes',20,1),(636,7507635,7507629,'ess',20,1),(636,7507636,7507629,'ssa',20,1),(636,7507637,7507629,'sag',20,1),(636,7507638,7507629,'age',20,1),(636,7507639,7507634,'wai',20,1),(636,7507640,7507634,'ait',20,1),(636,7507641,7507634,'iti',20,1),(636,7507642,7507634,'tin',20,1),(636,7507643,7507634,'ing',20,1),(636,7507644,7507639,'for',100,1),(636,7507645,7507644,'per',11.111,1),(636,7507646,7507644,'erf',11.111,1),(636,7507647,7507644,'rfo',11.111,1),(636,7507648,7507644,'for',11.111,1),(636,7507649,7507644,'orm',11.111,1),(636,7507650,7507644,'rma',11.111,1),(636,7507651,7507644,'man',11.111,1),(636,7507652,7507644,'anc',11.111,1),(636,7507653,7507644,'nce',11.111,1),(636,7507654,7507645,'ide',12.5,1),(636,7507655,7507645,'den',12.5,1),(636,7507656,7507645,'ent',12.5,1),(636,7507657,7507645,'nti',12.5,1),(636,7507658,7507645,'tif',12.5,1),(636,7507659,7507645,'ifi',12.5,1),(636,7507660,7507645,'fie',12.5,1),(636,7507661,7507645,'ier',12.5,1),(636,7507662,7507654,'vdi',33.333,3),(636,7507663,7507654,'dis',33.333,3),(636,7507664,7507654,'isk',33.333,3),(636,7507665,7507662,'nam',50,1),(636,7507666,7507662,'ame',50,1),(636,7507667,7507665,'typ',50,1),(636,7507668,7507665,'ype',50,1),(636,7507669,7507667,'dir',25,1),(636,7507670,7507667,'ire',25,1),(636,7507671,7507667,'rec',25,1),(636,7507672,7507667,'ect',25,1),(637,7507674,7507673,'naa',100,2),(637,7507675,7507674,'600',3.333,3),(637,7507676,7507674,'000',3.333,3),(637,7507677,7507674,'00c',3.333,3),(637,7507678,7507674,'0c2',3.333,3),(637,7507679,7507674,'c29',3.333,3),(637,7507680,7507674,'29c',3.333,3),(637,7507681,7507674,'9c0',3.333,3),(637,7507682,7507674,'c0b',3.333,3),(637,7507683,7507674,'0b0',3.333,3),(637,7507684,7507674,'b0f',3.333,3),(637,7507685,7507674,'0f8',3.333,3),(637,7507686,7507674,'f8d',3.333,3),(637,7507687,7507674,'8d4',3.333,3),(637,7507688,7507674,'d4b',3.333,3),(637,7507689,7507674,'4b8',3.333,3),(637,7507690,7507674,'b83',3.333,3),(637,7507691,7507674,'83b',3.333,3),(637,7507692,7507674,'3b2',3.333,3),(637,7507693,7507674,'b2c',3.333,3),(637,7507694,7507674,'2c2',3.333,3),(637,7507695,7507674,'c22',3.333,3),(637,7507696,7507674,'228',3.333,3),(637,7507697,7507674,'284',3.333,3),(637,7507698,7507674,'846',3.333,3),(637,7507699,7507674,'465',3.333,3),(637,7507700,7507674,'659',3.333,3),(637,7507701,7507674,'59d',3.333,3),(637,7507702,7507674,'9d8',3.333,3),(637,7507703,7507674,'d85',3.333,3),(637,7507704,7507674,'853',3.333,3),(637,7507705,7507675,'mon',100,1),(637,7507706,7507705,'201',50,1),(637,7507707,7507705,'013',50,1),(637,7507708,7507706,'adm',33.333,3),(637,7507709,7507706,'dmi',33.333,3),(637,7507710,7507706,'min',33.333,3),(637,7507711,7507708,'cap',16.667,1),(637,7507712,7507708,'apa',16.667,1),(637,7507713,7507708,'pac',16.667,1),(637,7507714,7507708,'aci',16.667,1),(637,7507715,7507708,'cit',16.667,1),(637,7507716,7507708,'ity',16.667,1),(637,7507717,7507711,'pat',50,1),(637,7507718,7507711,'ath',50,1),(637,7507719,7507717,'fre',14.286,1),(637,7507720,7507717,'ree',14.286,1),(637,7507721,7507717,'ees',14.286,1),(637,7507722,7507717,'esp',14.286,1),(637,7507723,7507717,'spa',14.286,1),(637,7507724,7507717,'pac',14.286,1),(637,7507725,7507717,'ace',14.286,1),(637,7507726,7507719,'dis',50,1),(637,7507727,7507719,'isk',50,1),(637,7507728,7507726,'ind',33.333,1),(637,7507729,7507726,'nde',33.333,1),(637,7507730,7507726,'dex',33.333,1),(637,7507731,7507728,'adm',8.333,1),(637,7507732,7507728,'dmi',8.333,1),(637,7507733,7507728,'min',8.333,1),(637,7507734,7507728,'ini',8.333,1),(637,7507735,7507728,'nis',8.333,1),(637,7507736,7507728,'ist',8.333,1),(637,7507737,7507728,'str',8.333,1),(637,7507738,7507728,'tra',8.333,1),(637,7507739,7507728,'rat',8.333,1),(637,7507740,7507728,'ati',8.333,1),(637,7507741,7507728,'tio',8.333,1),(637,7507742,7507728,'ion',8.333,1),(637,7507743,7507731,'sta',33.333,3),(637,7507744,7507731,'tat',33.333,3),(637,7507745,7507731,'ate',33.333,3),(637,7507746,7507743,'ena',20,2),(637,7507747,7507743,'nab',20,2),(637,7507748,7507743,'abl',20,2),(637,7507749,7507743,'ble',20,2),(637,7507750,7507743,'led',20,2),(637,7507751,7507746,'cac',33.333,2),(637,7507752,7507746,'ach',33.333,2),(637,7507753,7507746,'che',33.333,2),(637,7507754,7507751,'mod',50,1),(637,7507755,7507751,'ode',50,1),(637,7507756,7507754,'wri',14.286,1),(637,7507757,7507754,'rit',14.286,1),(637,7507758,7507754,'ite',14.286,1),(637,7507759,7507754,'tet',14.286,1),(637,7507760,7507754,'eth',14.286,1),(637,7507761,7507754,'thr',14.286,1),(637,7507762,7507754,'hru',14.286,1),(637,7507763,7507756,'ope',11.111,2),(637,7507764,7507756,'per',11.111,2),(637,7507765,7507756,'era',11.111,2),(637,7507766,7507756,'rat',11.111,2),(637,7507767,7507756,'ati',11.111,2),(637,7507768,7507756,'tio',11.111,2),(637,7507769,7507756,'ion',11.111,2),(637,7507770,7507756,'ona',11.111,2),(637,7507771,7507756,'nal',11.111,2),(637,7507772,7507763,'pen',20,1),(637,7507773,7507763,'end',20,1),(637,7507774,7507763,'ndi',20,1),(637,7507775,7507763,'din',20,1),(637,7507776,7507763,'ing',20,1),(637,7507777,7507772,'mes',20,1),(637,7507778,7507772,'ess',20,1),(637,7507779,7507772,'ssa',20,1),(637,7507780,7507772,'sag',20,1),(637,7507781,7507772,'age',20,1),(637,7507782,7507777,'wai',20,1),(637,7507783,7507777,'ait',20,1),(637,7507784,7507777,'iti',20,1),(637,7507785,7507777,'tin',20,1),(637,7507786,7507777,'ing',20,1),(637,7507787,7507782,'for',100,1),(637,7507788,7507787,'per',11.111,1),(637,7507789,7507787,'erf',11.111,1),(637,7507790,7507787,'rfo',11.111,1),(637,7507791,7507787,'for',11.111,1),(637,7507792,7507787,'orm',11.111,1),(637,7507793,7507787,'rma',11.111,1),(637,7507794,7507787,'man',11.111,1),(637,7507795,7507787,'anc',11.111,1),(637,7507796,7507787,'nce',11.111,1),(637,7507797,7507788,'ide',12.5,1),(637,7507798,7507788,'den',12.5,1),(637,7507799,7507788,'ent',12.5,1),(637,7507800,7507788,'nti',12.5,1),(637,7507801,7507788,'tif',12.5,1),(637,7507802,7507788,'ifi',12.5,1),(637,7507803,7507788,'fie',12.5,1),(637,7507804,7507788,'ier',12.5,1),(637,7507805,7507797,'vdi',33.333,3),(637,7507806,7507797,'dis',33.333,3),(637,7507807,7507797,'isk',33.333,3),(637,7507808,7507805,'nam',50,1),(637,7507809,7507805,'ame',50,1),(637,7507810,7507808,'typ',50,1),(637,7507811,7507808,'ype',50,1),(637,7507812,7507810,'dir',25,1),(637,7507813,7507810,'ire',25,1),(637,7507814,7507810,'rec',25,1),(637,7507815,7507810,'ect',25,1),(638,7507817,7507816,'naa',100,2),(638,7507818,7507817,'600',3.333,3),(638,7507819,7507817,'000',3.333,3),(638,7507820,7507817,'00c',3.333,3),(638,7507821,7507817,'0c2',3.333,3),(638,7507822,7507817,'c29',3.333,3),(638,7507823,7507817,'298',3.333,3),(638,7507824,7507817,'981',3.333,3),(638,7507825,7507817,'811',3.333,3),(638,7507826,7507817,'117',3.333,3),(638,7507827,7507817,'172',3.333,3),(638,7507828,7507817,'72d',3.333,3),(638,7507829,7507817,'2da',3.333,3),(638,7507830,7507817,'da9',3.333,3),(638,7507831,7507817,'a9f',3.333,3),(638,7507832,7507817,'9fa',3.333,3),(638,7507833,7507817,'fa3',3.333,3),(638,7507834,7507817,'a3b',3.333,3),(638,7507835,7507817,'3be',3.333,3),(638,7507836,7507817,'bec',3.333,3),(638,7507837,7507817,'eca',3.333,3),(638,7507838,7507817,'ca9',3.333,3),(638,7507839,7507817,'a9c',3.333,3),(638,7507840,7507817,'9c6',3.333,3),(638,7507841,7507817,'c60',3.333,3),(638,7507842,7507817,'608',3.333,3),(638,7507843,7507817,'081',3.333,3),(638,7507844,7507817,'814',3.333,3),(638,7507845,7507817,'14a',3.333,3),(638,7507846,7507817,'4a6',3.333,3),(638,7507847,7507817,'a6c',3.333,3),(638,7507848,7507818,'mon',100,1),(638,7507849,7507848,'201',50,1),(638,7507850,7507848,'013',50,1),(638,7507851,7507849,'adm',33.333,3),(638,7507852,7507849,'dmi',33.333,3),(638,7507853,7507849,'min',33.333,3),(638,7507854,7507851,'cap',16.667,1),(638,7507855,7507851,'apa',16.667,1),(638,7507856,7507851,'pac',16.667,1),(638,7507857,7507851,'aci',16.667,1),(638,7507858,7507851,'cit',16.667,1),(638,7507859,7507851,'ity',16.667,1),(638,7507860,7507854,'pat',50,1),(638,7507861,7507854,'ath',50,1),(638,7507862,7507860,'fre',14.286,1),(638,7507863,7507860,'ree',14.286,1),(638,7507864,7507860,'ees',14.286,1),(638,7507865,7507860,'esp',14.286,1),(638,7507866,7507860,'spa',14.286,1),(638,7507867,7507860,'pac',14.286,1),(638,7507868,7507860,'ace',14.286,1),(638,7507869,7507862,'dis',50,1),(638,7507870,7507862,'isk',50,1),(638,7507871,7507869,'ind',33.333,1),(638,7507872,7507869,'nde',33.333,1),(638,7507873,7507869,'dex',33.333,1),(638,7507874,7507871,'adm',8.333,1),(638,7507875,7507871,'dmi',8.333,1),(638,7507876,7507871,'min',8.333,1),(638,7507877,7507871,'ini',8.333,1),(638,7507878,7507871,'nis',8.333,1),(638,7507879,7507871,'ist',8.333,1),(638,7507880,7507871,'str',8.333,1),(638,7507881,7507871,'tra',8.333,1),(638,7507882,7507871,'rat',8.333,1),(638,7507883,7507871,'ati',8.333,1),(638,7507884,7507871,'tio',8.333,1),(638,7507885,7507871,'ion',8.333,1),(638,7507886,7507874,'sta',33.333,3),(638,7507887,7507874,'tat',33.333,3),(638,7507888,7507874,'ate',33.333,3),(638,7507889,7507886,'ena',20,2),(638,7507890,7507886,'nab',20,2),(638,7507891,7507886,'abl',20,2),(638,7507892,7507886,'ble',20,2),(638,7507893,7507886,'led',20,2),(638,7507894,7507889,'cac',33.333,2),(638,7507895,7507889,'ach',33.333,2),(638,7507896,7507889,'che',33.333,2),(638,7507897,7507894,'mod',50,1),(638,7507898,7507894,'ode',50,1),(638,7507899,7507897,'wri',14.286,1),(638,7507900,7507897,'rit',14.286,1),(638,7507901,7507897,'ite',14.286,1),(638,7507902,7507897,'tet',14.286,1),(638,7507903,7507897,'eth',14.286,1),(638,7507904,7507897,'thr',14.286,1),(638,7507905,7507897,'hru',14.286,1),(638,7507906,7507899,'ope',11.111,2),(638,7507907,7507899,'per',11.111,2),(638,7507908,7507899,'era',11.111,2),(638,7507909,7507899,'rat',11.111,2),(638,7507910,7507899,'ati',11.111,2),(638,7507911,7507899,'tio',11.111,2),(638,7507912,7507899,'ion',11.111,2),(638,7507913,7507899,'ona',11.111,2),(638,7507914,7507899,'nal',11.111,2),(638,7507915,7507906,'pen',20,1),(638,7507916,7507906,'end',20,1),(638,7507917,7507906,'ndi',20,1),(638,7507918,7507906,'din',20,1),(638,7507919,7507906,'ing',20,1),(638,7507920,7507915,'mes',20,1),(638,7507921,7507915,'ess',20,1),(638,7507922,7507915,'ssa',20,1),(638,7507923,7507915,'sag',20,1),(638,7507924,7507915,'age',20,1),(638,7507925,7507920,'wai',20,1),(638,7507926,7507920,'ait',20,1),(638,7507927,7507920,'iti',20,1),(638,7507928,7507920,'tin',20,1),(638,7507929,7507920,'ing',20,1),(638,7507930,7507925,'for',100,1),(638,7507931,7507930,'per',11.111,1),(638,7507932,7507930,'erf',11.111,1),(638,7507933,7507930,'rfo',11.111,1),(638,7507934,7507930,'for',11.111,1),(638,7507935,7507930,'orm',11.111,1),(638,7507936,7507930,'rma',11.111,1),(638,7507937,7507930,'man',11.111,1),(638,7507938,7507930,'anc',11.111,1),(638,7507939,7507930,'nce',11.111,1),(638,7507940,7507931,'ide',12.5,1),(638,7507941,7507931,'den',12.5,1),(638,7507942,7507931,'ent',12.5,1),(638,7507943,7507931,'nti',12.5,1),(638,7507944,7507931,'tif',12.5,1),(638,7507945,7507931,'ifi',12.5,1),(638,7507946,7507931,'fie',12.5,1),(638,7507947,7507931,'ier',12.5,1),(638,7507948,7507940,'vdi',33.333,3),(638,7507949,7507940,'dis',33.333,3),(638,7507950,7507940,'isk',33.333,3),(638,7507951,7507948,'nam',50,1),(638,7507952,7507948,'ame',50,1),(638,7507953,7507951,'typ',50,1),(638,7507954,7507951,'ype',50,1),(638,7507955,7507953,'dir',25,1),(638,7507956,7507953,'ire',25,1),(638,7507957,7507953,'rec',25,1),(638,7507958,7507953,'ect',25,1),(639,7507960,7507959,'naa',100,2),(639,7507961,7507960,'600',3.333,3),(639,7507962,7507960,'000',3.333,3),(639,7507963,7507960,'00c',3.333,3),(639,7507964,7507960,'0c2',3.333,3),(639,7507965,7507960,'c29',3.333,3),(639,7507966,7507960,'294',3.333,3),(639,7507967,7507960,'94c',3.333,3),(639,7507968,7507960,'4cd',3.333,3),(639,7507969,7507960,'cd2',3.333,3),(639,7507970,7507960,'d21',3.333,3),(639,7507971,7507960,'213',3.333,3),(639,7507972,7507960,'130',3.333,3),(639,7507973,7507960,'308',3.333,3),(639,7507974,7507960,'08e',3.333,3),(639,7507975,7507960,'8ec',3.333,3),(639,7507976,7507960,'ece',3.333,3),(639,7507977,7507960,'ce6',3.333,3),(639,7507978,7507960,'e62',3.333,3),(639,7507979,7507960,'62f',3.333,3),(639,7507980,7507960,'2f8',3.333,3),(639,7507981,7507960,'f84',3.333,3),(639,7507982,7507960,'84a',3.333,3),(639,7507983,7507960,'4ac',3.333,3),(639,7507984,7507960,'aca',3.333,3),(639,7507985,7507960,'ca9',3.333,3),(639,7507986,7507960,'a90',3.333,3),(639,7507987,7507960,'90d',3.333,3),(639,7507988,7507960,'0de',3.333,3),(639,7507989,7507960,'de7',3.333,3),(639,7507990,7507960,'e79',3.333,3),(639,7507991,7507961,'mon',100,1),(639,7507992,7507991,'201',50,1),(639,7507993,7507991,'013',50,1),(639,7507994,7507992,'adm',33.333,3),(639,7507995,7507992,'dmi',33.333,3),(639,7507996,7507992,'min',33.333,3),(639,7507997,7507994,'cap',16.667,1),(639,7507998,7507994,'apa',16.667,1),(639,7507999,7507994,'pac',16.667,1),(639,7508000,7507994,'aci',16.667,1),(639,7508001,7507994,'cit',16.667,1),(639,7508002,7507994,'ity',16.667,1),(639,7508003,7507997,'pat',50,1),(639,7508004,7507997,'ath',50,1),(639,7508005,7508003,'fre',14.286,1),(639,7508006,7508003,'ree',14.286,1),(639,7508007,7508003,'ees',14.286,1),(639,7508008,7508003,'esp',14.286,1),(639,7508009,7508003,'spa',14.286,1),(639,7508010,7508003,'pac',14.286,1),(639,7508011,7508003,'ace',14.286,1),(639,7508012,7508005,'dis',50,1),(639,7508013,7508005,'isk',50,1),(639,7508014,7508012,'ind',33.333,1),(639,7508015,7508012,'nde',33.333,1),(639,7508016,7508012,'dex',33.333,1),(639,7508017,7508014,'adm',8.333,1),(639,7508018,7508014,'dmi',8.333,1),(639,7508019,7508014,'min',8.333,1),(639,7508020,7508014,'ini',8.333,1),(639,7508021,7508014,'nis',8.333,1),(639,7508022,7508014,'ist',8.333,1),(639,7508023,7508014,'str',8.333,1),(639,7508024,7508014,'tra',8.333,1),(639,7508025,7508014,'rat',8.333,1),(639,7508026,7508014,'ati',8.333,1),(639,7508027,7508014,'tio',8.333,1),(639,7508028,7508014,'ion',8.333,1),(639,7508029,7508017,'sta',33.333,3),(639,7508030,7508017,'tat',33.333,3),(639,7508031,7508017,'ate',33.333,3),(639,7508032,7508029,'ena',20,2),(639,7508033,7508029,'nab',20,2),(639,7508034,7508029,'abl',20,2),(639,7508035,7508029,'ble',20,2),(639,7508036,7508029,'led',20,2),(639,7508037,7508032,'cac',33.333,2),(639,7508038,7508032,'ach',33.333,2),(639,7508039,7508032,'che',33.333,2),(639,7508040,7508037,'mod',50,1),(639,7508041,7508037,'ode',50,1),(639,7508042,7508040,'wri',14.286,1),(639,7508043,7508040,'rit',14.286,1),(639,7508044,7508040,'ite',14.286,1),(639,7508045,7508040,'tet',14.286,1),(639,7508046,7508040,'eth',14.286,1),(639,7508047,7508040,'thr',14.286,1),(639,7508048,7508040,'hru',14.286,1),(639,7508049,7508042,'ope',11.111,2),(639,7508050,7508042,'per',11.111,2),(639,7508051,7508042,'era',11.111,2),(639,7508052,7508042,'rat',11.111,2),(639,7508053,7508042,'ati',11.111,2),(639,7508054,7508042,'tio',11.111,2),(639,7508055,7508042,'ion',11.111,2),(639,7508056,7508042,'ona',11.111,2),(639,7508057,7508042,'nal',11.111,2),(639,7508058,7508049,'pen',20,1),(639,7508059,7508049,'end',20,1),(639,7508060,7508049,'ndi',20,1),(639,7508061,7508049,'din',20,1),(639,7508062,7508049,'ing',20,1),(639,7508063,7508058,'mes',20,1),(639,7508064,7508058,'ess',20,1),(639,7508065,7508058,'ssa',20,1),(639,7508066,7508058,'sag',20,1),(639,7508067,7508058,'age',20,1),(639,7508068,7508063,'wai',20,1),(639,7508069,7508063,'ait',20,1),(639,7508070,7508063,'iti',20,1),(639,7508071,7508063,'tin',20,1),(639,7508072,7508063,'ing',20,1),(639,7508073,7508068,'for',100,1),(639,7508074,7508073,'per',11.111,1),(639,7508075,7508073,'erf',11.111,1),(639,7508076,7508073,'rfo',11.111,1),(639,7508077,7508073,'for',11.111,1),(639,7508078,7508073,'orm',11.111,1),(639,7508079,7508073,'rma',11.111,1),(639,7508080,7508073,'man',11.111,1),(639,7508081,7508073,'anc',11.111,1),(639,7508082,7508073,'nce',11.111,1),(639,7508083,7508074,'ide',12.5,1),(639,7508084,7508074,'den',12.5,1),(639,7508085,7508074,'ent',12.5,1),(639,7508086,7508074,'nti',12.5,1),(639,7508087,7508074,'tif',12.5,1),(639,7508088,7508074,'ifi',12.5,1),(639,7508089,7508074,'fie',12.5,1),(639,7508090,7508074,'ier',12.5,1),(639,7508091,7508083,'vdi',33.333,3),(639,7508092,7508083,'dis',33.333,3),(639,7508093,7508083,'isk',33.333,3),(639,7508094,7508091,'nam',50,1),(639,7508095,7508091,'ame',50,1),(639,7508096,7508094,'typ',50,1),(639,7508097,7508094,'ype',50,1),(639,7508098,7508096,'dir',25,1),(639,7508099,7508096,'ire',25,1),(639,7508100,7508096,'rec',25,1),(639,7508101,7508096,'ect',25,1),(640,7508103,7508102,'naa',100,2),(640,7508104,7508103,'600',3.333,3),(640,7508105,7508103,'000',3.333,3),(640,7508106,7508103,'00c',3.333,3),(640,7508107,7508103,'0c2',3.333,3),(640,7508108,7508103,'c29',3.333,3),(640,7508109,7508103,'299',3.333,3),(640,7508110,7508103,'99e',3.333,3),(640,7508111,7508103,'9e8',3.333,3),(640,7508112,7508103,'e86',3.333,3),(640,7508113,7508103,'863',3.333,3),(640,7508114,7508103,'636',3.333,3),(640,7508115,7508103,'36b',3.333,3),(640,7508116,7508103,'6bf',3.333,3),(640,7508117,7508103,'bf1',3.333,3),(640,7508118,7508103,'f10',3.333,3),(640,7508119,7508103,'105',3.333,3),(640,7508120,7508103,'055',3.333,3),(640,7508121,7508103,'553',3.333,3),(640,7508122,7508103,'535',3.333,3),(640,7508123,7508103,'358',3.333,3),(640,7508124,7508103,'58e',3.333,3),(640,7508125,7508103,'8ea',3.333,3),(640,7508126,7508103,'ea3',3.333,3),(640,7508127,7508103,'a35',3.333,3),(640,7508128,7508103,'354',3.333,3),(640,7508129,7508103,'547',3.333,3),(640,7508130,7508103,'479',3.333,3),(640,7508131,7508103,'792',3.333,3),(640,7508132,7508103,'92e',3.333,3),(640,7508133,7508103,'2e3',3.333,3),(640,7508134,7508104,'mon',100,1),(640,7508135,7508134,'201',50,1),(640,7508136,7508134,'013',50,1),(640,7508137,7508135,'adm',33.333,3),(640,7508138,7508135,'dmi',33.333,3),(640,7508139,7508135,'min',33.333,3),(640,7508140,7508137,'cap',16.667,1),(640,7508141,7508137,'apa',16.667,1),(640,7508142,7508137,'pac',16.667,1),(640,7508143,7508137,'aci',16.667,1),(640,7508144,7508137,'cit',16.667,1),(640,7508145,7508137,'ity',16.667,1),(640,7508146,7508140,'pat',50,1),(640,7508147,7508140,'ath',50,1),(640,7508148,7508146,'fre',14.286,1),(640,7508149,7508146,'ree',14.286,1),(640,7508150,7508146,'ees',14.286,1),(640,7508151,7508146,'esp',14.286,1),(640,7508152,7508146,'spa',14.286,1),(640,7508153,7508146,'pac',14.286,1),(640,7508154,7508146,'ace',14.286,1),(640,7508155,7508148,'dis',50,1),(640,7508156,7508148,'isk',50,1),(640,7508157,7508155,'ind',33.333,1),(640,7508158,7508155,'nde',33.333,1),(640,7508159,7508155,'dex',33.333,1),(640,7508160,7508157,'adm',8.333,1),(640,7508161,7508157,'dmi',8.333,1),(640,7508162,7508157,'min',8.333,1),(640,7508163,7508157,'ini',8.333,1),(640,7508164,7508157,'nis',8.333,1),(640,7508165,7508157,'ist',8.333,1),(640,7508166,7508157,'str',8.333,1),(640,7508167,7508157,'tra',8.333,1),(640,7508168,7508157,'rat',8.333,1),(640,7508169,7508157,'ati',8.333,1),(640,7508170,7508157,'tio',8.333,1),(640,7508171,7508157,'ion',8.333,1),(640,7508172,7508160,'sta',33.333,3),(640,7508173,7508160,'tat',33.333,3),(640,7508174,7508160,'ate',33.333,3),(640,7508175,7508172,'ena',20,2),(640,7508176,7508172,'nab',20,2),(640,7508177,7508172,'abl',20,2),(640,7508178,7508172,'ble',20,2),(640,7508179,7508172,'led',20,2),(640,7508180,7508175,'cac',33.333,2),(640,7508181,7508175,'ach',33.333,2),(640,7508182,7508175,'che',33.333,2),(640,7508183,7508180,'mod',50,1),(640,7508184,7508180,'ode',50,1),(640,7508185,7508183,'wri',14.286,1),(640,7508186,7508183,'rit',14.286,1),(640,7508187,7508183,'ite',14.286,1),(640,7508188,7508183,'tet',14.286,1),(640,7508189,7508183,'eth',14.286,1),(640,7508190,7508183,'thr',14.286,1),(640,7508191,7508183,'hru',14.286,1),(640,7508192,7508185,'ope',11.111,2),(640,7508193,7508185,'per',11.111,2),(640,7508194,7508185,'era',11.111,2),(640,7508195,7508185,'rat',11.111,2),(640,7508196,7508185,'ati',11.111,2),(640,7508197,7508185,'tio',11.111,2),(640,7508198,7508185,'ion',11.111,2),(640,7508199,7508185,'ona',11.111,2),(640,7508200,7508185,'nal',11.111,2),(640,7508201,7508192,'pen',20,1),(640,7508202,7508192,'end',20,1),(640,7508203,7508192,'ndi',20,1),(640,7508204,7508192,'din',20,1),(640,7508205,7508192,'ing',20,1),(640,7508206,7508201,'mes',20,1),(640,7508207,7508201,'ess',20,1),(640,7508208,7508201,'ssa',20,1),(640,7508209,7508201,'sag',20,1),(640,7508210,7508201,'age',20,1),(640,7508211,7508206,'wai',20,1),(640,7508212,7508206,'ait',20,1),(640,7508213,7508206,'iti',20,1),(640,7508214,7508206,'tin',20,1),(640,7508215,7508206,'ing',20,1),(640,7508216,7508211,'for',100,1),(640,7508217,7508216,'per',11.111,1),(640,7508218,7508216,'erf',11.111,1),(640,7508219,7508216,'rfo',11.111,1),(640,7508220,7508216,'for',11.111,1),(640,7508221,7508216,'orm',11.111,1),(640,7508222,7508216,'rma',11.111,1),(640,7508223,7508216,'man',11.111,1),(640,7508224,7508216,'anc',11.111,1),(640,7508225,7508216,'nce',11.111,1),(640,7508226,7508217,'ide',12.5,1),(640,7508227,7508217,'den',12.5,1),(640,7508228,7508217,'ent',12.5,1),(640,7508229,7508217,'nti',12.5,1),(640,7508230,7508217,'tif',12.5,1),(640,7508231,7508217,'ifi',12.5,1),(640,7508232,7508217,'fie',12.5,1),(640,7508233,7508217,'ier',12.5,1),(640,7508234,7508226,'vdi',33.333,3),(640,7508235,7508226,'dis',33.333,3),(640,7508236,7508226,'isk',33.333,3),(640,7508237,7508234,'nam',50,1),(640,7508238,7508234,'ame',50,1),(640,7508239,7508237,'typ',50,1),(640,7508240,7508237,'ype',50,1),(640,7508241,7508239,'dir',25,1),(640,7508242,7508239,'ire',25,1),(640,7508243,7508239,'rec',25,1),(640,7508244,7508239,'ect',25,1),(641,7508246,7508245,'naa',100,2),(641,7508247,7508246,'600',3.333,3),(641,7508248,7508246,'000',3.333,3),(641,7508249,7508246,'00c',3.333,3),(641,7508250,7508246,'0c2',3.333,3),(641,7508251,7508246,'c29',3.333,3),(641,7508252,7508246,'295',3.333,3),(641,7508253,7508246,'950',3.333,3),(641,7508254,7508246,'504',3.333,3),(641,7508255,7508246,'044',3.333,3),(641,7508256,7508246,'44e',3.333,3),(641,7508257,7508246,'4e2',3.333,3),(641,7508258,7508246,'e28',3.333,3),(641,7508259,7508246,'287',3.333,3),(641,7508260,7508246,'87d',3.333,3),(641,7508261,7508246,'7d8',3.333,3),(641,7508262,7508246,'d8f',3.333,3),(641,7508263,7508246,'8f8',3.333,3),(641,7508264,7508246,'f88',3.333,3),(641,7508265,7508246,'880',3.333,3),(641,7508266,7508246,'800',3.333,3),(641,7508267,7508246,'00c',3.333,3),(641,7508268,7508246,'0ca',3.333,3),(641,7508269,7508246,'ca1',3.333,3),(641,7508270,7508246,'a1a',3.333,3),(641,7508271,7508246,'1a1',3.333,3),(641,7508272,7508246,'a17',3.333,3),(641,7508273,7508246,'179',3.333,3),(641,7508274,7508246,'793',3.333,3),(641,7508275,7508246,'930',3.333,3),(641,7508276,7508246,'30a',3.333,3),(641,7508277,7508247,'mon',100,1),(641,7508278,7508277,'201',50,1),(641,7508279,7508277,'013',50,1),(641,7508280,7508278,'adm',33.333,3),(641,7508281,7508278,'dmi',33.333,3),(641,7508282,7508278,'min',33.333,3),(641,7508283,7508280,'cap',16.667,1),(641,7508284,7508280,'apa',16.667,1),(641,7508285,7508280,'pac',16.667,1),(641,7508286,7508280,'aci',16.667,1),(641,7508287,7508280,'cit',16.667,1),(641,7508288,7508280,'ity',16.667,1),(641,7508289,7508283,'pat',50,1),(641,7508290,7508283,'ath',50,1),(641,7508291,7508289,'fre',14.286,1),(641,7508292,7508289,'ree',14.286,1),(641,7508293,7508289,'ees',14.286,1),(641,7508294,7508289,'esp',14.286,1),(641,7508295,7508289,'spa',14.286,1),(641,7508296,7508289,'pac',14.286,1),(641,7508297,7508289,'ace',14.286,1),(641,7508298,7508291,'dis',50,1),(641,7508299,7508291,'isk',50,1),(641,7508300,7508298,'ind',33.333,1),(641,7508301,7508298,'nde',33.333,1),(641,7508302,7508298,'dex',33.333,1),(641,7508303,7508300,'adm',8.333,1),(641,7508304,7508300,'dmi',8.333,1),(641,7508305,7508300,'min',8.333,1),(641,7508306,7508300,'ini',8.333,1),(641,7508307,7508300,'nis',8.333,1),(641,7508308,7508300,'ist',8.333,1),(641,7508309,7508300,'str',8.333,1),(641,7508310,7508300,'tra',8.333,1),(641,7508311,7508300,'rat',8.333,1),(641,7508312,7508300,'ati',8.333,1),(641,7508313,7508300,'tio',8.333,1),(641,7508314,7508300,'ion',8.333,1),(641,7508315,7508303,'sta',33.333,3),(641,7508316,7508303,'tat',33.333,3),(641,7508317,7508303,'ate',33.333,3),(641,7508318,7508315,'ena',20,2),(641,7508319,7508315,'nab',20,2),(641,7508320,7508315,'abl',20,2),(641,7508321,7508315,'ble',20,2),(641,7508322,7508315,'led',20,2),(641,7508323,7508318,'cac',33.333,2),(641,7508324,7508318,'ach',33.333,2),(641,7508325,7508318,'che',33.333,2),(641,7508326,7508323,'mod',50,1),(641,7508327,7508323,'ode',50,1),(641,7508328,7508326,'wri',14.286,1),(641,7508329,7508326,'rit',14.286,1),(641,7508330,7508326,'ite',14.286,1),(641,7508331,7508326,'tet',14.286,1),(641,7508332,7508326,'eth',14.286,1),(641,7508333,7508326,'thr',14.286,1),(641,7508334,7508326,'hru',14.286,1),(641,7508335,7508328,'ope',11.111,2),(641,7508336,7508328,'per',11.111,2),(641,7508337,7508328,'era',11.111,2),(641,7508338,7508328,'rat',11.111,2),(641,7508339,7508328,'ati',11.111,2),(641,7508340,7508328,'tio',11.111,2),(641,7508341,7508328,'ion',11.111,2),(641,7508342,7508328,'ona',11.111,2),(641,7508343,7508328,'nal',11.111,2),(641,7508344,7508335,'pen',20,1),(641,7508345,7508335,'end',20,1),(641,7508346,7508335,'ndi',20,1),(641,7508347,7508335,'din',20,1),(641,7508348,7508335,'ing',20,1),(641,7508349,7508344,'mes',20,1),(641,7508350,7508344,'ess',20,1),(641,7508351,7508344,'ssa',20,1),(641,7508352,7508344,'sag',20,1),(641,7508353,7508344,'age',20,1),(641,7508354,7508349,'wai',20,1),(641,7508355,7508349,'ait',20,1),(641,7508356,7508349,'iti',20,1),(641,7508357,7508349,'tin',20,1),(641,7508358,7508349,'ing',20,1),(641,7508359,7508354,'for',100,1),(641,7508360,7508359,'per',11.111,1),(641,7508361,7508359,'erf',11.111,1),(641,7508362,7508359,'rfo',11.111,1),(641,7508363,7508359,'for',11.111,1),(641,7508364,7508359,'orm',11.111,1),(641,7508365,7508359,'rma',11.111,1),(641,7508366,7508359,'man',11.111,1),(641,7508367,7508359,'anc',11.111,1),(641,7508368,7508359,'nce',11.111,1),(641,7508369,7508360,'ide',12.5,1),(641,7508370,7508360,'den',12.5,1),(641,7508371,7508360,'ent',12.5,1),(641,7508372,7508360,'nti',12.5,1),(641,7508373,7508360,'tif',12.5,1),(641,7508374,7508360,'ifi',12.5,1),(641,7508375,7508360,'fie',12.5,1),(641,7508376,7508360,'ier',12.5,1),(641,7508377,7508369,'vdi',33.333,3),(641,7508378,7508369,'dis',33.333,3),(641,7508379,7508369,'isk',33.333,3),(641,7508380,7508377,'nam',50,1),(641,7508381,7508377,'ame',50,1),(641,7508382,7508380,'typ',50,1),(641,7508383,7508380,'ype',50,1),(641,7508384,7508382,'dir',25,1),(641,7508385,7508382,'ire',25,1),(641,7508386,7508382,'rec',25,1),(641,7508387,7508382,'ect',25,1),(642,7508389,7508388,'naa',100,2),(642,7508390,7508389,'600',3.333,3),(642,7508391,7508389,'000',3.333,3),(642,7508392,7508389,'00c',3.333,3),(642,7508393,7508389,'0c2',3.333,3),(642,7508394,7508389,'c29',3.333,3),(642,7508395,7508389,'292',3.333,3),(642,7508396,7508389,'922',3.333,3),(642,7508397,7508389,'22c',3.333,3),(642,7508398,7508389,'2ca',3.333,3),(642,7508399,7508389,'ca3',3.333,3),(642,7508400,7508389,'a33',3.333,3),(642,7508401,7508389,'33e',3.333,3),(642,7508402,7508389,'3e3',3.333,3),(642,7508403,7508389,'e3f',3.333,3),(642,7508404,7508389,'3ff',3.333,3),(642,7508405,7508389,'ff4',3.333,3),(642,7508406,7508389,'f4c',3.333,3),(642,7508407,7508389,'4c6',3.333,3),(642,7508408,7508389,'c6b',3.333,3),(642,7508409,7508389,'6b2',3.333,3),(642,7508410,7508389,'b2d',3.333,3),(642,7508411,7508389,'2d2',3.333,3),(642,7508412,7508389,'d25',3.333,3),(642,7508413,7508389,'251',3.333,3),(642,7508414,7508389,'511',3.333,3),(642,7508415,7508389,'11b',3.333,3),(642,7508416,7508389,'1bf',3.333,3),(642,7508417,7508389,'bf8',3.333,3),(642,7508418,7508389,'f80',3.333,3),(642,7508419,7508389,'80b',3.333,3),(642,7508420,7508390,'mon',100,1),(642,7508421,7508420,'201',50,1),(642,7508422,7508420,'013',50,1),(642,7508423,7508421,'adm',33.333,3),(642,7508424,7508421,'dmi',33.333,3),(642,7508425,7508421,'min',33.333,3),(642,7508426,7508423,'cap',16.667,1),(642,7508427,7508423,'apa',16.667,1),(642,7508428,7508423,'pac',16.667,1),(642,7508429,7508423,'aci',16.667,1),(642,7508430,7508423,'cit',16.667,1),(642,7508431,7508423,'ity',16.667,1),(642,7508432,7508426,'pat',50,1),(642,7508433,7508426,'ath',50,1),(642,7508434,7508432,'fre',14.286,1),(642,7508435,7508432,'ree',14.286,1),(642,7508436,7508432,'ees',14.286,1),(642,7508437,7508432,'esp',14.286,1),(642,7508438,7508432,'spa',14.286,1),(642,7508439,7508432,'pac',14.286,1),(642,7508440,7508432,'ace',14.286,1),(642,7508441,7508434,'dis',50,1),(642,7508442,7508434,'isk',50,1),(642,7508443,7508441,'ind',33.333,1),(642,7508444,7508441,'nde',33.333,1),(642,7508445,7508441,'dex',33.333,1),(642,7508446,7508443,'adm',8.333,1),(642,7508447,7508443,'dmi',8.333,1),(642,7508448,7508443,'min',8.333,1),(642,7508449,7508443,'ini',8.333,1),(642,7508450,7508443,'nis',8.333,1),(642,7508451,7508443,'ist',8.333,1),(642,7508452,7508443,'str',8.333,1),(642,7508453,7508443,'tra',8.333,1),(642,7508454,7508443,'rat',8.333,1),(642,7508455,7508443,'ati',8.333,1),(642,7508456,7508443,'tio',8.333,1),(642,7508457,7508443,'ion',8.333,1),(642,7508458,7508446,'sta',33.333,3),(642,7508459,7508446,'tat',33.333,3),(642,7508460,7508446,'ate',33.333,3),(642,7508461,7508458,'ena',20,2),(642,7508462,7508458,'nab',20,2),(642,7508463,7508458,'abl',20,2),(642,7508464,7508458,'ble',20,2),(642,7508465,7508458,'led',20,2),(642,7508466,7508461,'cac',33.333,2),(642,7508467,7508461,'ach',33.333,2),(642,7508468,7508461,'che',33.333,2),(642,7508469,7508466,'mod',50,1),(642,7508470,7508466,'ode',50,1),(642,7508471,7508469,'wri',14.286,1),(642,7508472,7508469,'rit',14.286,1),(642,7508473,7508469,'ite',14.286,1),(642,7508474,7508469,'tet',14.286,1),(642,7508475,7508469,'eth',14.286,1),(642,7508476,7508469,'thr',14.286,1),(642,7508477,7508469,'hru',14.286,1),(642,7508478,7508471,'ope',11.111,2),(642,7508479,7508471,'per',11.111,2),(642,7508480,7508471,'era',11.111,2),(642,7508481,7508471,'rat',11.111,2),(642,7508482,7508471,'ati',11.111,2),(642,7508483,7508471,'tio',11.111,2),(642,7508484,7508471,'ion',11.111,2),(642,7508485,7508471,'ona',11.111,2),(642,7508486,7508471,'nal',11.111,2),(642,7508487,7508478,'pen',20,1),(642,7508488,7508478,'end',20,1),(642,7508489,7508478,'ndi',20,1),(642,7508490,7508478,'din',20,1),(642,7508491,7508478,'ing',20,1),(642,7508492,7508487,'mes',20,1),(642,7508493,7508487,'ess',20,1),(642,7508494,7508487,'ssa',20,1),(642,7508495,7508487,'sag',20,1),(642,7508496,7508487,'age',20,1),(642,7508497,7508492,'wai',20,1),(642,7508498,7508492,'ait',20,1),(642,7508499,7508492,'iti',20,1),(642,7508500,7508492,'tin',20,1),(642,7508501,7508492,'ing',20,1),(642,7508502,7508497,'for',100,1),(642,7508503,7508502,'per',11.111,1),(642,7508504,7508502,'erf',11.111,1),(642,7508505,7508502,'rfo',11.111,1),(642,7508506,7508502,'for',11.111,1),(642,7508507,7508502,'orm',11.111,1),(642,7508508,7508502,'rma',11.111,1),(642,7508509,7508502,'man',11.111,1),(642,7508510,7508502,'anc',11.111,1),(642,7508511,7508502,'nce',11.111,1),(642,7508512,7508503,'ide',12.5,1),(642,7508513,7508503,'den',12.5,1),(642,7508514,7508503,'ent',12.5,1),(642,7508515,7508503,'nti',12.5,1),(642,7508516,7508503,'tif',12.5,1),(642,7508517,7508503,'ifi',12.5,1),(642,7508518,7508503,'fie',12.5,1),(642,7508519,7508503,'ier',12.5,1),(642,7508520,7508512,'vdi',33.333,3),(642,7508521,7508512,'dis',33.333,3),(642,7508522,7508512,'isk',33.333,3),(642,7508523,7508520,'nam',50,1),(642,7508524,7508520,'ame',50,1),(642,7508525,7508523,'typ',50,1),(642,7508526,7508523,'ype',50,1),(642,7508527,7508525,'dir',25,1),(642,7508528,7508525,'ire',25,1),(642,7508529,7508525,'rec',25,1),(642,7508530,7508525,'ect',25,1),(583,7508722,7508721,'att',12.5,1),(583,7508723,7508721,'ttr',12.5,1),(583,7508724,7508721,'tri',12.5,1),(583,7508725,7508721,'rib',12.5,1),(583,7508726,7508721,'ibu',12.5,1),(583,7508727,7508721,'but',12.5,1),(583,7508728,7508721,'ute',12.5,1),(583,7508729,7508721,'tes',12.5,1),(583,7508730,7508722,'ref',20,3),(583,7508731,7508722,'efr',20,3),(583,7508732,7508722,'fre',20,3),(583,7508733,7508722,'res',20,3),(583,7508734,7508722,'esh',20,3),(583,7508735,7508730,'hos',50,2),(583,7508736,7508730,'ost',50,2),(583,7508737,7508735,'nam',50,2),(583,7508738,7508735,'ame',50,2),(583,7508739,7508737,'hg3',9.091,1),(583,7508740,7508737,'g32',9.091,1),(583,7508741,7508737,'32v',9.091,1),(583,7508742,7508737,'2vm',9.091,1),(583,7508743,7508737,'vm7',9.091,1),(583,7508744,7508737,'m7w',9.091,1),(583,7508745,7508737,'7w2',9.091,1),(583,7508746,7508737,'w2k',9.091,1),(583,7508747,7508737,'2k8',9.091,1),(583,7508748,7508737,'k8r',9.091,1),(583,7508749,7508737,'8r2',9.091,1),(583,7508750,7508739,'gdl',100,1),(583,7508751,7508750,'eng',25,1),(583,7508752,7508750,'ngl',25,1),(583,7508753,7508750,'gla',25,1),(583,7508754,7508750,'lab',25,1),(583,7508755,7508751,'net',25,1),(583,7508756,7508751,'eta',25,1),(583,7508757,7508751,'tap',25,1),(583,7508758,7508751,'app',25,1),(583,7508759,7508755,'com',100,1),(583,7508760,7508759,'mem',25,3),(583,7508761,7508759,'emo',25,3),(583,7508762,7508759,'mor',25,3),(583,7508763,7508759,'ory',25,3),(583,7508764,7508760,'siz',50,2),(583,7508765,7508760,'ize',50,2),(583,7508766,7508764,'614',50,1),(583,7508767,7508764,'144',50,1),(583,7508768,7508766,'cpu',100,1),(583,7508769,7508768,'usa',33.333,3),(583,7508770,7508768,'sag',33.333,3),(583,7508771,7508768,'age',33.333,3),(583,7508772,7508769,'mhz',100,1),(583,7508773,7508772,'add',20,1),(583,7508774,7508772,'ddr',20,1),(583,7508775,7508772,'dre',20,1),(583,7508776,7508772,'res',20,1),(583,7508777,7508772,'ess',20,1),(583,7508778,7508773,'226',100,1),(583,7508779,7508778,'147',100,1),(583,7508780,7508779,'209',100,1),(583,7508781,7508780,'397',50,1),(583,7508782,7508780,'974',50,1),(583,7508783,7508781,'gue',33.333,2),(583,7508784,7508781,'ues',33.333,2),(583,7508785,7508781,'est',33.333,2),(583,7508786,7508783,'122',100,1),(583,7508787,7508786,'vmw',25,2),(583,7508788,7508786,'mwa',25,2),(583,7508789,7508786,'war',25,2),(583,7508790,7508786,'are',25,2),(583,7508791,7508787,'too',33.333,2),(583,7508792,7508787,'ool',33.333,2),(583,7508793,7508787,'ols',33.333,2),(583,7508794,7508791,'run',20,1),(583,7508795,7508791,'unn',20,1),(583,7508796,7508791,'nni',20,1),(583,7508797,7508791,'nin',20,1),(583,7508798,7508791,'ing',20,1),(583,7508799,7508794,'and',100,1),(583,7508800,7508799,'the',100,1),(583,7508801,7508800,'ver',20,2),(583,7508802,7508800,'ers',20,2),(583,7508803,7508800,'rsi',20,2),(583,7508804,7508800,'sio',20,2),(583,7508805,7508800,'ion',20,2),(583,7508806,7508801,'cur',20,1),(583,7508807,7508801,'urr',20,1),(583,7508808,7508801,'rre',20,1),(583,7508809,7508801,'ren',20,1),(583,7508810,7508801,'ent',20,1),(583,7508811,7508806,'mic',14.286,1),(583,7508812,7508806,'icr',14.286,1),(583,7508813,7508806,'cro',14.286,1),(583,7508814,7508806,'ros',14.286,1),(583,7508815,7508806,'oso',14.286,1),(583,7508816,7508806,'sof',14.286,1),(583,7508817,7508806,'oft',14.286,1),(583,7508818,7508811,'win',20,1),(583,7508819,7508811,'ind',20,1),(583,7508820,7508811,'ndo',20,1),(583,7508821,7508811,'dow',20,1),(583,7508822,7508811,'ows',20,1),(583,7508823,7508818,'ser',25,1),(583,7508824,7508818,'erv',25,1),(583,7508825,7508818,'rve',25,1),(583,7508826,7508818,'ver',25,1),(583,7508827,7508823,'200',50,1),(583,7508828,7508823,'008',50,1),(583,7508829,7508827,'64b',33.333,1),(583,7508830,7508827,'4bi',33.333,1),(583,7508831,7508827,'bit',33.333,1),(583,7508832,7508829,'pat',50,1),(583,7508833,7508829,'ath',50,1),(583,7508834,7508832,'rx6',33.333,1),(583,7508835,7508832,'x60',33.333,1),(583,7508836,7508832,'600',33.333,1),(583,7508837,7508834,'vmf',20,1),(583,7508838,7508834,'mfi',20,1),(583,7508839,7508834,'fil',20,1),(583,7508840,7508834,'ile',20,1),(583,7508841,7508834,'les',20,1),(583,7508842,7508837,'hgw',9.091,2),(583,7508843,7508837,'gw2',9.091,2),(583,7508844,7508837,'w2k',9.091,2),(583,7508845,7508837,'2k8',9.091,2),(583,7508846,7508837,'k8r',9.091,2),(583,7508847,7508837,'8r2',9.091,2),(583,7508848,7508837,'r23',9.091,2),(583,7508849,7508837,'232',9.091,2),(583,7508850,7508837,'32v',9.091,2),(583,7508851,7508837,'2vm',9.091,2),(583,7508852,7508837,'vm7',9.091,2),(583,7508853,7508842,'vmx',100,1),(583,7508854,7508853,'fla',33.333,1),(583,7508855,7508853,'las',33.333,1),(583,7508856,7508853,'ash',33.333,1),(583,7508857,7508854,'acc',33.333,1),(583,7508858,7508854,'cce',33.333,1),(583,7508859,7508854,'cel',33.333,1),(583,7508860,7508857,'con',9.091,1),(583,7508861,7508857,'onf',9.091,1),(583,7508862,7508857,'nfi',9.091,1),(583,7508863,7508857,'fig',9.091,1),(583,7508864,7508857,'igu',9.091,1),(583,7508865,7508857,'gur',9.091,1),(583,7508866,7508857,'ura',9.091,1),(583,7508867,7508857,'rat',9.091,1),(583,7508868,7508857,'ati',9.091,1),(583,7508869,7508857,'tio',9.091,1),(583,7508870,7508857,'ion',9.091,1),(583,7508871,7508860,'age',33.333,1),(583,7508872,7508860,'gen',33.333,1),(583,7508873,7508860,'ent',33.333,1),(583,7508874,7508871,'193',16.667,1),(583,7508875,7508871,'932',16.667,1),(583,7508876,7508871,'320',16.667,1),(583,7508877,7508871,'204',16.667,1),(583,7508878,7508871,'044',16.667,1),(583,7508879,7508871,'449',16.667,1),(583,7508880,7508874,'cac',33.333,3),(583,7508881,7508874,'ach',33.333,3),(583,7508882,7508874,'che',33.333,3),(583,7508883,7508880,'sta',33.333,2),(583,7508884,7508880,'tat',33.333,2),(583,7508885,7508880,'ate',33.333,2),(583,7508886,7508883,'dis',16.667,3),(583,7508887,7508883,'isa',16.667,3),(583,7508888,7508883,'sab',16.667,3),(583,7508889,7508883,'abl',16.667,3),(583,7508890,7508883,'ble',16.667,3),(583,7508891,7508883,'led',16.667,3),(583,7508892,7508886,'ope',11.111,2),(583,7508893,7508886,'per',11.111,2),(583,7508894,7508886,'era',11.111,2),(583,7508895,7508886,'rat',11.111,2),(583,7508896,7508886,'ati',11.111,2),(583,7508897,7508886,'tio',11.111,2),(583,7508898,7508886,'ion',11.111,2),(583,7508899,7508886,'ona',11.111,2),(583,7508900,7508886,'nal',11.111,2),(583,7508901,7508892,'mod',50,1),(583,7508902,7508892,'ode',50,1),(583,7508903,7508901,'wri',14.286,1),(583,7508904,7508901,'rit',14.286,1),(583,7508905,7508901,'ite',14.286,1),(583,7508906,7508901,'tet',14.286,1),(583,7508907,7508901,'eth',14.286,1),(583,7508908,7508901,'thr',14.286,1),(583,7508909,7508901,'hru',14.286,1),(583,7508910,7508903,'mes',20,1),(583,7508911,7508903,'ess',20,1),(583,7508912,7508903,'ssa',20,1),(583,7508913,7508903,'sag',20,1),(583,7508914,7508903,'age',20,1),(583,7508915,7508910,'adm',33.333,1),(583,7508916,7508910,'dmi',33.333,1),(583,7508917,7508910,'min',33.333,1),(583,7508918,7508915,'met',20,3),(583,7508919,7508915,'etr',20,3),(583,7508920,7508915,'tri',20,3),(583,7508921,7508915,'ric',20,3),(583,7508922,7508915,'ics',20,3),(583,7508923,7508918,'ena',20,1),(583,7508924,7508918,'nab',20,1),(583,7508925,7508918,'abl',20,1),(583,7508926,7508918,'ble',20,1),(583,7508927,7508918,'led',20,1),(583,7508928,7508923,'vir',20,1),(583,7508929,7508923,'irt',20,1),(583,7508930,7508923,'rtu',20,1),(583,7508931,7508923,'tua',20,1),(583,7508932,7508923,'ual',20,1),(583,7508933,7508928,'dis',50,1),(583,7508934,7508928,'isk',50,1),(644,7508981,7508980,'naa',100,2),(644,7508982,7508981,'600',3.333,3),(644,7508983,7508981,'000',3.333,3),(644,7508984,7508981,'00c',3.333,3),(644,7508985,7508981,'0c2',3.333,3),(644,7508986,7508981,'c29',3.333,3),(644,7508987,7508981,'294',3.333,3),(644,7508988,7508981,'94d',3.333,3),(644,7508989,7508981,'4d6',3.333,3),(644,7508990,7508981,'d6d',3.333,3),(644,7508991,7508981,'6d0',3.333,3),(644,7508992,7508981,'d0c',3.333,3),(644,7508993,7508981,'0c3',3.333,3),(644,7508994,7508981,'c3e',3.333,3),(644,7508995,7508981,'3ee',3.333,3),(644,7508996,7508981,'eec',3.333,3),(644,7508997,7508981,'ecd',3.333,3),(644,7508998,7508981,'cde',3.333,3),(644,7508999,7508981,'def',3.333,3),(644,7509000,7508981,'efa',3.333,3),(644,7509001,7508981,'fa1',3.333,3),(644,7509002,7508981,'a1a',3.333,3),(644,7509003,7508981,'1a4',3.333,3),(644,7509004,7508981,'a4c',3.333,3),(644,7509005,7508981,'4c7',3.333,3),(644,7509006,7508981,'c7c',3.333,3),(644,7509007,7508981,'7ce',3.333,3),(644,7509008,7508981,'cea',3.333,3),(644,7509009,7508981,'ea8',3.333,3),(644,7509010,7508981,'a82',3.333,3),(644,7509011,7508981,'820',3.333,3),(644,7509012,7508982,'mon',100,1),(644,7509013,7509012,'201',50,1),(644,7509014,7509012,'013',50,1),(644,7509015,7509013,'adm',33.333,3),(644,7509016,7509013,'dmi',33.333,3),(644,7509017,7509013,'min',33.333,3),(644,7509018,7509015,'cap',16.667,1),(644,7509019,7509015,'apa',16.667,1),(644,7509020,7509015,'pac',16.667,1),(644,7509021,7509015,'aci',16.667,1),(644,7509022,7509015,'cit',16.667,1),(644,7509023,7509015,'ity',16.667,1),(644,7509024,7509018,'pat',50,1),(644,7509025,7509018,'ath',50,1),(644,7509026,7509024,'fre',14.286,1),(644,7509027,7509024,'ree',14.286,1),(644,7509028,7509024,'ees',14.286,1),(644,7509029,7509024,'esp',14.286,1),(644,7509030,7509024,'spa',14.286,1),(644,7509031,7509024,'pac',14.286,1),(644,7509032,7509024,'ace',14.286,1),(644,7509033,7509026,'dis',50,1),(644,7509034,7509026,'isk',50,1),(644,7509035,7509033,'ind',33.333,1),(644,7509036,7509033,'nde',33.333,1),(644,7509037,7509033,'dex',33.333,1),(644,7509038,7509035,'adm',8.333,1),(644,7509039,7509035,'dmi',8.333,1),(644,7509040,7509035,'min',8.333,1),(644,7509041,7509035,'ini',8.333,1),(644,7509042,7509035,'nis',8.333,1),(644,7509043,7509035,'ist',8.333,1),(644,7509044,7509035,'str',8.333,1),(644,7509045,7509035,'tra',8.333,1),(644,7509046,7509035,'rat',8.333,1),(644,7509047,7509035,'ati',8.333,1),(644,7509048,7509035,'tio',8.333,1),(644,7509049,7509035,'ion',8.333,1),(644,7509050,7509038,'sta',33.333,3),(644,7509051,7509038,'tat',33.333,3),(644,7509052,7509038,'ate',33.333,3),(644,7509053,7509050,'ena',20,2),(644,7509054,7509050,'nab',20,2),(644,7509055,7509050,'abl',20,2),(644,7509056,7509050,'ble',20,2),(644,7509057,7509050,'led',20,2),(644,7509058,7509053,'cac',33.333,2),(644,7509059,7509053,'ach',33.333,2),(644,7509060,7509053,'che',33.333,2),(644,7509061,7509058,'mod',50,1),(644,7509062,7509058,'ode',50,1),(644,7509063,7509061,'wri',14.286,1),(644,7509064,7509061,'rit',14.286,1),(644,7509065,7509061,'ite',14.286,1),(644,7509066,7509061,'tet',14.286,1),(644,7509067,7509061,'eth',14.286,1),(644,7509068,7509061,'thr',14.286,1),(644,7509069,7509061,'hru',14.286,1),(644,7509070,7509063,'ope',11.111,2),(644,7509071,7509063,'per',11.111,2),(644,7509072,7509063,'era',11.111,2),(644,7509073,7509063,'rat',11.111,2),(644,7509074,7509063,'ati',11.111,2),(644,7509075,7509063,'tio',11.111,2),(644,7509076,7509063,'ion',11.111,2),(644,7509077,7509063,'ona',11.111,2),(644,7509078,7509063,'nal',11.111,2),(644,7509079,7509070,'pen',20,1),(644,7509080,7509070,'end',20,1),(644,7509081,7509070,'ndi',20,1),(644,7509082,7509070,'din',20,1),(644,7509083,7509070,'ing',20,1),(644,7509084,7509079,'mes',20,1),(644,7509085,7509079,'ess',20,1),(644,7509086,7509079,'ssa',20,1),(644,7509087,7509079,'sag',20,1),(644,7509088,7509079,'age',20,1),(644,7509089,7509084,'wai',20,1),(644,7509090,7509084,'ait',20,1),(644,7509091,7509084,'iti',20,1),(644,7509092,7509084,'tin',20,1),(644,7509093,7509084,'ing',20,1),(644,7509094,7509089,'for',100,1),(644,7509095,7509094,'per',11.111,1),(644,7509096,7509094,'erf',11.111,1),(644,7509097,7509094,'rfo',11.111,1),(644,7509098,7509094,'for',11.111,1),(644,7509099,7509094,'orm',11.111,1),(644,7509100,7509094,'rma',11.111,1),(644,7509101,7509094,'man',11.111,1),(644,7509102,7509094,'anc',11.111,1),(644,7509103,7509094,'nce',11.111,1),(644,7509104,7509095,'ide',12.5,1),(644,7509105,7509095,'den',12.5,1),(644,7509106,7509095,'ent',12.5,1),(644,7509107,7509095,'nti',12.5,1),(644,7509108,7509095,'tif',12.5,1),(644,7509109,7509095,'ifi',12.5,1),(644,7509110,7509095,'fie',12.5,1),(644,7509111,7509095,'ier',12.5,1),(644,7509112,7509104,'vdi',33.333,3),(644,7509113,7509104,'dis',33.333,3),(644,7509114,7509104,'isk',33.333,3),(644,7509115,7509112,'nam',50,1),(644,7509116,7509112,'ame',50,1),(644,7509117,7509115,'typ',50,1),(644,7509118,7509115,'ype',50,1),(644,7509119,7509117,'dir',25,1),(644,7509120,7509117,'ire',25,1),(644,7509121,7509117,'rec',25,1),(644,7509122,7509117,'ect',25,1),(645,7509124,7509123,'naa',100,2),(645,7509125,7509124,'600',3.333,3),(645,7509126,7509124,'00a',3.333,3),(645,7509127,7509124,'0a0',3.333,3),(645,7509128,7509124,'a09',3.333,3),(645,7509129,7509124,'098',3.333,3),(645,7509130,7509124,'980',3.333,3),(645,7509131,7509124,'804',3.333,3),(645,7509132,7509124,'044',3.333,3),(645,7509133,7509124,'443',3.333,3),(645,7509134,7509124,'430',3.333,3),(645,7509135,7509124,'307',3.333,3),(645,7509136,7509124,'072',3.333,3),(645,7509137,7509124,'725',3.333,3),(645,7509138,7509124,'259',3.333,3),(645,7509139,7509124,'593',3.333,3),(645,7509140,7509124,'931',3.333,3),(645,7509141,7509124,'313',3.333,3),(645,7509142,7509124,'13f',3.333,3),(645,7509143,7509124,'3f3',3.333,3),(645,7509144,7509124,'f33',3.333,3),(645,7509145,7509124,'334',3.333,3),(645,7509146,7509124,'345',3.333,3),(645,7509147,7509124,'455',3.333,3),(645,7509148,7509124,'556',3.333,3),(645,7509149,7509124,'563',3.333,3),(645,7509150,7509124,'639',3.333,3),(645,7509151,7509124,'393',3.333,3),(645,7509152,7509124,'934',3.333,3),(645,7509153,7509124,'344',3.333,3),(645,7509154,7509124,'449',3.333,3),(645,7509155,7509125,'mon',100,1),(645,7509156,7509155,'201',50,1),(645,7509157,7509155,'013',50,1),(645,7509158,7509156,'adm',33.333,3),(645,7509159,7509156,'dmi',33.333,3),(645,7509160,7509156,'min',33.333,3),(645,7509161,7509158,'cap',16.667,1),(645,7509162,7509158,'apa',16.667,1),(645,7509163,7509158,'pac',16.667,1),(645,7509164,7509158,'aci',16.667,1),(645,7509165,7509158,'cit',16.667,1),(645,7509166,7509158,'ity',16.667,1),(645,7509167,7509161,'pat',50,1),(645,7509168,7509161,'ath',50,1),(645,7509169,7509167,'fre',14.286,1),(645,7509170,7509167,'ree',14.286,1),(645,7509171,7509167,'ees',14.286,1),(645,7509172,7509167,'esp',14.286,1),(645,7509173,7509167,'spa',14.286,1),(645,7509174,7509167,'pac',14.286,1),(645,7509175,7509167,'ace',14.286,1),(645,7509176,7509169,'dis',50,1),(645,7509177,7509169,'isk',50,1),(645,7509178,7509176,'ind',33.333,1),(645,7509179,7509176,'nde',33.333,1),(645,7509180,7509176,'dex',33.333,1),(645,7509181,7509178,'adm',8.333,1),(645,7509182,7509178,'dmi',8.333,1),(645,7509183,7509178,'min',8.333,1),(645,7509184,7509178,'ini',8.333,1),(645,7509185,7509178,'nis',8.333,1),(645,7509186,7509178,'ist',8.333,1),(645,7509187,7509178,'str',8.333,1),(645,7509188,7509178,'tra',8.333,1),(645,7509189,7509178,'rat',8.333,1),(645,7509190,7509178,'ati',8.333,1),(645,7509191,7509178,'tio',8.333,1),(645,7509192,7509178,'ion',8.333,1),(645,7509193,7509181,'sta',33.333,3),(645,7509194,7509181,'tat',33.333,3),(645,7509195,7509181,'ate',33.333,3),(645,7509196,7509193,'ena',20,2),(645,7509197,7509193,'nab',20,2),(645,7509198,7509193,'abl',20,2),(645,7509199,7509193,'ble',20,2),(645,7509200,7509193,'led',20,2),(645,7509201,7509196,'cac',33.333,2),(645,7509202,7509196,'ach',33.333,2),(645,7509203,7509196,'che',33.333,2),(645,7509204,7509201,'mod',50,1),(645,7509205,7509201,'ode',50,1),(645,7509206,7509204,'wri',14.286,1),(645,7509207,7509204,'rit',14.286,1),(645,7509208,7509204,'ite',14.286,1),(645,7509209,7509204,'tet',14.286,1),(645,7509210,7509204,'eth',14.286,1),(645,7509211,7509204,'thr',14.286,1),(645,7509212,7509204,'hru',14.286,1),(645,7509213,7509206,'ope',11.111,2),(645,7509214,7509206,'per',11.111,2),(645,7509215,7509206,'era',11.111,2),(645,7509216,7509206,'rat',11.111,2),(645,7509217,7509206,'ati',11.111,2),(645,7509218,7509206,'tio',11.111,2),(645,7509219,7509206,'ion',11.111,2),(645,7509220,7509206,'ona',11.111,2),(645,7509221,7509206,'nal',11.111,2),(645,7509222,7509213,'pen',20,1),(645,7509223,7509213,'end',20,1),(645,7509224,7509213,'ndi',20,1),(645,7509225,7509213,'din',20,1),(645,7509226,7509213,'ing',20,1),(645,7509227,7509222,'mes',20,1),(645,7509228,7509222,'ess',20,1),(645,7509229,7509222,'ssa',20,1),(645,7509230,7509222,'sag',20,1),(645,7509231,7509222,'age',20,1),(645,7509232,7509227,'wai',20,1),(645,7509233,7509227,'ait',20,1),(645,7509234,7509227,'iti',20,1),(645,7509235,7509227,'tin',20,1),(645,7509236,7509227,'ing',20,1),(645,7509237,7509232,'for',100,1),(645,7509238,7509237,'per',11.111,1),(645,7509239,7509237,'erf',11.111,1),(645,7509240,7509237,'rfo',11.111,1),(645,7509241,7509237,'for',11.111,1),(645,7509242,7509237,'orm',11.111,1),(645,7509243,7509237,'rma',11.111,1),(645,7509244,7509237,'man',11.111,1),(645,7509245,7509237,'anc',11.111,1),(645,7509246,7509237,'nce',11.111,1),(645,7509247,7509238,'ide',12.5,1),(645,7509248,7509238,'den',12.5,1),(645,7509249,7509238,'ent',12.5,1),(645,7509250,7509238,'nti',12.5,1),(645,7509251,7509238,'tif',12.5,1),(645,7509252,7509238,'ifi',12.5,1),(645,7509253,7509238,'fie',12.5,1),(645,7509254,7509238,'ier',12.5,1),(645,7509255,7509247,'vdi',33.333,3),(645,7509256,7509247,'dis',33.333,3),(645,7509257,7509247,'isk',33.333,3),(645,7509258,7509255,'nam',50,1),(645,7509259,7509255,'ame',50,1),(645,7509260,7509258,'typ',50,1),(645,7509261,7509258,'ype',50,1),(645,7509262,7509260,'dir',25,1),(645,7509263,7509260,'ire',25,1),(645,7509264,7509260,'rec',25,1),(645,7509265,7509260,'ect',25,1),(646,7509267,7509266,'naa',100,2),(646,7509268,7509267,'600',3.333,3),(646,7509269,7509267,'00a',3.333,3),(646,7509270,7509267,'0a0',3.333,3),(646,7509271,7509267,'a09',3.333,3),(646,7509272,7509267,'098',3.333,3),(646,7509273,7509267,'980',3.333,3),(646,7509274,7509267,'804',3.333,3),(646,7509275,7509267,'044',3.333,3),(646,7509276,7509267,'443',3.333,3),(646,7509277,7509267,'430',3.333,3),(646,7509278,7509267,'307',3.333,3),(646,7509279,7509267,'072',3.333,3),(646,7509280,7509267,'725',3.333,3),(646,7509281,7509267,'259',3.333,3),(646,7509282,7509267,'593',3.333,3),(646,7509283,7509267,'931',3.333,3),(646,7509284,7509267,'313',3.333,3),(646,7509285,7509267,'13f',3.333,3),(646,7509286,7509267,'3f3',3.333,3),(646,7509287,7509267,'f33',3.333,3),(646,7509288,7509267,'334',3.333,3),(646,7509289,7509267,'345',3.333,3),(646,7509290,7509267,'455',3.333,3),(646,7509291,7509267,'556',3.333,3),(646,7509292,7509267,'563',3.333,3),(646,7509293,7509267,'639',3.333,3),(646,7509294,7509267,'393',3.333,3),(646,7509295,7509267,'934',3.333,3),(646,7509296,7509267,'344',3.333,3),(646,7509297,7509267,'44a',3.333,3),(646,7509298,7509268,'mon',100,1),(646,7509299,7509298,'201',50,1),(646,7509300,7509298,'013',50,1),(646,7509301,7509299,'adm',33.333,3),(646,7509302,7509299,'dmi',33.333,3),(646,7509303,7509299,'min',33.333,3),(646,7509304,7509301,'cap',16.667,1),(646,7509305,7509301,'apa',16.667,1),(646,7509306,7509301,'pac',16.667,1),(646,7509307,7509301,'aci',16.667,1),(646,7509308,7509301,'cit',16.667,1),(646,7509309,7509301,'ity',16.667,1),(646,7509310,7509304,'pat',50,1),(646,7509311,7509304,'ath',50,1),(646,7509312,7509310,'fre',14.286,1),(646,7509313,7509310,'ree',14.286,1),(646,7509314,7509310,'ees',14.286,1),(646,7509315,7509310,'esp',14.286,1),(646,7509316,7509310,'spa',14.286,1),(646,7509317,7509310,'pac',14.286,1),(646,7509318,7509310,'ace',14.286,1),(646,7509319,7509312,'dis',50,1),(646,7509320,7509312,'isk',50,1),(646,7509321,7509319,'ind',33.333,1),(646,7509322,7509319,'nde',33.333,1),(646,7509323,7509319,'dex',33.333,1),(646,7509324,7509321,'adm',8.333,1),(646,7509325,7509321,'dmi',8.333,1),(646,7509326,7509321,'min',8.333,1),(646,7509327,7509321,'ini',8.333,1),(646,7509328,7509321,'nis',8.333,1),(646,7509329,7509321,'ist',8.333,1),(646,7509330,7509321,'str',8.333,1),(646,7509331,7509321,'tra',8.333,1),(646,7509332,7509321,'rat',8.333,1),(646,7509333,7509321,'ati',8.333,1),(646,7509334,7509321,'tio',8.333,1),(646,7509335,7509321,'ion',8.333,1),(646,7509336,7509324,'sta',33.333,3),(646,7509337,7509324,'tat',33.333,3),(646,7509338,7509324,'ate',33.333,3),(646,7509339,7509336,'ena',20,2),(646,7509340,7509336,'nab',20,2),(646,7509341,7509336,'abl',20,2),(646,7509342,7509336,'ble',20,2),(646,7509343,7509336,'led',20,2),(646,7509344,7509339,'cac',33.333,2),(646,7509345,7509339,'ach',33.333,2),(646,7509346,7509339,'che',33.333,2),(646,7509347,7509344,'mod',50,1),(646,7509348,7509344,'ode',50,1),(646,7509349,7509347,'wri',14.286,1),(646,7509350,7509347,'rit',14.286,1),(646,7509351,7509347,'ite',14.286,1),(646,7509352,7509347,'tet',14.286,1),(646,7509353,7509347,'eth',14.286,1),(646,7509354,7509347,'thr',14.286,1),(646,7509355,7509347,'hru',14.286,1),(646,7509356,7509349,'ope',11.111,2),(646,7509357,7509349,'per',11.111,2),(646,7509358,7509349,'era',11.111,2),(646,7509359,7509349,'rat',11.111,2),(646,7509360,7509349,'ati',11.111,2),(646,7509361,7509349,'tio',11.111,2),(646,7509362,7509349,'ion',11.111,2),(646,7509363,7509349,'ona',11.111,2),(646,7509364,7509349,'nal',11.111,2),(646,7509365,7509356,'pen',20,1),(646,7509366,7509356,'end',20,1),(646,7509367,7509356,'ndi',20,1),(646,7509368,7509356,'din',20,1),(646,7509369,7509356,'ing',20,1),(646,7509370,7509365,'mes',20,1),(646,7509371,7509365,'ess',20,1),(646,7509372,7509365,'ssa',20,1),(646,7509373,7509365,'sag',20,1),(646,7509374,7509365,'age',20,1),(646,7509375,7509370,'wai',20,1),(646,7509376,7509370,'ait',20,1),(646,7509377,7509370,'iti',20,1),(646,7509378,7509370,'tin',20,1),(646,7509379,7509370,'ing',20,1),(646,7509380,7509375,'for',100,1),(646,7509381,7509380,'per',11.111,1),(646,7509382,7509380,'erf',11.111,1),(646,7509383,7509380,'rfo',11.111,1),(646,7509384,7509380,'for',11.111,1),(646,7509385,7509380,'orm',11.111,1),(646,7509386,7509380,'rma',11.111,1),(646,7509387,7509380,'man',11.111,1),(646,7509388,7509380,'anc',11.111,1),(646,7509389,7509380,'nce',11.111,1),(646,7509390,7509381,'ide',12.5,1),(646,7509391,7509381,'den',12.5,1),(646,7509392,7509381,'ent',12.5,1),(646,7509393,7509381,'nti',12.5,1),(646,7509394,7509381,'tif',12.5,1),(646,7509395,7509381,'ifi',12.5,1),(646,7509396,7509381,'fie',12.5,1),(646,7509397,7509381,'ier',12.5,1),(646,7509398,7509390,'vdi',33.333,3),(646,7509399,7509390,'dis',33.333,3),(646,7509400,7509390,'isk',33.333,3),(646,7509401,7509398,'nam',50,1),(646,7509402,7509398,'ame',50,1),(646,7509403,7509401,'typ',50,1),(646,7509404,7509401,'ype',50,1),(646,7509405,7509403,'dir',25,1),(646,7509406,7509403,'ire',25,1),(646,7509407,7509403,'rec',25,1),(646,7509408,7509403,'ect',25,1),(647,7509410,7509409,'naa',100,2),(647,7509411,7509410,'600',3.333,3),(647,7509412,7509410,'00a',3.333,3),(647,7509413,7509410,'0a0',3.333,3),(647,7509414,7509410,'a09',3.333,3),(647,7509415,7509410,'098',3.333,3),(647,7509416,7509410,'980',3.333,3),(647,7509417,7509410,'804',3.333,3),(647,7509418,7509410,'044',3.333,3),(647,7509419,7509410,'443',3.333,3),(647,7509420,7509410,'430',3.333,3),(647,7509421,7509410,'307',3.333,3),(647,7509422,7509410,'075',3.333,3),(647,7509423,7509410,'753',3.333,3),(647,7509424,7509410,'535',3.333,3),(647,7509425,7509410,'357',3.333,3),(647,7509426,7509410,'573',3.333,3),(647,7509427,7509410,'732',3.333,3),(647,7509428,7509410,'32b',3.333,3),(647,7509429,7509410,'2b3',3.333,3),(647,7509430,7509410,'b33',3.333,3),(647,7509431,7509410,'334',3.333,3),(647,7509432,7509410,'345',3.333,3),(647,7509433,7509410,'457',3.333,3),(647,7509434,7509410,'571',3.333,3),(647,7509435,7509410,'715',3.333,3),(647,7509436,7509410,'153',3.333,3),(647,7509437,7509410,'533',3.333,3),(647,7509438,7509410,'336',3.333,3),(647,7509439,7509410,'363',3.333,3),(647,7509440,7509410,'634',3.333,3),(647,7509441,7509411,'mon',100,1),(647,7509442,7509441,'201',50,1),(647,7509443,7509441,'013',50,1),(647,7509444,7509442,'adm',33.333,3),(647,7509445,7509442,'dmi',33.333,3),(647,7509446,7509442,'min',33.333,3),(647,7509447,7509444,'cap',16.667,1),(647,7509448,7509444,'apa',16.667,1),(647,7509449,7509444,'pac',16.667,1),(647,7509450,7509444,'aci',16.667,1),(647,7509451,7509444,'cit',16.667,1),(647,7509452,7509444,'ity',16.667,1),(647,7509453,7509447,'pat',50,1),(647,7509454,7509447,'ath',50,1),(647,7509455,7509453,'fre',14.286,1),(647,7509456,7509453,'ree',14.286,1),(647,7509457,7509453,'ees',14.286,1),(647,7509458,7509453,'esp',14.286,1),(647,7509459,7509453,'spa',14.286,1),(647,7509460,7509453,'pac',14.286,1),(647,7509461,7509453,'ace',14.286,1),(647,7509462,7509455,'dis',50,1),(647,7509463,7509455,'isk',50,1),(647,7509464,7509462,'ind',33.333,1),(647,7509465,7509462,'nde',33.333,1),(647,7509466,7509462,'dex',33.333,1),(647,7509467,7509464,'adm',8.333,1),(647,7509468,7509464,'dmi',8.333,1),(647,7509469,7509464,'min',8.333,1),(647,7509470,7509464,'ini',8.333,1),(647,7509471,7509464,'nis',8.333,1),(647,7509472,7509464,'ist',8.333,1),(647,7509473,7509464,'str',8.333,1),(647,7509474,7509464,'tra',8.333,1),(647,7509475,7509464,'rat',8.333,1),(647,7509476,7509464,'ati',8.333,1),(647,7509477,7509464,'tio',8.333,1),(647,7509478,7509464,'ion',8.333,1),(647,7509479,7509467,'sta',33.333,3),(647,7509480,7509467,'tat',33.333,3),(647,7509481,7509467,'ate',33.333,3),(647,7509482,7509479,'ena',20,2),(647,7509483,7509479,'nab',20,2),(647,7509484,7509479,'abl',20,2),(647,7509485,7509479,'ble',20,2),(647,7509486,7509479,'led',20,2),(647,7509487,7509482,'cac',33.333,2),(647,7509488,7509482,'ach',33.333,2),(647,7509489,7509482,'che',33.333,2),(647,7509490,7509487,'mod',50,1),(647,7509491,7509487,'ode',50,1),(647,7509492,7509490,'wri',14.286,1),(647,7509493,7509490,'rit',14.286,1),(647,7509494,7509490,'ite',14.286,1),(647,7509495,7509490,'tet',14.286,1),(647,7509496,7509490,'eth',14.286,1),(647,7509497,7509490,'thr',14.286,1),(647,7509498,7509490,'hru',14.286,1),(647,7509499,7509492,'ope',11.111,2),(647,7509500,7509492,'per',11.111,2),(647,7509501,7509492,'era',11.111,2),(647,7509502,7509492,'rat',11.111,2),(647,7509503,7509492,'ati',11.111,2),(647,7509504,7509492,'tio',11.111,2),(647,7509505,7509492,'ion',11.111,2),(647,7509506,7509492,'ona',11.111,2),(647,7509507,7509492,'nal',11.111,2),(647,7509508,7509499,'pen',20,1),(647,7509509,7509499,'end',20,1),(647,7509510,7509499,'ndi',20,1),(647,7509511,7509499,'din',20,1),(647,7509512,7509499,'ing',20,1),(647,7509513,7509508,'mes',20,1),(647,7509514,7509508,'ess',20,1),(647,7509515,7509508,'ssa',20,1),(647,7509516,7509508,'sag',20,1),(647,7509517,7509508,'age',20,1),(647,7509518,7509513,'wai',20,1),(647,7509519,7509513,'ait',20,1),(647,7509520,7509513,'iti',20,1),(647,7509521,7509513,'tin',20,1),(647,7509522,7509513,'ing',20,1),(647,7509523,7509518,'for',100,1),(647,7509524,7509523,'per',11.111,1),(647,7509525,7509523,'erf',11.111,1),(647,7509526,7509523,'rfo',11.111,1),(647,7509527,7509523,'for',11.111,1),(647,7509528,7509523,'orm',11.111,1),(647,7509529,7509523,'rma',11.111,1),(647,7509530,7509523,'man',11.111,1),(647,7509531,7509523,'anc',11.111,1),(647,7509532,7509523,'nce',11.111,1),(647,7509533,7509524,'ide',12.5,1),(647,7509534,7509524,'den',12.5,1),(647,7509535,7509524,'ent',12.5,1),(647,7509536,7509524,'nti',12.5,1),(647,7509537,7509524,'tif',12.5,1),(647,7509538,7509524,'ifi',12.5,1),(647,7509539,7509524,'fie',12.5,1),(647,7509540,7509524,'ier',12.5,1),(647,7509541,7509533,'vdi',33.333,3),(647,7509542,7509533,'dis',33.333,3),(647,7509543,7509533,'isk',33.333,3),(647,7509544,7509541,'nam',50,1),(647,7509545,7509541,'ame',50,1),(647,7509546,7509544,'typ',50,1),(647,7509547,7509544,'ype',50,1),(647,7509548,7509546,'dir',25,1),(647,7509549,7509546,'ire',25,1),(647,7509550,7509546,'rec',25,1),(647,7509551,7509546,'ect',25,1),(648,7509553,7509552,'naa',100,2),(648,7509554,7509553,'600',3.333,3),(648,7509555,7509553,'00a',3.333,3),(648,7509556,7509553,'0a0',3.333,3),(648,7509557,7509553,'a09',3.333,3),(648,7509558,7509553,'098',3.333,3),(648,7509559,7509553,'980',3.333,3),(648,7509560,7509553,'804',3.333,3),(648,7509561,7509553,'044',3.333,3),(648,7509562,7509553,'443',3.333,3),(648,7509563,7509553,'430',3.333,3),(648,7509564,7509553,'307',3.333,3),(648,7509565,7509553,'075',3.333,3),(648,7509566,7509553,'753',3.333,3),(648,7509567,7509553,'535',3.333,3),(648,7509568,7509553,'357',3.333,3),(648,7509569,7509553,'573',3.333,3),(648,7509570,7509553,'732',3.333,3),(648,7509571,7509553,'32b',3.333,3),(648,7509572,7509553,'2b3',3.333,3),(648,7509573,7509553,'b33',3.333,3),(648,7509574,7509553,'334',3.333,3),(648,7509575,7509553,'345',3.333,3),(648,7509576,7509553,'457',3.333,3),(648,7509577,7509553,'571',3.333,3),(648,7509578,7509553,'715',3.333,3),(648,7509579,7509553,'153',3.333,3),(648,7509580,7509553,'533',3.333,3),(648,7509581,7509553,'336',3.333,3),(648,7509582,7509553,'363',3.333,3),(648,7509583,7509553,'635',3.333,3),(648,7509584,7509554,'mon',100,1),(648,7509585,7509584,'201',50,1),(648,7509586,7509584,'013',50,1),(648,7509587,7509585,'adm',33.333,3),(648,7509588,7509585,'dmi',33.333,3),(648,7509589,7509585,'min',33.333,3),(648,7509590,7509587,'cap',16.667,1),(648,7509591,7509587,'apa',16.667,1),(648,7509592,7509587,'pac',16.667,1),(648,7509593,7509587,'aci',16.667,1),(648,7509594,7509587,'cit',16.667,1),(648,7509595,7509587,'ity',16.667,1),(648,7509596,7509590,'pat',50,1),(648,7509597,7509590,'ath',50,1),(648,7509598,7509596,'fre',14.286,1),(648,7509599,7509596,'ree',14.286,1),(648,7509600,7509596,'ees',14.286,1),(648,7509601,7509596,'esp',14.286,1),(648,7509602,7509596,'spa',14.286,1),(648,7509603,7509596,'pac',14.286,1),(648,7509604,7509596,'ace',14.286,1),(648,7509605,7509598,'dis',50,1),(648,7509606,7509598,'isk',50,1),(648,7509607,7509605,'ind',33.333,1),(648,7509608,7509605,'nde',33.333,1),(648,7509609,7509605,'dex',33.333,1),(648,7509610,7509607,'adm',8.333,1),(648,7509611,7509607,'dmi',8.333,1),(648,7509612,7509607,'min',8.333,1),(648,7509613,7509607,'ini',8.333,1),(648,7509614,7509607,'nis',8.333,1),(648,7509615,7509607,'ist',8.333,1),(648,7509616,7509607,'str',8.333,1),(648,7509617,7509607,'tra',8.333,1),(648,7509618,7509607,'rat',8.333,1),(648,7509619,7509607,'ati',8.333,1),(648,7509620,7509607,'tio',8.333,1),(648,7509621,7509607,'ion',8.333,1),(648,7509622,7509610,'sta',33.333,3),(648,7509623,7509610,'tat',33.333,3),(648,7509624,7509610,'ate',33.333,3),(648,7509625,7509622,'ena',20,2),(648,7509626,7509622,'nab',20,2),(648,7509627,7509622,'abl',20,2),(648,7509628,7509622,'ble',20,2),(648,7509629,7509622,'led',20,2),(648,7509630,7509625,'cac',33.333,2),(648,7509631,7509625,'ach',33.333,2),(648,7509632,7509625,'che',33.333,2),(648,7509633,7509630,'mod',50,1),(648,7509634,7509630,'ode',50,1),(648,7509635,7509633,'wri',14.286,1),(648,7509636,7509633,'rit',14.286,1),(648,7509637,7509633,'ite',14.286,1),(648,7509638,7509633,'tet',14.286,1),(648,7509639,7509633,'eth',14.286,1),(648,7509640,7509633,'thr',14.286,1),(648,7509641,7509633,'hru',14.286,1),(648,7509642,7509635,'ope',11.111,2),(648,7509643,7509635,'per',11.111,2),(648,7509644,7509635,'era',11.111,2),(648,7509645,7509635,'rat',11.111,2),(648,7509646,7509635,'ati',11.111,2),(648,7509647,7509635,'tio',11.111,2),(648,7509648,7509635,'ion',11.111,2),(648,7509649,7509635,'ona',11.111,2),(648,7509650,7509635,'nal',11.111,2),(648,7509651,7509642,'pen',20,1),(648,7509652,7509642,'end',20,1),(648,7509653,7509642,'ndi',20,1),(648,7509654,7509642,'din',20,1),(648,7509655,7509642,'ing',20,1),(648,7509656,7509651,'mes',20,1),(648,7509657,7509651,'ess',20,1),(648,7509658,7509651,'ssa',20,1),(648,7509659,7509651,'sag',20,1),(648,7509660,7509651,'age',20,1),(648,7509661,7509656,'wai',20,1),(648,7509662,7509656,'ait',20,1),(648,7509663,7509656,'iti',20,1),(648,7509664,7509656,'tin',20,1),(648,7509665,7509656,'ing',20,1),(648,7509666,7509661,'for',100,1),(648,7509667,7509666,'per',11.111,1),(648,7509668,7509666,'erf',11.111,1),(648,7509669,7509666,'rfo',11.111,1),(648,7509670,7509666,'for',11.111,1),(648,7509671,7509666,'orm',11.111,1),(648,7509672,7509666,'rma',11.111,1),(648,7509673,7509666,'man',11.111,1),(648,7509674,7509666,'anc',11.111,1),(648,7509675,7509666,'nce',11.111,1),(648,7509676,7509667,'ide',12.5,1),(648,7509677,7509667,'den',12.5,1),(648,7509678,7509667,'ent',12.5,1),(648,7509679,7509667,'nti',12.5,1),(648,7509680,7509667,'tif',12.5,1),(648,7509681,7509667,'ifi',12.5,1),(648,7509682,7509667,'fie',12.5,1),(648,7509683,7509667,'ier',12.5,1),(648,7509684,7509676,'vdi',33.333,3),(648,7509685,7509676,'dis',33.333,3),(648,7509686,7509676,'isk',33.333,3),(648,7509687,7509684,'nam',50,1),(648,7509688,7509684,'ame',50,1),(648,7509689,7509687,'typ',50,1),(648,7509690,7509687,'ype',50,1),(648,7509691,7509689,'dir',25,1),(648,7509692,7509689,'ire',25,1),(648,7509693,7509689,'rec',25,1),(648,7509694,7509689,'ect',25,1),(649,7509696,7509695,'naa',100,2),(649,7509697,7509696,'600',3.333,3),(649,7509698,7509696,'000',3.333,3),(649,7509699,7509696,'00c',3.333,3),(649,7509700,7509696,'0c2',3.333,3),(649,7509701,7509696,'c29',3.333,3),(649,7509702,7509696,'297',3.333,3),(649,7509703,7509696,'97b',3.333,3),(649,7509704,7509696,'7bf',3.333,3),(649,7509705,7509696,'bf2',3.333,3),(649,7509706,7509696,'f2a',3.333,3),(649,7509707,7509696,'2a2',3.333,3),(649,7509708,7509696,'a22',3.333,3),(649,7509709,7509696,'226',3.333,3),(649,7509710,7509696,'264',3.333,3),(649,7509711,7509696,'641',3.333,3),(649,7509712,7509696,'419',3.333,3),(649,7509713,7509696,'198',3.333,3),(649,7509714,7509696,'982',3.333,3),(649,7509715,7509696,'82c',3.333,3),(649,7509716,7509696,'2c5',3.333,3),(649,7509717,7509696,'c56',3.333,3),(649,7509718,7509696,'567',3.333,3),(649,7509719,7509696,'67d',3.333,3),(649,7509720,7509696,'7dc',3.333,3),(649,7509721,7509696,'dc3',3.333,3),(649,7509722,7509696,'c31',3.333,3),(649,7509723,7509696,'310',3.333,3),(649,7509724,7509696,'10a',3.333,3),(649,7509725,7509696,'0a9',3.333,3),(649,7509726,7509696,'a9a',3.333,3),(649,7509727,7509697,'mon',100,1),(649,7509728,7509727,'201',50,1),(649,7509729,7509727,'013',50,1),(649,7509730,7509728,'adm',33.333,3),(649,7509731,7509728,'dmi',33.333,3),(649,7509732,7509728,'min',33.333,3),(649,7509733,7509730,'cap',16.667,1),(649,7509734,7509730,'apa',16.667,1),(649,7509735,7509730,'pac',16.667,1),(649,7509736,7509730,'aci',16.667,1),(649,7509737,7509730,'cit',16.667,1),(649,7509738,7509730,'ity',16.667,1),(649,7509739,7509733,'pat',50,1),(649,7509740,7509733,'ath',50,1),(649,7509741,7509739,'fre',14.286,1),(649,7509742,7509739,'ree',14.286,1),(649,7509743,7509739,'ees',14.286,1),(649,7509744,7509739,'esp',14.286,1),(649,7509745,7509739,'spa',14.286,1),(649,7509746,7509739,'pac',14.286,1),(649,7509747,7509739,'ace',14.286,1),(649,7509748,7509741,'dis',50,1),(649,7509749,7509741,'isk',50,1),(649,7509750,7509748,'ind',33.333,1),(649,7509751,7509748,'nde',33.333,1),(649,7509752,7509748,'dex',33.333,1),(649,7509753,7509750,'adm',8.333,1),(649,7509754,7509750,'dmi',8.333,1),(649,7509755,7509750,'min',8.333,1),(649,7509756,7509750,'ini',8.333,1),(649,7509757,7509750,'nis',8.333,1),(649,7509758,7509750,'ist',8.333,1),(649,7509759,7509750,'str',8.333,1),(649,7509760,7509750,'tra',8.333,1),(649,7509761,7509750,'rat',8.333,1),(649,7509762,7509750,'ati',8.333,1),(649,7509763,7509750,'tio',8.333,1),(649,7509764,7509750,'ion',8.333,1),(649,7509765,7509753,'sta',33.333,3),(649,7509766,7509753,'tat',33.333,3),(649,7509767,7509753,'ate',33.333,3),(649,7509768,7509765,'ena',20,2),(649,7509769,7509765,'nab',20,2),(649,7509770,7509765,'abl',20,2),(649,7509771,7509765,'ble',20,2),(649,7509772,7509765,'led',20,2),(649,7509773,7509768,'cac',33.333,2),(649,7509774,7509768,'ach',33.333,2),(649,7509775,7509768,'che',33.333,2),(649,7509776,7509773,'mod',50,1),(649,7509777,7509773,'ode',50,1),(649,7509778,7509776,'wri',14.286,1),(649,7509779,7509776,'rit',14.286,1),(649,7509780,7509776,'ite',14.286,1),(649,7509781,7509776,'tet',14.286,1),(649,7509782,7509776,'eth',14.286,1),(649,7509783,7509776,'thr',14.286,1),(649,7509784,7509776,'hru',14.286,1),(649,7509785,7509778,'ope',11.111,2),(649,7509786,7509778,'per',11.111,2),(649,7509787,7509778,'era',11.111,2),(649,7509788,7509778,'rat',11.111,2),(649,7509789,7509778,'ati',11.111,2),(649,7509790,7509778,'tio',11.111,2),(649,7509791,7509778,'ion',11.111,2),(649,7509792,7509778,'ona',11.111,2),(649,7509793,7509778,'nal',11.111,2),(649,7509794,7509785,'pen',20,1),(649,7509795,7509785,'end',20,1),(649,7509796,7509785,'ndi',20,1),(649,7509797,7509785,'din',20,1),(649,7509798,7509785,'ing',20,1),(649,7509799,7509794,'mes',20,1),(649,7509800,7509794,'ess',20,1),(649,7509801,7509794,'ssa',20,1),(649,7509802,7509794,'sag',20,1),(649,7509803,7509794,'age',20,1),(649,7509804,7509799,'wai',20,1),(649,7509805,7509799,'ait',20,1),(649,7509806,7509799,'iti',20,1),(649,7509807,7509799,'tin',20,1),(649,7509808,7509799,'ing',20,1),(649,7509809,7509804,'for',100,1),(649,7509810,7509809,'per',11.111,1),(649,7509811,7509809,'erf',11.111,1),(649,7509812,7509809,'rfo',11.111,1),(649,7509813,7509809,'for',11.111,1),(649,7509814,7509809,'orm',11.111,1),(649,7509815,7509809,'rma',11.111,1),(649,7509816,7509809,'man',11.111,1),(649,7509817,7509809,'anc',11.111,1),(649,7509818,7509809,'nce',11.111,1),(649,7509819,7509810,'ide',12.5,1),(649,7509820,7509810,'den',12.5,1),(649,7509821,7509810,'ent',12.5,1),(649,7509822,7509810,'nti',12.5,1),(649,7509823,7509810,'tif',12.5,1),(649,7509824,7509810,'ifi',12.5,1),(649,7509825,7509810,'fie',12.5,1),(649,7509826,7509810,'ier',12.5,1),(649,7509827,7509819,'vdi',33.333,3),(649,7509828,7509819,'dis',33.333,3),(649,7509829,7509819,'isk',33.333,3),(649,7509830,7509827,'nam',50,1),(649,7509831,7509827,'ame',50,1),(649,7509832,7509830,'typ',50,1),(649,7509833,7509830,'ype',50,1),(649,7509834,7509832,'dir',25,1),(649,7509835,7509832,'ire',25,1),(649,7509836,7509832,'rec',25,1),(649,7509837,7509832,'ect',25,1),(650,7509839,7509838,'naa',100,2),(650,7509840,7509839,'600',3.333,3),(650,7509841,7509839,'000',3.333,3),(650,7509842,7509839,'00c',3.333,3),(650,7509843,7509839,'0c2',3.333,3),(650,7509844,7509839,'c29',3.333,3),(650,7509845,7509839,'297',3.333,3),(650,7509846,7509839,'97a',3.333,3),(650,7509847,7509839,'7a5',3.333,3),(650,7509848,7509839,'a50',3.333,3),(650,7509849,7509839,'50c',3.333,3),(650,7509850,7509839,'0ca',3.333,3),(650,7509851,7509839,'ca9',3.333,3),(650,7509852,7509839,'a99',3.333,3),(650,7509853,7509839,'99c',3.333,3),(650,7509854,7509839,'9cb',3.333,3),(650,7509855,7509839,'cb2',3.333,3),(650,7509856,7509839,'b26',3.333,3),(650,7509857,7509839,'263',3.333,3),(650,7509858,7509839,'638',3.333,3),(650,7509859,7509839,'387',3.333,3),(650,7509860,7509839,'874',3.333,3),(650,7509861,7509839,'746',3.333,3),(650,7509862,7509839,'462',3.333,3),(650,7509863,7509839,'628',3.333,3),(650,7509864,7509839,'28b',3.333,3),(650,7509865,7509839,'8b9',3.333,3),(650,7509866,7509839,'b95',3.333,3),(650,7509867,7509839,'956',3.333,3),(650,7509868,7509839,'565',3.333,3),(650,7509869,7509839,'65b',3.333,3),(650,7509870,7509840,'mon',100,1),(650,7509871,7509870,'201',50,1),(650,7509872,7509870,'013',50,1),(650,7509873,7509871,'adm',33.333,3),(650,7509874,7509871,'dmi',33.333,3),(650,7509875,7509871,'min',33.333,3),(650,7509876,7509873,'cap',16.667,1),(650,7509877,7509873,'apa',16.667,1),(650,7509878,7509873,'pac',16.667,1),(650,7509879,7509873,'aci',16.667,1),(650,7509880,7509873,'cit',16.667,1),(650,7509881,7509873,'ity',16.667,1),(650,7509882,7509876,'pat',50,1),(650,7509883,7509876,'ath',50,1),(650,7509884,7509882,'fre',14.286,1),(650,7509885,7509882,'ree',14.286,1),(650,7509886,7509882,'ees',14.286,1),(650,7509887,7509882,'esp',14.286,1),(650,7509888,7509882,'spa',14.286,1),(650,7509889,7509882,'pac',14.286,1),(650,7509890,7509882,'ace',14.286,1),(650,7509891,7509884,'dis',50,1),(650,7509892,7509884,'isk',50,1),(650,7509893,7509891,'ind',33.333,1),(650,7509894,7509891,'nde',33.333,1),(650,7509895,7509891,'dex',33.333,1),(650,7509896,7509893,'adm',8.333,1),(650,7509897,7509893,'dmi',8.333,1),(650,7509898,7509893,'min',8.333,1),(650,7509899,7509893,'ini',8.333,1),(650,7509900,7509893,'nis',8.333,1),(650,7509901,7509893,'ist',8.333,1),(650,7509902,7509893,'str',8.333,1),(650,7509903,7509893,'tra',8.333,1),(650,7509904,7509893,'rat',8.333,1),(650,7509905,7509893,'ati',8.333,1),(650,7509906,7509893,'tio',8.333,1),(650,7509907,7509893,'ion',8.333,1),(650,7509908,7509896,'sta',33.333,3),(650,7509909,7509896,'tat',33.333,3),(650,7509910,7509896,'ate',33.333,3),(650,7509911,7509908,'ena',20,2),(650,7509912,7509908,'nab',20,2),(650,7509913,7509908,'abl',20,2),(650,7509914,7509908,'ble',20,2),(650,7509915,7509908,'led',20,2),(650,7509916,7509911,'cac',33.333,2),(650,7509917,7509911,'ach',33.333,2),(650,7509918,7509911,'che',33.333,2),(650,7509919,7509916,'mod',50,1),(650,7509920,7509916,'ode',50,1),(650,7509921,7509919,'wri',14.286,1),(650,7509922,7509919,'rit',14.286,1),(650,7509923,7509919,'ite',14.286,1),(650,7509924,7509919,'tet',14.286,1),(650,7509925,7509919,'eth',14.286,1),(650,7509926,7509919,'thr',14.286,1),(650,7509927,7509919,'hru',14.286,1),(650,7509928,7509921,'ope',11.111,2),(650,7509929,7509921,'per',11.111,2),(650,7509930,7509921,'era',11.111,2),(650,7509931,7509921,'rat',11.111,2),(650,7509932,7509921,'ati',11.111,2),(650,7509933,7509921,'tio',11.111,2),(650,7509934,7509921,'ion',11.111,2),(650,7509935,7509921,'ona',11.111,2),(650,7509936,7509921,'nal',11.111,2),(650,7509937,7509928,'pen',20,1),(650,7509938,7509928,'end',20,1),(650,7509939,7509928,'ndi',20,1),(650,7509940,7509928,'din',20,1),(650,7509941,7509928,'ing',20,1),(650,7509942,7509937,'mes',20,1),(650,7509943,7509937,'ess',20,1),(650,7509944,7509937,'ssa',20,1),(650,7509945,7509937,'sag',20,1),(650,7509946,7509937,'age',20,1),(650,7509947,7509942,'wai',20,1),(650,7509948,7509942,'ait',20,1),(650,7509949,7509942,'iti',20,1),(650,7509950,7509942,'tin',20,1),(650,7509951,7509942,'ing',20,1),(650,7509952,7509947,'for',100,1),(650,7509953,7509952,'per',11.111,1),(650,7509954,7509952,'erf',11.111,1),(650,7509955,7509952,'rfo',11.111,1),(650,7509956,7509952,'for',11.111,1),(650,7509957,7509952,'orm',11.111,1),(650,7509958,7509952,'rma',11.111,1),(650,7509959,7509952,'man',11.111,1),(650,7509960,7509952,'anc',11.111,1),(650,7509961,7509952,'nce',11.111,1),(650,7509962,7509953,'ide',12.5,1),(650,7509963,7509953,'den',12.5,1),(650,7509964,7509953,'ent',12.5,1),(650,7509965,7509953,'nti',12.5,1),(650,7509966,7509953,'tif',12.5,1),(650,7509967,7509953,'ifi',12.5,1),(650,7509968,7509953,'fie',12.5,1),(650,7509969,7509953,'ier',12.5,1),(650,7509970,7509962,'vdi',33.333,3),(650,7509971,7509962,'dis',33.333,3),(650,7509972,7509962,'isk',33.333,3),(650,7509973,7509970,'nam',50,1),(650,7509974,7509970,'ame',50,1),(650,7509975,7509973,'typ',50,1),(650,7509976,7509973,'ype',50,1),(650,7509977,7509975,'dir',25,1),(650,7509978,7509975,'ire',25,1),(650,7509979,7509975,'rec',25,1),(650,7509980,7509975,'ect',25,1),(651,7509982,7509981,'naa',100,2),(651,7509983,7509982,'600',3.333,3),(651,7509984,7509982,'000',3.333,3),(651,7509985,7509982,'00c',3.333,3),(651,7509986,7509982,'0c2',3.333,3),(651,7509987,7509982,'c29',3.333,3),(651,7509988,7509982,'29e',3.333,3),(651,7509989,7509982,'9ea',3.333,3),(651,7509990,7509982,'ead',3.333,3),(651,7509991,7509982,'adf',3.333,3),(651,7509992,7509982,'dfa',3.333,3),(651,7509993,7509982,'fae',3.333,3),(651,7509994,7509982,'ae7',3.333,3),(651,7509995,7509982,'e74',3.333,3),(651,7509996,7509982,'742',3.333,3),(651,7509997,7509982,'42d',3.333,3),(651,7509998,7509982,'2de',3.333,3),(651,7509999,7509982,'deb',3.333,3),(651,7510000,7509982,'eb3',3.333,3),(651,7510001,7509982,'b3e',3.333,3),(651,7510002,7509982,'3e0',3.333,3),(651,7510003,7509982,'e0d',3.333,3),(651,7510004,7509982,'0d4',3.333,3),(651,7510005,7509982,'d4a',3.333,3),(651,7510006,7509982,'4a7',3.333,3),(651,7510007,7509982,'a7e',3.333,3),(651,7510008,7509982,'7e1',3.333,3),(651,7510009,7509982,'e17',3.333,3),(651,7510010,7509982,'17d',3.333,3),(651,7510011,7509982,'7d8',3.333,3),(651,7510012,7509982,'d8c',3.333,3),(651,7510013,7509983,'mon',100,1),(651,7510014,7510013,'201',50,1),(651,7510015,7510013,'013',50,1),(651,7510016,7510014,'adm',33.333,3),(651,7510017,7510014,'dmi',33.333,3),(651,7510018,7510014,'min',33.333,3),(651,7510019,7510016,'cap',16.667,1),(651,7510020,7510016,'apa',16.667,1),(651,7510021,7510016,'pac',16.667,1),(651,7510022,7510016,'aci',16.667,1),(651,7510023,7510016,'cit',16.667,1),(651,7510024,7510016,'ity',16.667,1),(651,7510025,7510019,'pat',50,1),(651,7510026,7510019,'ath',50,1),(651,7510027,7510025,'fre',14.286,1),(651,7510028,7510025,'ree',14.286,1),(651,7510029,7510025,'ees',14.286,1),(651,7510030,7510025,'esp',14.286,1),(651,7510031,7510025,'spa',14.286,1),(651,7510032,7510025,'pac',14.286,1),(651,7510033,7510025,'ace',14.286,1),(651,7510034,7510027,'dis',50,1),(651,7510035,7510027,'isk',50,1),(651,7510036,7510034,'ind',33.333,1),(651,7510037,7510034,'nde',33.333,1),(651,7510038,7510034,'dex',33.333,1),(651,7510039,7510036,'adm',8.333,1),(651,7510040,7510036,'dmi',8.333,1),(651,7510041,7510036,'min',8.333,1),(651,7510042,7510036,'ini',8.333,1),(651,7510043,7510036,'nis',8.333,1),(651,7510044,7510036,'ist',8.333,1),(651,7510045,7510036,'str',8.333,1),(651,7510046,7510036,'tra',8.333,1),(651,7510047,7510036,'rat',8.333,1),(651,7510048,7510036,'ati',8.333,1),(651,7510049,7510036,'tio',8.333,1),(651,7510050,7510036,'ion',8.333,1),(651,7510051,7510039,'sta',33.333,3),(651,7510052,7510039,'tat',33.333,3),(651,7510053,7510039,'ate',33.333,3),(651,7510054,7510051,'ena',20,2),(651,7510055,7510051,'nab',20,2),(651,7510056,7510051,'abl',20,2),(651,7510057,7510051,'ble',20,2),(651,7510058,7510051,'led',20,2),(651,7510059,7510054,'cac',33.333,2),(651,7510060,7510054,'ach',33.333,2),(651,7510061,7510054,'che',33.333,2),(651,7510062,7510059,'mod',50,1),(651,7510063,7510059,'ode',50,1),(651,7510064,7510062,'wri',14.286,1),(651,7510065,7510062,'rit',14.286,1),(651,7510066,7510062,'ite',14.286,1),(651,7510067,7510062,'tet',14.286,1),(651,7510068,7510062,'eth',14.286,1),(651,7510069,7510062,'thr',14.286,1),(651,7510070,7510062,'hru',14.286,1),(651,7510071,7510064,'ope',11.111,2),(651,7510072,7510064,'per',11.111,2),(651,7510073,7510064,'era',11.111,2),(651,7510074,7510064,'rat',11.111,2),(651,7510075,7510064,'ati',11.111,2),(651,7510076,7510064,'tio',11.111,2),(651,7510077,7510064,'ion',11.111,2),(651,7510078,7510064,'ona',11.111,2),(651,7510079,7510064,'nal',11.111,2),(651,7510080,7510071,'pen',20,1),(651,7510081,7510071,'end',20,1),(651,7510082,7510071,'ndi',20,1),(651,7510083,7510071,'din',20,1),(651,7510084,7510071,'ing',20,1),(651,7510085,7510080,'mes',20,1),(651,7510086,7510080,'ess',20,1),(651,7510087,7510080,'ssa',20,1),(651,7510088,7510080,'sag',20,1),(651,7510089,7510080,'age',20,1),(651,7510090,7510085,'wai',20,1),(651,7510091,7510085,'ait',20,1),(651,7510092,7510085,'iti',20,1),(651,7510093,7510085,'tin',20,1),(651,7510094,7510085,'ing',20,1),(651,7510095,7510090,'for',100,1),(651,7510096,7510095,'per',11.111,1),(651,7510097,7510095,'erf',11.111,1),(651,7510098,7510095,'rfo',11.111,1),(651,7510099,7510095,'for',11.111,1),(651,7510100,7510095,'orm',11.111,1),(651,7510101,7510095,'rma',11.111,1),(651,7510102,7510095,'man',11.111,1),(651,7510103,7510095,'anc',11.111,1),(651,7510104,7510095,'nce',11.111,1),(651,7510105,7510096,'ide',12.5,1),(651,7510106,7510096,'den',12.5,1),(651,7510107,7510096,'ent',12.5,1),(651,7510108,7510096,'nti',12.5,1),(651,7510109,7510096,'tif',12.5,1),(651,7510110,7510096,'ifi',12.5,1),(651,7510111,7510096,'fie',12.5,1),(651,7510112,7510096,'ier',12.5,1),(651,7510113,7510105,'vdi',33.333,3),(651,7510114,7510105,'dis',33.333,3),(651,7510115,7510105,'isk',33.333,3),(651,7510116,7510113,'nam',50,1),(651,7510117,7510113,'ame',50,1),(651,7510118,7510116,'typ',50,1),(651,7510119,7510116,'ype',50,1),(651,7510120,7510118,'dir',25,1),(651,7510121,7510118,'ire',25,1),(651,7510122,7510118,'rec',25,1),(651,7510123,7510118,'ect',25,1),(652,7510125,7510124,'naa',100,2),(652,7510126,7510125,'600',3.333,3),(652,7510127,7510125,'000',3.333,3),(652,7510128,7510125,'00c',3.333,3),(652,7510129,7510125,'0c2',3.333,3),(652,7510130,7510125,'c29',3.333,3),(652,7510131,7510125,'292',3.333,3),(652,7510132,7510125,'92d',3.333,3),(652,7510133,7510125,'2d0',3.333,3),(652,7510134,7510125,'d05',3.333,3),(652,7510135,7510125,'051',3.333,3),(652,7510136,7510125,'514',3.333,3),(652,7510137,7510125,'140',3.333,3),(652,7510138,7510125,'400',3.333,3),(652,7510139,7510125,'006',3.333,3),(652,7510140,7510125,'063',3.333,3),(652,7510141,7510125,'636',3.333,3),(652,7510142,7510125,'362',3.333,3),(652,7510143,7510125,'62f',3.333,3),(652,7510144,7510125,'2f9',3.333,3),(652,7510145,7510125,'f90',3.333,3),(652,7510146,7510125,'906',3.333,3),(652,7510147,7510125,'06e',3.333,3),(652,7510148,7510125,'6e2',3.333,3),(652,7510149,7510125,'e2f',3.333,3),(652,7510150,7510125,'2f7',3.333,3),(652,7510151,7510125,'f7f',3.333,3),(652,7510152,7510125,'7f3',3.333,3),(652,7510153,7510125,'f3c',3.333,3),(652,7510154,7510125,'3c1',3.333,3),(652,7510155,7510125,'c10',3.333,3),(652,7510156,7510126,'mon',100,1),(652,7510157,7510156,'201',50,1),(652,7510158,7510156,'013',50,1),(652,7510159,7510157,'adm',33.333,3),(652,7510160,7510157,'dmi',33.333,3),(652,7510161,7510157,'min',33.333,3),(652,7510162,7510159,'cap',16.667,1),(652,7510163,7510159,'apa',16.667,1),(652,7510164,7510159,'pac',16.667,1),(652,7510165,7510159,'aci',16.667,1),(652,7510166,7510159,'cit',16.667,1),(652,7510167,7510159,'ity',16.667,1),(652,7510168,7510162,'pat',50,1),(652,7510169,7510162,'ath',50,1),(652,7510170,7510168,'fre',14.286,1),(652,7510171,7510168,'ree',14.286,1),(652,7510172,7510168,'ees',14.286,1),(652,7510173,7510168,'esp',14.286,1),(652,7510174,7510168,'spa',14.286,1),(652,7510175,7510168,'pac',14.286,1),(652,7510176,7510168,'ace',14.286,1),(652,7510177,7510170,'dis',50,1),(652,7510178,7510170,'isk',50,1),(652,7510179,7510177,'ind',33.333,1),(652,7510180,7510177,'nde',33.333,1),(652,7510181,7510177,'dex',33.333,1),(652,7510182,7510179,'adm',8.333,1),(652,7510183,7510179,'dmi',8.333,1),(652,7510184,7510179,'min',8.333,1),(652,7510185,7510179,'ini',8.333,1),(652,7510186,7510179,'nis',8.333,1),(652,7510187,7510179,'ist',8.333,1),(652,7510188,7510179,'str',8.333,1),(652,7510189,7510179,'tra',8.333,1),(652,7510190,7510179,'rat',8.333,1),(652,7510191,7510179,'ati',8.333,1),(652,7510192,7510179,'tio',8.333,1),(652,7510193,7510179,'ion',8.333,1),(652,7510194,7510182,'sta',33.333,3),(652,7510195,7510182,'tat',33.333,3),(652,7510196,7510182,'ate',33.333,3),(652,7510197,7510194,'ena',20,2),(652,7510198,7510194,'nab',20,2),(652,7510199,7510194,'abl',20,2),(652,7510200,7510194,'ble',20,2),(652,7510201,7510194,'led',20,2),(652,7510202,7510197,'cac',33.333,2),(652,7510203,7510197,'ach',33.333,2),(652,7510204,7510197,'che',33.333,2),(652,7510205,7510202,'mod',50,1),(652,7510206,7510202,'ode',50,1),(652,7510207,7510205,'wri',14.286,1),(652,7510208,7510205,'rit',14.286,1),(652,7510209,7510205,'ite',14.286,1),(652,7510210,7510205,'tet',14.286,1),(652,7510211,7510205,'eth',14.286,1),(652,7510212,7510205,'thr',14.286,1),(652,7510213,7510205,'hru',14.286,1),(652,7510214,7510207,'ope',11.111,2),(652,7510215,7510207,'per',11.111,2),(652,7510216,7510207,'era',11.111,2),(652,7510217,7510207,'rat',11.111,2),(652,7510218,7510207,'ati',11.111,2),(652,7510219,7510207,'tio',11.111,2),(652,7510220,7510207,'ion',11.111,2),(652,7510221,7510207,'ona',11.111,2),(652,7510222,7510207,'nal',11.111,2),(652,7510223,7510214,'pen',20,1),(652,7510224,7510214,'end',20,1),(652,7510225,7510214,'ndi',20,1),(652,7510226,7510214,'din',20,1),(652,7510227,7510214,'ing',20,1),(652,7510228,7510223,'mes',20,1),(652,7510229,7510223,'ess',20,1),(652,7510230,7510223,'ssa',20,1),(652,7510231,7510223,'sag',20,1),(652,7510232,7510223,'age',20,1),(652,7510233,7510228,'wai',20,1),(652,7510234,7510228,'ait',20,1),(652,7510235,7510228,'iti',20,1),(652,7510236,7510228,'tin',20,1),(652,7510237,7510228,'ing',20,1),(652,7510238,7510233,'for',100,1),(652,7510239,7510238,'per',11.111,1),(652,7510240,7510238,'erf',11.111,1),(652,7510241,7510238,'rfo',11.111,1),(652,7510242,7510238,'for',11.111,1),(652,7510243,7510238,'orm',11.111,1),(652,7510244,7510238,'rma',11.111,1),(652,7510245,7510238,'man',11.111,1),(652,7510246,7510238,'anc',11.111,1),(652,7510247,7510238,'nce',11.111,1),(652,7510248,7510239,'ide',12.5,1),(652,7510249,7510239,'den',12.5,1),(652,7510250,7510239,'ent',12.5,1),(652,7510251,7510239,'nti',12.5,1),(652,7510252,7510239,'tif',12.5,1),(652,7510253,7510239,'ifi',12.5,1),(652,7510254,7510239,'fie',12.5,1),(652,7510255,7510239,'ier',12.5,1),(652,7510256,7510248,'vdi',33.333,3),(652,7510257,7510248,'dis',33.333,3),(652,7510258,7510248,'isk',33.333,3),(652,7510259,7510256,'nam',50,1),(652,7510260,7510256,'ame',50,1),(652,7510261,7510259,'typ',50,1),(652,7510262,7510259,'ype',50,1),(652,7510263,7510261,'dir',25,1),(652,7510264,7510261,'ire',25,1),(652,7510265,7510261,'rec',25,1),(652,7510266,7510261,'ect',25,1),(653,7510268,7510267,'naa',100,2),(653,7510269,7510268,'600',3.333,3),(653,7510270,7510268,'000',3.333,3),(653,7510271,7510268,'00c',3.333,3),(653,7510272,7510268,'0c2',3.333,3),(653,7510273,7510268,'c29',3.333,3),(653,7510274,7510268,'293',3.333,3),(653,7510275,7510268,'938',3.333,3),(653,7510276,7510268,'38d',3.333,3),(653,7510277,7510268,'8d8',3.333,3),(653,7510278,7510268,'d85',3.333,3),(653,7510279,7510268,'85b',3.333,3),(653,7510280,7510268,'5ba',3.333,3),(653,7510281,7510268,'bac',3.333,3),(653,7510282,7510268,'ac2',3.333,3),(653,7510283,7510268,'c2f',3.333,3),(653,7510284,7510268,'2fa',3.333,3),(653,7510285,7510268,'fa6',3.333,3),(653,7510286,7510268,'a64',3.333,3),(653,7510287,7510268,'648',3.333,3),(653,7510288,7510268,'48a',3.333,3),(653,7510289,7510268,'8a5',3.333,3),(653,7510290,7510268,'a5f',3.333,3),(653,7510291,7510268,'5fc',3.333,3),(653,7510292,7510268,'fc4',3.333,3),(653,7510293,7510268,'c45',3.333,3),(653,7510294,7510268,'45a',3.333,3),(653,7510295,7510268,'5af',3.333,3),(653,7510296,7510268,'af3',3.333,3),(653,7510297,7510268,'f32',3.333,3),(653,7510298,7510268,'329',3.333,3),(653,7510299,7510269,'mon',100,1),(653,7510300,7510299,'201',50,1),(653,7510301,7510299,'013',50,1),(653,7510302,7510300,'adm',33.333,3),(653,7510303,7510300,'dmi',33.333,3),(653,7510304,7510300,'min',33.333,3),(653,7510305,7510302,'cap',16.667,1),(653,7510306,7510302,'apa',16.667,1),(653,7510307,7510302,'pac',16.667,1),(653,7510308,7510302,'aci',16.667,1),(653,7510309,7510302,'cit',16.667,1),(653,7510310,7510302,'ity',16.667,1),(653,7510311,7510305,'pat',50,1),(653,7510312,7510305,'ath',50,1),(653,7510313,7510311,'fre',14.286,1),(653,7510314,7510311,'ree',14.286,1),(653,7510315,7510311,'ees',14.286,1),(653,7510316,7510311,'esp',14.286,1),(653,7510317,7510311,'spa',14.286,1),(653,7510318,7510311,'pac',14.286,1),(653,7510319,7510311,'ace',14.286,1),(653,7510320,7510313,'dis',50,1),(653,7510321,7510313,'isk',50,1),(653,7510322,7510320,'ind',33.333,1),(653,7510323,7510320,'nde',33.333,1),(653,7510324,7510320,'dex',33.333,1),(653,7510325,7510322,'adm',8.333,1),(653,7510326,7510322,'dmi',8.333,1),(653,7510327,7510322,'min',8.333,1),(653,7510328,7510322,'ini',8.333,1),(653,7510329,7510322,'nis',8.333,1),(653,7510330,7510322,'ist',8.333,1),(653,7510331,7510322,'str',8.333,1),(653,7510332,7510322,'tra',8.333,1),(653,7510333,7510322,'rat',8.333,1),(653,7510334,7510322,'ati',8.333,1),(653,7510335,7510322,'tio',8.333,1),(653,7510336,7510322,'ion',8.333,1),(653,7510337,7510325,'sta',33.333,3),(653,7510338,7510325,'tat',33.333,3),(653,7510339,7510325,'ate',33.333,3),(653,7510340,7510337,'ena',20,2),(653,7510341,7510337,'nab',20,2),(653,7510342,7510337,'abl',20,2),(653,7510343,7510337,'ble',20,2),(653,7510344,7510337,'led',20,2),(653,7510345,7510340,'cac',33.333,2),(653,7510346,7510340,'ach',33.333,2),(653,7510347,7510340,'che',33.333,2),(653,7510348,7510345,'mod',50,1),(653,7510349,7510345,'ode',50,1),(653,7510350,7510348,'wri',14.286,1),(653,7510351,7510348,'rit',14.286,1),(653,7510352,7510348,'ite',14.286,1),(653,7510353,7510348,'tet',14.286,1),(653,7510354,7510348,'eth',14.286,1),(653,7510355,7510348,'thr',14.286,1),(653,7510356,7510348,'hru',14.286,1),(653,7510357,7510350,'ope',11.111,2),(653,7510358,7510350,'per',11.111,2),(653,7510359,7510350,'era',11.111,2),(653,7510360,7510350,'rat',11.111,2),(653,7510361,7510350,'ati',11.111,2),(653,7510362,7510350,'tio',11.111,2),(653,7510363,7510350,'ion',11.111,2),(653,7510364,7510350,'ona',11.111,2),(653,7510365,7510350,'nal',11.111,2),(653,7510366,7510357,'pen',20,1),(653,7510367,7510357,'end',20,1),(653,7510368,7510357,'ndi',20,1),(653,7510369,7510357,'din',20,1),(653,7510370,7510357,'ing',20,1),(653,7510371,7510366,'mes',20,1),(653,7510372,7510366,'ess',20,1),(653,7510373,7510366,'ssa',20,1),(653,7510374,7510366,'sag',20,1),(653,7510375,7510366,'age',20,1),(653,7510376,7510371,'wai',20,1),(653,7510377,7510371,'ait',20,1),(653,7510378,7510371,'iti',20,1),(653,7510379,7510371,'tin',20,1),(653,7510380,7510371,'ing',20,1),(653,7510381,7510376,'for',100,1),(653,7510382,7510381,'per',11.111,1),(653,7510383,7510381,'erf',11.111,1),(653,7510384,7510381,'rfo',11.111,1),(653,7510385,7510381,'for',11.111,1),(653,7510386,7510381,'orm',11.111,1),(653,7510387,7510381,'rma',11.111,1),(653,7510388,7510381,'man',11.111,1),(653,7510389,7510381,'anc',11.111,1),(653,7510390,7510381,'nce',11.111,1),(653,7510391,7510382,'ide',12.5,1),(653,7510392,7510382,'den',12.5,1),(653,7510393,7510382,'ent',12.5,1),(653,7510394,7510382,'nti',12.5,1),(653,7510395,7510382,'tif',12.5,1),(653,7510396,7510382,'ifi',12.5,1),(653,7510397,7510382,'fie',12.5,1),(653,7510398,7510382,'ier',12.5,1),(653,7510399,7510391,'vdi',33.333,3),(653,7510400,7510391,'dis',33.333,3),(653,7510401,7510391,'isk',33.333,3),(653,7510402,7510399,'nam',50,1),(653,7510403,7510399,'ame',50,1),(653,7510404,7510402,'typ',50,1),(653,7510405,7510402,'ype',50,1),(653,7510406,7510404,'dir',25,1),(653,7510407,7510404,'ire',25,1),(653,7510408,7510404,'rec',25,1),(653,7510409,7510404,'ect',25,1),(654,7510411,7510410,'naa',100,2),(654,7510412,7510411,'600',3.333,3),(654,7510413,7510411,'000',3.333,3),(654,7510414,7510411,'00c',3.333,3),(654,7510415,7510411,'0c2',3.333,3),(654,7510416,7510411,'c29',3.333,3),(654,7510417,7510411,'290',3.333,3),(654,7510418,7510411,'909',3.333,3),(654,7510419,7510411,'093',3.333,3),(654,7510420,7510411,'939',3.333,3),(654,7510421,7510411,'395',3.333,3),(654,7510422,7510411,'959',3.333,3),(654,7510423,7510411,'591',3.333,3),(654,7510424,7510411,'91e',3.333,3),(654,7510425,7510411,'1e7',3.333,3),(654,7510426,7510411,'e72',3.333,3),(654,7510427,7510411,'72b',3.333,3),(654,7510428,7510411,'2bb',3.333,3),(654,7510429,7510411,'bb0',3.333,3),(654,7510430,7510411,'b04',3.333,3),(654,7510431,7510411,'049',3.333,3),(654,7510432,7510411,'49e',3.333,3),(654,7510433,7510411,'9e6',3.333,3),(654,7510434,7510411,'e6e',3.333,3),(654,7510435,7510411,'6ee',3.333,3),(654,7510436,7510411,'ee2',3.333,3),(654,7510437,7510411,'e2d',3.333,3),(654,7510438,7510411,'2d1',3.333,3),(654,7510439,7510411,'d19',3.333,3),(654,7510440,7510411,'19b',3.333,3),(654,7510441,7510411,'9b3',3.333,3),(654,7510442,7510412,'mon',100,1),(654,7510443,7510442,'201',50,1),(654,7510444,7510442,'013',50,1),(654,7510445,7510443,'adm',33.333,3),(654,7510446,7510443,'dmi',33.333,3),(654,7510447,7510443,'min',33.333,3),(654,7510448,7510445,'cap',16.667,1),(654,7510449,7510445,'apa',16.667,1),(654,7510450,7510445,'pac',16.667,1),(654,7510451,7510445,'aci',16.667,1),(654,7510452,7510445,'cit',16.667,1),(654,7510453,7510445,'ity',16.667,1),(654,7510454,7510448,'pat',50,1),(654,7510455,7510448,'ath',50,1),(654,7510456,7510454,'fre',14.286,1),(654,7510457,7510454,'ree',14.286,1),(654,7510458,7510454,'ees',14.286,1),(654,7510459,7510454,'esp',14.286,1),(654,7510460,7510454,'spa',14.286,1),(654,7510461,7510454,'pac',14.286,1),(654,7510462,7510454,'ace',14.286,1),(654,7510463,7510456,'dis',50,1),(654,7510464,7510456,'isk',50,1),(654,7510465,7510463,'ind',33.333,1),(654,7510466,7510463,'nde',33.333,1),(654,7510467,7510463,'dex',33.333,1),(654,7510468,7510465,'adm',8.333,1),(654,7510469,7510465,'dmi',8.333,1),(654,7510470,7510465,'min',8.333,1),(654,7510471,7510465,'ini',8.333,1),(654,7510472,7510465,'nis',8.333,1),(654,7510473,7510465,'ist',8.333,1),(654,7510474,7510465,'str',8.333,1),(654,7510475,7510465,'tra',8.333,1),(654,7510476,7510465,'rat',8.333,1),(654,7510477,7510465,'ati',8.333,1),(654,7510478,7510465,'tio',8.333,1),(654,7510479,7510465,'ion',8.333,1),(654,7510480,7510468,'sta',33.333,3),(654,7510481,7510468,'tat',33.333,3),(654,7510482,7510468,'ate',33.333,3),(654,7510483,7510480,'ena',20,2),(654,7510484,7510480,'nab',20,2),(654,7510485,7510480,'abl',20,2),(654,7510486,7510480,'ble',20,2),(654,7510487,7510480,'led',20,2),(654,7510488,7510483,'cac',33.333,2),(654,7510489,7510483,'ach',33.333,2),(654,7510490,7510483,'che',33.333,2),(654,7510491,7510488,'mod',50,1),(654,7510492,7510488,'ode',50,1),(654,7510493,7510491,'wri',14.286,1),(654,7510494,7510491,'rit',14.286,1),(654,7510495,7510491,'ite',14.286,1),(654,7510496,7510491,'tet',14.286,1),(654,7510497,7510491,'eth',14.286,1),(654,7510498,7510491,'thr',14.286,1),(654,7510499,7510491,'hru',14.286,1),(654,7510500,7510493,'ope',11.111,2),(654,7510501,7510493,'per',11.111,2),(654,7510502,7510493,'era',11.111,2),(654,7510503,7510493,'rat',11.111,2),(654,7510504,7510493,'ati',11.111,2),(654,7510505,7510493,'tio',11.111,2),(654,7510506,7510493,'ion',11.111,2),(654,7510507,7510493,'ona',11.111,2),(654,7510508,7510493,'nal',11.111,2),(654,7510509,7510500,'pen',20,1),(654,7510510,7510500,'end',20,1),(654,7510511,7510500,'ndi',20,1),(654,7510512,7510500,'din',20,1),(654,7510513,7510500,'ing',20,1),(654,7510514,7510509,'mes',20,1),(654,7510515,7510509,'ess',20,1),(654,7510516,7510509,'ssa',20,1),(654,7510517,7510509,'sag',20,1),(654,7510518,7510509,'age',20,1),(654,7510519,7510514,'wai',20,1),(654,7510520,7510514,'ait',20,1),(654,7510521,7510514,'iti',20,1),(654,7510522,7510514,'tin',20,1),(654,7510523,7510514,'ing',20,1),(654,7510524,7510519,'for',100,1),(654,7510525,7510524,'per',11.111,1),(654,7510526,7510524,'erf',11.111,1),(654,7510527,7510524,'rfo',11.111,1),(654,7510528,7510524,'for',11.111,1),(654,7510529,7510524,'orm',11.111,1),(654,7510530,7510524,'rma',11.111,1),(654,7510531,7510524,'man',11.111,1),(654,7510532,7510524,'anc',11.111,1),(654,7510533,7510524,'nce',11.111,1),(654,7510534,7510525,'ide',12.5,1),(654,7510535,7510525,'den',12.5,1),(654,7510536,7510525,'ent',12.5,1),(654,7510537,7510525,'nti',12.5,1),(654,7510538,7510525,'tif',12.5,1),(654,7510539,7510525,'ifi',12.5,1),(654,7510540,7510525,'fie',12.5,1),(654,7510541,7510525,'ier',12.5,1),(654,7510542,7510534,'vdi',33.333,3),(654,7510543,7510534,'dis',33.333,3),(654,7510544,7510534,'isk',33.333,3),(654,7510545,7510542,'nam',50,1),(654,7510546,7510542,'ame',50,1),(654,7510547,7510545,'typ',50,1),(654,7510548,7510545,'ype',50,1),(654,7510549,7510547,'dir',25,1),(654,7510550,7510547,'ire',25,1),(654,7510551,7510547,'rec',25,1),(654,7510552,7510547,'ect',25,1),(655,7510554,7510553,'naa',100,2),(655,7510555,7510554,'600',3.333,3),(655,7510556,7510554,'000',3.333,3),(655,7510557,7510554,'00c',3.333,3),(655,7510558,7510554,'0c2',3.333,3),(655,7510559,7510554,'c29',3.333,3),(655,7510560,7510554,'294',3.333,3),(655,7510561,7510554,'945',3.333,3),(655,7510562,7510554,'456',3.333,3),(655,7510563,7510554,'560',3.333,3),(655,7510564,7510554,'605',3.333,3),(655,7510565,7510554,'056',3.333,3),(655,7510566,7510554,'564',3.333,3),(655,7510567,7510554,'64a',3.333,3),(655,7510568,7510554,'4a3',3.333,3),(655,7510569,7510554,'a33',3.333,3),(655,7510570,7510554,'330',3.333,3),(655,7510571,7510554,'30a',3.333,3),(655,7510572,7510554,'0a5',3.333,3),(655,7510573,7510554,'a53',3.333,3),(655,7510574,7510554,'53c',3.333,3),(655,7510575,7510554,'3cc',3.333,3),(655,7510576,7510554,'cca',3.333,3),(655,7510577,7510554,'caf',3.333,3),(655,7510578,7510554,'af9',3.333,3),(655,7510579,7510554,'f97',3.333,3),(655,7510580,7510554,'97e',3.333,3),(655,7510581,7510554,'7e6',3.333,3),(655,7510582,7510554,'e64',3.333,3),(655,7510583,7510554,'646',3.333,3),(655,7510584,7510554,'461',3.333,3),(655,7510585,7510555,'mon',100,1),(655,7510586,7510585,'201',50,1),(655,7510587,7510585,'013',50,1),(655,7510588,7510586,'adm',33.333,3),(655,7510589,7510586,'dmi',33.333,3),(655,7510590,7510586,'min',33.333,3),(655,7510591,7510588,'cap',16.667,1),(655,7510592,7510588,'apa',16.667,1),(655,7510593,7510588,'pac',16.667,1),(655,7510594,7510588,'aci',16.667,1),(655,7510595,7510588,'cit',16.667,1),(655,7510596,7510588,'ity',16.667,1),(655,7510597,7510591,'pat',50,1),(655,7510598,7510591,'ath',50,1),(655,7510599,7510597,'fre',14.286,1),(655,7510600,7510597,'ree',14.286,1),(655,7510601,7510597,'ees',14.286,1),(655,7510602,7510597,'esp',14.286,1),(655,7510603,7510597,'spa',14.286,1),(655,7510604,7510597,'pac',14.286,1),(655,7510605,7510597,'ace',14.286,1),(655,7510606,7510599,'dis',50,1),(655,7510607,7510599,'isk',50,1),(655,7510608,7510606,'ind',33.333,1),(655,7510609,7510606,'nde',33.333,1),(655,7510610,7510606,'dex',33.333,1),(655,7510611,7510608,'adm',8.333,1),(655,7510612,7510608,'dmi',8.333,1),(655,7510613,7510608,'min',8.333,1),(655,7510614,7510608,'ini',8.333,1),(655,7510615,7510608,'nis',8.333,1),(655,7510616,7510608,'ist',8.333,1),(655,7510617,7510608,'str',8.333,1),(655,7510618,7510608,'tra',8.333,1),(655,7510619,7510608,'rat',8.333,1),(655,7510620,7510608,'ati',8.333,1),(655,7510621,7510608,'tio',8.333,1),(655,7510622,7510608,'ion',8.333,1),(655,7510623,7510611,'sta',33.333,3),(655,7510624,7510611,'tat',33.333,3),(655,7510625,7510611,'ate',33.333,3),(655,7510626,7510623,'ena',20,2),(655,7510627,7510623,'nab',20,2),(655,7510628,7510623,'abl',20,2),(655,7510629,7510623,'ble',20,2),(655,7510630,7510623,'led',20,2),(655,7510631,7510626,'cac',33.333,2),(655,7510632,7510626,'ach',33.333,2),(655,7510633,7510626,'che',33.333,2),(655,7510634,7510631,'mod',50,1),(655,7510635,7510631,'ode',50,1),(655,7510636,7510634,'wri',14.286,1),(655,7510637,7510634,'rit',14.286,1),(655,7510638,7510634,'ite',14.286,1),(655,7510639,7510634,'tet',14.286,1),(655,7510640,7510634,'eth',14.286,1),(655,7510641,7510634,'thr',14.286,1),(655,7510642,7510634,'hru',14.286,1),(655,7510643,7510636,'ope',11.111,2),(655,7510644,7510636,'per',11.111,2),(655,7510645,7510636,'era',11.111,2),(655,7510646,7510636,'rat',11.111,2),(655,7510647,7510636,'ati',11.111,2),(655,7510648,7510636,'tio',11.111,2),(655,7510649,7510636,'ion',11.111,2),(655,7510650,7510636,'ona',11.111,2),(655,7510651,7510636,'nal',11.111,2),(655,7510652,7510643,'pen',20,1),(655,7510653,7510643,'end',20,1),(655,7510654,7510643,'ndi',20,1),(655,7510655,7510643,'din',20,1),(655,7510656,7510643,'ing',20,1),(655,7510657,7510652,'mes',20,1),(655,7510658,7510652,'ess',20,1),(655,7510659,7510652,'ssa',20,1),(655,7510660,7510652,'sag',20,1),(655,7510661,7510652,'age',20,1),(655,7510662,7510657,'wai',20,1),(655,7510663,7510657,'ait',20,1),(655,7510664,7510657,'iti',20,1),(655,7510665,7510657,'tin',20,1),(655,7510666,7510657,'ing',20,1),(655,7510667,7510662,'for',100,1),(655,7510668,7510667,'per',11.111,1),(655,7510669,7510667,'erf',11.111,1),(655,7510670,7510667,'rfo',11.111,1),(655,7510671,7510667,'for',11.111,1),(655,7510672,7510667,'orm',11.111,1),(655,7510673,7510667,'rma',11.111,1),(655,7510674,7510667,'man',11.111,1),(655,7510675,7510667,'anc',11.111,1),(655,7510676,7510667,'nce',11.111,1),(655,7510677,7510668,'ide',12.5,1),(655,7510678,7510668,'den',12.5,1),(655,7510679,7510668,'ent',12.5,1),(655,7510680,7510668,'nti',12.5,1),(655,7510681,7510668,'tif',12.5,1),(655,7510682,7510668,'ifi',12.5,1),(655,7510683,7510668,'fie',12.5,1),(655,7510684,7510668,'ier',12.5,1),(655,7510685,7510677,'vdi',33.333,3),(655,7510686,7510677,'dis',33.333,3),(655,7510687,7510677,'isk',33.333,3),(655,7510688,7510685,'nam',50,1),(655,7510689,7510685,'ame',50,1),(655,7510690,7510688,'typ',50,1),(655,7510691,7510688,'ype',50,1),(655,7510692,7510690,'dir',25,1),(655,7510693,7510690,'ire',25,1),(655,7510694,7510690,'rec',25,1),(655,7510695,7510690,'ect',25,1),(656,7510697,7510696,'naa',100,2),(656,7510698,7510697,'600',3.333,3),(656,7510699,7510697,'000',3.333,3),(656,7510700,7510697,'00c',3.333,3),(656,7510701,7510697,'0c2',3.333,3),(656,7510702,7510697,'c29',3.333,3),(656,7510703,7510697,'297',3.333,3),(656,7510704,7510697,'974',3.333,3),(656,7510705,7510697,'747',3.333,3),(656,7510706,7510697,'471',3.333,3),(656,7510707,7510697,'71e',3.333,3),(656,7510708,7510697,'1ed',3.333,3),(656,7510709,7510697,'ed7',3.333,3),(656,7510710,7510697,'d7b',3.333,3),(656,7510711,7510697,'7be',3.333,3),(656,7510712,7510697,'be5',3.333,3),(656,7510713,7510697,'e5b',3.333,3),(656,7510714,7510697,'5ba',3.333,3),(656,7510715,7510697,'ba7',3.333,3),(656,7510716,7510697,'a7d',3.333,3),(656,7510717,7510697,'7db',3.333,3),(656,7510718,7510697,'db5',3.333,3),(656,7510719,7510697,'b50',3.333,3),(656,7510720,7510697,'50e',3.333,3),(656,7510721,7510697,'0e9',3.333,3),(656,7510722,7510697,'e90',3.333,3),(656,7510723,7510697,'90b',3.333,3),(656,7510724,7510697,'0bb',3.333,3),(656,7510725,7510697,'bb9',3.333,3),(656,7510726,7510697,'b9d',3.333,3),(656,7510727,7510697,'9df',3.333,3),(656,7510728,7510698,'mon',100,1),(656,7510729,7510728,'201',50,1),(656,7510730,7510728,'013',50,1),(656,7510731,7510729,'adm',33.333,3),(656,7510732,7510729,'dmi',33.333,3),(656,7510733,7510729,'min',33.333,3),(656,7510734,7510731,'cap',16.667,1),(656,7510735,7510731,'apa',16.667,1),(656,7510736,7510731,'pac',16.667,1),(656,7510737,7510731,'aci',16.667,1),(656,7510738,7510731,'cit',16.667,1),(656,7510739,7510731,'ity',16.667,1),(656,7510740,7510734,'pat',50,1),(656,7510741,7510734,'ath',50,1),(656,7510742,7510740,'fre',14.286,1),(656,7510743,7510740,'ree',14.286,1),(656,7510744,7510740,'ees',14.286,1),(656,7510745,7510740,'esp',14.286,1),(656,7510746,7510740,'spa',14.286,1),(656,7510747,7510740,'pac',14.286,1),(656,7510748,7510740,'ace',14.286,1),(656,7510749,7510742,'dis',50,1),(656,7510750,7510742,'isk',50,1),(656,7510751,7510749,'ind',33.333,1),(656,7510752,7510749,'nde',33.333,1),(656,7510753,7510749,'dex',33.333,1),(656,7510754,7510751,'adm',8.333,1),(656,7510755,7510751,'dmi',8.333,1),(656,7510756,7510751,'min',8.333,1),(656,7510757,7510751,'ini',8.333,1),(656,7510758,7510751,'nis',8.333,1),(656,7510759,7510751,'ist',8.333,1),(656,7510760,7510751,'str',8.333,1),(656,7510761,7510751,'tra',8.333,1),(656,7510762,7510751,'rat',8.333,1),(656,7510763,7510751,'ati',8.333,1),(656,7510764,7510751,'tio',8.333,1),(656,7510765,7510751,'ion',8.333,1),(656,7510766,7510754,'sta',33.333,3),(656,7510767,7510754,'tat',33.333,3),(656,7510768,7510754,'ate',33.333,3),(656,7510769,7510766,'ena',20,2),(656,7510770,7510766,'nab',20,2),(656,7510771,7510766,'abl',20,2),(656,7510772,7510766,'ble',20,2),(656,7510773,7510766,'led',20,2),(656,7510774,7510769,'cac',33.333,2),(656,7510775,7510769,'ach',33.333,2),(656,7510776,7510769,'che',33.333,2),(656,7510777,7510774,'mod',50,1),(656,7510778,7510774,'ode',50,1),(656,7510779,7510777,'wri',14.286,1),(656,7510780,7510777,'rit',14.286,1),(656,7510781,7510777,'ite',14.286,1),(656,7510782,7510777,'tet',14.286,1),(656,7510783,7510777,'eth',14.286,1),(656,7510784,7510777,'thr',14.286,1),(656,7510785,7510777,'hru',14.286,1),(656,7510786,7510779,'ope',11.111,2),(656,7510787,7510779,'per',11.111,2),(656,7510788,7510779,'era',11.111,2),(656,7510789,7510779,'rat',11.111,2),(656,7510790,7510779,'ati',11.111,2),(656,7510791,7510779,'tio',11.111,2),(656,7510792,7510779,'ion',11.111,2),(656,7510793,7510779,'ona',11.111,2),(656,7510794,7510779,'nal',11.111,2),(656,7510795,7510786,'pen',20,1),(656,7510796,7510786,'end',20,1),(656,7510797,7510786,'ndi',20,1),(656,7510798,7510786,'din',20,1),(656,7510799,7510786,'ing',20,1),(656,7510800,7510795,'mes',20,1),(656,7510801,7510795,'ess',20,1),(656,7510802,7510795,'ssa',20,1),(656,7510803,7510795,'sag',20,1),(656,7510804,7510795,'age',20,1),(656,7510805,7510800,'wai',20,1),(656,7510806,7510800,'ait',20,1),(656,7510807,7510800,'iti',20,1),(656,7510808,7510800,'tin',20,1),(656,7510809,7510800,'ing',20,1),(656,7510810,7510805,'for',100,1),(656,7510811,7510810,'per',11.111,1),(656,7510812,7510810,'erf',11.111,1),(656,7510813,7510810,'rfo',11.111,1),(656,7510814,7510810,'for',11.111,1),(656,7510815,7510810,'orm',11.111,1),(656,7510816,7510810,'rma',11.111,1),(656,7510817,7510810,'man',11.111,1),(656,7510818,7510810,'anc',11.111,1),(656,7510819,7510810,'nce',11.111,1),(656,7510820,7510811,'ide',12.5,1),(656,7510821,7510811,'den',12.5,1),(656,7510822,7510811,'ent',12.5,1),(656,7510823,7510811,'nti',12.5,1),(656,7510824,7510811,'tif',12.5,1),(656,7510825,7510811,'ifi',12.5,1),(656,7510826,7510811,'fie',12.5,1),(656,7510827,7510811,'ier',12.5,1),(656,7510828,7510820,'vdi',33.333,3),(656,7510829,7510820,'dis',33.333,3),(656,7510830,7510820,'isk',33.333,3),(656,7510831,7510828,'nam',50,1),(656,7510832,7510828,'ame',50,1),(656,7510833,7510831,'typ',50,1),(656,7510834,7510831,'ype',50,1),(656,7510835,7510833,'dir',25,1),(656,7510836,7510833,'ire',25,1),(656,7510837,7510833,'rec',25,1),(656,7510838,7510833,'ect',25,1),(657,7510840,7510839,'naa',100,2),(657,7510841,7510840,'600',3.333,3),(657,7510842,7510840,'000',3.333,3),(657,7510843,7510840,'00c',3.333,3),(657,7510844,7510840,'0c2',3.333,3),(657,7510845,7510840,'c29',3.333,3),(657,7510846,7510840,'29a',3.333,3),(657,7510847,7510840,'9a0',3.333,3),(657,7510848,7510840,'a0d',3.333,3),(657,7510849,7510840,'0d8',3.333,3),(657,7510850,7510840,'d86',3.333,3),(657,7510851,7510840,'861',3.333,3),(657,7510852,7510840,'61f',3.333,3),(657,7510853,7510840,'1f5',3.333,3),(657,7510854,7510840,'f56',3.333,3),(657,7510855,7510840,'565',3.333,3),(657,7510856,7510840,'659',3.333,3),(657,7510857,7510840,'590',3.333,3),(657,7510858,7510840,'909',3.333,3),(657,7510859,7510840,'097',3.333,3),(657,7510860,7510840,'970',3.333,3),(657,7510861,7510840,'700',3.333,3),(657,7510862,7510840,'00f',3.333,3),(657,7510863,7510840,'0f4',3.333,3),(657,7510864,7510840,'f49',3.333,3),(657,7510865,7510840,'490',3.333,3),(657,7510866,7510840,'906',3.333,3),(657,7510867,7510840,'068',3.333,3),(657,7510868,7510840,'68a',3.333,3),(657,7510869,7510840,'8ae',3.333,3),(657,7510870,7510840,'ae5',3.333,3),(657,7510871,7510841,'mon',100,1),(657,7510872,7510871,'201',50,1),(657,7510873,7510871,'013',50,1),(657,7510874,7510872,'adm',33.333,3),(657,7510875,7510872,'dmi',33.333,3),(657,7510876,7510872,'min',33.333,3),(657,7510877,7510874,'cap',16.667,1),(657,7510878,7510874,'apa',16.667,1),(657,7510879,7510874,'pac',16.667,1),(657,7510880,7510874,'aci',16.667,1),(657,7510881,7510874,'cit',16.667,1),(657,7510882,7510874,'ity',16.667,1),(657,7510883,7510877,'pat',50,1),(657,7510884,7510877,'ath',50,1),(657,7510885,7510883,'fre',14.286,1),(657,7510886,7510883,'ree',14.286,1),(657,7510887,7510883,'ees',14.286,1),(657,7510888,7510883,'esp',14.286,1),(657,7510889,7510883,'spa',14.286,1),(657,7510890,7510883,'pac',14.286,1),(657,7510891,7510883,'ace',14.286,1),(657,7510892,7510885,'dis',50,1),(657,7510893,7510885,'isk',50,1),(657,7510894,7510892,'ind',33.333,1),(657,7510895,7510892,'nde',33.333,1),(657,7510896,7510892,'dex',33.333,1),(657,7510897,7510894,'adm',8.333,1),(657,7510898,7510894,'dmi',8.333,1),(657,7510899,7510894,'min',8.333,1),(657,7510900,7510894,'ini',8.333,1),(657,7510901,7510894,'nis',8.333,1),(657,7510902,7510894,'ist',8.333,1),(657,7510903,7510894,'str',8.333,1),(657,7510904,7510894,'tra',8.333,1),(657,7510905,7510894,'rat',8.333,1),(657,7510906,7510894,'ati',8.333,1),(657,7510907,7510894,'tio',8.333,1),(657,7510908,7510894,'ion',8.333,1),(657,7510909,7510897,'sta',33.333,3),(657,7510910,7510897,'tat',33.333,3),(657,7510911,7510897,'ate',33.333,3),(657,7510912,7510909,'ena',20,2),(657,7510913,7510909,'nab',20,2),(657,7510914,7510909,'abl',20,2),(657,7510915,7510909,'ble',20,2),(657,7510916,7510909,'led',20,2),(657,7510917,7510912,'cac',33.333,2),(657,7510918,7510912,'ach',33.333,2),(657,7510919,7510912,'che',33.333,2),(657,7510920,7510917,'mod',50,1),(657,7510921,7510917,'ode',50,1),(657,7510922,7510920,'wri',14.286,1),(657,7510923,7510920,'rit',14.286,1),(657,7510924,7510920,'ite',14.286,1),(657,7510925,7510920,'tet',14.286,1),(657,7510926,7510920,'eth',14.286,1),(657,7510927,7510920,'thr',14.286,1),(657,7510928,7510920,'hru',14.286,1),(657,7510929,7510922,'ope',11.111,2),(657,7510930,7510922,'per',11.111,2),(657,7510931,7510922,'era',11.111,2),(657,7510932,7510922,'rat',11.111,2),(657,7510933,7510922,'ati',11.111,2),(657,7510934,7510922,'tio',11.111,2),(657,7510935,7510922,'ion',11.111,2),(657,7510936,7510922,'ona',11.111,2),(657,7510937,7510922,'nal',11.111,2),(657,7510938,7510929,'pen',20,1),(657,7510939,7510929,'end',20,1),(657,7510940,7510929,'ndi',20,1),(657,7510941,7510929,'din',20,1),(657,7510942,7510929,'ing',20,1),(657,7510943,7510938,'mes',20,1),(657,7510944,7510938,'ess',20,1),(657,7510945,7510938,'ssa',20,1),(657,7510946,7510938,'sag',20,1),(657,7510947,7510938,'age',20,1),(657,7510948,7510943,'wai',20,1),(657,7510949,7510943,'ait',20,1),(657,7510950,7510943,'iti',20,1),(657,7510951,7510943,'tin',20,1),(657,7510952,7510943,'ing',20,1),(657,7510953,7510948,'for',100,1),(657,7510954,7510953,'per',11.111,1),(657,7510955,7510953,'erf',11.111,1),(657,7510956,7510953,'rfo',11.111,1),(657,7510957,7510953,'for',11.111,1),(657,7510958,7510953,'orm',11.111,1),(657,7510959,7510953,'rma',11.111,1),(657,7510960,7510953,'man',11.111,1),(657,7510961,7510953,'anc',11.111,1),(657,7510962,7510953,'nce',11.111,1),(657,7510963,7510954,'ide',12.5,1),(657,7510964,7510954,'den',12.5,1),(657,7510965,7510954,'ent',12.5,1),(657,7510966,7510954,'nti',12.5,1),(657,7510967,7510954,'tif',12.5,1),(657,7510968,7510954,'ifi',12.5,1),(657,7510969,7510954,'fie',12.5,1),(657,7510970,7510954,'ier',12.5,1),(657,7510971,7510963,'vdi',33.333,3),(657,7510972,7510963,'dis',33.333,3),(657,7510973,7510963,'isk',33.333,3),(657,7510974,7510971,'nam',50,1),(657,7510975,7510971,'ame',50,1),(657,7510976,7510974,'typ',50,1),(657,7510977,7510974,'ype',50,1),(657,7510978,7510976,'dir',25,1),(657,7510979,7510976,'ire',25,1),(657,7510980,7510976,'rec',25,1),(657,7510981,7510976,'ect',25,1),(658,7510983,7510982,'naa',100,2),(658,7510984,7510983,'600',3.333,3),(658,7510985,7510983,'000',3.333,3),(658,7510986,7510983,'00c',3.333,3),(658,7510987,7510983,'0c2',3.333,3),(658,7510988,7510983,'c29',3.333,3),(658,7510989,7510983,'296',3.333,3),(658,7510990,7510983,'965',3.333,3),(658,7510991,7510983,'65b',3.333,3),(658,7510992,7510983,'5ba',3.333,3),(658,7510993,7510983,'ba2',3.333,3),(658,7510994,7510983,'a28',3.333,3),(658,7510995,7510983,'287',3.333,3),(658,7510996,7510983,'87f',3.333,3),(658,7510997,7510983,'7f8',3.333,3),(658,7510998,7510983,'f8c',3.333,3),(658,7510999,7510983,'8cc',3.333,3),(658,7511000,7510983,'cc8',3.333,3),(658,7511001,7510983,'c86',3.333,3),(658,7511002,7510983,'861',3.333,3),(658,7511003,7510983,'611',3.333,3),(658,7511004,7510983,'11d',3.333,3),(658,7511005,7510983,'1d1',3.333,3),(658,7511006,7510983,'d19',3.333,3),(658,7511007,7510983,'19b',3.333,3),(658,7511008,7510983,'9bb',3.333,3),(658,7511009,7510983,'bb1',3.333,3),(658,7511010,7510983,'b13',3.333,3),(658,7511011,7510983,'13a',3.333,3),(658,7511012,7510983,'3a6',3.333,3),(658,7511013,7510983,'a69',3.333,3),(658,7511014,7510984,'mon',100,1),(658,7511015,7511014,'201',50,1),(658,7511016,7511014,'013',50,1),(658,7511017,7511015,'adm',33.333,3),(658,7511018,7511015,'dmi',33.333,3),(658,7511019,7511015,'min',33.333,3),(658,7511020,7511017,'cap',16.667,1),(658,7511021,7511017,'apa',16.667,1),(658,7511022,7511017,'pac',16.667,1),(658,7511023,7511017,'aci',16.667,1),(658,7511024,7511017,'cit',16.667,1),(658,7511025,7511017,'ity',16.667,1),(658,7511026,7511020,'pat',50,1),(658,7511027,7511020,'ath',50,1),(658,7511028,7511026,'fre',14.286,1),(658,7511029,7511026,'ree',14.286,1),(658,7511030,7511026,'ees',14.286,1),(658,7511031,7511026,'esp',14.286,1),(658,7511032,7511026,'spa',14.286,1),(658,7511033,7511026,'pac',14.286,1),(658,7511034,7511026,'ace',14.286,1),(658,7511035,7511028,'dis',50,1),(658,7511036,7511028,'isk',50,1),(658,7511037,7511035,'ind',33.333,1),(658,7511038,7511035,'nde',33.333,1),(658,7511039,7511035,'dex',33.333,1),(658,7511040,7511037,'adm',8.333,1),(658,7511041,7511037,'dmi',8.333,1),(658,7511042,7511037,'min',8.333,1),(658,7511043,7511037,'ini',8.333,1),(658,7511044,7511037,'nis',8.333,1),(658,7511045,7511037,'ist',8.333,1),(658,7511046,7511037,'str',8.333,1),(658,7511047,7511037,'tra',8.333,1),(658,7511048,7511037,'rat',8.333,1),(658,7511049,7511037,'ati',8.333,1),(658,7511050,7511037,'tio',8.333,1),(658,7511051,7511037,'ion',8.333,1),(658,7511052,7511040,'sta',33.333,3),(658,7511053,7511040,'tat',33.333,3),(658,7511054,7511040,'ate',33.333,3),(658,7511055,7511052,'ena',20,2),(658,7511056,7511052,'nab',20,2),(658,7511057,7511052,'abl',20,2),(658,7511058,7511052,'ble',20,2),(658,7511059,7511052,'led',20,2),(658,7511060,7511055,'cac',33.333,2),(658,7511061,7511055,'ach',33.333,2),(658,7511062,7511055,'che',33.333,2),(658,7511063,7511060,'mod',50,1),(658,7511064,7511060,'ode',50,1),(658,7511065,7511063,'wri',14.286,1),(658,7511066,7511063,'rit',14.286,1),(658,7511067,7511063,'ite',14.286,1),(658,7511068,7511063,'tet',14.286,1),(658,7511069,7511063,'eth',14.286,1),(658,7511070,7511063,'thr',14.286,1),(658,7511071,7511063,'hru',14.286,1),(658,7511072,7511065,'ope',11.111,2),(658,7511073,7511065,'per',11.111,2),(658,7511074,7511065,'era',11.111,2),(658,7511075,7511065,'rat',11.111,2),(658,7511076,7511065,'ati',11.111,2),(658,7511077,7511065,'tio',11.111,2),(658,7511078,7511065,'ion',11.111,2),(658,7511079,7511065,'ona',11.111,2),(658,7511080,7511065,'nal',11.111,2),(658,7511081,7511072,'pen',20,1),(658,7511082,7511072,'end',20,1),(658,7511083,7511072,'ndi',20,1),(658,7511084,7511072,'din',20,1),(658,7511085,7511072,'ing',20,1),(658,7511086,7511081,'mes',20,1),(658,7511087,7511081,'ess',20,1),(658,7511088,7511081,'ssa',20,1),(658,7511089,7511081,'sag',20,1),(658,7511090,7511081,'age',20,1),(658,7511091,7511086,'wai',20,1),(658,7511092,7511086,'ait',20,1),(658,7511093,7511086,'iti',20,1),(658,7511094,7511086,'tin',20,1),(658,7511095,7511086,'ing',20,1),(658,7511096,7511091,'for',100,1),(658,7511097,7511096,'per',11.111,1),(658,7511098,7511096,'erf',11.111,1),(658,7511099,7511096,'rfo',11.111,1),(658,7511100,7511096,'for',11.111,1),(658,7511101,7511096,'orm',11.111,1),(658,7511102,7511096,'rma',11.111,1),(658,7511103,7511096,'man',11.111,1),(658,7511104,7511096,'anc',11.111,1),(658,7511105,7511096,'nce',11.111,1),(658,7511106,7511097,'ide',12.5,1),(658,7511107,7511097,'den',12.5,1),(658,7511108,7511097,'ent',12.5,1),(658,7511109,7511097,'nti',12.5,1),(658,7511110,7511097,'tif',12.5,1),(658,7511111,7511097,'ifi',12.5,1),(658,7511112,7511097,'fie',12.5,1),(658,7511113,7511097,'ier',12.5,1),(658,7511114,7511106,'vdi',33.333,3),(658,7511115,7511106,'dis',33.333,3),(658,7511116,7511106,'isk',33.333,3),(658,7511117,7511114,'nam',50,1),(658,7511118,7511114,'ame',50,1),(658,7511119,7511117,'typ',50,1),(658,7511120,7511117,'ype',50,1),(658,7511121,7511119,'dir',25,1),(658,7511122,7511119,'ire',25,1),(658,7511123,7511119,'rec',25,1),(658,7511124,7511119,'ect',25,1),(659,7511126,7511125,'naa',100,2),(659,7511127,7511126,'600',3.333,3),(659,7511128,7511126,'000',3.333,3),(659,7511129,7511126,'00c',3.333,3),(659,7511130,7511126,'0c2',3.333,3),(659,7511131,7511126,'c29',3.333,3),(659,7511132,7511126,'291',3.333,3),(659,7511133,7511126,'912',3.333,3),(659,7511134,7511126,'12b',3.333,3),(659,7511135,7511126,'2b7',3.333,3),(659,7511136,7511126,'b76',3.333,3),(659,7511137,7511126,'76c',3.333,3),(659,7511138,7511126,'6c5',3.333,3),(659,7511139,7511126,'c5e',3.333,3),(659,7511140,7511126,'5e4',3.333,3),(659,7511141,7511126,'e4a',3.333,3),(659,7511142,7511126,'4ad',3.333,3),(659,7511143,7511126,'ad6',3.333,3),(659,7511144,7511126,'d6b',3.333,3),(659,7511145,7511126,'6bf',3.333,3),(659,7511146,7511126,'bf6',3.333,3),(659,7511147,7511126,'f67',3.333,3),(659,7511148,7511126,'674',3.333,3),(659,7511149,7511126,'749',3.333,3),(659,7511150,7511126,'49b',3.333,3),(659,7511151,7511126,'9bb',3.333,3),(659,7511152,7511126,'bb7',3.333,3),(659,7511153,7511126,'b7d',3.333,3),(659,7511154,7511126,'7d5',3.333,3),(659,7511155,7511126,'d57',3.333,3),(659,7511156,7511126,'57a',3.333,3),(659,7511157,7511127,'mon',100,1),(659,7511158,7511157,'201',50,1),(659,7511159,7511157,'013',50,1),(659,7511160,7511158,'adm',33.333,3),(659,7511161,7511158,'dmi',33.333,3),(659,7511162,7511158,'min',33.333,3),(659,7511163,7511160,'cap',16.667,1),(659,7511164,7511160,'apa',16.667,1),(659,7511165,7511160,'pac',16.667,1),(659,7511166,7511160,'aci',16.667,1),(659,7511167,7511160,'cit',16.667,1),(659,7511168,7511160,'ity',16.667,1),(659,7511169,7511163,'pat',50,1),(659,7511170,7511163,'ath',50,1),(659,7511171,7511169,'fre',14.286,1),(659,7511172,7511169,'ree',14.286,1),(659,7511173,7511169,'ees',14.286,1),(659,7511174,7511169,'esp',14.286,1),(659,7511175,7511169,'spa',14.286,1),(659,7511176,7511169,'pac',14.286,1),(659,7511177,7511169,'ace',14.286,1),(659,7511178,7511171,'dis',50,1),(659,7511179,7511171,'isk',50,1),(659,7511180,7511178,'ind',33.333,1),(659,7511181,7511178,'nde',33.333,1),(659,7511182,7511178,'dex',33.333,1),(659,7511183,7511180,'adm',8.333,1),(659,7511184,7511180,'dmi',8.333,1),(659,7511185,7511180,'min',8.333,1),(659,7511186,7511180,'ini',8.333,1),(659,7511187,7511180,'nis',8.333,1),(659,7511188,7511180,'ist',8.333,1),(659,7511189,7511180,'str',8.333,1),(659,7511190,7511180,'tra',8.333,1),(659,7511191,7511180,'rat',8.333,1),(659,7511192,7511180,'ati',8.333,1),(659,7511193,7511180,'tio',8.333,1),(659,7511194,7511180,'ion',8.333,1),(659,7511195,7511183,'sta',33.333,3),(659,7511196,7511183,'tat',33.333,3),(659,7511197,7511183,'ate',33.333,3),(659,7511198,7511195,'ena',20,2),(659,7511199,7511195,'nab',20,2),(659,7511200,7511195,'abl',20,2),(659,7511201,7511195,'ble',20,2),(659,7511202,7511195,'led',20,2),(659,7511203,7511198,'cac',33.333,2),(659,7511204,7511198,'ach',33.333,2),(659,7511205,7511198,'che',33.333,2),(659,7511206,7511203,'mod',50,1),(659,7511207,7511203,'ode',50,1),(659,7511208,7511206,'wri',14.286,1),(659,7511209,7511206,'rit',14.286,1),(659,7511210,7511206,'ite',14.286,1),(659,7511211,7511206,'tet',14.286,1),(659,7511212,7511206,'eth',14.286,1),(659,7511213,7511206,'thr',14.286,1),(659,7511214,7511206,'hru',14.286,1),(659,7511215,7511208,'ope',11.111,2),(659,7511216,7511208,'per',11.111,2),(659,7511217,7511208,'era',11.111,2),(659,7511218,7511208,'rat',11.111,2),(659,7511219,7511208,'ati',11.111,2),(659,7511220,7511208,'tio',11.111,2),(659,7511221,7511208,'ion',11.111,2),(659,7511222,7511208,'ona',11.111,2),(659,7511223,7511208,'nal',11.111,2),(659,7511224,7511215,'pen',20,1),(659,7511225,7511215,'end',20,1),(659,7511226,7511215,'ndi',20,1),(659,7511227,7511215,'din',20,1),(659,7511228,7511215,'ing',20,1),(659,7511229,7511224,'mes',20,1),(659,7511230,7511224,'ess',20,1),(659,7511231,7511224,'ssa',20,1),(659,7511232,7511224,'sag',20,1),(659,7511233,7511224,'age',20,1),(659,7511234,7511229,'wai',20,1),(659,7511235,7511229,'ait',20,1),(659,7511236,7511229,'iti',20,1),(659,7511237,7511229,'tin',20,1),(659,7511238,7511229,'ing',20,1),(659,7511239,7511234,'for',100,1),(659,7511240,7511239,'per',11.111,1),(659,7511241,7511239,'erf',11.111,1),(659,7511242,7511239,'rfo',11.111,1),(659,7511243,7511239,'for',11.111,1),(659,7511244,7511239,'orm',11.111,1),(659,7511245,7511239,'rma',11.111,1),(659,7511246,7511239,'man',11.111,1),(659,7511247,7511239,'anc',11.111,1),(659,7511248,7511239,'nce',11.111,1),(659,7511249,7511240,'ide',12.5,1),(659,7511250,7511240,'den',12.5,1),(659,7511251,7511240,'ent',12.5,1),(659,7511252,7511240,'nti',12.5,1),(659,7511253,7511240,'tif',12.5,1),(659,7511254,7511240,'ifi',12.5,1),(659,7511255,7511240,'fie',12.5,1),(659,7511256,7511240,'ier',12.5,1),(659,7511257,7511249,'vdi',33.333,3),(659,7511258,7511249,'dis',33.333,3),(659,7511259,7511249,'isk',33.333,3),(659,7511260,7511257,'nam',50,1),(659,7511261,7511257,'ame',50,1),(659,7511262,7511260,'typ',50,1),(659,7511263,7511260,'ype',50,1),(659,7511264,7511262,'dir',25,1),(659,7511265,7511262,'ire',25,1),(659,7511266,7511262,'rec',25,1),(659,7511267,7511262,'ect',25,1),(660,7511269,7511268,'naa',100,2),(660,7511270,7511269,'600',3.333,3),(660,7511271,7511269,'000',3.333,3),(660,7511272,7511269,'00c',3.333,3),(660,7511273,7511269,'0c2',3.333,3),(660,7511274,7511269,'c29',3.333,3),(660,7511275,7511269,'292',3.333,3),(660,7511276,7511269,'92a',3.333,3),(660,7511277,7511269,'2ae',3.333,3),(660,7511278,7511269,'ae2',3.333,3),(660,7511279,7511269,'e22',3.333,3),(660,7511280,7511269,'22c',3.333,3),(660,7511281,7511269,'2c9',3.333,3),(660,7511282,7511269,'c90',3.333,3),(660,7511283,7511269,'90a',3.333,3),(660,7511284,7511269,'0ac',3.333,3),(660,7511285,7511269,'acc',3.333,3),(660,7511286,7511269,'ccb',3.333,3),(660,7511287,7511269,'cbe',3.333,3),(660,7511288,7511269,'bea',3.333,3),(660,7511289,7511269,'eaf',3.333,3),(660,7511290,7511269,'afe',3.333,3),(660,7511291,7511269,'fef',3.333,3),(660,7511292,7511269,'efc',3.333,3),(660,7511293,7511269,'fcd',3.333,3),(660,7511294,7511269,'cde',3.333,3),(660,7511295,7511269,'dee',3.333,3),(660,7511296,7511269,'ee6',3.333,3),(660,7511297,7511269,'e61',3.333,3),(660,7511298,7511269,'611',3.333,3),(660,7511299,7511269,'112',3.333,3),(660,7511300,7511270,'mon',100,1),(660,7511301,7511300,'201',50,1),(660,7511302,7511300,'013',50,1),(660,7511303,7511301,'adm',33.333,3),(660,7511304,7511301,'dmi',33.333,3),(660,7511305,7511301,'min',33.333,3),(660,7511306,7511303,'cap',16.667,1),(660,7511307,7511303,'apa',16.667,1),(660,7511308,7511303,'pac',16.667,1),(660,7511309,7511303,'aci',16.667,1),(660,7511310,7511303,'cit',16.667,1),(660,7511311,7511303,'ity',16.667,1),(660,7511312,7511306,'pat',50,1),(660,7511313,7511306,'ath',50,1),(660,7511314,7511312,'fre',14.286,1),(660,7511315,7511312,'ree',14.286,1),(660,7511316,7511312,'ees',14.286,1),(660,7511317,7511312,'esp',14.286,1),(660,7511318,7511312,'spa',14.286,1),(660,7511319,7511312,'pac',14.286,1),(660,7511320,7511312,'ace',14.286,1),(660,7511321,7511314,'dis',50,1),(660,7511322,7511314,'isk',50,1),(660,7511323,7511321,'ind',33.333,1),(660,7511324,7511321,'nde',33.333,1),(660,7511325,7511321,'dex',33.333,1),(660,7511326,7511323,'adm',8.333,1),(660,7511327,7511323,'dmi',8.333,1),(660,7511328,7511323,'min',8.333,1),(660,7511329,7511323,'ini',8.333,1),(660,7511330,7511323,'nis',8.333,1),(660,7511331,7511323,'ist',8.333,1),(660,7511332,7511323,'str',8.333,1),(660,7511333,7511323,'tra',8.333,1),(660,7511334,7511323,'rat',8.333,1),(660,7511335,7511323,'ati',8.333,1),(660,7511336,7511323,'tio',8.333,1),(660,7511337,7511323,'ion',8.333,1),(660,7511338,7511326,'sta',33.333,3),(660,7511339,7511326,'tat',33.333,3),(660,7511340,7511326,'ate',33.333,3),(660,7511341,7511338,'ena',20,2),(660,7511342,7511338,'nab',20,2),(660,7511343,7511338,'abl',20,2),(660,7511344,7511338,'ble',20,2),(660,7511345,7511338,'led',20,2),(660,7511346,7511341,'cac',33.333,2),(660,7511347,7511341,'ach',33.333,2),(660,7511348,7511341,'che',33.333,2),(660,7511349,7511346,'mod',50,1),(660,7511350,7511346,'ode',50,1),(660,7511351,7511349,'wri',14.286,1),(660,7511352,7511349,'rit',14.286,1),(660,7511353,7511349,'ite',14.286,1),(660,7511354,7511349,'tet',14.286,1),(660,7511355,7511349,'eth',14.286,1),(660,7511356,7511349,'thr',14.286,1),(660,7511357,7511349,'hru',14.286,1),(660,7511358,7511351,'ope',11.111,2),(660,7511359,7511351,'per',11.111,2),(660,7511360,7511351,'era',11.111,2),(660,7511361,7511351,'rat',11.111,2),(660,7511362,7511351,'ati',11.111,2),(660,7511363,7511351,'tio',11.111,2),(660,7511364,7511351,'ion',11.111,2),(660,7511365,7511351,'ona',11.111,2),(660,7511366,7511351,'nal',11.111,2),(660,7511367,7511358,'pen',20,1),(660,7511368,7511358,'end',20,1),(660,7511369,7511358,'ndi',20,1),(660,7511370,7511358,'din',20,1),(660,7511371,7511358,'ing',20,1),(660,7511372,7511367,'mes',20,1),(660,7511373,7511367,'ess',20,1),(660,7511374,7511367,'ssa',20,1),(660,7511375,7511367,'sag',20,1),(660,7511376,7511367,'age',20,1),(660,7511377,7511372,'wai',20,1),(660,7511378,7511372,'ait',20,1),(660,7511379,7511372,'iti',20,1),(660,7511380,7511372,'tin',20,1),(660,7511381,7511372,'ing',20,1),(660,7511382,7511377,'for',100,1),(660,7511383,7511382,'per',11.111,1),(660,7511384,7511382,'erf',11.111,1),(660,7511385,7511382,'rfo',11.111,1),(660,7511386,7511382,'for',11.111,1),(660,7511387,7511382,'orm',11.111,1),(660,7511388,7511382,'rma',11.111,1),(660,7511389,7511382,'man',11.111,1),(660,7511390,7511382,'anc',11.111,1),(660,7511391,7511382,'nce',11.111,1),(660,7511392,7511383,'ide',12.5,1),(660,7511393,7511383,'den',12.5,1),(660,7511394,7511383,'ent',12.5,1),(660,7511395,7511383,'nti',12.5,1),(660,7511396,7511383,'tif',12.5,1),(660,7511397,7511383,'ifi',12.5,1),(660,7511398,7511383,'fie',12.5,1),(660,7511399,7511383,'ier',12.5,1),(660,7511400,7511392,'vdi',33.333,3),(660,7511401,7511392,'dis',33.333,3),(660,7511402,7511392,'isk',33.333,3),(660,7511403,7511400,'nam',50,1),(660,7511404,7511400,'ame',50,1),(660,7511405,7511403,'typ',50,1),(660,7511406,7511403,'ype',50,1),(660,7511407,7511405,'dir',25,1),(660,7511408,7511405,'ire',25,1),(660,7511409,7511405,'rec',25,1),(660,7511410,7511405,'ect',25,1),(661,7511412,7511411,'naa',100,2),(661,7511413,7511412,'600',3.333,3),(661,7511414,7511412,'000',3.333,3),(661,7511415,7511412,'00c',3.333,3),(661,7511416,7511412,'0c2',3.333,3),(661,7511417,7511412,'c29',3.333,3),(661,7511418,7511412,'294',3.333,3),(661,7511419,7511412,'94b',3.333,3),(661,7511420,7511412,'4b6',3.333,3),(661,7511421,7511412,'b69',3.333,3),(661,7511422,7511412,'69e',3.333,3),(661,7511423,7511412,'9ea',3.333,3),(661,7511424,7511412,'ea9',3.333,3),(661,7511425,7511412,'a93',3.333,3),(661,7511426,7511412,'931',3.333,3),(661,7511427,7511412,'31c',3.333,3),(661,7511428,7511412,'1c1',3.333,3),(661,7511429,7511412,'c10',3.333,3),(661,7511430,7511412,'10b',3.333,3),(661,7511431,7511412,'0bb',3.333,3),(661,7511432,7511412,'bb9',3.333,3),(661,7511433,7511412,'b93',3.333,3),(661,7511434,7511412,'934',3.333,3),(661,7511435,7511412,'34e',3.333,3),(661,7511436,7511412,'4e4',3.333,3),(661,7511437,7511412,'e41',3.333,3),(661,7511438,7511412,'412',3.333,3),(661,7511439,7511412,'123',3.333,3),(661,7511440,7511412,'232',3.333,3),(661,7511441,7511412,'326',3.333,3),(661,7511442,7511412,'26b',3.333,3),(661,7511443,7511413,'mon',100,1),(661,7511444,7511443,'201',50,1),(661,7511445,7511443,'013',50,1),(661,7511446,7511444,'adm',33.333,3),(661,7511447,7511444,'dmi',33.333,3),(661,7511448,7511444,'min',33.333,3),(661,7511449,7511446,'cap',16.667,1),(661,7511450,7511446,'apa',16.667,1),(661,7511451,7511446,'pac',16.667,1),(661,7511452,7511446,'aci',16.667,1),(661,7511453,7511446,'cit',16.667,1),(661,7511454,7511446,'ity',16.667,1),(661,7511455,7511449,'pat',50,1),(661,7511456,7511449,'ath',50,1),(661,7511457,7511455,'fre',14.286,1),(661,7511458,7511455,'ree',14.286,1),(661,7511459,7511455,'ees',14.286,1),(661,7511460,7511455,'esp',14.286,1),(661,7511461,7511455,'spa',14.286,1),(661,7511462,7511455,'pac',14.286,1),(661,7511463,7511455,'ace',14.286,1),(661,7511464,7511457,'dis',50,1),(661,7511465,7511457,'isk',50,1),(661,7511466,7511464,'ind',33.333,1),(661,7511467,7511464,'nde',33.333,1),(661,7511468,7511464,'dex',33.333,1),(661,7511469,7511466,'adm',8.333,1),(661,7511470,7511466,'dmi',8.333,1),(661,7511471,7511466,'min',8.333,1),(661,7511472,7511466,'ini',8.333,1),(661,7511473,7511466,'nis',8.333,1),(661,7511474,7511466,'ist',8.333,1),(661,7511475,7511466,'str',8.333,1),(661,7511476,7511466,'tra',8.333,1),(661,7511477,7511466,'rat',8.333,1),(661,7511478,7511466,'ati',8.333,1),(661,7511479,7511466,'tio',8.333,1),(661,7511480,7511466,'ion',8.333,1),(661,7511481,7511469,'sta',33.333,3),(661,7511482,7511469,'tat',33.333,3),(661,7511483,7511469,'ate',33.333,3),(661,7511484,7511481,'ena',20,2),(661,7511485,7511481,'nab',20,2),(661,7511486,7511481,'abl',20,2),(661,7511487,7511481,'ble',20,2),(661,7511488,7511481,'led',20,2),(661,7511489,7511484,'cac',33.333,2),(661,7511490,7511484,'ach',33.333,2),(661,7511491,7511484,'che',33.333,2),(661,7511492,7511489,'mod',50,1),(661,7511493,7511489,'ode',50,1),(661,7511494,7511492,'wri',14.286,1),(661,7511495,7511492,'rit',14.286,1),(661,7511496,7511492,'ite',14.286,1),(661,7511497,7511492,'tet',14.286,1),(661,7511498,7511492,'eth',14.286,1),(661,7511499,7511492,'thr',14.286,1),(661,7511500,7511492,'hru',14.286,1),(661,7511501,7511494,'ope',11.111,2),(661,7511502,7511494,'per',11.111,2),(661,7511503,7511494,'era',11.111,2),(661,7511504,7511494,'rat',11.111,2),(661,7511505,7511494,'ati',11.111,2),(661,7511506,7511494,'tio',11.111,2),(661,7511507,7511494,'ion',11.111,2),(661,7511508,7511494,'ona',11.111,2),(661,7511509,7511494,'nal',11.111,2),(661,7511510,7511501,'pen',20,1),(661,7511511,7511501,'end',20,1),(661,7511512,7511501,'ndi',20,1),(661,7511513,7511501,'din',20,1),(661,7511514,7511501,'ing',20,1),(661,7511515,7511510,'mes',20,1),(661,7511516,7511510,'ess',20,1),(661,7511517,7511510,'ssa',20,1),(661,7511518,7511510,'sag',20,1),(661,7511519,7511510,'age',20,1),(661,7511520,7511515,'wai',20,1),(661,7511521,7511515,'ait',20,1),(661,7511522,7511515,'iti',20,1),(661,7511523,7511515,'tin',20,1),(661,7511524,7511515,'ing',20,1),(661,7511525,7511520,'for',100,1),(661,7511526,7511525,'per',11.111,1),(661,7511527,7511525,'erf',11.111,1),(661,7511528,7511525,'rfo',11.111,1),(661,7511529,7511525,'for',11.111,1),(661,7511530,7511525,'orm',11.111,1),(661,7511531,7511525,'rma',11.111,1),(661,7511532,7511525,'man',11.111,1),(661,7511533,7511525,'anc',11.111,1),(661,7511534,7511525,'nce',11.111,1),(661,7511535,7511526,'ide',12.5,1),(661,7511536,7511526,'den',12.5,1),(661,7511537,7511526,'ent',12.5,1),(661,7511538,7511526,'nti',12.5,1),(661,7511539,7511526,'tif',12.5,1),(661,7511540,7511526,'ifi',12.5,1),(661,7511541,7511526,'fie',12.5,1),(661,7511542,7511526,'ier',12.5,1),(661,7511543,7511535,'vdi',33.333,3),(661,7511544,7511535,'dis',33.333,3),(661,7511545,7511535,'isk',33.333,3),(661,7511546,7511543,'nam',50,1),(661,7511547,7511543,'ame',50,1),(661,7511548,7511546,'typ',50,1),(661,7511549,7511546,'ype',50,1),(661,7511550,7511548,'dir',25,1),(661,7511551,7511548,'ire',25,1),(661,7511552,7511548,'rec',25,1),(661,7511553,7511548,'ect',25,1),(662,7511555,7511554,'naa',100,2),(662,7511556,7511555,'600',3.333,3),(662,7511557,7511555,'000',3.333,3),(662,7511558,7511555,'00c',3.333,3),(662,7511559,7511555,'0c2',3.333,3),(662,7511560,7511555,'c29',3.333,3),(662,7511561,7511555,'29d',3.333,3),(662,7511562,7511555,'9d3',3.333,3),(662,7511563,7511555,'d30',3.333,3),(662,7511564,7511555,'30c',3.333,3),(662,7511565,7511555,'0c0',3.333,3),(662,7511566,7511555,'c02',3.333,3),(662,7511567,7511555,'029',3.333,3),(662,7511568,7511555,'295',3.333,3),(662,7511569,7511555,'957',3.333,3),(662,7511570,7511555,'578',3.333,3),(662,7511571,7511555,'78a',3.333,3),(662,7511572,7511555,'8a6',3.333,3),(662,7511573,7511555,'a6c',3.333,3),(662,7511574,7511555,'6c0',3.333,3),(662,7511575,7511555,'c00',3.333,3),(662,7511576,7511555,'00f',3.333,3),(662,7511577,7511555,'0f4',3.333,3),(662,7511578,7511555,'f4b',3.333,3),(662,7511579,7511555,'4b5',3.333,3),(662,7511580,7511555,'b57',3.333,3),(662,7511581,7511555,'579',3.333,3),(662,7511582,7511555,'795',3.333,3),(662,7511583,7511555,'957',3.333,3),(662,7511584,7511555,'57c',3.333,3),(662,7511585,7511555,'7c8',3.333,3),(662,7511586,7511556,'mon',100,1),(662,7511587,7511586,'201',50,1),(662,7511588,7511586,'013',50,1),(662,7511589,7511587,'adm',33.333,3),(662,7511590,7511587,'dmi',33.333,3),(662,7511591,7511587,'min',33.333,3),(662,7511592,7511589,'cap',16.667,1),(662,7511593,7511589,'apa',16.667,1),(662,7511594,7511589,'pac',16.667,1),(662,7511595,7511589,'aci',16.667,1),(662,7511596,7511589,'cit',16.667,1),(662,7511597,7511589,'ity',16.667,1),(662,7511598,7511592,'pat',50,1),(662,7511599,7511592,'ath',50,1),(662,7511600,7511598,'fre',14.286,1),(662,7511601,7511598,'ree',14.286,1),(662,7511602,7511598,'ees',14.286,1),(662,7511603,7511598,'esp',14.286,1),(662,7511604,7511598,'spa',14.286,1),(662,7511605,7511598,'pac',14.286,1),(662,7511606,7511598,'ace',14.286,1),(662,7511607,7511600,'dis',50,1),(662,7511608,7511600,'isk',50,1),(662,7511609,7511607,'ind',33.333,1),(662,7511610,7511607,'nde',33.333,1),(662,7511611,7511607,'dex',33.333,1),(662,7511612,7511609,'adm',8.333,1),(662,7511613,7511609,'dmi',8.333,1),(662,7511614,7511609,'min',8.333,1),(662,7511615,7511609,'ini',8.333,1),(662,7511616,7511609,'nis',8.333,1),(662,7511617,7511609,'ist',8.333,1),(662,7511618,7511609,'str',8.333,1),(662,7511619,7511609,'tra',8.333,1),(662,7511620,7511609,'rat',8.333,1),(662,7511621,7511609,'ati',8.333,1),(662,7511622,7511609,'tio',8.333,1),(662,7511623,7511609,'ion',8.333,1),(662,7511624,7511612,'sta',33.333,3),(662,7511625,7511612,'tat',33.333,3),(662,7511626,7511612,'ate',33.333,3),(662,7511627,7511624,'ena',20,2),(662,7511628,7511624,'nab',20,2),(662,7511629,7511624,'abl',20,2),(662,7511630,7511624,'ble',20,2),(662,7511631,7511624,'led',20,2),(662,7511632,7511627,'cac',33.333,2),(662,7511633,7511627,'ach',33.333,2),(662,7511634,7511627,'che',33.333,2),(662,7511635,7511632,'mod',50,1),(662,7511636,7511632,'ode',50,1),(662,7511637,7511635,'wri',14.286,1),(662,7511638,7511635,'rit',14.286,1),(662,7511639,7511635,'ite',14.286,1),(662,7511640,7511635,'tet',14.286,1),(662,7511641,7511635,'eth',14.286,1),(662,7511642,7511635,'thr',14.286,1),(662,7511643,7511635,'hru',14.286,1),(662,7511644,7511637,'ope',11.111,2),(662,7511645,7511637,'per',11.111,2),(662,7511646,7511637,'era',11.111,2),(662,7511647,7511637,'rat',11.111,2),(662,7511648,7511637,'ati',11.111,2),(662,7511649,7511637,'tio',11.111,2),(662,7511650,7511637,'ion',11.111,2),(662,7511651,7511637,'ona',11.111,2),(662,7511652,7511637,'nal',11.111,2),(662,7511653,7511644,'pen',20,1),(662,7511654,7511644,'end',20,1),(662,7511655,7511644,'ndi',20,1),(662,7511656,7511644,'din',20,1),(662,7511657,7511644,'ing',20,1),(662,7511658,7511653,'mes',20,1),(662,7511659,7511653,'ess',20,1),(662,7511660,7511653,'ssa',20,1),(662,7511661,7511653,'sag',20,1),(662,7511662,7511653,'age',20,1),(662,7511663,7511658,'wai',20,1),(662,7511664,7511658,'ait',20,1),(662,7511665,7511658,'iti',20,1),(662,7511666,7511658,'tin',20,1),(662,7511667,7511658,'ing',20,1),(662,7511668,7511663,'for',100,1),(662,7511669,7511668,'per',11.111,1),(662,7511670,7511668,'erf',11.111,1),(662,7511671,7511668,'rfo',11.111,1),(662,7511672,7511668,'for',11.111,1),(662,7511673,7511668,'orm',11.111,1),(662,7511674,7511668,'rma',11.111,1),(662,7511675,7511668,'man',11.111,1),(662,7511676,7511668,'anc',11.111,1),(662,7511677,7511668,'nce',11.111,1),(662,7511678,7511669,'ide',12.5,1),(662,7511679,7511669,'den',12.5,1),(662,7511680,7511669,'ent',12.5,1),(662,7511681,7511669,'nti',12.5,1),(662,7511682,7511669,'tif',12.5,1),(662,7511683,7511669,'ifi',12.5,1),(662,7511684,7511669,'fie',12.5,1),(662,7511685,7511669,'ier',12.5,1),(662,7511686,7511678,'vdi',33.333,3),(662,7511687,7511678,'dis',33.333,3),(662,7511688,7511678,'isk',33.333,3),(662,7511689,7511686,'nam',50,1),(662,7511690,7511686,'ame',50,1),(662,7511691,7511689,'typ',50,1),(662,7511692,7511689,'ype',50,1),(662,7511693,7511691,'dir',25,1),(662,7511694,7511691,'ire',25,1),(662,7511695,7511691,'rec',25,1),(662,7511696,7511691,'ect',25,1),(663,7511698,7511697,'naa',100,2),(663,7511699,7511698,'600',3.333,3),(663,7511700,7511698,'000',3.333,3),(663,7511701,7511698,'00c',3.333,3),(663,7511702,7511698,'0c2',3.333,3),(663,7511703,7511698,'c29',3.333,3),(663,7511704,7511698,'29c',3.333,3),(663,7511705,7511698,'9c6',3.333,3),(663,7511706,7511698,'c65',3.333,3),(663,7511707,7511698,'65e',3.333,3),(663,7511708,7511698,'5e2',3.333,3),(663,7511709,7511698,'e26',3.333,3),(663,7511710,7511698,'262',3.333,3),(663,7511711,7511698,'62d',3.333,3),(663,7511712,7511698,'2d4',3.333,3),(663,7511713,7511698,'d43',3.333,3),(663,7511714,7511698,'438',3.333,3),(663,7511715,7511698,'380',3.333,3),(663,7511716,7511698,'80d',3.333,3),(663,7511717,7511698,'0d8',3.333,3),(663,7511718,7511698,'d8d',3.333,3),(663,7511719,7511698,'8d1',3.333,3),(663,7511720,7511698,'d19',3.333,3),(663,7511721,7511698,'197',3.333,3),(663,7511722,7511698,'97d',3.333,3),(663,7511723,7511698,'7dc',3.333,3),(663,7511724,7511698,'dca',3.333,3),(663,7511725,7511698,'ca5',3.333,3),(663,7511726,7511698,'a5a',3.333,3),(663,7511727,7511698,'5ab',3.333,3),(663,7511728,7511698,'ab9',3.333,3),(663,7511729,7511699,'mon',100,1),(663,7511730,7511729,'201',50,1),(663,7511731,7511729,'013',50,1),(663,7511732,7511730,'adm',33.333,3),(663,7511733,7511730,'dmi',33.333,3),(663,7511734,7511730,'min',33.333,3),(663,7511735,7511732,'cap',16.667,1),(663,7511736,7511732,'apa',16.667,1),(663,7511737,7511732,'pac',16.667,1),(663,7511738,7511732,'aci',16.667,1),(663,7511739,7511732,'cit',16.667,1),(663,7511740,7511732,'ity',16.667,1),(663,7511741,7511735,'pat',50,1),(663,7511742,7511735,'ath',50,1),(663,7511743,7511741,'fre',14.286,1),(663,7511744,7511741,'ree',14.286,1),(663,7511745,7511741,'ees',14.286,1),(663,7511746,7511741,'esp',14.286,1),(663,7511747,7511741,'spa',14.286,1),(663,7511748,7511741,'pac',14.286,1),(663,7511749,7511741,'ace',14.286,1),(663,7511750,7511743,'dis',50,1),(663,7511751,7511743,'isk',50,1),(663,7511752,7511750,'ind',33.333,1),(663,7511753,7511750,'nde',33.333,1),(663,7511754,7511750,'dex',33.333,1),(663,7511755,7511752,'adm',8.333,1),(663,7511756,7511752,'dmi',8.333,1),(663,7511757,7511752,'min',8.333,1),(663,7511758,7511752,'ini',8.333,1),(663,7511759,7511752,'nis',8.333,1),(663,7511760,7511752,'ist',8.333,1),(663,7511761,7511752,'str',8.333,1),(663,7511762,7511752,'tra',8.333,1),(663,7511763,7511752,'rat',8.333,1),(663,7511764,7511752,'ati',8.333,1),(663,7511765,7511752,'tio',8.333,1),(663,7511766,7511752,'ion',8.333,1),(663,7511767,7511755,'sta',33.333,3),(663,7511768,7511755,'tat',33.333,3),(663,7511769,7511755,'ate',33.333,3),(663,7511770,7511767,'ena',20,2),(663,7511771,7511767,'nab',20,2),(663,7511772,7511767,'abl',20,2),(663,7511773,7511767,'ble',20,2),(663,7511774,7511767,'led',20,2),(663,7511775,7511770,'cac',33.333,2),(663,7511776,7511770,'ach',33.333,2),(663,7511777,7511770,'che',33.333,2),(663,7511778,7511775,'mod',50,1),(663,7511779,7511775,'ode',50,1),(663,7511780,7511778,'wri',14.286,1),(663,7511781,7511778,'rit',14.286,1),(663,7511782,7511778,'ite',14.286,1),(663,7511783,7511778,'tet',14.286,1),(663,7511784,7511778,'eth',14.286,1),(663,7511785,7511778,'thr',14.286,1),(663,7511786,7511778,'hru',14.286,1),(663,7511787,7511780,'ope',11.111,2),(663,7511788,7511780,'per',11.111,2),(663,7511789,7511780,'era',11.111,2),(663,7511790,7511780,'rat',11.111,2),(663,7511791,7511780,'ati',11.111,2),(663,7511792,7511780,'tio',11.111,2),(663,7511793,7511780,'ion',11.111,2),(663,7511794,7511780,'ona',11.111,2),(663,7511795,7511780,'nal',11.111,2),(663,7511796,7511787,'pen',20,1),(663,7511797,7511787,'end',20,1),(663,7511798,7511787,'ndi',20,1),(663,7511799,7511787,'din',20,1),(663,7511800,7511787,'ing',20,1),(663,7511801,7511796,'mes',20,1),(663,7511802,7511796,'ess',20,1),(663,7511803,7511796,'ssa',20,1),(663,7511804,7511796,'sag',20,1),(663,7511805,7511796,'age',20,1),(663,7511806,7511801,'wai',20,1),(663,7511807,7511801,'ait',20,1),(663,7511808,7511801,'iti',20,1),(663,7511809,7511801,'tin',20,1),(663,7511810,7511801,'ing',20,1),(663,7511811,7511806,'for',100,1),(663,7511812,7511811,'per',11.111,1),(663,7511813,7511811,'erf',11.111,1),(663,7511814,7511811,'rfo',11.111,1),(663,7511815,7511811,'for',11.111,1),(663,7511816,7511811,'orm',11.111,1),(663,7511817,7511811,'rma',11.111,1),(663,7511818,7511811,'man',11.111,1),(663,7511819,7511811,'anc',11.111,1),(663,7511820,7511811,'nce',11.111,1),(663,7511821,7511812,'ide',12.5,1),(663,7511822,7511812,'den',12.5,1),(663,7511823,7511812,'ent',12.5,1),(663,7511824,7511812,'nti',12.5,1),(663,7511825,7511812,'tif',12.5,1),(663,7511826,7511812,'ifi',12.5,1),(663,7511827,7511812,'fie',12.5,1),(663,7511828,7511812,'ier',12.5,1),(663,7511829,7511821,'vdi',33.333,3),(663,7511830,7511821,'dis',33.333,3),(663,7511831,7511821,'isk',33.333,3),(663,7511832,7511829,'nam',50,1),(663,7511833,7511829,'ame',50,1),(663,7511834,7511832,'typ',50,1),(663,7511835,7511832,'ype',50,1),(663,7511836,7511834,'dir',25,1),(663,7511837,7511834,'ire',25,1),(663,7511838,7511834,'rec',25,1),(663,7511839,7511834,'ect',25,1),(664,7511841,7511840,'naa',100,2),(664,7511842,7511841,'600',3.333,3),(664,7511843,7511841,'000',3.333,3),(664,7511844,7511841,'00c',3.333,3),(664,7511845,7511841,'0c2',3.333,3),(664,7511846,7511841,'c29',3.333,3),(664,7511847,7511841,'293',3.333,3),(664,7511848,7511841,'930',3.333,3),(664,7511849,7511841,'30a',3.333,3),(664,7511850,7511841,'0ac',3.333,3),(664,7511851,7511841,'ac9',3.333,3),(664,7511852,7511841,'c93',3.333,3),(664,7511853,7511841,'93f',3.333,3),(664,7511854,7511841,'3f6',3.333,3),(664,7511855,7511841,'f66',3.333,3),(664,7511856,7511841,'663',3.333,3),(664,7511857,7511841,'632',3.333,3),(664,7511858,7511841,'327',3.333,3),(664,7511859,7511841,'271',3.333,3),(664,7511860,7511841,'712',3.333,3),(664,7511861,7511841,'123',3.333,3),(664,7511862,7511841,'23c',3.333,3),(664,7511863,7511841,'3cc',3.333,3),(664,7511864,7511841,'cc9',3.333,3),(664,7511865,7511841,'c90',3.333,3),(664,7511866,7511841,'90b',3.333,3),(664,7511867,7511841,'0ba',3.333,3),(664,7511868,7511841,'baa',3.333,3),(664,7511869,7511841,'aaa',3.333,3),(664,7511870,7511841,'aad',3.333,3),(664,7511871,7511841,'adc',3.333,3),(664,7511872,7511842,'mon',100,1),(664,7511873,7511872,'201',50,1),(664,7511874,7511872,'013',50,1),(664,7511875,7511873,'adm',33.333,3),(664,7511876,7511873,'dmi',33.333,3),(664,7511877,7511873,'min',33.333,3),(664,7511878,7511875,'cap',16.667,1),(664,7511879,7511875,'apa',16.667,1),(664,7511880,7511875,'pac',16.667,1),(664,7511881,7511875,'aci',16.667,1),(664,7511882,7511875,'cit',16.667,1),(664,7511883,7511875,'ity',16.667,1),(664,7511884,7511878,'pat',50,1),(664,7511885,7511878,'ath',50,1),(664,7511886,7511884,'fre',14.286,1),(664,7511887,7511884,'ree',14.286,1),(664,7511888,7511884,'ees',14.286,1),(664,7511889,7511884,'esp',14.286,1),(664,7511890,7511884,'spa',14.286,1),(664,7511891,7511884,'pac',14.286,1),(664,7511892,7511884,'ace',14.286,1),(664,7511893,7511886,'dis',50,1),(664,7511894,7511886,'isk',50,1),(664,7511895,7511893,'ind',33.333,1),(664,7511896,7511893,'nde',33.333,1),(664,7511897,7511893,'dex',33.333,1),(664,7511898,7511895,'adm',8.333,1),(664,7511899,7511895,'dmi',8.333,1),(664,7511900,7511895,'min',8.333,1),(664,7511901,7511895,'ini',8.333,1),(664,7511902,7511895,'nis',8.333,1),(664,7511903,7511895,'ist',8.333,1),(664,7511904,7511895,'str',8.333,1),(664,7511905,7511895,'tra',8.333,1),(664,7511906,7511895,'rat',8.333,1),(664,7511907,7511895,'ati',8.333,1),(664,7511908,7511895,'tio',8.333,1),(664,7511909,7511895,'ion',8.333,1),(664,7511910,7511898,'sta',33.333,3),(664,7511911,7511898,'tat',33.333,3),(664,7511912,7511898,'ate',33.333,3),(664,7511913,7511910,'ena',20,2),(664,7511914,7511910,'nab',20,2),(664,7511915,7511910,'abl',20,2),(664,7511916,7511910,'ble',20,2),(664,7511917,7511910,'led',20,2),(664,7511918,7511913,'cac',33.333,2),(664,7511919,7511913,'ach',33.333,2),(664,7511920,7511913,'che',33.333,2),(664,7511921,7511918,'mod',50,1),(664,7511922,7511918,'ode',50,1),(664,7511923,7511921,'wri',14.286,1),(664,7511924,7511921,'rit',14.286,1),(664,7511925,7511921,'ite',14.286,1),(664,7511926,7511921,'tet',14.286,1),(664,7511927,7511921,'eth',14.286,1),(664,7511928,7511921,'thr',14.286,1),(664,7511929,7511921,'hru',14.286,1),(664,7511930,7511923,'ope',11.111,2),(664,7511931,7511923,'per',11.111,2),(664,7511932,7511923,'era',11.111,2),(664,7511933,7511923,'rat',11.111,2),(664,7511934,7511923,'ati',11.111,2),(664,7511935,7511923,'tio',11.111,2),(664,7511936,7511923,'ion',11.111,2),(664,7511937,7511923,'ona',11.111,2),(664,7511938,7511923,'nal',11.111,2),(664,7511939,7511930,'pen',20,1),(664,7511940,7511930,'end',20,1),(664,7511941,7511930,'ndi',20,1),(664,7511942,7511930,'din',20,1),(664,7511943,7511930,'ing',20,1),(664,7511944,7511939,'mes',20,1),(664,7511945,7511939,'ess',20,1),(664,7511946,7511939,'ssa',20,1),(664,7511947,7511939,'sag',20,1),(664,7511948,7511939,'age',20,1),(664,7511949,7511944,'wai',20,1),(664,7511950,7511944,'ait',20,1),(664,7511951,7511944,'iti',20,1),(664,7511952,7511944,'tin',20,1),(664,7511953,7511944,'ing',20,1),(664,7511954,7511949,'for',100,1),(664,7511955,7511954,'per',11.111,1),(664,7511956,7511954,'erf',11.111,1),(664,7511957,7511954,'rfo',11.111,1),(664,7511958,7511954,'for',11.111,1),(664,7511959,7511954,'orm',11.111,1),(664,7511960,7511954,'rma',11.111,1),(664,7511961,7511954,'man',11.111,1),(664,7511962,7511954,'anc',11.111,1),(664,7511963,7511954,'nce',11.111,1),(664,7511964,7511955,'ide',12.5,1),(664,7511965,7511955,'den',12.5,1),(664,7511966,7511955,'ent',12.5,1),(664,7511967,7511955,'nti',12.5,1),(664,7511968,7511955,'tif',12.5,1),(664,7511969,7511955,'ifi',12.5,1),(664,7511970,7511955,'fie',12.5,1),(664,7511971,7511955,'ier',12.5,1),(664,7511972,7511964,'vdi',33.333,3),(664,7511973,7511964,'dis',33.333,3),(664,7511974,7511964,'isk',33.333,3),(664,7511975,7511972,'nam',50,1),(664,7511976,7511972,'ame',50,1),(664,7511977,7511975,'typ',50,1),(664,7511978,7511975,'ype',50,1),(664,7511979,7511977,'dir',25,1),(664,7511980,7511977,'ire',25,1),(664,7511981,7511977,'rec',25,1),(664,7511982,7511977,'ect',25,1),(665,7511984,7511983,'naa',100,2),(665,7511985,7511984,'600',3.333,3),(665,7511986,7511984,'000',3.333,3),(665,7511987,7511984,'00c',3.333,3),(665,7511988,7511984,'0c2',3.333,3),(665,7511989,7511984,'c29',3.333,3),(665,7511990,7511984,'29f',3.333,3),(665,7511991,7511984,'9f7',3.333,3),(665,7511992,7511984,'f73',3.333,3),(665,7511993,7511984,'737',3.333,3),(665,7511994,7511984,'37d',3.333,3),(665,7511995,7511984,'7dc',3.333,3),(665,7511996,7511984,'dc0',3.333,3),(665,7511997,7511984,'c0c',3.333,3),(665,7511998,7511984,'0cb',3.333,3),(665,7511999,7511984,'cb6',3.333,3),(665,7512000,7511984,'b6f',3.333,3),(665,7512001,7511984,'6f6',3.333,3),(665,7512002,7511984,'f64',3.333,3),(665,7512003,7511984,'64b',3.333,3),(665,7512004,7511984,'4bd',3.333,3),(665,7512005,7511984,'bda',3.333,3),(665,7512006,7511984,'dad',3.333,3),(665,7512007,7511984,'ad7',3.333,3),(665,7512008,7511984,'d73',3.333,3),(665,7512009,7511984,'73e',3.333,3),(665,7512010,7511984,'3e4',3.333,3),(665,7512011,7511984,'e43',3.333,3),(665,7512012,7511984,'438',3.333,3),(665,7512013,7511984,'385',3.333,3),(665,7512014,7511984,'855',3.333,3),(665,7512015,7511985,'mon',100,1),(665,7512016,7512015,'201',50,1),(665,7512017,7512015,'013',50,1),(665,7512018,7512016,'adm',33.333,3),(665,7512019,7512016,'dmi',33.333,3),(665,7512020,7512016,'min',33.333,3),(665,7512021,7512018,'cap',16.667,1),(665,7512022,7512018,'apa',16.667,1),(665,7512023,7512018,'pac',16.667,1),(665,7512024,7512018,'aci',16.667,1),(665,7512025,7512018,'cit',16.667,1),(665,7512026,7512018,'ity',16.667,1),(665,7512027,7512021,'pat',50,1),(665,7512028,7512021,'ath',50,1),(665,7512029,7512027,'fre',14.286,1),(665,7512030,7512027,'ree',14.286,1),(665,7512031,7512027,'ees',14.286,1),(665,7512032,7512027,'esp',14.286,1),(665,7512033,7512027,'spa',14.286,1),(665,7512034,7512027,'pac',14.286,1),(665,7512035,7512027,'ace',14.286,1),(665,7512036,7512029,'dis',50,1),(665,7512037,7512029,'isk',50,1),(665,7512038,7512036,'ind',33.333,1),(665,7512039,7512036,'nde',33.333,1),(665,7512040,7512036,'dex',33.333,1),(665,7512041,7512038,'adm',8.333,1),(665,7512042,7512038,'dmi',8.333,1),(665,7512043,7512038,'min',8.333,1),(665,7512044,7512038,'ini',8.333,1),(665,7512045,7512038,'nis',8.333,1),(665,7512046,7512038,'ist',8.333,1),(665,7512047,7512038,'str',8.333,1),(665,7512048,7512038,'tra',8.333,1),(665,7512049,7512038,'rat',8.333,1),(665,7512050,7512038,'ati',8.333,1),(665,7512051,7512038,'tio',8.333,1),(665,7512052,7512038,'ion',8.333,1),(665,7512053,7512041,'sta',33.333,3),(665,7512054,7512041,'tat',33.333,3),(665,7512055,7512041,'ate',33.333,3),(665,7512056,7512053,'ena',20,2),(665,7512057,7512053,'nab',20,2),(665,7512058,7512053,'abl',20,2),(665,7512059,7512053,'ble',20,2),(665,7512060,7512053,'led',20,2),(665,7512061,7512056,'cac',33.333,2),(665,7512062,7512056,'ach',33.333,2),(665,7512063,7512056,'che',33.333,2),(665,7512064,7512061,'mod',50,1),(665,7512065,7512061,'ode',50,1),(665,7512066,7512064,'wri',14.286,1),(665,7512067,7512064,'rit',14.286,1),(665,7512068,7512064,'ite',14.286,1),(665,7512069,7512064,'tet',14.286,1),(665,7512070,7512064,'eth',14.286,1),(665,7512071,7512064,'thr',14.286,1),(665,7512072,7512064,'hru',14.286,1),(665,7512073,7512066,'ope',11.111,2),(665,7512074,7512066,'per',11.111,2),(665,7512075,7512066,'era',11.111,2),(665,7512076,7512066,'rat',11.111,2),(665,7512077,7512066,'ati',11.111,2),(665,7512078,7512066,'tio',11.111,2),(665,7512079,7512066,'ion',11.111,2),(665,7512080,7512066,'ona',11.111,2),(665,7512081,7512066,'nal',11.111,2),(665,7512082,7512073,'pen',20,1),(665,7512083,7512073,'end',20,1),(665,7512084,7512073,'ndi',20,1),(665,7512085,7512073,'din',20,1),(665,7512086,7512073,'ing',20,1),(665,7512087,7512082,'mes',20,1),(665,7512088,7512082,'ess',20,1),(665,7512089,7512082,'ssa',20,1),(665,7512090,7512082,'sag',20,1),(665,7512091,7512082,'age',20,1),(665,7512092,7512087,'wai',20,1),(665,7512093,7512087,'ait',20,1),(665,7512094,7512087,'iti',20,1),(665,7512095,7512087,'tin',20,1),(665,7512096,7512087,'ing',20,1),(665,7512097,7512092,'for',100,1),(665,7512098,7512097,'per',11.111,1),(665,7512099,7512097,'erf',11.111,1),(665,7512100,7512097,'rfo',11.111,1),(665,7512101,7512097,'for',11.111,1),(665,7512102,7512097,'orm',11.111,1),(665,7512103,7512097,'rma',11.111,1),(665,7512104,7512097,'man',11.111,1),(665,7512105,7512097,'anc',11.111,1),(665,7512106,7512097,'nce',11.111,1),(665,7512107,7512098,'ide',12.5,1),(665,7512108,7512098,'den',12.5,1),(665,7512109,7512098,'ent',12.5,1),(665,7512110,7512098,'nti',12.5,1),(665,7512111,7512098,'tif',12.5,1),(665,7512112,7512098,'ifi',12.5,1),(665,7512113,7512098,'fie',12.5,1),(665,7512114,7512098,'ier',12.5,1),(665,7512115,7512107,'vdi',33.333,3),(665,7512116,7512107,'dis',33.333,3),(665,7512117,7512107,'isk',33.333,3),(665,7512118,7512115,'nam',50,1),(665,7512119,7512115,'ame',50,1),(665,7512120,7512118,'typ',50,1),(665,7512121,7512118,'ype',50,1),(665,7512122,7512120,'dir',25,1),(665,7512123,7512120,'ire',25,1),(665,7512124,7512120,'rec',25,1),(665,7512125,7512120,'ect',25,1),(666,7512127,7512126,'naa',100,2),(666,7512128,7512127,'600',3.333,3),(666,7512129,7512127,'000',3.333,3),(666,7512130,7512127,'00c',3.333,3),(666,7512131,7512127,'0c2',3.333,3),(666,7512132,7512127,'c29',3.333,3),(666,7512133,7512127,'294',3.333,3),(666,7512134,7512127,'945',3.333,3),(666,7512135,7512127,'45d',3.333,3),(666,7512136,7512127,'5d8',3.333,3),(666,7512137,7512127,'d81',3.333,3),(666,7512138,7512127,'81c',3.333,3),(666,7512139,7512127,'1cc',3.333,3),(666,7512140,7512127,'cc1',3.333,3),(666,7512141,7512127,'c14',3.333,3),(666,7512142,7512127,'140',3.333,3),(666,7512143,7512127,'40b',3.333,3),(666,7512144,7512127,'0b9',3.333,3),(666,7512145,7512127,'b98',3.333,3),(666,7512146,7512127,'98e',3.333,3),(666,7512147,7512127,'8ed',3.333,3),(666,7512148,7512127,'ed4',3.333,3),(666,7512149,7512127,'d46',3.333,3),(666,7512150,7512127,'463',3.333,3),(666,7512151,7512127,'633',3.333,3),(666,7512152,7512127,'330',3.333,3),(666,7512153,7512127,'309',3.333,3),(666,7512154,7512127,'099',3.333,3),(666,7512155,7512127,'99d',3.333,3),(666,7512156,7512127,'9d8',3.333,3),(666,7512157,7512127,'d86',3.333,3),(666,7512158,7512128,'mon',100,1),(666,7512159,7512158,'201',50,1),(666,7512160,7512158,'013',50,1),(666,7512161,7512159,'adm',33.333,3),(666,7512162,7512159,'dmi',33.333,3),(666,7512163,7512159,'min',33.333,3),(666,7512164,7512161,'cap',16.667,1),(666,7512165,7512161,'apa',16.667,1),(666,7512166,7512161,'pac',16.667,1),(666,7512167,7512161,'aci',16.667,1),(666,7512168,7512161,'cit',16.667,1),(666,7512169,7512161,'ity',16.667,1),(666,7512170,7512164,'pat',50,1),(666,7512171,7512164,'ath',50,1),(666,7512172,7512170,'fre',14.286,1),(666,7512173,7512170,'ree',14.286,1),(666,7512174,7512170,'ees',14.286,1),(666,7512175,7512170,'esp',14.286,1),(666,7512176,7512170,'spa',14.286,1),(666,7512177,7512170,'pac',14.286,1),(666,7512178,7512170,'ace',14.286,1),(666,7512179,7512172,'dis',50,1),(666,7512180,7512172,'isk',50,1),(666,7512181,7512179,'ind',33.333,1),(666,7512182,7512179,'nde',33.333,1),(666,7512183,7512179,'dex',33.333,1),(666,7512184,7512181,'adm',8.333,1),(666,7512185,7512181,'dmi',8.333,1),(666,7512186,7512181,'min',8.333,1),(666,7512187,7512181,'ini',8.333,1),(666,7512188,7512181,'nis',8.333,1),(666,7512189,7512181,'ist',8.333,1),(666,7512190,7512181,'str',8.333,1),(666,7512191,7512181,'tra',8.333,1),(666,7512192,7512181,'rat',8.333,1),(666,7512193,7512181,'ati',8.333,1),(666,7512194,7512181,'tio',8.333,1),(666,7512195,7512181,'ion',8.333,1),(666,7512196,7512184,'sta',33.333,3),(666,7512197,7512184,'tat',33.333,3),(666,7512198,7512184,'ate',33.333,3),(666,7512199,7512196,'ena',20,2),(666,7512200,7512196,'nab',20,2),(666,7512201,7512196,'abl',20,2),(666,7512202,7512196,'ble',20,2),(666,7512203,7512196,'led',20,2),(666,7512204,7512199,'cac',33.333,2),(666,7512205,7512199,'ach',33.333,2),(666,7512206,7512199,'che',33.333,2),(666,7512207,7512204,'mod',50,1),(666,7512208,7512204,'ode',50,1),(666,7512209,7512207,'wri',14.286,1),(666,7512210,7512207,'rit',14.286,1),(666,7512211,7512207,'ite',14.286,1),(666,7512212,7512207,'tet',14.286,1),(666,7512213,7512207,'eth',14.286,1),(666,7512214,7512207,'thr',14.286,1),(666,7512215,7512207,'hru',14.286,1),(666,7512216,7512209,'ope',11.111,2),(666,7512217,7512209,'per',11.111,2),(666,7512218,7512209,'era',11.111,2),(666,7512219,7512209,'rat',11.111,2),(666,7512220,7512209,'ati',11.111,2),(666,7512221,7512209,'tio',11.111,2),(666,7512222,7512209,'ion',11.111,2),(666,7512223,7512209,'ona',11.111,2),(666,7512224,7512209,'nal',11.111,2),(666,7512225,7512216,'pen',20,1),(666,7512226,7512216,'end',20,1),(666,7512227,7512216,'ndi',20,1),(666,7512228,7512216,'din',20,1),(666,7512229,7512216,'ing',20,1),(666,7512230,7512225,'mes',20,1),(666,7512231,7512225,'ess',20,1),(666,7512232,7512225,'ssa',20,1),(666,7512233,7512225,'sag',20,1),(666,7512234,7512225,'age',20,1),(666,7512235,7512230,'wai',20,1),(666,7512236,7512230,'ait',20,1),(666,7512237,7512230,'iti',20,1),(666,7512238,7512230,'tin',20,1),(666,7512239,7512230,'ing',20,1),(666,7512240,7512235,'for',100,1),(666,7512241,7512240,'per',11.111,1),(666,7512242,7512240,'erf',11.111,1),(666,7512243,7512240,'rfo',11.111,1),(666,7512244,7512240,'for',11.111,1),(666,7512245,7512240,'orm',11.111,1),(666,7512246,7512240,'rma',11.111,1),(666,7512247,7512240,'man',11.111,1),(666,7512248,7512240,'anc',11.111,1),(666,7512249,7512240,'nce',11.111,1),(666,7512250,7512241,'ide',12.5,1),(666,7512251,7512241,'den',12.5,1),(666,7512252,7512241,'ent',12.5,1),(666,7512253,7512241,'nti',12.5,1),(666,7512254,7512241,'tif',12.5,1),(666,7512255,7512241,'ifi',12.5,1),(666,7512256,7512241,'fie',12.5,1),(666,7512257,7512241,'ier',12.5,1),(666,7512258,7512250,'vdi',33.333,3),(666,7512259,7512250,'dis',33.333,3),(666,7512260,7512250,'isk',33.333,3),(666,7512261,7512258,'nam',50,1),(666,7512262,7512258,'ame',50,1),(666,7512263,7512261,'typ',50,1),(666,7512264,7512261,'ype',50,1),(666,7512265,7512263,'dir',25,1),(666,7512266,7512263,'ire',25,1),(666,7512267,7512263,'rec',25,1),(666,7512268,7512263,'ect',25,1),(667,7512270,7512269,'naa',100,2),(667,7512271,7512270,'600',3.333,3),(667,7512272,7512270,'000',3.333,3),(667,7512273,7512270,'00c',3.333,3),(667,7512274,7512270,'0c2',3.333,3),(667,7512275,7512270,'c29',3.333,3),(667,7512276,7512270,'298',3.333,3),(667,7512277,7512270,'986',3.333,3),(667,7512278,7512270,'861',3.333,3),(667,7512279,7512270,'617',3.333,3),(667,7512280,7512270,'176',3.333,3),(667,7512281,7512270,'767',3.333,3),(667,7512282,7512270,'67e',3.333,3),(667,7512283,7512270,'7e1',3.333,3),(667,7512284,7512270,'e19',3.333,3),(667,7512285,7512270,'19c',3.333,3),(667,7512286,7512270,'9cc',3.333,3),(667,7512287,7512270,'ccb',3.333,3),(667,7512288,7512270,'cb7',3.333,3),(667,7512289,7512270,'b73',3.333,3),(667,7512290,7512270,'73e',3.333,3),(667,7512291,7512270,'3ef',3.333,3),(667,7512292,7512270,'eff',3.333,3),(667,7512293,7512270,'ff1',3.333,3),(667,7512294,7512270,'f1d',3.333,3),(667,7512295,7512270,'1db',3.333,3),(667,7512296,7512270,'db2',3.333,3),(667,7512297,7512270,'b2b',3.333,3),(667,7512298,7512270,'2b6',3.333,3),(667,7512299,7512270,'b6d',3.333,3),(667,7512300,7512270,'6d7',3.333,3),(667,7512301,7512271,'mon',100,1),(667,7512302,7512301,'201',50,1),(667,7512303,7512301,'013',50,1),(667,7512304,7512302,'adm',33.333,3),(667,7512305,7512302,'dmi',33.333,3),(667,7512306,7512302,'min',33.333,3),(667,7512307,7512304,'cap',16.667,1),(667,7512308,7512304,'apa',16.667,1),(667,7512309,7512304,'pac',16.667,1),(667,7512310,7512304,'aci',16.667,1),(667,7512311,7512304,'cit',16.667,1),(667,7512312,7512304,'ity',16.667,1),(667,7512313,7512307,'pat',50,1),(667,7512314,7512307,'ath',50,1),(667,7512315,7512313,'fre',14.286,1),(667,7512316,7512313,'ree',14.286,1),(667,7512317,7512313,'ees',14.286,1),(667,7512318,7512313,'esp',14.286,1),(667,7512319,7512313,'spa',14.286,1),(667,7512320,7512313,'pac',14.286,1),(667,7512321,7512313,'ace',14.286,1),(667,7512322,7512315,'dis',50,1),(667,7512323,7512315,'isk',50,1),(667,7512324,7512322,'ind',33.333,1),(667,7512325,7512322,'nde',33.333,1),(667,7512326,7512322,'dex',33.333,1),(667,7512327,7512324,'adm',8.333,1),(667,7512328,7512324,'dmi',8.333,1),(667,7512329,7512324,'min',8.333,1),(667,7512330,7512324,'ini',8.333,1),(667,7512331,7512324,'nis',8.333,1),(667,7512332,7512324,'ist',8.333,1),(667,7512333,7512324,'str',8.333,1),(667,7512334,7512324,'tra',8.333,1),(667,7512335,7512324,'rat',8.333,1),(667,7512336,7512324,'ati',8.333,1),(667,7512337,7512324,'tio',8.333,1),(667,7512338,7512324,'ion',8.333,1),(667,7512339,7512327,'sta',33.333,3),(667,7512340,7512327,'tat',33.333,3),(667,7512341,7512327,'ate',33.333,3),(667,7512342,7512339,'ena',20,2),(667,7512343,7512339,'nab',20,2),(667,7512344,7512339,'abl',20,2),(667,7512345,7512339,'ble',20,2),(667,7512346,7512339,'led',20,2),(667,7512347,7512342,'cac',33.333,2),(667,7512348,7512342,'ach',33.333,2),(667,7512349,7512342,'che',33.333,2),(667,7512350,7512347,'mod',50,1),(667,7512351,7512347,'ode',50,1),(667,7512352,7512350,'wri',14.286,1),(667,7512353,7512350,'rit',14.286,1),(667,7512354,7512350,'ite',14.286,1),(667,7512355,7512350,'tet',14.286,1),(667,7512356,7512350,'eth',14.286,1),(667,7512357,7512350,'thr',14.286,1),(667,7512358,7512350,'hru',14.286,1),(667,7512359,7512352,'ope',11.111,2),(667,7512360,7512352,'per',11.111,2),(667,7512361,7512352,'era',11.111,2),(667,7512362,7512352,'rat',11.111,2),(667,7512363,7512352,'ati',11.111,2),(667,7512364,7512352,'tio',11.111,2),(667,7512365,7512352,'ion',11.111,2),(667,7512366,7512352,'ona',11.111,2),(667,7512367,7512352,'nal',11.111,2),(667,7512368,7512359,'pen',20,1),(667,7512369,7512359,'end',20,1),(667,7512370,7512359,'ndi',20,1),(667,7512371,7512359,'din',20,1),(667,7512372,7512359,'ing',20,1),(667,7512373,7512368,'mes',20,1),(667,7512374,7512368,'ess',20,1),(667,7512375,7512368,'ssa',20,1),(667,7512376,7512368,'sag',20,1),(667,7512377,7512368,'age',20,1),(667,7512378,7512373,'wai',20,1),(667,7512379,7512373,'ait',20,1),(667,7512380,7512373,'iti',20,1),(667,7512381,7512373,'tin',20,1),(667,7512382,7512373,'ing',20,1),(667,7512383,7512378,'for',100,1),(667,7512384,7512383,'per',11.111,1),(667,7512385,7512383,'erf',11.111,1),(667,7512386,7512383,'rfo',11.111,1),(667,7512387,7512383,'for',11.111,1),(667,7512388,7512383,'orm',11.111,1),(667,7512389,7512383,'rma',11.111,1),(667,7512390,7512383,'man',11.111,1),(667,7512391,7512383,'anc',11.111,1),(667,7512392,7512383,'nce',11.111,1),(667,7512393,7512384,'ide',12.5,1),(667,7512394,7512384,'den',12.5,1),(667,7512395,7512384,'ent',12.5,1),(667,7512396,7512384,'nti',12.5,1),(667,7512397,7512384,'tif',12.5,1),(667,7512398,7512384,'ifi',12.5,1),(667,7512399,7512384,'fie',12.5,1),(667,7512400,7512384,'ier',12.5,1),(667,7512401,7512393,'vdi',33.333,3),(667,7512402,7512393,'dis',33.333,3),(667,7512403,7512393,'isk',33.333,3),(667,7512404,7512401,'nam',50,1),(667,7512405,7512401,'ame',50,1),(667,7512406,7512404,'typ',50,1),(667,7512407,7512404,'ype',50,1),(667,7512408,7512406,'dir',25,1),(667,7512409,7512406,'ire',25,1),(667,7512410,7512406,'rec',25,1),(667,7512411,7512406,'ect',25,1),(668,7512413,7512412,'naa',100,2),(668,7512414,7512413,'600',3.333,3),(668,7512415,7512413,'000',3.333,3),(668,7512416,7512413,'00c',3.333,3),(668,7512417,7512413,'0c2',3.333,3),(668,7512418,7512413,'c29',3.333,3),(668,7512419,7512413,'292',3.333,3),(668,7512420,7512413,'929',3.333,3),(668,7512421,7512413,'298',3.333,3),(668,7512422,7512413,'98e',3.333,3),(668,7512423,7512413,'8e3',3.333,3),(668,7512424,7512413,'e39',3.333,3),(668,7512425,7512413,'394',3.333,3),(668,7512426,7512413,'941',3.333,3),(668,7512427,7512413,'41b',3.333,3),(668,7512428,7512413,'1ba',3.333,3),(668,7512429,7512413,'bae',3.333,3),(668,7512430,7512413,'ae5',3.333,3),(668,7512431,7512413,'e5b',3.333,3),(668,7512432,7512413,'5b9',3.333,3),(668,7512433,7512413,'b93',3.333,3),(668,7512434,7512413,'939',3.333,3),(668,7512435,7512413,'398',3.333,3),(668,7512436,7512413,'985',3.333,3),(668,7512437,7512413,'85f',3.333,3),(668,7512438,7512413,'5f4',3.333,3),(668,7512439,7512413,'f4a',3.333,3),(668,7512440,7512413,'4a0',3.333,3),(668,7512441,7512413,'a05',3.333,3),(668,7512442,7512413,'057',3.333,3),(668,7512443,7512413,'577',3.333,3),(668,7512444,7512414,'mon',100,1),(668,7512445,7512444,'201',50,1),(668,7512446,7512444,'013',50,1),(668,7512447,7512445,'adm',33.333,3),(668,7512448,7512445,'dmi',33.333,3),(668,7512449,7512445,'min',33.333,3),(668,7512450,7512447,'cap',16.667,1),(668,7512451,7512447,'apa',16.667,1),(668,7512452,7512447,'pac',16.667,1),(668,7512453,7512447,'aci',16.667,1),(668,7512454,7512447,'cit',16.667,1),(668,7512455,7512447,'ity',16.667,1),(668,7512456,7512450,'pat',50,1),(668,7512457,7512450,'ath',50,1),(668,7512458,7512456,'fre',14.286,1),(668,7512459,7512456,'ree',14.286,1),(668,7512460,7512456,'ees',14.286,1),(668,7512461,7512456,'esp',14.286,1),(668,7512462,7512456,'spa',14.286,1),(668,7512463,7512456,'pac',14.286,1),(668,7512464,7512456,'ace',14.286,1),(668,7512465,7512458,'dis',50,1),(668,7512466,7512458,'isk',50,1),(668,7512467,7512465,'ind',33.333,1),(668,7512468,7512465,'nde',33.333,1),(668,7512469,7512465,'dex',33.333,1),(668,7512470,7512467,'adm',8.333,1),(668,7512471,7512467,'dmi',8.333,1),(668,7512472,7512467,'min',8.333,1),(668,7512473,7512467,'ini',8.333,1),(668,7512474,7512467,'nis',8.333,1),(668,7512475,7512467,'ist',8.333,1),(668,7512476,7512467,'str',8.333,1),(668,7512477,7512467,'tra',8.333,1),(668,7512478,7512467,'rat',8.333,1),(668,7512479,7512467,'ati',8.333,1),(668,7512480,7512467,'tio',8.333,1),(668,7512481,7512467,'ion',8.333,1),(668,7512482,7512470,'sta',33.333,3),(668,7512483,7512470,'tat',33.333,3),(668,7512484,7512470,'ate',33.333,3),(668,7512485,7512482,'ena',20,2),(668,7512486,7512482,'nab',20,2),(668,7512487,7512482,'abl',20,2),(668,7512488,7512482,'ble',20,2),(668,7512489,7512482,'led',20,2),(668,7512490,7512485,'cac',33.333,2),(668,7512491,7512485,'ach',33.333,2),(668,7512492,7512485,'che',33.333,2),(668,7512493,7512490,'mod',50,1),(668,7512494,7512490,'ode',50,1),(668,7512495,7512493,'wri',14.286,1),(668,7512496,7512493,'rit',14.286,1),(668,7512497,7512493,'ite',14.286,1),(668,7512498,7512493,'tet',14.286,1),(668,7512499,7512493,'eth',14.286,1),(668,7512500,7512493,'thr',14.286,1),(668,7512501,7512493,'hru',14.286,1),(668,7512502,7512495,'ope',11.111,2),(668,7512503,7512495,'per',11.111,2),(668,7512504,7512495,'era',11.111,2),(668,7512505,7512495,'rat',11.111,2),(668,7512506,7512495,'ati',11.111,2),(668,7512507,7512495,'tio',11.111,2),(668,7512508,7512495,'ion',11.111,2),(668,7512509,7512495,'ona',11.111,2),(668,7512510,7512495,'nal',11.111,2),(668,7512511,7512502,'pen',20,1),(668,7512512,7512502,'end',20,1),(668,7512513,7512502,'ndi',20,1),(668,7512514,7512502,'din',20,1),(668,7512515,7512502,'ing',20,1),(668,7512516,7512511,'mes',20,1),(668,7512517,7512511,'ess',20,1),(668,7512518,7512511,'ssa',20,1),(668,7512519,7512511,'sag',20,1),(668,7512520,7512511,'age',20,1),(668,7512521,7512516,'wai',20,1),(668,7512522,7512516,'ait',20,1),(668,7512523,7512516,'iti',20,1),(668,7512524,7512516,'tin',20,1),(668,7512525,7512516,'ing',20,1),(668,7512526,7512521,'for',100,1),(668,7512527,7512526,'per',11.111,1),(668,7512528,7512526,'erf',11.111,1),(668,7512529,7512526,'rfo',11.111,1),(668,7512530,7512526,'for',11.111,1),(668,7512531,7512526,'orm',11.111,1),(668,7512532,7512526,'rma',11.111,1),(668,7512533,7512526,'man',11.111,1),(668,7512534,7512526,'anc',11.111,1),(668,7512535,7512526,'nce',11.111,1),(668,7512536,7512527,'ide',12.5,1),(668,7512537,7512527,'den',12.5,1),(668,7512538,7512527,'ent',12.5,1),(668,7512539,7512527,'nti',12.5,1),(668,7512540,7512527,'tif',12.5,1),(668,7512541,7512527,'ifi',12.5,1),(668,7512542,7512527,'fie',12.5,1),(668,7512543,7512527,'ier',12.5,1),(668,7512544,7512536,'vdi',33.333,3),(668,7512545,7512536,'dis',33.333,3),(668,7512546,7512536,'isk',33.333,3),(668,7512547,7512544,'nam',50,1),(668,7512548,7512544,'ame',50,1),(668,7512549,7512547,'typ',50,1),(668,7512550,7512547,'ype',50,1),(668,7512551,7512549,'dir',25,1),(668,7512552,7512549,'ire',25,1),(668,7512553,7512549,'rec',25,1),(668,7512554,7512549,'ect',25,1),(669,7512556,7512555,'naa',100,2),(669,7512557,7512556,'600',3.333,3),(669,7512558,7512556,'000',3.333,3),(669,7512559,7512556,'00c',3.333,3),(669,7512560,7512556,'0c2',3.333,3),(669,7512561,7512556,'c29',3.333,3),(669,7512562,7512556,'297',3.333,3),(669,7512563,7512556,'975',3.333,3),(669,7512564,7512556,'75b',3.333,3),(669,7512565,7512556,'5bb',3.333,3),(669,7512566,7512556,'bba',3.333,3),(669,7512567,7512556,'bae',3.333,3),(669,7512568,7512556,'ae0',3.333,3),(669,7512569,7512556,'e0e',3.333,3),(669,7512570,7512556,'0ee',3.333,3),(669,7512571,7512556,'ee3',3.333,3),(669,7512572,7512556,'e3e',3.333,3),(669,7512573,7512556,'3ec',3.333,3),(669,7512574,7512556,'ece',3.333,3),(669,7512575,7512556,'ce6',3.333,3),(669,7512576,7512556,'e62',3.333,3),(669,7512577,7512556,'62b',3.333,3),(669,7512578,7512556,'2b0',3.333,3),(669,7512579,7512556,'b06',3.333,3),(669,7512580,7512556,'06a',3.333,3),(669,7512581,7512556,'6a5',3.333,3),(669,7512582,7512556,'a57',3.333,3),(669,7512583,7512556,'573',3.333,3),(669,7512584,7512556,'731',3.333,3),(669,7512585,7512556,'316',3.333,3),(669,7512586,7512556,'168',3.333,3),(669,7512587,7512557,'mon',100,1),(669,7512588,7512587,'201',50,1),(669,7512589,7512587,'013',50,1),(669,7512590,7512588,'adm',33.333,3),(669,7512591,7512588,'dmi',33.333,3),(669,7512592,7512588,'min',33.333,3),(669,7512593,7512590,'cap',16.667,1),(669,7512594,7512590,'apa',16.667,1),(669,7512595,7512590,'pac',16.667,1),(669,7512596,7512590,'aci',16.667,1),(669,7512597,7512590,'cit',16.667,1),(669,7512598,7512590,'ity',16.667,1),(669,7512599,7512593,'pat',50,1),(669,7512600,7512593,'ath',50,1),(669,7512601,7512599,'fre',14.286,1),(669,7512602,7512599,'ree',14.286,1),(669,7512603,7512599,'ees',14.286,1),(669,7512604,7512599,'esp',14.286,1),(669,7512605,7512599,'spa',14.286,1),(669,7512606,7512599,'pac',14.286,1),(669,7512607,7512599,'ace',14.286,1),(669,7512608,7512601,'dis',50,1),(669,7512609,7512601,'isk',50,1),(669,7512610,7512608,'ind',33.333,1),(669,7512611,7512608,'nde',33.333,1),(669,7512612,7512608,'dex',33.333,1),(669,7512613,7512610,'adm',8.333,1),(669,7512614,7512610,'dmi',8.333,1),(669,7512615,7512610,'min',8.333,1),(669,7512616,7512610,'ini',8.333,1),(669,7512617,7512610,'nis',8.333,1),(669,7512618,7512610,'ist',8.333,1),(669,7512619,7512610,'str',8.333,1),(669,7512620,7512610,'tra',8.333,1),(669,7512621,7512610,'rat',8.333,1),(669,7512622,7512610,'ati',8.333,1),(669,7512623,7512610,'tio',8.333,1),(669,7512624,7512610,'ion',8.333,1),(669,7512625,7512613,'sta',33.333,3),(669,7512626,7512613,'tat',33.333,3),(669,7512627,7512613,'ate',33.333,3),(669,7512628,7512625,'ena',20,2),(669,7512629,7512625,'nab',20,2),(669,7512630,7512625,'abl',20,2),(669,7512631,7512625,'ble',20,2),(669,7512632,7512625,'led',20,2),(669,7512633,7512628,'cac',33.333,2),(669,7512634,7512628,'ach',33.333,2),(669,7512635,7512628,'che',33.333,2),(669,7512636,7512633,'mod',50,1),(669,7512637,7512633,'ode',50,1),(669,7512638,7512636,'wri',14.286,1),(669,7512639,7512636,'rit',14.286,1),(669,7512640,7512636,'ite',14.286,1),(669,7512641,7512636,'tet',14.286,1),(669,7512642,7512636,'eth',14.286,1),(669,7512643,7512636,'thr',14.286,1),(669,7512644,7512636,'hru',14.286,1),(669,7512645,7512638,'ope',11.111,2),(669,7512646,7512638,'per',11.111,2),(669,7512647,7512638,'era',11.111,2),(669,7512648,7512638,'rat',11.111,2),(669,7512649,7512638,'ati',11.111,2),(669,7512650,7512638,'tio',11.111,2),(669,7512651,7512638,'ion',11.111,2),(669,7512652,7512638,'ona',11.111,2),(669,7512653,7512638,'nal',11.111,2),(669,7512654,7512645,'pen',20,1),(669,7512655,7512645,'end',20,1),(669,7512656,7512645,'ndi',20,1),(669,7512657,7512645,'din',20,1),(669,7512658,7512645,'ing',20,1),(669,7512659,7512654,'mes',20,1),(669,7512660,7512654,'ess',20,1),(669,7512661,7512654,'ssa',20,1),(669,7512662,7512654,'sag',20,1),(669,7512663,7512654,'age',20,1),(669,7512664,7512659,'wai',20,1),(669,7512665,7512659,'ait',20,1),(669,7512666,7512659,'iti',20,1),(669,7512667,7512659,'tin',20,1),(669,7512668,7512659,'ing',20,1),(669,7512669,7512664,'for',100,1),(669,7512670,7512669,'per',11.111,1),(669,7512671,7512669,'erf',11.111,1),(669,7512672,7512669,'rfo',11.111,1),(669,7512673,7512669,'for',11.111,1),(669,7512674,7512669,'orm',11.111,1),(669,7512675,7512669,'rma',11.111,1),(669,7512676,7512669,'man',11.111,1),(669,7512677,7512669,'anc',11.111,1),(669,7512678,7512669,'nce',11.111,1),(669,7512679,7512670,'ide',12.5,1),(669,7512680,7512670,'den',12.5,1),(669,7512681,7512670,'ent',12.5,1),(669,7512682,7512670,'nti',12.5,1),(669,7512683,7512670,'tif',12.5,1),(669,7512684,7512670,'ifi',12.5,1),(669,7512685,7512670,'fie',12.5,1),(669,7512686,7512670,'ier',12.5,1),(669,7512687,7512679,'vdi',33.333,3),(669,7512688,7512679,'dis',33.333,3),(669,7512689,7512679,'isk',33.333,3),(669,7512690,7512687,'nam',50,1),(669,7512691,7512687,'ame',50,1),(669,7512692,7512690,'typ',50,1),(669,7512693,7512690,'ype',50,1),(669,7512694,7512692,'dir',25,1),(669,7512695,7512692,'ire',25,1),(669,7512696,7512692,'rec',25,1),(669,7512697,7512692,'ect',25,1),(670,7512699,7512698,'naa',100,2),(670,7512700,7512699,'600',3.333,3),(670,7512701,7512699,'000',3.333,3),(670,7512702,7512699,'00c',3.333,3),(670,7512703,7512699,'0c2',3.333,3),(670,7512704,7512699,'c29',3.333,3),(670,7512705,7512699,'298',3.333,3),(670,7512706,7512699,'983',3.333,3),(670,7512707,7512699,'835',3.333,3),(670,7512708,7512699,'35a',3.333,3),(670,7512709,7512699,'5a9',3.333,3),(670,7512710,7512699,'a94',3.333,3),(670,7512711,7512699,'945',3.333,3),(670,7512712,7512699,'454',3.333,3),(670,7512713,7512699,'549',3.333,3),(670,7512714,7512699,'495',3.333,3),(670,7512715,7512699,'950',3.333,3),(670,7512716,7512699,'506',3.333,3),(670,7512717,7512699,'068',3.333,3),(670,7512718,7512699,'684',3.333,3),(670,7512719,7512699,'84e',3.333,3),(670,7512720,7512699,'4ea',3.333,3),(670,7512721,7512699,'ea4',3.333,3),(670,7512722,7512699,'a4d',3.333,3),(670,7512723,7512699,'4d3',3.333,3),(670,7512724,7512699,'d30',3.333,3),(670,7512725,7512699,'30b',3.333,3),(670,7512726,7512699,'0b0',3.333,3),(670,7512727,7512699,'b05',3.333,3),(670,7512728,7512699,'05d',3.333,3),(670,7512729,7512699,'5d7',3.333,3),(670,7512730,7512700,'mon',100,1),(670,7512731,7512730,'201',50,1),(670,7512732,7512730,'013',50,1),(670,7512733,7512731,'adm',33.333,3),(670,7512734,7512731,'dmi',33.333,3),(670,7512735,7512731,'min',33.333,3),(670,7512736,7512733,'cap',16.667,1),(670,7512737,7512733,'apa',16.667,1),(670,7512738,7512733,'pac',16.667,1),(670,7512739,7512733,'aci',16.667,1),(670,7512740,7512733,'cit',16.667,1),(670,7512741,7512733,'ity',16.667,1),(670,7512742,7512736,'pat',50,1),(670,7512743,7512736,'ath',50,1),(670,7512744,7512742,'fre',14.286,1),(670,7512745,7512742,'ree',14.286,1),(670,7512746,7512742,'ees',14.286,1),(670,7512747,7512742,'esp',14.286,1),(670,7512748,7512742,'spa',14.286,1),(670,7512749,7512742,'pac',14.286,1),(670,7512750,7512742,'ace',14.286,1),(670,7512751,7512744,'dis',50,1),(670,7512752,7512744,'isk',50,1),(670,7512753,7512751,'ind',33.333,1),(670,7512754,7512751,'nde',33.333,1),(670,7512755,7512751,'dex',33.333,1),(670,7512756,7512753,'adm',8.333,1),(670,7512757,7512753,'dmi',8.333,1),(670,7512758,7512753,'min',8.333,1),(670,7512759,7512753,'ini',8.333,1),(670,7512760,7512753,'nis',8.333,1),(670,7512761,7512753,'ist',8.333,1),(670,7512762,7512753,'str',8.333,1),(670,7512763,7512753,'tra',8.333,1),(670,7512764,7512753,'rat',8.333,1),(670,7512765,7512753,'ati',8.333,1),(670,7512766,7512753,'tio',8.333,1),(670,7512767,7512753,'ion',8.333,1),(670,7512768,7512756,'sta',33.333,3),(670,7512769,7512756,'tat',33.333,3),(670,7512770,7512756,'ate',33.333,3),(670,7512771,7512768,'ena',20,2),(670,7512772,7512768,'nab',20,2),(670,7512773,7512768,'abl',20,2),(670,7512774,7512768,'ble',20,2),(670,7512775,7512768,'led',20,2),(670,7512776,7512771,'cac',33.333,2),(670,7512777,7512771,'ach',33.333,2),(670,7512778,7512771,'che',33.333,2),(670,7512779,7512776,'mod',50,1),(670,7512780,7512776,'ode',50,1),(670,7512781,7512779,'wri',14.286,1),(670,7512782,7512779,'rit',14.286,1),(670,7512783,7512779,'ite',14.286,1),(670,7512784,7512779,'tet',14.286,1),(670,7512785,7512779,'eth',14.286,1),(670,7512786,7512779,'thr',14.286,1),(670,7512787,7512779,'hru',14.286,1),(670,7512788,7512781,'ope',11.111,2),(670,7512789,7512781,'per',11.111,2),(670,7512790,7512781,'era',11.111,2),(670,7512791,7512781,'rat',11.111,2),(670,7512792,7512781,'ati',11.111,2),(670,7512793,7512781,'tio',11.111,2),(670,7512794,7512781,'ion',11.111,2),(670,7512795,7512781,'ona',11.111,2),(670,7512796,7512781,'nal',11.111,2),(670,7512797,7512788,'pen',20,1),(670,7512798,7512788,'end',20,1),(670,7512799,7512788,'ndi',20,1),(670,7512800,7512788,'din',20,1),(670,7512801,7512788,'ing',20,1),(670,7512802,7512797,'mes',20,1),(670,7512803,7512797,'ess',20,1),(670,7512804,7512797,'ssa',20,1),(670,7512805,7512797,'sag',20,1),(670,7512806,7512797,'age',20,1),(670,7512807,7512802,'wai',20,1),(670,7512808,7512802,'ait',20,1),(670,7512809,7512802,'iti',20,1),(670,7512810,7512802,'tin',20,1),(670,7512811,7512802,'ing',20,1),(670,7512812,7512807,'for',100,1),(670,7512813,7512812,'per',11.111,1),(670,7512814,7512812,'erf',11.111,1),(670,7512815,7512812,'rfo',11.111,1),(670,7512816,7512812,'for',11.111,1),(670,7512817,7512812,'orm',11.111,1),(670,7512818,7512812,'rma',11.111,1),(670,7512819,7512812,'man',11.111,1),(670,7512820,7512812,'anc',11.111,1),(670,7512821,7512812,'nce',11.111,1),(670,7512822,7512813,'ide',12.5,1),(670,7512823,7512813,'den',12.5,1),(670,7512824,7512813,'ent',12.5,1),(670,7512825,7512813,'nti',12.5,1),(670,7512826,7512813,'tif',12.5,1),(670,7512827,7512813,'ifi',12.5,1),(670,7512828,7512813,'fie',12.5,1),(670,7512829,7512813,'ier',12.5,1),(670,7512830,7512822,'vdi',33.333,3),(670,7512831,7512822,'dis',33.333,3),(670,7512832,7512822,'isk',33.333,3),(670,7512833,7512830,'nam',50,1),(670,7512834,7512830,'ame',50,1),(670,7512835,7512833,'typ',50,1),(670,7512836,7512833,'ype',50,1),(670,7512837,7512835,'dir',25,1),(670,7512838,7512835,'ire',25,1),(670,7512839,7512835,'rec',25,1),(670,7512840,7512835,'ect',25,1),(671,7512842,7512841,'naa',100,2),(671,7512843,7512842,'600',3.333,3),(671,7512844,7512842,'000',3.333,3),(671,7512845,7512842,'00c',3.333,3),(671,7512846,7512842,'0c2',3.333,3),(671,7512847,7512842,'c29',3.333,3),(671,7512848,7512842,'293',3.333,3),(671,7512849,7512842,'939',3.333,3),(671,7512850,7512842,'393',3.333,3),(671,7512851,7512842,'932',3.333,3),(671,7512852,7512842,'32c',3.333,3),(671,7512853,7512842,'2ca',3.333,3),(671,7512854,7512842,'cae',3.333,3),(671,7512855,7512842,'aee',3.333,3),(671,7512856,7512842,'ee6',3.333,3),(671,7512857,7512842,'e64',3.333,3),(671,7512858,7512842,'64c',3.333,3),(671,7512859,7512842,'4c1',3.333,3),(671,7512860,7512842,'c16',3.333,3),(671,7512861,7512842,'16b',3.333,3),(671,7512862,7512842,'6bb',3.333,3),(671,7512863,7512842,'bb3',3.333,3),(671,7512864,7512842,'b3b',3.333,3),(671,7512865,7512842,'3be',3.333,3),(671,7512866,7512842,'bef',3.333,3),(671,7512867,7512842,'ef7',3.333,3),(671,7512868,7512842,'f77',3.333,3),(671,7512869,7512842,'770',3.333,3),(671,7512870,7512842,'70e',3.333,3),(671,7512871,7512842,'0e6',3.333,3),(671,7512872,7512842,'e68',3.333,3),(671,7512873,7512843,'mon',100,1),(671,7512874,7512873,'201',50,1),(671,7512875,7512873,'013',50,1),(671,7512876,7512874,'adm',33.333,3),(671,7512877,7512874,'dmi',33.333,3),(671,7512878,7512874,'min',33.333,3),(671,7512879,7512876,'cap',16.667,1),(671,7512880,7512876,'apa',16.667,1),(671,7512881,7512876,'pac',16.667,1),(671,7512882,7512876,'aci',16.667,1),(671,7512883,7512876,'cit',16.667,1),(671,7512884,7512876,'ity',16.667,1),(671,7512885,7512879,'pat',50,1),(671,7512886,7512879,'ath',50,1),(671,7512887,7512885,'fre',14.286,1),(671,7512888,7512885,'ree',14.286,1),(671,7512889,7512885,'ees',14.286,1),(671,7512890,7512885,'esp',14.286,1),(671,7512891,7512885,'spa',14.286,1),(671,7512892,7512885,'pac',14.286,1),(671,7512893,7512885,'ace',14.286,1),(671,7512894,7512887,'dis',50,1),(671,7512895,7512887,'isk',50,1),(671,7512896,7512894,'ind',33.333,1),(671,7512897,7512894,'nde',33.333,1),(671,7512898,7512894,'dex',33.333,1),(671,7512899,7512896,'adm',8.333,1),(671,7512900,7512896,'dmi',8.333,1),(671,7512901,7512896,'min',8.333,1),(671,7512902,7512896,'ini',8.333,1),(671,7512903,7512896,'nis',8.333,1),(671,7512904,7512896,'ist',8.333,1),(671,7512905,7512896,'str',8.333,1),(671,7512906,7512896,'tra',8.333,1),(671,7512907,7512896,'rat',8.333,1),(671,7512908,7512896,'ati',8.333,1),(671,7512909,7512896,'tio',8.333,1),(671,7512910,7512896,'ion',8.333,1),(671,7512911,7512899,'sta',33.333,3),(671,7512912,7512899,'tat',33.333,3),(671,7512913,7512899,'ate',33.333,3),(671,7512914,7512911,'ena',20,2),(671,7512915,7512911,'nab',20,2),(671,7512916,7512911,'abl',20,2),(671,7512917,7512911,'ble',20,2),(671,7512918,7512911,'led',20,2),(671,7512919,7512914,'cac',33.333,2),(671,7512920,7512914,'ach',33.333,2),(671,7512921,7512914,'che',33.333,2),(671,7512922,7512919,'mod',50,1),(671,7512923,7512919,'ode',50,1),(671,7512924,7512922,'wri',14.286,1),(671,7512925,7512922,'rit',14.286,1),(671,7512926,7512922,'ite',14.286,1),(671,7512927,7512922,'tet',14.286,1),(671,7512928,7512922,'eth',14.286,1),(671,7512929,7512922,'thr',14.286,1),(671,7512930,7512922,'hru',14.286,1),(671,7512931,7512924,'ope',11.111,2),(671,7512932,7512924,'per',11.111,2),(671,7512933,7512924,'era',11.111,2),(671,7512934,7512924,'rat',11.111,2),(671,7512935,7512924,'ati',11.111,2),(671,7512936,7512924,'tio',11.111,2),(671,7512937,7512924,'ion',11.111,2),(671,7512938,7512924,'ona',11.111,2),(671,7512939,7512924,'nal',11.111,2),(671,7512940,7512931,'pen',20,1),(671,7512941,7512931,'end',20,1),(671,7512942,7512931,'ndi',20,1),(671,7512943,7512931,'din',20,1),(671,7512944,7512931,'ing',20,1),(671,7512945,7512940,'mes',20,1),(671,7512946,7512940,'ess',20,1),(671,7512947,7512940,'ssa',20,1),(671,7512948,7512940,'sag',20,1),(671,7512949,7512940,'age',20,1),(671,7512950,7512945,'wai',20,1),(671,7512951,7512945,'ait',20,1),(671,7512952,7512945,'iti',20,1),(671,7512953,7512945,'tin',20,1),(671,7512954,7512945,'ing',20,1),(671,7512955,7512950,'for',100,1),(671,7512956,7512955,'per',11.111,1),(671,7512957,7512955,'erf',11.111,1),(671,7512958,7512955,'rfo',11.111,1),(671,7512959,7512955,'for',11.111,1),(671,7512960,7512955,'orm',11.111,1),(671,7512961,7512955,'rma',11.111,1),(671,7512962,7512955,'man',11.111,1),(671,7512963,7512955,'anc',11.111,1),(671,7512964,7512955,'nce',11.111,1),(671,7512965,7512956,'ide',12.5,1),(671,7512966,7512956,'den',12.5,1),(671,7512967,7512956,'ent',12.5,1),(671,7512968,7512956,'nti',12.5,1),(671,7512969,7512956,'tif',12.5,1),(671,7512970,7512956,'ifi',12.5,1),(671,7512971,7512956,'fie',12.5,1),(671,7512972,7512956,'ier',12.5,1),(671,7512973,7512965,'vdi',33.333,3),(671,7512974,7512965,'dis',33.333,3),(671,7512975,7512965,'isk',33.333,3),(671,7512976,7512973,'nam',50,1),(671,7512977,7512973,'ame',50,1),(671,7512978,7512976,'typ',50,1),(671,7512979,7512976,'ype',50,1),(671,7512980,7512978,'dir',25,1),(671,7512981,7512978,'ire',25,1),(671,7512982,7512978,'rec',25,1),(671,7512983,7512978,'ect',25,1),(672,7512985,7512984,'naa',100,2),(672,7512986,7512985,'600',3.333,3),(672,7512987,7512985,'000',3.333,3),(672,7512988,7512985,'00c',3.333,3),(672,7512989,7512985,'0c2',3.333,3),(672,7512990,7512985,'c29',3.333,3),(672,7512991,7512985,'298',3.333,3),(672,7512992,7512985,'985',3.333,3),(672,7512993,7512985,'853',3.333,3),(672,7512994,7512985,'53d',3.333,3),(672,7512995,7512985,'3db',3.333,3),(672,7512996,7512985,'db4',3.333,3),(672,7512997,7512985,'b46',3.333,3),(672,7512998,7512985,'46f',3.333,3),(672,7512999,7512985,'6f1',3.333,3),(672,7513000,7512985,'f1c',3.333,3),(672,7513001,7512985,'1ce',3.333,3),(672,7513002,7512985,'ce5',3.333,3),(672,7513003,7512985,'e5c',3.333,3),(672,7513004,7512985,'5c0',3.333,3),(672,7513005,7512985,'c00',3.333,3),(672,7513006,7512985,'003',3.333,3),(672,7513007,7512985,'03e',3.333,3),(672,7513008,7512985,'3e9',3.333,3),(672,7513009,7512985,'e98',3.333,3),(672,7513010,7512985,'981',3.333,3),(672,7513011,7512985,'814',3.333,3),(672,7513012,7512985,'14e',3.333,3),(672,7513013,7512985,'4ea',3.333,3),(672,7513014,7512985,'ea4',3.333,3),(672,7513015,7512985,'a46',3.333,3),(672,7513016,7512986,'mon',100,1),(672,7513017,7513016,'201',50,1),(672,7513018,7513016,'013',50,1),(672,7513019,7513017,'adm',33.333,3),(672,7513020,7513017,'dmi',33.333,3),(672,7513021,7513017,'min',33.333,3),(672,7513022,7513019,'cap',16.667,1),(672,7513023,7513019,'apa',16.667,1),(672,7513024,7513019,'pac',16.667,1),(672,7513025,7513019,'aci',16.667,1),(672,7513026,7513019,'cit',16.667,1),(672,7513027,7513019,'ity',16.667,1),(672,7513028,7513022,'pat',50,1),(672,7513029,7513022,'ath',50,1),(672,7513030,7513028,'fre',14.286,1),(672,7513031,7513028,'ree',14.286,1),(672,7513032,7513028,'ees',14.286,1),(672,7513033,7513028,'esp',14.286,1),(672,7513034,7513028,'spa',14.286,1),(672,7513035,7513028,'pac',14.286,1),(672,7513036,7513028,'ace',14.286,1),(672,7513037,7513030,'dis',50,1),(672,7513038,7513030,'isk',50,1),(672,7513039,7513037,'ind',33.333,1),(672,7513040,7513037,'nde',33.333,1),(672,7513041,7513037,'dex',33.333,1),(672,7513042,7513039,'adm',8.333,1),(672,7513043,7513039,'dmi',8.333,1),(672,7513044,7513039,'min',8.333,1),(672,7513045,7513039,'ini',8.333,1),(672,7513046,7513039,'nis',8.333,1),(672,7513047,7513039,'ist',8.333,1),(672,7513048,7513039,'str',8.333,1),(672,7513049,7513039,'tra',8.333,1),(672,7513050,7513039,'rat',8.333,1),(672,7513051,7513039,'ati',8.333,1),(672,7513052,7513039,'tio',8.333,1),(672,7513053,7513039,'ion',8.333,1),(672,7513054,7513042,'sta',33.333,3),(672,7513055,7513042,'tat',33.333,3),(672,7513056,7513042,'ate',33.333,3),(672,7513057,7513054,'ena',20,2),(672,7513058,7513054,'nab',20,2),(672,7513059,7513054,'abl',20,2),(672,7513060,7513054,'ble',20,2),(672,7513061,7513054,'led',20,2),(672,7513062,7513057,'cac',33.333,2),(672,7513063,7513057,'ach',33.333,2),(672,7513064,7513057,'che',33.333,2),(672,7513065,7513062,'mod',50,1),(672,7513066,7513062,'ode',50,1),(672,7513067,7513065,'wri',14.286,1),(672,7513068,7513065,'rit',14.286,1),(672,7513069,7513065,'ite',14.286,1),(672,7513070,7513065,'tet',14.286,1),(672,7513071,7513065,'eth',14.286,1),(672,7513072,7513065,'thr',14.286,1),(672,7513073,7513065,'hru',14.286,1),(672,7513074,7513067,'ope',11.111,2),(672,7513075,7513067,'per',11.111,2),(672,7513076,7513067,'era',11.111,2),(672,7513077,7513067,'rat',11.111,2),(672,7513078,7513067,'ati',11.111,2),(672,7513079,7513067,'tio',11.111,2),(672,7513080,7513067,'ion',11.111,2),(672,7513081,7513067,'ona',11.111,2),(672,7513082,7513067,'nal',11.111,2),(672,7513083,7513074,'pen',20,1),(672,7513084,7513074,'end',20,1),(672,7513085,7513074,'ndi',20,1),(672,7513086,7513074,'din',20,1),(672,7513087,7513074,'ing',20,1),(672,7513088,7513083,'mes',20,1),(672,7513089,7513083,'ess',20,1),(672,7513090,7513083,'ssa',20,1),(672,7513091,7513083,'sag',20,1),(672,7513092,7513083,'age',20,1),(672,7513093,7513088,'wai',20,1),(672,7513094,7513088,'ait',20,1),(672,7513095,7513088,'iti',20,1),(672,7513096,7513088,'tin',20,1),(672,7513097,7513088,'ing',20,1),(672,7513098,7513093,'for',100,1),(672,7513099,7513098,'per',11.111,1),(672,7513100,7513098,'erf',11.111,1),(672,7513101,7513098,'rfo',11.111,1),(672,7513102,7513098,'for',11.111,1),(672,7513103,7513098,'orm',11.111,1),(672,7513104,7513098,'rma',11.111,1),(672,7513105,7513098,'man',11.111,1),(672,7513106,7513098,'anc',11.111,1),(672,7513107,7513098,'nce',11.111,1),(672,7513108,7513099,'ide',12.5,1),(672,7513109,7513099,'den',12.5,1),(672,7513110,7513099,'ent',12.5,1),(672,7513111,7513099,'nti',12.5,1),(672,7513112,7513099,'tif',12.5,1),(672,7513113,7513099,'ifi',12.5,1),(672,7513114,7513099,'fie',12.5,1),(672,7513115,7513099,'ier',12.5,1),(672,7513116,7513108,'vdi',33.333,3),(672,7513117,7513108,'dis',33.333,3),(672,7513118,7513108,'isk',33.333,3),(672,7513119,7513116,'nam',50,1),(672,7513120,7513116,'ame',50,1),(672,7513121,7513119,'typ',50,1),(672,7513122,7513119,'ype',50,1),(672,7513123,7513121,'dir',25,1),(672,7513124,7513121,'ire',25,1),(672,7513125,7513121,'rec',25,1),(672,7513126,7513121,'ect',25,1),(673,7513128,7513127,'naa',100,2),(673,7513129,7513128,'600',3.333,3),(673,7513130,7513128,'000',3.333,3),(673,7513131,7513128,'00c',3.333,3),(673,7513132,7513128,'0c2',3.333,3),(673,7513133,7513128,'c29',3.333,3),(673,7513134,7513128,'297',3.333,3),(673,7513135,7513128,'975',3.333,3),(673,7513136,7513128,'756',3.333,3),(673,7513137,7513128,'567',3.333,3),(673,7513138,7513128,'673',3.333,3),(673,7513139,7513128,'730',3.333,3),(673,7513140,7513128,'304',3.333,3),(673,7513141,7513128,'047',3.333,3),(673,7513142,7513128,'477',3.333,3),(673,7513143,7513128,'77a',3.333,3),(673,7513144,7513128,'7aa',3.333,3),(673,7513145,7513128,'aa8',3.333,3),(673,7513146,7513128,'a83',3.333,3),(673,7513147,7513128,'83f',3.333,3),(673,7513148,7513128,'3f9',3.333,3),(673,7513149,7513128,'f90',3.333,3),(673,7513150,7513128,'902',3.333,3),(673,7513151,7513128,'026',3.333,3),(673,7513152,7513128,'267',3.333,3),(673,7513153,7513128,'67d',3.333,3),(673,7513154,7513128,'7d9',3.333,3),(673,7513155,7513128,'d97',3.333,3),(673,7513156,7513128,'97a',3.333,3),(673,7513157,7513128,'7a2',3.333,3),(673,7513158,7513128,'a27',3.333,3),(673,7513159,7513129,'mon',100,1),(673,7513160,7513159,'201',50,1),(673,7513161,7513159,'013',50,1),(673,7513162,7513160,'adm',33.333,3),(673,7513163,7513160,'dmi',33.333,3),(673,7513164,7513160,'min',33.333,3),(673,7513165,7513162,'cap',16.667,1),(673,7513166,7513162,'apa',16.667,1),(673,7513167,7513162,'pac',16.667,1),(673,7513168,7513162,'aci',16.667,1),(673,7513169,7513162,'cit',16.667,1),(673,7513170,7513162,'ity',16.667,1),(673,7513171,7513165,'pat',50,1),(673,7513172,7513165,'ath',50,1),(673,7513173,7513171,'fre',14.286,1),(673,7513174,7513171,'ree',14.286,1),(673,7513175,7513171,'ees',14.286,1),(673,7513176,7513171,'esp',14.286,1),(673,7513177,7513171,'spa',14.286,1),(673,7513178,7513171,'pac',14.286,1),(673,7513179,7513171,'ace',14.286,1),(673,7513180,7513173,'dis',50,1),(673,7513181,7513173,'isk',50,1),(673,7513182,7513180,'ind',33.333,1),(673,7513183,7513180,'nde',33.333,1),(673,7513184,7513180,'dex',33.333,1),(673,7513185,7513182,'adm',8.333,1),(673,7513186,7513182,'dmi',8.333,1),(673,7513187,7513182,'min',8.333,1),(673,7513188,7513182,'ini',8.333,1),(673,7513189,7513182,'nis',8.333,1),(673,7513190,7513182,'ist',8.333,1),(673,7513191,7513182,'str',8.333,1),(673,7513192,7513182,'tra',8.333,1),(673,7513193,7513182,'rat',8.333,1),(673,7513194,7513182,'ati',8.333,1),(673,7513195,7513182,'tio',8.333,1),(673,7513196,7513182,'ion',8.333,1),(673,7513197,7513185,'sta',33.333,3),(673,7513198,7513185,'tat',33.333,3),(673,7513199,7513185,'ate',33.333,3),(673,7513200,7513197,'ena',20,2),(673,7513201,7513197,'nab',20,2),(673,7513202,7513197,'abl',20,2),(673,7513203,7513197,'ble',20,2),(673,7513204,7513197,'led',20,2),(673,7513205,7513200,'cac',33.333,2),(673,7513206,7513200,'ach',33.333,2),(673,7513207,7513200,'che',33.333,2),(673,7513208,7513205,'mod',50,1),(673,7513209,7513205,'ode',50,1),(673,7513210,7513208,'wri',14.286,1),(673,7513211,7513208,'rit',14.286,1),(673,7513212,7513208,'ite',14.286,1),(673,7513213,7513208,'tet',14.286,1),(673,7513214,7513208,'eth',14.286,1),(673,7513215,7513208,'thr',14.286,1),(673,7513216,7513208,'hru',14.286,1),(673,7513217,7513210,'ope',11.111,2),(673,7513218,7513210,'per',11.111,2),(673,7513219,7513210,'era',11.111,2),(673,7513220,7513210,'rat',11.111,2),(673,7513221,7513210,'ati',11.111,2),(673,7513222,7513210,'tio',11.111,2),(673,7513223,7513210,'ion',11.111,2),(673,7513224,7513210,'ona',11.111,2),(673,7513225,7513210,'nal',11.111,2),(673,7513226,7513217,'pen',20,1),(673,7513227,7513217,'end',20,1),(673,7513228,7513217,'ndi',20,1),(673,7513229,7513217,'din',20,1),(673,7513230,7513217,'ing',20,1),(673,7513231,7513226,'mes',20,1),(673,7513232,7513226,'ess',20,1),(673,7513233,7513226,'ssa',20,1),(673,7513234,7513226,'sag',20,1),(673,7513235,7513226,'age',20,1),(673,7513236,7513231,'wai',20,1),(673,7513237,7513231,'ait',20,1),(673,7513238,7513231,'iti',20,1),(673,7513239,7513231,'tin',20,1),(673,7513240,7513231,'ing',20,1),(673,7513241,7513236,'for',100,1),(673,7513242,7513241,'per',11.111,1),(673,7513243,7513241,'erf',11.111,1),(673,7513244,7513241,'rfo',11.111,1),(673,7513245,7513241,'for',11.111,1),(673,7513246,7513241,'orm',11.111,1),(673,7513247,7513241,'rma',11.111,1),(673,7513248,7513241,'man',11.111,1),(673,7513249,7513241,'anc',11.111,1),(673,7513250,7513241,'nce',11.111,1),(673,7513251,7513242,'ide',12.5,1),(673,7513252,7513242,'den',12.5,1),(673,7513253,7513242,'ent',12.5,1),(673,7513254,7513242,'nti',12.5,1),(673,7513255,7513242,'tif',12.5,1),(673,7513256,7513242,'ifi',12.5,1),(673,7513257,7513242,'fie',12.5,1),(673,7513258,7513242,'ier',12.5,1),(673,7513259,7513251,'vdi',33.333,3),(673,7513260,7513251,'dis',33.333,3),(673,7513261,7513251,'isk',33.333,3),(673,7513262,7513259,'nam',50,1),(673,7513263,7513259,'ame',50,1),(673,7513264,7513262,'typ',50,1),(673,7513265,7513262,'ype',50,1),(673,7513266,7513264,'dir',25,1),(673,7513267,7513264,'ire',25,1),(673,7513268,7513264,'rec',25,1),(673,7513269,7513264,'ect',25,1),(674,7513271,7513270,'naa',100,2),(674,7513272,7513271,'600',3.333,3),(674,7513273,7513271,'000',3.333,3),(674,7513274,7513271,'00c',3.333,3),(674,7513275,7513271,'0c2',3.333,3),(674,7513276,7513271,'c29',3.333,3),(674,7513277,7513271,'298',3.333,3),(674,7513278,7513271,'98d',3.333,3),(674,7513279,7513271,'8d7',3.333,3),(674,7513280,7513271,'d7c',3.333,3),(674,7513281,7513271,'7c0',3.333,3),(674,7513282,7513271,'c0d',3.333,3),(674,7513283,7513271,'0db',3.333,3),(674,7513284,7513271,'db9',3.333,3),(674,7513285,7513271,'b98',3.333,3),(674,7513286,7513271,'985',3.333,3),(674,7513287,7513271,'85c',3.333,3),(674,7513288,7513271,'5c4',3.333,3),(674,7513289,7513271,'c4c',3.333,3),(674,7513290,7513271,'4cc',3.333,3),(674,7513291,7513271,'cc2',3.333,3),(674,7513292,7513271,'c29',3.333,3),(674,7513293,7513271,'29e',3.333,3),(674,7513294,7513271,'9e4',3.333,3),(674,7513295,7513271,'e41',3.333,3),(674,7513296,7513271,'41f',3.333,3),(674,7513297,7513271,'1f6',3.333,3),(674,7513298,7513271,'f6b',3.333,3),(674,7513299,7513271,'6bb',3.333,3),(674,7513300,7513271,'bb3',3.333,3),(674,7513301,7513271,'b35',3.333,3),(674,7513302,7513272,'mon',100,1),(674,7513303,7513302,'201',50,1),(674,7513304,7513302,'013',50,1),(674,7513305,7513303,'adm',33.333,3),(674,7513306,7513303,'dmi',33.333,3),(674,7513307,7513303,'min',33.333,3),(674,7513308,7513305,'cap',16.667,1),(674,7513309,7513305,'apa',16.667,1),(674,7513310,7513305,'pac',16.667,1),(674,7513311,7513305,'aci',16.667,1),(674,7513312,7513305,'cit',16.667,1),(674,7513313,7513305,'ity',16.667,1),(674,7513314,7513308,'pat',50,1),(674,7513315,7513308,'ath',50,1),(674,7513316,7513314,'fre',14.286,1),(674,7513317,7513314,'ree',14.286,1),(674,7513318,7513314,'ees',14.286,1),(674,7513319,7513314,'esp',14.286,1),(674,7513320,7513314,'spa',14.286,1),(674,7513321,7513314,'pac',14.286,1),(674,7513322,7513314,'ace',14.286,1),(674,7513323,7513316,'dis',50,1),(674,7513324,7513316,'isk',50,1),(674,7513325,7513323,'ind',33.333,1),(674,7513326,7513323,'nde',33.333,1),(674,7513327,7513323,'dex',33.333,1),(674,7513328,7513325,'adm',8.333,1),(674,7513329,7513325,'dmi',8.333,1),(674,7513330,7513325,'min',8.333,1),(674,7513331,7513325,'ini',8.333,1),(674,7513332,7513325,'nis',8.333,1),(674,7513333,7513325,'ist',8.333,1),(674,7513334,7513325,'str',8.333,1),(674,7513335,7513325,'tra',8.333,1),(674,7513336,7513325,'rat',8.333,1),(674,7513337,7513325,'ati',8.333,1),(674,7513338,7513325,'tio',8.333,1),(674,7513339,7513325,'ion',8.333,1),(674,7513340,7513328,'sta',33.333,3),(674,7513341,7513328,'tat',33.333,3),(674,7513342,7513328,'ate',33.333,3),(674,7513343,7513340,'ena',20,2),(674,7513344,7513340,'nab',20,2),(674,7513345,7513340,'abl',20,2),(674,7513346,7513340,'ble',20,2),(674,7513347,7513340,'led',20,2),(674,7513348,7513343,'cac',33.333,2),(674,7513349,7513343,'ach',33.333,2),(674,7513350,7513343,'che',33.333,2),(674,7513351,7513348,'mod',50,1),(674,7513352,7513348,'ode',50,1),(674,7513353,7513351,'wri',14.286,1),(674,7513354,7513351,'rit',14.286,1),(674,7513355,7513351,'ite',14.286,1),(674,7513356,7513351,'tet',14.286,1),(674,7513357,7513351,'eth',14.286,1),(674,7513358,7513351,'thr',14.286,1),(674,7513359,7513351,'hru',14.286,1),(674,7513360,7513353,'ope',11.111,2),(674,7513361,7513353,'per',11.111,2),(674,7513362,7513353,'era',11.111,2),(674,7513363,7513353,'rat',11.111,2),(674,7513364,7513353,'ati',11.111,2),(674,7513365,7513353,'tio',11.111,2),(674,7513366,7513353,'ion',11.111,2),(674,7513367,7513353,'ona',11.111,2),(674,7513368,7513353,'nal',11.111,2),(674,7513369,7513360,'pen',20,1),(674,7513370,7513360,'end',20,1),(674,7513371,7513360,'ndi',20,1),(674,7513372,7513360,'din',20,1),(674,7513373,7513360,'ing',20,1),(674,7513374,7513369,'mes',20,1),(674,7513375,7513369,'ess',20,1),(674,7513376,7513369,'ssa',20,1),(674,7513377,7513369,'sag',20,1),(674,7513378,7513369,'age',20,1),(674,7513379,7513374,'wai',20,1),(674,7513380,7513374,'ait',20,1),(674,7513381,7513374,'iti',20,1),(674,7513382,7513374,'tin',20,1),(674,7513383,7513374,'ing',20,1),(674,7513384,7513379,'for',100,1),(674,7513385,7513384,'per',11.111,1),(674,7513386,7513384,'erf',11.111,1),(674,7513387,7513384,'rfo',11.111,1),(674,7513388,7513384,'for',11.111,1),(674,7513389,7513384,'orm',11.111,1),(674,7513390,7513384,'rma',11.111,1),(674,7513391,7513384,'man',11.111,1),(674,7513392,7513384,'anc',11.111,1),(674,7513393,7513384,'nce',11.111,1),(674,7513394,7513385,'ide',12.5,1),(674,7513395,7513385,'den',12.5,1),(674,7513396,7513385,'ent',12.5,1),(674,7513397,7513385,'nti',12.5,1),(674,7513398,7513385,'tif',12.5,1),(674,7513399,7513385,'ifi',12.5,1),(674,7513400,7513385,'fie',12.5,1),(674,7513401,7513385,'ier',12.5,1),(674,7513402,7513394,'vdi',33.333,3),(674,7513403,7513394,'dis',33.333,3),(674,7513404,7513394,'isk',33.333,3),(674,7513405,7513402,'nam',50,1),(674,7513406,7513402,'ame',50,1),(674,7513407,7513405,'typ',50,1),(674,7513408,7513405,'ype',50,1),(674,7513409,7513407,'dir',25,1),(674,7513410,7513407,'ire',25,1),(674,7513411,7513407,'rec',25,1),(674,7513412,7513407,'ect',25,1),(675,7513414,7513413,'naa',100,2),(675,7513415,7513414,'600',3.333,3),(675,7513416,7513414,'000',3.333,3),(675,7513417,7513414,'00c',3.333,3),(675,7513418,7513414,'0c2',3.333,3),(675,7513419,7513414,'c29',3.333,3),(675,7513420,7513414,'295',3.333,3),(675,7513421,7513414,'952',3.333,3),(675,7513422,7513414,'52a',3.333,3),(675,7513423,7513414,'2aa',3.333,3),(675,7513424,7513414,'aab',3.333,3),(675,7513425,7513414,'abb',3.333,3),(675,7513426,7513414,'bbb',3.333,3),(675,7513427,7513414,'bb8',3.333,3),(675,7513428,7513414,'b8b',3.333,3),(675,7513429,7513414,'8bc',3.333,3),(675,7513430,7513414,'bcb',3.333,3),(675,7513431,7513414,'cb3',3.333,3),(675,7513432,7513414,'b32',3.333,3),(675,7513433,7513414,'32a',3.333,3),(675,7513434,7513414,'2a5',3.333,3),(675,7513435,7513414,'a5e',3.333,3),(675,7513436,7513414,'5e4',3.333,3),(675,7513437,7513414,'e42',3.333,3),(675,7513438,7513414,'42d',3.333,3),(675,7513439,7513414,'2df',3.333,3),(675,7513440,7513414,'df8',3.333,3),(675,7513441,7513414,'f89',3.333,3),(675,7513442,7513414,'89c',3.333,3),(675,7513443,7513414,'9c0',3.333,3),(675,7513444,7513414,'c00',3.333,3),(675,7513445,7513415,'mon',100,1),(675,7513446,7513445,'201',50,1),(675,7513447,7513445,'013',50,1),(675,7513448,7513446,'adm',33.333,3),(675,7513449,7513446,'dmi',33.333,3),(675,7513450,7513446,'min',33.333,3),(675,7513451,7513448,'cap',16.667,1),(675,7513452,7513448,'apa',16.667,1),(675,7513453,7513448,'pac',16.667,1),(675,7513454,7513448,'aci',16.667,1),(675,7513455,7513448,'cit',16.667,1),(675,7513456,7513448,'ity',16.667,1),(675,7513457,7513451,'pat',50,1),(675,7513458,7513451,'ath',50,1),(675,7513459,7513457,'fre',14.286,1),(675,7513460,7513457,'ree',14.286,1),(675,7513461,7513457,'ees',14.286,1),(675,7513462,7513457,'esp',14.286,1),(675,7513463,7513457,'spa',14.286,1),(675,7513464,7513457,'pac',14.286,1),(675,7513465,7513457,'ace',14.286,1),(675,7513466,7513459,'dis',50,1),(675,7513467,7513459,'isk',50,1),(675,7513468,7513466,'ind',33.333,1),(675,7513469,7513466,'nde',33.333,1),(675,7513470,7513466,'dex',33.333,1),(675,7513471,7513468,'adm',8.333,1),(675,7513472,7513468,'dmi',8.333,1),(675,7513473,7513468,'min',8.333,1),(675,7513474,7513468,'ini',8.333,1),(675,7513475,7513468,'nis',8.333,1),(675,7513476,7513468,'ist',8.333,1),(675,7513477,7513468,'str',8.333,1),(675,7513478,7513468,'tra',8.333,1),(675,7513479,7513468,'rat',8.333,1),(675,7513480,7513468,'ati',8.333,1),(675,7513481,7513468,'tio',8.333,1),(675,7513482,7513468,'ion',8.333,1),(675,7513483,7513471,'sta',33.333,3),(675,7513484,7513471,'tat',33.333,3),(675,7513485,7513471,'ate',33.333,3),(675,7513486,7513483,'ena',20,2),(675,7513487,7513483,'nab',20,2),(675,7513488,7513483,'abl',20,2),(675,7513489,7513483,'ble',20,2),(675,7513490,7513483,'led',20,2),(675,7513491,7513486,'cac',33.333,2),(675,7513492,7513486,'ach',33.333,2),(675,7513493,7513486,'che',33.333,2),(675,7513494,7513491,'mod',50,1),(675,7513495,7513491,'ode',50,1),(675,7513496,7513494,'wri',14.286,1),(675,7513497,7513494,'rit',14.286,1),(675,7513498,7513494,'ite',14.286,1),(675,7513499,7513494,'tet',14.286,1),(675,7513500,7513494,'eth',14.286,1),(675,7513501,7513494,'thr',14.286,1),(675,7513502,7513494,'hru',14.286,1),(675,7513503,7513496,'ope',11.111,2),(675,7513504,7513496,'per',11.111,2),(675,7513505,7513496,'era',11.111,2),(675,7513506,7513496,'rat',11.111,2),(675,7513507,7513496,'ati',11.111,2),(675,7513508,7513496,'tio',11.111,2),(675,7513509,7513496,'ion',11.111,2),(675,7513510,7513496,'ona',11.111,2),(675,7513511,7513496,'nal',11.111,2),(675,7513512,7513503,'pen',20,1),(675,7513513,7513503,'end',20,1),(675,7513514,7513503,'ndi',20,1),(675,7513515,7513503,'din',20,1),(675,7513516,7513503,'ing',20,1),(675,7513517,7513512,'mes',20,1),(675,7513518,7513512,'ess',20,1),(675,7513519,7513512,'ssa',20,1),(675,7513520,7513512,'sag',20,1),(675,7513521,7513512,'age',20,1),(675,7513522,7513517,'wai',20,1),(675,7513523,7513517,'ait',20,1),(675,7513524,7513517,'iti',20,1),(675,7513525,7513517,'tin',20,1),(675,7513526,7513517,'ing',20,1),(675,7513527,7513522,'for',100,1),(675,7513528,7513527,'per',11.111,1),(675,7513529,7513527,'erf',11.111,1),(675,7513530,7513527,'rfo',11.111,1),(675,7513531,7513527,'for',11.111,1),(675,7513532,7513527,'orm',11.111,1),(675,7513533,7513527,'rma',11.111,1),(675,7513534,7513527,'man',11.111,1),(675,7513535,7513527,'anc',11.111,1),(675,7513536,7513527,'nce',11.111,1),(675,7513537,7513528,'ide',12.5,1),(675,7513538,7513528,'den',12.5,1),(675,7513539,7513528,'ent',12.5,1),(675,7513540,7513528,'nti',12.5,1),(675,7513541,7513528,'tif',12.5,1),(675,7513542,7513528,'ifi',12.5,1),(675,7513543,7513528,'fie',12.5,1),(675,7513544,7513528,'ier',12.5,1),(675,7513545,7513537,'vdi',33.333,3),(675,7513546,7513537,'dis',33.333,3),(675,7513547,7513537,'isk',33.333,3),(675,7513548,7513545,'nam',50,1),(675,7513549,7513545,'ame',50,1),(675,7513550,7513548,'typ',50,1),(675,7513551,7513548,'ype',50,1),(675,7513552,7513550,'dir',25,1),(675,7513553,7513550,'ire',25,1),(675,7513554,7513550,'rec',25,1),(675,7513555,7513550,'ect',25,1),(676,7513557,7513556,'naa',100,2),(676,7513558,7513557,'600',3.333,3),(676,7513559,7513557,'000',3.333,3),(676,7513560,7513557,'00c',3.333,3),(676,7513561,7513557,'0c2',3.333,3),(676,7513562,7513557,'c29',3.333,3),(676,7513563,7513557,'290',3.333,3),(676,7513564,7513557,'90f',3.333,3),(676,7513565,7513557,'0fd',3.333,3),(676,7513566,7513557,'fd2',3.333,3),(676,7513567,7513557,'d26',3.333,3),(676,7513568,7513557,'26c',3.333,3),(676,7513569,7513557,'6c0',3.333,3),(676,7513570,7513557,'c01',3.333,3),(676,7513571,7513557,'01b',3.333,3),(676,7513572,7513557,'1b5',3.333,3),(676,7513573,7513557,'b50',3.333,3),(676,7513574,7513557,'506',3.333,3),(676,7513575,7513557,'064',3.333,3),(676,7513576,7513557,'640',3.333,3),(676,7513577,7513557,'405',3.333,3),(676,7513578,7513557,'05e',3.333,3),(676,7513579,7513557,'5e8',3.333,3),(676,7513580,7513557,'e8c',3.333,3),(676,7513581,7513557,'8ca',3.333,3),(676,7513582,7513557,'cae',3.333,3),(676,7513583,7513557,'ae4',3.333,3),(676,7513584,7513557,'e40',3.333,3),(676,7513585,7513557,'405',3.333,3),(676,7513586,7513557,'05f',3.333,3),(676,7513587,7513557,'5f4',3.333,3),(676,7513588,7513558,'mon',100,1),(676,7513589,7513588,'201',50,1),(676,7513590,7513588,'013',50,1),(676,7513591,7513589,'adm',33.333,3),(676,7513592,7513589,'dmi',33.333,3),(676,7513593,7513589,'min',33.333,3),(676,7513594,7513591,'cap',16.667,1),(676,7513595,7513591,'apa',16.667,1),(676,7513596,7513591,'pac',16.667,1),(676,7513597,7513591,'aci',16.667,1),(676,7513598,7513591,'cit',16.667,1),(676,7513599,7513591,'ity',16.667,1),(676,7513600,7513594,'pat',50,1),(676,7513601,7513594,'ath',50,1),(676,7513602,7513600,'fre',14.286,1),(676,7513603,7513600,'ree',14.286,1),(676,7513604,7513600,'ees',14.286,1),(676,7513605,7513600,'esp',14.286,1),(676,7513606,7513600,'spa',14.286,1),(676,7513607,7513600,'pac',14.286,1),(676,7513608,7513600,'ace',14.286,1),(676,7513609,7513602,'dis',50,1),(676,7513610,7513602,'isk',50,1),(676,7513611,7513609,'ind',33.333,1),(676,7513612,7513609,'nde',33.333,1),(676,7513613,7513609,'dex',33.333,1),(676,7513614,7513611,'adm',8.333,1),(676,7513615,7513611,'dmi',8.333,1),(676,7513616,7513611,'min',8.333,1),(676,7513617,7513611,'ini',8.333,1),(676,7513618,7513611,'nis',8.333,1),(676,7513619,7513611,'ist',8.333,1),(676,7513620,7513611,'str',8.333,1),(676,7513621,7513611,'tra',8.333,1),(676,7513622,7513611,'rat',8.333,1),(676,7513623,7513611,'ati',8.333,1),(676,7513624,7513611,'tio',8.333,1),(676,7513625,7513611,'ion',8.333,1),(676,7513626,7513614,'sta',33.333,3),(676,7513627,7513614,'tat',33.333,3),(676,7513628,7513614,'ate',33.333,3),(676,7513629,7513626,'ena',20,2),(676,7513630,7513626,'nab',20,2),(676,7513631,7513626,'abl',20,2),(676,7513632,7513626,'ble',20,2),(676,7513633,7513626,'led',20,2),(676,7513634,7513629,'cac',33.333,2),(676,7513635,7513629,'ach',33.333,2),(676,7513636,7513629,'che',33.333,2),(676,7513637,7513634,'mod',50,1),(676,7513638,7513634,'ode',50,1),(676,7513639,7513637,'wri',14.286,1),(676,7513640,7513637,'rit',14.286,1),(676,7513641,7513637,'ite',14.286,1),(676,7513642,7513637,'tet',14.286,1),(676,7513643,7513637,'eth',14.286,1),(676,7513644,7513637,'thr',14.286,1),(676,7513645,7513637,'hru',14.286,1),(676,7513646,7513639,'ope',11.111,2),(676,7513647,7513639,'per',11.111,2),(676,7513648,7513639,'era',11.111,2),(676,7513649,7513639,'rat',11.111,2),(676,7513650,7513639,'ati',11.111,2),(676,7513651,7513639,'tio',11.111,2),(676,7513652,7513639,'ion',11.111,2),(676,7513653,7513639,'ona',11.111,2),(676,7513654,7513639,'nal',11.111,2),(676,7513655,7513646,'pen',20,1),(676,7513656,7513646,'end',20,1),(676,7513657,7513646,'ndi',20,1),(676,7513658,7513646,'din',20,1),(676,7513659,7513646,'ing',20,1),(676,7513660,7513655,'mes',20,1),(676,7513661,7513655,'ess',20,1),(676,7513662,7513655,'ssa',20,1),(676,7513663,7513655,'sag',20,1),(676,7513664,7513655,'age',20,1),(676,7513665,7513660,'wai',20,1),(676,7513666,7513660,'ait',20,1),(676,7513667,7513660,'iti',20,1),(676,7513668,7513660,'tin',20,1),(676,7513669,7513660,'ing',20,1),(676,7513670,7513665,'for',100,1),(676,7513671,7513670,'per',11.111,1),(676,7513672,7513670,'erf',11.111,1),(676,7513673,7513670,'rfo',11.111,1),(676,7513674,7513670,'for',11.111,1),(676,7513675,7513670,'orm',11.111,1),(676,7513676,7513670,'rma',11.111,1),(676,7513677,7513670,'man',11.111,1),(676,7513678,7513670,'anc',11.111,1),(676,7513679,7513670,'nce',11.111,1),(676,7513680,7513671,'ide',12.5,1),(676,7513681,7513671,'den',12.5,1),(676,7513682,7513671,'ent',12.5,1),(676,7513683,7513671,'nti',12.5,1),(676,7513684,7513671,'tif',12.5,1),(676,7513685,7513671,'ifi',12.5,1),(676,7513686,7513671,'fie',12.5,1),(676,7513687,7513671,'ier',12.5,1),(676,7513688,7513680,'vdi',33.333,3),(676,7513689,7513680,'dis',33.333,3),(676,7513690,7513680,'isk',33.333,3),(676,7513691,7513688,'nam',50,1),(676,7513692,7513688,'ame',50,1),(676,7513693,7513691,'typ',50,1),(676,7513694,7513691,'ype',50,1),(676,7513695,7513693,'dir',25,1),(676,7513696,7513693,'ire',25,1),(676,7513697,7513693,'rec',25,1),(676,7513698,7513693,'ect',25,1),(677,7513700,7513699,'naa',100,2),(677,7513701,7513700,'600',3.333,3),(677,7513702,7513700,'000',3.333,3),(677,7513703,7513700,'00c',3.333,3),(677,7513704,7513700,'0c2',3.333,3),(677,7513705,7513700,'c29',3.333,3),(677,7513706,7513700,'29f',3.333,3),(677,7513707,7513700,'9f4',3.333,3),(677,7513708,7513700,'f42',3.333,3),(677,7513709,7513700,'42d',3.333,3),(677,7513710,7513700,'2da',3.333,3),(677,7513711,7513700,'da8',3.333,3),(677,7513712,7513700,'a81',3.333,3),(677,7513713,7513700,'819',3.333,3),(677,7513714,7513700,'199',3.333,3),(677,7513715,7513700,'99b',3.333,3),(677,7513716,7513700,'9be',3.333,3),(677,7513717,7513700,'be3',3.333,3),(677,7513718,7513700,'e34',3.333,3),(677,7513719,7513700,'348',3.333,3),(677,7513720,7513700,'48d',3.333,3),(677,7513721,7513700,'8da',3.333,3),(677,7513722,7513700,'da7',3.333,3),(677,7513723,7513700,'a7e',3.333,3),(677,7513724,7513700,'7ef',3.333,3),(677,7513725,7513700,'ef6',3.333,3),(677,7513726,7513700,'f61',3.333,3),(677,7513727,7513700,'618',3.333,3),(677,7513728,7513700,'18f',3.333,3),(677,7513729,7513700,'8f9',3.333,3),(677,7513730,7513700,'f91',3.333,3),(677,7513731,7513701,'mon',100,1),(677,7513732,7513731,'201',50,1),(677,7513733,7513731,'013',50,1),(677,7513734,7513732,'adm',33.333,3),(677,7513735,7513732,'dmi',33.333,3),(677,7513736,7513732,'min',33.333,3),(677,7513737,7513734,'cap',16.667,1),(677,7513738,7513734,'apa',16.667,1),(677,7513739,7513734,'pac',16.667,1),(677,7513740,7513734,'aci',16.667,1),(677,7513741,7513734,'cit',16.667,1),(677,7513742,7513734,'ity',16.667,1),(677,7513743,7513737,'pat',50,1),(677,7513744,7513737,'ath',50,1),(677,7513745,7513743,'fre',14.286,1),(677,7513746,7513743,'ree',14.286,1),(677,7513747,7513743,'ees',14.286,1),(677,7513748,7513743,'esp',14.286,1),(677,7513749,7513743,'spa',14.286,1),(677,7513750,7513743,'pac',14.286,1),(677,7513751,7513743,'ace',14.286,1),(677,7513752,7513745,'dis',50,1),(677,7513753,7513745,'isk',50,1),(677,7513754,7513752,'ind',33.333,1),(677,7513755,7513752,'nde',33.333,1),(677,7513756,7513752,'dex',33.333,1),(677,7513757,7513754,'adm',8.333,1),(677,7513758,7513754,'dmi',8.333,1),(677,7513759,7513754,'min',8.333,1),(677,7513760,7513754,'ini',8.333,1),(677,7513761,7513754,'nis',8.333,1),(677,7513762,7513754,'ist',8.333,1),(677,7513763,7513754,'str',8.333,1),(677,7513764,7513754,'tra',8.333,1),(677,7513765,7513754,'rat',8.333,1),(677,7513766,7513754,'ati',8.333,1),(677,7513767,7513754,'tio',8.333,1),(677,7513768,7513754,'ion',8.333,1),(677,7513769,7513757,'sta',33.333,3),(677,7513770,7513757,'tat',33.333,3),(677,7513771,7513757,'ate',33.333,3),(677,7513772,7513769,'ena',20,2),(677,7513773,7513769,'nab',20,2),(677,7513774,7513769,'abl',20,2),(677,7513775,7513769,'ble',20,2),(677,7513776,7513769,'led',20,2),(677,7513777,7513772,'cac',33.333,2),(677,7513778,7513772,'ach',33.333,2),(677,7513779,7513772,'che',33.333,2),(677,7513780,7513777,'mod',50,1),(677,7513781,7513777,'ode',50,1),(677,7513782,7513780,'wri',14.286,1),(677,7513783,7513780,'rit',14.286,1),(677,7513784,7513780,'ite',14.286,1),(677,7513785,7513780,'tet',14.286,1),(677,7513786,7513780,'eth',14.286,1),(677,7513787,7513780,'thr',14.286,1),(677,7513788,7513780,'hru',14.286,1),(677,7513789,7513782,'ope',11.111,2),(677,7513790,7513782,'per',11.111,2),(677,7513791,7513782,'era',11.111,2),(677,7513792,7513782,'rat',11.111,2),(677,7513793,7513782,'ati',11.111,2),(677,7513794,7513782,'tio',11.111,2),(677,7513795,7513782,'ion',11.111,2),(677,7513796,7513782,'ona',11.111,2),(677,7513797,7513782,'nal',11.111,2),(677,7513798,7513789,'pen',20,1),(677,7513799,7513789,'end',20,1),(677,7513800,7513789,'ndi',20,1),(677,7513801,7513789,'din',20,1),(677,7513802,7513789,'ing',20,1),(677,7513803,7513798,'mes',20,1),(677,7513804,7513798,'ess',20,1),(677,7513805,7513798,'ssa',20,1),(677,7513806,7513798,'sag',20,1),(677,7513807,7513798,'age',20,1),(677,7513808,7513803,'wai',20,1),(677,7513809,7513803,'ait',20,1),(677,7513810,7513803,'iti',20,1),(677,7513811,7513803,'tin',20,1),(677,7513812,7513803,'ing',20,1),(677,7513813,7513808,'for',100,1),(677,7513814,7513813,'per',11.111,1),(677,7513815,7513813,'erf',11.111,1),(677,7513816,7513813,'rfo',11.111,1),(677,7513817,7513813,'for',11.111,1),(677,7513818,7513813,'orm',11.111,1),(677,7513819,7513813,'rma',11.111,1),(677,7513820,7513813,'man',11.111,1),(677,7513821,7513813,'anc',11.111,1),(677,7513822,7513813,'nce',11.111,1),(677,7513823,7513814,'ide',12.5,1),(677,7513824,7513814,'den',12.5,1),(677,7513825,7513814,'ent',12.5,1),(677,7513826,7513814,'nti',12.5,1),(677,7513827,7513814,'tif',12.5,1),(677,7513828,7513814,'ifi',12.5,1),(677,7513829,7513814,'fie',12.5,1),(677,7513830,7513814,'ier',12.5,1),(677,7513831,7513823,'vdi',33.333,3),(677,7513832,7513823,'dis',33.333,3),(677,7513833,7513823,'isk',33.333,3),(677,7513834,7513831,'nam',50,1),(677,7513835,7513831,'ame',50,1),(677,7513836,7513834,'typ',50,1),(677,7513837,7513834,'ype',50,1),(677,7513838,7513836,'dir',25,1),(677,7513839,7513836,'ire',25,1),(677,7513840,7513836,'rec',25,1),(677,7513841,7513836,'ect',25,1),(678,7513843,7513842,'naa',100,2),(678,7513844,7513843,'600',3.333,3),(678,7513845,7513843,'000',3.333,3),(678,7513846,7513843,'00c',3.333,3),(678,7513847,7513843,'0c2',3.333,3),(678,7513848,7513843,'c29',3.333,3),(678,7513849,7513843,'290',3.333,3),(678,7513850,7513843,'908',3.333,3),(678,7513851,7513843,'089',3.333,3),(678,7513852,7513843,'89d',3.333,3),(678,7513853,7513843,'9d7',3.333,3),(678,7513854,7513843,'d73',3.333,3),(678,7513855,7513843,'730',3.333,3),(678,7513856,7513843,'30f',3.333,3),(678,7513857,7513843,'0f1',3.333,3),(678,7513858,7513843,'f12',3.333,3),(678,7513859,7513843,'128',3.333,3),(678,7513860,7513843,'28d',3.333,3),(678,7513861,7513843,'8d9',3.333,3),(678,7513862,7513843,'d97',3.333,3),(678,7513863,7513843,'975',3.333,3),(678,7513864,7513843,'751',3.333,3),(678,7513865,7513843,'510',3.333,3),(678,7513866,7513843,'10a',3.333,3),(678,7513867,7513843,'0ad',3.333,3),(678,7513868,7513843,'ade',3.333,3),(678,7513869,7513843,'de8',3.333,3),(678,7513870,7513843,'e8a',3.333,3),(678,7513871,7513843,'8ae',3.333,3),(678,7513872,7513843,'ae2',3.333,3),(678,7513873,7513843,'e24',3.333,3),(678,7513874,7513844,'mon',100,1),(678,7513875,7513874,'201',50,1),(678,7513876,7513874,'013',50,1),(678,7513877,7513875,'adm',33.333,3),(678,7513878,7513875,'dmi',33.333,3),(678,7513879,7513875,'min',33.333,3),(678,7513880,7513877,'cap',16.667,1),(678,7513881,7513877,'apa',16.667,1),(678,7513882,7513877,'pac',16.667,1),(678,7513883,7513877,'aci',16.667,1),(678,7513884,7513877,'cit',16.667,1),(678,7513885,7513877,'ity',16.667,1),(678,7513886,7513880,'pat',50,1),(678,7513887,7513880,'ath',50,1),(678,7513888,7513886,'fre',14.286,1),(678,7513889,7513886,'ree',14.286,1),(678,7513890,7513886,'ees',14.286,1),(678,7513891,7513886,'esp',14.286,1),(678,7513892,7513886,'spa',14.286,1),(678,7513893,7513886,'pac',14.286,1),(678,7513894,7513886,'ace',14.286,1),(678,7513895,7513888,'dis',50,1),(678,7513896,7513888,'isk',50,1),(678,7513897,7513895,'ind',33.333,1),(678,7513898,7513895,'nde',33.333,1),(678,7513899,7513895,'dex',33.333,1),(678,7513900,7513897,'adm',8.333,1),(678,7513901,7513897,'dmi',8.333,1),(678,7513902,7513897,'min',8.333,1),(678,7513903,7513897,'ini',8.333,1),(678,7513904,7513897,'nis',8.333,1),(678,7513905,7513897,'ist',8.333,1),(678,7513906,7513897,'str',8.333,1),(678,7513907,7513897,'tra',8.333,1),(678,7513908,7513897,'rat',8.333,1),(678,7513909,7513897,'ati',8.333,1),(678,7513910,7513897,'tio',8.333,1),(678,7513911,7513897,'ion',8.333,1),(678,7513912,7513900,'sta',33.333,3),(678,7513913,7513900,'tat',33.333,3),(678,7513914,7513900,'ate',33.333,3),(678,7513915,7513912,'ena',20,2),(678,7513916,7513912,'nab',20,2),(678,7513917,7513912,'abl',20,2),(678,7513918,7513912,'ble',20,2),(678,7513919,7513912,'led',20,2),(678,7513920,7513915,'cac',33.333,2),(678,7513921,7513915,'ach',33.333,2),(678,7513922,7513915,'che',33.333,2),(678,7513923,7513920,'mod',50,1),(678,7513924,7513920,'ode',50,1),(678,7513925,7513923,'wri',14.286,1),(678,7513926,7513923,'rit',14.286,1),(678,7513927,7513923,'ite',14.286,1),(678,7513928,7513923,'tet',14.286,1),(678,7513929,7513923,'eth',14.286,1),(678,7513930,7513923,'thr',14.286,1),(678,7513931,7513923,'hru',14.286,1),(678,7513932,7513925,'ope',11.111,2),(678,7513933,7513925,'per',11.111,2),(678,7513934,7513925,'era',11.111,2),(678,7513935,7513925,'rat',11.111,2),(678,7513936,7513925,'ati',11.111,2),(678,7513937,7513925,'tio',11.111,2),(678,7513938,7513925,'ion',11.111,2),(678,7513939,7513925,'ona',11.111,2),(678,7513940,7513925,'nal',11.111,2),(678,7513941,7513932,'pen',20,1),(678,7513942,7513932,'end',20,1),(678,7513943,7513932,'ndi',20,1),(678,7513944,7513932,'din',20,1),(678,7513945,7513932,'ing',20,1),(678,7513946,7513941,'mes',20,1),(678,7513947,7513941,'ess',20,1),(678,7513948,7513941,'ssa',20,1),(678,7513949,7513941,'sag',20,1),(678,7513950,7513941,'age',20,1),(678,7513951,7513946,'wai',20,1),(678,7513952,7513946,'ait',20,1),(678,7513953,7513946,'iti',20,1),(678,7513954,7513946,'tin',20,1),(678,7513955,7513946,'ing',20,1),(678,7513956,7513951,'for',100,1),(678,7513957,7513956,'per',11.111,1),(678,7513958,7513956,'erf',11.111,1),(678,7513959,7513956,'rfo',11.111,1),(678,7513960,7513956,'for',11.111,1),(678,7513961,7513956,'orm',11.111,1),(678,7513962,7513956,'rma',11.111,1),(678,7513963,7513956,'man',11.111,1),(678,7513964,7513956,'anc',11.111,1),(678,7513965,7513956,'nce',11.111,1),(678,7513966,7513957,'ide',12.5,1),(678,7513967,7513957,'den',12.5,1),(678,7513968,7513957,'ent',12.5,1),(678,7513969,7513957,'nti',12.5,1),(678,7513970,7513957,'tif',12.5,1),(678,7513971,7513957,'ifi',12.5,1),(678,7513972,7513957,'fie',12.5,1),(678,7513973,7513957,'ier',12.5,1),(678,7513974,7513966,'vdi',33.333,3),(678,7513975,7513966,'dis',33.333,3),(678,7513976,7513966,'isk',33.333,3),(678,7513977,7513974,'nam',50,1),(678,7513978,7513974,'ame',50,1),(678,7513979,7513977,'typ',50,1),(678,7513980,7513977,'ype',50,1),(678,7513981,7513979,'dir',25,1),(678,7513982,7513979,'ire',25,1),(678,7513983,7513979,'rec',25,1),(678,7513984,7513979,'ect',25,1),(679,7513986,7513985,'naa',100,2),(679,7513987,7513986,'600',3.333,3),(679,7513988,7513986,'000',3.333,3),(679,7513989,7513986,'00c',3.333,3),(679,7513990,7513986,'0c2',3.333,3),(679,7513991,7513986,'c29',3.333,3),(679,7513992,7513986,'294',3.333,3),(679,7513993,7513986,'947',3.333,3),(679,7513994,7513986,'474',3.333,3),(679,7513995,7513986,'74d',3.333,3),(679,7513996,7513986,'4db',3.333,3),(679,7513997,7513986,'dbb',3.333,3),(679,7513998,7513986,'bbf',3.333,3),(679,7513999,7513986,'bff',3.333,3),(679,7514000,7513986,'ff7',3.333,3),(679,7514001,7513986,'f7d',3.333,3),(679,7514002,7513986,'7d5',3.333,3),(679,7514003,7513986,'d52',3.333,3),(679,7514004,7513986,'522',3.333,3),(679,7514005,7513986,'221',3.333,3),(679,7514006,7513986,'210',3.333,3),(679,7514007,7513986,'105',3.333,3),(679,7514008,7513986,'054',3.333,3),(679,7514009,7513986,'54c',3.333,3),(679,7514010,7513986,'4c6',3.333,3),(679,7514011,7513986,'c67',3.333,3),(679,7514012,7513986,'675',3.333,3),(679,7514013,7513986,'75b',3.333,3),(679,7514014,7513986,'5ba',3.333,3),(679,7514015,7513986,'ba9',3.333,3),(679,7514016,7513986,'a9e',3.333,3),(679,7514017,7513987,'mon',100,1),(679,7514018,7514017,'201',50,1),(679,7514019,7514017,'013',50,1),(679,7514020,7514018,'adm',33.333,3),(679,7514021,7514018,'dmi',33.333,3),(679,7514022,7514018,'min',33.333,3),(679,7514023,7514020,'cap',16.667,1),(679,7514024,7514020,'apa',16.667,1),(679,7514025,7514020,'pac',16.667,1),(679,7514026,7514020,'aci',16.667,1),(679,7514027,7514020,'cit',16.667,1),(679,7514028,7514020,'ity',16.667,1),(679,7514029,7514023,'pat',50,1),(679,7514030,7514023,'ath',50,1),(679,7514031,7514029,'fre',14.286,1),(679,7514032,7514029,'ree',14.286,1),(679,7514033,7514029,'ees',14.286,1),(679,7514034,7514029,'esp',14.286,1),(679,7514035,7514029,'spa',14.286,1),(679,7514036,7514029,'pac',14.286,1),(679,7514037,7514029,'ace',14.286,1),(679,7514038,7514031,'dis',50,1),(679,7514039,7514031,'isk',50,1),(679,7514040,7514038,'ind',33.333,1),(679,7514041,7514038,'nde',33.333,1),(679,7514042,7514038,'dex',33.333,1),(679,7514043,7514040,'adm',8.333,1),(679,7514044,7514040,'dmi',8.333,1),(679,7514045,7514040,'min',8.333,1),(679,7514046,7514040,'ini',8.333,1),(679,7514047,7514040,'nis',8.333,1),(679,7514048,7514040,'ist',8.333,1),(679,7514049,7514040,'str',8.333,1),(679,7514050,7514040,'tra',8.333,1),(679,7514051,7514040,'rat',8.333,1),(679,7514052,7514040,'ati',8.333,1),(679,7514053,7514040,'tio',8.333,1),(679,7514054,7514040,'ion',8.333,1),(679,7514055,7514043,'sta',33.333,3),(679,7514056,7514043,'tat',33.333,3),(679,7514057,7514043,'ate',33.333,3),(679,7514058,7514055,'ena',20,2),(679,7514059,7514055,'nab',20,2),(679,7514060,7514055,'abl',20,2),(679,7514061,7514055,'ble',20,2),(679,7514062,7514055,'led',20,2),(679,7514063,7514058,'cac',33.333,2),(679,7514064,7514058,'ach',33.333,2),(679,7514065,7514058,'che',33.333,2),(679,7514066,7514063,'mod',50,1),(679,7514067,7514063,'ode',50,1),(679,7514068,7514066,'wri',14.286,1),(679,7514069,7514066,'rit',14.286,1),(679,7514070,7514066,'ite',14.286,1),(679,7514071,7514066,'tet',14.286,1),(679,7514072,7514066,'eth',14.286,1),(679,7514073,7514066,'thr',14.286,1),(679,7514074,7514066,'hru',14.286,1),(679,7514075,7514068,'ope',11.111,2),(679,7514076,7514068,'per',11.111,2),(679,7514077,7514068,'era',11.111,2),(679,7514078,7514068,'rat',11.111,2),(679,7514079,7514068,'ati',11.111,2),(679,7514080,7514068,'tio',11.111,2),(679,7514081,7514068,'ion',11.111,2),(679,7514082,7514068,'ona',11.111,2),(679,7514083,7514068,'nal',11.111,2),(679,7514084,7514075,'pen',20,1),(679,7514085,7514075,'end',20,1),(679,7514086,7514075,'ndi',20,1),(679,7514087,7514075,'din',20,1),(679,7514088,7514075,'ing',20,1),(679,7514089,7514084,'mes',20,1),(679,7514090,7514084,'ess',20,1),(679,7514091,7514084,'ssa',20,1),(679,7514092,7514084,'sag',20,1),(679,7514093,7514084,'age',20,1),(679,7514094,7514089,'wai',20,1),(679,7514095,7514089,'ait',20,1),(679,7514096,7514089,'iti',20,1),(679,7514097,7514089,'tin',20,1),(679,7514098,7514089,'ing',20,1),(679,7514099,7514094,'for',100,1),(679,7514100,7514099,'per',11.111,1),(679,7514101,7514099,'erf',11.111,1),(679,7514102,7514099,'rfo',11.111,1),(679,7514103,7514099,'for',11.111,1),(679,7514104,7514099,'orm',11.111,1),(679,7514105,7514099,'rma',11.111,1),(679,7514106,7514099,'man',11.111,1),(679,7514107,7514099,'anc',11.111,1),(679,7514108,7514099,'nce',11.111,1),(679,7514109,7514100,'ide',12.5,1),(679,7514110,7514100,'den',12.5,1),(679,7514111,7514100,'ent',12.5,1),(679,7514112,7514100,'nti',12.5,1),(679,7514113,7514100,'tif',12.5,1),(679,7514114,7514100,'ifi',12.5,1),(679,7514115,7514100,'fie',12.5,1),(679,7514116,7514100,'ier',12.5,1),(679,7514117,7514109,'vdi',33.333,3),(679,7514118,7514109,'dis',33.333,3),(679,7514119,7514109,'isk',33.333,3),(679,7514120,7514117,'nam',50,1),(679,7514121,7514117,'ame',50,1),(679,7514122,7514120,'typ',50,1),(679,7514123,7514120,'ype',50,1),(679,7514124,7514122,'dir',25,1),(679,7514125,7514122,'ire',25,1),(679,7514126,7514122,'rec',25,1),(679,7514127,7514122,'ect',25,1),(680,7514129,7514128,'naa',100,2),(680,7514130,7514129,'600',3.333,3),(680,7514131,7514129,'000',3.333,3),(680,7514132,7514129,'00c',3.333,3),(680,7514133,7514129,'0c2',3.333,3),(680,7514134,7514129,'c29',3.333,3),(680,7514135,7514129,'297',3.333,3),(680,7514136,7514129,'97f',3.333,3),(680,7514137,7514129,'7f0',3.333,3),(680,7514138,7514129,'f07',3.333,3),(680,7514139,7514129,'077',3.333,3),(680,7514140,7514129,'773',3.333,3),(680,7514141,7514129,'730',3.333,3),(680,7514142,7514129,'307',3.333,3),(680,7514143,7514129,'07e',3.333,3),(680,7514144,7514129,'7e1',3.333,3),(680,7514145,7514129,'e1a',3.333,3),(680,7514146,7514129,'1ad',3.333,3),(680,7514147,7514129,'ad0',3.333,3),(680,7514148,7514129,'d01',3.333,3),(680,7514149,7514129,'014',3.333,3),(680,7514150,7514129,'144',3.333,3),(680,7514151,7514129,'44a',3.333,3),(680,7514152,7514129,'4aa',3.333,3),(680,7514153,7514129,'aa4',3.333,3),(680,7514154,7514129,'a43',3.333,3),(680,7514155,7514129,'437',3.333,3),(680,7514156,7514129,'379',3.333,3),(680,7514157,7514129,'797',3.333,3),(680,7514158,7514129,'971',3.333,3),(680,7514159,7514129,'718',3.333,3),(680,7514160,7514130,'mon',100,1),(680,7514161,7514160,'201',50,1),(680,7514162,7514160,'013',50,1),(680,7514163,7514161,'adm',33.333,3),(680,7514164,7514161,'dmi',33.333,3),(680,7514165,7514161,'min',33.333,3),(680,7514166,7514163,'cap',16.667,1),(680,7514167,7514163,'apa',16.667,1),(680,7514168,7514163,'pac',16.667,1),(680,7514169,7514163,'aci',16.667,1),(680,7514170,7514163,'cit',16.667,1),(680,7514171,7514163,'ity',16.667,1),(680,7514172,7514166,'pat',50,1),(680,7514173,7514166,'ath',50,1),(680,7514174,7514172,'fre',14.286,1),(680,7514175,7514172,'ree',14.286,1),(680,7514176,7514172,'ees',14.286,1),(680,7514177,7514172,'esp',14.286,1),(680,7514178,7514172,'spa',14.286,1),(680,7514179,7514172,'pac',14.286,1),(680,7514180,7514172,'ace',14.286,1),(680,7514181,7514174,'dis',50,1),(680,7514182,7514174,'isk',50,1),(680,7514183,7514181,'ind',33.333,1),(680,7514184,7514181,'nde',33.333,1),(680,7514185,7514181,'dex',33.333,1),(680,7514186,7514183,'adm',8.333,1),(680,7514187,7514183,'dmi',8.333,1),(680,7514188,7514183,'min',8.333,1),(680,7514189,7514183,'ini',8.333,1),(680,7514190,7514183,'nis',8.333,1),(680,7514191,7514183,'ist',8.333,1),(680,7514192,7514183,'str',8.333,1),(680,7514193,7514183,'tra',8.333,1),(680,7514194,7514183,'rat',8.333,1),(680,7514195,7514183,'ati',8.333,1),(680,7514196,7514183,'tio',8.333,1),(680,7514197,7514183,'ion',8.333,1),(680,7514198,7514186,'sta',33.333,3),(680,7514199,7514186,'tat',33.333,3),(680,7514200,7514186,'ate',33.333,3),(680,7514201,7514198,'ena',20,2),(680,7514202,7514198,'nab',20,2),(680,7514203,7514198,'abl',20,2),(680,7514204,7514198,'ble',20,2),(680,7514205,7514198,'led',20,2),(680,7514206,7514201,'cac',33.333,2),(680,7514207,7514201,'ach',33.333,2),(680,7514208,7514201,'che',33.333,2),(680,7514209,7514206,'mod',50,1),(680,7514210,7514206,'ode',50,1),(680,7514211,7514209,'wri',14.286,1),(680,7514212,7514209,'rit',14.286,1),(680,7514213,7514209,'ite',14.286,1),(680,7514214,7514209,'tet',14.286,1),(680,7514215,7514209,'eth',14.286,1),(680,7514216,7514209,'thr',14.286,1),(680,7514217,7514209,'hru',14.286,1),(680,7514218,7514211,'ope',11.111,2),(680,7514219,7514211,'per',11.111,2),(680,7514220,7514211,'era',11.111,2),(680,7514221,7514211,'rat',11.111,2),(680,7514222,7514211,'ati',11.111,2),(680,7514223,7514211,'tio',11.111,2),(680,7514224,7514211,'ion',11.111,2),(680,7514225,7514211,'ona',11.111,2),(680,7514226,7514211,'nal',11.111,2),(680,7514227,7514218,'pen',20,1),(680,7514228,7514218,'end',20,1),(680,7514229,7514218,'ndi',20,1),(680,7514230,7514218,'din',20,1),(680,7514231,7514218,'ing',20,1),(680,7514232,7514227,'mes',20,1),(680,7514233,7514227,'ess',20,1),(680,7514234,7514227,'ssa',20,1),(680,7514235,7514227,'sag',20,1),(680,7514236,7514227,'age',20,1),(680,7514237,7514232,'wai',20,1),(680,7514238,7514232,'ait',20,1),(680,7514239,7514232,'iti',20,1),(680,7514240,7514232,'tin',20,1),(680,7514241,7514232,'ing',20,1),(680,7514242,7514237,'for',100,1),(680,7514243,7514242,'per',11.111,1),(680,7514244,7514242,'erf',11.111,1),(680,7514245,7514242,'rfo',11.111,1),(680,7514246,7514242,'for',11.111,1),(680,7514247,7514242,'orm',11.111,1),(680,7514248,7514242,'rma',11.111,1),(680,7514249,7514242,'man',11.111,1),(680,7514250,7514242,'anc',11.111,1),(680,7514251,7514242,'nce',11.111,1),(680,7514252,7514243,'ide',12.5,1),(680,7514253,7514243,'den',12.5,1),(680,7514254,7514243,'ent',12.5,1),(680,7514255,7514243,'nti',12.5,1),(680,7514256,7514243,'tif',12.5,1),(680,7514257,7514243,'ifi',12.5,1),(680,7514258,7514243,'fie',12.5,1),(680,7514259,7514243,'ier',12.5,1),(680,7514260,7514252,'vdi',33.333,3),(680,7514261,7514252,'dis',33.333,3),(680,7514262,7514252,'isk',33.333,3),(680,7514263,7514260,'nam',50,1),(680,7514264,7514260,'ame',50,1),(680,7514265,7514263,'typ',50,1),(680,7514266,7514263,'ype',50,1),(680,7514267,7514265,'dir',25,1),(680,7514268,7514265,'ire',25,1),(680,7514269,7514265,'rec',25,1),(680,7514270,7514265,'ect',25,1),(681,7514272,7514271,'naa',100,2),(681,7514273,7514272,'600',3.333,3),(681,7514274,7514272,'000',3.333,3),(681,7514275,7514272,'00c',3.333,3),(681,7514276,7514272,'0c2',3.333,3),(681,7514277,7514272,'c29',3.333,3),(681,7514278,7514272,'299',3.333,3),(681,7514279,7514272,'995',3.333,3),(681,7514280,7514272,'950',3.333,3),(681,7514281,7514272,'508',3.333,3),(681,7514282,7514272,'084',3.333,3),(681,7514283,7514272,'844',3.333,3),(681,7514284,7514272,'440',3.333,3),(681,7514285,7514272,'402',3.333,3),(681,7514286,7514272,'028',3.333,3),(681,7514287,7514272,'28f',3.333,3),(681,7514288,7514272,'8fa',3.333,3),(681,7514289,7514272,'fa8',3.333,3),(681,7514290,7514272,'a82',3.333,3),(681,7514291,7514272,'827',3.333,3),(681,7514292,7514272,'275',3.333,3),(681,7514293,7514272,'75f',3.333,3),(681,7514294,7514272,'5f0',3.333,3),(681,7514295,7514272,'f03',3.333,3),(681,7514296,7514272,'032',3.333,3),(681,7514297,7514272,'320',3.333,3),(681,7514298,7514272,'208',3.333,3),(681,7514299,7514272,'088',3.333,3),(681,7514300,7514272,'885',3.333,3),(681,7514301,7514272,'852',3.333,3),(681,7514302,7514272,'52d',3.333,3),(681,7514303,7514273,'mon',100,1),(681,7514304,7514303,'201',50,1),(681,7514305,7514303,'013',50,1),(681,7514306,7514304,'adm',33.333,3),(681,7514307,7514304,'dmi',33.333,3),(681,7514308,7514304,'min',33.333,3),(681,7514309,7514306,'cap',16.667,1),(681,7514310,7514306,'apa',16.667,1),(681,7514311,7514306,'pac',16.667,1),(681,7514312,7514306,'aci',16.667,1),(681,7514313,7514306,'cit',16.667,1),(681,7514314,7514306,'ity',16.667,1),(681,7514315,7514309,'pat',50,1),(681,7514316,7514309,'ath',50,1),(681,7514317,7514315,'fre',14.286,1),(681,7514318,7514315,'ree',14.286,1),(681,7514319,7514315,'ees',14.286,1),(681,7514320,7514315,'esp',14.286,1),(681,7514321,7514315,'spa',14.286,1),(681,7514322,7514315,'pac',14.286,1),(681,7514323,7514315,'ace',14.286,1),(681,7514324,7514317,'dis',50,1),(681,7514325,7514317,'isk',50,1),(681,7514326,7514324,'ind',33.333,1),(681,7514327,7514324,'nde',33.333,1),(681,7514328,7514324,'dex',33.333,1),(681,7514329,7514326,'adm',8.333,1),(681,7514330,7514326,'dmi',8.333,1),(681,7514331,7514326,'min',8.333,1),(681,7514332,7514326,'ini',8.333,1),(681,7514333,7514326,'nis',8.333,1),(681,7514334,7514326,'ist',8.333,1),(681,7514335,7514326,'str',8.333,1),(681,7514336,7514326,'tra',8.333,1),(681,7514337,7514326,'rat',8.333,1),(681,7514338,7514326,'ati',8.333,1),(681,7514339,7514326,'tio',8.333,1),(681,7514340,7514326,'ion',8.333,1),(681,7514341,7514329,'sta',33.333,3),(681,7514342,7514329,'tat',33.333,3),(681,7514343,7514329,'ate',33.333,3),(681,7514344,7514341,'ena',20,2),(681,7514345,7514341,'nab',20,2),(681,7514346,7514341,'abl',20,2),(681,7514347,7514341,'ble',20,2),(681,7514348,7514341,'led',20,2),(681,7514349,7514344,'cac',33.333,2),(681,7514350,7514344,'ach',33.333,2),(681,7514351,7514344,'che',33.333,2),(681,7514352,7514349,'mod',50,1),(681,7514353,7514349,'ode',50,1),(681,7514354,7514352,'wri',14.286,1),(681,7514355,7514352,'rit',14.286,1),(681,7514356,7514352,'ite',14.286,1),(681,7514357,7514352,'tet',14.286,1),(681,7514358,7514352,'eth',14.286,1),(681,7514359,7514352,'thr',14.286,1),(681,7514360,7514352,'hru',14.286,1),(681,7514361,7514354,'ope',11.111,2),(681,7514362,7514354,'per',11.111,2),(681,7514363,7514354,'era',11.111,2),(681,7514364,7514354,'rat',11.111,2),(681,7514365,7514354,'ati',11.111,2),(681,7514366,7514354,'tio',11.111,2),(681,7514367,7514354,'ion',11.111,2),(681,7514368,7514354,'ona',11.111,2),(681,7514369,7514354,'nal',11.111,2),(681,7514370,7514361,'pen',20,1),(681,7514371,7514361,'end',20,1),(681,7514372,7514361,'ndi',20,1),(681,7514373,7514361,'din',20,1),(681,7514374,7514361,'ing',20,1),(681,7514375,7514370,'mes',20,1),(681,7514376,7514370,'ess',20,1),(681,7514377,7514370,'ssa',20,1),(681,7514378,7514370,'sag',20,1),(681,7514379,7514370,'age',20,1),(681,7514380,7514375,'wai',20,1),(681,7514381,7514375,'ait',20,1),(681,7514382,7514375,'iti',20,1),(681,7514383,7514375,'tin',20,1),(681,7514384,7514375,'ing',20,1),(681,7514385,7514380,'for',100,1),(681,7514386,7514385,'per',11.111,1),(681,7514387,7514385,'erf',11.111,1),(681,7514388,7514385,'rfo',11.111,1),(681,7514389,7514385,'for',11.111,1),(681,7514390,7514385,'orm',11.111,1),(681,7514391,7514385,'rma',11.111,1),(681,7514392,7514385,'man',11.111,1),(681,7514393,7514385,'anc',11.111,1),(681,7514394,7514385,'nce',11.111,1),(681,7514395,7514386,'ide',12.5,1),(681,7514396,7514386,'den',12.5,1),(681,7514397,7514386,'ent',12.5,1),(681,7514398,7514386,'nti',12.5,1),(681,7514399,7514386,'tif',12.5,1),(681,7514400,7514386,'ifi',12.5,1),(681,7514401,7514386,'fie',12.5,1),(681,7514402,7514386,'ier',12.5,1),(681,7514403,7514395,'vdi',33.333,3),(681,7514404,7514395,'dis',33.333,3),(681,7514405,7514395,'isk',33.333,3),(681,7514406,7514403,'nam',50,1),(681,7514407,7514403,'ame',50,1),(681,7514408,7514406,'typ',50,1),(681,7514409,7514406,'ype',50,1),(681,7514410,7514408,'dir',25,1),(681,7514411,7514408,'ire',25,1),(681,7514412,7514408,'rec',25,1),(681,7514413,7514408,'ect',25,1),(682,7514415,7514414,'naa',100,2),(682,7514416,7514415,'600',3.333,3),(682,7514417,7514415,'000',3.333,3),(682,7514418,7514415,'00c',3.333,3),(682,7514419,7514415,'0c2',3.333,3),(682,7514420,7514415,'c29',3.333,3),(682,7514421,7514415,'296',3.333,3),(682,7514422,7514415,'969',3.333,3),(682,7514423,7514415,'691',3.333,3),(682,7514424,7514415,'911',3.333,3),(682,7514425,7514415,'11c',3.333,3),(682,7514426,7514415,'1c2',3.333,3),(682,7514427,7514415,'c21',3.333,3),(682,7514428,7514415,'21a',3.333,3),(682,7514429,7514415,'1ad',3.333,3),(682,7514430,7514415,'adc',3.333,3),(682,7514431,7514415,'dcd',3.333,3),(682,7514432,7514415,'cd1',3.333,3),(682,7514433,7514415,'d17',3.333,3),(682,7514434,7514415,'173',3.333,3),(682,7514435,7514415,'73a',3.333,3),(682,7514436,7514415,'3a8',3.333,3),(682,7514437,7514415,'a89',3.333,3),(682,7514438,7514415,'89d',3.333,3),(682,7514439,7514415,'9d3',3.333,3),(682,7514440,7514415,'d35',3.333,3),(682,7514441,7514415,'35e',3.333,3),(682,7514442,7514415,'5ed',3.333,3),(682,7514443,7514415,'ed1',3.333,3),(682,7514444,7514415,'d1f',3.333,3),(682,7514445,7514415,'1ff',3.333,3),(682,7514446,7514416,'mon',100,1),(682,7514447,7514446,'201',50,1),(682,7514448,7514446,'013',50,1),(682,7514449,7514447,'adm',33.333,3),(682,7514450,7514447,'dmi',33.333,3),(682,7514451,7514447,'min',33.333,3),(682,7514452,7514449,'cap',16.667,1),(682,7514453,7514449,'apa',16.667,1),(682,7514454,7514449,'pac',16.667,1),(682,7514455,7514449,'aci',16.667,1),(682,7514456,7514449,'cit',16.667,1),(682,7514457,7514449,'ity',16.667,1),(682,7514458,7514452,'pat',50,1),(682,7514459,7514452,'ath',50,1),(682,7514460,7514458,'fre',14.286,1),(682,7514461,7514458,'ree',14.286,1),(682,7514462,7514458,'ees',14.286,1),(682,7514463,7514458,'esp',14.286,1),(682,7514464,7514458,'spa',14.286,1),(682,7514465,7514458,'pac',14.286,1),(682,7514466,7514458,'ace',14.286,1),(682,7514467,7514460,'dis',50,1),(682,7514468,7514460,'isk',50,1),(682,7514469,7514467,'ind',33.333,1),(682,7514470,7514467,'nde',33.333,1),(682,7514471,7514467,'dex',33.333,1),(682,7514472,7514469,'adm',8.333,1),(682,7514473,7514469,'dmi',8.333,1),(682,7514474,7514469,'min',8.333,1),(682,7514475,7514469,'ini',8.333,1),(682,7514476,7514469,'nis',8.333,1),(682,7514477,7514469,'ist',8.333,1),(682,7514478,7514469,'str',8.333,1),(682,7514479,7514469,'tra',8.333,1),(682,7514480,7514469,'rat',8.333,1),(682,7514481,7514469,'ati',8.333,1),(682,7514482,7514469,'tio',8.333,1),(682,7514483,7514469,'ion',8.333,1),(682,7514484,7514472,'sta',33.333,3),(682,7514485,7514472,'tat',33.333,3),(682,7514486,7514472,'ate',33.333,3),(682,7514487,7514484,'ena',20,2),(682,7514488,7514484,'nab',20,2),(682,7514489,7514484,'abl',20,2),(682,7514490,7514484,'ble',20,2),(682,7514491,7514484,'led',20,2),(682,7514492,7514487,'cac',33.333,2),(682,7514493,7514487,'ach',33.333,2),(682,7514494,7514487,'che',33.333,2),(682,7514495,7514492,'mod',50,1),(682,7514496,7514492,'ode',50,1),(682,7514497,7514495,'wri',14.286,1),(682,7514498,7514495,'rit',14.286,1),(682,7514499,7514495,'ite',14.286,1),(682,7514500,7514495,'tet',14.286,1),(682,7514501,7514495,'eth',14.286,1),(682,7514502,7514495,'thr',14.286,1),(682,7514503,7514495,'hru',14.286,1),(682,7514504,7514497,'ope',11.111,2),(682,7514505,7514497,'per',11.111,2),(682,7514506,7514497,'era',11.111,2),(682,7514507,7514497,'rat',11.111,2),(682,7514508,7514497,'ati',11.111,2),(682,7514509,7514497,'tio',11.111,2),(682,7514510,7514497,'ion',11.111,2),(682,7514511,7514497,'ona',11.111,2),(682,7514512,7514497,'nal',11.111,2),(682,7514513,7514504,'pen',20,1),(682,7514514,7514504,'end',20,1),(682,7514515,7514504,'ndi',20,1),(682,7514516,7514504,'din',20,1),(682,7514517,7514504,'ing',20,1),(682,7514518,7514513,'mes',20,1),(682,7514519,7514513,'ess',20,1),(682,7514520,7514513,'ssa',20,1),(682,7514521,7514513,'sag',20,1),(682,7514522,7514513,'age',20,1),(682,7514523,7514518,'wai',20,1),(682,7514524,7514518,'ait',20,1),(682,7514525,7514518,'iti',20,1),(682,7514526,7514518,'tin',20,1),(682,7514527,7514518,'ing',20,1),(682,7514528,7514523,'for',100,1),(682,7514529,7514528,'per',11.111,1),(682,7514530,7514528,'erf',11.111,1),(682,7514531,7514528,'rfo',11.111,1),(682,7514532,7514528,'for',11.111,1),(682,7514533,7514528,'orm',11.111,1),(682,7514534,7514528,'rma',11.111,1),(682,7514535,7514528,'man',11.111,1),(682,7514536,7514528,'anc',11.111,1),(682,7514537,7514528,'nce',11.111,1),(682,7514538,7514529,'ide',12.5,1),(682,7514539,7514529,'den',12.5,1),(682,7514540,7514529,'ent',12.5,1),(682,7514541,7514529,'nti',12.5,1),(682,7514542,7514529,'tif',12.5,1),(682,7514543,7514529,'ifi',12.5,1),(682,7514544,7514529,'fie',12.5,1),(682,7514545,7514529,'ier',12.5,1),(682,7514546,7514538,'vdi',33.333,3),(682,7514547,7514538,'dis',33.333,3),(682,7514548,7514538,'isk',33.333,3),(682,7514549,7514546,'nam',50,1),(682,7514550,7514546,'ame',50,1),(682,7514551,7514549,'typ',50,1),(682,7514552,7514549,'ype',50,1),(682,7514553,7514551,'dir',25,1),(682,7514554,7514551,'ire',25,1),(682,7514555,7514551,'rec',25,1),(682,7514556,7514551,'ect',25,1),(683,7514558,7514557,'naa',100,2),(683,7514559,7514558,'600',3.333,3),(683,7514560,7514558,'000',3.333,3),(683,7514561,7514558,'00c',3.333,3),(683,7514562,7514558,'0c2',3.333,3),(683,7514563,7514558,'c29',3.333,3),(683,7514564,7514558,'293',3.333,3),(683,7514565,7514558,'938',3.333,3),(683,7514566,7514558,'38c',3.333,3),(683,7514567,7514558,'8cc',3.333,3),(683,7514568,7514558,'cc1',3.333,3),(683,7514569,7514558,'c18',3.333,3),(683,7514570,7514558,'185',3.333,3),(683,7514571,7514558,'851',3.333,3),(683,7514572,7514558,'51b',3.333,3),(683,7514573,7514558,'1b4',3.333,3),(683,7514574,7514558,'b41',3.333,3),(683,7514575,7514558,'41a',3.333,3),(683,7514576,7514558,'1a5',3.333,3),(683,7514577,7514558,'a5b',3.333,3),(683,7514578,7514558,'5bb',3.333,3),(683,7514579,7514558,'bbb',3.333,3),(683,7514580,7514558,'bb9',3.333,3),(683,7514581,7514558,'b9c',3.333,3),(683,7514582,7514558,'9cd',3.333,3),(683,7514583,7514558,'cdd',3.333,3),(683,7514584,7514558,'dd4',3.333,3),(683,7514585,7514558,'d43',3.333,3),(683,7514586,7514558,'430',3.333,3),(683,7514587,7514558,'30d',3.333,3),(683,7514588,7514558,'0df',3.333,3),(683,7514589,7514559,'mon',100,1),(683,7514590,7514589,'201',50,1),(683,7514591,7514589,'013',50,1),(683,7514592,7514590,'adm',33.333,3),(683,7514593,7514590,'dmi',33.333,3),(683,7514594,7514590,'min',33.333,3),(683,7514595,7514592,'cap',16.667,1),(683,7514596,7514592,'apa',16.667,1),(683,7514597,7514592,'pac',16.667,1),(683,7514598,7514592,'aci',16.667,1),(683,7514599,7514592,'cit',16.667,1),(683,7514600,7514592,'ity',16.667,1),(683,7514601,7514595,'pat',50,1),(683,7514602,7514595,'ath',50,1),(683,7514603,7514601,'fre',14.286,1),(683,7514604,7514601,'ree',14.286,1),(683,7514605,7514601,'ees',14.286,1),(683,7514606,7514601,'esp',14.286,1),(683,7514607,7514601,'spa',14.286,1),(683,7514608,7514601,'pac',14.286,1),(683,7514609,7514601,'ace',14.286,1),(683,7514610,7514603,'dis',50,1),(683,7514611,7514603,'isk',50,1),(683,7514612,7514610,'ind',33.333,1),(683,7514613,7514610,'nde',33.333,1),(683,7514614,7514610,'dex',33.333,1),(683,7514615,7514612,'adm',8.333,1),(683,7514616,7514612,'dmi',8.333,1),(683,7514617,7514612,'min',8.333,1),(683,7514618,7514612,'ini',8.333,1),(683,7514619,7514612,'nis',8.333,1),(683,7514620,7514612,'ist',8.333,1),(683,7514621,7514612,'str',8.333,1),(683,7514622,7514612,'tra',8.333,1),(683,7514623,7514612,'rat',8.333,1),(683,7514624,7514612,'ati',8.333,1),(683,7514625,7514612,'tio',8.333,1),(683,7514626,7514612,'ion',8.333,1),(683,7514627,7514615,'sta',33.333,3),(683,7514628,7514615,'tat',33.333,3),(683,7514629,7514615,'ate',33.333,3),(683,7514630,7514627,'ena',20,2),(683,7514631,7514627,'nab',20,2),(683,7514632,7514627,'abl',20,2),(683,7514633,7514627,'ble',20,2),(683,7514634,7514627,'led',20,2),(683,7514635,7514630,'cac',33.333,2),(683,7514636,7514630,'ach',33.333,2),(683,7514637,7514630,'che',33.333,2),(683,7514638,7514635,'mod',50,1),(683,7514639,7514635,'ode',50,1),(683,7514640,7514638,'wri',14.286,1),(683,7514641,7514638,'rit',14.286,1),(683,7514642,7514638,'ite',14.286,1),(683,7514643,7514638,'tet',14.286,1),(683,7514644,7514638,'eth',14.286,1),(683,7514645,7514638,'thr',14.286,1),(683,7514646,7514638,'hru',14.286,1),(683,7514647,7514640,'ope',11.111,2),(683,7514648,7514640,'per',11.111,2),(683,7514649,7514640,'era',11.111,2),(683,7514650,7514640,'rat',11.111,2),(683,7514651,7514640,'ati',11.111,2),(683,7514652,7514640,'tio',11.111,2),(683,7514653,7514640,'ion',11.111,2),(683,7514654,7514640,'ona',11.111,2),(683,7514655,7514640,'nal',11.111,2),(683,7514656,7514647,'pen',20,1),(683,7514657,7514647,'end',20,1),(683,7514658,7514647,'ndi',20,1),(683,7514659,7514647,'din',20,1),(683,7514660,7514647,'ing',20,1),(683,7514661,7514656,'mes',20,1),(683,7514662,7514656,'ess',20,1),(683,7514663,7514656,'ssa',20,1),(683,7514664,7514656,'sag',20,1),(683,7514665,7514656,'age',20,1),(683,7514666,7514661,'wai',20,1),(683,7514667,7514661,'ait',20,1),(683,7514668,7514661,'iti',20,1),(683,7514669,7514661,'tin',20,1),(683,7514670,7514661,'ing',20,1),(683,7514671,7514666,'for',100,1),(683,7514672,7514671,'per',11.111,1),(683,7514673,7514671,'erf',11.111,1),(683,7514674,7514671,'rfo',11.111,1),(683,7514675,7514671,'for',11.111,1),(683,7514676,7514671,'orm',11.111,1),(683,7514677,7514671,'rma',11.111,1),(683,7514678,7514671,'man',11.111,1),(683,7514679,7514671,'anc',11.111,1),(683,7514680,7514671,'nce',11.111,1),(683,7514681,7514672,'ide',12.5,1),(683,7514682,7514672,'den',12.5,1),(683,7514683,7514672,'ent',12.5,1),(683,7514684,7514672,'nti',12.5,1),(683,7514685,7514672,'tif',12.5,1),(683,7514686,7514672,'ifi',12.5,1),(683,7514687,7514672,'fie',12.5,1),(683,7514688,7514672,'ier',12.5,1),(683,7514689,7514681,'vdi',33.333,3),(683,7514690,7514681,'dis',33.333,3),(683,7514691,7514681,'isk',33.333,3),(683,7514692,7514689,'nam',50,1),(683,7514693,7514689,'ame',50,1),(683,7514694,7514692,'typ',50,1),(683,7514695,7514692,'ype',50,1),(683,7514696,7514694,'dir',25,1),(683,7514697,7514694,'ire',25,1),(683,7514698,7514694,'rec',25,1),(683,7514699,7514694,'ect',25,1),(684,7514701,7514700,'naa',100,2),(684,7514702,7514701,'600',3.333,3),(684,7514703,7514701,'000',3.333,3),(684,7514704,7514701,'00c',3.333,3),(684,7514705,7514701,'0c2',3.333,3),(684,7514706,7514701,'c29',3.333,3),(684,7514707,7514701,'29f',3.333,3),(684,7514708,7514701,'9f0',3.333,3),(684,7514709,7514701,'f03',3.333,3),(684,7514710,7514701,'035',3.333,3),(684,7514711,7514701,'353',3.333,3),(684,7514712,7514701,'535',3.333,3),(684,7514713,7514701,'358',3.333,3),(684,7514714,7514701,'58f',3.333,3),(684,7514715,7514701,'8fb',3.333,3),(684,7514716,7514701,'fbf',3.333,3),(684,7514717,7514701,'bf3',3.333,3),(684,7514718,7514701,'f3c',3.333,3),(684,7514719,7514701,'3c6',3.333,3),(684,7514720,7514701,'c60',3.333,3),(684,7514721,7514701,'60d',3.333,3),(684,7514722,7514701,'0d3',3.333,3),(684,7514723,7514701,'d36',3.333,3),(684,7514724,7514701,'368',3.333,3),(684,7514725,7514701,'689',3.333,3),(684,7514726,7514701,'899',3.333,3),(684,7514727,7514701,'996',3.333,3),(684,7514728,7514701,'963',3.333,3),(684,7514729,7514701,'639',3.333,3),(684,7514730,7514701,'396',3.333,3),(684,7514731,7514701,'96a',3.333,3),(684,7514732,7514702,'mon',100,1),(684,7514733,7514732,'201',50,1),(684,7514734,7514732,'013',50,1),(684,7514735,7514733,'adm',33.333,3),(684,7514736,7514733,'dmi',33.333,3),(684,7514737,7514733,'min',33.333,3),(684,7514738,7514735,'cap',16.667,1),(684,7514739,7514735,'apa',16.667,1),(684,7514740,7514735,'pac',16.667,1),(684,7514741,7514735,'aci',16.667,1),(684,7514742,7514735,'cit',16.667,1),(684,7514743,7514735,'ity',16.667,1),(684,7514744,7514738,'pat',50,1),(684,7514745,7514738,'ath',50,1),(684,7514746,7514744,'fre',14.286,1),(684,7514747,7514744,'ree',14.286,1),(684,7514748,7514744,'ees',14.286,1),(684,7514749,7514744,'esp',14.286,1),(684,7514750,7514744,'spa',14.286,1),(684,7514751,7514744,'pac',14.286,1),(684,7514752,7514744,'ace',14.286,1),(684,7514753,7514746,'dis',50,1),(684,7514754,7514746,'isk',50,1),(684,7514755,7514753,'ind',33.333,1),(684,7514756,7514753,'nde',33.333,1),(684,7514757,7514753,'dex',33.333,1),(684,7514758,7514755,'adm',8.333,1),(684,7514759,7514755,'dmi',8.333,1),(684,7514760,7514755,'min',8.333,1),(684,7514761,7514755,'ini',8.333,1),(684,7514762,7514755,'nis',8.333,1),(684,7514763,7514755,'ist',8.333,1),(684,7514764,7514755,'str',8.333,1),(684,7514765,7514755,'tra',8.333,1),(684,7514766,7514755,'rat',8.333,1),(684,7514767,7514755,'ati',8.333,1),(684,7514768,7514755,'tio',8.333,1),(684,7514769,7514755,'ion',8.333,1),(684,7514770,7514758,'sta',33.333,3),(684,7514771,7514758,'tat',33.333,3),(684,7514772,7514758,'ate',33.333,3),(684,7514773,7514770,'ena',20,2),(684,7514774,7514770,'nab',20,2),(684,7514775,7514770,'abl',20,2),(684,7514776,7514770,'ble',20,2),(684,7514777,7514770,'led',20,2),(684,7514778,7514773,'cac',33.333,2),(684,7514779,7514773,'ach',33.333,2),(684,7514780,7514773,'che',33.333,2),(684,7514781,7514778,'mod',50,1),(684,7514782,7514778,'ode',50,1),(684,7514783,7514781,'wri',14.286,1),(684,7514784,7514781,'rit',14.286,1),(684,7514785,7514781,'ite',14.286,1),(684,7514786,7514781,'tet',14.286,1),(684,7514787,7514781,'eth',14.286,1),(684,7514788,7514781,'thr',14.286,1),(684,7514789,7514781,'hru',14.286,1),(684,7514790,7514783,'ope',11.111,2),(684,7514791,7514783,'per',11.111,2),(684,7514792,7514783,'era',11.111,2),(684,7514793,7514783,'rat',11.111,2),(684,7514794,7514783,'ati',11.111,2),(684,7514795,7514783,'tio',11.111,2),(684,7514796,7514783,'ion',11.111,2),(684,7514797,7514783,'ona',11.111,2),(684,7514798,7514783,'nal',11.111,2),(684,7514799,7514790,'pen',20,1),(684,7514800,7514790,'end',20,1),(684,7514801,7514790,'ndi',20,1),(684,7514802,7514790,'din',20,1),(684,7514803,7514790,'ing',20,1),(684,7514804,7514799,'mes',20,1),(684,7514805,7514799,'ess',20,1),(684,7514806,7514799,'ssa',20,1),(684,7514807,7514799,'sag',20,1),(684,7514808,7514799,'age',20,1),(684,7514809,7514804,'wai',20,1),(684,7514810,7514804,'ait',20,1),(684,7514811,7514804,'iti',20,1),(684,7514812,7514804,'tin',20,1),(684,7514813,7514804,'ing',20,1),(684,7514814,7514809,'for',100,1),(684,7514815,7514814,'per',11.111,1),(684,7514816,7514814,'erf',11.111,1),(684,7514817,7514814,'rfo',11.111,1),(684,7514818,7514814,'for',11.111,1),(684,7514819,7514814,'orm',11.111,1),(684,7514820,7514814,'rma',11.111,1),(684,7514821,7514814,'man',11.111,1),(684,7514822,7514814,'anc',11.111,1),(684,7514823,7514814,'nce',11.111,1),(684,7514824,7514815,'ide',12.5,1),(684,7514825,7514815,'den',12.5,1),(684,7514826,7514815,'ent',12.5,1),(684,7514827,7514815,'nti',12.5,1),(684,7514828,7514815,'tif',12.5,1),(684,7514829,7514815,'ifi',12.5,1),(684,7514830,7514815,'fie',12.5,1),(684,7514831,7514815,'ier',12.5,1),(684,7514832,7514824,'vdi',33.333,3),(684,7514833,7514824,'dis',33.333,3),(684,7514834,7514824,'isk',33.333,3),(684,7514835,7514832,'nam',50,1),(684,7514836,7514832,'ame',50,1),(684,7514837,7514835,'typ',50,1),(684,7514838,7514835,'ype',50,1),(684,7514839,7514837,'dir',25,1),(684,7514840,7514837,'ire',25,1),(684,7514841,7514837,'rec',25,1),(684,7514842,7514837,'ect',25,1),(685,7514844,7514843,'naa',100,2),(685,7514845,7514844,'600',3.333,3),(685,7514846,7514844,'000',3.333,3),(685,7514847,7514844,'00c',3.333,3),(685,7514848,7514844,'0c2',3.333,3),(685,7514849,7514844,'c29',3.333,3),(685,7514850,7514844,'299',3.333,3),(685,7514851,7514844,'99b',3.333,3),(685,7514852,7514844,'9bc',3.333,3),(685,7514853,7514844,'bcf',3.333,3),(685,7514854,7514844,'cfa',3.333,3),(685,7514855,7514844,'fa1',3.333,3),(685,7514856,7514844,'a1e',3.333,3),(685,7514857,7514844,'1e2',3.333,3),(685,7514858,7514844,'e2d',3.333,3),(685,7514859,7514844,'2dc',3.333,3),(685,7514860,7514844,'dca',3.333,3),(685,7514861,7514844,'ca1',3.333,3),(685,7514862,7514844,'a1c',3.333,3),(685,7514863,7514844,'1c1',3.333,3),(685,7514864,7514844,'c12',3.333,3),(685,7514865,7514844,'12a',3.333,3),(685,7514866,7514844,'2a2',3.333,3),(685,7514867,7514844,'a24',3.333,3),(685,7514868,7514844,'246',3.333,3),(685,7514869,7514844,'46b',3.333,3),(685,7514870,7514844,'6bb',3.333,3),(685,7514871,7514844,'bb3',3.333,3),(685,7514872,7514844,'b38',3.333,3),(685,7514873,7514844,'38b',3.333,3),(685,7514874,7514844,'8b3',3.333,3),(685,7514875,7514845,'mon',100,1),(685,7514876,7514875,'201',50,1),(685,7514877,7514875,'013',50,1),(685,7514878,7514876,'adm',33.333,3),(685,7514879,7514876,'dmi',33.333,3),(685,7514880,7514876,'min',33.333,3),(685,7514881,7514878,'cap',16.667,1),(685,7514882,7514878,'apa',16.667,1),(685,7514883,7514878,'pac',16.667,1),(685,7514884,7514878,'aci',16.667,1),(685,7514885,7514878,'cit',16.667,1),(685,7514886,7514878,'ity',16.667,1),(685,7514887,7514881,'pat',50,1),(685,7514888,7514881,'ath',50,1),(685,7514889,7514887,'fre',14.286,1),(685,7514890,7514887,'ree',14.286,1),(685,7514891,7514887,'ees',14.286,1),(685,7514892,7514887,'esp',14.286,1),(685,7514893,7514887,'spa',14.286,1),(685,7514894,7514887,'pac',14.286,1),(685,7514895,7514887,'ace',14.286,1),(685,7514896,7514889,'dis',50,1),(685,7514897,7514889,'isk',50,1),(685,7514898,7514896,'ind',33.333,1),(685,7514899,7514896,'nde',33.333,1),(685,7514900,7514896,'dex',33.333,1),(685,7514901,7514898,'adm',8.333,1),(685,7514902,7514898,'dmi',8.333,1),(685,7514903,7514898,'min',8.333,1),(685,7514904,7514898,'ini',8.333,1),(685,7514905,7514898,'nis',8.333,1),(685,7514906,7514898,'ist',8.333,1),(685,7514907,7514898,'str',8.333,1),(685,7514908,7514898,'tra',8.333,1),(685,7514909,7514898,'rat',8.333,1),(685,7514910,7514898,'ati',8.333,1),(685,7514911,7514898,'tio',8.333,1),(685,7514912,7514898,'ion',8.333,1),(685,7514913,7514901,'sta',33.333,3),(685,7514914,7514901,'tat',33.333,3),(685,7514915,7514901,'ate',33.333,3),(685,7514916,7514913,'ena',20,2),(685,7514917,7514913,'nab',20,2),(685,7514918,7514913,'abl',20,2),(685,7514919,7514913,'ble',20,2),(685,7514920,7514913,'led',20,2),(685,7514921,7514916,'cac',33.333,2),(685,7514922,7514916,'ach',33.333,2),(685,7514923,7514916,'che',33.333,2),(685,7514924,7514921,'mod',50,1),(685,7514925,7514921,'ode',50,1),(685,7514926,7514924,'wri',14.286,1),(685,7514927,7514924,'rit',14.286,1),(685,7514928,7514924,'ite',14.286,1),(685,7514929,7514924,'tet',14.286,1),(685,7514930,7514924,'eth',14.286,1),(685,7514931,7514924,'thr',14.286,1),(685,7514932,7514924,'hru',14.286,1),(685,7514933,7514926,'ope',11.111,2),(685,7514934,7514926,'per',11.111,2),(685,7514935,7514926,'era',11.111,2),(685,7514936,7514926,'rat',11.111,2),(685,7514937,7514926,'ati',11.111,2),(685,7514938,7514926,'tio',11.111,2),(685,7514939,7514926,'ion',11.111,2),(685,7514940,7514926,'ona',11.111,2),(685,7514941,7514926,'nal',11.111,2),(685,7514942,7514933,'pen',20,1),(685,7514943,7514933,'end',20,1),(685,7514944,7514933,'ndi',20,1),(685,7514945,7514933,'din',20,1),(685,7514946,7514933,'ing',20,1),(685,7514947,7514942,'mes',20,1),(685,7514948,7514942,'ess',20,1),(685,7514949,7514942,'ssa',20,1),(685,7514950,7514942,'sag',20,1),(685,7514951,7514942,'age',20,1),(685,7514952,7514947,'wai',20,1),(685,7514953,7514947,'ait',20,1),(685,7514954,7514947,'iti',20,1),(685,7514955,7514947,'tin',20,1),(685,7514956,7514947,'ing',20,1),(685,7514957,7514952,'for',100,1),(685,7514958,7514957,'per',11.111,1),(685,7514959,7514957,'erf',11.111,1),(685,7514960,7514957,'rfo',11.111,1),(685,7514961,7514957,'for',11.111,1),(685,7514962,7514957,'orm',11.111,1),(685,7514963,7514957,'rma',11.111,1),(685,7514964,7514957,'man',11.111,1),(685,7514965,7514957,'anc',11.111,1),(685,7514966,7514957,'nce',11.111,1),(685,7514967,7514958,'ide',12.5,1),(685,7514968,7514958,'den',12.5,1),(685,7514969,7514958,'ent',12.5,1),(685,7514970,7514958,'nti',12.5,1),(685,7514971,7514958,'tif',12.5,1),(685,7514972,7514958,'ifi',12.5,1),(685,7514973,7514958,'fie',12.5,1),(685,7514974,7514958,'ier',12.5,1),(685,7514975,7514967,'vdi',33.333,3),(685,7514976,7514967,'dis',33.333,3),(685,7514977,7514967,'isk',33.333,3),(685,7514978,7514975,'nam',50,1),(685,7514979,7514975,'ame',50,1),(685,7514980,7514978,'typ',50,1),(685,7514981,7514978,'ype',50,1),(685,7514982,7514980,'dir',25,1),(685,7514983,7514980,'ire',25,1),(685,7514984,7514980,'rec',25,1),(685,7514985,7514980,'ect',25,1),(686,7514987,7514986,'naa',100,2),(686,7514988,7514987,'600',3.333,3),(686,7514989,7514987,'000',3.333,3),(686,7514990,7514987,'00c',3.333,3),(686,7514991,7514987,'0c2',3.333,3),(686,7514992,7514987,'c29',3.333,3),(686,7514993,7514987,'293',3.333,3),(686,7514994,7514987,'93f',3.333,3),(686,7514995,7514987,'3fb',3.333,3),(686,7514996,7514987,'fb3',3.333,3),(686,7514997,7514987,'b36',3.333,3),(686,7514998,7514987,'36e',3.333,3),(686,7514999,7514987,'6e8',3.333,3),(686,7515000,7514987,'e8a',3.333,3),(686,7515001,7514987,'8a0',3.333,3),(686,7515002,7514987,'a07',3.333,3),(686,7515003,7514987,'077',3.333,3),(686,7515004,7514987,'775',3.333,3),(686,7515005,7514987,'75b',3.333,3),(686,7515006,7514987,'5b9',3.333,3),(686,7515007,7514987,'b9c',3.333,3),(686,7515008,7514987,'9cb',3.333,3),(686,7515009,7514987,'cbb',3.333,3),(686,7515010,7514987,'bbe',3.333,3),(686,7515011,7514987,'be1',3.333,3),(686,7515012,7514987,'e11',3.333,3),(686,7515013,7514987,'11b',3.333,3),(686,7515014,7514987,'1b6',3.333,3),(686,7515015,7514987,'b63',3.333,3),(686,7515016,7514987,'630',3.333,3),(686,7515017,7514987,'305',3.333,3),(686,7515018,7514988,'mon',100,1),(686,7515019,7515018,'201',50,1),(686,7515020,7515018,'013',50,1),(686,7515021,7515019,'adm',33.333,3),(686,7515022,7515019,'dmi',33.333,3),(686,7515023,7515019,'min',33.333,3),(686,7515024,7515021,'cap',16.667,1),(686,7515025,7515021,'apa',16.667,1),(686,7515026,7515021,'pac',16.667,1),(686,7515027,7515021,'aci',16.667,1),(686,7515028,7515021,'cit',16.667,1),(686,7515029,7515021,'ity',16.667,1),(686,7515030,7515024,'pat',50,1),(686,7515031,7515024,'ath',50,1),(686,7515032,7515030,'fre',14.286,1),(686,7515033,7515030,'ree',14.286,1),(686,7515034,7515030,'ees',14.286,1),(686,7515035,7515030,'esp',14.286,1),(686,7515036,7515030,'spa',14.286,1),(686,7515037,7515030,'pac',14.286,1),(686,7515038,7515030,'ace',14.286,1),(686,7515039,7515032,'dis',50,1),(686,7515040,7515032,'isk',50,1),(686,7515041,7515039,'ind',33.333,1),(686,7515042,7515039,'nde',33.333,1),(686,7515043,7515039,'dex',33.333,1),(686,7515044,7515041,'adm',8.333,1),(686,7515045,7515041,'dmi',8.333,1),(686,7515046,7515041,'min',8.333,1),(686,7515047,7515041,'ini',8.333,1),(686,7515048,7515041,'nis',8.333,1),(686,7515049,7515041,'ist',8.333,1),(686,7515050,7515041,'str',8.333,1),(686,7515051,7515041,'tra',8.333,1),(686,7515052,7515041,'rat',8.333,1),(686,7515053,7515041,'ati',8.333,1),(686,7515054,7515041,'tio',8.333,1),(686,7515055,7515041,'ion',8.333,1),(686,7515056,7515044,'sta',33.333,3),(686,7515057,7515044,'tat',33.333,3),(686,7515058,7515044,'ate',33.333,3),(686,7515059,7515056,'ena',20,2),(686,7515060,7515056,'nab',20,2),(686,7515061,7515056,'abl',20,2),(686,7515062,7515056,'ble',20,2),(686,7515063,7515056,'led',20,2),(686,7515064,7515059,'cac',33.333,2),(686,7515065,7515059,'ach',33.333,2),(686,7515066,7515059,'che',33.333,2),(686,7515067,7515064,'mod',50,1),(686,7515068,7515064,'ode',50,1),(686,7515069,7515067,'wri',14.286,1),(686,7515070,7515067,'rit',14.286,1),(686,7515071,7515067,'ite',14.286,1),(686,7515072,7515067,'tet',14.286,1),(686,7515073,7515067,'eth',14.286,1),(686,7515074,7515067,'thr',14.286,1),(686,7515075,7515067,'hru',14.286,1),(686,7515076,7515069,'ope',11.111,2),(686,7515077,7515069,'per',11.111,2),(686,7515078,7515069,'era',11.111,2),(686,7515079,7515069,'rat',11.111,2),(686,7515080,7515069,'ati',11.111,2),(686,7515081,7515069,'tio',11.111,2),(686,7515082,7515069,'ion',11.111,2),(686,7515083,7515069,'ona',11.111,2),(686,7515084,7515069,'nal',11.111,2),(686,7515085,7515076,'pen',20,1),(686,7515086,7515076,'end',20,1),(686,7515087,7515076,'ndi',20,1),(686,7515088,7515076,'din',20,1),(686,7515089,7515076,'ing',20,1),(686,7515090,7515085,'mes',20,1),(686,7515091,7515085,'ess',20,1),(686,7515092,7515085,'ssa',20,1),(686,7515093,7515085,'sag',20,1),(686,7515094,7515085,'age',20,1),(686,7515095,7515090,'wai',20,1),(686,7515096,7515090,'ait',20,1),(686,7515097,7515090,'iti',20,1),(686,7515098,7515090,'tin',20,1),(686,7515099,7515090,'ing',20,1),(686,7515100,7515095,'for',100,1),(686,7515101,7515100,'per',11.111,1),(686,7515102,7515100,'erf',11.111,1),(686,7515103,7515100,'rfo',11.111,1),(686,7515104,7515100,'for',11.111,1),(686,7515105,7515100,'orm',11.111,1),(686,7515106,7515100,'rma',11.111,1),(686,7515107,7515100,'man',11.111,1),(686,7515108,7515100,'anc',11.111,1),(686,7515109,7515100,'nce',11.111,1),(686,7515110,7515101,'ide',12.5,1),(686,7515111,7515101,'den',12.5,1),(686,7515112,7515101,'ent',12.5,1),(686,7515113,7515101,'nti',12.5,1),(686,7515114,7515101,'tif',12.5,1),(686,7515115,7515101,'ifi',12.5,1),(686,7515116,7515101,'fie',12.5,1),(686,7515117,7515101,'ier',12.5,1),(686,7515118,7515110,'vdi',33.333,3),(686,7515119,7515110,'dis',33.333,3),(686,7515120,7515110,'isk',33.333,3),(686,7515121,7515118,'nam',50,1),(686,7515122,7515118,'ame',50,1),(686,7515123,7515121,'typ',50,1),(686,7515124,7515121,'ype',50,1),(686,7515125,7515123,'dir',25,1),(686,7515126,7515123,'ire',25,1),(686,7515127,7515123,'rec',25,1),(686,7515128,7515123,'ect',25,1),(687,7515130,7515129,'naa',100,2),(687,7515131,7515130,'600',3.333,3),(687,7515132,7515130,'000',3.333,3),(687,7515133,7515130,'00c',3.333,3),(687,7515134,7515130,'0c2',3.333,3),(687,7515135,7515130,'c29',3.333,3),(687,7515136,7515130,'29f',3.333,3),(687,7515137,7515130,'9f7',3.333,3),(687,7515138,7515130,'f7c',3.333,3),(687,7515139,7515130,'7ce',3.333,3),(687,7515140,7515130,'ce0',3.333,3),(687,7515141,7515130,'e0c',3.333,3),(687,7515142,7515130,'0c9',3.333,3),(687,7515143,7515130,'c90',3.333,3),(687,7515144,7515130,'905',3.333,3),(687,7515145,7515130,'052',3.333,3),(687,7515146,7515130,'52b',3.333,3),(687,7515147,7515130,'2b7',3.333,3),(687,7515148,7515130,'b74',3.333,3),(687,7515149,7515130,'746',3.333,3),(687,7515150,7515130,'461',3.333,3),(687,7515151,7515130,'61c',3.333,3),(687,7515152,7515130,'1c1',3.333,3),(687,7515153,7515130,'c1a',3.333,3),(687,7515154,7515130,'1a1',3.333,3),(687,7515155,7515130,'a10',3.333,3),(687,7515156,7515130,'108',3.333,3),(687,7515157,7515130,'08d',3.333,3),(687,7515158,7515130,'8d7',3.333,3),(687,7515159,7515130,'d71',3.333,3),(687,7515160,7515130,'71f',3.333,3),(687,7515161,7515131,'mon',100,1),(687,7515162,7515161,'201',50,1),(687,7515163,7515161,'013',50,1),(687,7515164,7515162,'adm',33.333,3),(687,7515165,7515162,'dmi',33.333,3),(687,7515166,7515162,'min',33.333,3),(687,7515167,7515164,'cap',16.667,1),(687,7515168,7515164,'apa',16.667,1),(687,7515169,7515164,'pac',16.667,1),(687,7515170,7515164,'aci',16.667,1),(687,7515171,7515164,'cit',16.667,1),(687,7515172,7515164,'ity',16.667,1),(687,7515173,7515167,'pat',50,1),(687,7515174,7515167,'ath',50,1),(687,7515175,7515173,'fre',14.286,1),(687,7515176,7515173,'ree',14.286,1),(687,7515177,7515173,'ees',14.286,1),(687,7515178,7515173,'esp',14.286,1),(687,7515179,7515173,'spa',14.286,1),(687,7515180,7515173,'pac',14.286,1),(687,7515181,7515173,'ace',14.286,1),(687,7515182,7515175,'dis',50,1),(687,7515183,7515175,'isk',50,1),(687,7515184,7515182,'ind',33.333,1),(687,7515185,7515182,'nde',33.333,1),(687,7515186,7515182,'dex',33.333,1),(687,7515187,7515184,'adm',8.333,1),(687,7515188,7515184,'dmi',8.333,1),(687,7515189,7515184,'min',8.333,1),(687,7515190,7515184,'ini',8.333,1),(687,7515191,7515184,'nis',8.333,1),(687,7515192,7515184,'ist',8.333,1),(687,7515193,7515184,'str',8.333,1),(687,7515194,7515184,'tra',8.333,1),(687,7515195,7515184,'rat',8.333,1),(687,7515196,7515184,'ati',8.333,1),(687,7515197,7515184,'tio',8.333,1),(687,7515198,7515184,'ion',8.333,1),(687,7515199,7515187,'sta',33.333,3),(687,7515200,7515187,'tat',33.333,3),(687,7515201,7515187,'ate',33.333,3),(687,7515202,7515199,'ena',20,2),(687,7515203,7515199,'nab',20,2),(687,7515204,7515199,'abl',20,2),(687,7515205,7515199,'ble',20,2),(687,7515206,7515199,'led',20,2),(687,7515207,7515202,'cac',33.333,2),(687,7515208,7515202,'ach',33.333,2),(687,7515209,7515202,'che',33.333,2),(687,7515210,7515207,'mod',50,1),(687,7515211,7515207,'ode',50,1),(687,7515212,7515210,'wri',14.286,1),(687,7515213,7515210,'rit',14.286,1),(687,7515214,7515210,'ite',14.286,1),(687,7515215,7515210,'tet',14.286,1),(687,7515216,7515210,'eth',14.286,1),(687,7515217,7515210,'thr',14.286,1),(687,7515218,7515210,'hru',14.286,1),(687,7515219,7515212,'ope',11.111,2),(687,7515220,7515212,'per',11.111,2),(687,7515221,7515212,'era',11.111,2),(687,7515222,7515212,'rat',11.111,2),(687,7515223,7515212,'ati',11.111,2),(687,7515224,7515212,'tio',11.111,2),(687,7515225,7515212,'ion',11.111,2),(687,7515226,7515212,'ona',11.111,2),(687,7515227,7515212,'nal',11.111,2),(687,7515228,7515219,'pen',20,1),(687,7515229,7515219,'end',20,1),(687,7515230,7515219,'ndi',20,1),(687,7515231,7515219,'din',20,1),(687,7515232,7515219,'ing',20,1),(687,7515233,7515228,'mes',20,1),(687,7515234,7515228,'ess',20,1),(687,7515235,7515228,'ssa',20,1),(687,7515236,7515228,'sag',20,1),(687,7515237,7515228,'age',20,1),(687,7515238,7515233,'wai',20,1),(687,7515239,7515233,'ait',20,1),(687,7515240,7515233,'iti',20,1),(687,7515241,7515233,'tin',20,1),(687,7515242,7515233,'ing',20,1),(687,7515243,7515238,'for',100,1),(687,7515244,7515243,'per',11.111,1),(687,7515245,7515243,'erf',11.111,1),(687,7515246,7515243,'rfo',11.111,1),(687,7515247,7515243,'for',11.111,1),(687,7515248,7515243,'orm',11.111,1),(687,7515249,7515243,'rma',11.111,1),(687,7515250,7515243,'man',11.111,1),(687,7515251,7515243,'anc',11.111,1),(687,7515252,7515243,'nce',11.111,1),(687,7515253,7515244,'ide',12.5,1),(687,7515254,7515244,'den',12.5,1),(687,7515255,7515244,'ent',12.5,1),(687,7515256,7515244,'nti',12.5,1),(687,7515257,7515244,'tif',12.5,1),(687,7515258,7515244,'ifi',12.5,1),(687,7515259,7515244,'fie',12.5,1),(687,7515260,7515244,'ier',12.5,1),(687,7515261,7515253,'vdi',33.333,3),(687,7515262,7515253,'dis',33.333,3),(687,7515263,7515253,'isk',33.333,3),(687,7515264,7515261,'nam',50,1),(687,7515265,7515261,'ame',50,1),(687,7515266,7515264,'typ',50,1),(687,7515267,7515264,'ype',50,1),(687,7515268,7515266,'dir',25,1),(687,7515269,7515266,'ire',25,1),(687,7515270,7515266,'rec',25,1),(687,7515271,7515266,'ect',25,1),(688,7515273,7515272,'naa',100,2),(688,7515274,7515273,'600',3.333,3),(688,7515275,7515273,'000',3.333,3),(688,7515276,7515273,'00c',3.333,3),(688,7515277,7515273,'0c2',3.333,3),(688,7515278,7515273,'c29',3.333,3),(688,7515279,7515273,'29f',3.333,3),(688,7515280,7515273,'9f1',3.333,3),(688,7515281,7515273,'f17',3.333,3),(688,7515282,7515273,'173',3.333,3),(688,7515283,7515273,'731',3.333,3),(688,7515284,7515273,'314',3.333,3),(688,7515285,7515273,'142',3.333,3),(688,7515286,7515273,'425',3.333,3),(688,7515287,7515273,'252',3.333,3),(688,7515288,7515273,'521',3.333,3),(688,7515289,7515273,'21d',3.333,3),(688,7515290,7515273,'1d0',3.333,3),(688,7515291,7515273,'d0b',3.333,3),(688,7515292,7515273,'0b6',3.333,3),(688,7515293,7515273,'b6d',3.333,3),(688,7515294,7515273,'6de',3.333,3),(688,7515295,7515273,'dee',3.333,3),(688,7515296,7515273,'eed',3.333,3),(688,7515297,7515273,'ed7',3.333,3),(688,7515298,7515273,'d79',3.333,3),(688,7515299,7515273,'795',3.333,3),(688,7515300,7515273,'956',3.333,3),(688,7515301,7515273,'560',3.333,3),(688,7515302,7515273,'609',3.333,3),(688,7515303,7515273,'09d',3.333,3),(688,7515304,7515274,'mon',100,1),(688,7515305,7515304,'201',50,1),(688,7515306,7515304,'013',50,1),(688,7515307,7515305,'adm',33.333,3),(688,7515308,7515305,'dmi',33.333,3),(688,7515309,7515305,'min',33.333,3),(688,7515310,7515307,'cap',16.667,1),(688,7515311,7515307,'apa',16.667,1),(688,7515312,7515307,'pac',16.667,1),(688,7515313,7515307,'aci',16.667,1),(688,7515314,7515307,'cit',16.667,1),(688,7515315,7515307,'ity',16.667,1),(688,7515316,7515310,'pat',50,1),(688,7515317,7515310,'ath',50,1),(688,7515318,7515316,'fre',14.286,1),(688,7515319,7515316,'ree',14.286,1),(688,7515320,7515316,'ees',14.286,1),(688,7515321,7515316,'esp',14.286,1),(688,7515322,7515316,'spa',14.286,1),(688,7515323,7515316,'pac',14.286,1),(688,7515324,7515316,'ace',14.286,1),(688,7515325,7515318,'dis',50,1),(688,7515326,7515318,'isk',50,1),(688,7515327,7515325,'ind',33.333,1),(688,7515328,7515325,'nde',33.333,1),(688,7515329,7515325,'dex',33.333,1),(688,7515330,7515327,'adm',8.333,1),(688,7515331,7515327,'dmi',8.333,1),(688,7515332,7515327,'min',8.333,1),(688,7515333,7515327,'ini',8.333,1),(688,7515334,7515327,'nis',8.333,1),(688,7515335,7515327,'ist',8.333,1),(688,7515336,7515327,'str',8.333,1),(688,7515337,7515327,'tra',8.333,1),(688,7515338,7515327,'rat',8.333,1),(688,7515339,7515327,'ati',8.333,1),(688,7515340,7515327,'tio',8.333,1),(688,7515341,7515327,'ion',8.333,1),(688,7515342,7515330,'sta',33.333,3),(688,7515343,7515330,'tat',33.333,3),(688,7515344,7515330,'ate',33.333,3),(688,7515345,7515342,'ena',20,2),(688,7515346,7515342,'nab',20,2),(688,7515347,7515342,'abl',20,2),(688,7515348,7515342,'ble',20,2),(688,7515349,7515342,'led',20,2),(688,7515350,7515345,'cac',33.333,2),(688,7515351,7515345,'ach',33.333,2),(688,7515352,7515345,'che',33.333,2),(688,7515353,7515350,'mod',50,1),(688,7515354,7515350,'ode',50,1),(688,7515355,7515353,'wri',14.286,1),(688,7515356,7515353,'rit',14.286,1),(688,7515357,7515353,'ite',14.286,1),(688,7515358,7515353,'tet',14.286,1),(688,7515359,7515353,'eth',14.286,1),(688,7515360,7515353,'thr',14.286,1),(688,7515361,7515353,'hru',14.286,1),(688,7515362,7515355,'ope',11.111,2),(688,7515363,7515355,'per',11.111,2),(688,7515364,7515355,'era',11.111,2),(688,7515365,7515355,'rat',11.111,2),(688,7515366,7515355,'ati',11.111,2),(688,7515367,7515355,'tio',11.111,2),(688,7515368,7515355,'ion',11.111,2),(688,7515369,7515355,'ona',11.111,2),(688,7515370,7515355,'nal',11.111,2),(688,7515371,7515362,'pen',20,1),(688,7515372,7515362,'end',20,1),(688,7515373,7515362,'ndi',20,1),(688,7515374,7515362,'din',20,1),(688,7515375,7515362,'ing',20,1),(688,7515376,7515371,'mes',20,1),(688,7515377,7515371,'ess',20,1),(688,7515378,7515371,'ssa',20,1),(688,7515379,7515371,'sag',20,1),(688,7515380,7515371,'age',20,1),(688,7515381,7515376,'wai',20,1),(688,7515382,7515376,'ait',20,1),(688,7515383,7515376,'iti',20,1),(688,7515384,7515376,'tin',20,1),(688,7515385,7515376,'ing',20,1),(688,7515386,7515381,'for',100,1),(688,7515387,7515386,'per',11.111,1),(688,7515388,7515386,'erf',11.111,1),(688,7515389,7515386,'rfo',11.111,1),(688,7515390,7515386,'for',11.111,1),(688,7515391,7515386,'orm',11.111,1),(688,7515392,7515386,'rma',11.111,1),(688,7515393,7515386,'man',11.111,1),(688,7515394,7515386,'anc',11.111,1),(688,7515395,7515386,'nce',11.111,1),(688,7515396,7515387,'ide',12.5,1),(688,7515397,7515387,'den',12.5,1),(688,7515398,7515387,'ent',12.5,1),(688,7515399,7515387,'nti',12.5,1),(688,7515400,7515387,'tif',12.5,1),(688,7515401,7515387,'ifi',12.5,1),(688,7515402,7515387,'fie',12.5,1),(688,7515403,7515387,'ier',12.5,1),(688,7515404,7515396,'vdi',33.333,3),(688,7515405,7515396,'dis',33.333,3),(688,7515406,7515396,'isk',33.333,3),(688,7515407,7515404,'nam',50,1),(688,7515408,7515404,'ame',50,1),(688,7515409,7515407,'typ',50,1),(688,7515410,7515407,'ype',50,1),(688,7515411,7515409,'dir',25,1),(688,7515412,7515409,'ire',25,1),(688,7515413,7515409,'rec',25,1),(688,7515414,7515409,'ect',25,1),(689,7515416,7515415,'naa',100,2),(689,7515417,7515416,'600',3.333,3),(689,7515418,7515416,'000',3.333,3),(689,7515419,7515416,'00c',3.333,3),(689,7515420,7515416,'0c2',3.333,3),(689,7515421,7515416,'c29',3.333,3),(689,7515422,7515416,'295',3.333,3),(689,7515423,7515416,'95b',3.333,3),(689,7515424,7515416,'5b7',3.333,3),(689,7515425,7515416,'b71',3.333,3),(689,7515426,7515416,'71f',3.333,3),(689,7515427,7515416,'1f7',3.333,3),(689,7515428,7515416,'f71',3.333,3),(689,7515429,7515416,'715',3.333,3),(689,7515430,7515416,'15f',3.333,3),(689,7515431,7515416,'5f8',3.333,3),(689,7515432,7515416,'f89',3.333,3),(689,7515433,7515416,'89e',3.333,3),(689,7515434,7515416,'9e7',3.333,3),(689,7515435,7515416,'e72',3.333,3),(689,7515436,7515416,'724',3.333,3),(689,7515437,7515416,'240',3.333,3),(689,7515438,7515416,'406',3.333,3),(689,7515439,7515416,'063',3.333,3),(689,7515440,7515416,'63e',3.333,3),(689,7515441,7515416,'3eb',3.333,3),(689,7515442,7515416,'ebb',3.333,3),(689,7515443,7515416,'bb2',3.333,3),(689,7515444,7515416,'b2c',3.333,3),(689,7515445,7515416,'2c1',3.333,3),(689,7515446,7515416,'c1a',3.333,3),(689,7515447,7515417,'mon',100,1),(689,7515448,7515447,'201',50,1),(689,7515449,7515447,'013',50,1),(689,7515450,7515448,'adm',33.333,3),(689,7515451,7515448,'dmi',33.333,3),(689,7515452,7515448,'min',33.333,3),(689,7515453,7515450,'cap',16.667,1),(689,7515454,7515450,'apa',16.667,1),(689,7515455,7515450,'pac',16.667,1),(689,7515456,7515450,'aci',16.667,1),(689,7515457,7515450,'cit',16.667,1),(689,7515458,7515450,'ity',16.667,1),(689,7515459,7515453,'pat',50,1),(689,7515460,7515453,'ath',50,1),(689,7515461,7515459,'fre',14.286,1),(689,7515462,7515459,'ree',14.286,1),(689,7515463,7515459,'ees',14.286,1),(689,7515464,7515459,'esp',14.286,1),(689,7515465,7515459,'spa',14.286,1),(689,7515466,7515459,'pac',14.286,1),(689,7515467,7515459,'ace',14.286,1),(689,7515468,7515461,'dis',50,1),(689,7515469,7515461,'isk',50,1),(689,7515470,7515468,'ind',33.333,1),(689,7515471,7515468,'nde',33.333,1),(689,7515472,7515468,'dex',33.333,1),(689,7515473,7515470,'adm',8.333,1),(689,7515474,7515470,'dmi',8.333,1),(689,7515475,7515470,'min',8.333,1),(689,7515476,7515470,'ini',8.333,1),(689,7515477,7515470,'nis',8.333,1),(689,7515478,7515470,'ist',8.333,1),(689,7515479,7515470,'str',8.333,1),(689,7515480,7515470,'tra',8.333,1),(689,7515481,7515470,'rat',8.333,1),(689,7515482,7515470,'ati',8.333,1),(689,7515483,7515470,'tio',8.333,1),(689,7515484,7515470,'ion',8.333,1),(689,7515485,7515473,'sta',33.333,3),(689,7515486,7515473,'tat',33.333,3),(689,7515487,7515473,'ate',33.333,3),(689,7515488,7515485,'ena',20,2),(689,7515489,7515485,'nab',20,2),(689,7515490,7515485,'abl',20,2),(689,7515491,7515485,'ble',20,2),(689,7515492,7515485,'led',20,2),(689,7515493,7515488,'cac',33.333,2),(689,7515494,7515488,'ach',33.333,2),(689,7515495,7515488,'che',33.333,2),(689,7515496,7515493,'mod',50,1),(689,7515497,7515493,'ode',50,1),(689,7515498,7515496,'wri',14.286,1),(689,7515499,7515496,'rit',14.286,1),(689,7515500,7515496,'ite',14.286,1),(689,7515501,7515496,'tet',14.286,1),(689,7515502,7515496,'eth',14.286,1),(689,7515503,7515496,'thr',14.286,1),(689,7515504,7515496,'hru',14.286,1),(689,7515505,7515498,'ope',11.111,2),(689,7515506,7515498,'per',11.111,2),(689,7515507,7515498,'era',11.111,2),(689,7515508,7515498,'rat',11.111,2),(689,7515509,7515498,'ati',11.111,2),(689,7515510,7515498,'tio',11.111,2),(689,7515511,7515498,'ion',11.111,2),(689,7515512,7515498,'ona',11.111,2),(689,7515513,7515498,'nal',11.111,2),(689,7515514,7515505,'pen',20,1),(689,7515515,7515505,'end',20,1),(689,7515516,7515505,'ndi',20,1),(689,7515517,7515505,'din',20,1),(689,7515518,7515505,'ing',20,1),(689,7515519,7515514,'mes',20,1),(689,7515520,7515514,'ess',20,1),(689,7515521,7515514,'ssa',20,1),(689,7515522,7515514,'sag',20,1),(689,7515523,7515514,'age',20,1),(689,7515524,7515519,'wai',20,1),(689,7515525,7515519,'ait',20,1),(689,7515526,7515519,'iti',20,1),(689,7515527,7515519,'tin',20,1),(689,7515528,7515519,'ing',20,1),(689,7515529,7515524,'for',100,1),(689,7515530,7515529,'per',11.111,1),(689,7515531,7515529,'erf',11.111,1),(689,7515532,7515529,'rfo',11.111,1),(689,7515533,7515529,'for',11.111,1),(689,7515534,7515529,'orm',11.111,1),(689,7515535,7515529,'rma',11.111,1),(689,7515536,7515529,'man',11.111,1),(689,7515537,7515529,'anc',11.111,1),(689,7515538,7515529,'nce',11.111,1),(689,7515539,7515530,'ide',12.5,1),(689,7515540,7515530,'den',12.5,1),(689,7515541,7515530,'ent',12.5,1),(689,7515542,7515530,'nti',12.5,1),(689,7515543,7515530,'tif',12.5,1),(689,7515544,7515530,'ifi',12.5,1),(689,7515545,7515530,'fie',12.5,1),(689,7515546,7515530,'ier',12.5,1),(689,7515547,7515539,'vdi',33.333,3),(689,7515548,7515539,'dis',33.333,3),(689,7515549,7515539,'isk',33.333,3),(689,7515550,7515547,'nam',50,1),(689,7515551,7515547,'ame',50,1),(689,7515552,7515550,'typ',50,1),(689,7515553,7515550,'ype',50,1),(689,7515554,7515552,'dir',25,1),(689,7515555,7515552,'ire',25,1),(689,7515556,7515552,'rec',25,1),(689,7515557,7515552,'ect',25,1),(690,7515559,7515558,'naa',100,2),(690,7515560,7515559,'600',3.333,3),(690,7515561,7515559,'000',3.333,3),(690,7515562,7515559,'00c',3.333,3),(690,7515563,7515559,'0c2',3.333,3),(690,7515564,7515559,'c29',3.333,3),(690,7515565,7515559,'29f',3.333,3),(690,7515566,7515559,'9f7',3.333,3),(690,7515567,7515559,'f71',3.333,3),(690,7515568,7515559,'710',3.333,3),(690,7515569,7515559,'101',3.333,3),(690,7515570,7515559,'011',3.333,3),(690,7515571,7515559,'113',3.333,3),(690,7515572,7515559,'13c',3.333,3),(690,7515573,7515559,'3ca',3.333,3),(690,7515574,7515559,'ca8',3.333,3),(690,7515575,7515559,'a8f',3.333,3),(690,7515576,7515559,'8f9',3.333,3),(690,7515577,7515559,'f91',3.333,3),(690,7515578,7515559,'912',3.333,3),(690,7515579,7515559,'127',3.333,3),(690,7515580,7515559,'277',3.333,3),(690,7515581,7515559,'77f',3.333,3),(690,7515582,7515559,'7f4',3.333,3),(690,7515583,7515559,'f42',3.333,3),(690,7515584,7515559,'42f',3.333,3),(690,7515585,7515559,'2fa',3.333,3),(690,7515586,7515559,'fa5',3.333,3),(690,7515587,7515559,'a52',3.333,3),(690,7515588,7515559,'529',3.333,3),(690,7515589,7515559,'29d',3.333,3),(690,7515590,7515560,'mon',100,1),(690,7515591,7515590,'201',50,1),(690,7515592,7515590,'013',50,1),(690,7515593,7515591,'adm',33.333,3),(690,7515594,7515591,'dmi',33.333,3),(690,7515595,7515591,'min',33.333,3),(690,7515596,7515593,'cap',16.667,1),(690,7515597,7515593,'apa',16.667,1),(690,7515598,7515593,'pac',16.667,1),(690,7515599,7515593,'aci',16.667,1),(690,7515600,7515593,'cit',16.667,1),(690,7515601,7515593,'ity',16.667,1),(690,7515602,7515596,'pat',50,1),(690,7515603,7515596,'ath',50,1),(690,7515604,7515602,'fre',14.286,1),(690,7515605,7515602,'ree',14.286,1),(690,7515606,7515602,'ees',14.286,1),(690,7515607,7515602,'esp',14.286,1),(690,7515608,7515602,'spa',14.286,1),(690,7515609,7515602,'pac',14.286,1),(690,7515610,7515602,'ace',14.286,1),(690,7515611,7515604,'dis',50,1),(690,7515612,7515604,'isk',50,1),(690,7515613,7515611,'ind',33.333,1),(690,7515614,7515611,'nde',33.333,1),(690,7515615,7515611,'dex',33.333,1),(690,7515616,7515613,'adm',8.333,1),(690,7515617,7515613,'dmi',8.333,1),(690,7515618,7515613,'min',8.333,1),(690,7515619,7515613,'ini',8.333,1),(690,7515620,7515613,'nis',8.333,1),(690,7515621,7515613,'ist',8.333,1),(690,7515622,7515613,'str',8.333,1),(690,7515623,7515613,'tra',8.333,1),(690,7515624,7515613,'rat',8.333,1),(690,7515625,7515613,'ati',8.333,1),(690,7515626,7515613,'tio',8.333,1),(690,7515627,7515613,'ion',8.333,1),(690,7515628,7515616,'sta',33.333,3),(690,7515629,7515616,'tat',33.333,3),(690,7515630,7515616,'ate',33.333,3),(690,7515631,7515628,'ena',20,2),(690,7515632,7515628,'nab',20,2),(690,7515633,7515628,'abl',20,2),(690,7515634,7515628,'ble',20,2),(690,7515635,7515628,'led',20,2),(690,7515636,7515631,'cac',33.333,2),(690,7515637,7515631,'ach',33.333,2),(690,7515638,7515631,'che',33.333,2),(690,7515639,7515636,'mod',50,1),(690,7515640,7515636,'ode',50,1),(690,7515641,7515639,'wri',14.286,1),(690,7515642,7515639,'rit',14.286,1),(690,7515643,7515639,'ite',14.286,1),(690,7515644,7515639,'tet',14.286,1),(690,7515645,7515639,'eth',14.286,1),(690,7515646,7515639,'thr',14.286,1),(690,7515647,7515639,'hru',14.286,1),(690,7515648,7515641,'ope',11.111,2),(690,7515649,7515641,'per',11.111,2),(690,7515650,7515641,'era',11.111,2),(690,7515651,7515641,'rat',11.111,2),(690,7515652,7515641,'ati',11.111,2),(690,7515653,7515641,'tio',11.111,2),(690,7515654,7515641,'ion',11.111,2),(690,7515655,7515641,'ona',11.111,2),(690,7515656,7515641,'nal',11.111,2),(690,7515657,7515648,'pen',20,1),(690,7515658,7515648,'end',20,1),(690,7515659,7515648,'ndi',20,1),(690,7515660,7515648,'din',20,1),(690,7515661,7515648,'ing',20,1),(690,7515662,7515657,'mes',20,1),(690,7515663,7515657,'ess',20,1),(690,7515664,7515657,'ssa',20,1),(690,7515665,7515657,'sag',20,1),(690,7515666,7515657,'age',20,1),(690,7515667,7515662,'wai',20,1),(690,7515668,7515662,'ait',20,1),(690,7515669,7515662,'iti',20,1),(690,7515670,7515662,'tin',20,1),(690,7515671,7515662,'ing',20,1),(690,7515672,7515667,'for',100,1),(690,7515673,7515672,'per',11.111,1),(690,7515674,7515672,'erf',11.111,1),(690,7515675,7515672,'rfo',11.111,1),(690,7515676,7515672,'for',11.111,1),(690,7515677,7515672,'orm',11.111,1),(690,7515678,7515672,'rma',11.111,1),(690,7515679,7515672,'man',11.111,1),(690,7515680,7515672,'anc',11.111,1),(690,7515681,7515672,'nce',11.111,1),(690,7515682,7515673,'ide',12.5,1),(690,7515683,7515673,'den',12.5,1),(690,7515684,7515673,'ent',12.5,1),(690,7515685,7515673,'nti',12.5,1),(690,7515686,7515673,'tif',12.5,1),(690,7515687,7515673,'ifi',12.5,1),(690,7515688,7515673,'fie',12.5,1),(690,7515689,7515673,'ier',12.5,1),(690,7515690,7515682,'vdi',33.333,3),(690,7515691,7515682,'dis',33.333,3),(690,7515692,7515682,'isk',33.333,3),(690,7515693,7515690,'nam',50,1),(690,7515694,7515690,'ame',50,1),(690,7515695,7515693,'typ',50,1),(690,7515696,7515693,'ype',50,1),(690,7515697,7515695,'dir',25,1),(690,7515698,7515695,'ire',25,1),(690,7515699,7515695,'rec',25,1),(690,7515700,7515695,'ect',25,1),(691,7515702,7515701,'naa',100,2),(691,7515703,7515702,'600',3.333,3),(691,7515704,7515702,'000',3.333,3),(691,7515705,7515702,'00c',3.333,3),(691,7515706,7515702,'0c2',3.333,3),(691,7515707,7515702,'c29',3.333,3),(691,7515708,7515702,'29b',3.333,3),(691,7515709,7515702,'9b0',3.333,3),(691,7515710,7515702,'b0f',3.333,3),(691,7515711,7515702,'0f9',3.333,3),(691,7515712,7515702,'f9f',3.333,3),(691,7515713,7515702,'9f1',3.333,3),(691,7515714,7515702,'f1a',3.333,3),(691,7515715,7515702,'1a3',3.333,3),(691,7515716,7515702,'a3b',3.333,3),(691,7515717,7515702,'3b2',3.333,3),(691,7515718,7515702,'b2e',3.333,3),(691,7515719,7515702,'2e4',3.333,3),(691,7515720,7515702,'e4f',3.333,3),(691,7515721,7515702,'4ff',3.333,3),(691,7515722,7515702,'ff9',3.333,3),(691,7515723,7515702,'f91',3.333,3),(691,7515724,7515702,'91f',3.333,3),(691,7515725,7515702,'1f6',3.333,3),(691,7515726,7515702,'f6e',3.333,3),(691,7515727,7515702,'6ef',3.333,3),(691,7515728,7515702,'eff',3.333,3),(691,7515729,7515702,'ffb',3.333,3),(691,7515730,7515702,'fb5',3.333,3),(691,7515731,7515702,'b54',3.333,3),(691,7515732,7515702,'54d',3.333,3),(691,7515733,7515703,'mon',100,1),(691,7515734,7515733,'201',50,1),(691,7515735,7515733,'013',50,1),(691,7515736,7515734,'adm',33.333,3),(691,7515737,7515734,'dmi',33.333,3),(691,7515738,7515734,'min',33.333,3),(691,7515739,7515736,'cap',16.667,1),(691,7515740,7515736,'apa',16.667,1),(691,7515741,7515736,'pac',16.667,1),(691,7515742,7515736,'aci',16.667,1),(691,7515743,7515736,'cit',16.667,1),(691,7515744,7515736,'ity',16.667,1),(691,7515745,7515739,'pat',50,1),(691,7515746,7515739,'ath',50,1),(691,7515747,7515745,'fre',14.286,1),(691,7515748,7515745,'ree',14.286,1),(691,7515749,7515745,'ees',14.286,1),(691,7515750,7515745,'esp',14.286,1),(691,7515751,7515745,'spa',14.286,1),(691,7515752,7515745,'pac',14.286,1),(691,7515753,7515745,'ace',14.286,1),(691,7515754,7515747,'dis',50,1),(691,7515755,7515747,'isk',50,1),(691,7515756,7515754,'ind',33.333,1),(691,7515757,7515754,'nde',33.333,1),(691,7515758,7515754,'dex',33.333,1),(691,7515759,7515756,'adm',8.333,1),(691,7515760,7515756,'dmi',8.333,1),(691,7515761,7515756,'min',8.333,1),(691,7515762,7515756,'ini',8.333,1),(691,7515763,7515756,'nis',8.333,1),(691,7515764,7515756,'ist',8.333,1),(691,7515765,7515756,'str',8.333,1),(691,7515766,7515756,'tra',8.333,1),(691,7515767,7515756,'rat',8.333,1),(691,7515768,7515756,'ati',8.333,1),(691,7515769,7515756,'tio',8.333,1),(691,7515770,7515756,'ion',8.333,1),(691,7515771,7515759,'sta',33.333,3),(691,7515772,7515759,'tat',33.333,3),(691,7515773,7515759,'ate',33.333,3),(691,7515774,7515771,'ena',20,2),(691,7515775,7515771,'nab',20,2),(691,7515776,7515771,'abl',20,2),(691,7515777,7515771,'ble',20,2),(691,7515778,7515771,'led',20,2),(691,7515779,7515774,'cac',33.333,2),(691,7515780,7515774,'ach',33.333,2),(691,7515781,7515774,'che',33.333,2),(691,7515782,7515779,'mod',50,1),(691,7515783,7515779,'ode',50,1),(691,7515784,7515782,'wri',14.286,1),(691,7515785,7515782,'rit',14.286,1),(691,7515786,7515782,'ite',14.286,1),(691,7515787,7515782,'tet',14.286,1),(691,7515788,7515782,'eth',14.286,1),(691,7515789,7515782,'thr',14.286,1),(691,7515790,7515782,'hru',14.286,1),(691,7515791,7515784,'ope',11.111,2),(691,7515792,7515784,'per',11.111,2),(691,7515793,7515784,'era',11.111,2),(691,7515794,7515784,'rat',11.111,2),(691,7515795,7515784,'ati',11.111,2),(691,7515796,7515784,'tio',11.111,2),(691,7515797,7515784,'ion',11.111,2),(691,7515798,7515784,'ona',11.111,2),(691,7515799,7515784,'nal',11.111,2),(691,7515800,7515791,'pen',20,1),(691,7515801,7515791,'end',20,1),(691,7515802,7515791,'ndi',20,1),(691,7515803,7515791,'din',20,1),(691,7515804,7515791,'ing',20,1),(691,7515805,7515800,'mes',20,1),(691,7515806,7515800,'ess',20,1),(691,7515807,7515800,'ssa',20,1),(691,7515808,7515800,'sag',20,1),(691,7515809,7515800,'age',20,1),(691,7515810,7515805,'wai',20,1),(691,7515811,7515805,'ait',20,1),(691,7515812,7515805,'iti',20,1),(691,7515813,7515805,'tin',20,1),(691,7515814,7515805,'ing',20,1),(691,7515815,7515810,'for',100,1),(691,7515816,7515815,'per',11.111,1),(691,7515817,7515815,'erf',11.111,1),(691,7515818,7515815,'rfo',11.111,1),(691,7515819,7515815,'for',11.111,1),(691,7515820,7515815,'orm',11.111,1),(691,7515821,7515815,'rma',11.111,1),(691,7515822,7515815,'man',11.111,1),(691,7515823,7515815,'anc',11.111,1),(691,7515824,7515815,'nce',11.111,1),(691,7515825,7515816,'ide',12.5,1),(691,7515826,7515816,'den',12.5,1),(691,7515827,7515816,'ent',12.5,1),(691,7515828,7515816,'nti',12.5,1),(691,7515829,7515816,'tif',12.5,1),(691,7515830,7515816,'ifi',12.5,1),(691,7515831,7515816,'fie',12.5,1),(691,7515832,7515816,'ier',12.5,1),(691,7515833,7515825,'vdi',33.333,3),(691,7515834,7515825,'dis',33.333,3),(691,7515835,7515825,'isk',33.333,3),(691,7515836,7515833,'nam',50,1),(691,7515837,7515833,'ame',50,1),(691,7515838,7515836,'typ',50,1),(691,7515839,7515836,'ype',50,1),(691,7515840,7515838,'dir',25,1),(691,7515841,7515838,'ire',25,1),(691,7515842,7515838,'rec',25,1),(691,7515843,7515838,'ect',25,1),(692,7515845,7515844,'naa',100,2),(692,7515846,7515845,'600',3.333,3),(692,7515847,7515845,'000',3.333,3),(692,7515848,7515845,'00c',3.333,3),(692,7515849,7515845,'0c2',3.333,3),(692,7515850,7515845,'c29',3.333,3),(692,7515851,7515845,'29c',3.333,3),(692,7515852,7515845,'9c3',3.333,3),(692,7515853,7515845,'c3a',3.333,3),(692,7515854,7515845,'3a9',3.333,3),(692,7515855,7515845,'a99',3.333,3),(692,7515856,7515845,'99f',3.333,3),(692,7515857,7515845,'9f5',3.333,3),(692,7515858,7515845,'f55',3.333,3),(692,7515859,7515845,'557',3.333,3),(692,7515860,7515845,'57d',3.333,3),(692,7515861,7515845,'7da',3.333,3),(692,7515862,7515845,'da1',3.333,3),(692,7515863,7515845,'a10',3.333,3),(692,7515864,7515845,'107',3.333,3),(692,7515865,7515845,'077',3.333,3),(692,7515866,7515845,'778',3.333,3),(692,7515867,7515845,'784',3.333,3),(692,7515868,7515845,'84e',3.333,3),(692,7515869,7515845,'4e0',3.333,3),(692,7515870,7515845,'e0e',3.333,3),(692,7515871,7515845,'0e7',3.333,3),(692,7515872,7515845,'e76',3.333,3),(692,7515873,7515845,'76d',3.333,3),(692,7515874,7515845,'6df',3.333,3),(692,7515875,7515845,'df4',3.333,3),(692,7515876,7515846,'mon',100,1),(692,7515877,7515876,'201',50,1),(692,7515878,7515876,'013',50,1),(692,7515879,7515877,'adm',33.333,3),(692,7515880,7515877,'dmi',33.333,3),(692,7515881,7515877,'min',33.333,3),(692,7515882,7515879,'cap',16.667,1),(692,7515883,7515879,'apa',16.667,1),(692,7515884,7515879,'pac',16.667,1),(692,7515885,7515879,'aci',16.667,1),(692,7515886,7515879,'cit',16.667,1),(692,7515887,7515879,'ity',16.667,1),(692,7515888,7515882,'pat',50,1),(692,7515889,7515882,'ath',50,1),(692,7515890,7515888,'fre',14.286,1),(692,7515891,7515888,'ree',14.286,1),(692,7515892,7515888,'ees',14.286,1),(692,7515893,7515888,'esp',14.286,1),(692,7515894,7515888,'spa',14.286,1),(692,7515895,7515888,'pac',14.286,1),(692,7515896,7515888,'ace',14.286,1),(692,7515897,7515890,'dis',50,1),(692,7515898,7515890,'isk',50,1),(692,7515899,7515897,'ind',33.333,1),(692,7515900,7515897,'nde',33.333,1),(692,7515901,7515897,'dex',33.333,1),(692,7515902,7515899,'adm',8.333,1),(692,7515903,7515899,'dmi',8.333,1),(692,7515904,7515899,'min',8.333,1),(692,7515905,7515899,'ini',8.333,1),(692,7515906,7515899,'nis',8.333,1),(692,7515907,7515899,'ist',8.333,1),(692,7515908,7515899,'str',8.333,1),(692,7515909,7515899,'tra',8.333,1),(692,7515910,7515899,'rat',8.333,1),(692,7515911,7515899,'ati',8.333,1),(692,7515912,7515899,'tio',8.333,1),(692,7515913,7515899,'ion',8.333,1),(692,7515914,7515902,'sta',33.333,3),(692,7515915,7515902,'tat',33.333,3),(692,7515916,7515902,'ate',33.333,3),(692,7515917,7515914,'ena',20,2),(692,7515918,7515914,'nab',20,2),(692,7515919,7515914,'abl',20,2),(692,7515920,7515914,'ble',20,2),(692,7515921,7515914,'led',20,2),(692,7515922,7515917,'cac',33.333,2),(692,7515923,7515917,'ach',33.333,2),(692,7515924,7515917,'che',33.333,2),(692,7515925,7515922,'mod',50,1),(692,7515926,7515922,'ode',50,1),(692,7515927,7515925,'wri',14.286,1),(692,7515928,7515925,'rit',14.286,1),(692,7515929,7515925,'ite',14.286,1),(692,7515930,7515925,'tet',14.286,1),(692,7515931,7515925,'eth',14.286,1),(692,7515932,7515925,'thr',14.286,1),(692,7515933,7515925,'hru',14.286,1),(692,7515934,7515927,'ope',11.111,2),(692,7515935,7515927,'per',11.111,2),(692,7515936,7515927,'era',11.111,2),(692,7515937,7515927,'rat',11.111,2),(692,7515938,7515927,'ati',11.111,2),(692,7515939,7515927,'tio',11.111,2),(692,7515940,7515927,'ion',11.111,2),(692,7515941,7515927,'ona',11.111,2),(692,7515942,7515927,'nal',11.111,2),(692,7515943,7515934,'pen',20,1),(692,7515944,7515934,'end',20,1),(692,7515945,7515934,'ndi',20,1),(692,7515946,7515934,'din',20,1),(692,7515947,7515934,'ing',20,1),(692,7515948,7515943,'mes',20,1),(692,7515949,7515943,'ess',20,1),(692,7515950,7515943,'ssa',20,1),(692,7515951,7515943,'sag',20,1),(692,7515952,7515943,'age',20,1),(692,7515953,7515948,'wai',20,1),(692,7515954,7515948,'ait',20,1),(692,7515955,7515948,'iti',20,1),(692,7515956,7515948,'tin',20,1),(692,7515957,7515948,'ing',20,1),(692,7515958,7515953,'for',100,1),(692,7515959,7515958,'per',11.111,1),(692,7515960,7515958,'erf',11.111,1),(692,7515961,7515958,'rfo',11.111,1),(692,7515962,7515958,'for',11.111,1),(692,7515963,7515958,'orm',11.111,1),(692,7515964,7515958,'rma',11.111,1),(692,7515965,7515958,'man',11.111,1),(692,7515966,7515958,'anc',11.111,1),(692,7515967,7515958,'nce',11.111,1),(692,7515968,7515959,'ide',12.5,1),(692,7515969,7515959,'den',12.5,1),(692,7515970,7515959,'ent',12.5,1),(692,7515971,7515959,'nti',12.5,1),(692,7515972,7515959,'tif',12.5,1),(692,7515973,7515959,'ifi',12.5,1),(692,7515974,7515959,'fie',12.5,1),(692,7515975,7515959,'ier',12.5,1),(692,7515976,7515968,'vdi',33.333,3),(692,7515977,7515968,'dis',33.333,3),(692,7515978,7515968,'isk',33.333,3),(692,7515979,7515976,'nam',50,1),(692,7515980,7515976,'ame',50,1),(692,7515981,7515979,'typ',50,1),(692,7515982,7515979,'ype',50,1),(692,7515983,7515981,'dir',25,1),(692,7515984,7515981,'ire',25,1),(692,7515985,7515981,'rec',25,1),(692,7515986,7515981,'ect',25,1),(693,7515988,7515987,'naa',100,2),(693,7515989,7515988,'600',3.333,3),(693,7515990,7515988,'000',3.333,3),(693,7515991,7515988,'00c',3.333,3),(693,7515992,7515988,'0c2',3.333,3),(693,7515993,7515988,'c29',3.333,3),(693,7515994,7515988,'29f',3.333,3),(693,7515995,7515988,'9fc',3.333,3),(693,7515996,7515988,'fce',3.333,3),(693,7515997,7515988,'ce8',3.333,3),(693,7515998,7515988,'e80',3.333,3),(693,7515999,7515988,'80c',3.333,3),(693,7516000,7515988,'0cd',3.333,3),(693,7516001,7515988,'cd6',3.333,3),(693,7516002,7515988,'d6e',3.333,3),(693,7516003,7515988,'6e1',3.333,3),(693,7516004,7515988,'e14',3.333,3),(693,7516005,7515988,'14c',3.333,3),(693,7516006,7515988,'4c8',3.333,3),(693,7516007,7515988,'c85',3.333,3),(693,7516008,7515988,'85e',3.333,3),(693,7516009,7515988,'5e9',3.333,3),(693,7516010,7515988,'e9f',3.333,3),(693,7516011,7515988,'9f0',3.333,3),(693,7516012,7515988,'f08',3.333,3),(693,7516013,7515988,'08c',3.333,3),(693,7516014,7515988,'8cc',3.333,3),(693,7516015,7515988,'cc2',3.333,3),(693,7516016,7515988,'c2c',3.333,3),(693,7516017,7515988,'2c5',3.333,3),(693,7516018,7515988,'c5c',3.333,3),(693,7516019,7515989,'mon',100,1),(693,7516020,7516019,'201',50,1),(693,7516021,7516019,'013',50,1),(693,7516022,7516020,'adm',33.333,3),(693,7516023,7516020,'dmi',33.333,3),(693,7516024,7516020,'min',33.333,3),(693,7516025,7516022,'cap',16.667,1),(693,7516026,7516022,'apa',16.667,1),(693,7516027,7516022,'pac',16.667,1),(693,7516028,7516022,'aci',16.667,1),(693,7516029,7516022,'cit',16.667,1),(693,7516030,7516022,'ity',16.667,1),(693,7516031,7516025,'pat',50,1),(693,7516032,7516025,'ath',50,1),(693,7516033,7516031,'fre',14.286,1),(693,7516034,7516031,'ree',14.286,1),(693,7516035,7516031,'ees',14.286,1),(693,7516036,7516031,'esp',14.286,1),(693,7516037,7516031,'spa',14.286,1),(693,7516038,7516031,'pac',14.286,1),(693,7516039,7516031,'ace',14.286,1),(693,7516040,7516033,'dis',50,1),(693,7516041,7516033,'isk',50,1),(693,7516042,7516040,'ind',33.333,1),(693,7516043,7516040,'nde',33.333,1),(693,7516044,7516040,'dex',33.333,1),(693,7516045,7516042,'adm',8.333,1),(693,7516046,7516042,'dmi',8.333,1),(693,7516047,7516042,'min',8.333,1),(693,7516048,7516042,'ini',8.333,1),(693,7516049,7516042,'nis',8.333,1),(693,7516050,7516042,'ist',8.333,1),(693,7516051,7516042,'str',8.333,1),(693,7516052,7516042,'tra',8.333,1),(693,7516053,7516042,'rat',8.333,1),(693,7516054,7516042,'ati',8.333,1),(693,7516055,7516042,'tio',8.333,1),(693,7516056,7516042,'ion',8.333,1),(693,7516057,7516045,'sta',33.333,3),(693,7516058,7516045,'tat',33.333,3),(693,7516059,7516045,'ate',33.333,3),(693,7516060,7516057,'ena',20,2),(693,7516061,7516057,'nab',20,2),(693,7516062,7516057,'abl',20,2),(693,7516063,7516057,'ble',20,2),(693,7516064,7516057,'led',20,2),(693,7516065,7516060,'cac',33.333,2),(693,7516066,7516060,'ach',33.333,2),(693,7516067,7516060,'che',33.333,2),(693,7516068,7516065,'mod',50,1),(693,7516069,7516065,'ode',50,1),(693,7516070,7516068,'wri',14.286,1),(693,7516071,7516068,'rit',14.286,1),(693,7516072,7516068,'ite',14.286,1),(693,7516073,7516068,'tet',14.286,1),(693,7516074,7516068,'eth',14.286,1),(693,7516075,7516068,'thr',14.286,1),(693,7516076,7516068,'hru',14.286,1),(693,7516077,7516070,'ope',11.111,2),(693,7516078,7516070,'per',11.111,2),(693,7516079,7516070,'era',11.111,2),(693,7516080,7516070,'rat',11.111,2),(693,7516081,7516070,'ati',11.111,2),(693,7516082,7516070,'tio',11.111,2),(693,7516083,7516070,'ion',11.111,2),(693,7516084,7516070,'ona',11.111,2),(693,7516085,7516070,'nal',11.111,2),(693,7516086,7516077,'pen',20,1),(693,7516087,7516077,'end',20,1),(693,7516088,7516077,'ndi',20,1),(693,7516089,7516077,'din',20,1),(693,7516090,7516077,'ing',20,1),(693,7516091,7516086,'mes',20,1),(693,7516092,7516086,'ess',20,1),(693,7516093,7516086,'ssa',20,1),(693,7516094,7516086,'sag',20,1),(693,7516095,7516086,'age',20,1),(693,7516096,7516091,'wai',20,1),(693,7516097,7516091,'ait',20,1),(693,7516098,7516091,'iti',20,1),(693,7516099,7516091,'tin',20,1),(693,7516100,7516091,'ing',20,1),(693,7516101,7516096,'for',100,1),(693,7516102,7516101,'per',11.111,1),(693,7516103,7516101,'erf',11.111,1),(693,7516104,7516101,'rfo',11.111,1),(693,7516105,7516101,'for',11.111,1),(693,7516106,7516101,'orm',11.111,1),(693,7516107,7516101,'rma',11.111,1),(693,7516108,7516101,'man',11.111,1),(693,7516109,7516101,'anc',11.111,1),(693,7516110,7516101,'nce',11.111,1),(693,7516111,7516102,'ide',12.5,1),(693,7516112,7516102,'den',12.5,1),(693,7516113,7516102,'ent',12.5,1),(693,7516114,7516102,'nti',12.5,1),(693,7516115,7516102,'tif',12.5,1),(693,7516116,7516102,'ifi',12.5,1),(693,7516117,7516102,'fie',12.5,1),(693,7516118,7516102,'ier',12.5,1),(693,7516119,7516111,'vdi',33.333,3),(693,7516120,7516111,'dis',33.333,3),(693,7516121,7516111,'isk',33.333,3),(693,7516122,7516119,'nam',50,1),(693,7516123,7516119,'ame',50,1),(693,7516124,7516122,'typ',50,1),(693,7516125,7516122,'ype',50,1),(693,7516126,7516124,'dir',25,1),(693,7516127,7516124,'ire',25,1),(693,7516128,7516124,'rec',25,1),(693,7516129,7516124,'ect',25,1),(694,7516131,7516130,'naa',100,2),(694,7516132,7516131,'600',3.333,3),(694,7516133,7516131,'000',3.333,3),(694,7516134,7516131,'00c',3.333,3),(694,7516135,7516131,'0c2',3.333,3),(694,7516136,7516131,'c29',3.333,3),(694,7516137,7516131,'293',3.333,3),(694,7516138,7516131,'931',3.333,3),(694,7516139,7516131,'31e',3.333,3),(694,7516140,7516131,'1ec',3.333,3),(694,7516141,7516131,'ec1',3.333,3),(694,7516142,7516131,'c11',3.333,3),(694,7516143,7516131,'111',3.333,3),(694,7516144,7516131,'11e',3.333,3),(694,7516145,7516131,'1ed',3.333,3),(694,7516146,7516131,'ed6',3.333,3),(694,7516147,7516131,'d6d',3.333,3),(694,7516148,7516131,'6df',3.333,3),(694,7516149,7516131,'df3',3.333,3),(694,7516150,7516131,'f32',3.333,3),(694,7516151,7516131,'32f',3.333,3),(694,7516152,7516131,'2fb',3.333,3),(694,7516153,7516131,'fb8',3.333,3),(694,7516154,7516131,'b87',3.333,3),(694,7516155,7516131,'87f',3.333,3),(694,7516156,7516131,'7fe',3.333,3),(694,7516157,7516131,'fe0',3.333,3),(694,7516158,7516131,'e07',3.333,3),(694,7516159,7516131,'078',3.333,3),(694,7516160,7516131,'78e',3.333,3),(694,7516161,7516131,'8ec',3.333,3),(694,7516162,7516132,'mon',100,1),(694,7516163,7516162,'201',50,1),(694,7516164,7516162,'013',50,1),(694,7516165,7516163,'adm',33.333,3),(694,7516166,7516163,'dmi',33.333,3),(694,7516167,7516163,'min',33.333,3),(694,7516168,7516165,'cap',16.667,1),(694,7516169,7516165,'apa',16.667,1),(694,7516170,7516165,'pac',16.667,1),(694,7516171,7516165,'aci',16.667,1),(694,7516172,7516165,'cit',16.667,1),(694,7516173,7516165,'ity',16.667,1),(694,7516174,7516168,'pat',50,1),(694,7516175,7516168,'ath',50,1),(694,7516176,7516174,'fre',14.286,1),(694,7516177,7516174,'ree',14.286,1),(694,7516178,7516174,'ees',14.286,1),(694,7516179,7516174,'esp',14.286,1),(694,7516180,7516174,'spa',14.286,1),(694,7516181,7516174,'pac',14.286,1),(694,7516182,7516174,'ace',14.286,1),(694,7516183,7516176,'dis',50,1),(694,7516184,7516176,'isk',50,1),(694,7516185,7516183,'ind',33.333,1),(694,7516186,7516183,'nde',33.333,1),(694,7516187,7516183,'dex',33.333,1),(694,7516188,7516185,'adm',8.333,1),(694,7516189,7516185,'dmi',8.333,1),(694,7516190,7516185,'min',8.333,1),(694,7516191,7516185,'ini',8.333,1),(694,7516192,7516185,'nis',8.333,1),(694,7516193,7516185,'ist',8.333,1),(694,7516194,7516185,'str',8.333,1),(694,7516195,7516185,'tra',8.333,1),(694,7516196,7516185,'rat',8.333,1),(694,7516197,7516185,'ati',8.333,1),(694,7516198,7516185,'tio',8.333,1),(694,7516199,7516185,'ion',8.333,1),(694,7516200,7516188,'sta',33.333,3),(694,7516201,7516188,'tat',33.333,3),(694,7516202,7516188,'ate',33.333,3),(694,7516203,7516200,'ena',20,2),(694,7516204,7516200,'nab',20,2),(694,7516205,7516200,'abl',20,2),(694,7516206,7516200,'ble',20,2),(694,7516207,7516200,'led',20,2),(694,7516208,7516203,'cac',33.333,2),(694,7516209,7516203,'ach',33.333,2),(694,7516210,7516203,'che',33.333,2),(694,7516211,7516208,'mod',50,1),(694,7516212,7516208,'ode',50,1),(694,7516213,7516211,'wri',14.286,1),(694,7516214,7516211,'rit',14.286,1),(694,7516215,7516211,'ite',14.286,1),(694,7516216,7516211,'tet',14.286,1),(694,7516217,7516211,'eth',14.286,1),(694,7516218,7516211,'thr',14.286,1),(694,7516219,7516211,'hru',14.286,1),(694,7516220,7516213,'ope',11.111,2),(694,7516221,7516213,'per',11.111,2),(694,7516222,7516213,'era',11.111,2),(694,7516223,7516213,'rat',11.111,2),(694,7516224,7516213,'ati',11.111,2),(694,7516225,7516213,'tio',11.111,2),(694,7516226,7516213,'ion',11.111,2),(694,7516227,7516213,'ona',11.111,2),(694,7516228,7516213,'nal',11.111,2),(694,7516229,7516220,'pen',20,1),(694,7516230,7516220,'end',20,1),(694,7516231,7516220,'ndi',20,1),(694,7516232,7516220,'din',20,1),(694,7516233,7516220,'ing',20,1),(694,7516234,7516229,'mes',20,1),(694,7516235,7516229,'ess',20,1),(694,7516236,7516229,'ssa',20,1),(694,7516237,7516229,'sag',20,1),(694,7516238,7516229,'age',20,1),(694,7516239,7516234,'wai',20,1),(694,7516240,7516234,'ait',20,1),(694,7516241,7516234,'iti',20,1),(694,7516242,7516234,'tin',20,1),(694,7516243,7516234,'ing',20,1),(694,7516244,7516239,'for',100,1),(694,7516245,7516244,'per',11.111,1),(694,7516246,7516244,'erf',11.111,1),(694,7516247,7516244,'rfo',11.111,1),(694,7516248,7516244,'for',11.111,1),(694,7516249,7516244,'orm',11.111,1),(694,7516250,7516244,'rma',11.111,1),(694,7516251,7516244,'man',11.111,1),(694,7516252,7516244,'anc',11.111,1),(694,7516253,7516244,'nce',11.111,1),(694,7516254,7516245,'ide',12.5,1),(694,7516255,7516245,'den',12.5,1),(694,7516256,7516245,'ent',12.5,1),(694,7516257,7516245,'nti',12.5,1),(694,7516258,7516245,'tif',12.5,1),(694,7516259,7516245,'ifi',12.5,1),(694,7516260,7516245,'fie',12.5,1),(694,7516261,7516245,'ier',12.5,1),(694,7516262,7516254,'vdi',33.333,3),(694,7516263,7516254,'dis',33.333,3),(694,7516264,7516254,'isk',33.333,3),(694,7516265,7516262,'nam',50,1),(694,7516266,7516262,'ame',50,1),(694,7516267,7516265,'typ',50,1),(694,7516268,7516265,'ype',50,1),(694,7516269,7516267,'dir',25,1),(694,7516270,7516267,'ire',25,1),(694,7516271,7516267,'rec',25,1),(694,7516272,7516267,'ect',25,1),(695,7516274,7516273,'naa',100,2),(695,7516275,7516274,'600',3.333,3),(695,7516276,7516274,'000',3.333,3),(695,7516277,7516274,'00c',3.333,3),(695,7516278,7516274,'0c2',3.333,3),(695,7516279,7516274,'c29',3.333,3),(695,7516280,7516274,'291',3.333,3),(695,7516281,7516274,'919',3.333,3),(695,7516282,7516274,'19b',3.333,3),(695,7516283,7516274,'9b6',3.333,3),(695,7516284,7516274,'b60',3.333,3),(695,7516285,7516274,'604',3.333,3),(695,7516286,7516274,'048',3.333,3),(695,7516287,7516274,'483',3.333,3),(695,7516288,7516274,'83d',3.333,3),(695,7516289,7516274,'3d8',3.333,3),(695,7516290,7516274,'d89',3.333,3),(695,7516291,7516274,'890',3.333,3),(695,7516292,7516274,'900',3.333,3),(695,7516293,7516274,'005',3.333,3),(695,7516294,7516274,'051',3.333,3),(695,7516295,7516274,'510',3.333,3),(695,7516296,7516274,'104',3.333,3),(695,7516297,7516274,'04a',3.333,3),(695,7516298,7516274,'4ac',3.333,3),(695,7516299,7516274,'acc',3.333,3),(695,7516300,7516274,'cc7',3.333,3),(695,7516301,7516274,'c70',3.333,3),(695,7516302,7516274,'708',3.333,3),(695,7516303,7516274,'086',3.333,3),(695,7516304,7516274,'86c',3.333,3),(695,7516305,7516275,'mon',100,1),(695,7516306,7516305,'201',50,1),(695,7516307,7516305,'013',50,1),(695,7516308,7516306,'adm',33.333,3),(695,7516309,7516306,'dmi',33.333,3),(695,7516310,7516306,'min',33.333,3),(695,7516311,7516308,'cap',16.667,1),(695,7516312,7516308,'apa',16.667,1),(695,7516313,7516308,'pac',16.667,1),(695,7516314,7516308,'aci',16.667,1),(695,7516315,7516308,'cit',16.667,1),(695,7516316,7516308,'ity',16.667,1),(695,7516317,7516311,'pat',50,1),(695,7516318,7516311,'ath',50,1),(695,7516319,7516317,'fre',14.286,1),(695,7516320,7516317,'ree',14.286,1),(695,7516321,7516317,'ees',14.286,1),(695,7516322,7516317,'esp',14.286,1),(695,7516323,7516317,'spa',14.286,1),(695,7516324,7516317,'pac',14.286,1),(695,7516325,7516317,'ace',14.286,1),(695,7516326,7516319,'dis',50,1),(695,7516327,7516319,'isk',50,1),(695,7516328,7516326,'ind',33.333,1),(695,7516329,7516326,'nde',33.333,1),(695,7516330,7516326,'dex',33.333,1),(695,7516331,7516328,'adm',8.333,1),(695,7516332,7516328,'dmi',8.333,1),(695,7516333,7516328,'min',8.333,1),(695,7516334,7516328,'ini',8.333,1),(695,7516335,7516328,'nis',8.333,1),(695,7516336,7516328,'ist',8.333,1),(695,7516337,7516328,'str',8.333,1),(695,7516338,7516328,'tra',8.333,1),(695,7516339,7516328,'rat',8.333,1),(695,7516340,7516328,'ati',8.333,1),(695,7516341,7516328,'tio',8.333,1),(695,7516342,7516328,'ion',8.333,1),(695,7516343,7516331,'sta',33.333,3),(695,7516344,7516331,'tat',33.333,3),(695,7516345,7516331,'ate',33.333,3),(695,7516346,7516343,'ena',20,2),(695,7516347,7516343,'nab',20,2),(695,7516348,7516343,'abl',20,2),(695,7516349,7516343,'ble',20,2),(695,7516350,7516343,'led',20,2),(695,7516351,7516346,'cac',33.333,2),(695,7516352,7516346,'ach',33.333,2),(695,7516353,7516346,'che',33.333,2),(695,7516354,7516351,'mod',50,1),(695,7516355,7516351,'ode',50,1),(695,7516356,7516354,'wri',14.286,1),(695,7516357,7516354,'rit',14.286,1),(695,7516358,7516354,'ite',14.286,1),(695,7516359,7516354,'tet',14.286,1),(695,7516360,7516354,'eth',14.286,1),(695,7516361,7516354,'thr',14.286,1),(695,7516362,7516354,'hru',14.286,1),(695,7516363,7516356,'ope',11.111,2),(695,7516364,7516356,'per',11.111,2),(695,7516365,7516356,'era',11.111,2),(695,7516366,7516356,'rat',11.111,2),(695,7516367,7516356,'ati',11.111,2),(695,7516368,7516356,'tio',11.111,2),(695,7516369,7516356,'ion',11.111,2),(695,7516370,7516356,'ona',11.111,2),(695,7516371,7516356,'nal',11.111,2),(695,7516372,7516363,'pen',20,1),(695,7516373,7516363,'end',20,1),(695,7516374,7516363,'ndi',20,1),(695,7516375,7516363,'din',20,1),(695,7516376,7516363,'ing',20,1),(695,7516377,7516372,'mes',20,1),(695,7516378,7516372,'ess',20,1),(695,7516379,7516372,'ssa',20,1),(695,7516380,7516372,'sag',20,1),(695,7516381,7516372,'age',20,1),(695,7516382,7516377,'wai',20,1),(695,7516383,7516377,'ait',20,1),(695,7516384,7516377,'iti',20,1),(695,7516385,7516377,'tin',20,1),(695,7516386,7516377,'ing',20,1),(695,7516387,7516382,'for',100,1),(695,7516388,7516387,'per',11.111,1),(695,7516389,7516387,'erf',11.111,1),(695,7516390,7516387,'rfo',11.111,1),(695,7516391,7516387,'for',11.111,1),(695,7516392,7516387,'orm',11.111,1),(695,7516393,7516387,'rma',11.111,1),(695,7516394,7516387,'man',11.111,1),(695,7516395,7516387,'anc',11.111,1),(695,7516396,7516387,'nce',11.111,1),(695,7516397,7516388,'ide',12.5,1),(695,7516398,7516388,'den',12.5,1),(695,7516399,7516388,'ent',12.5,1),(695,7516400,7516388,'nti',12.5,1),(695,7516401,7516388,'tif',12.5,1),(695,7516402,7516388,'ifi',12.5,1),(695,7516403,7516388,'fie',12.5,1),(695,7516404,7516388,'ier',12.5,1),(695,7516405,7516397,'vdi',33.333,3),(695,7516406,7516397,'dis',33.333,3),(695,7516407,7516397,'isk',33.333,3),(695,7516408,7516405,'nam',50,1),(695,7516409,7516405,'ame',50,1),(695,7516410,7516408,'typ',50,1),(695,7516411,7516408,'ype',50,1),(695,7516412,7516410,'dir',25,1),(695,7516413,7516410,'ire',25,1),(695,7516414,7516410,'rec',25,1),(695,7516415,7516410,'ect',25,1),(696,7516417,7516416,'naa',100,2),(696,7516418,7516417,'600',3.333,3),(696,7516419,7516417,'000',3.333,3),(696,7516420,7516417,'00c',3.333,3),(696,7516421,7516417,'0c2',3.333,3),(696,7516422,7516417,'c29',3.333,3),(696,7516423,7516417,'298',3.333,3),(696,7516424,7516417,'98c',3.333,3),(696,7516425,7516417,'8c7',3.333,3),(696,7516426,7516417,'c79',3.333,3),(696,7516427,7516417,'790',3.333,3),(696,7516428,7516417,'906',3.333,3),(696,7516429,7516417,'06e',3.333,3),(696,7516430,7516417,'6e2',3.333,3),(696,7516431,7516417,'e21',3.333,3),(696,7516432,7516417,'216',3.333,3),(696,7516433,7516417,'16e',3.333,3),(696,7516434,7516417,'6ef',3.333,3),(696,7516435,7516417,'ef0',3.333,3),(696,7516436,7516417,'f02',3.333,3),(696,7516437,7516417,'02e',3.333,3),(696,7516438,7516417,'2eb',3.333,3),(696,7516439,7516417,'ebe',3.333,3),(696,7516440,7516417,'be5',3.333,3),(696,7516441,7516417,'e5c',3.333,3),(696,7516442,7516417,'5c8',3.333,3),(696,7516443,7516417,'c8a',3.333,3),(696,7516444,7516417,'8a0',3.333,3),(696,7516445,7516417,'a07',3.333,3),(696,7516446,7516417,'072',3.333,3),(696,7516447,7516417,'72e',3.333,3),(696,7516448,7516418,'mon',100,1),(696,7516449,7516448,'201',50,1),(696,7516450,7516448,'013',50,1),(696,7516451,7516449,'adm',33.333,3),(696,7516452,7516449,'dmi',33.333,3),(696,7516453,7516449,'min',33.333,3),(696,7516454,7516451,'cap',16.667,1),(696,7516455,7516451,'apa',16.667,1),(696,7516456,7516451,'pac',16.667,1),(696,7516457,7516451,'aci',16.667,1),(696,7516458,7516451,'cit',16.667,1),(696,7516459,7516451,'ity',16.667,1),(696,7516460,7516454,'pat',50,1),(696,7516461,7516454,'ath',50,1),(696,7516462,7516460,'fre',14.286,1),(696,7516463,7516460,'ree',14.286,1),(696,7516464,7516460,'ees',14.286,1),(696,7516465,7516460,'esp',14.286,1),(696,7516466,7516460,'spa',14.286,1),(696,7516467,7516460,'pac',14.286,1),(696,7516468,7516460,'ace',14.286,1),(696,7516469,7516462,'dis',50,1),(696,7516470,7516462,'isk',50,1),(696,7516471,7516469,'ind',33.333,1),(696,7516472,7516469,'nde',33.333,1),(696,7516473,7516469,'dex',33.333,1),(696,7516474,7516471,'adm',8.333,1),(696,7516475,7516471,'dmi',8.333,1),(696,7516476,7516471,'min',8.333,1),(696,7516477,7516471,'ini',8.333,1),(696,7516478,7516471,'nis',8.333,1),(696,7516479,7516471,'ist',8.333,1),(696,7516480,7516471,'str',8.333,1),(696,7516481,7516471,'tra',8.333,1),(696,7516482,7516471,'rat',8.333,1),(696,7516483,7516471,'ati',8.333,1),(696,7516484,7516471,'tio',8.333,1),(696,7516485,7516471,'ion',8.333,1),(696,7516486,7516474,'sta',33.333,3),(696,7516487,7516474,'tat',33.333,3),(696,7516488,7516474,'ate',33.333,3),(696,7516489,7516486,'ena',20,2),(696,7516490,7516486,'nab',20,2),(696,7516491,7516486,'abl',20,2),(696,7516492,7516486,'ble',20,2),(696,7516493,7516486,'led',20,2),(696,7516494,7516489,'cac',33.333,2),(696,7516495,7516489,'ach',33.333,2),(696,7516496,7516489,'che',33.333,2),(696,7516497,7516494,'mod',50,1),(696,7516498,7516494,'ode',50,1),(696,7516499,7516497,'wri',14.286,1),(696,7516500,7516497,'rit',14.286,1),(696,7516501,7516497,'ite',14.286,1),(696,7516502,7516497,'tet',14.286,1),(696,7516503,7516497,'eth',14.286,1),(696,7516504,7516497,'thr',14.286,1),(696,7516505,7516497,'hru',14.286,1),(696,7516506,7516499,'ope',11.111,2),(696,7516507,7516499,'per',11.111,2),(696,7516508,7516499,'era',11.111,2),(696,7516509,7516499,'rat',11.111,2),(696,7516510,7516499,'ati',11.111,2),(696,7516511,7516499,'tio',11.111,2),(696,7516512,7516499,'ion',11.111,2),(696,7516513,7516499,'ona',11.111,2),(696,7516514,7516499,'nal',11.111,2),(696,7516515,7516506,'pen',20,1),(696,7516516,7516506,'end',20,1),(696,7516517,7516506,'ndi',20,1),(696,7516518,7516506,'din',20,1),(696,7516519,7516506,'ing',20,1),(696,7516520,7516515,'mes',20,1),(696,7516521,7516515,'ess',20,1),(696,7516522,7516515,'ssa',20,1),(696,7516523,7516515,'sag',20,1),(696,7516524,7516515,'age',20,1),(696,7516525,7516520,'wai',20,1),(696,7516526,7516520,'ait',20,1),(696,7516527,7516520,'iti',20,1),(696,7516528,7516520,'tin',20,1),(696,7516529,7516520,'ing',20,1),(696,7516530,7516525,'for',100,1),(696,7516531,7516530,'per',11.111,1),(696,7516532,7516530,'erf',11.111,1),(696,7516533,7516530,'rfo',11.111,1),(696,7516534,7516530,'for',11.111,1),(696,7516535,7516530,'orm',11.111,1),(696,7516536,7516530,'rma',11.111,1),(696,7516537,7516530,'man',11.111,1),(696,7516538,7516530,'anc',11.111,1),(696,7516539,7516530,'nce',11.111,1),(696,7516540,7516531,'ide',12.5,1),(696,7516541,7516531,'den',12.5,1),(696,7516542,7516531,'ent',12.5,1),(696,7516543,7516531,'nti',12.5,1),(696,7516544,7516531,'tif',12.5,1),(696,7516545,7516531,'ifi',12.5,1),(696,7516546,7516531,'fie',12.5,1),(696,7516547,7516531,'ier',12.5,1),(696,7516548,7516540,'vdi',33.333,3),(696,7516549,7516540,'dis',33.333,3),(696,7516550,7516540,'isk',33.333,3),(696,7516551,7516548,'nam',50,1),(696,7516552,7516548,'ame',50,1),(696,7516553,7516551,'typ',50,1),(696,7516554,7516551,'ype',50,1),(696,7516555,7516553,'dir',25,1),(696,7516556,7516553,'ire',25,1),(696,7516557,7516553,'rec',25,1),(696,7516558,7516553,'ect',25,1),(697,7516560,7516559,'naa',100,2),(697,7516561,7516560,'600',3.333,3),(697,7516562,7516560,'000',3.333,3),(697,7516563,7516560,'00c',3.333,3),(697,7516564,7516560,'0c2',3.333,3),(697,7516565,7516560,'c29',3.333,3),(697,7516566,7516560,'299',3.333,3),(697,7516567,7516560,'995',3.333,3),(697,7516568,7516560,'952',3.333,3),(697,7516569,7516560,'521',3.333,3),(697,7516570,7516560,'215',3.333,3),(697,7516571,7516560,'15e',3.333,3),(697,7516572,7516560,'5e4',3.333,3),(697,7516573,7516560,'e42',3.333,3),(697,7516574,7516560,'42f',3.333,3),(697,7516575,7516560,'2f5',3.333,3),(697,7516576,7516560,'f5f',3.333,3),(697,7516577,7516560,'5f2',3.333,3),(697,7516578,7516560,'f29',3.333,3),(697,7516579,7516560,'29e',3.333,3),(697,7516580,7516560,'9ea',3.333,3),(697,7516581,7516560,'ea7',3.333,3),(697,7516582,7516560,'a7c',3.333,3),(697,7516583,7516560,'7c0',3.333,3),(697,7516584,7516560,'c0a',3.333,3),(697,7516585,7516560,'0a3',3.333,3),(697,7516586,7516560,'a3f',3.333,3),(697,7516587,7516560,'3f1',3.333,3),(697,7516588,7516560,'f13',3.333,3),(697,7516589,7516560,'130',3.333,3),(697,7516590,7516560,'30e',3.333,3),(697,7516591,7516561,'mon',100,1),(697,7516592,7516591,'201',50,1),(697,7516593,7516591,'013',50,1),(697,7516594,7516592,'adm',33.333,3),(697,7516595,7516592,'dmi',33.333,3),(697,7516596,7516592,'min',33.333,3),(697,7516597,7516594,'cap',16.667,1),(697,7516598,7516594,'apa',16.667,1),(697,7516599,7516594,'pac',16.667,1),(697,7516600,7516594,'aci',16.667,1),(697,7516601,7516594,'cit',16.667,1),(697,7516602,7516594,'ity',16.667,1),(697,7516603,7516597,'pat',50,1),(697,7516604,7516597,'ath',50,1),(697,7516605,7516603,'fre',14.286,1),(697,7516606,7516603,'ree',14.286,1),(697,7516607,7516603,'ees',14.286,1),(697,7516608,7516603,'esp',14.286,1),(697,7516609,7516603,'spa',14.286,1),(697,7516610,7516603,'pac',14.286,1),(697,7516611,7516603,'ace',14.286,1),(697,7516612,7516605,'dis',50,1),(697,7516613,7516605,'isk',50,1),(697,7516614,7516612,'ind',33.333,1),(697,7516615,7516612,'nde',33.333,1),(697,7516616,7516612,'dex',33.333,1),(697,7516617,7516614,'adm',8.333,1),(697,7516618,7516614,'dmi',8.333,1),(697,7516619,7516614,'min',8.333,1),(697,7516620,7516614,'ini',8.333,1),(697,7516621,7516614,'nis',8.333,1),(697,7516622,7516614,'ist',8.333,1),(697,7516623,7516614,'str',8.333,1),(697,7516624,7516614,'tra',8.333,1),(697,7516625,7516614,'rat',8.333,1),(697,7516626,7516614,'ati',8.333,1),(697,7516627,7516614,'tio',8.333,1),(697,7516628,7516614,'ion',8.333,1),(697,7516629,7516617,'sta',33.333,3),(697,7516630,7516617,'tat',33.333,3),(697,7516631,7516617,'ate',33.333,3),(697,7516632,7516629,'ena',20,2),(697,7516633,7516629,'nab',20,2),(697,7516634,7516629,'abl',20,2),(697,7516635,7516629,'ble',20,2),(697,7516636,7516629,'led',20,2),(697,7516637,7516632,'cac',33.333,2),(697,7516638,7516632,'ach',33.333,2),(697,7516639,7516632,'che',33.333,2),(697,7516640,7516637,'mod',50,1),(697,7516641,7516637,'ode',50,1),(697,7516642,7516640,'wri',14.286,1),(697,7516643,7516640,'rit',14.286,1),(697,7516644,7516640,'ite',14.286,1),(697,7516645,7516640,'tet',14.286,1),(697,7516646,7516640,'eth',14.286,1),(697,7516647,7516640,'thr',14.286,1),(697,7516648,7516640,'hru',14.286,1),(697,7516649,7516642,'ope',11.111,2),(697,7516650,7516642,'per',11.111,2),(697,7516651,7516642,'era',11.111,2),(697,7516652,7516642,'rat',11.111,2),(697,7516653,7516642,'ati',11.111,2),(697,7516654,7516642,'tio',11.111,2),(697,7516655,7516642,'ion',11.111,2),(697,7516656,7516642,'ona',11.111,2),(697,7516657,7516642,'nal',11.111,2),(697,7516658,7516649,'pen',20,1),(697,7516659,7516649,'end',20,1),(697,7516660,7516649,'ndi',20,1),(697,7516661,7516649,'din',20,1),(697,7516662,7516649,'ing',20,1),(697,7516663,7516658,'mes',20,1),(697,7516664,7516658,'ess',20,1),(697,7516665,7516658,'ssa',20,1),(697,7516666,7516658,'sag',20,1),(697,7516667,7516658,'age',20,1),(697,7516668,7516663,'wai',20,1),(697,7516669,7516663,'ait',20,1),(697,7516670,7516663,'iti',20,1),(697,7516671,7516663,'tin',20,1),(697,7516672,7516663,'ing',20,1),(697,7516673,7516668,'for',100,1),(697,7516674,7516673,'per',11.111,1),(697,7516675,7516673,'erf',11.111,1),(697,7516676,7516673,'rfo',11.111,1),(697,7516677,7516673,'for',11.111,1),(697,7516678,7516673,'orm',11.111,1),(697,7516679,7516673,'rma',11.111,1),(697,7516680,7516673,'man',11.111,1),(697,7516681,7516673,'anc',11.111,1),(697,7516682,7516673,'nce',11.111,1),(697,7516683,7516674,'ide',12.5,1),(697,7516684,7516674,'den',12.5,1),(697,7516685,7516674,'ent',12.5,1),(697,7516686,7516674,'nti',12.5,1),(697,7516687,7516674,'tif',12.5,1),(697,7516688,7516674,'ifi',12.5,1),(697,7516689,7516674,'fie',12.5,1),(697,7516690,7516674,'ier',12.5,1),(697,7516691,7516683,'vdi',33.333,3),(697,7516692,7516683,'dis',33.333,3),(697,7516693,7516683,'isk',33.333,3),(697,7516694,7516691,'nam',50,1),(697,7516695,7516691,'ame',50,1),(697,7516696,7516694,'typ',50,1),(697,7516697,7516694,'ype',50,1),(697,7516698,7516696,'dir',25,1),(697,7516699,7516696,'ire',25,1),(697,7516700,7516696,'rec',25,1),(697,7516701,7516696,'ect',25,1),(698,7516703,7516702,'naa',100,2),(698,7516704,7516703,'600',3.333,3),(698,7516705,7516703,'000',3.333,3),(698,7516706,7516703,'00c',3.333,3),(698,7516707,7516703,'0c2',3.333,3),(698,7516708,7516703,'c29',3.333,3),(698,7516709,7516703,'29d',3.333,3),(698,7516710,7516703,'9d0',3.333,3),(698,7516711,7516703,'d0b',3.333,3),(698,7516712,7516703,'0bd',3.333,3),(698,7516713,7516703,'bdf',3.333,3),(698,7516714,7516703,'dfb',3.333,3),(698,7516715,7516703,'fb2',3.333,3),(698,7516716,7516703,'b23',3.333,3),(698,7516717,7516703,'234',3.333,3),(698,7516718,7516703,'340',3.333,3),(698,7516719,7516703,'40f',3.333,3),(698,7516720,7516703,'0f4',3.333,3),(698,7516721,7516703,'f41',3.333,3),(698,7516722,7516703,'414',3.333,3),(698,7516723,7516703,'148',3.333,3),(698,7516724,7516703,'48b',3.333,3),(698,7516725,7516703,'8bb',3.333,3),(698,7516726,7516703,'bb8',3.333,3),(698,7516727,7516703,'b8a',3.333,3),(698,7516728,7516703,'8a1',3.333,3),(698,7516729,7516703,'a19',3.333,3),(698,7516730,7516703,'198',3.333,3),(698,7516731,7516703,'985',3.333,3),(698,7516732,7516703,'857',3.333,3),(698,7516733,7516703,'57e',3.333,3),(698,7516734,7516704,'mon',100,1),(698,7516735,7516734,'201',50,1),(698,7516736,7516734,'013',50,1),(698,7516737,7516735,'adm',33.333,3),(698,7516738,7516735,'dmi',33.333,3),(698,7516739,7516735,'min',33.333,3),(698,7516740,7516737,'cap',16.667,1),(698,7516741,7516737,'apa',16.667,1),(698,7516742,7516737,'pac',16.667,1),(698,7516743,7516737,'aci',16.667,1),(698,7516744,7516737,'cit',16.667,1),(698,7516745,7516737,'ity',16.667,1),(698,7516746,7516740,'pat',50,1),(698,7516747,7516740,'ath',50,1),(698,7516748,7516746,'fre',14.286,1),(698,7516749,7516746,'ree',14.286,1),(698,7516750,7516746,'ees',14.286,1),(698,7516751,7516746,'esp',14.286,1),(698,7516752,7516746,'spa',14.286,1),(698,7516753,7516746,'pac',14.286,1),(698,7516754,7516746,'ace',14.286,1),(698,7516755,7516748,'dis',50,1),(698,7516756,7516748,'isk',50,1),(698,7516757,7516755,'ind',33.333,1),(698,7516758,7516755,'nde',33.333,1),(698,7516759,7516755,'dex',33.333,1),(698,7516760,7516757,'adm',8.333,1),(698,7516761,7516757,'dmi',8.333,1),(698,7516762,7516757,'min',8.333,1),(698,7516763,7516757,'ini',8.333,1),(698,7516764,7516757,'nis',8.333,1),(698,7516765,7516757,'ist',8.333,1),(698,7516766,7516757,'str',8.333,1),(698,7516767,7516757,'tra',8.333,1),(698,7516768,7516757,'rat',8.333,1),(698,7516769,7516757,'ati',8.333,1),(698,7516770,7516757,'tio',8.333,1),(698,7516771,7516757,'ion',8.333,1),(698,7516772,7516760,'sta',33.333,3),(698,7516773,7516760,'tat',33.333,3),(698,7516774,7516760,'ate',33.333,3),(698,7516775,7516772,'ena',20,2),(698,7516776,7516772,'nab',20,2),(698,7516777,7516772,'abl',20,2),(698,7516778,7516772,'ble',20,2),(698,7516779,7516772,'led',20,2),(698,7516780,7516775,'cac',33.333,2),(698,7516781,7516775,'ach',33.333,2),(698,7516782,7516775,'che',33.333,2),(698,7516783,7516780,'mod',50,1),(698,7516784,7516780,'ode',50,1),(698,7516785,7516783,'wri',14.286,1),(698,7516786,7516783,'rit',14.286,1),(698,7516787,7516783,'ite',14.286,1),(698,7516788,7516783,'tet',14.286,1),(698,7516789,7516783,'eth',14.286,1),(698,7516790,7516783,'thr',14.286,1),(698,7516791,7516783,'hru',14.286,1),(698,7516792,7516785,'ope',11.111,2),(698,7516793,7516785,'per',11.111,2),(698,7516794,7516785,'era',11.111,2),(698,7516795,7516785,'rat',11.111,2),(698,7516796,7516785,'ati',11.111,2),(698,7516797,7516785,'tio',11.111,2),(698,7516798,7516785,'ion',11.111,2),(698,7516799,7516785,'ona',11.111,2),(698,7516800,7516785,'nal',11.111,2),(698,7516801,7516792,'pen',20,1),(698,7516802,7516792,'end',20,1),(698,7516803,7516792,'ndi',20,1),(698,7516804,7516792,'din',20,1),(698,7516805,7516792,'ing',20,1),(698,7516806,7516801,'mes',20,1),(698,7516807,7516801,'ess',20,1),(698,7516808,7516801,'ssa',20,1),(698,7516809,7516801,'sag',20,1),(698,7516810,7516801,'age',20,1),(698,7516811,7516806,'wai',20,1),(698,7516812,7516806,'ait',20,1),(698,7516813,7516806,'iti',20,1),(698,7516814,7516806,'tin',20,1),(698,7516815,7516806,'ing',20,1),(698,7516816,7516811,'for',100,1),(698,7516817,7516816,'per',11.111,1),(698,7516818,7516816,'erf',11.111,1),(698,7516819,7516816,'rfo',11.111,1),(698,7516820,7516816,'for',11.111,1),(698,7516821,7516816,'orm',11.111,1),(698,7516822,7516816,'rma',11.111,1),(698,7516823,7516816,'man',11.111,1),(698,7516824,7516816,'anc',11.111,1),(698,7516825,7516816,'nce',11.111,1),(698,7516826,7516817,'ide',12.5,1),(698,7516827,7516817,'den',12.5,1),(698,7516828,7516817,'ent',12.5,1),(698,7516829,7516817,'nti',12.5,1),(698,7516830,7516817,'tif',12.5,1),(698,7516831,7516817,'ifi',12.5,1),(698,7516832,7516817,'fie',12.5,1),(698,7516833,7516817,'ier',12.5,1),(698,7516834,7516826,'vdi',33.333,3),(698,7516835,7516826,'dis',33.333,3),(698,7516836,7516826,'isk',33.333,3),(698,7516837,7516834,'nam',50,1),(698,7516838,7516834,'ame',50,1),(698,7516839,7516837,'typ',50,1),(698,7516840,7516837,'ype',50,1),(698,7516841,7516839,'dir',25,1),(698,7516842,7516839,'ire',25,1),(698,7516843,7516839,'rec',25,1),(698,7516844,7516839,'ect',25,1),(699,7516846,7516845,'naa',100,2),(699,7516847,7516846,'600',3.333,3),(699,7516848,7516846,'000',3.333,3),(699,7516849,7516846,'00c',3.333,3),(699,7516850,7516846,'0c2',3.333,3),(699,7516851,7516846,'c29',3.333,3),(699,7516852,7516846,'29d',3.333,3),(699,7516853,7516846,'9d4',3.333,3),(699,7516854,7516846,'d45',3.333,3),(699,7516855,7516846,'45c',3.333,3),(699,7516856,7516846,'5c3',3.333,3),(699,7516857,7516846,'c31',3.333,3),(699,7516858,7516846,'311',3.333,3),(699,7516859,7516846,'110',3.333,3),(699,7516860,7516846,'106',3.333,3),(699,7516861,7516846,'06b',3.333,3),(699,7516862,7516846,'6be',3.333,3),(699,7516863,7516846,'bef',3.333,3),(699,7516864,7516846,'eff',3.333,3),(699,7516865,7516846,'fff',3.333,3),(699,7516866,7516846,'ff4',3.333,3),(699,7516867,7516846,'f47',3.333,3),(699,7516868,7516846,'47a',3.333,3),(699,7516869,7516846,'7ab',3.333,3),(699,7516870,7516846,'abc',3.333,3),(699,7516871,7516846,'bc8',3.333,3),(699,7516872,7516846,'c85',3.333,3),(699,7516873,7516846,'857',3.333,3),(699,7516874,7516846,'57a',3.333,3),(699,7516875,7516846,'7a9',3.333,3),(699,7516876,7516846,'a9f',3.333,3),(699,7516877,7516847,'mon',100,1),(699,7516878,7516877,'201',50,1),(699,7516879,7516877,'013',50,1),(699,7516880,7516878,'adm',33.333,3),(699,7516881,7516878,'dmi',33.333,3),(699,7516882,7516878,'min',33.333,3),(699,7516883,7516880,'cap',16.667,1),(699,7516884,7516880,'apa',16.667,1),(699,7516885,7516880,'pac',16.667,1),(699,7516886,7516880,'aci',16.667,1),(699,7516887,7516880,'cit',16.667,1),(699,7516888,7516880,'ity',16.667,1),(699,7516889,7516883,'pat',50,1),(699,7516890,7516883,'ath',50,1),(699,7516891,7516889,'fre',14.286,1),(699,7516892,7516889,'ree',14.286,1),(699,7516893,7516889,'ees',14.286,1),(699,7516894,7516889,'esp',14.286,1),(699,7516895,7516889,'spa',14.286,1),(699,7516896,7516889,'pac',14.286,1),(699,7516897,7516889,'ace',14.286,1),(699,7516898,7516891,'dis',50,1),(699,7516899,7516891,'isk',50,1),(699,7516900,7516898,'ind',33.333,1),(699,7516901,7516898,'nde',33.333,1),(699,7516902,7516898,'dex',33.333,1),(699,7516903,7516900,'adm',8.333,1),(699,7516904,7516900,'dmi',8.333,1),(699,7516905,7516900,'min',8.333,1),(699,7516906,7516900,'ini',8.333,1),(699,7516907,7516900,'nis',8.333,1),(699,7516908,7516900,'ist',8.333,1),(699,7516909,7516900,'str',8.333,1),(699,7516910,7516900,'tra',8.333,1),(699,7516911,7516900,'rat',8.333,1),(699,7516912,7516900,'ati',8.333,1),(699,7516913,7516900,'tio',8.333,1),(699,7516914,7516900,'ion',8.333,1),(699,7516915,7516903,'sta',33.333,3),(699,7516916,7516903,'tat',33.333,3),(699,7516917,7516903,'ate',33.333,3),(699,7516918,7516915,'ena',20,2),(699,7516919,7516915,'nab',20,2),(699,7516920,7516915,'abl',20,2),(699,7516921,7516915,'ble',20,2),(699,7516922,7516915,'led',20,2),(699,7516923,7516918,'cac',33.333,2),(699,7516924,7516918,'ach',33.333,2),(699,7516925,7516918,'che',33.333,2),(699,7516926,7516923,'mod',50,1),(699,7516927,7516923,'ode',50,1),(699,7516928,7516926,'wri',14.286,1),(699,7516929,7516926,'rit',14.286,1),(699,7516930,7516926,'ite',14.286,1),(699,7516931,7516926,'tet',14.286,1),(699,7516932,7516926,'eth',14.286,1),(699,7516933,7516926,'thr',14.286,1),(699,7516934,7516926,'hru',14.286,1),(699,7516935,7516928,'ope',11.111,2),(699,7516936,7516928,'per',11.111,2),(699,7516937,7516928,'era',11.111,2),(699,7516938,7516928,'rat',11.111,2),(699,7516939,7516928,'ati',11.111,2),(699,7516940,7516928,'tio',11.111,2),(699,7516941,7516928,'ion',11.111,2),(699,7516942,7516928,'ona',11.111,2),(699,7516943,7516928,'nal',11.111,2),(699,7516944,7516935,'pen',20,1),(699,7516945,7516935,'end',20,1),(699,7516946,7516935,'ndi',20,1),(699,7516947,7516935,'din',20,1),(699,7516948,7516935,'ing',20,1),(699,7516949,7516944,'mes',20,1),(699,7516950,7516944,'ess',20,1),(699,7516951,7516944,'ssa',20,1),(699,7516952,7516944,'sag',20,1),(699,7516953,7516944,'age',20,1),(699,7516954,7516949,'wai',20,1),(699,7516955,7516949,'ait',20,1),(699,7516956,7516949,'iti',20,1),(699,7516957,7516949,'tin',20,1),(699,7516958,7516949,'ing',20,1),(699,7516959,7516954,'for',100,1),(699,7516960,7516959,'per',11.111,1),(699,7516961,7516959,'erf',11.111,1),(699,7516962,7516959,'rfo',11.111,1),(699,7516963,7516959,'for',11.111,1),(699,7516964,7516959,'orm',11.111,1),(699,7516965,7516959,'rma',11.111,1),(699,7516966,7516959,'man',11.111,1),(699,7516967,7516959,'anc',11.111,1),(699,7516968,7516959,'nce',11.111,1),(699,7516969,7516960,'ide',12.5,1),(699,7516970,7516960,'den',12.5,1),(699,7516971,7516960,'ent',12.5,1),(699,7516972,7516960,'nti',12.5,1),(699,7516973,7516960,'tif',12.5,1),(699,7516974,7516960,'ifi',12.5,1),(699,7516975,7516960,'fie',12.5,1),(699,7516976,7516960,'ier',12.5,1),(699,7516977,7516969,'vdi',33.333,3),(699,7516978,7516969,'dis',33.333,3),(699,7516979,7516969,'isk',33.333,3),(699,7516980,7516977,'nam',50,1),(699,7516981,7516977,'ame',50,1),(699,7516982,7516980,'typ',50,1),(699,7516983,7516980,'ype',50,1),(699,7516984,7516982,'dir',25,1),(699,7516985,7516982,'ire',25,1),(699,7516986,7516982,'rec',25,1),(699,7516987,7516982,'ect',25,1),(700,7516989,7516988,'naa',100,2),(700,7516990,7516989,'600',3.333,3),(700,7516991,7516989,'000',3.333,3),(700,7516992,7516989,'00c',3.333,3),(700,7516993,7516989,'0c2',3.333,3),(700,7516994,7516989,'c29',3.333,3),(700,7516995,7516989,'296',3.333,3),(700,7516996,7516989,'968',3.333,3),(700,7516997,7516989,'688',3.333,3),(700,7516998,7516989,'88e',3.333,3),(700,7516999,7516989,'8e0',3.333,3),(700,7517000,7516989,'e00',3.333,3),(700,7517001,7516989,'00a',3.333,3),(700,7517002,7516989,'0a8',3.333,3),(700,7517003,7516989,'a8a',3.333,3),(700,7517004,7516989,'8a5',3.333,3),(700,7517005,7516989,'a55',3.333,3),(700,7517006,7516989,'55f',3.333,3),(700,7517007,7516989,'5f1',3.333,3),(700,7517008,7516989,'f1e',3.333,3),(700,7517009,7516989,'1e8',3.333,3),(700,7517010,7516989,'e8d',3.333,3),(700,7517011,7516989,'8de',3.333,3),(700,7517012,7516989,'dec',3.333,3),(700,7517013,7516989,'ec4',3.333,3),(700,7517014,7516989,'c46',3.333,3),(700,7517015,7516989,'469',3.333,3),(700,7517016,7516989,'69e',3.333,3),(700,7517017,7516989,'9e8',3.333,3),(700,7517018,7516989,'e87',3.333,3),(700,7517019,7516989,'878',3.333,3),(700,7517020,7516990,'mon',100,1),(700,7517021,7517020,'201',50,1),(700,7517022,7517020,'013',50,1),(700,7517023,7517021,'adm',33.333,3),(700,7517024,7517021,'dmi',33.333,3),(700,7517025,7517021,'min',33.333,3),(700,7517026,7517023,'cap',16.667,1),(700,7517027,7517023,'apa',16.667,1),(700,7517028,7517023,'pac',16.667,1),(700,7517029,7517023,'aci',16.667,1),(700,7517030,7517023,'cit',16.667,1),(700,7517031,7517023,'ity',16.667,1),(700,7517032,7517026,'pat',50,1),(700,7517033,7517026,'ath',50,1),(700,7517034,7517032,'fre',14.286,1),(700,7517035,7517032,'ree',14.286,1),(700,7517036,7517032,'ees',14.286,1),(700,7517037,7517032,'esp',14.286,1),(700,7517038,7517032,'spa',14.286,1),(700,7517039,7517032,'pac',14.286,1),(700,7517040,7517032,'ace',14.286,1),(700,7517041,7517034,'dis',50,1),(700,7517042,7517034,'isk',50,1),(700,7517043,7517041,'ind',33.333,1),(700,7517044,7517041,'nde',33.333,1),(700,7517045,7517041,'dex',33.333,1),(700,7517046,7517043,'adm',8.333,1),(700,7517047,7517043,'dmi',8.333,1),(700,7517048,7517043,'min',8.333,1),(700,7517049,7517043,'ini',8.333,1),(700,7517050,7517043,'nis',8.333,1),(700,7517051,7517043,'ist',8.333,1),(700,7517052,7517043,'str',8.333,1),(700,7517053,7517043,'tra',8.333,1),(700,7517054,7517043,'rat',8.333,1),(700,7517055,7517043,'ati',8.333,1),(700,7517056,7517043,'tio',8.333,1),(700,7517057,7517043,'ion',8.333,1),(700,7517058,7517046,'sta',33.333,3),(700,7517059,7517046,'tat',33.333,3),(700,7517060,7517046,'ate',33.333,3),(700,7517061,7517058,'ena',20,2),(700,7517062,7517058,'nab',20,2),(700,7517063,7517058,'abl',20,2),(700,7517064,7517058,'ble',20,2),(700,7517065,7517058,'led',20,2),(700,7517066,7517061,'cac',33.333,2),(700,7517067,7517061,'ach',33.333,2),(700,7517068,7517061,'che',33.333,2),(700,7517069,7517066,'mod',50,1),(700,7517070,7517066,'ode',50,1),(700,7517071,7517069,'wri',14.286,1),(700,7517072,7517069,'rit',14.286,1),(700,7517073,7517069,'ite',14.286,1),(700,7517074,7517069,'tet',14.286,1),(700,7517075,7517069,'eth',14.286,1),(700,7517076,7517069,'thr',14.286,1),(700,7517077,7517069,'hru',14.286,1),(700,7517078,7517071,'ope',11.111,2),(700,7517079,7517071,'per',11.111,2),(700,7517080,7517071,'era',11.111,2),(700,7517081,7517071,'rat',11.111,2),(700,7517082,7517071,'ati',11.111,2),(700,7517083,7517071,'tio',11.111,2),(700,7517084,7517071,'ion',11.111,2),(700,7517085,7517071,'ona',11.111,2),(700,7517086,7517071,'nal',11.111,2),(700,7517087,7517078,'pen',20,1),(700,7517088,7517078,'end',20,1),(700,7517089,7517078,'ndi',20,1),(700,7517090,7517078,'din',20,1),(700,7517091,7517078,'ing',20,1),(700,7517092,7517087,'mes',20,1),(700,7517093,7517087,'ess',20,1),(700,7517094,7517087,'ssa',20,1),(700,7517095,7517087,'sag',20,1),(700,7517096,7517087,'age',20,1),(700,7517097,7517092,'wai',20,1),(700,7517098,7517092,'ait',20,1),(700,7517099,7517092,'iti',20,1),(700,7517100,7517092,'tin',20,1),(700,7517101,7517092,'ing',20,1),(700,7517102,7517097,'for',100,1),(700,7517103,7517102,'per',11.111,1),(700,7517104,7517102,'erf',11.111,1),(700,7517105,7517102,'rfo',11.111,1),(700,7517106,7517102,'for',11.111,1),(700,7517107,7517102,'orm',11.111,1),(700,7517108,7517102,'rma',11.111,1),(700,7517109,7517102,'man',11.111,1),(700,7517110,7517102,'anc',11.111,1),(700,7517111,7517102,'nce',11.111,1),(700,7517112,7517103,'ide',12.5,1),(700,7517113,7517103,'den',12.5,1),(700,7517114,7517103,'ent',12.5,1),(700,7517115,7517103,'nti',12.5,1),(700,7517116,7517103,'tif',12.5,1),(700,7517117,7517103,'ifi',12.5,1),(700,7517118,7517103,'fie',12.5,1),(700,7517119,7517103,'ier',12.5,1),(700,7517120,7517112,'vdi',33.333,3),(700,7517121,7517112,'dis',33.333,3),(700,7517122,7517112,'isk',33.333,3),(700,7517123,7517120,'nam',50,1),(700,7517124,7517120,'ame',50,1),(700,7517125,7517123,'typ',50,1),(700,7517126,7517123,'ype',50,1),(700,7517127,7517125,'dir',25,1),(700,7517128,7517125,'ire',25,1),(700,7517129,7517125,'rec',25,1),(700,7517130,7517125,'ect',25,1),(701,7517132,7517131,'naa',100,2),(701,7517133,7517132,'600',3.333,3),(701,7517134,7517132,'000',3.333,3),(701,7517135,7517132,'00c',3.333,3),(701,7517136,7517132,'0c2',3.333,3),(701,7517137,7517132,'c29',3.333,3),(701,7517138,7517132,'29e',3.333,3),(701,7517139,7517132,'9e7',3.333,3),(701,7517140,7517132,'e74',3.333,3),(701,7517141,7517132,'741',3.333,3),(701,7517142,7517132,'41b',3.333,3),(701,7517143,7517132,'1bd',3.333,3),(701,7517144,7517132,'bd1',3.333,3),(701,7517145,7517132,'d1f',3.333,3),(701,7517146,7517132,'1fa',3.333,3),(701,7517147,7517132,'fad',3.333,3),(701,7517148,7517132,'adb',3.333,3),(701,7517149,7517132,'db7',3.333,3),(701,7517150,7517132,'b71',3.333,3),(701,7517151,7517132,'711',3.333,3),(701,7517152,7517132,'11c',3.333,3),(701,7517153,7517132,'1c4',3.333,3),(701,7517154,7517132,'c48',3.333,3),(701,7517155,7517132,'48b',3.333,3),(701,7517156,7517132,'8be',3.333,3),(701,7517157,7517132,'be2',3.333,3),(701,7517158,7517132,'e21',3.333,3),(701,7517159,7517132,'212',3.333,3),(701,7517160,7517132,'129',3.333,3),(701,7517161,7517132,'29d',3.333,3),(701,7517162,7517132,'9d8',3.333,3),(701,7517163,7517133,'mon',100,1),(701,7517164,7517163,'201',50,1),(701,7517165,7517163,'013',50,1),(701,7517166,7517164,'adm',33.333,3),(701,7517167,7517164,'dmi',33.333,3),(701,7517168,7517164,'min',33.333,3),(701,7517169,7517166,'cap',16.667,1),(701,7517170,7517166,'apa',16.667,1),(701,7517171,7517166,'pac',16.667,1),(701,7517172,7517166,'aci',16.667,1),(701,7517173,7517166,'cit',16.667,1),(701,7517174,7517166,'ity',16.667,1),(701,7517175,7517169,'pat',50,1),(701,7517176,7517169,'ath',50,1),(701,7517177,7517175,'fre',14.286,1),(701,7517178,7517175,'ree',14.286,1),(701,7517179,7517175,'ees',14.286,1),(701,7517180,7517175,'esp',14.286,1),(701,7517181,7517175,'spa',14.286,1),(701,7517182,7517175,'pac',14.286,1),(701,7517183,7517175,'ace',14.286,1),(701,7517184,7517177,'dis',50,1),(701,7517185,7517177,'isk',50,1),(701,7517186,7517184,'ind',33.333,1),(701,7517187,7517184,'nde',33.333,1),(701,7517188,7517184,'dex',33.333,1),(701,7517189,7517186,'adm',8.333,1),(701,7517190,7517186,'dmi',8.333,1),(701,7517191,7517186,'min',8.333,1),(701,7517192,7517186,'ini',8.333,1),(701,7517193,7517186,'nis',8.333,1),(701,7517194,7517186,'ist',8.333,1),(701,7517195,7517186,'str',8.333,1),(701,7517196,7517186,'tra',8.333,1),(701,7517197,7517186,'rat',8.333,1),(701,7517198,7517186,'ati',8.333,1),(701,7517199,7517186,'tio',8.333,1),(701,7517200,7517186,'ion',8.333,1),(701,7517201,7517189,'sta',33.333,3),(701,7517202,7517189,'tat',33.333,3),(701,7517203,7517189,'ate',33.333,3),(701,7517204,7517201,'ena',20,2),(701,7517205,7517201,'nab',20,2),(701,7517206,7517201,'abl',20,2),(701,7517207,7517201,'ble',20,2),(701,7517208,7517201,'led',20,2),(701,7517209,7517204,'cac',33.333,2),(701,7517210,7517204,'ach',33.333,2),(701,7517211,7517204,'che',33.333,2),(701,7517212,7517209,'mod',50,1),(701,7517213,7517209,'ode',50,1),(701,7517214,7517212,'wri',14.286,1),(701,7517215,7517212,'rit',14.286,1),(701,7517216,7517212,'ite',14.286,1),(701,7517217,7517212,'tet',14.286,1),(701,7517218,7517212,'eth',14.286,1),(701,7517219,7517212,'thr',14.286,1),(701,7517220,7517212,'hru',14.286,1),(701,7517221,7517214,'ope',11.111,2),(701,7517222,7517214,'per',11.111,2),(701,7517223,7517214,'era',11.111,2),(701,7517224,7517214,'rat',11.111,2),(701,7517225,7517214,'ati',11.111,2),(701,7517226,7517214,'tio',11.111,2),(701,7517227,7517214,'ion',11.111,2),(701,7517228,7517214,'ona',11.111,2),(701,7517229,7517214,'nal',11.111,2),(701,7517230,7517221,'pen',20,1),(701,7517231,7517221,'end',20,1),(701,7517232,7517221,'ndi',20,1),(701,7517233,7517221,'din',20,1),(701,7517234,7517221,'ing',20,1),(701,7517235,7517230,'mes',20,1),(701,7517236,7517230,'ess',20,1),(701,7517237,7517230,'ssa',20,1),(701,7517238,7517230,'sag',20,1),(701,7517239,7517230,'age',20,1),(701,7517240,7517235,'wai',20,1),(701,7517241,7517235,'ait',20,1),(701,7517242,7517235,'iti',20,1),(701,7517243,7517235,'tin',20,1),(701,7517244,7517235,'ing',20,1),(701,7517245,7517240,'for',100,1),(701,7517246,7517245,'per',11.111,1),(701,7517247,7517245,'erf',11.111,1),(701,7517248,7517245,'rfo',11.111,1),(701,7517249,7517245,'for',11.111,1),(701,7517250,7517245,'orm',11.111,1),(701,7517251,7517245,'rma',11.111,1),(701,7517252,7517245,'man',11.111,1),(701,7517253,7517245,'anc',11.111,1),(701,7517254,7517245,'nce',11.111,1),(701,7517255,7517246,'ide',12.5,1),(701,7517256,7517246,'den',12.5,1),(701,7517257,7517246,'ent',12.5,1),(701,7517258,7517246,'nti',12.5,1),(701,7517259,7517246,'tif',12.5,1),(701,7517260,7517246,'ifi',12.5,1),(701,7517261,7517246,'fie',12.5,1),(701,7517262,7517246,'ier',12.5,1),(701,7517263,7517255,'vdi',33.333,3),(701,7517264,7517255,'dis',33.333,3),(701,7517265,7517255,'isk',33.333,3),(701,7517266,7517263,'nam',50,1),(701,7517267,7517263,'ame',50,1),(701,7517268,7517266,'typ',50,1),(701,7517269,7517266,'ype',50,1),(701,7517270,7517268,'dir',25,1),(701,7517271,7517268,'ire',25,1),(701,7517272,7517268,'rec',25,1),(701,7517273,7517268,'ect',25,1),(702,7517275,7517274,'naa',100,2),(702,7517276,7517275,'600',3.333,3),(702,7517277,7517275,'000',3.333,3),(702,7517278,7517275,'00c',3.333,3),(702,7517279,7517275,'0c2',3.333,3),(702,7517280,7517275,'c29',3.333,3),(702,7517281,7517275,'291',3.333,3),(702,7517282,7517275,'91d',3.333,3),(702,7517283,7517275,'1dc',3.333,3),(702,7517284,7517275,'dcf',3.333,3),(702,7517285,7517275,'cf2',3.333,3),(702,7517286,7517275,'f2c',3.333,3),(702,7517287,7517275,'2c1',3.333,3),(702,7517288,7517275,'c1d',3.333,3),(702,7517289,7517275,'1df',3.333,3),(702,7517290,7517275,'df7',3.333,3),(702,7517291,7517275,'f7c',3.333,3),(702,7517292,7517275,'7cf',3.333,3),(702,7517293,7517275,'cfb',3.333,3),(702,7517294,7517275,'fb2',3.333,3),(702,7517295,7517275,'b20',3.333,3),(702,7517296,7517275,'205',3.333,3),(702,7517297,7517275,'05a',3.333,3),(702,7517298,7517275,'5a2',3.333,3),(702,7517299,7517275,'a2e',3.333,3),(702,7517300,7517275,'2e1',3.333,3),(702,7517301,7517275,'e11',3.333,3),(702,7517302,7517275,'11f',3.333,3),(702,7517303,7517275,'1ff',3.333,3),(702,7517304,7517275,'ffa',3.333,3),(702,7517305,7517275,'faf',3.333,3),(702,7517306,7517276,'mon',100,1),(702,7517307,7517306,'201',50,1),(702,7517308,7517306,'013',50,1),(702,7517309,7517307,'adm',33.333,3),(702,7517310,7517307,'dmi',33.333,3),(702,7517311,7517307,'min',33.333,3),(702,7517312,7517309,'cap',16.667,1),(702,7517313,7517309,'apa',16.667,1),(702,7517314,7517309,'pac',16.667,1),(702,7517315,7517309,'aci',16.667,1),(702,7517316,7517309,'cit',16.667,1),(702,7517317,7517309,'ity',16.667,1),(702,7517318,7517312,'pat',50,1),(702,7517319,7517312,'ath',50,1),(702,7517320,7517318,'fre',14.286,1),(702,7517321,7517318,'ree',14.286,1),(702,7517322,7517318,'ees',14.286,1),(702,7517323,7517318,'esp',14.286,1),(702,7517324,7517318,'spa',14.286,1),(702,7517325,7517318,'pac',14.286,1),(702,7517326,7517318,'ace',14.286,1),(702,7517327,7517320,'dis',50,1),(702,7517328,7517320,'isk',50,1),(702,7517329,7517327,'ind',33.333,1),(702,7517330,7517327,'nde',33.333,1),(702,7517331,7517327,'dex',33.333,1),(702,7517332,7517329,'adm',8.333,1),(702,7517333,7517329,'dmi',8.333,1),(702,7517334,7517329,'min',8.333,1),(702,7517335,7517329,'ini',8.333,1),(702,7517336,7517329,'nis',8.333,1),(702,7517337,7517329,'ist',8.333,1),(702,7517338,7517329,'str',8.333,1),(702,7517339,7517329,'tra',8.333,1),(702,7517340,7517329,'rat',8.333,1),(702,7517341,7517329,'ati',8.333,1),(702,7517342,7517329,'tio',8.333,1),(702,7517343,7517329,'ion',8.333,1),(702,7517344,7517332,'sta',33.333,3),(702,7517345,7517332,'tat',33.333,3),(702,7517346,7517332,'ate',33.333,3),(702,7517347,7517344,'ena',20,2),(702,7517348,7517344,'nab',20,2),(702,7517349,7517344,'abl',20,2),(702,7517350,7517344,'ble',20,2),(702,7517351,7517344,'led',20,2),(702,7517352,7517347,'cac',33.333,2),(702,7517353,7517347,'ach',33.333,2),(702,7517354,7517347,'che',33.333,2),(702,7517355,7517352,'mod',50,1),(702,7517356,7517352,'ode',50,1),(702,7517357,7517355,'wri',14.286,1),(702,7517358,7517355,'rit',14.286,1),(702,7517359,7517355,'ite',14.286,1),(702,7517360,7517355,'tet',14.286,1),(702,7517361,7517355,'eth',14.286,1),(702,7517362,7517355,'thr',14.286,1),(702,7517363,7517355,'hru',14.286,1),(702,7517364,7517357,'ope',11.111,2),(702,7517365,7517357,'per',11.111,2),(702,7517366,7517357,'era',11.111,2),(702,7517367,7517357,'rat',11.111,2),(702,7517368,7517357,'ati',11.111,2),(702,7517369,7517357,'tio',11.111,2),(702,7517370,7517357,'ion',11.111,2),(702,7517371,7517357,'ona',11.111,2),(702,7517372,7517357,'nal',11.111,2),(702,7517373,7517364,'pen',20,1),(702,7517374,7517364,'end',20,1),(702,7517375,7517364,'ndi',20,1),(702,7517376,7517364,'din',20,1),(702,7517377,7517364,'ing',20,1),(702,7517378,7517373,'mes',20,1),(702,7517379,7517373,'ess',20,1),(702,7517380,7517373,'ssa',20,1),(702,7517381,7517373,'sag',20,1),(702,7517382,7517373,'age',20,1),(702,7517383,7517378,'wai',20,1),(702,7517384,7517378,'ait',20,1),(702,7517385,7517378,'iti',20,1),(702,7517386,7517378,'tin',20,1),(702,7517387,7517378,'ing',20,1),(702,7517388,7517383,'for',100,1),(702,7517389,7517388,'per',11.111,1),(702,7517390,7517388,'erf',11.111,1),(702,7517391,7517388,'rfo',11.111,1),(702,7517392,7517388,'for',11.111,1),(702,7517393,7517388,'orm',11.111,1),(702,7517394,7517388,'rma',11.111,1),(702,7517395,7517388,'man',11.111,1),(702,7517396,7517388,'anc',11.111,1),(702,7517397,7517388,'nce',11.111,1),(702,7517398,7517389,'ide',12.5,1),(702,7517399,7517389,'den',12.5,1),(702,7517400,7517389,'ent',12.5,1),(702,7517401,7517389,'nti',12.5,1),(702,7517402,7517389,'tif',12.5,1),(702,7517403,7517389,'ifi',12.5,1),(702,7517404,7517389,'fie',12.5,1),(702,7517405,7517389,'ier',12.5,1),(702,7517406,7517398,'vdi',33.333,3),(702,7517407,7517398,'dis',33.333,3),(702,7517408,7517398,'isk',33.333,3),(702,7517409,7517406,'nam',50,1),(702,7517410,7517406,'ame',50,1),(702,7517411,7517409,'typ',50,1),(702,7517412,7517409,'ype',50,1),(702,7517413,7517411,'dir',25,1),(702,7517414,7517411,'ire',25,1),(702,7517415,7517411,'rec',25,1),(702,7517416,7517411,'ect',25,1),(643,7517608,7517607,'att',12.5,1),(643,7517609,7517607,'ttr',12.5,1),(643,7517610,7517607,'tri',12.5,1),(643,7517611,7517607,'rib',12.5,1),(643,7517612,7517607,'ibu',12.5,1),(643,7517613,7517607,'but',12.5,1),(643,7517614,7517607,'ute',12.5,1),(643,7517615,7517607,'tes',12.5,1),(643,7517616,7517608,'ref',20,3),(643,7517617,7517608,'efr',20,3),(643,7517618,7517608,'fre',20,3),(643,7517619,7517608,'res',20,3),(643,7517620,7517608,'esh',20,3),(643,7517621,7517616,'hos',50,2),(643,7517622,7517616,'ost',50,2),(643,7517623,7517621,'nam',50,2),(643,7517624,7517621,'ame',50,2),(643,7517625,7517623,'hg3',9.091,1),(643,7517626,7517623,'g32',9.091,1),(643,7517627,7517623,'32v',9.091,1),(643,7517628,7517623,'2vm',9.091,1),(643,7517629,7517623,'vm8',9.091,1),(643,7517630,7517623,'m8w',9.091,1),(643,7517631,7517623,'8w2',9.091,1),(643,7517632,7517623,'w2k',9.091,1),(643,7517633,7517623,'2k8',9.091,1),(643,7517634,7517623,'k8r',9.091,1),(643,7517635,7517623,'8r2',9.091,1),(643,7517636,7517625,'gdl',100,1),(643,7517637,7517636,'eng',25,1),(643,7517638,7517636,'ngl',25,1),(643,7517639,7517636,'gla',25,1),(643,7517640,7517636,'lab',25,1),(643,7517641,7517637,'net',25,1),(643,7517642,7517637,'eta',25,1),(643,7517643,7517637,'tap',25,1),(643,7517644,7517637,'app',25,1),(643,7517645,7517641,'com',100,1),(643,7517646,7517645,'mem',25,3),(643,7517647,7517645,'emo',25,3),(643,7517648,7517645,'mor',25,3),(643,7517649,7517645,'ory',25,3),(643,7517650,7517646,'siz',50,2),(643,7517651,7517646,'ize',50,2),(643,7517652,7517650,'614',50,1),(643,7517653,7517650,'144',50,1),(643,7517654,7517652,'cpu',100,1),(643,7517655,7517654,'usa',33.333,3),(643,7517656,7517654,'sag',33.333,3),(643,7517657,7517654,'age',33.333,3),(643,7517658,7517655,'mhz',100,1),(643,7517659,7517658,'add',20,1),(643,7517660,7517658,'ddr',20,1),(643,7517661,7517658,'dre',20,1),(643,7517662,7517658,'res',20,1),(643,7517663,7517658,'ess',20,1),(643,7517664,7517659,'226',100,1),(643,7517665,7517664,'147',100,1),(643,7517666,7517665,'210',100,1),(643,7517667,7517666,'400',50,1),(643,7517668,7517666,'004',50,1),(643,7517669,7517667,'gue',33.333,2),(643,7517670,7517667,'ues',33.333,2),(643,7517671,7517667,'est',33.333,2),(643,7517672,7517669,'vmw',25,2),(643,7517673,7517669,'mwa',25,2),(643,7517674,7517669,'war',25,2),(643,7517675,7517669,'are',25,2),(643,7517676,7517672,'too',33.333,2),(643,7517677,7517672,'ool',33.333,2),(643,7517678,7517672,'ols',33.333,2),(643,7517679,7517676,'run',20,1),(643,7517680,7517676,'unn',20,1),(643,7517681,7517676,'nni',20,1),(643,7517682,7517676,'nin',20,1),(643,7517683,7517676,'ing',20,1),(643,7517684,7517679,'and',100,1),(643,7517685,7517684,'the',100,1),(643,7517686,7517685,'ver',20,2),(643,7517687,7517685,'ers',20,2),(643,7517688,7517685,'rsi',20,2),(643,7517689,7517685,'sio',20,2),(643,7517690,7517685,'ion',20,2),(643,7517691,7517686,'cur',20,1),(643,7517692,7517686,'urr',20,1),(643,7517693,7517686,'rre',20,1),(643,7517694,7517686,'ren',20,1),(643,7517695,7517686,'ent',20,1),(643,7517696,7517691,'mic',14.286,1),(643,7517697,7517691,'icr',14.286,1),(643,7517698,7517691,'cro',14.286,1),(643,7517699,7517691,'ros',14.286,1),(643,7517700,7517691,'oso',14.286,1),(643,7517701,7517691,'sof',14.286,1),(643,7517702,7517691,'oft',14.286,1),(643,7517703,7517696,'win',20,1),(643,7517704,7517696,'ind',20,1),(643,7517705,7517696,'ndo',20,1),(643,7517706,7517696,'dow',20,1),(643,7517707,7517696,'ows',20,1),(643,7517708,7517703,'ser',25,1),(643,7517709,7517703,'erv',25,1),(643,7517710,7517703,'rve',25,1),(643,7517711,7517703,'ver',25,1),(643,7517712,7517708,'200',50,1),(643,7517713,7517708,'008',50,1),(643,7517714,7517712,'64b',33.333,1),(643,7517715,7517712,'4bi',33.333,1),(643,7517716,7517712,'bit',33.333,1),(643,7517717,7517714,'pat',50,1),(643,7517718,7517714,'ath',50,1),(643,7517719,7517717,'rx6',33.333,1),(643,7517720,7517717,'x60',33.333,1),(643,7517721,7517717,'600',33.333,1),(643,7517722,7517719,'vmf',20,1),(643,7517723,7517719,'mfi',20,1),(643,7517724,7517719,'fil',20,1),(643,7517725,7517719,'ile',20,1),(643,7517726,7517719,'les',20,1),(643,7517727,7517722,'hgw',9.091,2),(643,7517728,7517722,'gw2',9.091,2),(643,7517729,7517722,'w2k',9.091,2),(643,7517730,7517722,'2k8',9.091,2),(643,7517731,7517722,'k8r',9.091,2),(643,7517732,7517722,'8r2',9.091,2),(643,7517733,7517722,'r23',9.091,2),(643,7517734,7517722,'232',9.091,2),(643,7517735,7517722,'32v',9.091,2),(643,7517736,7517722,'2vm',9.091,2),(643,7517737,7517722,'vm8',9.091,2),(643,7517738,7517727,'vmx',100,1),(643,7517739,7517738,'fla',33.333,1),(643,7517740,7517738,'las',33.333,1),(643,7517741,7517738,'ash',33.333,1),(643,7517742,7517739,'acc',33.333,1),(643,7517743,7517739,'cce',33.333,1),(643,7517744,7517739,'cel',33.333,1),(643,7517745,7517742,'con',9.091,1),(643,7517746,7517742,'onf',9.091,1),(643,7517747,7517742,'nfi',9.091,1),(643,7517748,7517742,'fig',9.091,1),(643,7517749,7517742,'igu',9.091,1),(643,7517750,7517742,'gur',9.091,1),(643,7517751,7517742,'ura',9.091,1),(643,7517752,7517742,'rat',9.091,1),(643,7517753,7517742,'ati',9.091,1),(643,7517754,7517742,'tio',9.091,1),(643,7517755,7517742,'ion',9.091,1),(643,7517756,7517745,'age',33.333,1),(643,7517757,7517745,'gen',33.333,1),(643,7517758,7517745,'ent',33.333,1),(643,7517759,7517756,'193',16.667,1),(643,7517760,7517756,'930',16.667,1),(643,7517761,7517756,'302',16.667,1),(643,7517762,7517756,'028',16.667,1),(643,7517763,7517756,'288',16.667,1),(643,7517764,7517756,'889',16.667,1),(643,7517765,7517759,'cac',33.333,3),(643,7517766,7517759,'ach',33.333,3),(643,7517767,7517759,'che',33.333,3),(643,7517768,7517765,'sta',33.333,2),(643,7517769,7517765,'tat',33.333,2),(643,7517770,7517765,'ate',33.333,2),(643,7517771,7517768,'dis',16.667,3),(643,7517772,7517768,'isa',16.667,3),(643,7517773,7517768,'sab',16.667,3),(643,7517774,7517768,'abl',16.667,3),(643,7517775,7517768,'ble',16.667,3),(643,7517776,7517768,'led',16.667,3),(643,7517777,7517771,'ope',11.111,2),(643,7517778,7517771,'per',11.111,2),(643,7517779,7517771,'era',11.111,2),(643,7517780,7517771,'rat',11.111,2),(643,7517781,7517771,'ati',11.111,2),(643,7517782,7517771,'tio',11.111,2),(643,7517783,7517771,'ion',11.111,2),(643,7517784,7517771,'ona',11.111,2),(643,7517785,7517771,'nal',11.111,2),(643,7517786,7517777,'mod',50,1),(643,7517787,7517777,'ode',50,1),(643,7517788,7517786,'wri',14.286,1),(643,7517789,7517786,'rit',14.286,1),(643,7517790,7517786,'ite',14.286,1),(643,7517791,7517786,'tet',14.286,1),(643,7517792,7517786,'eth',14.286,1),(643,7517793,7517786,'thr',14.286,1),(643,7517794,7517786,'hru',14.286,1),(643,7517795,7517788,'mes',20,1),(643,7517796,7517788,'ess',20,1),(643,7517797,7517788,'ssa',20,1),(643,7517798,7517788,'sag',20,1),(643,7517799,7517788,'age',20,1),(643,7517800,7517795,'adm',33.333,1),(643,7517801,7517795,'dmi',33.333,1),(643,7517802,7517795,'min',33.333,1),(643,7517803,7517800,'met',20,3),(643,7517804,7517800,'etr',20,3),(643,7517805,7517800,'tri',20,3),(643,7517806,7517800,'ric',20,3),(643,7517807,7517800,'ics',20,3),(643,7517808,7517803,'ena',20,1),(643,7517809,7517803,'nab',20,1),(643,7517810,7517803,'abl',20,1),(643,7517811,7517803,'ble',20,1),(643,7517812,7517803,'led',20,1),(643,7517813,7517808,'vir',20,1),(643,7517814,7517808,'irt',20,1),(643,7517815,7517808,'rtu',20,1),(643,7517816,7517808,'tua',20,1),(643,7517817,7517808,'ual',20,1),(643,7517818,7517813,'dis',50,1),(643,7517819,7517813,'isk',50,1),(704,7517866,7517865,'naa',100,2),(704,7517867,7517866,'600',3.333,3),(704,7517868,7517866,'000',3.333,3),(704,7517869,7517866,'00c',3.333,3),(704,7517870,7517866,'0c2',3.333,3),(704,7517871,7517866,'c29',3.333,3),(704,7517872,7517866,'292',3.333,3),(704,7517873,7517866,'923',3.333,3),(704,7517874,7517866,'233',3.333,3),(704,7517875,7517866,'334',3.333,3),(704,7517876,7517866,'348',3.333,3),(704,7517877,7517866,'488',3.333,3),(704,7517878,7517866,'88e',3.333,3),(704,7517879,7517866,'8ec',3.333,3),(704,7517880,7517866,'ecd',3.333,3),(704,7517881,7517866,'cd7',3.333,3),(704,7517882,7517866,'d7d',3.333,3),(704,7517883,7517866,'7db',3.333,3),(704,7517884,7517866,'db1',3.333,3),(704,7517885,7517866,'b18',3.333,3),(704,7517886,7517866,'18a',3.333,3),(704,7517887,7517866,'8a6',3.333,3),(704,7517888,7517866,'a64',3.333,3),(704,7517889,7517866,'641',3.333,3),(704,7517890,7517866,'41f',3.333,3),(704,7517891,7517866,'1f4',3.333,3),(704,7517892,7517866,'f4f',3.333,3),(704,7517893,7517866,'4f0',3.333,3),(704,7517894,7517866,'f01',3.333,3),(704,7517895,7517866,'019',3.333,3),(704,7517896,7517866,'194',3.333,3),(704,7517897,7517867,'mon',100,1),(704,7517898,7517897,'201',50,1),(704,7517899,7517897,'013',50,1),(704,7517900,7517898,'adm',33.333,3),(704,7517901,7517898,'dmi',33.333,3),(704,7517902,7517898,'min',33.333,3),(704,7517903,7517900,'cap',16.667,1),(704,7517904,7517900,'apa',16.667,1),(704,7517905,7517900,'pac',16.667,1),(704,7517906,7517900,'aci',16.667,1),(704,7517907,7517900,'cit',16.667,1),(704,7517908,7517900,'ity',16.667,1),(704,7517909,7517903,'pat',50,1),(704,7517910,7517903,'ath',50,1),(704,7517911,7517909,'fre',14.286,1),(704,7517912,7517909,'ree',14.286,1),(704,7517913,7517909,'ees',14.286,1),(704,7517914,7517909,'esp',14.286,1),(704,7517915,7517909,'spa',14.286,1),(704,7517916,7517909,'pac',14.286,1),(704,7517917,7517909,'ace',14.286,1),(704,7517918,7517911,'dis',50,1),(704,7517919,7517911,'isk',50,1),(704,7517920,7517918,'ind',33.333,1),(704,7517921,7517918,'nde',33.333,1),(704,7517922,7517918,'dex',33.333,1),(704,7517923,7517920,'adm',8.333,1),(704,7517924,7517920,'dmi',8.333,1),(704,7517925,7517920,'min',8.333,1),(704,7517926,7517920,'ini',8.333,1),(704,7517927,7517920,'nis',8.333,1),(704,7517928,7517920,'ist',8.333,1),(704,7517929,7517920,'str',8.333,1),(704,7517930,7517920,'tra',8.333,1),(704,7517931,7517920,'rat',8.333,1),(704,7517932,7517920,'ati',8.333,1),(704,7517933,7517920,'tio',8.333,1),(704,7517934,7517920,'ion',8.333,1),(704,7517935,7517923,'sta',33.333,3),(704,7517936,7517923,'tat',33.333,3),(704,7517937,7517923,'ate',33.333,3),(704,7517938,7517935,'ena',20,2),(704,7517939,7517935,'nab',20,2),(704,7517940,7517935,'abl',20,2),(704,7517941,7517935,'ble',20,2),(704,7517942,7517935,'led',20,2),(704,7517943,7517938,'cac',33.333,2),(704,7517944,7517938,'ach',33.333,2),(704,7517945,7517938,'che',33.333,2),(704,7517946,7517943,'mod',50,1),(704,7517947,7517943,'ode',50,1),(704,7517948,7517946,'wri',14.286,1),(704,7517949,7517946,'rit',14.286,1),(704,7517950,7517946,'ite',14.286,1),(704,7517951,7517946,'tet',14.286,1),(704,7517952,7517946,'eth',14.286,1),(704,7517953,7517946,'thr',14.286,1),(704,7517954,7517946,'hru',14.286,1),(704,7517955,7517948,'ope',11.111,2),(704,7517956,7517948,'per',11.111,2),(704,7517957,7517948,'era',11.111,2),(704,7517958,7517948,'rat',11.111,2),(704,7517959,7517948,'ati',11.111,2),(704,7517960,7517948,'tio',11.111,2),(704,7517961,7517948,'ion',11.111,2),(704,7517962,7517948,'ona',11.111,2),(704,7517963,7517948,'nal',11.111,2),(704,7517964,7517955,'pen',20,1),(704,7517965,7517955,'end',20,1),(704,7517966,7517955,'ndi',20,1),(704,7517967,7517955,'din',20,1),(704,7517968,7517955,'ing',20,1),(704,7517969,7517964,'mes',20,1),(704,7517970,7517964,'ess',20,1),(704,7517971,7517964,'ssa',20,1),(704,7517972,7517964,'sag',20,1),(704,7517973,7517964,'age',20,1),(704,7517974,7517969,'wai',20,1),(704,7517975,7517969,'ait',20,1),(704,7517976,7517969,'iti',20,1),(704,7517977,7517969,'tin',20,1),(704,7517978,7517969,'ing',20,1),(704,7517979,7517974,'for',100,1),(704,7517980,7517979,'per',11.111,1),(704,7517981,7517979,'erf',11.111,1),(704,7517982,7517979,'rfo',11.111,1),(704,7517983,7517979,'for',11.111,1),(704,7517984,7517979,'orm',11.111,1),(704,7517985,7517979,'rma',11.111,1),(704,7517986,7517979,'man',11.111,1),(704,7517987,7517979,'anc',11.111,1),(704,7517988,7517979,'nce',11.111,1),(704,7517989,7517980,'ide',12.5,1),(704,7517990,7517980,'den',12.5,1),(704,7517991,7517980,'ent',12.5,1),(704,7517992,7517980,'nti',12.5,1),(704,7517993,7517980,'tif',12.5,1),(704,7517994,7517980,'ifi',12.5,1),(704,7517995,7517980,'fie',12.5,1),(704,7517996,7517980,'ier',12.5,1),(704,7517997,7517989,'vdi',33.333,3),(704,7517998,7517989,'dis',33.333,3),(704,7517999,7517989,'isk',33.333,3),(704,7518000,7517997,'nam',50,1),(704,7518001,7517997,'ame',50,1),(704,7518002,7518000,'typ',50,1),(704,7518003,7518000,'ype',50,1),(704,7518004,7518002,'dir',25,1),(704,7518005,7518002,'ire',25,1),(704,7518006,7518002,'rec',25,1),(704,7518007,7518002,'ect',25,1),(705,7518009,7518008,'naa',100,2),(705,7518010,7518009,'600',3.333,3),(705,7518011,7518009,'00a',3.333,3),(705,7518012,7518009,'0a0',3.333,3),(705,7518013,7518009,'a09',3.333,3),(705,7518014,7518009,'098',3.333,3),(705,7518015,7518009,'980',3.333,3),(705,7518016,7518009,'804',3.333,3),(705,7518017,7518009,'044',3.333,3),(705,7518018,7518009,'443',3.333,3),(705,7518019,7518009,'430',3.333,3),(705,7518020,7518009,'307',3.333,3),(705,7518021,7518009,'072',3.333,3),(705,7518022,7518009,'725',3.333,3),(705,7518023,7518009,'259',3.333,3),(705,7518024,7518009,'593',3.333,3),(705,7518025,7518009,'931',3.333,3),(705,7518026,7518009,'313',3.333,3),(705,7518027,7518009,'13f',3.333,3),(705,7518028,7518009,'3f3',3.333,3),(705,7518029,7518009,'f33',3.333,3),(705,7518030,7518009,'334',3.333,3),(705,7518031,7518009,'345',3.333,3),(705,7518032,7518009,'455',3.333,3),(705,7518033,7518009,'556',3.333,3),(705,7518034,7518009,'563',3.333,3),(705,7518035,7518009,'639',3.333,3),(705,7518036,7518009,'393',3.333,3),(705,7518037,7518009,'934',3.333,3),(705,7518038,7518009,'344',3.333,3),(705,7518039,7518009,'44b',3.333,3),(705,7518040,7518010,'mon',100,1),(705,7518041,7518040,'201',50,1),(705,7518042,7518040,'013',50,1),(705,7518043,7518041,'adm',33.333,3),(705,7518044,7518041,'dmi',33.333,3),(705,7518045,7518041,'min',33.333,3),(705,7518046,7518043,'cap',16.667,1),(705,7518047,7518043,'apa',16.667,1),(705,7518048,7518043,'pac',16.667,1),(705,7518049,7518043,'aci',16.667,1),(705,7518050,7518043,'cit',16.667,1),(705,7518051,7518043,'ity',16.667,1),(705,7518052,7518046,'pat',50,1),(705,7518053,7518046,'ath',50,1),(705,7518054,7518052,'fre',14.286,1),(705,7518055,7518052,'ree',14.286,1),(705,7518056,7518052,'ees',14.286,1),(705,7518057,7518052,'esp',14.286,1),(705,7518058,7518052,'spa',14.286,1),(705,7518059,7518052,'pac',14.286,1),(705,7518060,7518052,'ace',14.286,1),(705,7518061,7518054,'dis',50,1),(705,7518062,7518054,'isk',50,1),(705,7518063,7518061,'ind',33.333,1),(705,7518064,7518061,'nde',33.333,1),(705,7518065,7518061,'dex',33.333,1),(705,7518066,7518063,'adm',8.333,1),(705,7518067,7518063,'dmi',8.333,1),(705,7518068,7518063,'min',8.333,1),(705,7518069,7518063,'ini',8.333,1),(705,7518070,7518063,'nis',8.333,1),(705,7518071,7518063,'ist',8.333,1),(705,7518072,7518063,'str',8.333,1),(705,7518073,7518063,'tra',8.333,1),(705,7518074,7518063,'rat',8.333,1),(705,7518075,7518063,'ati',8.333,1),(705,7518076,7518063,'tio',8.333,1),(705,7518077,7518063,'ion',8.333,1),(705,7518078,7518066,'sta',33.333,3),(705,7518079,7518066,'tat',33.333,3),(705,7518080,7518066,'ate',33.333,3),(705,7518081,7518078,'ena',20,2),(705,7518082,7518078,'nab',20,2),(705,7518083,7518078,'abl',20,2),(705,7518084,7518078,'ble',20,2),(705,7518085,7518078,'led',20,2),(705,7518086,7518081,'cac',33.333,2),(705,7518087,7518081,'ach',33.333,2),(705,7518088,7518081,'che',33.333,2),(705,7518089,7518086,'mod',50,1),(705,7518090,7518086,'ode',50,1),(705,7518091,7518089,'wri',14.286,1),(705,7518092,7518089,'rit',14.286,1),(705,7518093,7518089,'ite',14.286,1),(705,7518094,7518089,'tet',14.286,1),(705,7518095,7518089,'eth',14.286,1),(705,7518096,7518089,'thr',14.286,1),(705,7518097,7518089,'hru',14.286,1),(705,7518098,7518091,'ope',11.111,2),(705,7518099,7518091,'per',11.111,2),(705,7518100,7518091,'era',11.111,2),(705,7518101,7518091,'rat',11.111,2),(705,7518102,7518091,'ati',11.111,2),(705,7518103,7518091,'tio',11.111,2),(705,7518104,7518091,'ion',11.111,2),(705,7518105,7518091,'ona',11.111,2),(705,7518106,7518091,'nal',11.111,2),(705,7518107,7518098,'pen',20,1),(705,7518108,7518098,'end',20,1),(705,7518109,7518098,'ndi',20,1),(705,7518110,7518098,'din',20,1),(705,7518111,7518098,'ing',20,1),(705,7518112,7518107,'mes',20,1),(705,7518113,7518107,'ess',20,1),(705,7518114,7518107,'ssa',20,1),(705,7518115,7518107,'sag',20,1),(705,7518116,7518107,'age',20,1),(705,7518117,7518112,'wai',20,1),(705,7518118,7518112,'ait',20,1),(705,7518119,7518112,'iti',20,1),(705,7518120,7518112,'tin',20,1),(705,7518121,7518112,'ing',20,1),(705,7518122,7518117,'for',100,1),(705,7518123,7518122,'per',11.111,1),(705,7518124,7518122,'erf',11.111,1),(705,7518125,7518122,'rfo',11.111,1),(705,7518126,7518122,'for',11.111,1),(705,7518127,7518122,'orm',11.111,1),(705,7518128,7518122,'rma',11.111,1),(705,7518129,7518122,'man',11.111,1),(705,7518130,7518122,'anc',11.111,1),(705,7518131,7518122,'nce',11.111,1),(705,7518132,7518123,'ide',12.5,1),(705,7518133,7518123,'den',12.5,1),(705,7518134,7518123,'ent',12.5,1),(705,7518135,7518123,'nti',12.5,1),(705,7518136,7518123,'tif',12.5,1),(705,7518137,7518123,'ifi',12.5,1),(705,7518138,7518123,'fie',12.5,1),(705,7518139,7518123,'ier',12.5,1),(705,7518140,7518132,'vdi',33.333,3),(705,7518141,7518132,'dis',33.333,3),(705,7518142,7518132,'isk',33.333,3),(705,7518143,7518140,'nam',50,1),(705,7518144,7518140,'ame',50,1),(705,7518145,7518143,'typ',50,1),(705,7518146,7518143,'ype',50,1),(705,7518147,7518145,'dir',25,1),(705,7518148,7518145,'ire',25,1),(705,7518149,7518145,'rec',25,1),(705,7518150,7518145,'ect',25,1),(706,7518152,7518151,'naa',100,2),(706,7518153,7518152,'600',3.333,3),(706,7518154,7518152,'00a',3.333,3),(706,7518155,7518152,'0a0',3.333,3),(706,7518156,7518152,'a09',3.333,3),(706,7518157,7518152,'098',3.333,3),(706,7518158,7518152,'980',3.333,3),(706,7518159,7518152,'804',3.333,3),(706,7518160,7518152,'044',3.333,3),(706,7518161,7518152,'443',3.333,3),(706,7518162,7518152,'430',3.333,3),(706,7518163,7518152,'307',3.333,3),(706,7518164,7518152,'072',3.333,3),(706,7518165,7518152,'725',3.333,3),(706,7518166,7518152,'259',3.333,3),(706,7518167,7518152,'593',3.333,3),(706,7518168,7518152,'931',3.333,3),(706,7518169,7518152,'313',3.333,3),(706,7518170,7518152,'13f',3.333,3),(706,7518171,7518152,'3f3',3.333,3),(706,7518172,7518152,'f33',3.333,3),(706,7518173,7518152,'334',3.333,3),(706,7518174,7518152,'345',3.333,3),(706,7518175,7518152,'455',3.333,3),(706,7518176,7518152,'556',3.333,3),(706,7518177,7518152,'563',3.333,3),(706,7518178,7518152,'639',3.333,3),(706,7518179,7518152,'393',3.333,3),(706,7518180,7518152,'934',3.333,3),(706,7518181,7518152,'344',3.333,3),(706,7518182,7518152,'44c',3.333,3),(706,7518183,7518153,'mon',100,1),(706,7518184,7518183,'201',50,1),(706,7518185,7518183,'013',50,1),(706,7518186,7518184,'adm',33.333,3),(706,7518187,7518184,'dmi',33.333,3),(706,7518188,7518184,'min',33.333,3),(706,7518189,7518186,'cap',16.667,1),(706,7518190,7518186,'apa',16.667,1),(706,7518191,7518186,'pac',16.667,1),(706,7518192,7518186,'aci',16.667,1),(706,7518193,7518186,'cit',16.667,1),(706,7518194,7518186,'ity',16.667,1),(706,7518195,7518189,'pat',50,1),(706,7518196,7518189,'ath',50,1),(706,7518197,7518195,'fre',14.286,1),(706,7518198,7518195,'ree',14.286,1),(706,7518199,7518195,'ees',14.286,1),(706,7518200,7518195,'esp',14.286,1),(706,7518201,7518195,'spa',14.286,1),(706,7518202,7518195,'pac',14.286,1),(706,7518203,7518195,'ace',14.286,1),(706,7518204,7518197,'dis',50,1),(706,7518205,7518197,'isk',50,1),(706,7518206,7518204,'ind',33.333,1),(706,7518207,7518204,'nde',33.333,1),(706,7518208,7518204,'dex',33.333,1),(706,7518209,7518206,'adm',8.333,1),(706,7518210,7518206,'dmi',8.333,1),(706,7518211,7518206,'min',8.333,1),(706,7518212,7518206,'ini',8.333,1),(706,7518213,7518206,'nis',8.333,1),(706,7518214,7518206,'ist',8.333,1),(706,7518215,7518206,'str',8.333,1),(706,7518216,7518206,'tra',8.333,1),(706,7518217,7518206,'rat',8.333,1),(706,7518218,7518206,'ati',8.333,1),(706,7518219,7518206,'tio',8.333,1),(706,7518220,7518206,'ion',8.333,1),(706,7518221,7518209,'sta',33.333,3),(706,7518222,7518209,'tat',33.333,3),(706,7518223,7518209,'ate',33.333,3),(706,7518224,7518221,'ena',20,2),(706,7518225,7518221,'nab',20,2),(706,7518226,7518221,'abl',20,2),(706,7518227,7518221,'ble',20,2),(706,7518228,7518221,'led',20,2),(706,7518229,7518224,'cac',33.333,2),(706,7518230,7518224,'ach',33.333,2),(706,7518231,7518224,'che',33.333,2),(706,7518232,7518229,'mod',50,1),(706,7518233,7518229,'ode',50,1),(706,7518234,7518232,'wri',14.286,1),(706,7518235,7518232,'rit',14.286,1),(706,7518236,7518232,'ite',14.286,1),(706,7518237,7518232,'tet',14.286,1),(706,7518238,7518232,'eth',14.286,1),(706,7518239,7518232,'thr',14.286,1),(706,7518240,7518232,'hru',14.286,1),(706,7518241,7518234,'ope',11.111,2),(706,7518242,7518234,'per',11.111,2),(706,7518243,7518234,'era',11.111,2),(706,7518244,7518234,'rat',11.111,2),(706,7518245,7518234,'ati',11.111,2),(706,7518246,7518234,'tio',11.111,2),(706,7518247,7518234,'ion',11.111,2),(706,7518248,7518234,'ona',11.111,2),(706,7518249,7518234,'nal',11.111,2),(706,7518250,7518241,'pen',20,1),(706,7518251,7518241,'end',20,1),(706,7518252,7518241,'ndi',20,1),(706,7518253,7518241,'din',20,1),(706,7518254,7518241,'ing',20,1),(706,7518255,7518250,'mes',20,1),(706,7518256,7518250,'ess',20,1),(706,7518257,7518250,'ssa',20,1),(706,7518258,7518250,'sag',20,1),(706,7518259,7518250,'age',20,1),(706,7518260,7518255,'wai',20,1),(706,7518261,7518255,'ait',20,1),(706,7518262,7518255,'iti',20,1),(706,7518263,7518255,'tin',20,1),(706,7518264,7518255,'ing',20,1),(706,7518265,7518260,'for',100,1),(706,7518266,7518265,'per',11.111,1),(706,7518267,7518265,'erf',11.111,1),(706,7518268,7518265,'rfo',11.111,1),(706,7518269,7518265,'for',11.111,1),(706,7518270,7518265,'orm',11.111,1),(706,7518271,7518265,'rma',11.111,1),(706,7518272,7518265,'man',11.111,1),(706,7518273,7518265,'anc',11.111,1),(706,7518274,7518265,'nce',11.111,1),(706,7518275,7518266,'ide',12.5,1),(706,7518276,7518266,'den',12.5,1),(706,7518277,7518266,'ent',12.5,1),(706,7518278,7518266,'nti',12.5,1),(706,7518279,7518266,'tif',12.5,1),(706,7518280,7518266,'ifi',12.5,1),(706,7518281,7518266,'fie',12.5,1),(706,7518282,7518266,'ier',12.5,1),(706,7518283,7518275,'vdi',33.333,3),(706,7518284,7518275,'dis',33.333,3),(706,7518285,7518275,'isk',33.333,3),(706,7518286,7518283,'nam',50,1),(706,7518287,7518283,'ame',50,1),(706,7518288,7518286,'typ',50,1),(706,7518289,7518286,'ype',50,1),(706,7518290,7518288,'dir',25,1),(706,7518291,7518288,'ire',25,1),(706,7518292,7518288,'rec',25,1),(706,7518293,7518288,'ect',25,1),(707,7518295,7518294,'naa',100,2),(707,7518296,7518295,'600',3.333,3),(707,7518297,7518295,'00a',3.333,3),(707,7518298,7518295,'0a0',3.333,3),(707,7518299,7518295,'a09',3.333,3),(707,7518300,7518295,'098',3.333,3),(707,7518301,7518295,'980',3.333,3),(707,7518302,7518295,'804',3.333,3),(707,7518303,7518295,'044',3.333,3),(707,7518304,7518295,'443',3.333,3),(707,7518305,7518295,'430',3.333,3),(707,7518306,7518295,'307',3.333,3),(707,7518307,7518295,'075',3.333,3),(707,7518308,7518295,'753',3.333,3),(707,7518309,7518295,'535',3.333,3),(707,7518310,7518295,'357',3.333,3),(707,7518311,7518295,'573',3.333,3),(707,7518312,7518295,'732',3.333,3),(707,7518313,7518295,'32b',3.333,3),(707,7518314,7518295,'2b3',3.333,3),(707,7518315,7518295,'b33',3.333,3),(707,7518316,7518295,'334',3.333,3),(707,7518317,7518295,'345',3.333,3),(707,7518318,7518295,'457',3.333,3),(707,7518319,7518295,'571',3.333,3),(707,7518320,7518295,'715',3.333,3),(707,7518321,7518295,'153',3.333,3),(707,7518322,7518295,'533',3.333,3),(707,7518323,7518295,'336',3.333,3),(707,7518324,7518295,'363',3.333,3),(707,7518325,7518295,'636',3.333,3),(707,7518326,7518296,'mon',100,1),(707,7518327,7518326,'201',50,1),(707,7518328,7518326,'013',50,1),(707,7518329,7518327,'adm',33.333,3),(707,7518330,7518327,'dmi',33.333,3),(707,7518331,7518327,'min',33.333,3),(707,7518332,7518329,'cap',16.667,1),(707,7518333,7518329,'apa',16.667,1),(707,7518334,7518329,'pac',16.667,1),(707,7518335,7518329,'aci',16.667,1),(707,7518336,7518329,'cit',16.667,1),(707,7518337,7518329,'ity',16.667,1),(707,7518338,7518332,'pat',50,1),(707,7518339,7518332,'ath',50,1),(707,7518340,7518338,'fre',14.286,1),(707,7518341,7518338,'ree',14.286,1),(707,7518342,7518338,'ees',14.286,1),(707,7518343,7518338,'esp',14.286,1),(707,7518344,7518338,'spa',14.286,1),(707,7518345,7518338,'pac',14.286,1),(707,7518346,7518338,'ace',14.286,1),(707,7518347,7518340,'dis',50,1),(707,7518348,7518340,'isk',50,1),(707,7518349,7518347,'ind',33.333,1),(707,7518350,7518347,'nde',33.333,1),(707,7518351,7518347,'dex',33.333,1),(707,7518352,7518349,'adm',8.333,1),(707,7518353,7518349,'dmi',8.333,1),(707,7518354,7518349,'min',8.333,1),(707,7518355,7518349,'ini',8.333,1),(707,7518356,7518349,'nis',8.333,1),(707,7518357,7518349,'ist',8.333,1),(707,7518358,7518349,'str',8.333,1),(707,7518359,7518349,'tra',8.333,1),(707,7518360,7518349,'rat',8.333,1),(707,7518361,7518349,'ati',8.333,1),(707,7518362,7518349,'tio',8.333,1),(707,7518363,7518349,'ion',8.333,1),(707,7518364,7518352,'sta',33.333,3),(707,7518365,7518352,'tat',33.333,3),(707,7518366,7518352,'ate',33.333,3),(707,7518367,7518364,'ena',20,2),(707,7518368,7518364,'nab',20,2),(707,7518369,7518364,'abl',20,2),(707,7518370,7518364,'ble',20,2),(707,7518371,7518364,'led',20,2),(707,7518372,7518367,'cac',33.333,2),(707,7518373,7518367,'ach',33.333,2),(707,7518374,7518367,'che',33.333,2),(707,7518375,7518372,'mod',50,1),(707,7518376,7518372,'ode',50,1),(707,7518377,7518375,'wri',14.286,1),(707,7518378,7518375,'rit',14.286,1),(707,7518379,7518375,'ite',14.286,1),(707,7518380,7518375,'tet',14.286,1),(707,7518381,7518375,'eth',14.286,1),(707,7518382,7518375,'thr',14.286,1),(707,7518383,7518375,'hru',14.286,1),(707,7518384,7518377,'ope',11.111,2),(707,7518385,7518377,'per',11.111,2),(707,7518386,7518377,'era',11.111,2),(707,7518387,7518377,'rat',11.111,2),(707,7518388,7518377,'ati',11.111,2),(707,7518389,7518377,'tio',11.111,2),(707,7518390,7518377,'ion',11.111,2),(707,7518391,7518377,'ona',11.111,2),(707,7518392,7518377,'nal',11.111,2),(707,7518393,7518384,'pen',20,1),(707,7518394,7518384,'end',20,1),(707,7518395,7518384,'ndi',20,1),(707,7518396,7518384,'din',20,1),(707,7518397,7518384,'ing',20,1),(707,7518398,7518393,'mes',20,1),(707,7518399,7518393,'ess',20,1),(707,7518400,7518393,'ssa',20,1),(707,7518401,7518393,'sag',20,1),(707,7518402,7518393,'age',20,1),(707,7518403,7518398,'wai',20,1),(707,7518404,7518398,'ait',20,1),(707,7518405,7518398,'iti',20,1),(707,7518406,7518398,'tin',20,1),(707,7518407,7518398,'ing',20,1),(707,7518408,7518403,'for',100,1),(707,7518409,7518408,'per',11.111,1),(707,7518410,7518408,'erf',11.111,1),(707,7518411,7518408,'rfo',11.111,1),(707,7518412,7518408,'for',11.111,1),(707,7518413,7518408,'orm',11.111,1),(707,7518414,7518408,'rma',11.111,1),(707,7518415,7518408,'man',11.111,1),(707,7518416,7518408,'anc',11.111,1),(707,7518417,7518408,'nce',11.111,1),(707,7518418,7518409,'ide',12.5,1),(707,7518419,7518409,'den',12.5,1),(707,7518420,7518409,'ent',12.5,1),(707,7518421,7518409,'nti',12.5,1),(707,7518422,7518409,'tif',12.5,1),(707,7518423,7518409,'ifi',12.5,1),(707,7518424,7518409,'fie',12.5,1),(707,7518425,7518409,'ier',12.5,1),(707,7518426,7518418,'vdi',33.333,3),(707,7518427,7518418,'dis',33.333,3),(707,7518428,7518418,'isk',33.333,3),(707,7518429,7518426,'nam',50,1),(707,7518430,7518426,'ame',50,1),(707,7518431,7518429,'typ',50,1),(707,7518432,7518429,'ype',50,1),(707,7518433,7518431,'dir',25,1),(707,7518434,7518431,'ire',25,1),(707,7518435,7518431,'rec',25,1),(707,7518436,7518431,'ect',25,1),(708,7518438,7518437,'naa',100,2),(708,7518439,7518438,'600',3.333,3),(708,7518440,7518438,'00a',3.333,3),(708,7518441,7518438,'0a0',3.333,3),(708,7518442,7518438,'a09',3.333,3),(708,7518443,7518438,'098',3.333,3),(708,7518444,7518438,'980',3.333,3),(708,7518445,7518438,'804',3.333,3),(708,7518446,7518438,'044',3.333,3),(708,7518447,7518438,'443',3.333,3),(708,7518448,7518438,'430',3.333,3),(708,7518449,7518438,'307',3.333,3),(708,7518450,7518438,'075',3.333,3),(708,7518451,7518438,'753',3.333,3),(708,7518452,7518438,'535',3.333,3),(708,7518453,7518438,'357',3.333,3),(708,7518454,7518438,'573',3.333,3),(708,7518455,7518438,'732',3.333,3),(708,7518456,7518438,'32b',3.333,3),(708,7518457,7518438,'2b3',3.333,3),(708,7518458,7518438,'b33',3.333,3),(708,7518459,7518438,'334',3.333,3),(708,7518460,7518438,'345',3.333,3),(708,7518461,7518438,'457',3.333,3),(708,7518462,7518438,'571',3.333,3),(708,7518463,7518438,'715',3.333,3),(708,7518464,7518438,'153',3.333,3),(708,7518465,7518438,'533',3.333,3),(708,7518466,7518438,'336',3.333,3),(708,7518467,7518438,'363',3.333,3),(708,7518468,7518438,'637',3.333,3),(708,7518469,7518439,'mon',100,1),(708,7518470,7518469,'201',50,1),(708,7518471,7518469,'013',50,1),(708,7518472,7518470,'adm',33.333,3),(708,7518473,7518470,'dmi',33.333,3),(708,7518474,7518470,'min',33.333,3),(708,7518475,7518472,'cap',16.667,1),(708,7518476,7518472,'apa',16.667,1),(708,7518477,7518472,'pac',16.667,1),(708,7518478,7518472,'aci',16.667,1),(708,7518479,7518472,'cit',16.667,1),(708,7518480,7518472,'ity',16.667,1),(708,7518481,7518475,'pat',50,1),(708,7518482,7518475,'ath',50,1),(708,7518483,7518481,'fre',14.286,1),(708,7518484,7518481,'ree',14.286,1),(708,7518485,7518481,'ees',14.286,1),(708,7518486,7518481,'esp',14.286,1),(708,7518487,7518481,'spa',14.286,1),(708,7518488,7518481,'pac',14.286,1),(708,7518489,7518481,'ace',14.286,1),(708,7518490,7518483,'dis',50,1),(708,7518491,7518483,'isk',50,1),(708,7518492,7518490,'ind',33.333,1),(708,7518493,7518490,'nde',33.333,1),(708,7518494,7518490,'dex',33.333,1),(708,7518495,7518492,'adm',8.333,1),(708,7518496,7518492,'dmi',8.333,1),(708,7518497,7518492,'min',8.333,1),(708,7518498,7518492,'ini',8.333,1),(708,7518499,7518492,'nis',8.333,1),(708,7518500,7518492,'ist',8.333,1),(708,7518501,7518492,'str',8.333,1),(708,7518502,7518492,'tra',8.333,1),(708,7518503,7518492,'rat',8.333,1),(708,7518504,7518492,'ati',8.333,1),(708,7518505,7518492,'tio',8.333,1),(708,7518506,7518492,'ion',8.333,1),(708,7518507,7518495,'sta',33.333,3),(708,7518508,7518495,'tat',33.333,3),(708,7518509,7518495,'ate',33.333,3),(708,7518510,7518507,'ena',20,2),(708,7518511,7518507,'nab',20,2),(708,7518512,7518507,'abl',20,2),(708,7518513,7518507,'ble',20,2),(708,7518514,7518507,'led',20,2),(708,7518515,7518510,'cac',33.333,2),(708,7518516,7518510,'ach',33.333,2),(708,7518517,7518510,'che',33.333,2),(708,7518518,7518515,'mod',50,1),(708,7518519,7518515,'ode',50,1),(708,7518520,7518518,'wri',14.286,1),(708,7518521,7518518,'rit',14.286,1),(708,7518522,7518518,'ite',14.286,1),(708,7518523,7518518,'tet',14.286,1),(708,7518524,7518518,'eth',14.286,1),(708,7518525,7518518,'thr',14.286,1),(708,7518526,7518518,'hru',14.286,1),(708,7518527,7518520,'ope',11.111,2),(708,7518528,7518520,'per',11.111,2),(708,7518529,7518520,'era',11.111,2),(708,7518530,7518520,'rat',11.111,2),(708,7518531,7518520,'ati',11.111,2),(708,7518532,7518520,'tio',11.111,2),(708,7518533,7518520,'ion',11.111,2),(708,7518534,7518520,'ona',11.111,2),(708,7518535,7518520,'nal',11.111,2),(708,7518536,7518527,'pen',20,1),(708,7518537,7518527,'end',20,1),(708,7518538,7518527,'ndi',20,1),(708,7518539,7518527,'din',20,1),(708,7518540,7518527,'ing',20,1),(708,7518541,7518536,'mes',20,1),(708,7518542,7518536,'ess',20,1),(708,7518543,7518536,'ssa',20,1),(708,7518544,7518536,'sag',20,1),(708,7518545,7518536,'age',20,1),(708,7518546,7518541,'wai',20,1),(708,7518547,7518541,'ait',20,1),(708,7518548,7518541,'iti',20,1),(708,7518549,7518541,'tin',20,1),(708,7518550,7518541,'ing',20,1),(708,7518551,7518546,'for',100,1),(708,7518552,7518551,'per',11.111,1),(708,7518553,7518551,'erf',11.111,1),(708,7518554,7518551,'rfo',11.111,1),(708,7518555,7518551,'for',11.111,1),(708,7518556,7518551,'orm',11.111,1),(708,7518557,7518551,'rma',11.111,1),(708,7518558,7518551,'man',11.111,1),(708,7518559,7518551,'anc',11.111,1),(708,7518560,7518551,'nce',11.111,1),(708,7518561,7518552,'ide',12.5,1),(708,7518562,7518552,'den',12.5,1),(708,7518563,7518552,'ent',12.5,1),(708,7518564,7518552,'nti',12.5,1),(708,7518565,7518552,'tif',12.5,1),(708,7518566,7518552,'ifi',12.5,1),(708,7518567,7518552,'fie',12.5,1),(708,7518568,7518552,'ier',12.5,1),(708,7518569,7518561,'vdi',33.333,3),(708,7518570,7518561,'dis',33.333,3),(708,7518571,7518561,'isk',33.333,3),(708,7518572,7518569,'nam',50,1),(708,7518573,7518569,'ame',50,1),(708,7518574,7518572,'typ',50,1),(708,7518575,7518572,'ype',50,1),(708,7518576,7518574,'dir',25,1),(708,7518577,7518574,'ire',25,1),(708,7518578,7518574,'rec',25,1),(708,7518579,7518574,'ect',25,1),(709,7518581,7518580,'naa',100,2),(709,7518582,7518581,'600',3.333,3),(709,7518583,7518581,'000',3.333,3),(709,7518584,7518581,'00c',3.333,3),(709,7518585,7518581,'0c2',3.333,3),(709,7518586,7518581,'c29',3.333,3),(709,7518587,7518581,'29c',3.333,3),(709,7518588,7518581,'9cd',3.333,3),(709,7518589,7518581,'cda',3.333,3),(709,7518590,7518581,'da5',3.333,3),(709,7518591,7518581,'a5a',3.333,3),(709,7518592,7518581,'5a7',3.333,3),(709,7518593,7518581,'a79',3.333,3),(709,7518594,7518581,'79f',3.333,3),(709,7518595,7518581,'9fb',3.333,3),(709,7518596,7518581,'fbb',3.333,3),(709,7518597,7518581,'bbc',3.333,3),(709,7518598,7518581,'bc7',3.333,3),(709,7518599,7518581,'c72',3.333,3),(709,7518600,7518581,'72d',3.333,3),(709,7518601,7518581,'2dc',3.333,3),(709,7518602,7518581,'dca',3.333,3),(709,7518603,7518581,'cae',3.333,3),(709,7518604,7518581,'aea',3.333,3),(709,7518605,7518581,'ea7',3.333,3),(709,7518606,7518581,'a73',3.333,3),(709,7518607,7518581,'731',3.333,3),(709,7518608,7518581,'317',3.333,3),(709,7518609,7518581,'176',3.333,3),(709,7518610,7518581,'76c',3.333,3),(709,7518611,7518581,'6c3',3.333,3),(709,7518612,7518582,'mon',100,1),(709,7518613,7518612,'201',50,1),(709,7518614,7518612,'013',50,1),(709,7518615,7518613,'adm',33.333,3),(709,7518616,7518613,'dmi',33.333,3),(709,7518617,7518613,'min',33.333,3),(709,7518618,7518615,'cap',16.667,1),(709,7518619,7518615,'apa',16.667,1),(709,7518620,7518615,'pac',16.667,1),(709,7518621,7518615,'aci',16.667,1),(709,7518622,7518615,'cit',16.667,1),(709,7518623,7518615,'ity',16.667,1),(709,7518624,7518618,'pat',50,1),(709,7518625,7518618,'ath',50,1),(709,7518626,7518624,'fre',14.286,1),(709,7518627,7518624,'ree',14.286,1),(709,7518628,7518624,'ees',14.286,1),(709,7518629,7518624,'esp',14.286,1),(709,7518630,7518624,'spa',14.286,1),(709,7518631,7518624,'pac',14.286,1),(709,7518632,7518624,'ace',14.286,1),(709,7518633,7518626,'dis',50,1),(709,7518634,7518626,'isk',50,1),(709,7518635,7518633,'ind',33.333,1),(709,7518636,7518633,'nde',33.333,1),(709,7518637,7518633,'dex',33.333,1),(709,7518638,7518635,'adm',8.333,1),(709,7518639,7518635,'dmi',8.333,1),(709,7518640,7518635,'min',8.333,1),(709,7518641,7518635,'ini',8.333,1),(709,7518642,7518635,'nis',8.333,1),(709,7518643,7518635,'ist',8.333,1),(709,7518644,7518635,'str',8.333,1),(709,7518645,7518635,'tra',8.333,1),(709,7518646,7518635,'rat',8.333,1),(709,7518647,7518635,'ati',8.333,1),(709,7518648,7518635,'tio',8.333,1),(709,7518649,7518635,'ion',8.333,1),(709,7518650,7518638,'sta',33.333,3),(709,7518651,7518638,'tat',33.333,3),(709,7518652,7518638,'ate',33.333,3),(709,7518653,7518650,'ena',20,2),(709,7518654,7518650,'nab',20,2),(709,7518655,7518650,'abl',20,2),(709,7518656,7518650,'ble',20,2),(709,7518657,7518650,'led',20,2),(709,7518658,7518653,'cac',33.333,2),(709,7518659,7518653,'ach',33.333,2),(709,7518660,7518653,'che',33.333,2),(709,7518661,7518658,'mod',50,1),(709,7518662,7518658,'ode',50,1),(709,7518663,7518661,'wri',14.286,1),(709,7518664,7518661,'rit',14.286,1),(709,7518665,7518661,'ite',14.286,1),(709,7518666,7518661,'tet',14.286,1),(709,7518667,7518661,'eth',14.286,1),(709,7518668,7518661,'thr',14.286,1),(709,7518669,7518661,'hru',14.286,1),(709,7518670,7518663,'ope',11.111,2),(709,7518671,7518663,'per',11.111,2),(709,7518672,7518663,'era',11.111,2),(709,7518673,7518663,'rat',11.111,2),(709,7518674,7518663,'ati',11.111,2),(709,7518675,7518663,'tio',11.111,2),(709,7518676,7518663,'ion',11.111,2),(709,7518677,7518663,'ona',11.111,2),(709,7518678,7518663,'nal',11.111,2),(709,7518679,7518670,'pen',20,1),(709,7518680,7518670,'end',20,1),(709,7518681,7518670,'ndi',20,1),(709,7518682,7518670,'din',20,1),(709,7518683,7518670,'ing',20,1),(709,7518684,7518679,'mes',20,1),(709,7518685,7518679,'ess',20,1),(709,7518686,7518679,'ssa',20,1),(709,7518687,7518679,'sag',20,1),(709,7518688,7518679,'age',20,1),(709,7518689,7518684,'wai',20,1),(709,7518690,7518684,'ait',20,1),(709,7518691,7518684,'iti',20,1),(709,7518692,7518684,'tin',20,1),(709,7518693,7518684,'ing',20,1),(709,7518694,7518689,'for',100,1),(709,7518695,7518694,'per',11.111,1),(709,7518696,7518694,'erf',11.111,1),(709,7518697,7518694,'rfo',11.111,1),(709,7518698,7518694,'for',11.111,1),(709,7518699,7518694,'orm',11.111,1),(709,7518700,7518694,'rma',11.111,1),(709,7518701,7518694,'man',11.111,1),(709,7518702,7518694,'anc',11.111,1),(709,7518703,7518694,'nce',11.111,1),(709,7518704,7518695,'ide',12.5,1),(709,7518705,7518695,'den',12.5,1),(709,7518706,7518695,'ent',12.5,1),(709,7518707,7518695,'nti',12.5,1),(709,7518708,7518695,'tif',12.5,1),(709,7518709,7518695,'ifi',12.5,1),(709,7518710,7518695,'fie',12.5,1),(709,7518711,7518695,'ier',12.5,1),(709,7518712,7518704,'vdi',33.333,3),(709,7518713,7518704,'dis',33.333,3),(709,7518714,7518704,'isk',33.333,3),(709,7518715,7518712,'nam',50,1),(709,7518716,7518712,'ame',50,1),(709,7518717,7518715,'typ',50,1),(709,7518718,7518715,'ype',50,1),(709,7518719,7518717,'dir',25,1),(709,7518720,7518717,'ire',25,1),(709,7518721,7518717,'rec',25,1),(709,7518722,7518717,'ect',25,1),(710,7518724,7518723,'naa',100,2),(710,7518725,7518724,'600',3.333,3),(710,7518726,7518724,'000',3.333,3),(710,7518727,7518724,'00c',3.333,3),(710,7518728,7518724,'0c2',3.333,3),(710,7518729,7518724,'c29',3.333,3),(710,7518730,7518724,'294',3.333,3),(710,7518731,7518724,'944',3.333,3),(710,7518732,7518724,'44a',3.333,3),(710,7518733,7518724,'4a6',3.333,3),(710,7518734,7518724,'a65',3.333,3),(710,7518735,7518724,'65a',3.333,3),(710,7518736,7518724,'5ad',3.333,3),(710,7518737,7518724,'ade',3.333,3),(710,7518738,7518724,'def',3.333,3),(710,7518739,7518724,'ef7',3.333,3),(710,7518740,7518724,'f76',3.333,3),(710,7518741,7518724,'760',3.333,3),(710,7518742,7518724,'604',3.333,3),(710,7518743,7518724,'043',3.333,3),(710,7518744,7518724,'43c',3.333,3),(710,7518745,7518724,'3c4',3.333,3),(710,7518746,7518724,'c47',3.333,3),(710,7518747,7518724,'47c',3.333,3),(710,7518748,7518724,'7c6',3.333,3),(710,7518749,7518724,'c69',3.333,3),(710,7518750,7518724,'699',3.333,3),(710,7518751,7518724,'994',3.333,3),(710,7518752,7518724,'941',3.333,3),(710,7518753,7518724,'41f',3.333,3),(710,7518754,7518724,'1f7',3.333,3),(710,7518755,7518725,'mon',100,1),(710,7518756,7518755,'201',50,1),(710,7518757,7518755,'013',50,1),(710,7518758,7518756,'adm',33.333,3),(710,7518759,7518756,'dmi',33.333,3),(710,7518760,7518756,'min',33.333,3),(710,7518761,7518758,'cap',16.667,1),(710,7518762,7518758,'apa',16.667,1),(710,7518763,7518758,'pac',16.667,1),(710,7518764,7518758,'aci',16.667,1),(710,7518765,7518758,'cit',16.667,1),(710,7518766,7518758,'ity',16.667,1),(710,7518767,7518761,'pat',50,1),(710,7518768,7518761,'ath',50,1),(710,7518769,7518767,'fre',14.286,1),(710,7518770,7518767,'ree',14.286,1),(710,7518771,7518767,'ees',14.286,1),(710,7518772,7518767,'esp',14.286,1),(710,7518773,7518767,'spa',14.286,1),(710,7518774,7518767,'pac',14.286,1),(710,7518775,7518767,'ace',14.286,1),(710,7518776,7518769,'dis',50,1),(710,7518777,7518769,'isk',50,1),(710,7518778,7518776,'ind',33.333,1),(710,7518779,7518776,'nde',33.333,1),(710,7518780,7518776,'dex',33.333,1),(710,7518781,7518778,'adm',8.333,1),(710,7518782,7518778,'dmi',8.333,1),(710,7518783,7518778,'min',8.333,1),(710,7518784,7518778,'ini',8.333,1),(710,7518785,7518778,'nis',8.333,1),(710,7518786,7518778,'ist',8.333,1),(710,7518787,7518778,'str',8.333,1),(710,7518788,7518778,'tra',8.333,1),(710,7518789,7518778,'rat',8.333,1),(710,7518790,7518778,'ati',8.333,1),(710,7518791,7518778,'tio',8.333,1),(710,7518792,7518778,'ion',8.333,1),(710,7518793,7518781,'sta',33.333,3),(710,7518794,7518781,'tat',33.333,3),(710,7518795,7518781,'ate',33.333,3),(710,7518796,7518793,'ena',20,2),(710,7518797,7518793,'nab',20,2),(710,7518798,7518793,'abl',20,2),(710,7518799,7518793,'ble',20,2),(710,7518800,7518793,'led',20,2),(710,7518801,7518796,'cac',33.333,2),(710,7518802,7518796,'ach',33.333,2),(710,7518803,7518796,'che',33.333,2),(710,7518804,7518801,'mod',50,1),(710,7518805,7518801,'ode',50,1),(710,7518806,7518804,'wri',14.286,1),(710,7518807,7518804,'rit',14.286,1),(710,7518808,7518804,'ite',14.286,1),(710,7518809,7518804,'tet',14.286,1),(710,7518810,7518804,'eth',14.286,1),(710,7518811,7518804,'thr',14.286,1),(710,7518812,7518804,'hru',14.286,1),(710,7518813,7518806,'ope',11.111,2),(710,7518814,7518806,'per',11.111,2),(710,7518815,7518806,'era',11.111,2),(710,7518816,7518806,'rat',11.111,2),(710,7518817,7518806,'ati',11.111,2),(710,7518818,7518806,'tio',11.111,2),(710,7518819,7518806,'ion',11.111,2),(710,7518820,7518806,'ona',11.111,2),(710,7518821,7518806,'nal',11.111,2),(710,7518822,7518813,'pen',20,1),(710,7518823,7518813,'end',20,1),(710,7518824,7518813,'ndi',20,1),(710,7518825,7518813,'din',20,1),(710,7518826,7518813,'ing',20,1),(710,7518827,7518822,'mes',20,1),(710,7518828,7518822,'ess',20,1),(710,7518829,7518822,'ssa',20,1),(710,7518830,7518822,'sag',20,1),(710,7518831,7518822,'age',20,1),(710,7518832,7518827,'wai',20,1),(710,7518833,7518827,'ait',20,1),(710,7518834,7518827,'iti',20,1),(710,7518835,7518827,'tin',20,1),(710,7518836,7518827,'ing',20,1),(710,7518837,7518832,'for',100,1),(710,7518838,7518837,'per',11.111,1),(710,7518839,7518837,'erf',11.111,1),(710,7518840,7518837,'rfo',11.111,1),(710,7518841,7518837,'for',11.111,1),(710,7518842,7518837,'orm',11.111,1),(710,7518843,7518837,'rma',11.111,1),(710,7518844,7518837,'man',11.111,1),(710,7518845,7518837,'anc',11.111,1),(710,7518846,7518837,'nce',11.111,1),(710,7518847,7518838,'ide',12.5,1),(710,7518848,7518838,'den',12.5,1),(710,7518849,7518838,'ent',12.5,1),(710,7518850,7518838,'nti',12.5,1),(710,7518851,7518838,'tif',12.5,1),(710,7518852,7518838,'ifi',12.5,1),(710,7518853,7518838,'fie',12.5,1),(710,7518854,7518838,'ier',12.5,1),(710,7518855,7518847,'vdi',33.333,3),(710,7518856,7518847,'dis',33.333,3),(710,7518857,7518847,'isk',33.333,3),(710,7518858,7518855,'nam',50,1),(710,7518859,7518855,'ame',50,1),(710,7518860,7518858,'typ',50,1),(710,7518861,7518858,'ype',50,1),(710,7518862,7518860,'dir',25,1),(710,7518863,7518860,'ire',25,1),(710,7518864,7518860,'rec',25,1),(710,7518865,7518860,'ect',25,1),(711,7518867,7518866,'naa',100,2),(711,7518868,7518867,'600',3.333,3),(711,7518869,7518867,'000',3.333,3),(711,7518870,7518867,'00c',3.333,3),(711,7518871,7518867,'0c2',3.333,3),(711,7518872,7518867,'c29',3.333,3),(711,7518873,7518867,'296',3.333,3),(711,7518874,7518867,'969',3.333,3),(711,7518875,7518867,'696',3.333,3),(711,7518876,7518867,'962',3.333,3),(711,7518877,7518867,'621',3.333,3),(711,7518878,7518867,'219',3.333,3),(711,7518879,7518867,'195',3.333,3),(711,7518880,7518867,'95a',3.333,3),(711,7518881,7518867,'5a7',3.333,3),(711,7518882,7518867,'a7d',3.333,3),(711,7518883,7518867,'7df',3.333,3),(711,7518884,7518867,'dfd',3.333,3),(711,7518885,7518867,'fd0',3.333,3),(711,7518886,7518867,'d0b',3.333,3),(711,7518887,7518867,'0b5',3.333,3),(711,7518888,7518867,'b53',3.333,3),(711,7518889,7518867,'53d',3.333,3),(711,7518890,7518867,'3df',3.333,3),(711,7518891,7518867,'dfd',3.333,3),(711,7518892,7518867,'fd3',3.333,3),(711,7518893,7518867,'d31',3.333,3),(711,7518894,7518867,'31e',3.333,3),(711,7518895,7518867,'1e8',3.333,3),(711,7518896,7518867,'e80',3.333,3),(711,7518897,7518867,'805',3.333,3),(711,7518898,7518868,'mon',100,1),(711,7518899,7518898,'201',50,1),(711,7518900,7518898,'013',50,1),(711,7518901,7518899,'adm',33.333,3),(711,7518902,7518899,'dmi',33.333,3),(711,7518903,7518899,'min',33.333,3),(711,7518904,7518901,'cap',16.667,1),(711,7518905,7518901,'apa',16.667,1),(711,7518906,7518901,'pac',16.667,1),(711,7518907,7518901,'aci',16.667,1),(711,7518908,7518901,'cit',16.667,1),(711,7518909,7518901,'ity',16.667,1),(711,7518910,7518904,'pat',50,1),(711,7518911,7518904,'ath',50,1),(711,7518912,7518910,'fre',14.286,1),(711,7518913,7518910,'ree',14.286,1),(711,7518914,7518910,'ees',14.286,1),(711,7518915,7518910,'esp',14.286,1),(711,7518916,7518910,'spa',14.286,1),(711,7518917,7518910,'pac',14.286,1),(711,7518918,7518910,'ace',14.286,1),(711,7518919,7518912,'dis',50,1),(711,7518920,7518912,'isk',50,1),(711,7518921,7518919,'ind',33.333,1),(711,7518922,7518919,'nde',33.333,1),(711,7518923,7518919,'dex',33.333,1),(711,7518924,7518921,'adm',8.333,1),(711,7518925,7518921,'dmi',8.333,1),(711,7518926,7518921,'min',8.333,1),(711,7518927,7518921,'ini',8.333,1),(711,7518928,7518921,'nis',8.333,1),(711,7518929,7518921,'ist',8.333,1),(711,7518930,7518921,'str',8.333,1),(711,7518931,7518921,'tra',8.333,1),(711,7518932,7518921,'rat',8.333,1),(711,7518933,7518921,'ati',8.333,1),(711,7518934,7518921,'tio',8.333,1),(711,7518935,7518921,'ion',8.333,1),(711,7518936,7518924,'sta',33.333,3),(711,7518937,7518924,'tat',33.333,3),(711,7518938,7518924,'ate',33.333,3),(711,7518939,7518936,'ena',20,2),(711,7518940,7518936,'nab',20,2),(711,7518941,7518936,'abl',20,2),(711,7518942,7518936,'ble',20,2),(711,7518943,7518936,'led',20,2),(711,7518944,7518939,'cac',33.333,2),(711,7518945,7518939,'ach',33.333,2),(711,7518946,7518939,'che',33.333,2),(711,7518947,7518944,'mod',50,1),(711,7518948,7518944,'ode',50,1),(711,7518949,7518947,'wri',14.286,1),(711,7518950,7518947,'rit',14.286,1),(711,7518951,7518947,'ite',14.286,1),(711,7518952,7518947,'tet',14.286,1),(711,7518953,7518947,'eth',14.286,1),(711,7518954,7518947,'thr',14.286,1),(711,7518955,7518947,'hru',14.286,1),(711,7518956,7518949,'ope',11.111,2),(711,7518957,7518949,'per',11.111,2),(711,7518958,7518949,'era',11.111,2),(711,7518959,7518949,'rat',11.111,2),(711,7518960,7518949,'ati',11.111,2),(711,7518961,7518949,'tio',11.111,2),(711,7518962,7518949,'ion',11.111,2),(711,7518963,7518949,'ona',11.111,2),(711,7518964,7518949,'nal',11.111,2),(711,7518965,7518956,'pen',20,1),(711,7518966,7518956,'end',20,1),(711,7518967,7518956,'ndi',20,1),(711,7518968,7518956,'din',20,1),(711,7518969,7518956,'ing',20,1),(711,7518970,7518965,'mes',20,1),(711,7518971,7518965,'ess',20,1),(711,7518972,7518965,'ssa',20,1),(711,7518973,7518965,'sag',20,1),(711,7518974,7518965,'age',20,1),(711,7518975,7518970,'wai',20,1),(711,7518976,7518970,'ait',20,1),(711,7518977,7518970,'iti',20,1),(711,7518978,7518970,'tin',20,1),(711,7518979,7518970,'ing',20,1),(711,7518980,7518975,'for',100,1),(711,7518981,7518980,'per',11.111,1),(711,7518982,7518980,'erf',11.111,1),(711,7518983,7518980,'rfo',11.111,1),(711,7518984,7518980,'for',11.111,1),(711,7518985,7518980,'orm',11.111,1),(711,7518986,7518980,'rma',11.111,1),(711,7518987,7518980,'man',11.111,1),(711,7518988,7518980,'anc',11.111,1),(711,7518989,7518980,'nce',11.111,1),(711,7518990,7518981,'ide',12.5,1),(711,7518991,7518981,'den',12.5,1),(711,7518992,7518981,'ent',12.5,1),(711,7518993,7518981,'nti',12.5,1),(711,7518994,7518981,'tif',12.5,1),(711,7518995,7518981,'ifi',12.5,1),(711,7518996,7518981,'fie',12.5,1),(711,7518997,7518981,'ier',12.5,1),(711,7518998,7518990,'vdi',33.333,3),(711,7518999,7518990,'dis',33.333,3),(711,7519000,7518990,'isk',33.333,3),(711,7519001,7518998,'nam',50,1),(711,7519002,7518998,'ame',50,1),(711,7519003,7519001,'typ',50,1),(711,7519004,7519001,'ype',50,1),(711,7519005,7519003,'dir',25,1),(711,7519006,7519003,'ire',25,1),(711,7519007,7519003,'rec',25,1),(711,7519008,7519003,'ect',25,1),(712,7519010,7519009,'naa',100,2),(712,7519011,7519010,'600',3.333,3),(712,7519012,7519010,'000',3.333,3),(712,7519013,7519010,'00c',3.333,3),(712,7519014,7519010,'0c2',3.333,3),(712,7519015,7519010,'c29',3.333,3),(712,7519016,7519010,'290',3.333,3),(712,7519017,7519010,'908',3.333,3),(712,7519018,7519010,'08f',3.333,3),(712,7519019,7519010,'8f6',3.333,3),(712,7519020,7519010,'f67',3.333,3),(712,7519021,7519010,'674',3.333,3),(712,7519022,7519010,'746',3.333,3),(712,7519023,7519010,'46f',3.333,3),(712,7519024,7519010,'6fa',3.333,3),(712,7519025,7519010,'fa8',3.333,3),(712,7519026,7519010,'a81',3.333,3),(712,7519027,7519010,'81a',3.333,3),(712,7519028,7519010,'1a2',3.333,3),(712,7519029,7519010,'a29',3.333,3),(712,7519030,7519010,'291',3.333,3),(712,7519031,7519010,'91e',3.333,3),(712,7519032,7519010,'1e3',3.333,3),(712,7519033,7519010,'e3d',3.333,3),(712,7519034,7519010,'3d8',3.333,3),(712,7519035,7519010,'d84',3.333,3),(712,7519036,7519010,'844',3.333,3),(712,7519037,7519010,'44d',3.333,3),(712,7519038,7519010,'4dc',3.333,3),(712,7519039,7519010,'dc6',3.333,3),(712,7519040,7519010,'c68',3.333,3),(712,7519041,7519011,'mon',100,1),(712,7519042,7519041,'201',50,1),(712,7519043,7519041,'013',50,1),(712,7519044,7519042,'adm',33.333,3),(712,7519045,7519042,'dmi',33.333,3),(712,7519046,7519042,'min',33.333,3),(712,7519047,7519044,'cap',16.667,1),(712,7519048,7519044,'apa',16.667,1),(712,7519049,7519044,'pac',16.667,1),(712,7519050,7519044,'aci',16.667,1),(712,7519051,7519044,'cit',16.667,1),(712,7519052,7519044,'ity',16.667,1),(712,7519053,7519047,'pat',50,1),(712,7519054,7519047,'ath',50,1),(712,7519055,7519053,'fre',14.286,1),(712,7519056,7519053,'ree',14.286,1),(712,7519057,7519053,'ees',14.286,1),(712,7519058,7519053,'esp',14.286,1),(712,7519059,7519053,'spa',14.286,1),(712,7519060,7519053,'pac',14.286,1),(712,7519061,7519053,'ace',14.286,1),(712,7519062,7519055,'dis',50,1),(712,7519063,7519055,'isk',50,1),(712,7519064,7519062,'ind',33.333,1),(712,7519065,7519062,'nde',33.333,1),(712,7519066,7519062,'dex',33.333,1),(712,7519067,7519064,'adm',8.333,1),(712,7519068,7519064,'dmi',8.333,1),(712,7519069,7519064,'min',8.333,1),(712,7519070,7519064,'ini',8.333,1),(712,7519071,7519064,'nis',8.333,1),(712,7519072,7519064,'ist',8.333,1),(712,7519073,7519064,'str',8.333,1),(712,7519074,7519064,'tra',8.333,1),(712,7519075,7519064,'rat',8.333,1),(712,7519076,7519064,'ati',8.333,1),(712,7519077,7519064,'tio',8.333,1),(712,7519078,7519064,'ion',8.333,1),(712,7519079,7519067,'sta',33.333,3),(712,7519080,7519067,'tat',33.333,3),(712,7519081,7519067,'ate',33.333,3),(712,7519082,7519079,'ena',20,2),(712,7519083,7519079,'nab',20,2),(712,7519084,7519079,'abl',20,2),(712,7519085,7519079,'ble',20,2),(712,7519086,7519079,'led',20,2),(712,7519087,7519082,'cac',33.333,2),(712,7519088,7519082,'ach',33.333,2),(712,7519089,7519082,'che',33.333,2),(712,7519090,7519087,'mod',50,1),(712,7519091,7519087,'ode',50,1),(712,7519092,7519090,'wri',14.286,1),(712,7519093,7519090,'rit',14.286,1),(712,7519094,7519090,'ite',14.286,1),(712,7519095,7519090,'tet',14.286,1),(712,7519096,7519090,'eth',14.286,1),(712,7519097,7519090,'thr',14.286,1),(712,7519098,7519090,'hru',14.286,1),(712,7519099,7519092,'ope',11.111,2),(712,7519100,7519092,'per',11.111,2),(712,7519101,7519092,'era',11.111,2),(712,7519102,7519092,'rat',11.111,2),(712,7519103,7519092,'ati',11.111,2),(712,7519104,7519092,'tio',11.111,2),(712,7519105,7519092,'ion',11.111,2),(712,7519106,7519092,'ona',11.111,2),(712,7519107,7519092,'nal',11.111,2),(712,7519108,7519099,'pen',20,1),(712,7519109,7519099,'end',20,1),(712,7519110,7519099,'ndi',20,1),(712,7519111,7519099,'din',20,1),(712,7519112,7519099,'ing',20,1),(712,7519113,7519108,'mes',20,1),(712,7519114,7519108,'ess',20,1),(712,7519115,7519108,'ssa',20,1),(712,7519116,7519108,'sag',20,1),(712,7519117,7519108,'age',20,1),(712,7519118,7519113,'wai',20,1),(712,7519119,7519113,'ait',20,1),(712,7519120,7519113,'iti',20,1),(712,7519121,7519113,'tin',20,1),(712,7519122,7519113,'ing',20,1),(712,7519123,7519118,'for',100,1),(712,7519124,7519123,'per',11.111,1),(712,7519125,7519123,'erf',11.111,1),(712,7519126,7519123,'rfo',11.111,1),(712,7519127,7519123,'for',11.111,1),(712,7519128,7519123,'orm',11.111,1),(712,7519129,7519123,'rma',11.111,1),(712,7519130,7519123,'man',11.111,1),(712,7519131,7519123,'anc',11.111,1),(712,7519132,7519123,'nce',11.111,1),(712,7519133,7519124,'ide',12.5,1),(712,7519134,7519124,'den',12.5,1),(712,7519135,7519124,'ent',12.5,1),(712,7519136,7519124,'nti',12.5,1),(712,7519137,7519124,'tif',12.5,1),(712,7519138,7519124,'ifi',12.5,1),(712,7519139,7519124,'fie',12.5,1),(712,7519140,7519124,'ier',12.5,1),(712,7519141,7519133,'vdi',33.333,3),(712,7519142,7519133,'dis',33.333,3),(712,7519143,7519133,'isk',33.333,3),(712,7519144,7519141,'nam',50,1),(712,7519145,7519141,'ame',50,1),(712,7519146,7519144,'typ',50,1),(712,7519147,7519144,'ype',50,1),(712,7519148,7519146,'dir',25,1),(712,7519149,7519146,'ire',25,1),(712,7519150,7519146,'rec',25,1),(712,7519151,7519146,'ect',25,1),(713,7519153,7519152,'naa',100,2),(713,7519154,7519153,'600',3.333,3),(713,7519155,7519153,'000',3.333,3),(713,7519156,7519153,'00c',3.333,3),(713,7519157,7519153,'0c2',3.333,3),(713,7519158,7519153,'c29',3.333,3),(713,7519159,7519153,'29d',3.333,3),(713,7519160,7519153,'9da',3.333,3),(713,7519161,7519153,'da8',3.333,3),(713,7519162,7519153,'a85',3.333,3),(713,7519163,7519153,'85a',3.333,3),(713,7519164,7519153,'5a9',3.333,3),(713,7519165,7519153,'a95',3.333,3),(713,7519166,7519153,'952',3.333,3),(713,7519167,7519153,'52a',3.333,3),(713,7519168,7519153,'2ac',3.333,3),(713,7519169,7519153,'ac8',3.333,3),(713,7519170,7519153,'c89',3.333,3),(713,7519171,7519153,'89e',3.333,3),(713,7519172,7519153,'9ec',3.333,3),(713,7519173,7519153,'ecf',3.333,3),(713,7519174,7519153,'cf1',3.333,3),(713,7519175,7519153,'f11',3.333,3),(713,7519176,7519153,'112',3.333,3),(713,7519177,7519153,'129',3.333,3),(713,7519178,7519153,'290',3.333,3),(713,7519179,7519153,'90e',3.333,3),(713,7519180,7519153,'0e1',3.333,3),(713,7519181,7519153,'e1d',3.333,3),(713,7519182,7519153,'1dd',3.333,3),(713,7519183,7519153,'dde',3.333,3),(713,7519184,7519154,'mon',100,1),(713,7519185,7519184,'201',50,1),(713,7519186,7519184,'013',50,1),(713,7519187,7519185,'adm',33.333,3),(713,7519188,7519185,'dmi',33.333,3),(713,7519189,7519185,'min',33.333,3),(713,7519190,7519187,'cap',16.667,1),(713,7519191,7519187,'apa',16.667,1),(713,7519192,7519187,'pac',16.667,1),(713,7519193,7519187,'aci',16.667,1),(713,7519194,7519187,'cit',16.667,1),(713,7519195,7519187,'ity',16.667,1),(713,7519196,7519190,'pat',50,1),(713,7519197,7519190,'ath',50,1),(713,7519198,7519196,'fre',14.286,1),(713,7519199,7519196,'ree',14.286,1),(713,7519200,7519196,'ees',14.286,1),(713,7519201,7519196,'esp',14.286,1),(713,7519202,7519196,'spa',14.286,1),(713,7519203,7519196,'pac',14.286,1),(713,7519204,7519196,'ace',14.286,1),(713,7519205,7519198,'dis',50,1),(713,7519206,7519198,'isk',50,1),(713,7519207,7519205,'ind',33.333,1),(713,7519208,7519205,'nde',33.333,1),(713,7519209,7519205,'dex',33.333,1),(713,7519210,7519207,'adm',8.333,1),(713,7519211,7519207,'dmi',8.333,1),(713,7519212,7519207,'min',8.333,1),(713,7519213,7519207,'ini',8.333,1),(713,7519214,7519207,'nis',8.333,1),(713,7519215,7519207,'ist',8.333,1),(713,7519216,7519207,'str',8.333,1),(713,7519217,7519207,'tra',8.333,1),(713,7519218,7519207,'rat',8.333,1),(713,7519219,7519207,'ati',8.333,1),(713,7519220,7519207,'tio',8.333,1),(713,7519221,7519207,'ion',8.333,1),(713,7519222,7519210,'sta',33.333,3),(713,7519223,7519210,'tat',33.333,3),(713,7519224,7519210,'ate',33.333,3),(713,7519225,7519222,'ena',20,2),(713,7519226,7519222,'nab',20,2),(713,7519227,7519222,'abl',20,2),(713,7519228,7519222,'ble',20,2),(713,7519229,7519222,'led',20,2),(713,7519230,7519225,'cac',33.333,2),(713,7519231,7519225,'ach',33.333,2),(713,7519232,7519225,'che',33.333,2),(713,7519233,7519230,'mod',50,1),(713,7519234,7519230,'ode',50,1),(713,7519235,7519233,'wri',14.286,1),(713,7519236,7519233,'rit',14.286,1),(713,7519237,7519233,'ite',14.286,1),(713,7519238,7519233,'tet',14.286,1),(713,7519239,7519233,'eth',14.286,1),(713,7519240,7519233,'thr',14.286,1),(713,7519241,7519233,'hru',14.286,1),(713,7519242,7519235,'ope',11.111,2),(713,7519243,7519235,'per',11.111,2),(713,7519244,7519235,'era',11.111,2),(713,7519245,7519235,'rat',11.111,2),(713,7519246,7519235,'ati',11.111,2),(713,7519247,7519235,'tio',11.111,2),(713,7519248,7519235,'ion',11.111,2),(713,7519249,7519235,'ona',11.111,2),(713,7519250,7519235,'nal',11.111,2),(713,7519251,7519242,'pen',20,1),(713,7519252,7519242,'end',20,1),(713,7519253,7519242,'ndi',20,1),(713,7519254,7519242,'din',20,1),(713,7519255,7519242,'ing',20,1),(713,7519256,7519251,'mes',20,1),(713,7519257,7519251,'ess',20,1),(713,7519258,7519251,'ssa',20,1),(713,7519259,7519251,'sag',20,1),(713,7519260,7519251,'age',20,1),(713,7519261,7519256,'wai',20,1),(713,7519262,7519256,'ait',20,1),(713,7519263,7519256,'iti',20,1),(713,7519264,7519256,'tin',20,1),(713,7519265,7519256,'ing',20,1),(713,7519266,7519261,'for',100,1),(713,7519267,7519266,'per',11.111,1),(713,7519268,7519266,'erf',11.111,1),(713,7519269,7519266,'rfo',11.111,1),(713,7519270,7519266,'for',11.111,1),(713,7519271,7519266,'orm',11.111,1),(713,7519272,7519266,'rma',11.111,1),(713,7519273,7519266,'man',11.111,1),(713,7519274,7519266,'anc',11.111,1),(713,7519275,7519266,'nce',11.111,1),(713,7519276,7519267,'ide',12.5,1),(713,7519277,7519267,'den',12.5,1),(713,7519278,7519267,'ent',12.5,1),(713,7519279,7519267,'nti',12.5,1),(713,7519280,7519267,'tif',12.5,1),(713,7519281,7519267,'ifi',12.5,1),(713,7519282,7519267,'fie',12.5,1),(713,7519283,7519267,'ier',12.5,1),(713,7519284,7519276,'vdi',33.333,3),(713,7519285,7519276,'dis',33.333,3),(713,7519286,7519276,'isk',33.333,3),(713,7519287,7519284,'nam',50,1),(713,7519288,7519284,'ame',50,1),(713,7519289,7519287,'typ',50,1),(713,7519290,7519287,'ype',50,1),(713,7519291,7519289,'dir',25,1),(713,7519292,7519289,'ire',25,1),(713,7519293,7519289,'rec',25,1),(713,7519294,7519289,'ect',25,1),(714,7519296,7519295,'naa',100,2),(714,7519297,7519296,'600',3.333,3),(714,7519298,7519296,'000',3.333,3),(714,7519299,7519296,'00c',3.333,3),(714,7519300,7519296,'0c2',3.333,3),(714,7519301,7519296,'c29',3.333,3),(714,7519302,7519296,'299',3.333,3),(714,7519303,7519296,'999',3.333,3),(714,7519304,7519296,'99a',3.333,3),(714,7519305,7519296,'9a4',3.333,3),(714,7519306,7519296,'a42',3.333,3),(714,7519307,7519296,'42c',3.333,3),(714,7519308,7519296,'2c6',3.333,3),(714,7519309,7519296,'c65',3.333,3),(714,7519310,7519296,'659',3.333,3),(714,7519311,7519296,'59a',3.333,3),(714,7519312,7519296,'9a4',3.333,3),(714,7519313,7519296,'a4f',3.333,3),(714,7519314,7519296,'4fe',3.333,3),(714,7519315,7519296,'fee',3.333,3),(714,7519316,7519296,'ee5',3.333,3),(714,7519317,7519296,'e57',3.333,3),(714,7519318,7519296,'57e',3.333,3),(714,7519319,7519296,'7ef',3.333,3),(714,7519320,7519296,'eff',3.333,3),(714,7519321,7519296,'ff5',3.333,3),(714,7519322,7519296,'f5c',3.333,3),(714,7519323,7519296,'5c0',3.333,3),(714,7519324,7519296,'c09',3.333,3),(714,7519325,7519296,'096',3.333,3),(714,7519326,7519296,'967',3.333,3),(714,7519327,7519297,'mon',100,1),(714,7519328,7519327,'201',50,1),(714,7519329,7519327,'013',50,1),(714,7519330,7519328,'adm',33.333,3),(714,7519331,7519328,'dmi',33.333,3),(714,7519332,7519328,'min',33.333,3),(714,7519333,7519330,'cap',16.667,1),(714,7519334,7519330,'apa',16.667,1),(714,7519335,7519330,'pac',16.667,1),(714,7519336,7519330,'aci',16.667,1),(714,7519337,7519330,'cit',16.667,1),(714,7519338,7519330,'ity',16.667,1),(714,7519339,7519333,'pat',50,1),(714,7519340,7519333,'ath',50,1),(714,7519341,7519339,'fre',14.286,1),(714,7519342,7519339,'ree',14.286,1),(714,7519343,7519339,'ees',14.286,1),(714,7519344,7519339,'esp',14.286,1),(714,7519345,7519339,'spa',14.286,1),(714,7519346,7519339,'pac',14.286,1),(714,7519347,7519339,'ace',14.286,1),(714,7519348,7519341,'dis',50,1),(714,7519349,7519341,'isk',50,1),(714,7519350,7519348,'ind',33.333,1),(714,7519351,7519348,'nde',33.333,1),(714,7519352,7519348,'dex',33.333,1),(714,7519353,7519350,'adm',8.333,1),(714,7519354,7519350,'dmi',8.333,1),(714,7519355,7519350,'min',8.333,1),(714,7519356,7519350,'ini',8.333,1),(714,7519357,7519350,'nis',8.333,1),(714,7519358,7519350,'ist',8.333,1),(714,7519359,7519350,'str',8.333,1),(714,7519360,7519350,'tra',8.333,1),(714,7519361,7519350,'rat',8.333,1),(714,7519362,7519350,'ati',8.333,1),(714,7519363,7519350,'tio',8.333,1),(714,7519364,7519350,'ion',8.333,1),(714,7519365,7519353,'sta',33.333,3),(714,7519366,7519353,'tat',33.333,3),(714,7519367,7519353,'ate',33.333,3),(714,7519368,7519365,'ena',20,2),(714,7519369,7519365,'nab',20,2),(714,7519370,7519365,'abl',20,2),(714,7519371,7519365,'ble',20,2),(714,7519372,7519365,'led',20,2),(714,7519373,7519368,'cac',33.333,2),(714,7519374,7519368,'ach',33.333,2),(714,7519375,7519368,'che',33.333,2),(714,7519376,7519373,'mod',50,1),(714,7519377,7519373,'ode',50,1),(714,7519378,7519376,'wri',14.286,1),(714,7519379,7519376,'rit',14.286,1),(714,7519380,7519376,'ite',14.286,1),(714,7519381,7519376,'tet',14.286,1),(714,7519382,7519376,'eth',14.286,1),(714,7519383,7519376,'thr',14.286,1),(714,7519384,7519376,'hru',14.286,1),(714,7519385,7519378,'ope',11.111,2),(714,7519386,7519378,'per',11.111,2),(714,7519387,7519378,'era',11.111,2),(714,7519388,7519378,'rat',11.111,2),(714,7519389,7519378,'ati',11.111,2),(714,7519390,7519378,'tio',11.111,2),(714,7519391,7519378,'ion',11.111,2),(714,7519392,7519378,'ona',11.111,2),(714,7519393,7519378,'nal',11.111,2),(714,7519394,7519385,'pen',20,1),(714,7519395,7519385,'end',20,1),(714,7519396,7519385,'ndi',20,1),(714,7519397,7519385,'din',20,1),(714,7519398,7519385,'ing',20,1),(714,7519399,7519394,'mes',20,1),(714,7519400,7519394,'ess',20,1),(714,7519401,7519394,'ssa',20,1),(714,7519402,7519394,'sag',20,1),(714,7519403,7519394,'age',20,1),(714,7519404,7519399,'wai',20,1),(714,7519405,7519399,'ait',20,1),(714,7519406,7519399,'iti',20,1),(714,7519407,7519399,'tin',20,1),(714,7519408,7519399,'ing',20,1),(714,7519409,7519404,'for',100,1),(714,7519410,7519409,'per',11.111,1),(714,7519411,7519409,'erf',11.111,1),(714,7519412,7519409,'rfo',11.111,1),(714,7519413,7519409,'for',11.111,1),(714,7519414,7519409,'orm',11.111,1),(714,7519415,7519409,'rma',11.111,1),(714,7519416,7519409,'man',11.111,1),(714,7519417,7519409,'anc',11.111,1),(714,7519418,7519409,'nce',11.111,1),(714,7519419,7519410,'ide',12.5,1),(714,7519420,7519410,'den',12.5,1),(714,7519421,7519410,'ent',12.5,1),(714,7519422,7519410,'nti',12.5,1),(714,7519423,7519410,'tif',12.5,1),(714,7519424,7519410,'ifi',12.5,1),(714,7519425,7519410,'fie',12.5,1),(714,7519426,7519410,'ier',12.5,1),(714,7519427,7519419,'vdi',33.333,3),(714,7519428,7519419,'dis',33.333,3),(714,7519429,7519419,'isk',33.333,3),(714,7519430,7519427,'nam',50,1),(714,7519431,7519427,'ame',50,1),(714,7519432,7519430,'typ',50,1),(714,7519433,7519430,'ype',50,1),(714,7519434,7519432,'dir',25,1),(714,7519435,7519432,'ire',25,1),(714,7519436,7519432,'rec',25,1),(714,7519437,7519432,'ect',25,1),(715,7519439,7519438,'naa',100,2),(715,7519440,7519439,'600',3.333,3),(715,7519441,7519439,'000',3.333,3),(715,7519442,7519439,'00c',3.333,3),(715,7519443,7519439,'0c2',3.333,3),(715,7519444,7519439,'c29',3.333,3),(715,7519445,7519439,'293',3.333,3),(715,7519446,7519439,'939',3.333,3),(715,7519447,7519439,'39d',3.333,3),(715,7519448,7519439,'9dc',3.333,3),(715,7519449,7519439,'dc7',3.333,3),(715,7519450,7519439,'c73',3.333,3),(715,7519451,7519439,'736',3.333,3),(715,7519452,7519439,'363',3.333,3),(715,7519453,7519439,'633',3.333,3),(715,7519454,7519439,'33c',3.333,3),(715,7519455,7519439,'3c5',3.333,3),(715,7519456,7519439,'c5a',3.333,3),(715,7519457,7519439,'5a8',3.333,3),(715,7519458,7519439,'a88',3.333,3),(715,7519459,7519439,'882',3.333,3),(715,7519460,7519439,'824',3.333,3),(715,7519461,7519439,'24c',3.333,3),(715,7519462,7519439,'4c5',3.333,3),(715,7519463,7519439,'c53',3.333,3),(715,7519464,7519439,'53e',3.333,3),(715,7519465,7519439,'3e8',3.333,3),(715,7519466,7519439,'e82',3.333,3),(715,7519467,7519439,'82c',3.333,3),(715,7519468,7519439,'2c1',3.333,3),(715,7519469,7519439,'c1f',3.333,3),(715,7519470,7519440,'mon',100,1),(715,7519471,7519470,'201',50,1),(715,7519472,7519470,'013',50,1),(715,7519473,7519471,'adm',33.333,3),(715,7519474,7519471,'dmi',33.333,3),(715,7519475,7519471,'min',33.333,3),(715,7519476,7519473,'cap',16.667,1),(715,7519477,7519473,'apa',16.667,1),(715,7519478,7519473,'pac',16.667,1),(715,7519479,7519473,'aci',16.667,1),(715,7519480,7519473,'cit',16.667,1),(715,7519481,7519473,'ity',16.667,1),(715,7519482,7519476,'pat',50,1),(715,7519483,7519476,'ath',50,1),(715,7519484,7519482,'fre',14.286,1),(715,7519485,7519482,'ree',14.286,1),(715,7519486,7519482,'ees',14.286,1),(715,7519487,7519482,'esp',14.286,1),(715,7519488,7519482,'spa',14.286,1),(715,7519489,7519482,'pac',14.286,1),(715,7519490,7519482,'ace',14.286,1),(715,7519491,7519484,'dis',50,1),(715,7519492,7519484,'isk',50,1),(715,7519493,7519491,'ind',33.333,1),(715,7519494,7519491,'nde',33.333,1),(715,7519495,7519491,'dex',33.333,1),(715,7519496,7519493,'adm',8.333,1),(715,7519497,7519493,'dmi',8.333,1),(715,7519498,7519493,'min',8.333,1),(715,7519499,7519493,'ini',8.333,1),(715,7519500,7519493,'nis',8.333,1),(715,7519501,7519493,'ist',8.333,1),(715,7519502,7519493,'str',8.333,1),(715,7519503,7519493,'tra',8.333,1),(715,7519504,7519493,'rat',8.333,1),(715,7519505,7519493,'ati',8.333,1),(715,7519506,7519493,'tio',8.333,1),(715,7519507,7519493,'ion',8.333,1),(715,7519508,7519496,'sta',33.333,3),(715,7519509,7519496,'tat',33.333,3),(715,7519510,7519496,'ate',33.333,3),(715,7519511,7519508,'ena',20,2),(715,7519512,7519508,'nab',20,2),(715,7519513,7519508,'abl',20,2),(715,7519514,7519508,'ble',20,2),(715,7519515,7519508,'led',20,2),(715,7519516,7519511,'cac',33.333,2),(715,7519517,7519511,'ach',33.333,2),(715,7519518,7519511,'che',33.333,2),(715,7519519,7519516,'mod',50,1),(715,7519520,7519516,'ode',50,1),(715,7519521,7519519,'wri',14.286,1),(715,7519522,7519519,'rit',14.286,1),(715,7519523,7519519,'ite',14.286,1),(715,7519524,7519519,'tet',14.286,1),(715,7519525,7519519,'eth',14.286,1),(715,7519526,7519519,'thr',14.286,1),(715,7519527,7519519,'hru',14.286,1),(715,7519528,7519521,'ope',11.111,2),(715,7519529,7519521,'per',11.111,2),(715,7519530,7519521,'era',11.111,2),(715,7519531,7519521,'rat',11.111,2),(715,7519532,7519521,'ati',11.111,2),(715,7519533,7519521,'tio',11.111,2),(715,7519534,7519521,'ion',11.111,2),(715,7519535,7519521,'ona',11.111,2),(715,7519536,7519521,'nal',11.111,2),(715,7519537,7519528,'pen',20,1),(715,7519538,7519528,'end',20,1),(715,7519539,7519528,'ndi',20,1),(715,7519540,7519528,'din',20,1),(715,7519541,7519528,'ing',20,1),(715,7519542,7519537,'mes',20,1),(715,7519543,7519537,'ess',20,1),(715,7519544,7519537,'ssa',20,1),(715,7519545,7519537,'sag',20,1),(715,7519546,7519537,'age',20,1),(715,7519547,7519542,'wai',20,1),(715,7519548,7519542,'ait',20,1),(715,7519549,7519542,'iti',20,1),(715,7519550,7519542,'tin',20,1),(715,7519551,7519542,'ing',20,1),(715,7519552,7519547,'for',100,1),(715,7519553,7519552,'per',11.111,1),(715,7519554,7519552,'erf',11.111,1),(715,7519555,7519552,'rfo',11.111,1),(715,7519556,7519552,'for',11.111,1),(715,7519557,7519552,'orm',11.111,1),(715,7519558,7519552,'rma',11.111,1),(715,7519559,7519552,'man',11.111,1),(715,7519560,7519552,'anc',11.111,1),(715,7519561,7519552,'nce',11.111,1),(715,7519562,7519553,'ide',12.5,1),(715,7519563,7519553,'den',12.5,1),(715,7519564,7519553,'ent',12.5,1),(715,7519565,7519553,'nti',12.5,1),(715,7519566,7519553,'tif',12.5,1),(715,7519567,7519553,'ifi',12.5,1),(715,7519568,7519553,'fie',12.5,1),(715,7519569,7519553,'ier',12.5,1),(715,7519570,7519562,'vdi',33.333,3),(715,7519571,7519562,'dis',33.333,3),(715,7519572,7519562,'isk',33.333,3),(715,7519573,7519570,'nam',50,1),(715,7519574,7519570,'ame',50,1),(715,7519575,7519573,'typ',50,1),(715,7519576,7519573,'ype',50,1),(715,7519577,7519575,'dir',25,1),(715,7519578,7519575,'ire',25,1),(715,7519579,7519575,'rec',25,1),(715,7519580,7519575,'ect',25,1),(716,7519582,7519581,'naa',100,2),(716,7519583,7519582,'600',3.333,3),(716,7519584,7519582,'000',3.333,3),(716,7519585,7519582,'00c',3.333,3),(716,7519586,7519582,'0c2',3.333,3),(716,7519587,7519582,'c29',3.333,3),(716,7519588,7519582,'299',3.333,3),(716,7519589,7519582,'991',3.333,3),(716,7519590,7519582,'914',3.333,3),(716,7519591,7519582,'14a',3.333,3),(716,7519592,7519582,'4a2',3.333,3),(716,7519593,7519582,'a2b',3.333,3),(716,7519594,7519582,'2b4',3.333,3),(716,7519595,7519582,'b49',3.333,3),(716,7519596,7519582,'49d',3.333,3),(716,7519597,7519582,'9d0',3.333,3),(716,7519598,7519582,'d0a',3.333,3),(716,7519599,7519582,'0a9',3.333,3),(716,7519600,7519582,'a91',3.333,3),(716,7519601,7519582,'918',3.333,3),(716,7519602,7519582,'187',3.333,3),(716,7519603,7519582,'872',3.333,3),(716,7519604,7519582,'72f',3.333,3),(716,7519605,7519582,'2f3',3.333,3),(716,7519606,7519582,'f34',3.333,3),(716,7519607,7519582,'341',3.333,3),(716,7519608,7519582,'41a',3.333,3),(716,7519609,7519582,'1ac',3.333,3),(716,7519610,7519582,'ac2',3.333,3),(716,7519611,7519582,'c23',3.333,3),(716,7519612,7519582,'237',3.333,3),(716,7519613,7519583,'mon',100,1),(716,7519614,7519613,'201',50,1),(716,7519615,7519613,'013',50,1),(716,7519616,7519614,'adm',33.333,3),(716,7519617,7519614,'dmi',33.333,3),(716,7519618,7519614,'min',33.333,3),(716,7519619,7519616,'cap',16.667,1),(716,7519620,7519616,'apa',16.667,1),(716,7519621,7519616,'pac',16.667,1),(716,7519622,7519616,'aci',16.667,1),(716,7519623,7519616,'cit',16.667,1),(716,7519624,7519616,'ity',16.667,1),(716,7519625,7519619,'pat',50,1),(716,7519626,7519619,'ath',50,1),(716,7519627,7519625,'fre',14.286,1),(716,7519628,7519625,'ree',14.286,1),(716,7519629,7519625,'ees',14.286,1),(716,7519630,7519625,'esp',14.286,1),(716,7519631,7519625,'spa',14.286,1),(716,7519632,7519625,'pac',14.286,1),(716,7519633,7519625,'ace',14.286,1),(716,7519634,7519627,'dis',50,1),(716,7519635,7519627,'isk',50,1),(716,7519636,7519634,'ind',33.333,1),(716,7519637,7519634,'nde',33.333,1),(716,7519638,7519634,'dex',33.333,1),(716,7519639,7519636,'adm',8.333,1),(716,7519640,7519636,'dmi',8.333,1),(716,7519641,7519636,'min',8.333,1),(716,7519642,7519636,'ini',8.333,1),(716,7519643,7519636,'nis',8.333,1),(716,7519644,7519636,'ist',8.333,1),(716,7519645,7519636,'str',8.333,1),(716,7519646,7519636,'tra',8.333,1),(716,7519647,7519636,'rat',8.333,1),(716,7519648,7519636,'ati',8.333,1),(716,7519649,7519636,'tio',8.333,1),(716,7519650,7519636,'ion',8.333,1),(716,7519651,7519639,'sta',33.333,3),(716,7519652,7519639,'tat',33.333,3),(716,7519653,7519639,'ate',33.333,3),(716,7519654,7519651,'ena',20,2),(716,7519655,7519651,'nab',20,2),(716,7519656,7519651,'abl',20,2),(716,7519657,7519651,'ble',20,2),(716,7519658,7519651,'led',20,2),(716,7519659,7519654,'cac',33.333,2),(716,7519660,7519654,'ach',33.333,2),(716,7519661,7519654,'che',33.333,2),(716,7519662,7519659,'mod',50,1),(716,7519663,7519659,'ode',50,1),(716,7519664,7519662,'wri',14.286,1),(716,7519665,7519662,'rit',14.286,1),(716,7519666,7519662,'ite',14.286,1),(716,7519667,7519662,'tet',14.286,1),(716,7519668,7519662,'eth',14.286,1),(716,7519669,7519662,'thr',14.286,1),(716,7519670,7519662,'hru',14.286,1),(716,7519671,7519664,'ope',11.111,2),(716,7519672,7519664,'per',11.111,2),(716,7519673,7519664,'era',11.111,2),(716,7519674,7519664,'rat',11.111,2),(716,7519675,7519664,'ati',11.111,2),(716,7519676,7519664,'tio',11.111,2),(716,7519677,7519664,'ion',11.111,2),(716,7519678,7519664,'ona',11.111,2),(716,7519679,7519664,'nal',11.111,2),(716,7519680,7519671,'pen',20,1),(716,7519681,7519671,'end',20,1),(716,7519682,7519671,'ndi',20,1),(716,7519683,7519671,'din',20,1),(716,7519684,7519671,'ing',20,1),(716,7519685,7519680,'mes',20,1),(716,7519686,7519680,'ess',20,1),(716,7519687,7519680,'ssa',20,1),(716,7519688,7519680,'sag',20,1),(716,7519689,7519680,'age',20,1),(716,7519690,7519685,'wai',20,1),(716,7519691,7519685,'ait',20,1),(716,7519692,7519685,'iti',20,1),(716,7519693,7519685,'tin',20,1),(716,7519694,7519685,'ing',20,1),(716,7519695,7519690,'for',100,1),(716,7519696,7519695,'per',11.111,1),(716,7519697,7519695,'erf',11.111,1),(716,7519698,7519695,'rfo',11.111,1),(716,7519699,7519695,'for',11.111,1),(716,7519700,7519695,'orm',11.111,1),(716,7519701,7519695,'rma',11.111,1),(716,7519702,7519695,'man',11.111,1),(716,7519703,7519695,'anc',11.111,1),(716,7519704,7519695,'nce',11.111,1),(716,7519705,7519696,'ide',12.5,1),(716,7519706,7519696,'den',12.5,1),(716,7519707,7519696,'ent',12.5,1),(716,7519708,7519696,'nti',12.5,1),(716,7519709,7519696,'tif',12.5,1),(716,7519710,7519696,'ifi',12.5,1),(716,7519711,7519696,'fie',12.5,1),(716,7519712,7519696,'ier',12.5,1),(716,7519713,7519705,'vdi',33.333,3),(716,7519714,7519705,'dis',33.333,3),(716,7519715,7519705,'isk',33.333,3),(716,7519716,7519713,'nam',50,1),(716,7519717,7519713,'ame',50,1),(716,7519718,7519716,'typ',50,1),(716,7519719,7519716,'ype',50,1),(716,7519720,7519718,'dir',25,1),(716,7519721,7519718,'ire',25,1),(716,7519722,7519718,'rec',25,1),(716,7519723,7519718,'ect',25,1),(717,7519725,7519724,'naa',100,2),(717,7519726,7519725,'600',3.333,3),(717,7519727,7519725,'000',3.333,3),(717,7519728,7519725,'00c',3.333,3),(717,7519729,7519725,'0c2',3.333,3),(717,7519730,7519725,'c29',3.333,3),(717,7519731,7519725,'292',3.333,3),(717,7519732,7519725,'922',3.333,3),(717,7519733,7519725,'228',3.333,3),(717,7519734,7519725,'281',3.333,3),(717,7519735,7519725,'811',3.333,3),(717,7519736,7519725,'11b',3.333,3),(717,7519737,7519725,'1b5',3.333,3),(717,7519738,7519725,'b56',3.333,3),(717,7519739,7519725,'569',3.333,3),(717,7519740,7519725,'694',3.333,3),(717,7519741,7519725,'94f',3.333,3),(717,7519742,7519725,'4f1',3.333,3),(717,7519743,7519725,'f19',3.333,3),(717,7519744,7519725,'190',3.333,3),(717,7519745,7519725,'90b',3.333,3),(717,7519746,7519725,'0be',3.333,3),(717,7519747,7519725,'be4',3.333,3),(717,7519748,7519725,'e49',3.333,3),(717,7519749,7519725,'490',3.333,3),(717,7519750,7519725,'90d',3.333,3),(717,7519751,7519725,'0da',3.333,3),(717,7519752,7519725,'da4',3.333,3),(717,7519753,7519725,'a4a',3.333,3),(717,7519754,7519725,'4a9',3.333,3),(717,7519755,7519725,'a93',3.333,3),(717,7519756,7519726,'mon',100,1),(717,7519757,7519756,'201',50,1),(717,7519758,7519756,'013',50,1),(717,7519759,7519757,'adm',33.333,3),(717,7519760,7519757,'dmi',33.333,3),(717,7519761,7519757,'min',33.333,3),(717,7519762,7519759,'cap',16.667,1),(717,7519763,7519759,'apa',16.667,1),(717,7519764,7519759,'pac',16.667,1),(717,7519765,7519759,'aci',16.667,1),(717,7519766,7519759,'cit',16.667,1),(717,7519767,7519759,'ity',16.667,1),(717,7519768,7519762,'pat',50,1),(717,7519769,7519762,'ath',50,1),(717,7519770,7519768,'fre',14.286,1),(717,7519771,7519768,'ree',14.286,1),(717,7519772,7519768,'ees',14.286,1),(717,7519773,7519768,'esp',14.286,1),(717,7519774,7519768,'spa',14.286,1),(717,7519775,7519768,'pac',14.286,1),(717,7519776,7519768,'ace',14.286,1),(717,7519777,7519770,'dis',50,1),(717,7519778,7519770,'isk',50,1),(717,7519779,7519777,'ind',33.333,1),(717,7519780,7519777,'nde',33.333,1),(717,7519781,7519777,'dex',33.333,1),(717,7519782,7519779,'adm',8.333,1),(717,7519783,7519779,'dmi',8.333,1),(717,7519784,7519779,'min',8.333,1),(717,7519785,7519779,'ini',8.333,1),(717,7519786,7519779,'nis',8.333,1),(717,7519787,7519779,'ist',8.333,1),(717,7519788,7519779,'str',8.333,1),(717,7519789,7519779,'tra',8.333,1),(717,7519790,7519779,'rat',8.333,1),(717,7519791,7519779,'ati',8.333,1),(717,7519792,7519779,'tio',8.333,1),(717,7519793,7519779,'ion',8.333,1),(717,7519794,7519782,'sta',33.333,3),(717,7519795,7519782,'tat',33.333,3),(717,7519796,7519782,'ate',33.333,3),(717,7519797,7519794,'ena',20,2),(717,7519798,7519794,'nab',20,2),(717,7519799,7519794,'abl',20,2),(717,7519800,7519794,'ble',20,2),(717,7519801,7519794,'led',20,2),(717,7519802,7519797,'cac',33.333,2),(717,7519803,7519797,'ach',33.333,2),(717,7519804,7519797,'che',33.333,2),(717,7519805,7519802,'mod',50,1),(717,7519806,7519802,'ode',50,1),(717,7519807,7519805,'wri',14.286,1),(717,7519808,7519805,'rit',14.286,1),(717,7519809,7519805,'ite',14.286,1),(717,7519810,7519805,'tet',14.286,1),(717,7519811,7519805,'eth',14.286,1),(717,7519812,7519805,'thr',14.286,1),(717,7519813,7519805,'hru',14.286,1),(717,7519814,7519807,'ope',11.111,2),(717,7519815,7519807,'per',11.111,2),(717,7519816,7519807,'era',11.111,2),(717,7519817,7519807,'rat',11.111,2),(717,7519818,7519807,'ati',11.111,2),(717,7519819,7519807,'tio',11.111,2),(717,7519820,7519807,'ion',11.111,2),(717,7519821,7519807,'ona',11.111,2),(717,7519822,7519807,'nal',11.111,2),(717,7519823,7519814,'pen',20,1),(717,7519824,7519814,'end',20,1),(717,7519825,7519814,'ndi',20,1),(717,7519826,7519814,'din',20,1),(717,7519827,7519814,'ing',20,1),(717,7519828,7519823,'mes',20,1),(717,7519829,7519823,'ess',20,1),(717,7519830,7519823,'ssa',20,1),(717,7519831,7519823,'sag',20,1),(717,7519832,7519823,'age',20,1),(717,7519833,7519828,'wai',20,1),(717,7519834,7519828,'ait',20,1),(717,7519835,7519828,'iti',20,1),(717,7519836,7519828,'tin',20,1),(717,7519837,7519828,'ing',20,1),(717,7519838,7519833,'for',100,1),(717,7519839,7519838,'per',11.111,1),(717,7519840,7519838,'erf',11.111,1),(717,7519841,7519838,'rfo',11.111,1),(717,7519842,7519838,'for',11.111,1),(717,7519843,7519838,'orm',11.111,1),(717,7519844,7519838,'rma',11.111,1),(717,7519845,7519838,'man',11.111,1),(717,7519846,7519838,'anc',11.111,1),(717,7519847,7519838,'nce',11.111,1),(717,7519848,7519839,'ide',12.5,1),(717,7519849,7519839,'den',12.5,1),(717,7519850,7519839,'ent',12.5,1),(717,7519851,7519839,'nti',12.5,1),(717,7519852,7519839,'tif',12.5,1),(717,7519853,7519839,'ifi',12.5,1),(717,7519854,7519839,'fie',12.5,1),(717,7519855,7519839,'ier',12.5,1),(717,7519856,7519848,'vdi',33.333,3),(717,7519857,7519848,'dis',33.333,3),(717,7519858,7519848,'isk',33.333,3),(717,7519859,7519856,'nam',50,1),(717,7519860,7519856,'ame',50,1),(717,7519861,7519859,'typ',50,1),(717,7519862,7519859,'ype',50,1),(717,7519863,7519861,'dir',25,1),(717,7519864,7519861,'ire',25,1),(717,7519865,7519861,'rec',25,1),(717,7519866,7519861,'ect',25,1),(718,7519868,7519867,'naa',100,2),(718,7519869,7519868,'600',3.333,3),(718,7519870,7519868,'000',3.333,3),(718,7519871,7519868,'00c',3.333,3),(718,7519872,7519868,'0c2',3.333,3),(718,7519873,7519868,'c29',3.333,3),(718,7519874,7519868,'297',3.333,3),(718,7519875,7519868,'972',3.333,3),(718,7519876,7519868,'721',3.333,3),(718,7519877,7519868,'21c',3.333,3),(718,7519878,7519868,'1c1',3.333,3),(718,7519879,7519868,'c1d',3.333,3),(718,7519880,7519868,'1dc',3.333,3),(718,7519881,7519868,'dc1',3.333,3),(718,7519882,7519868,'c12',3.333,3),(718,7519883,7519868,'120',3.333,3),(718,7519884,7519868,'201',3.333,3),(718,7519885,7519868,'018',3.333,3),(718,7519886,7519868,'18d',3.333,3),(718,7519887,7519868,'8db',3.333,3),(718,7519888,7519868,'db7',3.333,3),(718,7519889,7519868,'b73',3.333,3),(718,7519890,7519868,'733',3.333,3),(718,7519891,7519868,'334',3.333,3),(718,7519892,7519868,'34e',3.333,3),(718,7519893,7519868,'4e2',3.333,3),(718,7519894,7519868,'e29',3.333,3),(718,7519895,7519868,'293',3.333,3),(718,7519896,7519868,'93b',3.333,3),(718,7519897,7519868,'3b4',3.333,3),(718,7519898,7519868,'b4b',3.333,3),(718,7519899,7519869,'mon',100,1),(718,7519900,7519899,'201',50,1),(718,7519901,7519899,'013',50,1),(718,7519902,7519900,'adm',33.333,3),(718,7519903,7519900,'dmi',33.333,3),(718,7519904,7519900,'min',33.333,3),(718,7519905,7519902,'cap',16.667,1),(718,7519906,7519902,'apa',16.667,1),(718,7519907,7519902,'pac',16.667,1),(718,7519908,7519902,'aci',16.667,1),(718,7519909,7519902,'cit',16.667,1),(718,7519910,7519902,'ity',16.667,1),(718,7519911,7519905,'pat',50,1),(718,7519912,7519905,'ath',50,1),(718,7519913,7519911,'fre',14.286,1),(718,7519914,7519911,'ree',14.286,1),(718,7519915,7519911,'ees',14.286,1),(718,7519916,7519911,'esp',14.286,1),(718,7519917,7519911,'spa',14.286,1),(718,7519918,7519911,'pac',14.286,1),(718,7519919,7519911,'ace',14.286,1),(718,7519920,7519913,'dis',50,1),(718,7519921,7519913,'isk',50,1),(718,7519922,7519920,'ind',33.333,1),(718,7519923,7519920,'nde',33.333,1),(718,7519924,7519920,'dex',33.333,1),(718,7519925,7519922,'adm',8.333,1),(718,7519926,7519922,'dmi',8.333,1),(718,7519927,7519922,'min',8.333,1),(718,7519928,7519922,'ini',8.333,1),(718,7519929,7519922,'nis',8.333,1),(718,7519930,7519922,'ist',8.333,1),(718,7519931,7519922,'str',8.333,1),(718,7519932,7519922,'tra',8.333,1),(718,7519933,7519922,'rat',8.333,1),(718,7519934,7519922,'ati',8.333,1),(718,7519935,7519922,'tio',8.333,1),(718,7519936,7519922,'ion',8.333,1),(718,7519937,7519925,'sta',33.333,3),(718,7519938,7519925,'tat',33.333,3),(718,7519939,7519925,'ate',33.333,3),(718,7519940,7519937,'ena',20,2),(718,7519941,7519937,'nab',20,2),(718,7519942,7519937,'abl',20,2),(718,7519943,7519937,'ble',20,2),(718,7519944,7519937,'led',20,2),(718,7519945,7519940,'cac',33.333,2),(718,7519946,7519940,'ach',33.333,2),(718,7519947,7519940,'che',33.333,2),(718,7519948,7519945,'mod',50,1),(718,7519949,7519945,'ode',50,1),(718,7519950,7519948,'wri',14.286,1),(718,7519951,7519948,'rit',14.286,1),(718,7519952,7519948,'ite',14.286,1),(718,7519953,7519948,'tet',14.286,1),(718,7519954,7519948,'eth',14.286,1),(718,7519955,7519948,'thr',14.286,1),(718,7519956,7519948,'hru',14.286,1),(718,7519957,7519950,'ope',11.111,2),(718,7519958,7519950,'per',11.111,2),(718,7519959,7519950,'era',11.111,2),(718,7519960,7519950,'rat',11.111,2),(718,7519961,7519950,'ati',11.111,2),(718,7519962,7519950,'tio',11.111,2),(718,7519963,7519950,'ion',11.111,2),(718,7519964,7519950,'ona',11.111,2),(718,7519965,7519950,'nal',11.111,2),(718,7519966,7519957,'pen',20,1),(718,7519967,7519957,'end',20,1),(718,7519968,7519957,'ndi',20,1),(718,7519969,7519957,'din',20,1),(718,7519970,7519957,'ing',20,1),(718,7519971,7519966,'mes',20,1),(718,7519972,7519966,'ess',20,1),(718,7519973,7519966,'ssa',20,1),(718,7519974,7519966,'sag',20,1),(718,7519975,7519966,'age',20,1),(718,7519976,7519971,'wai',20,1),(718,7519977,7519971,'ait',20,1),(718,7519978,7519971,'iti',20,1),(718,7519979,7519971,'tin',20,1),(718,7519980,7519971,'ing',20,1),(718,7519981,7519976,'for',100,1),(718,7519982,7519981,'per',11.111,1),(718,7519983,7519981,'erf',11.111,1),(718,7519984,7519981,'rfo',11.111,1),(718,7519985,7519981,'for',11.111,1),(718,7519986,7519981,'orm',11.111,1),(718,7519987,7519981,'rma',11.111,1),(718,7519988,7519981,'man',11.111,1),(718,7519989,7519981,'anc',11.111,1),(718,7519990,7519981,'nce',11.111,1),(718,7519991,7519982,'ide',12.5,1),(718,7519992,7519982,'den',12.5,1),(718,7519993,7519982,'ent',12.5,1),(718,7519994,7519982,'nti',12.5,1),(718,7519995,7519982,'tif',12.5,1),(718,7519996,7519982,'ifi',12.5,1),(718,7519997,7519982,'fie',12.5,1),(718,7519998,7519982,'ier',12.5,1),(718,7519999,7519991,'vdi',33.333,3),(718,7520000,7519991,'dis',33.333,3),(718,7520001,7519991,'isk',33.333,3),(718,7520002,7519999,'nam',50,1),(718,7520003,7519999,'ame',50,1),(718,7520004,7520002,'typ',50,1),(718,7520005,7520002,'ype',50,1),(718,7520006,7520004,'dir',25,1),(718,7520007,7520004,'ire',25,1),(718,7520008,7520004,'rec',25,1),(718,7520009,7520004,'ect',25,1),(719,7520011,7520010,'naa',100,2),(719,7520012,7520011,'600',3.333,3),(719,7520013,7520011,'000',3.333,3),(719,7520014,7520011,'00c',3.333,3),(719,7520015,7520011,'0c2',3.333,3),(719,7520016,7520011,'c29',3.333,3),(719,7520017,7520011,'29f',3.333,3),(719,7520018,7520011,'9f0',3.333,3),(719,7520019,7520011,'f0e',3.333,3),(719,7520020,7520011,'0ee',3.333,3),(719,7520021,7520011,'eed',3.333,3),(719,7520022,7520011,'ed3',3.333,3),(719,7520023,7520011,'d3e',3.333,3),(719,7520024,7520011,'3ee',3.333,3),(719,7520025,7520011,'ee7',3.333,3),(719,7520026,7520011,'e74',3.333,3),(719,7520027,7520011,'74a',3.333,3),(719,7520028,7520011,'4ab',3.333,3),(719,7520029,7520011,'ab8',3.333,3),(719,7520030,7520011,'b8c',3.333,3),(719,7520031,7520011,'8c2',3.333,3),(719,7520032,7520011,'c28',3.333,3),(719,7520033,7520011,'28b',3.333,3),(719,7520034,7520011,'8b0',3.333,3),(719,7520035,7520011,'b06',3.333,3),(719,7520036,7520011,'06e',3.333,3),(719,7520037,7520011,'6e7',3.333,3),(719,7520038,7520011,'e75',3.333,3),(719,7520039,7520011,'75d',3.333,3),(719,7520040,7520011,'5d6',3.333,3),(719,7520041,7520011,'d62',3.333,3),(719,7520042,7520012,'mon',100,1),(719,7520043,7520042,'201',50,1),(719,7520044,7520042,'013',50,1),(719,7520045,7520043,'adm',33.333,3),(719,7520046,7520043,'dmi',33.333,3),(719,7520047,7520043,'min',33.333,3),(719,7520048,7520045,'cap',16.667,1),(719,7520049,7520045,'apa',16.667,1),(719,7520050,7520045,'pac',16.667,1),(719,7520051,7520045,'aci',16.667,1),(719,7520052,7520045,'cit',16.667,1),(719,7520053,7520045,'ity',16.667,1),(719,7520054,7520048,'pat',50,1),(719,7520055,7520048,'ath',50,1),(719,7520056,7520054,'fre',14.286,1),(719,7520057,7520054,'ree',14.286,1),(719,7520058,7520054,'ees',14.286,1),(719,7520059,7520054,'esp',14.286,1),(719,7520060,7520054,'spa',14.286,1),(719,7520061,7520054,'pac',14.286,1),(719,7520062,7520054,'ace',14.286,1),(719,7520063,7520056,'dis',50,1),(719,7520064,7520056,'isk',50,1),(719,7520065,7520063,'ind',33.333,1),(719,7520066,7520063,'nde',33.333,1),(719,7520067,7520063,'dex',33.333,1),(719,7520068,7520065,'adm',8.333,1),(719,7520069,7520065,'dmi',8.333,1),(719,7520070,7520065,'min',8.333,1),(719,7520071,7520065,'ini',8.333,1),(719,7520072,7520065,'nis',8.333,1),(719,7520073,7520065,'ist',8.333,1),(719,7520074,7520065,'str',8.333,1),(719,7520075,7520065,'tra',8.333,1),(719,7520076,7520065,'rat',8.333,1),(719,7520077,7520065,'ati',8.333,1),(719,7520078,7520065,'tio',8.333,1),(719,7520079,7520065,'ion',8.333,1),(719,7520080,7520068,'sta',33.333,3),(719,7520081,7520068,'tat',33.333,3),(719,7520082,7520068,'ate',33.333,3),(719,7520083,7520080,'ena',20,2),(719,7520084,7520080,'nab',20,2),(719,7520085,7520080,'abl',20,2),(719,7520086,7520080,'ble',20,2),(719,7520087,7520080,'led',20,2),(719,7520088,7520083,'cac',33.333,2),(719,7520089,7520083,'ach',33.333,2),(719,7520090,7520083,'che',33.333,2),(719,7520091,7520088,'mod',50,1),(719,7520092,7520088,'ode',50,1),(719,7520093,7520091,'wri',14.286,1),(719,7520094,7520091,'rit',14.286,1),(719,7520095,7520091,'ite',14.286,1),(719,7520096,7520091,'tet',14.286,1),(719,7520097,7520091,'eth',14.286,1),(719,7520098,7520091,'thr',14.286,1),(719,7520099,7520091,'hru',14.286,1),(719,7520100,7520093,'ope',11.111,2),(719,7520101,7520093,'per',11.111,2),(719,7520102,7520093,'era',11.111,2),(719,7520103,7520093,'rat',11.111,2),(719,7520104,7520093,'ati',11.111,2),(719,7520105,7520093,'tio',11.111,2),(719,7520106,7520093,'ion',11.111,2),(719,7520107,7520093,'ona',11.111,2),(719,7520108,7520093,'nal',11.111,2),(719,7520109,7520100,'pen',20,1),(719,7520110,7520100,'end',20,1),(719,7520111,7520100,'ndi',20,1),(719,7520112,7520100,'din',20,1),(719,7520113,7520100,'ing',20,1),(719,7520114,7520109,'mes',20,1),(719,7520115,7520109,'ess',20,1),(719,7520116,7520109,'ssa',20,1),(719,7520117,7520109,'sag',20,1),(719,7520118,7520109,'age',20,1),(719,7520119,7520114,'wai',20,1),(719,7520120,7520114,'ait',20,1),(719,7520121,7520114,'iti',20,1),(719,7520122,7520114,'tin',20,1),(719,7520123,7520114,'ing',20,1),(719,7520124,7520119,'for',100,1),(719,7520125,7520124,'per',11.111,1),(719,7520126,7520124,'erf',11.111,1),(719,7520127,7520124,'rfo',11.111,1),(719,7520128,7520124,'for',11.111,1),(719,7520129,7520124,'orm',11.111,1),(719,7520130,7520124,'rma',11.111,1),(719,7520131,7520124,'man',11.111,1),(719,7520132,7520124,'anc',11.111,1),(719,7520133,7520124,'nce',11.111,1),(719,7520134,7520125,'ide',12.5,1),(719,7520135,7520125,'den',12.5,1),(719,7520136,7520125,'ent',12.5,1),(719,7520137,7520125,'nti',12.5,1),(719,7520138,7520125,'tif',12.5,1),(719,7520139,7520125,'ifi',12.5,1),(719,7520140,7520125,'fie',12.5,1),(719,7520141,7520125,'ier',12.5,1),(719,7520142,7520134,'vdi',33.333,3),(719,7520143,7520134,'dis',33.333,3),(719,7520144,7520134,'isk',33.333,3),(719,7520145,7520142,'nam',50,1),(719,7520146,7520142,'ame',50,1),(719,7520147,7520145,'typ',50,1),(719,7520148,7520145,'ype',50,1),(719,7520149,7520147,'dir',25,1),(719,7520150,7520147,'ire',25,1),(719,7520151,7520147,'rec',25,1),(719,7520152,7520147,'ect',25,1),(720,7520154,7520153,'naa',100,2),(720,7520155,7520154,'600',3.333,3),(720,7520156,7520154,'000',3.333,3),(720,7520157,7520154,'00c',3.333,3),(720,7520158,7520154,'0c2',3.333,3),(720,7520159,7520154,'c29',3.333,3),(720,7520160,7520154,'295',3.333,3),(720,7520161,7520154,'957',3.333,3),(720,7520162,7520154,'573',3.333,3),(720,7520163,7520154,'731',3.333,3),(720,7520164,7520154,'313',3.333,3),(720,7520165,7520154,'133',3.333,3),(720,7520166,7520154,'33f',3.333,3),(720,7520167,7520154,'3fc',3.333,3),(720,7520168,7520154,'fc5',3.333,3),(720,7520169,7520154,'c59',3.333,3),(720,7520170,7520154,'593',3.333,3),(720,7520171,7520154,'938',3.333,3),(720,7520172,7520154,'384',3.333,3),(720,7520173,7520154,'843',3.333,3),(720,7520174,7520154,'43b',3.333,3),(720,7520175,7520154,'3b9',3.333,3),(720,7520176,7520154,'b9b',3.333,3),(720,7520177,7520154,'9b8',3.333,3),(720,7520178,7520154,'b8e',3.333,3),(720,7520179,7520154,'8ed',3.333,3),(720,7520180,7520154,'ed7',3.333,3),(720,7520181,7520154,'d7d',3.333,3),(720,7520182,7520154,'7d1',3.333,3),(720,7520183,7520154,'d15',3.333,3),(720,7520184,7520154,'15b',3.333,3),(720,7520185,7520155,'mon',100,1),(720,7520186,7520185,'201',50,1),(720,7520187,7520185,'013',50,1),(720,7520188,7520186,'adm',33.333,3),(720,7520189,7520186,'dmi',33.333,3),(720,7520190,7520186,'min',33.333,3),(720,7520191,7520188,'cap',16.667,1),(720,7520192,7520188,'apa',16.667,1),(720,7520193,7520188,'pac',16.667,1),(720,7520194,7520188,'aci',16.667,1),(720,7520195,7520188,'cit',16.667,1),(720,7520196,7520188,'ity',16.667,1),(720,7520197,7520191,'pat',50,1),(720,7520198,7520191,'ath',50,1),(720,7520199,7520197,'fre',14.286,1),(720,7520200,7520197,'ree',14.286,1),(720,7520201,7520197,'ees',14.286,1),(720,7520202,7520197,'esp',14.286,1),(720,7520203,7520197,'spa',14.286,1),(720,7520204,7520197,'pac',14.286,1),(720,7520205,7520197,'ace',14.286,1),(720,7520206,7520199,'dis',50,1),(720,7520207,7520199,'isk',50,1),(720,7520208,7520206,'ind',33.333,1),(720,7520209,7520206,'nde',33.333,1),(720,7520210,7520206,'dex',33.333,1),(720,7520211,7520208,'adm',8.333,1),(720,7520212,7520208,'dmi',8.333,1),(720,7520213,7520208,'min',8.333,1),(720,7520214,7520208,'ini',8.333,1),(720,7520215,7520208,'nis',8.333,1),(720,7520216,7520208,'ist',8.333,1),(720,7520217,7520208,'str',8.333,1),(720,7520218,7520208,'tra',8.333,1),(720,7520219,7520208,'rat',8.333,1),(720,7520220,7520208,'ati',8.333,1),(720,7520221,7520208,'tio',8.333,1),(720,7520222,7520208,'ion',8.333,1),(720,7520223,7520211,'sta',33.333,3),(720,7520224,7520211,'tat',33.333,3),(720,7520225,7520211,'ate',33.333,3),(720,7520226,7520223,'ena',20,2),(720,7520227,7520223,'nab',20,2),(720,7520228,7520223,'abl',20,2),(720,7520229,7520223,'ble',20,2),(720,7520230,7520223,'led',20,2),(720,7520231,7520226,'cac',33.333,2),(720,7520232,7520226,'ach',33.333,2),(720,7520233,7520226,'che',33.333,2),(720,7520234,7520231,'mod',50,1),(720,7520235,7520231,'ode',50,1),(720,7520236,7520234,'wri',14.286,1),(720,7520237,7520234,'rit',14.286,1),(720,7520238,7520234,'ite',14.286,1),(720,7520239,7520234,'tet',14.286,1),(720,7520240,7520234,'eth',14.286,1),(720,7520241,7520234,'thr',14.286,1),(720,7520242,7520234,'hru',14.286,1),(720,7520243,7520236,'ope',11.111,2),(720,7520244,7520236,'per',11.111,2),(720,7520245,7520236,'era',11.111,2),(720,7520246,7520236,'rat',11.111,2),(720,7520247,7520236,'ati',11.111,2),(720,7520248,7520236,'tio',11.111,2),(720,7520249,7520236,'ion',11.111,2),(720,7520250,7520236,'ona',11.111,2),(720,7520251,7520236,'nal',11.111,2),(720,7520252,7520243,'pen',20,1),(720,7520253,7520243,'end',20,1),(720,7520254,7520243,'ndi',20,1),(720,7520255,7520243,'din',20,1),(720,7520256,7520243,'ing',20,1),(720,7520257,7520252,'mes',20,1),(720,7520258,7520252,'ess',20,1),(720,7520259,7520252,'ssa',20,1),(720,7520260,7520252,'sag',20,1),(720,7520261,7520252,'age',20,1),(720,7520262,7520257,'wai',20,1),(720,7520263,7520257,'ait',20,1),(720,7520264,7520257,'iti',20,1),(720,7520265,7520257,'tin',20,1),(720,7520266,7520257,'ing',20,1),(720,7520267,7520262,'for',100,1),(720,7520268,7520267,'per',11.111,1),(720,7520269,7520267,'erf',11.111,1),(720,7520270,7520267,'rfo',11.111,1),(720,7520271,7520267,'for',11.111,1),(720,7520272,7520267,'orm',11.111,1),(720,7520273,7520267,'rma',11.111,1),(720,7520274,7520267,'man',11.111,1),(720,7520275,7520267,'anc',11.111,1),(720,7520276,7520267,'nce',11.111,1),(720,7520277,7520268,'ide',12.5,1),(720,7520278,7520268,'den',12.5,1),(720,7520279,7520268,'ent',12.5,1),(720,7520280,7520268,'nti',12.5,1),(720,7520281,7520268,'tif',12.5,1),(720,7520282,7520268,'ifi',12.5,1),(720,7520283,7520268,'fie',12.5,1),(720,7520284,7520268,'ier',12.5,1),(720,7520285,7520277,'vdi',33.333,3),(720,7520286,7520277,'dis',33.333,3),(720,7520287,7520277,'isk',33.333,3),(720,7520288,7520285,'nam',50,1),(720,7520289,7520285,'ame',50,1),(720,7520290,7520288,'typ',50,1),(720,7520291,7520288,'ype',50,1),(720,7520292,7520290,'dir',25,1),(720,7520293,7520290,'ire',25,1),(720,7520294,7520290,'rec',25,1),(720,7520295,7520290,'ect',25,1),(721,7520297,7520296,'naa',100,2),(721,7520298,7520297,'600',3.333,3),(721,7520299,7520297,'000',3.333,3),(721,7520300,7520297,'00c',3.333,3),(721,7520301,7520297,'0c2',3.333,3),(721,7520302,7520297,'c29',3.333,3),(721,7520303,7520297,'296',3.333,3),(721,7520304,7520297,'96d',3.333,3),(721,7520305,7520297,'6d9',3.333,3),(721,7520306,7520297,'d90',3.333,3),(721,7520307,7520297,'901',3.333,3),(721,7520308,7520297,'01f',3.333,3),(721,7520309,7520297,'1f7',3.333,3),(721,7520310,7520297,'f7d',3.333,3),(721,7520311,7520297,'7d5',3.333,3),(721,7520312,7520297,'d51',3.333,3),(721,7520313,7520297,'51f',3.333,3),(721,7520314,7520297,'1fb',3.333,3),(721,7520315,7520297,'fb4',3.333,3),(721,7520316,7520297,'b45',3.333,3),(721,7520317,7520297,'457',3.333,3),(721,7520318,7520297,'57e',3.333,3),(721,7520319,7520297,'7e7',3.333,3),(721,7520320,7520297,'e70',3.333,3),(721,7520321,7520297,'704',3.333,3),(721,7520322,7520297,'041',3.333,3),(721,7520323,7520297,'41f',3.333,3),(721,7520324,7520297,'1f2',3.333,3),(721,7520325,7520297,'f2f',3.333,3),(721,7520326,7520297,'2ff',3.333,3),(721,7520327,7520297,'ff0',3.333,3),(721,7520328,7520298,'mon',100,1),(721,7520329,7520328,'201',50,1),(721,7520330,7520328,'013',50,1),(721,7520331,7520329,'adm',33.333,3),(721,7520332,7520329,'dmi',33.333,3),(721,7520333,7520329,'min',33.333,3),(721,7520334,7520331,'cap',16.667,1),(721,7520335,7520331,'apa',16.667,1),(721,7520336,7520331,'pac',16.667,1),(721,7520337,7520331,'aci',16.667,1),(721,7520338,7520331,'cit',16.667,1),(721,7520339,7520331,'ity',16.667,1),(721,7520340,7520334,'pat',50,1),(721,7520341,7520334,'ath',50,1),(721,7520342,7520340,'fre',14.286,1),(721,7520343,7520340,'ree',14.286,1),(721,7520344,7520340,'ees',14.286,1),(721,7520345,7520340,'esp',14.286,1),(721,7520346,7520340,'spa',14.286,1),(721,7520347,7520340,'pac',14.286,1),(721,7520348,7520340,'ace',14.286,1),(721,7520349,7520342,'dis',50,1),(721,7520350,7520342,'isk',50,1),(721,7520351,7520349,'ind',33.333,1),(721,7520352,7520349,'nde',33.333,1),(721,7520353,7520349,'dex',33.333,1),(721,7520354,7520351,'adm',8.333,1),(721,7520355,7520351,'dmi',8.333,1),(721,7520356,7520351,'min',8.333,1),(721,7520357,7520351,'ini',8.333,1),(721,7520358,7520351,'nis',8.333,1),(721,7520359,7520351,'ist',8.333,1),(721,7520360,7520351,'str',8.333,1);
INSERT INTO `fuzzysearch_default_fuzzysearch_index_search_api_viewed` VALUES (721,7520361,7520351,'tra',8.333,1),(721,7520362,7520351,'rat',8.333,1),(721,7520363,7520351,'ati',8.333,1),(721,7520364,7520351,'tio',8.333,1),(721,7520365,7520351,'ion',8.333,1),(721,7520366,7520354,'sta',33.333,3),(721,7520367,7520354,'tat',33.333,3),(721,7520368,7520354,'ate',33.333,3),(721,7520369,7520366,'ena',20,2),(721,7520370,7520366,'nab',20,2),(721,7520371,7520366,'abl',20,2),(721,7520372,7520366,'ble',20,2),(721,7520373,7520366,'led',20,2),(721,7520374,7520369,'cac',33.333,2),(721,7520375,7520369,'ach',33.333,2),(721,7520376,7520369,'che',33.333,2),(721,7520377,7520374,'mod',50,1),(721,7520378,7520374,'ode',50,1),(721,7520379,7520377,'wri',14.286,1),(721,7520380,7520377,'rit',14.286,1),(721,7520381,7520377,'ite',14.286,1),(721,7520382,7520377,'tet',14.286,1),(721,7520383,7520377,'eth',14.286,1),(721,7520384,7520377,'thr',14.286,1),(721,7520385,7520377,'hru',14.286,1),(721,7520386,7520379,'ope',11.111,2),(721,7520387,7520379,'per',11.111,2),(721,7520388,7520379,'era',11.111,2),(721,7520389,7520379,'rat',11.111,2),(721,7520390,7520379,'ati',11.111,2),(721,7520391,7520379,'tio',11.111,2),(721,7520392,7520379,'ion',11.111,2),(721,7520393,7520379,'ona',11.111,2),(721,7520394,7520379,'nal',11.111,2),(721,7520395,7520386,'pen',20,1),(721,7520396,7520386,'end',20,1),(721,7520397,7520386,'ndi',20,1),(721,7520398,7520386,'din',20,1),(721,7520399,7520386,'ing',20,1),(721,7520400,7520395,'mes',20,1),(721,7520401,7520395,'ess',20,1),(721,7520402,7520395,'ssa',20,1),(721,7520403,7520395,'sag',20,1),(721,7520404,7520395,'age',20,1),(721,7520405,7520400,'wai',20,1),(721,7520406,7520400,'ait',20,1),(721,7520407,7520400,'iti',20,1),(721,7520408,7520400,'tin',20,1),(721,7520409,7520400,'ing',20,1),(721,7520410,7520405,'for',100,1),(721,7520411,7520410,'per',11.111,1),(721,7520412,7520410,'erf',11.111,1),(721,7520413,7520410,'rfo',11.111,1),(721,7520414,7520410,'for',11.111,1),(721,7520415,7520410,'orm',11.111,1),(721,7520416,7520410,'rma',11.111,1),(721,7520417,7520410,'man',11.111,1),(721,7520418,7520410,'anc',11.111,1),(721,7520419,7520410,'nce',11.111,1),(721,7520420,7520411,'ide',12.5,1),(721,7520421,7520411,'den',12.5,1),(721,7520422,7520411,'ent',12.5,1),(721,7520423,7520411,'nti',12.5,1),(721,7520424,7520411,'tif',12.5,1),(721,7520425,7520411,'ifi',12.5,1),(721,7520426,7520411,'fie',12.5,1),(721,7520427,7520411,'ier',12.5,1),(721,7520428,7520420,'vdi',33.333,3),(721,7520429,7520420,'dis',33.333,3),(721,7520430,7520420,'isk',33.333,3),(721,7520431,7520428,'nam',50,1),(721,7520432,7520428,'ame',50,1),(721,7520433,7520431,'typ',50,1),(721,7520434,7520431,'ype',50,1),(721,7520435,7520433,'dir',25,1),(721,7520436,7520433,'ire',25,1),(721,7520437,7520433,'rec',25,1),(721,7520438,7520433,'ect',25,1),(722,7520440,7520439,'naa',100,2),(722,7520441,7520440,'600',3.333,3),(722,7520442,7520440,'000',3.333,3),(722,7520443,7520440,'00c',3.333,3),(722,7520444,7520440,'0c2',3.333,3),(722,7520445,7520440,'c29',3.333,3),(722,7520446,7520440,'29e',3.333,3),(722,7520447,7520440,'9ea',3.333,3),(722,7520448,7520440,'ea4',3.333,3),(722,7520449,7520440,'a41',3.333,3),(722,7520450,7520440,'41a',3.333,3),(722,7520451,7520440,'1a1',3.333,3),(722,7520452,7520440,'a1e',3.333,3),(722,7520453,7520440,'1e3',3.333,3),(722,7520454,7520440,'e31',3.333,3),(722,7520455,7520440,'311',3.333,3),(722,7520456,7520440,'112',3.333,3),(722,7520457,7520440,'12d',3.333,3),(722,7520458,7520440,'2d7',3.333,3),(722,7520459,7520440,'d78',3.333,3),(722,7520460,7520440,'78a',3.333,3),(722,7520461,7520440,'8af',3.333,3),(722,7520462,7520440,'af3',3.333,3),(722,7520463,7520440,'f33',3.333,3),(722,7520464,7520440,'33e',3.333,3),(722,7520465,7520440,'3e4',3.333,3),(722,7520466,7520440,'e44',3.333,3),(722,7520467,7520440,'447',3.333,3),(722,7520468,7520440,'47f',3.333,3),(722,7520469,7520440,'7f7',3.333,3),(722,7520470,7520440,'f71',3.333,3),(722,7520471,7520441,'mon',100,1),(722,7520472,7520471,'201',50,1),(722,7520473,7520471,'013',50,1),(722,7520474,7520472,'adm',33.333,3),(722,7520475,7520472,'dmi',33.333,3),(722,7520476,7520472,'min',33.333,3),(722,7520477,7520474,'cap',16.667,1),(722,7520478,7520474,'apa',16.667,1),(722,7520479,7520474,'pac',16.667,1),(722,7520480,7520474,'aci',16.667,1),(722,7520481,7520474,'cit',16.667,1),(722,7520482,7520474,'ity',16.667,1),(722,7520483,7520477,'pat',50,1),(722,7520484,7520477,'ath',50,1),(722,7520485,7520483,'fre',14.286,1),(722,7520486,7520483,'ree',14.286,1),(722,7520487,7520483,'ees',14.286,1),(722,7520488,7520483,'esp',14.286,1),(722,7520489,7520483,'spa',14.286,1),(722,7520490,7520483,'pac',14.286,1),(722,7520491,7520483,'ace',14.286,1),(722,7520492,7520485,'dis',50,1),(722,7520493,7520485,'isk',50,1),(722,7520494,7520492,'ind',33.333,1),(722,7520495,7520492,'nde',33.333,1),(722,7520496,7520492,'dex',33.333,1),(722,7520497,7520494,'adm',8.333,1),(722,7520498,7520494,'dmi',8.333,1),(722,7520499,7520494,'min',8.333,1),(722,7520500,7520494,'ini',8.333,1),(722,7520501,7520494,'nis',8.333,1),(722,7520502,7520494,'ist',8.333,1),(722,7520503,7520494,'str',8.333,1),(722,7520504,7520494,'tra',8.333,1),(722,7520505,7520494,'rat',8.333,1),(722,7520506,7520494,'ati',8.333,1),(722,7520507,7520494,'tio',8.333,1),(722,7520508,7520494,'ion',8.333,1),(722,7520509,7520497,'sta',33.333,3),(722,7520510,7520497,'tat',33.333,3),(722,7520511,7520497,'ate',33.333,3),(722,7520512,7520509,'ena',20,2),(722,7520513,7520509,'nab',20,2),(722,7520514,7520509,'abl',20,2),(722,7520515,7520509,'ble',20,2),(722,7520516,7520509,'led',20,2),(722,7520517,7520512,'cac',33.333,2),(722,7520518,7520512,'ach',33.333,2),(722,7520519,7520512,'che',33.333,2),(722,7520520,7520517,'mod',50,1),(722,7520521,7520517,'ode',50,1),(722,7520522,7520520,'wri',14.286,1),(722,7520523,7520520,'rit',14.286,1),(722,7520524,7520520,'ite',14.286,1),(722,7520525,7520520,'tet',14.286,1),(722,7520526,7520520,'eth',14.286,1),(722,7520527,7520520,'thr',14.286,1),(722,7520528,7520520,'hru',14.286,1),(722,7520529,7520522,'ope',11.111,2),(722,7520530,7520522,'per',11.111,2),(722,7520531,7520522,'era',11.111,2),(722,7520532,7520522,'rat',11.111,2),(722,7520533,7520522,'ati',11.111,2),(722,7520534,7520522,'tio',11.111,2),(722,7520535,7520522,'ion',11.111,2),(722,7520536,7520522,'ona',11.111,2),(722,7520537,7520522,'nal',11.111,2),(722,7520538,7520529,'pen',20,1),(722,7520539,7520529,'end',20,1),(722,7520540,7520529,'ndi',20,1),(722,7520541,7520529,'din',20,1),(722,7520542,7520529,'ing',20,1),(722,7520543,7520538,'mes',20,1),(722,7520544,7520538,'ess',20,1),(722,7520545,7520538,'ssa',20,1),(722,7520546,7520538,'sag',20,1),(722,7520547,7520538,'age',20,1),(722,7520548,7520543,'wai',20,1),(722,7520549,7520543,'ait',20,1),(722,7520550,7520543,'iti',20,1),(722,7520551,7520543,'tin',20,1),(722,7520552,7520543,'ing',20,1),(722,7520553,7520548,'for',100,1),(722,7520554,7520553,'per',11.111,1),(722,7520555,7520553,'erf',11.111,1),(722,7520556,7520553,'rfo',11.111,1),(722,7520557,7520553,'for',11.111,1),(722,7520558,7520553,'orm',11.111,1),(722,7520559,7520553,'rma',11.111,1),(722,7520560,7520553,'man',11.111,1),(722,7520561,7520553,'anc',11.111,1),(722,7520562,7520553,'nce',11.111,1),(722,7520563,7520554,'ide',12.5,1),(722,7520564,7520554,'den',12.5,1),(722,7520565,7520554,'ent',12.5,1),(722,7520566,7520554,'nti',12.5,1),(722,7520567,7520554,'tif',12.5,1),(722,7520568,7520554,'ifi',12.5,1),(722,7520569,7520554,'fie',12.5,1),(722,7520570,7520554,'ier',12.5,1),(722,7520571,7520563,'vdi',33.333,3),(722,7520572,7520563,'dis',33.333,3),(722,7520573,7520563,'isk',33.333,3),(722,7520574,7520571,'nam',50,1),(722,7520575,7520571,'ame',50,1),(722,7520576,7520574,'typ',50,1),(722,7520577,7520574,'ype',50,1),(722,7520578,7520576,'dir',25,1),(722,7520579,7520576,'ire',25,1),(722,7520580,7520576,'rec',25,1),(722,7520581,7520576,'ect',25,1),(723,7520583,7520582,'naa',100,2),(723,7520584,7520583,'600',3.333,3),(723,7520585,7520583,'000',3.333,3),(723,7520586,7520583,'00c',3.333,3),(723,7520587,7520583,'0c2',3.333,3),(723,7520588,7520583,'c29',3.333,3),(723,7520589,7520583,'292',3.333,3),(723,7520590,7520583,'926',3.333,3),(723,7520591,7520583,'269',3.333,3),(723,7520592,7520583,'69e',3.333,3),(723,7520593,7520583,'9ea',3.333,3),(723,7520594,7520583,'ea8',3.333,3),(723,7520595,7520583,'a82',3.333,3),(723,7520596,7520583,'82c',3.333,3),(723,7520597,7520583,'2ce',3.333,3),(723,7520598,7520583,'ce8',3.333,3),(723,7520599,7520583,'e84',3.333,3),(723,7520600,7520583,'84d',3.333,3),(723,7520601,7520583,'4df',3.333,3),(723,7520602,7520583,'df2',3.333,3),(723,7520603,7520583,'f2f',3.333,3),(723,7520604,7520583,'2f7',3.333,3),(723,7520605,7520583,'f7d',3.333,3),(723,7520606,7520583,'7de',3.333,3),(723,7520607,7520583,'dec',3.333,3),(723,7520608,7520583,'ec2',3.333,3),(723,7520609,7520583,'c29',3.333,3),(723,7520610,7520583,'293',3.333,3),(723,7520611,7520583,'939',3.333,3),(723,7520612,7520583,'398',3.333,3),(723,7520613,7520583,'987',3.333,3),(723,7520614,7520584,'mon',100,1),(723,7520615,7520614,'201',50,1),(723,7520616,7520614,'013',50,1),(723,7520617,7520615,'adm',33.333,3),(723,7520618,7520615,'dmi',33.333,3),(723,7520619,7520615,'min',33.333,3),(723,7520620,7520617,'cap',16.667,1),(723,7520621,7520617,'apa',16.667,1),(723,7520622,7520617,'pac',16.667,1),(723,7520623,7520617,'aci',16.667,1),(723,7520624,7520617,'cit',16.667,1),(723,7520625,7520617,'ity',16.667,1),(723,7520626,7520620,'pat',50,1),(723,7520627,7520620,'ath',50,1),(723,7520628,7520626,'fre',14.286,1),(723,7520629,7520626,'ree',14.286,1),(723,7520630,7520626,'ees',14.286,1),(723,7520631,7520626,'esp',14.286,1),(723,7520632,7520626,'spa',14.286,1),(723,7520633,7520626,'pac',14.286,1),(723,7520634,7520626,'ace',14.286,1),(723,7520635,7520628,'dis',50,1),(723,7520636,7520628,'isk',50,1),(723,7520637,7520635,'ind',33.333,1),(723,7520638,7520635,'nde',33.333,1),(723,7520639,7520635,'dex',33.333,1),(723,7520640,7520637,'adm',8.333,1),(723,7520641,7520637,'dmi',8.333,1),(723,7520642,7520637,'min',8.333,1),(723,7520643,7520637,'ini',8.333,1),(723,7520644,7520637,'nis',8.333,1),(723,7520645,7520637,'ist',8.333,1),(723,7520646,7520637,'str',8.333,1),(723,7520647,7520637,'tra',8.333,1),(723,7520648,7520637,'rat',8.333,1),(723,7520649,7520637,'ati',8.333,1),(723,7520650,7520637,'tio',8.333,1),(723,7520651,7520637,'ion',8.333,1),(723,7520652,7520640,'sta',33.333,3),(723,7520653,7520640,'tat',33.333,3),(723,7520654,7520640,'ate',33.333,3),(723,7520655,7520652,'ena',20,2),(723,7520656,7520652,'nab',20,2),(723,7520657,7520652,'abl',20,2),(723,7520658,7520652,'ble',20,2),(723,7520659,7520652,'led',20,2),(723,7520660,7520655,'cac',33.333,2),(723,7520661,7520655,'ach',33.333,2),(723,7520662,7520655,'che',33.333,2),(723,7520663,7520660,'mod',50,1),(723,7520664,7520660,'ode',50,1),(723,7520665,7520663,'wri',14.286,1),(723,7520666,7520663,'rit',14.286,1),(723,7520667,7520663,'ite',14.286,1),(723,7520668,7520663,'tet',14.286,1),(723,7520669,7520663,'eth',14.286,1),(723,7520670,7520663,'thr',14.286,1),(723,7520671,7520663,'hru',14.286,1),(723,7520672,7520665,'ope',11.111,2),(723,7520673,7520665,'per',11.111,2),(723,7520674,7520665,'era',11.111,2),(723,7520675,7520665,'rat',11.111,2),(723,7520676,7520665,'ati',11.111,2),(723,7520677,7520665,'tio',11.111,2),(723,7520678,7520665,'ion',11.111,2),(723,7520679,7520665,'ona',11.111,2),(723,7520680,7520665,'nal',11.111,2),(723,7520681,7520672,'pen',20,1),(723,7520682,7520672,'end',20,1),(723,7520683,7520672,'ndi',20,1),(723,7520684,7520672,'din',20,1),(723,7520685,7520672,'ing',20,1),(723,7520686,7520681,'mes',20,1),(723,7520687,7520681,'ess',20,1),(723,7520688,7520681,'ssa',20,1),(723,7520689,7520681,'sag',20,1),(723,7520690,7520681,'age',20,1),(723,7520691,7520686,'wai',20,1),(723,7520692,7520686,'ait',20,1),(723,7520693,7520686,'iti',20,1),(723,7520694,7520686,'tin',20,1),(723,7520695,7520686,'ing',20,1),(723,7520696,7520691,'for',100,1),(723,7520697,7520696,'per',11.111,1),(723,7520698,7520696,'erf',11.111,1),(723,7520699,7520696,'rfo',11.111,1),(723,7520700,7520696,'for',11.111,1),(723,7520701,7520696,'orm',11.111,1),(723,7520702,7520696,'rma',11.111,1),(723,7520703,7520696,'man',11.111,1),(723,7520704,7520696,'anc',11.111,1),(723,7520705,7520696,'nce',11.111,1),(723,7520706,7520697,'ide',12.5,1),(723,7520707,7520697,'den',12.5,1),(723,7520708,7520697,'ent',12.5,1),(723,7520709,7520697,'nti',12.5,1),(723,7520710,7520697,'tif',12.5,1),(723,7520711,7520697,'ifi',12.5,1),(723,7520712,7520697,'fie',12.5,1),(723,7520713,7520697,'ier',12.5,1),(723,7520714,7520706,'vdi',33.333,3),(723,7520715,7520706,'dis',33.333,3),(723,7520716,7520706,'isk',33.333,3),(723,7520717,7520714,'nam',50,1),(723,7520718,7520714,'ame',50,1),(723,7520719,7520717,'typ',50,1),(723,7520720,7520717,'ype',50,1),(723,7520721,7520719,'dir',25,1),(723,7520722,7520719,'ire',25,1),(723,7520723,7520719,'rec',25,1),(723,7520724,7520719,'ect',25,1),(724,7520726,7520725,'naa',100,2),(724,7520727,7520726,'600',3.333,3),(724,7520728,7520726,'000',3.333,3),(724,7520729,7520726,'00c',3.333,3),(724,7520730,7520726,'0c2',3.333,3),(724,7520731,7520726,'c29',3.333,3),(724,7520732,7520726,'29f',3.333,3),(724,7520733,7520726,'9fa',3.333,3),(724,7520734,7520726,'fa7',3.333,3),(724,7520735,7520726,'a71',3.333,3),(724,7520736,7520726,'718',3.333,3),(724,7520737,7520726,'18e',3.333,3),(724,7520738,7520726,'8ee',3.333,3),(724,7520739,7520726,'ee7',3.333,3),(724,7520740,7520726,'e7a',3.333,3),(724,7520741,7520726,'7a1',3.333,3),(724,7520742,7520726,'a1b',3.333,3),(724,7520743,7520726,'1b6',3.333,3),(724,7520744,7520726,'b61',3.333,3),(724,7520745,7520726,'618',3.333,3),(724,7520746,7520726,'182',3.333,3),(724,7520747,7520726,'82b',3.333,3),(724,7520748,7520726,'2b8',3.333,3),(724,7520749,7520726,'b8b',3.333,3),(724,7520750,7520726,'8b7',3.333,3),(724,7520751,7520726,'b73',3.333,3),(724,7520752,7520726,'732',3.333,3),(724,7520753,7520726,'32d',3.333,3),(724,7520754,7520726,'2dc',3.333,3),(724,7520755,7520726,'dca',3.333,3),(724,7520756,7520726,'ca1',3.333,3),(724,7520757,7520727,'mon',100,1),(724,7520758,7520757,'201',50,1),(724,7520759,7520757,'013',50,1),(724,7520760,7520758,'adm',33.333,3),(724,7520761,7520758,'dmi',33.333,3),(724,7520762,7520758,'min',33.333,3),(724,7520763,7520760,'cap',16.667,1),(724,7520764,7520760,'apa',16.667,1),(724,7520765,7520760,'pac',16.667,1),(724,7520766,7520760,'aci',16.667,1),(724,7520767,7520760,'cit',16.667,1),(724,7520768,7520760,'ity',16.667,1),(724,7520769,7520763,'pat',50,1),(724,7520770,7520763,'ath',50,1),(724,7520771,7520769,'fre',14.286,1),(724,7520772,7520769,'ree',14.286,1),(724,7520773,7520769,'ees',14.286,1),(724,7520774,7520769,'esp',14.286,1),(724,7520775,7520769,'spa',14.286,1),(724,7520776,7520769,'pac',14.286,1),(724,7520777,7520769,'ace',14.286,1),(724,7520778,7520771,'dis',50,1),(724,7520779,7520771,'isk',50,1),(724,7520780,7520778,'ind',33.333,1),(724,7520781,7520778,'nde',33.333,1),(724,7520782,7520778,'dex',33.333,1),(724,7520783,7520780,'adm',8.333,1),(724,7520784,7520780,'dmi',8.333,1),(724,7520785,7520780,'min',8.333,1),(724,7520786,7520780,'ini',8.333,1),(724,7520787,7520780,'nis',8.333,1),(724,7520788,7520780,'ist',8.333,1),(724,7520789,7520780,'str',8.333,1),(724,7520790,7520780,'tra',8.333,1),(724,7520791,7520780,'rat',8.333,1),(724,7520792,7520780,'ati',8.333,1),(724,7520793,7520780,'tio',8.333,1),(724,7520794,7520780,'ion',8.333,1),(724,7520795,7520783,'sta',33.333,3),(724,7520796,7520783,'tat',33.333,3),(724,7520797,7520783,'ate',33.333,3),(724,7520798,7520795,'ena',20,2),(724,7520799,7520795,'nab',20,2),(724,7520800,7520795,'abl',20,2),(724,7520801,7520795,'ble',20,2),(724,7520802,7520795,'led',20,2),(724,7520803,7520798,'cac',33.333,2),(724,7520804,7520798,'ach',33.333,2),(724,7520805,7520798,'che',33.333,2),(724,7520806,7520803,'mod',50,1),(724,7520807,7520803,'ode',50,1),(724,7520808,7520806,'wri',14.286,1),(724,7520809,7520806,'rit',14.286,1),(724,7520810,7520806,'ite',14.286,1),(724,7520811,7520806,'tet',14.286,1),(724,7520812,7520806,'eth',14.286,1),(724,7520813,7520806,'thr',14.286,1),(724,7520814,7520806,'hru',14.286,1),(724,7520815,7520808,'ope',11.111,2),(724,7520816,7520808,'per',11.111,2),(724,7520817,7520808,'era',11.111,2),(724,7520818,7520808,'rat',11.111,2),(724,7520819,7520808,'ati',11.111,2),(724,7520820,7520808,'tio',11.111,2),(724,7520821,7520808,'ion',11.111,2),(724,7520822,7520808,'ona',11.111,2),(724,7520823,7520808,'nal',11.111,2),(724,7520824,7520815,'pen',20,1),(724,7520825,7520815,'end',20,1),(724,7520826,7520815,'ndi',20,1),(724,7520827,7520815,'din',20,1),(724,7520828,7520815,'ing',20,1),(724,7520829,7520824,'mes',20,1),(724,7520830,7520824,'ess',20,1),(724,7520831,7520824,'ssa',20,1),(724,7520832,7520824,'sag',20,1),(724,7520833,7520824,'age',20,1),(724,7520834,7520829,'wai',20,1),(724,7520835,7520829,'ait',20,1),(724,7520836,7520829,'iti',20,1),(724,7520837,7520829,'tin',20,1),(724,7520838,7520829,'ing',20,1),(724,7520839,7520834,'for',100,1),(724,7520840,7520839,'per',11.111,1),(724,7520841,7520839,'erf',11.111,1),(724,7520842,7520839,'rfo',11.111,1),(724,7520843,7520839,'for',11.111,1),(724,7520844,7520839,'orm',11.111,1),(724,7520845,7520839,'rma',11.111,1),(724,7520846,7520839,'man',11.111,1),(724,7520847,7520839,'anc',11.111,1),(724,7520848,7520839,'nce',11.111,1),(724,7520849,7520840,'ide',12.5,1),(724,7520850,7520840,'den',12.5,1),(724,7520851,7520840,'ent',12.5,1),(724,7520852,7520840,'nti',12.5,1),(724,7520853,7520840,'tif',12.5,1),(724,7520854,7520840,'ifi',12.5,1),(724,7520855,7520840,'fie',12.5,1),(724,7520856,7520840,'ier',12.5,1),(724,7520857,7520849,'vdi',33.333,3),(724,7520858,7520849,'dis',33.333,3),(724,7520859,7520849,'isk',33.333,3),(724,7520860,7520857,'nam',50,1),(724,7520861,7520857,'ame',50,1),(724,7520862,7520860,'typ',50,1),(724,7520863,7520860,'ype',50,1),(724,7520864,7520862,'dir',25,1),(724,7520865,7520862,'ire',25,1),(724,7520866,7520862,'rec',25,1),(724,7520867,7520862,'ect',25,1),(725,7520869,7520868,'naa',100,2),(725,7520870,7520869,'600',3.333,3),(725,7520871,7520869,'000',3.333,3),(725,7520872,7520869,'00c',3.333,3),(725,7520873,7520869,'0c2',3.333,3),(725,7520874,7520869,'c29',3.333,3),(725,7520875,7520869,'297',3.333,3),(725,7520876,7520869,'978',3.333,3),(725,7520877,7520869,'78f',3.333,3),(725,7520878,7520869,'8f3',3.333,3),(725,7520879,7520869,'f3a',3.333,3),(725,7520880,7520869,'3a8',3.333,3),(725,7520881,7520869,'a8c',3.333,3),(725,7520882,7520869,'8cb',3.333,3),(725,7520883,7520869,'cb7',3.333,3),(725,7520884,7520869,'b75',3.333,3),(725,7520885,7520869,'758',3.333,3),(725,7520886,7520869,'587',3.333,3),(725,7520887,7520869,'874',3.333,3),(725,7520888,7520869,'742',3.333,3),(725,7520889,7520869,'429',3.333,3),(725,7520890,7520869,'299',3.333,3),(725,7520891,7520869,'990',3.333,3),(725,7520892,7520869,'907',3.333,3),(725,7520893,7520869,'072',3.333,3),(725,7520894,7520869,'723',3.333,3),(725,7520895,7520869,'235',3.333,3),(725,7520896,7520869,'354',3.333,3),(725,7520897,7520869,'54b',3.333,3),(725,7520898,7520869,'4b5',3.333,3),(725,7520899,7520869,'b5c',3.333,3),(725,7520900,7520870,'mon',100,1),(725,7520901,7520900,'201',50,1),(725,7520902,7520900,'013',50,1),(725,7520903,7520901,'adm',33.333,3),(725,7520904,7520901,'dmi',33.333,3),(725,7520905,7520901,'min',33.333,3),(725,7520906,7520903,'cap',16.667,1),(725,7520907,7520903,'apa',16.667,1),(725,7520908,7520903,'pac',16.667,1),(725,7520909,7520903,'aci',16.667,1),(725,7520910,7520903,'cit',16.667,1),(725,7520911,7520903,'ity',16.667,1),(725,7520912,7520906,'pat',50,1),(725,7520913,7520906,'ath',50,1),(725,7520914,7520912,'fre',14.286,1),(725,7520915,7520912,'ree',14.286,1),(725,7520916,7520912,'ees',14.286,1),(725,7520917,7520912,'esp',14.286,1),(725,7520918,7520912,'spa',14.286,1),(725,7520919,7520912,'pac',14.286,1),(725,7520920,7520912,'ace',14.286,1),(725,7520921,7520914,'dis',50,1),(725,7520922,7520914,'isk',50,1),(725,7520923,7520921,'ind',33.333,1),(725,7520924,7520921,'nde',33.333,1),(725,7520925,7520921,'dex',33.333,1),(725,7520926,7520923,'adm',8.333,1),(725,7520927,7520923,'dmi',8.333,1),(725,7520928,7520923,'min',8.333,1),(725,7520929,7520923,'ini',8.333,1),(725,7520930,7520923,'nis',8.333,1),(725,7520931,7520923,'ist',8.333,1),(725,7520932,7520923,'str',8.333,1),(725,7520933,7520923,'tra',8.333,1),(725,7520934,7520923,'rat',8.333,1),(725,7520935,7520923,'ati',8.333,1),(725,7520936,7520923,'tio',8.333,1),(725,7520937,7520923,'ion',8.333,1),(725,7520938,7520926,'sta',33.333,3),(725,7520939,7520926,'tat',33.333,3),(725,7520940,7520926,'ate',33.333,3),(725,7520941,7520938,'ena',20,2),(725,7520942,7520938,'nab',20,2),(725,7520943,7520938,'abl',20,2),(725,7520944,7520938,'ble',20,2),(725,7520945,7520938,'led',20,2),(725,7520946,7520941,'cac',33.333,2),(725,7520947,7520941,'ach',33.333,2),(725,7520948,7520941,'che',33.333,2),(725,7520949,7520946,'mod',50,1),(725,7520950,7520946,'ode',50,1),(725,7520951,7520949,'wri',14.286,1),(725,7520952,7520949,'rit',14.286,1),(725,7520953,7520949,'ite',14.286,1),(725,7520954,7520949,'tet',14.286,1),(725,7520955,7520949,'eth',14.286,1),(725,7520956,7520949,'thr',14.286,1),(725,7520957,7520949,'hru',14.286,1),(725,7520958,7520951,'ope',11.111,2),(725,7520959,7520951,'per',11.111,2),(725,7520960,7520951,'era',11.111,2),(725,7520961,7520951,'rat',11.111,2),(725,7520962,7520951,'ati',11.111,2),(725,7520963,7520951,'tio',11.111,2),(725,7520964,7520951,'ion',11.111,2),(725,7520965,7520951,'ona',11.111,2),(725,7520966,7520951,'nal',11.111,2),(725,7520967,7520958,'pen',20,1),(725,7520968,7520958,'end',20,1),(725,7520969,7520958,'ndi',20,1),(725,7520970,7520958,'din',20,1),(725,7520971,7520958,'ing',20,1),(725,7520972,7520967,'mes',20,1),(725,7520973,7520967,'ess',20,1),(725,7520974,7520967,'ssa',20,1),(725,7520975,7520967,'sag',20,1),(725,7520976,7520967,'age',20,1),(725,7520977,7520972,'wai',20,1),(725,7520978,7520972,'ait',20,1),(725,7520979,7520972,'iti',20,1),(725,7520980,7520972,'tin',20,1),(725,7520981,7520972,'ing',20,1),(725,7520982,7520977,'for',100,1),(725,7520983,7520982,'per',11.111,1),(725,7520984,7520982,'erf',11.111,1),(725,7520985,7520982,'rfo',11.111,1),(725,7520986,7520982,'for',11.111,1),(725,7520987,7520982,'orm',11.111,1),(725,7520988,7520982,'rma',11.111,1),(725,7520989,7520982,'man',11.111,1),(725,7520990,7520982,'anc',11.111,1),(725,7520991,7520982,'nce',11.111,1),(725,7520992,7520983,'ide',12.5,1),(725,7520993,7520983,'den',12.5,1),(725,7520994,7520983,'ent',12.5,1),(725,7520995,7520983,'nti',12.5,1),(725,7520996,7520983,'tif',12.5,1),(725,7520997,7520983,'ifi',12.5,1),(725,7520998,7520983,'fie',12.5,1),(725,7520999,7520983,'ier',12.5,1),(725,7521000,7520992,'vdi',33.333,3),(725,7521001,7520992,'dis',33.333,3),(725,7521002,7520992,'isk',33.333,3),(725,7521003,7521000,'nam',50,1),(725,7521004,7521000,'ame',50,1),(725,7521005,7521003,'typ',50,1),(725,7521006,7521003,'ype',50,1),(725,7521007,7521005,'dir',25,1),(725,7521008,7521005,'ire',25,1),(725,7521009,7521005,'rec',25,1),(725,7521010,7521005,'ect',25,1),(726,7521012,7521011,'naa',100,2),(726,7521013,7521012,'600',3.333,3),(726,7521014,7521012,'000',3.333,3),(726,7521015,7521012,'00c',3.333,3),(726,7521016,7521012,'0c2',3.333,3),(726,7521017,7521012,'c29',3.333,3),(726,7521018,7521012,'29e',3.333,3),(726,7521019,7521012,'9e3',3.333,3),(726,7521020,7521012,'e37',3.333,3),(726,7521021,7521012,'376',3.333,3),(726,7521022,7521012,'768',3.333,3),(726,7521023,7521012,'680',3.333,3),(726,7521024,7521012,'80f',3.333,3),(726,7521025,7521012,'0f4',3.333,3),(726,7521026,7521012,'f4a',3.333,3),(726,7521027,7521012,'4ab',3.333,3),(726,7521028,7521012,'ab9',3.333,3),(726,7521029,7521012,'b96',3.333,3),(726,7521030,7521012,'96d',3.333,3),(726,7521031,7521012,'6d3',3.333,3),(726,7521032,7521012,'d31',3.333,3),(726,7521033,7521012,'31b',3.333,3),(726,7521034,7521012,'1b0',3.333,3),(726,7521035,7521012,'b09',3.333,3),(726,7521036,7521012,'09a',3.333,3),(726,7521037,7521012,'9ae',3.333,3),(726,7521038,7521012,'ae7',3.333,3),(726,7521039,7521012,'e74',3.333,3),(726,7521040,7521012,'749',3.333,3),(726,7521041,7521012,'494',3.333,3),(726,7521042,7521012,'943',3.333,3),(726,7521043,7521013,'mon',100,1),(726,7521044,7521043,'201',50,1),(726,7521045,7521043,'013',50,1),(726,7521046,7521044,'adm',33.333,3),(726,7521047,7521044,'dmi',33.333,3),(726,7521048,7521044,'min',33.333,3),(726,7521049,7521046,'cap',16.667,1),(726,7521050,7521046,'apa',16.667,1),(726,7521051,7521046,'pac',16.667,1),(726,7521052,7521046,'aci',16.667,1),(726,7521053,7521046,'cit',16.667,1),(726,7521054,7521046,'ity',16.667,1),(726,7521055,7521049,'pat',50,1),(726,7521056,7521049,'ath',50,1),(726,7521057,7521055,'fre',14.286,1),(726,7521058,7521055,'ree',14.286,1),(726,7521059,7521055,'ees',14.286,1),(726,7521060,7521055,'esp',14.286,1),(726,7521061,7521055,'spa',14.286,1),(726,7521062,7521055,'pac',14.286,1),(726,7521063,7521055,'ace',14.286,1),(726,7521064,7521057,'dis',50,1),(726,7521065,7521057,'isk',50,1),(726,7521066,7521064,'ind',33.333,1),(726,7521067,7521064,'nde',33.333,1),(726,7521068,7521064,'dex',33.333,1),(726,7521069,7521066,'adm',8.333,1),(726,7521070,7521066,'dmi',8.333,1),(726,7521071,7521066,'min',8.333,1),(726,7521072,7521066,'ini',8.333,1),(726,7521073,7521066,'nis',8.333,1),(726,7521074,7521066,'ist',8.333,1),(726,7521075,7521066,'str',8.333,1),(726,7521076,7521066,'tra',8.333,1),(726,7521077,7521066,'rat',8.333,1),(726,7521078,7521066,'ati',8.333,1),(726,7521079,7521066,'tio',8.333,1),(726,7521080,7521066,'ion',8.333,1),(726,7521081,7521069,'sta',33.333,3),(726,7521082,7521069,'tat',33.333,3),(726,7521083,7521069,'ate',33.333,3),(726,7521084,7521081,'ena',20,2),(726,7521085,7521081,'nab',20,2),(726,7521086,7521081,'abl',20,2),(726,7521087,7521081,'ble',20,2),(726,7521088,7521081,'led',20,2),(726,7521089,7521084,'cac',33.333,2),(726,7521090,7521084,'ach',33.333,2),(726,7521091,7521084,'che',33.333,2),(726,7521092,7521089,'mod',50,1),(726,7521093,7521089,'ode',50,1),(726,7521094,7521092,'wri',14.286,1),(726,7521095,7521092,'rit',14.286,1),(726,7521096,7521092,'ite',14.286,1),(726,7521097,7521092,'tet',14.286,1),(726,7521098,7521092,'eth',14.286,1),(726,7521099,7521092,'thr',14.286,1),(726,7521100,7521092,'hru',14.286,1),(726,7521101,7521094,'ope',11.111,2),(726,7521102,7521094,'per',11.111,2),(726,7521103,7521094,'era',11.111,2),(726,7521104,7521094,'rat',11.111,2),(726,7521105,7521094,'ati',11.111,2),(726,7521106,7521094,'tio',11.111,2),(726,7521107,7521094,'ion',11.111,2),(726,7521108,7521094,'ona',11.111,2),(726,7521109,7521094,'nal',11.111,2),(726,7521110,7521101,'pen',20,1),(726,7521111,7521101,'end',20,1),(726,7521112,7521101,'ndi',20,1),(726,7521113,7521101,'din',20,1),(726,7521114,7521101,'ing',20,1),(726,7521115,7521110,'mes',20,1),(726,7521116,7521110,'ess',20,1),(726,7521117,7521110,'ssa',20,1),(726,7521118,7521110,'sag',20,1),(726,7521119,7521110,'age',20,1),(726,7521120,7521115,'wai',20,1),(726,7521121,7521115,'ait',20,1),(726,7521122,7521115,'iti',20,1),(726,7521123,7521115,'tin',20,1),(726,7521124,7521115,'ing',20,1),(726,7521125,7521120,'for',100,1),(726,7521126,7521125,'per',11.111,1),(726,7521127,7521125,'erf',11.111,1),(726,7521128,7521125,'rfo',11.111,1),(726,7521129,7521125,'for',11.111,1),(726,7521130,7521125,'orm',11.111,1),(726,7521131,7521125,'rma',11.111,1),(726,7521132,7521125,'man',11.111,1),(726,7521133,7521125,'anc',11.111,1),(726,7521134,7521125,'nce',11.111,1),(726,7521135,7521126,'ide',12.5,1),(726,7521136,7521126,'den',12.5,1),(726,7521137,7521126,'ent',12.5,1),(726,7521138,7521126,'nti',12.5,1),(726,7521139,7521126,'tif',12.5,1),(726,7521140,7521126,'ifi',12.5,1),(726,7521141,7521126,'fie',12.5,1),(726,7521142,7521126,'ier',12.5,1),(726,7521143,7521135,'vdi',33.333,3),(726,7521144,7521135,'dis',33.333,3),(726,7521145,7521135,'isk',33.333,3),(726,7521146,7521143,'nam',50,1),(726,7521147,7521143,'ame',50,1),(726,7521148,7521146,'typ',50,1),(726,7521149,7521146,'ype',50,1),(726,7521150,7521148,'dir',25,1),(726,7521151,7521148,'ire',25,1),(726,7521152,7521148,'rec',25,1),(726,7521153,7521148,'ect',25,1),(727,7521155,7521154,'naa',100,2),(727,7521156,7521155,'600',3.333,3),(727,7521157,7521155,'000',3.333,3),(727,7521158,7521155,'00c',3.333,3),(727,7521159,7521155,'0c2',3.333,3),(727,7521160,7521155,'c29',3.333,3),(727,7521161,7521155,'298',3.333,3),(727,7521162,7521155,'98e',3.333,3),(727,7521163,7521155,'8ed',3.333,3),(727,7521164,7521155,'edc',3.333,3),(727,7521165,7521155,'dcf',3.333,3),(727,7521166,7521155,'cff',3.333,3),(727,7521167,7521155,'ffb',3.333,3),(727,7521168,7521155,'fb0',3.333,3),(727,7521169,7521155,'b01',3.333,3),(727,7521170,7521155,'01c',3.333,3),(727,7521171,7521155,'1c9',3.333,3),(727,7521172,7521155,'c9d',3.333,3),(727,7521173,7521155,'9dd',3.333,3),(727,7521174,7521155,'dda',3.333,3),(727,7521175,7521155,'da0',3.333,3),(727,7521176,7521155,'a05',3.333,3),(727,7521177,7521155,'058',3.333,3),(727,7521178,7521155,'581',3.333,3),(727,7521179,7521155,'818',3.333,3),(727,7521180,7521155,'18c',3.333,3),(727,7521181,7521155,'8cc',3.333,3),(727,7521182,7521155,'cc7',3.333,3),(727,7521183,7521155,'c73',3.333,3),(727,7521184,7521155,'73b',3.333,3),(727,7521185,7521155,'3b2',3.333,3),(727,7521186,7521156,'mon',100,1),(727,7521187,7521186,'201',50,1),(727,7521188,7521186,'013',50,1),(727,7521189,7521187,'adm',33.333,3),(727,7521190,7521187,'dmi',33.333,3),(727,7521191,7521187,'min',33.333,3),(727,7521192,7521189,'cap',16.667,1),(727,7521193,7521189,'apa',16.667,1),(727,7521194,7521189,'pac',16.667,1),(727,7521195,7521189,'aci',16.667,1),(727,7521196,7521189,'cit',16.667,1),(727,7521197,7521189,'ity',16.667,1),(727,7521198,7521192,'pat',50,1),(727,7521199,7521192,'ath',50,1),(727,7521200,7521198,'fre',14.286,1),(727,7521201,7521198,'ree',14.286,1),(727,7521202,7521198,'ees',14.286,1),(727,7521203,7521198,'esp',14.286,1),(727,7521204,7521198,'spa',14.286,1),(727,7521205,7521198,'pac',14.286,1),(727,7521206,7521198,'ace',14.286,1),(727,7521207,7521200,'dis',50,1),(727,7521208,7521200,'isk',50,1),(727,7521209,7521207,'ind',33.333,1),(727,7521210,7521207,'nde',33.333,1),(727,7521211,7521207,'dex',33.333,1),(727,7521212,7521209,'adm',8.333,1),(727,7521213,7521209,'dmi',8.333,1),(727,7521214,7521209,'min',8.333,1),(727,7521215,7521209,'ini',8.333,1),(727,7521216,7521209,'nis',8.333,1),(727,7521217,7521209,'ist',8.333,1),(727,7521218,7521209,'str',8.333,1),(727,7521219,7521209,'tra',8.333,1),(727,7521220,7521209,'rat',8.333,1),(727,7521221,7521209,'ati',8.333,1),(727,7521222,7521209,'tio',8.333,1),(727,7521223,7521209,'ion',8.333,1),(727,7521224,7521212,'sta',33.333,3),(727,7521225,7521212,'tat',33.333,3),(727,7521226,7521212,'ate',33.333,3),(727,7521227,7521224,'ena',20,2),(727,7521228,7521224,'nab',20,2),(727,7521229,7521224,'abl',20,2),(727,7521230,7521224,'ble',20,2),(727,7521231,7521224,'led',20,2),(727,7521232,7521227,'cac',33.333,2),(727,7521233,7521227,'ach',33.333,2),(727,7521234,7521227,'che',33.333,2),(727,7521235,7521232,'mod',50,1),(727,7521236,7521232,'ode',50,1),(727,7521237,7521235,'wri',14.286,1),(727,7521238,7521235,'rit',14.286,1),(727,7521239,7521235,'ite',14.286,1),(727,7521240,7521235,'tet',14.286,1),(727,7521241,7521235,'eth',14.286,1),(727,7521242,7521235,'thr',14.286,1),(727,7521243,7521235,'hru',14.286,1),(727,7521244,7521237,'ope',11.111,2),(727,7521245,7521237,'per',11.111,2),(727,7521246,7521237,'era',11.111,2),(727,7521247,7521237,'rat',11.111,2),(727,7521248,7521237,'ati',11.111,2),(727,7521249,7521237,'tio',11.111,2),(727,7521250,7521237,'ion',11.111,2),(727,7521251,7521237,'ona',11.111,2),(727,7521252,7521237,'nal',11.111,2),(727,7521253,7521244,'pen',20,1),(727,7521254,7521244,'end',20,1),(727,7521255,7521244,'ndi',20,1),(727,7521256,7521244,'din',20,1),(727,7521257,7521244,'ing',20,1),(727,7521258,7521253,'mes',20,1),(727,7521259,7521253,'ess',20,1),(727,7521260,7521253,'ssa',20,1),(727,7521261,7521253,'sag',20,1),(727,7521262,7521253,'age',20,1),(727,7521263,7521258,'wai',20,1),(727,7521264,7521258,'ait',20,1),(727,7521265,7521258,'iti',20,1),(727,7521266,7521258,'tin',20,1),(727,7521267,7521258,'ing',20,1),(727,7521268,7521263,'for',100,1),(727,7521269,7521268,'per',11.111,1),(727,7521270,7521268,'erf',11.111,1),(727,7521271,7521268,'rfo',11.111,1),(727,7521272,7521268,'for',11.111,1),(727,7521273,7521268,'orm',11.111,1),(727,7521274,7521268,'rma',11.111,1),(727,7521275,7521268,'man',11.111,1),(727,7521276,7521268,'anc',11.111,1),(727,7521277,7521268,'nce',11.111,1),(727,7521278,7521269,'ide',12.5,1),(727,7521279,7521269,'den',12.5,1),(727,7521280,7521269,'ent',12.5,1),(727,7521281,7521269,'nti',12.5,1),(727,7521282,7521269,'tif',12.5,1),(727,7521283,7521269,'ifi',12.5,1),(727,7521284,7521269,'fie',12.5,1),(727,7521285,7521269,'ier',12.5,1),(727,7521286,7521278,'vdi',33.333,3),(727,7521287,7521278,'dis',33.333,3),(727,7521288,7521278,'isk',33.333,3),(727,7521289,7521286,'nam',50,1),(727,7521290,7521286,'ame',50,1),(727,7521291,7521289,'typ',50,1),(727,7521292,7521289,'ype',50,1),(727,7521293,7521291,'dir',25,1),(727,7521294,7521291,'ire',25,1),(727,7521295,7521291,'rec',25,1),(727,7521296,7521291,'ect',25,1),(728,7521298,7521297,'naa',100,2),(728,7521299,7521298,'600',3.333,3),(728,7521300,7521298,'000',3.333,3),(728,7521301,7521298,'00c',3.333,3),(728,7521302,7521298,'0c2',3.333,3),(728,7521303,7521298,'c29',3.333,3),(728,7521304,7521298,'29f',3.333,3),(728,7521305,7521298,'9f5',3.333,3),(728,7521306,7521298,'f5f',3.333,3),(728,7521307,7521298,'5f2',3.333,3),(728,7521308,7521298,'f27',3.333,3),(728,7521309,7521298,'27e',3.333,3),(728,7521310,7521298,'7ed',3.333,3),(728,7521311,7521298,'ed5',3.333,3),(728,7521312,7521298,'d5e',3.333,3),(728,7521313,7521298,'5e3',3.333,3),(728,7521314,7521298,'e31',3.333,3),(728,7521315,7521298,'316',3.333,3),(728,7521316,7521298,'164',3.333,3),(728,7521317,7521298,'645',3.333,3),(728,7521318,7521298,'45e',3.333,3),(728,7521319,7521298,'5e4',3.333,3),(728,7521320,7521298,'e45',3.333,3),(728,7521321,7521298,'458',3.333,3),(728,7521322,7521298,'58e',3.333,3),(728,7521323,7521298,'8e6',3.333,3),(728,7521324,7521298,'e61',3.333,3),(728,7521325,7521298,'610',3.333,3),(728,7521326,7521298,'102',3.333,3),(728,7521327,7521298,'027',3.333,3),(728,7521328,7521298,'275',3.333,3),(728,7521329,7521299,'mon',100,1),(728,7521330,7521329,'201',50,1),(728,7521331,7521329,'013',50,1),(728,7521332,7521330,'adm',33.333,3),(728,7521333,7521330,'dmi',33.333,3),(728,7521334,7521330,'min',33.333,3),(728,7521335,7521332,'cap',16.667,1),(728,7521336,7521332,'apa',16.667,1),(728,7521337,7521332,'pac',16.667,1),(728,7521338,7521332,'aci',16.667,1),(728,7521339,7521332,'cit',16.667,1),(728,7521340,7521332,'ity',16.667,1),(728,7521341,7521335,'pat',50,1),(728,7521342,7521335,'ath',50,1),(728,7521343,7521341,'fre',14.286,1),(728,7521344,7521341,'ree',14.286,1),(728,7521345,7521341,'ees',14.286,1),(728,7521346,7521341,'esp',14.286,1),(728,7521347,7521341,'spa',14.286,1),(728,7521348,7521341,'pac',14.286,1),(728,7521349,7521341,'ace',14.286,1),(728,7521350,7521343,'dis',50,1),(728,7521351,7521343,'isk',50,1),(728,7521352,7521350,'ind',33.333,1),(728,7521353,7521350,'nde',33.333,1),(728,7521354,7521350,'dex',33.333,1),(728,7521355,7521352,'adm',8.333,1),(728,7521356,7521352,'dmi',8.333,1),(728,7521357,7521352,'min',8.333,1),(728,7521358,7521352,'ini',8.333,1),(728,7521359,7521352,'nis',8.333,1),(728,7521360,7521352,'ist',8.333,1),(728,7521361,7521352,'str',8.333,1),(728,7521362,7521352,'tra',8.333,1),(728,7521363,7521352,'rat',8.333,1),(728,7521364,7521352,'ati',8.333,1),(728,7521365,7521352,'tio',8.333,1),(728,7521366,7521352,'ion',8.333,1),(728,7521367,7521355,'sta',33.333,3),(728,7521368,7521355,'tat',33.333,3),(728,7521369,7521355,'ate',33.333,3),(728,7521370,7521367,'ena',20,2),(728,7521371,7521367,'nab',20,2),(728,7521372,7521367,'abl',20,2),(728,7521373,7521367,'ble',20,2),(728,7521374,7521367,'led',20,2),(728,7521375,7521370,'cac',33.333,2),(728,7521376,7521370,'ach',33.333,2),(728,7521377,7521370,'che',33.333,2),(728,7521378,7521375,'mod',50,1),(728,7521379,7521375,'ode',50,1),(728,7521380,7521378,'wri',14.286,1),(728,7521381,7521378,'rit',14.286,1),(728,7521382,7521378,'ite',14.286,1),(728,7521383,7521378,'tet',14.286,1),(728,7521384,7521378,'eth',14.286,1),(728,7521385,7521378,'thr',14.286,1),(728,7521386,7521378,'hru',14.286,1),(728,7521387,7521380,'ope',11.111,2),(728,7521388,7521380,'per',11.111,2),(728,7521389,7521380,'era',11.111,2),(728,7521390,7521380,'rat',11.111,2),(728,7521391,7521380,'ati',11.111,2),(728,7521392,7521380,'tio',11.111,2),(728,7521393,7521380,'ion',11.111,2),(728,7521394,7521380,'ona',11.111,2),(728,7521395,7521380,'nal',11.111,2),(728,7521396,7521387,'pen',20,1),(728,7521397,7521387,'end',20,1),(728,7521398,7521387,'ndi',20,1),(728,7521399,7521387,'din',20,1),(728,7521400,7521387,'ing',20,1),(728,7521401,7521396,'mes',20,1),(728,7521402,7521396,'ess',20,1),(728,7521403,7521396,'ssa',20,1),(728,7521404,7521396,'sag',20,1),(728,7521405,7521396,'age',20,1),(728,7521406,7521401,'wai',20,1),(728,7521407,7521401,'ait',20,1),(728,7521408,7521401,'iti',20,1),(728,7521409,7521401,'tin',20,1),(728,7521410,7521401,'ing',20,1),(728,7521411,7521406,'for',100,1),(728,7521412,7521411,'per',11.111,1),(728,7521413,7521411,'erf',11.111,1),(728,7521414,7521411,'rfo',11.111,1),(728,7521415,7521411,'for',11.111,1),(728,7521416,7521411,'orm',11.111,1),(728,7521417,7521411,'rma',11.111,1),(728,7521418,7521411,'man',11.111,1),(728,7521419,7521411,'anc',11.111,1),(728,7521420,7521411,'nce',11.111,1),(728,7521421,7521412,'ide',12.5,1),(728,7521422,7521412,'den',12.5,1),(728,7521423,7521412,'ent',12.5,1),(728,7521424,7521412,'nti',12.5,1),(728,7521425,7521412,'tif',12.5,1),(728,7521426,7521412,'ifi',12.5,1),(728,7521427,7521412,'fie',12.5,1),(728,7521428,7521412,'ier',12.5,1),(728,7521429,7521421,'vdi',33.333,3),(728,7521430,7521421,'dis',33.333,3),(728,7521431,7521421,'isk',33.333,3),(728,7521432,7521429,'nam',50,1),(728,7521433,7521429,'ame',50,1),(728,7521434,7521432,'typ',50,1),(728,7521435,7521432,'ype',50,1),(728,7521436,7521434,'dir',25,1),(728,7521437,7521434,'ire',25,1),(728,7521438,7521434,'rec',25,1),(728,7521439,7521434,'ect',25,1),(729,7521441,7521440,'naa',100,2),(729,7521442,7521441,'600',3.333,3),(729,7521443,7521441,'000',3.333,3),(729,7521444,7521441,'00c',3.333,3),(729,7521445,7521441,'0c2',3.333,3),(729,7521446,7521441,'c29',3.333,3),(729,7521447,7521441,'294',3.333,3),(729,7521448,7521441,'948',3.333,3),(729,7521449,7521441,'482',3.333,3),(729,7521450,7521441,'82b',3.333,3),(729,7521451,7521441,'2bd',3.333,3),(729,7521452,7521441,'bde',3.333,3),(729,7521453,7521441,'ded',3.333,3),(729,7521454,7521441,'edd',3.333,3),(729,7521455,7521441,'ddf',3.333,3),(729,7521456,7521441,'dfc',3.333,3),(729,7521457,7521441,'fc5',3.333,3),(729,7521458,7521441,'c52',3.333,3),(729,7521459,7521441,'521',3.333,3),(729,7521460,7521441,'216',3.333,3),(729,7521461,7521441,'16c',3.333,3),(729,7521462,7521441,'6c1',3.333,3),(729,7521463,7521441,'c1b',3.333,3),(729,7521464,7521441,'1b5',3.333,3),(729,7521465,7521441,'b55',3.333,3),(729,7521466,7521441,'554',3.333,3),(729,7521467,7521441,'54d',3.333,3),(729,7521468,7521441,'4db',3.333,3),(729,7521469,7521441,'db3',3.333,3),(729,7521470,7521441,'b37',3.333,3),(729,7521471,7521441,'37a',3.333,3),(729,7521472,7521442,'mon',100,1),(729,7521473,7521472,'201',50,1),(729,7521474,7521472,'013',50,1),(729,7521475,7521473,'adm',33.333,3),(729,7521476,7521473,'dmi',33.333,3),(729,7521477,7521473,'min',33.333,3),(729,7521478,7521475,'cap',16.667,1),(729,7521479,7521475,'apa',16.667,1),(729,7521480,7521475,'pac',16.667,1),(729,7521481,7521475,'aci',16.667,1),(729,7521482,7521475,'cit',16.667,1),(729,7521483,7521475,'ity',16.667,1),(729,7521484,7521478,'pat',50,1),(729,7521485,7521478,'ath',50,1),(729,7521486,7521484,'fre',14.286,1),(729,7521487,7521484,'ree',14.286,1),(729,7521488,7521484,'ees',14.286,1),(729,7521489,7521484,'esp',14.286,1),(729,7521490,7521484,'spa',14.286,1),(729,7521491,7521484,'pac',14.286,1),(729,7521492,7521484,'ace',14.286,1),(729,7521493,7521486,'dis',50,1),(729,7521494,7521486,'isk',50,1),(729,7521495,7521493,'ind',33.333,1),(729,7521496,7521493,'nde',33.333,1),(729,7521497,7521493,'dex',33.333,1),(729,7521498,7521495,'adm',8.333,1),(729,7521499,7521495,'dmi',8.333,1),(729,7521500,7521495,'min',8.333,1),(729,7521501,7521495,'ini',8.333,1),(729,7521502,7521495,'nis',8.333,1),(729,7521503,7521495,'ist',8.333,1),(729,7521504,7521495,'str',8.333,1),(729,7521505,7521495,'tra',8.333,1),(729,7521506,7521495,'rat',8.333,1),(729,7521507,7521495,'ati',8.333,1),(729,7521508,7521495,'tio',8.333,1),(729,7521509,7521495,'ion',8.333,1),(729,7521510,7521498,'sta',33.333,3),(729,7521511,7521498,'tat',33.333,3),(729,7521512,7521498,'ate',33.333,3),(729,7521513,7521510,'ena',20,2),(729,7521514,7521510,'nab',20,2),(729,7521515,7521510,'abl',20,2),(729,7521516,7521510,'ble',20,2),(729,7521517,7521510,'led',20,2),(729,7521518,7521513,'cac',33.333,2),(729,7521519,7521513,'ach',33.333,2),(729,7521520,7521513,'che',33.333,2),(729,7521521,7521518,'mod',50,1),(729,7521522,7521518,'ode',50,1),(729,7521523,7521521,'wri',14.286,1),(729,7521524,7521521,'rit',14.286,1),(729,7521525,7521521,'ite',14.286,1),(729,7521526,7521521,'tet',14.286,1),(729,7521527,7521521,'eth',14.286,1),(729,7521528,7521521,'thr',14.286,1),(729,7521529,7521521,'hru',14.286,1),(729,7521530,7521523,'ope',11.111,2),(729,7521531,7521523,'per',11.111,2),(729,7521532,7521523,'era',11.111,2),(729,7521533,7521523,'rat',11.111,2),(729,7521534,7521523,'ati',11.111,2),(729,7521535,7521523,'tio',11.111,2),(729,7521536,7521523,'ion',11.111,2),(729,7521537,7521523,'ona',11.111,2),(729,7521538,7521523,'nal',11.111,2),(729,7521539,7521530,'pen',20,1),(729,7521540,7521530,'end',20,1),(729,7521541,7521530,'ndi',20,1),(729,7521542,7521530,'din',20,1),(729,7521543,7521530,'ing',20,1),(729,7521544,7521539,'mes',20,1),(729,7521545,7521539,'ess',20,1),(729,7521546,7521539,'ssa',20,1),(729,7521547,7521539,'sag',20,1),(729,7521548,7521539,'age',20,1),(729,7521549,7521544,'wai',20,1),(729,7521550,7521544,'ait',20,1),(729,7521551,7521544,'iti',20,1),(729,7521552,7521544,'tin',20,1),(729,7521553,7521544,'ing',20,1),(729,7521554,7521549,'for',100,1),(729,7521555,7521554,'per',11.111,1),(729,7521556,7521554,'erf',11.111,1),(729,7521557,7521554,'rfo',11.111,1),(729,7521558,7521554,'for',11.111,1),(729,7521559,7521554,'orm',11.111,1),(729,7521560,7521554,'rma',11.111,1),(729,7521561,7521554,'man',11.111,1),(729,7521562,7521554,'anc',11.111,1),(729,7521563,7521554,'nce',11.111,1),(729,7521564,7521555,'ide',12.5,1),(729,7521565,7521555,'den',12.5,1),(729,7521566,7521555,'ent',12.5,1),(729,7521567,7521555,'nti',12.5,1),(729,7521568,7521555,'tif',12.5,1),(729,7521569,7521555,'ifi',12.5,1),(729,7521570,7521555,'fie',12.5,1),(729,7521571,7521555,'ier',12.5,1),(729,7521572,7521564,'vdi',33.333,3),(729,7521573,7521564,'dis',33.333,3),(729,7521574,7521564,'isk',33.333,3),(729,7521575,7521572,'nam',50,1),(729,7521576,7521572,'ame',50,1),(729,7521577,7521575,'typ',50,1),(729,7521578,7521575,'ype',50,1),(729,7521579,7521577,'dir',25,1),(729,7521580,7521577,'ire',25,1),(729,7521581,7521577,'rec',25,1),(729,7521582,7521577,'ect',25,1),(730,7521584,7521583,'naa',100,2),(730,7521585,7521584,'600',3.333,3),(730,7521586,7521584,'000',3.333,3),(730,7521587,7521584,'00c',3.333,3),(730,7521588,7521584,'0c2',3.333,3),(730,7521589,7521584,'c29',3.333,3),(730,7521590,7521584,'295',3.333,3),(730,7521591,7521584,'951',3.333,3),(730,7521592,7521584,'515',3.333,3),(730,7521593,7521584,'153',3.333,3),(730,7521594,7521584,'53f',3.333,3),(730,7521595,7521584,'3f5',3.333,3),(730,7521596,7521584,'f52',3.333,3),(730,7521597,7521584,'529',3.333,3),(730,7521598,7521584,'29a',3.333,3),(730,7521599,7521584,'9a6',3.333,3),(730,7521600,7521584,'a61',3.333,3),(730,7521601,7521584,'613',3.333,3),(730,7521602,7521584,'135',3.333,3),(730,7521603,7521584,'35f',3.333,3),(730,7521604,7521584,'5fc',3.333,3),(730,7521605,7521584,'fc6',3.333,3),(730,7521606,7521584,'c6d',3.333,3),(730,7521607,7521584,'6de',3.333,3),(730,7521608,7521584,'de0',3.333,3),(730,7521609,7521584,'e04',3.333,3),(730,7521610,7521584,'044',3.333,3),(730,7521611,7521584,'446',3.333,3),(730,7521612,7521584,'46b',3.333,3),(730,7521613,7521584,'6ba',3.333,3),(730,7521614,7521584,'bae',3.333,3),(730,7521615,7521585,'mon',100,1),(730,7521616,7521615,'201',50,1),(730,7521617,7521615,'013',50,1),(730,7521618,7521616,'adm',33.333,3),(730,7521619,7521616,'dmi',33.333,3),(730,7521620,7521616,'min',33.333,3),(730,7521621,7521618,'cap',16.667,1),(730,7521622,7521618,'apa',16.667,1),(730,7521623,7521618,'pac',16.667,1),(730,7521624,7521618,'aci',16.667,1),(730,7521625,7521618,'cit',16.667,1),(730,7521626,7521618,'ity',16.667,1),(730,7521627,7521621,'pat',50,1),(730,7521628,7521621,'ath',50,1),(730,7521629,7521627,'fre',14.286,1),(730,7521630,7521627,'ree',14.286,1),(730,7521631,7521627,'ees',14.286,1),(730,7521632,7521627,'esp',14.286,1),(730,7521633,7521627,'spa',14.286,1),(730,7521634,7521627,'pac',14.286,1),(730,7521635,7521627,'ace',14.286,1),(730,7521636,7521629,'dis',50,1),(730,7521637,7521629,'isk',50,1),(730,7521638,7521636,'ind',33.333,1),(730,7521639,7521636,'nde',33.333,1),(730,7521640,7521636,'dex',33.333,1),(730,7521641,7521638,'adm',8.333,1),(730,7521642,7521638,'dmi',8.333,1),(730,7521643,7521638,'min',8.333,1),(730,7521644,7521638,'ini',8.333,1),(730,7521645,7521638,'nis',8.333,1),(730,7521646,7521638,'ist',8.333,1),(730,7521647,7521638,'str',8.333,1),(730,7521648,7521638,'tra',8.333,1),(730,7521649,7521638,'rat',8.333,1),(730,7521650,7521638,'ati',8.333,1),(730,7521651,7521638,'tio',8.333,1),(730,7521652,7521638,'ion',8.333,1),(730,7521653,7521641,'sta',33.333,3),(730,7521654,7521641,'tat',33.333,3),(730,7521655,7521641,'ate',33.333,3),(730,7521656,7521653,'ena',20,2),(730,7521657,7521653,'nab',20,2),(730,7521658,7521653,'abl',20,2),(730,7521659,7521653,'ble',20,2),(730,7521660,7521653,'led',20,2),(730,7521661,7521656,'cac',33.333,2),(730,7521662,7521656,'ach',33.333,2),(730,7521663,7521656,'che',33.333,2),(730,7521664,7521661,'mod',50,1),(730,7521665,7521661,'ode',50,1),(730,7521666,7521664,'wri',14.286,1),(730,7521667,7521664,'rit',14.286,1),(730,7521668,7521664,'ite',14.286,1),(730,7521669,7521664,'tet',14.286,1),(730,7521670,7521664,'eth',14.286,1),(730,7521671,7521664,'thr',14.286,1),(730,7521672,7521664,'hru',14.286,1),(730,7521673,7521666,'ope',11.111,2),(730,7521674,7521666,'per',11.111,2),(730,7521675,7521666,'era',11.111,2),(730,7521676,7521666,'rat',11.111,2),(730,7521677,7521666,'ati',11.111,2),(730,7521678,7521666,'tio',11.111,2),(730,7521679,7521666,'ion',11.111,2),(730,7521680,7521666,'ona',11.111,2),(730,7521681,7521666,'nal',11.111,2),(730,7521682,7521673,'pen',20,1),(730,7521683,7521673,'end',20,1),(730,7521684,7521673,'ndi',20,1),(730,7521685,7521673,'din',20,1),(730,7521686,7521673,'ing',20,1),(730,7521687,7521682,'mes',20,1),(730,7521688,7521682,'ess',20,1),(730,7521689,7521682,'ssa',20,1),(730,7521690,7521682,'sag',20,1),(730,7521691,7521682,'age',20,1),(730,7521692,7521687,'wai',20,1),(730,7521693,7521687,'ait',20,1),(730,7521694,7521687,'iti',20,1),(730,7521695,7521687,'tin',20,1),(730,7521696,7521687,'ing',20,1),(730,7521697,7521692,'for',100,1),(730,7521698,7521697,'per',11.111,1),(730,7521699,7521697,'erf',11.111,1),(730,7521700,7521697,'rfo',11.111,1),(730,7521701,7521697,'for',11.111,1),(730,7521702,7521697,'orm',11.111,1),(730,7521703,7521697,'rma',11.111,1),(730,7521704,7521697,'man',11.111,1),(730,7521705,7521697,'anc',11.111,1),(730,7521706,7521697,'nce',11.111,1),(730,7521707,7521698,'ide',12.5,1),(730,7521708,7521698,'den',12.5,1),(730,7521709,7521698,'ent',12.5,1),(730,7521710,7521698,'nti',12.5,1),(730,7521711,7521698,'tif',12.5,1),(730,7521712,7521698,'ifi',12.5,1),(730,7521713,7521698,'fie',12.5,1),(730,7521714,7521698,'ier',12.5,1),(730,7521715,7521707,'vdi',33.333,3),(730,7521716,7521707,'dis',33.333,3),(730,7521717,7521707,'isk',33.333,3),(730,7521718,7521715,'nam',50,1),(730,7521719,7521715,'ame',50,1),(730,7521720,7521718,'typ',50,1),(730,7521721,7521718,'ype',50,1),(730,7521722,7521720,'dir',25,1),(730,7521723,7521720,'ire',25,1),(730,7521724,7521720,'rec',25,1),(730,7521725,7521720,'ect',25,1),(731,7521727,7521726,'naa',100,2),(731,7521728,7521727,'600',3.333,3),(731,7521729,7521727,'000',3.333,3),(731,7521730,7521727,'00c',3.333,3),(731,7521731,7521727,'0c2',3.333,3),(731,7521732,7521727,'c29',3.333,3),(731,7521733,7521727,'293',3.333,3),(731,7521734,7521727,'931',3.333,3),(731,7521735,7521727,'31b',3.333,3),(731,7521736,7521727,'1b5',3.333,3),(731,7521737,7521727,'b54',3.333,3),(731,7521738,7521727,'541',3.333,3),(731,7521739,7521727,'414',3.333,3),(731,7521740,7521727,'148',3.333,3),(731,7521741,7521727,'483',3.333,3),(731,7521742,7521727,'83d',3.333,3),(731,7521743,7521727,'3d3',3.333,3),(731,7521744,7521727,'d3f',3.333,3),(731,7521745,7521727,'3f0',3.333,3),(731,7521746,7521727,'f05',3.333,3),(731,7521747,7521727,'05b',3.333,3),(731,7521748,7521727,'5b9',3.333,3),(731,7521749,7521727,'b95',3.333,3),(731,7521750,7521727,'955',3.333,3),(731,7521751,7521727,'55e',3.333,3),(731,7521752,7521727,'5ed',3.333,3),(731,7521753,7521727,'ed0',3.333,3),(731,7521754,7521727,'d0b',3.333,3),(731,7521755,7521727,'0ba',3.333,3),(731,7521756,7521727,'baa',3.333,3),(731,7521757,7521727,'aaf',3.333,3),(731,7521758,7521728,'mon',100,1),(731,7521759,7521758,'201',50,1),(731,7521760,7521758,'013',50,1),(731,7521761,7521759,'adm',33.333,3),(731,7521762,7521759,'dmi',33.333,3),(731,7521763,7521759,'min',33.333,3),(731,7521764,7521761,'cap',16.667,1),(731,7521765,7521761,'apa',16.667,1),(731,7521766,7521761,'pac',16.667,1),(731,7521767,7521761,'aci',16.667,1),(731,7521768,7521761,'cit',16.667,1),(731,7521769,7521761,'ity',16.667,1),(731,7521770,7521764,'pat',50,1),(731,7521771,7521764,'ath',50,1),(731,7521772,7521770,'fre',14.286,1),(731,7521773,7521770,'ree',14.286,1),(731,7521774,7521770,'ees',14.286,1),(731,7521775,7521770,'esp',14.286,1),(731,7521776,7521770,'spa',14.286,1),(731,7521777,7521770,'pac',14.286,1),(731,7521778,7521770,'ace',14.286,1),(731,7521779,7521772,'dis',50,1),(731,7521780,7521772,'isk',50,1),(731,7521781,7521779,'ind',33.333,1),(731,7521782,7521779,'nde',33.333,1),(731,7521783,7521779,'dex',33.333,1),(731,7521784,7521781,'adm',8.333,1),(731,7521785,7521781,'dmi',8.333,1),(731,7521786,7521781,'min',8.333,1),(731,7521787,7521781,'ini',8.333,1),(731,7521788,7521781,'nis',8.333,1),(731,7521789,7521781,'ist',8.333,1),(731,7521790,7521781,'str',8.333,1),(731,7521791,7521781,'tra',8.333,1),(731,7521792,7521781,'rat',8.333,1),(731,7521793,7521781,'ati',8.333,1),(731,7521794,7521781,'tio',8.333,1),(731,7521795,7521781,'ion',8.333,1),(731,7521796,7521784,'sta',33.333,3),(731,7521797,7521784,'tat',33.333,3),(731,7521798,7521784,'ate',33.333,3),(731,7521799,7521796,'ena',20,2),(731,7521800,7521796,'nab',20,2),(731,7521801,7521796,'abl',20,2),(731,7521802,7521796,'ble',20,2),(731,7521803,7521796,'led',20,2),(731,7521804,7521799,'cac',33.333,2),(731,7521805,7521799,'ach',33.333,2),(731,7521806,7521799,'che',33.333,2),(731,7521807,7521804,'mod',50,1),(731,7521808,7521804,'ode',50,1),(731,7521809,7521807,'wri',14.286,1),(731,7521810,7521807,'rit',14.286,1),(731,7521811,7521807,'ite',14.286,1),(731,7521812,7521807,'tet',14.286,1),(731,7521813,7521807,'eth',14.286,1),(731,7521814,7521807,'thr',14.286,1),(731,7521815,7521807,'hru',14.286,1),(731,7521816,7521809,'ope',11.111,2),(731,7521817,7521809,'per',11.111,2),(731,7521818,7521809,'era',11.111,2),(731,7521819,7521809,'rat',11.111,2),(731,7521820,7521809,'ati',11.111,2),(731,7521821,7521809,'tio',11.111,2),(731,7521822,7521809,'ion',11.111,2),(731,7521823,7521809,'ona',11.111,2),(731,7521824,7521809,'nal',11.111,2),(731,7521825,7521816,'pen',20,1),(731,7521826,7521816,'end',20,1),(731,7521827,7521816,'ndi',20,1),(731,7521828,7521816,'din',20,1),(731,7521829,7521816,'ing',20,1),(731,7521830,7521825,'mes',20,1),(731,7521831,7521825,'ess',20,1),(731,7521832,7521825,'ssa',20,1),(731,7521833,7521825,'sag',20,1),(731,7521834,7521825,'age',20,1),(731,7521835,7521830,'wai',20,1),(731,7521836,7521830,'ait',20,1),(731,7521837,7521830,'iti',20,1),(731,7521838,7521830,'tin',20,1),(731,7521839,7521830,'ing',20,1),(731,7521840,7521835,'for',100,1),(731,7521841,7521840,'per',11.111,1),(731,7521842,7521840,'erf',11.111,1),(731,7521843,7521840,'rfo',11.111,1),(731,7521844,7521840,'for',11.111,1),(731,7521845,7521840,'orm',11.111,1),(731,7521846,7521840,'rma',11.111,1),(731,7521847,7521840,'man',11.111,1),(731,7521848,7521840,'anc',11.111,1),(731,7521849,7521840,'nce',11.111,1),(731,7521850,7521841,'ide',12.5,1),(731,7521851,7521841,'den',12.5,1),(731,7521852,7521841,'ent',12.5,1),(731,7521853,7521841,'nti',12.5,1),(731,7521854,7521841,'tif',12.5,1),(731,7521855,7521841,'ifi',12.5,1),(731,7521856,7521841,'fie',12.5,1),(731,7521857,7521841,'ier',12.5,1),(731,7521858,7521850,'vdi',33.333,3),(731,7521859,7521850,'dis',33.333,3),(731,7521860,7521850,'isk',33.333,3),(731,7521861,7521858,'nam',50,1),(731,7521862,7521858,'ame',50,1),(731,7521863,7521861,'typ',50,1),(731,7521864,7521861,'ype',50,1),(731,7521865,7521863,'dir',25,1),(731,7521866,7521863,'ire',25,1),(731,7521867,7521863,'rec',25,1),(731,7521868,7521863,'ect',25,1),(732,7521870,7521869,'naa',100,2),(732,7521871,7521870,'600',3.333,3),(732,7521872,7521870,'000',3.333,3),(732,7521873,7521870,'00c',3.333,3),(732,7521874,7521870,'0c2',3.333,3),(732,7521875,7521870,'c29',3.333,3),(732,7521876,7521870,'29d',3.333,3),(732,7521877,7521870,'9d7',3.333,3),(732,7521878,7521870,'d71',3.333,3),(732,7521879,7521870,'712',3.333,3),(732,7521880,7521870,'12f',3.333,3),(732,7521881,7521870,'2fa',3.333,3),(732,7521882,7521870,'fae',3.333,3),(732,7521883,7521870,'ae5',3.333,3),(732,7521884,7521870,'e50',3.333,3),(732,7521885,7521870,'504',3.333,3),(732,7521886,7521870,'04c',3.333,3),(732,7521887,7521870,'4cd',3.333,3),(732,7521888,7521870,'cd1',3.333,3),(732,7521889,7521870,'d10',3.333,3),(732,7521890,7521870,'10e',3.333,3),(732,7521891,7521870,'0e0',3.333,3),(732,7521892,7521870,'e02',3.333,3),(732,7521893,7521870,'02c',3.333,3),(732,7521894,7521870,'2ca',3.333,3),(732,7521895,7521870,'ca6',3.333,3),(732,7521896,7521870,'a68',3.333,3),(732,7521897,7521870,'68a',3.333,3),(732,7521898,7521870,'8ae',3.333,3),(732,7521899,7521870,'aec',3.333,3),(732,7521900,7521870,'ecc',3.333,3),(732,7521901,7521871,'mon',100,1),(732,7521902,7521901,'201',50,1),(732,7521903,7521901,'013',50,1),(732,7521904,7521902,'adm',33.333,3),(732,7521905,7521902,'dmi',33.333,3),(732,7521906,7521902,'min',33.333,3),(732,7521907,7521904,'cap',16.667,1),(732,7521908,7521904,'apa',16.667,1),(732,7521909,7521904,'pac',16.667,1),(732,7521910,7521904,'aci',16.667,1),(732,7521911,7521904,'cit',16.667,1),(732,7521912,7521904,'ity',16.667,1),(732,7521913,7521907,'pat',50,1),(732,7521914,7521907,'ath',50,1),(732,7521915,7521913,'fre',14.286,1),(732,7521916,7521913,'ree',14.286,1),(732,7521917,7521913,'ees',14.286,1),(732,7521918,7521913,'esp',14.286,1),(732,7521919,7521913,'spa',14.286,1),(732,7521920,7521913,'pac',14.286,1),(732,7521921,7521913,'ace',14.286,1),(732,7521922,7521915,'dis',50,1),(732,7521923,7521915,'isk',50,1),(732,7521924,7521922,'ind',33.333,1),(732,7521925,7521922,'nde',33.333,1),(732,7521926,7521922,'dex',33.333,1),(732,7521927,7521924,'adm',8.333,1),(732,7521928,7521924,'dmi',8.333,1),(732,7521929,7521924,'min',8.333,1),(732,7521930,7521924,'ini',8.333,1),(732,7521931,7521924,'nis',8.333,1),(732,7521932,7521924,'ist',8.333,1),(732,7521933,7521924,'str',8.333,1),(732,7521934,7521924,'tra',8.333,1),(732,7521935,7521924,'rat',8.333,1),(732,7521936,7521924,'ati',8.333,1),(732,7521937,7521924,'tio',8.333,1),(732,7521938,7521924,'ion',8.333,1),(732,7521939,7521927,'sta',33.333,3),(732,7521940,7521927,'tat',33.333,3),(732,7521941,7521927,'ate',33.333,3),(732,7521942,7521939,'ena',20,2),(732,7521943,7521939,'nab',20,2),(732,7521944,7521939,'abl',20,2),(732,7521945,7521939,'ble',20,2),(732,7521946,7521939,'led',20,2),(732,7521947,7521942,'cac',33.333,2),(732,7521948,7521942,'ach',33.333,2),(732,7521949,7521942,'che',33.333,2),(732,7521950,7521947,'mod',50,1),(732,7521951,7521947,'ode',50,1),(732,7521952,7521950,'wri',14.286,1),(732,7521953,7521950,'rit',14.286,1),(732,7521954,7521950,'ite',14.286,1),(732,7521955,7521950,'tet',14.286,1),(732,7521956,7521950,'eth',14.286,1),(732,7521957,7521950,'thr',14.286,1),(732,7521958,7521950,'hru',14.286,1),(732,7521959,7521952,'ope',11.111,2),(732,7521960,7521952,'per',11.111,2),(732,7521961,7521952,'era',11.111,2),(732,7521962,7521952,'rat',11.111,2),(732,7521963,7521952,'ati',11.111,2),(732,7521964,7521952,'tio',11.111,2),(732,7521965,7521952,'ion',11.111,2),(732,7521966,7521952,'ona',11.111,2),(732,7521967,7521952,'nal',11.111,2),(732,7521968,7521959,'pen',20,1),(732,7521969,7521959,'end',20,1),(732,7521970,7521959,'ndi',20,1),(732,7521971,7521959,'din',20,1),(732,7521972,7521959,'ing',20,1),(732,7521973,7521968,'mes',20,1),(732,7521974,7521968,'ess',20,1),(732,7521975,7521968,'ssa',20,1),(732,7521976,7521968,'sag',20,1),(732,7521977,7521968,'age',20,1),(732,7521978,7521973,'wai',20,1),(732,7521979,7521973,'ait',20,1),(732,7521980,7521973,'iti',20,1),(732,7521981,7521973,'tin',20,1),(732,7521982,7521973,'ing',20,1),(732,7521983,7521978,'for',100,1),(732,7521984,7521983,'per',11.111,1),(732,7521985,7521983,'erf',11.111,1),(732,7521986,7521983,'rfo',11.111,1),(732,7521987,7521983,'for',11.111,1),(732,7521988,7521983,'orm',11.111,1),(732,7521989,7521983,'rma',11.111,1),(732,7521990,7521983,'man',11.111,1),(732,7521991,7521983,'anc',11.111,1),(732,7521992,7521983,'nce',11.111,1),(732,7521993,7521984,'ide',12.5,1),(732,7521994,7521984,'den',12.5,1),(732,7521995,7521984,'ent',12.5,1),(732,7521996,7521984,'nti',12.5,1),(732,7521997,7521984,'tif',12.5,1),(732,7521998,7521984,'ifi',12.5,1),(732,7521999,7521984,'fie',12.5,1),(732,7522000,7521984,'ier',12.5,1),(732,7522001,7521993,'vdi',33.333,3),(732,7522002,7521993,'dis',33.333,3),(732,7522003,7521993,'isk',33.333,3),(732,7522004,7522001,'nam',50,1),(732,7522005,7522001,'ame',50,1),(732,7522006,7522004,'typ',50,1),(732,7522007,7522004,'ype',50,1),(732,7522008,7522006,'dir',25,1),(732,7522009,7522006,'ire',25,1),(732,7522010,7522006,'rec',25,1),(732,7522011,7522006,'ect',25,1),(733,7522013,7522012,'naa',100,2),(733,7522014,7522013,'600',3.333,3),(733,7522015,7522013,'000',3.333,3),(733,7522016,7522013,'00c',3.333,3),(733,7522017,7522013,'0c2',3.333,3),(733,7522018,7522013,'c29',3.333,3),(733,7522019,7522013,'29f',3.333,3),(733,7522020,7522013,'9f3',3.333,3),(733,7522021,7522013,'f30',3.333,3),(733,7522022,7522013,'30c',3.333,3),(733,7522023,7522013,'0c0',3.333,3),(733,7522024,7522013,'c0b',3.333,3),(733,7522025,7522013,'0bc',3.333,3),(733,7522026,7522013,'bce',3.333,3),(733,7522027,7522013,'ce2',3.333,3),(733,7522028,7522013,'e25',3.333,3),(733,7522029,7522013,'254',3.333,3),(733,7522030,7522013,'54f',3.333,3),(733,7522031,7522013,'4f2',3.333,3),(733,7522032,7522013,'f21',3.333,3),(733,7522033,7522013,'21f',3.333,3),(733,7522034,7522013,'1f8',3.333,3),(733,7522035,7522013,'f8f',3.333,3),(733,7522036,7522013,'8fa',3.333,3),(733,7522037,7522013,'fa5',3.333,3),(733,7522038,7522013,'a53',3.333,3),(733,7522039,7522013,'53e',3.333,3),(733,7522040,7522013,'3e8',3.333,3),(733,7522041,7522013,'e80',3.333,3),(733,7522042,7522013,'808',3.333,3),(733,7522043,7522013,'083',3.333,3),(733,7522044,7522014,'mon',100,1),(733,7522045,7522044,'201',50,1),(733,7522046,7522044,'013',50,1),(733,7522047,7522045,'adm',33.333,3),(733,7522048,7522045,'dmi',33.333,3),(733,7522049,7522045,'min',33.333,3),(733,7522050,7522047,'cap',16.667,1),(733,7522051,7522047,'apa',16.667,1),(733,7522052,7522047,'pac',16.667,1),(733,7522053,7522047,'aci',16.667,1),(733,7522054,7522047,'cit',16.667,1),(733,7522055,7522047,'ity',16.667,1),(733,7522056,7522050,'pat',50,1),(733,7522057,7522050,'ath',50,1),(733,7522058,7522056,'fre',14.286,1),(733,7522059,7522056,'ree',14.286,1),(733,7522060,7522056,'ees',14.286,1),(733,7522061,7522056,'esp',14.286,1),(733,7522062,7522056,'spa',14.286,1),(733,7522063,7522056,'pac',14.286,1),(733,7522064,7522056,'ace',14.286,1),(733,7522065,7522058,'dis',50,1),(733,7522066,7522058,'isk',50,1),(733,7522067,7522065,'ind',33.333,1),(733,7522068,7522065,'nde',33.333,1),(733,7522069,7522065,'dex',33.333,1),(733,7522070,7522067,'adm',8.333,1),(733,7522071,7522067,'dmi',8.333,1),(733,7522072,7522067,'min',8.333,1),(733,7522073,7522067,'ini',8.333,1),(733,7522074,7522067,'nis',8.333,1),(733,7522075,7522067,'ist',8.333,1),(733,7522076,7522067,'str',8.333,1),(733,7522077,7522067,'tra',8.333,1),(733,7522078,7522067,'rat',8.333,1),(733,7522079,7522067,'ati',8.333,1),(733,7522080,7522067,'tio',8.333,1),(733,7522081,7522067,'ion',8.333,1),(733,7522082,7522070,'sta',33.333,3),(733,7522083,7522070,'tat',33.333,3),(733,7522084,7522070,'ate',33.333,3),(733,7522085,7522082,'ena',20,2),(733,7522086,7522082,'nab',20,2),(733,7522087,7522082,'abl',20,2),(733,7522088,7522082,'ble',20,2),(733,7522089,7522082,'led',20,2),(733,7522090,7522085,'cac',33.333,2),(733,7522091,7522085,'ach',33.333,2),(733,7522092,7522085,'che',33.333,2),(733,7522093,7522090,'mod',50,1),(733,7522094,7522090,'ode',50,1),(733,7522095,7522093,'wri',14.286,1),(733,7522096,7522093,'rit',14.286,1),(733,7522097,7522093,'ite',14.286,1),(733,7522098,7522093,'tet',14.286,1),(733,7522099,7522093,'eth',14.286,1),(733,7522100,7522093,'thr',14.286,1),(733,7522101,7522093,'hru',14.286,1),(733,7522102,7522095,'ope',11.111,2),(733,7522103,7522095,'per',11.111,2),(733,7522104,7522095,'era',11.111,2),(733,7522105,7522095,'rat',11.111,2),(733,7522106,7522095,'ati',11.111,2),(733,7522107,7522095,'tio',11.111,2),(733,7522108,7522095,'ion',11.111,2),(733,7522109,7522095,'ona',11.111,2),(733,7522110,7522095,'nal',11.111,2),(733,7522111,7522102,'pen',20,1),(733,7522112,7522102,'end',20,1),(733,7522113,7522102,'ndi',20,1),(733,7522114,7522102,'din',20,1),(733,7522115,7522102,'ing',20,1),(733,7522116,7522111,'mes',20,1),(733,7522117,7522111,'ess',20,1),(733,7522118,7522111,'ssa',20,1),(733,7522119,7522111,'sag',20,1),(733,7522120,7522111,'age',20,1),(733,7522121,7522116,'wai',20,1),(733,7522122,7522116,'ait',20,1),(733,7522123,7522116,'iti',20,1),(733,7522124,7522116,'tin',20,1),(733,7522125,7522116,'ing',20,1),(733,7522126,7522121,'for',100,1),(733,7522127,7522126,'per',11.111,1),(733,7522128,7522126,'erf',11.111,1),(733,7522129,7522126,'rfo',11.111,1),(733,7522130,7522126,'for',11.111,1),(733,7522131,7522126,'orm',11.111,1),(733,7522132,7522126,'rma',11.111,1),(733,7522133,7522126,'man',11.111,1),(733,7522134,7522126,'anc',11.111,1),(733,7522135,7522126,'nce',11.111,1),(733,7522136,7522127,'ide',12.5,1),(733,7522137,7522127,'den',12.5,1),(733,7522138,7522127,'ent',12.5,1),(733,7522139,7522127,'nti',12.5,1),(733,7522140,7522127,'tif',12.5,1),(733,7522141,7522127,'ifi',12.5,1),(733,7522142,7522127,'fie',12.5,1),(733,7522143,7522127,'ier',12.5,1),(733,7522144,7522136,'vdi',33.333,3),(733,7522145,7522136,'dis',33.333,3),(733,7522146,7522136,'isk',33.333,3),(733,7522147,7522144,'nam',50,1),(733,7522148,7522144,'ame',50,1),(733,7522149,7522147,'typ',50,1),(733,7522150,7522147,'ype',50,1),(733,7522151,7522149,'dir',25,1),(733,7522152,7522149,'ire',25,1),(733,7522153,7522149,'rec',25,1),(733,7522154,7522149,'ect',25,1),(734,7522156,7522155,'naa',100,2),(734,7522157,7522156,'600',3.333,3),(734,7522158,7522156,'000',3.333,3),(734,7522159,7522156,'00c',3.333,3),(734,7522160,7522156,'0c2',3.333,3),(734,7522161,7522156,'c29',3.333,3),(734,7522162,7522156,'298',3.333,3),(734,7522163,7522156,'98f',3.333,3),(734,7522164,7522156,'8f3',3.333,3),(734,7522165,7522156,'f3e',3.333,3),(734,7522166,7522156,'3ee',3.333,3),(734,7522167,7522156,'ee1',3.333,3),(734,7522168,7522156,'e19',3.333,3),(734,7522169,7522156,'198',3.333,3),(734,7522170,7522156,'989',3.333,3),(734,7522171,7522156,'893',3.333,3),(734,7522172,7522156,'932',3.333,3),(734,7522173,7522156,'32e',3.333,3),(734,7522174,7522156,'2eb',3.333,3),(734,7522175,7522156,'eb1',3.333,3),(734,7522176,7522156,'b16',3.333,3),(734,7522177,7522156,'164',3.333,3),(734,7522178,7522156,'649',3.333,3),(734,7522179,7522156,'496',3.333,3),(734,7522180,7522156,'96a',3.333,3),(734,7522181,7522156,'6aa',3.333,3),(734,7522182,7522156,'aa5',3.333,3),(734,7522183,7522156,'a5d',3.333,3),(734,7522184,7522156,'5d3',3.333,3),(734,7522185,7522156,'d34',3.333,3),(734,7522186,7522156,'345',3.333,3),(734,7522187,7522157,'mon',100,1),(734,7522188,7522187,'201',50,1),(734,7522189,7522187,'013',50,1),(734,7522190,7522188,'adm',33.333,3),(734,7522191,7522188,'dmi',33.333,3),(734,7522192,7522188,'min',33.333,3),(734,7522193,7522190,'cap',16.667,1),(734,7522194,7522190,'apa',16.667,1),(734,7522195,7522190,'pac',16.667,1),(734,7522196,7522190,'aci',16.667,1),(734,7522197,7522190,'cit',16.667,1),(734,7522198,7522190,'ity',16.667,1),(734,7522199,7522193,'pat',50,1),(734,7522200,7522193,'ath',50,1),(734,7522201,7522199,'fre',14.286,1),(734,7522202,7522199,'ree',14.286,1),(734,7522203,7522199,'ees',14.286,1),(734,7522204,7522199,'esp',14.286,1),(734,7522205,7522199,'spa',14.286,1),(734,7522206,7522199,'pac',14.286,1),(734,7522207,7522199,'ace',14.286,1),(734,7522208,7522201,'dis',50,1),(734,7522209,7522201,'isk',50,1),(734,7522210,7522208,'ind',33.333,1),(734,7522211,7522208,'nde',33.333,1),(734,7522212,7522208,'dex',33.333,1),(734,7522213,7522210,'adm',8.333,1),(734,7522214,7522210,'dmi',8.333,1),(734,7522215,7522210,'min',8.333,1),(734,7522216,7522210,'ini',8.333,1),(734,7522217,7522210,'nis',8.333,1),(734,7522218,7522210,'ist',8.333,1),(734,7522219,7522210,'str',8.333,1),(734,7522220,7522210,'tra',8.333,1),(734,7522221,7522210,'rat',8.333,1),(734,7522222,7522210,'ati',8.333,1),(734,7522223,7522210,'tio',8.333,1),(734,7522224,7522210,'ion',8.333,1),(734,7522225,7522213,'sta',33.333,3),(734,7522226,7522213,'tat',33.333,3),(734,7522227,7522213,'ate',33.333,3),(734,7522228,7522225,'ena',20,2),(734,7522229,7522225,'nab',20,2),(734,7522230,7522225,'abl',20,2),(734,7522231,7522225,'ble',20,2),(734,7522232,7522225,'led',20,2),(734,7522233,7522228,'cac',33.333,2),(734,7522234,7522228,'ach',33.333,2),(734,7522235,7522228,'che',33.333,2),(734,7522236,7522233,'mod',50,1),(734,7522237,7522233,'ode',50,1),(734,7522238,7522236,'wri',14.286,1),(734,7522239,7522236,'rit',14.286,1),(734,7522240,7522236,'ite',14.286,1),(734,7522241,7522236,'tet',14.286,1),(734,7522242,7522236,'eth',14.286,1),(734,7522243,7522236,'thr',14.286,1),(734,7522244,7522236,'hru',14.286,1),(734,7522245,7522238,'ope',11.111,2),(734,7522246,7522238,'per',11.111,2),(734,7522247,7522238,'era',11.111,2),(734,7522248,7522238,'rat',11.111,2),(734,7522249,7522238,'ati',11.111,2),(734,7522250,7522238,'tio',11.111,2),(734,7522251,7522238,'ion',11.111,2),(734,7522252,7522238,'ona',11.111,2),(734,7522253,7522238,'nal',11.111,2),(734,7522254,7522245,'pen',20,1),(734,7522255,7522245,'end',20,1),(734,7522256,7522245,'ndi',20,1),(734,7522257,7522245,'din',20,1),(734,7522258,7522245,'ing',20,1),(734,7522259,7522254,'mes',20,1),(734,7522260,7522254,'ess',20,1),(734,7522261,7522254,'ssa',20,1),(734,7522262,7522254,'sag',20,1),(734,7522263,7522254,'age',20,1),(734,7522264,7522259,'wai',20,1),(734,7522265,7522259,'ait',20,1),(734,7522266,7522259,'iti',20,1),(734,7522267,7522259,'tin',20,1),(734,7522268,7522259,'ing',20,1),(734,7522269,7522264,'for',100,1),(734,7522270,7522269,'per',11.111,1),(734,7522271,7522269,'erf',11.111,1),(734,7522272,7522269,'rfo',11.111,1),(734,7522273,7522269,'for',11.111,1),(734,7522274,7522269,'orm',11.111,1),(734,7522275,7522269,'rma',11.111,1),(734,7522276,7522269,'man',11.111,1),(734,7522277,7522269,'anc',11.111,1),(734,7522278,7522269,'nce',11.111,1),(734,7522279,7522270,'ide',12.5,1),(734,7522280,7522270,'den',12.5,1),(734,7522281,7522270,'ent',12.5,1),(734,7522282,7522270,'nti',12.5,1),(734,7522283,7522270,'tif',12.5,1),(734,7522284,7522270,'ifi',12.5,1),(734,7522285,7522270,'fie',12.5,1),(734,7522286,7522270,'ier',12.5,1),(734,7522287,7522279,'vdi',33.333,3),(734,7522288,7522279,'dis',33.333,3),(734,7522289,7522279,'isk',33.333,3),(734,7522290,7522287,'nam',50,1),(734,7522291,7522287,'ame',50,1),(734,7522292,7522290,'typ',50,1),(734,7522293,7522290,'ype',50,1),(734,7522294,7522292,'dir',25,1),(734,7522295,7522292,'ire',25,1),(734,7522296,7522292,'rec',25,1),(734,7522297,7522292,'ect',25,1),(735,7522299,7522298,'naa',100,2),(735,7522300,7522299,'600',3.333,3),(735,7522301,7522299,'000',3.333,3),(735,7522302,7522299,'00c',3.333,3),(735,7522303,7522299,'0c2',3.333,3),(735,7522304,7522299,'c29',3.333,3),(735,7522305,7522299,'290',3.333,3),(735,7522306,7522299,'90d',3.333,3),(735,7522307,7522299,'0d6',3.333,3),(735,7522308,7522299,'d64',3.333,3),(735,7522309,7522299,'64d',3.333,3),(735,7522310,7522299,'4d4',3.333,3),(735,7522311,7522299,'d4f',3.333,3),(735,7522312,7522299,'4fc',3.333,3),(735,7522313,7522299,'fce',3.333,3),(735,7522314,7522299,'ce9',3.333,3),(735,7522315,7522299,'e99',3.333,3),(735,7522316,7522299,'997',3.333,3),(735,7522317,7522299,'97d',3.333,3),(735,7522318,7522299,'7d2',3.333,3),(735,7522319,7522299,'d2a',3.333,3),(735,7522320,7522299,'2ab',3.333,3),(735,7522321,7522299,'ab2',3.333,3),(735,7522322,7522299,'b24',3.333,3),(735,7522323,7522299,'241',3.333,3),(735,7522324,7522299,'419',3.333,3),(735,7522325,7522299,'194',3.333,3),(735,7522326,7522299,'94d',3.333,3),(735,7522327,7522299,'4d3',3.333,3),(735,7522328,7522299,'d3e',3.333,3),(735,7522329,7522299,'3e8',3.333,3),(735,7522330,7522300,'mon',100,1),(735,7522331,7522330,'201',50,1),(735,7522332,7522330,'013',50,1),(735,7522333,7522331,'adm',33.333,3),(735,7522334,7522331,'dmi',33.333,3),(735,7522335,7522331,'min',33.333,3),(735,7522336,7522333,'cap',16.667,1),(735,7522337,7522333,'apa',16.667,1),(735,7522338,7522333,'pac',16.667,1),(735,7522339,7522333,'aci',16.667,1),(735,7522340,7522333,'cit',16.667,1),(735,7522341,7522333,'ity',16.667,1),(735,7522342,7522336,'pat',50,1),(735,7522343,7522336,'ath',50,1),(735,7522344,7522342,'fre',14.286,1),(735,7522345,7522342,'ree',14.286,1),(735,7522346,7522342,'ees',14.286,1),(735,7522347,7522342,'esp',14.286,1),(735,7522348,7522342,'spa',14.286,1),(735,7522349,7522342,'pac',14.286,1),(735,7522350,7522342,'ace',14.286,1),(735,7522351,7522344,'dis',50,1),(735,7522352,7522344,'isk',50,1),(735,7522353,7522351,'ind',33.333,1),(735,7522354,7522351,'nde',33.333,1),(735,7522355,7522351,'dex',33.333,1),(735,7522356,7522353,'adm',8.333,1),(735,7522357,7522353,'dmi',8.333,1),(735,7522358,7522353,'min',8.333,1),(735,7522359,7522353,'ini',8.333,1),(735,7522360,7522353,'nis',8.333,1),(735,7522361,7522353,'ist',8.333,1),(735,7522362,7522353,'str',8.333,1),(735,7522363,7522353,'tra',8.333,1),(735,7522364,7522353,'rat',8.333,1),(735,7522365,7522353,'ati',8.333,1),(735,7522366,7522353,'tio',8.333,1),(735,7522367,7522353,'ion',8.333,1),(735,7522368,7522356,'sta',33.333,3),(735,7522369,7522356,'tat',33.333,3),(735,7522370,7522356,'ate',33.333,3),(735,7522371,7522368,'ena',20,2),(735,7522372,7522368,'nab',20,2),(735,7522373,7522368,'abl',20,2),(735,7522374,7522368,'ble',20,2),(735,7522375,7522368,'led',20,2),(735,7522376,7522371,'cac',33.333,2),(735,7522377,7522371,'ach',33.333,2),(735,7522378,7522371,'che',33.333,2),(735,7522379,7522376,'mod',50,1),(735,7522380,7522376,'ode',50,1),(735,7522381,7522379,'wri',14.286,1),(735,7522382,7522379,'rit',14.286,1),(735,7522383,7522379,'ite',14.286,1),(735,7522384,7522379,'tet',14.286,1),(735,7522385,7522379,'eth',14.286,1),(735,7522386,7522379,'thr',14.286,1),(735,7522387,7522379,'hru',14.286,1),(735,7522388,7522381,'ope',11.111,2),(735,7522389,7522381,'per',11.111,2),(735,7522390,7522381,'era',11.111,2),(735,7522391,7522381,'rat',11.111,2),(735,7522392,7522381,'ati',11.111,2),(735,7522393,7522381,'tio',11.111,2),(735,7522394,7522381,'ion',11.111,2),(735,7522395,7522381,'ona',11.111,2),(735,7522396,7522381,'nal',11.111,2),(735,7522397,7522388,'pen',20,1),(735,7522398,7522388,'end',20,1),(735,7522399,7522388,'ndi',20,1),(735,7522400,7522388,'din',20,1),(735,7522401,7522388,'ing',20,1),(735,7522402,7522397,'mes',20,1),(735,7522403,7522397,'ess',20,1),(735,7522404,7522397,'ssa',20,1),(735,7522405,7522397,'sag',20,1),(735,7522406,7522397,'age',20,1),(735,7522407,7522402,'wai',20,1),(735,7522408,7522402,'ait',20,1),(735,7522409,7522402,'iti',20,1),(735,7522410,7522402,'tin',20,1),(735,7522411,7522402,'ing',20,1),(735,7522412,7522407,'for',100,1),(735,7522413,7522412,'per',11.111,1),(735,7522414,7522412,'erf',11.111,1),(735,7522415,7522412,'rfo',11.111,1),(735,7522416,7522412,'for',11.111,1),(735,7522417,7522412,'orm',11.111,1),(735,7522418,7522412,'rma',11.111,1),(735,7522419,7522412,'man',11.111,1),(735,7522420,7522412,'anc',11.111,1),(735,7522421,7522412,'nce',11.111,1),(735,7522422,7522413,'ide',12.5,1),(735,7522423,7522413,'den',12.5,1),(735,7522424,7522413,'ent',12.5,1),(735,7522425,7522413,'nti',12.5,1),(735,7522426,7522413,'tif',12.5,1),(735,7522427,7522413,'ifi',12.5,1),(735,7522428,7522413,'fie',12.5,1),(735,7522429,7522413,'ier',12.5,1),(735,7522430,7522422,'vdi',33.333,3),(735,7522431,7522422,'dis',33.333,3),(735,7522432,7522422,'isk',33.333,3),(735,7522433,7522430,'nam',50,1),(735,7522434,7522430,'ame',50,1),(735,7522435,7522433,'typ',50,1),(735,7522436,7522433,'ype',50,1),(735,7522437,7522435,'dir',25,1),(735,7522438,7522435,'ire',25,1),(735,7522439,7522435,'rec',25,1),(735,7522440,7522435,'ect',25,1),(736,7522442,7522441,'naa',100,2),(736,7522443,7522442,'600',3.333,3),(736,7522444,7522442,'000',3.333,3),(736,7522445,7522442,'00c',3.333,3),(736,7522446,7522442,'0c2',3.333,3),(736,7522447,7522442,'c29',3.333,3),(736,7522448,7522442,'294',3.333,3),(736,7522449,7522442,'949',3.333,3),(736,7522450,7522442,'49a',3.333,3),(736,7522451,7522442,'9a8',3.333,3),(736,7522452,7522442,'a8a',3.333,3),(736,7522453,7522442,'8a2',3.333,3),(736,7522454,7522442,'a21',3.333,3),(736,7522455,7522442,'214',3.333,3),(736,7522456,7522442,'148',3.333,3),(736,7522457,7522442,'484',3.333,3),(736,7522458,7522442,'842',3.333,3),(736,7522459,7522442,'42b',3.333,3),(736,7522460,7522442,'2b5',3.333,3),(736,7522461,7522442,'b5f',3.333,3),(736,7522462,7522442,'5fd',3.333,3),(736,7522463,7522442,'fd5',3.333,3),(736,7522464,7522442,'d54',3.333,3),(736,7522465,7522442,'54d',3.333,3),(736,7522466,7522442,'4df',3.333,3),(736,7522467,7522442,'df8',3.333,3),(736,7522468,7522442,'f89',3.333,3),(736,7522469,7522442,'89e',3.333,3),(736,7522470,7522442,'9ed',3.333,3),(736,7522471,7522442,'ed4',3.333,3),(736,7522472,7522442,'d47',3.333,3),(736,7522473,7522443,'mon',100,1),(736,7522474,7522473,'201',50,1),(736,7522475,7522473,'013',50,1),(736,7522476,7522474,'adm',33.333,3),(736,7522477,7522474,'dmi',33.333,3),(736,7522478,7522474,'min',33.333,3),(736,7522479,7522476,'cap',16.667,1),(736,7522480,7522476,'apa',16.667,1),(736,7522481,7522476,'pac',16.667,1),(736,7522482,7522476,'aci',16.667,1),(736,7522483,7522476,'cit',16.667,1),(736,7522484,7522476,'ity',16.667,1),(736,7522485,7522479,'pat',50,1),(736,7522486,7522479,'ath',50,1),(736,7522487,7522485,'fre',14.286,1),(736,7522488,7522485,'ree',14.286,1),(736,7522489,7522485,'ees',14.286,1),(736,7522490,7522485,'esp',14.286,1),(736,7522491,7522485,'spa',14.286,1),(736,7522492,7522485,'pac',14.286,1),(736,7522493,7522485,'ace',14.286,1),(736,7522494,7522487,'dis',50,1),(736,7522495,7522487,'isk',50,1),(736,7522496,7522494,'ind',33.333,1),(736,7522497,7522494,'nde',33.333,1),(736,7522498,7522494,'dex',33.333,1),(736,7522499,7522496,'adm',8.333,1),(736,7522500,7522496,'dmi',8.333,1),(736,7522501,7522496,'min',8.333,1),(736,7522502,7522496,'ini',8.333,1),(736,7522503,7522496,'nis',8.333,1),(736,7522504,7522496,'ist',8.333,1),(736,7522505,7522496,'str',8.333,1),(736,7522506,7522496,'tra',8.333,1),(736,7522507,7522496,'rat',8.333,1),(736,7522508,7522496,'ati',8.333,1),(736,7522509,7522496,'tio',8.333,1),(736,7522510,7522496,'ion',8.333,1),(736,7522511,7522499,'sta',33.333,3),(736,7522512,7522499,'tat',33.333,3),(736,7522513,7522499,'ate',33.333,3),(736,7522514,7522511,'ena',20,2),(736,7522515,7522511,'nab',20,2),(736,7522516,7522511,'abl',20,2),(736,7522517,7522511,'ble',20,2),(736,7522518,7522511,'led',20,2),(736,7522519,7522514,'cac',33.333,2),(736,7522520,7522514,'ach',33.333,2),(736,7522521,7522514,'che',33.333,2),(736,7522522,7522519,'mod',50,1),(736,7522523,7522519,'ode',50,1),(736,7522524,7522522,'wri',14.286,1),(736,7522525,7522522,'rit',14.286,1),(736,7522526,7522522,'ite',14.286,1),(736,7522527,7522522,'tet',14.286,1),(736,7522528,7522522,'eth',14.286,1),(736,7522529,7522522,'thr',14.286,1),(736,7522530,7522522,'hru',14.286,1),(736,7522531,7522524,'ope',11.111,2),(736,7522532,7522524,'per',11.111,2),(736,7522533,7522524,'era',11.111,2),(736,7522534,7522524,'rat',11.111,2),(736,7522535,7522524,'ati',11.111,2),(736,7522536,7522524,'tio',11.111,2),(736,7522537,7522524,'ion',11.111,2),(736,7522538,7522524,'ona',11.111,2),(736,7522539,7522524,'nal',11.111,2),(736,7522540,7522531,'pen',20,1),(736,7522541,7522531,'end',20,1),(736,7522542,7522531,'ndi',20,1),(736,7522543,7522531,'din',20,1),(736,7522544,7522531,'ing',20,1),(736,7522545,7522540,'mes',20,1),(736,7522546,7522540,'ess',20,1),(736,7522547,7522540,'ssa',20,1),(736,7522548,7522540,'sag',20,1),(736,7522549,7522540,'age',20,1),(736,7522550,7522545,'wai',20,1),(736,7522551,7522545,'ait',20,1),(736,7522552,7522545,'iti',20,1),(736,7522553,7522545,'tin',20,1),(736,7522554,7522545,'ing',20,1),(736,7522555,7522550,'for',100,1),(736,7522556,7522555,'per',11.111,1),(736,7522557,7522555,'erf',11.111,1),(736,7522558,7522555,'rfo',11.111,1),(736,7522559,7522555,'for',11.111,1),(736,7522560,7522555,'orm',11.111,1),(736,7522561,7522555,'rma',11.111,1),(736,7522562,7522555,'man',11.111,1),(736,7522563,7522555,'anc',11.111,1),(736,7522564,7522555,'nce',11.111,1),(736,7522565,7522556,'ide',12.5,1),(736,7522566,7522556,'den',12.5,1),(736,7522567,7522556,'ent',12.5,1),(736,7522568,7522556,'nti',12.5,1),(736,7522569,7522556,'tif',12.5,1),(736,7522570,7522556,'ifi',12.5,1),(736,7522571,7522556,'fie',12.5,1),(736,7522572,7522556,'ier',12.5,1),(736,7522573,7522565,'vdi',33.333,3),(736,7522574,7522565,'dis',33.333,3),(736,7522575,7522565,'isk',33.333,3),(736,7522576,7522573,'nam',50,1),(736,7522577,7522573,'ame',50,1),(736,7522578,7522576,'typ',50,1),(736,7522579,7522576,'ype',50,1),(736,7522580,7522578,'dir',25,1),(736,7522581,7522578,'ire',25,1),(736,7522582,7522578,'rec',25,1),(736,7522583,7522578,'ect',25,1),(737,7522585,7522584,'naa',100,2),(737,7522586,7522585,'600',3.333,3),(737,7522587,7522585,'000',3.333,3),(737,7522588,7522585,'00c',3.333,3),(737,7522589,7522585,'0c2',3.333,3),(737,7522590,7522585,'c29',3.333,3),(737,7522591,7522585,'294',3.333,3),(737,7522592,7522585,'94c',3.333,3),(737,7522593,7522585,'4c4',3.333,3),(737,7522594,7522585,'c45',3.333,3),(737,7522595,7522585,'453',3.333,3),(737,7522596,7522585,'532',3.333,3),(737,7522597,7522585,'323',3.333,3),(737,7522598,7522585,'233',3.333,3),(737,7522599,7522585,'330',3.333,3),(737,7522600,7522585,'30d',3.333,3),(737,7522601,7522585,'0df',3.333,3),(737,7522602,7522585,'df9',3.333,3),(737,7522603,7522585,'f93',3.333,3),(737,7522604,7522585,'933',3.333,3),(737,7522605,7522585,'335',3.333,3),(737,7522606,7522585,'35f',3.333,3),(737,7522607,7522585,'5f1',3.333,3),(737,7522608,7522585,'f1a',3.333,3),(737,7522609,7522585,'1ad',3.333,3),(737,7522610,7522585,'ada',3.333,3),(737,7522611,7522585,'da2',3.333,3),(737,7522612,7522585,'a2d',3.333,3),(737,7522613,7522585,'2dc',3.333,3),(737,7522614,7522585,'dc3',3.333,3),(737,7522615,7522585,'c3a',3.333,3),(737,7522616,7522586,'mon',100,1),(737,7522617,7522616,'201',50,1),(737,7522618,7522616,'013',50,1),(737,7522619,7522617,'adm',33.333,3),(737,7522620,7522617,'dmi',33.333,3),(737,7522621,7522617,'min',33.333,3),(737,7522622,7522619,'cap',16.667,1),(737,7522623,7522619,'apa',16.667,1),(737,7522624,7522619,'pac',16.667,1),(737,7522625,7522619,'aci',16.667,1),(737,7522626,7522619,'cit',16.667,1),(737,7522627,7522619,'ity',16.667,1),(737,7522628,7522622,'pat',50,1),(737,7522629,7522622,'ath',50,1),(737,7522630,7522628,'fre',14.286,1),(737,7522631,7522628,'ree',14.286,1),(737,7522632,7522628,'ees',14.286,1),(737,7522633,7522628,'esp',14.286,1),(737,7522634,7522628,'spa',14.286,1),(737,7522635,7522628,'pac',14.286,1),(737,7522636,7522628,'ace',14.286,1),(737,7522637,7522630,'dis',50,1),(737,7522638,7522630,'isk',50,1),(737,7522639,7522637,'ind',33.333,1),(737,7522640,7522637,'nde',33.333,1),(737,7522641,7522637,'dex',33.333,1),(737,7522642,7522639,'adm',8.333,1),(737,7522643,7522639,'dmi',8.333,1),(737,7522644,7522639,'min',8.333,1),(737,7522645,7522639,'ini',8.333,1),(737,7522646,7522639,'nis',8.333,1),(737,7522647,7522639,'ist',8.333,1),(737,7522648,7522639,'str',8.333,1),(737,7522649,7522639,'tra',8.333,1),(737,7522650,7522639,'rat',8.333,1),(737,7522651,7522639,'ati',8.333,1),(737,7522652,7522639,'tio',8.333,1),(737,7522653,7522639,'ion',8.333,1),(737,7522654,7522642,'sta',33.333,3),(737,7522655,7522642,'tat',33.333,3),(737,7522656,7522642,'ate',33.333,3),(737,7522657,7522654,'ena',20,2),(737,7522658,7522654,'nab',20,2),(737,7522659,7522654,'abl',20,2),(737,7522660,7522654,'ble',20,2),(737,7522661,7522654,'led',20,2),(737,7522662,7522657,'cac',33.333,2),(737,7522663,7522657,'ach',33.333,2),(737,7522664,7522657,'che',33.333,2),(737,7522665,7522662,'mod',50,1),(737,7522666,7522662,'ode',50,1),(737,7522667,7522665,'wri',14.286,1),(737,7522668,7522665,'rit',14.286,1),(737,7522669,7522665,'ite',14.286,1),(737,7522670,7522665,'tet',14.286,1),(737,7522671,7522665,'eth',14.286,1),(737,7522672,7522665,'thr',14.286,1),(737,7522673,7522665,'hru',14.286,1),(737,7522674,7522667,'ope',11.111,2),(737,7522675,7522667,'per',11.111,2),(737,7522676,7522667,'era',11.111,2),(737,7522677,7522667,'rat',11.111,2),(737,7522678,7522667,'ati',11.111,2),(737,7522679,7522667,'tio',11.111,2),(737,7522680,7522667,'ion',11.111,2),(737,7522681,7522667,'ona',11.111,2),(737,7522682,7522667,'nal',11.111,2),(737,7522683,7522674,'pen',20,1),(737,7522684,7522674,'end',20,1),(737,7522685,7522674,'ndi',20,1),(737,7522686,7522674,'din',20,1),(737,7522687,7522674,'ing',20,1),(737,7522688,7522683,'mes',20,1),(737,7522689,7522683,'ess',20,1),(737,7522690,7522683,'ssa',20,1),(737,7522691,7522683,'sag',20,1),(737,7522692,7522683,'age',20,1),(737,7522693,7522688,'wai',20,1),(737,7522694,7522688,'ait',20,1),(737,7522695,7522688,'iti',20,1),(737,7522696,7522688,'tin',20,1),(737,7522697,7522688,'ing',20,1),(737,7522698,7522693,'for',100,1),(737,7522699,7522698,'per',11.111,1),(737,7522700,7522698,'erf',11.111,1),(737,7522701,7522698,'rfo',11.111,1),(737,7522702,7522698,'for',11.111,1),(737,7522703,7522698,'orm',11.111,1),(737,7522704,7522698,'rma',11.111,1),(737,7522705,7522698,'man',11.111,1),(737,7522706,7522698,'anc',11.111,1),(737,7522707,7522698,'nce',11.111,1),(737,7522708,7522699,'ide',12.5,1),(737,7522709,7522699,'den',12.5,1),(737,7522710,7522699,'ent',12.5,1),(737,7522711,7522699,'nti',12.5,1),(737,7522712,7522699,'tif',12.5,1),(737,7522713,7522699,'ifi',12.5,1),(737,7522714,7522699,'fie',12.5,1),(737,7522715,7522699,'ier',12.5,1),(737,7522716,7522708,'vdi',33.333,3),(737,7522717,7522708,'dis',33.333,3),(737,7522718,7522708,'isk',33.333,3),(737,7522719,7522716,'nam',50,1),(737,7522720,7522716,'ame',50,1),(737,7522721,7522719,'typ',50,1),(737,7522722,7522719,'ype',50,1),(737,7522723,7522721,'dir',25,1),(737,7522724,7522721,'ire',25,1),(737,7522725,7522721,'rec',25,1),(737,7522726,7522721,'ect',25,1),(738,7522728,7522727,'naa',100,2),(738,7522729,7522728,'600',3.333,3),(738,7522730,7522728,'000',3.333,3),(738,7522731,7522728,'00c',3.333,3),(738,7522732,7522728,'0c2',3.333,3),(738,7522733,7522728,'c29',3.333,3),(738,7522734,7522728,'29a',3.333,3),(738,7522735,7522728,'9a7',3.333,3),(738,7522736,7522728,'a77',3.333,3),(738,7522737,7522728,'77e',3.333,3),(738,7522738,7522728,'7e9',3.333,3),(738,7522739,7522728,'e9f',3.333,3),(738,7522740,7522728,'9fe',3.333,3),(738,7522741,7522728,'fea',3.333,3),(738,7522742,7522728,'ea9',3.333,3),(738,7522743,7522728,'a97',3.333,3),(738,7522744,7522728,'979',3.333,3),(738,7522745,7522728,'79e',3.333,3),(738,7522746,7522728,'9ee',3.333,3),(738,7522747,7522728,'ee0',3.333,3),(738,7522748,7522728,'e0e',3.333,3),(738,7522749,7522728,'0ee',3.333,3),(738,7522750,7522728,'ee8',3.333,3),(738,7522751,7522728,'e8e',3.333,3),(738,7522752,7522728,'8ee',3.333,3),(738,7522753,7522728,'ee6',3.333,3),(738,7522754,7522728,'e64',3.333,3),(738,7522755,7522728,'642',3.333,3),(738,7522756,7522728,'424',3.333,3),(738,7522757,7522728,'243',3.333,3),(738,7522758,7522728,'439',3.333,3),(738,7522759,7522729,'mon',100,1),(738,7522760,7522759,'201',50,1),(738,7522761,7522759,'013',50,1),(738,7522762,7522760,'adm',33.333,3),(738,7522763,7522760,'dmi',33.333,3),(738,7522764,7522760,'min',33.333,3),(738,7522765,7522762,'cap',16.667,1),(738,7522766,7522762,'apa',16.667,1),(738,7522767,7522762,'pac',16.667,1),(738,7522768,7522762,'aci',16.667,1),(738,7522769,7522762,'cit',16.667,1),(738,7522770,7522762,'ity',16.667,1),(738,7522771,7522765,'pat',50,1),(738,7522772,7522765,'ath',50,1),(738,7522773,7522771,'fre',14.286,1),(738,7522774,7522771,'ree',14.286,1),(738,7522775,7522771,'ees',14.286,1),(738,7522776,7522771,'esp',14.286,1),(738,7522777,7522771,'spa',14.286,1),(738,7522778,7522771,'pac',14.286,1),(738,7522779,7522771,'ace',14.286,1),(738,7522780,7522773,'dis',50,1),(738,7522781,7522773,'isk',50,1),(738,7522782,7522780,'ind',33.333,1),(738,7522783,7522780,'nde',33.333,1),(738,7522784,7522780,'dex',33.333,1),(738,7522785,7522782,'adm',8.333,1),(738,7522786,7522782,'dmi',8.333,1),(738,7522787,7522782,'min',8.333,1),(738,7522788,7522782,'ini',8.333,1),(738,7522789,7522782,'nis',8.333,1),(738,7522790,7522782,'ist',8.333,1),(738,7522791,7522782,'str',8.333,1),(738,7522792,7522782,'tra',8.333,1),(738,7522793,7522782,'rat',8.333,1),(738,7522794,7522782,'ati',8.333,1),(738,7522795,7522782,'tio',8.333,1),(738,7522796,7522782,'ion',8.333,1),(738,7522797,7522785,'sta',33.333,3),(738,7522798,7522785,'tat',33.333,3),(738,7522799,7522785,'ate',33.333,3),(738,7522800,7522797,'ena',20,2),(738,7522801,7522797,'nab',20,2),(738,7522802,7522797,'abl',20,2),(738,7522803,7522797,'ble',20,2),(738,7522804,7522797,'led',20,2),(738,7522805,7522800,'cac',33.333,2),(738,7522806,7522800,'ach',33.333,2),(738,7522807,7522800,'che',33.333,2),(738,7522808,7522805,'mod',50,1),(738,7522809,7522805,'ode',50,1),(738,7522810,7522808,'wri',14.286,1),(738,7522811,7522808,'rit',14.286,1),(738,7522812,7522808,'ite',14.286,1),(738,7522813,7522808,'tet',14.286,1),(738,7522814,7522808,'eth',14.286,1),(738,7522815,7522808,'thr',14.286,1),(738,7522816,7522808,'hru',14.286,1),(738,7522817,7522810,'ope',11.111,2),(738,7522818,7522810,'per',11.111,2),(738,7522819,7522810,'era',11.111,2),(738,7522820,7522810,'rat',11.111,2),(738,7522821,7522810,'ati',11.111,2),(738,7522822,7522810,'tio',11.111,2),(738,7522823,7522810,'ion',11.111,2),(738,7522824,7522810,'ona',11.111,2),(738,7522825,7522810,'nal',11.111,2),(738,7522826,7522817,'pen',20,1),(738,7522827,7522817,'end',20,1),(738,7522828,7522817,'ndi',20,1),(738,7522829,7522817,'din',20,1),(738,7522830,7522817,'ing',20,1),(738,7522831,7522826,'mes',20,1),(738,7522832,7522826,'ess',20,1),(738,7522833,7522826,'ssa',20,1),(738,7522834,7522826,'sag',20,1),(738,7522835,7522826,'age',20,1),(738,7522836,7522831,'wai',20,1),(738,7522837,7522831,'ait',20,1),(738,7522838,7522831,'iti',20,1),(738,7522839,7522831,'tin',20,1),(738,7522840,7522831,'ing',20,1),(738,7522841,7522836,'for',100,1),(738,7522842,7522841,'per',11.111,1),(738,7522843,7522841,'erf',11.111,1),(738,7522844,7522841,'rfo',11.111,1),(738,7522845,7522841,'for',11.111,1),(738,7522846,7522841,'orm',11.111,1),(738,7522847,7522841,'rma',11.111,1),(738,7522848,7522841,'man',11.111,1),(738,7522849,7522841,'anc',11.111,1),(738,7522850,7522841,'nce',11.111,1),(738,7522851,7522842,'ide',12.5,1),(738,7522852,7522842,'den',12.5,1),(738,7522853,7522842,'ent',12.5,1),(738,7522854,7522842,'nti',12.5,1),(738,7522855,7522842,'tif',12.5,1),(738,7522856,7522842,'ifi',12.5,1),(738,7522857,7522842,'fie',12.5,1),(738,7522858,7522842,'ier',12.5,1),(738,7522859,7522851,'vdi',33.333,3),(738,7522860,7522851,'dis',33.333,3),(738,7522861,7522851,'isk',33.333,3),(738,7522862,7522859,'nam',50,1),(738,7522863,7522859,'ame',50,1),(738,7522864,7522862,'typ',50,1),(738,7522865,7522862,'ype',50,1),(738,7522866,7522864,'dir',25,1),(738,7522867,7522864,'ire',25,1),(738,7522868,7522864,'rec',25,1),(738,7522869,7522864,'ect',25,1),(739,7522871,7522870,'naa',100,2),(739,7522872,7522871,'600',3.333,3),(739,7522873,7522871,'000',3.333,3),(739,7522874,7522871,'00c',3.333,3),(739,7522875,7522871,'0c2',3.333,3),(739,7522876,7522871,'c29',3.333,3),(739,7522877,7522871,'293',3.333,3),(739,7522878,7522871,'93c',3.333,3),(739,7522879,7522871,'3c7',3.333,3),(739,7522880,7522871,'c7c',3.333,3),(739,7522881,7522871,'7c1',3.333,3),(739,7522882,7522871,'c1d',3.333,3),(739,7522883,7522871,'1d8',3.333,3),(739,7522884,7522871,'d8b',3.333,3),(739,7522885,7522871,'8bd',3.333,3),(739,7522886,7522871,'bd8',3.333,3),(739,7522887,7522871,'d8a',3.333,3),(739,7522888,7522871,'8a0',3.333,3),(739,7522889,7522871,'a00',3.333,3),(739,7522890,7522871,'001',3.333,3),(739,7522891,7522871,'017',3.333,3),(739,7522892,7522871,'17c',3.333,3),(739,7522893,7522871,'7cd',3.333,3),(739,7522894,7522871,'cd4',3.333,3),(739,7522895,7522871,'d40',3.333,3),(739,7522896,7522871,'402',3.333,3),(739,7522897,7522871,'023',3.333,3),(739,7522898,7522871,'233',3.333,3),(739,7522899,7522871,'333',3.333,3),(739,7522900,7522871,'337',3.333,3),(739,7522901,7522871,'371',3.333,3),(739,7522902,7522872,'mon',100,1),(739,7522903,7522902,'201',50,1),(739,7522904,7522902,'013',50,1),(739,7522905,7522903,'adm',33.333,3),(739,7522906,7522903,'dmi',33.333,3),(739,7522907,7522903,'min',33.333,3),(739,7522908,7522905,'cap',16.667,1),(739,7522909,7522905,'apa',16.667,1),(739,7522910,7522905,'pac',16.667,1),(739,7522911,7522905,'aci',16.667,1),(739,7522912,7522905,'cit',16.667,1),(739,7522913,7522905,'ity',16.667,1),(739,7522914,7522908,'pat',50,1),(739,7522915,7522908,'ath',50,1),(739,7522916,7522914,'fre',14.286,1),(739,7522917,7522914,'ree',14.286,1),(739,7522918,7522914,'ees',14.286,1),(739,7522919,7522914,'esp',14.286,1),(739,7522920,7522914,'spa',14.286,1),(739,7522921,7522914,'pac',14.286,1),(739,7522922,7522914,'ace',14.286,1),(739,7522923,7522916,'dis',50,1),(739,7522924,7522916,'isk',50,1),(739,7522925,7522923,'ind',33.333,1),(739,7522926,7522923,'nde',33.333,1),(739,7522927,7522923,'dex',33.333,1),(739,7522928,7522925,'adm',8.333,1),(739,7522929,7522925,'dmi',8.333,1),(739,7522930,7522925,'min',8.333,1),(739,7522931,7522925,'ini',8.333,1),(739,7522932,7522925,'nis',8.333,1),(739,7522933,7522925,'ist',8.333,1),(739,7522934,7522925,'str',8.333,1),(739,7522935,7522925,'tra',8.333,1),(739,7522936,7522925,'rat',8.333,1),(739,7522937,7522925,'ati',8.333,1),(739,7522938,7522925,'tio',8.333,1),(739,7522939,7522925,'ion',8.333,1),(739,7522940,7522928,'sta',33.333,3),(739,7522941,7522928,'tat',33.333,3),(739,7522942,7522928,'ate',33.333,3),(739,7522943,7522940,'ena',20,2),(739,7522944,7522940,'nab',20,2),(739,7522945,7522940,'abl',20,2),(739,7522946,7522940,'ble',20,2),(739,7522947,7522940,'led',20,2),(739,7522948,7522943,'cac',33.333,2),(739,7522949,7522943,'ach',33.333,2),(739,7522950,7522943,'che',33.333,2),(739,7522951,7522948,'mod',50,1),(739,7522952,7522948,'ode',50,1),(739,7522953,7522951,'wri',14.286,1),(739,7522954,7522951,'rit',14.286,1),(739,7522955,7522951,'ite',14.286,1),(739,7522956,7522951,'tet',14.286,1),(739,7522957,7522951,'eth',14.286,1),(739,7522958,7522951,'thr',14.286,1),(739,7522959,7522951,'hru',14.286,1),(739,7522960,7522953,'ope',11.111,2),(739,7522961,7522953,'per',11.111,2),(739,7522962,7522953,'era',11.111,2),(739,7522963,7522953,'rat',11.111,2),(739,7522964,7522953,'ati',11.111,2),(739,7522965,7522953,'tio',11.111,2),(739,7522966,7522953,'ion',11.111,2),(739,7522967,7522953,'ona',11.111,2),(739,7522968,7522953,'nal',11.111,2),(739,7522969,7522960,'pen',20,1),(739,7522970,7522960,'end',20,1),(739,7522971,7522960,'ndi',20,1),(739,7522972,7522960,'din',20,1),(739,7522973,7522960,'ing',20,1),(739,7522974,7522969,'mes',20,1),(739,7522975,7522969,'ess',20,1),(739,7522976,7522969,'ssa',20,1),(739,7522977,7522969,'sag',20,1),(739,7522978,7522969,'age',20,1),(739,7522979,7522974,'wai',20,1),(739,7522980,7522974,'ait',20,1),(739,7522981,7522974,'iti',20,1),(739,7522982,7522974,'tin',20,1),(739,7522983,7522974,'ing',20,1),(739,7522984,7522979,'for',100,1),(739,7522985,7522984,'per',11.111,1),(739,7522986,7522984,'erf',11.111,1),(739,7522987,7522984,'rfo',11.111,1),(739,7522988,7522984,'for',11.111,1),(739,7522989,7522984,'orm',11.111,1),(739,7522990,7522984,'rma',11.111,1),(739,7522991,7522984,'man',11.111,1),(739,7522992,7522984,'anc',11.111,1),(739,7522993,7522984,'nce',11.111,1),(739,7522994,7522985,'ide',12.5,1),(739,7522995,7522985,'den',12.5,1),(739,7522996,7522985,'ent',12.5,1),(739,7522997,7522985,'nti',12.5,1),(739,7522998,7522985,'tif',12.5,1),(739,7522999,7522985,'ifi',12.5,1),(739,7523000,7522985,'fie',12.5,1),(739,7523001,7522985,'ier',12.5,1),(739,7523002,7522994,'vdi',33.333,3),(739,7523003,7522994,'dis',33.333,3),(739,7523004,7522994,'isk',33.333,3),(739,7523005,7523002,'nam',50,1),(739,7523006,7523002,'ame',50,1),(739,7523007,7523005,'typ',50,1),(739,7523008,7523005,'ype',50,1),(739,7523009,7523007,'dir',25,1),(739,7523010,7523007,'ire',25,1),(739,7523011,7523007,'rec',25,1),(739,7523012,7523007,'ect',25,1),(740,7523014,7523013,'naa',100,2),(740,7523015,7523014,'600',3.333,3),(740,7523016,7523014,'000',3.333,3),(740,7523017,7523014,'00c',3.333,3),(740,7523018,7523014,'0c2',3.333,3),(740,7523019,7523014,'c29',3.333,3),(740,7523020,7523014,'29b',3.333,3),(740,7523021,7523014,'9b3',3.333,3),(740,7523022,7523014,'b32',3.333,3),(740,7523023,7523014,'32b',3.333,3),(740,7523024,7523014,'2b4',3.333,3),(740,7523025,7523014,'b4b',3.333,3),(740,7523026,7523014,'4b9',3.333,3),(740,7523027,7523014,'b94',3.333,3),(740,7523028,7523014,'94b',3.333,3),(740,7523029,7523014,'4bb',3.333,3),(740,7523030,7523014,'bb6',3.333,3),(740,7523031,7523014,'b61',3.333,3),(740,7523032,7523014,'61d',3.333,3),(740,7523033,7523014,'1db',3.333,3),(740,7523034,7523014,'db4',3.333,3),(740,7523035,7523014,'b4f',3.333,3),(740,7523036,7523014,'4f0',3.333,3),(740,7523037,7523014,'f0f',3.333,3),(740,7523038,7523014,'0fd',3.333,3),(740,7523039,7523014,'fd1',3.333,3),(740,7523040,7523014,'d16',3.333,3),(740,7523041,7523014,'166',3.333,3),(740,7523042,7523014,'666',3.333,3),(740,7523043,7523014,'66c',3.333,3),(740,7523044,7523014,'6c7',3.333,3),(740,7523045,7523015,'mon',100,1),(740,7523046,7523045,'201',50,1),(740,7523047,7523045,'013',50,1),(740,7523048,7523046,'adm',33.333,3),(740,7523049,7523046,'dmi',33.333,3),(740,7523050,7523046,'min',33.333,3),(740,7523051,7523048,'cap',16.667,1),(740,7523052,7523048,'apa',16.667,1),(740,7523053,7523048,'pac',16.667,1),(740,7523054,7523048,'aci',16.667,1),(740,7523055,7523048,'cit',16.667,1),(740,7523056,7523048,'ity',16.667,1),(740,7523057,7523051,'pat',50,1),(740,7523058,7523051,'ath',50,1),(740,7523059,7523057,'fre',14.286,1),(740,7523060,7523057,'ree',14.286,1),(740,7523061,7523057,'ees',14.286,1),(740,7523062,7523057,'esp',14.286,1),(740,7523063,7523057,'spa',14.286,1),(740,7523064,7523057,'pac',14.286,1),(740,7523065,7523057,'ace',14.286,1),(740,7523066,7523059,'dis',50,1),(740,7523067,7523059,'isk',50,1),(740,7523068,7523066,'ind',33.333,1),(740,7523069,7523066,'nde',33.333,1),(740,7523070,7523066,'dex',33.333,1),(740,7523071,7523068,'adm',8.333,1),(740,7523072,7523068,'dmi',8.333,1),(740,7523073,7523068,'min',8.333,1),(740,7523074,7523068,'ini',8.333,1),(740,7523075,7523068,'nis',8.333,1),(740,7523076,7523068,'ist',8.333,1),(740,7523077,7523068,'str',8.333,1),(740,7523078,7523068,'tra',8.333,1),(740,7523079,7523068,'rat',8.333,1),(740,7523080,7523068,'ati',8.333,1),(740,7523081,7523068,'tio',8.333,1),(740,7523082,7523068,'ion',8.333,1),(740,7523083,7523071,'sta',33.333,3),(740,7523084,7523071,'tat',33.333,3),(740,7523085,7523071,'ate',33.333,3),(740,7523086,7523083,'ena',20,2),(740,7523087,7523083,'nab',20,2),(740,7523088,7523083,'abl',20,2),(740,7523089,7523083,'ble',20,2),(740,7523090,7523083,'led',20,2),(740,7523091,7523086,'cac',33.333,2),(740,7523092,7523086,'ach',33.333,2),(740,7523093,7523086,'che',33.333,2),(740,7523094,7523091,'mod',50,1),(740,7523095,7523091,'ode',50,1),(740,7523096,7523094,'wri',14.286,1),(740,7523097,7523094,'rit',14.286,1),(740,7523098,7523094,'ite',14.286,1),(740,7523099,7523094,'tet',14.286,1),(740,7523100,7523094,'eth',14.286,1),(740,7523101,7523094,'thr',14.286,1),(740,7523102,7523094,'hru',14.286,1),(740,7523103,7523096,'ope',11.111,2),(740,7523104,7523096,'per',11.111,2),(740,7523105,7523096,'era',11.111,2),(740,7523106,7523096,'rat',11.111,2),(740,7523107,7523096,'ati',11.111,2),(740,7523108,7523096,'tio',11.111,2),(740,7523109,7523096,'ion',11.111,2),(740,7523110,7523096,'ona',11.111,2),(740,7523111,7523096,'nal',11.111,2),(740,7523112,7523103,'pen',20,1),(740,7523113,7523103,'end',20,1),(740,7523114,7523103,'ndi',20,1),(740,7523115,7523103,'din',20,1),(740,7523116,7523103,'ing',20,1),(740,7523117,7523112,'mes',20,1),(740,7523118,7523112,'ess',20,1),(740,7523119,7523112,'ssa',20,1),(740,7523120,7523112,'sag',20,1),(740,7523121,7523112,'age',20,1),(740,7523122,7523117,'wai',20,1),(740,7523123,7523117,'ait',20,1),(740,7523124,7523117,'iti',20,1),(740,7523125,7523117,'tin',20,1),(740,7523126,7523117,'ing',20,1),(740,7523127,7523122,'for',100,1),(740,7523128,7523127,'per',11.111,1),(740,7523129,7523127,'erf',11.111,1),(740,7523130,7523127,'rfo',11.111,1),(740,7523131,7523127,'for',11.111,1),(740,7523132,7523127,'orm',11.111,1),(740,7523133,7523127,'rma',11.111,1),(740,7523134,7523127,'man',11.111,1),(740,7523135,7523127,'anc',11.111,1),(740,7523136,7523127,'nce',11.111,1),(740,7523137,7523128,'ide',12.5,1),(740,7523138,7523128,'den',12.5,1),(740,7523139,7523128,'ent',12.5,1),(740,7523140,7523128,'nti',12.5,1),(740,7523141,7523128,'tif',12.5,1),(740,7523142,7523128,'ifi',12.5,1),(740,7523143,7523128,'fie',12.5,1),(740,7523144,7523128,'ier',12.5,1),(740,7523145,7523137,'vdi',33.333,3),(740,7523146,7523137,'dis',33.333,3),(740,7523147,7523137,'isk',33.333,3),(740,7523148,7523145,'nam',50,1),(740,7523149,7523145,'ame',50,1),(740,7523150,7523148,'typ',50,1),(740,7523151,7523148,'ype',50,1),(740,7523152,7523150,'dir',25,1),(740,7523153,7523150,'ire',25,1),(740,7523154,7523150,'rec',25,1),(740,7523155,7523150,'ect',25,1),(741,7523157,7523156,'naa',100,2),(741,7523158,7523157,'600',3.333,3),(741,7523159,7523157,'000',3.333,3),(741,7523160,7523157,'00c',3.333,3),(741,7523161,7523157,'0c2',3.333,3),(741,7523162,7523157,'c29',3.333,3),(741,7523163,7523157,'29d',3.333,3),(741,7523164,7523157,'9d3',3.333,3),(741,7523165,7523157,'d31',3.333,3),(741,7523166,7523157,'31d',3.333,3),(741,7523167,7523157,'1d7',3.333,3),(741,7523168,7523157,'d70',3.333,3),(741,7523169,7523157,'701',3.333,3),(741,7523170,7523157,'019',3.333,3),(741,7523171,7523157,'190',3.333,3),(741,7523172,7523157,'90a',3.333,3),(741,7523173,7523157,'0a3',3.333,3),(741,7523174,7523157,'a36',3.333,3),(741,7523175,7523157,'36e',3.333,3),(741,7523176,7523157,'6e4',3.333,3),(741,7523177,7523157,'e41',3.333,3),(741,7523178,7523157,'419',3.333,3),(741,7523179,7523157,'192',3.333,3),(741,7523180,7523157,'924',3.333,3),(741,7523181,7523157,'24b',3.333,3),(741,7523182,7523157,'4bc',3.333,3),(741,7523183,7523157,'bce',3.333,3),(741,7523184,7523157,'ceb',3.333,3),(741,7523185,7523157,'ebc',3.333,3),(741,7523186,7523157,'bc8',3.333,3),(741,7523187,7523157,'c8f',3.333,3),(741,7523188,7523158,'mon',100,1),(741,7523189,7523188,'201',50,1),(741,7523190,7523188,'013',50,1),(741,7523191,7523189,'adm',33.333,3),(741,7523192,7523189,'dmi',33.333,3),(741,7523193,7523189,'min',33.333,3),(741,7523194,7523191,'cap',16.667,1),(741,7523195,7523191,'apa',16.667,1),(741,7523196,7523191,'pac',16.667,1),(741,7523197,7523191,'aci',16.667,1),(741,7523198,7523191,'cit',16.667,1),(741,7523199,7523191,'ity',16.667,1),(741,7523200,7523194,'pat',50,1),(741,7523201,7523194,'ath',50,1),(741,7523202,7523200,'fre',14.286,1),(741,7523203,7523200,'ree',14.286,1),(741,7523204,7523200,'ees',14.286,1),(741,7523205,7523200,'esp',14.286,1),(741,7523206,7523200,'spa',14.286,1),(741,7523207,7523200,'pac',14.286,1),(741,7523208,7523200,'ace',14.286,1),(741,7523209,7523202,'dis',50,1),(741,7523210,7523202,'isk',50,1),(741,7523211,7523209,'ind',33.333,1),(741,7523212,7523209,'nde',33.333,1),(741,7523213,7523209,'dex',33.333,1),(741,7523214,7523211,'adm',8.333,1),(741,7523215,7523211,'dmi',8.333,1),(741,7523216,7523211,'min',8.333,1),(741,7523217,7523211,'ini',8.333,1),(741,7523218,7523211,'nis',8.333,1),(741,7523219,7523211,'ist',8.333,1),(741,7523220,7523211,'str',8.333,1),(741,7523221,7523211,'tra',8.333,1),(741,7523222,7523211,'rat',8.333,1),(741,7523223,7523211,'ati',8.333,1),(741,7523224,7523211,'tio',8.333,1),(741,7523225,7523211,'ion',8.333,1),(741,7523226,7523214,'sta',33.333,3),(741,7523227,7523214,'tat',33.333,3),(741,7523228,7523214,'ate',33.333,3),(741,7523229,7523226,'ena',20,2),(741,7523230,7523226,'nab',20,2),(741,7523231,7523226,'abl',20,2),(741,7523232,7523226,'ble',20,2),(741,7523233,7523226,'led',20,2),(741,7523234,7523229,'cac',33.333,2),(741,7523235,7523229,'ach',33.333,2),(741,7523236,7523229,'che',33.333,2),(741,7523237,7523234,'mod',50,1),(741,7523238,7523234,'ode',50,1),(741,7523239,7523237,'wri',14.286,1),(741,7523240,7523237,'rit',14.286,1),(741,7523241,7523237,'ite',14.286,1),(741,7523242,7523237,'tet',14.286,1),(741,7523243,7523237,'eth',14.286,1),(741,7523244,7523237,'thr',14.286,1),(741,7523245,7523237,'hru',14.286,1),(741,7523246,7523239,'ope',11.111,2),(741,7523247,7523239,'per',11.111,2),(741,7523248,7523239,'era',11.111,2),(741,7523249,7523239,'rat',11.111,2),(741,7523250,7523239,'ati',11.111,2),(741,7523251,7523239,'tio',11.111,2),(741,7523252,7523239,'ion',11.111,2),(741,7523253,7523239,'ona',11.111,2),(741,7523254,7523239,'nal',11.111,2),(741,7523255,7523246,'pen',20,1),(741,7523256,7523246,'end',20,1),(741,7523257,7523246,'ndi',20,1),(741,7523258,7523246,'din',20,1),(741,7523259,7523246,'ing',20,1),(741,7523260,7523255,'mes',20,1),(741,7523261,7523255,'ess',20,1),(741,7523262,7523255,'ssa',20,1),(741,7523263,7523255,'sag',20,1),(741,7523264,7523255,'age',20,1),(741,7523265,7523260,'wai',20,1),(741,7523266,7523260,'ait',20,1),(741,7523267,7523260,'iti',20,1),(741,7523268,7523260,'tin',20,1),(741,7523269,7523260,'ing',20,1),(741,7523270,7523265,'for',100,1),(741,7523271,7523270,'per',11.111,1),(741,7523272,7523270,'erf',11.111,1),(741,7523273,7523270,'rfo',11.111,1),(741,7523274,7523270,'for',11.111,1),(741,7523275,7523270,'orm',11.111,1),(741,7523276,7523270,'rma',11.111,1),(741,7523277,7523270,'man',11.111,1),(741,7523278,7523270,'anc',11.111,1),(741,7523279,7523270,'nce',11.111,1),(741,7523280,7523271,'ide',12.5,1),(741,7523281,7523271,'den',12.5,1),(741,7523282,7523271,'ent',12.5,1),(741,7523283,7523271,'nti',12.5,1),(741,7523284,7523271,'tif',12.5,1),(741,7523285,7523271,'ifi',12.5,1),(741,7523286,7523271,'fie',12.5,1),(741,7523287,7523271,'ier',12.5,1),(741,7523288,7523280,'vdi',33.333,3),(741,7523289,7523280,'dis',33.333,3),(741,7523290,7523280,'isk',33.333,3),(741,7523291,7523288,'nam',50,1),(741,7523292,7523288,'ame',50,1),(741,7523293,7523291,'typ',50,1),(741,7523294,7523291,'ype',50,1),(741,7523295,7523293,'dir',25,1),(741,7523296,7523293,'ire',25,1),(741,7523297,7523293,'rec',25,1),(741,7523298,7523293,'ect',25,1),(742,7523300,7523299,'naa',100,2),(742,7523301,7523300,'600',3.333,3),(742,7523302,7523300,'000',3.333,3),(742,7523303,7523300,'00c',3.333,3),(742,7523304,7523300,'0c2',3.333,3),(742,7523305,7523300,'c29',3.333,3),(742,7523306,7523300,'295',3.333,3),(742,7523307,7523300,'95b',3.333,3),(742,7523308,7523300,'5bd',3.333,3),(742,7523309,7523300,'bd7',3.333,3),(742,7523310,7523300,'d71',3.333,3),(742,7523311,7523300,'71e',3.333,3),(742,7523312,7523300,'1ea',3.333,3),(742,7523313,7523300,'ea9',3.333,3),(742,7523314,7523300,'a93',3.333,3),(742,7523315,7523300,'930',3.333,3),(742,7523316,7523300,'302',3.333,3),(742,7523317,7523300,'024',3.333,3),(742,7523318,7523300,'240',3.333,3),(742,7523319,7523300,'404',3.333,3),(742,7523320,7523300,'042',3.333,3),(742,7523321,7523300,'422',3.333,3),(742,7523322,7523300,'223',3.333,3),(742,7523323,7523300,'23a',3.333,3),(742,7523324,7523300,'3ae',3.333,3),(742,7523325,7523300,'ae2',3.333,3),(742,7523326,7523300,'e29',3.333,3),(742,7523327,7523300,'299',3.333,3),(742,7523328,7523300,'99e',3.333,3),(742,7523329,7523300,'9e5',3.333,3),(742,7523330,7523300,'e52',3.333,3),(742,7523331,7523301,'mon',100,1),(742,7523332,7523331,'201',50,1),(742,7523333,7523331,'013',50,1),(742,7523334,7523332,'adm',33.333,3),(742,7523335,7523332,'dmi',33.333,3),(742,7523336,7523332,'min',33.333,3),(742,7523337,7523334,'cap',16.667,1),(742,7523338,7523334,'apa',16.667,1),(742,7523339,7523334,'pac',16.667,1),(742,7523340,7523334,'aci',16.667,1),(742,7523341,7523334,'cit',16.667,1),(742,7523342,7523334,'ity',16.667,1),(742,7523343,7523337,'pat',50,1),(742,7523344,7523337,'ath',50,1),(742,7523345,7523343,'fre',14.286,1),(742,7523346,7523343,'ree',14.286,1),(742,7523347,7523343,'ees',14.286,1),(742,7523348,7523343,'esp',14.286,1),(742,7523349,7523343,'spa',14.286,1),(742,7523350,7523343,'pac',14.286,1),(742,7523351,7523343,'ace',14.286,1),(742,7523352,7523345,'dis',50,1),(742,7523353,7523345,'isk',50,1),(742,7523354,7523352,'ind',33.333,1),(742,7523355,7523352,'nde',33.333,1),(742,7523356,7523352,'dex',33.333,1),(742,7523357,7523354,'adm',8.333,1),(742,7523358,7523354,'dmi',8.333,1),(742,7523359,7523354,'min',8.333,1),(742,7523360,7523354,'ini',8.333,1),(742,7523361,7523354,'nis',8.333,1),(742,7523362,7523354,'ist',8.333,1),(742,7523363,7523354,'str',8.333,1),(742,7523364,7523354,'tra',8.333,1),(742,7523365,7523354,'rat',8.333,1),(742,7523366,7523354,'ati',8.333,1),(742,7523367,7523354,'tio',8.333,1),(742,7523368,7523354,'ion',8.333,1),(742,7523369,7523357,'sta',33.333,3),(742,7523370,7523357,'tat',33.333,3),(742,7523371,7523357,'ate',33.333,3),(742,7523372,7523369,'ena',20,2),(742,7523373,7523369,'nab',20,2),(742,7523374,7523369,'abl',20,2),(742,7523375,7523369,'ble',20,2),(742,7523376,7523369,'led',20,2),(742,7523377,7523372,'cac',33.333,2),(742,7523378,7523372,'ach',33.333,2),(742,7523379,7523372,'che',33.333,2),(742,7523380,7523377,'mod',50,1),(742,7523381,7523377,'ode',50,1),(742,7523382,7523380,'wri',14.286,1),(742,7523383,7523380,'rit',14.286,1),(742,7523384,7523380,'ite',14.286,1),(742,7523385,7523380,'tet',14.286,1),(742,7523386,7523380,'eth',14.286,1),(742,7523387,7523380,'thr',14.286,1),(742,7523388,7523380,'hru',14.286,1),(742,7523389,7523382,'ope',11.111,2),(742,7523390,7523382,'per',11.111,2),(742,7523391,7523382,'era',11.111,2),(742,7523392,7523382,'rat',11.111,2),(742,7523393,7523382,'ati',11.111,2),(742,7523394,7523382,'tio',11.111,2),(742,7523395,7523382,'ion',11.111,2),(742,7523396,7523382,'ona',11.111,2),(742,7523397,7523382,'nal',11.111,2),(742,7523398,7523389,'pen',20,1),(742,7523399,7523389,'end',20,1),(742,7523400,7523389,'ndi',20,1),(742,7523401,7523389,'din',20,1),(742,7523402,7523389,'ing',20,1),(742,7523403,7523398,'mes',20,1),(742,7523404,7523398,'ess',20,1),(742,7523405,7523398,'ssa',20,1),(742,7523406,7523398,'sag',20,1),(742,7523407,7523398,'age',20,1),(742,7523408,7523403,'wai',20,1),(742,7523409,7523403,'ait',20,1),(742,7523410,7523403,'iti',20,1),(742,7523411,7523403,'tin',20,1),(742,7523412,7523403,'ing',20,1),(742,7523413,7523408,'for',100,1),(742,7523414,7523413,'per',11.111,1),(742,7523415,7523413,'erf',11.111,1),(742,7523416,7523413,'rfo',11.111,1),(742,7523417,7523413,'for',11.111,1),(742,7523418,7523413,'orm',11.111,1),(742,7523419,7523413,'rma',11.111,1),(742,7523420,7523413,'man',11.111,1),(742,7523421,7523413,'anc',11.111,1),(742,7523422,7523413,'nce',11.111,1),(742,7523423,7523414,'ide',12.5,1),(742,7523424,7523414,'den',12.5,1),(742,7523425,7523414,'ent',12.5,1),(742,7523426,7523414,'nti',12.5,1),(742,7523427,7523414,'tif',12.5,1),(742,7523428,7523414,'ifi',12.5,1),(742,7523429,7523414,'fie',12.5,1),(742,7523430,7523414,'ier',12.5,1),(742,7523431,7523423,'vdi',33.333,3),(742,7523432,7523423,'dis',33.333,3),(742,7523433,7523423,'isk',33.333,3),(742,7523434,7523431,'nam',50,1),(742,7523435,7523431,'ame',50,1),(742,7523436,7523434,'typ',50,1),(742,7523437,7523434,'ype',50,1),(742,7523438,7523436,'dir',25,1),(742,7523439,7523436,'ire',25,1),(742,7523440,7523436,'rec',25,1),(742,7523441,7523436,'ect',25,1),(743,7523443,7523442,'naa',100,2),(743,7523444,7523443,'600',3.333,3),(743,7523445,7523443,'000',3.333,3),(743,7523446,7523443,'00c',3.333,3),(743,7523447,7523443,'0c2',3.333,3),(743,7523448,7523443,'c29',3.333,3),(743,7523449,7523443,'297',3.333,3),(743,7523450,7523443,'974',3.333,3),(743,7523451,7523443,'743',3.333,3),(743,7523452,7523443,'433',3.333,3),(743,7523453,7523443,'337',3.333,3),(743,7523454,7523443,'377',3.333,3),(743,7523455,7523443,'77a',3.333,3),(743,7523456,7523443,'7ae',3.333,3),(743,7523457,7523443,'ae4',3.333,3),(743,7523458,7523443,'e4f',3.333,3),(743,7523459,7523443,'4f0',3.333,3),(743,7523460,7523443,'f0c',3.333,3),(743,7523461,7523443,'0c1',3.333,3),(743,7523462,7523443,'c10',3.333,3),(743,7523463,7523443,'103',3.333,3),(743,7523464,7523443,'03a',3.333,3),(743,7523465,7523443,'3a1',3.333,3),(743,7523466,7523443,'a18',3.333,3),(743,7523467,7523443,'18d',3.333,3),(743,7523468,7523443,'8da',3.333,3),(743,7523469,7523443,'da8',3.333,3),(743,7523470,7523443,'a88',3.333,3),(743,7523471,7523443,'881',3.333,3),(743,7523472,7523443,'816',3.333,3),(743,7523473,7523443,'16e',3.333,3),(743,7523474,7523444,'mon',100,1),(743,7523475,7523474,'201',50,1),(743,7523476,7523474,'013',50,1),(743,7523477,7523475,'adm',33.333,3),(743,7523478,7523475,'dmi',33.333,3),(743,7523479,7523475,'min',33.333,3),(743,7523480,7523477,'cap',16.667,1),(743,7523481,7523477,'apa',16.667,1),(743,7523482,7523477,'pac',16.667,1),(743,7523483,7523477,'aci',16.667,1),(743,7523484,7523477,'cit',16.667,1),(743,7523485,7523477,'ity',16.667,1),(743,7523486,7523480,'pat',50,1),(743,7523487,7523480,'ath',50,1),(743,7523488,7523486,'fre',14.286,1),(743,7523489,7523486,'ree',14.286,1),(743,7523490,7523486,'ees',14.286,1),(743,7523491,7523486,'esp',14.286,1),(743,7523492,7523486,'spa',14.286,1),(743,7523493,7523486,'pac',14.286,1),(743,7523494,7523486,'ace',14.286,1),(743,7523495,7523488,'dis',50,1),(743,7523496,7523488,'isk',50,1),(743,7523497,7523495,'ind',33.333,1),(743,7523498,7523495,'nde',33.333,1),(743,7523499,7523495,'dex',33.333,1),(743,7523500,7523497,'adm',8.333,1),(743,7523501,7523497,'dmi',8.333,1),(743,7523502,7523497,'min',8.333,1),(743,7523503,7523497,'ini',8.333,1),(743,7523504,7523497,'nis',8.333,1),(743,7523505,7523497,'ist',8.333,1),(743,7523506,7523497,'str',8.333,1),(743,7523507,7523497,'tra',8.333,1),(743,7523508,7523497,'rat',8.333,1),(743,7523509,7523497,'ati',8.333,1),(743,7523510,7523497,'tio',8.333,1),(743,7523511,7523497,'ion',8.333,1),(743,7523512,7523500,'sta',33.333,3),(743,7523513,7523500,'tat',33.333,3),(743,7523514,7523500,'ate',33.333,3),(743,7523515,7523512,'ena',20,2),(743,7523516,7523512,'nab',20,2),(743,7523517,7523512,'abl',20,2),(743,7523518,7523512,'ble',20,2),(743,7523519,7523512,'led',20,2),(743,7523520,7523515,'cac',33.333,2),(743,7523521,7523515,'ach',33.333,2),(743,7523522,7523515,'che',33.333,2),(743,7523523,7523520,'mod',50,1),(743,7523524,7523520,'ode',50,1),(743,7523525,7523523,'wri',14.286,1),(743,7523526,7523523,'rit',14.286,1),(743,7523527,7523523,'ite',14.286,1),(743,7523528,7523523,'tet',14.286,1),(743,7523529,7523523,'eth',14.286,1),(743,7523530,7523523,'thr',14.286,1),(743,7523531,7523523,'hru',14.286,1),(743,7523532,7523525,'ope',11.111,2),(743,7523533,7523525,'per',11.111,2),(743,7523534,7523525,'era',11.111,2),(743,7523535,7523525,'rat',11.111,2),(743,7523536,7523525,'ati',11.111,2),(743,7523537,7523525,'tio',11.111,2),(743,7523538,7523525,'ion',11.111,2),(743,7523539,7523525,'ona',11.111,2),(743,7523540,7523525,'nal',11.111,2),(743,7523541,7523532,'pen',20,1),(743,7523542,7523532,'end',20,1),(743,7523543,7523532,'ndi',20,1),(743,7523544,7523532,'din',20,1),(743,7523545,7523532,'ing',20,1),(743,7523546,7523541,'mes',20,1),(743,7523547,7523541,'ess',20,1),(743,7523548,7523541,'ssa',20,1),(743,7523549,7523541,'sag',20,1),(743,7523550,7523541,'age',20,1),(743,7523551,7523546,'wai',20,1),(743,7523552,7523546,'ait',20,1),(743,7523553,7523546,'iti',20,1),(743,7523554,7523546,'tin',20,1),(743,7523555,7523546,'ing',20,1),(743,7523556,7523551,'for',100,1),(743,7523557,7523556,'per',11.111,1),(743,7523558,7523556,'erf',11.111,1),(743,7523559,7523556,'rfo',11.111,1),(743,7523560,7523556,'for',11.111,1),(743,7523561,7523556,'orm',11.111,1),(743,7523562,7523556,'rma',11.111,1),(743,7523563,7523556,'man',11.111,1),(743,7523564,7523556,'anc',11.111,1),(743,7523565,7523556,'nce',11.111,1),(743,7523566,7523557,'ide',12.5,1),(743,7523567,7523557,'den',12.5,1),(743,7523568,7523557,'ent',12.5,1),(743,7523569,7523557,'nti',12.5,1),(743,7523570,7523557,'tif',12.5,1),(743,7523571,7523557,'ifi',12.5,1),(743,7523572,7523557,'fie',12.5,1),(743,7523573,7523557,'ier',12.5,1),(743,7523574,7523566,'vdi',33.333,3),(743,7523575,7523566,'dis',33.333,3),(743,7523576,7523566,'isk',33.333,3),(743,7523577,7523574,'nam',50,1),(743,7523578,7523574,'ame',50,1),(743,7523579,7523577,'typ',50,1),(743,7523580,7523577,'ype',50,1),(743,7523581,7523579,'dir',25,1),(743,7523582,7523579,'ire',25,1),(743,7523583,7523579,'rec',25,1),(743,7523584,7523579,'ect',25,1),(744,7523586,7523585,'naa',100,2),(744,7523587,7523586,'600',3.333,3),(744,7523588,7523586,'000',3.333,3),(744,7523589,7523586,'00c',3.333,3),(744,7523590,7523586,'0c2',3.333,3),(744,7523591,7523586,'c29',3.333,3),(744,7523592,7523586,'298',3.333,3),(744,7523593,7523586,'98d',3.333,3),(744,7523594,7523586,'8d6',3.333,3),(744,7523595,7523586,'d67',3.333,3),(744,7523596,7523586,'673',3.333,3),(744,7523597,7523586,'733',3.333,3),(744,7523598,7523586,'331',3.333,3),(744,7523599,7523586,'31d',3.333,3),(744,7523600,7523586,'1d3',3.333,3),(744,7523601,7523586,'d38',3.333,3),(744,7523602,7523586,'38e',3.333,3),(744,7523603,7523586,'8e6',3.333,3),(744,7523604,7523586,'e6b',3.333,3),(744,7523605,7523586,'6b9',3.333,3),(744,7523606,7523586,'b9f',3.333,3),(744,7523607,7523586,'9fb',3.333,3),(744,7523608,7523586,'fb1',3.333,3),(744,7523609,7523586,'b12',3.333,3),(744,7523610,7523586,'12c',3.333,3),(744,7523611,7523586,'2cd',3.333,3),(744,7523612,7523586,'cd3',3.333,3),(744,7523613,7523586,'d32',3.333,3),(744,7523614,7523586,'32f',3.333,3),(744,7523615,7523586,'2fa',3.333,3),(744,7523616,7523586,'fa1',3.333,3),(744,7523617,7523587,'mon',100,1),(744,7523618,7523617,'201',50,1),(744,7523619,7523617,'013',50,1),(744,7523620,7523618,'adm',33.333,3),(744,7523621,7523618,'dmi',33.333,3),(744,7523622,7523618,'min',33.333,3),(744,7523623,7523620,'cap',16.667,1),(744,7523624,7523620,'apa',16.667,1),(744,7523625,7523620,'pac',16.667,1),(744,7523626,7523620,'aci',16.667,1),(744,7523627,7523620,'cit',16.667,1),(744,7523628,7523620,'ity',16.667,1),(744,7523629,7523623,'pat',50,1),(744,7523630,7523623,'ath',50,1),(744,7523631,7523629,'fre',14.286,1),(744,7523632,7523629,'ree',14.286,1),(744,7523633,7523629,'ees',14.286,1),(744,7523634,7523629,'esp',14.286,1),(744,7523635,7523629,'spa',14.286,1),(744,7523636,7523629,'pac',14.286,1),(744,7523637,7523629,'ace',14.286,1),(744,7523638,7523631,'dis',50,1),(744,7523639,7523631,'isk',50,1),(744,7523640,7523638,'ind',33.333,1),(744,7523641,7523638,'nde',33.333,1),(744,7523642,7523638,'dex',33.333,1),(744,7523643,7523640,'adm',8.333,1),(744,7523644,7523640,'dmi',8.333,1),(744,7523645,7523640,'min',8.333,1),(744,7523646,7523640,'ini',8.333,1),(744,7523647,7523640,'nis',8.333,1),(744,7523648,7523640,'ist',8.333,1),(744,7523649,7523640,'str',8.333,1),(744,7523650,7523640,'tra',8.333,1),(744,7523651,7523640,'rat',8.333,1),(744,7523652,7523640,'ati',8.333,1),(744,7523653,7523640,'tio',8.333,1),(744,7523654,7523640,'ion',8.333,1),(744,7523655,7523643,'sta',33.333,3),(744,7523656,7523643,'tat',33.333,3),(744,7523657,7523643,'ate',33.333,3),(744,7523658,7523655,'ena',20,2),(744,7523659,7523655,'nab',20,2),(744,7523660,7523655,'abl',20,2),(744,7523661,7523655,'ble',20,2),(744,7523662,7523655,'led',20,2),(744,7523663,7523658,'cac',33.333,2),(744,7523664,7523658,'ach',33.333,2),(744,7523665,7523658,'che',33.333,2),(744,7523666,7523663,'mod',50,1),(744,7523667,7523663,'ode',50,1),(744,7523668,7523666,'wri',14.286,1),(744,7523669,7523666,'rit',14.286,1),(744,7523670,7523666,'ite',14.286,1),(744,7523671,7523666,'tet',14.286,1),(744,7523672,7523666,'eth',14.286,1),(744,7523673,7523666,'thr',14.286,1),(744,7523674,7523666,'hru',14.286,1),(744,7523675,7523668,'ope',11.111,2),(744,7523676,7523668,'per',11.111,2),(744,7523677,7523668,'era',11.111,2),(744,7523678,7523668,'rat',11.111,2),(744,7523679,7523668,'ati',11.111,2),(744,7523680,7523668,'tio',11.111,2),(744,7523681,7523668,'ion',11.111,2),(744,7523682,7523668,'ona',11.111,2),(744,7523683,7523668,'nal',11.111,2),(744,7523684,7523675,'pen',20,1),(744,7523685,7523675,'end',20,1),(744,7523686,7523675,'ndi',20,1),(744,7523687,7523675,'din',20,1),(744,7523688,7523675,'ing',20,1),(744,7523689,7523684,'mes',20,1),(744,7523690,7523684,'ess',20,1),(744,7523691,7523684,'ssa',20,1),(744,7523692,7523684,'sag',20,1),(744,7523693,7523684,'age',20,1),(744,7523694,7523689,'wai',20,1),(744,7523695,7523689,'ait',20,1),(744,7523696,7523689,'iti',20,1),(744,7523697,7523689,'tin',20,1),(744,7523698,7523689,'ing',20,1),(744,7523699,7523694,'for',100,1),(744,7523700,7523699,'per',11.111,1),(744,7523701,7523699,'erf',11.111,1),(744,7523702,7523699,'rfo',11.111,1),(744,7523703,7523699,'for',11.111,1),(744,7523704,7523699,'orm',11.111,1),(744,7523705,7523699,'rma',11.111,1),(744,7523706,7523699,'man',11.111,1),(744,7523707,7523699,'anc',11.111,1),(744,7523708,7523699,'nce',11.111,1),(744,7523709,7523700,'ide',12.5,1),(744,7523710,7523700,'den',12.5,1),(744,7523711,7523700,'ent',12.5,1),(744,7523712,7523700,'nti',12.5,1),(744,7523713,7523700,'tif',12.5,1),(744,7523714,7523700,'ifi',12.5,1),(744,7523715,7523700,'fie',12.5,1),(744,7523716,7523700,'ier',12.5,1),(744,7523717,7523709,'vdi',33.333,3),(744,7523718,7523709,'dis',33.333,3),(744,7523719,7523709,'isk',33.333,3),(744,7523720,7523717,'nam',50,1),(744,7523721,7523717,'ame',50,1),(744,7523722,7523720,'typ',50,1),(744,7523723,7523720,'ype',50,1),(744,7523724,7523722,'dir',25,1),(744,7523725,7523722,'ire',25,1),(744,7523726,7523722,'rec',25,1),(744,7523727,7523722,'ect',25,1),(745,7523729,7523728,'naa',100,2),(745,7523730,7523729,'600',3.333,3),(745,7523731,7523729,'000',3.333,3),(745,7523732,7523729,'00c',3.333,3),(745,7523733,7523729,'0c2',3.333,3),(745,7523734,7523729,'c29',3.333,3),(745,7523735,7523729,'29e',3.333,3),(745,7523736,7523729,'9e6',3.333,3),(745,7523737,7523729,'e62',3.333,3),(745,7523738,7523729,'625',3.333,3),(745,7523739,7523729,'253',3.333,3),(745,7523740,7523729,'530',3.333,3),(745,7523741,7523729,'30d',3.333,3),(745,7523742,7523729,'0df',3.333,3),(745,7523743,7523729,'df2',3.333,3),(745,7523744,7523729,'f24',3.333,3),(745,7523745,7523729,'24d',3.333,3),(745,7523746,7523729,'4de',3.333,3),(745,7523747,7523729,'def',3.333,3),(745,7523748,7523729,'efa',3.333,3),(745,7523749,7523729,'fa1',3.333,3),(745,7523750,7523729,'a1a',3.333,3),(745,7523751,7523729,'1a2',3.333,3),(745,7523752,7523729,'a28',3.333,3),(745,7523753,7523729,'28f',3.333,3),(745,7523754,7523729,'8fe',3.333,3),(745,7523755,7523729,'fed',3.333,3),(745,7523756,7523729,'ed1',3.333,3),(745,7523757,7523729,'d12',3.333,3),(745,7523758,7523729,'124',3.333,3),(745,7523759,7523729,'24c',3.333,3),(745,7523760,7523730,'mon',100,1),(745,7523761,7523760,'201',50,1),(745,7523762,7523760,'013',50,1),(745,7523763,7523761,'adm',33.333,3),(745,7523764,7523761,'dmi',33.333,3),(745,7523765,7523761,'min',33.333,3),(745,7523766,7523763,'cap',16.667,1),(745,7523767,7523763,'apa',16.667,1),(745,7523768,7523763,'pac',16.667,1),(745,7523769,7523763,'aci',16.667,1),(745,7523770,7523763,'cit',16.667,1),(745,7523771,7523763,'ity',16.667,1),(745,7523772,7523766,'pat',50,1),(745,7523773,7523766,'ath',50,1),(745,7523774,7523772,'fre',14.286,1),(745,7523775,7523772,'ree',14.286,1),(745,7523776,7523772,'ees',14.286,1),(745,7523777,7523772,'esp',14.286,1),(745,7523778,7523772,'spa',14.286,1),(745,7523779,7523772,'pac',14.286,1),(745,7523780,7523772,'ace',14.286,1),(745,7523781,7523774,'dis',50,1),(745,7523782,7523774,'isk',50,1),(745,7523783,7523781,'ind',33.333,1),(745,7523784,7523781,'nde',33.333,1),(745,7523785,7523781,'dex',33.333,1),(745,7523786,7523783,'adm',8.333,1),(745,7523787,7523783,'dmi',8.333,1),(745,7523788,7523783,'min',8.333,1),(745,7523789,7523783,'ini',8.333,1),(745,7523790,7523783,'nis',8.333,1),(745,7523791,7523783,'ist',8.333,1),(745,7523792,7523783,'str',8.333,1),(745,7523793,7523783,'tra',8.333,1),(745,7523794,7523783,'rat',8.333,1),(745,7523795,7523783,'ati',8.333,1),(745,7523796,7523783,'tio',8.333,1),(745,7523797,7523783,'ion',8.333,1),(745,7523798,7523786,'sta',33.333,3),(745,7523799,7523786,'tat',33.333,3),(745,7523800,7523786,'ate',33.333,3),(745,7523801,7523798,'ena',20,2),(745,7523802,7523798,'nab',20,2),(745,7523803,7523798,'abl',20,2),(745,7523804,7523798,'ble',20,2),(745,7523805,7523798,'led',20,2),(745,7523806,7523801,'cac',33.333,2),(745,7523807,7523801,'ach',33.333,2),(745,7523808,7523801,'che',33.333,2),(745,7523809,7523806,'mod',50,1),(745,7523810,7523806,'ode',50,1),(745,7523811,7523809,'wri',14.286,1),(745,7523812,7523809,'rit',14.286,1),(745,7523813,7523809,'ite',14.286,1),(745,7523814,7523809,'tet',14.286,1),(745,7523815,7523809,'eth',14.286,1),(745,7523816,7523809,'thr',14.286,1),(745,7523817,7523809,'hru',14.286,1),(745,7523818,7523811,'ope',11.111,2),(745,7523819,7523811,'per',11.111,2),(745,7523820,7523811,'era',11.111,2),(745,7523821,7523811,'rat',11.111,2),(745,7523822,7523811,'ati',11.111,2),(745,7523823,7523811,'tio',11.111,2),(745,7523824,7523811,'ion',11.111,2),(745,7523825,7523811,'ona',11.111,2),(745,7523826,7523811,'nal',11.111,2),(745,7523827,7523818,'pen',20,1),(745,7523828,7523818,'end',20,1),(745,7523829,7523818,'ndi',20,1),(745,7523830,7523818,'din',20,1),(745,7523831,7523818,'ing',20,1),(745,7523832,7523827,'mes',20,1),(745,7523833,7523827,'ess',20,1),(745,7523834,7523827,'ssa',20,1),(745,7523835,7523827,'sag',20,1),(745,7523836,7523827,'age',20,1),(745,7523837,7523832,'wai',20,1),(745,7523838,7523832,'ait',20,1),(745,7523839,7523832,'iti',20,1),(745,7523840,7523832,'tin',20,1),(745,7523841,7523832,'ing',20,1),(745,7523842,7523837,'for',100,1),(745,7523843,7523842,'per',11.111,1),(745,7523844,7523842,'erf',11.111,1),(745,7523845,7523842,'rfo',11.111,1),(745,7523846,7523842,'for',11.111,1),(745,7523847,7523842,'orm',11.111,1),(745,7523848,7523842,'rma',11.111,1),(745,7523849,7523842,'man',11.111,1),(745,7523850,7523842,'anc',11.111,1),(745,7523851,7523842,'nce',11.111,1),(745,7523852,7523843,'ide',12.5,1),(745,7523853,7523843,'den',12.5,1),(745,7523854,7523843,'ent',12.5,1),(745,7523855,7523843,'nti',12.5,1),(745,7523856,7523843,'tif',12.5,1),(745,7523857,7523843,'ifi',12.5,1),(745,7523858,7523843,'fie',12.5,1),(745,7523859,7523843,'ier',12.5,1),(745,7523860,7523852,'vdi',33.333,3),(745,7523861,7523852,'dis',33.333,3),(745,7523862,7523852,'isk',33.333,3),(745,7523863,7523860,'nam',50,1),(745,7523864,7523860,'ame',50,1),(745,7523865,7523863,'typ',50,1),(745,7523866,7523863,'ype',50,1),(745,7523867,7523865,'dir',25,1),(745,7523868,7523865,'ire',25,1),(745,7523869,7523865,'rec',25,1),(745,7523870,7523865,'ect',25,1),(746,7523872,7523871,'naa',100,2),(746,7523873,7523872,'600',3.333,3),(746,7523874,7523872,'000',3.333,3),(746,7523875,7523872,'00c',3.333,3),(746,7523876,7523872,'0c2',3.333,3),(746,7523877,7523872,'c29',3.333,3),(746,7523878,7523872,'299',3.333,3),(746,7523879,7523872,'993',3.333,3),(746,7523880,7523872,'931',3.333,3),(746,7523881,7523872,'316',3.333,3),(746,7523882,7523872,'166',3.333,3),(746,7523883,7523872,'663',3.333,3),(746,7523884,7523872,'63a',3.333,3),(746,7523885,7523872,'3a5',3.333,3),(746,7523886,7523872,'a51',3.333,3),(746,7523887,7523872,'51a',3.333,3),(746,7523888,7523872,'1a1',3.333,3),(746,7523889,7523872,'a17',3.333,3),(746,7523890,7523872,'171',3.333,3),(746,7523891,7523872,'710',3.333,3),(746,7523892,7523872,'102',3.333,3),(746,7523893,7523872,'021',3.333,3),(746,7523894,7523872,'210',3.333,3),(746,7523895,7523872,'109',3.333,3),(746,7523896,7523872,'098',3.333,3),(746,7523897,7523872,'98e',3.333,3),(746,7523898,7523872,'8ec',3.333,3),(746,7523899,7523872,'ecb',3.333,3),(746,7523900,7523872,'cb1',3.333,3),(746,7523901,7523872,'b12',3.333,3),(746,7523902,7523872,'12b',3.333,3),(746,7523903,7523873,'mon',100,1),(746,7523904,7523903,'201',50,1),(746,7523905,7523903,'013',50,1),(746,7523906,7523904,'adm',33.333,3),(746,7523907,7523904,'dmi',33.333,3),(746,7523908,7523904,'min',33.333,3),(746,7523909,7523906,'cap',16.667,1),(746,7523910,7523906,'apa',16.667,1),(746,7523911,7523906,'pac',16.667,1),(746,7523912,7523906,'aci',16.667,1),(746,7523913,7523906,'cit',16.667,1),(746,7523914,7523906,'ity',16.667,1),(746,7523915,7523909,'pat',50,1),(746,7523916,7523909,'ath',50,1),(746,7523917,7523915,'fre',14.286,1),(746,7523918,7523915,'ree',14.286,1),(746,7523919,7523915,'ees',14.286,1),(746,7523920,7523915,'esp',14.286,1),(746,7523921,7523915,'spa',14.286,1),(746,7523922,7523915,'pac',14.286,1),(746,7523923,7523915,'ace',14.286,1),(746,7523924,7523917,'dis',50,1),(746,7523925,7523917,'isk',50,1),(746,7523926,7523924,'ind',33.333,1),(746,7523927,7523924,'nde',33.333,1),(746,7523928,7523924,'dex',33.333,1),(746,7523929,7523926,'adm',8.333,1),(746,7523930,7523926,'dmi',8.333,1),(746,7523931,7523926,'min',8.333,1),(746,7523932,7523926,'ini',8.333,1),(746,7523933,7523926,'nis',8.333,1),(746,7523934,7523926,'ist',8.333,1),(746,7523935,7523926,'str',8.333,1),(746,7523936,7523926,'tra',8.333,1),(746,7523937,7523926,'rat',8.333,1),(746,7523938,7523926,'ati',8.333,1),(746,7523939,7523926,'tio',8.333,1),(746,7523940,7523926,'ion',8.333,1),(746,7523941,7523929,'sta',33.333,3),(746,7523942,7523929,'tat',33.333,3),(746,7523943,7523929,'ate',33.333,3),(746,7523944,7523941,'ena',20,2),(746,7523945,7523941,'nab',20,2),(746,7523946,7523941,'abl',20,2),(746,7523947,7523941,'ble',20,2),(746,7523948,7523941,'led',20,2),(746,7523949,7523944,'cac',33.333,2),(746,7523950,7523944,'ach',33.333,2),(746,7523951,7523944,'che',33.333,2),(746,7523952,7523949,'mod',50,1),(746,7523953,7523949,'ode',50,1),(746,7523954,7523952,'wri',14.286,1),(746,7523955,7523952,'rit',14.286,1),(746,7523956,7523952,'ite',14.286,1),(746,7523957,7523952,'tet',14.286,1),(746,7523958,7523952,'eth',14.286,1),(746,7523959,7523952,'thr',14.286,1),(746,7523960,7523952,'hru',14.286,1),(746,7523961,7523954,'ope',11.111,2),(746,7523962,7523954,'per',11.111,2),(746,7523963,7523954,'era',11.111,2),(746,7523964,7523954,'rat',11.111,2),(746,7523965,7523954,'ati',11.111,2),(746,7523966,7523954,'tio',11.111,2),(746,7523967,7523954,'ion',11.111,2),(746,7523968,7523954,'ona',11.111,2),(746,7523969,7523954,'nal',11.111,2),(746,7523970,7523961,'pen',20,1),(746,7523971,7523961,'end',20,1),(746,7523972,7523961,'ndi',20,1),(746,7523973,7523961,'din',20,1),(746,7523974,7523961,'ing',20,1),(746,7523975,7523970,'mes',20,1),(746,7523976,7523970,'ess',20,1),(746,7523977,7523970,'ssa',20,1),(746,7523978,7523970,'sag',20,1),(746,7523979,7523970,'age',20,1),(746,7523980,7523975,'wai',20,1),(746,7523981,7523975,'ait',20,1),(746,7523982,7523975,'iti',20,1),(746,7523983,7523975,'tin',20,1),(746,7523984,7523975,'ing',20,1),(746,7523985,7523980,'for',100,1),(746,7523986,7523985,'per',11.111,1),(746,7523987,7523985,'erf',11.111,1),(746,7523988,7523985,'rfo',11.111,1),(746,7523989,7523985,'for',11.111,1),(746,7523990,7523985,'orm',11.111,1),(746,7523991,7523985,'rma',11.111,1),(746,7523992,7523985,'man',11.111,1),(746,7523993,7523985,'anc',11.111,1),(746,7523994,7523985,'nce',11.111,1),(746,7523995,7523986,'ide',12.5,1),(746,7523996,7523986,'den',12.5,1),(746,7523997,7523986,'ent',12.5,1),(746,7523998,7523986,'nti',12.5,1),(746,7523999,7523986,'tif',12.5,1),(746,7524000,7523986,'ifi',12.5,1),(746,7524001,7523986,'fie',12.5,1),(746,7524002,7523986,'ier',12.5,1),(746,7524003,7523995,'vdi',33.333,3),(746,7524004,7523995,'dis',33.333,3),(746,7524005,7523995,'isk',33.333,3),(746,7524006,7524003,'nam',50,1),(746,7524007,7524003,'ame',50,1),(746,7524008,7524006,'typ',50,1),(746,7524009,7524006,'ype',50,1),(746,7524010,7524008,'dir',25,1),(746,7524011,7524008,'ire',25,1),(746,7524012,7524008,'rec',25,1),(746,7524013,7524008,'ect',25,1),(747,7524015,7524014,'naa',100,2),(747,7524016,7524015,'600',3.333,3),(747,7524017,7524015,'000',3.333,3),(747,7524018,7524015,'00c',3.333,3),(747,7524019,7524015,'0c2',3.333,3),(747,7524020,7524015,'c29',3.333,3),(747,7524021,7524015,'296',3.333,3),(747,7524022,7524015,'968',3.333,3),(747,7524023,7524015,'68d',3.333,3),(747,7524024,7524015,'8d7',3.333,3),(747,7524025,7524015,'d72',3.333,3),(747,7524026,7524015,'72c',3.333,3),(747,7524027,7524015,'2c9',3.333,3),(747,7524028,7524015,'c99',3.333,3),(747,7524029,7524015,'996',3.333,3),(747,7524030,7524015,'96a',3.333,3),(747,7524031,7524015,'6a3',3.333,3),(747,7524032,7524015,'a3a',3.333,3),(747,7524033,7524015,'3a2',3.333,3),(747,7524034,7524015,'a26',3.333,3),(747,7524035,7524015,'263',3.333,3),(747,7524036,7524015,'631',3.333,3),(747,7524037,7524015,'31e',3.333,3),(747,7524038,7524015,'1e1',3.333,3),(747,7524039,7524015,'e1e',3.333,3),(747,7524040,7524015,'1ef',3.333,3),(747,7524041,7524015,'ef0',3.333,3),(747,7524042,7524015,'f00',3.333,3),(747,7524043,7524015,'007',3.333,3),(747,7524044,7524015,'078',3.333,3),(747,7524045,7524015,'780',3.333,3),(747,7524046,7524016,'mon',100,1),(747,7524047,7524046,'201',50,1),(747,7524048,7524046,'013',50,1),(747,7524049,7524047,'adm',33.333,3),(747,7524050,7524047,'dmi',33.333,3),(747,7524051,7524047,'min',33.333,3),(747,7524052,7524049,'cap',16.667,1),(747,7524053,7524049,'apa',16.667,1),(747,7524054,7524049,'pac',16.667,1),(747,7524055,7524049,'aci',16.667,1),(747,7524056,7524049,'cit',16.667,1),(747,7524057,7524049,'ity',16.667,1),(747,7524058,7524052,'pat',50,1),(747,7524059,7524052,'ath',50,1),(747,7524060,7524058,'fre',14.286,1),(747,7524061,7524058,'ree',14.286,1),(747,7524062,7524058,'ees',14.286,1),(747,7524063,7524058,'esp',14.286,1),(747,7524064,7524058,'spa',14.286,1),(747,7524065,7524058,'pac',14.286,1),(747,7524066,7524058,'ace',14.286,1),(747,7524067,7524060,'dis',50,1),(747,7524068,7524060,'isk',50,1),(747,7524069,7524067,'ind',33.333,1),(747,7524070,7524067,'nde',33.333,1),(747,7524071,7524067,'dex',33.333,1),(747,7524072,7524069,'adm',8.333,1),(747,7524073,7524069,'dmi',8.333,1),(747,7524074,7524069,'min',8.333,1),(747,7524075,7524069,'ini',8.333,1),(747,7524076,7524069,'nis',8.333,1),(747,7524077,7524069,'ist',8.333,1),(747,7524078,7524069,'str',8.333,1),(747,7524079,7524069,'tra',8.333,1),(747,7524080,7524069,'rat',8.333,1),(747,7524081,7524069,'ati',8.333,1),(747,7524082,7524069,'tio',8.333,1),(747,7524083,7524069,'ion',8.333,1),(747,7524084,7524072,'sta',33.333,3),(747,7524085,7524072,'tat',33.333,3),(747,7524086,7524072,'ate',33.333,3),(747,7524087,7524084,'ena',20,2),(747,7524088,7524084,'nab',20,2),(747,7524089,7524084,'abl',20,2),(747,7524090,7524084,'ble',20,2),(747,7524091,7524084,'led',20,2),(747,7524092,7524087,'cac',33.333,2),(747,7524093,7524087,'ach',33.333,2),(747,7524094,7524087,'che',33.333,2),(747,7524095,7524092,'mod',50,1),(747,7524096,7524092,'ode',50,1),(747,7524097,7524095,'wri',14.286,1),(747,7524098,7524095,'rit',14.286,1),(747,7524099,7524095,'ite',14.286,1),(747,7524100,7524095,'tet',14.286,1),(747,7524101,7524095,'eth',14.286,1),(747,7524102,7524095,'thr',14.286,1),(747,7524103,7524095,'hru',14.286,1),(747,7524104,7524097,'ope',11.111,2),(747,7524105,7524097,'per',11.111,2),(747,7524106,7524097,'era',11.111,2),(747,7524107,7524097,'rat',11.111,2),(747,7524108,7524097,'ati',11.111,2),(747,7524109,7524097,'tio',11.111,2),(747,7524110,7524097,'ion',11.111,2),(747,7524111,7524097,'ona',11.111,2),(747,7524112,7524097,'nal',11.111,2),(747,7524113,7524104,'pen',20,1),(747,7524114,7524104,'end',20,1),(747,7524115,7524104,'ndi',20,1),(747,7524116,7524104,'din',20,1),(747,7524117,7524104,'ing',20,1),(747,7524118,7524113,'mes',20,1),(747,7524119,7524113,'ess',20,1),(747,7524120,7524113,'ssa',20,1),(747,7524121,7524113,'sag',20,1),(747,7524122,7524113,'age',20,1),(747,7524123,7524118,'wai',20,1),(747,7524124,7524118,'ait',20,1),(747,7524125,7524118,'iti',20,1),(747,7524126,7524118,'tin',20,1),(747,7524127,7524118,'ing',20,1),(747,7524128,7524123,'for',100,1),(747,7524129,7524128,'per',11.111,1),(747,7524130,7524128,'erf',11.111,1),(747,7524131,7524128,'rfo',11.111,1),(747,7524132,7524128,'for',11.111,1),(747,7524133,7524128,'orm',11.111,1),(747,7524134,7524128,'rma',11.111,1),(747,7524135,7524128,'man',11.111,1),(747,7524136,7524128,'anc',11.111,1),(747,7524137,7524128,'nce',11.111,1),(747,7524138,7524129,'ide',12.5,1),(747,7524139,7524129,'den',12.5,1),(747,7524140,7524129,'ent',12.5,1),(747,7524141,7524129,'nti',12.5,1),(747,7524142,7524129,'tif',12.5,1),(747,7524143,7524129,'ifi',12.5,1),(747,7524144,7524129,'fie',12.5,1),(747,7524145,7524129,'ier',12.5,1),(747,7524146,7524138,'vdi',33.333,3),(747,7524147,7524138,'dis',33.333,3),(747,7524148,7524138,'isk',33.333,3),(747,7524149,7524146,'nam',50,1),(747,7524150,7524146,'ame',50,1),(747,7524151,7524149,'typ',50,1),(747,7524152,7524149,'ype',50,1),(747,7524153,7524151,'dir',25,1),(747,7524154,7524151,'ire',25,1),(747,7524155,7524151,'rec',25,1),(747,7524156,7524151,'ect',25,1),(748,7524158,7524157,'naa',100,2),(748,7524159,7524158,'600',3.333,3),(748,7524160,7524158,'000',3.333,3),(748,7524161,7524158,'00c',3.333,3),(748,7524162,7524158,'0c2',3.333,3),(748,7524163,7524158,'c29',3.333,3),(748,7524164,7524158,'299',3.333,3),(748,7524165,7524158,'999',3.333,3),(748,7524166,7524158,'99b',3.333,3),(748,7524167,7524158,'9bd',3.333,3),(748,7524168,7524158,'bd2',3.333,3),(748,7524169,7524158,'d2d',3.333,3),(748,7524170,7524158,'2d2',3.333,3),(748,7524171,7524158,'d25',3.333,3),(748,7524172,7524158,'25a',3.333,3),(748,7524173,7524158,'5a8',3.333,3),(748,7524174,7524158,'a85',3.333,3),(748,7524175,7524158,'856',3.333,3),(748,7524176,7524158,'56f',3.333,3),(748,7524177,7524158,'6fd',3.333,3),(748,7524178,7524158,'fdb',3.333,3),(748,7524179,7524158,'dbd',3.333,3),(748,7524180,7524158,'bd7',3.333,3),(748,7524181,7524158,'d71',3.333,3),(748,7524182,7524158,'71a',3.333,3),(748,7524183,7524158,'1af',3.333,3),(748,7524184,7524158,'af8',3.333,3),(748,7524185,7524158,'f8e',3.333,3),(748,7524186,7524158,'8e5',3.333,3),(748,7524187,7524158,'e54',3.333,3),(748,7524188,7524158,'54e',3.333,3),(748,7524189,7524159,'mon',100,1),(748,7524190,7524189,'201',50,1),(748,7524191,7524189,'013',50,1),(748,7524192,7524190,'adm',33.333,3),(748,7524193,7524190,'dmi',33.333,3),(748,7524194,7524190,'min',33.333,3),(748,7524195,7524192,'cap',16.667,1),(748,7524196,7524192,'apa',16.667,1),(748,7524197,7524192,'pac',16.667,1),(748,7524198,7524192,'aci',16.667,1),(748,7524199,7524192,'cit',16.667,1),(748,7524200,7524192,'ity',16.667,1),(748,7524201,7524195,'pat',50,1),(748,7524202,7524195,'ath',50,1),(748,7524203,7524201,'fre',14.286,1),(748,7524204,7524201,'ree',14.286,1),(748,7524205,7524201,'ees',14.286,1),(748,7524206,7524201,'esp',14.286,1),(748,7524207,7524201,'spa',14.286,1),(748,7524208,7524201,'pac',14.286,1),(748,7524209,7524201,'ace',14.286,1),(748,7524210,7524203,'dis',50,1),(748,7524211,7524203,'isk',50,1),(748,7524212,7524210,'ind',33.333,1),(748,7524213,7524210,'nde',33.333,1),(748,7524214,7524210,'dex',33.333,1),(748,7524215,7524212,'adm',8.333,1),(748,7524216,7524212,'dmi',8.333,1),(748,7524217,7524212,'min',8.333,1),(748,7524218,7524212,'ini',8.333,1),(748,7524219,7524212,'nis',8.333,1),(748,7524220,7524212,'ist',8.333,1),(748,7524221,7524212,'str',8.333,1),(748,7524222,7524212,'tra',8.333,1),(748,7524223,7524212,'rat',8.333,1),(748,7524224,7524212,'ati',8.333,1),(748,7524225,7524212,'tio',8.333,1),(748,7524226,7524212,'ion',8.333,1),(748,7524227,7524215,'sta',33.333,3),(748,7524228,7524215,'tat',33.333,3),(748,7524229,7524215,'ate',33.333,3),(748,7524230,7524227,'ena',20,2),(748,7524231,7524227,'nab',20,2),(748,7524232,7524227,'abl',20,2),(748,7524233,7524227,'ble',20,2),(748,7524234,7524227,'led',20,2),(748,7524235,7524230,'cac',33.333,2),(748,7524236,7524230,'ach',33.333,2),(748,7524237,7524230,'che',33.333,2),(748,7524238,7524235,'mod',50,1),(748,7524239,7524235,'ode',50,1),(748,7524240,7524238,'wri',14.286,1),(748,7524241,7524238,'rit',14.286,1),(748,7524242,7524238,'ite',14.286,1),(748,7524243,7524238,'tet',14.286,1),(748,7524244,7524238,'eth',14.286,1),(748,7524245,7524238,'thr',14.286,1),(748,7524246,7524238,'hru',14.286,1),(748,7524247,7524240,'ope',11.111,2),(748,7524248,7524240,'per',11.111,2),(748,7524249,7524240,'era',11.111,2),(748,7524250,7524240,'rat',11.111,2),(748,7524251,7524240,'ati',11.111,2),(748,7524252,7524240,'tio',11.111,2),(748,7524253,7524240,'ion',11.111,2),(748,7524254,7524240,'ona',11.111,2),(748,7524255,7524240,'nal',11.111,2),(748,7524256,7524247,'pen',20,1),(748,7524257,7524247,'end',20,1),(748,7524258,7524247,'ndi',20,1),(748,7524259,7524247,'din',20,1),(748,7524260,7524247,'ing',20,1),(748,7524261,7524256,'mes',20,1),(748,7524262,7524256,'ess',20,1),(748,7524263,7524256,'ssa',20,1),(748,7524264,7524256,'sag',20,1),(748,7524265,7524256,'age',20,1),(748,7524266,7524261,'wai',20,1),(748,7524267,7524261,'ait',20,1),(748,7524268,7524261,'iti',20,1),(748,7524269,7524261,'tin',20,1),(748,7524270,7524261,'ing',20,1),(748,7524271,7524266,'for',100,1),(748,7524272,7524271,'per',11.111,1),(748,7524273,7524271,'erf',11.111,1),(748,7524274,7524271,'rfo',11.111,1),(748,7524275,7524271,'for',11.111,1),(748,7524276,7524271,'orm',11.111,1),(748,7524277,7524271,'rma',11.111,1),(748,7524278,7524271,'man',11.111,1),(748,7524279,7524271,'anc',11.111,1),(748,7524280,7524271,'nce',11.111,1),(748,7524281,7524272,'ide',12.5,1),(748,7524282,7524272,'den',12.5,1),(748,7524283,7524272,'ent',12.5,1),(748,7524284,7524272,'nti',12.5,1),(748,7524285,7524272,'tif',12.5,1),(748,7524286,7524272,'ifi',12.5,1),(748,7524287,7524272,'fie',12.5,1),(748,7524288,7524272,'ier',12.5,1),(748,7524289,7524281,'vdi',33.333,3),(748,7524290,7524281,'dis',33.333,3),(748,7524291,7524281,'isk',33.333,3),(748,7524292,7524289,'nam',50,1),(748,7524293,7524289,'ame',50,1),(748,7524294,7524292,'typ',50,1),(748,7524295,7524292,'ype',50,1),(748,7524296,7524294,'dir',25,1),(748,7524297,7524294,'ire',25,1),(748,7524298,7524294,'rec',25,1),(748,7524299,7524294,'ect',25,1),(749,7524301,7524300,'naa',100,2),(749,7524302,7524301,'600',3.333,3),(749,7524303,7524301,'000',3.333,3),(749,7524304,7524301,'00c',3.333,3),(749,7524305,7524301,'0c2',3.333,3),(749,7524306,7524301,'c29',3.333,3),(749,7524307,7524301,'29a',3.333,3),(749,7524308,7524301,'9ae',3.333,3),(749,7524309,7524301,'ae5',3.333,3),(749,7524310,7524301,'e5a',3.333,3),(749,7524311,7524301,'5ae',3.333,3),(749,7524312,7524301,'ae5',3.333,3),(749,7524313,7524301,'e56',3.333,3),(749,7524314,7524301,'567',3.333,3),(749,7524315,7524301,'674',3.333,3),(749,7524316,7524301,'74f',3.333,3),(749,7524317,7524301,'4f7',3.333,3),(749,7524318,7524301,'f7e',3.333,3),(749,7524319,7524301,'7e2',3.333,3),(749,7524320,7524301,'e28',3.333,3),(749,7524321,7524301,'283',3.333,3),(749,7524322,7524301,'83d',3.333,3),(749,7524323,7524301,'3da',3.333,3),(749,7524324,7524301,'da1',3.333,3),(749,7524325,7524301,'a16',3.333,3),(749,7524326,7524301,'169',3.333,3),(749,7524327,7524301,'69b',3.333,3),(749,7524328,7524301,'9b8',3.333,3),(749,7524329,7524301,'b88',3.333,3),(749,7524330,7524301,'889',3.333,3),(749,7524331,7524301,'898',3.333,3),(749,7524332,7524302,'mon',100,1),(749,7524333,7524332,'201',50,1),(749,7524334,7524332,'013',50,1),(749,7524335,7524333,'adm',33.333,3),(749,7524336,7524333,'dmi',33.333,3),(749,7524337,7524333,'min',33.333,3),(749,7524338,7524335,'cap',16.667,1),(749,7524339,7524335,'apa',16.667,1),(749,7524340,7524335,'pac',16.667,1),(749,7524341,7524335,'aci',16.667,1),(749,7524342,7524335,'cit',16.667,1),(749,7524343,7524335,'ity',16.667,1),(749,7524344,7524338,'pat',50,1),(749,7524345,7524338,'ath',50,1),(749,7524346,7524344,'fre',14.286,1),(749,7524347,7524344,'ree',14.286,1),(749,7524348,7524344,'ees',14.286,1),(749,7524349,7524344,'esp',14.286,1),(749,7524350,7524344,'spa',14.286,1),(749,7524351,7524344,'pac',14.286,1),(749,7524352,7524344,'ace',14.286,1),(749,7524353,7524346,'dis',50,1),(749,7524354,7524346,'isk',50,1),(749,7524355,7524353,'ind',33.333,1),(749,7524356,7524353,'nde',33.333,1),(749,7524357,7524353,'dex',33.333,1),(749,7524358,7524355,'adm',8.333,1),(749,7524359,7524355,'dmi',8.333,1),(749,7524360,7524355,'min',8.333,1),(749,7524361,7524355,'ini',8.333,1),(749,7524362,7524355,'nis',8.333,1),(749,7524363,7524355,'ist',8.333,1),(749,7524364,7524355,'str',8.333,1),(749,7524365,7524355,'tra',8.333,1),(749,7524366,7524355,'rat',8.333,1),(749,7524367,7524355,'ati',8.333,1),(749,7524368,7524355,'tio',8.333,1),(749,7524369,7524355,'ion',8.333,1),(749,7524370,7524358,'sta',33.333,3),(749,7524371,7524358,'tat',33.333,3),(749,7524372,7524358,'ate',33.333,3),(749,7524373,7524370,'ena',20,2),(749,7524374,7524370,'nab',20,2),(749,7524375,7524370,'abl',20,2),(749,7524376,7524370,'ble',20,2),(749,7524377,7524370,'led',20,2),(749,7524378,7524373,'cac',33.333,2),(749,7524379,7524373,'ach',33.333,2),(749,7524380,7524373,'che',33.333,2),(749,7524381,7524378,'mod',50,1),(749,7524382,7524378,'ode',50,1),(749,7524383,7524381,'wri',14.286,1),(749,7524384,7524381,'rit',14.286,1),(749,7524385,7524381,'ite',14.286,1),(749,7524386,7524381,'tet',14.286,1),(749,7524387,7524381,'eth',14.286,1),(749,7524388,7524381,'thr',14.286,1),(749,7524389,7524381,'hru',14.286,1),(749,7524390,7524383,'ope',11.111,2),(749,7524391,7524383,'per',11.111,2),(749,7524392,7524383,'era',11.111,2),(749,7524393,7524383,'rat',11.111,2),(749,7524394,7524383,'ati',11.111,2),(749,7524395,7524383,'tio',11.111,2),(749,7524396,7524383,'ion',11.111,2),(749,7524397,7524383,'ona',11.111,2),(749,7524398,7524383,'nal',11.111,2),(749,7524399,7524390,'pen',20,1),(749,7524400,7524390,'end',20,1),(749,7524401,7524390,'ndi',20,1),(749,7524402,7524390,'din',20,1),(749,7524403,7524390,'ing',20,1),(749,7524404,7524399,'mes',20,1),(749,7524405,7524399,'ess',20,1),(749,7524406,7524399,'ssa',20,1),(749,7524407,7524399,'sag',20,1),(749,7524408,7524399,'age',20,1),(749,7524409,7524404,'wai',20,1),(749,7524410,7524404,'ait',20,1),(749,7524411,7524404,'iti',20,1),(749,7524412,7524404,'tin',20,1),(749,7524413,7524404,'ing',20,1),(749,7524414,7524409,'for',100,1),(749,7524415,7524414,'per',11.111,1),(749,7524416,7524414,'erf',11.111,1),(749,7524417,7524414,'rfo',11.111,1),(749,7524418,7524414,'for',11.111,1),(749,7524419,7524414,'orm',11.111,1),(749,7524420,7524414,'rma',11.111,1),(749,7524421,7524414,'man',11.111,1),(749,7524422,7524414,'anc',11.111,1),(749,7524423,7524414,'nce',11.111,1),(749,7524424,7524415,'ide',12.5,1),(749,7524425,7524415,'den',12.5,1),(749,7524426,7524415,'ent',12.5,1),(749,7524427,7524415,'nti',12.5,1),(749,7524428,7524415,'tif',12.5,1),(749,7524429,7524415,'ifi',12.5,1),(749,7524430,7524415,'fie',12.5,1),(749,7524431,7524415,'ier',12.5,1),(749,7524432,7524424,'vdi',33.333,3),(749,7524433,7524424,'dis',33.333,3),(749,7524434,7524424,'isk',33.333,3),(749,7524435,7524432,'nam',50,1),(749,7524436,7524432,'ame',50,1),(749,7524437,7524435,'typ',50,1),(749,7524438,7524435,'ype',50,1),(749,7524439,7524437,'dir',25,1),(749,7524440,7524437,'ire',25,1),(749,7524441,7524437,'rec',25,1),(749,7524442,7524437,'ect',25,1),(750,7524444,7524443,'naa',100,2),(750,7524445,7524444,'600',3.333,3),(750,7524446,7524444,'000',3.333,3),(750,7524447,7524444,'00c',3.333,3),(750,7524448,7524444,'0c2',3.333,3),(750,7524449,7524444,'c29',3.333,3),(750,7524450,7524444,'29f',3.333,3),(750,7524451,7524444,'9f9',3.333,3),(750,7524452,7524444,'f98',3.333,3),(750,7524453,7524444,'98c',3.333,3),(750,7524454,7524444,'8c3',3.333,3),(750,7524455,7524444,'c3a',3.333,3),(750,7524456,7524444,'3a7',3.333,3),(750,7524457,7524444,'a71',3.333,3),(750,7524458,7524444,'711',3.333,3),(750,7524459,7524444,'115',3.333,3),(750,7524460,7524444,'154',3.333,3),(750,7524461,7524444,'542',3.333,3),(750,7524462,7524444,'423',3.333,3),(750,7524463,7524444,'232',3.333,3),(750,7524464,7524444,'327',3.333,3),(750,7524465,7524444,'275',3.333,3),(750,7524466,7524444,'75b',3.333,3),(750,7524467,7524444,'5b8',3.333,3),(750,7524468,7524444,'b86',3.333,3),(750,7524469,7524444,'867',3.333,3),(750,7524470,7524444,'679',3.333,3),(750,7524471,7524444,'794',3.333,3),(750,7524472,7524444,'943',3.333,3),(750,7524473,7524444,'436',3.333,3),(750,7524474,7524444,'364',3.333,3),(750,7524475,7524445,'mon',100,1),(750,7524476,7524475,'201',50,1),(750,7524477,7524475,'013',50,1),(750,7524478,7524476,'adm',33.333,3),(750,7524479,7524476,'dmi',33.333,3),(750,7524480,7524476,'min',33.333,3),(750,7524481,7524478,'cap',16.667,1),(750,7524482,7524478,'apa',16.667,1),(750,7524483,7524478,'pac',16.667,1),(750,7524484,7524478,'aci',16.667,1),(750,7524485,7524478,'cit',16.667,1),(750,7524486,7524478,'ity',16.667,1),(750,7524487,7524481,'pat',50,1),(750,7524488,7524481,'ath',50,1),(750,7524489,7524487,'fre',14.286,1),(750,7524490,7524487,'ree',14.286,1),(750,7524491,7524487,'ees',14.286,1),(750,7524492,7524487,'esp',14.286,1),(750,7524493,7524487,'spa',14.286,1),(750,7524494,7524487,'pac',14.286,1),(750,7524495,7524487,'ace',14.286,1),(750,7524496,7524489,'dis',50,1),(750,7524497,7524489,'isk',50,1),(750,7524498,7524496,'ind',33.333,1),(750,7524499,7524496,'nde',33.333,1),(750,7524500,7524496,'dex',33.333,1),(750,7524501,7524498,'adm',8.333,1),(750,7524502,7524498,'dmi',8.333,1),(750,7524503,7524498,'min',8.333,1),(750,7524504,7524498,'ini',8.333,1),(750,7524505,7524498,'nis',8.333,1),(750,7524506,7524498,'ist',8.333,1),(750,7524507,7524498,'str',8.333,1),(750,7524508,7524498,'tra',8.333,1),(750,7524509,7524498,'rat',8.333,1),(750,7524510,7524498,'ati',8.333,1),(750,7524511,7524498,'tio',8.333,1),(750,7524512,7524498,'ion',8.333,1),(750,7524513,7524501,'sta',33.333,3),(750,7524514,7524501,'tat',33.333,3),(750,7524515,7524501,'ate',33.333,3),(750,7524516,7524513,'ena',20,2),(750,7524517,7524513,'nab',20,2),(750,7524518,7524513,'abl',20,2),(750,7524519,7524513,'ble',20,2),(750,7524520,7524513,'led',20,2),(750,7524521,7524516,'cac',33.333,2),(750,7524522,7524516,'ach',33.333,2),(750,7524523,7524516,'che',33.333,2),(750,7524524,7524521,'mod',50,1),(750,7524525,7524521,'ode',50,1),(750,7524526,7524524,'wri',14.286,1),(750,7524527,7524524,'rit',14.286,1),(750,7524528,7524524,'ite',14.286,1),(750,7524529,7524524,'tet',14.286,1),(750,7524530,7524524,'eth',14.286,1),(750,7524531,7524524,'thr',14.286,1),(750,7524532,7524524,'hru',14.286,1),(750,7524533,7524526,'ope',11.111,2),(750,7524534,7524526,'per',11.111,2),(750,7524535,7524526,'era',11.111,2),(750,7524536,7524526,'rat',11.111,2),(750,7524537,7524526,'ati',11.111,2),(750,7524538,7524526,'tio',11.111,2),(750,7524539,7524526,'ion',11.111,2),(750,7524540,7524526,'ona',11.111,2),(750,7524541,7524526,'nal',11.111,2),(750,7524542,7524533,'pen',20,1),(750,7524543,7524533,'end',20,1),(750,7524544,7524533,'ndi',20,1),(750,7524545,7524533,'din',20,1),(750,7524546,7524533,'ing',20,1),(750,7524547,7524542,'mes',20,1),(750,7524548,7524542,'ess',20,1),(750,7524549,7524542,'ssa',20,1),(750,7524550,7524542,'sag',20,1),(750,7524551,7524542,'age',20,1),(750,7524552,7524547,'wai',20,1),(750,7524553,7524547,'ait',20,1),(750,7524554,7524547,'iti',20,1),(750,7524555,7524547,'tin',20,1),(750,7524556,7524547,'ing',20,1),(750,7524557,7524552,'for',100,1),(750,7524558,7524557,'per',11.111,1),(750,7524559,7524557,'erf',11.111,1),(750,7524560,7524557,'rfo',11.111,1),(750,7524561,7524557,'for',11.111,1),(750,7524562,7524557,'orm',11.111,1),(750,7524563,7524557,'rma',11.111,1),(750,7524564,7524557,'man',11.111,1),(750,7524565,7524557,'anc',11.111,1),(750,7524566,7524557,'nce',11.111,1),(750,7524567,7524558,'ide',12.5,1),(750,7524568,7524558,'den',12.5,1),(750,7524569,7524558,'ent',12.5,1),(750,7524570,7524558,'nti',12.5,1),(750,7524571,7524558,'tif',12.5,1),(750,7524572,7524558,'ifi',12.5,1),(750,7524573,7524558,'fie',12.5,1),(750,7524574,7524558,'ier',12.5,1),(750,7524575,7524567,'vdi',33.333,3),(750,7524576,7524567,'dis',33.333,3),(750,7524577,7524567,'isk',33.333,3),(750,7524578,7524575,'nam',50,1),(750,7524579,7524575,'ame',50,1),(750,7524580,7524578,'typ',50,1),(750,7524581,7524578,'ype',50,1),(750,7524582,7524580,'dir',25,1),(750,7524583,7524580,'ire',25,1),(750,7524584,7524580,'rec',25,1),(750,7524585,7524580,'ect',25,1),(751,7524587,7524586,'naa',100,2),(751,7524588,7524587,'600',3.333,3),(751,7524589,7524587,'000',3.333,3),(751,7524590,7524587,'00c',3.333,3),(751,7524591,7524587,'0c2',3.333,3),(751,7524592,7524587,'c29',3.333,3),(751,7524593,7524587,'29d',3.333,3),(751,7524594,7524587,'9d7',3.333,3),(751,7524595,7524587,'d7d',3.333,3),(751,7524596,7524587,'7d9',3.333,3),(751,7524597,7524587,'d95',3.333,3),(751,7524598,7524587,'95e',3.333,3),(751,7524599,7524587,'5e0',3.333,3),(751,7524600,7524587,'e07',3.333,3),(751,7524601,7524587,'071',3.333,3),(751,7524602,7524587,'712',3.333,3),(751,7524603,7524587,'125',3.333,3),(751,7524604,7524587,'25c',3.333,3),(751,7524605,7524587,'5c1',3.333,3),(751,7524606,7524587,'c14',3.333,3),(751,7524607,7524587,'145',3.333,3),(751,7524608,7524587,'453',3.333,3),(751,7524609,7524587,'536',3.333,3),(751,7524610,7524587,'361',3.333,3),(751,7524611,7524587,'61f',3.333,3),(751,7524612,7524587,'1fd',3.333,3),(751,7524613,7524587,'fd0',3.333,3),(751,7524614,7524587,'d07',3.333,3),(751,7524615,7524587,'07b',3.333,3),(751,7524616,7524587,'7ba',3.333,3),(751,7524617,7524587,'ba6',3.333,3),(751,7524618,7524588,'mon',100,1),(751,7524619,7524618,'201',50,1),(751,7524620,7524618,'013',50,1),(751,7524621,7524619,'adm',33.333,3),(751,7524622,7524619,'dmi',33.333,3),(751,7524623,7524619,'min',33.333,3),(751,7524624,7524621,'cap',16.667,1),(751,7524625,7524621,'apa',16.667,1),(751,7524626,7524621,'pac',16.667,1),(751,7524627,7524621,'aci',16.667,1),(751,7524628,7524621,'cit',16.667,1),(751,7524629,7524621,'ity',16.667,1),(751,7524630,7524624,'pat',50,1),(751,7524631,7524624,'ath',50,1),(751,7524632,7524630,'fre',14.286,1),(751,7524633,7524630,'ree',14.286,1),(751,7524634,7524630,'ees',14.286,1),(751,7524635,7524630,'esp',14.286,1),(751,7524636,7524630,'spa',14.286,1),(751,7524637,7524630,'pac',14.286,1),(751,7524638,7524630,'ace',14.286,1),(751,7524639,7524632,'dis',50,1),(751,7524640,7524632,'isk',50,1),(751,7524641,7524639,'ind',33.333,1),(751,7524642,7524639,'nde',33.333,1),(751,7524643,7524639,'dex',33.333,1),(751,7524644,7524641,'adm',8.333,1),(751,7524645,7524641,'dmi',8.333,1),(751,7524646,7524641,'min',8.333,1),(751,7524647,7524641,'ini',8.333,1),(751,7524648,7524641,'nis',8.333,1),(751,7524649,7524641,'ist',8.333,1),(751,7524650,7524641,'str',8.333,1),(751,7524651,7524641,'tra',8.333,1),(751,7524652,7524641,'rat',8.333,1),(751,7524653,7524641,'ati',8.333,1),(751,7524654,7524641,'tio',8.333,1),(751,7524655,7524641,'ion',8.333,1),(751,7524656,7524644,'sta',33.333,3),(751,7524657,7524644,'tat',33.333,3),(751,7524658,7524644,'ate',33.333,3),(751,7524659,7524656,'ena',20,2),(751,7524660,7524656,'nab',20,2),(751,7524661,7524656,'abl',20,2),(751,7524662,7524656,'ble',20,2),(751,7524663,7524656,'led',20,2),(751,7524664,7524659,'cac',33.333,2),(751,7524665,7524659,'ach',33.333,2),(751,7524666,7524659,'che',33.333,2),(751,7524667,7524664,'mod',50,1),(751,7524668,7524664,'ode',50,1),(751,7524669,7524667,'wri',14.286,1),(751,7524670,7524667,'rit',14.286,1),(751,7524671,7524667,'ite',14.286,1),(751,7524672,7524667,'tet',14.286,1),(751,7524673,7524667,'eth',14.286,1),(751,7524674,7524667,'thr',14.286,1),(751,7524675,7524667,'hru',14.286,1),(751,7524676,7524669,'ope',11.111,2),(751,7524677,7524669,'per',11.111,2),(751,7524678,7524669,'era',11.111,2),(751,7524679,7524669,'rat',11.111,2),(751,7524680,7524669,'ati',11.111,2),(751,7524681,7524669,'tio',11.111,2),(751,7524682,7524669,'ion',11.111,2),(751,7524683,7524669,'ona',11.111,2),(751,7524684,7524669,'nal',11.111,2),(751,7524685,7524676,'pen',20,1),(751,7524686,7524676,'end',20,1),(751,7524687,7524676,'ndi',20,1),(751,7524688,7524676,'din',20,1),(751,7524689,7524676,'ing',20,1),(751,7524690,7524685,'mes',20,1),(751,7524691,7524685,'ess',20,1),(751,7524692,7524685,'ssa',20,1),(751,7524693,7524685,'sag',20,1),(751,7524694,7524685,'age',20,1),(751,7524695,7524690,'wai',20,1),(751,7524696,7524690,'ait',20,1),(751,7524697,7524690,'iti',20,1),(751,7524698,7524690,'tin',20,1),(751,7524699,7524690,'ing',20,1),(751,7524700,7524695,'for',100,1),(751,7524701,7524700,'per',11.111,1),(751,7524702,7524700,'erf',11.111,1),(751,7524703,7524700,'rfo',11.111,1),(751,7524704,7524700,'for',11.111,1),(751,7524705,7524700,'orm',11.111,1),(751,7524706,7524700,'rma',11.111,1),(751,7524707,7524700,'man',11.111,1),(751,7524708,7524700,'anc',11.111,1),(751,7524709,7524700,'nce',11.111,1),(751,7524710,7524701,'ide',12.5,1),(751,7524711,7524701,'den',12.5,1),(751,7524712,7524701,'ent',12.5,1),(751,7524713,7524701,'nti',12.5,1),(751,7524714,7524701,'tif',12.5,1),(751,7524715,7524701,'ifi',12.5,1),(751,7524716,7524701,'fie',12.5,1),(751,7524717,7524701,'ier',12.5,1),(751,7524718,7524710,'vdi',33.333,3),(751,7524719,7524710,'dis',33.333,3),(751,7524720,7524710,'isk',33.333,3),(751,7524721,7524718,'nam',50,1),(751,7524722,7524718,'ame',50,1),(751,7524723,7524721,'typ',50,1),(751,7524724,7524721,'ype',50,1),(751,7524725,7524723,'dir',25,1),(751,7524726,7524723,'ire',25,1),(751,7524727,7524723,'rec',25,1),(751,7524728,7524723,'ect',25,1),(752,7524730,7524729,'naa',100,2),(752,7524731,7524730,'600',3.333,3),(752,7524732,7524730,'000',3.333,3),(752,7524733,7524730,'00c',3.333,3),(752,7524734,7524730,'0c2',3.333,3),(752,7524735,7524730,'c29',3.333,3),(752,7524736,7524730,'29a',3.333,3),(752,7524737,7524730,'9a6',3.333,3),(752,7524738,7524730,'a60',3.333,3),(752,7524739,7524730,'602',3.333,3),(752,7524740,7524730,'02a',3.333,3),(752,7524741,7524730,'2a1',3.333,3),(752,7524742,7524730,'a1d',3.333,3),(752,7524743,7524730,'1dc',3.333,3),(752,7524744,7524730,'dc8',3.333,3),(752,7524745,7524730,'c8c',3.333,3),(752,7524746,7524730,'8c9',3.333,3),(752,7524747,7524730,'c99',3.333,3),(752,7524748,7524730,'99c',3.333,3),(752,7524749,7524730,'9cc',3.333,3),(752,7524750,7524730,'ccf',3.333,3),(752,7524751,7524730,'cf6',3.333,3),(752,7524752,7524730,'f64',3.333,3),(752,7524753,7524730,'649',3.333,3),(752,7524754,7524730,'496',3.333,3),(752,7524755,7524730,'960',3.333,3),(752,7524756,7524730,'607',3.333,3),(752,7524757,7524730,'07d',3.333,3),(752,7524758,7524730,'7d2',3.333,3),(752,7524759,7524730,'d24',3.333,3),(752,7524760,7524730,'24b',3.333,3),(752,7524761,7524731,'mon',100,1),(752,7524762,7524761,'201',50,1),(752,7524763,7524761,'013',50,1),(752,7524764,7524762,'adm',33.333,3),(752,7524765,7524762,'dmi',33.333,3),(752,7524766,7524762,'min',33.333,3),(752,7524767,7524764,'cap',16.667,1),(752,7524768,7524764,'apa',16.667,1),(752,7524769,7524764,'pac',16.667,1),(752,7524770,7524764,'aci',16.667,1),(752,7524771,7524764,'cit',16.667,1),(752,7524772,7524764,'ity',16.667,1),(752,7524773,7524767,'pat',50,1),(752,7524774,7524767,'ath',50,1),(752,7524775,7524773,'fre',14.286,1),(752,7524776,7524773,'ree',14.286,1),(752,7524777,7524773,'ees',14.286,1),(752,7524778,7524773,'esp',14.286,1),(752,7524779,7524773,'spa',14.286,1),(752,7524780,7524773,'pac',14.286,1),(752,7524781,7524773,'ace',14.286,1),(752,7524782,7524775,'dis',50,1),(752,7524783,7524775,'isk',50,1),(752,7524784,7524782,'ind',33.333,1),(752,7524785,7524782,'nde',33.333,1),(752,7524786,7524782,'dex',33.333,1),(752,7524787,7524784,'adm',8.333,1),(752,7524788,7524784,'dmi',8.333,1),(752,7524789,7524784,'min',8.333,1),(752,7524790,7524784,'ini',8.333,1),(752,7524791,7524784,'nis',8.333,1),(752,7524792,7524784,'ist',8.333,1),(752,7524793,7524784,'str',8.333,1),(752,7524794,7524784,'tra',8.333,1),(752,7524795,7524784,'rat',8.333,1),(752,7524796,7524784,'ati',8.333,1),(752,7524797,7524784,'tio',8.333,1),(752,7524798,7524784,'ion',8.333,1),(752,7524799,7524787,'sta',33.333,3),(752,7524800,7524787,'tat',33.333,3),(752,7524801,7524787,'ate',33.333,3),(752,7524802,7524799,'ena',20,2),(752,7524803,7524799,'nab',20,2),(752,7524804,7524799,'abl',20,2),(752,7524805,7524799,'ble',20,2),(752,7524806,7524799,'led',20,2),(752,7524807,7524802,'cac',33.333,2),(752,7524808,7524802,'ach',33.333,2),(752,7524809,7524802,'che',33.333,2),(752,7524810,7524807,'mod',50,1),(752,7524811,7524807,'ode',50,1),(752,7524812,7524810,'wri',14.286,1),(752,7524813,7524810,'rit',14.286,1),(752,7524814,7524810,'ite',14.286,1),(752,7524815,7524810,'tet',14.286,1),(752,7524816,7524810,'eth',14.286,1),(752,7524817,7524810,'thr',14.286,1),(752,7524818,7524810,'hru',14.286,1),(752,7524819,7524812,'ope',11.111,2),(752,7524820,7524812,'per',11.111,2),(752,7524821,7524812,'era',11.111,2),(752,7524822,7524812,'rat',11.111,2),(752,7524823,7524812,'ati',11.111,2),(752,7524824,7524812,'tio',11.111,2),(752,7524825,7524812,'ion',11.111,2),(752,7524826,7524812,'ona',11.111,2),(752,7524827,7524812,'nal',11.111,2),(752,7524828,7524819,'pen',20,1),(752,7524829,7524819,'end',20,1),(752,7524830,7524819,'ndi',20,1),(752,7524831,7524819,'din',20,1),(752,7524832,7524819,'ing',20,1),(752,7524833,7524828,'mes',20,1),(752,7524834,7524828,'ess',20,1),(752,7524835,7524828,'ssa',20,1),(752,7524836,7524828,'sag',20,1),(752,7524837,7524828,'age',20,1),(752,7524838,7524833,'wai',20,1),(752,7524839,7524833,'ait',20,1),(752,7524840,7524833,'iti',20,1),(752,7524841,7524833,'tin',20,1),(752,7524842,7524833,'ing',20,1),(752,7524843,7524838,'for',100,1),(752,7524844,7524843,'per',11.111,1),(752,7524845,7524843,'erf',11.111,1),(752,7524846,7524843,'rfo',11.111,1),(752,7524847,7524843,'for',11.111,1),(752,7524848,7524843,'orm',11.111,1),(752,7524849,7524843,'rma',11.111,1),(752,7524850,7524843,'man',11.111,1),(752,7524851,7524843,'anc',11.111,1),(752,7524852,7524843,'nce',11.111,1),(752,7524853,7524844,'ide',12.5,1),(752,7524854,7524844,'den',12.5,1),(752,7524855,7524844,'ent',12.5,1),(752,7524856,7524844,'nti',12.5,1),(752,7524857,7524844,'tif',12.5,1),(752,7524858,7524844,'ifi',12.5,1),(752,7524859,7524844,'fie',12.5,1),(752,7524860,7524844,'ier',12.5,1),(752,7524861,7524853,'vdi',33.333,3),(752,7524862,7524853,'dis',33.333,3),(752,7524863,7524853,'isk',33.333,3),(752,7524864,7524861,'nam',50,1),(752,7524865,7524861,'ame',50,1),(752,7524866,7524864,'typ',50,1),(752,7524867,7524864,'ype',50,1),(752,7524868,7524866,'dir',25,1),(752,7524869,7524866,'ire',25,1),(752,7524870,7524866,'rec',25,1),(752,7524871,7524866,'ect',25,1),(753,7524873,7524872,'naa',100,2),(753,7524874,7524873,'600',3.333,3),(753,7524875,7524873,'000',3.333,3),(753,7524876,7524873,'00c',3.333,3),(753,7524877,7524873,'0c2',3.333,3),(753,7524878,7524873,'c29',3.333,3),(753,7524879,7524873,'29e',3.333,3),(753,7524880,7524873,'9e0',3.333,3),(753,7524881,7524873,'e0d',3.333,3),(753,7524882,7524873,'0d9',3.333,3),(753,7524883,7524873,'d93',3.333,3),(753,7524884,7524873,'938',3.333,3),(753,7524885,7524873,'381',3.333,3),(753,7524886,7524873,'817',3.333,3),(753,7524887,7524873,'175',3.333,3),(753,7524888,7524873,'756',3.333,3),(753,7524889,7524873,'56d',3.333,3),(753,7524890,7524873,'6dd',3.333,3),(753,7524891,7524873,'dd6',3.333,3),(753,7524892,7524873,'d66',3.333,3),(753,7524893,7524873,'66c',3.333,3),(753,7524894,7524873,'6c2',3.333,3),(753,7524895,7524873,'c2f',3.333,3),(753,7524896,7524873,'2f5',3.333,3),(753,7524897,7524873,'f52',3.333,3),(753,7524898,7524873,'521',3.333,3),(753,7524899,7524873,'217',3.333,3),(753,7524900,7524873,'172',3.333,3),(753,7524901,7524873,'722',3.333,3),(753,7524902,7524873,'227',3.333,3),(753,7524903,7524873,'275',3.333,3),(753,7524904,7524874,'mon',100,1),(753,7524905,7524904,'201',50,1),(753,7524906,7524904,'013',50,1),(753,7524907,7524905,'adm',33.333,3),(753,7524908,7524905,'dmi',33.333,3),(753,7524909,7524905,'min',33.333,3),(753,7524910,7524907,'cap',16.667,1),(753,7524911,7524907,'apa',16.667,1),(753,7524912,7524907,'pac',16.667,1),(753,7524913,7524907,'aci',16.667,1),(753,7524914,7524907,'cit',16.667,1),(753,7524915,7524907,'ity',16.667,1),(753,7524916,7524910,'pat',50,1),(753,7524917,7524910,'ath',50,1),(753,7524918,7524916,'fre',14.286,1),(753,7524919,7524916,'ree',14.286,1),(753,7524920,7524916,'ees',14.286,1),(753,7524921,7524916,'esp',14.286,1),(753,7524922,7524916,'spa',14.286,1),(753,7524923,7524916,'pac',14.286,1),(753,7524924,7524916,'ace',14.286,1),(753,7524925,7524918,'dis',50,1),(753,7524926,7524918,'isk',50,1),(753,7524927,7524925,'ind',33.333,1),(753,7524928,7524925,'nde',33.333,1),(753,7524929,7524925,'dex',33.333,1),(753,7524930,7524927,'adm',8.333,1),(753,7524931,7524927,'dmi',8.333,1),(753,7524932,7524927,'min',8.333,1),(753,7524933,7524927,'ini',8.333,1),(753,7524934,7524927,'nis',8.333,1),(753,7524935,7524927,'ist',8.333,1),(753,7524936,7524927,'str',8.333,1),(753,7524937,7524927,'tra',8.333,1),(753,7524938,7524927,'rat',8.333,1),(753,7524939,7524927,'ati',8.333,1),(753,7524940,7524927,'tio',8.333,1),(753,7524941,7524927,'ion',8.333,1),(753,7524942,7524930,'sta',33.333,3),(753,7524943,7524930,'tat',33.333,3),(753,7524944,7524930,'ate',33.333,3),(753,7524945,7524942,'ena',20,2),(753,7524946,7524942,'nab',20,2),(753,7524947,7524942,'abl',20,2),(753,7524948,7524942,'ble',20,2),(753,7524949,7524942,'led',20,2),(753,7524950,7524945,'cac',33.333,2),(753,7524951,7524945,'ach',33.333,2),(753,7524952,7524945,'che',33.333,2),(753,7524953,7524950,'mod',50,1),(753,7524954,7524950,'ode',50,1),(753,7524955,7524953,'wri',14.286,1),(753,7524956,7524953,'rit',14.286,1),(753,7524957,7524953,'ite',14.286,1),(753,7524958,7524953,'tet',14.286,1),(753,7524959,7524953,'eth',14.286,1),(753,7524960,7524953,'thr',14.286,1),(753,7524961,7524953,'hru',14.286,1),(753,7524962,7524955,'ope',11.111,2),(753,7524963,7524955,'per',11.111,2),(753,7524964,7524955,'era',11.111,2),(753,7524965,7524955,'rat',11.111,2),(753,7524966,7524955,'ati',11.111,2),(753,7524967,7524955,'tio',11.111,2),(753,7524968,7524955,'ion',11.111,2),(753,7524969,7524955,'ona',11.111,2),(753,7524970,7524955,'nal',11.111,2),(753,7524971,7524962,'pen',20,1),(753,7524972,7524962,'end',20,1),(753,7524973,7524962,'ndi',20,1),(753,7524974,7524962,'din',20,1),(753,7524975,7524962,'ing',20,1),(753,7524976,7524971,'mes',20,1),(753,7524977,7524971,'ess',20,1),(753,7524978,7524971,'ssa',20,1),(753,7524979,7524971,'sag',20,1),(753,7524980,7524971,'age',20,1),(753,7524981,7524976,'wai',20,1),(753,7524982,7524976,'ait',20,1),(753,7524983,7524976,'iti',20,1),(753,7524984,7524976,'tin',20,1),(753,7524985,7524976,'ing',20,1),(753,7524986,7524981,'for',100,1),(753,7524987,7524986,'per',11.111,1),(753,7524988,7524986,'erf',11.111,1),(753,7524989,7524986,'rfo',11.111,1),(753,7524990,7524986,'for',11.111,1),(753,7524991,7524986,'orm',11.111,1),(753,7524992,7524986,'rma',11.111,1),(753,7524993,7524986,'man',11.111,1),(753,7524994,7524986,'anc',11.111,1),(753,7524995,7524986,'nce',11.111,1),(753,7524996,7524987,'ide',12.5,1),(753,7524997,7524987,'den',12.5,1),(753,7524998,7524987,'ent',12.5,1),(753,7524999,7524987,'nti',12.5,1),(753,7525000,7524987,'tif',12.5,1),(753,7525001,7524987,'ifi',12.5,1),(753,7525002,7524987,'fie',12.5,1),(753,7525003,7524987,'ier',12.5,1),(753,7525004,7524996,'vdi',33.333,3),(753,7525005,7524996,'dis',33.333,3),(753,7525006,7524996,'isk',33.333,3),(753,7525007,7525004,'nam',50,1),(753,7525008,7525004,'ame',50,1),(753,7525009,7525007,'typ',50,1),(753,7525010,7525007,'ype',50,1),(753,7525011,7525009,'dir',25,1),(753,7525012,7525009,'ire',25,1),(753,7525013,7525009,'rec',25,1),(753,7525014,7525009,'ect',25,1),(754,7525016,7525015,'naa',100,2),(754,7525017,7525016,'600',3.333,3),(754,7525018,7525016,'000',3.333,3),(754,7525019,7525016,'00c',3.333,3),(754,7525020,7525016,'0c2',3.333,3),(754,7525021,7525016,'c29',3.333,3),(754,7525022,7525016,'298',3.333,3),(754,7525023,7525016,'989',3.333,3),(754,7525024,7525016,'893',3.333,3),(754,7525025,7525016,'931',3.333,3),(754,7525026,7525016,'31b',3.333,3),(754,7525027,7525016,'1bb',3.333,3),(754,7525028,7525016,'bbd',3.333,3),(754,7525029,7525016,'bd4',3.333,3),(754,7525030,7525016,'d40',3.333,3),(754,7525031,7525016,'405',3.333,3),(754,7525032,7525016,'051',3.333,3),(754,7525033,7525016,'51e',3.333,3),(754,7525034,7525016,'1e9',3.333,3),(754,7525035,7525016,'e93',3.333,3),(754,7525036,7525016,'93e',3.333,3),(754,7525037,7525016,'3ea',3.333,3),(754,7525038,7525016,'eac',3.333,3),(754,7525039,7525016,'ac1',3.333,3),(754,7525040,7525016,'c15',3.333,3),(754,7525041,7525016,'150',3.333,3),(754,7525042,7525016,'500',3.333,3),(754,7525043,7525016,'008',3.333,3),(754,7525044,7525016,'08f',3.333,3),(754,7525045,7525016,'8fd',3.333,3),(754,7525046,7525016,'fd6',3.333,3),(754,7525047,7525017,'mon',100,1),(754,7525048,7525047,'201',50,1),(754,7525049,7525047,'013',50,1),(754,7525050,7525048,'adm',33.333,3),(754,7525051,7525048,'dmi',33.333,3),(754,7525052,7525048,'min',33.333,3),(754,7525053,7525050,'cap',16.667,1),(754,7525054,7525050,'apa',16.667,1),(754,7525055,7525050,'pac',16.667,1),(754,7525056,7525050,'aci',16.667,1),(754,7525057,7525050,'cit',16.667,1),(754,7525058,7525050,'ity',16.667,1),(754,7525059,7525053,'pat',50,1),(754,7525060,7525053,'ath',50,1),(754,7525061,7525059,'fre',14.286,1),(754,7525062,7525059,'ree',14.286,1),(754,7525063,7525059,'ees',14.286,1),(754,7525064,7525059,'esp',14.286,1),(754,7525065,7525059,'spa',14.286,1),(754,7525066,7525059,'pac',14.286,1),(754,7525067,7525059,'ace',14.286,1),(754,7525068,7525061,'dis',50,1),(754,7525069,7525061,'isk',50,1),(754,7525070,7525068,'ind',33.333,1),(754,7525071,7525068,'nde',33.333,1),(754,7525072,7525068,'dex',33.333,1),(754,7525073,7525070,'adm',8.333,1),(754,7525074,7525070,'dmi',8.333,1),(754,7525075,7525070,'min',8.333,1),(754,7525076,7525070,'ini',8.333,1),(754,7525077,7525070,'nis',8.333,1),(754,7525078,7525070,'ist',8.333,1),(754,7525079,7525070,'str',8.333,1),(754,7525080,7525070,'tra',8.333,1),(754,7525081,7525070,'rat',8.333,1),(754,7525082,7525070,'ati',8.333,1),(754,7525083,7525070,'tio',8.333,1),(754,7525084,7525070,'ion',8.333,1),(754,7525085,7525073,'sta',33.333,3),(754,7525086,7525073,'tat',33.333,3),(754,7525087,7525073,'ate',33.333,3),(754,7525088,7525085,'ena',20,2),(754,7525089,7525085,'nab',20,2),(754,7525090,7525085,'abl',20,2),(754,7525091,7525085,'ble',20,2),(754,7525092,7525085,'led',20,2),(754,7525093,7525088,'cac',33.333,2),(754,7525094,7525088,'ach',33.333,2),(754,7525095,7525088,'che',33.333,2),(754,7525096,7525093,'mod',50,1),(754,7525097,7525093,'ode',50,1),(754,7525098,7525096,'wri',14.286,1),(754,7525099,7525096,'rit',14.286,1),(754,7525100,7525096,'ite',14.286,1),(754,7525101,7525096,'tet',14.286,1),(754,7525102,7525096,'eth',14.286,1),(754,7525103,7525096,'thr',14.286,1),(754,7525104,7525096,'hru',14.286,1),(754,7525105,7525098,'ope',11.111,2),(754,7525106,7525098,'per',11.111,2),(754,7525107,7525098,'era',11.111,2),(754,7525108,7525098,'rat',11.111,2),(754,7525109,7525098,'ati',11.111,2),(754,7525110,7525098,'tio',11.111,2),(754,7525111,7525098,'ion',11.111,2),(754,7525112,7525098,'ona',11.111,2),(754,7525113,7525098,'nal',11.111,2),(754,7525114,7525105,'pen',20,1),(754,7525115,7525105,'end',20,1),(754,7525116,7525105,'ndi',20,1),(754,7525117,7525105,'din',20,1),(754,7525118,7525105,'ing',20,1),(754,7525119,7525114,'mes',20,1),(754,7525120,7525114,'ess',20,1),(754,7525121,7525114,'ssa',20,1),(754,7525122,7525114,'sag',20,1),(754,7525123,7525114,'age',20,1),(754,7525124,7525119,'wai',20,1),(754,7525125,7525119,'ait',20,1),(754,7525126,7525119,'iti',20,1),(754,7525127,7525119,'tin',20,1),(754,7525128,7525119,'ing',20,1),(754,7525129,7525124,'for',100,1),(754,7525130,7525129,'per',11.111,1),(754,7525131,7525129,'erf',11.111,1),(754,7525132,7525129,'rfo',11.111,1),(754,7525133,7525129,'for',11.111,1),(754,7525134,7525129,'orm',11.111,1),(754,7525135,7525129,'rma',11.111,1),(754,7525136,7525129,'man',11.111,1),(754,7525137,7525129,'anc',11.111,1),(754,7525138,7525129,'nce',11.111,1),(754,7525139,7525130,'ide',12.5,1),(754,7525140,7525130,'den',12.5,1),(754,7525141,7525130,'ent',12.5,1),(754,7525142,7525130,'nti',12.5,1),(754,7525143,7525130,'tif',12.5,1),(754,7525144,7525130,'ifi',12.5,1),(754,7525145,7525130,'fie',12.5,1),(754,7525146,7525130,'ier',12.5,1),(754,7525147,7525139,'vdi',33.333,3),(754,7525148,7525139,'dis',33.333,3),(754,7525149,7525139,'isk',33.333,3),(754,7525150,7525147,'nam',50,1),(754,7525151,7525147,'ame',50,1),(754,7525152,7525150,'typ',50,1),(754,7525153,7525150,'ype',50,1),(754,7525154,7525152,'dir',25,1),(754,7525155,7525152,'ire',25,1),(754,7525156,7525152,'rec',25,1),(754,7525157,7525152,'ect',25,1),(755,7525159,7525158,'naa',100,2),(755,7525160,7525159,'600',3.333,3),(755,7525161,7525159,'000',3.333,3),(755,7525162,7525159,'00c',3.333,3),(755,7525163,7525159,'0c2',3.333,3),(755,7525164,7525159,'c29',3.333,3),(755,7525165,7525159,'29d',3.333,3),(755,7525166,7525159,'9da',3.333,3),(755,7525167,7525159,'dad',3.333,3),(755,7525168,7525159,'ad6',3.333,3),(755,7525169,7525159,'d6f',3.333,3),(755,7525170,7525159,'6ff',3.333,3),(755,7525171,7525159,'ff9',3.333,3),(755,7525172,7525159,'f96',3.333,3),(755,7525173,7525159,'96c',3.333,3),(755,7525174,7525159,'6c7',3.333,3),(755,7525175,7525159,'c7d',3.333,3),(755,7525176,7525159,'7d7',3.333,3),(755,7525177,7525159,'d74',3.333,3),(755,7525178,7525159,'74b',3.333,3),(755,7525179,7525159,'4b2',3.333,3),(755,7525180,7525159,'b2b',3.333,3),(755,7525181,7525159,'2bd',3.333,3),(755,7525182,7525159,'bd1',3.333,3),(755,7525183,7525159,'d1c',3.333,3),(755,7525184,7525159,'1c9',3.333,3),(755,7525185,7525159,'c96',3.333,3),(755,7525186,7525159,'969',3.333,3),(755,7525187,7525159,'697',3.333,3),(755,7525188,7525159,'970',3.333,3),(755,7525189,7525159,'70a',3.333,3),(755,7525190,7525160,'mon',100,1),(755,7525191,7525190,'201',50,1),(755,7525192,7525190,'013',50,1),(755,7525193,7525191,'adm',33.333,3),(755,7525194,7525191,'dmi',33.333,3),(755,7525195,7525191,'min',33.333,3),(755,7525196,7525193,'cap',16.667,1),(755,7525197,7525193,'apa',16.667,1),(755,7525198,7525193,'pac',16.667,1),(755,7525199,7525193,'aci',16.667,1),(755,7525200,7525193,'cit',16.667,1),(755,7525201,7525193,'ity',16.667,1),(755,7525202,7525196,'pat',50,1),(755,7525203,7525196,'ath',50,1),(755,7525204,7525202,'fre',14.286,1),(755,7525205,7525202,'ree',14.286,1),(755,7525206,7525202,'ees',14.286,1),(755,7525207,7525202,'esp',14.286,1),(755,7525208,7525202,'spa',14.286,1),(755,7525209,7525202,'pac',14.286,1),(755,7525210,7525202,'ace',14.286,1),(755,7525211,7525204,'dis',50,1),(755,7525212,7525204,'isk',50,1),(755,7525213,7525211,'ind',33.333,1),(755,7525214,7525211,'nde',33.333,1),(755,7525215,7525211,'dex',33.333,1),(755,7525216,7525213,'adm',8.333,1),(755,7525217,7525213,'dmi',8.333,1),(755,7525218,7525213,'min',8.333,1),(755,7525219,7525213,'ini',8.333,1),(755,7525220,7525213,'nis',8.333,1),(755,7525221,7525213,'ist',8.333,1),(755,7525222,7525213,'str',8.333,1),(755,7525223,7525213,'tra',8.333,1),(755,7525224,7525213,'rat',8.333,1),(755,7525225,7525213,'ati',8.333,1),(755,7525226,7525213,'tio',8.333,1),(755,7525227,7525213,'ion',8.333,1),(755,7525228,7525216,'sta',33.333,3),(755,7525229,7525216,'tat',33.333,3),(755,7525230,7525216,'ate',33.333,3),(755,7525231,7525228,'ena',20,2),(755,7525232,7525228,'nab',20,2),(755,7525233,7525228,'abl',20,2),(755,7525234,7525228,'ble',20,2),(755,7525235,7525228,'led',20,2),(755,7525236,7525231,'cac',33.333,2),(755,7525237,7525231,'ach',33.333,2),(755,7525238,7525231,'che',33.333,2),(755,7525239,7525236,'mod',50,1),(755,7525240,7525236,'ode',50,1),(755,7525241,7525239,'wri',14.286,1),(755,7525242,7525239,'rit',14.286,1),(755,7525243,7525239,'ite',14.286,1),(755,7525244,7525239,'tet',14.286,1),(755,7525245,7525239,'eth',14.286,1),(755,7525246,7525239,'thr',14.286,1),(755,7525247,7525239,'hru',14.286,1),(755,7525248,7525241,'ope',11.111,2),(755,7525249,7525241,'per',11.111,2),(755,7525250,7525241,'era',11.111,2),(755,7525251,7525241,'rat',11.111,2),(755,7525252,7525241,'ati',11.111,2),(755,7525253,7525241,'tio',11.111,2),(755,7525254,7525241,'ion',11.111,2),(755,7525255,7525241,'ona',11.111,2),(755,7525256,7525241,'nal',11.111,2),(755,7525257,7525248,'pen',20,1),(755,7525258,7525248,'end',20,1),(755,7525259,7525248,'ndi',20,1),(755,7525260,7525248,'din',20,1),(755,7525261,7525248,'ing',20,1),(755,7525262,7525257,'mes',20,1),(755,7525263,7525257,'ess',20,1),(755,7525264,7525257,'ssa',20,1),(755,7525265,7525257,'sag',20,1),(755,7525266,7525257,'age',20,1),(755,7525267,7525262,'wai',20,1),(755,7525268,7525262,'ait',20,1),(755,7525269,7525262,'iti',20,1),(755,7525270,7525262,'tin',20,1),(755,7525271,7525262,'ing',20,1),(755,7525272,7525267,'for',100,1),(755,7525273,7525272,'per',11.111,1),(755,7525274,7525272,'erf',11.111,1),(755,7525275,7525272,'rfo',11.111,1),(755,7525276,7525272,'for',11.111,1),(755,7525277,7525272,'orm',11.111,1),(755,7525278,7525272,'rma',11.111,1),(755,7525279,7525272,'man',11.111,1),(755,7525280,7525272,'anc',11.111,1),(755,7525281,7525272,'nce',11.111,1),(755,7525282,7525273,'ide',12.5,1),(755,7525283,7525273,'den',12.5,1),(755,7525284,7525273,'ent',12.5,1),(755,7525285,7525273,'nti',12.5,1),(755,7525286,7525273,'tif',12.5,1),(755,7525287,7525273,'ifi',12.5,1),(755,7525288,7525273,'fie',12.5,1),(755,7525289,7525273,'ier',12.5,1),(755,7525290,7525282,'vdi',33.333,3),(755,7525291,7525282,'dis',33.333,3),(755,7525292,7525282,'isk',33.333,3),(755,7525293,7525290,'nam',50,1),(755,7525294,7525290,'ame',50,1),(755,7525295,7525293,'typ',50,1),(755,7525296,7525293,'ype',50,1),(755,7525297,7525295,'dir',25,1),(755,7525298,7525295,'ire',25,1),(755,7525299,7525295,'rec',25,1),(755,7525300,7525295,'ect',25,1),(756,7525302,7525301,'naa',100,2),(756,7525303,7525302,'600',3.333,3),(756,7525304,7525302,'000',3.333,3),(756,7525305,7525302,'00c',3.333,3),(756,7525306,7525302,'0c2',3.333,3),(756,7525307,7525302,'c29',3.333,3),(756,7525308,7525302,'298',3.333,3),(756,7525309,7525302,'98a',3.333,3),(756,7525310,7525302,'8a1',3.333,3),(756,7525311,7525302,'a15',3.333,3),(756,7525312,7525302,'158',3.333,3),(756,7525313,7525302,'583',3.333,3),(756,7525314,7525302,'839',3.333,3),(756,7525315,7525302,'399',3.333,3),(756,7525316,7525302,'99a',3.333,3),(756,7525317,7525302,'9a8',3.333,3),(756,7525318,7525302,'a8c',3.333,3),(756,7525319,7525302,'8cf',3.333,3),(756,7525320,7525302,'cf0',3.333,3),(756,7525321,7525302,'f00',3.333,3),(756,7525322,7525302,'00e',3.333,3),(756,7525323,7525302,'0e9',3.333,3),(756,7525324,7525302,'e9c',3.333,3),(756,7525325,7525302,'9c9',3.333,3),(756,7525326,7525302,'c9b',3.333,3),(756,7525327,7525302,'9bc',3.333,3),(756,7525328,7525302,'bc3',3.333,3),(756,7525329,7525302,'c3c',3.333,3),(756,7525330,7525302,'3c9',3.333,3),(756,7525331,7525302,'c9e',3.333,3),(756,7525332,7525302,'9e5',3.333,3),(756,7525333,7525303,'mon',100,1),(756,7525334,7525333,'201',50,1),(756,7525335,7525333,'013',50,1),(756,7525336,7525334,'adm',33.333,3),(756,7525337,7525334,'dmi',33.333,3),(756,7525338,7525334,'min',33.333,3),(756,7525339,7525336,'cap',16.667,1),(756,7525340,7525336,'apa',16.667,1),(756,7525341,7525336,'pac',16.667,1),(756,7525342,7525336,'aci',16.667,1),(756,7525343,7525336,'cit',16.667,1),(756,7525344,7525336,'ity',16.667,1),(756,7525345,7525339,'pat',50,1),(756,7525346,7525339,'ath',50,1),(756,7525347,7525345,'fre',14.286,1),(756,7525348,7525345,'ree',14.286,1),(756,7525349,7525345,'ees',14.286,1),(756,7525350,7525345,'esp',14.286,1),(756,7525351,7525345,'spa',14.286,1),(756,7525352,7525345,'pac',14.286,1),(756,7525353,7525345,'ace',14.286,1),(756,7525354,7525347,'dis',50,1),(756,7525355,7525347,'isk',50,1),(756,7525356,7525354,'ind',33.333,1),(756,7525357,7525354,'nde',33.333,1),(756,7525358,7525354,'dex',33.333,1),(756,7525359,7525356,'adm',8.333,1),(756,7525360,7525356,'dmi',8.333,1),(756,7525361,7525356,'min',8.333,1),(756,7525362,7525356,'ini',8.333,1),(756,7525363,7525356,'nis',8.333,1),(756,7525364,7525356,'ist',8.333,1),(756,7525365,7525356,'str',8.333,1),(756,7525366,7525356,'tra',8.333,1),(756,7525367,7525356,'rat',8.333,1),(756,7525368,7525356,'ati',8.333,1),(756,7525369,7525356,'tio',8.333,1),(756,7525370,7525356,'ion',8.333,1),(756,7525371,7525359,'sta',33.333,3),(756,7525372,7525359,'tat',33.333,3),(756,7525373,7525359,'ate',33.333,3),(756,7525374,7525371,'ena',20,2),(756,7525375,7525371,'nab',20,2),(756,7525376,7525371,'abl',20,2),(756,7525377,7525371,'ble',20,2),(756,7525378,7525371,'led',20,2),(756,7525379,7525374,'cac',33.333,2),(756,7525380,7525374,'ach',33.333,2),(756,7525381,7525374,'che',33.333,2),(756,7525382,7525379,'mod',50,1),(756,7525383,7525379,'ode',50,1),(756,7525384,7525382,'wri',14.286,1),(756,7525385,7525382,'rit',14.286,1),(756,7525386,7525382,'ite',14.286,1),(756,7525387,7525382,'tet',14.286,1),(756,7525388,7525382,'eth',14.286,1),(756,7525389,7525382,'thr',14.286,1),(756,7525390,7525382,'hru',14.286,1),(756,7525391,7525384,'ope',11.111,2),(756,7525392,7525384,'per',11.111,2),(756,7525393,7525384,'era',11.111,2),(756,7525394,7525384,'rat',11.111,2),(756,7525395,7525384,'ati',11.111,2),(756,7525396,7525384,'tio',11.111,2),(756,7525397,7525384,'ion',11.111,2),(756,7525398,7525384,'ona',11.111,2),(756,7525399,7525384,'nal',11.111,2),(756,7525400,7525391,'pen',20,1),(756,7525401,7525391,'end',20,1),(756,7525402,7525391,'ndi',20,1),(756,7525403,7525391,'din',20,1),(756,7525404,7525391,'ing',20,1),(756,7525405,7525400,'mes',20,1),(756,7525406,7525400,'ess',20,1),(756,7525407,7525400,'ssa',20,1),(756,7525408,7525400,'sag',20,1),(756,7525409,7525400,'age',20,1),(756,7525410,7525405,'wai',20,1),(756,7525411,7525405,'ait',20,1),(756,7525412,7525405,'iti',20,1),(756,7525413,7525405,'tin',20,1),(756,7525414,7525405,'ing',20,1),(756,7525415,7525410,'for',100,1),(756,7525416,7525415,'per',11.111,1),(756,7525417,7525415,'erf',11.111,1),(756,7525418,7525415,'rfo',11.111,1),(756,7525419,7525415,'for',11.111,1),(756,7525420,7525415,'orm',11.111,1),(756,7525421,7525415,'rma',11.111,1),(756,7525422,7525415,'man',11.111,1),(756,7525423,7525415,'anc',11.111,1),(756,7525424,7525415,'nce',11.111,1),(756,7525425,7525416,'ide',12.5,1),(756,7525426,7525416,'den',12.5,1),(756,7525427,7525416,'ent',12.5,1),(756,7525428,7525416,'nti',12.5,1),(756,7525429,7525416,'tif',12.5,1),(756,7525430,7525416,'ifi',12.5,1),(756,7525431,7525416,'fie',12.5,1),(756,7525432,7525416,'ier',12.5,1),(756,7525433,7525425,'vdi',33.333,3),(756,7525434,7525425,'dis',33.333,3),(756,7525435,7525425,'isk',33.333,3),(756,7525436,7525433,'nam',50,1),(756,7525437,7525433,'ame',50,1),(756,7525438,7525436,'typ',50,1),(756,7525439,7525436,'ype',50,1),(756,7525440,7525438,'dir',25,1),(756,7525441,7525438,'ire',25,1),(756,7525442,7525438,'rec',25,1),(756,7525443,7525438,'ect',25,1),(757,7525445,7525444,'naa',100,2),(757,7525446,7525445,'600',3.333,3),(757,7525447,7525445,'000',3.333,3),(757,7525448,7525445,'00c',3.333,3),(757,7525449,7525445,'0c2',3.333,3),(757,7525450,7525445,'c29',3.333,3),(757,7525451,7525445,'292',3.333,3),(757,7525452,7525445,'923',3.333,3),(757,7525453,7525445,'23c',3.333,3),(757,7525454,7525445,'3c7',3.333,3),(757,7525455,7525445,'c7d',3.333,3),(757,7525456,7525445,'7d4',3.333,3),(757,7525457,7525445,'d40',3.333,3),(757,7525458,7525445,'402',3.333,3),(757,7525459,7525445,'020',3.333,3),(757,7525460,7525445,'204',3.333,3),(757,7525461,7525445,'046',3.333,3),(757,7525462,7525445,'46f',3.333,3),(757,7525463,7525445,'6fb',3.333,3),(757,7525464,7525445,'fbc',3.333,3),(757,7525465,7525445,'bcd',3.333,3),(757,7525466,7525445,'cdb',3.333,3),(757,7525467,7525445,'dbe',3.333,3),(757,7525468,7525445,'beb',3.333,3),(757,7525469,7525445,'eb5',3.333,3),(757,7525470,7525445,'b55',3.333,3),(757,7525471,7525445,'556',3.333,3),(757,7525472,7525445,'56d',3.333,3),(757,7525473,7525445,'6df',3.333,3),(757,7525474,7525445,'df8',3.333,3),(757,7525475,7525445,'f8a',3.333,3),(757,7525476,7525446,'mon',100,1),(757,7525477,7525476,'201',50,1),(757,7525478,7525476,'013',50,1),(757,7525479,7525477,'adm',33.333,3),(757,7525480,7525477,'dmi',33.333,3),(757,7525481,7525477,'min',33.333,3),(757,7525482,7525479,'cap',16.667,1),(757,7525483,7525479,'apa',16.667,1),(757,7525484,7525479,'pac',16.667,1),(757,7525485,7525479,'aci',16.667,1),(757,7525486,7525479,'cit',16.667,1),(757,7525487,7525479,'ity',16.667,1),(757,7525488,7525482,'pat',50,1),(757,7525489,7525482,'ath',50,1),(757,7525490,7525488,'fre',14.286,1),(757,7525491,7525488,'ree',14.286,1),(757,7525492,7525488,'ees',14.286,1),(757,7525493,7525488,'esp',14.286,1),(757,7525494,7525488,'spa',14.286,1),(757,7525495,7525488,'pac',14.286,1),(757,7525496,7525488,'ace',14.286,1),(757,7525497,7525490,'dis',50,1),(757,7525498,7525490,'isk',50,1),(757,7525499,7525497,'ind',33.333,1),(757,7525500,7525497,'nde',33.333,1),(757,7525501,7525497,'dex',33.333,1),(757,7525502,7525499,'adm',8.333,1),(757,7525503,7525499,'dmi',8.333,1),(757,7525504,7525499,'min',8.333,1),(757,7525505,7525499,'ini',8.333,1),(757,7525506,7525499,'nis',8.333,1),(757,7525507,7525499,'ist',8.333,1),(757,7525508,7525499,'str',8.333,1),(757,7525509,7525499,'tra',8.333,1),(757,7525510,7525499,'rat',8.333,1),(757,7525511,7525499,'ati',8.333,1),(757,7525512,7525499,'tio',8.333,1),(757,7525513,7525499,'ion',8.333,1),(757,7525514,7525502,'sta',33.333,3),(757,7525515,7525502,'tat',33.333,3),(757,7525516,7525502,'ate',33.333,3),(757,7525517,7525514,'ena',20,2),(757,7525518,7525514,'nab',20,2),(757,7525519,7525514,'abl',20,2),(757,7525520,7525514,'ble',20,2),(757,7525521,7525514,'led',20,2),(757,7525522,7525517,'cac',33.333,2),(757,7525523,7525517,'ach',33.333,2),(757,7525524,7525517,'che',33.333,2),(757,7525525,7525522,'mod',50,1),(757,7525526,7525522,'ode',50,1),(757,7525527,7525525,'wri',14.286,1),(757,7525528,7525525,'rit',14.286,1),(757,7525529,7525525,'ite',14.286,1),(757,7525530,7525525,'tet',14.286,1),(757,7525531,7525525,'eth',14.286,1),(757,7525532,7525525,'thr',14.286,1),(757,7525533,7525525,'hru',14.286,1),(757,7525534,7525527,'ope',11.111,2),(757,7525535,7525527,'per',11.111,2),(757,7525536,7525527,'era',11.111,2),(757,7525537,7525527,'rat',11.111,2),(757,7525538,7525527,'ati',11.111,2),(757,7525539,7525527,'tio',11.111,2),(757,7525540,7525527,'ion',11.111,2),(757,7525541,7525527,'ona',11.111,2),(757,7525542,7525527,'nal',11.111,2),(757,7525543,7525534,'pen',20,1),(757,7525544,7525534,'end',20,1),(757,7525545,7525534,'ndi',20,1),(757,7525546,7525534,'din',20,1),(757,7525547,7525534,'ing',20,1),(757,7525548,7525543,'mes',20,1),(757,7525549,7525543,'ess',20,1),(757,7525550,7525543,'ssa',20,1),(757,7525551,7525543,'sag',20,1),(757,7525552,7525543,'age',20,1),(757,7525553,7525548,'wai',20,1),(757,7525554,7525548,'ait',20,1),(757,7525555,7525548,'iti',20,1),(757,7525556,7525548,'tin',20,1),(757,7525557,7525548,'ing',20,1),(757,7525558,7525553,'for',100,1),(757,7525559,7525558,'per',11.111,1),(757,7525560,7525558,'erf',11.111,1),(757,7525561,7525558,'rfo',11.111,1),(757,7525562,7525558,'for',11.111,1),(757,7525563,7525558,'orm',11.111,1),(757,7525564,7525558,'rma',11.111,1),(757,7525565,7525558,'man',11.111,1),(757,7525566,7525558,'anc',11.111,1),(757,7525567,7525558,'nce',11.111,1),(757,7525568,7525559,'ide',12.5,1),(757,7525569,7525559,'den',12.5,1),(757,7525570,7525559,'ent',12.5,1),(757,7525571,7525559,'nti',12.5,1),(757,7525572,7525559,'tif',12.5,1),(757,7525573,7525559,'ifi',12.5,1),(757,7525574,7525559,'fie',12.5,1),(757,7525575,7525559,'ier',12.5,1),(757,7525576,7525568,'vdi',33.333,3),(757,7525577,7525568,'dis',33.333,3),(757,7525578,7525568,'isk',33.333,3),(757,7525579,7525576,'nam',50,1),(757,7525580,7525576,'ame',50,1),(757,7525581,7525579,'typ',50,1),(757,7525582,7525579,'ype',50,1),(757,7525583,7525581,'dir',25,1),(757,7525584,7525581,'ire',25,1),(757,7525585,7525581,'rec',25,1),(757,7525586,7525581,'ect',25,1),(758,7525588,7525587,'naa',100,2),(758,7525589,7525588,'600',3.333,3),(758,7525590,7525588,'000',3.333,3),(758,7525591,7525588,'00c',3.333,3),(758,7525592,7525588,'0c2',3.333,3),(758,7525593,7525588,'c29',3.333,3),(758,7525594,7525588,'299',3.333,3),(758,7525595,7525588,'99a',3.333,3),(758,7525596,7525588,'9aa',3.333,3),(758,7525597,7525588,'aa8',3.333,3),(758,7525598,7525588,'a8d',3.333,3),(758,7525599,7525588,'8df',3.333,3),(758,7525600,7525588,'dfd',3.333,3),(758,7525601,7525588,'fda',3.333,3),(758,7525602,7525588,'dac',3.333,3),(758,7525603,7525588,'ac2',3.333,3),(758,7525604,7525588,'c2d',3.333,3),(758,7525605,7525588,'2dc',3.333,3),(758,7525606,7525588,'dc3',3.333,3),(758,7525607,7525588,'c36',3.333,3),(758,7525608,7525588,'36b',3.333,3),(758,7525609,7525588,'6b1',3.333,3),(758,7525610,7525588,'b17',3.333,3),(758,7525611,7525588,'17a',3.333,3),(758,7525612,7525588,'7a1',3.333,3),(758,7525613,7525588,'a1f',3.333,3),(758,7525614,7525588,'1f7',3.333,3),(758,7525615,7525588,'f72',3.333,3),(758,7525616,7525588,'727',3.333,3),(758,7525617,7525588,'27d',3.333,3),(758,7525618,7525588,'7d5',3.333,3),(758,7525619,7525589,'mon',100,1),(758,7525620,7525619,'201',50,1),(758,7525621,7525619,'013',50,1),(758,7525622,7525620,'adm',33.333,3),(758,7525623,7525620,'dmi',33.333,3),(758,7525624,7525620,'min',33.333,3),(758,7525625,7525622,'cap',16.667,1),(758,7525626,7525622,'apa',16.667,1),(758,7525627,7525622,'pac',16.667,1),(758,7525628,7525622,'aci',16.667,1),(758,7525629,7525622,'cit',16.667,1),(758,7525630,7525622,'ity',16.667,1),(758,7525631,7525625,'pat',50,1),(758,7525632,7525625,'ath',50,1),(758,7525633,7525631,'fre',14.286,1),(758,7525634,7525631,'ree',14.286,1),(758,7525635,7525631,'ees',14.286,1),(758,7525636,7525631,'esp',14.286,1),(758,7525637,7525631,'spa',14.286,1),(758,7525638,7525631,'pac',14.286,1),(758,7525639,7525631,'ace',14.286,1),(758,7525640,7525633,'dis',50,1),(758,7525641,7525633,'isk',50,1),(758,7525642,7525640,'ind',33.333,1),(758,7525643,7525640,'nde',33.333,1),(758,7525644,7525640,'dex',33.333,1),(758,7525645,7525642,'adm',8.333,1),(758,7525646,7525642,'dmi',8.333,1),(758,7525647,7525642,'min',8.333,1),(758,7525648,7525642,'ini',8.333,1),(758,7525649,7525642,'nis',8.333,1),(758,7525650,7525642,'ist',8.333,1),(758,7525651,7525642,'str',8.333,1),(758,7525652,7525642,'tra',8.333,1),(758,7525653,7525642,'rat',8.333,1),(758,7525654,7525642,'ati',8.333,1),(758,7525655,7525642,'tio',8.333,1),(758,7525656,7525642,'ion',8.333,1),(758,7525657,7525645,'sta',33.333,3),(758,7525658,7525645,'tat',33.333,3),(758,7525659,7525645,'ate',33.333,3),(758,7525660,7525657,'ena',20,2),(758,7525661,7525657,'nab',20,2),(758,7525662,7525657,'abl',20,2),(758,7525663,7525657,'ble',20,2),(758,7525664,7525657,'led',20,2),(758,7525665,7525660,'cac',33.333,2),(758,7525666,7525660,'ach',33.333,2),(758,7525667,7525660,'che',33.333,2),(758,7525668,7525665,'mod',50,1),(758,7525669,7525665,'ode',50,1),(758,7525670,7525668,'wri',14.286,1),(758,7525671,7525668,'rit',14.286,1),(758,7525672,7525668,'ite',14.286,1),(758,7525673,7525668,'tet',14.286,1),(758,7525674,7525668,'eth',14.286,1),(758,7525675,7525668,'thr',14.286,1),(758,7525676,7525668,'hru',14.286,1),(758,7525677,7525670,'ope',11.111,2),(758,7525678,7525670,'per',11.111,2),(758,7525679,7525670,'era',11.111,2),(758,7525680,7525670,'rat',11.111,2),(758,7525681,7525670,'ati',11.111,2),(758,7525682,7525670,'tio',11.111,2),(758,7525683,7525670,'ion',11.111,2),(758,7525684,7525670,'ona',11.111,2),(758,7525685,7525670,'nal',11.111,2),(758,7525686,7525677,'pen',20,1),(758,7525687,7525677,'end',20,1),(758,7525688,7525677,'ndi',20,1),(758,7525689,7525677,'din',20,1),(758,7525690,7525677,'ing',20,1),(758,7525691,7525686,'mes',20,1),(758,7525692,7525686,'ess',20,1),(758,7525693,7525686,'ssa',20,1),(758,7525694,7525686,'sag',20,1),(758,7525695,7525686,'age',20,1),(758,7525696,7525691,'wai',20,1),(758,7525697,7525691,'ait',20,1),(758,7525698,7525691,'iti',20,1),(758,7525699,7525691,'tin',20,1),(758,7525700,7525691,'ing',20,1),(758,7525701,7525696,'for',100,1),(758,7525702,7525701,'per',11.111,1),(758,7525703,7525701,'erf',11.111,1),(758,7525704,7525701,'rfo',11.111,1),(758,7525705,7525701,'for',11.111,1),(758,7525706,7525701,'orm',11.111,1),(758,7525707,7525701,'rma',11.111,1),(758,7525708,7525701,'man',11.111,1),(758,7525709,7525701,'anc',11.111,1),(758,7525710,7525701,'nce',11.111,1),(758,7525711,7525702,'ide',12.5,1),(758,7525712,7525702,'den',12.5,1),(758,7525713,7525702,'ent',12.5,1),(758,7525714,7525702,'nti',12.5,1),(758,7525715,7525702,'tif',12.5,1),(758,7525716,7525702,'ifi',12.5,1),(758,7525717,7525702,'fie',12.5,1),(758,7525718,7525702,'ier',12.5,1),(758,7525719,7525711,'vdi',33.333,3),(758,7525720,7525711,'dis',33.333,3),(758,7525721,7525711,'isk',33.333,3),(758,7525722,7525719,'nam',50,1),(758,7525723,7525719,'ame',50,1),(758,7525724,7525722,'typ',50,1),(758,7525725,7525722,'ype',50,1),(758,7525726,7525724,'dir',25,1),(758,7525727,7525724,'ire',25,1),(758,7525728,7525724,'rec',25,1),(758,7525729,7525724,'ect',25,1),(759,7525731,7525730,'naa',100,2),(759,7525732,7525731,'600',3.333,3),(759,7525733,7525731,'000',3.333,3),(759,7525734,7525731,'00c',3.333,3),(759,7525735,7525731,'0c2',3.333,3),(759,7525736,7525731,'c29',3.333,3),(759,7525737,7525731,'295',3.333,3),(759,7525738,7525731,'95c',3.333,3),(759,7525739,7525731,'5c5',3.333,3),(759,7525740,7525731,'c52',3.333,3),(759,7525741,7525731,'524',3.333,3),(759,7525742,7525731,'242',3.333,3),(759,7525743,7525731,'427',3.333,3),(759,7525744,7525731,'272',3.333,3),(759,7525745,7525731,'72b',3.333,3),(759,7525746,7525731,'2be',3.333,3),(759,7525747,7525731,'be4',3.333,3),(759,7525748,7525731,'e4e',3.333,3),(759,7525749,7525731,'4ed',3.333,3),(759,7525750,7525731,'edc',3.333,3),(759,7525751,7525731,'dca',3.333,3),(759,7525752,7525731,'ca5',3.333,3),(759,7525753,7525731,'a50',3.333,3),(759,7525754,7525731,'509',3.333,3),(759,7525755,7525731,'093',3.333,3),(759,7525756,7525731,'938',3.333,3),(759,7525757,7525731,'38d',3.333,3),(759,7525758,7525731,'8dc',3.333,3),(759,7525759,7525731,'dc5',3.333,3),(759,7525760,7525731,'c55',3.333,3),(759,7525761,7525731,'55c',3.333,3),(759,7525762,7525732,'mon',100,1),(759,7525763,7525762,'201',50,1),(759,7525764,7525762,'013',50,1),(759,7525765,7525763,'adm',33.333,3),(759,7525766,7525763,'dmi',33.333,3),(759,7525767,7525763,'min',33.333,3),(759,7525768,7525765,'cap',16.667,1),(759,7525769,7525765,'apa',16.667,1),(759,7525770,7525765,'pac',16.667,1),(759,7525771,7525765,'aci',16.667,1),(759,7525772,7525765,'cit',16.667,1),(759,7525773,7525765,'ity',16.667,1),(759,7525774,7525768,'pat',50,1),(759,7525775,7525768,'ath',50,1),(759,7525776,7525774,'fre',14.286,1),(759,7525777,7525774,'ree',14.286,1),(759,7525778,7525774,'ees',14.286,1),(759,7525779,7525774,'esp',14.286,1),(759,7525780,7525774,'spa',14.286,1),(759,7525781,7525774,'pac',14.286,1),(759,7525782,7525774,'ace',14.286,1),(759,7525783,7525776,'dis',50,1),(759,7525784,7525776,'isk',50,1),(759,7525785,7525783,'ind',33.333,1),(759,7525786,7525783,'nde',33.333,1),(759,7525787,7525783,'dex',33.333,1),(759,7525788,7525785,'adm',8.333,1),(759,7525789,7525785,'dmi',8.333,1),(759,7525790,7525785,'min',8.333,1),(759,7525791,7525785,'ini',8.333,1),(759,7525792,7525785,'nis',8.333,1),(759,7525793,7525785,'ist',8.333,1),(759,7525794,7525785,'str',8.333,1),(759,7525795,7525785,'tra',8.333,1),(759,7525796,7525785,'rat',8.333,1),(759,7525797,7525785,'ati',8.333,1),(759,7525798,7525785,'tio',8.333,1),(759,7525799,7525785,'ion',8.333,1),(759,7525800,7525788,'sta',33.333,3),(759,7525801,7525788,'tat',33.333,3),(759,7525802,7525788,'ate',33.333,3),(759,7525803,7525800,'ena',20,2),(759,7525804,7525800,'nab',20,2),(759,7525805,7525800,'abl',20,2),(759,7525806,7525800,'ble',20,2),(759,7525807,7525800,'led',20,2),(759,7525808,7525803,'cac',33.333,2),(759,7525809,7525803,'ach',33.333,2),(759,7525810,7525803,'che',33.333,2),(759,7525811,7525808,'mod',50,1),(759,7525812,7525808,'ode',50,1),(759,7525813,7525811,'wri',14.286,1),(759,7525814,7525811,'rit',14.286,1),(759,7525815,7525811,'ite',14.286,1),(759,7525816,7525811,'tet',14.286,1),(759,7525817,7525811,'eth',14.286,1),(759,7525818,7525811,'thr',14.286,1),(759,7525819,7525811,'hru',14.286,1),(759,7525820,7525813,'ope',11.111,2),(759,7525821,7525813,'per',11.111,2),(759,7525822,7525813,'era',11.111,2),(759,7525823,7525813,'rat',11.111,2),(759,7525824,7525813,'ati',11.111,2),(759,7525825,7525813,'tio',11.111,2),(759,7525826,7525813,'ion',11.111,2),(759,7525827,7525813,'ona',11.111,2),(759,7525828,7525813,'nal',11.111,2),(759,7525829,7525820,'pen',20,1),(759,7525830,7525820,'end',20,1),(759,7525831,7525820,'ndi',20,1),(759,7525832,7525820,'din',20,1),(759,7525833,7525820,'ing',20,1),(759,7525834,7525829,'mes',20,1),(759,7525835,7525829,'ess',20,1),(759,7525836,7525829,'ssa',20,1),(759,7525837,7525829,'sag',20,1),(759,7525838,7525829,'age',20,1),(759,7525839,7525834,'wai',20,1),(759,7525840,7525834,'ait',20,1),(759,7525841,7525834,'iti',20,1),(759,7525842,7525834,'tin',20,1),(759,7525843,7525834,'ing',20,1),(759,7525844,7525839,'for',100,1),(759,7525845,7525844,'per',11.111,1),(759,7525846,7525844,'erf',11.111,1),(759,7525847,7525844,'rfo',11.111,1),(759,7525848,7525844,'for',11.111,1),(759,7525849,7525844,'orm',11.111,1),(759,7525850,7525844,'rma',11.111,1),(759,7525851,7525844,'man',11.111,1),(759,7525852,7525844,'anc',11.111,1),(759,7525853,7525844,'nce',11.111,1),(759,7525854,7525845,'ide',12.5,1),(759,7525855,7525845,'den',12.5,1),(759,7525856,7525845,'ent',12.5,1),(759,7525857,7525845,'nti',12.5,1),(759,7525858,7525845,'tif',12.5,1),(759,7525859,7525845,'ifi',12.5,1),(759,7525860,7525845,'fie',12.5,1),(759,7525861,7525845,'ier',12.5,1),(759,7525862,7525854,'vdi',33.333,3),(759,7525863,7525854,'dis',33.333,3),(759,7525864,7525854,'isk',33.333,3),(759,7525865,7525862,'nam',50,1),(759,7525866,7525862,'ame',50,1),(759,7525867,7525865,'typ',50,1),(759,7525868,7525865,'ype',50,1),(759,7525869,7525867,'dir',25,1),(759,7525870,7525867,'ire',25,1),(759,7525871,7525867,'rec',25,1),(759,7525872,7525867,'ect',25,1),(760,7525874,7525873,'naa',100,2),(760,7525875,7525874,'600',3.333,3),(760,7525876,7525874,'000',3.333,3),(760,7525877,7525874,'00c',3.333,3),(760,7525878,7525874,'0c2',3.333,3),(760,7525879,7525874,'c29',3.333,3),(760,7525880,7525874,'292',3.333,3),(760,7525881,7525874,'923',3.333,3),(760,7525882,7525874,'23f',3.333,3),(760,7525883,7525874,'3fc',3.333,3),(760,7525884,7525874,'fc6',3.333,3),(760,7525885,7525874,'c65',3.333,3),(760,7525886,7525874,'65a',3.333,3),(760,7525887,7525874,'5a0',3.333,3),(760,7525888,7525874,'a00',3.333,3),(760,7525889,7525874,'00d',3.333,3),(760,7525890,7525874,'0d2',3.333,3),(760,7525891,7525874,'d27',3.333,3),(760,7525892,7525874,'275',3.333,3),(760,7525893,7525874,'75b',3.333,3),(760,7525894,7525874,'5ba',3.333,3),(760,7525895,7525874,'bae',3.333,3),(760,7525896,7525874,'aed',3.333,3),(760,7525897,7525874,'ed3',3.333,3),(760,7525898,7525874,'d36',3.333,3),(760,7525899,7525874,'362',3.333,3),(760,7525900,7525874,'622',3.333,3),(760,7525901,7525874,'22d',3.333,3),(760,7525902,7525874,'2dc',3.333,3),(760,7525903,7525874,'dc0',3.333,3),(760,7525904,7525874,'c0f',3.333,3),(760,7525905,7525875,'mon',100,1),(760,7525906,7525905,'201',50,1),(760,7525907,7525905,'013',50,1),(760,7525908,7525906,'adm',33.333,3),(760,7525909,7525906,'dmi',33.333,3),(760,7525910,7525906,'min',33.333,3),(760,7525911,7525908,'cap',16.667,1),(760,7525912,7525908,'apa',16.667,1),(760,7525913,7525908,'pac',16.667,1),(760,7525914,7525908,'aci',16.667,1),(760,7525915,7525908,'cit',16.667,1),(760,7525916,7525908,'ity',16.667,1),(760,7525917,7525911,'pat',50,1),(760,7525918,7525911,'ath',50,1),(760,7525919,7525917,'fre',14.286,1),(760,7525920,7525917,'ree',14.286,1),(760,7525921,7525917,'ees',14.286,1),(760,7525922,7525917,'esp',14.286,1),(760,7525923,7525917,'spa',14.286,1),(760,7525924,7525917,'pac',14.286,1),(760,7525925,7525917,'ace',14.286,1),(760,7525926,7525919,'dis',50,1),(760,7525927,7525919,'isk',50,1),(760,7525928,7525926,'ind',33.333,1),(760,7525929,7525926,'nde',33.333,1),(760,7525930,7525926,'dex',33.333,1),(760,7525931,7525928,'adm',8.333,1),(760,7525932,7525928,'dmi',8.333,1),(760,7525933,7525928,'min',8.333,1),(760,7525934,7525928,'ini',8.333,1),(760,7525935,7525928,'nis',8.333,1),(760,7525936,7525928,'ist',8.333,1),(760,7525937,7525928,'str',8.333,1),(760,7525938,7525928,'tra',8.333,1),(760,7525939,7525928,'rat',8.333,1),(760,7525940,7525928,'ati',8.333,1),(760,7525941,7525928,'tio',8.333,1),(760,7525942,7525928,'ion',8.333,1),(760,7525943,7525931,'sta',33.333,3),(760,7525944,7525931,'tat',33.333,3),(760,7525945,7525931,'ate',33.333,3),(760,7525946,7525943,'ena',20,2),(760,7525947,7525943,'nab',20,2),(760,7525948,7525943,'abl',20,2),(760,7525949,7525943,'ble',20,2),(760,7525950,7525943,'led',20,2),(760,7525951,7525946,'cac',33.333,2),(760,7525952,7525946,'ach',33.333,2),(760,7525953,7525946,'che',33.333,2),(760,7525954,7525951,'mod',50,1),(760,7525955,7525951,'ode',50,1),(760,7525956,7525954,'wri',14.286,1),(760,7525957,7525954,'rit',14.286,1),(760,7525958,7525954,'ite',14.286,1),(760,7525959,7525954,'tet',14.286,1),(760,7525960,7525954,'eth',14.286,1),(760,7525961,7525954,'thr',14.286,1),(760,7525962,7525954,'hru',14.286,1),(760,7525963,7525956,'ope',11.111,2),(760,7525964,7525956,'per',11.111,2),(760,7525965,7525956,'era',11.111,2),(760,7525966,7525956,'rat',11.111,2),(760,7525967,7525956,'ati',11.111,2),(760,7525968,7525956,'tio',11.111,2),(760,7525969,7525956,'ion',11.111,2),(760,7525970,7525956,'ona',11.111,2),(760,7525971,7525956,'nal',11.111,2),(760,7525972,7525963,'pen',20,1),(760,7525973,7525963,'end',20,1),(760,7525974,7525963,'ndi',20,1),(760,7525975,7525963,'din',20,1),(760,7525976,7525963,'ing',20,1),(760,7525977,7525972,'mes',20,1),(760,7525978,7525972,'ess',20,1),(760,7525979,7525972,'ssa',20,1),(760,7525980,7525972,'sag',20,1),(760,7525981,7525972,'age',20,1),(760,7525982,7525977,'wai',20,1),(760,7525983,7525977,'ait',20,1),(760,7525984,7525977,'iti',20,1),(760,7525985,7525977,'tin',20,1),(760,7525986,7525977,'ing',20,1),(760,7525987,7525982,'for',100,1),(760,7525988,7525987,'per',11.111,1),(760,7525989,7525987,'erf',11.111,1),(760,7525990,7525987,'rfo',11.111,1),(760,7525991,7525987,'for',11.111,1),(760,7525992,7525987,'orm',11.111,1),(760,7525993,7525987,'rma',11.111,1),(760,7525994,7525987,'man',11.111,1),(760,7525995,7525987,'anc',11.111,1),(760,7525996,7525987,'nce',11.111,1),(760,7525997,7525988,'ide',12.5,1),(760,7525998,7525988,'den',12.5,1),(760,7525999,7525988,'ent',12.5,1),(760,7526000,7525988,'nti',12.5,1),(760,7526001,7525988,'tif',12.5,1),(760,7526002,7525988,'ifi',12.5,1),(760,7526003,7525988,'fie',12.5,1),(760,7526004,7525988,'ier',12.5,1),(760,7526005,7525997,'vdi',33.333,3),(760,7526006,7525997,'dis',33.333,3),(760,7526007,7525997,'isk',33.333,3),(760,7526008,7526005,'nam',50,1),(760,7526009,7526005,'ame',50,1),(760,7526010,7526008,'typ',50,1),(760,7526011,7526008,'ype',50,1),(760,7526012,7526010,'dir',25,1),(760,7526013,7526010,'ire',25,1),(760,7526014,7526010,'rec',25,1),(760,7526015,7526010,'ect',25,1),(761,7526017,7526016,'naa',100,2),(761,7526018,7526017,'600',3.333,3),(761,7526019,7526017,'000',3.333,3),(761,7526020,7526017,'00c',3.333,3),(761,7526021,7526017,'0c2',3.333,3),(761,7526022,7526017,'c29',3.333,3),(761,7526023,7526017,'296',3.333,3),(761,7526024,7526017,'964',3.333,3),(761,7526025,7526017,'642',3.333,3),(761,7526026,7526017,'421',3.333,3),(761,7526027,7526017,'212',3.333,3),(761,7526028,7526017,'120',3.333,3),(761,7526029,7526017,'20f',3.333,3),(761,7526030,7526017,'0f6',3.333,3),(761,7526031,7526017,'f6b',3.333,3),(761,7526032,7526017,'6b2',3.333,3),(761,7526033,7526017,'b23',3.333,3),(761,7526034,7526017,'23b',3.333,3),(761,7526035,7526017,'3b0',3.333,3),(761,7526036,7526017,'b07',3.333,3),(761,7526037,7526017,'074',3.333,3),(761,7526038,7526017,'74a',3.333,3),(761,7526039,7526017,'4ae',3.333,3),(761,7526040,7526017,'aef',3.333,3),(761,7526041,7526017,'ef6',3.333,3),(761,7526042,7526017,'f6d',3.333,3),(761,7526043,7526017,'6d0',3.333,3),(761,7526044,7526017,'d06',3.333,3),(761,7526045,7526017,'06f',3.333,3),(761,7526046,7526017,'6f5',3.333,3),(761,7526047,7526017,'f5e',3.333,3),(761,7526048,7526018,'mon',100,1),(761,7526049,7526048,'201',50,1),(761,7526050,7526048,'013',50,1),(761,7526051,7526049,'adm',33.333,3),(761,7526052,7526049,'dmi',33.333,3),(761,7526053,7526049,'min',33.333,3),(761,7526054,7526051,'cap',16.667,1),(761,7526055,7526051,'apa',16.667,1),(761,7526056,7526051,'pac',16.667,1),(761,7526057,7526051,'aci',16.667,1),(761,7526058,7526051,'cit',16.667,1),(761,7526059,7526051,'ity',16.667,1),(761,7526060,7526054,'pat',50,1),(761,7526061,7526054,'ath',50,1),(761,7526062,7526060,'fre',14.286,1),(761,7526063,7526060,'ree',14.286,1),(761,7526064,7526060,'ees',14.286,1),(761,7526065,7526060,'esp',14.286,1),(761,7526066,7526060,'spa',14.286,1),(761,7526067,7526060,'pac',14.286,1),(761,7526068,7526060,'ace',14.286,1),(761,7526069,7526062,'dis',50,1),(761,7526070,7526062,'isk',50,1),(761,7526071,7526069,'ind',33.333,1),(761,7526072,7526069,'nde',33.333,1),(761,7526073,7526069,'dex',33.333,1),(761,7526074,7526071,'adm',8.333,1),(761,7526075,7526071,'dmi',8.333,1),(761,7526076,7526071,'min',8.333,1),(761,7526077,7526071,'ini',8.333,1),(761,7526078,7526071,'nis',8.333,1),(761,7526079,7526071,'ist',8.333,1),(761,7526080,7526071,'str',8.333,1),(761,7526081,7526071,'tra',8.333,1),(761,7526082,7526071,'rat',8.333,1),(761,7526083,7526071,'ati',8.333,1),(761,7526084,7526071,'tio',8.333,1),(761,7526085,7526071,'ion',8.333,1),(761,7526086,7526074,'sta',33.333,3),(761,7526087,7526074,'tat',33.333,3),(761,7526088,7526074,'ate',33.333,3),(761,7526089,7526086,'ena',20,2),(761,7526090,7526086,'nab',20,2),(761,7526091,7526086,'abl',20,2),(761,7526092,7526086,'ble',20,2),(761,7526093,7526086,'led',20,2),(761,7526094,7526089,'cac',33.333,2),(761,7526095,7526089,'ach',33.333,2),(761,7526096,7526089,'che',33.333,2),(761,7526097,7526094,'mod',50,1),(761,7526098,7526094,'ode',50,1),(761,7526099,7526097,'wri',14.286,1),(761,7526100,7526097,'rit',14.286,1),(761,7526101,7526097,'ite',14.286,1),(761,7526102,7526097,'tet',14.286,1),(761,7526103,7526097,'eth',14.286,1),(761,7526104,7526097,'thr',14.286,1),(761,7526105,7526097,'hru',14.286,1),(761,7526106,7526099,'ope',11.111,2),(761,7526107,7526099,'per',11.111,2),(761,7526108,7526099,'era',11.111,2),(761,7526109,7526099,'rat',11.111,2),(761,7526110,7526099,'ati',11.111,2),(761,7526111,7526099,'tio',11.111,2),(761,7526112,7526099,'ion',11.111,2),(761,7526113,7526099,'ona',11.111,2),(761,7526114,7526099,'nal',11.111,2),(761,7526115,7526106,'pen',20,1),(761,7526116,7526106,'end',20,1),(761,7526117,7526106,'ndi',20,1),(761,7526118,7526106,'din',20,1),(761,7526119,7526106,'ing',20,1),(761,7526120,7526115,'mes',20,1),(761,7526121,7526115,'ess',20,1),(761,7526122,7526115,'ssa',20,1),(761,7526123,7526115,'sag',20,1),(761,7526124,7526115,'age',20,1),(761,7526125,7526120,'wai',20,1),(761,7526126,7526120,'ait',20,1),(761,7526127,7526120,'iti',20,1),(761,7526128,7526120,'tin',20,1),(761,7526129,7526120,'ing',20,1),(761,7526130,7526125,'for',100,1),(761,7526131,7526130,'per',11.111,1),(761,7526132,7526130,'erf',11.111,1),(761,7526133,7526130,'rfo',11.111,1),(761,7526134,7526130,'for',11.111,1),(761,7526135,7526130,'orm',11.111,1),(761,7526136,7526130,'rma',11.111,1),(761,7526137,7526130,'man',11.111,1),(761,7526138,7526130,'anc',11.111,1),(761,7526139,7526130,'nce',11.111,1),(761,7526140,7526131,'ide',12.5,1),(761,7526141,7526131,'den',12.5,1),(761,7526142,7526131,'ent',12.5,1),(761,7526143,7526131,'nti',12.5,1),(761,7526144,7526131,'tif',12.5,1),(761,7526145,7526131,'ifi',12.5,1),(761,7526146,7526131,'fie',12.5,1),(761,7526147,7526131,'ier',12.5,1),(761,7526148,7526140,'vdi',33.333,3),(761,7526149,7526140,'dis',33.333,3),(761,7526150,7526140,'isk',33.333,3),(761,7526151,7526148,'nam',50,1),(761,7526152,7526148,'ame',50,1),(761,7526153,7526151,'typ',50,1),(761,7526154,7526151,'ype',50,1),(761,7526155,7526153,'dir',25,1),(761,7526156,7526153,'ire',25,1),(761,7526157,7526153,'rec',25,1),(761,7526158,7526153,'ect',25,1),(762,7526160,7526159,'naa',100,2),(762,7526161,7526160,'600',3.333,3),(762,7526162,7526160,'000',3.333,3),(762,7526163,7526160,'00c',3.333,3),(762,7526164,7526160,'0c2',3.333,3),(762,7526165,7526160,'c29',3.333,3),(762,7526166,7526160,'293',3.333,3),(762,7526167,7526160,'93b',3.333,3),(762,7526168,7526160,'3b2',3.333,3),(762,7526169,7526160,'b2d',3.333,3),(762,7526170,7526160,'2dc',3.333,3),(762,7526171,7526160,'dc5',3.333,3),(762,7526172,7526160,'c59',3.333,3),(762,7526173,7526160,'597',3.333,3),(762,7526174,7526160,'97b',3.333,3),(762,7526175,7526160,'7bc',3.333,3),(762,7526176,7526160,'bc3',3.333,3),(762,7526177,7526160,'c34',3.333,3),(762,7526178,7526160,'342',3.333,3),(762,7526179,7526160,'428',3.333,3),(762,7526180,7526160,'281',3.333,3),(762,7526181,7526160,'818',3.333,3),(762,7526182,7526160,'189',3.333,3),(762,7526183,7526160,'893',3.333,3),(762,7526184,7526160,'935',3.333,3),(762,7526185,7526160,'354',3.333,3),(762,7526186,7526160,'54d',3.333,3),(762,7526187,7526160,'4d0',3.333,3),(762,7526188,7526160,'d0b',3.333,3),(762,7526189,7526160,'0bd',3.333,3),(762,7526190,7526160,'bd2',3.333,3),(762,7526191,7526161,'mon',100,1),(762,7526192,7526191,'201',50,1),(762,7526193,7526191,'013',50,1),(762,7526194,7526192,'adm',33.333,3),(762,7526195,7526192,'dmi',33.333,3),(762,7526196,7526192,'min',33.333,3),(762,7526197,7526194,'cap',16.667,1),(762,7526198,7526194,'apa',16.667,1),(762,7526199,7526194,'pac',16.667,1),(762,7526200,7526194,'aci',16.667,1),(762,7526201,7526194,'cit',16.667,1),(762,7526202,7526194,'ity',16.667,1),(762,7526203,7526197,'pat',50,1),(762,7526204,7526197,'ath',50,1),(762,7526205,7526203,'fre',14.286,1),(762,7526206,7526203,'ree',14.286,1),(762,7526207,7526203,'ees',14.286,1),(762,7526208,7526203,'esp',14.286,1),(762,7526209,7526203,'spa',14.286,1),(762,7526210,7526203,'pac',14.286,1),(762,7526211,7526203,'ace',14.286,1),(762,7526212,7526205,'dis',50,1),(762,7526213,7526205,'isk',50,1),(762,7526214,7526212,'ind',33.333,1),(762,7526215,7526212,'nde',33.333,1),(762,7526216,7526212,'dex',33.333,1),(762,7526217,7526214,'adm',8.333,1),(762,7526218,7526214,'dmi',8.333,1),(762,7526219,7526214,'min',8.333,1),(762,7526220,7526214,'ini',8.333,1),(762,7526221,7526214,'nis',8.333,1),(762,7526222,7526214,'ist',8.333,1),(762,7526223,7526214,'str',8.333,1),(762,7526224,7526214,'tra',8.333,1),(762,7526225,7526214,'rat',8.333,1),(762,7526226,7526214,'ati',8.333,1),(762,7526227,7526214,'tio',8.333,1),(762,7526228,7526214,'ion',8.333,1),(762,7526229,7526217,'sta',33.333,3),(762,7526230,7526217,'tat',33.333,3),(762,7526231,7526217,'ate',33.333,3),(762,7526232,7526229,'ena',20,2),(762,7526233,7526229,'nab',20,2),(762,7526234,7526229,'abl',20,2),(762,7526235,7526229,'ble',20,2),(762,7526236,7526229,'led',20,2),(762,7526237,7526232,'cac',33.333,2),(762,7526238,7526232,'ach',33.333,2),(762,7526239,7526232,'che',33.333,2),(762,7526240,7526237,'mod',50,1),(762,7526241,7526237,'ode',50,1),(762,7526242,7526240,'wri',14.286,1),(762,7526243,7526240,'rit',14.286,1),(762,7526244,7526240,'ite',14.286,1),(762,7526245,7526240,'tet',14.286,1),(762,7526246,7526240,'eth',14.286,1),(762,7526247,7526240,'thr',14.286,1),(762,7526248,7526240,'hru',14.286,1),(762,7526249,7526242,'ope',11.111,2),(762,7526250,7526242,'per',11.111,2),(762,7526251,7526242,'era',11.111,2),(762,7526252,7526242,'rat',11.111,2),(762,7526253,7526242,'ati',11.111,2),(762,7526254,7526242,'tio',11.111,2),(762,7526255,7526242,'ion',11.111,2),(762,7526256,7526242,'ona',11.111,2),(762,7526257,7526242,'nal',11.111,2),(762,7526258,7526249,'pen',20,1),(762,7526259,7526249,'end',20,1),(762,7526260,7526249,'ndi',20,1),(762,7526261,7526249,'din',20,1),(762,7526262,7526249,'ing',20,1),(762,7526263,7526258,'mes',20,1),(762,7526264,7526258,'ess',20,1),(762,7526265,7526258,'ssa',20,1),(762,7526266,7526258,'sag',20,1),(762,7526267,7526258,'age',20,1),(762,7526268,7526263,'wai',20,1),(762,7526269,7526263,'ait',20,1),(762,7526270,7526263,'iti',20,1),(762,7526271,7526263,'tin',20,1),(762,7526272,7526263,'ing',20,1),(762,7526273,7526268,'for',100,1),(762,7526274,7526273,'per',11.111,1),(762,7526275,7526273,'erf',11.111,1),(762,7526276,7526273,'rfo',11.111,1),(762,7526277,7526273,'for',11.111,1),(762,7526278,7526273,'orm',11.111,1),(762,7526279,7526273,'rma',11.111,1),(762,7526280,7526273,'man',11.111,1),(762,7526281,7526273,'anc',11.111,1),(762,7526282,7526273,'nce',11.111,1),(762,7526283,7526274,'ide',12.5,1),(762,7526284,7526274,'den',12.5,1),(762,7526285,7526274,'ent',12.5,1),(762,7526286,7526274,'nti',12.5,1),(762,7526287,7526274,'tif',12.5,1),(762,7526288,7526274,'ifi',12.5,1),(762,7526289,7526274,'fie',12.5,1),(762,7526290,7526274,'ier',12.5,1),(762,7526291,7526283,'vdi',33.333,3),(762,7526292,7526283,'dis',33.333,3),(762,7526293,7526283,'isk',33.333,3),(762,7526294,7526291,'nam',50,1),(762,7526295,7526291,'ame',50,1),(762,7526296,7526294,'typ',50,1),(762,7526297,7526294,'ype',50,1),(762,7526298,7526296,'dir',25,1),(762,7526299,7526296,'ire',25,1),(762,7526300,7526296,'rec',25,1),(762,7526301,7526296,'ect',25,1),(763,7526303,7526302,'att',12.5,1),(763,7526304,7526302,'ttr',12.5,1),(763,7526305,7526302,'tri',12.5,1),(763,7526306,7526302,'rib',12.5,1),(763,7526307,7526302,'ibu',12.5,1),(763,7526308,7526302,'but',12.5,1),(763,7526309,7526302,'ute',12.5,1),(763,7526310,7526302,'tes',12.5,1),(763,7526311,7526303,'ref',20,3),(763,7526312,7526303,'efr',20,3),(763,7526313,7526303,'fre',20,3),(763,7526314,7526303,'res',20,3),(763,7526315,7526303,'esh',20,3),(763,7526316,7526311,'hos',50,2),(763,7526317,7526311,'ost',50,2),(763,7526318,7526316,'nam',50,2),(763,7526319,7526316,'ame',50,2),(763,7526320,7526318,'hg3',8.333,1),(763,7526321,7526318,'g32',8.333,1),(763,7526322,7526318,'32v',8.333,1),(763,7526323,7526318,'2vm',8.333,1),(763,7526324,7526318,'vm1',8.333,1),(763,7526325,7526318,'m10',8.333,1),(763,7526326,7526318,'10w',8.333,1),(763,7526327,7526318,'0w2',8.333,1),(763,7526328,7526318,'w2k',8.333,1),(763,7526329,7526318,'2k8',8.333,1),(763,7526330,7526318,'k8r',8.333,1),(763,7526331,7526318,'8r2',8.333,1),(763,7526332,7526320,'gdl',100,1),(763,7526333,7526332,'eng',25,1),(763,7526334,7526332,'ngl',25,1),(763,7526335,7526332,'gla',25,1),(763,7526336,7526332,'lab',25,1),(763,7526337,7526333,'net',25,1),(763,7526338,7526333,'eta',25,1),(763,7526339,7526333,'tap',25,1),(763,7526340,7526333,'app',25,1),(763,7526341,7526337,'com',100,1),(763,7526342,7526341,'mem',25,3),(763,7526343,7526341,'emo',25,3),(763,7526344,7526341,'mor',25,3),(763,7526345,7526341,'ory',25,3),(763,7526346,7526342,'siz',50,2),(763,7526347,7526342,'ize',50,2),(763,7526348,7526346,'614',50,1),(763,7526349,7526346,'144',50,1),(763,7526350,7526348,'cpu',100,1),(763,7526351,7526350,'usa',33.333,3),(763,7526352,7526350,'sag',33.333,3),(763,7526353,7526350,'age',33.333,3),(763,7526354,7526351,'mhz',100,1),(763,7526355,7526354,'add',20,1),(763,7526356,7526354,'ddr',20,1),(763,7526357,7526354,'dre',20,1),(763,7526358,7526354,'res',20,1),(763,7526359,7526354,'ess',20,1),(763,7526360,7526355,'226',100,1),(763,7526361,7526360,'147',100,1),(763,7526362,7526361,'212',100,1),(763,7526363,7526362,'378',50,1),(763,7526364,7526362,'786',50,1),(763,7526365,7526363,'gue',33.333,2),(763,7526366,7526363,'ues',33.333,2),(763,7526367,7526363,'est',33.333,2),(763,7526368,7526365,'vmw',25,2),(763,7526369,7526365,'mwa',25,2),(763,7526370,7526365,'war',25,2),(763,7526371,7526365,'are',25,2),(763,7526372,7526368,'too',33.333,2),(763,7526373,7526368,'ool',33.333,2),(763,7526374,7526368,'ols',33.333,2),(763,7526375,7526372,'run',20,1),(763,7526376,7526372,'unn',20,1),(763,7526377,7526372,'nni',20,1),(763,7526378,7526372,'nin',20,1),(763,7526379,7526372,'ing',20,1),(763,7526380,7526375,'and',100,1),(763,7526381,7526380,'the',100,1),(763,7526382,7526381,'ver',20,2),(763,7526383,7526381,'ers',20,2),(763,7526384,7526381,'rsi',20,2),(763,7526385,7526381,'sio',20,2),(763,7526386,7526381,'ion',20,2),(763,7526387,7526382,'cur',20,1),(763,7526388,7526382,'urr',20,1),(763,7526389,7526382,'rre',20,1),(763,7526390,7526382,'ren',20,1),(763,7526391,7526382,'ent',20,1),(763,7526392,7526387,'mic',14.286,1),(763,7526393,7526387,'icr',14.286,1),(763,7526394,7526387,'cro',14.286,1),(763,7526395,7526387,'ros',14.286,1),(763,7526396,7526387,'oso',14.286,1),(763,7526397,7526387,'sof',14.286,1),(763,7526398,7526387,'oft',14.286,1),(763,7526399,7526392,'win',20,1),(763,7526400,7526392,'ind',20,1),(763,7526401,7526392,'ndo',20,1),(763,7526402,7526392,'dow',20,1),(763,7526403,7526392,'ows',20,1),(763,7526404,7526399,'ser',25,1),(763,7526405,7526399,'erv',25,1),(763,7526406,7526399,'rve',25,1),(763,7526407,7526399,'ver',25,1),(763,7526408,7526404,'200',50,1),(763,7526409,7526404,'008',50,1),(763,7526410,7526408,'64b',33.333,1),(763,7526411,7526408,'4bi',33.333,1),(763,7526412,7526408,'bit',33.333,1),(763,7526413,7526410,'pat',50,1),(763,7526414,7526410,'ath',50,1),(763,7526415,7526413,'rx6',33.333,1),(763,7526416,7526413,'x60',33.333,1),(763,7526417,7526413,'600',33.333,1),(763,7526418,7526415,'vmf',20,1),(763,7526419,7526415,'mfi',20,1),(763,7526420,7526415,'fil',20,1),(763,7526421,7526415,'ile',20,1),(763,7526422,7526415,'les',20,1),(763,7526423,7526418,'hgw',8.333,2),(763,7526424,7526418,'gw2',8.333,2),(763,7526425,7526418,'w2k',8.333,2),(763,7526426,7526418,'2k8',8.333,2),(763,7526427,7526418,'k8r',8.333,2),(763,7526428,7526418,'8r2',8.333,2),(763,7526429,7526418,'r23',8.333,2),(763,7526430,7526418,'232',8.333,2),(763,7526431,7526418,'32v',8.333,2),(763,7526432,7526418,'2vm',8.333,2),(763,7526433,7526418,'vm1',8.333,2),(763,7526434,7526418,'m10',8.333,2),(763,7526435,7526423,'vmx',100,1),(763,7526436,7526435,'fla',33.333,1),(763,7526437,7526435,'las',33.333,1),(763,7526438,7526435,'ash',33.333,1),(763,7526439,7526436,'acc',33.333,1),(763,7526440,7526436,'cce',33.333,1),(763,7526441,7526436,'cel',33.333,1),(763,7526442,7526439,'con',9.091,1),(763,7526443,7526439,'onf',9.091,1),(763,7526444,7526439,'nfi',9.091,1),(763,7526445,7526439,'fig',9.091,1),(763,7526446,7526439,'igu',9.091,1),(763,7526447,7526439,'gur',9.091,1),(763,7526448,7526439,'ura',9.091,1),(763,7526449,7526439,'rat',9.091,1),(763,7526450,7526439,'ati',9.091,1),(763,7526451,7526439,'tio',9.091,1),(763,7526452,7526439,'ion',9.091,1),(763,7526453,7526442,'age',33.333,1),(763,7526454,7526442,'gen',33.333,1),(763,7526455,7526442,'ent',33.333,1),(763,7526456,7526453,'193',16.667,1),(763,7526457,7526453,'938',16.667,1),(763,7526458,7526453,'380',16.667,1),(763,7526459,7526453,'809',16.667,1),(763,7526460,7526453,'097',16.667,1),(763,7526461,7526453,'979',16.667,1),(763,7526462,7526456,'cac',33.333,4),(763,7526463,7526456,'ach',33.333,4),(763,7526464,7526456,'che',33.333,4),(763,7526465,7526462,'sta',33.333,2),(763,7526466,7526462,'tat',33.333,2),(763,7526467,7526462,'ate',33.333,2),(763,7526468,7526465,'dis',16.667,2),(763,7526469,7526465,'isa',16.667,2),(763,7526470,7526465,'sab',16.667,2),(763,7526471,7526465,'abl',16.667,2),(763,7526472,7526465,'ble',16.667,2),(763,7526473,7526465,'led',16.667,2),(763,7526474,7526468,'ope',11.111,2),(763,7526475,7526468,'per',11.111,2),(763,7526476,7526468,'era',11.111,2),(763,7526477,7526468,'rat',11.111,2),(763,7526478,7526468,'ati',11.111,2),(763,7526479,7526468,'tio',11.111,2),(763,7526480,7526468,'ion',11.111,2),(763,7526481,7526468,'ona',11.111,2),(763,7526482,7526468,'nal',11.111,2),(763,7526483,7526474,'mod',50,1),(763,7526484,7526474,'ode',50,1),(763,7526485,7526483,'wri',14.286,1),(763,7526486,7526483,'rit',14.286,1),(763,7526487,7526483,'ite',14.286,1),(763,7526488,7526483,'tet',14.286,1),(763,7526489,7526483,'eth',14.286,1),(763,7526490,7526483,'thr',14.286,1),(763,7526491,7526483,'hru',14.286,1),(763,7526492,7526485,'mes',20,1),(763,7526493,7526485,'ess',20,1),(763,7526494,7526485,'ssa',20,1),(763,7526495,7526485,'sag',20,1),(763,7526496,7526485,'age',20,1),(763,7526497,7526492,'for',25,1),(763,7526498,7526492,'orm',25,1),(763,7526499,7526492,'rma',25,1),(763,7526500,7526492,'mat',25,1),(763,7526501,7526497,'100',100,1),(763,7526502,7526501,'com',16.667,1),(763,7526503,7526501,'omp',16.667,1),(763,7526504,7526501,'mpl',16.667,1),(763,7526505,7526501,'ple',16.667,1),(763,7526506,7526501,'let',16.667,1),(763,7526507,7526501,'ete',16.667,1),(763,7526508,7526502,'met',20,3),(763,7526509,7526502,'etr',20,3),(763,7526510,7526502,'tri',20,3),(763,7526511,7526502,'ric',20,3),(763,7526512,7526502,'ics',20,3),(763,7526513,7526508,'ena',20,1),(763,7526514,7526508,'nab',20,1),(763,7526515,7526508,'abl',20,1),(763,7526516,7526508,'ble',20,1),(763,7526517,7526508,'led',20,1),(763,7526518,7526513,'vir',20,1),(763,7526519,7526513,'irt',20,1),(763,7526520,7526513,'rtu',20,1),(763,7526521,7526513,'tua',20,1),(763,7526522,7526513,'ual',20,1),(763,7526523,7526518,'dis',50,1),(763,7526524,7526518,'isk',50,1),(764,7526526,7526525,'naa',100,2),(764,7526527,7526526,'600',3.333,3),(764,7526528,7526526,'000',3.333,3),(764,7526529,7526526,'00c',3.333,3),(764,7526530,7526526,'0c2',3.333,3),(764,7526531,7526526,'c29',3.333,3),(764,7526532,7526526,'296',3.333,3),(764,7526533,7526526,'96d',3.333,3),(764,7526534,7526526,'6d2',3.333,3),(764,7526535,7526526,'d29',3.333,3),(764,7526536,7526526,'290',3.333,3),(764,7526537,7526526,'905',3.333,3),(764,7526538,7526526,'053',3.333,3),(764,7526539,7526526,'531',3.333,3),(764,7526540,7526526,'311',3.333,3),(764,7526541,7526526,'11b',3.333,3),(764,7526542,7526526,'1bb',3.333,3),(764,7526543,7526526,'bb2',3.333,3),(764,7526544,7526526,'b23',3.333,3),(764,7526545,7526526,'23b',3.333,3),(764,7526546,7526526,'3b1',3.333,3),(764,7526547,7526526,'b17',3.333,3),(764,7526548,7526526,'17e',3.333,3),(764,7526549,7526526,'7ed',3.333,3),(764,7526550,7526526,'ed0',3.333,3),(764,7526551,7526526,'d00',3.333,3),(764,7526552,7526526,'002',3.333,3),(764,7526553,7526526,'027',3.333,3),(764,7526554,7526526,'278',3.333,3),(764,7526555,7526526,'786',3.333,3),(764,7526556,7526526,'86b',3.333,3),(764,7526557,7526527,'mon',100,1),(764,7526558,7526557,'201',50,1),(764,7526559,7526557,'013',50,1),(764,7526560,7526558,'adm',33.333,4),(764,7526561,7526558,'dmi',33.333,4),(764,7526562,7526558,'min',33.333,4),(764,7526563,7526560,'cap',16.667,1),(764,7526564,7526560,'apa',16.667,1),(764,7526565,7526560,'pac',16.667,1),(764,7526566,7526560,'aci',16.667,1),(764,7526567,7526560,'cit',16.667,1),(764,7526568,7526560,'ity',16.667,1),(764,7526569,7526563,'pat',50,1),(764,7526570,7526563,'ath',50,1),(764,7526571,7526569,'vol',25,1),(764,7526572,7526569,'olu',25,1),(764,7526573,7526569,'lum',25,1),(764,7526574,7526569,'ume',25,1),(764,7526575,7526571,'78e',3.333,1),(764,7526576,7526571,'8e3',3.333,1),(764,7526577,7526571,'e3f',3.333,1),(764,7526578,7526571,'3f1',3.333,1),(764,7526579,7526571,'f18',3.333,1),(764,7526580,7526571,'188',3.333,1),(764,7526581,7526571,'886',3.333,1),(764,7526582,7526571,'86d',3.333,1),(764,7526583,7526571,'6d8',3.333,1),(764,7526584,7526571,'d87',3.333,1),(764,7526585,7526571,'871',3.333,1),(764,7526586,7526571,'711',3.333,1),(764,7526587,7526571,'11e',3.333,1),(764,7526588,7526571,'1e1',3.333,1),(764,7526589,7526571,'e19',3.333,1),(764,7526590,7526571,'192',3.333,1),(764,7526591,7526571,'927',3.333,1),(764,7526592,7526571,'277',3.333,1),(764,7526593,7526571,'778',3.333,1),(764,7526594,7526571,'780',3.333,1),(764,7526595,7526571,'806',3.333,1),(764,7526596,7526571,'06e',3.333,1),(764,7526597,7526571,'6e6',3.333,1),(764,7526598,7526571,'e6f',3.333,1),(764,7526599,7526571,'6f6',3.333,1),(764,7526600,7526571,'f6e',3.333,1),(764,7526601,7526571,'6e6',3.333,1),(764,7526602,7526571,'e69',3.333,1),(764,7526603,7526571,'696',3.333,1),(764,7526604,7526571,'963',3.333,1),(764,7526605,7526575,'fre',14.286,1),(764,7526606,7526575,'ree',14.286,1),(764,7526607,7526575,'ees',14.286,1),(764,7526608,7526575,'esp',14.286,1),(764,7526609,7526575,'spa',14.286,1),(764,7526610,7526575,'pac',14.286,1),(764,7526611,7526575,'ace',14.286,1),(764,7526612,7526605,'dis',50,1),(764,7526613,7526605,'isk',50,1),(764,7526614,7526612,'ind',33.333,1),(764,7526615,7526612,'nde',33.333,1),(764,7526616,7526612,'dex',33.333,1),(764,7526617,7526614,'adm',8.333,1),(764,7526618,7526614,'dmi',8.333,1),(764,7526619,7526614,'min',8.333,1),(764,7526620,7526614,'ini',8.333,1),(764,7526621,7526614,'nis',8.333,1),(764,7526622,7526614,'ist',8.333,1),(764,7526623,7526614,'str',8.333,1),(764,7526624,7526614,'tra',8.333,1),(764,7526625,7526614,'rat',8.333,1),(764,7526626,7526614,'ati',8.333,1),(764,7526627,7526614,'tio',8.333,1),(764,7526628,7526614,'ion',8.333,1),(764,7526629,7526617,'sta',33.333,3),(764,7526630,7526617,'tat',33.333,3),(764,7526631,7526617,'ate',33.333,3),(764,7526632,7526629,'dis',16.667,4),(764,7526633,7526629,'isa',16.667,4),(764,7526634,7526629,'sab',16.667,4),(764,7526635,7526629,'abl',16.667,4),(764,7526636,7526629,'ble',16.667,4),(764,7526637,7526629,'led',16.667,4),(764,7526638,7526632,'cac',33.333,1),(764,7526639,7526632,'ach',33.333,1),(764,7526640,7526632,'che',33.333,1),(764,7526641,7526638,'mod',50,1),(764,7526642,7526638,'ode',50,1),(764,7526643,7526641,'wri',14.286,1),(764,7526644,7526641,'rit',14.286,1),(764,7526645,7526641,'ite',14.286,1),(764,7526646,7526641,'tet',14.286,1),(764,7526647,7526641,'eth',14.286,1),(764,7526648,7526641,'thr',14.286,1),(764,7526649,7526641,'hru',14.286,1),(764,7526650,7526643,'ope',11.111,2),(764,7526651,7526643,'per',11.111,2),(764,7526652,7526643,'era',11.111,2),(764,7526653,7526643,'rat',11.111,2),(764,7526654,7526643,'ati',11.111,2),(764,7526655,7526643,'tio',11.111,2),(764,7526656,7526643,'ion',11.111,2),(764,7526657,7526643,'ona',11.111,2),(764,7526658,7526643,'nal',11.111,2),(764,7526659,7526650,'mes',20,1),(764,7526660,7526650,'ess',20,1),(764,7526661,7526650,'ssa',20,1),(764,7526662,7526650,'sag',20,1),(764,7526663,7526650,'age',20,1),(764,7526664,7526659,'per',11.111,1),(764,7526665,7526659,'erf',11.111,1),(764,7526666,7526659,'rfo',11.111,1),(764,7526667,7526659,'for',11.111,1),(764,7526668,7526659,'orm',11.111,1),(764,7526669,7526659,'rma',11.111,1),(764,7526670,7526659,'man',11.111,1),(764,7526671,7526659,'anc',11.111,1),(764,7526672,7526659,'nce',11.111,1),(764,7526673,7526664,'ide',12.5,1),(764,7526674,7526664,'den',12.5,1),(764,7526675,7526664,'ent',12.5,1),(764,7526676,7526664,'nti',12.5,1),(764,7526677,7526664,'tif',12.5,1),(764,7526678,7526664,'ifi',12.5,1),(764,7526679,7526664,'fie',12.5,1),(764,7526680,7526664,'ier',12.5,1),(764,7526681,7526673,'vdi',33.333,3),(764,7526682,7526673,'dis',33.333,3),(764,7526683,7526673,'isk',33.333,3),(764,7526684,7526681,'nam',50,1),(764,7526685,7526681,'ame',50,1),(764,7526686,7526684,'typ',50,1),(764,7526687,7526684,'ype',50,1),(764,7526688,7526686,'dir',25,1),(764,7526689,7526686,'ire',25,1),(764,7526690,7526686,'rec',25,1),(764,7526691,7526686,'ect',25,1),(765,7526693,7526692,'naa',100,2),(765,7526694,7526693,'600',3.333,3),(765,7526695,7526693,'00a',3.333,3),(765,7526696,7526693,'0a0',3.333,3),(765,7526697,7526693,'a09',3.333,3),(765,7526698,7526693,'098',3.333,3),(765,7526699,7526693,'980',3.333,3),(765,7526700,7526693,'804',3.333,3),(765,7526701,7526693,'044',3.333,3),(765,7526702,7526693,'443',3.333,3),(765,7526703,7526693,'430',3.333,3),(765,7526704,7526693,'307',3.333,3),(765,7526705,7526693,'072',3.333,3),(765,7526706,7526693,'725',3.333,3),(765,7526707,7526693,'259',3.333,3),(765,7526708,7526693,'593',3.333,3),(765,7526709,7526693,'931',3.333,3),(765,7526710,7526693,'313',3.333,3),(765,7526711,7526693,'13f',3.333,3),(765,7526712,7526693,'3f3',3.333,3),(765,7526713,7526693,'f33',3.333,3),(765,7526714,7526693,'334',3.333,3),(765,7526715,7526693,'345',3.333,3),(765,7526716,7526693,'455',3.333,3),(765,7526717,7526693,'556',3.333,3),(765,7526718,7526693,'563',3.333,3),(765,7526719,7526693,'639',3.333,3),(765,7526720,7526693,'393',3.333,3),(765,7526721,7526693,'934',3.333,3),(765,7526722,7526693,'344',3.333,3),(765,7526723,7526693,'44d',3.333,3),(765,7526724,7526694,'mon',100,1),(765,7526725,7526724,'201',50,1),(765,7526726,7526724,'013',50,1),(765,7526727,7526725,'adm',33.333,4),(765,7526728,7526725,'dmi',33.333,4),(765,7526729,7526725,'min',33.333,4),(765,7526730,7526727,'cap',16.667,1),(765,7526731,7526727,'apa',16.667,1),(765,7526732,7526727,'pac',16.667,1),(765,7526733,7526727,'aci',16.667,1),(765,7526734,7526727,'cit',16.667,1),(765,7526735,7526727,'ity',16.667,1),(765,7526736,7526730,'pat',50,1),(765,7526737,7526730,'ath',50,1),(765,7526738,7526736,'fre',14.286,1),(765,7526739,7526736,'ree',14.286,1),(765,7526740,7526736,'ees',14.286,1),(765,7526741,7526736,'esp',14.286,1),(765,7526742,7526736,'spa',14.286,1),(765,7526743,7526736,'pac',14.286,1),(765,7526744,7526736,'ace',14.286,1),(765,7526745,7526738,'dis',50,1),(765,7526746,7526738,'isk',50,1),(765,7526747,7526745,'ind',33.333,1),(765,7526748,7526745,'nde',33.333,1),(765,7526749,7526745,'dex',33.333,1),(765,7526750,7526747,'adm',8.333,1),(765,7526751,7526747,'dmi',8.333,1),(765,7526752,7526747,'min',8.333,1),(765,7526753,7526747,'ini',8.333,1),(765,7526754,7526747,'nis',8.333,1),(765,7526755,7526747,'ist',8.333,1),(765,7526756,7526747,'str',8.333,1),(765,7526757,7526747,'tra',8.333,1),(765,7526758,7526747,'rat',8.333,1),(765,7526759,7526747,'ati',8.333,1),(765,7526760,7526747,'tio',8.333,1),(765,7526761,7526747,'ion',8.333,1),(765,7526762,7526750,'sta',33.333,3),(765,7526763,7526750,'tat',33.333,3),(765,7526764,7526750,'ate',33.333,3),(765,7526765,7526762,'dis',16.667,4),(765,7526766,7526762,'isa',16.667,4),(765,7526767,7526762,'sab',16.667,4),(765,7526768,7526762,'abl',16.667,4),(765,7526769,7526762,'ble',16.667,4),(765,7526770,7526762,'led',16.667,4),(765,7526771,7526765,'cac',33.333,1),(765,7526772,7526765,'ach',33.333,1),(765,7526773,7526765,'che',33.333,1),(765,7526774,7526771,'mod',50,1),(765,7526775,7526771,'ode',50,1),(765,7526776,7526774,'wri',14.286,1),(765,7526777,7526774,'rit',14.286,1),(765,7526778,7526774,'ite',14.286,1),(765,7526779,7526774,'tet',14.286,1),(765,7526780,7526774,'eth',14.286,1),(765,7526781,7526774,'thr',14.286,1),(765,7526782,7526774,'hru',14.286,1),(765,7526783,7526776,'ope',11.111,2),(765,7526784,7526776,'per',11.111,2),(765,7526785,7526776,'era',11.111,2),(765,7526786,7526776,'rat',11.111,2),(765,7526787,7526776,'ati',11.111,2),(765,7526788,7526776,'tio',11.111,2),(765,7526789,7526776,'ion',11.111,2),(765,7526790,7526776,'ona',11.111,2),(765,7526791,7526776,'nal',11.111,2),(765,7526792,7526783,'mes',20,1),(765,7526793,7526783,'ess',20,1),(765,7526794,7526783,'ssa',20,1),(765,7526795,7526783,'sag',20,1),(765,7526796,7526783,'age',20,1),(765,7526797,7526792,'per',11.111,1),(765,7526798,7526792,'erf',11.111,1),(765,7526799,7526792,'rfo',11.111,1),(765,7526800,7526792,'for',11.111,1),(765,7526801,7526792,'orm',11.111,1),(765,7526802,7526792,'rma',11.111,1),(765,7526803,7526792,'man',11.111,1),(765,7526804,7526792,'anc',11.111,1),(765,7526805,7526792,'nce',11.111,1),(765,7526806,7526797,'ide',12.5,1),(765,7526807,7526797,'den',12.5,1),(765,7526808,7526797,'ent',12.5,1),(765,7526809,7526797,'nti',12.5,1),(765,7526810,7526797,'tif',12.5,1),(765,7526811,7526797,'ifi',12.5,1),(765,7526812,7526797,'fie',12.5,1),(765,7526813,7526797,'ier',12.5,1),(765,7526814,7526806,'vdi',33.333,3),(765,7526815,7526806,'dis',33.333,3),(765,7526816,7526806,'isk',33.333,3),(765,7526817,7526814,'nam',50,1),(765,7526818,7526814,'ame',50,1),(765,7526819,7526817,'typ',50,1),(765,7526820,7526817,'ype',50,1),(765,7526821,7526819,'dir',25,1),(765,7526822,7526819,'ire',25,1),(765,7526823,7526819,'rec',25,1),(765,7526824,7526819,'ect',25,1),(766,7526826,7526825,'naa',100,2),(766,7526827,7526826,'600',3.333,3),(766,7526828,7526826,'00a',3.333,3),(766,7526829,7526826,'0a0',3.333,3),(766,7526830,7526826,'a09',3.333,3),(766,7526831,7526826,'098',3.333,3),(766,7526832,7526826,'980',3.333,3),(766,7526833,7526826,'804',3.333,3),(766,7526834,7526826,'044',3.333,3),(766,7526835,7526826,'443',3.333,3),(766,7526836,7526826,'430',3.333,3),(766,7526837,7526826,'307',3.333,3),(766,7526838,7526826,'072',3.333,3),(766,7526839,7526826,'725',3.333,3),(766,7526840,7526826,'259',3.333,3),(766,7526841,7526826,'593',3.333,3),(766,7526842,7526826,'931',3.333,3),(766,7526843,7526826,'313',3.333,3),(766,7526844,7526826,'13f',3.333,3),(766,7526845,7526826,'3f3',3.333,3),(766,7526846,7526826,'f33',3.333,3),(766,7526847,7526826,'334',3.333,3),(766,7526848,7526826,'345',3.333,3),(766,7526849,7526826,'455',3.333,3),(766,7526850,7526826,'556',3.333,3),(766,7526851,7526826,'563',3.333,3),(766,7526852,7526826,'639',3.333,3),(766,7526853,7526826,'393',3.333,3),(766,7526854,7526826,'934',3.333,3),(766,7526855,7526826,'344',3.333,3),(766,7526856,7526826,'44e',3.333,3),(766,7526857,7526827,'mon',100,1),(766,7526858,7526857,'201',50,1),(766,7526859,7526857,'013',50,1),(766,7526860,7526858,'adm',33.333,4),(766,7526861,7526858,'dmi',33.333,4),(766,7526862,7526858,'min',33.333,4),(766,7526863,7526860,'cap',16.667,1),(766,7526864,7526860,'apa',16.667,1),(766,7526865,7526860,'pac',16.667,1),(766,7526866,7526860,'aci',16.667,1),(766,7526867,7526860,'cit',16.667,1),(766,7526868,7526860,'ity',16.667,1),(766,7526869,7526863,'pat',50,1),(766,7526870,7526863,'ath',50,1),(766,7526871,7526869,'fre',14.286,1),(766,7526872,7526869,'ree',14.286,1),(766,7526873,7526869,'ees',14.286,1),(766,7526874,7526869,'esp',14.286,1),(766,7526875,7526869,'spa',14.286,1),(766,7526876,7526869,'pac',14.286,1),(766,7526877,7526869,'ace',14.286,1),(766,7526878,7526871,'dis',50,1),(766,7526879,7526871,'isk',50,1),(766,7526880,7526878,'ind',33.333,1),(766,7526881,7526878,'nde',33.333,1),(766,7526882,7526878,'dex',33.333,1),(766,7526883,7526880,'adm',8.333,1),(766,7526884,7526880,'dmi',8.333,1),(766,7526885,7526880,'min',8.333,1),(766,7526886,7526880,'ini',8.333,1),(766,7526887,7526880,'nis',8.333,1),(766,7526888,7526880,'ist',8.333,1),(766,7526889,7526880,'str',8.333,1),(766,7526890,7526880,'tra',8.333,1),(766,7526891,7526880,'rat',8.333,1),(766,7526892,7526880,'ati',8.333,1),(766,7526893,7526880,'tio',8.333,1),(766,7526894,7526880,'ion',8.333,1),(766,7526895,7526883,'sta',33.333,3),(766,7526896,7526883,'tat',33.333,3),(766,7526897,7526883,'ate',33.333,3),(766,7526898,7526895,'dis',16.667,4),(766,7526899,7526895,'isa',16.667,4),(766,7526900,7526895,'sab',16.667,4),(766,7526901,7526895,'abl',16.667,4),(766,7526902,7526895,'ble',16.667,4),(766,7526903,7526895,'led',16.667,4),(766,7526904,7526898,'cac',33.333,1),(766,7526905,7526898,'ach',33.333,1),(766,7526906,7526898,'che',33.333,1),(766,7526907,7526904,'mod',50,1),(766,7526908,7526904,'ode',50,1),(766,7526909,7526907,'wri',14.286,1),(766,7526910,7526907,'rit',14.286,1),(766,7526911,7526907,'ite',14.286,1),(766,7526912,7526907,'tet',14.286,1),(766,7526913,7526907,'eth',14.286,1),(766,7526914,7526907,'thr',14.286,1),(766,7526915,7526907,'hru',14.286,1),(766,7526916,7526909,'ope',11.111,2),(766,7526917,7526909,'per',11.111,2),(766,7526918,7526909,'era',11.111,2),(766,7526919,7526909,'rat',11.111,2),(766,7526920,7526909,'ati',11.111,2),(766,7526921,7526909,'tio',11.111,2),(766,7526922,7526909,'ion',11.111,2),(766,7526923,7526909,'ona',11.111,2),(766,7526924,7526909,'nal',11.111,2),(766,7526925,7526916,'mes',20,1),(766,7526926,7526916,'ess',20,1),(766,7526927,7526916,'ssa',20,1),(766,7526928,7526916,'sag',20,1),(766,7526929,7526916,'age',20,1),(766,7526930,7526925,'per',11.111,1),(766,7526931,7526925,'erf',11.111,1),(766,7526932,7526925,'rfo',11.111,1),(766,7526933,7526925,'for',11.111,1),(766,7526934,7526925,'orm',11.111,1),(766,7526935,7526925,'rma',11.111,1),(766,7526936,7526925,'man',11.111,1),(766,7526937,7526925,'anc',11.111,1),(766,7526938,7526925,'nce',11.111,1),(766,7526939,7526930,'ide',12.5,1),(766,7526940,7526930,'den',12.5,1),(766,7526941,7526930,'ent',12.5,1),(766,7526942,7526930,'nti',12.5,1),(766,7526943,7526930,'tif',12.5,1),(766,7526944,7526930,'ifi',12.5,1),(766,7526945,7526930,'fie',12.5,1),(766,7526946,7526930,'ier',12.5,1),(766,7526947,7526939,'vdi',33.333,3),(766,7526948,7526939,'dis',33.333,3),(766,7526949,7526939,'isk',33.333,3),(766,7526950,7526947,'nam',50,1),(766,7526951,7526947,'ame',50,1),(766,7526952,7526950,'typ',50,1),(766,7526953,7526950,'ype',50,1),(766,7526954,7526952,'dir',25,1),(766,7526955,7526952,'ire',25,1),(766,7526956,7526952,'rec',25,1),(766,7526957,7526952,'ect',25,1),(767,7526959,7526958,'naa',100,2),(767,7526960,7526959,'600',3.333,3),(767,7526961,7526959,'00a',3.333,3),(767,7526962,7526959,'0a0',3.333,3),(767,7526963,7526959,'a09',3.333,3),(767,7526964,7526959,'098',3.333,3),(767,7526965,7526959,'980',3.333,3),(767,7526966,7526959,'804',3.333,3),(767,7526967,7526959,'044',3.333,3),(767,7526968,7526959,'443',3.333,3),(767,7526969,7526959,'430',3.333,3),(767,7526970,7526959,'307',3.333,3),(767,7526971,7526959,'075',3.333,3),(767,7526972,7526959,'753',3.333,3),(767,7526973,7526959,'535',3.333,3),(767,7526974,7526959,'357',3.333,3),(767,7526975,7526959,'573',3.333,3),(767,7526976,7526959,'732',3.333,3),(767,7526977,7526959,'32b',3.333,3),(767,7526978,7526959,'2b3',3.333,3),(767,7526979,7526959,'b33',3.333,3),(767,7526980,7526959,'334',3.333,3),(767,7526981,7526959,'345',3.333,3),(767,7526982,7526959,'457',3.333,3),(767,7526983,7526959,'571',3.333,3),(767,7526984,7526959,'715',3.333,3),(767,7526985,7526959,'153',3.333,3),(767,7526986,7526959,'533',3.333,3),(767,7526987,7526959,'336',3.333,3),(767,7526988,7526959,'363',3.333,3),(767,7526989,7526959,'638',3.333,3),(767,7526990,7526960,'mon',100,1),(767,7526991,7526990,'201',50,1),(767,7526992,7526990,'013',50,1),(767,7526993,7526991,'adm',33.333,4),(767,7526994,7526991,'dmi',33.333,4),(767,7526995,7526991,'min',33.333,4),(767,7526996,7526993,'cap',16.667,1),(767,7526997,7526993,'apa',16.667,1),(767,7526998,7526993,'pac',16.667,1),(767,7526999,7526993,'aci',16.667,1),(767,7527000,7526993,'cit',16.667,1),(767,7527001,7526993,'ity',16.667,1),(767,7527002,7526996,'pat',50,1),(767,7527003,7526996,'ath',50,1),(767,7527004,7527002,'fre',14.286,1),(767,7527005,7527002,'ree',14.286,1),(767,7527006,7527002,'ees',14.286,1),(767,7527007,7527002,'esp',14.286,1),(767,7527008,7527002,'spa',14.286,1),(767,7527009,7527002,'pac',14.286,1),(767,7527010,7527002,'ace',14.286,1),(767,7527011,7527004,'dis',50,1),(767,7527012,7527004,'isk',50,1),(767,7527013,7527011,'ind',33.333,1),(767,7527014,7527011,'nde',33.333,1),(767,7527015,7527011,'dex',33.333,1),(767,7527016,7527013,'adm',8.333,1),(767,7527017,7527013,'dmi',8.333,1),(767,7527018,7527013,'min',8.333,1),(767,7527019,7527013,'ini',8.333,1),(767,7527020,7527013,'nis',8.333,1),(767,7527021,7527013,'ist',8.333,1),(767,7527022,7527013,'str',8.333,1),(767,7527023,7527013,'tra',8.333,1),(767,7527024,7527013,'rat',8.333,1),(767,7527025,7527013,'ati',8.333,1),(767,7527026,7527013,'tio',8.333,1),(767,7527027,7527013,'ion',8.333,1),(767,7527028,7527016,'sta',33.333,3),(767,7527029,7527016,'tat',33.333,3),(767,7527030,7527016,'ate',33.333,3),(767,7527031,7527028,'dis',16.667,4),(767,7527032,7527028,'isa',16.667,4),(767,7527033,7527028,'sab',16.667,4),(767,7527034,7527028,'abl',16.667,4),(767,7527035,7527028,'ble',16.667,4),(767,7527036,7527028,'led',16.667,4),(767,7527037,7527031,'cac',33.333,1),(767,7527038,7527031,'ach',33.333,1),(767,7527039,7527031,'che',33.333,1),(767,7527040,7527037,'mod',50,1),(767,7527041,7527037,'ode',50,1),(767,7527042,7527040,'wri',14.286,1),(767,7527043,7527040,'rit',14.286,1),(767,7527044,7527040,'ite',14.286,1),(767,7527045,7527040,'tet',14.286,1),(767,7527046,7527040,'eth',14.286,1),(767,7527047,7527040,'thr',14.286,1),(767,7527048,7527040,'hru',14.286,1),(767,7527049,7527042,'ope',11.111,2),(767,7527050,7527042,'per',11.111,2),(767,7527051,7527042,'era',11.111,2),(767,7527052,7527042,'rat',11.111,2),(767,7527053,7527042,'ati',11.111,2),(767,7527054,7527042,'tio',11.111,2),(767,7527055,7527042,'ion',11.111,2),(767,7527056,7527042,'ona',11.111,2),(767,7527057,7527042,'nal',11.111,2),(767,7527058,7527049,'mes',20,1),(767,7527059,7527049,'ess',20,1),(767,7527060,7527049,'ssa',20,1),(767,7527061,7527049,'sag',20,1),(767,7527062,7527049,'age',20,1),(767,7527063,7527058,'per',11.111,1),(767,7527064,7527058,'erf',11.111,1),(767,7527065,7527058,'rfo',11.111,1),(767,7527066,7527058,'for',11.111,1),(767,7527067,7527058,'orm',11.111,1),(767,7527068,7527058,'rma',11.111,1),(767,7527069,7527058,'man',11.111,1),(767,7527070,7527058,'anc',11.111,1),(767,7527071,7527058,'nce',11.111,1),(767,7527072,7527063,'ide',12.5,1),(767,7527073,7527063,'den',12.5,1),(767,7527074,7527063,'ent',12.5,1),(767,7527075,7527063,'nti',12.5,1),(767,7527076,7527063,'tif',12.5,1),(767,7527077,7527063,'ifi',12.5,1),(767,7527078,7527063,'fie',12.5,1),(767,7527079,7527063,'ier',12.5,1),(767,7527080,7527072,'vdi',33.333,3),(767,7527081,7527072,'dis',33.333,3),(767,7527082,7527072,'isk',33.333,3),(767,7527083,7527080,'nam',50,1),(767,7527084,7527080,'ame',50,1),(767,7527085,7527083,'typ',50,1),(767,7527086,7527083,'ype',50,1),(767,7527087,7527085,'dir',25,1),(767,7527088,7527085,'ire',25,1),(767,7527089,7527085,'rec',25,1),(767,7527090,7527085,'ect',25,1),(768,7527092,7527091,'naa',100,2),(768,7527093,7527092,'600',3.333,3),(768,7527094,7527092,'00a',3.333,3),(768,7527095,7527092,'0a0',3.333,3),(768,7527096,7527092,'a09',3.333,3),(768,7527097,7527092,'098',3.333,3),(768,7527098,7527092,'980',3.333,3),(768,7527099,7527092,'804',3.333,3),(768,7527100,7527092,'044',3.333,3),(768,7527101,7527092,'443',3.333,3),(768,7527102,7527092,'430',3.333,3),(768,7527103,7527092,'307',3.333,3),(768,7527104,7527092,'075',3.333,3),(768,7527105,7527092,'753',3.333,3),(768,7527106,7527092,'535',3.333,3),(768,7527107,7527092,'357',3.333,3),(768,7527108,7527092,'573',3.333,3),(768,7527109,7527092,'732',3.333,3),(768,7527110,7527092,'32b',3.333,3),(768,7527111,7527092,'2b3',3.333,3),(768,7527112,7527092,'b33',3.333,3),(768,7527113,7527092,'334',3.333,3),(768,7527114,7527092,'345',3.333,3),(768,7527115,7527092,'457',3.333,3),(768,7527116,7527092,'571',3.333,3),(768,7527117,7527092,'715',3.333,3),(768,7527118,7527092,'153',3.333,3),(768,7527119,7527092,'533',3.333,3),(768,7527120,7527092,'336',3.333,3),(768,7527121,7527092,'363',3.333,3),(768,7527122,7527092,'639',3.333,3),(768,7527123,7527093,'mon',100,1),(768,7527124,7527123,'201',50,1),(768,7527125,7527123,'013',50,1),(768,7527126,7527124,'adm',33.333,4),(768,7527127,7527124,'dmi',33.333,4),(768,7527128,7527124,'min',33.333,4),(768,7527129,7527126,'cap',16.667,1),(768,7527130,7527126,'apa',16.667,1),(768,7527131,7527126,'pac',16.667,1),(768,7527132,7527126,'aci',16.667,1),(768,7527133,7527126,'cit',16.667,1),(768,7527134,7527126,'ity',16.667,1),(768,7527135,7527129,'pat',50,1),(768,7527136,7527129,'ath',50,1),(768,7527137,7527135,'fre',14.286,1),(768,7527138,7527135,'ree',14.286,1),(768,7527139,7527135,'ees',14.286,1),(768,7527140,7527135,'esp',14.286,1),(768,7527141,7527135,'spa',14.286,1),(768,7527142,7527135,'pac',14.286,1),(768,7527143,7527135,'ace',14.286,1),(768,7527144,7527137,'dis',50,1),(768,7527145,7527137,'isk',50,1),(768,7527146,7527144,'ind',33.333,1),(768,7527147,7527144,'nde',33.333,1),(768,7527148,7527144,'dex',33.333,1),(768,7527149,7527146,'adm',8.333,1),(768,7527150,7527146,'dmi',8.333,1),(768,7527151,7527146,'min',8.333,1),(768,7527152,7527146,'ini',8.333,1),(768,7527153,7527146,'nis',8.333,1),(768,7527154,7527146,'ist',8.333,1),(768,7527155,7527146,'str',8.333,1),(768,7527156,7527146,'tra',8.333,1),(768,7527157,7527146,'rat',8.333,1),(768,7527158,7527146,'ati',8.333,1),(768,7527159,7527146,'tio',8.333,1),(768,7527160,7527146,'ion',8.333,1),(768,7527161,7527149,'sta',33.333,3),(768,7527162,7527149,'tat',33.333,3),(768,7527163,7527149,'ate',33.333,3),(768,7527164,7527161,'dis',16.667,4),(768,7527165,7527161,'isa',16.667,4),(768,7527166,7527161,'sab',16.667,4),(768,7527167,7527161,'abl',16.667,4),(768,7527168,7527161,'ble',16.667,4),(768,7527169,7527161,'led',16.667,4),(768,7527170,7527164,'cac',33.333,1),(768,7527171,7527164,'ach',33.333,1),(768,7527172,7527164,'che',33.333,1),(768,7527173,7527170,'mod',50,1),(768,7527174,7527170,'ode',50,1),(768,7527175,7527173,'wri',14.286,1),(768,7527176,7527173,'rit',14.286,1),(768,7527177,7527173,'ite',14.286,1),(768,7527178,7527173,'tet',14.286,1),(768,7527179,7527173,'eth',14.286,1),(768,7527180,7527173,'thr',14.286,1),(768,7527181,7527173,'hru',14.286,1),(768,7527182,7527175,'ope',11.111,2),(768,7527183,7527175,'per',11.111,2),(768,7527184,7527175,'era',11.111,2),(768,7527185,7527175,'rat',11.111,2),(768,7527186,7527175,'ati',11.111,2),(768,7527187,7527175,'tio',11.111,2),(768,7527188,7527175,'ion',11.111,2),(768,7527189,7527175,'ona',11.111,2),(768,7527190,7527175,'nal',11.111,2),(768,7527191,7527182,'mes',20,1),(768,7527192,7527182,'ess',20,1),(768,7527193,7527182,'ssa',20,1),(768,7527194,7527182,'sag',20,1),(768,7527195,7527182,'age',20,1),(768,7527196,7527191,'per',11.111,1),(768,7527197,7527191,'erf',11.111,1),(768,7527198,7527191,'rfo',11.111,1),(768,7527199,7527191,'for',11.111,1),(768,7527200,7527191,'orm',11.111,1),(768,7527201,7527191,'rma',11.111,1),(768,7527202,7527191,'man',11.111,1),(768,7527203,7527191,'anc',11.111,1),(768,7527204,7527191,'nce',11.111,1),(768,7527205,7527196,'ide',12.5,1),(768,7527206,7527196,'den',12.5,1),(768,7527207,7527196,'ent',12.5,1),(768,7527208,7527196,'nti',12.5,1),(768,7527209,7527196,'tif',12.5,1),(768,7527210,7527196,'ifi',12.5,1),(768,7527211,7527196,'fie',12.5,1),(768,7527212,7527196,'ier',12.5,1),(768,7527213,7527205,'vdi',33.333,3),(768,7527214,7527205,'dis',33.333,3),(768,7527215,7527205,'isk',33.333,3),(768,7527216,7527213,'nam',50,1),(768,7527217,7527213,'ame',50,1),(768,7527218,7527216,'typ',50,1),(768,7527219,7527216,'ype',50,1),(768,7527220,7527218,'dir',25,1),(768,7527221,7527218,'ire',25,1),(768,7527222,7527218,'rec',25,1),(768,7527223,7527218,'ect',25,1),(769,7527225,7527224,'naa',100,2),(769,7527226,7527225,'600',3.333,3),(769,7527227,7527225,'000',3.333,3),(769,7527228,7527225,'00c',3.333,3),(769,7527229,7527225,'0c2',3.333,3),(769,7527230,7527225,'c29',3.333,3),(769,7527231,7527225,'29c',3.333,3),(769,7527232,7527225,'9c7',3.333,3),(769,7527233,7527225,'c74',3.333,3),(769,7527234,7527225,'740',3.333,3),(769,7527235,7527225,'401',3.333,3),(769,7527236,7527225,'018',3.333,3),(769,7527237,7527225,'184',3.333,3),(769,7527238,7527225,'84c',3.333,3),(769,7527239,7527225,'4c4',3.333,3),(769,7527240,7527225,'c44',3.333,3),(769,7527241,7527225,'44f',3.333,3),(769,7527242,7527225,'4fc',3.333,3),(769,7527243,7527225,'fc2',3.333,3),(769,7527244,7527225,'c28',3.333,3),(769,7527245,7527225,'287',3.333,3),(769,7527246,7527225,'874',3.333,3),(769,7527247,7527225,'740',3.333,3),(769,7527248,7527225,'405',3.333,3),(769,7527249,7527225,'05b',3.333,3),(769,7527250,7527225,'5b0',3.333,3),(769,7527251,7527225,'b08',3.333,3),(769,7527252,7527225,'08e',3.333,3),(769,7527253,7527225,'8ea',3.333,3),(769,7527254,7527225,'ea0',3.333,3),(769,7527255,7527225,'a0e',3.333,3),(769,7527256,7527226,'mon',100,1),(769,7527257,7527256,'201',50,1),(769,7527258,7527256,'013',50,1),(769,7527259,7527257,'adm',33.333,4),(769,7527260,7527257,'dmi',33.333,4),(769,7527261,7527257,'min',33.333,4),(769,7527262,7527259,'cap',16.667,1),(769,7527263,7527259,'apa',16.667,1),(769,7527264,7527259,'pac',16.667,1),(769,7527265,7527259,'aci',16.667,1),(769,7527266,7527259,'cit',16.667,1),(769,7527267,7527259,'ity',16.667,1),(769,7527268,7527262,'pat',50,1),(769,7527269,7527262,'ath',50,1),(769,7527270,7527268,'fre',14.286,1),(769,7527271,7527268,'ree',14.286,1),(769,7527272,7527268,'ees',14.286,1),(769,7527273,7527268,'esp',14.286,1),(769,7527274,7527268,'spa',14.286,1),(769,7527275,7527268,'pac',14.286,1),(769,7527276,7527268,'ace',14.286,1),(769,7527277,7527270,'dis',50,1),(769,7527278,7527270,'isk',50,1),(769,7527279,7527277,'ind',33.333,1),(769,7527280,7527277,'nde',33.333,1),(769,7527281,7527277,'dex',33.333,1),(769,7527282,7527279,'adm',8.333,1),(769,7527283,7527279,'dmi',8.333,1),(769,7527284,7527279,'min',8.333,1),(769,7527285,7527279,'ini',8.333,1),(769,7527286,7527279,'nis',8.333,1),(769,7527287,7527279,'ist',8.333,1),(769,7527288,7527279,'str',8.333,1),(769,7527289,7527279,'tra',8.333,1),(769,7527290,7527279,'rat',8.333,1),(769,7527291,7527279,'ati',8.333,1),(769,7527292,7527279,'tio',8.333,1),(769,7527293,7527279,'ion',8.333,1),(769,7527294,7527282,'sta',33.333,3),(769,7527295,7527282,'tat',33.333,3),(769,7527296,7527282,'ate',33.333,3),(769,7527297,7527294,'dis',16.667,4),(769,7527298,7527294,'isa',16.667,4),(769,7527299,7527294,'sab',16.667,4),(769,7527300,7527294,'abl',16.667,4),(769,7527301,7527294,'ble',16.667,4),(769,7527302,7527294,'led',16.667,4),(769,7527303,7527297,'cac',33.333,1),(769,7527304,7527297,'ach',33.333,1),(769,7527305,7527297,'che',33.333,1),(769,7527306,7527303,'mod',50,1),(769,7527307,7527303,'ode',50,1),(769,7527308,7527306,'wri',14.286,1),(769,7527309,7527306,'rit',14.286,1),(769,7527310,7527306,'ite',14.286,1),(769,7527311,7527306,'tet',14.286,1),(769,7527312,7527306,'eth',14.286,1),(769,7527313,7527306,'thr',14.286,1),(769,7527314,7527306,'hru',14.286,1),(769,7527315,7527308,'ope',11.111,2),(769,7527316,7527308,'per',11.111,2),(769,7527317,7527308,'era',11.111,2),(769,7527318,7527308,'rat',11.111,2),(769,7527319,7527308,'ati',11.111,2),(769,7527320,7527308,'tio',11.111,2),(769,7527321,7527308,'ion',11.111,2),(769,7527322,7527308,'ona',11.111,2),(769,7527323,7527308,'nal',11.111,2),(769,7527324,7527315,'mes',20,1),(769,7527325,7527315,'ess',20,1),(769,7527326,7527315,'ssa',20,1),(769,7527327,7527315,'sag',20,1),(769,7527328,7527315,'age',20,1),(769,7527329,7527324,'per',11.111,1),(769,7527330,7527324,'erf',11.111,1),(769,7527331,7527324,'rfo',11.111,1),(769,7527332,7527324,'for',11.111,1),(769,7527333,7527324,'orm',11.111,1),(769,7527334,7527324,'rma',11.111,1),(769,7527335,7527324,'man',11.111,1),(769,7527336,7527324,'anc',11.111,1),(769,7527337,7527324,'nce',11.111,1),(769,7527338,7527329,'ide',12.5,1),(769,7527339,7527329,'den',12.5,1),(769,7527340,7527329,'ent',12.5,1),(769,7527341,7527329,'nti',12.5,1),(769,7527342,7527329,'tif',12.5,1),(769,7527343,7527329,'ifi',12.5,1),(769,7527344,7527329,'fie',12.5,1),(769,7527345,7527329,'ier',12.5,1),(769,7527346,7527338,'vdi',33.333,3),(769,7527347,7527338,'dis',33.333,3),(769,7527348,7527338,'isk',33.333,3),(769,7527349,7527346,'nam',50,1),(769,7527350,7527346,'ame',50,1),(769,7527351,7527349,'typ',50,1),(769,7527352,7527349,'ype',50,1),(769,7527353,7527351,'dir',25,1),(769,7527354,7527351,'ire',25,1),(769,7527355,7527351,'rec',25,1),(769,7527356,7527351,'ect',25,1),(770,7527358,7527357,'naa',100,2),(770,7527359,7527358,'600',3.333,3),(770,7527360,7527358,'000',3.333,3),(770,7527361,7527358,'00c',3.333,3),(770,7527362,7527358,'0c2',3.333,3),(770,7527363,7527358,'c29',3.333,3),(770,7527364,7527358,'29b',3.333,3),(770,7527365,7527358,'9b0',3.333,3),(770,7527366,7527358,'b0b',3.333,3),(770,7527367,7527358,'0b3',3.333,3),(770,7527368,7527358,'b3d',3.333,3),(770,7527369,7527358,'3d1',3.333,3),(770,7527370,7527358,'d1f',3.333,3),(770,7527371,7527358,'1f1',3.333,3),(770,7527372,7527358,'f12',3.333,3),(770,7527373,7527358,'124',3.333,3),(770,7527374,7527358,'243',3.333,3),(770,7527375,7527358,'430',3.333,3),(770,7527376,7527358,'309',3.333,3),(770,7527377,7527358,'096',3.333,3),(770,7527378,7527358,'96c',3.333,3),(770,7527379,7527358,'6c4',3.333,3),(770,7527380,7527358,'c49',3.333,3),(770,7527381,7527358,'496',3.333,3),(770,7527382,7527358,'96d',3.333,3),(770,7527383,7527358,'6dc',3.333,3),(770,7527384,7527358,'dce',3.333,3),(770,7527385,7527358,'ce1',3.333,3),(770,7527386,7527358,'e13',3.333,3),(770,7527387,7527358,'132',3.333,3),(770,7527388,7527358,'32e',3.333,3),(770,7527389,7527359,'mon',100,1),(770,7527390,7527389,'201',50,1),(770,7527391,7527389,'013',50,1),(770,7527392,7527390,'adm',33.333,4),(770,7527393,7527390,'dmi',33.333,4),(770,7527394,7527390,'min',33.333,4),(770,7527395,7527392,'cap',16.667,1),(770,7527396,7527392,'apa',16.667,1),(770,7527397,7527392,'pac',16.667,1),(770,7527398,7527392,'aci',16.667,1),(770,7527399,7527392,'cit',16.667,1),(770,7527400,7527392,'ity',16.667,1),(770,7527401,7527395,'pat',50,1),(770,7527402,7527395,'ath',50,1),(770,7527403,7527401,'fre',14.286,1),(770,7527404,7527401,'ree',14.286,1),(770,7527405,7527401,'ees',14.286,1),(770,7527406,7527401,'esp',14.286,1),(770,7527407,7527401,'spa',14.286,1),(770,7527408,7527401,'pac',14.286,1),(770,7527409,7527401,'ace',14.286,1),(770,7527410,7527403,'dis',50,1),(770,7527411,7527403,'isk',50,1),(770,7527412,7527410,'ind',33.333,1),(770,7527413,7527410,'nde',33.333,1),(770,7527414,7527410,'dex',33.333,1),(770,7527415,7527412,'adm',8.333,1),(770,7527416,7527412,'dmi',8.333,1),(770,7527417,7527412,'min',8.333,1),(770,7527418,7527412,'ini',8.333,1),(770,7527419,7527412,'nis',8.333,1),(770,7527420,7527412,'ist',8.333,1),(770,7527421,7527412,'str',8.333,1),(770,7527422,7527412,'tra',8.333,1),(770,7527423,7527412,'rat',8.333,1),(770,7527424,7527412,'ati',8.333,1),(770,7527425,7527412,'tio',8.333,1),(770,7527426,7527412,'ion',8.333,1),(770,7527427,7527415,'sta',33.333,3),(770,7527428,7527415,'tat',33.333,3),(770,7527429,7527415,'ate',33.333,3),(770,7527430,7527427,'dis',16.667,4),(770,7527431,7527427,'isa',16.667,4),(770,7527432,7527427,'sab',16.667,4),(770,7527433,7527427,'abl',16.667,4),(770,7527434,7527427,'ble',16.667,4),(770,7527435,7527427,'led',16.667,4),(770,7527436,7527430,'cac',33.333,1),(770,7527437,7527430,'ach',33.333,1),(770,7527438,7527430,'che',33.333,1),(770,7527439,7527436,'mod',50,1),(770,7527440,7527436,'ode',50,1),(770,7527441,7527439,'wri',14.286,1),(770,7527442,7527439,'rit',14.286,1),(770,7527443,7527439,'ite',14.286,1),(770,7527444,7527439,'tet',14.286,1),(770,7527445,7527439,'eth',14.286,1),(770,7527446,7527439,'thr',14.286,1),(770,7527447,7527439,'hru',14.286,1),(770,7527448,7527441,'ope',11.111,2),(770,7527449,7527441,'per',11.111,2),(770,7527450,7527441,'era',11.111,2),(770,7527451,7527441,'rat',11.111,2),(770,7527452,7527441,'ati',11.111,2),(770,7527453,7527441,'tio',11.111,2),(770,7527454,7527441,'ion',11.111,2),(770,7527455,7527441,'ona',11.111,2),(770,7527456,7527441,'nal',11.111,2),(770,7527457,7527448,'mes',20,1),(770,7527458,7527448,'ess',20,1),(770,7527459,7527448,'ssa',20,1),(770,7527460,7527448,'sag',20,1),(770,7527461,7527448,'age',20,1),(770,7527462,7527457,'per',11.111,1),(770,7527463,7527457,'erf',11.111,1),(770,7527464,7527457,'rfo',11.111,1),(770,7527465,7527457,'for',11.111,1),(770,7527466,7527457,'orm',11.111,1),(770,7527467,7527457,'rma',11.111,1),(770,7527468,7527457,'man',11.111,1),(770,7527469,7527457,'anc',11.111,1),(770,7527470,7527457,'nce',11.111,1),(770,7527471,7527462,'ide',12.5,1),(770,7527472,7527462,'den',12.5,1),(770,7527473,7527462,'ent',12.5,1),(770,7527474,7527462,'nti',12.5,1),(770,7527475,7527462,'tif',12.5,1),(770,7527476,7527462,'ifi',12.5,1),(770,7527477,7527462,'fie',12.5,1),(770,7527478,7527462,'ier',12.5,1),(770,7527479,7527471,'vdi',33.333,3),(770,7527480,7527471,'dis',33.333,3),(770,7527481,7527471,'isk',33.333,3),(770,7527482,7527479,'nam',50,1),(770,7527483,7527479,'ame',50,1),(770,7527484,7527482,'typ',50,1),(770,7527485,7527482,'ype',50,1),(770,7527486,7527484,'dir',25,1),(770,7527487,7527484,'ire',25,1),(770,7527488,7527484,'rec',25,1),(770,7527489,7527484,'ect',25,1),(771,7527491,7527490,'naa',100,2),(771,7527492,7527491,'600',3.333,3),(771,7527493,7527491,'000',3.333,3),(771,7527494,7527491,'00c',3.333,3),(771,7527495,7527491,'0c2',3.333,3),(771,7527496,7527491,'c29',3.333,3),(771,7527497,7527491,'29b',3.333,3),(771,7527498,7527491,'9be',3.333,3),(771,7527499,7527491,'beb',3.333,3),(771,7527500,7527491,'eb1',3.333,3),(771,7527501,7527491,'b1d',3.333,3),(771,7527502,7527491,'1dc',3.333,3),(771,7527503,7527491,'dcf',3.333,3),(771,7527504,7527491,'cfb',3.333,3),(771,7527505,7527491,'fb3',3.333,3),(771,7527506,7527491,'b37',3.333,3),(771,7527507,7527491,'37d',3.333,3),(771,7527508,7527491,'7d0',3.333,3),(771,7527509,7527491,'d0c',3.333,3),(771,7527510,7527491,'0c5',3.333,3),(771,7527511,7527491,'c59',3.333,3),(771,7527512,7527491,'596',3.333,3),(771,7527513,7527491,'961',3.333,3),(771,7527514,7527491,'616',3.333,3),(771,7527515,7527491,'168',3.333,3),(771,7527516,7527491,'685',3.333,3),(771,7527517,7527491,'852',3.333,3),(771,7527518,7527491,'523',3.333,3),(771,7527519,7527491,'231',3.333,3),(771,7527520,7527491,'311',3.333,3),(771,7527521,7527491,'11d',3.333,3),(771,7527522,7527492,'mon',100,1),(771,7527523,7527522,'201',50,1),(771,7527524,7527522,'013',50,1),(771,7527525,7527523,'adm',33.333,4),(771,7527526,7527523,'dmi',33.333,4),(771,7527527,7527523,'min',33.333,4),(771,7527528,7527525,'cap',16.667,1),(771,7527529,7527525,'apa',16.667,1),(771,7527530,7527525,'pac',16.667,1),(771,7527531,7527525,'aci',16.667,1),(771,7527532,7527525,'cit',16.667,1),(771,7527533,7527525,'ity',16.667,1),(771,7527534,7527528,'pat',50,1),(771,7527535,7527528,'ath',50,1),(771,7527536,7527534,'fre',14.286,1),(771,7527537,7527534,'ree',14.286,1),(771,7527538,7527534,'ees',14.286,1),(771,7527539,7527534,'esp',14.286,1),(771,7527540,7527534,'spa',14.286,1),(771,7527541,7527534,'pac',14.286,1),(771,7527542,7527534,'ace',14.286,1),(771,7527543,7527536,'dis',50,1),(771,7527544,7527536,'isk',50,1),(771,7527545,7527543,'ind',33.333,1),(771,7527546,7527543,'nde',33.333,1),(771,7527547,7527543,'dex',33.333,1),(771,7527548,7527545,'adm',8.333,1),(771,7527549,7527545,'dmi',8.333,1),(771,7527550,7527545,'min',8.333,1),(771,7527551,7527545,'ini',8.333,1),(771,7527552,7527545,'nis',8.333,1),(771,7527553,7527545,'ist',8.333,1),(771,7527554,7527545,'str',8.333,1),(771,7527555,7527545,'tra',8.333,1),(771,7527556,7527545,'rat',8.333,1),(771,7527557,7527545,'ati',8.333,1),(771,7527558,7527545,'tio',8.333,1),(771,7527559,7527545,'ion',8.333,1),(771,7527560,7527548,'sta',33.333,3),(771,7527561,7527548,'tat',33.333,3),(771,7527562,7527548,'ate',33.333,3),(771,7527563,7527560,'dis',16.667,4),(771,7527564,7527560,'isa',16.667,4),(771,7527565,7527560,'sab',16.667,4),(771,7527566,7527560,'abl',16.667,4),(771,7527567,7527560,'ble',16.667,4),(771,7527568,7527560,'led',16.667,4),(771,7527569,7527563,'cac',33.333,1),(771,7527570,7527563,'ach',33.333,1),(771,7527571,7527563,'che',33.333,1),(771,7527572,7527569,'mod',50,1),(771,7527573,7527569,'ode',50,1),(771,7527574,7527572,'wri',14.286,1),(771,7527575,7527572,'rit',14.286,1),(771,7527576,7527572,'ite',14.286,1),(771,7527577,7527572,'tet',14.286,1),(771,7527578,7527572,'eth',14.286,1),(771,7527579,7527572,'thr',14.286,1),(771,7527580,7527572,'hru',14.286,1),(771,7527581,7527574,'ope',11.111,2),(771,7527582,7527574,'per',11.111,2),(771,7527583,7527574,'era',11.111,2),(771,7527584,7527574,'rat',11.111,2),(771,7527585,7527574,'ati',11.111,2),(771,7527586,7527574,'tio',11.111,2),(771,7527587,7527574,'ion',11.111,2),(771,7527588,7527574,'ona',11.111,2),(771,7527589,7527574,'nal',11.111,2),(771,7527590,7527581,'mes',20,1),(771,7527591,7527581,'ess',20,1),(771,7527592,7527581,'ssa',20,1),(771,7527593,7527581,'sag',20,1),(771,7527594,7527581,'age',20,1),(771,7527595,7527590,'per',11.111,1),(771,7527596,7527590,'erf',11.111,1),(771,7527597,7527590,'rfo',11.111,1),(771,7527598,7527590,'for',11.111,1),(771,7527599,7527590,'orm',11.111,1),(771,7527600,7527590,'rma',11.111,1),(771,7527601,7527590,'man',11.111,1),(771,7527602,7527590,'anc',11.111,1),(771,7527603,7527590,'nce',11.111,1),(771,7527604,7527595,'ide',12.5,1),(771,7527605,7527595,'den',12.5,1),(771,7527606,7527595,'ent',12.5,1),(771,7527607,7527595,'nti',12.5,1),(771,7527608,7527595,'tif',12.5,1),(771,7527609,7527595,'ifi',12.5,1),(771,7527610,7527595,'fie',12.5,1),(771,7527611,7527595,'ier',12.5,1),(771,7527612,7527604,'vdi',33.333,3),(771,7527613,7527604,'dis',33.333,3),(771,7527614,7527604,'isk',33.333,3),(771,7527615,7527612,'nam',50,1),(771,7527616,7527612,'ame',50,1),(771,7527617,7527615,'typ',50,1),(771,7527618,7527615,'ype',50,1),(771,7527619,7527617,'dir',25,1),(771,7527620,7527617,'ire',25,1),(771,7527621,7527617,'rec',25,1),(771,7527622,7527617,'ect',25,1),(772,7527624,7527623,'naa',100,2),(772,7527625,7527624,'600',3.333,3),(772,7527626,7527624,'000',3.333,3),(772,7527627,7527624,'00c',3.333,3),(772,7527628,7527624,'0c2',3.333,3),(772,7527629,7527624,'c29',3.333,3),(772,7527630,7527624,'29b',3.333,3),(772,7527631,7527624,'9bc',3.333,3),(772,7527632,7527624,'bc7',3.333,3),(772,7527633,7527624,'c7b',3.333,3),(772,7527634,7527624,'7bb',3.333,3),(772,7527635,7527624,'bba',3.333,3),(772,7527636,7527624,'ba5',3.333,3),(772,7527637,7527624,'a5d',3.333,3),(772,7527638,7527624,'5dc',3.333,3),(772,7527639,7527624,'dcf',3.333,3),(772,7527640,7527624,'cf3',3.333,3),(772,7527641,7527624,'f37',3.333,3),(772,7527642,7527624,'37a',3.333,3),(772,7527643,7527624,'7a1',3.333,3),(772,7527644,7527624,'a19',3.333,3),(772,7527645,7527624,'19b',3.333,3),(772,7527646,7527624,'9ba',3.333,3),(772,7527647,7527624,'bae',3.333,3),(772,7527648,7527624,'aed',3.333,3),(772,7527649,7527624,'edb',3.333,3),(772,7527650,7527624,'db7',3.333,3),(772,7527651,7527624,'b71',3.333,3),(772,7527652,7527624,'71d',3.333,3),(772,7527653,7527624,'1df',3.333,3),(772,7527654,7527624,'df5',3.333,3),(772,7527655,7527625,'mon',100,1),(772,7527656,7527655,'201',50,1),(772,7527657,7527655,'013',50,1),(772,7527658,7527656,'adm',33.333,4),(772,7527659,7527656,'dmi',33.333,4),(772,7527660,7527656,'min',33.333,4),(772,7527661,7527658,'cap',16.667,1),(772,7527662,7527658,'apa',16.667,1),(772,7527663,7527658,'pac',16.667,1),(772,7527664,7527658,'aci',16.667,1),(772,7527665,7527658,'cit',16.667,1),(772,7527666,7527658,'ity',16.667,1),(772,7527667,7527661,'pat',50,1),(772,7527668,7527661,'ath',50,1),(772,7527669,7527667,'fre',14.286,1),(772,7527670,7527667,'ree',14.286,1),(772,7527671,7527667,'ees',14.286,1),(772,7527672,7527667,'esp',14.286,1),(772,7527673,7527667,'spa',14.286,1),(772,7527674,7527667,'pac',14.286,1),(772,7527675,7527667,'ace',14.286,1),(772,7527676,7527669,'dis',50,1),(772,7527677,7527669,'isk',50,1),(772,7527678,7527676,'ind',33.333,1),(772,7527679,7527676,'nde',33.333,1),(772,7527680,7527676,'dex',33.333,1),(772,7527681,7527678,'adm',8.333,1),(772,7527682,7527678,'dmi',8.333,1),(772,7527683,7527678,'min',8.333,1),(772,7527684,7527678,'ini',8.333,1),(772,7527685,7527678,'nis',8.333,1),(772,7527686,7527678,'ist',8.333,1),(772,7527687,7527678,'str',8.333,1),(772,7527688,7527678,'tra',8.333,1),(772,7527689,7527678,'rat',8.333,1),(772,7527690,7527678,'ati',8.333,1),(772,7527691,7527678,'tio',8.333,1),(772,7527692,7527678,'ion',8.333,1),(772,7527693,7527681,'sta',33.333,3),(772,7527694,7527681,'tat',33.333,3),(772,7527695,7527681,'ate',33.333,3),(772,7527696,7527693,'dis',16.667,4),(772,7527697,7527693,'isa',16.667,4),(772,7527698,7527693,'sab',16.667,4),(772,7527699,7527693,'abl',16.667,4),(772,7527700,7527693,'ble',16.667,4),(772,7527701,7527693,'led',16.667,4),(772,7527702,7527696,'cac',33.333,1),(772,7527703,7527696,'ach',33.333,1),(772,7527704,7527696,'che',33.333,1),(772,7527705,7527702,'mod',50,1),(772,7527706,7527702,'ode',50,1),(772,7527707,7527705,'wri',14.286,1),(772,7527708,7527705,'rit',14.286,1),(772,7527709,7527705,'ite',14.286,1),(772,7527710,7527705,'tet',14.286,1),(772,7527711,7527705,'eth',14.286,1),(772,7527712,7527705,'thr',14.286,1),(772,7527713,7527705,'hru',14.286,1),(772,7527714,7527707,'ope',11.111,2),(772,7527715,7527707,'per',11.111,2),(772,7527716,7527707,'era',11.111,2),(772,7527717,7527707,'rat',11.111,2),(772,7527718,7527707,'ati',11.111,2),(772,7527719,7527707,'tio',11.111,2),(772,7527720,7527707,'ion',11.111,2),(772,7527721,7527707,'ona',11.111,2),(772,7527722,7527707,'nal',11.111,2),(772,7527723,7527714,'mes',20,1),(772,7527724,7527714,'ess',20,1),(772,7527725,7527714,'ssa',20,1),(772,7527726,7527714,'sag',20,1),(772,7527727,7527714,'age',20,1),(772,7527728,7527723,'per',11.111,1),(772,7527729,7527723,'erf',11.111,1),(772,7527730,7527723,'rfo',11.111,1),(772,7527731,7527723,'for',11.111,1),(772,7527732,7527723,'orm',11.111,1),(772,7527733,7527723,'rma',11.111,1),(772,7527734,7527723,'man',11.111,1),(772,7527735,7527723,'anc',11.111,1),(772,7527736,7527723,'nce',11.111,1),(772,7527737,7527728,'ide',12.5,1),(772,7527738,7527728,'den',12.5,1),(772,7527739,7527728,'ent',12.5,1),(772,7527740,7527728,'nti',12.5,1),(772,7527741,7527728,'tif',12.5,1),(772,7527742,7527728,'ifi',12.5,1),(772,7527743,7527728,'fie',12.5,1),(772,7527744,7527728,'ier',12.5,1),(772,7527745,7527737,'vdi',33.333,3),(772,7527746,7527737,'dis',33.333,3),(772,7527747,7527737,'isk',33.333,3),(772,7527748,7527745,'nam',50,1),(772,7527749,7527745,'ame',50,1),(772,7527750,7527748,'typ',50,1),(772,7527751,7527748,'ype',50,1),(772,7527752,7527750,'dir',25,1),(772,7527753,7527750,'ire',25,1),(772,7527754,7527750,'rec',25,1),(772,7527755,7527750,'ect',25,1),(773,7527757,7527756,'naa',100,2),(773,7527758,7527757,'600',3.333,3),(773,7527759,7527757,'000',3.333,3),(773,7527760,7527757,'00c',3.333,3),(773,7527761,7527757,'0c2',3.333,3),(773,7527762,7527757,'c29',3.333,3),(773,7527763,7527757,'291',3.333,3),(773,7527764,7527757,'918',3.333,3),(773,7527765,7527757,'188',3.333,3),(773,7527766,7527757,'887',3.333,3),(773,7527767,7527757,'872',3.333,3),(773,7527768,7527757,'72b',3.333,3),(773,7527769,7527757,'2bc',3.333,3),(773,7527770,7527757,'bcf',3.333,3),(773,7527771,7527757,'cf9',3.333,3),(773,7527772,7527757,'f97',3.333,3),(773,7527773,7527757,'977',3.333,3),(773,7527774,7527757,'770',3.333,3),(773,7527775,7527757,'707',3.333,3),(773,7527776,7527757,'070',3.333,3),(773,7527777,7527757,'703',3.333,3),(773,7527778,7527757,'036',3.333,3),(773,7527779,7527757,'36d',3.333,3),(773,7527780,7527757,'6dd',3.333,3),(773,7527781,7527757,'ddc',3.333,3),(773,7527782,7527757,'dca',3.333,3),(773,7527783,7527757,'cab',3.333,3),(773,7527784,7527757,'ab5',3.333,3),(773,7527785,7527757,'b55',3.333,3),(773,7527786,7527757,'55a',3.333,3),(773,7527787,7527757,'5a5',3.333,3),(773,7527788,7527758,'mon',100,1),(773,7527789,7527788,'201',50,1),(773,7527790,7527788,'013',50,1),(773,7527791,7527789,'adm',33.333,4),(773,7527792,7527789,'dmi',33.333,4),(773,7527793,7527789,'min',33.333,4),(773,7527794,7527791,'cap',16.667,1),(773,7527795,7527791,'apa',16.667,1),(773,7527796,7527791,'pac',16.667,1),(773,7527797,7527791,'aci',16.667,1),(773,7527798,7527791,'cit',16.667,1),(773,7527799,7527791,'ity',16.667,1),(773,7527800,7527794,'pat',50,1),(773,7527801,7527794,'ath',50,1),(773,7527802,7527800,'fre',14.286,1),(773,7527803,7527800,'ree',14.286,1),(773,7527804,7527800,'ees',14.286,1),(773,7527805,7527800,'esp',14.286,1),(773,7527806,7527800,'spa',14.286,1),(773,7527807,7527800,'pac',14.286,1),(773,7527808,7527800,'ace',14.286,1),(773,7527809,7527802,'dis',50,1),(773,7527810,7527802,'isk',50,1),(773,7527811,7527809,'ind',33.333,1),(773,7527812,7527809,'nde',33.333,1),(773,7527813,7527809,'dex',33.333,1),(773,7527814,7527811,'adm',8.333,1),(773,7527815,7527811,'dmi',8.333,1),(773,7527816,7527811,'min',8.333,1),(773,7527817,7527811,'ini',8.333,1),(773,7527818,7527811,'nis',8.333,1),(773,7527819,7527811,'ist',8.333,1),(773,7527820,7527811,'str',8.333,1),(773,7527821,7527811,'tra',8.333,1),(773,7527822,7527811,'rat',8.333,1),(773,7527823,7527811,'ati',8.333,1),(773,7527824,7527811,'tio',8.333,1),(773,7527825,7527811,'ion',8.333,1),(773,7527826,7527814,'sta',33.333,3),(773,7527827,7527814,'tat',33.333,3),(773,7527828,7527814,'ate',33.333,3),(773,7527829,7527826,'dis',16.667,4),(773,7527830,7527826,'isa',16.667,4),(773,7527831,7527826,'sab',16.667,4),(773,7527832,7527826,'abl',16.667,4),(773,7527833,7527826,'ble',16.667,4),(773,7527834,7527826,'led',16.667,4),(773,7527835,7527829,'cac',33.333,1),(773,7527836,7527829,'ach',33.333,1),(773,7527837,7527829,'che',33.333,1),(773,7527838,7527835,'mod',50,1),(773,7527839,7527835,'ode',50,1),(773,7527840,7527838,'wri',14.286,1),(773,7527841,7527838,'rit',14.286,1),(773,7527842,7527838,'ite',14.286,1),(773,7527843,7527838,'tet',14.286,1),(773,7527844,7527838,'eth',14.286,1),(773,7527845,7527838,'thr',14.286,1),(773,7527846,7527838,'hru',14.286,1),(773,7527847,7527840,'ope',11.111,2),(773,7527848,7527840,'per',11.111,2),(773,7527849,7527840,'era',11.111,2),(773,7527850,7527840,'rat',11.111,2),(773,7527851,7527840,'ati',11.111,2),(773,7527852,7527840,'tio',11.111,2),(773,7527853,7527840,'ion',11.111,2),(773,7527854,7527840,'ona',11.111,2),(773,7527855,7527840,'nal',11.111,2),(773,7527856,7527847,'mes',20,1),(773,7527857,7527847,'ess',20,1),(773,7527858,7527847,'ssa',20,1),(773,7527859,7527847,'sag',20,1),(773,7527860,7527847,'age',20,1),(773,7527861,7527856,'per',11.111,1),(773,7527862,7527856,'erf',11.111,1),(773,7527863,7527856,'rfo',11.111,1),(773,7527864,7527856,'for',11.111,1),(773,7527865,7527856,'orm',11.111,1),(773,7527866,7527856,'rma',11.111,1),(773,7527867,7527856,'man',11.111,1),(773,7527868,7527856,'anc',11.111,1),(773,7527869,7527856,'nce',11.111,1),(773,7527870,7527861,'ide',12.5,1),(773,7527871,7527861,'den',12.5,1),(773,7527872,7527861,'ent',12.5,1),(773,7527873,7527861,'nti',12.5,1),(773,7527874,7527861,'tif',12.5,1),(773,7527875,7527861,'ifi',12.5,1),(773,7527876,7527861,'fie',12.5,1),(773,7527877,7527861,'ier',12.5,1),(773,7527878,7527870,'vdi',33.333,3),(773,7527879,7527870,'dis',33.333,3),(773,7527880,7527870,'isk',33.333,3),(773,7527881,7527878,'nam',50,1),(773,7527882,7527878,'ame',50,1),(773,7527883,7527881,'typ',50,1),(773,7527884,7527881,'ype',50,1),(773,7527885,7527883,'dir',25,1),(773,7527886,7527883,'ire',25,1),(773,7527887,7527883,'rec',25,1),(773,7527888,7527883,'ect',25,1),(774,7527890,7527889,'naa',100,2),(774,7527891,7527890,'600',3.333,3),(774,7527892,7527890,'000',3.333,3),(774,7527893,7527890,'00c',3.333,3),(774,7527894,7527890,'0c2',3.333,3),(774,7527895,7527890,'c29',3.333,3),(774,7527896,7527890,'29e',3.333,3),(774,7527897,7527890,'9eb',3.333,3),(774,7527898,7527890,'eba',3.333,3),(774,7527899,7527890,'ba1',3.333,3),(774,7527900,7527890,'a1e',3.333,3),(774,7527901,7527890,'1e8',3.333,3),(774,7527902,7527890,'e8c',3.333,3),(774,7527903,7527890,'8c6',3.333,3),(774,7527904,7527890,'c67',3.333,3),(774,7527905,7527890,'67d',3.333,3),(774,7527906,7527890,'7de',3.333,3),(774,7527907,7527890,'de0',3.333,3),(774,7527908,7527890,'e05',3.333,3),(774,7527909,7527890,'050',3.333,3),(774,7527910,7527890,'500',3.333,3),(774,7527911,7527890,'002',3.333,3),(774,7527912,7527890,'027',3.333,3),(774,7527913,7527890,'274',3.333,3),(774,7527914,7527890,'74d',3.333,3),(774,7527915,7527890,'4d7',3.333,3),(774,7527916,7527890,'d74',3.333,3),(774,7527917,7527890,'74d',3.333,3),(774,7527918,7527890,'4d9',3.333,3),(774,7527919,7527890,'d91',3.333,3),(774,7527920,7527890,'91c',3.333,3),(774,7527921,7527891,'mon',100,1),(774,7527922,7527921,'201',50,1),(774,7527923,7527921,'013',50,1),(774,7527924,7527922,'adm',33.333,4),(774,7527925,7527922,'dmi',33.333,4),(774,7527926,7527922,'min',33.333,4),(774,7527927,7527924,'cap',16.667,1),(774,7527928,7527924,'apa',16.667,1),(774,7527929,7527924,'pac',16.667,1),(774,7527930,7527924,'aci',16.667,1),(774,7527931,7527924,'cit',16.667,1),(774,7527932,7527924,'ity',16.667,1),(774,7527933,7527927,'pat',50,1),(774,7527934,7527927,'ath',50,1),(774,7527935,7527933,'fre',14.286,1),(774,7527936,7527933,'ree',14.286,1),(774,7527937,7527933,'ees',14.286,1),(774,7527938,7527933,'esp',14.286,1),(774,7527939,7527933,'spa',14.286,1),(774,7527940,7527933,'pac',14.286,1),(774,7527941,7527933,'ace',14.286,1),(774,7527942,7527935,'dis',50,1),(774,7527943,7527935,'isk',50,1),(774,7527944,7527942,'ind',33.333,1),(774,7527945,7527942,'nde',33.333,1),(774,7527946,7527942,'dex',33.333,1),(774,7527947,7527944,'adm',8.333,1),(774,7527948,7527944,'dmi',8.333,1),(774,7527949,7527944,'min',8.333,1),(774,7527950,7527944,'ini',8.333,1),(774,7527951,7527944,'nis',8.333,1),(774,7527952,7527944,'ist',8.333,1),(774,7527953,7527944,'str',8.333,1),(774,7527954,7527944,'tra',8.333,1),(774,7527955,7527944,'rat',8.333,1),(774,7527956,7527944,'ati',8.333,1),(774,7527957,7527944,'tio',8.333,1),(774,7527958,7527944,'ion',8.333,1),(774,7527959,7527947,'sta',33.333,3),(774,7527960,7527947,'tat',33.333,3),(774,7527961,7527947,'ate',33.333,3),(774,7527962,7527959,'dis',16.667,4),(774,7527963,7527959,'isa',16.667,4),(774,7527964,7527959,'sab',16.667,4),(774,7527965,7527959,'abl',16.667,4),(774,7527966,7527959,'ble',16.667,4),(774,7527967,7527959,'led',16.667,4),(774,7527968,7527962,'cac',33.333,1),(774,7527969,7527962,'ach',33.333,1),(774,7527970,7527962,'che',33.333,1),(774,7527971,7527968,'mod',50,1),(774,7527972,7527968,'ode',50,1),(774,7527973,7527971,'wri',14.286,1),(774,7527974,7527971,'rit',14.286,1),(774,7527975,7527971,'ite',14.286,1),(774,7527976,7527971,'tet',14.286,1),(774,7527977,7527971,'eth',14.286,1),(774,7527978,7527971,'thr',14.286,1),(774,7527979,7527971,'hru',14.286,1),(774,7527980,7527973,'ope',11.111,2),(774,7527981,7527973,'per',11.111,2),(774,7527982,7527973,'era',11.111,2),(774,7527983,7527973,'rat',11.111,2),(774,7527984,7527973,'ati',11.111,2),(774,7527985,7527973,'tio',11.111,2),(774,7527986,7527973,'ion',11.111,2),(774,7527987,7527973,'ona',11.111,2),(774,7527988,7527973,'nal',11.111,2),(774,7527989,7527980,'mes',20,1),(774,7527990,7527980,'ess',20,1),(774,7527991,7527980,'ssa',20,1),(774,7527992,7527980,'sag',20,1),(774,7527993,7527980,'age',20,1),(774,7527994,7527989,'per',11.111,1),(774,7527995,7527989,'erf',11.111,1),(774,7527996,7527989,'rfo',11.111,1),(774,7527997,7527989,'for',11.111,1),(774,7527998,7527989,'orm',11.111,1),(774,7527999,7527989,'rma',11.111,1),(774,7528000,7527989,'man',11.111,1),(774,7528001,7527989,'anc',11.111,1),(774,7528002,7527989,'nce',11.111,1),(774,7528003,7527994,'ide',12.5,1),(774,7528004,7527994,'den',12.5,1),(774,7528005,7527994,'ent',12.5,1),(774,7528006,7527994,'nti',12.5,1),(774,7528007,7527994,'tif',12.5,1),(774,7528008,7527994,'ifi',12.5,1),(774,7528009,7527994,'fie',12.5,1),(774,7528010,7527994,'ier',12.5,1),(774,7528011,7528003,'vdi',33.333,3),(774,7528012,7528003,'dis',33.333,3),(774,7528013,7528003,'isk',33.333,3),(774,7528014,7528011,'nam',50,1),(774,7528015,7528011,'ame',50,1),(774,7528016,7528014,'typ',50,1),(774,7528017,7528014,'ype',50,1),(774,7528018,7528016,'dir',25,1),(774,7528019,7528016,'ire',25,1),(774,7528020,7528016,'rec',25,1),(774,7528021,7528016,'ect',25,1),(775,7528023,7528022,'naa',100,2),(775,7528024,7528023,'600',3.333,3),(775,7528025,7528023,'000',3.333,3),(775,7528026,7528023,'00c',3.333,3),(775,7528027,7528023,'0c2',3.333,3),(775,7528028,7528023,'c29',3.333,3),(775,7528029,7528023,'29e',3.333,3),(775,7528030,7528023,'9ee',3.333,3),(775,7528031,7528023,'eed',3.333,3),(775,7528032,7528023,'ed0',3.333,3),(775,7528033,7528023,'d0b',3.333,3),(775,7528034,7528023,'0bf',3.333,3),(775,7528035,7528023,'bfd',3.333,3),(775,7528036,7528023,'fd9',3.333,3),(775,7528037,7528023,'d96',3.333,3),(775,7528038,7528023,'962',3.333,3),(775,7528039,7528023,'62b',3.333,3),(775,7528040,7528023,'2b5',3.333,3),(775,7528041,7528023,'b59',3.333,3),(775,7528042,7528023,'59b',3.333,3),(775,7528043,7528023,'9bd',3.333,3),(775,7528044,7528023,'bdb',3.333,3),(775,7528045,7528023,'db1',3.333,3),(775,7528046,7528023,'b13',3.333,3),(775,7528047,7528023,'134',3.333,3),(775,7528048,7528023,'346',3.333,3),(775,7528049,7528023,'46b',3.333,3),(775,7528050,7528023,'6b8',3.333,3),(775,7528051,7528023,'b89',3.333,3),(775,7528052,7528023,'89c',3.333,3),(775,7528053,7528023,'9cc',3.333,3),(775,7528054,7528024,'mon',100,1),(775,7528055,7528054,'201',50,1),(775,7528056,7528054,'013',50,1),(775,7528057,7528055,'adm',33.333,4),(775,7528058,7528055,'dmi',33.333,4),(775,7528059,7528055,'min',33.333,4),(775,7528060,7528057,'cap',16.667,1),(775,7528061,7528057,'apa',16.667,1),(775,7528062,7528057,'pac',16.667,1),(775,7528063,7528057,'aci',16.667,1),(775,7528064,7528057,'cit',16.667,1),(775,7528065,7528057,'ity',16.667,1),(775,7528066,7528060,'pat',50,1),(775,7528067,7528060,'ath',50,1),(775,7528068,7528066,'fre',14.286,1),(775,7528069,7528066,'ree',14.286,1),(775,7528070,7528066,'ees',14.286,1),(775,7528071,7528066,'esp',14.286,1),(775,7528072,7528066,'spa',14.286,1),(775,7528073,7528066,'pac',14.286,1),(775,7528074,7528066,'ace',14.286,1),(775,7528075,7528068,'dis',50,1),(775,7528076,7528068,'isk',50,1),(775,7528077,7528075,'ind',33.333,1),(775,7528078,7528075,'nde',33.333,1),(775,7528079,7528075,'dex',33.333,1),(775,7528080,7528077,'adm',8.333,1),(775,7528081,7528077,'dmi',8.333,1),(775,7528082,7528077,'min',8.333,1),(775,7528083,7528077,'ini',8.333,1),(775,7528084,7528077,'nis',8.333,1),(775,7528085,7528077,'ist',8.333,1),(775,7528086,7528077,'str',8.333,1),(775,7528087,7528077,'tra',8.333,1),(775,7528088,7528077,'rat',8.333,1),(775,7528089,7528077,'ati',8.333,1),(775,7528090,7528077,'tio',8.333,1),(775,7528091,7528077,'ion',8.333,1),(775,7528092,7528080,'sta',33.333,3),(775,7528093,7528080,'tat',33.333,3),(775,7528094,7528080,'ate',33.333,3),(775,7528095,7528092,'dis',16.667,4),(775,7528096,7528092,'isa',16.667,4),(775,7528097,7528092,'sab',16.667,4),(775,7528098,7528092,'abl',16.667,4),(775,7528099,7528092,'ble',16.667,4),(775,7528100,7528092,'led',16.667,4),(775,7528101,7528095,'cac',33.333,1),(775,7528102,7528095,'ach',33.333,1),(775,7528103,7528095,'che',33.333,1),(775,7528104,7528101,'mod',50,1),(775,7528105,7528101,'ode',50,1),(775,7528106,7528104,'wri',14.286,1),(775,7528107,7528104,'rit',14.286,1),(775,7528108,7528104,'ite',14.286,1),(775,7528109,7528104,'tet',14.286,1),(775,7528110,7528104,'eth',14.286,1),(775,7528111,7528104,'thr',14.286,1),(775,7528112,7528104,'hru',14.286,1),(775,7528113,7528106,'ope',11.111,2),(775,7528114,7528106,'per',11.111,2),(775,7528115,7528106,'era',11.111,2),(775,7528116,7528106,'rat',11.111,2),(775,7528117,7528106,'ati',11.111,2),(775,7528118,7528106,'tio',11.111,2),(775,7528119,7528106,'ion',11.111,2),(775,7528120,7528106,'ona',11.111,2),(775,7528121,7528106,'nal',11.111,2),(775,7528122,7528113,'mes',20,1),(775,7528123,7528113,'ess',20,1),(775,7528124,7528113,'ssa',20,1),(775,7528125,7528113,'sag',20,1),(775,7528126,7528113,'age',20,1),(775,7528127,7528122,'per',11.111,1),(775,7528128,7528122,'erf',11.111,1),(775,7528129,7528122,'rfo',11.111,1),(775,7528130,7528122,'for',11.111,1),(775,7528131,7528122,'orm',11.111,1),(775,7528132,7528122,'rma',11.111,1),(775,7528133,7528122,'man',11.111,1),(775,7528134,7528122,'anc',11.111,1),(775,7528135,7528122,'nce',11.111,1),(775,7528136,7528127,'ide',12.5,1),(775,7528137,7528127,'den',12.5,1),(775,7528138,7528127,'ent',12.5,1),(775,7528139,7528127,'nti',12.5,1),(775,7528140,7528127,'tif',12.5,1),(775,7528141,7528127,'ifi',12.5,1),(775,7528142,7528127,'fie',12.5,1),(775,7528143,7528127,'ier',12.5,1),(775,7528144,7528136,'vdi',33.333,3),(775,7528145,7528136,'dis',33.333,3),(775,7528146,7528136,'isk',33.333,3),(775,7528147,7528144,'nam',50,1),(775,7528148,7528144,'ame',50,1),(775,7528149,7528147,'typ',50,1),(775,7528150,7528147,'ype',50,1),(775,7528151,7528149,'dir',25,1),(775,7528152,7528149,'ire',25,1),(775,7528153,7528149,'rec',25,1),(775,7528154,7528149,'ect',25,1),(776,7528156,7528155,'naa',100,2),(776,7528157,7528156,'600',3.333,3),(776,7528158,7528156,'000',3.333,3),(776,7528159,7528156,'00c',3.333,3),(776,7528160,7528156,'0c2',3.333,3),(776,7528161,7528156,'c29',3.333,3),(776,7528162,7528156,'293',3.333,3),(776,7528163,7528156,'93b',3.333,3),(776,7528164,7528156,'3b7',3.333,3),(776,7528165,7528156,'b7c',3.333,3),(776,7528166,7528156,'7c5',3.333,3),(776,7528167,7528156,'c50',3.333,3),(776,7528168,7528156,'50a',3.333,3),(776,7528169,7528156,'0af',3.333,3),(776,7528170,7528156,'afc',3.333,3),(776,7528171,7528156,'fc9',3.333,3),(776,7528172,7528156,'c97',3.333,3),(776,7528173,7528156,'974',3.333,3),(776,7528174,7528156,'74b',3.333,3),(776,7528175,7528156,'4bc',3.333,3),(776,7528176,7528156,'bc9',3.333,3),(776,7528177,7528156,'c97',3.333,3),(776,7528178,7528156,'978',3.333,3),(776,7528179,7528156,'789',3.333,3),(776,7528180,7528156,'89a',3.333,3),(776,7528181,7528156,'9a9',3.333,3),(776,7528182,7528156,'a95',3.333,3),(776,7528183,7528156,'95c',3.333,3),(776,7528184,7528156,'5cd',3.333,3),(776,7528185,7528156,'cd9',3.333,3),(776,7528186,7528156,'d97',3.333,3),(776,7528187,7528157,'mon',100,1),(776,7528188,7528187,'201',50,1),(776,7528189,7528187,'013',50,1),(776,7528190,7528188,'adm',33.333,4),(776,7528191,7528188,'dmi',33.333,4),(776,7528192,7528188,'min',33.333,4),(776,7528193,7528190,'cap',16.667,1),(776,7528194,7528190,'apa',16.667,1),(776,7528195,7528190,'pac',16.667,1),(776,7528196,7528190,'aci',16.667,1),(776,7528197,7528190,'cit',16.667,1),(776,7528198,7528190,'ity',16.667,1),(776,7528199,7528193,'pat',50,1),(776,7528200,7528193,'ath',50,1),(776,7528201,7528199,'fre',14.286,1),(776,7528202,7528199,'ree',14.286,1),(776,7528203,7528199,'ees',14.286,1),(776,7528204,7528199,'esp',14.286,1),(776,7528205,7528199,'spa',14.286,1),(776,7528206,7528199,'pac',14.286,1),(776,7528207,7528199,'ace',14.286,1),(776,7528208,7528201,'dis',50,1),(776,7528209,7528201,'isk',50,1),(776,7528210,7528208,'ind',33.333,1),(776,7528211,7528208,'nde',33.333,1),(776,7528212,7528208,'dex',33.333,1),(776,7528213,7528210,'adm',8.333,1),(776,7528214,7528210,'dmi',8.333,1),(776,7528215,7528210,'min',8.333,1),(776,7528216,7528210,'ini',8.333,1),(776,7528217,7528210,'nis',8.333,1),(776,7528218,7528210,'ist',8.333,1),(776,7528219,7528210,'str',8.333,1),(776,7528220,7528210,'tra',8.333,1),(776,7528221,7528210,'rat',8.333,1),(776,7528222,7528210,'ati',8.333,1),(776,7528223,7528210,'tio',8.333,1),(776,7528224,7528210,'ion',8.333,1),(776,7528225,7528213,'sta',33.333,3),(776,7528226,7528213,'tat',33.333,3),(776,7528227,7528213,'ate',33.333,3),(776,7528228,7528225,'dis',16.667,4),(776,7528229,7528225,'isa',16.667,4),(776,7528230,7528225,'sab',16.667,4),(776,7528231,7528225,'abl',16.667,4),(776,7528232,7528225,'ble',16.667,4),(776,7528233,7528225,'led',16.667,4),(776,7528234,7528228,'cac',33.333,1),(776,7528235,7528228,'ach',33.333,1),(776,7528236,7528228,'che',33.333,1),(776,7528237,7528234,'mod',50,1),(776,7528238,7528234,'ode',50,1),(776,7528239,7528237,'wri',14.286,1),(776,7528240,7528237,'rit',14.286,1),(776,7528241,7528237,'ite',14.286,1),(776,7528242,7528237,'tet',14.286,1),(776,7528243,7528237,'eth',14.286,1),(776,7528244,7528237,'thr',14.286,1),(776,7528245,7528237,'hru',14.286,1),(776,7528246,7528239,'ope',11.111,2),(776,7528247,7528239,'per',11.111,2),(776,7528248,7528239,'era',11.111,2),(776,7528249,7528239,'rat',11.111,2),(776,7528250,7528239,'ati',11.111,2),(776,7528251,7528239,'tio',11.111,2),(776,7528252,7528239,'ion',11.111,2),(776,7528253,7528239,'ona',11.111,2),(776,7528254,7528239,'nal',11.111,2),(776,7528255,7528246,'mes',20,1),(776,7528256,7528246,'ess',20,1),(776,7528257,7528246,'ssa',20,1),(776,7528258,7528246,'sag',20,1),(776,7528259,7528246,'age',20,1),(776,7528260,7528255,'per',11.111,1),(776,7528261,7528255,'erf',11.111,1),(776,7528262,7528255,'rfo',11.111,1),(776,7528263,7528255,'for',11.111,1),(776,7528264,7528255,'orm',11.111,1),(776,7528265,7528255,'rma',11.111,1),(776,7528266,7528255,'man',11.111,1),(776,7528267,7528255,'anc',11.111,1),(776,7528268,7528255,'nce',11.111,1),(776,7528269,7528260,'ide',12.5,1),(776,7528270,7528260,'den',12.5,1),(776,7528271,7528260,'ent',12.5,1),(776,7528272,7528260,'nti',12.5,1),(776,7528273,7528260,'tif',12.5,1),(776,7528274,7528260,'ifi',12.5,1),(776,7528275,7528260,'fie',12.5,1),(776,7528276,7528260,'ier',12.5,1),(776,7528277,7528269,'vdi',33.333,3),(776,7528278,7528269,'dis',33.333,3),(776,7528279,7528269,'isk',33.333,3),(776,7528280,7528277,'nam',50,1),(776,7528281,7528277,'ame',50,1),(776,7528282,7528280,'typ',50,1),(776,7528283,7528280,'ype',50,1),(776,7528284,7528282,'dir',25,1),(776,7528285,7528282,'ire',25,1),(776,7528286,7528282,'rec',25,1),(776,7528287,7528282,'ect',25,1),(777,7528289,7528288,'naa',100,2),(777,7528290,7528289,'600',3.333,3),(777,7528291,7528289,'000',3.333,3),(777,7528292,7528289,'00c',3.333,3),(777,7528293,7528289,'0c2',3.333,3),(777,7528294,7528289,'c29',3.333,3),(777,7528295,7528289,'294',3.333,3),(777,7528296,7528289,'942',3.333,3),(777,7528297,7528289,'42b',3.333,3),(777,7528298,7528289,'2b3',3.333,3),(777,7528299,7528289,'b3d',3.333,3),(777,7528300,7528289,'3d3',3.333,3),(777,7528301,7528289,'d3b',3.333,3),(777,7528302,7528289,'3b4',3.333,3),(777,7528303,7528289,'b4c',3.333,3),(777,7528304,7528289,'4cd',3.333,3),(777,7528305,7528289,'cd3',3.333,3),(777,7528306,7528289,'d3f',3.333,3),(777,7528307,7528289,'3fd',3.333,3),(777,7528308,7528289,'fde',3.333,3),(777,7528309,7528289,'dea',3.333,3),(777,7528310,7528289,'eae',3.333,3),(777,7528311,7528289,'aea',3.333,3),(777,7528312,7528289,'ea5',3.333,3),(777,7528313,7528289,'a5f',3.333,3),(777,7528314,7528289,'5f0',3.333,3),(777,7528315,7528289,'f01',3.333,3),(777,7528316,7528289,'01d',3.333,3),(777,7528317,7528289,'1d7',3.333,3),(777,7528318,7528289,'d79',3.333,3),(777,7528319,7528289,'793',3.333,3),(777,7528320,7528290,'mon',100,1),(777,7528321,7528320,'201',50,1),(777,7528322,7528320,'013',50,1),(777,7528323,7528321,'adm',33.333,4),(777,7528324,7528321,'dmi',33.333,4),(777,7528325,7528321,'min',33.333,4),(777,7528326,7528323,'cap',16.667,1),(777,7528327,7528323,'apa',16.667,1),(777,7528328,7528323,'pac',16.667,1),(777,7528329,7528323,'aci',16.667,1),(777,7528330,7528323,'cit',16.667,1),(777,7528331,7528323,'ity',16.667,1),(777,7528332,7528326,'pat',50,1),(777,7528333,7528326,'ath',50,1),(777,7528334,7528332,'fre',14.286,1),(777,7528335,7528332,'ree',14.286,1),(777,7528336,7528332,'ees',14.286,1),(777,7528337,7528332,'esp',14.286,1),(777,7528338,7528332,'spa',14.286,1),(777,7528339,7528332,'pac',14.286,1),(777,7528340,7528332,'ace',14.286,1),(777,7528341,7528334,'dis',50,1),(777,7528342,7528334,'isk',50,1),(777,7528343,7528341,'ind',33.333,1),(777,7528344,7528341,'nde',33.333,1),(777,7528345,7528341,'dex',33.333,1),(777,7528346,7528343,'adm',8.333,1),(777,7528347,7528343,'dmi',8.333,1),(777,7528348,7528343,'min',8.333,1),(777,7528349,7528343,'ini',8.333,1),(777,7528350,7528343,'nis',8.333,1),(777,7528351,7528343,'ist',8.333,1),(777,7528352,7528343,'str',8.333,1),(777,7528353,7528343,'tra',8.333,1),(777,7528354,7528343,'rat',8.333,1),(777,7528355,7528343,'ati',8.333,1),(777,7528356,7528343,'tio',8.333,1),(777,7528357,7528343,'ion',8.333,1),(777,7528358,7528346,'sta',33.333,3),(777,7528359,7528346,'tat',33.333,3),(777,7528360,7528346,'ate',33.333,3),(777,7528361,7528358,'dis',16.667,4),(777,7528362,7528358,'isa',16.667,4),(777,7528363,7528358,'sab',16.667,4),(777,7528364,7528358,'abl',16.667,4),(777,7528365,7528358,'ble',16.667,4),(777,7528366,7528358,'led',16.667,4),(777,7528367,7528361,'cac',33.333,1),(777,7528368,7528361,'ach',33.333,1),(777,7528369,7528361,'che',33.333,1),(777,7528370,7528367,'mod',50,1),(777,7528371,7528367,'ode',50,1),(777,7528372,7528370,'wri',14.286,1),(777,7528373,7528370,'rit',14.286,1),(777,7528374,7528370,'ite',14.286,1),(777,7528375,7528370,'tet',14.286,1),(777,7528376,7528370,'eth',14.286,1),(777,7528377,7528370,'thr',14.286,1),(777,7528378,7528370,'hru',14.286,1),(777,7528379,7528372,'ope',11.111,2),(777,7528380,7528372,'per',11.111,2),(777,7528381,7528372,'era',11.111,2),(777,7528382,7528372,'rat',11.111,2),(777,7528383,7528372,'ati',11.111,2),(777,7528384,7528372,'tio',11.111,2),(777,7528385,7528372,'ion',11.111,2),(777,7528386,7528372,'ona',11.111,2),(777,7528387,7528372,'nal',11.111,2),(777,7528388,7528379,'mes',20,1),(777,7528389,7528379,'ess',20,1),(777,7528390,7528379,'ssa',20,1),(777,7528391,7528379,'sag',20,1),(777,7528392,7528379,'age',20,1),(777,7528393,7528388,'per',11.111,1),(777,7528394,7528388,'erf',11.111,1),(777,7528395,7528388,'rfo',11.111,1),(777,7528396,7528388,'for',11.111,1),(777,7528397,7528388,'orm',11.111,1),(777,7528398,7528388,'rma',11.111,1),(777,7528399,7528388,'man',11.111,1),(777,7528400,7528388,'anc',11.111,1),(777,7528401,7528388,'nce',11.111,1),(777,7528402,7528393,'ide',12.5,1),(777,7528403,7528393,'den',12.5,1),(777,7528404,7528393,'ent',12.5,1),(777,7528405,7528393,'nti',12.5,1),(777,7528406,7528393,'tif',12.5,1),(777,7528407,7528393,'ifi',12.5,1),(777,7528408,7528393,'fie',12.5,1),(777,7528409,7528393,'ier',12.5,1),(777,7528410,7528402,'vdi',33.333,3),(777,7528411,7528402,'dis',33.333,3),(777,7528412,7528402,'isk',33.333,3),(777,7528413,7528410,'nam',50,1),(777,7528414,7528410,'ame',50,1),(777,7528415,7528413,'typ',50,1),(777,7528416,7528413,'ype',50,1),(777,7528417,7528415,'dir',25,1),(777,7528418,7528415,'ire',25,1),(777,7528419,7528415,'rec',25,1),(777,7528420,7528415,'ect',25,1),(778,7528422,7528421,'naa',100,2),(778,7528423,7528422,'600',3.333,3),(778,7528424,7528422,'000',3.333,3),(778,7528425,7528422,'00c',3.333,3),(778,7528426,7528422,'0c2',3.333,3),(778,7528427,7528422,'c29',3.333,3),(778,7528428,7528422,'29f',3.333,3),(778,7528429,7528422,'9fe',3.333,3),(778,7528430,7528422,'feb',3.333,3),(778,7528431,7528422,'eb8',3.333,3),(778,7528432,7528422,'b8a',3.333,3),(778,7528433,7528422,'8a5',3.333,3),(778,7528434,7528422,'a56',3.333,3),(778,7528435,7528422,'569',3.333,3),(778,7528436,7528422,'69f',3.333,3),(778,7528437,7528422,'9f7',3.333,3),(778,7528438,7528422,'f7f',3.333,3),(778,7528439,7528422,'7ff',3.333,3),(778,7528440,7528422,'ff3',3.333,3),(778,7528441,7528422,'f3b',3.333,3),(778,7528442,7528422,'3b2',3.333,3),(778,7528443,7528422,'b23',3.333,3),(778,7528444,7528422,'23e',3.333,3),(778,7528445,7528422,'3e0',3.333,3),(778,7528446,7528422,'e03',3.333,3),(778,7528447,7528422,'035',3.333,3),(778,7528448,7528422,'353',3.333,3),(778,7528449,7528422,'532',3.333,3),(778,7528450,7528422,'320',3.333,3),(778,7528451,7528422,'20e',3.333,3),(778,7528452,7528422,'0e6',3.333,3),(778,7528453,7528423,'mon',100,1),(778,7528454,7528453,'201',50,1),(778,7528455,7528453,'013',50,1),(778,7528456,7528454,'adm',33.333,4),(778,7528457,7528454,'dmi',33.333,4),(778,7528458,7528454,'min',33.333,4),(778,7528459,7528456,'cap',16.667,1),(778,7528460,7528456,'apa',16.667,1),(778,7528461,7528456,'pac',16.667,1),(778,7528462,7528456,'aci',16.667,1),(778,7528463,7528456,'cit',16.667,1),(778,7528464,7528456,'ity',16.667,1),(778,7528465,7528459,'pat',50,1),(778,7528466,7528459,'ath',50,1),(778,7528467,7528465,'fre',14.286,1),(778,7528468,7528465,'ree',14.286,1),(778,7528469,7528465,'ees',14.286,1),(778,7528470,7528465,'esp',14.286,1),(778,7528471,7528465,'spa',14.286,1),(778,7528472,7528465,'pac',14.286,1),(778,7528473,7528465,'ace',14.286,1),(778,7528474,7528467,'dis',50,1),(778,7528475,7528467,'isk',50,1),(778,7528476,7528474,'ind',33.333,1),(778,7528477,7528474,'nde',33.333,1),(778,7528478,7528474,'dex',33.333,1),(778,7528479,7528476,'adm',8.333,1),(778,7528480,7528476,'dmi',8.333,1),(778,7528481,7528476,'min',8.333,1),(778,7528482,7528476,'ini',8.333,1),(778,7528483,7528476,'nis',8.333,1),(778,7528484,7528476,'ist',8.333,1),(778,7528485,7528476,'str',8.333,1),(778,7528486,7528476,'tra',8.333,1),(778,7528487,7528476,'rat',8.333,1),(778,7528488,7528476,'ati',8.333,1),(778,7528489,7528476,'tio',8.333,1),(778,7528490,7528476,'ion',8.333,1),(778,7528491,7528479,'sta',33.333,3),(778,7528492,7528479,'tat',33.333,3),(778,7528493,7528479,'ate',33.333,3),(778,7528494,7528491,'dis',16.667,4),(778,7528495,7528491,'isa',16.667,4),(778,7528496,7528491,'sab',16.667,4),(778,7528497,7528491,'abl',16.667,4),(778,7528498,7528491,'ble',16.667,4),(778,7528499,7528491,'led',16.667,4),(778,7528500,7528494,'cac',33.333,1),(778,7528501,7528494,'ach',33.333,1),(778,7528502,7528494,'che',33.333,1),(778,7528503,7528500,'mod',50,1),(778,7528504,7528500,'ode',50,1),(778,7528505,7528503,'wri',14.286,1),(778,7528506,7528503,'rit',14.286,1),(778,7528507,7528503,'ite',14.286,1),(778,7528508,7528503,'tet',14.286,1),(778,7528509,7528503,'eth',14.286,1),(778,7528510,7528503,'thr',14.286,1),(778,7528511,7528503,'hru',14.286,1),(778,7528512,7528505,'ope',11.111,2),(778,7528513,7528505,'per',11.111,2),(778,7528514,7528505,'era',11.111,2),(778,7528515,7528505,'rat',11.111,2),(778,7528516,7528505,'ati',11.111,2),(778,7528517,7528505,'tio',11.111,2),(778,7528518,7528505,'ion',11.111,2),(778,7528519,7528505,'ona',11.111,2),(778,7528520,7528505,'nal',11.111,2),(778,7528521,7528512,'mes',20,1),(778,7528522,7528512,'ess',20,1),(778,7528523,7528512,'ssa',20,1),(778,7528524,7528512,'sag',20,1),(778,7528525,7528512,'age',20,1),(778,7528526,7528521,'per',11.111,1),(778,7528527,7528521,'erf',11.111,1),(778,7528528,7528521,'rfo',11.111,1),(778,7528529,7528521,'for',11.111,1),(778,7528530,7528521,'orm',11.111,1),(778,7528531,7528521,'rma',11.111,1),(778,7528532,7528521,'man',11.111,1),(778,7528533,7528521,'anc',11.111,1),(778,7528534,7528521,'nce',11.111,1),(778,7528535,7528526,'ide',12.5,1),(778,7528536,7528526,'den',12.5,1),(778,7528537,7528526,'ent',12.5,1),(778,7528538,7528526,'nti',12.5,1),(778,7528539,7528526,'tif',12.5,1),(778,7528540,7528526,'ifi',12.5,1),(778,7528541,7528526,'fie',12.5,1),(778,7528542,7528526,'ier',12.5,1),(778,7528543,7528535,'vdi',33.333,3),(778,7528544,7528535,'dis',33.333,3),(778,7528545,7528535,'isk',33.333,3),(778,7528546,7528543,'nam',50,1),(778,7528547,7528543,'ame',50,1),(778,7528548,7528546,'typ',50,1),(778,7528549,7528546,'ype',50,1),(778,7528550,7528548,'dir',25,1),(778,7528551,7528548,'ire',25,1),(778,7528552,7528548,'rec',25,1),(778,7528553,7528548,'ect',25,1),(779,7528555,7528554,'naa',100,2),(779,7528556,7528555,'600',3.333,3),(779,7528557,7528555,'000',3.333,3),(779,7528558,7528555,'00c',3.333,3),(779,7528559,7528555,'0c2',3.333,3),(779,7528560,7528555,'c29',3.333,3),(779,7528561,7528555,'29b',3.333,3),(779,7528562,7528555,'9b3',3.333,3),(779,7528563,7528555,'b31',3.333,3),(779,7528564,7528555,'318',3.333,3),(779,7528565,7528555,'184',3.333,3),(779,7528566,7528555,'842',3.333,3),(779,7528567,7528555,'420',3.333,3),(779,7528568,7528555,'207',3.333,3),(779,7528569,7528555,'07e',3.333,3),(779,7528570,7528555,'7e0',3.333,3),(779,7528571,7528555,'e03',3.333,3),(779,7528572,7528555,'034',3.333,3),(779,7528573,7528555,'34d',3.333,3),(779,7528574,7528555,'4da',3.333,3),(779,7528575,7528555,'da1',3.333,3),(779,7528576,7528555,'a17',3.333,3),(779,7528577,7528555,'177',3.333,3),(779,7528578,7528555,'77f',3.333,3),(779,7528579,7528555,'7ff',3.333,3),(779,7528580,7528555,'ffe',3.333,3),(779,7528581,7528555,'fe3',3.333,3),(779,7528582,7528555,'e3a',3.333,3),(779,7528583,7528555,'3a9',3.333,3),(779,7528584,7528555,'a9b',3.333,3),(779,7528585,7528555,'9b9',3.333,3),(779,7528586,7528556,'mon',100,1),(779,7528587,7528586,'201',50,1),(779,7528588,7528586,'013',50,1),(779,7528589,7528587,'adm',33.333,4),(779,7528590,7528587,'dmi',33.333,4),(779,7528591,7528587,'min',33.333,4),(779,7528592,7528589,'cap',16.667,1),(779,7528593,7528589,'apa',16.667,1),(779,7528594,7528589,'pac',16.667,1),(779,7528595,7528589,'aci',16.667,1),(779,7528596,7528589,'cit',16.667,1),(779,7528597,7528589,'ity',16.667,1),(779,7528598,7528592,'pat',50,1),(779,7528599,7528592,'ath',50,1),(779,7528600,7528598,'fre',14.286,1),(779,7528601,7528598,'ree',14.286,1),(779,7528602,7528598,'ees',14.286,1),(779,7528603,7528598,'esp',14.286,1),(779,7528604,7528598,'spa',14.286,1),(779,7528605,7528598,'pac',14.286,1),(779,7528606,7528598,'ace',14.286,1),(779,7528607,7528600,'dis',50,1),(779,7528608,7528600,'isk',50,1),(779,7528609,7528607,'ind',33.333,1),(779,7528610,7528607,'nde',33.333,1),(779,7528611,7528607,'dex',33.333,1),(779,7528612,7528609,'adm',8.333,1),(779,7528613,7528609,'dmi',8.333,1),(779,7528614,7528609,'min',8.333,1),(779,7528615,7528609,'ini',8.333,1),(779,7528616,7528609,'nis',8.333,1),(779,7528617,7528609,'ist',8.333,1),(779,7528618,7528609,'str',8.333,1),(779,7528619,7528609,'tra',8.333,1),(779,7528620,7528609,'rat',8.333,1),(779,7528621,7528609,'ati',8.333,1),(779,7528622,7528609,'tio',8.333,1),(779,7528623,7528609,'ion',8.333,1),(779,7528624,7528612,'sta',33.333,3),(779,7528625,7528612,'tat',33.333,3),(779,7528626,7528612,'ate',33.333,3),(779,7528627,7528624,'dis',16.667,4),(779,7528628,7528624,'isa',16.667,4),(779,7528629,7528624,'sab',16.667,4),(779,7528630,7528624,'abl',16.667,4),(779,7528631,7528624,'ble',16.667,4),(779,7528632,7528624,'led',16.667,4),(779,7528633,7528627,'cac',33.333,1),(779,7528634,7528627,'ach',33.333,1),(779,7528635,7528627,'che',33.333,1),(779,7528636,7528633,'mod',50,1),(779,7528637,7528633,'ode',50,1),(779,7528638,7528636,'wri',14.286,1),(779,7528639,7528636,'rit',14.286,1),(779,7528640,7528636,'ite',14.286,1),(779,7528641,7528636,'tet',14.286,1),(779,7528642,7528636,'eth',14.286,1),(779,7528643,7528636,'thr',14.286,1),(779,7528644,7528636,'hru',14.286,1),(779,7528645,7528638,'ope',11.111,2),(779,7528646,7528638,'per',11.111,2),(779,7528647,7528638,'era',11.111,2),(779,7528648,7528638,'rat',11.111,2),(779,7528649,7528638,'ati',11.111,2),(779,7528650,7528638,'tio',11.111,2),(779,7528651,7528638,'ion',11.111,2),(779,7528652,7528638,'ona',11.111,2),(779,7528653,7528638,'nal',11.111,2),(779,7528654,7528645,'mes',20,1),(779,7528655,7528645,'ess',20,1),(779,7528656,7528645,'ssa',20,1),(779,7528657,7528645,'sag',20,1),(779,7528658,7528645,'age',20,1),(779,7528659,7528654,'per',11.111,1),(779,7528660,7528654,'erf',11.111,1),(779,7528661,7528654,'rfo',11.111,1),(779,7528662,7528654,'for',11.111,1),(779,7528663,7528654,'orm',11.111,1),(779,7528664,7528654,'rma',11.111,1),(779,7528665,7528654,'man',11.111,1),(779,7528666,7528654,'anc',11.111,1),(779,7528667,7528654,'nce',11.111,1),(779,7528668,7528659,'ide',12.5,1),(779,7528669,7528659,'den',12.5,1),(779,7528670,7528659,'ent',12.5,1),(779,7528671,7528659,'nti',12.5,1),(779,7528672,7528659,'tif',12.5,1),(779,7528673,7528659,'ifi',12.5,1),(779,7528674,7528659,'fie',12.5,1),(779,7528675,7528659,'ier',12.5,1),(779,7528676,7528668,'vdi',33.333,3),(779,7528677,7528668,'dis',33.333,3),(779,7528678,7528668,'isk',33.333,3),(779,7528679,7528676,'nam',50,1),(779,7528680,7528676,'ame',50,1),(779,7528681,7528679,'typ',50,1),(779,7528682,7528679,'ype',50,1),(779,7528683,7528681,'dir',25,1),(779,7528684,7528681,'ire',25,1),(779,7528685,7528681,'rec',25,1),(779,7528686,7528681,'ect',25,1),(780,7528688,7528687,'naa',100,2),(780,7528689,7528688,'600',3.333,3),(780,7528690,7528688,'000',3.333,3),(780,7528691,7528688,'00c',3.333,3),(780,7528692,7528688,'0c2',3.333,3),(780,7528693,7528688,'c29',3.333,3),(780,7528694,7528688,'291',3.333,3),(780,7528695,7528688,'914',3.333,3),(780,7528696,7528688,'148',3.333,3),(780,7528697,7528688,'489',3.333,3),(780,7528698,7528688,'896',3.333,3),(780,7528699,7528688,'969',3.333,3),(780,7528700,7528688,'69c',3.333,3),(780,7528701,7528688,'9cd',3.333,3),(780,7528702,7528688,'cd1',3.333,3),(780,7528703,7528688,'d18',3.333,3),(780,7528704,7528688,'182',3.333,3),(780,7528705,7528688,'823',3.333,3),(780,7528706,7528688,'234',3.333,3),(780,7528707,7528688,'347',3.333,3),(780,7528708,7528688,'471',3.333,3),(780,7528709,7528688,'71f',3.333,3),(780,7528710,7528688,'1f8',3.333,3),(780,7528711,7528688,'f87',3.333,3),(780,7528712,7528688,'877',3.333,3),(780,7528713,7528688,'777',3.333,3),(780,7528714,7528688,'776',3.333,3),(780,7528715,7528688,'761',3.333,3),(780,7528716,7528688,'618',3.333,3),(780,7528717,7528688,'18b',3.333,3),(780,7528718,7528688,'8b3',3.333,3),(780,7528719,7528689,'mon',100,1),(780,7528720,7528719,'201',50,1),(780,7528721,7528719,'013',50,1),(780,7528722,7528720,'adm',33.333,4),(780,7528723,7528720,'dmi',33.333,4),(780,7528724,7528720,'min',33.333,4),(780,7528725,7528722,'cap',16.667,1),(780,7528726,7528722,'apa',16.667,1),(780,7528727,7528722,'pac',16.667,1),(780,7528728,7528722,'aci',16.667,1),(780,7528729,7528722,'cit',16.667,1),(780,7528730,7528722,'ity',16.667,1),(780,7528731,7528725,'pat',50,1),(780,7528732,7528725,'ath',50,1),(780,7528733,7528731,'fre',14.286,1),(780,7528734,7528731,'ree',14.286,1),(780,7528735,7528731,'ees',14.286,1),(780,7528736,7528731,'esp',14.286,1),(780,7528737,7528731,'spa',14.286,1),(780,7528738,7528731,'pac',14.286,1),(780,7528739,7528731,'ace',14.286,1),(780,7528740,7528733,'dis',50,1),(780,7528741,7528733,'isk',50,1),(780,7528742,7528740,'ind',33.333,1),(780,7528743,7528740,'nde',33.333,1),(780,7528744,7528740,'dex',33.333,1),(780,7528745,7528742,'adm',8.333,1),(780,7528746,7528742,'dmi',8.333,1),(780,7528747,7528742,'min',8.333,1),(780,7528748,7528742,'ini',8.333,1),(780,7528749,7528742,'nis',8.333,1),(780,7528750,7528742,'ist',8.333,1),(780,7528751,7528742,'str',8.333,1),(780,7528752,7528742,'tra',8.333,1),(780,7528753,7528742,'rat',8.333,1),(780,7528754,7528742,'ati',8.333,1),(780,7528755,7528742,'tio',8.333,1),(780,7528756,7528742,'ion',8.333,1),(780,7528757,7528745,'sta',33.333,3),(780,7528758,7528745,'tat',33.333,3),(780,7528759,7528745,'ate',33.333,3),(780,7528760,7528757,'dis',16.667,4),(780,7528761,7528757,'isa',16.667,4),(780,7528762,7528757,'sab',16.667,4),(780,7528763,7528757,'abl',16.667,4),(780,7528764,7528757,'ble',16.667,4),(780,7528765,7528757,'led',16.667,4),(780,7528766,7528760,'cac',33.333,1),(780,7528767,7528760,'ach',33.333,1),(780,7528768,7528760,'che',33.333,1),(780,7528769,7528766,'mod',50,1),(780,7528770,7528766,'ode',50,1),(780,7528771,7528769,'wri',14.286,1),(780,7528772,7528769,'rit',14.286,1),(780,7528773,7528769,'ite',14.286,1),(780,7528774,7528769,'tet',14.286,1),(780,7528775,7528769,'eth',14.286,1),(780,7528776,7528769,'thr',14.286,1),(780,7528777,7528769,'hru',14.286,1),(780,7528778,7528771,'ope',11.111,2),(780,7528779,7528771,'per',11.111,2),(780,7528780,7528771,'era',11.111,2),(780,7528781,7528771,'rat',11.111,2),(780,7528782,7528771,'ati',11.111,2),(780,7528783,7528771,'tio',11.111,2),(780,7528784,7528771,'ion',11.111,2),(780,7528785,7528771,'ona',11.111,2),(780,7528786,7528771,'nal',11.111,2),(780,7528787,7528778,'mes',20,1),(780,7528788,7528778,'ess',20,1),(780,7528789,7528778,'ssa',20,1),(780,7528790,7528778,'sag',20,1),(780,7528791,7528778,'age',20,1),(780,7528792,7528787,'per',11.111,1),(780,7528793,7528787,'erf',11.111,1),(780,7528794,7528787,'rfo',11.111,1),(780,7528795,7528787,'for',11.111,1),(780,7528796,7528787,'orm',11.111,1),(780,7528797,7528787,'rma',11.111,1),(780,7528798,7528787,'man',11.111,1),(780,7528799,7528787,'anc',11.111,1),(780,7528800,7528787,'nce',11.111,1),(780,7528801,7528792,'ide',12.5,1),(780,7528802,7528792,'den',12.5,1),(780,7528803,7528792,'ent',12.5,1),(780,7528804,7528792,'nti',12.5,1),(780,7528805,7528792,'tif',12.5,1),(780,7528806,7528792,'ifi',12.5,1),(780,7528807,7528792,'fie',12.5,1),(780,7528808,7528792,'ier',12.5,1),(780,7528809,7528801,'vdi',33.333,3),(780,7528810,7528801,'dis',33.333,3),(780,7528811,7528801,'isk',33.333,3),(780,7528812,7528809,'nam',50,1),(780,7528813,7528809,'ame',50,1),(780,7528814,7528812,'typ',50,1),(780,7528815,7528812,'ype',50,1),(780,7528816,7528814,'dir',25,1),(780,7528817,7528814,'ire',25,1),(780,7528818,7528814,'rec',25,1),(780,7528819,7528814,'ect',25,1),(781,7528821,7528820,'naa',100,2),(781,7528822,7528821,'600',3.333,3),(781,7528823,7528821,'000',3.333,3),(781,7528824,7528821,'00c',3.333,3),(781,7528825,7528821,'0c2',3.333,3),(781,7528826,7528821,'c29',3.333,3),(781,7528827,7528821,'295',3.333,3),(781,7528828,7528821,'954',3.333,3),(781,7528829,7528821,'54a',3.333,3),(781,7528830,7528821,'4a0',3.333,3),(781,7528831,7528821,'a0e',3.333,3),(781,7528832,7528821,'0e6',3.333,3),(781,7528833,7528821,'e69',3.333,3),(781,7528834,7528821,'69e',3.333,3),(781,7528835,7528821,'9e1',3.333,3),(781,7528836,7528821,'e1f',3.333,3),(781,7528837,7528821,'1fb',3.333,3),(781,7528838,7528821,'fbd',3.333,3),(781,7528839,7528821,'bd0',3.333,3),(781,7528840,7528821,'d0d',3.333,3),(781,7528841,7528821,'0db',3.333,3),(781,7528842,7528821,'db6',3.333,3),(781,7528843,7528821,'b65',3.333,3),(781,7528844,7528821,'650',3.333,3),(781,7528845,7528821,'505',3.333,3),(781,7528846,7528821,'05f',3.333,3),(781,7528847,7528821,'5f6',3.333,3),(781,7528848,7528821,'f68',3.333,3),(781,7528849,7528821,'683',3.333,3),(781,7528850,7528821,'833',3.333,3),(781,7528851,7528821,'334',3.333,3),(781,7528852,7528822,'mon',100,1),(781,7528853,7528852,'201',50,1),(781,7528854,7528852,'013',50,1),(781,7528855,7528853,'adm',33.333,4),(781,7528856,7528853,'dmi',33.333,4),(781,7528857,7528853,'min',33.333,4),(781,7528858,7528855,'cap',16.667,1),(781,7528859,7528855,'apa',16.667,1),(781,7528860,7528855,'pac',16.667,1),(781,7528861,7528855,'aci',16.667,1),(781,7528862,7528855,'cit',16.667,1),(781,7528863,7528855,'ity',16.667,1),(781,7528864,7528858,'pat',50,1),(781,7528865,7528858,'ath',50,1),(781,7528866,7528864,'fre',14.286,1),(781,7528867,7528864,'ree',14.286,1),(781,7528868,7528864,'ees',14.286,1),(781,7528869,7528864,'esp',14.286,1),(781,7528870,7528864,'spa',14.286,1),(781,7528871,7528864,'pac',14.286,1),(781,7528872,7528864,'ace',14.286,1),(781,7528873,7528866,'dis',50,1),(781,7528874,7528866,'isk',50,1),(781,7528875,7528873,'ind',33.333,1),(781,7528876,7528873,'nde',33.333,1),(781,7528877,7528873,'dex',33.333,1),(781,7528878,7528875,'adm',8.333,1),(781,7528879,7528875,'dmi',8.333,1),(781,7528880,7528875,'min',8.333,1),(781,7528881,7528875,'ini',8.333,1),(781,7528882,7528875,'nis',8.333,1),(781,7528883,7528875,'ist',8.333,1),(781,7528884,7528875,'str',8.333,1),(781,7528885,7528875,'tra',8.333,1),(781,7528886,7528875,'rat',8.333,1),(781,7528887,7528875,'ati',8.333,1),(781,7528888,7528875,'tio',8.333,1),(781,7528889,7528875,'ion',8.333,1),(781,7528890,7528878,'sta',33.333,3),(781,7528891,7528878,'tat',33.333,3),(781,7528892,7528878,'ate',33.333,3),(781,7528893,7528890,'dis',16.667,4),(781,7528894,7528890,'isa',16.667,4),(781,7528895,7528890,'sab',16.667,4),(781,7528896,7528890,'abl',16.667,4),(781,7528897,7528890,'ble',16.667,4),(781,7528898,7528890,'led',16.667,4),(781,7528899,7528893,'cac',33.333,1),(781,7528900,7528893,'ach',33.333,1),(781,7528901,7528893,'che',33.333,1),(781,7528902,7528899,'mod',50,1),(781,7528903,7528899,'ode',50,1),(781,7528904,7528902,'wri',14.286,1),(781,7528905,7528902,'rit',14.286,1),(781,7528906,7528902,'ite',14.286,1),(781,7528907,7528902,'tet',14.286,1),(781,7528908,7528902,'eth',14.286,1),(781,7528909,7528902,'thr',14.286,1),(781,7528910,7528902,'hru',14.286,1),(781,7528911,7528904,'ope',11.111,2),(781,7528912,7528904,'per',11.111,2),(781,7528913,7528904,'era',11.111,2),(781,7528914,7528904,'rat',11.111,2),(781,7528915,7528904,'ati',11.111,2),(781,7528916,7528904,'tio',11.111,2),(781,7528917,7528904,'ion',11.111,2),(781,7528918,7528904,'ona',11.111,2),(781,7528919,7528904,'nal',11.111,2),(781,7528920,7528911,'mes',20,1),(781,7528921,7528911,'ess',20,1),(781,7528922,7528911,'ssa',20,1),(781,7528923,7528911,'sag',20,1),(781,7528924,7528911,'age',20,1),(781,7528925,7528920,'per',11.111,1),(781,7528926,7528920,'erf',11.111,1),(781,7528927,7528920,'rfo',11.111,1),(781,7528928,7528920,'for',11.111,1),(781,7528929,7528920,'orm',11.111,1),(781,7528930,7528920,'rma',11.111,1),(781,7528931,7528920,'man',11.111,1),(781,7528932,7528920,'anc',11.111,1),(781,7528933,7528920,'nce',11.111,1),(781,7528934,7528925,'ide',12.5,1),(781,7528935,7528925,'den',12.5,1),(781,7528936,7528925,'ent',12.5,1),(781,7528937,7528925,'nti',12.5,1),(781,7528938,7528925,'tif',12.5,1),(781,7528939,7528925,'ifi',12.5,1),(781,7528940,7528925,'fie',12.5,1),(781,7528941,7528925,'ier',12.5,1),(781,7528942,7528934,'vdi',33.333,3),(781,7528943,7528934,'dis',33.333,3),(781,7528944,7528934,'isk',33.333,3),(781,7528945,7528942,'nam',50,1),(781,7528946,7528942,'ame',50,1),(781,7528947,7528945,'typ',50,1),(781,7528948,7528945,'ype',50,1),(781,7528949,7528947,'dir',25,1),(781,7528950,7528947,'ire',25,1),(781,7528951,7528947,'rec',25,1),(781,7528952,7528947,'ect',25,1),(782,7528954,7528953,'naa',100,2),(782,7528955,7528954,'600',3.333,3),(782,7528956,7528954,'000',3.333,3),(782,7528957,7528954,'00c',3.333,3),(782,7528958,7528954,'0c2',3.333,3),(782,7528959,7528954,'c29',3.333,3),(782,7528960,7528954,'296',3.333,3),(782,7528961,7528954,'966',3.333,3),(782,7528962,7528954,'667',3.333,3),(782,7528963,7528954,'67a',3.333,3),(782,7528964,7528954,'7a0',3.333,3),(782,7528965,7528954,'a08',3.333,3),(782,7528966,7528954,'08a',3.333,3),(782,7528967,7528954,'8a4',3.333,3),(782,7528968,7528954,'a48',3.333,3),(782,7528969,7528954,'486',3.333,3),(782,7528970,7528954,'867',3.333,3),(782,7528971,7528954,'679',3.333,3),(782,7528972,7528954,'79f',3.333,3),(782,7528973,7528954,'9fc',3.333,3),(782,7528974,7528954,'fc2',3.333,3),(782,7528975,7528954,'c22',3.333,3),(782,7528976,7528954,'22a',3.333,3),(782,7528977,7528954,'2a3',3.333,3),(782,7528978,7528954,'a32',3.333,3),(782,7528979,7528954,'32e',3.333,3),(782,7528980,7528954,'2eb',3.333,3),(782,7528981,7528954,'eb0',3.333,3),(782,7528982,7528954,'b07',3.333,3),(782,7528983,7528954,'07d',3.333,3),(782,7528984,7528954,'7d9',3.333,3),(782,7528985,7528955,'mon',100,1),(782,7528986,7528985,'201',50,1),(782,7528987,7528985,'013',50,1),(782,7528988,7528986,'adm',33.333,4),(782,7528989,7528986,'dmi',33.333,4),(782,7528990,7528986,'min',33.333,4),(782,7528991,7528988,'cap',16.667,1),(782,7528992,7528988,'apa',16.667,1),(782,7528993,7528988,'pac',16.667,1),(782,7528994,7528988,'aci',16.667,1),(782,7528995,7528988,'cit',16.667,1),(782,7528996,7528988,'ity',16.667,1),(782,7528997,7528991,'pat',50,1),(782,7528998,7528991,'ath',50,1),(782,7528999,7528997,'fre',14.286,1),(782,7529000,7528997,'ree',14.286,1),(782,7529001,7528997,'ees',14.286,1),(782,7529002,7528997,'esp',14.286,1),(782,7529003,7528997,'spa',14.286,1),(782,7529004,7528997,'pac',14.286,1),(782,7529005,7528997,'ace',14.286,1),(782,7529006,7528999,'dis',50,1),(782,7529007,7528999,'isk',50,1),(782,7529008,7529006,'ind',33.333,1),(782,7529009,7529006,'nde',33.333,1),(782,7529010,7529006,'dex',33.333,1),(782,7529011,7529008,'adm',8.333,1),(782,7529012,7529008,'dmi',8.333,1),(782,7529013,7529008,'min',8.333,1),(782,7529014,7529008,'ini',8.333,1),(782,7529015,7529008,'nis',8.333,1),(782,7529016,7529008,'ist',8.333,1),(782,7529017,7529008,'str',8.333,1),(782,7529018,7529008,'tra',8.333,1),(782,7529019,7529008,'rat',8.333,1),(782,7529020,7529008,'ati',8.333,1),(782,7529021,7529008,'tio',8.333,1),(782,7529022,7529008,'ion',8.333,1),(782,7529023,7529011,'sta',33.333,3),(782,7529024,7529011,'tat',33.333,3),(782,7529025,7529011,'ate',33.333,3),(782,7529026,7529023,'dis',16.667,4),(782,7529027,7529023,'isa',16.667,4),(782,7529028,7529023,'sab',16.667,4),(782,7529029,7529023,'abl',16.667,4),(782,7529030,7529023,'ble',16.667,4),(782,7529031,7529023,'led',16.667,4),(782,7529032,7529026,'cac',33.333,1),(782,7529033,7529026,'ach',33.333,1),(782,7529034,7529026,'che',33.333,1),(782,7529035,7529032,'mod',50,1),(782,7529036,7529032,'ode',50,1),(782,7529037,7529035,'wri',14.286,1),(782,7529038,7529035,'rit',14.286,1),(782,7529039,7529035,'ite',14.286,1),(782,7529040,7529035,'tet',14.286,1),(782,7529041,7529035,'eth',14.286,1),(782,7529042,7529035,'thr',14.286,1),(782,7529043,7529035,'hru',14.286,1),(782,7529044,7529037,'ope',11.111,2),(782,7529045,7529037,'per',11.111,2),(782,7529046,7529037,'era',11.111,2),(782,7529047,7529037,'rat',11.111,2),(782,7529048,7529037,'ati',11.111,2),(782,7529049,7529037,'tio',11.111,2),(782,7529050,7529037,'ion',11.111,2),(782,7529051,7529037,'ona',11.111,2),(782,7529052,7529037,'nal',11.111,2),(782,7529053,7529044,'mes',20,1),(782,7529054,7529044,'ess',20,1),(782,7529055,7529044,'ssa',20,1),(782,7529056,7529044,'sag',20,1),(782,7529057,7529044,'age',20,1),(782,7529058,7529053,'per',11.111,1),(782,7529059,7529053,'erf',11.111,1),(782,7529060,7529053,'rfo',11.111,1),(782,7529061,7529053,'for',11.111,1),(782,7529062,7529053,'orm',11.111,1),(782,7529063,7529053,'rma',11.111,1),(782,7529064,7529053,'man',11.111,1),(782,7529065,7529053,'anc',11.111,1),(782,7529066,7529053,'nce',11.111,1),(782,7529067,7529058,'ide',12.5,1),(782,7529068,7529058,'den',12.5,1),(782,7529069,7529058,'ent',12.5,1),(782,7529070,7529058,'nti',12.5,1),(782,7529071,7529058,'tif',12.5,1),(782,7529072,7529058,'ifi',12.5,1),(782,7529073,7529058,'fie',12.5,1),(782,7529074,7529058,'ier',12.5,1),(782,7529075,7529067,'vdi',33.333,3),(782,7529076,7529067,'dis',33.333,3),(782,7529077,7529067,'isk',33.333,3),(782,7529078,7529075,'nam',50,1),(782,7529079,7529075,'ame',50,1),(782,7529080,7529078,'typ',50,1),(782,7529081,7529078,'ype',50,1),(782,7529082,7529080,'dir',25,1),(782,7529083,7529080,'ire',25,1),(782,7529084,7529080,'rec',25,1),(782,7529085,7529080,'ect',25,1),(783,7529087,7529086,'naa',100,2),(783,7529088,7529087,'600',3.333,3),(783,7529089,7529087,'000',3.333,3),(783,7529090,7529087,'00c',3.333,3),(783,7529091,7529087,'0c2',3.333,3),(783,7529092,7529087,'c29',3.333,3),(783,7529093,7529087,'294',3.333,3),(783,7529094,7529087,'943',3.333,3),(783,7529095,7529087,'43e',3.333,3),(783,7529096,7529087,'3e5',3.333,3),(783,7529097,7529087,'e5d',3.333,3),(783,7529098,7529087,'5d5',3.333,3),(783,7529099,7529087,'d58',3.333,3),(783,7529100,7529087,'58a',3.333,3),(783,7529101,7529087,'8a1',3.333,3),(783,7529102,7529087,'a1e',3.333,3),(783,7529103,7529087,'1e4',3.333,3),(783,7529104,7529087,'e45',3.333,3),(783,7529105,7529087,'450',3.333,3),(783,7529106,7529087,'500',3.333,3),(783,7529107,7529087,'009',3.333,3),(783,7529108,7529087,'093',3.333,3),(783,7529109,7529087,'937',3.333,3),(783,7529110,7529087,'373',3.333,3),(783,7529111,7529087,'737',3.333,3),(783,7529112,7529087,'37e',3.333,3),(783,7529113,7529087,'7e8',3.333,3),(783,7529114,7529087,'e82',3.333,3),(783,7529115,7529087,'820',3.333,3),(783,7529116,7529087,'209',3.333,3),(783,7529117,7529087,'09b',3.333,3),(783,7529118,7529088,'mon',100,1),(783,7529119,7529118,'201',50,1),(783,7529120,7529118,'013',50,1),(783,7529121,7529119,'adm',33.333,4),(783,7529122,7529119,'dmi',33.333,4),(783,7529123,7529119,'min',33.333,4),(783,7529124,7529121,'cap',16.667,1),(783,7529125,7529121,'apa',16.667,1),(783,7529126,7529121,'pac',16.667,1),(783,7529127,7529121,'aci',16.667,1),(783,7529128,7529121,'cit',16.667,1),(783,7529129,7529121,'ity',16.667,1),(783,7529130,7529124,'pat',50,1),(783,7529131,7529124,'ath',50,1),(783,7529132,7529130,'fre',14.286,1),(783,7529133,7529130,'ree',14.286,1),(783,7529134,7529130,'ees',14.286,1),(783,7529135,7529130,'esp',14.286,1),(783,7529136,7529130,'spa',14.286,1),(783,7529137,7529130,'pac',14.286,1),(783,7529138,7529130,'ace',14.286,1),(783,7529139,7529132,'dis',50,1),(783,7529140,7529132,'isk',50,1),(783,7529141,7529139,'ind',33.333,1),(783,7529142,7529139,'nde',33.333,1),(783,7529143,7529139,'dex',33.333,1),(783,7529144,7529141,'adm',8.333,1),(783,7529145,7529141,'dmi',8.333,1),(783,7529146,7529141,'min',8.333,1),(783,7529147,7529141,'ini',8.333,1),(783,7529148,7529141,'nis',8.333,1),(783,7529149,7529141,'ist',8.333,1),(783,7529150,7529141,'str',8.333,1),(783,7529151,7529141,'tra',8.333,1),(783,7529152,7529141,'rat',8.333,1),(783,7529153,7529141,'ati',8.333,1),(783,7529154,7529141,'tio',8.333,1),(783,7529155,7529141,'ion',8.333,1),(783,7529156,7529144,'sta',33.333,3),(783,7529157,7529144,'tat',33.333,3),(783,7529158,7529144,'ate',33.333,3),(783,7529159,7529156,'dis',16.667,4),(783,7529160,7529156,'isa',16.667,4),(783,7529161,7529156,'sab',16.667,4),(783,7529162,7529156,'abl',16.667,4),(783,7529163,7529156,'ble',16.667,4),(783,7529164,7529156,'led',16.667,4),(783,7529165,7529159,'cac',33.333,1),(783,7529166,7529159,'ach',33.333,1),(783,7529167,7529159,'che',33.333,1),(783,7529168,7529165,'mod',50,1),(783,7529169,7529165,'ode',50,1),(783,7529170,7529168,'wri',14.286,1),(783,7529171,7529168,'rit',14.286,1),(783,7529172,7529168,'ite',14.286,1),(783,7529173,7529168,'tet',14.286,1),(783,7529174,7529168,'eth',14.286,1),(783,7529175,7529168,'thr',14.286,1),(783,7529176,7529168,'hru',14.286,1),(783,7529177,7529170,'ope',11.111,2),(783,7529178,7529170,'per',11.111,2),(783,7529179,7529170,'era',11.111,2),(783,7529180,7529170,'rat',11.111,2),(783,7529181,7529170,'ati',11.111,2),(783,7529182,7529170,'tio',11.111,2),(783,7529183,7529170,'ion',11.111,2),(783,7529184,7529170,'ona',11.111,2),(783,7529185,7529170,'nal',11.111,2),(783,7529186,7529177,'mes',20,1),(783,7529187,7529177,'ess',20,1),(783,7529188,7529177,'ssa',20,1),(783,7529189,7529177,'sag',20,1),(783,7529190,7529177,'age',20,1),(783,7529191,7529186,'per',11.111,1),(783,7529192,7529186,'erf',11.111,1),(783,7529193,7529186,'rfo',11.111,1),(783,7529194,7529186,'for',11.111,1),(783,7529195,7529186,'orm',11.111,1),(783,7529196,7529186,'rma',11.111,1),(783,7529197,7529186,'man',11.111,1),(783,7529198,7529186,'anc',11.111,1),(783,7529199,7529186,'nce',11.111,1),(783,7529200,7529191,'ide',12.5,1),(783,7529201,7529191,'den',12.5,1),(783,7529202,7529191,'ent',12.5,1),(783,7529203,7529191,'nti',12.5,1),(783,7529204,7529191,'tif',12.5,1),(783,7529205,7529191,'ifi',12.5,1),(783,7529206,7529191,'fie',12.5,1),(783,7529207,7529191,'ier',12.5,1),(783,7529208,7529200,'vdi',33.333,3),(783,7529209,7529200,'dis',33.333,3),(783,7529210,7529200,'isk',33.333,3),(783,7529211,7529208,'nam',50,1),(783,7529212,7529208,'ame',50,1),(783,7529213,7529211,'typ',50,1),(783,7529214,7529211,'ype',50,1),(783,7529215,7529213,'dir',25,1),(783,7529216,7529213,'ire',25,1),(783,7529217,7529213,'rec',25,1),(783,7529218,7529213,'ect',25,1),(784,7529220,7529219,'naa',100,2),(784,7529221,7529220,'600',3.333,3),(784,7529222,7529220,'000',3.333,3),(784,7529223,7529220,'00c',3.333,3),(784,7529224,7529220,'0c2',3.333,3),(784,7529225,7529220,'c29',3.333,3),(784,7529226,7529220,'29b',3.333,3),(784,7529227,7529220,'9b7',3.333,3),(784,7529228,7529220,'b78',3.333,3),(784,7529229,7529220,'788',3.333,3),(784,7529230,7529220,'885',3.333,3),(784,7529231,7529220,'85f',3.333,3),(784,7529232,7529220,'5fa',3.333,3),(784,7529233,7529220,'fa7',3.333,3),(784,7529234,7529220,'a79',3.333,3),(784,7529235,7529220,'792',3.333,3),(784,7529236,7529220,'92f',3.333,3),(784,7529237,7529220,'2f8',3.333,3),(784,7529238,7529220,'f8f',3.333,3),(784,7529239,7529220,'8f9',3.333,3),(784,7529240,7529220,'f91',3.333,3),(784,7529241,7529220,'91f',3.333,3),(784,7529242,7529220,'1fe',3.333,3),(784,7529243,7529220,'fe5',3.333,3),(784,7529244,7529220,'e51',3.333,3),(784,7529245,7529220,'51a',3.333,3),(784,7529246,7529220,'1a5',3.333,3),(784,7529247,7529220,'a52',3.333,3),(784,7529248,7529220,'528',3.333,3),(784,7529249,7529220,'28d',3.333,3),(784,7529250,7529220,'8d0',3.333,3),(784,7529251,7529221,'mon',100,1),(784,7529252,7529251,'201',50,1),(784,7529253,7529251,'013',50,1),(784,7529254,7529252,'adm',33.333,4),(784,7529255,7529252,'dmi',33.333,4),(784,7529256,7529252,'min',33.333,4),(784,7529257,7529254,'cap',16.667,1),(784,7529258,7529254,'apa',16.667,1),(784,7529259,7529254,'pac',16.667,1),(784,7529260,7529254,'aci',16.667,1),(784,7529261,7529254,'cit',16.667,1),(784,7529262,7529254,'ity',16.667,1),(784,7529263,7529257,'pat',50,1),(784,7529264,7529257,'ath',50,1),(784,7529265,7529263,'fre',14.286,1),(784,7529266,7529263,'ree',14.286,1),(784,7529267,7529263,'ees',14.286,1),(784,7529268,7529263,'esp',14.286,1),(784,7529269,7529263,'spa',14.286,1),(784,7529270,7529263,'pac',14.286,1),(784,7529271,7529263,'ace',14.286,1),(784,7529272,7529265,'dis',50,1),(784,7529273,7529265,'isk',50,1),(784,7529274,7529272,'ind',33.333,1),(784,7529275,7529272,'nde',33.333,1),(784,7529276,7529272,'dex',33.333,1),(784,7529277,7529274,'adm',8.333,1),(784,7529278,7529274,'dmi',8.333,1),(784,7529279,7529274,'min',8.333,1),(784,7529280,7529274,'ini',8.333,1),(784,7529281,7529274,'nis',8.333,1),(784,7529282,7529274,'ist',8.333,1),(784,7529283,7529274,'str',8.333,1),(784,7529284,7529274,'tra',8.333,1),(784,7529285,7529274,'rat',8.333,1),(784,7529286,7529274,'ati',8.333,1),(784,7529287,7529274,'tio',8.333,1),(784,7529288,7529274,'ion',8.333,1),(784,7529289,7529277,'sta',33.333,3),(784,7529290,7529277,'tat',33.333,3),(784,7529291,7529277,'ate',33.333,3),(784,7529292,7529289,'dis',16.667,4),(784,7529293,7529289,'isa',16.667,4),(784,7529294,7529289,'sab',16.667,4),(784,7529295,7529289,'abl',16.667,4),(784,7529296,7529289,'ble',16.667,4),(784,7529297,7529289,'led',16.667,4),(784,7529298,7529292,'cac',33.333,1),(784,7529299,7529292,'ach',33.333,1),(784,7529300,7529292,'che',33.333,1),(784,7529301,7529298,'mod',50,1),(784,7529302,7529298,'ode',50,1),(784,7529303,7529301,'wri',14.286,1),(784,7529304,7529301,'rit',14.286,1),(784,7529305,7529301,'ite',14.286,1),(784,7529306,7529301,'tet',14.286,1),(784,7529307,7529301,'eth',14.286,1),(784,7529308,7529301,'thr',14.286,1),(784,7529309,7529301,'hru',14.286,1),(784,7529310,7529303,'ope',11.111,2),(784,7529311,7529303,'per',11.111,2),(784,7529312,7529303,'era',11.111,2),(784,7529313,7529303,'rat',11.111,2),(784,7529314,7529303,'ati',11.111,2),(784,7529315,7529303,'tio',11.111,2),(784,7529316,7529303,'ion',11.111,2),(784,7529317,7529303,'ona',11.111,2),(784,7529318,7529303,'nal',11.111,2),(784,7529319,7529310,'mes',20,1),(784,7529320,7529310,'ess',20,1),(784,7529321,7529310,'ssa',20,1),(784,7529322,7529310,'sag',20,1),(784,7529323,7529310,'age',20,1),(784,7529324,7529319,'per',11.111,1),(784,7529325,7529319,'erf',11.111,1),(784,7529326,7529319,'rfo',11.111,1),(784,7529327,7529319,'for',11.111,1),(784,7529328,7529319,'orm',11.111,1),(784,7529329,7529319,'rma',11.111,1),(784,7529330,7529319,'man',11.111,1),(784,7529331,7529319,'anc',11.111,1),(784,7529332,7529319,'nce',11.111,1),(784,7529333,7529324,'ide',12.5,1),(784,7529334,7529324,'den',12.5,1),(784,7529335,7529324,'ent',12.5,1),(784,7529336,7529324,'nti',12.5,1),(784,7529337,7529324,'tif',12.5,1),(784,7529338,7529324,'ifi',12.5,1),(784,7529339,7529324,'fie',12.5,1),(784,7529340,7529324,'ier',12.5,1),(784,7529341,7529333,'vdi',33.333,3),(784,7529342,7529333,'dis',33.333,3),(784,7529343,7529333,'isk',33.333,3),(784,7529344,7529341,'nam',50,1),(784,7529345,7529341,'ame',50,1),(784,7529346,7529344,'typ',50,1),(784,7529347,7529344,'ype',50,1),(784,7529348,7529346,'dir',25,1),(784,7529349,7529346,'ire',25,1),(784,7529350,7529346,'rec',25,1),(784,7529351,7529346,'ect',25,1),(785,7529353,7529352,'naa',100,2),(785,7529354,7529353,'600',3.333,3),(785,7529355,7529353,'000',3.333,3),(785,7529356,7529353,'00c',3.333,3),(785,7529357,7529353,'0c2',3.333,3),(785,7529358,7529353,'c29',3.333,3),(785,7529359,7529353,'290',3.333,3),(785,7529360,7529353,'90a',3.333,3),(785,7529361,7529353,'0aa',3.333,3),(785,7529362,7529353,'aa5',3.333,3),(785,7529363,7529353,'a50',3.333,3),(785,7529364,7529353,'507',3.333,3),(785,7529365,7529353,'072',3.333,3),(785,7529366,7529353,'725',3.333,3),(785,7529367,7529353,'259',3.333,3),(785,7529368,7529353,'599',3.333,3),(785,7529369,7529353,'99e',3.333,3),(785,7529370,7529353,'9e1',3.333,3),(785,7529371,7529353,'e1d',3.333,3),(785,7529372,7529353,'1d6',3.333,3),(785,7529373,7529353,'d6a',3.333,3),(785,7529374,7529353,'6ac',3.333,3),(785,7529375,7529353,'ac3',3.333,3),(785,7529376,7529353,'c35',3.333,3),(785,7529377,7529353,'356',3.333,3),(785,7529378,7529353,'567',3.333,3),(785,7529379,7529353,'676',3.333,3),(785,7529380,7529353,'767',3.333,3),(785,7529381,7529353,'67a',3.333,3),(785,7529382,7529353,'7af',3.333,3),(785,7529383,7529353,'af2',3.333,3),(785,7529384,7529354,'mon',100,1),(785,7529385,7529384,'201',50,1),(785,7529386,7529384,'013',50,1),(785,7529387,7529385,'adm',33.333,4),(785,7529388,7529385,'dmi',33.333,4),(785,7529389,7529385,'min',33.333,4),(785,7529390,7529387,'cap',16.667,1),(785,7529391,7529387,'apa',16.667,1),(785,7529392,7529387,'pac',16.667,1),(785,7529393,7529387,'aci',16.667,1),(785,7529394,7529387,'cit',16.667,1),(785,7529395,7529387,'ity',16.667,1),(785,7529396,7529390,'pat',50,1),(785,7529397,7529390,'ath',50,1),(785,7529398,7529396,'fre',14.286,1),(785,7529399,7529396,'ree',14.286,1),(785,7529400,7529396,'ees',14.286,1),(785,7529401,7529396,'esp',14.286,1),(785,7529402,7529396,'spa',14.286,1),(785,7529403,7529396,'pac',14.286,1),(785,7529404,7529396,'ace',14.286,1),(785,7529405,7529398,'dis',50,1),(785,7529406,7529398,'isk',50,1),(785,7529407,7529405,'ind',33.333,1),(785,7529408,7529405,'nde',33.333,1),(785,7529409,7529405,'dex',33.333,1),(785,7529410,7529407,'adm',8.333,1),(785,7529411,7529407,'dmi',8.333,1),(785,7529412,7529407,'min',8.333,1),(785,7529413,7529407,'ini',8.333,1),(785,7529414,7529407,'nis',8.333,1),(785,7529415,7529407,'ist',8.333,1),(785,7529416,7529407,'str',8.333,1),(785,7529417,7529407,'tra',8.333,1),(785,7529418,7529407,'rat',8.333,1),(785,7529419,7529407,'ati',8.333,1),(785,7529420,7529407,'tio',8.333,1),(785,7529421,7529407,'ion',8.333,1),(785,7529422,7529410,'sta',33.333,3),(785,7529423,7529410,'tat',33.333,3),(785,7529424,7529410,'ate',33.333,3),(785,7529425,7529422,'dis',16.667,4),(785,7529426,7529422,'isa',16.667,4),(785,7529427,7529422,'sab',16.667,4),(785,7529428,7529422,'abl',16.667,4),(785,7529429,7529422,'ble',16.667,4),(785,7529430,7529422,'led',16.667,4),(785,7529431,7529425,'cac',33.333,1),(785,7529432,7529425,'ach',33.333,1),(785,7529433,7529425,'che',33.333,1),(785,7529434,7529431,'mod',50,1),(785,7529435,7529431,'ode',50,1),(785,7529436,7529434,'wri',14.286,1),(785,7529437,7529434,'rit',14.286,1),(785,7529438,7529434,'ite',14.286,1),(785,7529439,7529434,'tet',14.286,1),(785,7529440,7529434,'eth',14.286,1),(785,7529441,7529434,'thr',14.286,1),(785,7529442,7529434,'hru',14.286,1),(785,7529443,7529436,'ope',11.111,2),(785,7529444,7529436,'per',11.111,2),(785,7529445,7529436,'era',11.111,2),(785,7529446,7529436,'rat',11.111,2),(785,7529447,7529436,'ati',11.111,2),(785,7529448,7529436,'tio',11.111,2),(785,7529449,7529436,'ion',11.111,2),(785,7529450,7529436,'ona',11.111,2),(785,7529451,7529436,'nal',11.111,2),(785,7529452,7529443,'mes',20,1),(785,7529453,7529443,'ess',20,1),(785,7529454,7529443,'ssa',20,1),(785,7529455,7529443,'sag',20,1),(785,7529456,7529443,'age',20,1),(785,7529457,7529452,'per',11.111,1),(785,7529458,7529452,'erf',11.111,1),(785,7529459,7529452,'rfo',11.111,1),(785,7529460,7529452,'for',11.111,1),(785,7529461,7529452,'orm',11.111,1),(785,7529462,7529452,'rma',11.111,1),(785,7529463,7529452,'man',11.111,1),(785,7529464,7529452,'anc',11.111,1),(785,7529465,7529452,'nce',11.111,1),(785,7529466,7529457,'ide',12.5,1),(785,7529467,7529457,'den',12.5,1),(785,7529468,7529457,'ent',12.5,1),(785,7529469,7529457,'nti',12.5,1),(785,7529470,7529457,'tif',12.5,1),(785,7529471,7529457,'ifi',12.5,1),(785,7529472,7529457,'fie',12.5,1),(785,7529473,7529457,'ier',12.5,1),(785,7529474,7529466,'vdi',33.333,3),(785,7529475,7529466,'dis',33.333,3),(785,7529476,7529466,'isk',33.333,3),(785,7529477,7529474,'nam',50,1),(785,7529478,7529474,'ame',50,1),(785,7529479,7529477,'typ',50,1),(785,7529480,7529477,'ype',50,1),(785,7529481,7529479,'dir',25,1),(785,7529482,7529479,'ire',25,1),(785,7529483,7529479,'rec',25,1),(785,7529484,7529479,'ect',25,1),(786,7529486,7529485,'naa',100,2),(786,7529487,7529486,'600',3.333,3),(786,7529488,7529486,'000',3.333,3),(786,7529489,7529486,'00c',3.333,3),(786,7529490,7529486,'0c2',3.333,3),(786,7529491,7529486,'c29',3.333,3),(786,7529492,7529486,'290',3.333,3),(786,7529493,7529486,'905',3.333,3),(786,7529494,7529486,'053',3.333,3),(786,7529495,7529486,'538',3.333,3),(786,7529496,7529486,'383',3.333,3),(786,7529497,7529486,'83d',3.333,3),(786,7529498,7529486,'3da',3.333,3),(786,7529499,7529486,'daf',3.333,3),(786,7529500,7529486,'afa',3.333,3),(786,7529501,7529486,'fa9',3.333,3),(786,7529502,7529486,'a9a',3.333,3),(786,7529503,7529486,'9ac',3.333,3),(786,7529504,7529486,'aca',3.333,3),(786,7529505,7529486,'cac',3.333,3),(786,7529506,7529486,'aca',3.333,3),(786,7529507,7529486,'ca8',3.333,3),(786,7529508,7529486,'a8d',3.333,3),(786,7529509,7529486,'8da',3.333,3),(786,7529510,7529486,'da0',3.333,3),(786,7529511,7529486,'a0e',3.333,3),(786,7529512,7529486,'0ec',3.333,3),(786,7529513,7529486,'ecb',3.333,3),(786,7529514,7529486,'cbb',3.333,3),(786,7529515,7529486,'bb7',3.333,3),(786,7529516,7529486,'b70',3.333,3),(786,7529517,7529487,'mon',100,1),(786,7529518,7529517,'201',50,1),(786,7529519,7529517,'013',50,1),(786,7529520,7529518,'adm',33.333,4),(786,7529521,7529518,'dmi',33.333,4),(786,7529522,7529518,'min',33.333,4),(786,7529523,7529520,'cap',16.667,1),(786,7529524,7529520,'apa',16.667,1),(786,7529525,7529520,'pac',16.667,1),(786,7529526,7529520,'aci',16.667,1),(786,7529527,7529520,'cit',16.667,1),(786,7529528,7529520,'ity',16.667,1),(786,7529529,7529523,'pat',50,1),(786,7529530,7529523,'ath',50,1),(786,7529531,7529529,'one',100,1),(786,7529532,7529531,'fre',14.286,1),(786,7529533,7529531,'ree',14.286,1),(786,7529534,7529531,'ees',14.286,1),(786,7529535,7529531,'esp',14.286,1),(786,7529536,7529531,'spa',14.286,1),(786,7529537,7529531,'pac',14.286,1),(786,7529538,7529531,'ace',14.286,1),(786,7529539,7529532,'dis',50,1),(786,7529540,7529532,'isk',50,1),(786,7529541,7529539,'ind',33.333,1),(786,7529542,7529539,'nde',33.333,1),(786,7529543,7529539,'dex',33.333,1),(786,7529544,7529541,'adm',8.333,1),(786,7529545,7529541,'dmi',8.333,1),(786,7529546,7529541,'min',8.333,1),(786,7529547,7529541,'ini',8.333,1),(786,7529548,7529541,'nis',8.333,1),(786,7529549,7529541,'ist',8.333,1),(786,7529550,7529541,'str',8.333,1),(786,7529551,7529541,'tra',8.333,1),(786,7529552,7529541,'rat',8.333,1),(786,7529553,7529541,'ati',8.333,1),(786,7529554,7529541,'tio',8.333,1),(786,7529555,7529541,'ion',8.333,1),(786,7529556,7529544,'sta',33.333,3),(786,7529557,7529544,'tat',33.333,3),(786,7529558,7529544,'ate',33.333,3),(786,7529559,7529556,'dis',16.667,4),(786,7529560,7529556,'isa',16.667,4),(786,7529561,7529556,'sab',16.667,4),(786,7529562,7529556,'abl',16.667,4),(786,7529563,7529556,'ble',16.667,4),(786,7529564,7529556,'led',16.667,4),(786,7529565,7529559,'cac',33.333,1),(786,7529566,7529559,'ach',33.333,1),(786,7529567,7529559,'che',33.333,1),(786,7529568,7529565,'mod',50,1),(786,7529569,7529565,'ode',50,1),(786,7529570,7529568,'wri',14.286,1),(786,7529571,7529568,'rit',14.286,1),(786,7529572,7529568,'ite',14.286,1),(786,7529573,7529568,'tet',14.286,1),(786,7529574,7529568,'eth',14.286,1),(786,7529575,7529568,'thr',14.286,1),(786,7529576,7529568,'hru',14.286,1),(786,7529577,7529570,'ope',11.111,2),(786,7529578,7529570,'per',11.111,2),(786,7529579,7529570,'era',11.111,2),(786,7529580,7529570,'rat',11.111,2),(786,7529581,7529570,'ati',11.111,2),(786,7529582,7529570,'tio',11.111,2),(786,7529583,7529570,'ion',11.111,2),(786,7529584,7529570,'ona',11.111,2),(786,7529585,7529570,'nal',11.111,2),(786,7529586,7529577,'mes',20,1),(786,7529587,7529577,'ess',20,1),(786,7529588,7529577,'ssa',20,1),(786,7529589,7529577,'sag',20,1),(786,7529590,7529577,'age',20,1),(786,7529591,7529586,'per',11.111,1),(786,7529592,7529586,'erf',11.111,1),(786,7529593,7529586,'rfo',11.111,1),(786,7529594,7529586,'for',11.111,1),(786,7529595,7529586,'orm',11.111,1),(786,7529596,7529586,'rma',11.111,1),(786,7529597,7529586,'man',11.111,1),(786,7529598,7529586,'anc',11.111,1),(786,7529599,7529586,'nce',11.111,1),(786,7529600,7529591,'ide',12.5,1),(786,7529601,7529591,'den',12.5,1),(786,7529602,7529591,'ent',12.5,1),(786,7529603,7529591,'nti',12.5,1),(786,7529604,7529591,'tif',12.5,1),(786,7529605,7529591,'ifi',12.5,1),(786,7529606,7529591,'fie',12.5,1),(786,7529607,7529591,'ier',12.5,1),(786,7529608,7529600,'vdi',33.333,3),(786,7529609,7529600,'dis',33.333,3),(786,7529610,7529600,'isk',33.333,3),(786,7529611,7529608,'nam',50,1),(786,7529612,7529608,'ame',50,1),(786,7529613,7529611,'typ',50,1),(786,7529614,7529611,'ype',50,1),(786,7529615,7529613,'dir',25,1),(786,7529616,7529613,'ire',25,1),(786,7529617,7529613,'rec',25,1),(786,7529618,7529613,'ect',25,1),(787,7529620,7529619,'naa',100,2),(787,7529621,7529620,'600',3.333,3),(787,7529622,7529620,'000',3.333,3),(787,7529623,7529620,'00c',3.333,3),(787,7529624,7529620,'0c2',3.333,3),(787,7529625,7529620,'c29',3.333,3),(787,7529626,7529620,'297',3.333,3),(787,7529627,7529620,'97e',3.333,3),(787,7529628,7529620,'7e6',3.333,3),(787,7529629,7529620,'e6b',3.333,3),(787,7529630,7529620,'6b0',3.333,3),(787,7529631,7529620,'b0b',3.333,3),(787,7529632,7529620,'0b6',3.333,3),(787,7529633,7529620,'b6d',3.333,3),(787,7529634,7529620,'6d4',3.333,3),(787,7529635,7529620,'d45',3.333,3),(787,7529636,7529620,'452',3.333,3),(787,7529637,7529620,'523',3.333,3),(787,7529638,7529620,'23a',3.333,3),(787,7529639,7529620,'3a9',3.333,3),(787,7529640,7529620,'a96',3.333,3),(787,7529641,7529620,'96c',3.333,3),(787,7529642,7529620,'6c6',3.333,3),(787,7529643,7529620,'c6a',3.333,3),(787,7529644,7529620,'6a6',3.333,3),(787,7529645,7529620,'a6f',3.333,3),(787,7529646,7529620,'6fa',3.333,3),(787,7529647,7529620,'fad',3.333,3),(787,7529648,7529620,'ad4',3.333,3),(787,7529649,7529620,'d4e',3.333,3),(787,7529650,7529620,'4eb',3.333,3),(787,7529651,7529621,'mon',100,1),(787,7529652,7529651,'201',50,1),(787,7529653,7529651,'013',50,1),(787,7529654,7529652,'adm',33.333,4),(787,7529655,7529652,'dmi',33.333,4),(787,7529656,7529652,'min',33.333,4),(787,7529657,7529654,'cap',16.667,1),(787,7529658,7529654,'apa',16.667,1),(787,7529659,7529654,'pac',16.667,1),(787,7529660,7529654,'aci',16.667,1),(787,7529661,7529654,'cit',16.667,1),(787,7529662,7529654,'ity',16.667,1),(787,7529663,7529657,'pat',50,1),(787,7529664,7529657,'ath',50,1),(787,7529665,7529663,'thr',33.333,1),(787,7529666,7529663,'hre',33.333,1),(787,7529667,7529663,'ree',33.333,1),(787,7529668,7529665,'fre',14.286,1),(787,7529669,7529665,'ree',14.286,1),(787,7529670,7529665,'ees',14.286,1),(787,7529671,7529665,'esp',14.286,1),(787,7529672,7529665,'spa',14.286,1),(787,7529673,7529665,'pac',14.286,1),(787,7529674,7529665,'ace',14.286,1),(787,7529675,7529668,'dis',50,1),(787,7529676,7529668,'isk',50,1),(787,7529677,7529675,'ind',33.333,1),(787,7529678,7529675,'nde',33.333,1),(787,7529679,7529675,'dex',33.333,1),(787,7529680,7529677,'adm',8.333,1),(787,7529681,7529677,'dmi',8.333,1),(787,7529682,7529677,'min',8.333,1),(787,7529683,7529677,'ini',8.333,1),(787,7529684,7529677,'nis',8.333,1),(787,7529685,7529677,'ist',8.333,1),(787,7529686,7529677,'str',8.333,1),(787,7529687,7529677,'tra',8.333,1),(787,7529688,7529677,'rat',8.333,1),(787,7529689,7529677,'ati',8.333,1),(787,7529690,7529677,'tio',8.333,1),(787,7529691,7529677,'ion',8.333,1),(787,7529692,7529680,'sta',33.333,3),(787,7529693,7529680,'tat',33.333,3),(787,7529694,7529680,'ate',33.333,3),(787,7529695,7529692,'dis',16.667,4),(787,7529696,7529692,'isa',16.667,4),(787,7529697,7529692,'sab',16.667,4),(787,7529698,7529692,'abl',16.667,4),(787,7529699,7529692,'ble',16.667,4),(787,7529700,7529692,'led',16.667,4),(787,7529701,7529695,'cac',33.333,1),(787,7529702,7529695,'ach',33.333,1),(787,7529703,7529695,'che',33.333,1),(787,7529704,7529701,'mod',50,1),(787,7529705,7529701,'ode',50,1),(787,7529706,7529704,'wri',14.286,1),(787,7529707,7529704,'rit',14.286,1),(787,7529708,7529704,'ite',14.286,1),(787,7529709,7529704,'tet',14.286,1),(787,7529710,7529704,'eth',14.286,1),(787,7529711,7529704,'thr',14.286,1),(787,7529712,7529704,'hru',14.286,1),(787,7529713,7529706,'ope',11.111,2),(787,7529714,7529706,'per',11.111,2),(787,7529715,7529706,'era',11.111,2),(787,7529716,7529706,'rat',11.111,2),(787,7529717,7529706,'ati',11.111,2),(787,7529718,7529706,'tio',11.111,2),(787,7529719,7529706,'ion',11.111,2),(787,7529720,7529706,'ona',11.111,2),(787,7529721,7529706,'nal',11.111,2),(787,7529722,7529713,'mes',20,1),(787,7529723,7529713,'ess',20,1),(787,7529724,7529713,'ssa',20,1),(787,7529725,7529713,'sag',20,1),(787,7529726,7529713,'age',20,1),(787,7529727,7529722,'per',11.111,1),(787,7529728,7529722,'erf',11.111,1),(787,7529729,7529722,'rfo',11.111,1),(787,7529730,7529722,'for',11.111,1),(787,7529731,7529722,'orm',11.111,1),(787,7529732,7529722,'rma',11.111,1),(787,7529733,7529722,'man',11.111,1),(787,7529734,7529722,'anc',11.111,1),(787,7529735,7529722,'nce',11.111,1),(787,7529736,7529727,'ide',12.5,1),(787,7529737,7529727,'den',12.5,1),(787,7529738,7529727,'ent',12.5,1),(787,7529739,7529727,'nti',12.5,1),(787,7529740,7529727,'tif',12.5,1),(787,7529741,7529727,'ifi',12.5,1),(787,7529742,7529727,'fie',12.5,1),(787,7529743,7529727,'ier',12.5,1),(787,7529744,7529736,'vdi',33.333,3),(787,7529745,7529736,'dis',33.333,3),(787,7529746,7529736,'isk',33.333,3),(787,7529747,7529744,'nam',50,1),(787,7529748,7529744,'ame',50,1),(787,7529749,7529747,'typ',50,1),(787,7529750,7529747,'ype',50,1),(787,7529751,7529749,'dir',25,1),(787,7529752,7529749,'ire',25,1),(787,7529753,7529749,'rec',25,1),(787,7529754,7529749,'ect',25,1),(788,7529756,7529755,'naa',100,2),(788,7529757,7529756,'600',3.333,3),(788,7529758,7529756,'000',3.333,3),(788,7529759,7529756,'00c',3.333,3),(788,7529760,7529756,'0c2',3.333,3),(788,7529761,7529756,'c29',3.333,3),(788,7529762,7529756,'29b',3.333,3),(788,7529763,7529756,'9ba',3.333,3),(788,7529764,7529756,'ba5',3.333,3),(788,7529765,7529756,'a58',3.333,3),(788,7529766,7529756,'588',3.333,3),(788,7529767,7529756,'88c',3.333,3),(788,7529768,7529756,'8cd',3.333,3),(788,7529769,7529756,'cd4',3.333,3),(788,7529770,7529756,'d4f',3.333,3),(788,7529771,7529756,'4fa',3.333,3),(788,7529772,7529756,'fab',3.333,3),(788,7529773,7529756,'abe',3.333,3),(788,7529774,7529756,'be2',3.333,3),(788,7529775,7529756,'e26',3.333,3),(788,7529776,7529756,'268',3.333,3),(788,7529777,7529756,'68e',3.333,3),(788,7529778,7529756,'8e7',3.333,3),(788,7529779,7529756,'e7d',3.333,3),(788,7529780,7529756,'7d0',3.333,3),(788,7529781,7529756,'d0d',3.333,3),(788,7529782,7529756,'0de',3.333,3),(788,7529783,7529756,'de1',3.333,3),(788,7529784,7529756,'e15',3.333,3),(788,7529785,7529756,'151',3.333,3),(788,7529786,7529756,'517',3.333,3),(788,7529787,7529757,'mon',100,1),(788,7529788,7529787,'201',50,1),(788,7529789,7529787,'013',50,1),(788,7529790,7529788,'adm',33.333,4),(788,7529791,7529788,'dmi',33.333,4),(788,7529792,7529788,'min',33.333,4),(788,7529793,7529790,'cap',16.667,1),(788,7529794,7529790,'apa',16.667,1),(788,7529795,7529790,'pac',16.667,1),(788,7529796,7529790,'aci',16.667,1),(788,7529797,7529790,'cit',16.667,1),(788,7529798,7529790,'ity',16.667,1),(788,7529799,7529793,'pat',50,1),(788,7529800,7529793,'ath',50,1),(788,7529801,7529799,'fou',50,1),(788,7529802,7529799,'our',50,1),(788,7529803,7529801,'fre',14.286,1),(788,7529804,7529801,'ree',14.286,1),(788,7529805,7529801,'ees',14.286,1),(788,7529806,7529801,'esp',14.286,1),(788,7529807,7529801,'spa',14.286,1),(788,7529808,7529801,'pac',14.286,1),(788,7529809,7529801,'ace',14.286,1),(788,7529810,7529803,'dis',50,1),(788,7529811,7529803,'isk',50,1),(788,7529812,7529810,'ind',33.333,1),(788,7529813,7529810,'nde',33.333,1),(788,7529814,7529810,'dex',33.333,1),(788,7529815,7529812,'adm',8.333,1),(788,7529816,7529812,'dmi',8.333,1),(788,7529817,7529812,'min',8.333,1),(788,7529818,7529812,'ini',8.333,1),(788,7529819,7529812,'nis',8.333,1),(788,7529820,7529812,'ist',8.333,1),(788,7529821,7529812,'str',8.333,1),(788,7529822,7529812,'tra',8.333,1),(788,7529823,7529812,'rat',8.333,1),(788,7529824,7529812,'ati',8.333,1),(788,7529825,7529812,'tio',8.333,1),(788,7529826,7529812,'ion',8.333,1),(788,7529827,7529815,'sta',33.333,3),(788,7529828,7529815,'tat',33.333,3),(788,7529829,7529815,'ate',33.333,3),(788,7529830,7529827,'dis',16.667,4),(788,7529831,7529827,'isa',16.667,4),(788,7529832,7529827,'sab',16.667,4),(788,7529833,7529827,'abl',16.667,4),(788,7529834,7529827,'ble',16.667,4),(788,7529835,7529827,'led',16.667,4),(788,7529836,7529830,'cac',33.333,1),(788,7529837,7529830,'ach',33.333,1),(788,7529838,7529830,'che',33.333,1),(788,7529839,7529836,'mod',50,1),(788,7529840,7529836,'ode',50,1),(788,7529841,7529839,'wri',14.286,1),(788,7529842,7529839,'rit',14.286,1),(788,7529843,7529839,'ite',14.286,1),(788,7529844,7529839,'tet',14.286,1),(788,7529845,7529839,'eth',14.286,1),(788,7529846,7529839,'thr',14.286,1),(788,7529847,7529839,'hru',14.286,1),(788,7529848,7529841,'ope',11.111,2),(788,7529849,7529841,'per',11.111,2),(788,7529850,7529841,'era',11.111,2),(788,7529851,7529841,'rat',11.111,2),(788,7529852,7529841,'ati',11.111,2),(788,7529853,7529841,'tio',11.111,2),(788,7529854,7529841,'ion',11.111,2),(788,7529855,7529841,'ona',11.111,2),(788,7529856,7529841,'nal',11.111,2),(788,7529857,7529848,'mes',20,1),(788,7529858,7529848,'ess',20,1),(788,7529859,7529848,'ssa',20,1),(788,7529860,7529848,'sag',20,1),(788,7529861,7529848,'age',20,1),(788,7529862,7529857,'per',11.111,1),(788,7529863,7529857,'erf',11.111,1),(788,7529864,7529857,'rfo',11.111,1),(788,7529865,7529857,'for',11.111,1),(788,7529866,7529857,'orm',11.111,1),(788,7529867,7529857,'rma',11.111,1),(788,7529868,7529857,'man',11.111,1),(788,7529869,7529857,'anc',11.111,1),(788,7529870,7529857,'nce',11.111,1),(788,7529871,7529862,'ide',12.5,1),(788,7529872,7529862,'den',12.5,1),(788,7529873,7529862,'ent',12.5,1),(788,7529874,7529862,'nti',12.5,1),(788,7529875,7529862,'tif',12.5,1),(788,7529876,7529862,'ifi',12.5,1),(788,7529877,7529862,'fie',12.5,1),(788,7529878,7529862,'ier',12.5,1),(788,7529879,7529871,'vdi',33.333,3),(788,7529880,7529871,'dis',33.333,3),(788,7529881,7529871,'isk',33.333,3),(788,7529882,7529879,'nam',50,1),(788,7529883,7529879,'ame',50,1),(788,7529884,7529882,'typ',50,1),(788,7529885,7529882,'ype',50,1),(788,7529886,7529884,'dir',25,1),(788,7529887,7529884,'ire',25,1),(788,7529888,7529884,'rec',25,1),(788,7529889,7529884,'ect',25,1),(789,7529891,7529890,'naa',100,2),(789,7529892,7529891,'600',3.333,3),(789,7529893,7529891,'000',3.333,3),(789,7529894,7529891,'00c',3.333,3),(789,7529895,7529891,'0c2',3.333,3),(789,7529896,7529891,'c29',3.333,3),(789,7529897,7529891,'296',3.333,3),(789,7529898,7529891,'96d',3.333,3),(789,7529899,7529891,'6d4',3.333,3),(789,7529900,7529891,'d44',3.333,3),(789,7529901,7529891,'440',3.333,3),(789,7529902,7529891,'404',3.333,3),(789,7529903,7529891,'040',3.333,3),(789,7529904,7529891,'40c',3.333,3),(789,7529905,7529891,'0c4',3.333,3),(789,7529906,7529891,'c46',3.333,3),(789,7529907,7529891,'46a',3.333,3),(789,7529908,7529891,'6a2',3.333,3),(789,7529909,7529891,'a27',3.333,3),(789,7529910,7529891,'278',3.333,3),(789,7529911,7529891,'78d',3.333,3),(789,7529912,7529891,'8df',3.333,3),(789,7529913,7529891,'df1',3.333,3),(789,7529914,7529891,'f1e',3.333,3),(789,7529915,7529891,'1e0',3.333,3),(789,7529916,7529891,'e0d',3.333,3),(789,7529917,7529891,'0df',3.333,3),(789,7529918,7529891,'df2',3.333,3),(789,7529919,7529891,'f21',3.333,3),(789,7529920,7529891,'211',3.333,3),(789,7529921,7529891,'11b',3.333,3),(789,7529922,7529892,'mon',100,1),(789,7529923,7529922,'201',50,1),(789,7529924,7529922,'013',50,1),(789,7529925,7529923,'adm',33.333,4),(789,7529926,7529923,'dmi',33.333,4),(789,7529927,7529923,'min',33.333,4),(789,7529928,7529925,'cap',16.667,1),(789,7529929,7529925,'apa',16.667,1),(789,7529930,7529925,'pac',16.667,1),(789,7529931,7529925,'aci',16.667,1),(789,7529932,7529925,'cit',16.667,1),(789,7529933,7529925,'ity',16.667,1),(789,7529934,7529928,'pat',50,1),(789,7529935,7529928,'ath',50,1),(789,7529936,7529934,'fiv',50,1),(789,7529937,7529934,'ive',50,1),(789,7529938,7529936,'fre',14.286,1),(789,7529939,7529936,'ree',14.286,1),(789,7529940,7529936,'ees',14.286,1),(789,7529941,7529936,'esp',14.286,1),(789,7529942,7529936,'spa',14.286,1),(789,7529943,7529936,'pac',14.286,1),(789,7529944,7529936,'ace',14.286,1),(789,7529945,7529938,'dis',50,1),(789,7529946,7529938,'isk',50,1),(789,7529947,7529945,'ind',33.333,1),(789,7529948,7529945,'nde',33.333,1),(789,7529949,7529945,'dex',33.333,1),(789,7529950,7529947,'adm',8.333,1),(789,7529951,7529947,'dmi',8.333,1),(789,7529952,7529947,'min',8.333,1),(789,7529953,7529947,'ini',8.333,1),(789,7529954,7529947,'nis',8.333,1),(789,7529955,7529947,'ist',8.333,1),(789,7529956,7529947,'str',8.333,1),(789,7529957,7529947,'tra',8.333,1),(789,7529958,7529947,'rat',8.333,1),(789,7529959,7529947,'ati',8.333,1),(789,7529960,7529947,'tio',8.333,1),(789,7529961,7529947,'ion',8.333,1),(789,7529962,7529950,'sta',33.333,3),(789,7529963,7529950,'tat',33.333,3),(789,7529964,7529950,'ate',33.333,3),(789,7529965,7529962,'dis',16.667,4),(789,7529966,7529962,'isa',16.667,4),(789,7529967,7529962,'sab',16.667,4),(789,7529968,7529962,'abl',16.667,4),(789,7529969,7529962,'ble',16.667,4),(789,7529970,7529962,'led',16.667,4),(789,7529971,7529965,'cac',33.333,1),(789,7529972,7529965,'ach',33.333,1),(789,7529973,7529965,'che',33.333,1),(789,7529974,7529971,'mod',50,1),(789,7529975,7529971,'ode',50,1),(789,7529976,7529974,'wri',14.286,1),(789,7529977,7529974,'rit',14.286,1),(789,7529978,7529974,'ite',14.286,1),(789,7529979,7529974,'tet',14.286,1),(789,7529980,7529974,'eth',14.286,1),(789,7529981,7529974,'thr',14.286,1),(789,7529982,7529974,'hru',14.286,1),(789,7529983,7529976,'ope',11.111,2),(789,7529984,7529976,'per',11.111,2),(789,7529985,7529976,'era',11.111,2),(789,7529986,7529976,'rat',11.111,2),(789,7529987,7529976,'ati',11.111,2),(789,7529988,7529976,'tio',11.111,2),(789,7529989,7529976,'ion',11.111,2),(789,7529990,7529976,'ona',11.111,2),(789,7529991,7529976,'nal',11.111,2),(789,7529992,7529983,'mes',20,1),(789,7529993,7529983,'ess',20,1),(789,7529994,7529983,'ssa',20,1),(789,7529995,7529983,'sag',20,1),(789,7529996,7529983,'age',20,1),(789,7529997,7529992,'per',11.111,1),(789,7529998,7529992,'erf',11.111,1),(789,7529999,7529992,'rfo',11.111,1),(789,7530000,7529992,'for',11.111,1),(789,7530001,7529992,'orm',11.111,1),(789,7530002,7529992,'rma',11.111,1),(789,7530003,7529992,'man',11.111,1),(789,7530004,7529992,'anc',11.111,1),(789,7530005,7529992,'nce',11.111,1),(789,7530006,7529997,'ide',12.5,1),(789,7530007,7529997,'den',12.5,1),(789,7530008,7529997,'ent',12.5,1),(789,7530009,7529997,'nti',12.5,1),(789,7530010,7529997,'tif',12.5,1),(789,7530011,7529997,'ifi',12.5,1),(789,7530012,7529997,'fie',12.5,1),(789,7530013,7529997,'ier',12.5,1),(789,7530014,7530006,'vdi',33.333,3),(789,7530015,7530006,'dis',33.333,3),(789,7530016,7530006,'isk',33.333,3),(789,7530017,7530014,'nam',50,1),(789,7530018,7530014,'ame',50,1),(789,7530019,7530017,'typ',50,1),(789,7530020,7530017,'ype',50,1),(789,7530021,7530019,'dir',25,1),(789,7530022,7530019,'ire',25,1),(789,7530023,7530019,'rec',25,1),(789,7530024,7530019,'ect',25,1),(790,7530026,7530025,'naa',100,2),(790,7530027,7530026,'600',3.333,3),(790,7530028,7530026,'000',3.333,3),(790,7530029,7530026,'00c',3.333,3),(790,7530030,7530026,'0c2',3.333,3),(790,7530031,7530026,'c29',3.333,3),(790,7530032,7530026,'29d',3.333,3),(790,7530033,7530026,'9db',3.333,3),(790,7530034,7530026,'db6',3.333,3),(790,7530035,7530026,'b6a',3.333,3),(790,7530036,7530026,'6af',3.333,3),(790,7530037,7530026,'afd',3.333,3),(790,7530038,7530026,'fd9',3.333,3),(790,7530039,7530026,'d90',3.333,3),(790,7530040,7530026,'903',3.333,3),(790,7530041,7530026,'03d',3.333,3),(790,7530042,7530026,'3d9',3.333,3),(790,7530043,7530026,'d90',3.333,3),(790,7530044,7530026,'907',3.333,3),(790,7530045,7530026,'07c',3.333,3),(790,7530046,7530026,'7cb',3.333,3),(790,7530047,7530026,'cbf',3.333,3),(790,7530048,7530026,'bf7',3.333,3),(790,7530049,7530026,'f7b',3.333,3),(790,7530050,7530026,'7bc',3.333,3),(790,7530051,7530026,'bce',3.333,3),(790,7530052,7530026,'cec',3.333,3),(790,7530053,7530026,'ec9',3.333,3),(790,7530054,7530026,'c91',3.333,3),(790,7530055,7530026,'91e',3.333,3),(790,7530056,7530026,'1e0',3.333,3),(790,7530057,7530027,'mon',100,1),(790,7530058,7530057,'201',50,1),(790,7530059,7530057,'013',50,1),(790,7530060,7530058,'adm',33.333,4),(790,7530061,7530058,'dmi',33.333,4),(790,7530062,7530058,'min',33.333,4),(790,7530063,7530060,'cap',16.667,1),(790,7530064,7530060,'apa',16.667,1),(790,7530065,7530060,'pac',16.667,1),(790,7530066,7530060,'aci',16.667,1),(790,7530067,7530060,'cit',16.667,1),(790,7530068,7530060,'ity',16.667,1),(790,7530069,7530063,'pat',50,1),(790,7530070,7530063,'ath',50,1),(790,7530071,7530069,'six',100,1),(790,7530072,7530071,'fre',14.286,1),(790,7530073,7530071,'ree',14.286,1),(790,7530074,7530071,'ees',14.286,1),(790,7530075,7530071,'esp',14.286,1),(790,7530076,7530071,'spa',14.286,1),(790,7530077,7530071,'pac',14.286,1),(790,7530078,7530071,'ace',14.286,1),(790,7530079,7530072,'dis',50,1),(790,7530080,7530072,'isk',50,1),(790,7530081,7530079,'ind',33.333,1),(790,7530082,7530079,'nde',33.333,1),(790,7530083,7530079,'dex',33.333,1),(790,7530084,7530081,'adm',8.333,1),(790,7530085,7530081,'dmi',8.333,1),(790,7530086,7530081,'min',8.333,1),(790,7530087,7530081,'ini',8.333,1),(790,7530088,7530081,'nis',8.333,1),(790,7530089,7530081,'ist',8.333,1),(790,7530090,7530081,'str',8.333,1),(790,7530091,7530081,'tra',8.333,1),(790,7530092,7530081,'rat',8.333,1),(790,7530093,7530081,'ati',8.333,1),(790,7530094,7530081,'tio',8.333,1),(790,7530095,7530081,'ion',8.333,1),(790,7530096,7530084,'sta',33.333,3),(790,7530097,7530084,'tat',33.333,3),(790,7530098,7530084,'ate',33.333,3),(790,7530099,7530096,'dis',16.667,4),(790,7530100,7530096,'isa',16.667,4),(790,7530101,7530096,'sab',16.667,4),(790,7530102,7530096,'abl',16.667,4),(790,7530103,7530096,'ble',16.667,4),(790,7530104,7530096,'led',16.667,4),(790,7530105,7530099,'cac',33.333,1),(790,7530106,7530099,'ach',33.333,1),(790,7530107,7530099,'che',33.333,1),(790,7530108,7530105,'mod',50,1),(790,7530109,7530105,'ode',50,1),(790,7530110,7530108,'wri',14.286,1),(790,7530111,7530108,'rit',14.286,1),(790,7530112,7530108,'ite',14.286,1),(790,7530113,7530108,'tet',14.286,1),(790,7530114,7530108,'eth',14.286,1),(790,7530115,7530108,'thr',14.286,1),(790,7530116,7530108,'hru',14.286,1),(790,7530117,7530110,'ope',11.111,2),(790,7530118,7530110,'per',11.111,2),(790,7530119,7530110,'era',11.111,2),(790,7530120,7530110,'rat',11.111,2),(790,7530121,7530110,'ati',11.111,2),(790,7530122,7530110,'tio',11.111,2),(790,7530123,7530110,'ion',11.111,2),(790,7530124,7530110,'ona',11.111,2),(790,7530125,7530110,'nal',11.111,2),(790,7530126,7530117,'mes',20,1),(790,7530127,7530117,'ess',20,1),(790,7530128,7530117,'ssa',20,1),(790,7530129,7530117,'sag',20,1),(790,7530130,7530117,'age',20,1),(790,7530131,7530126,'per',11.111,1),(790,7530132,7530126,'erf',11.111,1),(790,7530133,7530126,'rfo',11.111,1),(790,7530134,7530126,'for',11.111,1),(790,7530135,7530126,'orm',11.111,1),(790,7530136,7530126,'rma',11.111,1),(790,7530137,7530126,'man',11.111,1),(790,7530138,7530126,'anc',11.111,1),(790,7530139,7530126,'nce',11.111,1),(790,7530140,7530131,'ide',12.5,1),(790,7530141,7530131,'den',12.5,1),(790,7530142,7530131,'ent',12.5,1),(790,7530143,7530131,'nti',12.5,1),(790,7530144,7530131,'tif',12.5,1),(790,7530145,7530131,'ifi',12.5,1),(790,7530146,7530131,'fie',12.5,1),(790,7530147,7530131,'ier',12.5,1),(790,7530148,7530140,'vdi',33.333,3),(790,7530149,7530140,'dis',33.333,3),(790,7530150,7530140,'isk',33.333,3),(790,7530151,7530148,'nam',50,1),(790,7530152,7530148,'ame',50,1),(790,7530153,7530151,'typ',50,1),(790,7530154,7530151,'ype',50,1),(790,7530155,7530153,'dir',25,1),(790,7530156,7530153,'ire',25,1),(790,7530157,7530153,'rec',25,1),(790,7530158,7530153,'ect',25,1),(791,7530160,7530159,'naa',100,2),(791,7530161,7530160,'600',3.333,3),(791,7530162,7530160,'000',3.333,3),(791,7530163,7530160,'00c',3.333,3),(791,7530164,7530160,'0c2',3.333,3),(791,7530165,7530160,'c29',3.333,3),(791,7530166,7530160,'29a',3.333,3),(791,7530167,7530160,'9ae',3.333,3),(791,7530168,7530160,'aee',3.333,3),(791,7530169,7530160,'eef',3.333,3),(791,7530170,7530160,'ef7',3.333,3),(791,7530171,7530160,'f71',3.333,3),(791,7530172,7530160,'712',3.333,3),(791,7530173,7530160,'125',3.333,3),(791,7530174,7530160,'25d',3.333,3),(791,7530175,7530160,'5d5',3.333,3),(791,7530176,7530160,'d58',3.333,3),(791,7530177,7530160,'583',3.333,3),(791,7530178,7530160,'830',3.333,3),(791,7530179,7530160,'301',3.333,3),(791,7530180,7530160,'019',3.333,3),(791,7530181,7530160,'19e',3.333,3),(791,7530182,7530160,'9ef',3.333,3),(791,7530183,7530160,'ef0',3.333,3),(791,7530184,7530160,'f0e',3.333,3),(791,7530185,7530160,'0ea',3.333,3),(791,7530186,7530160,'ea0',3.333,3),(791,7530187,7530160,'a0e',3.333,3),(791,7530188,7530160,'0e5',3.333,3),(791,7530189,7530160,'e5a',3.333,3),(791,7530190,7530160,'5a6',3.333,3),(791,7530191,7530161,'mon',100,1),(791,7530192,7530191,'201',50,1),(791,7530193,7530191,'013',50,1),(791,7530194,7530192,'adm',33.333,4),(791,7530195,7530192,'dmi',33.333,4),(791,7530196,7530192,'min',33.333,4),(791,7530197,7530194,'cap',16.667,1),(791,7530198,7530194,'apa',16.667,1),(791,7530199,7530194,'pac',16.667,1),(791,7530200,7530194,'aci',16.667,1),(791,7530201,7530194,'cit',16.667,1),(791,7530202,7530194,'ity',16.667,1),(791,7530203,7530197,'pat',50,1),(791,7530204,7530197,'ath',50,1),(791,7530205,7530203,'sev',33.333,1),(791,7530206,7530203,'eve',33.333,1),(791,7530207,7530203,'ven',33.333,1),(791,7530208,7530205,'fre',14.286,1),(791,7530209,7530205,'ree',14.286,1),(791,7530210,7530205,'ees',14.286,1),(791,7530211,7530205,'esp',14.286,1),(791,7530212,7530205,'spa',14.286,1),(791,7530213,7530205,'pac',14.286,1),(791,7530214,7530205,'ace',14.286,1),(791,7530215,7530208,'dis',50,1),(791,7530216,7530208,'isk',50,1),(791,7530217,7530215,'ind',33.333,1),(791,7530218,7530215,'nde',33.333,1),(791,7530219,7530215,'dex',33.333,1),(791,7530220,7530217,'adm',8.333,1),(791,7530221,7530217,'dmi',8.333,1),(791,7530222,7530217,'min',8.333,1),(791,7530223,7530217,'ini',8.333,1),(791,7530224,7530217,'nis',8.333,1),(791,7530225,7530217,'ist',8.333,1),(791,7530226,7530217,'str',8.333,1),(791,7530227,7530217,'tra',8.333,1),(791,7530228,7530217,'rat',8.333,1),(791,7530229,7530217,'ati',8.333,1),(791,7530230,7530217,'tio',8.333,1),(791,7530231,7530217,'ion',8.333,1),(791,7530232,7530220,'sta',33.333,3),(791,7530233,7530220,'tat',33.333,3),(791,7530234,7530220,'ate',33.333,3),(791,7530235,7530232,'dis',16.667,4),(791,7530236,7530232,'isa',16.667,4),(791,7530237,7530232,'sab',16.667,4),(791,7530238,7530232,'abl',16.667,4),(791,7530239,7530232,'ble',16.667,4),(791,7530240,7530232,'led',16.667,4),(791,7530241,7530235,'cac',33.333,1),(791,7530242,7530235,'ach',33.333,1),(791,7530243,7530235,'che',33.333,1),(791,7530244,7530241,'mod',50,1),(791,7530245,7530241,'ode',50,1),(791,7530246,7530244,'wri',14.286,1),(791,7530247,7530244,'rit',14.286,1),(791,7530248,7530244,'ite',14.286,1),(791,7530249,7530244,'tet',14.286,1),(791,7530250,7530244,'eth',14.286,1),(791,7530251,7530244,'thr',14.286,1),(791,7530252,7530244,'hru',14.286,1),(791,7530253,7530246,'ope',11.111,2),(791,7530254,7530246,'per',11.111,2),(791,7530255,7530246,'era',11.111,2),(791,7530256,7530246,'rat',11.111,2),(791,7530257,7530246,'ati',11.111,2),(791,7530258,7530246,'tio',11.111,2),(791,7530259,7530246,'ion',11.111,2),(791,7530260,7530246,'ona',11.111,2),(791,7530261,7530246,'nal',11.111,2),(791,7530262,7530253,'mes',20,1),(791,7530263,7530253,'ess',20,1),(791,7530264,7530253,'ssa',20,1),(791,7530265,7530253,'sag',20,1),(791,7530266,7530253,'age',20,1),(791,7530267,7530262,'per',11.111,1),(791,7530268,7530262,'erf',11.111,1),(791,7530269,7530262,'rfo',11.111,1),(791,7530270,7530262,'for',11.111,1),(791,7530271,7530262,'orm',11.111,1),(791,7530272,7530262,'rma',11.111,1),(791,7530273,7530262,'man',11.111,1),(791,7530274,7530262,'anc',11.111,1),(791,7530275,7530262,'nce',11.111,1),(791,7530276,7530267,'ide',12.5,1),(791,7530277,7530267,'den',12.5,1),(791,7530278,7530267,'ent',12.5,1),(791,7530279,7530267,'nti',12.5,1),(791,7530280,7530267,'tif',12.5,1),(791,7530281,7530267,'ifi',12.5,1),(791,7530282,7530267,'fie',12.5,1),(791,7530283,7530267,'ier',12.5,1),(791,7530284,7530276,'vdi',33.333,3),(791,7530285,7530276,'dis',33.333,3),(791,7530286,7530276,'isk',33.333,3),(791,7530287,7530284,'nam',50,1),(791,7530288,7530284,'ame',50,1),(791,7530289,7530287,'typ',50,1),(791,7530290,7530287,'ype',50,1),(791,7530291,7530289,'dir',25,1),(791,7530292,7530289,'ire',25,1),(791,7530293,7530289,'rec',25,1),(791,7530294,7530289,'ect',25,1),(792,7530296,7530295,'naa',100,2),(792,7530297,7530296,'600',3.333,3),(792,7530298,7530296,'000',3.333,3),(792,7530299,7530296,'00c',3.333,3),(792,7530300,7530296,'0c2',3.333,3),(792,7530301,7530296,'c29',3.333,3),(792,7530302,7530296,'290',3.333,3),(792,7530303,7530296,'908',3.333,3),(792,7530304,7530296,'082',3.333,3),(792,7530305,7530296,'82b',3.333,3),(792,7530306,7530296,'2bb',3.333,3),(792,7530307,7530296,'bb3',3.333,3),(792,7530308,7530296,'b3d',3.333,3),(792,7530309,7530296,'3d9',3.333,3),(792,7530310,7530296,'d91',3.333,3),(792,7530311,7530296,'91f',3.333,3),(792,7530312,7530296,'1f4',3.333,3),(792,7530313,7530296,'f4c',3.333,3),(792,7530314,7530296,'4c3',3.333,3),(792,7530315,7530296,'c3e',3.333,3),(792,7530316,7530296,'3ef',3.333,3),(792,7530317,7530296,'eff',3.333,3),(792,7530318,7530296,'ff0',3.333,3),(792,7530319,7530296,'f0c',3.333,3),(792,7530320,7530296,'0c9',3.333,3),(792,7530321,7530296,'c99',3.333,3),(792,7530322,7530296,'99c',3.333,3),(792,7530323,7530296,'9c2',3.333,3),(792,7530324,7530296,'c27',3.333,3),(792,7530325,7530296,'275',3.333,3),(792,7530326,7530296,'756',3.333,3),(792,7530327,7530297,'mon',100,1),(792,7530328,7530327,'201',50,1),(792,7530329,7530327,'013',50,1),(792,7530330,7530328,'adm',33.333,4),(792,7530331,7530328,'dmi',33.333,4),(792,7530332,7530328,'min',33.333,4),(792,7530333,7530330,'cap',16.667,1),(792,7530334,7530330,'apa',16.667,1),(792,7530335,7530330,'pac',16.667,1),(792,7530336,7530330,'aci',16.667,1),(792,7530337,7530330,'cit',16.667,1),(792,7530338,7530330,'ity',16.667,1),(792,7530339,7530333,'pat',50,1),(792,7530340,7530333,'ath',50,1),(792,7530341,7530339,'eig',33.333,1),(792,7530342,7530339,'igh',33.333,1),(792,7530343,7530339,'ght',33.333,1),(792,7530344,7530341,'fre',14.286,1),(792,7530345,7530341,'ree',14.286,1),(792,7530346,7530341,'ees',14.286,1),(792,7530347,7530341,'esp',14.286,1),(792,7530348,7530341,'spa',14.286,1),(792,7530349,7530341,'pac',14.286,1),(792,7530350,7530341,'ace',14.286,1),(792,7530351,7530344,'dis',50,1),(792,7530352,7530344,'isk',50,1),(792,7530353,7530351,'ind',33.333,1),(792,7530354,7530351,'nde',33.333,1),(792,7530355,7530351,'dex',33.333,1),(792,7530356,7530353,'adm',8.333,1),(792,7530357,7530353,'dmi',8.333,1),(792,7530358,7530353,'min',8.333,1),(792,7530359,7530353,'ini',8.333,1),(792,7530360,7530353,'nis',8.333,1),(792,7530361,7530353,'ist',8.333,1),(792,7530362,7530353,'str',8.333,1),(792,7530363,7530353,'tra',8.333,1),(792,7530364,7530353,'rat',8.333,1),(792,7530365,7530353,'ati',8.333,1),(792,7530366,7530353,'tio',8.333,1),(792,7530367,7530353,'ion',8.333,1),(792,7530368,7530356,'sta',33.333,3),(792,7530369,7530356,'tat',33.333,3),(792,7530370,7530356,'ate',33.333,3),(792,7530371,7530368,'dis',16.667,4),(792,7530372,7530368,'isa',16.667,4),(792,7530373,7530368,'sab',16.667,4),(792,7530374,7530368,'abl',16.667,4),(792,7530375,7530368,'ble',16.667,4),(792,7530376,7530368,'led',16.667,4),(792,7530377,7530371,'cac',33.333,1),(792,7530378,7530371,'ach',33.333,1),(792,7530379,7530371,'che',33.333,1),(792,7530380,7530377,'mod',50,1),(792,7530381,7530377,'ode',50,1),(792,7530382,7530380,'wri',14.286,1),(792,7530383,7530380,'rit',14.286,1),(792,7530384,7530380,'ite',14.286,1),(792,7530385,7530380,'tet',14.286,1),(792,7530386,7530380,'eth',14.286,1),(792,7530387,7530380,'thr',14.286,1),(792,7530388,7530380,'hru',14.286,1),(792,7530389,7530382,'ope',11.111,2),(792,7530390,7530382,'per',11.111,2),(792,7530391,7530382,'era',11.111,2),(792,7530392,7530382,'rat',11.111,2),(792,7530393,7530382,'ati',11.111,2),(792,7530394,7530382,'tio',11.111,2),(792,7530395,7530382,'ion',11.111,2),(792,7530396,7530382,'ona',11.111,2),(792,7530397,7530382,'nal',11.111,2),(792,7530398,7530389,'mes',20,1),(792,7530399,7530389,'ess',20,1),(792,7530400,7530389,'ssa',20,1),(792,7530401,7530389,'sag',20,1),(792,7530402,7530389,'age',20,1),(792,7530403,7530398,'per',11.111,1),(792,7530404,7530398,'erf',11.111,1),(792,7530405,7530398,'rfo',11.111,1),(792,7530406,7530398,'for',11.111,1),(792,7530407,7530398,'orm',11.111,1),(792,7530408,7530398,'rma',11.111,1),(792,7530409,7530398,'man',11.111,1),(792,7530410,7530398,'anc',11.111,1),(792,7530411,7530398,'nce',11.111,1),(792,7530412,7530403,'ide',12.5,1),(792,7530413,7530403,'den',12.5,1),(792,7530414,7530403,'ent',12.5,1),(792,7530415,7530403,'nti',12.5,1),(792,7530416,7530403,'tif',12.5,1),(792,7530417,7530403,'ifi',12.5,1),(792,7530418,7530403,'fie',12.5,1),(792,7530419,7530403,'ier',12.5,1),(792,7530420,7530412,'vdi',33.333,3),(792,7530421,7530412,'dis',33.333,3),(792,7530422,7530412,'isk',33.333,3),(792,7530423,7530420,'nam',50,1),(792,7530424,7530420,'ame',50,1),(792,7530425,7530423,'typ',50,1),(792,7530426,7530423,'ype',50,1),(792,7530427,7530425,'dir',25,1),(792,7530428,7530425,'ire',25,1),(792,7530429,7530425,'rec',25,1),(792,7530430,7530425,'ect',25,1),(793,7530432,7530431,'naa',100,2),(793,7530433,7530432,'600',3.333,3),(793,7530434,7530432,'000',3.333,3),(793,7530435,7530432,'00c',3.333,3),(793,7530436,7530432,'0c2',3.333,3),(793,7530437,7530432,'c29',3.333,3),(793,7530438,7530432,'294',3.333,3),(793,7530439,7530432,'94b',3.333,3),(793,7530440,7530432,'4b9',3.333,3),(793,7530441,7530432,'b96',3.333,3),(793,7530442,7530432,'96e',3.333,3),(793,7530443,7530432,'6e5',3.333,3),(793,7530444,7530432,'e5c',3.333,3),(793,7530445,7530432,'5cd',3.333,3),(793,7530446,7530432,'cdb',3.333,3),(793,7530447,7530432,'dbb',3.333,3),(793,7530448,7530432,'bbe',3.333,3),(793,7530449,7530432,'be6',3.333,3),(793,7530450,7530432,'e6a',3.333,3),(793,7530451,7530432,'6ab',3.333,3),(793,7530452,7530432,'ab1',3.333,3),(793,7530453,7530432,'b14',3.333,3),(793,7530454,7530432,'140',3.333,3),(793,7530455,7530432,'409',3.333,3),(793,7530456,7530432,'09c',3.333,3),(793,7530457,7530432,'9c1',3.333,3),(793,7530458,7530432,'c17',3.333,3),(793,7530459,7530432,'17c',3.333,3),(793,7530460,7530432,'7cd',3.333,3),(793,7530461,7530432,'cd2',3.333,3),(793,7530462,7530432,'d29',3.333,3),(793,7530463,7530433,'mon',100,1),(793,7530464,7530463,'201',50,1),(793,7530465,7530463,'013',50,1),(793,7530466,7530464,'adm',33.333,4),(793,7530467,7530464,'dmi',33.333,4),(793,7530468,7530464,'min',33.333,4),(793,7530469,7530466,'cap',16.667,1),(793,7530470,7530466,'apa',16.667,1),(793,7530471,7530466,'pac',16.667,1),(793,7530472,7530466,'aci',16.667,1),(793,7530473,7530466,'cit',16.667,1),(793,7530474,7530466,'ity',16.667,1),(793,7530475,7530469,'pat',50,1),(793,7530476,7530469,'ath',50,1),(793,7530477,7530475,'nin',50,1),(793,7530478,7530475,'ine',50,1),(793,7530479,7530477,'fre',14.286,1),(793,7530480,7530477,'ree',14.286,1),(793,7530481,7530477,'ees',14.286,1),(793,7530482,7530477,'esp',14.286,1),(793,7530483,7530477,'spa',14.286,1),(793,7530484,7530477,'pac',14.286,1),(793,7530485,7530477,'ace',14.286,1),(793,7530486,7530479,'dis',50,1),(793,7530487,7530479,'isk',50,1),(793,7530488,7530486,'ind',33.333,1),(793,7530489,7530486,'nde',33.333,1),(793,7530490,7530486,'dex',33.333,1),(793,7530491,7530488,'adm',8.333,1),(793,7530492,7530488,'dmi',8.333,1),(793,7530493,7530488,'min',8.333,1),(793,7530494,7530488,'ini',8.333,1),(793,7530495,7530488,'nis',8.333,1),(793,7530496,7530488,'ist',8.333,1),(793,7530497,7530488,'str',8.333,1),(793,7530498,7530488,'tra',8.333,1),(793,7530499,7530488,'rat',8.333,1),(793,7530500,7530488,'ati',8.333,1),(793,7530501,7530488,'tio',8.333,1),(793,7530502,7530488,'ion',8.333,1),(793,7530503,7530491,'sta',33.333,3),(793,7530504,7530491,'tat',33.333,3),(793,7530505,7530491,'ate',33.333,3),(793,7530506,7530503,'dis',16.667,4),(793,7530507,7530503,'isa',16.667,4),(793,7530508,7530503,'sab',16.667,4),(793,7530509,7530503,'abl',16.667,4),(793,7530510,7530503,'ble',16.667,4),(793,7530511,7530503,'led',16.667,4),(793,7530512,7530506,'cac',33.333,1),(793,7530513,7530506,'ach',33.333,1),(793,7530514,7530506,'che',33.333,1),(793,7530515,7530512,'mod',50,1),(793,7530516,7530512,'ode',50,1),(793,7530517,7530515,'wri',14.286,1),(793,7530518,7530515,'rit',14.286,1),(793,7530519,7530515,'ite',14.286,1),(793,7530520,7530515,'tet',14.286,1),(793,7530521,7530515,'eth',14.286,1),(793,7530522,7530515,'thr',14.286,1),(793,7530523,7530515,'hru',14.286,1),(793,7530524,7530517,'ope',11.111,2),(793,7530525,7530517,'per',11.111,2),(793,7530526,7530517,'era',11.111,2),(793,7530527,7530517,'rat',11.111,2),(793,7530528,7530517,'ati',11.111,2),(793,7530529,7530517,'tio',11.111,2),(793,7530530,7530517,'ion',11.111,2),(793,7530531,7530517,'ona',11.111,2),(793,7530532,7530517,'nal',11.111,2),(793,7530533,7530524,'mes',20,1),(793,7530534,7530524,'ess',20,1),(793,7530535,7530524,'ssa',20,1),(793,7530536,7530524,'sag',20,1),(793,7530537,7530524,'age',20,1),(793,7530538,7530533,'per',11.111,1),(793,7530539,7530533,'erf',11.111,1),(793,7530540,7530533,'rfo',11.111,1),(793,7530541,7530533,'for',11.111,1),(793,7530542,7530533,'orm',11.111,1),(793,7530543,7530533,'rma',11.111,1),(793,7530544,7530533,'man',11.111,1),(793,7530545,7530533,'anc',11.111,1),(793,7530546,7530533,'nce',11.111,1),(793,7530547,7530538,'ide',12.5,1),(793,7530548,7530538,'den',12.5,1),(793,7530549,7530538,'ent',12.5,1),(793,7530550,7530538,'nti',12.5,1),(793,7530551,7530538,'tif',12.5,1),(793,7530552,7530538,'ifi',12.5,1),(793,7530553,7530538,'fie',12.5,1),(793,7530554,7530538,'ier',12.5,1),(793,7530555,7530547,'vdi',33.333,3),(793,7530556,7530547,'dis',33.333,3),(793,7530557,7530547,'isk',33.333,3),(793,7530558,7530555,'nam',50,1),(793,7530559,7530555,'ame',50,1),(793,7530560,7530558,'typ',50,1),(793,7530561,7530558,'ype',50,1),(793,7530562,7530560,'dir',25,1),(793,7530563,7530560,'ire',25,1),(793,7530564,7530560,'rec',25,1),(793,7530565,7530560,'ect',25,1),(794,7530567,7530566,'naa',100,2),(794,7530568,7530567,'600',3.333,3),(794,7530569,7530567,'000',3.333,3),(794,7530570,7530567,'00c',3.333,3),(794,7530571,7530567,'0c2',3.333,3),(794,7530572,7530567,'c29',3.333,3),(794,7530573,7530567,'29d',3.333,3),(794,7530574,7530567,'9d4',3.333,3),(794,7530575,7530567,'d46',3.333,3),(794,7530576,7530567,'460',3.333,3),(794,7530577,7530567,'609',3.333,3),(794,7530578,7530567,'095',3.333,3),(794,7530579,7530567,'95e',3.333,3),(794,7530580,7530567,'5e4',3.333,3),(794,7530581,7530567,'e4d',3.333,3),(794,7530582,7530567,'4dd',3.333,3),(794,7530583,7530567,'dd7',3.333,3),(794,7530584,7530567,'d7c',3.333,3),(794,7530585,7530567,'7c4',3.333,3),(794,7530586,7530567,'c4a',3.333,3),(794,7530587,7530567,'4a9',3.333,3),(794,7530588,7530567,'a96',3.333,3),(794,7530589,7530567,'96a',3.333,3),(794,7530590,7530567,'6ae',3.333,3),(794,7530591,7530567,'ae2',3.333,3),(794,7530592,7530567,'e24',3.333,3),(794,7530593,7530567,'24a',3.333,3),(794,7530594,7530567,'4a5',3.333,3),(794,7530595,7530567,'a53',3.333,3),(794,7530596,7530567,'530',3.333,3),(794,7530597,7530567,'30f',3.333,3),(794,7530598,7530568,'mon',100,1),(794,7530599,7530598,'201',50,1),(794,7530600,7530598,'013',50,1),(794,7530601,7530599,'adm',33.333,4),(794,7530602,7530599,'dmi',33.333,4),(794,7530603,7530599,'min',33.333,4),(794,7530604,7530601,'cap',16.667,1),(794,7530605,7530601,'apa',16.667,1),(794,7530606,7530601,'pac',16.667,1),(794,7530607,7530601,'aci',16.667,1),(794,7530608,7530601,'cit',16.667,1),(794,7530609,7530601,'ity',16.667,1),(794,7530610,7530604,'pat',50,1),(794,7530611,7530604,'ath',50,1),(794,7530612,7530610,'ten',100,1),(794,7530613,7530612,'fre',14.286,1),(794,7530614,7530612,'ree',14.286,1),(794,7530615,7530612,'ees',14.286,1),(794,7530616,7530612,'esp',14.286,1),(794,7530617,7530612,'spa',14.286,1),(794,7530618,7530612,'pac',14.286,1),(794,7530619,7530612,'ace',14.286,1),(794,7530620,7530613,'dis',50,1),(794,7530621,7530613,'isk',50,1),(794,7530622,7530620,'ind',33.333,1),(794,7530623,7530620,'nde',33.333,1),(794,7530624,7530620,'dex',33.333,1),(794,7530625,7530622,'adm',8.333,1),(794,7530626,7530622,'dmi',8.333,1),(794,7530627,7530622,'min',8.333,1),(794,7530628,7530622,'ini',8.333,1),(794,7530629,7530622,'nis',8.333,1),(794,7530630,7530622,'ist',8.333,1),(794,7530631,7530622,'str',8.333,1),(794,7530632,7530622,'tra',8.333,1),(794,7530633,7530622,'rat',8.333,1),(794,7530634,7530622,'ati',8.333,1),(794,7530635,7530622,'tio',8.333,1),(794,7530636,7530622,'ion',8.333,1),(794,7530637,7530625,'sta',33.333,3),(794,7530638,7530625,'tat',33.333,3),(794,7530639,7530625,'ate',33.333,3),(794,7530640,7530637,'dis',16.667,4),(794,7530641,7530637,'isa',16.667,4),(794,7530642,7530637,'sab',16.667,4),(794,7530643,7530637,'abl',16.667,4),(794,7530644,7530637,'ble',16.667,4),(794,7530645,7530637,'led',16.667,4),(794,7530646,7530640,'cac',33.333,1),(794,7530647,7530640,'ach',33.333,1),(794,7530648,7530640,'che',33.333,1),(794,7530649,7530646,'mod',50,1),(794,7530650,7530646,'ode',50,1),(794,7530651,7530649,'wri',14.286,1),(794,7530652,7530649,'rit',14.286,1),(794,7530653,7530649,'ite',14.286,1),(794,7530654,7530649,'tet',14.286,1),(794,7530655,7530649,'eth',14.286,1),(794,7530656,7530649,'thr',14.286,1),(794,7530657,7530649,'hru',14.286,1),(794,7530658,7530651,'ope',11.111,2),(794,7530659,7530651,'per',11.111,2),(794,7530660,7530651,'era',11.111,2),(794,7530661,7530651,'rat',11.111,2),(794,7530662,7530651,'ati',11.111,2),(794,7530663,7530651,'tio',11.111,2),(794,7530664,7530651,'ion',11.111,2),(794,7530665,7530651,'ona',11.111,2),(794,7530666,7530651,'nal',11.111,2),(794,7530667,7530658,'mes',20,1),(794,7530668,7530658,'ess',20,1),(794,7530669,7530658,'ssa',20,1),(794,7530670,7530658,'sag',20,1),(794,7530671,7530658,'age',20,1),(794,7530672,7530667,'per',11.111,1),(794,7530673,7530667,'erf',11.111,1),(794,7530674,7530667,'rfo',11.111,1),(794,7530675,7530667,'for',11.111,1),(794,7530676,7530667,'orm',11.111,1),(794,7530677,7530667,'rma',11.111,1),(794,7530678,7530667,'man',11.111,1),(794,7530679,7530667,'anc',11.111,1),(794,7530680,7530667,'nce',11.111,1),(794,7530681,7530672,'ide',12.5,1),(794,7530682,7530672,'den',12.5,1),(794,7530683,7530672,'ent',12.5,1),(794,7530684,7530672,'nti',12.5,1),(794,7530685,7530672,'tif',12.5,1),(794,7530686,7530672,'ifi',12.5,1),(794,7530687,7530672,'fie',12.5,1),(794,7530688,7530672,'ier',12.5,1),(794,7530689,7530681,'vdi',33.333,3),(794,7530690,7530681,'dis',33.333,3),(794,7530691,7530681,'isk',33.333,3),(794,7530692,7530689,'nam',50,1),(794,7530693,7530689,'ame',50,1),(794,7530694,7530692,'typ',50,1),(794,7530695,7530692,'ype',50,1),(794,7530696,7530694,'dir',25,1),(794,7530697,7530694,'ire',25,1),(794,7530698,7530694,'rec',25,1),(794,7530699,7530694,'ect',25,1),(795,7530701,7530700,'naa',100,2),(795,7530702,7530701,'600',3.333,3),(795,7530703,7530701,'000',3.333,3),(795,7530704,7530701,'00c',3.333,3),(795,7530705,7530701,'0c2',3.333,3),(795,7530706,7530701,'c29',3.333,3),(795,7530707,7530701,'292',3.333,3),(795,7530708,7530701,'929',3.333,3),(795,7530709,7530701,'294',3.333,3),(795,7530710,7530701,'94a',3.333,3),(795,7530711,7530701,'4a1',3.333,3),(795,7530712,7530701,'a12',3.333,3),(795,7530713,7530701,'122',3.333,3),(795,7530714,7530701,'22c',3.333,3),(795,7530715,7530701,'2c4',3.333,3),(795,7530716,7530701,'c40',3.333,3),(795,7530717,7530701,'40f',3.333,3),(795,7530718,7530701,'0fa',3.333,3),(795,7530719,7530701,'fab',3.333,3),(795,7530720,7530701,'aba',3.333,3),(795,7530721,7530701,'bad',3.333,3),(795,7530722,7530701,'ad4',3.333,3),(795,7530723,7530701,'d4c',3.333,3),(795,7530724,7530701,'4c2',3.333,3),(795,7530725,7530701,'c28',3.333,3),(795,7530726,7530701,'285',3.333,3),(795,7530727,7530701,'85f',3.333,3),(795,7530728,7530701,'5f8',3.333,3),(795,7530729,7530701,'f81',3.333,3),(795,7530730,7530701,'811',3.333,3),(795,7530731,7530701,'119',3.333,3),(795,7530732,7530702,'mon',100,1),(795,7530733,7530732,'201',50,1),(795,7530734,7530732,'013',50,1),(795,7530735,7530733,'adm',33.333,4),(795,7530736,7530733,'dmi',33.333,4),(795,7530737,7530733,'min',33.333,4),(795,7530738,7530735,'cap',16.667,1),(795,7530739,7530735,'apa',16.667,1),(795,7530740,7530735,'pac',16.667,1),(795,7530741,7530735,'aci',16.667,1),(795,7530742,7530735,'cit',16.667,1),(795,7530743,7530735,'ity',16.667,1),(795,7530744,7530738,'pat',50,1),(795,7530745,7530738,'ath',50,1),(795,7530746,7530744,'ele',25,1),(795,7530747,7530744,'lev',25,1),(795,7530748,7530744,'eve',25,1),(795,7530749,7530744,'ven',25,1),(795,7530750,7530746,'fre',14.286,1),(795,7530751,7530746,'ree',14.286,1),(795,7530752,7530746,'ees',14.286,1),(795,7530753,7530746,'esp',14.286,1),(795,7530754,7530746,'spa',14.286,1),(795,7530755,7530746,'pac',14.286,1),(795,7530756,7530746,'ace',14.286,1),(795,7530757,7530750,'dis',50,1),(795,7530758,7530750,'isk',50,1),(795,7530759,7530757,'ind',33.333,1),(795,7530760,7530757,'nde',33.333,1),(795,7530761,7530757,'dex',33.333,1),(795,7530762,7530759,'adm',8.333,1),(795,7530763,7530759,'dmi',8.333,1),(795,7530764,7530759,'min',8.333,1),(795,7530765,7530759,'ini',8.333,1),(795,7530766,7530759,'nis',8.333,1),(795,7530767,7530759,'ist',8.333,1),(795,7530768,7530759,'str',8.333,1),(795,7530769,7530759,'tra',8.333,1),(795,7530770,7530759,'rat',8.333,1),(795,7530771,7530759,'ati',8.333,1),(795,7530772,7530759,'tio',8.333,1),(795,7530773,7530759,'ion',8.333,1),(795,7530774,7530762,'sta',33.333,3),(795,7530775,7530762,'tat',33.333,3),(795,7530776,7530762,'ate',33.333,3),(795,7530777,7530774,'dis',16.667,4),(795,7530778,7530774,'isa',16.667,4),(795,7530779,7530774,'sab',16.667,4),(795,7530780,7530774,'abl',16.667,4),(795,7530781,7530774,'ble',16.667,4),(795,7530782,7530774,'led',16.667,4),(795,7530783,7530777,'cac',33.333,1),(795,7530784,7530777,'ach',33.333,1),(795,7530785,7530777,'che',33.333,1),(795,7530786,7530783,'mod',50,1),(795,7530787,7530783,'ode',50,1),(795,7530788,7530786,'wri',14.286,1),(795,7530789,7530786,'rit',14.286,1),(795,7530790,7530786,'ite',14.286,1),(795,7530791,7530786,'tet',14.286,1),(795,7530792,7530786,'eth',14.286,1),(795,7530793,7530786,'thr',14.286,1),(795,7530794,7530786,'hru',14.286,1),(795,7530795,7530788,'ope',11.111,2),(795,7530796,7530788,'per',11.111,2),(795,7530797,7530788,'era',11.111,2),(795,7530798,7530788,'rat',11.111,2),(795,7530799,7530788,'ati',11.111,2),(795,7530800,7530788,'tio',11.111,2),(795,7530801,7530788,'ion',11.111,2),(795,7530802,7530788,'ona',11.111,2),(795,7530803,7530788,'nal',11.111,2),(795,7530804,7530795,'mes',20,1),(795,7530805,7530795,'ess',20,1),(795,7530806,7530795,'ssa',20,1),(795,7530807,7530795,'sag',20,1),(795,7530808,7530795,'age',20,1),(795,7530809,7530804,'per',11.111,1),(795,7530810,7530804,'erf',11.111,1),(795,7530811,7530804,'rfo',11.111,1),(795,7530812,7530804,'for',11.111,1),(795,7530813,7530804,'orm',11.111,1),(795,7530814,7530804,'rma',11.111,1),(795,7530815,7530804,'man',11.111,1),(795,7530816,7530804,'anc',11.111,1),(795,7530817,7530804,'nce',11.111,1),(795,7530818,7530809,'ide',12.5,1),(795,7530819,7530809,'den',12.5,1),(795,7530820,7530809,'ent',12.5,1),(795,7530821,7530809,'nti',12.5,1),(795,7530822,7530809,'tif',12.5,1),(795,7530823,7530809,'ifi',12.5,1),(795,7530824,7530809,'fie',12.5,1),(795,7530825,7530809,'ier',12.5,1),(795,7530826,7530818,'vdi',33.333,3),(795,7530827,7530818,'dis',33.333,3),(795,7530828,7530818,'isk',33.333,3),(795,7530829,7530826,'nam',50,1),(795,7530830,7530826,'ame',50,1),(795,7530831,7530829,'typ',50,1),(795,7530832,7530829,'ype',50,1),(795,7530833,7530831,'dir',25,1),(795,7530834,7530831,'ire',25,1),(795,7530835,7530831,'rec',25,1),(795,7530836,7530831,'ect',25,1),(796,7530838,7530837,'naa',100,2),(796,7530839,7530838,'600',3.333,3),(796,7530840,7530838,'000',3.333,3),(796,7530841,7530838,'00c',3.333,3),(796,7530842,7530838,'0c2',3.333,3),(796,7530843,7530838,'c29',3.333,3),(796,7530844,7530838,'29e',3.333,3),(796,7530845,7530838,'9e6',3.333,3),(796,7530846,7530838,'e6f',3.333,3),(796,7530847,7530838,'6fd',3.333,3),(796,7530848,7530838,'fd8',3.333,3),(796,7530849,7530838,'d82',3.333,3),(796,7530850,7530838,'820',3.333,3),(796,7530851,7530838,'20d',3.333,3),(796,7530852,7530838,'0db',3.333,3),(796,7530853,7530838,'dbe',3.333,3),(796,7530854,7530838,'be9',3.333,3),(796,7530855,7530838,'e9c',3.333,3),(796,7530856,7530838,'9ce',3.333,3),(796,7530857,7530838,'ced',3.333,3),(796,7530858,7530838,'ed8',3.333,3),(796,7530859,7530838,'d81',3.333,3),(796,7530860,7530838,'81a',3.333,3),(796,7530861,7530838,'1a9',3.333,3),(796,7530862,7530838,'a9a',3.333,3),(796,7530863,7530838,'9a1',3.333,3),(796,7530864,7530838,'a18',3.333,3),(796,7530865,7530838,'185',3.333,3),(796,7530866,7530838,'85c',3.333,3),(796,7530867,7530838,'5c8',3.333,3),(796,7530868,7530838,'c8e',3.333,3),(796,7530869,7530839,'mon',100,1),(796,7530870,7530869,'201',50,1),(796,7530871,7530869,'013',50,1),(796,7530872,7530870,'adm',33.333,4),(796,7530873,7530870,'dmi',33.333,4),(796,7530874,7530870,'min',33.333,4),(796,7530875,7530872,'cap',16.667,1),(796,7530876,7530872,'apa',16.667,1),(796,7530877,7530872,'pac',16.667,1),(796,7530878,7530872,'aci',16.667,1),(796,7530879,7530872,'cit',16.667,1),(796,7530880,7530872,'ity',16.667,1),(796,7530881,7530875,'pat',50,1),(796,7530882,7530875,'ath',50,1),(796,7530883,7530881,'twe',25,1),(796,7530884,7530881,'wel',25,1),(796,7530885,7530881,'elv',25,1),(796,7530886,7530881,'lve',25,1),(796,7530887,7530883,'fre',14.286,1),(796,7530888,7530883,'ree',14.286,1),(796,7530889,7530883,'ees',14.286,1),(796,7530890,7530883,'esp',14.286,1),(796,7530891,7530883,'spa',14.286,1),(796,7530892,7530883,'pac',14.286,1),(796,7530893,7530883,'ace',14.286,1),(796,7530894,7530887,'dis',50,1),(796,7530895,7530887,'isk',50,1),(796,7530896,7530894,'ind',33.333,1),(796,7530897,7530894,'nde',33.333,1),(796,7530898,7530894,'dex',33.333,1),(796,7530899,7530896,'adm',8.333,1),(796,7530900,7530896,'dmi',8.333,1),(796,7530901,7530896,'min',8.333,1),(796,7530902,7530896,'ini',8.333,1),(796,7530903,7530896,'nis',8.333,1),(796,7530904,7530896,'ist',8.333,1),(796,7530905,7530896,'str',8.333,1),(796,7530906,7530896,'tra',8.333,1),(796,7530907,7530896,'rat',8.333,1),(796,7530908,7530896,'ati',8.333,1),(796,7530909,7530896,'tio',8.333,1),(796,7530910,7530896,'ion',8.333,1),(796,7530911,7530899,'sta',33.333,3),(796,7530912,7530899,'tat',33.333,3),(796,7530913,7530899,'ate',33.333,3),(796,7530914,7530911,'dis',16.667,4),(796,7530915,7530911,'isa',16.667,4),(796,7530916,7530911,'sab',16.667,4),(796,7530917,7530911,'abl',16.667,4),(796,7530918,7530911,'ble',16.667,4),(796,7530919,7530911,'led',16.667,4),(796,7530920,7530914,'cac',33.333,1),(796,7530921,7530914,'ach',33.333,1),(796,7530922,7530914,'che',33.333,1),(796,7530923,7530920,'mod',50,1),(796,7530924,7530920,'ode',50,1),(796,7530925,7530923,'wri',14.286,1),(796,7530926,7530923,'rit',14.286,1),(796,7530927,7530923,'ite',14.286,1),(796,7530928,7530923,'tet',14.286,1),(796,7530929,7530923,'eth',14.286,1),(796,7530930,7530923,'thr',14.286,1),(796,7530931,7530923,'hru',14.286,1),(796,7530932,7530925,'ope',11.111,2),(796,7530933,7530925,'per',11.111,2),(796,7530934,7530925,'era',11.111,2),(796,7530935,7530925,'rat',11.111,2),(796,7530936,7530925,'ati',11.111,2),(796,7530937,7530925,'tio',11.111,2),(796,7530938,7530925,'ion',11.111,2),(796,7530939,7530925,'ona',11.111,2),(796,7530940,7530925,'nal',11.111,2),(796,7530941,7530932,'mes',20,1),(796,7530942,7530932,'ess',20,1),(796,7530943,7530932,'ssa',20,1),(796,7530944,7530932,'sag',20,1),(796,7530945,7530932,'age',20,1),(796,7530946,7530941,'per',11.111,1),(796,7530947,7530941,'erf',11.111,1),(796,7530948,7530941,'rfo',11.111,1),(796,7530949,7530941,'for',11.111,1),(796,7530950,7530941,'orm',11.111,1),(796,7530951,7530941,'rma',11.111,1),(796,7530952,7530941,'man',11.111,1),(796,7530953,7530941,'anc',11.111,1),(796,7530954,7530941,'nce',11.111,1),(796,7530955,7530946,'ide',12.5,1),(796,7530956,7530946,'den',12.5,1),(796,7530957,7530946,'ent',12.5,1),(796,7530958,7530946,'nti',12.5,1),(796,7530959,7530946,'tif',12.5,1),(796,7530960,7530946,'ifi',12.5,1),(796,7530961,7530946,'fie',12.5,1),(796,7530962,7530946,'ier',12.5,1),(796,7530963,7530955,'vdi',33.333,3),(796,7530964,7530955,'dis',33.333,3),(796,7530965,7530955,'isk',33.333,3),(796,7530966,7530963,'nam',50,1),(796,7530967,7530963,'ame',50,1),(796,7530968,7530966,'typ',50,1),(796,7530969,7530966,'ype',50,1),(796,7530970,7530968,'dir',25,1),(796,7530971,7530968,'ire',25,1),(796,7530972,7530968,'rec',25,1),(796,7530973,7530968,'ect',25,1),(797,7530975,7530974,'naa',100,2),(797,7530976,7530975,'600',3.333,3),(797,7530977,7530975,'000',3.333,3),(797,7530978,7530975,'00c',3.333,3),(797,7530979,7530975,'0c2',3.333,3),(797,7530980,7530975,'c29',3.333,3),(797,7530981,7530975,'299',3.333,3),(797,7530982,7530975,'999',3.333,3),(797,7530983,7530975,'99e',3.333,3),(797,7530984,7530975,'9ef',3.333,3),(797,7530985,7530975,'ef1',3.333,3),(797,7530986,7530975,'f14',3.333,3),(797,7530987,7530975,'14a',3.333,3),(797,7530988,7530975,'4a3',3.333,3),(797,7530989,7530975,'a35',3.333,3),(797,7530990,7530975,'35e',3.333,3),(797,7530991,7530975,'5ef',3.333,3),(797,7530992,7530975,'ef8',3.333,3),(797,7530993,7530975,'f86',3.333,3),(797,7530994,7530975,'86c',3.333,3),(797,7530995,7530975,'6c4',3.333,3),(797,7530996,7530975,'c4f',3.333,3),(797,7530997,7530975,'4f2',3.333,3),(797,7530998,7530975,'f24',3.333,3),(797,7530999,7530975,'24b',3.333,3),(797,7531000,7530975,'4be',3.333,3),(797,7531001,7530975,'bed',3.333,3),(797,7531002,7530975,'ed9',3.333,3),(797,7531003,7530975,'d9f',3.333,3),(797,7531004,7530975,'9f0',3.333,3),(797,7531005,7530975,'f09',3.333,3),(797,7531006,7530976,'mon',100,1),(797,7531007,7531006,'201',50,1),(797,7531008,7531006,'013',50,1),(797,7531009,7531007,'adm',33.333,4),(797,7531010,7531007,'dmi',33.333,4),(797,7531011,7531007,'min',33.333,4),(797,7531012,7531009,'cap',16.667,1),(797,7531013,7531009,'apa',16.667,1),(797,7531014,7531009,'pac',16.667,1),(797,7531015,7531009,'aci',16.667,1),(797,7531016,7531009,'cit',16.667,1),(797,7531017,7531009,'ity',16.667,1),(797,7531018,7531012,'pat',50,1),(797,7531019,7531012,'ath',50,1),(797,7531020,7531018,'thi',16.667,1),(797,7531021,7531018,'hir',16.667,1),(797,7531022,7531018,'irt',16.667,1),(797,7531023,7531018,'rte',16.667,1),(797,7531024,7531018,'tee',16.667,1),(797,7531025,7531018,'een',16.667,1),(797,7531026,7531020,'fre',14.286,1),(797,7531027,7531020,'ree',14.286,1),(797,7531028,7531020,'ees',14.286,1),(797,7531029,7531020,'esp',14.286,1),(797,7531030,7531020,'spa',14.286,1),(797,7531031,7531020,'pac',14.286,1),(797,7531032,7531020,'ace',14.286,1),(797,7531033,7531026,'dis',50,1),(797,7531034,7531026,'isk',50,1),(797,7531035,7531033,'ind',33.333,1),(797,7531036,7531033,'nde',33.333,1),(797,7531037,7531033,'dex',33.333,1),(797,7531038,7531035,'adm',8.333,1),(797,7531039,7531035,'dmi',8.333,1),(797,7531040,7531035,'min',8.333,1),(797,7531041,7531035,'ini',8.333,1),(797,7531042,7531035,'nis',8.333,1),(797,7531043,7531035,'ist',8.333,1),(797,7531044,7531035,'str',8.333,1),(797,7531045,7531035,'tra',8.333,1),(797,7531046,7531035,'rat',8.333,1),(797,7531047,7531035,'ati',8.333,1),(797,7531048,7531035,'tio',8.333,1),(797,7531049,7531035,'ion',8.333,1),(797,7531050,7531038,'sta',33.333,3),(797,7531051,7531038,'tat',33.333,3),(797,7531052,7531038,'ate',33.333,3),(797,7531053,7531050,'dis',16.667,4),(797,7531054,7531050,'isa',16.667,4),(797,7531055,7531050,'sab',16.667,4),(797,7531056,7531050,'abl',16.667,4),(797,7531057,7531050,'ble',16.667,4),(797,7531058,7531050,'led',16.667,4),(797,7531059,7531053,'cac',33.333,1),(797,7531060,7531053,'ach',33.333,1),(797,7531061,7531053,'che',33.333,1),(797,7531062,7531059,'mod',50,1),(797,7531063,7531059,'ode',50,1),(797,7531064,7531062,'wri',14.286,1),(797,7531065,7531062,'rit',14.286,1),(797,7531066,7531062,'ite',14.286,1),(797,7531067,7531062,'tet',14.286,1),(797,7531068,7531062,'eth',14.286,1),(797,7531069,7531062,'thr',14.286,1),(797,7531070,7531062,'hru',14.286,1),(797,7531071,7531064,'ope',11.111,2),(797,7531072,7531064,'per',11.111,2),(797,7531073,7531064,'era',11.111,2),(797,7531074,7531064,'rat',11.111,2),(797,7531075,7531064,'ati',11.111,2),(797,7531076,7531064,'tio',11.111,2),(797,7531077,7531064,'ion',11.111,2),(797,7531078,7531064,'ona',11.111,2),(797,7531079,7531064,'nal',11.111,2),(797,7531080,7531071,'mes',20,1),(797,7531081,7531071,'ess',20,1),(797,7531082,7531071,'ssa',20,1),(797,7531083,7531071,'sag',20,1),(797,7531084,7531071,'age',20,1),(797,7531085,7531080,'per',11.111,1),(797,7531086,7531080,'erf',11.111,1),(797,7531087,7531080,'rfo',11.111,1),(797,7531088,7531080,'for',11.111,1),(797,7531089,7531080,'orm',11.111,1),(797,7531090,7531080,'rma',11.111,1),(797,7531091,7531080,'man',11.111,1),(797,7531092,7531080,'anc',11.111,1),(797,7531093,7531080,'nce',11.111,1),(797,7531094,7531085,'ide',12.5,1),(797,7531095,7531085,'den',12.5,1),(797,7531096,7531085,'ent',12.5,1),(797,7531097,7531085,'nti',12.5,1),(797,7531098,7531085,'tif',12.5,1),(797,7531099,7531085,'ifi',12.5,1),(797,7531100,7531085,'fie',12.5,1),(797,7531101,7531085,'ier',12.5,1),(797,7531102,7531094,'vdi',33.333,3),(797,7531103,7531094,'dis',33.333,3),(797,7531104,7531094,'isk',33.333,3),(797,7531105,7531102,'nam',50,1),(797,7531106,7531102,'ame',50,1),(797,7531107,7531105,'typ',50,1),(797,7531108,7531105,'ype',50,1),(797,7531109,7531107,'dir',25,1),(797,7531110,7531107,'ire',25,1),(797,7531111,7531107,'rec',25,1),(797,7531112,7531107,'ect',25,1),(798,7531114,7531113,'naa',100,2),(798,7531115,7531114,'600',3.333,3),(798,7531116,7531114,'000',3.333,3),(798,7531117,7531114,'00c',3.333,3),(798,7531118,7531114,'0c2',3.333,3),(798,7531119,7531114,'c29',3.333,3),(798,7531120,7531114,'29a',3.333,3),(798,7531121,7531114,'9a0',3.333,3),(798,7531122,7531114,'a07',3.333,3),(798,7531123,7531114,'07d',3.333,3),(798,7531124,7531114,'7dd',3.333,3),(798,7531125,7531114,'ddf',3.333,3),(798,7531126,7531114,'df4',3.333,3),(798,7531127,7531114,'f44',3.333,3),(798,7531128,7531114,'44e',3.333,3),(798,7531129,7531114,'4ec',3.333,3),(798,7531130,7531114,'ec3',3.333,3),(798,7531131,7531114,'c3d',3.333,3),(798,7531132,7531114,'3d5',3.333,3),(798,7531133,7531114,'d5c',3.333,3),(798,7531134,7531114,'5c4',3.333,3),(798,7531135,7531114,'c44',3.333,3),(798,7531136,7531114,'44d',3.333,3),(798,7531137,7531114,'4dd',3.333,3),(798,7531138,7531114,'dd2',3.333,3),(798,7531139,7531114,'d21',3.333,3),(798,7531140,7531114,'213',3.333,3),(798,7531141,7531114,'13f',3.333,3),(798,7531142,7531114,'3f6',3.333,3),(798,7531143,7531114,'f67',3.333,3),(798,7531144,7531114,'67a',3.333,3),(798,7531145,7531115,'mon',100,1),(798,7531146,7531145,'201',50,1),(798,7531147,7531145,'013',50,1),(798,7531148,7531146,'adm',33.333,4),(798,7531149,7531146,'dmi',33.333,4),(798,7531150,7531146,'min',33.333,4),(798,7531151,7531148,'cap',16.667,1),(798,7531152,7531148,'apa',16.667,1),(798,7531153,7531148,'pac',16.667,1),(798,7531154,7531148,'aci',16.667,1),(798,7531155,7531148,'cit',16.667,1),(798,7531156,7531148,'ity',16.667,1),(798,7531157,7531151,'pat',50,1),(798,7531158,7531151,'ath',50,1),(798,7531159,7531157,'fre',14.286,1),(798,7531160,7531157,'ree',14.286,1),(798,7531161,7531157,'ees',14.286,1),(798,7531162,7531157,'esp',14.286,1),(798,7531163,7531157,'spa',14.286,1),(798,7531164,7531157,'pac',14.286,1),(798,7531165,7531157,'ace',14.286,1),(798,7531166,7531159,'dis',50,1),(798,7531167,7531159,'isk',50,1),(798,7531168,7531166,'ind',33.333,1),(798,7531169,7531166,'nde',33.333,1),(798,7531170,7531166,'dex',33.333,1),(798,7531171,7531168,'adm',8.333,1),(798,7531172,7531168,'dmi',8.333,1),(798,7531173,7531168,'min',8.333,1),(798,7531174,7531168,'ini',8.333,1),(798,7531175,7531168,'nis',8.333,1),(798,7531176,7531168,'ist',8.333,1),(798,7531177,7531168,'str',8.333,1),(798,7531178,7531168,'tra',8.333,1),(798,7531179,7531168,'rat',8.333,1),(798,7531180,7531168,'ati',8.333,1),(798,7531181,7531168,'tio',8.333,1),(798,7531182,7531168,'ion',8.333,1),(798,7531183,7531171,'sta',33.333,3),(798,7531184,7531171,'tat',33.333,3),(798,7531185,7531171,'ate',33.333,3),(798,7531186,7531183,'dis',16.667,4),(798,7531187,7531183,'isa',16.667,4),(798,7531188,7531183,'sab',16.667,4),(798,7531189,7531183,'abl',16.667,4),(798,7531190,7531183,'ble',16.667,4),(798,7531191,7531183,'led',16.667,4),(798,7531192,7531186,'cac',33.333,1),(798,7531193,7531186,'ach',33.333,1),(798,7531194,7531186,'che',33.333,1),(798,7531195,7531192,'mod',50,1),(798,7531196,7531192,'ode',50,1),(798,7531197,7531195,'wri',14.286,1),(798,7531198,7531195,'rit',14.286,1),(798,7531199,7531195,'ite',14.286,1),(798,7531200,7531195,'tet',14.286,1),(798,7531201,7531195,'eth',14.286,1),(798,7531202,7531195,'thr',14.286,1),(798,7531203,7531195,'hru',14.286,1),(798,7531204,7531197,'ope',11.111,2),(798,7531205,7531197,'per',11.111,2),(798,7531206,7531197,'era',11.111,2),(798,7531207,7531197,'rat',11.111,2),(798,7531208,7531197,'ati',11.111,2),(798,7531209,7531197,'tio',11.111,2),(798,7531210,7531197,'ion',11.111,2),(798,7531211,7531197,'ona',11.111,2),(798,7531212,7531197,'nal',11.111,2),(798,7531213,7531204,'mes',20,1),(798,7531214,7531204,'ess',20,1),(798,7531215,7531204,'ssa',20,1),(798,7531216,7531204,'sag',20,1),(798,7531217,7531204,'age',20,1),(798,7531218,7531213,'per',11.111,1),(798,7531219,7531213,'erf',11.111,1),(798,7531220,7531213,'rfo',11.111,1),(798,7531221,7531213,'for',11.111,1),(798,7531222,7531213,'orm',11.111,1),(798,7531223,7531213,'rma',11.111,1),(798,7531224,7531213,'man',11.111,1),(798,7531225,7531213,'anc',11.111,1),(798,7531226,7531213,'nce',11.111,1),(798,7531227,7531218,'ide',12.5,1),(798,7531228,7531218,'den',12.5,1),(798,7531229,7531218,'ent',12.5,1),(798,7531230,7531218,'nti',12.5,1),(798,7531231,7531218,'tif',12.5,1),(798,7531232,7531218,'ifi',12.5,1),(798,7531233,7531218,'fie',12.5,1),(798,7531234,7531218,'ier',12.5,1),(798,7531235,7531227,'vdi',33.333,3),(798,7531236,7531227,'dis',33.333,3),(798,7531237,7531227,'isk',33.333,3),(798,7531238,7531235,'nam',50,1),(798,7531239,7531235,'ame',50,1),(798,7531240,7531238,'typ',50,1),(798,7531241,7531238,'ype',50,1),(798,7531242,7531240,'dir',25,1),(798,7531243,7531240,'ire',25,1),(798,7531244,7531240,'rec',25,1),(798,7531245,7531240,'ect',25,1),(799,7531247,7531246,'naa',100,2),(799,7531248,7531247,'600',3.333,3),(799,7531249,7531247,'000',3.333,3),(799,7531250,7531247,'00c',3.333,3),(799,7531251,7531247,'0c2',3.333,3),(799,7531252,7531247,'c29',3.333,3),(799,7531253,7531247,'295',3.333,3),(799,7531254,7531247,'951',3.333,3),(799,7531255,7531247,'517',3.333,3),(799,7531256,7531247,'17e',3.333,3),(799,7531257,7531247,'7e3',3.333,3),(799,7531258,7531247,'e36',3.333,3),(799,7531259,7531247,'367',3.333,3),(799,7531260,7531247,'67c',3.333,3),(799,7531261,7531247,'7ce',3.333,3),(799,7531262,7531247,'ce3',3.333,3),(799,7531263,7531247,'e35',3.333,3),(799,7531264,7531247,'353',3.333,3),(799,7531265,7531247,'538',3.333,3),(799,7531266,7531247,'383',3.333,3),(799,7531267,7531247,'83f',3.333,3),(799,7531268,7531247,'3f5',3.333,3),(799,7531269,7531247,'f53',3.333,3),(799,7531270,7531247,'53e',3.333,3),(799,7531271,7531247,'3e2',3.333,3),(799,7531272,7531247,'e2c',3.333,3),(799,7531273,7531247,'2c1',3.333,3),(799,7531274,7531247,'c1b',3.333,3),(799,7531275,7531247,'1bf',3.333,3),(799,7531276,7531247,'bfd',3.333,3),(799,7531277,7531247,'fd8',3.333,3),(799,7531278,7531248,'mon',100,1),(799,7531279,7531278,'201',50,1),(799,7531280,7531278,'013',50,1),(799,7531281,7531279,'adm',33.333,4),(799,7531282,7531279,'dmi',33.333,4),(799,7531283,7531279,'min',33.333,4),(799,7531284,7531281,'cap',16.667,1),(799,7531285,7531281,'apa',16.667,1),(799,7531286,7531281,'pac',16.667,1),(799,7531287,7531281,'aci',16.667,1),(799,7531288,7531281,'cit',16.667,1),(799,7531289,7531281,'ity',16.667,1),(799,7531290,7531284,'pat',50,1),(799,7531291,7531284,'ath',50,1),(799,7531292,7531290,'fre',14.286,1),(799,7531293,7531290,'ree',14.286,1),(799,7531294,7531290,'ees',14.286,1),(799,7531295,7531290,'esp',14.286,1),(799,7531296,7531290,'spa',14.286,1),(799,7531297,7531290,'pac',14.286,1),(799,7531298,7531290,'ace',14.286,1),(799,7531299,7531292,'dis',50,1),(799,7531300,7531292,'isk',50,1),(799,7531301,7531299,'ind',33.333,1),(799,7531302,7531299,'nde',33.333,1),(799,7531303,7531299,'dex',33.333,1),(799,7531304,7531301,'adm',8.333,1),(799,7531305,7531301,'dmi',8.333,1),(799,7531306,7531301,'min',8.333,1),(799,7531307,7531301,'ini',8.333,1),(799,7531308,7531301,'nis',8.333,1),(799,7531309,7531301,'ist',8.333,1),(799,7531310,7531301,'str',8.333,1),(799,7531311,7531301,'tra',8.333,1),(799,7531312,7531301,'rat',8.333,1),(799,7531313,7531301,'ati',8.333,1),(799,7531314,7531301,'tio',8.333,1),(799,7531315,7531301,'ion',8.333,1),(799,7531316,7531304,'sta',33.333,3),(799,7531317,7531304,'tat',33.333,3),(799,7531318,7531304,'ate',33.333,3),(799,7531319,7531316,'dis',16.667,4),(799,7531320,7531316,'isa',16.667,4),(799,7531321,7531316,'sab',16.667,4),(799,7531322,7531316,'abl',16.667,4),(799,7531323,7531316,'ble',16.667,4),(799,7531324,7531316,'led',16.667,4),(799,7531325,7531319,'cac',33.333,1),(799,7531326,7531319,'ach',33.333,1),(799,7531327,7531319,'che',33.333,1),(799,7531328,7531325,'mod',50,1),(799,7531329,7531325,'ode',50,1),(799,7531330,7531328,'wri',14.286,1),(799,7531331,7531328,'rit',14.286,1),(799,7531332,7531328,'ite',14.286,1),(799,7531333,7531328,'tet',14.286,1),(799,7531334,7531328,'eth',14.286,1),(799,7531335,7531328,'thr',14.286,1),(799,7531336,7531328,'hru',14.286,1),(799,7531337,7531330,'ope',11.111,2),(799,7531338,7531330,'per',11.111,2),(799,7531339,7531330,'era',11.111,2),(799,7531340,7531330,'rat',11.111,2),(799,7531341,7531330,'ati',11.111,2),(799,7531342,7531330,'tio',11.111,2),(799,7531343,7531330,'ion',11.111,2),(799,7531344,7531330,'ona',11.111,2),(799,7531345,7531330,'nal',11.111,2),(799,7531346,7531337,'mes',20,1),(799,7531347,7531337,'ess',20,1),(799,7531348,7531337,'ssa',20,1),(799,7531349,7531337,'sag',20,1),(799,7531350,7531337,'age',20,1),(799,7531351,7531346,'per',11.111,1),(799,7531352,7531346,'erf',11.111,1),(799,7531353,7531346,'rfo',11.111,1),(799,7531354,7531346,'for',11.111,1),(799,7531355,7531346,'orm',11.111,1),(799,7531356,7531346,'rma',11.111,1),(799,7531357,7531346,'man',11.111,1),(799,7531358,7531346,'anc',11.111,1),(799,7531359,7531346,'nce',11.111,1),(799,7531360,7531351,'ide',12.5,1),(799,7531361,7531351,'den',12.5,1),(799,7531362,7531351,'ent',12.5,1),(799,7531363,7531351,'nti',12.5,1),(799,7531364,7531351,'tif',12.5,1),(799,7531365,7531351,'ifi',12.5,1),(799,7531366,7531351,'fie',12.5,1),(799,7531367,7531351,'ier',12.5,1),(799,7531368,7531360,'vdi',33.333,3),(799,7531369,7531360,'dis',33.333,3),(799,7531370,7531360,'isk',33.333,3),(799,7531371,7531368,'nam',50,1),(799,7531372,7531368,'ame',50,1),(799,7531373,7531371,'typ',50,1),(799,7531374,7531371,'ype',50,1),(799,7531375,7531373,'dir',25,1),(799,7531376,7531373,'ire',25,1),(799,7531377,7531373,'rec',25,1),(799,7531378,7531373,'ect',25,1),(800,7531380,7531379,'naa',100,2),(800,7531381,7531380,'600',3.333,3),(800,7531382,7531380,'000',3.333,3),(800,7531383,7531380,'00c',3.333,3),(800,7531384,7531380,'0c2',3.333,3),(800,7531385,7531380,'c29',3.333,3),(800,7531386,7531380,'299',3.333,3),(800,7531387,7531380,'99c',3.333,3),(800,7531388,7531380,'9c9',3.333,3),(800,7531389,7531380,'c9f',3.333,3),(800,7531390,7531380,'9f8',3.333,3),(800,7531391,7531380,'f8c',3.333,3),(800,7531392,7531380,'8c7',3.333,3),(800,7531393,7531380,'c78',3.333,3),(800,7531394,7531380,'780',3.333,3),(800,7531395,7531380,'805',3.333,3),(800,7531396,7531380,'05b',3.333,3),(800,7531397,7531380,'5bd',3.333,3),(800,7531398,7531380,'bd6',3.333,3),(800,7531399,7531380,'d61',3.333,3),(800,7531400,7531380,'614',3.333,3),(800,7531401,7531380,'14f',3.333,3),(800,7531402,7531380,'4f4',3.333,3),(800,7531403,7531380,'f4b',3.333,3),(800,7531404,7531380,'4b7',3.333,3),(800,7531405,7531380,'b70',3.333,3),(800,7531406,7531380,'707',3.333,3),(800,7531407,7531380,'078',3.333,3),(800,7531408,7531380,'789',3.333,3),(800,7531409,7531380,'896',3.333,3),(800,7531410,7531380,'960',3.333,3),(800,7531411,7531381,'mon',100,1),(800,7531412,7531411,'201',50,1),(800,7531413,7531411,'013',50,1),(800,7531414,7531412,'adm',33.333,4),(800,7531415,7531412,'dmi',33.333,4),(800,7531416,7531412,'min',33.333,4),(800,7531417,7531414,'cap',16.667,1),(800,7531418,7531414,'apa',16.667,1),(800,7531419,7531414,'pac',16.667,1),(800,7531420,7531414,'aci',16.667,1),(800,7531421,7531414,'cit',16.667,1),(800,7531422,7531414,'ity',16.667,1),(800,7531423,7531417,'pat',50,1),(800,7531424,7531417,'ath',50,1),(800,7531425,7531423,'fre',14.286,1),(800,7531426,7531423,'ree',14.286,1),(800,7531427,7531423,'ees',14.286,1),(800,7531428,7531423,'esp',14.286,1),(800,7531429,7531423,'spa',14.286,1),(800,7531430,7531423,'pac',14.286,1),(800,7531431,7531423,'ace',14.286,1),(800,7531432,7531425,'dis',50,1),(800,7531433,7531425,'isk',50,1),(800,7531434,7531432,'ind',33.333,1),(800,7531435,7531432,'nde',33.333,1),(800,7531436,7531432,'dex',33.333,1),(800,7531437,7531434,'adm',8.333,1),(800,7531438,7531434,'dmi',8.333,1),(800,7531439,7531434,'min',8.333,1),(800,7531440,7531434,'ini',8.333,1),(800,7531441,7531434,'nis',8.333,1),(800,7531442,7531434,'ist',8.333,1),(800,7531443,7531434,'str',8.333,1),(800,7531444,7531434,'tra',8.333,1),(800,7531445,7531434,'rat',8.333,1),(800,7531446,7531434,'ati',8.333,1),(800,7531447,7531434,'tio',8.333,1),(800,7531448,7531434,'ion',8.333,1),(800,7531449,7531437,'sta',33.333,3),(800,7531450,7531437,'tat',33.333,3),(800,7531451,7531437,'ate',33.333,3),(800,7531452,7531449,'dis',16.667,4),(800,7531453,7531449,'isa',16.667,4),(800,7531454,7531449,'sab',16.667,4),(800,7531455,7531449,'abl',16.667,4),(800,7531456,7531449,'ble',16.667,4),(800,7531457,7531449,'led',16.667,4),(800,7531458,7531452,'cac',33.333,1),(800,7531459,7531452,'ach',33.333,1),(800,7531460,7531452,'che',33.333,1),(800,7531461,7531458,'mod',50,1),(800,7531462,7531458,'ode',50,1),(800,7531463,7531461,'wri',14.286,1),(800,7531464,7531461,'rit',14.286,1),(800,7531465,7531461,'ite',14.286,1),(800,7531466,7531461,'tet',14.286,1),(800,7531467,7531461,'eth',14.286,1),(800,7531468,7531461,'thr',14.286,1),(800,7531469,7531461,'hru',14.286,1),(800,7531470,7531463,'ope',11.111,2),(800,7531471,7531463,'per',11.111,2),(800,7531472,7531463,'era',11.111,2),(800,7531473,7531463,'rat',11.111,2),(800,7531474,7531463,'ati',11.111,2),(800,7531475,7531463,'tio',11.111,2),(800,7531476,7531463,'ion',11.111,2),(800,7531477,7531463,'ona',11.111,2),(800,7531478,7531463,'nal',11.111,2),(800,7531479,7531470,'mes',20,1),(800,7531480,7531470,'ess',20,1),(800,7531481,7531470,'ssa',20,1),(800,7531482,7531470,'sag',20,1),(800,7531483,7531470,'age',20,1),(800,7531484,7531479,'per',11.111,1),(800,7531485,7531479,'erf',11.111,1),(800,7531486,7531479,'rfo',11.111,1),(800,7531487,7531479,'for',11.111,1),(800,7531488,7531479,'orm',11.111,1),(800,7531489,7531479,'rma',11.111,1),(800,7531490,7531479,'man',11.111,1),(800,7531491,7531479,'anc',11.111,1),(800,7531492,7531479,'nce',11.111,1),(800,7531493,7531484,'ide',12.5,1),(800,7531494,7531484,'den',12.5,1),(800,7531495,7531484,'ent',12.5,1),(800,7531496,7531484,'nti',12.5,1),(800,7531497,7531484,'tif',12.5,1),(800,7531498,7531484,'ifi',12.5,1),(800,7531499,7531484,'fie',12.5,1),(800,7531500,7531484,'ier',12.5,1),(800,7531501,7531493,'vdi',33.333,3),(800,7531502,7531493,'dis',33.333,3),(800,7531503,7531493,'isk',33.333,3),(800,7531504,7531501,'nam',50,1),(800,7531505,7531501,'ame',50,1),(800,7531506,7531504,'typ',50,1),(800,7531507,7531504,'ype',50,1),(800,7531508,7531506,'dir',25,1),(800,7531509,7531506,'ire',25,1),(800,7531510,7531506,'rec',25,1),(800,7531511,7531506,'ect',25,1),(801,7531513,7531512,'naa',100,2),(801,7531514,7531513,'600',3.333,3),(801,7531515,7531513,'000',3.333,3),(801,7531516,7531513,'00c',3.333,3),(801,7531517,7531513,'0c2',3.333,3),(801,7531518,7531513,'c29',3.333,3),(801,7531519,7531513,'29d',3.333,3),(801,7531520,7531513,'9d4',3.333,3),(801,7531521,7531513,'d4d',3.333,3),(801,7531522,7531513,'4da',3.333,3),(801,7531523,7531513,'dab',3.333,3),(801,7531524,7531513,'abb',3.333,3),(801,7531525,7531513,'bb7',3.333,3),(801,7531526,7531513,'b70',3.333,3),(801,7531527,7531513,'70c',3.333,3),(801,7531528,7531513,'0c3',3.333,3),(801,7531529,7531513,'c33',3.333,3),(801,7531530,7531513,'330',3.333,3),(801,7531531,7531513,'30b',3.333,3),(801,7531532,7531513,'0bd',3.333,3),(801,7531533,7531513,'bdd',3.333,3),(801,7531534,7531513,'dd4',3.333,3),(801,7531535,7531513,'d4a',3.333,3),(801,7531536,7531513,'4a4',3.333,3),(801,7531537,7531513,'a4c',3.333,3),(801,7531538,7531513,'4c4',3.333,3),(801,7531539,7531513,'c47',3.333,3),(801,7531540,7531513,'479',3.333,3),(801,7531541,7531513,'79e',3.333,3),(801,7531542,7531513,'9e4',3.333,3),(801,7531543,7531513,'e4f',3.333,3),(801,7531544,7531514,'mon',100,1),(801,7531545,7531544,'201',50,1),(801,7531546,7531544,'013',50,1),(801,7531547,7531545,'adm',33.333,4),(801,7531548,7531545,'dmi',33.333,4),(801,7531549,7531545,'min',33.333,4),(801,7531550,7531547,'cap',16.667,1),(801,7531551,7531547,'apa',16.667,1),(801,7531552,7531547,'pac',16.667,1),(801,7531553,7531547,'aci',16.667,1),(801,7531554,7531547,'cit',16.667,1),(801,7531555,7531547,'ity',16.667,1),(801,7531556,7531550,'pat',50,1),(801,7531557,7531550,'ath',50,1),(801,7531558,7531556,'fre',14.286,1),(801,7531559,7531556,'ree',14.286,1),(801,7531560,7531556,'ees',14.286,1),(801,7531561,7531556,'esp',14.286,1),(801,7531562,7531556,'spa',14.286,1),(801,7531563,7531556,'pac',14.286,1),(801,7531564,7531556,'ace',14.286,1),(801,7531565,7531558,'dis',50,1),(801,7531566,7531558,'isk',50,1),(801,7531567,7531565,'ind',33.333,1),(801,7531568,7531565,'nde',33.333,1),(801,7531569,7531565,'dex',33.333,1),(801,7531570,7531567,'adm',8.333,1),(801,7531571,7531567,'dmi',8.333,1),(801,7531572,7531567,'min',8.333,1),(801,7531573,7531567,'ini',8.333,1),(801,7531574,7531567,'nis',8.333,1),(801,7531575,7531567,'ist',8.333,1),(801,7531576,7531567,'str',8.333,1),(801,7531577,7531567,'tra',8.333,1),(801,7531578,7531567,'rat',8.333,1),(801,7531579,7531567,'ati',8.333,1),(801,7531580,7531567,'tio',8.333,1),(801,7531581,7531567,'ion',8.333,1),(801,7531582,7531570,'sta',33.333,3),(801,7531583,7531570,'tat',33.333,3),(801,7531584,7531570,'ate',33.333,3),(801,7531585,7531582,'dis',16.667,4),(801,7531586,7531582,'isa',16.667,4),(801,7531587,7531582,'sab',16.667,4),(801,7531588,7531582,'abl',16.667,4),(801,7531589,7531582,'ble',16.667,4),(801,7531590,7531582,'led',16.667,4),(801,7531591,7531585,'cac',33.333,1),(801,7531592,7531585,'ach',33.333,1),(801,7531593,7531585,'che',33.333,1),(801,7531594,7531591,'mod',50,1),(801,7531595,7531591,'ode',50,1),(801,7531596,7531594,'wri',14.286,1),(801,7531597,7531594,'rit',14.286,1),(801,7531598,7531594,'ite',14.286,1),(801,7531599,7531594,'tet',14.286,1),(801,7531600,7531594,'eth',14.286,1),(801,7531601,7531594,'thr',14.286,1),(801,7531602,7531594,'hru',14.286,1),(801,7531603,7531596,'ope',11.111,2),(801,7531604,7531596,'per',11.111,2),(801,7531605,7531596,'era',11.111,2),(801,7531606,7531596,'rat',11.111,2),(801,7531607,7531596,'ati',11.111,2),(801,7531608,7531596,'tio',11.111,2),(801,7531609,7531596,'ion',11.111,2),(801,7531610,7531596,'ona',11.111,2),(801,7531611,7531596,'nal',11.111,2),(801,7531612,7531603,'mes',20,1),(801,7531613,7531603,'ess',20,1),(801,7531614,7531603,'ssa',20,1),(801,7531615,7531603,'sag',20,1),(801,7531616,7531603,'age',20,1),(801,7531617,7531612,'per',11.111,1),(801,7531618,7531612,'erf',11.111,1),(801,7531619,7531612,'rfo',11.111,1),(801,7531620,7531612,'for',11.111,1),(801,7531621,7531612,'orm',11.111,1),(801,7531622,7531612,'rma',11.111,1),(801,7531623,7531612,'man',11.111,1),(801,7531624,7531612,'anc',11.111,1),(801,7531625,7531612,'nce',11.111,1),(801,7531626,7531617,'ide',12.5,1),(801,7531627,7531617,'den',12.5,1),(801,7531628,7531617,'ent',12.5,1),(801,7531629,7531617,'nti',12.5,1),(801,7531630,7531617,'tif',12.5,1),(801,7531631,7531617,'ifi',12.5,1),(801,7531632,7531617,'fie',12.5,1),(801,7531633,7531617,'ier',12.5,1),(801,7531634,7531626,'vdi',33.333,3),(801,7531635,7531626,'dis',33.333,3),(801,7531636,7531626,'isk',33.333,3),(801,7531637,7531634,'nam',50,1),(801,7531638,7531634,'ame',50,1),(801,7531639,7531637,'typ',50,1),(801,7531640,7531637,'ype',50,1),(801,7531641,7531639,'dir',25,1),(801,7531642,7531639,'ire',25,1),(801,7531643,7531639,'rec',25,1),(801,7531644,7531639,'ect',25,1),(802,7531646,7531645,'naa',100,2),(802,7531647,7531646,'600',3.333,3),(802,7531648,7531646,'000',3.333,3),(802,7531649,7531646,'00c',3.333,3),(802,7531650,7531646,'0c2',3.333,3),(802,7531651,7531646,'c29',3.333,3),(802,7531652,7531646,'29b',3.333,3),(802,7531653,7531646,'9bc',3.333,3),(802,7531654,7531646,'bcf',3.333,3),(802,7531655,7531646,'cfd',3.333,3),(802,7531656,7531646,'fd9',3.333,3),(802,7531657,7531646,'d93',3.333,3),(802,7531658,7531646,'934',3.333,3),(802,7531659,7531646,'348',3.333,3),(802,7531660,7531646,'482',3.333,3),(802,7531661,7531646,'82b',3.333,3),(802,7531662,7531646,'2b6',3.333,3),(802,7531663,7531646,'b65',3.333,3),(802,7531664,7531646,'655',3.333,3),(802,7531665,7531646,'558',3.333,3),(802,7531666,7531646,'589',3.333,3),(802,7531667,7531646,'893',3.333,3),(802,7531668,7531646,'939',3.333,3),(802,7531669,7531646,'397',3.333,3),(802,7531670,7531646,'97a',3.333,3),(802,7531671,7531646,'7a6',3.333,3),(802,7531672,7531646,'a68',3.333,3),(802,7531673,7531646,'68f',3.333,3),(802,7531674,7531646,'8f5',3.333,3),(802,7531675,7531646,'f5f',3.333,3),(802,7531676,7531646,'5fb',3.333,3),(802,7531677,7531647,'mon',100,1),(802,7531678,7531677,'201',50,1),(802,7531679,7531677,'013',50,1),(802,7531680,7531678,'adm',33.333,4),(802,7531681,7531678,'dmi',33.333,4),(802,7531682,7531678,'min',33.333,4),(802,7531683,7531680,'cap',16.667,1),(802,7531684,7531680,'apa',16.667,1),(802,7531685,7531680,'pac',16.667,1),(802,7531686,7531680,'aci',16.667,1),(802,7531687,7531680,'cit',16.667,1),(802,7531688,7531680,'ity',16.667,1),(802,7531689,7531683,'pat',50,1),(802,7531690,7531683,'ath',50,1),(802,7531691,7531689,'fre',14.286,1),(802,7531692,7531689,'ree',14.286,1),(802,7531693,7531689,'ees',14.286,1),(802,7531694,7531689,'esp',14.286,1),(802,7531695,7531689,'spa',14.286,1),(802,7531696,7531689,'pac',14.286,1),(802,7531697,7531689,'ace',14.286,1),(802,7531698,7531691,'dis',50,1),(802,7531699,7531691,'isk',50,1),(802,7531700,7531698,'ind',33.333,1),(802,7531701,7531698,'nde',33.333,1),(802,7531702,7531698,'dex',33.333,1),(802,7531703,7531700,'adm',8.333,1),(802,7531704,7531700,'dmi',8.333,1),(802,7531705,7531700,'min',8.333,1),(802,7531706,7531700,'ini',8.333,1),(802,7531707,7531700,'nis',8.333,1),(802,7531708,7531700,'ist',8.333,1),(802,7531709,7531700,'str',8.333,1),(802,7531710,7531700,'tra',8.333,1),(802,7531711,7531700,'rat',8.333,1),(802,7531712,7531700,'ati',8.333,1),(802,7531713,7531700,'tio',8.333,1),(802,7531714,7531700,'ion',8.333,1),(802,7531715,7531703,'sta',33.333,3),(802,7531716,7531703,'tat',33.333,3),(802,7531717,7531703,'ate',33.333,3),(802,7531718,7531715,'dis',16.667,4),(802,7531719,7531715,'isa',16.667,4),(802,7531720,7531715,'sab',16.667,4),(802,7531721,7531715,'abl',16.667,4),(802,7531722,7531715,'ble',16.667,4),(802,7531723,7531715,'led',16.667,4),(802,7531724,7531718,'cac',33.333,1),(802,7531725,7531718,'ach',33.333,1),(802,7531726,7531718,'che',33.333,1),(802,7531727,7531724,'mod',50,1),(802,7531728,7531724,'ode',50,1),(802,7531729,7531727,'wri',14.286,1),(802,7531730,7531727,'rit',14.286,1),(802,7531731,7531727,'ite',14.286,1),(802,7531732,7531727,'tet',14.286,1),(802,7531733,7531727,'eth',14.286,1),(802,7531734,7531727,'thr',14.286,1),(802,7531735,7531727,'hru',14.286,1),(802,7531736,7531729,'ope',11.111,2),(802,7531737,7531729,'per',11.111,2),(802,7531738,7531729,'era',11.111,2),(802,7531739,7531729,'rat',11.111,2),(802,7531740,7531729,'ati',11.111,2),(802,7531741,7531729,'tio',11.111,2),(802,7531742,7531729,'ion',11.111,2),(802,7531743,7531729,'ona',11.111,2),(802,7531744,7531729,'nal',11.111,2),(802,7531745,7531736,'mes',20,1),(802,7531746,7531736,'ess',20,1),(802,7531747,7531736,'ssa',20,1),(802,7531748,7531736,'sag',20,1),(802,7531749,7531736,'age',20,1),(802,7531750,7531745,'per',11.111,1),(802,7531751,7531745,'erf',11.111,1),(802,7531752,7531745,'rfo',11.111,1),(802,7531753,7531745,'for',11.111,1),(802,7531754,7531745,'orm',11.111,1),(802,7531755,7531745,'rma',11.111,1),(802,7531756,7531745,'man',11.111,1),(802,7531757,7531745,'anc',11.111,1),(802,7531758,7531745,'nce',11.111,1),(802,7531759,7531750,'ide',12.5,1),(802,7531760,7531750,'den',12.5,1),(802,7531761,7531750,'ent',12.5,1),(802,7531762,7531750,'nti',12.5,1),(802,7531763,7531750,'tif',12.5,1),(802,7531764,7531750,'ifi',12.5,1),(802,7531765,7531750,'fie',12.5,1),(802,7531766,7531750,'ier',12.5,1),(802,7531767,7531759,'vdi',33.333,3),(802,7531768,7531759,'dis',33.333,3),(802,7531769,7531759,'isk',33.333,3),(802,7531770,7531767,'nam',50,1),(802,7531771,7531767,'ame',50,1),(802,7531772,7531770,'typ',50,1),(802,7531773,7531770,'ype',50,1),(802,7531774,7531772,'dir',25,1),(802,7531775,7531772,'ire',25,1),(802,7531776,7531772,'rec',25,1),(802,7531777,7531772,'ect',25,1),(803,7531779,7531778,'naa',100,2),(803,7531780,7531779,'600',3.333,3),(803,7531781,7531779,'000',3.333,3),(803,7531782,7531779,'00c',3.333,3),(803,7531783,7531779,'0c2',3.333,3),(803,7531784,7531779,'c29',3.333,3),(803,7531785,7531779,'296',3.333,3),(803,7531786,7531779,'96d',3.333,3),(803,7531787,7531779,'6dc',3.333,3),(803,7531788,7531779,'dcd',3.333,3),(803,7531789,7531779,'cdc',3.333,3),(803,7531790,7531779,'dc6',3.333,3),(803,7531791,7531779,'c63',3.333,3),(803,7531792,7531779,'636',3.333,3),(803,7531793,7531779,'368',3.333,3),(803,7531794,7531779,'680',3.333,3),(803,7531795,7531779,'809',3.333,3),(803,7531796,7531779,'096',3.333,3),(803,7531797,7531779,'963',3.333,3),(803,7531798,7531779,'63b',3.333,3),(803,7531799,7531779,'3ba',3.333,3),(803,7531800,7531779,'bad',3.333,3),(803,7531801,7531779,'adf',3.333,3),(803,7531802,7531779,'df9',3.333,3),(803,7531803,7531779,'f9a',3.333,3),(803,7531804,7531779,'9a2',3.333,3),(803,7531805,7531779,'a2a',3.333,3),(803,7531806,7531779,'2a5',3.333,3),(803,7531807,7531779,'a57',3.333,3),(803,7531808,7531779,'574',3.333,3),(803,7531809,7531779,'74e',3.333,3),(803,7531810,7531780,'mon',100,1),(803,7531811,7531810,'201',50,1),(803,7531812,7531810,'013',50,1),(803,7531813,7531811,'adm',33.333,4),(803,7531814,7531811,'dmi',33.333,4),(803,7531815,7531811,'min',33.333,4),(803,7531816,7531813,'cap',16.667,1),(803,7531817,7531813,'apa',16.667,1),(803,7531818,7531813,'pac',16.667,1),(803,7531819,7531813,'aci',16.667,1),(803,7531820,7531813,'cit',16.667,1),(803,7531821,7531813,'ity',16.667,1),(803,7531822,7531816,'pat',50,1),(803,7531823,7531816,'ath',50,1),(803,7531824,7531822,'fre',14.286,1),(803,7531825,7531822,'ree',14.286,1),(803,7531826,7531822,'ees',14.286,1),(803,7531827,7531822,'esp',14.286,1),(803,7531828,7531822,'spa',14.286,1),(803,7531829,7531822,'pac',14.286,1),(803,7531830,7531822,'ace',14.286,1),(803,7531831,7531824,'dis',50,1),(803,7531832,7531824,'isk',50,1),(803,7531833,7531831,'ind',33.333,1),(803,7531834,7531831,'nde',33.333,1),(803,7531835,7531831,'dex',33.333,1),(803,7531836,7531833,'adm',8.333,1),(803,7531837,7531833,'dmi',8.333,1),(803,7531838,7531833,'min',8.333,1),(803,7531839,7531833,'ini',8.333,1),(803,7531840,7531833,'nis',8.333,1),(803,7531841,7531833,'ist',8.333,1),(803,7531842,7531833,'str',8.333,1),(803,7531843,7531833,'tra',8.333,1),(803,7531844,7531833,'rat',8.333,1),(803,7531845,7531833,'ati',8.333,1),(803,7531846,7531833,'tio',8.333,1),(803,7531847,7531833,'ion',8.333,1),(803,7531848,7531836,'sta',33.333,3),(803,7531849,7531836,'tat',33.333,3),(803,7531850,7531836,'ate',33.333,3),(803,7531851,7531848,'dis',16.667,4),(803,7531852,7531848,'isa',16.667,4),(803,7531853,7531848,'sab',16.667,4),(803,7531854,7531848,'abl',16.667,4),(803,7531855,7531848,'ble',16.667,4),(803,7531856,7531848,'led',16.667,4),(803,7531857,7531851,'cac',33.333,1),(803,7531858,7531851,'ach',33.333,1),(803,7531859,7531851,'che',33.333,1),(803,7531860,7531857,'mod',50,1),(803,7531861,7531857,'ode',50,1),(803,7531862,7531860,'wri',14.286,1),(803,7531863,7531860,'rit',14.286,1),(803,7531864,7531860,'ite',14.286,1),(803,7531865,7531860,'tet',14.286,1),(803,7531866,7531860,'eth',14.286,1),(803,7531867,7531860,'thr',14.286,1),(803,7531868,7531860,'hru',14.286,1),(803,7531869,7531862,'ope',11.111,2),(803,7531870,7531862,'per',11.111,2),(803,7531871,7531862,'era',11.111,2),(803,7531872,7531862,'rat',11.111,2),(803,7531873,7531862,'ati',11.111,2),(803,7531874,7531862,'tio',11.111,2),(803,7531875,7531862,'ion',11.111,2),(803,7531876,7531862,'ona',11.111,2),(803,7531877,7531862,'nal',11.111,2),(803,7531878,7531869,'mes',20,1),(803,7531879,7531869,'ess',20,1),(803,7531880,7531869,'ssa',20,1),(803,7531881,7531869,'sag',20,1),(803,7531882,7531869,'age',20,1),(803,7531883,7531878,'per',11.111,1),(803,7531884,7531878,'erf',11.111,1),(803,7531885,7531878,'rfo',11.111,1),(803,7531886,7531878,'for',11.111,1),(803,7531887,7531878,'orm',11.111,1),(803,7531888,7531878,'rma',11.111,1),(803,7531889,7531878,'man',11.111,1),(803,7531890,7531878,'anc',11.111,1),(803,7531891,7531878,'nce',11.111,1),(803,7531892,7531883,'ide',12.5,1),(803,7531893,7531883,'den',12.5,1),(803,7531894,7531883,'ent',12.5,1),(803,7531895,7531883,'nti',12.5,1),(803,7531896,7531883,'tif',12.5,1),(803,7531897,7531883,'ifi',12.5,1),(803,7531898,7531883,'fie',12.5,1),(803,7531899,7531883,'ier',12.5,1),(803,7531900,7531892,'vdi',33.333,3),(803,7531901,7531892,'dis',33.333,3),(803,7531902,7531892,'isk',33.333,3),(803,7531903,7531900,'nam',50,1),(803,7531904,7531900,'ame',50,1),(803,7531905,7531903,'typ',50,1),(803,7531906,7531903,'ype',50,1),(803,7531907,7531905,'dir',25,1),(803,7531908,7531905,'ire',25,1),(803,7531909,7531905,'rec',25,1),(803,7531910,7531905,'ect',25,1),(804,7531912,7531911,'naa',100,2),(804,7531913,7531912,'600',3.333,3),(804,7531914,7531912,'000',3.333,3),(804,7531915,7531912,'00c',3.333,3),(804,7531916,7531912,'0c2',3.333,3),(804,7531917,7531912,'c29',3.333,3),(804,7531918,7531912,'29d',3.333,3),(804,7531919,7531912,'9dd',3.333,3),(804,7531920,7531912,'dd8',3.333,3),(804,7531921,7531912,'d89',3.333,3),(804,7531922,7531912,'89a',3.333,3),(804,7531923,7531912,'9a0',3.333,3),(804,7531924,7531912,'a0d',3.333,3),(804,7531925,7531912,'0d9',3.333,3),(804,7531926,7531912,'d9d',3.333,3),(804,7531927,7531912,'9db',3.333,3),(804,7531928,7531912,'db7',3.333,3),(804,7531929,7531912,'b72',3.333,3),(804,7531930,7531912,'721',3.333,3),(804,7531931,7531912,'210',3.333,3),(804,7531932,7531912,'104',3.333,3),(804,7531933,7531912,'04e',3.333,3),(804,7531934,7531912,'4ef',3.333,3),(804,7531935,7531912,'ef5',3.333,3),(804,7531936,7531912,'f5b',3.333,3),(804,7531937,7531912,'5b4',3.333,3),(804,7531938,7531912,'b40',3.333,3),(804,7531939,7531912,'40a',3.333,3),(804,7531940,7531912,'0ad',3.333,3),(804,7531941,7531912,'ad6',3.333,3),(804,7531942,7531912,'d66',3.333,3),(804,7531943,7531913,'mon',100,1),(804,7531944,7531943,'201',50,1),(804,7531945,7531943,'013',50,1),(804,7531946,7531944,'adm',33.333,4),(804,7531947,7531944,'dmi',33.333,4),(804,7531948,7531944,'min',33.333,4),(804,7531949,7531946,'cap',16.667,1),(804,7531950,7531946,'apa',16.667,1),(804,7531951,7531946,'pac',16.667,1),(804,7531952,7531946,'aci',16.667,1),(804,7531953,7531946,'cit',16.667,1),(804,7531954,7531946,'ity',16.667,1),(804,7531955,7531949,'pat',50,1),(804,7531956,7531949,'ath',50,1),(804,7531957,7531955,'fre',14.286,1),(804,7531958,7531955,'ree',14.286,1),(804,7531959,7531955,'ees',14.286,1),(804,7531960,7531955,'esp',14.286,1),(804,7531961,7531955,'spa',14.286,1),(804,7531962,7531955,'pac',14.286,1),(804,7531963,7531955,'ace',14.286,1),(804,7531964,7531957,'dis',50,1),(804,7531965,7531957,'isk',50,1),(804,7531966,7531964,'ind',33.333,1),(804,7531967,7531964,'nde',33.333,1),(804,7531968,7531964,'dex',33.333,1),(804,7531969,7531966,'adm',8.333,1),(804,7531970,7531966,'dmi',8.333,1),(804,7531971,7531966,'min',8.333,1),(804,7531972,7531966,'ini',8.333,1),(804,7531973,7531966,'nis',8.333,1),(804,7531974,7531966,'ist',8.333,1),(804,7531975,7531966,'str',8.333,1),(804,7531976,7531966,'tra',8.333,1),(804,7531977,7531966,'rat',8.333,1),(804,7531978,7531966,'ati',8.333,1),(804,7531979,7531966,'tio',8.333,1),(804,7531980,7531966,'ion',8.333,1),(804,7531981,7531969,'sta',33.333,3),(804,7531982,7531969,'tat',33.333,3),(804,7531983,7531969,'ate',33.333,3),(804,7531984,7531981,'dis',16.667,4),(804,7531985,7531981,'isa',16.667,4),(804,7531986,7531981,'sab',16.667,4),(804,7531987,7531981,'abl',16.667,4),(804,7531988,7531981,'ble',16.667,4),(804,7531989,7531981,'led',16.667,4),(804,7531990,7531984,'cac',33.333,1),(804,7531991,7531984,'ach',33.333,1),(804,7531992,7531984,'che',33.333,1),(804,7531993,7531990,'mod',50,1),(804,7531994,7531990,'ode',50,1),(804,7531995,7531993,'wri',14.286,1),(804,7531996,7531993,'rit',14.286,1),(804,7531997,7531993,'ite',14.286,1),(804,7531998,7531993,'tet',14.286,1),(804,7531999,7531993,'eth',14.286,1),(804,7532000,7531993,'thr',14.286,1),(804,7532001,7531993,'hru',14.286,1),(804,7532002,7531995,'ope',11.111,2),(804,7532003,7531995,'per',11.111,2),(804,7532004,7531995,'era',11.111,2),(804,7532005,7531995,'rat',11.111,2),(804,7532006,7531995,'ati',11.111,2),(804,7532007,7531995,'tio',11.111,2),(804,7532008,7531995,'ion',11.111,2),(804,7532009,7531995,'ona',11.111,2),(804,7532010,7531995,'nal',11.111,2),(804,7532011,7532002,'mes',20,1),(804,7532012,7532002,'ess',20,1),(804,7532013,7532002,'ssa',20,1),(804,7532014,7532002,'sag',20,1),(804,7532015,7532002,'age',20,1),(804,7532016,7532011,'per',11.111,1),(804,7532017,7532011,'erf',11.111,1),(804,7532018,7532011,'rfo',11.111,1),(804,7532019,7532011,'for',11.111,1),(804,7532020,7532011,'orm',11.111,1),(804,7532021,7532011,'rma',11.111,1),(804,7532022,7532011,'man',11.111,1),(804,7532023,7532011,'anc',11.111,1),(804,7532024,7532011,'nce',11.111,1),(804,7532025,7532016,'ide',12.5,1),(804,7532026,7532016,'den',12.5,1),(804,7532027,7532016,'ent',12.5,1),(804,7532028,7532016,'nti',12.5,1),(804,7532029,7532016,'tif',12.5,1),(804,7532030,7532016,'ifi',12.5,1),(804,7532031,7532016,'fie',12.5,1),(804,7532032,7532016,'ier',12.5,1),(804,7532033,7532025,'vdi',33.333,3),(804,7532034,7532025,'dis',33.333,3),(804,7532035,7532025,'isk',33.333,3),(804,7532036,7532033,'nam',50,1),(804,7532037,7532033,'ame',50,1),(804,7532038,7532036,'typ',50,1),(804,7532039,7532036,'ype',50,1),(804,7532040,7532038,'dir',25,1),(804,7532041,7532038,'ire',25,1),(804,7532042,7532038,'rec',25,1),(804,7532043,7532038,'ect',25,1),(805,7532045,7532044,'naa',100,2),(805,7532046,7532045,'600',3.333,3),(805,7532047,7532045,'000',3.333,3),(805,7532048,7532045,'00c',3.333,3),(805,7532049,7532045,'0c2',3.333,3),(805,7532050,7532045,'c29',3.333,3),(805,7532051,7532045,'291',3.333,3),(805,7532052,7532045,'913',3.333,3),(805,7532053,7532045,'132',3.333,3),(805,7532054,7532045,'327',3.333,3),(805,7532055,7532045,'27d',3.333,3),(805,7532056,7532045,'7d9',3.333,3),(805,7532057,7532045,'d90',3.333,3),(805,7532058,7532045,'908',3.333,3),(805,7532059,7532045,'08b',3.333,3),(805,7532060,7532045,'8b9',3.333,3),(805,7532061,7532045,'b97',3.333,3),(805,7532062,7532045,'97d',3.333,3),(805,7532063,7532045,'7df',3.333,3),(805,7532064,7532045,'dff',3.333,3),(805,7532065,7532045,'ff3',3.333,3),(805,7532066,7532045,'f3d',3.333,3),(805,7532067,7532045,'3dd',3.333,3),(805,7532068,7532045,'ddc',3.333,3),(805,7532069,7532045,'dc2',3.333,3),(805,7532070,7532045,'c2a',3.333,3),(805,7532071,7532045,'2a0',3.333,3),(805,7532072,7532045,'a07',3.333,3),(805,7532073,7532045,'071',3.333,3),(805,7532074,7532045,'712',3.333,3),(805,7532075,7532045,'120',3.333,3),(805,7532076,7532046,'mon',100,1),(805,7532077,7532076,'201',50,1),(805,7532078,7532076,'013',50,1),(805,7532079,7532077,'adm',33.333,4),(805,7532080,7532077,'dmi',33.333,4),(805,7532081,7532077,'min',33.333,4),(805,7532082,7532079,'cap',16.667,1),(805,7532083,7532079,'apa',16.667,1),(805,7532084,7532079,'pac',16.667,1),(805,7532085,7532079,'aci',16.667,1),(805,7532086,7532079,'cit',16.667,1),(805,7532087,7532079,'ity',16.667,1),(805,7532088,7532082,'pat',50,1),(805,7532089,7532082,'ath',50,1),(805,7532090,7532088,'fre',14.286,1),(805,7532091,7532088,'ree',14.286,1),(805,7532092,7532088,'ees',14.286,1),(805,7532093,7532088,'esp',14.286,1),(805,7532094,7532088,'spa',14.286,1),(805,7532095,7532088,'pac',14.286,1),(805,7532096,7532088,'ace',14.286,1),(805,7532097,7532090,'dis',50,1),(805,7532098,7532090,'isk',50,1),(805,7532099,7532097,'ind',33.333,1),(805,7532100,7532097,'nde',33.333,1),(805,7532101,7532097,'dex',33.333,1),(805,7532102,7532099,'adm',8.333,1),(805,7532103,7532099,'dmi',8.333,1),(805,7532104,7532099,'min',8.333,1),(805,7532105,7532099,'ini',8.333,1),(805,7532106,7532099,'nis',8.333,1),(805,7532107,7532099,'ist',8.333,1),(805,7532108,7532099,'str',8.333,1),(805,7532109,7532099,'tra',8.333,1),(805,7532110,7532099,'rat',8.333,1),(805,7532111,7532099,'ati',8.333,1),(805,7532112,7532099,'tio',8.333,1),(805,7532113,7532099,'ion',8.333,1),(805,7532114,7532102,'sta',33.333,3),(805,7532115,7532102,'tat',33.333,3),(805,7532116,7532102,'ate',33.333,3),(805,7532117,7532114,'dis',16.667,4),(805,7532118,7532114,'isa',16.667,4),(805,7532119,7532114,'sab',16.667,4),(805,7532120,7532114,'abl',16.667,4),(805,7532121,7532114,'ble',16.667,4),(805,7532122,7532114,'led',16.667,4),(805,7532123,7532117,'cac',33.333,1),(805,7532124,7532117,'ach',33.333,1),(805,7532125,7532117,'che',33.333,1),(805,7532126,7532123,'mod',50,1),(805,7532127,7532123,'ode',50,1),(805,7532128,7532126,'wri',14.286,1),(805,7532129,7532126,'rit',14.286,1),(805,7532130,7532126,'ite',14.286,1),(805,7532131,7532126,'tet',14.286,1),(805,7532132,7532126,'eth',14.286,1),(805,7532133,7532126,'thr',14.286,1),(805,7532134,7532126,'hru',14.286,1),(805,7532135,7532128,'ope',11.111,2),(805,7532136,7532128,'per',11.111,2),(805,7532137,7532128,'era',11.111,2),(805,7532138,7532128,'rat',11.111,2),(805,7532139,7532128,'ati',11.111,2),(805,7532140,7532128,'tio',11.111,2),(805,7532141,7532128,'ion',11.111,2),(805,7532142,7532128,'ona',11.111,2),(805,7532143,7532128,'nal',11.111,2),(805,7532144,7532135,'mes',20,1),(805,7532145,7532135,'ess',20,1),(805,7532146,7532135,'ssa',20,1),(805,7532147,7532135,'sag',20,1),(805,7532148,7532135,'age',20,1),(805,7532149,7532144,'per',11.111,1),(805,7532150,7532144,'erf',11.111,1),(805,7532151,7532144,'rfo',11.111,1),(805,7532152,7532144,'for',11.111,1),(805,7532153,7532144,'orm',11.111,1),(805,7532154,7532144,'rma',11.111,1),(805,7532155,7532144,'man',11.111,1),(805,7532156,7532144,'anc',11.111,1),(805,7532157,7532144,'nce',11.111,1),(805,7532158,7532149,'ide',12.5,1),(805,7532159,7532149,'den',12.5,1),(805,7532160,7532149,'ent',12.5,1),(805,7532161,7532149,'nti',12.5,1),(805,7532162,7532149,'tif',12.5,1),(805,7532163,7532149,'ifi',12.5,1),(805,7532164,7532149,'fie',12.5,1),(805,7532165,7532149,'ier',12.5,1),(805,7532166,7532158,'vdi',33.333,3),(805,7532167,7532158,'dis',33.333,3),(805,7532168,7532158,'isk',33.333,3),(805,7532169,7532166,'nam',50,1),(805,7532170,7532166,'ame',50,1),(805,7532171,7532169,'typ',50,1),(805,7532172,7532169,'ype',50,1),(805,7532173,7532171,'dir',25,1),(805,7532174,7532171,'ire',25,1),(805,7532175,7532171,'rec',25,1),(805,7532176,7532171,'ect',25,1),(806,7532178,7532177,'naa',100,2),(806,7532179,7532178,'600',3.333,3),(806,7532180,7532178,'000',3.333,3),(806,7532181,7532178,'00c',3.333,3),(806,7532182,7532178,'0c2',3.333,3),(806,7532183,7532178,'c29',3.333,3),(806,7532184,7532178,'295',3.333,3),(806,7532185,7532178,'952',3.333,3),(806,7532186,7532178,'52e',3.333,3),(806,7532187,7532178,'2e5',3.333,3),(806,7532188,7532178,'e55',3.333,3),(806,7532189,7532178,'552',3.333,3),(806,7532190,7532178,'524',3.333,3),(806,7532191,7532178,'242',3.333,3),(806,7532192,7532178,'426',3.333,3),(806,7532193,7532178,'26e',3.333,3),(806,7532194,7532178,'6e7',3.333,3),(806,7532195,7532178,'e7a',3.333,3),(806,7532196,7532178,'7a0',3.333,3),(806,7532197,7532178,'a07',3.333,3),(806,7532198,7532178,'073',3.333,3),(806,7532199,7532178,'737',3.333,3),(806,7532200,7532178,'379',3.333,3),(806,7532201,7532178,'79e',3.333,3),(806,7532202,7532178,'9ee',3.333,3),(806,7532203,7532178,'ee4',3.333,3),(806,7532204,7532178,'e4b',3.333,3),(806,7532205,7532178,'4bd',3.333,3),(806,7532206,7532178,'bd6',3.333,3),(806,7532207,7532178,'d61',3.333,3),(806,7532208,7532178,'61a',3.333,3),(806,7532209,7532179,'mon',100,1),(806,7532210,7532209,'201',50,1),(806,7532211,7532209,'013',50,1),(806,7532212,7532210,'adm',33.333,4),(806,7532213,7532210,'dmi',33.333,4),(806,7532214,7532210,'min',33.333,4),(806,7532215,7532212,'cap',16.667,1),(806,7532216,7532212,'apa',16.667,1),(806,7532217,7532212,'pac',16.667,1),(806,7532218,7532212,'aci',16.667,1),(806,7532219,7532212,'cit',16.667,1),(806,7532220,7532212,'ity',16.667,1),(806,7532221,7532215,'pat',50,1),(806,7532222,7532215,'ath',50,1),(806,7532223,7532221,'fre',14.286,1),(806,7532224,7532221,'ree',14.286,1),(806,7532225,7532221,'ees',14.286,1),(806,7532226,7532221,'esp',14.286,1),(806,7532227,7532221,'spa',14.286,1),(806,7532228,7532221,'pac',14.286,1),(806,7532229,7532221,'ace',14.286,1),(806,7532230,7532223,'dis',50,1),(806,7532231,7532223,'isk',50,1),(806,7532232,7532230,'ind',33.333,1),(806,7532233,7532230,'nde',33.333,1),(806,7532234,7532230,'dex',33.333,1),(806,7532235,7532232,'adm',8.333,1),(806,7532236,7532232,'dmi',8.333,1),(806,7532237,7532232,'min',8.333,1),(806,7532238,7532232,'ini',8.333,1),(806,7532239,7532232,'nis',8.333,1),(806,7532240,7532232,'ist',8.333,1),(806,7532241,7532232,'str',8.333,1),(806,7532242,7532232,'tra',8.333,1),(806,7532243,7532232,'rat',8.333,1),(806,7532244,7532232,'ati',8.333,1),(806,7532245,7532232,'tio',8.333,1),(806,7532246,7532232,'ion',8.333,1),(806,7532247,7532235,'sta',33.333,3),(806,7532248,7532235,'tat',33.333,3),(806,7532249,7532235,'ate',33.333,3),(806,7532250,7532247,'dis',16.667,4),(806,7532251,7532247,'isa',16.667,4),(806,7532252,7532247,'sab',16.667,4),(806,7532253,7532247,'abl',16.667,4),(806,7532254,7532247,'ble',16.667,4),(806,7532255,7532247,'led',16.667,4),(806,7532256,7532250,'cac',33.333,1),(806,7532257,7532250,'ach',33.333,1),(806,7532258,7532250,'che',33.333,1),(806,7532259,7532256,'mod',50,1),(806,7532260,7532256,'ode',50,1),(806,7532261,7532259,'wri',14.286,1),(806,7532262,7532259,'rit',14.286,1),(806,7532263,7532259,'ite',14.286,1),(806,7532264,7532259,'tet',14.286,1),(806,7532265,7532259,'eth',14.286,1),(806,7532266,7532259,'thr',14.286,1),(806,7532267,7532259,'hru',14.286,1),(806,7532268,7532261,'ope',11.111,2),(806,7532269,7532261,'per',11.111,2),(806,7532270,7532261,'era',11.111,2),(806,7532271,7532261,'rat',11.111,2),(806,7532272,7532261,'ati',11.111,2),(806,7532273,7532261,'tio',11.111,2),(806,7532274,7532261,'ion',11.111,2),(806,7532275,7532261,'ona',11.111,2),(806,7532276,7532261,'nal',11.111,2),(806,7532277,7532268,'mes',20,1),(806,7532278,7532268,'ess',20,1),(806,7532279,7532268,'ssa',20,1),(806,7532280,7532268,'sag',20,1),(806,7532281,7532268,'age',20,1),(806,7532282,7532277,'per',11.111,1),(806,7532283,7532277,'erf',11.111,1),(806,7532284,7532277,'rfo',11.111,1),(806,7532285,7532277,'for',11.111,1),(806,7532286,7532277,'orm',11.111,1),(806,7532287,7532277,'rma',11.111,1),(806,7532288,7532277,'man',11.111,1),(806,7532289,7532277,'anc',11.111,1),(806,7532290,7532277,'nce',11.111,1),(806,7532291,7532282,'ide',12.5,1),(806,7532292,7532282,'den',12.5,1),(806,7532293,7532282,'ent',12.5,1),(806,7532294,7532282,'nti',12.5,1),(806,7532295,7532282,'tif',12.5,1),(806,7532296,7532282,'ifi',12.5,1),(806,7532297,7532282,'fie',12.5,1),(806,7532298,7532282,'ier',12.5,1),(806,7532299,7532291,'vdi',33.333,3),(806,7532300,7532291,'dis',33.333,3),(806,7532301,7532291,'isk',33.333,3),(806,7532302,7532299,'nam',50,1),(806,7532303,7532299,'ame',50,1),(806,7532304,7532302,'typ',50,1),(806,7532305,7532302,'ype',50,1),(806,7532306,7532304,'dir',25,1),(806,7532307,7532304,'ire',25,1),(806,7532308,7532304,'rec',25,1),(806,7532309,7532304,'ect',25,1),(807,7532311,7532310,'naa',100,2),(807,7532312,7532311,'600',3.333,3),(807,7532313,7532311,'000',3.333,3),(807,7532314,7532311,'00c',3.333,3),(807,7532315,7532311,'0c2',3.333,3),(807,7532316,7532311,'c29',3.333,3),(807,7532317,7532311,'294',3.333,3),(807,7532318,7532311,'94c',3.333,3),(807,7532319,7532311,'4c3',3.333,3),(807,7532320,7532311,'c36',3.333,3),(807,7532321,7532311,'368',3.333,3),(807,7532322,7532311,'685',3.333,3),(807,7532323,7532311,'852',3.333,3),(807,7532324,7532311,'524',3.333,3),(807,7532325,7532311,'247',3.333,3),(807,7532326,7532311,'47d',3.333,3),(807,7532327,7532311,'7d2',3.333,3),(807,7532328,7532311,'d27',3.333,3),(807,7532329,7532311,'273',3.333,3),(807,7532330,7532311,'735',3.333,3),(807,7532331,7532311,'351',3.333,3),(807,7532332,7532311,'51f',3.333,3),(807,7532333,7532311,'1f7',3.333,3),(807,7532334,7532311,'f7c',3.333,3),(807,7532335,7532311,'7c0',3.333,3),(807,7532336,7532311,'c0d',3.333,3),(807,7532337,7532311,'0d9',3.333,3),(807,7532338,7532311,'d95',3.333,3),(807,7532339,7532311,'95c',3.333,3),(807,7532340,7532311,'5c7',3.333,3),(807,7532341,7532311,'c72',3.333,3),(807,7532342,7532312,'mon',100,1),(807,7532343,7532342,'201',50,1),(807,7532344,7532342,'013',50,1),(807,7532345,7532343,'adm',33.333,4),(807,7532346,7532343,'dmi',33.333,4),(807,7532347,7532343,'min',33.333,4),(807,7532348,7532345,'cap',16.667,1),(807,7532349,7532345,'apa',16.667,1),(807,7532350,7532345,'pac',16.667,1),(807,7532351,7532345,'aci',16.667,1),(807,7532352,7532345,'cit',16.667,1),(807,7532353,7532345,'ity',16.667,1),(807,7532354,7532348,'pat',50,1),(807,7532355,7532348,'ath',50,1),(807,7532356,7532354,'fre',14.286,1),(807,7532357,7532354,'ree',14.286,1),(807,7532358,7532354,'ees',14.286,1),(807,7532359,7532354,'esp',14.286,1),(807,7532360,7532354,'spa',14.286,1),(807,7532361,7532354,'pac',14.286,1),(807,7532362,7532354,'ace',14.286,1),(807,7532363,7532356,'dis',50,1),(807,7532364,7532356,'isk',50,1),(807,7532365,7532363,'ind',33.333,1),(807,7532366,7532363,'nde',33.333,1),(807,7532367,7532363,'dex',33.333,1),(807,7532368,7532365,'adm',8.333,1),(807,7532369,7532365,'dmi',8.333,1),(807,7532370,7532365,'min',8.333,1),(807,7532371,7532365,'ini',8.333,1),(807,7532372,7532365,'nis',8.333,1),(807,7532373,7532365,'ist',8.333,1),(807,7532374,7532365,'str',8.333,1),(807,7532375,7532365,'tra',8.333,1),(807,7532376,7532365,'rat',8.333,1),(807,7532377,7532365,'ati',8.333,1),(807,7532378,7532365,'tio',8.333,1),(807,7532379,7532365,'ion',8.333,1),(807,7532380,7532368,'sta',33.333,3),(807,7532381,7532368,'tat',33.333,3),(807,7532382,7532368,'ate',33.333,3),(807,7532383,7532380,'dis',16.667,4),(807,7532384,7532380,'isa',16.667,4),(807,7532385,7532380,'sab',16.667,4),(807,7532386,7532380,'abl',16.667,4),(807,7532387,7532380,'ble',16.667,4),(807,7532388,7532380,'led',16.667,4),(807,7532389,7532383,'cac',33.333,1),(807,7532390,7532383,'ach',33.333,1),(807,7532391,7532383,'che',33.333,1),(807,7532392,7532389,'mod',50,1),(807,7532393,7532389,'ode',50,1),(807,7532394,7532392,'wri',14.286,1),(807,7532395,7532392,'rit',14.286,1),(807,7532396,7532392,'ite',14.286,1),(807,7532397,7532392,'tet',14.286,1),(807,7532398,7532392,'eth',14.286,1),(807,7532399,7532392,'thr',14.286,1),(807,7532400,7532392,'hru',14.286,1),(807,7532401,7532394,'ope',11.111,2),(807,7532402,7532394,'per',11.111,2),(807,7532403,7532394,'era',11.111,2),(807,7532404,7532394,'rat',11.111,2),(807,7532405,7532394,'ati',11.111,2),(807,7532406,7532394,'tio',11.111,2),(807,7532407,7532394,'ion',11.111,2),(807,7532408,7532394,'ona',11.111,2),(807,7532409,7532394,'nal',11.111,2),(807,7532410,7532401,'mes',20,1),(807,7532411,7532401,'ess',20,1),(807,7532412,7532401,'ssa',20,1),(807,7532413,7532401,'sag',20,1),(807,7532414,7532401,'age',20,1),(807,7532415,7532410,'per',11.111,1),(807,7532416,7532410,'erf',11.111,1),(807,7532417,7532410,'rfo',11.111,1),(807,7532418,7532410,'for',11.111,1),(807,7532419,7532410,'orm',11.111,1),(807,7532420,7532410,'rma',11.111,1),(807,7532421,7532410,'man',11.111,1),(807,7532422,7532410,'anc',11.111,1),(807,7532423,7532410,'nce',11.111,1),(807,7532424,7532415,'ide',12.5,1),(807,7532425,7532415,'den',12.5,1),(807,7532426,7532415,'ent',12.5,1),(807,7532427,7532415,'nti',12.5,1),(807,7532428,7532415,'tif',12.5,1),(807,7532429,7532415,'ifi',12.5,1),(807,7532430,7532415,'fie',12.5,1),(807,7532431,7532415,'ier',12.5,1),(807,7532432,7532424,'vdi',33.333,3),(807,7532433,7532424,'dis',33.333,3),(807,7532434,7532424,'isk',33.333,3),(807,7532435,7532432,'nam',50,1),(807,7532436,7532432,'ame',50,1),(807,7532437,7532435,'typ',50,1),(807,7532438,7532435,'ype',50,1),(807,7532439,7532437,'dir',25,1),(807,7532440,7532437,'ire',25,1),(807,7532441,7532437,'rec',25,1),(807,7532442,7532437,'ect',25,1),(808,7532444,7532443,'naa',100,2),(808,7532445,7532444,'600',3.333,3),(808,7532446,7532444,'000',3.333,3),(808,7532447,7532444,'00c',3.333,3),(808,7532448,7532444,'0c2',3.333,3),(808,7532449,7532444,'c29',3.333,3),(808,7532450,7532444,'297',3.333,3),(808,7532451,7532444,'973',3.333,3),(808,7532452,7532444,'73f',3.333,3),(808,7532453,7532444,'3f0',3.333,3),(808,7532454,7532444,'f01',3.333,3),(808,7532455,7532444,'019',3.333,3),(808,7532456,7532444,'19f',3.333,3),(808,7532457,7532444,'9fa',3.333,3),(808,7532458,7532444,'fab',3.333,3),(808,7532459,7532444,'ab5',3.333,3),(808,7532460,7532444,'b5f',3.333,3),(808,7532461,7532444,'5fc',3.333,3),(808,7532462,7532444,'fc7',3.333,3),(808,7532463,7532444,'c73',3.333,3),(808,7532464,7532444,'734',3.333,3),(808,7532465,7532444,'349',3.333,3),(808,7532466,7532444,'49d',3.333,3),(808,7532467,7532444,'9d6',3.333,3),(808,7532468,7532444,'d65',3.333,3),(808,7532469,7532444,'651',3.333,3),(808,7532470,7532444,'518',3.333,3),(808,7532471,7532444,'18a',3.333,3),(808,7532472,7532444,'8af',3.333,3),(808,7532473,7532444,'afd',3.333,3),(808,7532474,7532444,'fd1',3.333,3),(808,7532475,7532445,'mon',100,1),(808,7532476,7532475,'201',50,1),(808,7532477,7532475,'013',50,1),(808,7532478,7532476,'adm',33.333,4),(808,7532479,7532476,'dmi',33.333,4),(808,7532480,7532476,'min',33.333,4),(808,7532481,7532478,'cap',16.667,1),(808,7532482,7532478,'apa',16.667,1),(808,7532483,7532478,'pac',16.667,1),(808,7532484,7532478,'aci',16.667,1),(808,7532485,7532478,'cit',16.667,1),(808,7532486,7532478,'ity',16.667,1),(808,7532487,7532481,'pat',50,1),(808,7532488,7532481,'ath',50,1),(808,7532489,7532487,'fre',14.286,1),(808,7532490,7532487,'ree',14.286,1),(808,7532491,7532487,'ees',14.286,1),(808,7532492,7532487,'esp',14.286,1),(808,7532493,7532487,'spa',14.286,1),(808,7532494,7532487,'pac',14.286,1),(808,7532495,7532487,'ace',14.286,1),(808,7532496,7532489,'dis',50,1),(808,7532497,7532489,'isk',50,1),(808,7532498,7532496,'ind',33.333,1),(808,7532499,7532496,'nde',33.333,1),(808,7532500,7532496,'dex',33.333,1),(808,7532501,7532498,'adm',8.333,1),(808,7532502,7532498,'dmi',8.333,1),(808,7532503,7532498,'min',8.333,1),(808,7532504,7532498,'ini',8.333,1),(808,7532505,7532498,'nis',8.333,1),(808,7532506,7532498,'ist',8.333,1),(808,7532507,7532498,'str',8.333,1),(808,7532508,7532498,'tra',8.333,1),(808,7532509,7532498,'rat',8.333,1),(808,7532510,7532498,'ati',8.333,1),(808,7532511,7532498,'tio',8.333,1),(808,7532512,7532498,'ion',8.333,1),(808,7532513,7532501,'sta',33.333,3),(808,7532514,7532501,'tat',33.333,3),(808,7532515,7532501,'ate',33.333,3),(808,7532516,7532513,'dis',16.667,4),(808,7532517,7532513,'isa',16.667,4),(808,7532518,7532513,'sab',16.667,4),(808,7532519,7532513,'abl',16.667,4),(808,7532520,7532513,'ble',16.667,4),(808,7532521,7532513,'led',16.667,4),(808,7532522,7532516,'cac',33.333,1),(808,7532523,7532516,'ach',33.333,1),(808,7532524,7532516,'che',33.333,1),(808,7532525,7532522,'mod',50,1),(808,7532526,7532522,'ode',50,1),(808,7532527,7532525,'wri',14.286,1),(808,7532528,7532525,'rit',14.286,1),(808,7532529,7532525,'ite',14.286,1),(808,7532530,7532525,'tet',14.286,1),(808,7532531,7532525,'eth',14.286,1),(808,7532532,7532525,'thr',14.286,1),(808,7532533,7532525,'hru',14.286,1),(808,7532534,7532527,'ope',11.111,2),(808,7532535,7532527,'per',11.111,2),(808,7532536,7532527,'era',11.111,2),(808,7532537,7532527,'rat',11.111,2),(808,7532538,7532527,'ati',11.111,2),(808,7532539,7532527,'tio',11.111,2),(808,7532540,7532527,'ion',11.111,2),(808,7532541,7532527,'ona',11.111,2),(808,7532542,7532527,'nal',11.111,2),(808,7532543,7532534,'mes',20,1),(808,7532544,7532534,'ess',20,1),(808,7532545,7532534,'ssa',20,1),(808,7532546,7532534,'sag',20,1),(808,7532547,7532534,'age',20,1),(808,7532548,7532543,'per',11.111,1),(808,7532549,7532543,'erf',11.111,1),(808,7532550,7532543,'rfo',11.111,1),(808,7532551,7532543,'for',11.111,1),(808,7532552,7532543,'orm',11.111,1),(808,7532553,7532543,'rma',11.111,1),(808,7532554,7532543,'man',11.111,1),(808,7532555,7532543,'anc',11.111,1),(808,7532556,7532543,'nce',11.111,1),(808,7532557,7532548,'ide',12.5,1),(808,7532558,7532548,'den',12.5,1),(808,7532559,7532548,'ent',12.5,1),(808,7532560,7532548,'nti',12.5,1),(808,7532561,7532548,'tif',12.5,1),(808,7532562,7532548,'ifi',12.5,1),(808,7532563,7532548,'fie',12.5,1),(808,7532564,7532548,'ier',12.5,1),(808,7532565,7532557,'vdi',33.333,3),(808,7532566,7532557,'dis',33.333,3),(808,7532567,7532557,'isk',33.333,3),(808,7532568,7532565,'nam',50,1),(808,7532569,7532565,'ame',50,1),(808,7532570,7532568,'typ',50,1),(808,7532571,7532568,'ype',50,1),(808,7532572,7532570,'dir',25,1),(808,7532573,7532570,'ire',25,1),(808,7532574,7532570,'rec',25,1),(808,7532575,7532570,'ect',25,1),(809,7532577,7532576,'naa',100,2),(809,7532578,7532577,'600',3.333,3),(809,7532579,7532577,'000',3.333,3),(809,7532580,7532577,'00c',3.333,3),(809,7532581,7532577,'0c2',3.333,3),(809,7532582,7532577,'c29',3.333,3),(809,7532583,7532577,'296',3.333,3),(809,7532584,7532577,'967',3.333,3),(809,7532585,7532577,'67c',3.333,3),(809,7532586,7532577,'7c9',3.333,3),(809,7532587,7532577,'c9b',3.333,3),(809,7532588,7532577,'9b9',3.333,3),(809,7532589,7532577,'b9d',3.333,3),(809,7532590,7532577,'9dd',3.333,3),(809,7532591,7532577,'dd9',3.333,3),(809,7532592,7532577,'d92',3.333,3),(809,7532593,7532577,'929',3.333,3),(809,7532594,7532577,'29c',3.333,3),(809,7532595,7532577,'9cd',3.333,3),(809,7532596,7532577,'cd3',3.333,3),(809,7532597,7532577,'d31',3.333,3),(809,7532598,7532577,'319',3.333,3),(809,7532599,7532577,'197',3.333,3),(809,7532600,7532577,'973',3.333,3),(809,7532601,7532577,'73a',3.333,3),(809,7532602,7532577,'3a2',3.333,3),(809,7532603,7532577,'a2e',3.333,3),(809,7532604,7532577,'2e7',3.333,3),(809,7532605,7532577,'e75',3.333,3),(809,7532606,7532577,'753',3.333,3),(809,7532607,7532577,'53a',3.333,3),(809,7532608,7532578,'mon',100,1),(809,7532609,7532608,'201',50,1),(809,7532610,7532608,'013',50,1),(809,7532611,7532609,'adm',33.333,4),(809,7532612,7532609,'dmi',33.333,4),(809,7532613,7532609,'min',33.333,4),(809,7532614,7532611,'cap',16.667,1),(809,7532615,7532611,'apa',16.667,1),(809,7532616,7532611,'pac',16.667,1),(809,7532617,7532611,'aci',16.667,1),(809,7532618,7532611,'cit',16.667,1),(809,7532619,7532611,'ity',16.667,1),(809,7532620,7532614,'pat',50,1),(809,7532621,7532614,'ath',50,1),(809,7532622,7532620,'fre',14.286,1),(809,7532623,7532620,'ree',14.286,1),(809,7532624,7532620,'ees',14.286,1),(809,7532625,7532620,'esp',14.286,1),(809,7532626,7532620,'spa',14.286,1),(809,7532627,7532620,'pac',14.286,1),(809,7532628,7532620,'ace',14.286,1),(809,7532629,7532622,'dis',50,1),(809,7532630,7532622,'isk',50,1),(809,7532631,7532629,'ind',33.333,1),(809,7532632,7532629,'nde',33.333,1),(809,7532633,7532629,'dex',33.333,1),(809,7532634,7532631,'adm',8.333,1),(809,7532635,7532631,'dmi',8.333,1),(809,7532636,7532631,'min',8.333,1),(809,7532637,7532631,'ini',8.333,1),(809,7532638,7532631,'nis',8.333,1),(809,7532639,7532631,'ist',8.333,1),(809,7532640,7532631,'str',8.333,1),(809,7532641,7532631,'tra',8.333,1),(809,7532642,7532631,'rat',8.333,1),(809,7532643,7532631,'ati',8.333,1),(809,7532644,7532631,'tio',8.333,1),(809,7532645,7532631,'ion',8.333,1),(809,7532646,7532634,'sta',33.333,3),(809,7532647,7532634,'tat',33.333,3),(809,7532648,7532634,'ate',33.333,3),(809,7532649,7532646,'dis',16.667,4),(809,7532650,7532646,'isa',16.667,4),(809,7532651,7532646,'sab',16.667,4),(809,7532652,7532646,'abl',16.667,4),(809,7532653,7532646,'ble',16.667,4),(809,7532654,7532646,'led',16.667,4),(809,7532655,7532649,'cac',33.333,1),(809,7532656,7532649,'ach',33.333,1),(809,7532657,7532649,'che',33.333,1),(809,7532658,7532655,'mod',50,1),(809,7532659,7532655,'ode',50,1),(809,7532660,7532658,'wri',14.286,1),(809,7532661,7532658,'rit',14.286,1),(809,7532662,7532658,'ite',14.286,1),(809,7532663,7532658,'tet',14.286,1),(809,7532664,7532658,'eth',14.286,1),(809,7532665,7532658,'thr',14.286,1),(809,7532666,7532658,'hru',14.286,1),(809,7532667,7532660,'ope',11.111,2),(809,7532668,7532660,'per',11.111,2),(809,7532669,7532660,'era',11.111,2),(809,7532670,7532660,'rat',11.111,2),(809,7532671,7532660,'ati',11.111,2),(809,7532672,7532660,'tio',11.111,2),(809,7532673,7532660,'ion',11.111,2),(809,7532674,7532660,'ona',11.111,2),(809,7532675,7532660,'nal',11.111,2),(809,7532676,7532667,'mes',20,1),(809,7532677,7532667,'ess',20,1),(809,7532678,7532667,'ssa',20,1),(809,7532679,7532667,'sag',20,1),(809,7532680,7532667,'age',20,1),(809,7532681,7532676,'per',11.111,1),(809,7532682,7532676,'erf',11.111,1),(809,7532683,7532676,'rfo',11.111,1),(809,7532684,7532676,'for',11.111,1),(809,7532685,7532676,'orm',11.111,1),(809,7532686,7532676,'rma',11.111,1),(809,7532687,7532676,'man',11.111,1),(809,7532688,7532676,'anc',11.111,1),(809,7532689,7532676,'nce',11.111,1),(809,7532690,7532681,'ide',12.5,1),(809,7532691,7532681,'den',12.5,1),(809,7532692,7532681,'ent',12.5,1),(809,7532693,7532681,'nti',12.5,1),(809,7532694,7532681,'tif',12.5,1),(809,7532695,7532681,'ifi',12.5,1),(809,7532696,7532681,'fie',12.5,1),(809,7532697,7532681,'ier',12.5,1),(809,7532698,7532690,'vdi',33.333,3),(809,7532699,7532690,'dis',33.333,3),(809,7532700,7532690,'isk',33.333,3),(809,7532701,7532698,'nam',50,1),(809,7532702,7532698,'ame',50,1),(809,7532703,7532701,'typ',50,1),(809,7532704,7532701,'ype',50,1),(809,7532705,7532703,'dir',25,1),(809,7532706,7532703,'ire',25,1),(809,7532707,7532703,'rec',25,1),(809,7532708,7532703,'ect',25,1),(810,7532710,7532709,'naa',100,2),(810,7532711,7532710,'600',3.333,3),(810,7532712,7532710,'000',3.333,3),(810,7532713,7532710,'00c',3.333,3),(810,7532714,7532710,'0c2',3.333,3),(810,7532715,7532710,'c29',3.333,3),(810,7532716,7532710,'29b',3.333,3),(810,7532717,7532710,'9b8',3.333,3),(810,7532718,7532710,'b8b',3.333,3),(810,7532719,7532710,'8b6',3.333,3),(810,7532720,7532710,'b6c',3.333,3),(810,7532721,7532710,'6c8',3.333,3),(810,7532722,7532710,'c89',3.333,3),(810,7532723,7532710,'899',3.333,3),(810,7532724,7532710,'995',3.333,3),(810,7532725,7532710,'958',3.333,3),(810,7532726,7532710,'589',3.333,3),(810,7532727,7532710,'89c',3.333,3),(810,7532728,7532710,'9c0',3.333,3),(810,7532729,7532710,'c0b',3.333,3),(810,7532730,7532710,'0bb',3.333,3),(810,7532731,7532710,'bb3',3.333,3),(810,7532732,7532710,'b32',3.333,3),(810,7532733,7532710,'321',3.333,3),(810,7532734,7532710,'21f',3.333,3),(810,7532735,7532710,'1f7',3.333,3),(810,7532736,7532710,'f75',3.333,3),(810,7532737,7532710,'751',3.333,3),(810,7532738,7532710,'516',3.333,3),(810,7532739,7532710,'163',3.333,3),(810,7532740,7532710,'639',3.333,3),(810,7532741,7532711,'mon',100,1),(810,7532742,7532741,'201',50,1),(810,7532743,7532741,'013',50,1),(810,7532744,7532742,'adm',33.333,4),(810,7532745,7532742,'dmi',33.333,4),(810,7532746,7532742,'min',33.333,4),(810,7532747,7532744,'cap',16.667,1),(810,7532748,7532744,'apa',16.667,1),(810,7532749,7532744,'pac',16.667,1),(810,7532750,7532744,'aci',16.667,1),(810,7532751,7532744,'cit',16.667,1),(810,7532752,7532744,'ity',16.667,1),(810,7532753,7532747,'pat',50,1),(810,7532754,7532747,'ath',50,1),(810,7532755,7532753,'fre',14.286,1),(810,7532756,7532753,'ree',14.286,1),(810,7532757,7532753,'ees',14.286,1),(810,7532758,7532753,'esp',14.286,1),(810,7532759,7532753,'spa',14.286,1),(810,7532760,7532753,'pac',14.286,1),(810,7532761,7532753,'ace',14.286,1),(810,7532762,7532755,'dis',50,1),(810,7532763,7532755,'isk',50,1),(810,7532764,7532762,'ind',33.333,1),(810,7532765,7532762,'nde',33.333,1),(810,7532766,7532762,'dex',33.333,1),(810,7532767,7532764,'adm',8.333,1),(810,7532768,7532764,'dmi',8.333,1),(810,7532769,7532764,'min',8.333,1),(810,7532770,7532764,'ini',8.333,1),(810,7532771,7532764,'nis',8.333,1),(810,7532772,7532764,'ist',8.333,1),(810,7532773,7532764,'str',8.333,1),(810,7532774,7532764,'tra',8.333,1),(810,7532775,7532764,'rat',8.333,1),(810,7532776,7532764,'ati',8.333,1),(810,7532777,7532764,'tio',8.333,1),(810,7532778,7532764,'ion',8.333,1),(810,7532779,7532767,'sta',33.333,3),(810,7532780,7532767,'tat',33.333,3),(810,7532781,7532767,'ate',33.333,3),(810,7532782,7532779,'dis',16.667,4),(810,7532783,7532779,'isa',16.667,4),(810,7532784,7532779,'sab',16.667,4),(810,7532785,7532779,'abl',16.667,4),(810,7532786,7532779,'ble',16.667,4),(810,7532787,7532779,'led',16.667,4),(810,7532788,7532782,'cac',33.333,1),(810,7532789,7532782,'ach',33.333,1),(810,7532790,7532782,'che',33.333,1),(810,7532791,7532788,'mod',50,1),(810,7532792,7532788,'ode',50,1),(810,7532793,7532791,'wri',14.286,1),(810,7532794,7532791,'rit',14.286,1),(810,7532795,7532791,'ite',14.286,1),(810,7532796,7532791,'tet',14.286,1),(810,7532797,7532791,'eth',14.286,1),(810,7532798,7532791,'thr',14.286,1),(810,7532799,7532791,'hru',14.286,1),(810,7532800,7532793,'ope',11.111,2),(810,7532801,7532793,'per',11.111,2),(810,7532802,7532793,'era',11.111,2),(810,7532803,7532793,'rat',11.111,2),(810,7532804,7532793,'ati',11.111,2),(810,7532805,7532793,'tio',11.111,2),(810,7532806,7532793,'ion',11.111,2),(810,7532807,7532793,'ona',11.111,2),(810,7532808,7532793,'nal',11.111,2),(810,7532809,7532800,'mes',20,1),(810,7532810,7532800,'ess',20,1),(810,7532811,7532800,'ssa',20,1),(810,7532812,7532800,'sag',20,1),(810,7532813,7532800,'age',20,1),(810,7532814,7532809,'per',11.111,1),(810,7532815,7532809,'erf',11.111,1),(810,7532816,7532809,'rfo',11.111,1),(810,7532817,7532809,'for',11.111,1),(810,7532818,7532809,'orm',11.111,1),(810,7532819,7532809,'rma',11.111,1),(810,7532820,7532809,'man',11.111,1),(810,7532821,7532809,'anc',11.111,1),(810,7532822,7532809,'nce',11.111,1),(810,7532823,7532814,'ide',12.5,1),(810,7532824,7532814,'den',12.5,1),(810,7532825,7532814,'ent',12.5,1),(810,7532826,7532814,'nti',12.5,1),(810,7532827,7532814,'tif',12.5,1),(810,7532828,7532814,'ifi',12.5,1),(810,7532829,7532814,'fie',12.5,1),(810,7532830,7532814,'ier',12.5,1),(810,7532831,7532823,'vdi',33.333,3),(810,7532832,7532823,'dis',33.333,3),(810,7532833,7532823,'isk',33.333,3),(810,7532834,7532831,'nam',50,1),(810,7532835,7532831,'ame',50,1),(810,7532836,7532834,'typ',50,1),(810,7532837,7532834,'ype',50,1),(810,7532838,7532836,'dir',25,1),(810,7532839,7532836,'ire',25,1),(810,7532840,7532836,'rec',25,1),(810,7532841,7532836,'ect',25,1),(811,7532843,7532842,'naa',100,2),(811,7532844,7532843,'600',3.333,3),(811,7532845,7532843,'000',3.333,3),(811,7532846,7532843,'00c',3.333,3),(811,7532847,7532843,'0c2',3.333,3),(811,7532848,7532843,'c29',3.333,3),(811,7532849,7532843,'29e',3.333,3),(811,7532850,7532843,'9e0',3.333,3),(811,7532851,7532843,'e05',3.333,3),(811,7532852,7532843,'056',3.333,3),(811,7532853,7532843,'567',3.333,3),(811,7532854,7532843,'67a',3.333,3),(811,7532855,7532843,'7ab',3.333,3),(811,7532856,7532843,'ab2',3.333,3),(811,7532857,7532843,'b2b',3.333,3),(811,7532858,7532843,'2be',3.333,3),(811,7532859,7532843,'bee',3.333,3),(811,7532860,7532843,'eec',3.333,3),(811,7532861,7532843,'ec5',3.333,3),(811,7532862,7532843,'c55',3.333,3),(811,7532863,7532843,'55a',3.333,3),(811,7532864,7532843,'5ae',3.333,3),(811,7532865,7532843,'aeb',3.333,3),(811,7532866,7532843,'ebf',3.333,3),(811,7532867,7532843,'bf8',3.333,3),(811,7532868,7532843,'f8f',3.333,3),(811,7532869,7532843,'8fb',3.333,3),(811,7532870,7532843,'fbf',3.333,3),(811,7532871,7532843,'bf9',3.333,3),(811,7532872,7532843,'f97',3.333,3),(811,7532873,7532843,'971',3.333,3),(811,7532874,7532844,'mon',100,1),(811,7532875,7532874,'201',50,1),(811,7532876,7532874,'013',50,1),(811,7532877,7532875,'adm',33.333,4),(811,7532878,7532875,'dmi',33.333,4),(811,7532879,7532875,'min',33.333,4),(811,7532880,7532877,'cap',16.667,1),(811,7532881,7532877,'apa',16.667,1),(811,7532882,7532877,'pac',16.667,1),(811,7532883,7532877,'aci',16.667,1),(811,7532884,7532877,'cit',16.667,1),(811,7532885,7532877,'ity',16.667,1),(811,7532886,7532880,'pat',50,1),(811,7532887,7532880,'ath',50,1),(811,7532888,7532886,'fre',14.286,1),(811,7532889,7532886,'ree',14.286,1),(811,7532890,7532886,'ees',14.286,1),(811,7532891,7532886,'esp',14.286,1),(811,7532892,7532886,'spa',14.286,1),(811,7532893,7532886,'pac',14.286,1),(811,7532894,7532886,'ace',14.286,1),(811,7532895,7532888,'dis',50,1),(811,7532896,7532888,'isk',50,1),(811,7532897,7532895,'ind',33.333,1),(811,7532898,7532895,'nde',33.333,1),(811,7532899,7532895,'dex',33.333,1),(811,7532900,7532897,'adm',8.333,1),(811,7532901,7532897,'dmi',8.333,1),(811,7532902,7532897,'min',8.333,1),(811,7532903,7532897,'ini',8.333,1),(811,7532904,7532897,'nis',8.333,1),(811,7532905,7532897,'ist',8.333,1),(811,7532906,7532897,'str',8.333,1),(811,7532907,7532897,'tra',8.333,1),(811,7532908,7532897,'rat',8.333,1),(811,7532909,7532897,'ati',8.333,1),(811,7532910,7532897,'tio',8.333,1),(811,7532911,7532897,'ion',8.333,1),(811,7532912,7532900,'sta',33.333,3),(811,7532913,7532900,'tat',33.333,3),(811,7532914,7532900,'ate',33.333,3),(811,7532915,7532912,'dis',16.667,4),(811,7532916,7532912,'isa',16.667,4),(811,7532917,7532912,'sab',16.667,4),(811,7532918,7532912,'abl',16.667,4),(811,7532919,7532912,'ble',16.667,4),(811,7532920,7532912,'led',16.667,4),(811,7532921,7532915,'cac',33.333,1),(811,7532922,7532915,'ach',33.333,1),(811,7532923,7532915,'che',33.333,1),(811,7532924,7532921,'mod',50,1),(811,7532925,7532921,'ode',50,1),(811,7532926,7532924,'wri',14.286,1),(811,7532927,7532924,'rit',14.286,1),(811,7532928,7532924,'ite',14.286,1),(811,7532929,7532924,'tet',14.286,1),(811,7532930,7532924,'eth',14.286,1),(811,7532931,7532924,'thr',14.286,1),(811,7532932,7532924,'hru',14.286,1),(811,7532933,7532926,'ope',11.111,2),(811,7532934,7532926,'per',11.111,2),(811,7532935,7532926,'era',11.111,2),(811,7532936,7532926,'rat',11.111,2),(811,7532937,7532926,'ati',11.111,2),(811,7532938,7532926,'tio',11.111,2),(811,7532939,7532926,'ion',11.111,2),(811,7532940,7532926,'ona',11.111,2),(811,7532941,7532926,'nal',11.111,2),(811,7532942,7532933,'mes',20,1),(811,7532943,7532933,'ess',20,1),(811,7532944,7532933,'ssa',20,1),(811,7532945,7532933,'sag',20,1),(811,7532946,7532933,'age',20,1),(811,7532947,7532942,'per',11.111,1),(811,7532948,7532942,'erf',11.111,1),(811,7532949,7532942,'rfo',11.111,1),(811,7532950,7532942,'for',11.111,1),(811,7532951,7532942,'orm',11.111,1),(811,7532952,7532942,'rma',11.111,1),(811,7532953,7532942,'man',11.111,1),(811,7532954,7532942,'anc',11.111,1),(811,7532955,7532942,'nce',11.111,1),(811,7532956,7532947,'ide',12.5,1),(811,7532957,7532947,'den',12.5,1),(811,7532958,7532947,'ent',12.5,1),(811,7532959,7532947,'nti',12.5,1),(811,7532960,7532947,'tif',12.5,1),(811,7532961,7532947,'ifi',12.5,1),(811,7532962,7532947,'fie',12.5,1),(811,7532963,7532947,'ier',12.5,1),(811,7532964,7532956,'vdi',33.333,3),(811,7532965,7532956,'dis',33.333,3),(811,7532966,7532956,'isk',33.333,3),(811,7532967,7532964,'nam',50,1),(811,7532968,7532964,'ame',50,1),(811,7532969,7532967,'typ',50,1),(811,7532970,7532967,'ype',50,1),(811,7532971,7532969,'dir',25,1),(811,7532972,7532969,'ire',25,1),(811,7532973,7532969,'rec',25,1),(811,7532974,7532969,'ect',25,1),(812,7532976,7532975,'naa',100,2),(812,7532977,7532976,'600',3.333,3),(812,7532978,7532976,'000',3.333,3),(812,7532979,7532976,'00c',3.333,3),(812,7532980,7532976,'0c2',3.333,3),(812,7532981,7532976,'c29',3.333,3),(812,7532982,7532976,'294',3.333,3),(812,7532983,7532976,'94e',3.333,3),(812,7532984,7532976,'4e3',3.333,3),(812,7532985,7532976,'e31',3.333,3),(812,7532986,7532976,'315',3.333,3),(812,7532987,7532976,'154',3.333,3),(812,7532988,7532976,'54e',3.333,3),(812,7532989,7532976,'4e8',3.333,3),(812,7532990,7532976,'e87',3.333,3),(812,7532991,7532976,'874',3.333,3),(812,7532992,7532976,'741',3.333,3),(812,7532993,7532976,'415',3.333,3),(812,7532994,7532976,'15c',3.333,3),(812,7532995,7532976,'5c3',3.333,3),(812,7532996,7532976,'c31',3.333,3),(812,7532997,7532976,'310',3.333,3),(812,7532998,7532976,'10e',3.333,3),(812,7532999,7532976,'0e2',3.333,3),(812,7533000,7532976,'e24',3.333,3),(812,7533001,7532976,'244',3.333,3),(812,7533002,7532976,'449',3.333,3),(812,7533003,7532976,'499',3.333,3),(812,7533004,7532976,'997',3.333,3),(812,7533005,7532976,'971',3.333,3),(812,7533006,7532976,'716',3.333,3),(812,7533007,7532977,'mon',100,1),(812,7533008,7533007,'201',50,1),(812,7533009,7533007,'013',50,1),(812,7533010,7533008,'adm',33.333,4),(812,7533011,7533008,'dmi',33.333,4),(812,7533012,7533008,'min',33.333,4),(812,7533013,7533010,'cap',16.667,1),(812,7533014,7533010,'apa',16.667,1),(812,7533015,7533010,'pac',16.667,1),(812,7533016,7533010,'aci',16.667,1),(812,7533017,7533010,'cit',16.667,1),(812,7533018,7533010,'ity',16.667,1),(812,7533019,7533013,'pat',50,1),(812,7533020,7533013,'ath',50,1),(812,7533021,7533019,'fre',14.286,1),(812,7533022,7533019,'ree',14.286,1),(812,7533023,7533019,'ees',14.286,1),(812,7533024,7533019,'esp',14.286,1),(812,7533025,7533019,'spa',14.286,1),(812,7533026,7533019,'pac',14.286,1),(812,7533027,7533019,'ace',14.286,1),(812,7533028,7533021,'dis',50,1),(812,7533029,7533021,'isk',50,1),(812,7533030,7533028,'ind',33.333,1),(812,7533031,7533028,'nde',33.333,1),(812,7533032,7533028,'dex',33.333,1),(812,7533033,7533030,'adm',8.333,1),(812,7533034,7533030,'dmi',8.333,1),(812,7533035,7533030,'min',8.333,1),(812,7533036,7533030,'ini',8.333,1),(812,7533037,7533030,'nis',8.333,1),(812,7533038,7533030,'ist',8.333,1),(812,7533039,7533030,'str',8.333,1),(812,7533040,7533030,'tra',8.333,1),(812,7533041,7533030,'rat',8.333,1),(812,7533042,7533030,'ati',8.333,1),(812,7533043,7533030,'tio',8.333,1),(812,7533044,7533030,'ion',8.333,1),(812,7533045,7533033,'sta',33.333,3),(812,7533046,7533033,'tat',33.333,3),(812,7533047,7533033,'ate',33.333,3),(812,7533048,7533045,'dis',16.667,4),(812,7533049,7533045,'isa',16.667,4),(812,7533050,7533045,'sab',16.667,4),(812,7533051,7533045,'abl',16.667,4),(812,7533052,7533045,'ble',16.667,4),(812,7533053,7533045,'led',16.667,4),(812,7533054,7533048,'cac',33.333,1),(812,7533055,7533048,'ach',33.333,1),(812,7533056,7533048,'che',33.333,1),(812,7533057,7533054,'mod',50,1),(812,7533058,7533054,'ode',50,1),(812,7533059,7533057,'wri',14.286,1),(812,7533060,7533057,'rit',14.286,1),(812,7533061,7533057,'ite',14.286,1),(812,7533062,7533057,'tet',14.286,1),(812,7533063,7533057,'eth',14.286,1),(812,7533064,7533057,'thr',14.286,1),(812,7533065,7533057,'hru',14.286,1),(812,7533066,7533059,'ope',11.111,2),(812,7533067,7533059,'per',11.111,2),(812,7533068,7533059,'era',11.111,2),(812,7533069,7533059,'rat',11.111,2),(812,7533070,7533059,'ati',11.111,2),(812,7533071,7533059,'tio',11.111,2),(812,7533072,7533059,'ion',11.111,2),(812,7533073,7533059,'ona',11.111,2),(812,7533074,7533059,'nal',11.111,2),(812,7533075,7533066,'mes',20,1),(812,7533076,7533066,'ess',20,1),(812,7533077,7533066,'ssa',20,1),(812,7533078,7533066,'sag',20,1),(812,7533079,7533066,'age',20,1),(812,7533080,7533075,'per',11.111,1),(812,7533081,7533075,'erf',11.111,1),(812,7533082,7533075,'rfo',11.111,1),(812,7533083,7533075,'for',11.111,1),(812,7533084,7533075,'orm',11.111,1),(812,7533085,7533075,'rma',11.111,1),(812,7533086,7533075,'man',11.111,1),(812,7533087,7533075,'anc',11.111,1),(812,7533088,7533075,'nce',11.111,1),(812,7533089,7533080,'ide',12.5,1),(812,7533090,7533080,'den',12.5,1),(812,7533091,7533080,'ent',12.5,1),(812,7533092,7533080,'nti',12.5,1),(812,7533093,7533080,'tif',12.5,1),(812,7533094,7533080,'ifi',12.5,1),(812,7533095,7533080,'fie',12.5,1),(812,7533096,7533080,'ier',12.5,1),(812,7533097,7533089,'vdi',33.333,3),(812,7533098,7533089,'dis',33.333,3),(812,7533099,7533089,'isk',33.333,3),(812,7533100,7533097,'nam',50,1),(812,7533101,7533097,'ame',50,1),(812,7533102,7533100,'typ',50,1),(812,7533103,7533100,'ype',50,1),(812,7533104,7533102,'dir',25,1),(812,7533105,7533102,'ire',25,1),(812,7533106,7533102,'rec',25,1),(812,7533107,7533102,'ect',25,1),(813,7533109,7533108,'naa',100,2),(813,7533110,7533109,'600',3.333,3),(813,7533111,7533109,'000',3.333,3),(813,7533112,7533109,'00c',3.333,3),(813,7533113,7533109,'0c2',3.333,3),(813,7533114,7533109,'c29',3.333,3),(813,7533115,7533109,'290',3.333,3),(813,7533116,7533109,'909',3.333,3),(813,7533117,7533109,'097',3.333,3),(813,7533118,7533109,'977',3.333,3),(813,7533119,7533109,'77b',3.333,3),(813,7533120,7533109,'7b7',3.333,3),(813,7533121,7533109,'b7c',3.333,3),(813,7533122,7533109,'7ce',3.333,3),(813,7533123,7533109,'cef',3.333,3),(813,7533124,7533109,'efe',3.333,3),(813,7533125,7533109,'fe7',3.333,3),(813,7533126,7533109,'e75',3.333,3),(813,7533127,7533109,'75c',3.333,3),(813,7533128,7533109,'5cb',3.333,3),(813,7533129,7533109,'cbe',3.333,3),(813,7533130,7533109,'be5',3.333,3),(813,7533131,7533109,'e5e',3.333,3),(813,7533132,7533109,'5e1',3.333,3),(813,7533133,7533109,'e19',3.333,3),(813,7533134,7533109,'196',3.333,3),(813,7533135,7533109,'964',3.333,3),(813,7533136,7533109,'649',3.333,3),(813,7533137,7533109,'49f',3.333,3),(813,7533138,7533109,'9f3',3.333,3),(813,7533139,7533109,'f3d',3.333,3),(813,7533140,7533110,'mon',100,1),(813,7533141,7533140,'201',50,1),(813,7533142,7533140,'013',50,1),(813,7533143,7533141,'adm',33.333,4),(813,7533144,7533141,'dmi',33.333,4),(813,7533145,7533141,'min',33.333,4),(813,7533146,7533143,'cap',16.667,1),(813,7533147,7533143,'apa',16.667,1),(813,7533148,7533143,'pac',16.667,1),(813,7533149,7533143,'aci',16.667,1),(813,7533150,7533143,'cit',16.667,1),(813,7533151,7533143,'ity',16.667,1),(813,7533152,7533146,'pat',50,1),(813,7533153,7533146,'ath',50,1),(813,7533154,7533152,'fre',14.286,1),(813,7533155,7533152,'ree',14.286,1),(813,7533156,7533152,'ees',14.286,1),(813,7533157,7533152,'esp',14.286,1),(813,7533158,7533152,'spa',14.286,1),(813,7533159,7533152,'pac',14.286,1),(813,7533160,7533152,'ace',14.286,1),(813,7533161,7533154,'dis',50,1),(813,7533162,7533154,'isk',50,1),(813,7533163,7533161,'ind',33.333,1),(813,7533164,7533161,'nde',33.333,1),(813,7533165,7533161,'dex',33.333,1),(813,7533166,7533163,'adm',8.333,1),(813,7533167,7533163,'dmi',8.333,1),(813,7533168,7533163,'min',8.333,1),(813,7533169,7533163,'ini',8.333,1),(813,7533170,7533163,'nis',8.333,1),(813,7533171,7533163,'ist',8.333,1),(813,7533172,7533163,'str',8.333,1),(813,7533173,7533163,'tra',8.333,1),(813,7533174,7533163,'rat',8.333,1),(813,7533175,7533163,'ati',8.333,1),(813,7533176,7533163,'tio',8.333,1),(813,7533177,7533163,'ion',8.333,1),(813,7533178,7533166,'sta',33.333,3),(813,7533179,7533166,'tat',33.333,3),(813,7533180,7533166,'ate',33.333,3),(813,7533181,7533178,'dis',16.667,4),(813,7533182,7533178,'isa',16.667,4),(813,7533183,7533178,'sab',16.667,4),(813,7533184,7533178,'abl',16.667,4),(813,7533185,7533178,'ble',16.667,4),(813,7533186,7533178,'led',16.667,4),(813,7533187,7533181,'cac',33.333,1),(813,7533188,7533181,'ach',33.333,1),(813,7533189,7533181,'che',33.333,1),(813,7533190,7533187,'mod',50,1),(813,7533191,7533187,'ode',50,1),(813,7533192,7533190,'wri',14.286,1),(813,7533193,7533190,'rit',14.286,1),(813,7533194,7533190,'ite',14.286,1),(813,7533195,7533190,'tet',14.286,1),(813,7533196,7533190,'eth',14.286,1),(813,7533197,7533190,'thr',14.286,1),(813,7533198,7533190,'hru',14.286,1),(813,7533199,7533192,'ope',11.111,2),(813,7533200,7533192,'per',11.111,2),(813,7533201,7533192,'era',11.111,2),(813,7533202,7533192,'rat',11.111,2),(813,7533203,7533192,'ati',11.111,2),(813,7533204,7533192,'tio',11.111,2),(813,7533205,7533192,'ion',11.111,2),(813,7533206,7533192,'ona',11.111,2),(813,7533207,7533192,'nal',11.111,2),(813,7533208,7533199,'mes',20,1),(813,7533209,7533199,'ess',20,1),(813,7533210,7533199,'ssa',20,1),(813,7533211,7533199,'sag',20,1),(813,7533212,7533199,'age',20,1),(813,7533213,7533208,'per',11.111,1),(813,7533214,7533208,'erf',11.111,1),(813,7533215,7533208,'rfo',11.111,1),(813,7533216,7533208,'for',11.111,1),(813,7533217,7533208,'orm',11.111,1),(813,7533218,7533208,'rma',11.111,1),(813,7533219,7533208,'man',11.111,1),(813,7533220,7533208,'anc',11.111,1),(813,7533221,7533208,'nce',11.111,1),(813,7533222,7533213,'ide',12.5,1),(813,7533223,7533213,'den',12.5,1),(813,7533224,7533213,'ent',12.5,1),(813,7533225,7533213,'nti',12.5,1),(813,7533226,7533213,'tif',12.5,1),(813,7533227,7533213,'ifi',12.5,1),(813,7533228,7533213,'fie',12.5,1),(813,7533229,7533213,'ier',12.5,1),(813,7533230,7533222,'vdi',33.333,3),(813,7533231,7533222,'dis',33.333,3),(813,7533232,7533222,'isk',33.333,3),(813,7533233,7533230,'nam',50,1),(813,7533234,7533230,'ame',50,1),(813,7533235,7533233,'typ',50,1),(813,7533236,7533233,'ype',50,1),(813,7533237,7533235,'dir',25,1),(813,7533238,7533235,'ire',25,1),(813,7533239,7533235,'rec',25,1),(813,7533240,7533235,'ect',25,1),(814,7533242,7533241,'naa',100,2),(814,7533243,7533242,'600',3.333,3),(814,7533244,7533242,'000',3.333,3),(814,7533245,7533242,'00c',3.333,3),(814,7533246,7533242,'0c2',3.333,3),(814,7533247,7533242,'c29',3.333,3),(814,7533248,7533242,'294',3.333,3),(814,7533249,7533242,'947',3.333,3),(814,7533250,7533242,'475',3.333,3),(814,7533251,7533242,'75a',3.333,3),(814,7533252,7533242,'5a7',3.333,3),(814,7533253,7533242,'a78',3.333,3),(814,7533254,7533242,'783',3.333,3),(814,7533255,7533242,'836',3.333,3),(814,7533256,7533242,'36c',3.333,3),(814,7533257,7533242,'6ca',3.333,3),(814,7533258,7533242,'ca4',3.333,3),(814,7533259,7533242,'a48',3.333,3),(814,7533260,7533242,'48b',3.333,3),(814,7533261,7533242,'8b5',3.333,3),(814,7533262,7533242,'b51',3.333,3),(814,7533263,7533242,'516',3.333,3),(814,7533264,7533242,'163',3.333,3),(814,7533265,7533242,'631',3.333,3),(814,7533266,7533242,'318',3.333,3),(814,7533267,7533242,'189',3.333,3),(814,7533268,7533242,'89f',3.333,3),(814,7533269,7533242,'9fe',3.333,3),(814,7533270,7533242,'fe9',3.333,3),(814,7533271,7533242,'e98',3.333,3),(814,7533272,7533242,'986',3.333,3),(814,7533273,7533243,'mon',100,1),(814,7533274,7533273,'201',50,1),(814,7533275,7533273,'013',50,1),(814,7533276,7533274,'adm',33.333,4),(814,7533277,7533274,'dmi',33.333,4),(814,7533278,7533274,'min',33.333,4),(814,7533279,7533276,'cap',16.667,1),(814,7533280,7533276,'apa',16.667,1),(814,7533281,7533276,'pac',16.667,1),(814,7533282,7533276,'aci',16.667,1),(814,7533283,7533276,'cit',16.667,1),(814,7533284,7533276,'ity',16.667,1),(814,7533285,7533279,'pat',50,1),(814,7533286,7533279,'ath',50,1),(814,7533287,7533285,'fre',14.286,1),(814,7533288,7533285,'ree',14.286,1),(814,7533289,7533285,'ees',14.286,1),(814,7533290,7533285,'esp',14.286,1),(814,7533291,7533285,'spa',14.286,1),(814,7533292,7533285,'pac',14.286,1),(814,7533293,7533285,'ace',14.286,1),(814,7533294,7533287,'dis',50,1),(814,7533295,7533287,'isk',50,1),(814,7533296,7533294,'ind',33.333,1),(814,7533297,7533294,'nde',33.333,1),(814,7533298,7533294,'dex',33.333,1),(814,7533299,7533296,'adm',8.333,1),(814,7533300,7533296,'dmi',8.333,1),(814,7533301,7533296,'min',8.333,1),(814,7533302,7533296,'ini',8.333,1),(814,7533303,7533296,'nis',8.333,1),(814,7533304,7533296,'ist',8.333,1),(814,7533305,7533296,'str',8.333,1),(814,7533306,7533296,'tra',8.333,1),(814,7533307,7533296,'rat',8.333,1),(814,7533308,7533296,'ati',8.333,1),(814,7533309,7533296,'tio',8.333,1),(814,7533310,7533296,'ion',8.333,1),(814,7533311,7533299,'sta',33.333,3),(814,7533312,7533299,'tat',33.333,3),(814,7533313,7533299,'ate',33.333,3),(814,7533314,7533311,'dis',16.667,4),(814,7533315,7533311,'isa',16.667,4),(814,7533316,7533311,'sab',16.667,4),(814,7533317,7533311,'abl',16.667,4),(814,7533318,7533311,'ble',16.667,4),(814,7533319,7533311,'led',16.667,4),(814,7533320,7533314,'cac',33.333,1),(814,7533321,7533314,'ach',33.333,1),(814,7533322,7533314,'che',33.333,1),(814,7533323,7533320,'mod',50,1),(814,7533324,7533320,'ode',50,1),(814,7533325,7533323,'wri',14.286,1),(814,7533326,7533323,'rit',14.286,1),(814,7533327,7533323,'ite',14.286,1),(814,7533328,7533323,'tet',14.286,1),(814,7533329,7533323,'eth',14.286,1),(814,7533330,7533323,'thr',14.286,1),(814,7533331,7533323,'hru',14.286,1),(814,7533332,7533325,'ope',11.111,2),(814,7533333,7533325,'per',11.111,2),(814,7533334,7533325,'era',11.111,2),(814,7533335,7533325,'rat',11.111,2),(814,7533336,7533325,'ati',11.111,2),(814,7533337,7533325,'tio',11.111,2),(814,7533338,7533325,'ion',11.111,2),(814,7533339,7533325,'ona',11.111,2),(814,7533340,7533325,'nal',11.111,2),(814,7533341,7533332,'mes',20,1),(814,7533342,7533332,'ess',20,1),(814,7533343,7533332,'ssa',20,1),(814,7533344,7533332,'sag',20,1),(814,7533345,7533332,'age',20,1),(814,7533346,7533341,'per',11.111,1),(814,7533347,7533341,'erf',11.111,1),(814,7533348,7533341,'rfo',11.111,1),(814,7533349,7533341,'for',11.111,1),(814,7533350,7533341,'orm',11.111,1),(814,7533351,7533341,'rma',11.111,1),(814,7533352,7533341,'man',11.111,1),(814,7533353,7533341,'anc',11.111,1),(814,7533354,7533341,'nce',11.111,1),(814,7533355,7533346,'ide',12.5,1),(814,7533356,7533346,'den',12.5,1),(814,7533357,7533346,'ent',12.5,1),(814,7533358,7533346,'nti',12.5,1),(814,7533359,7533346,'tif',12.5,1),(814,7533360,7533346,'ifi',12.5,1),(814,7533361,7533346,'fie',12.5,1),(814,7533362,7533346,'ier',12.5,1),(814,7533363,7533355,'vdi',33.333,3),(814,7533364,7533355,'dis',33.333,3),(814,7533365,7533355,'isk',33.333,3),(814,7533366,7533363,'nam',50,1),(814,7533367,7533363,'ame',50,1),(814,7533368,7533366,'typ',50,1),(814,7533369,7533366,'ype',50,1),(814,7533370,7533368,'dir',25,1),(814,7533371,7533368,'ire',25,1),(814,7533372,7533368,'rec',25,1),(814,7533373,7533368,'ect',25,1),(815,7533375,7533374,'naa',100,2),(815,7533376,7533375,'600',3.333,3),(815,7533377,7533375,'000',3.333,3),(815,7533378,7533375,'00c',3.333,3),(815,7533379,7533375,'0c2',3.333,3),(815,7533380,7533375,'c29',3.333,3),(815,7533381,7533375,'29e',3.333,3),(815,7533382,7533375,'9e5',3.333,3),(815,7533383,7533375,'e55',3.333,3),(815,7533384,7533375,'55d',3.333,3),(815,7533385,7533375,'5da',3.333,3),(815,7533386,7533375,'da9',3.333,3),(815,7533387,7533375,'a9a',3.333,3),(815,7533388,7533375,'9a7',3.333,3),(815,7533389,7533375,'a7e',3.333,3),(815,7533390,7533375,'7eb',3.333,3),(815,7533391,7533375,'eb2',3.333,3),(815,7533392,7533375,'b2b',3.333,3),(815,7533393,7533375,'2b7',3.333,3),(815,7533394,7533375,'b7e',3.333,3),(815,7533395,7533375,'7ef',3.333,3),(815,7533396,7533375,'ef2',3.333,3),(815,7533397,7533375,'f27',3.333,3),(815,7533398,7533375,'27c',3.333,3),(815,7533399,7533375,'7c6',3.333,3),(815,7533400,7533375,'c67',3.333,3),(815,7533401,7533375,'671',3.333,3),(815,7533402,7533375,'71f',3.333,3),(815,7533403,7533375,'1f9',3.333,3),(815,7533404,7533375,'f9f',3.333,3),(815,7533405,7533375,'9f0',3.333,3),(815,7533406,7533376,'mon',100,1),(815,7533407,7533406,'201',50,1),(815,7533408,7533406,'013',50,1),(815,7533409,7533407,'adm',33.333,4),(815,7533410,7533407,'dmi',33.333,4),(815,7533411,7533407,'min',33.333,4),(815,7533412,7533409,'cap',16.667,1),(815,7533413,7533409,'apa',16.667,1),(815,7533414,7533409,'pac',16.667,1),(815,7533415,7533409,'aci',16.667,1),(815,7533416,7533409,'cit',16.667,1),(815,7533417,7533409,'ity',16.667,1),(815,7533418,7533412,'pat',50,1),(815,7533419,7533412,'ath',50,1),(815,7533420,7533418,'fre',14.286,1),(815,7533421,7533418,'ree',14.286,1),(815,7533422,7533418,'ees',14.286,1),(815,7533423,7533418,'esp',14.286,1),(815,7533424,7533418,'spa',14.286,1),(815,7533425,7533418,'pac',14.286,1),(815,7533426,7533418,'ace',14.286,1),(815,7533427,7533420,'dis',50,1),(815,7533428,7533420,'isk',50,1),(815,7533429,7533427,'ind',33.333,1),(815,7533430,7533427,'nde',33.333,1),(815,7533431,7533427,'dex',33.333,1),(815,7533432,7533429,'adm',8.333,1),(815,7533433,7533429,'dmi',8.333,1),(815,7533434,7533429,'min',8.333,1),(815,7533435,7533429,'ini',8.333,1),(815,7533436,7533429,'nis',8.333,1),(815,7533437,7533429,'ist',8.333,1),(815,7533438,7533429,'str',8.333,1),(815,7533439,7533429,'tra',8.333,1),(815,7533440,7533429,'rat',8.333,1),(815,7533441,7533429,'ati',8.333,1),(815,7533442,7533429,'tio',8.333,1),(815,7533443,7533429,'ion',8.333,1),(815,7533444,7533432,'sta',33.333,3),(815,7533445,7533432,'tat',33.333,3),(815,7533446,7533432,'ate',33.333,3),(815,7533447,7533444,'dis',16.667,4),(815,7533448,7533444,'isa',16.667,4),(815,7533449,7533444,'sab',16.667,4),(815,7533450,7533444,'abl',16.667,4),(815,7533451,7533444,'ble',16.667,4),(815,7533452,7533444,'led',16.667,4),(815,7533453,7533447,'cac',33.333,1),(815,7533454,7533447,'ach',33.333,1),(815,7533455,7533447,'che',33.333,1),(815,7533456,7533453,'mod',50,1),(815,7533457,7533453,'ode',50,1),(815,7533458,7533456,'wri',14.286,1),(815,7533459,7533456,'rit',14.286,1),(815,7533460,7533456,'ite',14.286,1),(815,7533461,7533456,'tet',14.286,1),(815,7533462,7533456,'eth',14.286,1),(815,7533463,7533456,'thr',14.286,1),(815,7533464,7533456,'hru',14.286,1),(815,7533465,7533458,'ope',11.111,2),(815,7533466,7533458,'per',11.111,2),(815,7533467,7533458,'era',11.111,2),(815,7533468,7533458,'rat',11.111,2),(815,7533469,7533458,'ati',11.111,2),(815,7533470,7533458,'tio',11.111,2),(815,7533471,7533458,'ion',11.111,2),(815,7533472,7533458,'ona',11.111,2),(815,7533473,7533458,'nal',11.111,2),(815,7533474,7533465,'mes',20,1),(815,7533475,7533465,'ess',20,1),(815,7533476,7533465,'ssa',20,1),(815,7533477,7533465,'sag',20,1),(815,7533478,7533465,'age',20,1),(815,7533479,7533474,'per',11.111,1),(815,7533480,7533474,'erf',11.111,1),(815,7533481,7533474,'rfo',11.111,1),(815,7533482,7533474,'for',11.111,1),(815,7533483,7533474,'orm',11.111,1),(815,7533484,7533474,'rma',11.111,1),(815,7533485,7533474,'man',11.111,1),(815,7533486,7533474,'anc',11.111,1),(815,7533487,7533474,'nce',11.111,1),(815,7533488,7533479,'ide',12.5,1),(815,7533489,7533479,'den',12.5,1),(815,7533490,7533479,'ent',12.5,1),(815,7533491,7533479,'nti',12.5,1),(815,7533492,7533479,'tif',12.5,1),(815,7533493,7533479,'ifi',12.5,1),(815,7533494,7533479,'fie',12.5,1),(815,7533495,7533479,'ier',12.5,1),(815,7533496,7533488,'vdi',33.333,3),(815,7533497,7533488,'dis',33.333,3),(815,7533498,7533488,'isk',33.333,3),(815,7533499,7533496,'nam',50,1),(815,7533500,7533496,'ame',50,1),(815,7533501,7533499,'typ',50,1),(815,7533502,7533499,'ype',50,1),(815,7533503,7533501,'dir',25,1),(815,7533504,7533501,'ire',25,1),(815,7533505,7533501,'rec',25,1),(815,7533506,7533501,'ect',25,1),(816,7533508,7533507,'naa',100,2),(816,7533509,7533508,'600',3.333,3),(816,7533510,7533508,'000',3.333,3),(816,7533511,7533508,'00c',3.333,3),(816,7533512,7533508,'0c2',3.333,3),(816,7533513,7533508,'c29',3.333,3),(816,7533514,7533508,'29b',3.333,3),(816,7533515,7533508,'9b4',3.333,3),(816,7533516,7533508,'b4c',3.333,3),(816,7533517,7533508,'4c2',3.333,3),(816,7533518,7533508,'c2c',3.333,3),(816,7533519,7533508,'2c6',3.333,3),(816,7533520,7533508,'c63',3.333,3),(816,7533521,7533508,'63b',3.333,3),(816,7533522,7533508,'3b2',3.333,3),(816,7533523,7533508,'b20',3.333,3),(816,7533524,7533508,'200',3.333,3),(816,7533525,7533508,'001',3.333,3),(816,7533526,7533508,'018',3.333,3),(816,7533527,7533508,'181',3.333,3),(816,7533528,7533508,'817',3.333,3),(816,7533529,7533508,'178',3.333,3),(816,7533530,7533508,'786',3.333,3),(816,7533531,7533508,'869',3.333,3),(816,7533532,7533508,'698',3.333,3),(816,7533533,7533508,'984',3.333,3),(816,7533534,7533508,'84d',3.333,3),(816,7533535,7533508,'4d6',3.333,3),(816,7533536,7533508,'d60',3.333,3),(816,7533537,7533508,'60a',3.333,3),(816,7533538,7533508,'0a9',3.333,3),(816,7533539,7533509,'mon',100,1),(816,7533540,7533539,'201',50,1),(816,7533541,7533539,'013',50,1),(816,7533542,7533540,'adm',33.333,4),(816,7533543,7533540,'dmi',33.333,4),(816,7533544,7533540,'min',33.333,4),(816,7533545,7533542,'cap',16.667,1),(816,7533546,7533542,'apa',16.667,1),(816,7533547,7533542,'pac',16.667,1),(816,7533548,7533542,'aci',16.667,1),(816,7533549,7533542,'cit',16.667,1),(816,7533550,7533542,'ity',16.667,1),(816,7533551,7533545,'pat',50,1),(816,7533552,7533545,'ath',50,1),(816,7533553,7533551,'fre',14.286,1),(816,7533554,7533551,'ree',14.286,1),(816,7533555,7533551,'ees',14.286,1),(816,7533556,7533551,'esp',14.286,1),(816,7533557,7533551,'spa',14.286,1),(816,7533558,7533551,'pac',14.286,1),(816,7533559,7533551,'ace',14.286,1),(816,7533560,7533553,'dis',50,1),(816,7533561,7533553,'isk',50,1),(816,7533562,7533560,'ind',33.333,1),(816,7533563,7533560,'nde',33.333,1),(816,7533564,7533560,'dex',33.333,1),(816,7533565,7533562,'adm',8.333,1),(816,7533566,7533562,'dmi',8.333,1),(816,7533567,7533562,'min',8.333,1),(816,7533568,7533562,'ini',8.333,1),(816,7533569,7533562,'nis',8.333,1),(816,7533570,7533562,'ist',8.333,1),(816,7533571,7533562,'str',8.333,1),(816,7533572,7533562,'tra',8.333,1),(816,7533573,7533562,'rat',8.333,1),(816,7533574,7533562,'ati',8.333,1),(816,7533575,7533562,'tio',8.333,1),(816,7533576,7533562,'ion',8.333,1),(816,7533577,7533565,'sta',33.333,3),(816,7533578,7533565,'tat',33.333,3),(816,7533579,7533565,'ate',33.333,3),(816,7533580,7533577,'dis',16.667,4),(816,7533581,7533577,'isa',16.667,4),(816,7533582,7533577,'sab',16.667,4),(816,7533583,7533577,'abl',16.667,4),(816,7533584,7533577,'ble',16.667,4),(816,7533585,7533577,'led',16.667,4),(816,7533586,7533580,'cac',33.333,1),(816,7533587,7533580,'ach',33.333,1),(816,7533588,7533580,'che',33.333,1),(816,7533589,7533586,'mod',50,1),(816,7533590,7533586,'ode',50,1),(816,7533591,7533589,'wri',14.286,1),(816,7533592,7533589,'rit',14.286,1),(816,7533593,7533589,'ite',14.286,1),(816,7533594,7533589,'tet',14.286,1),(816,7533595,7533589,'eth',14.286,1),(816,7533596,7533589,'thr',14.286,1),(816,7533597,7533589,'hru',14.286,1),(816,7533598,7533591,'ope',11.111,2),(816,7533599,7533591,'per',11.111,2),(816,7533600,7533591,'era',11.111,2),(816,7533601,7533591,'rat',11.111,2),(816,7533602,7533591,'ati',11.111,2),(816,7533603,7533591,'tio',11.111,2),(816,7533604,7533591,'ion',11.111,2),(816,7533605,7533591,'ona',11.111,2),(816,7533606,7533591,'nal',11.111,2),(816,7533607,7533598,'mes',20,1),(816,7533608,7533598,'ess',20,1),(816,7533609,7533598,'ssa',20,1),(816,7533610,7533598,'sag',20,1),(816,7533611,7533598,'age',20,1),(816,7533612,7533607,'per',11.111,1),(816,7533613,7533607,'erf',11.111,1),(816,7533614,7533607,'rfo',11.111,1),(816,7533615,7533607,'for',11.111,1),(816,7533616,7533607,'orm',11.111,1),(816,7533617,7533607,'rma',11.111,1),(816,7533618,7533607,'man',11.111,1),(816,7533619,7533607,'anc',11.111,1),(816,7533620,7533607,'nce',11.111,1),(816,7533621,7533612,'ide',12.5,1),(816,7533622,7533612,'den',12.5,1),(816,7533623,7533612,'ent',12.5,1),(816,7533624,7533612,'nti',12.5,1),(816,7533625,7533612,'tif',12.5,1),(816,7533626,7533612,'ifi',12.5,1),(816,7533627,7533612,'fie',12.5,1),(816,7533628,7533612,'ier',12.5,1),(816,7533629,7533621,'vdi',33.333,3),(816,7533630,7533621,'dis',33.333,3),(816,7533631,7533621,'isk',33.333,3),(816,7533632,7533629,'nam',50,1),(816,7533633,7533629,'ame',50,1),(816,7533634,7533632,'typ',50,1),(816,7533635,7533632,'ype',50,1),(816,7533636,7533634,'dir',25,1),(816,7533637,7533634,'ire',25,1),(816,7533638,7533634,'rec',25,1),(816,7533639,7533634,'ect',25,1),(817,7533641,7533640,'naa',100,2),(817,7533642,7533641,'600',3.333,3),(817,7533643,7533641,'000',3.333,3),(817,7533644,7533641,'00c',3.333,3),(817,7533645,7533641,'0c2',3.333,3),(817,7533646,7533641,'c29',3.333,3),(817,7533647,7533641,'292',3.333,3),(817,7533648,7533641,'921',3.333,3),(817,7533649,7533641,'21f',3.333,3),(817,7533650,7533641,'1f4',3.333,3),(817,7533651,7533641,'f4d',3.333,3),(817,7533652,7533641,'4d2',3.333,3),(817,7533653,7533641,'d2b',3.333,3),(817,7533654,7533641,'2b0',3.333,3),(817,7533655,7533641,'b0b',3.333,3),(817,7533656,7533641,'0b9',3.333,3),(817,7533657,7533641,'b9e',3.333,3),(817,7533658,7533641,'9ee',3.333,3),(817,7533659,7533641,'ee2',3.333,3),(817,7533660,7533641,'e2c',3.333,3),(817,7533661,7533641,'2ce',3.333,3),(817,7533662,7533641,'ce1',3.333,3),(817,7533663,7533641,'e19',3.333,3),(817,7533664,7533641,'198',3.333,3),(817,7533665,7533641,'98e',3.333,3),(817,7533666,7533641,'8ec',3.333,3),(817,7533667,7533641,'ecd',3.333,3),(817,7533668,7533641,'cdd',3.333,3),(817,7533669,7533641,'dde',3.333,3),(817,7533670,7533641,'dea',3.333,3),(817,7533671,7533641,'ea0',3.333,3),(817,7533672,7533642,'mon',100,1),(817,7533673,7533672,'201',50,1),(817,7533674,7533672,'013',50,1),(817,7533675,7533673,'adm',33.333,4),(817,7533676,7533673,'dmi',33.333,4),(817,7533677,7533673,'min',33.333,4),(817,7533678,7533675,'cap',16.667,1),(817,7533679,7533675,'apa',16.667,1),(817,7533680,7533675,'pac',16.667,1),(817,7533681,7533675,'aci',16.667,1),(817,7533682,7533675,'cit',16.667,1),(817,7533683,7533675,'ity',16.667,1),(817,7533684,7533678,'pat',50,1),(817,7533685,7533678,'ath',50,1),(817,7533686,7533684,'fre',14.286,1),(817,7533687,7533684,'ree',14.286,1),(817,7533688,7533684,'ees',14.286,1),(817,7533689,7533684,'esp',14.286,1),(817,7533690,7533684,'spa',14.286,1),(817,7533691,7533684,'pac',14.286,1),(817,7533692,7533684,'ace',14.286,1),(817,7533693,7533686,'dis',50,1),(817,7533694,7533686,'isk',50,1),(817,7533695,7533693,'ind',33.333,1),(817,7533696,7533693,'nde',33.333,1),(817,7533697,7533693,'dex',33.333,1),(817,7533698,7533695,'adm',8.333,1),(817,7533699,7533695,'dmi',8.333,1),(817,7533700,7533695,'min',8.333,1),(817,7533701,7533695,'ini',8.333,1),(817,7533702,7533695,'nis',8.333,1),(817,7533703,7533695,'ist',8.333,1),(817,7533704,7533695,'str',8.333,1),(817,7533705,7533695,'tra',8.333,1),(817,7533706,7533695,'rat',8.333,1),(817,7533707,7533695,'ati',8.333,1),(817,7533708,7533695,'tio',8.333,1),(817,7533709,7533695,'ion',8.333,1),(817,7533710,7533698,'sta',33.333,3),(817,7533711,7533698,'tat',33.333,3),(817,7533712,7533698,'ate',33.333,3),(817,7533713,7533710,'dis',16.667,4),(817,7533714,7533710,'isa',16.667,4),(817,7533715,7533710,'sab',16.667,4),(817,7533716,7533710,'abl',16.667,4),(817,7533717,7533710,'ble',16.667,4),(817,7533718,7533710,'led',16.667,4),(817,7533719,7533713,'cac',33.333,1),(817,7533720,7533713,'ach',33.333,1),(817,7533721,7533713,'che',33.333,1),(817,7533722,7533719,'mod',50,1),(817,7533723,7533719,'ode',50,1),(817,7533724,7533722,'wri',14.286,1),(817,7533725,7533722,'rit',14.286,1),(817,7533726,7533722,'ite',14.286,1),(817,7533727,7533722,'tet',14.286,1),(817,7533728,7533722,'eth',14.286,1),(817,7533729,7533722,'thr',14.286,1),(817,7533730,7533722,'hru',14.286,1),(817,7533731,7533724,'ope',11.111,2),(817,7533732,7533724,'per',11.111,2),(817,7533733,7533724,'era',11.111,2),(817,7533734,7533724,'rat',11.111,2),(817,7533735,7533724,'ati',11.111,2),(817,7533736,7533724,'tio',11.111,2),(817,7533737,7533724,'ion',11.111,2),(817,7533738,7533724,'ona',11.111,2),(817,7533739,7533724,'nal',11.111,2),(817,7533740,7533731,'mes',20,1),(817,7533741,7533731,'ess',20,1),(817,7533742,7533731,'ssa',20,1),(817,7533743,7533731,'sag',20,1),(817,7533744,7533731,'age',20,1),(817,7533745,7533740,'per',11.111,1),(817,7533746,7533740,'erf',11.111,1),(817,7533747,7533740,'rfo',11.111,1),(817,7533748,7533740,'for',11.111,1),(817,7533749,7533740,'orm',11.111,1),(817,7533750,7533740,'rma',11.111,1),(817,7533751,7533740,'man',11.111,1),(817,7533752,7533740,'anc',11.111,1),(817,7533753,7533740,'nce',11.111,1),(817,7533754,7533745,'ide',12.5,1),(817,7533755,7533745,'den',12.5,1),(817,7533756,7533745,'ent',12.5,1),(817,7533757,7533745,'nti',12.5,1),(817,7533758,7533745,'tif',12.5,1),(817,7533759,7533745,'ifi',12.5,1),(817,7533760,7533745,'fie',12.5,1),(817,7533761,7533745,'ier',12.5,1),(817,7533762,7533754,'vdi',33.333,3),(817,7533763,7533754,'dis',33.333,3),(817,7533764,7533754,'isk',33.333,3),(817,7533765,7533762,'nam',50,1),(817,7533766,7533762,'ame',50,1),(817,7533767,7533765,'typ',50,1),(817,7533768,7533765,'ype',50,1),(817,7533769,7533767,'dir',25,1),(817,7533770,7533767,'ire',25,1),(817,7533771,7533767,'rec',25,1),(817,7533772,7533767,'ect',25,1),(818,7533774,7533773,'naa',100,2),(818,7533775,7533774,'600',3.333,3),(818,7533776,7533774,'000',3.333,3),(818,7533777,7533774,'00c',3.333,3),(818,7533778,7533774,'0c2',3.333,3),(818,7533779,7533774,'c29',3.333,3),(818,7533780,7533774,'290',3.333,3),(818,7533781,7533774,'903',3.333,3),(818,7533782,7533774,'03d',3.333,3),(818,7533783,7533774,'3d1',3.333,3),(818,7533784,7533774,'d16',3.333,3),(818,7533785,7533774,'169',3.333,3),(818,7533786,7533774,'696',3.333,3),(818,7533787,7533774,'96c',3.333,3),(818,7533788,7533774,'6c7',3.333,3),(818,7533789,7533774,'c7b',3.333,3),(818,7533790,7533774,'7b9',3.333,3),(818,7533791,7533774,'b98',3.333,3),(818,7533792,7533774,'983',3.333,3),(818,7533793,7533774,'831',3.333,3),(818,7533794,7533774,'318',3.333,3),(818,7533795,7533774,'18a',3.333,3),(818,7533796,7533774,'8aa',3.333,3),(818,7533797,7533774,'aae',3.333,3),(818,7533798,7533774,'ae2',3.333,3),(818,7533799,7533774,'e2f',3.333,3),(818,7533800,7533774,'2f0',3.333,3),(818,7533801,7533774,'f09',3.333,3),(818,7533802,7533774,'09d',3.333,3),(818,7533803,7533774,'9dc',3.333,3),(818,7533804,7533774,'dc4',3.333,3),(818,7533805,7533775,'mon',100,1),(818,7533806,7533805,'201',50,1),(818,7533807,7533805,'013',50,1),(818,7533808,7533806,'adm',33.333,4),(818,7533809,7533806,'dmi',33.333,4),(818,7533810,7533806,'min',33.333,4),(818,7533811,7533808,'cap',16.667,1),(818,7533812,7533808,'apa',16.667,1),(818,7533813,7533808,'pac',16.667,1),(818,7533814,7533808,'aci',16.667,1),(818,7533815,7533808,'cit',16.667,1),(818,7533816,7533808,'ity',16.667,1),(818,7533817,7533811,'pat',50,1),(818,7533818,7533811,'ath',50,1),(818,7533819,7533817,'fre',14.286,1),(818,7533820,7533817,'ree',14.286,1),(818,7533821,7533817,'ees',14.286,1),(818,7533822,7533817,'esp',14.286,1),(818,7533823,7533817,'spa',14.286,1),(818,7533824,7533817,'pac',14.286,1),(818,7533825,7533817,'ace',14.286,1),(818,7533826,7533819,'dis',50,1),(818,7533827,7533819,'isk',50,1),(818,7533828,7533826,'ind',33.333,1),(818,7533829,7533826,'nde',33.333,1),(818,7533830,7533826,'dex',33.333,1),(818,7533831,7533828,'adm',8.333,1),(818,7533832,7533828,'dmi',8.333,1),(818,7533833,7533828,'min',8.333,1),(818,7533834,7533828,'ini',8.333,1),(818,7533835,7533828,'nis',8.333,1),(818,7533836,7533828,'ist',8.333,1),(818,7533837,7533828,'str',8.333,1),(818,7533838,7533828,'tra',8.333,1),(818,7533839,7533828,'rat',8.333,1),(818,7533840,7533828,'ati',8.333,1),(818,7533841,7533828,'tio',8.333,1),(818,7533842,7533828,'ion',8.333,1),(818,7533843,7533831,'sta',33.333,3),(818,7533844,7533831,'tat',33.333,3),(818,7533845,7533831,'ate',33.333,3),(818,7533846,7533843,'dis',16.667,4),(818,7533847,7533843,'isa',16.667,4),(818,7533848,7533843,'sab',16.667,4),(818,7533849,7533843,'abl',16.667,4),(818,7533850,7533843,'ble',16.667,4),(818,7533851,7533843,'led',16.667,4),(818,7533852,7533846,'cac',33.333,1),(818,7533853,7533846,'ach',33.333,1),(818,7533854,7533846,'che',33.333,1),(818,7533855,7533852,'mod',50,1),(818,7533856,7533852,'ode',50,1),(818,7533857,7533855,'wri',14.286,1),(818,7533858,7533855,'rit',14.286,1),(818,7533859,7533855,'ite',14.286,1),(818,7533860,7533855,'tet',14.286,1),(818,7533861,7533855,'eth',14.286,1),(818,7533862,7533855,'thr',14.286,1),(818,7533863,7533855,'hru',14.286,1),(818,7533864,7533857,'ope',11.111,2),(818,7533865,7533857,'per',11.111,2),(818,7533866,7533857,'era',11.111,2),(818,7533867,7533857,'rat',11.111,2),(818,7533868,7533857,'ati',11.111,2),(818,7533869,7533857,'tio',11.111,2),(818,7533870,7533857,'ion',11.111,2),(818,7533871,7533857,'ona',11.111,2),(818,7533872,7533857,'nal',11.111,2),(818,7533873,7533864,'mes',20,1),(818,7533874,7533864,'ess',20,1),(818,7533875,7533864,'ssa',20,1),(818,7533876,7533864,'sag',20,1),(818,7533877,7533864,'age',20,1),(818,7533878,7533873,'per',11.111,1),(818,7533879,7533873,'erf',11.111,1),(818,7533880,7533873,'rfo',11.111,1),(818,7533881,7533873,'for',11.111,1),(818,7533882,7533873,'orm',11.111,1),(818,7533883,7533873,'rma',11.111,1),(818,7533884,7533873,'man',11.111,1),(818,7533885,7533873,'anc',11.111,1),(818,7533886,7533873,'nce',11.111,1),(818,7533887,7533878,'ide',12.5,1),(818,7533888,7533878,'den',12.5,1),(818,7533889,7533878,'ent',12.5,1),(818,7533890,7533878,'nti',12.5,1),(818,7533891,7533878,'tif',12.5,1),(818,7533892,7533878,'ifi',12.5,1),(818,7533893,7533878,'fie',12.5,1),(818,7533894,7533878,'ier',12.5,1),(818,7533895,7533887,'vdi',33.333,3),(818,7533896,7533887,'dis',33.333,3),(818,7533897,7533887,'isk',33.333,3),(818,7533898,7533895,'nam',50,1),(818,7533899,7533895,'ame',50,1),(818,7533900,7533898,'typ',50,1),(818,7533901,7533898,'ype',50,1),(818,7533902,7533900,'dir',25,1),(818,7533903,7533900,'ire',25,1),(818,7533904,7533900,'rec',25,1),(818,7533905,7533900,'ect',25,1),(819,7533907,7533906,'naa',100,2),(819,7533908,7533907,'600',3.333,3),(819,7533909,7533907,'000',3.333,3),(819,7533910,7533907,'00c',3.333,3),(819,7533911,7533907,'0c2',3.333,3),(819,7533912,7533907,'c29',3.333,3),(819,7533913,7533907,'29b',3.333,3),(819,7533914,7533907,'9ba',3.333,3),(819,7533915,7533907,'ba7',3.333,3),(819,7533916,7533907,'a7a',3.333,3),(819,7533917,7533907,'7a8',3.333,3),(819,7533918,7533907,'a8e',3.333,3),(819,7533919,7533907,'8ed',3.333,3),(819,7533920,7533907,'ed1',3.333,3),(819,7533921,7533907,'d1b',3.333,3),(819,7533922,7533907,'1b3',3.333,3),(819,7533923,7533907,'b37',3.333,3),(819,7533924,7533907,'376',3.333,3),(819,7533925,7533907,'76a',3.333,3),(819,7533926,7533907,'6a1',3.333,3),(819,7533927,7533907,'a1a',3.333,3),(819,7533928,7533907,'1a5',3.333,3),(819,7533929,7533907,'a54',3.333,3),(819,7533930,7533907,'54d',3.333,3),(819,7533931,7533907,'4de',3.333,3),(819,7533932,7533907,'dec',3.333,3),(819,7533933,7533907,'ec2',3.333,3),(819,7533934,7533907,'c2e',3.333,3),(819,7533935,7533907,'2ee',3.333,3),(819,7533936,7533907,'ee8',3.333,3),(819,7533937,7533907,'e87',3.333,3),(819,7533938,7533908,'mon',100,1),(819,7533939,7533938,'201',50,1),(819,7533940,7533938,'013',50,1),(819,7533941,7533939,'adm',33.333,4),(819,7533942,7533939,'dmi',33.333,4),(819,7533943,7533939,'min',33.333,4),(819,7533944,7533941,'cap',16.667,1),(819,7533945,7533941,'apa',16.667,1),(819,7533946,7533941,'pac',16.667,1),(819,7533947,7533941,'aci',16.667,1),(819,7533948,7533941,'cit',16.667,1),(819,7533949,7533941,'ity',16.667,1),(819,7533950,7533944,'pat',50,1),(819,7533951,7533944,'ath',50,1),(819,7533952,7533950,'fre',14.286,1),(819,7533953,7533950,'ree',14.286,1),(819,7533954,7533950,'ees',14.286,1),(819,7533955,7533950,'esp',14.286,1),(819,7533956,7533950,'spa',14.286,1),(819,7533957,7533950,'pac',14.286,1),(819,7533958,7533950,'ace',14.286,1),(819,7533959,7533952,'dis',50,1),(819,7533960,7533952,'isk',50,1),(819,7533961,7533959,'ind',33.333,1),(819,7533962,7533959,'nde',33.333,1),(819,7533963,7533959,'dex',33.333,1),(819,7533964,7533961,'adm',8.333,1),(819,7533965,7533961,'dmi',8.333,1),(819,7533966,7533961,'min',8.333,1),(819,7533967,7533961,'ini',8.333,1),(819,7533968,7533961,'nis',8.333,1),(819,7533969,7533961,'ist',8.333,1),(819,7533970,7533961,'str',8.333,1),(819,7533971,7533961,'tra',8.333,1),(819,7533972,7533961,'rat',8.333,1),(819,7533973,7533961,'ati',8.333,1),(819,7533974,7533961,'tio',8.333,1),(819,7533975,7533961,'ion',8.333,1),(819,7533976,7533964,'sta',33.333,3),(819,7533977,7533964,'tat',33.333,3),(819,7533978,7533964,'ate',33.333,3),(819,7533979,7533976,'dis',16.667,4),(819,7533980,7533976,'isa',16.667,4),(819,7533981,7533976,'sab',16.667,4),(819,7533982,7533976,'abl',16.667,4),(819,7533983,7533976,'ble',16.667,4),(819,7533984,7533976,'led',16.667,4),(819,7533985,7533979,'cac',33.333,1),(819,7533986,7533979,'ach',33.333,1),(819,7533987,7533979,'che',33.333,1),(819,7533988,7533985,'mod',50,1),(819,7533989,7533985,'ode',50,1),(819,7533990,7533988,'wri',14.286,1),(819,7533991,7533988,'rit',14.286,1),(819,7533992,7533988,'ite',14.286,1),(819,7533993,7533988,'tet',14.286,1),(819,7533994,7533988,'eth',14.286,1),(819,7533995,7533988,'thr',14.286,1),(819,7533996,7533988,'hru',14.286,1),(819,7533997,7533990,'ope',11.111,2),(819,7533998,7533990,'per',11.111,2),(819,7533999,7533990,'era',11.111,2),(819,7534000,7533990,'rat',11.111,2),(819,7534001,7533990,'ati',11.111,2),(819,7534002,7533990,'tio',11.111,2),(819,7534003,7533990,'ion',11.111,2),(819,7534004,7533990,'ona',11.111,2),(819,7534005,7533990,'nal',11.111,2),(819,7534006,7533997,'mes',20,1),(819,7534007,7533997,'ess',20,1),(819,7534008,7533997,'ssa',20,1),(819,7534009,7533997,'sag',20,1),(819,7534010,7533997,'age',20,1),(819,7534011,7534006,'per',11.111,1),(819,7534012,7534006,'erf',11.111,1),(819,7534013,7534006,'rfo',11.111,1),(819,7534014,7534006,'for',11.111,1),(819,7534015,7534006,'orm',11.111,1),(819,7534016,7534006,'rma',11.111,1),(819,7534017,7534006,'man',11.111,1),(819,7534018,7534006,'anc',11.111,1),(819,7534019,7534006,'nce',11.111,1),(819,7534020,7534011,'ide',12.5,1),(819,7534021,7534011,'den',12.5,1),(819,7534022,7534011,'ent',12.5,1),(819,7534023,7534011,'nti',12.5,1),(819,7534024,7534011,'tif',12.5,1),(819,7534025,7534011,'ifi',12.5,1),(819,7534026,7534011,'fie',12.5,1),(819,7534027,7534011,'ier',12.5,1),(819,7534028,7534020,'vdi',33.333,3),(819,7534029,7534020,'dis',33.333,3),(819,7534030,7534020,'isk',33.333,3),(819,7534031,7534028,'nam',50,1),(819,7534032,7534028,'ame',50,1),(819,7534033,7534031,'typ',50,1),(819,7534034,7534031,'ype',50,1),(819,7534035,7534033,'dir',25,1),(819,7534036,7534033,'ire',25,1),(819,7534037,7534033,'rec',25,1),(819,7534038,7534033,'ect',25,1),(820,7534040,7534039,'naa',100,2),(820,7534041,7534040,'600',3.333,3),(820,7534042,7534040,'000',3.333,3),(820,7534043,7534040,'00c',3.333,3),(820,7534044,7534040,'0c2',3.333,3),(820,7534045,7534040,'c29',3.333,3),(820,7534046,7534040,'29f',3.333,3),(820,7534047,7534040,'9fc',3.333,3),(820,7534048,7534040,'fc9',3.333,3),(820,7534049,7534040,'c94',3.333,3),(820,7534050,7534040,'94a',3.333,3),(820,7534051,7534040,'4a1',3.333,3),(820,7534052,7534040,'a17',3.333,3),(820,7534053,7534040,'179',3.333,3),(820,7534054,7534040,'79b',3.333,3),(820,7534055,7534040,'9b7',3.333,3),(820,7534056,7534040,'b70',3.333,3),(820,7534057,7534040,'70b',3.333,3),(820,7534058,7534040,'0b4',3.333,3),(820,7534059,7534040,'b4e',3.333,3),(820,7534060,7534040,'4ee',3.333,3),(820,7534061,7534040,'ee8',3.333,3),(820,7534062,7534040,'e8e',3.333,3),(820,7534063,7534040,'8ef',3.333,3),(820,7534064,7534040,'ef2',3.333,3),(820,7534065,7534040,'f2c',3.333,3),(820,7534066,7534040,'2cb',3.333,3),(820,7534067,7534040,'cbc',3.333,3),(820,7534068,7534040,'bc4',3.333,3),(820,7534069,7534040,'c4e',3.333,3),(820,7534070,7534040,'4e8',3.333,3),(820,7534071,7534041,'mon',100,1),(820,7534072,7534071,'201',50,1),(820,7534073,7534071,'013',50,1),(820,7534074,7534072,'adm',33.333,4),(820,7534075,7534072,'dmi',33.333,4),(820,7534076,7534072,'min',33.333,4),(820,7534077,7534074,'cap',16.667,1),(820,7534078,7534074,'apa',16.667,1),(820,7534079,7534074,'pac',16.667,1),(820,7534080,7534074,'aci',16.667,1),(820,7534081,7534074,'cit',16.667,1),(820,7534082,7534074,'ity',16.667,1),(820,7534083,7534077,'pat',50,1),(820,7534084,7534077,'ath',50,1),(820,7534085,7534083,'fre',14.286,1),(820,7534086,7534083,'ree',14.286,1),(820,7534087,7534083,'ees',14.286,1),(820,7534088,7534083,'esp',14.286,1),(820,7534089,7534083,'spa',14.286,1),(820,7534090,7534083,'pac',14.286,1),(820,7534091,7534083,'ace',14.286,1),(820,7534092,7534085,'dis',50,1),(820,7534093,7534085,'isk',50,1),(820,7534094,7534092,'ind',33.333,1),(820,7534095,7534092,'nde',33.333,1),(820,7534096,7534092,'dex',33.333,1),(820,7534097,7534094,'adm',8.333,1),(820,7534098,7534094,'dmi',8.333,1),(820,7534099,7534094,'min',8.333,1),(820,7534100,7534094,'ini',8.333,1),(820,7534101,7534094,'nis',8.333,1),(820,7534102,7534094,'ist',8.333,1),(820,7534103,7534094,'str',8.333,1),(820,7534104,7534094,'tra',8.333,1),(820,7534105,7534094,'rat',8.333,1),(820,7534106,7534094,'ati',8.333,1),(820,7534107,7534094,'tio',8.333,1),(820,7534108,7534094,'ion',8.333,1),(820,7534109,7534097,'sta',33.333,3),(820,7534110,7534097,'tat',33.333,3),(820,7534111,7534097,'ate',33.333,3),(820,7534112,7534109,'dis',16.667,4),(820,7534113,7534109,'isa',16.667,4),(820,7534114,7534109,'sab',16.667,4),(820,7534115,7534109,'abl',16.667,4),(820,7534116,7534109,'ble',16.667,4),(820,7534117,7534109,'led',16.667,4),(820,7534118,7534112,'cac',33.333,1),(820,7534119,7534112,'ach',33.333,1),(820,7534120,7534112,'che',33.333,1),(820,7534121,7534118,'mod',50,1),(820,7534122,7534118,'ode',50,1),(820,7534123,7534121,'wri',14.286,1),(820,7534124,7534121,'rit',14.286,1),(820,7534125,7534121,'ite',14.286,1),(820,7534126,7534121,'tet',14.286,1),(820,7534127,7534121,'eth',14.286,1),(820,7534128,7534121,'thr',14.286,1),(820,7534129,7534121,'hru',14.286,1),(820,7534130,7534123,'ope',11.111,2),(820,7534131,7534123,'per',11.111,2),(820,7534132,7534123,'era',11.111,2),(820,7534133,7534123,'rat',11.111,2),(820,7534134,7534123,'ati',11.111,2),(820,7534135,7534123,'tio',11.111,2),(820,7534136,7534123,'ion',11.111,2),(820,7534137,7534123,'ona',11.111,2),(820,7534138,7534123,'nal',11.111,2),(820,7534139,7534130,'mes',20,1),(820,7534140,7534130,'ess',20,1),(820,7534141,7534130,'ssa',20,1),(820,7534142,7534130,'sag',20,1),(820,7534143,7534130,'age',20,1),(820,7534144,7534139,'per',11.111,1),(820,7534145,7534139,'erf',11.111,1),(820,7534146,7534139,'rfo',11.111,1),(820,7534147,7534139,'for',11.111,1),(820,7534148,7534139,'orm',11.111,1),(820,7534149,7534139,'rma',11.111,1),(820,7534150,7534139,'man',11.111,1),(820,7534151,7534139,'anc',11.111,1),(820,7534152,7534139,'nce',11.111,1),(820,7534153,7534144,'ide',12.5,1),(820,7534154,7534144,'den',12.5,1),(820,7534155,7534144,'ent',12.5,1),(820,7534156,7534144,'nti',12.5,1),(820,7534157,7534144,'tif',12.5,1),(820,7534158,7534144,'ifi',12.5,1),(820,7534159,7534144,'fie',12.5,1),(820,7534160,7534144,'ier',12.5,1),(820,7534161,7534153,'vdi',33.333,3),(820,7534162,7534153,'dis',33.333,3),(820,7534163,7534153,'isk',33.333,3),(820,7534164,7534161,'nam',50,1),(820,7534165,7534161,'ame',50,1),(820,7534166,7534164,'typ',50,1),(820,7534167,7534164,'ype',50,1),(820,7534168,7534166,'dir',25,1),(820,7534169,7534166,'ire',25,1),(820,7534170,7534166,'rec',25,1),(820,7534171,7534166,'ect',25,1),(821,7534173,7534172,'naa',100,2),(821,7534174,7534173,'600',3.333,3),(821,7534175,7534173,'000',3.333,3),(821,7534176,7534173,'00c',3.333,3),(821,7534177,7534173,'0c2',3.333,3),(821,7534178,7534173,'c29',3.333,3),(821,7534179,7534173,'29a',3.333,3),(821,7534180,7534173,'9af',3.333,3),(821,7534181,7534173,'afe',3.333,3),(821,7534182,7534173,'fe5',3.333,3),(821,7534183,7534173,'e5d',3.333,3),(821,7534184,7534173,'5d5',3.333,3),(821,7534185,7534173,'d55',3.333,3),(821,7534186,7534173,'55b',3.333,3),(821,7534187,7534173,'5b8',3.333,3),(821,7534188,7534173,'b8f',3.333,3),(821,7534189,7534173,'8f3',3.333,3),(821,7534190,7534173,'f3a',3.333,3),(821,7534191,7534173,'3a6',3.333,3),(821,7534192,7534173,'a66',3.333,3),(821,7534193,7534173,'662',3.333,3),(821,7534194,7534173,'62f',3.333,3),(821,7534195,7534173,'2f0',3.333,3),(821,7534196,7534173,'f07',3.333,3),(821,7534197,7534173,'07c',3.333,3),(821,7534198,7534173,'7c7',3.333,3),(821,7534199,7534173,'c7f',3.333,3),(821,7534200,7534173,'7fa',3.333,3),(821,7534201,7534173,'fae',3.333,3),(821,7534202,7534173,'ae2',3.333,3),(821,7534203,7534173,'e2c',3.333,3),(821,7534204,7534174,'mon',100,1),(821,7534205,7534204,'201',50,1),(821,7534206,7534204,'013',50,1),(821,7534207,7534205,'adm',33.333,4),(821,7534208,7534205,'dmi',33.333,4),(821,7534209,7534205,'min',33.333,4),(821,7534210,7534207,'cap',16.667,1),(821,7534211,7534207,'apa',16.667,1),(821,7534212,7534207,'pac',16.667,1),(821,7534213,7534207,'aci',16.667,1),(821,7534214,7534207,'cit',16.667,1),(821,7534215,7534207,'ity',16.667,1),(821,7534216,7534210,'pat',50,1),(821,7534217,7534210,'ath',50,1),(821,7534218,7534216,'fre',14.286,1),(821,7534219,7534216,'ree',14.286,1),(821,7534220,7534216,'ees',14.286,1),(821,7534221,7534216,'esp',14.286,1),(821,7534222,7534216,'spa',14.286,1),(821,7534223,7534216,'pac',14.286,1),(821,7534224,7534216,'ace',14.286,1),(821,7534225,7534218,'dis',50,1),(821,7534226,7534218,'isk',50,1),(821,7534227,7534225,'ind',33.333,1),(821,7534228,7534225,'nde',33.333,1),(821,7534229,7534225,'dex',33.333,1),(821,7534230,7534227,'adm',8.333,1),(821,7534231,7534227,'dmi',8.333,1),(821,7534232,7534227,'min',8.333,1),(821,7534233,7534227,'ini',8.333,1),(821,7534234,7534227,'nis',8.333,1),(821,7534235,7534227,'ist',8.333,1),(821,7534236,7534227,'str',8.333,1),(821,7534237,7534227,'tra',8.333,1),(821,7534238,7534227,'rat',8.333,1),(821,7534239,7534227,'ati',8.333,1),(821,7534240,7534227,'tio',8.333,1),(821,7534241,7534227,'ion',8.333,1),(821,7534242,7534230,'sta',33.333,3),(821,7534243,7534230,'tat',33.333,3),(821,7534244,7534230,'ate',33.333,3),(821,7534245,7534242,'dis',16.667,4),(821,7534246,7534242,'isa',16.667,4),(821,7534247,7534242,'sab',16.667,4),(821,7534248,7534242,'abl',16.667,4),(821,7534249,7534242,'ble',16.667,4),(821,7534250,7534242,'led',16.667,4),(821,7534251,7534245,'cac',33.333,1),(821,7534252,7534245,'ach',33.333,1),(821,7534253,7534245,'che',33.333,1),(821,7534254,7534251,'mod',50,1),(821,7534255,7534251,'ode',50,1),(821,7534256,7534254,'wri',14.286,1),(821,7534257,7534254,'rit',14.286,1),(821,7534258,7534254,'ite',14.286,1),(821,7534259,7534254,'tet',14.286,1),(821,7534260,7534254,'eth',14.286,1),(821,7534261,7534254,'thr',14.286,1),(821,7534262,7534254,'hru',14.286,1),(821,7534263,7534256,'ope',11.111,2),(821,7534264,7534256,'per',11.111,2),(821,7534265,7534256,'era',11.111,2),(821,7534266,7534256,'rat',11.111,2),(821,7534267,7534256,'ati',11.111,2),(821,7534268,7534256,'tio',11.111,2),(821,7534269,7534256,'ion',11.111,2),(821,7534270,7534256,'ona',11.111,2),(821,7534271,7534256,'nal',11.111,2),(821,7534272,7534263,'mes',20,1),(821,7534273,7534263,'ess',20,1),(821,7534274,7534263,'ssa',20,1),(821,7534275,7534263,'sag',20,1),(821,7534276,7534263,'age',20,1),(821,7534277,7534272,'per',11.111,1),(821,7534278,7534272,'erf',11.111,1),(821,7534279,7534272,'rfo',11.111,1),(821,7534280,7534272,'for',11.111,1),(821,7534281,7534272,'orm',11.111,1),(821,7534282,7534272,'rma',11.111,1),(821,7534283,7534272,'man',11.111,1),(821,7534284,7534272,'anc',11.111,1),(821,7534285,7534272,'nce',11.111,1),(821,7534286,7534277,'ide',12.5,1),(821,7534287,7534277,'den',12.5,1),(821,7534288,7534277,'ent',12.5,1),(821,7534289,7534277,'nti',12.5,1),(821,7534290,7534277,'tif',12.5,1),(821,7534291,7534277,'ifi',12.5,1),(821,7534292,7534277,'fie',12.5,1),(821,7534293,7534277,'ier',12.5,1),(821,7534294,7534286,'vdi',33.333,3),(821,7534295,7534286,'dis',33.333,3),(821,7534296,7534286,'isk',33.333,3),(821,7534297,7534294,'nam',50,1),(821,7534298,7534294,'ame',50,1),(821,7534299,7534297,'typ',50,1),(821,7534300,7534297,'ype',50,1),(821,7534301,7534299,'dir',25,1),(821,7534302,7534299,'ire',25,1),(821,7534303,7534299,'rec',25,1),(821,7534304,7534299,'ect',25,1),(822,7534306,7534305,'naa',100,2),(822,7534307,7534306,'600',3.333,3),(822,7534308,7534306,'000',3.333,3),(822,7534309,7534306,'00c',3.333,3),(822,7534310,7534306,'0c2',3.333,3),(822,7534311,7534306,'c29',3.333,3),(822,7534312,7534306,'293',3.333,3),(822,7534313,7534306,'93d',3.333,3),(822,7534314,7534306,'3dc',3.333,3),(822,7534315,7534306,'dc4',3.333,3),(822,7534316,7534306,'c43',3.333,3),(822,7534317,7534306,'43c',3.333,3),(822,7534318,7534306,'3c8',3.333,3),(822,7534319,7534306,'c87',3.333,3),(822,7534320,7534306,'874',3.333,3),(822,7534321,7534306,'748',3.333,3),(822,7534322,7534306,'483',3.333,3),(822,7534323,7534306,'836',3.333,3),(822,7534324,7534306,'36a',3.333,3),(822,7534325,7534306,'6a2',3.333,3),(822,7534326,7534306,'a25',3.333,3),(822,7534327,7534306,'257',3.333,3),(822,7534328,7534306,'57b',3.333,3),(822,7534329,7534306,'7b3',3.333,3),(822,7534330,7534306,'b3b',3.333,3),(822,7534331,7534306,'3bf',3.333,3),(822,7534332,7534306,'bf4',3.333,3),(822,7534333,7534306,'f4c',3.333,3),(822,7534334,7534306,'4c5',3.333,3),(822,7534335,7534306,'c5f',3.333,3),(822,7534336,7534306,'5f8',3.333,3),(822,7534337,7534307,'mon',100,1),(822,7534338,7534337,'201',50,1),(822,7534339,7534337,'013',50,1),(822,7534340,7534338,'adm',33.333,4),(822,7534341,7534338,'dmi',33.333,4),(822,7534342,7534338,'min',33.333,4),(822,7534343,7534340,'cap',16.667,1),(822,7534344,7534340,'apa',16.667,1),(822,7534345,7534340,'pac',16.667,1),(822,7534346,7534340,'aci',16.667,1),(822,7534347,7534340,'cit',16.667,1),(822,7534348,7534340,'ity',16.667,1),(822,7534349,7534343,'pat',50,1),(822,7534350,7534343,'ath',50,1),(822,7534351,7534349,'two',100,1),(822,7534352,7534351,'fre',14.286,1),(822,7534353,7534351,'ree',14.286,1),(822,7534354,7534351,'ees',14.286,1),(822,7534355,7534351,'esp',14.286,1),(822,7534356,7534351,'spa',14.286,1),(822,7534357,7534351,'pac',14.286,1),(822,7534358,7534351,'ace',14.286,1),(822,7534359,7534352,'dis',50,1),(822,7534360,7534352,'isk',50,1),(822,7534361,7534359,'ind',33.333,1),(822,7534362,7534359,'nde',33.333,1),(822,7534363,7534359,'dex',33.333,1),(822,7534364,7534361,'adm',8.333,1),(822,7534365,7534361,'dmi',8.333,1),(822,7534366,7534361,'min',8.333,1),(822,7534367,7534361,'ini',8.333,1),(822,7534368,7534361,'nis',8.333,1),(822,7534369,7534361,'ist',8.333,1),(822,7534370,7534361,'str',8.333,1),(822,7534371,7534361,'tra',8.333,1),(822,7534372,7534361,'rat',8.333,1),(822,7534373,7534361,'ati',8.333,1),(822,7534374,7534361,'tio',8.333,1),(822,7534375,7534361,'ion',8.333,1),(822,7534376,7534364,'sta',33.333,3),(822,7534377,7534364,'tat',33.333,3),(822,7534378,7534364,'ate',33.333,3),(822,7534379,7534376,'dis',16.667,4),(822,7534380,7534376,'isa',16.667,4),(822,7534381,7534376,'sab',16.667,4),(822,7534382,7534376,'abl',16.667,4),(822,7534383,7534376,'ble',16.667,4),(822,7534384,7534376,'led',16.667,4),(822,7534385,7534379,'cac',33.333,1),(822,7534386,7534379,'ach',33.333,1),(822,7534387,7534379,'che',33.333,1),(822,7534388,7534385,'mod',50,1),(822,7534389,7534385,'ode',50,1),(822,7534390,7534388,'wri',14.286,1),(822,7534391,7534388,'rit',14.286,1),(822,7534392,7534388,'ite',14.286,1),(822,7534393,7534388,'tet',14.286,1),(822,7534394,7534388,'eth',14.286,1),(822,7534395,7534388,'thr',14.286,1),(822,7534396,7534388,'hru',14.286,1),(822,7534397,7534390,'ope',11.111,2),(822,7534398,7534390,'per',11.111,2),(822,7534399,7534390,'era',11.111,2),(822,7534400,7534390,'rat',11.111,2),(822,7534401,7534390,'ati',11.111,2),(822,7534402,7534390,'tio',11.111,2),(822,7534403,7534390,'ion',11.111,2),(822,7534404,7534390,'ona',11.111,2),(822,7534405,7534390,'nal',11.111,2),(822,7534406,7534397,'mes',20,1),(822,7534407,7534397,'ess',20,1),(822,7534408,7534397,'ssa',20,1),(822,7534409,7534397,'sag',20,1),(822,7534410,7534397,'age',20,1),(822,7534411,7534406,'per',11.111,1),(822,7534412,7534406,'erf',11.111,1),(822,7534413,7534406,'rfo',11.111,1),(822,7534414,7534406,'for',11.111,1),(822,7534415,7534406,'orm',11.111,1),(822,7534416,7534406,'rma',11.111,1),(822,7534417,7534406,'man',11.111,1),(822,7534418,7534406,'anc',11.111,1),(822,7534419,7534406,'nce',11.111,1),(822,7534420,7534411,'ide',12.5,1),(822,7534421,7534411,'den',12.5,1),(822,7534422,7534411,'ent',12.5,1),(822,7534423,7534411,'nti',12.5,1),(822,7534424,7534411,'tif',12.5,1),(822,7534425,7534411,'ifi',12.5,1),(822,7534426,7534411,'fie',12.5,1),(822,7534427,7534411,'ier',12.5,1),(822,7534428,7534420,'vdi',33.333,3),(822,7534429,7534420,'dis',33.333,3),(822,7534430,7534420,'isk',33.333,3),(822,7534431,7534428,'nam',50,1),(822,7534432,7534428,'ame',50,1),(822,7534433,7534431,'typ',50,1),(822,7534434,7534431,'ype',50,1),(822,7534435,7534433,'dir',25,1),(822,7534436,7534433,'ire',25,1),(822,7534437,7534433,'rec',25,1),(822,7534438,7534433,'ect',25,1),(823,7534653,7534652,'att',12.5,1),(823,7534654,7534652,'ttr',12.5,1),(823,7534655,7534652,'tri',12.5,1),(823,7534656,7534652,'rib',12.5,1),(823,7534657,7534652,'ibu',12.5,1),(823,7534658,7534652,'but',12.5,1),(823,7534659,7534652,'ute',12.5,1),(823,7534660,7534652,'tes',12.5,1),(823,7534661,7534653,'ref',20,3),(823,7534662,7534653,'efr',20,3),(823,7534663,7534653,'fre',20,3),(823,7534664,7534653,'res',20,3),(823,7534665,7534653,'esh',20,3),(823,7534666,7534661,'hos',50,2),(823,7534667,7534661,'ost',50,2),(823,7534668,7534666,'nam',50,2),(823,7534669,7534666,'ame',50,2),(823,7534670,7534668,'hg3',8.333,1),(823,7534671,7534668,'g32',8.333,1),(823,7534672,7534668,'32v',8.333,1),(823,7534673,7534668,'2vm',8.333,1),(823,7534674,7534668,'vm1',8.333,1),(823,7534675,7534668,'m11',8.333,1),(823,7534676,7534668,'11w',8.333,1),(823,7534677,7534668,'1w2',8.333,1),(823,7534678,7534668,'w2k',8.333,1),(823,7534679,7534668,'2k8',8.333,1),(823,7534680,7534668,'k8r',8.333,1),(823,7534681,7534668,'8r2',8.333,1),(823,7534682,7534670,'gdl',100,1),(823,7534683,7534682,'eng',25,1),(823,7534684,7534682,'ngl',25,1),(823,7534685,7534682,'gla',25,1),(823,7534686,7534682,'lab',25,1),(823,7534687,7534683,'net',25,1),(823,7534688,7534683,'eta',25,1),(823,7534689,7534683,'tap',25,1),(823,7534690,7534683,'app',25,1),(823,7534691,7534687,'com',100,1),(823,7534692,7534691,'mem',25,3),(823,7534693,7534691,'emo',25,3),(823,7534694,7534691,'mor',25,3),(823,7534695,7534691,'ory',25,3),(823,7534696,7534692,'siz',50,2),(823,7534697,7534692,'ize',50,2),(823,7534698,7534696,'614',50,1),(823,7534699,7534696,'144',50,1),(823,7534700,7534698,'cpu',100,1),(823,7534701,7534700,'usa',33.333,3),(823,7534702,7534700,'sag',33.333,3),(823,7534703,7534700,'age',33.333,3),(823,7534704,7534701,'mhz',100,1),(823,7534705,7534704,'add',20,1),(823,7534706,7534704,'ddr',20,1),(823,7534707,7534704,'dre',20,1),(823,7534708,7534704,'res',20,1),(823,7534709,7534704,'ess',20,1),(823,7534710,7534705,'226',100,1),(823,7534711,7534710,'147',100,1),(823,7534712,7534711,'213',100,1),(823,7534713,7534712,'363',50,1),(823,7534714,7534712,'636',50,1),(823,7534715,7534713,'gue',33.333,2),(823,7534716,7534713,'ues',33.333,2),(823,7534717,7534713,'est',33.333,2),(823,7534718,7534715,'vmw',25,2),(823,7534719,7534715,'mwa',25,2),(823,7534720,7534715,'war',25,2),(823,7534721,7534715,'are',25,2),(823,7534722,7534718,'too',33.333,2),(823,7534723,7534718,'ool',33.333,2),(823,7534724,7534718,'ols',33.333,2),(823,7534725,7534722,'run',20,1),(823,7534726,7534722,'unn',20,1),(823,7534727,7534722,'nni',20,1),(823,7534728,7534722,'nin',20,1),(823,7534729,7534722,'ing',20,1),(823,7534730,7534725,'and',100,1),(823,7534731,7534730,'the',100,1),(823,7534732,7534731,'ver',20,2),(823,7534733,7534731,'ers',20,2),(823,7534734,7534731,'rsi',20,2),(823,7534735,7534731,'sio',20,2),(823,7534736,7534731,'ion',20,2),(823,7534737,7534732,'cur',20,1),(823,7534738,7534732,'urr',20,1),(823,7534739,7534732,'rre',20,1),(823,7534740,7534732,'ren',20,1),(823,7534741,7534732,'ent',20,1),(823,7534742,7534737,'mic',14.286,1),(823,7534743,7534737,'icr',14.286,1),(823,7534744,7534737,'cro',14.286,1),(823,7534745,7534737,'ros',14.286,1),(823,7534746,7534737,'oso',14.286,1),(823,7534747,7534737,'sof',14.286,1),(823,7534748,7534737,'oft',14.286,1),(823,7534749,7534742,'win',20,1),(823,7534750,7534742,'ind',20,1),(823,7534751,7534742,'ndo',20,1),(823,7534752,7534742,'dow',20,1),(823,7534753,7534742,'ows',20,1),(823,7534754,7534749,'ser',25,1),(823,7534755,7534749,'erv',25,1),(823,7534756,7534749,'rve',25,1),(823,7534757,7534749,'ver',25,1),(823,7534758,7534754,'200',50,1),(823,7534759,7534754,'008',50,1),(823,7534760,7534758,'64b',33.333,1),(823,7534761,7534758,'4bi',33.333,1),(823,7534762,7534758,'bit',33.333,1),(823,7534763,7534760,'pat',50,1),(823,7534764,7534760,'ath',50,1),(823,7534765,7534763,'rx6',33.333,1),(823,7534766,7534763,'x60',33.333,1),(823,7534767,7534763,'600',33.333,1),(823,7534768,7534765,'vmf',20,1),(823,7534769,7534765,'mfi',20,1),(823,7534770,7534765,'fil',20,1),(823,7534771,7534765,'ile',20,1),(823,7534772,7534765,'les',20,1),(823,7534773,7534768,'hgw',8.333,2),(823,7534774,7534768,'gw2',8.333,2),(823,7534775,7534768,'w2k',8.333,2),(823,7534776,7534768,'2k8',8.333,2),(823,7534777,7534768,'k8r',8.333,2),(823,7534778,7534768,'8r2',8.333,2),(823,7534779,7534768,'r23',8.333,2),(823,7534780,7534768,'232',8.333,2),(823,7534781,7534768,'32v',8.333,2),(823,7534782,7534768,'2vm',8.333,2),(823,7534783,7534768,'vm1',8.333,2),(823,7534784,7534768,'m11',8.333,2),(823,7534785,7534773,'vmx',100,1),(823,7534786,7534785,'fla',33.333,1),(823,7534787,7534785,'las',33.333,1),(823,7534788,7534785,'ash',33.333,1),(823,7534789,7534786,'acc',33.333,1),(823,7534790,7534786,'cce',33.333,1),(823,7534791,7534786,'cel',33.333,1),(823,7534792,7534789,'con',9.091,1),(823,7534793,7534789,'onf',9.091,1),(823,7534794,7534789,'nfi',9.091,1),(823,7534795,7534789,'fig',9.091,1),(823,7534796,7534789,'igu',9.091,1),(823,7534797,7534789,'gur',9.091,1),(823,7534798,7534789,'ura',9.091,1),(823,7534799,7534789,'rat',9.091,1),(823,7534800,7534789,'ati',9.091,1),(823,7534801,7534789,'tio',9.091,1),(823,7534802,7534789,'ion',9.091,1),(823,7534803,7534792,'age',33.333,1),(823,7534804,7534792,'gen',33.333,1),(823,7534805,7534792,'ent',33.333,1),(823,7534806,7534803,'193',16.667,1),(823,7534807,7534803,'938',16.667,1),(823,7534808,7534803,'380',16.667,1),(823,7534809,7534803,'809',16.667,1),(823,7534810,7534803,'097',16.667,1),(823,7534811,7534803,'979',16.667,1),(823,7534812,7534806,'cac',33.333,3),(823,7534813,7534806,'ach',33.333,3),(823,7534814,7534806,'che',33.333,3),(823,7534815,7534812,'sta',33.333,2),(823,7534816,7534812,'tat',33.333,2),(823,7534817,7534812,'ate',33.333,2),(823,7534818,7534815,'dis',16.667,3),(823,7534819,7534815,'isa',16.667,3),(823,7534820,7534815,'sab',16.667,3),(823,7534821,7534815,'abl',16.667,3),(823,7534822,7534815,'ble',16.667,3),(823,7534823,7534815,'led',16.667,3),(823,7534824,7534818,'ope',11.111,2),(823,7534825,7534818,'per',11.111,2),(823,7534826,7534818,'era',11.111,2),(823,7534827,7534818,'rat',11.111,2),(823,7534828,7534818,'ati',11.111,2),(823,7534829,7534818,'tio',11.111,2),(823,7534830,7534818,'ion',11.111,2),(823,7534831,7534818,'ona',11.111,2),(823,7534832,7534818,'nal',11.111,2),(823,7534833,7534824,'mod',50,1),(823,7534834,7534824,'ode',50,1),(823,7534835,7534833,'wri',14.286,1),(823,7534836,7534833,'rit',14.286,1),(823,7534837,7534833,'ite',14.286,1),(823,7534838,7534833,'tet',14.286,1),(823,7534839,7534833,'eth',14.286,1),(823,7534840,7534833,'thr',14.286,1),(823,7534841,7534833,'hru',14.286,1),(823,7534842,7534835,'mes',20,1),(823,7534843,7534835,'ess',20,1),(823,7534844,7534835,'ssa',20,1),(823,7534845,7534835,'sag',20,1),(823,7534846,7534835,'age',20,1),(823,7534847,7534842,'adm',33.333,1),(823,7534848,7534842,'dmi',33.333,1),(823,7534849,7534842,'min',33.333,1),(823,7534850,7534847,'met',20,3),(823,7534851,7534847,'etr',20,3),(823,7534852,7534847,'tri',20,3),(823,7534853,7534847,'ric',20,3),(823,7534854,7534847,'ics',20,3),(823,7534855,7534850,'ena',20,1),(823,7534856,7534850,'nab',20,1),(823,7534857,7534850,'abl',20,1),(823,7534858,7534850,'ble',20,1),(823,7534859,7534850,'led',20,1),(823,7534860,7534855,'vir',20,1),(823,7534861,7534855,'irt',20,1),(823,7534862,7534855,'rtu',20,1),(823,7534863,7534855,'tua',20,1),(823,7534864,7534855,'ual',20,1),(823,7534865,7534860,'dis',50,1),(823,7534866,7534860,'isk',50,1),(824,7534868,7534867,'naa',100,2),(824,7534869,7534868,'600',3.333,3),(824,7534870,7534868,'000',3.333,3),(824,7534871,7534868,'00c',3.333,3),(824,7534872,7534868,'0c2',3.333,3),(824,7534873,7534868,'c29',3.333,3),(824,7534874,7534868,'29a',3.333,3),(824,7534875,7534868,'9a1',3.333,3),(824,7534876,7534868,'a17',3.333,3),(824,7534877,7534868,'173',3.333,3),(824,7534878,7534868,'737',3.333,3),(824,7534879,7534868,'373',3.333,3),(824,7534880,7534868,'733',3.333,3),(824,7534881,7534868,'331',3.333,3),(824,7534882,7534868,'31e',3.333,3),(824,7534883,7534868,'1e5',3.333,3),(824,7534884,7534868,'e5a',3.333,3),(824,7534885,7534868,'5a5',3.333,3),(824,7534886,7534868,'a59',3.333,3),(824,7534887,7534868,'597',3.333,3),(824,7534888,7534868,'97f',3.333,3),(824,7534889,7534868,'7f4',3.333,3),(824,7534890,7534868,'f48',3.333,3),(824,7534891,7534868,'480',3.333,3),(824,7534892,7534868,'802',3.333,3),(824,7534893,7534868,'025',3.333,3),(824,7534894,7534868,'253',3.333,3),(824,7534895,7534868,'539',3.333,3),(824,7534896,7534868,'399',3.333,3),(824,7534897,7534868,'998',3.333,3),(824,7534898,7534868,'980',3.333,3),(824,7534899,7534869,'mon',100,1),(824,7534900,7534899,'201',50,1),(824,7534901,7534899,'013',50,1),(824,7534902,7534900,'adm',33.333,4),(824,7534903,7534900,'dmi',33.333,4),(824,7534904,7534900,'min',33.333,4),(824,7534905,7534902,'cap',16.667,1),(824,7534906,7534902,'apa',16.667,1),(824,7534907,7534902,'pac',16.667,1),(824,7534908,7534902,'aci',16.667,1),(824,7534909,7534902,'cit',16.667,1),(824,7534910,7534902,'ity',16.667,1),(824,7534911,7534905,'pat',50,1),(824,7534912,7534905,'ath',50,1),(824,7534913,7534911,'vol',25,1),(824,7534914,7534911,'olu',25,1),(824,7534915,7534911,'lum',25,1),(824,7534916,7534911,'ume',25,1),(824,7534917,7534913,'78e',3.333,1),(824,7534918,7534913,'8e3',3.333,1),(824,7534919,7534913,'e3f',3.333,1),(824,7534920,7534913,'3f1',3.333,1),(824,7534921,7534913,'f18',3.333,1),(824,7534922,7534913,'188',3.333,1),(824,7534923,7534913,'886',3.333,1),(824,7534924,7534913,'86d',3.333,1),(824,7534925,7534913,'6d8',3.333,1),(824,7534926,7534913,'d87',3.333,1),(824,7534927,7534913,'871',3.333,1),(824,7534928,7534913,'711',3.333,1),(824,7534929,7534913,'11e',3.333,1),(824,7534930,7534913,'1e1',3.333,1),(824,7534931,7534913,'e19',3.333,1),(824,7534932,7534913,'192',3.333,1),(824,7534933,7534913,'927',3.333,1),(824,7534934,7534913,'277',3.333,1),(824,7534935,7534913,'778',3.333,1),(824,7534936,7534913,'780',3.333,1),(824,7534937,7534913,'806',3.333,1),(824,7534938,7534913,'06e',3.333,1),(824,7534939,7534913,'6e6',3.333,1),(824,7534940,7534913,'e6f',3.333,1),(824,7534941,7534913,'6f6',3.333,1),(824,7534942,7534913,'f6e',3.333,1),(824,7534943,7534913,'6e6',3.333,1),(824,7534944,7534913,'e69',3.333,1),(824,7534945,7534913,'696',3.333,1),(824,7534946,7534913,'963',3.333,1),(824,7534947,7534917,'fre',14.286,1),(824,7534948,7534917,'ree',14.286,1),(824,7534949,7534917,'ees',14.286,1),(824,7534950,7534917,'esp',14.286,1),(824,7534951,7534917,'spa',14.286,1),(824,7534952,7534917,'pac',14.286,1),(824,7534953,7534917,'ace',14.286,1),(824,7534954,7534947,'dis',50,1),(824,7534955,7534947,'isk',50,1),(824,7534956,7534954,'ind',33.333,1),(824,7534957,7534954,'nde',33.333,1),(824,7534958,7534954,'dex',33.333,1),(824,7534959,7534956,'adm',8.333,1),(824,7534960,7534956,'dmi',8.333,1),(824,7534961,7534956,'min',8.333,1),(824,7534962,7534956,'ini',8.333,1),(824,7534963,7534956,'nis',8.333,1),(824,7534964,7534956,'ist',8.333,1),(824,7534965,7534956,'str',8.333,1),(824,7534966,7534956,'tra',8.333,1),(824,7534967,7534956,'rat',8.333,1),(824,7534968,7534956,'ati',8.333,1),(824,7534969,7534956,'tio',8.333,1),(824,7534970,7534956,'ion',8.333,1),(824,7534971,7534959,'sta',33.333,3),(824,7534972,7534959,'tat',33.333,3),(824,7534973,7534959,'ate',33.333,3),(824,7534974,7534971,'dis',16.667,4),(824,7534975,7534971,'isa',16.667,4),(824,7534976,7534971,'sab',16.667,4),(824,7534977,7534971,'abl',16.667,4),(824,7534978,7534971,'ble',16.667,4),(824,7534979,7534971,'led',16.667,4),(824,7534980,7534974,'cac',33.333,1),(824,7534981,7534974,'ach',33.333,1),(824,7534982,7534974,'che',33.333,1),(824,7534983,7534980,'mod',50,1),(824,7534984,7534980,'ode',50,1),(824,7534985,7534983,'wri',14.286,1),(824,7534986,7534983,'rit',14.286,1),(824,7534987,7534983,'ite',14.286,1),(824,7534988,7534983,'tet',14.286,1),(824,7534989,7534983,'eth',14.286,1),(824,7534990,7534983,'thr',14.286,1),(824,7534991,7534983,'hru',14.286,1),(824,7534992,7534985,'ope',11.111,2),(824,7534993,7534985,'per',11.111,2),(824,7534994,7534985,'era',11.111,2),(824,7534995,7534985,'rat',11.111,2),(824,7534996,7534985,'ati',11.111,2),(824,7534997,7534985,'tio',11.111,2),(824,7534998,7534985,'ion',11.111,2),(824,7534999,7534985,'ona',11.111,2),(824,7535000,7534985,'nal',11.111,2),(824,7535001,7534992,'mes',20,1),(824,7535002,7534992,'ess',20,1),(824,7535003,7534992,'ssa',20,1),(824,7535004,7534992,'sag',20,1),(824,7535005,7534992,'age',20,1),(824,7535006,7535001,'per',11.111,1),(824,7535007,7535001,'erf',11.111,1),(824,7535008,7535001,'rfo',11.111,1),(824,7535009,7535001,'for',11.111,1),(824,7535010,7535001,'orm',11.111,1),(824,7535011,7535001,'rma',11.111,1),(824,7535012,7535001,'man',11.111,1),(824,7535013,7535001,'anc',11.111,1),(824,7535014,7535001,'nce',11.111,1),(824,7535015,7535006,'ide',12.5,1),(824,7535016,7535006,'den',12.5,1),(824,7535017,7535006,'ent',12.5,1),(824,7535018,7535006,'nti',12.5,1),(824,7535019,7535006,'tif',12.5,1),(824,7535020,7535006,'ifi',12.5,1),(824,7535021,7535006,'fie',12.5,1),(824,7535022,7535006,'ier',12.5,1),(824,7535023,7535015,'vdi',33.333,3),(824,7535024,7535015,'dis',33.333,3),(824,7535025,7535015,'isk',33.333,3),(824,7535026,7535023,'nam',50,1),(824,7535027,7535023,'ame',50,1),(824,7535028,7535026,'typ',50,1),(824,7535029,7535026,'ype',50,1),(824,7535030,7535028,'dir',25,1),(824,7535031,7535028,'ire',25,1),(824,7535032,7535028,'rec',25,1),(824,7535033,7535028,'ect',25,1),(825,7535035,7535034,'naa',100,2),(825,7535036,7535035,'600',3.333,3),(825,7535037,7535035,'00a',3.333,3),(825,7535038,7535035,'0a0',3.333,3),(825,7535039,7535035,'a09',3.333,3),(825,7535040,7535035,'098',3.333,3),(825,7535041,7535035,'980',3.333,3),(825,7535042,7535035,'804',3.333,3),(825,7535043,7535035,'044',3.333,3),(825,7535044,7535035,'443',3.333,3),(825,7535045,7535035,'430',3.333,3),(825,7535046,7535035,'307',3.333,3),(825,7535047,7535035,'072',3.333,3),(825,7535048,7535035,'725',3.333,3),(825,7535049,7535035,'259',3.333,3),(825,7535050,7535035,'593',3.333,3),(825,7535051,7535035,'931',3.333,3),(825,7535052,7535035,'313',3.333,3),(825,7535053,7535035,'13f',3.333,3),(825,7535054,7535035,'3f3',3.333,3),(825,7535055,7535035,'f33',3.333,3),(825,7535056,7535035,'334',3.333,3),(825,7535057,7535035,'345',3.333,3),(825,7535058,7535035,'455',3.333,3),(825,7535059,7535035,'556',3.333,3),(825,7535060,7535035,'563',3.333,3),(825,7535061,7535035,'639',3.333,3),(825,7535062,7535035,'393',3.333,3),(825,7535063,7535035,'934',3.333,3),(825,7535064,7535035,'344',3.333,3),(825,7535065,7535035,'44f',3.333,3),(825,7535066,7535036,'mon',100,1),(825,7535067,7535066,'201',50,1),(825,7535068,7535066,'013',50,1),(825,7535069,7535067,'adm',33.333,4),(825,7535070,7535067,'dmi',33.333,4),(825,7535071,7535067,'min',33.333,4),(825,7535072,7535069,'cap',16.667,1),(825,7535073,7535069,'apa',16.667,1),(825,7535074,7535069,'pac',16.667,1),(825,7535075,7535069,'aci',16.667,1),(825,7535076,7535069,'cit',16.667,1),(825,7535077,7535069,'ity',16.667,1),(825,7535078,7535072,'pat',50,1),(825,7535079,7535072,'ath',50,1),(825,7535080,7535078,'fre',14.286,1),(825,7535081,7535078,'ree',14.286,1),(825,7535082,7535078,'ees',14.286,1),(825,7535083,7535078,'esp',14.286,1),(825,7535084,7535078,'spa',14.286,1),(825,7535085,7535078,'pac',14.286,1),(825,7535086,7535078,'ace',14.286,1),(825,7535087,7535080,'dis',50,1),(825,7535088,7535080,'isk',50,1),(825,7535089,7535087,'ind',33.333,1),(825,7535090,7535087,'nde',33.333,1),(825,7535091,7535087,'dex',33.333,1),(825,7535092,7535089,'adm',8.333,1),(825,7535093,7535089,'dmi',8.333,1),(825,7535094,7535089,'min',8.333,1),(825,7535095,7535089,'ini',8.333,1),(825,7535096,7535089,'nis',8.333,1),(825,7535097,7535089,'ist',8.333,1),(825,7535098,7535089,'str',8.333,1),(825,7535099,7535089,'tra',8.333,1),(825,7535100,7535089,'rat',8.333,1),(825,7535101,7535089,'ati',8.333,1),(825,7535102,7535089,'tio',8.333,1),(825,7535103,7535089,'ion',8.333,1),(825,7535104,7535092,'sta',33.333,3),(825,7535105,7535092,'tat',33.333,3),(825,7535106,7535092,'ate',33.333,3),(825,7535107,7535104,'dis',16.667,4),(825,7535108,7535104,'isa',16.667,4),(825,7535109,7535104,'sab',16.667,4),(825,7535110,7535104,'abl',16.667,4),(825,7535111,7535104,'ble',16.667,4),(825,7535112,7535104,'led',16.667,4),(825,7535113,7535107,'cac',33.333,1),(825,7535114,7535107,'ach',33.333,1),(825,7535115,7535107,'che',33.333,1),(825,7535116,7535113,'mod',50,1),(825,7535117,7535113,'ode',50,1),(825,7535118,7535116,'wri',14.286,1),(825,7535119,7535116,'rit',14.286,1),(825,7535120,7535116,'ite',14.286,1),(825,7535121,7535116,'tet',14.286,1),(825,7535122,7535116,'eth',14.286,1),(825,7535123,7535116,'thr',14.286,1),(825,7535124,7535116,'hru',14.286,1),(825,7535125,7535118,'ope',11.111,2),(825,7535126,7535118,'per',11.111,2),(825,7535127,7535118,'era',11.111,2),(825,7535128,7535118,'rat',11.111,2),(825,7535129,7535118,'ati',11.111,2),(825,7535130,7535118,'tio',11.111,2),(825,7535131,7535118,'ion',11.111,2),(825,7535132,7535118,'ona',11.111,2),(825,7535133,7535118,'nal',11.111,2),(825,7535134,7535125,'mes',20,1),(825,7535135,7535125,'ess',20,1),(825,7535136,7535125,'ssa',20,1),(825,7535137,7535125,'sag',20,1),(825,7535138,7535125,'age',20,1),(825,7535139,7535134,'per',11.111,1),(825,7535140,7535134,'erf',11.111,1),(825,7535141,7535134,'rfo',11.111,1),(825,7535142,7535134,'for',11.111,1),(825,7535143,7535134,'orm',11.111,1),(825,7535144,7535134,'rma',11.111,1),(825,7535145,7535134,'man',11.111,1),(825,7535146,7535134,'anc',11.111,1),(825,7535147,7535134,'nce',11.111,1),(825,7535148,7535139,'ide',12.5,1),(825,7535149,7535139,'den',12.5,1),(825,7535150,7535139,'ent',12.5,1),(825,7535151,7535139,'nti',12.5,1),(825,7535152,7535139,'tif',12.5,1),(825,7535153,7535139,'ifi',12.5,1),(825,7535154,7535139,'fie',12.5,1),(825,7535155,7535139,'ier',12.5,1),(825,7535156,7535148,'vdi',33.333,3),(825,7535157,7535148,'dis',33.333,3),(825,7535158,7535148,'isk',33.333,3),(825,7535159,7535156,'nam',50,1),(825,7535160,7535156,'ame',50,1),(825,7535161,7535159,'typ',50,1),(825,7535162,7535159,'ype',50,1),(825,7535163,7535161,'dir',25,1),(825,7535164,7535161,'ire',25,1),(825,7535165,7535161,'rec',25,1),(825,7535166,7535161,'ect',25,1),(826,7535168,7535167,'naa',100,2),(826,7535169,7535168,'600',3.333,3),(826,7535170,7535168,'00a',3.333,3),(826,7535171,7535168,'0a0',3.333,3),(826,7535172,7535168,'a09',3.333,3),(826,7535173,7535168,'098',3.333,3),(826,7535174,7535168,'980',3.333,3),(826,7535175,7535168,'804',3.333,3),(826,7535176,7535168,'044',3.333,3),(826,7535177,7535168,'443',3.333,3),(826,7535178,7535168,'430',3.333,3),(826,7535179,7535168,'307',3.333,3),(826,7535180,7535168,'072',3.333,3),(826,7535181,7535168,'725',3.333,3),(826,7535182,7535168,'259',3.333,3),(826,7535183,7535168,'593',3.333,3),(826,7535184,7535168,'931',3.333,3),(826,7535185,7535168,'313',3.333,3),(826,7535186,7535168,'13f',3.333,3),(826,7535187,7535168,'3f3',3.333,3),(826,7535188,7535168,'f33',3.333,3),(826,7535189,7535168,'334',3.333,3),(826,7535190,7535168,'345',3.333,3),(826,7535191,7535168,'455',3.333,3),(826,7535192,7535168,'556',3.333,3),(826,7535193,7535168,'563',3.333,3),(826,7535194,7535168,'639',3.333,3),(826,7535195,7535168,'393',3.333,3),(826,7535196,7535168,'934',3.333,3),(826,7535197,7535168,'345',3.333,3),(826,7535198,7535168,'450',3.333,3),(826,7535199,7535169,'mon',100,1),(826,7535200,7535199,'201',50,1),(826,7535201,7535199,'013',50,1),(826,7535202,7535200,'adm',33.333,4),(826,7535203,7535200,'dmi',33.333,4),(826,7535204,7535200,'min',33.333,4),(826,7535205,7535202,'cap',16.667,1),(826,7535206,7535202,'apa',16.667,1),(826,7535207,7535202,'pac',16.667,1),(826,7535208,7535202,'aci',16.667,1),(826,7535209,7535202,'cit',16.667,1),(826,7535210,7535202,'ity',16.667,1),(826,7535211,7535205,'pat',50,1),(826,7535212,7535205,'ath',50,1),(826,7535213,7535211,'fre',14.286,1),(826,7535214,7535211,'ree',14.286,1),(826,7535215,7535211,'ees',14.286,1),(826,7535216,7535211,'esp',14.286,1),(826,7535217,7535211,'spa',14.286,1),(826,7535218,7535211,'pac',14.286,1),(826,7535219,7535211,'ace',14.286,1),(826,7535220,7535213,'dis',50,1),(826,7535221,7535213,'isk',50,1),(826,7535222,7535220,'ind',33.333,1),(826,7535223,7535220,'nde',33.333,1),(826,7535224,7535220,'dex',33.333,1),(826,7535225,7535222,'adm',8.333,1),(826,7535226,7535222,'dmi',8.333,1),(826,7535227,7535222,'min',8.333,1),(826,7535228,7535222,'ini',8.333,1),(826,7535229,7535222,'nis',8.333,1),(826,7535230,7535222,'ist',8.333,1),(826,7535231,7535222,'str',8.333,1),(826,7535232,7535222,'tra',8.333,1),(826,7535233,7535222,'rat',8.333,1),(826,7535234,7535222,'ati',8.333,1),(826,7535235,7535222,'tio',8.333,1),(826,7535236,7535222,'ion',8.333,1),(826,7535237,7535225,'sta',33.333,3),(826,7535238,7535225,'tat',33.333,3),(826,7535239,7535225,'ate',33.333,3),(826,7535240,7535237,'dis',16.667,4),(826,7535241,7535237,'isa',16.667,4),(826,7535242,7535237,'sab',16.667,4),(826,7535243,7535237,'abl',16.667,4),(826,7535244,7535237,'ble',16.667,4),(826,7535245,7535237,'led',16.667,4),(826,7535246,7535240,'cac',33.333,1),(826,7535247,7535240,'ach',33.333,1),(826,7535248,7535240,'che',33.333,1),(826,7535249,7535246,'mod',50,1),(826,7535250,7535246,'ode',50,1),(826,7535251,7535249,'wri',14.286,1),(826,7535252,7535249,'rit',14.286,1),(826,7535253,7535249,'ite',14.286,1),(826,7535254,7535249,'tet',14.286,1),(826,7535255,7535249,'eth',14.286,1),(826,7535256,7535249,'thr',14.286,1),(826,7535257,7535249,'hru',14.286,1),(826,7535258,7535251,'ope',11.111,2),(826,7535259,7535251,'per',11.111,2),(826,7535260,7535251,'era',11.111,2),(826,7535261,7535251,'rat',11.111,2),(826,7535262,7535251,'ati',11.111,2),(826,7535263,7535251,'tio',11.111,2),(826,7535264,7535251,'ion',11.111,2),(826,7535265,7535251,'ona',11.111,2),(826,7535266,7535251,'nal',11.111,2),(826,7535267,7535258,'mes',20,1),(826,7535268,7535258,'ess',20,1),(826,7535269,7535258,'ssa',20,1),(826,7535270,7535258,'sag',20,1),(826,7535271,7535258,'age',20,1),(826,7535272,7535267,'per',11.111,1),(826,7535273,7535267,'erf',11.111,1),(826,7535274,7535267,'rfo',11.111,1),(826,7535275,7535267,'for',11.111,1),(826,7535276,7535267,'orm',11.111,1),(826,7535277,7535267,'rma',11.111,1),(826,7535278,7535267,'man',11.111,1),(826,7535279,7535267,'anc',11.111,1),(826,7535280,7535267,'nce',11.111,1),(826,7535281,7535272,'ide',12.5,1),(826,7535282,7535272,'den',12.5,1),(826,7535283,7535272,'ent',12.5,1),(826,7535284,7535272,'nti',12.5,1),(826,7535285,7535272,'tif',12.5,1),(826,7535286,7535272,'ifi',12.5,1),(826,7535287,7535272,'fie',12.5,1),(826,7535288,7535272,'ier',12.5,1),(826,7535289,7535281,'vdi',33.333,3),(826,7535290,7535281,'dis',33.333,3),(826,7535291,7535281,'isk',33.333,3),(826,7535292,7535289,'nam',50,1),(826,7535293,7535289,'ame',50,1),(826,7535294,7535292,'typ',50,1),(826,7535295,7535292,'ype',50,1),(826,7535296,7535294,'dir',25,1),(826,7535297,7535294,'ire',25,1),(826,7535298,7535294,'rec',25,1),(826,7535299,7535294,'ect',25,1),(827,7535301,7535300,'naa',100,2),(827,7535302,7535301,'600',3.333,3),(827,7535303,7535301,'00a',3.333,3),(827,7535304,7535301,'0a0',3.333,3),(827,7535305,7535301,'a09',3.333,3),(827,7535306,7535301,'098',3.333,3),(827,7535307,7535301,'980',3.333,3),(827,7535308,7535301,'804',3.333,3),(827,7535309,7535301,'044',3.333,3),(827,7535310,7535301,'443',3.333,3),(827,7535311,7535301,'430',3.333,3),(827,7535312,7535301,'307',3.333,3),(827,7535313,7535301,'075',3.333,3),(827,7535314,7535301,'753',3.333,3),(827,7535315,7535301,'535',3.333,3),(827,7535316,7535301,'357',3.333,3),(827,7535317,7535301,'573',3.333,3),(827,7535318,7535301,'732',3.333,3),(827,7535319,7535301,'32b',3.333,3),(827,7535320,7535301,'2b3',3.333,3),(827,7535321,7535301,'b33',3.333,3),(827,7535322,7535301,'334',3.333,3),(827,7535323,7535301,'345',3.333,3),(827,7535324,7535301,'457',3.333,3),(827,7535325,7535301,'571',3.333,3),(827,7535326,7535301,'715',3.333,3),(827,7535327,7535301,'153',3.333,3),(827,7535328,7535301,'533',3.333,3),(827,7535329,7535301,'336',3.333,3),(827,7535330,7535301,'362',3.333,3),(827,7535331,7535301,'62d',3.333,3),(827,7535332,7535302,'mon',100,1),(827,7535333,7535332,'201',50,1),(827,7535334,7535332,'013',50,1),(827,7535335,7535333,'adm',33.333,4),(827,7535336,7535333,'dmi',33.333,4),(827,7535337,7535333,'min',33.333,4),(827,7535338,7535335,'cap',16.667,1),(827,7535339,7535335,'apa',16.667,1),(827,7535340,7535335,'pac',16.667,1),(827,7535341,7535335,'aci',16.667,1),(827,7535342,7535335,'cit',16.667,1),(827,7535343,7535335,'ity',16.667,1),(827,7535344,7535338,'pat',50,1),(827,7535345,7535338,'ath',50,1),(827,7535346,7535344,'fre',14.286,1),(827,7535347,7535344,'ree',14.286,1),(827,7535348,7535344,'ees',14.286,1),(827,7535349,7535344,'esp',14.286,1),(827,7535350,7535344,'spa',14.286,1),(827,7535351,7535344,'pac',14.286,1),(827,7535352,7535344,'ace',14.286,1),(827,7535353,7535346,'dis',50,1),(827,7535354,7535346,'isk',50,1),(827,7535355,7535353,'ind',33.333,1),(827,7535356,7535353,'nde',33.333,1),(827,7535357,7535353,'dex',33.333,1),(827,7535358,7535355,'adm',8.333,1),(827,7535359,7535355,'dmi',8.333,1),(827,7535360,7535355,'min',8.333,1),(827,7535361,7535355,'ini',8.333,1),(827,7535362,7535355,'nis',8.333,1),(827,7535363,7535355,'ist',8.333,1),(827,7535364,7535355,'str',8.333,1),(827,7535365,7535355,'tra',8.333,1),(827,7535366,7535355,'rat',8.333,1),(827,7535367,7535355,'ati',8.333,1),(827,7535368,7535355,'tio',8.333,1),(827,7535369,7535355,'ion',8.333,1),(827,7535370,7535358,'sta',33.333,3),(827,7535371,7535358,'tat',33.333,3),(827,7535372,7535358,'ate',33.333,3),(827,7535373,7535370,'dis',16.667,4),(827,7535374,7535370,'isa',16.667,4),(827,7535375,7535370,'sab',16.667,4),(827,7535376,7535370,'abl',16.667,4),(827,7535377,7535370,'ble',16.667,4),(827,7535378,7535370,'led',16.667,4),(827,7535379,7535373,'cac',33.333,1),(827,7535380,7535373,'ach',33.333,1),(827,7535381,7535373,'che',33.333,1),(827,7535382,7535379,'mod',50,1),(827,7535383,7535379,'ode',50,1),(827,7535384,7535382,'wri',14.286,1),(827,7535385,7535382,'rit',14.286,1),(827,7535386,7535382,'ite',14.286,1),(827,7535387,7535382,'tet',14.286,1),(827,7535388,7535382,'eth',14.286,1),(827,7535389,7535382,'thr',14.286,1),(827,7535390,7535382,'hru',14.286,1),(827,7535391,7535384,'ope',11.111,2),(827,7535392,7535384,'per',11.111,2),(827,7535393,7535384,'era',11.111,2),(827,7535394,7535384,'rat',11.111,2),(827,7535395,7535384,'ati',11.111,2),(827,7535396,7535384,'tio',11.111,2),(827,7535397,7535384,'ion',11.111,2),(827,7535398,7535384,'ona',11.111,2),(827,7535399,7535384,'nal',11.111,2),(827,7535400,7535391,'mes',20,1),(827,7535401,7535391,'ess',20,1),(827,7535402,7535391,'ssa',20,1),(827,7535403,7535391,'sag',20,1),(827,7535404,7535391,'age',20,1),(827,7535405,7535400,'per',11.111,1),(827,7535406,7535400,'erf',11.111,1),(827,7535407,7535400,'rfo',11.111,1),(827,7535408,7535400,'for',11.111,1),(827,7535409,7535400,'orm',11.111,1),(827,7535410,7535400,'rma',11.111,1),(827,7535411,7535400,'man',11.111,1),(827,7535412,7535400,'anc',11.111,1),(827,7535413,7535400,'nce',11.111,1),(827,7535414,7535405,'ide',12.5,1),(827,7535415,7535405,'den',12.5,1),(827,7535416,7535405,'ent',12.5,1),(827,7535417,7535405,'nti',12.5,1),(827,7535418,7535405,'tif',12.5,1),(827,7535419,7535405,'ifi',12.5,1),(827,7535420,7535405,'fie',12.5,1),(827,7535421,7535405,'ier',12.5,1),(827,7535422,7535414,'vdi',33.333,3),(827,7535423,7535414,'dis',33.333,3),(827,7535424,7535414,'isk',33.333,3),(827,7535425,7535422,'nam',50,1),(827,7535426,7535422,'ame',50,1),(827,7535427,7535425,'typ',50,1),(827,7535428,7535425,'ype',50,1),(827,7535429,7535427,'dir',25,1),(827,7535430,7535427,'ire',25,1),(827,7535431,7535427,'rec',25,1),(827,7535432,7535427,'ect',25,1),(828,7535434,7535433,'naa',100,2),(828,7535435,7535434,'600',3.333,3),(828,7535436,7535434,'00a',3.333,3),(828,7535437,7535434,'0a0',3.333,3),(828,7535438,7535434,'a09',3.333,3),(828,7535439,7535434,'098',3.333,3),(828,7535440,7535434,'980',3.333,3),(828,7535441,7535434,'804',3.333,3),(828,7535442,7535434,'044',3.333,3),(828,7535443,7535434,'443',3.333,3),(828,7535444,7535434,'430',3.333,3),(828,7535445,7535434,'307',3.333,3),(828,7535446,7535434,'075',3.333,3),(828,7535447,7535434,'753',3.333,3),(828,7535448,7535434,'535',3.333,3),(828,7535449,7535434,'357',3.333,3),(828,7535450,7535434,'573',3.333,3),(828,7535451,7535434,'732',3.333,3),(828,7535452,7535434,'32b',3.333,3),(828,7535453,7535434,'2b3',3.333,3),(828,7535454,7535434,'b33',3.333,3),(828,7535455,7535434,'334',3.333,3),(828,7535456,7535434,'345',3.333,3),(828,7535457,7535434,'457',3.333,3),(828,7535458,7535434,'571',3.333,3),(828,7535459,7535434,'715',3.333,3),(828,7535460,7535434,'153',3.333,3),(828,7535461,7535434,'533',3.333,3),(828,7535462,7535434,'336',3.333,3),(828,7535463,7535434,'364',3.333,3),(828,7535464,7535434,'641',3.333,3),(828,7535465,7535435,'mon',100,1),(828,7535466,7535465,'201',50,1),(828,7535467,7535465,'013',50,1),(828,7535468,7535466,'adm',33.333,4),(828,7535469,7535466,'dmi',33.333,4),(828,7535470,7535466,'min',33.333,4),(828,7535471,7535468,'cap',16.667,1),(828,7535472,7535468,'apa',16.667,1),(828,7535473,7535468,'pac',16.667,1),(828,7535474,7535468,'aci',16.667,1),(828,7535475,7535468,'cit',16.667,1),(828,7535476,7535468,'ity',16.667,1),(828,7535477,7535471,'pat',50,1),(828,7535478,7535471,'ath',50,1),(828,7535479,7535477,'fre',14.286,1),(828,7535480,7535477,'ree',14.286,1),(828,7535481,7535477,'ees',14.286,1),(828,7535482,7535477,'esp',14.286,1),(828,7535483,7535477,'spa',14.286,1),(828,7535484,7535477,'pac',14.286,1),(828,7535485,7535477,'ace',14.286,1),(828,7535486,7535479,'dis',50,1),(828,7535487,7535479,'isk',50,1),(828,7535488,7535486,'ind',33.333,1),(828,7535489,7535486,'nde',33.333,1),(828,7535490,7535486,'dex',33.333,1),(828,7535491,7535488,'adm',8.333,1),(828,7535492,7535488,'dmi',8.333,1),(828,7535493,7535488,'min',8.333,1),(828,7535494,7535488,'ini',8.333,1),(828,7535495,7535488,'nis',8.333,1),(828,7535496,7535488,'ist',8.333,1),(828,7535497,7535488,'str',8.333,1),(828,7535498,7535488,'tra',8.333,1),(828,7535499,7535488,'rat',8.333,1),(828,7535500,7535488,'ati',8.333,1),(828,7535501,7535488,'tio',8.333,1),(828,7535502,7535488,'ion',8.333,1),(828,7535503,7535491,'sta',33.333,3),(828,7535504,7535491,'tat',33.333,3),(828,7535505,7535491,'ate',33.333,3),(828,7535506,7535503,'dis',16.667,4),(828,7535507,7535503,'isa',16.667,4),(828,7535508,7535503,'sab',16.667,4),(828,7535509,7535503,'abl',16.667,4),(828,7535510,7535503,'ble',16.667,4),(828,7535511,7535503,'led',16.667,4),(828,7535512,7535506,'cac',33.333,1),(828,7535513,7535506,'ach',33.333,1),(828,7535514,7535506,'che',33.333,1),(828,7535515,7535512,'mod',50,1),(828,7535516,7535512,'ode',50,1),(828,7535517,7535515,'wri',14.286,1),(828,7535518,7535515,'rit',14.286,1),(828,7535519,7535515,'ite',14.286,1),(828,7535520,7535515,'tet',14.286,1),(828,7535521,7535515,'eth',14.286,1),(828,7535522,7535515,'thr',14.286,1),(828,7535523,7535515,'hru',14.286,1),(828,7535524,7535517,'ope',11.111,2),(828,7535525,7535517,'per',11.111,2),(828,7535526,7535517,'era',11.111,2),(828,7535527,7535517,'rat',11.111,2),(828,7535528,7535517,'ati',11.111,2),(828,7535529,7535517,'tio',11.111,2),(828,7535530,7535517,'ion',11.111,2),(828,7535531,7535517,'ona',11.111,2),(828,7535532,7535517,'nal',11.111,2),(828,7535533,7535524,'mes',20,1),(828,7535534,7535524,'ess',20,1),(828,7535535,7535524,'ssa',20,1),(828,7535536,7535524,'sag',20,1),(828,7535537,7535524,'age',20,1),(828,7535538,7535533,'per',11.111,1),(828,7535539,7535533,'erf',11.111,1),(828,7535540,7535533,'rfo',11.111,1),(828,7535541,7535533,'for',11.111,1),(828,7535542,7535533,'orm',11.111,1),(828,7535543,7535533,'rma',11.111,1),(828,7535544,7535533,'man',11.111,1),(828,7535545,7535533,'anc',11.111,1),(828,7535546,7535533,'nce',11.111,1),(828,7535547,7535538,'ide',12.5,1),(828,7535548,7535538,'den',12.5,1),(828,7535549,7535538,'ent',12.5,1),(828,7535550,7535538,'nti',12.5,1),(828,7535551,7535538,'tif',12.5,1),(828,7535552,7535538,'ifi',12.5,1),(828,7535553,7535538,'fie',12.5,1),(828,7535554,7535538,'ier',12.5,1),(828,7535555,7535547,'vdi',33.333,3),(828,7535556,7535547,'dis',33.333,3),(828,7535557,7535547,'isk',33.333,3),(828,7535558,7535555,'nam',50,1),(828,7535559,7535555,'ame',50,1),(828,7535560,7535558,'typ',50,1),(828,7535561,7535558,'ype',50,1),(828,7535562,7535560,'dir',25,1),(828,7535563,7535560,'ire',25,1),(828,7535564,7535560,'rec',25,1),(828,7535565,7535560,'ect',25,1),(829,7535567,7535566,'naa',100,2),(829,7535568,7535567,'600',3.333,3),(829,7535569,7535567,'000',3.333,3),(829,7535570,7535567,'00c',3.333,3),(829,7535571,7535567,'0c2',3.333,3),(829,7535572,7535567,'c29',3.333,3),(829,7535573,7535567,'294',3.333,3),(829,7535574,7535567,'944',3.333,3),(829,7535575,7535567,'446',3.333,3),(829,7535576,7535567,'46d',3.333,3),(829,7535577,7535567,'6d8',3.333,3),(829,7535578,7535567,'d8b',3.333,3),(829,7535579,7535567,'8be',3.333,3),(829,7535580,7535567,'be4',3.333,3),(829,7535581,7535567,'e48',3.333,3),(829,7535582,7535567,'485',3.333,3),(829,7535583,7535567,'859',3.333,3),(829,7535584,7535567,'598',3.333,3),(829,7535585,7535567,'98a',3.333,3),(829,7535586,7535567,'8a2',3.333,3),(829,7535587,7535567,'a23',3.333,3),(829,7535588,7535567,'231',3.333,3),(829,7535589,7535567,'311',3.333,3),(829,7535590,7535567,'11f',3.333,3),(829,7535591,7535567,'1fc',3.333,3),(829,7535592,7535567,'fcf',3.333,3),(829,7535593,7535567,'cf7',3.333,3),(829,7535594,7535567,'f73',3.333,3),(829,7535595,7535567,'73a',3.333,3),(829,7535596,7535567,'3af',3.333,3),(829,7535597,7535567,'af6',3.333,3),(829,7535598,7535568,'mon',100,1),(829,7535599,7535598,'201',50,1),(829,7535600,7535598,'013',50,1),(829,7535601,7535599,'adm',33.333,4),(829,7535602,7535599,'dmi',33.333,4),(829,7535603,7535599,'min',33.333,4),(829,7535604,7535601,'cap',16.667,1),(829,7535605,7535601,'apa',16.667,1),(829,7535606,7535601,'pac',16.667,1),(829,7535607,7535601,'aci',16.667,1),(829,7535608,7535601,'cit',16.667,1),(829,7535609,7535601,'ity',16.667,1),(829,7535610,7535604,'pat',50,1),(829,7535611,7535604,'ath',50,1),(829,7535612,7535610,'fre',14.286,1),(829,7535613,7535610,'ree',14.286,1),(829,7535614,7535610,'ees',14.286,1),(829,7535615,7535610,'esp',14.286,1),(829,7535616,7535610,'spa',14.286,1),(829,7535617,7535610,'pac',14.286,1),(829,7535618,7535610,'ace',14.286,1),(829,7535619,7535612,'dis',50,1),(829,7535620,7535612,'isk',50,1),(829,7535621,7535619,'ind',33.333,1),(829,7535622,7535619,'nde',33.333,1),(829,7535623,7535619,'dex',33.333,1),(829,7535624,7535621,'adm',8.333,1),(829,7535625,7535621,'dmi',8.333,1),(829,7535626,7535621,'min',8.333,1),(829,7535627,7535621,'ini',8.333,1),(829,7535628,7535621,'nis',8.333,1),(829,7535629,7535621,'ist',8.333,1),(829,7535630,7535621,'str',8.333,1),(829,7535631,7535621,'tra',8.333,1),(829,7535632,7535621,'rat',8.333,1),(829,7535633,7535621,'ati',8.333,1),(829,7535634,7535621,'tio',8.333,1),(829,7535635,7535621,'ion',8.333,1),(829,7535636,7535624,'sta',33.333,3),(829,7535637,7535624,'tat',33.333,3),(829,7535638,7535624,'ate',33.333,3),(829,7535639,7535636,'dis',16.667,4),(829,7535640,7535636,'isa',16.667,4),(829,7535641,7535636,'sab',16.667,4),(829,7535642,7535636,'abl',16.667,4),(829,7535643,7535636,'ble',16.667,4),(829,7535644,7535636,'led',16.667,4),(829,7535645,7535639,'cac',33.333,1),(829,7535646,7535639,'ach',33.333,1),(829,7535647,7535639,'che',33.333,1),(829,7535648,7535645,'mod',50,1),(829,7535649,7535645,'ode',50,1),(829,7535650,7535648,'wri',14.286,1),(829,7535651,7535648,'rit',14.286,1),(829,7535652,7535648,'ite',14.286,1),(829,7535653,7535648,'tet',14.286,1),(829,7535654,7535648,'eth',14.286,1),(829,7535655,7535648,'thr',14.286,1),(829,7535656,7535648,'hru',14.286,1),(829,7535657,7535650,'ope',11.111,2),(829,7535658,7535650,'per',11.111,2),(829,7535659,7535650,'era',11.111,2),(829,7535660,7535650,'rat',11.111,2),(829,7535661,7535650,'ati',11.111,2),(829,7535662,7535650,'tio',11.111,2),(829,7535663,7535650,'ion',11.111,2),(829,7535664,7535650,'ona',11.111,2),(829,7535665,7535650,'nal',11.111,2),(829,7535666,7535657,'mes',20,1),(829,7535667,7535657,'ess',20,1),(829,7535668,7535657,'ssa',20,1),(829,7535669,7535657,'sag',20,1),(829,7535670,7535657,'age',20,1),(829,7535671,7535666,'per',11.111,1),(829,7535672,7535666,'erf',11.111,1),(829,7535673,7535666,'rfo',11.111,1),(829,7535674,7535666,'for',11.111,1),(829,7535675,7535666,'orm',11.111,1),(829,7535676,7535666,'rma',11.111,1),(829,7535677,7535666,'man',11.111,1),(829,7535678,7535666,'anc',11.111,1),(829,7535679,7535666,'nce',11.111,1),(829,7535680,7535671,'ide',12.5,1),(829,7535681,7535671,'den',12.5,1),(829,7535682,7535671,'ent',12.5,1),(829,7535683,7535671,'nti',12.5,1),(829,7535684,7535671,'tif',12.5,1),(829,7535685,7535671,'ifi',12.5,1),(829,7535686,7535671,'fie',12.5,1),(829,7535687,7535671,'ier',12.5,1),(829,7535688,7535680,'vdi',33.333,3),(829,7535689,7535680,'dis',33.333,3),(829,7535690,7535680,'isk',33.333,3),(829,7535691,7535688,'nam',50,1),(829,7535692,7535688,'ame',50,1),(829,7535693,7535691,'typ',50,1),(829,7535694,7535691,'ype',50,1),(829,7535695,7535693,'dir',25,1),(829,7535696,7535693,'ire',25,1),(829,7535697,7535693,'rec',25,1),(829,7535698,7535693,'ect',25,1),(830,7535700,7535699,'naa',100,2),(830,7535701,7535700,'600',3.333,3),(830,7535702,7535700,'000',3.333,3),(830,7535703,7535700,'00c',3.333,3),(830,7535704,7535700,'0c2',3.333,3),(830,7535705,7535700,'c29',3.333,3),(830,7535706,7535700,'290',3.333,3),(830,7535707,7535700,'90c',3.333,3),(830,7535708,7535700,'0c0',3.333,3),(830,7535709,7535700,'c05',3.333,3),(830,7535710,7535700,'056',3.333,3),(830,7535711,7535700,'562',3.333,3),(830,7535712,7535700,'629',3.333,3),(830,7535713,7535700,'296',3.333,3),(830,7535714,7535700,'964',3.333,3),(830,7535715,7535700,'64c',3.333,3),(830,7535716,7535700,'4c2',3.333,3),(830,7535717,7535700,'c2e',3.333,3),(830,7535718,7535700,'2ef',3.333,3),(830,7535719,7535700,'ef0',3.333,3),(830,7535720,7535700,'f06',3.333,3),(830,7535721,7535700,'068',3.333,3),(830,7535722,7535700,'68c',3.333,3),(830,7535723,7535700,'8c9',3.333,3),(830,7535724,7535700,'c9a',3.333,3),(830,7535725,7535700,'9ae',3.333,3),(830,7535726,7535700,'aed',3.333,3),(830,7535727,7535700,'ed2',3.333,3),(830,7535728,7535700,'d2a',3.333,3),(830,7535729,7535700,'2aa',3.333,3),(830,7535730,7535700,'aab',3.333,3),(830,7535731,7535701,'mon',100,1),(830,7535732,7535731,'201',50,1),(830,7535733,7535731,'013',50,1),(830,7535734,7535732,'adm',33.333,4),(830,7535735,7535732,'dmi',33.333,4),(830,7535736,7535732,'min',33.333,4),(830,7535737,7535734,'cap',16.667,1),(830,7535738,7535734,'apa',16.667,1),(830,7535739,7535734,'pac',16.667,1),(830,7535740,7535734,'aci',16.667,1),(830,7535741,7535734,'cit',16.667,1),(830,7535742,7535734,'ity',16.667,1),(830,7535743,7535737,'pat',50,1),(830,7535744,7535737,'ath',50,1),(830,7535745,7535743,'fre',14.286,1),(830,7535746,7535743,'ree',14.286,1),(830,7535747,7535743,'ees',14.286,1),(830,7535748,7535743,'esp',14.286,1),(830,7535749,7535743,'spa',14.286,1),(830,7535750,7535743,'pac',14.286,1),(830,7535751,7535743,'ace',14.286,1),(830,7535752,7535745,'dis',50,1),(830,7535753,7535745,'isk',50,1),(830,7535754,7535752,'ind',33.333,1),(830,7535755,7535752,'nde',33.333,1),(830,7535756,7535752,'dex',33.333,1),(830,7535757,7535754,'adm',8.333,1),(830,7535758,7535754,'dmi',8.333,1),(830,7535759,7535754,'min',8.333,1),(830,7535760,7535754,'ini',8.333,1),(830,7535761,7535754,'nis',8.333,1),(830,7535762,7535754,'ist',8.333,1),(830,7535763,7535754,'str',8.333,1),(830,7535764,7535754,'tra',8.333,1),(830,7535765,7535754,'rat',8.333,1),(830,7535766,7535754,'ati',8.333,1),(830,7535767,7535754,'tio',8.333,1),(830,7535768,7535754,'ion',8.333,1),(830,7535769,7535757,'sta',33.333,3),(830,7535770,7535757,'tat',33.333,3),(830,7535771,7535757,'ate',33.333,3),(830,7535772,7535769,'dis',16.667,4),(830,7535773,7535769,'isa',16.667,4),(830,7535774,7535769,'sab',16.667,4),(830,7535775,7535769,'abl',16.667,4),(830,7535776,7535769,'ble',16.667,4),(830,7535777,7535769,'led',16.667,4),(830,7535778,7535772,'cac',33.333,1),(830,7535779,7535772,'ach',33.333,1),(830,7535780,7535772,'che',33.333,1),(830,7535781,7535778,'mod',50,1),(830,7535782,7535778,'ode',50,1),(830,7535783,7535781,'wri',14.286,1),(830,7535784,7535781,'rit',14.286,1),(830,7535785,7535781,'ite',14.286,1),(830,7535786,7535781,'tet',14.286,1),(830,7535787,7535781,'eth',14.286,1),(830,7535788,7535781,'thr',14.286,1),(830,7535789,7535781,'hru',14.286,1),(830,7535790,7535783,'ope',11.111,2),(830,7535791,7535783,'per',11.111,2),(830,7535792,7535783,'era',11.111,2),(830,7535793,7535783,'rat',11.111,2),(830,7535794,7535783,'ati',11.111,2),(830,7535795,7535783,'tio',11.111,2),(830,7535796,7535783,'ion',11.111,2),(830,7535797,7535783,'ona',11.111,2),(830,7535798,7535783,'nal',11.111,2),(830,7535799,7535790,'mes',20,1),(830,7535800,7535790,'ess',20,1),(830,7535801,7535790,'ssa',20,1),(830,7535802,7535790,'sag',20,1),(830,7535803,7535790,'age',20,1),(830,7535804,7535799,'per',11.111,1),(830,7535805,7535799,'erf',11.111,1),(830,7535806,7535799,'rfo',11.111,1),(830,7535807,7535799,'for',11.111,1),(830,7535808,7535799,'orm',11.111,1),(830,7535809,7535799,'rma',11.111,1),(830,7535810,7535799,'man',11.111,1),(830,7535811,7535799,'anc',11.111,1),(830,7535812,7535799,'nce',11.111,1),(830,7535813,7535804,'ide',12.5,1),(830,7535814,7535804,'den',12.5,1),(830,7535815,7535804,'ent',12.5,1),(830,7535816,7535804,'nti',12.5,1),(830,7535817,7535804,'tif',12.5,1),(830,7535818,7535804,'ifi',12.5,1),(830,7535819,7535804,'fie',12.5,1),(830,7535820,7535804,'ier',12.5,1),(830,7535821,7535813,'vdi',33.333,3),(830,7535822,7535813,'dis',33.333,3),(830,7535823,7535813,'isk',33.333,3),(830,7535824,7535821,'nam',50,1),(830,7535825,7535821,'ame',50,1),(830,7535826,7535824,'typ',50,1),(830,7535827,7535824,'ype',50,1),(830,7535828,7535826,'dir',25,1),(830,7535829,7535826,'ire',25,1),(830,7535830,7535826,'rec',25,1),(830,7535831,7535826,'ect',25,1),(831,7535833,7535832,'naa',100,2),(831,7535834,7535833,'600',3.333,3),(831,7535835,7535833,'000',3.333,3),(831,7535836,7535833,'00c',3.333,3),(831,7535837,7535833,'0c2',3.333,3),(831,7535838,7535833,'c29',3.333,3),(831,7535839,7535833,'29e',3.333,3),(831,7535840,7535833,'9ec',3.333,3),(831,7535841,7535833,'ecb',3.333,3),(831,7535842,7535833,'cb8',3.333,3),(831,7535843,7535833,'b82',3.333,3),(831,7535844,7535833,'820',3.333,3),(831,7535845,7535833,'200',3.333,3),(831,7535846,7535833,'007',3.333,3),(831,7535847,7535833,'072',3.333,3),(831,7535848,7535833,'724',3.333,3),(831,7535849,7535833,'24c',3.333,3),(831,7535850,7535833,'4c2',3.333,3),(831,7535851,7535833,'c2a',3.333,3),(831,7535852,7535833,'2a4',3.333,3),(831,7535853,7535833,'a43',3.333,3),(831,7535854,7535833,'43c',3.333,3),(831,7535855,7535833,'3c3',3.333,3),(831,7535856,7535833,'c36',3.333,3),(831,7535857,7535833,'366',3.333,3),(831,7535858,7535833,'66c',3.333,3),(831,7535859,7535833,'6cc',3.333,3),(831,7535860,7535833,'cc0',3.333,3),(831,7535861,7535833,'c05',3.333,3),(831,7535862,7535833,'059',3.333,3),(831,7535863,7535833,'593',3.333,3),(831,7535864,7535834,'mon',100,1),(831,7535865,7535864,'201',50,1),(831,7535866,7535864,'013',50,1),(831,7535867,7535865,'adm',33.333,4),(831,7535868,7535865,'dmi',33.333,4),(831,7535869,7535865,'min',33.333,4),(831,7535870,7535867,'cap',16.667,1),(831,7535871,7535867,'apa',16.667,1),(831,7535872,7535867,'pac',16.667,1),(831,7535873,7535867,'aci',16.667,1),(831,7535874,7535867,'cit',16.667,1),(831,7535875,7535867,'ity',16.667,1),(831,7535876,7535870,'pat',50,1),(831,7535877,7535870,'ath',50,1),(831,7535878,7535876,'fre',14.286,1),(831,7535879,7535876,'ree',14.286,1),(831,7535880,7535876,'ees',14.286,1),(831,7535881,7535876,'esp',14.286,1),(831,7535882,7535876,'spa',14.286,1),(831,7535883,7535876,'pac',14.286,1),(831,7535884,7535876,'ace',14.286,1),(831,7535885,7535878,'dis',50,1),(831,7535886,7535878,'isk',50,1),(831,7535887,7535885,'ind',33.333,1),(831,7535888,7535885,'nde',33.333,1),(831,7535889,7535885,'dex',33.333,1),(831,7535890,7535887,'adm',8.333,1),(831,7535891,7535887,'dmi',8.333,1),(831,7535892,7535887,'min',8.333,1),(831,7535893,7535887,'ini',8.333,1),(831,7535894,7535887,'nis',8.333,1),(831,7535895,7535887,'ist',8.333,1),(831,7535896,7535887,'str',8.333,1),(831,7535897,7535887,'tra',8.333,1),(831,7535898,7535887,'rat',8.333,1),(831,7535899,7535887,'ati',8.333,1),(831,7535900,7535887,'tio',8.333,1),(831,7535901,7535887,'ion',8.333,1),(831,7535902,7535890,'sta',33.333,3),(831,7535903,7535890,'tat',33.333,3),(831,7535904,7535890,'ate',33.333,3),(831,7535905,7535902,'dis',16.667,4),(831,7535906,7535902,'isa',16.667,4),(831,7535907,7535902,'sab',16.667,4),(831,7535908,7535902,'abl',16.667,4),(831,7535909,7535902,'ble',16.667,4),(831,7535910,7535902,'led',16.667,4),(831,7535911,7535905,'cac',33.333,1),(831,7535912,7535905,'ach',33.333,1),(831,7535913,7535905,'che',33.333,1),(831,7535914,7535911,'mod',50,1),(831,7535915,7535911,'ode',50,1),(831,7535916,7535914,'wri',14.286,1),(831,7535917,7535914,'rit',14.286,1),(831,7535918,7535914,'ite',14.286,1),(831,7535919,7535914,'tet',14.286,1),(831,7535920,7535914,'eth',14.286,1),(831,7535921,7535914,'thr',14.286,1),(831,7535922,7535914,'hru',14.286,1),(831,7535923,7535916,'ope',11.111,2),(831,7535924,7535916,'per',11.111,2),(831,7535925,7535916,'era',11.111,2),(831,7535926,7535916,'rat',11.111,2),(831,7535927,7535916,'ati',11.111,2),(831,7535928,7535916,'tio',11.111,2),(831,7535929,7535916,'ion',11.111,2),(831,7535930,7535916,'ona',11.111,2),(831,7535931,7535916,'nal',11.111,2),(831,7535932,7535923,'mes',20,1),(831,7535933,7535923,'ess',20,1),(831,7535934,7535923,'ssa',20,1),(831,7535935,7535923,'sag',20,1),(831,7535936,7535923,'age',20,1),(831,7535937,7535932,'per',11.111,1),(831,7535938,7535932,'erf',11.111,1),(831,7535939,7535932,'rfo',11.111,1),(831,7535940,7535932,'for',11.111,1),(831,7535941,7535932,'orm',11.111,1),(831,7535942,7535932,'rma',11.111,1),(831,7535943,7535932,'man',11.111,1),(831,7535944,7535932,'anc',11.111,1),(831,7535945,7535932,'nce',11.111,1),(831,7535946,7535937,'ide',12.5,1),(831,7535947,7535937,'den',12.5,1),(831,7535948,7535937,'ent',12.5,1),(831,7535949,7535937,'nti',12.5,1),(831,7535950,7535937,'tif',12.5,1),(831,7535951,7535937,'ifi',12.5,1),(831,7535952,7535937,'fie',12.5,1),(831,7535953,7535937,'ier',12.5,1),(831,7535954,7535946,'vdi',33.333,3),(831,7535955,7535946,'dis',33.333,3),(831,7535956,7535946,'isk',33.333,3),(831,7535957,7535954,'nam',50,1),(831,7535958,7535954,'ame',50,1),(831,7535959,7535957,'typ',50,1),(831,7535960,7535957,'ype',50,1),(831,7535961,7535959,'dir',25,1),(831,7535962,7535959,'ire',25,1),(831,7535963,7535959,'rec',25,1),(831,7535964,7535959,'ect',25,1),(832,7535966,7535965,'naa',100,2),(832,7535967,7535966,'600',3.333,3),(832,7535968,7535966,'000',3.333,3),(832,7535969,7535966,'00c',3.333,3),(832,7535970,7535966,'0c2',3.333,3),(832,7535971,7535966,'c29',3.333,3),(832,7535972,7535966,'291',3.333,3),(832,7535973,7535966,'914',3.333,3),(832,7535974,7535966,'140',3.333,3),(832,7535975,7535966,'40c',3.333,3),(832,7535976,7535966,'0c3',3.333,3),(832,7535977,7535966,'c3d',3.333,3),(832,7535978,7535966,'3da',3.333,3),(832,7535979,7535966,'dab',3.333,3),(832,7535980,7535966,'ab4',3.333,3),(832,7535981,7535966,'b45',3.333,3),(832,7535982,7535966,'450',3.333,3),(832,7535983,7535966,'501',3.333,3),(832,7535984,7535966,'018',3.333,3),(832,7535985,7535966,'185',3.333,3),(832,7535986,7535966,'85a',3.333,3),(832,7535987,7535966,'5ad',3.333,3),(832,7535988,7535966,'ad0',3.333,3),(832,7535989,7535966,'d07',3.333,3),(832,7535990,7535966,'075',3.333,3),(832,7535991,7535966,'75d',3.333,3),(832,7535992,7535966,'5d1',3.333,3),(832,7535993,7535966,'d16',3.333,3),(832,7535994,7535966,'163',3.333,3),(832,7535995,7535966,'639',3.333,3),(832,7535996,7535966,'390',3.333,3),(832,7535997,7535967,'mon',100,1),(832,7535998,7535997,'201',50,1),(832,7535999,7535997,'013',50,1),(832,7536000,7535998,'adm',33.333,4),(832,7536001,7535998,'dmi',33.333,4),(832,7536002,7535998,'min',33.333,4),(832,7536003,7536000,'cap',16.667,1),(832,7536004,7536000,'apa',16.667,1),(832,7536005,7536000,'pac',16.667,1),(832,7536006,7536000,'aci',16.667,1),(832,7536007,7536000,'cit',16.667,1),(832,7536008,7536000,'ity',16.667,1),(832,7536009,7536003,'pat',50,1),(832,7536010,7536003,'ath',50,1),(832,7536011,7536009,'fre',14.286,1),(832,7536012,7536009,'ree',14.286,1),(832,7536013,7536009,'ees',14.286,1),(832,7536014,7536009,'esp',14.286,1),(832,7536015,7536009,'spa',14.286,1),(832,7536016,7536009,'pac',14.286,1),(832,7536017,7536009,'ace',14.286,1),(832,7536018,7536011,'dis',50,1),(832,7536019,7536011,'isk',50,1),(832,7536020,7536018,'ind',33.333,1),(832,7536021,7536018,'nde',33.333,1),(832,7536022,7536018,'dex',33.333,1),(832,7536023,7536020,'adm',8.333,1),(832,7536024,7536020,'dmi',8.333,1),(832,7536025,7536020,'min',8.333,1),(832,7536026,7536020,'ini',8.333,1),(832,7536027,7536020,'nis',8.333,1),(832,7536028,7536020,'ist',8.333,1),(832,7536029,7536020,'str',8.333,1),(832,7536030,7536020,'tra',8.333,1),(832,7536031,7536020,'rat',8.333,1),(832,7536032,7536020,'ati',8.333,1),(832,7536033,7536020,'tio',8.333,1),(832,7536034,7536020,'ion',8.333,1),(832,7536035,7536023,'sta',33.333,3),(832,7536036,7536023,'tat',33.333,3),(832,7536037,7536023,'ate',33.333,3),(832,7536038,7536035,'dis',16.667,4),(832,7536039,7536035,'isa',16.667,4),(832,7536040,7536035,'sab',16.667,4),(832,7536041,7536035,'abl',16.667,4),(832,7536042,7536035,'ble',16.667,4),(832,7536043,7536035,'led',16.667,4),(832,7536044,7536038,'cac',33.333,1),(832,7536045,7536038,'ach',33.333,1),(832,7536046,7536038,'che',33.333,1),(832,7536047,7536044,'mod',50,1),(832,7536048,7536044,'ode',50,1),(832,7536049,7536047,'wri',14.286,1),(832,7536050,7536047,'rit',14.286,1),(832,7536051,7536047,'ite',14.286,1),(832,7536052,7536047,'tet',14.286,1),(832,7536053,7536047,'eth',14.286,1),(832,7536054,7536047,'thr',14.286,1),(832,7536055,7536047,'hru',14.286,1),(832,7536056,7536049,'ope',11.111,2),(832,7536057,7536049,'per',11.111,2),(832,7536058,7536049,'era',11.111,2),(832,7536059,7536049,'rat',11.111,2),(832,7536060,7536049,'ati',11.111,2),(832,7536061,7536049,'tio',11.111,2),(832,7536062,7536049,'ion',11.111,2),(832,7536063,7536049,'ona',11.111,2),(832,7536064,7536049,'nal',11.111,2),(832,7536065,7536056,'mes',20,1),(832,7536066,7536056,'ess',20,1),(832,7536067,7536056,'ssa',20,1),(832,7536068,7536056,'sag',20,1),(832,7536069,7536056,'age',20,1),(832,7536070,7536065,'per',11.111,1),(832,7536071,7536065,'erf',11.111,1),(832,7536072,7536065,'rfo',11.111,1),(832,7536073,7536065,'for',11.111,1),(832,7536074,7536065,'orm',11.111,1),(832,7536075,7536065,'rma',11.111,1),(832,7536076,7536065,'man',11.111,1),(832,7536077,7536065,'anc',11.111,1),(832,7536078,7536065,'nce',11.111,1),(832,7536079,7536070,'ide',12.5,1),(832,7536080,7536070,'den',12.5,1),(832,7536081,7536070,'ent',12.5,1),(832,7536082,7536070,'nti',12.5,1),(832,7536083,7536070,'tif',12.5,1),(832,7536084,7536070,'ifi',12.5,1),(832,7536085,7536070,'fie',12.5,1),(832,7536086,7536070,'ier',12.5,1),(832,7536087,7536079,'vdi',33.333,3),(832,7536088,7536079,'dis',33.333,3),(832,7536089,7536079,'isk',33.333,3),(832,7536090,7536087,'nam',50,1),(832,7536091,7536087,'ame',50,1),(832,7536092,7536090,'typ',50,1),(832,7536093,7536090,'ype',50,1),(832,7536094,7536092,'dir',25,1),(832,7536095,7536092,'ire',25,1),(832,7536096,7536092,'rec',25,1),(832,7536097,7536092,'ect',25,1),(833,7536099,7536098,'naa',100,2),(833,7536100,7536099,'600',3.333,3),(833,7536101,7536099,'000',3.333,3),(833,7536102,7536099,'00c',3.333,3),(833,7536103,7536099,'0c2',3.333,3),(833,7536104,7536099,'c29',3.333,3),(833,7536105,7536099,'29a',3.333,3),(833,7536106,7536099,'9a3',3.333,3),(833,7536107,7536099,'a30',3.333,3),(833,7536108,7536099,'303',3.333,3),(833,7536109,7536099,'037',3.333,3),(833,7536110,7536099,'373',3.333,3),(833,7536111,7536099,'735',3.333,3),(833,7536112,7536099,'352',3.333,3),(833,7536113,7536099,'524',3.333,3),(833,7536114,7536099,'240',3.333,3),(833,7536115,7536099,'403',3.333,3),(833,7536116,7536099,'03e',3.333,3),(833,7536117,7536099,'3ee',3.333,3),(833,7536118,7536099,'ee1',3.333,3),(833,7536119,7536099,'e17',3.333,3),(833,7536120,7536099,'17c',3.333,3),(833,7536121,7536099,'7ce',3.333,3),(833,7536122,7536099,'ce7',3.333,3),(833,7536123,7536099,'e72',3.333,3),(833,7536124,7536099,'722',3.333,3),(833,7536125,7536099,'22c',3.333,3),(833,7536126,7536099,'2ca',3.333,3),(833,7536127,7536099,'cad',3.333,3),(833,7536128,7536099,'ad6',3.333,3),(833,7536129,7536099,'d69',3.333,3),(833,7536130,7536100,'mon',100,1),(833,7536131,7536130,'201',50,1),(833,7536132,7536130,'013',50,1),(833,7536133,7536131,'adm',33.333,4),(833,7536134,7536131,'dmi',33.333,4),(833,7536135,7536131,'min',33.333,4),(833,7536136,7536133,'cap',16.667,1),(833,7536137,7536133,'apa',16.667,1),(833,7536138,7536133,'pac',16.667,1),(833,7536139,7536133,'aci',16.667,1),(833,7536140,7536133,'cit',16.667,1),(833,7536141,7536133,'ity',16.667,1),(833,7536142,7536136,'pat',50,1),(833,7536143,7536136,'ath',50,1),(833,7536144,7536142,'fre',14.286,1),(833,7536145,7536142,'ree',14.286,1),(833,7536146,7536142,'ees',14.286,1),(833,7536147,7536142,'esp',14.286,1),(833,7536148,7536142,'spa',14.286,1),(833,7536149,7536142,'pac',14.286,1),(833,7536150,7536142,'ace',14.286,1),(833,7536151,7536144,'dis',50,1),(833,7536152,7536144,'isk',50,1),(833,7536153,7536151,'ind',33.333,1),(833,7536154,7536151,'nde',33.333,1),(833,7536155,7536151,'dex',33.333,1),(833,7536156,7536153,'adm',8.333,1),(833,7536157,7536153,'dmi',8.333,1),(833,7536158,7536153,'min',8.333,1),(833,7536159,7536153,'ini',8.333,1),(833,7536160,7536153,'nis',8.333,1),(833,7536161,7536153,'ist',8.333,1),(833,7536162,7536153,'str',8.333,1),(833,7536163,7536153,'tra',8.333,1),(833,7536164,7536153,'rat',8.333,1),(833,7536165,7536153,'ati',8.333,1),(833,7536166,7536153,'tio',8.333,1),(833,7536167,7536153,'ion',8.333,1),(833,7536168,7536156,'sta',33.333,3),(833,7536169,7536156,'tat',33.333,3),(833,7536170,7536156,'ate',33.333,3),(833,7536171,7536168,'dis',16.667,4),(833,7536172,7536168,'isa',16.667,4),(833,7536173,7536168,'sab',16.667,4),(833,7536174,7536168,'abl',16.667,4),(833,7536175,7536168,'ble',16.667,4),(833,7536176,7536168,'led',16.667,4),(833,7536177,7536171,'cac',33.333,1),(833,7536178,7536171,'ach',33.333,1),(833,7536179,7536171,'che',33.333,1),(833,7536180,7536177,'mod',50,1),(833,7536181,7536177,'ode',50,1),(833,7536182,7536180,'wri',14.286,1),(833,7536183,7536180,'rit',14.286,1),(833,7536184,7536180,'ite',14.286,1),(833,7536185,7536180,'tet',14.286,1),(833,7536186,7536180,'eth',14.286,1),(833,7536187,7536180,'thr',14.286,1),(833,7536188,7536180,'hru',14.286,1),(833,7536189,7536182,'ope',11.111,2),(833,7536190,7536182,'per',11.111,2),(833,7536191,7536182,'era',11.111,2),(833,7536192,7536182,'rat',11.111,2),(833,7536193,7536182,'ati',11.111,2),(833,7536194,7536182,'tio',11.111,2),(833,7536195,7536182,'ion',11.111,2),(833,7536196,7536182,'ona',11.111,2),(833,7536197,7536182,'nal',11.111,2),(833,7536198,7536189,'mes',20,1),(833,7536199,7536189,'ess',20,1),(833,7536200,7536189,'ssa',20,1),(833,7536201,7536189,'sag',20,1),(833,7536202,7536189,'age',20,1),(833,7536203,7536198,'per',11.111,1),(833,7536204,7536198,'erf',11.111,1),(833,7536205,7536198,'rfo',11.111,1),(833,7536206,7536198,'for',11.111,1),(833,7536207,7536198,'orm',11.111,1),(833,7536208,7536198,'rma',11.111,1),(833,7536209,7536198,'man',11.111,1),(833,7536210,7536198,'anc',11.111,1),(833,7536211,7536198,'nce',11.111,1),(833,7536212,7536203,'ide',12.5,1),(833,7536213,7536203,'den',12.5,1),(833,7536214,7536203,'ent',12.5,1),(833,7536215,7536203,'nti',12.5,1),(833,7536216,7536203,'tif',12.5,1),(833,7536217,7536203,'ifi',12.5,1),(833,7536218,7536203,'fie',12.5,1),(833,7536219,7536203,'ier',12.5,1),(833,7536220,7536212,'vdi',33.333,3),(833,7536221,7536212,'dis',33.333,3),(833,7536222,7536212,'isk',33.333,3),(833,7536223,7536220,'nam',50,1),(833,7536224,7536220,'ame',50,1),(833,7536225,7536223,'typ',50,1),(833,7536226,7536223,'ype',50,1),(833,7536227,7536225,'dir',25,1),(833,7536228,7536225,'ire',25,1),(833,7536229,7536225,'rec',25,1),(833,7536230,7536225,'ect',25,1),(834,7536232,7536231,'naa',100,2),(834,7536233,7536232,'600',3.333,3),(834,7536234,7536232,'000',3.333,3),(834,7536235,7536232,'00c',3.333,3),(834,7536236,7536232,'0c2',3.333,3),(834,7536237,7536232,'c29',3.333,3),(834,7536238,7536232,'295',3.333,3),(834,7536239,7536232,'953',3.333,3),(834,7536240,7536232,'532',3.333,3),(834,7536241,7536232,'321',3.333,3),(834,7536242,7536232,'21c',3.333,3),(834,7536243,7536232,'1ca',3.333,3),(834,7536244,7536232,'ca5',3.333,3),(834,7536245,7536232,'a5a',3.333,3),(834,7536246,7536232,'5a2',3.333,3),(834,7536247,7536232,'a23',3.333,3),(834,7536248,7536232,'23b',3.333,3),(834,7536249,7536232,'3b0',3.333,3),(834,7536250,7536232,'b07',3.333,3),(834,7536251,7536232,'07f',3.333,3),(834,7536252,7536232,'7f0',3.333,3),(834,7536253,7536232,'f07',3.333,3),(834,7536254,7536232,'07a',3.333,3),(834,7536255,7536232,'7ae',3.333,3),(834,7536256,7536232,'aed',3.333,3),(834,7536257,7536232,'ede',3.333,3),(834,7536258,7536232,'def',3.333,3),(834,7536259,7536232,'efc',3.333,3),(834,7536260,7536232,'fca',3.333,3),(834,7536261,7536232,'ca7',3.333,3),(834,7536262,7536232,'a73',3.333,3),(834,7536263,7536233,'mon',100,1),(834,7536264,7536263,'201',50,1),(834,7536265,7536263,'013',50,1),(834,7536266,7536264,'adm',33.333,4),(834,7536267,7536264,'dmi',33.333,4),(834,7536268,7536264,'min',33.333,4),(834,7536269,7536266,'cap',16.667,1),(834,7536270,7536266,'apa',16.667,1),(834,7536271,7536266,'pac',16.667,1),(834,7536272,7536266,'aci',16.667,1),(834,7536273,7536266,'cit',16.667,1),(834,7536274,7536266,'ity',16.667,1),(834,7536275,7536269,'pat',50,1),(834,7536276,7536269,'ath',50,1),(834,7536277,7536275,'fre',14.286,1),(834,7536278,7536275,'ree',14.286,1),(834,7536279,7536275,'ees',14.286,1),(834,7536280,7536275,'esp',14.286,1),(834,7536281,7536275,'spa',14.286,1),(834,7536282,7536275,'pac',14.286,1),(834,7536283,7536275,'ace',14.286,1),(834,7536284,7536277,'dis',50,1),(834,7536285,7536277,'isk',50,1),(834,7536286,7536284,'ind',33.333,1),(834,7536287,7536284,'nde',33.333,1),(834,7536288,7536284,'dex',33.333,1),(834,7536289,7536286,'adm',8.333,1),(834,7536290,7536286,'dmi',8.333,1),(834,7536291,7536286,'min',8.333,1),(834,7536292,7536286,'ini',8.333,1),(834,7536293,7536286,'nis',8.333,1),(834,7536294,7536286,'ist',8.333,1),(834,7536295,7536286,'str',8.333,1),(834,7536296,7536286,'tra',8.333,1),(834,7536297,7536286,'rat',8.333,1),(834,7536298,7536286,'ati',8.333,1),(834,7536299,7536286,'tio',8.333,1),(834,7536300,7536286,'ion',8.333,1),(834,7536301,7536289,'sta',33.333,3),(834,7536302,7536289,'tat',33.333,3),(834,7536303,7536289,'ate',33.333,3),(834,7536304,7536301,'dis',16.667,4),(834,7536305,7536301,'isa',16.667,4),(834,7536306,7536301,'sab',16.667,4),(834,7536307,7536301,'abl',16.667,4),(834,7536308,7536301,'ble',16.667,4),(834,7536309,7536301,'led',16.667,4),(834,7536310,7536304,'cac',33.333,1),(834,7536311,7536304,'ach',33.333,1),(834,7536312,7536304,'che',33.333,1),(834,7536313,7536310,'mod',50,1),(834,7536314,7536310,'ode',50,1),(834,7536315,7536313,'wri',14.286,1),(834,7536316,7536313,'rit',14.286,1),(834,7536317,7536313,'ite',14.286,1),(834,7536318,7536313,'tet',14.286,1),(834,7536319,7536313,'eth',14.286,1),(834,7536320,7536313,'thr',14.286,1),(834,7536321,7536313,'hru',14.286,1),(834,7536322,7536315,'ope',11.111,2),(834,7536323,7536315,'per',11.111,2),(834,7536324,7536315,'era',11.111,2),(834,7536325,7536315,'rat',11.111,2),(834,7536326,7536315,'ati',11.111,2),(834,7536327,7536315,'tio',11.111,2),(834,7536328,7536315,'ion',11.111,2),(834,7536329,7536315,'ona',11.111,2),(834,7536330,7536315,'nal',11.111,2),(834,7536331,7536322,'mes',20,1),(834,7536332,7536322,'ess',20,1),(834,7536333,7536322,'ssa',20,1),(834,7536334,7536322,'sag',20,1),(834,7536335,7536322,'age',20,1),(834,7536336,7536331,'per',11.111,1),(834,7536337,7536331,'erf',11.111,1),(834,7536338,7536331,'rfo',11.111,1),(834,7536339,7536331,'for',11.111,1),(834,7536340,7536331,'orm',11.111,1),(834,7536341,7536331,'rma',11.111,1),(834,7536342,7536331,'man',11.111,1),(834,7536343,7536331,'anc',11.111,1),(834,7536344,7536331,'nce',11.111,1),(834,7536345,7536336,'ide',12.5,1),(834,7536346,7536336,'den',12.5,1),(834,7536347,7536336,'ent',12.5,1),(834,7536348,7536336,'nti',12.5,1),(834,7536349,7536336,'tif',12.5,1),(834,7536350,7536336,'ifi',12.5,1),(834,7536351,7536336,'fie',12.5,1),(834,7536352,7536336,'ier',12.5,1),(834,7536353,7536345,'vdi',33.333,3),(834,7536354,7536345,'dis',33.333,3),(834,7536355,7536345,'isk',33.333,3),(834,7536356,7536353,'nam',50,1),(834,7536357,7536353,'ame',50,1),(834,7536358,7536356,'typ',50,1),(834,7536359,7536356,'ype',50,1),(834,7536360,7536358,'dir',25,1),(834,7536361,7536358,'ire',25,1),(834,7536362,7536358,'rec',25,1),(834,7536363,7536358,'ect',25,1),(835,7536365,7536364,'naa',100,2),(835,7536366,7536365,'600',3.333,3),(835,7536367,7536365,'000',3.333,3),(835,7536368,7536365,'00c',3.333,3),(835,7536369,7536365,'0c2',3.333,3),(835,7536370,7536365,'c29',3.333,3),(835,7536371,7536365,'29f',3.333,3),(835,7536372,7536365,'9fa',3.333,3),(835,7536373,7536365,'fad',3.333,3),(835,7536374,7536365,'adc',3.333,3),(835,7536375,7536365,'dca',3.333,3),(835,7536376,7536365,'ca4',3.333,3),(835,7536377,7536365,'a4c',3.333,3),(835,7536378,7536365,'4c6',3.333,3),(835,7536379,7536365,'c6c',3.333,3),(835,7536380,7536365,'6ce',3.333,3),(835,7536381,7536365,'cea',3.333,3),(835,7536382,7536365,'ea8',3.333,3),(835,7536383,7536365,'a8a',3.333,3),(835,7536384,7536365,'8a3',3.333,3),(835,7536385,7536365,'a30',3.333,3),(835,7536386,7536365,'304',3.333,3),(835,7536387,7536365,'046',3.333,3),(835,7536388,7536365,'46a',3.333,3),(835,7536389,7536365,'6ae',3.333,3),(835,7536390,7536365,'aee',3.333,3),(835,7536391,7536365,'ee5',3.333,3),(835,7536392,7536365,'e5e',3.333,3),(835,7536393,7536365,'5e3',3.333,3),(835,7536394,7536365,'e33',3.333,3),(835,7536395,7536365,'336',3.333,3),(835,7536396,7536366,'mon',100,1),(835,7536397,7536396,'201',50,1),(835,7536398,7536396,'013',50,1),(835,7536399,7536397,'adm',33.333,4),(835,7536400,7536397,'dmi',33.333,4),(835,7536401,7536397,'min',33.333,4),(835,7536402,7536399,'cap',16.667,1),(835,7536403,7536399,'apa',16.667,1),(835,7536404,7536399,'pac',16.667,1),(835,7536405,7536399,'aci',16.667,1),(835,7536406,7536399,'cit',16.667,1),(835,7536407,7536399,'ity',16.667,1),(835,7536408,7536402,'pat',50,1),(835,7536409,7536402,'ath',50,1),(835,7536410,7536408,'fre',14.286,1),(835,7536411,7536408,'ree',14.286,1),(835,7536412,7536408,'ees',14.286,1),(835,7536413,7536408,'esp',14.286,1),(835,7536414,7536408,'spa',14.286,1),(835,7536415,7536408,'pac',14.286,1),(835,7536416,7536408,'ace',14.286,1),(835,7536417,7536410,'dis',50,1),(835,7536418,7536410,'isk',50,1),(835,7536419,7536417,'ind',33.333,1),(835,7536420,7536417,'nde',33.333,1),(835,7536421,7536417,'dex',33.333,1),(835,7536422,7536419,'adm',8.333,1),(835,7536423,7536419,'dmi',8.333,1),(835,7536424,7536419,'min',8.333,1),(835,7536425,7536419,'ini',8.333,1),(835,7536426,7536419,'nis',8.333,1),(835,7536427,7536419,'ist',8.333,1),(835,7536428,7536419,'str',8.333,1),(835,7536429,7536419,'tra',8.333,1),(835,7536430,7536419,'rat',8.333,1),(835,7536431,7536419,'ati',8.333,1),(835,7536432,7536419,'tio',8.333,1),(835,7536433,7536419,'ion',8.333,1),(835,7536434,7536422,'sta',33.333,3),(835,7536435,7536422,'tat',33.333,3),(835,7536436,7536422,'ate',33.333,3),(835,7536437,7536434,'dis',16.667,4),(835,7536438,7536434,'isa',16.667,4),(835,7536439,7536434,'sab',16.667,4),(835,7536440,7536434,'abl',16.667,4),(835,7536441,7536434,'ble',16.667,4),(835,7536442,7536434,'led',16.667,4),(835,7536443,7536437,'cac',33.333,1),(835,7536444,7536437,'ach',33.333,1),(835,7536445,7536437,'che',33.333,1),(835,7536446,7536443,'mod',50,1),(835,7536447,7536443,'ode',50,1),(835,7536448,7536446,'wri',14.286,1),(835,7536449,7536446,'rit',14.286,1),(835,7536450,7536446,'ite',14.286,1),(835,7536451,7536446,'tet',14.286,1),(835,7536452,7536446,'eth',14.286,1),(835,7536453,7536446,'thr',14.286,1),(835,7536454,7536446,'hru',14.286,1),(835,7536455,7536448,'ope',11.111,2),(835,7536456,7536448,'per',11.111,2),(835,7536457,7536448,'era',11.111,2),(835,7536458,7536448,'rat',11.111,2),(835,7536459,7536448,'ati',11.111,2),(835,7536460,7536448,'tio',11.111,2),(835,7536461,7536448,'ion',11.111,2),(835,7536462,7536448,'ona',11.111,2),(835,7536463,7536448,'nal',11.111,2),(835,7536464,7536455,'mes',20,1),(835,7536465,7536455,'ess',20,1),(835,7536466,7536455,'ssa',20,1),(835,7536467,7536455,'sag',20,1),(835,7536468,7536455,'age',20,1),(835,7536469,7536464,'per',11.111,1),(835,7536470,7536464,'erf',11.111,1),(835,7536471,7536464,'rfo',11.111,1),(835,7536472,7536464,'for',11.111,1),(835,7536473,7536464,'orm',11.111,1),(835,7536474,7536464,'rma',11.111,1),(835,7536475,7536464,'man',11.111,1),(835,7536476,7536464,'anc',11.111,1),(835,7536477,7536464,'nce',11.111,1),(835,7536478,7536469,'ide',12.5,1),(835,7536479,7536469,'den',12.5,1),(835,7536480,7536469,'ent',12.5,1),(835,7536481,7536469,'nti',12.5,1),(835,7536482,7536469,'tif',12.5,1),(835,7536483,7536469,'ifi',12.5,1),(835,7536484,7536469,'fie',12.5,1),(835,7536485,7536469,'ier',12.5,1),(835,7536486,7536478,'vdi',33.333,3),(835,7536487,7536478,'dis',33.333,3),(835,7536488,7536478,'isk',33.333,3),(835,7536489,7536486,'nam',50,1),(835,7536490,7536486,'ame',50,1),(835,7536491,7536489,'typ',50,1),(835,7536492,7536489,'ype',50,1),(835,7536493,7536491,'dir',25,1),(835,7536494,7536491,'ire',25,1),(835,7536495,7536491,'rec',25,1),(835,7536496,7536491,'ect',25,1),(836,7536498,7536497,'naa',100,2),(836,7536499,7536498,'600',3.333,3),(836,7536500,7536498,'000',3.333,3),(836,7536501,7536498,'00c',3.333,3),(836,7536502,7536498,'0c2',3.333,3),(836,7536503,7536498,'c29',3.333,3),(836,7536504,7536498,'29d',3.333,3),(836,7536505,7536498,'9d4',3.333,3),(836,7536506,7536498,'d43',3.333,3),(836,7536507,7536498,'43a',3.333,3),(836,7536508,7536498,'3a0',3.333,3),(836,7536509,7536498,'a06',3.333,3),(836,7536510,7536498,'06e',3.333,3),(836,7536511,7536498,'6ed',3.333,3),(836,7536512,7536498,'ed5',3.333,3),(836,7536513,7536498,'d53',3.333,3),(836,7536514,7536498,'53a',3.333,3),(836,7536515,7536498,'3a3',3.333,3),(836,7536516,7536498,'a38',3.333,3),(836,7536517,7536498,'38f',3.333,3),(836,7536518,7536498,'8f8',3.333,3),(836,7536519,7536498,'f81',3.333,3),(836,7536520,7536498,'81f',3.333,3),(836,7536521,7536498,'1fb',3.333,3),(836,7536522,7536498,'fb2',3.333,3),(836,7536523,7536498,'b2d',3.333,3),(836,7536524,7536498,'2de',3.333,3),(836,7536525,7536498,'de9',3.333,3),(836,7536526,7536498,'e94',3.333,3),(836,7536527,7536498,'943',3.333,3),(836,7536528,7536498,'434',3.333,3),(836,7536529,7536499,'mon',100,1),(836,7536530,7536529,'201',50,1),(836,7536531,7536529,'013',50,1),(836,7536532,7536530,'adm',33.333,4),(836,7536533,7536530,'dmi',33.333,4),(836,7536534,7536530,'min',33.333,4),(836,7536535,7536532,'cap',16.667,1),(836,7536536,7536532,'apa',16.667,1),(836,7536537,7536532,'pac',16.667,1),(836,7536538,7536532,'aci',16.667,1),(836,7536539,7536532,'cit',16.667,1),(836,7536540,7536532,'ity',16.667,1),(836,7536541,7536535,'pat',50,1),(836,7536542,7536535,'ath',50,1),(836,7536543,7536541,'fre',14.286,1),(836,7536544,7536541,'ree',14.286,1),(836,7536545,7536541,'ees',14.286,1),(836,7536546,7536541,'esp',14.286,1),(836,7536547,7536541,'spa',14.286,1),(836,7536548,7536541,'pac',14.286,1),(836,7536549,7536541,'ace',14.286,1),(836,7536550,7536543,'dis',50,1),(836,7536551,7536543,'isk',50,1),(836,7536552,7536550,'ind',33.333,1),(836,7536553,7536550,'nde',33.333,1),(836,7536554,7536550,'dex',33.333,1),(836,7536555,7536552,'adm',8.333,1),(836,7536556,7536552,'dmi',8.333,1),(836,7536557,7536552,'min',8.333,1),(836,7536558,7536552,'ini',8.333,1),(836,7536559,7536552,'nis',8.333,1),(836,7536560,7536552,'ist',8.333,1),(836,7536561,7536552,'str',8.333,1),(836,7536562,7536552,'tra',8.333,1),(836,7536563,7536552,'rat',8.333,1),(836,7536564,7536552,'ati',8.333,1),(836,7536565,7536552,'tio',8.333,1),(836,7536566,7536552,'ion',8.333,1),(836,7536567,7536555,'sta',33.333,3),(836,7536568,7536555,'tat',33.333,3),(836,7536569,7536555,'ate',33.333,3),(836,7536570,7536567,'dis',16.667,4),(836,7536571,7536567,'isa',16.667,4),(836,7536572,7536567,'sab',16.667,4),(836,7536573,7536567,'abl',16.667,4),(836,7536574,7536567,'ble',16.667,4),(836,7536575,7536567,'led',16.667,4),(836,7536576,7536570,'cac',33.333,1),(836,7536577,7536570,'ach',33.333,1),(836,7536578,7536570,'che',33.333,1),(836,7536579,7536576,'mod',50,1),(836,7536580,7536576,'ode',50,1),(836,7536581,7536579,'wri',14.286,1),(836,7536582,7536579,'rit',14.286,1),(836,7536583,7536579,'ite',14.286,1),(836,7536584,7536579,'tet',14.286,1),(836,7536585,7536579,'eth',14.286,1),(836,7536586,7536579,'thr',14.286,1),(836,7536587,7536579,'hru',14.286,1),(836,7536588,7536581,'ope',11.111,2),(836,7536589,7536581,'per',11.111,2),(836,7536590,7536581,'era',11.111,2),(836,7536591,7536581,'rat',11.111,2),(836,7536592,7536581,'ati',11.111,2),(836,7536593,7536581,'tio',11.111,2),(836,7536594,7536581,'ion',11.111,2),(836,7536595,7536581,'ona',11.111,2),(836,7536596,7536581,'nal',11.111,2),(836,7536597,7536588,'mes',20,1),(836,7536598,7536588,'ess',20,1),(836,7536599,7536588,'ssa',20,1),(836,7536600,7536588,'sag',20,1),(836,7536601,7536588,'age',20,1),(836,7536602,7536597,'per',11.111,1),(836,7536603,7536597,'erf',11.111,1),(836,7536604,7536597,'rfo',11.111,1),(836,7536605,7536597,'for',11.111,1),(836,7536606,7536597,'orm',11.111,1),(836,7536607,7536597,'rma',11.111,1),(836,7536608,7536597,'man',11.111,1),(836,7536609,7536597,'anc',11.111,1),(836,7536610,7536597,'nce',11.111,1),(836,7536611,7536602,'ide',12.5,1),(836,7536612,7536602,'den',12.5,1),(836,7536613,7536602,'ent',12.5,1),(836,7536614,7536602,'nti',12.5,1),(836,7536615,7536602,'tif',12.5,1),(836,7536616,7536602,'ifi',12.5,1),(836,7536617,7536602,'fie',12.5,1),(836,7536618,7536602,'ier',12.5,1),(836,7536619,7536611,'vdi',33.333,3),(836,7536620,7536611,'dis',33.333,3),(836,7536621,7536611,'isk',33.333,3),(836,7536622,7536619,'nam',50,1),(836,7536623,7536619,'ame',50,1),(836,7536624,7536622,'typ',50,1),(836,7536625,7536622,'ype',50,1),(836,7536626,7536624,'dir',25,1),(836,7536627,7536624,'ire',25,1),(836,7536628,7536624,'rec',25,1),(836,7536629,7536624,'ect',25,1),(837,7536631,7536630,'naa',100,2),(837,7536632,7536631,'600',3.333,3),(837,7536633,7536631,'000',3.333,3),(837,7536634,7536631,'00c',3.333,3),(837,7536635,7536631,'0c2',3.333,3),(837,7536636,7536631,'c29',3.333,3),(837,7536637,7536631,'295',3.333,3),(837,7536638,7536631,'952',3.333,3),(837,7536639,7536631,'52b',3.333,3),(837,7536640,7536631,'2b0',3.333,3),(837,7536641,7536631,'b0f',3.333,3),(837,7536642,7536631,'0ff',3.333,3),(837,7536643,7536631,'ff0',3.333,3),(837,7536644,7536631,'f0b',3.333,3),(837,7536645,7536631,'0b8',3.333,3),(837,7536646,7536631,'b8f',3.333,3),(837,7536647,7536631,'8fc',3.333,3),(837,7536648,7536631,'fc5',3.333,3),(837,7536649,7536631,'c5f',3.333,3),(837,7536650,7536631,'5fb',3.333,3),(837,7536651,7536631,'fbf',3.333,3),(837,7536652,7536631,'bf4',3.333,3),(837,7536653,7536631,'f4c',3.333,3),(837,7536654,7536631,'4cd',3.333,3),(837,7536655,7536631,'cde',3.333,3),(837,7536656,7536631,'dea',3.333,3),(837,7536657,7536631,'eaf',3.333,3),(837,7536658,7536631,'afa',3.333,3),(837,7536659,7536631,'fa8',3.333,3),(837,7536660,7536631,'a83',3.333,3),(837,7536661,7536631,'834',3.333,3),(837,7536662,7536632,'mon',100,1),(837,7536663,7536662,'201',50,1),(837,7536664,7536662,'013',50,1),(837,7536665,7536663,'adm',33.333,4),(837,7536666,7536663,'dmi',33.333,4),(837,7536667,7536663,'min',33.333,4),(837,7536668,7536665,'cap',16.667,1),(837,7536669,7536665,'apa',16.667,1),(837,7536670,7536665,'pac',16.667,1),(837,7536671,7536665,'aci',16.667,1),(837,7536672,7536665,'cit',16.667,1),(837,7536673,7536665,'ity',16.667,1),(837,7536674,7536668,'pat',50,1),(837,7536675,7536668,'ath',50,1),(837,7536676,7536674,'fre',14.286,1),(837,7536677,7536674,'ree',14.286,1),(837,7536678,7536674,'ees',14.286,1),(837,7536679,7536674,'esp',14.286,1),(837,7536680,7536674,'spa',14.286,1),(837,7536681,7536674,'pac',14.286,1),(837,7536682,7536674,'ace',14.286,1),(837,7536683,7536676,'dis',50,1),(837,7536684,7536676,'isk',50,1),(837,7536685,7536683,'ind',33.333,1),(837,7536686,7536683,'nde',33.333,1),(837,7536687,7536683,'dex',33.333,1),(837,7536688,7536685,'adm',8.333,1),(837,7536689,7536685,'dmi',8.333,1),(837,7536690,7536685,'min',8.333,1),(837,7536691,7536685,'ini',8.333,1),(837,7536692,7536685,'nis',8.333,1),(837,7536693,7536685,'ist',8.333,1),(837,7536694,7536685,'str',8.333,1),(837,7536695,7536685,'tra',8.333,1),(837,7536696,7536685,'rat',8.333,1),(837,7536697,7536685,'ati',8.333,1),(837,7536698,7536685,'tio',8.333,1),(837,7536699,7536685,'ion',8.333,1),(837,7536700,7536688,'sta',33.333,3),(837,7536701,7536688,'tat',33.333,3),(837,7536702,7536688,'ate',33.333,3),(837,7536703,7536700,'dis',16.667,4),(837,7536704,7536700,'isa',16.667,4),(837,7536705,7536700,'sab',16.667,4),(837,7536706,7536700,'abl',16.667,4),(837,7536707,7536700,'ble',16.667,4),(837,7536708,7536700,'led',16.667,4),(837,7536709,7536703,'cac',33.333,1),(837,7536710,7536703,'ach',33.333,1),(837,7536711,7536703,'che',33.333,1),(837,7536712,7536709,'mod',50,1),(837,7536713,7536709,'ode',50,1),(837,7536714,7536712,'wri',14.286,1),(837,7536715,7536712,'rit',14.286,1),(837,7536716,7536712,'ite',14.286,1),(837,7536717,7536712,'tet',14.286,1),(837,7536718,7536712,'eth',14.286,1),(837,7536719,7536712,'thr',14.286,1),(837,7536720,7536712,'hru',14.286,1),(837,7536721,7536714,'ope',11.111,2),(837,7536722,7536714,'per',11.111,2),(837,7536723,7536714,'era',11.111,2),(837,7536724,7536714,'rat',11.111,2),(837,7536725,7536714,'ati',11.111,2),(837,7536726,7536714,'tio',11.111,2),(837,7536727,7536714,'ion',11.111,2),(837,7536728,7536714,'ona',11.111,2),(837,7536729,7536714,'nal',11.111,2),(837,7536730,7536721,'mes',20,1),(837,7536731,7536721,'ess',20,1),(837,7536732,7536721,'ssa',20,1),(837,7536733,7536721,'sag',20,1),(837,7536734,7536721,'age',20,1),(837,7536735,7536730,'per',11.111,1),(837,7536736,7536730,'erf',11.111,1),(837,7536737,7536730,'rfo',11.111,1),(837,7536738,7536730,'for',11.111,1),(837,7536739,7536730,'orm',11.111,1),(837,7536740,7536730,'rma',11.111,1),(837,7536741,7536730,'man',11.111,1),(837,7536742,7536730,'anc',11.111,1),(837,7536743,7536730,'nce',11.111,1),(837,7536744,7536735,'ide',12.5,1),(837,7536745,7536735,'den',12.5,1),(837,7536746,7536735,'ent',12.5,1),(837,7536747,7536735,'nti',12.5,1),(837,7536748,7536735,'tif',12.5,1),(837,7536749,7536735,'ifi',12.5,1),(837,7536750,7536735,'fie',12.5,1),(837,7536751,7536735,'ier',12.5,1),(837,7536752,7536744,'vdi',33.333,3),(837,7536753,7536744,'dis',33.333,3),(837,7536754,7536744,'isk',33.333,3),(837,7536755,7536752,'nam',50,1),(837,7536756,7536752,'ame',50,1),(837,7536757,7536755,'typ',50,1),(837,7536758,7536755,'ype',50,1),(837,7536759,7536757,'dir',25,1),(837,7536760,7536757,'ire',25,1),(837,7536761,7536757,'rec',25,1),(837,7536762,7536757,'ect',25,1),(838,7536764,7536763,'naa',100,2),(838,7536765,7536764,'600',3.333,3),(838,7536766,7536764,'000',3.333,3),(838,7536767,7536764,'00c',3.333,3),(838,7536768,7536764,'0c2',3.333,3),(838,7536769,7536764,'c29',3.333,3),(838,7536770,7536764,'292',3.333,3),(838,7536771,7536764,'923',3.333,3),(838,7536772,7536764,'232',3.333,3),(838,7536773,7536764,'32d',3.333,3),(838,7536774,7536764,'2df',3.333,3),(838,7536775,7536764,'df3',3.333,3),(838,7536776,7536764,'f39',3.333,3),(838,7536777,7536764,'398',3.333,3),(838,7536778,7536764,'986',3.333,3),(838,7536779,7536764,'866',3.333,3),(838,7536780,7536764,'668',3.333,3),(838,7536781,7536764,'68d',3.333,3),(838,7536782,7536764,'8d6',3.333,3),(838,7536783,7536764,'d62',3.333,3),(838,7536784,7536764,'621',3.333,3),(838,7536785,7536764,'21e',3.333,3),(838,7536786,7536764,'1e0',3.333,3),(838,7536787,7536764,'e04',3.333,3),(838,7536788,7536764,'04f',3.333,3),(838,7536789,7536764,'4fa',3.333,3),(838,7536790,7536764,'fa5',3.333,3),(838,7536791,7536764,'a57',3.333,3),(838,7536792,7536764,'57b',3.333,3),(838,7536793,7536764,'7b8',3.333,3),(838,7536794,7536764,'b8f',3.333,3),(838,7536795,7536765,'mon',100,1),(838,7536796,7536795,'201',50,1),(838,7536797,7536795,'013',50,1),(838,7536798,7536796,'adm',33.333,4),(838,7536799,7536796,'dmi',33.333,4),(838,7536800,7536796,'min',33.333,4),(838,7536801,7536798,'cap',16.667,1),(838,7536802,7536798,'apa',16.667,1),(838,7536803,7536798,'pac',16.667,1),(838,7536804,7536798,'aci',16.667,1),(838,7536805,7536798,'cit',16.667,1),(838,7536806,7536798,'ity',16.667,1),(838,7536807,7536801,'pat',50,1),(838,7536808,7536801,'ath',50,1),(838,7536809,7536807,'fre',14.286,1),(838,7536810,7536807,'ree',14.286,1),(838,7536811,7536807,'ees',14.286,1),(838,7536812,7536807,'esp',14.286,1),(838,7536813,7536807,'spa',14.286,1),(838,7536814,7536807,'pac',14.286,1),(838,7536815,7536807,'ace',14.286,1),(838,7536816,7536809,'dis',50,1),(838,7536817,7536809,'isk',50,1),(838,7536818,7536816,'ind',33.333,1),(838,7536819,7536816,'nde',33.333,1),(838,7536820,7536816,'dex',33.333,1),(838,7536821,7536818,'adm',8.333,1),(838,7536822,7536818,'dmi',8.333,1),(838,7536823,7536818,'min',8.333,1),(838,7536824,7536818,'ini',8.333,1),(838,7536825,7536818,'nis',8.333,1),(838,7536826,7536818,'ist',8.333,1),(838,7536827,7536818,'str',8.333,1),(838,7536828,7536818,'tra',8.333,1),(838,7536829,7536818,'rat',8.333,1),(838,7536830,7536818,'ati',8.333,1),(838,7536831,7536818,'tio',8.333,1),(838,7536832,7536818,'ion',8.333,1),(838,7536833,7536821,'sta',33.333,3),(838,7536834,7536821,'tat',33.333,3),(838,7536835,7536821,'ate',33.333,3),(838,7536836,7536833,'dis',16.667,4),(838,7536837,7536833,'isa',16.667,4),(838,7536838,7536833,'sab',16.667,4),(838,7536839,7536833,'abl',16.667,4),(838,7536840,7536833,'ble',16.667,4),(838,7536841,7536833,'led',16.667,4),(838,7536842,7536836,'cac',33.333,1),(838,7536843,7536836,'ach',33.333,1),(838,7536844,7536836,'che',33.333,1),(838,7536845,7536842,'mod',50,1),(838,7536846,7536842,'ode',50,1),(838,7536847,7536845,'wri',14.286,1),(838,7536848,7536845,'rit',14.286,1),(838,7536849,7536845,'ite',14.286,1),(838,7536850,7536845,'tet',14.286,1),(838,7536851,7536845,'eth',14.286,1),(838,7536852,7536845,'thr',14.286,1),(838,7536853,7536845,'hru',14.286,1),(838,7536854,7536847,'ope',11.111,2),(838,7536855,7536847,'per',11.111,2),(838,7536856,7536847,'era',11.111,2),(838,7536857,7536847,'rat',11.111,2),(838,7536858,7536847,'ati',11.111,2),(838,7536859,7536847,'tio',11.111,2),(838,7536860,7536847,'ion',11.111,2),(838,7536861,7536847,'ona',11.111,2),(838,7536862,7536847,'nal',11.111,2),(838,7536863,7536854,'mes',20,1),(838,7536864,7536854,'ess',20,1),(838,7536865,7536854,'ssa',20,1),(838,7536866,7536854,'sag',20,1),(838,7536867,7536854,'age',20,1),(838,7536868,7536863,'per',11.111,1),(838,7536869,7536863,'erf',11.111,1),(838,7536870,7536863,'rfo',11.111,1),(838,7536871,7536863,'for',11.111,1),(838,7536872,7536863,'orm',11.111,1),(838,7536873,7536863,'rma',11.111,1),(838,7536874,7536863,'man',11.111,1),(838,7536875,7536863,'anc',11.111,1),(838,7536876,7536863,'nce',11.111,1),(838,7536877,7536868,'ide',12.5,1),(838,7536878,7536868,'den',12.5,1),(838,7536879,7536868,'ent',12.5,1),(838,7536880,7536868,'nti',12.5,1),(838,7536881,7536868,'tif',12.5,1),(838,7536882,7536868,'ifi',12.5,1),(838,7536883,7536868,'fie',12.5,1),(838,7536884,7536868,'ier',12.5,1),(838,7536885,7536877,'vdi',33.333,3),(838,7536886,7536877,'dis',33.333,3),(838,7536887,7536877,'isk',33.333,3),(838,7536888,7536885,'nam',50,1),(838,7536889,7536885,'ame',50,1),(838,7536890,7536888,'typ',50,1),(838,7536891,7536888,'ype',50,1),(838,7536892,7536890,'dir',25,1),(838,7536893,7536890,'ire',25,1),(838,7536894,7536890,'rec',25,1),(838,7536895,7536890,'ect',25,1),(839,7536897,7536896,'naa',100,2),(839,7536898,7536897,'600',3.333,3),(839,7536899,7536897,'000',3.333,3),(839,7536900,7536897,'00c',3.333,3),(839,7536901,7536897,'0c2',3.333,3),(839,7536902,7536897,'c29',3.333,3),(839,7536903,7536897,'290',3.333,3),(839,7536904,7536897,'90a',3.333,3),(839,7536905,7536897,'0ac',3.333,3),(839,7536906,7536897,'ac3',3.333,3),(839,7536907,7536897,'c38',3.333,3),(839,7536908,7536897,'38c',3.333,3),(839,7536909,7536897,'8c3',3.333,3),(839,7536910,7536897,'c3c',3.333,3),(839,7536911,7536897,'3c8',3.333,3),(839,7536912,7536897,'c85',3.333,3),(839,7536913,7536897,'85b',3.333,3),(839,7536914,7536897,'5b7',3.333,3),(839,7536915,7536897,'b79',3.333,3),(839,7536916,7536897,'795',3.333,3),(839,7536917,7536897,'958',3.333,3),(839,7536918,7536897,'584',3.333,3),(839,7536919,7536897,'842',3.333,3),(839,7536920,7536897,'42d',3.333,3),(839,7536921,7536897,'2da',3.333,3),(839,7536922,7536897,'daa',3.333,3),(839,7536923,7536897,'aa6',3.333,3),(839,7536924,7536897,'a62',3.333,3),(839,7536925,7536897,'62d',3.333,3),(839,7536926,7536897,'2d3',3.333,3),(839,7536927,7536897,'d39',3.333,3),(839,7536928,7536898,'mon',100,1),(839,7536929,7536928,'201',50,1),(839,7536930,7536928,'013',50,1),(839,7536931,7536929,'adm',33.333,4),(839,7536932,7536929,'dmi',33.333,4),(839,7536933,7536929,'min',33.333,4),(839,7536934,7536931,'cap',16.667,1),(839,7536935,7536931,'apa',16.667,1),(839,7536936,7536931,'pac',16.667,1),(839,7536937,7536931,'aci',16.667,1),(839,7536938,7536931,'cit',16.667,1),(839,7536939,7536931,'ity',16.667,1),(839,7536940,7536934,'pat',50,1),(839,7536941,7536934,'ath',50,1),(839,7536942,7536940,'fre',14.286,1),(839,7536943,7536940,'ree',14.286,1),(839,7536944,7536940,'ees',14.286,1),(839,7536945,7536940,'esp',14.286,1),(839,7536946,7536940,'spa',14.286,1),(839,7536947,7536940,'pac',14.286,1),(839,7536948,7536940,'ace',14.286,1),(839,7536949,7536942,'dis',50,1),(839,7536950,7536942,'isk',50,1),(839,7536951,7536949,'ind',33.333,1),(839,7536952,7536949,'nde',33.333,1),(839,7536953,7536949,'dex',33.333,1),(839,7536954,7536951,'adm',8.333,1),(839,7536955,7536951,'dmi',8.333,1),(839,7536956,7536951,'min',8.333,1),(839,7536957,7536951,'ini',8.333,1),(839,7536958,7536951,'nis',8.333,1),(839,7536959,7536951,'ist',8.333,1),(839,7536960,7536951,'str',8.333,1),(839,7536961,7536951,'tra',8.333,1),(839,7536962,7536951,'rat',8.333,1),(839,7536963,7536951,'ati',8.333,1),(839,7536964,7536951,'tio',8.333,1),(839,7536965,7536951,'ion',8.333,1),(839,7536966,7536954,'sta',33.333,3),(839,7536967,7536954,'tat',33.333,3),(839,7536968,7536954,'ate',33.333,3),(839,7536969,7536966,'dis',16.667,4),(839,7536970,7536966,'isa',16.667,4),(839,7536971,7536966,'sab',16.667,4),(839,7536972,7536966,'abl',16.667,4),(839,7536973,7536966,'ble',16.667,4),(839,7536974,7536966,'led',16.667,4),(839,7536975,7536969,'cac',33.333,1),(839,7536976,7536969,'ach',33.333,1),(839,7536977,7536969,'che',33.333,1),(839,7536978,7536975,'mod',50,1),(839,7536979,7536975,'ode',50,1),(839,7536980,7536978,'wri',14.286,1),(839,7536981,7536978,'rit',14.286,1),(839,7536982,7536978,'ite',14.286,1),(839,7536983,7536978,'tet',14.286,1),(839,7536984,7536978,'eth',14.286,1),(839,7536985,7536978,'thr',14.286,1),(839,7536986,7536978,'hru',14.286,1),(839,7536987,7536980,'ope',11.111,2),(839,7536988,7536980,'per',11.111,2),(839,7536989,7536980,'era',11.111,2),(839,7536990,7536980,'rat',11.111,2),(839,7536991,7536980,'ati',11.111,2),(839,7536992,7536980,'tio',11.111,2),(839,7536993,7536980,'ion',11.111,2),(839,7536994,7536980,'ona',11.111,2),(839,7536995,7536980,'nal',11.111,2),(839,7536996,7536987,'mes',20,1),(839,7536997,7536987,'ess',20,1),(839,7536998,7536987,'ssa',20,1),(839,7536999,7536987,'sag',20,1),(839,7537000,7536987,'age',20,1),(839,7537001,7536996,'per',11.111,1),(839,7537002,7536996,'erf',11.111,1),(839,7537003,7536996,'rfo',11.111,1),(839,7537004,7536996,'for',11.111,1),(839,7537005,7536996,'orm',11.111,1),(839,7537006,7536996,'rma',11.111,1),(839,7537007,7536996,'man',11.111,1),(839,7537008,7536996,'anc',11.111,1),(839,7537009,7536996,'nce',11.111,1),(839,7537010,7537001,'ide',12.5,1),(839,7537011,7537001,'den',12.5,1),(839,7537012,7537001,'ent',12.5,1),(839,7537013,7537001,'nti',12.5,1),(839,7537014,7537001,'tif',12.5,1),(839,7537015,7537001,'ifi',12.5,1),(839,7537016,7537001,'fie',12.5,1),(839,7537017,7537001,'ier',12.5,1),(839,7537018,7537010,'vdi',33.333,3),(839,7537019,7537010,'dis',33.333,3),(839,7537020,7537010,'isk',33.333,3),(839,7537021,7537018,'nam',50,1),(839,7537022,7537018,'ame',50,1),(839,7537023,7537021,'typ',50,1),(839,7537024,7537021,'ype',50,1),(839,7537025,7537023,'dir',25,1),(839,7537026,7537023,'ire',25,1),(839,7537027,7537023,'rec',25,1),(839,7537028,7537023,'ect',25,1),(840,7537030,7537029,'naa',100,2),(840,7537031,7537030,'600',3.333,3),(840,7537032,7537030,'000',3.333,3),(840,7537033,7537030,'00c',3.333,3),(840,7537034,7537030,'0c2',3.333,3),(840,7537035,7537030,'c29',3.333,3),(840,7537036,7537030,'298',3.333,3),(840,7537037,7537030,'988',3.333,3),(840,7537038,7537030,'88e',3.333,3),(840,7537039,7537030,'8e0',3.333,3),(840,7537040,7537030,'e09',3.333,3),(840,7537041,7537030,'091',3.333,3),(840,7537042,7537030,'91e',3.333,3),(840,7537043,7537030,'1ec',3.333,3),(840,7537044,7537030,'ecf',3.333,3),(840,7537045,7537030,'cf8',3.333,3),(840,7537046,7537030,'f82',3.333,3),(840,7537047,7537030,'822',3.333,3),(840,7537048,7537030,'224',3.333,3),(840,7537049,7537030,'24c',3.333,3),(840,7537050,7537030,'4c9',3.333,3),(840,7537051,7537030,'c9c',3.333,3),(840,7537052,7537030,'9c9',3.333,3),(840,7537053,7537030,'c97',3.333,3),(840,7537054,7537030,'979',3.333,3),(840,7537055,7537030,'794',3.333,3),(840,7537056,7537030,'945',3.333,3),(840,7537057,7537030,'45f',3.333,3),(840,7537058,7537030,'5ff',3.333,3),(840,7537059,7537030,'fff',3.333,3),(840,7537060,7537030,'ffd',3.333,3),(840,7537061,7537031,'mon',100,1),(840,7537062,7537061,'201',50,1),(840,7537063,7537061,'013',50,1),(840,7537064,7537062,'adm',33.333,4),(840,7537065,7537062,'dmi',33.333,4),(840,7537066,7537062,'min',33.333,4),(840,7537067,7537064,'cap',16.667,1),(840,7537068,7537064,'apa',16.667,1),(840,7537069,7537064,'pac',16.667,1),(840,7537070,7537064,'aci',16.667,1),(840,7537071,7537064,'cit',16.667,1),(840,7537072,7537064,'ity',16.667,1),(840,7537073,7537067,'pat',50,1),(840,7537074,7537067,'ath',50,1),(840,7537075,7537073,'fre',14.286,1),(840,7537076,7537073,'ree',14.286,1),(840,7537077,7537073,'ees',14.286,1),(840,7537078,7537073,'esp',14.286,1),(840,7537079,7537073,'spa',14.286,1),(840,7537080,7537073,'pac',14.286,1),(840,7537081,7537073,'ace',14.286,1),(840,7537082,7537075,'dis',50,1),(840,7537083,7537075,'isk',50,1),(840,7537084,7537082,'ind',33.333,1),(840,7537085,7537082,'nde',33.333,1),(840,7537086,7537082,'dex',33.333,1),(840,7537087,7537084,'adm',8.333,1),(840,7537088,7537084,'dmi',8.333,1),(840,7537089,7537084,'min',8.333,1),(840,7537090,7537084,'ini',8.333,1),(840,7537091,7537084,'nis',8.333,1),(840,7537092,7537084,'ist',8.333,1),(840,7537093,7537084,'str',8.333,1),(840,7537094,7537084,'tra',8.333,1),(840,7537095,7537084,'rat',8.333,1),(840,7537096,7537084,'ati',8.333,1),(840,7537097,7537084,'tio',8.333,1),(840,7537098,7537084,'ion',8.333,1),(840,7537099,7537087,'sta',33.333,3),(840,7537100,7537087,'tat',33.333,3),(840,7537101,7537087,'ate',33.333,3),(840,7537102,7537099,'dis',16.667,4),(840,7537103,7537099,'isa',16.667,4),(840,7537104,7537099,'sab',16.667,4),(840,7537105,7537099,'abl',16.667,4),(840,7537106,7537099,'ble',16.667,4),(840,7537107,7537099,'led',16.667,4),(840,7537108,7537102,'cac',33.333,1),(840,7537109,7537102,'ach',33.333,1),(840,7537110,7537102,'che',33.333,1),(840,7537111,7537108,'mod',50,1),(840,7537112,7537108,'ode',50,1),(840,7537113,7537111,'wri',14.286,1),(840,7537114,7537111,'rit',14.286,1),(840,7537115,7537111,'ite',14.286,1),(840,7537116,7537111,'tet',14.286,1),(840,7537117,7537111,'eth',14.286,1),(840,7537118,7537111,'thr',14.286,1),(840,7537119,7537111,'hru',14.286,1),(840,7537120,7537113,'ope',11.111,2),(840,7537121,7537113,'per',11.111,2),(840,7537122,7537113,'era',11.111,2),(840,7537123,7537113,'rat',11.111,2),(840,7537124,7537113,'ati',11.111,2),(840,7537125,7537113,'tio',11.111,2),(840,7537126,7537113,'ion',11.111,2),(840,7537127,7537113,'ona',11.111,2),(840,7537128,7537113,'nal',11.111,2),(840,7537129,7537120,'mes',20,1),(840,7537130,7537120,'ess',20,1),(840,7537131,7537120,'ssa',20,1),(840,7537132,7537120,'sag',20,1),(840,7537133,7537120,'age',20,1),(840,7537134,7537129,'per',11.111,1),(840,7537135,7537129,'erf',11.111,1),(840,7537136,7537129,'rfo',11.111,1),(840,7537137,7537129,'for',11.111,1),(840,7537138,7537129,'orm',11.111,1),(840,7537139,7537129,'rma',11.111,1),(840,7537140,7537129,'man',11.111,1),(840,7537141,7537129,'anc',11.111,1),(840,7537142,7537129,'nce',11.111,1),(840,7537143,7537134,'ide',12.5,1),(840,7537144,7537134,'den',12.5,1),(840,7537145,7537134,'ent',12.5,1),(840,7537146,7537134,'nti',12.5,1),(840,7537147,7537134,'tif',12.5,1),(840,7537148,7537134,'ifi',12.5,1),(840,7537149,7537134,'fie',12.5,1),(840,7537150,7537134,'ier',12.5,1),(840,7537151,7537143,'vdi',33.333,3),(840,7537152,7537143,'dis',33.333,3),(840,7537153,7537143,'isk',33.333,3),(840,7537154,7537151,'nam',50,1),(840,7537155,7537151,'ame',50,1),(840,7537156,7537154,'typ',50,1),(840,7537157,7537154,'ype',50,1),(840,7537158,7537156,'dir',25,1),(840,7537159,7537156,'ire',25,1),(840,7537160,7537156,'rec',25,1),(840,7537161,7537156,'ect',25,1),(841,7537163,7537162,'naa',100,2),(841,7537164,7537163,'600',3.333,3),(841,7537165,7537163,'000',3.333,3),(841,7537166,7537163,'00c',3.333,3),(841,7537167,7537163,'0c2',3.333,3),(841,7537168,7537163,'c29',3.333,3),(841,7537169,7537163,'29d',3.333,3),(841,7537170,7537163,'9d2',3.333,3),(841,7537171,7537163,'d25',3.333,3),(841,7537172,7537163,'258',3.333,3),(841,7537173,7537163,'584',3.333,3),(841,7537174,7537163,'84c',3.333,3),(841,7537175,7537163,'4c6',3.333,3),(841,7537176,7537163,'c64',3.333,3),(841,7537177,7537163,'649',3.333,3),(841,7537178,7537163,'498',3.333,3),(841,7537179,7537163,'988',3.333,3),(841,7537180,7537163,'88a',3.333,3),(841,7537181,7537163,'8aa',3.333,3),(841,7537182,7537163,'aa5',3.333,3),(841,7537183,7537163,'a5f',3.333,3),(841,7537184,7537163,'5ff',3.333,3),(841,7537185,7537163,'ff3',3.333,3),(841,7537186,7537163,'f35',3.333,3),(841,7537187,7537163,'357',3.333,3),(841,7537188,7537163,'579',3.333,3),(841,7537189,7537163,'795',3.333,3),(841,7537190,7537163,'954',3.333,3),(841,7537191,7537163,'54a',3.333,3),(841,7537192,7537163,'4a3',3.333,3),(841,7537193,7537163,'a37',3.333,3),(841,7537194,7537164,'mon',100,1),(841,7537195,7537194,'201',50,1),(841,7537196,7537194,'013',50,1),(841,7537197,7537195,'adm',33.333,4),(841,7537198,7537195,'dmi',33.333,4),(841,7537199,7537195,'min',33.333,4),(841,7537200,7537197,'cap',16.667,1),(841,7537201,7537197,'apa',16.667,1),(841,7537202,7537197,'pac',16.667,1),(841,7537203,7537197,'aci',16.667,1),(841,7537204,7537197,'cit',16.667,1),(841,7537205,7537197,'ity',16.667,1),(841,7537206,7537200,'pat',50,1),(841,7537207,7537200,'ath',50,1),(841,7537208,7537206,'fre',14.286,1),(841,7537209,7537206,'ree',14.286,1),(841,7537210,7537206,'ees',14.286,1),(841,7537211,7537206,'esp',14.286,1),(841,7537212,7537206,'spa',14.286,1),(841,7537213,7537206,'pac',14.286,1),(841,7537214,7537206,'ace',14.286,1),(841,7537215,7537208,'dis',50,1),(841,7537216,7537208,'isk',50,1),(841,7537217,7537215,'ind',33.333,1),(841,7537218,7537215,'nde',33.333,1),(841,7537219,7537215,'dex',33.333,1),(841,7537220,7537217,'adm',8.333,1),(841,7537221,7537217,'dmi',8.333,1),(841,7537222,7537217,'min',8.333,1),(841,7537223,7537217,'ini',8.333,1),(841,7537224,7537217,'nis',8.333,1),(841,7537225,7537217,'ist',8.333,1),(841,7537226,7537217,'str',8.333,1),(841,7537227,7537217,'tra',8.333,1),(841,7537228,7537217,'rat',8.333,1),(841,7537229,7537217,'ati',8.333,1),(841,7537230,7537217,'tio',8.333,1),(841,7537231,7537217,'ion',8.333,1),(841,7537232,7537220,'sta',33.333,3),(841,7537233,7537220,'tat',33.333,3),(841,7537234,7537220,'ate',33.333,3),(841,7537235,7537232,'dis',16.667,4),(841,7537236,7537232,'isa',16.667,4),(841,7537237,7537232,'sab',16.667,4),(841,7537238,7537232,'abl',16.667,4),(841,7537239,7537232,'ble',16.667,4),(841,7537240,7537232,'led',16.667,4),(841,7537241,7537235,'cac',33.333,1),(841,7537242,7537235,'ach',33.333,1),(841,7537243,7537235,'che',33.333,1),(841,7537244,7537241,'mod',50,1),(841,7537245,7537241,'ode',50,1),(841,7537246,7537244,'wri',14.286,1),(841,7537247,7537244,'rit',14.286,1),(841,7537248,7537244,'ite',14.286,1),(841,7537249,7537244,'tet',14.286,1),(841,7537250,7537244,'eth',14.286,1),(841,7537251,7537244,'thr',14.286,1),(841,7537252,7537244,'hru',14.286,1),(841,7537253,7537246,'ope',11.111,2),(841,7537254,7537246,'per',11.111,2),(841,7537255,7537246,'era',11.111,2),(841,7537256,7537246,'rat',11.111,2),(841,7537257,7537246,'ati',11.111,2),(841,7537258,7537246,'tio',11.111,2),(841,7537259,7537246,'ion',11.111,2),(841,7537260,7537246,'ona',11.111,2),(841,7537261,7537246,'nal',11.111,2),(841,7537262,7537253,'mes',20,1),(841,7537263,7537253,'ess',20,1),(841,7537264,7537253,'ssa',20,1),(841,7537265,7537253,'sag',20,1),(841,7537266,7537253,'age',20,1),(841,7537267,7537262,'per',11.111,1),(841,7537268,7537262,'erf',11.111,1),(841,7537269,7537262,'rfo',11.111,1),(841,7537270,7537262,'for',11.111,1),(841,7537271,7537262,'orm',11.111,1),(841,7537272,7537262,'rma',11.111,1),(841,7537273,7537262,'man',11.111,1),(841,7537274,7537262,'anc',11.111,1),(841,7537275,7537262,'nce',11.111,1),(841,7537276,7537267,'ide',12.5,1),(841,7537277,7537267,'den',12.5,1),(841,7537278,7537267,'ent',12.5,1),(841,7537279,7537267,'nti',12.5,1),(841,7537280,7537267,'tif',12.5,1),(841,7537281,7537267,'ifi',12.5,1),(841,7537282,7537267,'fie',12.5,1),(841,7537283,7537267,'ier',12.5,1),(841,7537284,7537276,'vdi',33.333,3),(841,7537285,7537276,'dis',33.333,3),(841,7537286,7537276,'isk',33.333,3),(841,7537287,7537284,'nam',50,1),(841,7537288,7537284,'ame',50,1),(841,7537289,7537287,'typ',50,1),(841,7537290,7537287,'ype',50,1),(841,7537291,7537289,'dir',25,1),(841,7537292,7537289,'ire',25,1),(841,7537293,7537289,'rec',25,1),(841,7537294,7537289,'ect',25,1),(842,7537296,7537295,'naa',100,2),(842,7537297,7537296,'600',3.333,3),(842,7537298,7537296,'000',3.333,3),(842,7537299,7537296,'00c',3.333,3),(842,7537300,7537296,'0c2',3.333,3),(842,7537301,7537296,'c29',3.333,3),(842,7537302,7537296,'297',3.333,3),(842,7537303,7537296,'978',3.333,3),(842,7537304,7537296,'789',3.333,3),(842,7537305,7537296,'89c',3.333,3),(842,7537306,7537296,'9c2',3.333,3),(842,7537307,7537296,'c2b',3.333,3),(842,7537308,7537296,'2b2',3.333,3),(842,7537309,7537296,'b2c',3.333,3),(842,7537310,7537296,'2cf',3.333,3),(842,7537311,7537296,'cfc',3.333,3),(842,7537312,7537296,'fce',3.333,3),(842,7537313,7537296,'ce2',3.333,3),(842,7537314,7537296,'e21',3.333,3),(842,7537315,7537296,'212',3.333,3),(842,7537316,7537296,'129',3.333,3),(842,7537317,7537296,'29e',3.333,3),(842,7537318,7537296,'9eb',3.333,3),(842,7537319,7537296,'eb5',3.333,3),(842,7537320,7537296,'b56',3.333,3),(842,7537321,7537296,'56a',3.333,3),(842,7537322,7537296,'6aa',3.333,3),(842,7537323,7537296,'aa1',3.333,3),(842,7537324,7537296,'a16',3.333,3),(842,7537325,7537296,'16c',3.333,3),(842,7537326,7537296,'6cb',3.333,3),(842,7537327,7537297,'mon',100,1),(842,7537328,7537327,'201',50,1),(842,7537329,7537327,'013',50,1),(842,7537330,7537328,'adm',33.333,4),(842,7537331,7537328,'dmi',33.333,4),(842,7537332,7537328,'min',33.333,4),(842,7537333,7537330,'cap',16.667,1),(842,7537334,7537330,'apa',16.667,1),(842,7537335,7537330,'pac',16.667,1),(842,7537336,7537330,'aci',16.667,1),(842,7537337,7537330,'cit',16.667,1),(842,7537338,7537330,'ity',16.667,1),(842,7537339,7537333,'pat',50,1),(842,7537340,7537333,'ath',50,1),(842,7537341,7537339,'fre',14.286,1),(842,7537342,7537339,'ree',14.286,1),(842,7537343,7537339,'ees',14.286,1),(842,7537344,7537339,'esp',14.286,1),(842,7537345,7537339,'spa',14.286,1),(842,7537346,7537339,'pac',14.286,1),(842,7537347,7537339,'ace',14.286,1),(842,7537348,7537341,'dis',50,1),(842,7537349,7537341,'isk',50,1),(842,7537350,7537348,'ind',33.333,1),(842,7537351,7537348,'nde',33.333,1),(842,7537352,7537348,'dex',33.333,1),(842,7537353,7537350,'adm',8.333,1),(842,7537354,7537350,'dmi',8.333,1),(842,7537355,7537350,'min',8.333,1),(842,7537356,7537350,'ini',8.333,1),(842,7537357,7537350,'nis',8.333,1),(842,7537358,7537350,'ist',8.333,1),(842,7537359,7537350,'str',8.333,1),(842,7537360,7537350,'tra',8.333,1),(842,7537361,7537350,'rat',8.333,1),(842,7537362,7537350,'ati',8.333,1),(842,7537363,7537350,'tio',8.333,1),(842,7537364,7537350,'ion',8.333,1),(842,7537365,7537353,'sta',33.333,3),(842,7537366,7537353,'tat',33.333,3),(842,7537367,7537353,'ate',33.333,3),(842,7537368,7537365,'dis',16.667,4),(842,7537369,7537365,'isa',16.667,4),(842,7537370,7537365,'sab',16.667,4),(842,7537371,7537365,'abl',16.667,4),(842,7537372,7537365,'ble',16.667,4),(842,7537373,7537365,'led',16.667,4),(842,7537374,7537368,'cac',33.333,1),(842,7537375,7537368,'ach',33.333,1),(842,7537376,7537368,'che',33.333,1),(842,7537377,7537374,'mod',50,1),(842,7537378,7537374,'ode',50,1),(842,7537379,7537377,'wri',14.286,1),(842,7537380,7537377,'rit',14.286,1),(842,7537381,7537377,'ite',14.286,1),(842,7537382,7537377,'tet',14.286,1),(842,7537383,7537377,'eth',14.286,1),(842,7537384,7537377,'thr',14.286,1),(842,7537385,7537377,'hru',14.286,1),(842,7537386,7537379,'ope',11.111,2),(842,7537387,7537379,'per',11.111,2),(842,7537388,7537379,'era',11.111,2),(842,7537389,7537379,'rat',11.111,2),(842,7537390,7537379,'ati',11.111,2),(842,7537391,7537379,'tio',11.111,2),(842,7537392,7537379,'ion',11.111,2),(842,7537393,7537379,'ona',11.111,2),(842,7537394,7537379,'nal',11.111,2),(842,7537395,7537386,'mes',20,1),(842,7537396,7537386,'ess',20,1),(842,7537397,7537386,'ssa',20,1),(842,7537398,7537386,'sag',20,1),(842,7537399,7537386,'age',20,1),(842,7537400,7537395,'per',11.111,1),(842,7537401,7537395,'erf',11.111,1),(842,7537402,7537395,'rfo',11.111,1),(842,7537403,7537395,'for',11.111,1),(842,7537404,7537395,'orm',11.111,1),(842,7537405,7537395,'rma',11.111,1),(842,7537406,7537395,'man',11.111,1),(842,7537407,7537395,'anc',11.111,1),(842,7537408,7537395,'nce',11.111,1),(842,7537409,7537400,'ide',12.5,1),(842,7537410,7537400,'den',12.5,1),(842,7537411,7537400,'ent',12.5,1),(842,7537412,7537400,'nti',12.5,1),(842,7537413,7537400,'tif',12.5,1),(842,7537414,7537400,'ifi',12.5,1),(842,7537415,7537400,'fie',12.5,1),(842,7537416,7537400,'ier',12.5,1),(842,7537417,7537409,'vdi',33.333,3),(842,7537418,7537409,'dis',33.333,3),(842,7537419,7537409,'isk',33.333,3),(842,7537420,7537417,'nam',50,1),(842,7537421,7537417,'ame',50,1),(842,7537422,7537420,'typ',50,1),(842,7537423,7537420,'ype',50,1),(842,7537424,7537422,'dir',25,1),(842,7537425,7537422,'ire',25,1),(842,7537426,7537422,'rec',25,1),(842,7537427,7537422,'ect',25,1),(843,7537429,7537428,'naa',100,2),(843,7537430,7537429,'600',3.333,3),(843,7537431,7537429,'000',3.333,3),(843,7537432,7537429,'00c',3.333,3),(843,7537433,7537429,'0c2',3.333,3),(843,7537434,7537429,'c29',3.333,3),(843,7537435,7537429,'29a',3.333,3),(843,7537436,7537429,'9ab',3.333,3),(843,7537437,7537429,'ab5',3.333,3),(843,7537438,7537429,'b54',3.333,3),(843,7537439,7537429,'543',3.333,3),(843,7537440,7537429,'436',3.333,3),(843,7537441,7537429,'361',3.333,3),(843,7537442,7537429,'61f',3.333,3),(843,7537443,7537429,'1f5',3.333,3),(843,7537444,7537429,'f5d',3.333,3),(843,7537445,7537429,'5dd',3.333,3),(843,7537446,7537429,'dd7',3.333,3),(843,7537447,7537429,'d7d',3.333,3),(843,7537448,7537429,'7d0',3.333,3),(843,7537449,7537429,'d01',3.333,3),(843,7537450,7537429,'010',3.333,3),(843,7537451,7537429,'106',3.333,3),(843,7537452,7537429,'062',3.333,3),(843,7537453,7537429,'629',3.333,3),(843,7537454,7537429,'299',3.333,3),(843,7537455,7537429,'992',3.333,3),(843,7537456,7537429,'92c',3.333,3),(843,7537457,7537429,'2c7',3.333,3),(843,7537458,7537429,'c7e',3.333,3),(843,7537459,7537429,'7e8',3.333,3),(843,7537460,7537430,'mon',100,1),(843,7537461,7537460,'201',50,1),(843,7537462,7537460,'013',50,1),(843,7537463,7537461,'adm',33.333,4),(843,7537464,7537461,'dmi',33.333,4),(843,7537465,7537461,'min',33.333,4),(843,7537466,7537463,'cap',16.667,1),(843,7537467,7537463,'apa',16.667,1),(843,7537468,7537463,'pac',16.667,1),(843,7537469,7537463,'aci',16.667,1),(843,7537470,7537463,'cit',16.667,1),(843,7537471,7537463,'ity',16.667,1),(843,7537472,7537466,'pat',50,1),(843,7537473,7537466,'ath',50,1),(843,7537474,7537472,'fre',14.286,1),(843,7537475,7537472,'ree',14.286,1),(843,7537476,7537472,'ees',14.286,1),(843,7537477,7537472,'esp',14.286,1),(843,7537478,7537472,'spa',14.286,1),(843,7537479,7537472,'pac',14.286,1),(843,7537480,7537472,'ace',14.286,1),(843,7537481,7537474,'dis',50,1),(843,7537482,7537474,'isk',50,1),(843,7537483,7537481,'ind',33.333,1),(843,7537484,7537481,'nde',33.333,1),(843,7537485,7537481,'dex',33.333,1),(843,7537486,7537483,'adm',8.333,1),(843,7537487,7537483,'dmi',8.333,1),(843,7537488,7537483,'min',8.333,1),(843,7537489,7537483,'ini',8.333,1),(843,7537490,7537483,'nis',8.333,1),(843,7537491,7537483,'ist',8.333,1),(843,7537492,7537483,'str',8.333,1),(843,7537493,7537483,'tra',8.333,1),(843,7537494,7537483,'rat',8.333,1),(843,7537495,7537483,'ati',8.333,1),(843,7537496,7537483,'tio',8.333,1),(843,7537497,7537483,'ion',8.333,1),(843,7537498,7537486,'sta',33.333,3),(843,7537499,7537486,'tat',33.333,3),(843,7537500,7537486,'ate',33.333,3),(843,7537501,7537498,'dis',16.667,4),(843,7537502,7537498,'isa',16.667,4),(843,7537503,7537498,'sab',16.667,4),(843,7537504,7537498,'abl',16.667,4),(843,7537505,7537498,'ble',16.667,4),(843,7537506,7537498,'led',16.667,4),(843,7537507,7537501,'cac',33.333,1),(843,7537508,7537501,'ach',33.333,1),(843,7537509,7537501,'che',33.333,1),(843,7537510,7537507,'mod',50,1),(843,7537511,7537507,'ode',50,1),(843,7537512,7537510,'wri',14.286,1),(843,7537513,7537510,'rit',14.286,1),(843,7537514,7537510,'ite',14.286,1),(843,7537515,7537510,'tet',14.286,1),(843,7537516,7537510,'eth',14.286,1),(843,7537517,7537510,'thr',14.286,1),(843,7537518,7537510,'hru',14.286,1),(843,7537519,7537512,'ope',11.111,2),(843,7537520,7537512,'per',11.111,2),(843,7537521,7537512,'era',11.111,2),(843,7537522,7537512,'rat',11.111,2),(843,7537523,7537512,'ati',11.111,2),(843,7537524,7537512,'tio',11.111,2),(843,7537525,7537512,'ion',11.111,2),(843,7537526,7537512,'ona',11.111,2),(843,7537527,7537512,'nal',11.111,2),(843,7537528,7537519,'mes',20,1),(843,7537529,7537519,'ess',20,1),(843,7537530,7537519,'ssa',20,1),(843,7537531,7537519,'sag',20,1),(843,7537532,7537519,'age',20,1),(843,7537533,7537528,'per',11.111,1),(843,7537534,7537528,'erf',11.111,1),(843,7537535,7537528,'rfo',11.111,1),(843,7537536,7537528,'for',11.111,1),(843,7537537,7537528,'orm',11.111,1),(843,7537538,7537528,'rma',11.111,1),(843,7537539,7537528,'man',11.111,1),(843,7537540,7537528,'anc',11.111,1),(843,7537541,7537528,'nce',11.111,1),(843,7537542,7537533,'ide',12.5,1),(843,7537543,7537533,'den',12.5,1),(843,7537544,7537533,'ent',12.5,1),(843,7537545,7537533,'nti',12.5,1),(843,7537546,7537533,'tif',12.5,1),(843,7537547,7537533,'ifi',12.5,1),(843,7537548,7537533,'fie',12.5,1),(843,7537549,7537533,'ier',12.5,1),(843,7537550,7537542,'vdi',33.333,3),(843,7537551,7537542,'dis',33.333,3),(843,7537552,7537542,'isk',33.333,3),(843,7537553,7537550,'nam',50,1),(843,7537554,7537550,'ame',50,1),(843,7537555,7537553,'typ',50,1),(843,7537556,7537553,'ype',50,1),(843,7537557,7537555,'dir',25,1),(843,7537558,7537555,'ire',25,1),(843,7537559,7537555,'rec',25,1),(843,7537560,7537555,'ect',25,1),(844,7537562,7537561,'naa',100,2),(844,7537563,7537562,'600',3.333,3),(844,7537564,7537562,'000',3.333,3),(844,7537565,7537562,'00c',3.333,3),(844,7537566,7537562,'0c2',3.333,3),(844,7537567,7537562,'c29',3.333,3),(844,7537568,7537562,'29c',3.333,3),(844,7537569,7537562,'9c5',3.333,3),(844,7537570,7537562,'c5f',3.333,3),(844,7537571,7537562,'5f7',3.333,3),(844,7537572,7537562,'f71',3.333,3),(844,7537573,7537562,'71d',3.333,3),(844,7537574,7537562,'1d3',3.333,3),(844,7537575,7537562,'d31',3.333,3),(844,7537576,7537562,'312',3.333,3),(844,7537577,7537562,'121',3.333,3),(844,7537578,7537562,'211',3.333,3),(844,7537579,7537562,'11c',3.333,3),(844,7537580,7537562,'1c8',3.333,3),(844,7537581,7537562,'c80',3.333,3),(844,7537582,7537562,'804',3.333,3),(844,7537583,7537562,'044',3.333,3),(844,7537584,7537562,'44a',3.333,3),(844,7537585,7537562,'4aa',3.333,3),(844,7537586,7537562,'aa1',3.333,3),(844,7537587,7537562,'a17',3.333,3),(844,7537588,7537562,'177',3.333,3),(844,7537589,7537562,'77b',3.333,3),(844,7537590,7537562,'7b9',3.333,3),(844,7537591,7537562,'b95',3.333,3),(844,7537592,7537562,'959',3.333,3),(844,7537593,7537563,'mon',100,1),(844,7537594,7537593,'201',50,1),(844,7537595,7537593,'013',50,1),(844,7537596,7537594,'adm',33.333,4),(844,7537597,7537594,'dmi',33.333,4),(844,7537598,7537594,'min',33.333,4),(844,7537599,7537596,'cap',16.667,1),(844,7537600,7537596,'apa',16.667,1),(844,7537601,7537596,'pac',16.667,1),(844,7537602,7537596,'aci',16.667,1),(844,7537603,7537596,'cit',16.667,1),(844,7537604,7537596,'ity',16.667,1),(844,7537605,7537599,'pat',50,1),(844,7537606,7537599,'ath',50,1),(844,7537607,7537605,'fre',14.286,1),(844,7537608,7537605,'ree',14.286,1),(844,7537609,7537605,'ees',14.286,1),(844,7537610,7537605,'esp',14.286,1),(844,7537611,7537605,'spa',14.286,1),(844,7537612,7537605,'pac',14.286,1),(844,7537613,7537605,'ace',14.286,1),(844,7537614,7537607,'dis',50,1),(844,7537615,7537607,'isk',50,1),(844,7537616,7537614,'ind',33.333,1),(844,7537617,7537614,'nde',33.333,1),(844,7537618,7537614,'dex',33.333,1),(844,7537619,7537616,'adm',8.333,1),(844,7537620,7537616,'dmi',8.333,1),(844,7537621,7537616,'min',8.333,1),(844,7537622,7537616,'ini',8.333,1),(844,7537623,7537616,'nis',8.333,1),(844,7537624,7537616,'ist',8.333,1),(844,7537625,7537616,'str',8.333,1),(844,7537626,7537616,'tra',8.333,1),(844,7537627,7537616,'rat',8.333,1),(844,7537628,7537616,'ati',8.333,1),(844,7537629,7537616,'tio',8.333,1),(844,7537630,7537616,'ion',8.333,1),(844,7537631,7537619,'sta',33.333,3),(844,7537632,7537619,'tat',33.333,3),(844,7537633,7537619,'ate',33.333,3),(844,7537634,7537631,'dis',16.667,4),(844,7537635,7537631,'isa',16.667,4),(844,7537636,7537631,'sab',16.667,4),(844,7537637,7537631,'abl',16.667,4),(844,7537638,7537631,'ble',16.667,4),(844,7537639,7537631,'led',16.667,4),(844,7537640,7537634,'cac',33.333,1),(844,7537641,7537634,'ach',33.333,1),(844,7537642,7537634,'che',33.333,1),(844,7537643,7537640,'mod',50,1),(844,7537644,7537640,'ode',50,1),(844,7537645,7537643,'wri',14.286,1),(844,7537646,7537643,'rit',14.286,1),(844,7537647,7537643,'ite',14.286,1),(844,7537648,7537643,'tet',14.286,1),(844,7537649,7537643,'eth',14.286,1),(844,7537650,7537643,'thr',14.286,1),(844,7537651,7537643,'hru',14.286,1),(844,7537652,7537645,'ope',11.111,2),(844,7537653,7537645,'per',11.111,2),(844,7537654,7537645,'era',11.111,2),(844,7537655,7537645,'rat',11.111,2),(844,7537656,7537645,'ati',11.111,2),(844,7537657,7537645,'tio',11.111,2),(844,7537658,7537645,'ion',11.111,2),(844,7537659,7537645,'ona',11.111,2),(844,7537660,7537645,'nal',11.111,2),(844,7537661,7537652,'mes',20,1),(844,7537662,7537652,'ess',20,1),(844,7537663,7537652,'ssa',20,1),(844,7537664,7537652,'sag',20,1),(844,7537665,7537652,'age',20,1),(844,7537666,7537661,'per',11.111,1),(844,7537667,7537661,'erf',11.111,1),(844,7537668,7537661,'rfo',11.111,1),(844,7537669,7537661,'for',11.111,1),(844,7537670,7537661,'orm',11.111,1),(844,7537671,7537661,'rma',11.111,1),(844,7537672,7537661,'man',11.111,1),(844,7537673,7537661,'anc',11.111,1),(844,7537674,7537661,'nce',11.111,1),(844,7537675,7537666,'ide',12.5,1),(844,7537676,7537666,'den',12.5,1),(844,7537677,7537666,'ent',12.5,1),(844,7537678,7537666,'nti',12.5,1),(844,7537679,7537666,'tif',12.5,1),(844,7537680,7537666,'ifi',12.5,1),(844,7537681,7537666,'fie',12.5,1),(844,7537682,7537666,'ier',12.5,1),(844,7537683,7537675,'vdi',33.333,3),(844,7537684,7537675,'dis',33.333,3),(844,7537685,7537675,'isk',33.333,3),(844,7537686,7537683,'nam',50,1),(844,7537687,7537683,'ame',50,1),(844,7537688,7537686,'typ',50,1),(844,7537689,7537686,'ype',50,1),(844,7537690,7537688,'dir',25,1),(844,7537691,7537688,'ire',25,1),(844,7537692,7537688,'rec',25,1),(844,7537693,7537688,'ect',25,1),(845,7537695,7537694,'naa',100,2),(845,7537696,7537695,'600',3.333,3),(845,7537697,7537695,'000',3.333,3),(845,7537698,7537695,'00c',3.333,3),(845,7537699,7537695,'0c2',3.333,3),(845,7537700,7537695,'c29',3.333,3),(845,7537701,7537695,'291',3.333,3),(845,7537702,7537695,'91a',3.333,3),(845,7537703,7537695,'1a3',3.333,3),(845,7537704,7537695,'a34',3.333,3),(845,7537705,7537695,'343',3.333,3),(845,7537706,7537695,'43a',3.333,3),(845,7537707,7537695,'3ac',3.333,3),(845,7537708,7537695,'ac8',3.333,3),(845,7537709,7537695,'c8e',3.333,3),(845,7537710,7537695,'8e5',3.333,3),(845,7537711,7537695,'e52',3.333,3),(845,7537712,7537695,'528',3.333,3),(845,7537713,7537695,'28e',3.333,3),(845,7537714,7537695,'8e7',3.333,3),(845,7537715,7537695,'e7d',3.333,3),(845,7537716,7537695,'7df',3.333,3),(845,7537717,7537695,'df5',3.333,3),(845,7537718,7537695,'f55',3.333,3),(845,7537719,7537695,'557',3.333,3),(845,7537720,7537695,'57a',3.333,3),(845,7537721,7537695,'7a1',3.333,3),(845,7537722,7537695,'a13',3.333,3),(845,7537723,7537695,'13d',3.333,3),(845,7537724,7537695,'3d6',3.333,3),(845,7537725,7537695,'d6d',3.333,3),(845,7537726,7537696,'mon',100,1),(845,7537727,7537726,'201',50,1),(845,7537728,7537726,'013',50,1),(845,7537729,7537727,'adm',33.333,4),(845,7537730,7537727,'dmi',33.333,4),(845,7537731,7537727,'min',33.333,4),(845,7537732,7537729,'cap',16.667,1),(845,7537733,7537729,'apa',16.667,1),(845,7537734,7537729,'pac',16.667,1),(845,7537735,7537729,'aci',16.667,1),(845,7537736,7537729,'cit',16.667,1),(845,7537737,7537729,'ity',16.667,1),(845,7537738,7537732,'pat',50,1),(845,7537739,7537732,'ath',50,1),(845,7537740,7537738,'fre',14.286,1),(845,7537741,7537738,'ree',14.286,1),(845,7537742,7537738,'ees',14.286,1),(845,7537743,7537738,'esp',14.286,1),(845,7537744,7537738,'spa',14.286,1),(845,7537745,7537738,'pac',14.286,1),(845,7537746,7537738,'ace',14.286,1),(845,7537747,7537740,'dis',50,1),(845,7537748,7537740,'isk',50,1),(845,7537749,7537747,'ind',33.333,1),(845,7537750,7537747,'nde',33.333,1),(845,7537751,7537747,'dex',33.333,1),(845,7537752,7537749,'adm',8.333,1),(845,7537753,7537749,'dmi',8.333,1),(845,7537754,7537749,'min',8.333,1),(845,7537755,7537749,'ini',8.333,1),(845,7537756,7537749,'nis',8.333,1),(845,7537757,7537749,'ist',8.333,1),(845,7537758,7537749,'str',8.333,1),(845,7537759,7537749,'tra',8.333,1),(845,7537760,7537749,'rat',8.333,1),(845,7537761,7537749,'ati',8.333,1),(845,7537762,7537749,'tio',8.333,1),(845,7537763,7537749,'ion',8.333,1),(845,7537764,7537752,'sta',33.333,3),(845,7537765,7537752,'tat',33.333,3),(845,7537766,7537752,'ate',33.333,3),(845,7537767,7537764,'dis',16.667,4),(845,7537768,7537764,'isa',16.667,4),(845,7537769,7537764,'sab',16.667,4),(845,7537770,7537764,'abl',16.667,4),(845,7537771,7537764,'ble',16.667,4),(845,7537772,7537764,'led',16.667,4),(845,7537773,7537767,'cac',33.333,1),(845,7537774,7537767,'ach',33.333,1),(845,7537775,7537767,'che',33.333,1),(845,7537776,7537773,'mod',50,1),(845,7537777,7537773,'ode',50,1),(845,7537778,7537776,'wri',14.286,1),(845,7537779,7537776,'rit',14.286,1),(845,7537780,7537776,'ite',14.286,1),(845,7537781,7537776,'tet',14.286,1),(845,7537782,7537776,'eth',14.286,1),(845,7537783,7537776,'thr',14.286,1),(845,7537784,7537776,'hru',14.286,1),(845,7537785,7537778,'ope',11.111,2),(845,7537786,7537778,'per',11.111,2),(845,7537787,7537778,'era',11.111,2),(845,7537788,7537778,'rat',11.111,2),(845,7537789,7537778,'ati',11.111,2),(845,7537790,7537778,'tio',11.111,2),(845,7537791,7537778,'ion',11.111,2),(845,7537792,7537778,'ona',11.111,2),(845,7537793,7537778,'nal',11.111,2),(845,7537794,7537785,'mes',20,1),(845,7537795,7537785,'ess',20,1),(845,7537796,7537785,'ssa',20,1),(845,7537797,7537785,'sag',20,1),(845,7537798,7537785,'age',20,1),(845,7537799,7537794,'per',11.111,1),(845,7537800,7537794,'erf',11.111,1),(845,7537801,7537794,'rfo',11.111,1),(845,7537802,7537794,'for',11.111,1),(845,7537803,7537794,'orm',11.111,1),(845,7537804,7537794,'rma',11.111,1),(845,7537805,7537794,'man',11.111,1),(845,7537806,7537794,'anc',11.111,1),(845,7537807,7537794,'nce',11.111,1),(845,7537808,7537799,'ide',12.5,1),(845,7537809,7537799,'den',12.5,1),(845,7537810,7537799,'ent',12.5,1),(845,7537811,7537799,'nti',12.5,1),(845,7537812,7537799,'tif',12.5,1),(845,7537813,7537799,'ifi',12.5,1),(845,7537814,7537799,'fie',12.5,1),(845,7537815,7537799,'ier',12.5,1),(845,7537816,7537808,'vdi',33.333,3),(845,7537817,7537808,'dis',33.333,3),(845,7537818,7537808,'isk',33.333,3),(845,7537819,7537816,'nam',50,1),(845,7537820,7537816,'ame',50,1),(845,7537821,7537819,'typ',50,1),(845,7537822,7537819,'ype',50,1),(845,7537823,7537821,'dir',25,1),(845,7537824,7537821,'ire',25,1),(845,7537825,7537821,'rec',25,1),(845,7537826,7537821,'ect',25,1),(846,7537828,7537827,'naa',100,2),(846,7537829,7537828,'600',3.333,3),(846,7537830,7537828,'000',3.333,3),(846,7537831,7537828,'00c',3.333,3),(846,7537832,7537828,'0c2',3.333,3),(846,7537833,7537828,'c29',3.333,3),(846,7537834,7537828,'292',3.333,3),(846,7537835,7537828,'928',3.333,3),(846,7537836,7537828,'28e',3.333,3),(846,7537837,7537828,'8ec',3.333,3),(846,7537838,7537828,'ec0',3.333,3),(846,7537839,7537828,'c00',3.333,3),(846,7537840,7537828,'001',3.333,3),(846,7537841,7537828,'011',3.333,3),(846,7537842,7537828,'11b',3.333,3),(846,7537843,7537828,'1bd',3.333,3),(846,7537844,7537828,'bdf',3.333,3),(846,7537845,7537828,'dfc',3.333,3),(846,7537846,7537828,'fca',3.333,3),(846,7537847,7537828,'ca7',3.333,3),(846,7537848,7537828,'a77',3.333,3),(846,7537849,7537828,'772',3.333,3),(846,7537850,7537828,'72c',3.333,3),(846,7537851,7537828,'2c4',3.333,3),(846,7537852,7537828,'c4f',3.333,3),(846,7537853,7537828,'4f9',3.333,3),(846,7537854,7537828,'f9d',3.333,3),(846,7537855,7537828,'9dc',3.333,3),(846,7537856,7537828,'dce',3.333,3),(846,7537857,7537828,'ce0',3.333,3),(846,7537858,7537828,'e07',3.333,3),(846,7537859,7537829,'mon',100,1),(846,7537860,7537859,'201',50,1),(846,7537861,7537859,'013',50,1),(846,7537862,7537860,'adm',33.333,4),(846,7537863,7537860,'dmi',33.333,4),(846,7537864,7537860,'min',33.333,4),(846,7537865,7537862,'cap',16.667,1),(846,7537866,7537862,'apa',16.667,1),(846,7537867,7537862,'pac',16.667,1),(846,7537868,7537862,'aci',16.667,1),(846,7537869,7537862,'cit',16.667,1),(846,7537870,7537862,'ity',16.667,1),(846,7537871,7537865,'pat',50,1),(846,7537872,7537865,'ath',50,1),(846,7537873,7537871,'one',100,1),(846,7537874,7537873,'fre',14.286,1),(846,7537875,7537873,'ree',14.286,1),(846,7537876,7537873,'ees',14.286,1),(846,7537877,7537873,'esp',14.286,1),(846,7537878,7537873,'spa',14.286,1),(846,7537879,7537873,'pac',14.286,1),(846,7537880,7537873,'ace',14.286,1),(846,7537881,7537874,'dis',50,1),(846,7537882,7537874,'isk',50,1),(846,7537883,7537881,'ind',33.333,1),(846,7537884,7537881,'nde',33.333,1),(846,7537885,7537881,'dex',33.333,1),(846,7537886,7537883,'adm',8.333,1),(846,7537887,7537883,'dmi',8.333,1),(846,7537888,7537883,'min',8.333,1),(846,7537889,7537883,'ini',8.333,1),(846,7537890,7537883,'nis',8.333,1),(846,7537891,7537883,'ist',8.333,1),(846,7537892,7537883,'str',8.333,1),(846,7537893,7537883,'tra',8.333,1),(846,7537894,7537883,'rat',8.333,1),(846,7537895,7537883,'ati',8.333,1),(846,7537896,7537883,'tio',8.333,1),(846,7537897,7537883,'ion',8.333,1),(846,7537898,7537886,'sta',33.333,3),(846,7537899,7537886,'tat',33.333,3),(846,7537900,7537886,'ate',33.333,3),(846,7537901,7537898,'dis',16.667,4),(846,7537902,7537898,'isa',16.667,4),(846,7537903,7537898,'sab',16.667,4),(846,7537904,7537898,'abl',16.667,4),(846,7537905,7537898,'ble',16.667,4),(846,7537906,7537898,'led',16.667,4),(846,7537907,7537901,'cac',33.333,1),(846,7537908,7537901,'ach',33.333,1),(846,7537909,7537901,'che',33.333,1),(846,7537910,7537907,'mod',50,1),(846,7537911,7537907,'ode',50,1),(846,7537912,7537910,'wri',14.286,1),(846,7537913,7537910,'rit',14.286,1),(846,7537914,7537910,'ite',14.286,1),(846,7537915,7537910,'tet',14.286,1),(846,7537916,7537910,'eth',14.286,1),(846,7537917,7537910,'thr',14.286,1),(846,7537918,7537910,'hru',14.286,1),(846,7537919,7537912,'ope',11.111,2),(846,7537920,7537912,'per',11.111,2),(846,7537921,7537912,'era',11.111,2),(846,7537922,7537912,'rat',11.111,2),(846,7537923,7537912,'ati',11.111,2),(846,7537924,7537912,'tio',11.111,2),(846,7537925,7537912,'ion',11.111,2),(846,7537926,7537912,'ona',11.111,2),(846,7537927,7537912,'nal',11.111,2),(846,7537928,7537919,'mes',20,1),(846,7537929,7537919,'ess',20,1),(846,7537930,7537919,'ssa',20,1),(846,7537931,7537919,'sag',20,1),(846,7537932,7537919,'age',20,1),(846,7537933,7537928,'per',11.111,1),(846,7537934,7537928,'erf',11.111,1),(846,7537935,7537928,'rfo',11.111,1),(846,7537936,7537928,'for',11.111,1),(846,7537937,7537928,'orm',11.111,1),(846,7537938,7537928,'rma',11.111,1),(846,7537939,7537928,'man',11.111,1),(846,7537940,7537928,'anc',11.111,1),(846,7537941,7537928,'nce',11.111,1),(846,7537942,7537933,'ide',12.5,1),(846,7537943,7537933,'den',12.5,1),(846,7537944,7537933,'ent',12.5,1),(846,7537945,7537933,'nti',12.5,1),(846,7537946,7537933,'tif',12.5,1),(846,7537947,7537933,'ifi',12.5,1),(846,7537948,7537933,'fie',12.5,1),(846,7537949,7537933,'ier',12.5,1),(846,7537950,7537942,'vdi',33.333,3),(846,7537951,7537942,'dis',33.333,3),(846,7537952,7537942,'isk',33.333,3),(846,7537953,7537950,'nam',50,1),(846,7537954,7537950,'ame',50,1),(846,7537955,7537953,'typ',50,1),(846,7537956,7537953,'ype',50,1),(846,7537957,7537955,'dir',25,1),(846,7537958,7537955,'ire',25,1),(846,7537959,7537955,'rec',25,1),(846,7537960,7537955,'ect',25,1),(847,7537962,7537961,'naa',100,2),(847,7537963,7537962,'600',3.333,3),(847,7537964,7537962,'000',3.333,3),(847,7537965,7537962,'00c',3.333,3),(847,7537966,7537962,'0c2',3.333,3),(847,7537967,7537962,'c29',3.333,3),(847,7537968,7537962,'298',3.333,3),(847,7537969,7537962,'983',3.333,3),(847,7537970,7537962,'83a',3.333,3),(847,7537971,7537962,'3ae',3.333,3),(847,7537972,7537962,'ae6',3.333,3),(847,7537973,7537962,'e64',3.333,3),(847,7537974,7537962,'648',3.333,3),(847,7537975,7537962,'482',3.333,3),(847,7537976,7537962,'82f',3.333,3),(847,7537977,7537962,'2f7',3.333,3),(847,7537978,7537962,'f7d',3.333,3),(847,7537979,7537962,'7da',3.333,3),(847,7537980,7537962,'da6',3.333,3),(847,7537981,7537962,'a67',3.333,3),(847,7537982,7537962,'675',3.333,3),(847,7537983,7537962,'75d',3.333,3),(847,7537984,7537962,'5d3',3.333,3),(847,7537985,7537962,'d39',3.333,3),(847,7537986,7537962,'394',3.333,3),(847,7537987,7537962,'942',3.333,3),(847,7537988,7537962,'428',3.333,3),(847,7537989,7537962,'28e',3.333,3),(847,7537990,7537962,'8e4',3.333,3),(847,7537991,7537962,'e4e',3.333,3),(847,7537992,7537962,'4e7',3.333,3),(847,7537993,7537963,'mon',100,1),(847,7537994,7537993,'201',50,1),(847,7537995,7537993,'013',50,1),(847,7537996,7537994,'adm',33.333,4),(847,7537997,7537994,'dmi',33.333,4),(847,7537998,7537994,'min',33.333,4),(847,7537999,7537996,'cap',16.667,1),(847,7538000,7537996,'apa',16.667,1),(847,7538001,7537996,'pac',16.667,1),(847,7538002,7537996,'aci',16.667,1),(847,7538003,7537996,'cit',16.667,1),(847,7538004,7537996,'ity',16.667,1),(847,7538005,7537999,'pat',50,1),(847,7538006,7537999,'ath',50,1),(847,7538007,7538005,'thr',33.333,1),(847,7538008,7538005,'hre',33.333,1),(847,7538009,7538005,'ree',33.333,1),(847,7538010,7538007,'fre',14.286,1),(847,7538011,7538007,'ree',14.286,1),(847,7538012,7538007,'ees',14.286,1),(847,7538013,7538007,'esp',14.286,1),(847,7538014,7538007,'spa',14.286,1),(847,7538015,7538007,'pac',14.286,1),(847,7538016,7538007,'ace',14.286,1),(847,7538017,7538010,'dis',50,1),(847,7538018,7538010,'isk',50,1),(847,7538019,7538017,'ind',33.333,1),(847,7538020,7538017,'nde',33.333,1),(847,7538021,7538017,'dex',33.333,1),(847,7538022,7538019,'adm',8.333,1),(847,7538023,7538019,'dmi',8.333,1),(847,7538024,7538019,'min',8.333,1),(847,7538025,7538019,'ini',8.333,1),(847,7538026,7538019,'nis',8.333,1),(847,7538027,7538019,'ist',8.333,1),(847,7538028,7538019,'str',8.333,1),(847,7538029,7538019,'tra',8.333,1),(847,7538030,7538019,'rat',8.333,1),(847,7538031,7538019,'ati',8.333,1),(847,7538032,7538019,'tio',8.333,1),(847,7538033,7538019,'ion',8.333,1),(847,7538034,7538022,'sta',33.333,3),(847,7538035,7538022,'tat',33.333,3),(847,7538036,7538022,'ate',33.333,3),(847,7538037,7538034,'dis',16.667,4),(847,7538038,7538034,'isa',16.667,4),(847,7538039,7538034,'sab',16.667,4),(847,7538040,7538034,'abl',16.667,4),(847,7538041,7538034,'ble',16.667,4),(847,7538042,7538034,'led',16.667,4),(847,7538043,7538037,'cac',33.333,1),(847,7538044,7538037,'ach',33.333,1),(847,7538045,7538037,'che',33.333,1),(847,7538046,7538043,'mod',50,1),(847,7538047,7538043,'ode',50,1),(847,7538048,7538046,'wri',14.286,1),(847,7538049,7538046,'rit',14.286,1),(847,7538050,7538046,'ite',14.286,1),(847,7538051,7538046,'tet',14.286,1),(847,7538052,7538046,'eth',14.286,1),(847,7538053,7538046,'thr',14.286,1),(847,7538054,7538046,'hru',14.286,1),(847,7538055,7538048,'ope',11.111,2),(847,7538056,7538048,'per',11.111,2),(847,7538057,7538048,'era',11.111,2),(847,7538058,7538048,'rat',11.111,2),(847,7538059,7538048,'ati',11.111,2),(847,7538060,7538048,'tio',11.111,2),(847,7538061,7538048,'ion',11.111,2),(847,7538062,7538048,'ona',11.111,2),(847,7538063,7538048,'nal',11.111,2),(847,7538064,7538055,'mes',20,1),(847,7538065,7538055,'ess',20,1),(847,7538066,7538055,'ssa',20,1),(847,7538067,7538055,'sag',20,1),(847,7538068,7538055,'age',20,1),(847,7538069,7538064,'per',11.111,1),(847,7538070,7538064,'erf',11.111,1),(847,7538071,7538064,'rfo',11.111,1),(847,7538072,7538064,'for',11.111,1),(847,7538073,7538064,'orm',11.111,1),(847,7538074,7538064,'rma',11.111,1),(847,7538075,7538064,'man',11.111,1),(847,7538076,7538064,'anc',11.111,1),(847,7538077,7538064,'nce',11.111,1),(847,7538078,7538069,'ide',12.5,1),(847,7538079,7538069,'den',12.5,1),(847,7538080,7538069,'ent',12.5,1),(847,7538081,7538069,'nti',12.5,1),(847,7538082,7538069,'tif',12.5,1),(847,7538083,7538069,'ifi',12.5,1),(847,7538084,7538069,'fie',12.5,1),(847,7538085,7538069,'ier',12.5,1),(847,7538086,7538078,'vdi',33.333,3),(847,7538087,7538078,'dis',33.333,3),(847,7538088,7538078,'isk',33.333,3),(847,7538089,7538086,'nam',50,1),(847,7538090,7538086,'ame',50,1),(847,7538091,7538089,'typ',50,1),(847,7538092,7538089,'ype',50,1),(847,7538093,7538091,'dir',25,1),(847,7538094,7538091,'ire',25,1),(847,7538095,7538091,'rec',25,1),(847,7538096,7538091,'ect',25,1),(848,7538098,7538097,'naa',100,2),(848,7538099,7538098,'600',3.333,3),(848,7538100,7538098,'000',3.333,3),(848,7538101,7538098,'00c',3.333,3),(848,7538102,7538098,'0c2',3.333,3),(848,7538103,7538098,'c29',3.333,3),(848,7538104,7538098,'292',3.333,3),(848,7538105,7538098,'92e',3.333,3),(848,7538106,7538098,'2e1',3.333,3),(848,7538107,7538098,'e1e',3.333,3),(848,7538108,7538098,'1e1',3.333,3),(848,7538109,7538098,'e10',3.333,3),(848,7538110,7538098,'106',3.333,3),(848,7538111,7538098,'060',3.333,3),(848,7538112,7538098,'608',3.333,3),(848,7538113,7538098,'088',3.333,3),(848,7538114,7538098,'882',3.333,3),(848,7538115,7538098,'82d',3.333,3),(848,7538116,7538098,'2d5',3.333,3),(848,7538117,7538098,'d56',3.333,3),(848,7538118,7538098,'564',3.333,3),(848,7538119,7538098,'649',3.333,3),(848,7538120,7538098,'49b',3.333,3),(848,7538121,7538098,'9b0',3.333,3),(848,7538122,7538098,'b09',3.333,3),(848,7538123,7538098,'095',3.333,3),(848,7538124,7538098,'958',3.333,3),(848,7538125,7538098,'58a',3.333,3),(848,7538126,7538098,'8ae',3.333,3),(848,7538127,7538098,'aec',3.333,3),(848,7538128,7538098,'ecd',3.333,3),(848,7538129,7538099,'mon',100,1),(848,7538130,7538129,'201',50,1),(848,7538131,7538129,'013',50,1),(848,7538132,7538130,'adm',33.333,4),(848,7538133,7538130,'dmi',33.333,4),(848,7538134,7538130,'min',33.333,4),(848,7538135,7538132,'cap',16.667,1),(848,7538136,7538132,'apa',16.667,1),(848,7538137,7538132,'pac',16.667,1),(848,7538138,7538132,'aci',16.667,1),(848,7538139,7538132,'cit',16.667,1),(848,7538140,7538132,'ity',16.667,1),(848,7538141,7538135,'pat',50,1),(848,7538142,7538135,'ath',50,1),(848,7538143,7538141,'fou',50,1),(848,7538144,7538141,'our',50,1),(848,7538145,7538143,'fre',14.286,1),(848,7538146,7538143,'ree',14.286,1),(848,7538147,7538143,'ees',14.286,1),(848,7538148,7538143,'esp',14.286,1),(848,7538149,7538143,'spa',14.286,1),(848,7538150,7538143,'pac',14.286,1),(848,7538151,7538143,'ace',14.286,1),(848,7538152,7538145,'dis',50,1),(848,7538153,7538145,'isk',50,1),(848,7538154,7538152,'ind',33.333,1),(848,7538155,7538152,'nde',33.333,1),(848,7538156,7538152,'dex',33.333,1),(848,7538157,7538154,'adm',8.333,1),(848,7538158,7538154,'dmi',8.333,1),(848,7538159,7538154,'min',8.333,1),(848,7538160,7538154,'ini',8.333,1),(848,7538161,7538154,'nis',8.333,1),(848,7538162,7538154,'ist',8.333,1),(848,7538163,7538154,'str',8.333,1),(848,7538164,7538154,'tra',8.333,1),(848,7538165,7538154,'rat',8.333,1),(848,7538166,7538154,'ati',8.333,1),(848,7538167,7538154,'tio',8.333,1),(848,7538168,7538154,'ion',8.333,1),(848,7538169,7538157,'sta',33.333,3),(848,7538170,7538157,'tat',33.333,3),(848,7538171,7538157,'ate',33.333,3),(848,7538172,7538169,'dis',16.667,4),(848,7538173,7538169,'isa',16.667,4),(848,7538174,7538169,'sab',16.667,4),(848,7538175,7538169,'abl',16.667,4),(848,7538176,7538169,'ble',16.667,4),(848,7538177,7538169,'led',16.667,4),(848,7538178,7538172,'cac',33.333,1),(848,7538179,7538172,'ach',33.333,1),(848,7538180,7538172,'che',33.333,1),(848,7538181,7538178,'mod',50,1),(848,7538182,7538178,'ode',50,1),(848,7538183,7538181,'wri',14.286,1),(848,7538184,7538181,'rit',14.286,1),(848,7538185,7538181,'ite',14.286,1),(848,7538186,7538181,'tet',14.286,1),(848,7538187,7538181,'eth',14.286,1),(848,7538188,7538181,'thr',14.286,1),(848,7538189,7538181,'hru',14.286,1),(848,7538190,7538183,'ope',11.111,2),(848,7538191,7538183,'per',11.111,2),(848,7538192,7538183,'era',11.111,2),(848,7538193,7538183,'rat',11.111,2),(848,7538194,7538183,'ati',11.111,2),(848,7538195,7538183,'tio',11.111,2),(848,7538196,7538183,'ion',11.111,2),(848,7538197,7538183,'ona',11.111,2),(848,7538198,7538183,'nal',11.111,2),(848,7538199,7538190,'mes',20,1),(848,7538200,7538190,'ess',20,1),(848,7538201,7538190,'ssa',20,1),(848,7538202,7538190,'sag',20,1),(848,7538203,7538190,'age',20,1),(848,7538204,7538199,'per',11.111,1),(848,7538205,7538199,'erf',11.111,1),(848,7538206,7538199,'rfo',11.111,1),(848,7538207,7538199,'for',11.111,1),(848,7538208,7538199,'orm',11.111,1),(848,7538209,7538199,'rma',11.111,1),(848,7538210,7538199,'man',11.111,1),(848,7538211,7538199,'anc',11.111,1),(848,7538212,7538199,'nce',11.111,1),(848,7538213,7538204,'ide',12.5,1),(848,7538214,7538204,'den',12.5,1),(848,7538215,7538204,'ent',12.5,1),(848,7538216,7538204,'nti',12.5,1),(848,7538217,7538204,'tif',12.5,1),(848,7538218,7538204,'ifi',12.5,1),(848,7538219,7538204,'fie',12.5,1),(848,7538220,7538204,'ier',12.5,1),(848,7538221,7538213,'vdi',33.333,3),(848,7538222,7538213,'dis',33.333,3),(848,7538223,7538213,'isk',33.333,3),(848,7538224,7538221,'nam',50,1),(848,7538225,7538221,'ame',50,1),(848,7538226,7538224,'typ',50,1),(848,7538227,7538224,'ype',50,1),(848,7538228,7538226,'dir',25,1),(848,7538229,7538226,'ire',25,1),(848,7538230,7538226,'rec',25,1),(848,7538231,7538226,'ect',25,1),(849,7538233,7538232,'naa',100,2),(849,7538234,7538233,'600',3.333,3),(849,7538235,7538233,'000',3.333,3),(849,7538236,7538233,'00c',3.333,3),(849,7538237,7538233,'0c2',3.333,3),(849,7538238,7538233,'c29',3.333,3),(849,7538239,7538233,'29d',3.333,3),(849,7538240,7538233,'9dd',3.333,3),(849,7538241,7538233,'dd7',3.333,3),(849,7538242,7538233,'d7d',3.333,3),(849,7538243,7538233,'7d2',3.333,3),(849,7538244,7538233,'d2c',3.333,3),(849,7538245,7538233,'2cb',3.333,3),(849,7538246,7538233,'cbb',3.333,3),(849,7538247,7538233,'bbd',3.333,3),(849,7538248,7538233,'bde',3.333,3),(849,7538249,7538233,'de8',3.333,3),(849,7538250,7538233,'e8b',3.333,3),(849,7538251,7538233,'8bc',3.333,3),(849,7538252,7538233,'bcd',3.333,3),(849,7538253,7538233,'cd7',3.333,3),(849,7538254,7538233,'d79',3.333,3),(849,7538255,7538233,'791',3.333,3),(849,7538256,7538233,'91a',3.333,3),(849,7538257,7538233,'1a5',3.333,3),(849,7538258,7538233,'a58',3.333,3),(849,7538259,7538233,'583',3.333,3),(849,7538260,7538233,'833',3.333,3),(849,7538261,7538233,'338',3.333,3),(849,7538262,7538233,'38c',3.333,3),(849,7538263,7538233,'8cb',3.333,3),(849,7538264,7538234,'mon',100,1),(849,7538265,7538264,'201',50,1),(849,7538266,7538264,'013',50,1),(849,7538267,7538265,'adm',33.333,4),(849,7538268,7538265,'dmi',33.333,4),(849,7538269,7538265,'min',33.333,4),(849,7538270,7538267,'cap',16.667,1),(849,7538271,7538267,'apa',16.667,1),(849,7538272,7538267,'pac',16.667,1),(849,7538273,7538267,'aci',16.667,1),(849,7538274,7538267,'cit',16.667,1),(849,7538275,7538267,'ity',16.667,1),(849,7538276,7538270,'pat',50,1),(849,7538277,7538270,'ath',50,1),(849,7538278,7538276,'fiv',50,1),(849,7538279,7538276,'ive',50,1),(849,7538280,7538278,'fre',14.286,1),(849,7538281,7538278,'ree',14.286,1),(849,7538282,7538278,'ees',14.286,1),(849,7538283,7538278,'esp',14.286,1),(849,7538284,7538278,'spa',14.286,1),(849,7538285,7538278,'pac',14.286,1),(849,7538286,7538278,'ace',14.286,1),(849,7538287,7538280,'dis',50,1),(849,7538288,7538280,'isk',50,1),(849,7538289,7538287,'ind',33.333,1),(849,7538290,7538287,'nde',33.333,1),(849,7538291,7538287,'dex',33.333,1),(849,7538292,7538289,'adm',8.333,1),(849,7538293,7538289,'dmi',8.333,1),(849,7538294,7538289,'min',8.333,1),(849,7538295,7538289,'ini',8.333,1),(849,7538296,7538289,'nis',8.333,1),(849,7538297,7538289,'ist',8.333,1),(849,7538298,7538289,'str',8.333,1),(849,7538299,7538289,'tra',8.333,1),(849,7538300,7538289,'rat',8.333,1),(849,7538301,7538289,'ati',8.333,1),(849,7538302,7538289,'tio',8.333,1),(849,7538303,7538289,'ion',8.333,1),(849,7538304,7538292,'sta',33.333,3),(849,7538305,7538292,'tat',33.333,3),(849,7538306,7538292,'ate',33.333,3),(849,7538307,7538304,'dis',16.667,4),(849,7538308,7538304,'isa',16.667,4),(849,7538309,7538304,'sab',16.667,4),(849,7538310,7538304,'abl',16.667,4),(849,7538311,7538304,'ble',16.667,4),(849,7538312,7538304,'led',16.667,4),(849,7538313,7538307,'cac',33.333,1),(849,7538314,7538307,'ach',33.333,1),(849,7538315,7538307,'che',33.333,1),(849,7538316,7538313,'mod',50,1),(849,7538317,7538313,'ode',50,1),(849,7538318,7538316,'wri',14.286,1),(849,7538319,7538316,'rit',14.286,1),(849,7538320,7538316,'ite',14.286,1),(849,7538321,7538316,'tet',14.286,1),(849,7538322,7538316,'eth',14.286,1),(849,7538323,7538316,'thr',14.286,1),(849,7538324,7538316,'hru',14.286,1),(849,7538325,7538318,'ope',11.111,2),(849,7538326,7538318,'per',11.111,2),(849,7538327,7538318,'era',11.111,2),(849,7538328,7538318,'rat',11.111,2),(849,7538329,7538318,'ati',11.111,2),(849,7538330,7538318,'tio',11.111,2),(849,7538331,7538318,'ion',11.111,2),(849,7538332,7538318,'ona',11.111,2),(849,7538333,7538318,'nal',11.111,2),(849,7538334,7538325,'mes',20,1),(849,7538335,7538325,'ess',20,1),(849,7538336,7538325,'ssa',20,1),(849,7538337,7538325,'sag',20,1),(849,7538338,7538325,'age',20,1),(849,7538339,7538334,'per',11.111,1),(849,7538340,7538334,'erf',11.111,1),(849,7538341,7538334,'rfo',11.111,1),(849,7538342,7538334,'for',11.111,1),(849,7538343,7538334,'orm',11.111,1),(849,7538344,7538334,'rma',11.111,1),(849,7538345,7538334,'man',11.111,1),(849,7538346,7538334,'anc',11.111,1),(849,7538347,7538334,'nce',11.111,1),(849,7538348,7538339,'ide',12.5,1),(849,7538349,7538339,'den',12.5,1),(849,7538350,7538339,'ent',12.5,1),(849,7538351,7538339,'nti',12.5,1),(849,7538352,7538339,'tif',12.5,1),(849,7538353,7538339,'ifi',12.5,1),(849,7538354,7538339,'fie',12.5,1),(849,7538355,7538339,'ier',12.5,1),(849,7538356,7538348,'vdi',33.333,3),(849,7538357,7538348,'dis',33.333,3),(849,7538358,7538348,'isk',33.333,3),(849,7538359,7538356,'nam',50,1),(849,7538360,7538356,'ame',50,1),(849,7538361,7538359,'typ',50,1),(849,7538362,7538359,'ype',50,1),(849,7538363,7538361,'dir',25,1),(849,7538364,7538361,'ire',25,1),(849,7538365,7538361,'rec',25,1),(849,7538366,7538361,'ect',25,1),(850,7538368,7538367,'naa',100,2),(850,7538369,7538368,'600',3.333,3),(850,7538370,7538368,'000',3.333,3),(850,7538371,7538368,'00c',3.333,3),(850,7538372,7538368,'0c2',3.333,3),(850,7538373,7538368,'c29',3.333,3),(850,7538374,7538368,'292',3.333,3),(850,7538375,7538368,'92e',3.333,3),(850,7538376,7538368,'2ec',3.333,3),(850,7538377,7538368,'ec7',3.333,3),(850,7538378,7538368,'c7f',3.333,3),(850,7538379,7538368,'7ff',3.333,3),(850,7538380,7538368,'ffa',3.333,3),(850,7538381,7538368,'fa1',3.333,3),(850,7538382,7538368,'a1b',3.333,3),(850,7538383,7538368,'1be',3.333,3),(850,7538384,7538368,'beb',3.333,3),(850,7538385,7538368,'ebe',3.333,3),(850,7538386,7538368,'be5',3.333,3),(850,7538387,7538368,'e5b',3.333,3),(850,7538388,7538368,'5b1',3.333,3),(850,7538389,7538368,'b13',3.333,3),(850,7538390,7538368,'133',3.333,3),(850,7538391,7538368,'336',3.333,3),(850,7538392,7538368,'363',3.333,3),(850,7538393,7538368,'635',3.333,3),(850,7538394,7538368,'351',3.333,3),(850,7538395,7538368,'511',3.333,3),(850,7538396,7538368,'110',3.333,3),(850,7538397,7538368,'109',3.333,3),(850,7538398,7538368,'091',3.333,3),(850,7538399,7538369,'mon',100,1),(850,7538400,7538399,'201',50,1),(850,7538401,7538399,'013',50,1),(850,7538402,7538400,'adm',33.333,4),(850,7538403,7538400,'dmi',33.333,4),(850,7538404,7538400,'min',33.333,4),(850,7538405,7538402,'cap',16.667,1),(850,7538406,7538402,'apa',16.667,1),(850,7538407,7538402,'pac',16.667,1),(850,7538408,7538402,'aci',16.667,1),(850,7538409,7538402,'cit',16.667,1),(850,7538410,7538402,'ity',16.667,1),(850,7538411,7538405,'pat',50,1),(850,7538412,7538405,'ath',50,1),(850,7538413,7538411,'six',100,1),(850,7538414,7538413,'fre',14.286,1),(850,7538415,7538413,'ree',14.286,1),(850,7538416,7538413,'ees',14.286,1),(850,7538417,7538413,'esp',14.286,1),(850,7538418,7538413,'spa',14.286,1),(850,7538419,7538413,'pac',14.286,1),(850,7538420,7538413,'ace',14.286,1),(850,7538421,7538414,'dis',50,1),(850,7538422,7538414,'isk',50,1),(850,7538423,7538421,'ind',33.333,1),(850,7538424,7538421,'nde',33.333,1),(850,7538425,7538421,'dex',33.333,1),(850,7538426,7538423,'adm',8.333,1),(850,7538427,7538423,'dmi',8.333,1),(850,7538428,7538423,'min',8.333,1),(850,7538429,7538423,'ini',8.333,1),(850,7538430,7538423,'nis',8.333,1),(850,7538431,7538423,'ist',8.333,1),(850,7538432,7538423,'str',8.333,1),(850,7538433,7538423,'tra',8.333,1),(850,7538434,7538423,'rat',8.333,1),(850,7538435,7538423,'ati',8.333,1),(850,7538436,7538423,'tio',8.333,1),(850,7538437,7538423,'ion',8.333,1),(850,7538438,7538426,'sta',33.333,3),(850,7538439,7538426,'tat',33.333,3),(850,7538440,7538426,'ate',33.333,3),(850,7538441,7538438,'dis',16.667,4),(850,7538442,7538438,'isa',16.667,4),(850,7538443,7538438,'sab',16.667,4),(850,7538444,7538438,'abl',16.667,4),(850,7538445,7538438,'ble',16.667,4),(850,7538446,7538438,'led',16.667,4),(850,7538447,7538441,'cac',33.333,1),(850,7538448,7538441,'ach',33.333,1),(850,7538449,7538441,'che',33.333,1),(850,7538450,7538447,'mod',50,1),(850,7538451,7538447,'ode',50,1),(850,7538452,7538450,'wri',14.286,1),(850,7538453,7538450,'rit',14.286,1),(850,7538454,7538450,'ite',14.286,1),(850,7538455,7538450,'tet',14.286,1),(850,7538456,7538450,'eth',14.286,1),(850,7538457,7538450,'thr',14.286,1),(850,7538458,7538450,'hru',14.286,1),(850,7538459,7538452,'ope',11.111,2),(850,7538460,7538452,'per',11.111,2),(850,7538461,7538452,'era',11.111,2),(850,7538462,7538452,'rat',11.111,2),(850,7538463,7538452,'ati',11.111,2),(850,7538464,7538452,'tio',11.111,2),(850,7538465,7538452,'ion',11.111,2),(850,7538466,7538452,'ona',11.111,2),(850,7538467,7538452,'nal',11.111,2),(850,7538468,7538459,'mes',20,1),(850,7538469,7538459,'ess',20,1),(850,7538470,7538459,'ssa',20,1),(850,7538471,7538459,'sag',20,1),(850,7538472,7538459,'age',20,1),(850,7538473,7538468,'per',11.111,1),(850,7538474,7538468,'erf',11.111,1),(850,7538475,7538468,'rfo',11.111,1),(850,7538476,7538468,'for',11.111,1),(850,7538477,7538468,'orm',11.111,1),(850,7538478,7538468,'rma',11.111,1),(850,7538479,7538468,'man',11.111,1),(850,7538480,7538468,'anc',11.111,1),(850,7538481,7538468,'nce',11.111,1),(850,7538482,7538473,'ide',12.5,1),(850,7538483,7538473,'den',12.5,1),(850,7538484,7538473,'ent',12.5,1),(850,7538485,7538473,'nti',12.5,1),(850,7538486,7538473,'tif',12.5,1),(850,7538487,7538473,'ifi',12.5,1),(850,7538488,7538473,'fie',12.5,1),(850,7538489,7538473,'ier',12.5,1),(850,7538490,7538482,'vdi',33.333,3),(850,7538491,7538482,'dis',33.333,3),(850,7538492,7538482,'isk',33.333,3),(850,7538493,7538490,'nam',50,1),(850,7538494,7538490,'ame',50,1),(850,7538495,7538493,'typ',50,1),(850,7538496,7538493,'ype',50,1),(850,7538497,7538495,'dir',25,1),(850,7538498,7538495,'ire',25,1),(850,7538499,7538495,'rec',25,1),(850,7538500,7538495,'ect',25,1),(851,7538502,7538501,'naa',100,2),(851,7538503,7538502,'600',3.333,3),(851,7538504,7538502,'000',3.333,3),(851,7538505,7538502,'00c',3.333,3),(851,7538506,7538502,'0c2',3.333,3),(851,7538507,7538502,'c29',3.333,3),(851,7538508,7538502,'299',3.333,3),(851,7538509,7538502,'999',3.333,3),(851,7538510,7538502,'995',3.333,3),(851,7538511,7538502,'95d',3.333,3),(851,7538512,7538502,'5d3',3.333,3),(851,7538513,7538502,'d3d',3.333,3),(851,7538514,7538502,'3dc',3.333,3),(851,7538515,7538502,'dcb',3.333,3),(851,7538516,7538502,'cbf',3.333,3),(851,7538517,7538502,'bf9',3.333,3),(851,7538518,7538502,'f9c',3.333,3),(851,7538519,7538502,'9c5',3.333,3),(851,7538520,7538502,'c51',3.333,3),(851,7538521,7538502,'519',3.333,3),(851,7538522,7538502,'19c',3.333,3),(851,7538523,7538502,'9c1',3.333,3),(851,7538524,7538502,'c1d',3.333,3),(851,7538525,7538502,'1d2',3.333,3),(851,7538526,7538502,'d2d',3.333,3),(851,7538527,7538502,'2d3',3.333,3),(851,7538528,7538502,'d32',3.333,3),(851,7538529,7538502,'32d',3.333,3),(851,7538530,7538502,'2d6',3.333,3),(851,7538531,7538502,'d6d',3.333,3),(851,7538532,7538502,'6d1',3.333,3),(851,7538533,7538503,'mon',100,1),(851,7538534,7538533,'201',50,1),(851,7538535,7538533,'013',50,1),(851,7538536,7538534,'adm',33.333,4),(851,7538537,7538534,'dmi',33.333,4),(851,7538538,7538534,'min',33.333,4),(851,7538539,7538536,'cap',16.667,1),(851,7538540,7538536,'apa',16.667,1),(851,7538541,7538536,'pac',16.667,1),(851,7538542,7538536,'aci',16.667,1),(851,7538543,7538536,'cit',16.667,1),(851,7538544,7538536,'ity',16.667,1),(851,7538545,7538539,'pat',50,1),(851,7538546,7538539,'ath',50,1),(851,7538547,7538545,'sev',33.333,1),(851,7538548,7538545,'eve',33.333,1),(851,7538549,7538545,'ven',33.333,1),(851,7538550,7538547,'fre',14.286,1),(851,7538551,7538547,'ree',14.286,1),(851,7538552,7538547,'ees',14.286,1),(851,7538553,7538547,'esp',14.286,1),(851,7538554,7538547,'spa',14.286,1),(851,7538555,7538547,'pac',14.286,1),(851,7538556,7538547,'ace',14.286,1),(851,7538557,7538550,'dis',50,1),(851,7538558,7538550,'isk',50,1),(851,7538559,7538557,'ind',33.333,1),(851,7538560,7538557,'nde',33.333,1),(851,7538561,7538557,'dex',33.333,1),(851,7538562,7538559,'adm',8.333,1),(851,7538563,7538559,'dmi',8.333,1),(851,7538564,7538559,'min',8.333,1),(851,7538565,7538559,'ini',8.333,1),(851,7538566,7538559,'nis',8.333,1),(851,7538567,7538559,'ist',8.333,1),(851,7538568,7538559,'str',8.333,1),(851,7538569,7538559,'tra',8.333,1),(851,7538570,7538559,'rat',8.333,1),(851,7538571,7538559,'ati',8.333,1),(851,7538572,7538559,'tio',8.333,1),(851,7538573,7538559,'ion',8.333,1),(851,7538574,7538562,'sta',33.333,3),(851,7538575,7538562,'tat',33.333,3),(851,7538576,7538562,'ate',33.333,3),(851,7538577,7538574,'dis',16.667,4),(851,7538578,7538574,'isa',16.667,4),(851,7538579,7538574,'sab',16.667,4),(851,7538580,7538574,'abl',16.667,4),(851,7538581,7538574,'ble',16.667,4),(851,7538582,7538574,'led',16.667,4),(851,7538583,7538577,'cac',33.333,1),(851,7538584,7538577,'ach',33.333,1),(851,7538585,7538577,'che',33.333,1),(851,7538586,7538583,'mod',50,1),(851,7538587,7538583,'ode',50,1),(851,7538588,7538586,'wri',14.286,1),(851,7538589,7538586,'rit',14.286,1),(851,7538590,7538586,'ite',14.286,1),(851,7538591,7538586,'tet',14.286,1),(851,7538592,7538586,'eth',14.286,1),(851,7538593,7538586,'thr',14.286,1),(851,7538594,7538586,'hru',14.286,1),(851,7538595,7538588,'ope',11.111,2),(851,7538596,7538588,'per',11.111,2),(851,7538597,7538588,'era',11.111,2),(851,7538598,7538588,'rat',11.111,2),(851,7538599,7538588,'ati',11.111,2),(851,7538600,7538588,'tio',11.111,2),(851,7538601,7538588,'ion',11.111,2),(851,7538602,7538588,'ona',11.111,2),(851,7538603,7538588,'nal',11.111,2),(851,7538604,7538595,'mes',20,1),(851,7538605,7538595,'ess',20,1),(851,7538606,7538595,'ssa',20,1),(851,7538607,7538595,'sag',20,1),(851,7538608,7538595,'age',20,1),(851,7538609,7538604,'per',11.111,1),(851,7538610,7538604,'erf',11.111,1),(851,7538611,7538604,'rfo',11.111,1),(851,7538612,7538604,'for',11.111,1),(851,7538613,7538604,'orm',11.111,1),(851,7538614,7538604,'rma',11.111,1),(851,7538615,7538604,'man',11.111,1),(851,7538616,7538604,'anc',11.111,1),(851,7538617,7538604,'nce',11.111,1),(851,7538618,7538609,'ide',12.5,1),(851,7538619,7538609,'den',12.5,1),(851,7538620,7538609,'ent',12.5,1),(851,7538621,7538609,'nti',12.5,1),(851,7538622,7538609,'tif',12.5,1),(851,7538623,7538609,'ifi',12.5,1),(851,7538624,7538609,'fie',12.5,1),(851,7538625,7538609,'ier',12.5,1),(851,7538626,7538618,'vdi',33.333,3),(851,7538627,7538618,'dis',33.333,3),(851,7538628,7538618,'isk',33.333,3),(851,7538629,7538626,'nam',50,1),(851,7538630,7538626,'ame',50,1),(851,7538631,7538629,'typ',50,1),(851,7538632,7538629,'ype',50,1),(851,7538633,7538631,'dir',25,1),(851,7538634,7538631,'ire',25,1),(851,7538635,7538631,'rec',25,1),(851,7538636,7538631,'ect',25,1),(852,7538638,7538637,'naa',100,2),(852,7538639,7538638,'600',3.333,3),(852,7538640,7538638,'000',3.333,3),(852,7538641,7538638,'00c',3.333,3),(852,7538642,7538638,'0c2',3.333,3),(852,7538643,7538638,'c29',3.333,3),(852,7538644,7538638,'29a',3.333,3),(852,7538645,7538638,'9a7',3.333,3),(852,7538646,7538638,'a74',3.333,3),(852,7538647,7538638,'740',3.333,3),(852,7538648,7538638,'40d',3.333,3),(852,7538649,7538638,'0d7',3.333,3),(852,7538650,7538638,'d71',3.333,3),(852,7538651,7538638,'71c',3.333,3),(852,7538652,7538638,'1ce',3.333,3),(852,7538653,7538638,'ce5',3.333,3),(852,7538654,7538638,'e54',3.333,3),(852,7538655,7538638,'548',3.333,3),(852,7538656,7538638,'48b',3.333,3),(852,7538657,7538638,'8bc',3.333,3),(852,7538658,7538638,'bc6',3.333,3),(852,7538659,7538638,'c61',3.333,3),(852,7538660,7538638,'614',3.333,3),(852,7538661,7538638,'146',3.333,3),(852,7538662,7538638,'46f',3.333,3),(852,7538663,7538638,'6fe',3.333,3),(852,7538664,7538638,'fe9',3.333,3),(852,7538665,7538638,'e94',3.333,3),(852,7538666,7538638,'94e',3.333,3),(852,7538667,7538638,'4e0',3.333,3),(852,7538668,7538638,'e05',3.333,3),(852,7538669,7538639,'mon',100,1),(852,7538670,7538669,'201',50,1),(852,7538671,7538669,'013',50,1),(852,7538672,7538670,'adm',33.333,4),(852,7538673,7538670,'dmi',33.333,4),(852,7538674,7538670,'min',33.333,4),(852,7538675,7538672,'cap',16.667,1),(852,7538676,7538672,'apa',16.667,1),(852,7538677,7538672,'pac',16.667,1),(852,7538678,7538672,'aci',16.667,1),(852,7538679,7538672,'cit',16.667,1),(852,7538680,7538672,'ity',16.667,1),(852,7538681,7538675,'pat',50,1),(852,7538682,7538675,'ath',50,1),(852,7538683,7538681,'eig',33.333,1),(852,7538684,7538681,'igh',33.333,1),(852,7538685,7538681,'ght',33.333,1),(852,7538686,7538683,'fre',14.286,1),(852,7538687,7538683,'ree',14.286,1),(852,7538688,7538683,'ees',14.286,1),(852,7538689,7538683,'esp',14.286,1),(852,7538690,7538683,'spa',14.286,1),(852,7538691,7538683,'pac',14.286,1),(852,7538692,7538683,'ace',14.286,1),(852,7538693,7538686,'dis',50,1),(852,7538694,7538686,'isk',50,1),(852,7538695,7538693,'ind',33.333,1),(852,7538696,7538693,'nde',33.333,1),(852,7538697,7538693,'dex',33.333,1),(852,7538698,7538695,'adm',8.333,1),(852,7538699,7538695,'dmi',8.333,1),(852,7538700,7538695,'min',8.333,1),(852,7538701,7538695,'ini',8.333,1),(852,7538702,7538695,'nis',8.333,1),(852,7538703,7538695,'ist',8.333,1),(852,7538704,7538695,'str',8.333,1),(852,7538705,7538695,'tra',8.333,1),(852,7538706,7538695,'rat',8.333,1),(852,7538707,7538695,'ati',8.333,1),(852,7538708,7538695,'tio',8.333,1),(852,7538709,7538695,'ion',8.333,1),(852,7538710,7538698,'sta',33.333,3),(852,7538711,7538698,'tat',33.333,3),(852,7538712,7538698,'ate',33.333,3),(852,7538713,7538710,'dis',16.667,4),(852,7538714,7538710,'isa',16.667,4),(852,7538715,7538710,'sab',16.667,4),(852,7538716,7538710,'abl',16.667,4),(852,7538717,7538710,'ble',16.667,4),(852,7538718,7538710,'led',16.667,4),(852,7538719,7538713,'cac',33.333,1),(852,7538720,7538713,'ach',33.333,1),(852,7538721,7538713,'che',33.333,1),(852,7538722,7538719,'mod',50,1),(852,7538723,7538719,'ode',50,1),(852,7538724,7538722,'wri',14.286,1),(852,7538725,7538722,'rit',14.286,1),(852,7538726,7538722,'ite',14.286,1),(852,7538727,7538722,'tet',14.286,1),(852,7538728,7538722,'eth',14.286,1),(852,7538729,7538722,'thr',14.286,1),(852,7538730,7538722,'hru',14.286,1),(852,7538731,7538724,'ope',11.111,2),(852,7538732,7538724,'per',11.111,2),(852,7538733,7538724,'era',11.111,2),(852,7538734,7538724,'rat',11.111,2),(852,7538735,7538724,'ati',11.111,2),(852,7538736,7538724,'tio',11.111,2),(852,7538737,7538724,'ion',11.111,2),(852,7538738,7538724,'ona',11.111,2),(852,7538739,7538724,'nal',11.111,2),(852,7538740,7538731,'mes',20,1),(852,7538741,7538731,'ess',20,1),(852,7538742,7538731,'ssa',20,1),(852,7538743,7538731,'sag',20,1),(852,7538744,7538731,'age',20,1),(852,7538745,7538740,'per',11.111,1),(852,7538746,7538740,'erf',11.111,1),(852,7538747,7538740,'rfo',11.111,1),(852,7538748,7538740,'for',11.111,1),(852,7538749,7538740,'orm',11.111,1),(852,7538750,7538740,'rma',11.111,1),(852,7538751,7538740,'man',11.111,1),(852,7538752,7538740,'anc',11.111,1),(852,7538753,7538740,'nce',11.111,1),(852,7538754,7538745,'ide',12.5,1),(852,7538755,7538745,'den',12.5,1),(852,7538756,7538745,'ent',12.5,1),(852,7538757,7538745,'nti',12.5,1),(852,7538758,7538745,'tif',12.5,1),(852,7538759,7538745,'ifi',12.5,1),(852,7538760,7538745,'fie',12.5,1),(852,7538761,7538745,'ier',12.5,1),(852,7538762,7538754,'vdi',33.333,3),(852,7538763,7538754,'dis',33.333,3),(852,7538764,7538754,'isk',33.333,3),(852,7538765,7538762,'nam',50,1),(852,7538766,7538762,'ame',50,1),(852,7538767,7538765,'typ',50,1),(852,7538768,7538765,'ype',50,1),(852,7538769,7538767,'dir',25,1),(852,7538770,7538767,'ire',25,1),(852,7538771,7538767,'rec',25,1),(852,7538772,7538767,'ect',25,1),(853,7538774,7538773,'naa',100,2),(853,7538775,7538774,'600',3.333,3),(853,7538776,7538774,'000',3.333,3),(853,7538777,7538774,'00c',3.333,3),(853,7538778,7538774,'0c2',3.333,3),(853,7538779,7538774,'c29',3.333,3),(853,7538780,7538774,'29f',3.333,3),(853,7538781,7538774,'9fd',3.333,3),(853,7538782,7538774,'fd6',3.333,3),(853,7538783,7538774,'d6f',3.333,3),(853,7538784,7538774,'6ff',3.333,3),(853,7538785,7538774,'ffe',3.333,3),(853,7538786,7538774,'fe8',3.333,3),(853,7538787,7538774,'e8f',3.333,3),(853,7538788,7538774,'8f6',3.333,3),(853,7538789,7538774,'f63',3.333,3),(853,7538790,7538774,'638',3.333,3),(853,7538791,7538774,'38b',3.333,3),(853,7538792,7538774,'8b3',3.333,3),(853,7538793,7538774,'b37',3.333,3),(853,7538794,7538774,'37c',3.333,3),(853,7538795,7538774,'7c6',3.333,3),(853,7538796,7538774,'c62',3.333,3),(853,7538797,7538774,'620',3.333,3),(853,7538798,7538774,'20e',3.333,3),(853,7538799,7538774,'0e3',3.333,3),(853,7538800,7538774,'e32',3.333,3),(853,7538801,7538774,'32b',3.333,3),(853,7538802,7538774,'2b5',3.333,3),(853,7538803,7538774,'b5f',3.333,3),(853,7538804,7538774,'5f9',3.333,3),(853,7538805,7538775,'mon',100,1),(853,7538806,7538805,'201',50,1),(853,7538807,7538805,'013',50,1),(853,7538808,7538806,'adm',33.333,4),(853,7538809,7538806,'dmi',33.333,4),(853,7538810,7538806,'min',33.333,4),(853,7538811,7538808,'cap',16.667,1),(853,7538812,7538808,'apa',16.667,1),(853,7538813,7538808,'pac',16.667,1),(853,7538814,7538808,'aci',16.667,1),(853,7538815,7538808,'cit',16.667,1),(853,7538816,7538808,'ity',16.667,1),(853,7538817,7538811,'pat',50,1),(853,7538818,7538811,'ath',50,1),(853,7538819,7538817,'nin',50,1),(853,7538820,7538817,'ine',50,1),(853,7538821,7538819,'fre',14.286,1),(853,7538822,7538819,'ree',14.286,1),(853,7538823,7538819,'ees',14.286,1),(853,7538824,7538819,'esp',14.286,1),(853,7538825,7538819,'spa',14.286,1),(853,7538826,7538819,'pac',14.286,1),(853,7538827,7538819,'ace',14.286,1),(853,7538828,7538821,'dis',50,1),(853,7538829,7538821,'isk',50,1),(853,7538830,7538828,'ind',33.333,1),(853,7538831,7538828,'nde',33.333,1),(853,7538832,7538828,'dex',33.333,1),(853,7538833,7538830,'adm',8.333,1),(853,7538834,7538830,'dmi',8.333,1),(853,7538835,7538830,'min',8.333,1),(853,7538836,7538830,'ini',8.333,1),(853,7538837,7538830,'nis',8.333,1),(853,7538838,7538830,'ist',8.333,1),(853,7538839,7538830,'str',8.333,1),(853,7538840,7538830,'tra',8.333,1),(853,7538841,7538830,'rat',8.333,1),(853,7538842,7538830,'ati',8.333,1),(853,7538843,7538830,'tio',8.333,1),(853,7538844,7538830,'ion',8.333,1),(853,7538845,7538833,'sta',33.333,3),(853,7538846,7538833,'tat',33.333,3),(853,7538847,7538833,'ate',33.333,3),(853,7538848,7538845,'dis',16.667,4),(853,7538849,7538845,'isa',16.667,4),(853,7538850,7538845,'sab',16.667,4),(853,7538851,7538845,'abl',16.667,4),(853,7538852,7538845,'ble',16.667,4),(853,7538853,7538845,'led',16.667,4),(853,7538854,7538848,'cac',33.333,1),(853,7538855,7538848,'ach',33.333,1),(853,7538856,7538848,'che',33.333,1),(853,7538857,7538854,'mod',50,1),(853,7538858,7538854,'ode',50,1),(853,7538859,7538857,'wri',14.286,1),(853,7538860,7538857,'rit',14.286,1),(853,7538861,7538857,'ite',14.286,1),(853,7538862,7538857,'tet',14.286,1),(853,7538863,7538857,'eth',14.286,1),(853,7538864,7538857,'thr',14.286,1),(853,7538865,7538857,'hru',14.286,1),(853,7538866,7538859,'ope',11.111,2),(853,7538867,7538859,'per',11.111,2),(853,7538868,7538859,'era',11.111,2),(853,7538869,7538859,'rat',11.111,2),(853,7538870,7538859,'ati',11.111,2),(853,7538871,7538859,'tio',11.111,2),(853,7538872,7538859,'ion',11.111,2),(853,7538873,7538859,'ona',11.111,2),(853,7538874,7538859,'nal',11.111,2),(853,7538875,7538866,'mes',20,1),(853,7538876,7538866,'ess',20,1),(853,7538877,7538866,'ssa',20,1),(853,7538878,7538866,'sag',20,1),(853,7538879,7538866,'age',20,1),(853,7538880,7538875,'per',11.111,1),(853,7538881,7538875,'erf',11.111,1),(853,7538882,7538875,'rfo',11.111,1),(853,7538883,7538875,'for',11.111,1),(853,7538884,7538875,'orm',11.111,1),(853,7538885,7538875,'rma',11.111,1),(853,7538886,7538875,'man',11.111,1),(853,7538887,7538875,'anc',11.111,1),(853,7538888,7538875,'nce',11.111,1),(853,7538889,7538880,'ide',12.5,1),(853,7538890,7538880,'den',12.5,1),(853,7538891,7538880,'ent',12.5,1),(853,7538892,7538880,'nti',12.5,1),(853,7538893,7538880,'tif',12.5,1),(853,7538894,7538880,'ifi',12.5,1),(853,7538895,7538880,'fie',12.5,1),(853,7538896,7538880,'ier',12.5,1),(853,7538897,7538889,'vdi',33.333,3),(853,7538898,7538889,'dis',33.333,3),(853,7538899,7538889,'isk',33.333,3),(853,7538900,7538897,'nam',50,1),(853,7538901,7538897,'ame',50,1),(853,7538902,7538900,'typ',50,1),(853,7538903,7538900,'ype',50,1),(853,7538904,7538902,'dir',25,1),(853,7538905,7538902,'ire',25,1),(853,7538906,7538902,'rec',25,1),(853,7538907,7538902,'ect',25,1),(854,7538909,7538908,'naa',100,2),(854,7538910,7538909,'600',3.333,3),(854,7538911,7538909,'000',3.333,3),(854,7538912,7538909,'00c',3.333,3),(854,7538913,7538909,'0c2',3.333,3),(854,7538914,7538909,'c29',3.333,3),(854,7538915,7538909,'29e',3.333,3),(854,7538916,7538909,'9e5',3.333,3),(854,7538917,7538909,'e54',3.333,3),(854,7538918,7538909,'54b',3.333,3),(854,7538919,7538909,'4b9',3.333,3),(854,7538920,7538909,'b95',3.333,3),(854,7538921,7538909,'950',3.333,3),(854,7538922,7538909,'508',3.333,3),(854,7538923,7538909,'08d',3.333,3),(854,7538924,7538909,'8d9',3.333,3),(854,7538925,7538909,'d93',3.333,3),(854,7538926,7538909,'939',3.333,3),(854,7538927,7538909,'390',3.333,3),(854,7538928,7538909,'905',3.333,3),(854,7538929,7538909,'052',3.333,3),(854,7538930,7538909,'521',3.333,3),(854,7538931,7538909,'219',3.333,3),(854,7538932,7538909,'19f',3.333,3),(854,7538933,7538909,'9fe',3.333,3),(854,7538934,7538909,'fe1',3.333,3),(854,7538935,7538909,'e17',3.333,3),(854,7538936,7538909,'171',3.333,3),(854,7538937,7538909,'710',3.333,3),(854,7538938,7538909,'10c',3.333,3),(854,7538939,7538909,'0c0',3.333,3),(854,7538940,7538910,'mon',100,1),(854,7538941,7538940,'201',50,1),(854,7538942,7538940,'013',50,1),(854,7538943,7538941,'adm',33.333,4),(854,7538944,7538941,'dmi',33.333,4),(854,7538945,7538941,'min',33.333,4),(854,7538946,7538943,'cap',16.667,1),(854,7538947,7538943,'apa',16.667,1),(854,7538948,7538943,'pac',16.667,1),(854,7538949,7538943,'aci',16.667,1),(854,7538950,7538943,'cit',16.667,1),(854,7538951,7538943,'ity',16.667,1),(854,7538952,7538946,'pat',50,1),(854,7538953,7538946,'ath',50,1),(854,7538954,7538952,'ten',100,1),(854,7538955,7538954,'fre',14.286,1),(854,7538956,7538954,'ree',14.286,1),(854,7538957,7538954,'ees',14.286,1),(854,7538958,7538954,'esp',14.286,1),(854,7538959,7538954,'spa',14.286,1),(854,7538960,7538954,'pac',14.286,1),(854,7538961,7538954,'ace',14.286,1),(854,7538962,7538955,'dis',50,1),(854,7538963,7538955,'isk',50,1),(854,7538964,7538962,'ind',33.333,1),(854,7538965,7538962,'nde',33.333,1),(854,7538966,7538962,'dex',33.333,1),(854,7538967,7538964,'adm',8.333,1),(854,7538968,7538964,'dmi',8.333,1),(854,7538969,7538964,'min',8.333,1),(854,7538970,7538964,'ini',8.333,1),(854,7538971,7538964,'nis',8.333,1),(854,7538972,7538964,'ist',8.333,1),(854,7538973,7538964,'str',8.333,1),(854,7538974,7538964,'tra',8.333,1),(854,7538975,7538964,'rat',8.333,1),(854,7538976,7538964,'ati',8.333,1),(854,7538977,7538964,'tio',8.333,1),(854,7538978,7538964,'ion',8.333,1),(854,7538979,7538967,'sta',33.333,3),(854,7538980,7538967,'tat',33.333,3),(854,7538981,7538967,'ate',33.333,3),(854,7538982,7538979,'dis',16.667,4),(854,7538983,7538979,'isa',16.667,4),(854,7538984,7538979,'sab',16.667,4),(854,7538985,7538979,'abl',16.667,4),(854,7538986,7538979,'ble',16.667,4),(854,7538987,7538979,'led',16.667,4),(854,7538988,7538982,'cac',33.333,1),(854,7538989,7538982,'ach',33.333,1),(854,7538990,7538982,'che',33.333,1),(854,7538991,7538988,'mod',50,1),(854,7538992,7538988,'ode',50,1),(854,7538993,7538991,'wri',14.286,1),(854,7538994,7538991,'rit',14.286,1),(854,7538995,7538991,'ite',14.286,1),(854,7538996,7538991,'tet',14.286,1),(854,7538997,7538991,'eth',14.286,1),(854,7538998,7538991,'thr',14.286,1),(854,7538999,7538991,'hru',14.286,1),(854,7539000,7538993,'ope',11.111,2),(854,7539001,7538993,'per',11.111,2),(854,7539002,7538993,'era',11.111,2),(854,7539003,7538993,'rat',11.111,2),(854,7539004,7538993,'ati',11.111,2),(854,7539005,7538993,'tio',11.111,2),(854,7539006,7538993,'ion',11.111,2),(854,7539007,7538993,'ona',11.111,2),(854,7539008,7538993,'nal',11.111,2),(854,7539009,7539000,'mes',20,1),(854,7539010,7539000,'ess',20,1),(854,7539011,7539000,'ssa',20,1),(854,7539012,7539000,'sag',20,1),(854,7539013,7539000,'age',20,1),(854,7539014,7539009,'per',11.111,1),(854,7539015,7539009,'erf',11.111,1),(854,7539016,7539009,'rfo',11.111,1),(854,7539017,7539009,'for',11.111,1),(854,7539018,7539009,'orm',11.111,1),(854,7539019,7539009,'rma',11.111,1),(854,7539020,7539009,'man',11.111,1),(854,7539021,7539009,'anc',11.111,1),(854,7539022,7539009,'nce',11.111,1),(854,7539023,7539014,'ide',12.5,1),(854,7539024,7539014,'den',12.5,1),(854,7539025,7539014,'ent',12.5,1),(854,7539026,7539014,'nti',12.5,1),(854,7539027,7539014,'tif',12.5,1),(854,7539028,7539014,'ifi',12.5,1),(854,7539029,7539014,'fie',12.5,1),(854,7539030,7539014,'ier',12.5,1),(854,7539031,7539023,'vdi',33.333,3),(854,7539032,7539023,'dis',33.333,3),(854,7539033,7539023,'isk',33.333,3),(854,7539034,7539031,'nam',50,1),(854,7539035,7539031,'ame',50,1),(854,7539036,7539034,'typ',50,1),(854,7539037,7539034,'ype',50,1),(854,7539038,7539036,'dir',25,1),(854,7539039,7539036,'ire',25,1),(854,7539040,7539036,'rec',25,1),(854,7539041,7539036,'ect',25,1),(855,7539043,7539042,'naa',100,2),(855,7539044,7539043,'600',3.333,3),(855,7539045,7539043,'000',3.333,3),(855,7539046,7539043,'00c',3.333,3),(855,7539047,7539043,'0c2',3.333,3),(855,7539048,7539043,'c29',3.333,3),(855,7539049,7539043,'29e',3.333,3),(855,7539050,7539043,'9e6',3.333,3),(855,7539051,7539043,'e6a',3.333,3),(855,7539052,7539043,'6ae',3.333,3),(855,7539053,7539043,'aee',3.333,3),(855,7539054,7539043,'ee1',3.333,3),(855,7539055,7539043,'e12',3.333,3),(855,7539056,7539043,'123',3.333,3),(855,7539057,7539043,'234',3.333,3),(855,7539058,7539043,'348',3.333,3),(855,7539059,7539043,'48d',3.333,3),(855,7539060,7539043,'8d2',3.333,3),(855,7539061,7539043,'d28',3.333,3),(855,7539062,7539043,'28d',3.333,3),(855,7539063,7539043,'8d3',3.333,3),(855,7539064,7539043,'d3f',3.333,3),(855,7539065,7539043,'3f0',3.333,3),(855,7539066,7539043,'f0c',3.333,3),(855,7539067,7539043,'0ce',3.333,3),(855,7539068,7539043,'cea',3.333,3),(855,7539069,7539043,'eaf',3.333,3),(855,7539070,7539043,'af3',3.333,3),(855,7539071,7539043,'f3f',3.333,3),(855,7539072,7539043,'3f5',3.333,3),(855,7539073,7539043,'f54',3.333,3),(855,7539074,7539044,'mon',100,1),(855,7539075,7539074,'201',50,1),(855,7539076,7539074,'013',50,1),(855,7539077,7539075,'adm',33.333,4),(855,7539078,7539075,'dmi',33.333,4),(855,7539079,7539075,'min',33.333,4),(855,7539080,7539077,'cap',16.667,1),(855,7539081,7539077,'apa',16.667,1),(855,7539082,7539077,'pac',16.667,1),(855,7539083,7539077,'aci',16.667,1),(855,7539084,7539077,'cit',16.667,1),(855,7539085,7539077,'ity',16.667,1),(855,7539086,7539080,'pat',50,1),(855,7539087,7539080,'ath',50,1),(855,7539088,7539086,'ele',25,1),(855,7539089,7539086,'lev',25,1),(855,7539090,7539086,'eve',25,1),(855,7539091,7539086,'ven',25,1),(855,7539092,7539088,'fre',14.286,1),(855,7539093,7539088,'ree',14.286,1),(855,7539094,7539088,'ees',14.286,1),(855,7539095,7539088,'esp',14.286,1),(855,7539096,7539088,'spa',14.286,1),(855,7539097,7539088,'pac',14.286,1),(855,7539098,7539088,'ace',14.286,1),(855,7539099,7539092,'dis',50,1),(855,7539100,7539092,'isk',50,1),(855,7539101,7539099,'ind',33.333,1),(855,7539102,7539099,'nde',33.333,1),(855,7539103,7539099,'dex',33.333,1),(855,7539104,7539101,'adm',8.333,1),(855,7539105,7539101,'dmi',8.333,1),(855,7539106,7539101,'min',8.333,1),(855,7539107,7539101,'ini',8.333,1),(855,7539108,7539101,'nis',8.333,1),(855,7539109,7539101,'ist',8.333,1),(855,7539110,7539101,'str',8.333,1),(855,7539111,7539101,'tra',8.333,1),(855,7539112,7539101,'rat',8.333,1),(855,7539113,7539101,'ati',8.333,1),(855,7539114,7539101,'tio',8.333,1),(855,7539115,7539101,'ion',8.333,1),(855,7539116,7539104,'sta',33.333,3),(855,7539117,7539104,'tat',33.333,3),(855,7539118,7539104,'ate',33.333,3),(855,7539119,7539116,'dis',16.667,4),(855,7539120,7539116,'isa',16.667,4),(855,7539121,7539116,'sab',16.667,4),(855,7539122,7539116,'abl',16.667,4),(855,7539123,7539116,'ble',16.667,4),(855,7539124,7539116,'led',16.667,4),(855,7539125,7539119,'cac',33.333,1),(855,7539126,7539119,'ach',33.333,1),(855,7539127,7539119,'che',33.333,1),(855,7539128,7539125,'mod',50,1),(855,7539129,7539125,'ode',50,1),(855,7539130,7539128,'wri',14.286,1),(855,7539131,7539128,'rit',14.286,1),(855,7539132,7539128,'ite',14.286,1),(855,7539133,7539128,'tet',14.286,1),(855,7539134,7539128,'eth',14.286,1),(855,7539135,7539128,'thr',14.286,1),(855,7539136,7539128,'hru',14.286,1),(855,7539137,7539130,'ope',11.111,2),(855,7539138,7539130,'per',11.111,2),(855,7539139,7539130,'era',11.111,2),(855,7539140,7539130,'rat',11.111,2),(855,7539141,7539130,'ati',11.111,2),(855,7539142,7539130,'tio',11.111,2),(855,7539143,7539130,'ion',11.111,2),(855,7539144,7539130,'ona',11.111,2),(855,7539145,7539130,'nal',11.111,2),(855,7539146,7539137,'mes',20,1),(855,7539147,7539137,'ess',20,1),(855,7539148,7539137,'ssa',20,1),(855,7539149,7539137,'sag',20,1),(855,7539150,7539137,'age',20,1),(855,7539151,7539146,'per',11.111,1),(855,7539152,7539146,'erf',11.111,1),(855,7539153,7539146,'rfo',11.111,1),(855,7539154,7539146,'for',11.111,1),(855,7539155,7539146,'orm',11.111,1),(855,7539156,7539146,'rma',11.111,1),(855,7539157,7539146,'man',11.111,1),(855,7539158,7539146,'anc',11.111,1),(855,7539159,7539146,'nce',11.111,1),(855,7539160,7539151,'ide',12.5,1),(855,7539161,7539151,'den',12.5,1),(855,7539162,7539151,'ent',12.5,1),(855,7539163,7539151,'nti',12.5,1),(855,7539164,7539151,'tif',12.5,1),(855,7539165,7539151,'ifi',12.5,1),(855,7539166,7539151,'fie',12.5,1),(855,7539167,7539151,'ier',12.5,1),(855,7539168,7539160,'vdi',33.333,3),(855,7539169,7539160,'dis',33.333,3),(855,7539170,7539160,'isk',33.333,3),(855,7539171,7539168,'nam',50,1),(855,7539172,7539168,'ame',50,1),(855,7539173,7539171,'typ',50,1),(855,7539174,7539171,'ype',50,1),(855,7539175,7539173,'dir',25,1),(855,7539176,7539173,'ire',25,1),(855,7539177,7539173,'rec',25,1),(855,7539178,7539173,'ect',25,1),(856,7539180,7539179,'naa',100,2),(856,7539181,7539180,'600',3.333,3),(856,7539182,7539180,'000',3.333,3),(856,7539183,7539180,'00c',3.333,3),(856,7539184,7539180,'0c2',3.333,3),(856,7539185,7539180,'c29',3.333,3),(856,7539186,7539180,'29f',3.333,3),(856,7539187,7539180,'9f4',3.333,3),(856,7539188,7539180,'f48',3.333,3),(856,7539189,7539180,'48c',3.333,3),(856,7539190,7539180,'8ca',3.333,3),(856,7539191,7539180,'ca9',3.333,3),(856,7539192,7539180,'a92',3.333,3),(856,7539193,7539180,'928',3.333,3),(856,7539194,7539180,'28d',3.333,3),(856,7539195,7539180,'8dc',3.333,3),(856,7539196,7539180,'dc5',3.333,3),(856,7539197,7539180,'c5a',3.333,3),(856,7539198,7539180,'5a8',3.333,3),(856,7539199,7539180,'a8e',3.333,3),(856,7539200,7539180,'8e5',3.333,3),(856,7539201,7539180,'e5f',3.333,3),(856,7539202,7539180,'5f2',3.333,3),(856,7539203,7539180,'f27',3.333,3),(856,7539204,7539180,'27b',3.333,3),(856,7539205,7539180,'7b5',3.333,3),(856,7539206,7539180,'b56',3.333,3),(856,7539207,7539180,'561',3.333,3),(856,7539208,7539180,'61c',3.333,3),(856,7539209,7539180,'1cb',3.333,3),(856,7539210,7539180,'cba',3.333,3),(856,7539211,7539181,'mon',100,1),(856,7539212,7539211,'201',50,1),(856,7539213,7539211,'013',50,1),(856,7539214,7539212,'adm',33.333,4),(856,7539215,7539212,'dmi',33.333,4),(856,7539216,7539212,'min',33.333,4),(856,7539217,7539214,'cap',16.667,1),(856,7539218,7539214,'apa',16.667,1),(856,7539219,7539214,'pac',16.667,1),(856,7539220,7539214,'aci',16.667,1),(856,7539221,7539214,'cit',16.667,1),(856,7539222,7539214,'ity',16.667,1),(856,7539223,7539217,'pat',50,1),(856,7539224,7539217,'ath',50,1),(856,7539225,7539223,'twe',25,1),(856,7539226,7539223,'wel',25,1),(856,7539227,7539223,'elv',25,1),(856,7539228,7539223,'lve',25,1),(856,7539229,7539225,'fre',14.286,1),(856,7539230,7539225,'ree',14.286,1),(856,7539231,7539225,'ees',14.286,1),(856,7539232,7539225,'esp',14.286,1),(856,7539233,7539225,'spa',14.286,1),(856,7539234,7539225,'pac',14.286,1),(856,7539235,7539225,'ace',14.286,1),(856,7539236,7539229,'dis',50,1),(856,7539237,7539229,'isk',50,1),(856,7539238,7539236,'ind',33.333,1),(856,7539239,7539236,'nde',33.333,1),(856,7539240,7539236,'dex',33.333,1),(856,7539241,7539238,'adm',8.333,1),(856,7539242,7539238,'dmi',8.333,1),(856,7539243,7539238,'min',8.333,1),(856,7539244,7539238,'ini',8.333,1),(856,7539245,7539238,'nis',8.333,1),(856,7539246,7539238,'ist',8.333,1),(856,7539247,7539238,'str',8.333,1),(856,7539248,7539238,'tra',8.333,1),(856,7539249,7539238,'rat',8.333,1),(856,7539250,7539238,'ati',8.333,1),(856,7539251,7539238,'tio',8.333,1),(856,7539252,7539238,'ion',8.333,1),(856,7539253,7539241,'sta',33.333,3),(856,7539254,7539241,'tat',33.333,3),(856,7539255,7539241,'ate',33.333,3),(856,7539256,7539253,'dis',16.667,4),(856,7539257,7539253,'isa',16.667,4),(856,7539258,7539253,'sab',16.667,4),(856,7539259,7539253,'abl',16.667,4),(856,7539260,7539253,'ble',16.667,4),(856,7539261,7539253,'led',16.667,4),(856,7539262,7539256,'cac',33.333,1),(856,7539263,7539256,'ach',33.333,1),(856,7539264,7539256,'che',33.333,1),(856,7539265,7539262,'mod',50,1),(856,7539266,7539262,'ode',50,1),(856,7539267,7539265,'wri',14.286,1),(856,7539268,7539265,'rit',14.286,1),(856,7539269,7539265,'ite',14.286,1),(856,7539270,7539265,'tet',14.286,1),(856,7539271,7539265,'eth',14.286,1),(856,7539272,7539265,'thr',14.286,1),(856,7539273,7539265,'hru',14.286,1),(856,7539274,7539267,'ope',11.111,2),(856,7539275,7539267,'per',11.111,2),(856,7539276,7539267,'era',11.111,2),(856,7539277,7539267,'rat',11.111,2),(856,7539278,7539267,'ati',11.111,2),(856,7539279,7539267,'tio',11.111,2),(856,7539280,7539267,'ion',11.111,2),(856,7539281,7539267,'ona',11.111,2),(856,7539282,7539267,'nal',11.111,2),(856,7539283,7539274,'mes',20,1),(856,7539284,7539274,'ess',20,1),(856,7539285,7539274,'ssa',20,1),(856,7539286,7539274,'sag',20,1),(856,7539287,7539274,'age',20,1),(856,7539288,7539283,'per',11.111,1),(856,7539289,7539283,'erf',11.111,1),(856,7539290,7539283,'rfo',11.111,1),(856,7539291,7539283,'for',11.111,1),(856,7539292,7539283,'orm',11.111,1),(856,7539293,7539283,'rma',11.111,1),(856,7539294,7539283,'man',11.111,1),(856,7539295,7539283,'anc',11.111,1),(856,7539296,7539283,'nce',11.111,1),(856,7539297,7539288,'ide',12.5,1),(856,7539298,7539288,'den',12.5,1),(856,7539299,7539288,'ent',12.5,1),(856,7539300,7539288,'nti',12.5,1),(856,7539301,7539288,'tif',12.5,1),(856,7539302,7539288,'ifi',12.5,1),(856,7539303,7539288,'fie',12.5,1),(856,7539304,7539288,'ier',12.5,1),(856,7539305,7539297,'vdi',33.333,3),(856,7539306,7539297,'dis',33.333,3),(856,7539307,7539297,'isk',33.333,3),(856,7539308,7539305,'nam',50,1),(856,7539309,7539305,'ame',50,1),(856,7539310,7539308,'typ',50,1),(856,7539311,7539308,'ype',50,1),(856,7539312,7539310,'dir',25,1),(856,7539313,7539310,'ire',25,1),(856,7539314,7539310,'rec',25,1),(856,7539315,7539310,'ect',25,1),(857,7539317,7539316,'naa',100,2),(857,7539318,7539317,'600',3.333,3),(857,7539319,7539317,'000',3.333,3),(857,7539320,7539317,'00c',3.333,3),(857,7539321,7539317,'0c2',3.333,3),(857,7539322,7539317,'c29',3.333,3),(857,7539323,7539317,'298',3.333,3),(857,7539324,7539317,'989',3.333,3),(857,7539325,7539317,'896',3.333,3),(857,7539326,7539317,'96b',3.333,3),(857,7539327,7539317,'6ba',3.333,3),(857,7539328,7539317,'ba2',3.333,3),(857,7539329,7539317,'a22',3.333,3),(857,7539330,7539317,'229',3.333,3),(857,7539331,7539317,'297',3.333,3),(857,7539332,7539317,'978',3.333,3),(857,7539333,7539317,'78c',3.333,3),(857,7539334,7539317,'8cb',3.333,3),(857,7539335,7539317,'cb4',3.333,3),(857,7539336,7539317,'b4f',3.333,3),(857,7539337,7539317,'4f3',3.333,3),(857,7539338,7539317,'f34',3.333,3),(857,7539339,7539317,'346',3.333,3),(857,7539340,7539317,'465',3.333,3),(857,7539341,7539317,'65f',3.333,3),(857,7539342,7539317,'5f9',3.333,3),(857,7539343,7539317,'f9d',3.333,3),(857,7539344,7539317,'9d5',3.333,3),(857,7539345,7539317,'d54',3.333,3),(857,7539346,7539317,'549',3.333,3),(857,7539347,7539317,'494',3.333,3),(857,7539348,7539318,'mon',100,1),(857,7539349,7539348,'201',50,1),(857,7539350,7539348,'013',50,1),(857,7539351,7539349,'adm',33.333,4),(857,7539352,7539349,'dmi',33.333,4),(857,7539353,7539349,'min',33.333,4),(857,7539354,7539351,'cap',16.667,1),(857,7539355,7539351,'apa',16.667,1),(857,7539356,7539351,'pac',16.667,1),(857,7539357,7539351,'aci',16.667,1),(857,7539358,7539351,'cit',16.667,1),(857,7539359,7539351,'ity',16.667,1),(857,7539360,7539354,'pat',50,1),(857,7539361,7539354,'ath',50,1),(857,7539362,7539360,'thi',16.667,1),(857,7539363,7539360,'hir',16.667,1),(857,7539364,7539360,'irt',16.667,1),(857,7539365,7539360,'rte',16.667,1),(857,7539366,7539360,'tee',16.667,1),(857,7539367,7539360,'een',16.667,1),(857,7539368,7539362,'fre',14.286,1),(857,7539369,7539362,'ree',14.286,1),(857,7539370,7539362,'ees',14.286,1),(857,7539371,7539362,'esp',14.286,1),(857,7539372,7539362,'spa',14.286,1),(857,7539373,7539362,'pac',14.286,1),(857,7539374,7539362,'ace',14.286,1),(857,7539375,7539368,'dis',50,1),(857,7539376,7539368,'isk',50,1),(857,7539377,7539375,'ind',33.333,1),(857,7539378,7539375,'nde',33.333,1),(857,7539379,7539375,'dex',33.333,1),(857,7539380,7539377,'adm',8.333,1),(857,7539381,7539377,'dmi',8.333,1),(857,7539382,7539377,'min',8.333,1),(857,7539383,7539377,'ini',8.333,1),(857,7539384,7539377,'nis',8.333,1),(857,7539385,7539377,'ist',8.333,1),(857,7539386,7539377,'str',8.333,1),(857,7539387,7539377,'tra',8.333,1),(857,7539388,7539377,'rat',8.333,1),(857,7539389,7539377,'ati',8.333,1),(857,7539390,7539377,'tio',8.333,1),(857,7539391,7539377,'ion',8.333,1),(857,7539392,7539380,'sta',33.333,3),(857,7539393,7539380,'tat',33.333,3),(857,7539394,7539380,'ate',33.333,3),(857,7539395,7539392,'dis',16.667,4),(857,7539396,7539392,'isa',16.667,4),(857,7539397,7539392,'sab',16.667,4),(857,7539398,7539392,'abl',16.667,4),(857,7539399,7539392,'ble',16.667,4),(857,7539400,7539392,'led',16.667,4),(857,7539401,7539395,'cac',33.333,1),(857,7539402,7539395,'ach',33.333,1),(857,7539403,7539395,'che',33.333,1),(857,7539404,7539401,'mod',50,1),(857,7539405,7539401,'ode',50,1),(857,7539406,7539404,'wri',14.286,1),(857,7539407,7539404,'rit',14.286,1),(857,7539408,7539404,'ite',14.286,1),(857,7539409,7539404,'tet',14.286,1),(857,7539410,7539404,'eth',14.286,1),(857,7539411,7539404,'thr',14.286,1),(857,7539412,7539404,'hru',14.286,1),(857,7539413,7539406,'ope',11.111,2),(857,7539414,7539406,'per',11.111,2),(857,7539415,7539406,'era',11.111,2),(857,7539416,7539406,'rat',11.111,2),(857,7539417,7539406,'ati',11.111,2),(857,7539418,7539406,'tio',11.111,2),(857,7539419,7539406,'ion',11.111,2),(857,7539420,7539406,'ona',11.111,2),(857,7539421,7539406,'nal',11.111,2),(857,7539422,7539413,'mes',20,1),(857,7539423,7539413,'ess',20,1),(857,7539424,7539413,'ssa',20,1),(857,7539425,7539413,'sag',20,1),(857,7539426,7539413,'age',20,1),(857,7539427,7539422,'per',11.111,1),(857,7539428,7539422,'erf',11.111,1),(857,7539429,7539422,'rfo',11.111,1),(857,7539430,7539422,'for',11.111,1),(857,7539431,7539422,'orm',11.111,1),(857,7539432,7539422,'rma',11.111,1),(857,7539433,7539422,'man',11.111,1),(857,7539434,7539422,'anc',11.111,1),(857,7539435,7539422,'nce',11.111,1),(857,7539436,7539427,'ide',12.5,1),(857,7539437,7539427,'den',12.5,1),(857,7539438,7539427,'ent',12.5,1),(857,7539439,7539427,'nti',12.5,1),(857,7539440,7539427,'tif',12.5,1),(857,7539441,7539427,'ifi',12.5,1),(857,7539442,7539427,'fie',12.5,1),(857,7539443,7539427,'ier',12.5,1),(857,7539444,7539436,'vdi',33.333,3),(857,7539445,7539436,'dis',33.333,3),(857,7539446,7539436,'isk',33.333,3),(857,7539447,7539444,'nam',50,1),(857,7539448,7539444,'ame',50,1),(857,7539449,7539447,'typ',50,1),(857,7539450,7539447,'ype',50,1),(857,7539451,7539449,'dir',25,1),(857,7539452,7539449,'ire',25,1),(857,7539453,7539449,'rec',25,1),(857,7539454,7539449,'ect',25,1),(858,7539456,7539455,'naa',100,2),(858,7539457,7539456,'600',3.333,3),(858,7539458,7539456,'000',3.333,3),(858,7539459,7539456,'00c',3.333,3),(858,7539460,7539456,'0c2',3.333,3),(858,7539461,7539456,'c29',3.333,3),(858,7539462,7539456,'294',3.333,3),(858,7539463,7539456,'94e',3.333,3),(858,7539464,7539456,'4ec',3.333,3),(858,7539465,7539456,'ec7',3.333,3),(858,7539466,7539456,'c75',3.333,3),(858,7539467,7539456,'75f',3.333,3),(858,7539468,7539456,'5f8',3.333,3),(858,7539469,7539456,'f8c',3.333,3),(858,7539470,7539456,'8cb',3.333,3),(858,7539471,7539456,'cb3',3.333,3),(858,7539472,7539456,'b3c',3.333,3),(858,7539473,7539456,'3c9',3.333,3),(858,7539474,7539456,'c94',3.333,3),(858,7539475,7539456,'94b',3.333,3),(858,7539476,7539456,'4bb',3.333,3),(858,7539477,7539456,'bb6',3.333,3),(858,7539478,7539456,'b69',3.333,3),(858,7539479,7539456,'69b',3.333,3),(858,7539480,7539456,'9b2',3.333,3),(858,7539481,7539456,'b24',3.333,3),(858,7539482,7539456,'247',3.333,3),(858,7539483,7539456,'471',3.333,3),(858,7539484,7539456,'717',3.333,3),(858,7539485,7539456,'177',3.333,3),(858,7539486,7539456,'779',3.333,3),(858,7539487,7539457,'mon',100,1),(858,7539488,7539487,'201',50,1),(858,7539489,7539487,'013',50,1),(858,7539490,7539488,'adm',33.333,4),(858,7539491,7539488,'dmi',33.333,4),(858,7539492,7539488,'min',33.333,4),(858,7539493,7539490,'cap',16.667,1),(858,7539494,7539490,'apa',16.667,1),(858,7539495,7539490,'pac',16.667,1),(858,7539496,7539490,'aci',16.667,1),(858,7539497,7539490,'cit',16.667,1),(858,7539498,7539490,'ity',16.667,1),(858,7539499,7539493,'pat',50,1),(858,7539500,7539493,'ath',50,1),(858,7539501,7539499,'fre',14.286,1),(858,7539502,7539499,'ree',14.286,1),(858,7539503,7539499,'ees',14.286,1),(858,7539504,7539499,'esp',14.286,1),(858,7539505,7539499,'spa',14.286,1),(858,7539506,7539499,'pac',14.286,1),(858,7539507,7539499,'ace',14.286,1),(858,7539508,7539501,'dis',50,1),(858,7539509,7539501,'isk',50,1),(858,7539510,7539508,'ind',33.333,1),(858,7539511,7539508,'nde',33.333,1),(858,7539512,7539508,'dex',33.333,1),(858,7539513,7539510,'adm',8.333,1),(858,7539514,7539510,'dmi',8.333,1),(858,7539515,7539510,'min',8.333,1),(858,7539516,7539510,'ini',8.333,1),(858,7539517,7539510,'nis',8.333,1),(858,7539518,7539510,'ist',8.333,1),(858,7539519,7539510,'str',8.333,1),(858,7539520,7539510,'tra',8.333,1),(858,7539521,7539510,'rat',8.333,1),(858,7539522,7539510,'ati',8.333,1),(858,7539523,7539510,'tio',8.333,1),(858,7539524,7539510,'ion',8.333,1),(858,7539525,7539513,'sta',33.333,3),(858,7539526,7539513,'tat',33.333,3),(858,7539527,7539513,'ate',33.333,3),(858,7539528,7539525,'dis',16.667,4),(858,7539529,7539525,'isa',16.667,4),(858,7539530,7539525,'sab',16.667,4),(858,7539531,7539525,'abl',16.667,4),(858,7539532,7539525,'ble',16.667,4),(858,7539533,7539525,'led',16.667,4),(858,7539534,7539528,'cac',33.333,1),(858,7539535,7539528,'ach',33.333,1),(858,7539536,7539528,'che',33.333,1),(858,7539537,7539534,'mod',50,1),(858,7539538,7539534,'ode',50,1),(858,7539539,7539537,'wri',14.286,1),(858,7539540,7539537,'rit',14.286,1),(858,7539541,7539537,'ite',14.286,1),(858,7539542,7539537,'tet',14.286,1),(858,7539543,7539537,'eth',14.286,1),(858,7539544,7539537,'thr',14.286,1),(858,7539545,7539537,'hru',14.286,1),(858,7539546,7539539,'ope',11.111,2),(858,7539547,7539539,'per',11.111,2),(858,7539548,7539539,'era',11.111,2),(858,7539549,7539539,'rat',11.111,2),(858,7539550,7539539,'ati',11.111,2),(858,7539551,7539539,'tio',11.111,2),(858,7539552,7539539,'ion',11.111,2),(858,7539553,7539539,'ona',11.111,2),(858,7539554,7539539,'nal',11.111,2),(858,7539555,7539546,'mes',20,1),(858,7539556,7539546,'ess',20,1),(858,7539557,7539546,'ssa',20,1),(858,7539558,7539546,'sag',20,1),(858,7539559,7539546,'age',20,1),(858,7539560,7539555,'per',11.111,1),(858,7539561,7539555,'erf',11.111,1),(858,7539562,7539555,'rfo',11.111,1),(858,7539563,7539555,'for',11.111,1),(858,7539564,7539555,'orm',11.111,1),(858,7539565,7539555,'rma',11.111,1),(858,7539566,7539555,'man',11.111,1),(858,7539567,7539555,'anc',11.111,1),(858,7539568,7539555,'nce',11.111,1),(858,7539569,7539560,'ide',12.5,1),(858,7539570,7539560,'den',12.5,1),(858,7539571,7539560,'ent',12.5,1),(858,7539572,7539560,'nti',12.5,1),(858,7539573,7539560,'tif',12.5,1),(858,7539574,7539560,'ifi',12.5,1),(858,7539575,7539560,'fie',12.5,1),(858,7539576,7539560,'ier',12.5,1),(858,7539577,7539569,'vdi',33.333,3),(858,7539578,7539569,'dis',33.333,3),(858,7539579,7539569,'isk',33.333,3),(858,7539580,7539577,'nam',50,1),(858,7539581,7539577,'ame',50,1),(858,7539582,7539580,'typ',50,1),(858,7539583,7539580,'ype',50,1),(858,7539584,7539582,'dir',25,1),(858,7539585,7539582,'ire',25,1),(858,7539586,7539582,'rec',25,1),(858,7539587,7539582,'ect',25,1),(859,7539589,7539588,'naa',100,2),(859,7539590,7539589,'600',3.333,3),(859,7539591,7539589,'000',3.333,3),(859,7539592,7539589,'00c',3.333,3),(859,7539593,7539589,'0c2',3.333,3),(859,7539594,7539589,'c29',3.333,3),(859,7539595,7539589,'29b',3.333,3),(859,7539596,7539589,'9bb',3.333,3),(859,7539597,7539589,'bbc',3.333,3),(859,7539598,7539589,'bca',3.333,3),(859,7539599,7539589,'ca0',3.333,3),(859,7539600,7539589,'a00',3.333,3),(859,7539601,7539589,'005',3.333,3),(859,7539602,7539589,'05f',3.333,3),(859,7539603,7539589,'5f5',3.333,3),(859,7539604,7539589,'f5c',3.333,3),(859,7539605,7539589,'5c3',3.333,3),(859,7539606,7539589,'c32',3.333,3),(859,7539607,7539589,'32a',3.333,3),(859,7539608,7539589,'2a0',3.333,3),(859,7539609,7539589,'a0e',3.333,3),(859,7539610,7539589,'0e3',3.333,3),(859,7539611,7539589,'e3b',3.333,3),(859,7539612,7539589,'3b7',3.333,3),(859,7539613,7539589,'b7c',3.333,3),(859,7539614,7539589,'7c8',3.333,3),(859,7539615,7539589,'c84',3.333,3),(859,7539616,7539589,'849',3.333,3),(859,7539617,7539589,'49f',3.333,3),(859,7539618,7539589,'9f4',3.333,3),(859,7539619,7539589,'f4f',3.333,3),(859,7539620,7539590,'mon',100,1),(859,7539621,7539620,'201',50,1),(859,7539622,7539620,'013',50,1),(859,7539623,7539621,'adm',33.333,4),(859,7539624,7539621,'dmi',33.333,4),(859,7539625,7539621,'min',33.333,4),(859,7539626,7539623,'cap',16.667,1),(859,7539627,7539623,'apa',16.667,1),(859,7539628,7539623,'pac',16.667,1),(859,7539629,7539623,'aci',16.667,1),(859,7539630,7539623,'cit',16.667,1),(859,7539631,7539623,'ity',16.667,1),(859,7539632,7539626,'pat',50,1),(859,7539633,7539626,'ath',50,1),(859,7539634,7539632,'fre',14.286,1),(859,7539635,7539632,'ree',14.286,1),(859,7539636,7539632,'ees',14.286,1),(859,7539637,7539632,'esp',14.286,1),(859,7539638,7539632,'spa',14.286,1),(859,7539639,7539632,'pac',14.286,1),(859,7539640,7539632,'ace',14.286,1),(859,7539641,7539634,'dis',50,1),(859,7539642,7539634,'isk',50,1),(859,7539643,7539641,'ind',33.333,1),(859,7539644,7539641,'nde',33.333,1),(859,7539645,7539641,'dex',33.333,1),(859,7539646,7539643,'adm',8.333,1),(859,7539647,7539643,'dmi',8.333,1),(859,7539648,7539643,'min',8.333,1),(859,7539649,7539643,'ini',8.333,1),(859,7539650,7539643,'nis',8.333,1),(859,7539651,7539643,'ist',8.333,1),(859,7539652,7539643,'str',8.333,1),(859,7539653,7539643,'tra',8.333,1),(859,7539654,7539643,'rat',8.333,1),(859,7539655,7539643,'ati',8.333,1),(859,7539656,7539643,'tio',8.333,1),(859,7539657,7539643,'ion',8.333,1),(859,7539658,7539646,'sta',33.333,3),(859,7539659,7539646,'tat',33.333,3),(859,7539660,7539646,'ate',33.333,3),(859,7539661,7539658,'dis',16.667,4),(859,7539662,7539658,'isa',16.667,4),(859,7539663,7539658,'sab',16.667,4),(859,7539664,7539658,'abl',16.667,4),(859,7539665,7539658,'ble',16.667,4),(859,7539666,7539658,'led',16.667,4),(859,7539667,7539661,'cac',33.333,1),(859,7539668,7539661,'ach',33.333,1),(859,7539669,7539661,'che',33.333,1),(859,7539670,7539667,'mod',50,1),(859,7539671,7539667,'ode',50,1),(859,7539672,7539670,'wri',14.286,1),(859,7539673,7539670,'rit',14.286,1),(859,7539674,7539670,'ite',14.286,1),(859,7539675,7539670,'tet',14.286,1),(859,7539676,7539670,'eth',14.286,1),(859,7539677,7539670,'thr',14.286,1),(859,7539678,7539670,'hru',14.286,1),(859,7539679,7539672,'ope',11.111,2),(859,7539680,7539672,'per',11.111,2),(859,7539681,7539672,'era',11.111,2),(859,7539682,7539672,'rat',11.111,2),(859,7539683,7539672,'ati',11.111,2),(859,7539684,7539672,'tio',11.111,2),(859,7539685,7539672,'ion',11.111,2),(859,7539686,7539672,'ona',11.111,2),(859,7539687,7539672,'nal',11.111,2),(859,7539688,7539679,'mes',20,1),(859,7539689,7539679,'ess',20,1),(859,7539690,7539679,'ssa',20,1),(859,7539691,7539679,'sag',20,1),(859,7539692,7539679,'age',20,1),(859,7539693,7539688,'per',11.111,1),(859,7539694,7539688,'erf',11.111,1),(859,7539695,7539688,'rfo',11.111,1),(859,7539696,7539688,'for',11.111,1),(859,7539697,7539688,'orm',11.111,1),(859,7539698,7539688,'rma',11.111,1),(859,7539699,7539688,'man',11.111,1),(859,7539700,7539688,'anc',11.111,1),(859,7539701,7539688,'nce',11.111,1),(859,7539702,7539693,'ide',12.5,1),(859,7539703,7539693,'den',12.5,1),(859,7539704,7539693,'ent',12.5,1),(859,7539705,7539693,'nti',12.5,1),(859,7539706,7539693,'tif',12.5,1),(859,7539707,7539693,'ifi',12.5,1),(859,7539708,7539693,'fie',12.5,1),(859,7539709,7539693,'ier',12.5,1),(859,7539710,7539702,'vdi',33.333,3),(859,7539711,7539702,'dis',33.333,3),(859,7539712,7539702,'isk',33.333,3),(859,7539713,7539710,'nam',50,1),(859,7539714,7539710,'ame',50,1),(859,7539715,7539713,'typ',50,1),(859,7539716,7539713,'ype',50,1),(859,7539717,7539715,'dir',25,1),(859,7539718,7539715,'ire',25,1),(859,7539719,7539715,'rec',25,1),(859,7539720,7539715,'ect',25,1),(860,7539722,7539721,'naa',100,2),(860,7539723,7539722,'600',3.333,3),(860,7539724,7539722,'000',3.333,3),(860,7539725,7539722,'00c',3.333,3),(860,7539726,7539722,'0c2',3.333,3),(860,7539727,7539722,'c29',3.333,3),(860,7539728,7539722,'29a',3.333,3),(860,7539729,7539722,'9aa',3.333,3),(860,7539730,7539722,'aaf',3.333,3),(860,7539731,7539722,'af5',3.333,3),(860,7539732,7539722,'f50',3.333,3),(860,7539733,7539722,'50b',3.333,3),(860,7539734,7539722,'0bb',3.333,3),(860,7539735,7539722,'bbb',3.333,3),(860,7539736,7539722,'bb5',3.333,3),(860,7539737,7539722,'b5a',3.333,3),(860,7539738,7539722,'5a2',3.333,3),(860,7539739,7539722,'a25',3.333,3),(860,7539740,7539722,'258',3.333,3),(860,7539741,7539722,'589',3.333,3),(860,7539742,7539722,'892',3.333,3),(860,7539743,7539722,'92e',3.333,3),(860,7539744,7539722,'2ef',3.333,3),(860,7539745,7539722,'efe',3.333,3),(860,7539746,7539722,'fe9',3.333,3),(860,7539747,7539722,'e93',3.333,3),(860,7539748,7539722,'936',3.333,3),(860,7539749,7539722,'369',3.333,3),(860,7539750,7539722,'697',3.333,3),(860,7539751,7539722,'976',3.333,3),(860,7539752,7539722,'76a',3.333,3),(860,7539753,7539723,'mon',100,1),(860,7539754,7539753,'201',50,1),(860,7539755,7539753,'013',50,1),(860,7539756,7539754,'adm',33.333,4),(860,7539757,7539754,'dmi',33.333,4),(860,7539758,7539754,'min',33.333,4),(860,7539759,7539756,'cap',16.667,1),(860,7539760,7539756,'apa',16.667,1),(860,7539761,7539756,'pac',16.667,1),(860,7539762,7539756,'aci',16.667,1),(860,7539763,7539756,'cit',16.667,1),(860,7539764,7539756,'ity',16.667,1),(860,7539765,7539759,'pat',50,1),(860,7539766,7539759,'ath',50,1),(860,7539767,7539765,'fre',14.286,1),(860,7539768,7539765,'ree',14.286,1),(860,7539769,7539765,'ees',14.286,1),(860,7539770,7539765,'esp',14.286,1),(860,7539771,7539765,'spa',14.286,1),(860,7539772,7539765,'pac',14.286,1),(860,7539773,7539765,'ace',14.286,1),(860,7539774,7539767,'dis',50,1),(860,7539775,7539767,'isk',50,1),(860,7539776,7539774,'ind',33.333,1),(860,7539777,7539774,'nde',33.333,1),(860,7539778,7539774,'dex',33.333,1),(860,7539779,7539776,'adm',8.333,1),(860,7539780,7539776,'dmi',8.333,1),(860,7539781,7539776,'min',8.333,1),(860,7539782,7539776,'ini',8.333,1),(860,7539783,7539776,'nis',8.333,1),(860,7539784,7539776,'ist',8.333,1),(860,7539785,7539776,'str',8.333,1),(860,7539786,7539776,'tra',8.333,1),(860,7539787,7539776,'rat',8.333,1),(860,7539788,7539776,'ati',8.333,1),(860,7539789,7539776,'tio',8.333,1),(860,7539790,7539776,'ion',8.333,1),(860,7539791,7539779,'sta',33.333,3),(860,7539792,7539779,'tat',33.333,3),(860,7539793,7539779,'ate',33.333,3),(860,7539794,7539791,'dis',16.667,4),(860,7539795,7539791,'isa',16.667,4),(860,7539796,7539791,'sab',16.667,4),(860,7539797,7539791,'abl',16.667,4),(860,7539798,7539791,'ble',16.667,4),(860,7539799,7539791,'led',16.667,4),(860,7539800,7539794,'cac',33.333,1),(860,7539801,7539794,'ach',33.333,1),(860,7539802,7539794,'che',33.333,1),(860,7539803,7539800,'mod',50,1),(860,7539804,7539800,'ode',50,1),(860,7539805,7539803,'wri',14.286,1),(860,7539806,7539803,'rit',14.286,1),(860,7539807,7539803,'ite',14.286,1),(860,7539808,7539803,'tet',14.286,1),(860,7539809,7539803,'eth',14.286,1),(860,7539810,7539803,'thr',14.286,1),(860,7539811,7539803,'hru',14.286,1),(860,7539812,7539805,'ope',11.111,2),(860,7539813,7539805,'per',11.111,2),(860,7539814,7539805,'era',11.111,2),(860,7539815,7539805,'rat',11.111,2),(860,7539816,7539805,'ati',11.111,2),(860,7539817,7539805,'tio',11.111,2),(860,7539818,7539805,'ion',11.111,2),(860,7539819,7539805,'ona',11.111,2),(860,7539820,7539805,'nal',11.111,2),(860,7539821,7539812,'mes',20,1),(860,7539822,7539812,'ess',20,1),(860,7539823,7539812,'ssa',20,1),(860,7539824,7539812,'sag',20,1),(860,7539825,7539812,'age',20,1),(860,7539826,7539821,'per',11.111,1),(860,7539827,7539821,'erf',11.111,1),(860,7539828,7539821,'rfo',11.111,1),(860,7539829,7539821,'for',11.111,1),(860,7539830,7539821,'orm',11.111,1),(860,7539831,7539821,'rma',11.111,1),(860,7539832,7539821,'man',11.111,1),(860,7539833,7539821,'anc',11.111,1),(860,7539834,7539821,'nce',11.111,1),(860,7539835,7539826,'ide',12.5,1),(860,7539836,7539826,'den',12.5,1),(860,7539837,7539826,'ent',12.5,1),(860,7539838,7539826,'nti',12.5,1),(860,7539839,7539826,'tif',12.5,1),(860,7539840,7539826,'ifi',12.5,1),(860,7539841,7539826,'fie',12.5,1),(860,7539842,7539826,'ier',12.5,1),(860,7539843,7539835,'vdi',33.333,3),(860,7539844,7539835,'dis',33.333,3),(860,7539845,7539835,'isk',33.333,3),(860,7539846,7539843,'nam',50,1),(860,7539847,7539843,'ame',50,1),(860,7539848,7539846,'typ',50,1),(860,7539849,7539846,'ype',50,1),(860,7539850,7539848,'dir',25,1),(860,7539851,7539848,'ire',25,1),(860,7539852,7539848,'rec',25,1),(860,7539853,7539848,'ect',25,1),(861,7539855,7539854,'naa',100,2),(861,7539856,7539855,'600',3.333,3),(861,7539857,7539855,'000',3.333,3),(861,7539858,7539855,'00c',3.333,3),(861,7539859,7539855,'0c2',3.333,3),(861,7539860,7539855,'c29',3.333,3),(861,7539861,7539855,'296',3.333,3),(861,7539862,7539855,'961',3.333,3),(861,7539863,7539855,'61b',3.333,3),(861,7539864,7539855,'1bf',3.333,3),(861,7539865,7539855,'bf5',3.333,3),(861,7539866,7539855,'f59',3.333,3),(861,7539867,7539855,'59b',3.333,3),(861,7539868,7539855,'9bb',3.333,3),(861,7539869,7539855,'bb3',3.333,3),(861,7539870,7539855,'b3b',3.333,3),(861,7539871,7539855,'3b1',3.333,3),(861,7539872,7539855,'b13',3.333,3),(861,7539873,7539855,'13d',3.333,3),(861,7539874,7539855,'3d3',3.333,3),(861,7539875,7539855,'d35',3.333,3),(861,7539876,7539855,'357',3.333,3),(861,7539877,7539855,'571',3.333,3),(861,7539878,7539855,'717',3.333,3),(861,7539879,7539855,'174',3.333,3),(861,7539880,7539855,'74d',3.333,3),(861,7539881,7539855,'4db',3.333,3),(861,7539882,7539855,'db4',3.333,3),(861,7539883,7539855,'b4a',3.333,3),(861,7539884,7539855,'4a4',3.333,3),(861,7539885,7539855,'a41',3.333,3),(861,7539886,7539856,'mon',100,1),(861,7539887,7539886,'201',50,1),(861,7539888,7539886,'013',50,1),(861,7539889,7539887,'adm',33.333,4),(861,7539890,7539887,'dmi',33.333,4),(861,7539891,7539887,'min',33.333,4),(861,7539892,7539889,'cap',16.667,1),(861,7539893,7539889,'apa',16.667,1),(861,7539894,7539889,'pac',16.667,1),(861,7539895,7539889,'aci',16.667,1),(861,7539896,7539889,'cit',16.667,1),(861,7539897,7539889,'ity',16.667,1),(861,7539898,7539892,'pat',50,1),(861,7539899,7539892,'ath',50,1),(861,7539900,7539898,'fre',14.286,1),(861,7539901,7539898,'ree',14.286,1),(861,7539902,7539898,'ees',14.286,1),(861,7539903,7539898,'esp',14.286,1),(861,7539904,7539898,'spa',14.286,1),(861,7539905,7539898,'pac',14.286,1),(861,7539906,7539898,'ace',14.286,1),(861,7539907,7539900,'dis',50,1),(861,7539908,7539900,'isk',50,1),(861,7539909,7539907,'ind',33.333,1),(861,7539910,7539907,'nde',33.333,1),(861,7539911,7539907,'dex',33.333,1),(861,7539912,7539909,'adm',8.333,1),(861,7539913,7539909,'dmi',8.333,1),(861,7539914,7539909,'min',8.333,1),(861,7539915,7539909,'ini',8.333,1),(861,7539916,7539909,'nis',8.333,1),(861,7539917,7539909,'ist',8.333,1),(861,7539918,7539909,'str',8.333,1),(861,7539919,7539909,'tra',8.333,1),(861,7539920,7539909,'rat',8.333,1),(861,7539921,7539909,'ati',8.333,1),(861,7539922,7539909,'tio',8.333,1),(861,7539923,7539909,'ion',8.333,1),(861,7539924,7539912,'sta',33.333,3),(861,7539925,7539912,'tat',33.333,3),(861,7539926,7539912,'ate',33.333,3),(861,7539927,7539924,'dis',16.667,4),(861,7539928,7539924,'isa',16.667,4),(861,7539929,7539924,'sab',16.667,4),(861,7539930,7539924,'abl',16.667,4),(861,7539931,7539924,'ble',16.667,4),(861,7539932,7539924,'led',16.667,4),(861,7539933,7539927,'cac',33.333,1),(861,7539934,7539927,'ach',33.333,1),(861,7539935,7539927,'che',33.333,1),(861,7539936,7539933,'mod',50,1),(861,7539937,7539933,'ode',50,1),(861,7539938,7539936,'wri',14.286,1),(861,7539939,7539936,'rit',14.286,1),(861,7539940,7539936,'ite',14.286,1),(861,7539941,7539936,'tet',14.286,1),(861,7539942,7539936,'eth',14.286,1),(861,7539943,7539936,'thr',14.286,1),(861,7539944,7539936,'hru',14.286,1),(861,7539945,7539938,'ope',11.111,2),(861,7539946,7539938,'per',11.111,2),(861,7539947,7539938,'era',11.111,2),(861,7539948,7539938,'rat',11.111,2),(861,7539949,7539938,'ati',11.111,2),(861,7539950,7539938,'tio',11.111,2),(861,7539951,7539938,'ion',11.111,2),(861,7539952,7539938,'ona',11.111,2),(861,7539953,7539938,'nal',11.111,2),(861,7539954,7539945,'mes',20,1),(861,7539955,7539945,'ess',20,1),(861,7539956,7539945,'ssa',20,1),(861,7539957,7539945,'sag',20,1),(861,7539958,7539945,'age',20,1),(861,7539959,7539954,'per',11.111,1),(861,7539960,7539954,'erf',11.111,1),(861,7539961,7539954,'rfo',11.111,1),(861,7539962,7539954,'for',11.111,1),(861,7539963,7539954,'orm',11.111,1),(861,7539964,7539954,'rma',11.111,1),(861,7539965,7539954,'man',11.111,1),(861,7539966,7539954,'anc',11.111,1),(861,7539967,7539954,'nce',11.111,1),(861,7539968,7539959,'ide',12.5,1),(861,7539969,7539959,'den',12.5,1),(861,7539970,7539959,'ent',12.5,1),(861,7539971,7539959,'nti',12.5,1),(861,7539972,7539959,'tif',12.5,1),(861,7539973,7539959,'ifi',12.5,1),(861,7539974,7539959,'fie',12.5,1),(861,7539975,7539959,'ier',12.5,1),(861,7539976,7539968,'vdi',33.333,3),(861,7539977,7539968,'dis',33.333,3),(861,7539978,7539968,'isk',33.333,3),(861,7539979,7539976,'nam',50,1),(861,7539980,7539976,'ame',50,1),(861,7539981,7539979,'typ',50,1),(861,7539982,7539979,'ype',50,1),(861,7539983,7539981,'dir',25,1),(861,7539984,7539981,'ire',25,1),(861,7539985,7539981,'rec',25,1),(861,7539986,7539981,'ect',25,1),(862,7539988,7539987,'naa',100,2),(862,7539989,7539988,'600',3.333,3),(862,7539990,7539988,'000',3.333,3),(862,7539991,7539988,'00c',3.333,3),(862,7539992,7539988,'0c2',3.333,3),(862,7539993,7539988,'c29',3.333,3),(862,7539994,7539988,'298',3.333,3),(862,7539995,7539988,'982',3.333,3),(862,7539996,7539988,'82b',3.333,3),(862,7539997,7539988,'2b8',3.333,3),(862,7539998,7539988,'b89',3.333,3),(862,7539999,7539988,'895',3.333,3),(862,7540000,7539988,'957',3.333,3),(862,7540001,7539988,'57b',3.333,3),(862,7540002,7539988,'7be',3.333,3),(862,7540003,7539988,'be5',3.333,3),(862,7540004,7539988,'e55',3.333,3),(862,7540005,7539988,'551',3.333,3),(862,7540006,7539988,'514',3.333,3),(862,7540007,7539988,'146',3.333,3),(862,7540008,7539988,'460',3.333,3),(862,7540009,7539988,'601',3.333,3),(862,7540010,7539988,'01f',3.333,3),(862,7540011,7539988,'1fd',3.333,3),(862,7540012,7539988,'fd8',3.333,3),(862,7540013,7539988,'d86',3.333,3),(862,7540014,7539988,'861',3.333,3),(862,7540015,7539988,'61b',3.333,3),(862,7540016,7539988,'1b7',3.333,3),(862,7540017,7539988,'b77',3.333,3),(862,7540018,7539988,'775',3.333,3),(862,7540019,7539989,'mon',100,1),(862,7540020,7540019,'201',50,1),(862,7540021,7540019,'013',50,1),(862,7540022,7540020,'adm',33.333,4),(862,7540023,7540020,'dmi',33.333,4),(862,7540024,7540020,'min',33.333,4),(862,7540025,7540022,'cap',16.667,1),(862,7540026,7540022,'apa',16.667,1),(862,7540027,7540022,'pac',16.667,1),(862,7540028,7540022,'aci',16.667,1),(862,7540029,7540022,'cit',16.667,1),(862,7540030,7540022,'ity',16.667,1),(862,7540031,7540025,'pat',50,1),(862,7540032,7540025,'ath',50,1),(862,7540033,7540031,'fre',14.286,1),(862,7540034,7540031,'ree',14.286,1),(862,7540035,7540031,'ees',14.286,1),(862,7540036,7540031,'esp',14.286,1),(862,7540037,7540031,'spa',14.286,1),(862,7540038,7540031,'pac',14.286,1),(862,7540039,7540031,'ace',14.286,1),(862,7540040,7540033,'dis',50,1),(862,7540041,7540033,'isk',50,1),(862,7540042,7540040,'ind',33.333,1),(862,7540043,7540040,'nde',33.333,1),(862,7540044,7540040,'dex',33.333,1),(862,7540045,7540042,'adm',8.333,1),(862,7540046,7540042,'dmi',8.333,1),(862,7540047,7540042,'min',8.333,1),(862,7540048,7540042,'ini',8.333,1),(862,7540049,7540042,'nis',8.333,1),(862,7540050,7540042,'ist',8.333,1),(862,7540051,7540042,'str',8.333,1),(862,7540052,7540042,'tra',8.333,1),(862,7540053,7540042,'rat',8.333,1),(862,7540054,7540042,'ati',8.333,1),(862,7540055,7540042,'tio',8.333,1),(862,7540056,7540042,'ion',8.333,1),(862,7540057,7540045,'sta',33.333,3),(862,7540058,7540045,'tat',33.333,3),(862,7540059,7540045,'ate',33.333,3),(862,7540060,7540057,'dis',16.667,4),(862,7540061,7540057,'isa',16.667,4),(862,7540062,7540057,'sab',16.667,4),(862,7540063,7540057,'abl',16.667,4),(862,7540064,7540057,'ble',16.667,4),(862,7540065,7540057,'led',16.667,4),(862,7540066,7540060,'cac',33.333,1),(862,7540067,7540060,'ach',33.333,1),(862,7540068,7540060,'che',33.333,1),(862,7540069,7540066,'mod',50,1),(862,7540070,7540066,'ode',50,1),(862,7540071,7540069,'wri',14.286,1),(862,7540072,7540069,'rit',14.286,1),(862,7540073,7540069,'ite',14.286,1),(862,7540074,7540069,'tet',14.286,1),(862,7540075,7540069,'eth',14.286,1),(862,7540076,7540069,'thr',14.286,1),(862,7540077,7540069,'hru',14.286,1),(862,7540078,7540071,'ope',11.111,2),(862,7540079,7540071,'per',11.111,2),(862,7540080,7540071,'era',11.111,2),(862,7540081,7540071,'rat',11.111,2),(862,7540082,7540071,'ati',11.111,2),(862,7540083,7540071,'tio',11.111,2),(862,7540084,7540071,'ion',11.111,2),(862,7540085,7540071,'ona',11.111,2),(862,7540086,7540071,'nal',11.111,2),(862,7540087,7540078,'mes',20,1),(862,7540088,7540078,'ess',20,1),(862,7540089,7540078,'ssa',20,1),(862,7540090,7540078,'sag',20,1),(862,7540091,7540078,'age',20,1),(862,7540092,7540087,'per',11.111,1),(862,7540093,7540087,'erf',11.111,1),(862,7540094,7540087,'rfo',11.111,1),(862,7540095,7540087,'for',11.111,1),(862,7540096,7540087,'orm',11.111,1),(862,7540097,7540087,'rma',11.111,1),(862,7540098,7540087,'man',11.111,1),(862,7540099,7540087,'anc',11.111,1),(862,7540100,7540087,'nce',11.111,1),(862,7540101,7540092,'ide',12.5,1),(862,7540102,7540092,'den',12.5,1),(862,7540103,7540092,'ent',12.5,1),(862,7540104,7540092,'nti',12.5,1),(862,7540105,7540092,'tif',12.5,1),(862,7540106,7540092,'ifi',12.5,1),(862,7540107,7540092,'fie',12.5,1),(862,7540108,7540092,'ier',12.5,1),(862,7540109,7540101,'vdi',33.333,3),(862,7540110,7540101,'dis',33.333,3),(862,7540111,7540101,'isk',33.333,3),(862,7540112,7540109,'nam',50,1),(862,7540113,7540109,'ame',50,1),(862,7540114,7540112,'typ',50,1),(862,7540115,7540112,'ype',50,1),(862,7540116,7540114,'dir',25,1),(862,7540117,7540114,'ire',25,1),(862,7540118,7540114,'rec',25,1),(862,7540119,7540114,'ect',25,1),(863,7540121,7540120,'naa',100,2),(863,7540122,7540121,'600',3.333,3),(863,7540123,7540121,'000',3.333,3),(863,7540124,7540121,'00c',3.333,3),(863,7540125,7540121,'0c2',3.333,3),(863,7540126,7540121,'c29',3.333,3),(863,7540127,7540121,'293',3.333,3),(863,7540128,7540121,'930',3.333,3),(863,7540129,7540121,'300',3.333,3),(863,7540130,7540121,'007',3.333,3),(863,7540131,7540121,'077',3.333,3),(863,7540132,7540121,'77f',3.333,3),(863,7540133,7540121,'7f3',3.333,3),(863,7540134,7540121,'f3b',3.333,3),(863,7540135,7540121,'3ba',3.333,3),(863,7540136,7540121,'ba9',3.333,3),(863,7540137,7540121,'a9a',3.333,3),(863,7540138,7540121,'9ab',3.333,3),(863,7540139,7540121,'ab2',3.333,3),(863,7540140,7540121,'b21',3.333,3),(863,7540141,7540121,'213',3.333,3),(863,7540142,7540121,'134',3.333,3),(863,7540143,7540121,'34f',3.333,3),(863,7540144,7540121,'4fa',3.333,3),(863,7540145,7540121,'fa8',3.333,3),(863,7540146,7540121,'a8c',3.333,3),(863,7540147,7540121,'8cc',3.333,3),(863,7540148,7540121,'cc4',3.333,3),(863,7540149,7540121,'c46',3.333,3),(863,7540150,7540121,'462',3.333,3),(863,7540151,7540121,'624',3.333,3),(863,7540152,7540122,'mon',100,1),(863,7540153,7540152,'201',50,1),(863,7540154,7540152,'013',50,1),(863,7540155,7540153,'adm',33.333,4),(863,7540156,7540153,'dmi',33.333,4),(863,7540157,7540153,'min',33.333,4),(863,7540158,7540155,'cap',16.667,1),(863,7540159,7540155,'apa',16.667,1),(863,7540160,7540155,'pac',16.667,1),(863,7540161,7540155,'aci',16.667,1),(863,7540162,7540155,'cit',16.667,1),(863,7540163,7540155,'ity',16.667,1),(863,7540164,7540158,'pat',50,1),(863,7540165,7540158,'ath',50,1),(863,7540166,7540164,'fre',14.286,1),(863,7540167,7540164,'ree',14.286,1),(863,7540168,7540164,'ees',14.286,1),(863,7540169,7540164,'esp',14.286,1),(863,7540170,7540164,'spa',14.286,1),(863,7540171,7540164,'pac',14.286,1),(863,7540172,7540164,'ace',14.286,1),(863,7540173,7540166,'dis',50,1),(863,7540174,7540166,'isk',50,1),(863,7540175,7540173,'ind',33.333,1),(863,7540176,7540173,'nde',33.333,1),(863,7540177,7540173,'dex',33.333,1),(863,7540178,7540175,'adm',8.333,1),(863,7540179,7540175,'dmi',8.333,1),(863,7540180,7540175,'min',8.333,1),(863,7540181,7540175,'ini',8.333,1),(863,7540182,7540175,'nis',8.333,1),(863,7540183,7540175,'ist',8.333,1),(863,7540184,7540175,'str',8.333,1),(863,7540185,7540175,'tra',8.333,1),(863,7540186,7540175,'rat',8.333,1),(863,7540187,7540175,'ati',8.333,1),(863,7540188,7540175,'tio',8.333,1),(863,7540189,7540175,'ion',8.333,1),(863,7540190,7540178,'sta',33.333,3),(863,7540191,7540178,'tat',33.333,3),(863,7540192,7540178,'ate',33.333,3),(863,7540193,7540190,'dis',16.667,4),(863,7540194,7540190,'isa',16.667,4),(863,7540195,7540190,'sab',16.667,4),(863,7540196,7540190,'abl',16.667,4),(863,7540197,7540190,'ble',16.667,4),(863,7540198,7540190,'led',16.667,4),(863,7540199,7540193,'cac',33.333,1),(863,7540200,7540193,'ach',33.333,1),(863,7540201,7540193,'che',33.333,1),(863,7540202,7540199,'mod',50,1),(863,7540203,7540199,'ode',50,1),(863,7540204,7540202,'wri',14.286,1),(863,7540205,7540202,'rit',14.286,1),(863,7540206,7540202,'ite',14.286,1),(863,7540207,7540202,'tet',14.286,1),(863,7540208,7540202,'eth',14.286,1),(863,7540209,7540202,'thr',14.286,1),(863,7540210,7540202,'hru',14.286,1),(863,7540211,7540204,'ope',11.111,2),(863,7540212,7540204,'per',11.111,2),(863,7540213,7540204,'era',11.111,2),(863,7540214,7540204,'rat',11.111,2),(863,7540215,7540204,'ati',11.111,2),(863,7540216,7540204,'tio',11.111,2),(863,7540217,7540204,'ion',11.111,2),(863,7540218,7540204,'ona',11.111,2),(863,7540219,7540204,'nal',11.111,2),(863,7540220,7540211,'mes',20,1),(863,7540221,7540211,'ess',20,1),(863,7540222,7540211,'ssa',20,1),(863,7540223,7540211,'sag',20,1),(863,7540224,7540211,'age',20,1),(863,7540225,7540220,'per',11.111,1),(863,7540226,7540220,'erf',11.111,1),(863,7540227,7540220,'rfo',11.111,1),(863,7540228,7540220,'for',11.111,1),(863,7540229,7540220,'orm',11.111,1),(863,7540230,7540220,'rma',11.111,1),(863,7540231,7540220,'man',11.111,1),(863,7540232,7540220,'anc',11.111,1),(863,7540233,7540220,'nce',11.111,1),(863,7540234,7540225,'ide',12.5,1),(863,7540235,7540225,'den',12.5,1),(863,7540236,7540225,'ent',12.5,1),(863,7540237,7540225,'nti',12.5,1),(863,7540238,7540225,'tif',12.5,1),(863,7540239,7540225,'ifi',12.5,1),(863,7540240,7540225,'fie',12.5,1),(863,7540241,7540225,'ier',12.5,1),(863,7540242,7540234,'vdi',33.333,3),(863,7540243,7540234,'dis',33.333,3),(863,7540244,7540234,'isk',33.333,3),(863,7540245,7540242,'nam',50,1),(863,7540246,7540242,'ame',50,1),(863,7540247,7540245,'typ',50,1),(863,7540248,7540245,'ype',50,1),(863,7540249,7540247,'dir',25,1),(863,7540250,7540247,'ire',25,1),(863,7540251,7540247,'rec',25,1),(863,7540252,7540247,'ect',25,1),(864,7540254,7540253,'naa',100,2),(864,7540255,7540254,'600',3.333,3),(864,7540256,7540254,'000',3.333,3),(864,7540257,7540254,'00c',3.333,3),(864,7540258,7540254,'0c2',3.333,3),(864,7540259,7540254,'c29',3.333,3),(864,7540260,7540254,'29b',3.333,3),(864,7540261,7540254,'9b5',3.333,3),(864,7540262,7540254,'b57',3.333,3),(864,7540263,7540254,'57a',3.333,3),(864,7540264,7540254,'7ad',3.333,3),(864,7540265,7540254,'ad7',3.333,3),(864,7540266,7540254,'d76',3.333,3),(864,7540267,7540254,'763',3.333,3),(864,7540268,7540254,'639',3.333,3),(864,7540269,7540254,'397',3.333,3),(864,7540270,7540254,'97d',3.333,3),(864,7540271,7540254,'7d0',3.333,3),(864,7540272,7540254,'d0f',3.333,3),(864,7540273,7540254,'0f4',3.333,3),(864,7540274,7540254,'f4d',3.333,3),(864,7540275,7540254,'4df',3.333,3),(864,7540276,7540254,'df3',3.333,3),(864,7540277,7540254,'f38',3.333,3),(864,7540278,7540254,'38d',3.333,3),(864,7540279,7540254,'8d6',3.333,3),(864,7540280,7540254,'d63',3.333,3),(864,7540281,7540254,'638',3.333,3),(864,7540282,7540254,'381',3.333,3),(864,7540283,7540254,'81f',3.333,3),(864,7540284,7540254,'1ff',3.333,3),(864,7540285,7540255,'mon',100,1),(864,7540286,7540285,'201',50,1),(864,7540287,7540285,'013',50,1),(864,7540288,7540286,'adm',33.333,4),(864,7540289,7540286,'dmi',33.333,4),(864,7540290,7540286,'min',33.333,4),(864,7540291,7540288,'cap',16.667,1),(864,7540292,7540288,'apa',16.667,1),(864,7540293,7540288,'pac',16.667,1),(864,7540294,7540288,'aci',16.667,1),(864,7540295,7540288,'cit',16.667,1),(864,7540296,7540288,'ity',16.667,1),(864,7540297,7540291,'pat',50,1),(864,7540298,7540291,'ath',50,1),(864,7540299,7540297,'fre',14.286,1),(864,7540300,7540297,'ree',14.286,1),(864,7540301,7540297,'ees',14.286,1),(864,7540302,7540297,'esp',14.286,1),(864,7540303,7540297,'spa',14.286,1),(864,7540304,7540297,'pac',14.286,1),(864,7540305,7540297,'ace',14.286,1),(864,7540306,7540299,'dis',50,1),(864,7540307,7540299,'isk',50,1),(864,7540308,7540306,'ind',33.333,1),(864,7540309,7540306,'nde',33.333,1),(864,7540310,7540306,'dex',33.333,1),(864,7540311,7540308,'adm',8.333,1),(864,7540312,7540308,'dmi',8.333,1),(864,7540313,7540308,'min',8.333,1),(864,7540314,7540308,'ini',8.333,1),(864,7540315,7540308,'nis',8.333,1),(864,7540316,7540308,'ist',8.333,1),(864,7540317,7540308,'str',8.333,1),(864,7540318,7540308,'tra',8.333,1),(864,7540319,7540308,'rat',8.333,1),(864,7540320,7540308,'ati',8.333,1),(864,7540321,7540308,'tio',8.333,1),(864,7540322,7540308,'ion',8.333,1),(864,7540323,7540311,'sta',33.333,3),(864,7540324,7540311,'tat',33.333,3),(864,7540325,7540311,'ate',33.333,3),(864,7540326,7540323,'dis',16.667,4),(864,7540327,7540323,'isa',16.667,4),(864,7540328,7540323,'sab',16.667,4),(864,7540329,7540323,'abl',16.667,4),(864,7540330,7540323,'ble',16.667,4),(864,7540331,7540323,'led',16.667,4),(864,7540332,7540326,'cac',33.333,1),(864,7540333,7540326,'ach',33.333,1),(864,7540334,7540326,'che',33.333,1),(864,7540335,7540332,'mod',50,1),(864,7540336,7540332,'ode',50,1),(864,7540337,7540335,'wri',14.286,1),(864,7540338,7540335,'rit',14.286,1),(864,7540339,7540335,'ite',14.286,1),(864,7540340,7540335,'tet',14.286,1),(864,7540341,7540335,'eth',14.286,1),(864,7540342,7540335,'thr',14.286,1),(864,7540343,7540335,'hru',14.286,1),(864,7540344,7540337,'ope',11.111,2),(864,7540345,7540337,'per',11.111,2),(864,7540346,7540337,'era',11.111,2),(864,7540347,7540337,'rat',11.111,2),(864,7540348,7540337,'ati',11.111,2),(864,7540349,7540337,'tio',11.111,2),(864,7540350,7540337,'ion',11.111,2),(864,7540351,7540337,'ona',11.111,2),(864,7540352,7540337,'nal',11.111,2),(864,7540353,7540344,'mes',20,1),(864,7540354,7540344,'ess',20,1),(864,7540355,7540344,'ssa',20,1),(864,7540356,7540344,'sag',20,1),(864,7540357,7540344,'age',20,1),(864,7540358,7540353,'per',11.111,1),(864,7540359,7540353,'erf',11.111,1),(864,7540360,7540353,'rfo',11.111,1),(864,7540361,7540353,'for',11.111,1),(864,7540362,7540353,'orm',11.111,1),(864,7540363,7540353,'rma',11.111,1),(864,7540364,7540353,'man',11.111,1),(864,7540365,7540353,'anc',11.111,1),(864,7540366,7540353,'nce',11.111,1),(864,7540367,7540358,'ide',12.5,1),(864,7540368,7540358,'den',12.5,1),(864,7540369,7540358,'ent',12.5,1),(864,7540370,7540358,'nti',12.5,1),(864,7540371,7540358,'tif',12.5,1),(864,7540372,7540358,'ifi',12.5,1),(864,7540373,7540358,'fie',12.5,1),(864,7540374,7540358,'ier',12.5,1),(864,7540375,7540367,'vdi',33.333,3),(864,7540376,7540367,'dis',33.333,3),(864,7540377,7540367,'isk',33.333,3),(864,7540378,7540375,'nam',50,1),(864,7540379,7540375,'ame',50,1),(864,7540380,7540378,'typ',50,1),(864,7540381,7540378,'ype',50,1),(864,7540382,7540380,'dir',25,1),(864,7540383,7540380,'ire',25,1),(864,7540384,7540380,'rec',25,1),(864,7540385,7540380,'ect',25,1),(865,7540387,7540386,'naa',100,2),(865,7540388,7540387,'600',3.333,3),(865,7540389,7540387,'000',3.333,3),(865,7540390,7540387,'00c',3.333,3),(865,7540391,7540387,'0c2',3.333,3),(865,7540392,7540387,'c29',3.333,3),(865,7540393,7540387,'298',3.333,3),(865,7540394,7540387,'981',3.333,3),(865,7540395,7540387,'812',3.333,3),(865,7540396,7540387,'12a',3.333,3),(865,7540397,7540387,'2a2',3.333,3),(865,7540398,7540387,'a2a',3.333,3),(865,7540399,7540387,'2ae',3.333,3),(865,7540400,7540387,'aed',3.333,3),(865,7540401,7540387,'ed3',3.333,3),(865,7540402,7540387,'d38',3.333,3),(865,7540403,7540387,'38a',3.333,3),(865,7540404,7540387,'8ae',3.333,3),(865,7540405,7540387,'aef',3.333,3),(865,7540406,7540387,'ef1',3.333,3),(865,7540407,7540387,'f11',3.333,3),(865,7540408,7540387,'118',3.333,3),(865,7540409,7540387,'18c',3.333,3),(865,7540410,7540387,'8c4',3.333,3),(865,7540411,7540387,'c4d',3.333,3),(865,7540412,7540387,'4dc',3.333,3),(865,7540413,7540387,'dcf',3.333,3),(865,7540414,7540387,'cf9',3.333,3),(865,7540415,7540387,'f94',3.333,3),(865,7540416,7540387,'944',3.333,3),(865,7540417,7540387,'44a',3.333,3),(865,7540418,7540388,'mon',100,1),(865,7540419,7540418,'201',50,1),(865,7540420,7540418,'013',50,1),(865,7540421,7540419,'adm',33.333,4),(865,7540422,7540419,'dmi',33.333,4),(865,7540423,7540419,'min',33.333,4),(865,7540424,7540421,'cap',16.667,1),(865,7540425,7540421,'apa',16.667,1),(865,7540426,7540421,'pac',16.667,1),(865,7540427,7540421,'aci',16.667,1),(865,7540428,7540421,'cit',16.667,1),(865,7540429,7540421,'ity',16.667,1),(865,7540430,7540424,'pat',50,1),(865,7540431,7540424,'ath',50,1),(865,7540432,7540430,'fre',14.286,1),(865,7540433,7540430,'ree',14.286,1),(865,7540434,7540430,'ees',14.286,1),(865,7540435,7540430,'esp',14.286,1),(865,7540436,7540430,'spa',14.286,1),(865,7540437,7540430,'pac',14.286,1),(865,7540438,7540430,'ace',14.286,1),(865,7540439,7540432,'dis',50,1),(865,7540440,7540432,'isk',50,1),(865,7540441,7540439,'ind',33.333,1),(865,7540442,7540439,'nde',33.333,1),(865,7540443,7540439,'dex',33.333,1),(865,7540444,7540441,'adm',8.333,1),(865,7540445,7540441,'dmi',8.333,1),(865,7540446,7540441,'min',8.333,1),(865,7540447,7540441,'ini',8.333,1),(865,7540448,7540441,'nis',8.333,1),(865,7540449,7540441,'ist',8.333,1),(865,7540450,7540441,'str',8.333,1),(865,7540451,7540441,'tra',8.333,1),(865,7540452,7540441,'rat',8.333,1),(865,7540453,7540441,'ati',8.333,1),(865,7540454,7540441,'tio',8.333,1),(865,7540455,7540441,'ion',8.333,1),(865,7540456,7540444,'sta',33.333,3),(865,7540457,7540444,'tat',33.333,3),(865,7540458,7540444,'ate',33.333,3),(865,7540459,7540456,'dis',16.667,4),(865,7540460,7540456,'isa',16.667,4),(865,7540461,7540456,'sab',16.667,4),(865,7540462,7540456,'abl',16.667,4),(865,7540463,7540456,'ble',16.667,4),(865,7540464,7540456,'led',16.667,4),(865,7540465,7540459,'cac',33.333,1),(865,7540466,7540459,'ach',33.333,1),(865,7540467,7540459,'che',33.333,1),(865,7540468,7540465,'mod',50,1),(865,7540469,7540465,'ode',50,1),(865,7540470,7540468,'wri',14.286,1),(865,7540471,7540468,'rit',14.286,1),(865,7540472,7540468,'ite',14.286,1),(865,7540473,7540468,'tet',14.286,1),(865,7540474,7540468,'eth',14.286,1),(865,7540475,7540468,'thr',14.286,1),(865,7540476,7540468,'hru',14.286,1),(865,7540477,7540470,'ope',11.111,2),(865,7540478,7540470,'per',11.111,2),(865,7540479,7540470,'era',11.111,2),(865,7540480,7540470,'rat',11.111,2),(865,7540481,7540470,'ati',11.111,2),(865,7540482,7540470,'tio',11.111,2),(865,7540483,7540470,'ion',11.111,2),(865,7540484,7540470,'ona',11.111,2),(865,7540485,7540470,'nal',11.111,2),(865,7540486,7540477,'mes',20,1),(865,7540487,7540477,'ess',20,1),(865,7540488,7540477,'ssa',20,1),(865,7540489,7540477,'sag',20,1),(865,7540490,7540477,'age',20,1),(865,7540491,7540486,'per',11.111,1),(865,7540492,7540486,'erf',11.111,1),(865,7540493,7540486,'rfo',11.111,1),(865,7540494,7540486,'for',11.111,1),(865,7540495,7540486,'orm',11.111,1),(865,7540496,7540486,'rma',11.111,1),(865,7540497,7540486,'man',11.111,1),(865,7540498,7540486,'anc',11.111,1),(865,7540499,7540486,'nce',11.111,1),(865,7540500,7540491,'ide',12.5,1),(865,7540501,7540491,'den',12.5,1),(865,7540502,7540491,'ent',12.5,1),(865,7540503,7540491,'nti',12.5,1),(865,7540504,7540491,'tif',12.5,1),(865,7540505,7540491,'ifi',12.5,1),(865,7540506,7540491,'fie',12.5,1),(865,7540507,7540491,'ier',12.5,1),(865,7540508,7540500,'vdi',33.333,3),(865,7540509,7540500,'dis',33.333,3),(865,7540510,7540500,'isk',33.333,3),(865,7540511,7540508,'nam',50,1),(865,7540512,7540508,'ame',50,1),(865,7540513,7540511,'typ',50,1),(865,7540514,7540511,'ype',50,1),(865,7540515,7540513,'dir',25,1),(865,7540516,7540513,'ire',25,1),(865,7540517,7540513,'rec',25,1),(865,7540518,7540513,'ect',25,1),(866,7540520,7540519,'naa',100,2),(866,7540521,7540520,'600',3.333,3),(866,7540522,7540520,'000',3.333,3),(866,7540523,7540520,'00c',3.333,3),(866,7540524,7540520,'0c2',3.333,3),(866,7540525,7540520,'c29',3.333,3),(866,7540526,7540520,'29d',3.333,3),(866,7540527,7540520,'9d8',3.333,3),(866,7540528,7540520,'d88',3.333,3),(866,7540529,7540520,'880',3.333,3),(866,7540530,7540520,'80c',3.333,3),(866,7540531,7540520,'0c9',3.333,3),(866,7540532,7540520,'c9b',3.333,3),(866,7540533,7540520,'9b7',3.333,3),(866,7540534,7540520,'b78',3.333,3),(866,7540535,7540520,'78d',3.333,3),(866,7540536,7540520,'8d3',3.333,3),(866,7540537,7540520,'d30',3.333,3),(866,7540538,7540520,'301',3.333,3),(866,7540539,7540520,'018',3.333,3),(866,7540540,7540520,'189',3.333,3),(866,7540541,7540520,'89e',3.333,3),(866,7540542,7540520,'9e6',3.333,3),(866,7540543,7540520,'e62',3.333,3),(866,7540544,7540520,'623',3.333,3),(866,7540545,7540520,'238',3.333,3),(866,7540546,7540520,'38c',3.333,3),(866,7540547,7540520,'8c3',3.333,3),(866,7540548,7540520,'c36',3.333,3),(866,7540549,7540520,'367',3.333,3),(866,7540550,7540520,'670',3.333,3),(866,7540551,7540521,'mon',100,1),(866,7540552,7540551,'201',50,1),(866,7540553,7540551,'013',50,1),(866,7540554,7540552,'adm',33.333,4),(866,7540555,7540552,'dmi',33.333,4),(866,7540556,7540552,'min',33.333,4),(866,7540557,7540554,'cap',16.667,1),(866,7540558,7540554,'apa',16.667,1),(866,7540559,7540554,'pac',16.667,1),(866,7540560,7540554,'aci',16.667,1),(866,7540561,7540554,'cit',16.667,1),(866,7540562,7540554,'ity',16.667,1),(866,7540563,7540557,'pat',50,1),(866,7540564,7540557,'ath',50,1),(866,7540565,7540563,'fre',14.286,1),(866,7540566,7540563,'ree',14.286,1),(866,7540567,7540563,'ees',14.286,1),(866,7540568,7540563,'esp',14.286,1),(866,7540569,7540563,'spa',14.286,1),(866,7540570,7540563,'pac',14.286,1),(866,7540571,7540563,'ace',14.286,1),(866,7540572,7540565,'dis',50,1),(866,7540573,7540565,'isk',50,1),(866,7540574,7540572,'ind',33.333,1),(866,7540575,7540572,'nde',33.333,1),(866,7540576,7540572,'dex',33.333,1),(866,7540577,7540574,'adm',8.333,1),(866,7540578,7540574,'dmi',8.333,1),(866,7540579,7540574,'min',8.333,1),(866,7540580,7540574,'ini',8.333,1),(866,7540581,7540574,'nis',8.333,1),(866,7540582,7540574,'ist',8.333,1),(866,7540583,7540574,'str',8.333,1),(866,7540584,7540574,'tra',8.333,1),(866,7540585,7540574,'rat',8.333,1),(866,7540586,7540574,'ati',8.333,1),(866,7540587,7540574,'tio',8.333,1),(866,7540588,7540574,'ion',8.333,1),(866,7540589,7540577,'sta',33.333,3),(866,7540590,7540577,'tat',33.333,3),(866,7540591,7540577,'ate',33.333,3),(866,7540592,7540589,'dis',16.667,4),(866,7540593,7540589,'isa',16.667,4),(866,7540594,7540589,'sab',16.667,4),(866,7540595,7540589,'abl',16.667,4),(866,7540596,7540589,'ble',16.667,4),(866,7540597,7540589,'led',16.667,4),(866,7540598,7540592,'cac',33.333,1),(866,7540599,7540592,'ach',33.333,1),(866,7540600,7540592,'che',33.333,1),(866,7540601,7540598,'mod',50,1),(866,7540602,7540598,'ode',50,1),(866,7540603,7540601,'wri',14.286,1),(866,7540604,7540601,'rit',14.286,1),(866,7540605,7540601,'ite',14.286,1),(866,7540606,7540601,'tet',14.286,1),(866,7540607,7540601,'eth',14.286,1),(866,7540608,7540601,'thr',14.286,1),(866,7540609,7540601,'hru',14.286,1),(866,7540610,7540603,'ope',11.111,2),(866,7540611,7540603,'per',11.111,2),(866,7540612,7540603,'era',11.111,2),(866,7540613,7540603,'rat',11.111,2),(866,7540614,7540603,'ati',11.111,2),(866,7540615,7540603,'tio',11.111,2),(866,7540616,7540603,'ion',11.111,2),(866,7540617,7540603,'ona',11.111,2),(866,7540618,7540603,'nal',11.111,2),(866,7540619,7540610,'mes',20,1),(866,7540620,7540610,'ess',20,1),(866,7540621,7540610,'ssa',20,1),(866,7540622,7540610,'sag',20,1),(866,7540623,7540610,'age',20,1),(866,7540624,7540619,'per',11.111,1),(866,7540625,7540619,'erf',11.111,1),(866,7540626,7540619,'rfo',11.111,1),(866,7540627,7540619,'for',11.111,1),(866,7540628,7540619,'orm',11.111,1),(866,7540629,7540619,'rma',11.111,1),(866,7540630,7540619,'man',11.111,1),(866,7540631,7540619,'anc',11.111,1),(866,7540632,7540619,'nce',11.111,1),(866,7540633,7540624,'ide',12.5,1),(866,7540634,7540624,'den',12.5,1),(866,7540635,7540624,'ent',12.5,1),(866,7540636,7540624,'nti',12.5,1),(866,7540637,7540624,'tif',12.5,1),(866,7540638,7540624,'ifi',12.5,1),(866,7540639,7540624,'fie',12.5,1),(866,7540640,7540624,'ier',12.5,1),(866,7540641,7540633,'vdi',33.333,3),(866,7540642,7540633,'dis',33.333,3),(866,7540643,7540633,'isk',33.333,3),(866,7540644,7540641,'nam',50,1),(866,7540645,7540641,'ame',50,1),(866,7540646,7540644,'typ',50,1),(866,7540647,7540644,'ype',50,1),(866,7540648,7540646,'dir',25,1),(866,7540649,7540646,'ire',25,1),(866,7540650,7540646,'rec',25,1),(866,7540651,7540646,'ect',25,1),(867,7540653,7540652,'naa',100,2),(867,7540654,7540653,'600',3.333,3),(867,7540655,7540653,'000',3.333,3),(867,7540656,7540653,'00c',3.333,3),(867,7540657,7540653,'0c2',3.333,3),(867,7540658,7540653,'c29',3.333,3),(867,7540659,7540653,'298',3.333,3),(867,7540660,7540653,'98e',3.333,3),(867,7540661,7540653,'8ea',3.333,3),(867,7540662,7540653,'eaa',3.333,3),(867,7540663,7540653,'aa2',3.333,3),(867,7540664,7540653,'a2a',3.333,3),(867,7540665,7540653,'2ab',3.333,3),(867,7540666,7540653,'ab5',3.333,3),(867,7540667,7540653,'b5d',3.333,3),(867,7540668,7540653,'5de',3.333,3),(867,7540669,7540653,'de5',3.333,3),(867,7540670,7540653,'e50',3.333,3),(867,7540671,7540653,'509',3.333,3),(867,7540672,7540653,'09f',3.333,3),(867,7540673,7540653,'9f8',3.333,3),(867,7540674,7540653,'f83',3.333,3),(867,7540675,7540653,'831',3.333,3),(867,7540676,7540653,'310',3.333,3),(867,7540677,7540653,'10c',3.333,3),(867,7540678,7540653,'0c7',3.333,3),(867,7540679,7540653,'c72',3.333,3),(867,7540680,7540653,'727',3.333,3),(867,7540681,7540653,'27b',3.333,3),(867,7540682,7540653,'7bc',3.333,3),(867,7540683,7540653,'bc3',3.333,3),(867,7540684,7540654,'mon',100,1),(867,7540685,7540684,'201',50,1),(867,7540686,7540684,'013',50,1),(867,7540687,7540685,'adm',33.333,4),(867,7540688,7540685,'dmi',33.333,4),(867,7540689,7540685,'min',33.333,4),(867,7540690,7540687,'cap',16.667,1),(867,7540691,7540687,'apa',16.667,1),(867,7540692,7540687,'pac',16.667,1),(867,7540693,7540687,'aci',16.667,1),(867,7540694,7540687,'cit',16.667,1),(867,7540695,7540687,'ity',16.667,1),(867,7540696,7540690,'pat',50,1),(867,7540697,7540690,'ath',50,1),(867,7540698,7540696,'fre',14.286,1),(867,7540699,7540696,'ree',14.286,1),(867,7540700,7540696,'ees',14.286,1),(867,7540701,7540696,'esp',14.286,1),(867,7540702,7540696,'spa',14.286,1),(867,7540703,7540696,'pac',14.286,1),(867,7540704,7540696,'ace',14.286,1),(867,7540705,7540698,'dis',50,1),(867,7540706,7540698,'isk',50,1),(867,7540707,7540705,'ind',33.333,1),(867,7540708,7540705,'nde',33.333,1),(867,7540709,7540705,'dex',33.333,1),(867,7540710,7540707,'adm',8.333,1),(867,7540711,7540707,'dmi',8.333,1),(867,7540712,7540707,'min',8.333,1),(867,7540713,7540707,'ini',8.333,1),(867,7540714,7540707,'nis',8.333,1),(867,7540715,7540707,'ist',8.333,1),(867,7540716,7540707,'str',8.333,1),(867,7540717,7540707,'tra',8.333,1),(867,7540718,7540707,'rat',8.333,1),(867,7540719,7540707,'ati',8.333,1),(867,7540720,7540707,'tio',8.333,1),(867,7540721,7540707,'ion',8.333,1),(867,7540722,7540710,'sta',33.333,3),(867,7540723,7540710,'tat',33.333,3),(867,7540724,7540710,'ate',33.333,3),(867,7540725,7540722,'dis',16.667,4),(867,7540726,7540722,'isa',16.667,4),(867,7540727,7540722,'sab',16.667,4),(867,7540728,7540722,'abl',16.667,4),(867,7540729,7540722,'ble',16.667,4),(867,7540730,7540722,'led',16.667,4),(867,7540731,7540725,'cac',33.333,1),(867,7540732,7540725,'ach',33.333,1),(867,7540733,7540725,'che',33.333,1),(867,7540734,7540731,'mod',50,1),(867,7540735,7540731,'ode',50,1),(867,7540736,7540734,'wri',14.286,1),(867,7540737,7540734,'rit',14.286,1),(867,7540738,7540734,'ite',14.286,1),(867,7540739,7540734,'tet',14.286,1),(867,7540740,7540734,'eth',14.286,1),(867,7540741,7540734,'thr',14.286,1),(867,7540742,7540734,'hru',14.286,1),(867,7540743,7540736,'ope',11.111,2),(867,7540744,7540736,'per',11.111,2),(867,7540745,7540736,'era',11.111,2),(867,7540746,7540736,'rat',11.111,2),(867,7540747,7540736,'ati',11.111,2),(867,7540748,7540736,'tio',11.111,2),(867,7540749,7540736,'ion',11.111,2),(867,7540750,7540736,'ona',11.111,2),(867,7540751,7540736,'nal',11.111,2),(867,7540752,7540743,'mes',20,1),(867,7540753,7540743,'ess',20,1),(867,7540754,7540743,'ssa',20,1),(867,7540755,7540743,'sag',20,1),(867,7540756,7540743,'age',20,1),(867,7540757,7540752,'per',11.111,1),(867,7540758,7540752,'erf',11.111,1),(867,7540759,7540752,'rfo',11.111,1),(867,7540760,7540752,'for',11.111,1),(867,7540761,7540752,'orm',11.111,1),(867,7540762,7540752,'rma',11.111,1),(867,7540763,7540752,'man',11.111,1),(867,7540764,7540752,'anc',11.111,1),(867,7540765,7540752,'nce',11.111,1),(867,7540766,7540757,'ide',12.5,1),(867,7540767,7540757,'den',12.5,1),(867,7540768,7540757,'ent',12.5,1),(867,7540769,7540757,'nti',12.5,1),(867,7540770,7540757,'tif',12.5,1),(867,7540771,7540757,'ifi',12.5,1),(867,7540772,7540757,'fie',12.5,1),(867,7540773,7540757,'ier',12.5,1),(867,7540774,7540766,'vdi',33.333,3),(867,7540775,7540766,'dis',33.333,3),(867,7540776,7540766,'isk',33.333,3),(867,7540777,7540774,'nam',50,1),(867,7540778,7540774,'ame',50,1),(867,7540779,7540777,'typ',50,1),(867,7540780,7540777,'ype',50,1),(867,7540781,7540779,'dir',25,1),(867,7540782,7540779,'ire',25,1),(867,7540783,7540779,'rec',25,1),(867,7540784,7540779,'ect',25,1),(868,7540786,7540785,'naa',100,2),(868,7540787,7540786,'600',3.333,3),(868,7540788,7540786,'000',3.333,3),(868,7540789,7540786,'00c',3.333,3),(868,7540790,7540786,'0c2',3.333,3),(868,7540791,7540786,'c29',3.333,3),(868,7540792,7540786,'291',3.333,3),(868,7540793,7540786,'919',3.333,3),(868,7540794,7540786,'19e',3.333,3),(868,7540795,7540786,'9eb',3.333,3),(868,7540796,7540786,'eb5',3.333,3),(868,7540797,7540786,'b54',3.333,3),(868,7540798,7540786,'54d',3.333,3),(868,7540799,7540786,'4d4',3.333,3),(868,7540800,7540786,'d4b',3.333,3),(868,7540801,7540786,'4bb',3.333,3),(868,7540802,7540786,'bb7',3.333,3),(868,7540803,7540786,'b75',3.333,3),(868,7540804,7540786,'75e',3.333,3),(868,7540805,7540786,'5ea',3.333,3),(868,7540806,7540786,'ea1',3.333,3),(868,7540807,7540786,'a18',3.333,3),(868,7540808,7540786,'18a',3.333,3),(868,7540809,7540786,'8a8',3.333,3),(868,7540810,7540786,'a8f',3.333,3),(868,7540811,7540786,'8f9',3.333,3),(868,7540812,7540786,'f9e',3.333,3),(868,7540813,7540786,'9e3',3.333,3),(868,7540814,7540786,'e3b',3.333,3),(868,7540815,7540786,'3b6',3.333,3),(868,7540816,7540786,'b67',3.333,3),(868,7540817,7540787,'mon',100,1),(868,7540818,7540817,'201',50,1),(868,7540819,7540817,'013',50,1),(868,7540820,7540818,'adm',33.333,4),(868,7540821,7540818,'dmi',33.333,4),(868,7540822,7540818,'min',33.333,4),(868,7540823,7540820,'cap',16.667,1),(868,7540824,7540820,'apa',16.667,1),(868,7540825,7540820,'pac',16.667,1),(868,7540826,7540820,'aci',16.667,1),(868,7540827,7540820,'cit',16.667,1),(868,7540828,7540820,'ity',16.667,1),(868,7540829,7540823,'pat',50,1),(868,7540830,7540823,'ath',50,1),(868,7540831,7540829,'fre',14.286,1),(868,7540832,7540829,'ree',14.286,1),(868,7540833,7540829,'ees',14.286,1),(868,7540834,7540829,'esp',14.286,1),(868,7540835,7540829,'spa',14.286,1),(868,7540836,7540829,'pac',14.286,1),(868,7540837,7540829,'ace',14.286,1),(868,7540838,7540831,'dis',50,1),(868,7540839,7540831,'isk',50,1),(868,7540840,7540838,'ind',33.333,1),(868,7540841,7540838,'nde',33.333,1),(868,7540842,7540838,'dex',33.333,1),(868,7540843,7540840,'adm',8.333,1),(868,7540844,7540840,'dmi',8.333,1),(868,7540845,7540840,'min',8.333,1),(868,7540846,7540840,'ini',8.333,1),(868,7540847,7540840,'nis',8.333,1),(868,7540848,7540840,'ist',8.333,1),(868,7540849,7540840,'str',8.333,1),(868,7540850,7540840,'tra',8.333,1),(868,7540851,7540840,'rat',8.333,1),(868,7540852,7540840,'ati',8.333,1),(868,7540853,7540840,'tio',8.333,1),(868,7540854,7540840,'ion',8.333,1),(868,7540855,7540843,'sta',33.333,3),(868,7540856,7540843,'tat',33.333,3),(868,7540857,7540843,'ate',33.333,3),(868,7540858,7540855,'dis',16.667,4),(868,7540859,7540855,'isa',16.667,4),(868,7540860,7540855,'sab',16.667,4),(868,7540861,7540855,'abl',16.667,4),(868,7540862,7540855,'ble',16.667,4),(868,7540863,7540855,'led',16.667,4),(868,7540864,7540858,'cac',33.333,1),(868,7540865,7540858,'ach',33.333,1),(868,7540866,7540858,'che',33.333,1),(868,7540867,7540864,'mod',50,1),(868,7540868,7540864,'ode',50,1),(868,7540869,7540867,'wri',14.286,1),(868,7540870,7540867,'rit',14.286,1),(868,7540871,7540867,'ite',14.286,1),(868,7540872,7540867,'tet',14.286,1),(868,7540873,7540867,'eth',14.286,1),(868,7540874,7540867,'thr',14.286,1),(868,7540875,7540867,'hru',14.286,1),(868,7540876,7540869,'ope',11.111,2),(868,7540877,7540869,'per',11.111,2),(868,7540878,7540869,'era',11.111,2),(868,7540879,7540869,'rat',11.111,2),(868,7540880,7540869,'ati',11.111,2),(868,7540881,7540869,'tio',11.111,2),(868,7540882,7540869,'ion',11.111,2),(868,7540883,7540869,'ona',11.111,2),(868,7540884,7540869,'nal',11.111,2),(868,7540885,7540876,'mes',20,1),(868,7540886,7540876,'ess',20,1),(868,7540887,7540876,'ssa',20,1),(868,7540888,7540876,'sag',20,1),(868,7540889,7540876,'age',20,1),(868,7540890,7540885,'per',11.111,1),(868,7540891,7540885,'erf',11.111,1),(868,7540892,7540885,'rfo',11.111,1),(868,7540893,7540885,'for',11.111,1),(868,7540894,7540885,'orm',11.111,1),(868,7540895,7540885,'rma',11.111,1),(868,7540896,7540885,'man',11.111,1),(868,7540897,7540885,'anc',11.111,1),(868,7540898,7540885,'nce',11.111,1),(868,7540899,7540890,'ide',12.5,1),(868,7540900,7540890,'den',12.5,1),(868,7540901,7540890,'ent',12.5,1),(868,7540902,7540890,'nti',12.5,1),(868,7540903,7540890,'tif',12.5,1),(868,7540904,7540890,'ifi',12.5,1),(868,7540905,7540890,'fie',12.5,1),(868,7540906,7540890,'ier',12.5,1),(868,7540907,7540899,'vdi',33.333,3),(868,7540908,7540899,'dis',33.333,3),(868,7540909,7540899,'isk',33.333,3),(868,7540910,7540907,'nam',50,1),(868,7540911,7540907,'ame',50,1),(868,7540912,7540910,'typ',50,1),(868,7540913,7540910,'ype',50,1),(868,7540914,7540912,'dir',25,1),(868,7540915,7540912,'ire',25,1),(868,7540916,7540912,'rec',25,1),(868,7540917,7540912,'ect',25,1),(869,7540919,7540918,'naa',100,2),(869,7540920,7540919,'600',3.333,3),(869,7540921,7540919,'000',3.333,3),(869,7540922,7540919,'00c',3.333,3),(869,7540923,7540919,'0c2',3.333,3),(869,7540924,7540919,'c29',3.333,3),(869,7540925,7540919,'295',3.333,3),(869,7540926,7540919,'95e',3.333,3),(869,7540927,7540919,'5e3',3.333,3),(869,7540928,7540919,'e3f',3.333,3),(869,7540929,7540919,'3f6',3.333,3),(869,7540930,7540919,'f6c',3.333,3),(869,7540931,7540919,'6ce',3.333,3),(869,7540932,7540919,'ce2',3.333,3),(869,7540933,7540919,'e22',3.333,3),(869,7540934,7540919,'22c',3.333,3),(869,7540935,7540919,'2c6',3.333,3),(869,7540936,7540919,'c64',3.333,3),(869,7540937,7540919,'643',3.333,3),(869,7540938,7540919,'437',3.333,3),(869,7540939,7540919,'375',3.333,3),(869,7540940,7540919,'756',3.333,3),(869,7540941,7540919,'56d',3.333,3),(869,7540942,7540919,'6de',3.333,3),(869,7540943,7540919,'deb',3.333,3),(869,7540944,7540919,'eb0',3.333,3),(869,7540945,7540919,'b04',3.333,3),(869,7540946,7540919,'045',3.333,3),(869,7540947,7540919,'459',3.333,3),(869,7540948,7540919,'591',3.333,3),(869,7540949,7540919,'910',3.333,3),(869,7540950,7540920,'mon',100,1),(869,7540951,7540950,'201',50,1),(869,7540952,7540950,'013',50,1),(869,7540953,7540951,'adm',33.333,4),(869,7540954,7540951,'dmi',33.333,4),(869,7540955,7540951,'min',33.333,4),(869,7540956,7540953,'cap',16.667,1),(869,7540957,7540953,'apa',16.667,1),(869,7540958,7540953,'pac',16.667,1),(869,7540959,7540953,'aci',16.667,1),(869,7540960,7540953,'cit',16.667,1),(869,7540961,7540953,'ity',16.667,1),(869,7540962,7540956,'pat',50,1),(869,7540963,7540956,'ath',50,1),(869,7540964,7540962,'fre',14.286,1),(869,7540965,7540962,'ree',14.286,1),(869,7540966,7540962,'ees',14.286,1),(869,7540967,7540962,'esp',14.286,1),(869,7540968,7540962,'spa',14.286,1),(869,7540969,7540962,'pac',14.286,1),(869,7540970,7540962,'ace',14.286,1),(869,7540971,7540964,'dis',50,1),(869,7540972,7540964,'isk',50,1),(869,7540973,7540971,'ind',33.333,1),(869,7540974,7540971,'nde',33.333,1),(869,7540975,7540971,'dex',33.333,1),(869,7540976,7540973,'adm',8.333,1),(869,7540977,7540973,'dmi',8.333,1),(869,7540978,7540973,'min',8.333,1),(869,7540979,7540973,'ini',8.333,1),(869,7540980,7540973,'nis',8.333,1),(869,7540981,7540973,'ist',8.333,1),(869,7540982,7540973,'str',8.333,1),(869,7540983,7540973,'tra',8.333,1),(869,7540984,7540973,'rat',8.333,1),(869,7540985,7540973,'ati',8.333,1),(869,7540986,7540973,'tio',8.333,1),(869,7540987,7540973,'ion',8.333,1),(869,7540988,7540976,'sta',33.333,3),(869,7540989,7540976,'tat',33.333,3),(869,7540990,7540976,'ate',33.333,3),(869,7540991,7540988,'dis',16.667,4),(869,7540992,7540988,'isa',16.667,4),(869,7540993,7540988,'sab',16.667,4),(869,7540994,7540988,'abl',16.667,4),(869,7540995,7540988,'ble',16.667,4),(869,7540996,7540988,'led',16.667,4),(869,7540997,7540991,'cac',33.333,1),(869,7540998,7540991,'ach',33.333,1),(869,7540999,7540991,'che',33.333,1),(869,7541000,7540997,'mod',50,1),(869,7541001,7540997,'ode',50,1),(869,7541002,7541000,'wri',14.286,1),(869,7541003,7541000,'rit',14.286,1),(869,7541004,7541000,'ite',14.286,1),(869,7541005,7541000,'tet',14.286,1),(869,7541006,7541000,'eth',14.286,1),(869,7541007,7541000,'thr',14.286,1),(869,7541008,7541000,'hru',14.286,1),(869,7541009,7541002,'ope',11.111,2),(869,7541010,7541002,'per',11.111,2),(869,7541011,7541002,'era',11.111,2),(869,7541012,7541002,'rat',11.111,2),(869,7541013,7541002,'ati',11.111,2),(869,7541014,7541002,'tio',11.111,2),(869,7541015,7541002,'ion',11.111,2),(869,7541016,7541002,'ona',11.111,2),(869,7541017,7541002,'nal',11.111,2),(869,7541018,7541009,'mes',20,1),(869,7541019,7541009,'ess',20,1),(869,7541020,7541009,'ssa',20,1),(869,7541021,7541009,'sag',20,1),(869,7541022,7541009,'age',20,1),(869,7541023,7541018,'per',11.111,1),(869,7541024,7541018,'erf',11.111,1),(869,7541025,7541018,'rfo',11.111,1),(869,7541026,7541018,'for',11.111,1),(869,7541027,7541018,'orm',11.111,1),(869,7541028,7541018,'rma',11.111,1),(869,7541029,7541018,'man',11.111,1),(869,7541030,7541018,'anc',11.111,1),(869,7541031,7541018,'nce',11.111,1),(869,7541032,7541023,'ide',12.5,1),(869,7541033,7541023,'den',12.5,1),(869,7541034,7541023,'ent',12.5,1),(869,7541035,7541023,'nti',12.5,1),(869,7541036,7541023,'tif',12.5,1),(869,7541037,7541023,'ifi',12.5,1),(869,7541038,7541023,'fie',12.5,1),(869,7541039,7541023,'ier',12.5,1),(869,7541040,7541032,'vdi',33.333,3),(869,7541041,7541032,'dis',33.333,3),(869,7541042,7541032,'isk',33.333,3),(869,7541043,7541040,'nam',50,1),(869,7541044,7541040,'ame',50,1),(869,7541045,7541043,'typ',50,1),(869,7541046,7541043,'ype',50,1),(869,7541047,7541045,'dir',25,1),(869,7541048,7541045,'ire',25,1),(869,7541049,7541045,'rec',25,1),(869,7541050,7541045,'ect',25,1),(870,7541052,7541051,'naa',100,2),(870,7541053,7541052,'600',3.333,3),(870,7541054,7541052,'000',3.333,3),(870,7541055,7541052,'00c',3.333,3),(870,7541056,7541052,'0c2',3.333,3),(870,7541057,7541052,'c29',3.333,3),(870,7541058,7541052,'298',3.333,3),(870,7541059,7541052,'987',3.333,3),(870,7541060,7541052,'87e',3.333,3),(870,7541061,7541052,'7e7',3.333,3),(870,7541062,7541052,'e75',3.333,3),(870,7541063,7541052,'755',3.333,3),(870,7541064,7541052,'551',3.333,3),(870,7541065,7541052,'51e',3.333,3),(870,7541066,7541052,'1e6',3.333,3),(870,7541067,7541052,'e65',3.333,3),(870,7541068,7541052,'653',3.333,3),(870,7541069,7541052,'534',3.333,3),(870,7541070,7541052,'347',3.333,3),(870,7541071,7541052,'475',3.333,3),(870,7541072,7541052,'752',3.333,3),(870,7541073,7541052,'52f',3.333,3),(870,7541074,7541052,'2f1',3.333,3),(870,7541075,7541052,'f1b',3.333,3),(870,7541076,7541052,'1b3',3.333,3),(870,7541077,7541052,'b37',3.333,3),(870,7541078,7541052,'379',3.333,3),(870,7541079,7541052,'792',3.333,3),(870,7541080,7541052,'921',3.333,3),(870,7541081,7541052,'216',3.333,3),(870,7541082,7541052,'166',3.333,3),(870,7541083,7541053,'mon',100,1),(870,7541084,7541083,'201',50,1),(870,7541085,7541083,'013',50,1),(870,7541086,7541084,'adm',33.333,4),(870,7541087,7541084,'dmi',33.333,4),(870,7541088,7541084,'min',33.333,4),(870,7541089,7541086,'cap',16.667,1),(870,7541090,7541086,'apa',16.667,1),(870,7541091,7541086,'pac',16.667,1),(870,7541092,7541086,'aci',16.667,1),(870,7541093,7541086,'cit',16.667,1),(870,7541094,7541086,'ity',16.667,1),(870,7541095,7541089,'pat',50,1),(870,7541096,7541089,'ath',50,1),(870,7541097,7541095,'fre',14.286,1),(870,7541098,7541095,'ree',14.286,1),(870,7541099,7541095,'ees',14.286,1),(870,7541100,7541095,'esp',14.286,1),(870,7541101,7541095,'spa',14.286,1),(870,7541102,7541095,'pac',14.286,1),(870,7541103,7541095,'ace',14.286,1),(870,7541104,7541097,'dis',50,1),(870,7541105,7541097,'isk',50,1),(870,7541106,7541104,'ind',33.333,1),(870,7541107,7541104,'nde',33.333,1),(870,7541108,7541104,'dex',33.333,1),(870,7541109,7541106,'adm',8.333,1),(870,7541110,7541106,'dmi',8.333,1),(870,7541111,7541106,'min',8.333,1),(870,7541112,7541106,'ini',8.333,1),(870,7541113,7541106,'nis',8.333,1),(870,7541114,7541106,'ist',8.333,1),(870,7541115,7541106,'str',8.333,1),(870,7541116,7541106,'tra',8.333,1),(870,7541117,7541106,'rat',8.333,1),(870,7541118,7541106,'ati',8.333,1),(870,7541119,7541106,'tio',8.333,1),(870,7541120,7541106,'ion',8.333,1),(870,7541121,7541109,'sta',33.333,3),(870,7541122,7541109,'tat',33.333,3),(870,7541123,7541109,'ate',33.333,3),(870,7541124,7541121,'dis',16.667,4),(870,7541125,7541121,'isa',16.667,4),(870,7541126,7541121,'sab',16.667,4),(870,7541127,7541121,'abl',16.667,4),(870,7541128,7541121,'ble',16.667,4),(870,7541129,7541121,'led',16.667,4),(870,7541130,7541124,'cac',33.333,1),(870,7541131,7541124,'ach',33.333,1),(870,7541132,7541124,'che',33.333,1),(870,7541133,7541130,'mod',50,1),(870,7541134,7541130,'ode',50,1),(870,7541135,7541133,'wri',14.286,1),(870,7541136,7541133,'rit',14.286,1),(870,7541137,7541133,'ite',14.286,1),(870,7541138,7541133,'tet',14.286,1),(870,7541139,7541133,'eth',14.286,1),(870,7541140,7541133,'thr',14.286,1),(870,7541141,7541133,'hru',14.286,1),(870,7541142,7541135,'ope',11.111,2),(870,7541143,7541135,'per',11.111,2),(870,7541144,7541135,'era',11.111,2),(870,7541145,7541135,'rat',11.111,2),(870,7541146,7541135,'ati',11.111,2),(870,7541147,7541135,'tio',11.111,2),(870,7541148,7541135,'ion',11.111,2),(870,7541149,7541135,'ona',11.111,2),(870,7541150,7541135,'nal',11.111,2),(870,7541151,7541142,'mes',20,1),(870,7541152,7541142,'ess',20,1),(870,7541153,7541142,'ssa',20,1),(870,7541154,7541142,'sag',20,1),(870,7541155,7541142,'age',20,1),(870,7541156,7541151,'per',11.111,1),(870,7541157,7541151,'erf',11.111,1),(870,7541158,7541151,'rfo',11.111,1),(870,7541159,7541151,'for',11.111,1),(870,7541160,7541151,'orm',11.111,1),(870,7541161,7541151,'rma',11.111,1),(870,7541162,7541151,'man',11.111,1),(870,7541163,7541151,'anc',11.111,1),(870,7541164,7541151,'nce',11.111,1),(870,7541165,7541156,'ide',12.5,1),(870,7541166,7541156,'den',12.5,1),(870,7541167,7541156,'ent',12.5,1),(870,7541168,7541156,'nti',12.5,1),(870,7541169,7541156,'tif',12.5,1),(870,7541170,7541156,'ifi',12.5,1),(870,7541171,7541156,'fie',12.5,1),(870,7541172,7541156,'ier',12.5,1),(870,7541173,7541165,'vdi',33.333,3),(870,7541174,7541165,'dis',33.333,3),(870,7541175,7541165,'isk',33.333,3),(870,7541176,7541173,'nam',50,1),(870,7541177,7541173,'ame',50,1),(870,7541178,7541176,'typ',50,1),(870,7541179,7541176,'ype',50,1),(870,7541180,7541178,'dir',25,1),(870,7541181,7541178,'ire',25,1),(870,7541182,7541178,'rec',25,1),(870,7541183,7541178,'ect',25,1),(871,7541185,7541184,'naa',100,2),(871,7541186,7541185,'600',3.333,3),(871,7541187,7541185,'000',3.333,3),(871,7541188,7541185,'00c',3.333,3),(871,7541189,7541185,'0c2',3.333,3),(871,7541190,7541185,'c29',3.333,3),(871,7541191,7541185,'29b',3.333,3),(871,7541192,7541185,'9b6',3.333,3),(871,7541193,7541185,'b6c',3.333,3),(871,7541194,7541185,'6c9',3.333,3),(871,7541195,7541185,'c93',3.333,3),(871,7541196,7541185,'932',3.333,3),(871,7541197,7541185,'32b',3.333,3),(871,7541198,7541185,'2b2',3.333,3),(871,7541199,7541185,'b24',3.333,3),(871,7541200,7541185,'245',3.333,3),(871,7541201,7541185,'45b',3.333,3),(871,7541202,7541185,'5b0',3.333,3),(871,7541203,7541185,'b0a',3.333,3),(871,7541204,7541185,'0a1',3.333,3),(871,7541205,7541185,'a1d',3.333,3),(871,7541206,7541185,'1d3',3.333,3),(871,7541207,7541185,'d33',3.333,3),(871,7541208,7541185,'337',3.333,3),(871,7541209,7541185,'37c',3.333,3),(871,7541210,7541185,'7cf',3.333,3),(871,7541211,7541185,'cf0',3.333,3),(871,7541212,7541185,'f0d',3.333,3),(871,7541213,7541185,'0d4',3.333,3),(871,7541214,7541185,'d49',3.333,3),(871,7541215,7541185,'499',3.333,3),(871,7541216,7541186,'mon',100,1),(871,7541217,7541216,'201',50,1),(871,7541218,7541216,'013',50,1),(871,7541219,7541217,'adm',33.333,4),(871,7541220,7541217,'dmi',33.333,4),(871,7541221,7541217,'min',33.333,4),(871,7541222,7541219,'cap',16.667,1),(871,7541223,7541219,'apa',16.667,1),(871,7541224,7541219,'pac',16.667,1),(871,7541225,7541219,'aci',16.667,1),(871,7541226,7541219,'cit',16.667,1),(871,7541227,7541219,'ity',16.667,1),(871,7541228,7541222,'pat',50,1),(871,7541229,7541222,'ath',50,1),(871,7541230,7541228,'fre',14.286,1),(871,7541231,7541228,'ree',14.286,1),(871,7541232,7541228,'ees',14.286,1),(871,7541233,7541228,'esp',14.286,1),(871,7541234,7541228,'spa',14.286,1),(871,7541235,7541228,'pac',14.286,1),(871,7541236,7541228,'ace',14.286,1),(871,7541237,7541230,'dis',50,1),(871,7541238,7541230,'isk',50,1),(871,7541239,7541237,'ind',33.333,1),(871,7541240,7541237,'nde',33.333,1),(871,7541241,7541237,'dex',33.333,1),(871,7541242,7541239,'adm',8.333,1),(871,7541243,7541239,'dmi',8.333,1),(871,7541244,7541239,'min',8.333,1),(871,7541245,7541239,'ini',8.333,1),(871,7541246,7541239,'nis',8.333,1),(871,7541247,7541239,'ist',8.333,1),(871,7541248,7541239,'str',8.333,1),(871,7541249,7541239,'tra',8.333,1),(871,7541250,7541239,'rat',8.333,1),(871,7541251,7541239,'ati',8.333,1),(871,7541252,7541239,'tio',8.333,1),(871,7541253,7541239,'ion',8.333,1),(871,7541254,7541242,'sta',33.333,3),(871,7541255,7541242,'tat',33.333,3),(871,7541256,7541242,'ate',33.333,3),(871,7541257,7541254,'dis',16.667,4),(871,7541258,7541254,'isa',16.667,4),(871,7541259,7541254,'sab',16.667,4),(871,7541260,7541254,'abl',16.667,4),(871,7541261,7541254,'ble',16.667,4),(871,7541262,7541254,'led',16.667,4),(871,7541263,7541257,'cac',33.333,1),(871,7541264,7541257,'ach',33.333,1),(871,7541265,7541257,'che',33.333,1),(871,7541266,7541263,'mod',50,1),(871,7541267,7541263,'ode',50,1),(871,7541268,7541266,'wri',14.286,1),(871,7541269,7541266,'rit',14.286,1),(871,7541270,7541266,'ite',14.286,1),(871,7541271,7541266,'tet',14.286,1),(871,7541272,7541266,'eth',14.286,1),(871,7541273,7541266,'thr',14.286,1),(871,7541274,7541266,'hru',14.286,1),(871,7541275,7541268,'ope',11.111,2),(871,7541276,7541268,'per',11.111,2),(871,7541277,7541268,'era',11.111,2),(871,7541278,7541268,'rat',11.111,2),(871,7541279,7541268,'ati',11.111,2),(871,7541280,7541268,'tio',11.111,2),(871,7541281,7541268,'ion',11.111,2),(871,7541282,7541268,'ona',11.111,2),(871,7541283,7541268,'nal',11.111,2),(871,7541284,7541275,'mes',20,1),(871,7541285,7541275,'ess',20,1),(871,7541286,7541275,'ssa',20,1),(871,7541287,7541275,'sag',20,1),(871,7541288,7541275,'age',20,1),(871,7541289,7541284,'per',11.111,1),(871,7541290,7541284,'erf',11.111,1),(871,7541291,7541284,'rfo',11.111,1),(871,7541292,7541284,'for',11.111,1),(871,7541293,7541284,'orm',11.111,1),(871,7541294,7541284,'rma',11.111,1),(871,7541295,7541284,'man',11.111,1),(871,7541296,7541284,'anc',11.111,1),(871,7541297,7541284,'nce',11.111,1),(871,7541298,7541289,'ide',12.5,1),(871,7541299,7541289,'den',12.5,1),(871,7541300,7541289,'ent',12.5,1),(871,7541301,7541289,'nti',12.5,1),(871,7541302,7541289,'tif',12.5,1),(871,7541303,7541289,'ifi',12.5,1),(871,7541304,7541289,'fie',12.5,1),(871,7541305,7541289,'ier',12.5,1),(871,7541306,7541298,'vdi',33.333,3),(871,7541307,7541298,'dis',33.333,3),(871,7541308,7541298,'isk',33.333,3),(871,7541309,7541306,'nam',50,1),(871,7541310,7541306,'ame',50,1),(871,7541311,7541309,'typ',50,1),(871,7541312,7541309,'ype',50,1),(871,7541313,7541311,'dir',25,1),(871,7541314,7541311,'ire',25,1),(871,7541315,7541311,'rec',25,1),(871,7541316,7541311,'ect',25,1),(872,7541318,7541317,'naa',100,2),(872,7541319,7541318,'600',3.333,3),(872,7541320,7541318,'000',3.333,3),(872,7541321,7541318,'00c',3.333,3),(872,7541322,7541318,'0c2',3.333,3),(872,7541323,7541318,'c29',3.333,3),(872,7541324,7541318,'29e',3.333,3),(872,7541325,7541318,'9e6',3.333,3),(872,7541326,7541318,'e68',3.333,3),(872,7541327,7541318,'68f',3.333,3),(872,7541328,7541318,'8f6',3.333,3),(872,7541329,7541318,'f62',3.333,3),(872,7541330,7541318,'624',3.333,3),(872,7541331,7541318,'24e',3.333,3),(872,7541332,7541318,'4ed',3.333,3),(872,7541333,7541318,'ed3',3.333,3),(872,7541334,7541318,'d30',3.333,3),(872,7541335,7541318,'301',3.333,3),(872,7541336,7541318,'011',3.333,3),(872,7541337,7541318,'11a',3.333,3),(872,7541338,7541318,'1af',3.333,3),(872,7541339,7541318,'af7',3.333,3),(872,7541340,7541318,'f72',3.333,3),(872,7541341,7541318,'728',3.333,3),(872,7541342,7541318,'289',3.333,3),(872,7541343,7541318,'896',3.333,3),(872,7541344,7541318,'96a',3.333,3),(872,7541345,7541318,'6a6',3.333,3),(872,7541346,7541318,'a64',3.333,3),(872,7541347,7541318,'64f',3.333,3),(872,7541348,7541318,'4f7',3.333,3),(872,7541349,7541319,'mon',100,1),(872,7541350,7541349,'201',50,1),(872,7541351,7541349,'013',50,1),(872,7541352,7541350,'adm',33.333,4),(872,7541353,7541350,'dmi',33.333,4),(872,7541354,7541350,'min',33.333,4),(872,7541355,7541352,'cap',16.667,1),(872,7541356,7541352,'apa',16.667,1),(872,7541357,7541352,'pac',16.667,1),(872,7541358,7541352,'aci',16.667,1),(872,7541359,7541352,'cit',16.667,1),(872,7541360,7541352,'ity',16.667,1),(872,7541361,7541355,'pat',50,1),(872,7541362,7541355,'ath',50,1),(872,7541363,7541361,'fre',14.286,1),(872,7541364,7541361,'ree',14.286,1),(872,7541365,7541361,'ees',14.286,1),(872,7541366,7541361,'esp',14.286,1),(872,7541367,7541361,'spa',14.286,1),(872,7541368,7541361,'pac',14.286,1),(872,7541369,7541361,'ace',14.286,1),(872,7541370,7541363,'dis',50,1),(872,7541371,7541363,'isk',50,1),(872,7541372,7541370,'ind',33.333,1),(872,7541373,7541370,'nde',33.333,1),(872,7541374,7541370,'dex',33.333,1),(872,7541375,7541372,'adm',8.333,1),(872,7541376,7541372,'dmi',8.333,1),(872,7541377,7541372,'min',8.333,1),(872,7541378,7541372,'ini',8.333,1),(872,7541379,7541372,'nis',8.333,1),(872,7541380,7541372,'ist',8.333,1),(872,7541381,7541372,'str',8.333,1),(872,7541382,7541372,'tra',8.333,1),(872,7541383,7541372,'rat',8.333,1),(872,7541384,7541372,'ati',8.333,1),(872,7541385,7541372,'tio',8.333,1),(872,7541386,7541372,'ion',8.333,1),(872,7541387,7541375,'sta',33.333,3),(872,7541388,7541375,'tat',33.333,3),(872,7541389,7541375,'ate',33.333,3),(872,7541390,7541387,'dis',16.667,4),(872,7541391,7541387,'isa',16.667,4),(872,7541392,7541387,'sab',16.667,4),(872,7541393,7541387,'abl',16.667,4),(872,7541394,7541387,'ble',16.667,4),(872,7541395,7541387,'led',16.667,4),(872,7541396,7541390,'cac',33.333,1),(872,7541397,7541390,'ach',33.333,1),(872,7541398,7541390,'che',33.333,1),(872,7541399,7541396,'mod',50,1),(872,7541400,7541396,'ode',50,1),(872,7541401,7541399,'wri',14.286,1),(872,7541402,7541399,'rit',14.286,1),(872,7541403,7541399,'ite',14.286,1),(872,7541404,7541399,'tet',14.286,1),(872,7541405,7541399,'eth',14.286,1),(872,7541406,7541399,'thr',14.286,1),(872,7541407,7541399,'hru',14.286,1),(872,7541408,7541401,'ope',11.111,2),(872,7541409,7541401,'per',11.111,2),(872,7541410,7541401,'era',11.111,2),(872,7541411,7541401,'rat',11.111,2),(872,7541412,7541401,'ati',11.111,2),(872,7541413,7541401,'tio',11.111,2),(872,7541414,7541401,'ion',11.111,2),(872,7541415,7541401,'ona',11.111,2),(872,7541416,7541401,'nal',11.111,2),(872,7541417,7541408,'mes',20,1),(872,7541418,7541408,'ess',20,1),(872,7541419,7541408,'ssa',20,1),(872,7541420,7541408,'sag',20,1),(872,7541421,7541408,'age',20,1),(872,7541422,7541417,'per',11.111,1),(872,7541423,7541417,'erf',11.111,1),(872,7541424,7541417,'rfo',11.111,1),(872,7541425,7541417,'for',11.111,1),(872,7541426,7541417,'orm',11.111,1),(872,7541427,7541417,'rma',11.111,1),(872,7541428,7541417,'man',11.111,1),(872,7541429,7541417,'anc',11.111,1),(872,7541430,7541417,'nce',11.111,1),(872,7541431,7541422,'ide',12.5,1),(872,7541432,7541422,'den',12.5,1),(872,7541433,7541422,'ent',12.5,1),(872,7541434,7541422,'nti',12.5,1),(872,7541435,7541422,'tif',12.5,1),(872,7541436,7541422,'ifi',12.5,1),(872,7541437,7541422,'fie',12.5,1),(872,7541438,7541422,'ier',12.5,1),(872,7541439,7541431,'vdi',33.333,3),(872,7541440,7541431,'dis',33.333,3),(872,7541441,7541431,'isk',33.333,3),(872,7541442,7541439,'nam',50,1),(872,7541443,7541439,'ame',50,1),(872,7541444,7541442,'typ',50,1),(872,7541445,7541442,'ype',50,1),(872,7541446,7541444,'dir',25,1),(872,7541447,7541444,'ire',25,1),(872,7541448,7541444,'rec',25,1),(872,7541449,7541444,'ect',25,1),(873,7541451,7541450,'naa',100,2),(873,7541452,7541451,'600',3.333,3),(873,7541453,7541451,'000',3.333,3),(873,7541454,7541451,'00c',3.333,3),(873,7541455,7541451,'0c2',3.333,3),(873,7541456,7541451,'c29',3.333,3),(873,7541457,7541451,'29b',3.333,3),(873,7541458,7541451,'9b0',3.333,3),(873,7541459,7541451,'b09',3.333,3),(873,7541460,7541451,'09b',3.333,3),(873,7541461,7541451,'9bc',3.333,3),(873,7541462,7541451,'bc5',3.333,3),(873,7541463,7541451,'c57',3.333,3),(873,7541464,7541451,'576',3.333,3),(873,7541465,7541451,'76a',3.333,3),(873,7541466,7541451,'6a5',3.333,3),(873,7541467,7541451,'a59',3.333,3),(873,7541468,7541451,'592',3.333,3),(873,7541469,7541451,'92e',3.333,3),(873,7541470,7541451,'2e0',3.333,3),(873,7541471,7541451,'e0d',3.333,3),(873,7541472,7541451,'0d3',3.333,3),(873,7541473,7541451,'d3b',3.333,3),(873,7541474,7541451,'3b5',3.333,3),(873,7541475,7541451,'b5e',3.333,3),(873,7541476,7541451,'5e7',3.333,3),(873,7541477,7541451,'e7f',3.333,3),(873,7541478,7541451,'7ff',3.333,3),(873,7541479,7541451,'ff6',3.333,3),(873,7541480,7541451,'f6d',3.333,3),(873,7541481,7541451,'6d4',3.333,3),(873,7541482,7541452,'mon',100,1),(873,7541483,7541482,'201',50,1),(873,7541484,7541482,'013',50,1),(873,7541485,7541483,'adm',33.333,4),(873,7541486,7541483,'dmi',33.333,4),(873,7541487,7541483,'min',33.333,4),(873,7541488,7541485,'cap',16.667,1),(873,7541489,7541485,'apa',16.667,1),(873,7541490,7541485,'pac',16.667,1),(873,7541491,7541485,'aci',16.667,1),(873,7541492,7541485,'cit',16.667,1),(873,7541493,7541485,'ity',16.667,1),(873,7541494,7541488,'pat',50,1),(873,7541495,7541488,'ath',50,1),(873,7541496,7541494,'fre',14.286,1),(873,7541497,7541494,'ree',14.286,1),(873,7541498,7541494,'ees',14.286,1),(873,7541499,7541494,'esp',14.286,1),(873,7541500,7541494,'spa',14.286,1),(873,7541501,7541494,'pac',14.286,1),(873,7541502,7541494,'ace',14.286,1),(873,7541503,7541496,'dis',50,1),(873,7541504,7541496,'isk',50,1),(873,7541505,7541503,'ind',33.333,1),(873,7541506,7541503,'nde',33.333,1),(873,7541507,7541503,'dex',33.333,1),(873,7541508,7541505,'adm',8.333,1),(873,7541509,7541505,'dmi',8.333,1),(873,7541510,7541505,'min',8.333,1),(873,7541511,7541505,'ini',8.333,1),(873,7541512,7541505,'nis',8.333,1),(873,7541513,7541505,'ist',8.333,1),(873,7541514,7541505,'str',8.333,1),(873,7541515,7541505,'tra',8.333,1),(873,7541516,7541505,'rat',8.333,1),(873,7541517,7541505,'ati',8.333,1),(873,7541518,7541505,'tio',8.333,1),(873,7541519,7541505,'ion',8.333,1),(873,7541520,7541508,'sta',33.333,3),(873,7541521,7541508,'tat',33.333,3),(873,7541522,7541508,'ate',33.333,3),(873,7541523,7541520,'dis',16.667,4),(873,7541524,7541520,'isa',16.667,4),(873,7541525,7541520,'sab',16.667,4),(873,7541526,7541520,'abl',16.667,4),(873,7541527,7541520,'ble',16.667,4),(873,7541528,7541520,'led',16.667,4),(873,7541529,7541523,'cac',33.333,1),(873,7541530,7541523,'ach',33.333,1),(873,7541531,7541523,'che',33.333,1),(873,7541532,7541529,'mod',50,1),(873,7541533,7541529,'ode',50,1),(873,7541534,7541532,'wri',14.286,1),(873,7541535,7541532,'rit',14.286,1),(873,7541536,7541532,'ite',14.286,1),(873,7541537,7541532,'tet',14.286,1),(873,7541538,7541532,'eth',14.286,1),(873,7541539,7541532,'thr',14.286,1),(873,7541540,7541532,'hru',14.286,1),(873,7541541,7541534,'ope',11.111,2),(873,7541542,7541534,'per',11.111,2),(873,7541543,7541534,'era',11.111,2),(873,7541544,7541534,'rat',11.111,2),(873,7541545,7541534,'ati',11.111,2),(873,7541546,7541534,'tio',11.111,2),(873,7541547,7541534,'ion',11.111,2),(873,7541548,7541534,'ona',11.111,2),(873,7541549,7541534,'nal',11.111,2),(873,7541550,7541541,'mes',20,1),(873,7541551,7541541,'ess',20,1),(873,7541552,7541541,'ssa',20,1),(873,7541553,7541541,'sag',20,1),(873,7541554,7541541,'age',20,1),(873,7541555,7541550,'per',11.111,1),(873,7541556,7541550,'erf',11.111,1),(873,7541557,7541550,'rfo',11.111,1),(873,7541558,7541550,'for',11.111,1),(873,7541559,7541550,'orm',11.111,1),(873,7541560,7541550,'rma',11.111,1),(873,7541561,7541550,'man',11.111,1),(873,7541562,7541550,'anc',11.111,1),(873,7541563,7541550,'nce',11.111,1),(873,7541564,7541555,'ide',12.5,1),(873,7541565,7541555,'den',12.5,1),(873,7541566,7541555,'ent',12.5,1),(873,7541567,7541555,'nti',12.5,1),(873,7541568,7541555,'tif',12.5,1),(873,7541569,7541555,'ifi',12.5,1),(873,7541570,7541555,'fie',12.5,1),(873,7541571,7541555,'ier',12.5,1),(873,7541572,7541564,'vdi',33.333,3),(873,7541573,7541564,'dis',33.333,3),(873,7541574,7541564,'isk',33.333,3),(873,7541575,7541572,'nam',50,1),(873,7541576,7541572,'ame',50,1),(873,7541577,7541575,'typ',50,1),(873,7541578,7541575,'ype',50,1),(873,7541579,7541577,'dir',25,1),(873,7541580,7541577,'ire',25,1),(873,7541581,7541577,'rec',25,1),(873,7541582,7541577,'ect',25,1),(874,7541584,7541583,'naa',100,2),(874,7541585,7541584,'600',3.333,3),(874,7541586,7541584,'000',3.333,3),(874,7541587,7541584,'00c',3.333,3),(874,7541588,7541584,'0c2',3.333,3),(874,7541589,7541584,'c29',3.333,3),(874,7541590,7541584,'297',3.333,3),(874,7541591,7541584,'97f',3.333,3),(874,7541592,7541584,'7fe',3.333,3),(874,7541593,7541584,'fe4',3.333,3),(874,7541594,7541584,'e44',3.333,3),(874,7541595,7541584,'449',3.333,3),(874,7541596,7541584,'499',3.333,3),(874,7541597,7541584,'993',3.333,3),(874,7541598,7541584,'939',3.333,3),(874,7541599,7541584,'39f',3.333,3),(874,7541600,7541584,'9fa',3.333,3),(874,7541601,7541584,'fa1',3.333,3),(874,7541602,7541584,'a1a',3.333,3),(874,7541603,7541584,'1a2',3.333,3),(874,7541604,7541584,'a23',3.333,3),(874,7541605,7541584,'231',3.333,3),(874,7541606,7541584,'318',3.333,3),(874,7541607,7541584,'187',3.333,3),(874,7541608,7541584,'871',3.333,3),(874,7541609,7541584,'719',3.333,3),(874,7541610,7541584,'197',3.333,3),(874,7541611,7541584,'97d',3.333,3),(874,7541612,7541584,'7dc',3.333,3),(874,7541613,7541584,'dc0',3.333,3),(874,7541614,7541584,'c05',3.333,3),(874,7541615,7541585,'mon',100,1),(874,7541616,7541615,'201',50,1),(874,7541617,7541615,'013',50,1),(874,7541618,7541616,'adm',33.333,4),(874,7541619,7541616,'dmi',33.333,4),(874,7541620,7541616,'min',33.333,4),(874,7541621,7541618,'cap',16.667,1),(874,7541622,7541618,'apa',16.667,1),(874,7541623,7541618,'pac',16.667,1),(874,7541624,7541618,'aci',16.667,1),(874,7541625,7541618,'cit',16.667,1),(874,7541626,7541618,'ity',16.667,1),(874,7541627,7541621,'pat',50,1),(874,7541628,7541621,'ath',50,1),(874,7541629,7541627,'fre',14.286,1),(874,7541630,7541627,'ree',14.286,1),(874,7541631,7541627,'ees',14.286,1),(874,7541632,7541627,'esp',14.286,1),(874,7541633,7541627,'spa',14.286,1),(874,7541634,7541627,'pac',14.286,1),(874,7541635,7541627,'ace',14.286,1),(874,7541636,7541629,'dis',50,1),(874,7541637,7541629,'isk',50,1),(874,7541638,7541636,'ind',33.333,1),(874,7541639,7541636,'nde',33.333,1),(874,7541640,7541636,'dex',33.333,1),(874,7541641,7541638,'adm',8.333,1),(874,7541642,7541638,'dmi',8.333,1),(874,7541643,7541638,'min',8.333,1),(874,7541644,7541638,'ini',8.333,1),(874,7541645,7541638,'nis',8.333,1),(874,7541646,7541638,'ist',8.333,1),(874,7541647,7541638,'str',8.333,1),(874,7541648,7541638,'tra',8.333,1),(874,7541649,7541638,'rat',8.333,1),(874,7541650,7541638,'ati',8.333,1),(874,7541651,7541638,'tio',8.333,1),(874,7541652,7541638,'ion',8.333,1),(874,7541653,7541641,'sta',33.333,3),(874,7541654,7541641,'tat',33.333,3),(874,7541655,7541641,'ate',33.333,3),(874,7541656,7541653,'dis',16.667,4),(874,7541657,7541653,'isa',16.667,4),(874,7541658,7541653,'sab',16.667,4),(874,7541659,7541653,'abl',16.667,4),(874,7541660,7541653,'ble',16.667,4),(874,7541661,7541653,'led',16.667,4),(874,7541662,7541656,'cac',33.333,1),(874,7541663,7541656,'ach',33.333,1),(874,7541664,7541656,'che',33.333,1),(874,7541665,7541662,'mod',50,1),(874,7541666,7541662,'ode',50,1),(874,7541667,7541665,'wri',14.286,1),(874,7541668,7541665,'rit',14.286,1),(874,7541669,7541665,'ite',14.286,1),(874,7541670,7541665,'tet',14.286,1),(874,7541671,7541665,'eth',14.286,1),(874,7541672,7541665,'thr',14.286,1),(874,7541673,7541665,'hru',14.286,1),(874,7541674,7541667,'ope',11.111,2),(874,7541675,7541667,'per',11.111,2),(874,7541676,7541667,'era',11.111,2),(874,7541677,7541667,'rat',11.111,2),(874,7541678,7541667,'ati',11.111,2),(874,7541679,7541667,'tio',11.111,2),(874,7541680,7541667,'ion',11.111,2),(874,7541681,7541667,'ona',11.111,2),(874,7541682,7541667,'nal',11.111,2),(874,7541683,7541674,'mes',20,1),(874,7541684,7541674,'ess',20,1),(874,7541685,7541674,'ssa',20,1),(874,7541686,7541674,'sag',20,1),(874,7541687,7541674,'age',20,1),(874,7541688,7541683,'per',11.111,1),(874,7541689,7541683,'erf',11.111,1),(874,7541690,7541683,'rfo',11.111,1),(874,7541691,7541683,'for',11.111,1),(874,7541692,7541683,'orm',11.111,1),(874,7541693,7541683,'rma',11.111,1),(874,7541694,7541683,'man',11.111,1),(874,7541695,7541683,'anc',11.111,1),(874,7541696,7541683,'nce',11.111,1),(874,7541697,7541688,'ide',12.5,1),(874,7541698,7541688,'den',12.5,1),(874,7541699,7541688,'ent',12.5,1),(874,7541700,7541688,'nti',12.5,1),(874,7541701,7541688,'tif',12.5,1),(874,7541702,7541688,'ifi',12.5,1),(874,7541703,7541688,'fie',12.5,1),(874,7541704,7541688,'ier',12.5,1),(874,7541705,7541697,'vdi',33.333,3),(874,7541706,7541697,'dis',33.333,3),(874,7541707,7541697,'isk',33.333,3),(874,7541708,7541705,'nam',50,1),(874,7541709,7541705,'ame',50,1),(874,7541710,7541708,'typ',50,1),(874,7541711,7541708,'ype',50,1),(874,7541712,7541710,'dir',25,1),(874,7541713,7541710,'ire',25,1),(874,7541714,7541710,'rec',25,1),(874,7541715,7541710,'ect',25,1),(875,7541717,7541716,'naa',100,2),(875,7541718,7541717,'600',3.333,3),(875,7541719,7541717,'000',3.333,3),(875,7541720,7541717,'00c',3.333,3),(875,7541721,7541717,'0c2',3.333,3),(875,7541722,7541717,'c29',3.333,3),(875,7541723,7541717,'29b',3.333,3),(875,7541724,7541717,'9bf',3.333,3),(875,7541725,7541717,'bfc',3.333,3),(875,7541726,7541717,'fce',3.333,3),(875,7541727,7541717,'cef',3.333,3),(875,7541728,7541717,'efd',3.333,3),(875,7541729,7541717,'fdb',3.333,3),(875,7541730,7541717,'db0',3.333,3),(875,7541731,7541717,'b01',3.333,3),(875,7541732,7541717,'01d',3.333,3),(875,7541733,7541717,'1d7',3.333,3),(875,7541734,7541717,'d71',3.333,3),(875,7541735,7541717,'71a',3.333,3),(875,7541736,7541717,'1ac',3.333,3),(875,7541737,7541717,'acb',3.333,3),(875,7541738,7541717,'cb8',3.333,3),(875,7541739,7541717,'b80',3.333,3),(875,7541740,7541717,'809',3.333,3),(875,7541741,7541717,'090',3.333,3),(875,7541742,7541717,'90d',3.333,3),(875,7541743,7541717,'0dc',3.333,3),(875,7541744,7541717,'dc8',3.333,3),(875,7541745,7541717,'c8b',3.333,3),(875,7541746,7541717,'8b7',3.333,3),(875,7541747,7541717,'b7d',3.333,3),(875,7541748,7541718,'mon',100,1),(875,7541749,7541748,'201',50,1),(875,7541750,7541748,'013',50,1),(875,7541751,7541749,'adm',33.333,4),(875,7541752,7541749,'dmi',33.333,4),(875,7541753,7541749,'min',33.333,4),(875,7541754,7541751,'cap',16.667,1),(875,7541755,7541751,'apa',16.667,1),(875,7541756,7541751,'pac',16.667,1),(875,7541757,7541751,'aci',16.667,1),(875,7541758,7541751,'cit',16.667,1),(875,7541759,7541751,'ity',16.667,1),(875,7541760,7541754,'pat',50,1),(875,7541761,7541754,'ath',50,1),(875,7541762,7541760,'fre',14.286,1),(875,7541763,7541760,'ree',14.286,1),(875,7541764,7541760,'ees',14.286,1),(875,7541765,7541760,'esp',14.286,1),(875,7541766,7541760,'spa',14.286,1),(875,7541767,7541760,'pac',14.286,1),(875,7541768,7541760,'ace',14.286,1),(875,7541769,7541762,'dis',50,1),(875,7541770,7541762,'isk',50,1),(875,7541771,7541769,'ind',33.333,1),(875,7541772,7541769,'nde',33.333,1),(875,7541773,7541769,'dex',33.333,1),(875,7541774,7541771,'adm',8.333,1),(875,7541775,7541771,'dmi',8.333,1),(875,7541776,7541771,'min',8.333,1),(875,7541777,7541771,'ini',8.333,1),(875,7541778,7541771,'nis',8.333,1),(875,7541779,7541771,'ist',8.333,1),(875,7541780,7541771,'str',8.333,1),(875,7541781,7541771,'tra',8.333,1),(875,7541782,7541771,'rat',8.333,1),(875,7541783,7541771,'ati',8.333,1),(875,7541784,7541771,'tio',8.333,1),(875,7541785,7541771,'ion',8.333,1),(875,7541786,7541774,'sta',33.333,3),(875,7541787,7541774,'tat',33.333,3),(875,7541788,7541774,'ate',33.333,3),(875,7541789,7541786,'dis',16.667,4),(875,7541790,7541786,'isa',16.667,4),(875,7541791,7541786,'sab',16.667,4),(875,7541792,7541786,'abl',16.667,4),(875,7541793,7541786,'ble',16.667,4),(875,7541794,7541786,'led',16.667,4),(875,7541795,7541789,'cac',33.333,1),(875,7541796,7541789,'ach',33.333,1),(875,7541797,7541789,'che',33.333,1),(875,7541798,7541795,'mod',50,1),(875,7541799,7541795,'ode',50,1),(875,7541800,7541798,'wri',14.286,1),(875,7541801,7541798,'rit',14.286,1),(875,7541802,7541798,'ite',14.286,1),(875,7541803,7541798,'tet',14.286,1),(875,7541804,7541798,'eth',14.286,1),(875,7541805,7541798,'thr',14.286,1),(875,7541806,7541798,'hru',14.286,1),(875,7541807,7541800,'ope',11.111,2),(875,7541808,7541800,'per',11.111,2),(875,7541809,7541800,'era',11.111,2),(875,7541810,7541800,'rat',11.111,2),(875,7541811,7541800,'ati',11.111,2),(875,7541812,7541800,'tio',11.111,2),(875,7541813,7541800,'ion',11.111,2),(875,7541814,7541800,'ona',11.111,2),(875,7541815,7541800,'nal',11.111,2),(875,7541816,7541807,'mes',20,1),(875,7541817,7541807,'ess',20,1),(875,7541818,7541807,'ssa',20,1),(875,7541819,7541807,'sag',20,1),(875,7541820,7541807,'age',20,1),(875,7541821,7541816,'per',11.111,1),(875,7541822,7541816,'erf',11.111,1),(875,7541823,7541816,'rfo',11.111,1),(875,7541824,7541816,'for',11.111,1),(875,7541825,7541816,'orm',11.111,1),(875,7541826,7541816,'rma',11.111,1),(875,7541827,7541816,'man',11.111,1),(875,7541828,7541816,'anc',11.111,1),(875,7541829,7541816,'nce',11.111,1),(875,7541830,7541821,'ide',12.5,1),(875,7541831,7541821,'den',12.5,1),(875,7541832,7541821,'ent',12.5,1),(875,7541833,7541821,'nti',12.5,1),(875,7541834,7541821,'tif',12.5,1),(875,7541835,7541821,'ifi',12.5,1),(875,7541836,7541821,'fie',12.5,1),(875,7541837,7541821,'ier',12.5,1),(875,7541838,7541830,'vdi',33.333,3),(875,7541839,7541830,'dis',33.333,3),(875,7541840,7541830,'isk',33.333,3),(875,7541841,7541838,'nam',50,1),(875,7541842,7541838,'ame',50,1),(875,7541843,7541841,'typ',50,1),(875,7541844,7541841,'ype',50,1),(875,7541845,7541843,'dir',25,1),(875,7541846,7541843,'ire',25,1),(875,7541847,7541843,'rec',25,1),(875,7541848,7541843,'ect',25,1),(876,7541850,7541849,'naa',100,2),(876,7541851,7541850,'600',3.333,3),(876,7541852,7541850,'000',3.333,3),(876,7541853,7541850,'00c',3.333,3),(876,7541854,7541850,'0c2',3.333,3),(876,7541855,7541850,'c29',3.333,3),(876,7541856,7541850,'298',3.333,3),(876,7541857,7541850,'987',3.333,3),(876,7541858,7541850,'873',3.333,3),(876,7541859,7541850,'730',3.333,3),(876,7541860,7541850,'30a',3.333,3),(876,7541861,7541850,'0a9',3.333,3),(876,7541862,7541850,'a93',3.333,3),(876,7541863,7541850,'935',3.333,3),(876,7541864,7541850,'35e',3.333,3),(876,7541865,7541850,'5ef',3.333,3),(876,7541866,7541850,'ef2',3.333,3),(876,7541867,7541850,'f28',3.333,3),(876,7541868,7541850,'28f',3.333,3),(876,7541869,7541850,'8fb',3.333,3),(876,7541870,7541850,'fb3',3.333,3),(876,7541871,7541850,'b35',3.333,3),(876,7541872,7541850,'351',3.333,3),(876,7541873,7541850,'51d',3.333,3),(876,7541874,7541850,'1de',3.333,3),(876,7541875,7541850,'de7',3.333,3),(876,7541876,7541850,'e76',3.333,3),(876,7541877,7541850,'76d',3.333,3),(876,7541878,7541850,'6d3',3.333,3),(876,7541879,7541850,'d39',3.333,3),(876,7541880,7541850,'397',3.333,3),(876,7541881,7541851,'mon',100,1),(876,7541882,7541881,'201',50,1),(876,7541883,7541881,'013',50,1),(876,7541884,7541882,'adm',33.333,4),(876,7541885,7541882,'dmi',33.333,4),(876,7541886,7541882,'min',33.333,4),(876,7541887,7541884,'cap',16.667,1),(876,7541888,7541884,'apa',16.667,1),(876,7541889,7541884,'pac',16.667,1),(876,7541890,7541884,'aci',16.667,1),(876,7541891,7541884,'cit',16.667,1),(876,7541892,7541884,'ity',16.667,1),(876,7541893,7541887,'pat',50,1),(876,7541894,7541887,'ath',50,1),(876,7541895,7541893,'fre',14.286,1),(876,7541896,7541893,'ree',14.286,1),(876,7541897,7541893,'ees',14.286,1),(876,7541898,7541893,'esp',14.286,1),(876,7541899,7541893,'spa',14.286,1),(876,7541900,7541893,'pac',14.286,1),(876,7541901,7541893,'ace',14.286,1),(876,7541902,7541895,'dis',50,1),(876,7541903,7541895,'isk',50,1),(876,7541904,7541902,'ind',33.333,1),(876,7541905,7541902,'nde',33.333,1),(876,7541906,7541902,'dex',33.333,1),(876,7541907,7541904,'adm',8.333,1),(876,7541908,7541904,'dmi',8.333,1),(876,7541909,7541904,'min',8.333,1),(876,7541910,7541904,'ini',8.333,1),(876,7541911,7541904,'nis',8.333,1),(876,7541912,7541904,'ist',8.333,1),(876,7541913,7541904,'str',8.333,1),(876,7541914,7541904,'tra',8.333,1),(876,7541915,7541904,'rat',8.333,1),(876,7541916,7541904,'ati',8.333,1),(876,7541917,7541904,'tio',8.333,1),(876,7541918,7541904,'ion',8.333,1),(876,7541919,7541907,'sta',33.333,3),(876,7541920,7541907,'tat',33.333,3),(876,7541921,7541907,'ate',33.333,3),(876,7541922,7541919,'dis',16.667,4),(876,7541923,7541919,'isa',16.667,4),(876,7541924,7541919,'sab',16.667,4),(876,7541925,7541919,'abl',16.667,4),(876,7541926,7541919,'ble',16.667,4),(876,7541927,7541919,'led',16.667,4),(876,7541928,7541922,'cac',33.333,1),(876,7541929,7541922,'ach',33.333,1),(876,7541930,7541922,'che',33.333,1),(876,7541931,7541928,'mod',50,1),(876,7541932,7541928,'ode',50,1),(876,7541933,7541931,'wri',14.286,1),(876,7541934,7541931,'rit',14.286,1),(876,7541935,7541931,'ite',14.286,1),(876,7541936,7541931,'tet',14.286,1),(876,7541937,7541931,'eth',14.286,1),(876,7541938,7541931,'thr',14.286,1),(876,7541939,7541931,'hru',14.286,1),(876,7541940,7541933,'ope',11.111,2),(876,7541941,7541933,'per',11.111,2),(876,7541942,7541933,'era',11.111,2),(876,7541943,7541933,'rat',11.111,2),(876,7541944,7541933,'ati',11.111,2),(876,7541945,7541933,'tio',11.111,2),(876,7541946,7541933,'ion',11.111,2),(876,7541947,7541933,'ona',11.111,2),(876,7541948,7541933,'nal',11.111,2),(876,7541949,7541940,'mes',20,1),(876,7541950,7541940,'ess',20,1),(876,7541951,7541940,'ssa',20,1),(876,7541952,7541940,'sag',20,1),(876,7541953,7541940,'age',20,1),(876,7541954,7541949,'per',11.111,1),(876,7541955,7541949,'erf',11.111,1),(876,7541956,7541949,'rfo',11.111,1),(876,7541957,7541949,'for',11.111,1),(876,7541958,7541949,'orm',11.111,1),(876,7541959,7541949,'rma',11.111,1),(876,7541960,7541949,'man',11.111,1),(876,7541961,7541949,'anc',11.111,1),(876,7541962,7541949,'nce',11.111,1),(876,7541963,7541954,'ide',12.5,1),(876,7541964,7541954,'den',12.5,1),(876,7541965,7541954,'ent',12.5,1),(876,7541966,7541954,'nti',12.5,1),(876,7541967,7541954,'tif',12.5,1),(876,7541968,7541954,'ifi',12.5,1),(876,7541969,7541954,'fie',12.5,1),(876,7541970,7541954,'ier',12.5,1),(876,7541971,7541963,'vdi',33.333,3),(876,7541972,7541963,'dis',33.333,3),(876,7541973,7541963,'isk',33.333,3),(876,7541974,7541971,'nam',50,1),(876,7541975,7541971,'ame',50,1),(876,7541976,7541974,'typ',50,1),(876,7541977,7541974,'ype',50,1),(876,7541978,7541976,'dir',25,1),(876,7541979,7541976,'ire',25,1),(876,7541980,7541976,'rec',25,1),(876,7541981,7541976,'ect',25,1),(877,7541983,7541982,'naa',100,2),(877,7541984,7541983,'600',3.333,3),(877,7541985,7541983,'000',3.333,3),(877,7541986,7541983,'00c',3.333,3),(877,7541987,7541983,'0c2',3.333,3),(877,7541988,7541983,'c29',3.333,3),(877,7541989,7541983,'29e',3.333,3),(877,7541990,7541983,'9e9',3.333,3),(877,7541991,7541983,'e96',3.333,3),(877,7541992,7541983,'961',3.333,3),(877,7541993,7541983,'616',3.333,3),(877,7541994,7541983,'166',3.333,3),(877,7541995,7541983,'668',3.333,3),(877,7541996,7541983,'689',3.333,3),(877,7541997,7541983,'89b',3.333,3),(877,7541998,7541983,'9b1',3.333,3),(877,7541999,7541983,'b1a',3.333,3),(877,7542000,7541983,'1a5',3.333,3),(877,7542001,7541983,'a50',3.333,3),(877,7542002,7541983,'503',3.333,3),(877,7542003,7541983,'034',3.333,3),(877,7542004,7541983,'340',3.333,3),(877,7542005,7541983,'40c',3.333,3),(877,7542006,7541983,'0c8',3.333,3),(877,7542007,7541983,'c81',3.333,3),(877,7542008,7541983,'81f',3.333,3),(877,7542009,7541983,'1f7',3.333,3),(877,7542010,7541983,'f7f',3.333,3),(877,7542011,7541983,'7f9',3.333,3),(877,7542012,7541983,'f96',3.333,3),(877,7542013,7541983,'96c',3.333,3),(877,7542014,7541984,'mon',100,1),(877,7542015,7542014,'201',50,1),(877,7542016,7542014,'013',50,1),(877,7542017,7542015,'adm',33.333,4),(877,7542018,7542015,'dmi',33.333,4),(877,7542019,7542015,'min',33.333,4),(877,7542020,7542017,'cap',16.667,1),(877,7542021,7542017,'apa',16.667,1),(877,7542022,7542017,'pac',16.667,1),(877,7542023,7542017,'aci',16.667,1),(877,7542024,7542017,'cit',16.667,1),(877,7542025,7542017,'ity',16.667,1),(877,7542026,7542020,'pat',50,1),(877,7542027,7542020,'ath',50,1),(877,7542028,7542026,'fre',14.286,1),(877,7542029,7542026,'ree',14.286,1),(877,7542030,7542026,'ees',14.286,1),(877,7542031,7542026,'esp',14.286,1),(877,7542032,7542026,'spa',14.286,1),(877,7542033,7542026,'pac',14.286,1),(877,7542034,7542026,'ace',14.286,1),(877,7542035,7542028,'dis',50,1),(877,7542036,7542028,'isk',50,1),(877,7542037,7542035,'ind',33.333,1),(877,7542038,7542035,'nde',33.333,1),(877,7542039,7542035,'dex',33.333,1),(877,7542040,7542037,'adm',8.333,1),(877,7542041,7542037,'dmi',8.333,1),(877,7542042,7542037,'min',8.333,1),(877,7542043,7542037,'ini',8.333,1),(877,7542044,7542037,'nis',8.333,1),(877,7542045,7542037,'ist',8.333,1),(877,7542046,7542037,'str',8.333,1),(877,7542047,7542037,'tra',8.333,1),(877,7542048,7542037,'rat',8.333,1),(877,7542049,7542037,'ati',8.333,1),(877,7542050,7542037,'tio',8.333,1),(877,7542051,7542037,'ion',8.333,1),(877,7542052,7542040,'sta',33.333,3),(877,7542053,7542040,'tat',33.333,3),(877,7542054,7542040,'ate',33.333,3),(877,7542055,7542052,'dis',16.667,4),(877,7542056,7542052,'isa',16.667,4),(877,7542057,7542052,'sab',16.667,4),(877,7542058,7542052,'abl',16.667,4),(877,7542059,7542052,'ble',16.667,4),(877,7542060,7542052,'led',16.667,4),(877,7542061,7542055,'cac',33.333,1),(877,7542062,7542055,'ach',33.333,1),(877,7542063,7542055,'che',33.333,1),(877,7542064,7542061,'mod',50,1),(877,7542065,7542061,'ode',50,1),(877,7542066,7542064,'wri',14.286,1),(877,7542067,7542064,'rit',14.286,1),(877,7542068,7542064,'ite',14.286,1),(877,7542069,7542064,'tet',14.286,1),(877,7542070,7542064,'eth',14.286,1),(877,7542071,7542064,'thr',14.286,1),(877,7542072,7542064,'hru',14.286,1),(877,7542073,7542066,'ope',11.111,2),(877,7542074,7542066,'per',11.111,2),(877,7542075,7542066,'era',11.111,2),(877,7542076,7542066,'rat',11.111,2),(877,7542077,7542066,'ati',11.111,2),(877,7542078,7542066,'tio',11.111,2),(877,7542079,7542066,'ion',11.111,2),(877,7542080,7542066,'ona',11.111,2),(877,7542081,7542066,'nal',11.111,2),(877,7542082,7542073,'mes',20,1),(877,7542083,7542073,'ess',20,1),(877,7542084,7542073,'ssa',20,1),(877,7542085,7542073,'sag',20,1),(877,7542086,7542073,'age',20,1),(877,7542087,7542082,'per',11.111,1),(877,7542088,7542082,'erf',11.111,1),(877,7542089,7542082,'rfo',11.111,1),(877,7542090,7542082,'for',11.111,1),(877,7542091,7542082,'orm',11.111,1),(877,7542092,7542082,'rma',11.111,1),(877,7542093,7542082,'man',11.111,1),(877,7542094,7542082,'anc',11.111,1),(877,7542095,7542082,'nce',11.111,1),(877,7542096,7542087,'ide',12.5,1),(877,7542097,7542087,'den',12.5,1),(877,7542098,7542087,'ent',12.5,1),(877,7542099,7542087,'nti',12.5,1),(877,7542100,7542087,'tif',12.5,1),(877,7542101,7542087,'ifi',12.5,1),(877,7542102,7542087,'fie',12.5,1),(877,7542103,7542087,'ier',12.5,1),(877,7542104,7542096,'vdi',33.333,3),(877,7542105,7542096,'dis',33.333,3),(877,7542106,7542096,'isk',33.333,3),(877,7542107,7542104,'nam',50,1),(877,7542108,7542104,'ame',50,1),(877,7542109,7542107,'typ',50,1),(877,7542110,7542107,'ype',50,1),(877,7542111,7542109,'dir',25,1),(877,7542112,7542109,'ire',25,1),(877,7542113,7542109,'rec',25,1),(877,7542114,7542109,'ect',25,1),(878,7542116,7542115,'naa',100,2),(878,7542117,7542116,'600',3.333,3),(878,7542118,7542116,'000',3.333,3),(878,7542119,7542116,'00c',3.333,3),(878,7542120,7542116,'0c2',3.333,3),(878,7542121,7542116,'c29',3.333,3),(878,7542122,7542116,'296',3.333,3),(878,7542123,7542116,'966',3.333,3),(878,7542124,7542116,'66f',3.333,3),(878,7542125,7542116,'6f0',3.333,3),(878,7542126,7542116,'f0a',3.333,3),(878,7542127,7542116,'0ac',3.333,3),(878,7542128,7542116,'acd',3.333,3),(878,7542129,7542116,'cd1',3.333,3),(878,7542130,7542116,'d1e',3.333,3),(878,7542131,7542116,'1e9',3.333,3),(878,7542132,7542116,'e99',3.333,3),(878,7542133,7542116,'999',3.333,3),(878,7542134,7542116,'998',3.333,3),(878,7542135,7542116,'98e',3.333,3),(878,7542136,7542116,'8ec',3.333,3),(878,7542137,7542116,'ecb',3.333,3),(878,7542138,7542116,'cb9',3.333,3),(878,7542139,7542116,'b9c',3.333,3),(878,7542140,7542116,'9c2',3.333,3),(878,7542141,7542116,'c25',3.333,3),(878,7542142,7542116,'25b',3.333,3),(878,7542143,7542116,'5b8',3.333,3),(878,7542144,7542116,'b8c',3.333,3),(878,7542145,7542116,'8c2',3.333,3),(878,7542146,7542116,'c2a',3.333,3),(878,7542147,7542117,'mon',100,1),(878,7542148,7542147,'201',50,1),(878,7542149,7542147,'013',50,1),(878,7542150,7542148,'adm',33.333,4),(878,7542151,7542148,'dmi',33.333,4),(878,7542152,7542148,'min',33.333,4),(878,7542153,7542150,'cap',16.667,1),(878,7542154,7542150,'apa',16.667,1),(878,7542155,7542150,'pac',16.667,1),(878,7542156,7542150,'aci',16.667,1),(878,7542157,7542150,'cit',16.667,1),(878,7542158,7542150,'ity',16.667,1),(878,7542159,7542153,'pat',50,1),(878,7542160,7542153,'ath',50,1),(878,7542161,7542159,'fre',14.286,1),(878,7542162,7542159,'ree',14.286,1),(878,7542163,7542159,'ees',14.286,1),(878,7542164,7542159,'esp',14.286,1),(878,7542165,7542159,'spa',14.286,1),(878,7542166,7542159,'pac',14.286,1),(878,7542167,7542159,'ace',14.286,1),(878,7542168,7542161,'dis',50,1),(878,7542169,7542161,'isk',50,1),(878,7542170,7542168,'ind',33.333,1),(878,7542171,7542168,'nde',33.333,1),(878,7542172,7542168,'dex',33.333,1),(878,7542173,7542170,'adm',8.333,1),(878,7542174,7542170,'dmi',8.333,1),(878,7542175,7542170,'min',8.333,1),(878,7542176,7542170,'ini',8.333,1),(878,7542177,7542170,'nis',8.333,1),(878,7542178,7542170,'ist',8.333,1),(878,7542179,7542170,'str',8.333,1),(878,7542180,7542170,'tra',8.333,1),(878,7542181,7542170,'rat',8.333,1),(878,7542182,7542170,'ati',8.333,1),(878,7542183,7542170,'tio',8.333,1),(878,7542184,7542170,'ion',8.333,1),(878,7542185,7542173,'sta',33.333,3),(878,7542186,7542173,'tat',33.333,3),(878,7542187,7542173,'ate',33.333,3),(878,7542188,7542185,'dis',16.667,4),(878,7542189,7542185,'isa',16.667,4),(878,7542190,7542185,'sab',16.667,4),(878,7542191,7542185,'abl',16.667,4),(878,7542192,7542185,'ble',16.667,4),(878,7542193,7542185,'led',16.667,4),(878,7542194,7542188,'cac',33.333,1),(878,7542195,7542188,'ach',33.333,1),(878,7542196,7542188,'che',33.333,1),(878,7542197,7542194,'mod',50,1),(878,7542198,7542194,'ode',50,1),(878,7542199,7542197,'wri',14.286,1),(878,7542200,7542197,'rit',14.286,1),(878,7542201,7542197,'ite',14.286,1),(878,7542202,7542197,'tet',14.286,1),(878,7542203,7542197,'eth',14.286,1),(878,7542204,7542197,'thr',14.286,1),(878,7542205,7542197,'hru',14.286,1),(878,7542206,7542199,'ope',11.111,2),(878,7542207,7542199,'per',11.111,2),(878,7542208,7542199,'era',11.111,2),(878,7542209,7542199,'rat',11.111,2),(878,7542210,7542199,'ati',11.111,2),(878,7542211,7542199,'tio',11.111,2),(878,7542212,7542199,'ion',11.111,2),(878,7542213,7542199,'ona',11.111,2),(878,7542214,7542199,'nal',11.111,2),(878,7542215,7542206,'mes',20,1),(878,7542216,7542206,'ess',20,1),(878,7542217,7542206,'ssa',20,1),(878,7542218,7542206,'sag',20,1),(878,7542219,7542206,'age',20,1),(878,7542220,7542215,'per',11.111,1),(878,7542221,7542215,'erf',11.111,1),(878,7542222,7542215,'rfo',11.111,1),(878,7542223,7542215,'for',11.111,1),(878,7542224,7542215,'orm',11.111,1),(878,7542225,7542215,'rma',11.111,1),(878,7542226,7542215,'man',11.111,1),(878,7542227,7542215,'anc',11.111,1),(878,7542228,7542215,'nce',11.111,1),(878,7542229,7542220,'ide',12.5,1),(878,7542230,7542220,'den',12.5,1),(878,7542231,7542220,'ent',12.5,1),(878,7542232,7542220,'nti',12.5,1),(878,7542233,7542220,'tif',12.5,1),(878,7542234,7542220,'ifi',12.5,1),(878,7542235,7542220,'fie',12.5,1),(878,7542236,7542220,'ier',12.5,1),(878,7542237,7542229,'vdi',33.333,3),(878,7542238,7542229,'dis',33.333,3),(878,7542239,7542229,'isk',33.333,3),(878,7542240,7542237,'nam',50,1),(878,7542241,7542237,'ame',50,1),(878,7542242,7542240,'typ',50,1),(878,7542243,7542240,'ype',50,1),(878,7542244,7542242,'dir',25,1),(878,7542245,7542242,'ire',25,1),(878,7542246,7542242,'rec',25,1),(878,7542247,7542242,'ect',25,1),(879,7542249,7542248,'naa',100,2),(879,7542250,7542249,'600',3.333,3),(879,7542251,7542249,'000',3.333,3),(879,7542252,7542249,'00c',3.333,3),(879,7542253,7542249,'0c2',3.333,3),(879,7542254,7542249,'c29',3.333,3),(879,7542255,7542249,'295',3.333,3),(879,7542256,7542249,'957',3.333,3),(879,7542257,7542249,'570',3.333,3),(879,7542258,7542249,'705',3.333,3),(879,7542259,7542249,'057',3.333,3),(879,7542260,7542249,'57e',3.333,3),(879,7542261,7542249,'7ea',3.333,3),(879,7542262,7542249,'eac',3.333,3),(879,7542263,7542249,'ac0',3.333,3),(879,7542264,7542249,'c03',3.333,3),(879,7542265,7542249,'038',3.333,3),(879,7542266,7542249,'38b',3.333,3),(879,7542267,7542249,'8b4',3.333,3),(879,7542268,7542249,'b48',3.333,3),(879,7542269,7542249,'488',3.333,3),(879,7542270,7542249,'882',3.333,3),(879,7542271,7542249,'827',3.333,3),(879,7542272,7542249,'27b',3.333,3),(879,7542273,7542249,'7bc',3.333,3),(879,7542274,7542249,'bc4',3.333,3),(879,7542275,7542249,'c4b',3.333,3),(879,7542276,7542249,'4b8',3.333,3),(879,7542277,7542249,'b87',3.333,3),(879,7542278,7542249,'879',3.333,3),(879,7542279,7542249,'794',3.333,3),(879,7542280,7542250,'mon',100,1),(879,7542281,7542280,'201',50,1),(879,7542282,7542280,'013',50,1),(879,7542283,7542281,'adm',33.333,4),(879,7542284,7542281,'dmi',33.333,4),(879,7542285,7542281,'min',33.333,4),(879,7542286,7542283,'cap',16.667,1),(879,7542287,7542283,'apa',16.667,1),(879,7542288,7542283,'pac',16.667,1),(879,7542289,7542283,'aci',16.667,1),(879,7542290,7542283,'cit',16.667,1),(879,7542291,7542283,'ity',16.667,1),(879,7542292,7542286,'pat',50,1),(879,7542293,7542286,'ath',50,1),(879,7542294,7542292,'fre',14.286,1),(879,7542295,7542292,'ree',14.286,1),(879,7542296,7542292,'ees',14.286,1),(879,7542297,7542292,'esp',14.286,1),(879,7542298,7542292,'spa',14.286,1),(879,7542299,7542292,'pac',14.286,1),(879,7542300,7542292,'ace',14.286,1),(879,7542301,7542294,'dis',50,1),(879,7542302,7542294,'isk',50,1),(879,7542303,7542301,'ind',33.333,1),(879,7542304,7542301,'nde',33.333,1),(879,7542305,7542301,'dex',33.333,1),(879,7542306,7542303,'adm',8.333,1),(879,7542307,7542303,'dmi',8.333,1),(879,7542308,7542303,'min',8.333,1),(879,7542309,7542303,'ini',8.333,1),(879,7542310,7542303,'nis',8.333,1),(879,7542311,7542303,'ist',8.333,1),(879,7542312,7542303,'str',8.333,1),(879,7542313,7542303,'tra',8.333,1),(879,7542314,7542303,'rat',8.333,1),(879,7542315,7542303,'ati',8.333,1),(879,7542316,7542303,'tio',8.333,1),(879,7542317,7542303,'ion',8.333,1),(879,7542318,7542306,'sta',33.333,3),(879,7542319,7542306,'tat',33.333,3),(879,7542320,7542306,'ate',33.333,3),(879,7542321,7542318,'dis',16.667,4),(879,7542322,7542318,'isa',16.667,4),(879,7542323,7542318,'sab',16.667,4),(879,7542324,7542318,'abl',16.667,4),(879,7542325,7542318,'ble',16.667,4),(879,7542326,7542318,'led',16.667,4),(879,7542327,7542321,'cac',33.333,1),(879,7542328,7542321,'ach',33.333,1),(879,7542329,7542321,'che',33.333,1),(879,7542330,7542327,'mod',50,1),(879,7542331,7542327,'ode',50,1),(879,7542332,7542330,'wri',14.286,1),(879,7542333,7542330,'rit',14.286,1),(879,7542334,7542330,'ite',14.286,1),(879,7542335,7542330,'tet',14.286,1),(879,7542336,7542330,'eth',14.286,1),(879,7542337,7542330,'thr',14.286,1),(879,7542338,7542330,'hru',14.286,1),(879,7542339,7542332,'ope',11.111,2),(879,7542340,7542332,'per',11.111,2),(879,7542341,7542332,'era',11.111,2),(879,7542342,7542332,'rat',11.111,2),(879,7542343,7542332,'ati',11.111,2),(879,7542344,7542332,'tio',11.111,2),(879,7542345,7542332,'ion',11.111,2),(879,7542346,7542332,'ona',11.111,2),(879,7542347,7542332,'nal',11.111,2),(879,7542348,7542339,'mes',20,1),(879,7542349,7542339,'ess',20,1),(879,7542350,7542339,'ssa',20,1),(879,7542351,7542339,'sag',20,1),(879,7542352,7542339,'age',20,1),(879,7542353,7542348,'per',11.111,1),(879,7542354,7542348,'erf',11.111,1),(879,7542355,7542348,'rfo',11.111,1),(879,7542356,7542348,'for',11.111,1),(879,7542357,7542348,'orm',11.111,1),(879,7542358,7542348,'rma',11.111,1),(879,7542359,7542348,'man',11.111,1),(879,7542360,7542348,'anc',11.111,1),(879,7542361,7542348,'nce',11.111,1),(879,7542362,7542353,'ide',12.5,1),(879,7542363,7542353,'den',12.5,1),(879,7542364,7542353,'ent',12.5,1),(879,7542365,7542353,'nti',12.5,1),(879,7542366,7542353,'tif',12.5,1),(879,7542367,7542353,'ifi',12.5,1),(879,7542368,7542353,'fie',12.5,1),(879,7542369,7542353,'ier',12.5,1),(879,7542370,7542362,'vdi',33.333,3),(879,7542371,7542362,'dis',33.333,3),(879,7542372,7542362,'isk',33.333,3),(879,7542373,7542370,'nam',50,1),(879,7542374,7542370,'ame',50,1),(879,7542375,7542373,'typ',50,1),(879,7542376,7542373,'ype',50,1),(879,7542377,7542375,'dir',25,1),(879,7542378,7542375,'ire',25,1),(879,7542379,7542375,'rec',25,1),(879,7542380,7542375,'ect',25,1),(880,7542382,7542381,'naa',100,2),(880,7542383,7542382,'600',3.333,3),(880,7542384,7542382,'000',3.333,3),(880,7542385,7542382,'00c',3.333,3),(880,7542386,7542382,'0c2',3.333,3),(880,7542387,7542382,'c29',3.333,3),(880,7542388,7542382,'29e',3.333,3),(880,7542389,7542382,'9ed',3.333,3),(880,7542390,7542382,'ed5',3.333,3),(880,7542391,7542382,'d56',3.333,3),(880,7542392,7542382,'56b',3.333,3),(880,7542393,7542382,'6b7',3.333,3),(880,7542394,7542382,'b7b',3.333,3),(880,7542395,7542382,'7be',3.333,3),(880,7542396,7542382,'bee',3.333,3),(880,7542397,7542382,'eef',3.333,3),(880,7542398,7542382,'ef1',3.333,3),(880,7542399,7542382,'f13',3.333,3),(880,7542400,7542382,'13a',3.333,3),(880,7542401,7542382,'3a5',3.333,3),(880,7542402,7542382,'a5c',3.333,3),(880,7542403,7542382,'5cf',3.333,3),(880,7542404,7542382,'cf7',3.333,3),(880,7542405,7542382,'f7f',3.333,3),(880,7542406,7542382,'7f3',3.333,3),(880,7542407,7542382,'f35',3.333,3),(880,7542408,7542382,'350',3.333,3),(880,7542409,7542382,'50a',3.333,3),(880,7542410,7542382,'0af',3.333,3),(880,7542411,7542382,'af5',3.333,3),(880,7542412,7542382,'f50',3.333,3),(880,7542413,7542383,'mon',100,1),(880,7542414,7542413,'201',50,1),(880,7542415,7542413,'013',50,1),(880,7542416,7542414,'adm',33.333,4),(880,7542417,7542414,'dmi',33.333,4),(880,7542418,7542414,'min',33.333,4),(880,7542419,7542416,'cap',16.667,1),(880,7542420,7542416,'apa',16.667,1),(880,7542421,7542416,'pac',16.667,1),(880,7542422,7542416,'aci',16.667,1),(880,7542423,7542416,'cit',16.667,1),(880,7542424,7542416,'ity',16.667,1),(880,7542425,7542419,'pat',50,1),(880,7542426,7542419,'ath',50,1),(880,7542427,7542425,'fre',14.286,1),(880,7542428,7542425,'ree',14.286,1),(880,7542429,7542425,'ees',14.286,1),(880,7542430,7542425,'esp',14.286,1),(880,7542431,7542425,'spa',14.286,1),(880,7542432,7542425,'pac',14.286,1),(880,7542433,7542425,'ace',14.286,1),(880,7542434,7542427,'dis',50,1),(880,7542435,7542427,'isk',50,1),(880,7542436,7542434,'ind',33.333,1),(880,7542437,7542434,'nde',33.333,1),(880,7542438,7542434,'dex',33.333,1),(880,7542439,7542436,'adm',8.333,1),(880,7542440,7542436,'dmi',8.333,1),(880,7542441,7542436,'min',8.333,1),(880,7542442,7542436,'ini',8.333,1),(880,7542443,7542436,'nis',8.333,1),(880,7542444,7542436,'ist',8.333,1),(880,7542445,7542436,'str',8.333,1),(880,7542446,7542436,'tra',8.333,1),(880,7542447,7542436,'rat',8.333,1),(880,7542448,7542436,'ati',8.333,1),(880,7542449,7542436,'tio',8.333,1),(880,7542450,7542436,'ion',8.333,1),(880,7542451,7542439,'sta',33.333,3),(880,7542452,7542439,'tat',33.333,3),(880,7542453,7542439,'ate',33.333,3),(880,7542454,7542451,'dis',16.667,4),(880,7542455,7542451,'isa',16.667,4),(880,7542456,7542451,'sab',16.667,4),(880,7542457,7542451,'abl',16.667,4),(880,7542458,7542451,'ble',16.667,4),(880,7542459,7542451,'led',16.667,4),(880,7542460,7542454,'cac',33.333,1),(880,7542461,7542454,'ach',33.333,1),(880,7542462,7542454,'che',33.333,1),(880,7542463,7542460,'mod',50,1),(880,7542464,7542460,'ode',50,1),(880,7542465,7542463,'wri',14.286,1),(880,7542466,7542463,'rit',14.286,1),(880,7542467,7542463,'ite',14.286,1),(880,7542468,7542463,'tet',14.286,1),(880,7542469,7542463,'eth',14.286,1),(880,7542470,7542463,'thr',14.286,1),(880,7542471,7542463,'hru',14.286,1),(880,7542472,7542465,'ope',11.111,2),(880,7542473,7542465,'per',11.111,2),(880,7542474,7542465,'era',11.111,2),(880,7542475,7542465,'rat',11.111,2),(880,7542476,7542465,'ati',11.111,2),(880,7542477,7542465,'tio',11.111,2),(880,7542478,7542465,'ion',11.111,2),(880,7542479,7542465,'ona',11.111,2),(880,7542480,7542465,'nal',11.111,2),(880,7542481,7542472,'mes',20,1),(880,7542482,7542472,'ess',20,1),(880,7542483,7542472,'ssa',20,1),(880,7542484,7542472,'sag',20,1),(880,7542485,7542472,'age',20,1),(880,7542486,7542481,'per',11.111,1),(880,7542487,7542481,'erf',11.111,1),(880,7542488,7542481,'rfo',11.111,1),(880,7542489,7542481,'for',11.111,1),(880,7542490,7542481,'orm',11.111,1),(880,7542491,7542481,'rma',11.111,1),(880,7542492,7542481,'man',11.111,1),(880,7542493,7542481,'anc',11.111,1),(880,7542494,7542481,'nce',11.111,1),(880,7542495,7542486,'ide',12.5,1),(880,7542496,7542486,'den',12.5,1),(880,7542497,7542486,'ent',12.5,1),(880,7542498,7542486,'nti',12.5,1),(880,7542499,7542486,'tif',12.5,1),(880,7542500,7542486,'ifi',12.5,1),(880,7542501,7542486,'fie',12.5,1),(880,7542502,7542486,'ier',12.5,1),(880,7542503,7542495,'vdi',33.333,3),(880,7542504,7542495,'dis',33.333,3),(880,7542505,7542495,'isk',33.333,3),(880,7542506,7542503,'nam',50,1),(880,7542507,7542503,'ame',50,1),(880,7542508,7542506,'typ',50,1),(880,7542509,7542506,'ype',50,1),(880,7542510,7542508,'dir',25,1),(880,7542511,7542508,'ire',25,1),(880,7542512,7542508,'rec',25,1),(880,7542513,7542508,'ect',25,1),(881,7542515,7542514,'naa',100,2),(881,7542516,7542515,'600',3.333,3),(881,7542517,7542515,'000',3.333,3),(881,7542518,7542515,'00c',3.333,3),(881,7542519,7542515,'0c2',3.333,3),(881,7542520,7542515,'c29',3.333,3),(881,7542521,7542515,'295',3.333,3),(881,7542522,7542515,'95a',3.333,3),(881,7542523,7542515,'5a5',3.333,3),(881,7542524,7542515,'a58',3.333,3),(881,7542525,7542515,'581',3.333,3),(881,7542526,7542515,'819',3.333,3),(881,7542527,7542515,'192',3.333,3),(881,7542528,7542515,'929',3.333,3),(881,7542529,7542515,'295',3.333,3),(881,7542530,7542515,'955',3.333,3),(881,7542531,7542515,'551',3.333,3),(881,7542532,7542515,'510',3.333,3),(881,7542533,7542515,'10f',3.333,3),(881,7542534,7542515,'0f6',3.333,3),(881,7542535,7542515,'f68',3.333,3),(881,7542536,7542515,'68c',3.333,3),(881,7542537,7542515,'8c2',3.333,3),(881,7542538,7542515,'c2c',3.333,3),(881,7542539,7542515,'2c2',3.333,3),(881,7542540,7542515,'c2f',3.333,3),(881,7542541,7542515,'2f3',3.333,3),(881,7542542,7542515,'f39',3.333,3),(881,7542543,7542515,'395',3.333,3),(881,7542544,7542515,'95d',3.333,3),(881,7542545,7542515,'5d1',3.333,3),(881,7542546,7542516,'mon',100,1),(881,7542547,7542546,'201',50,1),(881,7542548,7542546,'013',50,1),(881,7542549,7542547,'adm',33.333,4),(881,7542550,7542547,'dmi',33.333,4),(881,7542551,7542547,'min',33.333,4),(881,7542552,7542549,'cap',16.667,1),(881,7542553,7542549,'apa',16.667,1),(881,7542554,7542549,'pac',16.667,1),(881,7542555,7542549,'aci',16.667,1),(881,7542556,7542549,'cit',16.667,1),(881,7542557,7542549,'ity',16.667,1),(881,7542558,7542552,'pat',50,1),(881,7542559,7542552,'ath',50,1),(881,7542560,7542558,'fre',14.286,1),(881,7542561,7542558,'ree',14.286,1),(881,7542562,7542558,'ees',14.286,1),(881,7542563,7542558,'esp',14.286,1),(881,7542564,7542558,'spa',14.286,1),(881,7542565,7542558,'pac',14.286,1),(881,7542566,7542558,'ace',14.286,1),(881,7542567,7542560,'dis',50,1),(881,7542568,7542560,'isk',50,1),(881,7542569,7542567,'ind',33.333,1),(881,7542570,7542567,'nde',33.333,1),(881,7542571,7542567,'dex',33.333,1),(881,7542572,7542569,'adm',8.333,1),(881,7542573,7542569,'dmi',8.333,1),(881,7542574,7542569,'min',8.333,1),(881,7542575,7542569,'ini',8.333,1),(881,7542576,7542569,'nis',8.333,1),(881,7542577,7542569,'ist',8.333,1),(881,7542578,7542569,'str',8.333,1),(881,7542579,7542569,'tra',8.333,1),(881,7542580,7542569,'rat',8.333,1),(881,7542581,7542569,'ati',8.333,1),(881,7542582,7542569,'tio',8.333,1),(881,7542583,7542569,'ion',8.333,1),(881,7542584,7542572,'sta',33.333,3),(881,7542585,7542572,'tat',33.333,3),(881,7542586,7542572,'ate',33.333,3),(881,7542587,7542584,'dis',16.667,4),(881,7542588,7542584,'isa',16.667,4),(881,7542589,7542584,'sab',16.667,4),(881,7542590,7542584,'abl',16.667,4),(881,7542591,7542584,'ble',16.667,4),(881,7542592,7542584,'led',16.667,4),(881,7542593,7542587,'cac',33.333,1),(881,7542594,7542587,'ach',33.333,1),(881,7542595,7542587,'che',33.333,1),(881,7542596,7542593,'mod',50,1),(881,7542597,7542593,'ode',50,1),(881,7542598,7542596,'wri',14.286,1),(881,7542599,7542596,'rit',14.286,1),(881,7542600,7542596,'ite',14.286,1),(881,7542601,7542596,'tet',14.286,1),(881,7542602,7542596,'eth',14.286,1),(881,7542603,7542596,'thr',14.286,1),(881,7542604,7542596,'hru',14.286,1),(881,7542605,7542598,'ope',11.111,2),(881,7542606,7542598,'per',11.111,2),(881,7542607,7542598,'era',11.111,2),(881,7542608,7542598,'rat',11.111,2),(881,7542609,7542598,'ati',11.111,2),(881,7542610,7542598,'tio',11.111,2),(881,7542611,7542598,'ion',11.111,2),(881,7542612,7542598,'ona',11.111,2),(881,7542613,7542598,'nal',11.111,2),(881,7542614,7542605,'mes',20,1),(881,7542615,7542605,'ess',20,1),(881,7542616,7542605,'ssa',20,1),(881,7542617,7542605,'sag',20,1),(881,7542618,7542605,'age',20,1),(881,7542619,7542614,'per',11.111,1),(881,7542620,7542614,'erf',11.111,1),(881,7542621,7542614,'rfo',11.111,1),(881,7542622,7542614,'for',11.111,1),(881,7542623,7542614,'orm',11.111,1),(881,7542624,7542614,'rma',11.111,1),(881,7542625,7542614,'man',11.111,1),(881,7542626,7542614,'anc',11.111,1),(881,7542627,7542614,'nce',11.111,1),(881,7542628,7542619,'ide',12.5,1),(881,7542629,7542619,'den',12.5,1),(881,7542630,7542619,'ent',12.5,1),(881,7542631,7542619,'nti',12.5,1),(881,7542632,7542619,'tif',12.5,1),(881,7542633,7542619,'ifi',12.5,1),(881,7542634,7542619,'fie',12.5,1),(881,7542635,7542619,'ier',12.5,1),(881,7542636,7542628,'vdi',33.333,3),(881,7542637,7542628,'dis',33.333,3),(881,7542638,7542628,'isk',33.333,3),(881,7542639,7542636,'nam',50,1),(881,7542640,7542636,'ame',50,1),(881,7542641,7542639,'typ',50,1),(881,7542642,7542639,'ype',50,1),(881,7542643,7542641,'dir',25,1),(881,7542644,7542641,'ire',25,1),(881,7542645,7542641,'rec',25,1),(881,7542646,7542641,'ect',25,1),(882,7542648,7542647,'naa',100,2),(882,7542649,7542648,'600',3.333,3),(882,7542650,7542648,'000',3.333,3),(882,7542651,7542648,'00c',3.333,3),(882,7542652,7542648,'0c2',3.333,3),(882,7542653,7542648,'c29',3.333,3),(882,7542654,7542648,'299',3.333,3),(882,7542655,7542648,'995',3.333,3),(882,7542656,7542648,'953',3.333,3),(882,7542657,7542648,'532',3.333,3),(882,7542658,7542648,'325',3.333,3),(882,7542659,7542648,'259',3.333,3),(882,7542660,7542648,'590',3.333,3),(882,7542661,7542648,'909',3.333,3),(882,7542662,7542648,'09e',3.333,3),(882,7542663,7542648,'9e8',3.333,3),(882,7542664,7542648,'e86',3.333,3),(882,7542665,7542648,'861',3.333,3),(882,7542666,7542648,'611',3.333,3),(882,7542667,7542648,'110',3.333,3),(882,7542668,7542648,'103',3.333,3),(882,7542669,7542648,'03d',3.333,3),(882,7542670,7542648,'3d9',3.333,3),(882,7542671,7542648,'d9a',3.333,3),(882,7542672,7542648,'9a2',3.333,3),(882,7542673,7542648,'a20',3.333,3),(882,7542674,7542648,'20f',3.333,3),(882,7542675,7542648,'0f0',3.333,3),(882,7542676,7542648,'f02',3.333,3),(882,7542677,7542648,'024',3.333,3),(882,7542678,7542648,'242',3.333,3),(882,7542679,7542649,'mon',100,1),(882,7542680,7542679,'201',50,1),(882,7542681,7542679,'013',50,1),(882,7542682,7542680,'adm',33.333,4),(882,7542683,7542680,'dmi',33.333,4),(882,7542684,7542680,'min',33.333,4),(882,7542685,7542682,'cap',16.667,1),(882,7542686,7542682,'apa',16.667,1),(882,7542687,7542682,'pac',16.667,1),(882,7542688,7542682,'aci',16.667,1),(882,7542689,7542682,'cit',16.667,1),(882,7542690,7542682,'ity',16.667,1),(882,7542691,7542685,'pat',50,1),(882,7542692,7542685,'ath',50,1),(882,7542693,7542691,'two',100,1),(882,7542694,7542693,'fre',14.286,1),(882,7542695,7542693,'ree',14.286,1),(882,7542696,7542693,'ees',14.286,1),(882,7542697,7542693,'esp',14.286,1),(882,7542698,7542693,'spa',14.286,1),(882,7542699,7542693,'pac',14.286,1),(882,7542700,7542693,'ace',14.286,1),(882,7542701,7542694,'dis',50,1),(882,7542702,7542694,'isk',50,1),(882,7542703,7542701,'ind',33.333,1),(882,7542704,7542701,'nde',33.333,1),(882,7542705,7542701,'dex',33.333,1),(882,7542706,7542703,'adm',8.333,1),(882,7542707,7542703,'dmi',8.333,1),(882,7542708,7542703,'min',8.333,1),(882,7542709,7542703,'ini',8.333,1),(882,7542710,7542703,'nis',8.333,1),(882,7542711,7542703,'ist',8.333,1),(882,7542712,7542703,'str',8.333,1),(882,7542713,7542703,'tra',8.333,1),(882,7542714,7542703,'rat',8.333,1),(882,7542715,7542703,'ati',8.333,1),(882,7542716,7542703,'tio',8.333,1),(882,7542717,7542703,'ion',8.333,1),(882,7542718,7542706,'sta',33.333,3),(882,7542719,7542706,'tat',33.333,3),(882,7542720,7542706,'ate',33.333,3),(882,7542721,7542718,'dis',16.667,4),(882,7542722,7542718,'isa',16.667,4),(882,7542723,7542718,'sab',16.667,4),(882,7542724,7542718,'abl',16.667,4),(882,7542725,7542718,'ble',16.667,4),(882,7542726,7542718,'led',16.667,4),(882,7542727,7542721,'cac',33.333,1),(882,7542728,7542721,'ach',33.333,1),(882,7542729,7542721,'che',33.333,1),(882,7542730,7542727,'mod',50,1),(882,7542731,7542727,'ode',50,1),(882,7542732,7542730,'wri',14.286,1),(882,7542733,7542730,'rit',14.286,1),(882,7542734,7542730,'ite',14.286,1),(882,7542735,7542730,'tet',14.286,1),(882,7542736,7542730,'eth',14.286,1),(882,7542737,7542730,'thr',14.286,1),(882,7542738,7542730,'hru',14.286,1),(882,7542739,7542732,'ope',11.111,2),(882,7542740,7542732,'per',11.111,2),(882,7542741,7542732,'era',11.111,2),(882,7542742,7542732,'rat',11.111,2),(882,7542743,7542732,'ati',11.111,2),(882,7542744,7542732,'tio',11.111,2),(882,7542745,7542732,'ion',11.111,2),(882,7542746,7542732,'ona',11.111,2),(882,7542747,7542732,'nal',11.111,2),(882,7542748,7542739,'mes',20,1),(882,7542749,7542739,'ess',20,1),(882,7542750,7542739,'ssa',20,1),(882,7542751,7542739,'sag',20,1),(882,7542752,7542739,'age',20,1),(882,7542753,7542748,'per',11.111,1),(882,7542754,7542748,'erf',11.111,1),(882,7542755,7542748,'rfo',11.111,1),(882,7542756,7542748,'for',11.111,1),(882,7542757,7542748,'orm',11.111,1),(882,7542758,7542748,'rma',11.111,1),(882,7542759,7542748,'man',11.111,1),(882,7542760,7542748,'anc',11.111,1),(882,7542761,7542748,'nce',11.111,1),(882,7542762,7542753,'ide',12.5,1),(882,7542763,7542753,'den',12.5,1),(882,7542764,7542753,'ent',12.5,1),(882,7542765,7542753,'nti',12.5,1),(882,7542766,7542753,'tif',12.5,1),(882,7542767,7542753,'ifi',12.5,1),(882,7542768,7542753,'fie',12.5,1),(882,7542769,7542753,'ier',12.5,1),(882,7542770,7542762,'vdi',33.333,3),(882,7542771,7542762,'dis',33.333,3),(882,7542772,7542762,'isk',33.333,3),(882,7542773,7542770,'nam',50,1),(882,7542774,7542770,'ame',50,1),(882,7542775,7542773,'typ',50,1),(882,7542776,7542773,'ype',50,1),(882,7542777,7542775,'dir',25,1),(882,7542778,7542775,'ire',25,1),(882,7542779,7542775,'rec',25,1),(882,7542780,7542775,'ect',25,1),(883,7542782,7542781,'att',12.5,1),(883,7542783,7542781,'ttr',12.5,1),(883,7542784,7542781,'tri',12.5,1),(883,7542785,7542781,'rib',12.5,1),(883,7542786,7542781,'ibu',12.5,1),(883,7542787,7542781,'but',12.5,1),(883,7542788,7542781,'ute',12.5,1),(883,7542789,7542781,'tes',12.5,1),(883,7542790,7542782,'ref',20,3),(883,7542791,7542782,'efr',20,3),(883,7542792,7542782,'fre',20,3),(883,7542793,7542782,'res',20,3),(883,7542794,7542782,'esh',20,3),(883,7542795,7542790,'hos',50,2),(883,7542796,7542790,'ost',50,2),(883,7542797,7542795,'nam',50,2),(883,7542798,7542795,'ame',50,2),(883,7542799,7542797,'hg3',8.333,1),(883,7542800,7542797,'g32',8.333,1),(883,7542801,7542797,'32v',8.333,1),(883,7542802,7542797,'2vm',8.333,1),(883,7542803,7542797,'vm1',8.333,1),(883,7542804,7542797,'m12',8.333,1),(883,7542805,7542797,'12w',8.333,1),(883,7542806,7542797,'2w2',8.333,1),(883,7542807,7542797,'w2k',8.333,1),(883,7542808,7542797,'2k8',8.333,1),(883,7542809,7542797,'k8r',8.333,1),(883,7542810,7542797,'8r2',8.333,1),(883,7542811,7542799,'gdl',100,1),(883,7542812,7542811,'eng',25,1),(883,7542813,7542811,'ngl',25,1),(883,7542814,7542811,'gla',25,1),(883,7542815,7542811,'lab',25,1),(883,7542816,7542812,'net',25,1),(883,7542817,7542812,'eta',25,1),(883,7542818,7542812,'tap',25,1),(883,7542819,7542812,'app',25,1),(883,7542820,7542816,'com',100,1),(883,7542821,7542820,'mem',25,3),(883,7542822,7542820,'emo',25,3),(883,7542823,7542820,'mor',25,3),(883,7542824,7542820,'ory',25,3),(883,7542825,7542821,'siz',50,2),(883,7542826,7542821,'ize',50,2),(883,7542827,7542825,'614',50,1),(883,7542828,7542825,'144',50,1),(883,7542829,7542827,'cpu',100,1),(883,7542830,7542829,'usa',33.333,3),(883,7542831,7542829,'sag',33.333,3),(883,7542832,7542829,'age',33.333,3),(883,7542833,7542830,'mhz',100,1),(883,7542834,7542833,'add',20,1),(883,7542835,7542833,'ddr',20,1),(883,7542836,7542833,'dre',20,1),(883,7542837,7542833,'res',20,1),(883,7542838,7542833,'ess',20,1),(883,7542839,7542834,'226',100,1),(883,7542840,7542839,'147',100,1),(883,7542841,7542840,'214',100,1),(883,7542842,7542841,'349',50,1),(883,7542843,7542841,'490',50,1),(883,7542844,7542842,'gue',33.333,2),(883,7542845,7542842,'ues',33.333,2),(883,7542846,7542842,'est',33.333,2),(883,7542847,7542844,'vmw',25,2),(883,7542848,7542844,'mwa',25,2),(883,7542849,7542844,'war',25,2),(883,7542850,7542844,'are',25,2),(883,7542851,7542847,'too',33.333,2),(883,7542852,7542847,'ool',33.333,2),(883,7542853,7542847,'ols',33.333,2),(883,7542854,7542851,'run',20,1),(883,7542855,7542851,'unn',20,1),(883,7542856,7542851,'nni',20,1),(883,7542857,7542851,'nin',20,1),(883,7542858,7542851,'ing',20,1),(883,7542859,7542854,'and',100,1),(883,7542860,7542859,'the',100,1),(883,7542861,7542860,'ver',20,2),(883,7542862,7542860,'ers',20,2),(883,7542863,7542860,'rsi',20,2),(883,7542864,7542860,'sio',20,2),(883,7542865,7542860,'ion',20,2),(883,7542866,7542861,'cur',20,1),(883,7542867,7542861,'urr',20,1),(883,7542868,7542861,'rre',20,1),(883,7542869,7542861,'ren',20,1),(883,7542870,7542861,'ent',20,1),(883,7542871,7542866,'mic',14.286,1),(883,7542872,7542866,'icr',14.286,1),(883,7542873,7542866,'cro',14.286,1),(883,7542874,7542866,'ros',14.286,1),(883,7542875,7542866,'oso',14.286,1),(883,7542876,7542866,'sof',14.286,1),(883,7542877,7542866,'oft',14.286,1),(883,7542878,7542871,'win',20,1),(883,7542879,7542871,'ind',20,1),(883,7542880,7542871,'ndo',20,1),(883,7542881,7542871,'dow',20,1),(883,7542882,7542871,'ows',20,1),(883,7542883,7542878,'ser',25,1),(883,7542884,7542878,'erv',25,1),(883,7542885,7542878,'rve',25,1),(883,7542886,7542878,'ver',25,1),(883,7542887,7542883,'200',50,1),(883,7542888,7542883,'008',50,1),(883,7542889,7542887,'64b',33.333,1),(883,7542890,7542887,'4bi',33.333,1),(883,7542891,7542887,'bit',33.333,1),(883,7542892,7542889,'pat',50,1),(883,7542893,7542889,'ath',50,1),(883,7542894,7542892,'rx6',33.333,1),(883,7542895,7542892,'x60',33.333,1),(883,7542896,7542892,'600',33.333,1),(883,7542897,7542894,'vmf',20,1),(883,7542898,7542894,'mfi',20,1),(883,7542899,7542894,'fil',20,1),(883,7542900,7542894,'ile',20,1),(883,7542901,7542894,'les',20,1),(883,7542902,7542897,'hgw',8.333,2),(883,7542903,7542897,'gw2',8.333,2),(883,7542904,7542897,'w2k',8.333,2),(883,7542905,7542897,'2k8',8.333,2),(883,7542906,7542897,'k8r',8.333,2),(883,7542907,7542897,'8r2',8.333,2),(883,7542908,7542897,'r23',8.333,2),(883,7542909,7542897,'232',8.333,2),(883,7542910,7542897,'32v',8.333,2),(883,7542911,7542897,'2vm',8.333,2),(883,7542912,7542897,'vm1',8.333,2),(883,7542913,7542897,'m12',8.333,2),(883,7542914,7542902,'vmx',100,1),(883,7542915,7542914,'fla',33.333,1),(883,7542916,7542914,'las',33.333,1),(883,7542917,7542914,'ash',33.333,1),(883,7542918,7542915,'acc',33.333,1),(883,7542919,7542915,'cce',33.333,1),(883,7542920,7542915,'cel',33.333,1),(883,7542921,7542918,'con',9.091,1),(883,7542922,7542918,'onf',9.091,1),(883,7542923,7542918,'nfi',9.091,1),(883,7542924,7542918,'fig',9.091,1),(883,7542925,7542918,'igu',9.091,1),(883,7542926,7542918,'gur',9.091,1),(883,7542927,7542918,'ura',9.091,1),(883,7542928,7542918,'rat',9.091,1),(883,7542929,7542918,'ati',9.091,1),(883,7542930,7542918,'tio',9.091,1),(883,7542931,7542918,'ion',9.091,1),(883,7542932,7542921,'age',33.333,1),(883,7542933,7542921,'gen',33.333,1),(883,7542934,7542921,'ent',33.333,1),(883,7542935,7542932,'193',16.667,1),(883,7542936,7542932,'938',16.667,1),(883,7542937,7542932,'380',16.667,1),(883,7542938,7542932,'809',16.667,1),(883,7542939,7542932,'097',16.667,1),(883,7542940,7542932,'979',16.667,1),(883,7542941,7542935,'cac',33.333,3),(883,7542942,7542935,'ach',33.333,3),(883,7542943,7542935,'che',33.333,3),(883,7542944,7542941,'sta',33.333,2),(883,7542945,7542941,'tat',33.333,2),(883,7542946,7542941,'ate',33.333,2),(883,7542947,7542944,'dis',16.667,3),(883,7542948,7542944,'isa',16.667,3),(883,7542949,7542944,'sab',16.667,3),(883,7542950,7542944,'abl',16.667,3),(883,7542951,7542944,'ble',16.667,3),(883,7542952,7542944,'led',16.667,3),(883,7542953,7542947,'ope',11.111,2),(883,7542954,7542947,'per',11.111,2),(883,7542955,7542947,'era',11.111,2),(883,7542956,7542947,'rat',11.111,2),(883,7542957,7542947,'ati',11.111,2),(883,7542958,7542947,'tio',11.111,2),(883,7542959,7542947,'ion',11.111,2),(883,7542960,7542947,'ona',11.111,2),(883,7542961,7542947,'nal',11.111,2),(883,7542962,7542953,'mod',50,1),(883,7542963,7542953,'ode',50,1),(883,7542964,7542962,'wri',14.286,1),(883,7542965,7542962,'rit',14.286,1),(883,7542966,7542962,'ite',14.286,1),(883,7542967,7542962,'tet',14.286,1),(883,7542968,7542962,'eth',14.286,1),(883,7542969,7542962,'thr',14.286,1),(883,7542970,7542962,'hru',14.286,1),(883,7542971,7542964,'mes',20,1),(883,7542972,7542964,'ess',20,1),(883,7542973,7542964,'ssa',20,1),(883,7542974,7542964,'sag',20,1),(883,7542975,7542964,'age',20,1),(883,7542976,7542971,'adm',33.333,1),(883,7542977,7542971,'dmi',33.333,1),(883,7542978,7542971,'min',33.333,1),(883,7542979,7542976,'met',20,3),(883,7542980,7542976,'etr',20,3),(883,7542981,7542976,'tri',20,3),(883,7542982,7542976,'ric',20,3),(883,7542983,7542976,'ics',20,3),(883,7542984,7542979,'ena',20,1),(883,7542985,7542979,'nab',20,1),(883,7542986,7542979,'abl',20,1),(883,7542987,7542979,'ble',20,1),(883,7542988,7542979,'led',20,1),(883,7542989,7542984,'vir',20,1),(883,7542990,7542984,'irt',20,1),(883,7542991,7542984,'rtu',20,1),(883,7542992,7542984,'tua',20,1),(883,7542993,7542984,'ual',20,1),(883,7542994,7542989,'dis',50,1),(883,7542995,7542989,'isk',50,1),(884,7543042,7543041,'naa',100,2),(884,7543043,7543042,'600',3.333,3),(884,7543044,7543042,'000',3.333,3),(884,7543045,7543042,'00c',3.333,3),(884,7543046,7543042,'0c2',3.333,3),(884,7543047,7543042,'c29',3.333,3),(884,7543048,7543042,'294',3.333,3),(884,7543049,7543042,'948',3.333,3),(884,7543050,7543042,'486',3.333,3),(884,7543051,7543042,'861',3.333,3),(884,7543052,7543042,'615',3.333,3),(884,7543053,7543042,'15d',3.333,3),(884,7543054,7543042,'5dc',3.333,3),(884,7543055,7543042,'dcd',3.333,3),(884,7543056,7543042,'cd7',3.333,3),(884,7543057,7543042,'d7f',3.333,3),(884,7543058,7543042,'7fa',3.333,3),(884,7543059,7543042,'fa3',3.333,3),(884,7543060,7543042,'a38',3.333,3),(884,7543061,7543042,'38e',3.333,3),(884,7543062,7543042,'8e5',3.333,3),(884,7543063,7543042,'e54',3.333,3),(884,7543064,7543042,'540',3.333,3),(884,7543065,7543042,'406',3.333,3),(884,7543066,7543042,'061',3.333,3),(884,7543067,7543042,'61d',3.333,3),(884,7543068,7543042,'1d7',3.333,3),(884,7543069,7543042,'d7c',3.333,3),(884,7543070,7543042,'7cb',3.333,3),(884,7543071,7543042,'cbd',3.333,3),(884,7543072,7543042,'bd2',3.333,3),(884,7543073,7543043,'mon',100,1),(884,7543074,7543073,'201',50,1),(884,7543075,7543073,'013',50,1),(884,7543076,7543074,'adm',33.333,4),(884,7543077,7543074,'dmi',33.333,4),(884,7543078,7543074,'min',33.333,4),(884,7543079,7543076,'cap',16.667,1),(884,7543080,7543076,'apa',16.667,1),(884,7543081,7543076,'pac',16.667,1),(884,7543082,7543076,'aci',16.667,1),(884,7543083,7543076,'cit',16.667,1),(884,7543084,7543076,'ity',16.667,1),(884,7543085,7543079,'pat',50,1),(884,7543086,7543079,'ath',50,1),(884,7543087,7543085,'vol',25,1),(884,7543088,7543085,'olu',25,1),(884,7543089,7543085,'lum',25,1),(884,7543090,7543085,'ume',25,1),(884,7543091,7543087,'78e',3.333,1),(884,7543092,7543087,'8e3',3.333,1),(884,7543093,7543087,'e3f',3.333,1),(884,7543094,7543087,'3f1',3.333,1),(884,7543095,7543087,'f18',3.333,1),(884,7543096,7543087,'188',3.333,1),(884,7543097,7543087,'886',3.333,1),(884,7543098,7543087,'86d',3.333,1),(884,7543099,7543087,'6d8',3.333,1),(884,7543100,7543087,'d87',3.333,1),(884,7543101,7543087,'871',3.333,1),(884,7543102,7543087,'711',3.333,1),(884,7543103,7543087,'11e',3.333,1),(884,7543104,7543087,'1e1',3.333,1),(884,7543105,7543087,'e19',3.333,1),(884,7543106,7543087,'192',3.333,1),(884,7543107,7543087,'927',3.333,1),(884,7543108,7543087,'277',3.333,1),(884,7543109,7543087,'778',3.333,1),(884,7543110,7543087,'780',3.333,1),(884,7543111,7543087,'806',3.333,1),(884,7543112,7543087,'06e',3.333,1),(884,7543113,7543087,'6e6',3.333,1),(884,7543114,7543087,'e6f',3.333,1),(884,7543115,7543087,'6f6',3.333,1),(884,7543116,7543087,'f6e',3.333,1),(884,7543117,7543087,'6e6',3.333,1),(884,7543118,7543087,'e69',3.333,1),(884,7543119,7543087,'696',3.333,1),(884,7543120,7543087,'963',3.333,1),(884,7543121,7543091,'fre',14.286,1),(884,7543122,7543091,'ree',14.286,1),(884,7543123,7543091,'ees',14.286,1),(884,7543124,7543091,'esp',14.286,1),(884,7543125,7543091,'spa',14.286,1),(884,7543126,7543091,'pac',14.286,1),(884,7543127,7543091,'ace',14.286,1),(884,7543128,7543121,'dis',50,1),(884,7543129,7543121,'isk',50,1),(884,7543130,7543128,'ind',33.333,1),(884,7543131,7543128,'nde',33.333,1),(884,7543132,7543128,'dex',33.333,1),(884,7543133,7543130,'adm',8.333,1),(884,7543134,7543130,'dmi',8.333,1),(884,7543135,7543130,'min',8.333,1),(884,7543136,7543130,'ini',8.333,1),(884,7543137,7543130,'nis',8.333,1),(884,7543138,7543130,'ist',8.333,1),(884,7543139,7543130,'str',8.333,1),(884,7543140,7543130,'tra',8.333,1),(884,7543141,7543130,'rat',8.333,1),(884,7543142,7543130,'ati',8.333,1),(884,7543143,7543130,'tio',8.333,1),(884,7543144,7543130,'ion',8.333,1),(884,7543145,7543133,'sta',33.333,3),(884,7543146,7543133,'tat',33.333,3),(884,7543147,7543133,'ate',33.333,3),(884,7543148,7543145,'dis',16.667,4),(884,7543149,7543145,'isa',16.667,4),(884,7543150,7543145,'sab',16.667,4),(884,7543151,7543145,'abl',16.667,4),(884,7543152,7543145,'ble',16.667,4),(884,7543153,7543145,'led',16.667,4),(884,7543154,7543148,'cac',33.333,1),(884,7543155,7543148,'ach',33.333,1),(884,7543156,7543148,'che',33.333,1),(884,7543157,7543154,'mod',50,1),(884,7543158,7543154,'ode',50,1),(884,7543159,7543157,'wri',14.286,1),(884,7543160,7543157,'rit',14.286,1),(884,7543161,7543157,'ite',14.286,1),(884,7543162,7543157,'tet',14.286,1),(884,7543163,7543157,'eth',14.286,1),(884,7543164,7543157,'thr',14.286,1),(884,7543165,7543157,'hru',14.286,1),(884,7543166,7543159,'ope',11.111,2),(884,7543167,7543159,'per',11.111,2),(884,7543168,7543159,'era',11.111,2),(884,7543169,7543159,'rat',11.111,2),(884,7543170,7543159,'ati',11.111,2),(884,7543171,7543159,'tio',11.111,2),(884,7543172,7543159,'ion',11.111,2),(884,7543173,7543159,'ona',11.111,2),(884,7543174,7543159,'nal',11.111,2),(884,7543175,7543166,'mes',20,1),(884,7543176,7543166,'ess',20,1),(884,7543177,7543166,'ssa',20,1),(884,7543178,7543166,'sag',20,1),(884,7543179,7543166,'age',20,1),(884,7543180,7543175,'per',11.111,1),(884,7543181,7543175,'erf',11.111,1),(884,7543182,7543175,'rfo',11.111,1),(884,7543183,7543175,'for',11.111,1),(884,7543184,7543175,'orm',11.111,1),(884,7543185,7543175,'rma',11.111,1),(884,7543186,7543175,'man',11.111,1),(884,7543187,7543175,'anc',11.111,1),(884,7543188,7543175,'nce',11.111,1),(884,7543189,7543180,'ide',12.5,1),(884,7543190,7543180,'den',12.5,1),(884,7543191,7543180,'ent',12.5,1),(884,7543192,7543180,'nti',12.5,1),(884,7543193,7543180,'tif',12.5,1),(884,7543194,7543180,'ifi',12.5,1),(884,7543195,7543180,'fie',12.5,1),(884,7543196,7543180,'ier',12.5,1),(884,7543197,7543189,'vdi',33.333,3),(884,7543198,7543189,'dis',33.333,3),(884,7543199,7543189,'isk',33.333,3),(884,7543200,7543197,'nam',50,1),(884,7543201,7543197,'ame',50,1),(884,7543202,7543200,'typ',50,1),(884,7543203,7543200,'ype',50,1),(884,7543204,7543202,'dir',25,1),(884,7543205,7543202,'ire',25,1),(884,7543206,7543202,'rec',25,1),(884,7543207,7543202,'ect',25,1),(885,7543209,7543208,'naa',100,2),(885,7543210,7543209,'600',3.333,3),(885,7543211,7543209,'00a',3.333,3),(885,7543212,7543209,'0a0',3.333,3),(885,7543213,7543209,'a09',3.333,3),(885,7543214,7543209,'098',3.333,3),(885,7543215,7543209,'980',3.333,3),(885,7543216,7543209,'804',3.333,3),(885,7543217,7543209,'044',3.333,3),(885,7543218,7543209,'443',3.333,3),(885,7543219,7543209,'430',3.333,3),(885,7543220,7543209,'307',3.333,3),(885,7543221,7543209,'072',3.333,3),(885,7543222,7543209,'725',3.333,3),(885,7543223,7543209,'259',3.333,3),(885,7543224,7543209,'593',3.333,3),(885,7543225,7543209,'931',3.333,3),(885,7543226,7543209,'313',3.333,3),(885,7543227,7543209,'13f',3.333,3),(885,7543228,7543209,'3f3',3.333,3),(885,7543229,7543209,'f33',3.333,3),(885,7543230,7543209,'334',3.333,3),(885,7543231,7543209,'345',3.333,3),(885,7543232,7543209,'455',3.333,3),(885,7543233,7543209,'556',3.333,3),(885,7543234,7543209,'563',3.333,3),(885,7543235,7543209,'639',3.333,3),(885,7543236,7543209,'393',3.333,3),(885,7543237,7543209,'934',3.333,3),(885,7543238,7543209,'345',3.333,3),(885,7543239,7543209,'451',3.333,3),(885,7543240,7543210,'mon',100,1),(885,7543241,7543240,'201',50,1),(885,7543242,7543240,'013',50,1),(885,7543243,7543241,'adm',33.333,4),(885,7543244,7543241,'dmi',33.333,4),(885,7543245,7543241,'min',33.333,4),(885,7543246,7543243,'cap',16.667,1),(885,7543247,7543243,'apa',16.667,1),(885,7543248,7543243,'pac',16.667,1),(885,7543249,7543243,'aci',16.667,1),(885,7543250,7543243,'cit',16.667,1),(885,7543251,7543243,'ity',16.667,1),(885,7543252,7543246,'pat',50,1),(885,7543253,7543246,'ath',50,1),(885,7543254,7543252,'fre',14.286,1),(885,7543255,7543252,'ree',14.286,1),(885,7543256,7543252,'ees',14.286,1),(885,7543257,7543252,'esp',14.286,1),(885,7543258,7543252,'spa',14.286,1),(885,7543259,7543252,'pac',14.286,1),(885,7543260,7543252,'ace',14.286,1),(885,7543261,7543254,'dis',50,1),(885,7543262,7543254,'isk',50,1),(885,7543263,7543261,'ind',33.333,1),(885,7543264,7543261,'nde',33.333,1),(885,7543265,7543261,'dex',33.333,1),(885,7543266,7543263,'adm',8.333,1),(885,7543267,7543263,'dmi',8.333,1),(885,7543268,7543263,'min',8.333,1),(885,7543269,7543263,'ini',8.333,1),(885,7543270,7543263,'nis',8.333,1),(885,7543271,7543263,'ist',8.333,1),(885,7543272,7543263,'str',8.333,1),(885,7543273,7543263,'tra',8.333,1),(885,7543274,7543263,'rat',8.333,1),(885,7543275,7543263,'ati',8.333,1),(885,7543276,7543263,'tio',8.333,1),(885,7543277,7543263,'ion',8.333,1),(885,7543278,7543266,'sta',33.333,3),(885,7543279,7543266,'tat',33.333,3),(885,7543280,7543266,'ate',33.333,3),(885,7543281,7543278,'dis',16.667,4),(885,7543282,7543278,'isa',16.667,4),(885,7543283,7543278,'sab',16.667,4),(885,7543284,7543278,'abl',16.667,4),(885,7543285,7543278,'ble',16.667,4),(885,7543286,7543278,'led',16.667,4),(885,7543287,7543281,'cac',33.333,1),(885,7543288,7543281,'ach',33.333,1),(885,7543289,7543281,'che',33.333,1),(885,7543290,7543287,'mod',50,1),(885,7543291,7543287,'ode',50,1),(885,7543292,7543290,'wri',14.286,1),(885,7543293,7543290,'rit',14.286,1),(885,7543294,7543290,'ite',14.286,1),(885,7543295,7543290,'tet',14.286,1),(885,7543296,7543290,'eth',14.286,1),(885,7543297,7543290,'thr',14.286,1),(885,7543298,7543290,'hru',14.286,1),(885,7543299,7543292,'ope',11.111,2),(885,7543300,7543292,'per',11.111,2),(885,7543301,7543292,'era',11.111,2),(885,7543302,7543292,'rat',11.111,2),(885,7543303,7543292,'ati',11.111,2),(885,7543304,7543292,'tio',11.111,2),(885,7543305,7543292,'ion',11.111,2),(885,7543306,7543292,'ona',11.111,2),(885,7543307,7543292,'nal',11.111,2),(885,7543308,7543299,'mes',20,1),(885,7543309,7543299,'ess',20,1),(885,7543310,7543299,'ssa',20,1),(885,7543311,7543299,'sag',20,1),(885,7543312,7543299,'age',20,1),(885,7543313,7543308,'per',11.111,1),(885,7543314,7543308,'erf',11.111,1),(885,7543315,7543308,'rfo',11.111,1),(885,7543316,7543308,'for',11.111,1),(885,7543317,7543308,'orm',11.111,1),(885,7543318,7543308,'rma',11.111,1),(885,7543319,7543308,'man',11.111,1),(885,7543320,7543308,'anc',11.111,1),(885,7543321,7543308,'nce',11.111,1),(885,7543322,7543313,'ide',12.5,1),(885,7543323,7543313,'den',12.5,1),(885,7543324,7543313,'ent',12.5,1),(885,7543325,7543313,'nti',12.5,1),(885,7543326,7543313,'tif',12.5,1),(885,7543327,7543313,'ifi',12.5,1),(885,7543328,7543313,'fie',12.5,1),(885,7543329,7543313,'ier',12.5,1),(885,7543330,7543322,'vdi',33.333,3),(885,7543331,7543322,'dis',33.333,3),(885,7543332,7543322,'isk',33.333,3),(885,7543333,7543330,'nam',50,1),(885,7543334,7543330,'ame',50,1),(885,7543335,7543333,'typ',50,1),(885,7543336,7543333,'ype',50,1),(885,7543337,7543335,'dir',25,1),(885,7543338,7543335,'ire',25,1),(885,7543339,7543335,'rec',25,1),(885,7543340,7543335,'ect',25,1),(886,7543342,7543341,'naa',100,2),(886,7543343,7543342,'600',3.333,3),(886,7543344,7543342,'00a',3.333,3),(886,7543345,7543342,'0a0',3.333,3),(886,7543346,7543342,'a09',3.333,3),(886,7543347,7543342,'098',3.333,3),(886,7543348,7543342,'980',3.333,3),(886,7543349,7543342,'804',3.333,3),(886,7543350,7543342,'044',3.333,3),(886,7543351,7543342,'443',3.333,3),(886,7543352,7543342,'430',3.333,3),(886,7543353,7543342,'307',3.333,3),(886,7543354,7543342,'072',3.333,3),(886,7543355,7543342,'725',3.333,3),(886,7543356,7543342,'259',3.333,3),(886,7543357,7543342,'593',3.333,3),(886,7543358,7543342,'931',3.333,3),(886,7543359,7543342,'313',3.333,3),(886,7543360,7543342,'13f',3.333,3),(886,7543361,7543342,'3f3',3.333,3),(886,7543362,7543342,'f33',3.333,3),(886,7543363,7543342,'334',3.333,3),(886,7543364,7543342,'345',3.333,3),(886,7543365,7543342,'455',3.333,3),(886,7543366,7543342,'556',3.333,3),(886,7543367,7543342,'563',3.333,3),(886,7543368,7543342,'639',3.333,3),(886,7543369,7543342,'393',3.333,3),(886,7543370,7543342,'934',3.333,3),(886,7543371,7543342,'345',3.333,3),(886,7543372,7543342,'452',3.333,3),(886,7543373,7543343,'mon',100,1),(886,7543374,7543373,'201',50,1),(886,7543375,7543373,'013',50,1),(886,7543376,7543374,'adm',33.333,4),(886,7543377,7543374,'dmi',33.333,4),(886,7543378,7543374,'min',33.333,4),(886,7543379,7543376,'cap',16.667,1),(886,7543380,7543376,'apa',16.667,1),(886,7543381,7543376,'pac',16.667,1),(886,7543382,7543376,'aci',16.667,1),(886,7543383,7543376,'cit',16.667,1),(886,7543384,7543376,'ity',16.667,1),(886,7543385,7543379,'pat',50,1),(886,7543386,7543379,'ath',50,1),(886,7543387,7543385,'fre',14.286,1),(886,7543388,7543385,'ree',14.286,1),(886,7543389,7543385,'ees',14.286,1),(886,7543390,7543385,'esp',14.286,1),(886,7543391,7543385,'spa',14.286,1),(886,7543392,7543385,'pac',14.286,1),(886,7543393,7543385,'ace',14.286,1),(886,7543394,7543387,'dis',50,1),(886,7543395,7543387,'isk',50,1),(886,7543396,7543394,'ind',33.333,1),(886,7543397,7543394,'nde',33.333,1),(886,7543398,7543394,'dex',33.333,1),(886,7543399,7543396,'adm',8.333,1),(886,7543400,7543396,'dmi',8.333,1),(886,7543401,7543396,'min',8.333,1),(886,7543402,7543396,'ini',8.333,1),(886,7543403,7543396,'nis',8.333,1),(886,7543404,7543396,'ist',8.333,1),(886,7543405,7543396,'str',8.333,1),(886,7543406,7543396,'tra',8.333,1),(886,7543407,7543396,'rat',8.333,1),(886,7543408,7543396,'ati',8.333,1),(886,7543409,7543396,'tio',8.333,1),(886,7543410,7543396,'ion',8.333,1),(886,7543411,7543399,'sta',33.333,3),(886,7543412,7543399,'tat',33.333,3),(886,7543413,7543399,'ate',33.333,3),(886,7543414,7543411,'dis',16.667,4),(886,7543415,7543411,'isa',16.667,4),(886,7543416,7543411,'sab',16.667,4),(886,7543417,7543411,'abl',16.667,4),(886,7543418,7543411,'ble',16.667,4),(886,7543419,7543411,'led',16.667,4),(886,7543420,7543414,'cac',33.333,1),(886,7543421,7543414,'ach',33.333,1),(886,7543422,7543414,'che',33.333,1),(886,7543423,7543420,'mod',50,1),(886,7543424,7543420,'ode',50,1),(886,7543425,7543423,'wri',14.286,1),(886,7543426,7543423,'rit',14.286,1),(886,7543427,7543423,'ite',14.286,1),(886,7543428,7543423,'tet',14.286,1),(886,7543429,7543423,'eth',14.286,1),(886,7543430,7543423,'thr',14.286,1),(886,7543431,7543423,'hru',14.286,1),(886,7543432,7543425,'ope',11.111,2),(886,7543433,7543425,'per',11.111,2),(886,7543434,7543425,'era',11.111,2),(886,7543435,7543425,'rat',11.111,2),(886,7543436,7543425,'ati',11.111,2),(886,7543437,7543425,'tio',11.111,2),(886,7543438,7543425,'ion',11.111,2),(886,7543439,7543425,'ona',11.111,2),(886,7543440,7543425,'nal',11.111,2),(886,7543441,7543432,'mes',20,1),(886,7543442,7543432,'ess',20,1),(886,7543443,7543432,'ssa',20,1),(886,7543444,7543432,'sag',20,1),(886,7543445,7543432,'age',20,1),(886,7543446,7543441,'per',11.111,1),(886,7543447,7543441,'erf',11.111,1),(886,7543448,7543441,'rfo',11.111,1),(886,7543449,7543441,'for',11.111,1),(886,7543450,7543441,'orm',11.111,1),(886,7543451,7543441,'rma',11.111,1),(886,7543452,7543441,'man',11.111,1),(886,7543453,7543441,'anc',11.111,1),(886,7543454,7543441,'nce',11.111,1),(886,7543455,7543446,'ide',12.5,1),(886,7543456,7543446,'den',12.5,1),(886,7543457,7543446,'ent',12.5,1),(886,7543458,7543446,'nti',12.5,1),(886,7543459,7543446,'tif',12.5,1),(886,7543460,7543446,'ifi',12.5,1),(886,7543461,7543446,'fie',12.5,1),(886,7543462,7543446,'ier',12.5,1),(886,7543463,7543455,'vdi',33.333,3),(886,7543464,7543455,'dis',33.333,3),(886,7543465,7543455,'isk',33.333,3),(886,7543466,7543463,'nam',50,1),(886,7543467,7543463,'ame',50,1),(886,7543468,7543466,'typ',50,1),(886,7543469,7543466,'ype',50,1),(886,7543470,7543468,'dir',25,1),(886,7543471,7543468,'ire',25,1),(886,7543472,7543468,'rec',25,1),(886,7543473,7543468,'ect',25,1),(887,7543475,7543474,'naa',100,2),(887,7543476,7543475,'600',3.333,3),(887,7543477,7543475,'00a',3.333,3),(887,7543478,7543475,'0a0',3.333,3),(887,7543479,7543475,'a09',3.333,3),(887,7543480,7543475,'098',3.333,3),(887,7543481,7543475,'980',3.333,3),(887,7543482,7543475,'804',3.333,3),(887,7543483,7543475,'044',3.333,3),(887,7543484,7543475,'443',3.333,3),(887,7543485,7543475,'430',3.333,3),(887,7543486,7543475,'307',3.333,3),(887,7543487,7543475,'075',3.333,3),(887,7543488,7543475,'753',3.333,3),(887,7543489,7543475,'535',3.333,3),(887,7543490,7543475,'357',3.333,3),(887,7543491,7543475,'573',3.333,3),(887,7543492,7543475,'732',3.333,3),(887,7543493,7543475,'32b',3.333,3),(887,7543494,7543475,'2b3',3.333,3),(887,7543495,7543475,'b33',3.333,3),(887,7543496,7543475,'334',3.333,3),(887,7543497,7543475,'345',3.333,3),(887,7543498,7543475,'457',3.333,3),(887,7543499,7543475,'571',3.333,3),(887,7543500,7543475,'715',3.333,3),(887,7543501,7543475,'153',3.333,3),(887,7543502,7543475,'533',3.333,3),(887,7543503,7543475,'336',3.333,3),(887,7543504,7543475,'364',3.333,3),(887,7543505,7543475,'642',3.333,3),(887,7543506,7543476,'mon',100,1),(887,7543507,7543506,'201',50,1),(887,7543508,7543506,'013',50,1),(887,7543509,7543507,'adm',33.333,4),(887,7543510,7543507,'dmi',33.333,4),(887,7543511,7543507,'min',33.333,4),(887,7543512,7543509,'cap',16.667,1),(887,7543513,7543509,'apa',16.667,1),(887,7543514,7543509,'pac',16.667,1),(887,7543515,7543509,'aci',16.667,1),(887,7543516,7543509,'cit',16.667,1),(887,7543517,7543509,'ity',16.667,1),(887,7543518,7543512,'pat',50,1),(887,7543519,7543512,'ath',50,1),(887,7543520,7543518,'fre',14.286,1),(887,7543521,7543518,'ree',14.286,1),(887,7543522,7543518,'ees',14.286,1),(887,7543523,7543518,'esp',14.286,1),(887,7543524,7543518,'spa',14.286,1),(887,7543525,7543518,'pac',14.286,1),(887,7543526,7543518,'ace',14.286,1),(887,7543527,7543520,'dis',50,1),(887,7543528,7543520,'isk',50,1),(887,7543529,7543527,'ind',33.333,1),(887,7543530,7543527,'nde',33.333,1),(887,7543531,7543527,'dex',33.333,1),(887,7543532,7543529,'adm',8.333,1),(887,7543533,7543529,'dmi',8.333,1),(887,7543534,7543529,'min',8.333,1),(887,7543535,7543529,'ini',8.333,1),(887,7543536,7543529,'nis',8.333,1),(887,7543537,7543529,'ist',8.333,1),(887,7543538,7543529,'str',8.333,1),(887,7543539,7543529,'tra',8.333,1),(887,7543540,7543529,'rat',8.333,1),(887,7543541,7543529,'ati',8.333,1),(887,7543542,7543529,'tio',8.333,1),(887,7543543,7543529,'ion',8.333,1),(887,7543544,7543532,'sta',33.333,3),(887,7543545,7543532,'tat',33.333,3),(887,7543546,7543532,'ate',33.333,3),(887,7543547,7543544,'dis',16.667,4),(887,7543548,7543544,'isa',16.667,4),(887,7543549,7543544,'sab',16.667,4),(887,7543550,7543544,'abl',16.667,4),(887,7543551,7543544,'ble',16.667,4),(887,7543552,7543544,'led',16.667,4),(887,7543553,7543547,'cac',33.333,1),(887,7543554,7543547,'ach',33.333,1),(887,7543555,7543547,'che',33.333,1),(887,7543556,7543553,'mod',50,1),(887,7543557,7543553,'ode',50,1),(887,7543558,7543556,'wri',14.286,1),(887,7543559,7543556,'rit',14.286,1),(887,7543560,7543556,'ite',14.286,1),(887,7543561,7543556,'tet',14.286,1),(887,7543562,7543556,'eth',14.286,1),(887,7543563,7543556,'thr',14.286,1),(887,7543564,7543556,'hru',14.286,1),(887,7543565,7543558,'ope',11.111,2),(887,7543566,7543558,'per',11.111,2),(887,7543567,7543558,'era',11.111,2),(887,7543568,7543558,'rat',11.111,2),(887,7543569,7543558,'ati',11.111,2),(887,7543570,7543558,'tio',11.111,2),(887,7543571,7543558,'ion',11.111,2),(887,7543572,7543558,'ona',11.111,2),(887,7543573,7543558,'nal',11.111,2),(887,7543574,7543565,'mes',20,1),(887,7543575,7543565,'ess',20,1),(887,7543576,7543565,'ssa',20,1),(887,7543577,7543565,'sag',20,1),(887,7543578,7543565,'age',20,1),(887,7543579,7543574,'per',11.111,1),(887,7543580,7543574,'erf',11.111,1),(887,7543581,7543574,'rfo',11.111,1),(887,7543582,7543574,'for',11.111,1),(887,7543583,7543574,'orm',11.111,1),(887,7543584,7543574,'rma',11.111,1),(887,7543585,7543574,'man',11.111,1),(887,7543586,7543574,'anc',11.111,1),(887,7543587,7543574,'nce',11.111,1),(887,7543588,7543579,'ide',12.5,1),(887,7543589,7543579,'den',12.5,1),(887,7543590,7543579,'ent',12.5,1),(887,7543591,7543579,'nti',12.5,1),(887,7543592,7543579,'tif',12.5,1),(887,7543593,7543579,'ifi',12.5,1),(887,7543594,7543579,'fie',12.5,1),(887,7543595,7543579,'ier',12.5,1),(887,7543596,7543588,'vdi',33.333,3),(887,7543597,7543588,'dis',33.333,3),(887,7543598,7543588,'isk',33.333,3),(887,7543599,7543596,'nam',50,1),(887,7543600,7543596,'ame',50,1),(887,7543601,7543599,'typ',50,1),(887,7543602,7543599,'ype',50,1),(887,7543603,7543601,'dir',25,1),(887,7543604,7543601,'ire',25,1),(887,7543605,7543601,'rec',25,1),(887,7543606,7543601,'ect',25,1),(888,7543608,7543607,'naa',100,2),(888,7543609,7543608,'600',3.333,3),(888,7543610,7543608,'00a',3.333,3),(888,7543611,7543608,'0a0',3.333,3),(888,7543612,7543608,'a09',3.333,3),(888,7543613,7543608,'098',3.333,3),(888,7543614,7543608,'980',3.333,3),(888,7543615,7543608,'804',3.333,3),(888,7543616,7543608,'044',3.333,3),(888,7543617,7543608,'443',3.333,3),(888,7543618,7543608,'430',3.333,3),(888,7543619,7543608,'307',3.333,3),(888,7543620,7543608,'075',3.333,3),(888,7543621,7543608,'753',3.333,3),(888,7543622,7543608,'535',3.333,3),(888,7543623,7543608,'357',3.333,3),(888,7543624,7543608,'573',3.333,3),(888,7543625,7543608,'732',3.333,3),(888,7543626,7543608,'32b',3.333,3),(888,7543627,7543608,'2b3',3.333,3),(888,7543628,7543608,'b33',3.333,3),(888,7543629,7543608,'334',3.333,3),(888,7543630,7543608,'345',3.333,3),(888,7543631,7543608,'457',3.333,3),(888,7543632,7543608,'571',3.333,3),(888,7543633,7543608,'715',3.333,3),(888,7543634,7543608,'153',3.333,3),(888,7543635,7543608,'533',3.333,3),(888,7543636,7543608,'336',3.333,3),(888,7543637,7543608,'364',3.333,3),(888,7543638,7543608,'643',3.333,3),(888,7543639,7543609,'mon',100,1),(888,7543640,7543639,'201',50,1),(888,7543641,7543639,'013',50,1),(888,7543642,7543640,'adm',33.333,4),(888,7543643,7543640,'dmi',33.333,4),(888,7543644,7543640,'min',33.333,4),(888,7543645,7543642,'cap',16.667,1),(888,7543646,7543642,'apa',16.667,1),(888,7543647,7543642,'pac',16.667,1),(888,7543648,7543642,'aci',16.667,1),(888,7543649,7543642,'cit',16.667,1),(888,7543650,7543642,'ity',16.667,1),(888,7543651,7543645,'pat',50,1),(888,7543652,7543645,'ath',50,1),(888,7543653,7543651,'fre',14.286,1),(888,7543654,7543651,'ree',14.286,1),(888,7543655,7543651,'ees',14.286,1),(888,7543656,7543651,'esp',14.286,1),(888,7543657,7543651,'spa',14.286,1),(888,7543658,7543651,'pac',14.286,1),(888,7543659,7543651,'ace',14.286,1),(888,7543660,7543653,'dis',50,1),(888,7543661,7543653,'isk',50,1),(888,7543662,7543660,'ind',33.333,1),(888,7543663,7543660,'nde',33.333,1),(888,7543664,7543660,'dex',33.333,1),(888,7543665,7543662,'adm',8.333,1),(888,7543666,7543662,'dmi',8.333,1),(888,7543667,7543662,'min',8.333,1),(888,7543668,7543662,'ini',8.333,1),(888,7543669,7543662,'nis',8.333,1),(888,7543670,7543662,'ist',8.333,1),(888,7543671,7543662,'str',8.333,1),(888,7543672,7543662,'tra',8.333,1),(888,7543673,7543662,'rat',8.333,1),(888,7543674,7543662,'ati',8.333,1),(888,7543675,7543662,'tio',8.333,1),(888,7543676,7543662,'ion',8.333,1),(888,7543677,7543665,'sta',33.333,3),(888,7543678,7543665,'tat',33.333,3),(888,7543679,7543665,'ate',33.333,3),(888,7543680,7543677,'dis',16.667,4),(888,7543681,7543677,'isa',16.667,4),(888,7543682,7543677,'sab',16.667,4),(888,7543683,7543677,'abl',16.667,4),(888,7543684,7543677,'ble',16.667,4),(888,7543685,7543677,'led',16.667,4),(888,7543686,7543680,'cac',33.333,1),(888,7543687,7543680,'ach',33.333,1),(888,7543688,7543680,'che',33.333,1),(888,7543689,7543686,'mod',50,1),(888,7543690,7543686,'ode',50,1),(888,7543691,7543689,'wri',14.286,1),(888,7543692,7543689,'rit',14.286,1),(888,7543693,7543689,'ite',14.286,1),(888,7543694,7543689,'tet',14.286,1),(888,7543695,7543689,'eth',14.286,1),(888,7543696,7543689,'thr',14.286,1),(888,7543697,7543689,'hru',14.286,1),(888,7543698,7543691,'ope',11.111,2),(888,7543699,7543691,'per',11.111,2),(888,7543700,7543691,'era',11.111,2),(888,7543701,7543691,'rat',11.111,2),(888,7543702,7543691,'ati',11.111,2),(888,7543703,7543691,'tio',11.111,2),(888,7543704,7543691,'ion',11.111,2),(888,7543705,7543691,'ona',11.111,2),(888,7543706,7543691,'nal',11.111,2),(888,7543707,7543698,'mes',20,1),(888,7543708,7543698,'ess',20,1),(888,7543709,7543698,'ssa',20,1),(888,7543710,7543698,'sag',20,1),(888,7543711,7543698,'age',20,1),(888,7543712,7543707,'per',11.111,1),(888,7543713,7543707,'erf',11.111,1),(888,7543714,7543707,'rfo',11.111,1),(888,7543715,7543707,'for',11.111,1),(888,7543716,7543707,'orm',11.111,1),(888,7543717,7543707,'rma',11.111,1),(888,7543718,7543707,'man',11.111,1),(888,7543719,7543707,'anc',11.111,1),(888,7543720,7543707,'nce',11.111,1),(888,7543721,7543712,'ide',12.5,1),(888,7543722,7543712,'den',12.5,1),(888,7543723,7543712,'ent',12.5,1),(888,7543724,7543712,'nti',12.5,1),(888,7543725,7543712,'tif',12.5,1),(888,7543726,7543712,'ifi',12.5,1),(888,7543727,7543712,'fie',12.5,1),(888,7543728,7543712,'ier',12.5,1),(888,7543729,7543721,'vdi',33.333,3),(888,7543730,7543721,'dis',33.333,3),(888,7543731,7543721,'isk',33.333,3),(888,7543732,7543729,'nam',50,1),(888,7543733,7543729,'ame',50,1),(888,7543734,7543732,'typ',50,1),(888,7543735,7543732,'ype',50,1),(888,7543736,7543734,'dir',25,1),(888,7543737,7543734,'ire',25,1),(888,7543738,7543734,'rec',25,1),(888,7543739,7543734,'ect',25,1),(889,7543741,7543740,'naa',100,2),(889,7543742,7543741,'600',3.333,3),(889,7543743,7543741,'000',3.333,3),(889,7543744,7543741,'00c',3.333,3),(889,7543745,7543741,'0c2',3.333,3),(889,7543746,7543741,'c29',3.333,3),(889,7543747,7543741,'29b',3.333,3),(889,7543748,7543741,'9b2',3.333,3),(889,7543749,7543741,'b20',3.333,3),(889,7543750,7543741,'207',3.333,3),(889,7543751,7543741,'07d',3.333,3),(889,7543752,7543741,'7d3',3.333,3),(889,7543753,7543741,'d32',3.333,3),(889,7543754,7543741,'32e',3.333,3),(889,7543755,7543741,'2e1',3.333,3),(889,7543756,7543741,'e12',3.333,3),(889,7543757,7543741,'12e',3.333,3),(889,7543758,7543741,'2ea',3.333,3),(889,7543759,7543741,'ea2',3.333,3),(889,7543760,7543741,'a2d',3.333,3),(889,7543761,7543741,'2d6',3.333,3),(889,7543762,7543741,'d6a',3.333,3),(889,7543763,7543741,'6a6',3.333,3),(889,7543764,7543741,'a66',3.333,3),(889,7543765,7543741,'664',3.333,3),(889,7543766,7543741,'64b',3.333,3),(889,7543767,7543741,'4bf',3.333,3),(889,7543768,7543741,'bf5',3.333,3),(889,7543769,7543741,'f55',3.333,3),(889,7543770,7543741,'553',3.333,3),(889,7543771,7543741,'53d',3.333,3),(889,7543772,7543742,'mon',100,1),(889,7543773,7543772,'201',50,1),(889,7543774,7543772,'013',50,1),(889,7543775,7543773,'adm',33.333,4),(889,7543776,7543773,'dmi',33.333,4),(889,7543777,7543773,'min',33.333,4),(889,7543778,7543775,'cap',16.667,1),(889,7543779,7543775,'apa',16.667,1),(889,7543780,7543775,'pac',16.667,1),(889,7543781,7543775,'aci',16.667,1),(889,7543782,7543775,'cit',16.667,1),(889,7543783,7543775,'ity',16.667,1),(889,7543784,7543778,'pat',50,1),(889,7543785,7543778,'ath',50,1),(889,7543786,7543784,'fre',14.286,1),(889,7543787,7543784,'ree',14.286,1),(889,7543788,7543784,'ees',14.286,1),(889,7543789,7543784,'esp',14.286,1),(889,7543790,7543784,'spa',14.286,1),(889,7543791,7543784,'pac',14.286,1),(889,7543792,7543784,'ace',14.286,1),(889,7543793,7543786,'dis',50,1),(889,7543794,7543786,'isk',50,1),(889,7543795,7543793,'ind',33.333,1),(889,7543796,7543793,'nde',33.333,1),(889,7543797,7543793,'dex',33.333,1),(889,7543798,7543795,'adm',8.333,1),(889,7543799,7543795,'dmi',8.333,1),(889,7543800,7543795,'min',8.333,1),(889,7543801,7543795,'ini',8.333,1),(889,7543802,7543795,'nis',8.333,1),(889,7543803,7543795,'ist',8.333,1),(889,7543804,7543795,'str',8.333,1),(889,7543805,7543795,'tra',8.333,1),(889,7543806,7543795,'rat',8.333,1),(889,7543807,7543795,'ati',8.333,1),(889,7543808,7543795,'tio',8.333,1),(889,7543809,7543795,'ion',8.333,1),(889,7543810,7543798,'sta',33.333,3),(889,7543811,7543798,'tat',33.333,3),(889,7543812,7543798,'ate',33.333,3),(889,7543813,7543810,'dis',16.667,4),(889,7543814,7543810,'isa',16.667,4),(889,7543815,7543810,'sab',16.667,4),(889,7543816,7543810,'abl',16.667,4),(889,7543817,7543810,'ble',16.667,4),(889,7543818,7543810,'led',16.667,4),(889,7543819,7543813,'cac',33.333,1),(889,7543820,7543813,'ach',33.333,1),(889,7543821,7543813,'che',33.333,1),(889,7543822,7543819,'mod',50,1),(889,7543823,7543819,'ode',50,1),(889,7543824,7543822,'wri',14.286,1),(889,7543825,7543822,'rit',14.286,1),(889,7543826,7543822,'ite',14.286,1),(889,7543827,7543822,'tet',14.286,1),(889,7543828,7543822,'eth',14.286,1),(889,7543829,7543822,'thr',14.286,1),(889,7543830,7543822,'hru',14.286,1),(889,7543831,7543824,'ope',11.111,2),(889,7543832,7543824,'per',11.111,2),(889,7543833,7543824,'era',11.111,2),(889,7543834,7543824,'rat',11.111,2),(889,7543835,7543824,'ati',11.111,2),(889,7543836,7543824,'tio',11.111,2),(889,7543837,7543824,'ion',11.111,2),(889,7543838,7543824,'ona',11.111,2),(889,7543839,7543824,'nal',11.111,2),(889,7543840,7543831,'mes',20,1),(889,7543841,7543831,'ess',20,1),(889,7543842,7543831,'ssa',20,1),(889,7543843,7543831,'sag',20,1),(889,7543844,7543831,'age',20,1),(889,7543845,7543840,'per',11.111,1),(889,7543846,7543840,'erf',11.111,1),(889,7543847,7543840,'rfo',11.111,1),(889,7543848,7543840,'for',11.111,1),(889,7543849,7543840,'orm',11.111,1),(889,7543850,7543840,'rma',11.111,1),(889,7543851,7543840,'man',11.111,1),(889,7543852,7543840,'anc',11.111,1),(889,7543853,7543840,'nce',11.111,1),(889,7543854,7543845,'ide',12.5,1),(889,7543855,7543845,'den',12.5,1),(889,7543856,7543845,'ent',12.5,1),(889,7543857,7543845,'nti',12.5,1),(889,7543858,7543845,'tif',12.5,1),(889,7543859,7543845,'ifi',12.5,1),(889,7543860,7543845,'fie',12.5,1),(889,7543861,7543845,'ier',12.5,1),(889,7543862,7543854,'vdi',33.333,3),(889,7543863,7543854,'dis',33.333,3),(889,7543864,7543854,'isk',33.333,3),(889,7543865,7543862,'nam',50,1),(889,7543866,7543862,'ame',50,1),(889,7543867,7543865,'typ',50,1),(889,7543868,7543865,'ype',50,1),(889,7543869,7543867,'dir',25,1),(889,7543870,7543867,'ire',25,1),(889,7543871,7543867,'rec',25,1),(889,7543872,7543867,'ect',25,1),(890,7543874,7543873,'naa',100,2),(890,7543875,7543874,'600',3.333,3),(890,7543876,7543874,'000',3.333,3),(890,7543877,7543874,'00c',3.333,3),(890,7543878,7543874,'0c2',3.333,3),(890,7543879,7543874,'c29',3.333,3),(890,7543880,7543874,'29d',3.333,3),(890,7543881,7543874,'9d8',3.333,3),(890,7543882,7543874,'d80',3.333,3),(890,7543883,7543874,'80c',3.333,3),(890,7543884,7543874,'0c3',3.333,3),(890,7543885,7543874,'c35',3.333,3),(890,7543886,7543874,'35d',3.333,3),(890,7543887,7543874,'5d1',3.333,3),(890,7543888,7543874,'d1a',3.333,3),(890,7543889,7543874,'1a2',3.333,3),(890,7543890,7543874,'a2c',3.333,3),(890,7543891,7543874,'2cf',3.333,3),(890,7543892,7543874,'cfd',3.333,3),(890,7543893,7543874,'fda',3.333,3),(890,7543894,7543874,'daa',3.333,3),(890,7543895,7543874,'aa2',3.333,3),(890,7543896,7543874,'a2f',3.333,3),(890,7543897,7543874,'2f6',3.333,3),(890,7543898,7543874,'f6d',3.333,3),(890,7543899,7543874,'6dc',3.333,3),(890,7543900,7543874,'dc9',3.333,3),(890,7543901,7543874,'c96',3.333,3),(890,7543902,7543874,'96d',3.333,3),(890,7543903,7543874,'6d9',3.333,3),(890,7543904,7543874,'d96',3.333,3),(890,7543905,7543875,'mon',100,1),(890,7543906,7543905,'201',50,1),(890,7543907,7543905,'013',50,1),(890,7543908,7543906,'adm',33.333,4),(890,7543909,7543906,'dmi',33.333,4),(890,7543910,7543906,'min',33.333,4),(890,7543911,7543908,'cap',16.667,1),(890,7543912,7543908,'apa',16.667,1),(890,7543913,7543908,'pac',16.667,1),(890,7543914,7543908,'aci',16.667,1),(890,7543915,7543908,'cit',16.667,1),(890,7543916,7543908,'ity',16.667,1),(890,7543917,7543911,'pat',50,1),(890,7543918,7543911,'ath',50,1),(890,7543919,7543917,'fre',14.286,1),(890,7543920,7543917,'ree',14.286,1),(890,7543921,7543917,'ees',14.286,1),(890,7543922,7543917,'esp',14.286,1),(890,7543923,7543917,'spa',14.286,1),(890,7543924,7543917,'pac',14.286,1),(890,7543925,7543917,'ace',14.286,1),(890,7543926,7543919,'dis',50,1),(890,7543927,7543919,'isk',50,1),(890,7543928,7543926,'ind',33.333,1),(890,7543929,7543926,'nde',33.333,1),(890,7543930,7543926,'dex',33.333,1),(890,7543931,7543928,'adm',8.333,1),(890,7543932,7543928,'dmi',8.333,1),(890,7543933,7543928,'min',8.333,1),(890,7543934,7543928,'ini',8.333,1),(890,7543935,7543928,'nis',8.333,1),(890,7543936,7543928,'ist',8.333,1),(890,7543937,7543928,'str',8.333,1),(890,7543938,7543928,'tra',8.333,1),(890,7543939,7543928,'rat',8.333,1),(890,7543940,7543928,'ati',8.333,1),(890,7543941,7543928,'tio',8.333,1),(890,7543942,7543928,'ion',8.333,1),(890,7543943,7543931,'sta',33.333,3),(890,7543944,7543931,'tat',33.333,3),(890,7543945,7543931,'ate',33.333,3),(890,7543946,7543943,'dis',16.667,4),(890,7543947,7543943,'isa',16.667,4),(890,7543948,7543943,'sab',16.667,4),(890,7543949,7543943,'abl',16.667,4),(890,7543950,7543943,'ble',16.667,4),(890,7543951,7543943,'led',16.667,4),(890,7543952,7543946,'cac',33.333,1),(890,7543953,7543946,'ach',33.333,1),(890,7543954,7543946,'che',33.333,1),(890,7543955,7543952,'mod',50,1),(890,7543956,7543952,'ode',50,1),(890,7543957,7543955,'wri',14.286,1),(890,7543958,7543955,'rit',14.286,1),(890,7543959,7543955,'ite',14.286,1),(890,7543960,7543955,'tet',14.286,1),(890,7543961,7543955,'eth',14.286,1),(890,7543962,7543955,'thr',14.286,1),(890,7543963,7543955,'hru',14.286,1),(890,7543964,7543957,'ope',11.111,2),(890,7543965,7543957,'per',11.111,2),(890,7543966,7543957,'era',11.111,2),(890,7543967,7543957,'rat',11.111,2),(890,7543968,7543957,'ati',11.111,2),(890,7543969,7543957,'tio',11.111,2),(890,7543970,7543957,'ion',11.111,2),(890,7543971,7543957,'ona',11.111,2),(890,7543972,7543957,'nal',11.111,2),(890,7543973,7543964,'mes',20,1),(890,7543974,7543964,'ess',20,1),(890,7543975,7543964,'ssa',20,1),(890,7543976,7543964,'sag',20,1),(890,7543977,7543964,'age',20,1),(890,7543978,7543973,'per',11.111,1),(890,7543979,7543973,'erf',11.111,1),(890,7543980,7543973,'rfo',11.111,1),(890,7543981,7543973,'for',11.111,1),(890,7543982,7543973,'orm',11.111,1),(890,7543983,7543973,'rma',11.111,1),(890,7543984,7543973,'man',11.111,1),(890,7543985,7543973,'anc',11.111,1),(890,7543986,7543973,'nce',11.111,1),(890,7543987,7543978,'ide',12.5,1),(890,7543988,7543978,'den',12.5,1),(890,7543989,7543978,'ent',12.5,1),(890,7543990,7543978,'nti',12.5,1),(890,7543991,7543978,'tif',12.5,1),(890,7543992,7543978,'ifi',12.5,1),(890,7543993,7543978,'fie',12.5,1),(890,7543994,7543978,'ier',12.5,1),(890,7543995,7543987,'vdi',33.333,3),(890,7543996,7543987,'dis',33.333,3),(890,7543997,7543987,'isk',33.333,3),(890,7543998,7543995,'nam',50,1),(890,7543999,7543995,'ame',50,1),(890,7544000,7543998,'typ',50,1),(890,7544001,7543998,'ype',50,1),(890,7544002,7544000,'dir',25,1),(890,7544003,7544000,'ire',25,1),(890,7544004,7544000,'rec',25,1),(890,7544005,7544000,'ect',25,1),(891,7544007,7544006,'naa',100,2),(891,7544008,7544007,'600',3.333,3),(891,7544009,7544007,'000',3.333,3),(891,7544010,7544007,'00c',3.333,3),(891,7544011,7544007,'0c2',3.333,3),(891,7544012,7544007,'c29',3.333,3),(891,7544013,7544007,'296',3.333,3),(891,7544014,7544007,'96e',3.333,3),(891,7544015,7544007,'6ef',3.333,3),(891,7544016,7544007,'efe',3.333,3),(891,7544017,7544007,'fe9',3.333,3),(891,7544018,7544007,'e98',3.333,3),(891,7544019,7544007,'987',3.333,3),(891,7544020,7544007,'878',3.333,3),(891,7544021,7544007,'782',3.333,3),(891,7544022,7544007,'826',3.333,3),(891,7544023,7544007,'261',3.333,3),(891,7544024,7544007,'618',3.333,3),(891,7544025,7544007,'182',3.333,3),(891,7544026,7544007,'824',3.333,3),(891,7544027,7544007,'245',3.333,3),(891,7544028,7544007,'454',3.333,3),(891,7544029,7544007,'544',3.333,3),(891,7544030,7544007,'443',3.333,3),(891,7544031,7544007,'43e',3.333,3),(891,7544032,7544007,'3e7',3.333,3),(891,7544033,7544007,'e77',3.333,3),(891,7544034,7544007,'772',3.333,3),(891,7544035,7544007,'72b',3.333,3),(891,7544036,7544007,'2be',3.333,3),(891,7544037,7544007,'bec',3.333,3),(891,7544038,7544008,'mon',100,1),(891,7544039,7544038,'201',50,1),(891,7544040,7544038,'013',50,1),(891,7544041,7544039,'adm',33.333,4),(891,7544042,7544039,'dmi',33.333,4),(891,7544043,7544039,'min',33.333,4),(891,7544044,7544041,'cap',16.667,1),(891,7544045,7544041,'apa',16.667,1),(891,7544046,7544041,'pac',16.667,1),(891,7544047,7544041,'aci',16.667,1),(891,7544048,7544041,'cit',16.667,1),(891,7544049,7544041,'ity',16.667,1),(891,7544050,7544044,'pat',50,1),(891,7544051,7544044,'ath',50,1),(891,7544052,7544050,'fre',14.286,1),(891,7544053,7544050,'ree',14.286,1),(891,7544054,7544050,'ees',14.286,1),(891,7544055,7544050,'esp',14.286,1),(891,7544056,7544050,'spa',14.286,1),(891,7544057,7544050,'pac',14.286,1),(891,7544058,7544050,'ace',14.286,1),(891,7544059,7544052,'dis',50,1),(891,7544060,7544052,'isk',50,1),(891,7544061,7544059,'ind',33.333,1),(891,7544062,7544059,'nde',33.333,1),(891,7544063,7544059,'dex',33.333,1),(891,7544064,7544061,'adm',8.333,1),(891,7544065,7544061,'dmi',8.333,1),(891,7544066,7544061,'min',8.333,1),(891,7544067,7544061,'ini',8.333,1),(891,7544068,7544061,'nis',8.333,1),(891,7544069,7544061,'ist',8.333,1),(891,7544070,7544061,'str',8.333,1),(891,7544071,7544061,'tra',8.333,1),(891,7544072,7544061,'rat',8.333,1),(891,7544073,7544061,'ati',8.333,1),(891,7544074,7544061,'tio',8.333,1),(891,7544075,7544061,'ion',8.333,1),(891,7544076,7544064,'sta',33.333,3),(891,7544077,7544064,'tat',33.333,3),(891,7544078,7544064,'ate',33.333,3),(891,7544079,7544076,'dis',16.667,4),(891,7544080,7544076,'isa',16.667,4),(891,7544081,7544076,'sab',16.667,4),(891,7544082,7544076,'abl',16.667,4),(891,7544083,7544076,'ble',16.667,4),(891,7544084,7544076,'led',16.667,4),(891,7544085,7544079,'cac',33.333,1),(891,7544086,7544079,'ach',33.333,1),(891,7544087,7544079,'che',33.333,1),(891,7544088,7544085,'mod',50,1),(891,7544089,7544085,'ode',50,1),(891,7544090,7544088,'wri',14.286,1),(891,7544091,7544088,'rit',14.286,1),(891,7544092,7544088,'ite',14.286,1),(891,7544093,7544088,'tet',14.286,1),(891,7544094,7544088,'eth',14.286,1),(891,7544095,7544088,'thr',14.286,1),(891,7544096,7544088,'hru',14.286,1),(891,7544097,7544090,'ope',11.111,2),(891,7544098,7544090,'per',11.111,2),(891,7544099,7544090,'era',11.111,2),(891,7544100,7544090,'rat',11.111,2),(891,7544101,7544090,'ati',11.111,2),(891,7544102,7544090,'tio',11.111,2),(891,7544103,7544090,'ion',11.111,2),(891,7544104,7544090,'ona',11.111,2),(891,7544105,7544090,'nal',11.111,2),(891,7544106,7544097,'mes',20,1),(891,7544107,7544097,'ess',20,1),(891,7544108,7544097,'ssa',20,1),(891,7544109,7544097,'sag',20,1),(891,7544110,7544097,'age',20,1),(891,7544111,7544106,'per',11.111,1),(891,7544112,7544106,'erf',11.111,1),(891,7544113,7544106,'rfo',11.111,1),(891,7544114,7544106,'for',11.111,1),(891,7544115,7544106,'orm',11.111,1),(891,7544116,7544106,'rma',11.111,1),(891,7544117,7544106,'man',11.111,1),(891,7544118,7544106,'anc',11.111,1),(891,7544119,7544106,'nce',11.111,1),(891,7544120,7544111,'ide',12.5,1),(891,7544121,7544111,'den',12.5,1),(891,7544122,7544111,'ent',12.5,1),(891,7544123,7544111,'nti',12.5,1),(891,7544124,7544111,'tif',12.5,1),(891,7544125,7544111,'ifi',12.5,1),(891,7544126,7544111,'fie',12.5,1),(891,7544127,7544111,'ier',12.5,1),(891,7544128,7544120,'vdi',33.333,3),(891,7544129,7544120,'dis',33.333,3),(891,7544130,7544120,'isk',33.333,3),(891,7544131,7544128,'nam',50,1),(891,7544132,7544128,'ame',50,1),(891,7544133,7544131,'typ',50,1),(891,7544134,7544131,'ype',50,1),(891,7544135,7544133,'dir',25,1),(891,7544136,7544133,'ire',25,1),(891,7544137,7544133,'rec',25,1),(891,7544138,7544133,'ect',25,1),(892,7544140,7544139,'naa',100,2),(892,7544141,7544140,'600',3.333,3),(892,7544142,7544140,'000',3.333,3),(892,7544143,7544140,'00c',3.333,3),(892,7544144,7544140,'0c2',3.333,3),(892,7544145,7544140,'c29',3.333,3),(892,7544146,7544140,'29f',3.333,3),(892,7544147,7544140,'9f2',3.333,3),(892,7544148,7544140,'f22',3.333,3),(892,7544149,7544140,'224',3.333,3),(892,7544150,7544140,'24d',3.333,3),(892,7544151,7544140,'4d5',3.333,3),(892,7544152,7544140,'d52',3.333,3),(892,7544153,7544140,'52b',3.333,3),(892,7544154,7544140,'2b1',3.333,3),(892,7544155,7544140,'b11',3.333,3),(892,7544156,7544140,'113',3.333,3),(892,7544157,7544140,'13f',3.333,3),(892,7544158,7544140,'3f5',3.333,3),(892,7544159,7544140,'f5e',3.333,3),(892,7544160,7544140,'5e0',3.333,3),(892,7544161,7544140,'e05',3.333,3),(892,7544162,7544140,'05c',3.333,3),(892,7544163,7544140,'5c2',3.333,3),(892,7544164,7544140,'c2c',3.333,3),(892,7544165,7544140,'2cd',3.333,3),(892,7544166,7544140,'cda',3.333,3),(892,7544167,7544140,'da0',3.333,3),(892,7544168,7544140,'a0e',3.333,3),(892,7544169,7544140,'0ed',3.333,3),(892,7544170,7544140,'ed8',3.333,3),(892,7544171,7544141,'mon',100,1),(892,7544172,7544171,'201',50,1),(892,7544173,7544171,'013',50,1),(892,7544174,7544172,'adm',33.333,4),(892,7544175,7544172,'dmi',33.333,4),(892,7544176,7544172,'min',33.333,4),(892,7544177,7544174,'cap',16.667,1),(892,7544178,7544174,'apa',16.667,1),(892,7544179,7544174,'pac',16.667,1),(892,7544180,7544174,'aci',16.667,1),(892,7544181,7544174,'cit',16.667,1),(892,7544182,7544174,'ity',16.667,1),(892,7544183,7544177,'pat',50,1),(892,7544184,7544177,'ath',50,1),(892,7544185,7544183,'fre',14.286,1),(892,7544186,7544183,'ree',14.286,1),(892,7544187,7544183,'ees',14.286,1),(892,7544188,7544183,'esp',14.286,1),(892,7544189,7544183,'spa',14.286,1),(892,7544190,7544183,'pac',14.286,1),(892,7544191,7544183,'ace',14.286,1),(892,7544192,7544185,'dis',50,1),(892,7544193,7544185,'isk',50,1),(892,7544194,7544192,'ind',33.333,1),(892,7544195,7544192,'nde',33.333,1),(892,7544196,7544192,'dex',33.333,1),(892,7544197,7544194,'adm',8.333,1),(892,7544198,7544194,'dmi',8.333,1),(892,7544199,7544194,'min',8.333,1),(892,7544200,7544194,'ini',8.333,1),(892,7544201,7544194,'nis',8.333,1),(892,7544202,7544194,'ist',8.333,1),(892,7544203,7544194,'str',8.333,1),(892,7544204,7544194,'tra',8.333,1),(892,7544205,7544194,'rat',8.333,1),(892,7544206,7544194,'ati',8.333,1),(892,7544207,7544194,'tio',8.333,1),(892,7544208,7544194,'ion',8.333,1),(892,7544209,7544197,'sta',33.333,3),(892,7544210,7544197,'tat',33.333,3),(892,7544211,7544197,'ate',33.333,3),(892,7544212,7544209,'dis',16.667,4),(892,7544213,7544209,'isa',16.667,4),(892,7544214,7544209,'sab',16.667,4),(892,7544215,7544209,'abl',16.667,4),(892,7544216,7544209,'ble',16.667,4),(892,7544217,7544209,'led',16.667,4),(892,7544218,7544212,'cac',33.333,1),(892,7544219,7544212,'ach',33.333,1),(892,7544220,7544212,'che',33.333,1),(892,7544221,7544218,'mod',50,1),(892,7544222,7544218,'ode',50,1),(892,7544223,7544221,'wri',14.286,1),(892,7544224,7544221,'rit',14.286,1),(892,7544225,7544221,'ite',14.286,1),(892,7544226,7544221,'tet',14.286,1),(892,7544227,7544221,'eth',14.286,1),(892,7544228,7544221,'thr',14.286,1),(892,7544229,7544221,'hru',14.286,1),(892,7544230,7544223,'ope',11.111,2),(892,7544231,7544223,'per',11.111,2),(892,7544232,7544223,'era',11.111,2),(892,7544233,7544223,'rat',11.111,2),(892,7544234,7544223,'ati',11.111,2),(892,7544235,7544223,'tio',11.111,2),(892,7544236,7544223,'ion',11.111,2),(892,7544237,7544223,'ona',11.111,2),(892,7544238,7544223,'nal',11.111,2),(892,7544239,7544230,'mes',20,1),(892,7544240,7544230,'ess',20,1),(892,7544241,7544230,'ssa',20,1),(892,7544242,7544230,'sag',20,1),(892,7544243,7544230,'age',20,1),(892,7544244,7544239,'per',11.111,1),(892,7544245,7544239,'erf',11.111,1),(892,7544246,7544239,'rfo',11.111,1),(892,7544247,7544239,'for',11.111,1),(892,7544248,7544239,'orm',11.111,1),(892,7544249,7544239,'rma',11.111,1),(892,7544250,7544239,'man',11.111,1),(892,7544251,7544239,'anc',11.111,1),(892,7544252,7544239,'nce',11.111,1),(892,7544253,7544244,'ide',12.5,1),(892,7544254,7544244,'den',12.5,1),(892,7544255,7544244,'ent',12.5,1),(892,7544256,7544244,'nti',12.5,1),(892,7544257,7544244,'tif',12.5,1),(892,7544258,7544244,'ifi',12.5,1),(892,7544259,7544244,'fie',12.5,1),(892,7544260,7544244,'ier',12.5,1),(892,7544261,7544253,'vdi',33.333,3),(892,7544262,7544253,'dis',33.333,3),(892,7544263,7544253,'isk',33.333,3),(892,7544264,7544261,'nam',50,1),(892,7544265,7544261,'ame',50,1),(892,7544266,7544264,'typ',50,1),(892,7544267,7544264,'ype',50,1),(892,7544268,7544266,'dir',25,1),(892,7544269,7544266,'ire',25,1),(892,7544270,7544266,'rec',25,1),(892,7544271,7544266,'ect',25,1),(893,7544273,7544272,'naa',100,2),(893,7544274,7544273,'600',3.333,3),(893,7544275,7544273,'000',3.333,3),(893,7544276,7544273,'00c',3.333,3),(893,7544277,7544273,'0c2',3.333,3),(893,7544278,7544273,'c29',3.333,3),(893,7544279,7544273,'295',3.333,3),(893,7544280,7544273,'954',3.333,3),(893,7544281,7544273,'54c',3.333,3),(893,7544282,7544273,'4ce',3.333,3),(893,7544283,7544273,'ce7',3.333,3),(893,7544284,7544273,'e76',3.333,3),(893,7544285,7544273,'76e',3.333,3),(893,7544286,7544273,'6e0',3.333,3),(893,7544287,7544273,'e04',3.333,3),(893,7544288,7544273,'046',3.333,3),(893,7544289,7544273,'46b',3.333,3),(893,7544290,7544273,'6bb',3.333,3),(893,7544291,7544273,'bbd',3.333,3),(893,7544292,7544273,'bd7',3.333,3),(893,7544293,7544273,'d76',3.333,3),(893,7544294,7544273,'765',3.333,3),(893,7544295,7544273,'65c',3.333,3),(893,7544296,7544273,'5c0',3.333,3),(893,7544297,7544273,'c07',3.333,3),(893,7544298,7544273,'073',3.333,3),(893,7544299,7544273,'736',3.333,3),(893,7544300,7544273,'360',3.333,3),(893,7544301,7544273,'609',3.333,3),(893,7544302,7544273,'09d',3.333,3),(893,7544303,7544273,'9dd',3.333,3),(893,7544304,7544274,'mon',100,1),(893,7544305,7544304,'201',50,1),(893,7544306,7544304,'013',50,1),(893,7544307,7544305,'adm',33.333,4),(893,7544308,7544305,'dmi',33.333,4),(893,7544309,7544305,'min',33.333,4),(893,7544310,7544307,'cap',16.667,1),(893,7544311,7544307,'apa',16.667,1),(893,7544312,7544307,'pac',16.667,1),(893,7544313,7544307,'aci',16.667,1),(893,7544314,7544307,'cit',16.667,1),(893,7544315,7544307,'ity',16.667,1),(893,7544316,7544310,'pat',50,1),(893,7544317,7544310,'ath',50,1),(893,7544318,7544316,'fre',14.286,1),(893,7544319,7544316,'ree',14.286,1),(893,7544320,7544316,'ees',14.286,1),(893,7544321,7544316,'esp',14.286,1),(893,7544322,7544316,'spa',14.286,1),(893,7544323,7544316,'pac',14.286,1),(893,7544324,7544316,'ace',14.286,1),(893,7544325,7544318,'dis',50,1),(893,7544326,7544318,'isk',50,1),(893,7544327,7544325,'ind',33.333,1),(893,7544328,7544325,'nde',33.333,1),(893,7544329,7544325,'dex',33.333,1),(893,7544330,7544327,'adm',8.333,1),(893,7544331,7544327,'dmi',8.333,1),(893,7544332,7544327,'min',8.333,1),(893,7544333,7544327,'ini',8.333,1),(893,7544334,7544327,'nis',8.333,1),(893,7544335,7544327,'ist',8.333,1),(893,7544336,7544327,'str',8.333,1),(893,7544337,7544327,'tra',8.333,1),(893,7544338,7544327,'rat',8.333,1),(893,7544339,7544327,'ati',8.333,1),(893,7544340,7544327,'tio',8.333,1),(893,7544341,7544327,'ion',8.333,1),(893,7544342,7544330,'sta',33.333,3),(893,7544343,7544330,'tat',33.333,3),(893,7544344,7544330,'ate',33.333,3),(893,7544345,7544342,'dis',16.667,4),(893,7544346,7544342,'isa',16.667,4),(893,7544347,7544342,'sab',16.667,4),(893,7544348,7544342,'abl',16.667,4),(893,7544349,7544342,'ble',16.667,4),(893,7544350,7544342,'led',16.667,4),(893,7544351,7544345,'cac',33.333,1),(893,7544352,7544345,'ach',33.333,1),(893,7544353,7544345,'che',33.333,1),(893,7544354,7544351,'mod',50,1),(893,7544355,7544351,'ode',50,1),(893,7544356,7544354,'wri',14.286,1),(893,7544357,7544354,'rit',14.286,1),(893,7544358,7544354,'ite',14.286,1),(893,7544359,7544354,'tet',14.286,1),(893,7544360,7544354,'eth',14.286,1),(893,7544361,7544354,'thr',14.286,1),(893,7544362,7544354,'hru',14.286,1),(893,7544363,7544356,'ope',11.111,2),(893,7544364,7544356,'per',11.111,2),(893,7544365,7544356,'era',11.111,2),(893,7544366,7544356,'rat',11.111,2),(893,7544367,7544356,'ati',11.111,2),(893,7544368,7544356,'tio',11.111,2),(893,7544369,7544356,'ion',11.111,2),(893,7544370,7544356,'ona',11.111,2),(893,7544371,7544356,'nal',11.111,2),(893,7544372,7544363,'mes',20,1),(893,7544373,7544363,'ess',20,1),(893,7544374,7544363,'ssa',20,1),(893,7544375,7544363,'sag',20,1),(893,7544376,7544363,'age',20,1),(893,7544377,7544372,'per',11.111,1),(893,7544378,7544372,'erf',11.111,1),(893,7544379,7544372,'rfo',11.111,1),(893,7544380,7544372,'for',11.111,1),(893,7544381,7544372,'orm',11.111,1),(893,7544382,7544372,'rma',11.111,1),(893,7544383,7544372,'man',11.111,1),(893,7544384,7544372,'anc',11.111,1),(893,7544385,7544372,'nce',11.111,1),(893,7544386,7544377,'ide',12.5,1),(893,7544387,7544377,'den',12.5,1),(893,7544388,7544377,'ent',12.5,1),(893,7544389,7544377,'nti',12.5,1),(893,7544390,7544377,'tif',12.5,1),(893,7544391,7544377,'ifi',12.5,1),(893,7544392,7544377,'fie',12.5,1),(893,7544393,7544377,'ier',12.5,1),(893,7544394,7544386,'vdi',33.333,3),(893,7544395,7544386,'dis',33.333,3),(893,7544396,7544386,'isk',33.333,3),(893,7544397,7544394,'nam',50,1),(893,7544398,7544394,'ame',50,1),(893,7544399,7544397,'typ',50,1),(893,7544400,7544397,'ype',50,1),(893,7544401,7544399,'dir',25,1),(893,7544402,7544399,'ire',25,1),(893,7544403,7544399,'rec',25,1),(893,7544404,7544399,'ect',25,1),(894,7544406,7544405,'naa',100,2),(894,7544407,7544406,'600',3.333,3),(894,7544408,7544406,'000',3.333,3),(894,7544409,7544406,'00c',3.333,3),(894,7544410,7544406,'0c2',3.333,3),(894,7544411,7544406,'c29',3.333,3),(894,7544412,7544406,'29b',3.333,3),(894,7544413,7544406,'9be',3.333,3),(894,7544414,7544406,'be3',3.333,3),(894,7544415,7544406,'e3a',3.333,3),(894,7544416,7544406,'3a2',3.333,3),(894,7544417,7544406,'a23',3.333,3),(894,7544418,7544406,'234',3.333,3),(894,7544419,7544406,'341',3.333,3),(894,7544420,7544406,'414',3.333,3),(894,7544421,7544406,'14f',3.333,3),(894,7544422,7544406,'4f4',3.333,3),(894,7544423,7544406,'f49',3.333,3),(894,7544424,7544406,'493',3.333,3),(894,7544425,7544406,'934',3.333,3),(894,7544426,7544406,'349',3.333,3),(894,7544427,7544406,'49e',3.333,3),(894,7544428,7544406,'9e0',3.333,3),(894,7544429,7544406,'e00',3.333,3),(894,7544430,7544406,'001',3.333,3),(894,7544431,7544406,'019',3.333,3),(894,7544432,7544406,'19a',3.333,3),(894,7544433,7544406,'9ab',3.333,3),(894,7544434,7544406,'ab9',3.333,3),(894,7544435,7544406,'b98',3.333,3),(894,7544436,7544406,'982',3.333,3),(894,7544437,7544407,'mon',100,1),(894,7544438,7544437,'201',50,1),(894,7544439,7544437,'013',50,1),(894,7544440,7544438,'adm',33.333,4),(894,7544441,7544438,'dmi',33.333,4),(894,7544442,7544438,'min',33.333,4),(894,7544443,7544440,'cap',16.667,1),(894,7544444,7544440,'apa',16.667,1),(894,7544445,7544440,'pac',16.667,1),(894,7544446,7544440,'aci',16.667,1),(894,7544447,7544440,'cit',16.667,1),(894,7544448,7544440,'ity',16.667,1),(894,7544449,7544443,'pat',50,1),(894,7544450,7544443,'ath',50,1),(894,7544451,7544449,'fre',14.286,1),(894,7544452,7544449,'ree',14.286,1),(894,7544453,7544449,'ees',14.286,1),(894,7544454,7544449,'esp',14.286,1),(894,7544455,7544449,'spa',14.286,1),(894,7544456,7544449,'pac',14.286,1),(894,7544457,7544449,'ace',14.286,1),(894,7544458,7544451,'dis',50,1),(894,7544459,7544451,'isk',50,1),(894,7544460,7544458,'ind',33.333,1),(894,7544461,7544458,'nde',33.333,1),(894,7544462,7544458,'dex',33.333,1),(894,7544463,7544460,'adm',8.333,1),(894,7544464,7544460,'dmi',8.333,1),(894,7544465,7544460,'min',8.333,1),(894,7544466,7544460,'ini',8.333,1),(894,7544467,7544460,'nis',8.333,1),(894,7544468,7544460,'ist',8.333,1),(894,7544469,7544460,'str',8.333,1),(894,7544470,7544460,'tra',8.333,1),(894,7544471,7544460,'rat',8.333,1),(894,7544472,7544460,'ati',8.333,1),(894,7544473,7544460,'tio',8.333,1),(894,7544474,7544460,'ion',8.333,1),(894,7544475,7544463,'sta',33.333,3),(894,7544476,7544463,'tat',33.333,3),(894,7544477,7544463,'ate',33.333,3),(894,7544478,7544475,'dis',16.667,4),(894,7544479,7544475,'isa',16.667,4),(894,7544480,7544475,'sab',16.667,4),(894,7544481,7544475,'abl',16.667,4),(894,7544482,7544475,'ble',16.667,4),(894,7544483,7544475,'led',16.667,4),(894,7544484,7544478,'cac',33.333,1),(894,7544485,7544478,'ach',33.333,1),(894,7544486,7544478,'che',33.333,1),(894,7544487,7544484,'mod',50,1),(894,7544488,7544484,'ode',50,1),(894,7544489,7544487,'wri',14.286,1),(894,7544490,7544487,'rit',14.286,1),(894,7544491,7544487,'ite',14.286,1),(894,7544492,7544487,'tet',14.286,1),(894,7544493,7544487,'eth',14.286,1),(894,7544494,7544487,'thr',14.286,1),(894,7544495,7544487,'hru',14.286,1),(894,7544496,7544489,'ope',11.111,2),(894,7544497,7544489,'per',11.111,2),(894,7544498,7544489,'era',11.111,2),(894,7544499,7544489,'rat',11.111,2),(894,7544500,7544489,'ati',11.111,2),(894,7544501,7544489,'tio',11.111,2),(894,7544502,7544489,'ion',11.111,2),(894,7544503,7544489,'ona',11.111,2),(894,7544504,7544489,'nal',11.111,2),(894,7544505,7544496,'mes',20,1),(894,7544506,7544496,'ess',20,1),(894,7544507,7544496,'ssa',20,1),(894,7544508,7544496,'sag',20,1),(894,7544509,7544496,'age',20,1),(894,7544510,7544505,'per',11.111,1),(894,7544511,7544505,'erf',11.111,1),(894,7544512,7544505,'rfo',11.111,1),(894,7544513,7544505,'for',11.111,1),(894,7544514,7544505,'orm',11.111,1),(894,7544515,7544505,'rma',11.111,1),(894,7544516,7544505,'man',11.111,1),(894,7544517,7544505,'anc',11.111,1),(894,7544518,7544505,'nce',11.111,1),(894,7544519,7544510,'ide',12.5,1),(894,7544520,7544510,'den',12.5,1),(894,7544521,7544510,'ent',12.5,1),(894,7544522,7544510,'nti',12.5,1),(894,7544523,7544510,'tif',12.5,1),(894,7544524,7544510,'ifi',12.5,1),(894,7544525,7544510,'fie',12.5,1),(894,7544526,7544510,'ier',12.5,1),(894,7544527,7544519,'vdi',33.333,3),(894,7544528,7544519,'dis',33.333,3),(894,7544529,7544519,'isk',33.333,3),(894,7544530,7544527,'nam',50,1),(894,7544531,7544527,'ame',50,1),(894,7544532,7544530,'typ',50,1),(894,7544533,7544530,'ype',50,1),(894,7544534,7544532,'dir',25,1),(894,7544535,7544532,'ire',25,1),(894,7544536,7544532,'rec',25,1),(894,7544537,7544532,'ect',25,1),(895,7544539,7544538,'naa',100,2),(895,7544540,7544539,'600',3.333,3),(895,7544541,7544539,'000',3.333,3),(895,7544542,7544539,'00c',3.333,3),(895,7544543,7544539,'0c2',3.333,3),(895,7544544,7544539,'c29',3.333,3),(895,7544545,7544539,'29e',3.333,3),(895,7544546,7544539,'9e6',3.333,3),(895,7544547,7544539,'e65',3.333,3),(895,7544548,7544539,'657',3.333,3),(895,7544549,7544539,'57f',3.333,3),(895,7544550,7544539,'7fc',3.333,3),(895,7544551,7544539,'fce',3.333,3),(895,7544552,7544539,'ceb',3.333,3),(895,7544553,7544539,'eb9',3.333,3),(895,7544554,7544539,'b93',3.333,3),(895,7544555,7544539,'93f',3.333,3),(895,7544556,7544539,'3f7',3.333,3),(895,7544557,7544539,'f7a',3.333,3),(895,7544558,7544539,'7a3',3.333,3),(895,7544559,7544539,'a3f',3.333,3),(895,7544560,7544539,'3f0',3.333,3),(895,7544561,7544539,'f00',3.333,3),(895,7544562,7544539,'001',3.333,3),(895,7544563,7544539,'013',3.333,3),(895,7544564,7544539,'139',3.333,3),(895,7544565,7544539,'395',3.333,3),(895,7544566,7544539,'95a',3.333,3),(895,7544567,7544539,'5a6',3.333,3),(895,7544568,7544539,'a64',3.333,3),(895,7544569,7544539,'64e',3.333,3),(895,7544570,7544540,'mon',100,1),(895,7544571,7544570,'201',50,1),(895,7544572,7544570,'013',50,1),(895,7544573,7544571,'adm',33.333,4),(895,7544574,7544571,'dmi',33.333,4),(895,7544575,7544571,'min',33.333,4),(895,7544576,7544573,'cap',16.667,1),(895,7544577,7544573,'apa',16.667,1),(895,7544578,7544573,'pac',16.667,1),(895,7544579,7544573,'aci',16.667,1),(895,7544580,7544573,'cit',16.667,1),(895,7544581,7544573,'ity',16.667,1),(895,7544582,7544576,'pat',50,1),(895,7544583,7544576,'ath',50,1),(895,7544584,7544582,'fre',14.286,1),(895,7544585,7544582,'ree',14.286,1),(895,7544586,7544582,'ees',14.286,1),(895,7544587,7544582,'esp',14.286,1),(895,7544588,7544582,'spa',14.286,1),(895,7544589,7544582,'pac',14.286,1),(895,7544590,7544582,'ace',14.286,1),(895,7544591,7544584,'dis',50,1),(895,7544592,7544584,'isk',50,1),(895,7544593,7544591,'ind',33.333,1),(895,7544594,7544591,'nde',33.333,1),(895,7544595,7544591,'dex',33.333,1),(895,7544596,7544593,'adm',8.333,1),(895,7544597,7544593,'dmi',8.333,1),(895,7544598,7544593,'min',8.333,1),(895,7544599,7544593,'ini',8.333,1),(895,7544600,7544593,'nis',8.333,1),(895,7544601,7544593,'ist',8.333,1),(895,7544602,7544593,'str',8.333,1),(895,7544603,7544593,'tra',8.333,1),(895,7544604,7544593,'rat',8.333,1),(895,7544605,7544593,'ati',8.333,1),(895,7544606,7544593,'tio',8.333,1),(895,7544607,7544593,'ion',8.333,1),(895,7544608,7544596,'sta',33.333,3),(895,7544609,7544596,'tat',33.333,3),(895,7544610,7544596,'ate',33.333,3),(895,7544611,7544608,'dis',16.667,4),(895,7544612,7544608,'isa',16.667,4),(895,7544613,7544608,'sab',16.667,4),(895,7544614,7544608,'abl',16.667,4),(895,7544615,7544608,'ble',16.667,4),(895,7544616,7544608,'led',16.667,4),(895,7544617,7544611,'cac',33.333,1),(895,7544618,7544611,'ach',33.333,1),(895,7544619,7544611,'che',33.333,1),(895,7544620,7544617,'mod',50,1),(895,7544621,7544617,'ode',50,1),(895,7544622,7544620,'wri',14.286,1),(895,7544623,7544620,'rit',14.286,1),(895,7544624,7544620,'ite',14.286,1),(895,7544625,7544620,'tet',14.286,1),(895,7544626,7544620,'eth',14.286,1),(895,7544627,7544620,'thr',14.286,1),(895,7544628,7544620,'hru',14.286,1),(895,7544629,7544622,'ope',11.111,2),(895,7544630,7544622,'per',11.111,2),(895,7544631,7544622,'era',11.111,2),(895,7544632,7544622,'rat',11.111,2),(895,7544633,7544622,'ati',11.111,2),(895,7544634,7544622,'tio',11.111,2),(895,7544635,7544622,'ion',11.111,2),(895,7544636,7544622,'ona',11.111,2),(895,7544637,7544622,'nal',11.111,2),(895,7544638,7544629,'mes',20,1),(895,7544639,7544629,'ess',20,1),(895,7544640,7544629,'ssa',20,1),(895,7544641,7544629,'sag',20,1),(895,7544642,7544629,'age',20,1),(895,7544643,7544638,'per',11.111,1),(895,7544644,7544638,'erf',11.111,1),(895,7544645,7544638,'rfo',11.111,1),(895,7544646,7544638,'for',11.111,1),(895,7544647,7544638,'orm',11.111,1),(895,7544648,7544638,'rma',11.111,1),(895,7544649,7544638,'man',11.111,1),(895,7544650,7544638,'anc',11.111,1),(895,7544651,7544638,'nce',11.111,1),(895,7544652,7544643,'ide',12.5,1),(895,7544653,7544643,'den',12.5,1),(895,7544654,7544643,'ent',12.5,1),(895,7544655,7544643,'nti',12.5,1),(895,7544656,7544643,'tif',12.5,1),(895,7544657,7544643,'ifi',12.5,1),(895,7544658,7544643,'fie',12.5,1),(895,7544659,7544643,'ier',12.5,1),(895,7544660,7544652,'vdi',33.333,3),(895,7544661,7544652,'dis',33.333,3),(895,7544662,7544652,'isk',33.333,3),(895,7544663,7544660,'nam',50,1),(895,7544664,7544660,'ame',50,1),(895,7544665,7544663,'typ',50,1),(895,7544666,7544663,'ype',50,1),(895,7544667,7544665,'dir',25,1),(895,7544668,7544665,'ire',25,1),(895,7544669,7544665,'rec',25,1),(895,7544670,7544665,'ect',25,1),(896,7544672,7544671,'naa',100,2),(896,7544673,7544672,'600',3.333,3),(896,7544674,7544672,'000',3.333,3),(896,7544675,7544672,'00c',3.333,3),(896,7544676,7544672,'0c2',3.333,3),(896,7544677,7544672,'c29',3.333,3),(896,7544678,7544672,'293',3.333,3),(896,7544679,7544672,'93f',3.333,3),(896,7544680,7544672,'3f5',3.333,3),(896,7544681,7544672,'f59',3.333,3),(896,7544682,7544672,'590',3.333,3),(896,7544683,7544672,'905',3.333,3),(896,7544684,7544672,'05a',3.333,3),(896,7544685,7544672,'5ac',3.333,3),(896,7544686,7544672,'acb',3.333,3),(896,7544687,7544672,'cb8',3.333,3),(896,7544688,7544672,'b80',3.333,3),(896,7544689,7544672,'80c',3.333,3),(896,7544690,7544672,'0c4',3.333,3),(896,7544691,7544672,'c41',3.333,3),(896,7544692,7544672,'411',3.333,3),(896,7544693,7544672,'114',3.333,3),(896,7544694,7544672,'14f',3.333,3),(896,7544695,7544672,'4f6',3.333,3),(896,7544696,7544672,'f67',3.333,3),(896,7544697,7544672,'679',3.333,3),(896,7544698,7544672,'791',3.333,3),(896,7544699,7544672,'917',3.333,3),(896,7544700,7544672,'176',3.333,3),(896,7544701,7544672,'764',3.333,3),(896,7544702,7544672,'640',3.333,3),(896,7544703,7544673,'mon',100,1),(896,7544704,7544703,'201',50,1),(896,7544705,7544703,'013',50,1),(896,7544706,7544704,'adm',33.333,4),(896,7544707,7544704,'dmi',33.333,4),(896,7544708,7544704,'min',33.333,4),(896,7544709,7544706,'cap',16.667,1),(896,7544710,7544706,'apa',16.667,1),(896,7544711,7544706,'pac',16.667,1),(896,7544712,7544706,'aci',16.667,1),(896,7544713,7544706,'cit',16.667,1),(896,7544714,7544706,'ity',16.667,1),(896,7544715,7544709,'pat',50,1),(896,7544716,7544709,'ath',50,1),(896,7544717,7544715,'fre',14.286,1),(896,7544718,7544715,'ree',14.286,1),(896,7544719,7544715,'ees',14.286,1),(896,7544720,7544715,'esp',14.286,1),(896,7544721,7544715,'spa',14.286,1),(896,7544722,7544715,'pac',14.286,1),(896,7544723,7544715,'ace',14.286,1),(896,7544724,7544717,'dis',50,1),(896,7544725,7544717,'isk',50,1),(896,7544726,7544724,'ind',33.333,1),(896,7544727,7544724,'nde',33.333,1),(896,7544728,7544724,'dex',33.333,1),(896,7544729,7544726,'adm',8.333,1),(896,7544730,7544726,'dmi',8.333,1),(896,7544731,7544726,'min',8.333,1),(896,7544732,7544726,'ini',8.333,1),(896,7544733,7544726,'nis',8.333,1),(896,7544734,7544726,'ist',8.333,1),(896,7544735,7544726,'str',8.333,1),(896,7544736,7544726,'tra',8.333,1),(896,7544737,7544726,'rat',8.333,1),(896,7544738,7544726,'ati',8.333,1),(896,7544739,7544726,'tio',8.333,1),(896,7544740,7544726,'ion',8.333,1),(896,7544741,7544729,'sta',33.333,3),(896,7544742,7544729,'tat',33.333,3),(896,7544743,7544729,'ate',33.333,3),(896,7544744,7544741,'dis',16.667,4),(896,7544745,7544741,'isa',16.667,4),(896,7544746,7544741,'sab',16.667,4),(896,7544747,7544741,'abl',16.667,4),(896,7544748,7544741,'ble',16.667,4),(896,7544749,7544741,'led',16.667,4),(896,7544750,7544744,'cac',33.333,1),(896,7544751,7544744,'ach',33.333,1),(896,7544752,7544744,'che',33.333,1),(896,7544753,7544750,'mod',50,1),(896,7544754,7544750,'ode',50,1),(896,7544755,7544753,'wri',14.286,1),(896,7544756,7544753,'rit',14.286,1),(896,7544757,7544753,'ite',14.286,1),(896,7544758,7544753,'tet',14.286,1),(896,7544759,7544753,'eth',14.286,1),(896,7544760,7544753,'thr',14.286,1),(896,7544761,7544753,'hru',14.286,1),(896,7544762,7544755,'ope',11.111,2),(896,7544763,7544755,'per',11.111,2),(896,7544764,7544755,'era',11.111,2),(896,7544765,7544755,'rat',11.111,2),(896,7544766,7544755,'ati',11.111,2),(896,7544767,7544755,'tio',11.111,2),(896,7544768,7544755,'ion',11.111,2),(896,7544769,7544755,'ona',11.111,2),(896,7544770,7544755,'nal',11.111,2),(896,7544771,7544762,'mes',20,1),(896,7544772,7544762,'ess',20,1),(896,7544773,7544762,'ssa',20,1),(896,7544774,7544762,'sag',20,1),(896,7544775,7544762,'age',20,1),(896,7544776,7544771,'per',11.111,1),(896,7544777,7544771,'erf',11.111,1),(896,7544778,7544771,'rfo',11.111,1),(896,7544779,7544771,'for',11.111,1),(896,7544780,7544771,'orm',11.111,1),(896,7544781,7544771,'rma',11.111,1),(896,7544782,7544771,'man',11.111,1),(896,7544783,7544771,'anc',11.111,1),(896,7544784,7544771,'nce',11.111,1),(896,7544785,7544776,'ide',12.5,1),(896,7544786,7544776,'den',12.5,1),(896,7544787,7544776,'ent',12.5,1),(896,7544788,7544776,'nti',12.5,1),(896,7544789,7544776,'tif',12.5,1),(896,7544790,7544776,'ifi',12.5,1),(896,7544791,7544776,'fie',12.5,1),(896,7544792,7544776,'ier',12.5,1),(896,7544793,7544785,'vdi',33.333,3),(896,7544794,7544785,'dis',33.333,3),(896,7544795,7544785,'isk',33.333,3),(896,7544796,7544793,'nam',50,1),(896,7544797,7544793,'ame',50,1),(896,7544798,7544796,'typ',50,1),(896,7544799,7544796,'ype',50,1),(896,7544800,7544798,'dir',25,1),(896,7544801,7544798,'ire',25,1),(896,7544802,7544798,'rec',25,1),(896,7544803,7544798,'ect',25,1),(897,7544805,7544804,'naa',100,2),(897,7544806,7544805,'600',3.333,3),(897,7544807,7544805,'000',3.333,3),(897,7544808,7544805,'00c',3.333,3),(897,7544809,7544805,'0c2',3.333,3),(897,7544810,7544805,'c29',3.333,3),(897,7544811,7544805,'29e',3.333,3),(897,7544812,7544805,'9e4',3.333,3),(897,7544813,7544805,'e40',3.333,3),(897,7544814,7544805,'407',3.333,3),(897,7544815,7544805,'078',3.333,3),(897,7544816,7544805,'78c',3.333,3),(897,7544817,7544805,'8cf',3.333,3),(897,7544818,7544805,'cf4',3.333,3),(897,7544819,7544805,'f49',3.333,3),(897,7544820,7544805,'496',3.333,3),(897,7544821,7544805,'962',3.333,3),(897,7544822,7544805,'625',3.333,3),(897,7544823,7544805,'25e',3.333,3),(897,7544824,7544805,'5e3',3.333,3),(897,7544825,7544805,'e3e',3.333,3),(897,7544826,7544805,'3ee',3.333,3),(897,7544827,7544805,'ee8',3.333,3),(897,7544828,7544805,'e82',3.333,3),(897,7544829,7544805,'82e',3.333,3),(897,7544830,7544805,'2e5',3.333,3),(897,7544831,7544805,'e57',3.333,3),(897,7544832,7544805,'576',3.333,3),(897,7544833,7544805,'761',3.333,3),(897,7544834,7544805,'61d',3.333,3),(897,7544835,7544805,'1d9',3.333,3),(897,7544836,7544806,'mon',100,1),(897,7544837,7544836,'201',50,1),(897,7544838,7544836,'013',50,1),(897,7544839,7544837,'adm',33.333,4),(897,7544840,7544837,'dmi',33.333,4),(897,7544841,7544837,'min',33.333,4),(897,7544842,7544839,'cap',16.667,1),(897,7544843,7544839,'apa',16.667,1),(897,7544844,7544839,'pac',16.667,1),(897,7544845,7544839,'aci',16.667,1),(897,7544846,7544839,'cit',16.667,1),(897,7544847,7544839,'ity',16.667,1),(897,7544848,7544842,'pat',50,1),(897,7544849,7544842,'ath',50,1),(897,7544850,7544848,'fre',14.286,1),(897,7544851,7544848,'ree',14.286,1),(897,7544852,7544848,'ees',14.286,1),(897,7544853,7544848,'esp',14.286,1),(897,7544854,7544848,'spa',14.286,1),(897,7544855,7544848,'pac',14.286,1),(897,7544856,7544848,'ace',14.286,1),(897,7544857,7544850,'dis',50,1),(897,7544858,7544850,'isk',50,1),(897,7544859,7544857,'ind',33.333,1),(897,7544860,7544857,'nde',33.333,1),(897,7544861,7544857,'dex',33.333,1),(897,7544862,7544859,'adm',8.333,1),(897,7544863,7544859,'dmi',8.333,1),(897,7544864,7544859,'min',8.333,1),(897,7544865,7544859,'ini',8.333,1),(897,7544866,7544859,'nis',8.333,1),(897,7544867,7544859,'ist',8.333,1),(897,7544868,7544859,'str',8.333,1),(897,7544869,7544859,'tra',8.333,1),(897,7544870,7544859,'rat',8.333,1),(897,7544871,7544859,'ati',8.333,1),(897,7544872,7544859,'tio',8.333,1),(897,7544873,7544859,'ion',8.333,1),(897,7544874,7544862,'sta',33.333,3),(897,7544875,7544862,'tat',33.333,3),(897,7544876,7544862,'ate',33.333,3),(897,7544877,7544874,'dis',16.667,4),(897,7544878,7544874,'isa',16.667,4),(897,7544879,7544874,'sab',16.667,4),(897,7544880,7544874,'abl',16.667,4),(897,7544881,7544874,'ble',16.667,4),(897,7544882,7544874,'led',16.667,4),(897,7544883,7544877,'cac',33.333,1),(897,7544884,7544877,'ach',33.333,1),(897,7544885,7544877,'che',33.333,1),(897,7544886,7544883,'mod',50,1),(897,7544887,7544883,'ode',50,1),(897,7544888,7544886,'wri',14.286,1),(897,7544889,7544886,'rit',14.286,1),(897,7544890,7544886,'ite',14.286,1),(897,7544891,7544886,'tet',14.286,1),(897,7544892,7544886,'eth',14.286,1),(897,7544893,7544886,'thr',14.286,1),(897,7544894,7544886,'hru',14.286,1),(897,7544895,7544888,'ope',11.111,2),(897,7544896,7544888,'per',11.111,2),(897,7544897,7544888,'era',11.111,2),(897,7544898,7544888,'rat',11.111,2),(897,7544899,7544888,'ati',11.111,2),(897,7544900,7544888,'tio',11.111,2),(897,7544901,7544888,'ion',11.111,2),(897,7544902,7544888,'ona',11.111,2),(897,7544903,7544888,'nal',11.111,2),(897,7544904,7544895,'mes',20,1),(897,7544905,7544895,'ess',20,1),(897,7544906,7544895,'ssa',20,1),(897,7544907,7544895,'sag',20,1),(897,7544908,7544895,'age',20,1),(897,7544909,7544904,'per',11.111,1),(897,7544910,7544904,'erf',11.111,1),(897,7544911,7544904,'rfo',11.111,1),(897,7544912,7544904,'for',11.111,1),(897,7544913,7544904,'orm',11.111,1),(897,7544914,7544904,'rma',11.111,1),(897,7544915,7544904,'man',11.111,1),(897,7544916,7544904,'anc',11.111,1),(897,7544917,7544904,'nce',11.111,1),(897,7544918,7544909,'ide',12.5,1),(897,7544919,7544909,'den',12.5,1),(897,7544920,7544909,'ent',12.5,1),(897,7544921,7544909,'nti',12.5,1),(897,7544922,7544909,'tif',12.5,1),(897,7544923,7544909,'ifi',12.5,1),(897,7544924,7544909,'fie',12.5,1),(897,7544925,7544909,'ier',12.5,1),(897,7544926,7544918,'vdi',33.333,3),(897,7544927,7544918,'dis',33.333,3),(897,7544928,7544918,'isk',33.333,3),(897,7544929,7544926,'nam',50,1),(897,7544930,7544926,'ame',50,1),(897,7544931,7544929,'typ',50,1),(897,7544932,7544929,'ype',50,1),(897,7544933,7544931,'dir',25,1),(897,7544934,7544931,'ire',25,1),(897,7544935,7544931,'rec',25,1),(897,7544936,7544931,'ect',25,1),(898,7544938,7544937,'naa',100,2),(898,7544939,7544938,'600',3.333,3),(898,7544940,7544938,'000',3.333,3),(898,7544941,7544938,'00c',3.333,3),(898,7544942,7544938,'0c2',3.333,3),(898,7544943,7544938,'c29',3.333,3),(898,7544944,7544938,'291',3.333,3),(898,7544945,7544938,'91c',3.333,3),(898,7544946,7544938,'1c6',3.333,3),(898,7544947,7544938,'c65',3.333,3),(898,7544948,7544938,'65e',3.333,3),(898,7544949,7544938,'5ea',3.333,3),(898,7544950,7544938,'ea1',3.333,3),(898,7544951,7544938,'a12',3.333,3),(898,7544952,7544938,'129',3.333,3),(898,7544953,7544938,'29b',3.333,3),(898,7544954,7544938,'9b7',3.333,3),(898,7544955,7544938,'b7c',3.333,3),(898,7544956,7544938,'7ce',3.333,3),(898,7544957,7544938,'cee',3.333,3),(898,7544958,7544938,'ee8',3.333,3),(898,7544959,7544938,'e80',3.333,3),(898,7544960,7544938,'802',3.333,3),(898,7544961,7544938,'02f',3.333,3),(898,7544962,7544938,'2f4',3.333,3),(898,7544963,7544938,'f4c',3.333,3),(898,7544964,7544938,'4cd',3.333,3),(898,7544965,7544938,'cdb',3.333,3),(898,7544966,7544938,'dbc',3.333,3),(898,7544967,7544938,'bc3',3.333,3),(898,7544968,7544938,'c3e',3.333,3),(898,7544969,7544939,'mon',100,1),(898,7544970,7544969,'201',50,1),(898,7544971,7544969,'013',50,1),(898,7544972,7544970,'adm',33.333,4),(898,7544973,7544970,'dmi',33.333,4),(898,7544974,7544970,'min',33.333,4),(898,7544975,7544972,'cap',16.667,1),(898,7544976,7544972,'apa',16.667,1),(898,7544977,7544972,'pac',16.667,1),(898,7544978,7544972,'aci',16.667,1),(898,7544979,7544972,'cit',16.667,1),(898,7544980,7544972,'ity',16.667,1),(898,7544981,7544975,'pat',50,1),(898,7544982,7544975,'ath',50,1),(898,7544983,7544981,'fre',14.286,1),(898,7544984,7544981,'ree',14.286,1),(898,7544985,7544981,'ees',14.286,1),(898,7544986,7544981,'esp',14.286,1),(898,7544987,7544981,'spa',14.286,1),(898,7544988,7544981,'pac',14.286,1),(898,7544989,7544981,'ace',14.286,1),(898,7544990,7544983,'dis',50,1),(898,7544991,7544983,'isk',50,1),(898,7544992,7544990,'ind',33.333,1),(898,7544993,7544990,'nde',33.333,1),(898,7544994,7544990,'dex',33.333,1),(898,7544995,7544992,'adm',8.333,1),(898,7544996,7544992,'dmi',8.333,1),(898,7544997,7544992,'min',8.333,1),(898,7544998,7544992,'ini',8.333,1),(898,7544999,7544992,'nis',8.333,1),(898,7545000,7544992,'ist',8.333,1),(898,7545001,7544992,'str',8.333,1),(898,7545002,7544992,'tra',8.333,1),(898,7545003,7544992,'rat',8.333,1),(898,7545004,7544992,'ati',8.333,1),(898,7545005,7544992,'tio',8.333,1),(898,7545006,7544992,'ion',8.333,1),(898,7545007,7544995,'sta',33.333,3),(898,7545008,7544995,'tat',33.333,3),(898,7545009,7544995,'ate',33.333,3),(898,7545010,7545007,'dis',16.667,4),(898,7545011,7545007,'isa',16.667,4),(898,7545012,7545007,'sab',16.667,4),(898,7545013,7545007,'abl',16.667,4),(898,7545014,7545007,'ble',16.667,4),(898,7545015,7545007,'led',16.667,4),(898,7545016,7545010,'cac',33.333,1),(898,7545017,7545010,'ach',33.333,1),(898,7545018,7545010,'che',33.333,1),(898,7545019,7545016,'mod',50,1),(898,7545020,7545016,'ode',50,1),(898,7545021,7545019,'wri',14.286,1),(898,7545022,7545019,'rit',14.286,1),(898,7545023,7545019,'ite',14.286,1),(898,7545024,7545019,'tet',14.286,1),(898,7545025,7545019,'eth',14.286,1),(898,7545026,7545019,'thr',14.286,1),(898,7545027,7545019,'hru',14.286,1),(898,7545028,7545021,'ope',11.111,2),(898,7545029,7545021,'per',11.111,2),(898,7545030,7545021,'era',11.111,2),(898,7545031,7545021,'rat',11.111,2),(898,7545032,7545021,'ati',11.111,2),(898,7545033,7545021,'tio',11.111,2),(898,7545034,7545021,'ion',11.111,2),(898,7545035,7545021,'ona',11.111,2),(898,7545036,7545021,'nal',11.111,2),(898,7545037,7545028,'mes',20,1),(898,7545038,7545028,'ess',20,1),(898,7545039,7545028,'ssa',20,1),(898,7545040,7545028,'sag',20,1),(898,7545041,7545028,'age',20,1),(898,7545042,7545037,'per',11.111,1),(898,7545043,7545037,'erf',11.111,1),(898,7545044,7545037,'rfo',11.111,1),(898,7545045,7545037,'for',11.111,1),(898,7545046,7545037,'orm',11.111,1),(898,7545047,7545037,'rma',11.111,1),(898,7545048,7545037,'man',11.111,1),(898,7545049,7545037,'anc',11.111,1),(898,7545050,7545037,'nce',11.111,1),(898,7545051,7545042,'ide',12.5,1),(898,7545052,7545042,'den',12.5,1),(898,7545053,7545042,'ent',12.5,1),(898,7545054,7545042,'nti',12.5,1),(898,7545055,7545042,'tif',12.5,1),(898,7545056,7545042,'ifi',12.5,1),(898,7545057,7545042,'fie',12.5,1),(898,7545058,7545042,'ier',12.5,1),(898,7545059,7545051,'vdi',33.333,3),(898,7545060,7545051,'dis',33.333,3),(898,7545061,7545051,'isk',33.333,3),(898,7545062,7545059,'nam',50,1),(898,7545063,7545059,'ame',50,1),(898,7545064,7545062,'typ',50,1),(898,7545065,7545062,'ype',50,1),(898,7545066,7545064,'dir',25,1),(898,7545067,7545064,'ire',25,1),(898,7545068,7545064,'rec',25,1),(898,7545069,7545064,'ect',25,1),(899,7545071,7545070,'naa',100,2),(899,7545072,7545071,'600',3.333,3),(899,7545073,7545071,'000',3.333,3),(899,7545074,7545071,'00c',3.333,3),(899,7545075,7545071,'0c2',3.333,3),(899,7545076,7545071,'c29',3.333,3),(899,7545077,7545071,'291',3.333,3),(899,7545078,7545071,'915',3.333,3),(899,7545079,7545071,'159',3.333,3),(899,7545080,7545071,'59c',3.333,3),(899,7545081,7545071,'9ce',3.333,3),(899,7545082,7545071,'cee',3.333,3),(899,7545083,7545071,'eea',3.333,3),(899,7545084,7545071,'eaa',3.333,3),(899,7545085,7545071,'aa2',3.333,3),(899,7545086,7545071,'a2d',3.333,3),(899,7545087,7545071,'2db',3.333,3),(899,7545088,7545071,'db1',3.333,3),(899,7545089,7545071,'b18',3.333,3),(899,7545090,7545071,'18c',3.333,3),(899,7545091,7545071,'8c5',3.333,3),(899,7545092,7545071,'c5b',3.333,3),(899,7545093,7545071,'5b0',3.333,3),(899,7545094,7545071,'b00',3.333,3),(899,7545095,7545071,'00e',3.333,3),(899,7545096,7545071,'0eb',3.333,3),(899,7545097,7545071,'eb7',3.333,3),(899,7545098,7545071,'b77',3.333,3),(899,7545099,7545071,'77c',3.333,3),(899,7545100,7545071,'7ca',3.333,3),(899,7545101,7545071,'cac',3.333,3),(899,7545102,7545072,'mon',100,1),(899,7545103,7545102,'201',50,1),(899,7545104,7545102,'013',50,1),(899,7545105,7545103,'adm',33.333,4),(899,7545106,7545103,'dmi',33.333,4),(899,7545107,7545103,'min',33.333,4),(899,7545108,7545105,'cap',16.667,1),(899,7545109,7545105,'apa',16.667,1),(899,7545110,7545105,'pac',16.667,1),(899,7545111,7545105,'aci',16.667,1),(899,7545112,7545105,'cit',16.667,1),(899,7545113,7545105,'ity',16.667,1),(899,7545114,7545108,'pat',50,1),(899,7545115,7545108,'ath',50,1),(899,7545116,7545114,'fre',14.286,1),(899,7545117,7545114,'ree',14.286,1),(899,7545118,7545114,'ees',14.286,1),(899,7545119,7545114,'esp',14.286,1),(899,7545120,7545114,'spa',14.286,1),(899,7545121,7545114,'pac',14.286,1),(899,7545122,7545114,'ace',14.286,1),(899,7545123,7545116,'dis',50,1),(899,7545124,7545116,'isk',50,1),(899,7545125,7545123,'ind',33.333,1),(899,7545126,7545123,'nde',33.333,1),(899,7545127,7545123,'dex',33.333,1),(899,7545128,7545125,'adm',8.333,1),(899,7545129,7545125,'dmi',8.333,1),(899,7545130,7545125,'min',8.333,1),(899,7545131,7545125,'ini',8.333,1),(899,7545132,7545125,'nis',8.333,1),(899,7545133,7545125,'ist',8.333,1),(899,7545134,7545125,'str',8.333,1),(899,7545135,7545125,'tra',8.333,1),(899,7545136,7545125,'rat',8.333,1),(899,7545137,7545125,'ati',8.333,1),(899,7545138,7545125,'tio',8.333,1),(899,7545139,7545125,'ion',8.333,1),(899,7545140,7545128,'sta',33.333,3),(899,7545141,7545128,'tat',33.333,3),(899,7545142,7545128,'ate',33.333,3),(899,7545143,7545140,'dis',16.667,4),(899,7545144,7545140,'isa',16.667,4),(899,7545145,7545140,'sab',16.667,4),(899,7545146,7545140,'abl',16.667,4),(899,7545147,7545140,'ble',16.667,4),(899,7545148,7545140,'led',16.667,4),(899,7545149,7545143,'cac',33.333,1),(899,7545150,7545143,'ach',33.333,1),(899,7545151,7545143,'che',33.333,1),(899,7545152,7545149,'mod',50,1),(899,7545153,7545149,'ode',50,1),(899,7545154,7545152,'wri',14.286,1),(899,7545155,7545152,'rit',14.286,1),(899,7545156,7545152,'ite',14.286,1),(899,7545157,7545152,'tet',14.286,1),(899,7545158,7545152,'eth',14.286,1),(899,7545159,7545152,'thr',14.286,1),(899,7545160,7545152,'hru',14.286,1),(899,7545161,7545154,'ope',11.111,2),(899,7545162,7545154,'per',11.111,2),(899,7545163,7545154,'era',11.111,2),(899,7545164,7545154,'rat',11.111,2),(899,7545165,7545154,'ati',11.111,2),(899,7545166,7545154,'tio',11.111,2),(899,7545167,7545154,'ion',11.111,2),(899,7545168,7545154,'ona',11.111,2),(899,7545169,7545154,'nal',11.111,2),(899,7545170,7545161,'mes',20,1),(899,7545171,7545161,'ess',20,1),(899,7545172,7545161,'ssa',20,1),(899,7545173,7545161,'sag',20,1),(899,7545174,7545161,'age',20,1),(899,7545175,7545170,'per',11.111,1),(899,7545176,7545170,'erf',11.111,1),(899,7545177,7545170,'rfo',11.111,1),(899,7545178,7545170,'for',11.111,1),(899,7545179,7545170,'orm',11.111,1),(899,7545180,7545170,'rma',11.111,1),(899,7545181,7545170,'man',11.111,1),(899,7545182,7545170,'anc',11.111,1),(899,7545183,7545170,'nce',11.111,1),(899,7545184,7545175,'ide',12.5,1),(899,7545185,7545175,'den',12.5,1),(899,7545186,7545175,'ent',12.5,1),(899,7545187,7545175,'nti',12.5,1),(899,7545188,7545175,'tif',12.5,1),(899,7545189,7545175,'ifi',12.5,1),(899,7545190,7545175,'fie',12.5,1),(899,7545191,7545175,'ier',12.5,1),(899,7545192,7545184,'vdi',33.333,3),(899,7545193,7545184,'dis',33.333,3),(899,7545194,7545184,'isk',33.333,3),(899,7545195,7545192,'nam',50,1),(899,7545196,7545192,'ame',50,1),(899,7545197,7545195,'typ',50,1),(899,7545198,7545195,'ype',50,1),(899,7545199,7545197,'dir',25,1),(899,7545200,7545197,'ire',25,1),(899,7545201,7545197,'rec',25,1),(899,7545202,7545197,'ect',25,1),(900,7545204,7545203,'naa',100,2),(900,7545205,7545204,'600',3.333,3),(900,7545206,7545204,'000',3.333,3),(900,7545207,7545204,'00c',3.333,3),(900,7545208,7545204,'0c2',3.333,3),(900,7545209,7545204,'c29',3.333,3),(900,7545210,7545204,'29e',3.333,3),(900,7545211,7545204,'9e2',3.333,3),(900,7545212,7545204,'e28',3.333,3),(900,7545213,7545204,'28d',3.333,3),(900,7545214,7545204,'8df',3.333,3),(900,7545215,7545204,'df1',3.333,3),(900,7545216,7545204,'f12',3.333,3),(900,7545217,7545204,'12d',3.333,3),(900,7545218,7545204,'2df',3.333,3),(900,7545219,7545204,'dfd',3.333,3),(900,7545220,7545204,'fd2',3.333,3),(900,7545221,7545204,'d28',3.333,3),(900,7545222,7545204,'283',3.333,3),(900,7545223,7545204,'83a',3.333,3),(900,7545224,7545204,'3aa',3.333,3),(900,7545225,7545204,'aaa',3.333,3),(900,7545226,7545204,'aa8',3.333,3),(900,7545227,7545204,'a8e',3.333,3),(900,7545228,7545204,'8ea',3.333,3),(900,7545229,7545204,'ea2',3.333,3),(900,7545230,7545204,'a29',3.333,3),(900,7545231,7545204,'29b',3.333,3),(900,7545232,7545204,'9b5',3.333,3),(900,7545233,7545204,'b5b',3.333,3),(900,7545234,7545204,'5bf',3.333,3),(900,7545235,7545205,'mon',100,1),(900,7545236,7545235,'201',50,1),(900,7545237,7545235,'013',50,1),(900,7545238,7545236,'adm',33.333,4),(900,7545239,7545236,'dmi',33.333,4),(900,7545240,7545236,'min',33.333,4),(900,7545241,7545238,'cap',16.667,1),(900,7545242,7545238,'apa',16.667,1),(900,7545243,7545238,'pac',16.667,1),(900,7545244,7545238,'aci',16.667,1),(900,7545245,7545238,'cit',16.667,1),(900,7545246,7545238,'ity',16.667,1),(900,7545247,7545241,'pat',50,1),(900,7545248,7545241,'ath',50,1),(900,7545249,7545247,'fre',14.286,1),(900,7545250,7545247,'ree',14.286,1),(900,7545251,7545247,'ees',14.286,1),(900,7545252,7545247,'esp',14.286,1),(900,7545253,7545247,'spa',14.286,1),(900,7545254,7545247,'pac',14.286,1),(900,7545255,7545247,'ace',14.286,1),(900,7545256,7545249,'dis',50,1),(900,7545257,7545249,'isk',50,1),(900,7545258,7545256,'ind',33.333,1),(900,7545259,7545256,'nde',33.333,1),(900,7545260,7545256,'dex',33.333,1),(900,7545261,7545258,'adm',8.333,1),(900,7545262,7545258,'dmi',8.333,1),(900,7545263,7545258,'min',8.333,1),(900,7545264,7545258,'ini',8.333,1),(900,7545265,7545258,'nis',8.333,1),(900,7545266,7545258,'ist',8.333,1),(900,7545267,7545258,'str',8.333,1),(900,7545268,7545258,'tra',8.333,1),(900,7545269,7545258,'rat',8.333,1),(900,7545270,7545258,'ati',8.333,1),(900,7545271,7545258,'tio',8.333,1),(900,7545272,7545258,'ion',8.333,1),(900,7545273,7545261,'sta',33.333,3),(900,7545274,7545261,'tat',33.333,3),(900,7545275,7545261,'ate',33.333,3),(900,7545276,7545273,'dis',16.667,4),(900,7545277,7545273,'isa',16.667,4),(900,7545278,7545273,'sab',16.667,4),(900,7545279,7545273,'abl',16.667,4),(900,7545280,7545273,'ble',16.667,4),(900,7545281,7545273,'led',16.667,4),(900,7545282,7545276,'cac',33.333,1),(900,7545283,7545276,'ach',33.333,1),(900,7545284,7545276,'che',33.333,1),(900,7545285,7545282,'mod',50,1),(900,7545286,7545282,'ode',50,1),(900,7545287,7545285,'wri',14.286,1),(900,7545288,7545285,'rit',14.286,1),(900,7545289,7545285,'ite',14.286,1),(900,7545290,7545285,'tet',14.286,1),(900,7545291,7545285,'eth',14.286,1),(900,7545292,7545285,'thr',14.286,1),(900,7545293,7545285,'hru',14.286,1),(900,7545294,7545287,'ope',11.111,2),(900,7545295,7545287,'per',11.111,2),(900,7545296,7545287,'era',11.111,2),(900,7545297,7545287,'rat',11.111,2),(900,7545298,7545287,'ati',11.111,2),(900,7545299,7545287,'tio',11.111,2),(900,7545300,7545287,'ion',11.111,2),(900,7545301,7545287,'ona',11.111,2),(900,7545302,7545287,'nal',11.111,2),(900,7545303,7545294,'mes',20,1),(900,7545304,7545294,'ess',20,1),(900,7545305,7545294,'ssa',20,1),(900,7545306,7545294,'sag',20,1),(900,7545307,7545294,'age',20,1),(900,7545308,7545303,'per',11.111,1),(900,7545309,7545303,'erf',11.111,1),(900,7545310,7545303,'rfo',11.111,1),(900,7545311,7545303,'for',11.111,1),(900,7545312,7545303,'orm',11.111,1),(900,7545313,7545303,'rma',11.111,1),(900,7545314,7545303,'man',11.111,1),(900,7545315,7545303,'anc',11.111,1),(900,7545316,7545303,'nce',11.111,1),(900,7545317,7545308,'ide',12.5,1),(900,7545318,7545308,'den',12.5,1),(900,7545319,7545308,'ent',12.5,1),(900,7545320,7545308,'nti',12.5,1),(900,7545321,7545308,'tif',12.5,1),(900,7545322,7545308,'ifi',12.5,1),(900,7545323,7545308,'fie',12.5,1),(900,7545324,7545308,'ier',12.5,1),(900,7545325,7545317,'vdi',33.333,3),(900,7545326,7545317,'dis',33.333,3),(900,7545327,7545317,'isk',33.333,3),(900,7545328,7545325,'nam',50,1),(900,7545329,7545325,'ame',50,1),(900,7545330,7545328,'typ',50,1),(900,7545331,7545328,'ype',50,1),(900,7545332,7545330,'dir',25,1),(900,7545333,7545330,'ire',25,1),(900,7545334,7545330,'rec',25,1),(900,7545335,7545330,'ect',25,1),(901,7545337,7545336,'naa',100,2),(901,7545338,7545337,'600',3.333,3),(901,7545339,7545337,'000',3.333,3),(901,7545340,7545337,'00c',3.333,3),(901,7545341,7545337,'0c2',3.333,3),(901,7545342,7545337,'c29',3.333,3),(901,7545343,7545337,'29b',3.333,3),(901,7545344,7545337,'9ba',3.333,3),(901,7545345,7545337,'ba0',3.333,3),(901,7545346,7545337,'a09',3.333,3),(901,7545347,7545337,'09c',3.333,3),(901,7545348,7545337,'9cb',3.333,3),(901,7545349,7545337,'cbd',3.333,3),(901,7545350,7545337,'bd0',3.333,3),(901,7545351,7545337,'d0b',3.333,3),(901,7545352,7545337,'0ba',3.333,3),(901,7545353,7545337,'ba1',3.333,3),(901,7545354,7545337,'a1f',3.333,3),(901,7545355,7545337,'1fc',3.333,3),(901,7545356,7545337,'fc5',3.333,3),(901,7545357,7545337,'c5e',3.333,3),(901,7545358,7545337,'5ee',3.333,3),(901,7545359,7545337,'ee4',3.333,3),(901,7545360,7545337,'e4b',3.333,3),(901,7545361,7545337,'4b1',3.333,3),(901,7545362,7545337,'b10',3.333,3),(901,7545363,7545337,'10b',3.333,3),(901,7545364,7545337,'0b8',3.333,3),(901,7545365,7545337,'b8e',3.333,3),(901,7545366,7545337,'8eb',3.333,3),(901,7545367,7545337,'ebe',3.333,3),(901,7545368,7545338,'mon',100,1),(901,7545369,7545368,'201',50,1),(901,7545370,7545368,'013',50,1),(901,7545371,7545369,'adm',33.333,4),(901,7545372,7545369,'dmi',33.333,4),(901,7545373,7545369,'min',33.333,4),(901,7545374,7545371,'cap',16.667,1),(901,7545375,7545371,'apa',16.667,1),(901,7545376,7545371,'pac',16.667,1),(901,7545377,7545371,'aci',16.667,1),(901,7545378,7545371,'cit',16.667,1),(901,7545379,7545371,'ity',16.667,1),(901,7545380,7545374,'pat',50,1),(901,7545381,7545374,'ath',50,1),(901,7545382,7545380,'fre',14.286,1),(901,7545383,7545380,'ree',14.286,1),(901,7545384,7545380,'ees',14.286,1),(901,7545385,7545380,'esp',14.286,1),(901,7545386,7545380,'spa',14.286,1),(901,7545387,7545380,'pac',14.286,1),(901,7545388,7545380,'ace',14.286,1),(901,7545389,7545382,'dis',50,1),(901,7545390,7545382,'isk',50,1),(901,7545391,7545389,'ind',33.333,1),(901,7545392,7545389,'nde',33.333,1),(901,7545393,7545389,'dex',33.333,1),(901,7545394,7545391,'adm',8.333,1),(901,7545395,7545391,'dmi',8.333,1),(901,7545396,7545391,'min',8.333,1),(901,7545397,7545391,'ini',8.333,1),(901,7545398,7545391,'nis',8.333,1),(901,7545399,7545391,'ist',8.333,1),(901,7545400,7545391,'str',8.333,1),(901,7545401,7545391,'tra',8.333,1),(901,7545402,7545391,'rat',8.333,1),(901,7545403,7545391,'ati',8.333,1),(901,7545404,7545391,'tio',8.333,1),(901,7545405,7545391,'ion',8.333,1),(901,7545406,7545394,'sta',33.333,3),(901,7545407,7545394,'tat',33.333,3),(901,7545408,7545394,'ate',33.333,3),(901,7545409,7545406,'dis',16.667,4),(901,7545410,7545406,'isa',16.667,4),(901,7545411,7545406,'sab',16.667,4),(901,7545412,7545406,'abl',16.667,4),(901,7545413,7545406,'ble',16.667,4),(901,7545414,7545406,'led',16.667,4),(901,7545415,7545409,'cac',33.333,1),(901,7545416,7545409,'ach',33.333,1),(901,7545417,7545409,'che',33.333,1),(901,7545418,7545415,'mod',50,1),(901,7545419,7545415,'ode',50,1),(901,7545420,7545418,'wri',14.286,1),(901,7545421,7545418,'rit',14.286,1),(901,7545422,7545418,'ite',14.286,1),(901,7545423,7545418,'tet',14.286,1),(901,7545424,7545418,'eth',14.286,1),(901,7545425,7545418,'thr',14.286,1),(901,7545426,7545418,'hru',14.286,1),(901,7545427,7545420,'ope',11.111,2),(901,7545428,7545420,'per',11.111,2),(901,7545429,7545420,'era',11.111,2),(901,7545430,7545420,'rat',11.111,2),(901,7545431,7545420,'ati',11.111,2),(901,7545432,7545420,'tio',11.111,2),(901,7545433,7545420,'ion',11.111,2),(901,7545434,7545420,'ona',11.111,2),(901,7545435,7545420,'nal',11.111,2),(901,7545436,7545427,'mes',20,1),(901,7545437,7545427,'ess',20,1),(901,7545438,7545427,'ssa',20,1),(901,7545439,7545427,'sag',20,1),(901,7545440,7545427,'age',20,1),(901,7545441,7545436,'per',11.111,1),(901,7545442,7545436,'erf',11.111,1),(901,7545443,7545436,'rfo',11.111,1),(901,7545444,7545436,'for',11.111,1),(901,7545445,7545436,'orm',11.111,1),(901,7545446,7545436,'rma',11.111,1),(901,7545447,7545436,'man',11.111,1),(901,7545448,7545436,'anc',11.111,1),(901,7545449,7545436,'nce',11.111,1),(901,7545450,7545441,'ide',12.5,1),(901,7545451,7545441,'den',12.5,1),(901,7545452,7545441,'ent',12.5,1),(901,7545453,7545441,'nti',12.5,1),(901,7545454,7545441,'tif',12.5,1),(901,7545455,7545441,'ifi',12.5,1),(901,7545456,7545441,'fie',12.5,1),(901,7545457,7545441,'ier',12.5,1),(901,7545458,7545450,'vdi',33.333,3),(901,7545459,7545450,'dis',33.333,3),(901,7545460,7545450,'isk',33.333,3),(901,7545461,7545458,'nam',50,1),(901,7545462,7545458,'ame',50,1),(901,7545463,7545461,'typ',50,1),(901,7545464,7545461,'ype',50,1),(901,7545465,7545463,'dir',25,1),(901,7545466,7545463,'ire',25,1),(901,7545467,7545463,'rec',25,1),(901,7545468,7545463,'ect',25,1),(902,7545470,7545469,'naa',100,2),(902,7545471,7545470,'600',3.333,3),(902,7545472,7545470,'000',3.333,3),(902,7545473,7545470,'00c',3.333,3),(902,7545474,7545470,'0c2',3.333,3),(902,7545475,7545470,'c29',3.333,3),(902,7545476,7545470,'29e',3.333,3),(902,7545477,7545470,'9e5',3.333,3),(902,7545478,7545470,'e52',3.333,3),(902,7545479,7545470,'52c',3.333,3),(902,7545480,7545470,'2c9',3.333,3),(902,7545481,7545470,'c9c',3.333,3),(902,7545482,7545470,'9c7',3.333,3),(902,7545483,7545470,'c71',3.333,3),(902,7545484,7545470,'716',3.333,3),(902,7545485,7545470,'16b',3.333,3),(902,7545486,7545470,'6b6',3.333,3),(902,7545487,7545470,'b69',3.333,3),(902,7545488,7545470,'698',3.333,3),(902,7545489,7545470,'987',3.333,3),(902,7545490,7545470,'87f',3.333,3),(902,7545491,7545470,'7f9',3.333,3),(902,7545492,7545470,'f97',3.333,3),(902,7545493,7545470,'975',3.333,3),(902,7545494,7545470,'75c',3.333,3),(902,7545495,7545470,'5cd',3.333,3),(902,7545496,7545470,'cd7',3.333,3),(902,7545497,7545470,'d71',3.333,3),(902,7545498,7545470,'717',3.333,3),(902,7545499,7545470,'170',3.333,3),(902,7545500,7545470,'70a',3.333,3),(902,7545501,7545471,'mon',100,1),(902,7545502,7545501,'201',50,1),(902,7545503,7545501,'013',50,1),(902,7545504,7545502,'adm',33.333,4),(902,7545505,7545502,'dmi',33.333,4),(902,7545506,7545502,'min',33.333,4),(902,7545507,7545504,'cap',16.667,1),(902,7545508,7545504,'apa',16.667,1),(902,7545509,7545504,'pac',16.667,1),(902,7545510,7545504,'aci',16.667,1),(902,7545511,7545504,'cit',16.667,1),(902,7545512,7545504,'ity',16.667,1),(902,7545513,7545507,'pat',50,1),(902,7545514,7545507,'ath',50,1),(902,7545515,7545513,'fre',14.286,1),(902,7545516,7545513,'ree',14.286,1),(902,7545517,7545513,'ees',14.286,1),(902,7545518,7545513,'esp',14.286,1),(902,7545519,7545513,'spa',14.286,1),(902,7545520,7545513,'pac',14.286,1),(902,7545521,7545513,'ace',14.286,1),(902,7545522,7545515,'dis',50,1),(902,7545523,7545515,'isk',50,1),(902,7545524,7545522,'ind',33.333,1),(902,7545525,7545522,'nde',33.333,1),(902,7545526,7545522,'dex',33.333,1),(902,7545527,7545524,'adm',8.333,1),(902,7545528,7545524,'dmi',8.333,1),(902,7545529,7545524,'min',8.333,1),(902,7545530,7545524,'ini',8.333,1),(902,7545531,7545524,'nis',8.333,1),(902,7545532,7545524,'ist',8.333,1),(902,7545533,7545524,'str',8.333,1),(902,7545534,7545524,'tra',8.333,1),(902,7545535,7545524,'rat',8.333,1),(902,7545536,7545524,'ati',8.333,1),(902,7545537,7545524,'tio',8.333,1),(902,7545538,7545524,'ion',8.333,1),(902,7545539,7545527,'sta',33.333,3),(902,7545540,7545527,'tat',33.333,3),(902,7545541,7545527,'ate',33.333,3),(902,7545542,7545539,'dis',16.667,4),(902,7545543,7545539,'isa',16.667,4),(902,7545544,7545539,'sab',16.667,4),(902,7545545,7545539,'abl',16.667,4),(902,7545546,7545539,'ble',16.667,4),(902,7545547,7545539,'led',16.667,4),(902,7545548,7545542,'cac',33.333,1),(902,7545549,7545542,'ach',33.333,1),(902,7545550,7545542,'che',33.333,1),(902,7545551,7545548,'mod',50,1),(902,7545552,7545548,'ode',50,1),(902,7545553,7545551,'wri',14.286,1),(902,7545554,7545551,'rit',14.286,1),(902,7545555,7545551,'ite',14.286,1),(902,7545556,7545551,'tet',14.286,1),(902,7545557,7545551,'eth',14.286,1),(902,7545558,7545551,'thr',14.286,1),(902,7545559,7545551,'hru',14.286,1),(902,7545560,7545553,'ope',11.111,2),(902,7545561,7545553,'per',11.111,2),(902,7545562,7545553,'era',11.111,2),(902,7545563,7545553,'rat',11.111,2),(902,7545564,7545553,'ati',11.111,2),(902,7545565,7545553,'tio',11.111,2),(902,7545566,7545553,'ion',11.111,2),(902,7545567,7545553,'ona',11.111,2),(902,7545568,7545553,'nal',11.111,2),(902,7545569,7545560,'mes',20,1),(902,7545570,7545560,'ess',20,1),(902,7545571,7545560,'ssa',20,1),(902,7545572,7545560,'sag',20,1),(902,7545573,7545560,'age',20,1),(902,7545574,7545569,'per',11.111,1),(902,7545575,7545569,'erf',11.111,1),(902,7545576,7545569,'rfo',11.111,1),(902,7545577,7545569,'for',11.111,1),(902,7545578,7545569,'orm',11.111,1),(902,7545579,7545569,'rma',11.111,1),(902,7545580,7545569,'man',11.111,1),(902,7545581,7545569,'anc',11.111,1),(902,7545582,7545569,'nce',11.111,1),(902,7545583,7545574,'ide',12.5,1),(902,7545584,7545574,'den',12.5,1),(902,7545585,7545574,'ent',12.5,1),(902,7545586,7545574,'nti',12.5,1),(902,7545587,7545574,'tif',12.5,1),(902,7545588,7545574,'ifi',12.5,1),(902,7545589,7545574,'fie',12.5,1),(902,7545590,7545574,'ier',12.5,1),(902,7545591,7545583,'vdi',33.333,3),(902,7545592,7545583,'dis',33.333,3),(902,7545593,7545583,'isk',33.333,3),(902,7545594,7545591,'nam',50,1),(902,7545595,7545591,'ame',50,1),(902,7545596,7545594,'typ',50,1),(902,7545597,7545594,'ype',50,1),(902,7545598,7545596,'dir',25,1),(902,7545599,7545596,'ire',25,1),(902,7545600,7545596,'rec',25,1),(902,7545601,7545596,'ect',25,1),(903,7545603,7545602,'naa',100,2),(903,7545604,7545603,'600',3.333,3),(903,7545605,7545603,'000',3.333,3),(903,7545606,7545603,'00c',3.333,3),(903,7545607,7545603,'0c2',3.333,3),(903,7545608,7545603,'c29',3.333,3),(903,7545609,7545603,'293',3.333,3),(903,7545610,7545603,'93d',3.333,3),(903,7545611,7545603,'3d6',3.333,3),(903,7545612,7545603,'d60',3.333,3),(903,7545613,7545603,'60f',3.333,3),(903,7545614,7545603,'0f9',3.333,3),(903,7545615,7545603,'f9e',3.333,3),(903,7545616,7545603,'9e6',3.333,3),(903,7545617,7545603,'e6c',3.333,3),(903,7545618,7545603,'6ce',3.333,3),(903,7545619,7545603,'ce3',3.333,3),(903,7545620,7545603,'e3f',3.333,3),(903,7545621,7545603,'3fa',3.333,3),(903,7545622,7545603,'fa1',3.333,3),(903,7545623,7545603,'a13',3.333,3),(903,7545624,7545603,'138',3.333,3),(903,7545625,7545603,'388',3.333,3),(903,7545626,7545603,'88e',3.333,3),(903,7545627,7545603,'8ed',3.333,3),(903,7545628,7545603,'edd',3.333,3),(903,7545629,7545603,'ddf',3.333,3),(903,7545630,7545603,'df3',3.333,3),(903,7545631,7545603,'f33',3.333,3),(903,7545632,7545603,'331',3.333,3),(903,7545633,7545603,'311',3.333,3),(903,7545634,7545604,'mon',100,1),(903,7545635,7545634,'201',50,1),(903,7545636,7545634,'013',50,1),(903,7545637,7545635,'adm',33.333,4),(903,7545638,7545635,'dmi',33.333,4),(903,7545639,7545635,'min',33.333,4),(903,7545640,7545637,'cap',16.667,1),(903,7545641,7545637,'apa',16.667,1),(903,7545642,7545637,'pac',16.667,1),(903,7545643,7545637,'aci',16.667,1),(903,7545644,7545637,'cit',16.667,1),(903,7545645,7545637,'ity',16.667,1),(903,7545646,7545640,'pat',50,1),(903,7545647,7545640,'ath',50,1),(903,7545648,7545646,'fre',14.286,1),(903,7545649,7545646,'ree',14.286,1),(903,7545650,7545646,'ees',14.286,1),(903,7545651,7545646,'esp',14.286,1),(903,7545652,7545646,'spa',14.286,1),(903,7545653,7545646,'pac',14.286,1),(903,7545654,7545646,'ace',14.286,1),(903,7545655,7545648,'dis',50,1),(903,7545656,7545648,'isk',50,1),(903,7545657,7545655,'ind',33.333,1),(903,7545658,7545655,'nde',33.333,1),(903,7545659,7545655,'dex',33.333,1),(903,7545660,7545657,'adm',8.333,1),(903,7545661,7545657,'dmi',8.333,1),(903,7545662,7545657,'min',8.333,1),(903,7545663,7545657,'ini',8.333,1),(903,7545664,7545657,'nis',8.333,1),(903,7545665,7545657,'ist',8.333,1),(903,7545666,7545657,'str',8.333,1),(903,7545667,7545657,'tra',8.333,1),(903,7545668,7545657,'rat',8.333,1),(903,7545669,7545657,'ati',8.333,1),(903,7545670,7545657,'tio',8.333,1),(903,7545671,7545657,'ion',8.333,1),(903,7545672,7545660,'sta',33.333,3),(903,7545673,7545660,'tat',33.333,3),(903,7545674,7545660,'ate',33.333,3),(903,7545675,7545672,'dis',16.667,4),(903,7545676,7545672,'isa',16.667,4),(903,7545677,7545672,'sab',16.667,4),(903,7545678,7545672,'abl',16.667,4),(903,7545679,7545672,'ble',16.667,4),(903,7545680,7545672,'led',16.667,4),(903,7545681,7545675,'cac',33.333,1),(903,7545682,7545675,'ach',33.333,1),(903,7545683,7545675,'che',33.333,1),(903,7545684,7545681,'mod',50,1),(903,7545685,7545681,'ode',50,1),(903,7545686,7545684,'wri',14.286,1),(903,7545687,7545684,'rit',14.286,1),(903,7545688,7545684,'ite',14.286,1),(903,7545689,7545684,'tet',14.286,1),(903,7545690,7545684,'eth',14.286,1),(903,7545691,7545684,'thr',14.286,1),(903,7545692,7545684,'hru',14.286,1),(903,7545693,7545686,'ope',11.111,2),(903,7545694,7545686,'per',11.111,2),(903,7545695,7545686,'era',11.111,2),(903,7545696,7545686,'rat',11.111,2),(903,7545697,7545686,'ati',11.111,2),(903,7545698,7545686,'tio',11.111,2),(903,7545699,7545686,'ion',11.111,2),(903,7545700,7545686,'ona',11.111,2),(903,7545701,7545686,'nal',11.111,2),(903,7545702,7545693,'mes',20,1),(903,7545703,7545693,'ess',20,1),(903,7545704,7545693,'ssa',20,1),(903,7545705,7545693,'sag',20,1),(903,7545706,7545693,'age',20,1),(903,7545707,7545702,'per',11.111,1),(903,7545708,7545702,'erf',11.111,1),(903,7545709,7545702,'rfo',11.111,1),(903,7545710,7545702,'for',11.111,1),(903,7545711,7545702,'orm',11.111,1),(903,7545712,7545702,'rma',11.111,1),(903,7545713,7545702,'man',11.111,1),(903,7545714,7545702,'anc',11.111,1),(903,7545715,7545702,'nce',11.111,1),(903,7545716,7545707,'ide',12.5,1),(903,7545717,7545707,'den',12.5,1),(903,7545718,7545707,'ent',12.5,1),(903,7545719,7545707,'nti',12.5,1),(903,7545720,7545707,'tif',12.5,1),(903,7545721,7545707,'ifi',12.5,1),(903,7545722,7545707,'fie',12.5,1),(903,7545723,7545707,'ier',12.5,1),(903,7545724,7545716,'vdi',33.333,3),(903,7545725,7545716,'dis',33.333,3),(903,7545726,7545716,'isk',33.333,3),(903,7545727,7545724,'nam',50,1),(903,7545728,7545724,'ame',50,1),(903,7545729,7545727,'typ',50,1),(903,7545730,7545727,'ype',50,1),(903,7545731,7545729,'dir',25,1),(903,7545732,7545729,'ire',25,1),(903,7545733,7545729,'rec',25,1),(903,7545734,7545729,'ect',25,1),(904,7545736,7545735,'naa',100,2),(904,7545737,7545736,'600',3.333,3),(904,7545738,7545736,'000',3.333,3),(904,7545739,7545736,'00c',3.333,3),(904,7545740,7545736,'0c2',3.333,3),(904,7545741,7545736,'c29',3.333,3),(904,7545742,7545736,'29b',3.333,3),(904,7545743,7545736,'9b3',3.333,3),(904,7545744,7545736,'b3d',3.333,3),(904,7545745,7545736,'3d3',3.333,3),(904,7545746,7545736,'d3a',3.333,3),(904,7545747,7545736,'3a5',3.333,3),(904,7545748,7545736,'a5c',3.333,3),(904,7545749,7545736,'5ce',3.333,3),(904,7545750,7545736,'cea',3.333,3),(904,7545751,7545736,'eaf',3.333,3),(904,7545752,7545736,'afd',3.333,3),(904,7545753,7545736,'fd2',3.333,3),(904,7545754,7545736,'d2f',3.333,3),(904,7545755,7545736,'2fd',3.333,3),(904,7545756,7545736,'fd1',3.333,3),(904,7545757,7545736,'d1f',3.333,3),(904,7545758,7545736,'1fb',3.333,3),(904,7545759,7545736,'fb7',3.333,3),(904,7545760,7545736,'b71',3.333,3),(904,7545761,7545736,'711',3.333,3),(904,7545762,7545736,'11f',3.333,3),(904,7545763,7545736,'1fe',3.333,3),(904,7545764,7545736,'fe6',3.333,3),(904,7545765,7545736,'e64',3.333,3),(904,7545766,7545736,'64c',3.333,3),(904,7545767,7545737,'mon',100,1),(904,7545768,7545767,'201',50,1),(904,7545769,7545767,'013',50,1),(904,7545770,7545768,'adm',33.333,4),(904,7545771,7545768,'dmi',33.333,4),(904,7545772,7545768,'min',33.333,4),(904,7545773,7545770,'cap',16.667,1),(904,7545774,7545770,'apa',16.667,1),(904,7545775,7545770,'pac',16.667,1),(904,7545776,7545770,'aci',16.667,1),(904,7545777,7545770,'cit',16.667,1),(904,7545778,7545770,'ity',16.667,1),(904,7545779,7545773,'pat',50,1),(904,7545780,7545773,'ath',50,1),(904,7545781,7545779,'fre',14.286,1),(904,7545782,7545779,'ree',14.286,1),(904,7545783,7545779,'ees',14.286,1),(904,7545784,7545779,'esp',14.286,1),(904,7545785,7545779,'spa',14.286,1),(904,7545786,7545779,'pac',14.286,1),(904,7545787,7545779,'ace',14.286,1),(904,7545788,7545781,'dis',50,1),(904,7545789,7545781,'isk',50,1),(904,7545790,7545788,'ind',33.333,1),(904,7545791,7545788,'nde',33.333,1),(904,7545792,7545788,'dex',33.333,1),(904,7545793,7545790,'adm',8.333,1),(904,7545794,7545790,'dmi',8.333,1),(904,7545795,7545790,'min',8.333,1),(904,7545796,7545790,'ini',8.333,1),(904,7545797,7545790,'nis',8.333,1),(904,7545798,7545790,'ist',8.333,1),(904,7545799,7545790,'str',8.333,1),(904,7545800,7545790,'tra',8.333,1),(904,7545801,7545790,'rat',8.333,1),(904,7545802,7545790,'ati',8.333,1),(904,7545803,7545790,'tio',8.333,1),(904,7545804,7545790,'ion',8.333,1),(904,7545805,7545793,'sta',33.333,3),(904,7545806,7545793,'tat',33.333,3),(904,7545807,7545793,'ate',33.333,3),(904,7545808,7545805,'dis',16.667,4),(904,7545809,7545805,'isa',16.667,4),(904,7545810,7545805,'sab',16.667,4),(904,7545811,7545805,'abl',16.667,4),(904,7545812,7545805,'ble',16.667,4),(904,7545813,7545805,'led',16.667,4),(904,7545814,7545808,'cac',33.333,1),(904,7545815,7545808,'ach',33.333,1),(904,7545816,7545808,'che',33.333,1),(904,7545817,7545814,'mod',50,1),(904,7545818,7545814,'ode',50,1),(904,7545819,7545817,'wri',14.286,1),(904,7545820,7545817,'rit',14.286,1),(904,7545821,7545817,'ite',14.286,1),(904,7545822,7545817,'tet',14.286,1),(904,7545823,7545817,'eth',14.286,1),(904,7545824,7545817,'thr',14.286,1),(904,7545825,7545817,'hru',14.286,1),(904,7545826,7545819,'ope',11.111,2),(904,7545827,7545819,'per',11.111,2),(904,7545828,7545819,'era',11.111,2),(904,7545829,7545819,'rat',11.111,2),(904,7545830,7545819,'ati',11.111,2),(904,7545831,7545819,'tio',11.111,2),(904,7545832,7545819,'ion',11.111,2),(904,7545833,7545819,'ona',11.111,2),(904,7545834,7545819,'nal',11.111,2),(904,7545835,7545826,'mes',20,1),(904,7545836,7545826,'ess',20,1),(904,7545837,7545826,'ssa',20,1),(904,7545838,7545826,'sag',20,1),(904,7545839,7545826,'age',20,1),(904,7545840,7545835,'per',11.111,1),(904,7545841,7545835,'erf',11.111,1),(904,7545842,7545835,'rfo',11.111,1),(904,7545843,7545835,'for',11.111,1),(904,7545844,7545835,'orm',11.111,1),(904,7545845,7545835,'rma',11.111,1),(904,7545846,7545835,'man',11.111,1),(904,7545847,7545835,'anc',11.111,1),(904,7545848,7545835,'nce',11.111,1),(904,7545849,7545840,'ide',12.5,1),(904,7545850,7545840,'den',12.5,1),(904,7545851,7545840,'ent',12.5,1),(904,7545852,7545840,'nti',12.5,1),(904,7545853,7545840,'tif',12.5,1),(904,7545854,7545840,'ifi',12.5,1),(904,7545855,7545840,'fie',12.5,1),(904,7545856,7545840,'ier',12.5,1),(904,7545857,7545849,'vdi',33.333,3),(904,7545858,7545849,'dis',33.333,3),(904,7545859,7545849,'isk',33.333,3),(904,7545860,7545857,'nam',50,1),(904,7545861,7545857,'ame',50,1),(904,7545862,7545860,'typ',50,1),(904,7545863,7545860,'ype',50,1),(904,7545864,7545862,'dir',25,1),(904,7545865,7545862,'ire',25,1),(904,7545866,7545862,'rec',25,1),(904,7545867,7545862,'ect',25,1),(905,7545869,7545868,'naa',100,2),(905,7545870,7545869,'600',3.333,3),(905,7545871,7545869,'000',3.333,3),(905,7545872,7545869,'00c',3.333,3),(905,7545873,7545869,'0c2',3.333,3),(905,7545874,7545869,'c29',3.333,3),(905,7545875,7545869,'294',3.333,3),(905,7545876,7545869,'943',3.333,3),(905,7545877,7545869,'43c',3.333,3),(905,7545878,7545869,'3c2',3.333,3),(905,7545879,7545869,'c2d',3.333,3),(905,7545880,7545869,'2d4',3.333,3),(905,7545881,7545869,'d46',3.333,3),(905,7545882,7545869,'465',3.333,3),(905,7545883,7545869,'653',3.333,3),(905,7545884,7545869,'536',3.333,3),(905,7545885,7545869,'369',3.333,3),(905,7545886,7545869,'69a',3.333,3),(905,7545887,7545869,'9af',3.333,3),(905,7545888,7545869,'af4',3.333,3),(905,7545889,7545869,'f4e',3.333,3),(905,7545890,7545869,'4e6',3.333,3),(905,7545891,7545869,'e60',3.333,3),(905,7545892,7545869,'603',3.333,3),(905,7545893,7545869,'03e',3.333,3),(905,7545894,7545869,'3e6',3.333,3),(905,7545895,7545869,'e6a',3.333,3),(905,7545896,7545869,'6a5',3.333,3),(905,7545897,7545869,'a55',3.333,3),(905,7545898,7545869,'554',3.333,3),(905,7545899,7545869,'54b',3.333,3),(905,7545900,7545870,'mon',100,1),(905,7545901,7545900,'201',50,1),(905,7545902,7545900,'013',50,1),(905,7545903,7545901,'adm',33.333,4),(905,7545904,7545901,'dmi',33.333,4),(905,7545905,7545901,'min',33.333,4),(905,7545906,7545903,'cap',16.667,1),(905,7545907,7545903,'apa',16.667,1),(905,7545908,7545903,'pac',16.667,1),(905,7545909,7545903,'aci',16.667,1),(905,7545910,7545903,'cit',16.667,1),(905,7545911,7545903,'ity',16.667,1),(905,7545912,7545906,'pat',50,1),(905,7545913,7545906,'ath',50,1),(905,7545914,7545912,'fre',14.286,1),(905,7545915,7545912,'ree',14.286,1),(905,7545916,7545912,'ees',14.286,1),(905,7545917,7545912,'esp',14.286,1),(905,7545918,7545912,'spa',14.286,1),(905,7545919,7545912,'pac',14.286,1),(905,7545920,7545912,'ace',14.286,1),(905,7545921,7545914,'dis',50,1),(905,7545922,7545914,'isk',50,1),(905,7545923,7545921,'ind',33.333,1),(905,7545924,7545921,'nde',33.333,1),(905,7545925,7545921,'dex',33.333,1),(905,7545926,7545923,'adm',8.333,1),(905,7545927,7545923,'dmi',8.333,1),(905,7545928,7545923,'min',8.333,1),(905,7545929,7545923,'ini',8.333,1),(905,7545930,7545923,'nis',8.333,1),(905,7545931,7545923,'ist',8.333,1),(905,7545932,7545923,'str',8.333,1),(905,7545933,7545923,'tra',8.333,1),(905,7545934,7545923,'rat',8.333,1),(905,7545935,7545923,'ati',8.333,1),(905,7545936,7545923,'tio',8.333,1),(905,7545937,7545923,'ion',8.333,1),(905,7545938,7545926,'sta',33.333,3),(905,7545939,7545926,'tat',33.333,3),(905,7545940,7545926,'ate',33.333,3),(905,7545941,7545938,'dis',16.667,4),(905,7545942,7545938,'isa',16.667,4),(905,7545943,7545938,'sab',16.667,4),(905,7545944,7545938,'abl',16.667,4),(905,7545945,7545938,'ble',16.667,4),(905,7545946,7545938,'led',16.667,4),(905,7545947,7545941,'cac',33.333,1),(905,7545948,7545941,'ach',33.333,1),(905,7545949,7545941,'che',33.333,1),(905,7545950,7545947,'mod',50,1),(905,7545951,7545947,'ode',50,1),(905,7545952,7545950,'wri',14.286,1),(905,7545953,7545950,'rit',14.286,1),(905,7545954,7545950,'ite',14.286,1),(905,7545955,7545950,'tet',14.286,1),(905,7545956,7545950,'eth',14.286,1),(905,7545957,7545950,'thr',14.286,1),(905,7545958,7545950,'hru',14.286,1),(905,7545959,7545952,'ope',11.111,2),(905,7545960,7545952,'per',11.111,2),(905,7545961,7545952,'era',11.111,2),(905,7545962,7545952,'rat',11.111,2),(905,7545963,7545952,'ati',11.111,2),(905,7545964,7545952,'tio',11.111,2),(905,7545965,7545952,'ion',11.111,2),(905,7545966,7545952,'ona',11.111,2),(905,7545967,7545952,'nal',11.111,2),(905,7545968,7545959,'mes',20,1),(905,7545969,7545959,'ess',20,1),(905,7545970,7545959,'ssa',20,1),(905,7545971,7545959,'sag',20,1),(905,7545972,7545959,'age',20,1),(905,7545973,7545968,'per',11.111,1),(905,7545974,7545968,'erf',11.111,1),(905,7545975,7545968,'rfo',11.111,1),(905,7545976,7545968,'for',11.111,1),(905,7545977,7545968,'orm',11.111,1),(905,7545978,7545968,'rma',11.111,1),(905,7545979,7545968,'man',11.111,1),(905,7545980,7545968,'anc',11.111,1),(905,7545981,7545968,'nce',11.111,1),(905,7545982,7545973,'ide',12.5,1),(905,7545983,7545973,'den',12.5,1),(905,7545984,7545973,'ent',12.5,1),(905,7545985,7545973,'nti',12.5,1),(905,7545986,7545973,'tif',12.5,1),(905,7545987,7545973,'ifi',12.5,1),(905,7545988,7545973,'fie',12.5,1),(905,7545989,7545973,'ier',12.5,1),(905,7545990,7545982,'vdi',33.333,3),(905,7545991,7545982,'dis',33.333,3),(905,7545992,7545982,'isk',33.333,3),(905,7545993,7545990,'nam',50,1),(905,7545994,7545990,'ame',50,1),(905,7545995,7545993,'typ',50,1),(905,7545996,7545993,'ype',50,1),(905,7545997,7545995,'dir',25,1),(905,7545998,7545995,'ire',25,1),(905,7545999,7545995,'rec',25,1),(905,7546000,7545995,'ect',25,1),(906,7546002,7546001,'naa',100,2),(906,7546003,7546002,'600',3.333,3),(906,7546004,7546002,'000',3.333,3),(906,7546005,7546002,'00c',3.333,3),(906,7546006,7546002,'0c2',3.333,3),(906,7546007,7546002,'c29',3.333,3),(906,7546008,7546002,'297',3.333,3),(906,7546009,7546002,'97c',3.333,3),(906,7546010,7546002,'7c2',3.333,3),(906,7546011,7546002,'c23',3.333,3),(906,7546012,7546002,'23c',3.333,3),(906,7546013,7546002,'3ce',3.333,3),(906,7546014,7546002,'ce5',3.333,3),(906,7546015,7546002,'e56',3.333,3),(906,7546016,7546002,'566',3.333,3),(906,7546017,7546002,'66e',3.333,3),(906,7546018,7546002,'6ef',3.333,3),(906,7546019,7546002,'ef1',3.333,3),(906,7546020,7546002,'f1d',3.333,3),(906,7546021,7546002,'1d1',3.333,3),(906,7546022,7546002,'d11',3.333,3),(906,7546023,7546002,'11f',3.333,3),(906,7546024,7546002,'1f9',3.333,3),(906,7546025,7546002,'f9c',3.333,3),(906,7546026,7546002,'9c4',3.333,3),(906,7546027,7546002,'c4f',3.333,3),(906,7546028,7546002,'4ff',3.333,3),(906,7546029,7546002,'ffc',3.333,3),(906,7546030,7546002,'fc5',3.333,3),(906,7546031,7546002,'c54',3.333,3),(906,7546032,7546002,'54b',3.333,3),(906,7546033,7546003,'mon',100,1),(906,7546034,7546033,'201',50,1),(906,7546035,7546033,'013',50,1),(906,7546036,7546034,'adm',33.333,4),(906,7546037,7546034,'dmi',33.333,4),(906,7546038,7546034,'min',33.333,4),(906,7546039,7546036,'cap',16.667,1),(906,7546040,7546036,'apa',16.667,1),(906,7546041,7546036,'pac',16.667,1),(906,7546042,7546036,'aci',16.667,1),(906,7546043,7546036,'cit',16.667,1),(906,7546044,7546036,'ity',16.667,1),(906,7546045,7546039,'pat',50,1),(906,7546046,7546039,'ath',50,1),(906,7546047,7546045,'one',100,1),(906,7546048,7546047,'fre',14.286,1),(906,7546049,7546047,'ree',14.286,1),(906,7546050,7546047,'ees',14.286,1),(906,7546051,7546047,'esp',14.286,1),(906,7546052,7546047,'spa',14.286,1),(906,7546053,7546047,'pac',14.286,1),(906,7546054,7546047,'ace',14.286,1),(906,7546055,7546048,'dis',50,1),(906,7546056,7546048,'isk',50,1),(906,7546057,7546055,'ind',33.333,1),(906,7546058,7546055,'nde',33.333,1),(906,7546059,7546055,'dex',33.333,1),(906,7546060,7546057,'adm',8.333,1),(906,7546061,7546057,'dmi',8.333,1),(906,7546062,7546057,'min',8.333,1),(906,7546063,7546057,'ini',8.333,1),(906,7546064,7546057,'nis',8.333,1),(906,7546065,7546057,'ist',8.333,1),(906,7546066,7546057,'str',8.333,1),(906,7546067,7546057,'tra',8.333,1),(906,7546068,7546057,'rat',8.333,1),(906,7546069,7546057,'ati',8.333,1),(906,7546070,7546057,'tio',8.333,1),(906,7546071,7546057,'ion',8.333,1),(906,7546072,7546060,'sta',33.333,3),(906,7546073,7546060,'tat',33.333,3),(906,7546074,7546060,'ate',33.333,3),(906,7546075,7546072,'dis',16.667,4),(906,7546076,7546072,'isa',16.667,4),(906,7546077,7546072,'sab',16.667,4),(906,7546078,7546072,'abl',16.667,4),(906,7546079,7546072,'ble',16.667,4),(906,7546080,7546072,'led',16.667,4),(906,7546081,7546075,'cac',33.333,1),(906,7546082,7546075,'ach',33.333,1),(906,7546083,7546075,'che',33.333,1),(906,7546084,7546081,'mod',50,1),(906,7546085,7546081,'ode',50,1),(906,7546086,7546084,'wri',14.286,1),(906,7546087,7546084,'rit',14.286,1),(906,7546088,7546084,'ite',14.286,1),(906,7546089,7546084,'tet',14.286,1),(906,7546090,7546084,'eth',14.286,1),(906,7546091,7546084,'thr',14.286,1),(906,7546092,7546084,'hru',14.286,1),(906,7546093,7546086,'ope',11.111,2),(906,7546094,7546086,'per',11.111,2),(906,7546095,7546086,'era',11.111,2),(906,7546096,7546086,'rat',11.111,2),(906,7546097,7546086,'ati',11.111,2),(906,7546098,7546086,'tio',11.111,2),(906,7546099,7546086,'ion',11.111,2),(906,7546100,7546086,'ona',11.111,2),(906,7546101,7546086,'nal',11.111,2),(906,7546102,7546093,'mes',20,1),(906,7546103,7546093,'ess',20,1),(906,7546104,7546093,'ssa',20,1),(906,7546105,7546093,'sag',20,1),(906,7546106,7546093,'age',20,1),(906,7546107,7546102,'per',11.111,1),(906,7546108,7546102,'erf',11.111,1),(906,7546109,7546102,'rfo',11.111,1),(906,7546110,7546102,'for',11.111,1),(906,7546111,7546102,'orm',11.111,1),(906,7546112,7546102,'rma',11.111,1),(906,7546113,7546102,'man',11.111,1),(906,7546114,7546102,'anc',11.111,1),(906,7546115,7546102,'nce',11.111,1),(906,7546116,7546107,'ide',12.5,1),(906,7546117,7546107,'den',12.5,1),(906,7546118,7546107,'ent',12.5,1),(906,7546119,7546107,'nti',12.5,1),(906,7546120,7546107,'tif',12.5,1),(906,7546121,7546107,'ifi',12.5,1),(906,7546122,7546107,'fie',12.5,1),(906,7546123,7546107,'ier',12.5,1),(906,7546124,7546116,'vdi',33.333,3),(906,7546125,7546116,'dis',33.333,3),(906,7546126,7546116,'isk',33.333,3),(906,7546127,7546124,'nam',50,1),(906,7546128,7546124,'ame',50,1),(906,7546129,7546127,'typ',50,1),(906,7546130,7546127,'ype',50,1),(906,7546131,7546129,'dir',25,1),(906,7546132,7546129,'ire',25,1),(906,7546133,7546129,'rec',25,1),(906,7546134,7546129,'ect',25,1),(907,7546136,7546135,'naa',100,2),(907,7546137,7546136,'600',3.333,3),(907,7546138,7546136,'000',3.333,3),(907,7546139,7546136,'00c',3.333,3),(907,7546140,7546136,'0c2',3.333,3),(907,7546141,7546136,'c29',3.333,3),(907,7546142,7546136,'294',3.333,3),(907,7546143,7546136,'94b',3.333,3),(907,7546144,7546136,'4be',3.333,3),(907,7546145,7546136,'be0',3.333,3),(907,7546146,7546136,'e07',3.333,3),(907,7546147,7546136,'075',3.333,3),(907,7546148,7546136,'75e',3.333,3),(907,7546149,7546136,'5e9',3.333,3),(907,7546150,7546136,'e9a',3.333,3),(907,7546151,7546136,'9ad',3.333,3),(907,7546152,7546136,'ad0',3.333,3),(907,7546153,7546136,'d0f',3.333,3),(907,7546154,7546136,'0f8',3.333,3),(907,7546155,7546136,'f8b',3.333,3),(907,7546156,7546136,'8b6',3.333,3),(907,7546157,7546136,'b6e',3.333,3),(907,7546158,7546136,'6e2',3.333,3),(907,7546159,7546136,'e2f',3.333,3),(907,7546160,7546136,'2f4',3.333,3),(907,7546161,7546136,'f4f',3.333,3),(907,7546162,7546136,'4f0',3.333,3),(907,7546163,7546136,'f04',3.333,3),(907,7546164,7546136,'04f',3.333,3),(907,7546165,7546136,'4fe',3.333,3),(907,7546166,7546136,'fe8',3.333,3),(907,7546167,7546137,'mon',100,1),(907,7546168,7546167,'201',50,1),(907,7546169,7546167,'013',50,1),(907,7546170,7546168,'adm',33.333,4),(907,7546171,7546168,'dmi',33.333,4),(907,7546172,7546168,'min',33.333,4),(907,7546173,7546170,'cap',16.667,1),(907,7546174,7546170,'apa',16.667,1),(907,7546175,7546170,'pac',16.667,1),(907,7546176,7546170,'aci',16.667,1),(907,7546177,7546170,'cit',16.667,1),(907,7546178,7546170,'ity',16.667,1),(907,7546179,7546173,'pat',50,1),(907,7546180,7546173,'ath',50,1),(907,7546181,7546179,'thr',33.333,1),(907,7546182,7546179,'hre',33.333,1),(907,7546183,7546179,'ree',33.333,1),(907,7546184,7546181,'fre',14.286,1),(907,7546185,7546181,'ree',14.286,1),(907,7546186,7546181,'ees',14.286,1),(907,7546187,7546181,'esp',14.286,1),(907,7546188,7546181,'spa',14.286,1),(907,7546189,7546181,'pac',14.286,1),(907,7546190,7546181,'ace',14.286,1),(907,7546191,7546184,'dis',50,1),(907,7546192,7546184,'isk',50,1),(907,7546193,7546191,'ind',33.333,1),(907,7546194,7546191,'nde',33.333,1),(907,7546195,7546191,'dex',33.333,1),(907,7546196,7546193,'adm',8.333,1),(907,7546197,7546193,'dmi',8.333,1),(907,7546198,7546193,'min',8.333,1),(907,7546199,7546193,'ini',8.333,1),(907,7546200,7546193,'nis',8.333,1),(907,7546201,7546193,'ist',8.333,1),(907,7546202,7546193,'str',8.333,1),(907,7546203,7546193,'tra',8.333,1),(907,7546204,7546193,'rat',8.333,1),(907,7546205,7546193,'ati',8.333,1),(907,7546206,7546193,'tio',8.333,1),(907,7546207,7546193,'ion',8.333,1),(907,7546208,7546196,'sta',33.333,3),(907,7546209,7546196,'tat',33.333,3),(907,7546210,7546196,'ate',33.333,3),(907,7546211,7546208,'dis',16.667,4),(907,7546212,7546208,'isa',16.667,4),(907,7546213,7546208,'sab',16.667,4),(907,7546214,7546208,'abl',16.667,4),(907,7546215,7546208,'ble',16.667,4),(907,7546216,7546208,'led',16.667,4),(907,7546217,7546211,'cac',33.333,1),(907,7546218,7546211,'ach',33.333,1),(907,7546219,7546211,'che',33.333,1),(907,7546220,7546217,'mod',50,1),(907,7546221,7546217,'ode',50,1),(907,7546222,7546220,'wri',14.286,1),(907,7546223,7546220,'rit',14.286,1),(907,7546224,7546220,'ite',14.286,1),(907,7546225,7546220,'tet',14.286,1),(907,7546226,7546220,'eth',14.286,1),(907,7546227,7546220,'thr',14.286,1),(907,7546228,7546220,'hru',14.286,1),(907,7546229,7546222,'ope',11.111,2),(907,7546230,7546222,'per',11.111,2),(907,7546231,7546222,'era',11.111,2),(907,7546232,7546222,'rat',11.111,2),(907,7546233,7546222,'ati',11.111,2),(907,7546234,7546222,'tio',11.111,2),(907,7546235,7546222,'ion',11.111,2),(907,7546236,7546222,'ona',11.111,2),(907,7546237,7546222,'nal',11.111,2),(907,7546238,7546229,'mes',20,1),(907,7546239,7546229,'ess',20,1),(907,7546240,7546229,'ssa',20,1),(907,7546241,7546229,'sag',20,1),(907,7546242,7546229,'age',20,1),(907,7546243,7546238,'per',11.111,1),(907,7546244,7546238,'erf',11.111,1),(907,7546245,7546238,'rfo',11.111,1),(907,7546246,7546238,'for',11.111,1),(907,7546247,7546238,'orm',11.111,1),(907,7546248,7546238,'rma',11.111,1),(907,7546249,7546238,'man',11.111,1),(907,7546250,7546238,'anc',11.111,1),(907,7546251,7546238,'nce',11.111,1),(907,7546252,7546243,'ide',12.5,1),(907,7546253,7546243,'den',12.5,1),(907,7546254,7546243,'ent',12.5,1),(907,7546255,7546243,'nti',12.5,1),(907,7546256,7546243,'tif',12.5,1),(907,7546257,7546243,'ifi',12.5,1),(907,7546258,7546243,'fie',12.5,1),(907,7546259,7546243,'ier',12.5,1),(907,7546260,7546252,'vdi',33.333,3),(907,7546261,7546252,'dis',33.333,3),(907,7546262,7546252,'isk',33.333,3),(907,7546263,7546260,'nam',50,1),(907,7546264,7546260,'ame',50,1),(907,7546265,7546263,'typ',50,1),(907,7546266,7546263,'ype',50,1),(907,7546267,7546265,'dir',25,1),(907,7546268,7546265,'ire',25,1),(907,7546269,7546265,'rec',25,1),(907,7546270,7546265,'ect',25,1),(908,7546272,7546271,'naa',100,2),(908,7546273,7546272,'600',3.333,3),(908,7546274,7546272,'000',3.333,3),(908,7546275,7546272,'00c',3.333,3),(908,7546276,7546272,'0c2',3.333,3),(908,7546277,7546272,'c29',3.333,3),(908,7546278,7546272,'29b',3.333,3),(908,7546279,7546272,'9b4',3.333,3),(908,7546280,7546272,'b4f',3.333,3),(908,7546281,7546272,'4f3',3.333,3),(908,7546282,7546272,'f3a',3.333,3),(908,7546283,7546272,'3a5',3.333,3),(908,7546284,7546272,'a57',3.333,3),(908,7546285,7546272,'571',3.333,3),(908,7546286,7546272,'71c',3.333,3),(908,7546287,7546272,'1cc',3.333,3),(908,7546288,7546272,'cce',3.333,3),(908,7546289,7546272,'ce0',3.333,3),(908,7546290,7546272,'e0d',3.333,3),(908,7546291,7546272,'0de',3.333,3),(908,7546292,7546272,'de2',3.333,3),(908,7546293,7546272,'e24',3.333,3),(908,7546294,7546272,'242',3.333,3),(908,7546295,7546272,'42b',3.333,3),(908,7546296,7546272,'2b5',3.333,3),(908,7546297,7546272,'b50',3.333,3),(908,7546298,7546272,'50c',3.333,3),(908,7546299,7546272,'0cb',3.333,3),(908,7546300,7546272,'cb4',3.333,3),(908,7546301,7546272,'b4d',3.333,3),(908,7546302,7546272,'4df',3.333,3),(908,7546303,7546273,'mon',100,1),(908,7546304,7546303,'201',50,1),(908,7546305,7546303,'013',50,1),(908,7546306,7546304,'adm',33.333,4),(908,7546307,7546304,'dmi',33.333,4),(908,7546308,7546304,'min',33.333,4),(908,7546309,7546306,'cap',16.667,1),(908,7546310,7546306,'apa',16.667,1),(908,7546311,7546306,'pac',16.667,1),(908,7546312,7546306,'aci',16.667,1),(908,7546313,7546306,'cit',16.667,1),(908,7546314,7546306,'ity',16.667,1),(908,7546315,7546309,'pat',50,1),(908,7546316,7546309,'ath',50,1),(908,7546317,7546315,'fou',50,1),(908,7546318,7546315,'our',50,1),(908,7546319,7546317,'fre',14.286,1),(908,7546320,7546317,'ree',14.286,1),(908,7546321,7546317,'ees',14.286,1),(908,7546322,7546317,'esp',14.286,1),(908,7546323,7546317,'spa',14.286,1),(908,7546324,7546317,'pac',14.286,1),(908,7546325,7546317,'ace',14.286,1),(908,7546326,7546319,'dis',50,1),(908,7546327,7546319,'isk',50,1),(908,7546328,7546326,'ind',33.333,1),(908,7546329,7546326,'nde',33.333,1),(908,7546330,7546326,'dex',33.333,1),(908,7546331,7546328,'adm',8.333,1),(908,7546332,7546328,'dmi',8.333,1),(908,7546333,7546328,'min',8.333,1),(908,7546334,7546328,'ini',8.333,1),(908,7546335,7546328,'nis',8.333,1),(908,7546336,7546328,'ist',8.333,1),(908,7546337,7546328,'str',8.333,1),(908,7546338,7546328,'tra',8.333,1),(908,7546339,7546328,'rat',8.333,1),(908,7546340,7546328,'ati',8.333,1),(908,7546341,7546328,'tio',8.333,1),(908,7546342,7546328,'ion',8.333,1),(908,7546343,7546331,'sta',33.333,3),(908,7546344,7546331,'tat',33.333,3),(908,7546345,7546331,'ate',33.333,3),(908,7546346,7546343,'dis',16.667,4),(908,7546347,7546343,'isa',16.667,4),(908,7546348,7546343,'sab',16.667,4),(908,7546349,7546343,'abl',16.667,4),(908,7546350,7546343,'ble',16.667,4),(908,7546351,7546343,'led',16.667,4),(908,7546352,7546346,'cac',33.333,1),(908,7546353,7546346,'ach',33.333,1),(908,7546354,7546346,'che',33.333,1),(908,7546355,7546352,'mod',50,1),(908,7546356,7546352,'ode',50,1),(908,7546357,7546355,'wri',14.286,1),(908,7546358,7546355,'rit',14.286,1),(908,7546359,7546355,'ite',14.286,1),(908,7546360,7546355,'tet',14.286,1),(908,7546361,7546355,'eth',14.286,1),(908,7546362,7546355,'thr',14.286,1),(908,7546363,7546355,'hru',14.286,1),(908,7546364,7546357,'ope',11.111,2),(908,7546365,7546357,'per',11.111,2),(908,7546366,7546357,'era',11.111,2),(908,7546367,7546357,'rat',11.111,2),(908,7546368,7546357,'ati',11.111,2),(908,7546369,7546357,'tio',11.111,2),(908,7546370,7546357,'ion',11.111,2),(908,7546371,7546357,'ona',11.111,2),(908,7546372,7546357,'nal',11.111,2),(908,7546373,7546364,'mes',20,1),(908,7546374,7546364,'ess',20,1),(908,7546375,7546364,'ssa',20,1),(908,7546376,7546364,'sag',20,1),(908,7546377,7546364,'age',20,1),(908,7546378,7546373,'per',11.111,1),(908,7546379,7546373,'erf',11.111,1),(908,7546380,7546373,'rfo',11.111,1),(908,7546381,7546373,'for',11.111,1),(908,7546382,7546373,'orm',11.111,1),(908,7546383,7546373,'rma',11.111,1),(908,7546384,7546373,'man',11.111,1),(908,7546385,7546373,'anc',11.111,1),(908,7546386,7546373,'nce',11.111,1),(908,7546387,7546378,'ide',12.5,1),(908,7546388,7546378,'den',12.5,1),(908,7546389,7546378,'ent',12.5,1),(908,7546390,7546378,'nti',12.5,1),(908,7546391,7546378,'tif',12.5,1),(908,7546392,7546378,'ifi',12.5,1),(908,7546393,7546378,'fie',12.5,1),(908,7546394,7546378,'ier',12.5,1),(908,7546395,7546387,'vdi',33.333,3),(908,7546396,7546387,'dis',33.333,3),(908,7546397,7546387,'isk',33.333,3),(908,7546398,7546395,'nam',50,1),(908,7546399,7546395,'ame',50,1),(908,7546400,7546398,'typ',50,1),(908,7546401,7546398,'ype',50,1),(908,7546402,7546400,'dir',25,1),(908,7546403,7546400,'ire',25,1),(908,7546404,7546400,'rec',25,1),(908,7546405,7546400,'ect',25,1),(909,7546407,7546406,'naa',100,2),(909,7546408,7546407,'600',3.333,3),(909,7546409,7546407,'000',3.333,3),(909,7546410,7546407,'00c',3.333,3),(909,7546411,7546407,'0c2',3.333,3),(909,7546412,7546407,'c29',3.333,3),(909,7546413,7546407,'296',3.333,3),(909,7546414,7546407,'960',3.333,3),(909,7546415,7546407,'601',3.333,3),(909,7546416,7546407,'01b',3.333,3),(909,7546417,7546407,'1bd',3.333,3),(909,7546418,7546407,'bd2',3.333,3),(909,7546419,7546407,'d24',3.333,3),(909,7546420,7546407,'24c',3.333,3),(909,7546421,7546407,'4c6',3.333,3),(909,7546422,7546407,'c6c',3.333,3),(909,7546423,7546407,'6c5',3.333,3),(909,7546424,7546407,'c5e',3.333,3),(909,7546425,7546407,'5e2',3.333,3),(909,7546426,7546407,'e2d',3.333,3),(909,7546427,7546407,'2d0',3.333,3),(909,7546428,7546407,'d09',3.333,3),(909,7546429,7546407,'09f',3.333,3),(909,7546430,7546407,'9f2',3.333,3),(909,7546431,7546407,'f27',3.333,3),(909,7546432,7546407,'27b',3.333,3),(909,7546433,7546407,'7b5',3.333,3),(909,7546434,7546407,'b5c',3.333,3),(909,7546435,7546407,'5c6',3.333,3),(909,7546436,7546407,'c63',3.333,3),(909,7546437,7546407,'634',3.333,3),(909,7546438,7546408,'mon',100,1),(909,7546439,7546438,'201',50,1),(909,7546440,7546438,'013',50,1),(909,7546441,7546439,'adm',33.333,4),(909,7546442,7546439,'dmi',33.333,4),(909,7546443,7546439,'min',33.333,4),(909,7546444,7546441,'cap',16.667,1),(909,7546445,7546441,'apa',16.667,1),(909,7546446,7546441,'pac',16.667,1),(909,7546447,7546441,'aci',16.667,1),(909,7546448,7546441,'cit',16.667,1),(909,7546449,7546441,'ity',16.667,1),(909,7546450,7546444,'pat',50,1),(909,7546451,7546444,'ath',50,1),(909,7546452,7546450,'fiv',50,1),(909,7546453,7546450,'ive',50,1),(909,7546454,7546452,'fre',14.286,1),(909,7546455,7546452,'ree',14.286,1),(909,7546456,7546452,'ees',14.286,1),(909,7546457,7546452,'esp',14.286,1),(909,7546458,7546452,'spa',14.286,1),(909,7546459,7546452,'pac',14.286,1),(909,7546460,7546452,'ace',14.286,1),(909,7546461,7546454,'dis',50,1),(909,7546462,7546454,'isk',50,1),(909,7546463,7546461,'ind',33.333,1),(909,7546464,7546461,'nde',33.333,1),(909,7546465,7546461,'dex',33.333,1),(909,7546466,7546463,'adm',8.333,1),(909,7546467,7546463,'dmi',8.333,1),(909,7546468,7546463,'min',8.333,1),(909,7546469,7546463,'ini',8.333,1),(909,7546470,7546463,'nis',8.333,1),(909,7546471,7546463,'ist',8.333,1),(909,7546472,7546463,'str',8.333,1),(909,7546473,7546463,'tra',8.333,1),(909,7546474,7546463,'rat',8.333,1),(909,7546475,7546463,'ati',8.333,1),(909,7546476,7546463,'tio',8.333,1),(909,7546477,7546463,'ion',8.333,1),(909,7546478,7546466,'sta',33.333,3),(909,7546479,7546466,'tat',33.333,3),(909,7546480,7546466,'ate',33.333,3),(909,7546481,7546478,'dis',16.667,4),(909,7546482,7546478,'isa',16.667,4),(909,7546483,7546478,'sab',16.667,4),(909,7546484,7546478,'abl',16.667,4),(909,7546485,7546478,'ble',16.667,4),(909,7546486,7546478,'led',16.667,4),(909,7546487,7546481,'cac',33.333,1),(909,7546488,7546481,'ach',33.333,1),(909,7546489,7546481,'che',33.333,1),(909,7546490,7546487,'mod',50,1),(909,7546491,7546487,'ode',50,1),(909,7546492,7546490,'wri',14.286,1),(909,7546493,7546490,'rit',14.286,1),(909,7546494,7546490,'ite',14.286,1),(909,7546495,7546490,'tet',14.286,1),(909,7546496,7546490,'eth',14.286,1),(909,7546497,7546490,'thr',14.286,1),(909,7546498,7546490,'hru',14.286,1),(909,7546499,7546492,'ope',11.111,2),(909,7546500,7546492,'per',11.111,2),(909,7546501,7546492,'era',11.111,2),(909,7546502,7546492,'rat',11.111,2),(909,7546503,7546492,'ati',11.111,2),(909,7546504,7546492,'tio',11.111,2),(909,7546505,7546492,'ion',11.111,2),(909,7546506,7546492,'ona',11.111,2),(909,7546507,7546492,'nal',11.111,2),(909,7546508,7546499,'mes',20,1),(909,7546509,7546499,'ess',20,1),(909,7546510,7546499,'ssa',20,1),(909,7546511,7546499,'sag',20,1),(909,7546512,7546499,'age',20,1),(909,7546513,7546508,'per',11.111,1),(909,7546514,7546508,'erf',11.111,1),(909,7546515,7546508,'rfo',11.111,1),(909,7546516,7546508,'for',11.111,1),(909,7546517,7546508,'orm',11.111,1),(909,7546518,7546508,'rma',11.111,1),(909,7546519,7546508,'man',11.111,1),(909,7546520,7546508,'anc',11.111,1),(909,7546521,7546508,'nce',11.111,1),(909,7546522,7546513,'ide',12.5,1),(909,7546523,7546513,'den',12.5,1),(909,7546524,7546513,'ent',12.5,1),(909,7546525,7546513,'nti',12.5,1),(909,7546526,7546513,'tif',12.5,1),(909,7546527,7546513,'ifi',12.5,1),(909,7546528,7546513,'fie',12.5,1),(909,7546529,7546513,'ier',12.5,1),(909,7546530,7546522,'vdi',33.333,3),(909,7546531,7546522,'dis',33.333,3),(909,7546532,7546522,'isk',33.333,3),(909,7546533,7546530,'nam',50,1),(909,7546534,7546530,'ame',50,1),(909,7546535,7546533,'typ',50,1),(909,7546536,7546533,'ype',50,1),(909,7546537,7546535,'dir',25,1),(909,7546538,7546535,'ire',25,1),(909,7546539,7546535,'rec',25,1),(909,7546540,7546535,'ect',25,1),(910,7546542,7546541,'naa',100,2),(910,7546543,7546542,'600',3.333,3),(910,7546544,7546542,'000',3.333,3),(910,7546545,7546542,'00c',3.333,3),(910,7546546,7546542,'0c2',3.333,3),(910,7546547,7546542,'c29',3.333,3),(910,7546548,7546542,'290',3.333,3),(910,7546549,7546542,'90a',3.333,3),(910,7546550,7546542,'0ad',3.333,3),(910,7546551,7546542,'ad1',3.333,3),(910,7546552,7546542,'d1f',3.333,3),(910,7546553,7546542,'1f6',3.333,3),(910,7546554,7546542,'f63',3.333,3),(910,7546555,7546542,'634',3.333,3),(910,7546556,7546542,'341',3.333,3),(910,7546557,7546542,'412',3.333,3),(910,7546558,7546542,'12f',3.333,3),(910,7546559,7546542,'2f7',3.333,3),(910,7546560,7546542,'f7c',3.333,3),(910,7546561,7546542,'7c1',3.333,3),(910,7546562,7546542,'c1e',3.333,3),(910,7546563,7546542,'1e6',3.333,3),(910,7546564,7546542,'e6e',3.333,3),(910,7546565,7546542,'6ef',3.333,3),(910,7546566,7546542,'ef5',3.333,3),(910,7546567,7546542,'f51',3.333,3),(910,7546568,7546542,'51c',3.333,3),(910,7546569,7546542,'1ca',3.333,3),(910,7546570,7546542,'ca3',3.333,3),(910,7546571,7546542,'a3d',3.333,3),(910,7546572,7546542,'3d6',3.333,3),(910,7546573,7546543,'mon',100,1),(910,7546574,7546573,'201',50,1),(910,7546575,7546573,'013',50,1),(910,7546576,7546574,'adm',33.333,4),(910,7546577,7546574,'dmi',33.333,4),(910,7546578,7546574,'min',33.333,4),(910,7546579,7546576,'cap',16.667,1),(910,7546580,7546576,'apa',16.667,1),(910,7546581,7546576,'pac',16.667,1),(910,7546582,7546576,'aci',16.667,1),(910,7546583,7546576,'cit',16.667,1),(910,7546584,7546576,'ity',16.667,1),(910,7546585,7546579,'pat',50,1),(910,7546586,7546579,'ath',50,1),(910,7546587,7546585,'six',100,1),(910,7546588,7546587,'fre',14.286,1),(910,7546589,7546587,'ree',14.286,1),(910,7546590,7546587,'ees',14.286,1),(910,7546591,7546587,'esp',14.286,1),(910,7546592,7546587,'spa',14.286,1),(910,7546593,7546587,'pac',14.286,1),(910,7546594,7546587,'ace',14.286,1),(910,7546595,7546588,'dis',50,1),(910,7546596,7546588,'isk',50,1),(910,7546597,7546595,'ind',33.333,1),(910,7546598,7546595,'nde',33.333,1),(910,7546599,7546595,'dex',33.333,1),(910,7546600,7546597,'adm',8.333,1),(910,7546601,7546597,'dmi',8.333,1),(910,7546602,7546597,'min',8.333,1),(910,7546603,7546597,'ini',8.333,1),(910,7546604,7546597,'nis',8.333,1),(910,7546605,7546597,'ist',8.333,1),(910,7546606,7546597,'str',8.333,1),(910,7546607,7546597,'tra',8.333,1),(910,7546608,7546597,'rat',8.333,1),(910,7546609,7546597,'ati',8.333,1),(910,7546610,7546597,'tio',8.333,1),(910,7546611,7546597,'ion',8.333,1),(910,7546612,7546600,'sta',33.333,3),(910,7546613,7546600,'tat',33.333,3),(910,7546614,7546600,'ate',33.333,3),(910,7546615,7546612,'dis',16.667,4),(910,7546616,7546612,'isa',16.667,4),(910,7546617,7546612,'sab',16.667,4),(910,7546618,7546612,'abl',16.667,4),(910,7546619,7546612,'ble',16.667,4),(910,7546620,7546612,'led',16.667,4),(910,7546621,7546615,'cac',33.333,1),(910,7546622,7546615,'ach',33.333,1),(910,7546623,7546615,'che',33.333,1),(910,7546624,7546621,'mod',50,1),(910,7546625,7546621,'ode',50,1),(910,7546626,7546624,'wri',14.286,1),(910,7546627,7546624,'rit',14.286,1),(910,7546628,7546624,'ite',14.286,1),(910,7546629,7546624,'tet',14.286,1),(910,7546630,7546624,'eth',14.286,1),(910,7546631,7546624,'thr',14.286,1),(910,7546632,7546624,'hru',14.286,1),(910,7546633,7546626,'ope',11.111,2),(910,7546634,7546626,'per',11.111,2),(910,7546635,7546626,'era',11.111,2),(910,7546636,7546626,'rat',11.111,2),(910,7546637,7546626,'ati',11.111,2),(910,7546638,7546626,'tio',11.111,2),(910,7546639,7546626,'ion',11.111,2),(910,7546640,7546626,'ona',11.111,2),(910,7546641,7546626,'nal',11.111,2),(910,7546642,7546633,'mes',20,1),(910,7546643,7546633,'ess',20,1),(910,7546644,7546633,'ssa',20,1),(910,7546645,7546633,'sag',20,1),(910,7546646,7546633,'age',20,1),(910,7546647,7546642,'per',11.111,1),(910,7546648,7546642,'erf',11.111,1),(910,7546649,7546642,'rfo',11.111,1),(910,7546650,7546642,'for',11.111,1),(910,7546651,7546642,'orm',11.111,1),(910,7546652,7546642,'rma',11.111,1),(910,7546653,7546642,'man',11.111,1),(910,7546654,7546642,'anc',11.111,1),(910,7546655,7546642,'nce',11.111,1),(910,7546656,7546647,'ide',12.5,1),(910,7546657,7546647,'den',12.5,1),(910,7546658,7546647,'ent',12.5,1),(910,7546659,7546647,'nti',12.5,1),(910,7546660,7546647,'tif',12.5,1),(910,7546661,7546647,'ifi',12.5,1),(910,7546662,7546647,'fie',12.5,1),(910,7546663,7546647,'ier',12.5,1),(910,7546664,7546656,'vdi',33.333,3),(910,7546665,7546656,'dis',33.333,3),(910,7546666,7546656,'isk',33.333,3),(910,7546667,7546664,'nam',50,1),(910,7546668,7546664,'ame',50,1),(910,7546669,7546667,'typ',50,1),(910,7546670,7546667,'ype',50,1),(910,7546671,7546669,'dir',25,1),(910,7546672,7546669,'ire',25,1),(910,7546673,7546669,'rec',25,1),(910,7546674,7546669,'ect',25,1),(911,7546676,7546675,'naa',100,2),(911,7546677,7546676,'600',3.333,3),(911,7546678,7546676,'000',3.333,3),(911,7546679,7546676,'00c',3.333,3),(911,7546680,7546676,'0c2',3.333,3),(911,7546681,7546676,'c29',3.333,3),(911,7546682,7546676,'29a',3.333,3),(911,7546683,7546676,'9ae',3.333,3),(911,7546684,7546676,'ae0',3.333,3),(911,7546685,7546676,'e0f',3.333,3),(911,7546686,7546676,'0ff',3.333,3),(911,7546687,7546676,'ff2',3.333,3),(911,7546688,7546676,'f24',3.333,3),(911,7546689,7546676,'248',3.333,3),(911,7546690,7546676,'484',3.333,3),(911,7546691,7546676,'843',3.333,3),(911,7546692,7546676,'43a',3.333,3),(911,7546693,7546676,'3a0',3.333,3),(911,7546694,7546676,'a00',3.333,3),(911,7546695,7546676,'007',3.333,3),(911,7546696,7546676,'077',3.333,3),(911,7546697,7546676,'774',3.333,3),(911,7546698,7546676,'740',3.333,3),(911,7546699,7546676,'40f',3.333,3),(911,7546700,7546676,'0f7',3.333,3),(911,7546701,7546676,'f7d',3.333,3),(911,7546702,7546676,'7da',3.333,3),(911,7546703,7546676,'dab',3.333,3),(911,7546704,7546676,'ab9',3.333,3),(911,7546705,7546676,'b90',3.333,3),(911,7546706,7546676,'901',3.333,3),(911,7546707,7546677,'mon',100,1),(911,7546708,7546707,'201',50,1),(911,7546709,7546707,'013',50,1),(911,7546710,7546708,'adm',33.333,4),(911,7546711,7546708,'dmi',33.333,4),(911,7546712,7546708,'min',33.333,4),(911,7546713,7546710,'cap',16.667,1),(911,7546714,7546710,'apa',16.667,1),(911,7546715,7546710,'pac',16.667,1),(911,7546716,7546710,'aci',16.667,1),(911,7546717,7546710,'cit',16.667,1),(911,7546718,7546710,'ity',16.667,1),(911,7546719,7546713,'pat',50,1),(911,7546720,7546713,'ath',50,1),(911,7546721,7546719,'sev',33.333,1),(911,7546722,7546719,'eve',33.333,1),(911,7546723,7546719,'ven',33.333,1),(911,7546724,7546721,'fre',14.286,1),(911,7546725,7546721,'ree',14.286,1),(911,7546726,7546721,'ees',14.286,1),(911,7546727,7546721,'esp',14.286,1),(911,7546728,7546721,'spa',14.286,1),(911,7546729,7546721,'pac',14.286,1),(911,7546730,7546721,'ace',14.286,1),(911,7546731,7546724,'dis',50,1),(911,7546732,7546724,'isk',50,1),(911,7546733,7546731,'ind',33.333,1),(911,7546734,7546731,'nde',33.333,1),(911,7546735,7546731,'dex',33.333,1),(911,7546736,7546733,'adm',8.333,1),(911,7546737,7546733,'dmi',8.333,1),(911,7546738,7546733,'min',8.333,1),(911,7546739,7546733,'ini',8.333,1),(911,7546740,7546733,'nis',8.333,1),(911,7546741,7546733,'ist',8.333,1),(911,7546742,7546733,'str',8.333,1),(911,7546743,7546733,'tra',8.333,1),(911,7546744,7546733,'rat',8.333,1),(911,7546745,7546733,'ati',8.333,1),(911,7546746,7546733,'tio',8.333,1),(911,7546747,7546733,'ion',8.333,1),(911,7546748,7546736,'sta',33.333,3),(911,7546749,7546736,'tat',33.333,3),(911,7546750,7546736,'ate',33.333,3),(911,7546751,7546748,'dis',16.667,4),(911,7546752,7546748,'isa',16.667,4),(911,7546753,7546748,'sab',16.667,4),(911,7546754,7546748,'abl',16.667,4),(911,7546755,7546748,'ble',16.667,4),(911,7546756,7546748,'led',16.667,4),(911,7546757,7546751,'cac',33.333,1),(911,7546758,7546751,'ach',33.333,1),(911,7546759,7546751,'che',33.333,1),(911,7546760,7546757,'mod',50,1),(911,7546761,7546757,'ode',50,1),(911,7546762,7546760,'wri',14.286,1),(911,7546763,7546760,'rit',14.286,1),(911,7546764,7546760,'ite',14.286,1),(911,7546765,7546760,'tet',14.286,1),(911,7546766,7546760,'eth',14.286,1),(911,7546767,7546760,'thr',14.286,1),(911,7546768,7546760,'hru',14.286,1),(911,7546769,7546762,'ope',11.111,2),(911,7546770,7546762,'per',11.111,2),(911,7546771,7546762,'era',11.111,2),(911,7546772,7546762,'rat',11.111,2),(911,7546773,7546762,'ati',11.111,2),(911,7546774,7546762,'tio',11.111,2),(911,7546775,7546762,'ion',11.111,2),(911,7546776,7546762,'ona',11.111,2),(911,7546777,7546762,'nal',11.111,2),(911,7546778,7546769,'mes',20,1),(911,7546779,7546769,'ess',20,1),(911,7546780,7546769,'ssa',20,1),(911,7546781,7546769,'sag',20,1),(911,7546782,7546769,'age',20,1),(911,7546783,7546778,'per',11.111,1),(911,7546784,7546778,'erf',11.111,1),(911,7546785,7546778,'rfo',11.111,1),(911,7546786,7546778,'for',11.111,1),(911,7546787,7546778,'orm',11.111,1),(911,7546788,7546778,'rma',11.111,1),(911,7546789,7546778,'man',11.111,1),(911,7546790,7546778,'anc',11.111,1),(911,7546791,7546778,'nce',11.111,1),(911,7546792,7546783,'ide',12.5,1),(911,7546793,7546783,'den',12.5,1),(911,7546794,7546783,'ent',12.5,1),(911,7546795,7546783,'nti',12.5,1),(911,7546796,7546783,'tif',12.5,1),(911,7546797,7546783,'ifi',12.5,1),(911,7546798,7546783,'fie',12.5,1),(911,7546799,7546783,'ier',12.5,1),(911,7546800,7546792,'vdi',33.333,3),(911,7546801,7546792,'dis',33.333,3),(911,7546802,7546792,'isk',33.333,3),(911,7546803,7546800,'nam',50,1),(911,7546804,7546800,'ame',50,1),(911,7546805,7546803,'typ',50,1),(911,7546806,7546803,'ype',50,1),(911,7546807,7546805,'dir',25,1),(911,7546808,7546805,'ire',25,1),(911,7546809,7546805,'rec',25,1),(911,7546810,7546805,'ect',25,1),(912,7546812,7546811,'naa',100,2),(912,7546813,7546812,'600',3.333,3),(912,7546814,7546812,'000',3.333,3),(912,7546815,7546812,'00c',3.333,3),(912,7546816,7546812,'0c2',3.333,3),(912,7546817,7546812,'c29',3.333,3),(912,7546818,7546812,'29c',3.333,3),(912,7546819,7546812,'9c4',3.333,3),(912,7546820,7546812,'c47',3.333,3),(912,7546821,7546812,'473',3.333,3),(912,7546822,7546812,'73f',3.333,3),(912,7546823,7546812,'3f8',3.333,3),(912,7546824,7546812,'f82',3.333,3),(912,7546825,7546812,'82e',3.333,3),(912,7546826,7546812,'2ed',3.333,3),(912,7546827,7546812,'eda',3.333,3),(912,7546828,7546812,'da5',3.333,3),(912,7546829,7546812,'a53',3.333,3),(912,7546830,7546812,'53e',3.333,3),(912,7546831,7546812,'3e7',3.333,3),(912,7546832,7546812,'e71',3.333,3),(912,7546833,7546812,'711',3.333,3),(912,7546834,7546812,'11e',3.333,3),(912,7546835,7546812,'1e7',3.333,3),(912,7546836,7546812,'e79',3.333,3),(912,7546837,7546812,'79d',3.333,3),(912,7546838,7546812,'9d2',3.333,3),(912,7546839,7546812,'d28',3.333,3),(912,7546840,7546812,'28f',3.333,3),(912,7546841,7546812,'8f2',3.333,3),(912,7546842,7546812,'f21',3.333,3),(912,7546843,7546813,'mon',100,1),(912,7546844,7546843,'201',50,1),(912,7546845,7546843,'013',50,1),(912,7546846,7546844,'adm',33.333,4),(912,7546847,7546844,'dmi',33.333,4),(912,7546848,7546844,'min',33.333,4),(912,7546849,7546846,'cap',16.667,1),(912,7546850,7546846,'apa',16.667,1),(912,7546851,7546846,'pac',16.667,1),(912,7546852,7546846,'aci',16.667,1),(912,7546853,7546846,'cit',16.667,1),(912,7546854,7546846,'ity',16.667,1),(912,7546855,7546849,'pat',50,1),(912,7546856,7546849,'ath',50,1),(912,7546857,7546855,'eig',33.333,1),(912,7546858,7546855,'igh',33.333,1),(912,7546859,7546855,'ght',33.333,1),(912,7546860,7546857,'fre',14.286,1),(912,7546861,7546857,'ree',14.286,1),(912,7546862,7546857,'ees',14.286,1),(912,7546863,7546857,'esp',14.286,1),(912,7546864,7546857,'spa',14.286,1),(912,7546865,7546857,'pac',14.286,1),(912,7546866,7546857,'ace',14.286,1),(912,7546867,7546860,'dis',50,1),(912,7546868,7546860,'isk',50,1),(912,7546869,7546867,'ind',33.333,1),(912,7546870,7546867,'nde',33.333,1),(912,7546871,7546867,'dex',33.333,1),(912,7546872,7546869,'adm',8.333,1),(912,7546873,7546869,'dmi',8.333,1),(912,7546874,7546869,'min',8.333,1),(912,7546875,7546869,'ini',8.333,1),(912,7546876,7546869,'nis',8.333,1),(912,7546877,7546869,'ist',8.333,1),(912,7546878,7546869,'str',8.333,1),(912,7546879,7546869,'tra',8.333,1),(912,7546880,7546869,'rat',8.333,1),(912,7546881,7546869,'ati',8.333,1),(912,7546882,7546869,'tio',8.333,1),(912,7546883,7546869,'ion',8.333,1),(912,7546884,7546872,'sta',33.333,3),(912,7546885,7546872,'tat',33.333,3),(912,7546886,7546872,'ate',33.333,3),(912,7546887,7546884,'dis',16.667,4),(912,7546888,7546884,'isa',16.667,4),(912,7546889,7546884,'sab',16.667,4),(912,7546890,7546884,'abl',16.667,4),(912,7546891,7546884,'ble',16.667,4),(912,7546892,7546884,'led',16.667,4),(912,7546893,7546887,'cac',33.333,1),(912,7546894,7546887,'ach',33.333,1),(912,7546895,7546887,'che',33.333,1),(912,7546896,7546893,'mod',50,1),(912,7546897,7546893,'ode',50,1),(912,7546898,7546896,'wri',14.286,1),(912,7546899,7546896,'rit',14.286,1),(912,7546900,7546896,'ite',14.286,1),(912,7546901,7546896,'tet',14.286,1),(912,7546902,7546896,'eth',14.286,1),(912,7546903,7546896,'thr',14.286,1),(912,7546904,7546896,'hru',14.286,1),(912,7546905,7546898,'ope',11.111,2),(912,7546906,7546898,'per',11.111,2),(912,7546907,7546898,'era',11.111,2),(912,7546908,7546898,'rat',11.111,2),(912,7546909,7546898,'ati',11.111,2),(912,7546910,7546898,'tio',11.111,2),(912,7546911,7546898,'ion',11.111,2),(912,7546912,7546898,'ona',11.111,2),(912,7546913,7546898,'nal',11.111,2),(912,7546914,7546905,'mes',20,1),(912,7546915,7546905,'ess',20,1),(912,7546916,7546905,'ssa',20,1),(912,7546917,7546905,'sag',20,1),(912,7546918,7546905,'age',20,1),(912,7546919,7546914,'per',11.111,1),(912,7546920,7546914,'erf',11.111,1),(912,7546921,7546914,'rfo',11.111,1),(912,7546922,7546914,'for',11.111,1),(912,7546923,7546914,'orm',11.111,1),(912,7546924,7546914,'rma',11.111,1),(912,7546925,7546914,'man',11.111,1),(912,7546926,7546914,'anc',11.111,1),(912,7546927,7546914,'nce',11.111,1),(912,7546928,7546919,'ide',12.5,1),(912,7546929,7546919,'den',12.5,1),(912,7546930,7546919,'ent',12.5,1),(912,7546931,7546919,'nti',12.5,1),(912,7546932,7546919,'tif',12.5,1),(912,7546933,7546919,'ifi',12.5,1),(912,7546934,7546919,'fie',12.5,1),(912,7546935,7546919,'ier',12.5,1),(912,7546936,7546928,'vdi',33.333,3),(912,7546937,7546928,'dis',33.333,3),(912,7546938,7546928,'isk',33.333,3),(912,7546939,7546936,'nam',50,1),(912,7546940,7546936,'ame',50,1),(912,7546941,7546939,'typ',50,1),(912,7546942,7546939,'ype',50,1),(912,7546943,7546941,'dir',25,1),(912,7546944,7546941,'ire',25,1),(912,7546945,7546941,'rec',25,1),(912,7546946,7546941,'ect',25,1),(913,7546948,7546947,'naa',100,2),(913,7546949,7546948,'600',3.333,3),(913,7546950,7546948,'000',3.333,3),(913,7546951,7546948,'00c',3.333,3),(913,7546952,7546948,'0c2',3.333,3),(913,7546953,7546948,'c29',3.333,3),(913,7546954,7546948,'296',3.333,3),(913,7546955,7546948,'966',3.333,3),(913,7546956,7546948,'66b',3.333,3),(913,7546957,7546948,'6b6',3.333,3),(913,7546958,7546948,'b63',3.333,3),(913,7546959,7546948,'63a',3.333,3),(913,7546960,7546948,'3ac',3.333,3),(913,7546961,7546948,'acc',3.333,3),(913,7546962,7546948,'cca',3.333,3),(913,7546963,7546948,'ca9',3.333,3),(913,7546964,7546948,'a96',3.333,3),(913,7546965,7546948,'968',3.333,3),(913,7546966,7546948,'680',3.333,3),(913,7546967,7546948,'800',3.333,3),(913,7546968,7546948,'00a',3.333,3),(913,7546969,7546948,'0a1',3.333,3),(913,7546970,7546948,'a10',3.333,3),(913,7546971,7546948,'10b',3.333,3),(913,7546972,7546948,'0b1',3.333,3),(913,7546973,7546948,'b19',3.333,3),(913,7546974,7546948,'19d',3.333,3),(913,7546975,7546948,'9d1',3.333,3),(913,7546976,7546948,'d16',3.333,3),(913,7546977,7546948,'162',3.333,3),(913,7546978,7546948,'626',3.333,3),(913,7546979,7546949,'mon',100,1),(913,7546980,7546979,'201',50,1),(913,7546981,7546979,'013',50,1),(913,7546982,7546980,'adm',33.333,4),(913,7546983,7546980,'dmi',33.333,4),(913,7546984,7546980,'min',33.333,4),(913,7546985,7546982,'cap',16.667,1),(913,7546986,7546982,'apa',16.667,1),(913,7546987,7546982,'pac',16.667,1),(913,7546988,7546982,'aci',16.667,1),(913,7546989,7546982,'cit',16.667,1),(913,7546990,7546982,'ity',16.667,1),(913,7546991,7546985,'pat',50,1),(913,7546992,7546985,'ath',50,1),(913,7546993,7546991,'nin',50,1),(913,7546994,7546991,'ine',50,1),(913,7546995,7546993,'fre',14.286,1),(913,7546996,7546993,'ree',14.286,1),(913,7546997,7546993,'ees',14.286,1),(913,7546998,7546993,'esp',14.286,1),(913,7546999,7546993,'spa',14.286,1),(913,7547000,7546993,'pac',14.286,1),(913,7547001,7546993,'ace',14.286,1),(913,7547002,7546995,'dis',50,1),(913,7547003,7546995,'isk',50,1),(913,7547004,7547002,'ind',33.333,1),(913,7547005,7547002,'nde',33.333,1),(913,7547006,7547002,'dex',33.333,1),(913,7547007,7547004,'adm',8.333,1),(913,7547008,7547004,'dmi',8.333,1),(913,7547009,7547004,'min',8.333,1),(913,7547010,7547004,'ini',8.333,1),(913,7547011,7547004,'nis',8.333,1),(913,7547012,7547004,'ist',8.333,1),(913,7547013,7547004,'str',8.333,1),(913,7547014,7547004,'tra',8.333,1),(913,7547015,7547004,'rat',8.333,1),(913,7547016,7547004,'ati',8.333,1),(913,7547017,7547004,'tio',8.333,1),(913,7547018,7547004,'ion',8.333,1),(913,7547019,7547007,'sta',33.333,3),(913,7547020,7547007,'tat',33.333,3),(913,7547021,7547007,'ate',33.333,3),(913,7547022,7547019,'dis',16.667,4),(913,7547023,7547019,'isa',16.667,4),(913,7547024,7547019,'sab',16.667,4),(913,7547025,7547019,'abl',16.667,4),(913,7547026,7547019,'ble',16.667,4),(913,7547027,7547019,'led',16.667,4),(913,7547028,7547022,'cac',33.333,1),(913,7547029,7547022,'ach',33.333,1),(913,7547030,7547022,'che',33.333,1),(913,7547031,7547028,'mod',50,1),(913,7547032,7547028,'ode',50,1),(913,7547033,7547031,'wri',14.286,1),(913,7547034,7547031,'rit',14.286,1),(913,7547035,7547031,'ite',14.286,1),(913,7547036,7547031,'tet',14.286,1),(913,7547037,7547031,'eth',14.286,1),(913,7547038,7547031,'thr',14.286,1),(913,7547039,7547031,'hru',14.286,1),(913,7547040,7547033,'ope',11.111,2),(913,7547041,7547033,'per',11.111,2),(913,7547042,7547033,'era',11.111,2),(913,7547043,7547033,'rat',11.111,2),(913,7547044,7547033,'ati',11.111,2),(913,7547045,7547033,'tio',11.111,2),(913,7547046,7547033,'ion',11.111,2),(913,7547047,7547033,'ona',11.111,2),(913,7547048,7547033,'nal',11.111,2),(913,7547049,7547040,'mes',20,1),(913,7547050,7547040,'ess',20,1),(913,7547051,7547040,'ssa',20,1),(913,7547052,7547040,'sag',20,1),(913,7547053,7547040,'age',20,1),(913,7547054,7547049,'per',11.111,1),(913,7547055,7547049,'erf',11.111,1),(913,7547056,7547049,'rfo',11.111,1),(913,7547057,7547049,'for',11.111,1),(913,7547058,7547049,'orm',11.111,1),(913,7547059,7547049,'rma',11.111,1),(913,7547060,7547049,'man',11.111,1),(913,7547061,7547049,'anc',11.111,1),(913,7547062,7547049,'nce',11.111,1),(913,7547063,7547054,'ide',12.5,1),(913,7547064,7547054,'den',12.5,1),(913,7547065,7547054,'ent',12.5,1),(913,7547066,7547054,'nti',12.5,1),(913,7547067,7547054,'tif',12.5,1),(913,7547068,7547054,'ifi',12.5,1),(913,7547069,7547054,'fie',12.5,1),(913,7547070,7547054,'ier',12.5,1),(913,7547071,7547063,'vdi',33.333,3),(913,7547072,7547063,'dis',33.333,3),(913,7547073,7547063,'isk',33.333,3),(913,7547074,7547071,'nam',50,1),(913,7547075,7547071,'ame',50,1),(913,7547076,7547074,'typ',50,1),(913,7547077,7547074,'ype',50,1),(913,7547078,7547076,'dir',25,1),(913,7547079,7547076,'ire',25,1),(913,7547080,7547076,'rec',25,1),(913,7547081,7547076,'ect',25,1),(914,7547083,7547082,'naa',100,2),(914,7547084,7547083,'600',3.333,3),(914,7547085,7547083,'000',3.333,3),(914,7547086,7547083,'00c',3.333,3),(914,7547087,7547083,'0c2',3.333,3),(914,7547088,7547083,'c29',3.333,3),(914,7547089,7547083,'291',3.333,3),(914,7547090,7547083,'916',3.333,3),(914,7547091,7547083,'16d',3.333,3),(914,7547092,7547083,'6db',3.333,3),(914,7547093,7547083,'db7',3.333,3),(914,7547094,7547083,'b73',3.333,3),(914,7547095,7547083,'738',3.333,3),(914,7547096,7547083,'38c',3.333,3),(914,7547097,7547083,'8c3',3.333,3),(914,7547098,7547083,'c3b',3.333,3),(914,7547099,7547083,'3b0',3.333,3),(914,7547100,7547083,'b0b',3.333,3),(914,7547101,7547083,'0b9',3.333,3),(914,7547102,7547083,'b9b',3.333,3),(914,7547103,7547083,'9b0',3.333,3),(914,7547104,7547083,'b0d',3.333,3),(914,7547105,7547083,'0d8',3.333,3),(914,7547106,7547083,'d87',3.333,3),(914,7547107,7547083,'877',3.333,3),(914,7547108,7547083,'77b',3.333,3),(914,7547109,7547083,'7bb',3.333,3),(914,7547110,7547083,'bb2',3.333,3),(914,7547111,7547083,'b23',3.333,3),(914,7547112,7547083,'23c',3.333,3),(914,7547113,7547083,'3c8',3.333,3),(914,7547114,7547084,'mon',100,1),(914,7547115,7547114,'201',50,1),(914,7547116,7547114,'013',50,1),(914,7547117,7547115,'adm',33.333,4),(914,7547118,7547115,'dmi',33.333,4),(914,7547119,7547115,'min',33.333,4),(914,7547120,7547117,'cap',16.667,1),(914,7547121,7547117,'apa',16.667,1),(914,7547122,7547117,'pac',16.667,1),(914,7547123,7547117,'aci',16.667,1),(914,7547124,7547117,'cit',16.667,1),(914,7547125,7547117,'ity',16.667,1),(914,7547126,7547120,'pat',50,1),(914,7547127,7547120,'ath',50,1),(914,7547128,7547126,'ten',100,1),(914,7547129,7547128,'fre',14.286,1),(914,7547130,7547128,'ree',14.286,1),(914,7547131,7547128,'ees',14.286,1),(914,7547132,7547128,'esp',14.286,1),(914,7547133,7547128,'spa',14.286,1),(914,7547134,7547128,'pac',14.286,1),(914,7547135,7547128,'ace',14.286,1),(914,7547136,7547129,'dis',50,1),(914,7547137,7547129,'isk',50,1),(914,7547138,7547136,'ind',33.333,1),(914,7547139,7547136,'nde',33.333,1),(914,7547140,7547136,'dex',33.333,1),(914,7547141,7547138,'adm',8.333,1),(914,7547142,7547138,'dmi',8.333,1),(914,7547143,7547138,'min',8.333,1),(914,7547144,7547138,'ini',8.333,1),(914,7547145,7547138,'nis',8.333,1),(914,7547146,7547138,'ist',8.333,1),(914,7547147,7547138,'str',8.333,1),(914,7547148,7547138,'tra',8.333,1),(914,7547149,7547138,'rat',8.333,1),(914,7547150,7547138,'ati',8.333,1),(914,7547151,7547138,'tio',8.333,1),(914,7547152,7547138,'ion',8.333,1),(914,7547153,7547141,'sta',33.333,3),(914,7547154,7547141,'tat',33.333,3),(914,7547155,7547141,'ate',33.333,3),(914,7547156,7547153,'dis',16.667,4),(914,7547157,7547153,'isa',16.667,4),(914,7547158,7547153,'sab',16.667,4),(914,7547159,7547153,'abl',16.667,4),(914,7547160,7547153,'ble',16.667,4),(914,7547161,7547153,'led',16.667,4),(914,7547162,7547156,'cac',33.333,1),(914,7547163,7547156,'ach',33.333,1),(914,7547164,7547156,'che',33.333,1),(914,7547165,7547162,'mod',50,1),(914,7547166,7547162,'ode',50,1),(914,7547167,7547165,'wri',14.286,1),(914,7547168,7547165,'rit',14.286,1),(914,7547169,7547165,'ite',14.286,1),(914,7547170,7547165,'tet',14.286,1),(914,7547171,7547165,'eth',14.286,1),(914,7547172,7547165,'thr',14.286,1),(914,7547173,7547165,'hru',14.286,1),(914,7547174,7547167,'ope',11.111,2),(914,7547175,7547167,'per',11.111,2),(914,7547176,7547167,'era',11.111,2),(914,7547177,7547167,'rat',11.111,2),(914,7547178,7547167,'ati',11.111,2),(914,7547179,7547167,'tio',11.111,2),(914,7547180,7547167,'ion',11.111,2),(914,7547181,7547167,'ona',11.111,2),(914,7547182,7547167,'nal',11.111,2),(914,7547183,7547174,'mes',20,1),(914,7547184,7547174,'ess',20,1),(914,7547185,7547174,'ssa',20,1),(914,7547186,7547174,'sag',20,1),(914,7547187,7547174,'age',20,1),(914,7547188,7547183,'per',11.111,1),(914,7547189,7547183,'erf',11.111,1),(914,7547190,7547183,'rfo',11.111,1),(914,7547191,7547183,'for',11.111,1),(914,7547192,7547183,'orm',11.111,1),(914,7547193,7547183,'rma',11.111,1),(914,7547194,7547183,'man',11.111,1),(914,7547195,7547183,'anc',11.111,1),(914,7547196,7547183,'nce',11.111,1),(914,7547197,7547188,'ide',12.5,1),(914,7547198,7547188,'den',12.5,1),(914,7547199,7547188,'ent',12.5,1),(914,7547200,7547188,'nti',12.5,1),(914,7547201,7547188,'tif',12.5,1),(914,7547202,7547188,'ifi',12.5,1),(914,7547203,7547188,'fie',12.5,1),(914,7547204,7547188,'ier',12.5,1),(914,7547205,7547197,'vdi',33.333,3),(914,7547206,7547197,'dis',33.333,3),(914,7547207,7547197,'isk',33.333,3),(914,7547208,7547205,'nam',50,1),(914,7547209,7547205,'ame',50,1),(914,7547210,7547208,'typ',50,1),(914,7547211,7547208,'ype',50,1),(914,7547212,7547210,'dir',25,1),(914,7547213,7547210,'ire',25,1),(914,7547214,7547210,'rec',25,1),(914,7547215,7547210,'ect',25,1),(915,7547217,7547216,'naa',100,2),(915,7547218,7547217,'600',3.333,3),(915,7547219,7547217,'000',3.333,3),(915,7547220,7547217,'00c',3.333,3),(915,7547221,7547217,'0c2',3.333,3),(915,7547222,7547217,'c29',3.333,3),(915,7547223,7547217,'29a',3.333,3),(915,7547224,7547217,'9a4',3.333,3),(915,7547225,7547217,'a42',3.333,3),(915,7547226,7547217,'42a',3.333,3),(915,7547227,7547217,'2a7',3.333,3),(915,7547228,7547217,'a7d',3.333,3),(915,7547229,7547217,'7db',3.333,3),(915,7547230,7547217,'db7',3.333,3),(915,7547231,7547217,'b75',3.333,3),(915,7547232,7547217,'759',3.333,3),(915,7547233,7547217,'59e',3.333,3),(915,7547234,7547217,'9ee',3.333,3),(915,7547235,7547217,'ee2',3.333,3),(915,7547236,7547217,'e20',3.333,3),(915,7547237,7547217,'209',3.333,3),(915,7547238,7547217,'09a',3.333,3),(915,7547239,7547217,'9a8',3.333,3),(915,7547240,7547217,'a8d',3.333,3),(915,7547241,7547217,'8da',3.333,3),(915,7547242,7547217,'da9',3.333,3),(915,7547243,7547217,'a9b',3.333,3),(915,7547244,7547217,'9bc',3.333,3),(915,7547245,7547217,'bc9',3.333,3),(915,7547246,7547217,'c94',3.333,3),(915,7547247,7547217,'945',3.333,3),(915,7547248,7547218,'mon',100,1),(915,7547249,7547248,'201',50,1),(915,7547250,7547248,'013',50,1),(915,7547251,7547249,'adm',33.333,4),(915,7547252,7547249,'dmi',33.333,4),(915,7547253,7547249,'min',33.333,4),(915,7547254,7547251,'cap',16.667,1),(915,7547255,7547251,'apa',16.667,1),(915,7547256,7547251,'pac',16.667,1),(915,7547257,7547251,'aci',16.667,1),(915,7547258,7547251,'cit',16.667,1),(915,7547259,7547251,'ity',16.667,1),(915,7547260,7547254,'pat',50,1),(915,7547261,7547254,'ath',50,1),(915,7547262,7547260,'ele',25,1),(915,7547263,7547260,'lev',25,1),(915,7547264,7547260,'eve',25,1),(915,7547265,7547260,'ven',25,1),(915,7547266,7547262,'fre',14.286,1),(915,7547267,7547262,'ree',14.286,1),(915,7547268,7547262,'ees',14.286,1),(915,7547269,7547262,'esp',14.286,1),(915,7547270,7547262,'spa',14.286,1),(915,7547271,7547262,'pac',14.286,1),(915,7547272,7547262,'ace',14.286,1),(915,7547273,7547266,'dis',50,1),(915,7547274,7547266,'isk',50,1),(915,7547275,7547273,'ind',33.333,1),(915,7547276,7547273,'nde',33.333,1),(915,7547277,7547273,'dex',33.333,1),(915,7547278,7547275,'adm',8.333,1),(915,7547279,7547275,'dmi',8.333,1),(915,7547280,7547275,'min',8.333,1),(915,7547281,7547275,'ini',8.333,1),(915,7547282,7547275,'nis',8.333,1),(915,7547283,7547275,'ist',8.333,1),(915,7547284,7547275,'str',8.333,1),(915,7547285,7547275,'tra',8.333,1),(915,7547286,7547275,'rat',8.333,1),(915,7547287,7547275,'ati',8.333,1),(915,7547288,7547275,'tio',8.333,1),(915,7547289,7547275,'ion',8.333,1),(915,7547290,7547278,'sta',33.333,3),(915,7547291,7547278,'tat',33.333,3),(915,7547292,7547278,'ate',33.333,3),(915,7547293,7547290,'dis',16.667,4),(915,7547294,7547290,'isa',16.667,4),(915,7547295,7547290,'sab',16.667,4),(915,7547296,7547290,'abl',16.667,4),(915,7547297,7547290,'ble',16.667,4),(915,7547298,7547290,'led',16.667,4),(915,7547299,7547293,'cac',33.333,1),(915,7547300,7547293,'ach',33.333,1),(915,7547301,7547293,'che',33.333,1),(915,7547302,7547299,'mod',50,1),(915,7547303,7547299,'ode',50,1),(915,7547304,7547302,'wri',14.286,1),(915,7547305,7547302,'rit',14.286,1),(915,7547306,7547302,'ite',14.286,1),(915,7547307,7547302,'tet',14.286,1),(915,7547308,7547302,'eth',14.286,1),(915,7547309,7547302,'thr',14.286,1),(915,7547310,7547302,'hru',14.286,1),(915,7547311,7547304,'ope',11.111,2),(915,7547312,7547304,'per',11.111,2),(915,7547313,7547304,'era',11.111,2),(915,7547314,7547304,'rat',11.111,2),(915,7547315,7547304,'ati',11.111,2),(915,7547316,7547304,'tio',11.111,2),(915,7547317,7547304,'ion',11.111,2),(915,7547318,7547304,'ona',11.111,2),(915,7547319,7547304,'nal',11.111,2),(915,7547320,7547311,'mes',20,1),(915,7547321,7547311,'ess',20,1),(915,7547322,7547311,'ssa',20,1),(915,7547323,7547311,'sag',20,1),(915,7547324,7547311,'age',20,1),(915,7547325,7547320,'per',11.111,1),(915,7547326,7547320,'erf',11.111,1),(915,7547327,7547320,'rfo',11.111,1),(915,7547328,7547320,'for',11.111,1),(915,7547329,7547320,'orm',11.111,1),(915,7547330,7547320,'rma',11.111,1),(915,7547331,7547320,'man',11.111,1),(915,7547332,7547320,'anc',11.111,1),(915,7547333,7547320,'nce',11.111,1),(915,7547334,7547325,'ide',12.5,1),(915,7547335,7547325,'den',12.5,1),(915,7547336,7547325,'ent',12.5,1),(915,7547337,7547325,'nti',12.5,1),(915,7547338,7547325,'tif',12.5,1),(915,7547339,7547325,'ifi',12.5,1),(915,7547340,7547325,'fie',12.5,1),(915,7547341,7547325,'ier',12.5,1),(915,7547342,7547334,'vdi',33.333,3),(915,7547343,7547334,'dis',33.333,3),(915,7547344,7547334,'isk',33.333,3),(915,7547345,7547342,'nam',50,1),(915,7547346,7547342,'ame',50,1),(915,7547347,7547345,'typ',50,1),(915,7547348,7547345,'ype',50,1),(915,7547349,7547347,'dir',25,1),(915,7547350,7547347,'ire',25,1),(915,7547351,7547347,'rec',25,1),(915,7547352,7547347,'ect',25,1),(916,7547354,7547353,'naa',100,2),(916,7547355,7547354,'600',3.333,3),(916,7547356,7547354,'000',3.333,3),(916,7547357,7547354,'00c',3.333,3),(916,7547358,7547354,'0c2',3.333,3),(916,7547359,7547354,'c29',3.333,3),(916,7547360,7547354,'290',3.333,3),(916,7547361,7547354,'902',3.333,3),(916,7547362,7547354,'02a',3.333,3),(916,7547363,7547354,'2ac',3.333,3),(916,7547364,7547354,'ac5',3.333,3),(916,7547365,7547354,'c56',3.333,3),(916,7547366,7547354,'56e',3.333,3),(916,7547367,7547354,'6e6',3.333,3),(916,7547368,7547354,'e6f',3.333,3),(916,7547369,7547354,'6f4',3.333,3),(916,7547370,7547354,'f4f',3.333,3),(916,7547371,7547354,'4fb',3.333,3),(916,7547372,7547354,'fb3',3.333,3),(916,7547373,7547354,'b3e',3.333,3),(916,7547374,7547354,'3ec',3.333,3),(916,7547375,7547354,'ec2',3.333,3),(916,7547376,7547354,'c25',3.333,3),(916,7547377,7547354,'25a',3.333,3),(916,7547378,7547354,'5a9',3.333,3),(916,7547379,7547354,'a93',3.333,3),(916,7547380,7547354,'938',3.333,3),(916,7547381,7547354,'38e',3.333,3),(916,7547382,7547354,'8e5',3.333,3),(916,7547383,7547354,'e50',3.333,3),(916,7547384,7547354,'509',3.333,3),(916,7547385,7547355,'mon',100,1),(916,7547386,7547385,'201',50,1),(916,7547387,7547385,'013',50,1),(916,7547388,7547386,'adm',33.333,4),(916,7547389,7547386,'dmi',33.333,4),(916,7547390,7547386,'min',33.333,4),(916,7547391,7547388,'cap',16.667,1),(916,7547392,7547388,'apa',16.667,1),(916,7547393,7547388,'pac',16.667,1),(916,7547394,7547388,'aci',16.667,1),(916,7547395,7547388,'cit',16.667,1),(916,7547396,7547388,'ity',16.667,1),(916,7547397,7547391,'pat',50,1),(916,7547398,7547391,'ath',50,1),(916,7547399,7547397,'twe',25,1),(916,7547400,7547397,'wel',25,1),(916,7547401,7547397,'elv',25,1),(916,7547402,7547397,'lve',25,1),(916,7547403,7547399,'fre',14.286,1),(916,7547404,7547399,'ree',14.286,1),(916,7547405,7547399,'ees',14.286,1),(916,7547406,7547399,'esp',14.286,1),(916,7547407,7547399,'spa',14.286,1),(916,7547408,7547399,'pac',14.286,1),(916,7547409,7547399,'ace',14.286,1),(916,7547410,7547403,'dis',50,1),(916,7547411,7547403,'isk',50,1),(916,7547412,7547410,'ind',33.333,1),(916,7547413,7547410,'nde',33.333,1),(916,7547414,7547410,'dex',33.333,1),(916,7547415,7547412,'adm',8.333,1),(916,7547416,7547412,'dmi',8.333,1),(916,7547417,7547412,'min',8.333,1),(916,7547418,7547412,'ini',8.333,1),(916,7547419,7547412,'nis',8.333,1),(916,7547420,7547412,'ist',8.333,1),(916,7547421,7547412,'str',8.333,1),(916,7547422,7547412,'tra',8.333,1),(916,7547423,7547412,'rat',8.333,1),(916,7547424,7547412,'ati',8.333,1),(916,7547425,7547412,'tio',8.333,1),(916,7547426,7547412,'ion',8.333,1),(916,7547427,7547415,'sta',33.333,3),(916,7547428,7547415,'tat',33.333,3),(916,7547429,7547415,'ate',33.333,3),(916,7547430,7547427,'dis',16.667,4),(916,7547431,7547427,'isa',16.667,4),(916,7547432,7547427,'sab',16.667,4),(916,7547433,7547427,'abl',16.667,4),(916,7547434,7547427,'ble',16.667,4),(916,7547435,7547427,'led',16.667,4),(916,7547436,7547430,'cac',33.333,1),(916,7547437,7547430,'ach',33.333,1),(916,7547438,7547430,'che',33.333,1),(916,7547439,7547436,'mod',50,1),(916,7547440,7547436,'ode',50,1),(916,7547441,7547439,'wri',14.286,1),(916,7547442,7547439,'rit',14.286,1),(916,7547443,7547439,'ite',14.286,1),(916,7547444,7547439,'tet',14.286,1),(916,7547445,7547439,'eth',14.286,1),(916,7547446,7547439,'thr',14.286,1),(916,7547447,7547439,'hru',14.286,1),(916,7547448,7547441,'ope',11.111,2),(916,7547449,7547441,'per',11.111,2),(916,7547450,7547441,'era',11.111,2),(916,7547451,7547441,'rat',11.111,2),(916,7547452,7547441,'ati',11.111,2),(916,7547453,7547441,'tio',11.111,2),(916,7547454,7547441,'ion',11.111,2),(916,7547455,7547441,'ona',11.111,2),(916,7547456,7547441,'nal',11.111,2),(916,7547457,7547448,'mes',20,1),(916,7547458,7547448,'ess',20,1),(916,7547459,7547448,'ssa',20,1),(916,7547460,7547448,'sag',20,1),(916,7547461,7547448,'age',20,1),(916,7547462,7547457,'per',11.111,1),(916,7547463,7547457,'erf',11.111,1),(916,7547464,7547457,'rfo',11.111,1),(916,7547465,7547457,'for',11.111,1),(916,7547466,7547457,'orm',11.111,1),(916,7547467,7547457,'rma',11.111,1),(916,7547468,7547457,'man',11.111,1),(916,7547469,7547457,'anc',11.111,1),(916,7547470,7547457,'nce',11.111,1),(916,7547471,7547462,'ide',12.5,1),(916,7547472,7547462,'den',12.5,1),(916,7547473,7547462,'ent',12.5,1),(916,7547474,7547462,'nti',12.5,1),(916,7547475,7547462,'tif',12.5,1),(916,7547476,7547462,'ifi',12.5,1),(916,7547477,7547462,'fie',12.5,1),(916,7547478,7547462,'ier',12.5,1),(916,7547479,7547471,'vdi',33.333,3),(916,7547480,7547471,'dis',33.333,3),(916,7547481,7547471,'isk',33.333,3),(916,7547482,7547479,'nam',50,1),(916,7547483,7547479,'ame',50,1),(916,7547484,7547482,'typ',50,1),(916,7547485,7547482,'ype',50,1),(916,7547486,7547484,'dir',25,1),(916,7547487,7547484,'ire',25,1),(916,7547488,7547484,'rec',25,1),(916,7547489,7547484,'ect',25,1),(917,7547491,7547490,'naa',100,2),(917,7547492,7547491,'600',3.333,3),(917,7547493,7547491,'000',3.333,3),(917,7547494,7547491,'00c',3.333,3),(917,7547495,7547491,'0c2',3.333,3),(917,7547496,7547491,'c29',3.333,3),(917,7547497,7547491,'29d',3.333,3),(917,7547498,7547491,'9d2',3.333,3),(917,7547499,7547491,'d25',3.333,3),(917,7547500,7547491,'250',3.333,3),(917,7547501,7547491,'50c',3.333,3),(917,7547502,7547491,'0cc',3.333,3),(917,7547503,7547491,'ccb',3.333,3),(917,7547504,7547491,'cbb',3.333,3),(917,7547505,7547491,'bb2',3.333,3),(917,7547506,7547491,'b2e',3.333,3),(917,7547507,7547491,'2ef',3.333,3),(917,7547508,7547491,'ef4',3.333,3),(917,7547509,7547491,'f4f',3.333,3),(917,7547510,7547491,'4f9',3.333,3),(917,7547511,7547491,'f95',3.333,3),(917,7547512,7547491,'957',3.333,3),(917,7547513,7547491,'57e',3.333,3),(917,7547514,7547491,'7e9',3.333,3),(917,7547515,7547491,'e90',3.333,3),(917,7547516,7547491,'90b',3.333,3),(917,7547517,7547491,'0ba',3.333,3),(917,7547518,7547491,'ba8',3.333,3),(917,7547519,7547491,'a8b',3.333,3),(917,7547520,7547491,'8b8',3.333,3),(917,7547521,7547491,'b86',3.333,3),(917,7547522,7547492,'mon',100,1),(917,7547523,7547522,'201',50,1),(917,7547524,7547522,'013',50,1),(917,7547525,7547523,'adm',33.333,4),(917,7547526,7547523,'dmi',33.333,4),(917,7547527,7547523,'min',33.333,4),(917,7547528,7547525,'cap',16.667,1),(917,7547529,7547525,'apa',16.667,1),(917,7547530,7547525,'pac',16.667,1),(917,7547531,7547525,'aci',16.667,1),(917,7547532,7547525,'cit',16.667,1),(917,7547533,7547525,'ity',16.667,1),(917,7547534,7547528,'pat',50,1),(917,7547535,7547528,'ath',50,1),(917,7547536,7547534,'thi',16.667,1),(917,7547537,7547534,'hir',16.667,1),(917,7547538,7547534,'irt',16.667,1),(917,7547539,7547534,'rte',16.667,1),(917,7547540,7547534,'tee',16.667,1),(917,7547541,7547534,'een',16.667,1),(917,7547542,7547536,'fre',14.286,1),(917,7547543,7547536,'ree',14.286,1),(917,7547544,7547536,'ees',14.286,1),(917,7547545,7547536,'esp',14.286,1),(917,7547546,7547536,'spa',14.286,1),(917,7547547,7547536,'pac',14.286,1),(917,7547548,7547536,'ace',14.286,1),(917,7547549,7547542,'dis',50,1),(917,7547550,7547542,'isk',50,1),(917,7547551,7547549,'ind',33.333,1),(917,7547552,7547549,'nde',33.333,1),(917,7547553,7547549,'dex',33.333,1),(917,7547554,7547551,'adm',8.333,1),(917,7547555,7547551,'dmi',8.333,1),(917,7547556,7547551,'min',8.333,1),(917,7547557,7547551,'ini',8.333,1),(917,7547558,7547551,'nis',8.333,1),(917,7547559,7547551,'ist',8.333,1),(917,7547560,7547551,'str',8.333,1),(917,7547561,7547551,'tra',8.333,1),(917,7547562,7547551,'rat',8.333,1),(917,7547563,7547551,'ati',8.333,1),(917,7547564,7547551,'tio',8.333,1),(917,7547565,7547551,'ion',8.333,1),(917,7547566,7547554,'sta',33.333,3),(917,7547567,7547554,'tat',33.333,3),(917,7547568,7547554,'ate',33.333,3),(917,7547569,7547566,'dis',16.667,4),(917,7547570,7547566,'isa',16.667,4),(917,7547571,7547566,'sab',16.667,4),(917,7547572,7547566,'abl',16.667,4),(917,7547573,7547566,'ble',16.667,4),(917,7547574,7547566,'led',16.667,4),(917,7547575,7547569,'cac',33.333,1),(917,7547576,7547569,'ach',33.333,1),(917,7547577,7547569,'che',33.333,1),(917,7547578,7547575,'mod',50,1),(917,7547579,7547575,'ode',50,1),(917,7547580,7547578,'wri',14.286,1),(917,7547581,7547578,'rit',14.286,1),(917,7547582,7547578,'ite',14.286,1),(917,7547583,7547578,'tet',14.286,1),(917,7547584,7547578,'eth',14.286,1),(917,7547585,7547578,'thr',14.286,1),(917,7547586,7547578,'hru',14.286,1),(917,7547587,7547580,'ope',11.111,2),(917,7547588,7547580,'per',11.111,2),(917,7547589,7547580,'era',11.111,2),(917,7547590,7547580,'rat',11.111,2),(917,7547591,7547580,'ati',11.111,2),(917,7547592,7547580,'tio',11.111,2),(917,7547593,7547580,'ion',11.111,2),(917,7547594,7547580,'ona',11.111,2),(917,7547595,7547580,'nal',11.111,2),(917,7547596,7547587,'mes',20,1),(917,7547597,7547587,'ess',20,1),(917,7547598,7547587,'ssa',20,1),(917,7547599,7547587,'sag',20,1),(917,7547600,7547587,'age',20,1),(917,7547601,7547596,'per',11.111,1),(917,7547602,7547596,'erf',11.111,1),(917,7547603,7547596,'rfo',11.111,1),(917,7547604,7547596,'for',11.111,1),(917,7547605,7547596,'orm',11.111,1),(917,7547606,7547596,'rma',11.111,1),(917,7547607,7547596,'man',11.111,1),(917,7547608,7547596,'anc',11.111,1),(917,7547609,7547596,'nce',11.111,1),(917,7547610,7547601,'ide',12.5,1),(917,7547611,7547601,'den',12.5,1),(917,7547612,7547601,'ent',12.5,1),(917,7547613,7547601,'nti',12.5,1),(917,7547614,7547601,'tif',12.5,1),(917,7547615,7547601,'ifi',12.5,1),(917,7547616,7547601,'fie',12.5,1),(917,7547617,7547601,'ier',12.5,1),(917,7547618,7547610,'vdi',33.333,3),(917,7547619,7547610,'dis',33.333,3),(917,7547620,7547610,'isk',33.333,3),(917,7547621,7547618,'nam',50,1),(917,7547622,7547618,'ame',50,1),(917,7547623,7547621,'typ',50,1),(917,7547624,7547621,'ype',50,1),(917,7547625,7547623,'dir',25,1),(917,7547626,7547623,'ire',25,1),(917,7547627,7547623,'rec',25,1),(917,7547628,7547623,'ect',25,1),(918,7547630,7547629,'naa',100,2),(918,7547631,7547630,'600',3.333,3),(918,7547632,7547630,'000',3.333,3),(918,7547633,7547630,'00c',3.333,3),(918,7547634,7547630,'0c2',3.333,3),(918,7547635,7547630,'c29',3.333,3),(918,7547636,7547630,'291',3.333,3),(918,7547637,7547630,'914',3.333,3),(918,7547638,7547630,'14a',3.333,3),(918,7547639,7547630,'4a3',3.333,3),(918,7547640,7547630,'a3a',3.333,3),(918,7547641,7547630,'3ae',3.333,3),(918,7547642,7547630,'ae9',3.333,3),(918,7547643,7547630,'e96',3.333,3),(918,7547644,7547630,'960',3.333,3),(918,7547645,7547630,'608',3.333,3),(918,7547646,7547630,'08b',3.333,3),(918,7547647,7547630,'8b2',3.333,3),(918,7547648,7547630,'b24',3.333,3),(918,7547649,7547630,'24b',3.333,3),(918,7547650,7547630,'4b8',3.333,3),(918,7547651,7547630,'b84',3.333,3),(918,7547652,7547630,'846',3.333,3),(918,7547653,7547630,'469',3.333,3),(918,7547654,7547630,'69a',3.333,3),(918,7547655,7547630,'9af',3.333,3),(918,7547656,7547630,'af3',3.333,3),(918,7547657,7547630,'f3c',3.333,3),(918,7547658,7547630,'3ca',3.333,3),(918,7547659,7547630,'caa',3.333,3),(918,7547660,7547630,'aa2',3.333,3),(918,7547661,7547631,'mon',100,1),(918,7547662,7547661,'201',50,1),(918,7547663,7547661,'013',50,1),(918,7547664,7547662,'adm',33.333,4),(918,7547665,7547662,'dmi',33.333,4),(918,7547666,7547662,'min',33.333,4),(918,7547667,7547664,'cap',16.667,1),(918,7547668,7547664,'apa',16.667,1),(918,7547669,7547664,'pac',16.667,1),(918,7547670,7547664,'aci',16.667,1),(918,7547671,7547664,'cit',16.667,1),(918,7547672,7547664,'ity',16.667,1),(918,7547673,7547667,'pat',50,1),(918,7547674,7547667,'ath',50,1),(918,7547675,7547673,'fre',14.286,1),(918,7547676,7547673,'ree',14.286,1),(918,7547677,7547673,'ees',14.286,1),(918,7547678,7547673,'esp',14.286,1),(918,7547679,7547673,'spa',14.286,1),(918,7547680,7547673,'pac',14.286,1),(918,7547681,7547673,'ace',14.286,1),(918,7547682,7547675,'dis',50,1),(918,7547683,7547675,'isk',50,1),(918,7547684,7547682,'ind',33.333,1),(918,7547685,7547682,'nde',33.333,1),(918,7547686,7547682,'dex',33.333,1),(918,7547687,7547684,'adm',8.333,1),(918,7547688,7547684,'dmi',8.333,1),(918,7547689,7547684,'min',8.333,1),(918,7547690,7547684,'ini',8.333,1),(918,7547691,7547684,'nis',8.333,1),(918,7547692,7547684,'ist',8.333,1),(918,7547693,7547684,'str',8.333,1),(918,7547694,7547684,'tra',8.333,1),(918,7547695,7547684,'rat',8.333,1),(918,7547696,7547684,'ati',8.333,1),(918,7547697,7547684,'tio',8.333,1),(918,7547698,7547684,'ion',8.333,1),(918,7547699,7547687,'sta',33.333,3),(918,7547700,7547687,'tat',33.333,3),(918,7547701,7547687,'ate',33.333,3),(918,7547702,7547699,'dis',16.667,4),(918,7547703,7547699,'isa',16.667,4),(918,7547704,7547699,'sab',16.667,4),(918,7547705,7547699,'abl',16.667,4),(918,7547706,7547699,'ble',16.667,4),(918,7547707,7547699,'led',16.667,4),(918,7547708,7547702,'cac',33.333,1),(918,7547709,7547702,'ach',33.333,1),(918,7547710,7547702,'che',33.333,1),(918,7547711,7547708,'mod',50,1),(918,7547712,7547708,'ode',50,1),(918,7547713,7547711,'wri',14.286,1),(918,7547714,7547711,'rit',14.286,1),(918,7547715,7547711,'ite',14.286,1),(918,7547716,7547711,'tet',14.286,1),(918,7547717,7547711,'eth',14.286,1),(918,7547718,7547711,'thr',14.286,1),(918,7547719,7547711,'hru',14.286,1),(918,7547720,7547713,'ope',11.111,2),(918,7547721,7547713,'per',11.111,2),(918,7547722,7547713,'era',11.111,2),(918,7547723,7547713,'rat',11.111,2),(918,7547724,7547713,'ati',11.111,2),(918,7547725,7547713,'tio',11.111,2),(918,7547726,7547713,'ion',11.111,2),(918,7547727,7547713,'ona',11.111,2),(918,7547728,7547713,'nal',11.111,2),(918,7547729,7547720,'mes',20,1),(918,7547730,7547720,'ess',20,1),(918,7547731,7547720,'ssa',20,1),(918,7547732,7547720,'sag',20,1),(918,7547733,7547720,'age',20,1),(918,7547734,7547729,'per',11.111,1),(918,7547735,7547729,'erf',11.111,1),(918,7547736,7547729,'rfo',11.111,1),(918,7547737,7547729,'for',11.111,1),(918,7547738,7547729,'orm',11.111,1),(918,7547739,7547729,'rma',11.111,1),(918,7547740,7547729,'man',11.111,1),(918,7547741,7547729,'anc',11.111,1),(918,7547742,7547729,'nce',11.111,1),(918,7547743,7547734,'ide',12.5,1),(918,7547744,7547734,'den',12.5,1),(918,7547745,7547734,'ent',12.5,1),(918,7547746,7547734,'nti',12.5,1),(918,7547747,7547734,'tif',12.5,1),(918,7547748,7547734,'ifi',12.5,1),(918,7547749,7547734,'fie',12.5,1),(918,7547750,7547734,'ier',12.5,1),(918,7547751,7547743,'vdi',33.333,3),(918,7547752,7547743,'dis',33.333,3),(918,7547753,7547743,'isk',33.333,3),(918,7547754,7547751,'nam',50,1),(918,7547755,7547751,'ame',50,1),(918,7547756,7547754,'typ',50,1),(918,7547757,7547754,'ype',50,1),(918,7547758,7547756,'dir',25,1),(918,7547759,7547756,'ire',25,1),(918,7547760,7547756,'rec',25,1),(918,7547761,7547756,'ect',25,1),(919,7547763,7547762,'naa',100,2),(919,7547764,7547763,'600',3.333,3),(919,7547765,7547763,'000',3.333,3),(919,7547766,7547763,'00c',3.333,3),(919,7547767,7547763,'0c2',3.333,3),(919,7547768,7547763,'c29',3.333,3),(919,7547769,7547763,'293',3.333,3),(919,7547770,7547763,'93c',3.333,3),(919,7547771,7547763,'3c2',3.333,3),(919,7547772,7547763,'c2d',3.333,3),(919,7547773,7547763,'2d4',3.333,3),(919,7547774,7547763,'d46',3.333,3),(919,7547775,7547763,'469',3.333,3),(919,7547776,7547763,'692',3.333,3),(919,7547777,7547763,'920',3.333,3),(919,7547778,7547763,'20c',3.333,3),(919,7547779,7547763,'0c8',3.333,3),(919,7547780,7547763,'c80',3.333,3),(919,7547781,7547763,'803',3.333,3),(919,7547782,7547763,'03e',3.333,3),(919,7547783,7547763,'3ed',3.333,3),(919,7547784,7547763,'eda',3.333,3),(919,7547785,7547763,'da9',3.333,3),(919,7547786,7547763,'a9c',3.333,3),(919,7547787,7547763,'9c3',3.333,3),(919,7547788,7547763,'c3e',3.333,3),(919,7547789,7547763,'3e2',3.333,3),(919,7547790,7547763,'e20',3.333,3),(919,7547791,7547763,'207',3.333,3),(919,7547792,7547763,'07e',3.333,3),(919,7547793,7547763,'7e9',3.333,3),(919,7547794,7547764,'mon',100,1),(919,7547795,7547794,'201',50,1),(919,7547796,7547794,'013',50,1),(919,7547797,7547795,'adm',33.333,4),(919,7547798,7547795,'dmi',33.333,4),(919,7547799,7547795,'min',33.333,4),(919,7547800,7547797,'cap',16.667,1),(919,7547801,7547797,'apa',16.667,1),(919,7547802,7547797,'pac',16.667,1),(919,7547803,7547797,'aci',16.667,1),(919,7547804,7547797,'cit',16.667,1),(919,7547805,7547797,'ity',16.667,1),(919,7547806,7547800,'pat',50,1),(919,7547807,7547800,'ath',50,1),(919,7547808,7547806,'fre',14.286,1),(919,7547809,7547806,'ree',14.286,1),(919,7547810,7547806,'ees',14.286,1),(919,7547811,7547806,'esp',14.286,1),(919,7547812,7547806,'spa',14.286,1),(919,7547813,7547806,'pac',14.286,1),(919,7547814,7547806,'ace',14.286,1),(919,7547815,7547808,'dis',50,1),(919,7547816,7547808,'isk',50,1),(919,7547817,7547815,'ind',33.333,1),(919,7547818,7547815,'nde',33.333,1),(919,7547819,7547815,'dex',33.333,1),(919,7547820,7547817,'adm',8.333,1),(919,7547821,7547817,'dmi',8.333,1),(919,7547822,7547817,'min',8.333,1),(919,7547823,7547817,'ini',8.333,1),(919,7547824,7547817,'nis',8.333,1),(919,7547825,7547817,'ist',8.333,1),(919,7547826,7547817,'str',8.333,1),(919,7547827,7547817,'tra',8.333,1),(919,7547828,7547817,'rat',8.333,1),(919,7547829,7547817,'ati',8.333,1),(919,7547830,7547817,'tio',8.333,1),(919,7547831,7547817,'ion',8.333,1),(919,7547832,7547820,'sta',33.333,3),(919,7547833,7547820,'tat',33.333,3),(919,7547834,7547820,'ate',33.333,3),(919,7547835,7547832,'dis',16.667,4),(919,7547836,7547832,'isa',16.667,4),(919,7547837,7547832,'sab',16.667,4),(919,7547838,7547832,'abl',16.667,4),(919,7547839,7547832,'ble',16.667,4),(919,7547840,7547832,'led',16.667,4),(919,7547841,7547835,'cac',33.333,1),(919,7547842,7547835,'ach',33.333,1),(919,7547843,7547835,'che',33.333,1),(919,7547844,7547841,'mod',50,1),(919,7547845,7547841,'ode',50,1),(919,7547846,7547844,'wri',14.286,1),(919,7547847,7547844,'rit',14.286,1),(919,7547848,7547844,'ite',14.286,1),(919,7547849,7547844,'tet',14.286,1),(919,7547850,7547844,'eth',14.286,1),(919,7547851,7547844,'thr',14.286,1),(919,7547852,7547844,'hru',14.286,1),(919,7547853,7547846,'ope',11.111,2),(919,7547854,7547846,'per',11.111,2),(919,7547855,7547846,'era',11.111,2),(919,7547856,7547846,'rat',11.111,2),(919,7547857,7547846,'ati',11.111,2),(919,7547858,7547846,'tio',11.111,2),(919,7547859,7547846,'ion',11.111,2),(919,7547860,7547846,'ona',11.111,2),(919,7547861,7547846,'nal',11.111,2),(919,7547862,7547853,'mes',20,1),(919,7547863,7547853,'ess',20,1),(919,7547864,7547853,'ssa',20,1),(919,7547865,7547853,'sag',20,1),(919,7547866,7547853,'age',20,1),(919,7547867,7547862,'per',11.111,1),(919,7547868,7547862,'erf',11.111,1),(919,7547869,7547862,'rfo',11.111,1),(919,7547870,7547862,'for',11.111,1),(919,7547871,7547862,'orm',11.111,1),(919,7547872,7547862,'rma',11.111,1),(919,7547873,7547862,'man',11.111,1),(919,7547874,7547862,'anc',11.111,1),(919,7547875,7547862,'nce',11.111,1),(919,7547876,7547867,'ide',12.5,1),(919,7547877,7547867,'den',12.5,1),(919,7547878,7547867,'ent',12.5,1),(919,7547879,7547867,'nti',12.5,1),(919,7547880,7547867,'tif',12.5,1),(919,7547881,7547867,'ifi',12.5,1),(919,7547882,7547867,'fie',12.5,1),(919,7547883,7547867,'ier',12.5,1),(919,7547884,7547876,'vdi',33.333,3),(919,7547885,7547876,'dis',33.333,3),(919,7547886,7547876,'isk',33.333,3),(919,7547887,7547884,'nam',50,1),(919,7547888,7547884,'ame',50,1),(919,7547889,7547887,'typ',50,1),(919,7547890,7547887,'ype',50,1),(919,7547891,7547889,'dir',25,1),(919,7547892,7547889,'ire',25,1),(919,7547893,7547889,'rec',25,1),(919,7547894,7547889,'ect',25,1),(920,7547896,7547895,'naa',100,2),(920,7547897,7547896,'600',3.333,3),(920,7547898,7547896,'000',3.333,3),(920,7547899,7547896,'00c',3.333,3),(920,7547900,7547896,'0c2',3.333,3),(920,7547901,7547896,'c29',3.333,3),(920,7547902,7547896,'299',3.333,3),(920,7547903,7547896,'991',3.333,3),(920,7547904,7547896,'919',3.333,3),(920,7547905,7547896,'191',3.333,3),(920,7547906,7547896,'91b',3.333,3),(920,7547907,7547896,'1bf',3.333,3),(920,7547908,7547896,'bfe',3.333,3),(920,7547909,7547896,'fef',3.333,3),(920,7547910,7547896,'ef2',3.333,3),(920,7547911,7547896,'f29',3.333,3),(920,7547912,7547896,'296',3.333,3),(920,7547913,7547896,'969',3.333,3),(920,7547914,7547896,'694',3.333,3),(920,7547915,7547896,'94d',3.333,3),(920,7547916,7547896,'4d6',3.333,3),(920,7547917,7547896,'d60',3.333,3),(920,7547918,7547896,'608',3.333,3),(920,7547919,7547896,'089',3.333,3),(920,7547920,7547896,'89d',3.333,3),(920,7547921,7547896,'9d6',3.333,3),(920,7547922,7547896,'d6d',3.333,3),(920,7547923,7547896,'6d3',3.333,3),(920,7547924,7547896,'d38',3.333,3),(920,7547925,7547896,'38a',3.333,3),(920,7547926,7547896,'8ac',3.333,3),(920,7547927,7547897,'mon',100,1),(920,7547928,7547927,'201',50,1),(920,7547929,7547927,'013',50,1),(920,7547930,7547928,'adm',33.333,4),(920,7547931,7547928,'dmi',33.333,4),(920,7547932,7547928,'min',33.333,4),(920,7547933,7547930,'cap',16.667,1),(920,7547934,7547930,'apa',16.667,1),(920,7547935,7547930,'pac',16.667,1),(920,7547936,7547930,'aci',16.667,1),(920,7547937,7547930,'cit',16.667,1),(920,7547938,7547930,'ity',16.667,1),(920,7547939,7547933,'pat',50,1),(920,7547940,7547933,'ath',50,1),(920,7547941,7547939,'fre',14.286,1),(920,7547942,7547939,'ree',14.286,1),(920,7547943,7547939,'ees',14.286,1),(920,7547944,7547939,'esp',14.286,1),(920,7547945,7547939,'spa',14.286,1),(920,7547946,7547939,'pac',14.286,1),(920,7547947,7547939,'ace',14.286,1),(920,7547948,7547941,'dis',50,1),(920,7547949,7547941,'isk',50,1),(920,7547950,7547948,'ind',33.333,1),(920,7547951,7547948,'nde',33.333,1),(920,7547952,7547948,'dex',33.333,1),(920,7547953,7547950,'adm',8.333,1),(920,7547954,7547950,'dmi',8.333,1),(920,7547955,7547950,'min',8.333,1),(920,7547956,7547950,'ini',8.333,1),(920,7547957,7547950,'nis',8.333,1),(920,7547958,7547950,'ist',8.333,1),(920,7547959,7547950,'str',8.333,1),(920,7547960,7547950,'tra',8.333,1),(920,7547961,7547950,'rat',8.333,1),(920,7547962,7547950,'ati',8.333,1),(920,7547963,7547950,'tio',8.333,1),(920,7547964,7547950,'ion',8.333,1),(920,7547965,7547953,'sta',33.333,3),(920,7547966,7547953,'tat',33.333,3),(920,7547967,7547953,'ate',33.333,3),(920,7547968,7547965,'dis',16.667,4),(920,7547969,7547965,'isa',16.667,4),(920,7547970,7547965,'sab',16.667,4),(920,7547971,7547965,'abl',16.667,4),(920,7547972,7547965,'ble',16.667,4),(920,7547973,7547965,'led',16.667,4),(920,7547974,7547968,'cac',33.333,1),(920,7547975,7547968,'ach',33.333,1),(920,7547976,7547968,'che',33.333,1),(920,7547977,7547974,'mod',50,1),(920,7547978,7547974,'ode',50,1),(920,7547979,7547977,'wri',14.286,1),(920,7547980,7547977,'rit',14.286,1),(920,7547981,7547977,'ite',14.286,1),(920,7547982,7547977,'tet',14.286,1),(920,7547983,7547977,'eth',14.286,1),(920,7547984,7547977,'thr',14.286,1),(920,7547985,7547977,'hru',14.286,1),(920,7547986,7547979,'ope',11.111,2),(920,7547987,7547979,'per',11.111,2),(920,7547988,7547979,'era',11.111,2),(920,7547989,7547979,'rat',11.111,2),(920,7547990,7547979,'ati',11.111,2),(920,7547991,7547979,'tio',11.111,2),(920,7547992,7547979,'ion',11.111,2),(920,7547993,7547979,'ona',11.111,2),(920,7547994,7547979,'nal',11.111,2),(920,7547995,7547986,'mes',20,1),(920,7547996,7547986,'ess',20,1),(920,7547997,7547986,'ssa',20,1),(920,7547998,7547986,'sag',20,1),(920,7547999,7547986,'age',20,1),(920,7548000,7547995,'per',11.111,1),(920,7548001,7547995,'erf',11.111,1),(920,7548002,7547995,'rfo',11.111,1),(920,7548003,7547995,'for',11.111,1),(920,7548004,7547995,'orm',11.111,1),(920,7548005,7547995,'rma',11.111,1),(920,7548006,7547995,'man',11.111,1),(920,7548007,7547995,'anc',11.111,1),(920,7548008,7547995,'nce',11.111,1),(920,7548009,7548000,'ide',12.5,1),(920,7548010,7548000,'den',12.5,1),(920,7548011,7548000,'ent',12.5,1),(920,7548012,7548000,'nti',12.5,1),(920,7548013,7548000,'tif',12.5,1),(920,7548014,7548000,'ifi',12.5,1),(920,7548015,7548000,'fie',12.5,1),(920,7548016,7548000,'ier',12.5,1),(920,7548017,7548009,'vdi',33.333,3),(920,7548018,7548009,'dis',33.333,3),(920,7548019,7548009,'isk',33.333,3),(920,7548020,7548017,'nam',50,1),(920,7548021,7548017,'ame',50,1),(920,7548022,7548020,'typ',50,1),(920,7548023,7548020,'ype',50,1),(920,7548024,7548022,'dir',25,1),(920,7548025,7548022,'ire',25,1),(920,7548026,7548022,'rec',25,1),(920,7548027,7548022,'ect',25,1),(921,7548029,7548028,'naa',100,2),(921,7548030,7548029,'600',3.333,3),(921,7548031,7548029,'000',3.333,3),(921,7548032,7548029,'00c',3.333,3),(921,7548033,7548029,'0c2',3.333,3),(921,7548034,7548029,'c29',3.333,3),(921,7548035,7548029,'295',3.333,3),(921,7548036,7548029,'959',3.333,3),(921,7548037,7548029,'598',3.333,3),(921,7548038,7548029,'983',3.333,3),(921,7548039,7548029,'83d',3.333,3),(921,7548040,7548029,'3d7',3.333,3),(921,7548041,7548029,'d7f',3.333,3),(921,7548042,7548029,'7f1',3.333,3),(921,7548043,7548029,'f15',3.333,3),(921,7548044,7548029,'15b',3.333,3),(921,7548045,7548029,'5bb',3.333,3),(921,7548046,7548029,'bbe',3.333,3),(921,7548047,7548029,'bec',3.333,3),(921,7548048,7548029,'ec8',3.333,3),(921,7548049,7548029,'c87',3.333,3),(921,7548050,7548029,'874',3.333,3),(921,7548051,7548029,'748',3.333,3),(921,7548052,7548029,'485',3.333,3),(921,7548053,7548029,'853',3.333,3),(921,7548054,7548029,'53c',3.333,3),(921,7548055,7548029,'3cb',3.333,3),(921,7548056,7548029,'cbe',3.333,3),(921,7548057,7548029,'be8',3.333,3),(921,7548058,7548029,'e80',3.333,3),(921,7548059,7548029,'80d',3.333,3),(921,7548060,7548030,'mon',100,1),(921,7548061,7548060,'201',50,1),(921,7548062,7548060,'013',50,1),(921,7548063,7548061,'adm',33.333,4),(921,7548064,7548061,'dmi',33.333,4),(921,7548065,7548061,'min',33.333,4),(921,7548066,7548063,'cap',16.667,1),(921,7548067,7548063,'apa',16.667,1),(921,7548068,7548063,'pac',16.667,1),(921,7548069,7548063,'aci',16.667,1),(921,7548070,7548063,'cit',16.667,1),(921,7548071,7548063,'ity',16.667,1),(921,7548072,7548066,'pat',50,1),(921,7548073,7548066,'ath',50,1),(921,7548074,7548072,'fre',14.286,1),(921,7548075,7548072,'ree',14.286,1),(921,7548076,7548072,'ees',14.286,1),(921,7548077,7548072,'esp',14.286,1),(921,7548078,7548072,'spa',14.286,1),(921,7548079,7548072,'pac',14.286,1),(921,7548080,7548072,'ace',14.286,1),(921,7548081,7548074,'dis',50,1),(921,7548082,7548074,'isk',50,1),(921,7548083,7548081,'ind',33.333,1),(921,7548084,7548081,'nde',33.333,1),(921,7548085,7548081,'dex',33.333,1),(921,7548086,7548083,'adm',8.333,1),(921,7548087,7548083,'dmi',8.333,1),(921,7548088,7548083,'min',8.333,1),(921,7548089,7548083,'ini',8.333,1),(921,7548090,7548083,'nis',8.333,1),(921,7548091,7548083,'ist',8.333,1),(921,7548092,7548083,'str',8.333,1),(921,7548093,7548083,'tra',8.333,1),(921,7548094,7548083,'rat',8.333,1),(921,7548095,7548083,'ati',8.333,1),(921,7548096,7548083,'tio',8.333,1),(921,7548097,7548083,'ion',8.333,1),(921,7548098,7548086,'sta',33.333,3),(921,7548099,7548086,'tat',33.333,3),(921,7548100,7548086,'ate',33.333,3),(921,7548101,7548098,'dis',16.667,4),(921,7548102,7548098,'isa',16.667,4),(921,7548103,7548098,'sab',16.667,4),(921,7548104,7548098,'abl',16.667,4),(921,7548105,7548098,'ble',16.667,4),(921,7548106,7548098,'led',16.667,4),(921,7548107,7548101,'cac',33.333,1),(921,7548108,7548101,'ach',33.333,1),(921,7548109,7548101,'che',33.333,1),(921,7548110,7548107,'mod',50,1),(921,7548111,7548107,'ode',50,1),(921,7548112,7548110,'wri',14.286,1),(921,7548113,7548110,'rit',14.286,1),(921,7548114,7548110,'ite',14.286,1),(921,7548115,7548110,'tet',14.286,1),(921,7548116,7548110,'eth',14.286,1),(921,7548117,7548110,'thr',14.286,1),(921,7548118,7548110,'hru',14.286,1),(921,7548119,7548112,'ope',11.111,2),(921,7548120,7548112,'per',11.111,2),(921,7548121,7548112,'era',11.111,2),(921,7548122,7548112,'rat',11.111,2),(921,7548123,7548112,'ati',11.111,2),(921,7548124,7548112,'tio',11.111,2),(921,7548125,7548112,'ion',11.111,2),(921,7548126,7548112,'ona',11.111,2),(921,7548127,7548112,'nal',11.111,2),(921,7548128,7548119,'mes',20,1),(921,7548129,7548119,'ess',20,1),(921,7548130,7548119,'ssa',20,1),(921,7548131,7548119,'sag',20,1),(921,7548132,7548119,'age',20,1),(921,7548133,7548128,'per',11.111,1),(921,7548134,7548128,'erf',11.111,1),(921,7548135,7548128,'rfo',11.111,1),(921,7548136,7548128,'for',11.111,1),(921,7548137,7548128,'orm',11.111,1),(921,7548138,7548128,'rma',11.111,1),(921,7548139,7548128,'man',11.111,1),(921,7548140,7548128,'anc',11.111,1),(921,7548141,7548128,'nce',11.111,1),(921,7548142,7548133,'ide',12.5,1),(921,7548143,7548133,'den',12.5,1),(921,7548144,7548133,'ent',12.5,1),(921,7548145,7548133,'nti',12.5,1),(921,7548146,7548133,'tif',12.5,1),(921,7548147,7548133,'ifi',12.5,1),(921,7548148,7548133,'fie',12.5,1),(921,7548149,7548133,'ier',12.5,1),(921,7548150,7548142,'vdi',33.333,3),(921,7548151,7548142,'dis',33.333,3),(921,7548152,7548142,'isk',33.333,3),(921,7548153,7548150,'nam',50,1),(921,7548154,7548150,'ame',50,1),(921,7548155,7548153,'typ',50,1),(921,7548156,7548153,'ype',50,1),(921,7548157,7548155,'dir',25,1),(921,7548158,7548155,'ire',25,1),(921,7548159,7548155,'rec',25,1),(921,7548160,7548155,'ect',25,1),(922,7548162,7548161,'naa',100,2),(922,7548163,7548162,'600',3.333,3),(922,7548164,7548162,'000',3.333,3),(922,7548165,7548162,'00c',3.333,3),(922,7548166,7548162,'0c2',3.333,3),(922,7548167,7548162,'c29',3.333,3),(922,7548168,7548162,'29d',3.333,3),(922,7548169,7548162,'9d1',3.333,3),(922,7548170,7548162,'d1f',3.333,3),(922,7548171,7548162,'1f0',3.333,3),(922,7548172,7548162,'f08',3.333,3),(922,7548173,7548162,'082',3.333,3),(922,7548174,7548162,'820',3.333,3),(922,7548175,7548162,'209',3.333,3),(922,7548176,7548162,'09d',3.333,3),(922,7548177,7548162,'9d8',3.333,3),(922,7548178,7548162,'d84',3.333,3),(922,7548179,7548162,'84b',3.333,3),(922,7548180,7548162,'4b2',3.333,3),(922,7548181,7548162,'b20',3.333,3),(922,7548182,7548162,'20a',3.333,3),(922,7548183,7548162,'0a5',3.333,3),(922,7548184,7548162,'a5d',3.333,3),(922,7548185,7548162,'5de',3.333,3),(922,7548186,7548162,'dea',3.333,3),(922,7548187,7548162,'ea2',3.333,3),(922,7548188,7548162,'a24',3.333,3),(922,7548189,7548162,'244',3.333,3),(922,7548190,7548162,'44b',3.333,3),(922,7548191,7548162,'4bc',3.333,3),(922,7548192,7548162,'bcd',3.333,3),(922,7548193,7548163,'mon',100,1),(922,7548194,7548193,'201',50,1),(922,7548195,7548193,'013',50,1),(922,7548196,7548194,'adm',33.333,4),(922,7548197,7548194,'dmi',33.333,4),(922,7548198,7548194,'min',33.333,4),(922,7548199,7548196,'cap',16.667,1),(922,7548200,7548196,'apa',16.667,1),(922,7548201,7548196,'pac',16.667,1),(922,7548202,7548196,'aci',16.667,1),(922,7548203,7548196,'cit',16.667,1),(922,7548204,7548196,'ity',16.667,1),(922,7548205,7548199,'pat',50,1),(922,7548206,7548199,'ath',50,1),(922,7548207,7548205,'fre',14.286,1),(922,7548208,7548205,'ree',14.286,1),(922,7548209,7548205,'ees',14.286,1),(922,7548210,7548205,'esp',14.286,1),(922,7548211,7548205,'spa',14.286,1),(922,7548212,7548205,'pac',14.286,1),(922,7548213,7548205,'ace',14.286,1),(922,7548214,7548207,'dis',50,1),(922,7548215,7548207,'isk',50,1),(922,7548216,7548214,'ind',33.333,1),(922,7548217,7548214,'nde',33.333,1),(922,7548218,7548214,'dex',33.333,1),(922,7548219,7548216,'adm',8.333,1),(922,7548220,7548216,'dmi',8.333,1),(922,7548221,7548216,'min',8.333,1),(922,7548222,7548216,'ini',8.333,1),(922,7548223,7548216,'nis',8.333,1),(922,7548224,7548216,'ist',8.333,1),(922,7548225,7548216,'str',8.333,1),(922,7548226,7548216,'tra',8.333,1),(922,7548227,7548216,'rat',8.333,1),(922,7548228,7548216,'ati',8.333,1),(922,7548229,7548216,'tio',8.333,1),(922,7548230,7548216,'ion',8.333,1),(922,7548231,7548219,'sta',33.333,3),(922,7548232,7548219,'tat',33.333,3),(922,7548233,7548219,'ate',33.333,3),(922,7548234,7548231,'dis',16.667,4),(922,7548235,7548231,'isa',16.667,4),(922,7548236,7548231,'sab',16.667,4),(922,7548237,7548231,'abl',16.667,4),(922,7548238,7548231,'ble',16.667,4),(922,7548239,7548231,'led',16.667,4),(922,7548240,7548234,'cac',33.333,1),(922,7548241,7548234,'ach',33.333,1),(922,7548242,7548234,'che',33.333,1),(922,7548243,7548240,'mod',50,1),(922,7548244,7548240,'ode',50,1),(922,7548245,7548243,'wri',14.286,1),(922,7548246,7548243,'rit',14.286,1),(922,7548247,7548243,'ite',14.286,1),(922,7548248,7548243,'tet',14.286,1),(922,7548249,7548243,'eth',14.286,1),(922,7548250,7548243,'thr',14.286,1),(922,7548251,7548243,'hru',14.286,1),(922,7548252,7548245,'ope',11.111,2),(922,7548253,7548245,'per',11.111,2),(922,7548254,7548245,'era',11.111,2),(922,7548255,7548245,'rat',11.111,2),(922,7548256,7548245,'ati',11.111,2),(922,7548257,7548245,'tio',11.111,2),(922,7548258,7548245,'ion',11.111,2),(922,7548259,7548245,'ona',11.111,2),(922,7548260,7548245,'nal',11.111,2),(922,7548261,7548252,'mes',20,1),(922,7548262,7548252,'ess',20,1),(922,7548263,7548252,'ssa',20,1),(922,7548264,7548252,'sag',20,1),(922,7548265,7548252,'age',20,1),(922,7548266,7548261,'per',11.111,1),(922,7548267,7548261,'erf',11.111,1),(922,7548268,7548261,'rfo',11.111,1),(922,7548269,7548261,'for',11.111,1),(922,7548270,7548261,'orm',11.111,1),(922,7548271,7548261,'rma',11.111,1),(922,7548272,7548261,'man',11.111,1),(922,7548273,7548261,'anc',11.111,1),(922,7548274,7548261,'nce',11.111,1),(922,7548275,7548266,'ide',12.5,1),(922,7548276,7548266,'den',12.5,1),(922,7548277,7548266,'ent',12.5,1),(922,7548278,7548266,'nti',12.5,1),(922,7548279,7548266,'tif',12.5,1),(922,7548280,7548266,'ifi',12.5,1),(922,7548281,7548266,'fie',12.5,1),(922,7548282,7548266,'ier',12.5,1),(922,7548283,7548275,'vdi',33.333,3),(922,7548284,7548275,'dis',33.333,3),(922,7548285,7548275,'isk',33.333,3),(922,7548286,7548283,'nam',50,1),(922,7548287,7548283,'ame',50,1),(922,7548288,7548286,'typ',50,1),(922,7548289,7548286,'ype',50,1),(922,7548290,7548288,'dir',25,1),(922,7548291,7548288,'ire',25,1),(922,7548292,7548288,'rec',25,1),(922,7548293,7548288,'ect',25,1),(923,7548295,7548294,'naa',100,2),(923,7548296,7548295,'600',3.333,3),(923,7548297,7548295,'000',3.333,3),(923,7548298,7548295,'00c',3.333,3),(923,7548299,7548295,'0c2',3.333,3),(923,7548300,7548295,'c29',3.333,3),(923,7548301,7548295,'29c',3.333,3),(923,7548302,7548295,'9cb',3.333,3),(923,7548303,7548295,'cba',3.333,3),(923,7548304,7548295,'ba7',3.333,3),(923,7548305,7548295,'a7d',3.333,3),(923,7548306,7548295,'7d9',3.333,3),(923,7548307,7548295,'d97',3.333,3),(923,7548308,7548295,'97b',3.333,3),(923,7548309,7548295,'7b8',3.333,3),(923,7548310,7548295,'b87',3.333,3),(923,7548311,7548295,'877',3.333,3),(923,7548312,7548295,'77a',3.333,3),(923,7548313,7548295,'7aa',3.333,3),(923,7548314,7548295,'aa1',3.333,3),(923,7548315,7548295,'a1f',3.333,3),(923,7548316,7548295,'1f4',3.333,3),(923,7548317,7548295,'f49',3.333,3),(923,7548318,7548295,'49c',3.333,3),(923,7548319,7548295,'9c4',3.333,3),(923,7548320,7548295,'c49',3.333,3),(923,7548321,7548295,'49c',3.333,3),(923,7548322,7548295,'9c5',3.333,3),(923,7548323,7548295,'c5f',3.333,3),(923,7548324,7548295,'5f3',3.333,3),(923,7548325,7548295,'f3d',3.333,3),(923,7548326,7548296,'mon',100,1),(923,7548327,7548326,'201',50,1),(923,7548328,7548326,'013',50,1),(923,7548329,7548327,'adm',33.333,4),(923,7548330,7548327,'dmi',33.333,4),(923,7548331,7548327,'min',33.333,4),(923,7548332,7548329,'cap',16.667,1),(923,7548333,7548329,'apa',16.667,1),(923,7548334,7548329,'pac',16.667,1),(923,7548335,7548329,'aci',16.667,1),(923,7548336,7548329,'cit',16.667,1),(923,7548337,7548329,'ity',16.667,1),(923,7548338,7548332,'pat',50,1),(923,7548339,7548332,'ath',50,1),(923,7548340,7548338,'fre',14.286,1),(923,7548341,7548338,'ree',14.286,1),(923,7548342,7548338,'ees',14.286,1),(923,7548343,7548338,'esp',14.286,1),(923,7548344,7548338,'spa',14.286,1),(923,7548345,7548338,'pac',14.286,1),(923,7548346,7548338,'ace',14.286,1),(923,7548347,7548340,'dis',50,1),(923,7548348,7548340,'isk',50,1),(923,7548349,7548347,'ind',33.333,1),(923,7548350,7548347,'nde',33.333,1),(923,7548351,7548347,'dex',33.333,1),(923,7548352,7548349,'adm',8.333,1),(923,7548353,7548349,'dmi',8.333,1),(923,7548354,7548349,'min',8.333,1),(923,7548355,7548349,'ini',8.333,1),(923,7548356,7548349,'nis',8.333,1),(923,7548357,7548349,'ist',8.333,1),(923,7548358,7548349,'str',8.333,1),(923,7548359,7548349,'tra',8.333,1),(923,7548360,7548349,'rat',8.333,1),(923,7548361,7548349,'ati',8.333,1),(923,7548362,7548349,'tio',8.333,1),(923,7548363,7548349,'ion',8.333,1),(923,7548364,7548352,'sta',33.333,3),(923,7548365,7548352,'tat',33.333,3),(923,7548366,7548352,'ate',33.333,3),(923,7548367,7548364,'dis',16.667,4),(923,7548368,7548364,'isa',16.667,4),(923,7548369,7548364,'sab',16.667,4),(923,7548370,7548364,'abl',16.667,4),(923,7548371,7548364,'ble',16.667,4),(923,7548372,7548364,'led',16.667,4),(923,7548373,7548367,'cac',33.333,1),(923,7548374,7548367,'ach',33.333,1),(923,7548375,7548367,'che',33.333,1),(923,7548376,7548373,'mod',50,1),(923,7548377,7548373,'ode',50,1),(923,7548378,7548376,'wri',14.286,1),(923,7548379,7548376,'rit',14.286,1),(923,7548380,7548376,'ite',14.286,1),(923,7548381,7548376,'tet',14.286,1),(923,7548382,7548376,'eth',14.286,1),(923,7548383,7548376,'thr',14.286,1),(923,7548384,7548376,'hru',14.286,1),(923,7548385,7548378,'ope',11.111,2),(923,7548386,7548378,'per',11.111,2),(923,7548387,7548378,'era',11.111,2),(923,7548388,7548378,'rat',11.111,2),(923,7548389,7548378,'ati',11.111,2),(923,7548390,7548378,'tio',11.111,2),(923,7548391,7548378,'ion',11.111,2),(923,7548392,7548378,'ona',11.111,2),(923,7548393,7548378,'nal',11.111,2),(923,7548394,7548385,'mes',20,1),(923,7548395,7548385,'ess',20,1),(923,7548396,7548385,'ssa',20,1),(923,7548397,7548385,'sag',20,1),(923,7548398,7548385,'age',20,1),(923,7548399,7548394,'per',11.111,1),(923,7548400,7548394,'erf',11.111,1),(923,7548401,7548394,'rfo',11.111,1),(923,7548402,7548394,'for',11.111,1),(923,7548403,7548394,'orm',11.111,1),(923,7548404,7548394,'rma',11.111,1),(923,7548405,7548394,'man',11.111,1),(923,7548406,7548394,'anc',11.111,1),(923,7548407,7548394,'nce',11.111,1),(923,7548408,7548399,'ide',12.5,1),(923,7548409,7548399,'den',12.5,1),(923,7548410,7548399,'ent',12.5,1),(923,7548411,7548399,'nti',12.5,1),(923,7548412,7548399,'tif',12.5,1),(923,7548413,7548399,'ifi',12.5,1),(923,7548414,7548399,'fie',12.5,1),(923,7548415,7548399,'ier',12.5,1),(923,7548416,7548408,'vdi',33.333,3),(923,7548417,7548408,'dis',33.333,3),(923,7548418,7548408,'isk',33.333,3),(923,7548419,7548416,'nam',50,1),(923,7548420,7548416,'ame',50,1),(923,7548421,7548419,'typ',50,1),(923,7548422,7548419,'ype',50,1),(923,7548423,7548421,'dir',25,1),(923,7548424,7548421,'ire',25,1),(923,7548425,7548421,'rec',25,1),(923,7548426,7548421,'ect',25,1),(924,7548428,7548427,'naa',100,2),(924,7548429,7548428,'600',3.333,3),(924,7548430,7548428,'000',3.333,3),(924,7548431,7548428,'00c',3.333,3),(924,7548432,7548428,'0c2',3.333,3),(924,7548433,7548428,'c29',3.333,3),(924,7548434,7548428,'297',3.333,3),(924,7548435,7548428,'975',3.333,3),(924,7548436,7548428,'75f',3.333,3),(924,7548437,7548428,'5f3',3.333,3),(924,7548438,7548428,'f31',3.333,3),(924,7548439,7548428,'315',3.333,3),(924,7548440,7548428,'156',3.333,3),(924,7548441,7548428,'564',3.333,3),(924,7548442,7548428,'647',3.333,3),(924,7548443,7548428,'471',3.333,3),(924,7548444,7548428,'717',3.333,3),(924,7548445,7548428,'17f',3.333,3),(924,7548446,7548428,'7f5',3.333,3),(924,7548447,7548428,'f58',3.333,3),(924,7548448,7548428,'585',3.333,3),(924,7548449,7548428,'857',3.333,3),(924,7548450,7548428,'570',3.333,3),(924,7548451,7548428,'702',3.333,3),(924,7548452,7548428,'027',3.333,3),(924,7548453,7548428,'275',3.333,3),(924,7548454,7548428,'758',3.333,3),(924,7548455,7548428,'586',3.333,3),(924,7548456,7548428,'86c',3.333,3),(924,7548457,7548428,'6cc',3.333,3),(924,7548458,7548428,'cc1',3.333,3),(924,7548459,7548429,'mon',100,1),(924,7548460,7548459,'201',50,1),(924,7548461,7548459,'013',50,1),(924,7548462,7548460,'adm',33.333,4),(924,7548463,7548460,'dmi',33.333,4),(924,7548464,7548460,'min',33.333,4),(924,7548465,7548462,'cap',16.667,1),(924,7548466,7548462,'apa',16.667,1),(924,7548467,7548462,'pac',16.667,1),(924,7548468,7548462,'aci',16.667,1),(924,7548469,7548462,'cit',16.667,1),(924,7548470,7548462,'ity',16.667,1),(924,7548471,7548465,'pat',50,1),(924,7548472,7548465,'ath',50,1),(924,7548473,7548471,'fre',14.286,1),(924,7548474,7548471,'ree',14.286,1),(924,7548475,7548471,'ees',14.286,1),(924,7548476,7548471,'esp',14.286,1),(924,7548477,7548471,'spa',14.286,1),(924,7548478,7548471,'pac',14.286,1),(924,7548479,7548471,'ace',14.286,1),(924,7548480,7548473,'dis',50,1),(924,7548481,7548473,'isk',50,1),(924,7548482,7548480,'ind',33.333,1),(924,7548483,7548480,'nde',33.333,1),(924,7548484,7548480,'dex',33.333,1),(924,7548485,7548482,'adm',8.333,1),(924,7548486,7548482,'dmi',8.333,1),(924,7548487,7548482,'min',8.333,1),(924,7548488,7548482,'ini',8.333,1),(924,7548489,7548482,'nis',8.333,1),(924,7548490,7548482,'ist',8.333,1),(924,7548491,7548482,'str',8.333,1),(924,7548492,7548482,'tra',8.333,1),(924,7548493,7548482,'rat',8.333,1),(924,7548494,7548482,'ati',8.333,1),(924,7548495,7548482,'tio',8.333,1),(924,7548496,7548482,'ion',8.333,1),(924,7548497,7548485,'sta',33.333,3),(924,7548498,7548485,'tat',33.333,3),(924,7548499,7548485,'ate',33.333,3),(924,7548500,7548497,'dis',16.667,4),(924,7548501,7548497,'isa',16.667,4),(924,7548502,7548497,'sab',16.667,4),(924,7548503,7548497,'abl',16.667,4),(924,7548504,7548497,'ble',16.667,4),(924,7548505,7548497,'led',16.667,4),(924,7548506,7548500,'cac',33.333,1),(924,7548507,7548500,'ach',33.333,1),(924,7548508,7548500,'che',33.333,1),(924,7548509,7548506,'mod',50,1),(924,7548510,7548506,'ode',50,1),(924,7548511,7548509,'wri',14.286,1),(924,7548512,7548509,'rit',14.286,1),(924,7548513,7548509,'ite',14.286,1),(924,7548514,7548509,'tet',14.286,1),(924,7548515,7548509,'eth',14.286,1),(924,7548516,7548509,'thr',14.286,1),(924,7548517,7548509,'hru',14.286,1),(924,7548518,7548511,'ope',11.111,2),(924,7548519,7548511,'per',11.111,2),(924,7548520,7548511,'era',11.111,2),(924,7548521,7548511,'rat',11.111,2),(924,7548522,7548511,'ati',11.111,2),(924,7548523,7548511,'tio',11.111,2),(924,7548524,7548511,'ion',11.111,2),(924,7548525,7548511,'ona',11.111,2),(924,7548526,7548511,'nal',11.111,2),(924,7548527,7548518,'mes',20,1),(924,7548528,7548518,'ess',20,1),(924,7548529,7548518,'ssa',20,1),(924,7548530,7548518,'sag',20,1),(924,7548531,7548518,'age',20,1),(924,7548532,7548527,'per',11.111,1),(924,7548533,7548527,'erf',11.111,1),(924,7548534,7548527,'rfo',11.111,1),(924,7548535,7548527,'for',11.111,1),(924,7548536,7548527,'orm',11.111,1),(924,7548537,7548527,'rma',11.111,1),(924,7548538,7548527,'man',11.111,1),(924,7548539,7548527,'anc',11.111,1),(924,7548540,7548527,'nce',11.111,1),(924,7548541,7548532,'ide',12.5,1),(924,7548542,7548532,'den',12.5,1),(924,7548543,7548532,'ent',12.5,1),(924,7548544,7548532,'nti',12.5,1),(924,7548545,7548532,'tif',12.5,1),(924,7548546,7548532,'ifi',12.5,1),(924,7548547,7548532,'fie',12.5,1),(924,7548548,7548532,'ier',12.5,1),(924,7548549,7548541,'vdi',33.333,3),(924,7548550,7548541,'dis',33.333,3),(924,7548551,7548541,'isk',33.333,3),(924,7548552,7548549,'nam',50,1),(924,7548553,7548549,'ame',50,1),(924,7548554,7548552,'typ',50,1),(924,7548555,7548552,'ype',50,1),(924,7548556,7548554,'dir',25,1),(924,7548557,7548554,'ire',25,1),(924,7548558,7548554,'rec',25,1),(924,7548559,7548554,'ect',25,1),(925,7548561,7548560,'naa',100,2),(925,7548562,7548561,'600',3.333,3),(925,7548563,7548561,'000',3.333,3),(925,7548564,7548561,'00c',3.333,3),(925,7548565,7548561,'0c2',3.333,3),(925,7548566,7548561,'c29',3.333,3),(925,7548567,7548561,'298',3.333,3),(925,7548568,7548561,'987',3.333,3),(925,7548569,7548561,'87b',3.333,3),(925,7548570,7548561,'7bf',3.333,3),(925,7548571,7548561,'bf4',3.333,3),(925,7548572,7548561,'f4e',3.333,3),(925,7548573,7548561,'4e8',3.333,3),(925,7548574,7548561,'e8d',3.333,3),(925,7548575,7548561,'8d2',3.333,3),(925,7548576,7548561,'d23',3.333,3),(925,7548577,7548561,'238',3.333,3),(925,7548578,7548561,'383',3.333,3),(925,7548579,7548561,'83d',3.333,3),(925,7548580,7548561,'3da',3.333,3),(925,7548581,7548561,'dac',3.333,3),(925,7548582,7548561,'ace',3.333,3),(925,7548583,7548561,'cee',3.333,3),(925,7548584,7548561,'eec',3.333,3),(925,7548585,7548561,'ecc',3.333,3),(925,7548586,7548561,'cc5',3.333,3),(925,7548587,7548561,'c5f',3.333,3),(925,7548588,7548561,'5f6',3.333,3),(925,7548589,7548561,'f65',3.333,3),(925,7548590,7548561,'65d',3.333,3),(925,7548591,7548561,'5d9',3.333,3),(925,7548592,7548562,'mon',100,1),(925,7548593,7548592,'201',50,1),(925,7548594,7548592,'013',50,1),(925,7548595,7548593,'adm',33.333,4),(925,7548596,7548593,'dmi',33.333,4),(925,7548597,7548593,'min',33.333,4),(925,7548598,7548595,'cap',16.667,1),(925,7548599,7548595,'apa',16.667,1),(925,7548600,7548595,'pac',16.667,1),(925,7548601,7548595,'aci',16.667,1),(925,7548602,7548595,'cit',16.667,1),(925,7548603,7548595,'ity',16.667,1),(925,7548604,7548598,'pat',50,1),(925,7548605,7548598,'ath',50,1),(925,7548606,7548604,'fre',14.286,1),(925,7548607,7548604,'ree',14.286,1),(925,7548608,7548604,'ees',14.286,1),(925,7548609,7548604,'esp',14.286,1),(925,7548610,7548604,'spa',14.286,1),(925,7548611,7548604,'pac',14.286,1),(925,7548612,7548604,'ace',14.286,1),(925,7548613,7548606,'dis',50,1),(925,7548614,7548606,'isk',50,1),(925,7548615,7548613,'ind',33.333,1),(925,7548616,7548613,'nde',33.333,1),(925,7548617,7548613,'dex',33.333,1),(925,7548618,7548615,'adm',8.333,1),(925,7548619,7548615,'dmi',8.333,1),(925,7548620,7548615,'min',8.333,1),(925,7548621,7548615,'ini',8.333,1),(925,7548622,7548615,'nis',8.333,1),(925,7548623,7548615,'ist',8.333,1),(925,7548624,7548615,'str',8.333,1),(925,7548625,7548615,'tra',8.333,1),(925,7548626,7548615,'rat',8.333,1),(925,7548627,7548615,'ati',8.333,1),(925,7548628,7548615,'tio',8.333,1),(925,7548629,7548615,'ion',8.333,1),(925,7548630,7548618,'sta',33.333,3),(925,7548631,7548618,'tat',33.333,3),(925,7548632,7548618,'ate',33.333,3),(925,7548633,7548630,'dis',16.667,4),(925,7548634,7548630,'isa',16.667,4),(925,7548635,7548630,'sab',16.667,4),(925,7548636,7548630,'abl',16.667,4),(925,7548637,7548630,'ble',16.667,4),(925,7548638,7548630,'led',16.667,4),(925,7548639,7548633,'cac',33.333,1),(925,7548640,7548633,'ach',33.333,1),(925,7548641,7548633,'che',33.333,1),(925,7548642,7548639,'mod',50,1),(925,7548643,7548639,'ode',50,1),(925,7548644,7548642,'wri',14.286,1),(925,7548645,7548642,'rit',14.286,1),(925,7548646,7548642,'ite',14.286,1),(925,7548647,7548642,'tet',14.286,1),(925,7548648,7548642,'eth',14.286,1),(925,7548649,7548642,'thr',14.286,1),(925,7548650,7548642,'hru',14.286,1),(925,7548651,7548644,'ope',11.111,2),(925,7548652,7548644,'per',11.111,2),(925,7548653,7548644,'era',11.111,2),(925,7548654,7548644,'rat',11.111,2),(925,7548655,7548644,'ati',11.111,2),(925,7548656,7548644,'tio',11.111,2),(925,7548657,7548644,'ion',11.111,2),(925,7548658,7548644,'ona',11.111,2),(925,7548659,7548644,'nal',11.111,2),(925,7548660,7548651,'mes',20,1),(925,7548661,7548651,'ess',20,1),(925,7548662,7548651,'ssa',20,1),(925,7548663,7548651,'sag',20,1),(925,7548664,7548651,'age',20,1),(925,7548665,7548660,'per',11.111,1),(925,7548666,7548660,'erf',11.111,1),(925,7548667,7548660,'rfo',11.111,1),(925,7548668,7548660,'for',11.111,1),(925,7548669,7548660,'orm',11.111,1),(925,7548670,7548660,'rma',11.111,1),(925,7548671,7548660,'man',11.111,1),(925,7548672,7548660,'anc',11.111,1),(925,7548673,7548660,'nce',11.111,1),(925,7548674,7548665,'ide',12.5,1),(925,7548675,7548665,'den',12.5,1),(925,7548676,7548665,'ent',12.5,1),(925,7548677,7548665,'nti',12.5,1),(925,7548678,7548665,'tif',12.5,1),(925,7548679,7548665,'ifi',12.5,1),(925,7548680,7548665,'fie',12.5,1),(925,7548681,7548665,'ier',12.5,1),(925,7548682,7548674,'vdi',33.333,3),(925,7548683,7548674,'dis',33.333,3),(925,7548684,7548674,'isk',33.333,3),(925,7548685,7548682,'nam',50,1),(925,7548686,7548682,'ame',50,1),(925,7548687,7548685,'typ',50,1),(925,7548688,7548685,'ype',50,1),(925,7548689,7548687,'dir',25,1),(925,7548690,7548687,'ire',25,1),(925,7548691,7548687,'rec',25,1),(925,7548692,7548687,'ect',25,1),(926,7548694,7548693,'naa',100,2),(926,7548695,7548694,'600',3.333,3),(926,7548696,7548694,'000',3.333,3),(926,7548697,7548694,'00c',3.333,3),(926,7548698,7548694,'0c2',3.333,3),(926,7548699,7548694,'c29',3.333,3),(926,7548700,7548694,'295',3.333,3),(926,7548701,7548694,'95f',3.333,3),(926,7548702,7548694,'5f1',3.333,3),(926,7548703,7548694,'f19',3.333,3),(926,7548704,7548694,'19d',3.333,3),(926,7548705,7548694,'9d5',3.333,3),(926,7548706,7548694,'d58',3.333,3),(926,7548707,7548694,'58d',3.333,3),(926,7548708,7548694,'8dc',3.333,3),(926,7548709,7548694,'dcb',3.333,3),(926,7548710,7548694,'cb2',3.333,3),(926,7548711,7548694,'b23',3.333,3),(926,7548712,7548694,'237',3.333,3),(926,7548713,7548694,'371',3.333,3),(926,7548714,7548694,'716',3.333,3),(926,7548715,7548694,'16e',3.333,3),(926,7548716,7548694,'6e9',3.333,3),(926,7548717,7548694,'e9c',3.333,3),(926,7548718,7548694,'9c2',3.333,3),(926,7548719,7548694,'c26',3.333,3),(926,7548720,7548694,'267',3.333,3),(926,7548721,7548694,'67d',3.333,3),(926,7548722,7548694,'7d3',3.333,3),(926,7548723,7548694,'d3e',3.333,3),(926,7548724,7548694,'3e0',3.333,3),(926,7548725,7548695,'mon',100,1),(926,7548726,7548725,'201',50,1),(926,7548727,7548725,'013',50,1),(926,7548728,7548726,'adm',33.333,4),(926,7548729,7548726,'dmi',33.333,4),(926,7548730,7548726,'min',33.333,4),(926,7548731,7548728,'cap',16.667,1),(926,7548732,7548728,'apa',16.667,1),(926,7548733,7548728,'pac',16.667,1),(926,7548734,7548728,'aci',16.667,1),(926,7548735,7548728,'cit',16.667,1),(926,7548736,7548728,'ity',16.667,1),(926,7548737,7548731,'pat',50,1),(926,7548738,7548731,'ath',50,1),(926,7548739,7548737,'fre',14.286,1),(926,7548740,7548737,'ree',14.286,1),(926,7548741,7548737,'ees',14.286,1),(926,7548742,7548737,'esp',14.286,1),(926,7548743,7548737,'spa',14.286,1),(926,7548744,7548737,'pac',14.286,1),(926,7548745,7548737,'ace',14.286,1),(926,7548746,7548739,'dis',50,1),(926,7548747,7548739,'isk',50,1),(926,7548748,7548746,'ind',33.333,1),(926,7548749,7548746,'nde',33.333,1),(926,7548750,7548746,'dex',33.333,1),(926,7548751,7548748,'adm',8.333,1),(926,7548752,7548748,'dmi',8.333,1),(926,7548753,7548748,'min',8.333,1),(926,7548754,7548748,'ini',8.333,1),(926,7548755,7548748,'nis',8.333,1),(926,7548756,7548748,'ist',8.333,1),(926,7548757,7548748,'str',8.333,1),(926,7548758,7548748,'tra',8.333,1),(926,7548759,7548748,'rat',8.333,1),(926,7548760,7548748,'ati',8.333,1),(926,7548761,7548748,'tio',8.333,1),(926,7548762,7548748,'ion',8.333,1),(926,7548763,7548751,'sta',33.333,3),(926,7548764,7548751,'tat',33.333,3),(926,7548765,7548751,'ate',33.333,3),(926,7548766,7548763,'dis',16.667,4),(926,7548767,7548763,'isa',16.667,4),(926,7548768,7548763,'sab',16.667,4),(926,7548769,7548763,'abl',16.667,4),(926,7548770,7548763,'ble',16.667,4),(926,7548771,7548763,'led',16.667,4),(926,7548772,7548766,'cac',33.333,1),(926,7548773,7548766,'ach',33.333,1),(926,7548774,7548766,'che',33.333,1),(926,7548775,7548772,'mod',50,1),(926,7548776,7548772,'ode',50,1),(926,7548777,7548775,'wri',14.286,1),(926,7548778,7548775,'rit',14.286,1),(926,7548779,7548775,'ite',14.286,1),(926,7548780,7548775,'tet',14.286,1),(926,7548781,7548775,'eth',14.286,1),(926,7548782,7548775,'thr',14.286,1),(926,7548783,7548775,'hru',14.286,1),(926,7548784,7548777,'ope',11.111,2),(926,7548785,7548777,'per',11.111,2),(926,7548786,7548777,'era',11.111,2),(926,7548787,7548777,'rat',11.111,2),(926,7548788,7548777,'ati',11.111,2),(926,7548789,7548777,'tio',11.111,2),(926,7548790,7548777,'ion',11.111,2),(926,7548791,7548777,'ona',11.111,2),(926,7548792,7548777,'nal',11.111,2),(926,7548793,7548784,'mes',20,1),(926,7548794,7548784,'ess',20,1),(926,7548795,7548784,'ssa',20,1),(926,7548796,7548784,'sag',20,1),(926,7548797,7548784,'age',20,1),(926,7548798,7548793,'per',11.111,1),(926,7548799,7548793,'erf',11.111,1),(926,7548800,7548793,'rfo',11.111,1),(926,7548801,7548793,'for',11.111,1),(926,7548802,7548793,'orm',11.111,1),(926,7548803,7548793,'rma',11.111,1),(926,7548804,7548793,'man',11.111,1),(926,7548805,7548793,'anc',11.111,1),(926,7548806,7548793,'nce',11.111,1),(926,7548807,7548798,'ide',12.5,1),(926,7548808,7548798,'den',12.5,1),(926,7548809,7548798,'ent',12.5,1),(926,7548810,7548798,'nti',12.5,1),(926,7548811,7548798,'tif',12.5,1),(926,7548812,7548798,'ifi',12.5,1),(926,7548813,7548798,'fie',12.5,1),(926,7548814,7548798,'ier',12.5,1),(926,7548815,7548807,'vdi',33.333,3),(926,7548816,7548807,'dis',33.333,3),(926,7548817,7548807,'isk',33.333,3),(926,7548818,7548815,'nam',50,1),(926,7548819,7548815,'ame',50,1),(926,7548820,7548818,'typ',50,1),(926,7548821,7548818,'ype',50,1),(926,7548822,7548820,'dir',25,1),(926,7548823,7548820,'ire',25,1),(926,7548824,7548820,'rec',25,1),(926,7548825,7548820,'ect',25,1),(927,7548827,7548826,'naa',100,2),(927,7548828,7548827,'600',3.333,3),(927,7548829,7548827,'000',3.333,3),(927,7548830,7548827,'00c',3.333,3),(927,7548831,7548827,'0c2',3.333,3),(927,7548832,7548827,'c29',3.333,3),(927,7548833,7548827,'29d',3.333,3),(927,7548834,7548827,'9df',3.333,3),(927,7548835,7548827,'dfd',3.333,3),(927,7548836,7548827,'fdb',3.333,3),(927,7548837,7548827,'dbf',3.333,3),(927,7548838,7548827,'bf2',3.333,3),(927,7548839,7548827,'f2e',3.333,3),(927,7548840,7548827,'2ee',3.333,3),(927,7548841,7548827,'eea',3.333,3),(927,7548842,7548827,'ea9',3.333,3),(927,7548843,7548827,'a9c',3.333,3),(927,7548844,7548827,'9ca',3.333,3),(927,7548845,7548827,'ca8',3.333,3),(927,7548846,7548827,'a82',3.333,3),(927,7548847,7548827,'82d',3.333,3),(927,7548848,7548827,'2d3',3.333,3),(927,7548849,7548827,'d33',3.333,3),(927,7548850,7548827,'337',3.333,3),(927,7548851,7548827,'375',3.333,3),(927,7548852,7548827,'750',3.333,3),(927,7548853,7548827,'50f',3.333,3),(927,7548854,7548827,'0f8',3.333,3),(927,7548855,7548827,'f86',3.333,3),(927,7548856,7548827,'867',3.333,3),(927,7548857,7548827,'671',3.333,3),(927,7548858,7548828,'mon',100,1),(927,7548859,7548858,'201',50,1),(927,7548860,7548858,'013',50,1),(927,7548861,7548859,'adm',33.333,4),(927,7548862,7548859,'dmi',33.333,4),(927,7548863,7548859,'min',33.333,4),(927,7548864,7548861,'cap',16.667,1),(927,7548865,7548861,'apa',16.667,1),(927,7548866,7548861,'pac',16.667,1),(927,7548867,7548861,'aci',16.667,1),(927,7548868,7548861,'cit',16.667,1),(927,7548869,7548861,'ity',16.667,1),(927,7548870,7548864,'pat',50,1),(927,7548871,7548864,'ath',50,1),(927,7548872,7548870,'fre',14.286,1),(927,7548873,7548870,'ree',14.286,1),(927,7548874,7548870,'ees',14.286,1),(927,7548875,7548870,'esp',14.286,1),(927,7548876,7548870,'spa',14.286,1),(927,7548877,7548870,'pac',14.286,1),(927,7548878,7548870,'ace',14.286,1),(927,7548879,7548872,'dis',50,1),(927,7548880,7548872,'isk',50,1),(927,7548881,7548879,'ind',33.333,1),(927,7548882,7548879,'nde',33.333,1),(927,7548883,7548879,'dex',33.333,1),(927,7548884,7548881,'adm',8.333,1),(927,7548885,7548881,'dmi',8.333,1),(927,7548886,7548881,'min',8.333,1),(927,7548887,7548881,'ini',8.333,1),(927,7548888,7548881,'nis',8.333,1),(927,7548889,7548881,'ist',8.333,1),(927,7548890,7548881,'str',8.333,1),(927,7548891,7548881,'tra',8.333,1),(927,7548892,7548881,'rat',8.333,1),(927,7548893,7548881,'ati',8.333,1),(927,7548894,7548881,'tio',8.333,1),(927,7548895,7548881,'ion',8.333,1),(927,7548896,7548884,'sta',33.333,3),(927,7548897,7548884,'tat',33.333,3),(927,7548898,7548884,'ate',33.333,3),(927,7548899,7548896,'dis',16.667,4),(927,7548900,7548896,'isa',16.667,4),(927,7548901,7548896,'sab',16.667,4),(927,7548902,7548896,'abl',16.667,4),(927,7548903,7548896,'ble',16.667,4),(927,7548904,7548896,'led',16.667,4),(927,7548905,7548899,'cac',33.333,1),(927,7548906,7548899,'ach',33.333,1),(927,7548907,7548899,'che',33.333,1),(927,7548908,7548905,'mod',50,1),(927,7548909,7548905,'ode',50,1),(927,7548910,7548908,'wri',14.286,1),(927,7548911,7548908,'rit',14.286,1),(927,7548912,7548908,'ite',14.286,1),(927,7548913,7548908,'tet',14.286,1),(927,7548914,7548908,'eth',14.286,1),(927,7548915,7548908,'thr',14.286,1),(927,7548916,7548908,'hru',14.286,1),(927,7548917,7548910,'ope',11.111,2),(927,7548918,7548910,'per',11.111,2),(927,7548919,7548910,'era',11.111,2),(927,7548920,7548910,'rat',11.111,2),(927,7548921,7548910,'ati',11.111,2),(927,7548922,7548910,'tio',11.111,2),(927,7548923,7548910,'ion',11.111,2),(927,7548924,7548910,'ona',11.111,2),(927,7548925,7548910,'nal',11.111,2),(927,7548926,7548917,'mes',20,1),(927,7548927,7548917,'ess',20,1),(927,7548928,7548917,'ssa',20,1),(927,7548929,7548917,'sag',20,1),(927,7548930,7548917,'age',20,1),(927,7548931,7548926,'per',11.111,1),(927,7548932,7548926,'erf',11.111,1),(927,7548933,7548926,'rfo',11.111,1),(927,7548934,7548926,'for',11.111,1),(927,7548935,7548926,'orm',11.111,1),(927,7548936,7548926,'rma',11.111,1),(927,7548937,7548926,'man',11.111,1),(927,7548938,7548926,'anc',11.111,1),(927,7548939,7548926,'nce',11.111,1),(927,7548940,7548931,'ide',12.5,1),(927,7548941,7548931,'den',12.5,1),(927,7548942,7548931,'ent',12.5,1),(927,7548943,7548931,'nti',12.5,1),(927,7548944,7548931,'tif',12.5,1),(927,7548945,7548931,'ifi',12.5,1),(927,7548946,7548931,'fie',12.5,1),(927,7548947,7548931,'ier',12.5,1),(927,7548948,7548940,'vdi',33.333,3),(927,7548949,7548940,'dis',33.333,3),(927,7548950,7548940,'isk',33.333,3),(927,7548951,7548948,'nam',50,1),(927,7548952,7548948,'ame',50,1),(927,7548953,7548951,'typ',50,1),(927,7548954,7548951,'ype',50,1),(927,7548955,7548953,'dir',25,1),(927,7548956,7548953,'ire',25,1),(927,7548957,7548953,'rec',25,1),(927,7548958,7548953,'ect',25,1),(928,7548960,7548959,'naa',100,2),(928,7548961,7548960,'600',3.333,3),(928,7548962,7548960,'000',3.333,3),(928,7548963,7548960,'00c',3.333,3),(928,7548964,7548960,'0c2',3.333,3),(928,7548965,7548960,'c29',3.333,3),(928,7548966,7548960,'29f',3.333,3),(928,7548967,7548960,'9f1',3.333,3),(928,7548968,7548960,'f11',3.333,3),(928,7548969,7548960,'11c',3.333,3),(928,7548970,7548960,'1cd',3.333,3),(928,7548971,7548960,'cdd',3.333,3),(928,7548972,7548960,'dda',3.333,3),(928,7548973,7548960,'da4',3.333,3),(928,7548974,7548960,'a49',3.333,3),(928,7548975,7548960,'490',3.333,3),(928,7548976,7548960,'905',3.333,3),(928,7548977,7548960,'053',3.333,3),(928,7548978,7548960,'536',3.333,3),(928,7548979,7548960,'36b',3.333,3),(928,7548980,7548960,'6bb',3.333,3),(928,7548981,7548960,'bb8',3.333,3),(928,7548982,7548960,'b87',3.333,3),(928,7548983,7548960,'874',3.333,3),(928,7548984,7548960,'742',3.333,3),(928,7548985,7548960,'42a',3.333,3),(928,7548986,7548960,'2a5',3.333,3),(928,7548987,7548960,'a53',3.333,3),(928,7548988,7548960,'532',3.333,3),(928,7548989,7548960,'323',3.333,3),(928,7548990,7548960,'23f',3.333,3),(928,7548991,7548961,'mon',100,1),(928,7548992,7548991,'201',50,1),(928,7548993,7548991,'013',50,1),(928,7548994,7548992,'adm',33.333,4),(928,7548995,7548992,'dmi',33.333,4),(928,7548996,7548992,'min',33.333,4),(928,7548997,7548994,'cap',16.667,1),(928,7548998,7548994,'apa',16.667,1),(928,7548999,7548994,'pac',16.667,1),(928,7549000,7548994,'aci',16.667,1),(928,7549001,7548994,'cit',16.667,1),(928,7549002,7548994,'ity',16.667,1),(928,7549003,7548997,'pat',50,1),(928,7549004,7548997,'ath',50,1),(928,7549005,7549003,'fre',14.286,1),(928,7549006,7549003,'ree',14.286,1),(928,7549007,7549003,'ees',14.286,1),(928,7549008,7549003,'esp',14.286,1),(928,7549009,7549003,'spa',14.286,1),(928,7549010,7549003,'pac',14.286,1),(928,7549011,7549003,'ace',14.286,1),(928,7549012,7549005,'dis',50,1),(928,7549013,7549005,'isk',50,1),(928,7549014,7549012,'ind',33.333,1),(928,7549015,7549012,'nde',33.333,1),(928,7549016,7549012,'dex',33.333,1),(928,7549017,7549014,'adm',8.333,1),(928,7549018,7549014,'dmi',8.333,1),(928,7549019,7549014,'min',8.333,1),(928,7549020,7549014,'ini',8.333,1),(928,7549021,7549014,'nis',8.333,1),(928,7549022,7549014,'ist',8.333,1),(928,7549023,7549014,'str',8.333,1),(928,7549024,7549014,'tra',8.333,1),(928,7549025,7549014,'rat',8.333,1),(928,7549026,7549014,'ati',8.333,1),(928,7549027,7549014,'tio',8.333,1),(928,7549028,7549014,'ion',8.333,1),(928,7549029,7549017,'sta',33.333,3),(928,7549030,7549017,'tat',33.333,3),(928,7549031,7549017,'ate',33.333,3),(928,7549032,7549029,'dis',16.667,4),(928,7549033,7549029,'isa',16.667,4),(928,7549034,7549029,'sab',16.667,4),(928,7549035,7549029,'abl',16.667,4),(928,7549036,7549029,'ble',16.667,4),(928,7549037,7549029,'led',16.667,4),(928,7549038,7549032,'cac',33.333,1),(928,7549039,7549032,'ach',33.333,1),(928,7549040,7549032,'che',33.333,1),(928,7549041,7549038,'mod',50,1),(928,7549042,7549038,'ode',50,1),(928,7549043,7549041,'wri',14.286,1),(928,7549044,7549041,'rit',14.286,1),(928,7549045,7549041,'ite',14.286,1),(928,7549046,7549041,'tet',14.286,1),(928,7549047,7549041,'eth',14.286,1),(928,7549048,7549041,'thr',14.286,1),(928,7549049,7549041,'hru',14.286,1),(928,7549050,7549043,'ope',11.111,2),(928,7549051,7549043,'per',11.111,2),(928,7549052,7549043,'era',11.111,2),(928,7549053,7549043,'rat',11.111,2),(928,7549054,7549043,'ati',11.111,2),(928,7549055,7549043,'tio',11.111,2),(928,7549056,7549043,'ion',11.111,2),(928,7549057,7549043,'ona',11.111,2),(928,7549058,7549043,'nal',11.111,2),(928,7549059,7549050,'mes',20,1),(928,7549060,7549050,'ess',20,1),(928,7549061,7549050,'ssa',20,1),(928,7549062,7549050,'sag',20,1),(928,7549063,7549050,'age',20,1),(928,7549064,7549059,'per',11.111,1),(928,7549065,7549059,'erf',11.111,1),(928,7549066,7549059,'rfo',11.111,1),(928,7549067,7549059,'for',11.111,1),(928,7549068,7549059,'orm',11.111,1),(928,7549069,7549059,'rma',11.111,1),(928,7549070,7549059,'man',11.111,1),(928,7549071,7549059,'anc',11.111,1),(928,7549072,7549059,'nce',11.111,1),(928,7549073,7549064,'ide',12.5,1),(928,7549074,7549064,'den',12.5,1),(928,7549075,7549064,'ent',12.5,1),(928,7549076,7549064,'nti',12.5,1),(928,7549077,7549064,'tif',12.5,1),(928,7549078,7549064,'ifi',12.5,1),(928,7549079,7549064,'fie',12.5,1),(928,7549080,7549064,'ier',12.5,1),(928,7549081,7549073,'vdi',33.333,3),(928,7549082,7549073,'dis',33.333,3),(928,7549083,7549073,'isk',33.333,3),(928,7549084,7549081,'nam',50,1),(928,7549085,7549081,'ame',50,1),(928,7549086,7549084,'typ',50,1),(928,7549087,7549084,'ype',50,1),(928,7549088,7549086,'dir',25,1),(928,7549089,7549086,'ire',25,1),(928,7549090,7549086,'rec',25,1),(928,7549091,7549086,'ect',25,1),(929,7549093,7549092,'naa',100,2),(929,7549094,7549093,'600',3.333,3),(929,7549095,7549093,'000',3.333,3),(929,7549096,7549093,'00c',3.333,3),(929,7549097,7549093,'0c2',3.333,3),(929,7549098,7549093,'c29',3.333,3),(929,7549099,7549093,'294',3.333,3),(929,7549100,7549093,'948',3.333,3),(929,7549101,7549093,'48a',3.333,3),(929,7549102,7549093,'8a3',3.333,3),(929,7549103,7549093,'a3a',3.333,3),(929,7549104,7549093,'3aa',3.333,3),(929,7549105,7549093,'aaf',3.333,3),(929,7549106,7549093,'afa',3.333,3),(929,7549107,7549093,'fa7',3.333,3),(929,7549108,7549093,'a72',3.333,3),(929,7549109,7549093,'726',3.333,3),(929,7549110,7549093,'26f',3.333,3),(929,7549111,7549093,'6f2',3.333,3),(929,7549112,7549093,'f28',3.333,3),(929,7549113,7549093,'28d',3.333,3),(929,7549114,7549093,'8d0',3.333,3),(929,7549115,7549093,'d08',3.333,3),(929,7549116,7549093,'084',3.333,3),(929,7549117,7549093,'84e',3.333,3),(929,7549118,7549093,'4ec',3.333,3),(929,7549119,7549093,'ec0',3.333,3),(929,7549120,7549093,'c04',3.333,3),(929,7549121,7549093,'04e',3.333,3),(929,7549122,7549093,'4e3',3.333,3),(929,7549123,7549093,'e36',3.333,3),(929,7549124,7549094,'mon',100,1),(929,7549125,7549124,'201',50,1),(929,7549126,7549124,'013',50,1),(929,7549127,7549125,'adm',33.333,4),(929,7549128,7549125,'dmi',33.333,4),(929,7549129,7549125,'min',33.333,4),(929,7549130,7549127,'cap',16.667,1),(929,7549131,7549127,'apa',16.667,1),(929,7549132,7549127,'pac',16.667,1),(929,7549133,7549127,'aci',16.667,1),(929,7549134,7549127,'cit',16.667,1),(929,7549135,7549127,'ity',16.667,1),(929,7549136,7549130,'pat',50,1),(929,7549137,7549130,'ath',50,1),(929,7549138,7549136,'fre',14.286,1),(929,7549139,7549136,'ree',14.286,1),(929,7549140,7549136,'ees',14.286,1),(929,7549141,7549136,'esp',14.286,1),(929,7549142,7549136,'spa',14.286,1),(929,7549143,7549136,'pac',14.286,1),(929,7549144,7549136,'ace',14.286,1),(929,7549145,7549138,'dis',50,1),(929,7549146,7549138,'isk',50,1),(929,7549147,7549145,'ind',33.333,1),(929,7549148,7549145,'nde',33.333,1),(929,7549149,7549145,'dex',33.333,1),(929,7549150,7549147,'adm',8.333,1),(929,7549151,7549147,'dmi',8.333,1),(929,7549152,7549147,'min',8.333,1),(929,7549153,7549147,'ini',8.333,1),(929,7549154,7549147,'nis',8.333,1),(929,7549155,7549147,'ist',8.333,1),(929,7549156,7549147,'str',8.333,1),(929,7549157,7549147,'tra',8.333,1),(929,7549158,7549147,'rat',8.333,1),(929,7549159,7549147,'ati',8.333,1),(929,7549160,7549147,'tio',8.333,1),(929,7549161,7549147,'ion',8.333,1),(929,7549162,7549150,'sta',33.333,3),(929,7549163,7549150,'tat',33.333,3),(929,7549164,7549150,'ate',33.333,3),(929,7549165,7549162,'dis',16.667,4),(929,7549166,7549162,'isa',16.667,4),(929,7549167,7549162,'sab',16.667,4),(929,7549168,7549162,'abl',16.667,4),(929,7549169,7549162,'ble',16.667,4),(929,7549170,7549162,'led',16.667,4),(929,7549171,7549165,'cac',33.333,1),(929,7549172,7549165,'ach',33.333,1),(929,7549173,7549165,'che',33.333,1),(929,7549174,7549171,'mod',50,1),(929,7549175,7549171,'ode',50,1),(929,7549176,7549174,'wri',14.286,1),(929,7549177,7549174,'rit',14.286,1),(929,7549178,7549174,'ite',14.286,1),(929,7549179,7549174,'tet',14.286,1),(929,7549180,7549174,'eth',14.286,1),(929,7549181,7549174,'thr',14.286,1),(929,7549182,7549174,'hru',14.286,1),(929,7549183,7549176,'ope',11.111,2),(929,7549184,7549176,'per',11.111,2),(929,7549185,7549176,'era',11.111,2),(929,7549186,7549176,'rat',11.111,2),(929,7549187,7549176,'ati',11.111,2),(929,7549188,7549176,'tio',11.111,2),(929,7549189,7549176,'ion',11.111,2),(929,7549190,7549176,'ona',11.111,2),(929,7549191,7549176,'nal',11.111,2),(929,7549192,7549183,'mes',20,1),(929,7549193,7549183,'ess',20,1),(929,7549194,7549183,'ssa',20,1),(929,7549195,7549183,'sag',20,1),(929,7549196,7549183,'age',20,1),(929,7549197,7549192,'per',11.111,1),(929,7549198,7549192,'erf',11.111,1),(929,7549199,7549192,'rfo',11.111,1),(929,7549200,7549192,'for',11.111,1),(929,7549201,7549192,'orm',11.111,1),(929,7549202,7549192,'rma',11.111,1),(929,7549203,7549192,'man',11.111,1),(929,7549204,7549192,'anc',11.111,1),(929,7549205,7549192,'nce',11.111,1),(929,7549206,7549197,'ide',12.5,1),(929,7549207,7549197,'den',12.5,1),(929,7549208,7549197,'ent',12.5,1),(929,7549209,7549197,'nti',12.5,1),(929,7549210,7549197,'tif',12.5,1),(929,7549211,7549197,'ifi',12.5,1),(929,7549212,7549197,'fie',12.5,1),(929,7549213,7549197,'ier',12.5,1),(929,7549214,7549206,'vdi',33.333,3),(929,7549215,7549206,'dis',33.333,3),(929,7549216,7549206,'isk',33.333,3),(929,7549217,7549214,'nam',50,1),(929,7549218,7549214,'ame',50,1),(929,7549219,7549217,'typ',50,1),(929,7549220,7549217,'ype',50,1),(929,7549221,7549219,'dir',25,1),(929,7549222,7549219,'ire',25,1),(929,7549223,7549219,'rec',25,1),(929,7549224,7549219,'ect',25,1),(930,7549226,7549225,'naa',100,2),(930,7549227,7549226,'600',3.333,3),(930,7549228,7549226,'000',3.333,3),(930,7549229,7549226,'00c',3.333,3),(930,7549230,7549226,'0c2',3.333,3),(930,7549231,7549226,'c29',3.333,3),(930,7549232,7549226,'296',3.333,3),(930,7549233,7549226,'966',3.333,3),(930,7549234,7549226,'661',3.333,3),(930,7549235,7549226,'614',3.333,3),(930,7549236,7549226,'148',3.333,3),(930,7549237,7549226,'482',3.333,3),(930,7549238,7549226,'827',3.333,3),(930,7549239,7549226,'279',3.333,3),(930,7549240,7549226,'792',3.333,3),(930,7549241,7549226,'925',3.333,3),(930,7549242,7549226,'25f',3.333,3),(930,7549243,7549226,'5fc',3.333,3),(930,7549244,7549226,'fc5',3.333,3),(930,7549245,7549226,'c5d',3.333,3),(930,7549246,7549226,'5d2',3.333,3),(930,7549247,7549226,'d22',3.333,3),(930,7549248,7549226,'228',3.333,3),(930,7549249,7549226,'285',3.333,3),(930,7549250,7549226,'850',3.333,3),(930,7549251,7549226,'509',3.333,3),(930,7549252,7549226,'091',3.333,3),(930,7549253,7549226,'912',3.333,3),(930,7549254,7549226,'129',3.333,3),(930,7549255,7549226,'299',3.333,3),(930,7549256,7549226,'99a',3.333,3),(930,7549257,7549227,'mon',100,1),(930,7549258,7549257,'201',50,1),(930,7549259,7549257,'013',50,1),(930,7549260,7549258,'adm',33.333,4),(930,7549261,7549258,'dmi',33.333,4),(930,7549262,7549258,'min',33.333,4),(930,7549263,7549260,'cap',16.667,1),(930,7549264,7549260,'apa',16.667,1),(930,7549265,7549260,'pac',16.667,1),(930,7549266,7549260,'aci',16.667,1),(930,7549267,7549260,'cit',16.667,1),(930,7549268,7549260,'ity',16.667,1),(930,7549269,7549263,'pat',50,1),(930,7549270,7549263,'ath',50,1),(930,7549271,7549269,'fre',14.286,1),(930,7549272,7549269,'ree',14.286,1),(930,7549273,7549269,'ees',14.286,1),(930,7549274,7549269,'esp',14.286,1),(930,7549275,7549269,'spa',14.286,1),(930,7549276,7549269,'pac',14.286,1),(930,7549277,7549269,'ace',14.286,1),(930,7549278,7549271,'dis',50,1),(930,7549279,7549271,'isk',50,1),(930,7549280,7549278,'ind',33.333,1),(930,7549281,7549278,'nde',33.333,1),(930,7549282,7549278,'dex',33.333,1);
INSERT INTO `fuzzysearch_default_fuzzysearch_index_search_api_viewed` VALUES (930,7549283,7549280,'adm',8.333,1),(930,7549284,7549280,'dmi',8.333,1),(930,7549285,7549280,'min',8.333,1),(930,7549286,7549280,'ini',8.333,1),(930,7549287,7549280,'nis',8.333,1),(930,7549288,7549280,'ist',8.333,1),(930,7549289,7549280,'str',8.333,1),(930,7549290,7549280,'tra',8.333,1),(930,7549291,7549280,'rat',8.333,1),(930,7549292,7549280,'ati',8.333,1),(930,7549293,7549280,'tio',8.333,1),(930,7549294,7549280,'ion',8.333,1),(930,7549295,7549283,'sta',33.333,3),(930,7549296,7549283,'tat',33.333,3),(930,7549297,7549283,'ate',33.333,3),(930,7549298,7549295,'dis',16.667,4),(930,7549299,7549295,'isa',16.667,4),(930,7549300,7549295,'sab',16.667,4),(930,7549301,7549295,'abl',16.667,4),(930,7549302,7549295,'ble',16.667,4),(930,7549303,7549295,'led',16.667,4),(930,7549304,7549298,'cac',33.333,1),(930,7549305,7549298,'ach',33.333,1),(930,7549306,7549298,'che',33.333,1),(930,7549307,7549304,'mod',50,1),(930,7549308,7549304,'ode',50,1),(930,7549309,7549307,'wri',14.286,1),(930,7549310,7549307,'rit',14.286,1),(930,7549311,7549307,'ite',14.286,1),(930,7549312,7549307,'tet',14.286,1),(930,7549313,7549307,'eth',14.286,1),(930,7549314,7549307,'thr',14.286,1),(930,7549315,7549307,'hru',14.286,1),(930,7549316,7549309,'ope',11.111,2),(930,7549317,7549309,'per',11.111,2),(930,7549318,7549309,'era',11.111,2),(930,7549319,7549309,'rat',11.111,2),(930,7549320,7549309,'ati',11.111,2),(930,7549321,7549309,'tio',11.111,2),(930,7549322,7549309,'ion',11.111,2),(930,7549323,7549309,'ona',11.111,2),(930,7549324,7549309,'nal',11.111,2),(930,7549325,7549316,'mes',20,1),(930,7549326,7549316,'ess',20,1),(930,7549327,7549316,'ssa',20,1),(930,7549328,7549316,'sag',20,1),(930,7549329,7549316,'age',20,1),(930,7549330,7549325,'per',11.111,1),(930,7549331,7549325,'erf',11.111,1),(930,7549332,7549325,'rfo',11.111,1),(930,7549333,7549325,'for',11.111,1),(930,7549334,7549325,'orm',11.111,1),(930,7549335,7549325,'rma',11.111,1),(930,7549336,7549325,'man',11.111,1),(930,7549337,7549325,'anc',11.111,1),(930,7549338,7549325,'nce',11.111,1),(930,7549339,7549330,'ide',12.5,1),(930,7549340,7549330,'den',12.5,1),(930,7549341,7549330,'ent',12.5,1),(930,7549342,7549330,'nti',12.5,1),(930,7549343,7549330,'tif',12.5,1),(930,7549344,7549330,'ifi',12.5,1),(930,7549345,7549330,'fie',12.5,1),(930,7549346,7549330,'ier',12.5,1),(930,7549347,7549339,'vdi',33.333,3),(930,7549348,7549339,'dis',33.333,3),(930,7549349,7549339,'isk',33.333,3),(930,7549350,7549347,'nam',50,1),(930,7549351,7549347,'ame',50,1),(930,7549352,7549350,'typ',50,1),(930,7549353,7549350,'ype',50,1),(930,7549354,7549352,'dir',25,1),(930,7549355,7549352,'ire',25,1),(930,7549356,7549352,'rec',25,1),(930,7549357,7549352,'ect',25,1),(931,7549359,7549358,'naa',100,2),(931,7549360,7549359,'600',3.333,3),(931,7549361,7549359,'000',3.333,3),(931,7549362,7549359,'00c',3.333,3),(931,7549363,7549359,'0c2',3.333,3),(931,7549364,7549359,'c29',3.333,3),(931,7549365,7549359,'290',3.333,3),(931,7549366,7549359,'90e',3.333,3),(931,7549367,7549359,'0e0',3.333,3),(931,7549368,7549359,'e01',3.333,3),(931,7549369,7549359,'01b',3.333,3),(931,7549370,7549359,'1b4',3.333,3),(931,7549371,7549359,'b46',3.333,3),(931,7549372,7549359,'46d',3.333,3),(931,7549373,7549359,'6d7',3.333,3),(931,7549374,7549359,'d74',3.333,3),(931,7549375,7549359,'749',3.333,3),(931,7549376,7549359,'496',3.333,3),(931,7549377,7549359,'969',3.333,3),(931,7549378,7549359,'69a',3.333,3),(931,7549379,7549359,'9ab',3.333,3),(931,7549380,7549359,'aba',3.333,3),(931,7549381,7549359,'ba3',3.333,3),(931,7549382,7549359,'a33',3.333,3),(931,7549383,7549359,'33a',3.333,3),(931,7549384,7549359,'3a9',3.333,3),(931,7549385,7549359,'a9c',3.333,3),(931,7549386,7549359,'9cb',3.333,3),(931,7549387,7549359,'cb2',3.333,3),(931,7549388,7549359,'b26',3.333,3),(931,7549389,7549359,'26b',3.333,3),(931,7549390,7549360,'mon',100,1),(931,7549391,7549390,'201',50,1),(931,7549392,7549390,'013',50,1),(931,7549393,7549391,'adm',33.333,4),(931,7549394,7549391,'dmi',33.333,4),(931,7549395,7549391,'min',33.333,4),(931,7549396,7549393,'cap',16.667,1),(931,7549397,7549393,'apa',16.667,1),(931,7549398,7549393,'pac',16.667,1),(931,7549399,7549393,'aci',16.667,1),(931,7549400,7549393,'cit',16.667,1),(931,7549401,7549393,'ity',16.667,1),(931,7549402,7549396,'pat',50,1),(931,7549403,7549396,'ath',50,1),(931,7549404,7549402,'fre',14.286,1),(931,7549405,7549402,'ree',14.286,1),(931,7549406,7549402,'ees',14.286,1),(931,7549407,7549402,'esp',14.286,1),(931,7549408,7549402,'spa',14.286,1),(931,7549409,7549402,'pac',14.286,1),(931,7549410,7549402,'ace',14.286,1),(931,7549411,7549404,'dis',50,1),(931,7549412,7549404,'isk',50,1),(931,7549413,7549411,'ind',33.333,1),(931,7549414,7549411,'nde',33.333,1),(931,7549415,7549411,'dex',33.333,1),(931,7549416,7549413,'adm',8.333,1),(931,7549417,7549413,'dmi',8.333,1),(931,7549418,7549413,'min',8.333,1),(931,7549419,7549413,'ini',8.333,1),(931,7549420,7549413,'nis',8.333,1),(931,7549421,7549413,'ist',8.333,1),(931,7549422,7549413,'str',8.333,1),(931,7549423,7549413,'tra',8.333,1),(931,7549424,7549413,'rat',8.333,1),(931,7549425,7549413,'ati',8.333,1),(931,7549426,7549413,'tio',8.333,1),(931,7549427,7549413,'ion',8.333,1),(931,7549428,7549416,'sta',33.333,3),(931,7549429,7549416,'tat',33.333,3),(931,7549430,7549416,'ate',33.333,3),(931,7549431,7549428,'dis',16.667,4),(931,7549432,7549428,'isa',16.667,4),(931,7549433,7549428,'sab',16.667,4),(931,7549434,7549428,'abl',16.667,4),(931,7549435,7549428,'ble',16.667,4),(931,7549436,7549428,'led',16.667,4),(931,7549437,7549431,'cac',33.333,1),(931,7549438,7549431,'ach',33.333,1),(931,7549439,7549431,'che',33.333,1),(931,7549440,7549437,'mod',50,1),(931,7549441,7549437,'ode',50,1),(931,7549442,7549440,'wri',14.286,1),(931,7549443,7549440,'rit',14.286,1),(931,7549444,7549440,'ite',14.286,1),(931,7549445,7549440,'tet',14.286,1),(931,7549446,7549440,'eth',14.286,1),(931,7549447,7549440,'thr',14.286,1),(931,7549448,7549440,'hru',14.286,1),(931,7549449,7549442,'ope',11.111,2),(931,7549450,7549442,'per',11.111,2),(931,7549451,7549442,'era',11.111,2),(931,7549452,7549442,'rat',11.111,2),(931,7549453,7549442,'ati',11.111,2),(931,7549454,7549442,'tio',11.111,2),(931,7549455,7549442,'ion',11.111,2),(931,7549456,7549442,'ona',11.111,2),(931,7549457,7549442,'nal',11.111,2),(931,7549458,7549449,'mes',20,1),(931,7549459,7549449,'ess',20,1),(931,7549460,7549449,'ssa',20,1),(931,7549461,7549449,'sag',20,1),(931,7549462,7549449,'age',20,1),(931,7549463,7549458,'per',11.111,1),(931,7549464,7549458,'erf',11.111,1),(931,7549465,7549458,'rfo',11.111,1),(931,7549466,7549458,'for',11.111,1),(931,7549467,7549458,'orm',11.111,1),(931,7549468,7549458,'rma',11.111,1),(931,7549469,7549458,'man',11.111,1),(931,7549470,7549458,'anc',11.111,1),(931,7549471,7549458,'nce',11.111,1),(931,7549472,7549463,'ide',12.5,1),(931,7549473,7549463,'den',12.5,1),(931,7549474,7549463,'ent',12.5,1),(931,7549475,7549463,'nti',12.5,1),(931,7549476,7549463,'tif',12.5,1),(931,7549477,7549463,'ifi',12.5,1),(931,7549478,7549463,'fie',12.5,1),(931,7549479,7549463,'ier',12.5,1),(931,7549480,7549472,'vdi',33.333,3),(931,7549481,7549472,'dis',33.333,3),(931,7549482,7549472,'isk',33.333,3),(931,7549483,7549480,'nam',50,1),(931,7549484,7549480,'ame',50,1),(931,7549485,7549483,'typ',50,1),(931,7549486,7549483,'ype',50,1),(931,7549487,7549485,'dir',25,1),(931,7549488,7549485,'ire',25,1),(931,7549489,7549485,'rec',25,1),(931,7549490,7549485,'ect',25,1),(932,7549492,7549491,'naa',100,2),(932,7549493,7549492,'600',3.333,3),(932,7549494,7549492,'000',3.333,3),(932,7549495,7549492,'00c',3.333,3),(932,7549496,7549492,'0c2',3.333,3),(932,7549497,7549492,'c29',3.333,3),(932,7549498,7549492,'29f',3.333,3),(932,7549499,7549492,'9f9',3.333,3),(932,7549500,7549492,'f9d',3.333,3),(932,7549501,7549492,'9d5',3.333,3),(932,7549502,7549492,'d5e',3.333,3),(932,7549503,7549492,'5e6',3.333,3),(932,7549504,7549492,'e68',3.333,3),(932,7549505,7549492,'683',3.333,3),(932,7549506,7549492,'83f',3.333,3),(932,7549507,7549492,'3ff',3.333,3),(932,7549508,7549492,'ffa',3.333,3),(932,7549509,7549492,'fa7',3.333,3),(932,7549510,7549492,'a70',3.333,3),(932,7549511,7549492,'705',3.333,3),(932,7549512,7549492,'053',3.333,3),(932,7549513,7549492,'535',3.333,3),(932,7549514,7549492,'356',3.333,3),(932,7549515,7549492,'56c',3.333,3),(932,7549516,7549492,'6cb',3.333,3),(932,7549517,7549492,'cbb',3.333,3),(932,7549518,7549492,'bb3',3.333,3),(932,7549519,7549492,'b38',3.333,3),(932,7549520,7549492,'38d',3.333,3),(932,7549521,7549492,'8de',3.333,3),(932,7549522,7549492,'def',3.333,3),(932,7549523,7549493,'mon',100,1),(932,7549524,7549523,'201',50,1),(932,7549525,7549523,'013',50,1),(932,7549526,7549524,'adm',33.333,4),(932,7549527,7549524,'dmi',33.333,4),(932,7549528,7549524,'min',33.333,4),(932,7549529,7549526,'cap',16.667,1),(932,7549530,7549526,'apa',16.667,1),(932,7549531,7549526,'pac',16.667,1),(932,7549532,7549526,'aci',16.667,1),(932,7549533,7549526,'cit',16.667,1),(932,7549534,7549526,'ity',16.667,1),(932,7549535,7549529,'pat',50,1),(932,7549536,7549529,'ath',50,1),(932,7549537,7549535,'fre',14.286,1),(932,7549538,7549535,'ree',14.286,1),(932,7549539,7549535,'ees',14.286,1),(932,7549540,7549535,'esp',14.286,1),(932,7549541,7549535,'spa',14.286,1),(932,7549542,7549535,'pac',14.286,1),(932,7549543,7549535,'ace',14.286,1),(932,7549544,7549537,'dis',50,1),(932,7549545,7549537,'isk',50,1),(932,7549546,7549544,'ind',33.333,1),(932,7549547,7549544,'nde',33.333,1),(932,7549548,7549544,'dex',33.333,1),(932,7549549,7549546,'adm',8.333,1),(932,7549550,7549546,'dmi',8.333,1),(932,7549551,7549546,'min',8.333,1),(932,7549552,7549546,'ini',8.333,1),(932,7549553,7549546,'nis',8.333,1),(932,7549554,7549546,'ist',8.333,1),(932,7549555,7549546,'str',8.333,1),(932,7549556,7549546,'tra',8.333,1),(932,7549557,7549546,'rat',8.333,1),(932,7549558,7549546,'ati',8.333,1),(932,7549559,7549546,'tio',8.333,1),(932,7549560,7549546,'ion',8.333,1),(932,7549561,7549549,'sta',33.333,3),(932,7549562,7549549,'tat',33.333,3),(932,7549563,7549549,'ate',33.333,3),(932,7549564,7549561,'dis',16.667,4),(932,7549565,7549561,'isa',16.667,4),(932,7549566,7549561,'sab',16.667,4),(932,7549567,7549561,'abl',16.667,4),(932,7549568,7549561,'ble',16.667,4),(932,7549569,7549561,'led',16.667,4),(932,7549570,7549564,'cac',33.333,1),(932,7549571,7549564,'ach',33.333,1),(932,7549572,7549564,'che',33.333,1),(932,7549573,7549570,'mod',50,1),(932,7549574,7549570,'ode',50,1),(932,7549575,7549573,'wri',14.286,1),(932,7549576,7549573,'rit',14.286,1),(932,7549577,7549573,'ite',14.286,1),(932,7549578,7549573,'tet',14.286,1),(932,7549579,7549573,'eth',14.286,1),(932,7549580,7549573,'thr',14.286,1),(932,7549581,7549573,'hru',14.286,1),(932,7549582,7549575,'ope',11.111,2),(932,7549583,7549575,'per',11.111,2),(932,7549584,7549575,'era',11.111,2),(932,7549585,7549575,'rat',11.111,2),(932,7549586,7549575,'ati',11.111,2),(932,7549587,7549575,'tio',11.111,2),(932,7549588,7549575,'ion',11.111,2),(932,7549589,7549575,'ona',11.111,2),(932,7549590,7549575,'nal',11.111,2),(932,7549591,7549582,'mes',20,1),(932,7549592,7549582,'ess',20,1),(932,7549593,7549582,'ssa',20,1),(932,7549594,7549582,'sag',20,1),(932,7549595,7549582,'age',20,1),(932,7549596,7549591,'per',11.111,1),(932,7549597,7549591,'erf',11.111,1),(932,7549598,7549591,'rfo',11.111,1),(932,7549599,7549591,'for',11.111,1),(932,7549600,7549591,'orm',11.111,1),(932,7549601,7549591,'rma',11.111,1),(932,7549602,7549591,'man',11.111,1),(932,7549603,7549591,'anc',11.111,1),(932,7549604,7549591,'nce',11.111,1),(932,7549605,7549596,'ide',12.5,1),(932,7549606,7549596,'den',12.5,1),(932,7549607,7549596,'ent',12.5,1),(932,7549608,7549596,'nti',12.5,1),(932,7549609,7549596,'tif',12.5,1),(932,7549610,7549596,'ifi',12.5,1),(932,7549611,7549596,'fie',12.5,1),(932,7549612,7549596,'ier',12.5,1),(932,7549613,7549605,'vdi',33.333,3),(932,7549614,7549605,'dis',33.333,3),(932,7549615,7549605,'isk',33.333,3),(932,7549616,7549613,'nam',50,1),(932,7549617,7549613,'ame',50,1),(932,7549618,7549616,'typ',50,1),(932,7549619,7549616,'ype',50,1),(932,7549620,7549618,'dir',25,1),(932,7549621,7549618,'ire',25,1),(932,7549622,7549618,'rec',25,1),(932,7549623,7549618,'ect',25,1),(933,7549625,7549624,'naa',100,2),(933,7549626,7549625,'600',3.333,3),(933,7549627,7549625,'000',3.333,3),(933,7549628,7549625,'00c',3.333,3),(933,7549629,7549625,'0c2',3.333,3),(933,7549630,7549625,'c29',3.333,3),(933,7549631,7549625,'290',3.333,3),(933,7549632,7549625,'904',3.333,3),(933,7549633,7549625,'049',3.333,3),(933,7549634,7549625,'495',3.333,3),(933,7549635,7549625,'95d',3.333,3),(933,7549636,7549625,'5db',3.333,3),(933,7549637,7549625,'db6',3.333,3),(933,7549638,7549625,'b67',3.333,3),(933,7549639,7549625,'67c',3.333,3),(933,7549640,7549625,'7ce',3.333,3),(933,7549641,7549625,'ce2',3.333,3),(933,7549642,7549625,'e2e',3.333,3),(933,7549643,7549625,'2e2',3.333,3),(933,7549644,7549625,'e2d',3.333,3),(933,7549645,7549625,'2d9',3.333,3),(933,7549646,7549625,'d9d',3.333,3),(933,7549647,7549625,'9d4',3.333,3),(933,7549648,7549625,'d4c',3.333,3),(933,7549649,7549625,'4c8',3.333,3),(933,7549650,7549625,'c8d',3.333,3),(933,7549651,7549625,'8d2',3.333,3),(933,7549652,7549625,'d29',3.333,3),(933,7549653,7549625,'29e',3.333,3),(933,7549654,7549625,'9e1',3.333,3),(933,7549655,7549625,'e1f',3.333,3),(933,7549656,7549626,'mon',100,1),(933,7549657,7549656,'201',50,1),(933,7549658,7549656,'013',50,1),(933,7549659,7549657,'adm',33.333,4),(933,7549660,7549657,'dmi',33.333,4),(933,7549661,7549657,'min',33.333,4),(933,7549662,7549659,'cap',16.667,1),(933,7549663,7549659,'apa',16.667,1),(933,7549664,7549659,'pac',16.667,1),(933,7549665,7549659,'aci',16.667,1),(933,7549666,7549659,'cit',16.667,1),(933,7549667,7549659,'ity',16.667,1),(933,7549668,7549662,'pat',50,1),(933,7549669,7549662,'ath',50,1),(933,7549670,7549668,'fre',14.286,1),(933,7549671,7549668,'ree',14.286,1),(933,7549672,7549668,'ees',14.286,1),(933,7549673,7549668,'esp',14.286,1),(933,7549674,7549668,'spa',14.286,1),(933,7549675,7549668,'pac',14.286,1),(933,7549676,7549668,'ace',14.286,1),(933,7549677,7549670,'dis',50,1),(933,7549678,7549670,'isk',50,1),(933,7549679,7549677,'ind',33.333,1),(933,7549680,7549677,'nde',33.333,1),(933,7549681,7549677,'dex',33.333,1),(933,7549682,7549679,'adm',8.333,1),(933,7549683,7549679,'dmi',8.333,1),(933,7549684,7549679,'min',8.333,1),(933,7549685,7549679,'ini',8.333,1),(933,7549686,7549679,'nis',8.333,1),(933,7549687,7549679,'ist',8.333,1),(933,7549688,7549679,'str',8.333,1),(933,7549689,7549679,'tra',8.333,1),(933,7549690,7549679,'rat',8.333,1),(933,7549691,7549679,'ati',8.333,1),(933,7549692,7549679,'tio',8.333,1),(933,7549693,7549679,'ion',8.333,1),(933,7549694,7549682,'sta',33.333,3),(933,7549695,7549682,'tat',33.333,3),(933,7549696,7549682,'ate',33.333,3),(933,7549697,7549694,'dis',16.667,4),(933,7549698,7549694,'isa',16.667,4),(933,7549699,7549694,'sab',16.667,4),(933,7549700,7549694,'abl',16.667,4),(933,7549701,7549694,'ble',16.667,4),(933,7549702,7549694,'led',16.667,4),(933,7549703,7549697,'cac',33.333,1),(933,7549704,7549697,'ach',33.333,1),(933,7549705,7549697,'che',33.333,1),(933,7549706,7549703,'mod',50,1),(933,7549707,7549703,'ode',50,1),(933,7549708,7549706,'wri',14.286,1),(933,7549709,7549706,'rit',14.286,1),(933,7549710,7549706,'ite',14.286,1),(933,7549711,7549706,'tet',14.286,1),(933,7549712,7549706,'eth',14.286,1),(933,7549713,7549706,'thr',14.286,1),(933,7549714,7549706,'hru',14.286,1),(933,7549715,7549708,'ope',11.111,2),(933,7549716,7549708,'per',11.111,2),(933,7549717,7549708,'era',11.111,2),(933,7549718,7549708,'rat',11.111,2),(933,7549719,7549708,'ati',11.111,2),(933,7549720,7549708,'tio',11.111,2),(933,7549721,7549708,'ion',11.111,2),(933,7549722,7549708,'ona',11.111,2),(933,7549723,7549708,'nal',11.111,2),(933,7549724,7549715,'mes',20,1),(933,7549725,7549715,'ess',20,1),(933,7549726,7549715,'ssa',20,1),(933,7549727,7549715,'sag',20,1),(933,7549728,7549715,'age',20,1),(933,7549729,7549724,'per',11.111,1),(933,7549730,7549724,'erf',11.111,1),(933,7549731,7549724,'rfo',11.111,1),(933,7549732,7549724,'for',11.111,1),(933,7549733,7549724,'orm',11.111,1),(933,7549734,7549724,'rma',11.111,1),(933,7549735,7549724,'man',11.111,1),(933,7549736,7549724,'anc',11.111,1),(933,7549737,7549724,'nce',11.111,1),(933,7549738,7549729,'ide',12.5,1),(933,7549739,7549729,'den',12.5,1),(933,7549740,7549729,'ent',12.5,1),(933,7549741,7549729,'nti',12.5,1),(933,7549742,7549729,'tif',12.5,1),(933,7549743,7549729,'ifi',12.5,1),(933,7549744,7549729,'fie',12.5,1),(933,7549745,7549729,'ier',12.5,1),(933,7549746,7549738,'vdi',33.333,3),(933,7549747,7549738,'dis',33.333,3),(933,7549748,7549738,'isk',33.333,3),(933,7549749,7549746,'nam',50,1),(933,7549750,7549746,'ame',50,1),(933,7549751,7549749,'typ',50,1),(933,7549752,7549749,'ype',50,1),(933,7549753,7549751,'dir',25,1),(933,7549754,7549751,'ire',25,1),(933,7549755,7549751,'rec',25,1),(933,7549756,7549751,'ect',25,1),(934,7549758,7549757,'naa',100,2),(934,7549759,7549758,'600',3.333,3),(934,7549760,7549758,'000',3.333,3),(934,7549761,7549758,'00c',3.333,3),(934,7549762,7549758,'0c2',3.333,3),(934,7549763,7549758,'c29',3.333,3),(934,7549764,7549758,'29c',3.333,3),(934,7549765,7549758,'9c5',3.333,3),(934,7549766,7549758,'c57',3.333,3),(934,7549767,7549758,'574',3.333,3),(934,7549768,7549758,'744',3.333,3),(934,7549769,7549758,'448',3.333,3),(934,7549770,7549758,'489',3.333,3),(934,7549771,7549758,'89c',3.333,3),(934,7549772,7549758,'9c3',3.333,3),(934,7549773,7549758,'c33',3.333,3),(934,7549774,7549758,'331',3.333,3),(934,7549775,7549758,'31c',3.333,3),(934,7549776,7549758,'1ce',3.333,3),(934,7549777,7549758,'ceb',3.333,3),(934,7549778,7549758,'ebc',3.333,3),(934,7549779,7549758,'bc2',3.333,3),(934,7549780,7549758,'c20',3.333,3),(934,7549781,7549758,'20d',3.333,3),(934,7549782,7549758,'0d4',3.333,3),(934,7549783,7549758,'d4b',3.333,3),(934,7549784,7549758,'4b0',3.333,3),(934,7549785,7549758,'b0d',3.333,3),(934,7549786,7549758,'0d4',3.333,3),(934,7549787,7549758,'d48',3.333,3),(934,7549788,7549758,'481',3.333,3),(934,7549789,7549759,'mon',100,1),(934,7549790,7549789,'201',50,1),(934,7549791,7549789,'013',50,1),(934,7549792,7549790,'adm',33.333,4),(934,7549793,7549790,'dmi',33.333,4),(934,7549794,7549790,'min',33.333,4),(934,7549795,7549792,'cap',16.667,1),(934,7549796,7549792,'apa',16.667,1),(934,7549797,7549792,'pac',16.667,1),(934,7549798,7549792,'aci',16.667,1),(934,7549799,7549792,'cit',16.667,1),(934,7549800,7549792,'ity',16.667,1),(934,7549801,7549795,'pat',50,1),(934,7549802,7549795,'ath',50,1),(934,7549803,7549801,'fre',14.286,1),(934,7549804,7549801,'ree',14.286,1),(934,7549805,7549801,'ees',14.286,1),(934,7549806,7549801,'esp',14.286,1),(934,7549807,7549801,'spa',14.286,1),(934,7549808,7549801,'pac',14.286,1),(934,7549809,7549801,'ace',14.286,1),(934,7549810,7549803,'dis',50,1),(934,7549811,7549803,'isk',50,1),(934,7549812,7549810,'ind',33.333,1),(934,7549813,7549810,'nde',33.333,1),(934,7549814,7549810,'dex',33.333,1),(934,7549815,7549812,'adm',8.333,1),(934,7549816,7549812,'dmi',8.333,1),(934,7549817,7549812,'min',8.333,1),(934,7549818,7549812,'ini',8.333,1),(934,7549819,7549812,'nis',8.333,1),(934,7549820,7549812,'ist',8.333,1),(934,7549821,7549812,'str',8.333,1),(934,7549822,7549812,'tra',8.333,1),(934,7549823,7549812,'rat',8.333,1),(934,7549824,7549812,'ati',8.333,1),(934,7549825,7549812,'tio',8.333,1),(934,7549826,7549812,'ion',8.333,1),(934,7549827,7549815,'sta',33.333,3),(934,7549828,7549815,'tat',33.333,3),(934,7549829,7549815,'ate',33.333,3),(934,7549830,7549827,'dis',16.667,4),(934,7549831,7549827,'isa',16.667,4),(934,7549832,7549827,'sab',16.667,4),(934,7549833,7549827,'abl',16.667,4),(934,7549834,7549827,'ble',16.667,4),(934,7549835,7549827,'led',16.667,4),(934,7549836,7549830,'cac',33.333,1),(934,7549837,7549830,'ach',33.333,1),(934,7549838,7549830,'che',33.333,1),(934,7549839,7549836,'mod',50,1),(934,7549840,7549836,'ode',50,1),(934,7549841,7549839,'wri',14.286,1),(934,7549842,7549839,'rit',14.286,1),(934,7549843,7549839,'ite',14.286,1),(934,7549844,7549839,'tet',14.286,1),(934,7549845,7549839,'eth',14.286,1),(934,7549846,7549839,'thr',14.286,1),(934,7549847,7549839,'hru',14.286,1),(934,7549848,7549841,'ope',11.111,2),(934,7549849,7549841,'per',11.111,2),(934,7549850,7549841,'era',11.111,2),(934,7549851,7549841,'rat',11.111,2),(934,7549852,7549841,'ati',11.111,2),(934,7549853,7549841,'tio',11.111,2),(934,7549854,7549841,'ion',11.111,2),(934,7549855,7549841,'ona',11.111,2),(934,7549856,7549841,'nal',11.111,2),(934,7549857,7549848,'mes',20,1),(934,7549858,7549848,'ess',20,1),(934,7549859,7549848,'ssa',20,1),(934,7549860,7549848,'sag',20,1),(934,7549861,7549848,'age',20,1),(934,7549862,7549857,'per',11.111,1),(934,7549863,7549857,'erf',11.111,1),(934,7549864,7549857,'rfo',11.111,1),(934,7549865,7549857,'for',11.111,1),(934,7549866,7549857,'orm',11.111,1),(934,7549867,7549857,'rma',11.111,1),(934,7549868,7549857,'man',11.111,1),(934,7549869,7549857,'anc',11.111,1),(934,7549870,7549857,'nce',11.111,1),(934,7549871,7549862,'ide',12.5,1),(934,7549872,7549862,'den',12.5,1),(934,7549873,7549862,'ent',12.5,1),(934,7549874,7549862,'nti',12.5,1),(934,7549875,7549862,'tif',12.5,1),(934,7549876,7549862,'ifi',12.5,1),(934,7549877,7549862,'fie',12.5,1),(934,7549878,7549862,'ier',12.5,1),(934,7549879,7549871,'vdi',33.333,3),(934,7549880,7549871,'dis',33.333,3),(934,7549881,7549871,'isk',33.333,3),(934,7549882,7549879,'nam',50,1),(934,7549883,7549879,'ame',50,1),(934,7549884,7549882,'typ',50,1),(934,7549885,7549882,'ype',50,1),(934,7549886,7549884,'dir',25,1),(934,7549887,7549884,'ire',25,1),(934,7549888,7549884,'rec',25,1),(934,7549889,7549884,'ect',25,1),(935,7549891,7549890,'naa',100,2),(935,7549892,7549891,'600',3.333,3),(935,7549893,7549891,'000',3.333,3),(935,7549894,7549891,'00c',3.333,3),(935,7549895,7549891,'0c2',3.333,3),(935,7549896,7549891,'c29',3.333,3),(935,7549897,7549891,'293',3.333,3),(935,7549898,7549891,'939',3.333,3),(935,7549899,7549891,'399',3.333,3),(935,7549900,7549891,'99e',3.333,3),(935,7549901,7549891,'9e1',3.333,3),(935,7549902,7549891,'e19',3.333,3),(935,7549903,7549891,'19a',3.333,3),(935,7549904,7549891,'9ae',3.333,3),(935,7549905,7549891,'aec',3.333,3),(935,7549906,7549891,'ece',3.333,3),(935,7549907,7549891,'cea',3.333,3),(935,7549908,7549891,'ea0',3.333,3),(935,7549909,7549891,'a00',3.333,3),(935,7549910,7549891,'005',3.333,3),(935,7549911,7549891,'054',3.333,3),(935,7549912,7549891,'54a',3.333,3),(935,7549913,7549891,'4ad',3.333,3),(935,7549914,7549891,'ad6',3.333,3),(935,7549915,7549891,'d62',3.333,3),(935,7549916,7549891,'62a',3.333,3),(935,7549917,7549891,'2ab',3.333,3),(935,7549918,7549891,'ab6',3.333,3),(935,7549919,7549891,'b6d',3.333,3),(935,7549920,7549891,'6db',3.333,3),(935,7549921,7549891,'db7',3.333,3),(935,7549922,7549892,'mon',100,1),(935,7549923,7549922,'201',50,1),(935,7549924,7549922,'013',50,1),(935,7549925,7549923,'adm',33.333,4),(935,7549926,7549923,'dmi',33.333,4),(935,7549927,7549923,'min',33.333,4),(935,7549928,7549925,'cap',16.667,1),(935,7549929,7549925,'apa',16.667,1),(935,7549930,7549925,'pac',16.667,1),(935,7549931,7549925,'aci',16.667,1),(935,7549932,7549925,'cit',16.667,1),(935,7549933,7549925,'ity',16.667,1),(935,7549934,7549928,'pat',50,1),(935,7549935,7549928,'ath',50,1),(935,7549936,7549934,'fre',14.286,1),(935,7549937,7549934,'ree',14.286,1),(935,7549938,7549934,'ees',14.286,1),(935,7549939,7549934,'esp',14.286,1),(935,7549940,7549934,'spa',14.286,1),(935,7549941,7549934,'pac',14.286,1),(935,7549942,7549934,'ace',14.286,1),(935,7549943,7549936,'dis',50,1),(935,7549944,7549936,'isk',50,1),(935,7549945,7549943,'ind',33.333,1),(935,7549946,7549943,'nde',33.333,1),(935,7549947,7549943,'dex',33.333,1),(935,7549948,7549945,'adm',8.333,1),(935,7549949,7549945,'dmi',8.333,1),(935,7549950,7549945,'min',8.333,1),(935,7549951,7549945,'ini',8.333,1),(935,7549952,7549945,'nis',8.333,1),(935,7549953,7549945,'ist',8.333,1),(935,7549954,7549945,'str',8.333,1),(935,7549955,7549945,'tra',8.333,1),(935,7549956,7549945,'rat',8.333,1),(935,7549957,7549945,'ati',8.333,1),(935,7549958,7549945,'tio',8.333,1),(935,7549959,7549945,'ion',8.333,1),(935,7549960,7549948,'sta',33.333,3),(935,7549961,7549948,'tat',33.333,3),(935,7549962,7549948,'ate',33.333,3),(935,7549963,7549960,'dis',16.667,4),(935,7549964,7549960,'isa',16.667,4),(935,7549965,7549960,'sab',16.667,4),(935,7549966,7549960,'abl',16.667,4),(935,7549967,7549960,'ble',16.667,4),(935,7549968,7549960,'led',16.667,4),(935,7549969,7549963,'cac',33.333,1),(935,7549970,7549963,'ach',33.333,1),(935,7549971,7549963,'che',33.333,1),(935,7549972,7549969,'mod',50,1),(935,7549973,7549969,'ode',50,1),(935,7549974,7549972,'wri',14.286,1),(935,7549975,7549972,'rit',14.286,1),(935,7549976,7549972,'ite',14.286,1),(935,7549977,7549972,'tet',14.286,1),(935,7549978,7549972,'eth',14.286,1),(935,7549979,7549972,'thr',14.286,1),(935,7549980,7549972,'hru',14.286,1),(935,7549981,7549974,'ope',11.111,2),(935,7549982,7549974,'per',11.111,2),(935,7549983,7549974,'era',11.111,2),(935,7549984,7549974,'rat',11.111,2),(935,7549985,7549974,'ati',11.111,2),(935,7549986,7549974,'tio',11.111,2),(935,7549987,7549974,'ion',11.111,2),(935,7549988,7549974,'ona',11.111,2),(935,7549989,7549974,'nal',11.111,2),(935,7549990,7549981,'mes',20,1),(935,7549991,7549981,'ess',20,1),(935,7549992,7549981,'ssa',20,1),(935,7549993,7549981,'sag',20,1),(935,7549994,7549981,'age',20,1),(935,7549995,7549990,'per',11.111,1),(935,7549996,7549990,'erf',11.111,1),(935,7549997,7549990,'rfo',11.111,1),(935,7549998,7549990,'for',11.111,1),(935,7549999,7549990,'orm',11.111,1),(935,7550000,7549990,'rma',11.111,1),(935,7550001,7549990,'man',11.111,1),(935,7550002,7549990,'anc',11.111,1),(935,7550003,7549990,'nce',11.111,1),(935,7550004,7549995,'ide',12.5,1),(935,7550005,7549995,'den',12.5,1),(935,7550006,7549995,'ent',12.5,1),(935,7550007,7549995,'nti',12.5,1),(935,7550008,7549995,'tif',12.5,1),(935,7550009,7549995,'ifi',12.5,1),(935,7550010,7549995,'fie',12.5,1),(935,7550011,7549995,'ier',12.5,1),(935,7550012,7550004,'vdi',33.333,3),(935,7550013,7550004,'dis',33.333,3),(935,7550014,7550004,'isk',33.333,3),(935,7550015,7550012,'nam',50,1),(935,7550016,7550012,'ame',50,1),(935,7550017,7550015,'typ',50,1),(935,7550018,7550015,'ype',50,1),(935,7550019,7550017,'dir',25,1),(935,7550020,7550017,'ire',25,1),(935,7550021,7550017,'rec',25,1),(935,7550022,7550017,'ect',25,1),(936,7550024,7550023,'naa',100,2),(936,7550025,7550024,'600',3.333,3),(936,7550026,7550024,'000',3.333,3),(936,7550027,7550024,'00c',3.333,3),(936,7550028,7550024,'0c2',3.333,3),(936,7550029,7550024,'c29',3.333,3),(936,7550030,7550024,'29e',3.333,3),(936,7550031,7550024,'9ea',3.333,3),(936,7550032,7550024,'ea9',3.333,3),(936,7550033,7550024,'a91',3.333,3),(936,7550034,7550024,'912',3.333,3),(936,7550035,7550024,'129',3.333,3),(936,7550036,7550024,'295',3.333,3),(936,7550037,7550024,'954',3.333,3),(936,7550038,7550024,'54e',3.333,3),(936,7550039,7550024,'4ea',3.333,3),(936,7550040,7550024,'eae',3.333,3),(936,7550041,7550024,'ae0',3.333,3),(936,7550042,7550024,'e08',3.333,3),(936,7550043,7550024,'087',3.333,3),(936,7550044,7550024,'87f',3.333,3),(936,7550045,7550024,'7fd',3.333,3),(936,7550046,7550024,'fd5',3.333,3),(936,7550047,7550024,'d58',3.333,3),(936,7550048,7550024,'58a',3.333,3),(936,7550049,7550024,'8a9',3.333,3),(936,7550050,7550024,'a9c',3.333,3),(936,7550051,7550024,'9c1',3.333,3),(936,7550052,7550024,'c13',3.333,3),(936,7550053,7550024,'137',3.333,3),(936,7550054,7550024,'37d',3.333,3),(936,7550055,7550025,'mon',100,1),(936,7550056,7550055,'201',50,1),(936,7550057,7550055,'013',50,1),(936,7550058,7550056,'adm',33.333,4),(936,7550059,7550056,'dmi',33.333,4),(936,7550060,7550056,'min',33.333,4),(936,7550061,7550058,'cap',16.667,1),(936,7550062,7550058,'apa',16.667,1),(936,7550063,7550058,'pac',16.667,1),(936,7550064,7550058,'aci',16.667,1),(936,7550065,7550058,'cit',16.667,1),(936,7550066,7550058,'ity',16.667,1),(936,7550067,7550061,'pat',50,1),(936,7550068,7550061,'ath',50,1),(936,7550069,7550067,'fre',14.286,1),(936,7550070,7550067,'ree',14.286,1),(936,7550071,7550067,'ees',14.286,1),(936,7550072,7550067,'esp',14.286,1),(936,7550073,7550067,'spa',14.286,1),(936,7550074,7550067,'pac',14.286,1),(936,7550075,7550067,'ace',14.286,1),(936,7550076,7550069,'dis',50,1),(936,7550077,7550069,'isk',50,1),(936,7550078,7550076,'ind',33.333,1),(936,7550079,7550076,'nde',33.333,1),(936,7550080,7550076,'dex',33.333,1),(936,7550081,7550078,'adm',8.333,1),(936,7550082,7550078,'dmi',8.333,1),(936,7550083,7550078,'min',8.333,1),(936,7550084,7550078,'ini',8.333,1),(936,7550085,7550078,'nis',8.333,1),(936,7550086,7550078,'ist',8.333,1),(936,7550087,7550078,'str',8.333,1),(936,7550088,7550078,'tra',8.333,1),(936,7550089,7550078,'rat',8.333,1),(936,7550090,7550078,'ati',8.333,1),(936,7550091,7550078,'tio',8.333,1),(936,7550092,7550078,'ion',8.333,1),(936,7550093,7550081,'sta',33.333,3),(936,7550094,7550081,'tat',33.333,3),(936,7550095,7550081,'ate',33.333,3),(936,7550096,7550093,'dis',16.667,4),(936,7550097,7550093,'isa',16.667,4),(936,7550098,7550093,'sab',16.667,4),(936,7550099,7550093,'abl',16.667,4),(936,7550100,7550093,'ble',16.667,4),(936,7550101,7550093,'led',16.667,4),(936,7550102,7550096,'cac',33.333,1),(936,7550103,7550096,'ach',33.333,1),(936,7550104,7550096,'che',33.333,1),(936,7550105,7550102,'mod',50,1),(936,7550106,7550102,'ode',50,1),(936,7550107,7550105,'wri',14.286,1),(936,7550108,7550105,'rit',14.286,1),(936,7550109,7550105,'ite',14.286,1),(936,7550110,7550105,'tet',14.286,1),(936,7550111,7550105,'eth',14.286,1),(936,7550112,7550105,'thr',14.286,1),(936,7550113,7550105,'hru',14.286,1),(936,7550114,7550107,'ope',11.111,2),(936,7550115,7550107,'per',11.111,2),(936,7550116,7550107,'era',11.111,2),(936,7550117,7550107,'rat',11.111,2),(936,7550118,7550107,'ati',11.111,2),(936,7550119,7550107,'tio',11.111,2),(936,7550120,7550107,'ion',11.111,2),(936,7550121,7550107,'ona',11.111,2),(936,7550122,7550107,'nal',11.111,2),(936,7550123,7550114,'mes',20,1),(936,7550124,7550114,'ess',20,1),(936,7550125,7550114,'ssa',20,1),(936,7550126,7550114,'sag',20,1),(936,7550127,7550114,'age',20,1),(936,7550128,7550123,'per',11.111,1),(936,7550129,7550123,'erf',11.111,1),(936,7550130,7550123,'rfo',11.111,1),(936,7550131,7550123,'for',11.111,1),(936,7550132,7550123,'orm',11.111,1),(936,7550133,7550123,'rma',11.111,1),(936,7550134,7550123,'man',11.111,1),(936,7550135,7550123,'anc',11.111,1),(936,7550136,7550123,'nce',11.111,1),(936,7550137,7550128,'ide',12.5,1),(936,7550138,7550128,'den',12.5,1),(936,7550139,7550128,'ent',12.5,1),(936,7550140,7550128,'nti',12.5,1),(936,7550141,7550128,'tif',12.5,1),(936,7550142,7550128,'ifi',12.5,1),(936,7550143,7550128,'fie',12.5,1),(936,7550144,7550128,'ier',12.5,1),(936,7550145,7550137,'vdi',33.333,3),(936,7550146,7550137,'dis',33.333,3),(936,7550147,7550137,'isk',33.333,3),(936,7550148,7550145,'nam',50,1),(936,7550149,7550145,'ame',50,1),(936,7550150,7550148,'typ',50,1),(936,7550151,7550148,'ype',50,1),(936,7550152,7550150,'dir',25,1),(936,7550153,7550150,'ire',25,1),(936,7550154,7550150,'rec',25,1),(936,7550155,7550150,'ect',25,1),(937,7550157,7550156,'naa',100,2),(937,7550158,7550157,'600',3.333,3),(937,7550159,7550157,'000',3.333,3),(937,7550160,7550157,'00c',3.333,3),(937,7550161,7550157,'0c2',3.333,3),(937,7550162,7550157,'c29',3.333,3),(937,7550163,7550157,'296',3.333,3),(937,7550164,7550157,'967',3.333,3),(937,7550165,7550157,'671',3.333,3),(937,7550166,7550157,'71e',3.333,3),(937,7550167,7550157,'1ee',3.333,3),(937,7550168,7550157,'ee8',3.333,3),(937,7550169,7550157,'e88',3.333,3),(937,7550170,7550157,'88b',3.333,3),(937,7550171,7550157,'8bf',3.333,3),(937,7550172,7550157,'bfa',3.333,3),(937,7550173,7550157,'fa2',3.333,3),(937,7550174,7550157,'a2b',3.333,3),(937,7550175,7550157,'2b2',3.333,3),(937,7550176,7550157,'b2c',3.333,3),(937,7550177,7550157,'2c5',3.333,3),(937,7550178,7550157,'c5f',3.333,3),(937,7550179,7550157,'5f5',3.333,3),(937,7550180,7550157,'f5c',3.333,3),(937,7550181,7550157,'5c3',3.333,3),(937,7550182,7550157,'c38',3.333,3),(937,7550183,7550157,'383',3.333,3),(937,7550184,7550157,'832',3.333,3),(937,7550185,7550157,'322',3.333,3),(937,7550186,7550157,'225',3.333,3),(937,7550187,7550157,'25b',3.333,3),(937,7550188,7550158,'mon',100,1),(937,7550189,7550188,'201',50,1),(937,7550190,7550188,'013',50,1),(937,7550191,7550189,'adm',33.333,4),(937,7550192,7550189,'dmi',33.333,4),(937,7550193,7550189,'min',33.333,4),(937,7550194,7550191,'cap',16.667,1),(937,7550195,7550191,'apa',16.667,1),(937,7550196,7550191,'pac',16.667,1),(937,7550197,7550191,'aci',16.667,1),(937,7550198,7550191,'cit',16.667,1),(937,7550199,7550191,'ity',16.667,1),(937,7550200,7550194,'pat',50,1),(937,7550201,7550194,'ath',50,1),(937,7550202,7550200,'fre',14.286,1),(937,7550203,7550200,'ree',14.286,1),(937,7550204,7550200,'ees',14.286,1),(937,7550205,7550200,'esp',14.286,1),(937,7550206,7550200,'spa',14.286,1),(937,7550207,7550200,'pac',14.286,1),(937,7550208,7550200,'ace',14.286,1),(937,7550209,7550202,'dis',50,1),(937,7550210,7550202,'isk',50,1),(937,7550211,7550209,'ind',33.333,1),(937,7550212,7550209,'nde',33.333,1),(937,7550213,7550209,'dex',33.333,1),(937,7550214,7550211,'adm',8.333,1),(937,7550215,7550211,'dmi',8.333,1),(937,7550216,7550211,'min',8.333,1),(937,7550217,7550211,'ini',8.333,1),(937,7550218,7550211,'nis',8.333,1),(937,7550219,7550211,'ist',8.333,1),(937,7550220,7550211,'str',8.333,1),(937,7550221,7550211,'tra',8.333,1),(937,7550222,7550211,'rat',8.333,1),(937,7550223,7550211,'ati',8.333,1),(937,7550224,7550211,'tio',8.333,1),(937,7550225,7550211,'ion',8.333,1),(937,7550226,7550214,'sta',33.333,3),(937,7550227,7550214,'tat',33.333,3),(937,7550228,7550214,'ate',33.333,3),(937,7550229,7550226,'dis',16.667,4),(937,7550230,7550226,'isa',16.667,4),(937,7550231,7550226,'sab',16.667,4),(937,7550232,7550226,'abl',16.667,4),(937,7550233,7550226,'ble',16.667,4),(937,7550234,7550226,'led',16.667,4),(937,7550235,7550229,'cac',33.333,1),(937,7550236,7550229,'ach',33.333,1),(937,7550237,7550229,'che',33.333,1),(937,7550238,7550235,'mod',50,1),(937,7550239,7550235,'ode',50,1),(937,7550240,7550238,'wri',14.286,1),(937,7550241,7550238,'rit',14.286,1),(937,7550242,7550238,'ite',14.286,1),(937,7550243,7550238,'tet',14.286,1),(937,7550244,7550238,'eth',14.286,1),(937,7550245,7550238,'thr',14.286,1),(937,7550246,7550238,'hru',14.286,1),(937,7550247,7550240,'ope',11.111,2),(937,7550248,7550240,'per',11.111,2),(937,7550249,7550240,'era',11.111,2),(937,7550250,7550240,'rat',11.111,2),(937,7550251,7550240,'ati',11.111,2),(937,7550252,7550240,'tio',11.111,2),(937,7550253,7550240,'ion',11.111,2),(937,7550254,7550240,'ona',11.111,2),(937,7550255,7550240,'nal',11.111,2),(937,7550256,7550247,'mes',20,1),(937,7550257,7550247,'ess',20,1),(937,7550258,7550247,'ssa',20,1),(937,7550259,7550247,'sag',20,1),(937,7550260,7550247,'age',20,1),(937,7550261,7550256,'per',11.111,1),(937,7550262,7550256,'erf',11.111,1),(937,7550263,7550256,'rfo',11.111,1),(937,7550264,7550256,'for',11.111,1),(937,7550265,7550256,'orm',11.111,1),(937,7550266,7550256,'rma',11.111,1),(937,7550267,7550256,'man',11.111,1),(937,7550268,7550256,'anc',11.111,1),(937,7550269,7550256,'nce',11.111,1),(937,7550270,7550261,'ide',12.5,1),(937,7550271,7550261,'den',12.5,1),(937,7550272,7550261,'ent',12.5,1),(937,7550273,7550261,'nti',12.5,1),(937,7550274,7550261,'tif',12.5,1),(937,7550275,7550261,'ifi',12.5,1),(937,7550276,7550261,'fie',12.5,1),(937,7550277,7550261,'ier',12.5,1),(937,7550278,7550270,'vdi',33.333,3),(937,7550279,7550270,'dis',33.333,3),(937,7550280,7550270,'isk',33.333,3),(937,7550281,7550278,'nam',50,1),(937,7550282,7550278,'ame',50,1),(937,7550283,7550281,'typ',50,1),(937,7550284,7550281,'ype',50,1),(937,7550285,7550283,'dir',25,1),(937,7550286,7550283,'ire',25,1),(937,7550287,7550283,'rec',25,1),(937,7550288,7550283,'ect',25,1),(938,7550290,7550289,'naa',100,2),(938,7550291,7550290,'600',3.333,3),(938,7550292,7550290,'000',3.333,3),(938,7550293,7550290,'00c',3.333,3),(938,7550294,7550290,'0c2',3.333,3),(938,7550295,7550290,'c29',3.333,3),(938,7550296,7550290,'290',3.333,3),(938,7550297,7550290,'906',3.333,3),(938,7550298,7550290,'066',3.333,3),(938,7550299,7550290,'66c',3.333,3),(938,7550300,7550290,'6c5',3.333,3),(938,7550301,7550290,'c56',3.333,3),(938,7550302,7550290,'562',3.333,3),(938,7550303,7550290,'626',3.333,3),(938,7550304,7550290,'264',3.333,3),(938,7550305,7550290,'64b',3.333,3),(938,7550306,7550290,'4b0',3.333,3),(938,7550307,7550290,'b08',3.333,3),(938,7550308,7550290,'08c',3.333,3),(938,7550309,7550290,'8c2',3.333,3),(938,7550310,7550290,'c29',3.333,3),(938,7550311,7550290,'29e',3.333,3),(938,7550312,7550290,'9e9',3.333,3),(938,7550313,7550290,'e90',3.333,3),(938,7550314,7550290,'904',3.333,3),(938,7550315,7550290,'048',3.333,3),(938,7550316,7550290,'48b',3.333,3),(938,7550317,7550290,'8b1',3.333,3),(938,7550318,7550290,'b1c',3.333,3),(938,7550319,7550290,'1c9',3.333,3),(938,7550320,7550290,'c99',3.333,3),(938,7550321,7550291,'mon',100,1),(938,7550322,7550321,'201',50,1),(938,7550323,7550321,'013',50,1),(938,7550324,7550322,'adm',33.333,4),(938,7550325,7550322,'dmi',33.333,4),(938,7550326,7550322,'min',33.333,4),(938,7550327,7550324,'cap',16.667,1),(938,7550328,7550324,'apa',16.667,1),(938,7550329,7550324,'pac',16.667,1),(938,7550330,7550324,'aci',16.667,1),(938,7550331,7550324,'cit',16.667,1),(938,7550332,7550324,'ity',16.667,1),(938,7550333,7550327,'pat',50,1),(938,7550334,7550327,'ath',50,1),(938,7550335,7550333,'fre',14.286,1),(938,7550336,7550333,'ree',14.286,1),(938,7550337,7550333,'ees',14.286,1),(938,7550338,7550333,'esp',14.286,1),(938,7550339,7550333,'spa',14.286,1),(938,7550340,7550333,'pac',14.286,1),(938,7550341,7550333,'ace',14.286,1),(938,7550342,7550335,'dis',50,1),(938,7550343,7550335,'isk',50,1),(938,7550344,7550342,'ind',33.333,1),(938,7550345,7550342,'nde',33.333,1),(938,7550346,7550342,'dex',33.333,1),(938,7550347,7550344,'adm',8.333,1),(938,7550348,7550344,'dmi',8.333,1),(938,7550349,7550344,'min',8.333,1),(938,7550350,7550344,'ini',8.333,1),(938,7550351,7550344,'nis',8.333,1),(938,7550352,7550344,'ist',8.333,1),(938,7550353,7550344,'str',8.333,1),(938,7550354,7550344,'tra',8.333,1),(938,7550355,7550344,'rat',8.333,1),(938,7550356,7550344,'ati',8.333,1),(938,7550357,7550344,'tio',8.333,1),(938,7550358,7550344,'ion',8.333,1),(938,7550359,7550347,'sta',33.333,3),(938,7550360,7550347,'tat',33.333,3),(938,7550361,7550347,'ate',33.333,3),(938,7550362,7550359,'dis',16.667,4),(938,7550363,7550359,'isa',16.667,4),(938,7550364,7550359,'sab',16.667,4),(938,7550365,7550359,'abl',16.667,4),(938,7550366,7550359,'ble',16.667,4),(938,7550367,7550359,'led',16.667,4),(938,7550368,7550362,'cac',33.333,1),(938,7550369,7550362,'ach',33.333,1),(938,7550370,7550362,'che',33.333,1),(938,7550371,7550368,'mod',50,1),(938,7550372,7550368,'ode',50,1),(938,7550373,7550371,'wri',14.286,1),(938,7550374,7550371,'rit',14.286,1),(938,7550375,7550371,'ite',14.286,1),(938,7550376,7550371,'tet',14.286,1),(938,7550377,7550371,'eth',14.286,1),(938,7550378,7550371,'thr',14.286,1),(938,7550379,7550371,'hru',14.286,1),(938,7550380,7550373,'ope',11.111,2),(938,7550381,7550373,'per',11.111,2),(938,7550382,7550373,'era',11.111,2),(938,7550383,7550373,'rat',11.111,2),(938,7550384,7550373,'ati',11.111,2),(938,7550385,7550373,'tio',11.111,2),(938,7550386,7550373,'ion',11.111,2),(938,7550387,7550373,'ona',11.111,2),(938,7550388,7550373,'nal',11.111,2),(938,7550389,7550380,'mes',20,1),(938,7550390,7550380,'ess',20,1),(938,7550391,7550380,'ssa',20,1),(938,7550392,7550380,'sag',20,1),(938,7550393,7550380,'age',20,1),(938,7550394,7550389,'per',11.111,1),(938,7550395,7550389,'erf',11.111,1),(938,7550396,7550389,'rfo',11.111,1),(938,7550397,7550389,'for',11.111,1),(938,7550398,7550389,'orm',11.111,1),(938,7550399,7550389,'rma',11.111,1),(938,7550400,7550389,'man',11.111,1),(938,7550401,7550389,'anc',11.111,1),(938,7550402,7550389,'nce',11.111,1),(938,7550403,7550394,'ide',12.5,1),(938,7550404,7550394,'den',12.5,1),(938,7550405,7550394,'ent',12.5,1),(938,7550406,7550394,'nti',12.5,1),(938,7550407,7550394,'tif',12.5,1),(938,7550408,7550394,'ifi',12.5,1),(938,7550409,7550394,'fie',12.5,1),(938,7550410,7550394,'ier',12.5,1),(938,7550411,7550403,'vdi',33.333,3),(938,7550412,7550403,'dis',33.333,3),(938,7550413,7550403,'isk',33.333,3),(938,7550414,7550411,'nam',50,1),(938,7550415,7550411,'ame',50,1),(938,7550416,7550414,'typ',50,1),(938,7550417,7550414,'ype',50,1),(938,7550418,7550416,'dir',25,1),(938,7550419,7550416,'ire',25,1),(938,7550420,7550416,'rec',25,1),(938,7550421,7550416,'ect',25,1),(939,7550423,7550422,'naa',100,2),(939,7550424,7550423,'600',3.333,3),(939,7550425,7550423,'000',3.333,3),(939,7550426,7550423,'00c',3.333,3),(939,7550427,7550423,'0c2',3.333,3),(939,7550428,7550423,'c29',3.333,3),(939,7550429,7550423,'297',3.333,3),(939,7550430,7550423,'974',3.333,3),(939,7550431,7550423,'74f',3.333,3),(939,7550432,7550423,'4fc',3.333,3),(939,7550433,7550423,'fca',3.333,3),(939,7550434,7550423,'ca4',3.333,3),(939,7550435,7550423,'a4d',3.333,3),(939,7550436,7550423,'4d4',3.333,3),(939,7550437,7550423,'d45',3.333,3),(939,7550438,7550423,'450',3.333,3),(939,7550439,7550423,'504',3.333,3),(939,7550440,7550423,'046',3.333,3),(939,7550441,7550423,'468',3.333,3),(939,7550442,7550423,'68b',3.333,3),(939,7550443,7550423,'8b7',3.333,3),(939,7550444,7550423,'b7b',3.333,3),(939,7550445,7550423,'7bb',3.333,3),(939,7550446,7550423,'bb1',3.333,3),(939,7550447,7550423,'b14',3.333,3),(939,7550448,7550423,'140',3.333,3),(939,7550449,7550423,'401',3.333,3),(939,7550450,7550423,'017',3.333,3),(939,7550451,7550423,'170',3.333,3),(939,7550452,7550423,'708',3.333,3),(939,7550453,7550423,'08b',3.333,3),(939,7550454,7550424,'mon',100,1),(939,7550455,7550454,'201',50,1),(939,7550456,7550454,'013',50,1),(939,7550457,7550455,'adm',33.333,4),(939,7550458,7550455,'dmi',33.333,4),(939,7550459,7550455,'min',33.333,4),(939,7550460,7550457,'cap',16.667,1),(939,7550461,7550457,'apa',16.667,1),(939,7550462,7550457,'pac',16.667,1),(939,7550463,7550457,'aci',16.667,1),(939,7550464,7550457,'cit',16.667,1),(939,7550465,7550457,'ity',16.667,1),(939,7550466,7550460,'pat',50,1),(939,7550467,7550460,'ath',50,1),(939,7550468,7550466,'fre',14.286,1),(939,7550469,7550466,'ree',14.286,1),(939,7550470,7550466,'ees',14.286,1),(939,7550471,7550466,'esp',14.286,1),(939,7550472,7550466,'spa',14.286,1),(939,7550473,7550466,'pac',14.286,1),(939,7550474,7550466,'ace',14.286,1),(939,7550475,7550468,'dis',50,1),(939,7550476,7550468,'isk',50,1),(939,7550477,7550475,'ind',33.333,1),(939,7550478,7550475,'nde',33.333,1),(939,7550479,7550475,'dex',33.333,1),(939,7550480,7550477,'adm',8.333,1),(939,7550481,7550477,'dmi',8.333,1),(939,7550482,7550477,'min',8.333,1),(939,7550483,7550477,'ini',8.333,1),(939,7550484,7550477,'nis',8.333,1),(939,7550485,7550477,'ist',8.333,1),(939,7550486,7550477,'str',8.333,1),(939,7550487,7550477,'tra',8.333,1),(939,7550488,7550477,'rat',8.333,1),(939,7550489,7550477,'ati',8.333,1),(939,7550490,7550477,'tio',8.333,1),(939,7550491,7550477,'ion',8.333,1),(939,7550492,7550480,'sta',33.333,3),(939,7550493,7550480,'tat',33.333,3),(939,7550494,7550480,'ate',33.333,3),(939,7550495,7550492,'dis',16.667,4),(939,7550496,7550492,'isa',16.667,4),(939,7550497,7550492,'sab',16.667,4),(939,7550498,7550492,'abl',16.667,4),(939,7550499,7550492,'ble',16.667,4),(939,7550500,7550492,'led',16.667,4),(939,7550501,7550495,'cac',33.333,1),(939,7550502,7550495,'ach',33.333,1),(939,7550503,7550495,'che',33.333,1),(939,7550504,7550501,'mod',50,1),(939,7550505,7550501,'ode',50,1),(939,7550506,7550504,'wri',14.286,1),(939,7550507,7550504,'rit',14.286,1),(939,7550508,7550504,'ite',14.286,1),(939,7550509,7550504,'tet',14.286,1),(939,7550510,7550504,'eth',14.286,1),(939,7550511,7550504,'thr',14.286,1),(939,7550512,7550504,'hru',14.286,1),(939,7550513,7550506,'ope',11.111,2),(939,7550514,7550506,'per',11.111,2),(939,7550515,7550506,'era',11.111,2),(939,7550516,7550506,'rat',11.111,2),(939,7550517,7550506,'ati',11.111,2),(939,7550518,7550506,'tio',11.111,2),(939,7550519,7550506,'ion',11.111,2),(939,7550520,7550506,'ona',11.111,2),(939,7550521,7550506,'nal',11.111,2),(939,7550522,7550513,'mes',20,1),(939,7550523,7550513,'ess',20,1),(939,7550524,7550513,'ssa',20,1),(939,7550525,7550513,'sag',20,1),(939,7550526,7550513,'age',20,1),(939,7550527,7550522,'per',11.111,1),(939,7550528,7550522,'erf',11.111,1),(939,7550529,7550522,'rfo',11.111,1),(939,7550530,7550522,'for',11.111,1),(939,7550531,7550522,'orm',11.111,1),(939,7550532,7550522,'rma',11.111,1),(939,7550533,7550522,'man',11.111,1),(939,7550534,7550522,'anc',11.111,1),(939,7550535,7550522,'nce',11.111,1),(939,7550536,7550527,'ide',12.5,1),(939,7550537,7550527,'den',12.5,1),(939,7550538,7550527,'ent',12.5,1),(939,7550539,7550527,'nti',12.5,1),(939,7550540,7550527,'tif',12.5,1),(939,7550541,7550527,'ifi',12.5,1),(939,7550542,7550527,'fie',12.5,1),(939,7550543,7550527,'ier',12.5,1),(939,7550544,7550536,'vdi',33.333,3),(939,7550545,7550536,'dis',33.333,3),(939,7550546,7550536,'isk',33.333,3),(939,7550547,7550544,'nam',50,1),(939,7550548,7550544,'ame',50,1),(939,7550549,7550547,'typ',50,1),(939,7550550,7550547,'ype',50,1),(939,7550551,7550549,'dir',25,1),(939,7550552,7550549,'ire',25,1),(939,7550553,7550549,'rec',25,1),(939,7550554,7550549,'ect',25,1),(940,7550556,7550555,'naa',100,2),(940,7550557,7550556,'600',3.333,3),(940,7550558,7550556,'000',3.333,3),(940,7550559,7550556,'00c',3.333,3),(940,7550560,7550556,'0c2',3.333,3),(940,7550561,7550556,'c29',3.333,3),(940,7550562,7550556,'29a',3.333,3),(940,7550563,7550556,'9af',3.333,3),(940,7550564,7550556,'af2',3.333,3),(940,7550565,7550556,'f2c',3.333,3),(940,7550566,7550556,'2cf',3.333,3),(940,7550567,7550556,'cf7',3.333,3),(940,7550568,7550556,'f77',3.333,3),(940,7550569,7550556,'773',3.333,3),(940,7550570,7550556,'733',3.333,3),(940,7550571,7550556,'330',3.333,3),(940,7550572,7550556,'307',3.333,3),(940,7550573,7550556,'07e',3.333,3),(940,7550574,7550556,'7e9',3.333,3),(940,7550575,7550556,'e9c',3.333,3),(940,7550576,7550556,'9ca',3.333,3),(940,7550577,7550556,'ca4',3.333,3),(940,7550578,7550556,'a42',3.333,3),(940,7550579,7550556,'427',3.333,3),(940,7550580,7550556,'27a',3.333,3),(940,7550581,7550556,'7ad',3.333,3),(940,7550582,7550556,'ad5',3.333,3),(940,7550583,7550556,'d5d',3.333,3),(940,7550584,7550556,'5d7',3.333,3),(940,7550585,7550556,'d70',3.333,3),(940,7550586,7550556,'70c',3.333,3),(940,7550587,7550557,'mon',100,1),(940,7550588,7550587,'201',50,1),(940,7550589,7550587,'013',50,1),(940,7550590,7550588,'adm',33.333,4),(940,7550591,7550588,'dmi',33.333,4),(940,7550592,7550588,'min',33.333,4),(940,7550593,7550590,'cap',16.667,1),(940,7550594,7550590,'apa',16.667,1),(940,7550595,7550590,'pac',16.667,1),(940,7550596,7550590,'aci',16.667,1),(940,7550597,7550590,'cit',16.667,1),(940,7550598,7550590,'ity',16.667,1),(940,7550599,7550593,'pat',50,1),(940,7550600,7550593,'ath',50,1),(940,7550601,7550599,'fre',14.286,1),(940,7550602,7550599,'ree',14.286,1),(940,7550603,7550599,'ees',14.286,1),(940,7550604,7550599,'esp',14.286,1),(940,7550605,7550599,'spa',14.286,1),(940,7550606,7550599,'pac',14.286,1),(940,7550607,7550599,'ace',14.286,1),(940,7550608,7550601,'dis',50,1),(940,7550609,7550601,'isk',50,1),(940,7550610,7550608,'ind',33.333,1),(940,7550611,7550608,'nde',33.333,1),(940,7550612,7550608,'dex',33.333,1),(940,7550613,7550610,'adm',8.333,1),(940,7550614,7550610,'dmi',8.333,1),(940,7550615,7550610,'min',8.333,1),(940,7550616,7550610,'ini',8.333,1),(940,7550617,7550610,'nis',8.333,1),(940,7550618,7550610,'ist',8.333,1),(940,7550619,7550610,'str',8.333,1),(940,7550620,7550610,'tra',8.333,1),(940,7550621,7550610,'rat',8.333,1),(940,7550622,7550610,'ati',8.333,1),(940,7550623,7550610,'tio',8.333,1),(940,7550624,7550610,'ion',8.333,1),(940,7550625,7550613,'sta',33.333,3),(940,7550626,7550613,'tat',33.333,3),(940,7550627,7550613,'ate',33.333,3),(940,7550628,7550625,'dis',16.667,4),(940,7550629,7550625,'isa',16.667,4),(940,7550630,7550625,'sab',16.667,4),(940,7550631,7550625,'abl',16.667,4),(940,7550632,7550625,'ble',16.667,4),(940,7550633,7550625,'led',16.667,4),(940,7550634,7550628,'cac',33.333,1),(940,7550635,7550628,'ach',33.333,1),(940,7550636,7550628,'che',33.333,1),(940,7550637,7550634,'mod',50,1),(940,7550638,7550634,'ode',50,1),(940,7550639,7550637,'wri',14.286,1),(940,7550640,7550637,'rit',14.286,1),(940,7550641,7550637,'ite',14.286,1),(940,7550642,7550637,'tet',14.286,1),(940,7550643,7550637,'eth',14.286,1),(940,7550644,7550637,'thr',14.286,1),(940,7550645,7550637,'hru',14.286,1),(940,7550646,7550639,'ope',11.111,2),(940,7550647,7550639,'per',11.111,2),(940,7550648,7550639,'era',11.111,2),(940,7550649,7550639,'rat',11.111,2),(940,7550650,7550639,'ati',11.111,2),(940,7550651,7550639,'tio',11.111,2),(940,7550652,7550639,'ion',11.111,2),(940,7550653,7550639,'ona',11.111,2),(940,7550654,7550639,'nal',11.111,2),(940,7550655,7550646,'mes',20,1),(940,7550656,7550646,'ess',20,1),(940,7550657,7550646,'ssa',20,1),(940,7550658,7550646,'sag',20,1),(940,7550659,7550646,'age',20,1),(940,7550660,7550655,'per',11.111,1),(940,7550661,7550655,'erf',11.111,1),(940,7550662,7550655,'rfo',11.111,1),(940,7550663,7550655,'for',11.111,1),(940,7550664,7550655,'orm',11.111,1),(940,7550665,7550655,'rma',11.111,1),(940,7550666,7550655,'man',11.111,1),(940,7550667,7550655,'anc',11.111,1),(940,7550668,7550655,'nce',11.111,1),(940,7550669,7550660,'ide',12.5,1),(940,7550670,7550660,'den',12.5,1),(940,7550671,7550660,'ent',12.5,1),(940,7550672,7550660,'nti',12.5,1),(940,7550673,7550660,'tif',12.5,1),(940,7550674,7550660,'ifi',12.5,1),(940,7550675,7550660,'fie',12.5,1),(940,7550676,7550660,'ier',12.5,1),(940,7550677,7550669,'vdi',33.333,3),(940,7550678,7550669,'dis',33.333,3),(940,7550679,7550669,'isk',33.333,3),(940,7550680,7550677,'nam',50,1),(940,7550681,7550677,'ame',50,1),(940,7550682,7550680,'typ',50,1),(940,7550683,7550680,'ype',50,1),(940,7550684,7550682,'dir',25,1),(940,7550685,7550682,'ire',25,1),(940,7550686,7550682,'rec',25,1),(940,7550687,7550682,'ect',25,1),(941,7550689,7550688,'naa',100,2),(941,7550690,7550689,'600',3.333,3),(941,7550691,7550689,'000',3.333,3),(941,7550692,7550689,'00c',3.333,3),(941,7550693,7550689,'0c2',3.333,3),(941,7550694,7550689,'c29',3.333,3),(941,7550695,7550689,'294',3.333,3),(941,7550696,7550689,'940',3.333,3),(941,7550697,7550689,'404',3.333,3),(941,7550698,7550689,'046',3.333,3),(941,7550699,7550689,'46f',3.333,3),(941,7550700,7550689,'6f8',3.333,3),(941,7550701,7550689,'f87',3.333,3),(941,7550702,7550689,'87f',3.333,3),(941,7550703,7550689,'7fc',3.333,3),(941,7550704,7550689,'fc5',3.333,3),(941,7550705,7550689,'c5f',3.333,3),(941,7550706,7550689,'5fd',3.333,3),(941,7550707,7550689,'fdc',3.333,3),(941,7550708,7550689,'dc0',3.333,3),(941,7550709,7550689,'c0a',3.333,3),(941,7550710,7550689,'0aa',3.333,3),(941,7550711,7550689,'aa9',3.333,3),(941,7550712,7550689,'a9b',3.333,3),(941,7550713,7550689,'9b5',3.333,3),(941,7550714,7550689,'b55',3.333,3),(941,7550715,7550689,'55b',3.333,3),(941,7550716,7550689,'5b6',3.333,3),(941,7550717,7550689,'b60',3.333,3),(941,7550718,7550689,'606',3.333,3),(941,7550719,7550689,'062',3.333,3),(941,7550720,7550690,'mon',100,1),(941,7550721,7550720,'201',50,1),(941,7550722,7550720,'013',50,1),(941,7550723,7550721,'adm',33.333,4),(941,7550724,7550721,'dmi',33.333,4),(941,7550725,7550721,'min',33.333,4),(941,7550726,7550723,'cap',16.667,1),(941,7550727,7550723,'apa',16.667,1),(941,7550728,7550723,'pac',16.667,1),(941,7550729,7550723,'aci',16.667,1),(941,7550730,7550723,'cit',16.667,1),(941,7550731,7550723,'ity',16.667,1),(941,7550732,7550726,'pat',50,1),(941,7550733,7550726,'ath',50,1),(941,7550734,7550732,'fre',14.286,1),(941,7550735,7550732,'ree',14.286,1),(941,7550736,7550732,'ees',14.286,1),(941,7550737,7550732,'esp',14.286,1),(941,7550738,7550732,'spa',14.286,1),(941,7550739,7550732,'pac',14.286,1),(941,7550740,7550732,'ace',14.286,1),(941,7550741,7550734,'dis',50,1),(941,7550742,7550734,'isk',50,1),(941,7550743,7550741,'ind',33.333,1),(941,7550744,7550741,'nde',33.333,1),(941,7550745,7550741,'dex',33.333,1),(941,7550746,7550743,'adm',8.333,1),(941,7550747,7550743,'dmi',8.333,1),(941,7550748,7550743,'min',8.333,1),(941,7550749,7550743,'ini',8.333,1),(941,7550750,7550743,'nis',8.333,1),(941,7550751,7550743,'ist',8.333,1),(941,7550752,7550743,'str',8.333,1),(941,7550753,7550743,'tra',8.333,1),(941,7550754,7550743,'rat',8.333,1),(941,7550755,7550743,'ati',8.333,1),(941,7550756,7550743,'tio',8.333,1),(941,7550757,7550743,'ion',8.333,1),(941,7550758,7550746,'sta',33.333,3),(941,7550759,7550746,'tat',33.333,3),(941,7550760,7550746,'ate',33.333,3),(941,7550761,7550758,'dis',16.667,4),(941,7550762,7550758,'isa',16.667,4),(941,7550763,7550758,'sab',16.667,4),(941,7550764,7550758,'abl',16.667,4),(941,7550765,7550758,'ble',16.667,4),(941,7550766,7550758,'led',16.667,4),(941,7550767,7550761,'cac',33.333,1),(941,7550768,7550761,'ach',33.333,1),(941,7550769,7550761,'che',33.333,1),(941,7550770,7550767,'mod',50,1),(941,7550771,7550767,'ode',50,1),(941,7550772,7550770,'wri',14.286,1),(941,7550773,7550770,'rit',14.286,1),(941,7550774,7550770,'ite',14.286,1),(941,7550775,7550770,'tet',14.286,1),(941,7550776,7550770,'eth',14.286,1),(941,7550777,7550770,'thr',14.286,1),(941,7550778,7550770,'hru',14.286,1),(941,7550779,7550772,'ope',11.111,2),(941,7550780,7550772,'per',11.111,2),(941,7550781,7550772,'era',11.111,2),(941,7550782,7550772,'rat',11.111,2),(941,7550783,7550772,'ati',11.111,2),(941,7550784,7550772,'tio',11.111,2),(941,7550785,7550772,'ion',11.111,2),(941,7550786,7550772,'ona',11.111,2),(941,7550787,7550772,'nal',11.111,2),(941,7550788,7550779,'mes',20,1),(941,7550789,7550779,'ess',20,1),(941,7550790,7550779,'ssa',20,1),(941,7550791,7550779,'sag',20,1),(941,7550792,7550779,'age',20,1),(941,7550793,7550788,'per',11.111,1),(941,7550794,7550788,'erf',11.111,1),(941,7550795,7550788,'rfo',11.111,1),(941,7550796,7550788,'for',11.111,1),(941,7550797,7550788,'orm',11.111,1),(941,7550798,7550788,'rma',11.111,1),(941,7550799,7550788,'man',11.111,1),(941,7550800,7550788,'anc',11.111,1),(941,7550801,7550788,'nce',11.111,1),(941,7550802,7550793,'ide',12.5,1),(941,7550803,7550793,'den',12.5,1),(941,7550804,7550793,'ent',12.5,1),(941,7550805,7550793,'nti',12.5,1),(941,7550806,7550793,'tif',12.5,1),(941,7550807,7550793,'ifi',12.5,1),(941,7550808,7550793,'fie',12.5,1),(941,7550809,7550793,'ier',12.5,1),(941,7550810,7550802,'vdi',33.333,3),(941,7550811,7550802,'dis',33.333,3),(941,7550812,7550802,'isk',33.333,3),(941,7550813,7550810,'nam',50,1),(941,7550814,7550810,'ame',50,1),(941,7550815,7550813,'typ',50,1),(941,7550816,7550813,'ype',50,1),(941,7550817,7550815,'dir',25,1),(941,7550818,7550815,'ire',25,1),(941,7550819,7550815,'rec',25,1),(941,7550820,7550815,'ect',25,1),(942,7550822,7550821,'naa',100,2),(942,7550823,7550822,'600',3.333,3),(942,7550824,7550822,'000',3.333,3),(942,7550825,7550822,'00c',3.333,3),(942,7550826,7550822,'0c2',3.333,3),(942,7550827,7550822,'c29',3.333,3),(942,7550828,7550822,'29b',3.333,3),(942,7550829,7550822,'9b3',3.333,3),(942,7550830,7550822,'b3e',3.333,3),(942,7550831,7550822,'3ec',3.333,3),(942,7550832,7550822,'ec8',3.333,3),(942,7550833,7550822,'c81',3.333,3),(942,7550834,7550822,'816',3.333,3),(942,7550835,7550822,'16a',3.333,3),(942,7550836,7550822,'6a0',3.333,3),(942,7550837,7550822,'a0b',3.333,3),(942,7550838,7550822,'0b6',3.333,3),(942,7550839,7550822,'b6f',3.333,3),(942,7550840,7550822,'6f9',3.333,3),(942,7550841,7550822,'f9c',3.333,3),(942,7550842,7550822,'9c1',3.333,3),(942,7550843,7550822,'c12',3.333,3),(942,7550844,7550822,'12e',3.333,3),(942,7550845,7550822,'2e2',3.333,3),(942,7550846,7550822,'e22',3.333,3),(942,7550847,7550822,'22c',3.333,3),(942,7550848,7550822,'2cf',3.333,3),(942,7550849,7550822,'cf0',3.333,3),(942,7550850,7550822,'f07',3.333,3),(942,7550851,7550822,'070',3.333,3),(942,7550852,7550822,'700',3.333,3),(942,7550853,7550823,'mon',100,1),(942,7550854,7550853,'201',50,1),(942,7550855,7550853,'013',50,1),(942,7550856,7550854,'adm',33.333,4),(942,7550857,7550854,'dmi',33.333,4),(942,7550858,7550854,'min',33.333,4),(942,7550859,7550856,'cap',16.667,1),(942,7550860,7550856,'apa',16.667,1),(942,7550861,7550856,'pac',16.667,1),(942,7550862,7550856,'aci',16.667,1),(942,7550863,7550856,'cit',16.667,1),(942,7550864,7550856,'ity',16.667,1),(942,7550865,7550859,'pat',50,1),(942,7550866,7550859,'ath',50,1),(942,7550867,7550865,'two',100,1),(942,7550868,7550867,'fre',14.286,1),(942,7550869,7550867,'ree',14.286,1),(942,7550870,7550867,'ees',14.286,1),(942,7550871,7550867,'esp',14.286,1),(942,7550872,7550867,'spa',14.286,1),(942,7550873,7550867,'pac',14.286,1),(942,7550874,7550867,'ace',14.286,1),(942,7550875,7550868,'dis',50,1),(942,7550876,7550868,'isk',50,1),(942,7550877,7550875,'ind',33.333,1),(942,7550878,7550875,'nde',33.333,1),(942,7550879,7550875,'dex',33.333,1),(942,7550880,7550877,'adm',8.333,1),(942,7550881,7550877,'dmi',8.333,1),(942,7550882,7550877,'min',8.333,1),(942,7550883,7550877,'ini',8.333,1),(942,7550884,7550877,'nis',8.333,1),(942,7550885,7550877,'ist',8.333,1),(942,7550886,7550877,'str',8.333,1),(942,7550887,7550877,'tra',8.333,1),(942,7550888,7550877,'rat',8.333,1),(942,7550889,7550877,'ati',8.333,1),(942,7550890,7550877,'tio',8.333,1),(942,7550891,7550877,'ion',8.333,1),(942,7550892,7550880,'sta',33.333,3),(942,7550893,7550880,'tat',33.333,3),(942,7550894,7550880,'ate',33.333,3),(942,7550895,7550892,'dis',16.667,4),(942,7550896,7550892,'isa',16.667,4),(942,7550897,7550892,'sab',16.667,4),(942,7550898,7550892,'abl',16.667,4),(942,7550899,7550892,'ble',16.667,4),(942,7550900,7550892,'led',16.667,4),(942,7550901,7550895,'cac',33.333,1),(942,7550902,7550895,'ach',33.333,1),(942,7550903,7550895,'che',33.333,1),(942,7550904,7550901,'mod',50,1),(942,7550905,7550901,'ode',50,1),(942,7550906,7550904,'wri',14.286,1),(942,7550907,7550904,'rit',14.286,1),(942,7550908,7550904,'ite',14.286,1),(942,7550909,7550904,'tet',14.286,1),(942,7550910,7550904,'eth',14.286,1),(942,7550911,7550904,'thr',14.286,1),(942,7550912,7550904,'hru',14.286,1),(942,7550913,7550906,'ope',11.111,2),(942,7550914,7550906,'per',11.111,2),(942,7550915,7550906,'era',11.111,2),(942,7550916,7550906,'rat',11.111,2),(942,7550917,7550906,'ati',11.111,2),(942,7550918,7550906,'tio',11.111,2),(942,7550919,7550906,'ion',11.111,2),(942,7550920,7550906,'ona',11.111,2),(942,7550921,7550906,'nal',11.111,2),(942,7550922,7550913,'mes',20,1),(942,7550923,7550913,'ess',20,1),(942,7550924,7550913,'ssa',20,1),(942,7550925,7550913,'sag',20,1),(942,7550926,7550913,'age',20,1),(942,7550927,7550922,'per',11.111,1),(942,7550928,7550922,'erf',11.111,1),(942,7550929,7550922,'rfo',11.111,1),(942,7550930,7550922,'for',11.111,1),(942,7550931,7550922,'orm',11.111,1),(942,7550932,7550922,'rma',11.111,1),(942,7550933,7550922,'man',11.111,1),(942,7550934,7550922,'anc',11.111,1),(942,7550935,7550922,'nce',11.111,1),(942,7550936,7550927,'ide',12.5,1),(942,7550937,7550927,'den',12.5,1),(942,7550938,7550927,'ent',12.5,1),(942,7550939,7550927,'nti',12.5,1),(942,7550940,7550927,'tif',12.5,1),(942,7550941,7550927,'ifi',12.5,1),(942,7550942,7550927,'fie',12.5,1),(942,7550943,7550927,'ier',12.5,1),(942,7550944,7550936,'vdi',33.333,3),(942,7550945,7550936,'dis',33.333,3),(942,7550946,7550936,'isk',33.333,3),(942,7550947,7550944,'nam',50,1),(942,7550948,7550944,'ame',50,1),(942,7550949,7550947,'typ',50,1),(942,7550950,7550947,'ype',50,1),(942,7550951,7550949,'dir',25,1),(942,7550952,7550949,'ire',25,1),(942,7550953,7550949,'rec',25,1),(942,7550954,7550949,'ect',25,1),(943,7550956,7550955,'att',12.5,1),(943,7550957,7550955,'ttr',12.5,1),(943,7550958,7550955,'tri',12.5,1),(943,7550959,7550955,'rib',12.5,1),(943,7550960,7550955,'ibu',12.5,1),(943,7550961,7550955,'but',12.5,1),(943,7550962,7550955,'ute',12.5,1),(943,7550963,7550955,'tes',12.5,1),(943,7550964,7550956,'ref',20,3),(943,7550965,7550956,'efr',20,3),(943,7550966,7550956,'fre',20,3),(943,7550967,7550956,'res',20,3),(943,7550968,7550956,'esh',20,3),(943,7550969,7550964,'hos',50,2),(943,7550970,7550964,'ost',50,2),(943,7550971,7550969,'nam',50,2),(943,7550972,7550969,'ame',50,2),(943,7550973,7550971,'hg3',8.333,1),(943,7550974,7550971,'g32',8.333,1),(943,7550975,7550971,'32v',8.333,1),(943,7550976,7550971,'2vm',8.333,1),(943,7550977,7550971,'vm1',8.333,1),(943,7550978,7550971,'m13',8.333,1),(943,7550979,7550971,'13w',8.333,1),(943,7550980,7550971,'3w2',8.333,1),(943,7550981,7550971,'w2k',8.333,1),(943,7550982,7550971,'2k8',8.333,1),(943,7550983,7550971,'k8r',8.333,1),(943,7550984,7550971,'8r2',8.333,1),(943,7550985,7550973,'gdl',100,1),(943,7550986,7550985,'eng',25,1),(943,7550987,7550985,'ngl',25,1),(943,7550988,7550985,'gla',25,1),(943,7550989,7550985,'lab',25,1),(943,7550990,7550986,'net',25,1),(943,7550991,7550986,'eta',25,1),(943,7550992,7550986,'tap',25,1),(943,7550993,7550986,'app',25,1),(943,7550994,7550990,'com',100,1),(943,7550995,7550994,'mem',25,3),(943,7550996,7550994,'emo',25,3),(943,7550997,7550994,'mor',25,3),(943,7550998,7550994,'ory',25,3),(943,7550999,7550995,'siz',50,2),(943,7551000,7550995,'ize',50,2),(943,7551001,7550999,'614',50,1),(943,7551002,7550999,'144',50,1),(943,7551003,7551001,'cpu',100,1),(943,7551004,7551003,'usa',33.333,3),(943,7551005,7551003,'sag',33.333,3),(943,7551006,7551003,'age',33.333,3),(943,7551007,7551004,'mhz',100,1),(943,7551008,7551007,'add',20,1),(943,7551009,7551007,'ddr',20,1),(943,7551010,7551007,'dre',20,1),(943,7551011,7551007,'res',20,1),(943,7551012,7551007,'ess',20,1),(943,7551013,7551008,'226',100,1),(943,7551014,7551013,'147',100,1),(943,7551015,7551014,'215',100,1),(943,7551016,7551015,'354',50,1),(943,7551017,7551015,'544',50,1),(943,7551018,7551016,'gue',33.333,2),(943,7551019,7551016,'ues',33.333,2),(943,7551020,7551016,'est',33.333,2),(943,7551021,7551018,'vmw',25,2),(943,7551022,7551018,'mwa',25,2),(943,7551023,7551018,'war',25,2),(943,7551024,7551018,'are',25,2),(943,7551025,7551021,'too',33.333,2),(943,7551026,7551021,'ool',33.333,2),(943,7551027,7551021,'ols',33.333,2),(943,7551028,7551025,'run',20,1),(943,7551029,7551025,'unn',20,1),(943,7551030,7551025,'nni',20,1),(943,7551031,7551025,'nin',20,1),(943,7551032,7551025,'ing',20,1),(943,7551033,7551028,'and',100,1),(943,7551034,7551033,'the',100,1),(943,7551035,7551034,'ver',20,2),(943,7551036,7551034,'ers',20,2),(943,7551037,7551034,'rsi',20,2),(943,7551038,7551034,'sio',20,2),(943,7551039,7551034,'ion',20,2),(943,7551040,7551035,'cur',20,1),(943,7551041,7551035,'urr',20,1),(943,7551042,7551035,'rre',20,1),(943,7551043,7551035,'ren',20,1),(943,7551044,7551035,'ent',20,1),(943,7551045,7551040,'mic',14.286,1),(943,7551046,7551040,'icr',14.286,1),(943,7551047,7551040,'cro',14.286,1),(943,7551048,7551040,'ros',14.286,1),(943,7551049,7551040,'oso',14.286,1),(943,7551050,7551040,'sof',14.286,1),(943,7551051,7551040,'oft',14.286,1),(943,7551052,7551045,'win',20,1),(943,7551053,7551045,'ind',20,1),(943,7551054,7551045,'ndo',20,1),(943,7551055,7551045,'dow',20,1),(943,7551056,7551045,'ows',20,1),(943,7551057,7551052,'ser',25,1),(943,7551058,7551052,'erv',25,1),(943,7551059,7551052,'rve',25,1),(943,7551060,7551052,'ver',25,1),(943,7551061,7551057,'200',50,1),(943,7551062,7551057,'008',50,1),(943,7551063,7551061,'64b',33.333,1),(943,7551064,7551061,'4bi',33.333,1),(943,7551065,7551061,'bit',33.333,1),(943,7551066,7551063,'pat',50,1),(943,7551067,7551063,'ath',50,1),(943,7551068,7551066,'rx6',33.333,1),(943,7551069,7551066,'x60',33.333,1),(943,7551070,7551066,'600',33.333,1),(943,7551071,7551068,'vmf',20,1),(943,7551072,7551068,'mfi',20,1),(943,7551073,7551068,'fil',20,1),(943,7551074,7551068,'ile',20,1),(943,7551075,7551068,'les',20,1),(943,7551076,7551071,'hgw',8.333,2),(943,7551077,7551071,'gw2',8.333,2),(943,7551078,7551071,'w2k',8.333,2),(943,7551079,7551071,'2k8',8.333,2),(943,7551080,7551071,'k8r',8.333,2),(943,7551081,7551071,'8r2',8.333,2),(943,7551082,7551071,'r23',8.333,2),(943,7551083,7551071,'232',8.333,2),(943,7551084,7551071,'32v',8.333,2),(943,7551085,7551071,'2vm',8.333,2),(943,7551086,7551071,'vm1',8.333,2),(943,7551087,7551071,'m13',8.333,2),(943,7551088,7551076,'vmx',100,1),(943,7551089,7551088,'fla',33.333,1),(943,7551090,7551088,'las',33.333,1),(943,7551091,7551088,'ash',33.333,1),(943,7551092,7551089,'acc',33.333,1),(943,7551093,7551089,'cce',33.333,1),(943,7551094,7551089,'cel',33.333,1),(943,7551095,7551092,'con',9.091,1),(943,7551096,7551092,'onf',9.091,1),(943,7551097,7551092,'nfi',9.091,1),(943,7551098,7551092,'fig',9.091,1),(943,7551099,7551092,'igu',9.091,1),(943,7551100,7551092,'gur',9.091,1),(943,7551101,7551092,'ura',9.091,1),(943,7551102,7551092,'rat',9.091,1),(943,7551103,7551092,'ati',9.091,1),(943,7551104,7551092,'tio',9.091,1),(943,7551105,7551092,'ion',9.091,1),(943,7551106,7551095,'age',33.333,1),(943,7551107,7551095,'gen',33.333,1),(943,7551108,7551095,'ent',33.333,1),(943,7551109,7551106,'193',16.667,1),(943,7551110,7551106,'938',16.667,1),(943,7551111,7551106,'380',16.667,1),(943,7551112,7551106,'809',16.667,1),(943,7551113,7551106,'097',16.667,1),(943,7551114,7551106,'979',16.667,1),(943,7551115,7551109,'cac',33.333,3),(943,7551116,7551109,'ach',33.333,3),(943,7551117,7551109,'che',33.333,3),(943,7551118,7551115,'sta',33.333,2),(943,7551119,7551115,'tat',33.333,2),(943,7551120,7551115,'ate',33.333,2),(943,7551121,7551118,'dis',16.667,3),(943,7551122,7551118,'isa',16.667,3),(943,7551123,7551118,'sab',16.667,3),(943,7551124,7551118,'abl',16.667,3),(943,7551125,7551118,'ble',16.667,3),(943,7551126,7551118,'led',16.667,3),(943,7551127,7551121,'ope',11.111,2),(943,7551128,7551121,'per',11.111,2),(943,7551129,7551121,'era',11.111,2),(943,7551130,7551121,'rat',11.111,2),(943,7551131,7551121,'ati',11.111,2),(943,7551132,7551121,'tio',11.111,2),(943,7551133,7551121,'ion',11.111,2),(943,7551134,7551121,'ona',11.111,2),(943,7551135,7551121,'nal',11.111,2),(943,7551136,7551127,'mod',50,1),(943,7551137,7551127,'ode',50,1),(943,7551138,7551136,'wri',14.286,1),(943,7551139,7551136,'rit',14.286,1),(943,7551140,7551136,'ite',14.286,1),(943,7551141,7551136,'tet',14.286,1),(943,7551142,7551136,'eth',14.286,1),(943,7551143,7551136,'thr',14.286,1),(943,7551144,7551136,'hru',14.286,1),(943,7551145,7551138,'mes',20,1),(943,7551146,7551138,'ess',20,1),(943,7551147,7551138,'ssa',20,1),(943,7551148,7551138,'sag',20,1),(943,7551149,7551138,'age',20,1),(943,7551150,7551145,'adm',33.333,1),(943,7551151,7551145,'dmi',33.333,1),(943,7551152,7551145,'min',33.333,1),(943,7551153,7551150,'met',20,3),(943,7551154,7551150,'etr',20,3),(943,7551155,7551150,'tri',20,3),(943,7551156,7551150,'ric',20,3),(943,7551157,7551150,'ics',20,3),(943,7551158,7551153,'ena',20,1),(943,7551159,7551153,'nab',20,1),(943,7551160,7551153,'abl',20,1),(943,7551161,7551153,'ble',20,1),(943,7551162,7551153,'led',20,1),(943,7551163,7551158,'vir',20,1),(943,7551164,7551158,'irt',20,1),(943,7551165,7551158,'rtu',20,1),(943,7551166,7551158,'tua',20,1),(943,7551167,7551158,'ual',20,1),(943,7551168,7551163,'dis',50,1),(943,7551169,7551163,'isk',50,1),(944,7551171,7551170,'naa',100,2),(944,7551172,7551171,'600',3.333,3),(944,7551173,7551171,'000',3.333,3),(944,7551174,7551171,'00c',3.333,3),(944,7551175,7551171,'0c2',3.333,3),(944,7551176,7551171,'c29',3.333,3),(944,7551177,7551171,'29f',3.333,3),(944,7551178,7551171,'9fd',3.333,3),(944,7551179,7551171,'fd7',3.333,3),(944,7551180,7551171,'d79',3.333,3),(944,7551181,7551171,'797',3.333,3),(944,7551182,7551171,'972',3.333,3),(944,7551183,7551171,'728',3.333,3),(944,7551184,7551171,'287',3.333,3),(944,7551185,7551171,'878',3.333,3),(944,7551186,7551171,'787',3.333,3),(944,7551187,7551171,'875',3.333,3),(944,7551188,7551171,'756',3.333,3),(944,7551189,7551171,'561',3.333,3),(944,7551190,7551171,'615',3.333,3),(944,7551191,7551171,'159',3.333,3),(944,7551192,7551171,'590',3.333,3),(944,7551193,7551171,'903',3.333,3),(944,7551194,7551171,'039',3.333,3),(944,7551195,7551171,'39f',3.333,3),(944,7551196,7551171,'9f9',3.333,3),(944,7551197,7551171,'f96',3.333,3),(944,7551198,7551171,'96d',3.333,3),(944,7551199,7551171,'6d9',3.333,3),(944,7551200,7551171,'d92',3.333,3),(944,7551201,7551171,'925',3.333,3),(944,7551202,7551172,'mon',100,1),(944,7551203,7551202,'201',50,1),(944,7551204,7551202,'013',50,1),(944,7551205,7551203,'adm',33.333,4),(944,7551206,7551203,'dmi',33.333,4),(944,7551207,7551203,'min',33.333,4),(944,7551208,7551205,'cap',16.667,1),(944,7551209,7551205,'apa',16.667,1),(944,7551210,7551205,'pac',16.667,1),(944,7551211,7551205,'aci',16.667,1),(944,7551212,7551205,'cit',16.667,1),(944,7551213,7551205,'ity',16.667,1),(944,7551214,7551208,'pat',50,1),(944,7551215,7551208,'ath',50,1),(944,7551216,7551214,'vol',25,1),(944,7551217,7551214,'olu',25,1),(944,7551218,7551214,'lum',25,1),(944,7551219,7551214,'ume',25,1),(944,7551220,7551216,'78e',3.333,1),(944,7551221,7551216,'8e3',3.333,1),(944,7551222,7551216,'e3f',3.333,1),(944,7551223,7551216,'3f1',3.333,1),(944,7551224,7551216,'f18',3.333,1),(944,7551225,7551216,'188',3.333,1),(944,7551226,7551216,'886',3.333,1),(944,7551227,7551216,'86d',3.333,1),(944,7551228,7551216,'6d8',3.333,1),(944,7551229,7551216,'d87',3.333,1),(944,7551230,7551216,'871',3.333,1),(944,7551231,7551216,'711',3.333,1),(944,7551232,7551216,'11e',3.333,1),(944,7551233,7551216,'1e1',3.333,1),(944,7551234,7551216,'e19',3.333,1),(944,7551235,7551216,'192',3.333,1),(944,7551236,7551216,'927',3.333,1),(944,7551237,7551216,'277',3.333,1),(944,7551238,7551216,'778',3.333,1),(944,7551239,7551216,'780',3.333,1),(944,7551240,7551216,'806',3.333,1),(944,7551241,7551216,'06e',3.333,1),(944,7551242,7551216,'6e6',3.333,1),(944,7551243,7551216,'e6f',3.333,1),(944,7551244,7551216,'6f6',3.333,1),(944,7551245,7551216,'f6e',3.333,1),(944,7551246,7551216,'6e6',3.333,1),(944,7551247,7551216,'e69',3.333,1),(944,7551248,7551216,'696',3.333,1),(944,7551249,7551216,'963',3.333,1),(944,7551250,7551220,'fre',14.286,1),(944,7551251,7551220,'ree',14.286,1),(944,7551252,7551220,'ees',14.286,1),(944,7551253,7551220,'esp',14.286,1),(944,7551254,7551220,'spa',14.286,1),(944,7551255,7551220,'pac',14.286,1),(944,7551256,7551220,'ace',14.286,1),(944,7551257,7551250,'dis',50,1),(944,7551258,7551250,'isk',50,1),(944,7551259,7551257,'ind',33.333,1),(944,7551260,7551257,'nde',33.333,1),(944,7551261,7551257,'dex',33.333,1),(944,7551262,7551259,'adm',8.333,1),(944,7551263,7551259,'dmi',8.333,1),(944,7551264,7551259,'min',8.333,1),(944,7551265,7551259,'ini',8.333,1),(944,7551266,7551259,'nis',8.333,1),(944,7551267,7551259,'ist',8.333,1),(944,7551268,7551259,'str',8.333,1),(944,7551269,7551259,'tra',8.333,1),(944,7551270,7551259,'rat',8.333,1),(944,7551271,7551259,'ati',8.333,1),(944,7551272,7551259,'tio',8.333,1),(944,7551273,7551259,'ion',8.333,1),(944,7551274,7551262,'sta',33.333,3),(944,7551275,7551262,'tat',33.333,3),(944,7551276,7551262,'ate',33.333,3),(944,7551277,7551274,'dis',16.667,4),(944,7551278,7551274,'isa',16.667,4),(944,7551279,7551274,'sab',16.667,4),(944,7551280,7551274,'abl',16.667,4),(944,7551281,7551274,'ble',16.667,4),(944,7551282,7551274,'led',16.667,4),(944,7551283,7551277,'cac',33.333,1),(944,7551284,7551277,'ach',33.333,1),(944,7551285,7551277,'che',33.333,1),(944,7551286,7551283,'mod',50,1),(944,7551287,7551283,'ode',50,1),(944,7551288,7551286,'wri',14.286,1),(944,7551289,7551286,'rit',14.286,1),(944,7551290,7551286,'ite',14.286,1),(944,7551291,7551286,'tet',14.286,1),(944,7551292,7551286,'eth',14.286,1),(944,7551293,7551286,'thr',14.286,1),(944,7551294,7551286,'hru',14.286,1),(944,7551295,7551288,'ope',11.111,2),(944,7551296,7551288,'per',11.111,2),(944,7551297,7551288,'era',11.111,2),(944,7551298,7551288,'rat',11.111,2),(944,7551299,7551288,'ati',11.111,2),(944,7551300,7551288,'tio',11.111,2),(944,7551301,7551288,'ion',11.111,2),(944,7551302,7551288,'ona',11.111,2),(944,7551303,7551288,'nal',11.111,2),(944,7551304,7551295,'mes',20,1),(944,7551305,7551295,'ess',20,1),(944,7551306,7551295,'ssa',20,1),(944,7551307,7551295,'sag',20,1),(944,7551308,7551295,'age',20,1),(944,7551309,7551304,'per',11.111,1),(944,7551310,7551304,'erf',11.111,1),(944,7551311,7551304,'rfo',11.111,1),(944,7551312,7551304,'for',11.111,1),(944,7551313,7551304,'orm',11.111,1),(944,7551314,7551304,'rma',11.111,1),(944,7551315,7551304,'man',11.111,1),(944,7551316,7551304,'anc',11.111,1),(944,7551317,7551304,'nce',11.111,1),(944,7551318,7551309,'ide',12.5,1),(944,7551319,7551309,'den',12.5,1),(944,7551320,7551309,'ent',12.5,1),(944,7551321,7551309,'nti',12.5,1),(944,7551322,7551309,'tif',12.5,1),(944,7551323,7551309,'ifi',12.5,1),(944,7551324,7551309,'fie',12.5,1),(944,7551325,7551309,'ier',12.5,1),(944,7551326,7551318,'vdi',33.333,3),(944,7551327,7551318,'dis',33.333,3),(944,7551328,7551318,'isk',33.333,3),(944,7551329,7551326,'nam',50,1),(944,7551330,7551326,'ame',50,1),(944,7551331,7551329,'typ',50,1),(944,7551332,7551329,'ype',50,1),(944,7551333,7551331,'dir',25,1),(944,7551334,7551331,'ire',25,1),(944,7551335,7551331,'rec',25,1),(944,7551336,7551331,'ect',25,1),(945,7551338,7551337,'naa',100,2),(945,7551339,7551338,'600',3.333,3),(945,7551340,7551338,'00a',3.333,3),(945,7551341,7551338,'0a0',3.333,3),(945,7551342,7551338,'a09',3.333,3),(945,7551343,7551338,'098',3.333,3),(945,7551344,7551338,'980',3.333,3),(945,7551345,7551338,'804',3.333,3),(945,7551346,7551338,'044',3.333,3),(945,7551347,7551338,'443',3.333,3),(945,7551348,7551338,'430',3.333,3),(945,7551349,7551338,'307',3.333,3),(945,7551350,7551338,'072',3.333,3),(945,7551351,7551338,'725',3.333,3),(945,7551352,7551338,'259',3.333,3),(945,7551353,7551338,'593',3.333,3),(945,7551354,7551338,'931',3.333,3),(945,7551355,7551338,'313',3.333,3),(945,7551356,7551338,'13f',3.333,3),(945,7551357,7551338,'3f3',3.333,3),(945,7551358,7551338,'f33',3.333,3),(945,7551359,7551338,'334',3.333,3),(945,7551360,7551338,'345',3.333,3),(945,7551361,7551338,'455',3.333,3),(945,7551362,7551338,'556',3.333,3),(945,7551363,7551338,'563',3.333,3),(945,7551364,7551338,'639',3.333,3),(945,7551365,7551338,'393',3.333,3),(945,7551366,7551338,'934',3.333,3),(945,7551367,7551338,'345',3.333,3),(945,7551368,7551338,'453',3.333,3),(945,7551369,7551339,'mon',100,1),(945,7551370,7551369,'201',50,1),(945,7551371,7551369,'013',50,1),(945,7551372,7551370,'adm',33.333,4),(945,7551373,7551370,'dmi',33.333,4),(945,7551374,7551370,'min',33.333,4),(945,7551375,7551372,'cap',16.667,1),(945,7551376,7551372,'apa',16.667,1),(945,7551377,7551372,'pac',16.667,1),(945,7551378,7551372,'aci',16.667,1),(945,7551379,7551372,'cit',16.667,1),(945,7551380,7551372,'ity',16.667,1),(945,7551381,7551375,'pat',50,1),(945,7551382,7551375,'ath',50,1),(945,7551383,7551381,'fre',14.286,1),(945,7551384,7551381,'ree',14.286,1),(945,7551385,7551381,'ees',14.286,1),(945,7551386,7551381,'esp',14.286,1),(945,7551387,7551381,'spa',14.286,1),(945,7551388,7551381,'pac',14.286,1),(945,7551389,7551381,'ace',14.286,1),(945,7551390,7551383,'dis',50,1),(945,7551391,7551383,'isk',50,1),(945,7551392,7551390,'ind',33.333,1),(945,7551393,7551390,'nde',33.333,1),(945,7551394,7551390,'dex',33.333,1),(945,7551395,7551392,'adm',8.333,1),(945,7551396,7551392,'dmi',8.333,1),(945,7551397,7551392,'min',8.333,1),(945,7551398,7551392,'ini',8.333,1),(945,7551399,7551392,'nis',8.333,1),(945,7551400,7551392,'ist',8.333,1),(945,7551401,7551392,'str',8.333,1),(945,7551402,7551392,'tra',8.333,1),(945,7551403,7551392,'rat',8.333,1),(945,7551404,7551392,'ati',8.333,1),(945,7551405,7551392,'tio',8.333,1),(945,7551406,7551392,'ion',8.333,1),(945,7551407,7551395,'sta',33.333,3),(945,7551408,7551395,'tat',33.333,3),(945,7551409,7551395,'ate',33.333,3),(945,7551410,7551407,'dis',16.667,4),(945,7551411,7551407,'isa',16.667,4),(945,7551412,7551407,'sab',16.667,4),(945,7551413,7551407,'abl',16.667,4),(945,7551414,7551407,'ble',16.667,4),(945,7551415,7551407,'led',16.667,4),(945,7551416,7551410,'cac',33.333,1),(945,7551417,7551410,'ach',33.333,1),(945,7551418,7551410,'che',33.333,1),(945,7551419,7551416,'mod',50,1),(945,7551420,7551416,'ode',50,1),(945,7551421,7551419,'wri',14.286,1),(945,7551422,7551419,'rit',14.286,1),(945,7551423,7551419,'ite',14.286,1),(945,7551424,7551419,'tet',14.286,1),(945,7551425,7551419,'eth',14.286,1),(945,7551426,7551419,'thr',14.286,1),(945,7551427,7551419,'hru',14.286,1),(945,7551428,7551421,'ope',11.111,2),(945,7551429,7551421,'per',11.111,2),(945,7551430,7551421,'era',11.111,2),(945,7551431,7551421,'rat',11.111,2),(945,7551432,7551421,'ati',11.111,2),(945,7551433,7551421,'tio',11.111,2),(945,7551434,7551421,'ion',11.111,2),(945,7551435,7551421,'ona',11.111,2),(945,7551436,7551421,'nal',11.111,2),(945,7551437,7551428,'mes',20,1),(945,7551438,7551428,'ess',20,1),(945,7551439,7551428,'ssa',20,1),(945,7551440,7551428,'sag',20,1),(945,7551441,7551428,'age',20,1),(945,7551442,7551437,'per',11.111,1),(945,7551443,7551437,'erf',11.111,1),(945,7551444,7551437,'rfo',11.111,1),(945,7551445,7551437,'for',11.111,1),(945,7551446,7551437,'orm',11.111,1),(945,7551447,7551437,'rma',11.111,1),(945,7551448,7551437,'man',11.111,1),(945,7551449,7551437,'anc',11.111,1),(945,7551450,7551437,'nce',11.111,1),(945,7551451,7551442,'ide',12.5,1),(945,7551452,7551442,'den',12.5,1),(945,7551453,7551442,'ent',12.5,1),(945,7551454,7551442,'nti',12.5,1),(945,7551455,7551442,'tif',12.5,1),(945,7551456,7551442,'ifi',12.5,1),(945,7551457,7551442,'fie',12.5,1),(945,7551458,7551442,'ier',12.5,1),(945,7551459,7551451,'vdi',33.333,3),(945,7551460,7551451,'dis',33.333,3),(945,7551461,7551451,'isk',33.333,3),(945,7551462,7551459,'nam',50,1),(945,7551463,7551459,'ame',50,1),(945,7551464,7551462,'typ',50,1),(945,7551465,7551462,'ype',50,1),(945,7551466,7551464,'dir',25,1),(945,7551467,7551464,'ire',25,1),(945,7551468,7551464,'rec',25,1),(945,7551469,7551464,'ect',25,1),(946,7551471,7551470,'naa',100,2),(946,7551472,7551471,'600',3.333,3),(946,7551473,7551471,'00a',3.333,3),(946,7551474,7551471,'0a0',3.333,3),(946,7551475,7551471,'a09',3.333,3),(946,7551476,7551471,'098',3.333,3),(946,7551477,7551471,'980',3.333,3),(946,7551478,7551471,'804',3.333,3),(946,7551479,7551471,'044',3.333,3),(946,7551480,7551471,'443',3.333,3),(946,7551481,7551471,'430',3.333,3),(946,7551482,7551471,'307',3.333,3),(946,7551483,7551471,'072',3.333,3),(946,7551484,7551471,'725',3.333,3),(946,7551485,7551471,'259',3.333,3),(946,7551486,7551471,'593',3.333,3),(946,7551487,7551471,'931',3.333,3),(946,7551488,7551471,'313',3.333,3),(946,7551489,7551471,'13f',3.333,3),(946,7551490,7551471,'3f3',3.333,3),(946,7551491,7551471,'f33',3.333,3),(946,7551492,7551471,'334',3.333,3),(946,7551493,7551471,'345',3.333,3),(946,7551494,7551471,'455',3.333,3),(946,7551495,7551471,'556',3.333,3),(946,7551496,7551471,'563',3.333,3),(946,7551497,7551471,'639',3.333,3),(946,7551498,7551471,'393',3.333,3),(946,7551499,7551471,'934',3.333,3),(946,7551500,7551471,'345',3.333,3),(946,7551501,7551471,'454',3.333,3),(946,7551502,7551472,'mon',100,1),(946,7551503,7551502,'201',50,1),(946,7551504,7551502,'013',50,1),(946,7551505,7551503,'adm',33.333,4),(946,7551506,7551503,'dmi',33.333,4),(946,7551507,7551503,'min',33.333,4),(946,7551508,7551505,'cap',16.667,1),(946,7551509,7551505,'apa',16.667,1),(946,7551510,7551505,'pac',16.667,1),(946,7551511,7551505,'aci',16.667,1),(946,7551512,7551505,'cit',16.667,1),(946,7551513,7551505,'ity',16.667,1),(946,7551514,7551508,'pat',50,1),(946,7551515,7551508,'ath',50,1),(946,7551516,7551514,'fre',14.286,1),(946,7551517,7551514,'ree',14.286,1),(946,7551518,7551514,'ees',14.286,1),(946,7551519,7551514,'esp',14.286,1),(946,7551520,7551514,'spa',14.286,1),(946,7551521,7551514,'pac',14.286,1),(946,7551522,7551514,'ace',14.286,1),(946,7551523,7551516,'dis',50,1),(946,7551524,7551516,'isk',50,1),(946,7551525,7551523,'ind',33.333,1),(946,7551526,7551523,'nde',33.333,1),(946,7551527,7551523,'dex',33.333,1),(946,7551528,7551525,'adm',8.333,1),(946,7551529,7551525,'dmi',8.333,1),(946,7551530,7551525,'min',8.333,1),(946,7551531,7551525,'ini',8.333,1),(946,7551532,7551525,'nis',8.333,1),(946,7551533,7551525,'ist',8.333,1),(946,7551534,7551525,'str',8.333,1),(946,7551535,7551525,'tra',8.333,1),(946,7551536,7551525,'rat',8.333,1),(946,7551537,7551525,'ati',8.333,1),(946,7551538,7551525,'tio',8.333,1),(946,7551539,7551525,'ion',8.333,1),(946,7551540,7551528,'sta',33.333,3),(946,7551541,7551528,'tat',33.333,3),(946,7551542,7551528,'ate',33.333,3),(946,7551543,7551540,'dis',16.667,4),(946,7551544,7551540,'isa',16.667,4),(946,7551545,7551540,'sab',16.667,4),(946,7551546,7551540,'abl',16.667,4),(946,7551547,7551540,'ble',16.667,4),(946,7551548,7551540,'led',16.667,4),(946,7551549,7551543,'cac',33.333,1),(946,7551550,7551543,'ach',33.333,1),(946,7551551,7551543,'che',33.333,1),(946,7551552,7551549,'mod',50,1),(946,7551553,7551549,'ode',50,1),(946,7551554,7551552,'wri',14.286,1),(946,7551555,7551552,'rit',14.286,1),(946,7551556,7551552,'ite',14.286,1),(946,7551557,7551552,'tet',14.286,1),(946,7551558,7551552,'eth',14.286,1),(946,7551559,7551552,'thr',14.286,1),(946,7551560,7551552,'hru',14.286,1),(946,7551561,7551554,'ope',11.111,2),(946,7551562,7551554,'per',11.111,2),(946,7551563,7551554,'era',11.111,2),(946,7551564,7551554,'rat',11.111,2),(946,7551565,7551554,'ati',11.111,2),(946,7551566,7551554,'tio',11.111,2),(946,7551567,7551554,'ion',11.111,2),(946,7551568,7551554,'ona',11.111,2),(946,7551569,7551554,'nal',11.111,2),(946,7551570,7551561,'mes',20,1),(946,7551571,7551561,'ess',20,1),(946,7551572,7551561,'ssa',20,1),(946,7551573,7551561,'sag',20,1),(946,7551574,7551561,'age',20,1),(946,7551575,7551570,'per',11.111,1),(946,7551576,7551570,'erf',11.111,1),(946,7551577,7551570,'rfo',11.111,1),(946,7551578,7551570,'for',11.111,1),(946,7551579,7551570,'orm',11.111,1),(946,7551580,7551570,'rma',11.111,1),(946,7551581,7551570,'man',11.111,1),(946,7551582,7551570,'anc',11.111,1),(946,7551583,7551570,'nce',11.111,1),(946,7551584,7551575,'ide',12.5,1),(946,7551585,7551575,'den',12.5,1),(946,7551586,7551575,'ent',12.5,1),(946,7551587,7551575,'nti',12.5,1),(946,7551588,7551575,'tif',12.5,1),(946,7551589,7551575,'ifi',12.5,1),(946,7551590,7551575,'fie',12.5,1),(946,7551591,7551575,'ier',12.5,1),(946,7551592,7551584,'vdi',33.333,3),(946,7551593,7551584,'dis',33.333,3),(946,7551594,7551584,'isk',33.333,3),(946,7551595,7551592,'nam',50,1),(946,7551596,7551592,'ame',50,1),(946,7551597,7551595,'typ',50,1),(946,7551598,7551595,'ype',50,1),(946,7551599,7551597,'dir',25,1),(946,7551600,7551597,'ire',25,1),(946,7551601,7551597,'rec',25,1),(946,7551602,7551597,'ect',25,1),(947,7551604,7551603,'naa',100,2),(947,7551605,7551604,'600',3.333,3),(947,7551606,7551604,'00a',3.333,3),(947,7551607,7551604,'0a0',3.333,3),(947,7551608,7551604,'a09',3.333,3),(947,7551609,7551604,'098',3.333,3),(947,7551610,7551604,'980',3.333,3),(947,7551611,7551604,'804',3.333,3),(947,7551612,7551604,'044',3.333,3),(947,7551613,7551604,'443',3.333,3),(947,7551614,7551604,'430',3.333,3),(947,7551615,7551604,'307',3.333,3),(947,7551616,7551604,'075',3.333,3),(947,7551617,7551604,'753',3.333,3),(947,7551618,7551604,'535',3.333,3),(947,7551619,7551604,'357',3.333,3),(947,7551620,7551604,'573',3.333,3),(947,7551621,7551604,'732',3.333,3),(947,7551622,7551604,'32b',3.333,3),(947,7551623,7551604,'2b3',3.333,3),(947,7551624,7551604,'b33',3.333,3),(947,7551625,7551604,'334',3.333,3),(947,7551626,7551604,'345',3.333,3),(947,7551627,7551604,'457',3.333,3),(947,7551628,7551604,'571',3.333,3),(947,7551629,7551604,'715',3.333,3),(947,7551630,7551604,'153',3.333,3),(947,7551631,7551604,'533',3.333,3),(947,7551632,7551604,'336',3.333,3),(947,7551633,7551604,'364',3.333,3),(947,7551634,7551604,'644',3.333,3),(947,7551635,7551605,'mon',100,1),(947,7551636,7551635,'201',50,1),(947,7551637,7551635,'013',50,1),(947,7551638,7551636,'adm',33.333,4),(947,7551639,7551636,'dmi',33.333,4),(947,7551640,7551636,'min',33.333,4),(947,7551641,7551638,'cap',16.667,1),(947,7551642,7551638,'apa',16.667,1),(947,7551643,7551638,'pac',16.667,1),(947,7551644,7551638,'aci',16.667,1),(947,7551645,7551638,'cit',16.667,1),(947,7551646,7551638,'ity',16.667,1),(947,7551647,7551641,'pat',50,1),(947,7551648,7551641,'ath',50,1),(947,7551649,7551647,'fre',14.286,1),(947,7551650,7551647,'ree',14.286,1),(947,7551651,7551647,'ees',14.286,1),(947,7551652,7551647,'esp',14.286,1),(947,7551653,7551647,'spa',14.286,1),(947,7551654,7551647,'pac',14.286,1),(947,7551655,7551647,'ace',14.286,1),(947,7551656,7551649,'dis',50,1),(947,7551657,7551649,'isk',50,1),(947,7551658,7551656,'ind',33.333,1),(947,7551659,7551656,'nde',33.333,1),(947,7551660,7551656,'dex',33.333,1),(947,7551661,7551658,'adm',8.333,1),(947,7551662,7551658,'dmi',8.333,1),(947,7551663,7551658,'min',8.333,1),(947,7551664,7551658,'ini',8.333,1),(947,7551665,7551658,'nis',8.333,1),(947,7551666,7551658,'ist',8.333,1),(947,7551667,7551658,'str',8.333,1),(947,7551668,7551658,'tra',8.333,1),(947,7551669,7551658,'rat',8.333,1),(947,7551670,7551658,'ati',8.333,1),(947,7551671,7551658,'tio',8.333,1),(947,7551672,7551658,'ion',8.333,1),(947,7551673,7551661,'sta',33.333,3),(947,7551674,7551661,'tat',33.333,3),(947,7551675,7551661,'ate',33.333,3),(947,7551676,7551673,'dis',16.667,4),(947,7551677,7551673,'isa',16.667,4),(947,7551678,7551673,'sab',16.667,4),(947,7551679,7551673,'abl',16.667,4),(947,7551680,7551673,'ble',16.667,4),(947,7551681,7551673,'led',16.667,4),(947,7551682,7551676,'cac',33.333,1),(947,7551683,7551676,'ach',33.333,1),(947,7551684,7551676,'che',33.333,1),(947,7551685,7551682,'mod',50,1),(947,7551686,7551682,'ode',50,1),(947,7551687,7551685,'wri',14.286,1),(947,7551688,7551685,'rit',14.286,1),(947,7551689,7551685,'ite',14.286,1),(947,7551690,7551685,'tet',14.286,1),(947,7551691,7551685,'eth',14.286,1),(947,7551692,7551685,'thr',14.286,1),(947,7551693,7551685,'hru',14.286,1),(947,7551694,7551687,'ope',11.111,2),(947,7551695,7551687,'per',11.111,2),(947,7551696,7551687,'era',11.111,2),(947,7551697,7551687,'rat',11.111,2),(947,7551698,7551687,'ati',11.111,2),(947,7551699,7551687,'tio',11.111,2),(947,7551700,7551687,'ion',11.111,2),(947,7551701,7551687,'ona',11.111,2),(947,7551702,7551687,'nal',11.111,2),(947,7551703,7551694,'mes',20,1),(947,7551704,7551694,'ess',20,1),(947,7551705,7551694,'ssa',20,1),(947,7551706,7551694,'sag',20,1),(947,7551707,7551694,'age',20,1),(947,7551708,7551703,'per',11.111,1),(947,7551709,7551703,'erf',11.111,1),(947,7551710,7551703,'rfo',11.111,1),(947,7551711,7551703,'for',11.111,1),(947,7551712,7551703,'orm',11.111,1),(947,7551713,7551703,'rma',11.111,1),(947,7551714,7551703,'man',11.111,1),(947,7551715,7551703,'anc',11.111,1),(947,7551716,7551703,'nce',11.111,1),(947,7551717,7551708,'ide',12.5,1),(947,7551718,7551708,'den',12.5,1),(947,7551719,7551708,'ent',12.5,1),(947,7551720,7551708,'nti',12.5,1),(947,7551721,7551708,'tif',12.5,1),(947,7551722,7551708,'ifi',12.5,1),(947,7551723,7551708,'fie',12.5,1),(947,7551724,7551708,'ier',12.5,1),(947,7551725,7551717,'vdi',33.333,3),(947,7551726,7551717,'dis',33.333,3),(947,7551727,7551717,'isk',33.333,3),(947,7551728,7551725,'nam',50,1),(947,7551729,7551725,'ame',50,1),(947,7551730,7551728,'typ',50,1),(947,7551731,7551728,'ype',50,1),(947,7551732,7551730,'dir',25,1),(947,7551733,7551730,'ire',25,1),(947,7551734,7551730,'rec',25,1),(947,7551735,7551730,'ect',25,1),(948,7551737,7551736,'naa',100,2),(948,7551738,7551737,'600',3.333,3),(948,7551739,7551737,'00a',3.333,3),(948,7551740,7551737,'0a0',3.333,3),(948,7551741,7551737,'a09',3.333,3),(948,7551742,7551737,'098',3.333,3),(948,7551743,7551737,'980',3.333,3),(948,7551744,7551737,'804',3.333,3),(948,7551745,7551737,'044',3.333,3),(948,7551746,7551737,'443',3.333,3),(948,7551747,7551737,'430',3.333,3),(948,7551748,7551737,'307',3.333,3),(948,7551749,7551737,'075',3.333,3),(948,7551750,7551737,'753',3.333,3),(948,7551751,7551737,'535',3.333,3),(948,7551752,7551737,'357',3.333,3),(948,7551753,7551737,'573',3.333,3),(948,7551754,7551737,'732',3.333,3),(948,7551755,7551737,'32b',3.333,3),(948,7551756,7551737,'2b3',3.333,3),(948,7551757,7551737,'b33',3.333,3),(948,7551758,7551737,'334',3.333,3),(948,7551759,7551737,'345',3.333,3),(948,7551760,7551737,'457',3.333,3),(948,7551761,7551737,'571',3.333,3),(948,7551762,7551737,'715',3.333,3),(948,7551763,7551737,'153',3.333,3),(948,7551764,7551737,'533',3.333,3),(948,7551765,7551737,'336',3.333,3),(948,7551766,7551737,'364',3.333,3),(948,7551767,7551737,'645',3.333,3),(948,7551768,7551738,'mon',100,1),(948,7551769,7551768,'201',50,1),(948,7551770,7551768,'013',50,1),(948,7551771,7551769,'adm',33.333,4),(948,7551772,7551769,'dmi',33.333,4),(948,7551773,7551769,'min',33.333,4),(948,7551774,7551771,'cap',16.667,1),(948,7551775,7551771,'apa',16.667,1),(948,7551776,7551771,'pac',16.667,1),(948,7551777,7551771,'aci',16.667,1),(948,7551778,7551771,'cit',16.667,1),(948,7551779,7551771,'ity',16.667,1),(948,7551780,7551774,'pat',50,1),(948,7551781,7551774,'ath',50,1),(948,7551782,7551780,'fre',14.286,1),(948,7551783,7551780,'ree',14.286,1),(948,7551784,7551780,'ees',14.286,1),(948,7551785,7551780,'esp',14.286,1),(948,7551786,7551780,'spa',14.286,1),(948,7551787,7551780,'pac',14.286,1),(948,7551788,7551780,'ace',14.286,1),(948,7551789,7551782,'dis',50,1),(948,7551790,7551782,'isk',50,1),(948,7551791,7551789,'ind',33.333,1),(948,7551792,7551789,'nde',33.333,1),(948,7551793,7551789,'dex',33.333,1),(948,7551794,7551791,'adm',8.333,1),(948,7551795,7551791,'dmi',8.333,1),(948,7551796,7551791,'min',8.333,1),(948,7551797,7551791,'ini',8.333,1),(948,7551798,7551791,'nis',8.333,1),(948,7551799,7551791,'ist',8.333,1),(948,7551800,7551791,'str',8.333,1),(948,7551801,7551791,'tra',8.333,1),(948,7551802,7551791,'rat',8.333,1),(948,7551803,7551791,'ati',8.333,1),(948,7551804,7551791,'tio',8.333,1),(948,7551805,7551791,'ion',8.333,1),(948,7551806,7551794,'sta',33.333,3),(948,7551807,7551794,'tat',33.333,3),(948,7551808,7551794,'ate',33.333,3),(948,7551809,7551806,'dis',16.667,4),(948,7551810,7551806,'isa',16.667,4),(948,7551811,7551806,'sab',16.667,4),(948,7551812,7551806,'abl',16.667,4),(948,7551813,7551806,'ble',16.667,4),(948,7551814,7551806,'led',16.667,4),(948,7551815,7551809,'cac',33.333,1),(948,7551816,7551809,'ach',33.333,1),(948,7551817,7551809,'che',33.333,1),(948,7551818,7551815,'mod',50,1),(948,7551819,7551815,'ode',50,1),(948,7551820,7551818,'wri',14.286,1),(948,7551821,7551818,'rit',14.286,1),(948,7551822,7551818,'ite',14.286,1),(948,7551823,7551818,'tet',14.286,1),(948,7551824,7551818,'eth',14.286,1),(948,7551825,7551818,'thr',14.286,1),(948,7551826,7551818,'hru',14.286,1),(948,7551827,7551820,'ope',11.111,2),(948,7551828,7551820,'per',11.111,2),(948,7551829,7551820,'era',11.111,2),(948,7551830,7551820,'rat',11.111,2),(948,7551831,7551820,'ati',11.111,2),(948,7551832,7551820,'tio',11.111,2),(948,7551833,7551820,'ion',11.111,2),(948,7551834,7551820,'ona',11.111,2),(948,7551835,7551820,'nal',11.111,2),(948,7551836,7551827,'mes',20,1),(948,7551837,7551827,'ess',20,1),(948,7551838,7551827,'ssa',20,1),(948,7551839,7551827,'sag',20,1),(948,7551840,7551827,'age',20,1),(948,7551841,7551836,'per',11.111,1),(948,7551842,7551836,'erf',11.111,1),(948,7551843,7551836,'rfo',11.111,1),(948,7551844,7551836,'for',11.111,1),(948,7551845,7551836,'orm',11.111,1),(948,7551846,7551836,'rma',11.111,1),(948,7551847,7551836,'man',11.111,1),(948,7551848,7551836,'anc',11.111,1),(948,7551849,7551836,'nce',11.111,1),(948,7551850,7551841,'ide',12.5,1),(948,7551851,7551841,'den',12.5,1),(948,7551852,7551841,'ent',12.5,1),(948,7551853,7551841,'nti',12.5,1),(948,7551854,7551841,'tif',12.5,1),(948,7551855,7551841,'ifi',12.5,1),(948,7551856,7551841,'fie',12.5,1),(948,7551857,7551841,'ier',12.5,1),(948,7551858,7551850,'vdi',33.333,3),(948,7551859,7551850,'dis',33.333,3),(948,7551860,7551850,'isk',33.333,3),(948,7551861,7551858,'nam',50,1),(948,7551862,7551858,'ame',50,1),(948,7551863,7551861,'typ',50,1),(948,7551864,7551861,'ype',50,1),(948,7551865,7551863,'dir',25,1),(948,7551866,7551863,'ire',25,1),(948,7551867,7551863,'rec',25,1),(948,7551868,7551863,'ect',25,1),(949,7551870,7551869,'naa',100,2),(949,7551871,7551870,'600',3.333,3),(949,7551872,7551870,'000',3.333,3),(949,7551873,7551870,'00c',3.333,3),(949,7551874,7551870,'0c2',3.333,3),(949,7551875,7551870,'c29',3.333,3),(949,7551876,7551870,'29b',3.333,3),(949,7551877,7551870,'9b9',3.333,3),(949,7551878,7551870,'b9f',3.333,3),(949,7551879,7551870,'9fd',3.333,3),(949,7551880,7551870,'fd2',3.333,3),(949,7551881,7551870,'d25',3.333,3),(949,7551882,7551870,'259',3.333,3),(949,7551883,7551870,'59d',3.333,3),(949,7551884,7551870,'9d2',3.333,3),(949,7551885,7551870,'d20',3.333,3),(949,7551886,7551870,'208',3.333,3),(949,7551887,7551870,'08e',3.333,3),(949,7551888,7551870,'8e4',3.333,3),(949,7551889,7551870,'e44',3.333,3),(949,7551890,7551870,'444',3.333,3),(949,7551891,7551870,'444',3.333,3),(949,7551892,7551870,'442',3.333,3),(949,7551893,7551870,'42f',3.333,3),(949,7551894,7551870,'2f3',3.333,3),(949,7551895,7551870,'f34',3.333,3),(949,7551896,7551870,'341',3.333,3),(949,7551897,7551870,'418',3.333,3),(949,7551898,7551870,'188',3.333,3),(949,7551899,7551870,'887',3.333,3),(949,7551900,7551870,'873',3.333,3),(949,7551901,7551871,'mon',100,1),(949,7551902,7551901,'201',50,1),(949,7551903,7551901,'013',50,1),(949,7551904,7551902,'adm',33.333,4),(949,7551905,7551902,'dmi',33.333,4),(949,7551906,7551902,'min',33.333,4),(949,7551907,7551904,'cap',16.667,1),(949,7551908,7551904,'apa',16.667,1),(949,7551909,7551904,'pac',16.667,1),(949,7551910,7551904,'aci',16.667,1),(949,7551911,7551904,'cit',16.667,1),(949,7551912,7551904,'ity',16.667,1),(949,7551913,7551907,'pat',50,1),(949,7551914,7551907,'ath',50,1),(949,7551915,7551913,'fre',14.286,1),(949,7551916,7551913,'ree',14.286,1),(949,7551917,7551913,'ees',14.286,1),(949,7551918,7551913,'esp',14.286,1),(949,7551919,7551913,'spa',14.286,1),(949,7551920,7551913,'pac',14.286,1),(949,7551921,7551913,'ace',14.286,1),(949,7551922,7551915,'dis',50,1),(949,7551923,7551915,'isk',50,1),(949,7551924,7551922,'ind',33.333,1),(949,7551925,7551922,'nde',33.333,1),(949,7551926,7551922,'dex',33.333,1),(949,7551927,7551924,'adm',8.333,1),(949,7551928,7551924,'dmi',8.333,1),(949,7551929,7551924,'min',8.333,1),(949,7551930,7551924,'ini',8.333,1),(949,7551931,7551924,'nis',8.333,1),(949,7551932,7551924,'ist',8.333,1),(949,7551933,7551924,'str',8.333,1),(949,7551934,7551924,'tra',8.333,1),(949,7551935,7551924,'rat',8.333,1),(949,7551936,7551924,'ati',8.333,1),(949,7551937,7551924,'tio',8.333,1),(949,7551938,7551924,'ion',8.333,1),(949,7551939,7551927,'sta',33.333,3),(949,7551940,7551927,'tat',33.333,3),(949,7551941,7551927,'ate',33.333,3),(949,7551942,7551939,'dis',16.667,4),(949,7551943,7551939,'isa',16.667,4),(949,7551944,7551939,'sab',16.667,4),(949,7551945,7551939,'abl',16.667,4),(949,7551946,7551939,'ble',16.667,4),(949,7551947,7551939,'led',16.667,4),(949,7551948,7551942,'cac',33.333,1),(949,7551949,7551942,'ach',33.333,1),(949,7551950,7551942,'che',33.333,1),(949,7551951,7551948,'mod',50,1),(949,7551952,7551948,'ode',50,1),(949,7551953,7551951,'wri',14.286,1),(949,7551954,7551951,'rit',14.286,1),(949,7551955,7551951,'ite',14.286,1),(949,7551956,7551951,'tet',14.286,1),(949,7551957,7551951,'eth',14.286,1),(949,7551958,7551951,'thr',14.286,1),(949,7551959,7551951,'hru',14.286,1),(949,7551960,7551953,'ope',11.111,2),(949,7551961,7551953,'per',11.111,2),(949,7551962,7551953,'era',11.111,2),(949,7551963,7551953,'rat',11.111,2),(949,7551964,7551953,'ati',11.111,2),(949,7551965,7551953,'tio',11.111,2),(949,7551966,7551953,'ion',11.111,2),(949,7551967,7551953,'ona',11.111,2),(949,7551968,7551953,'nal',11.111,2),(949,7551969,7551960,'mes',20,1),(949,7551970,7551960,'ess',20,1),(949,7551971,7551960,'ssa',20,1),(949,7551972,7551960,'sag',20,1),(949,7551973,7551960,'age',20,1),(949,7551974,7551969,'per',11.111,1),(949,7551975,7551969,'erf',11.111,1),(949,7551976,7551969,'rfo',11.111,1),(949,7551977,7551969,'for',11.111,1),(949,7551978,7551969,'orm',11.111,1),(949,7551979,7551969,'rma',11.111,1),(949,7551980,7551969,'man',11.111,1),(949,7551981,7551969,'anc',11.111,1),(949,7551982,7551969,'nce',11.111,1),(949,7551983,7551974,'ide',12.5,1),(949,7551984,7551974,'den',12.5,1),(949,7551985,7551974,'ent',12.5,1),(949,7551986,7551974,'nti',12.5,1),(949,7551987,7551974,'tif',12.5,1),(949,7551988,7551974,'ifi',12.5,1),(949,7551989,7551974,'fie',12.5,1),(949,7551990,7551974,'ier',12.5,1),(949,7551991,7551983,'vdi',33.333,3),(949,7551992,7551983,'dis',33.333,3),(949,7551993,7551983,'isk',33.333,3),(949,7551994,7551991,'nam',50,1),(949,7551995,7551991,'ame',50,1),(949,7551996,7551994,'typ',50,1),(949,7551997,7551994,'ype',50,1),(949,7551998,7551996,'dir',25,1),(949,7551999,7551996,'ire',25,1),(949,7552000,7551996,'rec',25,1),(949,7552001,7551996,'ect',25,1),(950,7552003,7552002,'naa',100,2),(950,7552004,7552003,'600',3.333,3),(950,7552005,7552003,'000',3.333,3),(950,7552006,7552003,'00c',3.333,3),(950,7552007,7552003,'0c2',3.333,3),(950,7552008,7552003,'c29',3.333,3),(950,7552009,7552003,'295',3.333,3),(950,7552010,7552003,'95c',3.333,3),(950,7552011,7552003,'5c0',3.333,3),(950,7552012,7552003,'c0f',3.333,3),(950,7552013,7552003,'0fc',3.333,3),(950,7552014,7552003,'fce',3.333,3),(950,7552015,7552003,'ce5',3.333,3),(950,7552016,7552003,'e57',3.333,3),(950,7552017,7552003,'57f',3.333,3),(950,7552018,7552003,'7fd',3.333,3),(950,7552019,7552003,'fd2',3.333,3),(950,7552020,7552003,'d2e',3.333,3),(950,7552021,7552003,'2e7',3.333,3),(950,7552022,7552003,'e75',3.333,3),(950,7552023,7552003,'753',3.333,3),(950,7552024,7552003,'535',3.333,3),(950,7552025,7552003,'355',3.333,3),(950,7552026,7552003,'554',3.333,3),(950,7552027,7552003,'542',3.333,3),(950,7552028,7552003,'42a',3.333,3),(950,7552029,7552003,'2a8',3.333,3),(950,7552030,7552003,'a85',3.333,3),(950,7552031,7552003,'851',3.333,3),(950,7552032,7552003,'516',3.333,3),(950,7552033,7552003,'16a',3.333,3),(950,7552034,7552004,'mon',100,1),(950,7552035,7552034,'201',50,1),(950,7552036,7552034,'013',50,1),(950,7552037,7552035,'adm',33.333,4),(950,7552038,7552035,'dmi',33.333,4),(950,7552039,7552035,'min',33.333,4),(950,7552040,7552037,'cap',16.667,1),(950,7552041,7552037,'apa',16.667,1),(950,7552042,7552037,'pac',16.667,1),(950,7552043,7552037,'aci',16.667,1),(950,7552044,7552037,'cit',16.667,1),(950,7552045,7552037,'ity',16.667,1),(950,7552046,7552040,'pat',50,1),(950,7552047,7552040,'ath',50,1),(950,7552048,7552046,'fre',14.286,1),(950,7552049,7552046,'ree',14.286,1),(950,7552050,7552046,'ees',14.286,1),(950,7552051,7552046,'esp',14.286,1),(950,7552052,7552046,'spa',14.286,1),(950,7552053,7552046,'pac',14.286,1),(950,7552054,7552046,'ace',14.286,1),(950,7552055,7552048,'dis',50,1),(950,7552056,7552048,'isk',50,1),(950,7552057,7552055,'ind',33.333,1),(950,7552058,7552055,'nde',33.333,1),(950,7552059,7552055,'dex',33.333,1),(950,7552060,7552057,'adm',8.333,1),(950,7552061,7552057,'dmi',8.333,1),(950,7552062,7552057,'min',8.333,1),(950,7552063,7552057,'ini',8.333,1),(950,7552064,7552057,'nis',8.333,1),(950,7552065,7552057,'ist',8.333,1),(950,7552066,7552057,'str',8.333,1),(950,7552067,7552057,'tra',8.333,1),(950,7552068,7552057,'rat',8.333,1),(950,7552069,7552057,'ati',8.333,1),(950,7552070,7552057,'tio',8.333,1),(950,7552071,7552057,'ion',8.333,1),(950,7552072,7552060,'sta',33.333,3),(950,7552073,7552060,'tat',33.333,3),(950,7552074,7552060,'ate',33.333,3),(950,7552075,7552072,'dis',16.667,4),(950,7552076,7552072,'isa',16.667,4),(950,7552077,7552072,'sab',16.667,4),(950,7552078,7552072,'abl',16.667,4),(950,7552079,7552072,'ble',16.667,4),(950,7552080,7552072,'led',16.667,4),(950,7552081,7552075,'cac',33.333,1),(950,7552082,7552075,'ach',33.333,1),(950,7552083,7552075,'che',33.333,1),(950,7552084,7552081,'mod',50,1),(950,7552085,7552081,'ode',50,1),(950,7552086,7552084,'wri',14.286,1),(950,7552087,7552084,'rit',14.286,1),(950,7552088,7552084,'ite',14.286,1),(950,7552089,7552084,'tet',14.286,1),(950,7552090,7552084,'eth',14.286,1),(950,7552091,7552084,'thr',14.286,1),(950,7552092,7552084,'hru',14.286,1),(950,7552093,7552086,'ope',11.111,2),(950,7552094,7552086,'per',11.111,2),(950,7552095,7552086,'era',11.111,2),(950,7552096,7552086,'rat',11.111,2),(950,7552097,7552086,'ati',11.111,2),(950,7552098,7552086,'tio',11.111,2),(950,7552099,7552086,'ion',11.111,2),(950,7552100,7552086,'ona',11.111,2),(950,7552101,7552086,'nal',11.111,2),(950,7552102,7552093,'mes',20,1),(950,7552103,7552093,'ess',20,1),(950,7552104,7552093,'ssa',20,1),(950,7552105,7552093,'sag',20,1),(950,7552106,7552093,'age',20,1),(950,7552107,7552102,'per',11.111,1),(950,7552108,7552102,'erf',11.111,1),(950,7552109,7552102,'rfo',11.111,1),(950,7552110,7552102,'for',11.111,1),(950,7552111,7552102,'orm',11.111,1),(950,7552112,7552102,'rma',11.111,1),(950,7552113,7552102,'man',11.111,1),(950,7552114,7552102,'anc',11.111,1),(950,7552115,7552102,'nce',11.111,1),(950,7552116,7552107,'ide',12.5,1),(950,7552117,7552107,'den',12.5,1),(950,7552118,7552107,'ent',12.5,1),(950,7552119,7552107,'nti',12.5,1),(950,7552120,7552107,'tif',12.5,1),(950,7552121,7552107,'ifi',12.5,1),(950,7552122,7552107,'fie',12.5,1),(950,7552123,7552107,'ier',12.5,1),(950,7552124,7552116,'vdi',33.333,3),(950,7552125,7552116,'dis',33.333,3),(950,7552126,7552116,'isk',33.333,3),(950,7552127,7552124,'nam',50,1),(950,7552128,7552124,'ame',50,1),(950,7552129,7552127,'typ',50,1),(950,7552130,7552127,'ype',50,1),(950,7552131,7552129,'dir',25,1),(950,7552132,7552129,'ire',25,1),(950,7552133,7552129,'rec',25,1),(950,7552134,7552129,'ect',25,1),(951,7552136,7552135,'naa',100,2),(951,7552137,7552136,'600',3.333,3),(951,7552138,7552136,'000',3.333,3),(951,7552139,7552136,'00c',3.333,3),(951,7552140,7552136,'0c2',3.333,3),(951,7552141,7552136,'c29',3.333,3),(951,7552142,7552136,'294',3.333,3),(951,7552143,7552136,'949',3.333,3),(951,7552144,7552136,'497',3.333,3),(951,7552145,7552136,'977',3.333,3),(951,7552146,7552136,'772',3.333,3),(951,7552147,7552136,'727',3.333,3),(951,7552148,7552136,'277',3.333,3),(951,7552149,7552136,'770',3.333,3),(951,7552150,7552136,'709',3.333,3),(951,7552151,7552136,'095',3.333,3),(951,7552152,7552136,'95f',3.333,3),(951,7552153,7552136,'5fb',3.333,3),(951,7552154,7552136,'fb9',3.333,3),(951,7552155,7552136,'b92',3.333,3),(951,7552156,7552136,'92e',3.333,3),(951,7552157,7552136,'2e5',3.333,3),(951,7552158,7552136,'e5f',3.333,3),(951,7552159,7552136,'5f0',3.333,3),(951,7552160,7552136,'f0e',3.333,3),(951,7552161,7552136,'0eb',3.333,3),(951,7552162,7552136,'eb7',3.333,3),(951,7552163,7552136,'b7a',3.333,3),(951,7552164,7552136,'7ad',3.333,3),(951,7552165,7552136,'ada',3.333,3),(951,7552166,7552136,'da9',3.333,3),(951,7552167,7552137,'mon',100,1),(951,7552168,7552167,'201',50,1),(951,7552169,7552167,'013',50,1),(951,7552170,7552168,'adm',33.333,4),(951,7552171,7552168,'dmi',33.333,4),(951,7552172,7552168,'min',33.333,4),(951,7552173,7552170,'cap',16.667,1),(951,7552174,7552170,'apa',16.667,1),(951,7552175,7552170,'pac',16.667,1),(951,7552176,7552170,'aci',16.667,1),(951,7552177,7552170,'cit',16.667,1),(951,7552178,7552170,'ity',16.667,1),(951,7552179,7552173,'pat',50,1),(951,7552180,7552173,'ath',50,1),(951,7552181,7552179,'fre',14.286,1),(951,7552182,7552179,'ree',14.286,1),(951,7552183,7552179,'ees',14.286,1),(951,7552184,7552179,'esp',14.286,1),(951,7552185,7552179,'spa',14.286,1),(951,7552186,7552179,'pac',14.286,1),(951,7552187,7552179,'ace',14.286,1),(951,7552188,7552181,'dis',50,1),(951,7552189,7552181,'isk',50,1),(951,7552190,7552188,'ind',33.333,1),(951,7552191,7552188,'nde',33.333,1),(951,7552192,7552188,'dex',33.333,1),(951,7552193,7552190,'adm',8.333,1),(951,7552194,7552190,'dmi',8.333,1),(951,7552195,7552190,'min',8.333,1),(951,7552196,7552190,'ini',8.333,1),(951,7552197,7552190,'nis',8.333,1),(951,7552198,7552190,'ist',8.333,1),(951,7552199,7552190,'str',8.333,1),(951,7552200,7552190,'tra',8.333,1),(951,7552201,7552190,'rat',8.333,1),(951,7552202,7552190,'ati',8.333,1),(951,7552203,7552190,'tio',8.333,1),(951,7552204,7552190,'ion',8.333,1),(951,7552205,7552193,'sta',33.333,3),(951,7552206,7552193,'tat',33.333,3),(951,7552207,7552193,'ate',33.333,3),(951,7552208,7552205,'dis',16.667,4),(951,7552209,7552205,'isa',16.667,4),(951,7552210,7552205,'sab',16.667,4),(951,7552211,7552205,'abl',16.667,4),(951,7552212,7552205,'ble',16.667,4),(951,7552213,7552205,'led',16.667,4),(951,7552214,7552208,'cac',33.333,1),(951,7552215,7552208,'ach',33.333,1),(951,7552216,7552208,'che',33.333,1),(951,7552217,7552214,'mod',50,1),(951,7552218,7552214,'ode',50,1),(951,7552219,7552217,'wri',14.286,1),(951,7552220,7552217,'rit',14.286,1),(951,7552221,7552217,'ite',14.286,1),(951,7552222,7552217,'tet',14.286,1),(951,7552223,7552217,'eth',14.286,1),(951,7552224,7552217,'thr',14.286,1),(951,7552225,7552217,'hru',14.286,1),(951,7552226,7552219,'ope',11.111,2),(951,7552227,7552219,'per',11.111,2),(951,7552228,7552219,'era',11.111,2),(951,7552229,7552219,'rat',11.111,2),(951,7552230,7552219,'ati',11.111,2),(951,7552231,7552219,'tio',11.111,2),(951,7552232,7552219,'ion',11.111,2),(951,7552233,7552219,'ona',11.111,2),(951,7552234,7552219,'nal',11.111,2),(951,7552235,7552226,'mes',20,1),(951,7552236,7552226,'ess',20,1),(951,7552237,7552226,'ssa',20,1),(951,7552238,7552226,'sag',20,1),(951,7552239,7552226,'age',20,1),(951,7552240,7552235,'per',11.111,1),(951,7552241,7552235,'erf',11.111,1),(951,7552242,7552235,'rfo',11.111,1),(951,7552243,7552235,'for',11.111,1),(951,7552244,7552235,'orm',11.111,1),(951,7552245,7552235,'rma',11.111,1),(951,7552246,7552235,'man',11.111,1),(951,7552247,7552235,'anc',11.111,1),(951,7552248,7552235,'nce',11.111,1),(951,7552249,7552240,'ide',12.5,1),(951,7552250,7552240,'den',12.5,1),(951,7552251,7552240,'ent',12.5,1),(951,7552252,7552240,'nti',12.5,1),(951,7552253,7552240,'tif',12.5,1),(951,7552254,7552240,'ifi',12.5,1),(951,7552255,7552240,'fie',12.5,1),(951,7552256,7552240,'ier',12.5,1),(951,7552257,7552249,'vdi',33.333,3),(951,7552258,7552249,'dis',33.333,3),(951,7552259,7552249,'isk',33.333,3),(951,7552260,7552257,'nam',50,1),(951,7552261,7552257,'ame',50,1),(951,7552262,7552260,'typ',50,1),(951,7552263,7552260,'ype',50,1),(951,7552264,7552262,'dir',25,1),(951,7552265,7552262,'ire',25,1),(951,7552266,7552262,'rec',25,1),(951,7552267,7552262,'ect',25,1),(952,7552269,7552268,'naa',100,2),(952,7552270,7552269,'600',3.333,3),(952,7552271,7552269,'000',3.333,3),(952,7552272,7552269,'00c',3.333,3),(952,7552273,7552269,'0c2',3.333,3),(952,7552274,7552269,'c29',3.333,3),(952,7552275,7552269,'29b',3.333,3),(952,7552276,7552269,'9bc',3.333,3),(952,7552277,7552269,'bcb',3.333,3),(952,7552278,7552269,'cb6',3.333,3),(952,7552279,7552269,'b6f',3.333,3),(952,7552280,7552269,'6f6',3.333,3),(952,7552281,7552269,'f6c',3.333,3),(952,7552282,7552269,'6ce',3.333,3),(952,7552283,7552269,'ced',3.333,3),(952,7552284,7552269,'ed8',3.333,3),(952,7552285,7552269,'d8a',3.333,3),(952,7552286,7552269,'8ab',3.333,3),(952,7552287,7552269,'ab1',3.333,3),(952,7552288,7552269,'b1d',3.333,3),(952,7552289,7552269,'1d5',3.333,3),(952,7552290,7552269,'d52',3.333,3),(952,7552291,7552269,'52e',3.333,3),(952,7552292,7552269,'2e9',3.333,3),(952,7552293,7552269,'e95',3.333,3),(952,7552294,7552269,'954',3.333,3),(952,7552295,7552269,'54a',3.333,3),(952,7552296,7552269,'4a8',3.333,3),(952,7552297,7552269,'a88',3.333,3),(952,7552298,7552269,'883',3.333,3),(952,7552299,7552269,'833',3.333,3),(952,7552300,7552270,'mon',100,1),(952,7552301,7552300,'201',50,1),(952,7552302,7552300,'013',50,1),(952,7552303,7552301,'adm',33.333,4),(952,7552304,7552301,'dmi',33.333,4),(952,7552305,7552301,'min',33.333,4),(952,7552306,7552303,'cap',16.667,1),(952,7552307,7552303,'apa',16.667,1),(952,7552308,7552303,'pac',16.667,1),(952,7552309,7552303,'aci',16.667,1),(952,7552310,7552303,'cit',16.667,1),(952,7552311,7552303,'ity',16.667,1),(952,7552312,7552306,'pat',50,1),(952,7552313,7552306,'ath',50,1),(952,7552314,7552312,'fre',14.286,1),(952,7552315,7552312,'ree',14.286,1),(952,7552316,7552312,'ees',14.286,1),(952,7552317,7552312,'esp',14.286,1),(952,7552318,7552312,'spa',14.286,1),(952,7552319,7552312,'pac',14.286,1),(952,7552320,7552312,'ace',14.286,1),(952,7552321,7552314,'dis',50,1),(952,7552322,7552314,'isk',50,1),(952,7552323,7552321,'ind',33.333,1),(952,7552324,7552321,'nde',33.333,1),(952,7552325,7552321,'dex',33.333,1),(952,7552326,7552323,'adm',8.333,1),(952,7552327,7552323,'dmi',8.333,1),(952,7552328,7552323,'min',8.333,1),(952,7552329,7552323,'ini',8.333,1),(952,7552330,7552323,'nis',8.333,1),(952,7552331,7552323,'ist',8.333,1),(952,7552332,7552323,'str',8.333,1),(952,7552333,7552323,'tra',8.333,1),(952,7552334,7552323,'rat',8.333,1),(952,7552335,7552323,'ati',8.333,1),(952,7552336,7552323,'tio',8.333,1),(952,7552337,7552323,'ion',8.333,1),(952,7552338,7552326,'sta',33.333,3),(952,7552339,7552326,'tat',33.333,3),(952,7552340,7552326,'ate',33.333,3),(952,7552341,7552338,'dis',16.667,4),(952,7552342,7552338,'isa',16.667,4),(952,7552343,7552338,'sab',16.667,4),(952,7552344,7552338,'abl',16.667,4),(952,7552345,7552338,'ble',16.667,4),(952,7552346,7552338,'led',16.667,4),(952,7552347,7552341,'cac',33.333,1),(952,7552348,7552341,'ach',33.333,1),(952,7552349,7552341,'che',33.333,1),(952,7552350,7552347,'mod',50,1),(952,7552351,7552347,'ode',50,1),(952,7552352,7552350,'wri',14.286,1),(952,7552353,7552350,'rit',14.286,1),(952,7552354,7552350,'ite',14.286,1),(952,7552355,7552350,'tet',14.286,1),(952,7552356,7552350,'eth',14.286,1),(952,7552357,7552350,'thr',14.286,1),(952,7552358,7552350,'hru',14.286,1),(952,7552359,7552352,'ope',11.111,2),(952,7552360,7552352,'per',11.111,2),(952,7552361,7552352,'era',11.111,2),(952,7552362,7552352,'rat',11.111,2),(952,7552363,7552352,'ati',11.111,2),(952,7552364,7552352,'tio',11.111,2),(952,7552365,7552352,'ion',11.111,2),(952,7552366,7552352,'ona',11.111,2),(952,7552367,7552352,'nal',11.111,2),(952,7552368,7552359,'mes',20,1),(952,7552369,7552359,'ess',20,1),(952,7552370,7552359,'ssa',20,1),(952,7552371,7552359,'sag',20,1),(952,7552372,7552359,'age',20,1),(952,7552373,7552368,'per',11.111,1),(952,7552374,7552368,'erf',11.111,1),(952,7552375,7552368,'rfo',11.111,1),(952,7552376,7552368,'for',11.111,1),(952,7552377,7552368,'orm',11.111,1),(952,7552378,7552368,'rma',11.111,1),(952,7552379,7552368,'man',11.111,1),(952,7552380,7552368,'anc',11.111,1),(952,7552381,7552368,'nce',11.111,1),(952,7552382,7552373,'ide',12.5,1),(952,7552383,7552373,'den',12.5,1),(952,7552384,7552373,'ent',12.5,1),(952,7552385,7552373,'nti',12.5,1),(952,7552386,7552373,'tif',12.5,1),(952,7552387,7552373,'ifi',12.5,1),(952,7552388,7552373,'fie',12.5,1),(952,7552389,7552373,'ier',12.5,1),(952,7552390,7552382,'vdi',33.333,3),(952,7552391,7552382,'dis',33.333,3),(952,7552392,7552382,'isk',33.333,3),(952,7552393,7552390,'nam',50,1),(952,7552394,7552390,'ame',50,1),(952,7552395,7552393,'typ',50,1),(952,7552396,7552393,'ype',50,1),(952,7552397,7552395,'dir',25,1),(952,7552398,7552395,'ire',25,1),(952,7552399,7552395,'rec',25,1),(952,7552400,7552395,'ect',25,1),(953,7552402,7552401,'naa',100,2),(953,7552403,7552402,'600',3.333,3),(953,7552404,7552402,'000',3.333,3),(953,7552405,7552402,'00c',3.333,3),(953,7552406,7552402,'0c2',3.333,3),(953,7552407,7552402,'c29',3.333,3),(953,7552408,7552402,'29a',3.333,3),(953,7552409,7552402,'9aa',3.333,3),(953,7552410,7552402,'aad',3.333,3),(953,7552411,7552402,'adc',3.333,3),(953,7552412,7552402,'dc1',3.333,3),(953,7552413,7552402,'c13',3.333,3),(953,7552414,7552402,'132',3.333,3),(953,7552415,7552402,'328',3.333,3),(953,7552416,7552402,'286',3.333,3),(953,7552417,7552402,'862',3.333,3),(953,7552418,7552402,'62a',3.333,3),(953,7552419,7552402,'2ab',3.333,3),(953,7552420,7552402,'ab5',3.333,3),(953,7552421,7552402,'b5a',3.333,3),(953,7552422,7552402,'5a0',3.333,3),(953,7552423,7552402,'a04',3.333,3),(953,7552424,7552402,'049',3.333,3),(953,7552425,7552402,'493',3.333,3),(953,7552426,7552402,'93d',3.333,3),(953,7552427,7552402,'3d8',3.333,3),(953,7552428,7552402,'d83',3.333,3),(953,7552429,7552402,'832',3.333,3),(953,7552430,7552402,'32a',3.333,3),(953,7552431,7552402,'2a5',3.333,3),(953,7552432,7552402,'a58',3.333,3),(953,7552433,7552403,'mon',100,1),(953,7552434,7552433,'201',50,1),(953,7552435,7552433,'013',50,1),(953,7552436,7552434,'adm',33.333,4),(953,7552437,7552434,'dmi',33.333,4),(953,7552438,7552434,'min',33.333,4),(953,7552439,7552436,'cap',16.667,1),(953,7552440,7552436,'apa',16.667,1),(953,7552441,7552436,'pac',16.667,1),(953,7552442,7552436,'aci',16.667,1),(953,7552443,7552436,'cit',16.667,1),(953,7552444,7552436,'ity',16.667,1),(953,7552445,7552439,'pat',50,1),(953,7552446,7552439,'ath',50,1),(953,7552447,7552445,'fre',14.286,1),(953,7552448,7552445,'ree',14.286,1),(953,7552449,7552445,'ees',14.286,1),(953,7552450,7552445,'esp',14.286,1),(953,7552451,7552445,'spa',14.286,1),(953,7552452,7552445,'pac',14.286,1),(953,7552453,7552445,'ace',14.286,1),(953,7552454,7552447,'dis',50,1),(953,7552455,7552447,'isk',50,1),(953,7552456,7552454,'ind',33.333,1),(953,7552457,7552454,'nde',33.333,1),(953,7552458,7552454,'dex',33.333,1),(953,7552459,7552456,'adm',8.333,1),(953,7552460,7552456,'dmi',8.333,1),(953,7552461,7552456,'min',8.333,1),(953,7552462,7552456,'ini',8.333,1),(953,7552463,7552456,'nis',8.333,1),(953,7552464,7552456,'ist',8.333,1),(953,7552465,7552456,'str',8.333,1),(953,7552466,7552456,'tra',8.333,1),(953,7552467,7552456,'rat',8.333,1),(953,7552468,7552456,'ati',8.333,1),(953,7552469,7552456,'tio',8.333,1),(953,7552470,7552456,'ion',8.333,1),(953,7552471,7552459,'sta',33.333,3),(953,7552472,7552459,'tat',33.333,3),(953,7552473,7552459,'ate',33.333,3),(953,7552474,7552471,'dis',16.667,4),(953,7552475,7552471,'isa',16.667,4),(953,7552476,7552471,'sab',16.667,4),(953,7552477,7552471,'abl',16.667,4),(953,7552478,7552471,'ble',16.667,4),(953,7552479,7552471,'led',16.667,4),(953,7552480,7552474,'cac',33.333,1),(953,7552481,7552474,'ach',33.333,1),(953,7552482,7552474,'che',33.333,1),(953,7552483,7552480,'mod',50,1),(953,7552484,7552480,'ode',50,1),(953,7552485,7552483,'wri',14.286,1),(953,7552486,7552483,'rit',14.286,1),(953,7552487,7552483,'ite',14.286,1),(953,7552488,7552483,'tet',14.286,1),(953,7552489,7552483,'eth',14.286,1),(953,7552490,7552483,'thr',14.286,1),(953,7552491,7552483,'hru',14.286,1),(953,7552492,7552485,'ope',11.111,2),(953,7552493,7552485,'per',11.111,2),(953,7552494,7552485,'era',11.111,2),(953,7552495,7552485,'rat',11.111,2),(953,7552496,7552485,'ati',11.111,2),(953,7552497,7552485,'tio',11.111,2),(953,7552498,7552485,'ion',11.111,2),(953,7552499,7552485,'ona',11.111,2),(953,7552500,7552485,'nal',11.111,2),(953,7552501,7552492,'mes',20,1),(953,7552502,7552492,'ess',20,1),(953,7552503,7552492,'ssa',20,1),(953,7552504,7552492,'sag',20,1),(953,7552505,7552492,'age',20,1),(953,7552506,7552501,'per',11.111,1),(953,7552507,7552501,'erf',11.111,1),(953,7552508,7552501,'rfo',11.111,1),(953,7552509,7552501,'for',11.111,1),(953,7552510,7552501,'orm',11.111,1),(953,7552511,7552501,'rma',11.111,1),(953,7552512,7552501,'man',11.111,1),(953,7552513,7552501,'anc',11.111,1),(953,7552514,7552501,'nce',11.111,1),(953,7552515,7552506,'ide',12.5,1),(953,7552516,7552506,'den',12.5,1),(953,7552517,7552506,'ent',12.5,1),(953,7552518,7552506,'nti',12.5,1),(953,7552519,7552506,'tif',12.5,1),(953,7552520,7552506,'ifi',12.5,1),(953,7552521,7552506,'fie',12.5,1),(953,7552522,7552506,'ier',12.5,1),(953,7552523,7552515,'vdi',33.333,3),(953,7552524,7552515,'dis',33.333,3),(953,7552525,7552515,'isk',33.333,3),(953,7552526,7552523,'nam',50,1),(953,7552527,7552523,'ame',50,1),(953,7552528,7552526,'typ',50,1),(953,7552529,7552526,'ype',50,1),(953,7552530,7552528,'dir',25,1),(953,7552531,7552528,'ire',25,1),(953,7552532,7552528,'rec',25,1),(953,7552533,7552528,'ect',25,1),(954,7552535,7552534,'naa',100,2),(954,7552536,7552535,'600',3.333,3),(954,7552537,7552535,'000',3.333,3),(954,7552538,7552535,'00c',3.333,3),(954,7552539,7552535,'0c2',3.333,3),(954,7552540,7552535,'c29',3.333,3),(954,7552541,7552535,'292',3.333,3),(954,7552542,7552535,'92d',3.333,3),(954,7552543,7552535,'2d8',3.333,3),(954,7552544,7552535,'d82',3.333,3),(954,7552545,7552535,'82e',3.333,3),(954,7552546,7552535,'2e3',3.333,3),(954,7552547,7552535,'e31',3.333,3),(954,7552548,7552535,'316',3.333,3),(954,7552549,7552535,'164',3.333,3),(954,7552550,7552535,'647',3.333,3),(954,7552551,7552535,'474',3.333,3),(954,7552552,7552535,'745',3.333,3),(954,7552553,7552535,'45d',3.333,3),(954,7552554,7552535,'5d8',3.333,3),(954,7552555,7552535,'d8c',3.333,3),(954,7552556,7552535,'8ca',3.333,3),(954,7552557,7552535,'ca6',3.333,3),(954,7552558,7552535,'a63',3.333,3),(954,7552559,7552535,'63e',3.333,3),(954,7552560,7552535,'3e7',3.333,3),(954,7552561,7552535,'e78',3.333,3),(954,7552562,7552535,'78d',3.333,3),(954,7552563,7552535,'8d3',3.333,3),(954,7552564,7552535,'d3a',3.333,3),(954,7552565,7552535,'3a8',3.333,3),(954,7552566,7552536,'mon',100,1),(954,7552567,7552566,'201',50,1),(954,7552568,7552566,'013',50,1),(954,7552569,7552567,'adm',33.333,4),(954,7552570,7552567,'dmi',33.333,4),(954,7552571,7552567,'min',33.333,4),(954,7552572,7552569,'cap',16.667,1),(954,7552573,7552569,'apa',16.667,1),(954,7552574,7552569,'pac',16.667,1),(954,7552575,7552569,'aci',16.667,1),(954,7552576,7552569,'cit',16.667,1),(954,7552577,7552569,'ity',16.667,1),(954,7552578,7552572,'pat',50,1),(954,7552579,7552572,'ath',50,1),(954,7552580,7552578,'fre',14.286,1),(954,7552581,7552578,'ree',14.286,1),(954,7552582,7552578,'ees',14.286,1),(954,7552583,7552578,'esp',14.286,1),(954,7552584,7552578,'spa',14.286,1),(954,7552585,7552578,'pac',14.286,1),(954,7552586,7552578,'ace',14.286,1),(954,7552587,7552580,'dis',50,1),(954,7552588,7552580,'isk',50,1),(954,7552589,7552587,'ind',33.333,1),(954,7552590,7552587,'nde',33.333,1),(954,7552591,7552587,'dex',33.333,1),(954,7552592,7552589,'adm',8.333,1),(954,7552593,7552589,'dmi',8.333,1),(954,7552594,7552589,'min',8.333,1),(954,7552595,7552589,'ini',8.333,1),(954,7552596,7552589,'nis',8.333,1),(954,7552597,7552589,'ist',8.333,1),(954,7552598,7552589,'str',8.333,1),(954,7552599,7552589,'tra',8.333,1),(954,7552600,7552589,'rat',8.333,1),(954,7552601,7552589,'ati',8.333,1),(954,7552602,7552589,'tio',8.333,1),(954,7552603,7552589,'ion',8.333,1),(954,7552604,7552592,'sta',33.333,3),(954,7552605,7552592,'tat',33.333,3),(954,7552606,7552592,'ate',33.333,3),(954,7552607,7552604,'dis',16.667,4),(954,7552608,7552604,'isa',16.667,4),(954,7552609,7552604,'sab',16.667,4),(954,7552610,7552604,'abl',16.667,4),(954,7552611,7552604,'ble',16.667,4),(954,7552612,7552604,'led',16.667,4),(954,7552613,7552607,'cac',33.333,1),(954,7552614,7552607,'ach',33.333,1),(954,7552615,7552607,'che',33.333,1),(954,7552616,7552613,'mod',50,1),(954,7552617,7552613,'ode',50,1),(954,7552618,7552616,'wri',14.286,1),(954,7552619,7552616,'rit',14.286,1),(954,7552620,7552616,'ite',14.286,1),(954,7552621,7552616,'tet',14.286,1),(954,7552622,7552616,'eth',14.286,1),(954,7552623,7552616,'thr',14.286,1),(954,7552624,7552616,'hru',14.286,1),(954,7552625,7552618,'ope',11.111,2),(954,7552626,7552618,'per',11.111,2),(954,7552627,7552618,'era',11.111,2),(954,7552628,7552618,'rat',11.111,2),(954,7552629,7552618,'ati',11.111,2),(954,7552630,7552618,'tio',11.111,2),(954,7552631,7552618,'ion',11.111,2),(954,7552632,7552618,'ona',11.111,2),(954,7552633,7552618,'nal',11.111,2),(954,7552634,7552625,'mes',20,1),(954,7552635,7552625,'ess',20,1),(954,7552636,7552625,'ssa',20,1),(954,7552637,7552625,'sag',20,1),(954,7552638,7552625,'age',20,1),(954,7552639,7552634,'per',11.111,1),(954,7552640,7552634,'erf',11.111,1),(954,7552641,7552634,'rfo',11.111,1),(954,7552642,7552634,'for',11.111,1),(954,7552643,7552634,'orm',11.111,1),(954,7552644,7552634,'rma',11.111,1),(954,7552645,7552634,'man',11.111,1),(954,7552646,7552634,'anc',11.111,1),(954,7552647,7552634,'nce',11.111,1),(954,7552648,7552639,'ide',12.5,1),(954,7552649,7552639,'den',12.5,1),(954,7552650,7552639,'ent',12.5,1),(954,7552651,7552639,'nti',12.5,1),(954,7552652,7552639,'tif',12.5,1),(954,7552653,7552639,'ifi',12.5,1),(954,7552654,7552639,'fie',12.5,1),(954,7552655,7552639,'ier',12.5,1),(954,7552656,7552648,'vdi',33.333,3),(954,7552657,7552648,'dis',33.333,3),(954,7552658,7552648,'isk',33.333,3),(954,7552659,7552656,'nam',50,1),(954,7552660,7552656,'ame',50,1),(954,7552661,7552659,'typ',50,1),(954,7552662,7552659,'ype',50,1),(954,7552663,7552661,'dir',25,1),(954,7552664,7552661,'ire',25,1),(954,7552665,7552661,'rec',25,1),(954,7552666,7552661,'ect',25,1),(955,7552668,7552667,'naa',100,2),(955,7552669,7552668,'600',3.333,3),(955,7552670,7552668,'000',3.333,3),(955,7552671,7552668,'00c',3.333,3),(955,7552672,7552668,'0c2',3.333,3),(955,7552673,7552668,'c29',3.333,3),(955,7552674,7552668,'29a',3.333,3),(955,7552675,7552668,'9a1',3.333,3),(955,7552676,7552668,'a12',3.333,3),(955,7552677,7552668,'120',3.333,3),(955,7552678,7552668,'202',3.333,3),(955,7552679,7552668,'02e',3.333,3),(955,7552680,7552668,'2e1',3.333,3),(955,7552681,7552668,'e13',3.333,3),(955,7552682,7552668,'136',3.333,3),(955,7552683,7552668,'36e',3.333,3),(955,7552684,7552668,'6e4',3.333,3),(955,7552685,7552668,'e42',3.333,3),(955,7552686,7552668,'420',3.333,3),(955,7552687,7552668,'201',3.333,3),(955,7552688,7552668,'011',3.333,3),(955,7552689,7552668,'11c',3.333,3),(955,7552690,7552668,'1c5',3.333,3),(955,7552691,7552668,'c5e',3.333,3),(955,7552692,7552668,'5ea',3.333,3),(955,7552693,7552668,'ea0',3.333,3),(955,7552694,7552668,'a0f',3.333,3),(955,7552695,7552668,'0ff',3.333,3),(955,7552696,7552668,'ffd',3.333,3),(955,7552697,7552668,'fda',3.333,3),(955,7552698,7552668,'daf',3.333,3),(955,7552699,7552669,'mon',100,1),(955,7552700,7552699,'201',50,1),(955,7552701,7552699,'013',50,1),(955,7552702,7552700,'adm',33.333,4),(955,7552703,7552700,'dmi',33.333,4),(955,7552704,7552700,'min',33.333,4),(955,7552705,7552702,'cap',16.667,1),(955,7552706,7552702,'apa',16.667,1),(955,7552707,7552702,'pac',16.667,1),(955,7552708,7552702,'aci',16.667,1),(955,7552709,7552702,'cit',16.667,1),(955,7552710,7552702,'ity',16.667,1),(955,7552711,7552705,'pat',50,1),(955,7552712,7552705,'ath',50,1),(955,7552713,7552711,'fre',14.286,1),(955,7552714,7552711,'ree',14.286,1),(955,7552715,7552711,'ees',14.286,1),(955,7552716,7552711,'esp',14.286,1),(955,7552717,7552711,'spa',14.286,1),(955,7552718,7552711,'pac',14.286,1),(955,7552719,7552711,'ace',14.286,1),(955,7552720,7552713,'dis',50,1),(955,7552721,7552713,'isk',50,1),(955,7552722,7552720,'ind',33.333,1),(955,7552723,7552720,'nde',33.333,1),(955,7552724,7552720,'dex',33.333,1),(955,7552725,7552722,'adm',8.333,1),(955,7552726,7552722,'dmi',8.333,1),(955,7552727,7552722,'min',8.333,1),(955,7552728,7552722,'ini',8.333,1),(955,7552729,7552722,'nis',8.333,1),(955,7552730,7552722,'ist',8.333,1),(955,7552731,7552722,'str',8.333,1),(955,7552732,7552722,'tra',8.333,1),(955,7552733,7552722,'rat',8.333,1),(955,7552734,7552722,'ati',8.333,1),(955,7552735,7552722,'tio',8.333,1),(955,7552736,7552722,'ion',8.333,1),(955,7552737,7552725,'sta',33.333,3),(955,7552738,7552725,'tat',33.333,3),(955,7552739,7552725,'ate',33.333,3),(955,7552740,7552737,'dis',16.667,4),(955,7552741,7552737,'isa',16.667,4),(955,7552742,7552737,'sab',16.667,4),(955,7552743,7552737,'abl',16.667,4),(955,7552744,7552737,'ble',16.667,4),(955,7552745,7552737,'led',16.667,4),(955,7552746,7552740,'cac',33.333,1),(955,7552747,7552740,'ach',33.333,1),(955,7552748,7552740,'che',33.333,1),(955,7552749,7552746,'mod',50,1),(955,7552750,7552746,'ode',50,1),(955,7552751,7552749,'wri',14.286,1),(955,7552752,7552749,'rit',14.286,1),(955,7552753,7552749,'ite',14.286,1),(955,7552754,7552749,'tet',14.286,1),(955,7552755,7552749,'eth',14.286,1),(955,7552756,7552749,'thr',14.286,1),(955,7552757,7552749,'hru',14.286,1),(955,7552758,7552751,'ope',11.111,2),(955,7552759,7552751,'per',11.111,2),(955,7552760,7552751,'era',11.111,2),(955,7552761,7552751,'rat',11.111,2),(955,7552762,7552751,'ati',11.111,2),(955,7552763,7552751,'tio',11.111,2),(955,7552764,7552751,'ion',11.111,2),(955,7552765,7552751,'ona',11.111,2),(955,7552766,7552751,'nal',11.111,2),(955,7552767,7552758,'mes',20,1),(955,7552768,7552758,'ess',20,1),(955,7552769,7552758,'ssa',20,1),(955,7552770,7552758,'sag',20,1),(955,7552771,7552758,'age',20,1),(955,7552772,7552767,'per',11.111,1),(955,7552773,7552767,'erf',11.111,1),(955,7552774,7552767,'rfo',11.111,1),(955,7552775,7552767,'for',11.111,1),(955,7552776,7552767,'orm',11.111,1),(955,7552777,7552767,'rma',11.111,1),(955,7552778,7552767,'man',11.111,1),(955,7552779,7552767,'anc',11.111,1),(955,7552780,7552767,'nce',11.111,1),(955,7552781,7552772,'ide',12.5,1),(955,7552782,7552772,'den',12.5,1),(955,7552783,7552772,'ent',12.5,1),(955,7552784,7552772,'nti',12.5,1),(955,7552785,7552772,'tif',12.5,1),(955,7552786,7552772,'ifi',12.5,1),(955,7552787,7552772,'fie',12.5,1),(955,7552788,7552772,'ier',12.5,1),(955,7552789,7552781,'vdi',33.333,3),(955,7552790,7552781,'dis',33.333,3),(955,7552791,7552781,'isk',33.333,3),(955,7552792,7552789,'nam',50,1),(955,7552793,7552789,'ame',50,1),(955,7552794,7552792,'typ',50,1),(955,7552795,7552792,'ype',50,1),(955,7552796,7552794,'dir',25,1),(955,7552797,7552794,'ire',25,1),(955,7552798,7552794,'rec',25,1),(955,7552799,7552794,'ect',25,1),(956,7552801,7552800,'naa',100,2),(956,7552802,7552801,'600',3.333,3),(956,7552803,7552801,'000',3.333,3),(956,7552804,7552801,'00c',3.333,3),(956,7552805,7552801,'0c2',3.333,3),(956,7552806,7552801,'c29',3.333,3),(956,7552807,7552801,'296',3.333,3),(956,7552808,7552801,'961',3.333,3),(956,7552809,7552801,'61e',3.333,3),(956,7552810,7552801,'1e0',3.333,3),(956,7552811,7552801,'e08',3.333,3),(956,7552812,7552801,'089',3.333,3),(956,7552813,7552801,'89e',3.333,3),(956,7552814,7552801,'9e5',3.333,3),(956,7552815,7552801,'e5f',3.333,3),(956,7552816,7552801,'5fd',3.333,3),(956,7552817,7552801,'fd0',3.333,3),(956,7552818,7552801,'d03',3.333,3),(956,7552819,7552801,'03b',3.333,3),(956,7552820,7552801,'3b5',3.333,3),(956,7552821,7552801,'b53',3.333,3),(956,7552822,7552801,'531',3.333,3),(956,7552823,7552801,'31b',3.333,3),(956,7552824,7552801,'1b7',3.333,3),(956,7552825,7552801,'b79',3.333,3),(956,7552826,7552801,'790',3.333,3),(956,7552827,7552801,'90d',3.333,3),(956,7552828,7552801,'0d2',3.333,3),(956,7552829,7552801,'d24',3.333,3),(956,7552830,7552801,'249',3.333,3),(956,7552831,7552801,'491',3.333,3),(956,7552832,7552802,'mon',100,1),(956,7552833,7552832,'201',50,1),(956,7552834,7552832,'013',50,1),(956,7552835,7552833,'adm',33.333,4),(956,7552836,7552833,'dmi',33.333,4),(956,7552837,7552833,'min',33.333,4),(956,7552838,7552835,'cap',16.667,1),(956,7552839,7552835,'apa',16.667,1),(956,7552840,7552835,'pac',16.667,1),(956,7552841,7552835,'aci',16.667,1),(956,7552842,7552835,'cit',16.667,1),(956,7552843,7552835,'ity',16.667,1),(956,7552844,7552838,'pat',50,1),(956,7552845,7552838,'ath',50,1),(956,7552846,7552844,'fre',14.286,1),(956,7552847,7552844,'ree',14.286,1),(956,7552848,7552844,'ees',14.286,1),(956,7552849,7552844,'esp',14.286,1),(956,7552850,7552844,'spa',14.286,1),(956,7552851,7552844,'pac',14.286,1),(956,7552852,7552844,'ace',14.286,1),(956,7552853,7552846,'dis',50,1),(956,7552854,7552846,'isk',50,1),(956,7552855,7552853,'ind',33.333,1),(956,7552856,7552853,'nde',33.333,1),(956,7552857,7552853,'dex',33.333,1),(956,7552858,7552855,'adm',8.333,1),(956,7552859,7552855,'dmi',8.333,1),(956,7552860,7552855,'min',8.333,1),(956,7552861,7552855,'ini',8.333,1),(956,7552862,7552855,'nis',8.333,1),(956,7552863,7552855,'ist',8.333,1),(956,7552864,7552855,'str',8.333,1),(956,7552865,7552855,'tra',8.333,1),(956,7552866,7552855,'rat',8.333,1),(956,7552867,7552855,'ati',8.333,1),(956,7552868,7552855,'tio',8.333,1),(956,7552869,7552855,'ion',8.333,1),(956,7552870,7552858,'sta',33.333,3),(956,7552871,7552858,'tat',33.333,3),(956,7552872,7552858,'ate',33.333,3),(956,7552873,7552870,'dis',16.667,4),(956,7552874,7552870,'isa',16.667,4),(956,7552875,7552870,'sab',16.667,4),(956,7552876,7552870,'abl',16.667,4),(956,7552877,7552870,'ble',16.667,4),(956,7552878,7552870,'led',16.667,4),(956,7552879,7552873,'cac',33.333,1),(956,7552880,7552873,'ach',33.333,1),(956,7552881,7552873,'che',33.333,1),(956,7552882,7552879,'mod',50,1),(956,7552883,7552879,'ode',50,1),(956,7552884,7552882,'wri',14.286,1),(956,7552885,7552882,'rit',14.286,1),(956,7552886,7552882,'ite',14.286,1),(956,7552887,7552882,'tet',14.286,1),(956,7552888,7552882,'eth',14.286,1),(956,7552889,7552882,'thr',14.286,1),(956,7552890,7552882,'hru',14.286,1),(956,7552891,7552884,'ope',11.111,2),(956,7552892,7552884,'per',11.111,2),(956,7552893,7552884,'era',11.111,2),(956,7552894,7552884,'rat',11.111,2),(956,7552895,7552884,'ati',11.111,2),(956,7552896,7552884,'tio',11.111,2),(956,7552897,7552884,'ion',11.111,2),(956,7552898,7552884,'ona',11.111,2),(956,7552899,7552884,'nal',11.111,2),(956,7552900,7552891,'mes',20,1),(956,7552901,7552891,'ess',20,1),(956,7552902,7552891,'ssa',20,1),(956,7552903,7552891,'sag',20,1),(956,7552904,7552891,'age',20,1),(956,7552905,7552900,'per',11.111,1),(956,7552906,7552900,'erf',11.111,1),(956,7552907,7552900,'rfo',11.111,1),(956,7552908,7552900,'for',11.111,1),(956,7552909,7552900,'orm',11.111,1),(956,7552910,7552900,'rma',11.111,1),(956,7552911,7552900,'man',11.111,1),(956,7552912,7552900,'anc',11.111,1),(956,7552913,7552900,'nce',11.111,1),(956,7552914,7552905,'ide',12.5,1),(956,7552915,7552905,'den',12.5,1),(956,7552916,7552905,'ent',12.5,1),(956,7552917,7552905,'nti',12.5,1),(956,7552918,7552905,'tif',12.5,1),(956,7552919,7552905,'ifi',12.5,1),(956,7552920,7552905,'fie',12.5,1),(956,7552921,7552905,'ier',12.5,1),(956,7552922,7552914,'vdi',33.333,3),(956,7552923,7552914,'dis',33.333,3),(956,7552924,7552914,'isk',33.333,3),(956,7552925,7552922,'nam',50,1),(956,7552926,7552922,'ame',50,1),(956,7552927,7552925,'typ',50,1),(956,7552928,7552925,'ype',50,1),(956,7552929,7552927,'dir',25,1),(956,7552930,7552927,'ire',25,1),(956,7552931,7552927,'rec',25,1),(956,7552932,7552927,'ect',25,1),(957,7552934,7552933,'naa',100,2),(957,7552935,7552934,'600',3.333,3),(957,7552936,7552934,'000',3.333,3),(957,7552937,7552934,'00c',3.333,3),(957,7552938,7552934,'0c2',3.333,3),(957,7552939,7552934,'c29',3.333,3),(957,7552940,7552934,'295',3.333,3),(957,7552941,7552934,'950',3.333,3),(957,7552942,7552934,'502',3.333,3),(957,7552943,7552934,'029',3.333,3),(957,7552944,7552934,'298',3.333,3),(957,7552945,7552934,'98e',3.333,3),(957,7552946,7552934,'8e9',3.333,3),(957,7552947,7552934,'e9c',3.333,3),(957,7552948,7552934,'9c6',3.333,3),(957,7552949,7552934,'c62',3.333,3),(957,7552950,7552934,'62a',3.333,3),(957,7552951,7552934,'2a6',3.333,3),(957,7552952,7552934,'a66',3.333,3),(957,7552953,7552934,'660',3.333,3),(957,7552954,7552934,'606',3.333,3),(957,7552955,7552934,'069',3.333,3),(957,7552956,7552934,'699',3.333,3),(957,7552957,7552934,'996',3.333,3),(957,7552958,7552934,'965',3.333,3),(957,7552959,7552934,'650',3.333,3),(957,7552960,7552934,'500',3.333,3),(957,7552961,7552934,'00d',3.333,3),(957,7552962,7552934,'0d9',3.333,3),(957,7552963,7552934,'d9c',3.333,3),(957,7552964,7552934,'9ce',3.333,3),(957,7552965,7552935,'mon',100,1),(957,7552966,7552965,'201',50,1),(957,7552967,7552965,'013',50,1),(957,7552968,7552966,'adm',33.333,4),(957,7552969,7552966,'dmi',33.333,4),(957,7552970,7552966,'min',33.333,4),(957,7552971,7552968,'cap',16.667,1),(957,7552972,7552968,'apa',16.667,1),(957,7552973,7552968,'pac',16.667,1),(957,7552974,7552968,'aci',16.667,1),(957,7552975,7552968,'cit',16.667,1),(957,7552976,7552968,'ity',16.667,1),(957,7552977,7552971,'pat',50,1),(957,7552978,7552971,'ath',50,1),(957,7552979,7552977,'fre',14.286,1),(957,7552980,7552977,'ree',14.286,1),(957,7552981,7552977,'ees',14.286,1),(957,7552982,7552977,'esp',14.286,1),(957,7552983,7552977,'spa',14.286,1),(957,7552984,7552977,'pac',14.286,1),(957,7552985,7552977,'ace',14.286,1),(957,7552986,7552979,'dis',50,1),(957,7552987,7552979,'isk',50,1),(957,7552988,7552986,'ind',33.333,1),(957,7552989,7552986,'nde',33.333,1),(957,7552990,7552986,'dex',33.333,1),(957,7552991,7552988,'adm',8.333,1),(957,7552992,7552988,'dmi',8.333,1),(957,7552993,7552988,'min',8.333,1),(957,7552994,7552988,'ini',8.333,1),(957,7552995,7552988,'nis',8.333,1),(957,7552996,7552988,'ist',8.333,1),(957,7552997,7552988,'str',8.333,1),(957,7552998,7552988,'tra',8.333,1),(957,7552999,7552988,'rat',8.333,1),(957,7553000,7552988,'ati',8.333,1),(957,7553001,7552988,'tio',8.333,1),(957,7553002,7552988,'ion',8.333,1),(957,7553003,7552991,'sta',33.333,3),(957,7553004,7552991,'tat',33.333,3),(957,7553005,7552991,'ate',33.333,3),(957,7553006,7553003,'dis',16.667,4),(957,7553007,7553003,'isa',16.667,4),(957,7553008,7553003,'sab',16.667,4),(957,7553009,7553003,'abl',16.667,4),(957,7553010,7553003,'ble',16.667,4),(957,7553011,7553003,'led',16.667,4),(957,7553012,7553006,'cac',33.333,1),(957,7553013,7553006,'ach',33.333,1),(957,7553014,7553006,'che',33.333,1),(957,7553015,7553012,'mod',50,1),(957,7553016,7553012,'ode',50,1),(957,7553017,7553015,'wri',14.286,1),(957,7553018,7553015,'rit',14.286,1),(957,7553019,7553015,'ite',14.286,1),(957,7553020,7553015,'tet',14.286,1),(957,7553021,7553015,'eth',14.286,1),(957,7553022,7553015,'thr',14.286,1),(957,7553023,7553015,'hru',14.286,1),(957,7553024,7553017,'ope',11.111,2),(957,7553025,7553017,'per',11.111,2),(957,7553026,7553017,'era',11.111,2),(957,7553027,7553017,'rat',11.111,2),(957,7553028,7553017,'ati',11.111,2),(957,7553029,7553017,'tio',11.111,2),(957,7553030,7553017,'ion',11.111,2),(957,7553031,7553017,'ona',11.111,2),(957,7553032,7553017,'nal',11.111,2),(957,7553033,7553024,'mes',20,1),(957,7553034,7553024,'ess',20,1),(957,7553035,7553024,'ssa',20,1),(957,7553036,7553024,'sag',20,1),(957,7553037,7553024,'age',20,1),(957,7553038,7553033,'per',11.111,1),(957,7553039,7553033,'erf',11.111,1),(957,7553040,7553033,'rfo',11.111,1),(957,7553041,7553033,'for',11.111,1),(957,7553042,7553033,'orm',11.111,1),(957,7553043,7553033,'rma',11.111,1),(957,7553044,7553033,'man',11.111,1),(957,7553045,7553033,'anc',11.111,1),(957,7553046,7553033,'nce',11.111,1),(957,7553047,7553038,'ide',12.5,1),(957,7553048,7553038,'den',12.5,1),(957,7553049,7553038,'ent',12.5,1),(957,7553050,7553038,'nti',12.5,1),(957,7553051,7553038,'tif',12.5,1),(957,7553052,7553038,'ifi',12.5,1),(957,7553053,7553038,'fie',12.5,1),(957,7553054,7553038,'ier',12.5,1),(957,7553055,7553047,'vdi',33.333,3),(957,7553056,7553047,'dis',33.333,3),(957,7553057,7553047,'isk',33.333,3),(957,7553058,7553055,'nam',50,1),(957,7553059,7553055,'ame',50,1),(957,7553060,7553058,'typ',50,1),(957,7553061,7553058,'ype',50,1),(957,7553062,7553060,'dir',25,1),(957,7553063,7553060,'ire',25,1),(957,7553064,7553060,'rec',25,1),(957,7553065,7553060,'ect',25,1),(958,7553067,7553066,'naa',100,2),(958,7553068,7553067,'600',3.333,3),(958,7553069,7553067,'000',3.333,3),(958,7553070,7553067,'00c',3.333,3),(958,7553071,7553067,'0c2',3.333,3),(958,7553072,7553067,'c29',3.333,3),(958,7553073,7553067,'29a',3.333,3),(958,7553074,7553067,'9a2',3.333,3),(958,7553075,7553067,'a26',3.333,3),(958,7553076,7553067,'265',3.333,3),(958,7553077,7553067,'65f',3.333,3),(958,7553078,7553067,'5fa',3.333,3),(958,7553079,7553067,'fa2',3.333,3),(958,7553080,7553067,'a20',3.333,3),(958,7553081,7553067,'205',3.333,3),(958,7553082,7553067,'05d',3.333,3),(958,7553083,7553067,'5d5',3.333,3),(958,7553084,7553067,'d59',3.333,3),(958,7553085,7553067,'59c',3.333,3),(958,7553086,7553067,'9ca',3.333,3),(958,7553087,7553067,'ca8',3.333,3),(958,7553088,7553067,'a8c',3.333,3),(958,7553089,7553067,'8c6',3.333,3),(958,7553090,7553067,'c61',3.333,3),(958,7553091,7553067,'61f',3.333,3),(958,7553092,7553067,'1fb',3.333,3),(958,7553093,7553067,'fb3',3.333,3),(958,7553094,7553067,'b37',3.333,3),(958,7553095,7553067,'375',3.333,3),(958,7553096,7553067,'757',3.333,3),(958,7553097,7553067,'571',3.333,3),(958,7553098,7553068,'mon',100,1),(958,7553099,7553098,'201',50,1),(958,7553100,7553098,'013',50,1),(958,7553101,7553099,'adm',33.333,4),(958,7553102,7553099,'dmi',33.333,4),(958,7553103,7553099,'min',33.333,4),(958,7553104,7553101,'cap',16.667,1),(958,7553105,7553101,'apa',16.667,1),(958,7553106,7553101,'pac',16.667,1),(958,7553107,7553101,'aci',16.667,1),(958,7553108,7553101,'cit',16.667,1),(958,7553109,7553101,'ity',16.667,1),(958,7553110,7553104,'pat',50,1),(958,7553111,7553104,'ath',50,1),(958,7553112,7553110,'fre',14.286,1),(958,7553113,7553110,'ree',14.286,1),(958,7553114,7553110,'ees',14.286,1),(958,7553115,7553110,'esp',14.286,1),(958,7553116,7553110,'spa',14.286,1),(958,7553117,7553110,'pac',14.286,1),(958,7553118,7553110,'ace',14.286,1),(958,7553119,7553112,'dis',50,1),(958,7553120,7553112,'isk',50,1),(958,7553121,7553119,'ind',33.333,1),(958,7553122,7553119,'nde',33.333,1),(958,7553123,7553119,'dex',33.333,1),(958,7553124,7553121,'adm',8.333,1),(958,7553125,7553121,'dmi',8.333,1),(958,7553126,7553121,'min',8.333,1),(958,7553127,7553121,'ini',8.333,1),(958,7553128,7553121,'nis',8.333,1),(958,7553129,7553121,'ist',8.333,1),(958,7553130,7553121,'str',8.333,1),(958,7553131,7553121,'tra',8.333,1),(958,7553132,7553121,'rat',8.333,1),(958,7553133,7553121,'ati',8.333,1),(958,7553134,7553121,'tio',8.333,1),(958,7553135,7553121,'ion',8.333,1),(958,7553136,7553124,'sta',33.333,3),(958,7553137,7553124,'tat',33.333,3),(958,7553138,7553124,'ate',33.333,3),(958,7553139,7553136,'dis',16.667,4),(958,7553140,7553136,'isa',16.667,4),(958,7553141,7553136,'sab',16.667,4),(958,7553142,7553136,'abl',16.667,4),(958,7553143,7553136,'ble',16.667,4),(958,7553144,7553136,'led',16.667,4),(958,7553145,7553139,'cac',33.333,1),(958,7553146,7553139,'ach',33.333,1),(958,7553147,7553139,'che',33.333,1),(958,7553148,7553145,'mod',50,1),(958,7553149,7553145,'ode',50,1),(958,7553150,7553148,'wri',14.286,1),(958,7553151,7553148,'rit',14.286,1),(958,7553152,7553148,'ite',14.286,1),(958,7553153,7553148,'tet',14.286,1),(958,7553154,7553148,'eth',14.286,1),(958,7553155,7553148,'thr',14.286,1),(958,7553156,7553148,'hru',14.286,1),(958,7553157,7553150,'ope',11.111,2),(958,7553158,7553150,'per',11.111,2),(958,7553159,7553150,'era',11.111,2),(958,7553160,7553150,'rat',11.111,2),(958,7553161,7553150,'ati',11.111,2),(958,7553162,7553150,'tio',11.111,2),(958,7553163,7553150,'ion',11.111,2),(958,7553164,7553150,'ona',11.111,2),(958,7553165,7553150,'nal',11.111,2),(958,7553166,7553157,'mes',20,1),(958,7553167,7553157,'ess',20,1),(958,7553168,7553157,'ssa',20,1),(958,7553169,7553157,'sag',20,1),(958,7553170,7553157,'age',20,1),(958,7553171,7553166,'per',11.111,1),(958,7553172,7553166,'erf',11.111,1),(958,7553173,7553166,'rfo',11.111,1),(958,7553174,7553166,'for',11.111,1),(958,7553175,7553166,'orm',11.111,1),(958,7553176,7553166,'rma',11.111,1),(958,7553177,7553166,'man',11.111,1),(958,7553178,7553166,'anc',11.111,1),(958,7553179,7553166,'nce',11.111,1),(958,7553180,7553171,'ide',12.5,1),(958,7553181,7553171,'den',12.5,1),(958,7553182,7553171,'ent',12.5,1),(958,7553183,7553171,'nti',12.5,1),(958,7553184,7553171,'tif',12.5,1),(958,7553185,7553171,'ifi',12.5,1),(958,7553186,7553171,'fie',12.5,1),(958,7553187,7553171,'ier',12.5,1),(958,7553188,7553180,'vdi',33.333,3),(958,7553189,7553180,'dis',33.333,3),(958,7553190,7553180,'isk',33.333,3),(958,7553191,7553188,'nam',50,1),(958,7553192,7553188,'ame',50,1),(958,7553193,7553191,'typ',50,1),(958,7553194,7553191,'ype',50,1),(958,7553195,7553193,'dir',25,1),(958,7553196,7553193,'ire',25,1),(958,7553197,7553193,'rec',25,1),(958,7553198,7553193,'ect',25,1),(959,7553200,7553199,'naa',100,2),(959,7553201,7553200,'600',3.333,3),(959,7553202,7553200,'000',3.333,3),(959,7553203,7553200,'00c',3.333,3),(959,7553204,7553200,'0c2',3.333,3),(959,7553205,7553200,'c29',3.333,3),(959,7553206,7553200,'293',3.333,3),(959,7553207,7553200,'932',3.333,3),(959,7553208,7553200,'32a',3.333,3),(959,7553209,7553200,'2a6',3.333,3),(959,7553210,7553200,'a6d',3.333,3),(959,7553211,7553200,'6d6',3.333,3),(959,7553212,7553200,'d62',3.333,3),(959,7553213,7553200,'626',3.333,3),(959,7553214,7553200,'268',3.333,3),(959,7553215,7553200,'68d',3.333,3),(959,7553216,7553200,'8df',3.333,3),(959,7553217,7553200,'df5',3.333,3),(959,7553218,7553200,'f53',3.333,3),(959,7553219,7553200,'53d',3.333,3),(959,7553220,7553200,'3d0',3.333,3),(959,7553221,7553200,'d03',3.333,3),(959,7553222,7553200,'03c',3.333,3),(959,7553223,7553200,'3c6',3.333,3),(959,7553224,7553200,'c65',3.333,3),(959,7553225,7553200,'655',3.333,3),(959,7553226,7553200,'557',3.333,3),(959,7553227,7553200,'577',3.333,3),(959,7553228,7553200,'776',3.333,3),(959,7553229,7553200,'76f',3.333,3),(959,7553230,7553200,'6ff',3.333,3),(959,7553231,7553201,'mon',100,1),(959,7553232,7553231,'201',50,1),(959,7553233,7553231,'013',50,1),(959,7553234,7553232,'adm',33.333,4),(959,7553235,7553232,'dmi',33.333,4),(959,7553236,7553232,'min',33.333,4),(959,7553237,7553234,'cap',16.667,1),(959,7553238,7553234,'apa',16.667,1),(959,7553239,7553234,'pac',16.667,1),(959,7553240,7553234,'aci',16.667,1),(959,7553241,7553234,'cit',16.667,1),(959,7553242,7553234,'ity',16.667,1),(959,7553243,7553237,'pat',50,1),(959,7553244,7553237,'ath',50,1),(959,7553245,7553243,'fre',14.286,1),(959,7553246,7553243,'ree',14.286,1),(959,7553247,7553243,'ees',14.286,1),(959,7553248,7553243,'esp',14.286,1),(959,7553249,7553243,'spa',14.286,1),(959,7553250,7553243,'pac',14.286,1),(959,7553251,7553243,'ace',14.286,1),(959,7553252,7553245,'dis',50,1),(959,7553253,7553245,'isk',50,1),(959,7553254,7553252,'ind',33.333,1),(959,7553255,7553252,'nde',33.333,1),(959,7553256,7553252,'dex',33.333,1),(959,7553257,7553254,'adm',8.333,1),(959,7553258,7553254,'dmi',8.333,1),(959,7553259,7553254,'min',8.333,1),(959,7553260,7553254,'ini',8.333,1),(959,7553261,7553254,'nis',8.333,1),(959,7553262,7553254,'ist',8.333,1),(959,7553263,7553254,'str',8.333,1),(959,7553264,7553254,'tra',8.333,1),(959,7553265,7553254,'rat',8.333,1),(959,7553266,7553254,'ati',8.333,1),(959,7553267,7553254,'tio',8.333,1),(959,7553268,7553254,'ion',8.333,1),(959,7553269,7553257,'sta',33.333,3),(959,7553270,7553257,'tat',33.333,3),(959,7553271,7553257,'ate',33.333,3),(959,7553272,7553269,'dis',16.667,4),(959,7553273,7553269,'isa',16.667,4),(959,7553274,7553269,'sab',16.667,4),(959,7553275,7553269,'abl',16.667,4),(959,7553276,7553269,'ble',16.667,4),(959,7553277,7553269,'led',16.667,4),(959,7553278,7553272,'cac',33.333,1),(959,7553279,7553272,'ach',33.333,1),(959,7553280,7553272,'che',33.333,1),(959,7553281,7553278,'mod',50,1),(959,7553282,7553278,'ode',50,1),(959,7553283,7553281,'wri',14.286,1),(959,7553284,7553281,'rit',14.286,1),(959,7553285,7553281,'ite',14.286,1),(959,7553286,7553281,'tet',14.286,1),(959,7553287,7553281,'eth',14.286,1),(959,7553288,7553281,'thr',14.286,1),(959,7553289,7553281,'hru',14.286,1),(959,7553290,7553283,'ope',11.111,2),(959,7553291,7553283,'per',11.111,2),(959,7553292,7553283,'era',11.111,2),(959,7553293,7553283,'rat',11.111,2),(959,7553294,7553283,'ati',11.111,2),(959,7553295,7553283,'tio',11.111,2),(959,7553296,7553283,'ion',11.111,2),(959,7553297,7553283,'ona',11.111,2),(959,7553298,7553283,'nal',11.111,2),(959,7553299,7553290,'mes',20,1),(959,7553300,7553290,'ess',20,1),(959,7553301,7553290,'ssa',20,1),(959,7553302,7553290,'sag',20,1),(959,7553303,7553290,'age',20,1),(959,7553304,7553299,'per',11.111,1),(959,7553305,7553299,'erf',11.111,1),(959,7553306,7553299,'rfo',11.111,1),(959,7553307,7553299,'for',11.111,1),(959,7553308,7553299,'orm',11.111,1),(959,7553309,7553299,'rma',11.111,1),(959,7553310,7553299,'man',11.111,1),(959,7553311,7553299,'anc',11.111,1),(959,7553312,7553299,'nce',11.111,1),(959,7553313,7553304,'ide',12.5,1),(959,7553314,7553304,'den',12.5,1),(959,7553315,7553304,'ent',12.5,1),(959,7553316,7553304,'nti',12.5,1),(959,7553317,7553304,'tif',12.5,1),(959,7553318,7553304,'ifi',12.5,1),(959,7553319,7553304,'fie',12.5,1),(959,7553320,7553304,'ier',12.5,1),(959,7553321,7553313,'vdi',33.333,3),(959,7553322,7553313,'dis',33.333,3),(959,7553323,7553313,'isk',33.333,3),(959,7553324,7553321,'nam',50,1),(959,7553325,7553321,'ame',50,1),(959,7553326,7553324,'typ',50,1),(959,7553327,7553324,'ype',50,1),(959,7553328,7553326,'dir',25,1),(959,7553329,7553326,'ire',25,1),(959,7553330,7553326,'rec',25,1),(959,7553331,7553326,'ect',25,1),(960,7553333,7553332,'naa',100,2),(960,7553334,7553333,'600',3.333,3),(960,7553335,7553333,'000',3.333,3),(960,7553336,7553333,'00c',3.333,3),(960,7553337,7553333,'0c2',3.333,3),(960,7553338,7553333,'c29',3.333,3),(960,7553339,7553333,'299',3.333,3),(960,7553340,7553333,'99b',3.333,3),(960,7553341,7553333,'9bb',3.333,3),(960,7553342,7553333,'bb9',3.333,3),(960,7553343,7553333,'b9d',3.333,3),(960,7553344,7553333,'9da',3.333,3),(960,7553345,7553333,'daf',3.333,3),(960,7553346,7553333,'af8',3.333,3),(960,7553347,7553333,'f8c',3.333,3),(960,7553348,7553333,'8c3',3.333,3),(960,7553349,7553333,'c37',3.333,3),(960,7553350,7553333,'372',3.333,3),(960,7553351,7553333,'720',3.333,3),(960,7553352,7553333,'20b',3.333,3),(960,7553353,7553333,'0bf',3.333,3),(960,7553354,7553333,'bf3',3.333,3),(960,7553355,7553333,'f3a',3.333,3),(960,7553356,7553333,'3a1',3.333,3),(960,7553357,7553333,'a18',3.333,3),(960,7553358,7553333,'184',3.333,3),(960,7553359,7553333,'843',3.333,3),(960,7553360,7553333,'43f',3.333,3),(960,7553361,7553333,'3ff',3.333,3),(960,7553362,7553333,'ff2',3.333,3),(960,7553363,7553333,'f2a',3.333,3),(960,7553364,7553334,'mon',100,1),(960,7553365,7553364,'201',50,1),(960,7553366,7553364,'013',50,1),(960,7553367,7553365,'adm',33.333,4),(960,7553368,7553365,'dmi',33.333,4),(960,7553369,7553365,'min',33.333,4),(960,7553370,7553367,'cap',16.667,1),(960,7553371,7553367,'apa',16.667,1),(960,7553372,7553367,'pac',16.667,1),(960,7553373,7553367,'aci',16.667,1),(960,7553374,7553367,'cit',16.667,1),(960,7553375,7553367,'ity',16.667,1),(960,7553376,7553370,'pat',50,1),(960,7553377,7553370,'ath',50,1),(960,7553378,7553376,'fre',14.286,1),(960,7553379,7553376,'ree',14.286,1),(960,7553380,7553376,'ees',14.286,1),(960,7553381,7553376,'esp',14.286,1),(960,7553382,7553376,'spa',14.286,1),(960,7553383,7553376,'pac',14.286,1),(960,7553384,7553376,'ace',14.286,1),(960,7553385,7553378,'dis',50,1),(960,7553386,7553378,'isk',50,1),(960,7553387,7553385,'ind',33.333,1),(960,7553388,7553385,'nde',33.333,1),(960,7553389,7553385,'dex',33.333,1),(960,7553390,7553387,'adm',8.333,1),(960,7553391,7553387,'dmi',8.333,1),(960,7553392,7553387,'min',8.333,1),(960,7553393,7553387,'ini',8.333,1),(960,7553394,7553387,'nis',8.333,1),(960,7553395,7553387,'ist',8.333,1),(960,7553396,7553387,'str',8.333,1),(960,7553397,7553387,'tra',8.333,1),(960,7553398,7553387,'rat',8.333,1),(960,7553399,7553387,'ati',8.333,1),(960,7553400,7553387,'tio',8.333,1),(960,7553401,7553387,'ion',8.333,1),(960,7553402,7553390,'sta',33.333,3),(960,7553403,7553390,'tat',33.333,3),(960,7553404,7553390,'ate',33.333,3),(960,7553405,7553402,'dis',16.667,4),(960,7553406,7553402,'isa',16.667,4),(960,7553407,7553402,'sab',16.667,4),(960,7553408,7553402,'abl',16.667,4),(960,7553409,7553402,'ble',16.667,4),(960,7553410,7553402,'led',16.667,4),(960,7553411,7553405,'cac',33.333,1),(960,7553412,7553405,'ach',33.333,1),(960,7553413,7553405,'che',33.333,1),(960,7553414,7553411,'mod',50,1),(960,7553415,7553411,'ode',50,1),(960,7553416,7553414,'wri',14.286,1),(960,7553417,7553414,'rit',14.286,1),(960,7553418,7553414,'ite',14.286,1),(960,7553419,7553414,'tet',14.286,1),(960,7553420,7553414,'eth',14.286,1),(960,7553421,7553414,'thr',14.286,1),(960,7553422,7553414,'hru',14.286,1),(960,7553423,7553416,'ope',11.111,2),(960,7553424,7553416,'per',11.111,2),(960,7553425,7553416,'era',11.111,2),(960,7553426,7553416,'rat',11.111,2),(960,7553427,7553416,'ati',11.111,2),(960,7553428,7553416,'tio',11.111,2),(960,7553429,7553416,'ion',11.111,2),(960,7553430,7553416,'ona',11.111,2),(960,7553431,7553416,'nal',11.111,2),(960,7553432,7553423,'mes',20,1),(960,7553433,7553423,'ess',20,1),(960,7553434,7553423,'ssa',20,1),(960,7553435,7553423,'sag',20,1),(960,7553436,7553423,'age',20,1),(960,7553437,7553432,'per',11.111,1),(960,7553438,7553432,'erf',11.111,1),(960,7553439,7553432,'rfo',11.111,1),(960,7553440,7553432,'for',11.111,1),(960,7553441,7553432,'orm',11.111,1),(960,7553442,7553432,'rma',11.111,1),(960,7553443,7553432,'man',11.111,1),(960,7553444,7553432,'anc',11.111,1),(960,7553445,7553432,'nce',11.111,1),(960,7553446,7553437,'ide',12.5,1),(960,7553447,7553437,'den',12.5,1),(960,7553448,7553437,'ent',12.5,1),(960,7553449,7553437,'nti',12.5,1),(960,7553450,7553437,'tif',12.5,1),(960,7553451,7553437,'ifi',12.5,1),(960,7553452,7553437,'fie',12.5,1),(960,7553453,7553437,'ier',12.5,1),(960,7553454,7553446,'vdi',33.333,3),(960,7553455,7553446,'dis',33.333,3),(960,7553456,7553446,'isk',33.333,3),(960,7553457,7553454,'nam',50,1),(960,7553458,7553454,'ame',50,1),(960,7553459,7553457,'typ',50,1),(960,7553460,7553457,'ype',50,1),(960,7553461,7553459,'dir',25,1),(960,7553462,7553459,'ire',25,1),(960,7553463,7553459,'rec',25,1),(960,7553464,7553459,'ect',25,1),(961,7553466,7553465,'naa',100,2),(961,7553467,7553466,'600',3.333,3),(961,7553468,7553466,'000',3.333,3),(961,7553469,7553466,'00c',3.333,3),(961,7553470,7553466,'0c2',3.333,3),(961,7553471,7553466,'c29',3.333,3),(961,7553472,7553466,'299',3.333,3),(961,7553473,7553466,'99f',3.333,3),(961,7553474,7553466,'9f0',3.333,3),(961,7553475,7553466,'f04',3.333,3),(961,7553476,7553466,'049',3.333,3),(961,7553477,7553466,'492',3.333,3),(961,7553478,7553466,'920',3.333,3),(961,7553479,7553466,'206',3.333,3),(961,7553480,7553466,'069',3.333,3),(961,7553481,7553466,'69f',3.333,3),(961,7553482,7553466,'9f0',3.333,3),(961,7553483,7553466,'f0b',3.333,3),(961,7553484,7553466,'0bd',3.333,3),(961,7553485,7553466,'bd7',3.333,3),(961,7553486,7553466,'d79',3.333,3),(961,7553487,7553466,'792',3.333,3),(961,7553488,7553466,'928',3.333,3),(961,7553489,7553466,'280',3.333,3),(961,7553490,7553466,'805',3.333,3),(961,7553491,7553466,'05d',3.333,3),(961,7553492,7553466,'5dc',3.333,3),(961,7553493,7553466,'dcc',3.333,3),(961,7553494,7553466,'cc8',3.333,3),(961,7553495,7553466,'c86',3.333,3),(961,7553496,7553466,'86a',3.333,3),(961,7553497,7553467,'mon',100,1),(961,7553498,7553497,'201',50,1),(961,7553499,7553497,'013',50,1),(961,7553500,7553498,'adm',33.333,4),(961,7553501,7553498,'dmi',33.333,4),(961,7553502,7553498,'min',33.333,4),(961,7553503,7553500,'cap',16.667,1),(961,7553504,7553500,'apa',16.667,1),(961,7553505,7553500,'pac',16.667,1),(961,7553506,7553500,'aci',16.667,1),(961,7553507,7553500,'cit',16.667,1),(961,7553508,7553500,'ity',16.667,1),(961,7553509,7553503,'pat',50,1),(961,7553510,7553503,'ath',50,1),(961,7553511,7553509,'fre',14.286,1),(961,7553512,7553509,'ree',14.286,1),(961,7553513,7553509,'ees',14.286,1),(961,7553514,7553509,'esp',14.286,1),(961,7553515,7553509,'spa',14.286,1),(961,7553516,7553509,'pac',14.286,1),(961,7553517,7553509,'ace',14.286,1),(961,7553518,7553511,'dis',50,1),(961,7553519,7553511,'isk',50,1),(961,7553520,7553518,'ind',33.333,1),(961,7553521,7553518,'nde',33.333,1),(961,7553522,7553518,'dex',33.333,1),(961,7553523,7553520,'adm',8.333,1),(961,7553524,7553520,'dmi',8.333,1),(961,7553525,7553520,'min',8.333,1),(961,7553526,7553520,'ini',8.333,1),(961,7553527,7553520,'nis',8.333,1),(961,7553528,7553520,'ist',8.333,1),(961,7553529,7553520,'str',8.333,1),(961,7553530,7553520,'tra',8.333,1),(961,7553531,7553520,'rat',8.333,1),(961,7553532,7553520,'ati',8.333,1),(961,7553533,7553520,'tio',8.333,1),(961,7553534,7553520,'ion',8.333,1),(961,7553535,7553523,'sta',33.333,3),(961,7553536,7553523,'tat',33.333,3),(961,7553537,7553523,'ate',33.333,3),(961,7553538,7553535,'dis',16.667,4),(961,7553539,7553535,'isa',16.667,4),(961,7553540,7553535,'sab',16.667,4),(961,7553541,7553535,'abl',16.667,4),(961,7553542,7553535,'ble',16.667,4),(961,7553543,7553535,'led',16.667,4),(961,7553544,7553538,'cac',33.333,1),(961,7553545,7553538,'ach',33.333,1),(961,7553546,7553538,'che',33.333,1),(961,7553547,7553544,'mod',50,1),(961,7553548,7553544,'ode',50,1),(961,7553549,7553547,'wri',14.286,1),(961,7553550,7553547,'rit',14.286,1),(961,7553551,7553547,'ite',14.286,1),(961,7553552,7553547,'tet',14.286,1),(961,7553553,7553547,'eth',14.286,1),(961,7553554,7553547,'thr',14.286,1),(961,7553555,7553547,'hru',14.286,1),(961,7553556,7553549,'ope',11.111,2),(961,7553557,7553549,'per',11.111,2),(961,7553558,7553549,'era',11.111,2),(961,7553559,7553549,'rat',11.111,2),(961,7553560,7553549,'ati',11.111,2),(961,7553561,7553549,'tio',11.111,2),(961,7553562,7553549,'ion',11.111,2),(961,7553563,7553549,'ona',11.111,2),(961,7553564,7553549,'nal',11.111,2),(961,7553565,7553556,'mes',20,1),(961,7553566,7553556,'ess',20,1),(961,7553567,7553556,'ssa',20,1),(961,7553568,7553556,'sag',20,1),(961,7553569,7553556,'age',20,1),(961,7553570,7553565,'per',11.111,1),(961,7553571,7553565,'erf',11.111,1),(961,7553572,7553565,'rfo',11.111,1),(961,7553573,7553565,'for',11.111,1),(961,7553574,7553565,'orm',11.111,1),(961,7553575,7553565,'rma',11.111,1),(961,7553576,7553565,'man',11.111,1),(961,7553577,7553565,'anc',11.111,1),(961,7553578,7553565,'nce',11.111,1),(961,7553579,7553570,'ide',12.5,1),(961,7553580,7553570,'den',12.5,1),(961,7553581,7553570,'ent',12.5,1),(961,7553582,7553570,'nti',12.5,1),(961,7553583,7553570,'tif',12.5,1),(961,7553584,7553570,'ifi',12.5,1),(961,7553585,7553570,'fie',12.5,1),(961,7553586,7553570,'ier',12.5,1),(961,7553587,7553579,'vdi',33.333,3),(961,7553588,7553579,'dis',33.333,3),(961,7553589,7553579,'isk',33.333,3),(961,7553590,7553587,'nam',50,1),(961,7553591,7553587,'ame',50,1),(961,7553592,7553590,'typ',50,1),(961,7553593,7553590,'ype',50,1),(961,7553594,7553592,'dir',25,1),(961,7553595,7553592,'ire',25,1),(961,7553596,7553592,'rec',25,1),(961,7553597,7553592,'ect',25,1),(962,7553599,7553598,'naa',100,2),(962,7553600,7553599,'600',3.333,3),(962,7553601,7553599,'000',3.333,3),(962,7553602,7553599,'00c',3.333,3),(962,7553603,7553599,'0c2',3.333,3),(962,7553604,7553599,'c29',3.333,3),(962,7553605,7553599,'291',3.333,3),(962,7553606,7553599,'910',3.333,3),(962,7553607,7553599,'10f',3.333,3),(962,7553608,7553599,'0fc',3.333,3),(962,7553609,7553599,'fc5',3.333,3),(962,7553610,7553599,'c56',3.333,3),(962,7553611,7553599,'564',3.333,3),(962,7553612,7553599,'64b',3.333,3),(962,7553613,7553599,'4b7',3.333,3),(962,7553614,7553599,'b72',3.333,3),(962,7553615,7553599,'724',3.333,3),(962,7553616,7553599,'245',3.333,3),(962,7553617,7553599,'450',3.333,3),(962,7553618,7553599,'506',3.333,3),(962,7553619,7553599,'06a',3.333,3),(962,7553620,7553599,'6a9',3.333,3),(962,7553621,7553599,'a91',3.333,3),(962,7553622,7553599,'917',3.333,3),(962,7553623,7553599,'175',3.333,3),(962,7553624,7553599,'750',3.333,3),(962,7553625,7553599,'509',3.333,3),(962,7553626,7553599,'093',3.333,3),(962,7553627,7553599,'936',3.333,3),(962,7553628,7553599,'361',3.333,3),(962,7553629,7553599,'614',3.333,3),(962,7553630,7553600,'mon',100,1),(962,7553631,7553630,'201',50,1),(962,7553632,7553630,'013',50,1),(962,7553633,7553631,'adm',33.333,4),(962,7553634,7553631,'dmi',33.333,4),(962,7553635,7553631,'min',33.333,4),(962,7553636,7553633,'cap',16.667,1),(962,7553637,7553633,'apa',16.667,1),(962,7553638,7553633,'pac',16.667,1),(962,7553639,7553633,'aci',16.667,1),(962,7553640,7553633,'cit',16.667,1),(962,7553641,7553633,'ity',16.667,1),(962,7553642,7553636,'pat',50,1),(962,7553643,7553636,'ath',50,1),(962,7553644,7553642,'fre',14.286,1),(962,7553645,7553642,'ree',14.286,1),(962,7553646,7553642,'ees',14.286,1),(962,7553647,7553642,'esp',14.286,1),(962,7553648,7553642,'spa',14.286,1),(962,7553649,7553642,'pac',14.286,1),(962,7553650,7553642,'ace',14.286,1),(962,7553651,7553644,'dis',50,1),(962,7553652,7553644,'isk',50,1),(962,7553653,7553651,'ind',33.333,1),(962,7553654,7553651,'nde',33.333,1),(962,7553655,7553651,'dex',33.333,1),(962,7553656,7553653,'adm',8.333,1),(962,7553657,7553653,'dmi',8.333,1),(962,7553658,7553653,'min',8.333,1),(962,7553659,7553653,'ini',8.333,1),(962,7553660,7553653,'nis',8.333,1),(962,7553661,7553653,'ist',8.333,1),(962,7553662,7553653,'str',8.333,1),(962,7553663,7553653,'tra',8.333,1),(962,7553664,7553653,'rat',8.333,1),(962,7553665,7553653,'ati',8.333,1),(962,7553666,7553653,'tio',8.333,1),(962,7553667,7553653,'ion',8.333,1),(962,7553668,7553656,'sta',33.333,3),(962,7553669,7553656,'tat',33.333,3),(962,7553670,7553656,'ate',33.333,3),(962,7553671,7553668,'dis',16.667,4),(962,7553672,7553668,'isa',16.667,4),(962,7553673,7553668,'sab',16.667,4),(962,7553674,7553668,'abl',16.667,4),(962,7553675,7553668,'ble',16.667,4),(962,7553676,7553668,'led',16.667,4),(962,7553677,7553671,'cac',33.333,1),(962,7553678,7553671,'ach',33.333,1),(962,7553679,7553671,'che',33.333,1),(962,7553680,7553677,'mod',50,1),(962,7553681,7553677,'ode',50,1),(962,7553682,7553680,'wri',14.286,1),(962,7553683,7553680,'rit',14.286,1),(962,7553684,7553680,'ite',14.286,1),(962,7553685,7553680,'tet',14.286,1),(962,7553686,7553680,'eth',14.286,1),(962,7553687,7553680,'thr',14.286,1),(962,7553688,7553680,'hru',14.286,1),(962,7553689,7553682,'ope',11.111,2),(962,7553690,7553682,'per',11.111,2),(962,7553691,7553682,'era',11.111,2),(962,7553692,7553682,'rat',11.111,2),(962,7553693,7553682,'ati',11.111,2),(962,7553694,7553682,'tio',11.111,2),(962,7553695,7553682,'ion',11.111,2),(962,7553696,7553682,'ona',11.111,2),(962,7553697,7553682,'nal',11.111,2),(962,7553698,7553689,'mes',20,1),(962,7553699,7553689,'ess',20,1),(962,7553700,7553689,'ssa',20,1),(962,7553701,7553689,'sag',20,1),(962,7553702,7553689,'age',20,1),(962,7553703,7553698,'per',11.111,1),(962,7553704,7553698,'erf',11.111,1),(962,7553705,7553698,'rfo',11.111,1),(962,7553706,7553698,'for',11.111,1),(962,7553707,7553698,'orm',11.111,1),(962,7553708,7553698,'rma',11.111,1),(962,7553709,7553698,'man',11.111,1),(962,7553710,7553698,'anc',11.111,1),(962,7553711,7553698,'nce',11.111,1),(962,7553712,7553703,'ide',12.5,1),(962,7553713,7553703,'den',12.5,1),(962,7553714,7553703,'ent',12.5,1),(962,7553715,7553703,'nti',12.5,1),(962,7553716,7553703,'tif',12.5,1),(962,7553717,7553703,'ifi',12.5,1),(962,7553718,7553703,'fie',12.5,1),(962,7553719,7553703,'ier',12.5,1),(962,7553720,7553712,'vdi',33.333,3),(962,7553721,7553712,'dis',33.333,3),(962,7553722,7553712,'isk',33.333,3),(962,7553723,7553720,'nam',50,1),(962,7553724,7553720,'ame',50,1),(962,7553725,7553723,'typ',50,1),(962,7553726,7553723,'ype',50,1),(962,7553727,7553725,'dir',25,1),(962,7553728,7553725,'ire',25,1),(962,7553729,7553725,'rec',25,1),(962,7553730,7553725,'ect',25,1),(963,7553732,7553731,'naa',100,2),(963,7553733,7553732,'600',3.333,3),(963,7553734,7553732,'000',3.333,3),(963,7553735,7553732,'00c',3.333,3),(963,7553736,7553732,'0c2',3.333,3),(963,7553737,7553732,'c29',3.333,3),(963,7553738,7553732,'295',3.333,3),(963,7553739,7553732,'95d',3.333,3),(963,7553740,7553732,'5dc',3.333,3),(963,7553741,7553732,'dce',3.333,3),(963,7553742,7553732,'ce9',3.333,3),(963,7553743,7553732,'e93',3.333,3),(963,7553744,7553732,'93e',3.333,3),(963,7553745,7553732,'3e4',3.333,3),(963,7553746,7553732,'e4e',3.333,3),(963,7553747,7553732,'4ee',3.333,3),(963,7553748,7553732,'ee6',3.333,3),(963,7553749,7553732,'e61',3.333,3),(963,7553750,7553732,'616',3.333,3),(963,7553751,7553732,'161',3.333,3),(963,7553752,7553732,'61b',3.333,3),(963,7553753,7553732,'1be',3.333,3),(963,7553754,7553732,'bed',3.333,3),(963,7553755,7553732,'edc',3.333,3),(963,7553756,7553732,'dcf',3.333,3),(963,7553757,7553732,'cf9',3.333,3),(963,7553758,7553732,'f94',3.333,3),(963,7553759,7553732,'946',3.333,3),(963,7553760,7553732,'46e',3.333,3),(963,7553761,7553732,'6ec',3.333,3),(963,7553762,7553732,'ec1',3.333,3),(963,7553763,7553733,'mon',100,1),(963,7553764,7553763,'201',50,1),(963,7553765,7553763,'013',50,1),(963,7553766,7553764,'adm',33.333,4),(963,7553767,7553764,'dmi',33.333,4),(963,7553768,7553764,'min',33.333,4),(963,7553769,7553766,'cap',16.667,1),(963,7553770,7553766,'apa',16.667,1),(963,7553771,7553766,'pac',16.667,1),(963,7553772,7553766,'aci',16.667,1),(963,7553773,7553766,'cit',16.667,1),(963,7553774,7553766,'ity',16.667,1),(963,7553775,7553769,'pat',50,1),(963,7553776,7553769,'ath',50,1),(963,7553777,7553775,'fre',14.286,1),(963,7553778,7553775,'ree',14.286,1),(963,7553779,7553775,'ees',14.286,1),(963,7553780,7553775,'esp',14.286,1),(963,7553781,7553775,'spa',14.286,1),(963,7553782,7553775,'pac',14.286,1),(963,7553783,7553775,'ace',14.286,1),(963,7553784,7553777,'dis',50,1),(963,7553785,7553777,'isk',50,1),(963,7553786,7553784,'ind',33.333,1),(963,7553787,7553784,'nde',33.333,1),(963,7553788,7553784,'dex',33.333,1),(963,7553789,7553786,'adm',8.333,1),(963,7553790,7553786,'dmi',8.333,1),(963,7553791,7553786,'min',8.333,1),(963,7553792,7553786,'ini',8.333,1),(963,7553793,7553786,'nis',8.333,1),(963,7553794,7553786,'ist',8.333,1),(963,7553795,7553786,'str',8.333,1),(963,7553796,7553786,'tra',8.333,1),(963,7553797,7553786,'rat',8.333,1),(963,7553798,7553786,'ati',8.333,1),(963,7553799,7553786,'tio',8.333,1),(963,7553800,7553786,'ion',8.333,1),(963,7553801,7553789,'sta',33.333,3),(963,7553802,7553789,'tat',33.333,3),(963,7553803,7553789,'ate',33.333,3),(963,7553804,7553801,'dis',16.667,4),(963,7553805,7553801,'isa',16.667,4),(963,7553806,7553801,'sab',16.667,4),(963,7553807,7553801,'abl',16.667,4),(963,7553808,7553801,'ble',16.667,4),(963,7553809,7553801,'led',16.667,4),(963,7553810,7553804,'cac',33.333,1),(963,7553811,7553804,'ach',33.333,1),(963,7553812,7553804,'che',33.333,1),(963,7553813,7553810,'mod',50,1),(963,7553814,7553810,'ode',50,1),(963,7553815,7553813,'wri',14.286,1),(963,7553816,7553813,'rit',14.286,1),(963,7553817,7553813,'ite',14.286,1),(963,7553818,7553813,'tet',14.286,1),(963,7553819,7553813,'eth',14.286,1),(963,7553820,7553813,'thr',14.286,1),(963,7553821,7553813,'hru',14.286,1),(963,7553822,7553815,'ope',11.111,2),(963,7553823,7553815,'per',11.111,2),(963,7553824,7553815,'era',11.111,2),(963,7553825,7553815,'rat',11.111,2),(963,7553826,7553815,'ati',11.111,2),(963,7553827,7553815,'tio',11.111,2),(963,7553828,7553815,'ion',11.111,2),(963,7553829,7553815,'ona',11.111,2),(963,7553830,7553815,'nal',11.111,2),(963,7553831,7553822,'mes',20,1),(963,7553832,7553822,'ess',20,1),(963,7553833,7553822,'ssa',20,1),(963,7553834,7553822,'sag',20,1),(963,7553835,7553822,'age',20,1),(963,7553836,7553831,'per',11.111,1),(963,7553837,7553831,'erf',11.111,1),(963,7553838,7553831,'rfo',11.111,1),(963,7553839,7553831,'for',11.111,1),(963,7553840,7553831,'orm',11.111,1),(963,7553841,7553831,'rma',11.111,1),(963,7553842,7553831,'man',11.111,1),(963,7553843,7553831,'anc',11.111,1),(963,7553844,7553831,'nce',11.111,1),(963,7553845,7553836,'ide',12.5,1),(963,7553846,7553836,'den',12.5,1),(963,7553847,7553836,'ent',12.5,1),(963,7553848,7553836,'nti',12.5,1),(963,7553849,7553836,'tif',12.5,1),(963,7553850,7553836,'ifi',12.5,1),(963,7553851,7553836,'fie',12.5,1),(963,7553852,7553836,'ier',12.5,1),(963,7553853,7553845,'vdi',33.333,3),(963,7553854,7553845,'dis',33.333,3),(963,7553855,7553845,'isk',33.333,3),(963,7553856,7553853,'nam',50,1),(963,7553857,7553853,'ame',50,1),(963,7553858,7553856,'typ',50,1),(963,7553859,7553856,'ype',50,1),(963,7553860,7553858,'dir',25,1),(963,7553861,7553858,'ire',25,1),(963,7553862,7553858,'rec',25,1),(963,7553863,7553858,'ect',25,1),(964,7553865,7553864,'naa',100,2),(964,7553866,7553865,'600',3.333,3),(964,7553867,7553865,'000',3.333,3),(964,7553868,7553865,'00c',3.333,3),(964,7553869,7553865,'0c2',3.333,3),(964,7553870,7553865,'c29',3.333,3),(964,7553871,7553865,'29a',3.333,3),(964,7553872,7553865,'9aa',3.333,3),(964,7553873,7553865,'aa0',3.333,3),(964,7553874,7553865,'a00',3.333,3),(964,7553875,7553865,'002',3.333,3),(964,7553876,7553865,'023',3.333,3),(964,7553877,7553865,'237',3.333,3),(964,7553878,7553865,'371',3.333,3),(964,7553879,7553865,'715',3.333,3),(964,7553880,7553865,'153',3.333,3),(964,7553881,7553865,'532',3.333,3),(964,7553882,7553865,'32e',3.333,3),(964,7553883,7553865,'2e6',3.333,3),(964,7553884,7553865,'e6e',3.333,3),(964,7553885,7553865,'6e7',3.333,3),(964,7553886,7553865,'e7e',3.333,3),(964,7553887,7553865,'7ed',3.333,3),(964,7553888,7553865,'ed5',3.333,3),(964,7553889,7553865,'d55',3.333,3),(964,7553890,7553865,'554',3.333,3),(964,7553891,7553865,'541',3.333,3),(964,7553892,7553865,'41b',3.333,3),(964,7553893,7553865,'1bc',3.333,3),(964,7553894,7553865,'bcc',3.333,3),(964,7553895,7553865,'cc0',3.333,3),(964,7553896,7553866,'mon',100,1),(964,7553897,7553896,'201',50,1),(964,7553898,7553896,'013',50,1),(964,7553899,7553897,'adm',33.333,4),(964,7553900,7553897,'dmi',33.333,4),(964,7553901,7553897,'min',33.333,4),(964,7553902,7553899,'cap',16.667,1),(964,7553903,7553899,'apa',16.667,1),(964,7553904,7553899,'pac',16.667,1),(964,7553905,7553899,'aci',16.667,1),(964,7553906,7553899,'cit',16.667,1),(964,7553907,7553899,'ity',16.667,1),(964,7553908,7553902,'pat',50,1),(964,7553909,7553902,'ath',50,1),(964,7553910,7553908,'fre',14.286,1),(964,7553911,7553908,'ree',14.286,1),(964,7553912,7553908,'ees',14.286,1),(964,7553913,7553908,'esp',14.286,1),(964,7553914,7553908,'spa',14.286,1),(964,7553915,7553908,'pac',14.286,1),(964,7553916,7553908,'ace',14.286,1),(964,7553917,7553910,'dis',50,1),(964,7553918,7553910,'isk',50,1),(964,7553919,7553917,'ind',33.333,1),(964,7553920,7553917,'nde',33.333,1),(964,7553921,7553917,'dex',33.333,1),(964,7553922,7553919,'adm',8.333,1),(964,7553923,7553919,'dmi',8.333,1),(964,7553924,7553919,'min',8.333,1),(964,7553925,7553919,'ini',8.333,1),(964,7553926,7553919,'nis',8.333,1),(964,7553927,7553919,'ist',8.333,1),(964,7553928,7553919,'str',8.333,1),(964,7553929,7553919,'tra',8.333,1),(964,7553930,7553919,'rat',8.333,1),(964,7553931,7553919,'ati',8.333,1),(964,7553932,7553919,'tio',8.333,1),(964,7553933,7553919,'ion',8.333,1),(964,7553934,7553922,'sta',33.333,3),(964,7553935,7553922,'tat',33.333,3),(964,7553936,7553922,'ate',33.333,3),(964,7553937,7553934,'dis',16.667,4),(964,7553938,7553934,'isa',16.667,4),(964,7553939,7553934,'sab',16.667,4),(964,7553940,7553934,'abl',16.667,4),(964,7553941,7553934,'ble',16.667,4),(964,7553942,7553934,'led',16.667,4),(964,7553943,7553937,'cac',33.333,1),(964,7553944,7553937,'ach',33.333,1),(964,7553945,7553937,'che',33.333,1),(964,7553946,7553943,'mod',50,1),(964,7553947,7553943,'ode',50,1),(964,7553948,7553946,'wri',14.286,1),(964,7553949,7553946,'rit',14.286,1),(964,7553950,7553946,'ite',14.286,1),(964,7553951,7553946,'tet',14.286,1),(964,7553952,7553946,'eth',14.286,1),(964,7553953,7553946,'thr',14.286,1),(964,7553954,7553946,'hru',14.286,1),(964,7553955,7553948,'ope',11.111,2),(964,7553956,7553948,'per',11.111,2),(964,7553957,7553948,'era',11.111,2),(964,7553958,7553948,'rat',11.111,2),(964,7553959,7553948,'ati',11.111,2),(964,7553960,7553948,'tio',11.111,2),(964,7553961,7553948,'ion',11.111,2),(964,7553962,7553948,'ona',11.111,2),(964,7553963,7553948,'nal',11.111,2),(964,7553964,7553955,'mes',20,1),(964,7553965,7553955,'ess',20,1),(964,7553966,7553955,'ssa',20,1),(964,7553967,7553955,'sag',20,1),(964,7553968,7553955,'age',20,1),(964,7553969,7553964,'per',11.111,1),(964,7553970,7553964,'erf',11.111,1),(964,7553971,7553964,'rfo',11.111,1),(964,7553972,7553964,'for',11.111,1),(964,7553973,7553964,'orm',11.111,1),(964,7553974,7553964,'rma',11.111,1),(964,7553975,7553964,'man',11.111,1),(964,7553976,7553964,'anc',11.111,1),(964,7553977,7553964,'nce',11.111,1),(964,7553978,7553969,'ide',12.5,1),(964,7553979,7553969,'den',12.5,1),(964,7553980,7553969,'ent',12.5,1),(964,7553981,7553969,'nti',12.5,1),(964,7553982,7553969,'tif',12.5,1),(964,7553983,7553969,'ifi',12.5,1),(964,7553984,7553969,'fie',12.5,1),(964,7553985,7553969,'ier',12.5,1),(964,7553986,7553978,'vdi',33.333,3),(964,7553987,7553978,'dis',33.333,3),(964,7553988,7553978,'isk',33.333,3),(964,7553989,7553986,'nam',50,1),(964,7553990,7553986,'ame',50,1),(964,7553991,7553989,'typ',50,1),(964,7553992,7553989,'ype',50,1),(964,7553993,7553991,'dir',25,1),(964,7553994,7553991,'ire',25,1),(964,7553995,7553991,'rec',25,1),(964,7553996,7553991,'ect',25,1),(965,7553998,7553997,'naa',100,2),(965,7553999,7553998,'600',3.333,3),(965,7554000,7553998,'000',3.333,3),(965,7554001,7553998,'00c',3.333,3),(965,7554002,7553998,'0c2',3.333,3),(965,7554003,7553998,'c29',3.333,3),(965,7554004,7553998,'293',3.333,3),(965,7554005,7553998,'938',3.333,3),(965,7554006,7553998,'385',3.333,3),(965,7554007,7553998,'857',3.333,3),(965,7554008,7553998,'57b',3.333,3),(965,7554009,7553998,'7bb',3.333,3),(965,7554010,7553998,'bb8',3.333,3),(965,7554011,7553998,'b81',3.333,3),(965,7554012,7553998,'81f',3.333,3),(965,7554013,7553998,'1f2',3.333,3),(965,7554014,7553998,'f26',3.333,3),(965,7554015,7553998,'26e',3.333,3),(965,7554016,7553998,'6e5',3.333,3),(965,7554017,7553998,'e51',3.333,3),(965,7554018,7553998,'51b',3.333,3),(965,7554019,7553998,'1b8',3.333,3),(965,7554020,7553998,'b8a',3.333,3),(965,7554021,7553998,'8ac',3.333,3),(965,7554022,7553998,'ac5',3.333,3),(965,7554023,7553998,'c54',3.333,3),(965,7554024,7553998,'549',3.333,3),(965,7554025,7553998,'49a',3.333,3),(965,7554026,7553998,'9a1',3.333,3),(965,7554027,7553998,'a1c',3.333,3),(965,7554028,7553998,'1c0',3.333,3),(965,7554029,7553999,'mon',100,1),(965,7554030,7554029,'201',50,1),(965,7554031,7554029,'013',50,1),(965,7554032,7554030,'adm',33.333,4),(965,7554033,7554030,'dmi',33.333,4),(965,7554034,7554030,'min',33.333,4),(965,7554035,7554032,'cap',16.667,1),(965,7554036,7554032,'apa',16.667,1),(965,7554037,7554032,'pac',16.667,1),(965,7554038,7554032,'aci',16.667,1),(965,7554039,7554032,'cit',16.667,1),(965,7554040,7554032,'ity',16.667,1),(965,7554041,7554035,'pat',50,1),(965,7554042,7554035,'ath',50,1),(965,7554043,7554041,'fre',14.286,1),(965,7554044,7554041,'ree',14.286,1),(965,7554045,7554041,'ees',14.286,1),(965,7554046,7554041,'esp',14.286,1),(965,7554047,7554041,'spa',14.286,1),(965,7554048,7554041,'pac',14.286,1),(965,7554049,7554041,'ace',14.286,1),(965,7554050,7554043,'dis',50,1),(965,7554051,7554043,'isk',50,1),(965,7554052,7554050,'ind',33.333,1),(965,7554053,7554050,'nde',33.333,1),(965,7554054,7554050,'dex',33.333,1),(965,7554055,7554052,'adm',8.333,1),(965,7554056,7554052,'dmi',8.333,1),(965,7554057,7554052,'min',8.333,1),(965,7554058,7554052,'ini',8.333,1),(965,7554059,7554052,'nis',8.333,1),(965,7554060,7554052,'ist',8.333,1),(965,7554061,7554052,'str',8.333,1),(965,7554062,7554052,'tra',8.333,1),(965,7554063,7554052,'rat',8.333,1),(965,7554064,7554052,'ati',8.333,1),(965,7554065,7554052,'tio',8.333,1),(965,7554066,7554052,'ion',8.333,1),(965,7554067,7554055,'sta',33.333,3),(965,7554068,7554055,'tat',33.333,3),(965,7554069,7554055,'ate',33.333,3),(965,7554070,7554067,'dis',16.667,4),(965,7554071,7554067,'isa',16.667,4),(965,7554072,7554067,'sab',16.667,4),(965,7554073,7554067,'abl',16.667,4),(965,7554074,7554067,'ble',16.667,4),(965,7554075,7554067,'led',16.667,4),(965,7554076,7554070,'cac',33.333,1),(965,7554077,7554070,'ach',33.333,1),(965,7554078,7554070,'che',33.333,1),(965,7554079,7554076,'mod',50,1),(965,7554080,7554076,'ode',50,1),(965,7554081,7554079,'wri',14.286,1),(965,7554082,7554079,'rit',14.286,1),(965,7554083,7554079,'ite',14.286,1),(965,7554084,7554079,'tet',14.286,1),(965,7554085,7554079,'eth',14.286,1),(965,7554086,7554079,'thr',14.286,1),(965,7554087,7554079,'hru',14.286,1),(965,7554088,7554081,'ope',11.111,2),(965,7554089,7554081,'per',11.111,2),(965,7554090,7554081,'era',11.111,2),(965,7554091,7554081,'rat',11.111,2),(965,7554092,7554081,'ati',11.111,2),(965,7554093,7554081,'tio',11.111,2),(965,7554094,7554081,'ion',11.111,2),(965,7554095,7554081,'ona',11.111,2),(965,7554096,7554081,'nal',11.111,2),(965,7554097,7554088,'mes',20,1),(965,7554098,7554088,'ess',20,1),(965,7554099,7554088,'ssa',20,1),(965,7554100,7554088,'sag',20,1),(965,7554101,7554088,'age',20,1),(965,7554102,7554097,'per',11.111,1),(965,7554103,7554097,'erf',11.111,1),(965,7554104,7554097,'rfo',11.111,1),(965,7554105,7554097,'for',11.111,1),(965,7554106,7554097,'orm',11.111,1),(965,7554107,7554097,'rma',11.111,1),(965,7554108,7554097,'man',11.111,1),(965,7554109,7554097,'anc',11.111,1),(965,7554110,7554097,'nce',11.111,1),(965,7554111,7554102,'ide',12.5,1),(965,7554112,7554102,'den',12.5,1),(965,7554113,7554102,'ent',12.5,1),(965,7554114,7554102,'nti',12.5,1),(965,7554115,7554102,'tif',12.5,1),(965,7554116,7554102,'ifi',12.5,1),(965,7554117,7554102,'fie',12.5,1),(965,7554118,7554102,'ier',12.5,1),(965,7554119,7554111,'vdi',33.333,3),(965,7554120,7554111,'dis',33.333,3),(965,7554121,7554111,'isk',33.333,3),(965,7554122,7554119,'nam',50,1),(965,7554123,7554119,'ame',50,1),(965,7554124,7554122,'typ',50,1),(965,7554125,7554122,'ype',50,1),(965,7554126,7554124,'dir',25,1),(965,7554127,7554124,'ire',25,1),(965,7554128,7554124,'rec',25,1),(965,7554129,7554124,'ect',25,1),(966,7554131,7554130,'naa',100,2),(966,7554132,7554131,'600',3.333,3),(966,7554133,7554131,'000',3.333,3),(966,7554134,7554131,'00c',3.333,3),(966,7554135,7554131,'0c2',3.333,3),(966,7554136,7554131,'c29',3.333,3),(966,7554137,7554131,'297',3.333,3),(966,7554138,7554131,'977',3.333,3),(966,7554139,7554131,'779',3.333,3),(966,7554140,7554131,'795',3.333,3),(966,7554141,7554131,'95b',3.333,3),(966,7554142,7554131,'5b4',3.333,3),(966,7554143,7554131,'b43',3.333,3),(966,7554144,7554131,'43f',3.333,3),(966,7554145,7554131,'3f0',3.333,3),(966,7554146,7554131,'f00',3.333,3),(966,7554147,7554131,'004',3.333,3),(966,7554148,7554131,'041',3.333,3),(966,7554149,7554131,'417',3.333,3),(966,7554150,7554131,'176',3.333,3),(966,7554151,7554131,'761',3.333,3),(966,7554152,7554131,'61f',3.333,3),(966,7554153,7554131,'1fc',3.333,3),(966,7554154,7554131,'fc1',3.333,3),(966,7554155,7554131,'c17',3.333,3),(966,7554156,7554131,'171',3.333,3),(966,7554157,7554131,'71e',3.333,3),(966,7554158,7554131,'1ef',3.333,3),(966,7554159,7554131,'ef9',3.333,3),(966,7554160,7554131,'f90',3.333,3),(966,7554161,7554131,'906',3.333,3),(966,7554162,7554132,'mon',100,1),(966,7554163,7554162,'201',50,1),(966,7554164,7554162,'013',50,1),(966,7554165,7554163,'adm',33.333,4),(966,7554166,7554163,'dmi',33.333,4),(966,7554167,7554163,'min',33.333,4),(966,7554168,7554165,'cap',16.667,1),(966,7554169,7554165,'apa',16.667,1),(966,7554170,7554165,'pac',16.667,1),(966,7554171,7554165,'aci',16.667,1),(966,7554172,7554165,'cit',16.667,1),(966,7554173,7554165,'ity',16.667,1),(966,7554174,7554168,'pat',50,1),(966,7554175,7554168,'ath',50,1),(966,7554176,7554174,'one',100,1),(966,7554177,7554176,'fre',14.286,1),(966,7554178,7554176,'ree',14.286,1),(966,7554179,7554176,'ees',14.286,1),(966,7554180,7554176,'esp',14.286,1),(966,7554181,7554176,'spa',14.286,1),(966,7554182,7554176,'pac',14.286,1),(966,7554183,7554176,'ace',14.286,1),(966,7554184,7554177,'dis',50,1),(966,7554185,7554177,'isk',50,1),(966,7554186,7554184,'ind',33.333,1),(966,7554187,7554184,'nde',33.333,1),(966,7554188,7554184,'dex',33.333,1),(966,7554189,7554186,'adm',8.333,1),(966,7554190,7554186,'dmi',8.333,1),(966,7554191,7554186,'min',8.333,1),(966,7554192,7554186,'ini',8.333,1),(966,7554193,7554186,'nis',8.333,1),(966,7554194,7554186,'ist',8.333,1),(966,7554195,7554186,'str',8.333,1),(966,7554196,7554186,'tra',8.333,1),(966,7554197,7554186,'rat',8.333,1),(966,7554198,7554186,'ati',8.333,1),(966,7554199,7554186,'tio',8.333,1),(966,7554200,7554186,'ion',8.333,1),(966,7554201,7554189,'sta',33.333,3),(966,7554202,7554189,'tat',33.333,3),(966,7554203,7554189,'ate',33.333,3),(966,7554204,7554201,'dis',16.667,4),(966,7554205,7554201,'isa',16.667,4),(966,7554206,7554201,'sab',16.667,4),(966,7554207,7554201,'abl',16.667,4),(966,7554208,7554201,'ble',16.667,4),(966,7554209,7554201,'led',16.667,4),(966,7554210,7554204,'cac',33.333,1),(966,7554211,7554204,'ach',33.333,1),(966,7554212,7554204,'che',33.333,1),(966,7554213,7554210,'mod',50,1),(966,7554214,7554210,'ode',50,1),(966,7554215,7554213,'wri',14.286,1),(966,7554216,7554213,'rit',14.286,1),(966,7554217,7554213,'ite',14.286,1),(966,7554218,7554213,'tet',14.286,1),(966,7554219,7554213,'eth',14.286,1),(966,7554220,7554213,'thr',14.286,1),(966,7554221,7554213,'hru',14.286,1),(966,7554222,7554215,'ope',11.111,2),(966,7554223,7554215,'per',11.111,2),(966,7554224,7554215,'era',11.111,2),(966,7554225,7554215,'rat',11.111,2),(966,7554226,7554215,'ati',11.111,2),(966,7554227,7554215,'tio',11.111,2),(966,7554228,7554215,'ion',11.111,2),(966,7554229,7554215,'ona',11.111,2),(966,7554230,7554215,'nal',11.111,2),(966,7554231,7554222,'mes',20,1),(966,7554232,7554222,'ess',20,1),(966,7554233,7554222,'ssa',20,1),(966,7554234,7554222,'sag',20,1),(966,7554235,7554222,'age',20,1),(966,7554236,7554231,'per',11.111,1),(966,7554237,7554231,'erf',11.111,1),(966,7554238,7554231,'rfo',11.111,1),(966,7554239,7554231,'for',11.111,1),(966,7554240,7554231,'orm',11.111,1),(966,7554241,7554231,'rma',11.111,1),(966,7554242,7554231,'man',11.111,1),(966,7554243,7554231,'anc',11.111,1),(966,7554244,7554231,'nce',11.111,1),(966,7554245,7554236,'ide',12.5,1),(966,7554246,7554236,'den',12.5,1),(966,7554247,7554236,'ent',12.5,1),(966,7554248,7554236,'nti',12.5,1),(966,7554249,7554236,'tif',12.5,1),(966,7554250,7554236,'ifi',12.5,1),(966,7554251,7554236,'fie',12.5,1),(966,7554252,7554236,'ier',12.5,1),(966,7554253,7554245,'vdi',33.333,3),(966,7554254,7554245,'dis',33.333,3),(966,7554255,7554245,'isk',33.333,3),(966,7554256,7554253,'nam',50,1),(966,7554257,7554253,'ame',50,1),(966,7554258,7554256,'typ',50,1),(966,7554259,7554256,'ype',50,1),(966,7554260,7554258,'dir',25,1),(966,7554261,7554258,'ire',25,1),(966,7554262,7554258,'rec',25,1),(966,7554263,7554258,'ect',25,1),(967,7554265,7554264,'naa',100,2),(967,7554266,7554265,'600',3.333,3),(967,7554267,7554265,'000',3.333,3),(967,7554268,7554265,'00c',3.333,3),(967,7554269,7554265,'0c2',3.333,3),(967,7554270,7554265,'c29',3.333,3),(967,7554271,7554265,'29b',3.333,3),(967,7554272,7554265,'9b1',3.333,3),(967,7554273,7554265,'b1a',3.333,3),(967,7554274,7554265,'1a9',3.333,3),(967,7554275,7554265,'a9e',3.333,3),(967,7554276,7554265,'9eb',3.333,3),(967,7554277,7554265,'eb1',3.333,3),(967,7554278,7554265,'b17',3.333,3),(967,7554279,7554265,'171',3.333,3),(967,7554280,7554265,'71f',3.333,3),(967,7554281,7554265,'1ff',3.333,3),(967,7554282,7554265,'ff6',3.333,3),(967,7554283,7554265,'f6e',3.333,3),(967,7554284,7554265,'6e1',3.333,3),(967,7554285,7554265,'e1a',3.333,3),(967,7554286,7554265,'1a7',3.333,3),(967,7554287,7554265,'a7e',3.333,3),(967,7554288,7554265,'7ec',3.333,3),(967,7554289,7554265,'ec5',3.333,3),(967,7554290,7554265,'c51',3.333,3),(967,7554291,7554265,'515',3.333,3),(967,7554292,7554265,'154',3.333,3),(967,7554293,7554265,'54c',3.333,3),(967,7554294,7554265,'4c0',3.333,3),(967,7554295,7554265,'c06',3.333,3),(967,7554296,7554266,'mon',100,1),(967,7554297,7554296,'201',50,1),(967,7554298,7554296,'013',50,1),(967,7554299,7554297,'adm',33.333,4),(967,7554300,7554297,'dmi',33.333,4),(967,7554301,7554297,'min',33.333,4),(967,7554302,7554299,'cap',16.667,1),(967,7554303,7554299,'apa',16.667,1),(967,7554304,7554299,'pac',16.667,1),(967,7554305,7554299,'aci',16.667,1),(967,7554306,7554299,'cit',16.667,1),(967,7554307,7554299,'ity',16.667,1),(967,7554308,7554302,'pat',50,1),(967,7554309,7554302,'ath',50,1),(967,7554310,7554308,'fre',14.286,1),(967,7554311,7554308,'ree',14.286,1),(967,7554312,7554308,'ees',14.286,1),(967,7554313,7554308,'esp',14.286,1),(967,7554314,7554308,'spa',14.286,1),(967,7554315,7554308,'pac',14.286,1),(967,7554316,7554308,'ace',14.286,1),(967,7554317,7554310,'dis',50,1),(967,7554318,7554310,'isk',50,1),(967,7554319,7554317,'ind',33.333,1),(967,7554320,7554317,'nde',33.333,1),(967,7554321,7554317,'dex',33.333,1),(967,7554322,7554319,'adm',8.333,1),(967,7554323,7554319,'dmi',8.333,1),(967,7554324,7554319,'min',8.333,1),(967,7554325,7554319,'ini',8.333,1),(967,7554326,7554319,'nis',8.333,1),(967,7554327,7554319,'ist',8.333,1),(967,7554328,7554319,'str',8.333,1),(967,7554329,7554319,'tra',8.333,1),(967,7554330,7554319,'rat',8.333,1),(967,7554331,7554319,'ati',8.333,1),(967,7554332,7554319,'tio',8.333,1),(967,7554333,7554319,'ion',8.333,1),(967,7554334,7554322,'sta',33.333,3),(967,7554335,7554322,'tat',33.333,3),(967,7554336,7554322,'ate',33.333,3),(967,7554337,7554334,'dis',16.667,4),(967,7554338,7554334,'isa',16.667,4),(967,7554339,7554334,'sab',16.667,4),(967,7554340,7554334,'abl',16.667,4),(967,7554341,7554334,'ble',16.667,4),(967,7554342,7554334,'led',16.667,4),(967,7554343,7554337,'cac',33.333,1),(967,7554344,7554337,'ach',33.333,1),(967,7554345,7554337,'che',33.333,1),(967,7554346,7554343,'mod',50,1),(967,7554347,7554343,'ode',50,1),(967,7554348,7554346,'wri',14.286,1),(967,7554349,7554346,'rit',14.286,1),(967,7554350,7554346,'ite',14.286,1),(967,7554351,7554346,'tet',14.286,1),(967,7554352,7554346,'eth',14.286,1),(967,7554353,7554346,'thr',14.286,1),(967,7554354,7554346,'hru',14.286,1),(967,7554355,7554348,'ope',11.111,2),(967,7554356,7554348,'per',11.111,2),(967,7554357,7554348,'era',11.111,2),(967,7554358,7554348,'rat',11.111,2),(967,7554359,7554348,'ati',11.111,2),(967,7554360,7554348,'tio',11.111,2),(967,7554361,7554348,'ion',11.111,2),(967,7554362,7554348,'ona',11.111,2),(967,7554363,7554348,'nal',11.111,2),(967,7554364,7554355,'mes',20,1),(967,7554365,7554355,'ess',20,1),(967,7554366,7554355,'ssa',20,1),(967,7554367,7554355,'sag',20,1),(967,7554368,7554355,'age',20,1),(967,7554369,7554364,'per',11.111,1),(967,7554370,7554364,'erf',11.111,1),(967,7554371,7554364,'rfo',11.111,1),(967,7554372,7554364,'for',11.111,1),(967,7554373,7554364,'orm',11.111,1),(967,7554374,7554364,'rma',11.111,1),(967,7554375,7554364,'man',11.111,1),(967,7554376,7554364,'anc',11.111,1),(967,7554377,7554364,'nce',11.111,1),(967,7554378,7554369,'ide',12.5,1),(967,7554379,7554369,'den',12.5,1),(967,7554380,7554369,'ent',12.5,1),(967,7554381,7554369,'nti',12.5,1),(967,7554382,7554369,'tif',12.5,1),(967,7554383,7554369,'ifi',12.5,1),(967,7554384,7554369,'fie',12.5,1),(967,7554385,7554369,'ier',12.5,1),(967,7554386,7554378,'vdi',33.333,3),(967,7554387,7554378,'dis',33.333,3),(967,7554388,7554378,'isk',33.333,3),(967,7554389,7554386,'nam',50,1),(967,7554390,7554386,'ame',50,1),(967,7554391,7554389,'typ',50,1),(967,7554392,7554389,'ype',50,1),(967,7554393,7554391,'dir',25,1),(967,7554394,7554391,'ire',25,1),(967,7554395,7554391,'rec',25,1),(967,7554396,7554391,'ect',25,1),(968,7554398,7554397,'naa',100,2),(968,7554399,7554398,'600',3.333,3),(968,7554400,7554398,'000',3.333,3),(968,7554401,7554398,'00c',3.333,3),(968,7554402,7554398,'0c2',3.333,3),(968,7554403,7554398,'c29',3.333,3),(968,7554404,7554398,'293',3.333,3),(968,7554405,7554398,'936',3.333,3),(968,7554406,7554398,'369',3.333,3),(968,7554407,7554398,'690',3.333,3),(968,7554408,7554398,'901',3.333,3),(968,7554409,7554398,'01f',3.333,3),(968,7554410,7554398,'1f1',3.333,3),(968,7554411,7554398,'f19',3.333,3),(968,7554412,7554398,'19d',3.333,3),(968,7554413,7554398,'9d6',3.333,3),(968,7554414,7554398,'d63',3.333,3),(968,7554415,7554398,'63c',3.333,3),(968,7554416,7554398,'3cd',3.333,3),(968,7554417,7554398,'cd9',3.333,3),(968,7554418,7554398,'d9e',3.333,3),(968,7554419,7554398,'9e1',3.333,3),(968,7554420,7554398,'e18',3.333,3),(968,7554421,7554398,'18d',3.333,3),(968,7554422,7554398,'8d9',3.333,3),(968,7554423,7554398,'d96',3.333,3),(968,7554424,7554398,'96f',3.333,3),(968,7554425,7554398,'6f9',3.333,3),(968,7554426,7554398,'f91',3.333,3),(968,7554427,7554398,'91b',3.333,3),(968,7554428,7554398,'1bd',3.333,3),(968,7554429,7554399,'mon',100,1),(968,7554430,7554429,'201',50,1),(968,7554431,7554429,'013',50,1),(968,7554432,7554430,'adm',33.333,4),(968,7554433,7554430,'dmi',33.333,4),(968,7554434,7554430,'min',33.333,4),(968,7554435,7554432,'cap',16.667,1),(968,7554436,7554432,'apa',16.667,1),(968,7554437,7554432,'pac',16.667,1),(968,7554438,7554432,'aci',16.667,1),(968,7554439,7554432,'cit',16.667,1),(968,7554440,7554432,'ity',16.667,1),(968,7554441,7554435,'pat',50,1),(968,7554442,7554435,'ath',50,1),(968,7554443,7554441,'fou',50,1),(968,7554444,7554441,'our',50,1),(968,7554445,7554443,'fre',14.286,1),(968,7554446,7554443,'ree',14.286,1),(968,7554447,7554443,'ees',14.286,1),(968,7554448,7554443,'esp',14.286,1),(968,7554449,7554443,'spa',14.286,1),(968,7554450,7554443,'pac',14.286,1),(968,7554451,7554443,'ace',14.286,1),(968,7554452,7554445,'dis',50,1),(968,7554453,7554445,'isk',50,1),(968,7554454,7554452,'ind',33.333,1),(968,7554455,7554452,'nde',33.333,1),(968,7554456,7554452,'dex',33.333,1),(968,7554457,7554454,'adm',8.333,1),(968,7554458,7554454,'dmi',8.333,1),(968,7554459,7554454,'min',8.333,1),(968,7554460,7554454,'ini',8.333,1),(968,7554461,7554454,'nis',8.333,1),(968,7554462,7554454,'ist',8.333,1),(968,7554463,7554454,'str',8.333,1),(968,7554464,7554454,'tra',8.333,1),(968,7554465,7554454,'rat',8.333,1),(968,7554466,7554454,'ati',8.333,1),(968,7554467,7554454,'tio',8.333,1),(968,7554468,7554454,'ion',8.333,1),(968,7554469,7554457,'sta',33.333,3),(968,7554470,7554457,'tat',33.333,3),(968,7554471,7554457,'ate',33.333,3),(968,7554472,7554469,'dis',16.667,4),(968,7554473,7554469,'isa',16.667,4),(968,7554474,7554469,'sab',16.667,4),(968,7554475,7554469,'abl',16.667,4),(968,7554476,7554469,'ble',16.667,4),(968,7554477,7554469,'led',16.667,4),(968,7554478,7554472,'cac',33.333,1),(968,7554479,7554472,'ach',33.333,1),(968,7554480,7554472,'che',33.333,1),(968,7554481,7554478,'mod',50,1),(968,7554482,7554478,'ode',50,1),(968,7554483,7554481,'wri',14.286,1),(968,7554484,7554481,'rit',14.286,1),(968,7554485,7554481,'ite',14.286,1),(968,7554486,7554481,'tet',14.286,1),(968,7554487,7554481,'eth',14.286,1),(968,7554488,7554481,'thr',14.286,1),(968,7554489,7554481,'hru',14.286,1),(968,7554490,7554483,'ope',11.111,2),(968,7554491,7554483,'per',11.111,2),(968,7554492,7554483,'era',11.111,2),(968,7554493,7554483,'rat',11.111,2),(968,7554494,7554483,'ati',11.111,2),(968,7554495,7554483,'tio',11.111,2),(968,7554496,7554483,'ion',11.111,2),(968,7554497,7554483,'ona',11.111,2),(968,7554498,7554483,'nal',11.111,2),(968,7554499,7554490,'mes',20,1),(968,7554500,7554490,'ess',20,1),(968,7554501,7554490,'ssa',20,1),(968,7554502,7554490,'sag',20,1),(968,7554503,7554490,'age',20,1),(968,7554504,7554499,'per',11.111,1),(968,7554505,7554499,'erf',11.111,1),(968,7554506,7554499,'rfo',11.111,1),(968,7554507,7554499,'for',11.111,1),(968,7554508,7554499,'orm',11.111,1),(968,7554509,7554499,'rma',11.111,1),(968,7554510,7554499,'man',11.111,1),(968,7554511,7554499,'anc',11.111,1),(968,7554512,7554499,'nce',11.111,1),(968,7554513,7554504,'ide',12.5,1),(968,7554514,7554504,'den',12.5,1),(968,7554515,7554504,'ent',12.5,1),(968,7554516,7554504,'nti',12.5,1),(968,7554517,7554504,'tif',12.5,1),(968,7554518,7554504,'ifi',12.5,1),(968,7554519,7554504,'fie',12.5,1),(968,7554520,7554504,'ier',12.5,1),(968,7554521,7554513,'vdi',33.333,3),(968,7554522,7554513,'dis',33.333,3),(968,7554523,7554513,'isk',33.333,3),(968,7554524,7554521,'nam',50,1),(968,7554525,7554521,'ame',50,1),(968,7554526,7554524,'typ',50,1),(968,7554527,7554524,'ype',50,1),(968,7554528,7554526,'dir',25,1),(968,7554529,7554526,'ire',25,1),(968,7554530,7554526,'rec',25,1),(968,7554531,7554526,'ect',25,1),(969,7554533,7554532,'naa',100,2),(969,7554534,7554533,'600',3.333,3),(969,7554535,7554533,'000',3.333,3),(969,7554536,7554533,'00c',3.333,3),(969,7554537,7554533,'0c2',3.333,3),(969,7554538,7554533,'c29',3.333,3),(969,7554539,7554533,'295',3.333,3),(969,7554540,7554533,'95c',3.333,3),(969,7554541,7554533,'5c9',3.333,3),(969,7554542,7554533,'c9e',3.333,3),(969,7554543,7554533,'9e3',3.333,3),(969,7554544,7554533,'e3e',3.333,3),(969,7554545,7554533,'3e0',3.333,3),(969,7554546,7554533,'e07',3.333,3),(969,7554547,7554533,'075',3.333,3),(969,7554548,7554533,'759',3.333,3),(969,7554549,7554533,'59c',3.333,3),(969,7554550,7554533,'9c9',3.333,3),(969,7554551,7554533,'c91',3.333,3),(969,7554552,7554533,'91e',3.333,3),(969,7554553,7554533,'1e7',3.333,3),(969,7554554,7554533,'e74',3.333,3),(969,7554555,7554533,'744',3.333,3),(969,7554556,7554533,'447',3.333,3),(969,7554557,7554533,'47d',3.333,3),(969,7554558,7554533,'7d0',3.333,3),(969,7554559,7554533,'d0a',3.333,3),(969,7554560,7554533,'0ad',3.333,3),(969,7554561,7554533,'adc',3.333,3),(969,7554562,7554533,'dc1',3.333,3),(969,7554563,7554533,'c16',3.333,3),(969,7554564,7554534,'mon',100,1),(969,7554565,7554564,'201',50,1),(969,7554566,7554564,'013',50,1),(969,7554567,7554565,'adm',33.333,4),(969,7554568,7554565,'dmi',33.333,4),(969,7554569,7554565,'min',33.333,4),(969,7554570,7554567,'cap',16.667,1),(969,7554571,7554567,'apa',16.667,1),(969,7554572,7554567,'pac',16.667,1),(969,7554573,7554567,'aci',16.667,1),(969,7554574,7554567,'cit',16.667,1),(969,7554575,7554567,'ity',16.667,1),(969,7554576,7554570,'pat',50,1),(969,7554577,7554570,'ath',50,1),(969,7554578,7554576,'fiv',50,1),(969,7554579,7554576,'ive',50,1),(969,7554580,7554578,'fre',14.286,1),(969,7554581,7554578,'ree',14.286,1),(969,7554582,7554578,'ees',14.286,1),(969,7554583,7554578,'esp',14.286,1),(969,7554584,7554578,'spa',14.286,1),(969,7554585,7554578,'pac',14.286,1),(969,7554586,7554578,'ace',14.286,1),(969,7554587,7554580,'dis',50,1),(969,7554588,7554580,'isk',50,1),(969,7554589,7554587,'ind',33.333,1),(969,7554590,7554587,'nde',33.333,1),(969,7554591,7554587,'dex',33.333,1),(969,7554592,7554589,'adm',8.333,1),(969,7554593,7554589,'dmi',8.333,1),(969,7554594,7554589,'min',8.333,1),(969,7554595,7554589,'ini',8.333,1),(969,7554596,7554589,'nis',8.333,1),(969,7554597,7554589,'ist',8.333,1),(969,7554598,7554589,'str',8.333,1),(969,7554599,7554589,'tra',8.333,1),(969,7554600,7554589,'rat',8.333,1),(969,7554601,7554589,'ati',8.333,1),(969,7554602,7554589,'tio',8.333,1),(969,7554603,7554589,'ion',8.333,1),(969,7554604,7554592,'sta',33.333,3),(969,7554605,7554592,'tat',33.333,3),(969,7554606,7554592,'ate',33.333,3),(969,7554607,7554604,'dis',16.667,4),(969,7554608,7554604,'isa',16.667,4),(969,7554609,7554604,'sab',16.667,4),(969,7554610,7554604,'abl',16.667,4),(969,7554611,7554604,'ble',16.667,4),(969,7554612,7554604,'led',16.667,4),(969,7554613,7554607,'cac',33.333,1),(969,7554614,7554607,'ach',33.333,1),(969,7554615,7554607,'che',33.333,1),(969,7554616,7554613,'mod',50,1),(969,7554617,7554613,'ode',50,1),(969,7554618,7554616,'wri',14.286,1),(969,7554619,7554616,'rit',14.286,1),(969,7554620,7554616,'ite',14.286,1),(969,7554621,7554616,'tet',14.286,1),(969,7554622,7554616,'eth',14.286,1),(969,7554623,7554616,'thr',14.286,1),(969,7554624,7554616,'hru',14.286,1),(969,7554625,7554618,'ope',11.111,2),(969,7554626,7554618,'per',11.111,2),(969,7554627,7554618,'era',11.111,2),(969,7554628,7554618,'rat',11.111,2),(969,7554629,7554618,'ati',11.111,2),(969,7554630,7554618,'tio',11.111,2),(969,7554631,7554618,'ion',11.111,2),(969,7554632,7554618,'ona',11.111,2),(969,7554633,7554618,'nal',11.111,2),(969,7554634,7554625,'mes',20,1),(969,7554635,7554625,'ess',20,1),(969,7554636,7554625,'ssa',20,1),(969,7554637,7554625,'sag',20,1),(969,7554638,7554625,'age',20,1),(969,7554639,7554634,'per',11.111,1),(969,7554640,7554634,'erf',11.111,1),(969,7554641,7554634,'rfo',11.111,1),(969,7554642,7554634,'for',11.111,1),(969,7554643,7554634,'orm',11.111,1),(969,7554644,7554634,'rma',11.111,1),(969,7554645,7554634,'man',11.111,1),(969,7554646,7554634,'anc',11.111,1),(969,7554647,7554634,'nce',11.111,1),(969,7554648,7554639,'ide',12.5,1),(969,7554649,7554639,'den',12.5,1),(969,7554650,7554639,'ent',12.5,1),(969,7554651,7554639,'nti',12.5,1),(969,7554652,7554639,'tif',12.5,1),(969,7554653,7554639,'ifi',12.5,1),(969,7554654,7554639,'fie',12.5,1),(969,7554655,7554639,'ier',12.5,1),(969,7554656,7554648,'vdi',33.333,3),(969,7554657,7554648,'dis',33.333,3),(969,7554658,7554648,'isk',33.333,3),(969,7554659,7554656,'nam',50,1),(969,7554660,7554656,'ame',50,1),(969,7554661,7554659,'typ',50,1),(969,7554662,7554659,'ype',50,1),(969,7554663,7554661,'dir',25,1),(969,7554664,7554661,'ire',25,1),(969,7554665,7554661,'rec',25,1),(969,7554666,7554661,'ect',25,1),(970,7554668,7554667,'naa',100,2),(970,7554669,7554668,'600',3.333,3),(970,7554670,7554668,'000',3.333,3),(970,7554671,7554668,'00c',3.333,3),(970,7554672,7554668,'0c2',3.333,3),(970,7554673,7554668,'c29',3.333,3),(970,7554674,7554668,'29f',3.333,3),(970,7554675,7554668,'9f0',3.333,3),(970,7554676,7554668,'f0a',3.333,3),(970,7554677,7554668,'0ab',3.333,3),(970,7554678,7554668,'ab6',3.333,3),(970,7554679,7554668,'b61',3.333,3),(970,7554680,7554668,'61d',3.333,3),(970,7554681,7554668,'1d0',3.333,3),(970,7554682,7554668,'d06',3.333,3),(970,7554683,7554668,'065',3.333,3),(970,7554684,7554668,'657',3.333,3),(970,7554685,7554668,'578',3.333,3),(970,7554686,7554668,'78e',3.333,3),(970,7554687,7554668,'8e5',3.333,3),(970,7554688,7554668,'e5b',3.333,3),(970,7554689,7554668,'5b6',3.333,3),(970,7554690,7554668,'b6d',3.333,3),(970,7554691,7554668,'6d3',3.333,3),(970,7554692,7554668,'d3f',3.333,3),(970,7554693,7554668,'3fb',3.333,3),(970,7554694,7554668,'fbe',3.333,3),(970,7554695,7554668,'beb',3.333,3),(970,7554696,7554668,'eb6',3.333,3),(970,7554697,7554668,'b65',3.333,3),(970,7554698,7554668,'65c',3.333,3),(970,7554699,7554669,'mon',100,1),(970,7554700,7554699,'201',50,1),(970,7554701,7554699,'013',50,1),(970,7554702,7554700,'adm',33.333,4),(970,7554703,7554700,'dmi',33.333,4),(970,7554704,7554700,'min',33.333,4),(970,7554705,7554702,'cap',16.667,1),(970,7554706,7554702,'apa',16.667,1),(970,7554707,7554702,'pac',16.667,1),(970,7554708,7554702,'aci',16.667,1),(970,7554709,7554702,'cit',16.667,1),(970,7554710,7554702,'ity',16.667,1),(970,7554711,7554705,'pat',50,1),(970,7554712,7554705,'ath',50,1),(970,7554713,7554711,'six',100,1),(970,7554714,7554713,'fre',14.286,1),(970,7554715,7554713,'ree',14.286,1),(970,7554716,7554713,'ees',14.286,1),(970,7554717,7554713,'esp',14.286,1),(970,7554718,7554713,'spa',14.286,1),(970,7554719,7554713,'pac',14.286,1),(970,7554720,7554713,'ace',14.286,1),(970,7554721,7554714,'dis',50,1),(970,7554722,7554714,'isk',50,1),(970,7554723,7554721,'ind',33.333,1),(970,7554724,7554721,'nde',33.333,1),(970,7554725,7554721,'dex',33.333,1),(970,7554726,7554723,'adm',8.333,1),(970,7554727,7554723,'dmi',8.333,1),(970,7554728,7554723,'min',8.333,1),(970,7554729,7554723,'ini',8.333,1),(970,7554730,7554723,'nis',8.333,1),(970,7554731,7554723,'ist',8.333,1),(970,7554732,7554723,'str',8.333,1),(970,7554733,7554723,'tra',8.333,1),(970,7554734,7554723,'rat',8.333,1),(970,7554735,7554723,'ati',8.333,1),(970,7554736,7554723,'tio',8.333,1),(970,7554737,7554723,'ion',8.333,1),(970,7554738,7554726,'sta',33.333,3),(970,7554739,7554726,'tat',33.333,3),(970,7554740,7554726,'ate',33.333,3),(970,7554741,7554738,'dis',16.667,4),(970,7554742,7554738,'isa',16.667,4),(970,7554743,7554738,'sab',16.667,4),(970,7554744,7554738,'abl',16.667,4),(970,7554745,7554738,'ble',16.667,4),(970,7554746,7554738,'led',16.667,4),(970,7554747,7554741,'cac',33.333,1),(970,7554748,7554741,'ach',33.333,1),(970,7554749,7554741,'che',33.333,1),(970,7554750,7554747,'mod',50,1),(970,7554751,7554747,'ode',50,1),(970,7554752,7554750,'wri',14.286,1),(970,7554753,7554750,'rit',14.286,1),(970,7554754,7554750,'ite',14.286,1),(970,7554755,7554750,'tet',14.286,1),(970,7554756,7554750,'eth',14.286,1),(970,7554757,7554750,'thr',14.286,1),(970,7554758,7554750,'hru',14.286,1),(970,7554759,7554752,'ope',11.111,2),(970,7554760,7554752,'per',11.111,2),(970,7554761,7554752,'era',11.111,2),(970,7554762,7554752,'rat',11.111,2),(970,7554763,7554752,'ati',11.111,2),(970,7554764,7554752,'tio',11.111,2),(970,7554765,7554752,'ion',11.111,2),(970,7554766,7554752,'ona',11.111,2),(970,7554767,7554752,'nal',11.111,2),(970,7554768,7554759,'mes',20,1),(970,7554769,7554759,'ess',20,1),(970,7554770,7554759,'ssa',20,1),(970,7554771,7554759,'sag',20,1),(970,7554772,7554759,'age',20,1),(970,7554773,7554768,'per',11.111,1),(970,7554774,7554768,'erf',11.111,1),(970,7554775,7554768,'rfo',11.111,1),(970,7554776,7554768,'for',11.111,1),(970,7554777,7554768,'orm',11.111,1),(970,7554778,7554768,'rma',11.111,1),(970,7554779,7554768,'man',11.111,1),(970,7554780,7554768,'anc',11.111,1),(970,7554781,7554768,'nce',11.111,1),(970,7554782,7554773,'ide',12.5,1),(970,7554783,7554773,'den',12.5,1),(970,7554784,7554773,'ent',12.5,1),(970,7554785,7554773,'nti',12.5,1),(970,7554786,7554773,'tif',12.5,1),(970,7554787,7554773,'ifi',12.5,1),(970,7554788,7554773,'fie',12.5,1),(970,7554789,7554773,'ier',12.5,1),(970,7554790,7554782,'vdi',33.333,3),(970,7554791,7554782,'dis',33.333,3),(970,7554792,7554782,'isk',33.333,3),(970,7554793,7554790,'nam',50,1),(970,7554794,7554790,'ame',50,1),(970,7554795,7554793,'typ',50,1),(970,7554796,7554793,'ype',50,1),(970,7554797,7554795,'dir',25,1),(970,7554798,7554795,'ire',25,1),(970,7554799,7554795,'rec',25,1),(970,7554800,7554795,'ect',25,1),(971,7554802,7554801,'naa',100,2),(971,7554803,7554802,'600',3.333,3),(971,7554804,7554802,'000',3.333,3),(971,7554805,7554802,'00c',3.333,3),(971,7554806,7554802,'0c2',3.333,3),(971,7554807,7554802,'c29',3.333,3),(971,7554808,7554802,'299',3.333,3),(971,7554809,7554802,'99c',3.333,3),(971,7554810,7554802,'9c9',3.333,3),(971,7554811,7554802,'c95',3.333,3),(971,7554812,7554802,'956',3.333,3),(971,7554813,7554802,'568',3.333,3),(971,7554814,7554802,'682',3.333,3),(971,7554815,7554802,'82a',3.333,3),(971,7554816,7554802,'2aa',3.333,3),(971,7554817,7554802,'aa3',3.333,3),(971,7554818,7554802,'a38',3.333,3),(971,7554819,7554802,'388',3.333,3),(971,7554820,7554802,'887',3.333,3),(971,7554821,7554802,'878',3.333,3),(971,7554822,7554802,'78d',3.333,3),(971,7554823,7554802,'8d5',3.333,3),(971,7554824,7554802,'d51',3.333,3),(971,7554825,7554802,'512',3.333,3),(971,7554826,7554802,'124',3.333,3),(971,7554827,7554802,'240',3.333,3),(971,7554828,7554802,'407',3.333,3),(971,7554829,7554802,'07b',3.333,3),(971,7554830,7554802,'7b4',3.333,3),(971,7554831,7554802,'b4c',3.333,3),(971,7554832,7554802,'4c1',3.333,3),(971,7554833,7554803,'mon',100,1),(971,7554834,7554833,'201',50,1),(971,7554835,7554833,'013',50,1),(971,7554836,7554834,'adm',33.333,4),(971,7554837,7554834,'dmi',33.333,4),(971,7554838,7554834,'min',33.333,4),(971,7554839,7554836,'cap',16.667,1),(971,7554840,7554836,'apa',16.667,1),(971,7554841,7554836,'pac',16.667,1),(971,7554842,7554836,'aci',16.667,1),(971,7554843,7554836,'cit',16.667,1),(971,7554844,7554836,'ity',16.667,1),(971,7554845,7554839,'pat',50,1),(971,7554846,7554839,'ath',50,1),(971,7554847,7554845,'sev',33.333,1),(971,7554848,7554845,'eve',33.333,1),(971,7554849,7554845,'ven',33.333,1),(971,7554850,7554847,'fre',14.286,1),(971,7554851,7554847,'ree',14.286,1),(971,7554852,7554847,'ees',14.286,1),(971,7554853,7554847,'esp',14.286,1),(971,7554854,7554847,'spa',14.286,1),(971,7554855,7554847,'pac',14.286,1),(971,7554856,7554847,'ace',14.286,1),(971,7554857,7554850,'dis',50,1),(971,7554858,7554850,'isk',50,1),(971,7554859,7554857,'ind',33.333,1),(971,7554860,7554857,'nde',33.333,1),(971,7554861,7554857,'dex',33.333,1),(971,7554862,7554859,'adm',8.333,1),(971,7554863,7554859,'dmi',8.333,1),(971,7554864,7554859,'min',8.333,1),(971,7554865,7554859,'ini',8.333,1),(971,7554866,7554859,'nis',8.333,1),(971,7554867,7554859,'ist',8.333,1),(971,7554868,7554859,'str',8.333,1),(971,7554869,7554859,'tra',8.333,1),(971,7554870,7554859,'rat',8.333,1),(971,7554871,7554859,'ati',8.333,1),(971,7554872,7554859,'tio',8.333,1),(971,7554873,7554859,'ion',8.333,1),(971,7554874,7554862,'sta',33.333,3),(971,7554875,7554862,'tat',33.333,3),(971,7554876,7554862,'ate',33.333,3),(971,7554877,7554874,'dis',16.667,4),(971,7554878,7554874,'isa',16.667,4),(971,7554879,7554874,'sab',16.667,4),(971,7554880,7554874,'abl',16.667,4),(971,7554881,7554874,'ble',16.667,4),(971,7554882,7554874,'led',16.667,4),(971,7554883,7554877,'cac',33.333,1),(971,7554884,7554877,'ach',33.333,1),(971,7554885,7554877,'che',33.333,1),(971,7554886,7554883,'mod',50,1),(971,7554887,7554883,'ode',50,1),(971,7554888,7554886,'wri',14.286,1),(971,7554889,7554886,'rit',14.286,1),(971,7554890,7554886,'ite',14.286,1),(971,7554891,7554886,'tet',14.286,1),(971,7554892,7554886,'eth',14.286,1),(971,7554893,7554886,'thr',14.286,1),(971,7554894,7554886,'hru',14.286,1),(971,7554895,7554888,'ope',11.111,2),(971,7554896,7554888,'per',11.111,2),(971,7554897,7554888,'era',11.111,2),(971,7554898,7554888,'rat',11.111,2),(971,7554899,7554888,'ati',11.111,2),(971,7554900,7554888,'tio',11.111,2),(971,7554901,7554888,'ion',11.111,2),(971,7554902,7554888,'ona',11.111,2),(971,7554903,7554888,'nal',11.111,2),(971,7554904,7554895,'mes',20,1),(971,7554905,7554895,'ess',20,1),(971,7554906,7554895,'ssa',20,1),(971,7554907,7554895,'sag',20,1),(971,7554908,7554895,'age',20,1),(971,7554909,7554904,'per',11.111,1),(971,7554910,7554904,'erf',11.111,1),(971,7554911,7554904,'rfo',11.111,1),(971,7554912,7554904,'for',11.111,1),(971,7554913,7554904,'orm',11.111,1),(971,7554914,7554904,'rma',11.111,1),(971,7554915,7554904,'man',11.111,1),(971,7554916,7554904,'anc',11.111,1),(971,7554917,7554904,'nce',11.111,1),(971,7554918,7554909,'ide',12.5,1),(971,7554919,7554909,'den',12.5,1),(971,7554920,7554909,'ent',12.5,1),(971,7554921,7554909,'nti',12.5,1),(971,7554922,7554909,'tif',12.5,1),(971,7554923,7554909,'ifi',12.5,1),(971,7554924,7554909,'fie',12.5,1),(971,7554925,7554909,'ier',12.5,1),(971,7554926,7554918,'vdi',33.333,3),(971,7554927,7554918,'dis',33.333,3),(971,7554928,7554918,'isk',33.333,3),(971,7554929,7554926,'nam',50,1),(971,7554930,7554926,'ame',50,1),(971,7554931,7554929,'typ',50,1),(971,7554932,7554929,'ype',50,1),(971,7554933,7554931,'dir',25,1),(971,7554934,7554931,'ire',25,1),(971,7554935,7554931,'rec',25,1),(971,7554936,7554931,'ect',25,1),(972,7554938,7554937,'naa',100,2),(972,7554939,7554938,'600',3.333,3),(972,7554940,7554938,'000',3.333,3),(972,7554941,7554938,'00c',3.333,3),(972,7554942,7554938,'0c2',3.333,3),(972,7554943,7554938,'c29',3.333,3),(972,7554944,7554938,'297',3.333,3),(972,7554945,7554938,'97c',3.333,3),(972,7554946,7554938,'7c8',3.333,3),(972,7554947,7554938,'c88',3.333,3),(972,7554948,7554938,'882',3.333,3),(972,7554949,7554938,'821',3.333,3),(972,7554950,7554938,'213',3.333,3),(972,7554951,7554938,'13a',3.333,3),(972,7554952,7554938,'3a0',3.333,3),(972,7554953,7554938,'a03',3.333,3),(972,7554954,7554938,'03f',3.333,3),(972,7554955,7554938,'3f3',3.333,3),(972,7554956,7554938,'f32',3.333,3),(972,7554957,7554938,'328',3.333,3),(972,7554958,7554938,'28b',3.333,3),(972,7554959,7554938,'8b1',3.333,3),(972,7554960,7554938,'b13',3.333,3),(972,7554961,7554938,'13d',3.333,3),(972,7554962,7554938,'3d6',3.333,3),(972,7554963,7554938,'d6e',3.333,3),(972,7554964,7554938,'6e9',3.333,3),(972,7554965,7554938,'e96',3.333,3),(972,7554966,7554938,'962',3.333,3),(972,7554967,7554938,'628',3.333,3),(972,7554968,7554938,'285',3.333,3),(972,7554969,7554939,'mon',100,1),(972,7554970,7554969,'201',50,1),(972,7554971,7554969,'013',50,1),(972,7554972,7554970,'adm',33.333,4),(972,7554973,7554970,'dmi',33.333,4),(972,7554974,7554970,'min',33.333,4),(972,7554975,7554972,'cap',16.667,1),(972,7554976,7554972,'apa',16.667,1),(972,7554977,7554972,'pac',16.667,1),(972,7554978,7554972,'aci',16.667,1),(972,7554979,7554972,'cit',16.667,1),(972,7554980,7554972,'ity',16.667,1),(972,7554981,7554975,'pat',50,1),(972,7554982,7554975,'ath',50,1),(972,7554983,7554981,'eig',33.333,1),(972,7554984,7554981,'igh',33.333,1),(972,7554985,7554981,'ght',33.333,1),(972,7554986,7554983,'fre',14.286,1),(972,7554987,7554983,'ree',14.286,1),(972,7554988,7554983,'ees',14.286,1),(972,7554989,7554983,'esp',14.286,1),(972,7554990,7554983,'spa',14.286,1),(972,7554991,7554983,'pac',14.286,1),(972,7554992,7554983,'ace',14.286,1),(972,7554993,7554986,'dis',50,1),(972,7554994,7554986,'isk',50,1),(972,7554995,7554993,'ind',33.333,1),(972,7554996,7554993,'nde',33.333,1),(972,7554997,7554993,'dex',33.333,1),(972,7554998,7554995,'adm',8.333,1),(972,7554999,7554995,'dmi',8.333,1),(972,7555000,7554995,'min',8.333,1),(972,7555001,7554995,'ini',8.333,1),(972,7555002,7554995,'nis',8.333,1),(972,7555003,7554995,'ist',8.333,1),(972,7555004,7554995,'str',8.333,1),(972,7555005,7554995,'tra',8.333,1),(972,7555006,7554995,'rat',8.333,1),(972,7555007,7554995,'ati',8.333,1),(972,7555008,7554995,'tio',8.333,1),(972,7555009,7554995,'ion',8.333,1),(972,7555010,7554998,'sta',33.333,3),(972,7555011,7554998,'tat',33.333,3),(972,7555012,7554998,'ate',33.333,3),(972,7555013,7555010,'dis',16.667,4),(972,7555014,7555010,'isa',16.667,4),(972,7555015,7555010,'sab',16.667,4),(972,7555016,7555010,'abl',16.667,4),(972,7555017,7555010,'ble',16.667,4),(972,7555018,7555010,'led',16.667,4),(972,7555019,7555013,'cac',33.333,1),(972,7555020,7555013,'ach',33.333,1),(972,7555021,7555013,'che',33.333,1),(972,7555022,7555019,'mod',50,1),(972,7555023,7555019,'ode',50,1),(972,7555024,7555022,'wri',14.286,1),(972,7555025,7555022,'rit',14.286,1),(972,7555026,7555022,'ite',14.286,1),(972,7555027,7555022,'tet',14.286,1),(972,7555028,7555022,'eth',14.286,1),(972,7555029,7555022,'thr',14.286,1),(972,7555030,7555022,'hru',14.286,1),(972,7555031,7555024,'ope',11.111,2),(972,7555032,7555024,'per',11.111,2),(972,7555033,7555024,'era',11.111,2),(972,7555034,7555024,'rat',11.111,2),(972,7555035,7555024,'ati',11.111,2),(972,7555036,7555024,'tio',11.111,2),(972,7555037,7555024,'ion',11.111,2),(972,7555038,7555024,'ona',11.111,2),(972,7555039,7555024,'nal',11.111,2),(972,7555040,7555031,'mes',20,1),(972,7555041,7555031,'ess',20,1),(972,7555042,7555031,'ssa',20,1),(972,7555043,7555031,'sag',20,1),(972,7555044,7555031,'age',20,1),(972,7555045,7555040,'per',11.111,1),(972,7555046,7555040,'erf',11.111,1),(972,7555047,7555040,'rfo',11.111,1),(972,7555048,7555040,'for',11.111,1),(972,7555049,7555040,'orm',11.111,1),(972,7555050,7555040,'rma',11.111,1),(972,7555051,7555040,'man',11.111,1),(972,7555052,7555040,'anc',11.111,1),(972,7555053,7555040,'nce',11.111,1),(972,7555054,7555045,'ide',12.5,1),(972,7555055,7555045,'den',12.5,1),(972,7555056,7555045,'ent',12.5,1),(972,7555057,7555045,'nti',12.5,1),(972,7555058,7555045,'tif',12.5,1),(972,7555059,7555045,'ifi',12.5,1),(972,7555060,7555045,'fie',12.5,1),(972,7555061,7555045,'ier',12.5,1),(972,7555062,7555054,'vdi',33.333,3),(972,7555063,7555054,'dis',33.333,3),(972,7555064,7555054,'isk',33.333,3),(972,7555065,7555062,'nam',50,1),(972,7555066,7555062,'ame',50,1),(972,7555067,7555065,'typ',50,1),(972,7555068,7555065,'ype',50,1),(972,7555069,7555067,'dir',25,1),(972,7555070,7555067,'ire',25,1),(972,7555071,7555067,'rec',25,1),(972,7555072,7555067,'ect',25,1),(973,7555074,7555073,'naa',100,2),(973,7555075,7555074,'600',3.333,3),(973,7555076,7555074,'000',3.333,3),(973,7555077,7555074,'00c',3.333,3),(973,7555078,7555074,'0c2',3.333,3),(973,7555079,7555074,'c29',3.333,3),(973,7555080,7555074,'29b',3.333,3),(973,7555081,7555074,'9b5',3.333,3),(973,7555082,7555074,'b52',3.333,3),(973,7555083,7555074,'528',3.333,3),(973,7555084,7555074,'283',3.333,3),(973,7555085,7555074,'834',3.333,3),(973,7555086,7555074,'340',3.333,3),(973,7555087,7555074,'40c',3.333,3),(973,7555088,7555074,'0c4',3.333,3),(973,7555089,7555074,'c40',3.333,3),(973,7555090,7555074,'407',3.333,3),(973,7555091,7555074,'07f',3.333,3),(973,7555092,7555074,'7f0',3.333,3),(973,7555093,7555074,'f0d',3.333,3),(973,7555094,7555074,'0dc',3.333,3),(973,7555095,7555074,'dcf',3.333,3),(973,7555096,7555074,'cfa',3.333,3),(973,7555097,7555074,'fa0',3.333,3),(973,7555098,7555074,'a0f',3.333,3),(973,7555099,7555074,'0f1',3.333,3),(973,7555100,7555074,'f12',3.333,3),(973,7555101,7555074,'125',3.333,3),(973,7555102,7555074,'25e',3.333,3),(973,7555103,7555074,'5e6',3.333,3),(973,7555104,7555074,'e6b',3.333,3),(973,7555105,7555075,'mon',100,1),(973,7555106,7555105,'201',50,1),(973,7555107,7555105,'013',50,1),(973,7555108,7555106,'adm',33.333,4),(973,7555109,7555106,'dmi',33.333,4),(973,7555110,7555106,'min',33.333,4),(973,7555111,7555108,'cap',16.667,1),(973,7555112,7555108,'apa',16.667,1),(973,7555113,7555108,'pac',16.667,1),(973,7555114,7555108,'aci',16.667,1),(973,7555115,7555108,'cit',16.667,1),(973,7555116,7555108,'ity',16.667,1),(973,7555117,7555111,'pat',50,1),(973,7555118,7555111,'ath',50,1),(973,7555119,7555117,'nin',50,1),(973,7555120,7555117,'ine',50,1),(973,7555121,7555119,'fre',14.286,1),(973,7555122,7555119,'ree',14.286,1),(973,7555123,7555119,'ees',14.286,1),(973,7555124,7555119,'esp',14.286,1),(973,7555125,7555119,'spa',14.286,1),(973,7555126,7555119,'pac',14.286,1),(973,7555127,7555119,'ace',14.286,1),(973,7555128,7555121,'dis',50,1),(973,7555129,7555121,'isk',50,1),(973,7555130,7555128,'ind',33.333,1),(973,7555131,7555128,'nde',33.333,1),(973,7555132,7555128,'dex',33.333,1),(973,7555133,7555130,'adm',8.333,1),(973,7555134,7555130,'dmi',8.333,1),(973,7555135,7555130,'min',8.333,1),(973,7555136,7555130,'ini',8.333,1),(973,7555137,7555130,'nis',8.333,1),(973,7555138,7555130,'ist',8.333,1),(973,7555139,7555130,'str',8.333,1),(973,7555140,7555130,'tra',8.333,1),(973,7555141,7555130,'rat',8.333,1),(973,7555142,7555130,'ati',8.333,1),(973,7555143,7555130,'tio',8.333,1),(973,7555144,7555130,'ion',8.333,1),(973,7555145,7555133,'sta',33.333,3),(973,7555146,7555133,'tat',33.333,3),(973,7555147,7555133,'ate',33.333,3),(973,7555148,7555145,'dis',16.667,4),(973,7555149,7555145,'isa',16.667,4),(973,7555150,7555145,'sab',16.667,4),(973,7555151,7555145,'abl',16.667,4),(973,7555152,7555145,'ble',16.667,4),(973,7555153,7555145,'led',16.667,4),(973,7555154,7555148,'cac',33.333,1),(973,7555155,7555148,'ach',33.333,1),(973,7555156,7555148,'che',33.333,1),(973,7555157,7555154,'mod',50,1),(973,7555158,7555154,'ode',50,1),(973,7555159,7555157,'wri',14.286,1),(973,7555160,7555157,'rit',14.286,1),(973,7555161,7555157,'ite',14.286,1),(973,7555162,7555157,'tet',14.286,1),(973,7555163,7555157,'eth',14.286,1),(973,7555164,7555157,'thr',14.286,1),(973,7555165,7555157,'hru',14.286,1),(973,7555166,7555159,'ope',11.111,2),(973,7555167,7555159,'per',11.111,2),(973,7555168,7555159,'era',11.111,2),(973,7555169,7555159,'rat',11.111,2),(973,7555170,7555159,'ati',11.111,2),(973,7555171,7555159,'tio',11.111,2),(973,7555172,7555159,'ion',11.111,2),(973,7555173,7555159,'ona',11.111,2),(973,7555174,7555159,'nal',11.111,2),(973,7555175,7555166,'mes',20,1),(973,7555176,7555166,'ess',20,1),(973,7555177,7555166,'ssa',20,1),(973,7555178,7555166,'sag',20,1),(973,7555179,7555166,'age',20,1),(973,7555180,7555175,'per',11.111,1),(973,7555181,7555175,'erf',11.111,1),(973,7555182,7555175,'rfo',11.111,1),(973,7555183,7555175,'for',11.111,1),(973,7555184,7555175,'orm',11.111,1),(973,7555185,7555175,'rma',11.111,1),(973,7555186,7555175,'man',11.111,1),(973,7555187,7555175,'anc',11.111,1),(973,7555188,7555175,'nce',11.111,1),(973,7555189,7555180,'ide',12.5,1),(973,7555190,7555180,'den',12.5,1),(973,7555191,7555180,'ent',12.5,1),(973,7555192,7555180,'nti',12.5,1),(973,7555193,7555180,'tif',12.5,1),(973,7555194,7555180,'ifi',12.5,1),(973,7555195,7555180,'fie',12.5,1),(973,7555196,7555180,'ier',12.5,1),(973,7555197,7555189,'vdi',33.333,3),(973,7555198,7555189,'dis',33.333,3),(973,7555199,7555189,'isk',33.333,3),(973,7555200,7555197,'nam',50,1),(973,7555201,7555197,'ame',50,1),(973,7555202,7555200,'typ',50,1),(973,7555203,7555200,'ype',50,1),(973,7555204,7555202,'dir',25,1),(973,7555205,7555202,'ire',25,1),(973,7555206,7555202,'rec',25,1),(973,7555207,7555202,'ect',25,1),(974,7555209,7555208,'naa',100,2),(974,7555210,7555209,'600',3.333,3),(974,7555211,7555209,'000',3.333,3),(974,7555212,7555209,'00c',3.333,3),(974,7555213,7555209,'0c2',3.333,3),(974,7555214,7555209,'c29',3.333,3),(974,7555215,7555209,'29e',3.333,3),(974,7555216,7555209,'9e1',3.333,3),(974,7555217,7555209,'e17',3.333,3),(974,7555218,7555209,'178',3.333,3),(974,7555219,7555209,'786',3.333,3),(974,7555220,7555209,'869',3.333,3),(974,7555221,7555209,'690',3.333,3),(974,7555222,7555209,'909',3.333,3),(974,7555223,7555209,'09e',3.333,3),(974,7555224,7555209,'9ea',3.333,3),(974,7555225,7555209,'eac',3.333,3),(974,7555226,7555209,'acd',3.333,3),(974,7555227,7555209,'cd0',3.333,3),(974,7555228,7555209,'d0a',3.333,3),(974,7555229,7555209,'0ac',3.333,3),(974,7555230,7555209,'ac6',3.333,3),(974,7555231,7555209,'c6c',3.333,3),(974,7555232,7555209,'6c9',3.333,3),(974,7555233,7555209,'c94',3.333,3),(974,7555234,7555209,'946',3.333,3),(974,7555235,7555209,'46a',3.333,3),(974,7555236,7555209,'6a7',3.333,3),(974,7555237,7555209,'a7c',3.333,3),(974,7555238,7555209,'7c4',3.333,3),(974,7555239,7555209,'c4e',3.333,3),(974,7555240,7555210,'mon',100,1),(974,7555241,7555240,'201',50,1),(974,7555242,7555240,'013',50,1),(974,7555243,7555241,'adm',33.333,4),(974,7555244,7555241,'dmi',33.333,4),(974,7555245,7555241,'min',33.333,4),(974,7555246,7555243,'cap',16.667,1),(974,7555247,7555243,'apa',16.667,1),(974,7555248,7555243,'pac',16.667,1),(974,7555249,7555243,'aci',16.667,1),(974,7555250,7555243,'cit',16.667,1),(974,7555251,7555243,'ity',16.667,1),(974,7555252,7555246,'pat',50,1),(974,7555253,7555246,'ath',50,1),(974,7555254,7555252,'ten',100,1),(974,7555255,7555254,'fre',14.286,1),(974,7555256,7555254,'ree',14.286,1),(974,7555257,7555254,'ees',14.286,1),(974,7555258,7555254,'esp',14.286,1),(974,7555259,7555254,'spa',14.286,1),(974,7555260,7555254,'pac',14.286,1),(974,7555261,7555254,'ace',14.286,1),(974,7555262,7555255,'dis',50,1),(974,7555263,7555255,'isk',50,1),(974,7555264,7555262,'ind',33.333,1),(974,7555265,7555262,'nde',33.333,1),(974,7555266,7555262,'dex',33.333,1),(974,7555267,7555264,'adm',8.333,1),(974,7555268,7555264,'dmi',8.333,1),(974,7555269,7555264,'min',8.333,1),(974,7555270,7555264,'ini',8.333,1),(974,7555271,7555264,'nis',8.333,1),(974,7555272,7555264,'ist',8.333,1),(974,7555273,7555264,'str',8.333,1),(974,7555274,7555264,'tra',8.333,1),(974,7555275,7555264,'rat',8.333,1),(974,7555276,7555264,'ati',8.333,1),(974,7555277,7555264,'tio',8.333,1),(974,7555278,7555264,'ion',8.333,1),(974,7555279,7555267,'sta',33.333,3),(974,7555280,7555267,'tat',33.333,3),(974,7555281,7555267,'ate',33.333,3),(974,7555282,7555279,'dis',16.667,4),(974,7555283,7555279,'isa',16.667,4),(974,7555284,7555279,'sab',16.667,4),(974,7555285,7555279,'abl',16.667,4),(974,7555286,7555279,'ble',16.667,4),(974,7555287,7555279,'led',16.667,4),(974,7555288,7555282,'cac',33.333,1),(974,7555289,7555282,'ach',33.333,1),(974,7555290,7555282,'che',33.333,1),(974,7555291,7555288,'mod',50,1),(974,7555292,7555288,'ode',50,1),(974,7555293,7555291,'wri',14.286,1),(974,7555294,7555291,'rit',14.286,1),(974,7555295,7555291,'ite',14.286,1),(974,7555296,7555291,'tet',14.286,1),(974,7555297,7555291,'eth',14.286,1),(974,7555298,7555291,'thr',14.286,1),(974,7555299,7555291,'hru',14.286,1),(974,7555300,7555293,'ope',11.111,2),(974,7555301,7555293,'per',11.111,2),(974,7555302,7555293,'era',11.111,2),(974,7555303,7555293,'rat',11.111,2),(974,7555304,7555293,'ati',11.111,2),(974,7555305,7555293,'tio',11.111,2),(974,7555306,7555293,'ion',11.111,2),(974,7555307,7555293,'ona',11.111,2),(974,7555308,7555293,'nal',11.111,2),(974,7555309,7555300,'mes',20,1),(974,7555310,7555300,'ess',20,1),(974,7555311,7555300,'ssa',20,1),(974,7555312,7555300,'sag',20,1),(974,7555313,7555300,'age',20,1),(974,7555314,7555309,'per',11.111,1),(974,7555315,7555309,'erf',11.111,1),(974,7555316,7555309,'rfo',11.111,1),(974,7555317,7555309,'for',11.111,1),(974,7555318,7555309,'orm',11.111,1),(974,7555319,7555309,'rma',11.111,1),(974,7555320,7555309,'man',11.111,1),(974,7555321,7555309,'anc',11.111,1),(974,7555322,7555309,'nce',11.111,1),(974,7555323,7555314,'ide',12.5,1),(974,7555324,7555314,'den',12.5,1),(974,7555325,7555314,'ent',12.5,1),(974,7555326,7555314,'nti',12.5,1),(974,7555327,7555314,'tif',12.5,1),(974,7555328,7555314,'ifi',12.5,1),(974,7555329,7555314,'fie',12.5,1),(974,7555330,7555314,'ier',12.5,1),(974,7555331,7555323,'vdi',33.333,3),(974,7555332,7555323,'dis',33.333,3),(974,7555333,7555323,'isk',33.333,3),(974,7555334,7555331,'nam',50,1),(974,7555335,7555331,'ame',50,1),(974,7555336,7555334,'typ',50,1),(974,7555337,7555334,'ype',50,1),(974,7555338,7555336,'dir',25,1),(974,7555339,7555336,'ire',25,1),(974,7555340,7555336,'rec',25,1),(974,7555341,7555336,'ect',25,1),(975,7555343,7555342,'naa',100,2),(975,7555344,7555343,'600',3.333,3),(975,7555345,7555343,'000',3.333,3),(975,7555346,7555343,'00c',3.333,3),(975,7555347,7555343,'0c2',3.333,3),(975,7555348,7555343,'c29',3.333,3),(975,7555349,7555343,'29b',3.333,3),(975,7555350,7555343,'9bc',3.333,3),(975,7555351,7555343,'bce',3.333,3),(975,7555352,7555343,'ce8',3.333,3),(975,7555353,7555343,'e87',3.333,3),(975,7555354,7555343,'87d',3.333,3),(975,7555355,7555343,'7d2',3.333,3),(975,7555356,7555343,'d23',3.333,3),(975,7555357,7555343,'234',3.333,3),(975,7555358,7555343,'344',3.333,3),(975,7555359,7555343,'448',3.333,3),(975,7555360,7555343,'48b',3.333,3),(975,7555361,7555343,'8b7',3.333,3),(975,7555362,7555343,'b7f',3.333,3),(975,7555363,7555343,'7f0',3.333,3),(975,7555364,7555343,'f07',3.333,3),(975,7555365,7555343,'070',3.333,3),(975,7555366,7555343,'704',3.333,3),(975,7555367,7555343,'04f',3.333,3),(975,7555368,7555343,'4ff',3.333,3),(975,7555369,7555343,'ffd',3.333,3),(975,7555370,7555343,'fd0',3.333,3),(975,7555371,7555343,'d08',3.333,3),(975,7555372,7555343,'087',3.333,3),(975,7555373,7555343,'877',3.333,3),(975,7555374,7555344,'mon',100,1),(975,7555375,7555374,'201',50,1),(975,7555376,7555374,'013',50,1),(975,7555377,7555375,'adm',33.333,4),(975,7555378,7555375,'dmi',33.333,4),(975,7555379,7555375,'min',33.333,4),(975,7555380,7555377,'cap',16.667,1),(975,7555381,7555377,'apa',16.667,1),(975,7555382,7555377,'pac',16.667,1),(975,7555383,7555377,'aci',16.667,1),(975,7555384,7555377,'cit',16.667,1),(975,7555385,7555377,'ity',16.667,1),(975,7555386,7555380,'pat',50,1),(975,7555387,7555380,'ath',50,1),(975,7555388,7555386,'ele',25,1),(975,7555389,7555386,'lev',25,1),(975,7555390,7555386,'eve',25,1),(975,7555391,7555386,'ven',25,1),(975,7555392,7555388,'fre',14.286,1),(975,7555393,7555388,'ree',14.286,1),(975,7555394,7555388,'ees',14.286,1),(975,7555395,7555388,'esp',14.286,1),(975,7555396,7555388,'spa',14.286,1),(975,7555397,7555388,'pac',14.286,1),(975,7555398,7555388,'ace',14.286,1),(975,7555399,7555392,'dis',50,1),(975,7555400,7555392,'isk',50,1),(975,7555401,7555399,'ind',33.333,1),(975,7555402,7555399,'nde',33.333,1),(975,7555403,7555399,'dex',33.333,1),(975,7555404,7555401,'adm',8.333,1),(975,7555405,7555401,'dmi',8.333,1),(975,7555406,7555401,'min',8.333,1),(975,7555407,7555401,'ini',8.333,1),(975,7555408,7555401,'nis',8.333,1),(975,7555409,7555401,'ist',8.333,1),(975,7555410,7555401,'str',8.333,1),(975,7555411,7555401,'tra',8.333,1),(975,7555412,7555401,'rat',8.333,1),(975,7555413,7555401,'ati',8.333,1),(975,7555414,7555401,'tio',8.333,1),(975,7555415,7555401,'ion',8.333,1),(975,7555416,7555404,'sta',33.333,3),(975,7555417,7555404,'tat',33.333,3),(975,7555418,7555404,'ate',33.333,3),(975,7555419,7555416,'dis',16.667,4),(975,7555420,7555416,'isa',16.667,4),(975,7555421,7555416,'sab',16.667,4),(975,7555422,7555416,'abl',16.667,4),(975,7555423,7555416,'ble',16.667,4),(975,7555424,7555416,'led',16.667,4),(975,7555425,7555419,'cac',33.333,1),(975,7555426,7555419,'ach',33.333,1),(975,7555427,7555419,'che',33.333,1),(975,7555428,7555425,'mod',50,1),(975,7555429,7555425,'ode',50,1),(975,7555430,7555428,'wri',14.286,1),(975,7555431,7555428,'rit',14.286,1),(975,7555432,7555428,'ite',14.286,1),(975,7555433,7555428,'tet',14.286,1),(975,7555434,7555428,'eth',14.286,1),(975,7555435,7555428,'thr',14.286,1),(975,7555436,7555428,'hru',14.286,1),(975,7555437,7555430,'ope',11.111,2),(975,7555438,7555430,'per',11.111,2),(975,7555439,7555430,'era',11.111,2),(975,7555440,7555430,'rat',11.111,2),(975,7555441,7555430,'ati',11.111,2),(975,7555442,7555430,'tio',11.111,2),(975,7555443,7555430,'ion',11.111,2),(975,7555444,7555430,'ona',11.111,2),(975,7555445,7555430,'nal',11.111,2),(975,7555446,7555437,'mes',20,1),(975,7555447,7555437,'ess',20,1),(975,7555448,7555437,'ssa',20,1),(975,7555449,7555437,'sag',20,1),(975,7555450,7555437,'age',20,1),(975,7555451,7555446,'per',11.111,1),(975,7555452,7555446,'erf',11.111,1),(975,7555453,7555446,'rfo',11.111,1),(975,7555454,7555446,'for',11.111,1),(975,7555455,7555446,'orm',11.111,1),(975,7555456,7555446,'rma',11.111,1),(975,7555457,7555446,'man',11.111,1),(975,7555458,7555446,'anc',11.111,1),(975,7555459,7555446,'nce',11.111,1),(975,7555460,7555451,'ide',12.5,1),(975,7555461,7555451,'den',12.5,1),(975,7555462,7555451,'ent',12.5,1),(975,7555463,7555451,'nti',12.5,1),(975,7555464,7555451,'tif',12.5,1),(975,7555465,7555451,'ifi',12.5,1),(975,7555466,7555451,'fie',12.5,1),(975,7555467,7555451,'ier',12.5,1),(975,7555468,7555460,'vdi',33.333,3),(975,7555469,7555460,'dis',33.333,3),(975,7555470,7555460,'isk',33.333,3),(975,7555471,7555468,'nam',50,1),(975,7555472,7555468,'ame',50,1),(975,7555473,7555471,'typ',50,1),(975,7555474,7555471,'ype',50,1),(975,7555475,7555473,'dir',25,1),(975,7555476,7555473,'ire',25,1),(975,7555477,7555473,'rec',25,1),(975,7555478,7555473,'ect',25,1),(976,7555480,7555479,'naa',100,2),(976,7555481,7555480,'600',3.333,3),(976,7555482,7555480,'000',3.333,3),(976,7555483,7555480,'00c',3.333,3),(976,7555484,7555480,'0c2',3.333,3),(976,7555485,7555480,'c29',3.333,3),(976,7555486,7555480,'29f',3.333,3),(976,7555487,7555480,'9fc',3.333,3),(976,7555488,7555480,'fc9',3.333,3),(976,7555489,7555480,'c99',3.333,3),(976,7555490,7555480,'994',3.333,3),(976,7555491,7555480,'940',3.333,3),(976,7555492,7555480,'40c',3.333,3),(976,7555493,7555480,'0c6',3.333,3),(976,7555494,7555480,'c64',3.333,3),(976,7555495,7555480,'64a',3.333,3),(976,7555496,7555480,'4a7',3.333,3),(976,7555497,7555480,'a72',3.333,3),(976,7555498,7555480,'72c',3.333,3),(976,7555499,7555480,'2c8',3.333,3),(976,7555500,7555480,'c80',3.333,3),(976,7555501,7555480,'804',3.333,3),(976,7555502,7555480,'04e',3.333,3),(976,7555503,7555480,'4e3',3.333,3),(976,7555504,7555480,'e3f',3.333,3),(976,7555505,7555480,'3fb',3.333,3),(976,7555506,7555480,'fbd',3.333,3),(976,7555507,7555480,'bd6',3.333,3),(976,7555508,7555480,'d65',3.333,3),(976,7555509,7555480,'650',3.333,3),(976,7555510,7555480,'50f',3.333,3),(976,7555511,7555481,'mon',100,1),(976,7555512,7555511,'201',50,1),(976,7555513,7555511,'013',50,1),(976,7555514,7555512,'adm',33.333,4),(976,7555515,7555512,'dmi',33.333,4),(976,7555516,7555512,'min',33.333,4),(976,7555517,7555514,'cap',16.667,1),(976,7555518,7555514,'apa',16.667,1),(976,7555519,7555514,'pac',16.667,1),(976,7555520,7555514,'aci',16.667,1),(976,7555521,7555514,'cit',16.667,1),(976,7555522,7555514,'ity',16.667,1),(976,7555523,7555517,'pat',50,1),(976,7555524,7555517,'ath',50,1),(976,7555525,7555523,'twe',25,1),(976,7555526,7555523,'wel',25,1),(976,7555527,7555523,'elv',25,1),(976,7555528,7555523,'lve',25,1),(976,7555529,7555525,'fre',14.286,1),(976,7555530,7555525,'ree',14.286,1),(976,7555531,7555525,'ees',14.286,1),(976,7555532,7555525,'esp',14.286,1),(976,7555533,7555525,'spa',14.286,1),(976,7555534,7555525,'pac',14.286,1),(976,7555535,7555525,'ace',14.286,1),(976,7555536,7555529,'dis',50,1),(976,7555537,7555529,'isk',50,1),(976,7555538,7555536,'ind',33.333,1),(976,7555539,7555536,'nde',33.333,1),(976,7555540,7555536,'dex',33.333,1),(976,7555541,7555538,'adm',8.333,1),(976,7555542,7555538,'dmi',8.333,1),(976,7555543,7555538,'min',8.333,1),(976,7555544,7555538,'ini',8.333,1),(976,7555545,7555538,'nis',8.333,1),(976,7555546,7555538,'ist',8.333,1),(976,7555547,7555538,'str',8.333,1),(976,7555548,7555538,'tra',8.333,1),(976,7555549,7555538,'rat',8.333,1),(976,7555550,7555538,'ati',8.333,1),(976,7555551,7555538,'tio',8.333,1),(976,7555552,7555538,'ion',8.333,1),(976,7555553,7555541,'sta',33.333,3),(976,7555554,7555541,'tat',33.333,3),(976,7555555,7555541,'ate',33.333,3),(976,7555556,7555553,'dis',16.667,4),(976,7555557,7555553,'isa',16.667,4),(976,7555558,7555553,'sab',16.667,4),(976,7555559,7555553,'abl',16.667,4),(976,7555560,7555553,'ble',16.667,4),(976,7555561,7555553,'led',16.667,4),(976,7555562,7555556,'cac',33.333,1),(976,7555563,7555556,'ach',33.333,1),(976,7555564,7555556,'che',33.333,1),(976,7555565,7555562,'mod',50,1),(976,7555566,7555562,'ode',50,1),(976,7555567,7555565,'wri',14.286,1),(976,7555568,7555565,'rit',14.286,1),(976,7555569,7555565,'ite',14.286,1),(976,7555570,7555565,'tet',14.286,1),(976,7555571,7555565,'eth',14.286,1),(976,7555572,7555565,'thr',14.286,1),(976,7555573,7555565,'hru',14.286,1),(976,7555574,7555567,'ope',11.111,2),(976,7555575,7555567,'per',11.111,2),(976,7555576,7555567,'era',11.111,2),(976,7555577,7555567,'rat',11.111,2),(976,7555578,7555567,'ati',11.111,2),(976,7555579,7555567,'tio',11.111,2),(976,7555580,7555567,'ion',11.111,2),(976,7555581,7555567,'ona',11.111,2),(976,7555582,7555567,'nal',11.111,2),(976,7555583,7555574,'mes',20,1),(976,7555584,7555574,'ess',20,1),(976,7555585,7555574,'ssa',20,1),(976,7555586,7555574,'sag',20,1),(976,7555587,7555574,'age',20,1),(976,7555588,7555583,'per',11.111,1),(976,7555589,7555583,'erf',11.111,1),(976,7555590,7555583,'rfo',11.111,1),(976,7555591,7555583,'for',11.111,1),(976,7555592,7555583,'orm',11.111,1),(976,7555593,7555583,'rma',11.111,1),(976,7555594,7555583,'man',11.111,1),(976,7555595,7555583,'anc',11.111,1),(976,7555596,7555583,'nce',11.111,1),(976,7555597,7555588,'ide',12.5,1),(976,7555598,7555588,'den',12.5,1),(976,7555599,7555588,'ent',12.5,1),(976,7555600,7555588,'nti',12.5,1),(976,7555601,7555588,'tif',12.5,1),(976,7555602,7555588,'ifi',12.5,1),(976,7555603,7555588,'fie',12.5,1),(976,7555604,7555588,'ier',12.5,1),(976,7555605,7555597,'vdi',33.333,3),(976,7555606,7555597,'dis',33.333,3),(976,7555607,7555597,'isk',33.333,3),(976,7555608,7555605,'nam',50,1),(976,7555609,7555605,'ame',50,1),(976,7555610,7555608,'typ',50,1),(976,7555611,7555608,'ype',50,1),(976,7555612,7555610,'dir',25,1),(976,7555613,7555610,'ire',25,1),(976,7555614,7555610,'rec',25,1),(976,7555615,7555610,'ect',25,1),(977,7555617,7555616,'naa',100,2),(977,7555618,7555617,'600',3.333,3),(977,7555619,7555617,'000',3.333,3),(977,7555620,7555617,'00c',3.333,3),(977,7555621,7555617,'0c2',3.333,3),(977,7555622,7555617,'c29',3.333,3),(977,7555623,7555617,'29a',3.333,3),(977,7555624,7555617,'9af',3.333,3),(977,7555625,7555617,'af1',3.333,3),(977,7555626,7555617,'f1e',3.333,3),(977,7555627,7555617,'1e2',3.333,3),(977,7555628,7555617,'e23',3.333,3),(977,7555629,7555617,'23d',3.333,3),(977,7555630,7555617,'3d5',3.333,3),(977,7555631,7555617,'d56',3.333,3),(977,7555632,7555617,'56d',3.333,3),(977,7555633,7555617,'6d1',3.333,3),(977,7555634,7555617,'d15',3.333,3),(977,7555635,7555617,'15d',3.333,3),(977,7555636,7555617,'5d8',3.333,3),(977,7555637,7555617,'d8e',3.333,3),(977,7555638,7555617,'8e5',3.333,3),(977,7555639,7555617,'e53',3.333,3),(977,7555640,7555617,'530',3.333,3),(977,7555641,7555617,'30f',3.333,3),(977,7555642,7555617,'0f1',3.333,3),(977,7555643,7555617,'f1d',3.333,3),(977,7555644,7555617,'1dc',3.333,3),(977,7555645,7555617,'dc7',3.333,3),(977,7555646,7555617,'c77',3.333,3),(977,7555647,7555617,'77f',3.333,3),(977,7555648,7555618,'mon',100,1),(977,7555649,7555648,'201',50,1),(977,7555650,7555648,'013',50,1),(977,7555651,7555649,'adm',33.333,4),(977,7555652,7555649,'dmi',33.333,4),(977,7555653,7555649,'min',33.333,4),(977,7555654,7555651,'cap',16.667,1),(977,7555655,7555651,'apa',16.667,1),(977,7555656,7555651,'pac',16.667,1),(977,7555657,7555651,'aci',16.667,1),(977,7555658,7555651,'cit',16.667,1),(977,7555659,7555651,'ity',16.667,1),(977,7555660,7555654,'pat',50,1),(977,7555661,7555654,'ath',50,1),(977,7555662,7555660,'thi',16.667,1),(977,7555663,7555660,'hir',16.667,1),(977,7555664,7555660,'irt',16.667,1),(977,7555665,7555660,'rte',16.667,1),(977,7555666,7555660,'tee',16.667,1),(977,7555667,7555660,'een',16.667,1),(977,7555668,7555662,'fre',14.286,1),(977,7555669,7555662,'ree',14.286,1),(977,7555670,7555662,'ees',14.286,1),(977,7555671,7555662,'esp',14.286,1),(977,7555672,7555662,'spa',14.286,1),(977,7555673,7555662,'pac',14.286,1),(977,7555674,7555662,'ace',14.286,1),(977,7555675,7555668,'dis',50,1),(977,7555676,7555668,'isk',50,1),(977,7555677,7555675,'ind',33.333,1),(977,7555678,7555675,'nde',33.333,1),(977,7555679,7555675,'dex',33.333,1),(977,7555680,7555677,'adm',8.333,1),(977,7555681,7555677,'dmi',8.333,1),(977,7555682,7555677,'min',8.333,1),(977,7555683,7555677,'ini',8.333,1),(977,7555684,7555677,'nis',8.333,1),(977,7555685,7555677,'ist',8.333,1),(977,7555686,7555677,'str',8.333,1),(977,7555687,7555677,'tra',8.333,1),(977,7555688,7555677,'rat',8.333,1),(977,7555689,7555677,'ati',8.333,1),(977,7555690,7555677,'tio',8.333,1),(977,7555691,7555677,'ion',8.333,1),(977,7555692,7555680,'sta',33.333,3),(977,7555693,7555680,'tat',33.333,3),(977,7555694,7555680,'ate',33.333,3),(977,7555695,7555692,'dis',16.667,4),(977,7555696,7555692,'isa',16.667,4),(977,7555697,7555692,'sab',16.667,4),(977,7555698,7555692,'abl',16.667,4),(977,7555699,7555692,'ble',16.667,4),(977,7555700,7555692,'led',16.667,4),(977,7555701,7555695,'cac',33.333,1),(977,7555702,7555695,'ach',33.333,1),(977,7555703,7555695,'che',33.333,1),(977,7555704,7555701,'mod',50,1),(977,7555705,7555701,'ode',50,1),(977,7555706,7555704,'wri',14.286,1),(977,7555707,7555704,'rit',14.286,1),(977,7555708,7555704,'ite',14.286,1),(977,7555709,7555704,'tet',14.286,1),(977,7555710,7555704,'eth',14.286,1),(977,7555711,7555704,'thr',14.286,1),(977,7555712,7555704,'hru',14.286,1),(977,7555713,7555706,'ope',11.111,2),(977,7555714,7555706,'per',11.111,2),(977,7555715,7555706,'era',11.111,2),(977,7555716,7555706,'rat',11.111,2),(977,7555717,7555706,'ati',11.111,2),(977,7555718,7555706,'tio',11.111,2),(977,7555719,7555706,'ion',11.111,2),(977,7555720,7555706,'ona',11.111,2),(977,7555721,7555706,'nal',11.111,2),(977,7555722,7555713,'mes',20,1),(977,7555723,7555713,'ess',20,1),(977,7555724,7555713,'ssa',20,1),(977,7555725,7555713,'sag',20,1),(977,7555726,7555713,'age',20,1),(977,7555727,7555722,'per',11.111,1),(977,7555728,7555722,'erf',11.111,1),(977,7555729,7555722,'rfo',11.111,1),(977,7555730,7555722,'for',11.111,1),(977,7555731,7555722,'orm',11.111,1),(977,7555732,7555722,'rma',11.111,1),(977,7555733,7555722,'man',11.111,1),(977,7555734,7555722,'anc',11.111,1),(977,7555735,7555722,'nce',11.111,1),(977,7555736,7555727,'ide',12.5,1),(977,7555737,7555727,'den',12.5,1),(977,7555738,7555727,'ent',12.5,1),(977,7555739,7555727,'nti',12.5,1),(977,7555740,7555727,'tif',12.5,1),(977,7555741,7555727,'ifi',12.5,1),(977,7555742,7555727,'fie',12.5,1),(977,7555743,7555727,'ier',12.5,1),(977,7555744,7555736,'vdi',33.333,3),(977,7555745,7555736,'dis',33.333,3),(977,7555746,7555736,'isk',33.333,3),(977,7555747,7555744,'nam',50,1),(977,7555748,7555744,'ame',50,1),(977,7555749,7555747,'typ',50,1),(977,7555750,7555747,'ype',50,1),(977,7555751,7555749,'dir',25,1),(977,7555752,7555749,'ire',25,1),(977,7555753,7555749,'rec',25,1),(977,7555754,7555749,'ect',25,1),(978,7555756,7555755,'naa',100,2),(978,7555757,7555756,'600',3.333,3),(978,7555758,7555756,'000',3.333,3),(978,7555759,7555756,'00c',3.333,3),(978,7555760,7555756,'0c2',3.333,3),(978,7555761,7555756,'c29',3.333,3),(978,7555762,7555756,'291',3.333,3),(978,7555763,7555756,'91c',3.333,3),(978,7555764,7555756,'1cb',3.333,3),(978,7555765,7555756,'cb0',3.333,3),(978,7555766,7555756,'b0a',3.333,3),(978,7555767,7555756,'0ad',3.333,3),(978,7555768,7555756,'ad3',3.333,3),(978,7555769,7555756,'d33',3.333,3),(978,7555770,7555756,'336',3.333,3),(978,7555771,7555756,'366',3.333,3),(978,7555772,7555756,'667',3.333,3),(978,7555773,7555756,'67e',3.333,3),(978,7555774,7555756,'7e4',3.333,3),(978,7555775,7555756,'e46',3.333,3),(978,7555776,7555756,'464',3.333,3),(978,7555777,7555756,'64f',3.333,3),(978,7555778,7555756,'4fe',3.333,3),(978,7555779,7555756,'feb',3.333,3),(978,7555780,7555756,'ebe',3.333,3),(978,7555781,7555756,'bef',3.333,3),(978,7555782,7555756,'ef4',3.333,3),(978,7555783,7555756,'f4e',3.333,3),(978,7555784,7555756,'4e7',3.333,3),(978,7555785,7555756,'e7d',3.333,3),(978,7555786,7555756,'7d5',3.333,3),(978,7555787,7555757,'mon',100,1),(978,7555788,7555787,'201',50,1),(978,7555789,7555787,'013',50,1),(978,7555790,7555788,'adm',33.333,4),(978,7555791,7555788,'dmi',33.333,4),(978,7555792,7555788,'min',33.333,4),(978,7555793,7555790,'cap',16.667,1),(978,7555794,7555790,'apa',16.667,1),(978,7555795,7555790,'pac',16.667,1),(978,7555796,7555790,'aci',16.667,1),(978,7555797,7555790,'cit',16.667,1),(978,7555798,7555790,'ity',16.667,1),(978,7555799,7555793,'pat',50,1),(978,7555800,7555793,'ath',50,1),(978,7555801,7555799,'fre',14.286,1),(978,7555802,7555799,'ree',14.286,1),(978,7555803,7555799,'ees',14.286,1),(978,7555804,7555799,'esp',14.286,1),(978,7555805,7555799,'spa',14.286,1),(978,7555806,7555799,'pac',14.286,1),(978,7555807,7555799,'ace',14.286,1),(978,7555808,7555801,'dis',50,1),(978,7555809,7555801,'isk',50,1),(978,7555810,7555808,'ind',33.333,1),(978,7555811,7555808,'nde',33.333,1),(978,7555812,7555808,'dex',33.333,1),(978,7555813,7555810,'adm',8.333,1),(978,7555814,7555810,'dmi',8.333,1),(978,7555815,7555810,'min',8.333,1),(978,7555816,7555810,'ini',8.333,1),(978,7555817,7555810,'nis',8.333,1),(978,7555818,7555810,'ist',8.333,1),(978,7555819,7555810,'str',8.333,1),(978,7555820,7555810,'tra',8.333,1),(978,7555821,7555810,'rat',8.333,1),(978,7555822,7555810,'ati',8.333,1),(978,7555823,7555810,'tio',8.333,1),(978,7555824,7555810,'ion',8.333,1),(978,7555825,7555813,'sta',33.333,3),(978,7555826,7555813,'tat',33.333,3),(978,7555827,7555813,'ate',33.333,3),(978,7555828,7555825,'dis',16.667,4),(978,7555829,7555825,'isa',16.667,4),(978,7555830,7555825,'sab',16.667,4),(978,7555831,7555825,'abl',16.667,4),(978,7555832,7555825,'ble',16.667,4),(978,7555833,7555825,'led',16.667,4),(978,7555834,7555828,'cac',33.333,1),(978,7555835,7555828,'ach',33.333,1),(978,7555836,7555828,'che',33.333,1),(978,7555837,7555834,'mod',50,1),(978,7555838,7555834,'ode',50,1),(978,7555839,7555837,'wri',14.286,1),(978,7555840,7555837,'rit',14.286,1),(978,7555841,7555837,'ite',14.286,1),(978,7555842,7555837,'tet',14.286,1),(978,7555843,7555837,'eth',14.286,1),(978,7555844,7555837,'thr',14.286,1),(978,7555845,7555837,'hru',14.286,1),(978,7555846,7555839,'ope',11.111,2),(978,7555847,7555839,'per',11.111,2),(978,7555848,7555839,'era',11.111,2),(978,7555849,7555839,'rat',11.111,2),(978,7555850,7555839,'ati',11.111,2),(978,7555851,7555839,'tio',11.111,2),(978,7555852,7555839,'ion',11.111,2),(978,7555853,7555839,'ona',11.111,2),(978,7555854,7555839,'nal',11.111,2),(978,7555855,7555846,'mes',20,1),(978,7555856,7555846,'ess',20,1),(978,7555857,7555846,'ssa',20,1),(978,7555858,7555846,'sag',20,1),(978,7555859,7555846,'age',20,1),(978,7555860,7555855,'per',11.111,1),(978,7555861,7555855,'erf',11.111,1),(978,7555862,7555855,'rfo',11.111,1),(978,7555863,7555855,'for',11.111,1),(978,7555864,7555855,'orm',11.111,1),(978,7555865,7555855,'rma',11.111,1),(978,7555866,7555855,'man',11.111,1),(978,7555867,7555855,'anc',11.111,1),(978,7555868,7555855,'nce',11.111,1),(978,7555869,7555860,'ide',12.5,1),(978,7555870,7555860,'den',12.5,1),(978,7555871,7555860,'ent',12.5,1),(978,7555872,7555860,'nti',12.5,1),(978,7555873,7555860,'tif',12.5,1),(978,7555874,7555860,'ifi',12.5,1),(978,7555875,7555860,'fie',12.5,1),(978,7555876,7555860,'ier',12.5,1),(978,7555877,7555869,'vdi',33.333,3),(978,7555878,7555869,'dis',33.333,3),(978,7555879,7555869,'isk',33.333,3),(978,7555880,7555877,'nam',50,1),(978,7555881,7555877,'ame',50,1),(978,7555882,7555880,'typ',50,1),(978,7555883,7555880,'ype',50,1),(978,7555884,7555882,'dir',25,1),(978,7555885,7555882,'ire',25,1),(978,7555886,7555882,'rec',25,1),(978,7555887,7555882,'ect',25,1),(979,7555889,7555888,'naa',100,2),(979,7555890,7555889,'600',3.333,3),(979,7555891,7555889,'000',3.333,3),(979,7555892,7555889,'00c',3.333,3),(979,7555893,7555889,'0c2',3.333,3),(979,7555894,7555889,'c29',3.333,3),(979,7555895,7555889,'29f',3.333,3),(979,7555896,7555889,'9f6',3.333,3),(979,7555897,7555889,'f6d',3.333,3),(979,7555898,7555889,'6dd',3.333,3),(979,7555899,7555889,'dda',3.333,3),(979,7555900,7555889,'da1',3.333,3),(979,7555901,7555889,'a19',3.333,3),(979,7555902,7555889,'197',3.333,3),(979,7555903,7555889,'974',3.333,3),(979,7555904,7555889,'74b',3.333,3),(979,7555905,7555889,'4be',3.333,3),(979,7555906,7555889,'bec',3.333,3),(979,7555907,7555889,'ec5',3.333,3),(979,7555908,7555889,'c54',3.333,3),(979,7555909,7555889,'549',3.333,3),(979,7555910,7555889,'492',3.333,3),(979,7555911,7555889,'927',3.333,3),(979,7555912,7555889,'273',3.333,3),(979,7555913,7555889,'739',3.333,3),(979,7555914,7555889,'392',3.333,3),(979,7555915,7555889,'92f',3.333,3),(979,7555916,7555889,'2f4',3.333,3),(979,7555917,7555889,'f4f',3.333,3),(979,7555918,7555889,'4fd',3.333,3),(979,7555919,7555889,'fda',3.333,3),(979,7555920,7555890,'mon',100,1),(979,7555921,7555920,'201',50,1),(979,7555922,7555920,'013',50,1),(979,7555923,7555921,'adm',33.333,4),(979,7555924,7555921,'dmi',33.333,4),(979,7555925,7555921,'min',33.333,4),(979,7555926,7555923,'cap',16.667,1),(979,7555927,7555923,'apa',16.667,1),(979,7555928,7555923,'pac',16.667,1),(979,7555929,7555923,'aci',16.667,1),(979,7555930,7555923,'cit',16.667,1),(979,7555931,7555923,'ity',16.667,1),(979,7555932,7555926,'pat',50,1),(979,7555933,7555926,'ath',50,1),(979,7555934,7555932,'fre',14.286,1),(979,7555935,7555932,'ree',14.286,1),(979,7555936,7555932,'ees',14.286,1),(979,7555937,7555932,'esp',14.286,1),(979,7555938,7555932,'spa',14.286,1),(979,7555939,7555932,'pac',14.286,1),(979,7555940,7555932,'ace',14.286,1),(979,7555941,7555934,'dis',50,1),(979,7555942,7555934,'isk',50,1),(979,7555943,7555941,'ind',33.333,1),(979,7555944,7555941,'nde',33.333,1),(979,7555945,7555941,'dex',33.333,1),(979,7555946,7555943,'adm',8.333,1),(979,7555947,7555943,'dmi',8.333,1),(979,7555948,7555943,'min',8.333,1),(979,7555949,7555943,'ini',8.333,1),(979,7555950,7555943,'nis',8.333,1),(979,7555951,7555943,'ist',8.333,1),(979,7555952,7555943,'str',8.333,1),(979,7555953,7555943,'tra',8.333,1),(979,7555954,7555943,'rat',8.333,1),(979,7555955,7555943,'ati',8.333,1),(979,7555956,7555943,'tio',8.333,1),(979,7555957,7555943,'ion',8.333,1),(979,7555958,7555946,'sta',33.333,3),(979,7555959,7555946,'tat',33.333,3),(979,7555960,7555946,'ate',33.333,3),(979,7555961,7555958,'dis',16.667,4),(979,7555962,7555958,'isa',16.667,4),(979,7555963,7555958,'sab',16.667,4),(979,7555964,7555958,'abl',16.667,4),(979,7555965,7555958,'ble',16.667,4),(979,7555966,7555958,'led',16.667,4),(979,7555967,7555961,'cac',33.333,1),(979,7555968,7555961,'ach',33.333,1),(979,7555969,7555961,'che',33.333,1),(979,7555970,7555967,'mod',50,1),(979,7555971,7555967,'ode',50,1),(979,7555972,7555970,'wri',14.286,1),(979,7555973,7555970,'rit',14.286,1),(979,7555974,7555970,'ite',14.286,1),(979,7555975,7555970,'tet',14.286,1),(979,7555976,7555970,'eth',14.286,1),(979,7555977,7555970,'thr',14.286,1),(979,7555978,7555970,'hru',14.286,1),(979,7555979,7555972,'ope',11.111,2),(979,7555980,7555972,'per',11.111,2),(979,7555981,7555972,'era',11.111,2),(979,7555982,7555972,'rat',11.111,2),(979,7555983,7555972,'ati',11.111,2),(979,7555984,7555972,'tio',11.111,2),(979,7555985,7555972,'ion',11.111,2),(979,7555986,7555972,'ona',11.111,2),(979,7555987,7555972,'nal',11.111,2),(979,7555988,7555979,'mes',20,1),(979,7555989,7555979,'ess',20,1),(979,7555990,7555979,'ssa',20,1),(979,7555991,7555979,'sag',20,1),(979,7555992,7555979,'age',20,1),(979,7555993,7555988,'per',11.111,1),(979,7555994,7555988,'erf',11.111,1),(979,7555995,7555988,'rfo',11.111,1),(979,7555996,7555988,'for',11.111,1),(979,7555997,7555988,'orm',11.111,1),(979,7555998,7555988,'rma',11.111,1),(979,7555999,7555988,'man',11.111,1),(979,7556000,7555988,'anc',11.111,1),(979,7556001,7555988,'nce',11.111,1),(979,7556002,7555993,'ide',12.5,1),(979,7556003,7555993,'den',12.5,1),(979,7556004,7555993,'ent',12.5,1),(979,7556005,7555993,'nti',12.5,1),(979,7556006,7555993,'tif',12.5,1),(979,7556007,7555993,'ifi',12.5,1),(979,7556008,7555993,'fie',12.5,1),(979,7556009,7555993,'ier',12.5,1),(979,7556010,7556002,'vdi',33.333,3),(979,7556011,7556002,'dis',33.333,3),(979,7556012,7556002,'isk',33.333,3),(979,7556013,7556010,'nam',50,1),(979,7556014,7556010,'ame',50,1),(979,7556015,7556013,'typ',50,1),(979,7556016,7556013,'ype',50,1),(979,7556017,7556015,'dir',25,1),(979,7556018,7556015,'ire',25,1),(979,7556019,7556015,'rec',25,1),(979,7556020,7556015,'ect',25,1),(980,7556022,7556021,'naa',100,2),(980,7556023,7556022,'600',3.333,3),(980,7556024,7556022,'000',3.333,3),(980,7556025,7556022,'00c',3.333,3),(980,7556026,7556022,'0c2',3.333,3),(980,7556027,7556022,'c29',3.333,3),(980,7556028,7556022,'295',3.333,3),(980,7556029,7556022,'95e',3.333,3),(980,7556030,7556022,'5e7',3.333,3),(980,7556031,7556022,'e76',3.333,3),(980,7556032,7556022,'768',3.333,3),(980,7556033,7556022,'68f',3.333,3),(980,7556034,7556022,'8f9',3.333,3),(980,7556035,7556022,'f98',3.333,3),(980,7556036,7556022,'989',3.333,3),(980,7556037,7556022,'890',3.333,3),(980,7556038,7556022,'900',3.333,3),(980,7556039,7556022,'004',3.333,3),(980,7556040,7556022,'04a',3.333,3),(980,7556041,7556022,'4a3',3.333,3),(980,7556042,7556022,'a32',3.333,3),(980,7556043,7556022,'32a',3.333,3),(980,7556044,7556022,'2a4',3.333,3),(980,7556045,7556022,'a49',3.333,3),(980,7556046,7556022,'49f',3.333,3),(980,7556047,7556022,'9fc',3.333,3),(980,7556048,7556022,'fc8',3.333,3),(980,7556049,7556022,'c8d',3.333,3),(980,7556050,7556022,'8db',3.333,3),(980,7556051,7556022,'db8',3.333,3),(980,7556052,7556022,'b81',3.333,3),(980,7556053,7556023,'mon',100,1),(980,7556054,7556053,'201',50,1),(980,7556055,7556053,'013',50,1),(980,7556056,7556054,'adm',33.333,4),(980,7556057,7556054,'dmi',33.333,4),(980,7556058,7556054,'min',33.333,4),(980,7556059,7556056,'cap',16.667,1),(980,7556060,7556056,'apa',16.667,1),(980,7556061,7556056,'pac',16.667,1),(980,7556062,7556056,'aci',16.667,1),(980,7556063,7556056,'cit',16.667,1),(980,7556064,7556056,'ity',16.667,1),(980,7556065,7556059,'pat',50,1),(980,7556066,7556059,'ath',50,1),(980,7556067,7556065,'fre',14.286,1),(980,7556068,7556065,'ree',14.286,1),(980,7556069,7556065,'ees',14.286,1),(980,7556070,7556065,'esp',14.286,1),(980,7556071,7556065,'spa',14.286,1),(980,7556072,7556065,'pac',14.286,1),(980,7556073,7556065,'ace',14.286,1),(980,7556074,7556067,'dis',50,1),(980,7556075,7556067,'isk',50,1),(980,7556076,7556074,'ind',33.333,1),(980,7556077,7556074,'nde',33.333,1),(980,7556078,7556074,'dex',33.333,1),(980,7556079,7556076,'adm',8.333,1),(980,7556080,7556076,'dmi',8.333,1),(980,7556081,7556076,'min',8.333,1),(980,7556082,7556076,'ini',8.333,1),(980,7556083,7556076,'nis',8.333,1),(980,7556084,7556076,'ist',8.333,1),(980,7556085,7556076,'str',8.333,1),(980,7556086,7556076,'tra',8.333,1),(980,7556087,7556076,'rat',8.333,1),(980,7556088,7556076,'ati',8.333,1),(980,7556089,7556076,'tio',8.333,1),(980,7556090,7556076,'ion',8.333,1),(980,7556091,7556079,'sta',33.333,3),(980,7556092,7556079,'tat',33.333,3),(980,7556093,7556079,'ate',33.333,3),(980,7556094,7556091,'dis',16.667,4),(980,7556095,7556091,'isa',16.667,4),(980,7556096,7556091,'sab',16.667,4),(980,7556097,7556091,'abl',16.667,4),(980,7556098,7556091,'ble',16.667,4),(980,7556099,7556091,'led',16.667,4),(980,7556100,7556094,'cac',33.333,1),(980,7556101,7556094,'ach',33.333,1),(980,7556102,7556094,'che',33.333,1),(980,7556103,7556100,'mod',50,1),(980,7556104,7556100,'ode',50,1),(980,7556105,7556103,'wri',14.286,1),(980,7556106,7556103,'rit',14.286,1),(980,7556107,7556103,'ite',14.286,1),(980,7556108,7556103,'tet',14.286,1),(980,7556109,7556103,'eth',14.286,1),(980,7556110,7556103,'thr',14.286,1),(980,7556111,7556103,'hru',14.286,1),(980,7556112,7556105,'ope',11.111,2),(980,7556113,7556105,'per',11.111,2),(980,7556114,7556105,'era',11.111,2),(980,7556115,7556105,'rat',11.111,2),(980,7556116,7556105,'ati',11.111,2),(980,7556117,7556105,'tio',11.111,2),(980,7556118,7556105,'ion',11.111,2),(980,7556119,7556105,'ona',11.111,2),(980,7556120,7556105,'nal',11.111,2),(980,7556121,7556112,'mes',20,1),(980,7556122,7556112,'ess',20,1),(980,7556123,7556112,'ssa',20,1),(980,7556124,7556112,'sag',20,1),(980,7556125,7556112,'age',20,1),(980,7556126,7556121,'per',11.111,1),(980,7556127,7556121,'erf',11.111,1),(980,7556128,7556121,'rfo',11.111,1),(980,7556129,7556121,'for',11.111,1),(980,7556130,7556121,'orm',11.111,1),(980,7556131,7556121,'rma',11.111,1),(980,7556132,7556121,'man',11.111,1),(980,7556133,7556121,'anc',11.111,1),(980,7556134,7556121,'nce',11.111,1),(980,7556135,7556126,'ide',12.5,1),(980,7556136,7556126,'den',12.5,1),(980,7556137,7556126,'ent',12.5,1),(980,7556138,7556126,'nti',12.5,1),(980,7556139,7556126,'tif',12.5,1),(980,7556140,7556126,'ifi',12.5,1),(980,7556141,7556126,'fie',12.5,1),(980,7556142,7556126,'ier',12.5,1),(980,7556143,7556135,'vdi',33.333,3),(980,7556144,7556135,'dis',33.333,3),(980,7556145,7556135,'isk',33.333,3),(980,7556146,7556143,'nam',50,1),(980,7556147,7556143,'ame',50,1),(980,7556148,7556146,'typ',50,1),(980,7556149,7556146,'ype',50,1),(980,7556150,7556148,'dir',25,1),(980,7556151,7556148,'ire',25,1),(980,7556152,7556148,'rec',25,1),(980,7556153,7556148,'ect',25,1),(981,7556155,7556154,'naa',100,2),(981,7556156,7556155,'600',3.333,3),(981,7556157,7556155,'000',3.333,3),(981,7556158,7556155,'00c',3.333,3),(981,7556159,7556155,'0c2',3.333,3),(981,7556160,7556155,'c29',3.333,3),(981,7556161,7556155,'291',3.333,3),(981,7556162,7556155,'91d',3.333,3),(981,7556163,7556155,'1d5',3.333,3),(981,7556164,7556155,'d52',3.333,3),(981,7556165,7556155,'520',3.333,3),(981,7556166,7556155,'208',3.333,3),(981,7556167,7556155,'08d',3.333,3),(981,7556168,7556155,'8d1',3.333,3),(981,7556169,7556155,'d12',3.333,3),(981,7556170,7556155,'122',3.333,3),(981,7556171,7556155,'227',3.333,3),(981,7556172,7556155,'27d',3.333,3),(981,7556173,7556155,'7d0',3.333,3),(981,7556174,7556155,'d0c',3.333,3),(981,7556175,7556155,'0cd',3.333,3),(981,7556176,7556155,'cd9',3.333,3),(981,7556177,7556155,'d96',3.333,3),(981,7556178,7556155,'96b',3.333,3),(981,7556179,7556155,'6b3',3.333,3),(981,7556180,7556155,'b39',3.333,3),(981,7556181,7556155,'395',3.333,3),(981,7556182,7556155,'95a',3.333,3),(981,7556183,7556155,'5a1',3.333,3),(981,7556184,7556155,'a1b',3.333,3),(981,7556185,7556155,'1b3',3.333,3),(981,7556186,7556156,'mon',100,1),(981,7556187,7556186,'201',50,1),(981,7556188,7556186,'013',50,1),(981,7556189,7556187,'adm',33.333,4),(981,7556190,7556187,'dmi',33.333,4),(981,7556191,7556187,'min',33.333,4),(981,7556192,7556189,'cap',16.667,1),(981,7556193,7556189,'apa',16.667,1),(981,7556194,7556189,'pac',16.667,1),(981,7556195,7556189,'aci',16.667,1),(981,7556196,7556189,'cit',16.667,1),(981,7556197,7556189,'ity',16.667,1),(981,7556198,7556192,'pat',50,1),(981,7556199,7556192,'ath',50,1),(981,7556200,7556198,'fre',14.286,1),(981,7556201,7556198,'ree',14.286,1),(981,7556202,7556198,'ees',14.286,1),(981,7556203,7556198,'esp',14.286,1),(981,7556204,7556198,'spa',14.286,1),(981,7556205,7556198,'pac',14.286,1),(981,7556206,7556198,'ace',14.286,1),(981,7556207,7556200,'dis',50,1),(981,7556208,7556200,'isk',50,1),(981,7556209,7556207,'ind',33.333,1),(981,7556210,7556207,'nde',33.333,1),(981,7556211,7556207,'dex',33.333,1),(981,7556212,7556209,'adm',8.333,1),(981,7556213,7556209,'dmi',8.333,1),(981,7556214,7556209,'min',8.333,1),(981,7556215,7556209,'ini',8.333,1),(981,7556216,7556209,'nis',8.333,1),(981,7556217,7556209,'ist',8.333,1),(981,7556218,7556209,'str',8.333,1),(981,7556219,7556209,'tra',8.333,1),(981,7556220,7556209,'rat',8.333,1),(981,7556221,7556209,'ati',8.333,1),(981,7556222,7556209,'tio',8.333,1),(981,7556223,7556209,'ion',8.333,1),(981,7556224,7556212,'sta',33.333,3),(981,7556225,7556212,'tat',33.333,3),(981,7556226,7556212,'ate',33.333,3),(981,7556227,7556224,'dis',16.667,4),(981,7556228,7556224,'isa',16.667,4),(981,7556229,7556224,'sab',16.667,4),(981,7556230,7556224,'abl',16.667,4),(981,7556231,7556224,'ble',16.667,4),(981,7556232,7556224,'led',16.667,4),(981,7556233,7556227,'cac',33.333,1),(981,7556234,7556227,'ach',33.333,1),(981,7556235,7556227,'che',33.333,1),(981,7556236,7556233,'mod',50,1),(981,7556237,7556233,'ode',50,1),(981,7556238,7556236,'wri',14.286,1),(981,7556239,7556236,'rit',14.286,1),(981,7556240,7556236,'ite',14.286,1),(981,7556241,7556236,'tet',14.286,1),(981,7556242,7556236,'eth',14.286,1),(981,7556243,7556236,'thr',14.286,1),(981,7556244,7556236,'hru',14.286,1),(981,7556245,7556238,'ope',11.111,2),(981,7556246,7556238,'per',11.111,2),(981,7556247,7556238,'era',11.111,2),(981,7556248,7556238,'rat',11.111,2),(981,7556249,7556238,'ati',11.111,2),(981,7556250,7556238,'tio',11.111,2),(981,7556251,7556238,'ion',11.111,2),(981,7556252,7556238,'ona',11.111,2),(981,7556253,7556238,'nal',11.111,2),(981,7556254,7556245,'mes',20,1),(981,7556255,7556245,'ess',20,1),(981,7556256,7556245,'ssa',20,1),(981,7556257,7556245,'sag',20,1),(981,7556258,7556245,'age',20,1),(981,7556259,7556254,'per',11.111,1),(981,7556260,7556254,'erf',11.111,1),(981,7556261,7556254,'rfo',11.111,1),(981,7556262,7556254,'for',11.111,1),(981,7556263,7556254,'orm',11.111,1),(981,7556264,7556254,'rma',11.111,1),(981,7556265,7556254,'man',11.111,1),(981,7556266,7556254,'anc',11.111,1),(981,7556267,7556254,'nce',11.111,1),(981,7556268,7556259,'ide',12.5,1),(981,7556269,7556259,'den',12.5,1),(981,7556270,7556259,'ent',12.5,1),(981,7556271,7556259,'nti',12.5,1),(981,7556272,7556259,'tif',12.5,1),(981,7556273,7556259,'ifi',12.5,1),(981,7556274,7556259,'fie',12.5,1),(981,7556275,7556259,'ier',12.5,1),(981,7556276,7556268,'vdi',33.333,3),(981,7556277,7556268,'dis',33.333,3),(981,7556278,7556268,'isk',33.333,3),(981,7556279,7556276,'nam',50,1),(981,7556280,7556276,'ame',50,1),(981,7556281,7556279,'typ',50,1),(981,7556282,7556279,'ype',50,1),(981,7556283,7556281,'dir',25,1),(981,7556284,7556281,'ire',25,1),(981,7556285,7556281,'rec',25,1),(981,7556286,7556281,'ect',25,1),(982,7556288,7556287,'naa',100,2),(982,7556289,7556288,'600',3.333,3),(982,7556290,7556288,'000',3.333,3),(982,7556291,7556288,'00c',3.333,3),(982,7556292,7556288,'0c2',3.333,3),(982,7556293,7556288,'c29',3.333,3),(982,7556294,7556288,'293',3.333,3),(982,7556295,7556288,'938',3.333,3),(982,7556296,7556288,'387',3.333,3),(982,7556297,7556288,'872',3.333,3),(982,7556298,7556288,'723',3.333,3),(982,7556299,7556288,'234',3.333,3),(982,7556300,7556288,'34c',3.333,3),(982,7556301,7556288,'4c5',3.333,3),(982,7556302,7556288,'c59',3.333,3),(982,7556303,7556288,'597',3.333,3),(982,7556304,7556288,'97d',3.333,3),(982,7556305,7556288,'7d0',3.333,3),(982,7556306,7556288,'d0f',3.333,3),(982,7556307,7556288,'0f1',3.333,3),(982,7556308,7556288,'f18',3.333,3),(982,7556309,7556288,'181',3.333,3),(982,7556310,7556288,'812',3.333,3),(982,7556311,7556288,'12d',3.333,3),(982,7556312,7556288,'2d8',3.333,3),(982,7556313,7556288,'d88',3.333,3),(982,7556314,7556288,'885',3.333,3),(982,7556315,7556288,'850',3.333,3),(982,7556316,7556288,'50b',3.333,3),(982,7556317,7556288,'0b9',3.333,3),(982,7556318,7556288,'b9b',3.333,3),(982,7556319,7556289,'mon',100,1),(982,7556320,7556319,'201',50,1),(982,7556321,7556319,'013',50,1),(982,7556322,7556320,'adm',33.333,4),(982,7556323,7556320,'dmi',33.333,4),(982,7556324,7556320,'min',33.333,4),(982,7556325,7556322,'cap',16.667,1),(982,7556326,7556322,'apa',16.667,1),(982,7556327,7556322,'pac',16.667,1),(982,7556328,7556322,'aci',16.667,1),(982,7556329,7556322,'cit',16.667,1),(982,7556330,7556322,'ity',16.667,1),(982,7556331,7556325,'pat',50,1),(982,7556332,7556325,'ath',50,1),(982,7556333,7556331,'fre',14.286,1),(982,7556334,7556331,'ree',14.286,1),(982,7556335,7556331,'ees',14.286,1),(982,7556336,7556331,'esp',14.286,1),(982,7556337,7556331,'spa',14.286,1),(982,7556338,7556331,'pac',14.286,1),(982,7556339,7556331,'ace',14.286,1),(982,7556340,7556333,'dis',50,1),(982,7556341,7556333,'isk',50,1),(982,7556342,7556340,'ind',33.333,1),(982,7556343,7556340,'nde',33.333,1),(982,7556344,7556340,'dex',33.333,1),(982,7556345,7556342,'adm',8.333,1),(982,7556346,7556342,'dmi',8.333,1),(982,7556347,7556342,'min',8.333,1),(982,7556348,7556342,'ini',8.333,1),(982,7556349,7556342,'nis',8.333,1),(982,7556350,7556342,'ist',8.333,1),(982,7556351,7556342,'str',8.333,1),(982,7556352,7556342,'tra',8.333,1),(982,7556353,7556342,'rat',8.333,1),(982,7556354,7556342,'ati',8.333,1),(982,7556355,7556342,'tio',8.333,1),(982,7556356,7556342,'ion',8.333,1),(982,7556357,7556345,'sta',33.333,3),(982,7556358,7556345,'tat',33.333,3),(982,7556359,7556345,'ate',33.333,3),(982,7556360,7556357,'dis',16.667,4),(982,7556361,7556357,'isa',16.667,4),(982,7556362,7556357,'sab',16.667,4),(982,7556363,7556357,'abl',16.667,4),(982,7556364,7556357,'ble',16.667,4),(982,7556365,7556357,'led',16.667,4),(982,7556366,7556360,'cac',33.333,1),(982,7556367,7556360,'ach',33.333,1),(982,7556368,7556360,'che',33.333,1),(982,7556369,7556366,'mod',50,1),(982,7556370,7556366,'ode',50,1),(982,7556371,7556369,'wri',14.286,1),(982,7556372,7556369,'rit',14.286,1),(982,7556373,7556369,'ite',14.286,1),(982,7556374,7556369,'tet',14.286,1),(982,7556375,7556369,'eth',14.286,1),(982,7556376,7556369,'thr',14.286,1),(982,7556377,7556369,'hru',14.286,1),(982,7556378,7556371,'ope',11.111,2),(982,7556379,7556371,'per',11.111,2),(982,7556380,7556371,'era',11.111,2),(982,7556381,7556371,'rat',11.111,2),(982,7556382,7556371,'ati',11.111,2),(982,7556383,7556371,'tio',11.111,2),(982,7556384,7556371,'ion',11.111,2),(982,7556385,7556371,'ona',11.111,2),(982,7556386,7556371,'nal',11.111,2),(982,7556387,7556378,'mes',20,1),(982,7556388,7556378,'ess',20,1),(982,7556389,7556378,'ssa',20,1),(982,7556390,7556378,'sag',20,1),(982,7556391,7556378,'age',20,1),(982,7556392,7556387,'per',11.111,1),(982,7556393,7556387,'erf',11.111,1),(982,7556394,7556387,'rfo',11.111,1),(982,7556395,7556387,'for',11.111,1),(982,7556396,7556387,'orm',11.111,1),(982,7556397,7556387,'rma',11.111,1),(982,7556398,7556387,'man',11.111,1),(982,7556399,7556387,'anc',11.111,1),(982,7556400,7556387,'nce',11.111,1),(982,7556401,7556392,'ide',12.5,1),(982,7556402,7556392,'den',12.5,1),(982,7556403,7556392,'ent',12.5,1),(982,7556404,7556392,'nti',12.5,1),(982,7556405,7556392,'tif',12.5,1),(982,7556406,7556392,'ifi',12.5,1),(982,7556407,7556392,'fie',12.5,1),(982,7556408,7556392,'ier',12.5,1),(982,7556409,7556401,'vdi',33.333,3),(982,7556410,7556401,'dis',33.333,3),(982,7556411,7556401,'isk',33.333,3),(982,7556412,7556409,'nam',50,1),(982,7556413,7556409,'ame',50,1),(982,7556414,7556412,'typ',50,1),(982,7556415,7556412,'ype',50,1),(982,7556416,7556414,'dir',25,1),(982,7556417,7556414,'ire',25,1),(982,7556418,7556414,'rec',25,1),(982,7556419,7556414,'ect',25,1),(983,7556421,7556420,'naa',100,2),(983,7556422,7556421,'600',3.333,3),(983,7556423,7556421,'000',3.333,3),(983,7556424,7556421,'00c',3.333,3),(983,7556425,7556421,'0c2',3.333,3),(983,7556426,7556421,'c29',3.333,3),(983,7556427,7556421,'290',3.333,3),(983,7556428,7556421,'902',3.333,3),(983,7556429,7556421,'02a',3.333,3),(983,7556430,7556421,'2ad',3.333,3),(983,7556431,7556421,'adb',3.333,3),(983,7556432,7556421,'db6',3.333,3),(983,7556433,7556421,'b68',3.333,3),(983,7556434,7556421,'689',3.333,3),(983,7556435,7556421,'89f',3.333,3),(983,7556436,7556421,'9f1',3.333,3),(983,7556437,7556421,'f12',3.333,3),(983,7556438,7556421,'12c',3.333,3),(983,7556439,7556421,'2c0',3.333,3),(983,7556440,7556421,'c0a',3.333,3),(983,7556441,7556421,'0a9',3.333,3),(983,7556442,7556421,'a98',3.333,3),(983,7556443,7556421,'98c',3.333,3),(983,7556444,7556421,'8cf',3.333,3),(983,7556445,7556421,'cfc',3.333,3),(983,7556446,7556421,'fc3',3.333,3),(983,7556447,7556421,'c3f',3.333,3),(983,7556448,7556421,'3f2',3.333,3),(983,7556449,7556421,'f22',3.333,3),(983,7556450,7556421,'22f',3.333,3),(983,7556451,7556421,'2f4',3.333,3),(983,7556452,7556422,'mon',100,1),(983,7556453,7556452,'201',50,1),(983,7556454,7556452,'013',50,1),(983,7556455,7556453,'adm',33.333,4),(983,7556456,7556453,'dmi',33.333,4),(983,7556457,7556453,'min',33.333,4),(983,7556458,7556455,'cap',16.667,1),(983,7556459,7556455,'apa',16.667,1),(983,7556460,7556455,'pac',16.667,1),(983,7556461,7556455,'aci',16.667,1),(983,7556462,7556455,'cit',16.667,1),(983,7556463,7556455,'ity',16.667,1),(983,7556464,7556458,'pat',50,1),(983,7556465,7556458,'ath',50,1),(983,7556466,7556464,'fre',14.286,1),(983,7556467,7556464,'ree',14.286,1),(983,7556468,7556464,'ees',14.286,1),(983,7556469,7556464,'esp',14.286,1),(983,7556470,7556464,'spa',14.286,1),(983,7556471,7556464,'pac',14.286,1),(983,7556472,7556464,'ace',14.286,1),(983,7556473,7556466,'dis',50,1),(983,7556474,7556466,'isk',50,1),(983,7556475,7556473,'ind',33.333,1),(983,7556476,7556473,'nde',33.333,1),(983,7556477,7556473,'dex',33.333,1),(983,7556478,7556475,'adm',8.333,1),(983,7556479,7556475,'dmi',8.333,1),(983,7556480,7556475,'min',8.333,1),(983,7556481,7556475,'ini',8.333,1),(983,7556482,7556475,'nis',8.333,1),(983,7556483,7556475,'ist',8.333,1),(983,7556484,7556475,'str',8.333,1),(983,7556485,7556475,'tra',8.333,1),(983,7556486,7556475,'rat',8.333,1),(983,7556487,7556475,'ati',8.333,1),(983,7556488,7556475,'tio',8.333,1),(983,7556489,7556475,'ion',8.333,1),(983,7556490,7556478,'sta',33.333,3),(983,7556491,7556478,'tat',33.333,3),(983,7556492,7556478,'ate',33.333,3),(983,7556493,7556490,'dis',16.667,4),(983,7556494,7556490,'isa',16.667,4),(983,7556495,7556490,'sab',16.667,4),(983,7556496,7556490,'abl',16.667,4),(983,7556497,7556490,'ble',16.667,4),(983,7556498,7556490,'led',16.667,4),(983,7556499,7556493,'cac',33.333,1),(983,7556500,7556493,'ach',33.333,1),(983,7556501,7556493,'che',33.333,1),(983,7556502,7556499,'mod',50,1),(983,7556503,7556499,'ode',50,1),(983,7556504,7556502,'wri',14.286,1),(983,7556505,7556502,'rit',14.286,1),(983,7556506,7556502,'ite',14.286,1),(983,7556507,7556502,'tet',14.286,1),(983,7556508,7556502,'eth',14.286,1),(983,7556509,7556502,'thr',14.286,1),(983,7556510,7556502,'hru',14.286,1),(983,7556511,7556504,'ope',11.111,2),(983,7556512,7556504,'per',11.111,2),(983,7556513,7556504,'era',11.111,2),(983,7556514,7556504,'rat',11.111,2),(983,7556515,7556504,'ati',11.111,2),(983,7556516,7556504,'tio',11.111,2),(983,7556517,7556504,'ion',11.111,2),(983,7556518,7556504,'ona',11.111,2),(983,7556519,7556504,'nal',11.111,2),(983,7556520,7556511,'mes',20,1),(983,7556521,7556511,'ess',20,1),(983,7556522,7556511,'ssa',20,1),(983,7556523,7556511,'sag',20,1),(983,7556524,7556511,'age',20,1),(983,7556525,7556520,'per',11.111,1),(983,7556526,7556520,'erf',11.111,1),(983,7556527,7556520,'rfo',11.111,1),(983,7556528,7556520,'for',11.111,1),(983,7556529,7556520,'orm',11.111,1),(983,7556530,7556520,'rma',11.111,1),(983,7556531,7556520,'man',11.111,1),(983,7556532,7556520,'anc',11.111,1),(983,7556533,7556520,'nce',11.111,1),(983,7556534,7556525,'ide',12.5,1),(983,7556535,7556525,'den',12.5,1),(983,7556536,7556525,'ent',12.5,1),(983,7556537,7556525,'nti',12.5,1),(983,7556538,7556525,'tif',12.5,1),(983,7556539,7556525,'ifi',12.5,1),(983,7556540,7556525,'fie',12.5,1),(983,7556541,7556525,'ier',12.5,1),(983,7556542,7556534,'vdi',33.333,3),(983,7556543,7556534,'dis',33.333,3),(983,7556544,7556534,'isk',33.333,3),(983,7556545,7556542,'nam',50,1),(983,7556546,7556542,'ame',50,1),(983,7556547,7556545,'typ',50,1),(983,7556548,7556545,'ype',50,1),(983,7556549,7556547,'dir',25,1),(983,7556550,7556547,'ire',25,1),(983,7556551,7556547,'rec',25,1),(983,7556552,7556547,'ect',25,1),(984,7556554,7556553,'naa',100,2),(984,7556555,7556554,'600',3.333,3),(984,7556556,7556554,'000',3.333,3),(984,7556557,7556554,'00c',3.333,3),(984,7556558,7556554,'0c2',3.333,3),(984,7556559,7556554,'c29',3.333,3),(984,7556560,7556554,'29c',3.333,3),(984,7556561,7556554,'9c0',3.333,3),(984,7556562,7556554,'c00',3.333,3),(984,7556563,7556554,'00f',3.333,3),(984,7556564,7556554,'0fb',3.333,3),(984,7556565,7556554,'fbf',3.333,3),(984,7556566,7556554,'bfc',3.333,3),(984,7556567,7556554,'fc2',3.333,3),(984,7556568,7556554,'c2e',3.333,3),(984,7556569,7556554,'2e9',3.333,3),(984,7556570,7556554,'e91',3.333,3),(984,7556571,7556554,'913',3.333,3),(984,7556572,7556554,'134',3.333,3),(984,7556573,7556554,'342',3.333,3),(984,7556574,7556554,'428',3.333,3),(984,7556575,7556554,'289',3.333,3),(984,7556576,7556554,'89c',3.333,3),(984,7556577,7556554,'9c0',3.333,3),(984,7556578,7556554,'c06',3.333,3),(984,7556579,7556554,'06d',3.333,3),(984,7556580,7556554,'6d3',3.333,3),(984,7556581,7556554,'d33',3.333,3),(984,7556582,7556554,'335',3.333,3),(984,7556583,7556554,'356',3.333,3),(984,7556584,7556554,'563',3.333,3),(984,7556585,7556555,'mon',100,1),(984,7556586,7556585,'201',50,1),(984,7556587,7556585,'013',50,1),(984,7556588,7556586,'adm',33.333,4),(984,7556589,7556586,'dmi',33.333,4),(984,7556590,7556586,'min',33.333,4),(984,7556591,7556588,'cap',16.667,1),(984,7556592,7556588,'apa',16.667,1),(984,7556593,7556588,'pac',16.667,1),(984,7556594,7556588,'aci',16.667,1),(984,7556595,7556588,'cit',16.667,1),(984,7556596,7556588,'ity',16.667,1),(984,7556597,7556591,'pat',50,1),(984,7556598,7556591,'ath',50,1),(984,7556599,7556597,'fre',14.286,1),(984,7556600,7556597,'ree',14.286,1),(984,7556601,7556597,'ees',14.286,1),(984,7556602,7556597,'esp',14.286,1),(984,7556603,7556597,'spa',14.286,1),(984,7556604,7556597,'pac',14.286,1),(984,7556605,7556597,'ace',14.286,1),(984,7556606,7556599,'dis',50,1),(984,7556607,7556599,'isk',50,1),(984,7556608,7556606,'ind',33.333,1),(984,7556609,7556606,'nde',33.333,1),(984,7556610,7556606,'dex',33.333,1),(984,7556611,7556608,'adm',8.333,1),(984,7556612,7556608,'dmi',8.333,1),(984,7556613,7556608,'min',8.333,1),(984,7556614,7556608,'ini',8.333,1),(984,7556615,7556608,'nis',8.333,1),(984,7556616,7556608,'ist',8.333,1),(984,7556617,7556608,'str',8.333,1),(984,7556618,7556608,'tra',8.333,1),(984,7556619,7556608,'rat',8.333,1),(984,7556620,7556608,'ati',8.333,1),(984,7556621,7556608,'tio',8.333,1),(984,7556622,7556608,'ion',8.333,1),(984,7556623,7556611,'sta',33.333,3),(984,7556624,7556611,'tat',33.333,3),(984,7556625,7556611,'ate',33.333,3),(984,7556626,7556623,'dis',16.667,4),(984,7556627,7556623,'isa',16.667,4),(984,7556628,7556623,'sab',16.667,4),(984,7556629,7556623,'abl',16.667,4),(984,7556630,7556623,'ble',16.667,4),(984,7556631,7556623,'led',16.667,4),(984,7556632,7556626,'cac',33.333,1),(984,7556633,7556626,'ach',33.333,1),(984,7556634,7556626,'che',33.333,1),(984,7556635,7556632,'mod',50,1),(984,7556636,7556632,'ode',50,1),(984,7556637,7556635,'wri',14.286,1),(984,7556638,7556635,'rit',14.286,1),(984,7556639,7556635,'ite',14.286,1),(984,7556640,7556635,'tet',14.286,1),(984,7556641,7556635,'eth',14.286,1),(984,7556642,7556635,'thr',14.286,1),(984,7556643,7556635,'hru',14.286,1),(984,7556644,7556637,'ope',11.111,2),(984,7556645,7556637,'per',11.111,2),(984,7556646,7556637,'era',11.111,2),(984,7556647,7556637,'rat',11.111,2),(984,7556648,7556637,'ati',11.111,2),(984,7556649,7556637,'tio',11.111,2),(984,7556650,7556637,'ion',11.111,2),(984,7556651,7556637,'ona',11.111,2),(984,7556652,7556637,'nal',11.111,2),(984,7556653,7556644,'mes',20,1),(984,7556654,7556644,'ess',20,1),(984,7556655,7556644,'ssa',20,1),(984,7556656,7556644,'sag',20,1),(984,7556657,7556644,'age',20,1),(984,7556658,7556653,'per',11.111,1),(984,7556659,7556653,'erf',11.111,1),(984,7556660,7556653,'rfo',11.111,1),(984,7556661,7556653,'for',11.111,1),(984,7556662,7556653,'orm',11.111,1),(984,7556663,7556653,'rma',11.111,1),(984,7556664,7556653,'man',11.111,1),(984,7556665,7556653,'anc',11.111,1),(984,7556666,7556653,'nce',11.111,1),(984,7556667,7556658,'ide',12.5,1),(984,7556668,7556658,'den',12.5,1),(984,7556669,7556658,'ent',12.5,1),(984,7556670,7556658,'nti',12.5,1),(984,7556671,7556658,'tif',12.5,1),(984,7556672,7556658,'ifi',12.5,1),(984,7556673,7556658,'fie',12.5,1),(984,7556674,7556658,'ier',12.5,1),(984,7556675,7556667,'vdi',33.333,3),(984,7556676,7556667,'dis',33.333,3),(984,7556677,7556667,'isk',33.333,3),(984,7556678,7556675,'nam',50,1),(984,7556679,7556675,'ame',50,1),(984,7556680,7556678,'typ',50,1),(984,7556681,7556678,'ype',50,1),(984,7556682,7556680,'dir',25,1),(984,7556683,7556680,'ire',25,1),(984,7556684,7556680,'rec',25,1),(984,7556685,7556680,'ect',25,1),(985,7556687,7556686,'naa',100,2),(985,7556688,7556687,'600',3.333,3),(985,7556689,7556687,'000',3.333,3),(985,7556690,7556687,'00c',3.333,3),(985,7556691,7556687,'0c2',3.333,3),(985,7556692,7556687,'c29',3.333,3),(985,7556693,7556687,'296',3.333,3),(985,7556694,7556687,'960',3.333,3),(985,7556695,7556687,'608',3.333,3),(985,7556696,7556687,'083',3.333,3),(985,7556697,7556687,'834',3.333,3),(985,7556698,7556687,'348',3.333,3),(985,7556699,7556687,'481',3.333,3),(985,7556700,7556687,'817',3.333,3),(985,7556701,7556687,'17d',3.333,3),(985,7556702,7556687,'7d1',3.333,3),(985,7556703,7556687,'d18',3.333,3),(985,7556704,7556687,'188',3.333,3),(985,7556705,7556687,'881',3.333,3),(985,7556706,7556687,'81d',3.333,3),(985,7556707,7556687,'1d6',3.333,3),(985,7556708,7556687,'d64',3.333,3),(985,7556709,7556687,'640',3.333,3),(985,7556710,7556687,'40e',3.333,3),(985,7556711,7556687,'0e5',3.333,3),(985,7556712,7556687,'e59',3.333,3),(985,7556713,7556687,'597',3.333,3),(985,7556714,7556687,'97f',3.333,3),(985,7556715,7556687,'7f4',3.333,3),(985,7556716,7556687,'f45',3.333,3),(985,7556717,7556687,'45c',3.333,3),(985,7556718,7556688,'mon',100,1),(985,7556719,7556718,'201',50,1),(985,7556720,7556718,'013',50,1),(985,7556721,7556719,'adm',33.333,4),(985,7556722,7556719,'dmi',33.333,4),(985,7556723,7556719,'min',33.333,4),(985,7556724,7556721,'cap',16.667,1),(985,7556725,7556721,'apa',16.667,1),(985,7556726,7556721,'pac',16.667,1),(985,7556727,7556721,'aci',16.667,1),(985,7556728,7556721,'cit',16.667,1),(985,7556729,7556721,'ity',16.667,1),(985,7556730,7556724,'pat',50,1),(985,7556731,7556724,'ath',50,1),(985,7556732,7556730,'fre',14.286,1),(985,7556733,7556730,'ree',14.286,1),(985,7556734,7556730,'ees',14.286,1),(985,7556735,7556730,'esp',14.286,1),(985,7556736,7556730,'spa',14.286,1),(985,7556737,7556730,'pac',14.286,1),(985,7556738,7556730,'ace',14.286,1),(985,7556739,7556732,'dis',50,1),(985,7556740,7556732,'isk',50,1),(985,7556741,7556739,'ind',33.333,1),(985,7556742,7556739,'nde',33.333,1),(985,7556743,7556739,'dex',33.333,1),(985,7556744,7556741,'adm',8.333,1),(985,7556745,7556741,'dmi',8.333,1),(985,7556746,7556741,'min',8.333,1),(985,7556747,7556741,'ini',8.333,1),(985,7556748,7556741,'nis',8.333,1),(985,7556749,7556741,'ist',8.333,1),(985,7556750,7556741,'str',8.333,1),(985,7556751,7556741,'tra',8.333,1),(985,7556752,7556741,'rat',8.333,1),(985,7556753,7556741,'ati',8.333,1),(985,7556754,7556741,'tio',8.333,1),(985,7556755,7556741,'ion',8.333,1),(985,7556756,7556744,'sta',33.333,3),(985,7556757,7556744,'tat',33.333,3),(985,7556758,7556744,'ate',33.333,3),(985,7556759,7556756,'dis',16.667,4),(985,7556760,7556756,'isa',16.667,4),(985,7556761,7556756,'sab',16.667,4),(985,7556762,7556756,'abl',16.667,4),(985,7556763,7556756,'ble',16.667,4),(985,7556764,7556756,'led',16.667,4),(985,7556765,7556759,'cac',33.333,1),(985,7556766,7556759,'ach',33.333,1),(985,7556767,7556759,'che',33.333,1),(985,7556768,7556765,'mod',50,1),(985,7556769,7556765,'ode',50,1),(985,7556770,7556768,'wri',14.286,1),(985,7556771,7556768,'rit',14.286,1),(985,7556772,7556768,'ite',14.286,1),(985,7556773,7556768,'tet',14.286,1),(985,7556774,7556768,'eth',14.286,1),(985,7556775,7556768,'thr',14.286,1),(985,7556776,7556768,'hru',14.286,1),(985,7556777,7556770,'ope',11.111,2),(985,7556778,7556770,'per',11.111,2),(985,7556779,7556770,'era',11.111,2),(985,7556780,7556770,'rat',11.111,2),(985,7556781,7556770,'ati',11.111,2),(985,7556782,7556770,'tio',11.111,2),(985,7556783,7556770,'ion',11.111,2),(985,7556784,7556770,'ona',11.111,2),(985,7556785,7556770,'nal',11.111,2),(985,7556786,7556777,'mes',20,1),(985,7556787,7556777,'ess',20,1),(985,7556788,7556777,'ssa',20,1),(985,7556789,7556777,'sag',20,1),(985,7556790,7556777,'age',20,1),(985,7556791,7556786,'per',11.111,1),(985,7556792,7556786,'erf',11.111,1),(985,7556793,7556786,'rfo',11.111,1),(985,7556794,7556786,'for',11.111,1),(985,7556795,7556786,'orm',11.111,1),(985,7556796,7556786,'rma',11.111,1),(985,7556797,7556786,'man',11.111,1),(985,7556798,7556786,'anc',11.111,1),(985,7556799,7556786,'nce',11.111,1),(985,7556800,7556791,'ide',12.5,1),(985,7556801,7556791,'den',12.5,1),(985,7556802,7556791,'ent',12.5,1),(985,7556803,7556791,'nti',12.5,1),(985,7556804,7556791,'tif',12.5,1),(985,7556805,7556791,'ifi',12.5,1),(985,7556806,7556791,'fie',12.5,1),(985,7556807,7556791,'ier',12.5,1),(985,7556808,7556800,'vdi',33.333,3),(985,7556809,7556800,'dis',33.333,3),(985,7556810,7556800,'isk',33.333,3),(985,7556811,7556808,'nam',50,1),(985,7556812,7556808,'ame',50,1),(985,7556813,7556811,'typ',50,1),(985,7556814,7556811,'ype',50,1),(985,7556815,7556813,'dir',25,1),(985,7556816,7556813,'ire',25,1),(985,7556817,7556813,'rec',25,1),(985,7556818,7556813,'ect',25,1),(986,7556820,7556819,'naa',100,2),(986,7556821,7556820,'600',3.333,3),(986,7556822,7556820,'000',3.333,3),(986,7556823,7556820,'00c',3.333,3),(986,7556824,7556820,'0c2',3.333,3),(986,7556825,7556820,'c29',3.333,3),(986,7556826,7556820,'293',3.333,3),(986,7556827,7556820,'939',3.333,3),(986,7556828,7556820,'396',3.333,3),(986,7556829,7556820,'964',3.333,3),(986,7556830,7556820,'642',3.333,3),(986,7556831,7556820,'42f',3.333,3),(986,7556832,7556820,'2f3',3.333,3),(986,7556833,7556820,'f3d',3.333,3),(986,7556834,7556820,'3de',3.333,3),(986,7556835,7556820,'de3',3.333,3),(986,7556836,7556820,'e31',3.333,3),(986,7556837,7556820,'31b',3.333,3),(986,7556838,7556820,'1b1',3.333,3),(986,7556839,7556820,'b1c',3.333,3),(986,7556840,7556820,'1ca',3.333,3),(986,7556841,7556820,'ca3',3.333,3),(986,7556842,7556820,'a33',3.333,3),(986,7556843,7556820,'334',3.333,3),(986,7556844,7556820,'344',3.333,3),(986,7556845,7556820,'440',3.333,3),(986,7556846,7556820,'402',3.333,3),(986,7556847,7556820,'02b',3.333,3),(986,7556848,7556820,'2ba',3.333,3),(986,7556849,7556820,'ba9',3.333,3),(986,7556850,7556820,'a96',3.333,3),(986,7556851,7556821,'mon',100,1),(986,7556852,7556851,'201',50,1),(986,7556853,7556851,'013',50,1),(986,7556854,7556852,'adm',33.333,4),(986,7556855,7556852,'dmi',33.333,4),(986,7556856,7556852,'min',33.333,4),(986,7556857,7556854,'cap',16.667,1),(986,7556858,7556854,'apa',16.667,1),(986,7556859,7556854,'pac',16.667,1),(986,7556860,7556854,'aci',16.667,1),(986,7556861,7556854,'cit',16.667,1),(986,7556862,7556854,'ity',16.667,1),(986,7556863,7556857,'pat',50,1),(986,7556864,7556857,'ath',50,1),(986,7556865,7556863,'fre',14.286,1),(986,7556866,7556863,'ree',14.286,1),(986,7556867,7556863,'ees',14.286,1),(986,7556868,7556863,'esp',14.286,1),(986,7556869,7556863,'spa',14.286,1),(986,7556870,7556863,'pac',14.286,1),(986,7556871,7556863,'ace',14.286,1),(986,7556872,7556865,'dis',50,1),(986,7556873,7556865,'isk',50,1),(986,7556874,7556872,'ind',33.333,1),(986,7556875,7556872,'nde',33.333,1),(986,7556876,7556872,'dex',33.333,1),(986,7556877,7556874,'adm',8.333,1),(986,7556878,7556874,'dmi',8.333,1),(986,7556879,7556874,'min',8.333,1),(986,7556880,7556874,'ini',8.333,1),(986,7556881,7556874,'nis',8.333,1),(986,7556882,7556874,'ist',8.333,1),(986,7556883,7556874,'str',8.333,1),(986,7556884,7556874,'tra',8.333,1),(986,7556885,7556874,'rat',8.333,1),(986,7556886,7556874,'ati',8.333,1),(986,7556887,7556874,'tio',8.333,1),(986,7556888,7556874,'ion',8.333,1),(986,7556889,7556877,'sta',33.333,3),(986,7556890,7556877,'tat',33.333,3),(986,7556891,7556877,'ate',33.333,3),(986,7556892,7556889,'dis',16.667,4),(986,7556893,7556889,'isa',16.667,4),(986,7556894,7556889,'sab',16.667,4),(986,7556895,7556889,'abl',16.667,4),(986,7556896,7556889,'ble',16.667,4),(986,7556897,7556889,'led',16.667,4),(986,7556898,7556892,'cac',33.333,1),(986,7556899,7556892,'ach',33.333,1),(986,7556900,7556892,'che',33.333,1),(986,7556901,7556898,'mod',50,1),(986,7556902,7556898,'ode',50,1),(986,7556903,7556901,'wri',14.286,1),(986,7556904,7556901,'rit',14.286,1),(986,7556905,7556901,'ite',14.286,1),(986,7556906,7556901,'tet',14.286,1),(986,7556907,7556901,'eth',14.286,1),(986,7556908,7556901,'thr',14.286,1),(986,7556909,7556901,'hru',14.286,1),(986,7556910,7556903,'ope',11.111,2),(986,7556911,7556903,'per',11.111,2),(986,7556912,7556903,'era',11.111,2),(986,7556913,7556903,'rat',11.111,2),(986,7556914,7556903,'ati',11.111,2),(986,7556915,7556903,'tio',11.111,2),(986,7556916,7556903,'ion',11.111,2),(986,7556917,7556903,'ona',11.111,2),(986,7556918,7556903,'nal',11.111,2),(986,7556919,7556910,'mes',20,1),(986,7556920,7556910,'ess',20,1),(986,7556921,7556910,'ssa',20,1),(986,7556922,7556910,'sag',20,1),(986,7556923,7556910,'age',20,1),(986,7556924,7556919,'per',11.111,1),(986,7556925,7556919,'erf',11.111,1),(986,7556926,7556919,'rfo',11.111,1),(986,7556927,7556919,'for',11.111,1),(986,7556928,7556919,'orm',11.111,1),(986,7556929,7556919,'rma',11.111,1),(986,7556930,7556919,'man',11.111,1),(986,7556931,7556919,'anc',11.111,1),(986,7556932,7556919,'nce',11.111,1),(986,7556933,7556924,'ide',12.5,1),(986,7556934,7556924,'den',12.5,1),(986,7556935,7556924,'ent',12.5,1),(986,7556936,7556924,'nti',12.5,1),(986,7556937,7556924,'tif',12.5,1),(986,7556938,7556924,'ifi',12.5,1),(986,7556939,7556924,'fie',12.5,1),(986,7556940,7556924,'ier',12.5,1),(986,7556941,7556933,'vdi',33.333,3),(986,7556942,7556933,'dis',33.333,3),(986,7556943,7556933,'isk',33.333,3),(986,7556944,7556941,'nam',50,1),(986,7556945,7556941,'ame',50,1),(986,7556946,7556944,'typ',50,1),(986,7556947,7556944,'ype',50,1),(986,7556948,7556946,'dir',25,1),(986,7556949,7556946,'ire',25,1),(986,7556950,7556946,'rec',25,1),(986,7556951,7556946,'ect',25,1),(987,7556953,7556952,'naa',100,2),(987,7556954,7556953,'600',3.333,3),(987,7556955,7556953,'000',3.333,3),(987,7556956,7556953,'00c',3.333,3),(987,7556957,7556953,'0c2',3.333,3),(987,7556958,7556953,'c29',3.333,3),(987,7556959,7556953,'295',3.333,3),(987,7556960,7556953,'950',3.333,3),(987,7556961,7556953,'50b',3.333,3),(987,7556962,7556953,'0b2',3.333,3),(987,7556963,7556953,'b2c',3.333,3),(987,7556964,7556953,'2ca',3.333,3),(987,7556965,7556953,'ca4',3.333,3),(987,7556966,7556953,'a4d',3.333,3),(987,7556967,7556953,'4d0',3.333,3),(987,7556968,7556953,'d06',3.333,3),(987,7556969,7556953,'06e',3.333,3),(987,7556970,7556953,'6e6',3.333,3),(987,7556971,7556953,'e64',3.333,3),(987,7556972,7556953,'64c',3.333,3),(987,7556973,7556953,'4c3',3.333,3),(987,7556974,7556953,'c30',3.333,3),(987,7556975,7556953,'304',3.333,3),(987,7556976,7556953,'041',3.333,3),(987,7556977,7556953,'41a',3.333,3),(987,7556978,7556953,'1a2',3.333,3),(987,7556979,7556953,'a23',3.333,3),(987,7556980,7556953,'235',3.333,3),(987,7556981,7556953,'35f',3.333,3),(987,7556982,7556953,'5fd',3.333,3),(987,7556983,7556953,'fd2',3.333,3),(987,7556984,7556954,'mon',100,1),(987,7556985,7556984,'201',50,1),(987,7556986,7556984,'013',50,1),(987,7556987,7556985,'adm',33.333,4),(987,7556988,7556985,'dmi',33.333,4),(987,7556989,7556985,'min',33.333,4),(987,7556990,7556987,'cap',16.667,1),(987,7556991,7556987,'apa',16.667,1),(987,7556992,7556987,'pac',16.667,1),(987,7556993,7556987,'aci',16.667,1),(987,7556994,7556987,'cit',16.667,1),(987,7556995,7556987,'ity',16.667,1),(987,7556996,7556990,'pat',50,1),(987,7556997,7556990,'ath',50,1),(987,7556998,7556996,'fre',14.286,1),(987,7556999,7556996,'ree',14.286,1),(987,7557000,7556996,'ees',14.286,1),(987,7557001,7556996,'esp',14.286,1),(987,7557002,7556996,'spa',14.286,1),(987,7557003,7556996,'pac',14.286,1),(987,7557004,7556996,'ace',14.286,1),(987,7557005,7556998,'dis',50,1),(987,7557006,7556998,'isk',50,1),(987,7557007,7557005,'ind',33.333,1),(987,7557008,7557005,'nde',33.333,1),(987,7557009,7557005,'dex',33.333,1),(987,7557010,7557007,'adm',8.333,1),(987,7557011,7557007,'dmi',8.333,1),(987,7557012,7557007,'min',8.333,1),(987,7557013,7557007,'ini',8.333,1),(987,7557014,7557007,'nis',8.333,1),(987,7557015,7557007,'ist',8.333,1),(987,7557016,7557007,'str',8.333,1),(987,7557017,7557007,'tra',8.333,1),(987,7557018,7557007,'rat',8.333,1),(987,7557019,7557007,'ati',8.333,1),(987,7557020,7557007,'tio',8.333,1),(987,7557021,7557007,'ion',8.333,1),(987,7557022,7557010,'sta',33.333,3),(987,7557023,7557010,'tat',33.333,3),(987,7557024,7557010,'ate',33.333,3),(987,7557025,7557022,'dis',16.667,4),(987,7557026,7557022,'isa',16.667,4),(987,7557027,7557022,'sab',16.667,4),(987,7557028,7557022,'abl',16.667,4),(987,7557029,7557022,'ble',16.667,4),(987,7557030,7557022,'led',16.667,4),(987,7557031,7557025,'cac',33.333,1),(987,7557032,7557025,'ach',33.333,1),(987,7557033,7557025,'che',33.333,1),(987,7557034,7557031,'mod',50,1),(987,7557035,7557031,'ode',50,1),(987,7557036,7557034,'wri',14.286,1),(987,7557037,7557034,'rit',14.286,1),(987,7557038,7557034,'ite',14.286,1),(987,7557039,7557034,'tet',14.286,1),(987,7557040,7557034,'eth',14.286,1),(987,7557041,7557034,'thr',14.286,1),(987,7557042,7557034,'hru',14.286,1),(987,7557043,7557036,'ope',11.111,2),(987,7557044,7557036,'per',11.111,2),(987,7557045,7557036,'era',11.111,2),(987,7557046,7557036,'rat',11.111,2),(987,7557047,7557036,'ati',11.111,2),(987,7557048,7557036,'tio',11.111,2),(987,7557049,7557036,'ion',11.111,2),(987,7557050,7557036,'ona',11.111,2),(987,7557051,7557036,'nal',11.111,2),(987,7557052,7557043,'mes',20,1),(987,7557053,7557043,'ess',20,1),(987,7557054,7557043,'ssa',20,1),(987,7557055,7557043,'sag',20,1),(987,7557056,7557043,'age',20,1),(987,7557057,7557052,'per',11.111,1),(987,7557058,7557052,'erf',11.111,1),(987,7557059,7557052,'rfo',11.111,1),(987,7557060,7557052,'for',11.111,1),(987,7557061,7557052,'orm',11.111,1),(987,7557062,7557052,'rma',11.111,1),(987,7557063,7557052,'man',11.111,1),(987,7557064,7557052,'anc',11.111,1),(987,7557065,7557052,'nce',11.111,1),(987,7557066,7557057,'ide',12.5,1),(987,7557067,7557057,'den',12.5,1),(987,7557068,7557057,'ent',12.5,1),(987,7557069,7557057,'nti',12.5,1),(987,7557070,7557057,'tif',12.5,1),(987,7557071,7557057,'ifi',12.5,1),(987,7557072,7557057,'fie',12.5,1),(987,7557073,7557057,'ier',12.5,1),(987,7557074,7557066,'vdi',33.333,3),(987,7557075,7557066,'dis',33.333,3),(987,7557076,7557066,'isk',33.333,3),(987,7557077,7557074,'nam',50,1),(987,7557078,7557074,'ame',50,1),(987,7557079,7557077,'typ',50,1),(987,7557080,7557077,'ype',50,1),(987,7557081,7557079,'dir',25,1),(987,7557082,7557079,'ire',25,1),(987,7557083,7557079,'rec',25,1),(987,7557084,7557079,'ect',25,1),(988,7557086,7557085,'naa',100,2),(988,7557087,7557086,'600',3.333,3),(988,7557088,7557086,'000',3.333,3),(988,7557089,7557086,'00c',3.333,3),(988,7557090,7557086,'0c2',3.333,3),(988,7557091,7557086,'c29',3.333,3),(988,7557092,7557086,'293',3.333,3),(988,7557093,7557086,'931',3.333,3),(988,7557094,7557086,'316',3.333,3),(988,7557095,7557086,'163',3.333,3),(988,7557096,7557086,'630',3.333,3),(988,7557097,7557086,'30a',3.333,3),(988,7557098,7557086,'0a5',3.333,3),(988,7557099,7557086,'a5e',3.333,3),(988,7557100,7557086,'5eb',3.333,3),(988,7557101,7557086,'ebc',3.333,3),(988,7557102,7557086,'bcc',3.333,3),(988,7557103,7557086,'cc7',3.333,3),(988,7557104,7557086,'c75',3.333,3),(988,7557105,7557086,'751',3.333,3),(988,7557106,7557086,'512',3.333,3),(988,7557107,7557086,'127',3.333,3),(988,7557108,7557086,'279',3.333,3),(988,7557109,7557086,'796',3.333,3),(988,7557110,7557086,'96d',3.333,3),(988,7557111,7557086,'6d7',3.333,3),(988,7557112,7557086,'d77',3.333,3),(988,7557113,7557086,'77d',3.333,3),(988,7557114,7557086,'7dc',3.333,3),(988,7557115,7557086,'dcf',3.333,3),(988,7557116,7557086,'cf1',3.333,3),(988,7557117,7557087,'mon',100,1),(988,7557118,7557117,'201',50,1),(988,7557119,7557117,'013',50,1),(988,7557120,7557118,'adm',33.333,4),(988,7557121,7557118,'dmi',33.333,4),(988,7557122,7557118,'min',33.333,4),(988,7557123,7557120,'cap',16.667,1),(988,7557124,7557120,'apa',16.667,1),(988,7557125,7557120,'pac',16.667,1),(988,7557126,7557120,'aci',16.667,1),(988,7557127,7557120,'cit',16.667,1),(988,7557128,7557120,'ity',16.667,1),(988,7557129,7557123,'pat',50,1),(988,7557130,7557123,'ath',50,1),(988,7557131,7557129,'fre',14.286,1),(988,7557132,7557129,'ree',14.286,1),(988,7557133,7557129,'ees',14.286,1),(988,7557134,7557129,'esp',14.286,1),(988,7557135,7557129,'spa',14.286,1),(988,7557136,7557129,'pac',14.286,1),(988,7557137,7557129,'ace',14.286,1),(988,7557138,7557131,'dis',50,1),(988,7557139,7557131,'isk',50,1),(988,7557140,7557138,'ind',33.333,1),(988,7557141,7557138,'nde',33.333,1),(988,7557142,7557138,'dex',33.333,1),(988,7557143,7557140,'adm',8.333,1),(988,7557144,7557140,'dmi',8.333,1),(988,7557145,7557140,'min',8.333,1),(988,7557146,7557140,'ini',8.333,1),(988,7557147,7557140,'nis',8.333,1),(988,7557148,7557140,'ist',8.333,1),(988,7557149,7557140,'str',8.333,1),(988,7557150,7557140,'tra',8.333,1),(988,7557151,7557140,'rat',8.333,1),(988,7557152,7557140,'ati',8.333,1),(988,7557153,7557140,'tio',8.333,1),(988,7557154,7557140,'ion',8.333,1),(988,7557155,7557143,'sta',33.333,3),(988,7557156,7557143,'tat',33.333,3),(988,7557157,7557143,'ate',33.333,3),(988,7557158,7557155,'dis',16.667,4),(988,7557159,7557155,'isa',16.667,4),(988,7557160,7557155,'sab',16.667,4),(988,7557161,7557155,'abl',16.667,4),(988,7557162,7557155,'ble',16.667,4),(988,7557163,7557155,'led',16.667,4),(988,7557164,7557158,'cac',33.333,1),(988,7557165,7557158,'ach',33.333,1),(988,7557166,7557158,'che',33.333,1),(988,7557167,7557164,'mod',50,1),(988,7557168,7557164,'ode',50,1),(988,7557169,7557167,'wri',14.286,1),(988,7557170,7557167,'rit',14.286,1),(988,7557171,7557167,'ite',14.286,1),(988,7557172,7557167,'tet',14.286,1),(988,7557173,7557167,'eth',14.286,1),(988,7557174,7557167,'thr',14.286,1),(988,7557175,7557167,'hru',14.286,1),(988,7557176,7557169,'ope',11.111,2),(988,7557177,7557169,'per',11.111,2),(988,7557178,7557169,'era',11.111,2),(988,7557179,7557169,'rat',11.111,2),(988,7557180,7557169,'ati',11.111,2),(988,7557181,7557169,'tio',11.111,2),(988,7557182,7557169,'ion',11.111,2),(988,7557183,7557169,'ona',11.111,2),(988,7557184,7557169,'nal',11.111,2),(988,7557185,7557176,'mes',20,1),(988,7557186,7557176,'ess',20,1),(988,7557187,7557176,'ssa',20,1),(988,7557188,7557176,'sag',20,1),(988,7557189,7557176,'age',20,1),(988,7557190,7557185,'per',11.111,1),(988,7557191,7557185,'erf',11.111,1),(988,7557192,7557185,'rfo',11.111,1),(988,7557193,7557185,'for',11.111,1),(988,7557194,7557185,'orm',11.111,1),(988,7557195,7557185,'rma',11.111,1),(988,7557196,7557185,'man',11.111,1),(988,7557197,7557185,'anc',11.111,1),(988,7557198,7557185,'nce',11.111,1),(988,7557199,7557190,'ide',12.5,1),(988,7557200,7557190,'den',12.5,1),(988,7557201,7557190,'ent',12.5,1),(988,7557202,7557190,'nti',12.5,1),(988,7557203,7557190,'tif',12.5,1),(988,7557204,7557190,'ifi',12.5,1),(988,7557205,7557190,'fie',12.5,1),(988,7557206,7557190,'ier',12.5,1),(988,7557207,7557199,'vdi',33.333,3),(988,7557208,7557199,'dis',33.333,3),(988,7557209,7557199,'isk',33.333,3),(988,7557210,7557207,'nam',50,1),(988,7557211,7557207,'ame',50,1),(988,7557212,7557210,'typ',50,1),(988,7557213,7557210,'ype',50,1),(988,7557214,7557212,'dir',25,1),(988,7557215,7557212,'ire',25,1),(988,7557216,7557212,'rec',25,1),(988,7557217,7557212,'ect',25,1),(989,7557219,7557218,'naa',100,2),(989,7557220,7557219,'600',3.333,3),(989,7557221,7557219,'000',3.333,3),(989,7557222,7557219,'00c',3.333,3),(989,7557223,7557219,'0c2',3.333,3),(989,7557224,7557219,'c29',3.333,3),(989,7557225,7557219,'29d',3.333,3),(989,7557226,7557219,'9d8',3.333,3),(989,7557227,7557219,'d89',3.333,3),(989,7557228,7557219,'891',3.333,3),(989,7557229,7557219,'91e',3.333,3),(989,7557230,7557219,'1e6',3.333,3),(989,7557231,7557219,'e6b',3.333,3),(989,7557232,7557219,'6b3',3.333,3),(989,7557233,7557219,'b3d',3.333,3),(989,7557234,7557219,'3dd',3.333,3),(989,7557235,7557219,'dd2',3.333,3),(989,7557236,7557219,'d21',3.333,3),(989,7557237,7557219,'217',3.333,3),(989,7557238,7557219,'175',3.333,3),(989,7557239,7557219,'758',3.333,3),(989,7557240,7557219,'582',3.333,3),(989,7557241,7557219,'825',3.333,3),(989,7557242,7557219,'253',3.333,3),(989,7557243,7557219,'536',3.333,3),(989,7557244,7557219,'360',3.333,3),(989,7557245,7557219,'605',3.333,3),(989,7557246,7557219,'05b',3.333,3),(989,7557247,7557219,'5bd',3.333,3),(989,7557248,7557219,'bdd',3.333,3),(989,7557249,7557219,'dd3',3.333,3),(989,7557250,7557220,'mon',100,1),(989,7557251,7557250,'201',50,1),(989,7557252,7557250,'013',50,1),(989,7557253,7557251,'adm',33.333,4),(989,7557254,7557251,'dmi',33.333,4),(989,7557255,7557251,'min',33.333,4),(989,7557256,7557253,'cap',16.667,1),(989,7557257,7557253,'apa',16.667,1),(989,7557258,7557253,'pac',16.667,1),(989,7557259,7557253,'aci',16.667,1),(989,7557260,7557253,'cit',16.667,1),(989,7557261,7557253,'ity',16.667,1),(989,7557262,7557256,'pat',50,1),(989,7557263,7557256,'ath',50,1),(989,7557264,7557262,'fre',14.286,1),(989,7557265,7557262,'ree',14.286,1),(989,7557266,7557262,'ees',14.286,1),(989,7557267,7557262,'esp',14.286,1),(989,7557268,7557262,'spa',14.286,1),(989,7557269,7557262,'pac',14.286,1),(989,7557270,7557262,'ace',14.286,1),(989,7557271,7557264,'dis',50,1),(989,7557272,7557264,'isk',50,1),(989,7557273,7557271,'ind',33.333,1),(989,7557274,7557271,'nde',33.333,1),(989,7557275,7557271,'dex',33.333,1),(989,7557276,7557273,'adm',8.333,1),(989,7557277,7557273,'dmi',8.333,1),(989,7557278,7557273,'min',8.333,1),(989,7557279,7557273,'ini',8.333,1),(989,7557280,7557273,'nis',8.333,1),(989,7557281,7557273,'ist',8.333,1),(989,7557282,7557273,'str',8.333,1),(989,7557283,7557273,'tra',8.333,1),(989,7557284,7557273,'rat',8.333,1),(989,7557285,7557273,'ati',8.333,1),(989,7557286,7557273,'tio',8.333,1),(989,7557287,7557273,'ion',8.333,1),(989,7557288,7557276,'sta',33.333,3),(989,7557289,7557276,'tat',33.333,3),(989,7557290,7557276,'ate',33.333,3),(989,7557291,7557288,'dis',16.667,4),(989,7557292,7557288,'isa',16.667,4),(989,7557293,7557288,'sab',16.667,4),(989,7557294,7557288,'abl',16.667,4),(989,7557295,7557288,'ble',16.667,4),(989,7557296,7557288,'led',16.667,4),(989,7557297,7557291,'cac',33.333,1),(989,7557298,7557291,'ach',33.333,1),(989,7557299,7557291,'che',33.333,1),(989,7557300,7557297,'mod',50,1),(989,7557301,7557297,'ode',50,1),(989,7557302,7557300,'wri',14.286,1),(989,7557303,7557300,'rit',14.286,1),(989,7557304,7557300,'ite',14.286,1),(989,7557305,7557300,'tet',14.286,1),(989,7557306,7557300,'eth',14.286,1),(989,7557307,7557300,'thr',14.286,1),(989,7557308,7557300,'hru',14.286,1),(989,7557309,7557302,'ope',11.111,2),(989,7557310,7557302,'per',11.111,2),(989,7557311,7557302,'era',11.111,2),(989,7557312,7557302,'rat',11.111,2),(989,7557313,7557302,'ati',11.111,2),(989,7557314,7557302,'tio',11.111,2),(989,7557315,7557302,'ion',11.111,2),(989,7557316,7557302,'ona',11.111,2),(989,7557317,7557302,'nal',11.111,2),(989,7557318,7557309,'mes',20,1),(989,7557319,7557309,'ess',20,1),(989,7557320,7557309,'ssa',20,1),(989,7557321,7557309,'sag',20,1),(989,7557322,7557309,'age',20,1),(989,7557323,7557318,'per',11.111,1),(989,7557324,7557318,'erf',11.111,1),(989,7557325,7557318,'rfo',11.111,1),(989,7557326,7557318,'for',11.111,1),(989,7557327,7557318,'orm',11.111,1),(989,7557328,7557318,'rma',11.111,1),(989,7557329,7557318,'man',11.111,1),(989,7557330,7557318,'anc',11.111,1),(989,7557331,7557318,'nce',11.111,1),(989,7557332,7557323,'ide',12.5,1),(989,7557333,7557323,'den',12.5,1),(989,7557334,7557323,'ent',12.5,1),(989,7557335,7557323,'nti',12.5,1),(989,7557336,7557323,'tif',12.5,1),(989,7557337,7557323,'ifi',12.5,1),(989,7557338,7557323,'fie',12.5,1),(989,7557339,7557323,'ier',12.5,1),(989,7557340,7557332,'vdi',33.333,3),(989,7557341,7557332,'dis',33.333,3),(989,7557342,7557332,'isk',33.333,3),(989,7557343,7557340,'nam',50,1),(989,7557344,7557340,'ame',50,1),(989,7557345,7557343,'typ',50,1),(989,7557346,7557343,'ype',50,1),(989,7557347,7557345,'dir',25,1),(989,7557348,7557345,'ire',25,1),(989,7557349,7557345,'rec',25,1),(989,7557350,7557345,'ect',25,1),(990,7557352,7557351,'naa',100,2),(990,7557353,7557352,'600',3.333,3),(990,7557354,7557352,'000',3.333,3),(990,7557355,7557352,'00c',3.333,3),(990,7557356,7557352,'0c2',3.333,3),(990,7557357,7557352,'c29',3.333,3),(990,7557358,7557352,'29b',3.333,3),(990,7557359,7557352,'9b4',3.333,3),(990,7557360,7557352,'b43',3.333,3),(990,7557361,7557352,'43b',3.333,3),(990,7557362,7557352,'3b4',3.333,3),(990,7557363,7557352,'b41',3.333,3),(990,7557364,7557352,'41c',3.333,3),(990,7557365,7557352,'1c5',3.333,3),(990,7557366,7557352,'c53',3.333,3),(990,7557367,7557352,'539',3.333,3),(990,7557368,7557352,'392',3.333,3),(990,7557369,7557352,'929',3.333,3),(990,7557370,7557352,'294',3.333,3),(990,7557371,7557352,'948',3.333,3),(990,7557372,7557352,'489',3.333,3),(990,7557373,7557352,'891',3.333,3),(990,7557374,7557352,'91c',3.333,3),(990,7557375,7557352,'1cd',3.333,3),(990,7557376,7557352,'cdc',3.333,3),(990,7557377,7557352,'dca',3.333,3),(990,7557378,7557352,'ca3',3.333,3),(990,7557379,7557352,'a3b',3.333,3),(990,7557380,7557352,'3b8',3.333,3),(990,7557381,7557352,'b86',3.333,3),(990,7557382,7557352,'86e',3.333,3),(990,7557383,7557353,'mon',100,1),(990,7557384,7557383,'201',50,1),(990,7557385,7557383,'013',50,1),(990,7557386,7557384,'adm',33.333,4),(990,7557387,7557384,'dmi',33.333,4),(990,7557388,7557384,'min',33.333,4),(990,7557389,7557386,'cap',16.667,1),(990,7557390,7557386,'apa',16.667,1),(990,7557391,7557386,'pac',16.667,1),(990,7557392,7557386,'aci',16.667,1),(990,7557393,7557386,'cit',16.667,1),(990,7557394,7557386,'ity',16.667,1),(990,7557395,7557389,'pat',50,1),(990,7557396,7557389,'ath',50,1),(990,7557397,7557395,'fre',14.286,1),(990,7557398,7557395,'ree',14.286,1),(990,7557399,7557395,'ees',14.286,1),(990,7557400,7557395,'esp',14.286,1),(990,7557401,7557395,'spa',14.286,1),(990,7557402,7557395,'pac',14.286,1),(990,7557403,7557395,'ace',14.286,1),(990,7557404,7557397,'dis',50,1),(990,7557405,7557397,'isk',50,1),(990,7557406,7557404,'ind',33.333,1),(990,7557407,7557404,'nde',33.333,1),(990,7557408,7557404,'dex',33.333,1),(990,7557409,7557406,'adm',8.333,1),(990,7557410,7557406,'dmi',8.333,1),(990,7557411,7557406,'min',8.333,1),(990,7557412,7557406,'ini',8.333,1),(990,7557413,7557406,'nis',8.333,1),(990,7557414,7557406,'ist',8.333,1),(990,7557415,7557406,'str',8.333,1),(990,7557416,7557406,'tra',8.333,1),(990,7557417,7557406,'rat',8.333,1),(990,7557418,7557406,'ati',8.333,1),(990,7557419,7557406,'tio',8.333,1),(990,7557420,7557406,'ion',8.333,1),(990,7557421,7557409,'sta',33.333,3),(990,7557422,7557409,'tat',33.333,3),(990,7557423,7557409,'ate',33.333,3),(990,7557424,7557421,'dis',16.667,4),(990,7557425,7557421,'isa',16.667,4),(990,7557426,7557421,'sab',16.667,4),(990,7557427,7557421,'abl',16.667,4),(990,7557428,7557421,'ble',16.667,4),(990,7557429,7557421,'led',16.667,4),(990,7557430,7557424,'cac',33.333,1),(990,7557431,7557424,'ach',33.333,1),(990,7557432,7557424,'che',33.333,1),(990,7557433,7557430,'mod',50,1),(990,7557434,7557430,'ode',50,1),(990,7557435,7557433,'wri',14.286,1),(990,7557436,7557433,'rit',14.286,1),(990,7557437,7557433,'ite',14.286,1),(990,7557438,7557433,'tet',14.286,1),(990,7557439,7557433,'eth',14.286,1),(990,7557440,7557433,'thr',14.286,1),(990,7557441,7557433,'hru',14.286,1),(990,7557442,7557435,'ope',11.111,2),(990,7557443,7557435,'per',11.111,2),(990,7557444,7557435,'era',11.111,2),(990,7557445,7557435,'rat',11.111,2),(990,7557446,7557435,'ati',11.111,2),(990,7557447,7557435,'tio',11.111,2),(990,7557448,7557435,'ion',11.111,2),(990,7557449,7557435,'ona',11.111,2),(990,7557450,7557435,'nal',11.111,2),(990,7557451,7557442,'mes',20,1),(990,7557452,7557442,'ess',20,1),(990,7557453,7557442,'ssa',20,1),(990,7557454,7557442,'sag',20,1),(990,7557455,7557442,'age',20,1),(990,7557456,7557451,'per',11.111,1),(990,7557457,7557451,'erf',11.111,1),(990,7557458,7557451,'rfo',11.111,1),(990,7557459,7557451,'for',11.111,1),(990,7557460,7557451,'orm',11.111,1),(990,7557461,7557451,'rma',11.111,1),(990,7557462,7557451,'man',11.111,1),(990,7557463,7557451,'anc',11.111,1),(990,7557464,7557451,'nce',11.111,1),(990,7557465,7557456,'ide',12.5,1),(990,7557466,7557456,'den',12.5,1),(990,7557467,7557456,'ent',12.5,1),(990,7557468,7557456,'nti',12.5,1),(990,7557469,7557456,'tif',12.5,1),(990,7557470,7557456,'ifi',12.5,1),(990,7557471,7557456,'fie',12.5,1),(990,7557472,7557456,'ier',12.5,1),(990,7557473,7557465,'vdi',33.333,3),(990,7557474,7557465,'dis',33.333,3),(990,7557475,7557465,'isk',33.333,3),(990,7557476,7557473,'nam',50,1),(990,7557477,7557473,'ame',50,1),(990,7557478,7557476,'typ',50,1),(990,7557479,7557476,'ype',50,1),(990,7557480,7557478,'dir',25,1),(990,7557481,7557478,'ire',25,1),(990,7557482,7557478,'rec',25,1),(990,7557483,7557478,'ect',25,1),(991,7557485,7557484,'naa',100,2),(991,7557486,7557485,'600',3.333,3),(991,7557487,7557485,'000',3.333,3),(991,7557488,7557485,'00c',3.333,3),(991,7557489,7557485,'0c2',3.333,3),(991,7557490,7557485,'c29',3.333,3),(991,7557491,7557485,'292',3.333,3),(991,7557492,7557485,'92d',3.333,3),(991,7557493,7557485,'2dd',3.333,3),(991,7557494,7557485,'dd9',3.333,3),(991,7557495,7557485,'d95',3.333,3),(991,7557496,7557485,'95e',3.333,3),(991,7557497,7557485,'5e0',3.333,3),(991,7557498,7557485,'e04',3.333,3),(991,7557499,7557485,'048',3.333,3),(991,7557500,7557485,'48f',3.333,3),(991,7557501,7557485,'8f3',3.333,3),(991,7557502,7557485,'f36',3.333,3),(991,7557503,7557485,'367',3.333,3),(991,7557504,7557485,'67e',3.333,3),(991,7557505,7557485,'7e5',3.333,3),(991,7557506,7557485,'e5c',3.333,3),(991,7557507,7557485,'5c7',3.333,3),(991,7557508,7557485,'c78',3.333,3),(991,7557509,7557485,'78b',3.333,3),(991,7557510,7557485,'8b1',3.333,3),(991,7557511,7557485,'b13',3.333,3),(991,7557512,7557485,'13d',3.333,3),(991,7557513,7557485,'3d0',3.333,3),(991,7557514,7557485,'d0a',3.333,3),(991,7557515,7557485,'0a1',3.333,3),(991,7557516,7557486,'mon',100,1),(991,7557517,7557516,'201',50,1),(991,7557518,7557516,'013',50,1),(991,7557519,7557517,'adm',33.333,4),(991,7557520,7557517,'dmi',33.333,4),(991,7557521,7557517,'min',33.333,4),(991,7557522,7557519,'cap',16.667,1),(991,7557523,7557519,'apa',16.667,1),(991,7557524,7557519,'pac',16.667,1),(991,7557525,7557519,'aci',16.667,1),(991,7557526,7557519,'cit',16.667,1),(991,7557527,7557519,'ity',16.667,1),(991,7557528,7557522,'pat',50,1),(991,7557529,7557522,'ath',50,1),(991,7557530,7557528,'fre',14.286,1),(991,7557531,7557528,'ree',14.286,1),(991,7557532,7557528,'ees',14.286,1),(991,7557533,7557528,'esp',14.286,1),(991,7557534,7557528,'spa',14.286,1),(991,7557535,7557528,'pac',14.286,1),(991,7557536,7557528,'ace',14.286,1),(991,7557537,7557530,'dis',50,1),(991,7557538,7557530,'isk',50,1),(991,7557539,7557537,'ind',33.333,1),(991,7557540,7557537,'nde',33.333,1),(991,7557541,7557537,'dex',33.333,1),(991,7557542,7557539,'adm',8.333,1),(991,7557543,7557539,'dmi',8.333,1),(991,7557544,7557539,'min',8.333,1),(991,7557545,7557539,'ini',8.333,1),(991,7557546,7557539,'nis',8.333,1),(991,7557547,7557539,'ist',8.333,1),(991,7557548,7557539,'str',8.333,1),(991,7557549,7557539,'tra',8.333,1),(991,7557550,7557539,'rat',8.333,1),(991,7557551,7557539,'ati',8.333,1),(991,7557552,7557539,'tio',8.333,1),(991,7557553,7557539,'ion',8.333,1),(991,7557554,7557542,'sta',33.333,3),(991,7557555,7557542,'tat',33.333,3),(991,7557556,7557542,'ate',33.333,3),(991,7557557,7557554,'dis',16.667,4),(991,7557558,7557554,'isa',16.667,4),(991,7557559,7557554,'sab',16.667,4),(991,7557560,7557554,'abl',16.667,4),(991,7557561,7557554,'ble',16.667,4),(991,7557562,7557554,'led',16.667,4),(991,7557563,7557557,'cac',33.333,1),(991,7557564,7557557,'ach',33.333,1),(991,7557565,7557557,'che',33.333,1),(991,7557566,7557563,'mod',50,1),(991,7557567,7557563,'ode',50,1),(991,7557568,7557566,'wri',14.286,1),(991,7557569,7557566,'rit',14.286,1),(991,7557570,7557566,'ite',14.286,1),(991,7557571,7557566,'tet',14.286,1),(991,7557572,7557566,'eth',14.286,1),(991,7557573,7557566,'thr',14.286,1),(991,7557574,7557566,'hru',14.286,1),(991,7557575,7557568,'ope',11.111,2),(991,7557576,7557568,'per',11.111,2),(991,7557577,7557568,'era',11.111,2),(991,7557578,7557568,'rat',11.111,2),(991,7557579,7557568,'ati',11.111,2),(991,7557580,7557568,'tio',11.111,2),(991,7557581,7557568,'ion',11.111,2),(991,7557582,7557568,'ona',11.111,2),(991,7557583,7557568,'nal',11.111,2),(991,7557584,7557575,'mes',20,1),(991,7557585,7557575,'ess',20,1),(991,7557586,7557575,'ssa',20,1),(991,7557587,7557575,'sag',20,1),(991,7557588,7557575,'age',20,1),(991,7557589,7557584,'per',11.111,1),(991,7557590,7557584,'erf',11.111,1),(991,7557591,7557584,'rfo',11.111,1),(991,7557592,7557584,'for',11.111,1),(991,7557593,7557584,'orm',11.111,1),(991,7557594,7557584,'rma',11.111,1),(991,7557595,7557584,'man',11.111,1),(991,7557596,7557584,'anc',11.111,1),(991,7557597,7557584,'nce',11.111,1),(991,7557598,7557589,'ide',12.5,1),(991,7557599,7557589,'den',12.5,1),(991,7557600,7557589,'ent',12.5,1),(991,7557601,7557589,'nti',12.5,1),(991,7557602,7557589,'tif',12.5,1),(991,7557603,7557589,'ifi',12.5,1),(991,7557604,7557589,'fie',12.5,1),(991,7557605,7557589,'ier',12.5,1),(991,7557606,7557598,'vdi',33.333,3),(991,7557607,7557598,'dis',33.333,3),(991,7557608,7557598,'isk',33.333,3),(991,7557609,7557606,'nam',50,1),(991,7557610,7557606,'ame',50,1),(991,7557611,7557609,'typ',50,1),(991,7557612,7557609,'ype',50,1),(991,7557613,7557611,'dir',25,1),(991,7557614,7557611,'ire',25,1),(991,7557615,7557611,'rec',25,1),(991,7557616,7557611,'ect',25,1),(992,7557618,7557617,'naa',100,2),(992,7557619,7557618,'600',3.333,3),(992,7557620,7557618,'000',3.333,3),(992,7557621,7557618,'00c',3.333,3),(992,7557622,7557618,'0c2',3.333,3),(992,7557623,7557618,'c29',3.333,3),(992,7557624,7557618,'290',3.333,3),(992,7557625,7557618,'90f',3.333,3),(992,7557626,7557618,'0f0',3.333,3),(992,7557627,7557618,'f0e',3.333,3),(992,7557628,7557618,'0e6',3.333,3),(992,7557629,7557618,'e66',3.333,3),(992,7557630,7557618,'66c',3.333,3),(992,7557631,7557618,'6c0',3.333,3),(992,7557632,7557618,'c07',3.333,3),(992,7557633,7557618,'076',3.333,3),(992,7557634,7557618,'764',3.333,3),(992,7557635,7557618,'643',3.333,3),(992,7557636,7557618,'432',3.333,3),(992,7557637,7557618,'326',3.333,3),(992,7557638,7557618,'266',3.333,3),(992,7557639,7557618,'66c',3.333,3),(992,7557640,7557618,'6ca',3.333,3),(992,7557641,7557618,'ca9',3.333,3),(992,7557642,7557618,'a98',3.333,3),(992,7557643,7557618,'983',3.333,3),(992,7557644,7557618,'83f',3.333,3),(992,7557645,7557618,'3fb',3.333,3),(992,7557646,7557618,'fb4',3.333,3),(992,7557647,7557618,'b48',3.333,3),(992,7557648,7557618,'486',3.333,3),(992,7557649,7557619,'mon',100,1),(992,7557650,7557649,'201',50,1),(992,7557651,7557649,'013',50,1),(992,7557652,7557650,'adm',33.333,4),(992,7557653,7557650,'dmi',33.333,4),(992,7557654,7557650,'min',33.333,4),(992,7557655,7557652,'cap',16.667,1),(992,7557656,7557652,'apa',16.667,1),(992,7557657,7557652,'pac',16.667,1),(992,7557658,7557652,'aci',16.667,1),(992,7557659,7557652,'cit',16.667,1),(992,7557660,7557652,'ity',16.667,1),(992,7557661,7557655,'pat',50,1),(992,7557662,7557655,'ath',50,1),(992,7557663,7557661,'fre',14.286,1),(992,7557664,7557661,'ree',14.286,1),(992,7557665,7557661,'ees',14.286,1),(992,7557666,7557661,'esp',14.286,1),(992,7557667,7557661,'spa',14.286,1),(992,7557668,7557661,'pac',14.286,1),(992,7557669,7557661,'ace',14.286,1),(992,7557670,7557663,'dis',50,1),(992,7557671,7557663,'isk',50,1),(992,7557672,7557670,'ind',33.333,1),(992,7557673,7557670,'nde',33.333,1),(992,7557674,7557670,'dex',33.333,1),(992,7557675,7557672,'adm',8.333,1),(992,7557676,7557672,'dmi',8.333,1),(992,7557677,7557672,'min',8.333,1),(992,7557678,7557672,'ini',8.333,1),(992,7557679,7557672,'nis',8.333,1),(992,7557680,7557672,'ist',8.333,1),(992,7557681,7557672,'str',8.333,1),(992,7557682,7557672,'tra',8.333,1),(992,7557683,7557672,'rat',8.333,1),(992,7557684,7557672,'ati',8.333,1),(992,7557685,7557672,'tio',8.333,1),(992,7557686,7557672,'ion',8.333,1),(992,7557687,7557675,'sta',33.333,3),(992,7557688,7557675,'tat',33.333,3),(992,7557689,7557675,'ate',33.333,3),(992,7557690,7557687,'dis',16.667,4),(992,7557691,7557687,'isa',16.667,4),(992,7557692,7557687,'sab',16.667,4),(992,7557693,7557687,'abl',16.667,4),(992,7557694,7557687,'ble',16.667,4),(992,7557695,7557687,'led',16.667,4),(992,7557696,7557690,'cac',33.333,1),(992,7557697,7557690,'ach',33.333,1),(992,7557698,7557690,'che',33.333,1),(992,7557699,7557696,'mod',50,1),(992,7557700,7557696,'ode',50,1),(992,7557701,7557699,'wri',14.286,1),(992,7557702,7557699,'rit',14.286,1),(992,7557703,7557699,'ite',14.286,1),(992,7557704,7557699,'tet',14.286,1),(992,7557705,7557699,'eth',14.286,1),(992,7557706,7557699,'thr',14.286,1),(992,7557707,7557699,'hru',14.286,1),(992,7557708,7557701,'ope',11.111,2),(992,7557709,7557701,'per',11.111,2),(992,7557710,7557701,'era',11.111,2),(992,7557711,7557701,'rat',11.111,2),(992,7557712,7557701,'ati',11.111,2),(992,7557713,7557701,'tio',11.111,2),(992,7557714,7557701,'ion',11.111,2),(992,7557715,7557701,'ona',11.111,2),(992,7557716,7557701,'nal',11.111,2),(992,7557717,7557708,'mes',20,1),(992,7557718,7557708,'ess',20,1),(992,7557719,7557708,'ssa',20,1),(992,7557720,7557708,'sag',20,1),(992,7557721,7557708,'age',20,1),(992,7557722,7557717,'per',11.111,1),(992,7557723,7557717,'erf',11.111,1),(992,7557724,7557717,'rfo',11.111,1),(992,7557725,7557717,'for',11.111,1),(992,7557726,7557717,'orm',11.111,1),(992,7557727,7557717,'rma',11.111,1),(992,7557728,7557717,'man',11.111,1),(992,7557729,7557717,'anc',11.111,1),(992,7557730,7557717,'nce',11.111,1),(992,7557731,7557722,'ide',12.5,1),(992,7557732,7557722,'den',12.5,1),(992,7557733,7557722,'ent',12.5,1),(992,7557734,7557722,'nti',12.5,1),(992,7557735,7557722,'tif',12.5,1),(992,7557736,7557722,'ifi',12.5,1),(992,7557737,7557722,'fie',12.5,1),(992,7557738,7557722,'ier',12.5,1),(992,7557739,7557731,'vdi',33.333,3),(992,7557740,7557731,'dis',33.333,3),(992,7557741,7557731,'isk',33.333,3),(992,7557742,7557739,'nam',50,1),(992,7557743,7557739,'ame',50,1),(992,7557744,7557742,'typ',50,1),(992,7557745,7557742,'ype',50,1),(992,7557746,7557744,'dir',25,1),(992,7557747,7557744,'ire',25,1),(992,7557748,7557744,'rec',25,1),(992,7557749,7557744,'ect',25,1),(993,7557751,7557750,'naa',100,2),(993,7557752,7557751,'600',3.333,3),(993,7557753,7557751,'000',3.333,3),(993,7557754,7557751,'00c',3.333,3),(993,7557755,7557751,'0c2',3.333,3),(993,7557756,7557751,'c29',3.333,3),(993,7557757,7557751,'29f',3.333,3),(993,7557758,7557751,'9ff',3.333,3),(993,7557759,7557751,'ff4',3.333,3),(993,7557760,7557751,'f48',3.333,3),(993,7557761,7557751,'48e',3.333,3),(993,7557762,7557751,'8e0',3.333,3),(993,7557763,7557751,'e06',3.333,3),(993,7557764,7557751,'067',3.333,3),(993,7557765,7557751,'67f',3.333,3),(993,7557766,7557751,'7f9',3.333,3),(993,7557767,7557751,'f9d',3.333,3),(993,7557768,7557751,'9d0',3.333,3),(993,7557769,7557751,'d0d',3.333,3),(993,7557770,7557751,'0d0',3.333,3),(993,7557771,7557751,'d0a',3.333,3),(993,7557772,7557751,'0a6',3.333,3),(993,7557773,7557751,'a61',3.333,3),(993,7557774,7557751,'616',3.333,3),(993,7557775,7557751,'16a',3.333,3),(993,7557776,7557751,'6a5',3.333,3),(993,7557777,7557751,'a54',3.333,3),(993,7557778,7557751,'54b',3.333,3),(993,7557779,7557751,'4b1',3.333,3),(993,7557780,7557751,'b15',3.333,3),(993,7557781,7557751,'157',3.333,3),(993,7557782,7557752,'mon',100,1),(993,7557783,7557782,'201',50,1),(993,7557784,7557782,'013',50,1),(993,7557785,7557783,'adm',33.333,4),(993,7557786,7557783,'dmi',33.333,4),(993,7557787,7557783,'min',33.333,4),(993,7557788,7557785,'cap',16.667,1),(993,7557789,7557785,'apa',16.667,1),(993,7557790,7557785,'pac',16.667,1),(993,7557791,7557785,'aci',16.667,1),(993,7557792,7557785,'cit',16.667,1),(993,7557793,7557785,'ity',16.667,1),(993,7557794,7557788,'pat',50,1),(993,7557795,7557788,'ath',50,1),(993,7557796,7557794,'fre',14.286,1),(993,7557797,7557794,'ree',14.286,1),(993,7557798,7557794,'ees',14.286,1),(993,7557799,7557794,'esp',14.286,1),(993,7557800,7557794,'spa',14.286,1),(993,7557801,7557794,'pac',14.286,1),(993,7557802,7557794,'ace',14.286,1),(993,7557803,7557796,'dis',50,1),(993,7557804,7557796,'isk',50,1),(993,7557805,7557803,'ind',33.333,1),(993,7557806,7557803,'nde',33.333,1),(993,7557807,7557803,'dex',33.333,1),(993,7557808,7557805,'adm',8.333,1),(993,7557809,7557805,'dmi',8.333,1),(993,7557810,7557805,'min',8.333,1),(993,7557811,7557805,'ini',8.333,1),(993,7557812,7557805,'nis',8.333,1),(993,7557813,7557805,'ist',8.333,1),(993,7557814,7557805,'str',8.333,1),(993,7557815,7557805,'tra',8.333,1),(993,7557816,7557805,'rat',8.333,1),(993,7557817,7557805,'ati',8.333,1),(993,7557818,7557805,'tio',8.333,1),(993,7557819,7557805,'ion',8.333,1),(993,7557820,7557808,'sta',33.333,3),(993,7557821,7557808,'tat',33.333,3),(993,7557822,7557808,'ate',33.333,3),(993,7557823,7557820,'dis',16.667,4),(993,7557824,7557820,'isa',16.667,4),(993,7557825,7557820,'sab',16.667,4),(993,7557826,7557820,'abl',16.667,4),(993,7557827,7557820,'ble',16.667,4),(993,7557828,7557820,'led',16.667,4),(993,7557829,7557823,'cac',33.333,1),(993,7557830,7557823,'ach',33.333,1),(993,7557831,7557823,'che',33.333,1),(993,7557832,7557829,'mod',50,1),(993,7557833,7557829,'ode',50,1),(993,7557834,7557832,'wri',14.286,1),(993,7557835,7557832,'rit',14.286,1),(993,7557836,7557832,'ite',14.286,1),(993,7557837,7557832,'tet',14.286,1),(993,7557838,7557832,'eth',14.286,1),(993,7557839,7557832,'thr',14.286,1),(993,7557840,7557832,'hru',14.286,1),(993,7557841,7557834,'ope',11.111,2),(993,7557842,7557834,'per',11.111,2),(993,7557843,7557834,'era',11.111,2),(993,7557844,7557834,'rat',11.111,2),(993,7557845,7557834,'ati',11.111,2),(993,7557846,7557834,'tio',11.111,2),(993,7557847,7557834,'ion',11.111,2),(993,7557848,7557834,'ona',11.111,2),(993,7557849,7557834,'nal',11.111,2),(993,7557850,7557841,'mes',20,1),(993,7557851,7557841,'ess',20,1),(993,7557852,7557841,'ssa',20,1),(993,7557853,7557841,'sag',20,1),(993,7557854,7557841,'age',20,1),(993,7557855,7557850,'per',11.111,1),(993,7557856,7557850,'erf',11.111,1),(993,7557857,7557850,'rfo',11.111,1),(993,7557858,7557850,'for',11.111,1),(993,7557859,7557850,'orm',11.111,1),(993,7557860,7557850,'rma',11.111,1),(993,7557861,7557850,'man',11.111,1),(993,7557862,7557850,'anc',11.111,1),(993,7557863,7557850,'nce',11.111,1),(993,7557864,7557855,'ide',12.5,1),(993,7557865,7557855,'den',12.5,1),(993,7557866,7557855,'ent',12.5,1),(993,7557867,7557855,'nti',12.5,1),(993,7557868,7557855,'tif',12.5,1),(993,7557869,7557855,'ifi',12.5,1),(993,7557870,7557855,'fie',12.5,1),(993,7557871,7557855,'ier',12.5,1),(993,7557872,7557864,'vdi',33.333,3),(993,7557873,7557864,'dis',33.333,3),(993,7557874,7557864,'isk',33.333,3),(993,7557875,7557872,'nam',50,1),(993,7557876,7557872,'ame',50,1),(993,7557877,7557875,'typ',50,1),(993,7557878,7557875,'ype',50,1),(993,7557879,7557877,'dir',25,1),(993,7557880,7557877,'ire',25,1),(993,7557881,7557877,'rec',25,1),(993,7557882,7557877,'ect',25,1),(994,7557884,7557883,'naa',100,2),(994,7557885,7557884,'600',3.333,3),(994,7557886,7557884,'000',3.333,3),(994,7557887,7557884,'00c',3.333,3),(994,7557888,7557884,'0c2',3.333,3),(994,7557889,7557884,'c29',3.333,3),(994,7557890,7557884,'29c',3.333,3),(994,7557891,7557884,'9c4',3.333,3),(994,7557892,7557884,'c4a',3.333,3),(994,7557893,7557884,'4a7',3.333,3),(994,7557894,7557884,'a74',3.333,3),(994,7557895,7557884,'74e',3.333,3),(994,7557896,7557884,'4e8',3.333,3),(994,7557897,7557884,'e8a',3.333,3),(994,7557898,7557884,'8ae',3.333,3),(994,7557899,7557884,'ae0',3.333,3),(994,7557900,7557884,'e03',3.333,3),(994,7557901,7557884,'037',3.333,3),(994,7557902,7557884,'379',3.333,3),(994,7557903,7557884,'797',3.333,3),(994,7557904,7557884,'97a',3.333,3),(994,7557905,7557884,'7a2',3.333,3),(994,7557906,7557884,'a27',3.333,3),(994,7557907,7557884,'270',3.333,3),(994,7557908,7557884,'706',3.333,3),(994,7557909,7557884,'06c',3.333,3),(994,7557910,7557884,'6ca',3.333,3),(994,7557911,7557884,'ca4',3.333,3),(994,7557912,7557884,'a4c',3.333,3),(994,7557913,7557884,'4ca',3.333,3),(994,7557914,7557884,'caa',3.333,3),(994,7557915,7557885,'mon',100,1),(994,7557916,7557915,'201',50,1),(994,7557917,7557915,'013',50,1),(994,7557918,7557916,'adm',33.333,4),(994,7557919,7557916,'dmi',33.333,4),(994,7557920,7557916,'min',33.333,4),(994,7557921,7557918,'cap',16.667,1),(994,7557922,7557918,'apa',16.667,1),(994,7557923,7557918,'pac',16.667,1),(994,7557924,7557918,'aci',16.667,1),(994,7557925,7557918,'cit',16.667,1),(994,7557926,7557918,'ity',16.667,1),(994,7557927,7557921,'pat',50,1),(994,7557928,7557921,'ath',50,1),(994,7557929,7557927,'fre',14.286,1),(994,7557930,7557927,'ree',14.286,1),(994,7557931,7557927,'ees',14.286,1),(994,7557932,7557927,'esp',14.286,1),(994,7557933,7557927,'spa',14.286,1),(994,7557934,7557927,'pac',14.286,1),(994,7557935,7557927,'ace',14.286,1),(994,7557936,7557929,'dis',50,1),(994,7557937,7557929,'isk',50,1),(994,7557938,7557936,'ind',33.333,1),(994,7557939,7557936,'nde',33.333,1),(994,7557940,7557936,'dex',33.333,1),(994,7557941,7557938,'adm',8.333,1),(994,7557942,7557938,'dmi',8.333,1),(994,7557943,7557938,'min',8.333,1),(994,7557944,7557938,'ini',8.333,1),(994,7557945,7557938,'nis',8.333,1),(994,7557946,7557938,'ist',8.333,1),(994,7557947,7557938,'str',8.333,1),(994,7557948,7557938,'tra',8.333,1),(994,7557949,7557938,'rat',8.333,1),(994,7557950,7557938,'ati',8.333,1),(994,7557951,7557938,'tio',8.333,1),(994,7557952,7557938,'ion',8.333,1),(994,7557953,7557941,'sta',33.333,3),(994,7557954,7557941,'tat',33.333,3),(994,7557955,7557941,'ate',33.333,3),(994,7557956,7557953,'dis',16.667,4),(994,7557957,7557953,'isa',16.667,4),(994,7557958,7557953,'sab',16.667,4),(994,7557959,7557953,'abl',16.667,4),(994,7557960,7557953,'ble',16.667,4),(994,7557961,7557953,'led',16.667,4),(994,7557962,7557956,'cac',33.333,1),(994,7557963,7557956,'ach',33.333,1),(994,7557964,7557956,'che',33.333,1),(994,7557965,7557962,'mod',50,1),(994,7557966,7557962,'ode',50,1),(994,7557967,7557965,'wri',14.286,1),(994,7557968,7557965,'rit',14.286,1),(994,7557969,7557965,'ite',14.286,1),(994,7557970,7557965,'tet',14.286,1),(994,7557971,7557965,'eth',14.286,1),(994,7557972,7557965,'thr',14.286,1),(994,7557973,7557965,'hru',14.286,1),(994,7557974,7557967,'ope',11.111,2),(994,7557975,7557967,'per',11.111,2),(994,7557976,7557967,'era',11.111,2),(994,7557977,7557967,'rat',11.111,2),(994,7557978,7557967,'ati',11.111,2),(994,7557979,7557967,'tio',11.111,2),(994,7557980,7557967,'ion',11.111,2),(994,7557981,7557967,'ona',11.111,2),(994,7557982,7557967,'nal',11.111,2),(994,7557983,7557974,'mes',20,1),(994,7557984,7557974,'ess',20,1),(994,7557985,7557974,'ssa',20,1),(994,7557986,7557974,'sag',20,1),(994,7557987,7557974,'age',20,1),(994,7557988,7557983,'per',11.111,1),(994,7557989,7557983,'erf',11.111,1),(994,7557990,7557983,'rfo',11.111,1),(994,7557991,7557983,'for',11.111,1),(994,7557992,7557983,'orm',11.111,1),(994,7557993,7557983,'rma',11.111,1),(994,7557994,7557983,'man',11.111,1),(994,7557995,7557983,'anc',11.111,1),(994,7557996,7557983,'nce',11.111,1),(994,7557997,7557988,'ide',12.5,1),(994,7557998,7557988,'den',12.5,1),(994,7557999,7557988,'ent',12.5,1),(994,7558000,7557988,'nti',12.5,1),(994,7558001,7557988,'tif',12.5,1),(994,7558002,7557988,'ifi',12.5,1),(994,7558003,7557988,'fie',12.5,1),(994,7558004,7557988,'ier',12.5,1),(994,7558005,7557997,'vdi',33.333,3),(994,7558006,7557997,'dis',33.333,3),(994,7558007,7557997,'isk',33.333,3),(994,7558008,7558005,'nam',50,1),(994,7558009,7558005,'ame',50,1),(994,7558010,7558008,'typ',50,1),(994,7558011,7558008,'ype',50,1),(994,7558012,7558010,'dir',25,1),(994,7558013,7558010,'ire',25,1),(994,7558014,7558010,'rec',25,1),(994,7558015,7558010,'ect',25,1),(995,7558017,7558016,'naa',100,2),(995,7558018,7558017,'600',3.333,3),(995,7558019,7558017,'000',3.333,3),(995,7558020,7558017,'00c',3.333,3),(995,7558021,7558017,'0c2',3.333,3),(995,7558022,7558017,'c29',3.333,3),(995,7558023,7558017,'291',3.333,3),(995,7558024,7558017,'912',3.333,3),(995,7558025,7558017,'127',3.333,3),(995,7558026,7558017,'275',3.333,3),(995,7558027,7558017,'752',3.333,3),(995,7558028,7558017,'528',3.333,3),(995,7558029,7558017,'28e',3.333,3),(995,7558030,7558017,'8e2',3.333,3),(995,7558031,7558017,'e23',3.333,3),(995,7558032,7558017,'230',3.333,3),(995,7558033,7558017,'303',3.333,3),(995,7558034,7558017,'039',3.333,3),(995,7558035,7558017,'39b',3.333,3),(995,7558036,7558017,'9b3',3.333,3),(995,7558037,7558017,'b3e',3.333,3),(995,7558038,7558017,'3e8',3.333,3),(995,7558039,7558017,'e8c',3.333,3),(995,7558040,7558017,'8ca',3.333,3),(995,7558041,7558017,'ca7',3.333,3),(995,7558042,7558017,'a73',3.333,3),(995,7558043,7558017,'731',3.333,3),(995,7558044,7558017,'311',3.333,3),(995,7558045,7558017,'118',3.333,3),(995,7558046,7558017,'180',3.333,3),(995,7558047,7558017,'805',3.333,3),(995,7558048,7558018,'mon',100,1),(995,7558049,7558048,'201',50,1),(995,7558050,7558048,'013',50,1),(995,7558051,7558049,'adm',33.333,4),(995,7558052,7558049,'dmi',33.333,4),(995,7558053,7558049,'min',33.333,4),(995,7558054,7558051,'cap',16.667,1),(995,7558055,7558051,'apa',16.667,1),(995,7558056,7558051,'pac',16.667,1),(995,7558057,7558051,'aci',16.667,1),(995,7558058,7558051,'cit',16.667,1),(995,7558059,7558051,'ity',16.667,1),(995,7558060,7558054,'pat',50,1),(995,7558061,7558054,'ath',50,1),(995,7558062,7558060,'fre',14.286,1),(995,7558063,7558060,'ree',14.286,1),(995,7558064,7558060,'ees',14.286,1),(995,7558065,7558060,'esp',14.286,1),(995,7558066,7558060,'spa',14.286,1),(995,7558067,7558060,'pac',14.286,1),(995,7558068,7558060,'ace',14.286,1),(995,7558069,7558062,'dis',50,1),(995,7558070,7558062,'isk',50,1),(995,7558071,7558069,'ind',33.333,1),(995,7558072,7558069,'nde',33.333,1),(995,7558073,7558069,'dex',33.333,1),(995,7558074,7558071,'adm',8.333,1),(995,7558075,7558071,'dmi',8.333,1),(995,7558076,7558071,'min',8.333,1),(995,7558077,7558071,'ini',8.333,1),(995,7558078,7558071,'nis',8.333,1),(995,7558079,7558071,'ist',8.333,1),(995,7558080,7558071,'str',8.333,1),(995,7558081,7558071,'tra',8.333,1),(995,7558082,7558071,'rat',8.333,1),(995,7558083,7558071,'ati',8.333,1),(995,7558084,7558071,'tio',8.333,1),(995,7558085,7558071,'ion',8.333,1),(995,7558086,7558074,'sta',33.333,3),(995,7558087,7558074,'tat',33.333,3),(995,7558088,7558074,'ate',33.333,3),(995,7558089,7558086,'dis',16.667,4),(995,7558090,7558086,'isa',16.667,4),(995,7558091,7558086,'sab',16.667,4),(995,7558092,7558086,'abl',16.667,4),(995,7558093,7558086,'ble',16.667,4),(995,7558094,7558086,'led',16.667,4),(995,7558095,7558089,'cac',33.333,1),(995,7558096,7558089,'ach',33.333,1),(995,7558097,7558089,'che',33.333,1),(995,7558098,7558095,'mod',50,1),(995,7558099,7558095,'ode',50,1),(995,7558100,7558098,'wri',14.286,1),(995,7558101,7558098,'rit',14.286,1),(995,7558102,7558098,'ite',14.286,1),(995,7558103,7558098,'tet',14.286,1),(995,7558104,7558098,'eth',14.286,1),(995,7558105,7558098,'thr',14.286,1),(995,7558106,7558098,'hru',14.286,1),(995,7558107,7558100,'ope',11.111,2),(995,7558108,7558100,'per',11.111,2),(995,7558109,7558100,'era',11.111,2),(995,7558110,7558100,'rat',11.111,2),(995,7558111,7558100,'ati',11.111,2),(995,7558112,7558100,'tio',11.111,2),(995,7558113,7558100,'ion',11.111,2),(995,7558114,7558100,'ona',11.111,2),(995,7558115,7558100,'nal',11.111,2),(995,7558116,7558107,'mes',20,1),(995,7558117,7558107,'ess',20,1),(995,7558118,7558107,'ssa',20,1),(995,7558119,7558107,'sag',20,1),(995,7558120,7558107,'age',20,1),(995,7558121,7558116,'per',11.111,1),(995,7558122,7558116,'erf',11.111,1),(995,7558123,7558116,'rfo',11.111,1),(995,7558124,7558116,'for',11.111,1),(995,7558125,7558116,'orm',11.111,1),(995,7558126,7558116,'rma',11.111,1),(995,7558127,7558116,'man',11.111,1),(995,7558128,7558116,'anc',11.111,1),(995,7558129,7558116,'nce',11.111,1),(995,7558130,7558121,'ide',12.5,1),(995,7558131,7558121,'den',12.5,1),(995,7558132,7558121,'ent',12.5,1),(995,7558133,7558121,'nti',12.5,1),(995,7558134,7558121,'tif',12.5,1),(995,7558135,7558121,'ifi',12.5,1),(995,7558136,7558121,'fie',12.5,1),(995,7558137,7558121,'ier',12.5,1),(995,7558138,7558130,'vdi',33.333,3),(995,7558139,7558130,'dis',33.333,3),(995,7558140,7558130,'isk',33.333,3),(995,7558141,7558138,'nam',50,1),(995,7558142,7558138,'ame',50,1),(995,7558143,7558141,'typ',50,1),(995,7558144,7558141,'ype',50,1),(995,7558145,7558143,'dir',25,1),(995,7558146,7558143,'ire',25,1),(995,7558147,7558143,'rec',25,1),(995,7558148,7558143,'ect',25,1),(996,7558150,7558149,'naa',100,2),(996,7558151,7558150,'600',3.333,3),(996,7558152,7558150,'000',3.333,3),(996,7558153,7558150,'00c',3.333,3),(996,7558154,7558150,'0c2',3.333,3),(996,7558155,7558150,'c29',3.333,3),(996,7558156,7558150,'29d',3.333,3),(996,7558157,7558150,'9d6',3.333,3),(996,7558158,7558150,'d65',3.333,3),(996,7558159,7558150,'65e',3.333,3),(996,7558160,7558150,'5e1',3.333,3),(996,7558161,7558150,'e18',3.333,3),(996,7558162,7558150,'186',3.333,3),(996,7558163,7558150,'863',3.333,3),(996,7558164,7558150,'633',3.333,3),(996,7558165,7558150,'331',3.333,3),(996,7558166,7558150,'31f',3.333,3),(996,7558167,7558150,'1fc',3.333,3),(996,7558168,7558150,'fc2',3.333,3),(996,7558169,7558150,'c2c',3.333,3),(996,7558170,7558150,'2c0',3.333,3),(996,7558171,7558150,'c02',3.333,3),(996,7558172,7558150,'025',3.333,3),(996,7558173,7558150,'255',3.333,3),(996,7558174,7558150,'55c',3.333,3),(996,7558175,7558150,'5c5',3.333,3),(996,7558176,7558150,'c5b',3.333,3),(996,7558177,7558150,'5b2',3.333,3),(996,7558178,7558150,'b2b',3.333,3),(996,7558179,7558150,'2b7',3.333,3),(996,7558180,7558150,'b7a',3.333,3),(996,7558181,7558151,'mon',100,1),(996,7558182,7558181,'201',50,1),(996,7558183,7558181,'013',50,1),(996,7558184,7558182,'adm',33.333,4),(996,7558185,7558182,'dmi',33.333,4),(996,7558186,7558182,'min',33.333,4),(996,7558187,7558184,'cap',16.667,1),(996,7558188,7558184,'apa',16.667,1),(996,7558189,7558184,'pac',16.667,1),(996,7558190,7558184,'aci',16.667,1),(996,7558191,7558184,'cit',16.667,1),(996,7558192,7558184,'ity',16.667,1),(996,7558193,7558187,'pat',50,1),(996,7558194,7558187,'ath',50,1),(996,7558195,7558193,'fre',14.286,1),(996,7558196,7558193,'ree',14.286,1),(996,7558197,7558193,'ees',14.286,1),(996,7558198,7558193,'esp',14.286,1),(996,7558199,7558193,'spa',14.286,1),(996,7558200,7558193,'pac',14.286,1),(996,7558201,7558193,'ace',14.286,1),(996,7558202,7558195,'dis',50,1),(996,7558203,7558195,'isk',50,1),(996,7558204,7558202,'ind',33.333,1),(996,7558205,7558202,'nde',33.333,1),(996,7558206,7558202,'dex',33.333,1),(996,7558207,7558204,'adm',8.333,1),(996,7558208,7558204,'dmi',8.333,1),(996,7558209,7558204,'min',8.333,1),(996,7558210,7558204,'ini',8.333,1),(996,7558211,7558204,'nis',8.333,1),(996,7558212,7558204,'ist',8.333,1),(996,7558213,7558204,'str',8.333,1),(996,7558214,7558204,'tra',8.333,1),(996,7558215,7558204,'rat',8.333,1),(996,7558216,7558204,'ati',8.333,1),(996,7558217,7558204,'tio',8.333,1),(996,7558218,7558204,'ion',8.333,1),(996,7558219,7558207,'sta',33.333,3),(996,7558220,7558207,'tat',33.333,3),(996,7558221,7558207,'ate',33.333,3),(996,7558222,7558219,'dis',16.667,4),(996,7558223,7558219,'isa',16.667,4),(996,7558224,7558219,'sab',16.667,4),(996,7558225,7558219,'abl',16.667,4),(996,7558226,7558219,'ble',16.667,4),(996,7558227,7558219,'led',16.667,4),(996,7558228,7558222,'cac',33.333,1),(996,7558229,7558222,'ach',33.333,1),(996,7558230,7558222,'che',33.333,1),(996,7558231,7558228,'mod',50,1),(996,7558232,7558228,'ode',50,1),(996,7558233,7558231,'wri',14.286,1),(996,7558234,7558231,'rit',14.286,1),(996,7558235,7558231,'ite',14.286,1),(996,7558236,7558231,'tet',14.286,1),(996,7558237,7558231,'eth',14.286,1),(996,7558238,7558231,'thr',14.286,1),(996,7558239,7558231,'hru',14.286,1),(996,7558240,7558233,'ope',11.111,2),(996,7558241,7558233,'per',11.111,2),(996,7558242,7558233,'era',11.111,2),(996,7558243,7558233,'rat',11.111,2),(996,7558244,7558233,'ati',11.111,2),(996,7558245,7558233,'tio',11.111,2),(996,7558246,7558233,'ion',11.111,2),(996,7558247,7558233,'ona',11.111,2),(996,7558248,7558233,'nal',11.111,2),(996,7558249,7558240,'mes',20,1),(996,7558250,7558240,'ess',20,1),(996,7558251,7558240,'ssa',20,1),(996,7558252,7558240,'sag',20,1),(996,7558253,7558240,'age',20,1),(996,7558254,7558249,'per',11.111,1),(996,7558255,7558249,'erf',11.111,1),(996,7558256,7558249,'rfo',11.111,1),(996,7558257,7558249,'for',11.111,1),(996,7558258,7558249,'orm',11.111,1),(996,7558259,7558249,'rma',11.111,1),(996,7558260,7558249,'man',11.111,1),(996,7558261,7558249,'anc',11.111,1),(996,7558262,7558249,'nce',11.111,1),(996,7558263,7558254,'ide',12.5,1),(996,7558264,7558254,'den',12.5,1),(996,7558265,7558254,'ent',12.5,1),(996,7558266,7558254,'nti',12.5,1),(996,7558267,7558254,'tif',12.5,1),(996,7558268,7558254,'ifi',12.5,1),(996,7558269,7558254,'fie',12.5,1),(996,7558270,7558254,'ier',12.5,1),(996,7558271,7558263,'vdi',33.333,3),(996,7558272,7558263,'dis',33.333,3),(996,7558273,7558263,'isk',33.333,3),(996,7558274,7558271,'nam',50,1),(996,7558275,7558271,'ame',50,1),(996,7558276,7558274,'typ',50,1),(996,7558277,7558274,'ype',50,1),(996,7558278,7558276,'dir',25,1),(996,7558279,7558276,'ire',25,1),(996,7558280,7558276,'rec',25,1),(996,7558281,7558276,'ect',25,1),(997,7558283,7558282,'naa',100,2),(997,7558284,7558283,'600',3.333,3),(997,7558285,7558283,'000',3.333,3),(997,7558286,7558283,'00c',3.333,3),(997,7558287,7558283,'0c2',3.333,3),(997,7558288,7558283,'c29',3.333,3),(997,7558289,7558283,'29a',3.333,3),(997,7558290,7558283,'9a7',3.333,3),(997,7558291,7558283,'a76',3.333,3),(997,7558292,7558283,'764',3.333,3),(997,7558293,7558283,'64b',3.333,3),(997,7558294,7558283,'4b4',3.333,3),(997,7558295,7558283,'b4a',3.333,3),(997,7558296,7558283,'4a8',3.333,3),(997,7558297,7558283,'a81',3.333,3),(997,7558298,7558283,'818',3.333,3),(997,7558299,7558283,'182',3.333,3),(997,7558300,7558283,'824',3.333,3),(997,7558301,7558283,'24b',3.333,3),(997,7558302,7558283,'4b3',3.333,3),(997,7558303,7558283,'b36',3.333,3),(997,7558304,7558283,'362',3.333,3),(997,7558305,7558283,'62b',3.333,3),(997,7558306,7558283,'2b6',3.333,3),(997,7558307,7558283,'b61',3.333,3),(997,7558308,7558283,'615',3.333,3),(997,7558309,7558283,'151',3.333,3),(997,7558310,7558283,'519',3.333,3),(997,7558311,7558283,'194',3.333,3),(997,7558312,7558283,'940',3.333,3),(997,7558313,7558283,'40c',3.333,3),(997,7558314,7558284,'mon',100,1),(997,7558315,7558314,'201',50,1),(997,7558316,7558314,'013',50,1),(997,7558317,7558315,'adm',33.333,4),(997,7558318,7558315,'dmi',33.333,4),(997,7558319,7558315,'min',33.333,4),(997,7558320,7558317,'cap',16.667,1),(997,7558321,7558317,'apa',16.667,1),(997,7558322,7558317,'pac',16.667,1),(997,7558323,7558317,'aci',16.667,1),(997,7558324,7558317,'cit',16.667,1),(997,7558325,7558317,'ity',16.667,1),(997,7558326,7558320,'pat',50,1),(997,7558327,7558320,'ath',50,1),(997,7558328,7558326,'fre',14.286,1),(997,7558329,7558326,'ree',14.286,1),(997,7558330,7558326,'ees',14.286,1),(997,7558331,7558326,'esp',14.286,1),(997,7558332,7558326,'spa',14.286,1),(997,7558333,7558326,'pac',14.286,1),(997,7558334,7558326,'ace',14.286,1),(997,7558335,7558328,'dis',50,1),(997,7558336,7558328,'isk',50,1),(997,7558337,7558335,'ind',33.333,1),(997,7558338,7558335,'nde',33.333,1),(997,7558339,7558335,'dex',33.333,1),(997,7558340,7558337,'adm',8.333,1),(997,7558341,7558337,'dmi',8.333,1),(997,7558342,7558337,'min',8.333,1),(997,7558343,7558337,'ini',8.333,1),(997,7558344,7558337,'nis',8.333,1),(997,7558345,7558337,'ist',8.333,1),(997,7558346,7558337,'str',8.333,1),(997,7558347,7558337,'tra',8.333,1),(997,7558348,7558337,'rat',8.333,1),(997,7558349,7558337,'ati',8.333,1),(997,7558350,7558337,'tio',8.333,1),(997,7558351,7558337,'ion',8.333,1),(997,7558352,7558340,'sta',33.333,3),(997,7558353,7558340,'tat',33.333,3),(997,7558354,7558340,'ate',33.333,3),(997,7558355,7558352,'dis',16.667,4),(997,7558356,7558352,'isa',16.667,4),(997,7558357,7558352,'sab',16.667,4),(997,7558358,7558352,'abl',16.667,4),(997,7558359,7558352,'ble',16.667,4),(997,7558360,7558352,'led',16.667,4),(997,7558361,7558355,'cac',33.333,1),(997,7558362,7558355,'ach',33.333,1),(997,7558363,7558355,'che',33.333,1),(997,7558364,7558361,'mod',50,1),(997,7558365,7558361,'ode',50,1),(997,7558366,7558364,'wri',14.286,1),(997,7558367,7558364,'rit',14.286,1),(997,7558368,7558364,'ite',14.286,1),(997,7558369,7558364,'tet',14.286,1),(997,7558370,7558364,'eth',14.286,1),(997,7558371,7558364,'thr',14.286,1),(997,7558372,7558364,'hru',14.286,1),(997,7558373,7558366,'ope',11.111,2),(997,7558374,7558366,'per',11.111,2),(997,7558375,7558366,'era',11.111,2),(997,7558376,7558366,'rat',11.111,2),(997,7558377,7558366,'ati',11.111,2),(997,7558378,7558366,'tio',11.111,2),(997,7558379,7558366,'ion',11.111,2),(997,7558380,7558366,'ona',11.111,2),(997,7558381,7558366,'nal',11.111,2),(997,7558382,7558373,'mes',20,1),(997,7558383,7558373,'ess',20,1),(997,7558384,7558373,'ssa',20,1),(997,7558385,7558373,'sag',20,1),(997,7558386,7558373,'age',20,1),(997,7558387,7558382,'per',11.111,1),(997,7558388,7558382,'erf',11.111,1),(997,7558389,7558382,'rfo',11.111,1),(997,7558390,7558382,'for',11.111,1),(997,7558391,7558382,'orm',11.111,1),(997,7558392,7558382,'rma',11.111,1),(997,7558393,7558382,'man',11.111,1),(997,7558394,7558382,'anc',11.111,1),(997,7558395,7558382,'nce',11.111,1),(997,7558396,7558387,'ide',12.5,1),(997,7558397,7558387,'den',12.5,1),(997,7558398,7558387,'ent',12.5,1),(997,7558399,7558387,'nti',12.5,1),(997,7558400,7558387,'tif',12.5,1),(997,7558401,7558387,'ifi',12.5,1),(997,7558402,7558387,'fie',12.5,1),(997,7558403,7558387,'ier',12.5,1),(997,7558404,7558396,'vdi',33.333,3),(997,7558405,7558396,'dis',33.333,3),(997,7558406,7558396,'isk',33.333,3),(997,7558407,7558404,'nam',50,1),(997,7558408,7558404,'ame',50,1),(997,7558409,7558407,'typ',50,1),(997,7558410,7558407,'ype',50,1),(997,7558411,7558409,'dir',25,1),(997,7558412,7558409,'ire',25,1),(997,7558413,7558409,'rec',25,1),(997,7558414,7558409,'ect',25,1),(998,7558416,7558415,'naa',100,2),(998,7558417,7558416,'600',3.333,3),(998,7558418,7558416,'000',3.333,3),(998,7558419,7558416,'00c',3.333,3),(998,7558420,7558416,'0c2',3.333,3),(998,7558421,7558416,'c29',3.333,3),(998,7558422,7558416,'297',3.333,3),(998,7558423,7558416,'973',3.333,3),(998,7558424,7558416,'734',3.333,3),(998,7558425,7558416,'344',3.333,3),(998,7558426,7558416,'44e',3.333,3),(998,7558427,7558416,'4e7',3.333,3),(998,7558428,7558416,'e72',3.333,3),(998,7558429,7558416,'721',3.333,3),(998,7558430,7558416,'21e',3.333,3),(998,7558431,7558416,'1ec',3.333,3),(998,7558432,7558416,'ec7',3.333,3),(998,7558433,7558416,'c77',3.333,3),(998,7558434,7558416,'77b',3.333,3),(998,7558435,7558416,'7b9',3.333,3),(998,7558436,7558416,'b99',3.333,3),(998,7558437,7558416,'99e',3.333,3),(998,7558438,7558416,'9ea',3.333,3),(998,7558439,7558416,'ea7',3.333,3),(998,7558440,7558416,'a74',3.333,3),(998,7558441,7558416,'740',3.333,3),(998,7558442,7558416,'407',3.333,3),(998,7558443,7558416,'073',3.333,3),(998,7558444,7558416,'73d',3.333,3),(998,7558445,7558416,'3df',3.333,3),(998,7558446,7558416,'df4',3.333,3),(998,7558447,7558417,'mon',100,1),(998,7558448,7558447,'201',50,1),(998,7558449,7558447,'013',50,1),(998,7558450,7558448,'adm',33.333,4),(998,7558451,7558448,'dmi',33.333,4),(998,7558452,7558448,'min',33.333,4),(998,7558453,7558450,'cap',16.667,1),(998,7558454,7558450,'apa',16.667,1),(998,7558455,7558450,'pac',16.667,1),(998,7558456,7558450,'aci',16.667,1),(998,7558457,7558450,'cit',16.667,1),(998,7558458,7558450,'ity',16.667,1),(998,7558459,7558453,'pat',50,1),(998,7558460,7558453,'ath',50,1),(998,7558461,7558459,'fre',14.286,1),(998,7558462,7558459,'ree',14.286,1),(998,7558463,7558459,'ees',14.286,1),(998,7558464,7558459,'esp',14.286,1),(998,7558465,7558459,'spa',14.286,1),(998,7558466,7558459,'pac',14.286,1),(998,7558467,7558459,'ace',14.286,1),(998,7558468,7558461,'dis',50,1),(998,7558469,7558461,'isk',50,1),(998,7558470,7558468,'ind',33.333,1),(998,7558471,7558468,'nde',33.333,1),(998,7558472,7558468,'dex',33.333,1),(998,7558473,7558470,'adm',8.333,1),(998,7558474,7558470,'dmi',8.333,1),(998,7558475,7558470,'min',8.333,1),(998,7558476,7558470,'ini',8.333,1),(998,7558477,7558470,'nis',8.333,1),(998,7558478,7558470,'ist',8.333,1),(998,7558479,7558470,'str',8.333,1),(998,7558480,7558470,'tra',8.333,1),(998,7558481,7558470,'rat',8.333,1),(998,7558482,7558470,'ati',8.333,1),(998,7558483,7558470,'tio',8.333,1),(998,7558484,7558470,'ion',8.333,1),(998,7558485,7558473,'sta',33.333,3),(998,7558486,7558473,'tat',33.333,3),(998,7558487,7558473,'ate',33.333,3),(998,7558488,7558485,'dis',16.667,4),(998,7558489,7558485,'isa',16.667,4),(998,7558490,7558485,'sab',16.667,4),(998,7558491,7558485,'abl',16.667,4),(998,7558492,7558485,'ble',16.667,4),(998,7558493,7558485,'led',16.667,4),(998,7558494,7558488,'cac',33.333,1),(998,7558495,7558488,'ach',33.333,1),(998,7558496,7558488,'che',33.333,1),(998,7558497,7558494,'mod',50,1),(998,7558498,7558494,'ode',50,1),(998,7558499,7558497,'wri',14.286,1),(998,7558500,7558497,'rit',14.286,1),(998,7558501,7558497,'ite',14.286,1),(998,7558502,7558497,'tet',14.286,1),(998,7558503,7558497,'eth',14.286,1),(998,7558504,7558497,'thr',14.286,1),(998,7558505,7558497,'hru',14.286,1),(998,7558506,7558499,'ope',11.111,2),(998,7558507,7558499,'per',11.111,2),(998,7558508,7558499,'era',11.111,2),(998,7558509,7558499,'rat',11.111,2),(998,7558510,7558499,'ati',11.111,2),(998,7558511,7558499,'tio',11.111,2),(998,7558512,7558499,'ion',11.111,2),(998,7558513,7558499,'ona',11.111,2),(998,7558514,7558499,'nal',11.111,2),(998,7558515,7558506,'mes',20,1),(998,7558516,7558506,'ess',20,1),(998,7558517,7558506,'ssa',20,1),(998,7558518,7558506,'sag',20,1),(998,7558519,7558506,'age',20,1),(998,7558520,7558515,'per',11.111,1),(998,7558521,7558515,'erf',11.111,1),(998,7558522,7558515,'rfo',11.111,1),(998,7558523,7558515,'for',11.111,1),(998,7558524,7558515,'orm',11.111,1),(998,7558525,7558515,'rma',11.111,1),(998,7558526,7558515,'man',11.111,1),(998,7558527,7558515,'anc',11.111,1),(998,7558528,7558515,'nce',11.111,1),(998,7558529,7558520,'ide',12.5,1),(998,7558530,7558520,'den',12.5,1),(998,7558531,7558520,'ent',12.5,1),(998,7558532,7558520,'nti',12.5,1),(998,7558533,7558520,'tif',12.5,1),(998,7558534,7558520,'ifi',12.5,1),(998,7558535,7558520,'fie',12.5,1),(998,7558536,7558520,'ier',12.5,1),(998,7558537,7558529,'vdi',33.333,3),(998,7558538,7558529,'dis',33.333,3),(998,7558539,7558529,'isk',33.333,3),(998,7558540,7558537,'nam',50,1),(998,7558541,7558537,'ame',50,1),(998,7558542,7558540,'typ',50,1),(998,7558543,7558540,'ype',50,1),(998,7558544,7558542,'dir',25,1),(998,7558545,7558542,'ire',25,1),(998,7558546,7558542,'rec',25,1),(998,7558547,7558542,'ect',25,1),(999,7558549,7558548,'naa',100,2),(999,7558550,7558549,'600',3.333,3),(999,7558551,7558549,'000',3.333,3),(999,7558552,7558549,'00c',3.333,3),(999,7558553,7558549,'0c2',3.333,3),(999,7558554,7558549,'c29',3.333,3),(999,7558555,7558549,'29a',3.333,3),(999,7558556,7558549,'9a8',3.333,3),(999,7558557,7558549,'a8e',3.333,3),(999,7558558,7558549,'8ee',3.333,3),(999,7558559,7558549,'eec',3.333,3),(999,7558560,7558549,'eca',3.333,3),(999,7558561,7558549,'ca7',3.333,3),(999,7558562,7558549,'a70',3.333,3),(999,7558563,7558549,'70f',3.333,3),(999,7558564,7558549,'0ff',3.333,3),(999,7558565,7558549,'ff3',3.333,3),(999,7558566,7558549,'f30',3.333,3),(999,7558567,7558549,'304',3.333,3),(999,7558568,7558549,'047',3.333,3),(999,7558569,7558549,'471',3.333,3),(999,7558570,7558549,'715',3.333,3),(999,7558571,7558549,'155',3.333,3),(999,7558572,7558549,'55c',3.333,3),(999,7558573,7558549,'5c0',3.333,3),(999,7558574,7558549,'c0a',3.333,3),(999,7558575,7558549,'0ac',3.333,3),(999,7558576,7558549,'ac7',3.333,3),(999,7558577,7558549,'c7e',3.333,3),(999,7558578,7558549,'7e5',3.333,3),(999,7558579,7558549,'e57',3.333,3),(999,7558580,7558550,'mon',100,1),(999,7558581,7558580,'201',50,1),(999,7558582,7558580,'013',50,1),(999,7558583,7558581,'adm',33.333,4),(999,7558584,7558581,'dmi',33.333,4),(999,7558585,7558581,'min',33.333,4),(999,7558586,7558583,'cap',16.667,1),(999,7558587,7558583,'apa',16.667,1),(999,7558588,7558583,'pac',16.667,1),(999,7558589,7558583,'aci',16.667,1),(999,7558590,7558583,'cit',16.667,1),(999,7558591,7558583,'ity',16.667,1),(999,7558592,7558586,'pat',50,1),(999,7558593,7558586,'ath',50,1),(999,7558594,7558592,'fre',14.286,1),(999,7558595,7558592,'ree',14.286,1),(999,7558596,7558592,'ees',14.286,1),(999,7558597,7558592,'esp',14.286,1),(999,7558598,7558592,'spa',14.286,1),(999,7558599,7558592,'pac',14.286,1),(999,7558600,7558592,'ace',14.286,1),(999,7558601,7558594,'dis',50,1),(999,7558602,7558594,'isk',50,1),(999,7558603,7558601,'ind',33.333,1),(999,7558604,7558601,'nde',33.333,1),(999,7558605,7558601,'dex',33.333,1),(999,7558606,7558603,'adm',8.333,1),(999,7558607,7558603,'dmi',8.333,1),(999,7558608,7558603,'min',8.333,1),(999,7558609,7558603,'ini',8.333,1),(999,7558610,7558603,'nis',8.333,1),(999,7558611,7558603,'ist',8.333,1),(999,7558612,7558603,'str',8.333,1),(999,7558613,7558603,'tra',8.333,1),(999,7558614,7558603,'rat',8.333,1),(999,7558615,7558603,'ati',8.333,1),(999,7558616,7558603,'tio',8.333,1),(999,7558617,7558603,'ion',8.333,1),(999,7558618,7558606,'sta',33.333,3),(999,7558619,7558606,'tat',33.333,3),(999,7558620,7558606,'ate',33.333,3),(999,7558621,7558618,'dis',16.667,4),(999,7558622,7558618,'isa',16.667,4),(999,7558623,7558618,'sab',16.667,4),(999,7558624,7558618,'abl',16.667,4),(999,7558625,7558618,'ble',16.667,4),(999,7558626,7558618,'led',16.667,4),(999,7558627,7558621,'cac',33.333,1),(999,7558628,7558621,'ach',33.333,1),(999,7558629,7558621,'che',33.333,1),(999,7558630,7558627,'mod',50,1),(999,7558631,7558627,'ode',50,1),(999,7558632,7558630,'wri',14.286,1),(999,7558633,7558630,'rit',14.286,1),(999,7558634,7558630,'ite',14.286,1),(999,7558635,7558630,'tet',14.286,1),(999,7558636,7558630,'eth',14.286,1),(999,7558637,7558630,'thr',14.286,1),(999,7558638,7558630,'hru',14.286,1),(999,7558639,7558632,'ope',11.111,2),(999,7558640,7558632,'per',11.111,2),(999,7558641,7558632,'era',11.111,2),(999,7558642,7558632,'rat',11.111,2),(999,7558643,7558632,'ati',11.111,2),(999,7558644,7558632,'tio',11.111,2),(999,7558645,7558632,'ion',11.111,2),(999,7558646,7558632,'ona',11.111,2),(999,7558647,7558632,'nal',11.111,2),(999,7558648,7558639,'mes',20,1),(999,7558649,7558639,'ess',20,1),(999,7558650,7558639,'ssa',20,1),(999,7558651,7558639,'sag',20,1),(999,7558652,7558639,'age',20,1),(999,7558653,7558648,'per',11.111,1),(999,7558654,7558648,'erf',11.111,1),(999,7558655,7558648,'rfo',11.111,1),(999,7558656,7558648,'for',11.111,1),(999,7558657,7558648,'orm',11.111,1),(999,7558658,7558648,'rma',11.111,1),(999,7558659,7558648,'man',11.111,1),(999,7558660,7558648,'anc',11.111,1),(999,7558661,7558648,'nce',11.111,1),(999,7558662,7558653,'ide',12.5,1),(999,7558663,7558653,'den',12.5,1),(999,7558664,7558653,'ent',12.5,1),(999,7558665,7558653,'nti',12.5,1),(999,7558666,7558653,'tif',12.5,1),(999,7558667,7558653,'ifi',12.5,1),(999,7558668,7558653,'fie',12.5,1),(999,7558669,7558653,'ier',12.5,1),(999,7558670,7558662,'vdi',33.333,3),(999,7558671,7558662,'dis',33.333,3),(999,7558672,7558662,'isk',33.333,3),(999,7558673,7558670,'nam',50,1),(999,7558674,7558670,'ame',50,1),(999,7558675,7558673,'typ',50,1),(999,7558676,7558673,'ype',50,1),(999,7558677,7558675,'dir',25,1),(999,7558678,7558675,'ire',25,1),(999,7558679,7558675,'rec',25,1),(999,7558680,7558675,'ect',25,1),(1000,7558682,7558681,'naa',100,2),(1000,7558683,7558682,'600',3.333,3),(1000,7558684,7558682,'000',3.333,3),(1000,7558685,7558682,'00c',3.333,3),(1000,7558686,7558682,'0c2',3.333,3),(1000,7558687,7558682,'c29',3.333,3),(1000,7558688,7558682,'295',3.333,3),(1000,7558689,7558682,'952',3.333,3),(1000,7558690,7558682,'521',3.333,3),(1000,7558691,7558682,'21b',3.333,3),(1000,7558692,7558682,'1b0',3.333,3),(1000,7558693,7558682,'b01',3.333,3),(1000,7558694,7558682,'010',3.333,3),(1000,7558695,7558682,'105',3.333,3),(1000,7558696,7558682,'054',3.333,3),(1000,7558697,7558682,'541',3.333,3),(1000,7558698,7558682,'41c',3.333,3),(1000,7558699,7558682,'1c5',3.333,3),(1000,7558700,7558682,'c53',3.333,3),(1000,7558701,7558682,'537',3.333,3),(1000,7558702,7558682,'37b',3.333,3),(1000,7558703,7558682,'7b3',3.333,3),(1000,7558704,7558682,'b3c',3.333,3),(1000,7558705,7558682,'3ca',3.333,3),(1000,7558706,7558682,'ca3',3.333,3),(1000,7558707,7558682,'a32',3.333,3),(1000,7558708,7558682,'327',3.333,3),(1000,7558709,7558682,'275',3.333,3),(1000,7558710,7558682,'75e',3.333,3),(1000,7558711,7558682,'5e7',3.333,3),(1000,7558712,7558682,'e7f',3.333,3),(1000,7558713,7558683,'mon',100,1),(1000,7558714,7558713,'201',50,1),(1000,7558715,7558713,'013',50,1),(1000,7558716,7558714,'adm',33.333,4),(1000,7558717,7558714,'dmi',33.333,4),(1000,7558718,7558714,'min',33.333,4),(1000,7558719,7558716,'cap',16.667,1),(1000,7558720,7558716,'apa',16.667,1),(1000,7558721,7558716,'pac',16.667,1),(1000,7558722,7558716,'aci',16.667,1),(1000,7558723,7558716,'cit',16.667,1),(1000,7558724,7558716,'ity',16.667,1),(1000,7558725,7558719,'pat',50,1),(1000,7558726,7558719,'ath',50,1),(1000,7558727,7558725,'fre',14.286,1),(1000,7558728,7558725,'ree',14.286,1),(1000,7558729,7558725,'ees',14.286,1),(1000,7558730,7558725,'esp',14.286,1),(1000,7558731,7558725,'spa',14.286,1),(1000,7558732,7558725,'pac',14.286,1),(1000,7558733,7558725,'ace',14.286,1),(1000,7558734,7558727,'dis',50,1),(1000,7558735,7558727,'isk',50,1),(1000,7558736,7558734,'ind',33.333,1),(1000,7558737,7558734,'nde',33.333,1),(1000,7558738,7558734,'dex',33.333,1),(1000,7558739,7558736,'adm',8.333,1),(1000,7558740,7558736,'dmi',8.333,1),(1000,7558741,7558736,'min',8.333,1),(1000,7558742,7558736,'ini',8.333,1),(1000,7558743,7558736,'nis',8.333,1),(1000,7558744,7558736,'ist',8.333,1),(1000,7558745,7558736,'str',8.333,1),(1000,7558746,7558736,'tra',8.333,1),(1000,7558747,7558736,'rat',8.333,1),(1000,7558748,7558736,'ati',8.333,1),(1000,7558749,7558736,'tio',8.333,1),(1000,7558750,7558736,'ion',8.333,1),(1000,7558751,7558739,'sta',33.333,3),(1000,7558752,7558739,'tat',33.333,3),(1000,7558753,7558739,'ate',33.333,3),(1000,7558754,7558751,'dis',16.667,4),(1000,7558755,7558751,'isa',16.667,4),(1000,7558756,7558751,'sab',16.667,4),(1000,7558757,7558751,'abl',16.667,4),(1000,7558758,7558751,'ble',16.667,4),(1000,7558759,7558751,'led',16.667,4),(1000,7558760,7558754,'cac',33.333,1),(1000,7558761,7558754,'ach',33.333,1),(1000,7558762,7558754,'che',33.333,1),(1000,7558763,7558760,'mod',50,1),(1000,7558764,7558760,'ode',50,1),(1000,7558765,7558763,'wri',14.286,1),(1000,7558766,7558763,'rit',14.286,1),(1000,7558767,7558763,'ite',14.286,1),(1000,7558768,7558763,'tet',14.286,1),(1000,7558769,7558763,'eth',14.286,1),(1000,7558770,7558763,'thr',14.286,1),(1000,7558771,7558763,'hru',14.286,1),(1000,7558772,7558765,'ope',11.111,2),(1000,7558773,7558765,'per',11.111,2),(1000,7558774,7558765,'era',11.111,2),(1000,7558775,7558765,'rat',11.111,2),(1000,7558776,7558765,'ati',11.111,2),(1000,7558777,7558765,'tio',11.111,2),(1000,7558778,7558765,'ion',11.111,2),(1000,7558779,7558765,'ona',11.111,2),(1000,7558780,7558765,'nal',11.111,2),(1000,7558781,7558772,'mes',20,1),(1000,7558782,7558772,'ess',20,1),(1000,7558783,7558772,'ssa',20,1),(1000,7558784,7558772,'sag',20,1),(1000,7558785,7558772,'age',20,1),(1000,7558786,7558781,'per',11.111,1),(1000,7558787,7558781,'erf',11.111,1),(1000,7558788,7558781,'rfo',11.111,1),(1000,7558789,7558781,'for',11.111,1),(1000,7558790,7558781,'orm',11.111,1),(1000,7558791,7558781,'rma',11.111,1),(1000,7558792,7558781,'man',11.111,1),(1000,7558793,7558781,'anc',11.111,1),(1000,7558794,7558781,'nce',11.111,1),(1000,7558795,7558786,'ide',12.5,1),(1000,7558796,7558786,'den',12.5,1),(1000,7558797,7558786,'ent',12.5,1),(1000,7558798,7558786,'nti',12.5,1),(1000,7558799,7558786,'tif',12.5,1),(1000,7558800,7558786,'ifi',12.5,1),(1000,7558801,7558786,'fie',12.5,1),(1000,7558802,7558786,'ier',12.5,1),(1000,7558803,7558795,'vdi',33.333,3),(1000,7558804,7558795,'dis',33.333,3),(1000,7558805,7558795,'isk',33.333,3),(1000,7558806,7558803,'nam',50,1),(1000,7558807,7558803,'ame',50,1),(1000,7558808,7558806,'typ',50,1),(1000,7558809,7558806,'ype',50,1),(1000,7558810,7558808,'dir',25,1),(1000,7558811,7558808,'ire',25,1),(1000,7558812,7558808,'rec',25,1),(1000,7558813,7558808,'ect',25,1),(1001,7558815,7558814,'naa',100,2),(1001,7558816,7558815,'600',3.333,3),(1001,7558817,7558815,'000',3.333,3),(1001,7558818,7558815,'00c',3.333,3),(1001,7558819,7558815,'0c2',3.333,3),(1001,7558820,7558815,'c29',3.333,3),(1001,7558821,7558815,'299',3.333,3),(1001,7558822,7558815,'997',3.333,3),(1001,7558823,7558815,'977',3.333,3),(1001,7558824,7558815,'77a',3.333,3),(1001,7558825,7558815,'7a5',3.333,3),(1001,7558826,7558815,'a59',3.333,3),(1001,7558827,7558815,'592',3.333,3),(1001,7558828,7558815,'924',3.333,3),(1001,7558829,7558815,'24d',3.333,3),(1001,7558830,7558815,'4d5',3.333,3),(1001,7558831,7558815,'d52',3.333,3),(1001,7558832,7558815,'527',3.333,3),(1001,7558833,7558815,'274',3.333,3),(1001,7558834,7558815,'74e',3.333,3),(1001,7558835,7558815,'4e2',3.333,3),(1001,7558836,7558815,'e2f',3.333,3),(1001,7558837,7558815,'2f7',3.333,3),(1001,7558838,7558815,'f79',3.333,3),(1001,7558839,7558815,'79e',3.333,3),(1001,7558840,7558815,'9ec',3.333,3),(1001,7558841,7558815,'ecf',3.333,3),(1001,7558842,7558815,'cf8',3.333,3),(1001,7558843,7558815,'f83',3.333,3),(1001,7558844,7558815,'83a',3.333,3),(1001,7558845,7558815,'3aa',3.333,3),(1001,7558846,7558816,'mon',100,1),(1001,7558847,7558846,'201',50,1),(1001,7558848,7558846,'013',50,1),(1001,7558849,7558847,'adm',33.333,4),(1001,7558850,7558847,'dmi',33.333,4),(1001,7558851,7558847,'min',33.333,4),(1001,7558852,7558849,'cap',16.667,1),(1001,7558853,7558849,'apa',16.667,1),(1001,7558854,7558849,'pac',16.667,1),(1001,7558855,7558849,'aci',16.667,1),(1001,7558856,7558849,'cit',16.667,1),(1001,7558857,7558849,'ity',16.667,1),(1001,7558858,7558852,'pat',50,1),(1001,7558859,7558852,'ath',50,1),(1001,7558860,7558858,'two',100,1),(1001,7558861,7558860,'fre',14.286,1),(1001,7558862,7558860,'ree',14.286,1),(1001,7558863,7558860,'ees',14.286,1),(1001,7558864,7558860,'esp',14.286,1),(1001,7558865,7558860,'spa',14.286,1),(1001,7558866,7558860,'pac',14.286,1),(1001,7558867,7558860,'ace',14.286,1),(1001,7558868,7558861,'dis',50,1),(1001,7558869,7558861,'isk',50,1),(1001,7558870,7558868,'ind',33.333,1),(1001,7558871,7558868,'nde',33.333,1),(1001,7558872,7558868,'dex',33.333,1),(1001,7558873,7558870,'adm',8.333,1),(1001,7558874,7558870,'dmi',8.333,1),(1001,7558875,7558870,'min',8.333,1),(1001,7558876,7558870,'ini',8.333,1),(1001,7558877,7558870,'nis',8.333,1),(1001,7558878,7558870,'ist',8.333,1),(1001,7558879,7558870,'str',8.333,1),(1001,7558880,7558870,'tra',8.333,1),(1001,7558881,7558870,'rat',8.333,1),(1001,7558882,7558870,'ati',8.333,1),(1001,7558883,7558870,'tio',8.333,1),(1001,7558884,7558870,'ion',8.333,1),(1001,7558885,7558873,'sta',33.333,3),(1001,7558886,7558873,'tat',33.333,3),(1001,7558887,7558873,'ate',33.333,3),(1001,7558888,7558885,'dis',16.667,4),(1001,7558889,7558885,'isa',16.667,4),(1001,7558890,7558885,'sab',16.667,4),(1001,7558891,7558885,'abl',16.667,4),(1001,7558892,7558885,'ble',16.667,4),(1001,7558893,7558885,'led',16.667,4),(1001,7558894,7558888,'cac',33.333,1),(1001,7558895,7558888,'ach',33.333,1),(1001,7558896,7558888,'che',33.333,1),(1001,7558897,7558894,'mod',50,1),(1001,7558898,7558894,'ode',50,1),(1001,7558899,7558897,'wri',14.286,1),(1001,7558900,7558897,'rit',14.286,1),(1001,7558901,7558897,'ite',14.286,1),(1001,7558902,7558897,'tet',14.286,1),(1001,7558903,7558897,'eth',14.286,1),(1001,7558904,7558897,'thr',14.286,1),(1001,7558905,7558897,'hru',14.286,1),(1001,7558906,7558899,'ope',11.111,2),(1001,7558907,7558899,'per',11.111,2),(1001,7558908,7558899,'era',11.111,2),(1001,7558909,7558899,'rat',11.111,2),(1001,7558910,7558899,'ati',11.111,2),(1001,7558911,7558899,'tio',11.111,2),(1001,7558912,7558899,'ion',11.111,2),(1001,7558913,7558899,'ona',11.111,2),(1001,7558914,7558899,'nal',11.111,2),(1001,7558915,7558906,'mes',20,1),(1001,7558916,7558906,'ess',20,1),(1001,7558917,7558906,'ssa',20,1),(1001,7558918,7558906,'sag',20,1),(1001,7558919,7558906,'age',20,1),(1001,7558920,7558915,'per',11.111,1),(1001,7558921,7558915,'erf',11.111,1),(1001,7558922,7558915,'rfo',11.111,1),(1001,7558923,7558915,'for',11.111,1),(1001,7558924,7558915,'orm',11.111,1),(1001,7558925,7558915,'rma',11.111,1),(1001,7558926,7558915,'man',11.111,1),(1001,7558927,7558915,'anc',11.111,1),(1001,7558928,7558915,'nce',11.111,1),(1001,7558929,7558920,'ide',12.5,1),(1001,7558930,7558920,'den',12.5,1),(1001,7558931,7558920,'ent',12.5,1),(1001,7558932,7558920,'nti',12.5,1),(1001,7558933,7558920,'tif',12.5,1),(1001,7558934,7558920,'ifi',12.5,1),(1001,7558935,7558920,'fie',12.5,1),(1001,7558936,7558920,'ier',12.5,1),(1001,7558937,7558929,'vdi',33.333,3),(1001,7558938,7558929,'dis',33.333,3),(1001,7558939,7558929,'isk',33.333,3),(1001,7558940,7558937,'nam',50,1),(1001,7558941,7558937,'ame',50,1),(1001,7558942,7558940,'typ',50,1),(1001,7558943,7558940,'ype',50,1),(1001,7558944,7558942,'dir',25,1),(1001,7558945,7558942,'ire',25,1),(1001,7558946,7558942,'rec',25,1),(1001,7558947,7558942,'ect',25,1),(1002,7558949,7558948,'naa',100,2),(1002,7558950,7558949,'600',3.333,3),(1002,7558951,7558949,'000',3.333,3),(1002,7558952,7558949,'00c',3.333,3),(1002,7558953,7558949,'0c2',3.333,3),(1002,7558954,7558949,'c29',3.333,3),(1002,7558955,7558949,'294',3.333,3),(1002,7558956,7558949,'94b',3.333,3),(1002,7558957,7558949,'4bb',3.333,3),(1002,7558958,7558949,'bba',3.333,3),(1002,7558959,7558949,'baf',3.333,3),(1002,7558960,7558949,'af3',3.333,3),(1002,7558961,7558949,'f30',3.333,3),(1002,7558962,7558949,'300',3.333,3),(1002,7558963,7558949,'00f',3.333,3),(1002,7558964,7558949,'0f4',3.333,3),(1002,7558965,7558949,'f47',3.333,3),(1002,7558966,7558949,'47a',3.333,3),(1002,7558967,7558949,'7ad',3.333,3),(1002,7558968,7558949,'ad2',3.333,3),(1002,7558969,7558949,'d28',3.333,3),(1002,7558970,7558949,'28c',3.333,3),(1002,7558971,7558949,'8cd',3.333,3),(1002,7558972,7558949,'cd5',3.333,3),(1002,7558973,7558949,'d59',3.333,3),(1002,7558974,7558949,'59c',3.333,3),(1002,7558975,7558949,'9c4',3.333,3),(1002,7558976,7558949,'c46',3.333,3),(1002,7558977,7558949,'462',3.333,3),(1002,7558978,7558949,'620',3.333,3),(1002,7558979,7558949,'204',3.333,3),(1002,7558980,7558950,'mon',100,1),(1002,7558981,7558980,'201',50,1),(1002,7558982,7558980,'013',50,1),(1002,7558983,7558981,'adm',33.333,4),(1002,7558984,7558981,'dmi',33.333,4),(1002,7558985,7558981,'min',33.333,4),(1002,7558986,7558983,'cap',16.667,1),(1002,7558987,7558983,'apa',16.667,1),(1002,7558988,7558983,'pac',16.667,1),(1002,7558989,7558983,'aci',16.667,1),(1002,7558990,7558983,'cit',16.667,1),(1002,7558991,7558983,'ity',16.667,1),(1002,7558992,7558986,'pat',50,1),(1002,7558993,7558986,'ath',50,1),(1002,7558994,7558992,'fre',14.286,1),(1002,7558995,7558992,'ree',14.286,1),(1002,7558996,7558992,'ees',14.286,1),(1002,7558997,7558992,'esp',14.286,1),(1002,7558998,7558992,'spa',14.286,1),(1002,7558999,7558992,'pac',14.286,1),(1002,7559000,7558992,'ace',14.286,1),(1002,7559001,7558994,'dis',50,1),(1002,7559002,7558994,'isk',50,1),(1002,7559003,7559001,'ind',33.333,1),(1002,7559004,7559001,'nde',33.333,1),(1002,7559005,7559001,'dex',33.333,1),(1002,7559006,7559003,'adm',8.333,1),(1002,7559007,7559003,'dmi',8.333,1),(1002,7559008,7559003,'min',8.333,1),(1002,7559009,7559003,'ini',8.333,1),(1002,7559010,7559003,'nis',8.333,1),(1002,7559011,7559003,'ist',8.333,1),(1002,7559012,7559003,'str',8.333,1),(1002,7559013,7559003,'tra',8.333,1),(1002,7559014,7559003,'rat',8.333,1),(1002,7559015,7559003,'ati',8.333,1),(1002,7559016,7559003,'tio',8.333,1),(1002,7559017,7559003,'ion',8.333,1),(1002,7559018,7559006,'sta',33.333,3),(1002,7559019,7559006,'tat',33.333,3),(1002,7559020,7559006,'ate',33.333,3),(1002,7559021,7559018,'dis',16.667,4),(1002,7559022,7559018,'isa',16.667,4),(1002,7559023,7559018,'sab',16.667,4),(1002,7559024,7559018,'abl',16.667,4),(1002,7559025,7559018,'ble',16.667,4),(1002,7559026,7559018,'led',16.667,4),(1002,7559027,7559021,'cac',33.333,1),(1002,7559028,7559021,'ach',33.333,1),(1002,7559029,7559021,'che',33.333,1),(1002,7559030,7559027,'mod',50,1),(1002,7559031,7559027,'ode',50,1),(1002,7559032,7559030,'wri',14.286,1),(1002,7559033,7559030,'rit',14.286,1),(1002,7559034,7559030,'ite',14.286,1),(1002,7559035,7559030,'tet',14.286,1),(1002,7559036,7559030,'eth',14.286,1),(1002,7559037,7559030,'thr',14.286,1),(1002,7559038,7559030,'hru',14.286,1),(1002,7559039,7559032,'ope',11.111,2),(1002,7559040,7559032,'per',11.111,2),(1002,7559041,7559032,'era',11.111,2),(1002,7559042,7559032,'rat',11.111,2),(1002,7559043,7559032,'ati',11.111,2),(1002,7559044,7559032,'tio',11.111,2),(1002,7559045,7559032,'ion',11.111,2),(1002,7559046,7559032,'ona',11.111,2),(1002,7559047,7559032,'nal',11.111,2),(1002,7559048,7559039,'mes',20,1),(1002,7559049,7559039,'ess',20,1),(1002,7559050,7559039,'ssa',20,1),(1002,7559051,7559039,'sag',20,1),(1002,7559052,7559039,'age',20,1),(1002,7559053,7559048,'per',11.111,1),(1002,7559054,7559048,'erf',11.111,1),(1002,7559055,7559048,'rfo',11.111,1),(1002,7559056,7559048,'for',11.111,1),(1002,7559057,7559048,'orm',11.111,1),(1002,7559058,7559048,'rma',11.111,1),(1002,7559059,7559048,'man',11.111,1),(1002,7559060,7559048,'anc',11.111,1),(1002,7559061,7559048,'nce',11.111,1),(1002,7559062,7559053,'ide',12.5,1),(1002,7559063,7559053,'den',12.5,1),(1002,7559064,7559053,'ent',12.5,1),(1002,7559065,7559053,'nti',12.5,1),(1002,7559066,7559053,'tif',12.5,1),(1002,7559067,7559053,'ifi',12.5,1),(1002,7559068,7559053,'fie',12.5,1),(1002,7559069,7559053,'ier',12.5,1),(1002,7559070,7559062,'vdi',33.333,3),(1002,7559071,7559062,'dis',33.333,3),(1002,7559072,7559062,'isk',33.333,3),(1002,7559073,7559070,'nam',50,1),(1002,7559074,7559070,'ame',50,1),(1002,7559075,7559073,'typ',50,1),(1002,7559076,7559073,'ype',50,1),(1002,7559077,7559075,'dir',25,1),(1002,7559078,7559075,'ire',25,1),(1002,7559079,7559075,'rec',25,1),(1002,7559080,7559075,'ect',25,1),(1003,7559082,7559081,'att',12.5,1),(1003,7559083,7559081,'ttr',12.5,1),(1003,7559084,7559081,'tri',12.5,1),(1003,7559085,7559081,'rib',12.5,1),(1003,7559086,7559081,'ibu',12.5,1),(1003,7559087,7559081,'but',12.5,1),(1003,7559088,7559081,'ute',12.5,1),(1003,7559089,7559081,'tes',12.5,1),(1003,7559090,7559082,'ref',20,3),(1003,7559091,7559082,'efr',20,3),(1003,7559092,7559082,'fre',20,3),(1003,7559093,7559082,'res',20,3),(1003,7559094,7559082,'esh',20,3),(1003,7559095,7559090,'hos',50,2),(1003,7559096,7559090,'ost',50,2),(1003,7559097,7559095,'nam',50,2),(1003,7559098,7559095,'ame',50,2),(1003,7559099,7559097,'hg3',8.333,1),(1003,7559100,7559097,'g32',8.333,1),(1003,7559101,7559097,'32v',8.333,1),(1003,7559102,7559097,'2vm',8.333,1),(1003,7559103,7559097,'vm1',8.333,1),(1003,7559104,7559097,'m14',8.333,1),(1003,7559105,7559097,'14w',8.333,1),(1003,7559106,7559097,'4w2',8.333,1),(1003,7559107,7559097,'w2k',8.333,1),(1003,7559108,7559097,'2k8',8.333,1),(1003,7559109,7559097,'k8r',8.333,1),(1003,7559110,7559097,'8r2',8.333,1),(1003,7559111,7559099,'gdl',100,1),(1003,7559112,7559111,'eng',25,1),(1003,7559113,7559111,'ngl',25,1),(1003,7559114,7559111,'gla',25,1),(1003,7559115,7559111,'lab',25,1),(1003,7559116,7559112,'net',25,1),(1003,7559117,7559112,'eta',25,1),(1003,7559118,7559112,'tap',25,1),(1003,7559119,7559112,'app',25,1),(1003,7559120,7559116,'com',100,1),(1003,7559121,7559120,'mem',25,3),(1003,7559122,7559120,'emo',25,3),(1003,7559123,7559120,'mor',25,3),(1003,7559124,7559120,'ory',25,3),(1003,7559125,7559121,'siz',50,2),(1003,7559126,7559121,'ize',50,2),(1003,7559127,7559125,'614',50,1),(1003,7559128,7559125,'144',50,1),(1003,7559129,7559127,'cpu',100,1),(1003,7559130,7559129,'usa',33.333,3),(1003,7559131,7559129,'sag',33.333,3),(1003,7559132,7559129,'age',33.333,3),(1003,7559133,7559130,'mhz',100,1),(1003,7559134,7559133,'add',20,1),(1003,7559135,7559133,'ddr',20,1),(1003,7559136,7559133,'dre',20,1),(1003,7559137,7559133,'res',20,1),(1003,7559138,7559133,'ess',20,1),(1003,7559139,7559134,'226',100,1),(1003,7559140,7559139,'147',100,1),(1003,7559141,7559140,'216',100,1),(1003,7559142,7559141,'344',50,1),(1003,7559143,7559141,'444',50,1),(1003,7559144,7559142,'gue',33.333,2),(1003,7559145,7559142,'ues',33.333,2),(1003,7559146,7559142,'est',33.333,2),(1003,7559147,7559144,'vmw',25,2),(1003,7559148,7559144,'mwa',25,2),(1003,7559149,7559144,'war',25,2),(1003,7559150,7559144,'are',25,2),(1003,7559151,7559147,'too',33.333,2),(1003,7559152,7559147,'ool',33.333,2),(1003,7559153,7559147,'ols',33.333,2),(1003,7559154,7559151,'run',20,1),(1003,7559155,7559151,'unn',20,1),(1003,7559156,7559151,'nni',20,1),(1003,7559157,7559151,'nin',20,1),(1003,7559158,7559151,'ing',20,1),(1003,7559159,7559154,'and',100,1),(1003,7559160,7559159,'the',100,1),(1003,7559161,7559160,'ver',20,2),(1003,7559162,7559160,'ers',20,2),(1003,7559163,7559160,'rsi',20,2),(1003,7559164,7559160,'sio',20,2),(1003,7559165,7559160,'ion',20,2),(1003,7559166,7559161,'cur',20,1),(1003,7559167,7559161,'urr',20,1),(1003,7559168,7559161,'rre',20,1),(1003,7559169,7559161,'ren',20,1),(1003,7559170,7559161,'ent',20,1),(1003,7559171,7559166,'mic',14.286,1),(1003,7559172,7559166,'icr',14.286,1),(1003,7559173,7559166,'cro',14.286,1),(1003,7559174,7559166,'ros',14.286,1),(1003,7559175,7559166,'oso',14.286,1),(1003,7559176,7559166,'sof',14.286,1),(1003,7559177,7559166,'oft',14.286,1),(1003,7559178,7559171,'win',20,1),(1003,7559179,7559171,'ind',20,1),(1003,7559180,7559171,'ndo',20,1),(1003,7559181,7559171,'dow',20,1),(1003,7559182,7559171,'ows',20,1),(1003,7559183,7559178,'ser',25,1),(1003,7559184,7559178,'erv',25,1),(1003,7559185,7559178,'rve',25,1),(1003,7559186,7559178,'ver',25,1),(1003,7559187,7559183,'200',50,1),(1003,7559188,7559183,'008',50,1),(1003,7559189,7559187,'64b',33.333,1),(1003,7559190,7559187,'4bi',33.333,1),(1003,7559191,7559187,'bit',33.333,1),(1003,7559192,7559189,'pat',50,1),(1003,7559193,7559189,'ath',50,1),(1003,7559194,7559192,'rx6',33.333,1),(1003,7559195,7559192,'x60',33.333,1),(1003,7559196,7559192,'600',33.333,1),(1003,7559197,7559194,'vmf',20,1),(1003,7559198,7559194,'mfi',20,1),(1003,7559199,7559194,'fil',20,1),(1003,7559200,7559194,'ile',20,1),(1003,7559201,7559194,'les',20,1),(1003,7559202,7559197,'hgw',8.333,2),(1003,7559203,7559197,'gw2',8.333,2),(1003,7559204,7559197,'w2k',8.333,2),(1003,7559205,7559197,'2k8',8.333,2),(1003,7559206,7559197,'k8r',8.333,2),(1003,7559207,7559197,'8r2',8.333,2),(1003,7559208,7559197,'r23',8.333,2),(1003,7559209,7559197,'232',8.333,2),(1003,7559210,7559197,'32v',8.333,2),(1003,7559211,7559197,'2vm',8.333,2),(1003,7559212,7559197,'vm1',8.333,2),(1003,7559213,7559197,'m14',8.333,2),(1003,7559214,7559202,'vmx',100,1),(1003,7559215,7559214,'fla',33.333,1),(1003,7559216,7559214,'las',33.333,1),(1003,7559217,7559214,'ash',33.333,1),(1003,7559218,7559215,'acc',33.333,1),(1003,7559219,7559215,'cce',33.333,1),(1003,7559220,7559215,'cel',33.333,1),(1003,7559221,7559218,'con',9.091,1),(1003,7559222,7559218,'onf',9.091,1),(1003,7559223,7559218,'nfi',9.091,1),(1003,7559224,7559218,'fig',9.091,1),(1003,7559225,7559218,'igu',9.091,1),(1003,7559226,7559218,'gur',9.091,1),(1003,7559227,7559218,'ura',9.091,1),(1003,7559228,7559218,'rat',9.091,1),(1003,7559229,7559218,'ati',9.091,1),(1003,7559230,7559218,'tio',9.091,1),(1003,7559231,7559218,'ion',9.091,1),(1003,7559232,7559221,'age',33.333,1),(1003,7559233,7559221,'gen',33.333,1),(1003,7559234,7559221,'ent',33.333,1),(1003,7559235,7559232,'193',16.667,1),(1003,7559236,7559232,'938',16.667,1),(1003,7559237,7559232,'380',16.667,1),(1003,7559238,7559232,'809',16.667,1),(1003,7559239,7559232,'097',16.667,1),(1003,7559240,7559232,'979',16.667,1),(1003,7559241,7559235,'cac',33.333,3),(1003,7559242,7559235,'ach',33.333,3),(1003,7559243,7559235,'che',33.333,3),(1003,7559244,7559241,'sta',33.333,2),(1003,7559245,7559241,'tat',33.333,2),(1003,7559246,7559241,'ate',33.333,2),(1003,7559247,7559244,'dis',16.667,3),(1003,7559248,7559244,'isa',16.667,3),(1003,7559249,7559244,'sab',16.667,3),(1003,7559250,7559244,'abl',16.667,3),(1003,7559251,7559244,'ble',16.667,3),(1003,7559252,7559244,'led',16.667,3),(1003,7559253,7559247,'ope',11.111,2),(1003,7559254,7559247,'per',11.111,2),(1003,7559255,7559247,'era',11.111,2),(1003,7559256,7559247,'rat',11.111,2),(1003,7559257,7559247,'ati',11.111,2),(1003,7559258,7559247,'tio',11.111,2),(1003,7559259,7559247,'ion',11.111,2),(1003,7559260,7559247,'ona',11.111,2),(1003,7559261,7559247,'nal',11.111,2),(1003,7559262,7559253,'mod',50,1),(1003,7559263,7559253,'ode',50,1),(1003,7559264,7559262,'wri',14.286,1),(1003,7559265,7559262,'rit',14.286,1),(1003,7559266,7559262,'ite',14.286,1),(1003,7559267,7559262,'tet',14.286,1),(1003,7559268,7559262,'eth',14.286,1),(1003,7559269,7559262,'thr',14.286,1),(1003,7559270,7559262,'hru',14.286,1),(1003,7559271,7559264,'mes',20,1),(1003,7559272,7559264,'ess',20,1),(1003,7559273,7559264,'ssa',20,1),(1003,7559274,7559264,'sag',20,1),(1003,7559275,7559264,'age',20,1),(1003,7559276,7559271,'adm',33.333,1),(1003,7559277,7559271,'dmi',33.333,1),(1003,7559278,7559271,'min',33.333,1),(1003,7559279,7559276,'met',20,3),(1003,7559280,7559276,'etr',20,3),(1003,7559281,7559276,'tri',20,3),(1003,7559282,7559276,'ric',20,3),(1003,7559283,7559276,'ics',20,3),(1003,7559284,7559279,'ena',20,1),(1003,7559285,7559279,'nab',20,1),(1003,7559286,7559279,'abl',20,1),(1003,7559287,7559279,'ble',20,1),(1003,7559288,7559279,'led',20,1),(1003,7559289,7559284,'vir',20,1),(1003,7559290,7559284,'irt',20,1),(1003,7559291,7559284,'rtu',20,1),(1003,7559292,7559284,'tua',20,1),(1003,7559293,7559284,'ual',20,1),(1003,7559294,7559289,'dis',50,1),(1003,7559295,7559289,'isk',50,1),(1004,7559297,7559296,'naa',100,2),(1004,7559298,7559297,'600',3.333,3),(1004,7559299,7559297,'000',3.333,3),(1004,7559300,7559297,'00c',3.333,3),(1004,7559301,7559297,'0c2',3.333,3),(1004,7559302,7559297,'c29',3.333,3),(1004,7559303,7559297,'29a',3.333,3),(1004,7559304,7559297,'9aa',3.333,3),(1004,7559305,7559297,'aa3',3.333,3),(1004,7559306,7559297,'a3c',3.333,3),(1004,7559307,7559297,'3c7',3.333,3),(1004,7559308,7559297,'c79',3.333,3),(1004,7559309,7559297,'79a',3.333,3),(1004,7559310,7559297,'9a2',3.333,3),(1004,7559311,7559297,'a20',3.333,3),(1004,7559312,7559297,'209',3.333,3),(1004,7559313,7559297,'091',3.333,3),(1004,7559314,7559297,'91c',3.333,3),(1004,7559315,7559297,'1c7',3.333,3),(1004,7559316,7559297,'c73',3.333,3),(1004,7559317,7559297,'73e',3.333,3),(1004,7559318,7559297,'3e2',3.333,3),(1004,7559319,7559297,'e22',3.333,3),(1004,7559320,7559297,'22a',3.333,3),(1004,7559321,7559297,'2a5',3.333,3),(1004,7559322,7559297,'a5d',3.333,3),(1004,7559323,7559297,'5d9',3.333,3),(1004,7559324,7559297,'d98',3.333,3),(1004,7559325,7559297,'98d',3.333,3),(1004,7559326,7559297,'8d2',3.333,3),(1004,7559327,7559297,'d2c',3.333,3),(1004,7559328,7559298,'mon',100,1),(1004,7559329,7559328,'201',50,1),(1004,7559330,7559328,'013',50,1),(1004,7559331,7559329,'adm',33.333,4),(1004,7559332,7559329,'dmi',33.333,4),(1004,7559333,7559329,'min',33.333,4),(1004,7559334,7559331,'cap',16.667,1),(1004,7559335,7559331,'apa',16.667,1),(1004,7559336,7559331,'pac',16.667,1),(1004,7559337,7559331,'aci',16.667,1),(1004,7559338,7559331,'cit',16.667,1),(1004,7559339,7559331,'ity',16.667,1),(1004,7559340,7559334,'pat',50,1),(1004,7559341,7559334,'ath',50,1),(1004,7559342,7559340,'vol',25,1),(1004,7559343,7559340,'olu',25,1),(1004,7559344,7559340,'lum',25,1),(1004,7559345,7559340,'ume',25,1),(1004,7559346,7559342,'78e',3.333,1),(1004,7559347,7559342,'8e3',3.333,1),(1004,7559348,7559342,'e3f',3.333,1),(1004,7559349,7559342,'3f1',3.333,1),(1004,7559350,7559342,'f18',3.333,1),(1004,7559351,7559342,'188',3.333,1),(1004,7559352,7559342,'886',3.333,1),(1004,7559353,7559342,'86d',3.333,1),(1004,7559354,7559342,'6d8',3.333,1),(1004,7559355,7559342,'d87',3.333,1),(1004,7559356,7559342,'871',3.333,1),(1004,7559357,7559342,'711',3.333,1),(1004,7559358,7559342,'11e',3.333,1),(1004,7559359,7559342,'1e1',3.333,1),(1004,7559360,7559342,'e19',3.333,1),(1004,7559361,7559342,'192',3.333,1),(1004,7559362,7559342,'927',3.333,1),(1004,7559363,7559342,'277',3.333,1),(1004,7559364,7559342,'778',3.333,1),(1004,7559365,7559342,'780',3.333,1),(1004,7559366,7559342,'806',3.333,1),(1004,7559367,7559342,'06e',3.333,1),(1004,7559368,7559342,'6e6',3.333,1),(1004,7559369,7559342,'e6f',3.333,1),(1004,7559370,7559342,'6f6',3.333,1),(1004,7559371,7559342,'f6e',3.333,1),(1004,7559372,7559342,'6e6',3.333,1),(1004,7559373,7559342,'e69',3.333,1),(1004,7559374,7559342,'696',3.333,1),(1004,7559375,7559342,'963',3.333,1),(1004,7559376,7559346,'fre',14.286,1),(1004,7559377,7559346,'ree',14.286,1),(1004,7559378,7559346,'ees',14.286,1),(1004,7559379,7559346,'esp',14.286,1),(1004,7559380,7559346,'spa',14.286,1),(1004,7559381,7559346,'pac',14.286,1),(1004,7559382,7559346,'ace',14.286,1),(1004,7559383,7559376,'dis',50,1),(1004,7559384,7559376,'isk',50,1),(1004,7559385,7559383,'ind',33.333,1),(1004,7559386,7559383,'nde',33.333,1),(1004,7559387,7559383,'dex',33.333,1),(1004,7559388,7559385,'adm',8.333,1),(1004,7559389,7559385,'dmi',8.333,1),(1004,7559390,7559385,'min',8.333,1),(1004,7559391,7559385,'ini',8.333,1),(1004,7559392,7559385,'nis',8.333,1),(1004,7559393,7559385,'ist',8.333,1),(1004,7559394,7559385,'str',8.333,1),(1004,7559395,7559385,'tra',8.333,1),(1004,7559396,7559385,'rat',8.333,1),(1004,7559397,7559385,'ati',8.333,1),(1004,7559398,7559385,'tio',8.333,1),(1004,7559399,7559385,'ion',8.333,1),(1004,7559400,7559388,'sta',33.333,3),(1004,7559401,7559388,'tat',33.333,3),(1004,7559402,7559388,'ate',33.333,3),(1004,7559403,7559400,'dis',16.667,4),(1004,7559404,7559400,'isa',16.667,4),(1004,7559405,7559400,'sab',16.667,4),(1004,7559406,7559400,'abl',16.667,4),(1004,7559407,7559400,'ble',16.667,4),(1004,7559408,7559400,'led',16.667,4),(1004,7559409,7559403,'cac',33.333,1),(1004,7559410,7559403,'ach',33.333,1),(1004,7559411,7559403,'che',33.333,1),(1004,7559412,7559409,'mod',50,1),(1004,7559413,7559409,'ode',50,1),(1004,7559414,7559412,'wri',14.286,1),(1004,7559415,7559412,'rit',14.286,1),(1004,7559416,7559412,'ite',14.286,1),(1004,7559417,7559412,'tet',14.286,1),(1004,7559418,7559412,'eth',14.286,1),(1004,7559419,7559412,'thr',14.286,1),(1004,7559420,7559412,'hru',14.286,1),(1004,7559421,7559414,'ope',11.111,2),(1004,7559422,7559414,'per',11.111,2),(1004,7559423,7559414,'era',11.111,2),(1004,7559424,7559414,'rat',11.111,2),(1004,7559425,7559414,'ati',11.111,2),(1004,7559426,7559414,'tio',11.111,2),(1004,7559427,7559414,'ion',11.111,2),(1004,7559428,7559414,'ona',11.111,2),(1004,7559429,7559414,'nal',11.111,2),(1004,7559430,7559421,'mes',20,1),(1004,7559431,7559421,'ess',20,1),(1004,7559432,7559421,'ssa',20,1),(1004,7559433,7559421,'sag',20,1),(1004,7559434,7559421,'age',20,1),(1004,7559435,7559430,'per',11.111,1),(1004,7559436,7559430,'erf',11.111,1),(1004,7559437,7559430,'rfo',11.111,1),(1004,7559438,7559430,'for',11.111,1),(1004,7559439,7559430,'orm',11.111,1),(1004,7559440,7559430,'rma',11.111,1),(1004,7559441,7559430,'man',11.111,1),(1004,7559442,7559430,'anc',11.111,1),(1004,7559443,7559430,'nce',11.111,1),(1004,7559444,7559435,'ide',12.5,1),(1004,7559445,7559435,'den',12.5,1),(1004,7559446,7559435,'ent',12.5,1),(1004,7559447,7559435,'nti',12.5,1),(1004,7559448,7559435,'tif',12.5,1),(1004,7559449,7559435,'ifi',12.5,1),(1004,7559450,7559435,'fie',12.5,1),(1004,7559451,7559435,'ier',12.5,1),(1004,7559452,7559444,'vdi',33.333,3),(1004,7559453,7559444,'dis',33.333,3),(1004,7559454,7559444,'isk',33.333,3),(1004,7559455,7559452,'nam',50,1),(1004,7559456,7559452,'ame',50,1),(1004,7559457,7559455,'typ',50,1),(1004,7559458,7559455,'ype',50,1),(1004,7559459,7559457,'dir',25,1),(1004,7559460,7559457,'ire',25,1),(1004,7559461,7559457,'rec',25,1),(1004,7559462,7559457,'ect',25,1),(1005,7559464,7559463,'naa',100,2),(1005,7559465,7559464,'600',3.333,3),(1005,7559466,7559464,'00a',3.333,3),(1005,7559467,7559464,'0a0',3.333,3),(1005,7559468,7559464,'a09',3.333,3),(1005,7559469,7559464,'098',3.333,3),(1005,7559470,7559464,'980',3.333,3),(1005,7559471,7559464,'804',3.333,3),(1005,7559472,7559464,'044',3.333,3),(1005,7559473,7559464,'443',3.333,3),(1005,7559474,7559464,'430',3.333,3),(1005,7559475,7559464,'307',3.333,3),(1005,7559476,7559464,'072',3.333,3),(1005,7559477,7559464,'725',3.333,3),(1005,7559478,7559464,'259',3.333,3),(1005,7559479,7559464,'593',3.333,3),(1005,7559480,7559464,'931',3.333,3),(1005,7559481,7559464,'313',3.333,3),(1005,7559482,7559464,'13f',3.333,3),(1005,7559483,7559464,'3f3',3.333,3),(1005,7559484,7559464,'f33',3.333,3),(1005,7559485,7559464,'334',3.333,3),(1005,7559486,7559464,'345',3.333,3),(1005,7559487,7559464,'455',3.333,3),(1005,7559488,7559464,'556',3.333,3),(1005,7559489,7559464,'563',3.333,3),(1005,7559490,7559464,'639',3.333,3),(1005,7559491,7559464,'393',3.333,3),(1005,7559492,7559464,'934',3.333,3),(1005,7559493,7559464,'345',3.333,3),(1005,7559494,7559464,'455',3.333,3),(1005,7559495,7559465,'mon',100,1),(1005,7559496,7559495,'201',50,1),(1005,7559497,7559495,'013',50,1),(1005,7559498,7559496,'adm',33.333,4),(1005,7559499,7559496,'dmi',33.333,4),(1005,7559500,7559496,'min',33.333,4),(1005,7559501,7559498,'cap',16.667,1),(1005,7559502,7559498,'apa',16.667,1),(1005,7559503,7559498,'pac',16.667,1),(1005,7559504,7559498,'aci',16.667,1),(1005,7559505,7559498,'cit',16.667,1),(1005,7559506,7559498,'ity',16.667,1),(1005,7559507,7559501,'pat',50,1),(1005,7559508,7559501,'ath',50,1),(1005,7559509,7559507,'fre',14.286,1),(1005,7559510,7559507,'ree',14.286,1),(1005,7559511,7559507,'ees',14.286,1),(1005,7559512,7559507,'esp',14.286,1),(1005,7559513,7559507,'spa',14.286,1),(1005,7559514,7559507,'pac',14.286,1),(1005,7559515,7559507,'ace',14.286,1),(1005,7559516,7559509,'dis',50,1),(1005,7559517,7559509,'isk',50,1),(1005,7559518,7559516,'ind',33.333,1),(1005,7559519,7559516,'nde',33.333,1),(1005,7559520,7559516,'dex',33.333,1),(1005,7559521,7559518,'adm',8.333,1),(1005,7559522,7559518,'dmi',8.333,1),(1005,7559523,7559518,'min',8.333,1),(1005,7559524,7559518,'ini',8.333,1),(1005,7559525,7559518,'nis',8.333,1),(1005,7559526,7559518,'ist',8.333,1),(1005,7559527,7559518,'str',8.333,1),(1005,7559528,7559518,'tra',8.333,1),(1005,7559529,7559518,'rat',8.333,1),(1005,7559530,7559518,'ati',8.333,1),(1005,7559531,7559518,'tio',8.333,1),(1005,7559532,7559518,'ion',8.333,1),(1005,7559533,7559521,'sta',33.333,3),(1005,7559534,7559521,'tat',33.333,3),(1005,7559535,7559521,'ate',33.333,3),(1005,7559536,7559533,'dis',16.667,4),(1005,7559537,7559533,'isa',16.667,4),(1005,7559538,7559533,'sab',16.667,4),(1005,7559539,7559533,'abl',16.667,4),(1005,7559540,7559533,'ble',16.667,4),(1005,7559541,7559533,'led',16.667,4),(1005,7559542,7559536,'cac',33.333,1),(1005,7559543,7559536,'ach',33.333,1),(1005,7559544,7559536,'che',33.333,1),(1005,7559545,7559542,'mod',50,1),(1005,7559546,7559542,'ode',50,1),(1005,7559547,7559545,'wri',14.286,1),(1005,7559548,7559545,'rit',14.286,1),(1005,7559549,7559545,'ite',14.286,1),(1005,7559550,7559545,'tet',14.286,1),(1005,7559551,7559545,'eth',14.286,1),(1005,7559552,7559545,'thr',14.286,1),(1005,7559553,7559545,'hru',14.286,1),(1005,7559554,7559547,'ope',11.111,2),(1005,7559555,7559547,'per',11.111,2),(1005,7559556,7559547,'era',11.111,2),(1005,7559557,7559547,'rat',11.111,2),(1005,7559558,7559547,'ati',11.111,2),(1005,7559559,7559547,'tio',11.111,2),(1005,7559560,7559547,'ion',11.111,2),(1005,7559561,7559547,'ona',11.111,2),(1005,7559562,7559547,'nal',11.111,2),(1005,7559563,7559554,'mes',20,1),(1005,7559564,7559554,'ess',20,1),(1005,7559565,7559554,'ssa',20,1),(1005,7559566,7559554,'sag',20,1),(1005,7559567,7559554,'age',20,1),(1005,7559568,7559563,'per',11.111,1),(1005,7559569,7559563,'erf',11.111,1),(1005,7559570,7559563,'rfo',11.111,1),(1005,7559571,7559563,'for',11.111,1),(1005,7559572,7559563,'orm',11.111,1),(1005,7559573,7559563,'rma',11.111,1),(1005,7559574,7559563,'man',11.111,1),(1005,7559575,7559563,'anc',11.111,1),(1005,7559576,7559563,'nce',11.111,1),(1005,7559577,7559568,'ide',12.5,1),(1005,7559578,7559568,'den',12.5,1),(1005,7559579,7559568,'ent',12.5,1),(1005,7559580,7559568,'nti',12.5,1),(1005,7559581,7559568,'tif',12.5,1),(1005,7559582,7559568,'ifi',12.5,1),(1005,7559583,7559568,'fie',12.5,1),(1005,7559584,7559568,'ier',12.5,1),(1005,7559585,7559577,'vdi',33.333,3),(1005,7559586,7559577,'dis',33.333,3),(1005,7559587,7559577,'isk',33.333,3),(1005,7559588,7559585,'nam',50,1),(1005,7559589,7559585,'ame',50,1),(1005,7559590,7559588,'typ',50,1),(1005,7559591,7559588,'ype',50,1),(1005,7559592,7559590,'dir',25,1),(1005,7559593,7559590,'ire',25,1),(1005,7559594,7559590,'rec',25,1),(1005,7559595,7559590,'ect',25,1),(1006,7559597,7559596,'naa',100,2),(1006,7559598,7559597,'600',3.333,3),(1006,7559599,7559597,'00a',3.333,3),(1006,7559600,7559597,'0a0',3.333,3),(1006,7559601,7559597,'a09',3.333,3),(1006,7559602,7559597,'098',3.333,3),(1006,7559603,7559597,'980',3.333,3),(1006,7559604,7559597,'804',3.333,3),(1006,7559605,7559597,'044',3.333,3),(1006,7559606,7559597,'443',3.333,3),(1006,7559607,7559597,'430',3.333,3),(1006,7559608,7559597,'307',3.333,3),(1006,7559609,7559597,'072',3.333,3),(1006,7559610,7559597,'725',3.333,3),(1006,7559611,7559597,'259',3.333,3),(1006,7559612,7559597,'593',3.333,3),(1006,7559613,7559597,'931',3.333,3),(1006,7559614,7559597,'313',3.333,3),(1006,7559615,7559597,'13f',3.333,3),(1006,7559616,7559597,'3f3',3.333,3),(1006,7559617,7559597,'f33',3.333,3),(1006,7559618,7559597,'334',3.333,3),(1006,7559619,7559597,'345',3.333,3),(1006,7559620,7559597,'455',3.333,3),(1006,7559621,7559597,'556',3.333,3),(1006,7559622,7559597,'563',3.333,3),(1006,7559623,7559597,'639',3.333,3),(1006,7559624,7559597,'393',3.333,3),(1006,7559625,7559597,'934',3.333,3),(1006,7559626,7559597,'345',3.333,3),(1006,7559627,7559597,'456',3.333,3),(1006,7559628,7559598,'mon',100,1),(1006,7559629,7559628,'201',50,1),(1006,7559630,7559628,'013',50,1),(1006,7559631,7559629,'adm',33.333,4),(1006,7559632,7559629,'dmi',33.333,4),(1006,7559633,7559629,'min',33.333,4),(1006,7559634,7559631,'cap',16.667,1),(1006,7559635,7559631,'apa',16.667,1),(1006,7559636,7559631,'pac',16.667,1),(1006,7559637,7559631,'aci',16.667,1),(1006,7559638,7559631,'cit',16.667,1),(1006,7559639,7559631,'ity',16.667,1),(1006,7559640,7559634,'pat',50,1),(1006,7559641,7559634,'ath',50,1),(1006,7559642,7559640,'fre',14.286,1),(1006,7559643,7559640,'ree',14.286,1),(1006,7559644,7559640,'ees',14.286,1),(1006,7559645,7559640,'esp',14.286,1),(1006,7559646,7559640,'spa',14.286,1),(1006,7559647,7559640,'pac',14.286,1),(1006,7559648,7559640,'ace',14.286,1),(1006,7559649,7559642,'dis',50,1),(1006,7559650,7559642,'isk',50,1),(1006,7559651,7559649,'ind',33.333,1),(1006,7559652,7559649,'nde',33.333,1),(1006,7559653,7559649,'dex',33.333,1),(1006,7559654,7559651,'adm',8.333,1),(1006,7559655,7559651,'dmi',8.333,1),(1006,7559656,7559651,'min',8.333,1),(1006,7559657,7559651,'ini',8.333,1),(1006,7559658,7559651,'nis',8.333,1),(1006,7559659,7559651,'ist',8.333,1),(1006,7559660,7559651,'str',8.333,1),(1006,7559661,7559651,'tra',8.333,1),(1006,7559662,7559651,'rat',8.333,1),(1006,7559663,7559651,'ati',8.333,1),(1006,7559664,7559651,'tio',8.333,1),(1006,7559665,7559651,'ion',8.333,1),(1006,7559666,7559654,'sta',33.333,3),(1006,7559667,7559654,'tat',33.333,3),(1006,7559668,7559654,'ate',33.333,3),(1006,7559669,7559666,'dis',16.667,4),(1006,7559670,7559666,'isa',16.667,4),(1006,7559671,7559666,'sab',16.667,4),(1006,7559672,7559666,'abl',16.667,4),(1006,7559673,7559666,'ble',16.667,4),(1006,7559674,7559666,'led',16.667,4),(1006,7559675,7559669,'cac',33.333,1),(1006,7559676,7559669,'ach',33.333,1),(1006,7559677,7559669,'che',33.333,1),(1006,7559678,7559675,'mod',50,1),(1006,7559679,7559675,'ode',50,1),(1006,7559680,7559678,'wri',14.286,1),(1006,7559681,7559678,'rit',14.286,1),(1006,7559682,7559678,'ite',14.286,1),(1006,7559683,7559678,'tet',14.286,1),(1006,7559684,7559678,'eth',14.286,1),(1006,7559685,7559678,'thr',14.286,1),(1006,7559686,7559678,'hru',14.286,1),(1006,7559687,7559680,'ope',11.111,2),(1006,7559688,7559680,'per',11.111,2),(1006,7559689,7559680,'era',11.111,2),(1006,7559690,7559680,'rat',11.111,2),(1006,7559691,7559680,'ati',11.111,2),(1006,7559692,7559680,'tio',11.111,2),(1006,7559693,7559680,'ion',11.111,2),(1006,7559694,7559680,'ona',11.111,2),(1006,7559695,7559680,'nal',11.111,2),(1006,7559696,7559687,'mes',20,1),(1006,7559697,7559687,'ess',20,1),(1006,7559698,7559687,'ssa',20,1),(1006,7559699,7559687,'sag',20,1),(1006,7559700,7559687,'age',20,1),(1006,7559701,7559696,'per',11.111,1),(1006,7559702,7559696,'erf',11.111,1),(1006,7559703,7559696,'rfo',11.111,1),(1006,7559704,7559696,'for',11.111,1),(1006,7559705,7559696,'orm',11.111,1),(1006,7559706,7559696,'rma',11.111,1),(1006,7559707,7559696,'man',11.111,1),(1006,7559708,7559696,'anc',11.111,1),(1006,7559709,7559696,'nce',11.111,1),(1006,7559710,7559701,'ide',12.5,1),(1006,7559711,7559701,'den',12.5,1),(1006,7559712,7559701,'ent',12.5,1),(1006,7559713,7559701,'nti',12.5,1),(1006,7559714,7559701,'tif',12.5,1),(1006,7559715,7559701,'ifi',12.5,1),(1006,7559716,7559701,'fie',12.5,1),(1006,7559717,7559701,'ier',12.5,1),(1006,7559718,7559710,'vdi',33.333,3),(1006,7559719,7559710,'dis',33.333,3),(1006,7559720,7559710,'isk',33.333,3),(1006,7559721,7559718,'nam',50,1),(1006,7559722,7559718,'ame',50,1),(1006,7559723,7559721,'typ',50,1),(1006,7559724,7559721,'ype',50,1),(1006,7559725,7559723,'dir',25,1),(1006,7559726,7559723,'ire',25,1),(1006,7559727,7559723,'rec',25,1),(1006,7559728,7559723,'ect',25,1),(1007,7559730,7559729,'naa',100,2),(1007,7559731,7559730,'600',3.333,3),(1007,7559732,7559730,'00a',3.333,3),(1007,7559733,7559730,'0a0',3.333,3),(1007,7559734,7559730,'a09',3.333,3),(1007,7559735,7559730,'098',3.333,3),(1007,7559736,7559730,'980',3.333,3),(1007,7559737,7559730,'804',3.333,3),(1007,7559738,7559730,'044',3.333,3),(1007,7559739,7559730,'443',3.333,3),(1007,7559740,7559730,'430',3.333,3),(1007,7559741,7559730,'307',3.333,3),(1007,7559742,7559730,'075',3.333,3),(1007,7559743,7559730,'753',3.333,3),(1007,7559744,7559730,'535',3.333,3),(1007,7559745,7559730,'357',3.333,3),(1007,7559746,7559730,'573',3.333,3),(1007,7559747,7559730,'732',3.333,3),(1007,7559748,7559730,'32b',3.333,3),(1007,7559749,7559730,'2b3',3.333,3),(1007,7559750,7559730,'b33',3.333,3),(1007,7559751,7559730,'334',3.333,3),(1007,7559752,7559730,'345',3.333,3),(1007,7559753,7559730,'457',3.333,3),(1007,7559754,7559730,'571',3.333,3),(1007,7559755,7559730,'715',3.333,3),(1007,7559756,7559730,'153',3.333,3),(1007,7559757,7559730,'533',3.333,3),(1007,7559758,7559730,'336',3.333,3),(1007,7559759,7559730,'364',3.333,3),(1007,7559760,7559730,'646',3.333,3),(1007,7559761,7559731,'mon',100,1),(1007,7559762,7559761,'201',50,1),(1007,7559763,7559761,'013',50,1),(1007,7559764,7559762,'adm',33.333,4),(1007,7559765,7559762,'dmi',33.333,4),(1007,7559766,7559762,'min',33.333,4),(1007,7559767,7559764,'cap',16.667,1),(1007,7559768,7559764,'apa',16.667,1),(1007,7559769,7559764,'pac',16.667,1),(1007,7559770,7559764,'aci',16.667,1),(1007,7559771,7559764,'cit',16.667,1),(1007,7559772,7559764,'ity',16.667,1),(1007,7559773,7559767,'pat',50,1),(1007,7559774,7559767,'ath',50,1),(1007,7559775,7559773,'fre',14.286,1),(1007,7559776,7559773,'ree',14.286,1),(1007,7559777,7559773,'ees',14.286,1),(1007,7559778,7559773,'esp',14.286,1),(1007,7559779,7559773,'spa',14.286,1),(1007,7559780,7559773,'pac',14.286,1),(1007,7559781,7559773,'ace',14.286,1),(1007,7559782,7559775,'dis',50,1),(1007,7559783,7559775,'isk',50,1),(1007,7559784,7559782,'ind',33.333,1),(1007,7559785,7559782,'nde',33.333,1),(1007,7559786,7559782,'dex',33.333,1),(1007,7559787,7559784,'adm',8.333,1),(1007,7559788,7559784,'dmi',8.333,1),(1007,7559789,7559784,'min',8.333,1),(1007,7559790,7559784,'ini',8.333,1),(1007,7559791,7559784,'nis',8.333,1),(1007,7559792,7559784,'ist',8.333,1),(1007,7559793,7559784,'str',8.333,1),(1007,7559794,7559784,'tra',8.333,1),(1007,7559795,7559784,'rat',8.333,1),(1007,7559796,7559784,'ati',8.333,1),(1007,7559797,7559784,'tio',8.333,1),(1007,7559798,7559784,'ion',8.333,1),(1007,7559799,7559787,'sta',33.333,3),(1007,7559800,7559787,'tat',33.333,3),(1007,7559801,7559787,'ate',33.333,3),(1007,7559802,7559799,'dis',16.667,4),(1007,7559803,7559799,'isa',16.667,4),(1007,7559804,7559799,'sab',16.667,4),(1007,7559805,7559799,'abl',16.667,4),(1007,7559806,7559799,'ble',16.667,4),(1007,7559807,7559799,'led',16.667,4),(1007,7559808,7559802,'cac',33.333,1),(1007,7559809,7559802,'ach',33.333,1),(1007,7559810,7559802,'che',33.333,1),(1007,7559811,7559808,'mod',50,1),(1007,7559812,7559808,'ode',50,1),(1007,7559813,7559811,'wri',14.286,1),(1007,7559814,7559811,'rit',14.286,1),(1007,7559815,7559811,'ite',14.286,1),(1007,7559816,7559811,'tet',14.286,1),(1007,7559817,7559811,'eth',14.286,1),(1007,7559818,7559811,'thr',14.286,1),(1007,7559819,7559811,'hru',14.286,1),(1007,7559820,7559813,'ope',11.111,2),(1007,7559821,7559813,'per',11.111,2),(1007,7559822,7559813,'era',11.111,2),(1007,7559823,7559813,'rat',11.111,2),(1007,7559824,7559813,'ati',11.111,2),(1007,7559825,7559813,'tio',11.111,2),(1007,7559826,7559813,'ion',11.111,2),(1007,7559827,7559813,'ona',11.111,2),(1007,7559828,7559813,'nal',11.111,2),(1007,7559829,7559820,'mes',20,1),(1007,7559830,7559820,'ess',20,1),(1007,7559831,7559820,'ssa',20,1),(1007,7559832,7559820,'sag',20,1),(1007,7559833,7559820,'age',20,1),(1007,7559834,7559829,'per',11.111,1),(1007,7559835,7559829,'erf',11.111,1),(1007,7559836,7559829,'rfo',11.111,1),(1007,7559837,7559829,'for',11.111,1),(1007,7559838,7559829,'orm',11.111,1),(1007,7559839,7559829,'rma',11.111,1),(1007,7559840,7559829,'man',11.111,1),(1007,7559841,7559829,'anc',11.111,1),(1007,7559842,7559829,'nce',11.111,1),(1007,7559843,7559834,'ide',12.5,1),(1007,7559844,7559834,'den',12.5,1),(1007,7559845,7559834,'ent',12.5,1),(1007,7559846,7559834,'nti',12.5,1),(1007,7559847,7559834,'tif',12.5,1),(1007,7559848,7559834,'ifi',12.5,1),(1007,7559849,7559834,'fie',12.5,1),(1007,7559850,7559834,'ier',12.5,1),(1007,7559851,7559843,'vdi',33.333,3),(1007,7559852,7559843,'dis',33.333,3),(1007,7559853,7559843,'isk',33.333,3),(1007,7559854,7559851,'nam',50,1),(1007,7559855,7559851,'ame',50,1),(1007,7559856,7559854,'typ',50,1),(1007,7559857,7559854,'ype',50,1),(1007,7559858,7559856,'dir',25,1),(1007,7559859,7559856,'ire',25,1),(1007,7559860,7559856,'rec',25,1),(1007,7559861,7559856,'ect',25,1),(1008,7559863,7559862,'naa',100,2),(1008,7559864,7559863,'600',3.333,3),(1008,7559865,7559863,'00a',3.333,3),(1008,7559866,7559863,'0a0',3.333,3),(1008,7559867,7559863,'a09',3.333,3),(1008,7559868,7559863,'098',3.333,3),(1008,7559869,7559863,'980',3.333,3),(1008,7559870,7559863,'804',3.333,3),(1008,7559871,7559863,'044',3.333,3),(1008,7559872,7559863,'443',3.333,3),(1008,7559873,7559863,'430',3.333,3),(1008,7559874,7559863,'307',3.333,3),(1008,7559875,7559863,'075',3.333,3),(1008,7559876,7559863,'753',3.333,3),(1008,7559877,7559863,'535',3.333,3),(1008,7559878,7559863,'357',3.333,3),(1008,7559879,7559863,'573',3.333,3),(1008,7559880,7559863,'732',3.333,3),(1008,7559881,7559863,'32b',3.333,3),(1008,7559882,7559863,'2b3',3.333,3),(1008,7559883,7559863,'b33',3.333,3),(1008,7559884,7559863,'334',3.333,3),(1008,7559885,7559863,'345',3.333,3),(1008,7559886,7559863,'457',3.333,3),(1008,7559887,7559863,'571',3.333,3),(1008,7559888,7559863,'715',3.333,3),(1008,7559889,7559863,'153',3.333,3),(1008,7559890,7559863,'533',3.333,3),(1008,7559891,7559863,'336',3.333,3),(1008,7559892,7559863,'364',3.333,3),(1008,7559893,7559863,'647',3.333,3),(1008,7559894,7559864,'mon',100,1),(1008,7559895,7559894,'201',50,1),(1008,7559896,7559894,'013',50,1),(1008,7559897,7559895,'adm',33.333,4),(1008,7559898,7559895,'dmi',33.333,4),(1008,7559899,7559895,'min',33.333,4),(1008,7559900,7559897,'cap',16.667,1),(1008,7559901,7559897,'apa',16.667,1),(1008,7559902,7559897,'pac',16.667,1),(1008,7559903,7559897,'aci',16.667,1),(1008,7559904,7559897,'cit',16.667,1),(1008,7559905,7559897,'ity',16.667,1),(1008,7559906,7559900,'pat',50,1),(1008,7559907,7559900,'ath',50,1),(1008,7559908,7559906,'fre',14.286,1),(1008,7559909,7559906,'ree',14.286,1),(1008,7559910,7559906,'ees',14.286,1),(1008,7559911,7559906,'esp',14.286,1),(1008,7559912,7559906,'spa',14.286,1),(1008,7559913,7559906,'pac',14.286,1),(1008,7559914,7559906,'ace',14.286,1),(1008,7559915,7559908,'dis',50,1),(1008,7559916,7559908,'isk',50,1),(1008,7559917,7559915,'ind',33.333,1),(1008,7559918,7559915,'nde',33.333,1),(1008,7559919,7559915,'dex',33.333,1),(1008,7559920,7559917,'adm',8.333,1),(1008,7559921,7559917,'dmi',8.333,1),(1008,7559922,7559917,'min',8.333,1),(1008,7559923,7559917,'ini',8.333,1),(1008,7559924,7559917,'nis',8.333,1),(1008,7559925,7559917,'ist',8.333,1),(1008,7559926,7559917,'str',8.333,1),(1008,7559927,7559917,'tra',8.333,1),(1008,7559928,7559917,'rat',8.333,1),(1008,7559929,7559917,'ati',8.333,1),(1008,7559930,7559917,'tio',8.333,1),(1008,7559931,7559917,'ion',8.333,1),(1008,7559932,7559920,'sta',33.333,3),(1008,7559933,7559920,'tat',33.333,3),(1008,7559934,7559920,'ate',33.333,3),(1008,7559935,7559932,'dis',16.667,4),(1008,7559936,7559932,'isa',16.667,4),(1008,7559937,7559932,'sab',16.667,4),(1008,7559938,7559932,'abl',16.667,4),(1008,7559939,7559932,'ble',16.667,4),(1008,7559940,7559932,'led',16.667,4),(1008,7559941,7559935,'cac',33.333,1),(1008,7559942,7559935,'ach',33.333,1),(1008,7559943,7559935,'che',33.333,1),(1008,7559944,7559941,'mod',50,1),(1008,7559945,7559941,'ode',50,1),(1008,7559946,7559944,'wri',14.286,1),(1008,7559947,7559944,'rit',14.286,1),(1008,7559948,7559944,'ite',14.286,1),(1008,7559949,7559944,'tet',14.286,1),(1008,7559950,7559944,'eth',14.286,1),(1008,7559951,7559944,'thr',14.286,1),(1008,7559952,7559944,'hru',14.286,1),(1008,7559953,7559946,'ope',11.111,2),(1008,7559954,7559946,'per',11.111,2),(1008,7559955,7559946,'era',11.111,2),(1008,7559956,7559946,'rat',11.111,2),(1008,7559957,7559946,'ati',11.111,2),(1008,7559958,7559946,'tio',11.111,2),(1008,7559959,7559946,'ion',11.111,2),(1008,7559960,7559946,'ona',11.111,2),(1008,7559961,7559946,'nal',11.111,2),(1008,7559962,7559953,'mes',20,1),(1008,7559963,7559953,'ess',20,1),(1008,7559964,7559953,'ssa',20,1),(1008,7559965,7559953,'sag',20,1),(1008,7559966,7559953,'age',20,1),(1008,7559967,7559962,'per',11.111,1),(1008,7559968,7559962,'erf',11.111,1),(1008,7559969,7559962,'rfo',11.111,1),(1008,7559970,7559962,'for',11.111,1),(1008,7559971,7559962,'orm',11.111,1),(1008,7559972,7559962,'rma',11.111,1),(1008,7559973,7559962,'man',11.111,1),(1008,7559974,7559962,'anc',11.111,1),(1008,7559975,7559962,'nce',11.111,1),(1008,7559976,7559967,'ide',12.5,1),(1008,7559977,7559967,'den',12.5,1),(1008,7559978,7559967,'ent',12.5,1),(1008,7559979,7559967,'nti',12.5,1),(1008,7559980,7559967,'tif',12.5,1),(1008,7559981,7559967,'ifi',12.5,1),(1008,7559982,7559967,'fie',12.5,1),(1008,7559983,7559967,'ier',12.5,1),(1008,7559984,7559976,'vdi',33.333,3),(1008,7559985,7559976,'dis',33.333,3),(1008,7559986,7559976,'isk',33.333,3),(1008,7559987,7559984,'nam',50,1),(1008,7559988,7559984,'ame',50,1),(1008,7559989,7559987,'typ',50,1),(1008,7559990,7559987,'ype',50,1),(1008,7559991,7559989,'dir',25,1),(1008,7559992,7559989,'ire',25,1),(1008,7559993,7559989,'rec',25,1),(1008,7559994,7559989,'ect',25,1),(1009,7559996,7559995,'naa',100,2),(1009,7559997,7559996,'600',3.333,3),(1009,7559998,7559996,'000',3.333,3),(1009,7559999,7559996,'00c',3.333,3),(1009,7560000,7559996,'0c2',3.333,3),(1009,7560001,7559996,'c29',3.333,3),(1009,7560002,7559996,'291',3.333,3),(1009,7560003,7559996,'916',3.333,3),(1009,7560004,7559996,'164',3.333,3),(1009,7560005,7559996,'64c',3.333,3),(1009,7560006,7559996,'4cf',3.333,3),(1009,7560007,7559996,'cf1',3.333,3),(1009,7560008,7559996,'f10',3.333,3),(1009,7560009,7559996,'10d',3.333,3),(1009,7560010,7559996,'0dc',3.333,3),(1009,7560011,7559996,'dc0',3.333,3),(1009,7560012,7559996,'c07',3.333,3),(1009,7560013,7559996,'072',3.333,3),(1009,7560014,7559996,'729',3.333,3),(1009,7560015,7559996,'298',3.333,3),(1009,7560016,7559996,'980',3.333,3),(1009,7560017,7559996,'806',3.333,3),(1009,7560018,7559996,'06c',3.333,3),(1009,7560019,7559996,'6c2',3.333,3),(1009,7560020,7559996,'c23',3.333,3),(1009,7560021,7559996,'234',3.333,3),(1009,7560022,7559996,'349',3.333,3),(1009,7560023,7559996,'498',3.333,3),(1009,7560024,7559996,'98f',3.333,3),(1009,7560025,7559996,'8f6',3.333,3),(1009,7560026,7559996,'f64',3.333,3),(1009,7560027,7559997,'mon',100,1),(1009,7560028,7560027,'201',50,1),(1009,7560029,7560027,'013',50,1),(1009,7560030,7560028,'adm',33.333,4),(1009,7560031,7560028,'dmi',33.333,4),(1009,7560032,7560028,'min',33.333,4),(1009,7560033,7560030,'cap',16.667,1),(1009,7560034,7560030,'apa',16.667,1),(1009,7560035,7560030,'pac',16.667,1),(1009,7560036,7560030,'aci',16.667,1),(1009,7560037,7560030,'cit',16.667,1),(1009,7560038,7560030,'ity',16.667,1),(1009,7560039,7560033,'pat',50,1),(1009,7560040,7560033,'ath',50,1),(1009,7560041,7560039,'fre',14.286,1),(1009,7560042,7560039,'ree',14.286,1),(1009,7560043,7560039,'ees',14.286,1),(1009,7560044,7560039,'esp',14.286,1),(1009,7560045,7560039,'spa',14.286,1),(1009,7560046,7560039,'pac',14.286,1),(1009,7560047,7560039,'ace',14.286,1),(1009,7560048,7560041,'dis',50,1),(1009,7560049,7560041,'isk',50,1),(1009,7560050,7560048,'ind',33.333,1),(1009,7560051,7560048,'nde',33.333,1),(1009,7560052,7560048,'dex',33.333,1),(1009,7560053,7560050,'adm',8.333,1),(1009,7560054,7560050,'dmi',8.333,1),(1009,7560055,7560050,'min',8.333,1),(1009,7560056,7560050,'ini',8.333,1),(1009,7560057,7560050,'nis',8.333,1),(1009,7560058,7560050,'ist',8.333,1),(1009,7560059,7560050,'str',8.333,1),(1009,7560060,7560050,'tra',8.333,1),(1009,7560061,7560050,'rat',8.333,1),(1009,7560062,7560050,'ati',8.333,1),(1009,7560063,7560050,'tio',8.333,1),(1009,7560064,7560050,'ion',8.333,1),(1009,7560065,7560053,'sta',33.333,3),(1009,7560066,7560053,'tat',33.333,3),(1009,7560067,7560053,'ate',33.333,3),(1009,7560068,7560065,'dis',16.667,4),(1009,7560069,7560065,'isa',16.667,4),(1009,7560070,7560065,'sab',16.667,4),(1009,7560071,7560065,'abl',16.667,4),(1009,7560072,7560065,'ble',16.667,4),(1009,7560073,7560065,'led',16.667,4),(1009,7560074,7560068,'cac',33.333,1),(1009,7560075,7560068,'ach',33.333,1),(1009,7560076,7560068,'che',33.333,1),(1009,7560077,7560074,'mod',50,1),(1009,7560078,7560074,'ode',50,1),(1009,7560079,7560077,'wri',14.286,1),(1009,7560080,7560077,'rit',14.286,1),(1009,7560081,7560077,'ite',14.286,1),(1009,7560082,7560077,'tet',14.286,1),(1009,7560083,7560077,'eth',14.286,1),(1009,7560084,7560077,'thr',14.286,1),(1009,7560085,7560077,'hru',14.286,1),(1009,7560086,7560079,'ope',11.111,2),(1009,7560087,7560079,'per',11.111,2),(1009,7560088,7560079,'era',11.111,2),(1009,7560089,7560079,'rat',11.111,2),(1009,7560090,7560079,'ati',11.111,2),(1009,7560091,7560079,'tio',11.111,2),(1009,7560092,7560079,'ion',11.111,2),(1009,7560093,7560079,'ona',11.111,2),(1009,7560094,7560079,'nal',11.111,2),(1009,7560095,7560086,'mes',20,1),(1009,7560096,7560086,'ess',20,1),(1009,7560097,7560086,'ssa',20,1),(1009,7560098,7560086,'sag',20,1),(1009,7560099,7560086,'age',20,1),(1009,7560100,7560095,'per',11.111,1),(1009,7560101,7560095,'erf',11.111,1),(1009,7560102,7560095,'rfo',11.111,1),(1009,7560103,7560095,'for',11.111,1),(1009,7560104,7560095,'orm',11.111,1),(1009,7560105,7560095,'rma',11.111,1),(1009,7560106,7560095,'man',11.111,1),(1009,7560107,7560095,'anc',11.111,1),(1009,7560108,7560095,'nce',11.111,1),(1009,7560109,7560100,'ide',12.5,1),(1009,7560110,7560100,'den',12.5,1),(1009,7560111,7560100,'ent',12.5,1),(1009,7560112,7560100,'nti',12.5,1),(1009,7560113,7560100,'tif',12.5,1),(1009,7560114,7560100,'ifi',12.5,1),(1009,7560115,7560100,'fie',12.5,1),(1009,7560116,7560100,'ier',12.5,1),(1009,7560117,7560109,'vdi',33.333,3),(1009,7560118,7560109,'dis',33.333,3),(1009,7560119,7560109,'isk',33.333,3),(1009,7560120,7560117,'nam',50,1),(1009,7560121,7560117,'ame',50,1),(1009,7560122,7560120,'typ',50,1),(1009,7560123,7560120,'ype',50,1),(1009,7560124,7560122,'dir',25,1),(1009,7560125,7560122,'ire',25,1),(1009,7560126,7560122,'rec',25,1),(1009,7560127,7560122,'ect',25,1),(1010,7560129,7560128,'naa',100,2),(1010,7560130,7560129,'600',3.333,3),(1010,7560131,7560129,'000',3.333,3),(1010,7560132,7560129,'00c',3.333,3),(1010,7560133,7560129,'0c2',3.333,3),(1010,7560134,7560129,'c29',3.333,3),(1010,7560135,7560129,'291',3.333,3),(1010,7560136,7560129,'91f',3.333,3),(1010,7560137,7560129,'1f9',3.333,3),(1010,7560138,7560129,'f95',3.333,3),(1010,7560139,7560129,'95d',3.333,3),(1010,7560140,7560129,'5d7',3.333,3),(1010,7560141,7560129,'d70',3.333,3),(1010,7560142,7560129,'70b',3.333,3),(1010,7560143,7560129,'0bc',3.333,3),(1010,7560144,7560129,'bc1',3.333,3),(1010,7560145,7560129,'c14',3.333,3),(1010,7560146,7560129,'14a',3.333,3),(1010,7560147,7560129,'4a6',3.333,3),(1010,7560148,7560129,'a6c',3.333,3),(1010,7560149,7560129,'6c8',3.333,3),(1010,7560150,7560129,'c88',3.333,3),(1010,7560151,7560129,'889',3.333,3),(1010,7560152,7560129,'892',3.333,3),(1010,7560153,7560129,'928',3.333,3),(1010,7560154,7560129,'284',3.333,3),(1010,7560155,7560129,'848',3.333,3),(1010,7560156,7560129,'485',3.333,3),(1010,7560157,7560129,'85a',3.333,3),(1010,7560158,7560129,'5aa',3.333,3),(1010,7560159,7560129,'aa5',3.333,3),(1010,7560160,7560130,'mon',100,1),(1010,7560161,7560160,'201',50,1),(1010,7560162,7560160,'013',50,1),(1010,7560163,7560161,'adm',33.333,4),(1010,7560164,7560161,'dmi',33.333,4),(1010,7560165,7560161,'min',33.333,4),(1010,7560166,7560163,'cap',16.667,1),(1010,7560167,7560163,'apa',16.667,1),(1010,7560168,7560163,'pac',16.667,1),(1010,7560169,7560163,'aci',16.667,1),(1010,7560170,7560163,'cit',16.667,1),(1010,7560171,7560163,'ity',16.667,1),(1010,7560172,7560166,'pat',50,1),(1010,7560173,7560166,'ath',50,1),(1010,7560174,7560172,'fre',14.286,1),(1010,7560175,7560172,'ree',14.286,1),(1010,7560176,7560172,'ees',14.286,1),(1010,7560177,7560172,'esp',14.286,1),(1010,7560178,7560172,'spa',14.286,1),(1010,7560179,7560172,'pac',14.286,1),(1010,7560180,7560172,'ace',14.286,1),(1010,7560181,7560174,'dis',50,1),(1010,7560182,7560174,'isk',50,1),(1010,7560183,7560181,'ind',33.333,1),(1010,7560184,7560181,'nde',33.333,1),(1010,7560185,7560181,'dex',33.333,1),(1010,7560186,7560183,'adm',8.333,1),(1010,7560187,7560183,'dmi',8.333,1),(1010,7560188,7560183,'min',8.333,1),(1010,7560189,7560183,'ini',8.333,1),(1010,7560190,7560183,'nis',8.333,1),(1010,7560191,7560183,'ist',8.333,1),(1010,7560192,7560183,'str',8.333,1),(1010,7560193,7560183,'tra',8.333,1),(1010,7560194,7560183,'rat',8.333,1),(1010,7560195,7560183,'ati',8.333,1),(1010,7560196,7560183,'tio',8.333,1),(1010,7560197,7560183,'ion',8.333,1),(1010,7560198,7560186,'sta',33.333,3),(1010,7560199,7560186,'tat',33.333,3),(1010,7560200,7560186,'ate',33.333,3),(1010,7560201,7560198,'dis',16.667,4),(1010,7560202,7560198,'isa',16.667,4),(1010,7560203,7560198,'sab',16.667,4),(1010,7560204,7560198,'abl',16.667,4),(1010,7560205,7560198,'ble',16.667,4),(1010,7560206,7560198,'led',16.667,4),(1010,7560207,7560201,'cac',33.333,1),(1010,7560208,7560201,'ach',33.333,1),(1010,7560209,7560201,'che',33.333,1),(1010,7560210,7560207,'mod',50,1),(1010,7560211,7560207,'ode',50,1),(1010,7560212,7560210,'wri',14.286,1),(1010,7560213,7560210,'rit',14.286,1),(1010,7560214,7560210,'ite',14.286,1),(1010,7560215,7560210,'tet',14.286,1),(1010,7560216,7560210,'eth',14.286,1),(1010,7560217,7560210,'thr',14.286,1),(1010,7560218,7560210,'hru',14.286,1),(1010,7560219,7560212,'ope',11.111,2),(1010,7560220,7560212,'per',11.111,2),(1010,7560221,7560212,'era',11.111,2),(1010,7560222,7560212,'rat',11.111,2),(1010,7560223,7560212,'ati',11.111,2),(1010,7560224,7560212,'tio',11.111,2),(1010,7560225,7560212,'ion',11.111,2),(1010,7560226,7560212,'ona',11.111,2),(1010,7560227,7560212,'nal',11.111,2),(1010,7560228,7560219,'mes',20,1),(1010,7560229,7560219,'ess',20,1),(1010,7560230,7560219,'ssa',20,1),(1010,7560231,7560219,'sag',20,1),(1010,7560232,7560219,'age',20,1),(1010,7560233,7560228,'per',11.111,1),(1010,7560234,7560228,'erf',11.111,1),(1010,7560235,7560228,'rfo',11.111,1),(1010,7560236,7560228,'for',11.111,1),(1010,7560237,7560228,'orm',11.111,1),(1010,7560238,7560228,'rma',11.111,1),(1010,7560239,7560228,'man',11.111,1),(1010,7560240,7560228,'anc',11.111,1),(1010,7560241,7560228,'nce',11.111,1),(1010,7560242,7560233,'ide',12.5,1),(1010,7560243,7560233,'den',12.5,1),(1010,7560244,7560233,'ent',12.5,1),(1010,7560245,7560233,'nti',12.5,1),(1010,7560246,7560233,'tif',12.5,1),(1010,7560247,7560233,'ifi',12.5,1),(1010,7560248,7560233,'fie',12.5,1),(1010,7560249,7560233,'ier',12.5,1),(1010,7560250,7560242,'vdi',33.333,3),(1010,7560251,7560242,'dis',33.333,3),(1010,7560252,7560242,'isk',33.333,3),(1010,7560253,7560250,'nam',50,1),(1010,7560254,7560250,'ame',50,1),(1010,7560255,7560253,'typ',50,1),(1010,7560256,7560253,'ype',50,1),(1010,7560257,7560255,'dir',25,1),(1010,7560258,7560255,'ire',25,1),(1010,7560259,7560255,'rec',25,1),(1010,7560260,7560255,'ect',25,1),(1011,7560262,7560261,'naa',100,2),(1011,7560263,7560262,'600',3.333,3),(1011,7560264,7560262,'000',3.333,3),(1011,7560265,7560262,'00c',3.333,3),(1011,7560266,7560262,'0c2',3.333,3),(1011,7560267,7560262,'c29',3.333,3),(1011,7560268,7560262,'292',3.333,3),(1011,7560269,7560262,'92f',3.333,3),(1011,7560270,7560262,'2f2',3.333,3),(1011,7560271,7560262,'f2e',3.333,3),(1011,7560272,7560262,'2e8',3.333,3),(1011,7560273,7560262,'e89',3.333,3),(1011,7560274,7560262,'89f',3.333,3),(1011,7560275,7560262,'9f8',3.333,3),(1011,7560276,7560262,'f8e',3.333,3),(1011,7560277,7560262,'8ed',3.333,3),(1011,7560278,7560262,'edf',3.333,3),(1011,7560279,7560262,'dfc',3.333,3),(1011,7560280,7560262,'fc9',3.333,3),(1011,7560281,7560262,'c97',3.333,3),(1011,7560282,7560262,'97c',3.333,3),(1011,7560283,7560262,'7ce',3.333,3),(1011,7560284,7560262,'ce6',3.333,3),(1011,7560285,7560262,'e68',3.333,3),(1011,7560286,7560262,'68e',3.333,3),(1011,7560287,7560262,'8ea',3.333,3),(1011,7560288,7560262,'ea3',3.333,3),(1011,7560289,7560262,'a37',3.333,3),(1011,7560290,7560262,'378',3.333,3),(1011,7560291,7560262,'785',3.333,3),(1011,7560292,7560262,'85a',3.333,3),(1011,7560293,7560263,'mon',100,1),(1011,7560294,7560293,'201',50,1),(1011,7560295,7560293,'013',50,1),(1011,7560296,7560294,'adm',33.333,4),(1011,7560297,7560294,'dmi',33.333,4),(1011,7560298,7560294,'min',33.333,4),(1011,7560299,7560296,'cap',16.667,1),(1011,7560300,7560296,'apa',16.667,1),(1011,7560301,7560296,'pac',16.667,1),(1011,7560302,7560296,'aci',16.667,1),(1011,7560303,7560296,'cit',16.667,1),(1011,7560304,7560296,'ity',16.667,1),(1011,7560305,7560299,'pat',50,1),(1011,7560306,7560299,'ath',50,1),(1011,7560307,7560305,'fre',14.286,1),(1011,7560308,7560305,'ree',14.286,1),(1011,7560309,7560305,'ees',14.286,1),(1011,7560310,7560305,'esp',14.286,1),(1011,7560311,7560305,'spa',14.286,1),(1011,7560312,7560305,'pac',14.286,1),(1011,7560313,7560305,'ace',14.286,1),(1011,7560314,7560307,'dis',50,1),(1011,7560315,7560307,'isk',50,1),(1011,7560316,7560314,'ind',33.333,1),(1011,7560317,7560314,'nde',33.333,1),(1011,7560318,7560314,'dex',33.333,1),(1011,7560319,7560316,'adm',8.333,1),(1011,7560320,7560316,'dmi',8.333,1),(1011,7560321,7560316,'min',8.333,1),(1011,7560322,7560316,'ini',8.333,1),(1011,7560323,7560316,'nis',8.333,1),(1011,7560324,7560316,'ist',8.333,1),(1011,7560325,7560316,'str',8.333,1),(1011,7560326,7560316,'tra',8.333,1),(1011,7560327,7560316,'rat',8.333,1),(1011,7560328,7560316,'ati',8.333,1),(1011,7560329,7560316,'tio',8.333,1),(1011,7560330,7560316,'ion',8.333,1),(1011,7560331,7560319,'sta',33.333,3),(1011,7560332,7560319,'tat',33.333,3),(1011,7560333,7560319,'ate',33.333,3),(1011,7560334,7560331,'dis',16.667,4),(1011,7560335,7560331,'isa',16.667,4),(1011,7560336,7560331,'sab',16.667,4),(1011,7560337,7560331,'abl',16.667,4),(1011,7560338,7560331,'ble',16.667,4),(1011,7560339,7560331,'led',16.667,4),(1011,7560340,7560334,'cac',33.333,1),(1011,7560341,7560334,'ach',33.333,1),(1011,7560342,7560334,'che',33.333,1),(1011,7560343,7560340,'mod',50,1),(1011,7560344,7560340,'ode',50,1),(1011,7560345,7560343,'wri',14.286,1),(1011,7560346,7560343,'rit',14.286,1),(1011,7560347,7560343,'ite',14.286,1),(1011,7560348,7560343,'tet',14.286,1),(1011,7560349,7560343,'eth',14.286,1),(1011,7560350,7560343,'thr',14.286,1),(1011,7560351,7560343,'hru',14.286,1),(1011,7560352,7560345,'ope',11.111,2),(1011,7560353,7560345,'per',11.111,2),(1011,7560354,7560345,'era',11.111,2),(1011,7560355,7560345,'rat',11.111,2),(1011,7560356,7560345,'ati',11.111,2),(1011,7560357,7560345,'tio',11.111,2),(1011,7560358,7560345,'ion',11.111,2),(1011,7560359,7560345,'ona',11.111,2),(1011,7560360,7560345,'nal',11.111,2),(1011,7560361,7560352,'mes',20,1),(1011,7560362,7560352,'ess',20,1),(1011,7560363,7560352,'ssa',20,1),(1011,7560364,7560352,'sag',20,1),(1011,7560365,7560352,'age',20,1),(1011,7560366,7560361,'per',11.111,1),(1011,7560367,7560361,'erf',11.111,1),(1011,7560368,7560361,'rfo',11.111,1),(1011,7560369,7560361,'for',11.111,1),(1011,7560370,7560361,'orm',11.111,1),(1011,7560371,7560361,'rma',11.111,1),(1011,7560372,7560361,'man',11.111,1),(1011,7560373,7560361,'anc',11.111,1),(1011,7560374,7560361,'nce',11.111,1),(1011,7560375,7560366,'ide',12.5,1),(1011,7560376,7560366,'den',12.5,1),(1011,7560377,7560366,'ent',12.5,1),(1011,7560378,7560366,'nti',12.5,1),(1011,7560379,7560366,'tif',12.5,1),(1011,7560380,7560366,'ifi',12.5,1),(1011,7560381,7560366,'fie',12.5,1),(1011,7560382,7560366,'ier',12.5,1),(1011,7560383,7560375,'vdi',33.333,3),(1011,7560384,7560375,'dis',33.333,3),(1011,7560385,7560375,'isk',33.333,3),(1011,7560386,7560383,'nam',50,1),(1011,7560387,7560383,'ame',50,1),(1011,7560388,7560386,'typ',50,1),(1011,7560389,7560386,'ype',50,1),(1011,7560390,7560388,'dir',25,1),(1011,7560391,7560388,'ire',25,1),(1011,7560392,7560388,'rec',25,1),(1011,7560393,7560388,'ect',25,1),(1012,7560395,7560394,'naa',100,2),(1012,7560396,7560395,'600',3.333,3),(1012,7560397,7560395,'000',3.333,3),(1012,7560398,7560395,'00c',3.333,3),(1012,7560399,7560395,'0c2',3.333,3),(1012,7560400,7560395,'c29',3.333,3),(1012,7560401,7560395,'290',3.333,3),(1012,7560402,7560395,'90e',3.333,3),(1012,7560403,7560395,'0ee',3.333,3),(1012,7560404,7560395,'ee7',3.333,3),(1012,7560405,7560395,'e73',3.333,3),(1012,7560406,7560395,'734',3.333,3),(1012,7560407,7560395,'343',3.333,3),(1012,7560408,7560395,'436',3.333,3),(1012,7560409,7560395,'36b',3.333,3),(1012,7560410,7560395,'6b8',3.333,3),(1012,7560411,7560395,'b86',3.333,3),(1012,7560412,7560395,'860',3.333,3),(1012,7560413,7560395,'600',3.333,3),(1012,7560414,7560395,'008',3.333,3),(1012,7560415,7560395,'086',3.333,3),(1012,7560416,7560395,'863',3.333,3),(1012,7560417,7560395,'63d',3.333,3),(1012,7560418,7560395,'3dd',3.333,3),(1012,7560419,7560395,'dd8',3.333,3),(1012,7560420,7560395,'d8d',3.333,3),(1012,7560421,7560395,'8df',3.333,3),(1012,7560422,7560395,'df7',3.333,3),(1012,7560423,7560395,'f73',3.333,3),(1012,7560424,7560395,'73f',3.333,3),(1012,7560425,7560395,'3fb',3.333,3),(1012,7560426,7560396,'mon',100,1),(1012,7560427,7560426,'201',50,1),(1012,7560428,7560426,'013',50,1),(1012,7560429,7560427,'adm',33.333,4),(1012,7560430,7560427,'dmi',33.333,4),(1012,7560431,7560427,'min',33.333,4),(1012,7560432,7560429,'cap',16.667,1),(1012,7560433,7560429,'apa',16.667,1),(1012,7560434,7560429,'pac',16.667,1),(1012,7560435,7560429,'aci',16.667,1),(1012,7560436,7560429,'cit',16.667,1),(1012,7560437,7560429,'ity',16.667,1),(1012,7560438,7560432,'pat',50,1),(1012,7560439,7560432,'ath',50,1),(1012,7560440,7560438,'fre',14.286,1),(1012,7560441,7560438,'ree',14.286,1),(1012,7560442,7560438,'ees',14.286,1),(1012,7560443,7560438,'esp',14.286,1),(1012,7560444,7560438,'spa',14.286,1),(1012,7560445,7560438,'pac',14.286,1),(1012,7560446,7560438,'ace',14.286,1),(1012,7560447,7560440,'dis',50,1),(1012,7560448,7560440,'isk',50,1),(1012,7560449,7560447,'ind',33.333,1),(1012,7560450,7560447,'nde',33.333,1),(1012,7560451,7560447,'dex',33.333,1),(1012,7560452,7560449,'adm',8.333,1),(1012,7560453,7560449,'dmi',8.333,1),(1012,7560454,7560449,'min',8.333,1),(1012,7560455,7560449,'ini',8.333,1),(1012,7560456,7560449,'nis',8.333,1),(1012,7560457,7560449,'ist',8.333,1),(1012,7560458,7560449,'str',8.333,1),(1012,7560459,7560449,'tra',8.333,1),(1012,7560460,7560449,'rat',8.333,1),(1012,7560461,7560449,'ati',8.333,1),(1012,7560462,7560449,'tio',8.333,1),(1012,7560463,7560449,'ion',8.333,1),(1012,7560464,7560452,'sta',33.333,3),(1012,7560465,7560452,'tat',33.333,3),(1012,7560466,7560452,'ate',33.333,3),(1012,7560467,7560464,'dis',16.667,4),(1012,7560468,7560464,'isa',16.667,4),(1012,7560469,7560464,'sab',16.667,4),(1012,7560470,7560464,'abl',16.667,4),(1012,7560471,7560464,'ble',16.667,4),(1012,7560472,7560464,'led',16.667,4),(1012,7560473,7560467,'cac',33.333,1),(1012,7560474,7560467,'ach',33.333,1),(1012,7560475,7560467,'che',33.333,1),(1012,7560476,7560473,'mod',50,1),(1012,7560477,7560473,'ode',50,1),(1012,7560478,7560476,'wri',14.286,1),(1012,7560479,7560476,'rit',14.286,1),(1012,7560480,7560476,'ite',14.286,1),(1012,7560481,7560476,'tet',14.286,1),(1012,7560482,7560476,'eth',14.286,1),(1012,7560483,7560476,'thr',14.286,1),(1012,7560484,7560476,'hru',14.286,1),(1012,7560485,7560478,'ope',11.111,2),(1012,7560486,7560478,'per',11.111,2),(1012,7560487,7560478,'era',11.111,2),(1012,7560488,7560478,'rat',11.111,2),(1012,7560489,7560478,'ati',11.111,2),(1012,7560490,7560478,'tio',11.111,2),(1012,7560491,7560478,'ion',11.111,2),(1012,7560492,7560478,'ona',11.111,2),(1012,7560493,7560478,'nal',11.111,2),(1012,7560494,7560485,'mes',20,1),(1012,7560495,7560485,'ess',20,1),(1012,7560496,7560485,'ssa',20,1),(1012,7560497,7560485,'sag',20,1),(1012,7560498,7560485,'age',20,1),(1012,7560499,7560494,'per',11.111,1),(1012,7560500,7560494,'erf',11.111,1),(1012,7560501,7560494,'rfo',11.111,1),(1012,7560502,7560494,'for',11.111,1),(1012,7560503,7560494,'orm',11.111,1),(1012,7560504,7560494,'rma',11.111,1),(1012,7560505,7560494,'man',11.111,1),(1012,7560506,7560494,'anc',11.111,1),(1012,7560507,7560494,'nce',11.111,1),(1012,7560508,7560499,'ide',12.5,1),(1012,7560509,7560499,'den',12.5,1),(1012,7560510,7560499,'ent',12.5,1),(1012,7560511,7560499,'nti',12.5,1),(1012,7560512,7560499,'tif',12.5,1),(1012,7560513,7560499,'ifi',12.5,1),(1012,7560514,7560499,'fie',12.5,1),(1012,7560515,7560499,'ier',12.5,1),(1012,7560516,7560508,'vdi',33.333,3),(1012,7560517,7560508,'dis',33.333,3),(1012,7560518,7560508,'isk',33.333,3),(1012,7560519,7560516,'nam',50,1),(1012,7560520,7560516,'ame',50,1),(1012,7560521,7560519,'typ',50,1),(1012,7560522,7560519,'ype',50,1),(1012,7560523,7560521,'dir',25,1),(1012,7560524,7560521,'ire',25,1),(1012,7560525,7560521,'rec',25,1),(1012,7560526,7560521,'ect',25,1),(1013,7560528,7560527,'naa',100,2),(1013,7560529,7560528,'600',3.333,3),(1013,7560530,7560528,'000',3.333,3),(1013,7560531,7560528,'00c',3.333,3),(1013,7560532,7560528,'0c2',3.333,3),(1013,7560533,7560528,'c29',3.333,3),(1013,7560534,7560528,'295',3.333,3),(1013,7560535,7560528,'95b',3.333,3),(1013,7560536,7560528,'5b5',3.333,3),(1013,7560537,7560528,'b52',3.333,3),(1013,7560538,7560528,'520',3.333,3),(1013,7560539,7560528,'20e',3.333,3),(1013,7560540,7560528,'0e7',3.333,3),(1013,7560541,7560528,'e72',3.333,3),(1013,7560542,7560528,'726',3.333,3),(1013,7560543,7560528,'268',3.333,3),(1013,7560544,7560528,'686',3.333,3),(1013,7560545,7560528,'865',3.333,3),(1013,7560546,7560528,'652',3.333,3),(1013,7560547,7560528,'52b',3.333,3),(1013,7560548,7560528,'2b4',3.333,3),(1013,7560549,7560528,'b40',3.333,3),(1013,7560550,7560528,'40d',3.333,3),(1013,7560551,7560528,'0dc',3.333,3),(1013,7560552,7560528,'dc7',3.333,3),(1013,7560553,7560528,'c72',3.333,3),(1013,7560554,7560528,'723',3.333,3),(1013,7560555,7560528,'239',3.333,3),(1013,7560556,7560528,'39e',3.333,3),(1013,7560557,7560528,'9e8',3.333,3),(1013,7560558,7560528,'e8e',3.333,3),(1013,7560559,7560529,'mon',100,1),(1013,7560560,7560559,'201',50,1),(1013,7560561,7560559,'013',50,1),(1013,7560562,7560560,'adm',33.333,4),(1013,7560563,7560560,'dmi',33.333,4),(1013,7560564,7560560,'min',33.333,4),(1013,7560565,7560562,'cap',16.667,1),(1013,7560566,7560562,'apa',16.667,1),(1013,7560567,7560562,'pac',16.667,1),(1013,7560568,7560562,'aci',16.667,1),(1013,7560569,7560562,'cit',16.667,1),(1013,7560570,7560562,'ity',16.667,1),(1013,7560571,7560565,'pat',50,1),(1013,7560572,7560565,'ath',50,1),(1013,7560573,7560571,'fre',14.286,1),(1013,7560574,7560571,'ree',14.286,1),(1013,7560575,7560571,'ees',14.286,1),(1013,7560576,7560571,'esp',14.286,1),(1013,7560577,7560571,'spa',14.286,1),(1013,7560578,7560571,'pac',14.286,1),(1013,7560579,7560571,'ace',14.286,1),(1013,7560580,7560573,'dis',50,1),(1013,7560581,7560573,'isk',50,1),(1013,7560582,7560580,'ind',33.333,1),(1013,7560583,7560580,'nde',33.333,1),(1013,7560584,7560580,'dex',33.333,1),(1013,7560585,7560582,'adm',8.333,1),(1013,7560586,7560582,'dmi',8.333,1),(1013,7560587,7560582,'min',8.333,1),(1013,7560588,7560582,'ini',8.333,1),(1013,7560589,7560582,'nis',8.333,1),(1013,7560590,7560582,'ist',8.333,1),(1013,7560591,7560582,'str',8.333,1),(1013,7560592,7560582,'tra',8.333,1),(1013,7560593,7560582,'rat',8.333,1),(1013,7560594,7560582,'ati',8.333,1),(1013,7560595,7560582,'tio',8.333,1),(1013,7560596,7560582,'ion',8.333,1),(1013,7560597,7560585,'sta',33.333,3),(1013,7560598,7560585,'tat',33.333,3),(1013,7560599,7560585,'ate',33.333,3),(1013,7560600,7560597,'dis',16.667,4),(1013,7560601,7560597,'isa',16.667,4),(1013,7560602,7560597,'sab',16.667,4),(1013,7560603,7560597,'abl',16.667,4),(1013,7560604,7560597,'ble',16.667,4),(1013,7560605,7560597,'led',16.667,4),(1013,7560606,7560600,'cac',33.333,1),(1013,7560607,7560600,'ach',33.333,1),(1013,7560608,7560600,'che',33.333,1),(1013,7560609,7560606,'mod',50,1),(1013,7560610,7560606,'ode',50,1),(1013,7560611,7560609,'wri',14.286,1),(1013,7560612,7560609,'rit',14.286,1),(1013,7560613,7560609,'ite',14.286,1),(1013,7560614,7560609,'tet',14.286,1),(1013,7560615,7560609,'eth',14.286,1),(1013,7560616,7560609,'thr',14.286,1),(1013,7560617,7560609,'hru',14.286,1),(1013,7560618,7560611,'ope',11.111,2),(1013,7560619,7560611,'per',11.111,2),(1013,7560620,7560611,'era',11.111,2),(1013,7560621,7560611,'rat',11.111,2),(1013,7560622,7560611,'ati',11.111,2),(1013,7560623,7560611,'tio',11.111,2),(1013,7560624,7560611,'ion',11.111,2),(1013,7560625,7560611,'ona',11.111,2),(1013,7560626,7560611,'nal',11.111,2),(1013,7560627,7560618,'mes',20,1),(1013,7560628,7560618,'ess',20,1),(1013,7560629,7560618,'ssa',20,1),(1013,7560630,7560618,'sag',20,1),(1013,7560631,7560618,'age',20,1),(1013,7560632,7560627,'per',11.111,1),(1013,7560633,7560627,'erf',11.111,1),(1013,7560634,7560627,'rfo',11.111,1),(1013,7560635,7560627,'for',11.111,1),(1013,7560636,7560627,'orm',11.111,1),(1013,7560637,7560627,'rma',11.111,1),(1013,7560638,7560627,'man',11.111,1),(1013,7560639,7560627,'anc',11.111,1),(1013,7560640,7560627,'nce',11.111,1),(1013,7560641,7560632,'ide',12.5,1),(1013,7560642,7560632,'den',12.5,1),(1013,7560643,7560632,'ent',12.5,1),(1013,7560644,7560632,'nti',12.5,1),(1013,7560645,7560632,'tif',12.5,1),(1013,7560646,7560632,'ifi',12.5,1),(1013,7560647,7560632,'fie',12.5,1),(1013,7560648,7560632,'ier',12.5,1),(1013,7560649,7560641,'vdi',33.333,3),(1013,7560650,7560641,'dis',33.333,3),(1013,7560651,7560641,'isk',33.333,3),(1013,7560652,7560649,'nam',50,1),(1013,7560653,7560649,'ame',50,1),(1013,7560654,7560652,'typ',50,1),(1013,7560655,7560652,'ype',50,1),(1013,7560656,7560654,'dir',25,1),(1013,7560657,7560654,'ire',25,1),(1013,7560658,7560654,'rec',25,1),(1013,7560659,7560654,'ect',25,1),(1014,7560661,7560660,'naa',100,2),(1014,7560662,7560661,'600',3.333,3),(1014,7560663,7560661,'000',3.333,3),(1014,7560664,7560661,'00c',3.333,3),(1014,7560665,7560661,'0c2',3.333,3),(1014,7560666,7560661,'c29',3.333,3),(1014,7560667,7560661,'299',3.333,3),(1014,7560668,7560661,'99c',3.333,3),(1014,7560669,7560661,'9c3',3.333,3),(1014,7560670,7560661,'c35',3.333,3),(1014,7560671,7560661,'354',3.333,3),(1014,7560672,7560661,'543',3.333,3),(1014,7560673,7560661,'438',3.333,3),(1014,7560674,7560661,'385',3.333,3),(1014,7560675,7560661,'85e',3.333,3),(1014,7560676,7560661,'5ef',3.333,3),(1014,7560677,7560661,'ef1',3.333,3),(1014,7560678,7560661,'f17',3.333,3),(1014,7560679,7560661,'171',3.333,3),(1014,7560680,7560661,'715',3.333,3),(1014,7560681,7560661,'15c',3.333,3),(1014,7560682,7560661,'5cc',3.333,3),(1014,7560683,7560661,'cca',3.333,3),(1014,7560684,7560661,'caf',3.333,3),(1014,7560685,7560661,'af7',3.333,3),(1014,7560686,7560661,'f77',3.333,3),(1014,7560687,7560661,'77a',3.333,3),(1014,7560688,7560661,'7a7',3.333,3),(1014,7560689,7560661,'a7d',3.333,3),(1014,7560690,7560661,'7d2',3.333,3),(1014,7560691,7560661,'d2d',3.333,3),(1014,7560692,7560662,'mon',100,1),(1014,7560693,7560692,'201',50,1),(1014,7560694,7560692,'013',50,1),(1014,7560695,7560693,'adm',33.333,4),(1014,7560696,7560693,'dmi',33.333,4),(1014,7560697,7560693,'min',33.333,4),(1014,7560698,7560695,'cap',16.667,1),(1014,7560699,7560695,'apa',16.667,1),(1014,7560700,7560695,'pac',16.667,1),(1014,7560701,7560695,'aci',16.667,1),(1014,7560702,7560695,'cit',16.667,1),(1014,7560703,7560695,'ity',16.667,1),(1014,7560704,7560698,'pat',50,1),(1014,7560705,7560698,'ath',50,1),(1014,7560706,7560704,'fre',14.286,1),(1014,7560707,7560704,'ree',14.286,1),(1014,7560708,7560704,'ees',14.286,1),(1014,7560709,7560704,'esp',14.286,1),(1014,7560710,7560704,'spa',14.286,1),(1014,7560711,7560704,'pac',14.286,1),(1014,7560712,7560704,'ace',14.286,1),(1014,7560713,7560706,'dis',50,1),(1014,7560714,7560706,'isk',50,1),(1014,7560715,7560713,'ind',33.333,1),(1014,7560716,7560713,'nde',33.333,1),(1014,7560717,7560713,'dex',33.333,1),(1014,7560718,7560715,'adm',8.333,1),(1014,7560719,7560715,'dmi',8.333,1),(1014,7560720,7560715,'min',8.333,1),(1014,7560721,7560715,'ini',8.333,1),(1014,7560722,7560715,'nis',8.333,1),(1014,7560723,7560715,'ist',8.333,1),(1014,7560724,7560715,'str',8.333,1),(1014,7560725,7560715,'tra',8.333,1),(1014,7560726,7560715,'rat',8.333,1),(1014,7560727,7560715,'ati',8.333,1),(1014,7560728,7560715,'tio',8.333,1),(1014,7560729,7560715,'ion',8.333,1),(1014,7560730,7560718,'sta',33.333,3),(1014,7560731,7560718,'tat',33.333,3),(1014,7560732,7560718,'ate',33.333,3),(1014,7560733,7560730,'dis',16.667,4),(1014,7560734,7560730,'isa',16.667,4),(1014,7560735,7560730,'sab',16.667,4),(1014,7560736,7560730,'abl',16.667,4),(1014,7560737,7560730,'ble',16.667,4),(1014,7560738,7560730,'led',16.667,4),(1014,7560739,7560733,'cac',33.333,1),(1014,7560740,7560733,'ach',33.333,1),(1014,7560741,7560733,'che',33.333,1),(1014,7560742,7560739,'mod',50,1),(1014,7560743,7560739,'ode',50,1),(1014,7560744,7560742,'wri',14.286,1),(1014,7560745,7560742,'rit',14.286,1),(1014,7560746,7560742,'ite',14.286,1),(1014,7560747,7560742,'tet',14.286,1),(1014,7560748,7560742,'eth',14.286,1),(1014,7560749,7560742,'thr',14.286,1),(1014,7560750,7560742,'hru',14.286,1),(1014,7560751,7560744,'ope',11.111,2),(1014,7560752,7560744,'per',11.111,2),(1014,7560753,7560744,'era',11.111,2),(1014,7560754,7560744,'rat',11.111,2),(1014,7560755,7560744,'ati',11.111,2),(1014,7560756,7560744,'tio',11.111,2),(1014,7560757,7560744,'ion',11.111,2),(1014,7560758,7560744,'ona',11.111,2),(1014,7560759,7560744,'nal',11.111,2),(1014,7560760,7560751,'mes',20,1),(1014,7560761,7560751,'ess',20,1),(1014,7560762,7560751,'ssa',20,1),(1014,7560763,7560751,'sag',20,1),(1014,7560764,7560751,'age',20,1),(1014,7560765,7560760,'per',11.111,1),(1014,7560766,7560760,'erf',11.111,1),(1014,7560767,7560760,'rfo',11.111,1),(1014,7560768,7560760,'for',11.111,1),(1014,7560769,7560760,'orm',11.111,1),(1014,7560770,7560760,'rma',11.111,1),(1014,7560771,7560760,'man',11.111,1),(1014,7560772,7560760,'anc',11.111,1),(1014,7560773,7560760,'nce',11.111,1),(1014,7560774,7560765,'ide',12.5,1),(1014,7560775,7560765,'den',12.5,1),(1014,7560776,7560765,'ent',12.5,1),(1014,7560777,7560765,'nti',12.5,1),(1014,7560778,7560765,'tif',12.5,1),(1014,7560779,7560765,'ifi',12.5,1),(1014,7560780,7560765,'fie',12.5,1),(1014,7560781,7560765,'ier',12.5,1),(1014,7560782,7560774,'vdi',33.333,3),(1014,7560783,7560774,'dis',33.333,3),(1014,7560784,7560774,'isk',33.333,3),(1014,7560785,7560782,'nam',50,1),(1014,7560786,7560782,'ame',50,1),(1014,7560787,7560785,'typ',50,1),(1014,7560788,7560785,'ype',50,1),(1014,7560789,7560787,'dir',25,1),(1014,7560790,7560787,'ire',25,1),(1014,7560791,7560787,'rec',25,1),(1014,7560792,7560787,'ect',25,1),(1015,7560794,7560793,'naa',100,2),(1015,7560795,7560794,'600',3.333,3),(1015,7560796,7560794,'000',3.333,3),(1015,7560797,7560794,'00c',3.333,3),(1015,7560798,7560794,'0c2',3.333,3),(1015,7560799,7560794,'c29',3.333,3),(1015,7560800,7560794,'290',3.333,3),(1015,7560801,7560794,'901',3.333,3),(1015,7560802,7560794,'01e',3.333,3),(1015,7560803,7560794,'1e7',3.333,3),(1015,7560804,7560794,'e73',3.333,3),(1015,7560805,7560794,'734',3.333,3),(1015,7560806,7560794,'346',3.333,3),(1015,7560807,7560794,'46f',3.333,3),(1015,7560808,7560794,'6f5',3.333,3),(1015,7560809,7560794,'f5c',3.333,3),(1015,7560810,7560794,'5c1',3.333,3),(1015,7560811,7560794,'c1f',3.333,3),(1015,7560812,7560794,'1f8',3.333,3),(1015,7560813,7560794,'f89',3.333,3),(1015,7560814,7560794,'898',3.333,3),(1015,7560815,7560794,'987',3.333,3),(1015,7560816,7560794,'87c',3.333,3),(1015,7560817,7560794,'7c0',3.333,3),(1015,7560818,7560794,'c05',3.333,3),(1015,7560819,7560794,'05f',3.333,3),(1015,7560820,7560794,'5f3',3.333,3),(1015,7560821,7560794,'f3e',3.333,3),(1015,7560822,7560794,'3e8',3.333,3),(1015,7560823,7560794,'e84',3.333,3),(1015,7560824,7560794,'840',3.333,3),(1015,7560825,7560795,'mon',100,1),(1015,7560826,7560825,'201',50,1),(1015,7560827,7560825,'013',50,1),(1015,7560828,7560826,'adm',33.333,4),(1015,7560829,7560826,'dmi',33.333,4),(1015,7560830,7560826,'min',33.333,4),(1015,7560831,7560828,'cap',16.667,1),(1015,7560832,7560828,'apa',16.667,1),(1015,7560833,7560828,'pac',16.667,1),(1015,7560834,7560828,'aci',16.667,1),(1015,7560835,7560828,'cit',16.667,1),(1015,7560836,7560828,'ity',16.667,1),(1015,7560837,7560831,'pat',50,1),(1015,7560838,7560831,'ath',50,1),(1015,7560839,7560837,'fre',14.286,1),(1015,7560840,7560837,'ree',14.286,1),(1015,7560841,7560837,'ees',14.286,1),(1015,7560842,7560837,'esp',14.286,1),(1015,7560843,7560837,'spa',14.286,1),(1015,7560844,7560837,'pac',14.286,1),(1015,7560845,7560837,'ace',14.286,1),(1015,7560846,7560839,'dis',50,1),(1015,7560847,7560839,'isk',50,1),(1015,7560848,7560846,'ind',33.333,1),(1015,7560849,7560846,'nde',33.333,1),(1015,7560850,7560846,'dex',33.333,1),(1015,7560851,7560848,'adm',8.333,1),(1015,7560852,7560848,'dmi',8.333,1),(1015,7560853,7560848,'min',8.333,1),(1015,7560854,7560848,'ini',8.333,1),(1015,7560855,7560848,'nis',8.333,1),(1015,7560856,7560848,'ist',8.333,1),(1015,7560857,7560848,'str',8.333,1),(1015,7560858,7560848,'tra',8.333,1),(1015,7560859,7560848,'rat',8.333,1),(1015,7560860,7560848,'ati',8.333,1),(1015,7560861,7560848,'tio',8.333,1),(1015,7560862,7560848,'ion',8.333,1),(1015,7560863,7560851,'sta',33.333,3),(1015,7560864,7560851,'tat',33.333,3),(1015,7560865,7560851,'ate',33.333,3),(1015,7560866,7560863,'dis',16.667,4),(1015,7560867,7560863,'isa',16.667,4),(1015,7560868,7560863,'sab',16.667,4),(1015,7560869,7560863,'abl',16.667,4),(1015,7560870,7560863,'ble',16.667,4),(1015,7560871,7560863,'led',16.667,4),(1015,7560872,7560866,'cac',33.333,1),(1015,7560873,7560866,'ach',33.333,1),(1015,7560874,7560866,'che',33.333,1),(1015,7560875,7560872,'mod',50,1),(1015,7560876,7560872,'ode',50,1),(1015,7560877,7560875,'wri',14.286,1),(1015,7560878,7560875,'rit',14.286,1),(1015,7560879,7560875,'ite',14.286,1),(1015,7560880,7560875,'tet',14.286,1),(1015,7560881,7560875,'eth',14.286,1),(1015,7560882,7560875,'thr',14.286,1),(1015,7560883,7560875,'hru',14.286,1),(1015,7560884,7560877,'ope',11.111,2),(1015,7560885,7560877,'per',11.111,2),(1015,7560886,7560877,'era',11.111,2),(1015,7560887,7560877,'rat',11.111,2),(1015,7560888,7560877,'ati',11.111,2),(1015,7560889,7560877,'tio',11.111,2),(1015,7560890,7560877,'ion',11.111,2),(1015,7560891,7560877,'ona',11.111,2),(1015,7560892,7560877,'nal',11.111,2),(1015,7560893,7560884,'mes',20,1),(1015,7560894,7560884,'ess',20,1),(1015,7560895,7560884,'ssa',20,1),(1015,7560896,7560884,'sag',20,1),(1015,7560897,7560884,'age',20,1),(1015,7560898,7560893,'per',11.111,1),(1015,7560899,7560893,'erf',11.111,1),(1015,7560900,7560893,'rfo',11.111,1),(1015,7560901,7560893,'for',11.111,1),(1015,7560902,7560893,'orm',11.111,1),(1015,7560903,7560893,'rma',11.111,1),(1015,7560904,7560893,'man',11.111,1),(1015,7560905,7560893,'anc',11.111,1),(1015,7560906,7560893,'nce',11.111,1),(1015,7560907,7560898,'ide',12.5,1),(1015,7560908,7560898,'den',12.5,1),(1015,7560909,7560898,'ent',12.5,1),(1015,7560910,7560898,'nti',12.5,1),(1015,7560911,7560898,'tif',12.5,1),(1015,7560912,7560898,'ifi',12.5,1),(1015,7560913,7560898,'fie',12.5,1),(1015,7560914,7560898,'ier',12.5,1),(1015,7560915,7560907,'vdi',33.333,3),(1015,7560916,7560907,'dis',33.333,3),(1015,7560917,7560907,'isk',33.333,3),(1015,7560918,7560915,'nam',50,1),(1015,7560919,7560915,'ame',50,1),(1015,7560920,7560918,'typ',50,1),(1015,7560921,7560918,'ype',50,1),(1015,7560922,7560920,'dir',25,1),(1015,7560923,7560920,'ire',25,1),(1015,7560924,7560920,'rec',25,1),(1015,7560925,7560920,'ect',25,1),(1016,7560927,7560926,'naa',100,2),(1016,7560928,7560927,'600',3.333,3),(1016,7560929,7560927,'000',3.333,3),(1016,7560930,7560927,'00c',3.333,3),(1016,7560931,7560927,'0c2',3.333,3),(1016,7560932,7560927,'c29',3.333,3),(1016,7560933,7560927,'298',3.333,3),(1016,7560934,7560927,'987',3.333,3),(1016,7560935,7560927,'876',3.333,3),(1016,7560936,7560927,'761',3.333,3),(1016,7560937,7560927,'61e',3.333,3),(1016,7560938,7560927,'1e6',3.333,3),(1016,7560939,7560927,'e6a',3.333,3),(1016,7560940,7560927,'6a7',3.333,3),(1016,7560941,7560927,'a7a',3.333,3),(1016,7560942,7560927,'7a5',3.333,3),(1016,7560943,7560927,'a52',3.333,3),(1016,7560944,7560927,'52d',3.333,3),(1016,7560945,7560927,'2d1',3.333,3),(1016,7560946,7560927,'d11',3.333,3),(1016,7560947,7560927,'11a',3.333,3),(1016,7560948,7560927,'1ae',3.333,3),(1016,7560949,7560927,'ae5',3.333,3),(1016,7560950,7560927,'e53',3.333,3),(1016,7560951,7560927,'53d',3.333,3),(1016,7560952,7560927,'3de',3.333,3),(1016,7560953,7560927,'deb',3.333,3),(1016,7560954,7560927,'eb4',3.333,3),(1016,7560955,7560927,'b42',3.333,3),(1016,7560956,7560927,'42a',3.333,3),(1016,7560957,7560927,'2a8',3.333,3),(1016,7560958,7560928,'mon',100,1),(1016,7560959,7560958,'201',50,1),(1016,7560960,7560958,'013',50,1),(1016,7560961,7560959,'adm',33.333,4),(1016,7560962,7560959,'dmi',33.333,4),(1016,7560963,7560959,'min',33.333,4),(1016,7560964,7560961,'cap',16.667,1),(1016,7560965,7560961,'apa',16.667,1),(1016,7560966,7560961,'pac',16.667,1),(1016,7560967,7560961,'aci',16.667,1),(1016,7560968,7560961,'cit',16.667,1),(1016,7560969,7560961,'ity',16.667,1),(1016,7560970,7560964,'pat',50,1),(1016,7560971,7560964,'ath',50,1),(1016,7560972,7560970,'fre',14.286,1),(1016,7560973,7560970,'ree',14.286,1),(1016,7560974,7560970,'ees',14.286,1),(1016,7560975,7560970,'esp',14.286,1),(1016,7560976,7560970,'spa',14.286,1),(1016,7560977,7560970,'pac',14.286,1),(1016,7560978,7560970,'ace',14.286,1),(1016,7560979,7560972,'dis',50,1),(1016,7560980,7560972,'isk',50,1),(1016,7560981,7560979,'ind',33.333,1),(1016,7560982,7560979,'nde',33.333,1),(1016,7560983,7560979,'dex',33.333,1),(1016,7560984,7560981,'adm',8.333,1),(1016,7560985,7560981,'dmi',8.333,1),(1016,7560986,7560981,'min',8.333,1),(1016,7560987,7560981,'ini',8.333,1),(1016,7560988,7560981,'nis',8.333,1),(1016,7560989,7560981,'ist',8.333,1),(1016,7560990,7560981,'str',8.333,1),(1016,7560991,7560981,'tra',8.333,1),(1016,7560992,7560981,'rat',8.333,1),(1016,7560993,7560981,'ati',8.333,1),(1016,7560994,7560981,'tio',8.333,1),(1016,7560995,7560981,'ion',8.333,1),(1016,7560996,7560984,'sta',33.333,3),(1016,7560997,7560984,'tat',33.333,3),(1016,7560998,7560984,'ate',33.333,3),(1016,7560999,7560996,'dis',16.667,4),(1016,7561000,7560996,'isa',16.667,4),(1016,7561001,7560996,'sab',16.667,4),(1016,7561002,7560996,'abl',16.667,4),(1016,7561003,7560996,'ble',16.667,4),(1016,7561004,7560996,'led',16.667,4),(1016,7561005,7560999,'cac',33.333,1),(1016,7561006,7560999,'ach',33.333,1),(1016,7561007,7560999,'che',33.333,1),(1016,7561008,7561005,'mod',50,1),(1016,7561009,7561005,'ode',50,1),(1016,7561010,7561008,'wri',14.286,1),(1016,7561011,7561008,'rit',14.286,1),(1016,7561012,7561008,'ite',14.286,1),(1016,7561013,7561008,'tet',14.286,1),(1016,7561014,7561008,'eth',14.286,1),(1016,7561015,7561008,'thr',14.286,1),(1016,7561016,7561008,'hru',14.286,1),(1016,7561017,7561010,'ope',11.111,2),(1016,7561018,7561010,'per',11.111,2),(1016,7561019,7561010,'era',11.111,2),(1016,7561020,7561010,'rat',11.111,2),(1016,7561021,7561010,'ati',11.111,2),(1016,7561022,7561010,'tio',11.111,2),(1016,7561023,7561010,'ion',11.111,2),(1016,7561024,7561010,'ona',11.111,2),(1016,7561025,7561010,'nal',11.111,2),(1016,7561026,7561017,'mes',20,1),(1016,7561027,7561017,'ess',20,1),(1016,7561028,7561017,'ssa',20,1),(1016,7561029,7561017,'sag',20,1),(1016,7561030,7561017,'age',20,1),(1016,7561031,7561026,'per',11.111,1),(1016,7561032,7561026,'erf',11.111,1),(1016,7561033,7561026,'rfo',11.111,1),(1016,7561034,7561026,'for',11.111,1),(1016,7561035,7561026,'orm',11.111,1),(1016,7561036,7561026,'rma',11.111,1),(1016,7561037,7561026,'man',11.111,1),(1016,7561038,7561026,'anc',11.111,1),(1016,7561039,7561026,'nce',11.111,1),(1016,7561040,7561031,'ide',12.5,1),(1016,7561041,7561031,'den',12.5,1),(1016,7561042,7561031,'ent',12.5,1),(1016,7561043,7561031,'nti',12.5,1),(1016,7561044,7561031,'tif',12.5,1),(1016,7561045,7561031,'ifi',12.5,1),(1016,7561046,7561031,'fie',12.5,1),(1016,7561047,7561031,'ier',12.5,1),(1016,7561048,7561040,'vdi',33.333,3),(1016,7561049,7561040,'dis',33.333,3),(1016,7561050,7561040,'isk',33.333,3),(1016,7561051,7561048,'nam',50,1),(1016,7561052,7561048,'ame',50,1),(1016,7561053,7561051,'typ',50,1),(1016,7561054,7561051,'ype',50,1),(1016,7561055,7561053,'dir',25,1),(1016,7561056,7561053,'ire',25,1),(1016,7561057,7561053,'rec',25,1),(1016,7561058,7561053,'ect',25,1),(1017,7561060,7561059,'naa',100,2),(1017,7561061,7561060,'600',3.333,3),(1017,7561062,7561060,'000',3.333,3),(1017,7561063,7561060,'00c',3.333,3),(1017,7561064,7561060,'0c2',3.333,3),(1017,7561065,7561060,'c29',3.333,3),(1017,7561066,7561060,'29d',3.333,3),(1017,7561067,7561060,'9da',3.333,3),(1017,7561068,7561060,'dad',3.333,3),(1017,7561069,7561060,'ada',3.333,3),(1017,7561070,7561060,'dad',3.333,3),(1017,7561071,7561060,'ada',3.333,3),(1017,7561072,7561060,'daf',3.333,3),(1017,7561073,7561060,'afa',3.333,3),(1017,7561074,7561060,'fa6',3.333,3),(1017,7561075,7561060,'a68',3.333,3),(1017,7561076,7561060,'687',3.333,3),(1017,7561077,7561060,'872',3.333,3),(1017,7561078,7561060,'727',3.333,3),(1017,7561079,7561060,'273',3.333,3),(1017,7561080,7561060,'730',3.333,3),(1017,7561081,7561060,'308',3.333,3),(1017,7561082,7561060,'08e',3.333,3),(1017,7561083,7561060,'8e2',3.333,3),(1017,7561084,7561060,'e2e',3.333,3),(1017,7561085,7561060,'2ee',3.333,3),(1017,7561086,7561060,'ee1',3.333,3),(1017,7561087,7561060,'e10',3.333,3),(1017,7561088,7561060,'10b',3.333,3),(1017,7561089,7561060,'0b4',3.333,3),(1017,7561090,7561060,'b49',3.333,3),(1017,7561091,7561061,'mon',100,1),(1017,7561092,7561091,'201',50,1),(1017,7561093,7561091,'013',50,1),(1017,7561094,7561092,'adm',33.333,4),(1017,7561095,7561092,'dmi',33.333,4),(1017,7561096,7561092,'min',33.333,4),(1017,7561097,7561094,'cap',16.667,1),(1017,7561098,7561094,'apa',16.667,1),(1017,7561099,7561094,'pac',16.667,1),(1017,7561100,7561094,'aci',16.667,1),(1017,7561101,7561094,'cit',16.667,1),(1017,7561102,7561094,'ity',16.667,1),(1017,7561103,7561097,'pat',50,1),(1017,7561104,7561097,'ath',50,1),(1017,7561105,7561103,'fre',14.286,1),(1017,7561106,7561103,'ree',14.286,1),(1017,7561107,7561103,'ees',14.286,1),(1017,7561108,7561103,'esp',14.286,1),(1017,7561109,7561103,'spa',14.286,1),(1017,7561110,7561103,'pac',14.286,1),(1017,7561111,7561103,'ace',14.286,1),(1017,7561112,7561105,'dis',50,1),(1017,7561113,7561105,'isk',50,1),(1017,7561114,7561112,'ind',33.333,1),(1017,7561115,7561112,'nde',33.333,1),(1017,7561116,7561112,'dex',33.333,1),(1017,7561117,7561114,'adm',8.333,1),(1017,7561118,7561114,'dmi',8.333,1),(1017,7561119,7561114,'min',8.333,1),(1017,7561120,7561114,'ini',8.333,1),(1017,7561121,7561114,'nis',8.333,1),(1017,7561122,7561114,'ist',8.333,1),(1017,7561123,7561114,'str',8.333,1),(1017,7561124,7561114,'tra',8.333,1),(1017,7561125,7561114,'rat',8.333,1),(1017,7561126,7561114,'ati',8.333,1),(1017,7561127,7561114,'tio',8.333,1),(1017,7561128,7561114,'ion',8.333,1),(1017,7561129,7561117,'sta',33.333,3),(1017,7561130,7561117,'tat',33.333,3),(1017,7561131,7561117,'ate',33.333,3),(1017,7561132,7561129,'dis',16.667,4),(1017,7561133,7561129,'isa',16.667,4),(1017,7561134,7561129,'sab',16.667,4),(1017,7561135,7561129,'abl',16.667,4),(1017,7561136,7561129,'ble',16.667,4),(1017,7561137,7561129,'led',16.667,4),(1017,7561138,7561132,'cac',33.333,1),(1017,7561139,7561132,'ach',33.333,1),(1017,7561140,7561132,'che',33.333,1),(1017,7561141,7561138,'mod',50,1),(1017,7561142,7561138,'ode',50,1),(1017,7561143,7561141,'wri',14.286,1),(1017,7561144,7561141,'rit',14.286,1),(1017,7561145,7561141,'ite',14.286,1),(1017,7561146,7561141,'tet',14.286,1),(1017,7561147,7561141,'eth',14.286,1),(1017,7561148,7561141,'thr',14.286,1),(1017,7561149,7561141,'hru',14.286,1),(1017,7561150,7561143,'ope',11.111,2),(1017,7561151,7561143,'per',11.111,2),(1017,7561152,7561143,'era',11.111,2),(1017,7561153,7561143,'rat',11.111,2),(1017,7561154,7561143,'ati',11.111,2),(1017,7561155,7561143,'tio',11.111,2),(1017,7561156,7561143,'ion',11.111,2),(1017,7561157,7561143,'ona',11.111,2),(1017,7561158,7561143,'nal',11.111,2),(1017,7561159,7561150,'mes',20,1),(1017,7561160,7561150,'ess',20,1),(1017,7561161,7561150,'ssa',20,1),(1017,7561162,7561150,'sag',20,1),(1017,7561163,7561150,'age',20,1),(1017,7561164,7561159,'per',11.111,1),(1017,7561165,7561159,'erf',11.111,1),(1017,7561166,7561159,'rfo',11.111,1),(1017,7561167,7561159,'for',11.111,1),(1017,7561168,7561159,'orm',11.111,1),(1017,7561169,7561159,'rma',11.111,1),(1017,7561170,7561159,'man',11.111,1),(1017,7561171,7561159,'anc',11.111,1),(1017,7561172,7561159,'nce',11.111,1),(1017,7561173,7561164,'ide',12.5,1),(1017,7561174,7561164,'den',12.5,1),(1017,7561175,7561164,'ent',12.5,1),(1017,7561176,7561164,'nti',12.5,1),(1017,7561177,7561164,'tif',12.5,1),(1017,7561178,7561164,'ifi',12.5,1),(1017,7561179,7561164,'fie',12.5,1),(1017,7561180,7561164,'ier',12.5,1),(1017,7561181,7561173,'vdi',33.333,3),(1017,7561182,7561173,'dis',33.333,3),(1017,7561183,7561173,'isk',33.333,3),(1017,7561184,7561181,'nam',50,1),(1017,7561185,7561181,'ame',50,1),(1017,7561186,7561184,'typ',50,1),(1017,7561187,7561184,'ype',50,1),(1017,7561188,7561186,'dir',25,1),(1017,7561189,7561186,'ire',25,1),(1017,7561190,7561186,'rec',25,1),(1017,7561191,7561186,'ect',25,1),(1018,7561193,7561192,'naa',100,2),(1018,7561194,7561193,'600',3.333,3),(1018,7561195,7561193,'000',3.333,3),(1018,7561196,7561193,'00c',3.333,3),(1018,7561197,7561193,'0c2',3.333,3),(1018,7561198,7561193,'c29',3.333,3),(1018,7561199,7561193,'298',3.333,3),(1018,7561200,7561193,'983',3.333,3),(1018,7561201,7561193,'831',3.333,3),(1018,7561202,7561193,'314',3.333,3),(1018,7561203,7561193,'147',3.333,3),(1018,7561204,7561193,'477',3.333,3),(1018,7561205,7561193,'774',3.333,3),(1018,7561206,7561193,'745',3.333,3),(1018,7561207,7561193,'456',3.333,3),(1018,7561208,7561193,'567',3.333,3),(1018,7561209,7561193,'676',3.333,3),(1018,7561210,7561193,'763',3.333,3),(1018,7561211,7561193,'630',3.333,3),(1018,7561212,7561193,'306',3.333,3),(1018,7561213,7561193,'061',3.333,3),(1018,7561214,7561193,'61d',3.333,3),(1018,7561215,7561193,'1d4',3.333,3),(1018,7561216,7561193,'d44',3.333,3),(1018,7561217,7561193,'440',3.333,3),(1018,7561218,7561193,'40a',3.333,3),(1018,7561219,7561193,'0aa',3.333,3),(1018,7561220,7561193,'aa4',3.333,3),(1018,7561221,7561193,'a48',3.333,3),(1018,7561222,7561193,'480',3.333,3),(1018,7561223,7561193,'800',3.333,3),(1018,7561224,7561194,'mon',100,1),(1018,7561225,7561224,'201',50,1),(1018,7561226,7561224,'013',50,1),(1018,7561227,7561225,'adm',33.333,4),(1018,7561228,7561225,'dmi',33.333,4),(1018,7561229,7561225,'min',33.333,4),(1018,7561230,7561227,'cap',16.667,1),(1018,7561231,7561227,'apa',16.667,1),(1018,7561232,7561227,'pac',16.667,1),(1018,7561233,7561227,'aci',16.667,1),(1018,7561234,7561227,'cit',16.667,1),(1018,7561235,7561227,'ity',16.667,1),(1018,7561236,7561230,'pat',50,1),(1018,7561237,7561230,'ath',50,1),(1018,7561238,7561236,'fre',14.286,1),(1018,7561239,7561236,'ree',14.286,1),(1018,7561240,7561236,'ees',14.286,1),(1018,7561241,7561236,'esp',14.286,1),(1018,7561242,7561236,'spa',14.286,1),(1018,7561243,7561236,'pac',14.286,1),(1018,7561244,7561236,'ace',14.286,1),(1018,7561245,7561238,'dis',50,1),(1018,7561246,7561238,'isk',50,1),(1018,7561247,7561245,'ind',33.333,1),(1018,7561248,7561245,'nde',33.333,1),(1018,7561249,7561245,'dex',33.333,1),(1018,7561250,7561247,'adm',8.333,1),(1018,7561251,7561247,'dmi',8.333,1),(1018,7561252,7561247,'min',8.333,1),(1018,7561253,7561247,'ini',8.333,1),(1018,7561254,7561247,'nis',8.333,1),(1018,7561255,7561247,'ist',8.333,1),(1018,7561256,7561247,'str',8.333,1),(1018,7561257,7561247,'tra',8.333,1),(1018,7561258,7561247,'rat',8.333,1),(1018,7561259,7561247,'ati',8.333,1),(1018,7561260,7561247,'tio',8.333,1),(1018,7561261,7561247,'ion',8.333,1),(1018,7561262,7561250,'sta',33.333,3),(1018,7561263,7561250,'tat',33.333,3),(1018,7561264,7561250,'ate',33.333,3),(1018,7561265,7561262,'dis',16.667,4),(1018,7561266,7561262,'isa',16.667,4),(1018,7561267,7561262,'sab',16.667,4),(1018,7561268,7561262,'abl',16.667,4),(1018,7561269,7561262,'ble',16.667,4),(1018,7561270,7561262,'led',16.667,4),(1018,7561271,7561265,'cac',33.333,1),(1018,7561272,7561265,'ach',33.333,1),(1018,7561273,7561265,'che',33.333,1),(1018,7561274,7561271,'mod',50,1),(1018,7561275,7561271,'ode',50,1),(1018,7561276,7561274,'wri',14.286,1),(1018,7561277,7561274,'rit',14.286,1),(1018,7561278,7561274,'ite',14.286,1),(1018,7561279,7561274,'tet',14.286,1),(1018,7561280,7561274,'eth',14.286,1),(1018,7561281,7561274,'thr',14.286,1),(1018,7561282,7561274,'hru',14.286,1),(1018,7561283,7561276,'ope',11.111,2),(1018,7561284,7561276,'per',11.111,2),(1018,7561285,7561276,'era',11.111,2),(1018,7561286,7561276,'rat',11.111,2),(1018,7561287,7561276,'ati',11.111,2),(1018,7561288,7561276,'tio',11.111,2),(1018,7561289,7561276,'ion',11.111,2),(1018,7561290,7561276,'ona',11.111,2),(1018,7561291,7561276,'nal',11.111,2),(1018,7561292,7561283,'mes',20,1),(1018,7561293,7561283,'ess',20,1),(1018,7561294,7561283,'ssa',20,1),(1018,7561295,7561283,'sag',20,1),(1018,7561296,7561283,'age',20,1),(1018,7561297,7561292,'per',11.111,1),(1018,7561298,7561292,'erf',11.111,1),(1018,7561299,7561292,'rfo',11.111,1),(1018,7561300,7561292,'for',11.111,1),(1018,7561301,7561292,'orm',11.111,1),(1018,7561302,7561292,'rma',11.111,1),(1018,7561303,7561292,'man',11.111,1),(1018,7561304,7561292,'anc',11.111,1),(1018,7561305,7561292,'nce',11.111,1),(1018,7561306,7561297,'ide',12.5,1),(1018,7561307,7561297,'den',12.5,1),(1018,7561308,7561297,'ent',12.5,1),(1018,7561309,7561297,'nti',12.5,1),(1018,7561310,7561297,'tif',12.5,1),(1018,7561311,7561297,'ifi',12.5,1),(1018,7561312,7561297,'fie',12.5,1),(1018,7561313,7561297,'ier',12.5,1),(1018,7561314,7561306,'vdi',33.333,3),(1018,7561315,7561306,'dis',33.333,3),(1018,7561316,7561306,'isk',33.333,3),(1018,7561317,7561314,'nam',50,1),(1018,7561318,7561314,'ame',50,1),(1018,7561319,7561317,'typ',50,1),(1018,7561320,7561317,'ype',50,1),(1018,7561321,7561319,'dir',25,1),(1018,7561322,7561319,'ire',25,1),(1018,7561323,7561319,'rec',25,1),(1018,7561324,7561319,'ect',25,1),(1019,7561326,7561325,'naa',100,2),(1019,7561327,7561326,'600',3.333,3),(1019,7561328,7561326,'000',3.333,3),(1019,7561329,7561326,'00c',3.333,3),(1019,7561330,7561326,'0c2',3.333,3),(1019,7561331,7561326,'c29',3.333,3),(1019,7561332,7561326,'29a',3.333,3),(1019,7561333,7561326,'9a6',3.333,3),(1019,7561334,7561326,'a61',3.333,3),(1019,7561335,7561326,'611',3.333,3),(1019,7561336,7561326,'11a',3.333,3),(1019,7561337,7561326,'1ae',3.333,3),(1019,7561338,7561326,'ae2',3.333,3),(1019,7561339,7561326,'e2f',3.333,3),(1019,7561340,7561326,'2f0',3.333,3),(1019,7561341,7561326,'f08',3.333,3),(1019,7561342,7561326,'08a',3.333,3),(1019,7561343,7561326,'8a2',3.333,3),(1019,7561344,7561326,'a24',3.333,3),(1019,7561345,7561326,'242',3.333,3),(1019,7561346,7561326,'42c',3.333,3),(1019,7561347,7561326,'2c5',3.333,3),(1019,7561348,7561326,'c59',3.333,3),(1019,7561349,7561326,'59d',3.333,3),(1019,7561350,7561326,'9d3',3.333,3),(1019,7561351,7561326,'d34',3.333,3),(1019,7561352,7561326,'344',3.333,3),(1019,7561353,7561326,'44c',3.333,3),(1019,7561354,7561326,'4c9',3.333,3),(1019,7561355,7561326,'c94',3.333,3),(1019,7561356,7561326,'941',3.333,3),(1019,7561357,7561327,'mon',100,1),(1019,7561358,7561357,'201',50,1),(1019,7561359,7561357,'013',50,1),(1019,7561360,7561358,'adm',33.333,4),(1019,7561361,7561358,'dmi',33.333,4),(1019,7561362,7561358,'min',33.333,4),(1019,7561363,7561360,'cap',16.667,1),(1019,7561364,7561360,'apa',16.667,1),(1019,7561365,7561360,'pac',16.667,1),(1019,7561366,7561360,'aci',16.667,1),(1019,7561367,7561360,'cit',16.667,1),(1019,7561368,7561360,'ity',16.667,1),(1019,7561369,7561363,'pat',50,1),(1019,7561370,7561363,'ath',50,1),(1019,7561371,7561369,'fre',14.286,1),(1019,7561372,7561369,'ree',14.286,1),(1019,7561373,7561369,'ees',14.286,1),(1019,7561374,7561369,'esp',14.286,1),(1019,7561375,7561369,'spa',14.286,1),(1019,7561376,7561369,'pac',14.286,1),(1019,7561377,7561369,'ace',14.286,1),(1019,7561378,7561371,'dis',50,1),(1019,7561379,7561371,'isk',50,1),(1019,7561380,7561378,'ind',33.333,1),(1019,7561381,7561378,'nde',33.333,1),(1019,7561382,7561378,'dex',33.333,1),(1019,7561383,7561380,'adm',8.333,1),(1019,7561384,7561380,'dmi',8.333,1),(1019,7561385,7561380,'min',8.333,1),(1019,7561386,7561380,'ini',8.333,1),(1019,7561387,7561380,'nis',8.333,1),(1019,7561388,7561380,'ist',8.333,1),(1019,7561389,7561380,'str',8.333,1),(1019,7561390,7561380,'tra',8.333,1),(1019,7561391,7561380,'rat',8.333,1),(1019,7561392,7561380,'ati',8.333,1),(1019,7561393,7561380,'tio',8.333,1),(1019,7561394,7561380,'ion',8.333,1),(1019,7561395,7561383,'sta',33.333,3),(1019,7561396,7561383,'tat',33.333,3),(1019,7561397,7561383,'ate',33.333,3),(1019,7561398,7561395,'dis',16.667,4),(1019,7561399,7561395,'isa',16.667,4),(1019,7561400,7561395,'sab',16.667,4),(1019,7561401,7561395,'abl',16.667,4),(1019,7561402,7561395,'ble',16.667,4),(1019,7561403,7561395,'led',16.667,4),(1019,7561404,7561398,'cac',33.333,1),(1019,7561405,7561398,'ach',33.333,1),(1019,7561406,7561398,'che',33.333,1),(1019,7561407,7561404,'mod',50,1),(1019,7561408,7561404,'ode',50,1),(1019,7561409,7561407,'wri',14.286,1),(1019,7561410,7561407,'rit',14.286,1),(1019,7561411,7561407,'ite',14.286,1),(1019,7561412,7561407,'tet',14.286,1),(1019,7561413,7561407,'eth',14.286,1),(1019,7561414,7561407,'thr',14.286,1),(1019,7561415,7561407,'hru',14.286,1),(1019,7561416,7561409,'ope',11.111,2),(1019,7561417,7561409,'per',11.111,2),(1019,7561418,7561409,'era',11.111,2),(1019,7561419,7561409,'rat',11.111,2),(1019,7561420,7561409,'ati',11.111,2),(1019,7561421,7561409,'tio',11.111,2),(1019,7561422,7561409,'ion',11.111,2),(1019,7561423,7561409,'ona',11.111,2),(1019,7561424,7561409,'nal',11.111,2),(1019,7561425,7561416,'mes',20,1),(1019,7561426,7561416,'ess',20,1),(1019,7561427,7561416,'ssa',20,1),(1019,7561428,7561416,'sag',20,1),(1019,7561429,7561416,'age',20,1),(1019,7561430,7561425,'per',11.111,1),(1019,7561431,7561425,'erf',11.111,1),(1019,7561432,7561425,'rfo',11.111,1),(1019,7561433,7561425,'for',11.111,1),(1019,7561434,7561425,'orm',11.111,1),(1019,7561435,7561425,'rma',11.111,1),(1019,7561436,7561425,'man',11.111,1),(1019,7561437,7561425,'anc',11.111,1),(1019,7561438,7561425,'nce',11.111,1),(1019,7561439,7561430,'ide',12.5,1),(1019,7561440,7561430,'den',12.5,1),(1019,7561441,7561430,'ent',12.5,1),(1019,7561442,7561430,'nti',12.5,1),(1019,7561443,7561430,'tif',12.5,1),(1019,7561444,7561430,'ifi',12.5,1),(1019,7561445,7561430,'fie',12.5,1),(1019,7561446,7561430,'ier',12.5,1),(1019,7561447,7561439,'vdi',33.333,3),(1019,7561448,7561439,'dis',33.333,3),(1019,7561449,7561439,'isk',33.333,3),(1019,7561450,7561447,'nam',50,1),(1019,7561451,7561447,'ame',50,1),(1019,7561452,7561450,'typ',50,1),(1019,7561453,7561450,'ype',50,1),(1019,7561454,7561452,'dir',25,1),(1019,7561455,7561452,'ire',25,1),(1019,7561456,7561452,'rec',25,1),(1019,7561457,7561452,'ect',25,1),(1020,7561459,7561458,'naa',100,2),(1020,7561460,7561459,'600',3.333,3),(1020,7561461,7561459,'000',3.333,3),(1020,7561462,7561459,'00c',3.333,3),(1020,7561463,7561459,'0c2',3.333,3),(1020,7561464,7561459,'c29',3.333,3),(1020,7561465,7561459,'297',3.333,3),(1020,7561466,7561459,'97f',3.333,3),(1020,7561467,7561459,'7f4',3.333,3),(1020,7561468,7561459,'f41',3.333,3),(1020,7561469,7561459,'410',3.333,3),(1020,7561470,7561459,'100',3.333,3),(1020,7561471,7561459,'00e',3.333,3),(1020,7561472,7561459,'0ec',3.333,3),(1020,7561473,7561459,'ecd',3.333,3),(1020,7561474,7561459,'cd6',3.333,3),(1020,7561475,7561459,'d6e',3.333,3),(1020,7561476,7561459,'6e8',3.333,3),(1020,7561477,7561459,'e8c',3.333,3),(1020,7561478,7561459,'8c8',3.333,3),(1020,7561479,7561459,'c88',3.333,3),(1020,7561480,7561459,'886',3.333,3),(1020,7561481,7561459,'861',3.333,3),(1020,7561482,7561459,'61e',3.333,3),(1020,7561483,7561459,'1e1',3.333,3),(1020,7561484,7561459,'e14',3.333,3),(1020,7561485,7561459,'142',3.333,3),(1020,7561486,7561459,'42b',3.333,3),(1020,7561487,7561459,'2b5',3.333,3),(1020,7561488,7561459,'b54',3.333,3),(1020,7561489,7561459,'540',3.333,3),(1020,7561490,7561460,'mon',100,1),(1020,7561491,7561490,'201',50,1),(1020,7561492,7561490,'013',50,1),(1020,7561493,7561491,'adm',33.333,4),(1020,7561494,7561491,'dmi',33.333,4),(1020,7561495,7561491,'min',33.333,4),(1020,7561496,7561493,'cap',16.667,1),(1020,7561497,7561493,'apa',16.667,1),(1020,7561498,7561493,'pac',16.667,1),(1020,7561499,7561493,'aci',16.667,1),(1020,7561500,7561493,'cit',16.667,1),(1020,7561501,7561493,'ity',16.667,1),(1020,7561502,7561496,'pat',50,1),(1020,7561503,7561496,'ath',50,1),(1020,7561504,7561502,'fre',14.286,1),(1020,7561505,7561502,'ree',14.286,1),(1020,7561506,7561502,'ees',14.286,1),(1020,7561507,7561502,'esp',14.286,1),(1020,7561508,7561502,'spa',14.286,1),(1020,7561509,7561502,'pac',14.286,1),(1020,7561510,7561502,'ace',14.286,1),(1020,7561511,7561504,'dis',50,1),(1020,7561512,7561504,'isk',50,1),(1020,7561513,7561511,'ind',33.333,1),(1020,7561514,7561511,'nde',33.333,1),(1020,7561515,7561511,'dex',33.333,1),(1020,7561516,7561513,'adm',8.333,1),(1020,7561517,7561513,'dmi',8.333,1),(1020,7561518,7561513,'min',8.333,1),(1020,7561519,7561513,'ini',8.333,1),(1020,7561520,7561513,'nis',8.333,1),(1020,7561521,7561513,'ist',8.333,1),(1020,7561522,7561513,'str',8.333,1),(1020,7561523,7561513,'tra',8.333,1),(1020,7561524,7561513,'rat',8.333,1),(1020,7561525,7561513,'ati',8.333,1),(1020,7561526,7561513,'tio',8.333,1),(1020,7561527,7561513,'ion',8.333,1),(1020,7561528,7561516,'sta',33.333,3),(1020,7561529,7561516,'tat',33.333,3),(1020,7561530,7561516,'ate',33.333,3),(1020,7561531,7561528,'dis',16.667,4),(1020,7561532,7561528,'isa',16.667,4),(1020,7561533,7561528,'sab',16.667,4),(1020,7561534,7561528,'abl',16.667,4),(1020,7561535,7561528,'ble',16.667,4),(1020,7561536,7561528,'led',16.667,4),(1020,7561537,7561531,'cac',33.333,1),(1020,7561538,7561531,'ach',33.333,1),(1020,7561539,7561531,'che',33.333,1),(1020,7561540,7561537,'mod',50,1),(1020,7561541,7561537,'ode',50,1),(1020,7561542,7561540,'wri',14.286,1),(1020,7561543,7561540,'rit',14.286,1),(1020,7561544,7561540,'ite',14.286,1),(1020,7561545,7561540,'tet',14.286,1),(1020,7561546,7561540,'eth',14.286,1),(1020,7561547,7561540,'thr',14.286,1),(1020,7561548,7561540,'hru',14.286,1),(1020,7561549,7561542,'ope',11.111,2),(1020,7561550,7561542,'per',11.111,2),(1020,7561551,7561542,'era',11.111,2),(1020,7561552,7561542,'rat',11.111,2),(1020,7561553,7561542,'ati',11.111,2),(1020,7561554,7561542,'tio',11.111,2),(1020,7561555,7561542,'ion',11.111,2),(1020,7561556,7561542,'ona',11.111,2),(1020,7561557,7561542,'nal',11.111,2),(1020,7561558,7561549,'mes',20,1),(1020,7561559,7561549,'ess',20,1),(1020,7561560,7561549,'ssa',20,1),(1020,7561561,7561549,'sag',20,1),(1020,7561562,7561549,'age',20,1),(1020,7561563,7561558,'per',11.111,1),(1020,7561564,7561558,'erf',11.111,1),(1020,7561565,7561558,'rfo',11.111,1),(1020,7561566,7561558,'for',11.111,1),(1020,7561567,7561558,'orm',11.111,1),(1020,7561568,7561558,'rma',11.111,1),(1020,7561569,7561558,'man',11.111,1),(1020,7561570,7561558,'anc',11.111,1),(1020,7561571,7561558,'nce',11.111,1),(1020,7561572,7561563,'ide',12.5,1),(1020,7561573,7561563,'den',12.5,1),(1020,7561574,7561563,'ent',12.5,1),(1020,7561575,7561563,'nti',12.5,1),(1020,7561576,7561563,'tif',12.5,1),(1020,7561577,7561563,'ifi',12.5,1),(1020,7561578,7561563,'fie',12.5,1),(1020,7561579,7561563,'ier',12.5,1),(1020,7561580,7561572,'vdi',33.333,3),(1020,7561581,7561572,'dis',33.333,3),(1020,7561582,7561572,'isk',33.333,3),(1020,7561583,7561580,'nam',50,1),(1020,7561584,7561580,'ame',50,1),(1020,7561585,7561583,'typ',50,1),(1020,7561586,7561583,'ype',50,1),(1020,7561587,7561585,'dir',25,1),(1020,7561588,7561585,'ire',25,1),(1020,7561589,7561585,'rec',25,1),(1020,7561590,7561585,'ect',25,1),(1021,7561592,7561591,'naa',100,2),(1021,7561593,7561592,'600',3.333,3),(1021,7561594,7561592,'000',3.333,3),(1021,7561595,7561592,'00c',3.333,3),(1021,7561596,7561592,'0c2',3.333,3),(1021,7561597,7561592,'c29',3.333,3),(1021,7561598,7561592,'29a',3.333,3),(1021,7561599,7561592,'9a9',3.333,3),(1021,7561600,7561592,'a9c',3.333,3),(1021,7561601,7561592,'9ca',3.333,3),(1021,7561602,7561592,'ca7',3.333,3),(1021,7561603,7561592,'a78',3.333,3),(1021,7561604,7561592,'783',3.333,3),(1021,7561605,7561592,'837',3.333,3),(1021,7561606,7561592,'378',3.333,3),(1021,7561607,7561592,'788',3.333,3),(1021,7561608,7561592,'883',3.333,3),(1021,7561609,7561592,'839',3.333,3),(1021,7561610,7561592,'39d',3.333,3),(1021,7561611,7561592,'9d3',3.333,3),(1021,7561612,7561592,'d38',3.333,3),(1021,7561613,7561592,'380',3.333,3),(1021,7561614,7561592,'806',3.333,3),(1021,7561615,7561592,'067',3.333,3),(1021,7561616,7561592,'673',3.333,3),(1021,7561617,7561592,'732',3.333,3),(1021,7561618,7561592,'32e',3.333,3),(1021,7561619,7561592,'2e4',3.333,3),(1021,7561620,7561592,'e42',3.333,3),(1021,7561621,7561592,'421',3.333,3),(1021,7561622,7561592,'210',3.333,3),(1021,7561623,7561593,'mon',100,1),(1021,7561624,7561623,'201',50,1),(1021,7561625,7561623,'013',50,1),(1021,7561626,7561624,'adm',33.333,4),(1021,7561627,7561624,'dmi',33.333,4),(1021,7561628,7561624,'min',33.333,4),(1021,7561629,7561626,'cap',16.667,1),(1021,7561630,7561626,'apa',16.667,1),(1021,7561631,7561626,'pac',16.667,1),(1021,7561632,7561626,'aci',16.667,1),(1021,7561633,7561626,'cit',16.667,1),(1021,7561634,7561626,'ity',16.667,1),(1021,7561635,7561629,'pat',50,1),(1021,7561636,7561629,'ath',50,1),(1021,7561637,7561635,'fre',14.286,1),(1021,7561638,7561635,'ree',14.286,1),(1021,7561639,7561635,'ees',14.286,1),(1021,7561640,7561635,'esp',14.286,1),(1021,7561641,7561635,'spa',14.286,1),(1021,7561642,7561635,'pac',14.286,1),(1021,7561643,7561635,'ace',14.286,1),(1021,7561644,7561637,'dis',50,1),(1021,7561645,7561637,'isk',50,1),(1021,7561646,7561644,'ind',33.333,1),(1021,7561647,7561644,'nde',33.333,1),(1021,7561648,7561644,'dex',33.333,1),(1021,7561649,7561646,'adm',8.333,1),(1021,7561650,7561646,'dmi',8.333,1),(1021,7561651,7561646,'min',8.333,1),(1021,7561652,7561646,'ini',8.333,1),(1021,7561653,7561646,'nis',8.333,1),(1021,7561654,7561646,'ist',8.333,1),(1021,7561655,7561646,'str',8.333,1),(1021,7561656,7561646,'tra',8.333,1),(1021,7561657,7561646,'rat',8.333,1),(1021,7561658,7561646,'ati',8.333,1),(1021,7561659,7561646,'tio',8.333,1),(1021,7561660,7561646,'ion',8.333,1),(1021,7561661,7561649,'sta',33.333,3),(1021,7561662,7561649,'tat',33.333,3),(1021,7561663,7561649,'ate',33.333,3),(1021,7561664,7561661,'dis',16.667,4),(1021,7561665,7561661,'isa',16.667,4),(1021,7561666,7561661,'sab',16.667,4),(1021,7561667,7561661,'abl',16.667,4),(1021,7561668,7561661,'ble',16.667,4),(1021,7561669,7561661,'led',16.667,4),(1021,7561670,7561664,'cac',33.333,1),(1021,7561671,7561664,'ach',33.333,1),(1021,7561672,7561664,'che',33.333,1),(1021,7561673,7561670,'mod',50,1),(1021,7561674,7561670,'ode',50,1),(1021,7561675,7561673,'wri',14.286,1),(1021,7561676,7561673,'rit',14.286,1),(1021,7561677,7561673,'ite',14.286,1),(1021,7561678,7561673,'tet',14.286,1),(1021,7561679,7561673,'eth',14.286,1),(1021,7561680,7561673,'thr',14.286,1),(1021,7561681,7561673,'hru',14.286,1),(1021,7561682,7561675,'ope',11.111,2),(1021,7561683,7561675,'per',11.111,2),(1021,7561684,7561675,'era',11.111,2),(1021,7561685,7561675,'rat',11.111,2),(1021,7561686,7561675,'ati',11.111,2),(1021,7561687,7561675,'tio',11.111,2),(1021,7561688,7561675,'ion',11.111,2),(1021,7561689,7561675,'ona',11.111,2),(1021,7561690,7561675,'nal',11.111,2),(1021,7561691,7561682,'mes',20,1),(1021,7561692,7561682,'ess',20,1),(1021,7561693,7561682,'ssa',20,1),(1021,7561694,7561682,'sag',20,1),(1021,7561695,7561682,'age',20,1),(1021,7561696,7561691,'per',11.111,1),(1021,7561697,7561691,'erf',11.111,1),(1021,7561698,7561691,'rfo',11.111,1),(1021,7561699,7561691,'for',11.111,1),(1021,7561700,7561691,'orm',11.111,1),(1021,7561701,7561691,'rma',11.111,1),(1021,7561702,7561691,'man',11.111,1),(1021,7561703,7561691,'anc',11.111,1),(1021,7561704,7561691,'nce',11.111,1),(1021,7561705,7561696,'ide',12.5,1),(1021,7561706,7561696,'den',12.5,1),(1021,7561707,7561696,'ent',12.5,1),(1021,7561708,7561696,'nti',12.5,1),(1021,7561709,7561696,'tif',12.5,1),(1021,7561710,7561696,'ifi',12.5,1),(1021,7561711,7561696,'fie',12.5,1),(1021,7561712,7561696,'ier',12.5,1),(1021,7561713,7561705,'vdi',33.333,3),(1021,7561714,7561705,'dis',33.333,3),(1021,7561715,7561705,'isk',33.333,3),(1021,7561716,7561713,'nam',50,1),(1021,7561717,7561713,'ame',50,1),(1021,7561718,7561716,'typ',50,1),(1021,7561719,7561716,'ype',50,1),(1021,7561720,7561718,'dir',25,1),(1021,7561721,7561718,'ire',25,1),(1021,7561722,7561718,'rec',25,1),(1021,7561723,7561718,'ect',25,1),(1022,7561725,7561724,'naa',100,2),(1022,7561726,7561725,'600',3.333,3),(1022,7561727,7561725,'000',3.333,3),(1022,7561728,7561725,'00c',3.333,3),(1022,7561729,7561725,'0c2',3.333,3),(1022,7561730,7561725,'c29',3.333,3),(1022,7561731,7561725,'292',3.333,3),(1022,7561732,7561725,'921',3.333,3),(1022,7561733,7561725,'210',3.333,3),(1022,7561734,7561725,'106',3.333,3),(1022,7561735,7561725,'06f',3.333,3),(1022,7561736,7561725,'6fe',3.333,3),(1022,7561737,7561725,'fe1',3.333,3),(1022,7561738,7561725,'e1c',3.333,3),(1022,7561739,7561725,'1c3',3.333,3),(1022,7561740,7561725,'c33',3.333,3),(1022,7561741,7561725,'334',3.333,3),(1022,7561742,7561725,'34a',3.333,3),(1022,7561743,7561725,'4a8',3.333,3),(1022,7561744,7561725,'a87',3.333,3),(1022,7561745,7561725,'87f',3.333,3),(1022,7561746,7561725,'7fd',3.333,3),(1022,7561747,7561725,'fd0',3.333,3),(1022,7561748,7561725,'d02',3.333,3),(1022,7561749,7561725,'021',3.333,3),(1022,7561750,7561725,'212',3.333,3),(1022,7561751,7561725,'125',3.333,3),(1022,7561752,7561725,'257',3.333,3),(1022,7561753,7561725,'57c',3.333,3),(1022,7561754,7561725,'7cc',3.333,3),(1022,7561755,7561725,'cc1',3.333,3),(1022,7561756,7561726,'mon',100,1),(1022,7561757,7561756,'201',50,1),(1022,7561758,7561756,'013',50,1),(1022,7561759,7561757,'adm',33.333,4),(1022,7561760,7561757,'dmi',33.333,4),(1022,7561761,7561757,'min',33.333,4),(1022,7561762,7561759,'cap',16.667,1),(1022,7561763,7561759,'apa',16.667,1),(1022,7561764,7561759,'pac',16.667,1),(1022,7561765,7561759,'aci',16.667,1),(1022,7561766,7561759,'cit',16.667,1),(1022,7561767,7561759,'ity',16.667,1),(1022,7561768,7561762,'pat',50,1),(1022,7561769,7561762,'ath',50,1),(1022,7561770,7561768,'fre',14.286,1),(1022,7561771,7561768,'ree',14.286,1),(1022,7561772,7561768,'ees',14.286,1),(1022,7561773,7561768,'esp',14.286,1),(1022,7561774,7561768,'spa',14.286,1),(1022,7561775,7561768,'pac',14.286,1),(1022,7561776,7561768,'ace',14.286,1),(1022,7561777,7561770,'dis',50,1),(1022,7561778,7561770,'isk',50,1),(1022,7561779,7561777,'ind',33.333,1),(1022,7561780,7561777,'nde',33.333,1),(1022,7561781,7561777,'dex',33.333,1),(1022,7561782,7561779,'adm',8.333,1),(1022,7561783,7561779,'dmi',8.333,1),(1022,7561784,7561779,'min',8.333,1),(1022,7561785,7561779,'ini',8.333,1),(1022,7561786,7561779,'nis',8.333,1),(1022,7561787,7561779,'ist',8.333,1),(1022,7561788,7561779,'str',8.333,1),(1022,7561789,7561779,'tra',8.333,1),(1022,7561790,7561779,'rat',8.333,1),(1022,7561791,7561779,'ati',8.333,1),(1022,7561792,7561779,'tio',8.333,1),(1022,7561793,7561779,'ion',8.333,1),(1022,7561794,7561782,'sta',33.333,3),(1022,7561795,7561782,'tat',33.333,3),(1022,7561796,7561782,'ate',33.333,3),(1022,7561797,7561794,'dis',16.667,4),(1022,7561798,7561794,'isa',16.667,4),(1022,7561799,7561794,'sab',16.667,4),(1022,7561800,7561794,'abl',16.667,4),(1022,7561801,7561794,'ble',16.667,4),(1022,7561802,7561794,'led',16.667,4),(1022,7561803,7561797,'cac',33.333,1),(1022,7561804,7561797,'ach',33.333,1),(1022,7561805,7561797,'che',33.333,1),(1022,7561806,7561803,'mod',50,1),(1022,7561807,7561803,'ode',50,1),(1022,7561808,7561806,'wri',14.286,1),(1022,7561809,7561806,'rit',14.286,1),(1022,7561810,7561806,'ite',14.286,1),(1022,7561811,7561806,'tet',14.286,1),(1022,7561812,7561806,'eth',14.286,1),(1022,7561813,7561806,'thr',14.286,1),(1022,7561814,7561806,'hru',14.286,1),(1022,7561815,7561808,'ope',11.111,2),(1022,7561816,7561808,'per',11.111,2),(1022,7561817,7561808,'era',11.111,2),(1022,7561818,7561808,'rat',11.111,2),(1022,7561819,7561808,'ati',11.111,2),(1022,7561820,7561808,'tio',11.111,2),(1022,7561821,7561808,'ion',11.111,2),(1022,7561822,7561808,'ona',11.111,2),(1022,7561823,7561808,'nal',11.111,2),(1022,7561824,7561815,'mes',20,1),(1022,7561825,7561815,'ess',20,1),(1022,7561826,7561815,'ssa',20,1),(1022,7561827,7561815,'sag',20,1),(1022,7561828,7561815,'age',20,1),(1022,7561829,7561824,'per',11.111,1),(1022,7561830,7561824,'erf',11.111,1),(1022,7561831,7561824,'rfo',11.111,1),(1022,7561832,7561824,'for',11.111,1),(1022,7561833,7561824,'orm',11.111,1),(1022,7561834,7561824,'rma',11.111,1),(1022,7561835,7561824,'man',11.111,1),(1022,7561836,7561824,'anc',11.111,1),(1022,7561837,7561824,'nce',11.111,1),(1022,7561838,7561829,'ide',12.5,1),(1022,7561839,7561829,'den',12.5,1),(1022,7561840,7561829,'ent',12.5,1),(1022,7561841,7561829,'nti',12.5,1),(1022,7561842,7561829,'tif',12.5,1),(1022,7561843,7561829,'ifi',12.5,1),(1022,7561844,7561829,'fie',12.5,1),(1022,7561845,7561829,'ier',12.5,1),(1022,7561846,7561838,'vdi',33.333,3),(1022,7561847,7561838,'dis',33.333,3),(1022,7561848,7561838,'isk',33.333,3),(1022,7561849,7561846,'nam',50,1),(1022,7561850,7561846,'ame',50,1),(1022,7561851,7561849,'typ',50,1),(1022,7561852,7561849,'ype',50,1),(1022,7561853,7561851,'dir',25,1),(1022,7561854,7561851,'ire',25,1),(1022,7561855,7561851,'rec',25,1),(1022,7561856,7561851,'ect',25,1),(1023,7561858,7561857,'naa',100,2),(1023,7561859,7561858,'600',3.333,3),(1023,7561860,7561858,'000',3.333,3),(1023,7561861,7561858,'00c',3.333,3),(1023,7561862,7561858,'0c2',3.333,3),(1023,7561863,7561858,'c29',3.333,3),(1023,7561864,7561858,'29a',3.333,3),(1023,7561865,7561858,'9aa',3.333,3),(1023,7561866,7561858,'aad',3.333,3),(1023,7561867,7561858,'adf',3.333,3),(1023,7561868,7561858,'dfb',3.333,3),(1023,7561869,7561858,'fb7',3.333,3),(1023,7561870,7561858,'b7e',3.333,3),(1023,7561871,7561858,'7e3',3.333,3),(1023,7561872,7561858,'e3a',3.333,3),(1023,7561873,7561858,'3a9',3.333,3),(1023,7561874,7561858,'a99',3.333,3),(1023,7561875,7561858,'998',3.333,3),(1023,7561876,7561858,'98a',3.333,3),(1023,7561877,7561858,'8a3',3.333,3),(1023,7561878,7561858,'a3b',3.333,3),(1023,7561879,7561858,'3b3',3.333,3),(1023,7561880,7561858,'b3c',3.333,3),(1023,7561881,7561858,'3c5',3.333,3),(1023,7561882,7561858,'c55',3.333,3),(1023,7561883,7561858,'554',3.333,3),(1023,7561884,7561858,'542',3.333,3),(1023,7561885,7561858,'425',3.333,3),(1023,7561886,7561858,'253',3.333,3),(1023,7561887,7561858,'533',3.333,3),(1023,7561888,7561858,'333',3.333,3),(1023,7561889,7561859,'mon',100,1),(1023,7561890,7561889,'201',50,1),(1023,7561891,7561889,'013',50,1),(1023,7561892,7561890,'adm',33.333,4),(1023,7561893,7561890,'dmi',33.333,4),(1023,7561894,7561890,'min',33.333,4),(1023,7561895,7561892,'cap',16.667,1),(1023,7561896,7561892,'apa',16.667,1),(1023,7561897,7561892,'pac',16.667,1),(1023,7561898,7561892,'aci',16.667,1),(1023,7561899,7561892,'cit',16.667,1),(1023,7561900,7561892,'ity',16.667,1),(1023,7561901,7561895,'pat',50,1),(1023,7561902,7561895,'ath',50,1),(1023,7561903,7561901,'fre',14.286,1),(1023,7561904,7561901,'ree',14.286,1),(1023,7561905,7561901,'ees',14.286,1),(1023,7561906,7561901,'esp',14.286,1),(1023,7561907,7561901,'spa',14.286,1),(1023,7561908,7561901,'pac',14.286,1),(1023,7561909,7561901,'ace',14.286,1),(1023,7561910,7561903,'dis',50,1),(1023,7561911,7561903,'isk',50,1),(1023,7561912,7561910,'ind',33.333,1),(1023,7561913,7561910,'nde',33.333,1),(1023,7561914,7561910,'dex',33.333,1),(1023,7561915,7561912,'adm',8.333,1),(1023,7561916,7561912,'dmi',8.333,1),(1023,7561917,7561912,'min',8.333,1),(1023,7561918,7561912,'ini',8.333,1),(1023,7561919,7561912,'nis',8.333,1),(1023,7561920,7561912,'ist',8.333,1),(1023,7561921,7561912,'str',8.333,1),(1023,7561922,7561912,'tra',8.333,1),(1023,7561923,7561912,'rat',8.333,1),(1023,7561924,7561912,'ati',8.333,1),(1023,7561925,7561912,'tio',8.333,1),(1023,7561926,7561912,'ion',8.333,1),(1023,7561927,7561915,'sta',33.333,3),(1023,7561928,7561915,'tat',33.333,3),(1023,7561929,7561915,'ate',33.333,3),(1023,7561930,7561927,'dis',16.667,4),(1023,7561931,7561927,'isa',16.667,4),(1023,7561932,7561927,'sab',16.667,4),(1023,7561933,7561927,'abl',16.667,4),(1023,7561934,7561927,'ble',16.667,4),(1023,7561935,7561927,'led',16.667,4),(1023,7561936,7561930,'cac',33.333,1),(1023,7561937,7561930,'ach',33.333,1),(1023,7561938,7561930,'che',33.333,1),(1023,7561939,7561936,'mod',50,1),(1023,7561940,7561936,'ode',50,1),(1023,7561941,7561939,'wri',14.286,1),(1023,7561942,7561939,'rit',14.286,1),(1023,7561943,7561939,'ite',14.286,1),(1023,7561944,7561939,'tet',14.286,1),(1023,7561945,7561939,'eth',14.286,1),(1023,7561946,7561939,'thr',14.286,1),(1023,7561947,7561939,'hru',14.286,1),(1023,7561948,7561941,'ope',11.111,2),(1023,7561949,7561941,'per',11.111,2),(1023,7561950,7561941,'era',11.111,2),(1023,7561951,7561941,'rat',11.111,2),(1023,7561952,7561941,'ati',11.111,2),(1023,7561953,7561941,'tio',11.111,2),(1023,7561954,7561941,'ion',11.111,2),(1023,7561955,7561941,'ona',11.111,2),(1023,7561956,7561941,'nal',11.111,2),(1023,7561957,7561948,'mes',20,1),(1023,7561958,7561948,'ess',20,1),(1023,7561959,7561948,'ssa',20,1),(1023,7561960,7561948,'sag',20,1),(1023,7561961,7561948,'age',20,1),(1023,7561962,7561957,'per',11.111,1),(1023,7561963,7561957,'erf',11.111,1),(1023,7561964,7561957,'rfo',11.111,1),(1023,7561965,7561957,'for',11.111,1),(1023,7561966,7561957,'orm',11.111,1),(1023,7561967,7561957,'rma',11.111,1),(1023,7561968,7561957,'man',11.111,1),(1023,7561969,7561957,'anc',11.111,1),(1023,7561970,7561957,'nce',11.111,1),(1023,7561971,7561962,'ide',12.5,1),(1023,7561972,7561962,'den',12.5,1),(1023,7561973,7561962,'ent',12.5,1),(1023,7561974,7561962,'nti',12.5,1),(1023,7561975,7561962,'tif',12.5,1),(1023,7561976,7561962,'ifi',12.5,1),(1023,7561977,7561962,'fie',12.5,1),(1023,7561978,7561962,'ier',12.5,1),(1023,7561979,7561971,'vdi',33.333,3),(1023,7561980,7561971,'dis',33.333,3),(1023,7561981,7561971,'isk',33.333,3),(1023,7561982,7561979,'nam',50,1),(1023,7561983,7561979,'ame',50,1),(1023,7561984,7561982,'typ',50,1),(1023,7561985,7561982,'ype',50,1),(1023,7561986,7561984,'dir',25,1),(1023,7561987,7561984,'ire',25,1),(1023,7561988,7561984,'rec',25,1),(1023,7561989,7561984,'ect',25,1),(1024,7561991,7561990,'naa',100,2),(1024,7561992,7561991,'600',3.333,3),(1024,7561993,7561991,'000',3.333,3),(1024,7561994,7561991,'00c',3.333,3),(1024,7561995,7561991,'0c2',3.333,3),(1024,7561996,7561991,'c29',3.333,3),(1024,7561997,7561991,'290',3.333,3),(1024,7561998,7561991,'906',3.333,3),(1024,7561999,7561991,'060',3.333,3),(1024,7562000,7561991,'609',3.333,3),(1024,7562001,7561991,'092',3.333,3),(1024,7562002,7561991,'921',3.333,3),(1024,7562003,7561991,'211',3.333,3),(1024,7562004,7561991,'11d',3.333,3),(1024,7562005,7561991,'1d9',3.333,3),(1024,7562006,7561991,'d94',3.333,3),(1024,7562007,7561991,'948',3.333,3),(1024,7562008,7561991,'480',3.333,3),(1024,7562009,7561991,'80e',3.333,3),(1024,7562010,7561991,'0e1',3.333,3),(1024,7562011,7561991,'e19',3.333,3),(1024,7562012,7561991,'192',3.333,3),(1024,7562013,7561991,'920',3.333,3),(1024,7562014,7561991,'20c',3.333,3),(1024,7562015,7561991,'0ce',3.333,3),(1024,7562016,7561991,'ce8',3.333,3),(1024,7562017,7561991,'e8d',3.333,3),(1024,7562018,7561991,'8dc',3.333,3),(1024,7562019,7561991,'dce',3.333,3),(1024,7562020,7561991,'cea',3.333,3),(1024,7562021,7561991,'ea3',3.333,3),(1024,7562022,7561992,'mon',100,1),(1024,7562023,7562022,'201',50,1),(1024,7562024,7562022,'013',50,1),(1024,7562025,7562023,'adm',33.333,4),(1024,7562026,7562023,'dmi',33.333,4),(1024,7562027,7562023,'min',33.333,4),(1024,7562028,7562025,'cap',16.667,1),(1024,7562029,7562025,'apa',16.667,1),(1024,7562030,7562025,'pac',16.667,1),(1024,7562031,7562025,'aci',16.667,1),(1024,7562032,7562025,'cit',16.667,1),(1024,7562033,7562025,'ity',16.667,1),(1024,7562034,7562028,'pat',50,1),(1024,7562035,7562028,'ath',50,1),(1024,7562036,7562034,'fre',14.286,1),(1024,7562037,7562034,'ree',14.286,1),(1024,7562038,7562034,'ees',14.286,1),(1024,7562039,7562034,'esp',14.286,1),(1024,7562040,7562034,'spa',14.286,1),(1024,7562041,7562034,'pac',14.286,1),(1024,7562042,7562034,'ace',14.286,1),(1024,7562043,7562036,'dis',50,1),(1024,7562044,7562036,'isk',50,1),(1024,7562045,7562043,'ind',33.333,1),(1024,7562046,7562043,'nde',33.333,1),(1024,7562047,7562043,'dex',33.333,1),(1024,7562048,7562045,'adm',8.333,1),(1024,7562049,7562045,'dmi',8.333,1),(1024,7562050,7562045,'min',8.333,1),(1024,7562051,7562045,'ini',8.333,1),(1024,7562052,7562045,'nis',8.333,1),(1024,7562053,7562045,'ist',8.333,1),(1024,7562054,7562045,'str',8.333,1),(1024,7562055,7562045,'tra',8.333,1),(1024,7562056,7562045,'rat',8.333,1),(1024,7562057,7562045,'ati',8.333,1),(1024,7562058,7562045,'tio',8.333,1),(1024,7562059,7562045,'ion',8.333,1),(1024,7562060,7562048,'sta',33.333,3),(1024,7562061,7562048,'tat',33.333,3),(1024,7562062,7562048,'ate',33.333,3),(1024,7562063,7562060,'dis',16.667,4),(1024,7562064,7562060,'isa',16.667,4),(1024,7562065,7562060,'sab',16.667,4),(1024,7562066,7562060,'abl',16.667,4),(1024,7562067,7562060,'ble',16.667,4),(1024,7562068,7562060,'led',16.667,4),(1024,7562069,7562063,'cac',33.333,1),(1024,7562070,7562063,'ach',33.333,1),(1024,7562071,7562063,'che',33.333,1),(1024,7562072,7562069,'mod',50,1),(1024,7562073,7562069,'ode',50,1),(1024,7562074,7562072,'wri',14.286,1),(1024,7562075,7562072,'rit',14.286,1),(1024,7562076,7562072,'ite',14.286,1),(1024,7562077,7562072,'tet',14.286,1),(1024,7562078,7562072,'eth',14.286,1),(1024,7562079,7562072,'thr',14.286,1),(1024,7562080,7562072,'hru',14.286,1),(1024,7562081,7562074,'ope',11.111,2),(1024,7562082,7562074,'per',11.111,2),(1024,7562083,7562074,'era',11.111,2),(1024,7562084,7562074,'rat',11.111,2),(1024,7562085,7562074,'ati',11.111,2),(1024,7562086,7562074,'tio',11.111,2),(1024,7562087,7562074,'ion',11.111,2),(1024,7562088,7562074,'ona',11.111,2),(1024,7562089,7562074,'nal',11.111,2),(1024,7562090,7562081,'mes',20,1),(1024,7562091,7562081,'ess',20,1),(1024,7562092,7562081,'ssa',20,1),(1024,7562093,7562081,'sag',20,1),(1024,7562094,7562081,'age',20,1),(1024,7562095,7562090,'per',11.111,1),(1024,7562096,7562090,'erf',11.111,1),(1024,7562097,7562090,'rfo',11.111,1),(1024,7562098,7562090,'for',11.111,1),(1024,7562099,7562090,'orm',11.111,1),(1024,7562100,7562090,'rma',11.111,1),(1024,7562101,7562090,'man',11.111,1),(1024,7562102,7562090,'anc',11.111,1),(1024,7562103,7562090,'nce',11.111,1),(1024,7562104,7562095,'ide',12.5,1),(1024,7562105,7562095,'den',12.5,1),(1024,7562106,7562095,'ent',12.5,1),(1024,7562107,7562095,'nti',12.5,1),(1024,7562108,7562095,'tif',12.5,1),(1024,7562109,7562095,'ifi',12.5,1),(1024,7562110,7562095,'fie',12.5,1),(1024,7562111,7562095,'ier',12.5,1),(1024,7562112,7562104,'vdi',33.333,3),(1024,7562113,7562104,'dis',33.333,3),(1024,7562114,7562104,'isk',33.333,3),(1024,7562115,7562112,'nam',50,1),(1024,7562116,7562112,'ame',50,1),(1024,7562117,7562115,'typ',50,1),(1024,7562118,7562115,'ype',50,1),(1024,7562119,7562117,'dir',25,1),(1024,7562120,7562117,'ire',25,1),(1024,7562121,7562117,'rec',25,1),(1024,7562122,7562117,'ect',25,1),(1025,7562124,7562123,'naa',100,2),(1025,7562125,7562124,'600',3.333,3),(1025,7562126,7562124,'000',3.333,3),(1025,7562127,7562124,'00c',3.333,3),(1025,7562128,7562124,'0c2',3.333,3),(1025,7562129,7562124,'c29',3.333,3),(1025,7562130,7562124,'298',3.333,3),(1025,7562131,7562124,'98e',3.333,3),(1025,7562132,7562124,'8e6',3.333,3),(1025,7562133,7562124,'e64',3.333,3),(1025,7562134,7562124,'643',3.333,3),(1025,7562135,7562124,'433',3.333,3),(1025,7562136,7562124,'339',3.333,3),(1025,7562137,7562124,'394',3.333,3),(1025,7562138,7562124,'946',3.333,3),(1025,7562139,7562124,'46c',3.333,3),(1025,7562140,7562124,'6c5',3.333,3),(1025,7562141,7562124,'c5a',3.333,3),(1025,7562142,7562124,'5a2',3.333,3),(1025,7562143,7562124,'a2c',3.333,3),(1025,7562144,7562124,'2cb',3.333,3),(1025,7562145,7562124,'cb1',3.333,3),(1025,7562146,7562124,'b12',3.333,3),(1025,7562147,7562124,'125',3.333,3),(1025,7562148,7562124,'25f',3.333,3),(1025,7562149,7562124,'5f8',3.333,3),(1025,7562150,7562124,'f87',3.333,3),(1025,7562151,7562124,'87b',3.333,3),(1025,7562152,7562124,'7bf',3.333,3),(1025,7562153,7562124,'bf0',3.333,3),(1025,7562154,7562124,'f0b',3.333,3),(1025,7562155,7562125,'mon',100,1),(1025,7562156,7562155,'201',50,1),(1025,7562157,7562155,'013',50,1),(1025,7562158,7562156,'adm',33.333,4),(1025,7562159,7562156,'dmi',33.333,4),(1025,7562160,7562156,'min',33.333,4),(1025,7562161,7562158,'cap',16.667,1),(1025,7562162,7562158,'apa',16.667,1),(1025,7562163,7562158,'pac',16.667,1),(1025,7562164,7562158,'aci',16.667,1),(1025,7562165,7562158,'cit',16.667,1),(1025,7562166,7562158,'ity',16.667,1),(1025,7562167,7562161,'pat',50,1),(1025,7562168,7562161,'ath',50,1),(1025,7562169,7562167,'fre',14.286,1),(1025,7562170,7562167,'ree',14.286,1),(1025,7562171,7562167,'ees',14.286,1),(1025,7562172,7562167,'esp',14.286,1),(1025,7562173,7562167,'spa',14.286,1),(1025,7562174,7562167,'pac',14.286,1),(1025,7562175,7562167,'ace',14.286,1),(1025,7562176,7562169,'dis',50,1),(1025,7562177,7562169,'isk',50,1),(1025,7562178,7562176,'ind',33.333,1),(1025,7562179,7562176,'nde',33.333,1),(1025,7562180,7562176,'dex',33.333,1),(1025,7562181,7562178,'adm',8.333,1),(1025,7562182,7562178,'dmi',8.333,1),(1025,7562183,7562178,'min',8.333,1),(1025,7562184,7562178,'ini',8.333,1),(1025,7562185,7562178,'nis',8.333,1),(1025,7562186,7562178,'ist',8.333,1),(1025,7562187,7562178,'str',8.333,1),(1025,7562188,7562178,'tra',8.333,1),(1025,7562189,7562178,'rat',8.333,1),(1025,7562190,7562178,'ati',8.333,1),(1025,7562191,7562178,'tio',8.333,1),(1025,7562192,7562178,'ion',8.333,1),(1025,7562193,7562181,'sta',33.333,3),(1025,7562194,7562181,'tat',33.333,3),(1025,7562195,7562181,'ate',33.333,3),(1025,7562196,7562193,'dis',16.667,4),(1025,7562197,7562193,'isa',16.667,4),(1025,7562198,7562193,'sab',16.667,4),(1025,7562199,7562193,'abl',16.667,4),(1025,7562200,7562193,'ble',16.667,4),(1025,7562201,7562193,'led',16.667,4),(1025,7562202,7562196,'cac',33.333,1),(1025,7562203,7562196,'ach',33.333,1),(1025,7562204,7562196,'che',33.333,1),(1025,7562205,7562202,'mod',50,1),(1025,7562206,7562202,'ode',50,1),(1025,7562207,7562205,'wri',14.286,1),(1025,7562208,7562205,'rit',14.286,1),(1025,7562209,7562205,'ite',14.286,1),(1025,7562210,7562205,'tet',14.286,1),(1025,7562211,7562205,'eth',14.286,1),(1025,7562212,7562205,'thr',14.286,1),(1025,7562213,7562205,'hru',14.286,1),(1025,7562214,7562207,'ope',11.111,2),(1025,7562215,7562207,'per',11.111,2),(1025,7562216,7562207,'era',11.111,2),(1025,7562217,7562207,'rat',11.111,2),(1025,7562218,7562207,'ati',11.111,2),(1025,7562219,7562207,'tio',11.111,2),(1025,7562220,7562207,'ion',11.111,2),(1025,7562221,7562207,'ona',11.111,2),(1025,7562222,7562207,'nal',11.111,2),(1025,7562223,7562214,'mes',20,1),(1025,7562224,7562214,'ess',20,1),(1025,7562225,7562214,'ssa',20,1),(1025,7562226,7562214,'sag',20,1),(1025,7562227,7562214,'age',20,1),(1025,7562228,7562223,'per',11.111,1),(1025,7562229,7562223,'erf',11.111,1),(1025,7562230,7562223,'rfo',11.111,1),(1025,7562231,7562223,'for',11.111,1),(1025,7562232,7562223,'orm',11.111,1),(1025,7562233,7562223,'rma',11.111,1),(1025,7562234,7562223,'man',11.111,1),(1025,7562235,7562223,'anc',11.111,1),(1025,7562236,7562223,'nce',11.111,1),(1025,7562237,7562228,'ide',12.5,1),(1025,7562238,7562228,'den',12.5,1),(1025,7562239,7562228,'ent',12.5,1),(1025,7562240,7562228,'nti',12.5,1),(1025,7562241,7562228,'tif',12.5,1),(1025,7562242,7562228,'ifi',12.5,1),(1025,7562243,7562228,'fie',12.5,1),(1025,7562244,7562228,'ier',12.5,1),(1025,7562245,7562237,'vdi',33.333,3),(1025,7562246,7562237,'dis',33.333,3),(1025,7562247,7562237,'isk',33.333,3),(1025,7562248,7562245,'nam',50,1),(1025,7562249,7562245,'ame',50,1),(1025,7562250,7562248,'typ',50,1),(1025,7562251,7562248,'ype',50,1),(1025,7562252,7562250,'dir',25,1),(1025,7562253,7562250,'ire',25,1),(1025,7562254,7562250,'rec',25,1),(1025,7562255,7562250,'ect',25,1),(1026,7562257,7562256,'naa',100,2),(1026,7562258,7562257,'600',3.333,3),(1026,7562259,7562257,'000',3.333,3),(1026,7562260,7562257,'00c',3.333,3),(1026,7562261,7562257,'0c2',3.333,3),(1026,7562262,7562257,'c29',3.333,3),(1026,7562263,7562257,'298',3.333,3),(1026,7562264,7562257,'98f',3.333,3),(1026,7562265,7562257,'8fa',3.333,3),(1026,7562266,7562257,'fa1',3.333,3),(1026,7562267,7562257,'a1b',3.333,3),(1026,7562268,7562257,'1b1',3.333,3),(1026,7562269,7562257,'b1b',3.333,3),(1026,7562270,7562257,'1b9',3.333,3),(1026,7562271,7562257,'b96',3.333,3),(1026,7562272,7562257,'969',3.333,3),(1026,7562273,7562257,'697',3.333,3),(1026,7562274,7562257,'976',3.333,3),(1026,7562275,7562257,'763',3.333,3),(1026,7562276,7562257,'63f',3.333,3),(1026,7562277,7562257,'3f6',3.333,3),(1026,7562278,7562257,'f64',3.333,3),(1026,7562279,7562257,'64c',3.333,3),(1026,7562280,7562257,'4c1',3.333,3),(1026,7562281,7562257,'c1a',3.333,3),(1026,7562282,7562257,'1a4',3.333,3),(1026,7562283,7562257,'a48',3.333,3),(1026,7562284,7562257,'488',3.333,3),(1026,7562285,7562257,'884',3.333,3),(1026,7562286,7562257,'846',3.333,3),(1026,7562287,7562257,'466',3.333,3),(1026,7562288,7562258,'mon',100,1),(1026,7562289,7562288,'201',50,1),(1026,7562290,7562288,'013',50,1),(1026,7562291,7562289,'adm',33.333,4),(1026,7562292,7562289,'dmi',33.333,4),(1026,7562293,7562289,'min',33.333,4),(1026,7562294,7562291,'cap',16.667,1),(1026,7562295,7562291,'apa',16.667,1),(1026,7562296,7562291,'pac',16.667,1),(1026,7562297,7562291,'aci',16.667,1),(1026,7562298,7562291,'cit',16.667,1),(1026,7562299,7562291,'ity',16.667,1),(1026,7562300,7562294,'pat',50,1),(1026,7562301,7562294,'ath',50,1),(1026,7562302,7562300,'fre',14.286,1),(1026,7562303,7562300,'ree',14.286,1),(1026,7562304,7562300,'ees',14.286,1),(1026,7562305,7562300,'esp',14.286,1),(1026,7562306,7562300,'spa',14.286,1),(1026,7562307,7562300,'pac',14.286,1),(1026,7562308,7562300,'ace',14.286,1),(1026,7562309,7562302,'dis',50,1),(1026,7562310,7562302,'isk',50,1),(1026,7562311,7562309,'ind',33.333,1),(1026,7562312,7562309,'nde',33.333,1),(1026,7562313,7562309,'dex',33.333,1),(1026,7562314,7562311,'adm',8.333,1),(1026,7562315,7562311,'dmi',8.333,1),(1026,7562316,7562311,'min',8.333,1),(1026,7562317,7562311,'ini',8.333,1),(1026,7562318,7562311,'nis',8.333,1),(1026,7562319,7562311,'ist',8.333,1),(1026,7562320,7562311,'str',8.333,1),(1026,7562321,7562311,'tra',8.333,1),(1026,7562322,7562311,'rat',8.333,1),(1026,7562323,7562311,'ati',8.333,1),(1026,7562324,7562311,'tio',8.333,1),(1026,7562325,7562311,'ion',8.333,1),(1026,7562326,7562314,'sta',33.333,3),(1026,7562327,7562314,'tat',33.333,3),(1026,7562328,7562314,'ate',33.333,3),(1026,7562329,7562326,'dis',16.667,4),(1026,7562330,7562326,'isa',16.667,4),(1026,7562331,7562326,'sab',16.667,4),(1026,7562332,7562326,'abl',16.667,4),(1026,7562333,7562326,'ble',16.667,4),(1026,7562334,7562326,'led',16.667,4),(1026,7562335,7562329,'cac',33.333,1),(1026,7562336,7562329,'ach',33.333,1),(1026,7562337,7562329,'che',33.333,1),(1026,7562338,7562335,'mod',50,1),(1026,7562339,7562335,'ode',50,1),(1026,7562340,7562338,'wri',14.286,1),(1026,7562341,7562338,'rit',14.286,1),(1026,7562342,7562338,'ite',14.286,1),(1026,7562343,7562338,'tet',14.286,1),(1026,7562344,7562338,'eth',14.286,1),(1026,7562345,7562338,'thr',14.286,1),(1026,7562346,7562338,'hru',14.286,1),(1026,7562347,7562340,'ope',11.111,2),(1026,7562348,7562340,'per',11.111,2),(1026,7562349,7562340,'era',11.111,2),(1026,7562350,7562340,'rat',11.111,2),(1026,7562351,7562340,'ati',11.111,2),(1026,7562352,7562340,'tio',11.111,2),(1026,7562353,7562340,'ion',11.111,2),(1026,7562354,7562340,'ona',11.111,2),(1026,7562355,7562340,'nal',11.111,2),(1026,7562356,7562347,'mes',20,1),(1026,7562357,7562347,'ess',20,1),(1026,7562358,7562347,'ssa',20,1),(1026,7562359,7562347,'sag',20,1),(1026,7562360,7562347,'age',20,1),(1026,7562361,7562356,'per',11.111,1),(1026,7562362,7562356,'erf',11.111,1),(1026,7562363,7562356,'rfo',11.111,1),(1026,7562364,7562356,'for',11.111,1),(1026,7562365,7562356,'orm',11.111,1),(1026,7562366,7562356,'rma',11.111,1),(1026,7562367,7562356,'man',11.111,1),(1026,7562368,7562356,'anc',11.111,1),(1026,7562369,7562356,'nce',11.111,1),(1026,7562370,7562361,'ide',12.5,1),(1026,7562371,7562361,'den',12.5,1),(1026,7562372,7562361,'ent',12.5,1),(1026,7562373,7562361,'nti',12.5,1),(1026,7562374,7562361,'tif',12.5,1),(1026,7562375,7562361,'ifi',12.5,1),(1026,7562376,7562361,'fie',12.5,1),(1026,7562377,7562361,'ier',12.5,1),(1026,7562378,7562370,'vdi',33.333,3),(1026,7562379,7562370,'dis',33.333,3),(1026,7562380,7562370,'isk',33.333,3),(1026,7562381,7562378,'nam',50,1),(1026,7562382,7562378,'ame',50,1),(1026,7562383,7562381,'typ',50,1),(1026,7562384,7562381,'ype',50,1),(1026,7562385,7562383,'dir',25,1),(1026,7562386,7562383,'ire',25,1),(1026,7562387,7562383,'rec',25,1),(1026,7562388,7562383,'ect',25,1),(1027,7562390,7562389,'naa',100,2),(1027,7562391,7562390,'600',3.333,3),(1027,7562392,7562390,'000',3.333,3),(1027,7562393,7562390,'00c',3.333,3),(1027,7562394,7562390,'0c2',3.333,3),(1027,7562395,7562390,'c29',3.333,3),(1027,7562396,7562390,'298',3.333,3),(1027,7562397,7562390,'987',3.333,3),(1027,7562398,7562390,'878',3.333,3),(1027,7562399,7562390,'787',3.333,3),(1027,7562400,7562390,'871',3.333,3),(1027,7562401,7562390,'715',3.333,3),(1027,7562402,7562390,'155',3.333,3),(1027,7562403,7562390,'553',3.333,3),(1027,7562404,7562390,'531',3.333,3),(1027,7562405,7562390,'312',3.333,3),(1027,7562406,7562390,'125',3.333,3),(1027,7562407,7562390,'256',3.333,3),(1027,7562408,7562390,'569',3.333,3),(1027,7562409,7562390,'691',3.333,3),(1027,7562410,7562390,'914',3.333,3),(1027,7562411,7562390,'14e',3.333,3),(1027,7562412,7562390,'4ee',3.333,3),(1027,7562413,7562390,'ee8',3.333,3),(1027,7562414,7562390,'e85',3.333,3),(1027,7562415,7562390,'856',3.333,3),(1027,7562416,7562390,'567',3.333,3),(1027,7562417,7562390,'67d',3.333,3),(1027,7562418,7562390,'7d0',3.333,3),(1027,7562419,7562390,'d02',3.333,3),(1027,7562420,7562390,'029',3.333,3),(1027,7562421,7562391,'mon',100,1),(1027,7562422,7562421,'201',50,1),(1027,7562423,7562421,'013',50,1),(1027,7562424,7562422,'adm',33.333,4),(1027,7562425,7562422,'dmi',33.333,4),(1027,7562426,7562422,'min',33.333,4),(1027,7562427,7562424,'cap',16.667,1),(1027,7562428,7562424,'apa',16.667,1),(1027,7562429,7562424,'pac',16.667,1),(1027,7562430,7562424,'aci',16.667,1),(1027,7562431,7562424,'cit',16.667,1),(1027,7562432,7562424,'ity',16.667,1),(1027,7562433,7562427,'pat',50,1),(1027,7562434,7562427,'ath',50,1),(1027,7562435,7562433,'fre',14.286,1),(1027,7562436,7562433,'ree',14.286,1),(1027,7562437,7562433,'ees',14.286,1),(1027,7562438,7562433,'esp',14.286,1),(1027,7562439,7562433,'spa',14.286,1),(1027,7562440,7562433,'pac',14.286,1),(1027,7562441,7562433,'ace',14.286,1),(1027,7562442,7562435,'dis',50,1),(1027,7562443,7562435,'isk',50,1),(1027,7562444,7562442,'ind',33.333,1),(1027,7562445,7562442,'nde',33.333,1),(1027,7562446,7562442,'dex',33.333,1),(1027,7562447,7562444,'adm',8.333,1),(1027,7562448,7562444,'dmi',8.333,1),(1027,7562449,7562444,'min',8.333,1),(1027,7562450,7562444,'ini',8.333,1),(1027,7562451,7562444,'nis',8.333,1),(1027,7562452,7562444,'ist',8.333,1),(1027,7562453,7562444,'str',8.333,1),(1027,7562454,7562444,'tra',8.333,1),(1027,7562455,7562444,'rat',8.333,1),(1027,7562456,7562444,'ati',8.333,1),(1027,7562457,7562444,'tio',8.333,1),(1027,7562458,7562444,'ion',8.333,1),(1027,7562459,7562447,'sta',33.333,3),(1027,7562460,7562447,'tat',33.333,3),(1027,7562461,7562447,'ate',33.333,3),(1027,7562462,7562459,'dis',16.667,4),(1027,7562463,7562459,'isa',16.667,4),(1027,7562464,7562459,'sab',16.667,4),(1027,7562465,7562459,'abl',16.667,4),(1027,7562466,7562459,'ble',16.667,4),(1027,7562467,7562459,'led',16.667,4),(1027,7562468,7562462,'cac',33.333,1),(1027,7562469,7562462,'ach',33.333,1),(1027,7562470,7562462,'che',33.333,1),(1027,7562471,7562468,'mod',50,1),(1027,7562472,7562468,'ode',50,1),(1027,7562473,7562471,'wri',14.286,1),(1027,7562474,7562471,'rit',14.286,1),(1027,7562475,7562471,'ite',14.286,1),(1027,7562476,7562471,'tet',14.286,1),(1027,7562477,7562471,'eth',14.286,1),(1027,7562478,7562471,'thr',14.286,1),(1027,7562479,7562471,'hru',14.286,1),(1027,7562480,7562473,'ope',11.111,2),(1027,7562481,7562473,'per',11.111,2),(1027,7562482,7562473,'era',11.111,2),(1027,7562483,7562473,'rat',11.111,2),(1027,7562484,7562473,'ati',11.111,2),(1027,7562485,7562473,'tio',11.111,2),(1027,7562486,7562473,'ion',11.111,2),(1027,7562487,7562473,'ona',11.111,2),(1027,7562488,7562473,'nal',11.111,2),(1027,7562489,7562480,'mes',20,1),(1027,7562490,7562480,'ess',20,1),(1027,7562491,7562480,'ssa',20,1),(1027,7562492,7562480,'sag',20,1),(1027,7562493,7562480,'age',20,1),(1027,7562494,7562489,'per',11.111,1),(1027,7562495,7562489,'erf',11.111,1),(1027,7562496,7562489,'rfo',11.111,1),(1027,7562497,7562489,'for',11.111,1),(1027,7562498,7562489,'orm',11.111,1),(1027,7562499,7562489,'rma',11.111,1),(1027,7562500,7562489,'man',11.111,1),(1027,7562501,7562489,'anc',11.111,1),(1027,7562502,7562489,'nce',11.111,1),(1027,7562503,7562494,'ide',12.5,1),(1027,7562504,7562494,'den',12.5,1),(1027,7562505,7562494,'ent',12.5,1),(1027,7562506,7562494,'nti',12.5,1),(1027,7562507,7562494,'tif',12.5,1),(1027,7562508,7562494,'ifi',12.5,1),(1027,7562509,7562494,'fie',12.5,1),(1027,7562510,7562494,'ier',12.5,1),(1027,7562511,7562503,'vdi',33.333,3),(1027,7562512,7562503,'dis',33.333,3),(1027,7562513,7562503,'isk',33.333,3),(1027,7562514,7562511,'nam',50,1),(1027,7562515,7562511,'ame',50,1),(1027,7562516,7562514,'typ',50,1),(1027,7562517,7562514,'ype',50,1),(1027,7562518,7562516,'dir',25,1),(1027,7562519,7562516,'ire',25,1),(1027,7562520,7562516,'rec',25,1),(1027,7562521,7562516,'ect',25,1),(1028,7562523,7562522,'naa',100,2),(1028,7562524,7562523,'600',3.333,3),(1028,7562525,7562523,'000',3.333,3),(1028,7562526,7562523,'00c',3.333,3),(1028,7562527,7562523,'0c2',3.333,3),(1028,7562528,7562523,'c29',3.333,3),(1028,7562529,7562523,'294',3.333,3),(1028,7562530,7562523,'941',3.333,3),(1028,7562531,7562523,'413',3.333,3),(1028,7562532,7562523,'13d',3.333,3),(1028,7562533,7562523,'3d8',3.333,3),(1028,7562534,7562523,'d80',3.333,3),(1028,7562535,7562523,'80e',3.333,3),(1028,7562536,7562523,'0e2',3.333,3),(1028,7562537,7562523,'e2b',3.333,3),(1028,7562538,7562523,'2b9',3.333,3),(1028,7562539,7562523,'b91',3.333,3),(1028,7562540,7562523,'918',3.333,3),(1028,7562541,7562523,'18f',3.333,3),(1028,7562542,7562523,'8f0',3.333,3),(1028,7562543,7562523,'f00',3.333,3),(1028,7562544,7562523,'009',3.333,3),(1028,7562545,7562523,'09e',3.333,3),(1028,7562546,7562523,'9ef',3.333,3),(1028,7562547,7562523,'ef2',3.333,3),(1028,7562548,7562523,'f22',3.333,3),(1028,7562549,7562523,'225',3.333,3),(1028,7562550,7562523,'254',3.333,3),(1028,7562551,7562523,'547',3.333,3),(1028,7562552,7562523,'479',3.333,3),(1028,7562553,7562523,'798',3.333,3),(1028,7562554,7562524,'mon',100,1),(1028,7562555,7562554,'201',50,1),(1028,7562556,7562554,'013',50,1),(1028,7562557,7562555,'adm',33.333,4),(1028,7562558,7562555,'dmi',33.333,4),(1028,7562559,7562555,'min',33.333,4),(1028,7562560,7562557,'cap',16.667,1),(1028,7562561,7562557,'apa',16.667,1),(1028,7562562,7562557,'pac',16.667,1),(1028,7562563,7562557,'aci',16.667,1),(1028,7562564,7562557,'cit',16.667,1),(1028,7562565,7562557,'ity',16.667,1),(1028,7562566,7562560,'pat',50,1),(1028,7562567,7562560,'ath',50,1),(1028,7562568,7562566,'fre',14.286,1),(1028,7562569,7562566,'ree',14.286,1),(1028,7562570,7562566,'ees',14.286,1),(1028,7562571,7562566,'esp',14.286,1),(1028,7562572,7562566,'spa',14.286,1),(1028,7562573,7562566,'pac',14.286,1),(1028,7562574,7562566,'ace',14.286,1),(1028,7562575,7562568,'dis',50,1),(1028,7562576,7562568,'isk',50,1),(1028,7562577,7562575,'ind',33.333,1),(1028,7562578,7562575,'nde',33.333,1),(1028,7562579,7562575,'dex',33.333,1),(1028,7562580,7562577,'adm',8.333,1),(1028,7562581,7562577,'dmi',8.333,1),(1028,7562582,7562577,'min',8.333,1),(1028,7562583,7562577,'ini',8.333,1),(1028,7562584,7562577,'nis',8.333,1),(1028,7562585,7562577,'ist',8.333,1),(1028,7562586,7562577,'str',8.333,1),(1028,7562587,7562577,'tra',8.333,1),(1028,7562588,7562577,'rat',8.333,1),(1028,7562589,7562577,'ati',8.333,1),(1028,7562590,7562577,'tio',8.333,1),(1028,7562591,7562577,'ion',8.333,1),(1028,7562592,7562580,'sta',33.333,3),(1028,7562593,7562580,'tat',33.333,3),(1028,7562594,7562580,'ate',33.333,3),(1028,7562595,7562592,'dis',16.667,4),(1028,7562596,7562592,'isa',16.667,4),(1028,7562597,7562592,'sab',16.667,4),(1028,7562598,7562592,'abl',16.667,4),(1028,7562599,7562592,'ble',16.667,4),(1028,7562600,7562592,'led',16.667,4),(1028,7562601,7562595,'cac',33.333,1),(1028,7562602,7562595,'ach',33.333,1),(1028,7562603,7562595,'che',33.333,1),(1028,7562604,7562601,'mod',50,1),(1028,7562605,7562601,'ode',50,1),(1028,7562606,7562604,'wri',14.286,1),(1028,7562607,7562604,'rit',14.286,1),(1028,7562608,7562604,'ite',14.286,1),(1028,7562609,7562604,'tet',14.286,1),(1028,7562610,7562604,'eth',14.286,1),(1028,7562611,7562604,'thr',14.286,1),(1028,7562612,7562604,'hru',14.286,1),(1028,7562613,7562606,'ope',11.111,2),(1028,7562614,7562606,'per',11.111,2),(1028,7562615,7562606,'era',11.111,2),(1028,7562616,7562606,'rat',11.111,2),(1028,7562617,7562606,'ati',11.111,2),(1028,7562618,7562606,'tio',11.111,2),(1028,7562619,7562606,'ion',11.111,2),(1028,7562620,7562606,'ona',11.111,2),(1028,7562621,7562606,'nal',11.111,2),(1028,7562622,7562613,'mes',20,1),(1028,7562623,7562613,'ess',20,1),(1028,7562624,7562613,'ssa',20,1),(1028,7562625,7562613,'sag',20,1),(1028,7562626,7562613,'age',20,1),(1028,7562627,7562622,'per',11.111,1),(1028,7562628,7562622,'erf',11.111,1),(1028,7562629,7562622,'rfo',11.111,1),(1028,7562630,7562622,'for',11.111,1),(1028,7562631,7562622,'orm',11.111,1),(1028,7562632,7562622,'rma',11.111,1),(1028,7562633,7562622,'man',11.111,1),(1028,7562634,7562622,'anc',11.111,1),(1028,7562635,7562622,'nce',11.111,1),(1028,7562636,7562627,'ide',12.5,1),(1028,7562637,7562627,'den',12.5,1),(1028,7562638,7562627,'ent',12.5,1),(1028,7562639,7562627,'nti',12.5,1),(1028,7562640,7562627,'tif',12.5,1),(1028,7562641,7562627,'ifi',12.5,1),(1028,7562642,7562627,'fie',12.5,1),(1028,7562643,7562627,'ier',12.5,1),(1028,7562644,7562636,'vdi',33.333,3),(1028,7562645,7562636,'dis',33.333,3),(1028,7562646,7562636,'isk',33.333,3),(1028,7562647,7562644,'nam',50,1),(1028,7562648,7562644,'ame',50,1),(1028,7562649,7562647,'typ',50,1),(1028,7562650,7562647,'ype',50,1),(1028,7562651,7562649,'dir',25,1),(1028,7562652,7562649,'ire',25,1),(1028,7562653,7562649,'rec',25,1),(1028,7562654,7562649,'ect',25,1),(1029,7562656,7562655,'naa',100,2),(1029,7562657,7562656,'600',3.333,3),(1029,7562658,7562656,'000',3.333,3),(1029,7562659,7562656,'00c',3.333,3),(1029,7562660,7562656,'0c2',3.333,3),(1029,7562661,7562656,'c29',3.333,3),(1029,7562662,7562656,'297',3.333,3),(1029,7562663,7562656,'972',3.333,3),(1029,7562664,7562656,'727',3.333,3),(1029,7562665,7562656,'27f',3.333,3),(1029,7562666,7562656,'7fa',3.333,3),(1029,7562667,7562656,'fa8',3.333,3),(1029,7562668,7562656,'a8a',3.333,3),(1029,7562669,7562656,'8a7',3.333,3),(1029,7562670,7562656,'a7a',3.333,3),(1029,7562671,7562656,'7a5',3.333,3),(1029,7562672,7562656,'a51',3.333,3),(1029,7562673,7562656,'518',3.333,3),(1029,7562674,7562656,'18c',3.333,3),(1029,7562675,7562656,'8cf',3.333,3),(1029,7562676,7562656,'cf3',3.333,3),(1029,7562677,7562656,'f37',3.333,3),(1029,7562678,7562656,'37d',3.333,3),(1029,7562679,7562656,'7dd',3.333,3),(1029,7562680,7562656,'ddd',3.333,3),(1029,7562681,7562656,'ddd',3.333,3),(1029,7562682,7562656,'ddf',3.333,3),(1029,7562683,7562656,'dfe',3.333,3),(1029,7562684,7562656,'fe0',3.333,3),(1029,7562685,7562656,'e0d',3.333,3),(1029,7562686,7562656,'0db',3.333,3),(1029,7562687,7562657,'mon',100,1),(1029,7562688,7562687,'201',50,1),(1029,7562689,7562687,'013',50,1),(1029,7562690,7562688,'adm',33.333,4),(1029,7562691,7562688,'dmi',33.333,4),(1029,7562692,7562688,'min',33.333,4),(1029,7562693,7562690,'cap',16.667,1),(1029,7562694,7562690,'apa',16.667,1),(1029,7562695,7562690,'pac',16.667,1),(1029,7562696,7562690,'aci',16.667,1),(1029,7562697,7562690,'cit',16.667,1),(1029,7562698,7562690,'ity',16.667,1),(1029,7562699,7562693,'pat',50,1),(1029,7562700,7562693,'ath',50,1),(1029,7562701,7562699,'fre',14.286,1),(1029,7562702,7562699,'ree',14.286,1),(1029,7562703,7562699,'ees',14.286,1),(1029,7562704,7562699,'esp',14.286,1),(1029,7562705,7562699,'spa',14.286,1),(1029,7562706,7562699,'pac',14.286,1),(1029,7562707,7562699,'ace',14.286,1),(1029,7562708,7562701,'dis',50,1),(1029,7562709,7562701,'isk',50,1),(1029,7562710,7562708,'ind',33.333,1),(1029,7562711,7562708,'nde',33.333,1),(1029,7562712,7562708,'dex',33.333,1),(1029,7562713,7562710,'adm',8.333,1),(1029,7562714,7562710,'dmi',8.333,1),(1029,7562715,7562710,'min',8.333,1),(1029,7562716,7562710,'ini',8.333,1),(1029,7562717,7562710,'nis',8.333,1),(1029,7562718,7562710,'ist',8.333,1),(1029,7562719,7562710,'str',8.333,1),(1029,7562720,7562710,'tra',8.333,1),(1029,7562721,7562710,'rat',8.333,1),(1029,7562722,7562710,'ati',8.333,1),(1029,7562723,7562710,'tio',8.333,1),(1029,7562724,7562710,'ion',8.333,1),(1029,7562725,7562713,'sta',33.333,3),(1029,7562726,7562713,'tat',33.333,3),(1029,7562727,7562713,'ate',33.333,3),(1029,7562728,7562725,'dis',16.667,4),(1029,7562729,7562725,'isa',16.667,4),(1029,7562730,7562725,'sab',16.667,4),(1029,7562731,7562725,'abl',16.667,4),(1029,7562732,7562725,'ble',16.667,4),(1029,7562733,7562725,'led',16.667,4),(1029,7562734,7562728,'cac',33.333,1),(1029,7562735,7562728,'ach',33.333,1),(1029,7562736,7562728,'che',33.333,1),(1029,7562737,7562734,'mod',50,1),(1029,7562738,7562734,'ode',50,1),(1029,7562739,7562737,'wri',14.286,1),(1029,7562740,7562737,'rit',14.286,1),(1029,7562741,7562737,'ite',14.286,1),(1029,7562742,7562737,'tet',14.286,1),(1029,7562743,7562737,'eth',14.286,1),(1029,7562744,7562737,'thr',14.286,1),(1029,7562745,7562737,'hru',14.286,1),(1029,7562746,7562739,'ope',11.111,2),(1029,7562747,7562739,'per',11.111,2),(1029,7562748,7562739,'era',11.111,2),(1029,7562749,7562739,'rat',11.111,2),(1029,7562750,7562739,'ati',11.111,2),(1029,7562751,7562739,'tio',11.111,2),(1029,7562752,7562739,'ion',11.111,2),(1029,7562753,7562739,'ona',11.111,2),(1029,7562754,7562739,'nal',11.111,2),(1029,7562755,7562746,'mes',20,1),(1029,7562756,7562746,'ess',20,1),(1029,7562757,7562746,'ssa',20,1),(1029,7562758,7562746,'sag',20,1),(1029,7562759,7562746,'age',20,1),(1029,7562760,7562755,'per',11.111,1),(1029,7562761,7562755,'erf',11.111,1),(1029,7562762,7562755,'rfo',11.111,1),(1029,7562763,7562755,'for',11.111,1),(1029,7562764,7562755,'orm',11.111,1),(1029,7562765,7562755,'rma',11.111,1),(1029,7562766,7562755,'man',11.111,1),(1029,7562767,7562755,'anc',11.111,1),(1029,7562768,7562755,'nce',11.111,1),(1029,7562769,7562760,'ide',12.5,1),(1029,7562770,7562760,'den',12.5,1),(1029,7562771,7562760,'ent',12.5,1),(1029,7562772,7562760,'nti',12.5,1),(1029,7562773,7562760,'tif',12.5,1),(1029,7562774,7562760,'ifi',12.5,1),(1029,7562775,7562760,'fie',12.5,1),(1029,7562776,7562760,'ier',12.5,1),(1029,7562777,7562769,'vdi',33.333,3),(1029,7562778,7562769,'dis',33.333,3),(1029,7562779,7562769,'isk',33.333,3),(1029,7562780,7562777,'nam',50,1),(1029,7562781,7562777,'ame',50,1),(1029,7562782,7562780,'typ',50,1),(1029,7562783,7562780,'ype',50,1),(1029,7562784,7562782,'dir',25,1),(1029,7562785,7562782,'ire',25,1),(1029,7562786,7562782,'rec',25,1),(1029,7562787,7562782,'ect',25,1),(1030,7562789,7562788,'naa',100,2),(1030,7562790,7562789,'600',3.333,3),(1030,7562791,7562789,'000',3.333,3),(1030,7562792,7562789,'00c',3.333,3),(1030,7562793,7562789,'0c2',3.333,3),(1030,7562794,7562789,'c29',3.333,3),(1030,7562795,7562789,'29c',3.333,3),(1030,7562796,7562789,'9c0',3.333,3),(1030,7562797,7562789,'c0b',3.333,3),(1030,7562798,7562789,'0b8',3.333,3),(1030,7562799,7562789,'b8b',3.333,3),(1030,7562800,7562789,'8bd',3.333,3),(1030,7562801,7562789,'bdf',3.333,3),(1030,7562802,7562789,'df9',3.333,3),(1030,7562803,7562789,'f97',3.333,3),(1030,7562804,7562789,'974',3.333,3),(1030,7562805,7562789,'747',3.333,3),(1030,7562806,7562789,'47f',3.333,3),(1030,7562807,7562789,'7ff',3.333,3),(1030,7562808,7562789,'ff9',3.333,3),(1030,7562809,7562789,'f9e',3.333,3),(1030,7562810,7562789,'9e0',3.333,3),(1030,7562811,7562789,'e03',3.333,3),(1030,7562812,7562789,'035',3.333,3),(1030,7562813,7562789,'350',3.333,3),(1030,7562814,7562789,'502',3.333,3),(1030,7562815,7562789,'02c',3.333,3),(1030,7562816,7562789,'2c8',3.333,3),(1030,7562817,7562789,'c89',3.333,3),(1030,7562818,7562789,'890',3.333,3),(1030,7562819,7562789,'903',3.333,3),(1030,7562820,7562790,'mon',100,1),(1030,7562821,7562820,'201',50,1),(1030,7562822,7562820,'013',50,1),(1030,7562823,7562821,'adm',33.333,4),(1030,7562824,7562821,'dmi',33.333,4),(1030,7562825,7562821,'min',33.333,4),(1030,7562826,7562823,'cap',16.667,1),(1030,7562827,7562823,'apa',16.667,1),(1030,7562828,7562823,'pac',16.667,1),(1030,7562829,7562823,'aci',16.667,1),(1030,7562830,7562823,'cit',16.667,1),(1030,7562831,7562823,'ity',16.667,1),(1030,7562832,7562826,'pat',50,1),(1030,7562833,7562826,'ath',50,1),(1030,7562834,7562832,'fre',14.286,1),(1030,7562835,7562832,'ree',14.286,1),(1030,7562836,7562832,'ees',14.286,1),(1030,7562837,7562832,'esp',14.286,1),(1030,7562838,7562832,'spa',14.286,1),(1030,7562839,7562832,'pac',14.286,1),(1030,7562840,7562832,'ace',14.286,1),(1030,7562841,7562834,'dis',50,1),(1030,7562842,7562834,'isk',50,1),(1030,7562843,7562841,'ind',33.333,1),(1030,7562844,7562841,'nde',33.333,1),(1030,7562845,7562841,'dex',33.333,1),(1030,7562846,7562843,'adm',8.333,1),(1030,7562847,7562843,'dmi',8.333,1),(1030,7562848,7562843,'min',8.333,1),(1030,7562849,7562843,'ini',8.333,1),(1030,7562850,7562843,'nis',8.333,1),(1030,7562851,7562843,'ist',8.333,1),(1030,7562852,7562843,'str',8.333,1),(1030,7562853,7562843,'tra',8.333,1),(1030,7562854,7562843,'rat',8.333,1),(1030,7562855,7562843,'ati',8.333,1),(1030,7562856,7562843,'tio',8.333,1),(1030,7562857,7562843,'ion',8.333,1),(1030,7562858,7562846,'sta',33.333,3),(1030,7562859,7562846,'tat',33.333,3),(1030,7562860,7562846,'ate',33.333,3),(1030,7562861,7562858,'dis',16.667,4),(1030,7562862,7562858,'isa',16.667,4),(1030,7562863,7562858,'sab',16.667,4),(1030,7562864,7562858,'abl',16.667,4),(1030,7562865,7562858,'ble',16.667,4),(1030,7562866,7562858,'led',16.667,4),(1030,7562867,7562861,'cac',33.333,1),(1030,7562868,7562861,'ach',33.333,1),(1030,7562869,7562861,'che',33.333,1),(1030,7562870,7562867,'mod',50,1),(1030,7562871,7562867,'ode',50,1),(1030,7562872,7562870,'wri',14.286,1),(1030,7562873,7562870,'rit',14.286,1),(1030,7562874,7562870,'ite',14.286,1),(1030,7562875,7562870,'tet',14.286,1),(1030,7562876,7562870,'eth',14.286,1),(1030,7562877,7562870,'thr',14.286,1),(1030,7562878,7562870,'hru',14.286,1),(1030,7562879,7562872,'ope',11.111,2),(1030,7562880,7562872,'per',11.111,2),(1030,7562881,7562872,'era',11.111,2),(1030,7562882,7562872,'rat',11.111,2),(1030,7562883,7562872,'ati',11.111,2),(1030,7562884,7562872,'tio',11.111,2),(1030,7562885,7562872,'ion',11.111,2),(1030,7562886,7562872,'ona',11.111,2),(1030,7562887,7562872,'nal',11.111,2),(1030,7562888,7562879,'mes',20,1),(1030,7562889,7562879,'ess',20,1),(1030,7562890,7562879,'ssa',20,1),(1030,7562891,7562879,'sag',20,1),(1030,7562892,7562879,'age',20,1),(1030,7562893,7562888,'per',11.111,1),(1030,7562894,7562888,'erf',11.111,1),(1030,7562895,7562888,'rfo',11.111,1),(1030,7562896,7562888,'for',11.111,1),(1030,7562897,7562888,'orm',11.111,1),(1030,7562898,7562888,'rma',11.111,1),(1030,7562899,7562888,'man',11.111,1),(1030,7562900,7562888,'anc',11.111,1),(1030,7562901,7562888,'nce',11.111,1),(1030,7562902,7562893,'ide',12.5,1),(1030,7562903,7562893,'den',12.5,1),(1030,7562904,7562893,'ent',12.5,1),(1030,7562905,7562893,'nti',12.5,1),(1030,7562906,7562893,'tif',12.5,1),(1030,7562907,7562893,'ifi',12.5,1),(1030,7562908,7562893,'fie',12.5,1),(1030,7562909,7562893,'ier',12.5,1),(1030,7562910,7562902,'vdi',33.333,3),(1030,7562911,7562902,'dis',33.333,3),(1030,7562912,7562902,'isk',33.333,3),(1030,7562913,7562910,'nam',50,1),(1030,7562914,7562910,'ame',50,1),(1030,7562915,7562913,'typ',50,1),(1030,7562916,7562913,'ype',50,1),(1030,7562917,7562915,'dir',25,1),(1030,7562918,7562915,'ire',25,1),(1030,7562919,7562915,'rec',25,1),(1030,7562920,7562915,'ect',25,1),(1031,7562922,7562921,'naa',100,2),(1031,7562923,7562922,'600',3.333,3),(1031,7562924,7562922,'000',3.333,3),(1031,7562925,7562922,'00c',3.333,3),(1031,7562926,7562922,'0c2',3.333,3),(1031,7562927,7562922,'c29',3.333,3),(1031,7562928,7562922,'296',3.333,3),(1031,7562929,7562922,'969',3.333,3),(1031,7562930,7562922,'696',3.333,3),(1031,7562931,7562922,'967',3.333,3),(1031,7562932,7562922,'673',3.333,3),(1031,7562933,7562922,'739',3.333,3),(1031,7562934,7562922,'39d',3.333,3),(1031,7562935,7562922,'9d8',3.333,3),(1031,7562936,7562922,'d86',3.333,3),(1031,7562937,7562922,'867',3.333,3),(1031,7562938,7562922,'67b',3.333,3),(1031,7562939,7562922,'7b9',3.333,3),(1031,7562940,7562922,'b91',3.333,3),(1031,7562941,7562922,'910',3.333,3),(1031,7562942,7562922,'108',3.333,3),(1031,7562943,7562922,'080',3.333,3),(1031,7562944,7562922,'806',3.333,3),(1031,7562945,7562922,'06b',3.333,3),(1031,7562946,7562922,'6b2',3.333,3),(1031,7562947,7562922,'b20',3.333,3),(1031,7562948,7562922,'20b',3.333,3),(1031,7562949,7562922,'0bf',3.333,3),(1031,7562950,7562922,'bf9',3.333,3),(1031,7562951,7562922,'f90',3.333,3),(1031,7562952,7562922,'90f',3.333,3),(1031,7562953,7562923,'mon',100,1),(1031,7562954,7562953,'201',50,1),(1031,7562955,7562953,'013',50,1),(1031,7562956,7562954,'adm',33.333,4),(1031,7562957,7562954,'dmi',33.333,4),(1031,7562958,7562954,'min',33.333,4),(1031,7562959,7562956,'cap',16.667,1),(1031,7562960,7562956,'apa',16.667,1),(1031,7562961,7562956,'pac',16.667,1),(1031,7562962,7562956,'aci',16.667,1),(1031,7562963,7562956,'cit',16.667,1),(1031,7562964,7562956,'ity',16.667,1),(1031,7562965,7562959,'pat',50,1),(1031,7562966,7562959,'ath',50,1),(1031,7562967,7562965,'fre',14.286,1),(1031,7562968,7562965,'ree',14.286,1),(1031,7562969,7562965,'ees',14.286,1),(1031,7562970,7562965,'esp',14.286,1),(1031,7562971,7562965,'spa',14.286,1),(1031,7562972,7562965,'pac',14.286,1),(1031,7562973,7562965,'ace',14.286,1),(1031,7562974,7562967,'dis',50,1),(1031,7562975,7562967,'isk',50,1),(1031,7562976,7562974,'ind',33.333,1),(1031,7562977,7562974,'nde',33.333,1),(1031,7562978,7562974,'dex',33.333,1),(1031,7562979,7562976,'adm',8.333,1),(1031,7562980,7562976,'dmi',8.333,1),(1031,7562981,7562976,'min',8.333,1),(1031,7562982,7562976,'ini',8.333,1),(1031,7562983,7562976,'nis',8.333,1),(1031,7562984,7562976,'ist',8.333,1),(1031,7562985,7562976,'str',8.333,1),(1031,7562986,7562976,'tra',8.333,1),(1031,7562987,7562976,'rat',8.333,1),(1031,7562988,7562976,'ati',8.333,1),(1031,7562989,7562976,'tio',8.333,1),(1031,7562990,7562976,'ion',8.333,1),(1031,7562991,7562979,'sta',33.333,3),(1031,7562992,7562979,'tat',33.333,3),(1031,7562993,7562979,'ate',33.333,3),(1031,7562994,7562991,'dis',16.667,4),(1031,7562995,7562991,'isa',16.667,4),(1031,7562996,7562991,'sab',16.667,4),(1031,7562997,7562991,'abl',16.667,4),(1031,7562998,7562991,'ble',16.667,4),(1031,7562999,7562991,'led',16.667,4),(1031,7563000,7562994,'cac',33.333,1),(1031,7563001,7562994,'ach',33.333,1),(1031,7563002,7562994,'che',33.333,1),(1031,7563003,7563000,'mod',50,1),(1031,7563004,7563000,'ode',50,1),(1031,7563005,7563003,'wri',14.286,1),(1031,7563006,7563003,'rit',14.286,1),(1031,7563007,7563003,'ite',14.286,1),(1031,7563008,7563003,'tet',14.286,1),(1031,7563009,7563003,'eth',14.286,1),(1031,7563010,7563003,'thr',14.286,1),(1031,7563011,7563003,'hru',14.286,1),(1031,7563012,7563005,'ope',11.111,2),(1031,7563013,7563005,'per',11.111,2),(1031,7563014,7563005,'era',11.111,2),(1031,7563015,7563005,'rat',11.111,2),(1031,7563016,7563005,'ati',11.111,2),(1031,7563017,7563005,'tio',11.111,2),(1031,7563018,7563005,'ion',11.111,2),(1031,7563019,7563005,'ona',11.111,2),(1031,7563020,7563005,'nal',11.111,2),(1031,7563021,7563012,'mes',20,1),(1031,7563022,7563012,'ess',20,1),(1031,7563023,7563012,'ssa',20,1),(1031,7563024,7563012,'sag',20,1),(1031,7563025,7563012,'age',20,1),(1031,7563026,7563021,'per',11.111,1),(1031,7563027,7563021,'erf',11.111,1),(1031,7563028,7563021,'rfo',11.111,1),(1031,7563029,7563021,'for',11.111,1),(1031,7563030,7563021,'orm',11.111,1),(1031,7563031,7563021,'rma',11.111,1),(1031,7563032,7563021,'man',11.111,1),(1031,7563033,7563021,'anc',11.111,1),(1031,7563034,7563021,'nce',11.111,1),(1031,7563035,7563026,'ide',12.5,1),(1031,7563036,7563026,'den',12.5,1),(1031,7563037,7563026,'ent',12.5,1),(1031,7563038,7563026,'nti',12.5,1),(1031,7563039,7563026,'tif',12.5,1),(1031,7563040,7563026,'ifi',12.5,1),(1031,7563041,7563026,'fie',12.5,1),(1031,7563042,7563026,'ier',12.5,1),(1031,7563043,7563035,'vdi',33.333,3),(1031,7563044,7563035,'dis',33.333,3),(1031,7563045,7563035,'isk',33.333,3),(1031,7563046,7563043,'nam',50,1),(1031,7563047,7563043,'ame',50,1),(1031,7563048,7563046,'typ',50,1),(1031,7563049,7563046,'ype',50,1),(1031,7563050,7563048,'dir',25,1),(1031,7563051,7563048,'ire',25,1),(1031,7563052,7563048,'rec',25,1),(1031,7563053,7563048,'ect',25,1),(1032,7563055,7563054,'naa',100,2),(1032,7563056,7563055,'600',3.333,3),(1032,7563057,7563055,'000',3.333,3),(1032,7563058,7563055,'00c',3.333,3),(1032,7563059,7563055,'0c2',3.333,3),(1032,7563060,7563055,'c29',3.333,3),(1032,7563061,7563055,'29b',3.333,3),(1032,7563062,7563055,'9bf',3.333,3),(1032,7563063,7563055,'bfc',3.333,3),(1032,7563064,7563055,'fc0',3.333,3),(1032,7563065,7563055,'c02',3.333,3),(1032,7563066,7563055,'02c',3.333,3),(1032,7563067,7563055,'2c9',3.333,3),(1032,7563068,7563055,'c91',3.333,3),(1032,7563069,7563055,'91b',3.333,3),(1032,7563070,7563055,'1b6',3.333,3),(1032,7563071,7563055,'b67',3.333,3),(1032,7563072,7563055,'67d',3.333,3),(1032,7563073,7563055,'7d3',3.333,3),(1032,7563074,7563055,'d3e',3.333,3),(1032,7563075,7563055,'3e0',3.333,3),(1032,7563076,7563055,'e02',3.333,3),(1032,7563077,7563055,'023',3.333,3),(1032,7563078,7563055,'230',3.333,3),(1032,7563079,7563055,'30b',3.333,3),(1032,7563080,7563055,'0be',3.333,3),(1032,7563081,7563055,'be1',3.333,3),(1032,7563082,7563055,'e11',3.333,3),(1032,7563083,7563055,'119',3.333,3),(1032,7563084,7563055,'191',3.333,3),(1032,7563085,7563055,'91e',3.333,3),(1032,7563086,7563056,'mon',100,1),(1032,7563087,7563086,'201',50,1),(1032,7563088,7563086,'013',50,1),(1032,7563089,7563087,'adm',33.333,4),(1032,7563090,7563087,'dmi',33.333,4),(1032,7563091,7563087,'min',33.333,4),(1032,7563092,7563089,'cap',16.667,1),(1032,7563093,7563089,'apa',16.667,1),(1032,7563094,7563089,'pac',16.667,1),(1032,7563095,7563089,'aci',16.667,1),(1032,7563096,7563089,'cit',16.667,1),(1032,7563097,7563089,'ity',16.667,1),(1032,7563098,7563092,'pat',50,1),(1032,7563099,7563092,'ath',50,1),(1032,7563100,7563098,'fre',14.286,1),(1032,7563101,7563098,'ree',14.286,1),(1032,7563102,7563098,'ees',14.286,1),(1032,7563103,7563098,'esp',14.286,1),(1032,7563104,7563098,'spa',14.286,1),(1032,7563105,7563098,'pac',14.286,1),(1032,7563106,7563098,'ace',14.286,1),(1032,7563107,7563100,'dis',50,1),(1032,7563108,7563100,'isk',50,1),(1032,7563109,7563107,'ind',33.333,1),(1032,7563110,7563107,'nde',33.333,1),(1032,7563111,7563107,'dex',33.333,1),(1032,7563112,7563109,'adm',8.333,1),(1032,7563113,7563109,'dmi',8.333,1),(1032,7563114,7563109,'min',8.333,1),(1032,7563115,7563109,'ini',8.333,1),(1032,7563116,7563109,'nis',8.333,1),(1032,7563117,7563109,'ist',8.333,1),(1032,7563118,7563109,'str',8.333,1),(1032,7563119,7563109,'tra',8.333,1),(1032,7563120,7563109,'rat',8.333,1),(1032,7563121,7563109,'ati',8.333,1),(1032,7563122,7563109,'tio',8.333,1),(1032,7563123,7563109,'ion',8.333,1),(1032,7563124,7563112,'sta',33.333,3),(1032,7563125,7563112,'tat',33.333,3),(1032,7563126,7563112,'ate',33.333,3),(1032,7563127,7563124,'dis',16.667,4),(1032,7563128,7563124,'isa',16.667,4),(1032,7563129,7563124,'sab',16.667,4),(1032,7563130,7563124,'abl',16.667,4),(1032,7563131,7563124,'ble',16.667,4),(1032,7563132,7563124,'led',16.667,4),(1032,7563133,7563127,'cac',33.333,1),(1032,7563134,7563127,'ach',33.333,1),(1032,7563135,7563127,'che',33.333,1),(1032,7563136,7563133,'mod',50,1),(1032,7563137,7563133,'ode',50,1),(1032,7563138,7563136,'wri',14.286,1),(1032,7563139,7563136,'rit',14.286,1),(1032,7563140,7563136,'ite',14.286,1),(1032,7563141,7563136,'tet',14.286,1),(1032,7563142,7563136,'eth',14.286,1),(1032,7563143,7563136,'thr',14.286,1),(1032,7563144,7563136,'hru',14.286,1),(1032,7563145,7563138,'ope',11.111,2),(1032,7563146,7563138,'per',11.111,2),(1032,7563147,7563138,'era',11.111,2),(1032,7563148,7563138,'rat',11.111,2),(1032,7563149,7563138,'ati',11.111,2),(1032,7563150,7563138,'tio',11.111,2),(1032,7563151,7563138,'ion',11.111,2),(1032,7563152,7563138,'ona',11.111,2),(1032,7563153,7563138,'nal',11.111,2),(1032,7563154,7563145,'mes',20,1),(1032,7563155,7563145,'ess',20,1),(1032,7563156,7563145,'ssa',20,1),(1032,7563157,7563145,'sag',20,1),(1032,7563158,7563145,'age',20,1),(1032,7563159,7563154,'per',11.111,1),(1032,7563160,7563154,'erf',11.111,1),(1032,7563161,7563154,'rfo',11.111,1),(1032,7563162,7563154,'for',11.111,1),(1032,7563163,7563154,'orm',11.111,1),(1032,7563164,7563154,'rma',11.111,1),(1032,7563165,7563154,'man',11.111,1),(1032,7563166,7563154,'anc',11.111,1),(1032,7563167,7563154,'nce',11.111,1),(1032,7563168,7563159,'ide',12.5,1),(1032,7563169,7563159,'den',12.5,1),(1032,7563170,7563159,'ent',12.5,1),(1032,7563171,7563159,'nti',12.5,1),(1032,7563172,7563159,'tif',12.5,1),(1032,7563173,7563159,'ifi',12.5,1),(1032,7563174,7563159,'fie',12.5,1),(1032,7563175,7563159,'ier',12.5,1),(1032,7563176,7563168,'vdi',33.333,3),(1032,7563177,7563168,'dis',33.333,3),(1032,7563178,7563168,'isk',33.333,3),(1032,7563179,7563176,'nam',50,1),(1032,7563180,7563176,'ame',50,1),(1032,7563181,7563179,'typ',50,1),(1032,7563182,7563179,'ype',50,1),(1032,7563183,7563181,'dir',25,1),(1032,7563184,7563181,'ire',25,1),(1032,7563185,7563181,'rec',25,1),(1032,7563186,7563181,'ect',25,1),(1033,7563188,7563187,'naa',100,2),(1033,7563189,7563188,'600',3.333,3),(1033,7563190,7563188,'000',3.333,3),(1033,7563191,7563188,'00c',3.333,3),(1033,7563192,7563188,'0c2',3.333,3),(1033,7563193,7563188,'c29',3.333,3),(1033,7563194,7563188,'29a',3.333,3),(1033,7563195,7563188,'9a2',3.333,3),(1033,7563196,7563188,'a2d',3.333,3),(1033,7563197,7563188,'2d5',3.333,3),(1033,7563198,7563188,'d5b',3.333,3),(1033,7563199,7563188,'5b9',3.333,3),(1033,7563200,7563188,'b99',3.333,3),(1033,7563201,7563188,'997',3.333,3),(1033,7563202,7563188,'97b',3.333,3),(1033,7563203,7563188,'7bb',3.333,3),(1033,7563204,7563188,'bbb',3.333,3),(1033,7563205,7563188,'bb4',3.333,3),(1033,7563206,7563188,'b41',3.333,3),(1033,7563207,7563188,'41b',3.333,3),(1033,7563208,7563188,'1b0',3.333,3),(1033,7563209,7563188,'b06',3.333,3),(1033,7563210,7563188,'06a',3.333,3),(1033,7563211,7563188,'6aa',3.333,3),(1033,7563212,7563188,'aaf',3.333,3),(1033,7563213,7563188,'af1',3.333,3),(1033,7563214,7563188,'f1f',3.333,3),(1033,7563215,7563188,'1f7',3.333,3),(1033,7563216,7563188,'f7f',3.333,3),(1033,7563217,7563188,'7f6',3.333,3),(1033,7563218,7563188,'f69',3.333,3),(1033,7563219,7563189,'mon',100,1),(1033,7563220,7563219,'201',50,1),(1033,7563221,7563219,'013',50,1),(1033,7563222,7563220,'adm',33.333,4),(1033,7563223,7563220,'dmi',33.333,4),(1033,7563224,7563220,'min',33.333,4),(1033,7563225,7563222,'cap',16.667,1),(1033,7563226,7563222,'apa',16.667,1),(1033,7563227,7563222,'pac',16.667,1),(1033,7563228,7563222,'aci',16.667,1),(1033,7563229,7563222,'cit',16.667,1),(1033,7563230,7563222,'ity',16.667,1),(1033,7563231,7563225,'pat',50,1),(1033,7563232,7563225,'ath',50,1),(1033,7563233,7563231,'fre',14.286,1),(1033,7563234,7563231,'ree',14.286,1),(1033,7563235,7563231,'ees',14.286,1),(1033,7563236,7563231,'esp',14.286,1),(1033,7563237,7563231,'spa',14.286,1),(1033,7563238,7563231,'pac',14.286,1),(1033,7563239,7563231,'ace',14.286,1),(1033,7563240,7563233,'dis',50,1),(1033,7563241,7563233,'isk',50,1),(1033,7563242,7563240,'ind',33.333,1),(1033,7563243,7563240,'nde',33.333,1),(1033,7563244,7563240,'dex',33.333,1),(1033,7563245,7563242,'adm',8.333,1),(1033,7563246,7563242,'dmi',8.333,1),(1033,7563247,7563242,'min',8.333,1),(1033,7563248,7563242,'ini',8.333,1),(1033,7563249,7563242,'nis',8.333,1),(1033,7563250,7563242,'ist',8.333,1),(1033,7563251,7563242,'str',8.333,1),(1033,7563252,7563242,'tra',8.333,1),(1033,7563253,7563242,'rat',8.333,1),(1033,7563254,7563242,'ati',8.333,1),(1033,7563255,7563242,'tio',8.333,1),(1033,7563256,7563242,'ion',8.333,1),(1033,7563257,7563245,'sta',33.333,3),(1033,7563258,7563245,'tat',33.333,3),(1033,7563259,7563245,'ate',33.333,3),(1033,7563260,7563257,'dis',16.667,4),(1033,7563261,7563257,'isa',16.667,4),(1033,7563262,7563257,'sab',16.667,4),(1033,7563263,7563257,'abl',16.667,4),(1033,7563264,7563257,'ble',16.667,4),(1033,7563265,7563257,'led',16.667,4),(1033,7563266,7563260,'cac',33.333,1),(1033,7563267,7563260,'ach',33.333,1),(1033,7563268,7563260,'che',33.333,1),(1033,7563269,7563266,'mod',50,1),(1033,7563270,7563266,'ode',50,1),(1033,7563271,7563269,'wri',14.286,1),(1033,7563272,7563269,'rit',14.286,1),(1033,7563273,7563269,'ite',14.286,1),(1033,7563274,7563269,'tet',14.286,1),(1033,7563275,7563269,'eth',14.286,1),(1033,7563276,7563269,'thr',14.286,1),(1033,7563277,7563269,'hru',14.286,1),(1033,7563278,7563271,'ope',11.111,2),(1033,7563279,7563271,'per',11.111,2),(1033,7563280,7563271,'era',11.111,2),(1033,7563281,7563271,'rat',11.111,2),(1033,7563282,7563271,'ati',11.111,2),(1033,7563283,7563271,'tio',11.111,2),(1033,7563284,7563271,'ion',11.111,2),(1033,7563285,7563271,'ona',11.111,2),(1033,7563286,7563271,'nal',11.111,2),(1033,7563287,7563278,'mes',20,1),(1033,7563288,7563278,'ess',20,1),(1033,7563289,7563278,'ssa',20,1),(1033,7563290,7563278,'sag',20,1),(1033,7563291,7563278,'age',20,1),(1033,7563292,7563287,'per',11.111,1),(1033,7563293,7563287,'erf',11.111,1),(1033,7563294,7563287,'rfo',11.111,1),(1033,7563295,7563287,'for',11.111,1),(1033,7563296,7563287,'orm',11.111,1),(1033,7563297,7563287,'rma',11.111,1),(1033,7563298,7563287,'man',11.111,1),(1033,7563299,7563287,'anc',11.111,1),(1033,7563300,7563287,'nce',11.111,1),(1033,7563301,7563292,'ide',12.5,1),(1033,7563302,7563292,'den',12.5,1),(1033,7563303,7563292,'ent',12.5,1),(1033,7563304,7563292,'nti',12.5,1),(1033,7563305,7563292,'tif',12.5,1),(1033,7563306,7563292,'ifi',12.5,1),(1033,7563307,7563292,'fie',12.5,1),(1033,7563308,7563292,'ier',12.5,1),(1033,7563309,7563301,'vdi',33.333,3),(1033,7563310,7563301,'dis',33.333,3),(1033,7563311,7563301,'isk',33.333,3),(1033,7563312,7563309,'nam',50,1),(1033,7563313,7563309,'ame',50,1),(1033,7563314,7563312,'typ',50,1),(1033,7563315,7563312,'ype',50,1),(1033,7563316,7563314,'dir',25,1),(1033,7563317,7563314,'ire',25,1),(1033,7563318,7563314,'rec',25,1),(1033,7563319,7563314,'ect',25,1),(1034,7563321,7563320,'naa',100,2),(1034,7563322,7563321,'600',3.333,3),(1034,7563323,7563321,'000',3.333,3),(1034,7563324,7563321,'00c',3.333,3),(1034,7563325,7563321,'0c2',3.333,3),(1034,7563326,7563321,'c29',3.333,3),(1034,7563327,7563321,'290',3.333,3),(1034,7563328,7563321,'906',3.333,3),(1034,7563329,7563321,'066',3.333,3),(1034,7563330,7563321,'665',3.333,3),(1034,7563331,7563321,'651',3.333,3),(1034,7563332,7563321,'516',3.333,3),(1034,7563333,7563321,'161',3.333,3),(1034,7563334,7563321,'614',3.333,3),(1034,7563335,7563321,'146',3.333,3),(1034,7563336,7563321,'461',3.333,3),(1034,7563337,7563321,'616',3.333,3),(1034,7563338,7563321,'169',3.333,3),(1034,7563339,7563321,'691',3.333,3),(1034,7563340,7563321,'91e',3.333,3),(1034,7563341,7563321,'1e2',3.333,3),(1034,7563342,7563321,'e24',3.333,3),(1034,7563343,7563321,'247',3.333,3),(1034,7563344,7563321,'47e',3.333,3),(1034,7563345,7563321,'7ee',3.333,3),(1034,7563346,7563321,'eea',3.333,3),(1034,7563347,7563321,'ea5',3.333,3),(1034,7563348,7563321,'a5c',3.333,3),(1034,7563349,7563321,'5cf',3.333,3),(1034,7563350,7563321,'cf1',3.333,3),(1034,7563351,7563321,'f10',3.333,3),(1034,7563352,7563322,'mon',100,1),(1034,7563353,7563352,'201',50,1),(1034,7563354,7563352,'013',50,1),(1034,7563355,7563353,'adm',33.333,4),(1034,7563356,7563353,'dmi',33.333,4),(1034,7563357,7563353,'min',33.333,4),(1034,7563358,7563355,'cap',16.667,1),(1034,7563359,7563355,'apa',16.667,1),(1034,7563360,7563355,'pac',16.667,1),(1034,7563361,7563355,'aci',16.667,1),(1034,7563362,7563355,'cit',16.667,1),(1034,7563363,7563355,'ity',16.667,1),(1034,7563364,7563358,'pat',50,1),(1034,7563365,7563358,'ath',50,1),(1034,7563366,7563364,'eig',33.333,1),(1034,7563367,7563364,'igh',33.333,1),(1034,7563368,7563364,'ght',33.333,1),(1034,7563369,7563366,'fre',14.286,1),(1034,7563370,7563366,'ree',14.286,1),(1034,7563371,7563366,'ees',14.286,1),(1034,7563372,7563366,'esp',14.286,1),(1034,7563373,7563366,'spa',14.286,1),(1034,7563374,7563366,'pac',14.286,1),(1034,7563375,7563366,'ace',14.286,1),(1034,7563376,7563369,'dis',50,1),(1034,7563377,7563369,'isk',50,1),(1034,7563378,7563376,'ind',33.333,1),(1034,7563379,7563376,'nde',33.333,1),(1034,7563380,7563376,'dex',33.333,1),(1034,7563381,7563378,'adm',8.333,1),(1034,7563382,7563378,'dmi',8.333,1),(1034,7563383,7563378,'min',8.333,1),(1034,7563384,7563378,'ini',8.333,1),(1034,7563385,7563378,'nis',8.333,1),(1034,7563386,7563378,'ist',8.333,1),(1034,7563387,7563378,'str',8.333,1),(1034,7563388,7563378,'tra',8.333,1),(1034,7563389,7563378,'rat',8.333,1),(1034,7563390,7563378,'ati',8.333,1),(1034,7563391,7563378,'tio',8.333,1),(1034,7563392,7563378,'ion',8.333,1),(1034,7563393,7563381,'sta',33.333,3),(1034,7563394,7563381,'tat',33.333,3),(1034,7563395,7563381,'ate',33.333,3),(1034,7563396,7563393,'dis',16.667,4),(1034,7563397,7563393,'isa',16.667,4),(1034,7563398,7563393,'sab',16.667,4),(1034,7563399,7563393,'abl',16.667,4),(1034,7563400,7563393,'ble',16.667,4),(1034,7563401,7563393,'led',16.667,4),(1034,7563402,7563396,'cac',33.333,1),(1034,7563403,7563396,'ach',33.333,1),(1034,7563404,7563396,'che',33.333,1),(1034,7563405,7563402,'mod',50,1),(1034,7563406,7563402,'ode',50,1),(1034,7563407,7563405,'wri',14.286,1),(1034,7563408,7563405,'rit',14.286,1),(1034,7563409,7563405,'ite',14.286,1),(1034,7563410,7563405,'tet',14.286,1),(1034,7563411,7563405,'eth',14.286,1),(1034,7563412,7563405,'thr',14.286,1),(1034,7563413,7563405,'hru',14.286,1),(1034,7563414,7563407,'ope',11.111,2),(1034,7563415,7563407,'per',11.111,2),(1034,7563416,7563407,'era',11.111,2),(1034,7563417,7563407,'rat',11.111,2),(1034,7563418,7563407,'ati',11.111,2),(1034,7563419,7563407,'tio',11.111,2),(1034,7563420,7563407,'ion',11.111,2),(1034,7563421,7563407,'ona',11.111,2),(1034,7563422,7563407,'nal',11.111,2),(1034,7563423,7563414,'mes',20,1),(1034,7563424,7563414,'ess',20,1),(1034,7563425,7563414,'ssa',20,1),(1034,7563426,7563414,'sag',20,1),(1034,7563427,7563414,'age',20,1),(1034,7563428,7563423,'per',11.111,1),(1034,7563429,7563423,'erf',11.111,1),(1034,7563430,7563423,'rfo',11.111,1),(1034,7563431,7563423,'for',11.111,1),(1034,7563432,7563423,'orm',11.111,1),(1034,7563433,7563423,'rma',11.111,1),(1034,7563434,7563423,'man',11.111,1),(1034,7563435,7563423,'anc',11.111,1),(1034,7563436,7563423,'nce',11.111,1),(1034,7563437,7563428,'ide',12.5,1),(1034,7563438,7563428,'den',12.5,1),(1034,7563439,7563428,'ent',12.5,1),(1034,7563440,7563428,'nti',12.5,1),(1034,7563441,7563428,'tif',12.5,1),(1034,7563442,7563428,'ifi',12.5,1),(1034,7563443,7563428,'fie',12.5,1),(1034,7563444,7563428,'ier',12.5,1),(1034,7563445,7563437,'vdi',33.333,3),(1034,7563446,7563437,'dis',33.333,3),(1034,7563447,7563437,'isk',33.333,3),(1034,7563448,7563445,'nam',50,1),(1034,7563449,7563445,'ame',50,1),(1034,7563450,7563448,'typ',50,1),(1034,7563451,7563448,'ype',50,1),(1034,7563452,7563450,'dir',25,1),(1034,7563453,7563450,'ire',25,1),(1034,7563454,7563450,'rec',25,1),(1034,7563455,7563450,'ect',25,1),(1035,7563457,7563456,'naa',100,2),(1035,7563458,7563457,'600',3.333,3),(1035,7563459,7563457,'000',3.333,3),(1035,7563460,7563457,'00c',3.333,3),(1035,7563461,7563457,'0c2',3.333,3),(1035,7563462,7563457,'c29',3.333,3),(1035,7563463,7563457,'290',3.333,3),(1035,7563464,7563457,'90b',3.333,3),(1035,7563465,7563457,'0b7',3.333,3),(1035,7563466,7563457,'b79',3.333,3),(1035,7563467,7563457,'795',3.333,3),(1035,7563468,7563457,'958',3.333,3),(1035,7563469,7563457,'582',3.333,3),(1035,7563470,7563457,'82d',3.333,3),(1035,7563471,7563457,'2df',3.333,3),(1035,7563472,7563457,'df1',3.333,3),(1035,7563473,7563457,'f1f',3.333,3),(1035,7563474,7563457,'1f9',3.333,3),(1035,7563475,7563457,'f9e',3.333,3),(1035,7563476,7563457,'9ec',3.333,3),(1035,7563477,7563457,'ecd',3.333,3),(1035,7563478,7563457,'cd8',3.333,3),(1035,7563479,7563457,'d8f',3.333,3),(1035,7563480,7563457,'8fa',3.333,3),(1035,7563481,7563457,'fa4',3.333,3),(1035,7563482,7563457,'a45',3.333,3),(1035,7563483,7563457,'454',3.333,3),(1035,7563484,7563457,'546',3.333,3),(1035,7563485,7563457,'462',3.333,3),(1035,7563486,7563457,'62a',3.333,3),(1035,7563487,7563457,'2a5',3.333,3),(1035,7563488,7563458,'mon',100,1),(1035,7563489,7563488,'201',50,1),(1035,7563490,7563488,'013',50,1),(1035,7563491,7563489,'adm',33.333,4),(1035,7563492,7563489,'dmi',33.333,4),(1035,7563493,7563489,'min',33.333,4),(1035,7563494,7563491,'cap',16.667,1),(1035,7563495,7563491,'apa',16.667,1),(1035,7563496,7563491,'pac',16.667,1),(1035,7563497,7563491,'aci',16.667,1),(1035,7563498,7563491,'cit',16.667,1),(1035,7563499,7563491,'ity',16.667,1),(1035,7563500,7563494,'pat',50,1),(1035,7563501,7563494,'ath',50,1),(1035,7563502,7563500,'fre',14.286,1),(1035,7563503,7563500,'ree',14.286,1),(1035,7563504,7563500,'ees',14.286,1),(1035,7563505,7563500,'esp',14.286,1),(1035,7563506,7563500,'spa',14.286,1),(1035,7563507,7563500,'pac',14.286,1),(1035,7563508,7563500,'ace',14.286,1),(1035,7563509,7563502,'dis',50,1),(1035,7563510,7563502,'isk',50,1),(1035,7563511,7563509,'ind',33.333,1),(1035,7563512,7563509,'nde',33.333,1),(1035,7563513,7563509,'dex',33.333,1),(1035,7563514,7563511,'adm',8.333,1),(1035,7563515,7563511,'dmi',8.333,1),(1035,7563516,7563511,'min',8.333,1),(1035,7563517,7563511,'ini',8.333,1),(1035,7563518,7563511,'nis',8.333,1),(1035,7563519,7563511,'ist',8.333,1),(1035,7563520,7563511,'str',8.333,1),(1035,7563521,7563511,'tra',8.333,1),(1035,7563522,7563511,'rat',8.333,1),(1035,7563523,7563511,'ati',8.333,1),(1035,7563524,7563511,'tio',8.333,1),(1035,7563525,7563511,'ion',8.333,1),(1035,7563526,7563514,'sta',33.333,3),(1035,7563527,7563514,'tat',33.333,3),(1035,7563528,7563514,'ate',33.333,3),(1035,7563529,7563526,'dis',16.667,4),(1035,7563530,7563526,'isa',16.667,4),(1035,7563531,7563526,'sab',16.667,4),(1035,7563532,7563526,'abl',16.667,4),(1035,7563533,7563526,'ble',16.667,4),(1035,7563534,7563526,'led',16.667,4),(1035,7563535,7563529,'cac',33.333,1),(1035,7563536,7563529,'ach',33.333,1),(1035,7563537,7563529,'che',33.333,1),(1035,7563538,7563535,'mod',50,1),(1035,7563539,7563535,'ode',50,1),(1035,7563540,7563538,'wri',14.286,1),(1035,7563541,7563538,'rit',14.286,1),(1035,7563542,7563538,'ite',14.286,1),(1035,7563543,7563538,'tet',14.286,1),(1035,7563544,7563538,'eth',14.286,1),(1035,7563545,7563538,'thr',14.286,1),(1035,7563546,7563538,'hru',14.286,1),(1035,7563547,7563540,'ope',11.111,2),(1035,7563548,7563540,'per',11.111,2),(1035,7563549,7563540,'era',11.111,2),(1035,7563550,7563540,'rat',11.111,2),(1035,7563551,7563540,'ati',11.111,2),(1035,7563552,7563540,'tio',11.111,2),(1035,7563553,7563540,'ion',11.111,2),(1035,7563554,7563540,'ona',11.111,2),(1035,7563555,7563540,'nal',11.111,2),(1035,7563556,7563547,'mes',20,1),(1035,7563557,7563547,'ess',20,1),(1035,7563558,7563547,'ssa',20,1),(1035,7563559,7563547,'sag',20,1),(1035,7563560,7563547,'age',20,1),(1035,7563561,7563556,'per',11.111,1),(1035,7563562,7563556,'erf',11.111,1),(1035,7563563,7563556,'rfo',11.111,1),(1035,7563564,7563556,'for',11.111,1),(1035,7563565,7563556,'orm',11.111,1),(1035,7563566,7563556,'rma',11.111,1),(1035,7563567,7563556,'man',11.111,1),(1035,7563568,7563556,'anc',11.111,1),(1035,7563569,7563556,'nce',11.111,1),(1035,7563570,7563561,'ide',12.5,1),(1035,7563571,7563561,'den',12.5,1),(1035,7563572,7563561,'ent',12.5,1),(1035,7563573,7563561,'nti',12.5,1),(1035,7563574,7563561,'tif',12.5,1),(1035,7563575,7563561,'ifi',12.5,1),(1035,7563576,7563561,'fie',12.5,1),(1035,7563577,7563561,'ier',12.5,1),(1035,7563578,7563570,'vdi',33.333,3),(1035,7563579,7563570,'dis',33.333,3),(1035,7563580,7563570,'isk',33.333,3),(1035,7563581,7563578,'nam',50,1),(1035,7563582,7563578,'ame',50,1),(1035,7563583,7563581,'typ',50,1),(1035,7563584,7563581,'ype',50,1),(1035,7563585,7563583,'dir',25,1),(1035,7563586,7563583,'ire',25,1),(1035,7563587,7563583,'rec',25,1),(1035,7563588,7563583,'ect',25,1),(1036,7563590,7563589,'naa',100,2),(1036,7563591,7563590,'600',3.333,3),(1036,7563592,7563590,'000',3.333,3),(1036,7563593,7563590,'00c',3.333,3),(1036,7563594,7563590,'0c2',3.333,3),(1036,7563595,7563590,'c29',3.333,3),(1036,7563596,7563590,'298',3.333,3),(1036,7563597,7563590,'982',3.333,3),(1036,7563598,7563590,'829',3.333,3),(1036,7563599,7563590,'29b',3.333,3),(1036,7563600,7563590,'9b0',3.333,3),(1036,7563601,7563590,'b09',3.333,3),(1036,7563602,7563590,'097',3.333,3),(1036,7563603,7563590,'971',3.333,3),(1036,7563604,7563590,'717',3.333,3),(1036,7563605,7563590,'17e',3.333,3),(1036,7563606,7563590,'7e3',3.333,3),(1036,7563607,7563590,'e37',3.333,3),(1036,7563608,7563590,'37a',3.333,3),(1036,7563609,7563590,'7ac',3.333,3),(1036,7563610,7563590,'ac7',3.333,3),(1036,7563611,7563590,'c70',3.333,3),(1036,7563612,7563590,'705',3.333,3),(1036,7563613,7563590,'05f',3.333,3),(1036,7563614,7563590,'5f7',3.333,3),(1036,7563615,7563590,'f7c',3.333,3),(1036,7563616,7563590,'7ce',3.333,3),(1036,7563617,7563590,'ce8',3.333,3),(1036,7563618,7563590,'e89',3.333,3),(1036,7563619,7563590,'89a',3.333,3),(1036,7563620,7563590,'9a3',3.333,3),(1036,7563621,7563591,'mon',100,1),(1036,7563622,7563621,'201',50,1),(1036,7563623,7563621,'013',50,1),(1036,7563624,7563622,'adm',33.333,4),(1036,7563625,7563622,'dmi',33.333,4),(1036,7563626,7563622,'min',33.333,4),(1036,7563627,7563624,'cap',16.667,1),(1036,7563628,7563624,'apa',16.667,1),(1036,7563629,7563624,'pac',16.667,1),(1036,7563630,7563624,'aci',16.667,1),(1036,7563631,7563624,'cit',16.667,1),(1036,7563632,7563624,'ity',16.667,1),(1036,7563633,7563627,'pat',50,1),(1036,7563634,7563627,'ath',50,1),(1036,7563635,7563633,'ele',25,1),(1036,7563636,7563633,'lev',25,1),(1036,7563637,7563633,'eve',25,1),(1036,7563638,7563633,'ven',25,1),(1036,7563639,7563635,'fre',14.286,1),(1036,7563640,7563635,'ree',14.286,1),(1036,7563641,7563635,'ees',14.286,1),(1036,7563642,7563635,'esp',14.286,1),(1036,7563643,7563635,'spa',14.286,1),(1036,7563644,7563635,'pac',14.286,1),(1036,7563645,7563635,'ace',14.286,1),(1036,7563646,7563639,'dis',50,1),(1036,7563647,7563639,'isk',50,1),(1036,7563648,7563646,'ind',33.333,1),(1036,7563649,7563646,'nde',33.333,1),(1036,7563650,7563646,'dex',33.333,1),(1036,7563651,7563648,'adm',8.333,1),(1036,7563652,7563648,'dmi',8.333,1),(1036,7563653,7563648,'min',8.333,1),(1036,7563654,7563648,'ini',8.333,1),(1036,7563655,7563648,'nis',8.333,1),(1036,7563656,7563648,'ist',8.333,1),(1036,7563657,7563648,'str',8.333,1),(1036,7563658,7563648,'tra',8.333,1),(1036,7563659,7563648,'rat',8.333,1),(1036,7563660,7563648,'ati',8.333,1),(1036,7563661,7563648,'tio',8.333,1),(1036,7563662,7563648,'ion',8.333,1),(1036,7563663,7563651,'sta',33.333,3),(1036,7563664,7563651,'tat',33.333,3),(1036,7563665,7563651,'ate',33.333,3),(1036,7563666,7563663,'dis',16.667,4),(1036,7563667,7563663,'isa',16.667,4),(1036,7563668,7563663,'sab',16.667,4),(1036,7563669,7563663,'abl',16.667,4),(1036,7563670,7563663,'ble',16.667,4),(1036,7563671,7563663,'led',16.667,4),(1036,7563672,7563666,'cac',33.333,1),(1036,7563673,7563666,'ach',33.333,1),(1036,7563674,7563666,'che',33.333,1),(1036,7563675,7563672,'mod',50,1),(1036,7563676,7563672,'ode',50,1),(1036,7563677,7563675,'wri',14.286,1),(1036,7563678,7563675,'rit',14.286,1),(1036,7563679,7563675,'ite',14.286,1),(1036,7563680,7563675,'tet',14.286,1),(1036,7563681,7563675,'eth',14.286,1),(1036,7563682,7563675,'thr',14.286,1),(1036,7563683,7563675,'hru',14.286,1),(1036,7563684,7563677,'ope',11.111,2),(1036,7563685,7563677,'per',11.111,2),(1036,7563686,7563677,'era',11.111,2),(1036,7563687,7563677,'rat',11.111,2),(1036,7563688,7563677,'ati',11.111,2),(1036,7563689,7563677,'tio',11.111,2),(1036,7563690,7563677,'ion',11.111,2),(1036,7563691,7563677,'ona',11.111,2),(1036,7563692,7563677,'nal',11.111,2),(1036,7563693,7563684,'mes',20,1),(1036,7563694,7563684,'ess',20,1),(1036,7563695,7563684,'ssa',20,1),(1036,7563696,7563684,'sag',20,1),(1036,7563697,7563684,'age',20,1),(1036,7563698,7563693,'per',11.111,1),(1036,7563699,7563693,'erf',11.111,1),(1036,7563700,7563693,'rfo',11.111,1),(1036,7563701,7563693,'for',11.111,1),(1036,7563702,7563693,'orm',11.111,1),(1036,7563703,7563693,'rma',11.111,1),(1036,7563704,7563693,'man',11.111,1),(1036,7563705,7563693,'anc',11.111,1),(1036,7563706,7563693,'nce',11.111,1),(1036,7563707,7563698,'ide',12.5,1),(1036,7563708,7563698,'den',12.5,1),(1036,7563709,7563698,'ent',12.5,1),(1036,7563710,7563698,'nti',12.5,1),(1036,7563711,7563698,'tif',12.5,1),(1036,7563712,7563698,'ifi',12.5,1),(1036,7563713,7563698,'fie',12.5,1),(1036,7563714,7563698,'ier',12.5,1),(1036,7563715,7563707,'vdi',33.333,3),(1036,7563716,7563707,'dis',33.333,3),(1036,7563717,7563707,'isk',33.333,3),(1036,7563718,7563715,'nam',50,1),(1036,7563719,7563715,'ame',50,1),(1036,7563720,7563718,'typ',50,1),(1036,7563721,7563718,'ype',50,1),(1036,7563722,7563720,'dir',25,1),(1036,7563723,7563720,'ire',25,1),(1036,7563724,7563720,'rec',25,1),(1036,7563725,7563720,'ect',25,1),(1037,7563727,7563726,'naa',100,2),(1037,7563728,7563727,'600',3.333,3),(1037,7563729,7563727,'000',3.333,3),(1037,7563730,7563727,'00c',3.333,3),(1037,7563731,7563727,'0c2',3.333,3),(1037,7563732,7563727,'c29',3.333,3),(1037,7563733,7563727,'298',3.333,3),(1037,7563734,7563727,'98c',3.333,3),(1037,7563735,7563727,'8cf',3.333,3),(1037,7563736,7563727,'cf2',3.333,3),(1037,7563737,7563727,'f26',3.333,3),(1037,7563738,7563727,'260',3.333,3),(1037,7563739,7563727,'60d',3.333,3),(1037,7563740,7563727,'0d0',3.333,3),(1037,7563741,7563727,'d0d',3.333,3),(1037,7563742,7563727,'0d7',3.333,3),(1037,7563743,7563727,'d72',3.333,3),(1037,7563744,7563727,'72f',3.333,3),(1037,7563745,7563727,'2fe',3.333,3),(1037,7563746,7563727,'fe7',3.333,3),(1037,7563747,7563727,'e76',3.333,3),(1037,7563748,7563727,'768',3.333,3),(1037,7563749,7563727,'685',3.333,3),(1037,7563750,7563727,'85b',3.333,3),(1037,7563751,7563727,'5bc',3.333,3),(1037,7563752,7563727,'bcd',3.333,3),(1037,7563753,7563727,'cd2',3.333,3),(1037,7563754,7563727,'d2d',3.333,3),(1037,7563755,7563727,'2d6',3.333,3),(1037,7563756,7563727,'d63',3.333,3),(1037,7563757,7563727,'633',3.333,3),(1037,7563758,7563728,'mon',100,1),(1037,7563759,7563758,'201',50,1),(1037,7563760,7563758,'013',50,1),(1037,7563761,7563759,'adm',33.333,4),(1037,7563762,7563759,'dmi',33.333,4),(1037,7563763,7563759,'min',33.333,4),(1037,7563764,7563761,'cap',16.667,1),(1037,7563765,7563761,'apa',16.667,1),(1037,7563766,7563761,'pac',16.667,1),(1037,7563767,7563761,'aci',16.667,1),(1037,7563768,7563761,'cit',16.667,1),(1037,7563769,7563761,'ity',16.667,1),(1037,7563770,7563764,'pat',50,1),(1037,7563771,7563764,'ath',50,1),(1037,7563772,7563770,'fre',14.286,1),(1037,7563773,7563770,'ree',14.286,1),(1037,7563774,7563770,'ees',14.286,1),(1037,7563775,7563770,'esp',14.286,1),(1037,7563776,7563770,'spa',14.286,1),(1037,7563777,7563770,'pac',14.286,1),(1037,7563778,7563770,'ace',14.286,1),(1037,7563779,7563772,'dis',50,1),(1037,7563780,7563772,'isk',50,1),(1037,7563781,7563779,'ind',33.333,1),(1037,7563782,7563779,'nde',33.333,1),(1037,7563783,7563779,'dex',33.333,1),(1037,7563784,7563781,'adm',8.333,1),(1037,7563785,7563781,'dmi',8.333,1),(1037,7563786,7563781,'min',8.333,1),(1037,7563787,7563781,'ini',8.333,1),(1037,7563788,7563781,'nis',8.333,1),(1037,7563789,7563781,'ist',8.333,1),(1037,7563790,7563781,'str',8.333,1),(1037,7563791,7563781,'tra',8.333,1),(1037,7563792,7563781,'rat',8.333,1),(1037,7563793,7563781,'ati',8.333,1),(1037,7563794,7563781,'tio',8.333,1),(1037,7563795,7563781,'ion',8.333,1),(1037,7563796,7563784,'sta',33.333,3),(1037,7563797,7563784,'tat',33.333,3),(1037,7563798,7563784,'ate',33.333,3),(1037,7563799,7563796,'dis',16.667,4),(1037,7563800,7563796,'isa',16.667,4),(1037,7563801,7563796,'sab',16.667,4),(1037,7563802,7563796,'abl',16.667,4),(1037,7563803,7563796,'ble',16.667,4),(1037,7563804,7563796,'led',16.667,4),(1037,7563805,7563799,'cac',33.333,1),(1037,7563806,7563799,'ach',33.333,1),(1037,7563807,7563799,'che',33.333,1),(1037,7563808,7563805,'mod',50,1),(1037,7563809,7563805,'ode',50,1),(1037,7563810,7563808,'wri',14.286,1),(1037,7563811,7563808,'rit',14.286,1),(1037,7563812,7563808,'ite',14.286,1),(1037,7563813,7563808,'tet',14.286,1),(1037,7563814,7563808,'eth',14.286,1),(1037,7563815,7563808,'thr',14.286,1),(1037,7563816,7563808,'hru',14.286,1),(1037,7563817,7563810,'ope',11.111,2),(1037,7563818,7563810,'per',11.111,2),(1037,7563819,7563810,'era',11.111,2),(1037,7563820,7563810,'rat',11.111,2),(1037,7563821,7563810,'ati',11.111,2),(1037,7563822,7563810,'tio',11.111,2),(1037,7563823,7563810,'ion',11.111,2),(1037,7563824,7563810,'ona',11.111,2),(1037,7563825,7563810,'nal',11.111,2),(1037,7563826,7563817,'mes',20,1),(1037,7563827,7563817,'ess',20,1),(1037,7563828,7563817,'ssa',20,1),(1037,7563829,7563817,'sag',20,1),(1037,7563830,7563817,'age',20,1),(1037,7563831,7563826,'per',11.111,1),(1037,7563832,7563826,'erf',11.111,1),(1037,7563833,7563826,'rfo',11.111,1),(1037,7563834,7563826,'for',11.111,1),(1037,7563835,7563826,'orm',11.111,1),(1037,7563836,7563826,'rma',11.111,1),(1037,7563837,7563826,'man',11.111,1),(1037,7563838,7563826,'anc',11.111,1),(1037,7563839,7563826,'nce',11.111,1),(1037,7563840,7563831,'ide',12.5,1),(1037,7563841,7563831,'den',12.5,1),(1037,7563842,7563831,'ent',12.5,1),(1037,7563843,7563831,'nti',12.5,1),(1037,7563844,7563831,'tif',12.5,1),(1037,7563845,7563831,'ifi',12.5,1),(1037,7563846,7563831,'fie',12.5,1),(1037,7563847,7563831,'ier',12.5,1),(1037,7563848,7563840,'vdi',33.333,3),(1037,7563849,7563840,'dis',33.333,3),(1037,7563850,7563840,'isk',33.333,3),(1037,7563851,7563848,'nam',50,1),(1037,7563852,7563848,'ame',50,1),(1037,7563853,7563851,'typ',50,1),(1037,7563854,7563851,'ype',50,1),(1037,7563855,7563853,'dir',25,1),(1037,7563856,7563853,'ire',25,1),(1037,7563857,7563853,'rec',25,1),(1037,7563858,7563853,'ect',25,1),(1038,7563860,7563859,'naa',100,2),(1038,7563861,7563860,'600',3.333,3),(1038,7563862,7563860,'000',3.333,3),(1038,7563863,7563860,'00c',3.333,3),(1038,7563864,7563860,'0c2',3.333,3),(1038,7563865,7563860,'c29',3.333,3),(1038,7563866,7563860,'294',3.333,3),(1038,7563867,7563860,'94b',3.333,3),(1038,7563868,7563860,'4b9',3.333,3),(1038,7563869,7563860,'b9d',3.333,3),(1038,7563870,7563860,'9d8',3.333,3),(1038,7563871,7563860,'d86',3.333,3),(1038,7563872,7563860,'865',3.333,3),(1038,7563873,7563860,'659',3.333,3),(1038,7563874,7563860,'596',3.333,3),(1038,7563875,7563860,'969',3.333,3),(1038,7563876,7563860,'69a',3.333,3),(1038,7563877,7563860,'9a6',3.333,3),(1038,7563878,7563860,'a67',3.333,3),(1038,7563879,7563860,'67d',3.333,3),(1038,7563880,7563860,'7d1',3.333,3),(1038,7563881,7563860,'d19',3.333,3),(1038,7563882,7563860,'19f',3.333,3),(1038,7563883,7563860,'9f9',3.333,3),(1038,7563884,7563860,'f9c',3.333,3),(1038,7563885,7563860,'9c9',3.333,3),(1038,7563886,7563860,'c97',3.333,3),(1038,7563887,7563860,'97b',3.333,3),(1038,7563888,7563860,'7b8',3.333,3),(1038,7563889,7563860,'b82',3.333,3),(1038,7563890,7563860,'825',3.333,3),(1038,7563891,7563861,'mon',100,1),(1038,7563892,7563891,'201',50,1),(1038,7563893,7563891,'013',50,1),(1038,7563894,7563892,'adm',33.333,4),(1038,7563895,7563892,'dmi',33.333,4),(1038,7563896,7563892,'min',33.333,4),(1038,7563897,7563894,'cap',16.667,1),(1038,7563898,7563894,'apa',16.667,1),(1038,7563899,7563894,'pac',16.667,1),(1038,7563900,7563894,'aci',16.667,1),(1038,7563901,7563894,'cit',16.667,1),(1038,7563902,7563894,'ity',16.667,1),(1038,7563903,7563897,'pat',50,1),(1038,7563904,7563897,'ath',50,1),(1038,7563905,7563903,'fre',14.286,1),(1038,7563906,7563903,'ree',14.286,1),(1038,7563907,7563903,'ees',14.286,1),(1038,7563908,7563903,'esp',14.286,1),(1038,7563909,7563903,'spa',14.286,1),(1038,7563910,7563903,'pac',14.286,1),(1038,7563911,7563903,'ace',14.286,1),(1038,7563912,7563905,'dis',50,1),(1038,7563913,7563905,'isk',50,1),(1038,7563914,7563912,'ind',33.333,1),(1038,7563915,7563912,'nde',33.333,1),(1038,7563916,7563912,'dex',33.333,1),(1038,7563917,7563914,'adm',8.333,1),(1038,7563918,7563914,'dmi',8.333,1),(1038,7563919,7563914,'min',8.333,1),(1038,7563920,7563914,'ini',8.333,1),(1038,7563921,7563914,'nis',8.333,1),(1038,7563922,7563914,'ist',8.333,1),(1038,7563923,7563914,'str',8.333,1),(1038,7563924,7563914,'tra',8.333,1),(1038,7563925,7563914,'rat',8.333,1),(1038,7563926,7563914,'ati',8.333,1),(1038,7563927,7563914,'tio',8.333,1),(1038,7563928,7563914,'ion',8.333,1),(1038,7563929,7563917,'sta',33.333,3),(1038,7563930,7563917,'tat',33.333,3),(1038,7563931,7563917,'ate',33.333,3),(1038,7563932,7563929,'dis',16.667,4),(1038,7563933,7563929,'isa',16.667,4),(1038,7563934,7563929,'sab',16.667,4),(1038,7563935,7563929,'abl',16.667,4),(1038,7563936,7563929,'ble',16.667,4),(1038,7563937,7563929,'led',16.667,4),(1038,7563938,7563932,'cac',33.333,1),(1038,7563939,7563932,'ach',33.333,1),(1038,7563940,7563932,'che',33.333,1),(1038,7563941,7563938,'mod',50,1),(1038,7563942,7563938,'ode',50,1),(1038,7563943,7563941,'wri',14.286,1),(1038,7563944,7563941,'rit',14.286,1),(1038,7563945,7563941,'ite',14.286,1),(1038,7563946,7563941,'tet',14.286,1),(1038,7563947,7563941,'eth',14.286,1),(1038,7563948,7563941,'thr',14.286,1),(1038,7563949,7563941,'hru',14.286,1),(1038,7563950,7563943,'ope',11.111,2),(1038,7563951,7563943,'per',11.111,2),(1038,7563952,7563943,'era',11.111,2),(1038,7563953,7563943,'rat',11.111,2),(1038,7563954,7563943,'ati',11.111,2),(1038,7563955,7563943,'tio',11.111,2),(1038,7563956,7563943,'ion',11.111,2),(1038,7563957,7563943,'ona',11.111,2),(1038,7563958,7563943,'nal',11.111,2),(1038,7563959,7563950,'mes',20,1),(1038,7563960,7563950,'ess',20,1),(1038,7563961,7563950,'ssa',20,1),(1038,7563962,7563950,'sag',20,1),(1038,7563963,7563950,'age',20,1),(1038,7563964,7563959,'per',11.111,1),(1038,7563965,7563959,'erf',11.111,1),(1038,7563966,7563959,'rfo',11.111,1),(1038,7563967,7563959,'for',11.111,1),(1038,7563968,7563959,'orm',11.111,1),(1038,7563969,7563959,'rma',11.111,1),(1038,7563970,7563959,'man',11.111,1),(1038,7563971,7563959,'anc',11.111,1),(1038,7563972,7563959,'nce',11.111,1),(1038,7563973,7563964,'ide',12.5,1),(1038,7563974,7563964,'den',12.5,1),(1038,7563975,7563964,'ent',12.5,1),(1038,7563976,7563964,'nti',12.5,1),(1038,7563977,7563964,'tif',12.5,1),(1038,7563978,7563964,'ifi',12.5,1),(1038,7563979,7563964,'fie',12.5,1),(1038,7563980,7563964,'ier',12.5,1),(1038,7563981,7563973,'vdi',33.333,3),(1038,7563982,7563973,'dis',33.333,3),(1038,7563983,7563973,'isk',33.333,3),(1038,7563984,7563981,'nam',50,1),(1038,7563985,7563981,'ame',50,1),(1038,7563986,7563984,'typ',50,1),(1038,7563987,7563984,'ype',50,1),(1038,7563988,7563986,'dir',25,1),(1038,7563989,7563986,'ire',25,1),(1038,7563990,7563986,'rec',25,1),(1038,7563991,7563986,'ect',25,1),(1039,7563993,7563992,'naa',100,2),(1039,7563994,7563993,'600',3.333,3),(1039,7563995,7563993,'000',3.333,3),(1039,7563996,7563993,'00c',3.333,3),(1039,7563997,7563993,'0c2',3.333,3),(1039,7563998,7563993,'c29',3.333,3),(1039,7563999,7563993,'291',3.333,3),(1039,7564000,7563993,'91b',3.333,3),(1039,7564001,7563993,'1bc',3.333,3),(1039,7564002,7563993,'bc3',3.333,3),(1039,7564003,7563993,'c37',3.333,3),(1039,7564004,7563993,'37a',3.333,3),(1039,7564005,7563993,'7a7',3.333,3),(1039,7564006,7563993,'a74',3.333,3),(1039,7564007,7563993,'74f',3.333,3),(1039,7564008,7563993,'4fd',3.333,3),(1039,7564009,7563993,'fd5',3.333,3),(1039,7564010,7563993,'d5c',3.333,3),(1039,7564011,7563993,'5c3',3.333,3),(1039,7564012,7563993,'c39',3.333,3),(1039,7564013,7563993,'398',3.333,3),(1039,7564014,7563993,'98a',3.333,3),(1039,7564015,7563993,'8a8',3.333,3),(1039,7564016,7563993,'a84',3.333,3),(1039,7564017,7563993,'84f',3.333,3),(1039,7564018,7563993,'4f7',3.333,3),(1039,7564019,7563993,'f76',3.333,3),(1039,7564020,7563993,'764',3.333,3),(1039,7564021,7563993,'641',3.333,3),(1039,7564022,7563993,'41e',3.333,3),(1039,7564023,7563993,'1e0',3.333,3),(1039,7564024,7563994,'mon',100,1),(1039,7564025,7564024,'201',50,1),(1039,7564026,7564024,'013',50,1),(1039,7564027,7564025,'adm',33.333,4),(1039,7564028,7564025,'dmi',33.333,4),(1039,7564029,7564025,'min',33.333,4),(1039,7564030,7564027,'cap',16.667,1),(1039,7564031,7564027,'apa',16.667,1),(1039,7564032,7564027,'pac',16.667,1),(1039,7564033,7564027,'aci',16.667,1),(1039,7564034,7564027,'cit',16.667,1),(1039,7564035,7564027,'ity',16.667,1),(1039,7564036,7564030,'pat',50,1),(1039,7564037,7564030,'ath',50,1),(1039,7564038,7564036,'fre',14.286,1),(1039,7564039,7564036,'ree',14.286,1),(1039,7564040,7564036,'ees',14.286,1),(1039,7564041,7564036,'esp',14.286,1),(1039,7564042,7564036,'spa',14.286,1),(1039,7564043,7564036,'pac',14.286,1),(1039,7564044,7564036,'ace',14.286,1),(1039,7564045,7564038,'dis',50,1),(1039,7564046,7564038,'isk',50,1),(1039,7564047,7564045,'ind',33.333,1),(1039,7564048,7564045,'nde',33.333,1),(1039,7564049,7564045,'dex',33.333,1),(1039,7564050,7564047,'adm',8.333,1),(1039,7564051,7564047,'dmi',8.333,1),(1039,7564052,7564047,'min',8.333,1),(1039,7564053,7564047,'ini',8.333,1),(1039,7564054,7564047,'nis',8.333,1),(1039,7564055,7564047,'ist',8.333,1),(1039,7564056,7564047,'str',8.333,1),(1039,7564057,7564047,'tra',8.333,1),(1039,7564058,7564047,'rat',8.333,1),(1039,7564059,7564047,'ati',8.333,1),(1039,7564060,7564047,'tio',8.333,1),(1039,7564061,7564047,'ion',8.333,1),(1039,7564062,7564050,'sta',33.333,3),(1039,7564063,7564050,'tat',33.333,3),(1039,7564064,7564050,'ate',33.333,3),(1039,7564065,7564062,'dis',16.667,4),(1039,7564066,7564062,'isa',16.667,4),(1039,7564067,7564062,'sab',16.667,4),(1039,7564068,7564062,'abl',16.667,4),(1039,7564069,7564062,'ble',16.667,4),(1039,7564070,7564062,'led',16.667,4),(1039,7564071,7564065,'cac',33.333,1),(1039,7564072,7564065,'ach',33.333,1),(1039,7564073,7564065,'che',33.333,1),(1039,7564074,7564071,'mod',50,1),(1039,7564075,7564071,'ode',50,1),(1039,7564076,7564074,'wri',14.286,1),(1039,7564077,7564074,'rit',14.286,1),(1039,7564078,7564074,'ite',14.286,1),(1039,7564079,7564074,'tet',14.286,1),(1039,7564080,7564074,'eth',14.286,1),(1039,7564081,7564074,'thr',14.286,1),(1039,7564082,7564074,'hru',14.286,1),(1039,7564083,7564076,'ope',11.111,2),(1039,7564084,7564076,'per',11.111,2),(1039,7564085,7564076,'era',11.111,2),(1039,7564086,7564076,'rat',11.111,2),(1039,7564087,7564076,'ati',11.111,2),(1039,7564088,7564076,'tio',11.111,2),(1039,7564089,7564076,'ion',11.111,2),(1039,7564090,7564076,'ona',11.111,2),(1039,7564091,7564076,'nal',11.111,2),(1039,7564092,7564083,'mes',20,1),(1039,7564093,7564083,'ess',20,1),(1039,7564094,7564083,'ssa',20,1),(1039,7564095,7564083,'sag',20,1),(1039,7564096,7564083,'age',20,1),(1039,7564097,7564092,'per',11.111,1),(1039,7564098,7564092,'erf',11.111,1),(1039,7564099,7564092,'rfo',11.111,1),(1039,7564100,7564092,'for',11.111,1),(1039,7564101,7564092,'orm',11.111,1),(1039,7564102,7564092,'rma',11.111,1),(1039,7564103,7564092,'man',11.111,1),(1039,7564104,7564092,'anc',11.111,1),(1039,7564105,7564092,'nce',11.111,1),(1039,7564106,7564097,'ide',12.5,1),(1039,7564107,7564097,'den',12.5,1),(1039,7564108,7564097,'ent',12.5,1),(1039,7564109,7564097,'nti',12.5,1),(1039,7564110,7564097,'tif',12.5,1),(1039,7564111,7564097,'ifi',12.5,1),(1039,7564112,7564097,'fie',12.5,1),(1039,7564113,7564097,'ier',12.5,1),(1039,7564114,7564106,'vdi',33.333,3),(1039,7564115,7564106,'dis',33.333,3),(1039,7564116,7564106,'isk',33.333,3),(1039,7564117,7564114,'nam',50,1),(1039,7564118,7564114,'ame',50,1),(1039,7564119,7564117,'typ',50,1),(1039,7564120,7564117,'ype',50,1),(1039,7564121,7564119,'dir',25,1),(1039,7564122,7564119,'ire',25,1),(1039,7564123,7564119,'rec',25,1),(1039,7564124,7564119,'ect',25,1),(1040,7564126,7564125,'naa',100,2),(1040,7564127,7564126,'600',3.333,3),(1040,7564128,7564126,'000',3.333,3),(1040,7564129,7564126,'00c',3.333,3),(1040,7564130,7564126,'0c2',3.333,3),(1040,7564131,7564126,'c29',3.333,3),(1040,7564132,7564126,'292',3.333,3),(1040,7564133,7564126,'925',3.333,3),(1040,7564134,7564126,'25a',3.333,3),(1040,7564135,7564126,'5ab',3.333,3),(1040,7564136,7564126,'abe',3.333,3),(1040,7564137,7564126,'be3',3.333,3),(1040,7564138,7564126,'e38',3.333,3),(1040,7564139,7564126,'385',3.333,3),(1040,7564140,7564126,'85a',3.333,3),(1040,7564141,7564126,'5a8',3.333,3),(1040,7564142,7564126,'a8f',3.333,3),(1040,7564143,7564126,'8f6',3.333,3),(1040,7564144,7564126,'f68',3.333,3),(1040,7564145,7564126,'68a',3.333,3),(1040,7564146,7564126,'8a4',3.333,3),(1040,7564147,7564126,'a4d',3.333,3),(1040,7564148,7564126,'4d0',3.333,3),(1040,7564149,7564126,'d05',3.333,3),(1040,7564150,7564126,'054',3.333,3),(1040,7564151,7564126,'542',3.333,3),(1040,7564152,7564126,'42e',3.333,3),(1040,7564153,7564126,'2e3',3.333,3),(1040,7564154,7564126,'e33',3.333,3),(1040,7564155,7564126,'33c',3.333,3),(1040,7564156,7564126,'3c8',3.333,3),(1040,7564157,7564127,'mon',100,1),(1040,7564158,7564157,'201',50,1),(1040,7564159,7564157,'013',50,1),(1040,7564160,7564158,'adm',33.333,4),(1040,7564161,7564158,'dmi',33.333,4),(1040,7564162,7564158,'min',33.333,4),(1040,7564163,7564160,'cap',16.667,1),(1040,7564164,7564160,'apa',16.667,1),(1040,7564165,7564160,'pac',16.667,1),(1040,7564166,7564160,'aci',16.667,1),(1040,7564167,7564160,'cit',16.667,1),(1040,7564168,7564160,'ity',16.667,1),(1040,7564169,7564163,'pat',50,1),(1040,7564170,7564163,'ath',50,1),(1040,7564171,7564169,'fre',14.286,1),(1040,7564172,7564169,'ree',14.286,1),(1040,7564173,7564169,'ees',14.286,1),(1040,7564174,7564169,'esp',14.286,1),(1040,7564175,7564169,'spa',14.286,1),(1040,7564176,7564169,'pac',14.286,1),(1040,7564177,7564169,'ace',14.286,1),(1040,7564178,7564171,'dis',50,1),(1040,7564179,7564171,'isk',50,1),(1040,7564180,7564178,'ind',33.333,1),(1040,7564181,7564178,'nde',33.333,1),(1040,7564182,7564178,'dex',33.333,1),(1040,7564183,7564180,'adm',8.333,1),(1040,7564184,7564180,'dmi',8.333,1),(1040,7564185,7564180,'min',8.333,1),(1040,7564186,7564180,'ini',8.333,1),(1040,7564187,7564180,'nis',8.333,1),(1040,7564188,7564180,'ist',8.333,1),(1040,7564189,7564180,'str',8.333,1),(1040,7564190,7564180,'tra',8.333,1),(1040,7564191,7564180,'rat',8.333,1),(1040,7564192,7564180,'ati',8.333,1),(1040,7564193,7564180,'tio',8.333,1),(1040,7564194,7564180,'ion',8.333,1),(1040,7564195,7564183,'sta',33.333,3),(1040,7564196,7564183,'tat',33.333,3),(1040,7564197,7564183,'ate',33.333,3),(1040,7564198,7564195,'dis',16.667,4),(1040,7564199,7564195,'isa',16.667,4),(1040,7564200,7564195,'sab',16.667,4),(1040,7564201,7564195,'abl',16.667,4),(1040,7564202,7564195,'ble',16.667,4),(1040,7564203,7564195,'led',16.667,4),(1040,7564204,7564198,'cac',33.333,1),(1040,7564205,7564198,'ach',33.333,1),(1040,7564206,7564198,'che',33.333,1),(1040,7564207,7564204,'mod',50,1),(1040,7564208,7564204,'ode',50,1),(1040,7564209,7564207,'wri',14.286,1),(1040,7564210,7564207,'rit',14.286,1),(1040,7564211,7564207,'ite',14.286,1),(1040,7564212,7564207,'tet',14.286,1),(1040,7564213,7564207,'eth',14.286,1),(1040,7564214,7564207,'thr',14.286,1),(1040,7564215,7564207,'hru',14.286,1),(1040,7564216,7564209,'ope',11.111,2),(1040,7564217,7564209,'per',11.111,2),(1040,7564218,7564209,'era',11.111,2),(1040,7564219,7564209,'rat',11.111,2),(1040,7564220,7564209,'ati',11.111,2),(1040,7564221,7564209,'tio',11.111,2),(1040,7564222,7564209,'ion',11.111,2),(1040,7564223,7564209,'ona',11.111,2),(1040,7564224,7564209,'nal',11.111,2),(1040,7564225,7564216,'mes',20,1),(1040,7564226,7564216,'ess',20,1),(1040,7564227,7564216,'ssa',20,1),(1040,7564228,7564216,'sag',20,1),(1040,7564229,7564216,'age',20,1),(1040,7564230,7564225,'per',11.111,1),(1040,7564231,7564225,'erf',11.111,1),(1040,7564232,7564225,'rfo',11.111,1),(1040,7564233,7564225,'for',11.111,1),(1040,7564234,7564225,'orm',11.111,1),(1040,7564235,7564225,'rma',11.111,1),(1040,7564236,7564225,'man',11.111,1),(1040,7564237,7564225,'anc',11.111,1),(1040,7564238,7564225,'nce',11.111,1),(1040,7564239,7564230,'ide',12.5,1),(1040,7564240,7564230,'den',12.5,1),(1040,7564241,7564230,'ent',12.5,1),(1040,7564242,7564230,'nti',12.5,1),(1040,7564243,7564230,'tif',12.5,1),(1040,7564244,7564230,'ifi',12.5,1),(1040,7564245,7564230,'fie',12.5,1),(1040,7564246,7564230,'ier',12.5,1),(1040,7564247,7564239,'vdi',33.333,3),(1040,7564248,7564239,'dis',33.333,3),(1040,7564249,7564239,'isk',33.333,3),(1040,7564250,7564247,'nam',50,1),(1040,7564251,7564247,'ame',50,1),(1040,7564252,7564250,'typ',50,1),(1040,7564253,7564250,'ype',50,1),(1040,7564254,7564252,'dir',25,1),(1040,7564255,7564252,'ire',25,1),(1040,7564256,7564252,'rec',25,1),(1040,7564257,7564252,'ect',25,1),(1041,7564259,7564258,'naa',100,2),(1041,7564260,7564259,'600',3.333,3),(1041,7564261,7564259,'000',3.333,3),(1041,7564262,7564259,'00c',3.333,3),(1041,7564263,7564259,'0c2',3.333,3),(1041,7564264,7564259,'c29',3.333,3),(1041,7564265,7564259,'29c',3.333,3),(1041,7564266,7564259,'9cb',3.333,3),(1041,7564267,7564259,'cb2',3.333,3),(1041,7564268,7564259,'b28',3.333,3),(1041,7564269,7564259,'284',3.333,3),(1041,7564270,7564259,'84a',3.333,3),(1041,7564271,7564259,'4a7',3.333,3),(1041,7564272,7564259,'a71',3.333,3),(1041,7564273,7564259,'715',3.333,3),(1041,7564274,7564259,'150',3.333,3),(1041,7564275,7564259,'509',3.333,3),(1041,7564276,7564259,'093',3.333,3),(1041,7564277,7564259,'93d',3.333,3),(1041,7564278,7564259,'3da',3.333,3),(1041,7564279,7564259,'da6',3.333,3),(1041,7564280,7564259,'a6b',3.333,3),(1041,7564281,7564259,'6b1',3.333,3),(1041,7564282,7564259,'b11',3.333,3),(1041,7564283,7564259,'11e',3.333,3),(1041,7564284,7564259,'1e0',3.333,3),(1041,7564285,7564259,'e01',3.333,3),(1041,7564286,7564259,'012',3.333,3),(1041,7564287,7564259,'129',3.333,3),(1041,7564288,7564259,'29f',3.333,3),(1041,7564289,7564259,'9fc',3.333,3),(1041,7564290,7564260,'mon',100,1),(1041,7564291,7564290,'201',50,1),(1041,7564292,7564290,'013',50,1),(1041,7564293,7564291,'adm',33.333,4),(1041,7564294,7564291,'dmi',33.333,4),(1041,7564295,7564291,'min',33.333,4),(1041,7564296,7564293,'cap',16.667,1),(1041,7564297,7564293,'apa',16.667,1),(1041,7564298,7564293,'pac',16.667,1),(1041,7564299,7564293,'aci',16.667,1),(1041,7564300,7564293,'cit',16.667,1),(1041,7564301,7564293,'ity',16.667,1),(1041,7564302,7564296,'pat',50,1),(1041,7564303,7564296,'ath',50,1),(1041,7564304,7564302,'fre',14.286,1),(1041,7564305,7564302,'ree',14.286,1),(1041,7564306,7564302,'ees',14.286,1),(1041,7564307,7564302,'esp',14.286,1),(1041,7564308,7564302,'spa',14.286,1),(1041,7564309,7564302,'pac',14.286,1),(1041,7564310,7564302,'ace',14.286,1),(1041,7564311,7564304,'dis',50,1),(1041,7564312,7564304,'isk',50,1),(1041,7564313,7564311,'ind',33.333,1),(1041,7564314,7564311,'nde',33.333,1),(1041,7564315,7564311,'dex',33.333,1),(1041,7564316,7564313,'adm',8.333,1),(1041,7564317,7564313,'dmi',8.333,1),(1041,7564318,7564313,'min',8.333,1),(1041,7564319,7564313,'ini',8.333,1),(1041,7564320,7564313,'nis',8.333,1),(1041,7564321,7564313,'ist',8.333,1),(1041,7564322,7564313,'str',8.333,1),(1041,7564323,7564313,'tra',8.333,1),(1041,7564324,7564313,'rat',8.333,1),(1041,7564325,7564313,'ati',8.333,1),(1041,7564326,7564313,'tio',8.333,1),(1041,7564327,7564313,'ion',8.333,1),(1041,7564328,7564316,'sta',33.333,3),(1041,7564329,7564316,'tat',33.333,3),(1041,7564330,7564316,'ate',33.333,3),(1041,7564331,7564328,'dis',16.667,4),(1041,7564332,7564328,'isa',16.667,4),(1041,7564333,7564328,'sab',16.667,4),(1041,7564334,7564328,'abl',16.667,4),(1041,7564335,7564328,'ble',16.667,4),(1041,7564336,7564328,'led',16.667,4),(1041,7564337,7564331,'cac',33.333,1),(1041,7564338,7564331,'ach',33.333,1),(1041,7564339,7564331,'che',33.333,1),(1041,7564340,7564337,'mod',50,1),(1041,7564341,7564337,'ode',50,1),(1041,7564342,7564340,'wri',14.286,1),(1041,7564343,7564340,'rit',14.286,1),(1041,7564344,7564340,'ite',14.286,1),(1041,7564345,7564340,'tet',14.286,1),(1041,7564346,7564340,'eth',14.286,1),(1041,7564347,7564340,'thr',14.286,1),(1041,7564348,7564340,'hru',14.286,1),(1041,7564349,7564342,'ope',11.111,2),(1041,7564350,7564342,'per',11.111,2),(1041,7564351,7564342,'era',11.111,2),(1041,7564352,7564342,'rat',11.111,2),(1041,7564353,7564342,'ati',11.111,2),(1041,7564354,7564342,'tio',11.111,2),(1041,7564355,7564342,'ion',11.111,2),(1041,7564356,7564342,'ona',11.111,2),(1041,7564357,7564342,'nal',11.111,2),(1041,7564358,7564349,'mes',20,1),(1041,7564359,7564349,'ess',20,1),(1041,7564360,7564349,'ssa',20,1),(1041,7564361,7564349,'sag',20,1),(1041,7564362,7564349,'age',20,1),(1041,7564363,7564358,'per',11.111,1),(1041,7564364,7564358,'erf',11.111,1),(1041,7564365,7564358,'rfo',11.111,1),(1041,7564366,7564358,'for',11.111,1),(1041,7564367,7564358,'orm',11.111,1),(1041,7564368,7564358,'rma',11.111,1),(1041,7564369,7564358,'man',11.111,1),(1041,7564370,7564358,'anc',11.111,1),(1041,7564371,7564358,'nce',11.111,1),(1041,7564372,7564363,'ide',12.5,1),(1041,7564373,7564363,'den',12.5,1),(1041,7564374,7564363,'ent',12.5,1),(1041,7564375,7564363,'nti',12.5,1),(1041,7564376,7564363,'tif',12.5,1),(1041,7564377,7564363,'ifi',12.5,1),(1041,7564378,7564363,'fie',12.5,1),(1041,7564379,7564363,'ier',12.5,1),(1041,7564380,7564372,'vdi',33.333,3),(1041,7564381,7564372,'dis',33.333,3),(1041,7564382,7564372,'isk',33.333,3),(1041,7564383,7564380,'nam',50,1),(1041,7564384,7564380,'ame',50,1),(1041,7564385,7564383,'typ',50,1),(1041,7564386,7564383,'ype',50,1),(1041,7564387,7564385,'dir',25,1),(1041,7564388,7564385,'ire',25,1),(1041,7564389,7564385,'rec',25,1),(1041,7564390,7564385,'ect',25,1),(1042,7564392,7564391,'naa',100,2),(1042,7564393,7564392,'600',3.333,3),(1042,7564394,7564392,'000',3.333,3),(1042,7564395,7564392,'00c',3.333,3),(1042,7564396,7564392,'0c2',3.333,3),(1042,7564397,7564392,'c29',3.333,3),(1042,7564398,7564392,'29f',3.333,3),(1042,7564399,7564392,'9f7',3.333,3),(1042,7564400,7564392,'f70',3.333,3),(1042,7564401,7564392,'702',3.333,3),(1042,7564402,7564392,'02b',3.333,3),(1042,7564403,7564392,'2b2',3.333,3),(1042,7564404,7564392,'b28',3.333,3),(1042,7564405,7564392,'287',3.333,3),(1042,7564406,7564392,'878',3.333,3),(1042,7564407,7564392,'78f',3.333,3),(1042,7564408,7564392,'8fa',3.333,3),(1042,7564409,7564392,'fae',3.333,3),(1042,7564410,7564392,'ae8',3.333,3),(1042,7564411,7564392,'e8f',3.333,3),(1042,7564412,7564392,'8f0',3.333,3),(1042,7564413,7564392,'f07',3.333,3),(1042,7564414,7564392,'07c',3.333,3),(1042,7564415,7564392,'7c2',3.333,3),(1042,7564416,7564392,'c2b',3.333,3),(1042,7564417,7564392,'2b0',3.333,3),(1042,7564418,7564392,'b0f',3.333,3),(1042,7564419,7564392,'0f7',3.333,3),(1042,7564420,7564392,'f70',3.333,3),(1042,7564421,7564392,'707',3.333,3),(1042,7564422,7564392,'077',3.333,3),(1042,7564423,7564393,'mon',100,1),(1042,7564424,7564423,'201',50,1),(1042,7564425,7564423,'013',50,1),(1042,7564426,7564424,'adm',33.333,4),(1042,7564427,7564424,'dmi',33.333,4),(1042,7564428,7564424,'min',33.333,4),(1042,7564429,7564426,'cap',16.667,1),(1042,7564430,7564426,'apa',16.667,1),(1042,7564431,7564426,'pac',16.667,1),(1042,7564432,7564426,'aci',16.667,1),(1042,7564433,7564426,'cit',16.667,1),(1042,7564434,7564426,'ity',16.667,1),(1042,7564435,7564429,'pat',50,1),(1042,7564436,7564429,'ath',50,1),(1042,7564437,7564435,'fre',14.286,1),(1042,7564438,7564435,'ree',14.286,1),(1042,7564439,7564435,'ees',14.286,1),(1042,7564440,7564435,'esp',14.286,1),(1042,7564441,7564435,'spa',14.286,1),(1042,7564442,7564435,'pac',14.286,1),(1042,7564443,7564435,'ace',14.286,1),(1042,7564444,7564437,'dis',50,1),(1042,7564445,7564437,'isk',50,1),(1042,7564446,7564444,'ind',33.333,1),(1042,7564447,7564444,'nde',33.333,1),(1042,7564448,7564444,'dex',33.333,1),(1042,7564449,7564446,'adm',8.333,1),(1042,7564450,7564446,'dmi',8.333,1),(1042,7564451,7564446,'min',8.333,1),(1042,7564452,7564446,'ini',8.333,1),(1042,7564453,7564446,'nis',8.333,1),(1042,7564454,7564446,'ist',8.333,1),(1042,7564455,7564446,'str',8.333,1),(1042,7564456,7564446,'tra',8.333,1),(1042,7564457,7564446,'rat',8.333,1),(1042,7564458,7564446,'ati',8.333,1),(1042,7564459,7564446,'tio',8.333,1),(1042,7564460,7564446,'ion',8.333,1),(1042,7564461,7564449,'sta',33.333,3),(1042,7564462,7564449,'tat',33.333,3),(1042,7564463,7564449,'ate',33.333,3),(1042,7564464,7564461,'dis',16.667,4),(1042,7564465,7564461,'isa',16.667,4),(1042,7564466,7564461,'sab',16.667,4),(1042,7564467,7564461,'abl',16.667,4),(1042,7564468,7564461,'ble',16.667,4),(1042,7564469,7564461,'led',16.667,4),(1042,7564470,7564464,'cac',33.333,1),(1042,7564471,7564464,'ach',33.333,1),(1042,7564472,7564464,'che',33.333,1),(1042,7564473,7564470,'mod',50,1),(1042,7564474,7564470,'ode',50,1),(1042,7564475,7564473,'wri',14.286,1),(1042,7564476,7564473,'rit',14.286,1),(1042,7564477,7564473,'ite',14.286,1),(1042,7564478,7564473,'tet',14.286,1),(1042,7564479,7564473,'eth',14.286,1),(1042,7564480,7564473,'thr',14.286,1),(1042,7564481,7564473,'hru',14.286,1),(1042,7564482,7564475,'ope',11.111,2),(1042,7564483,7564475,'per',11.111,2),(1042,7564484,7564475,'era',11.111,2),(1042,7564485,7564475,'rat',11.111,2),(1042,7564486,7564475,'ati',11.111,2),(1042,7564487,7564475,'tio',11.111,2),(1042,7564488,7564475,'ion',11.111,2),(1042,7564489,7564475,'ona',11.111,2),(1042,7564490,7564475,'nal',11.111,2),(1042,7564491,7564482,'mes',20,1),(1042,7564492,7564482,'ess',20,1),(1042,7564493,7564482,'ssa',20,1),(1042,7564494,7564482,'sag',20,1),(1042,7564495,7564482,'age',20,1),(1042,7564496,7564491,'per',11.111,1),(1042,7564497,7564491,'erf',11.111,1),(1042,7564498,7564491,'rfo',11.111,1),(1042,7564499,7564491,'for',11.111,1),(1042,7564500,7564491,'orm',11.111,1),(1042,7564501,7564491,'rma',11.111,1),(1042,7564502,7564491,'man',11.111,1),(1042,7564503,7564491,'anc',11.111,1),(1042,7564504,7564491,'nce',11.111,1),(1042,7564505,7564496,'ide',12.5,1),(1042,7564506,7564496,'den',12.5,1),(1042,7564507,7564496,'ent',12.5,1),(1042,7564508,7564496,'nti',12.5,1),(1042,7564509,7564496,'tif',12.5,1),(1042,7564510,7564496,'ifi',12.5,1),(1042,7564511,7564496,'fie',12.5,1),(1042,7564512,7564496,'ier',12.5,1),(1042,7564513,7564505,'vdi',33.333,3),(1042,7564514,7564505,'dis',33.333,3),(1042,7564515,7564505,'isk',33.333,3),(1042,7564516,7564513,'nam',50,1),(1042,7564517,7564513,'ame',50,1),(1042,7564518,7564516,'typ',50,1),(1042,7564519,7564516,'ype',50,1),(1042,7564520,7564518,'dir',25,1),(1042,7564521,7564518,'ire',25,1),(1042,7564522,7564518,'rec',25,1),(1042,7564523,7564518,'ect',25,1),(1043,7564525,7564524,'naa',100,2),(1043,7564526,7564525,'600',3.333,3),(1043,7564527,7564525,'000',3.333,3),(1043,7564528,7564525,'00c',3.333,3),(1043,7564529,7564525,'0c2',3.333,3),(1043,7564530,7564525,'c29',3.333,3),(1043,7564531,7564525,'295',3.333,3),(1043,7564532,7564525,'953',3.333,3),(1043,7564533,7564525,'535',3.333,3),(1043,7564534,7564525,'351',3.333,3),(1043,7564535,7564525,'51a',3.333,3),(1043,7564536,7564525,'1ab',3.333,3),(1043,7564537,7564525,'ab5',3.333,3),(1043,7564538,7564525,'b5b',3.333,3),(1043,7564539,7564525,'5b0',3.333,3),(1043,7564540,7564525,'b0e',3.333,3),(1043,7564541,7564525,'0e5',3.333,3),(1043,7564542,7564525,'e55',3.333,3),(1043,7564543,7564525,'553',3.333,3),(1043,7564544,7564525,'53d',3.333,3),(1043,7564545,7564525,'3d4',3.333,3),(1043,7564546,7564525,'d42',3.333,3),(1043,7564547,7564525,'425',3.333,3),(1043,7564548,7564525,'259',3.333,3),(1043,7564549,7564525,'590',3.333,3),(1043,7564550,7564525,'909',3.333,3),(1043,7564551,7564525,'09d',3.333,3),(1043,7564552,7564525,'9d4',3.333,3),(1043,7564553,7564525,'d40',3.333,3),(1043,7564554,7564525,'40d',3.333,3),(1043,7564555,7564525,'0d9',3.333,3),(1043,7564556,7564526,'mon',100,1),(1043,7564557,7564556,'201',50,1),(1043,7564558,7564556,'013',50,1),(1043,7564559,7564557,'adm',33.333,4),(1043,7564560,7564557,'dmi',33.333,4),(1043,7564561,7564557,'min',33.333,4),(1043,7564562,7564559,'cap',16.667,1),(1043,7564563,7564559,'apa',16.667,1),(1043,7564564,7564559,'pac',16.667,1),(1043,7564565,7564559,'aci',16.667,1),(1043,7564566,7564559,'cit',16.667,1),(1043,7564567,7564559,'ity',16.667,1),(1043,7564568,7564562,'pat',50,1),(1043,7564569,7564562,'ath',50,1),(1043,7564570,7564568,'fre',14.286,1),(1043,7564571,7564568,'ree',14.286,1),(1043,7564572,7564568,'ees',14.286,1),(1043,7564573,7564568,'esp',14.286,1),(1043,7564574,7564568,'spa',14.286,1),(1043,7564575,7564568,'pac',14.286,1),(1043,7564576,7564568,'ace',14.286,1),(1043,7564577,7564570,'dis',50,1),(1043,7564578,7564570,'isk',50,1),(1043,7564579,7564577,'ind',33.333,1),(1043,7564580,7564577,'nde',33.333,1),(1043,7564581,7564577,'dex',33.333,1),(1043,7564582,7564579,'adm',8.333,1),(1043,7564583,7564579,'dmi',8.333,1),(1043,7564584,7564579,'min',8.333,1),(1043,7564585,7564579,'ini',8.333,1),(1043,7564586,7564579,'nis',8.333,1),(1043,7564587,7564579,'ist',8.333,1),(1043,7564588,7564579,'str',8.333,1),(1043,7564589,7564579,'tra',8.333,1),(1043,7564590,7564579,'rat',8.333,1),(1043,7564591,7564579,'ati',8.333,1),(1043,7564592,7564579,'tio',8.333,1),(1043,7564593,7564579,'ion',8.333,1),(1043,7564594,7564582,'sta',33.333,3),(1043,7564595,7564582,'tat',33.333,3),(1043,7564596,7564582,'ate',33.333,3),(1043,7564597,7564594,'dis',16.667,4),(1043,7564598,7564594,'isa',16.667,4),(1043,7564599,7564594,'sab',16.667,4),(1043,7564600,7564594,'abl',16.667,4),(1043,7564601,7564594,'ble',16.667,4),(1043,7564602,7564594,'led',16.667,4),(1043,7564603,7564597,'cac',33.333,1),(1043,7564604,7564597,'ach',33.333,1),(1043,7564605,7564597,'che',33.333,1),(1043,7564606,7564603,'mod',50,1),(1043,7564607,7564603,'ode',50,1),(1043,7564608,7564606,'wri',14.286,1),(1043,7564609,7564606,'rit',14.286,1),(1043,7564610,7564606,'ite',14.286,1),(1043,7564611,7564606,'tet',14.286,1),(1043,7564612,7564606,'eth',14.286,1),(1043,7564613,7564606,'thr',14.286,1),(1043,7564614,7564606,'hru',14.286,1),(1043,7564615,7564608,'ope',11.111,2),(1043,7564616,7564608,'per',11.111,2),(1043,7564617,7564608,'era',11.111,2),(1043,7564618,7564608,'rat',11.111,2),(1043,7564619,7564608,'ati',11.111,2),(1043,7564620,7564608,'tio',11.111,2),(1043,7564621,7564608,'ion',11.111,2),(1043,7564622,7564608,'ona',11.111,2),(1043,7564623,7564608,'nal',11.111,2),(1043,7564624,7564615,'mes',20,1),(1043,7564625,7564615,'ess',20,1),(1043,7564626,7564615,'ssa',20,1),(1043,7564627,7564615,'sag',20,1),(1043,7564628,7564615,'age',20,1),(1043,7564629,7564624,'per',11.111,1),(1043,7564630,7564624,'erf',11.111,1),(1043,7564631,7564624,'rfo',11.111,1),(1043,7564632,7564624,'for',11.111,1),(1043,7564633,7564624,'orm',11.111,1),(1043,7564634,7564624,'rma',11.111,1),(1043,7564635,7564624,'man',11.111,1),(1043,7564636,7564624,'anc',11.111,1),(1043,7564637,7564624,'nce',11.111,1),(1043,7564638,7564629,'ide',12.5,1),(1043,7564639,7564629,'den',12.5,1),(1043,7564640,7564629,'ent',12.5,1),(1043,7564641,7564629,'nti',12.5,1),(1043,7564642,7564629,'tif',12.5,1),(1043,7564643,7564629,'ifi',12.5,1),(1043,7564644,7564629,'fie',12.5,1),(1043,7564645,7564629,'ier',12.5,1),(1043,7564646,7564638,'vdi',33.333,3),(1043,7564647,7564638,'dis',33.333,3),(1043,7564648,7564638,'isk',33.333,3),(1043,7564649,7564646,'nam',50,1),(1043,7564650,7564646,'ame',50,1),(1043,7564651,7564649,'typ',50,1),(1043,7564652,7564649,'ype',50,1),(1043,7564653,7564651,'dir',25,1),(1043,7564654,7564651,'ire',25,1),(1043,7564655,7564651,'rec',25,1),(1043,7564656,7564651,'ect',25,1),(1044,7564658,7564657,'naa',100,2),(1044,7564659,7564658,'600',3.333,3),(1044,7564660,7564658,'000',3.333,3),(1044,7564661,7564658,'00c',3.333,3),(1044,7564662,7564658,'0c2',3.333,3),(1044,7564663,7564658,'c29',3.333,3),(1044,7564664,7564658,'295',3.333,3),(1044,7564665,7564658,'95f',3.333,3),(1044,7564666,7564658,'5ff',3.333,3),(1044,7564667,7564658,'ff5',3.333,3),(1044,7564668,7564658,'f58',3.333,3),(1044,7564669,7564658,'582',3.333,3),(1044,7564670,7564658,'82a',3.333,3),(1044,7564671,7564658,'2ab',3.333,3),(1044,7564672,7564658,'abe',3.333,3),(1044,7564673,7564658,'be8',3.333,3),(1044,7564674,7564658,'e88',3.333,3),(1044,7564675,7564658,'88f',3.333,3),(1044,7564676,7564658,'8fa',3.333,3),(1044,7564677,7564658,'fa6',3.333,3),(1044,7564678,7564658,'a6c',3.333,3),(1044,7564679,7564658,'6cd',3.333,3),(1044,7564680,7564658,'cdc',3.333,3),(1044,7564681,7564658,'dc2',3.333,3),(1044,7564682,7564658,'c28',3.333,3),(1044,7564683,7564658,'285',3.333,3),(1044,7564684,7564658,'858',3.333,3),(1044,7564685,7564658,'58d',3.333,3),(1044,7564686,7564658,'8d8',3.333,3),(1044,7564687,7564658,'d89',3.333,3),(1044,7564688,7564658,'890',3.333,3),(1044,7564689,7564659,'mon',100,1),(1044,7564690,7564689,'201',50,1),(1044,7564691,7564689,'013',50,1),(1044,7564692,7564690,'adm',33.333,4),(1044,7564693,7564690,'dmi',33.333,4),(1044,7564694,7564690,'min',33.333,4),(1044,7564695,7564692,'cap',16.667,1),(1044,7564696,7564692,'apa',16.667,1),(1044,7564697,7564692,'pac',16.667,1),(1044,7564698,7564692,'aci',16.667,1),(1044,7564699,7564692,'cit',16.667,1),(1044,7564700,7564692,'ity',16.667,1),(1044,7564701,7564695,'pat',50,1),(1044,7564702,7564695,'ath',50,1),(1044,7564703,7564701,'fiv',50,1),(1044,7564704,7564701,'ive',50,1),(1044,7564705,7564703,'fre',14.286,1),(1044,7564706,7564703,'ree',14.286,1),(1044,7564707,7564703,'ees',14.286,1),(1044,7564708,7564703,'esp',14.286,1),(1044,7564709,7564703,'spa',14.286,1),(1044,7564710,7564703,'pac',14.286,1),(1044,7564711,7564703,'ace',14.286,1),(1044,7564712,7564705,'dis',50,1),(1044,7564713,7564705,'isk',50,1),(1044,7564714,7564712,'ind',33.333,1),(1044,7564715,7564712,'nde',33.333,1),(1044,7564716,7564712,'dex',33.333,1),(1044,7564717,7564714,'adm',8.333,1),(1044,7564718,7564714,'dmi',8.333,1),(1044,7564719,7564714,'min',8.333,1),(1044,7564720,7564714,'ini',8.333,1),(1044,7564721,7564714,'nis',8.333,1),(1044,7564722,7564714,'ist',8.333,1),(1044,7564723,7564714,'str',8.333,1),(1044,7564724,7564714,'tra',8.333,1),(1044,7564725,7564714,'rat',8.333,1),(1044,7564726,7564714,'ati',8.333,1),(1044,7564727,7564714,'tio',8.333,1),(1044,7564728,7564714,'ion',8.333,1),(1044,7564729,7564717,'sta',33.333,3),(1044,7564730,7564717,'tat',33.333,3),(1044,7564731,7564717,'ate',33.333,3),(1044,7564732,7564729,'dis',16.667,4),(1044,7564733,7564729,'isa',16.667,4),(1044,7564734,7564729,'sab',16.667,4),(1044,7564735,7564729,'abl',16.667,4),(1044,7564736,7564729,'ble',16.667,4),(1044,7564737,7564729,'led',16.667,4),(1044,7564738,7564732,'cac',33.333,1),(1044,7564739,7564732,'ach',33.333,1),(1044,7564740,7564732,'che',33.333,1),(1044,7564741,7564738,'mod',50,1),(1044,7564742,7564738,'ode',50,1),(1044,7564743,7564741,'wri',14.286,1),(1044,7564744,7564741,'rit',14.286,1),(1044,7564745,7564741,'ite',14.286,1),(1044,7564746,7564741,'tet',14.286,1),(1044,7564747,7564741,'eth',14.286,1),(1044,7564748,7564741,'thr',14.286,1),(1044,7564749,7564741,'hru',14.286,1),(1044,7564750,7564743,'ope',11.111,2),(1044,7564751,7564743,'per',11.111,2),(1044,7564752,7564743,'era',11.111,2),(1044,7564753,7564743,'rat',11.111,2),(1044,7564754,7564743,'ati',11.111,2),(1044,7564755,7564743,'tio',11.111,2),(1044,7564756,7564743,'ion',11.111,2),(1044,7564757,7564743,'ona',11.111,2),(1044,7564758,7564743,'nal',11.111,2),(1044,7564759,7564750,'mes',20,1),(1044,7564760,7564750,'ess',20,1),(1044,7564761,7564750,'ssa',20,1),(1044,7564762,7564750,'sag',20,1),(1044,7564763,7564750,'age',20,1),(1044,7564764,7564759,'per',11.111,1),(1044,7564765,7564759,'erf',11.111,1),(1044,7564766,7564759,'rfo',11.111,1),(1044,7564767,7564759,'for',11.111,1),(1044,7564768,7564759,'orm',11.111,1),(1044,7564769,7564759,'rma',11.111,1),(1044,7564770,7564759,'man',11.111,1),(1044,7564771,7564759,'anc',11.111,1),(1044,7564772,7564759,'nce',11.111,1),(1044,7564773,7564764,'ide',12.5,1),(1044,7564774,7564764,'den',12.5,1),(1044,7564775,7564764,'ent',12.5,1),(1044,7564776,7564764,'nti',12.5,1),(1044,7564777,7564764,'tif',12.5,1),(1044,7564778,7564764,'ifi',12.5,1),(1044,7564779,7564764,'fie',12.5,1),(1044,7564780,7564764,'ier',12.5,1),(1044,7564781,7564773,'vdi',33.333,3),(1044,7564782,7564773,'dis',33.333,3),(1044,7564783,7564773,'isk',33.333,3),(1044,7564784,7564781,'nam',50,1),(1044,7564785,7564781,'ame',50,1),(1044,7564786,7564784,'typ',50,1),(1044,7564787,7564784,'ype',50,1),(1044,7564788,7564786,'dir',25,1),(1044,7564789,7564786,'ire',25,1),(1044,7564790,7564786,'rec',25,1),(1044,7564791,7564786,'ect',25,1),(1045,7564793,7564792,'naa',100,2),(1045,7564794,7564793,'600',3.333,3),(1045,7564795,7564793,'000',3.333,3),(1045,7564796,7564793,'00c',3.333,3),(1045,7564797,7564793,'0c2',3.333,3),(1045,7564798,7564793,'c29',3.333,3),(1045,7564799,7564793,'29d',3.333,3),(1045,7564800,7564793,'9d3',3.333,3),(1045,7564801,7564793,'d35',3.333,3),(1045,7564802,7564793,'350',3.333,3),(1045,7564803,7564793,'504',3.333,3),(1045,7564804,7564793,'045',3.333,3),(1045,7564805,7564793,'459',3.333,3),(1045,7564806,7564793,'592',3.333,3),(1045,7564807,7564793,'92e',3.333,3),(1045,7564808,7564793,'2ea',3.333,3),(1045,7564809,7564793,'ea1',3.333,3),(1045,7564810,7564793,'a11',3.333,3),(1045,7564811,7564793,'118',3.333,3),(1045,7564812,7564793,'189',3.333,3),(1045,7564813,7564793,'898',3.333,3),(1045,7564814,7564793,'98c',3.333,3),(1045,7564815,7564793,'8cf',3.333,3),(1045,7564816,7564793,'cf3',3.333,3),(1045,7564817,7564793,'f3b',3.333,3),(1045,7564818,7564793,'3b3',3.333,3),(1045,7564819,7564793,'b3b',3.333,3),(1045,7564820,7564793,'3b9',3.333,3),(1045,7564821,7564793,'b9a',3.333,3),(1045,7564822,7564793,'9af',3.333,3),(1045,7564823,7564793,'af0',3.333,3),(1045,7564824,7564794,'mon',100,1),(1045,7564825,7564824,'201',50,1),(1045,7564826,7564824,'013',50,1),(1045,7564827,7564825,'adm',33.333,4),(1045,7564828,7564825,'dmi',33.333,4),(1045,7564829,7564825,'min',33.333,4),(1045,7564830,7564827,'cap',16.667,1),(1045,7564831,7564827,'apa',16.667,1),(1045,7564832,7564827,'pac',16.667,1),(1045,7564833,7564827,'aci',16.667,1),(1045,7564834,7564827,'cit',16.667,1),(1045,7564835,7564827,'ity',16.667,1),(1045,7564836,7564830,'pat',50,1),(1045,7564837,7564830,'ath',50,1),(1045,7564838,7564836,'nin',50,1),(1045,7564839,7564836,'ine',50,1),(1045,7564840,7564838,'fre',14.286,1),(1045,7564841,7564838,'ree',14.286,1),(1045,7564842,7564838,'ees',14.286,1),(1045,7564843,7564838,'esp',14.286,1),(1045,7564844,7564838,'spa',14.286,1),(1045,7564845,7564838,'pac',14.286,1),(1045,7564846,7564838,'ace',14.286,1),(1045,7564847,7564840,'dis',50,1),(1045,7564848,7564840,'isk',50,1),(1045,7564849,7564847,'ind',33.333,1),(1045,7564850,7564847,'nde',33.333,1),(1045,7564851,7564847,'dex',33.333,1),(1045,7564852,7564849,'adm',8.333,1),(1045,7564853,7564849,'dmi',8.333,1),(1045,7564854,7564849,'min',8.333,1),(1045,7564855,7564849,'ini',8.333,1),(1045,7564856,7564849,'nis',8.333,1),(1045,7564857,7564849,'ist',8.333,1),(1045,7564858,7564849,'str',8.333,1),(1045,7564859,7564849,'tra',8.333,1),(1045,7564860,7564849,'rat',8.333,1),(1045,7564861,7564849,'ati',8.333,1),(1045,7564862,7564849,'tio',8.333,1),(1045,7564863,7564849,'ion',8.333,1),(1045,7564864,7564852,'sta',33.333,3),(1045,7564865,7564852,'tat',33.333,3),(1045,7564866,7564852,'ate',33.333,3),(1045,7564867,7564864,'dis',16.667,4),(1045,7564868,7564864,'isa',16.667,4),(1045,7564869,7564864,'sab',16.667,4),(1045,7564870,7564864,'abl',16.667,4),(1045,7564871,7564864,'ble',16.667,4),(1045,7564872,7564864,'led',16.667,4),(1045,7564873,7564867,'cac',33.333,1),(1045,7564874,7564867,'ach',33.333,1),(1045,7564875,7564867,'che',33.333,1),(1045,7564876,7564873,'mod',50,1),(1045,7564877,7564873,'ode',50,1),(1045,7564878,7564876,'wri',14.286,1),(1045,7564879,7564876,'rit',14.286,1),(1045,7564880,7564876,'ite',14.286,1),(1045,7564881,7564876,'tet',14.286,1),(1045,7564882,7564876,'eth',14.286,1),(1045,7564883,7564876,'thr',14.286,1),(1045,7564884,7564876,'hru',14.286,1),(1045,7564885,7564878,'ope',11.111,2),(1045,7564886,7564878,'per',11.111,2),(1045,7564887,7564878,'era',11.111,2),(1045,7564888,7564878,'rat',11.111,2),(1045,7564889,7564878,'ati',11.111,2),(1045,7564890,7564878,'tio',11.111,2),(1045,7564891,7564878,'ion',11.111,2),(1045,7564892,7564878,'ona',11.111,2),(1045,7564893,7564878,'nal',11.111,2),(1045,7564894,7564885,'mes',20,1),(1045,7564895,7564885,'ess',20,1),(1045,7564896,7564885,'ssa',20,1),(1045,7564897,7564885,'sag',20,1),(1045,7564898,7564885,'age',20,1),(1045,7564899,7564894,'per',11.111,1),(1045,7564900,7564894,'erf',11.111,1),(1045,7564901,7564894,'rfo',11.111,1),(1045,7564902,7564894,'for',11.111,1),(1045,7564903,7564894,'orm',11.111,1),(1045,7564904,7564894,'rma',11.111,1),(1045,7564905,7564894,'man',11.111,1),(1045,7564906,7564894,'anc',11.111,1),(1045,7564907,7564894,'nce',11.111,1),(1045,7564908,7564899,'ide',12.5,1),(1045,7564909,7564899,'den',12.5,1),(1045,7564910,7564899,'ent',12.5,1),(1045,7564911,7564899,'nti',12.5,1),(1045,7564912,7564899,'tif',12.5,1),(1045,7564913,7564899,'ifi',12.5,1),(1045,7564914,7564899,'fie',12.5,1),(1045,7564915,7564899,'ier',12.5,1),(1045,7564916,7564908,'vdi',33.333,3),(1045,7564917,7564908,'dis',33.333,3),(1045,7564918,7564908,'isk',33.333,3),(1045,7564919,7564916,'nam',50,1),(1045,7564920,7564916,'ame',50,1),(1045,7564921,7564919,'typ',50,1),(1045,7564922,7564919,'ype',50,1),(1045,7564923,7564921,'dir',25,1),(1045,7564924,7564921,'ire',25,1),(1045,7564925,7564921,'rec',25,1),(1045,7564926,7564921,'ect',25,1),(1046,7564928,7564927,'naa',100,2),(1046,7564929,7564928,'600',3.333,3),(1046,7564930,7564928,'000',3.333,3),(1046,7564931,7564928,'00c',3.333,3),(1046,7564932,7564928,'0c2',3.333,3),(1046,7564933,7564928,'c29',3.333,3),(1046,7564934,7564928,'299',3.333,3),(1046,7564935,7564928,'99a',3.333,3),(1046,7564936,7564928,'9a5',3.333,3),(1046,7564937,7564928,'a59',3.333,3),(1046,7564938,7564928,'597',3.333,3),(1046,7564939,7564928,'977',3.333,3),(1046,7564940,7564928,'77c',3.333,3),(1046,7564941,7564928,'7cc',3.333,3),(1046,7564942,7564928,'ccb',3.333,3),(1046,7564943,7564928,'cbf',3.333,3),(1046,7564944,7564928,'bf4',3.333,3),(1046,7564945,7564928,'f40',3.333,3),(1046,7564946,7564928,'403',3.333,3),(1046,7564947,7564928,'030',3.333,3),(1046,7564948,7564928,'302',3.333,3),(1046,7564949,7564928,'024',3.333,3),(1046,7564950,7564928,'244',3.333,3),(1046,7564951,7564928,'448',3.333,3),(1046,7564952,7564928,'488',3.333,3),(1046,7564953,7564928,'88a',3.333,3),(1046,7564954,7564928,'8a9',3.333,3),(1046,7564955,7564928,'a9d',3.333,3),(1046,7564956,7564928,'9d4',3.333,3),(1046,7564957,7564928,'d4d',3.333,3),(1046,7564958,7564928,'4d3',3.333,3),(1046,7564959,7564929,'mon',100,1),(1046,7564960,7564959,'201',50,1),(1046,7564961,7564959,'013',50,1),(1046,7564962,7564960,'adm',33.333,4),(1046,7564963,7564960,'dmi',33.333,4),(1046,7564964,7564960,'min',33.333,4),(1046,7564965,7564962,'cap',16.667,1),(1046,7564966,7564962,'apa',16.667,1),(1046,7564967,7564962,'pac',16.667,1),(1046,7564968,7564962,'aci',16.667,1),(1046,7564969,7564962,'cit',16.667,1),(1046,7564970,7564962,'ity',16.667,1),(1046,7564971,7564965,'pat',50,1),(1046,7564972,7564965,'ath',50,1),(1046,7564973,7564971,'fre',14.286,1),(1046,7564974,7564971,'ree',14.286,1),(1046,7564975,7564971,'ees',14.286,1),(1046,7564976,7564971,'esp',14.286,1),(1046,7564977,7564971,'spa',14.286,1),(1046,7564978,7564971,'pac',14.286,1),(1046,7564979,7564971,'ace',14.286,1),(1046,7564980,7564973,'dis',50,1),(1046,7564981,7564973,'isk',50,1),(1046,7564982,7564980,'ind',33.333,1),(1046,7564983,7564980,'nde',33.333,1),(1046,7564984,7564980,'dex',33.333,1),(1046,7564985,7564982,'adm',8.333,1),(1046,7564986,7564982,'dmi',8.333,1),(1046,7564987,7564982,'min',8.333,1),(1046,7564988,7564982,'ini',8.333,1),(1046,7564989,7564982,'nis',8.333,1),(1046,7564990,7564982,'ist',8.333,1),(1046,7564991,7564982,'str',8.333,1),(1046,7564992,7564982,'tra',8.333,1),(1046,7564993,7564982,'rat',8.333,1),(1046,7564994,7564982,'ati',8.333,1),(1046,7564995,7564982,'tio',8.333,1),(1046,7564996,7564982,'ion',8.333,1),(1046,7564997,7564985,'sta',33.333,3),(1046,7564998,7564985,'tat',33.333,3),(1046,7564999,7564985,'ate',33.333,3),(1046,7565000,7564997,'dis',16.667,4),(1046,7565001,7564997,'isa',16.667,4),(1046,7565002,7564997,'sab',16.667,4),(1046,7565003,7564997,'abl',16.667,4),(1046,7565004,7564997,'ble',16.667,4),(1046,7565005,7564997,'led',16.667,4),(1046,7565006,7565000,'cac',33.333,1),(1046,7565007,7565000,'ach',33.333,1),(1046,7565008,7565000,'che',33.333,1),(1046,7565009,7565006,'mod',50,1),(1046,7565010,7565006,'ode',50,1),(1046,7565011,7565009,'wri',14.286,1),(1046,7565012,7565009,'rit',14.286,1),(1046,7565013,7565009,'ite',14.286,1),(1046,7565014,7565009,'tet',14.286,1),(1046,7565015,7565009,'eth',14.286,1),(1046,7565016,7565009,'thr',14.286,1),(1046,7565017,7565009,'hru',14.286,1),(1046,7565018,7565011,'ope',11.111,2),(1046,7565019,7565011,'per',11.111,2),(1046,7565020,7565011,'era',11.111,2),(1046,7565021,7565011,'rat',11.111,2),(1046,7565022,7565011,'ati',11.111,2),(1046,7565023,7565011,'tio',11.111,2),(1046,7565024,7565011,'ion',11.111,2),(1046,7565025,7565011,'ona',11.111,2),(1046,7565026,7565011,'nal',11.111,2),(1046,7565027,7565018,'mes',20,1),(1046,7565028,7565018,'ess',20,1),(1046,7565029,7565018,'ssa',20,1),(1046,7565030,7565018,'sag',20,1),(1046,7565031,7565018,'age',20,1),(1046,7565032,7565027,'per',11.111,1),(1046,7565033,7565027,'erf',11.111,1),(1046,7565034,7565027,'rfo',11.111,1),(1046,7565035,7565027,'for',11.111,1),(1046,7565036,7565027,'orm',11.111,1),(1046,7565037,7565027,'rma',11.111,1),(1046,7565038,7565027,'man',11.111,1),(1046,7565039,7565027,'anc',11.111,1),(1046,7565040,7565027,'nce',11.111,1),(1046,7565041,7565032,'ide',12.5,1),(1046,7565042,7565032,'den',12.5,1),(1046,7565043,7565032,'ent',12.5,1),(1046,7565044,7565032,'nti',12.5,1),(1046,7565045,7565032,'tif',12.5,1),(1046,7565046,7565032,'ifi',12.5,1),(1046,7565047,7565032,'fie',12.5,1),(1046,7565048,7565032,'ier',12.5,1),(1046,7565049,7565041,'vdi',33.333,3),(1046,7565050,7565041,'dis',33.333,3),(1046,7565051,7565041,'isk',33.333,3),(1046,7565052,7565049,'nam',50,1),(1046,7565053,7565049,'ame',50,1),(1046,7565054,7565052,'typ',50,1),(1046,7565055,7565052,'ype',50,1),(1046,7565056,7565054,'dir',25,1),(1046,7565057,7565054,'ire',25,1),(1046,7565058,7565054,'rec',25,1),(1046,7565059,7565054,'ect',25,1),(1047,7565061,7565060,'naa',100,2),(1047,7565062,7565061,'600',3.333,3),(1047,7565063,7565061,'000',3.333,3),(1047,7565064,7565061,'00c',3.333,3),(1047,7565065,7565061,'0c2',3.333,3),(1047,7565066,7565061,'c29',3.333,3),(1047,7565067,7565061,'291',3.333,3),(1047,7565068,7565061,'919',3.333,3),(1047,7565069,7565061,'195',3.333,3),(1047,7565070,7565061,'956',3.333,3),(1047,7565071,7565061,'567',3.333,3),(1047,7565072,7565061,'673',3.333,3),(1047,7565073,7565061,'73b',3.333,3),(1047,7565074,7565061,'3b0',3.333,3),(1047,7565075,7565061,'b07',3.333,3),(1047,7565076,7565061,'07a',3.333,3),(1047,7565077,7565061,'7a8',3.333,3),(1047,7565078,7565061,'a82',3.333,3),(1047,7565079,7565061,'82d',3.333,3),(1047,7565080,7565061,'2d3',3.333,3),(1047,7565081,7565061,'d32',3.333,3),(1047,7565082,7565061,'32e',3.333,3),(1047,7565083,7565061,'2ed',3.333,3),(1047,7565084,7565061,'ed5',3.333,3),(1047,7565085,7565061,'d55',3.333,3),(1047,7565086,7565061,'550',3.333,3),(1047,7565087,7565061,'50e',3.333,3),(1047,7565088,7565061,'0ed',3.333,3),(1047,7565089,7565061,'ed7',3.333,3),(1047,7565090,7565061,'d73',3.333,3),(1047,7565091,7565061,'733',3.333,3),(1047,7565092,7565062,'mon',100,1),(1047,7565093,7565092,'201',50,1),(1047,7565094,7565092,'013',50,1),(1047,7565095,7565093,'adm',33.333,4),(1047,7565096,7565093,'dmi',33.333,4),(1047,7565097,7565093,'min',33.333,4),(1047,7565098,7565095,'cap',16.667,1),(1047,7565099,7565095,'apa',16.667,1),(1047,7565100,7565095,'pac',16.667,1),(1047,7565101,7565095,'aci',16.667,1),(1047,7565102,7565095,'cit',16.667,1),(1047,7565103,7565095,'ity',16.667,1),(1047,7565104,7565098,'pat',50,1),(1047,7565105,7565098,'ath',50,1),(1047,7565106,7565104,'one',100,1),(1047,7565107,7565106,'fre',14.286,1),(1047,7565108,7565106,'ree',14.286,1),(1047,7565109,7565106,'ees',14.286,1),(1047,7565110,7565106,'esp',14.286,1),(1047,7565111,7565106,'spa',14.286,1),(1047,7565112,7565106,'pac',14.286,1),(1047,7565113,7565106,'ace',14.286,1),(1047,7565114,7565107,'dis',50,1),(1047,7565115,7565107,'isk',50,1),(1047,7565116,7565114,'ind',33.333,1),(1047,7565117,7565114,'nde',33.333,1),(1047,7565118,7565114,'dex',33.333,1),(1047,7565119,7565116,'adm',8.333,1),(1047,7565120,7565116,'dmi',8.333,1),(1047,7565121,7565116,'min',8.333,1),(1047,7565122,7565116,'ini',8.333,1),(1047,7565123,7565116,'nis',8.333,1),(1047,7565124,7565116,'ist',8.333,1),(1047,7565125,7565116,'str',8.333,1),(1047,7565126,7565116,'tra',8.333,1),(1047,7565127,7565116,'rat',8.333,1),(1047,7565128,7565116,'ati',8.333,1),(1047,7565129,7565116,'tio',8.333,1),(1047,7565130,7565116,'ion',8.333,1),(1047,7565131,7565119,'sta',33.333,3),(1047,7565132,7565119,'tat',33.333,3),(1047,7565133,7565119,'ate',33.333,3),(1047,7565134,7565131,'dis',16.667,4),(1047,7565135,7565131,'isa',16.667,4),(1047,7565136,7565131,'sab',16.667,4),(1047,7565137,7565131,'abl',16.667,4),(1047,7565138,7565131,'ble',16.667,4),(1047,7565139,7565131,'led',16.667,4),(1047,7565140,7565134,'cac',33.333,1),(1047,7565141,7565134,'ach',33.333,1),(1047,7565142,7565134,'che',33.333,1),(1047,7565143,7565140,'mod',50,1),(1047,7565144,7565140,'ode',50,1),(1047,7565145,7565143,'wri',14.286,1),(1047,7565146,7565143,'rit',14.286,1),(1047,7565147,7565143,'ite',14.286,1),(1047,7565148,7565143,'tet',14.286,1),(1047,7565149,7565143,'eth',14.286,1),(1047,7565150,7565143,'thr',14.286,1),(1047,7565151,7565143,'hru',14.286,1),(1047,7565152,7565145,'ope',11.111,2),(1047,7565153,7565145,'per',11.111,2),(1047,7565154,7565145,'era',11.111,2),(1047,7565155,7565145,'rat',11.111,2),(1047,7565156,7565145,'ati',11.111,2),(1047,7565157,7565145,'tio',11.111,2),(1047,7565158,7565145,'ion',11.111,2),(1047,7565159,7565145,'ona',11.111,2),(1047,7565160,7565145,'nal',11.111,2),(1047,7565161,7565152,'mes',20,1),(1047,7565162,7565152,'ess',20,1),(1047,7565163,7565152,'ssa',20,1),(1047,7565164,7565152,'sag',20,1),(1047,7565165,7565152,'age',20,1),(1047,7565166,7565161,'per',11.111,1),(1047,7565167,7565161,'erf',11.111,1),(1047,7565168,7565161,'rfo',11.111,1),(1047,7565169,7565161,'for',11.111,1),(1047,7565170,7565161,'orm',11.111,1),(1047,7565171,7565161,'rma',11.111,1),(1047,7565172,7565161,'man',11.111,1),(1047,7565173,7565161,'anc',11.111,1),(1047,7565174,7565161,'nce',11.111,1),(1047,7565175,7565166,'ide',12.5,1),(1047,7565176,7565166,'den',12.5,1),(1047,7565177,7565166,'ent',12.5,1),(1047,7565178,7565166,'nti',12.5,1),(1047,7565179,7565166,'tif',12.5,1),(1047,7565180,7565166,'ifi',12.5,1),(1047,7565181,7565166,'fie',12.5,1),(1047,7565182,7565166,'ier',12.5,1),(1047,7565183,7565175,'vdi',33.333,3),(1047,7565184,7565175,'dis',33.333,3),(1047,7565185,7565175,'isk',33.333,3),(1047,7565186,7565183,'nam',50,1),(1047,7565187,7565183,'ame',50,1),(1047,7565188,7565186,'typ',50,1),(1047,7565189,7565186,'ype',50,1),(1047,7565190,7565188,'dir',25,1),(1047,7565191,7565188,'ire',25,1),(1047,7565192,7565188,'rec',25,1),(1047,7565193,7565188,'ect',25,1),(1048,7565195,7565194,'naa',100,2),(1048,7565196,7565195,'600',3.333,3),(1048,7565197,7565195,'000',3.333,3),(1048,7565198,7565195,'00c',3.333,3),(1048,7565199,7565195,'0c2',3.333,3),(1048,7565200,7565195,'c29',3.333,3),(1048,7565201,7565195,'29e',3.333,3),(1048,7565202,7565195,'9e6',3.333,3),(1048,7565203,7565195,'e6a',3.333,3),(1048,7565204,7565195,'6a0',3.333,3),(1048,7565205,7565195,'a04',3.333,3),(1048,7565206,7565195,'04a',3.333,3),(1048,7565207,7565195,'4a7',3.333,3),(1048,7565208,7565195,'a78',3.333,3),(1048,7565209,7565195,'78d',3.333,3),(1048,7565210,7565195,'8d3',3.333,3),(1048,7565211,7565195,'d3d',3.333,3),(1048,7565212,7565195,'3d0',3.333,3),(1048,7565213,7565195,'d05',3.333,3),(1048,7565214,7565195,'058',3.333,3),(1048,7565215,7565195,'58a',3.333,3),(1048,7565216,7565195,'8a6',3.333,3),(1048,7565217,7565195,'a6a',3.333,3),(1048,7565218,7565195,'6ae',3.333,3),(1048,7565219,7565195,'aeb',3.333,3),(1048,7565220,7565195,'ebf',3.333,3),(1048,7565221,7565195,'bf2',3.333,3),(1048,7565222,7565195,'f2b',3.333,3),(1048,7565223,7565195,'2bc',3.333,3),(1048,7565224,7565195,'bc2',3.333,3),(1048,7565225,7565195,'c2d',3.333,3),(1048,7565226,7565196,'mon',100,1),(1048,7565227,7565226,'201',50,1),(1048,7565228,7565226,'013',50,1),(1048,7565229,7565227,'adm',33.333,4),(1048,7565230,7565227,'dmi',33.333,4),(1048,7565231,7565227,'min',33.333,4),(1048,7565232,7565229,'cap',16.667,1),(1048,7565233,7565229,'apa',16.667,1),(1048,7565234,7565229,'pac',16.667,1),(1048,7565235,7565229,'aci',16.667,1),(1048,7565236,7565229,'cit',16.667,1),(1048,7565237,7565229,'ity',16.667,1),(1048,7565238,7565232,'pat',50,1),(1048,7565239,7565232,'ath',50,1),(1048,7565240,7565238,'fou',50,1),(1048,7565241,7565238,'our',50,1),(1048,7565242,7565240,'fre',14.286,1),(1048,7565243,7565240,'ree',14.286,1),(1048,7565244,7565240,'ees',14.286,1),(1048,7565245,7565240,'esp',14.286,1),(1048,7565246,7565240,'spa',14.286,1),(1048,7565247,7565240,'pac',14.286,1),(1048,7565248,7565240,'ace',14.286,1),(1048,7565249,7565242,'dis',50,1),(1048,7565250,7565242,'isk',50,1),(1048,7565251,7565249,'ind',33.333,1),(1048,7565252,7565249,'nde',33.333,1),(1048,7565253,7565249,'dex',33.333,1),(1048,7565254,7565251,'adm',8.333,1),(1048,7565255,7565251,'dmi',8.333,1),(1048,7565256,7565251,'min',8.333,1),(1048,7565257,7565251,'ini',8.333,1),(1048,7565258,7565251,'nis',8.333,1),(1048,7565259,7565251,'ist',8.333,1),(1048,7565260,7565251,'str',8.333,1),(1048,7565261,7565251,'tra',8.333,1),(1048,7565262,7565251,'rat',8.333,1),(1048,7565263,7565251,'ati',8.333,1),(1048,7565264,7565251,'tio',8.333,1),(1048,7565265,7565251,'ion',8.333,1),(1048,7565266,7565254,'sta',33.333,3),(1048,7565267,7565254,'tat',33.333,3),(1048,7565268,7565254,'ate',33.333,3),(1048,7565269,7565266,'dis',16.667,4),(1048,7565270,7565266,'isa',16.667,4),(1048,7565271,7565266,'sab',16.667,4),(1048,7565272,7565266,'abl',16.667,4),(1048,7565273,7565266,'ble',16.667,4),(1048,7565274,7565266,'led',16.667,4),(1048,7565275,7565269,'cac',33.333,1),(1048,7565276,7565269,'ach',33.333,1),(1048,7565277,7565269,'che',33.333,1),(1048,7565278,7565275,'mod',50,1),(1048,7565279,7565275,'ode',50,1),(1048,7565280,7565278,'wri',14.286,1),(1048,7565281,7565278,'rit',14.286,1),(1048,7565282,7565278,'ite',14.286,1),(1048,7565283,7565278,'tet',14.286,1),(1048,7565284,7565278,'eth',14.286,1),(1048,7565285,7565278,'thr',14.286,1),(1048,7565286,7565278,'hru',14.286,1),(1048,7565287,7565280,'ope',11.111,2),(1048,7565288,7565280,'per',11.111,2),(1048,7565289,7565280,'era',11.111,2),(1048,7565290,7565280,'rat',11.111,2),(1048,7565291,7565280,'ati',11.111,2),(1048,7565292,7565280,'tio',11.111,2),(1048,7565293,7565280,'ion',11.111,2),(1048,7565294,7565280,'ona',11.111,2),(1048,7565295,7565280,'nal',11.111,2),(1048,7565296,7565287,'mes',20,1),(1048,7565297,7565287,'ess',20,1),(1048,7565298,7565287,'ssa',20,1),(1048,7565299,7565287,'sag',20,1),(1048,7565300,7565287,'age',20,1),(1048,7565301,7565296,'per',11.111,1),(1048,7565302,7565296,'erf',11.111,1),(1048,7565303,7565296,'rfo',11.111,1),(1048,7565304,7565296,'for',11.111,1),(1048,7565305,7565296,'orm',11.111,1),(1048,7565306,7565296,'rma',11.111,1),(1048,7565307,7565296,'man',11.111,1),(1048,7565308,7565296,'anc',11.111,1),(1048,7565309,7565296,'nce',11.111,1),(1048,7565310,7565301,'ide',12.5,1),(1048,7565311,7565301,'den',12.5,1),(1048,7565312,7565301,'ent',12.5,1),(1048,7565313,7565301,'nti',12.5,1),(1048,7565314,7565301,'tif',12.5,1),(1048,7565315,7565301,'ifi',12.5,1),(1048,7565316,7565301,'fie',12.5,1),(1048,7565317,7565301,'ier',12.5,1),(1048,7565318,7565310,'vdi',33.333,3),(1048,7565319,7565310,'dis',33.333,3),(1048,7565320,7565310,'isk',33.333,3),(1048,7565321,7565318,'nam',50,1),(1048,7565322,7565318,'ame',50,1),(1048,7565323,7565321,'typ',50,1),(1048,7565324,7565321,'ype',50,1),(1048,7565325,7565323,'dir',25,1),(1048,7565326,7565323,'ire',25,1),(1048,7565327,7565323,'rec',25,1),(1048,7565328,7565323,'ect',25,1),(1049,7565330,7565329,'naa',100,2),(1049,7565331,7565330,'600',3.333,3),(1049,7565332,7565330,'000',3.333,3),(1049,7565333,7565330,'00c',3.333,3),(1049,7565334,7565330,'0c2',3.333,3),(1049,7565335,7565330,'c29',3.333,3),(1049,7565336,7565330,'29f',3.333,3),(1049,7565337,7565330,'9f8',3.333,3),(1049,7565338,7565330,'f86',3.333,3),(1049,7565339,7565330,'867',3.333,3),(1049,7565340,7565330,'67e',3.333,3),(1049,7565341,7565330,'7ed',3.333,3),(1049,7565342,7565330,'ed9',3.333,3),(1049,7565343,7565330,'d9d',3.333,3),(1049,7565344,7565330,'9d3',3.333,3),(1049,7565345,7565330,'d3c',3.333,3),(1049,7565346,7565330,'3cb',3.333,3),(1049,7565347,7565330,'cbb',3.333,3),(1049,7565348,7565330,'bbe',3.333,3),(1049,7565349,7565330,'bee',3.333,3),(1049,7565350,7565330,'eef',3.333,3),(1049,7565351,7565330,'efc',3.333,3),(1049,7565352,7565330,'fc3',3.333,3),(1049,7565353,7565330,'c30',3.333,3),(1049,7565354,7565330,'30e',3.333,3),(1049,7565355,7565330,'0e7',3.333,3),(1049,7565356,7565330,'e7b',3.333,3),(1049,7565357,7565330,'7ba',3.333,3),(1049,7565358,7565330,'ba1',3.333,3),(1049,7565359,7565330,'a1b',3.333,3),(1049,7565360,7565330,'1b7',3.333,3),(1049,7565361,7565331,'mon',100,1),(1049,7565362,7565361,'201',50,1),(1049,7565363,7565361,'013',50,1),(1049,7565364,7565362,'adm',33.333,4),(1049,7565365,7565362,'dmi',33.333,4),(1049,7565366,7565362,'min',33.333,4),(1049,7565367,7565364,'cap',16.667,1),(1049,7565368,7565364,'apa',16.667,1),(1049,7565369,7565364,'pac',16.667,1),(1049,7565370,7565364,'aci',16.667,1),(1049,7565371,7565364,'cit',16.667,1),(1049,7565372,7565364,'ity',16.667,1),(1049,7565373,7565367,'pat',50,1),(1049,7565374,7565367,'ath',50,1),(1049,7565375,7565373,'fre',14.286,1),(1049,7565376,7565373,'ree',14.286,1),(1049,7565377,7565373,'ees',14.286,1),(1049,7565378,7565373,'esp',14.286,1),(1049,7565379,7565373,'spa',14.286,1),(1049,7565380,7565373,'pac',14.286,1),(1049,7565381,7565373,'ace',14.286,1),(1049,7565382,7565375,'dis',50,1),(1049,7565383,7565375,'isk',50,1),(1049,7565384,7565382,'ind',33.333,1),(1049,7565385,7565382,'nde',33.333,1),(1049,7565386,7565382,'dex',33.333,1),(1049,7565387,7565384,'adm',8.333,1),(1049,7565388,7565384,'dmi',8.333,1),(1049,7565389,7565384,'min',8.333,1),(1049,7565390,7565384,'ini',8.333,1),(1049,7565391,7565384,'nis',8.333,1),(1049,7565392,7565384,'ist',8.333,1),(1049,7565393,7565384,'str',8.333,1),(1049,7565394,7565384,'tra',8.333,1),(1049,7565395,7565384,'rat',8.333,1),(1049,7565396,7565384,'ati',8.333,1),(1049,7565397,7565384,'tio',8.333,1),(1049,7565398,7565384,'ion',8.333,1),(1049,7565399,7565387,'sta',33.333,3),(1049,7565400,7565387,'tat',33.333,3),(1049,7565401,7565387,'ate',33.333,3),(1049,7565402,7565399,'dis',16.667,4),(1049,7565403,7565399,'isa',16.667,4),(1049,7565404,7565399,'sab',16.667,4),(1049,7565405,7565399,'abl',16.667,4),(1049,7565406,7565399,'ble',16.667,4),(1049,7565407,7565399,'led',16.667,4),(1049,7565408,7565402,'cac',33.333,1),(1049,7565409,7565402,'ach',33.333,1),(1049,7565410,7565402,'che',33.333,1),(1049,7565411,7565408,'mod',50,1),(1049,7565412,7565408,'ode',50,1),(1049,7565413,7565411,'wri',14.286,1),(1049,7565414,7565411,'rit',14.286,1),(1049,7565415,7565411,'ite',14.286,1),(1049,7565416,7565411,'tet',14.286,1),(1049,7565417,7565411,'eth',14.286,1),(1049,7565418,7565411,'thr',14.286,1),(1049,7565419,7565411,'hru',14.286,1),(1049,7565420,7565413,'ope',11.111,2),(1049,7565421,7565413,'per',11.111,2),(1049,7565422,7565413,'era',11.111,2),(1049,7565423,7565413,'rat',11.111,2),(1049,7565424,7565413,'ati',11.111,2),(1049,7565425,7565413,'tio',11.111,2),(1049,7565426,7565413,'ion',11.111,2),(1049,7565427,7565413,'ona',11.111,2),(1049,7565428,7565413,'nal',11.111,2),(1049,7565429,7565420,'mes',20,1),(1049,7565430,7565420,'ess',20,1),(1049,7565431,7565420,'ssa',20,1),(1049,7565432,7565420,'sag',20,1),(1049,7565433,7565420,'age',20,1),(1049,7565434,7565429,'per',11.111,1),(1049,7565435,7565429,'erf',11.111,1),(1049,7565436,7565429,'rfo',11.111,1),(1049,7565437,7565429,'for',11.111,1),(1049,7565438,7565429,'orm',11.111,1),(1049,7565439,7565429,'rma',11.111,1),(1049,7565440,7565429,'man',11.111,1),(1049,7565441,7565429,'anc',11.111,1),(1049,7565442,7565429,'nce',11.111,1),(1049,7565443,7565434,'ide',12.5,1),(1049,7565444,7565434,'den',12.5,1),(1049,7565445,7565434,'ent',12.5,1),(1049,7565446,7565434,'nti',12.5,1),(1049,7565447,7565434,'tif',12.5,1),(1049,7565448,7565434,'ifi',12.5,1),(1049,7565449,7565434,'fie',12.5,1),(1049,7565450,7565434,'ier',12.5,1),(1049,7565451,7565443,'vdi',33.333,3),(1049,7565452,7565443,'dis',33.333,3),(1049,7565453,7565443,'isk',33.333,3),(1049,7565454,7565451,'nam',50,1),(1049,7565455,7565451,'ame',50,1),(1049,7565456,7565454,'typ',50,1),(1049,7565457,7565454,'ype',50,1),(1049,7565458,7565456,'dir',25,1),(1049,7565459,7565456,'ire',25,1),(1049,7565460,7565456,'rec',25,1),(1049,7565461,7565456,'ect',25,1),(1050,7565463,7565462,'naa',100,2),(1050,7565464,7565463,'600',3.333,3),(1050,7565465,7565463,'000',3.333,3),(1050,7565466,7565463,'00c',3.333,3),(1050,7565467,7565463,'0c2',3.333,3),(1050,7565468,7565463,'c29',3.333,3),(1050,7565469,7565463,'299',3.333,3),(1050,7565470,7565463,'99b',3.333,3),(1050,7565471,7565463,'9bc',3.333,3),(1050,7565472,7565463,'bc3',3.333,3),(1050,7565473,7565463,'c34',3.333,3),(1050,7565474,7565463,'347',3.333,3),(1050,7565475,7565463,'479',3.333,3),(1050,7565476,7565463,'79b',3.333,3),(1050,7565477,7565463,'9bc',3.333,3),(1050,7565478,7565463,'bc3',3.333,3),(1050,7565479,7565463,'c38',3.333,3),(1050,7565480,7565463,'380',3.333,3),(1050,7565481,7565463,'80b',3.333,3),(1050,7565482,7565463,'0b0',3.333,3),(1050,7565483,7565463,'b07',3.333,3),(1050,7565484,7565463,'072',3.333,3),(1050,7565485,7565463,'725',3.333,3),(1050,7565486,7565463,'25d',3.333,3),(1050,7565487,7565463,'5de',3.333,3),(1050,7565488,7565463,'deb',3.333,3),(1050,7565489,7565463,'ebb',3.333,3),(1050,7565490,7565463,'bba',3.333,3),(1050,7565491,7565463,'ba0',3.333,3),(1050,7565492,7565463,'a0e',3.333,3),(1050,7565493,7565463,'0e0',3.333,3),(1050,7565494,7565464,'mon',100,1),(1050,7565495,7565494,'201',50,1),(1050,7565496,7565494,'013',50,1),(1050,7565497,7565495,'adm',33.333,4),(1050,7565498,7565495,'dmi',33.333,4),(1050,7565499,7565495,'min',33.333,4),(1050,7565500,7565497,'cap',16.667,1),(1050,7565501,7565497,'apa',16.667,1),(1050,7565502,7565497,'pac',16.667,1),(1050,7565503,7565497,'aci',16.667,1),(1050,7565504,7565497,'cit',16.667,1),(1050,7565505,7565497,'ity',16.667,1),(1050,7565506,7565500,'pat',50,1),(1050,7565507,7565500,'ath',50,1),(1050,7565508,7565506,'fre',14.286,1),(1050,7565509,7565506,'ree',14.286,1),(1050,7565510,7565506,'ees',14.286,1),(1050,7565511,7565506,'esp',14.286,1),(1050,7565512,7565506,'spa',14.286,1),(1050,7565513,7565506,'pac',14.286,1),(1050,7565514,7565506,'ace',14.286,1),(1050,7565515,7565508,'dis',50,1),(1050,7565516,7565508,'isk',50,1),(1050,7565517,7565515,'ind',33.333,1),(1050,7565518,7565515,'nde',33.333,1),(1050,7565519,7565515,'dex',33.333,1),(1050,7565520,7565517,'adm',8.333,1),(1050,7565521,7565517,'dmi',8.333,1),(1050,7565522,7565517,'min',8.333,1),(1050,7565523,7565517,'ini',8.333,1),(1050,7565524,7565517,'nis',8.333,1),(1050,7565525,7565517,'ist',8.333,1),(1050,7565526,7565517,'str',8.333,1),(1050,7565527,7565517,'tra',8.333,1),(1050,7565528,7565517,'rat',8.333,1),(1050,7565529,7565517,'ati',8.333,1),(1050,7565530,7565517,'tio',8.333,1),(1050,7565531,7565517,'ion',8.333,1),(1050,7565532,7565520,'sta',33.333,3),(1050,7565533,7565520,'tat',33.333,3),(1050,7565534,7565520,'ate',33.333,3),(1050,7565535,7565532,'dis',16.667,4),(1050,7565536,7565532,'isa',16.667,4),(1050,7565537,7565532,'sab',16.667,4),(1050,7565538,7565532,'abl',16.667,4),(1050,7565539,7565532,'ble',16.667,4),(1050,7565540,7565532,'led',16.667,4),(1050,7565541,7565535,'cac',33.333,1),(1050,7565542,7565535,'ach',33.333,1),(1050,7565543,7565535,'che',33.333,1),(1050,7565544,7565541,'mod',50,1),(1050,7565545,7565541,'ode',50,1),(1050,7565546,7565544,'wri',14.286,1),(1050,7565547,7565544,'rit',14.286,1),(1050,7565548,7565544,'ite',14.286,1),(1050,7565549,7565544,'tet',14.286,1),(1050,7565550,7565544,'eth',14.286,1),(1050,7565551,7565544,'thr',14.286,1),(1050,7565552,7565544,'hru',14.286,1),(1050,7565553,7565546,'ope',11.111,2),(1050,7565554,7565546,'per',11.111,2),(1050,7565555,7565546,'era',11.111,2),(1050,7565556,7565546,'rat',11.111,2),(1050,7565557,7565546,'ati',11.111,2),(1050,7565558,7565546,'tio',11.111,2),(1050,7565559,7565546,'ion',11.111,2),(1050,7565560,7565546,'ona',11.111,2),(1050,7565561,7565546,'nal',11.111,2),(1050,7565562,7565553,'mes',20,1),(1050,7565563,7565553,'ess',20,1),(1050,7565564,7565553,'ssa',20,1),(1050,7565565,7565553,'sag',20,1),(1050,7565566,7565553,'age',20,1),(1050,7565567,7565562,'per',11.111,1),(1050,7565568,7565562,'erf',11.111,1),(1050,7565569,7565562,'rfo',11.111,1),(1050,7565570,7565562,'for',11.111,1),(1050,7565571,7565562,'orm',11.111,1),(1050,7565572,7565562,'rma',11.111,1),(1050,7565573,7565562,'man',11.111,1),(1050,7565574,7565562,'anc',11.111,1),(1050,7565575,7565562,'nce',11.111,1),(1050,7565576,7565567,'ide',12.5,1),(1050,7565577,7565567,'den',12.5,1),(1050,7565578,7565567,'ent',12.5,1),(1050,7565579,7565567,'nti',12.5,1),(1050,7565580,7565567,'tif',12.5,1),(1050,7565581,7565567,'ifi',12.5,1),(1050,7565582,7565567,'fie',12.5,1),(1050,7565583,7565567,'ier',12.5,1),(1050,7565584,7565576,'vdi',33.333,3),(1050,7565585,7565576,'dis',33.333,3),(1050,7565586,7565576,'isk',33.333,3),(1050,7565587,7565584,'nam',50,1),(1050,7565588,7565584,'ame',50,1),(1050,7565589,7565587,'typ',50,1),(1050,7565590,7565587,'ype',50,1),(1050,7565591,7565589,'dir',25,1),(1050,7565592,7565589,'ire',25,1),(1050,7565593,7565589,'rec',25,1),(1050,7565594,7565589,'ect',25,1),(1051,7565596,7565595,'naa',100,2),(1051,7565597,7565596,'600',3.333,3),(1051,7565598,7565596,'000',3.333,3),(1051,7565599,7565596,'00c',3.333,3),(1051,7565600,7565596,'0c2',3.333,3),(1051,7565601,7565596,'c29',3.333,3),(1051,7565602,7565596,'29e',3.333,3),(1051,7565603,7565596,'9ef',3.333,3),(1051,7565604,7565596,'efb',3.333,3),(1051,7565605,7565596,'fb7',3.333,3),(1051,7565606,7565596,'b74',3.333,3),(1051,7565607,7565596,'740',3.333,3),(1051,7565608,7565596,'400',3.333,3),(1051,7565609,7565596,'00c',3.333,3),(1051,7565610,7565596,'0c1',3.333,3),(1051,7565611,7565596,'c14',3.333,3),(1051,7565612,7565596,'140',3.333,3),(1051,7565613,7565596,'405',3.333,3),(1051,7565614,7565596,'058',3.333,3),(1051,7565615,7565596,'582',3.333,3),(1051,7565616,7565596,'829',3.333,3),(1051,7565617,7565596,'295',3.333,3),(1051,7565618,7565596,'956',3.333,3),(1051,7565619,7565596,'56b',3.333,3),(1051,7565620,7565596,'6bd',3.333,3),(1051,7565621,7565596,'bde',3.333,3),(1051,7565622,7565596,'de3',3.333,3),(1051,7565623,7565596,'e37',3.333,3),(1051,7565624,7565596,'37e',3.333,3),(1051,7565625,7565596,'7e0',3.333,3),(1051,7565626,7565596,'e04',3.333,3),(1051,7565627,7565597,'mon',100,1),(1051,7565628,7565627,'201',50,1),(1051,7565629,7565627,'013',50,1),(1051,7565630,7565628,'adm',33.333,4),(1051,7565631,7565628,'dmi',33.333,4),(1051,7565632,7565628,'min',33.333,4),(1051,7565633,7565630,'cap',16.667,1),(1051,7565634,7565630,'apa',16.667,1),(1051,7565635,7565630,'pac',16.667,1),(1051,7565636,7565630,'aci',16.667,1),(1051,7565637,7565630,'cit',16.667,1),(1051,7565638,7565630,'ity',16.667,1),(1051,7565639,7565633,'pat',50,1),(1051,7565640,7565633,'ath',50,1),(1051,7565641,7565639,'fre',14.286,1),(1051,7565642,7565639,'ree',14.286,1),(1051,7565643,7565639,'ees',14.286,1),(1051,7565644,7565639,'esp',14.286,1),(1051,7565645,7565639,'spa',14.286,1),(1051,7565646,7565639,'pac',14.286,1),(1051,7565647,7565639,'ace',14.286,1),(1051,7565648,7565641,'dis',50,1),(1051,7565649,7565641,'isk',50,1),(1051,7565650,7565648,'ind',33.333,1),(1051,7565651,7565648,'nde',33.333,1),(1051,7565652,7565648,'dex',33.333,1),(1051,7565653,7565650,'adm',8.333,1),(1051,7565654,7565650,'dmi',8.333,1),(1051,7565655,7565650,'min',8.333,1),(1051,7565656,7565650,'ini',8.333,1),(1051,7565657,7565650,'nis',8.333,1),(1051,7565658,7565650,'ist',8.333,1),(1051,7565659,7565650,'str',8.333,1),(1051,7565660,7565650,'tra',8.333,1),(1051,7565661,7565650,'rat',8.333,1),(1051,7565662,7565650,'ati',8.333,1),(1051,7565663,7565650,'tio',8.333,1),(1051,7565664,7565650,'ion',8.333,1),(1051,7565665,7565653,'sta',33.333,3),(1051,7565666,7565653,'tat',33.333,3),(1051,7565667,7565653,'ate',33.333,3),(1051,7565668,7565665,'dis',16.667,4),(1051,7565669,7565665,'isa',16.667,4),(1051,7565670,7565665,'sab',16.667,4),(1051,7565671,7565665,'abl',16.667,4),(1051,7565672,7565665,'ble',16.667,4),(1051,7565673,7565665,'led',16.667,4),(1051,7565674,7565668,'cac',33.333,1),(1051,7565675,7565668,'ach',33.333,1),(1051,7565676,7565668,'che',33.333,1),(1051,7565677,7565674,'mod',50,1),(1051,7565678,7565674,'ode',50,1),(1051,7565679,7565677,'wri',14.286,1),(1051,7565680,7565677,'rit',14.286,1),(1051,7565681,7565677,'ite',14.286,1),(1051,7565682,7565677,'tet',14.286,1),(1051,7565683,7565677,'eth',14.286,1),(1051,7565684,7565677,'thr',14.286,1),(1051,7565685,7565677,'hru',14.286,1),(1051,7565686,7565679,'ope',11.111,2),(1051,7565687,7565679,'per',11.111,2),(1051,7565688,7565679,'era',11.111,2),(1051,7565689,7565679,'rat',11.111,2),(1051,7565690,7565679,'ati',11.111,2),(1051,7565691,7565679,'tio',11.111,2),(1051,7565692,7565679,'ion',11.111,2),(1051,7565693,7565679,'ona',11.111,2),(1051,7565694,7565679,'nal',11.111,2),(1051,7565695,7565686,'mes',20,1),(1051,7565696,7565686,'ess',20,1),(1051,7565697,7565686,'ssa',20,1),(1051,7565698,7565686,'sag',20,1),(1051,7565699,7565686,'age',20,1),(1051,7565700,7565695,'per',11.111,1),(1051,7565701,7565695,'erf',11.111,1),(1051,7565702,7565695,'rfo',11.111,1),(1051,7565703,7565695,'for',11.111,1),(1051,7565704,7565695,'orm',11.111,1),(1051,7565705,7565695,'rma',11.111,1),(1051,7565706,7565695,'man',11.111,1),(1051,7565707,7565695,'anc',11.111,1),(1051,7565708,7565695,'nce',11.111,1),(1051,7565709,7565700,'ide',12.5,1),(1051,7565710,7565700,'den',12.5,1),(1051,7565711,7565700,'ent',12.5,1),(1051,7565712,7565700,'nti',12.5,1),(1051,7565713,7565700,'tif',12.5,1),(1051,7565714,7565700,'ifi',12.5,1),(1051,7565715,7565700,'fie',12.5,1),(1051,7565716,7565700,'ier',12.5,1),(1051,7565717,7565709,'vdi',33.333,3),(1051,7565718,7565709,'dis',33.333,3),(1051,7565719,7565709,'isk',33.333,3),(1051,7565720,7565717,'nam',50,1),(1051,7565721,7565717,'ame',50,1),(1051,7565722,7565720,'typ',50,1),(1051,7565723,7565720,'ype',50,1),(1051,7565724,7565722,'dir',25,1),(1051,7565725,7565722,'ire',25,1),(1051,7565726,7565722,'rec',25,1),(1051,7565727,7565722,'ect',25,1),(1052,7565729,7565728,'naa',100,2),(1052,7565730,7565729,'600',3.333,3),(1052,7565731,7565729,'000',3.333,3),(1052,7565732,7565729,'00c',3.333,3),(1052,7565733,7565729,'0c2',3.333,3),(1052,7565734,7565729,'c29',3.333,3),(1052,7565735,7565729,'29e',3.333,3),(1052,7565736,7565729,'9e5',3.333,3),(1052,7565737,7565729,'e58',3.333,3),(1052,7565738,7565729,'58a',3.333,3),(1052,7565739,7565729,'8a8',3.333,3),(1052,7565740,7565729,'a86',3.333,3),(1052,7565741,7565729,'86d',3.333,3),(1052,7565742,7565729,'6d3',3.333,3),(1052,7565743,7565729,'d36',3.333,3),(1052,7565744,7565729,'369',3.333,3),(1052,7565745,7565729,'69a',3.333,3),(1052,7565746,7565729,'9a7',3.333,3),(1052,7565747,7565729,'a7c',3.333,3),(1052,7565748,7565729,'7c6',3.333,3),(1052,7565749,7565729,'c63',3.333,3),(1052,7565750,7565729,'63c',3.333,3),(1052,7565751,7565729,'3cc',3.333,3),(1052,7565752,7565729,'cc5',3.333,3),(1052,7565753,7565729,'c5f',3.333,3),(1052,7565754,7565729,'5fd',3.333,3),(1052,7565755,7565729,'fdf',3.333,3),(1052,7565756,7565729,'dfe',3.333,3),(1052,7565757,7565729,'fe1',3.333,3),(1052,7565758,7565729,'e12',3.333,3),(1052,7565759,7565729,'120',3.333,3),(1052,7565760,7565730,'mon',100,1),(1052,7565761,7565760,'201',50,1),(1052,7565762,7565760,'013',50,1),(1052,7565763,7565761,'adm',33.333,4),(1052,7565764,7565761,'dmi',33.333,4),(1052,7565765,7565761,'min',33.333,4),(1052,7565766,7565763,'cap',16.667,1),(1052,7565767,7565763,'apa',16.667,1),(1052,7565768,7565763,'pac',16.667,1),(1052,7565769,7565763,'aci',16.667,1),(1052,7565770,7565763,'cit',16.667,1),(1052,7565771,7565763,'ity',16.667,1),(1052,7565772,7565766,'pat',50,1),(1052,7565773,7565766,'ath',50,1),(1052,7565774,7565772,'fre',14.286,1),(1052,7565775,7565772,'ree',14.286,1),(1052,7565776,7565772,'ees',14.286,1),(1052,7565777,7565772,'esp',14.286,1),(1052,7565778,7565772,'spa',14.286,1),(1052,7565779,7565772,'pac',14.286,1),(1052,7565780,7565772,'ace',14.286,1),(1052,7565781,7565774,'dis',50,1),(1052,7565782,7565774,'isk',50,1),(1052,7565783,7565781,'ind',33.333,1),(1052,7565784,7565781,'nde',33.333,1),(1052,7565785,7565781,'dex',33.333,1),(1052,7565786,7565783,'adm',8.333,1),(1052,7565787,7565783,'dmi',8.333,1),(1052,7565788,7565783,'min',8.333,1),(1052,7565789,7565783,'ini',8.333,1),(1052,7565790,7565783,'nis',8.333,1),(1052,7565791,7565783,'ist',8.333,1),(1052,7565792,7565783,'str',8.333,1),(1052,7565793,7565783,'tra',8.333,1),(1052,7565794,7565783,'rat',8.333,1),(1052,7565795,7565783,'ati',8.333,1),(1052,7565796,7565783,'tio',8.333,1),(1052,7565797,7565783,'ion',8.333,1),(1052,7565798,7565786,'sta',33.333,3),(1052,7565799,7565786,'tat',33.333,3),(1052,7565800,7565786,'ate',33.333,3),(1052,7565801,7565798,'dis',16.667,4),(1052,7565802,7565798,'isa',16.667,4),(1052,7565803,7565798,'sab',16.667,4),(1052,7565804,7565798,'abl',16.667,4),(1052,7565805,7565798,'ble',16.667,4),(1052,7565806,7565798,'led',16.667,4),(1052,7565807,7565801,'cac',33.333,1),(1052,7565808,7565801,'ach',33.333,1),(1052,7565809,7565801,'che',33.333,1),(1052,7565810,7565807,'mod',50,1),(1052,7565811,7565807,'ode',50,1),(1052,7565812,7565810,'wri',14.286,1),(1052,7565813,7565810,'rit',14.286,1),(1052,7565814,7565810,'ite',14.286,1),(1052,7565815,7565810,'tet',14.286,1),(1052,7565816,7565810,'eth',14.286,1),(1052,7565817,7565810,'thr',14.286,1),(1052,7565818,7565810,'hru',14.286,1),(1052,7565819,7565812,'ope',11.111,2),(1052,7565820,7565812,'per',11.111,2),(1052,7565821,7565812,'era',11.111,2),(1052,7565822,7565812,'rat',11.111,2),(1052,7565823,7565812,'ati',11.111,2),(1052,7565824,7565812,'tio',11.111,2),(1052,7565825,7565812,'ion',11.111,2),(1052,7565826,7565812,'ona',11.111,2),(1052,7565827,7565812,'nal',11.111,2),(1052,7565828,7565819,'mes',20,1),(1052,7565829,7565819,'ess',20,1),(1052,7565830,7565819,'ssa',20,1),(1052,7565831,7565819,'sag',20,1),(1052,7565832,7565819,'age',20,1),(1052,7565833,7565828,'per',11.111,1),(1052,7565834,7565828,'erf',11.111,1),(1052,7565835,7565828,'rfo',11.111,1),(1052,7565836,7565828,'for',11.111,1),(1052,7565837,7565828,'orm',11.111,1),(1052,7565838,7565828,'rma',11.111,1),(1052,7565839,7565828,'man',11.111,1),(1052,7565840,7565828,'anc',11.111,1),(1052,7565841,7565828,'nce',11.111,1),(1052,7565842,7565833,'ide',12.5,1),(1052,7565843,7565833,'den',12.5,1),(1052,7565844,7565833,'ent',12.5,1),(1052,7565845,7565833,'nti',12.5,1),(1052,7565846,7565833,'tif',12.5,1),(1052,7565847,7565833,'ifi',12.5,1),(1052,7565848,7565833,'fie',12.5,1),(1052,7565849,7565833,'ier',12.5,1),(1052,7565850,7565842,'vdi',33.333,3),(1052,7565851,7565842,'dis',33.333,3),(1052,7565852,7565842,'isk',33.333,3),(1052,7565853,7565850,'nam',50,1),(1052,7565854,7565850,'ame',50,1),(1052,7565855,7565853,'typ',50,1),(1052,7565856,7565853,'ype',50,1),(1052,7565857,7565855,'dir',25,1),(1052,7565858,7565855,'ire',25,1),(1052,7565859,7565855,'rec',25,1),(1052,7565860,7565855,'ect',25,1),(1053,7565862,7565861,'naa',100,2),(1053,7565863,7565862,'600',3.333,3),(1053,7565864,7565862,'000',3.333,3),(1053,7565865,7565862,'00c',3.333,3),(1053,7565866,7565862,'0c2',3.333,3),(1053,7565867,7565862,'c29',3.333,3),(1053,7565868,7565862,'29b',3.333,3),(1053,7565869,7565862,'9be',3.333,3),(1053,7565870,7565862,'be4',3.333,3),(1053,7565871,7565862,'e43',3.333,3),(1053,7565872,7565862,'43e',3.333,3),(1053,7565873,7565862,'3e0',3.333,3),(1053,7565874,7565862,'e09',3.333,3),(1053,7565875,7565862,'090',3.333,3),(1053,7565876,7565862,'906',3.333,3),(1053,7565877,7565862,'063',3.333,3),(1053,7565878,7565862,'639',3.333,3),(1053,7565879,7565862,'396',3.333,3),(1053,7565880,7565862,'966',3.333,3),(1053,7565881,7565862,'660',3.333,3),(1053,7565882,7565862,'608',3.333,3),(1053,7565883,7565862,'083',3.333,3),(1053,7565884,7565862,'83a',3.333,3),(1053,7565885,7565862,'3a4',3.333,3),(1053,7565886,7565862,'a4f',3.333,3),(1053,7565887,7565862,'4fb',3.333,3),(1053,7565888,7565862,'fb5',3.333,3),(1053,7565889,7565862,'b54',3.333,3),(1053,7565890,7565862,'540',3.333,3),(1053,7565891,7565862,'40b',3.333,3),(1053,7565892,7565862,'0b2',3.333,3),(1053,7565893,7565863,'mon',100,1),(1053,7565894,7565893,'201',50,1),(1053,7565895,7565893,'013',50,1),(1053,7565896,7565894,'adm',33.333,4),(1053,7565897,7565894,'dmi',33.333,4),(1053,7565898,7565894,'min',33.333,4),(1053,7565899,7565896,'cap',16.667,1),(1053,7565900,7565896,'apa',16.667,1),(1053,7565901,7565896,'pac',16.667,1),(1053,7565902,7565896,'aci',16.667,1),(1053,7565903,7565896,'cit',16.667,1),(1053,7565904,7565896,'ity',16.667,1),(1053,7565905,7565899,'pat',50,1),(1053,7565906,7565899,'ath',50,1),(1053,7565907,7565905,'fre',14.286,1),(1053,7565908,7565905,'ree',14.286,1),(1053,7565909,7565905,'ees',14.286,1),(1053,7565910,7565905,'esp',14.286,1),(1053,7565911,7565905,'spa',14.286,1),(1053,7565912,7565905,'pac',14.286,1),(1053,7565913,7565905,'ace',14.286,1),(1053,7565914,7565907,'dis',50,1),(1053,7565915,7565907,'isk',50,1),(1053,7565916,7565914,'ind',33.333,1),(1053,7565917,7565914,'nde',33.333,1),(1053,7565918,7565914,'dex',33.333,1),(1053,7565919,7565916,'adm',8.333,1),(1053,7565920,7565916,'dmi',8.333,1),(1053,7565921,7565916,'min',8.333,1),(1053,7565922,7565916,'ini',8.333,1),(1053,7565923,7565916,'nis',8.333,1),(1053,7565924,7565916,'ist',8.333,1),(1053,7565925,7565916,'str',8.333,1),(1053,7565926,7565916,'tra',8.333,1),(1053,7565927,7565916,'rat',8.333,1),(1053,7565928,7565916,'ati',8.333,1),(1053,7565929,7565916,'tio',8.333,1),(1053,7565930,7565916,'ion',8.333,1),(1053,7565931,7565919,'sta',33.333,3),(1053,7565932,7565919,'tat',33.333,3),(1053,7565933,7565919,'ate',33.333,3),(1053,7565934,7565931,'dis',16.667,4),(1053,7565935,7565931,'isa',16.667,4),(1053,7565936,7565931,'sab',16.667,4),(1053,7565937,7565931,'abl',16.667,4),(1053,7565938,7565931,'ble',16.667,4),(1053,7565939,7565931,'led',16.667,4),(1053,7565940,7565934,'cac',33.333,1),(1053,7565941,7565934,'ach',33.333,1),(1053,7565942,7565934,'che',33.333,1),(1053,7565943,7565940,'mod',50,1),(1053,7565944,7565940,'ode',50,1),(1053,7565945,7565943,'wri',14.286,1),(1053,7565946,7565943,'rit',14.286,1),(1053,7565947,7565943,'ite',14.286,1),(1053,7565948,7565943,'tet',14.286,1),(1053,7565949,7565943,'eth',14.286,1),(1053,7565950,7565943,'thr',14.286,1),(1053,7565951,7565943,'hru',14.286,1),(1053,7565952,7565945,'ope',11.111,2),(1053,7565953,7565945,'per',11.111,2),(1053,7565954,7565945,'era',11.111,2),(1053,7565955,7565945,'rat',11.111,2),(1053,7565956,7565945,'ati',11.111,2),(1053,7565957,7565945,'tio',11.111,2),(1053,7565958,7565945,'ion',11.111,2),(1053,7565959,7565945,'ona',11.111,2),(1053,7565960,7565945,'nal',11.111,2),(1053,7565961,7565952,'mes',20,1),(1053,7565962,7565952,'ess',20,1),(1053,7565963,7565952,'ssa',20,1),(1053,7565964,7565952,'sag',20,1),(1053,7565965,7565952,'age',20,1),(1053,7565966,7565961,'per',11.111,1),(1053,7565967,7565961,'erf',11.111,1),(1053,7565968,7565961,'rfo',11.111,1),(1053,7565969,7565961,'for',11.111,1),(1053,7565970,7565961,'orm',11.111,1),(1053,7565971,7565961,'rma',11.111,1),(1053,7565972,7565961,'man',11.111,1),(1053,7565973,7565961,'anc',11.111,1),(1053,7565974,7565961,'nce',11.111,1),(1053,7565975,7565966,'ide',12.5,1),(1053,7565976,7565966,'den',12.5,1),(1053,7565977,7565966,'ent',12.5,1),(1053,7565978,7565966,'nti',12.5,1),(1053,7565979,7565966,'tif',12.5,1),(1053,7565980,7565966,'ifi',12.5,1),(1053,7565981,7565966,'fie',12.5,1),(1053,7565982,7565966,'ier',12.5,1),(1053,7565983,7565975,'vdi',33.333,3),(1053,7565984,7565975,'dis',33.333,3),(1053,7565985,7565975,'isk',33.333,3),(1053,7565986,7565983,'nam',50,1),(1053,7565987,7565983,'ame',50,1),(1053,7565988,7565986,'typ',50,1),(1053,7565989,7565986,'ype',50,1),(1053,7565990,7565988,'dir',25,1),(1053,7565991,7565988,'ire',25,1),(1053,7565992,7565988,'rec',25,1),(1053,7565993,7565988,'ect',25,1),(1054,7565995,7565994,'naa',100,2),(1054,7565996,7565995,'600',3.333,3),(1054,7565997,7565995,'000',3.333,3),(1054,7565998,7565995,'00c',3.333,3),(1054,7565999,7565995,'0c2',3.333,3),(1054,7566000,7565995,'c29',3.333,3),(1054,7566001,7565995,'291',3.333,3),(1054,7566002,7565995,'919',3.333,3),(1054,7566003,7565995,'199',3.333,3),(1054,7566004,7565995,'99f',3.333,3),(1054,7566005,7565995,'9f4',3.333,3),(1054,7566006,7565995,'f4b',3.333,3),(1054,7566007,7565995,'4bd',3.333,3),(1054,7566008,7565995,'bd2',3.333,3),(1054,7566009,7565995,'d2a',3.333,3),(1054,7566010,7565995,'2af',3.333,3),(1054,7566011,7565995,'af7',3.333,3),(1054,7566012,7565995,'f7d',3.333,3),(1054,7566013,7565995,'7dc',3.333,3),(1054,7566014,7565995,'dc6',3.333,3),(1054,7566015,7565995,'c67',3.333,3),(1054,7566016,7565995,'678',3.333,3),(1054,7566017,7565995,'786',3.333,3),(1054,7566018,7565995,'866',3.333,3),(1054,7566019,7565995,'66d',3.333,3),(1054,7566020,7565995,'6df',3.333,3),(1054,7566021,7565995,'dfc',3.333,3),(1054,7566022,7565995,'fc3',3.333,3),(1054,7566023,7565995,'c3e',3.333,3),(1054,7566024,7565995,'3ef',3.333,3),(1054,7566025,7565995,'efb',3.333,3),(1054,7566026,7565996,'mon',100,1),(1054,7566027,7566026,'201',50,1),(1054,7566028,7566026,'013',50,1),(1054,7566029,7566027,'adm',33.333,4),(1054,7566030,7566027,'dmi',33.333,4),(1054,7566031,7566027,'min',33.333,4),(1054,7566032,7566029,'cap',16.667,1),(1054,7566033,7566029,'apa',16.667,1),(1054,7566034,7566029,'pac',16.667,1),(1054,7566035,7566029,'aci',16.667,1),(1054,7566036,7566029,'cit',16.667,1),(1054,7566037,7566029,'ity',16.667,1),(1054,7566038,7566032,'pat',50,1),(1054,7566039,7566032,'ath',50,1),(1054,7566040,7566038,'sev',33.333,1),(1054,7566041,7566038,'eve',33.333,1),(1054,7566042,7566038,'ven',33.333,1),(1054,7566043,7566040,'fre',14.286,1),(1054,7566044,7566040,'ree',14.286,1),(1054,7566045,7566040,'ees',14.286,1),(1054,7566046,7566040,'esp',14.286,1),(1054,7566047,7566040,'spa',14.286,1),(1054,7566048,7566040,'pac',14.286,1),(1054,7566049,7566040,'ace',14.286,1),(1054,7566050,7566043,'dis',50,1),(1054,7566051,7566043,'isk',50,1),(1054,7566052,7566050,'ind',33.333,1),(1054,7566053,7566050,'nde',33.333,1),(1054,7566054,7566050,'dex',33.333,1),(1054,7566055,7566052,'adm',8.333,1),(1054,7566056,7566052,'dmi',8.333,1),(1054,7566057,7566052,'min',8.333,1),(1054,7566058,7566052,'ini',8.333,1),(1054,7566059,7566052,'nis',8.333,1),(1054,7566060,7566052,'ist',8.333,1),(1054,7566061,7566052,'str',8.333,1),(1054,7566062,7566052,'tra',8.333,1),(1054,7566063,7566052,'rat',8.333,1),(1054,7566064,7566052,'ati',8.333,1),(1054,7566065,7566052,'tio',8.333,1),(1054,7566066,7566052,'ion',8.333,1),(1054,7566067,7566055,'sta',33.333,3),(1054,7566068,7566055,'tat',33.333,3),(1054,7566069,7566055,'ate',33.333,3),(1054,7566070,7566067,'dis',16.667,4),(1054,7566071,7566067,'isa',16.667,4),(1054,7566072,7566067,'sab',16.667,4),(1054,7566073,7566067,'abl',16.667,4),(1054,7566074,7566067,'ble',16.667,4),(1054,7566075,7566067,'led',16.667,4),(1054,7566076,7566070,'cac',33.333,1),(1054,7566077,7566070,'ach',33.333,1),(1054,7566078,7566070,'che',33.333,1),(1054,7566079,7566076,'mod',50,1),(1054,7566080,7566076,'ode',50,1),(1054,7566081,7566079,'wri',14.286,1),(1054,7566082,7566079,'rit',14.286,1),(1054,7566083,7566079,'ite',14.286,1),(1054,7566084,7566079,'tet',14.286,1),(1054,7566085,7566079,'eth',14.286,1),(1054,7566086,7566079,'thr',14.286,1),(1054,7566087,7566079,'hru',14.286,1),(1054,7566088,7566081,'ope',11.111,2),(1054,7566089,7566081,'per',11.111,2),(1054,7566090,7566081,'era',11.111,2),(1054,7566091,7566081,'rat',11.111,2),(1054,7566092,7566081,'ati',11.111,2),(1054,7566093,7566081,'tio',11.111,2),(1054,7566094,7566081,'ion',11.111,2),(1054,7566095,7566081,'ona',11.111,2),(1054,7566096,7566081,'nal',11.111,2),(1054,7566097,7566088,'mes',20,1),(1054,7566098,7566088,'ess',20,1),(1054,7566099,7566088,'ssa',20,1),(1054,7566100,7566088,'sag',20,1),(1054,7566101,7566088,'age',20,1),(1054,7566102,7566097,'per',11.111,1),(1054,7566103,7566097,'erf',11.111,1),(1054,7566104,7566097,'rfo',11.111,1),(1054,7566105,7566097,'for',11.111,1),(1054,7566106,7566097,'orm',11.111,1),(1054,7566107,7566097,'rma',11.111,1),(1054,7566108,7566097,'man',11.111,1),(1054,7566109,7566097,'anc',11.111,1),(1054,7566110,7566097,'nce',11.111,1),(1054,7566111,7566102,'ide',12.5,1),(1054,7566112,7566102,'den',12.5,1),(1054,7566113,7566102,'ent',12.5,1),(1054,7566114,7566102,'nti',12.5,1),(1054,7566115,7566102,'tif',12.5,1),(1054,7566116,7566102,'ifi',12.5,1),(1054,7566117,7566102,'fie',12.5,1),(1054,7566118,7566102,'ier',12.5,1),(1054,7566119,7566111,'vdi',33.333,3),(1054,7566120,7566111,'dis',33.333,3),(1054,7566121,7566111,'isk',33.333,3),(1054,7566122,7566119,'nam',50,1),(1054,7566123,7566119,'ame',50,1),(1054,7566124,7566122,'typ',50,1),(1054,7566125,7566122,'ype',50,1),(1054,7566126,7566124,'dir',25,1),(1054,7566127,7566124,'ire',25,1),(1054,7566128,7566124,'rec',25,1),(1054,7566129,7566124,'ect',25,1),(1055,7566131,7566130,'naa',100,2),(1055,7566132,7566131,'600',3.333,3),(1055,7566133,7566131,'000',3.333,3),(1055,7566134,7566131,'00c',3.333,3),(1055,7566135,7566131,'0c2',3.333,3),(1055,7566136,7566131,'c29',3.333,3),(1055,7566137,7566131,'296',3.333,3),(1055,7566138,7566131,'960',3.333,3),(1055,7566139,7566131,'601',3.333,3),(1055,7566140,7566131,'01f',3.333,3),(1055,7566141,7566131,'1f4',3.333,3),(1055,7566142,7566131,'f47',3.333,3),(1055,7566143,7566131,'47c',3.333,3),(1055,7566144,7566131,'7c3',3.333,3),(1055,7566145,7566131,'c3c',3.333,3),(1055,7566146,7566131,'3ce',3.333,3),(1055,7566147,7566131,'ce5',3.333,3),(1055,7566148,7566131,'e5f',3.333,3),(1055,7566149,7566131,'5fc',3.333,3),(1055,7566150,7566131,'fcc',3.333,3),(1055,7566151,7566131,'cc2',3.333,3),(1055,7566152,7566131,'c29',3.333,3),(1055,7566153,7566131,'295',3.333,3),(1055,7566154,7566131,'951',3.333,3),(1055,7566155,7566131,'51b',3.333,3),(1055,7566156,7566131,'1b5',3.333,3),(1055,7566157,7566131,'b5e',3.333,3),(1055,7566158,7566131,'5e7',3.333,3),(1055,7566159,7566131,'e72',3.333,3),(1055,7566160,7566131,'72c',3.333,3),(1055,7566161,7566131,'2c6',3.333,3),(1055,7566162,7566132,'mon',100,1),(1055,7566163,7566162,'201',50,1),(1055,7566164,7566162,'013',50,1),(1055,7566165,7566163,'adm',33.333,4),(1055,7566166,7566163,'dmi',33.333,4),(1055,7566167,7566163,'min',33.333,4),(1055,7566168,7566165,'cap',16.667,1),(1055,7566169,7566165,'apa',16.667,1),(1055,7566170,7566165,'pac',16.667,1),(1055,7566171,7566165,'aci',16.667,1),(1055,7566172,7566165,'cit',16.667,1),(1055,7566173,7566165,'ity',16.667,1),(1055,7566174,7566168,'pat',50,1),(1055,7566175,7566168,'ath',50,1),(1055,7566176,7566174,'six',100,1),(1055,7566177,7566176,'fre',14.286,1),(1055,7566178,7566176,'ree',14.286,1),(1055,7566179,7566176,'ees',14.286,1),(1055,7566180,7566176,'esp',14.286,1),(1055,7566181,7566176,'spa',14.286,1),(1055,7566182,7566176,'pac',14.286,1),(1055,7566183,7566176,'ace',14.286,1),(1055,7566184,7566177,'dis',50,1),(1055,7566185,7566177,'isk',50,1),(1055,7566186,7566184,'ind',33.333,1),(1055,7566187,7566184,'nde',33.333,1),(1055,7566188,7566184,'dex',33.333,1),(1055,7566189,7566186,'adm',8.333,1),(1055,7566190,7566186,'dmi',8.333,1),(1055,7566191,7566186,'min',8.333,1),(1055,7566192,7566186,'ini',8.333,1),(1055,7566193,7566186,'nis',8.333,1),(1055,7566194,7566186,'ist',8.333,1),(1055,7566195,7566186,'str',8.333,1),(1055,7566196,7566186,'tra',8.333,1),(1055,7566197,7566186,'rat',8.333,1),(1055,7566198,7566186,'ati',8.333,1),(1055,7566199,7566186,'tio',8.333,1),(1055,7566200,7566186,'ion',8.333,1),(1055,7566201,7566189,'sta',33.333,3),(1055,7566202,7566189,'tat',33.333,3),(1055,7566203,7566189,'ate',33.333,3),(1055,7566204,7566201,'dis',16.667,4),(1055,7566205,7566201,'isa',16.667,4),(1055,7566206,7566201,'sab',16.667,4),(1055,7566207,7566201,'abl',16.667,4),(1055,7566208,7566201,'ble',16.667,4),(1055,7566209,7566201,'led',16.667,4),(1055,7566210,7566204,'cac',33.333,1),(1055,7566211,7566204,'ach',33.333,1),(1055,7566212,7566204,'che',33.333,1),(1055,7566213,7566210,'mod',50,1),(1055,7566214,7566210,'ode',50,1),(1055,7566215,7566213,'wri',14.286,1),(1055,7566216,7566213,'rit',14.286,1),(1055,7566217,7566213,'ite',14.286,1),(1055,7566218,7566213,'tet',14.286,1),(1055,7566219,7566213,'eth',14.286,1),(1055,7566220,7566213,'thr',14.286,1),(1055,7566221,7566213,'hru',14.286,1),(1055,7566222,7566215,'ope',11.111,2),(1055,7566223,7566215,'per',11.111,2),(1055,7566224,7566215,'era',11.111,2),(1055,7566225,7566215,'rat',11.111,2),(1055,7566226,7566215,'ati',11.111,2),(1055,7566227,7566215,'tio',11.111,2),(1055,7566228,7566215,'ion',11.111,2),(1055,7566229,7566215,'ona',11.111,2),(1055,7566230,7566215,'nal',11.111,2),(1055,7566231,7566222,'mes',20,1),(1055,7566232,7566222,'ess',20,1),(1055,7566233,7566222,'ssa',20,1),(1055,7566234,7566222,'sag',20,1),(1055,7566235,7566222,'age',20,1),(1055,7566236,7566231,'per',11.111,1),(1055,7566237,7566231,'erf',11.111,1),(1055,7566238,7566231,'rfo',11.111,1),(1055,7566239,7566231,'for',11.111,1),(1055,7566240,7566231,'orm',11.111,1),(1055,7566241,7566231,'rma',11.111,1),(1055,7566242,7566231,'man',11.111,1),(1055,7566243,7566231,'anc',11.111,1),(1055,7566244,7566231,'nce',11.111,1),(1055,7566245,7566236,'ide',12.5,1),(1055,7566246,7566236,'den',12.5,1),(1055,7566247,7566236,'ent',12.5,1),(1055,7566248,7566236,'nti',12.5,1),(1055,7566249,7566236,'tif',12.5,1),(1055,7566250,7566236,'ifi',12.5,1),(1055,7566251,7566236,'fie',12.5,1),(1055,7566252,7566236,'ier',12.5,1),(1055,7566253,7566245,'vdi',33.333,3),(1055,7566254,7566245,'dis',33.333,3),(1055,7566255,7566245,'isk',33.333,3),(1055,7566256,7566253,'nam',50,1),(1055,7566257,7566253,'ame',50,1),(1055,7566258,7566256,'typ',50,1),(1055,7566259,7566256,'ype',50,1),(1055,7566260,7566258,'dir',25,1),(1055,7566261,7566258,'ire',25,1),(1055,7566262,7566258,'rec',25,1),(1055,7566263,7566258,'ect',25,1),(1056,7566265,7566264,'naa',100,2),(1056,7566266,7566265,'600',3.333,3),(1056,7566267,7566265,'000',3.333,3),(1056,7566268,7566265,'00c',3.333,3),(1056,7566269,7566265,'0c2',3.333,3),(1056,7566270,7566265,'c29',3.333,3),(1056,7566271,7566265,'299',3.333,3),(1056,7566272,7566265,'995',3.333,3),(1056,7566273,7566265,'95c',3.333,3),(1056,7566274,7566265,'5cd',3.333,3),(1056,7566275,7566265,'cdb',3.333,3),(1056,7566276,7566265,'db5',3.333,3),(1056,7566277,7566265,'b55',3.333,3),(1056,7566278,7566265,'553',3.333,3),(1056,7566279,7566265,'534',3.333,3),(1056,7566280,7566265,'343',3.333,3),(1056,7566281,7566265,'435',3.333,3),(1056,7566282,7566265,'350',3.333,3),(1056,7566283,7566265,'506',3.333,3),(1056,7566284,7566265,'063',3.333,3),(1056,7566285,7566265,'63d',3.333,3),(1056,7566286,7566265,'3dc',3.333,3),(1056,7566287,7566265,'dc1',3.333,3),(1056,7566288,7566265,'c1a',3.333,3),(1056,7566289,7566265,'1a4',3.333,3),(1056,7566290,7566265,'a45',3.333,3),(1056,7566291,7566265,'45e',3.333,3),(1056,7566292,7566265,'5e0',3.333,3),(1056,7566293,7566265,'e0b',3.333,3),(1056,7566294,7566265,'0be',3.333,3),(1056,7566295,7566265,'be7',3.333,3),(1056,7566296,7566266,'mon',100,1),(1056,7566297,7566296,'201',50,1),(1056,7566298,7566296,'013',50,1),(1056,7566299,7566297,'adm',33.333,4),(1056,7566300,7566297,'dmi',33.333,4),(1056,7566301,7566297,'min',33.333,4),(1056,7566302,7566299,'cap',16.667,1),(1056,7566303,7566299,'apa',16.667,1),(1056,7566304,7566299,'pac',16.667,1),(1056,7566305,7566299,'aci',16.667,1),(1056,7566306,7566299,'cit',16.667,1),(1056,7566307,7566299,'ity',16.667,1),(1056,7566308,7566302,'pat',50,1),(1056,7566309,7566302,'ath',50,1),(1056,7566310,7566308,'fre',14.286,1),(1056,7566311,7566308,'ree',14.286,1),(1056,7566312,7566308,'ees',14.286,1),(1056,7566313,7566308,'esp',14.286,1),(1056,7566314,7566308,'spa',14.286,1),(1056,7566315,7566308,'pac',14.286,1),(1056,7566316,7566308,'ace',14.286,1),(1056,7566317,7566310,'dis',50,1),(1056,7566318,7566310,'isk',50,1),(1056,7566319,7566317,'ind',33.333,1),(1056,7566320,7566317,'nde',33.333,1),(1056,7566321,7566317,'dex',33.333,1),(1056,7566322,7566319,'adm',8.333,1),(1056,7566323,7566319,'dmi',8.333,1),(1056,7566324,7566319,'min',8.333,1),(1056,7566325,7566319,'ini',8.333,1),(1056,7566326,7566319,'nis',8.333,1),(1056,7566327,7566319,'ist',8.333,1),(1056,7566328,7566319,'str',8.333,1),(1056,7566329,7566319,'tra',8.333,1),(1056,7566330,7566319,'rat',8.333,1),(1056,7566331,7566319,'ati',8.333,1),(1056,7566332,7566319,'tio',8.333,1),(1056,7566333,7566319,'ion',8.333,1),(1056,7566334,7566322,'sta',33.333,3),(1056,7566335,7566322,'tat',33.333,3),(1056,7566336,7566322,'ate',33.333,3),(1056,7566337,7566334,'dis',16.667,4),(1056,7566338,7566334,'isa',16.667,4),(1056,7566339,7566334,'sab',16.667,4),(1056,7566340,7566334,'abl',16.667,4),(1056,7566341,7566334,'ble',16.667,4),(1056,7566342,7566334,'led',16.667,4),(1056,7566343,7566337,'cac',33.333,1),(1056,7566344,7566337,'ach',33.333,1),(1056,7566345,7566337,'che',33.333,1),(1056,7566346,7566343,'mod',50,1),(1056,7566347,7566343,'ode',50,1),(1056,7566348,7566346,'wri',14.286,1),(1056,7566349,7566346,'rit',14.286,1),(1056,7566350,7566346,'ite',14.286,1),(1056,7566351,7566346,'tet',14.286,1),(1056,7566352,7566346,'eth',14.286,1),(1056,7566353,7566346,'thr',14.286,1),(1056,7566354,7566346,'hru',14.286,1),(1056,7566355,7566348,'ope',11.111,2),(1056,7566356,7566348,'per',11.111,2),(1056,7566357,7566348,'era',11.111,2),(1056,7566358,7566348,'rat',11.111,2),(1056,7566359,7566348,'ati',11.111,2),(1056,7566360,7566348,'tio',11.111,2),(1056,7566361,7566348,'ion',11.111,2),(1056,7566362,7566348,'ona',11.111,2),(1056,7566363,7566348,'nal',11.111,2),(1056,7566364,7566355,'mes',20,1),(1056,7566365,7566355,'ess',20,1),(1056,7566366,7566355,'ssa',20,1),(1056,7566367,7566355,'sag',20,1),(1056,7566368,7566355,'age',20,1),(1056,7566369,7566364,'per',11.111,1),(1056,7566370,7566364,'erf',11.111,1),(1056,7566371,7566364,'rfo',11.111,1),(1056,7566372,7566364,'for',11.111,1),(1056,7566373,7566364,'orm',11.111,1),(1056,7566374,7566364,'rma',11.111,1),(1056,7566375,7566364,'man',11.111,1),(1056,7566376,7566364,'anc',11.111,1),(1056,7566377,7566364,'nce',11.111,1),(1056,7566378,7566369,'ide',12.5,1),(1056,7566379,7566369,'den',12.5,1),(1056,7566380,7566369,'ent',12.5,1),(1056,7566381,7566369,'nti',12.5,1),(1056,7566382,7566369,'tif',12.5,1),(1056,7566383,7566369,'ifi',12.5,1),(1056,7566384,7566369,'fie',12.5,1),(1056,7566385,7566369,'ier',12.5,1),(1056,7566386,7566378,'vdi',33.333,3),(1056,7566387,7566378,'dis',33.333,3),(1056,7566388,7566378,'isk',33.333,3),(1056,7566389,7566386,'nam',50,1),(1056,7566390,7566386,'ame',50,1),(1056,7566391,7566389,'typ',50,1),(1056,7566392,7566389,'ype',50,1),(1056,7566393,7566391,'dir',25,1),(1056,7566394,7566391,'ire',25,1),(1056,7566395,7566391,'rec',25,1),(1056,7566396,7566391,'ect',25,1),(1057,7566398,7566397,'naa',100,2),(1057,7566399,7566398,'600',3.333,3),(1057,7566400,7566398,'000',3.333,3),(1057,7566401,7566398,'00c',3.333,3),(1057,7566402,7566398,'0c2',3.333,3),(1057,7566403,7566398,'c29',3.333,3),(1057,7566404,7566398,'292',3.333,3),(1057,7566405,7566398,'928',3.333,3),(1057,7566406,7566398,'284',3.333,3),(1057,7566407,7566398,'84b',3.333,3),(1057,7566408,7566398,'4b5',3.333,3),(1057,7566409,7566398,'b53',3.333,3),(1057,7566410,7566398,'53b',3.333,3),(1057,7566411,7566398,'3b7',3.333,3),(1057,7566412,7566398,'b73',3.333,3),(1057,7566413,7566398,'730',3.333,3),(1057,7566414,7566398,'30c',3.333,3),(1057,7566415,7566398,'0cc',3.333,3),(1057,7566416,7566398,'cc7',3.333,3),(1057,7566417,7566398,'c72',3.333,3),(1057,7566418,7566398,'726',3.333,3),(1057,7566419,7566398,'26c',3.333,3),(1057,7566420,7566398,'6cf',3.333,3),(1057,7566421,7566398,'cfc',3.333,3),(1057,7566422,7566398,'fc4',3.333,3),(1057,7566423,7566398,'c43',3.333,3),(1057,7566424,7566398,'43f',3.333,3),(1057,7566425,7566398,'3f0',3.333,3),(1057,7566426,7566398,'f09',3.333,3),(1057,7566427,7566398,'09c',3.333,3),(1057,7566428,7566398,'9c6',3.333,3),(1057,7566429,7566399,'mon',100,1),(1057,7566430,7566429,'201',50,1),(1057,7566431,7566429,'013',50,1),(1057,7566432,7566430,'adm',33.333,4),(1057,7566433,7566430,'dmi',33.333,4),(1057,7566434,7566430,'min',33.333,4),(1057,7566435,7566432,'cap',16.667,1),(1057,7566436,7566432,'apa',16.667,1),(1057,7566437,7566432,'pac',16.667,1),(1057,7566438,7566432,'aci',16.667,1),(1057,7566439,7566432,'cit',16.667,1),(1057,7566440,7566432,'ity',16.667,1),(1057,7566441,7566435,'pat',50,1),(1057,7566442,7566435,'ath',50,1),(1057,7566443,7566441,'ten',100,1),(1057,7566444,7566443,'fre',14.286,1),(1057,7566445,7566443,'ree',14.286,1),(1057,7566446,7566443,'ees',14.286,1),(1057,7566447,7566443,'esp',14.286,1),(1057,7566448,7566443,'spa',14.286,1),(1057,7566449,7566443,'pac',14.286,1),(1057,7566450,7566443,'ace',14.286,1),(1057,7566451,7566444,'dis',50,1),(1057,7566452,7566444,'isk',50,1),(1057,7566453,7566451,'ind',33.333,1),(1057,7566454,7566451,'nde',33.333,1),(1057,7566455,7566451,'dex',33.333,1),(1057,7566456,7566453,'adm',8.333,1),(1057,7566457,7566453,'dmi',8.333,1),(1057,7566458,7566453,'min',8.333,1),(1057,7566459,7566453,'ini',8.333,1),(1057,7566460,7566453,'nis',8.333,1),(1057,7566461,7566453,'ist',8.333,1),(1057,7566462,7566453,'str',8.333,1),(1057,7566463,7566453,'tra',8.333,1),(1057,7566464,7566453,'rat',8.333,1),(1057,7566465,7566453,'ati',8.333,1),(1057,7566466,7566453,'tio',8.333,1),(1057,7566467,7566453,'ion',8.333,1),(1057,7566468,7566456,'sta',33.333,3),(1057,7566469,7566456,'tat',33.333,3),(1057,7566470,7566456,'ate',33.333,3),(1057,7566471,7566468,'dis',16.667,4),(1057,7566472,7566468,'isa',16.667,4),(1057,7566473,7566468,'sab',16.667,4),(1057,7566474,7566468,'abl',16.667,4),(1057,7566475,7566468,'ble',16.667,4),(1057,7566476,7566468,'led',16.667,4),(1057,7566477,7566471,'cac',33.333,1),(1057,7566478,7566471,'ach',33.333,1),(1057,7566479,7566471,'che',33.333,1),(1057,7566480,7566477,'mod',50,1),(1057,7566481,7566477,'ode',50,1),(1057,7566482,7566480,'wri',14.286,1),(1057,7566483,7566480,'rit',14.286,1),(1057,7566484,7566480,'ite',14.286,1),(1057,7566485,7566480,'tet',14.286,1),(1057,7566486,7566480,'eth',14.286,1),(1057,7566487,7566480,'thr',14.286,1),(1057,7566488,7566480,'hru',14.286,1),(1057,7566489,7566482,'ope',11.111,2),(1057,7566490,7566482,'per',11.111,2),(1057,7566491,7566482,'era',11.111,2),(1057,7566492,7566482,'rat',11.111,2),(1057,7566493,7566482,'ati',11.111,2),(1057,7566494,7566482,'tio',11.111,2),(1057,7566495,7566482,'ion',11.111,2),(1057,7566496,7566482,'ona',11.111,2),(1057,7566497,7566482,'nal',11.111,2),(1057,7566498,7566489,'mes',20,1),(1057,7566499,7566489,'ess',20,1),(1057,7566500,7566489,'ssa',20,1),(1057,7566501,7566489,'sag',20,1),(1057,7566502,7566489,'age',20,1),(1057,7566503,7566498,'per',11.111,1),(1057,7566504,7566498,'erf',11.111,1),(1057,7566505,7566498,'rfo',11.111,1),(1057,7566506,7566498,'for',11.111,1),(1057,7566507,7566498,'orm',11.111,1),(1057,7566508,7566498,'rma',11.111,1),(1057,7566509,7566498,'man',11.111,1),(1057,7566510,7566498,'anc',11.111,1),(1057,7566511,7566498,'nce',11.111,1),(1057,7566512,7566503,'ide',12.5,1),(1057,7566513,7566503,'den',12.5,1),(1057,7566514,7566503,'ent',12.5,1),(1057,7566515,7566503,'nti',12.5,1),(1057,7566516,7566503,'tif',12.5,1),(1057,7566517,7566503,'ifi',12.5,1),(1057,7566518,7566503,'fie',12.5,1),(1057,7566519,7566503,'ier',12.5,1),(1057,7566520,7566512,'vdi',33.333,3),(1057,7566521,7566512,'dis',33.333,3),(1057,7566522,7566512,'isk',33.333,3),(1057,7566523,7566520,'nam',50,1),(1057,7566524,7566520,'ame',50,1),(1057,7566525,7566523,'typ',50,1),(1057,7566526,7566523,'ype',50,1),(1057,7566527,7566525,'dir',25,1),(1057,7566528,7566525,'ire',25,1),(1057,7566529,7566525,'rec',25,1),(1057,7566530,7566525,'ect',25,1),(1058,7566532,7566531,'naa',100,2),(1058,7566533,7566532,'600',3.333,3),(1058,7566534,7566532,'000',3.333,3),(1058,7566535,7566532,'00c',3.333,3),(1058,7566536,7566532,'0c2',3.333,3),(1058,7566537,7566532,'c29',3.333,3),(1058,7566538,7566532,'297',3.333,3),(1058,7566539,7566532,'976',3.333,3),(1058,7566540,7566532,'76d',3.333,3),(1058,7566541,7566532,'6de',3.333,3),(1058,7566542,7566532,'deb',3.333,3),(1058,7566543,7566532,'ebf',3.333,3),(1058,7566544,7566532,'bf2',3.333,3),(1058,7566545,7566532,'f20',3.333,3),(1058,7566546,7566532,'206',3.333,3),(1058,7566547,7566532,'06c',3.333,3),(1058,7566548,7566532,'6cf',3.333,3),(1058,7566549,7566532,'cf6',3.333,3),(1058,7566550,7566532,'f68',3.333,3),(1058,7566551,7566532,'689',3.333,3),(1058,7566552,7566532,'892',3.333,3),(1058,7566553,7566532,'924',3.333,3),(1058,7566554,7566532,'247',3.333,3),(1058,7566555,7566532,'474',3.333,3),(1058,7566556,7566532,'749',3.333,3),(1058,7566557,7566532,'49f',3.333,3),(1058,7566558,7566532,'9f3',3.333,3),(1058,7566559,7566532,'f31',3.333,3),(1058,7566560,7566532,'310',3.333,3),(1058,7566561,7566532,'104',3.333,3),(1058,7566562,7566532,'041',3.333,3),(1058,7566563,7566533,'mon',100,1),(1058,7566564,7566563,'201',50,1),(1058,7566565,7566563,'013',50,1),(1058,7566566,7566564,'adm',33.333,4),(1058,7566567,7566564,'dmi',33.333,4),(1058,7566568,7566564,'min',33.333,4),(1058,7566569,7566566,'cap',16.667,1),(1058,7566570,7566566,'apa',16.667,1),(1058,7566571,7566566,'pac',16.667,1),(1058,7566572,7566566,'aci',16.667,1),(1058,7566573,7566566,'cit',16.667,1),(1058,7566574,7566566,'ity',16.667,1),(1058,7566575,7566569,'pat',50,1),(1058,7566576,7566569,'ath',50,1),(1058,7566577,7566575,'thi',16.667,1),(1058,7566578,7566575,'hir',16.667,1),(1058,7566579,7566575,'irt',16.667,1),(1058,7566580,7566575,'rte',16.667,1),(1058,7566581,7566575,'tee',16.667,1),(1058,7566582,7566575,'een',16.667,1),(1058,7566583,7566577,'fre',14.286,1),(1058,7566584,7566577,'ree',14.286,1),(1058,7566585,7566577,'ees',14.286,1),(1058,7566586,7566577,'esp',14.286,1),(1058,7566587,7566577,'spa',14.286,1),(1058,7566588,7566577,'pac',14.286,1),(1058,7566589,7566577,'ace',14.286,1),(1058,7566590,7566583,'dis',50,1),(1058,7566591,7566583,'isk',50,1),(1058,7566592,7566590,'ind',33.333,1),(1058,7566593,7566590,'nde',33.333,1),(1058,7566594,7566590,'dex',33.333,1),(1058,7566595,7566592,'adm',8.333,1),(1058,7566596,7566592,'dmi',8.333,1),(1058,7566597,7566592,'min',8.333,1),(1058,7566598,7566592,'ini',8.333,1),(1058,7566599,7566592,'nis',8.333,1),(1058,7566600,7566592,'ist',8.333,1),(1058,7566601,7566592,'str',8.333,1),(1058,7566602,7566592,'tra',8.333,1),(1058,7566603,7566592,'rat',8.333,1),(1058,7566604,7566592,'ati',8.333,1),(1058,7566605,7566592,'tio',8.333,1),(1058,7566606,7566592,'ion',8.333,1),(1058,7566607,7566595,'sta',33.333,3),(1058,7566608,7566595,'tat',33.333,3),(1058,7566609,7566595,'ate',33.333,3),(1058,7566610,7566607,'dis',16.667,4),(1058,7566611,7566607,'isa',16.667,4),(1058,7566612,7566607,'sab',16.667,4),(1058,7566613,7566607,'abl',16.667,4),(1058,7566614,7566607,'ble',16.667,4),(1058,7566615,7566607,'led',16.667,4),(1058,7566616,7566610,'cac',33.333,1),(1058,7566617,7566610,'ach',33.333,1),(1058,7566618,7566610,'che',33.333,1),(1058,7566619,7566616,'mod',50,1),(1058,7566620,7566616,'ode',50,1),(1058,7566621,7566619,'wri',14.286,1),(1058,7566622,7566619,'rit',14.286,1),(1058,7566623,7566619,'ite',14.286,1),(1058,7566624,7566619,'tet',14.286,1),(1058,7566625,7566619,'eth',14.286,1),(1058,7566626,7566619,'thr',14.286,1),(1058,7566627,7566619,'hru',14.286,1),(1058,7566628,7566621,'ope',11.111,2),(1058,7566629,7566621,'per',11.111,2),(1058,7566630,7566621,'era',11.111,2),(1058,7566631,7566621,'rat',11.111,2),(1058,7566632,7566621,'ati',11.111,2),(1058,7566633,7566621,'tio',11.111,2),(1058,7566634,7566621,'ion',11.111,2),(1058,7566635,7566621,'ona',11.111,2),(1058,7566636,7566621,'nal',11.111,2),(1058,7566637,7566628,'mes',20,1),(1058,7566638,7566628,'ess',20,1),(1058,7566639,7566628,'ssa',20,1),(1058,7566640,7566628,'sag',20,1),(1058,7566641,7566628,'age',20,1),(1058,7566642,7566637,'per',11.111,1),(1058,7566643,7566637,'erf',11.111,1),(1058,7566644,7566637,'rfo',11.111,1),(1058,7566645,7566637,'for',11.111,1),(1058,7566646,7566637,'orm',11.111,1),(1058,7566647,7566637,'rma',11.111,1),(1058,7566648,7566637,'man',11.111,1),(1058,7566649,7566637,'anc',11.111,1),(1058,7566650,7566637,'nce',11.111,1),(1058,7566651,7566642,'ide',12.5,1),(1058,7566652,7566642,'den',12.5,1),(1058,7566653,7566642,'ent',12.5,1),(1058,7566654,7566642,'nti',12.5,1),(1058,7566655,7566642,'tif',12.5,1),(1058,7566656,7566642,'ifi',12.5,1),(1058,7566657,7566642,'fie',12.5,1),(1058,7566658,7566642,'ier',12.5,1),(1058,7566659,7566651,'vdi',33.333,3),(1058,7566660,7566651,'dis',33.333,3),(1058,7566661,7566651,'isk',33.333,3),(1058,7566662,7566659,'nam',50,1),(1058,7566663,7566659,'ame',50,1),(1058,7566664,7566662,'typ',50,1),(1058,7566665,7566662,'ype',50,1),(1058,7566666,7566664,'dir',25,1),(1058,7566667,7566664,'ire',25,1),(1058,7566668,7566664,'rec',25,1),(1058,7566669,7566664,'ect',25,1),(1059,7566671,7566670,'naa',100,2),(1059,7566672,7566671,'600',3.333,3),(1059,7566673,7566671,'000',3.333,3),(1059,7566674,7566671,'00c',3.333,3),(1059,7566675,7566671,'0c2',3.333,3),(1059,7566676,7566671,'c29',3.333,3),(1059,7566677,7566671,'29a',3.333,3),(1059,7566678,7566671,'9a3',3.333,3),(1059,7566679,7566671,'a3a',3.333,3),(1059,7566680,7566671,'3af',3.333,3),(1059,7566681,7566671,'aff',3.333,3),(1059,7566682,7566671,'ff7',3.333,3),(1059,7566683,7566671,'f76',3.333,3),(1059,7566684,7566671,'765',3.333,3),(1059,7566685,7566671,'652',3.333,3),(1059,7566686,7566671,'52c',3.333,3),(1059,7566687,7566671,'2ca',3.333,3),(1059,7566688,7566671,'cab',3.333,3),(1059,7566689,7566671,'ab0',3.333,3),(1059,7566690,7566671,'b07',3.333,3),(1059,7566691,7566671,'079',3.333,3),(1059,7566692,7566671,'79c',3.333,3),(1059,7566693,7566671,'9cb',3.333,3),(1059,7566694,7566671,'cb4',3.333,3),(1059,7566695,7566671,'b49',3.333,3),(1059,7566696,7566671,'49b',3.333,3),(1059,7566697,7566671,'9b9',3.333,3),(1059,7566698,7566671,'b93',3.333,3),(1059,7566699,7566671,'930',3.333,3),(1059,7566700,7566671,'300',3.333,3),(1059,7566701,7566671,'001',3.333,3),(1059,7566702,7566672,'mon',100,1),(1059,7566703,7566702,'201',50,1),(1059,7566704,7566702,'013',50,1),(1059,7566705,7566703,'adm',33.333,4),(1059,7566706,7566703,'dmi',33.333,4),(1059,7566707,7566703,'min',33.333,4),(1059,7566708,7566705,'cap',16.667,1),(1059,7566709,7566705,'apa',16.667,1),(1059,7566710,7566705,'pac',16.667,1),(1059,7566711,7566705,'aci',16.667,1),(1059,7566712,7566705,'cit',16.667,1),(1059,7566713,7566705,'ity',16.667,1),(1059,7566714,7566708,'pat',50,1),(1059,7566715,7566708,'ath',50,1),(1059,7566716,7566714,'fre',14.286,1),(1059,7566717,7566714,'ree',14.286,1),(1059,7566718,7566714,'ees',14.286,1),(1059,7566719,7566714,'esp',14.286,1),(1059,7566720,7566714,'spa',14.286,1),(1059,7566721,7566714,'pac',14.286,1),(1059,7566722,7566714,'ace',14.286,1),(1059,7566723,7566716,'dis',50,1),(1059,7566724,7566716,'isk',50,1),(1059,7566725,7566723,'ind',33.333,1),(1059,7566726,7566723,'nde',33.333,1),(1059,7566727,7566723,'dex',33.333,1),(1059,7566728,7566725,'adm',8.333,1),(1059,7566729,7566725,'dmi',8.333,1),(1059,7566730,7566725,'min',8.333,1),(1059,7566731,7566725,'ini',8.333,1),(1059,7566732,7566725,'nis',8.333,1),(1059,7566733,7566725,'ist',8.333,1),(1059,7566734,7566725,'str',8.333,1),(1059,7566735,7566725,'tra',8.333,1),(1059,7566736,7566725,'rat',8.333,1),(1059,7566737,7566725,'ati',8.333,1),(1059,7566738,7566725,'tio',8.333,1),(1059,7566739,7566725,'ion',8.333,1),(1059,7566740,7566728,'sta',33.333,3),(1059,7566741,7566728,'tat',33.333,3),(1059,7566742,7566728,'ate',33.333,3),(1059,7566743,7566740,'dis',16.667,4),(1059,7566744,7566740,'isa',16.667,4),(1059,7566745,7566740,'sab',16.667,4),(1059,7566746,7566740,'abl',16.667,4),(1059,7566747,7566740,'ble',16.667,4),(1059,7566748,7566740,'led',16.667,4),(1059,7566749,7566743,'cac',33.333,1),(1059,7566750,7566743,'ach',33.333,1),(1059,7566751,7566743,'che',33.333,1),(1059,7566752,7566749,'mod',50,1),(1059,7566753,7566749,'ode',50,1),(1059,7566754,7566752,'wri',14.286,1),(1059,7566755,7566752,'rit',14.286,1),(1059,7566756,7566752,'ite',14.286,1),(1059,7566757,7566752,'tet',14.286,1),(1059,7566758,7566752,'eth',14.286,1),(1059,7566759,7566752,'thr',14.286,1),(1059,7566760,7566752,'hru',14.286,1),(1059,7566761,7566754,'ope',11.111,2),(1059,7566762,7566754,'per',11.111,2),(1059,7566763,7566754,'era',11.111,2),(1059,7566764,7566754,'rat',11.111,2),(1059,7566765,7566754,'ati',11.111,2),(1059,7566766,7566754,'tio',11.111,2),(1059,7566767,7566754,'ion',11.111,2),(1059,7566768,7566754,'ona',11.111,2),(1059,7566769,7566754,'nal',11.111,2),(1059,7566770,7566761,'mes',20,1),(1059,7566771,7566761,'ess',20,1),(1059,7566772,7566761,'ssa',20,1),(1059,7566773,7566761,'sag',20,1),(1059,7566774,7566761,'age',20,1),(1059,7566775,7566770,'per',11.111,1),(1059,7566776,7566770,'erf',11.111,1),(1059,7566777,7566770,'rfo',11.111,1),(1059,7566778,7566770,'for',11.111,1),(1059,7566779,7566770,'orm',11.111,1),(1059,7566780,7566770,'rma',11.111,1),(1059,7566781,7566770,'man',11.111,1),(1059,7566782,7566770,'anc',11.111,1),(1059,7566783,7566770,'nce',11.111,1),(1059,7566784,7566775,'ide',12.5,1),(1059,7566785,7566775,'den',12.5,1),(1059,7566786,7566775,'ent',12.5,1),(1059,7566787,7566775,'nti',12.5,1),(1059,7566788,7566775,'tif',12.5,1),(1059,7566789,7566775,'ifi',12.5,1),(1059,7566790,7566775,'fie',12.5,1),(1059,7566791,7566775,'ier',12.5,1),(1059,7566792,7566784,'vdi',33.333,3),(1059,7566793,7566784,'dis',33.333,3),(1059,7566794,7566784,'isk',33.333,3),(1059,7566795,7566792,'nam',50,1),(1059,7566796,7566792,'ame',50,1),(1059,7566797,7566795,'typ',50,1),(1059,7566798,7566795,'ype',50,1),(1059,7566799,7566797,'dir',25,1),(1059,7566800,7566797,'ire',25,1),(1059,7566801,7566797,'rec',25,1),(1059,7566802,7566797,'ect',25,1),(1060,7566804,7566803,'naa',100,2),(1060,7566805,7566804,'600',3.333,3),(1060,7566806,7566804,'000',3.333,3),(1060,7566807,7566804,'00c',3.333,3),(1060,7566808,7566804,'0c2',3.333,3),(1060,7566809,7566804,'c29',3.333,3),(1060,7566810,7566804,'29e',3.333,3),(1060,7566811,7566804,'9ed',3.333,3),(1060,7566812,7566804,'edc',3.333,3),(1060,7566813,7566804,'dcd',3.333,3),(1060,7566814,7566804,'cde',3.333,3),(1060,7566815,7566804,'def',3.333,3),(1060,7566816,7566804,'ef2',3.333,3),(1060,7566817,7566804,'f23',3.333,3),(1060,7566818,7566804,'23c',3.333,3),(1060,7566819,7566804,'3c8',3.333,3),(1060,7566820,7566804,'c8c',3.333,3),(1060,7566821,7566804,'8ce',3.333,3),(1060,7566822,7566804,'ceb',3.333,3),(1060,7566823,7566804,'eb1',3.333,3),(1060,7566824,7566804,'b1d',3.333,3),(1060,7566825,7566804,'1d6',3.333,3),(1060,7566826,7566804,'d6f',3.333,3),(1060,7566827,7566804,'6f3',3.333,3),(1060,7566828,7566804,'f32',3.333,3),(1060,7566829,7566804,'322',3.333,3),(1060,7566830,7566804,'22f',3.333,3),(1060,7566831,7566804,'2fd',3.333,3),(1060,7566832,7566804,'fdb',3.333,3),(1060,7566833,7566804,'db5',3.333,3),(1060,7566834,7566804,'b50',3.333,3),(1060,7566835,7566805,'mon',100,1),(1060,7566836,7566835,'201',50,1),(1060,7566837,7566835,'013',50,1),(1060,7566838,7566836,'adm',33.333,4),(1060,7566839,7566836,'dmi',33.333,4),(1060,7566840,7566836,'min',33.333,4),(1060,7566841,7566838,'cap',16.667,1),(1060,7566842,7566838,'apa',16.667,1),(1060,7566843,7566838,'pac',16.667,1),(1060,7566844,7566838,'aci',16.667,1),(1060,7566845,7566838,'cit',16.667,1),(1060,7566846,7566838,'ity',16.667,1),(1060,7566847,7566841,'pat',50,1),(1060,7566848,7566841,'ath',50,1),(1060,7566849,7566847,'thr',33.333,1),(1060,7566850,7566847,'hre',33.333,1),(1060,7566851,7566847,'ree',33.333,1),(1060,7566852,7566849,'fre',14.286,1),(1060,7566853,7566849,'ree',14.286,1),(1060,7566854,7566849,'ees',14.286,1),(1060,7566855,7566849,'esp',14.286,1),(1060,7566856,7566849,'spa',14.286,1),(1060,7566857,7566849,'pac',14.286,1),(1060,7566858,7566849,'ace',14.286,1),(1060,7566859,7566852,'dis',50,1),(1060,7566860,7566852,'isk',50,1),(1060,7566861,7566859,'ind',33.333,1),(1060,7566862,7566859,'nde',33.333,1),(1060,7566863,7566859,'dex',33.333,1),(1060,7566864,7566861,'adm',8.333,1),(1060,7566865,7566861,'dmi',8.333,1),(1060,7566866,7566861,'min',8.333,1),(1060,7566867,7566861,'ini',8.333,1),(1060,7566868,7566861,'nis',8.333,1),(1060,7566869,7566861,'ist',8.333,1),(1060,7566870,7566861,'str',8.333,1),(1060,7566871,7566861,'tra',8.333,1),(1060,7566872,7566861,'rat',8.333,1),(1060,7566873,7566861,'ati',8.333,1),(1060,7566874,7566861,'tio',8.333,1),(1060,7566875,7566861,'ion',8.333,1),(1060,7566876,7566864,'sta',33.333,3),(1060,7566877,7566864,'tat',33.333,3),(1060,7566878,7566864,'ate',33.333,3),(1060,7566879,7566876,'dis',16.667,4),(1060,7566880,7566876,'isa',16.667,4),(1060,7566881,7566876,'sab',16.667,4),(1060,7566882,7566876,'abl',16.667,4),(1060,7566883,7566876,'ble',16.667,4),(1060,7566884,7566876,'led',16.667,4),(1060,7566885,7566879,'cac',33.333,1),(1060,7566886,7566879,'ach',33.333,1),(1060,7566887,7566879,'che',33.333,1),(1060,7566888,7566885,'mod',50,1),(1060,7566889,7566885,'ode',50,1),(1060,7566890,7566888,'wri',14.286,1),(1060,7566891,7566888,'rit',14.286,1),(1060,7566892,7566888,'ite',14.286,1),(1060,7566893,7566888,'tet',14.286,1),(1060,7566894,7566888,'eth',14.286,1),(1060,7566895,7566888,'thr',14.286,1),(1060,7566896,7566888,'hru',14.286,1),(1060,7566897,7566890,'ope',11.111,2),(1060,7566898,7566890,'per',11.111,2),(1060,7566899,7566890,'era',11.111,2),(1060,7566900,7566890,'rat',11.111,2),(1060,7566901,7566890,'ati',11.111,2),(1060,7566902,7566890,'tio',11.111,2),(1060,7566903,7566890,'ion',11.111,2),(1060,7566904,7566890,'ona',11.111,2),(1060,7566905,7566890,'nal',11.111,2),(1060,7566906,7566897,'mes',20,1),(1060,7566907,7566897,'ess',20,1),(1060,7566908,7566897,'ssa',20,1),(1060,7566909,7566897,'sag',20,1),(1060,7566910,7566897,'age',20,1),(1060,7566911,7566906,'per',11.111,1),(1060,7566912,7566906,'erf',11.111,1),(1060,7566913,7566906,'rfo',11.111,1),(1060,7566914,7566906,'for',11.111,1),(1060,7566915,7566906,'orm',11.111,1),(1060,7566916,7566906,'rma',11.111,1),(1060,7566917,7566906,'man',11.111,1),(1060,7566918,7566906,'anc',11.111,1),(1060,7566919,7566906,'nce',11.111,1),(1060,7566920,7566911,'ide',12.5,1),(1060,7566921,7566911,'den',12.5,1),(1060,7566922,7566911,'ent',12.5,1),(1060,7566923,7566911,'nti',12.5,1),(1060,7566924,7566911,'tif',12.5,1),(1060,7566925,7566911,'ifi',12.5,1),(1060,7566926,7566911,'fie',12.5,1),(1060,7566927,7566911,'ier',12.5,1),(1060,7566928,7566920,'vdi',33.333,3),(1060,7566929,7566920,'dis',33.333,3),(1060,7566930,7566920,'isk',33.333,3),(1060,7566931,7566928,'nam',50,1),(1060,7566932,7566928,'ame',50,1),(1060,7566933,7566931,'typ',50,1),(1060,7566934,7566931,'ype',50,1),(1060,7566935,7566933,'dir',25,1),(1060,7566936,7566933,'ire',25,1),(1060,7566937,7566933,'rec',25,1),(1060,7566938,7566933,'ect',25,1),(1061,7566940,7566939,'naa',100,2),(1061,7566941,7566940,'600',3.333,3),(1061,7566942,7566940,'000',3.333,3),(1061,7566943,7566940,'00c',3.333,3),(1061,7566944,7566940,'0c2',3.333,3),(1061,7566945,7566940,'c29',3.333,3),(1061,7566946,7566940,'29c',3.333,3),(1061,7566947,7566940,'9c3',3.333,3),(1061,7566948,7566940,'c3b',3.333,3),(1061,7566949,7566940,'3bc',3.333,3),(1061,7566950,7566940,'bcd',3.333,3),(1061,7566951,7566940,'cd7',3.333,3),(1061,7566952,7566940,'d72',3.333,3),(1061,7566953,7566940,'720',3.333,3),(1061,7566954,7566940,'209',3.333,3),(1061,7566955,7566940,'09b',3.333,3),(1061,7566956,7566940,'9b7',3.333,3),(1061,7566957,7566940,'b70',3.333,3),(1061,7566958,7566940,'708',3.333,3),(1061,7566959,7566940,'088',3.333,3),(1061,7566960,7566940,'887',3.333,3),(1061,7566961,7566940,'87a',3.333,3),(1061,7566962,7566940,'7a7',3.333,3),(1061,7566963,7566940,'a77',3.333,3),(1061,7566964,7566940,'77e',3.333,3),(1061,7566965,7566940,'7e2',3.333,3),(1061,7566966,7566940,'e27',3.333,3),(1061,7566967,7566940,'277',3.333,3),(1061,7566968,7566940,'775',3.333,3),(1061,7566969,7566940,'75d',3.333,3),(1061,7566970,7566940,'5da',3.333,3),(1061,7566971,7566941,'mon',100,1),(1061,7566972,7566971,'201',50,1),(1061,7566973,7566971,'013',50,1),(1061,7566974,7566972,'adm',33.333,4),(1061,7566975,7566972,'dmi',33.333,4),(1061,7566976,7566972,'min',33.333,4),(1061,7566977,7566974,'cap',16.667,1),(1061,7566978,7566974,'apa',16.667,1),(1061,7566979,7566974,'pac',16.667,1),(1061,7566980,7566974,'aci',16.667,1),(1061,7566981,7566974,'cit',16.667,1),(1061,7566982,7566974,'ity',16.667,1),(1061,7566983,7566977,'pat',50,1),(1061,7566984,7566977,'ath',50,1),(1061,7566985,7566983,'two',100,1),(1061,7566986,7566985,'fre',14.286,1),(1061,7566987,7566985,'ree',14.286,1),(1061,7566988,7566985,'ees',14.286,1),(1061,7566989,7566985,'esp',14.286,1),(1061,7566990,7566985,'spa',14.286,1),(1061,7566991,7566985,'pac',14.286,1),(1061,7566992,7566985,'ace',14.286,1),(1061,7566993,7566986,'dis',50,1),(1061,7566994,7566986,'isk',50,1),(1061,7566995,7566993,'ind',33.333,1),(1061,7566996,7566993,'nde',33.333,1),(1061,7566997,7566993,'dex',33.333,1),(1061,7566998,7566995,'adm',8.333,1),(1061,7566999,7566995,'dmi',8.333,1),(1061,7567000,7566995,'min',8.333,1),(1061,7567001,7566995,'ini',8.333,1),(1061,7567002,7566995,'nis',8.333,1),(1061,7567003,7566995,'ist',8.333,1),(1061,7567004,7566995,'str',8.333,1),(1061,7567005,7566995,'tra',8.333,1),(1061,7567006,7566995,'rat',8.333,1),(1061,7567007,7566995,'ati',8.333,1),(1061,7567008,7566995,'tio',8.333,1),(1061,7567009,7566995,'ion',8.333,1),(1061,7567010,7566998,'sta',33.333,3),(1061,7567011,7566998,'tat',33.333,3),(1061,7567012,7566998,'ate',33.333,3),(1061,7567013,7567010,'dis',16.667,4),(1061,7567014,7567010,'isa',16.667,4),(1061,7567015,7567010,'sab',16.667,4),(1061,7567016,7567010,'abl',16.667,4),(1061,7567017,7567010,'ble',16.667,4),(1061,7567018,7567010,'led',16.667,4),(1061,7567019,7567013,'cac',33.333,1),(1061,7567020,7567013,'ach',33.333,1),(1061,7567021,7567013,'che',33.333,1),(1061,7567022,7567019,'mod',50,1),(1061,7567023,7567019,'ode',50,1),(1061,7567024,7567022,'wri',14.286,1),(1061,7567025,7567022,'rit',14.286,1),(1061,7567026,7567022,'ite',14.286,1),(1061,7567027,7567022,'tet',14.286,1),(1061,7567028,7567022,'eth',14.286,1),(1061,7567029,7567022,'thr',14.286,1),(1061,7567030,7567022,'hru',14.286,1),(1061,7567031,7567024,'ope',11.111,2),(1061,7567032,7567024,'per',11.111,2),(1061,7567033,7567024,'era',11.111,2),(1061,7567034,7567024,'rat',11.111,2),(1061,7567035,7567024,'ati',11.111,2),(1061,7567036,7567024,'tio',11.111,2),(1061,7567037,7567024,'ion',11.111,2),(1061,7567038,7567024,'ona',11.111,2),(1061,7567039,7567024,'nal',11.111,2),(1061,7567040,7567031,'mes',20,1),(1061,7567041,7567031,'ess',20,1),(1061,7567042,7567031,'ssa',20,1),(1061,7567043,7567031,'sag',20,1),(1061,7567044,7567031,'age',20,1),(1061,7567045,7567040,'per',11.111,1),(1061,7567046,7567040,'erf',11.111,1),(1061,7567047,7567040,'rfo',11.111,1),(1061,7567048,7567040,'for',11.111,1),(1061,7567049,7567040,'orm',11.111,1),(1061,7567050,7567040,'rma',11.111,1),(1061,7567051,7567040,'man',11.111,1),(1061,7567052,7567040,'anc',11.111,1),(1061,7567053,7567040,'nce',11.111,1),(1061,7567054,7567045,'ide',12.5,1),(1061,7567055,7567045,'den',12.5,1),(1061,7567056,7567045,'ent',12.5,1),(1061,7567057,7567045,'nti',12.5,1),(1061,7567058,7567045,'tif',12.5,1),(1061,7567059,7567045,'ifi',12.5,1),(1061,7567060,7567045,'fie',12.5,1),(1061,7567061,7567045,'ier',12.5,1),(1061,7567062,7567054,'vdi',33.333,3),(1061,7567063,7567054,'dis',33.333,3),(1061,7567064,7567054,'isk',33.333,3),(1061,7567065,7567062,'nam',50,1),(1061,7567066,7567062,'ame',50,1),(1061,7567067,7567065,'typ',50,1),(1061,7567068,7567065,'ype',50,1),(1061,7567069,7567067,'dir',25,1),(1061,7567070,7567067,'ire',25,1),(1061,7567071,7567067,'rec',25,1),(1061,7567072,7567067,'ect',25,1),(1062,7567074,7567073,'naa',100,2),(1062,7567075,7567074,'600',3.333,3),(1062,7567076,7567074,'000',3.333,3),(1062,7567077,7567074,'00c',3.333,3),(1062,7567078,7567074,'0c2',3.333,3),(1062,7567079,7567074,'c29',3.333,3),(1062,7567080,7567074,'29a',3.333,3),(1062,7567081,7567074,'9ad',3.333,3),(1062,7567082,7567074,'ad0',3.333,3),(1062,7567083,7567074,'d04',3.333,3),(1062,7567084,7567074,'047',3.333,3),(1062,7567085,7567074,'47c',3.333,3),(1062,7567086,7567074,'7cd',3.333,3),(1062,7567087,7567074,'cdc',3.333,3),(1062,7567088,7567074,'dc1',3.333,3),(1062,7567089,7567074,'c1a',3.333,3),(1062,7567090,7567074,'1a9',3.333,3),(1062,7567091,7567074,'a99',3.333,3),(1062,7567092,7567074,'996',3.333,3),(1062,7567093,7567074,'96b',3.333,3),(1062,7567094,7567074,'6bb',3.333,3),(1062,7567095,7567074,'bb7',3.333,3),(1062,7567096,7567074,'b74',3.333,3),(1062,7567097,7567074,'744',3.333,3),(1062,7567098,7567074,'44b',3.333,3),(1062,7567099,7567074,'4bb',3.333,3),(1062,7567100,7567074,'bb9',3.333,3),(1062,7567101,7567074,'b91',3.333,3),(1062,7567102,7567074,'911',3.333,3),(1062,7567103,7567074,'11e',3.333,3),(1062,7567104,7567074,'1ed',3.333,3),(1062,7567105,7567075,'mon',100,1),(1062,7567106,7567105,'201',50,1),(1062,7567107,7567105,'013',50,1),(1062,7567108,7567106,'adm',33.333,4),(1062,7567109,7567106,'dmi',33.333,4),(1062,7567110,7567106,'min',33.333,4),(1062,7567111,7567108,'cap',16.667,1),(1062,7567112,7567108,'apa',16.667,1),(1062,7567113,7567108,'pac',16.667,1),(1062,7567114,7567108,'aci',16.667,1),(1062,7567115,7567108,'cit',16.667,1),(1062,7567116,7567108,'ity',16.667,1),(1062,7567117,7567111,'pat',50,1),(1062,7567118,7567111,'ath',50,1),(1062,7567119,7567117,'twe',25,1),(1062,7567120,7567117,'wel',25,1),(1062,7567121,7567117,'elv',25,1),(1062,7567122,7567117,'lve',25,1),(1062,7567123,7567119,'fre',14.286,1),(1062,7567124,7567119,'ree',14.286,1),(1062,7567125,7567119,'ees',14.286,1),(1062,7567126,7567119,'esp',14.286,1),(1062,7567127,7567119,'spa',14.286,1),(1062,7567128,7567119,'pac',14.286,1),(1062,7567129,7567119,'ace',14.286,1),(1062,7567130,7567123,'dis',50,1),(1062,7567131,7567123,'isk',50,1),(1062,7567132,7567130,'ind',33.333,1),(1062,7567133,7567130,'nde',33.333,1),(1062,7567134,7567130,'dex',33.333,1),(1062,7567135,7567132,'adm',8.333,1),(1062,7567136,7567132,'dmi',8.333,1),(1062,7567137,7567132,'min',8.333,1),(1062,7567138,7567132,'ini',8.333,1),(1062,7567139,7567132,'nis',8.333,1),(1062,7567140,7567132,'ist',8.333,1),(1062,7567141,7567132,'str',8.333,1),(1062,7567142,7567132,'tra',8.333,1),(1062,7567143,7567132,'rat',8.333,1),(1062,7567144,7567132,'ati',8.333,1),(1062,7567145,7567132,'tio',8.333,1),(1062,7567146,7567132,'ion',8.333,1),(1062,7567147,7567135,'sta',33.333,3),(1062,7567148,7567135,'tat',33.333,3),(1062,7567149,7567135,'ate',33.333,3),(1062,7567150,7567147,'dis',16.667,4),(1062,7567151,7567147,'isa',16.667,4),(1062,7567152,7567147,'sab',16.667,4),(1062,7567153,7567147,'abl',16.667,4),(1062,7567154,7567147,'ble',16.667,4),(1062,7567155,7567147,'led',16.667,4),(1062,7567156,7567150,'cac',33.333,1),(1062,7567157,7567150,'ach',33.333,1),(1062,7567158,7567150,'che',33.333,1),(1062,7567159,7567156,'mod',50,1),(1062,7567160,7567156,'ode',50,1),(1062,7567161,7567159,'wri',14.286,1),(1062,7567162,7567159,'rit',14.286,1),(1062,7567163,7567159,'ite',14.286,1),(1062,7567164,7567159,'tet',14.286,1),(1062,7567165,7567159,'eth',14.286,1),(1062,7567166,7567159,'thr',14.286,1),(1062,7567167,7567159,'hru',14.286,1),(1062,7567168,7567161,'ope',11.111,2),(1062,7567169,7567161,'per',11.111,2),(1062,7567170,7567161,'era',11.111,2),(1062,7567171,7567161,'rat',11.111,2),(1062,7567172,7567161,'ati',11.111,2),(1062,7567173,7567161,'tio',11.111,2),(1062,7567174,7567161,'ion',11.111,2),(1062,7567175,7567161,'ona',11.111,2),(1062,7567176,7567161,'nal',11.111,2),(1062,7567177,7567168,'mes',20,1),(1062,7567178,7567168,'ess',20,1),(1062,7567179,7567168,'ssa',20,1),(1062,7567180,7567168,'sag',20,1),(1062,7567181,7567168,'age',20,1),(1062,7567182,7567177,'per',11.111,1),(1062,7567183,7567177,'erf',11.111,1),(1062,7567184,7567177,'rfo',11.111,1),(1062,7567185,7567177,'for',11.111,1),(1062,7567186,7567177,'orm',11.111,1),(1062,7567187,7567177,'rma',11.111,1),(1062,7567188,7567177,'man',11.111,1),(1062,7567189,7567177,'anc',11.111,1),(1062,7567190,7567177,'nce',11.111,1),(1062,7567191,7567182,'ide',12.5,1),(1062,7567192,7567182,'den',12.5,1),(1062,7567193,7567182,'ent',12.5,1),(1062,7567194,7567182,'nti',12.5,1),(1062,7567195,7567182,'tif',12.5,1),(1062,7567196,7567182,'ifi',12.5,1),(1062,7567197,7567182,'fie',12.5,1),(1062,7567198,7567182,'ier',12.5,1),(1062,7567199,7567191,'vdi',33.333,3),(1062,7567200,7567191,'dis',33.333,3),(1062,7567201,7567191,'isk',33.333,3),(1062,7567202,7567199,'nam',50,1),(1062,7567203,7567199,'ame',50,1),(1062,7567204,7567202,'typ',50,1),(1062,7567205,7567202,'ype',50,1),(1062,7567206,7567204,'dir',25,1),(1062,7567207,7567204,'ire',25,1),(1062,7567208,7567204,'rec',25,1),(1062,7567209,7567204,'ect',25,1),(1063,7567211,7567210,'att',12.5,1),(1063,7567212,7567210,'ttr',12.5,1),(1063,7567213,7567210,'tri',12.5,1),(1063,7567214,7567210,'rib',12.5,1),(1063,7567215,7567210,'ibu',12.5,1),(1063,7567216,7567210,'but',12.5,1),(1063,7567217,7567210,'ute',12.5,1),(1063,7567218,7567210,'tes',12.5,1),(1063,7567219,7567211,'ref',20,3),(1063,7567220,7567211,'efr',20,3),(1063,7567221,7567211,'fre',20,3),(1063,7567222,7567211,'res',20,3),(1063,7567223,7567211,'esh',20,3),(1063,7567224,7567219,'hos',50,2),(1063,7567225,7567219,'ost',50,2),(1063,7567226,7567224,'nam',50,2),(1063,7567227,7567224,'ame',50,2),(1063,7567228,7567226,'hg3',8.333,1),(1063,7567229,7567226,'g32',8.333,1),(1063,7567230,7567226,'32v',8.333,1),(1063,7567231,7567226,'2vm',8.333,1),(1063,7567232,7567226,'vm1',8.333,1),(1063,7567233,7567226,'m15',8.333,1),(1063,7567234,7567226,'15w',8.333,1),(1063,7567235,7567226,'5w2',8.333,1),(1063,7567236,7567226,'w2k',8.333,1),(1063,7567237,7567226,'2k8',8.333,1),(1063,7567238,7567226,'k8r',8.333,1),(1063,7567239,7567226,'8r2',8.333,1),(1063,7567240,7567228,'gdl',100,1),(1063,7567241,7567240,'eng',25,1),(1063,7567242,7567240,'ngl',25,1),(1063,7567243,7567240,'gla',25,1),(1063,7567244,7567240,'lab',25,1),(1063,7567245,7567241,'net',25,1),(1063,7567246,7567241,'eta',25,1),(1063,7567247,7567241,'tap',25,1),(1063,7567248,7567241,'app',25,1),(1063,7567249,7567245,'com',100,1),(1063,7567250,7567249,'mem',25,3),(1063,7567251,7567249,'emo',25,3),(1063,7567252,7567249,'mor',25,3),(1063,7567253,7567249,'ory',25,3),(1063,7567254,7567250,'siz',50,2),(1063,7567255,7567250,'ize',50,2),(1063,7567256,7567254,'614',50,1),(1063,7567257,7567254,'144',50,1),(1063,7567258,7567256,'cpu',100,1),(1063,7567259,7567258,'usa',33.333,3),(1063,7567260,7567258,'sag',33.333,3),(1063,7567261,7567258,'age',33.333,3),(1063,7567262,7567259,'mhz',100,1),(1063,7567263,7567262,'add',20,1),(1063,7567264,7567262,'ddr',20,1),(1063,7567265,7567262,'dre',20,1),(1063,7567266,7567262,'res',20,1),(1063,7567267,7567262,'ess',20,1),(1063,7567268,7567263,'226',100,1),(1063,7567269,7567268,'147',100,1),(1063,7567270,7567269,'217',100,1),(1063,7567271,7567270,'360',50,1),(1063,7567272,7567270,'604',50,1),(1063,7567273,7567271,'gue',33.333,2),(1063,7567274,7567271,'ues',33.333,2),(1063,7567275,7567271,'est',33.333,2),(1063,7567276,7567273,'vmw',25,2),(1063,7567277,7567273,'mwa',25,2),(1063,7567278,7567273,'war',25,2),(1063,7567279,7567273,'are',25,2),(1063,7567280,7567276,'too',33.333,2),(1063,7567281,7567276,'ool',33.333,2),(1063,7567282,7567276,'ols',33.333,2),(1063,7567283,7567280,'run',20,1),(1063,7567284,7567280,'unn',20,1),(1063,7567285,7567280,'nni',20,1),(1063,7567286,7567280,'nin',20,1),(1063,7567287,7567280,'ing',20,1),(1063,7567288,7567283,'and',100,1),(1063,7567289,7567288,'the',100,1),(1063,7567290,7567289,'ver',20,2),(1063,7567291,7567289,'ers',20,2),(1063,7567292,7567289,'rsi',20,2),(1063,7567293,7567289,'sio',20,2),(1063,7567294,7567289,'ion',20,2),(1063,7567295,7567290,'cur',20,1),(1063,7567296,7567290,'urr',20,1),(1063,7567297,7567290,'rre',20,1),(1063,7567298,7567290,'ren',20,1),(1063,7567299,7567290,'ent',20,1),(1063,7567300,7567295,'mic',14.286,1),(1063,7567301,7567295,'icr',14.286,1),(1063,7567302,7567295,'cro',14.286,1),(1063,7567303,7567295,'ros',14.286,1),(1063,7567304,7567295,'oso',14.286,1),(1063,7567305,7567295,'sof',14.286,1),(1063,7567306,7567295,'oft',14.286,1),(1063,7567307,7567300,'win',20,1),(1063,7567308,7567300,'ind',20,1),(1063,7567309,7567300,'ndo',20,1),(1063,7567310,7567300,'dow',20,1),(1063,7567311,7567300,'ows',20,1),(1063,7567312,7567307,'ser',25,1),(1063,7567313,7567307,'erv',25,1),(1063,7567314,7567307,'rve',25,1),(1063,7567315,7567307,'ver',25,1),(1063,7567316,7567312,'200',50,1),(1063,7567317,7567312,'008',50,1),(1063,7567318,7567316,'64b',33.333,1),(1063,7567319,7567316,'4bi',33.333,1),(1063,7567320,7567316,'bit',33.333,1),(1063,7567321,7567318,'pat',50,1),(1063,7567322,7567318,'ath',50,1),(1063,7567323,7567321,'rx6',33.333,1),(1063,7567324,7567321,'x60',33.333,1),(1063,7567325,7567321,'600',33.333,1),(1063,7567326,7567323,'vmf',20,1),(1063,7567327,7567323,'mfi',20,1),(1063,7567328,7567323,'fil',20,1),(1063,7567329,7567323,'ile',20,1),(1063,7567330,7567323,'les',20,1),(1063,7567331,7567326,'hgw',8.333,2),(1063,7567332,7567326,'gw2',8.333,2),(1063,7567333,7567326,'w2k',8.333,2),(1063,7567334,7567326,'2k8',8.333,2),(1063,7567335,7567326,'k8r',8.333,2),(1063,7567336,7567326,'8r2',8.333,2),(1063,7567337,7567326,'r23',8.333,2),(1063,7567338,7567326,'232',8.333,2),(1063,7567339,7567326,'32v',8.333,2),(1063,7567340,7567326,'2vm',8.333,2),(1063,7567341,7567326,'vm1',8.333,2),(1063,7567342,7567326,'m15',8.333,2),(1063,7567343,7567331,'vmx',100,1),(1063,7567344,7567343,'fla',33.333,1),(1063,7567345,7567343,'las',33.333,1),(1063,7567346,7567343,'ash',33.333,1),(1063,7567347,7567344,'acc',33.333,1),(1063,7567348,7567344,'cce',33.333,1),(1063,7567349,7567344,'cel',33.333,1),(1063,7567350,7567347,'con',9.091,1),(1063,7567351,7567347,'onf',9.091,1),(1063,7567352,7567347,'nfi',9.091,1),(1063,7567353,7567347,'fig',9.091,1),(1063,7567354,7567347,'igu',9.091,1),(1063,7567355,7567347,'gur',9.091,1),(1063,7567356,7567347,'ura',9.091,1),(1063,7567357,7567347,'rat',9.091,1),(1063,7567358,7567347,'ati',9.091,1),(1063,7567359,7567347,'tio',9.091,1),(1063,7567360,7567347,'ion',9.091,1),(1063,7567361,7567350,'age',33.333,1),(1063,7567362,7567350,'gen',33.333,1),(1063,7567363,7567350,'ent',33.333,1),(1063,7567364,7567361,'193',16.667,1),(1063,7567365,7567361,'938',16.667,1),(1063,7567366,7567361,'380',16.667,1),(1063,7567367,7567361,'809',16.667,1),(1063,7567368,7567361,'097',16.667,1),(1063,7567369,7567361,'979',16.667,1),(1063,7567370,7567364,'cac',33.333,3),(1063,7567371,7567364,'ach',33.333,3),(1063,7567372,7567364,'che',33.333,3),(1063,7567373,7567370,'sta',33.333,2),(1063,7567374,7567370,'tat',33.333,2),(1063,7567375,7567370,'ate',33.333,2),(1063,7567376,7567373,'dis',16.667,3),(1063,7567377,7567373,'isa',16.667,3),(1063,7567378,7567373,'sab',16.667,3),(1063,7567379,7567373,'abl',16.667,3),(1063,7567380,7567373,'ble',16.667,3),(1063,7567381,7567373,'led',16.667,3),(1063,7567382,7567376,'ope',11.111,2),(1063,7567383,7567376,'per',11.111,2),(1063,7567384,7567376,'era',11.111,2),(1063,7567385,7567376,'rat',11.111,2),(1063,7567386,7567376,'ati',11.111,2),(1063,7567387,7567376,'tio',11.111,2),(1063,7567388,7567376,'ion',11.111,2),(1063,7567389,7567376,'ona',11.111,2),(1063,7567390,7567376,'nal',11.111,2),(1063,7567391,7567382,'mod',50,1),(1063,7567392,7567382,'ode',50,1),(1063,7567393,7567391,'wri',14.286,1),(1063,7567394,7567391,'rit',14.286,1),(1063,7567395,7567391,'ite',14.286,1),(1063,7567396,7567391,'tet',14.286,1),(1063,7567397,7567391,'eth',14.286,1),(1063,7567398,7567391,'thr',14.286,1),(1063,7567399,7567391,'hru',14.286,1),(1063,7567400,7567393,'mes',20,1),(1063,7567401,7567393,'ess',20,1),(1063,7567402,7567393,'ssa',20,1),(1063,7567403,7567393,'sag',20,1),(1063,7567404,7567393,'age',20,1),(1063,7567405,7567400,'adm',33.333,1),(1063,7567406,7567400,'dmi',33.333,1),(1063,7567407,7567400,'min',33.333,1),(1063,7567408,7567405,'met',20,3),(1063,7567409,7567405,'etr',20,3),(1063,7567410,7567405,'tri',20,3),(1063,7567411,7567405,'ric',20,3),(1063,7567412,7567405,'ics',20,3),(1063,7567413,7567408,'ena',20,1),(1063,7567414,7567408,'nab',20,1),(1063,7567415,7567408,'abl',20,1),(1063,7567416,7567408,'ble',20,1),(1063,7567417,7567408,'led',20,1),(1063,7567418,7567413,'vir',20,1),(1063,7567419,7567413,'irt',20,1),(1063,7567420,7567413,'rtu',20,1),(1063,7567421,7567413,'tua',20,1),(1063,7567422,7567413,'ual',20,1),(1063,7567423,7567418,'dis',50,1),(1063,7567424,7567418,'isk',50,1),(1064,7567426,7567425,'naa',100,2),(1064,7567427,7567426,'600',3.333,3),(1064,7567428,7567426,'000',3.333,3),(1064,7567429,7567426,'00c',3.333,3),(1064,7567430,7567426,'0c2',3.333,3),(1064,7567431,7567426,'c29',3.333,3),(1064,7567432,7567426,'29c',3.333,3),(1064,7567433,7567426,'9c8',3.333,3),(1064,7567434,7567426,'c80',3.333,3),(1064,7567435,7567426,'80e',3.333,3),(1064,7567436,7567426,'0ee',3.333,3),(1064,7567437,7567426,'ee2',3.333,3),(1064,7567438,7567426,'e21',3.333,3),(1064,7567439,7567426,'215',3.333,3),(1064,7567440,7567426,'152',3.333,3),(1064,7567441,7567426,'524',3.333,3),(1064,7567442,7567426,'240',3.333,3),(1064,7567443,7567426,'402',3.333,3),(1064,7567444,7567426,'020',3.333,3),(1064,7567445,7567426,'209',3.333,3),(1064,7567446,7567426,'095',3.333,3),(1064,7567447,7567426,'95a',3.333,3),(1064,7567448,7567426,'5ab',3.333,3),(1064,7567449,7567426,'ab6',3.333,3),(1064,7567450,7567426,'b67',3.333,3),(1064,7567451,7567426,'67c',3.333,3),(1064,7567452,7567426,'7cf',3.333,3),(1064,7567453,7567426,'cf5',3.333,3),(1064,7567454,7567426,'f5f',3.333,3),(1064,7567455,7567426,'5f2',3.333,3),(1064,7567456,7567426,'f2f',3.333,3),(1064,7567457,7567427,'mon',100,1),(1064,7567458,7567457,'201',50,1),(1064,7567459,7567457,'013',50,1),(1064,7567460,7567458,'adm',33.333,4),(1064,7567461,7567458,'dmi',33.333,4),(1064,7567462,7567458,'min',33.333,4),(1064,7567463,7567460,'cap',16.667,1),(1064,7567464,7567460,'apa',16.667,1),(1064,7567465,7567460,'pac',16.667,1),(1064,7567466,7567460,'aci',16.667,1),(1064,7567467,7567460,'cit',16.667,1),(1064,7567468,7567460,'ity',16.667,1),(1064,7567469,7567463,'pat',50,1),(1064,7567470,7567463,'ath',50,1),(1064,7567471,7567469,'vol',25,1),(1064,7567472,7567469,'olu',25,1),(1064,7567473,7567469,'lum',25,1),(1064,7567474,7567469,'ume',25,1),(1064,7567475,7567471,'78e',3.333,1),(1064,7567476,7567471,'8e3',3.333,1),(1064,7567477,7567471,'e3f',3.333,1),(1064,7567478,7567471,'3f1',3.333,1),(1064,7567479,7567471,'f18',3.333,1),(1064,7567480,7567471,'188',3.333,1),(1064,7567481,7567471,'886',3.333,1),(1064,7567482,7567471,'86d',3.333,1),(1064,7567483,7567471,'6d8',3.333,1),(1064,7567484,7567471,'d87',3.333,1),(1064,7567485,7567471,'871',3.333,1),(1064,7567486,7567471,'711',3.333,1),(1064,7567487,7567471,'11e',3.333,1),(1064,7567488,7567471,'1e1',3.333,1),(1064,7567489,7567471,'e19',3.333,1),(1064,7567490,7567471,'192',3.333,1),(1064,7567491,7567471,'927',3.333,1),(1064,7567492,7567471,'277',3.333,1),(1064,7567493,7567471,'778',3.333,1),(1064,7567494,7567471,'780',3.333,1),(1064,7567495,7567471,'806',3.333,1),(1064,7567496,7567471,'06e',3.333,1),(1064,7567497,7567471,'6e6',3.333,1),(1064,7567498,7567471,'e6f',3.333,1),(1064,7567499,7567471,'6f6',3.333,1),(1064,7567500,7567471,'f6e',3.333,1),(1064,7567501,7567471,'6e6',3.333,1),(1064,7567502,7567471,'e69',3.333,1),(1064,7567503,7567471,'696',3.333,1),(1064,7567504,7567471,'963',3.333,1),(1064,7567505,7567475,'fre',14.286,1),(1064,7567506,7567475,'ree',14.286,1),(1064,7567507,7567475,'ees',14.286,1),(1064,7567508,7567475,'esp',14.286,1),(1064,7567509,7567475,'spa',14.286,1),(1064,7567510,7567475,'pac',14.286,1),(1064,7567511,7567475,'ace',14.286,1),(1064,7567512,7567505,'dis',50,1),(1064,7567513,7567505,'isk',50,1),(1064,7567514,7567512,'ind',33.333,1),(1064,7567515,7567512,'nde',33.333,1),(1064,7567516,7567512,'dex',33.333,1),(1064,7567517,7567514,'adm',8.333,1),(1064,7567518,7567514,'dmi',8.333,1),(1064,7567519,7567514,'min',8.333,1),(1064,7567520,7567514,'ini',8.333,1),(1064,7567521,7567514,'nis',8.333,1),(1064,7567522,7567514,'ist',8.333,1),(1064,7567523,7567514,'str',8.333,1),(1064,7567524,7567514,'tra',8.333,1),(1064,7567525,7567514,'rat',8.333,1),(1064,7567526,7567514,'ati',8.333,1),(1064,7567527,7567514,'tio',8.333,1),(1064,7567528,7567514,'ion',8.333,1),(1064,7567529,7567517,'sta',33.333,3),(1064,7567530,7567517,'tat',33.333,3),(1064,7567531,7567517,'ate',33.333,3),(1064,7567532,7567529,'dis',16.667,4),(1064,7567533,7567529,'isa',16.667,4),(1064,7567534,7567529,'sab',16.667,4),(1064,7567535,7567529,'abl',16.667,4),(1064,7567536,7567529,'ble',16.667,4),(1064,7567537,7567529,'led',16.667,4),(1064,7567538,7567532,'cac',33.333,1),(1064,7567539,7567532,'ach',33.333,1),(1064,7567540,7567532,'che',33.333,1),(1064,7567541,7567538,'mod',50,1),(1064,7567542,7567538,'ode',50,1),(1064,7567543,7567541,'wri',14.286,1),(1064,7567544,7567541,'rit',14.286,1),(1064,7567545,7567541,'ite',14.286,1),(1064,7567546,7567541,'tet',14.286,1),(1064,7567547,7567541,'eth',14.286,1),(1064,7567548,7567541,'thr',14.286,1),(1064,7567549,7567541,'hru',14.286,1),(1064,7567550,7567543,'ope',11.111,2),(1064,7567551,7567543,'per',11.111,2),(1064,7567552,7567543,'era',11.111,2),(1064,7567553,7567543,'rat',11.111,2),(1064,7567554,7567543,'ati',11.111,2),(1064,7567555,7567543,'tio',11.111,2),(1064,7567556,7567543,'ion',11.111,2),(1064,7567557,7567543,'ona',11.111,2),(1064,7567558,7567543,'nal',11.111,2),(1064,7567559,7567550,'mes',20,1),(1064,7567560,7567550,'ess',20,1),(1064,7567561,7567550,'ssa',20,1),(1064,7567562,7567550,'sag',20,1),(1064,7567563,7567550,'age',20,1),(1064,7567564,7567559,'per',11.111,1),(1064,7567565,7567559,'erf',11.111,1),(1064,7567566,7567559,'rfo',11.111,1),(1064,7567567,7567559,'for',11.111,1),(1064,7567568,7567559,'orm',11.111,1),(1064,7567569,7567559,'rma',11.111,1),(1064,7567570,7567559,'man',11.111,1),(1064,7567571,7567559,'anc',11.111,1),(1064,7567572,7567559,'nce',11.111,1),(1064,7567573,7567564,'ide',12.5,1),(1064,7567574,7567564,'den',12.5,1),(1064,7567575,7567564,'ent',12.5,1),(1064,7567576,7567564,'nti',12.5,1),(1064,7567577,7567564,'tif',12.5,1),(1064,7567578,7567564,'ifi',12.5,1),(1064,7567579,7567564,'fie',12.5,1),(1064,7567580,7567564,'ier',12.5,1),(1064,7567581,7567573,'vdi',33.333,3),(1064,7567582,7567573,'dis',33.333,3),(1064,7567583,7567573,'isk',33.333,3),(1064,7567584,7567581,'nam',50,1),(1064,7567585,7567581,'ame',50,1),(1064,7567586,7567584,'typ',50,1),(1064,7567587,7567584,'ype',50,1),(1064,7567588,7567586,'dir',25,1),(1064,7567589,7567586,'ire',25,1),(1064,7567590,7567586,'rec',25,1),(1064,7567591,7567586,'ect',25,1),(1065,7567593,7567592,'naa',100,2),(1065,7567594,7567593,'600',3.333,3),(1065,7567595,7567593,'00a',3.333,3),(1065,7567596,7567593,'0a0',3.333,3),(1065,7567597,7567593,'a09',3.333,3),(1065,7567598,7567593,'098',3.333,3),(1065,7567599,7567593,'980',3.333,3),(1065,7567600,7567593,'804',3.333,3),(1065,7567601,7567593,'044',3.333,3),(1065,7567602,7567593,'443',3.333,3),(1065,7567603,7567593,'430',3.333,3),(1065,7567604,7567593,'307',3.333,3),(1065,7567605,7567593,'072',3.333,3),(1065,7567606,7567593,'725',3.333,3),(1065,7567607,7567593,'259',3.333,3),(1065,7567608,7567593,'593',3.333,3),(1065,7567609,7567593,'931',3.333,3),(1065,7567610,7567593,'313',3.333,3),(1065,7567611,7567593,'13f',3.333,3),(1065,7567612,7567593,'3f3',3.333,3),(1065,7567613,7567593,'f33',3.333,3),(1065,7567614,7567593,'334',3.333,3),(1065,7567615,7567593,'345',3.333,3),(1065,7567616,7567593,'455',3.333,3),(1065,7567617,7567593,'556',3.333,3),(1065,7567618,7567593,'563',3.333,3),(1065,7567619,7567593,'639',3.333,3),(1065,7567620,7567593,'393',3.333,3),(1065,7567621,7567593,'934',3.333,3),(1065,7567622,7567593,'345',3.333,3),(1065,7567623,7567593,'457',3.333,3),(1065,7567624,7567594,'mon',100,1),(1065,7567625,7567624,'201',50,1),(1065,7567626,7567624,'013',50,1),(1065,7567627,7567625,'adm',33.333,4),(1065,7567628,7567625,'dmi',33.333,4),(1065,7567629,7567625,'min',33.333,4),(1065,7567630,7567627,'cap',16.667,1),(1065,7567631,7567627,'apa',16.667,1),(1065,7567632,7567627,'pac',16.667,1),(1065,7567633,7567627,'aci',16.667,1),(1065,7567634,7567627,'cit',16.667,1),(1065,7567635,7567627,'ity',16.667,1),(1065,7567636,7567630,'pat',50,1),(1065,7567637,7567630,'ath',50,1),(1065,7567638,7567636,'fre',14.286,1),(1065,7567639,7567636,'ree',14.286,1),(1065,7567640,7567636,'ees',14.286,1),(1065,7567641,7567636,'esp',14.286,1),(1065,7567642,7567636,'spa',14.286,1),(1065,7567643,7567636,'pac',14.286,1),(1065,7567644,7567636,'ace',14.286,1),(1065,7567645,7567638,'dis',50,1),(1065,7567646,7567638,'isk',50,1),(1065,7567647,7567645,'ind',33.333,1),(1065,7567648,7567645,'nde',33.333,1),(1065,7567649,7567645,'dex',33.333,1),(1065,7567650,7567647,'adm',8.333,1),(1065,7567651,7567647,'dmi',8.333,1),(1065,7567652,7567647,'min',8.333,1),(1065,7567653,7567647,'ini',8.333,1),(1065,7567654,7567647,'nis',8.333,1),(1065,7567655,7567647,'ist',8.333,1),(1065,7567656,7567647,'str',8.333,1),(1065,7567657,7567647,'tra',8.333,1),(1065,7567658,7567647,'rat',8.333,1),(1065,7567659,7567647,'ati',8.333,1),(1065,7567660,7567647,'tio',8.333,1),(1065,7567661,7567647,'ion',8.333,1),(1065,7567662,7567650,'sta',33.333,3),(1065,7567663,7567650,'tat',33.333,3),(1065,7567664,7567650,'ate',33.333,3),(1065,7567665,7567662,'dis',16.667,4),(1065,7567666,7567662,'isa',16.667,4),(1065,7567667,7567662,'sab',16.667,4),(1065,7567668,7567662,'abl',16.667,4),(1065,7567669,7567662,'ble',16.667,4),(1065,7567670,7567662,'led',16.667,4),(1065,7567671,7567665,'cac',33.333,1),(1065,7567672,7567665,'ach',33.333,1),(1065,7567673,7567665,'che',33.333,1),(1065,7567674,7567671,'mod',50,1),(1065,7567675,7567671,'ode',50,1),(1065,7567676,7567674,'wri',14.286,1),(1065,7567677,7567674,'rit',14.286,1),(1065,7567678,7567674,'ite',14.286,1),(1065,7567679,7567674,'tet',14.286,1),(1065,7567680,7567674,'eth',14.286,1),(1065,7567681,7567674,'thr',14.286,1),(1065,7567682,7567674,'hru',14.286,1),(1065,7567683,7567676,'ope',11.111,2),(1065,7567684,7567676,'per',11.111,2),(1065,7567685,7567676,'era',11.111,2),(1065,7567686,7567676,'rat',11.111,2),(1065,7567687,7567676,'ati',11.111,2),(1065,7567688,7567676,'tio',11.111,2),(1065,7567689,7567676,'ion',11.111,2),(1065,7567690,7567676,'ona',11.111,2),(1065,7567691,7567676,'nal',11.111,2),(1065,7567692,7567683,'mes',20,1),(1065,7567693,7567683,'ess',20,1),(1065,7567694,7567683,'ssa',20,1),(1065,7567695,7567683,'sag',20,1),(1065,7567696,7567683,'age',20,1),(1065,7567697,7567692,'per',11.111,1),(1065,7567698,7567692,'erf',11.111,1),(1065,7567699,7567692,'rfo',11.111,1),(1065,7567700,7567692,'for',11.111,1),(1065,7567701,7567692,'orm',11.111,1),(1065,7567702,7567692,'rma',11.111,1),(1065,7567703,7567692,'man',11.111,1),(1065,7567704,7567692,'anc',11.111,1),(1065,7567705,7567692,'nce',11.111,1),(1065,7567706,7567697,'ide',12.5,1),(1065,7567707,7567697,'den',12.5,1),(1065,7567708,7567697,'ent',12.5,1),(1065,7567709,7567697,'nti',12.5,1),(1065,7567710,7567697,'tif',12.5,1),(1065,7567711,7567697,'ifi',12.5,1),(1065,7567712,7567697,'fie',12.5,1),(1065,7567713,7567697,'ier',12.5,1),(1065,7567714,7567706,'vdi',33.333,3),(1065,7567715,7567706,'dis',33.333,3),(1065,7567716,7567706,'isk',33.333,3),(1065,7567717,7567714,'nam',50,1),(1065,7567718,7567714,'ame',50,1),(1065,7567719,7567717,'typ',50,1),(1065,7567720,7567717,'ype',50,1),(1065,7567721,7567719,'dir',25,1),(1065,7567722,7567719,'ire',25,1),(1065,7567723,7567719,'rec',25,1),(1065,7567724,7567719,'ect',25,1),(1066,7567726,7567725,'naa',100,2),(1066,7567727,7567726,'600',3.333,3),(1066,7567728,7567726,'00a',3.333,3),(1066,7567729,7567726,'0a0',3.333,3),(1066,7567730,7567726,'a09',3.333,3),(1066,7567731,7567726,'098',3.333,3),(1066,7567732,7567726,'980',3.333,3),(1066,7567733,7567726,'804',3.333,3),(1066,7567734,7567726,'044',3.333,3),(1066,7567735,7567726,'443',3.333,3),(1066,7567736,7567726,'430',3.333,3),(1066,7567737,7567726,'307',3.333,3),(1066,7567738,7567726,'072',3.333,3),(1066,7567739,7567726,'725',3.333,3),(1066,7567740,7567726,'259',3.333,3),(1066,7567741,7567726,'593',3.333,3),(1066,7567742,7567726,'931',3.333,3),(1066,7567743,7567726,'313',3.333,3),(1066,7567744,7567726,'13f',3.333,3),(1066,7567745,7567726,'3f3',3.333,3),(1066,7567746,7567726,'f33',3.333,3),(1066,7567747,7567726,'334',3.333,3),(1066,7567748,7567726,'345',3.333,3),(1066,7567749,7567726,'455',3.333,3),(1066,7567750,7567726,'556',3.333,3),(1066,7567751,7567726,'563',3.333,3),(1066,7567752,7567726,'639',3.333,3),(1066,7567753,7567726,'393',3.333,3),(1066,7567754,7567726,'934',3.333,3),(1066,7567755,7567726,'345',3.333,3),(1066,7567756,7567726,'458',3.333,3),(1066,7567757,7567727,'mon',100,1),(1066,7567758,7567757,'201',50,1),(1066,7567759,7567757,'013',50,1),(1066,7567760,7567758,'adm',33.333,4),(1066,7567761,7567758,'dmi',33.333,4),(1066,7567762,7567758,'min',33.333,4),(1066,7567763,7567760,'cap',16.667,1),(1066,7567764,7567760,'apa',16.667,1),(1066,7567765,7567760,'pac',16.667,1),(1066,7567766,7567760,'aci',16.667,1),(1066,7567767,7567760,'cit',16.667,1),(1066,7567768,7567760,'ity',16.667,1),(1066,7567769,7567763,'pat',50,1),(1066,7567770,7567763,'ath',50,1),(1066,7567771,7567769,'fre',14.286,1),(1066,7567772,7567769,'ree',14.286,1),(1066,7567773,7567769,'ees',14.286,1),(1066,7567774,7567769,'esp',14.286,1),(1066,7567775,7567769,'spa',14.286,1),(1066,7567776,7567769,'pac',14.286,1),(1066,7567777,7567769,'ace',14.286,1),(1066,7567778,7567771,'dis',50,1),(1066,7567779,7567771,'isk',50,1),(1066,7567780,7567778,'ind',33.333,1),(1066,7567781,7567778,'nde',33.333,1),(1066,7567782,7567778,'dex',33.333,1),(1066,7567783,7567780,'adm',8.333,1),(1066,7567784,7567780,'dmi',8.333,1),(1066,7567785,7567780,'min',8.333,1),(1066,7567786,7567780,'ini',8.333,1),(1066,7567787,7567780,'nis',8.333,1),(1066,7567788,7567780,'ist',8.333,1),(1066,7567789,7567780,'str',8.333,1),(1066,7567790,7567780,'tra',8.333,1),(1066,7567791,7567780,'rat',8.333,1),(1066,7567792,7567780,'ati',8.333,1),(1066,7567793,7567780,'tio',8.333,1),(1066,7567794,7567780,'ion',8.333,1),(1066,7567795,7567783,'sta',33.333,3),(1066,7567796,7567783,'tat',33.333,3),(1066,7567797,7567783,'ate',33.333,3),(1066,7567798,7567795,'dis',16.667,4),(1066,7567799,7567795,'isa',16.667,4),(1066,7567800,7567795,'sab',16.667,4),(1066,7567801,7567795,'abl',16.667,4),(1066,7567802,7567795,'ble',16.667,4),(1066,7567803,7567795,'led',16.667,4),(1066,7567804,7567798,'cac',33.333,1),(1066,7567805,7567798,'ach',33.333,1),(1066,7567806,7567798,'che',33.333,1),(1066,7567807,7567804,'mod',50,1),(1066,7567808,7567804,'ode',50,1),(1066,7567809,7567807,'wri',14.286,1),(1066,7567810,7567807,'rit',14.286,1),(1066,7567811,7567807,'ite',14.286,1),(1066,7567812,7567807,'tet',14.286,1),(1066,7567813,7567807,'eth',14.286,1),(1066,7567814,7567807,'thr',14.286,1),(1066,7567815,7567807,'hru',14.286,1),(1066,7567816,7567809,'ope',11.111,2),(1066,7567817,7567809,'per',11.111,2),(1066,7567818,7567809,'era',11.111,2),(1066,7567819,7567809,'rat',11.111,2),(1066,7567820,7567809,'ati',11.111,2),(1066,7567821,7567809,'tio',11.111,2),(1066,7567822,7567809,'ion',11.111,2),(1066,7567823,7567809,'ona',11.111,2),(1066,7567824,7567809,'nal',11.111,2),(1066,7567825,7567816,'mes',20,1),(1066,7567826,7567816,'ess',20,1),(1066,7567827,7567816,'ssa',20,1),(1066,7567828,7567816,'sag',20,1),(1066,7567829,7567816,'age',20,1),(1066,7567830,7567825,'per',11.111,1),(1066,7567831,7567825,'erf',11.111,1),(1066,7567832,7567825,'rfo',11.111,1),(1066,7567833,7567825,'for',11.111,1),(1066,7567834,7567825,'orm',11.111,1),(1066,7567835,7567825,'rma',11.111,1),(1066,7567836,7567825,'man',11.111,1),(1066,7567837,7567825,'anc',11.111,1),(1066,7567838,7567825,'nce',11.111,1),(1066,7567839,7567830,'ide',12.5,1),(1066,7567840,7567830,'den',12.5,1),(1066,7567841,7567830,'ent',12.5,1),(1066,7567842,7567830,'nti',12.5,1),(1066,7567843,7567830,'tif',12.5,1),(1066,7567844,7567830,'ifi',12.5,1),(1066,7567845,7567830,'fie',12.5,1),(1066,7567846,7567830,'ier',12.5,1),(1066,7567847,7567839,'vdi',33.333,3),(1066,7567848,7567839,'dis',33.333,3),(1066,7567849,7567839,'isk',33.333,3),(1066,7567850,7567847,'nam',50,1),(1066,7567851,7567847,'ame',50,1),(1066,7567852,7567850,'typ',50,1),(1066,7567853,7567850,'ype',50,1),(1066,7567854,7567852,'dir',25,1),(1066,7567855,7567852,'ire',25,1),(1066,7567856,7567852,'rec',25,1),(1066,7567857,7567852,'ect',25,1),(1067,7567859,7567858,'naa',100,2),(1067,7567860,7567859,'600',3.333,3),(1067,7567861,7567859,'00a',3.333,3),(1067,7567862,7567859,'0a0',3.333,3),(1067,7567863,7567859,'a09',3.333,3),(1067,7567864,7567859,'098',3.333,3),(1067,7567865,7567859,'980',3.333,3),(1067,7567866,7567859,'804',3.333,3),(1067,7567867,7567859,'044',3.333,3),(1067,7567868,7567859,'443',3.333,3),(1067,7567869,7567859,'430',3.333,3),(1067,7567870,7567859,'307',3.333,3),(1067,7567871,7567859,'075',3.333,3),(1067,7567872,7567859,'753',3.333,3),(1067,7567873,7567859,'535',3.333,3),(1067,7567874,7567859,'357',3.333,3),(1067,7567875,7567859,'573',3.333,3),(1067,7567876,7567859,'732',3.333,3),(1067,7567877,7567859,'32b',3.333,3),(1067,7567878,7567859,'2b3',3.333,3),(1067,7567879,7567859,'b33',3.333,3),(1067,7567880,7567859,'334',3.333,3),(1067,7567881,7567859,'345',3.333,3),(1067,7567882,7567859,'457',3.333,3),(1067,7567883,7567859,'571',3.333,3),(1067,7567884,7567859,'715',3.333,3),(1067,7567885,7567859,'153',3.333,3),(1067,7567886,7567859,'533',3.333,3),(1067,7567887,7567859,'336',3.333,3),(1067,7567888,7567859,'364',3.333,3),(1067,7567889,7567859,'648',3.333,3),(1067,7567890,7567860,'mon',100,1),(1067,7567891,7567890,'201',50,1),(1067,7567892,7567890,'013',50,1),(1067,7567893,7567891,'adm',33.333,4),(1067,7567894,7567891,'dmi',33.333,4),(1067,7567895,7567891,'min',33.333,4),(1067,7567896,7567893,'cap',16.667,1),(1067,7567897,7567893,'apa',16.667,1),(1067,7567898,7567893,'pac',16.667,1),(1067,7567899,7567893,'aci',16.667,1),(1067,7567900,7567893,'cit',16.667,1),(1067,7567901,7567893,'ity',16.667,1),(1067,7567902,7567896,'pat',50,1),(1067,7567903,7567896,'ath',50,1),(1067,7567904,7567902,'fre',14.286,1),(1067,7567905,7567902,'ree',14.286,1),(1067,7567906,7567902,'ees',14.286,1),(1067,7567907,7567902,'esp',14.286,1),(1067,7567908,7567902,'spa',14.286,1),(1067,7567909,7567902,'pac',14.286,1),(1067,7567910,7567902,'ace',14.286,1),(1067,7567911,7567904,'dis',50,1),(1067,7567912,7567904,'isk',50,1),(1067,7567913,7567911,'ind',33.333,1),(1067,7567914,7567911,'nde',33.333,1),(1067,7567915,7567911,'dex',33.333,1),(1067,7567916,7567913,'adm',8.333,1),(1067,7567917,7567913,'dmi',8.333,1),(1067,7567918,7567913,'min',8.333,1),(1067,7567919,7567913,'ini',8.333,1),(1067,7567920,7567913,'nis',8.333,1),(1067,7567921,7567913,'ist',8.333,1),(1067,7567922,7567913,'str',8.333,1),(1067,7567923,7567913,'tra',8.333,1),(1067,7567924,7567913,'rat',8.333,1),(1067,7567925,7567913,'ati',8.333,1),(1067,7567926,7567913,'tio',8.333,1),(1067,7567927,7567913,'ion',8.333,1),(1067,7567928,7567916,'sta',33.333,3),(1067,7567929,7567916,'tat',33.333,3),(1067,7567930,7567916,'ate',33.333,3),(1067,7567931,7567928,'dis',16.667,4),(1067,7567932,7567928,'isa',16.667,4),(1067,7567933,7567928,'sab',16.667,4),(1067,7567934,7567928,'abl',16.667,4),(1067,7567935,7567928,'ble',16.667,4),(1067,7567936,7567928,'led',16.667,4),(1067,7567937,7567931,'cac',33.333,1),(1067,7567938,7567931,'ach',33.333,1),(1067,7567939,7567931,'che',33.333,1),(1067,7567940,7567937,'mod',50,1),(1067,7567941,7567937,'ode',50,1),(1067,7567942,7567940,'wri',14.286,1),(1067,7567943,7567940,'rit',14.286,1),(1067,7567944,7567940,'ite',14.286,1),(1067,7567945,7567940,'tet',14.286,1),(1067,7567946,7567940,'eth',14.286,1),(1067,7567947,7567940,'thr',14.286,1),(1067,7567948,7567940,'hru',14.286,1),(1067,7567949,7567942,'ope',11.111,2),(1067,7567950,7567942,'per',11.111,2),(1067,7567951,7567942,'era',11.111,2),(1067,7567952,7567942,'rat',11.111,2),(1067,7567953,7567942,'ati',11.111,2),(1067,7567954,7567942,'tio',11.111,2),(1067,7567955,7567942,'ion',11.111,2),(1067,7567956,7567942,'ona',11.111,2),(1067,7567957,7567942,'nal',11.111,2),(1067,7567958,7567949,'mes',20,1),(1067,7567959,7567949,'ess',20,1),(1067,7567960,7567949,'ssa',20,1),(1067,7567961,7567949,'sag',20,1),(1067,7567962,7567949,'age',20,1),(1067,7567963,7567958,'per',11.111,1),(1067,7567964,7567958,'erf',11.111,1),(1067,7567965,7567958,'rfo',11.111,1),(1067,7567966,7567958,'for',11.111,1),(1067,7567967,7567958,'orm',11.111,1),(1067,7567968,7567958,'rma',11.111,1),(1067,7567969,7567958,'man',11.111,1),(1067,7567970,7567958,'anc',11.111,1),(1067,7567971,7567958,'nce',11.111,1),(1067,7567972,7567963,'ide',12.5,1),(1067,7567973,7567963,'den',12.5,1),(1067,7567974,7567963,'ent',12.5,1),(1067,7567975,7567963,'nti',12.5,1),(1067,7567976,7567963,'tif',12.5,1),(1067,7567977,7567963,'ifi',12.5,1),(1067,7567978,7567963,'fie',12.5,1),(1067,7567979,7567963,'ier',12.5,1),(1067,7567980,7567972,'vdi',33.333,3),(1067,7567981,7567972,'dis',33.333,3),(1067,7567982,7567972,'isk',33.333,3),(1067,7567983,7567980,'nam',50,1),(1067,7567984,7567980,'ame',50,1),(1067,7567985,7567983,'typ',50,1),(1067,7567986,7567983,'ype',50,1),(1067,7567987,7567985,'dir',25,1),(1067,7567988,7567985,'ire',25,1),(1067,7567989,7567985,'rec',25,1),(1067,7567990,7567985,'ect',25,1),(1068,7567992,7567991,'naa',100,2),(1068,7567993,7567992,'600',3.333,3),(1068,7567994,7567992,'00a',3.333,3),(1068,7567995,7567992,'0a0',3.333,3),(1068,7567996,7567992,'a09',3.333,3),(1068,7567997,7567992,'098',3.333,3),(1068,7567998,7567992,'980',3.333,3),(1068,7567999,7567992,'804',3.333,3),(1068,7568000,7567992,'044',3.333,3),(1068,7568001,7567992,'443',3.333,3),(1068,7568002,7567992,'430',3.333,3),(1068,7568003,7567992,'307',3.333,3),(1068,7568004,7567992,'075',3.333,3),(1068,7568005,7567992,'753',3.333,3),(1068,7568006,7567992,'535',3.333,3),(1068,7568007,7567992,'357',3.333,3),(1068,7568008,7567992,'573',3.333,3),(1068,7568009,7567992,'732',3.333,3),(1068,7568010,7567992,'32b',3.333,3),(1068,7568011,7567992,'2b3',3.333,3),(1068,7568012,7567992,'b33',3.333,3),(1068,7568013,7567992,'334',3.333,3),(1068,7568014,7567992,'345',3.333,3),(1068,7568015,7567992,'457',3.333,3),(1068,7568016,7567992,'571',3.333,3),(1068,7568017,7567992,'715',3.333,3),(1068,7568018,7567992,'153',3.333,3),(1068,7568019,7567992,'533',3.333,3),(1068,7568020,7567992,'336',3.333,3),(1068,7568021,7567992,'364',3.333,3),(1068,7568022,7567992,'649',3.333,3),(1068,7568023,7567993,'mon',100,1),(1068,7568024,7568023,'201',50,1),(1068,7568025,7568023,'013',50,1),(1068,7568026,7568024,'adm',33.333,4),(1068,7568027,7568024,'dmi',33.333,4),(1068,7568028,7568024,'min',33.333,4),(1068,7568029,7568026,'cap',16.667,1),(1068,7568030,7568026,'apa',16.667,1),(1068,7568031,7568026,'pac',16.667,1),(1068,7568032,7568026,'aci',16.667,1),(1068,7568033,7568026,'cit',16.667,1),(1068,7568034,7568026,'ity',16.667,1),(1068,7568035,7568029,'pat',50,1),(1068,7568036,7568029,'ath',50,1),(1068,7568037,7568035,'fre',14.286,1),(1068,7568038,7568035,'ree',14.286,1),(1068,7568039,7568035,'ees',14.286,1),(1068,7568040,7568035,'esp',14.286,1),(1068,7568041,7568035,'spa',14.286,1),(1068,7568042,7568035,'pac',14.286,1),(1068,7568043,7568035,'ace',14.286,1),(1068,7568044,7568037,'dis',50,1),(1068,7568045,7568037,'isk',50,1),(1068,7568046,7568044,'ind',33.333,1),(1068,7568047,7568044,'nde',33.333,1),(1068,7568048,7568044,'dex',33.333,1),(1068,7568049,7568046,'adm',8.333,1),(1068,7568050,7568046,'dmi',8.333,1),(1068,7568051,7568046,'min',8.333,1),(1068,7568052,7568046,'ini',8.333,1),(1068,7568053,7568046,'nis',8.333,1),(1068,7568054,7568046,'ist',8.333,1),(1068,7568055,7568046,'str',8.333,1),(1068,7568056,7568046,'tra',8.333,1),(1068,7568057,7568046,'rat',8.333,1),(1068,7568058,7568046,'ati',8.333,1),(1068,7568059,7568046,'tio',8.333,1),(1068,7568060,7568046,'ion',8.333,1),(1068,7568061,7568049,'sta',33.333,3),(1068,7568062,7568049,'tat',33.333,3),(1068,7568063,7568049,'ate',33.333,3),(1068,7568064,7568061,'dis',16.667,4),(1068,7568065,7568061,'isa',16.667,4),(1068,7568066,7568061,'sab',16.667,4),(1068,7568067,7568061,'abl',16.667,4),(1068,7568068,7568061,'ble',16.667,4),(1068,7568069,7568061,'led',16.667,4),(1068,7568070,7568064,'cac',33.333,1),(1068,7568071,7568064,'ach',33.333,1),(1068,7568072,7568064,'che',33.333,1),(1068,7568073,7568070,'mod',50,1),(1068,7568074,7568070,'ode',50,1),(1068,7568075,7568073,'wri',14.286,1),(1068,7568076,7568073,'rit',14.286,1),(1068,7568077,7568073,'ite',14.286,1),(1068,7568078,7568073,'tet',14.286,1),(1068,7568079,7568073,'eth',14.286,1),(1068,7568080,7568073,'thr',14.286,1),(1068,7568081,7568073,'hru',14.286,1),(1068,7568082,7568075,'ope',11.111,2),(1068,7568083,7568075,'per',11.111,2),(1068,7568084,7568075,'era',11.111,2),(1068,7568085,7568075,'rat',11.111,2),(1068,7568086,7568075,'ati',11.111,2),(1068,7568087,7568075,'tio',11.111,2),(1068,7568088,7568075,'ion',11.111,2),(1068,7568089,7568075,'ona',11.111,2),(1068,7568090,7568075,'nal',11.111,2),(1068,7568091,7568082,'mes',20,1),(1068,7568092,7568082,'ess',20,1),(1068,7568093,7568082,'ssa',20,1),(1068,7568094,7568082,'sag',20,1),(1068,7568095,7568082,'age',20,1),(1068,7568096,7568091,'per',11.111,1),(1068,7568097,7568091,'erf',11.111,1),(1068,7568098,7568091,'rfo',11.111,1),(1068,7568099,7568091,'for',11.111,1),(1068,7568100,7568091,'orm',11.111,1),(1068,7568101,7568091,'rma',11.111,1),(1068,7568102,7568091,'man',11.111,1),(1068,7568103,7568091,'anc',11.111,1),(1068,7568104,7568091,'nce',11.111,1),(1068,7568105,7568096,'ide',12.5,1),(1068,7568106,7568096,'den',12.5,1),(1068,7568107,7568096,'ent',12.5,1),(1068,7568108,7568096,'nti',12.5,1),(1068,7568109,7568096,'tif',12.5,1),(1068,7568110,7568096,'ifi',12.5,1),(1068,7568111,7568096,'fie',12.5,1),(1068,7568112,7568096,'ier',12.5,1),(1068,7568113,7568105,'vdi',33.333,3),(1068,7568114,7568105,'dis',33.333,3),(1068,7568115,7568105,'isk',33.333,3),(1068,7568116,7568113,'nam',50,1),(1068,7568117,7568113,'ame',50,1),(1068,7568118,7568116,'typ',50,1),(1068,7568119,7568116,'ype',50,1),(1068,7568120,7568118,'dir',25,1),(1068,7568121,7568118,'ire',25,1),(1068,7568122,7568118,'rec',25,1),(1068,7568123,7568118,'ect',25,1),(1069,7568125,7568124,'naa',100,2),(1069,7568126,7568125,'600',3.333,3),(1069,7568127,7568125,'000',3.333,3),(1069,7568128,7568125,'00c',3.333,3),(1069,7568129,7568125,'0c2',3.333,3),(1069,7568130,7568125,'c29',3.333,3),(1069,7568131,7568125,'290',3.333,3),(1069,7568132,7568125,'908',3.333,3),(1069,7568133,7568125,'081',3.333,3),(1069,7568134,7568125,'81d',3.333,3),(1069,7568135,7568125,'1d3',3.333,3),(1069,7568136,7568125,'d3b',3.333,3),(1069,7568137,7568125,'3b1',3.333,3),(1069,7568138,7568125,'b17',3.333,3),(1069,7568139,7568125,'171',3.333,3),(1069,7568140,7568125,'71a',3.333,3),(1069,7568141,7568125,'1aa',3.333,3),(1069,7568142,7568125,'aa3',3.333,3),(1069,7568143,7568125,'a3e',3.333,3),(1069,7568144,7568125,'3e2',3.333,3),(1069,7568145,7568125,'e2a',3.333,3),(1069,7568146,7568125,'2a9',3.333,3),(1069,7568147,7568125,'a97',3.333,3),(1069,7568148,7568125,'97e',3.333,3),(1069,7568149,7568125,'7e4',3.333,3),(1069,7568150,7568125,'e42',3.333,3),(1069,7568151,7568125,'42d',3.333,3),(1069,7568152,7568125,'2df',3.333,3),(1069,7568153,7568125,'df8',3.333,3),(1069,7568154,7568125,'f80',3.333,3),(1069,7568155,7568125,'807',3.333,3),(1069,7568156,7568126,'mon',100,1),(1069,7568157,7568156,'201',50,1),(1069,7568158,7568156,'013',50,1),(1069,7568159,7568157,'adm',33.333,4),(1069,7568160,7568157,'dmi',33.333,4),(1069,7568161,7568157,'min',33.333,4),(1069,7568162,7568159,'cap',16.667,1),(1069,7568163,7568159,'apa',16.667,1),(1069,7568164,7568159,'pac',16.667,1),(1069,7568165,7568159,'aci',16.667,1),(1069,7568166,7568159,'cit',16.667,1),(1069,7568167,7568159,'ity',16.667,1),(1069,7568168,7568162,'pat',50,1),(1069,7568169,7568162,'ath',50,1),(1069,7568170,7568168,'fre',14.286,1),(1069,7568171,7568168,'ree',14.286,1),(1069,7568172,7568168,'ees',14.286,1),(1069,7568173,7568168,'esp',14.286,1),(1069,7568174,7568168,'spa',14.286,1),(1069,7568175,7568168,'pac',14.286,1),(1069,7568176,7568168,'ace',14.286,1),(1069,7568177,7568170,'dis',50,1),(1069,7568178,7568170,'isk',50,1),(1069,7568179,7568177,'ind',33.333,1),(1069,7568180,7568177,'nde',33.333,1),(1069,7568181,7568177,'dex',33.333,1),(1069,7568182,7568179,'adm',8.333,1),(1069,7568183,7568179,'dmi',8.333,1),(1069,7568184,7568179,'min',8.333,1),(1069,7568185,7568179,'ini',8.333,1),(1069,7568186,7568179,'nis',8.333,1),(1069,7568187,7568179,'ist',8.333,1),(1069,7568188,7568179,'str',8.333,1),(1069,7568189,7568179,'tra',8.333,1),(1069,7568190,7568179,'rat',8.333,1),(1069,7568191,7568179,'ati',8.333,1),(1069,7568192,7568179,'tio',8.333,1),(1069,7568193,7568179,'ion',8.333,1),(1069,7568194,7568182,'sta',33.333,3),(1069,7568195,7568182,'tat',33.333,3),(1069,7568196,7568182,'ate',33.333,3),(1069,7568197,7568194,'dis',16.667,4),(1069,7568198,7568194,'isa',16.667,4),(1069,7568199,7568194,'sab',16.667,4),(1069,7568200,7568194,'abl',16.667,4),(1069,7568201,7568194,'ble',16.667,4),(1069,7568202,7568194,'led',16.667,4),(1069,7568203,7568197,'cac',33.333,1),(1069,7568204,7568197,'ach',33.333,1),(1069,7568205,7568197,'che',33.333,1),(1069,7568206,7568203,'mod',50,1),(1069,7568207,7568203,'ode',50,1),(1069,7568208,7568206,'wri',14.286,1),(1069,7568209,7568206,'rit',14.286,1),(1069,7568210,7568206,'ite',14.286,1),(1069,7568211,7568206,'tet',14.286,1),(1069,7568212,7568206,'eth',14.286,1),(1069,7568213,7568206,'thr',14.286,1),(1069,7568214,7568206,'hru',14.286,1),(1069,7568215,7568208,'ope',11.111,2),(1069,7568216,7568208,'per',11.111,2),(1069,7568217,7568208,'era',11.111,2),(1069,7568218,7568208,'rat',11.111,2),(1069,7568219,7568208,'ati',11.111,2),(1069,7568220,7568208,'tio',11.111,2),(1069,7568221,7568208,'ion',11.111,2),(1069,7568222,7568208,'ona',11.111,2),(1069,7568223,7568208,'nal',11.111,2),(1069,7568224,7568215,'mes',20,1),(1069,7568225,7568215,'ess',20,1),(1069,7568226,7568215,'ssa',20,1),(1069,7568227,7568215,'sag',20,1),(1069,7568228,7568215,'age',20,1),(1069,7568229,7568224,'per',11.111,1),(1069,7568230,7568224,'erf',11.111,1),(1069,7568231,7568224,'rfo',11.111,1),(1069,7568232,7568224,'for',11.111,1),(1069,7568233,7568224,'orm',11.111,1),(1069,7568234,7568224,'rma',11.111,1),(1069,7568235,7568224,'man',11.111,1),(1069,7568236,7568224,'anc',11.111,1),(1069,7568237,7568224,'nce',11.111,1),(1069,7568238,7568229,'ide',12.5,1),(1069,7568239,7568229,'den',12.5,1),(1069,7568240,7568229,'ent',12.5,1),(1069,7568241,7568229,'nti',12.5,1),(1069,7568242,7568229,'tif',12.5,1),(1069,7568243,7568229,'ifi',12.5,1),(1069,7568244,7568229,'fie',12.5,1),(1069,7568245,7568229,'ier',12.5,1),(1069,7568246,7568238,'vdi',33.333,3),(1069,7568247,7568238,'dis',33.333,3),(1069,7568248,7568238,'isk',33.333,3),(1069,7568249,7568246,'nam',50,1),(1069,7568250,7568246,'ame',50,1),(1069,7568251,7568249,'typ',50,1),(1069,7568252,7568249,'ype',50,1),(1069,7568253,7568251,'dir',25,1),(1069,7568254,7568251,'ire',25,1),(1069,7568255,7568251,'rec',25,1),(1069,7568256,7568251,'ect',25,1),(1070,7568258,7568257,'naa',100,2),(1070,7568259,7568258,'600',3.333,3),(1070,7568260,7568258,'000',3.333,3),(1070,7568261,7568258,'00c',3.333,3),(1070,7568262,7568258,'0c2',3.333,3),(1070,7568263,7568258,'c29',3.333,3),(1070,7568264,7568258,'298',3.333,3),(1070,7568265,7568258,'981',3.333,3),(1070,7568266,7568258,'81b',3.333,3),(1070,7568267,7568258,'1b9',3.333,3),(1070,7568268,7568258,'b94',3.333,3),(1070,7568269,7568258,'94f',3.333,3),(1070,7568270,7568258,'4f1',3.333,3),(1070,7568271,7568258,'f1b',3.333,3),(1070,7568272,7568258,'1b3',3.333,3),(1070,7568273,7568258,'b3a',3.333,3),(1070,7568274,7568258,'3a3',3.333,3),(1070,7568275,7568258,'a39',3.333,3),(1070,7568276,7568258,'39d',3.333,3),(1070,7568277,7568258,'9de',3.333,3),(1070,7568278,7568258,'dec',3.333,3),(1070,7568279,7568258,'ec3',3.333,3),(1070,7568280,7568258,'c30',3.333,3),(1070,7568281,7568258,'306',3.333,3),(1070,7568282,7568258,'06a',3.333,3),(1070,7568283,7568258,'6ad',3.333,3),(1070,7568284,7568258,'adf',3.333,3),(1070,7568285,7568258,'dfa',3.333,3),(1070,7568286,7568258,'fab',3.333,3),(1070,7568287,7568258,'ab8',3.333,3),(1070,7568288,7568258,'b89',3.333,3),(1070,7568289,7568259,'mon',100,1),(1070,7568290,7568289,'201',50,1),(1070,7568291,7568289,'013',50,1),(1070,7568292,7568290,'adm',33.333,4),(1070,7568293,7568290,'dmi',33.333,4),(1070,7568294,7568290,'min',33.333,4),(1070,7568295,7568292,'cap',16.667,1),(1070,7568296,7568292,'apa',16.667,1),(1070,7568297,7568292,'pac',16.667,1),(1070,7568298,7568292,'aci',16.667,1),(1070,7568299,7568292,'cit',16.667,1),(1070,7568300,7568292,'ity',16.667,1),(1070,7568301,7568295,'pat',50,1),(1070,7568302,7568295,'ath',50,1),(1070,7568303,7568301,'fre',14.286,1),(1070,7568304,7568301,'ree',14.286,1),(1070,7568305,7568301,'ees',14.286,1),(1070,7568306,7568301,'esp',14.286,1),(1070,7568307,7568301,'spa',14.286,1),(1070,7568308,7568301,'pac',14.286,1),(1070,7568309,7568301,'ace',14.286,1),(1070,7568310,7568303,'dis',50,1),(1070,7568311,7568303,'isk',50,1),(1070,7568312,7568310,'ind',33.333,1),(1070,7568313,7568310,'nde',33.333,1),(1070,7568314,7568310,'dex',33.333,1),(1070,7568315,7568312,'adm',8.333,1),(1070,7568316,7568312,'dmi',8.333,1),(1070,7568317,7568312,'min',8.333,1),(1070,7568318,7568312,'ini',8.333,1),(1070,7568319,7568312,'nis',8.333,1),(1070,7568320,7568312,'ist',8.333,1),(1070,7568321,7568312,'str',8.333,1),(1070,7568322,7568312,'tra',8.333,1),(1070,7568323,7568312,'rat',8.333,1),(1070,7568324,7568312,'ati',8.333,1),(1070,7568325,7568312,'tio',8.333,1),(1070,7568326,7568312,'ion',8.333,1),(1070,7568327,7568315,'sta',33.333,3),(1070,7568328,7568315,'tat',33.333,3),(1070,7568329,7568315,'ate',33.333,3),(1070,7568330,7568327,'dis',16.667,4),(1070,7568331,7568327,'isa',16.667,4),(1070,7568332,7568327,'sab',16.667,4),(1070,7568333,7568327,'abl',16.667,4),(1070,7568334,7568327,'ble',16.667,4),(1070,7568335,7568327,'led',16.667,4),(1070,7568336,7568330,'cac',33.333,1),(1070,7568337,7568330,'ach',33.333,1),(1070,7568338,7568330,'che',33.333,1),(1070,7568339,7568336,'mod',50,1),(1070,7568340,7568336,'ode',50,1),(1070,7568341,7568339,'wri',14.286,1),(1070,7568342,7568339,'rit',14.286,1),(1070,7568343,7568339,'ite',14.286,1),(1070,7568344,7568339,'tet',14.286,1),(1070,7568345,7568339,'eth',14.286,1),(1070,7568346,7568339,'thr',14.286,1),(1070,7568347,7568339,'hru',14.286,1),(1070,7568348,7568341,'ope',11.111,2),(1070,7568349,7568341,'per',11.111,2),(1070,7568350,7568341,'era',11.111,2),(1070,7568351,7568341,'rat',11.111,2),(1070,7568352,7568341,'ati',11.111,2),(1070,7568353,7568341,'tio',11.111,2),(1070,7568354,7568341,'ion',11.111,2),(1070,7568355,7568341,'ona',11.111,2),(1070,7568356,7568341,'nal',11.111,2),(1070,7568357,7568348,'mes',20,1),(1070,7568358,7568348,'ess',20,1),(1070,7568359,7568348,'ssa',20,1),(1070,7568360,7568348,'sag',20,1),(1070,7568361,7568348,'age',20,1),(1070,7568362,7568357,'per',11.111,1),(1070,7568363,7568357,'erf',11.111,1),(1070,7568364,7568357,'rfo',11.111,1),(1070,7568365,7568357,'for',11.111,1),(1070,7568366,7568357,'orm',11.111,1),(1070,7568367,7568357,'rma',11.111,1),(1070,7568368,7568357,'man',11.111,1),(1070,7568369,7568357,'anc',11.111,1),(1070,7568370,7568357,'nce',11.111,1),(1070,7568371,7568362,'ide',12.5,1),(1070,7568372,7568362,'den',12.5,1),(1070,7568373,7568362,'ent',12.5,1),(1070,7568374,7568362,'nti',12.5,1),(1070,7568375,7568362,'tif',12.5,1),(1070,7568376,7568362,'ifi',12.5,1),(1070,7568377,7568362,'fie',12.5,1),(1070,7568378,7568362,'ier',12.5,1),(1070,7568379,7568371,'vdi',33.333,3),(1070,7568380,7568371,'dis',33.333,3),(1070,7568381,7568371,'isk',33.333,3),(1070,7568382,7568379,'nam',50,1),(1070,7568383,7568379,'ame',50,1),(1070,7568384,7568382,'typ',50,1),(1070,7568385,7568382,'ype',50,1),(1070,7568386,7568384,'dir',25,1),(1070,7568387,7568384,'ire',25,1),(1070,7568388,7568384,'rec',25,1),(1070,7568389,7568384,'ect',25,1),(1071,7568391,7568390,'naa',100,2),(1071,7568392,7568391,'600',3.333,3),(1071,7568393,7568391,'000',3.333,3),(1071,7568394,7568391,'00c',3.333,3),(1071,7568395,7568391,'0c2',3.333,3),(1071,7568396,7568391,'c29',3.333,3),(1071,7568397,7568391,'29e',3.333,3),(1071,7568398,7568391,'9e7',3.333,3),(1071,7568399,7568391,'e7c',3.333,3),(1071,7568400,7568391,'7c2',3.333,3),(1071,7568401,7568391,'c22',3.333,3),(1071,7568402,7568391,'22d',3.333,3),(1071,7568403,7568391,'2d9',3.333,3),(1071,7568404,7568391,'d9f',3.333,3),(1071,7568405,7568391,'9fa',3.333,3),(1071,7568406,7568391,'fa3',3.333,3),(1071,7568407,7568391,'a39',3.333,3),(1071,7568408,7568391,'39d',3.333,3),(1071,7568409,7568391,'9d7',3.333,3),(1071,7568410,7568391,'d7b',3.333,3),(1071,7568411,7568391,'7b8',3.333,3),(1071,7568412,7568391,'b87',3.333,3),(1071,7568413,7568391,'87e',3.333,3),(1071,7568414,7568391,'7ee',3.333,3),(1071,7568415,7568391,'ee2',3.333,3),(1071,7568416,7568391,'e22',3.333,3),(1071,7568417,7568391,'229',3.333,3),(1071,7568418,7568391,'29a',3.333,3),(1071,7568419,7568391,'9ad',3.333,3),(1071,7568420,7568391,'ad1',3.333,3),(1071,7568421,7568391,'d1e',3.333,3),(1071,7568422,7568392,'mon',100,1),(1071,7568423,7568422,'201',50,1),(1071,7568424,7568422,'013',50,1),(1071,7568425,7568423,'adm',33.333,4),(1071,7568426,7568423,'dmi',33.333,4),(1071,7568427,7568423,'min',33.333,4),(1071,7568428,7568425,'cap',16.667,1),(1071,7568429,7568425,'apa',16.667,1),(1071,7568430,7568425,'pac',16.667,1),(1071,7568431,7568425,'aci',16.667,1),(1071,7568432,7568425,'cit',16.667,1),(1071,7568433,7568425,'ity',16.667,1),(1071,7568434,7568428,'pat',50,1),(1071,7568435,7568428,'ath',50,1),(1071,7568436,7568434,'fre',14.286,1),(1071,7568437,7568434,'ree',14.286,1),(1071,7568438,7568434,'ees',14.286,1),(1071,7568439,7568434,'esp',14.286,1),(1071,7568440,7568434,'spa',14.286,1),(1071,7568441,7568434,'pac',14.286,1),(1071,7568442,7568434,'ace',14.286,1),(1071,7568443,7568436,'dis',50,1),(1071,7568444,7568436,'isk',50,1),(1071,7568445,7568443,'ind',33.333,1),(1071,7568446,7568443,'nde',33.333,1),(1071,7568447,7568443,'dex',33.333,1),(1071,7568448,7568445,'adm',8.333,1),(1071,7568449,7568445,'dmi',8.333,1),(1071,7568450,7568445,'min',8.333,1),(1071,7568451,7568445,'ini',8.333,1),(1071,7568452,7568445,'nis',8.333,1),(1071,7568453,7568445,'ist',8.333,1),(1071,7568454,7568445,'str',8.333,1),(1071,7568455,7568445,'tra',8.333,1),(1071,7568456,7568445,'rat',8.333,1),(1071,7568457,7568445,'ati',8.333,1),(1071,7568458,7568445,'tio',8.333,1),(1071,7568459,7568445,'ion',8.333,1),(1071,7568460,7568448,'sta',33.333,3),(1071,7568461,7568448,'tat',33.333,3),(1071,7568462,7568448,'ate',33.333,3),(1071,7568463,7568460,'dis',16.667,4),(1071,7568464,7568460,'isa',16.667,4),(1071,7568465,7568460,'sab',16.667,4),(1071,7568466,7568460,'abl',16.667,4),(1071,7568467,7568460,'ble',16.667,4),(1071,7568468,7568460,'led',16.667,4),(1071,7568469,7568463,'cac',33.333,1),(1071,7568470,7568463,'ach',33.333,1),(1071,7568471,7568463,'che',33.333,1),(1071,7568472,7568469,'mod',50,1),(1071,7568473,7568469,'ode',50,1),(1071,7568474,7568472,'wri',14.286,1),(1071,7568475,7568472,'rit',14.286,1),(1071,7568476,7568472,'ite',14.286,1),(1071,7568477,7568472,'tet',14.286,1),(1071,7568478,7568472,'eth',14.286,1),(1071,7568479,7568472,'thr',14.286,1),(1071,7568480,7568472,'hru',14.286,1),(1071,7568481,7568474,'ope',11.111,2),(1071,7568482,7568474,'per',11.111,2),(1071,7568483,7568474,'era',11.111,2),(1071,7568484,7568474,'rat',11.111,2),(1071,7568485,7568474,'ati',11.111,2),(1071,7568486,7568474,'tio',11.111,2),(1071,7568487,7568474,'ion',11.111,2),(1071,7568488,7568474,'ona',11.111,2),(1071,7568489,7568474,'nal',11.111,2),(1071,7568490,7568481,'mes',20,1),(1071,7568491,7568481,'ess',20,1),(1071,7568492,7568481,'ssa',20,1),(1071,7568493,7568481,'sag',20,1),(1071,7568494,7568481,'age',20,1),(1071,7568495,7568490,'per',11.111,1),(1071,7568496,7568490,'erf',11.111,1),(1071,7568497,7568490,'rfo',11.111,1),(1071,7568498,7568490,'for',11.111,1),(1071,7568499,7568490,'orm',11.111,1),(1071,7568500,7568490,'rma',11.111,1),(1071,7568501,7568490,'man',11.111,1),(1071,7568502,7568490,'anc',11.111,1),(1071,7568503,7568490,'nce',11.111,1),(1071,7568504,7568495,'ide',12.5,1),(1071,7568505,7568495,'den',12.5,1),(1071,7568506,7568495,'ent',12.5,1),(1071,7568507,7568495,'nti',12.5,1),(1071,7568508,7568495,'tif',12.5,1),(1071,7568509,7568495,'ifi',12.5,1),(1071,7568510,7568495,'fie',12.5,1),(1071,7568511,7568495,'ier',12.5,1),(1071,7568512,7568504,'vdi',33.333,3),(1071,7568513,7568504,'dis',33.333,3),(1071,7568514,7568504,'isk',33.333,3),(1071,7568515,7568512,'nam',50,1),(1071,7568516,7568512,'ame',50,1),(1071,7568517,7568515,'typ',50,1),(1071,7568518,7568515,'ype',50,1),(1071,7568519,7568517,'dir',25,1),(1071,7568520,7568517,'ire',25,1),(1071,7568521,7568517,'rec',25,1),(1071,7568522,7568517,'ect',25,1),(1072,7568524,7568523,'naa',100,2),(1072,7568525,7568524,'600',3.333,3),(1072,7568526,7568524,'000',3.333,3),(1072,7568527,7568524,'00c',3.333,3),(1072,7568528,7568524,'0c2',3.333,3),(1072,7568529,7568524,'c29',3.333,3),(1072,7568530,7568524,'29d',3.333,3),(1072,7568531,7568524,'9d1',3.333,3),(1072,7568532,7568524,'d15',3.333,3),(1072,7568533,7568524,'155',3.333,3),(1072,7568534,7568524,'551',3.333,3),(1072,7568535,7568524,'513',3.333,3),(1072,7568536,7568524,'137',3.333,3),(1072,7568537,7568524,'376',3.333,3),(1072,7568538,7568524,'769',3.333,3),(1072,7568539,7568524,'69e',3.333,3),(1072,7568540,7568524,'9e7',3.333,3),(1072,7568541,7568524,'e71',3.333,3),(1072,7568542,7568524,'71c',3.333,3),(1072,7568543,7568524,'1c3',3.333,3),(1072,7568544,7568524,'c39',3.333,3),(1072,7568545,7568524,'39b',3.333,3),(1072,7568546,7568524,'9b8',3.333,3),(1072,7568547,7568524,'b85',3.333,3),(1072,7568548,7568524,'852',3.333,3),(1072,7568549,7568524,'52f',3.333,3),(1072,7568550,7568524,'2f7',3.333,3),(1072,7568551,7568524,'f74',3.333,3),(1072,7568552,7568524,'743',3.333,3),(1072,7568553,7568524,'433',3.333,3),(1072,7568554,7568524,'337',3.333,3),(1072,7568555,7568525,'mon',100,1),(1072,7568556,7568555,'201',50,1),(1072,7568557,7568555,'013',50,1),(1072,7568558,7568556,'adm',33.333,4),(1072,7568559,7568556,'dmi',33.333,4),(1072,7568560,7568556,'min',33.333,4),(1072,7568561,7568558,'cap',16.667,1),(1072,7568562,7568558,'apa',16.667,1),(1072,7568563,7568558,'pac',16.667,1),(1072,7568564,7568558,'aci',16.667,1),(1072,7568565,7568558,'cit',16.667,1),(1072,7568566,7568558,'ity',16.667,1),(1072,7568567,7568561,'pat',50,1),(1072,7568568,7568561,'ath',50,1),(1072,7568569,7568567,'fre',14.286,1),(1072,7568570,7568567,'ree',14.286,1),(1072,7568571,7568567,'ees',14.286,1),(1072,7568572,7568567,'esp',14.286,1),(1072,7568573,7568567,'spa',14.286,1),(1072,7568574,7568567,'pac',14.286,1),(1072,7568575,7568567,'ace',14.286,1),(1072,7568576,7568569,'dis',50,1),(1072,7568577,7568569,'isk',50,1),(1072,7568578,7568576,'ind',33.333,1),(1072,7568579,7568576,'nde',33.333,1),(1072,7568580,7568576,'dex',33.333,1),(1072,7568581,7568578,'adm',8.333,1),(1072,7568582,7568578,'dmi',8.333,1),(1072,7568583,7568578,'min',8.333,1),(1072,7568584,7568578,'ini',8.333,1),(1072,7568585,7568578,'nis',8.333,1),(1072,7568586,7568578,'ist',8.333,1),(1072,7568587,7568578,'str',8.333,1),(1072,7568588,7568578,'tra',8.333,1),(1072,7568589,7568578,'rat',8.333,1),(1072,7568590,7568578,'ati',8.333,1),(1072,7568591,7568578,'tio',8.333,1),(1072,7568592,7568578,'ion',8.333,1),(1072,7568593,7568581,'sta',33.333,3),(1072,7568594,7568581,'tat',33.333,3),(1072,7568595,7568581,'ate',33.333,3),(1072,7568596,7568593,'dis',16.667,4),(1072,7568597,7568593,'isa',16.667,4),(1072,7568598,7568593,'sab',16.667,4),(1072,7568599,7568593,'abl',16.667,4),(1072,7568600,7568593,'ble',16.667,4),(1072,7568601,7568593,'led',16.667,4),(1072,7568602,7568596,'cac',33.333,1),(1072,7568603,7568596,'ach',33.333,1),(1072,7568604,7568596,'che',33.333,1),(1072,7568605,7568602,'mod',50,1),(1072,7568606,7568602,'ode',50,1),(1072,7568607,7568605,'wri',14.286,1),(1072,7568608,7568605,'rit',14.286,1),(1072,7568609,7568605,'ite',14.286,1),(1072,7568610,7568605,'tet',14.286,1),(1072,7568611,7568605,'eth',14.286,1),(1072,7568612,7568605,'thr',14.286,1),(1072,7568613,7568605,'hru',14.286,1),(1072,7568614,7568607,'ope',11.111,2),(1072,7568615,7568607,'per',11.111,2),(1072,7568616,7568607,'era',11.111,2),(1072,7568617,7568607,'rat',11.111,2),(1072,7568618,7568607,'ati',11.111,2),(1072,7568619,7568607,'tio',11.111,2),(1072,7568620,7568607,'ion',11.111,2),(1072,7568621,7568607,'ona',11.111,2),(1072,7568622,7568607,'nal',11.111,2),(1072,7568623,7568614,'mes',20,1),(1072,7568624,7568614,'ess',20,1),(1072,7568625,7568614,'ssa',20,1),(1072,7568626,7568614,'sag',20,1),(1072,7568627,7568614,'age',20,1),(1072,7568628,7568623,'per',11.111,1),(1072,7568629,7568623,'erf',11.111,1),(1072,7568630,7568623,'rfo',11.111,1),(1072,7568631,7568623,'for',11.111,1),(1072,7568632,7568623,'orm',11.111,1),(1072,7568633,7568623,'rma',11.111,1),(1072,7568634,7568623,'man',11.111,1),(1072,7568635,7568623,'anc',11.111,1),(1072,7568636,7568623,'nce',11.111,1),(1072,7568637,7568628,'ide',12.5,1),(1072,7568638,7568628,'den',12.5,1),(1072,7568639,7568628,'ent',12.5,1),(1072,7568640,7568628,'nti',12.5,1),(1072,7568641,7568628,'tif',12.5,1),(1072,7568642,7568628,'ifi',12.5,1),(1072,7568643,7568628,'fie',12.5,1),(1072,7568644,7568628,'ier',12.5,1),(1072,7568645,7568637,'vdi',33.333,3),(1072,7568646,7568637,'dis',33.333,3),(1072,7568647,7568637,'isk',33.333,3),(1072,7568648,7568645,'nam',50,1),(1072,7568649,7568645,'ame',50,1),(1072,7568650,7568648,'typ',50,1),(1072,7568651,7568648,'ype',50,1),(1072,7568652,7568650,'dir',25,1),(1072,7568653,7568650,'ire',25,1),(1072,7568654,7568650,'rec',25,1),(1072,7568655,7568650,'ect',25,1),(1073,7568657,7568656,'naa',100,2),(1073,7568658,7568657,'600',3.333,3),(1073,7568659,7568657,'000',3.333,3),(1073,7568660,7568657,'00c',3.333,3),(1073,7568661,7568657,'0c2',3.333,3),(1073,7568662,7568657,'c29',3.333,3),(1073,7568663,7568657,'298',3.333,3),(1073,7568664,7568657,'989',3.333,3),(1073,7568665,7568657,'89f',3.333,3),(1073,7568666,7568657,'9f3',3.333,3),(1073,7568667,7568657,'f39',3.333,3),(1073,7568668,7568657,'395',3.333,3),(1073,7568669,7568657,'950',3.333,3),(1073,7568670,7568657,'500',3.333,3),(1073,7568671,7568657,'004',3.333,3),(1073,7568672,7568657,'048',3.333,3),(1073,7568673,7568657,'487',3.333,3),(1073,7568674,7568657,'876',3.333,3),(1073,7568675,7568657,'76c',3.333,3),(1073,7568676,7568657,'6c9',3.333,3),(1073,7568677,7568657,'c95',3.333,3),(1073,7568678,7568657,'959',3.333,3),(1073,7568679,7568657,'590',3.333,3),(1073,7568680,7568657,'905',3.333,3),(1073,7568681,7568657,'054',3.333,3),(1073,7568682,7568657,'544',3.333,3),(1073,7568683,7568657,'44b',3.333,3),(1073,7568684,7568657,'4b8',3.333,3),(1073,7568685,7568657,'b83',3.333,3),(1073,7568686,7568657,'835',3.333,3),(1073,7568687,7568657,'357',3.333,3),(1073,7568688,7568658,'mon',100,1),(1073,7568689,7568688,'201',50,1),(1073,7568690,7568688,'013',50,1),(1073,7568691,7568689,'adm',33.333,4),(1073,7568692,7568689,'dmi',33.333,4),(1073,7568693,7568689,'min',33.333,4),(1073,7568694,7568691,'cap',16.667,1),(1073,7568695,7568691,'apa',16.667,1),(1073,7568696,7568691,'pac',16.667,1),(1073,7568697,7568691,'aci',16.667,1),(1073,7568698,7568691,'cit',16.667,1),(1073,7568699,7568691,'ity',16.667,1),(1073,7568700,7568694,'pat',50,1),(1073,7568701,7568694,'ath',50,1),(1073,7568702,7568700,'fre',14.286,1),(1073,7568703,7568700,'ree',14.286,1),(1073,7568704,7568700,'ees',14.286,1),(1073,7568705,7568700,'esp',14.286,1),(1073,7568706,7568700,'spa',14.286,1),(1073,7568707,7568700,'pac',14.286,1),(1073,7568708,7568700,'ace',14.286,1),(1073,7568709,7568702,'dis',50,1),(1073,7568710,7568702,'isk',50,1),(1073,7568711,7568709,'ind',33.333,1),(1073,7568712,7568709,'nde',33.333,1),(1073,7568713,7568709,'dex',33.333,1),(1073,7568714,7568711,'adm',8.333,1),(1073,7568715,7568711,'dmi',8.333,1),(1073,7568716,7568711,'min',8.333,1),(1073,7568717,7568711,'ini',8.333,1),(1073,7568718,7568711,'nis',8.333,1),(1073,7568719,7568711,'ist',8.333,1),(1073,7568720,7568711,'str',8.333,1),(1073,7568721,7568711,'tra',8.333,1),(1073,7568722,7568711,'rat',8.333,1),(1073,7568723,7568711,'ati',8.333,1),(1073,7568724,7568711,'tio',8.333,1),(1073,7568725,7568711,'ion',8.333,1),(1073,7568726,7568714,'sta',33.333,3),(1073,7568727,7568714,'tat',33.333,3),(1073,7568728,7568714,'ate',33.333,3),(1073,7568729,7568726,'dis',16.667,4),(1073,7568730,7568726,'isa',16.667,4),(1073,7568731,7568726,'sab',16.667,4),(1073,7568732,7568726,'abl',16.667,4),(1073,7568733,7568726,'ble',16.667,4),(1073,7568734,7568726,'led',16.667,4),(1073,7568735,7568729,'cac',33.333,1),(1073,7568736,7568729,'ach',33.333,1),(1073,7568737,7568729,'che',33.333,1),(1073,7568738,7568735,'mod',50,1),(1073,7568739,7568735,'ode',50,1),(1073,7568740,7568738,'wri',14.286,1),(1073,7568741,7568738,'rit',14.286,1),(1073,7568742,7568738,'ite',14.286,1),(1073,7568743,7568738,'tet',14.286,1),(1073,7568744,7568738,'eth',14.286,1),(1073,7568745,7568738,'thr',14.286,1),(1073,7568746,7568738,'hru',14.286,1),(1073,7568747,7568740,'ope',11.111,2),(1073,7568748,7568740,'per',11.111,2),(1073,7568749,7568740,'era',11.111,2),(1073,7568750,7568740,'rat',11.111,2),(1073,7568751,7568740,'ati',11.111,2),(1073,7568752,7568740,'tio',11.111,2),(1073,7568753,7568740,'ion',11.111,2),(1073,7568754,7568740,'ona',11.111,2),(1073,7568755,7568740,'nal',11.111,2),(1073,7568756,7568747,'mes',20,1),(1073,7568757,7568747,'ess',20,1),(1073,7568758,7568747,'ssa',20,1),(1073,7568759,7568747,'sag',20,1),(1073,7568760,7568747,'age',20,1),(1073,7568761,7568756,'per',11.111,1),(1073,7568762,7568756,'erf',11.111,1),(1073,7568763,7568756,'rfo',11.111,1),(1073,7568764,7568756,'for',11.111,1),(1073,7568765,7568756,'orm',11.111,1),(1073,7568766,7568756,'rma',11.111,1),(1073,7568767,7568756,'man',11.111,1),(1073,7568768,7568756,'anc',11.111,1),(1073,7568769,7568756,'nce',11.111,1),(1073,7568770,7568761,'ide',12.5,1),(1073,7568771,7568761,'den',12.5,1),(1073,7568772,7568761,'ent',12.5,1),(1073,7568773,7568761,'nti',12.5,1),(1073,7568774,7568761,'tif',12.5,1),(1073,7568775,7568761,'ifi',12.5,1),(1073,7568776,7568761,'fie',12.5,1),(1073,7568777,7568761,'ier',12.5,1),(1073,7568778,7568770,'vdi',33.333,3),(1073,7568779,7568770,'dis',33.333,3),(1073,7568780,7568770,'isk',33.333,3),(1073,7568781,7568778,'nam',50,1),(1073,7568782,7568778,'ame',50,1),(1073,7568783,7568781,'typ',50,1),(1073,7568784,7568781,'ype',50,1),(1073,7568785,7568783,'dir',25,1),(1073,7568786,7568783,'ire',25,1),(1073,7568787,7568783,'rec',25,1),(1073,7568788,7568783,'ect',25,1),(1074,7568790,7568789,'naa',100,2),(1074,7568791,7568790,'600',3.333,3),(1074,7568792,7568790,'000',3.333,3),(1074,7568793,7568790,'00c',3.333,3),(1074,7568794,7568790,'0c2',3.333,3),(1074,7568795,7568790,'c29',3.333,3),(1074,7568796,7568790,'299',3.333,3),(1074,7568797,7568790,'99f',3.333,3),(1074,7568798,7568790,'9f4',3.333,3),(1074,7568799,7568790,'f48',3.333,3),(1074,7568800,7568790,'483',3.333,3),(1074,7568801,7568790,'832',3.333,3),(1074,7568802,7568790,'328',3.333,3),(1074,7568803,7568790,'283',3.333,3),(1074,7568804,7568790,'83b',3.333,3),(1074,7568805,7568790,'3be',3.333,3),(1074,7568806,7568790,'be4',3.333,3),(1074,7568807,7568790,'e47',3.333,3),(1074,7568808,7568790,'479',3.333,3),(1074,7568809,7568790,'79d',3.333,3),(1074,7568810,7568790,'9d3',3.333,3),(1074,7568811,7568790,'d3d',3.333,3),(1074,7568812,7568790,'3d3',3.333,3),(1074,7568813,7568790,'d37',3.333,3),(1074,7568814,7568790,'37b',3.333,3),(1074,7568815,7568790,'7b5',3.333,3),(1074,7568816,7568790,'b56',3.333,3),(1074,7568817,7568790,'562',3.333,3),(1074,7568818,7568790,'62e',3.333,3),(1074,7568819,7568790,'2e8',3.333,3),(1074,7568820,7568790,'e86',3.333,3),(1074,7568821,7568791,'mon',100,1),(1074,7568822,7568821,'201',50,1),(1074,7568823,7568821,'013',50,1),(1074,7568824,7568822,'adm',33.333,4),(1074,7568825,7568822,'dmi',33.333,4),(1074,7568826,7568822,'min',33.333,4),(1074,7568827,7568824,'cap',16.667,1),(1074,7568828,7568824,'apa',16.667,1),(1074,7568829,7568824,'pac',16.667,1),(1074,7568830,7568824,'aci',16.667,1),(1074,7568831,7568824,'cit',16.667,1),(1074,7568832,7568824,'ity',16.667,1),(1074,7568833,7568827,'pat',50,1),(1074,7568834,7568827,'ath',50,1),(1074,7568835,7568833,'fre',14.286,1),(1074,7568836,7568833,'ree',14.286,1),(1074,7568837,7568833,'ees',14.286,1),(1074,7568838,7568833,'esp',14.286,1),(1074,7568839,7568833,'spa',14.286,1),(1074,7568840,7568833,'pac',14.286,1),(1074,7568841,7568833,'ace',14.286,1),(1074,7568842,7568835,'dis',50,1),(1074,7568843,7568835,'isk',50,1),(1074,7568844,7568842,'ind',33.333,1),(1074,7568845,7568842,'nde',33.333,1),(1074,7568846,7568842,'dex',33.333,1),(1074,7568847,7568844,'adm',8.333,1),(1074,7568848,7568844,'dmi',8.333,1),(1074,7568849,7568844,'min',8.333,1),(1074,7568850,7568844,'ini',8.333,1),(1074,7568851,7568844,'nis',8.333,1),(1074,7568852,7568844,'ist',8.333,1),(1074,7568853,7568844,'str',8.333,1),(1074,7568854,7568844,'tra',8.333,1),(1074,7568855,7568844,'rat',8.333,1),(1074,7568856,7568844,'ati',8.333,1),(1074,7568857,7568844,'tio',8.333,1),(1074,7568858,7568844,'ion',8.333,1),(1074,7568859,7568847,'sta',33.333,3),(1074,7568860,7568847,'tat',33.333,3),(1074,7568861,7568847,'ate',33.333,3),(1074,7568862,7568859,'dis',16.667,4),(1074,7568863,7568859,'isa',16.667,4),(1074,7568864,7568859,'sab',16.667,4),(1074,7568865,7568859,'abl',16.667,4),(1074,7568866,7568859,'ble',16.667,4),(1074,7568867,7568859,'led',16.667,4),(1074,7568868,7568862,'cac',33.333,1),(1074,7568869,7568862,'ach',33.333,1),(1074,7568870,7568862,'che',33.333,1),(1074,7568871,7568868,'mod',50,1),(1074,7568872,7568868,'ode',50,1),(1074,7568873,7568871,'wri',14.286,1),(1074,7568874,7568871,'rit',14.286,1),(1074,7568875,7568871,'ite',14.286,1),(1074,7568876,7568871,'tet',14.286,1),(1074,7568877,7568871,'eth',14.286,1),(1074,7568878,7568871,'thr',14.286,1),(1074,7568879,7568871,'hru',14.286,1),(1074,7568880,7568873,'ope',11.111,2),(1074,7568881,7568873,'per',11.111,2),(1074,7568882,7568873,'era',11.111,2),(1074,7568883,7568873,'rat',11.111,2),(1074,7568884,7568873,'ati',11.111,2),(1074,7568885,7568873,'tio',11.111,2),(1074,7568886,7568873,'ion',11.111,2),(1074,7568887,7568873,'ona',11.111,2),(1074,7568888,7568873,'nal',11.111,2),(1074,7568889,7568880,'mes',20,1),(1074,7568890,7568880,'ess',20,1),(1074,7568891,7568880,'ssa',20,1),(1074,7568892,7568880,'sag',20,1),(1074,7568893,7568880,'age',20,1),(1074,7568894,7568889,'per',11.111,1),(1074,7568895,7568889,'erf',11.111,1),(1074,7568896,7568889,'rfo',11.111,1),(1074,7568897,7568889,'for',11.111,1),(1074,7568898,7568889,'orm',11.111,1),(1074,7568899,7568889,'rma',11.111,1),(1074,7568900,7568889,'man',11.111,1),(1074,7568901,7568889,'anc',11.111,1),(1074,7568902,7568889,'nce',11.111,1),(1074,7568903,7568894,'ide',12.5,1),(1074,7568904,7568894,'den',12.5,1),(1074,7568905,7568894,'ent',12.5,1),(1074,7568906,7568894,'nti',12.5,1),(1074,7568907,7568894,'tif',12.5,1),(1074,7568908,7568894,'ifi',12.5,1),(1074,7568909,7568894,'fie',12.5,1),(1074,7568910,7568894,'ier',12.5,1),(1074,7568911,7568903,'vdi',33.333,3),(1074,7568912,7568903,'dis',33.333,3),(1074,7568913,7568903,'isk',33.333,3),(1074,7568914,7568911,'nam',50,1),(1074,7568915,7568911,'ame',50,1),(1074,7568916,7568914,'typ',50,1),(1074,7568917,7568914,'ype',50,1),(1074,7568918,7568916,'dir',25,1),(1074,7568919,7568916,'ire',25,1),(1074,7568920,7568916,'rec',25,1),(1074,7568921,7568916,'ect',25,1),(1075,7568923,7568922,'naa',100,2),(1075,7568924,7568923,'600',3.333,3),(1075,7568925,7568923,'000',3.333,3),(1075,7568926,7568923,'00c',3.333,3),(1075,7568927,7568923,'0c2',3.333,3),(1075,7568928,7568923,'c29',3.333,3),(1075,7568929,7568923,'292',3.333,3),(1075,7568930,7568923,'92f',3.333,3),(1075,7568931,7568923,'2f8',3.333,3),(1075,7568932,7568923,'f89',3.333,3),(1075,7568933,7568923,'890',3.333,3),(1075,7568934,7568923,'90c',3.333,3),(1075,7568935,7568923,'0ce',3.333,3),(1075,7568936,7568923,'ce9',3.333,3),(1075,7568937,7568923,'e99',3.333,3),(1075,7568938,7568923,'991',3.333,3),(1075,7568939,7568923,'91a',3.333,3),(1075,7568940,7568923,'1af',3.333,3),(1075,7568941,7568923,'af3',3.333,3),(1075,7568942,7568923,'f32',3.333,3),(1075,7568943,7568923,'322',3.333,3),(1075,7568944,7568923,'22a',3.333,3),(1075,7568945,7568923,'2af',3.333,3),(1075,7568946,7568923,'af9',3.333,3),(1075,7568947,7568923,'f9f',3.333,3),(1075,7568948,7568923,'9f2',3.333,3),(1075,7568949,7568923,'f27',3.333,3),(1075,7568950,7568923,'271',3.333,3),(1075,7568951,7568923,'71a',3.333,3),(1075,7568952,7568923,'1a0',3.333,3),(1075,7568953,7568923,'a0e',3.333,3),(1075,7568954,7568924,'mon',100,1),(1075,7568955,7568954,'201',50,1),(1075,7568956,7568954,'013',50,1),(1075,7568957,7568955,'adm',33.333,4),(1075,7568958,7568955,'dmi',33.333,4),(1075,7568959,7568955,'min',33.333,4),(1075,7568960,7568957,'cap',16.667,1),(1075,7568961,7568957,'apa',16.667,1),(1075,7568962,7568957,'pac',16.667,1),(1075,7568963,7568957,'aci',16.667,1),(1075,7568964,7568957,'cit',16.667,1),(1075,7568965,7568957,'ity',16.667,1),(1075,7568966,7568960,'pat',50,1),(1075,7568967,7568960,'ath',50,1),(1075,7568968,7568966,'fre',14.286,1),(1075,7568969,7568966,'ree',14.286,1),(1075,7568970,7568966,'ees',14.286,1),(1075,7568971,7568966,'esp',14.286,1),(1075,7568972,7568966,'spa',14.286,1),(1075,7568973,7568966,'pac',14.286,1),(1075,7568974,7568966,'ace',14.286,1),(1075,7568975,7568968,'dis',50,1),(1075,7568976,7568968,'isk',50,1),(1075,7568977,7568975,'ind',33.333,1),(1075,7568978,7568975,'nde',33.333,1),(1075,7568979,7568975,'dex',33.333,1),(1075,7568980,7568977,'adm',8.333,1),(1075,7568981,7568977,'dmi',8.333,1),(1075,7568982,7568977,'min',8.333,1),(1075,7568983,7568977,'ini',8.333,1),(1075,7568984,7568977,'nis',8.333,1),(1075,7568985,7568977,'ist',8.333,1),(1075,7568986,7568977,'str',8.333,1),(1075,7568987,7568977,'tra',8.333,1),(1075,7568988,7568977,'rat',8.333,1),(1075,7568989,7568977,'ati',8.333,1),(1075,7568990,7568977,'tio',8.333,1),(1075,7568991,7568977,'ion',8.333,1),(1075,7568992,7568980,'sta',33.333,3),(1075,7568993,7568980,'tat',33.333,3),(1075,7568994,7568980,'ate',33.333,3),(1075,7568995,7568992,'dis',16.667,4),(1075,7568996,7568992,'isa',16.667,4),(1075,7568997,7568992,'sab',16.667,4),(1075,7568998,7568992,'abl',16.667,4),(1075,7568999,7568992,'ble',16.667,4),(1075,7569000,7568992,'led',16.667,4),(1075,7569001,7568995,'cac',33.333,1),(1075,7569002,7568995,'ach',33.333,1),(1075,7569003,7568995,'che',33.333,1),(1075,7569004,7569001,'mod',50,1),(1075,7569005,7569001,'ode',50,1),(1075,7569006,7569004,'wri',14.286,1),(1075,7569007,7569004,'rit',14.286,1),(1075,7569008,7569004,'ite',14.286,1),(1075,7569009,7569004,'tet',14.286,1),(1075,7569010,7569004,'eth',14.286,1),(1075,7569011,7569004,'thr',14.286,1),(1075,7569012,7569004,'hru',14.286,1),(1075,7569013,7569006,'ope',11.111,2),(1075,7569014,7569006,'per',11.111,2),(1075,7569015,7569006,'era',11.111,2),(1075,7569016,7569006,'rat',11.111,2),(1075,7569017,7569006,'ati',11.111,2),(1075,7569018,7569006,'tio',11.111,2),(1075,7569019,7569006,'ion',11.111,2),(1075,7569020,7569006,'ona',11.111,2),(1075,7569021,7569006,'nal',11.111,2),(1075,7569022,7569013,'mes',20,1),(1075,7569023,7569013,'ess',20,1),(1075,7569024,7569013,'ssa',20,1),(1075,7569025,7569013,'sag',20,1),(1075,7569026,7569013,'age',20,1),(1075,7569027,7569022,'per',11.111,1),(1075,7569028,7569022,'erf',11.111,1),(1075,7569029,7569022,'rfo',11.111,1),(1075,7569030,7569022,'for',11.111,1),(1075,7569031,7569022,'orm',11.111,1),(1075,7569032,7569022,'rma',11.111,1),(1075,7569033,7569022,'man',11.111,1),(1075,7569034,7569022,'anc',11.111,1),(1075,7569035,7569022,'nce',11.111,1),(1075,7569036,7569027,'ide',12.5,1),(1075,7569037,7569027,'den',12.5,1),(1075,7569038,7569027,'ent',12.5,1),(1075,7569039,7569027,'nti',12.5,1),(1075,7569040,7569027,'tif',12.5,1),(1075,7569041,7569027,'ifi',12.5,1),(1075,7569042,7569027,'fie',12.5,1),(1075,7569043,7569027,'ier',12.5,1),(1075,7569044,7569036,'vdi',33.333,3),(1075,7569045,7569036,'dis',33.333,3),(1075,7569046,7569036,'isk',33.333,3),(1075,7569047,7569044,'nam',50,1),(1075,7569048,7569044,'ame',50,1),(1075,7569049,7569047,'typ',50,1),(1075,7569050,7569047,'ype',50,1),(1075,7569051,7569049,'dir',25,1),(1075,7569052,7569049,'ire',25,1),(1075,7569053,7569049,'rec',25,1),(1075,7569054,7569049,'ect',25,1),(1076,7569056,7569055,'naa',100,2),(1076,7569057,7569056,'600',3.333,3),(1076,7569058,7569056,'000',3.333,3),(1076,7569059,7569056,'00c',3.333,3),(1076,7569060,7569056,'0c2',3.333,3),(1076,7569061,7569056,'c29',3.333,3),(1076,7569062,7569056,'299',3.333,3),(1076,7569063,7569056,'994',3.333,3),(1076,7569064,7569056,'94d',3.333,3),(1076,7569065,7569056,'4d7',3.333,3),(1076,7569066,7569056,'d73',3.333,3),(1076,7569067,7569056,'730',3.333,3),(1076,7569068,7569056,'30e',3.333,3),(1076,7569069,7569056,'0e8',3.333,3),(1076,7569070,7569056,'e86',3.333,3),(1076,7569071,7569056,'860',3.333,3),(1076,7569072,7569056,'606',3.333,3),(1076,7569073,7569056,'068',3.333,3),(1076,7569074,7569056,'68f',3.333,3),(1076,7569075,7569056,'8fa',3.333,3),(1076,7569076,7569056,'faa',3.333,3),(1076,7569077,7569056,'aa3',3.333,3),(1076,7569078,7569056,'a39',3.333,3),(1076,7569079,7569056,'39c',3.333,3),(1076,7569080,7569056,'9c7',3.333,3),(1076,7569081,7569056,'c7f',3.333,3),(1076,7569082,7569056,'7fc',3.333,3),(1076,7569083,7569056,'fc1',3.333,3),(1076,7569084,7569056,'c1c',3.333,3),(1076,7569085,7569056,'1cf',3.333,3),(1076,7569086,7569056,'cfa',3.333,3),(1076,7569087,7569057,'mon',100,1),(1076,7569088,7569087,'201',50,1),(1076,7569089,7569087,'013',50,1),(1076,7569090,7569088,'adm',33.333,4),(1076,7569091,7569088,'dmi',33.333,4),(1076,7569092,7569088,'min',33.333,4),(1076,7569093,7569090,'cap',16.667,1),(1076,7569094,7569090,'apa',16.667,1),(1076,7569095,7569090,'pac',16.667,1),(1076,7569096,7569090,'aci',16.667,1),(1076,7569097,7569090,'cit',16.667,1),(1076,7569098,7569090,'ity',16.667,1),(1076,7569099,7569093,'pat',50,1),(1076,7569100,7569093,'ath',50,1),(1076,7569101,7569099,'fre',14.286,1),(1076,7569102,7569099,'ree',14.286,1),(1076,7569103,7569099,'ees',14.286,1),(1076,7569104,7569099,'esp',14.286,1),(1076,7569105,7569099,'spa',14.286,1),(1076,7569106,7569099,'pac',14.286,1),(1076,7569107,7569099,'ace',14.286,1),(1076,7569108,7569101,'dis',50,1),(1076,7569109,7569101,'isk',50,1),(1076,7569110,7569108,'ind',33.333,1),(1076,7569111,7569108,'nde',33.333,1),(1076,7569112,7569108,'dex',33.333,1),(1076,7569113,7569110,'adm',8.333,1),(1076,7569114,7569110,'dmi',8.333,1),(1076,7569115,7569110,'min',8.333,1),(1076,7569116,7569110,'ini',8.333,1),(1076,7569117,7569110,'nis',8.333,1),(1076,7569118,7569110,'ist',8.333,1),(1076,7569119,7569110,'str',8.333,1),(1076,7569120,7569110,'tra',8.333,1),(1076,7569121,7569110,'rat',8.333,1),(1076,7569122,7569110,'ati',8.333,1),(1076,7569123,7569110,'tio',8.333,1),(1076,7569124,7569110,'ion',8.333,1),(1076,7569125,7569113,'sta',33.333,3),(1076,7569126,7569113,'tat',33.333,3),(1076,7569127,7569113,'ate',33.333,3),(1076,7569128,7569125,'dis',16.667,4),(1076,7569129,7569125,'isa',16.667,4),(1076,7569130,7569125,'sab',16.667,4),(1076,7569131,7569125,'abl',16.667,4),(1076,7569132,7569125,'ble',16.667,4),(1076,7569133,7569125,'led',16.667,4),(1076,7569134,7569128,'cac',33.333,1),(1076,7569135,7569128,'ach',33.333,1),(1076,7569136,7569128,'che',33.333,1),(1076,7569137,7569134,'mod',50,1),(1076,7569138,7569134,'ode',50,1),(1076,7569139,7569137,'wri',14.286,1),(1076,7569140,7569137,'rit',14.286,1),(1076,7569141,7569137,'ite',14.286,1),(1076,7569142,7569137,'tet',14.286,1),(1076,7569143,7569137,'eth',14.286,1),(1076,7569144,7569137,'thr',14.286,1),(1076,7569145,7569137,'hru',14.286,1),(1076,7569146,7569139,'ope',11.111,2),(1076,7569147,7569139,'per',11.111,2),(1076,7569148,7569139,'era',11.111,2),(1076,7569149,7569139,'rat',11.111,2),(1076,7569150,7569139,'ati',11.111,2),(1076,7569151,7569139,'tio',11.111,2),(1076,7569152,7569139,'ion',11.111,2),(1076,7569153,7569139,'ona',11.111,2),(1076,7569154,7569139,'nal',11.111,2),(1076,7569155,7569146,'mes',20,1),(1076,7569156,7569146,'ess',20,1),(1076,7569157,7569146,'ssa',20,1),(1076,7569158,7569146,'sag',20,1),(1076,7569159,7569146,'age',20,1),(1076,7569160,7569155,'per',11.111,1),(1076,7569161,7569155,'erf',11.111,1),(1076,7569162,7569155,'rfo',11.111,1),(1076,7569163,7569155,'for',11.111,1),(1076,7569164,7569155,'orm',11.111,1),(1076,7569165,7569155,'rma',11.111,1),(1076,7569166,7569155,'man',11.111,1),(1076,7569167,7569155,'anc',11.111,1),(1076,7569168,7569155,'nce',11.111,1),(1076,7569169,7569160,'ide',12.5,1),(1076,7569170,7569160,'den',12.5,1),(1076,7569171,7569160,'ent',12.5,1),(1076,7569172,7569160,'nti',12.5,1),(1076,7569173,7569160,'tif',12.5,1),(1076,7569174,7569160,'ifi',12.5,1),(1076,7569175,7569160,'fie',12.5,1),(1076,7569176,7569160,'ier',12.5,1),(1076,7569177,7569169,'vdi',33.333,3),(1076,7569178,7569169,'dis',33.333,3),(1076,7569179,7569169,'isk',33.333,3),(1076,7569180,7569177,'nam',50,1),(1076,7569181,7569177,'ame',50,1),(1076,7569182,7569180,'typ',50,1),(1076,7569183,7569180,'ype',50,1),(1076,7569184,7569182,'dir',25,1),(1076,7569185,7569182,'ire',25,1),(1076,7569186,7569182,'rec',25,1),(1076,7569187,7569182,'ect',25,1),(1077,7569189,7569188,'naa',100,2),(1077,7569190,7569189,'600',3.333,3),(1077,7569191,7569189,'000',3.333,3),(1077,7569192,7569189,'00c',3.333,3),(1077,7569193,7569189,'0c2',3.333,3),(1077,7569194,7569189,'c29',3.333,3),(1077,7569195,7569189,'299',3.333,3),(1077,7569196,7569189,'99b',3.333,3),(1077,7569197,7569189,'9b9',3.333,3),(1077,7569198,7569189,'b93',3.333,3),(1077,7569199,7569189,'935',3.333,3),(1077,7569200,7569189,'350',3.333,3),(1077,7569201,7569189,'501',3.333,3),(1077,7569202,7569189,'01d',3.333,3),(1077,7569203,7569189,'1d1',3.333,3),(1077,7569204,7569189,'d1f',3.333,3),(1077,7569205,7569189,'1fd',3.333,3),(1077,7569206,7569189,'fd2',3.333,3),(1077,7569207,7569189,'d28',3.333,3),(1077,7569208,7569189,'281',3.333,3),(1077,7569209,7569189,'813',3.333,3),(1077,7569210,7569189,'130',3.333,3),(1077,7569211,7569189,'30f',3.333,3),(1077,7569212,7569189,'0fe',3.333,3),(1077,7569213,7569189,'fe3',3.333,3),(1077,7569214,7569189,'e3a',3.333,3),(1077,7569215,7569189,'3a1',3.333,3),(1077,7569216,7569189,'a12',3.333,3),(1077,7569217,7569189,'12c',3.333,3),(1077,7569218,7569189,'2c7',3.333,3),(1077,7569219,7569189,'c7d',3.333,3),(1077,7569220,7569190,'mon',100,1),(1077,7569221,7569220,'201',50,1),(1077,7569222,7569220,'013',50,1),(1077,7569223,7569221,'adm',33.333,4),(1077,7569224,7569221,'dmi',33.333,4),(1077,7569225,7569221,'min',33.333,4),(1077,7569226,7569223,'cap',16.667,1),(1077,7569227,7569223,'apa',16.667,1),(1077,7569228,7569223,'pac',16.667,1),(1077,7569229,7569223,'aci',16.667,1),(1077,7569230,7569223,'cit',16.667,1),(1077,7569231,7569223,'ity',16.667,1),(1077,7569232,7569226,'pat',50,1),(1077,7569233,7569226,'ath',50,1),(1077,7569234,7569232,'fre',14.286,1),(1077,7569235,7569232,'ree',14.286,1),(1077,7569236,7569232,'ees',14.286,1),(1077,7569237,7569232,'esp',14.286,1),(1077,7569238,7569232,'spa',14.286,1),(1077,7569239,7569232,'pac',14.286,1),(1077,7569240,7569232,'ace',14.286,1),(1077,7569241,7569234,'dis',50,1),(1077,7569242,7569234,'isk',50,1),(1077,7569243,7569241,'ind',33.333,1),(1077,7569244,7569241,'nde',33.333,1),(1077,7569245,7569241,'dex',33.333,1),(1077,7569246,7569243,'adm',8.333,1),(1077,7569247,7569243,'dmi',8.333,1),(1077,7569248,7569243,'min',8.333,1),(1077,7569249,7569243,'ini',8.333,1),(1077,7569250,7569243,'nis',8.333,1),(1077,7569251,7569243,'ist',8.333,1),(1077,7569252,7569243,'str',8.333,1),(1077,7569253,7569243,'tra',8.333,1),(1077,7569254,7569243,'rat',8.333,1),(1077,7569255,7569243,'ati',8.333,1),(1077,7569256,7569243,'tio',8.333,1),(1077,7569257,7569243,'ion',8.333,1),(1077,7569258,7569246,'sta',33.333,3),(1077,7569259,7569246,'tat',33.333,3),(1077,7569260,7569246,'ate',33.333,3),(1077,7569261,7569258,'dis',16.667,4),(1077,7569262,7569258,'isa',16.667,4),(1077,7569263,7569258,'sab',16.667,4),(1077,7569264,7569258,'abl',16.667,4),(1077,7569265,7569258,'ble',16.667,4),(1077,7569266,7569258,'led',16.667,4),(1077,7569267,7569261,'cac',33.333,1),(1077,7569268,7569261,'ach',33.333,1),(1077,7569269,7569261,'che',33.333,1),(1077,7569270,7569267,'mod',50,1),(1077,7569271,7569267,'ode',50,1),(1077,7569272,7569270,'wri',14.286,1),(1077,7569273,7569270,'rit',14.286,1),(1077,7569274,7569270,'ite',14.286,1),(1077,7569275,7569270,'tet',14.286,1),(1077,7569276,7569270,'eth',14.286,1),(1077,7569277,7569270,'thr',14.286,1),(1077,7569278,7569270,'hru',14.286,1),(1077,7569279,7569272,'ope',11.111,2),(1077,7569280,7569272,'per',11.111,2),(1077,7569281,7569272,'era',11.111,2),(1077,7569282,7569272,'rat',11.111,2),(1077,7569283,7569272,'ati',11.111,2),(1077,7569284,7569272,'tio',11.111,2),(1077,7569285,7569272,'ion',11.111,2),(1077,7569286,7569272,'ona',11.111,2),(1077,7569287,7569272,'nal',11.111,2),(1077,7569288,7569279,'mes',20,1),(1077,7569289,7569279,'ess',20,1),(1077,7569290,7569279,'ssa',20,1),(1077,7569291,7569279,'sag',20,1),(1077,7569292,7569279,'age',20,1),(1077,7569293,7569288,'per',11.111,1),(1077,7569294,7569288,'erf',11.111,1),(1077,7569295,7569288,'rfo',11.111,1),(1077,7569296,7569288,'for',11.111,1),(1077,7569297,7569288,'orm',11.111,1),(1077,7569298,7569288,'rma',11.111,1),(1077,7569299,7569288,'man',11.111,1),(1077,7569300,7569288,'anc',11.111,1),(1077,7569301,7569288,'nce',11.111,1),(1077,7569302,7569293,'ide',12.5,1),(1077,7569303,7569293,'den',12.5,1),(1077,7569304,7569293,'ent',12.5,1),(1077,7569305,7569293,'nti',12.5,1),(1077,7569306,7569293,'tif',12.5,1),(1077,7569307,7569293,'ifi',12.5,1),(1077,7569308,7569293,'fie',12.5,1),(1077,7569309,7569293,'ier',12.5,1),(1077,7569310,7569302,'vdi',33.333,3),(1077,7569311,7569302,'dis',33.333,3),(1077,7569312,7569302,'isk',33.333,3),(1077,7569313,7569310,'nam',50,1),(1077,7569314,7569310,'ame',50,1),(1077,7569315,7569313,'typ',50,1),(1077,7569316,7569313,'ype',50,1),(1077,7569317,7569315,'dir',25,1),(1077,7569318,7569315,'ire',25,1),(1077,7569319,7569315,'rec',25,1),(1077,7569320,7569315,'ect',25,1),(1078,7569322,7569321,'naa',100,2),(1078,7569323,7569322,'600',3.333,3),(1078,7569324,7569322,'000',3.333,3),(1078,7569325,7569322,'00c',3.333,3),(1078,7569326,7569322,'0c2',3.333,3),(1078,7569327,7569322,'c29',3.333,3),(1078,7569328,7569322,'29e',3.333,3),(1078,7569329,7569322,'9ee',3.333,3),(1078,7569330,7569322,'eee',3.333,3),(1078,7569331,7569322,'ee0',3.333,3),(1078,7569332,7569322,'e0f',3.333,3),(1078,7569333,7569322,'0f3',3.333,3),(1078,7569334,7569322,'f3e',3.333,3),(1078,7569335,7569322,'3ef',3.333,3),(1078,7569336,7569322,'efd',3.333,3),(1078,7569337,7569322,'fd2',3.333,3),(1078,7569338,7569322,'d24',3.333,3),(1078,7569339,7569322,'24f',3.333,3),(1078,7569340,7569322,'4fd',3.333,3),(1078,7569341,7569322,'fde',3.333,3),(1078,7569342,7569322,'def',3.333,3),(1078,7569343,7569322,'efe',3.333,3),(1078,7569344,7569322,'fed',3.333,3),(1078,7569345,7569322,'ed6',3.333,3),(1078,7569346,7569322,'d6b',3.333,3),(1078,7569347,7569322,'6b5',3.333,3),(1078,7569348,7569322,'b51',3.333,3),(1078,7569349,7569322,'512',3.333,3),(1078,7569350,7569322,'12c',3.333,3),(1078,7569351,7569322,'2c7',3.333,3),(1078,7569352,7569322,'c7f',3.333,3),(1078,7569353,7569323,'mon',100,1),(1078,7569354,7569353,'201',50,1),(1078,7569355,7569353,'013',50,1),(1078,7569356,7569354,'adm',33.333,4),(1078,7569357,7569354,'dmi',33.333,4),(1078,7569358,7569354,'min',33.333,4),(1078,7569359,7569356,'cap',16.667,1),(1078,7569360,7569356,'apa',16.667,1),(1078,7569361,7569356,'pac',16.667,1),(1078,7569362,7569356,'aci',16.667,1),(1078,7569363,7569356,'cit',16.667,1),(1078,7569364,7569356,'ity',16.667,1),(1078,7569365,7569359,'pat',50,1),(1078,7569366,7569359,'ath',50,1),(1078,7569367,7569365,'fre',14.286,1),(1078,7569368,7569365,'ree',14.286,1),(1078,7569369,7569365,'ees',14.286,1),(1078,7569370,7569365,'esp',14.286,1),(1078,7569371,7569365,'spa',14.286,1),(1078,7569372,7569365,'pac',14.286,1),(1078,7569373,7569365,'ace',14.286,1),(1078,7569374,7569367,'dis',50,1),(1078,7569375,7569367,'isk',50,1),(1078,7569376,7569374,'ind',33.333,1),(1078,7569377,7569374,'nde',33.333,1),(1078,7569378,7569374,'dex',33.333,1),(1078,7569379,7569376,'adm',8.333,1),(1078,7569380,7569376,'dmi',8.333,1),(1078,7569381,7569376,'min',8.333,1),(1078,7569382,7569376,'ini',8.333,1),(1078,7569383,7569376,'nis',8.333,1),(1078,7569384,7569376,'ist',8.333,1),(1078,7569385,7569376,'str',8.333,1),(1078,7569386,7569376,'tra',8.333,1),(1078,7569387,7569376,'rat',8.333,1),(1078,7569388,7569376,'ati',8.333,1),(1078,7569389,7569376,'tio',8.333,1),(1078,7569390,7569376,'ion',8.333,1),(1078,7569391,7569379,'sta',33.333,3),(1078,7569392,7569379,'tat',33.333,3),(1078,7569393,7569379,'ate',33.333,3),(1078,7569394,7569391,'dis',16.667,4),(1078,7569395,7569391,'isa',16.667,4),(1078,7569396,7569391,'sab',16.667,4),(1078,7569397,7569391,'abl',16.667,4),(1078,7569398,7569391,'ble',16.667,4),(1078,7569399,7569391,'led',16.667,4),(1078,7569400,7569394,'cac',33.333,1),(1078,7569401,7569394,'ach',33.333,1),(1078,7569402,7569394,'che',33.333,1),(1078,7569403,7569400,'mod',50,1),(1078,7569404,7569400,'ode',50,1),(1078,7569405,7569403,'wri',14.286,1),(1078,7569406,7569403,'rit',14.286,1),(1078,7569407,7569403,'ite',14.286,1),(1078,7569408,7569403,'tet',14.286,1),(1078,7569409,7569403,'eth',14.286,1),(1078,7569410,7569403,'thr',14.286,1),(1078,7569411,7569403,'hru',14.286,1),(1078,7569412,7569405,'ope',11.111,2),(1078,7569413,7569405,'per',11.111,2),(1078,7569414,7569405,'era',11.111,2),(1078,7569415,7569405,'rat',11.111,2),(1078,7569416,7569405,'ati',11.111,2),(1078,7569417,7569405,'tio',11.111,2),(1078,7569418,7569405,'ion',11.111,2),(1078,7569419,7569405,'ona',11.111,2),(1078,7569420,7569405,'nal',11.111,2),(1078,7569421,7569412,'mes',20,1),(1078,7569422,7569412,'ess',20,1),(1078,7569423,7569412,'ssa',20,1),(1078,7569424,7569412,'sag',20,1),(1078,7569425,7569412,'age',20,1),(1078,7569426,7569421,'per',11.111,1),(1078,7569427,7569421,'erf',11.111,1),(1078,7569428,7569421,'rfo',11.111,1),(1078,7569429,7569421,'for',11.111,1),(1078,7569430,7569421,'orm',11.111,1),(1078,7569431,7569421,'rma',11.111,1),(1078,7569432,7569421,'man',11.111,1),(1078,7569433,7569421,'anc',11.111,1),(1078,7569434,7569421,'nce',11.111,1),(1078,7569435,7569426,'ide',12.5,1),(1078,7569436,7569426,'den',12.5,1),(1078,7569437,7569426,'ent',12.5,1),(1078,7569438,7569426,'nti',12.5,1),(1078,7569439,7569426,'tif',12.5,1),(1078,7569440,7569426,'ifi',12.5,1),(1078,7569441,7569426,'fie',12.5,1),(1078,7569442,7569426,'ier',12.5,1),(1078,7569443,7569435,'vdi',33.333,3),(1078,7569444,7569435,'dis',33.333,3),(1078,7569445,7569435,'isk',33.333,3),(1078,7569446,7569443,'nam',50,1),(1078,7569447,7569443,'ame',50,1),(1078,7569448,7569446,'typ',50,1),(1078,7569449,7569446,'ype',50,1),(1078,7569450,7569448,'dir',25,1),(1078,7569451,7569448,'ire',25,1),(1078,7569452,7569448,'rec',25,1),(1078,7569453,7569448,'ect',25,1),(1079,7569455,7569454,'naa',100,2),(1079,7569456,7569455,'600',3.333,3),(1079,7569457,7569455,'000',3.333,3),(1079,7569458,7569455,'00c',3.333,3),(1079,7569459,7569455,'0c2',3.333,3),(1079,7569460,7569455,'c29',3.333,3),(1079,7569461,7569455,'299',3.333,3),(1079,7569462,7569455,'99f',3.333,3),(1079,7569463,7569455,'9f5',3.333,3),(1079,7569464,7569455,'f52',3.333,3),(1079,7569465,7569455,'528',3.333,3),(1079,7569466,7569455,'283',3.333,3),(1079,7569467,7569455,'838',3.333,3),(1079,7569468,7569455,'388',3.333,3),(1079,7569469,7569455,'885',3.333,3),(1079,7569470,7569455,'856',3.333,3),(1079,7569471,7569455,'566',3.333,3),(1079,7569472,7569455,'66e',3.333,3),(1079,7569473,7569455,'6ee',3.333,3),(1079,7569474,7569455,'ee8',3.333,3),(1079,7569475,7569455,'e86',3.333,3),(1079,7569476,7569455,'868',3.333,3),(1079,7569477,7569455,'686',3.333,3),(1079,7569478,7569455,'868',3.333,3),(1079,7569479,7569455,'68e',3.333,3),(1079,7569480,7569455,'8ed',3.333,3),(1079,7569481,7569455,'ed0',3.333,3),(1079,7569482,7569455,'d0e',3.333,3),(1079,7569483,7569455,'0e4',3.333,3),(1079,7569484,7569455,'e48',3.333,3),(1079,7569485,7569455,'488',3.333,3),(1079,7569486,7569456,'mon',100,1),(1079,7569487,7569486,'201',50,1),(1079,7569488,7569486,'013',50,1),(1079,7569489,7569487,'adm',33.333,4),(1079,7569490,7569487,'dmi',33.333,4),(1079,7569491,7569487,'min',33.333,4),(1079,7569492,7569489,'cap',16.667,1),(1079,7569493,7569489,'apa',16.667,1),(1079,7569494,7569489,'pac',16.667,1),(1079,7569495,7569489,'aci',16.667,1),(1079,7569496,7569489,'cit',16.667,1),(1079,7569497,7569489,'ity',16.667,1),(1079,7569498,7569492,'pat',50,1),(1079,7569499,7569492,'ath',50,1),(1079,7569500,7569498,'fre',14.286,1),(1079,7569501,7569498,'ree',14.286,1),(1079,7569502,7569498,'ees',14.286,1),(1079,7569503,7569498,'esp',14.286,1),(1079,7569504,7569498,'spa',14.286,1),(1079,7569505,7569498,'pac',14.286,1),(1079,7569506,7569498,'ace',14.286,1),(1079,7569507,7569500,'dis',50,1),(1079,7569508,7569500,'isk',50,1),(1079,7569509,7569507,'ind',33.333,1),(1079,7569510,7569507,'nde',33.333,1),(1079,7569511,7569507,'dex',33.333,1),(1079,7569512,7569509,'adm',8.333,1),(1079,7569513,7569509,'dmi',8.333,1),(1079,7569514,7569509,'min',8.333,1),(1079,7569515,7569509,'ini',8.333,1),(1079,7569516,7569509,'nis',8.333,1),(1079,7569517,7569509,'ist',8.333,1),(1079,7569518,7569509,'str',8.333,1),(1079,7569519,7569509,'tra',8.333,1),(1079,7569520,7569509,'rat',8.333,1),(1079,7569521,7569509,'ati',8.333,1),(1079,7569522,7569509,'tio',8.333,1),(1079,7569523,7569509,'ion',8.333,1),(1079,7569524,7569512,'sta',33.333,3),(1079,7569525,7569512,'tat',33.333,3),(1079,7569526,7569512,'ate',33.333,3),(1079,7569527,7569524,'dis',16.667,4),(1079,7569528,7569524,'isa',16.667,4),(1079,7569529,7569524,'sab',16.667,4),(1079,7569530,7569524,'abl',16.667,4),(1079,7569531,7569524,'ble',16.667,4),(1079,7569532,7569524,'led',16.667,4),(1079,7569533,7569527,'cac',33.333,1),(1079,7569534,7569527,'ach',33.333,1),(1079,7569535,7569527,'che',33.333,1),(1079,7569536,7569533,'mod',50,1),(1079,7569537,7569533,'ode',50,1),(1079,7569538,7569536,'wri',14.286,1),(1079,7569539,7569536,'rit',14.286,1),(1079,7569540,7569536,'ite',14.286,1),(1079,7569541,7569536,'tet',14.286,1),(1079,7569542,7569536,'eth',14.286,1),(1079,7569543,7569536,'thr',14.286,1),(1079,7569544,7569536,'hru',14.286,1),(1079,7569545,7569538,'ope',11.111,2),(1079,7569546,7569538,'per',11.111,2),(1079,7569547,7569538,'era',11.111,2),(1079,7569548,7569538,'rat',11.111,2),(1079,7569549,7569538,'ati',11.111,2),(1079,7569550,7569538,'tio',11.111,2),(1079,7569551,7569538,'ion',11.111,2),(1079,7569552,7569538,'ona',11.111,2),(1079,7569553,7569538,'nal',11.111,2),(1079,7569554,7569545,'mes',20,1),(1079,7569555,7569545,'ess',20,1),(1079,7569556,7569545,'ssa',20,1),(1079,7569557,7569545,'sag',20,1),(1079,7569558,7569545,'age',20,1),(1079,7569559,7569554,'per',11.111,1),(1079,7569560,7569554,'erf',11.111,1),(1079,7569561,7569554,'rfo',11.111,1),(1079,7569562,7569554,'for',11.111,1),(1079,7569563,7569554,'orm',11.111,1),(1079,7569564,7569554,'rma',11.111,1),(1079,7569565,7569554,'man',11.111,1),(1079,7569566,7569554,'anc',11.111,1),(1079,7569567,7569554,'nce',11.111,1),(1079,7569568,7569559,'ide',12.5,1),(1079,7569569,7569559,'den',12.5,1),(1079,7569570,7569559,'ent',12.5,1),(1079,7569571,7569559,'nti',12.5,1),(1079,7569572,7569559,'tif',12.5,1),(1079,7569573,7569559,'ifi',12.5,1),(1079,7569574,7569559,'fie',12.5,1),(1079,7569575,7569559,'ier',12.5,1),(1079,7569576,7569568,'vdi',33.333,3),(1079,7569577,7569568,'dis',33.333,3),(1079,7569578,7569568,'isk',33.333,3),(1079,7569579,7569576,'nam',50,1),(1079,7569580,7569576,'ame',50,1),(1079,7569581,7569579,'typ',50,1),(1079,7569582,7569579,'ype',50,1),(1079,7569583,7569581,'dir',25,1),(1079,7569584,7569581,'ire',25,1),(1079,7569585,7569581,'rec',25,1),(1079,7569586,7569581,'ect',25,1),(1080,7569588,7569587,'naa',100,2),(1080,7569589,7569588,'600',3.333,3),(1080,7569590,7569588,'000',3.333,3),(1080,7569591,7569588,'00c',3.333,3),(1080,7569592,7569588,'0c2',3.333,3),(1080,7569593,7569588,'c29',3.333,3),(1080,7569594,7569588,'292',3.333,3),(1080,7569595,7569588,'926',3.333,3),(1080,7569596,7569588,'26e',3.333,3),(1080,7569597,7569588,'6e5',3.333,3),(1080,7569598,7569588,'e5b',3.333,3),(1080,7569599,7569588,'5b1',3.333,3),(1080,7569600,7569588,'b17',3.333,3),(1080,7569601,7569588,'176',3.333,3),(1080,7569602,7569588,'768',3.333,3),(1080,7569603,7569588,'68c',3.333,3),(1080,7569604,7569588,'8ce',3.333,3),(1080,7569605,7569588,'ce4',3.333,3),(1080,7569606,7569588,'e41',3.333,3),(1080,7569607,7569588,'410',3.333,3),(1080,7569608,7569588,'106',3.333,3),(1080,7569609,7569588,'06b',3.333,3),(1080,7569610,7569588,'6b6',3.333,3),(1080,7569611,7569588,'b68',3.333,3),(1080,7569612,7569588,'68f',3.333,3),(1080,7569613,7569588,'8fa',3.333,3),(1080,7569614,7569588,'fa7',3.333,3),(1080,7569615,7569588,'a70',3.333,3),(1080,7569616,7569588,'703',3.333,3),(1080,7569617,7569588,'030',3.333,3),(1080,7569618,7569588,'300',3.333,3),(1080,7569619,7569589,'mon',100,1),(1080,7569620,7569619,'201',50,1),(1080,7569621,7569619,'013',50,1),(1080,7569622,7569620,'adm',33.333,4),(1080,7569623,7569620,'dmi',33.333,4),(1080,7569624,7569620,'min',33.333,4),(1080,7569625,7569622,'cap',16.667,1),(1080,7569626,7569622,'apa',16.667,1),(1080,7569627,7569622,'pac',16.667,1),(1080,7569628,7569622,'aci',16.667,1),(1080,7569629,7569622,'cit',16.667,1),(1080,7569630,7569622,'ity',16.667,1),(1080,7569631,7569625,'pat',50,1),(1080,7569632,7569625,'ath',50,1),(1080,7569633,7569631,'fre',14.286,1),(1080,7569634,7569631,'ree',14.286,1),(1080,7569635,7569631,'ees',14.286,1),(1080,7569636,7569631,'esp',14.286,1),(1080,7569637,7569631,'spa',14.286,1),(1080,7569638,7569631,'pac',14.286,1),(1080,7569639,7569631,'ace',14.286,1),(1080,7569640,7569633,'dis',50,1),(1080,7569641,7569633,'isk',50,1),(1080,7569642,7569640,'ind',33.333,1),(1080,7569643,7569640,'nde',33.333,1),(1080,7569644,7569640,'dex',33.333,1),(1080,7569645,7569642,'adm',8.333,1),(1080,7569646,7569642,'dmi',8.333,1),(1080,7569647,7569642,'min',8.333,1),(1080,7569648,7569642,'ini',8.333,1),(1080,7569649,7569642,'nis',8.333,1),(1080,7569650,7569642,'ist',8.333,1),(1080,7569651,7569642,'str',8.333,1),(1080,7569652,7569642,'tra',8.333,1),(1080,7569653,7569642,'rat',8.333,1),(1080,7569654,7569642,'ati',8.333,1),(1080,7569655,7569642,'tio',8.333,1),(1080,7569656,7569642,'ion',8.333,1),(1080,7569657,7569645,'sta',33.333,3),(1080,7569658,7569645,'tat',33.333,3),(1080,7569659,7569645,'ate',33.333,3),(1080,7569660,7569657,'dis',16.667,4),(1080,7569661,7569657,'isa',16.667,4),(1080,7569662,7569657,'sab',16.667,4),(1080,7569663,7569657,'abl',16.667,4),(1080,7569664,7569657,'ble',16.667,4),(1080,7569665,7569657,'led',16.667,4),(1080,7569666,7569660,'cac',33.333,1),(1080,7569667,7569660,'ach',33.333,1),(1080,7569668,7569660,'che',33.333,1),(1080,7569669,7569666,'mod',50,1),(1080,7569670,7569666,'ode',50,1),(1080,7569671,7569669,'wri',14.286,1),(1080,7569672,7569669,'rit',14.286,1),(1080,7569673,7569669,'ite',14.286,1),(1080,7569674,7569669,'tet',14.286,1),(1080,7569675,7569669,'eth',14.286,1),(1080,7569676,7569669,'thr',14.286,1),(1080,7569677,7569669,'hru',14.286,1),(1080,7569678,7569671,'ope',11.111,2),(1080,7569679,7569671,'per',11.111,2),(1080,7569680,7569671,'era',11.111,2),(1080,7569681,7569671,'rat',11.111,2),(1080,7569682,7569671,'ati',11.111,2),(1080,7569683,7569671,'tio',11.111,2),(1080,7569684,7569671,'ion',11.111,2),(1080,7569685,7569671,'ona',11.111,2),(1080,7569686,7569671,'nal',11.111,2),(1080,7569687,7569678,'mes',20,1),(1080,7569688,7569678,'ess',20,1),(1080,7569689,7569678,'ssa',20,1),(1080,7569690,7569678,'sag',20,1),(1080,7569691,7569678,'age',20,1),(1080,7569692,7569687,'per',11.111,1),(1080,7569693,7569687,'erf',11.111,1),(1080,7569694,7569687,'rfo',11.111,1),(1080,7569695,7569687,'for',11.111,1),(1080,7569696,7569687,'orm',11.111,1),(1080,7569697,7569687,'rma',11.111,1),(1080,7569698,7569687,'man',11.111,1),(1080,7569699,7569687,'anc',11.111,1),(1080,7569700,7569687,'nce',11.111,1),(1080,7569701,7569692,'ide',12.5,1),(1080,7569702,7569692,'den',12.5,1),(1080,7569703,7569692,'ent',12.5,1),(1080,7569704,7569692,'nti',12.5,1),(1080,7569705,7569692,'tif',12.5,1),(1080,7569706,7569692,'ifi',12.5,1),(1080,7569707,7569692,'fie',12.5,1),(1080,7569708,7569692,'ier',12.5,1),(1080,7569709,7569701,'vdi',33.333,3),(1080,7569710,7569701,'dis',33.333,3),(1080,7569711,7569701,'isk',33.333,3),(1080,7569712,7569709,'nam',50,1),(1080,7569713,7569709,'ame',50,1),(1080,7569714,7569712,'typ',50,1),(1080,7569715,7569712,'ype',50,1),(1080,7569716,7569714,'dir',25,1),(1080,7569717,7569714,'ire',25,1),(1080,7569718,7569714,'rec',25,1),(1080,7569719,7569714,'ect',25,1),(1081,7569721,7569720,'naa',100,2),(1081,7569722,7569721,'600',3.333,3),(1081,7569723,7569721,'000',3.333,3),(1081,7569724,7569721,'00c',3.333,3),(1081,7569725,7569721,'0c2',3.333,3),(1081,7569726,7569721,'c29',3.333,3),(1081,7569727,7569721,'293',3.333,3),(1081,7569728,7569721,'93d',3.333,3),(1081,7569729,7569721,'3d1',3.333,3),(1081,7569730,7569721,'d14',3.333,3),(1081,7569731,7569721,'148',3.333,3),(1081,7569732,7569721,'488',3.333,3),(1081,7569733,7569721,'88e',3.333,3),(1081,7569734,7569721,'8eb',3.333,3),(1081,7569735,7569721,'ebc',3.333,3),(1081,7569736,7569721,'bc4',3.333,3),(1081,7569737,7569721,'c48',3.333,3),(1081,7569738,7569721,'484',3.333,3),(1081,7569739,7569721,'845',3.333,3),(1081,7569740,7569721,'453',3.333,3),(1081,7569741,7569721,'538',3.333,3),(1081,7569742,7569721,'386',3.333,3),(1081,7569743,7569721,'860',3.333,3),(1081,7569744,7569721,'603',3.333,3),(1081,7569745,7569721,'031',3.333,3),(1081,7569746,7569721,'311',3.333,3),(1081,7569747,7569721,'11c',3.333,3),(1081,7569748,7569721,'1c1',3.333,3),(1081,7569749,7569721,'c18',3.333,3),(1081,7569750,7569721,'18f',3.333,3),(1081,7569751,7569721,'8f9',3.333,3),(1081,7569752,7569722,'mon',100,1),(1081,7569753,7569752,'201',50,1),(1081,7569754,7569752,'013',50,1),(1081,7569755,7569753,'adm',33.333,4),(1081,7569756,7569753,'dmi',33.333,4),(1081,7569757,7569753,'min',33.333,4),(1081,7569758,7569755,'cap',16.667,1),(1081,7569759,7569755,'apa',16.667,1),(1081,7569760,7569755,'pac',16.667,1),(1081,7569761,7569755,'aci',16.667,1),(1081,7569762,7569755,'cit',16.667,1),(1081,7569763,7569755,'ity',16.667,1),(1081,7569764,7569758,'pat',50,1),(1081,7569765,7569758,'ath',50,1),(1081,7569766,7569764,'fre',14.286,1),(1081,7569767,7569764,'ree',14.286,1),(1081,7569768,7569764,'ees',14.286,1),(1081,7569769,7569764,'esp',14.286,1),(1081,7569770,7569764,'spa',14.286,1),(1081,7569771,7569764,'pac',14.286,1),(1081,7569772,7569764,'ace',14.286,1),(1081,7569773,7569766,'dis',50,1),(1081,7569774,7569766,'isk',50,1),(1081,7569775,7569773,'ind',33.333,1),(1081,7569776,7569773,'nde',33.333,1),(1081,7569777,7569773,'dex',33.333,1),(1081,7569778,7569775,'adm',8.333,1),(1081,7569779,7569775,'dmi',8.333,1),(1081,7569780,7569775,'min',8.333,1),(1081,7569781,7569775,'ini',8.333,1),(1081,7569782,7569775,'nis',8.333,1),(1081,7569783,7569775,'ist',8.333,1),(1081,7569784,7569775,'str',8.333,1),(1081,7569785,7569775,'tra',8.333,1),(1081,7569786,7569775,'rat',8.333,1),(1081,7569787,7569775,'ati',8.333,1),(1081,7569788,7569775,'tio',8.333,1),(1081,7569789,7569775,'ion',8.333,1),(1081,7569790,7569778,'sta',33.333,3),(1081,7569791,7569778,'tat',33.333,3),(1081,7569792,7569778,'ate',33.333,3),(1081,7569793,7569790,'dis',16.667,4),(1081,7569794,7569790,'isa',16.667,4),(1081,7569795,7569790,'sab',16.667,4),(1081,7569796,7569790,'abl',16.667,4),(1081,7569797,7569790,'ble',16.667,4),(1081,7569798,7569790,'led',16.667,4),(1081,7569799,7569793,'cac',33.333,1),(1081,7569800,7569793,'ach',33.333,1),(1081,7569801,7569793,'che',33.333,1),(1081,7569802,7569799,'mod',50,1),(1081,7569803,7569799,'ode',50,1),(1081,7569804,7569802,'wri',14.286,1),(1081,7569805,7569802,'rit',14.286,1),(1081,7569806,7569802,'ite',14.286,1),(1081,7569807,7569802,'tet',14.286,1),(1081,7569808,7569802,'eth',14.286,1),(1081,7569809,7569802,'thr',14.286,1),(1081,7569810,7569802,'hru',14.286,1),(1081,7569811,7569804,'ope',11.111,2),(1081,7569812,7569804,'per',11.111,2),(1081,7569813,7569804,'era',11.111,2),(1081,7569814,7569804,'rat',11.111,2),(1081,7569815,7569804,'ati',11.111,2),(1081,7569816,7569804,'tio',11.111,2),(1081,7569817,7569804,'ion',11.111,2),(1081,7569818,7569804,'ona',11.111,2),(1081,7569819,7569804,'nal',11.111,2),(1081,7569820,7569811,'mes',20,1),(1081,7569821,7569811,'ess',20,1),(1081,7569822,7569811,'ssa',20,1),(1081,7569823,7569811,'sag',20,1),(1081,7569824,7569811,'age',20,1),(1081,7569825,7569820,'per',11.111,1),(1081,7569826,7569820,'erf',11.111,1),(1081,7569827,7569820,'rfo',11.111,1),(1081,7569828,7569820,'for',11.111,1),(1081,7569829,7569820,'orm',11.111,1),(1081,7569830,7569820,'rma',11.111,1),(1081,7569831,7569820,'man',11.111,1),(1081,7569832,7569820,'anc',11.111,1),(1081,7569833,7569820,'nce',11.111,1),(1081,7569834,7569825,'ide',12.5,1),(1081,7569835,7569825,'den',12.5,1),(1081,7569836,7569825,'ent',12.5,1),(1081,7569837,7569825,'nti',12.5,1),(1081,7569838,7569825,'tif',12.5,1),(1081,7569839,7569825,'ifi',12.5,1),(1081,7569840,7569825,'fie',12.5,1),(1081,7569841,7569825,'ier',12.5,1),(1081,7569842,7569834,'vdi',33.333,3),(1081,7569843,7569834,'dis',33.333,3),(1081,7569844,7569834,'isk',33.333,3),(1081,7569845,7569842,'nam',50,1),(1081,7569846,7569842,'ame',50,1),(1081,7569847,7569845,'typ',50,1),(1081,7569848,7569845,'ype',50,1),(1081,7569849,7569847,'dir',25,1),(1081,7569850,7569847,'ire',25,1),(1081,7569851,7569847,'rec',25,1),(1081,7569852,7569847,'ect',25,1),(1082,7569854,7569853,'naa',100,2),(1082,7569855,7569854,'600',3.333,3),(1082,7569856,7569854,'000',3.333,3),(1082,7569857,7569854,'00c',3.333,3),(1082,7569858,7569854,'0c2',3.333,3),(1082,7569859,7569854,'c29',3.333,3),(1082,7569860,7569854,'29f',3.333,3),(1082,7569861,7569854,'9fb',3.333,3),(1082,7569862,7569854,'fb4',3.333,3),(1082,7569863,7569854,'b41',3.333,3),(1082,7569864,7569854,'413',3.333,3),(1082,7569865,7569854,'13b',3.333,3),(1082,7569866,7569854,'3b1',3.333,3),(1082,7569867,7569854,'b1a',3.333,3),(1082,7569868,7569854,'1ab',3.333,3),(1082,7569869,7569854,'ab0',3.333,3),(1082,7569870,7569854,'b0b',3.333,3),(1082,7569871,7569854,'0b4',3.333,3),(1082,7569872,7569854,'b45',3.333,3),(1082,7569873,7569854,'453',3.333,3),(1082,7569874,7569854,'532',3.333,3),(1082,7569875,7569854,'32e',3.333,3),(1082,7569876,7569854,'2eb',3.333,3),(1082,7569877,7569854,'ebc',3.333,3),(1082,7569878,7569854,'bca',3.333,3),(1082,7569879,7569854,'cae',3.333,3),(1082,7569880,7569854,'ae8',3.333,3),(1082,7569881,7569854,'e82',3.333,3),(1082,7569882,7569854,'829',3.333,3),(1082,7569883,7569854,'295',3.333,3),(1082,7569884,7569854,'95c',3.333,3),(1082,7569885,7569855,'mon',100,1),(1082,7569886,7569885,'201',50,1),(1082,7569887,7569885,'013',50,1),(1082,7569888,7569886,'adm',33.333,4),(1082,7569889,7569886,'dmi',33.333,4),(1082,7569890,7569886,'min',33.333,4),(1082,7569891,7569888,'cap',16.667,1),(1082,7569892,7569888,'apa',16.667,1),(1082,7569893,7569888,'pac',16.667,1),(1082,7569894,7569888,'aci',16.667,1),(1082,7569895,7569888,'cit',16.667,1),(1082,7569896,7569888,'ity',16.667,1),(1082,7569897,7569891,'pat',50,1),(1082,7569898,7569891,'ath',50,1),(1082,7569899,7569897,'fre',14.286,1),(1082,7569900,7569897,'ree',14.286,1),(1082,7569901,7569897,'ees',14.286,1),(1082,7569902,7569897,'esp',14.286,1),(1082,7569903,7569897,'spa',14.286,1),(1082,7569904,7569897,'pac',14.286,1),(1082,7569905,7569897,'ace',14.286,1),(1082,7569906,7569899,'dis',50,1),(1082,7569907,7569899,'isk',50,1),(1082,7569908,7569906,'ind',33.333,1),(1082,7569909,7569906,'nde',33.333,1),(1082,7569910,7569906,'dex',33.333,1),(1082,7569911,7569908,'adm',8.333,1),(1082,7569912,7569908,'dmi',8.333,1),(1082,7569913,7569908,'min',8.333,1),(1082,7569914,7569908,'ini',8.333,1),(1082,7569915,7569908,'nis',8.333,1),(1082,7569916,7569908,'ist',8.333,1),(1082,7569917,7569908,'str',8.333,1),(1082,7569918,7569908,'tra',8.333,1),(1082,7569919,7569908,'rat',8.333,1),(1082,7569920,7569908,'ati',8.333,1),(1082,7569921,7569908,'tio',8.333,1),(1082,7569922,7569908,'ion',8.333,1),(1082,7569923,7569911,'sta',33.333,3),(1082,7569924,7569911,'tat',33.333,3),(1082,7569925,7569911,'ate',33.333,3),(1082,7569926,7569923,'dis',16.667,4),(1082,7569927,7569923,'isa',16.667,4),(1082,7569928,7569923,'sab',16.667,4),(1082,7569929,7569923,'abl',16.667,4),(1082,7569930,7569923,'ble',16.667,4),(1082,7569931,7569923,'led',16.667,4),(1082,7569932,7569926,'cac',33.333,1),(1082,7569933,7569926,'ach',33.333,1),(1082,7569934,7569926,'che',33.333,1),(1082,7569935,7569932,'mod',50,1),(1082,7569936,7569932,'ode',50,1),(1082,7569937,7569935,'wri',14.286,1),(1082,7569938,7569935,'rit',14.286,1),(1082,7569939,7569935,'ite',14.286,1),(1082,7569940,7569935,'tet',14.286,1),(1082,7569941,7569935,'eth',14.286,1),(1082,7569942,7569935,'thr',14.286,1),(1082,7569943,7569935,'hru',14.286,1),(1082,7569944,7569937,'ope',11.111,2),(1082,7569945,7569937,'per',11.111,2),(1082,7569946,7569937,'era',11.111,2),(1082,7569947,7569937,'rat',11.111,2),(1082,7569948,7569937,'ati',11.111,2),(1082,7569949,7569937,'tio',11.111,2),(1082,7569950,7569937,'ion',11.111,2),(1082,7569951,7569937,'ona',11.111,2),(1082,7569952,7569937,'nal',11.111,2),(1082,7569953,7569944,'mes',20,1),(1082,7569954,7569944,'ess',20,1),(1082,7569955,7569944,'ssa',20,1),(1082,7569956,7569944,'sag',20,1),(1082,7569957,7569944,'age',20,1),(1082,7569958,7569953,'per',11.111,1),(1082,7569959,7569953,'erf',11.111,1),(1082,7569960,7569953,'rfo',11.111,1),(1082,7569961,7569953,'for',11.111,1),(1082,7569962,7569953,'orm',11.111,1),(1082,7569963,7569953,'rma',11.111,1),(1082,7569964,7569953,'man',11.111,1),(1082,7569965,7569953,'anc',11.111,1),(1082,7569966,7569953,'nce',11.111,1),(1082,7569967,7569958,'ide',12.5,1),(1082,7569968,7569958,'den',12.5,1),(1082,7569969,7569958,'ent',12.5,1),(1082,7569970,7569958,'nti',12.5,1),(1082,7569971,7569958,'tif',12.5,1),(1082,7569972,7569958,'ifi',12.5,1),(1082,7569973,7569958,'fie',12.5,1),(1082,7569974,7569958,'ier',12.5,1),(1082,7569975,7569967,'vdi',33.333,3),(1082,7569976,7569967,'dis',33.333,3),(1082,7569977,7569967,'isk',33.333,3),(1082,7569978,7569975,'nam',50,1),(1082,7569979,7569975,'ame',50,1),(1082,7569980,7569978,'typ',50,1),(1082,7569981,7569978,'ype',50,1),(1082,7569982,7569980,'dir',25,1),(1082,7569983,7569980,'ire',25,1),(1082,7569984,7569980,'rec',25,1),(1082,7569985,7569980,'ect',25,1),(1083,7569987,7569986,'naa',100,2),(1083,7569988,7569987,'600',3.333,3),(1083,7569989,7569987,'000',3.333,3),(1083,7569990,7569987,'00c',3.333,3),(1083,7569991,7569987,'0c2',3.333,3),(1083,7569992,7569987,'c29',3.333,3),(1083,7569993,7569987,'294',3.333,3),(1083,7569994,7569987,'94d',3.333,3),(1083,7569995,7569987,'4d6',3.333,3),(1083,7569996,7569987,'d69',3.333,3),(1083,7569997,7569987,'69d',3.333,3),(1083,7569998,7569987,'9d7',3.333,3),(1083,7569999,7569987,'d72',3.333,3),(1083,7570000,7569987,'72b',3.333,3),(1083,7570001,7569987,'2bd',3.333,3),(1083,7570002,7569987,'bd7',3.333,3),(1083,7570003,7569987,'d76',3.333,3),(1083,7570004,7569987,'76d',3.333,3),(1083,7570005,7569987,'6d5',3.333,3),(1083,7570006,7569987,'d5e',3.333,3),(1083,7570007,7569987,'5e7',3.333,3),(1083,7570008,7569987,'e7a',3.333,3),(1083,7570009,7569987,'7a9',3.333,3),(1083,7570010,7569987,'a9f',3.333,3),(1083,7570011,7569987,'9f2',3.333,3),(1083,7570012,7569987,'f2a',3.333,3),(1083,7570013,7569987,'2a3',3.333,3),(1083,7570014,7569987,'a3f',3.333,3),(1083,7570015,7569987,'3f8',3.333,3),(1083,7570016,7569987,'f84',3.333,3),(1083,7570017,7569987,'843',3.333,3),(1083,7570018,7569988,'mon',100,1),(1083,7570019,7570018,'201',50,1),(1083,7570020,7570018,'013',50,1),(1083,7570021,7570019,'adm',33.333,4),(1083,7570022,7570019,'dmi',33.333,4),(1083,7570023,7570019,'min',33.333,4),(1083,7570024,7570021,'cap',16.667,1),(1083,7570025,7570021,'apa',16.667,1),(1083,7570026,7570021,'pac',16.667,1),(1083,7570027,7570021,'aci',16.667,1),(1083,7570028,7570021,'cit',16.667,1),(1083,7570029,7570021,'ity',16.667,1),(1083,7570030,7570024,'pat',50,1),(1083,7570031,7570024,'ath',50,1),(1083,7570032,7570030,'fre',14.286,1),(1083,7570033,7570030,'ree',14.286,1),(1083,7570034,7570030,'ees',14.286,1),(1083,7570035,7570030,'esp',14.286,1),(1083,7570036,7570030,'spa',14.286,1),(1083,7570037,7570030,'pac',14.286,1),(1083,7570038,7570030,'ace',14.286,1),(1083,7570039,7570032,'dis',50,1),(1083,7570040,7570032,'isk',50,1),(1083,7570041,7570039,'ind',33.333,1),(1083,7570042,7570039,'nde',33.333,1),(1083,7570043,7570039,'dex',33.333,1),(1083,7570044,7570041,'adm',8.333,1),(1083,7570045,7570041,'dmi',8.333,1),(1083,7570046,7570041,'min',8.333,1),(1083,7570047,7570041,'ini',8.333,1),(1083,7570048,7570041,'nis',8.333,1),(1083,7570049,7570041,'ist',8.333,1),(1083,7570050,7570041,'str',8.333,1),(1083,7570051,7570041,'tra',8.333,1),(1083,7570052,7570041,'rat',8.333,1),(1083,7570053,7570041,'ati',8.333,1),(1083,7570054,7570041,'tio',8.333,1),(1083,7570055,7570041,'ion',8.333,1),(1083,7570056,7570044,'sta',33.333,3),(1083,7570057,7570044,'tat',33.333,3),(1083,7570058,7570044,'ate',33.333,3),(1083,7570059,7570056,'dis',16.667,4),(1083,7570060,7570056,'isa',16.667,4),(1083,7570061,7570056,'sab',16.667,4),(1083,7570062,7570056,'abl',16.667,4),(1083,7570063,7570056,'ble',16.667,4),(1083,7570064,7570056,'led',16.667,4),(1083,7570065,7570059,'cac',33.333,1),(1083,7570066,7570059,'ach',33.333,1),(1083,7570067,7570059,'che',33.333,1),(1083,7570068,7570065,'mod',50,1),(1083,7570069,7570065,'ode',50,1),(1083,7570070,7570068,'wri',14.286,1),(1083,7570071,7570068,'rit',14.286,1),(1083,7570072,7570068,'ite',14.286,1),(1083,7570073,7570068,'tet',14.286,1),(1083,7570074,7570068,'eth',14.286,1),(1083,7570075,7570068,'thr',14.286,1),(1083,7570076,7570068,'hru',14.286,1),(1083,7570077,7570070,'ope',11.111,2),(1083,7570078,7570070,'per',11.111,2),(1083,7570079,7570070,'era',11.111,2),(1083,7570080,7570070,'rat',11.111,2),(1083,7570081,7570070,'ati',11.111,2),(1083,7570082,7570070,'tio',11.111,2),(1083,7570083,7570070,'ion',11.111,2),(1083,7570084,7570070,'ona',11.111,2),(1083,7570085,7570070,'nal',11.111,2),(1083,7570086,7570077,'mes',20,1),(1083,7570087,7570077,'ess',20,1),(1083,7570088,7570077,'ssa',20,1),(1083,7570089,7570077,'sag',20,1),(1083,7570090,7570077,'age',20,1),(1083,7570091,7570086,'per',11.111,1),(1083,7570092,7570086,'erf',11.111,1),(1083,7570093,7570086,'rfo',11.111,1),(1083,7570094,7570086,'for',11.111,1),(1083,7570095,7570086,'orm',11.111,1),(1083,7570096,7570086,'rma',11.111,1),(1083,7570097,7570086,'man',11.111,1),(1083,7570098,7570086,'anc',11.111,1),(1083,7570099,7570086,'nce',11.111,1),(1083,7570100,7570091,'ide',12.5,1),(1083,7570101,7570091,'den',12.5,1),(1083,7570102,7570091,'ent',12.5,1),(1083,7570103,7570091,'nti',12.5,1),(1083,7570104,7570091,'tif',12.5,1),(1083,7570105,7570091,'ifi',12.5,1),(1083,7570106,7570091,'fie',12.5,1),(1083,7570107,7570091,'ier',12.5,1),(1083,7570108,7570100,'vdi',33.333,3),(1083,7570109,7570100,'dis',33.333,3),(1083,7570110,7570100,'isk',33.333,3),(1083,7570111,7570108,'nam',50,1),(1083,7570112,7570108,'ame',50,1),(1083,7570113,7570111,'typ',50,1),(1083,7570114,7570111,'ype',50,1),(1083,7570115,7570113,'dir',25,1),(1083,7570116,7570113,'ire',25,1),(1083,7570117,7570113,'rec',25,1),(1083,7570118,7570113,'ect',25,1),(1084,7570120,7570119,'naa',100,2),(1084,7570121,7570120,'600',3.333,3),(1084,7570122,7570120,'000',3.333,3),(1084,7570123,7570120,'00c',3.333,3),(1084,7570124,7570120,'0c2',3.333,3),(1084,7570125,7570120,'c29',3.333,3),(1084,7570126,7570120,'29c',3.333,3),(1084,7570127,7570120,'9cd',3.333,3),(1084,7570128,7570120,'cd2',3.333,3),(1084,7570129,7570120,'d23',3.333,3),(1084,7570130,7570120,'23d',3.333,3),(1084,7570131,7570120,'3d4',3.333,3),(1084,7570132,7570120,'d4c',3.333,3),(1084,7570133,7570120,'4c7',3.333,3),(1084,7570134,7570120,'c7b',3.333,3),(1084,7570135,7570120,'7bb',3.333,3),(1084,7570136,7570120,'bb4',3.333,3),(1084,7570137,7570120,'b47',3.333,3),(1084,7570138,7570120,'47d',3.333,3),(1084,7570139,7570120,'7d9',3.333,3),(1084,7570140,7570120,'d93',3.333,3),(1084,7570141,7570120,'93e',3.333,3),(1084,7570142,7570120,'3e3',3.333,3),(1084,7570143,7570120,'e37',3.333,3),(1084,7570144,7570120,'379',3.333,3),(1084,7570145,7570120,'790',3.333,3),(1084,7570146,7570120,'905',3.333,3),(1084,7570147,7570120,'050',3.333,3),(1084,7570148,7570120,'50b',3.333,3),(1084,7570149,7570120,'0bd',3.333,3),(1084,7570150,7570120,'bd8',3.333,3),(1084,7570151,7570121,'mon',100,1),(1084,7570152,7570151,'201',50,1),(1084,7570153,7570151,'013',50,1),(1084,7570154,7570152,'adm',33.333,4),(1084,7570155,7570152,'dmi',33.333,4),(1084,7570156,7570152,'min',33.333,4),(1084,7570157,7570154,'cap',16.667,1),(1084,7570158,7570154,'apa',16.667,1),(1084,7570159,7570154,'pac',16.667,1),(1084,7570160,7570154,'aci',16.667,1),(1084,7570161,7570154,'cit',16.667,1),(1084,7570162,7570154,'ity',16.667,1),(1084,7570163,7570157,'pat',50,1),(1084,7570164,7570157,'ath',50,1),(1084,7570165,7570163,'fre',14.286,1),(1084,7570166,7570163,'ree',14.286,1),(1084,7570167,7570163,'ees',14.286,1),(1084,7570168,7570163,'esp',14.286,1),(1084,7570169,7570163,'spa',14.286,1),(1084,7570170,7570163,'pac',14.286,1),(1084,7570171,7570163,'ace',14.286,1),(1084,7570172,7570165,'dis',50,1),(1084,7570173,7570165,'isk',50,1),(1084,7570174,7570172,'ind',33.333,1),(1084,7570175,7570172,'nde',33.333,1),(1084,7570176,7570172,'dex',33.333,1),(1084,7570177,7570174,'adm',8.333,1),(1084,7570178,7570174,'dmi',8.333,1),(1084,7570179,7570174,'min',8.333,1),(1084,7570180,7570174,'ini',8.333,1),(1084,7570181,7570174,'nis',8.333,1),(1084,7570182,7570174,'ist',8.333,1),(1084,7570183,7570174,'str',8.333,1),(1084,7570184,7570174,'tra',8.333,1),(1084,7570185,7570174,'rat',8.333,1),(1084,7570186,7570174,'ati',8.333,1),(1084,7570187,7570174,'tio',8.333,1),(1084,7570188,7570174,'ion',8.333,1),(1084,7570189,7570177,'sta',33.333,3),(1084,7570190,7570177,'tat',33.333,3),(1084,7570191,7570177,'ate',33.333,3),(1084,7570192,7570189,'dis',16.667,4),(1084,7570193,7570189,'isa',16.667,4),(1084,7570194,7570189,'sab',16.667,4),(1084,7570195,7570189,'abl',16.667,4),(1084,7570196,7570189,'ble',16.667,4),(1084,7570197,7570189,'led',16.667,4),(1084,7570198,7570192,'cac',33.333,1),(1084,7570199,7570192,'ach',33.333,1),(1084,7570200,7570192,'che',33.333,1),(1084,7570201,7570198,'mod',50,1),(1084,7570202,7570198,'ode',50,1),(1084,7570203,7570201,'wri',14.286,1),(1084,7570204,7570201,'rit',14.286,1),(1084,7570205,7570201,'ite',14.286,1),(1084,7570206,7570201,'tet',14.286,1),(1084,7570207,7570201,'eth',14.286,1),(1084,7570208,7570201,'thr',14.286,1),(1084,7570209,7570201,'hru',14.286,1),(1084,7570210,7570203,'ope',11.111,2),(1084,7570211,7570203,'per',11.111,2),(1084,7570212,7570203,'era',11.111,2),(1084,7570213,7570203,'rat',11.111,2),(1084,7570214,7570203,'ati',11.111,2),(1084,7570215,7570203,'tio',11.111,2),(1084,7570216,7570203,'ion',11.111,2),(1084,7570217,7570203,'ona',11.111,2),(1084,7570218,7570203,'nal',11.111,2),(1084,7570219,7570210,'mes',20,1),(1084,7570220,7570210,'ess',20,1),(1084,7570221,7570210,'ssa',20,1),(1084,7570222,7570210,'sag',20,1),(1084,7570223,7570210,'age',20,1),(1084,7570224,7570219,'per',11.111,1),(1084,7570225,7570219,'erf',11.111,1),(1084,7570226,7570219,'rfo',11.111,1),(1084,7570227,7570219,'for',11.111,1),(1084,7570228,7570219,'orm',11.111,1),(1084,7570229,7570219,'rma',11.111,1),(1084,7570230,7570219,'man',11.111,1),(1084,7570231,7570219,'anc',11.111,1),(1084,7570232,7570219,'nce',11.111,1),(1084,7570233,7570224,'ide',12.5,1),(1084,7570234,7570224,'den',12.5,1),(1084,7570235,7570224,'ent',12.5,1),(1084,7570236,7570224,'nti',12.5,1),(1084,7570237,7570224,'tif',12.5,1),(1084,7570238,7570224,'ifi',12.5,1),(1084,7570239,7570224,'fie',12.5,1),(1084,7570240,7570224,'ier',12.5,1),(1084,7570241,7570233,'vdi',33.333,3),(1084,7570242,7570233,'dis',33.333,3),(1084,7570243,7570233,'isk',33.333,3),(1084,7570244,7570241,'nam',50,1),(1084,7570245,7570241,'ame',50,1),(1084,7570246,7570244,'typ',50,1),(1084,7570247,7570244,'ype',50,1),(1084,7570248,7570246,'dir',25,1),(1084,7570249,7570246,'ire',25,1),(1084,7570250,7570246,'rec',25,1),(1084,7570251,7570246,'ect',25,1),(1085,7570253,7570252,'naa',100,2),(1085,7570254,7570253,'600',3.333,3),(1085,7570255,7570253,'000',3.333,3),(1085,7570256,7570253,'00c',3.333,3),(1085,7570257,7570253,'0c2',3.333,3),(1085,7570258,7570253,'c29',3.333,3),(1085,7570259,7570253,'298',3.333,3),(1085,7570260,7570253,'98c',3.333,3),(1085,7570261,7570253,'8c5',3.333,3),(1085,7570262,7570253,'c5e',3.333,3),(1085,7570263,7570253,'5ee',3.333,3),(1085,7570264,7570253,'ee9',3.333,3),(1085,7570265,7570253,'e9e',3.333,3),(1085,7570266,7570253,'9e9',3.333,3),(1085,7570267,7570253,'e97',3.333,3),(1085,7570268,7570253,'974',3.333,3),(1085,7570269,7570253,'74a',3.333,3),(1085,7570270,7570253,'4a1',3.333,3),(1085,7570271,7570253,'a12',3.333,3),(1085,7570272,7570253,'12e',3.333,3),(1085,7570273,7570253,'2e5',3.333,3),(1085,7570274,7570253,'e50',3.333,3),(1085,7570275,7570253,'50a',3.333,3),(1085,7570276,7570253,'0a0',3.333,3),(1085,7570277,7570253,'a09',3.333,3),(1085,7570278,7570253,'09b',3.333,3),(1085,7570279,7570253,'9b3',3.333,3),(1085,7570280,7570253,'b38',3.333,3),(1085,7570281,7570253,'388',3.333,3),(1085,7570282,7570253,'882',3.333,3),(1085,7570283,7570253,'823',3.333,3),(1085,7570284,7570254,'mon',100,1),(1085,7570285,7570284,'201',50,1),(1085,7570286,7570284,'013',50,1),(1085,7570287,7570285,'adm',33.333,4),(1085,7570288,7570285,'dmi',33.333,4),(1085,7570289,7570285,'min',33.333,4),(1085,7570290,7570287,'cap',16.667,1),(1085,7570291,7570287,'apa',16.667,1),(1085,7570292,7570287,'pac',16.667,1),(1085,7570293,7570287,'aci',16.667,1),(1085,7570294,7570287,'cit',16.667,1),(1085,7570295,7570287,'ity',16.667,1),(1085,7570296,7570290,'pat',50,1),(1085,7570297,7570290,'ath',50,1),(1085,7570298,7570296,'fre',14.286,1),(1085,7570299,7570296,'ree',14.286,1),(1085,7570300,7570296,'ees',14.286,1),(1085,7570301,7570296,'esp',14.286,1),(1085,7570302,7570296,'spa',14.286,1),(1085,7570303,7570296,'pac',14.286,1),(1085,7570304,7570296,'ace',14.286,1),(1085,7570305,7570298,'dis',50,1),(1085,7570306,7570298,'isk',50,1),(1085,7570307,7570305,'ind',33.333,1),(1085,7570308,7570305,'nde',33.333,1),(1085,7570309,7570305,'dex',33.333,1),(1085,7570310,7570307,'adm',8.333,1),(1085,7570311,7570307,'dmi',8.333,1),(1085,7570312,7570307,'min',8.333,1),(1085,7570313,7570307,'ini',8.333,1),(1085,7570314,7570307,'nis',8.333,1),(1085,7570315,7570307,'ist',8.333,1),(1085,7570316,7570307,'str',8.333,1),(1085,7570317,7570307,'tra',8.333,1),(1085,7570318,7570307,'rat',8.333,1),(1085,7570319,7570307,'ati',8.333,1),(1085,7570320,7570307,'tio',8.333,1),(1085,7570321,7570307,'ion',8.333,1),(1085,7570322,7570310,'sta',33.333,3),(1085,7570323,7570310,'tat',33.333,3),(1085,7570324,7570310,'ate',33.333,3),(1085,7570325,7570322,'dis',16.667,4),(1085,7570326,7570322,'isa',16.667,4),(1085,7570327,7570322,'sab',16.667,4),(1085,7570328,7570322,'abl',16.667,4),(1085,7570329,7570322,'ble',16.667,4),(1085,7570330,7570322,'led',16.667,4),(1085,7570331,7570325,'cac',33.333,1),(1085,7570332,7570325,'ach',33.333,1),(1085,7570333,7570325,'che',33.333,1),(1085,7570334,7570331,'mod',50,1),(1085,7570335,7570331,'ode',50,1),(1085,7570336,7570334,'wri',14.286,1),(1085,7570337,7570334,'rit',14.286,1),(1085,7570338,7570334,'ite',14.286,1),(1085,7570339,7570334,'tet',14.286,1),(1085,7570340,7570334,'eth',14.286,1),(1085,7570341,7570334,'thr',14.286,1),(1085,7570342,7570334,'hru',14.286,1),(1085,7570343,7570336,'ope',11.111,2),(1085,7570344,7570336,'per',11.111,2),(1085,7570345,7570336,'era',11.111,2),(1085,7570346,7570336,'rat',11.111,2),(1085,7570347,7570336,'ati',11.111,2),(1085,7570348,7570336,'tio',11.111,2),(1085,7570349,7570336,'ion',11.111,2),(1085,7570350,7570336,'ona',11.111,2),(1085,7570351,7570336,'nal',11.111,2),(1085,7570352,7570343,'mes',20,1),(1085,7570353,7570343,'ess',20,1),(1085,7570354,7570343,'ssa',20,1),(1085,7570355,7570343,'sag',20,1),(1085,7570356,7570343,'age',20,1),(1085,7570357,7570352,'per',11.111,1),(1085,7570358,7570352,'erf',11.111,1),(1085,7570359,7570352,'rfo',11.111,1),(1085,7570360,7570352,'for',11.111,1),(1085,7570361,7570352,'orm',11.111,1),(1085,7570362,7570352,'rma',11.111,1),(1085,7570363,7570352,'man',11.111,1),(1085,7570364,7570352,'anc',11.111,1),(1085,7570365,7570352,'nce',11.111,1),(1085,7570366,7570357,'ide',12.5,1),(1085,7570367,7570357,'den',12.5,1),(1085,7570368,7570357,'ent',12.5,1),(1085,7570369,7570357,'nti',12.5,1),(1085,7570370,7570357,'tif',12.5,1),(1085,7570371,7570357,'ifi',12.5,1),(1085,7570372,7570357,'fie',12.5,1),(1085,7570373,7570357,'ier',12.5,1),(1085,7570374,7570366,'vdi',33.333,3),(1085,7570375,7570366,'dis',33.333,3),(1085,7570376,7570366,'isk',33.333,3),(1085,7570377,7570374,'nam',50,1),(1085,7570378,7570374,'ame',50,1),(1085,7570379,7570377,'typ',50,1),(1085,7570380,7570377,'ype',50,1),(1085,7570381,7570379,'dir',25,1),(1085,7570382,7570379,'ire',25,1),(1085,7570383,7570379,'rec',25,1),(1085,7570384,7570379,'ect',25,1),(1086,7570386,7570385,'naa',100,2),(1086,7570387,7570386,'600',3.333,3),(1086,7570388,7570386,'000',3.333,3),(1086,7570389,7570386,'00c',3.333,3),(1086,7570390,7570386,'0c2',3.333,3),(1086,7570391,7570386,'c29',3.333,3),(1086,7570392,7570386,'29d',3.333,3),(1086,7570393,7570386,'9d7',3.333,3),(1086,7570394,7570386,'d72',3.333,3),(1086,7570395,7570386,'728',3.333,3),(1086,7570396,7570386,'28c',3.333,3),(1086,7570397,7570386,'8c9',3.333,3),(1086,7570398,7570386,'c9b',3.333,3),(1086,7570399,7570386,'9b5',3.333,3),(1086,7570400,7570386,'b5d',3.333,3),(1086,7570401,7570386,'5d4',3.333,3),(1086,7570402,7570386,'d4d',3.333,3),(1086,7570403,7570386,'4d4',3.333,3),(1086,7570404,7570386,'d41',3.333,3),(1086,7570405,7570386,'414',3.333,3),(1086,7570406,7570386,'147',3.333,3),(1086,7570407,7570386,'470',3.333,3),(1086,7570408,7570386,'705',3.333,3),(1086,7570409,7570386,'05b',3.333,3),(1086,7570410,7570386,'5b2',3.333,3),(1086,7570411,7570386,'b28',3.333,3),(1086,7570412,7570386,'28d',3.333,3),(1086,7570413,7570386,'8d2',3.333,3),(1086,7570414,7570386,'d2a',3.333,3),(1086,7570415,7570386,'2a7',3.333,3),(1086,7570416,7570386,'a78',3.333,3),(1086,7570417,7570387,'mon',100,1),(1086,7570418,7570417,'201',50,1),(1086,7570419,7570417,'013',50,1),(1086,7570420,7570418,'adm',33.333,4),(1086,7570421,7570418,'dmi',33.333,4),(1086,7570422,7570418,'min',33.333,4),(1086,7570423,7570420,'cap',16.667,1),(1086,7570424,7570420,'apa',16.667,1),(1086,7570425,7570420,'pac',16.667,1),(1086,7570426,7570420,'aci',16.667,1),(1086,7570427,7570420,'cit',16.667,1),(1086,7570428,7570420,'ity',16.667,1),(1086,7570429,7570423,'pat',50,1),(1086,7570430,7570423,'ath',50,1),(1086,7570431,7570429,'one',100,1),(1086,7570432,7570431,'fre',14.286,1),(1086,7570433,7570431,'ree',14.286,1),(1086,7570434,7570431,'ees',14.286,1),(1086,7570435,7570431,'esp',14.286,1),(1086,7570436,7570431,'spa',14.286,1),(1086,7570437,7570431,'pac',14.286,1),(1086,7570438,7570431,'ace',14.286,1),(1086,7570439,7570432,'dis',50,1),(1086,7570440,7570432,'isk',50,1),(1086,7570441,7570439,'ind',33.333,1),(1086,7570442,7570439,'nde',33.333,1),(1086,7570443,7570439,'dex',33.333,1),(1086,7570444,7570441,'adm',8.333,1),(1086,7570445,7570441,'dmi',8.333,1),(1086,7570446,7570441,'min',8.333,1),(1086,7570447,7570441,'ini',8.333,1),(1086,7570448,7570441,'nis',8.333,1),(1086,7570449,7570441,'ist',8.333,1),(1086,7570450,7570441,'str',8.333,1),(1086,7570451,7570441,'tra',8.333,1),(1086,7570452,7570441,'rat',8.333,1),(1086,7570453,7570441,'ati',8.333,1),(1086,7570454,7570441,'tio',8.333,1),(1086,7570455,7570441,'ion',8.333,1),(1086,7570456,7570444,'sta',33.333,3),(1086,7570457,7570444,'tat',33.333,3),(1086,7570458,7570444,'ate',33.333,3),(1086,7570459,7570456,'dis',16.667,4),(1086,7570460,7570456,'isa',16.667,4),(1086,7570461,7570456,'sab',16.667,4),(1086,7570462,7570456,'abl',16.667,4),(1086,7570463,7570456,'ble',16.667,4),(1086,7570464,7570456,'led',16.667,4),(1086,7570465,7570459,'cac',33.333,1),(1086,7570466,7570459,'ach',33.333,1),(1086,7570467,7570459,'che',33.333,1),(1086,7570468,7570465,'mod',50,1),(1086,7570469,7570465,'ode',50,1),(1086,7570470,7570468,'wri',14.286,1),(1086,7570471,7570468,'rit',14.286,1),(1086,7570472,7570468,'ite',14.286,1),(1086,7570473,7570468,'tet',14.286,1),(1086,7570474,7570468,'eth',14.286,1),(1086,7570475,7570468,'thr',14.286,1),(1086,7570476,7570468,'hru',14.286,1),(1086,7570477,7570470,'ope',11.111,2),(1086,7570478,7570470,'per',11.111,2),(1086,7570479,7570470,'era',11.111,2),(1086,7570480,7570470,'rat',11.111,2),(1086,7570481,7570470,'ati',11.111,2),(1086,7570482,7570470,'tio',11.111,2),(1086,7570483,7570470,'ion',11.111,2),(1086,7570484,7570470,'ona',11.111,2),(1086,7570485,7570470,'nal',11.111,2),(1086,7570486,7570477,'mes',20,1),(1086,7570487,7570477,'ess',20,1),(1086,7570488,7570477,'ssa',20,1),(1086,7570489,7570477,'sag',20,1),(1086,7570490,7570477,'age',20,1),(1086,7570491,7570486,'per',11.111,1),(1086,7570492,7570486,'erf',11.111,1),(1086,7570493,7570486,'rfo',11.111,1),(1086,7570494,7570486,'for',11.111,1),(1086,7570495,7570486,'orm',11.111,1),(1086,7570496,7570486,'rma',11.111,1),(1086,7570497,7570486,'man',11.111,1),(1086,7570498,7570486,'anc',11.111,1),(1086,7570499,7570486,'nce',11.111,1),(1086,7570500,7570491,'ide',12.5,1),(1086,7570501,7570491,'den',12.5,1),(1086,7570502,7570491,'ent',12.5,1),(1086,7570503,7570491,'nti',12.5,1),(1086,7570504,7570491,'tif',12.5,1),(1086,7570505,7570491,'ifi',12.5,1),(1086,7570506,7570491,'fie',12.5,1),(1086,7570507,7570491,'ier',12.5,1),(1086,7570508,7570500,'vdi',33.333,3),(1086,7570509,7570500,'dis',33.333,3),(1086,7570510,7570500,'isk',33.333,3),(1086,7570511,7570508,'nam',50,1),(1086,7570512,7570508,'ame',50,1),(1086,7570513,7570511,'typ',50,1),(1086,7570514,7570511,'ype',50,1),(1086,7570515,7570513,'dir',25,1),(1086,7570516,7570513,'ire',25,1),(1086,7570517,7570513,'rec',25,1),(1086,7570518,7570513,'ect',25,1),(1087,7570520,7570519,'naa',100,2),(1087,7570521,7570520,'600',3.333,3),(1087,7570522,7570520,'000',3.333,3),(1087,7570523,7570520,'00c',3.333,3),(1087,7570524,7570520,'0c2',3.333,3),(1087,7570525,7570520,'c29',3.333,3),(1087,7570526,7570520,'29e',3.333,3),(1087,7570527,7570520,'9e1',3.333,3),(1087,7570528,7570520,'e12',3.333,3),(1087,7570529,7570520,'124',3.333,3),(1087,7570530,7570520,'249',3.333,3),(1087,7570531,7570520,'499',3.333,3),(1087,7570532,7570520,'992',3.333,3),(1087,7570533,7570520,'92a',3.333,3),(1087,7570534,7570520,'2a1',3.333,3),(1087,7570535,7570520,'a11',3.333,3),(1087,7570536,7570520,'118',3.333,3),(1087,7570537,7570520,'181',3.333,3),(1087,7570538,7570520,'814',3.333,3),(1087,7570539,7570520,'14b',3.333,3),(1087,7570540,7570520,'4bf',3.333,3),(1087,7570541,7570520,'bfc',3.333,3),(1087,7570542,7570520,'fcc',3.333,3),(1087,7570543,7570520,'cc0',3.333,3),(1087,7570544,7570520,'c0a',3.333,3),(1087,7570545,7570520,'0aa',3.333,3),(1087,7570546,7570520,'aae',3.333,3),(1087,7570547,7570520,'aee',3.333,3),(1087,7570548,7570520,'eed',3.333,3),(1087,7570549,7570520,'ed3',3.333,3),(1087,7570550,7570520,'d32',3.333,3),(1087,7570551,7570521,'mon',100,1),(1087,7570552,7570551,'201',50,1),(1087,7570553,7570551,'013',50,1),(1087,7570554,7570552,'adm',33.333,4),(1087,7570555,7570552,'dmi',33.333,4),(1087,7570556,7570552,'min',33.333,4),(1087,7570557,7570554,'cap',16.667,1),(1087,7570558,7570554,'apa',16.667,1),(1087,7570559,7570554,'pac',16.667,1),(1087,7570560,7570554,'aci',16.667,1),(1087,7570561,7570554,'cit',16.667,1),(1087,7570562,7570554,'ity',16.667,1),(1087,7570563,7570557,'pat',50,1),(1087,7570564,7570557,'ath',50,1),(1087,7570565,7570563,'thr',33.333,1),(1087,7570566,7570563,'hre',33.333,1),(1087,7570567,7570563,'ree',33.333,1),(1087,7570568,7570565,'fre',14.286,1),(1087,7570569,7570565,'ree',14.286,1),(1087,7570570,7570565,'ees',14.286,1),(1087,7570571,7570565,'esp',14.286,1),(1087,7570572,7570565,'spa',14.286,1),(1087,7570573,7570565,'pac',14.286,1),(1087,7570574,7570565,'ace',14.286,1),(1087,7570575,7570568,'dis',50,1),(1087,7570576,7570568,'isk',50,1),(1087,7570577,7570575,'ind',33.333,1),(1087,7570578,7570575,'nde',33.333,1),(1087,7570579,7570575,'dex',33.333,1),(1087,7570580,7570577,'adm',8.333,1),(1087,7570581,7570577,'dmi',8.333,1),(1087,7570582,7570577,'min',8.333,1),(1087,7570583,7570577,'ini',8.333,1),(1087,7570584,7570577,'nis',8.333,1),(1087,7570585,7570577,'ist',8.333,1),(1087,7570586,7570577,'str',8.333,1),(1087,7570587,7570577,'tra',8.333,1),(1087,7570588,7570577,'rat',8.333,1),(1087,7570589,7570577,'ati',8.333,1),(1087,7570590,7570577,'tio',8.333,1),(1087,7570591,7570577,'ion',8.333,1),(1087,7570592,7570580,'sta',33.333,3),(1087,7570593,7570580,'tat',33.333,3),(1087,7570594,7570580,'ate',33.333,3),(1087,7570595,7570592,'dis',16.667,4),(1087,7570596,7570592,'isa',16.667,4),(1087,7570597,7570592,'sab',16.667,4),(1087,7570598,7570592,'abl',16.667,4),(1087,7570599,7570592,'ble',16.667,4),(1087,7570600,7570592,'led',16.667,4),(1087,7570601,7570595,'cac',33.333,1),(1087,7570602,7570595,'ach',33.333,1),(1087,7570603,7570595,'che',33.333,1),(1087,7570604,7570601,'mod',50,1),(1087,7570605,7570601,'ode',50,1),(1087,7570606,7570604,'wri',14.286,1),(1087,7570607,7570604,'rit',14.286,1),(1087,7570608,7570604,'ite',14.286,1),(1087,7570609,7570604,'tet',14.286,1),(1087,7570610,7570604,'eth',14.286,1),(1087,7570611,7570604,'thr',14.286,1),(1087,7570612,7570604,'hru',14.286,1),(1087,7570613,7570606,'ope',11.111,2),(1087,7570614,7570606,'per',11.111,2),(1087,7570615,7570606,'era',11.111,2),(1087,7570616,7570606,'rat',11.111,2),(1087,7570617,7570606,'ati',11.111,2),(1087,7570618,7570606,'tio',11.111,2),(1087,7570619,7570606,'ion',11.111,2),(1087,7570620,7570606,'ona',11.111,2),(1087,7570621,7570606,'nal',11.111,2),(1087,7570622,7570613,'mes',20,1),(1087,7570623,7570613,'ess',20,1),(1087,7570624,7570613,'ssa',20,1),(1087,7570625,7570613,'sag',20,1),(1087,7570626,7570613,'age',20,1),(1087,7570627,7570622,'per',11.111,1),(1087,7570628,7570622,'erf',11.111,1),(1087,7570629,7570622,'rfo',11.111,1),(1087,7570630,7570622,'for',11.111,1),(1087,7570631,7570622,'orm',11.111,1),(1087,7570632,7570622,'rma',11.111,1),(1087,7570633,7570622,'man',11.111,1),(1087,7570634,7570622,'anc',11.111,1),(1087,7570635,7570622,'nce',11.111,1),(1087,7570636,7570627,'ide',12.5,1),(1087,7570637,7570627,'den',12.5,1),(1087,7570638,7570627,'ent',12.5,1),(1087,7570639,7570627,'nti',12.5,1),(1087,7570640,7570627,'tif',12.5,1),(1087,7570641,7570627,'ifi',12.5,1),(1087,7570642,7570627,'fie',12.5,1),(1087,7570643,7570627,'ier',12.5,1),(1087,7570644,7570636,'vdi',33.333,3),(1087,7570645,7570636,'dis',33.333,3),(1087,7570646,7570636,'isk',33.333,3),(1087,7570647,7570644,'nam',50,1),(1087,7570648,7570644,'ame',50,1),(1087,7570649,7570647,'typ',50,1),(1087,7570650,7570647,'ype',50,1),(1087,7570651,7570649,'dir',25,1),(1087,7570652,7570649,'ire',25,1),(1087,7570653,7570649,'rec',25,1),(1087,7570654,7570649,'ect',25,1),(1088,7570656,7570655,'naa',100,2),(1088,7570657,7570656,'600',3.333,3),(1088,7570658,7570656,'000',3.333,3),(1088,7570659,7570656,'00c',3.333,3),(1088,7570660,7570656,'0c2',3.333,3),(1088,7570661,7570656,'c29',3.333,3),(1088,7570662,7570656,'29a',3.333,3),(1088,7570663,7570656,'9a9',3.333,3),(1088,7570664,7570656,'a90',3.333,3),(1088,7570665,7570656,'900',3.333,3),(1088,7570666,7570656,'000',3.333,3),(1088,7570667,7570656,'006',3.333,3),(1088,7570668,7570656,'06a',3.333,3),(1088,7570669,7570656,'6a8',3.333,3),(1088,7570670,7570656,'a8a',3.333,3),(1088,7570671,7570656,'8a4',3.333,3),(1088,7570672,7570656,'a40',3.333,3),(1088,7570673,7570656,'40f',3.333,3),(1088,7570674,7570656,'0f9',3.333,3),(1088,7570675,7570656,'f93',3.333,3),(1088,7570676,7570656,'939',3.333,3),(1088,7570677,7570656,'391',3.333,3),(1088,7570678,7570656,'919',3.333,3),(1088,7570679,7570656,'19f',3.333,3),(1088,7570680,7570656,'9f4',3.333,3),(1088,7570681,7570656,'f46',3.333,3),(1088,7570682,7570656,'46c',3.333,3),(1088,7570683,7570656,'6cb',3.333,3),(1088,7570684,7570656,'cbb',3.333,3),(1088,7570685,7570656,'bb9',3.333,3),(1088,7570686,7570656,'b9c',3.333,3),(1088,7570687,7570657,'mon',100,1),(1088,7570688,7570687,'201',50,1),(1088,7570689,7570687,'013',50,1),(1088,7570690,7570688,'adm',33.333,4),(1088,7570691,7570688,'dmi',33.333,4),(1088,7570692,7570688,'min',33.333,4),(1088,7570693,7570690,'cap',16.667,1),(1088,7570694,7570690,'apa',16.667,1),(1088,7570695,7570690,'pac',16.667,1),(1088,7570696,7570690,'aci',16.667,1),(1088,7570697,7570690,'cit',16.667,1),(1088,7570698,7570690,'ity',16.667,1),(1088,7570699,7570693,'pat',50,1),(1088,7570700,7570693,'ath',50,1),(1088,7570701,7570699,'fou',50,1),(1088,7570702,7570699,'our',50,1),(1088,7570703,7570701,'fre',14.286,1),(1088,7570704,7570701,'ree',14.286,1),(1088,7570705,7570701,'ees',14.286,1),(1088,7570706,7570701,'esp',14.286,1),(1088,7570707,7570701,'spa',14.286,1),(1088,7570708,7570701,'pac',14.286,1),(1088,7570709,7570701,'ace',14.286,1),(1088,7570710,7570703,'dis',50,1),(1088,7570711,7570703,'isk',50,1),(1088,7570712,7570710,'ind',33.333,1),(1088,7570713,7570710,'nde',33.333,1),(1088,7570714,7570710,'dex',33.333,1),(1088,7570715,7570712,'adm',8.333,1),(1088,7570716,7570712,'dmi',8.333,1),(1088,7570717,7570712,'min',8.333,1),(1088,7570718,7570712,'ini',8.333,1),(1088,7570719,7570712,'nis',8.333,1),(1088,7570720,7570712,'ist',8.333,1),(1088,7570721,7570712,'str',8.333,1),(1088,7570722,7570712,'tra',8.333,1),(1088,7570723,7570712,'rat',8.333,1),(1088,7570724,7570712,'ati',8.333,1),(1088,7570725,7570712,'tio',8.333,1),(1088,7570726,7570712,'ion',8.333,1),(1088,7570727,7570715,'sta',33.333,3),(1088,7570728,7570715,'tat',33.333,3),(1088,7570729,7570715,'ate',33.333,3),(1088,7570730,7570727,'dis',16.667,4),(1088,7570731,7570727,'isa',16.667,4),(1088,7570732,7570727,'sab',16.667,4),(1088,7570733,7570727,'abl',16.667,4),(1088,7570734,7570727,'ble',16.667,4),(1088,7570735,7570727,'led',16.667,4),(1088,7570736,7570730,'cac',33.333,1),(1088,7570737,7570730,'ach',33.333,1),(1088,7570738,7570730,'che',33.333,1),(1088,7570739,7570736,'mod',50,1),(1088,7570740,7570736,'ode',50,1),(1088,7570741,7570739,'wri',14.286,1),(1088,7570742,7570739,'rit',14.286,1),(1088,7570743,7570739,'ite',14.286,1),(1088,7570744,7570739,'tet',14.286,1),(1088,7570745,7570739,'eth',14.286,1),(1088,7570746,7570739,'thr',14.286,1),(1088,7570747,7570739,'hru',14.286,1),(1088,7570748,7570741,'ope',11.111,2),(1088,7570749,7570741,'per',11.111,2),(1088,7570750,7570741,'era',11.111,2),(1088,7570751,7570741,'rat',11.111,2),(1088,7570752,7570741,'ati',11.111,2),(1088,7570753,7570741,'tio',11.111,2),(1088,7570754,7570741,'ion',11.111,2),(1088,7570755,7570741,'ona',11.111,2),(1088,7570756,7570741,'nal',11.111,2),(1088,7570757,7570748,'mes',20,1),(1088,7570758,7570748,'ess',20,1),(1088,7570759,7570748,'ssa',20,1),(1088,7570760,7570748,'sag',20,1),(1088,7570761,7570748,'age',20,1),(1088,7570762,7570757,'per',11.111,1),(1088,7570763,7570757,'erf',11.111,1),(1088,7570764,7570757,'rfo',11.111,1),(1088,7570765,7570757,'for',11.111,1),(1088,7570766,7570757,'orm',11.111,1),(1088,7570767,7570757,'rma',11.111,1),(1088,7570768,7570757,'man',11.111,1),(1088,7570769,7570757,'anc',11.111,1),(1088,7570770,7570757,'nce',11.111,1),(1088,7570771,7570762,'ide',12.5,1),(1088,7570772,7570762,'den',12.5,1),(1088,7570773,7570762,'ent',12.5,1),(1088,7570774,7570762,'nti',12.5,1),(1088,7570775,7570762,'tif',12.5,1),(1088,7570776,7570762,'ifi',12.5,1),(1088,7570777,7570762,'fie',12.5,1),(1088,7570778,7570762,'ier',12.5,1),(1088,7570779,7570771,'vdi',33.333,3),(1088,7570780,7570771,'dis',33.333,3),(1088,7570781,7570771,'isk',33.333,3),(1088,7570782,7570779,'nam',50,1),(1088,7570783,7570779,'ame',50,1),(1088,7570784,7570782,'typ',50,1),(1088,7570785,7570782,'ype',50,1),(1088,7570786,7570784,'dir',25,1),(1088,7570787,7570784,'ire',25,1),(1088,7570788,7570784,'rec',25,1),(1088,7570789,7570784,'ect',25,1),(1089,7570791,7570790,'naa',100,2),(1089,7570792,7570791,'600',3.333,3),(1089,7570793,7570791,'000',3.333,3),(1089,7570794,7570791,'00c',3.333,3),(1089,7570795,7570791,'0c2',3.333,3),(1089,7570796,7570791,'c29',3.333,3),(1089,7570797,7570791,'298',3.333,3),(1089,7570798,7570791,'98f',3.333,3),(1089,7570799,7570791,'8f3',3.333,3),(1089,7570800,7570791,'f36',3.333,3),(1089,7570801,7570791,'367',3.333,3),(1089,7570802,7570791,'677',3.333,3),(1089,7570803,7570791,'775',3.333,3),(1089,7570804,7570791,'754',3.333,3),(1089,7570805,7570791,'54e',3.333,3),(1089,7570806,7570791,'4e6',3.333,3),(1089,7570807,7570791,'e66',3.333,3),(1089,7570808,7570791,'66b',3.333,3),(1089,7570809,7570791,'6b3',3.333,3),(1089,7570810,7570791,'b3f',3.333,3),(1089,7570811,7570791,'3fd',3.333,3),(1089,7570812,7570791,'fd6',3.333,3),(1089,7570813,7570791,'d6f',3.333,3),(1089,7570814,7570791,'6f5',3.333,3),(1089,7570815,7570791,'f5a',3.333,3),(1089,7570816,7570791,'5a0',3.333,3),(1089,7570817,7570791,'a08',3.333,3),(1089,7570818,7570791,'08f',3.333,3),(1089,7570819,7570791,'8f0',3.333,3),(1089,7570820,7570791,'f06',3.333,3),(1089,7570821,7570791,'06c',3.333,3),(1089,7570822,7570792,'mon',100,1),(1089,7570823,7570822,'201',50,1),(1089,7570824,7570822,'013',50,1),(1089,7570825,7570823,'adm',33.333,4),(1089,7570826,7570823,'dmi',33.333,4),(1089,7570827,7570823,'min',33.333,4),(1089,7570828,7570825,'cap',16.667,1),(1089,7570829,7570825,'apa',16.667,1),(1089,7570830,7570825,'pac',16.667,1),(1089,7570831,7570825,'aci',16.667,1),(1089,7570832,7570825,'cit',16.667,1),(1089,7570833,7570825,'ity',16.667,1),(1089,7570834,7570828,'pat',50,1),(1089,7570835,7570828,'ath',50,1),(1089,7570836,7570834,'fiv',50,1),(1089,7570837,7570834,'ive',50,1),(1089,7570838,7570836,'fre',14.286,1),(1089,7570839,7570836,'ree',14.286,1),(1089,7570840,7570836,'ees',14.286,1),(1089,7570841,7570836,'esp',14.286,1),(1089,7570842,7570836,'spa',14.286,1),(1089,7570843,7570836,'pac',14.286,1),(1089,7570844,7570836,'ace',14.286,1),(1089,7570845,7570838,'dis',50,1),(1089,7570846,7570838,'isk',50,1),(1089,7570847,7570845,'ind',33.333,1),(1089,7570848,7570845,'nde',33.333,1),(1089,7570849,7570845,'dex',33.333,1),(1089,7570850,7570847,'adm',8.333,1),(1089,7570851,7570847,'dmi',8.333,1),(1089,7570852,7570847,'min',8.333,1),(1089,7570853,7570847,'ini',8.333,1),(1089,7570854,7570847,'nis',8.333,1),(1089,7570855,7570847,'ist',8.333,1),(1089,7570856,7570847,'str',8.333,1),(1089,7570857,7570847,'tra',8.333,1),(1089,7570858,7570847,'rat',8.333,1),(1089,7570859,7570847,'ati',8.333,1),(1089,7570860,7570847,'tio',8.333,1),(1089,7570861,7570847,'ion',8.333,1),(1089,7570862,7570850,'sta',33.333,3),(1089,7570863,7570850,'tat',33.333,3),(1089,7570864,7570850,'ate',33.333,3),(1089,7570865,7570862,'dis',16.667,4),(1089,7570866,7570862,'isa',16.667,4),(1089,7570867,7570862,'sab',16.667,4),(1089,7570868,7570862,'abl',16.667,4),(1089,7570869,7570862,'ble',16.667,4),(1089,7570870,7570862,'led',16.667,4),(1089,7570871,7570865,'cac',33.333,1),(1089,7570872,7570865,'ach',33.333,1),(1089,7570873,7570865,'che',33.333,1),(1089,7570874,7570871,'mod',50,1),(1089,7570875,7570871,'ode',50,1),(1089,7570876,7570874,'wri',14.286,1),(1089,7570877,7570874,'rit',14.286,1),(1089,7570878,7570874,'ite',14.286,1),(1089,7570879,7570874,'tet',14.286,1),(1089,7570880,7570874,'eth',14.286,1),(1089,7570881,7570874,'thr',14.286,1),(1089,7570882,7570874,'hru',14.286,1),(1089,7570883,7570876,'ope',11.111,2),(1089,7570884,7570876,'per',11.111,2),(1089,7570885,7570876,'era',11.111,2),(1089,7570886,7570876,'rat',11.111,2),(1089,7570887,7570876,'ati',11.111,2),(1089,7570888,7570876,'tio',11.111,2),(1089,7570889,7570876,'ion',11.111,2),(1089,7570890,7570876,'ona',11.111,2),(1089,7570891,7570876,'nal',11.111,2),(1089,7570892,7570883,'mes',20,1),(1089,7570893,7570883,'ess',20,1),(1089,7570894,7570883,'ssa',20,1),(1089,7570895,7570883,'sag',20,1),(1089,7570896,7570883,'age',20,1),(1089,7570897,7570892,'per',11.111,1),(1089,7570898,7570892,'erf',11.111,1),(1089,7570899,7570892,'rfo',11.111,1),(1089,7570900,7570892,'for',11.111,1),(1089,7570901,7570892,'orm',11.111,1),(1089,7570902,7570892,'rma',11.111,1),(1089,7570903,7570892,'man',11.111,1),(1089,7570904,7570892,'anc',11.111,1),(1089,7570905,7570892,'nce',11.111,1),(1089,7570906,7570897,'ide',12.5,1),(1089,7570907,7570897,'den',12.5,1),(1089,7570908,7570897,'ent',12.5,1),(1089,7570909,7570897,'nti',12.5,1),(1089,7570910,7570897,'tif',12.5,1),(1089,7570911,7570897,'ifi',12.5,1),(1089,7570912,7570897,'fie',12.5,1),(1089,7570913,7570897,'ier',12.5,1),(1089,7570914,7570906,'vdi',33.333,3),(1089,7570915,7570906,'dis',33.333,3),(1089,7570916,7570906,'isk',33.333,3),(1089,7570917,7570914,'nam',50,1),(1089,7570918,7570914,'ame',50,1),(1089,7570919,7570917,'typ',50,1),(1089,7570920,7570917,'ype',50,1),(1089,7570921,7570919,'dir',25,1),(1089,7570922,7570919,'ire',25,1),(1089,7570923,7570919,'rec',25,1),(1089,7570924,7570919,'ect',25,1),(1090,7570926,7570925,'naa',100,2),(1090,7570927,7570926,'600',3.333,3),(1090,7570928,7570926,'000',3.333,3),(1090,7570929,7570926,'00c',3.333,3),(1090,7570930,7570926,'0c2',3.333,3),(1090,7570931,7570926,'c29',3.333,3),(1090,7570932,7570926,'299',3.333,3),(1090,7570933,7570926,'999',3.333,3),(1090,7570934,7570926,'992',3.333,3),(1090,7570935,7570926,'92e',3.333,3),(1090,7570936,7570926,'2ec',3.333,3),(1090,7570937,7570926,'ecc',3.333,3),(1090,7570938,7570926,'cce',3.333,3),(1090,7570939,7570926,'cec',3.333,3),(1090,7570940,7570926,'ecd',3.333,3),(1090,7570941,7570926,'cdc',3.333,3),(1090,7570942,7570926,'dc5',3.333,3),(1090,7570943,7570926,'c54',3.333,3),(1090,7570944,7570926,'54a',3.333,3),(1090,7570945,7570926,'4ad',3.333,3),(1090,7570946,7570926,'ad8',3.333,3),(1090,7570947,7570926,'d8a',3.333,3),(1090,7570948,7570926,'8a4',3.333,3),(1090,7570949,7570926,'a48',3.333,3),(1090,7570950,7570926,'48e',3.333,3),(1090,7570951,7570926,'8e1',3.333,3),(1090,7570952,7570926,'e11',3.333,3),(1090,7570953,7570926,'111',3.333,3),(1090,7570954,7570926,'11d',3.333,3),(1090,7570955,7570926,'1d0',3.333,3),(1090,7570956,7570926,'d0b',3.333,3),(1090,7570957,7570927,'mon',100,1),(1090,7570958,7570957,'201',50,1),(1090,7570959,7570957,'013',50,1),(1090,7570960,7570958,'adm',33.333,4),(1090,7570961,7570958,'dmi',33.333,4),(1090,7570962,7570958,'min',33.333,4),(1090,7570963,7570960,'cap',16.667,1),(1090,7570964,7570960,'apa',16.667,1),(1090,7570965,7570960,'pac',16.667,1),(1090,7570966,7570960,'aci',16.667,1),(1090,7570967,7570960,'cit',16.667,1),(1090,7570968,7570960,'ity',16.667,1),(1090,7570969,7570963,'pat',50,1),(1090,7570970,7570963,'ath',50,1),(1090,7570971,7570969,'six',100,1),(1090,7570972,7570971,'fre',14.286,1),(1090,7570973,7570971,'ree',14.286,1),(1090,7570974,7570971,'ees',14.286,1),(1090,7570975,7570971,'esp',14.286,1),(1090,7570976,7570971,'spa',14.286,1),(1090,7570977,7570971,'pac',14.286,1),(1090,7570978,7570971,'ace',14.286,1),(1090,7570979,7570972,'dis',50,1),(1090,7570980,7570972,'isk',50,1),(1090,7570981,7570979,'ind',33.333,1),(1090,7570982,7570979,'nde',33.333,1),(1090,7570983,7570979,'dex',33.333,1),(1090,7570984,7570981,'adm',8.333,1),(1090,7570985,7570981,'dmi',8.333,1),(1090,7570986,7570981,'min',8.333,1),(1090,7570987,7570981,'ini',8.333,1),(1090,7570988,7570981,'nis',8.333,1),(1090,7570989,7570981,'ist',8.333,1),(1090,7570990,7570981,'str',8.333,1),(1090,7570991,7570981,'tra',8.333,1),(1090,7570992,7570981,'rat',8.333,1),(1090,7570993,7570981,'ati',8.333,1),(1090,7570994,7570981,'tio',8.333,1),(1090,7570995,7570981,'ion',8.333,1),(1090,7570996,7570984,'sta',33.333,3),(1090,7570997,7570984,'tat',33.333,3),(1090,7570998,7570984,'ate',33.333,3),(1090,7570999,7570996,'dis',16.667,4),(1090,7571000,7570996,'isa',16.667,4),(1090,7571001,7570996,'sab',16.667,4),(1090,7571002,7570996,'abl',16.667,4),(1090,7571003,7570996,'ble',16.667,4),(1090,7571004,7570996,'led',16.667,4),(1090,7571005,7570999,'cac',33.333,1),(1090,7571006,7570999,'ach',33.333,1),(1090,7571007,7570999,'che',33.333,1),(1090,7571008,7571005,'mod',50,1),(1090,7571009,7571005,'ode',50,1),(1090,7571010,7571008,'wri',14.286,1),(1090,7571011,7571008,'rit',14.286,1),(1090,7571012,7571008,'ite',14.286,1),(1090,7571013,7571008,'tet',14.286,1),(1090,7571014,7571008,'eth',14.286,1),(1090,7571015,7571008,'thr',14.286,1),(1090,7571016,7571008,'hru',14.286,1),(1090,7571017,7571010,'ope',11.111,2),(1090,7571018,7571010,'per',11.111,2),(1090,7571019,7571010,'era',11.111,2),(1090,7571020,7571010,'rat',11.111,2),(1090,7571021,7571010,'ati',11.111,2),(1090,7571022,7571010,'tio',11.111,2),(1090,7571023,7571010,'ion',11.111,2),(1090,7571024,7571010,'ona',11.111,2),(1090,7571025,7571010,'nal',11.111,2),(1090,7571026,7571017,'mes',20,1),(1090,7571027,7571017,'ess',20,1),(1090,7571028,7571017,'ssa',20,1),(1090,7571029,7571017,'sag',20,1),(1090,7571030,7571017,'age',20,1),(1090,7571031,7571026,'per',11.111,1),(1090,7571032,7571026,'erf',11.111,1),(1090,7571033,7571026,'rfo',11.111,1),(1090,7571034,7571026,'for',11.111,1),(1090,7571035,7571026,'orm',11.111,1),(1090,7571036,7571026,'rma',11.111,1),(1090,7571037,7571026,'man',11.111,1),(1090,7571038,7571026,'anc',11.111,1),(1090,7571039,7571026,'nce',11.111,1),(1090,7571040,7571031,'ide',12.5,1),(1090,7571041,7571031,'den',12.5,1),(1090,7571042,7571031,'ent',12.5,1),(1090,7571043,7571031,'nti',12.5,1),(1090,7571044,7571031,'tif',12.5,1),(1090,7571045,7571031,'ifi',12.5,1),(1090,7571046,7571031,'fie',12.5,1),(1090,7571047,7571031,'ier',12.5,1),(1090,7571048,7571040,'vdi',33.333,3),(1090,7571049,7571040,'dis',33.333,3),(1090,7571050,7571040,'isk',33.333,3),(1090,7571051,7571048,'nam',50,1),(1090,7571052,7571048,'ame',50,1),(1090,7571053,7571051,'typ',50,1),(1090,7571054,7571051,'ype',50,1),(1090,7571055,7571053,'dir',25,1),(1090,7571056,7571053,'ire',25,1),(1090,7571057,7571053,'rec',25,1),(1090,7571058,7571053,'ect',25,1),(1091,7571060,7571059,'naa',100,2),(1091,7571061,7571060,'600',3.333,3),(1091,7571062,7571060,'000',3.333,3),(1091,7571063,7571060,'00c',3.333,3),(1091,7571064,7571060,'0c2',3.333,3),(1091,7571065,7571060,'c29',3.333,3),(1091,7571066,7571060,'29c',3.333,3),(1091,7571067,7571060,'9ce',3.333,3),(1091,7571068,7571060,'ce4',3.333,3),(1091,7571069,7571060,'e4b',3.333,3),(1091,7571070,7571060,'4b7',3.333,3),(1091,7571071,7571060,'b79',3.333,3),(1091,7571072,7571060,'793',3.333,3),(1091,7571073,7571060,'931',3.333,3),(1091,7571074,7571060,'31e',3.333,3),(1091,7571075,7571060,'1ea',3.333,3),(1091,7571076,7571060,'ead',3.333,3),(1091,7571077,7571060,'adc',3.333,3),(1091,7571078,7571060,'dcd',3.333,3),(1091,7571079,7571060,'cdf',3.333,3),(1091,7571080,7571060,'dfb',3.333,3),(1091,7571081,7571060,'fb3',3.333,3),(1091,7571082,7571060,'b3e',3.333,3),(1091,7571083,7571060,'3ef',3.333,3),(1091,7571084,7571060,'ef3',3.333,3),(1091,7571085,7571060,'f30',3.333,3),(1091,7571086,7571060,'301',3.333,3),(1091,7571087,7571060,'01b',3.333,3),(1091,7571088,7571060,'1be',3.333,3),(1091,7571089,7571060,'be7',3.333,3),(1091,7571090,7571060,'e70',3.333,3),(1091,7571091,7571061,'mon',100,1),(1091,7571092,7571091,'201',50,1),(1091,7571093,7571091,'013',50,1),(1091,7571094,7571092,'adm',33.333,4),(1091,7571095,7571092,'dmi',33.333,4),(1091,7571096,7571092,'min',33.333,4),(1091,7571097,7571094,'cap',16.667,1),(1091,7571098,7571094,'apa',16.667,1),(1091,7571099,7571094,'pac',16.667,1),(1091,7571100,7571094,'aci',16.667,1),(1091,7571101,7571094,'cit',16.667,1),(1091,7571102,7571094,'ity',16.667,1),(1091,7571103,7571097,'pat',50,1),(1091,7571104,7571097,'ath',50,1),(1091,7571105,7571103,'sev',33.333,1),(1091,7571106,7571103,'eve',33.333,1),(1091,7571107,7571103,'ven',33.333,1),(1091,7571108,7571105,'fre',14.286,1),(1091,7571109,7571105,'ree',14.286,1),(1091,7571110,7571105,'ees',14.286,1),(1091,7571111,7571105,'esp',14.286,1),(1091,7571112,7571105,'spa',14.286,1),(1091,7571113,7571105,'pac',14.286,1),(1091,7571114,7571105,'ace',14.286,1),(1091,7571115,7571108,'dis',50,1),(1091,7571116,7571108,'isk',50,1),(1091,7571117,7571115,'ind',33.333,1),(1091,7571118,7571115,'nde',33.333,1),(1091,7571119,7571115,'dex',33.333,1),(1091,7571120,7571117,'adm',8.333,1),(1091,7571121,7571117,'dmi',8.333,1),(1091,7571122,7571117,'min',8.333,1),(1091,7571123,7571117,'ini',8.333,1),(1091,7571124,7571117,'nis',8.333,1),(1091,7571125,7571117,'ist',8.333,1),(1091,7571126,7571117,'str',8.333,1),(1091,7571127,7571117,'tra',8.333,1),(1091,7571128,7571117,'rat',8.333,1),(1091,7571129,7571117,'ati',8.333,1),(1091,7571130,7571117,'tio',8.333,1),(1091,7571131,7571117,'ion',8.333,1),(1091,7571132,7571120,'sta',33.333,3),(1091,7571133,7571120,'tat',33.333,3),(1091,7571134,7571120,'ate',33.333,3),(1091,7571135,7571132,'dis',16.667,4),(1091,7571136,7571132,'isa',16.667,4),(1091,7571137,7571132,'sab',16.667,4),(1091,7571138,7571132,'abl',16.667,4),(1091,7571139,7571132,'ble',16.667,4),(1091,7571140,7571132,'led',16.667,4),(1091,7571141,7571135,'cac',33.333,1),(1091,7571142,7571135,'ach',33.333,1),(1091,7571143,7571135,'che',33.333,1),(1091,7571144,7571141,'mod',50,1),(1091,7571145,7571141,'ode',50,1),(1091,7571146,7571144,'wri',14.286,1),(1091,7571147,7571144,'rit',14.286,1),(1091,7571148,7571144,'ite',14.286,1),(1091,7571149,7571144,'tet',14.286,1),(1091,7571150,7571144,'eth',14.286,1),(1091,7571151,7571144,'thr',14.286,1),(1091,7571152,7571144,'hru',14.286,1),(1091,7571153,7571146,'ope',11.111,2),(1091,7571154,7571146,'per',11.111,2),(1091,7571155,7571146,'era',11.111,2),(1091,7571156,7571146,'rat',11.111,2),(1091,7571157,7571146,'ati',11.111,2),(1091,7571158,7571146,'tio',11.111,2),(1091,7571159,7571146,'ion',11.111,2),(1091,7571160,7571146,'ona',11.111,2),(1091,7571161,7571146,'nal',11.111,2),(1091,7571162,7571153,'mes',20,1),(1091,7571163,7571153,'ess',20,1),(1091,7571164,7571153,'ssa',20,1),(1091,7571165,7571153,'sag',20,1),(1091,7571166,7571153,'age',20,1),(1091,7571167,7571162,'per',11.111,1),(1091,7571168,7571162,'erf',11.111,1),(1091,7571169,7571162,'rfo',11.111,1),(1091,7571170,7571162,'for',11.111,1),(1091,7571171,7571162,'orm',11.111,1),(1091,7571172,7571162,'rma',11.111,1),(1091,7571173,7571162,'man',11.111,1),(1091,7571174,7571162,'anc',11.111,1),(1091,7571175,7571162,'nce',11.111,1),(1091,7571176,7571167,'ide',12.5,1),(1091,7571177,7571167,'den',12.5,1),(1091,7571178,7571167,'ent',12.5,1),(1091,7571179,7571167,'nti',12.5,1),(1091,7571180,7571167,'tif',12.5,1),(1091,7571181,7571167,'ifi',12.5,1),(1091,7571182,7571167,'fie',12.5,1),(1091,7571183,7571167,'ier',12.5,1),(1091,7571184,7571176,'vdi',33.333,3),(1091,7571185,7571176,'dis',33.333,3),(1091,7571186,7571176,'isk',33.333,3),(1091,7571187,7571184,'nam',50,1),(1091,7571188,7571184,'ame',50,1),(1091,7571189,7571187,'typ',50,1),(1091,7571190,7571187,'ype',50,1),(1091,7571191,7571189,'dir',25,1),(1091,7571192,7571189,'ire',25,1),(1091,7571193,7571189,'rec',25,1),(1091,7571194,7571189,'ect',25,1),(1092,7571196,7571195,'naa',100,2),(1092,7571197,7571196,'600',3.333,3),(1092,7571198,7571196,'000',3.333,3),(1092,7571199,7571196,'00c',3.333,3),(1092,7571200,7571196,'0c2',3.333,3),(1092,7571201,7571196,'c29',3.333,3),(1092,7571202,7571196,'298',3.333,3),(1092,7571203,7571196,'989',3.333,3),(1092,7571204,7571196,'898',3.333,3),(1092,7571205,7571196,'98d',3.333,3),(1092,7571206,7571196,'8d9',3.333,3),(1092,7571207,7571196,'d95',3.333,3),(1092,7571208,7571196,'953',3.333,3),(1092,7571209,7571196,'53a',3.333,3),(1092,7571210,7571196,'3aa',3.333,3),(1092,7571211,7571196,'aab',3.333,3),(1092,7571212,7571196,'abd',3.333,3),(1092,7571213,7571196,'bd7',3.333,3),(1092,7571214,7571196,'d7f',3.333,3),(1092,7571215,7571196,'7fa',3.333,3),(1092,7571216,7571196,'fa7',3.333,3),(1092,7571217,7571196,'a78',3.333,3),(1092,7571218,7571196,'78e',3.333,3),(1092,7571219,7571196,'8e0',3.333,3),(1092,7571220,7571196,'e08',3.333,3),(1092,7571221,7571196,'08a',3.333,3),(1092,7571222,7571196,'8a8',3.333,3),(1092,7571223,7571196,'a87',3.333,3),(1092,7571224,7571196,'871',3.333,3),(1092,7571225,7571196,'71d',3.333,3),(1092,7571226,7571196,'1d2',3.333,3),(1092,7571227,7571197,'mon',100,1),(1092,7571228,7571227,'201',50,1),(1092,7571229,7571227,'013',50,1),(1092,7571230,7571228,'adm',33.333,4),(1092,7571231,7571228,'dmi',33.333,4),(1092,7571232,7571228,'min',33.333,4),(1092,7571233,7571230,'cap',16.667,1),(1092,7571234,7571230,'apa',16.667,1),(1092,7571235,7571230,'pac',16.667,1),(1092,7571236,7571230,'aci',16.667,1),(1092,7571237,7571230,'cit',16.667,1),(1092,7571238,7571230,'ity',16.667,1),(1092,7571239,7571233,'pat',50,1),(1092,7571240,7571233,'ath',50,1),(1092,7571241,7571239,'eig',33.333,1),(1092,7571242,7571239,'igh',33.333,1),(1092,7571243,7571239,'ght',33.333,1),(1092,7571244,7571241,'fre',14.286,1),(1092,7571245,7571241,'ree',14.286,1),(1092,7571246,7571241,'ees',14.286,1),(1092,7571247,7571241,'esp',14.286,1),(1092,7571248,7571241,'spa',14.286,1),(1092,7571249,7571241,'pac',14.286,1),(1092,7571250,7571241,'ace',14.286,1),(1092,7571251,7571244,'dis',50,1),(1092,7571252,7571244,'isk',50,1),(1092,7571253,7571251,'ind',33.333,1),(1092,7571254,7571251,'nde',33.333,1),(1092,7571255,7571251,'dex',33.333,1),(1092,7571256,7571253,'adm',8.333,1),(1092,7571257,7571253,'dmi',8.333,1),(1092,7571258,7571253,'min',8.333,1),(1092,7571259,7571253,'ini',8.333,1),(1092,7571260,7571253,'nis',8.333,1),(1092,7571261,7571253,'ist',8.333,1),(1092,7571262,7571253,'str',8.333,1),(1092,7571263,7571253,'tra',8.333,1),(1092,7571264,7571253,'rat',8.333,1),(1092,7571265,7571253,'ati',8.333,1),(1092,7571266,7571253,'tio',8.333,1),(1092,7571267,7571253,'ion',8.333,1),(1092,7571268,7571256,'sta',33.333,3),(1092,7571269,7571256,'tat',33.333,3),(1092,7571270,7571256,'ate',33.333,3),(1092,7571271,7571268,'dis',16.667,4),(1092,7571272,7571268,'isa',16.667,4),(1092,7571273,7571268,'sab',16.667,4),(1092,7571274,7571268,'abl',16.667,4),(1092,7571275,7571268,'ble',16.667,4),(1092,7571276,7571268,'led',16.667,4),(1092,7571277,7571271,'cac',33.333,1),(1092,7571278,7571271,'ach',33.333,1),(1092,7571279,7571271,'che',33.333,1),(1092,7571280,7571277,'mod',50,1),(1092,7571281,7571277,'ode',50,1),(1092,7571282,7571280,'wri',14.286,1),(1092,7571283,7571280,'rit',14.286,1),(1092,7571284,7571280,'ite',14.286,1),(1092,7571285,7571280,'tet',14.286,1),(1092,7571286,7571280,'eth',14.286,1),(1092,7571287,7571280,'thr',14.286,1),(1092,7571288,7571280,'hru',14.286,1),(1092,7571289,7571282,'ope',11.111,2),(1092,7571290,7571282,'per',11.111,2),(1092,7571291,7571282,'era',11.111,2),(1092,7571292,7571282,'rat',11.111,2),(1092,7571293,7571282,'ati',11.111,2),(1092,7571294,7571282,'tio',11.111,2),(1092,7571295,7571282,'ion',11.111,2),(1092,7571296,7571282,'ona',11.111,2),(1092,7571297,7571282,'nal',11.111,2),(1092,7571298,7571289,'mes',20,1),(1092,7571299,7571289,'ess',20,1),(1092,7571300,7571289,'ssa',20,1),(1092,7571301,7571289,'sag',20,1),(1092,7571302,7571289,'age',20,1),(1092,7571303,7571298,'per',11.111,1),(1092,7571304,7571298,'erf',11.111,1),(1092,7571305,7571298,'rfo',11.111,1),(1092,7571306,7571298,'for',11.111,1),(1092,7571307,7571298,'orm',11.111,1),(1092,7571308,7571298,'rma',11.111,1),(1092,7571309,7571298,'man',11.111,1),(1092,7571310,7571298,'anc',11.111,1),(1092,7571311,7571298,'nce',11.111,1),(1092,7571312,7571303,'ide',12.5,1),(1092,7571313,7571303,'den',12.5,1),(1092,7571314,7571303,'ent',12.5,1),(1092,7571315,7571303,'nti',12.5,1),(1092,7571316,7571303,'tif',12.5,1),(1092,7571317,7571303,'ifi',12.5,1),(1092,7571318,7571303,'fie',12.5,1),(1092,7571319,7571303,'ier',12.5,1),(1092,7571320,7571312,'vdi',33.333,3),(1092,7571321,7571312,'dis',33.333,3),(1092,7571322,7571312,'isk',33.333,3),(1092,7571323,7571320,'nam',50,1),(1092,7571324,7571320,'ame',50,1),(1092,7571325,7571323,'typ',50,1),(1092,7571326,7571323,'ype',50,1),(1092,7571327,7571325,'dir',25,1),(1092,7571328,7571325,'ire',25,1),(1092,7571329,7571325,'rec',25,1),(1092,7571330,7571325,'ect',25,1),(1093,7571332,7571331,'naa',100,2),(1093,7571333,7571332,'600',3.333,3),(1093,7571334,7571332,'000',3.333,3),(1093,7571335,7571332,'00c',3.333,3),(1093,7571336,7571332,'0c2',3.333,3),(1093,7571337,7571332,'c29',3.333,3),(1093,7571338,7571332,'298',3.333,3),(1093,7571339,7571332,'984',3.333,3),(1093,7571340,7571332,'848',3.333,3),(1093,7571341,7571332,'484',3.333,3),(1093,7571342,7571332,'84c',3.333,3),(1093,7571343,7571332,'4c4',3.333,3),(1093,7571344,7571332,'c4a',3.333,3),(1093,7571345,7571332,'4a9',3.333,3),(1093,7571346,7571332,'a9c',3.333,3),(1093,7571347,7571332,'9c4',3.333,3),(1093,7571348,7571332,'c44',3.333,3),(1093,7571349,7571332,'44b',3.333,3),(1093,7571350,7571332,'4b5',3.333,3),(1093,7571351,7571332,'b5f',3.333,3),(1093,7571352,7571332,'5fc',3.333,3),(1093,7571353,7571332,'fc5',3.333,3),(1093,7571354,7571332,'c57',3.333,3),(1093,7571355,7571332,'573',3.333,3),(1093,7571356,7571332,'734',3.333,3),(1093,7571357,7571332,'345',3.333,3),(1093,7571358,7571332,'45b',3.333,3),(1093,7571359,7571332,'5b0',3.333,3),(1093,7571360,7571332,'b09',3.333,3),(1093,7571361,7571332,'09e',3.333,3),(1093,7571362,7571332,'9e8',3.333,3),(1093,7571363,7571333,'mon',100,1),(1093,7571364,7571363,'201',50,1),(1093,7571365,7571363,'013',50,1),(1093,7571366,7571364,'adm',33.333,4),(1093,7571367,7571364,'dmi',33.333,4),(1093,7571368,7571364,'min',33.333,4),(1093,7571369,7571366,'cap',16.667,1),(1093,7571370,7571366,'apa',16.667,1),(1093,7571371,7571366,'pac',16.667,1),(1093,7571372,7571366,'aci',16.667,1),(1093,7571373,7571366,'cit',16.667,1),(1093,7571374,7571366,'ity',16.667,1),(1093,7571375,7571369,'pat',50,1),(1093,7571376,7571369,'ath',50,1),(1093,7571377,7571375,'nin',50,1),(1093,7571378,7571375,'ine',50,1),(1093,7571379,7571377,'fre',14.286,1),(1093,7571380,7571377,'ree',14.286,1),(1093,7571381,7571377,'ees',14.286,1),(1093,7571382,7571377,'esp',14.286,1),(1093,7571383,7571377,'spa',14.286,1),(1093,7571384,7571377,'pac',14.286,1),(1093,7571385,7571377,'ace',14.286,1),(1093,7571386,7571379,'dis',50,1),(1093,7571387,7571379,'isk',50,1),(1093,7571388,7571386,'ind',33.333,1),(1093,7571389,7571386,'nde',33.333,1),(1093,7571390,7571386,'dex',33.333,1),(1093,7571391,7571388,'adm',8.333,1),(1093,7571392,7571388,'dmi',8.333,1),(1093,7571393,7571388,'min',8.333,1),(1093,7571394,7571388,'ini',8.333,1),(1093,7571395,7571388,'nis',8.333,1),(1093,7571396,7571388,'ist',8.333,1),(1093,7571397,7571388,'str',8.333,1),(1093,7571398,7571388,'tra',8.333,1),(1093,7571399,7571388,'rat',8.333,1),(1093,7571400,7571388,'ati',8.333,1),(1093,7571401,7571388,'tio',8.333,1),(1093,7571402,7571388,'ion',8.333,1),(1093,7571403,7571391,'sta',33.333,3),(1093,7571404,7571391,'tat',33.333,3),(1093,7571405,7571391,'ate',33.333,3),(1093,7571406,7571403,'dis',16.667,4),(1093,7571407,7571403,'isa',16.667,4),(1093,7571408,7571403,'sab',16.667,4),(1093,7571409,7571403,'abl',16.667,4),(1093,7571410,7571403,'ble',16.667,4),(1093,7571411,7571403,'led',16.667,4),(1093,7571412,7571406,'cac',33.333,1),(1093,7571413,7571406,'ach',33.333,1),(1093,7571414,7571406,'che',33.333,1),(1093,7571415,7571412,'mod',50,1),(1093,7571416,7571412,'ode',50,1),(1093,7571417,7571415,'wri',14.286,1),(1093,7571418,7571415,'rit',14.286,1),(1093,7571419,7571415,'ite',14.286,1),(1093,7571420,7571415,'tet',14.286,1),(1093,7571421,7571415,'eth',14.286,1),(1093,7571422,7571415,'thr',14.286,1),(1093,7571423,7571415,'hru',14.286,1),(1093,7571424,7571417,'ope',11.111,2),(1093,7571425,7571417,'per',11.111,2),(1093,7571426,7571417,'era',11.111,2),(1093,7571427,7571417,'rat',11.111,2),(1093,7571428,7571417,'ati',11.111,2),(1093,7571429,7571417,'tio',11.111,2),(1093,7571430,7571417,'ion',11.111,2),(1093,7571431,7571417,'ona',11.111,2),(1093,7571432,7571417,'nal',11.111,2),(1093,7571433,7571424,'mes',20,1),(1093,7571434,7571424,'ess',20,1),(1093,7571435,7571424,'ssa',20,1),(1093,7571436,7571424,'sag',20,1),(1093,7571437,7571424,'age',20,1),(1093,7571438,7571433,'per',11.111,1),(1093,7571439,7571433,'erf',11.111,1),(1093,7571440,7571433,'rfo',11.111,1),(1093,7571441,7571433,'for',11.111,1),(1093,7571442,7571433,'orm',11.111,1),(1093,7571443,7571433,'rma',11.111,1),(1093,7571444,7571433,'man',11.111,1),(1093,7571445,7571433,'anc',11.111,1),(1093,7571446,7571433,'nce',11.111,1),(1093,7571447,7571438,'ide',12.5,1),(1093,7571448,7571438,'den',12.5,1),(1093,7571449,7571438,'ent',12.5,1),(1093,7571450,7571438,'nti',12.5,1),(1093,7571451,7571438,'tif',12.5,1),(1093,7571452,7571438,'ifi',12.5,1),(1093,7571453,7571438,'fie',12.5,1),(1093,7571454,7571438,'ier',12.5,1),(1093,7571455,7571447,'vdi',33.333,3),(1093,7571456,7571447,'dis',33.333,3),(1093,7571457,7571447,'isk',33.333,3),(1093,7571458,7571455,'nam',50,1),(1093,7571459,7571455,'ame',50,1),(1093,7571460,7571458,'typ',50,1),(1093,7571461,7571458,'ype',50,1),(1093,7571462,7571460,'dir',25,1),(1093,7571463,7571460,'ire',25,1),(1093,7571464,7571460,'rec',25,1),(1093,7571465,7571460,'ect',25,1),(1094,7571467,7571466,'naa',100,2),(1094,7571468,7571467,'600',3.333,3),(1094,7571469,7571467,'000',3.333,3),(1094,7571470,7571467,'00c',3.333,3),(1094,7571471,7571467,'0c2',3.333,3),(1094,7571472,7571467,'c29',3.333,3),(1094,7571473,7571467,'297',3.333,3),(1094,7571474,7571467,'976',3.333,3),(1094,7571475,7571467,'763',3.333,3),(1094,7571476,7571467,'632',3.333,3),(1094,7571477,7571467,'32f',3.333,3),(1094,7571478,7571467,'2f5',3.333,3),(1094,7571479,7571467,'f52',3.333,3),(1094,7571480,7571467,'52a',3.333,3),(1094,7571481,7571467,'2a6',3.333,3),(1094,7571482,7571467,'a6d',3.333,3),(1094,7571483,7571467,'6d0',3.333,3),(1094,7571484,7571467,'d08',3.333,3),(1094,7571485,7571467,'087',3.333,3),(1094,7571486,7571467,'87e',3.333,3),(1094,7571487,7571467,'7e9',3.333,3),(1094,7571488,7571467,'e94',3.333,3),(1094,7571489,7571467,'94f',3.333,3),(1094,7571490,7571467,'4f5',3.333,3),(1094,7571491,7571467,'f5b',3.333,3),(1094,7571492,7571467,'5b6',3.333,3),(1094,7571493,7571467,'b63',3.333,3),(1094,7571494,7571467,'637',3.333,3),(1094,7571495,7571467,'376',3.333,3),(1094,7571496,7571467,'761',3.333,3),(1094,7571497,7571467,'615',3.333,3),(1094,7571498,7571468,'mon',100,1),(1094,7571499,7571498,'201',50,1),(1094,7571500,7571498,'013',50,1),(1094,7571501,7571499,'adm',33.333,4),(1094,7571502,7571499,'dmi',33.333,4),(1094,7571503,7571499,'min',33.333,4),(1094,7571504,7571501,'cap',16.667,1),(1094,7571505,7571501,'apa',16.667,1),(1094,7571506,7571501,'pac',16.667,1),(1094,7571507,7571501,'aci',16.667,1),(1094,7571508,7571501,'cit',16.667,1),(1094,7571509,7571501,'ity',16.667,1),(1094,7571510,7571504,'pat',50,1),(1094,7571511,7571504,'ath',50,1),(1094,7571512,7571510,'ten',100,1),(1094,7571513,7571512,'fre',14.286,1),(1094,7571514,7571512,'ree',14.286,1),(1094,7571515,7571512,'ees',14.286,1),(1094,7571516,7571512,'esp',14.286,1),(1094,7571517,7571512,'spa',14.286,1),(1094,7571518,7571512,'pac',14.286,1),(1094,7571519,7571512,'ace',14.286,1),(1094,7571520,7571513,'dis',50,1),(1094,7571521,7571513,'isk',50,1),(1094,7571522,7571520,'ind',33.333,1),(1094,7571523,7571520,'nde',33.333,1),(1094,7571524,7571520,'dex',33.333,1),(1094,7571525,7571522,'adm',8.333,1),(1094,7571526,7571522,'dmi',8.333,1),(1094,7571527,7571522,'min',8.333,1),(1094,7571528,7571522,'ini',8.333,1),(1094,7571529,7571522,'nis',8.333,1),(1094,7571530,7571522,'ist',8.333,1),(1094,7571531,7571522,'str',8.333,1),(1094,7571532,7571522,'tra',8.333,1),(1094,7571533,7571522,'rat',8.333,1),(1094,7571534,7571522,'ati',8.333,1),(1094,7571535,7571522,'tio',8.333,1),(1094,7571536,7571522,'ion',8.333,1),(1094,7571537,7571525,'sta',33.333,3),(1094,7571538,7571525,'tat',33.333,3),(1094,7571539,7571525,'ate',33.333,3),(1094,7571540,7571537,'dis',16.667,4),(1094,7571541,7571537,'isa',16.667,4),(1094,7571542,7571537,'sab',16.667,4),(1094,7571543,7571537,'abl',16.667,4),(1094,7571544,7571537,'ble',16.667,4),(1094,7571545,7571537,'led',16.667,4),(1094,7571546,7571540,'cac',33.333,1),(1094,7571547,7571540,'ach',33.333,1),(1094,7571548,7571540,'che',33.333,1),(1094,7571549,7571546,'mod',50,1),(1094,7571550,7571546,'ode',50,1),(1094,7571551,7571549,'wri',14.286,1),(1094,7571552,7571549,'rit',14.286,1),(1094,7571553,7571549,'ite',14.286,1),(1094,7571554,7571549,'tet',14.286,1),(1094,7571555,7571549,'eth',14.286,1),(1094,7571556,7571549,'thr',14.286,1),(1094,7571557,7571549,'hru',14.286,1),(1094,7571558,7571551,'ope',11.111,2),(1094,7571559,7571551,'per',11.111,2),(1094,7571560,7571551,'era',11.111,2),(1094,7571561,7571551,'rat',11.111,2),(1094,7571562,7571551,'ati',11.111,2),(1094,7571563,7571551,'tio',11.111,2),(1094,7571564,7571551,'ion',11.111,2),(1094,7571565,7571551,'ona',11.111,2),(1094,7571566,7571551,'nal',11.111,2),(1094,7571567,7571558,'mes',20,1),(1094,7571568,7571558,'ess',20,1),(1094,7571569,7571558,'ssa',20,1),(1094,7571570,7571558,'sag',20,1),(1094,7571571,7571558,'age',20,1),(1094,7571572,7571567,'per',11.111,1),(1094,7571573,7571567,'erf',11.111,1),(1094,7571574,7571567,'rfo',11.111,1),(1094,7571575,7571567,'for',11.111,1),(1094,7571576,7571567,'orm',11.111,1),(1094,7571577,7571567,'rma',11.111,1),(1094,7571578,7571567,'man',11.111,1),(1094,7571579,7571567,'anc',11.111,1),(1094,7571580,7571567,'nce',11.111,1),(1094,7571581,7571572,'ide',12.5,1),(1094,7571582,7571572,'den',12.5,1),(1094,7571583,7571572,'ent',12.5,1),(1094,7571584,7571572,'nti',12.5,1),(1094,7571585,7571572,'tif',12.5,1),(1094,7571586,7571572,'ifi',12.5,1),(1094,7571587,7571572,'fie',12.5,1),(1094,7571588,7571572,'ier',12.5,1),(1094,7571589,7571581,'vdi',33.333,3),(1094,7571590,7571581,'dis',33.333,3),(1094,7571591,7571581,'isk',33.333,3),(1094,7571592,7571589,'nam',50,1),(1094,7571593,7571589,'ame',50,1),(1094,7571594,7571592,'typ',50,1),(1094,7571595,7571592,'ype',50,1),(1094,7571596,7571594,'dir',25,1),(1094,7571597,7571594,'ire',25,1),(1094,7571598,7571594,'rec',25,1),(1094,7571599,7571594,'ect',25,1),(1095,7571601,7571600,'naa',100,2),(1095,7571602,7571601,'600',3.333,3),(1095,7571603,7571601,'000',3.333,3),(1095,7571604,7571601,'00c',3.333,3),(1095,7571605,7571601,'0c2',3.333,3),(1095,7571606,7571601,'c29',3.333,3),(1095,7571607,7571601,'299',3.333,3),(1095,7571608,7571601,'99f',3.333,3),(1095,7571609,7571601,'9f6',3.333,3),(1095,7571610,7571601,'f63',3.333,3),(1095,7571611,7571601,'630',3.333,3),(1095,7571612,7571601,'30f',3.333,3),(1095,7571613,7571601,'0f7',3.333,3),(1095,7571614,7571601,'f74',3.333,3),(1095,7571615,7571601,'74b',3.333,3),(1095,7571616,7571601,'4b6',3.333,3),(1095,7571617,7571601,'b61',3.333,3),(1095,7571618,7571601,'610',3.333,3),(1095,7571619,7571601,'105',3.333,3),(1095,7571620,7571601,'059',3.333,3),(1095,7571621,7571601,'59e',3.333,3),(1095,7571622,7571601,'9ee',3.333,3),(1095,7571623,7571601,'ee7',3.333,3),(1095,7571624,7571601,'e71',3.333,3),(1095,7571625,7571601,'716',3.333,3),(1095,7571626,7571601,'165',3.333,3),(1095,7571627,7571601,'65d',3.333,3),(1095,7571628,7571601,'5da',3.333,3),(1095,7571629,7571601,'da7',3.333,3),(1095,7571630,7571601,'a78',3.333,3),(1095,7571631,7571601,'78c',3.333,3),(1095,7571632,7571602,'mon',100,1),(1095,7571633,7571632,'201',50,1),(1095,7571634,7571632,'013',50,1),(1095,7571635,7571633,'adm',33.333,4),(1095,7571636,7571633,'dmi',33.333,4),(1095,7571637,7571633,'min',33.333,4),(1095,7571638,7571635,'cap',16.667,1),(1095,7571639,7571635,'apa',16.667,1),(1095,7571640,7571635,'pac',16.667,1),(1095,7571641,7571635,'aci',16.667,1),(1095,7571642,7571635,'cit',16.667,1),(1095,7571643,7571635,'ity',16.667,1),(1095,7571644,7571638,'pat',50,1),(1095,7571645,7571638,'ath',50,1),(1095,7571646,7571644,'ele',25,1),(1095,7571647,7571644,'lev',25,1),(1095,7571648,7571644,'eve',25,1),(1095,7571649,7571644,'ven',25,1),(1095,7571650,7571646,'fre',14.286,1),(1095,7571651,7571646,'ree',14.286,1),(1095,7571652,7571646,'ees',14.286,1),(1095,7571653,7571646,'esp',14.286,1),(1095,7571654,7571646,'spa',14.286,1),(1095,7571655,7571646,'pac',14.286,1),(1095,7571656,7571646,'ace',14.286,1),(1095,7571657,7571650,'dis',50,1),(1095,7571658,7571650,'isk',50,1),(1095,7571659,7571657,'ind',33.333,1),(1095,7571660,7571657,'nde',33.333,1),(1095,7571661,7571657,'dex',33.333,1),(1095,7571662,7571659,'adm',8.333,1),(1095,7571663,7571659,'dmi',8.333,1),(1095,7571664,7571659,'min',8.333,1),(1095,7571665,7571659,'ini',8.333,1),(1095,7571666,7571659,'nis',8.333,1),(1095,7571667,7571659,'ist',8.333,1),(1095,7571668,7571659,'str',8.333,1),(1095,7571669,7571659,'tra',8.333,1),(1095,7571670,7571659,'rat',8.333,1),(1095,7571671,7571659,'ati',8.333,1),(1095,7571672,7571659,'tio',8.333,1),(1095,7571673,7571659,'ion',8.333,1),(1095,7571674,7571662,'sta',33.333,3),(1095,7571675,7571662,'tat',33.333,3),(1095,7571676,7571662,'ate',33.333,3),(1095,7571677,7571674,'dis',16.667,4),(1095,7571678,7571674,'isa',16.667,4),(1095,7571679,7571674,'sab',16.667,4),(1095,7571680,7571674,'abl',16.667,4),(1095,7571681,7571674,'ble',16.667,4),(1095,7571682,7571674,'led',16.667,4),(1095,7571683,7571677,'cac',33.333,1),(1095,7571684,7571677,'ach',33.333,1),(1095,7571685,7571677,'che',33.333,1),(1095,7571686,7571683,'mod',50,1),(1095,7571687,7571683,'ode',50,1),(1095,7571688,7571686,'wri',14.286,1),(1095,7571689,7571686,'rit',14.286,1),(1095,7571690,7571686,'ite',14.286,1),(1095,7571691,7571686,'tet',14.286,1),(1095,7571692,7571686,'eth',14.286,1),(1095,7571693,7571686,'thr',14.286,1),(1095,7571694,7571686,'hru',14.286,1),(1095,7571695,7571688,'ope',11.111,2),(1095,7571696,7571688,'per',11.111,2),(1095,7571697,7571688,'era',11.111,2),(1095,7571698,7571688,'rat',11.111,2),(1095,7571699,7571688,'ati',11.111,2),(1095,7571700,7571688,'tio',11.111,2),(1095,7571701,7571688,'ion',11.111,2),(1095,7571702,7571688,'ona',11.111,2),(1095,7571703,7571688,'nal',11.111,2),(1095,7571704,7571695,'mes',20,1),(1095,7571705,7571695,'ess',20,1),(1095,7571706,7571695,'ssa',20,1),(1095,7571707,7571695,'sag',20,1),(1095,7571708,7571695,'age',20,1),(1095,7571709,7571704,'per',11.111,1),(1095,7571710,7571704,'erf',11.111,1),(1095,7571711,7571704,'rfo',11.111,1),(1095,7571712,7571704,'for',11.111,1),(1095,7571713,7571704,'orm',11.111,1),(1095,7571714,7571704,'rma',11.111,1),(1095,7571715,7571704,'man',11.111,1),(1095,7571716,7571704,'anc',11.111,1),(1095,7571717,7571704,'nce',11.111,1),(1095,7571718,7571709,'ide',12.5,1),(1095,7571719,7571709,'den',12.5,1),(1095,7571720,7571709,'ent',12.5,1),(1095,7571721,7571709,'nti',12.5,1),(1095,7571722,7571709,'tif',12.5,1),(1095,7571723,7571709,'ifi',12.5,1),(1095,7571724,7571709,'fie',12.5,1),(1095,7571725,7571709,'ier',12.5,1),(1095,7571726,7571718,'vdi',33.333,3),(1095,7571727,7571718,'dis',33.333,3),(1095,7571728,7571718,'isk',33.333,3),(1095,7571729,7571726,'nam',50,1),(1095,7571730,7571726,'ame',50,1),(1095,7571731,7571729,'typ',50,1),(1095,7571732,7571729,'ype',50,1),(1095,7571733,7571731,'dir',25,1),(1095,7571734,7571731,'ire',25,1),(1095,7571735,7571731,'rec',25,1),(1095,7571736,7571731,'ect',25,1),(1096,7571738,7571737,'naa',100,2),(1096,7571739,7571738,'600',3.333,3),(1096,7571740,7571738,'000',3.333,3),(1096,7571741,7571738,'00c',3.333,3),(1096,7571742,7571738,'0c2',3.333,3),(1096,7571743,7571738,'c29',3.333,3),(1096,7571744,7571738,'293',3.333,3),(1096,7571745,7571738,'93a',3.333,3),(1096,7571746,7571738,'3a8',3.333,3),(1096,7571747,7571738,'a81',3.333,3),(1096,7571748,7571738,'810',3.333,3),(1096,7571749,7571738,'10d',3.333,3),(1096,7571750,7571738,'0dc',3.333,3),(1096,7571751,7571738,'dc0',3.333,3),(1096,7571752,7571738,'c00',3.333,3),(1096,7571753,7571738,'007',3.333,3),(1096,7571754,7571738,'075',3.333,3),(1096,7571755,7571738,'750',3.333,3),(1096,7571756,7571738,'509',3.333,3),(1096,7571757,7571738,'096',3.333,3),(1096,7571758,7571738,'960',3.333,3),(1096,7571759,7571738,'60a',3.333,3),(1096,7571760,7571738,'0a0',3.333,3),(1096,7571761,7571738,'a09',3.333,3),(1096,7571762,7571738,'09c',3.333,3),(1096,7571763,7571738,'9c2',3.333,3),(1096,7571764,7571738,'c21',3.333,3),(1096,7571765,7571738,'218',3.333,3),(1096,7571766,7571738,'18d',3.333,3),(1096,7571767,7571738,'8d2',3.333,3),(1096,7571768,7571738,'d28',3.333,3),(1096,7571769,7571739,'mon',100,1),(1096,7571770,7571769,'201',50,1),(1096,7571771,7571769,'013',50,1),(1096,7571772,7571770,'adm',33.333,4),(1096,7571773,7571770,'dmi',33.333,4),(1096,7571774,7571770,'min',33.333,4),(1096,7571775,7571772,'cap',16.667,1),(1096,7571776,7571772,'apa',16.667,1),(1096,7571777,7571772,'pac',16.667,1),(1096,7571778,7571772,'aci',16.667,1),(1096,7571779,7571772,'cit',16.667,1),(1096,7571780,7571772,'ity',16.667,1),(1096,7571781,7571775,'pat',50,1),(1096,7571782,7571775,'ath',50,1),(1096,7571783,7571781,'twe',25,1),(1096,7571784,7571781,'wel',25,1),(1096,7571785,7571781,'elv',25,1),(1096,7571786,7571781,'lve',25,1),(1096,7571787,7571783,'fre',14.286,1),(1096,7571788,7571783,'ree',14.286,1),(1096,7571789,7571783,'ees',14.286,1),(1096,7571790,7571783,'esp',14.286,1),(1096,7571791,7571783,'spa',14.286,1),(1096,7571792,7571783,'pac',14.286,1),(1096,7571793,7571783,'ace',14.286,1),(1096,7571794,7571787,'dis',50,1),(1096,7571795,7571787,'isk',50,1),(1096,7571796,7571794,'ind',33.333,1),(1096,7571797,7571794,'nde',33.333,1),(1096,7571798,7571794,'dex',33.333,1),(1096,7571799,7571796,'adm',8.333,1),(1096,7571800,7571796,'dmi',8.333,1),(1096,7571801,7571796,'min',8.333,1),(1096,7571802,7571796,'ini',8.333,1),(1096,7571803,7571796,'nis',8.333,1),(1096,7571804,7571796,'ist',8.333,1),(1096,7571805,7571796,'str',8.333,1),(1096,7571806,7571796,'tra',8.333,1),(1096,7571807,7571796,'rat',8.333,1),(1096,7571808,7571796,'ati',8.333,1),(1096,7571809,7571796,'tio',8.333,1),(1096,7571810,7571796,'ion',8.333,1),(1096,7571811,7571799,'sta',33.333,3),(1096,7571812,7571799,'tat',33.333,3),(1096,7571813,7571799,'ate',33.333,3),(1096,7571814,7571811,'dis',16.667,4),(1096,7571815,7571811,'isa',16.667,4),(1096,7571816,7571811,'sab',16.667,4),(1096,7571817,7571811,'abl',16.667,4),(1096,7571818,7571811,'ble',16.667,4),(1096,7571819,7571811,'led',16.667,4),(1096,7571820,7571814,'cac',33.333,1),(1096,7571821,7571814,'ach',33.333,1),(1096,7571822,7571814,'che',33.333,1),(1096,7571823,7571820,'mod',50,1),(1096,7571824,7571820,'ode',50,1),(1096,7571825,7571823,'wri',14.286,1),(1096,7571826,7571823,'rit',14.286,1),(1096,7571827,7571823,'ite',14.286,1),(1096,7571828,7571823,'tet',14.286,1),(1096,7571829,7571823,'eth',14.286,1),(1096,7571830,7571823,'thr',14.286,1),(1096,7571831,7571823,'hru',14.286,1),(1096,7571832,7571825,'ope',11.111,2),(1096,7571833,7571825,'per',11.111,2),(1096,7571834,7571825,'era',11.111,2),(1096,7571835,7571825,'rat',11.111,2),(1096,7571836,7571825,'ati',11.111,2),(1096,7571837,7571825,'tio',11.111,2),(1096,7571838,7571825,'ion',11.111,2),(1096,7571839,7571825,'ona',11.111,2),(1096,7571840,7571825,'nal',11.111,2),(1096,7571841,7571832,'mes',20,1),(1096,7571842,7571832,'ess',20,1),(1096,7571843,7571832,'ssa',20,1),(1096,7571844,7571832,'sag',20,1),(1096,7571845,7571832,'age',20,1),(1096,7571846,7571841,'per',11.111,1),(1096,7571847,7571841,'erf',11.111,1),(1096,7571848,7571841,'rfo',11.111,1),(1096,7571849,7571841,'for',11.111,1),(1096,7571850,7571841,'orm',11.111,1),(1096,7571851,7571841,'rma',11.111,1),(1096,7571852,7571841,'man',11.111,1),(1096,7571853,7571841,'anc',11.111,1),(1096,7571854,7571841,'nce',11.111,1),(1096,7571855,7571846,'ide',12.5,1),(1096,7571856,7571846,'den',12.5,1),(1096,7571857,7571846,'ent',12.5,1),(1096,7571858,7571846,'nti',12.5,1),(1096,7571859,7571846,'tif',12.5,1),(1096,7571860,7571846,'ifi',12.5,1),(1096,7571861,7571846,'fie',12.5,1),(1096,7571862,7571846,'ier',12.5,1),(1096,7571863,7571855,'vdi',33.333,3),(1096,7571864,7571855,'dis',33.333,3),(1096,7571865,7571855,'isk',33.333,3),(1096,7571866,7571863,'nam',50,1),(1096,7571867,7571863,'ame',50,1),(1096,7571868,7571866,'typ',50,1),(1096,7571869,7571866,'ype',50,1),(1096,7571870,7571868,'dir',25,1),(1096,7571871,7571868,'ire',25,1),(1096,7571872,7571868,'rec',25,1),(1096,7571873,7571868,'ect',25,1),(1097,7571875,7571874,'naa',100,2),(1097,7571876,7571875,'600',3.333,3),(1097,7571877,7571875,'000',3.333,3),(1097,7571878,7571875,'00c',3.333,3),(1097,7571879,7571875,'0c2',3.333,3),(1097,7571880,7571875,'c29',3.333,3),(1097,7571881,7571875,'293',3.333,3),(1097,7571882,7571875,'936',3.333,3),(1097,7571883,7571875,'36b',3.333,3),(1097,7571884,7571875,'6b4',3.333,3),(1097,7571885,7571875,'b41',3.333,3),(1097,7571886,7571875,'41b',3.333,3),(1097,7571887,7571875,'1b0',3.333,3),(1097,7571888,7571875,'b02',3.333,3),(1097,7571889,7571875,'02e',3.333,3),(1097,7571890,7571875,'2e5',3.333,3),(1097,7571891,7571875,'e50',3.333,3),(1097,7571892,7571875,'50b',3.333,3),(1097,7571893,7571875,'0bd',3.333,3),(1097,7571894,7571875,'bdc',3.333,3),(1097,7571895,7571875,'dc5',3.333,3),(1097,7571896,7571875,'c53',3.333,3),(1097,7571897,7571875,'534',3.333,3),(1097,7571898,7571875,'344',3.333,3),(1097,7571899,7571875,'44d',3.333,3),(1097,7571900,7571875,'4d7',3.333,3),(1097,7571901,7571875,'d72',3.333,3),(1097,7571902,7571875,'724',3.333,3),(1097,7571903,7571875,'244',3.333,3),(1097,7571904,7571875,'443',3.333,3),(1097,7571905,7571875,'43b',3.333,3),(1097,7571906,7571876,'mon',100,1),(1097,7571907,7571906,'201',50,1),(1097,7571908,7571906,'013',50,1),(1097,7571909,7571907,'adm',33.333,4),(1097,7571910,7571907,'dmi',33.333,4),(1097,7571911,7571907,'min',33.333,4),(1097,7571912,7571909,'cap',16.667,1),(1097,7571913,7571909,'apa',16.667,1),(1097,7571914,7571909,'pac',16.667,1),(1097,7571915,7571909,'aci',16.667,1),(1097,7571916,7571909,'cit',16.667,1),(1097,7571917,7571909,'ity',16.667,1),(1097,7571918,7571912,'pat',50,1),(1097,7571919,7571912,'ath',50,1),(1097,7571920,7571918,'thi',16.667,1),(1097,7571921,7571918,'hir',16.667,1),(1097,7571922,7571918,'irt',16.667,1),(1097,7571923,7571918,'rte',16.667,1),(1097,7571924,7571918,'tee',16.667,1),(1097,7571925,7571918,'een',16.667,1),(1097,7571926,7571920,'fre',14.286,1),(1097,7571927,7571920,'ree',14.286,1),(1097,7571928,7571920,'ees',14.286,1),(1097,7571929,7571920,'esp',14.286,1),(1097,7571930,7571920,'spa',14.286,1),(1097,7571931,7571920,'pac',14.286,1),(1097,7571932,7571920,'ace',14.286,1),(1097,7571933,7571926,'dis',50,1),(1097,7571934,7571926,'isk',50,1),(1097,7571935,7571933,'ind',33.333,1),(1097,7571936,7571933,'nde',33.333,1),(1097,7571937,7571933,'dex',33.333,1),(1097,7571938,7571935,'adm',8.333,1),(1097,7571939,7571935,'dmi',8.333,1),(1097,7571940,7571935,'min',8.333,1),(1097,7571941,7571935,'ini',8.333,1),(1097,7571942,7571935,'nis',8.333,1),(1097,7571943,7571935,'ist',8.333,1),(1097,7571944,7571935,'str',8.333,1),(1097,7571945,7571935,'tra',8.333,1),(1097,7571946,7571935,'rat',8.333,1),(1097,7571947,7571935,'ati',8.333,1),(1097,7571948,7571935,'tio',8.333,1),(1097,7571949,7571935,'ion',8.333,1),(1097,7571950,7571938,'sta',33.333,3),(1097,7571951,7571938,'tat',33.333,3),(1097,7571952,7571938,'ate',33.333,3),(1097,7571953,7571950,'dis',16.667,4),(1097,7571954,7571950,'isa',16.667,4),(1097,7571955,7571950,'sab',16.667,4),(1097,7571956,7571950,'abl',16.667,4),(1097,7571957,7571950,'ble',16.667,4),(1097,7571958,7571950,'led',16.667,4),(1097,7571959,7571953,'cac',33.333,1),(1097,7571960,7571953,'ach',33.333,1),(1097,7571961,7571953,'che',33.333,1),(1097,7571962,7571959,'mod',50,1),(1097,7571963,7571959,'ode',50,1),(1097,7571964,7571962,'wri',14.286,1),(1097,7571965,7571962,'rit',14.286,1),(1097,7571966,7571962,'ite',14.286,1),(1097,7571967,7571962,'tet',14.286,1),(1097,7571968,7571962,'eth',14.286,1),(1097,7571969,7571962,'thr',14.286,1),(1097,7571970,7571962,'hru',14.286,1),(1097,7571971,7571964,'ope',11.111,2),(1097,7571972,7571964,'per',11.111,2),(1097,7571973,7571964,'era',11.111,2),(1097,7571974,7571964,'rat',11.111,2),(1097,7571975,7571964,'ati',11.111,2),(1097,7571976,7571964,'tio',11.111,2),(1097,7571977,7571964,'ion',11.111,2),(1097,7571978,7571964,'ona',11.111,2),(1097,7571979,7571964,'nal',11.111,2),(1097,7571980,7571971,'mes',20,1),(1097,7571981,7571971,'ess',20,1),(1097,7571982,7571971,'ssa',20,1),(1097,7571983,7571971,'sag',20,1),(1097,7571984,7571971,'age',20,1),(1097,7571985,7571980,'per',11.111,1),(1097,7571986,7571980,'erf',11.111,1),(1097,7571987,7571980,'rfo',11.111,1),(1097,7571988,7571980,'for',11.111,1),(1097,7571989,7571980,'orm',11.111,1),(1097,7571990,7571980,'rma',11.111,1),(1097,7571991,7571980,'man',11.111,1),(1097,7571992,7571980,'anc',11.111,1),(1097,7571993,7571980,'nce',11.111,1),(1097,7571994,7571985,'ide',12.5,1),(1097,7571995,7571985,'den',12.5,1),(1097,7571996,7571985,'ent',12.5,1),(1097,7571997,7571985,'nti',12.5,1),(1097,7571998,7571985,'tif',12.5,1),(1097,7571999,7571985,'ifi',12.5,1),(1097,7572000,7571985,'fie',12.5,1),(1097,7572001,7571985,'ier',12.5,1),(1097,7572002,7571994,'vdi',33.333,3),(1097,7572003,7571994,'dis',33.333,3),(1097,7572004,7571994,'isk',33.333,3),(1097,7572005,7572002,'nam',50,1),(1097,7572006,7572002,'ame',50,1),(1097,7572007,7572005,'typ',50,1),(1097,7572008,7572005,'ype',50,1),(1097,7572009,7572007,'dir',25,1),(1097,7572010,7572007,'ire',25,1),(1097,7572011,7572007,'rec',25,1),(1097,7572012,7572007,'ect',25,1),(1098,7572014,7572013,'naa',100,2),(1098,7572015,7572014,'600',3.333,3),(1098,7572016,7572014,'000',3.333,3),(1098,7572017,7572014,'00c',3.333,3),(1098,7572018,7572014,'0c2',3.333,3),(1098,7572019,7572014,'c29',3.333,3),(1098,7572020,7572014,'294',3.333,3),(1098,7572021,7572014,'94f',3.333,3),(1098,7572022,7572014,'4fb',3.333,3),(1098,7572023,7572014,'fb3',3.333,3),(1098,7572024,7572014,'b39',3.333,3),(1098,7572025,7572014,'39a',3.333,3),(1098,7572026,7572014,'9aa',3.333,3),(1098,7572027,7572014,'aa2',3.333,3),(1098,7572028,7572014,'a21',3.333,3),(1098,7572029,7572014,'21b',3.333,3),(1098,7572030,7572014,'1bd',3.333,3),(1098,7572031,7572014,'bdd',3.333,3),(1098,7572032,7572014,'dd8',3.333,3),(1098,7572033,7572014,'d8b',3.333,3),(1098,7572034,7572014,'8ba',3.333,3),(1098,7572035,7572014,'ba1',3.333,3),(1098,7572036,7572014,'a12',3.333,3),(1098,7572037,7572014,'12b',3.333,3),(1098,7572038,7572014,'2b3',3.333,3),(1098,7572039,7572014,'b37',3.333,3),(1098,7572040,7572014,'377',3.333,3),(1098,7572041,7572014,'77b',3.333,3),(1098,7572042,7572014,'7bb',3.333,3),(1098,7572043,7572014,'bb5',3.333,3),(1098,7572044,7572014,'b58',3.333,3),(1098,7572045,7572015,'mon',100,1),(1098,7572046,7572045,'201',50,1),(1098,7572047,7572045,'013',50,1),(1098,7572048,7572046,'adm',33.333,4),(1098,7572049,7572046,'dmi',33.333,4),(1098,7572050,7572046,'min',33.333,4),(1098,7572051,7572048,'cap',16.667,1),(1098,7572052,7572048,'apa',16.667,1),(1098,7572053,7572048,'pac',16.667,1),(1098,7572054,7572048,'aci',16.667,1),(1098,7572055,7572048,'cit',16.667,1),(1098,7572056,7572048,'ity',16.667,1),(1098,7572057,7572051,'pat',50,1),(1098,7572058,7572051,'ath',50,1),(1098,7572059,7572057,'fre',14.286,1),(1098,7572060,7572057,'ree',14.286,1),(1098,7572061,7572057,'ees',14.286,1),(1098,7572062,7572057,'esp',14.286,1),(1098,7572063,7572057,'spa',14.286,1),(1098,7572064,7572057,'pac',14.286,1),(1098,7572065,7572057,'ace',14.286,1),(1098,7572066,7572059,'dis',50,1),(1098,7572067,7572059,'isk',50,1),(1098,7572068,7572066,'ind',33.333,1),(1098,7572069,7572066,'nde',33.333,1),(1098,7572070,7572066,'dex',33.333,1),(1098,7572071,7572068,'adm',8.333,1),(1098,7572072,7572068,'dmi',8.333,1),(1098,7572073,7572068,'min',8.333,1),(1098,7572074,7572068,'ini',8.333,1),(1098,7572075,7572068,'nis',8.333,1),(1098,7572076,7572068,'ist',8.333,1),(1098,7572077,7572068,'str',8.333,1),(1098,7572078,7572068,'tra',8.333,1),(1098,7572079,7572068,'rat',8.333,1),(1098,7572080,7572068,'ati',8.333,1),(1098,7572081,7572068,'tio',8.333,1),(1098,7572082,7572068,'ion',8.333,1),(1098,7572083,7572071,'sta',33.333,3),(1098,7572084,7572071,'tat',33.333,3),(1098,7572085,7572071,'ate',33.333,3),(1098,7572086,7572083,'dis',16.667,4),(1098,7572087,7572083,'isa',16.667,4),(1098,7572088,7572083,'sab',16.667,4),(1098,7572089,7572083,'abl',16.667,4),(1098,7572090,7572083,'ble',16.667,4),(1098,7572091,7572083,'led',16.667,4),(1098,7572092,7572086,'cac',33.333,1),(1098,7572093,7572086,'ach',33.333,1),(1098,7572094,7572086,'che',33.333,1),(1098,7572095,7572092,'mod',50,1),(1098,7572096,7572092,'ode',50,1),(1098,7572097,7572095,'wri',14.286,1),(1098,7572098,7572095,'rit',14.286,1),(1098,7572099,7572095,'ite',14.286,1),(1098,7572100,7572095,'tet',14.286,1),(1098,7572101,7572095,'eth',14.286,1),(1098,7572102,7572095,'thr',14.286,1),(1098,7572103,7572095,'hru',14.286,1),(1098,7572104,7572097,'ope',11.111,2),(1098,7572105,7572097,'per',11.111,2),(1098,7572106,7572097,'era',11.111,2),(1098,7572107,7572097,'rat',11.111,2),(1098,7572108,7572097,'ati',11.111,2),(1098,7572109,7572097,'tio',11.111,2),(1098,7572110,7572097,'ion',11.111,2),(1098,7572111,7572097,'ona',11.111,2),(1098,7572112,7572097,'nal',11.111,2),(1098,7572113,7572104,'mes',20,1),(1098,7572114,7572104,'ess',20,1),(1098,7572115,7572104,'ssa',20,1),(1098,7572116,7572104,'sag',20,1),(1098,7572117,7572104,'age',20,1),(1098,7572118,7572113,'per',11.111,1),(1098,7572119,7572113,'erf',11.111,1),(1098,7572120,7572113,'rfo',11.111,1),(1098,7572121,7572113,'for',11.111,1),(1098,7572122,7572113,'orm',11.111,1),(1098,7572123,7572113,'rma',11.111,1),(1098,7572124,7572113,'man',11.111,1),(1098,7572125,7572113,'anc',11.111,1),(1098,7572126,7572113,'nce',11.111,1),(1098,7572127,7572118,'ide',12.5,1),(1098,7572128,7572118,'den',12.5,1),(1098,7572129,7572118,'ent',12.5,1),(1098,7572130,7572118,'nti',12.5,1),(1098,7572131,7572118,'tif',12.5,1),(1098,7572132,7572118,'ifi',12.5,1),(1098,7572133,7572118,'fie',12.5,1),(1098,7572134,7572118,'ier',12.5,1),(1098,7572135,7572127,'vdi',33.333,3),(1098,7572136,7572127,'dis',33.333,3),(1098,7572137,7572127,'isk',33.333,3),(1098,7572138,7572135,'nam',50,1),(1098,7572139,7572135,'ame',50,1),(1098,7572140,7572138,'typ',50,1),(1098,7572141,7572138,'ype',50,1),(1098,7572142,7572140,'dir',25,1),(1098,7572143,7572140,'ire',25,1),(1098,7572144,7572140,'rec',25,1),(1098,7572145,7572140,'ect',25,1),(1099,7572147,7572146,'naa',100,2),(1099,7572148,7572147,'600',3.333,3),(1099,7572149,7572147,'000',3.333,3),(1099,7572150,7572147,'00c',3.333,3),(1099,7572151,7572147,'0c2',3.333,3),(1099,7572152,7572147,'c29',3.333,3),(1099,7572153,7572147,'297',3.333,3),(1099,7572154,7572147,'97c',3.333,3),(1099,7572155,7572147,'7c6',3.333,3),(1099,7572156,7572147,'c61',3.333,3),(1099,7572157,7572147,'61b',3.333,3),(1099,7572158,7572147,'1b3',3.333,3),(1099,7572159,7572147,'b34',3.333,3),(1099,7572160,7572147,'345',3.333,3),(1099,7572161,7572147,'456',3.333,3),(1099,7572162,7572147,'561',3.333,3),(1099,7572163,7572147,'61e',3.333,3),(1099,7572164,7572147,'1e9',3.333,3),(1099,7572165,7572147,'e95',3.333,3),(1099,7572166,7572147,'951',3.333,3),(1099,7572167,7572147,'511',3.333,3),(1099,7572168,7572147,'11f',3.333,3),(1099,7572169,7572147,'1f2',3.333,3),(1099,7572170,7572147,'f28',3.333,3),(1099,7572171,7572147,'288',3.333,3),(1099,7572172,7572147,'887',3.333,3),(1099,7572173,7572147,'87e',3.333,3),(1099,7572174,7572147,'7e2',3.333,3),(1099,7572175,7572147,'e27',3.333,3),(1099,7572176,7572147,'27c',3.333,3),(1099,7572177,7572147,'7c2',3.333,3),(1099,7572178,7572148,'mon',100,1),(1099,7572179,7572178,'201',50,1),(1099,7572180,7572178,'013',50,1),(1099,7572181,7572179,'adm',33.333,4),(1099,7572182,7572179,'dmi',33.333,4),(1099,7572183,7572179,'min',33.333,4),(1099,7572184,7572181,'cap',16.667,1),(1099,7572185,7572181,'apa',16.667,1),(1099,7572186,7572181,'pac',16.667,1),(1099,7572187,7572181,'aci',16.667,1),(1099,7572188,7572181,'cit',16.667,1),(1099,7572189,7572181,'ity',16.667,1),(1099,7572190,7572184,'pat',50,1),(1099,7572191,7572184,'ath',50,1),(1099,7572192,7572190,'fre',14.286,1),(1099,7572193,7572190,'ree',14.286,1),(1099,7572194,7572190,'ees',14.286,1),(1099,7572195,7572190,'esp',14.286,1),(1099,7572196,7572190,'spa',14.286,1),(1099,7572197,7572190,'pac',14.286,1),(1099,7572198,7572190,'ace',14.286,1),(1099,7572199,7572192,'dis',50,1),(1099,7572200,7572192,'isk',50,1),(1099,7572201,7572199,'ind',33.333,1),(1099,7572202,7572199,'nde',33.333,1),(1099,7572203,7572199,'dex',33.333,1),(1099,7572204,7572201,'adm',8.333,1),(1099,7572205,7572201,'dmi',8.333,1),(1099,7572206,7572201,'min',8.333,1),(1099,7572207,7572201,'ini',8.333,1),(1099,7572208,7572201,'nis',8.333,1),(1099,7572209,7572201,'ist',8.333,1),(1099,7572210,7572201,'str',8.333,1),(1099,7572211,7572201,'tra',8.333,1),(1099,7572212,7572201,'rat',8.333,1),(1099,7572213,7572201,'ati',8.333,1),(1099,7572214,7572201,'tio',8.333,1),(1099,7572215,7572201,'ion',8.333,1),(1099,7572216,7572204,'sta',33.333,3),(1099,7572217,7572204,'tat',33.333,3),(1099,7572218,7572204,'ate',33.333,3),(1099,7572219,7572216,'dis',16.667,4),(1099,7572220,7572216,'isa',16.667,4),(1099,7572221,7572216,'sab',16.667,4),(1099,7572222,7572216,'abl',16.667,4),(1099,7572223,7572216,'ble',16.667,4),(1099,7572224,7572216,'led',16.667,4),(1099,7572225,7572219,'cac',33.333,1),(1099,7572226,7572219,'ach',33.333,1),(1099,7572227,7572219,'che',33.333,1),(1099,7572228,7572225,'mod',50,1),(1099,7572229,7572225,'ode',50,1),(1099,7572230,7572228,'wri',14.286,1),(1099,7572231,7572228,'rit',14.286,1),(1099,7572232,7572228,'ite',14.286,1),(1099,7572233,7572228,'tet',14.286,1),(1099,7572234,7572228,'eth',14.286,1),(1099,7572235,7572228,'thr',14.286,1),(1099,7572236,7572228,'hru',14.286,1),(1099,7572237,7572230,'ope',11.111,2),(1099,7572238,7572230,'per',11.111,2),(1099,7572239,7572230,'era',11.111,2),(1099,7572240,7572230,'rat',11.111,2),(1099,7572241,7572230,'ati',11.111,2),(1099,7572242,7572230,'tio',11.111,2),(1099,7572243,7572230,'ion',11.111,2),(1099,7572244,7572230,'ona',11.111,2),(1099,7572245,7572230,'nal',11.111,2),(1099,7572246,7572237,'mes',20,1),(1099,7572247,7572237,'ess',20,1),(1099,7572248,7572237,'ssa',20,1),(1099,7572249,7572237,'sag',20,1),(1099,7572250,7572237,'age',20,1),(1099,7572251,7572246,'per',11.111,1),(1099,7572252,7572246,'erf',11.111,1),(1099,7572253,7572246,'rfo',11.111,1),(1099,7572254,7572246,'for',11.111,1),(1099,7572255,7572246,'orm',11.111,1),(1099,7572256,7572246,'rma',11.111,1),(1099,7572257,7572246,'man',11.111,1),(1099,7572258,7572246,'anc',11.111,1),(1099,7572259,7572246,'nce',11.111,1),(1099,7572260,7572251,'ide',12.5,1),(1099,7572261,7572251,'den',12.5,1),(1099,7572262,7572251,'ent',12.5,1),(1099,7572263,7572251,'nti',12.5,1),(1099,7572264,7572251,'tif',12.5,1),(1099,7572265,7572251,'ifi',12.5,1),(1099,7572266,7572251,'fie',12.5,1),(1099,7572267,7572251,'ier',12.5,1),(1099,7572268,7572260,'vdi',33.333,3),(1099,7572269,7572260,'dis',33.333,3),(1099,7572270,7572260,'isk',33.333,3),(1099,7572271,7572268,'nam',50,1),(1099,7572272,7572268,'ame',50,1),(1099,7572273,7572271,'typ',50,1),(1099,7572274,7572271,'ype',50,1),(1099,7572275,7572273,'dir',25,1),(1099,7572276,7572273,'ire',25,1),(1099,7572277,7572273,'rec',25,1),(1099,7572278,7572273,'ect',25,1),(1100,7572280,7572279,'naa',100,2),(1100,7572281,7572280,'600',3.333,3),(1100,7572282,7572280,'000',3.333,3),(1100,7572283,7572280,'00c',3.333,3),(1100,7572284,7572280,'0c2',3.333,3),(1100,7572285,7572280,'c29',3.333,3),(1100,7572286,7572280,'298',3.333,3),(1100,7572287,7572280,'980',3.333,3),(1100,7572288,7572280,'808',3.333,3),(1100,7572289,7572280,'081',3.333,3),(1100,7572290,7572280,'811',3.333,3),(1100,7572291,7572280,'114',3.333,3),(1100,7572292,7572280,'146',3.333,3),(1100,7572293,7572280,'46e',3.333,3),(1100,7572294,7572280,'6e1',3.333,3),(1100,7572295,7572280,'e19',3.333,3),(1100,7572296,7572280,'194',3.333,3),(1100,7572297,7572280,'94a',3.333,3),(1100,7572298,7572280,'4ad',3.333,3),(1100,7572299,7572280,'adb',3.333,3),(1100,7572300,7572280,'db6',3.333,3),(1100,7572301,7572280,'b6f',3.333,3),(1100,7572302,7572280,'6f3',3.333,3),(1100,7572303,7572280,'f39',3.333,3),(1100,7572304,7572280,'395',3.333,3),(1100,7572305,7572280,'95f',3.333,3),(1100,7572306,7572280,'5f7',3.333,3),(1100,7572307,7572280,'f7e',3.333,3),(1100,7572308,7572280,'7e2',3.333,3),(1100,7572309,7572280,'e2d',3.333,3),(1100,7572310,7572280,'2da',3.333,3),(1100,7572311,7572281,'mon',100,1),(1100,7572312,7572311,'201',50,1),(1100,7572313,7572311,'013',50,1),(1100,7572314,7572312,'adm',33.333,4),(1100,7572315,7572312,'dmi',33.333,4),(1100,7572316,7572312,'min',33.333,4),(1100,7572317,7572314,'cap',16.667,1),(1100,7572318,7572314,'apa',16.667,1),(1100,7572319,7572314,'pac',16.667,1),(1100,7572320,7572314,'aci',16.667,1),(1100,7572321,7572314,'cit',16.667,1),(1100,7572322,7572314,'ity',16.667,1),(1100,7572323,7572317,'pat',50,1),(1100,7572324,7572317,'ath',50,1),(1100,7572325,7572323,'fre',14.286,1),(1100,7572326,7572323,'ree',14.286,1),(1100,7572327,7572323,'ees',14.286,1),(1100,7572328,7572323,'esp',14.286,1),(1100,7572329,7572323,'spa',14.286,1),(1100,7572330,7572323,'pac',14.286,1),(1100,7572331,7572323,'ace',14.286,1),(1100,7572332,7572325,'dis',50,1),(1100,7572333,7572325,'isk',50,1),(1100,7572334,7572332,'ind',33.333,1),(1100,7572335,7572332,'nde',33.333,1),(1100,7572336,7572332,'dex',33.333,1),(1100,7572337,7572334,'adm',8.333,1),(1100,7572338,7572334,'dmi',8.333,1),(1100,7572339,7572334,'min',8.333,1),(1100,7572340,7572334,'ini',8.333,1),(1100,7572341,7572334,'nis',8.333,1),(1100,7572342,7572334,'ist',8.333,1),(1100,7572343,7572334,'str',8.333,1),(1100,7572344,7572334,'tra',8.333,1),(1100,7572345,7572334,'rat',8.333,1),(1100,7572346,7572334,'ati',8.333,1),(1100,7572347,7572334,'tio',8.333,1),(1100,7572348,7572334,'ion',8.333,1),(1100,7572349,7572337,'sta',33.333,3),(1100,7572350,7572337,'tat',33.333,3),(1100,7572351,7572337,'ate',33.333,3),(1100,7572352,7572349,'dis',16.667,4),(1100,7572353,7572349,'isa',16.667,4),(1100,7572354,7572349,'sab',16.667,4),(1100,7572355,7572349,'abl',16.667,4),(1100,7572356,7572349,'ble',16.667,4),(1100,7572357,7572349,'led',16.667,4),(1100,7572358,7572352,'cac',33.333,1),(1100,7572359,7572352,'ach',33.333,1),(1100,7572360,7572352,'che',33.333,1),(1100,7572361,7572358,'mod',50,1),(1100,7572362,7572358,'ode',50,1),(1100,7572363,7572361,'wri',14.286,1),(1100,7572364,7572361,'rit',14.286,1),(1100,7572365,7572361,'ite',14.286,1),(1100,7572366,7572361,'tet',14.286,1),(1100,7572367,7572361,'eth',14.286,1),(1100,7572368,7572361,'thr',14.286,1),(1100,7572369,7572361,'hru',14.286,1),(1100,7572370,7572363,'ope',11.111,2),(1100,7572371,7572363,'per',11.111,2),(1100,7572372,7572363,'era',11.111,2),(1100,7572373,7572363,'rat',11.111,2),(1100,7572374,7572363,'ati',11.111,2),(1100,7572375,7572363,'tio',11.111,2),(1100,7572376,7572363,'ion',11.111,2),(1100,7572377,7572363,'ona',11.111,2),(1100,7572378,7572363,'nal',11.111,2),(1100,7572379,7572370,'mes',20,1),(1100,7572380,7572370,'ess',20,1),(1100,7572381,7572370,'ssa',20,1),(1100,7572382,7572370,'sag',20,1),(1100,7572383,7572370,'age',20,1),(1100,7572384,7572379,'per',11.111,1),(1100,7572385,7572379,'erf',11.111,1),(1100,7572386,7572379,'rfo',11.111,1),(1100,7572387,7572379,'for',11.111,1),(1100,7572388,7572379,'orm',11.111,1),(1100,7572389,7572379,'rma',11.111,1),(1100,7572390,7572379,'man',11.111,1),(1100,7572391,7572379,'anc',11.111,1),(1100,7572392,7572379,'nce',11.111,1),(1100,7572393,7572384,'ide',12.5,1),(1100,7572394,7572384,'den',12.5,1),(1100,7572395,7572384,'ent',12.5,1),(1100,7572396,7572384,'nti',12.5,1),(1100,7572397,7572384,'tif',12.5,1),(1100,7572398,7572384,'ifi',12.5,1),(1100,7572399,7572384,'fie',12.5,1),(1100,7572400,7572384,'ier',12.5,1),(1100,7572401,7572393,'vdi',33.333,3),(1100,7572402,7572393,'dis',33.333,3),(1100,7572403,7572393,'isk',33.333,3),(1100,7572404,7572401,'nam',50,1),(1100,7572405,7572401,'ame',50,1),(1100,7572406,7572404,'typ',50,1),(1100,7572407,7572404,'ype',50,1),(1100,7572408,7572406,'dir',25,1),(1100,7572409,7572406,'ire',25,1),(1100,7572410,7572406,'rec',25,1),(1100,7572411,7572406,'ect',25,1),(1101,7572413,7572412,'naa',100,2),(1101,7572414,7572413,'600',3.333,3),(1101,7572415,7572413,'000',3.333,3),(1101,7572416,7572413,'00c',3.333,3),(1101,7572417,7572413,'0c2',3.333,3),(1101,7572418,7572413,'c29',3.333,3),(1101,7572419,7572413,'298',3.333,3),(1101,7572420,7572413,'98a',3.333,3),(1101,7572421,7572413,'8a7',3.333,3),(1101,7572422,7572413,'a7f',3.333,3),(1101,7572423,7572413,'7fb',3.333,3),(1101,7572424,7572413,'fb6',3.333,3),(1101,7572425,7572413,'b61',3.333,3),(1101,7572426,7572413,'617',3.333,3),(1101,7572427,7572413,'17e',3.333,3),(1101,7572428,7572413,'7e0',3.333,3),(1101,7572429,7572413,'e01',3.333,3),(1101,7572430,7572413,'01e',3.333,3),(1101,7572431,7572413,'1e5',3.333,3),(1101,7572432,7572413,'e5f',3.333,3),(1101,7572433,7572413,'5fa',3.333,3),(1101,7572434,7572413,'faf',3.333,3),(1101,7572435,7572413,'af1',3.333,3),(1101,7572436,7572413,'f1b',3.333,3),(1101,7572437,7572413,'1b5',3.333,3),(1101,7572438,7572413,'b50',3.333,3),(1101,7572439,7572413,'502',3.333,3),(1101,7572440,7572413,'02a',3.333,3),(1101,7572441,7572413,'2ab',3.333,3),(1101,7572442,7572413,'ab6',3.333,3),(1101,7572443,7572413,'b6d',3.333,3),(1101,7572444,7572414,'mon',100,1),(1101,7572445,7572444,'201',50,1),(1101,7572446,7572444,'013',50,1),(1101,7572447,7572445,'adm',33.333,4),(1101,7572448,7572445,'dmi',33.333,4),(1101,7572449,7572445,'min',33.333,4),(1101,7572450,7572447,'cap',16.667,1),(1101,7572451,7572447,'apa',16.667,1),(1101,7572452,7572447,'pac',16.667,1),(1101,7572453,7572447,'aci',16.667,1),(1101,7572454,7572447,'cit',16.667,1),(1101,7572455,7572447,'ity',16.667,1),(1101,7572456,7572450,'pat',50,1),(1101,7572457,7572450,'ath',50,1),(1101,7572458,7572456,'fre',14.286,1),(1101,7572459,7572456,'ree',14.286,1),(1101,7572460,7572456,'ees',14.286,1),(1101,7572461,7572456,'esp',14.286,1),(1101,7572462,7572456,'spa',14.286,1),(1101,7572463,7572456,'pac',14.286,1),(1101,7572464,7572456,'ace',14.286,1),(1101,7572465,7572458,'dis',50,1),(1101,7572466,7572458,'isk',50,1),(1101,7572467,7572465,'ind',33.333,1),(1101,7572468,7572465,'nde',33.333,1),(1101,7572469,7572465,'dex',33.333,1),(1101,7572470,7572467,'adm',8.333,1),(1101,7572471,7572467,'dmi',8.333,1),(1101,7572472,7572467,'min',8.333,1),(1101,7572473,7572467,'ini',8.333,1),(1101,7572474,7572467,'nis',8.333,1),(1101,7572475,7572467,'ist',8.333,1),(1101,7572476,7572467,'str',8.333,1),(1101,7572477,7572467,'tra',8.333,1),(1101,7572478,7572467,'rat',8.333,1),(1101,7572479,7572467,'ati',8.333,1),(1101,7572480,7572467,'tio',8.333,1),(1101,7572481,7572467,'ion',8.333,1),(1101,7572482,7572470,'sta',33.333,3),(1101,7572483,7572470,'tat',33.333,3),(1101,7572484,7572470,'ate',33.333,3),(1101,7572485,7572482,'dis',16.667,4),(1101,7572486,7572482,'isa',16.667,4),(1101,7572487,7572482,'sab',16.667,4),(1101,7572488,7572482,'abl',16.667,4),(1101,7572489,7572482,'ble',16.667,4),(1101,7572490,7572482,'led',16.667,4),(1101,7572491,7572485,'cac',33.333,1),(1101,7572492,7572485,'ach',33.333,1),(1101,7572493,7572485,'che',33.333,1),(1101,7572494,7572491,'mod',50,1),(1101,7572495,7572491,'ode',50,1),(1101,7572496,7572494,'wri',14.286,1),(1101,7572497,7572494,'rit',14.286,1),(1101,7572498,7572494,'ite',14.286,1),(1101,7572499,7572494,'tet',14.286,1),(1101,7572500,7572494,'eth',14.286,1),(1101,7572501,7572494,'thr',14.286,1),(1101,7572502,7572494,'hru',14.286,1),(1101,7572503,7572496,'ope',11.111,2),(1101,7572504,7572496,'per',11.111,2),(1101,7572505,7572496,'era',11.111,2),(1101,7572506,7572496,'rat',11.111,2),(1101,7572507,7572496,'ati',11.111,2),(1101,7572508,7572496,'tio',11.111,2),(1101,7572509,7572496,'ion',11.111,2),(1101,7572510,7572496,'ona',11.111,2),(1101,7572511,7572496,'nal',11.111,2),(1101,7572512,7572503,'mes',20,1),(1101,7572513,7572503,'ess',20,1),(1101,7572514,7572503,'ssa',20,1),(1101,7572515,7572503,'sag',20,1),(1101,7572516,7572503,'age',20,1),(1101,7572517,7572512,'per',11.111,1),(1101,7572518,7572512,'erf',11.111,1),(1101,7572519,7572512,'rfo',11.111,1),(1101,7572520,7572512,'for',11.111,1),(1101,7572521,7572512,'orm',11.111,1),(1101,7572522,7572512,'rma',11.111,1),(1101,7572523,7572512,'man',11.111,1),(1101,7572524,7572512,'anc',11.111,1),(1101,7572525,7572512,'nce',11.111,1),(1101,7572526,7572517,'ide',12.5,1),(1101,7572527,7572517,'den',12.5,1),(1101,7572528,7572517,'ent',12.5,1),(1101,7572529,7572517,'nti',12.5,1),(1101,7572530,7572517,'tif',12.5,1),(1101,7572531,7572517,'ifi',12.5,1),(1101,7572532,7572517,'fie',12.5,1),(1101,7572533,7572517,'ier',12.5,1),(1101,7572534,7572526,'vdi',33.333,3),(1101,7572535,7572526,'dis',33.333,3),(1101,7572536,7572526,'isk',33.333,3),(1101,7572537,7572534,'nam',50,1),(1101,7572538,7572534,'ame',50,1),(1101,7572539,7572537,'typ',50,1),(1101,7572540,7572537,'ype',50,1),(1101,7572541,7572539,'dir',25,1),(1101,7572542,7572539,'ire',25,1),(1101,7572543,7572539,'rec',25,1),(1101,7572544,7572539,'ect',25,1),(1102,7572546,7572545,'naa',100,2),(1102,7572547,7572546,'600',3.333,3),(1102,7572548,7572546,'000',3.333,3),(1102,7572549,7572546,'00c',3.333,3),(1102,7572550,7572546,'0c2',3.333,3),(1102,7572551,7572546,'c29',3.333,3),(1102,7572552,7572546,'296',3.333,3),(1102,7572553,7572546,'968',3.333,3),(1102,7572554,7572546,'682',3.333,3),(1102,7572555,7572546,'821',3.333,3),(1102,7572556,7572546,'21e',3.333,3),(1102,7572557,7572546,'1e5',3.333,3),(1102,7572558,7572546,'e5f',3.333,3),(1102,7572559,7572546,'5fb',3.333,3),(1102,7572560,7572546,'fb0',3.333,3),(1102,7572561,7572546,'b0a',3.333,3),(1102,7572562,7572546,'0a4',3.333,3),(1102,7572563,7572546,'a4f',3.333,3),(1102,7572564,7572546,'4f1',3.333,3),(1102,7572565,7572546,'f17',3.333,3),(1102,7572566,7572546,'17b',3.333,3),(1102,7572567,7572546,'7bb',3.333,3),(1102,7572568,7572546,'bb5',3.333,3),(1102,7572569,7572546,'b56',3.333,3),(1102,7572570,7572546,'560',3.333,3),(1102,7572571,7572546,'609',3.333,3),(1102,7572572,7572546,'090',3.333,3),(1102,7572573,7572546,'90b',3.333,3),(1102,7572574,7572546,'0b7',3.333,3),(1102,7572575,7572546,'b77',3.333,3),(1102,7572576,7572546,'773',3.333,3),(1102,7572577,7572547,'mon',100,1),(1102,7572578,7572577,'201',50,1),(1102,7572579,7572577,'013',50,1),(1102,7572580,7572578,'adm',33.333,4),(1102,7572581,7572578,'dmi',33.333,4),(1102,7572582,7572578,'min',33.333,4),(1102,7572583,7572580,'cap',16.667,1),(1102,7572584,7572580,'apa',16.667,1),(1102,7572585,7572580,'pac',16.667,1),(1102,7572586,7572580,'aci',16.667,1),(1102,7572587,7572580,'cit',16.667,1),(1102,7572588,7572580,'ity',16.667,1),(1102,7572589,7572583,'pat',50,1),(1102,7572590,7572583,'ath',50,1),(1102,7572591,7572589,'fre',14.286,1),(1102,7572592,7572589,'ree',14.286,1),(1102,7572593,7572589,'ees',14.286,1),(1102,7572594,7572589,'esp',14.286,1),(1102,7572595,7572589,'spa',14.286,1),(1102,7572596,7572589,'pac',14.286,1),(1102,7572597,7572589,'ace',14.286,1),(1102,7572598,7572591,'dis',50,1),(1102,7572599,7572591,'isk',50,1),(1102,7572600,7572598,'ind',33.333,1),(1102,7572601,7572598,'nde',33.333,1),(1102,7572602,7572598,'dex',33.333,1),(1102,7572603,7572600,'adm',8.333,1),(1102,7572604,7572600,'dmi',8.333,1),(1102,7572605,7572600,'min',8.333,1),(1102,7572606,7572600,'ini',8.333,1),(1102,7572607,7572600,'nis',8.333,1),(1102,7572608,7572600,'ist',8.333,1),(1102,7572609,7572600,'str',8.333,1),(1102,7572610,7572600,'tra',8.333,1),(1102,7572611,7572600,'rat',8.333,1),(1102,7572612,7572600,'ati',8.333,1),(1102,7572613,7572600,'tio',8.333,1),(1102,7572614,7572600,'ion',8.333,1),(1102,7572615,7572603,'sta',33.333,3),(1102,7572616,7572603,'tat',33.333,3),(1102,7572617,7572603,'ate',33.333,3),(1102,7572618,7572615,'dis',16.667,4),(1102,7572619,7572615,'isa',16.667,4),(1102,7572620,7572615,'sab',16.667,4),(1102,7572621,7572615,'abl',16.667,4),(1102,7572622,7572615,'ble',16.667,4),(1102,7572623,7572615,'led',16.667,4),(1102,7572624,7572618,'cac',33.333,1),(1102,7572625,7572618,'ach',33.333,1),(1102,7572626,7572618,'che',33.333,1),(1102,7572627,7572624,'mod',50,1),(1102,7572628,7572624,'ode',50,1),(1102,7572629,7572627,'wri',14.286,1),(1102,7572630,7572627,'rit',14.286,1),(1102,7572631,7572627,'ite',14.286,1),(1102,7572632,7572627,'tet',14.286,1),(1102,7572633,7572627,'eth',14.286,1),(1102,7572634,7572627,'thr',14.286,1),(1102,7572635,7572627,'hru',14.286,1),(1102,7572636,7572629,'ope',11.111,2),(1102,7572637,7572629,'per',11.111,2),(1102,7572638,7572629,'era',11.111,2),(1102,7572639,7572629,'rat',11.111,2),(1102,7572640,7572629,'ati',11.111,2),(1102,7572641,7572629,'tio',11.111,2),(1102,7572642,7572629,'ion',11.111,2),(1102,7572643,7572629,'ona',11.111,2),(1102,7572644,7572629,'nal',11.111,2),(1102,7572645,7572636,'mes',20,1),(1102,7572646,7572636,'ess',20,1),(1102,7572647,7572636,'ssa',20,1),(1102,7572648,7572636,'sag',20,1),(1102,7572649,7572636,'age',20,1),(1102,7572650,7572645,'per',11.111,1),(1102,7572651,7572645,'erf',11.111,1),(1102,7572652,7572645,'rfo',11.111,1),(1102,7572653,7572645,'for',11.111,1),(1102,7572654,7572645,'orm',11.111,1),(1102,7572655,7572645,'rma',11.111,1),(1102,7572656,7572645,'man',11.111,1),(1102,7572657,7572645,'anc',11.111,1),(1102,7572658,7572645,'nce',11.111,1),(1102,7572659,7572650,'ide',12.5,1),(1102,7572660,7572650,'den',12.5,1),(1102,7572661,7572650,'ent',12.5,1),(1102,7572662,7572650,'nti',12.5,1),(1102,7572663,7572650,'tif',12.5,1),(1102,7572664,7572650,'ifi',12.5,1),(1102,7572665,7572650,'fie',12.5,1),(1102,7572666,7572650,'ier',12.5,1),(1102,7572667,7572659,'vdi',33.333,3),(1102,7572668,7572659,'dis',33.333,3),(1102,7572669,7572659,'isk',33.333,3),(1102,7572670,7572667,'nam',50,1),(1102,7572671,7572667,'ame',50,1),(1102,7572672,7572670,'typ',50,1),(1102,7572673,7572670,'ype',50,1),(1102,7572674,7572672,'dir',25,1),(1102,7572675,7572672,'ire',25,1),(1102,7572676,7572672,'rec',25,1),(1102,7572677,7572672,'ect',25,1),(1103,7572679,7572678,'naa',100,2),(1103,7572680,7572679,'600',3.333,3),(1103,7572681,7572679,'000',3.333,3),(1103,7572682,7572679,'00c',3.333,3),(1103,7572683,7572679,'0c2',3.333,3),(1103,7572684,7572679,'c29',3.333,3),(1103,7572685,7572679,'290',3.333,3),(1103,7572686,7572679,'909',3.333,3),(1103,7572687,7572679,'098',3.333,3),(1103,7572688,7572679,'987',3.333,3),(1103,7572689,7572679,'879',3.333,3),(1103,7572690,7572679,'795',3.333,3),(1103,7572691,7572679,'95d',3.333,3),(1103,7572692,7572679,'5d4',3.333,3),(1103,7572693,7572679,'d4a',3.333,3),(1103,7572694,7572679,'4a5',3.333,3),(1103,7572695,7572679,'a5d',3.333,3),(1103,7572696,7572679,'5d4',3.333,3),(1103,7572697,7572679,'d4b',3.333,3),(1103,7572698,7572679,'4bc',3.333,3),(1103,7572699,7572679,'bc4',3.333,3),(1103,7572700,7572679,'c49',3.333,3),(1103,7572701,7572679,'495',3.333,3),(1103,7572702,7572679,'956',3.333,3),(1103,7572703,7572679,'561',3.333,3),(1103,7572704,7572679,'615',3.333,3),(1103,7572705,7572679,'157',3.333,3),(1103,7572706,7572679,'577',3.333,3),(1103,7572707,7572679,'77a',3.333,3),(1103,7572708,7572679,'7ab',3.333,3),(1103,7572709,7572679,'ab2',3.333,3),(1103,7572710,7572680,'mon',100,1),(1103,7572711,7572710,'201',50,1),(1103,7572712,7572710,'013',50,1),(1103,7572713,7572711,'adm',33.333,4),(1103,7572714,7572711,'dmi',33.333,4),(1103,7572715,7572711,'min',33.333,4),(1103,7572716,7572713,'cap',16.667,1),(1103,7572717,7572713,'apa',16.667,1),(1103,7572718,7572713,'pac',16.667,1),(1103,7572719,7572713,'aci',16.667,1),(1103,7572720,7572713,'cit',16.667,1),(1103,7572721,7572713,'ity',16.667,1),(1103,7572722,7572716,'pat',50,1),(1103,7572723,7572716,'ath',50,1),(1103,7572724,7572722,'fre',14.286,1),(1103,7572725,7572722,'ree',14.286,1),(1103,7572726,7572722,'ees',14.286,1),(1103,7572727,7572722,'esp',14.286,1),(1103,7572728,7572722,'spa',14.286,1),(1103,7572729,7572722,'pac',14.286,1),(1103,7572730,7572722,'ace',14.286,1),(1103,7572731,7572724,'dis',50,1),(1103,7572732,7572724,'isk',50,1),(1103,7572733,7572731,'ind',33.333,1),(1103,7572734,7572731,'nde',33.333,1),(1103,7572735,7572731,'dex',33.333,1),(1103,7572736,7572733,'adm',8.333,1),(1103,7572737,7572733,'dmi',8.333,1),(1103,7572738,7572733,'min',8.333,1),(1103,7572739,7572733,'ini',8.333,1),(1103,7572740,7572733,'nis',8.333,1),(1103,7572741,7572733,'ist',8.333,1),(1103,7572742,7572733,'str',8.333,1),(1103,7572743,7572733,'tra',8.333,1),(1103,7572744,7572733,'rat',8.333,1),(1103,7572745,7572733,'ati',8.333,1),(1103,7572746,7572733,'tio',8.333,1),(1103,7572747,7572733,'ion',8.333,1),(1103,7572748,7572736,'sta',33.333,3),(1103,7572749,7572736,'tat',33.333,3),(1103,7572750,7572736,'ate',33.333,3),(1103,7572751,7572748,'dis',16.667,4),(1103,7572752,7572748,'isa',16.667,4),(1103,7572753,7572748,'sab',16.667,4),(1103,7572754,7572748,'abl',16.667,4),(1103,7572755,7572748,'ble',16.667,4),(1103,7572756,7572748,'led',16.667,4),(1103,7572757,7572751,'cac',33.333,1),(1103,7572758,7572751,'ach',33.333,1),(1103,7572759,7572751,'che',33.333,1),(1103,7572760,7572757,'mod',50,1),(1103,7572761,7572757,'ode',50,1),(1103,7572762,7572760,'wri',14.286,1),(1103,7572763,7572760,'rit',14.286,1),(1103,7572764,7572760,'ite',14.286,1),(1103,7572765,7572760,'tet',14.286,1),(1103,7572766,7572760,'eth',14.286,1),(1103,7572767,7572760,'thr',14.286,1),(1103,7572768,7572760,'hru',14.286,1),(1103,7572769,7572762,'ope',11.111,2),(1103,7572770,7572762,'per',11.111,2),(1103,7572771,7572762,'era',11.111,2),(1103,7572772,7572762,'rat',11.111,2),(1103,7572773,7572762,'ati',11.111,2),(1103,7572774,7572762,'tio',11.111,2),(1103,7572775,7572762,'ion',11.111,2),(1103,7572776,7572762,'ona',11.111,2),(1103,7572777,7572762,'nal',11.111,2),(1103,7572778,7572769,'mes',20,1),(1103,7572779,7572769,'ess',20,1),(1103,7572780,7572769,'ssa',20,1),(1103,7572781,7572769,'sag',20,1),(1103,7572782,7572769,'age',20,1),(1103,7572783,7572778,'per',11.111,1),(1103,7572784,7572778,'erf',11.111,1),(1103,7572785,7572778,'rfo',11.111,1),(1103,7572786,7572778,'for',11.111,1),(1103,7572787,7572778,'orm',11.111,1),(1103,7572788,7572778,'rma',11.111,1),(1103,7572789,7572778,'man',11.111,1),(1103,7572790,7572778,'anc',11.111,1),(1103,7572791,7572778,'nce',11.111,1),(1103,7572792,7572783,'ide',12.5,1),(1103,7572793,7572783,'den',12.5,1),(1103,7572794,7572783,'ent',12.5,1),(1103,7572795,7572783,'nti',12.5,1),(1103,7572796,7572783,'tif',12.5,1),(1103,7572797,7572783,'ifi',12.5,1),(1103,7572798,7572783,'fie',12.5,1),(1103,7572799,7572783,'ier',12.5,1),(1103,7572800,7572792,'vdi',33.333,3),(1103,7572801,7572792,'dis',33.333,3),(1103,7572802,7572792,'isk',33.333,3),(1103,7572803,7572800,'nam',50,1),(1103,7572804,7572800,'ame',50,1),(1103,7572805,7572803,'typ',50,1),(1103,7572806,7572803,'ype',50,1),(1103,7572807,7572805,'dir',25,1),(1103,7572808,7572805,'ire',25,1),(1103,7572809,7572805,'rec',25,1),(1103,7572810,7572805,'ect',25,1),(1104,7572812,7572811,'naa',100,2),(1104,7572813,7572812,'600',3.333,3),(1104,7572814,7572812,'000',3.333,3),(1104,7572815,7572812,'00c',3.333,3),(1104,7572816,7572812,'0c2',3.333,3),(1104,7572817,7572812,'c29',3.333,3),(1104,7572818,7572812,'294',3.333,3),(1104,7572819,7572812,'945',3.333,3),(1104,7572820,7572812,'45c',3.333,3),(1104,7572821,7572812,'5c6',3.333,3),(1104,7572822,7572812,'c6d',3.333,3),(1104,7572823,7572812,'6dc',3.333,3),(1104,7572824,7572812,'dc3',3.333,3),(1104,7572825,7572812,'c32',3.333,3),(1104,7572826,7572812,'32f',3.333,3),(1104,7572827,7572812,'2f2',3.333,3),(1104,7572828,7572812,'f24',3.333,3),(1104,7572829,7572812,'24c',3.333,3),(1104,7572830,7572812,'4c3',3.333,3),(1104,7572831,7572812,'c36',3.333,3),(1104,7572832,7572812,'369',3.333,3),(1104,7572833,7572812,'690',3.333,3),(1104,7572834,7572812,'90d',3.333,3),(1104,7572835,7572812,'0d7',3.333,3),(1104,7572836,7572812,'d7a',3.333,3),(1104,7572837,7572812,'7aa',3.333,3),(1104,7572838,7572812,'aae',3.333,3),(1104,7572839,7572812,'ae5',3.333,3),(1104,7572840,7572812,'e55',3.333,3),(1104,7572841,7572812,'552',3.333,3),(1104,7572842,7572812,'52b',3.333,3),(1104,7572843,7572813,'mon',100,1),(1104,7572844,7572843,'201',50,1),(1104,7572845,7572843,'013',50,1),(1104,7572846,7572844,'adm',33.333,4),(1104,7572847,7572844,'dmi',33.333,4),(1104,7572848,7572844,'min',33.333,4),(1104,7572849,7572846,'cap',16.667,1),(1104,7572850,7572846,'apa',16.667,1),(1104,7572851,7572846,'pac',16.667,1),(1104,7572852,7572846,'aci',16.667,1),(1104,7572853,7572846,'cit',16.667,1),(1104,7572854,7572846,'ity',16.667,1),(1104,7572855,7572849,'pat',50,1),(1104,7572856,7572849,'ath',50,1),(1104,7572857,7572855,'fre',14.286,1),(1104,7572858,7572855,'ree',14.286,1),(1104,7572859,7572855,'ees',14.286,1),(1104,7572860,7572855,'esp',14.286,1),(1104,7572861,7572855,'spa',14.286,1),(1104,7572862,7572855,'pac',14.286,1),(1104,7572863,7572855,'ace',14.286,1),(1104,7572864,7572857,'dis',50,1),(1104,7572865,7572857,'isk',50,1),(1104,7572866,7572864,'ind',33.333,1),(1104,7572867,7572864,'nde',33.333,1),(1104,7572868,7572864,'dex',33.333,1),(1104,7572869,7572866,'adm',8.333,1),(1104,7572870,7572866,'dmi',8.333,1),(1104,7572871,7572866,'min',8.333,1),(1104,7572872,7572866,'ini',8.333,1),(1104,7572873,7572866,'nis',8.333,1),(1104,7572874,7572866,'ist',8.333,1),(1104,7572875,7572866,'str',8.333,1),(1104,7572876,7572866,'tra',8.333,1),(1104,7572877,7572866,'rat',8.333,1),(1104,7572878,7572866,'ati',8.333,1),(1104,7572879,7572866,'tio',8.333,1),(1104,7572880,7572866,'ion',8.333,1),(1104,7572881,7572869,'sta',33.333,3),(1104,7572882,7572869,'tat',33.333,3),(1104,7572883,7572869,'ate',33.333,3),(1104,7572884,7572881,'dis',16.667,4),(1104,7572885,7572881,'isa',16.667,4),(1104,7572886,7572881,'sab',16.667,4),(1104,7572887,7572881,'abl',16.667,4),(1104,7572888,7572881,'ble',16.667,4),(1104,7572889,7572881,'led',16.667,4),(1104,7572890,7572884,'cac',33.333,1),(1104,7572891,7572884,'ach',33.333,1),(1104,7572892,7572884,'che',33.333,1),(1104,7572893,7572890,'mod',50,1),(1104,7572894,7572890,'ode',50,1),(1104,7572895,7572893,'wri',14.286,1),(1104,7572896,7572893,'rit',14.286,1),(1104,7572897,7572893,'ite',14.286,1),(1104,7572898,7572893,'tet',14.286,1),(1104,7572899,7572893,'eth',14.286,1),(1104,7572900,7572893,'thr',14.286,1),(1104,7572901,7572893,'hru',14.286,1),(1104,7572902,7572895,'ope',11.111,2),(1104,7572903,7572895,'per',11.111,2),(1104,7572904,7572895,'era',11.111,2),(1104,7572905,7572895,'rat',11.111,2),(1104,7572906,7572895,'ati',11.111,2),(1104,7572907,7572895,'tio',11.111,2),(1104,7572908,7572895,'ion',11.111,2),(1104,7572909,7572895,'ona',11.111,2),(1104,7572910,7572895,'nal',11.111,2),(1104,7572911,7572902,'mes',20,1),(1104,7572912,7572902,'ess',20,1),(1104,7572913,7572902,'ssa',20,1),(1104,7572914,7572902,'sag',20,1),(1104,7572915,7572902,'age',20,1),(1104,7572916,7572911,'per',11.111,1),(1104,7572917,7572911,'erf',11.111,1),(1104,7572918,7572911,'rfo',11.111,1),(1104,7572919,7572911,'for',11.111,1),(1104,7572920,7572911,'orm',11.111,1),(1104,7572921,7572911,'rma',11.111,1),(1104,7572922,7572911,'man',11.111,1),(1104,7572923,7572911,'anc',11.111,1),(1104,7572924,7572911,'nce',11.111,1),(1104,7572925,7572916,'ide',12.5,1),(1104,7572926,7572916,'den',12.5,1),(1104,7572927,7572916,'ent',12.5,1),(1104,7572928,7572916,'nti',12.5,1),(1104,7572929,7572916,'tif',12.5,1),(1104,7572930,7572916,'ifi',12.5,1),(1104,7572931,7572916,'fie',12.5,1),(1104,7572932,7572916,'ier',12.5,1),(1104,7572933,7572925,'vdi',33.333,3),(1104,7572934,7572925,'dis',33.333,3),(1104,7572935,7572925,'isk',33.333,3),(1104,7572936,7572933,'nam',50,1),(1104,7572937,7572933,'ame',50,1),(1104,7572938,7572936,'typ',50,1),(1104,7572939,7572936,'ype',50,1),(1104,7572940,7572938,'dir',25,1),(1104,7572941,7572938,'ire',25,1),(1104,7572942,7572938,'rec',25,1),(1104,7572943,7572938,'ect',25,1),(1105,7572945,7572944,'naa',100,2),(1105,7572946,7572945,'600',3.333,3),(1105,7572947,7572945,'000',3.333,3),(1105,7572948,7572945,'00c',3.333,3),(1105,7572949,7572945,'0c2',3.333,3),(1105,7572950,7572945,'c29',3.333,3),(1105,7572951,7572945,'29c',3.333,3),(1105,7572952,7572945,'9c9',3.333,3),(1105,7572953,7572945,'c9b',3.333,3),(1105,7572954,7572945,'9b6',3.333,3),(1105,7572955,7572945,'b66',3.333,3),(1105,7572956,7572945,'665',3.333,3),(1105,7572957,7572945,'65f',3.333,3),(1105,7572958,7572945,'5f0',3.333,3),(1105,7572959,7572945,'f01',3.333,3),(1105,7572960,7572945,'014',3.333,3),(1105,7572961,7572945,'14e',3.333,3),(1105,7572962,7572945,'4e7',3.333,3),(1105,7572963,7572945,'e71',3.333,3),(1105,7572964,7572945,'71d',3.333,3),(1105,7572965,7572945,'1dd',3.333,3),(1105,7572966,7572945,'dda',3.333,3),(1105,7572967,7572945,'dab',3.333,3),(1105,7572968,7572945,'ab4',3.333,3),(1105,7572969,7572945,'b43',3.333,3),(1105,7572970,7572945,'43f',3.333,3),(1105,7572971,7572945,'3fc',3.333,3),(1105,7572972,7572945,'fcc',3.333,3),(1105,7572973,7572945,'ccb',3.333,3),(1105,7572974,7572945,'cbb',3.333,3),(1105,7572975,7572945,'bb5',3.333,3),(1105,7572976,7572946,'mon',100,1),(1105,7572977,7572976,'201',50,1),(1105,7572978,7572976,'013',50,1),(1105,7572979,7572977,'adm',33.333,4),(1105,7572980,7572977,'dmi',33.333,4),(1105,7572981,7572977,'min',33.333,4),(1105,7572982,7572979,'cap',16.667,1),(1105,7572983,7572979,'apa',16.667,1),(1105,7572984,7572979,'pac',16.667,1),(1105,7572985,7572979,'aci',16.667,1),(1105,7572986,7572979,'cit',16.667,1),(1105,7572987,7572979,'ity',16.667,1),(1105,7572988,7572982,'pat',50,1),(1105,7572989,7572982,'ath',50,1),(1105,7572990,7572988,'fre',14.286,1),(1105,7572991,7572988,'ree',14.286,1),(1105,7572992,7572988,'ees',14.286,1),(1105,7572993,7572988,'esp',14.286,1),(1105,7572994,7572988,'spa',14.286,1),(1105,7572995,7572988,'pac',14.286,1),(1105,7572996,7572988,'ace',14.286,1),(1105,7572997,7572990,'dis',50,1),(1105,7572998,7572990,'isk',50,1),(1105,7572999,7572997,'ind',33.333,1),(1105,7573000,7572997,'nde',33.333,1),(1105,7573001,7572997,'dex',33.333,1),(1105,7573002,7572999,'adm',8.333,1),(1105,7573003,7572999,'dmi',8.333,1),(1105,7573004,7572999,'min',8.333,1),(1105,7573005,7572999,'ini',8.333,1),(1105,7573006,7572999,'nis',8.333,1),(1105,7573007,7572999,'ist',8.333,1),(1105,7573008,7572999,'str',8.333,1),(1105,7573009,7572999,'tra',8.333,1),(1105,7573010,7572999,'rat',8.333,1),(1105,7573011,7572999,'ati',8.333,1),(1105,7573012,7572999,'tio',8.333,1),(1105,7573013,7572999,'ion',8.333,1),(1105,7573014,7573002,'sta',33.333,3),(1105,7573015,7573002,'tat',33.333,3),(1105,7573016,7573002,'ate',33.333,3),(1105,7573017,7573014,'dis',16.667,4),(1105,7573018,7573014,'isa',16.667,4),(1105,7573019,7573014,'sab',16.667,4),(1105,7573020,7573014,'abl',16.667,4),(1105,7573021,7573014,'ble',16.667,4),(1105,7573022,7573014,'led',16.667,4),(1105,7573023,7573017,'cac',33.333,1),(1105,7573024,7573017,'ach',33.333,1),(1105,7573025,7573017,'che',33.333,1),(1105,7573026,7573023,'mod',50,1),(1105,7573027,7573023,'ode',50,1),(1105,7573028,7573026,'wri',14.286,1),(1105,7573029,7573026,'rit',14.286,1),(1105,7573030,7573026,'ite',14.286,1),(1105,7573031,7573026,'tet',14.286,1),(1105,7573032,7573026,'eth',14.286,1),(1105,7573033,7573026,'thr',14.286,1),(1105,7573034,7573026,'hru',14.286,1),(1105,7573035,7573028,'ope',11.111,2),(1105,7573036,7573028,'per',11.111,2),(1105,7573037,7573028,'era',11.111,2),(1105,7573038,7573028,'rat',11.111,2),(1105,7573039,7573028,'ati',11.111,2),(1105,7573040,7573028,'tio',11.111,2),(1105,7573041,7573028,'ion',11.111,2),(1105,7573042,7573028,'ona',11.111,2),(1105,7573043,7573028,'nal',11.111,2),(1105,7573044,7573035,'mes',20,1),(1105,7573045,7573035,'ess',20,1),(1105,7573046,7573035,'ssa',20,1),(1105,7573047,7573035,'sag',20,1),(1105,7573048,7573035,'age',20,1),(1105,7573049,7573044,'per',11.111,1),(1105,7573050,7573044,'erf',11.111,1),(1105,7573051,7573044,'rfo',11.111,1),(1105,7573052,7573044,'for',11.111,1),(1105,7573053,7573044,'orm',11.111,1),(1105,7573054,7573044,'rma',11.111,1),(1105,7573055,7573044,'man',11.111,1),(1105,7573056,7573044,'anc',11.111,1),(1105,7573057,7573044,'nce',11.111,1),(1105,7573058,7573049,'ide',12.5,1),(1105,7573059,7573049,'den',12.5,1),(1105,7573060,7573049,'ent',12.5,1),(1105,7573061,7573049,'nti',12.5,1),(1105,7573062,7573049,'tif',12.5,1),(1105,7573063,7573049,'ifi',12.5,1),(1105,7573064,7573049,'fie',12.5,1),(1105,7573065,7573049,'ier',12.5,1),(1105,7573066,7573058,'vdi',33.333,3),(1105,7573067,7573058,'dis',33.333,3),(1105,7573068,7573058,'isk',33.333,3),(1105,7573069,7573066,'nam',50,1),(1105,7573070,7573066,'ame',50,1),(1105,7573071,7573069,'typ',50,1),(1105,7573072,7573069,'ype',50,1),(1105,7573073,7573071,'dir',25,1),(1105,7573074,7573071,'ire',25,1),(1105,7573075,7573071,'rec',25,1),(1105,7573076,7573071,'ect',25,1),(1106,7573078,7573077,'naa',100,2),(1106,7573079,7573078,'600',3.333,3),(1106,7573080,7573078,'000',3.333,3),(1106,7573081,7573078,'00c',3.333,3),(1106,7573082,7573078,'0c2',3.333,3),(1106,7573083,7573078,'c29',3.333,3),(1106,7573084,7573078,'294',3.333,3),(1106,7573085,7573078,'949',3.333,3),(1106,7573086,7573078,'497',3.333,3),(1106,7573087,7573078,'979',3.333,3),(1106,7573088,7573078,'791',3.333,3),(1106,7573089,7573078,'91c',3.333,3),(1106,7573090,7573078,'1c1',3.333,3),(1106,7573091,7573078,'c12',3.333,3),(1106,7573092,7573078,'12d',3.333,3),(1106,7573093,7573078,'2db',3.333,3),(1106,7573094,7573078,'db0',3.333,3),(1106,7573095,7573078,'b0e',3.333,3),(1106,7573096,7573078,'0ed',3.333,3),(1106,7573097,7573078,'ed4',3.333,3),(1106,7573098,7573078,'d4e',3.333,3),(1106,7573099,7573078,'4eb',3.333,3),(1106,7573100,7573078,'ebf',3.333,3),(1106,7573101,7573078,'bf4',3.333,3),(1106,7573102,7573078,'f4f',3.333,3),(1106,7573103,7573078,'4f0',3.333,3),(1106,7573104,7573078,'f09',3.333,3),(1106,7573105,7573078,'09e',3.333,3),(1106,7573106,7573078,'9e4',3.333,3),(1106,7573107,7573078,'e4e',3.333,3),(1106,7573108,7573078,'4e2',3.333,3),(1106,7573109,7573079,'mon',100,1),(1106,7573110,7573109,'201',50,1),(1106,7573111,7573109,'013',50,1),(1106,7573112,7573110,'adm',33.333,4),(1106,7573113,7573110,'dmi',33.333,4),(1106,7573114,7573110,'min',33.333,4),(1106,7573115,7573112,'cap',16.667,1),(1106,7573116,7573112,'apa',16.667,1),(1106,7573117,7573112,'pac',16.667,1),(1106,7573118,7573112,'aci',16.667,1),(1106,7573119,7573112,'cit',16.667,1),(1106,7573120,7573112,'ity',16.667,1),(1106,7573121,7573115,'pat',50,1),(1106,7573122,7573115,'ath',50,1),(1106,7573123,7573121,'fre',14.286,1),(1106,7573124,7573121,'ree',14.286,1),(1106,7573125,7573121,'ees',14.286,1),(1106,7573126,7573121,'esp',14.286,1),(1106,7573127,7573121,'spa',14.286,1),(1106,7573128,7573121,'pac',14.286,1),(1106,7573129,7573121,'ace',14.286,1),(1106,7573130,7573123,'dis',50,1),(1106,7573131,7573123,'isk',50,1),(1106,7573132,7573130,'ind',33.333,1),(1106,7573133,7573130,'nde',33.333,1),(1106,7573134,7573130,'dex',33.333,1),(1106,7573135,7573132,'adm',8.333,1),(1106,7573136,7573132,'dmi',8.333,1),(1106,7573137,7573132,'min',8.333,1),(1106,7573138,7573132,'ini',8.333,1),(1106,7573139,7573132,'nis',8.333,1),(1106,7573140,7573132,'ist',8.333,1),(1106,7573141,7573132,'str',8.333,1),(1106,7573142,7573132,'tra',8.333,1),(1106,7573143,7573132,'rat',8.333,1),(1106,7573144,7573132,'ati',8.333,1),(1106,7573145,7573132,'tio',8.333,1),(1106,7573146,7573132,'ion',8.333,1),(1106,7573147,7573135,'sta',33.333,3),(1106,7573148,7573135,'tat',33.333,3),(1106,7573149,7573135,'ate',33.333,3),(1106,7573150,7573147,'dis',16.667,4),(1106,7573151,7573147,'isa',16.667,4),(1106,7573152,7573147,'sab',16.667,4),(1106,7573153,7573147,'abl',16.667,4),(1106,7573154,7573147,'ble',16.667,4),(1106,7573155,7573147,'led',16.667,4),(1106,7573156,7573150,'cac',33.333,1),(1106,7573157,7573150,'ach',33.333,1),(1106,7573158,7573150,'che',33.333,1),(1106,7573159,7573156,'mod',50,1),(1106,7573160,7573156,'ode',50,1),(1106,7573161,7573159,'wri',14.286,1),(1106,7573162,7573159,'rit',14.286,1),(1106,7573163,7573159,'ite',14.286,1),(1106,7573164,7573159,'tet',14.286,1),(1106,7573165,7573159,'eth',14.286,1),(1106,7573166,7573159,'thr',14.286,1),(1106,7573167,7573159,'hru',14.286,1),(1106,7573168,7573161,'ope',11.111,2),(1106,7573169,7573161,'per',11.111,2),(1106,7573170,7573161,'era',11.111,2),(1106,7573171,7573161,'rat',11.111,2),(1106,7573172,7573161,'ati',11.111,2),(1106,7573173,7573161,'tio',11.111,2),(1106,7573174,7573161,'ion',11.111,2),(1106,7573175,7573161,'ona',11.111,2),(1106,7573176,7573161,'nal',11.111,2),(1106,7573177,7573168,'mes',20,1),(1106,7573178,7573168,'ess',20,1),(1106,7573179,7573168,'ssa',20,1),(1106,7573180,7573168,'sag',20,1),(1106,7573181,7573168,'age',20,1),(1106,7573182,7573177,'per',11.111,1),(1106,7573183,7573177,'erf',11.111,1),(1106,7573184,7573177,'rfo',11.111,1),(1106,7573185,7573177,'for',11.111,1),(1106,7573186,7573177,'orm',11.111,1),(1106,7573187,7573177,'rma',11.111,1),(1106,7573188,7573177,'man',11.111,1),(1106,7573189,7573177,'anc',11.111,1),(1106,7573190,7573177,'nce',11.111,1),(1106,7573191,7573182,'ide',12.5,1),(1106,7573192,7573182,'den',12.5,1),(1106,7573193,7573182,'ent',12.5,1),(1106,7573194,7573182,'nti',12.5,1),(1106,7573195,7573182,'tif',12.5,1),(1106,7573196,7573182,'ifi',12.5,1),(1106,7573197,7573182,'fie',12.5,1),(1106,7573198,7573182,'ier',12.5,1),(1106,7573199,7573191,'vdi',33.333,3),(1106,7573200,7573191,'dis',33.333,3),(1106,7573201,7573191,'isk',33.333,3),(1106,7573202,7573199,'nam',50,1),(1106,7573203,7573199,'ame',50,1),(1106,7573204,7573202,'typ',50,1),(1106,7573205,7573202,'ype',50,1),(1106,7573206,7573204,'dir',25,1),(1106,7573207,7573204,'ire',25,1),(1106,7573208,7573204,'rec',25,1),(1106,7573209,7573204,'ect',25,1),(1107,7573211,7573210,'naa',100,2),(1107,7573212,7573211,'600',3.333,3),(1107,7573213,7573211,'000',3.333,3),(1107,7573214,7573211,'00c',3.333,3),(1107,7573215,7573211,'0c2',3.333,3),(1107,7573216,7573211,'c29',3.333,3),(1107,7573217,7573211,'294',3.333,3),(1107,7573218,7573211,'94e',3.333,3),(1107,7573219,7573211,'4e8',3.333,3),(1107,7573220,7573211,'e87',3.333,3),(1107,7573221,7573211,'87b',3.333,3),(1107,7573222,7573211,'7b1',3.333,3),(1107,7573223,7573211,'b18',3.333,3),(1107,7573224,7573211,'184',3.333,3),(1107,7573225,7573211,'84d',3.333,3),(1107,7573226,7573211,'4d3',3.333,3),(1107,7573227,7573211,'d39',3.333,3),(1107,7573228,7573211,'39c',3.333,3),(1107,7573229,7573211,'9c6',3.333,3),(1107,7573230,7573211,'c68',3.333,3),(1107,7573231,7573211,'682',3.333,3),(1107,7573232,7573211,'82d',3.333,3),(1107,7573233,7573211,'2d1',3.333,3),(1107,7573234,7573211,'d18',3.333,3),(1107,7573235,7573211,'184',3.333,3),(1107,7573236,7573211,'84e',3.333,3),(1107,7573237,7573211,'4e8',3.333,3),(1107,7573238,7573211,'e89',3.333,3),(1107,7573239,7573211,'896',3.333,3),(1107,7573240,7573211,'96b',3.333,3),(1107,7573241,7573211,'6b0',3.333,3),(1107,7573242,7573212,'mon',100,1),(1107,7573243,7573242,'201',50,1),(1107,7573244,7573242,'013',50,1),(1107,7573245,7573243,'adm',33.333,4),(1107,7573246,7573243,'dmi',33.333,4),(1107,7573247,7573243,'min',33.333,4),(1107,7573248,7573245,'cap',16.667,1),(1107,7573249,7573245,'apa',16.667,1),(1107,7573250,7573245,'pac',16.667,1),(1107,7573251,7573245,'aci',16.667,1),(1107,7573252,7573245,'cit',16.667,1),(1107,7573253,7573245,'ity',16.667,1),(1107,7573254,7573248,'pat',50,1),(1107,7573255,7573248,'ath',50,1),(1107,7573256,7573254,'fre',14.286,1),(1107,7573257,7573254,'ree',14.286,1),(1107,7573258,7573254,'ees',14.286,1),(1107,7573259,7573254,'esp',14.286,1),(1107,7573260,7573254,'spa',14.286,1),(1107,7573261,7573254,'pac',14.286,1),(1107,7573262,7573254,'ace',14.286,1),(1107,7573263,7573256,'dis',50,1),(1107,7573264,7573256,'isk',50,1),(1107,7573265,7573263,'ind',33.333,1),(1107,7573266,7573263,'nde',33.333,1),(1107,7573267,7573263,'dex',33.333,1),(1107,7573268,7573265,'adm',8.333,1),(1107,7573269,7573265,'dmi',8.333,1),(1107,7573270,7573265,'min',8.333,1),(1107,7573271,7573265,'ini',8.333,1),(1107,7573272,7573265,'nis',8.333,1),(1107,7573273,7573265,'ist',8.333,1),(1107,7573274,7573265,'str',8.333,1),(1107,7573275,7573265,'tra',8.333,1),(1107,7573276,7573265,'rat',8.333,1),(1107,7573277,7573265,'ati',8.333,1),(1107,7573278,7573265,'tio',8.333,1),(1107,7573279,7573265,'ion',8.333,1),(1107,7573280,7573268,'sta',33.333,3),(1107,7573281,7573268,'tat',33.333,3),(1107,7573282,7573268,'ate',33.333,3),(1107,7573283,7573280,'dis',16.667,4),(1107,7573284,7573280,'isa',16.667,4),(1107,7573285,7573280,'sab',16.667,4),(1107,7573286,7573280,'abl',16.667,4),(1107,7573287,7573280,'ble',16.667,4),(1107,7573288,7573280,'led',16.667,4),(1107,7573289,7573283,'cac',33.333,1),(1107,7573290,7573283,'ach',33.333,1),(1107,7573291,7573283,'che',33.333,1),(1107,7573292,7573289,'mod',50,1),(1107,7573293,7573289,'ode',50,1),(1107,7573294,7573292,'wri',14.286,1),(1107,7573295,7573292,'rit',14.286,1),(1107,7573296,7573292,'ite',14.286,1),(1107,7573297,7573292,'tet',14.286,1),(1107,7573298,7573292,'eth',14.286,1),(1107,7573299,7573292,'thr',14.286,1),(1107,7573300,7573292,'hru',14.286,1),(1107,7573301,7573294,'ope',11.111,2),(1107,7573302,7573294,'per',11.111,2),(1107,7573303,7573294,'era',11.111,2),(1107,7573304,7573294,'rat',11.111,2),(1107,7573305,7573294,'ati',11.111,2),(1107,7573306,7573294,'tio',11.111,2),(1107,7573307,7573294,'ion',11.111,2),(1107,7573308,7573294,'ona',11.111,2),(1107,7573309,7573294,'nal',11.111,2),(1107,7573310,7573301,'mes',20,1),(1107,7573311,7573301,'ess',20,1),(1107,7573312,7573301,'ssa',20,1),(1107,7573313,7573301,'sag',20,1),(1107,7573314,7573301,'age',20,1),(1107,7573315,7573310,'per',11.111,1),(1107,7573316,7573310,'erf',11.111,1),(1107,7573317,7573310,'rfo',11.111,1),(1107,7573318,7573310,'for',11.111,1),(1107,7573319,7573310,'orm',11.111,1),(1107,7573320,7573310,'rma',11.111,1),(1107,7573321,7573310,'man',11.111,1),(1107,7573322,7573310,'anc',11.111,1),(1107,7573323,7573310,'nce',11.111,1),(1107,7573324,7573315,'ide',12.5,1),(1107,7573325,7573315,'den',12.5,1),(1107,7573326,7573315,'ent',12.5,1),(1107,7573327,7573315,'nti',12.5,1),(1107,7573328,7573315,'tif',12.5,1),(1107,7573329,7573315,'ifi',12.5,1),(1107,7573330,7573315,'fie',12.5,1),(1107,7573331,7573315,'ier',12.5,1),(1107,7573332,7573324,'vdi',33.333,3),(1107,7573333,7573324,'dis',33.333,3),(1107,7573334,7573324,'isk',33.333,3),(1107,7573335,7573332,'nam',50,1),(1107,7573336,7573332,'ame',50,1),(1107,7573337,7573335,'typ',50,1),(1107,7573338,7573335,'ype',50,1),(1107,7573339,7573337,'dir',25,1),(1107,7573340,7573337,'ire',25,1),(1107,7573341,7573337,'rec',25,1),(1107,7573342,7573337,'ect',25,1),(1108,7573344,7573343,'naa',100,2),(1108,7573345,7573344,'600',3.333,3),(1108,7573346,7573344,'000',3.333,3),(1108,7573347,7573344,'00c',3.333,3),(1108,7573348,7573344,'0c2',3.333,3),(1108,7573349,7573344,'c29',3.333,3),(1108,7573350,7573344,'290',3.333,3),(1108,7573351,7573344,'902',3.333,3),(1108,7573352,7573344,'02a',3.333,3),(1108,7573353,7573344,'2a2',3.333,3),(1108,7573354,7573344,'a2d',3.333,3),(1108,7573355,7573344,'2d7',3.333,3),(1108,7573356,7573344,'d72',3.333,3),(1108,7573357,7573344,'72e',3.333,3),(1108,7573358,7573344,'2ef',3.333,3),(1108,7573359,7573344,'efe',3.333,3),(1108,7573360,7573344,'fe7',3.333,3),(1108,7573361,7573344,'e74',3.333,3),(1108,7573362,7573344,'744',3.333,3),(1108,7573363,7573344,'44e',3.333,3),(1108,7573364,7573344,'4e3',3.333,3),(1108,7573365,7573344,'e32',3.333,3),(1108,7573366,7573344,'321',3.333,3),(1108,7573367,7573344,'213',3.333,3),(1108,7573368,7573344,'137',3.333,3),(1108,7573369,7573344,'374',3.333,3),(1108,7573370,7573344,'743',3.333,3),(1108,7573371,7573344,'43a',3.333,3),(1108,7573372,7573344,'3a5',3.333,3),(1108,7573373,7573344,'a5c',3.333,3),(1108,7573374,7573344,'5cf',3.333,3),(1108,7573375,7573345,'mon',100,1),(1108,7573376,7573375,'201',50,1),(1108,7573377,7573375,'013',50,1),(1108,7573378,7573376,'adm',33.333,4),(1108,7573379,7573376,'dmi',33.333,4),(1108,7573380,7573376,'min',33.333,4),(1108,7573381,7573378,'cap',16.667,1),(1108,7573382,7573378,'apa',16.667,1),(1108,7573383,7573378,'pac',16.667,1),(1108,7573384,7573378,'aci',16.667,1),(1108,7573385,7573378,'cit',16.667,1),(1108,7573386,7573378,'ity',16.667,1),(1108,7573387,7573381,'pat',50,1),(1108,7573388,7573381,'ath',50,1),(1108,7573389,7573387,'fre',14.286,1),(1108,7573390,7573387,'ree',14.286,1),(1108,7573391,7573387,'ees',14.286,1),(1108,7573392,7573387,'esp',14.286,1),(1108,7573393,7573387,'spa',14.286,1),(1108,7573394,7573387,'pac',14.286,1),(1108,7573395,7573387,'ace',14.286,1),(1108,7573396,7573389,'dis',50,1),(1108,7573397,7573389,'isk',50,1),(1108,7573398,7573396,'ind',33.333,1),(1108,7573399,7573396,'nde',33.333,1),(1108,7573400,7573396,'dex',33.333,1),(1108,7573401,7573398,'adm',8.333,1),(1108,7573402,7573398,'dmi',8.333,1),(1108,7573403,7573398,'min',8.333,1),(1108,7573404,7573398,'ini',8.333,1),(1108,7573405,7573398,'nis',8.333,1),(1108,7573406,7573398,'ist',8.333,1),(1108,7573407,7573398,'str',8.333,1),(1108,7573408,7573398,'tra',8.333,1),(1108,7573409,7573398,'rat',8.333,1),(1108,7573410,7573398,'ati',8.333,1),(1108,7573411,7573398,'tio',8.333,1),(1108,7573412,7573398,'ion',8.333,1),(1108,7573413,7573401,'sta',33.333,3),(1108,7573414,7573401,'tat',33.333,3),(1108,7573415,7573401,'ate',33.333,3),(1108,7573416,7573413,'dis',16.667,4),(1108,7573417,7573413,'isa',16.667,4),(1108,7573418,7573413,'sab',16.667,4),(1108,7573419,7573413,'abl',16.667,4),(1108,7573420,7573413,'ble',16.667,4),(1108,7573421,7573413,'led',16.667,4),(1108,7573422,7573416,'cac',33.333,1),(1108,7573423,7573416,'ach',33.333,1),(1108,7573424,7573416,'che',33.333,1),(1108,7573425,7573422,'mod',50,1),(1108,7573426,7573422,'ode',50,1),(1108,7573427,7573425,'wri',14.286,1),(1108,7573428,7573425,'rit',14.286,1),(1108,7573429,7573425,'ite',14.286,1),(1108,7573430,7573425,'tet',14.286,1),(1108,7573431,7573425,'eth',14.286,1),(1108,7573432,7573425,'thr',14.286,1),(1108,7573433,7573425,'hru',14.286,1),(1108,7573434,7573427,'ope',11.111,2),(1108,7573435,7573427,'per',11.111,2),(1108,7573436,7573427,'era',11.111,2),(1108,7573437,7573427,'rat',11.111,2),(1108,7573438,7573427,'ati',11.111,2),(1108,7573439,7573427,'tio',11.111,2),(1108,7573440,7573427,'ion',11.111,2),(1108,7573441,7573427,'ona',11.111,2),(1108,7573442,7573427,'nal',11.111,2),(1108,7573443,7573434,'mes',20,1),(1108,7573444,7573434,'ess',20,1),(1108,7573445,7573434,'ssa',20,1),(1108,7573446,7573434,'sag',20,1),(1108,7573447,7573434,'age',20,1),(1108,7573448,7573443,'per',11.111,1),(1108,7573449,7573443,'erf',11.111,1),(1108,7573450,7573443,'rfo',11.111,1),(1108,7573451,7573443,'for',11.111,1),(1108,7573452,7573443,'orm',11.111,1),(1108,7573453,7573443,'rma',11.111,1),(1108,7573454,7573443,'man',11.111,1),(1108,7573455,7573443,'anc',11.111,1),(1108,7573456,7573443,'nce',11.111,1),(1108,7573457,7573448,'ide',12.5,1),(1108,7573458,7573448,'den',12.5,1),(1108,7573459,7573448,'ent',12.5,1),(1108,7573460,7573448,'nti',12.5,1),(1108,7573461,7573448,'tif',12.5,1),(1108,7573462,7573448,'ifi',12.5,1),(1108,7573463,7573448,'fie',12.5,1),(1108,7573464,7573448,'ier',12.5,1),(1108,7573465,7573457,'vdi',33.333,3),(1108,7573466,7573457,'dis',33.333,3),(1108,7573467,7573457,'isk',33.333,3),(1108,7573468,7573465,'nam',50,1),(1108,7573469,7573465,'ame',50,1),(1108,7573470,7573468,'typ',50,1),(1108,7573471,7573468,'ype',50,1),(1108,7573472,7573470,'dir',25,1),(1108,7573473,7573470,'ire',25,1),(1108,7573474,7573470,'rec',25,1),(1108,7573475,7573470,'ect',25,1),(1109,7573477,7573476,'naa',100,2),(1109,7573478,7573477,'600',3.333,3),(1109,7573479,7573477,'000',3.333,3),(1109,7573480,7573477,'00c',3.333,3),(1109,7573481,7573477,'0c2',3.333,3),(1109,7573482,7573477,'c29',3.333,3),(1109,7573483,7573477,'29e',3.333,3),(1109,7573484,7573477,'9eb',3.333,3),(1109,7573485,7573477,'eba',3.333,3),(1109,7573486,7573477,'ba1',3.333,3),(1109,7573487,7573477,'a18',3.333,3),(1109,7573488,7573477,'18d',3.333,3),(1109,7573489,7573477,'8d7',3.333,3),(1109,7573490,7573477,'d72',3.333,3),(1109,7573491,7573477,'72a',3.333,3),(1109,7573492,7573477,'2af',3.333,3),(1109,7573493,7573477,'af5',3.333,3),(1109,7573494,7573477,'f5f',3.333,3),(1109,7573495,7573477,'5f0',3.333,3),(1109,7573496,7573477,'f05',3.333,3),(1109,7573497,7573477,'05b',3.333,3),(1109,7573498,7573477,'5be',3.333,3),(1109,7573499,7573477,'be4',3.333,3),(1109,7573500,7573477,'e4f',3.333,3),(1109,7573501,7573477,'4f0',3.333,3),(1109,7573502,7573477,'f01',3.333,3),(1109,7573503,7573477,'019',3.333,3),(1109,7573504,7573477,'194',3.333,3),(1109,7573505,7573477,'94b',3.333,3),(1109,7573506,7573477,'4b1',3.333,3),(1109,7573507,7573477,'b16',3.333,3),(1109,7573508,7573478,'mon',100,1),(1109,7573509,7573508,'201',50,1),(1109,7573510,7573508,'013',50,1),(1109,7573511,7573509,'adm',33.333,4),(1109,7573512,7573509,'dmi',33.333,4),(1109,7573513,7573509,'min',33.333,4),(1109,7573514,7573511,'cap',16.667,1),(1109,7573515,7573511,'apa',16.667,1),(1109,7573516,7573511,'pac',16.667,1),(1109,7573517,7573511,'aci',16.667,1),(1109,7573518,7573511,'cit',16.667,1),(1109,7573519,7573511,'ity',16.667,1),(1109,7573520,7573514,'pat',50,1),(1109,7573521,7573514,'ath',50,1),(1109,7573522,7573520,'fre',14.286,1),(1109,7573523,7573520,'ree',14.286,1),(1109,7573524,7573520,'ees',14.286,1),(1109,7573525,7573520,'esp',14.286,1),(1109,7573526,7573520,'spa',14.286,1),(1109,7573527,7573520,'pac',14.286,1),(1109,7573528,7573520,'ace',14.286,1),(1109,7573529,7573522,'dis',50,1),(1109,7573530,7573522,'isk',50,1),(1109,7573531,7573529,'ind',33.333,1),(1109,7573532,7573529,'nde',33.333,1),(1109,7573533,7573529,'dex',33.333,1),(1109,7573534,7573531,'adm',8.333,1),(1109,7573535,7573531,'dmi',8.333,1),(1109,7573536,7573531,'min',8.333,1),(1109,7573537,7573531,'ini',8.333,1),(1109,7573538,7573531,'nis',8.333,1),(1109,7573539,7573531,'ist',8.333,1),(1109,7573540,7573531,'str',8.333,1),(1109,7573541,7573531,'tra',8.333,1),(1109,7573542,7573531,'rat',8.333,1),(1109,7573543,7573531,'ati',8.333,1),(1109,7573544,7573531,'tio',8.333,1),(1109,7573545,7573531,'ion',8.333,1),(1109,7573546,7573534,'sta',33.333,3),(1109,7573547,7573534,'tat',33.333,3),(1109,7573548,7573534,'ate',33.333,3),(1109,7573549,7573546,'dis',16.667,4),(1109,7573550,7573546,'isa',16.667,4),(1109,7573551,7573546,'sab',16.667,4),(1109,7573552,7573546,'abl',16.667,4),(1109,7573553,7573546,'ble',16.667,4),(1109,7573554,7573546,'led',16.667,4),(1109,7573555,7573549,'cac',33.333,1),(1109,7573556,7573549,'ach',33.333,1),(1109,7573557,7573549,'che',33.333,1),(1109,7573558,7573555,'mod',50,1),(1109,7573559,7573555,'ode',50,1),(1109,7573560,7573558,'wri',14.286,1),(1109,7573561,7573558,'rit',14.286,1),(1109,7573562,7573558,'ite',14.286,1),(1109,7573563,7573558,'tet',14.286,1),(1109,7573564,7573558,'eth',14.286,1),(1109,7573565,7573558,'thr',14.286,1),(1109,7573566,7573558,'hru',14.286,1),(1109,7573567,7573560,'ope',11.111,2),(1109,7573568,7573560,'per',11.111,2),(1109,7573569,7573560,'era',11.111,2),(1109,7573570,7573560,'rat',11.111,2),(1109,7573571,7573560,'ati',11.111,2),(1109,7573572,7573560,'tio',11.111,2),(1109,7573573,7573560,'ion',11.111,2),(1109,7573574,7573560,'ona',11.111,2),(1109,7573575,7573560,'nal',11.111,2),(1109,7573576,7573567,'mes',20,1),(1109,7573577,7573567,'ess',20,1),(1109,7573578,7573567,'ssa',20,1),(1109,7573579,7573567,'sag',20,1),(1109,7573580,7573567,'age',20,1),(1109,7573581,7573576,'per',11.111,1),(1109,7573582,7573576,'erf',11.111,1),(1109,7573583,7573576,'rfo',11.111,1),(1109,7573584,7573576,'for',11.111,1),(1109,7573585,7573576,'orm',11.111,1),(1109,7573586,7573576,'rma',11.111,1),(1109,7573587,7573576,'man',11.111,1),(1109,7573588,7573576,'anc',11.111,1),(1109,7573589,7573576,'nce',11.111,1),(1109,7573590,7573581,'ide',12.5,1),(1109,7573591,7573581,'den',12.5,1),(1109,7573592,7573581,'ent',12.5,1),(1109,7573593,7573581,'nti',12.5,1),(1109,7573594,7573581,'tif',12.5,1),(1109,7573595,7573581,'ifi',12.5,1),(1109,7573596,7573581,'fie',12.5,1),(1109,7573597,7573581,'ier',12.5,1),(1109,7573598,7573590,'vdi',33.333,3),(1109,7573599,7573590,'dis',33.333,3),(1109,7573600,7573590,'isk',33.333,3),(1109,7573601,7573598,'nam',50,1),(1109,7573602,7573598,'ame',50,1),(1109,7573603,7573601,'typ',50,1),(1109,7573604,7573601,'ype',50,1),(1109,7573605,7573603,'dir',25,1),(1109,7573606,7573603,'ire',25,1),(1109,7573607,7573603,'rec',25,1),(1109,7573608,7573603,'ect',25,1),(1110,7573610,7573609,'naa',100,2),(1110,7573611,7573610,'600',3.333,3),(1110,7573612,7573610,'000',3.333,3),(1110,7573613,7573610,'00c',3.333,3),(1110,7573614,7573610,'0c2',3.333,3),(1110,7573615,7573610,'c29',3.333,3),(1110,7573616,7573610,'292',3.333,3),(1110,7573617,7573610,'92f',3.333,3),(1110,7573618,7573610,'2f4',3.333,3),(1110,7573619,7573610,'f43',3.333,3),(1110,7573620,7573610,'437',3.333,3),(1110,7573621,7573610,'370',3.333,3),(1110,7573622,7573610,'708',3.333,3),(1110,7573623,7573610,'087',3.333,3),(1110,7573624,7573610,'87f',3.333,3),(1110,7573625,7573610,'7f0',3.333,3),(1110,7573626,7573610,'f03',3.333,3),(1110,7573627,7573610,'03e',3.333,3),(1110,7573628,7573610,'3e0',3.333,3),(1110,7573629,7573610,'e0a',3.333,3),(1110,7573630,7573610,'0ac',3.333,3),(1110,7573631,7573610,'ace',3.333,3),(1110,7573632,7573610,'ce6',3.333,3),(1110,7573633,7573610,'e68',3.333,3),(1110,7573634,7573610,'680',3.333,3),(1110,7573635,7573610,'80e',3.333,3),(1110,7573636,7573610,'0e2',3.333,3),(1110,7573637,7573610,'e2d',3.333,3),(1110,7573638,7573610,'2dc',3.333,3),(1110,7573639,7573610,'dcd',3.333,3),(1110,7573640,7573610,'cd8',3.333,3),(1110,7573641,7573611,'mon',100,1),(1110,7573642,7573641,'201',50,1),(1110,7573643,7573641,'013',50,1),(1110,7573644,7573642,'adm',33.333,4),(1110,7573645,7573642,'dmi',33.333,4),(1110,7573646,7573642,'min',33.333,4),(1110,7573647,7573644,'cap',16.667,1),(1110,7573648,7573644,'apa',16.667,1),(1110,7573649,7573644,'pac',16.667,1),(1110,7573650,7573644,'aci',16.667,1),(1110,7573651,7573644,'cit',16.667,1),(1110,7573652,7573644,'ity',16.667,1),(1110,7573653,7573647,'pat',50,1),(1110,7573654,7573647,'ath',50,1),(1110,7573655,7573653,'fre',14.286,1),(1110,7573656,7573653,'ree',14.286,1),(1110,7573657,7573653,'ees',14.286,1),(1110,7573658,7573653,'esp',14.286,1),(1110,7573659,7573653,'spa',14.286,1),(1110,7573660,7573653,'pac',14.286,1),(1110,7573661,7573653,'ace',14.286,1),(1110,7573662,7573655,'dis',50,1),(1110,7573663,7573655,'isk',50,1),(1110,7573664,7573662,'ind',33.333,1),(1110,7573665,7573662,'nde',33.333,1),(1110,7573666,7573662,'dex',33.333,1),(1110,7573667,7573664,'adm',8.333,1),(1110,7573668,7573664,'dmi',8.333,1),(1110,7573669,7573664,'min',8.333,1),(1110,7573670,7573664,'ini',8.333,1),(1110,7573671,7573664,'nis',8.333,1),(1110,7573672,7573664,'ist',8.333,1),(1110,7573673,7573664,'str',8.333,1),(1110,7573674,7573664,'tra',8.333,1),(1110,7573675,7573664,'rat',8.333,1),(1110,7573676,7573664,'ati',8.333,1),(1110,7573677,7573664,'tio',8.333,1),(1110,7573678,7573664,'ion',8.333,1),(1110,7573679,7573667,'sta',33.333,3),(1110,7573680,7573667,'tat',33.333,3),(1110,7573681,7573667,'ate',33.333,3),(1110,7573682,7573679,'dis',16.667,4),(1110,7573683,7573679,'isa',16.667,4),(1110,7573684,7573679,'sab',16.667,4),(1110,7573685,7573679,'abl',16.667,4),(1110,7573686,7573679,'ble',16.667,4),(1110,7573687,7573679,'led',16.667,4),(1110,7573688,7573682,'cac',33.333,1),(1110,7573689,7573682,'ach',33.333,1),(1110,7573690,7573682,'che',33.333,1),(1110,7573691,7573688,'mod',50,1),(1110,7573692,7573688,'ode',50,1),(1110,7573693,7573691,'wri',14.286,1),(1110,7573694,7573691,'rit',14.286,1),(1110,7573695,7573691,'ite',14.286,1),(1110,7573696,7573691,'tet',14.286,1),(1110,7573697,7573691,'eth',14.286,1),(1110,7573698,7573691,'thr',14.286,1),(1110,7573699,7573691,'hru',14.286,1),(1110,7573700,7573693,'ope',11.111,2),(1110,7573701,7573693,'per',11.111,2),(1110,7573702,7573693,'era',11.111,2),(1110,7573703,7573693,'rat',11.111,2),(1110,7573704,7573693,'ati',11.111,2),(1110,7573705,7573693,'tio',11.111,2),(1110,7573706,7573693,'ion',11.111,2),(1110,7573707,7573693,'ona',11.111,2),(1110,7573708,7573693,'nal',11.111,2),(1110,7573709,7573700,'mes',20,1),(1110,7573710,7573700,'ess',20,1),(1110,7573711,7573700,'ssa',20,1),(1110,7573712,7573700,'sag',20,1),(1110,7573713,7573700,'age',20,1),(1110,7573714,7573709,'per',11.111,1),(1110,7573715,7573709,'erf',11.111,1),(1110,7573716,7573709,'rfo',11.111,1),(1110,7573717,7573709,'for',11.111,1),(1110,7573718,7573709,'orm',11.111,1),(1110,7573719,7573709,'rma',11.111,1),(1110,7573720,7573709,'man',11.111,1),(1110,7573721,7573709,'anc',11.111,1),(1110,7573722,7573709,'nce',11.111,1),(1110,7573723,7573714,'ide',12.5,1),(1110,7573724,7573714,'den',12.5,1),(1110,7573725,7573714,'ent',12.5,1),(1110,7573726,7573714,'nti',12.5,1),(1110,7573727,7573714,'tif',12.5,1),(1110,7573728,7573714,'ifi',12.5,1),(1110,7573729,7573714,'fie',12.5,1),(1110,7573730,7573714,'ier',12.5,1),(1110,7573731,7573723,'vdi',33.333,3),(1110,7573732,7573723,'dis',33.333,3),(1110,7573733,7573723,'isk',33.333,3),(1110,7573734,7573731,'nam',50,1),(1110,7573735,7573731,'ame',50,1),(1110,7573736,7573734,'typ',50,1),(1110,7573737,7573734,'ype',50,1),(1110,7573738,7573736,'dir',25,1),(1110,7573739,7573736,'ire',25,1),(1110,7573740,7573736,'rec',25,1),(1110,7573741,7573736,'ect',25,1),(1111,7573743,7573742,'naa',100,2),(1111,7573744,7573743,'600',3.333,3),(1111,7573745,7573743,'000',3.333,3),(1111,7573746,7573743,'00c',3.333,3),(1111,7573747,7573743,'0c2',3.333,3),(1111,7573748,7573743,'c29',3.333,3),(1111,7573749,7573743,'29d',3.333,3),(1111,7573750,7573743,'9de',3.333,3),(1111,7573751,7573743,'de6',3.333,3),(1111,7573752,7573743,'e60',3.333,3),(1111,7573753,7573743,'601',3.333,3),(1111,7573754,7573743,'013',3.333,3),(1111,7573755,7573743,'139',3.333,3),(1111,7573756,7573743,'396',3.333,3),(1111,7573757,7573743,'96b',3.333,3),(1111,7573758,7573743,'6b5',3.333,3),(1111,7573759,7573743,'b50',3.333,3),(1111,7573760,7573743,'50b',3.333,3),(1111,7573761,7573743,'0b8',3.333,3),(1111,7573762,7573743,'b8b',3.333,3),(1111,7573763,7573743,'8be',3.333,3),(1111,7573764,7573743,'be4',3.333,3),(1111,7573765,7573743,'e4d',3.333,3),(1111,7573766,7573743,'4d9',3.333,3),(1111,7573767,7573743,'d9a',3.333,3),(1111,7573768,7573743,'9ad',3.333,3),(1111,7573769,7573743,'ad0',3.333,3),(1111,7573770,7573743,'d0d',3.333,3),(1111,7573771,7573743,'0d3',3.333,3),(1111,7573772,7573743,'d34',3.333,3),(1111,7573773,7573743,'34e',3.333,3),(1111,7573774,7573744,'mon',100,1),(1111,7573775,7573774,'201',50,1),(1111,7573776,7573774,'013',50,1),(1111,7573777,7573775,'adm',33.333,4),(1111,7573778,7573775,'dmi',33.333,4),(1111,7573779,7573775,'min',33.333,4),(1111,7573780,7573777,'cap',16.667,1),(1111,7573781,7573777,'apa',16.667,1),(1111,7573782,7573777,'pac',16.667,1),(1111,7573783,7573777,'aci',16.667,1),(1111,7573784,7573777,'cit',16.667,1),(1111,7573785,7573777,'ity',16.667,1),(1111,7573786,7573780,'pat',50,1),(1111,7573787,7573780,'ath',50,1),(1111,7573788,7573786,'fre',14.286,1),(1111,7573789,7573786,'ree',14.286,1),(1111,7573790,7573786,'ees',14.286,1),(1111,7573791,7573786,'esp',14.286,1),(1111,7573792,7573786,'spa',14.286,1),(1111,7573793,7573786,'pac',14.286,1),(1111,7573794,7573786,'ace',14.286,1),(1111,7573795,7573788,'dis',50,1),(1111,7573796,7573788,'isk',50,1),(1111,7573797,7573795,'ind',33.333,1),(1111,7573798,7573795,'nde',33.333,1),(1111,7573799,7573795,'dex',33.333,1),(1111,7573800,7573797,'adm',8.333,1),(1111,7573801,7573797,'dmi',8.333,1),(1111,7573802,7573797,'min',8.333,1),(1111,7573803,7573797,'ini',8.333,1),(1111,7573804,7573797,'nis',8.333,1),(1111,7573805,7573797,'ist',8.333,1),(1111,7573806,7573797,'str',8.333,1),(1111,7573807,7573797,'tra',8.333,1),(1111,7573808,7573797,'rat',8.333,1),(1111,7573809,7573797,'ati',8.333,1),(1111,7573810,7573797,'tio',8.333,1),(1111,7573811,7573797,'ion',8.333,1),(1111,7573812,7573800,'sta',33.333,3),(1111,7573813,7573800,'tat',33.333,3),(1111,7573814,7573800,'ate',33.333,3),(1111,7573815,7573812,'dis',16.667,4),(1111,7573816,7573812,'isa',16.667,4),(1111,7573817,7573812,'sab',16.667,4),(1111,7573818,7573812,'abl',16.667,4),(1111,7573819,7573812,'ble',16.667,4),(1111,7573820,7573812,'led',16.667,4),(1111,7573821,7573815,'cac',33.333,1),(1111,7573822,7573815,'ach',33.333,1),(1111,7573823,7573815,'che',33.333,1),(1111,7573824,7573821,'mod',50,1),(1111,7573825,7573821,'ode',50,1),(1111,7573826,7573824,'wri',14.286,1),(1111,7573827,7573824,'rit',14.286,1),(1111,7573828,7573824,'ite',14.286,1),(1111,7573829,7573824,'tet',14.286,1),(1111,7573830,7573824,'eth',14.286,1),(1111,7573831,7573824,'thr',14.286,1),(1111,7573832,7573824,'hru',14.286,1),(1111,7573833,7573826,'ope',11.111,2),(1111,7573834,7573826,'per',11.111,2),(1111,7573835,7573826,'era',11.111,2),(1111,7573836,7573826,'rat',11.111,2),(1111,7573837,7573826,'ati',11.111,2),(1111,7573838,7573826,'tio',11.111,2),(1111,7573839,7573826,'ion',11.111,2),(1111,7573840,7573826,'ona',11.111,2),(1111,7573841,7573826,'nal',11.111,2),(1111,7573842,7573833,'mes',20,1),(1111,7573843,7573833,'ess',20,1),(1111,7573844,7573833,'ssa',20,1),(1111,7573845,7573833,'sag',20,1),(1111,7573846,7573833,'age',20,1),(1111,7573847,7573842,'per',11.111,1),(1111,7573848,7573842,'erf',11.111,1),(1111,7573849,7573842,'rfo',11.111,1),(1111,7573850,7573842,'for',11.111,1),(1111,7573851,7573842,'orm',11.111,1),(1111,7573852,7573842,'rma',11.111,1),(1111,7573853,7573842,'man',11.111,1),(1111,7573854,7573842,'anc',11.111,1),(1111,7573855,7573842,'nce',11.111,1),(1111,7573856,7573847,'ide',12.5,1),(1111,7573857,7573847,'den',12.5,1),(1111,7573858,7573847,'ent',12.5,1),(1111,7573859,7573847,'nti',12.5,1),(1111,7573860,7573847,'tif',12.5,1),(1111,7573861,7573847,'ifi',12.5,1),(1111,7573862,7573847,'fie',12.5,1),(1111,7573863,7573847,'ier',12.5,1),(1111,7573864,7573856,'vdi',33.333,3),(1111,7573865,7573856,'dis',33.333,3),(1111,7573866,7573856,'isk',33.333,3),(1111,7573867,7573864,'nam',50,1),(1111,7573868,7573864,'ame',50,1),(1111,7573869,7573867,'typ',50,1),(1111,7573870,7573867,'ype',50,1),(1111,7573871,7573869,'dir',25,1),(1111,7573872,7573869,'ire',25,1),(1111,7573873,7573869,'rec',25,1),(1111,7573874,7573869,'ect',25,1),(1112,7573876,7573875,'naa',100,2),(1112,7573877,7573876,'600',3.333,3),(1112,7573878,7573876,'000',3.333,3),(1112,7573879,7573876,'00c',3.333,3),(1112,7573880,7573876,'0c2',3.333,3),(1112,7573881,7573876,'c29',3.333,3),(1112,7573882,7573876,'291',3.333,3),(1112,7573883,7573876,'91e',3.333,3),(1112,7573884,7573876,'1ed',3.333,3),(1112,7573885,7573876,'ed1',3.333,3),(1112,7573886,7573876,'d18',3.333,3),(1112,7573887,7573876,'180',3.333,3),(1112,7573888,7573876,'806',3.333,3),(1112,7573889,7573876,'067',3.333,3),(1112,7573890,7573876,'674',3.333,3),(1112,7573891,7573876,'746',3.333,3),(1112,7573892,7573876,'466',3.333,3),(1112,7573893,7573876,'663',3.333,3),(1112,7573894,7573876,'635',3.333,3),(1112,7573895,7573876,'35f',3.333,3),(1112,7573896,7573876,'5f9',3.333,3),(1112,7573897,7573876,'f96',3.333,3),(1112,7573898,7573876,'964',3.333,3),(1112,7573899,7573876,'64d',3.333,3),(1112,7573900,7573876,'4d2',3.333,3),(1112,7573901,7573876,'d28',3.333,3),(1112,7573902,7573876,'28f',3.333,3),(1112,7573903,7573876,'8fd',3.333,3),(1112,7573904,7573876,'fd6',3.333,3),(1112,7573905,7573876,'d68',3.333,3),(1112,7573906,7573876,'68f',3.333,3),(1112,7573907,7573877,'mon',100,1),(1112,7573908,7573907,'201',50,1),(1112,7573909,7573907,'013',50,1),(1112,7573910,7573908,'adm',33.333,4),(1112,7573911,7573908,'dmi',33.333,4),(1112,7573912,7573908,'min',33.333,4),(1112,7573913,7573910,'cap',16.667,1),(1112,7573914,7573910,'apa',16.667,1),(1112,7573915,7573910,'pac',16.667,1),(1112,7573916,7573910,'aci',16.667,1),(1112,7573917,7573910,'cit',16.667,1),(1112,7573918,7573910,'ity',16.667,1),(1112,7573919,7573913,'pat',50,1),(1112,7573920,7573913,'ath',50,1),(1112,7573921,7573919,'fre',14.286,1),(1112,7573922,7573919,'ree',14.286,1),(1112,7573923,7573919,'ees',14.286,1),(1112,7573924,7573919,'esp',14.286,1),(1112,7573925,7573919,'spa',14.286,1),(1112,7573926,7573919,'pac',14.286,1),(1112,7573927,7573919,'ace',14.286,1),(1112,7573928,7573921,'dis',50,1),(1112,7573929,7573921,'isk',50,1),(1112,7573930,7573928,'ind',33.333,1),(1112,7573931,7573928,'nde',33.333,1),(1112,7573932,7573928,'dex',33.333,1),(1112,7573933,7573930,'adm',8.333,1),(1112,7573934,7573930,'dmi',8.333,1),(1112,7573935,7573930,'min',8.333,1),(1112,7573936,7573930,'ini',8.333,1),(1112,7573937,7573930,'nis',8.333,1),(1112,7573938,7573930,'ist',8.333,1),(1112,7573939,7573930,'str',8.333,1),(1112,7573940,7573930,'tra',8.333,1),(1112,7573941,7573930,'rat',8.333,1),(1112,7573942,7573930,'ati',8.333,1),(1112,7573943,7573930,'tio',8.333,1),(1112,7573944,7573930,'ion',8.333,1),(1112,7573945,7573933,'sta',33.333,3),(1112,7573946,7573933,'tat',33.333,3),(1112,7573947,7573933,'ate',33.333,3),(1112,7573948,7573945,'dis',16.667,4),(1112,7573949,7573945,'isa',16.667,4),(1112,7573950,7573945,'sab',16.667,4),(1112,7573951,7573945,'abl',16.667,4),(1112,7573952,7573945,'ble',16.667,4),(1112,7573953,7573945,'led',16.667,4),(1112,7573954,7573948,'cac',33.333,1),(1112,7573955,7573948,'ach',33.333,1),(1112,7573956,7573948,'che',33.333,1),(1112,7573957,7573954,'mod',50,1),(1112,7573958,7573954,'ode',50,1),(1112,7573959,7573957,'wri',14.286,1),(1112,7573960,7573957,'rit',14.286,1),(1112,7573961,7573957,'ite',14.286,1),(1112,7573962,7573957,'tet',14.286,1),(1112,7573963,7573957,'eth',14.286,1),(1112,7573964,7573957,'thr',14.286,1),(1112,7573965,7573957,'hru',14.286,1),(1112,7573966,7573959,'ope',11.111,2),(1112,7573967,7573959,'per',11.111,2),(1112,7573968,7573959,'era',11.111,2),(1112,7573969,7573959,'rat',11.111,2),(1112,7573970,7573959,'ati',11.111,2),(1112,7573971,7573959,'tio',11.111,2),(1112,7573972,7573959,'ion',11.111,2),(1112,7573973,7573959,'ona',11.111,2),(1112,7573974,7573959,'nal',11.111,2),(1112,7573975,7573966,'mes',20,1),(1112,7573976,7573966,'ess',20,1),(1112,7573977,7573966,'ssa',20,1),(1112,7573978,7573966,'sag',20,1),(1112,7573979,7573966,'age',20,1),(1112,7573980,7573975,'per',11.111,1),(1112,7573981,7573975,'erf',11.111,1),(1112,7573982,7573975,'rfo',11.111,1),(1112,7573983,7573975,'for',11.111,1),(1112,7573984,7573975,'orm',11.111,1),(1112,7573985,7573975,'rma',11.111,1),(1112,7573986,7573975,'man',11.111,1),(1112,7573987,7573975,'anc',11.111,1),(1112,7573988,7573975,'nce',11.111,1),(1112,7573989,7573980,'ide',12.5,1),(1112,7573990,7573980,'den',12.5,1),(1112,7573991,7573980,'ent',12.5,1),(1112,7573992,7573980,'nti',12.5,1),(1112,7573993,7573980,'tif',12.5,1),(1112,7573994,7573980,'ifi',12.5,1),(1112,7573995,7573980,'fie',12.5,1),(1112,7573996,7573980,'ier',12.5,1),(1112,7573997,7573989,'vdi',33.333,3),(1112,7573998,7573989,'dis',33.333,3),(1112,7573999,7573989,'isk',33.333,3),(1112,7574000,7573997,'nam',50,1),(1112,7574001,7573997,'ame',50,1),(1112,7574002,7574000,'typ',50,1),(1112,7574003,7574000,'ype',50,1),(1112,7574004,7574002,'dir',25,1),(1112,7574005,7574002,'ire',25,1),(1112,7574006,7574002,'rec',25,1),(1112,7574007,7574002,'ect',25,1),(1113,7574009,7574008,'naa',100,2),(1113,7574010,7574009,'600',3.333,3),(1113,7574011,7574009,'000',3.333,3),(1113,7574012,7574009,'00c',3.333,3),(1113,7574013,7574009,'0c2',3.333,3),(1113,7574014,7574009,'c29',3.333,3),(1113,7574015,7574009,'291',3.333,3),(1113,7574016,7574009,'91c',3.333,3),(1113,7574017,7574009,'1cb',3.333,3),(1113,7574018,7574009,'cbb',3.333,3),(1113,7574019,7574009,'bb2',3.333,3),(1113,7574020,7574009,'b23',3.333,3),(1113,7574021,7574009,'234',3.333,3),(1113,7574022,7574009,'34a',3.333,3),(1113,7574023,7574009,'4a6',3.333,3),(1113,7574024,7574009,'a6a',3.333,3),(1113,7574025,7574009,'6a8',3.333,3),(1113,7574026,7574009,'a8f',3.333,3),(1113,7574027,7574009,'8fb',3.333,3),(1113,7574028,7574009,'fbe',3.333,3),(1113,7574029,7574009,'beb',3.333,3),(1113,7574030,7574009,'eb3',3.333,3),(1113,7574031,7574009,'b3d',3.333,3),(1113,7574032,7574009,'3d4',3.333,3),(1113,7574033,7574009,'d4b',3.333,3),(1113,7574034,7574009,'4b3',3.333,3),(1113,7574035,7574009,'b34',3.333,3),(1113,7574036,7574009,'342',3.333,3),(1113,7574037,7574009,'420',3.333,3),(1113,7574038,7574009,'20b',3.333,3),(1113,7574039,7574009,'0b1',3.333,3),(1113,7574040,7574010,'mon',100,1),(1113,7574041,7574040,'201',50,1),(1113,7574042,7574040,'013',50,1),(1113,7574043,7574041,'adm',33.333,4),(1113,7574044,7574041,'dmi',33.333,4),(1113,7574045,7574041,'min',33.333,4),(1113,7574046,7574043,'cap',16.667,1),(1113,7574047,7574043,'apa',16.667,1),(1113,7574048,7574043,'pac',16.667,1),(1113,7574049,7574043,'aci',16.667,1),(1113,7574050,7574043,'cit',16.667,1),(1113,7574051,7574043,'ity',16.667,1),(1113,7574052,7574046,'pat',50,1),(1113,7574053,7574046,'ath',50,1),(1113,7574054,7574052,'fre',14.286,1),(1113,7574055,7574052,'ree',14.286,1),(1113,7574056,7574052,'ees',14.286,1),(1113,7574057,7574052,'esp',14.286,1),(1113,7574058,7574052,'spa',14.286,1),(1113,7574059,7574052,'pac',14.286,1),(1113,7574060,7574052,'ace',14.286,1),(1113,7574061,7574054,'dis',50,1),(1113,7574062,7574054,'isk',50,1),(1113,7574063,7574061,'ind',33.333,1),(1113,7574064,7574061,'nde',33.333,1),(1113,7574065,7574061,'dex',33.333,1),(1113,7574066,7574063,'adm',8.333,1),(1113,7574067,7574063,'dmi',8.333,1),(1113,7574068,7574063,'min',8.333,1),(1113,7574069,7574063,'ini',8.333,1),(1113,7574070,7574063,'nis',8.333,1),(1113,7574071,7574063,'ist',8.333,1),(1113,7574072,7574063,'str',8.333,1),(1113,7574073,7574063,'tra',8.333,1),(1113,7574074,7574063,'rat',8.333,1),(1113,7574075,7574063,'ati',8.333,1),(1113,7574076,7574063,'tio',8.333,1),(1113,7574077,7574063,'ion',8.333,1),(1113,7574078,7574066,'sta',33.333,3),(1113,7574079,7574066,'tat',33.333,3),(1113,7574080,7574066,'ate',33.333,3),(1113,7574081,7574078,'dis',16.667,4),(1113,7574082,7574078,'isa',16.667,4),(1113,7574083,7574078,'sab',16.667,4),(1113,7574084,7574078,'abl',16.667,4),(1113,7574085,7574078,'ble',16.667,4),(1113,7574086,7574078,'led',16.667,4),(1113,7574087,7574081,'cac',33.333,1),(1113,7574088,7574081,'ach',33.333,1),(1113,7574089,7574081,'che',33.333,1),(1113,7574090,7574087,'mod',50,1),(1113,7574091,7574087,'ode',50,1),(1113,7574092,7574090,'wri',14.286,1),(1113,7574093,7574090,'rit',14.286,1),(1113,7574094,7574090,'ite',14.286,1),(1113,7574095,7574090,'tet',14.286,1),(1113,7574096,7574090,'eth',14.286,1),(1113,7574097,7574090,'thr',14.286,1),(1113,7574098,7574090,'hru',14.286,1),(1113,7574099,7574092,'ope',11.111,2),(1113,7574100,7574092,'per',11.111,2),(1113,7574101,7574092,'era',11.111,2),(1113,7574102,7574092,'rat',11.111,2),(1113,7574103,7574092,'ati',11.111,2),(1113,7574104,7574092,'tio',11.111,2),(1113,7574105,7574092,'ion',11.111,2),(1113,7574106,7574092,'ona',11.111,2),(1113,7574107,7574092,'nal',11.111,2),(1113,7574108,7574099,'mes',20,1),(1113,7574109,7574099,'ess',20,1),(1113,7574110,7574099,'ssa',20,1),(1113,7574111,7574099,'sag',20,1),(1113,7574112,7574099,'age',20,1),(1113,7574113,7574108,'per',11.111,1),(1113,7574114,7574108,'erf',11.111,1),(1113,7574115,7574108,'rfo',11.111,1),(1113,7574116,7574108,'for',11.111,1),(1113,7574117,7574108,'orm',11.111,1),(1113,7574118,7574108,'rma',11.111,1),(1113,7574119,7574108,'man',11.111,1),(1113,7574120,7574108,'anc',11.111,1),(1113,7574121,7574108,'nce',11.111,1),(1113,7574122,7574113,'ide',12.5,1),(1113,7574123,7574113,'den',12.5,1),(1113,7574124,7574113,'ent',12.5,1),(1113,7574125,7574113,'nti',12.5,1),(1113,7574126,7574113,'tif',12.5,1),(1113,7574127,7574113,'ifi',12.5,1),(1113,7574128,7574113,'fie',12.5,1),(1113,7574129,7574113,'ier',12.5,1),(1113,7574130,7574122,'vdi',33.333,3),(1113,7574131,7574122,'dis',33.333,3),(1113,7574132,7574122,'isk',33.333,3),(1113,7574133,7574130,'nam',50,1),(1113,7574134,7574130,'ame',50,1),(1113,7574135,7574133,'typ',50,1),(1113,7574136,7574133,'ype',50,1),(1113,7574137,7574135,'dir',25,1),(1113,7574138,7574135,'ire',25,1),(1113,7574139,7574135,'rec',25,1),(1113,7574140,7574135,'ect',25,1),(1114,7574142,7574141,'naa',100,2),(1114,7574143,7574142,'600',3.333,3),(1114,7574144,7574142,'000',3.333,3),(1114,7574145,7574142,'00c',3.333,3),(1114,7574146,7574142,'0c2',3.333,3),(1114,7574147,7574142,'c29',3.333,3),(1114,7574148,7574142,'290',3.333,3),(1114,7574149,7574142,'908',3.333,3),(1114,7574150,7574142,'088',3.333,3),(1114,7574151,7574142,'880',3.333,3),(1114,7574152,7574142,'80f',3.333,3),(1114,7574153,7574142,'0f0',3.333,3),(1114,7574154,7574142,'f02',3.333,3),(1114,7574155,7574142,'029',3.333,3),(1114,7574156,7574142,'291',3.333,3),(1114,7574157,7574142,'911',3.333,3),(1114,7574158,7574142,'115',3.333,3),(1114,7574159,7574142,'150',3.333,3),(1114,7574160,7574142,'500',3.333,3),(1114,7574161,7574142,'003',3.333,3),(1114,7574162,7574142,'03a',3.333,3),(1114,7574163,7574142,'3aa',3.333,3),(1114,7574164,7574142,'aa8',3.333,3),(1114,7574165,7574142,'a8e',3.333,3),(1114,7574166,7574142,'8ea',3.333,3),(1114,7574167,7574142,'ea6',3.333,3),(1114,7574168,7574142,'a62',3.333,3),(1114,7574169,7574142,'626',3.333,3),(1114,7574170,7574142,'262',3.333,3),(1114,7574171,7574142,'625',3.333,3),(1114,7574172,7574142,'258',3.333,3),(1114,7574173,7574143,'mon',100,1),(1114,7574174,7574173,'201',50,1),(1114,7574175,7574173,'013',50,1),(1114,7574176,7574174,'adm',33.333,4),(1114,7574177,7574174,'dmi',33.333,4),(1114,7574178,7574174,'min',33.333,4),(1114,7574179,7574176,'cap',16.667,1),(1114,7574180,7574176,'apa',16.667,1),(1114,7574181,7574176,'pac',16.667,1),(1114,7574182,7574176,'aci',16.667,1),(1114,7574183,7574176,'cit',16.667,1),(1114,7574184,7574176,'ity',16.667,1),(1114,7574185,7574179,'pat',50,1),(1114,7574186,7574179,'ath',50,1),(1114,7574187,7574185,'fre',14.286,1),(1114,7574188,7574185,'ree',14.286,1),(1114,7574189,7574185,'ees',14.286,1),(1114,7574190,7574185,'esp',14.286,1),(1114,7574191,7574185,'spa',14.286,1),(1114,7574192,7574185,'pac',14.286,1),(1114,7574193,7574185,'ace',14.286,1),(1114,7574194,7574187,'dis',50,1),(1114,7574195,7574187,'isk',50,1),(1114,7574196,7574194,'ind',33.333,1),(1114,7574197,7574194,'nde',33.333,1),(1114,7574198,7574194,'dex',33.333,1),(1114,7574199,7574196,'adm',8.333,1),(1114,7574200,7574196,'dmi',8.333,1),(1114,7574201,7574196,'min',8.333,1),(1114,7574202,7574196,'ini',8.333,1),(1114,7574203,7574196,'nis',8.333,1),(1114,7574204,7574196,'ist',8.333,1),(1114,7574205,7574196,'str',8.333,1),(1114,7574206,7574196,'tra',8.333,1),(1114,7574207,7574196,'rat',8.333,1),(1114,7574208,7574196,'ati',8.333,1),(1114,7574209,7574196,'tio',8.333,1),(1114,7574210,7574196,'ion',8.333,1),(1114,7574211,7574199,'sta',33.333,3),(1114,7574212,7574199,'tat',33.333,3),(1114,7574213,7574199,'ate',33.333,3),(1114,7574214,7574211,'dis',16.667,4),(1114,7574215,7574211,'isa',16.667,4),(1114,7574216,7574211,'sab',16.667,4),(1114,7574217,7574211,'abl',16.667,4),(1114,7574218,7574211,'ble',16.667,4),(1114,7574219,7574211,'led',16.667,4),(1114,7574220,7574214,'cac',33.333,1),(1114,7574221,7574214,'ach',33.333,1),(1114,7574222,7574214,'che',33.333,1),(1114,7574223,7574220,'mod',50,1),(1114,7574224,7574220,'ode',50,1),(1114,7574225,7574223,'wri',14.286,1),(1114,7574226,7574223,'rit',14.286,1),(1114,7574227,7574223,'ite',14.286,1),(1114,7574228,7574223,'tet',14.286,1),(1114,7574229,7574223,'eth',14.286,1),(1114,7574230,7574223,'thr',14.286,1),(1114,7574231,7574223,'hru',14.286,1),(1114,7574232,7574225,'ope',11.111,2),(1114,7574233,7574225,'per',11.111,2),(1114,7574234,7574225,'era',11.111,2),(1114,7574235,7574225,'rat',11.111,2),(1114,7574236,7574225,'ati',11.111,2),(1114,7574237,7574225,'tio',11.111,2),(1114,7574238,7574225,'ion',11.111,2),(1114,7574239,7574225,'ona',11.111,2),(1114,7574240,7574225,'nal',11.111,2),(1114,7574241,7574232,'mes',20,1),(1114,7574242,7574232,'ess',20,1),(1114,7574243,7574232,'ssa',20,1),(1114,7574244,7574232,'sag',20,1),(1114,7574245,7574232,'age',20,1),(1114,7574246,7574241,'per',11.111,1),(1114,7574247,7574241,'erf',11.111,1),(1114,7574248,7574241,'rfo',11.111,1),(1114,7574249,7574241,'for',11.111,1),(1114,7574250,7574241,'orm',11.111,1),(1114,7574251,7574241,'rma',11.111,1),(1114,7574252,7574241,'man',11.111,1),(1114,7574253,7574241,'anc',11.111,1),(1114,7574254,7574241,'nce',11.111,1),(1114,7574255,7574246,'ide',12.5,1),(1114,7574256,7574246,'den',12.5,1),(1114,7574257,7574246,'ent',12.5,1),(1114,7574258,7574246,'nti',12.5,1),(1114,7574259,7574246,'tif',12.5,1),(1114,7574260,7574246,'ifi',12.5,1),(1114,7574261,7574246,'fie',12.5,1),(1114,7574262,7574246,'ier',12.5,1),(1114,7574263,7574255,'vdi',33.333,3),(1114,7574264,7574255,'dis',33.333,3),(1114,7574265,7574255,'isk',33.333,3),(1114,7574266,7574263,'nam',50,1),(1114,7574267,7574263,'ame',50,1),(1114,7574268,7574266,'typ',50,1),(1114,7574269,7574266,'ype',50,1),(1114,7574270,7574268,'dir',25,1),(1114,7574271,7574268,'ire',25,1),(1114,7574272,7574268,'rec',25,1),(1114,7574273,7574268,'ect',25,1),(1115,7574275,7574274,'naa',100,2),(1115,7574276,7574275,'600',3.333,3),(1115,7574277,7574275,'000',3.333,3),(1115,7574278,7574275,'00c',3.333,3),(1115,7574279,7574275,'0c2',3.333,3),(1115,7574280,7574275,'c29',3.333,3),(1115,7574281,7574275,'29a',3.333,3),(1115,7574282,7574275,'9a9',3.333,3),(1115,7574283,7574275,'a97',3.333,3),(1115,7574284,7574275,'973',3.333,3),(1115,7574285,7574275,'73a',3.333,3),(1115,7574286,7574275,'3a9',3.333,3),(1115,7574287,7574275,'a90',3.333,3),(1115,7574288,7574275,'903',3.333,3),(1115,7574289,7574275,'03c',3.333,3),(1115,7574290,7574275,'3c8',3.333,3),(1115,7574291,7574275,'c82',3.333,3),(1115,7574292,7574275,'828',3.333,3),(1115,7574293,7574275,'289',3.333,3),(1115,7574294,7574275,'89b',3.333,3),(1115,7574295,7574275,'9b8',3.333,3),(1115,7574296,7574275,'b8f',3.333,3),(1115,7574297,7574275,'8f0',3.333,3),(1115,7574298,7574275,'f07',3.333,3),(1115,7574299,7574275,'07c',3.333,3),(1115,7574300,7574275,'7c9',3.333,3),(1115,7574301,7574275,'c97',3.333,3),(1115,7574302,7574275,'97a',3.333,3),(1115,7574303,7574275,'7a4',3.333,3),(1115,7574304,7574275,'a44',3.333,3),(1115,7574305,7574275,'447',3.333,3),(1115,7574306,7574276,'mon',100,1),(1115,7574307,7574306,'201',50,1),(1115,7574308,7574306,'013',50,1),(1115,7574309,7574307,'adm',33.333,4),(1115,7574310,7574307,'dmi',33.333,4),(1115,7574311,7574307,'min',33.333,4),(1115,7574312,7574309,'cap',16.667,1),(1115,7574313,7574309,'apa',16.667,1),(1115,7574314,7574309,'pac',16.667,1),(1115,7574315,7574309,'aci',16.667,1),(1115,7574316,7574309,'cit',16.667,1),(1115,7574317,7574309,'ity',16.667,1),(1115,7574318,7574312,'pat',50,1),(1115,7574319,7574312,'ath',50,1),(1115,7574320,7574318,'fre',14.286,1),(1115,7574321,7574318,'ree',14.286,1),(1115,7574322,7574318,'ees',14.286,1),(1115,7574323,7574318,'esp',14.286,1),(1115,7574324,7574318,'spa',14.286,1),(1115,7574325,7574318,'pac',14.286,1),(1115,7574326,7574318,'ace',14.286,1),(1115,7574327,7574320,'dis',50,1),(1115,7574328,7574320,'isk',50,1),(1115,7574329,7574327,'ind',33.333,1),(1115,7574330,7574327,'nde',33.333,1),(1115,7574331,7574327,'dex',33.333,1),(1115,7574332,7574329,'adm',8.333,1),(1115,7574333,7574329,'dmi',8.333,1),(1115,7574334,7574329,'min',8.333,1),(1115,7574335,7574329,'ini',8.333,1),(1115,7574336,7574329,'nis',8.333,1),(1115,7574337,7574329,'ist',8.333,1),(1115,7574338,7574329,'str',8.333,1),(1115,7574339,7574329,'tra',8.333,1),(1115,7574340,7574329,'rat',8.333,1),(1115,7574341,7574329,'ati',8.333,1),(1115,7574342,7574329,'tio',8.333,1),(1115,7574343,7574329,'ion',8.333,1),(1115,7574344,7574332,'sta',33.333,3),(1115,7574345,7574332,'tat',33.333,3),(1115,7574346,7574332,'ate',33.333,3),(1115,7574347,7574344,'dis',16.667,4),(1115,7574348,7574344,'isa',16.667,4),(1115,7574349,7574344,'sab',16.667,4),(1115,7574350,7574344,'abl',16.667,4),(1115,7574351,7574344,'ble',16.667,4),(1115,7574352,7574344,'led',16.667,4),(1115,7574353,7574347,'cac',33.333,1),(1115,7574354,7574347,'ach',33.333,1),(1115,7574355,7574347,'che',33.333,1),(1115,7574356,7574353,'mod',50,1),(1115,7574357,7574353,'ode',50,1),(1115,7574358,7574356,'wri',14.286,1),(1115,7574359,7574356,'rit',14.286,1),(1115,7574360,7574356,'ite',14.286,1),(1115,7574361,7574356,'tet',14.286,1),(1115,7574362,7574356,'eth',14.286,1),(1115,7574363,7574356,'thr',14.286,1),(1115,7574364,7574356,'hru',14.286,1),(1115,7574365,7574358,'ope',11.111,2),(1115,7574366,7574358,'per',11.111,2),(1115,7574367,7574358,'era',11.111,2),(1115,7574368,7574358,'rat',11.111,2),(1115,7574369,7574358,'ati',11.111,2),(1115,7574370,7574358,'tio',11.111,2),(1115,7574371,7574358,'ion',11.111,2),(1115,7574372,7574358,'ona',11.111,2),(1115,7574373,7574358,'nal',11.111,2),(1115,7574374,7574365,'mes',20,1),(1115,7574375,7574365,'ess',20,1),(1115,7574376,7574365,'ssa',20,1),(1115,7574377,7574365,'sag',20,1),(1115,7574378,7574365,'age',20,1),(1115,7574379,7574374,'per',11.111,1),(1115,7574380,7574374,'erf',11.111,1),(1115,7574381,7574374,'rfo',11.111,1),(1115,7574382,7574374,'for',11.111,1),(1115,7574383,7574374,'orm',11.111,1),(1115,7574384,7574374,'rma',11.111,1),(1115,7574385,7574374,'man',11.111,1),(1115,7574386,7574374,'anc',11.111,1),(1115,7574387,7574374,'nce',11.111,1),(1115,7574388,7574379,'ide',12.5,1),(1115,7574389,7574379,'den',12.5,1),(1115,7574390,7574379,'ent',12.5,1),(1115,7574391,7574379,'nti',12.5,1),(1115,7574392,7574379,'tif',12.5,1),(1115,7574393,7574379,'ifi',12.5,1),(1115,7574394,7574379,'fie',12.5,1),(1115,7574395,7574379,'ier',12.5,1),(1115,7574396,7574388,'vdi',33.333,3),(1115,7574397,7574388,'dis',33.333,3),(1115,7574398,7574388,'isk',33.333,3),(1115,7574399,7574396,'nam',50,1),(1115,7574400,7574396,'ame',50,1),(1115,7574401,7574399,'typ',50,1),(1115,7574402,7574399,'ype',50,1),(1115,7574403,7574401,'dir',25,1),(1115,7574404,7574401,'ire',25,1),(1115,7574405,7574401,'rec',25,1),(1115,7574406,7574401,'ect',25,1),(1116,7574408,7574407,'naa',100,2),(1116,7574409,7574408,'600',3.333,3),(1116,7574410,7574408,'000',3.333,3),(1116,7574411,7574408,'00c',3.333,3),(1116,7574412,7574408,'0c2',3.333,3),(1116,7574413,7574408,'c29',3.333,3),(1116,7574414,7574408,'290',3.333,3),(1116,7574415,7574408,'90a',3.333,3),(1116,7574416,7574408,'0ad',3.333,3),(1116,7574417,7574408,'ad2',3.333,3),(1116,7574418,7574408,'d2b',3.333,3),(1116,7574419,7574408,'2ba',3.333,3),(1116,7574420,7574408,'ba5',3.333,3),(1116,7574421,7574408,'a58',3.333,3),(1116,7574422,7574408,'585',3.333,3),(1116,7574423,7574408,'853',3.333,3),(1116,7574424,7574408,'531',3.333,3),(1116,7574425,7574408,'315',3.333,3),(1116,7574426,7574408,'151',3.333,3),(1116,7574427,7574408,'511',3.333,3),(1116,7574428,7574408,'11a',3.333,3),(1116,7574429,7574408,'1aa',3.333,3),(1116,7574430,7574408,'aa3',3.333,3),(1116,7574431,7574408,'a39',3.333,3),(1116,7574432,7574408,'392',3.333,3),(1116,7574433,7574408,'92c',3.333,3),(1116,7574434,7574408,'2c1',3.333,3),(1116,7574435,7574408,'c14',3.333,3),(1116,7574436,7574408,'145',3.333,3),(1116,7574437,7574408,'45a',3.333,3),(1116,7574438,7574408,'5a3',3.333,3),(1116,7574439,7574409,'mon',100,1),(1116,7574440,7574439,'201',50,1),(1116,7574441,7574439,'013',50,1),(1116,7574442,7574440,'adm',33.333,4),(1116,7574443,7574440,'dmi',33.333,4),(1116,7574444,7574440,'min',33.333,4),(1116,7574445,7574442,'cap',16.667,1),(1116,7574446,7574442,'apa',16.667,1),(1116,7574447,7574442,'pac',16.667,1),(1116,7574448,7574442,'aci',16.667,1),(1116,7574449,7574442,'cit',16.667,1),(1116,7574450,7574442,'ity',16.667,1),(1116,7574451,7574445,'pat',50,1),(1116,7574452,7574445,'ath',50,1),(1116,7574453,7574451,'fre',14.286,1),(1116,7574454,7574451,'ree',14.286,1),(1116,7574455,7574451,'ees',14.286,1),(1116,7574456,7574451,'esp',14.286,1),(1116,7574457,7574451,'spa',14.286,1),(1116,7574458,7574451,'pac',14.286,1),(1116,7574459,7574451,'ace',14.286,1),(1116,7574460,7574453,'dis',50,1),(1116,7574461,7574453,'isk',50,1),(1116,7574462,7574460,'ind',33.333,1),(1116,7574463,7574460,'nde',33.333,1),(1116,7574464,7574460,'dex',33.333,1),(1116,7574465,7574462,'adm',8.333,1),(1116,7574466,7574462,'dmi',8.333,1),(1116,7574467,7574462,'min',8.333,1),(1116,7574468,7574462,'ini',8.333,1),(1116,7574469,7574462,'nis',8.333,1),(1116,7574470,7574462,'ist',8.333,1),(1116,7574471,7574462,'str',8.333,1),(1116,7574472,7574462,'tra',8.333,1),(1116,7574473,7574462,'rat',8.333,1),(1116,7574474,7574462,'ati',8.333,1),(1116,7574475,7574462,'tio',8.333,1),(1116,7574476,7574462,'ion',8.333,1),(1116,7574477,7574465,'sta',33.333,3),(1116,7574478,7574465,'tat',33.333,3),(1116,7574479,7574465,'ate',33.333,3),(1116,7574480,7574477,'dis',16.667,4),(1116,7574481,7574477,'isa',16.667,4),(1116,7574482,7574477,'sab',16.667,4),(1116,7574483,7574477,'abl',16.667,4),(1116,7574484,7574477,'ble',16.667,4),(1116,7574485,7574477,'led',16.667,4),(1116,7574486,7574480,'cac',33.333,1),(1116,7574487,7574480,'ach',33.333,1),(1116,7574488,7574480,'che',33.333,1),(1116,7574489,7574486,'mod',50,1),(1116,7574490,7574486,'ode',50,1),(1116,7574491,7574489,'wri',14.286,1),(1116,7574492,7574489,'rit',14.286,1),(1116,7574493,7574489,'ite',14.286,1),(1116,7574494,7574489,'tet',14.286,1),(1116,7574495,7574489,'eth',14.286,1),(1116,7574496,7574489,'thr',14.286,1),(1116,7574497,7574489,'hru',14.286,1),(1116,7574498,7574491,'ope',11.111,2),(1116,7574499,7574491,'per',11.111,2),(1116,7574500,7574491,'era',11.111,2),(1116,7574501,7574491,'rat',11.111,2),(1116,7574502,7574491,'ati',11.111,2),(1116,7574503,7574491,'tio',11.111,2),(1116,7574504,7574491,'ion',11.111,2),(1116,7574505,7574491,'ona',11.111,2),(1116,7574506,7574491,'nal',11.111,2),(1116,7574507,7574498,'mes',20,1),(1116,7574508,7574498,'ess',20,1),(1116,7574509,7574498,'ssa',20,1),(1116,7574510,7574498,'sag',20,1),(1116,7574511,7574498,'age',20,1),(1116,7574512,7574507,'per',11.111,1),(1116,7574513,7574507,'erf',11.111,1),(1116,7574514,7574507,'rfo',11.111,1),(1116,7574515,7574507,'for',11.111,1),(1116,7574516,7574507,'orm',11.111,1),(1116,7574517,7574507,'rma',11.111,1),(1116,7574518,7574507,'man',11.111,1),(1116,7574519,7574507,'anc',11.111,1),(1116,7574520,7574507,'nce',11.111,1),(1116,7574521,7574512,'ide',12.5,1),(1116,7574522,7574512,'den',12.5,1),(1116,7574523,7574512,'ent',12.5,1),(1116,7574524,7574512,'nti',12.5,1),(1116,7574525,7574512,'tif',12.5,1),(1116,7574526,7574512,'ifi',12.5,1),(1116,7574527,7574512,'fie',12.5,1),(1116,7574528,7574512,'ier',12.5,1),(1116,7574529,7574521,'vdi',33.333,3),(1116,7574530,7574521,'dis',33.333,3),(1116,7574531,7574521,'isk',33.333,3),(1116,7574532,7574529,'nam',50,1),(1116,7574533,7574529,'ame',50,1),(1116,7574534,7574532,'typ',50,1),(1116,7574535,7574532,'ype',50,1),(1116,7574536,7574534,'dir',25,1),(1116,7574537,7574534,'ire',25,1),(1116,7574538,7574534,'rec',25,1),(1116,7574539,7574534,'ect',25,1),(1117,7574541,7574540,'naa',100,2),(1117,7574542,7574541,'600',3.333,3),(1117,7574543,7574541,'000',3.333,3),(1117,7574544,7574541,'00c',3.333,3),(1117,7574545,7574541,'0c2',3.333,3),(1117,7574546,7574541,'c29',3.333,3),(1117,7574547,7574541,'296',3.333,3),(1117,7574548,7574541,'962',3.333,3),(1117,7574549,7574541,'626',3.333,3),(1117,7574550,7574541,'264',3.333,3),(1117,7574551,7574541,'649',3.333,3),(1117,7574552,7574541,'49e',3.333,3),(1117,7574553,7574541,'9ec',3.333,3),(1117,7574554,7574541,'ec6',3.333,3),(1117,7574555,7574541,'c65',3.333,3),(1117,7574556,7574541,'655',3.333,3),(1117,7574557,7574541,'558',3.333,3),(1117,7574558,7574541,'580',3.333,3),(1117,7574559,7574541,'80a',3.333,3),(1117,7574560,7574541,'0ab',3.333,3),(1117,7574561,7574541,'ab8',3.333,3),(1117,7574562,7574541,'b80',3.333,3),(1117,7574563,7574541,'803',3.333,3),(1117,7574564,7574541,'036',3.333,3),(1117,7574565,7574541,'36b',3.333,3),(1117,7574566,7574541,'6bb',3.333,3),(1117,7574567,7574541,'bb1',3.333,3),(1117,7574568,7574541,'b1a',3.333,3),(1117,7574569,7574541,'1a0',3.333,3),(1117,7574570,7574541,'a05',3.333,3),(1117,7574571,7574541,'054',3.333,3),(1117,7574572,7574542,'mon',100,1),(1117,7574573,7574572,'201',50,1),(1117,7574574,7574572,'013',50,1),(1117,7574575,7574573,'adm',33.333,4),(1117,7574576,7574573,'dmi',33.333,4),(1117,7574577,7574573,'min',33.333,4),(1117,7574578,7574575,'cap',16.667,1),(1117,7574579,7574575,'apa',16.667,1),(1117,7574580,7574575,'pac',16.667,1),(1117,7574581,7574575,'aci',16.667,1),(1117,7574582,7574575,'cit',16.667,1),(1117,7574583,7574575,'ity',16.667,1),(1117,7574584,7574578,'pat',50,1),(1117,7574585,7574578,'ath',50,1),(1117,7574586,7574584,'fre',14.286,1),(1117,7574587,7574584,'ree',14.286,1),(1117,7574588,7574584,'ees',14.286,1),(1117,7574589,7574584,'esp',14.286,1),(1117,7574590,7574584,'spa',14.286,1),(1117,7574591,7574584,'pac',14.286,1),(1117,7574592,7574584,'ace',14.286,1),(1117,7574593,7574586,'dis',50,1),(1117,7574594,7574586,'isk',50,1),(1117,7574595,7574593,'ind',33.333,1),(1117,7574596,7574593,'nde',33.333,1),(1117,7574597,7574593,'dex',33.333,1),(1117,7574598,7574595,'adm',8.333,1),(1117,7574599,7574595,'dmi',8.333,1),(1117,7574600,7574595,'min',8.333,1),(1117,7574601,7574595,'ini',8.333,1),(1117,7574602,7574595,'nis',8.333,1),(1117,7574603,7574595,'ist',8.333,1),(1117,7574604,7574595,'str',8.333,1),(1117,7574605,7574595,'tra',8.333,1),(1117,7574606,7574595,'rat',8.333,1),(1117,7574607,7574595,'ati',8.333,1),(1117,7574608,7574595,'tio',8.333,1),(1117,7574609,7574595,'ion',8.333,1),(1117,7574610,7574598,'sta',33.333,3),(1117,7574611,7574598,'tat',33.333,3),(1117,7574612,7574598,'ate',33.333,3),(1117,7574613,7574610,'dis',16.667,4),(1117,7574614,7574610,'isa',16.667,4),(1117,7574615,7574610,'sab',16.667,4),(1117,7574616,7574610,'abl',16.667,4),(1117,7574617,7574610,'ble',16.667,4),(1117,7574618,7574610,'led',16.667,4),(1117,7574619,7574613,'cac',33.333,1),(1117,7574620,7574613,'ach',33.333,1),(1117,7574621,7574613,'che',33.333,1),(1117,7574622,7574619,'mod',50,1),(1117,7574623,7574619,'ode',50,1),(1117,7574624,7574622,'wri',14.286,1),(1117,7574625,7574622,'rit',14.286,1),(1117,7574626,7574622,'ite',14.286,1),(1117,7574627,7574622,'tet',14.286,1),(1117,7574628,7574622,'eth',14.286,1),(1117,7574629,7574622,'thr',14.286,1),(1117,7574630,7574622,'hru',14.286,1),(1117,7574631,7574624,'ope',11.111,2),(1117,7574632,7574624,'per',11.111,2),(1117,7574633,7574624,'era',11.111,2),(1117,7574634,7574624,'rat',11.111,2),(1117,7574635,7574624,'ati',11.111,2),(1117,7574636,7574624,'tio',11.111,2),(1117,7574637,7574624,'ion',11.111,2),(1117,7574638,7574624,'ona',11.111,2),(1117,7574639,7574624,'nal',11.111,2),(1117,7574640,7574631,'mes',20,1),(1117,7574641,7574631,'ess',20,1),(1117,7574642,7574631,'ssa',20,1),(1117,7574643,7574631,'sag',20,1),(1117,7574644,7574631,'age',20,1),(1117,7574645,7574640,'per',11.111,1),(1117,7574646,7574640,'erf',11.111,1),(1117,7574647,7574640,'rfo',11.111,1),(1117,7574648,7574640,'for',11.111,1),(1117,7574649,7574640,'orm',11.111,1),(1117,7574650,7574640,'rma',11.111,1),(1117,7574651,7574640,'man',11.111,1),(1117,7574652,7574640,'anc',11.111,1),(1117,7574653,7574640,'nce',11.111,1),(1117,7574654,7574645,'ide',12.5,1),(1117,7574655,7574645,'den',12.5,1),(1117,7574656,7574645,'ent',12.5,1),(1117,7574657,7574645,'nti',12.5,1),(1117,7574658,7574645,'tif',12.5,1),(1117,7574659,7574645,'ifi',12.5,1),(1117,7574660,7574645,'fie',12.5,1),(1117,7574661,7574645,'ier',12.5,1),(1117,7574662,7574654,'vdi',33.333,3),(1117,7574663,7574654,'dis',33.333,3),(1117,7574664,7574654,'isk',33.333,3),(1117,7574665,7574662,'nam',50,1),(1117,7574666,7574662,'ame',50,1),(1117,7574667,7574665,'typ',50,1),(1117,7574668,7574665,'ype',50,1),(1117,7574669,7574667,'dir',25,1),(1117,7574670,7574667,'ire',25,1),(1117,7574671,7574667,'rec',25,1),(1117,7574672,7574667,'ect',25,1),(1118,7574674,7574673,'naa',100,2),(1118,7574675,7574674,'600',3.333,3),(1118,7574676,7574674,'000',3.333,3),(1118,7574677,7574674,'00c',3.333,3),(1118,7574678,7574674,'0c2',3.333,3),(1118,7574679,7574674,'c29',3.333,3),(1118,7574680,7574674,'29d',3.333,3),(1118,7574681,7574674,'9da',3.333,3),(1118,7574682,7574674,'da0',3.333,3),(1118,7574683,7574674,'a0c',3.333,3),(1118,7574684,7574674,'0c6',3.333,3),(1118,7574685,7574674,'c67',3.333,3),(1118,7574686,7574674,'678',3.333,3),(1118,7574687,7574674,'786',3.333,3),(1118,7574688,7574674,'863',3.333,3),(1118,7574689,7574674,'63e',3.333,3),(1118,7574690,7574674,'3ed',3.333,3),(1118,7574691,7574674,'ed3',3.333,3),(1118,7574692,7574674,'d3f',3.333,3),(1118,7574693,7574674,'3f0',3.333,3),(1118,7574694,7574674,'f00',3.333,3),(1118,7574695,7574674,'00c',3.333,3),(1118,7574696,7574674,'0cc',3.333,3),(1118,7574697,7574674,'cc7',3.333,3),(1118,7574698,7574674,'c73',3.333,3),(1118,7574699,7574674,'73d',3.333,3),(1118,7574700,7574674,'3d2',3.333,3),(1118,7574701,7574674,'d28',3.333,3),(1118,7574702,7574674,'282',3.333,3),(1118,7574703,7574674,'821',3.333,3),(1118,7574704,7574674,'219',3.333,3),(1118,7574705,7574675,'mon',100,1),(1118,7574706,7574705,'201',50,1),(1118,7574707,7574705,'013',50,1),(1118,7574708,7574706,'adm',33.333,4),(1118,7574709,7574706,'dmi',33.333,4),(1118,7574710,7574706,'min',33.333,4),(1118,7574711,7574708,'cap',16.667,1),(1118,7574712,7574708,'apa',16.667,1),(1118,7574713,7574708,'pac',16.667,1),(1118,7574714,7574708,'aci',16.667,1),(1118,7574715,7574708,'cit',16.667,1),(1118,7574716,7574708,'ity',16.667,1),(1118,7574717,7574711,'pat',50,1),(1118,7574718,7574711,'ath',50,1),(1118,7574719,7574717,'fre',14.286,1),(1118,7574720,7574717,'ree',14.286,1),(1118,7574721,7574717,'ees',14.286,1),(1118,7574722,7574717,'esp',14.286,1),(1118,7574723,7574717,'spa',14.286,1),(1118,7574724,7574717,'pac',14.286,1),(1118,7574725,7574717,'ace',14.286,1),(1118,7574726,7574719,'dis',50,1),(1118,7574727,7574719,'isk',50,1),(1118,7574728,7574726,'ind',33.333,1),(1118,7574729,7574726,'nde',33.333,1),(1118,7574730,7574726,'dex',33.333,1),(1118,7574731,7574728,'adm',8.333,1),(1118,7574732,7574728,'dmi',8.333,1),(1118,7574733,7574728,'min',8.333,1),(1118,7574734,7574728,'ini',8.333,1),(1118,7574735,7574728,'nis',8.333,1),(1118,7574736,7574728,'ist',8.333,1),(1118,7574737,7574728,'str',8.333,1),(1118,7574738,7574728,'tra',8.333,1),(1118,7574739,7574728,'rat',8.333,1),(1118,7574740,7574728,'ati',8.333,1),(1118,7574741,7574728,'tio',8.333,1),(1118,7574742,7574728,'ion',8.333,1),(1118,7574743,7574731,'sta',33.333,3),(1118,7574744,7574731,'tat',33.333,3),(1118,7574745,7574731,'ate',33.333,3),(1118,7574746,7574743,'dis',16.667,4),(1118,7574747,7574743,'isa',16.667,4),(1118,7574748,7574743,'sab',16.667,4),(1118,7574749,7574743,'abl',16.667,4),(1118,7574750,7574743,'ble',16.667,4),(1118,7574751,7574743,'led',16.667,4),(1118,7574752,7574746,'cac',33.333,1),(1118,7574753,7574746,'ach',33.333,1),(1118,7574754,7574746,'che',33.333,1),(1118,7574755,7574752,'mod',50,1),(1118,7574756,7574752,'ode',50,1),(1118,7574757,7574755,'wri',14.286,1),(1118,7574758,7574755,'rit',14.286,1),(1118,7574759,7574755,'ite',14.286,1),(1118,7574760,7574755,'tet',14.286,1),(1118,7574761,7574755,'eth',14.286,1),(1118,7574762,7574755,'thr',14.286,1),(1118,7574763,7574755,'hru',14.286,1),(1118,7574764,7574757,'ope',11.111,2),(1118,7574765,7574757,'per',11.111,2),(1118,7574766,7574757,'era',11.111,2),(1118,7574767,7574757,'rat',11.111,2),(1118,7574768,7574757,'ati',11.111,2),(1118,7574769,7574757,'tio',11.111,2),(1118,7574770,7574757,'ion',11.111,2),(1118,7574771,7574757,'ona',11.111,2),(1118,7574772,7574757,'nal',11.111,2),(1118,7574773,7574764,'mes',20,1),(1118,7574774,7574764,'ess',20,1),(1118,7574775,7574764,'ssa',20,1),(1118,7574776,7574764,'sag',20,1),(1118,7574777,7574764,'age',20,1),(1118,7574778,7574773,'per',11.111,1),(1118,7574779,7574773,'erf',11.111,1),(1118,7574780,7574773,'rfo',11.111,1),(1118,7574781,7574773,'for',11.111,1),(1118,7574782,7574773,'orm',11.111,1),(1118,7574783,7574773,'rma',11.111,1),(1118,7574784,7574773,'man',11.111,1),(1118,7574785,7574773,'anc',11.111,1),(1118,7574786,7574773,'nce',11.111,1),(1118,7574787,7574778,'ide',12.5,1),(1118,7574788,7574778,'den',12.5,1),(1118,7574789,7574778,'ent',12.5,1),(1118,7574790,7574778,'nti',12.5,1),(1118,7574791,7574778,'tif',12.5,1),(1118,7574792,7574778,'ifi',12.5,1),(1118,7574793,7574778,'fie',12.5,1),(1118,7574794,7574778,'ier',12.5,1),(1118,7574795,7574787,'vdi',33.333,3),(1118,7574796,7574787,'dis',33.333,3),(1118,7574797,7574787,'isk',33.333,3),(1118,7574798,7574795,'nam',50,1),(1118,7574799,7574795,'ame',50,1),(1118,7574800,7574798,'typ',50,1),(1118,7574801,7574798,'ype',50,1),(1118,7574802,7574800,'dir',25,1),(1118,7574803,7574800,'ire',25,1),(1118,7574804,7574800,'rec',25,1),(1118,7574805,7574800,'ect',25,1),(1119,7574807,7574806,'naa',100,2),(1119,7574808,7574807,'600',3.333,3),(1119,7574809,7574807,'000',3.333,3),(1119,7574810,7574807,'00c',3.333,3),(1119,7574811,7574807,'0c2',3.333,3),(1119,7574812,7574807,'c29',3.333,3),(1119,7574813,7574807,'29d',3.333,3),(1119,7574814,7574807,'9de',3.333,3),(1119,7574815,7574807,'de7',3.333,3),(1119,7574816,7574807,'e76',3.333,3),(1119,7574817,7574807,'769',3.333,3),(1119,7574818,7574807,'690',3.333,3),(1119,7574819,7574807,'909',3.333,3),(1119,7574820,7574807,'09d',3.333,3),(1119,7574821,7574807,'9d1',3.333,3),(1119,7574822,7574807,'d14',3.333,3),(1119,7574823,7574807,'14d',3.333,3),(1119,7574824,7574807,'4d5',3.333,3),(1119,7574825,7574807,'d55',3.333,3),(1119,7574826,7574807,'55e',3.333,3),(1119,7574827,7574807,'5e3',3.333,3),(1119,7574828,7574807,'e36',3.333,3),(1119,7574829,7574807,'369',3.333,3),(1119,7574830,7574807,'69d',3.333,3),(1119,7574831,7574807,'9dc',3.333,3),(1119,7574832,7574807,'dc0',3.333,3),(1119,7574833,7574807,'c06',3.333,3),(1119,7574834,7574807,'064',3.333,3),(1119,7574835,7574807,'647',3.333,3),(1119,7574836,7574807,'47d',3.333,3),(1119,7574837,7574807,'7d2',3.333,3),(1119,7574838,7574808,'mon',100,1),(1119,7574839,7574838,'201',50,1),(1119,7574840,7574838,'013',50,1),(1119,7574841,7574839,'adm',33.333,4),(1119,7574842,7574839,'dmi',33.333,4),(1119,7574843,7574839,'min',33.333,4),(1119,7574844,7574841,'cap',16.667,1),(1119,7574845,7574841,'apa',16.667,1),(1119,7574846,7574841,'pac',16.667,1),(1119,7574847,7574841,'aci',16.667,1),(1119,7574848,7574841,'cit',16.667,1),(1119,7574849,7574841,'ity',16.667,1),(1119,7574850,7574844,'pat',50,1),(1119,7574851,7574844,'ath',50,1),(1119,7574852,7574850,'fre',14.286,1),(1119,7574853,7574850,'ree',14.286,1),(1119,7574854,7574850,'ees',14.286,1),(1119,7574855,7574850,'esp',14.286,1),(1119,7574856,7574850,'spa',14.286,1),(1119,7574857,7574850,'pac',14.286,1),(1119,7574858,7574850,'ace',14.286,1),(1119,7574859,7574852,'dis',50,1),(1119,7574860,7574852,'isk',50,1),(1119,7574861,7574859,'ind',33.333,1),(1119,7574862,7574859,'nde',33.333,1),(1119,7574863,7574859,'dex',33.333,1),(1119,7574864,7574861,'adm',8.333,1),(1119,7574865,7574861,'dmi',8.333,1),(1119,7574866,7574861,'min',8.333,1),(1119,7574867,7574861,'ini',8.333,1),(1119,7574868,7574861,'nis',8.333,1),(1119,7574869,7574861,'ist',8.333,1),(1119,7574870,7574861,'str',8.333,1),(1119,7574871,7574861,'tra',8.333,1),(1119,7574872,7574861,'rat',8.333,1),(1119,7574873,7574861,'ati',8.333,1),(1119,7574874,7574861,'tio',8.333,1),(1119,7574875,7574861,'ion',8.333,1),(1119,7574876,7574864,'sta',33.333,3),(1119,7574877,7574864,'tat',33.333,3),(1119,7574878,7574864,'ate',33.333,3),(1119,7574879,7574876,'dis',16.667,4),(1119,7574880,7574876,'isa',16.667,4),(1119,7574881,7574876,'sab',16.667,4),(1119,7574882,7574876,'abl',16.667,4),(1119,7574883,7574876,'ble',16.667,4),(1119,7574884,7574876,'led',16.667,4),(1119,7574885,7574879,'cac',33.333,1),(1119,7574886,7574879,'ach',33.333,1),(1119,7574887,7574879,'che',33.333,1),(1119,7574888,7574885,'mod',50,1),(1119,7574889,7574885,'ode',50,1),(1119,7574890,7574888,'wri',14.286,1),(1119,7574891,7574888,'rit',14.286,1),(1119,7574892,7574888,'ite',14.286,1),(1119,7574893,7574888,'tet',14.286,1),(1119,7574894,7574888,'eth',14.286,1),(1119,7574895,7574888,'thr',14.286,1),(1119,7574896,7574888,'hru',14.286,1),(1119,7574897,7574890,'ope',11.111,2),(1119,7574898,7574890,'per',11.111,2),(1119,7574899,7574890,'era',11.111,2),(1119,7574900,7574890,'rat',11.111,2),(1119,7574901,7574890,'ati',11.111,2),(1119,7574902,7574890,'tio',11.111,2),(1119,7574903,7574890,'ion',11.111,2),(1119,7574904,7574890,'ona',11.111,2),(1119,7574905,7574890,'nal',11.111,2),(1119,7574906,7574897,'mes',20,1),(1119,7574907,7574897,'ess',20,1),(1119,7574908,7574897,'ssa',20,1),(1119,7574909,7574897,'sag',20,1),(1119,7574910,7574897,'age',20,1),(1119,7574911,7574906,'per',11.111,1),(1119,7574912,7574906,'erf',11.111,1),(1119,7574913,7574906,'rfo',11.111,1),(1119,7574914,7574906,'for',11.111,1),(1119,7574915,7574906,'orm',11.111,1),(1119,7574916,7574906,'rma',11.111,1),(1119,7574917,7574906,'man',11.111,1),(1119,7574918,7574906,'anc',11.111,1),(1119,7574919,7574906,'nce',11.111,1),(1119,7574920,7574911,'ide',12.5,1),(1119,7574921,7574911,'den',12.5,1),(1119,7574922,7574911,'ent',12.5,1),(1119,7574923,7574911,'nti',12.5,1),(1119,7574924,7574911,'tif',12.5,1),(1119,7574925,7574911,'ifi',12.5,1),(1119,7574926,7574911,'fie',12.5,1),(1119,7574927,7574911,'ier',12.5,1),(1119,7574928,7574920,'vdi',33.333,3),(1119,7574929,7574920,'dis',33.333,3),(1119,7574930,7574920,'isk',33.333,3),(1119,7574931,7574928,'nam',50,1),(1119,7574932,7574928,'ame',50,1),(1119,7574933,7574931,'typ',50,1),(1119,7574934,7574931,'ype',50,1),(1119,7574935,7574933,'dir',25,1),(1119,7574936,7574933,'ire',25,1),(1119,7574937,7574933,'rec',25,1),(1119,7574938,7574933,'ect',25,1),(1120,7574940,7574939,'naa',100,2),(1120,7574941,7574940,'600',3.333,3),(1120,7574942,7574940,'000',3.333,3),(1120,7574943,7574940,'00c',3.333,3),(1120,7574944,7574940,'0c2',3.333,3),(1120,7574945,7574940,'c29',3.333,3),(1120,7574946,7574940,'295',3.333,3),(1120,7574947,7574940,'958',3.333,3),(1120,7574948,7574940,'58b',3.333,3),(1120,7574949,7574940,'8b8',3.333,3),(1120,7574950,7574940,'b8c',3.333,3),(1120,7574951,7574940,'8ca',3.333,3),(1120,7574952,7574940,'ca3',3.333,3),(1120,7574953,7574940,'a35',3.333,3),(1120,7574954,7574940,'35c',3.333,3),(1120,7574955,7574940,'5cf',3.333,3),(1120,7574956,7574940,'cfe',3.333,3),(1120,7574957,7574940,'fe8',3.333,3),(1120,7574958,7574940,'e84',3.333,3),(1120,7574959,7574940,'840',3.333,3),(1120,7574960,7574940,'404',3.333,3),(1120,7574961,7574940,'043',3.333,3),(1120,7574962,7574940,'435',3.333,3),(1120,7574963,7574940,'350',3.333,3),(1120,7574964,7574940,'501',3.333,3),(1120,7574965,7574940,'016',3.333,3),(1120,7574966,7574940,'166',3.333,3),(1120,7574967,7574940,'668',3.333,3),(1120,7574968,7574940,'68d',3.333,3),(1120,7574969,7574940,'8d3',3.333,3),(1120,7574970,7574940,'d36',3.333,3),(1120,7574971,7574941,'mon',100,1),(1120,7574972,7574971,'201',50,1),(1120,7574973,7574971,'013',50,1),(1120,7574974,7574972,'adm',33.333,4),(1120,7574975,7574972,'dmi',33.333,4),(1120,7574976,7574972,'min',33.333,4),(1120,7574977,7574974,'cap',16.667,1),(1120,7574978,7574974,'apa',16.667,1),(1120,7574979,7574974,'pac',16.667,1),(1120,7574980,7574974,'aci',16.667,1),(1120,7574981,7574974,'cit',16.667,1),(1120,7574982,7574974,'ity',16.667,1),(1120,7574983,7574977,'pat',50,1),(1120,7574984,7574977,'ath',50,1),(1120,7574985,7574983,'fre',14.286,1),(1120,7574986,7574983,'ree',14.286,1),(1120,7574987,7574983,'ees',14.286,1),(1120,7574988,7574983,'esp',14.286,1),(1120,7574989,7574983,'spa',14.286,1),(1120,7574990,7574983,'pac',14.286,1),(1120,7574991,7574983,'ace',14.286,1),(1120,7574992,7574985,'dis',50,1),(1120,7574993,7574985,'isk',50,1),(1120,7574994,7574992,'ind',33.333,1),(1120,7574995,7574992,'nde',33.333,1),(1120,7574996,7574992,'dex',33.333,1),(1120,7574997,7574994,'adm',8.333,1),(1120,7574998,7574994,'dmi',8.333,1),(1120,7574999,7574994,'min',8.333,1),(1120,7575000,7574994,'ini',8.333,1),(1120,7575001,7574994,'nis',8.333,1),(1120,7575002,7574994,'ist',8.333,1),(1120,7575003,7574994,'str',8.333,1),(1120,7575004,7574994,'tra',8.333,1),(1120,7575005,7574994,'rat',8.333,1),(1120,7575006,7574994,'ati',8.333,1),(1120,7575007,7574994,'tio',8.333,1),(1120,7575008,7574994,'ion',8.333,1),(1120,7575009,7574997,'sta',33.333,3),(1120,7575010,7574997,'tat',33.333,3),(1120,7575011,7574997,'ate',33.333,3),(1120,7575012,7575009,'dis',16.667,4),(1120,7575013,7575009,'isa',16.667,4),(1120,7575014,7575009,'sab',16.667,4),(1120,7575015,7575009,'abl',16.667,4),(1120,7575016,7575009,'ble',16.667,4),(1120,7575017,7575009,'led',16.667,4),(1120,7575018,7575012,'cac',33.333,1),(1120,7575019,7575012,'ach',33.333,1),(1120,7575020,7575012,'che',33.333,1),(1120,7575021,7575018,'mod',50,1),(1120,7575022,7575018,'ode',50,1),(1120,7575023,7575021,'wri',14.286,1),(1120,7575024,7575021,'rit',14.286,1),(1120,7575025,7575021,'ite',14.286,1),(1120,7575026,7575021,'tet',14.286,1),(1120,7575027,7575021,'eth',14.286,1),(1120,7575028,7575021,'thr',14.286,1),(1120,7575029,7575021,'hru',14.286,1),(1120,7575030,7575023,'ope',11.111,2),(1120,7575031,7575023,'per',11.111,2),(1120,7575032,7575023,'era',11.111,2),(1120,7575033,7575023,'rat',11.111,2),(1120,7575034,7575023,'ati',11.111,2),(1120,7575035,7575023,'tio',11.111,2),(1120,7575036,7575023,'ion',11.111,2),(1120,7575037,7575023,'ona',11.111,2),(1120,7575038,7575023,'nal',11.111,2),(1120,7575039,7575030,'mes',20,1),(1120,7575040,7575030,'ess',20,1),(1120,7575041,7575030,'ssa',20,1),(1120,7575042,7575030,'sag',20,1),(1120,7575043,7575030,'age',20,1),(1120,7575044,7575039,'per',11.111,1),(1120,7575045,7575039,'erf',11.111,1),(1120,7575046,7575039,'rfo',11.111,1),(1120,7575047,7575039,'for',11.111,1),(1120,7575048,7575039,'orm',11.111,1),(1120,7575049,7575039,'rma',11.111,1),(1120,7575050,7575039,'man',11.111,1),(1120,7575051,7575039,'anc',11.111,1),(1120,7575052,7575039,'nce',11.111,1),(1120,7575053,7575044,'ide',12.5,1),(1120,7575054,7575044,'den',12.5,1),(1120,7575055,7575044,'ent',12.5,1),(1120,7575056,7575044,'nti',12.5,1),(1120,7575057,7575044,'tif',12.5,1),(1120,7575058,7575044,'ifi',12.5,1),(1120,7575059,7575044,'fie',12.5,1),(1120,7575060,7575044,'ier',12.5,1),(1120,7575061,7575053,'vdi',33.333,3),(1120,7575062,7575053,'dis',33.333,3),(1120,7575063,7575053,'isk',33.333,3),(1120,7575064,7575061,'nam',50,1),(1120,7575065,7575061,'ame',50,1),(1120,7575066,7575064,'typ',50,1),(1120,7575067,7575064,'ype',50,1),(1120,7575068,7575066,'dir',25,1),(1120,7575069,7575066,'ire',25,1),(1120,7575070,7575066,'rec',25,1),(1120,7575071,7575066,'ect',25,1),(1121,7575073,7575072,'naa',100,2),(1121,7575074,7575073,'600',3.333,3),(1121,7575075,7575073,'000',3.333,3),(1121,7575076,7575073,'00c',3.333,3),(1121,7575077,7575073,'0c2',3.333,3),(1121,7575078,7575073,'c29',3.333,3),(1121,7575079,7575073,'295',3.333,3),(1121,7575080,7575073,'953',3.333,3),(1121,7575081,7575073,'53c',3.333,3),(1121,7575082,7575073,'3c1',3.333,3),(1121,7575083,7575073,'c14',3.333,3),(1121,7575084,7575073,'147',3.333,3),(1121,7575085,7575073,'471',3.333,3),(1121,7575086,7575073,'71b',3.333,3),(1121,7575087,7575073,'1b1',3.333,3),(1121,7575088,7575073,'b1b',3.333,3),(1121,7575089,7575073,'1b6',3.333,3),(1121,7575090,7575073,'b67',3.333,3),(1121,7575091,7575073,'67b',3.333,3),(1121,7575092,7575073,'7b9',3.333,3),(1121,7575093,7575073,'b9d',3.333,3),(1121,7575094,7575073,'9df',3.333,3),(1121,7575095,7575073,'df1',3.333,3),(1121,7575096,7575073,'f17',3.333,3),(1121,7575097,7575073,'17a',3.333,3),(1121,7575098,7575073,'7a3',3.333,3),(1121,7575099,7575073,'a3a',3.333,3),(1121,7575100,7575073,'3a9',3.333,3),(1121,7575101,7575073,'a95',3.333,3),(1121,7575102,7575073,'957',3.333,3),(1121,7575103,7575073,'57a',3.333,3),(1121,7575104,7575074,'mon',100,1),(1121,7575105,7575104,'201',50,1),(1121,7575106,7575104,'013',50,1),(1121,7575107,7575105,'adm',33.333,4),(1121,7575108,7575105,'dmi',33.333,4),(1121,7575109,7575105,'min',33.333,4),(1121,7575110,7575107,'cap',16.667,1),(1121,7575111,7575107,'apa',16.667,1),(1121,7575112,7575107,'pac',16.667,1),(1121,7575113,7575107,'aci',16.667,1),(1121,7575114,7575107,'cit',16.667,1),(1121,7575115,7575107,'ity',16.667,1),(1121,7575116,7575110,'pat',50,1),(1121,7575117,7575110,'ath',50,1),(1121,7575118,7575116,'fre',14.286,1),(1121,7575119,7575116,'ree',14.286,1),(1121,7575120,7575116,'ees',14.286,1),(1121,7575121,7575116,'esp',14.286,1),(1121,7575122,7575116,'spa',14.286,1),(1121,7575123,7575116,'pac',14.286,1),(1121,7575124,7575116,'ace',14.286,1),(1121,7575125,7575118,'dis',50,1),(1121,7575126,7575118,'isk',50,1),(1121,7575127,7575125,'ind',33.333,1),(1121,7575128,7575125,'nde',33.333,1),(1121,7575129,7575125,'dex',33.333,1),(1121,7575130,7575127,'adm',8.333,1),(1121,7575131,7575127,'dmi',8.333,1),(1121,7575132,7575127,'min',8.333,1),(1121,7575133,7575127,'ini',8.333,1),(1121,7575134,7575127,'nis',8.333,1),(1121,7575135,7575127,'ist',8.333,1),(1121,7575136,7575127,'str',8.333,1),(1121,7575137,7575127,'tra',8.333,1),(1121,7575138,7575127,'rat',8.333,1),(1121,7575139,7575127,'ati',8.333,1),(1121,7575140,7575127,'tio',8.333,1),(1121,7575141,7575127,'ion',8.333,1),(1121,7575142,7575130,'sta',33.333,3),(1121,7575143,7575130,'tat',33.333,3),(1121,7575144,7575130,'ate',33.333,3),(1121,7575145,7575142,'dis',16.667,4),(1121,7575146,7575142,'isa',16.667,4),(1121,7575147,7575142,'sab',16.667,4),(1121,7575148,7575142,'abl',16.667,4),(1121,7575149,7575142,'ble',16.667,4),(1121,7575150,7575142,'led',16.667,4),(1121,7575151,7575145,'cac',33.333,1),(1121,7575152,7575145,'ach',33.333,1),(1121,7575153,7575145,'che',33.333,1),(1121,7575154,7575151,'mod',50,1),(1121,7575155,7575151,'ode',50,1),(1121,7575156,7575154,'wri',14.286,1),(1121,7575157,7575154,'rit',14.286,1),(1121,7575158,7575154,'ite',14.286,1),(1121,7575159,7575154,'tet',14.286,1),(1121,7575160,7575154,'eth',14.286,1),(1121,7575161,7575154,'thr',14.286,1),(1121,7575162,7575154,'hru',14.286,1),(1121,7575163,7575156,'ope',11.111,2),(1121,7575164,7575156,'per',11.111,2),(1121,7575165,7575156,'era',11.111,2),(1121,7575166,7575156,'rat',11.111,2),(1121,7575167,7575156,'ati',11.111,2),(1121,7575168,7575156,'tio',11.111,2),(1121,7575169,7575156,'ion',11.111,2),(1121,7575170,7575156,'ona',11.111,2),(1121,7575171,7575156,'nal',11.111,2),(1121,7575172,7575163,'mes',20,1),(1121,7575173,7575163,'ess',20,1),(1121,7575174,7575163,'ssa',20,1),(1121,7575175,7575163,'sag',20,1),(1121,7575176,7575163,'age',20,1),(1121,7575177,7575172,'per',11.111,1),(1121,7575178,7575172,'erf',11.111,1),(1121,7575179,7575172,'rfo',11.111,1),(1121,7575180,7575172,'for',11.111,1),(1121,7575181,7575172,'orm',11.111,1),(1121,7575182,7575172,'rma',11.111,1),(1121,7575183,7575172,'man',11.111,1),(1121,7575184,7575172,'anc',11.111,1),(1121,7575185,7575172,'nce',11.111,1),(1121,7575186,7575177,'ide',12.5,1),(1121,7575187,7575177,'den',12.5,1),(1121,7575188,7575177,'ent',12.5,1),(1121,7575189,7575177,'nti',12.5,1),(1121,7575190,7575177,'tif',12.5,1),(1121,7575191,7575177,'ifi',12.5,1),(1121,7575192,7575177,'fie',12.5,1),(1121,7575193,7575177,'ier',12.5,1),(1121,7575194,7575186,'vdi',33.333,3),(1121,7575195,7575186,'dis',33.333,3),(1121,7575196,7575186,'isk',33.333,3),(1121,7575197,7575194,'nam',50,1),(1121,7575198,7575194,'ame',50,1),(1121,7575199,7575197,'typ',50,1),(1121,7575200,7575197,'ype',50,1),(1121,7575201,7575199,'dir',25,1),(1121,7575202,7575199,'ire',25,1),(1121,7575203,7575199,'rec',25,1),(1121,7575204,7575199,'ect',25,1),(1122,7575206,7575205,'naa',100,2),(1122,7575207,7575206,'600',3.333,3),(1122,7575208,7575206,'000',3.333,3),(1122,7575209,7575206,'00c',3.333,3),(1122,7575210,7575206,'0c2',3.333,3),(1122,7575211,7575206,'c29',3.333,3),(1122,7575212,7575206,'296',3.333,3),(1122,7575213,7575206,'96a',3.333,3),(1122,7575214,7575206,'6ad',3.333,3),(1122,7575215,7575206,'adf',3.333,3),(1122,7575216,7575206,'df5',3.333,3),(1122,7575217,7575206,'f5f',3.333,3),(1122,7575218,7575206,'5f0',3.333,3),(1122,7575219,7575206,'f07',3.333,3),(1122,7575220,7575206,'07c',3.333,3),(1122,7575221,7575206,'7c1',3.333,3),(1122,7575222,7575206,'c1c',3.333,3),(1122,7575223,7575206,'1cf',3.333,3),(1122,7575224,7575206,'cf4',3.333,3),(1122,7575225,7575206,'f49',3.333,3),(1122,7575226,7575206,'498',3.333,3),(1122,7575227,7575206,'988',3.333,3),(1122,7575228,7575206,'883',3.333,3),(1122,7575229,7575206,'83e',3.333,3),(1122,7575230,7575206,'3e0',3.333,3),(1122,7575231,7575206,'e0d',3.333,3),(1122,7575232,7575206,'0d8',3.333,3),(1122,7575233,7575206,'d86',3.333,3),(1122,7575234,7575206,'868',3.333,3),(1122,7575235,7575206,'689',3.333,3),(1122,7575236,7575206,'890',3.333,3),(1122,7575237,7575207,'mon',100,1),(1122,7575238,7575237,'201',50,1),(1122,7575239,7575237,'013',50,1),(1122,7575240,7575238,'adm',33.333,4),(1122,7575241,7575238,'dmi',33.333,4),(1122,7575242,7575238,'min',33.333,4),(1122,7575243,7575240,'cap',16.667,1),(1122,7575244,7575240,'apa',16.667,1),(1122,7575245,7575240,'pac',16.667,1),(1122,7575246,7575240,'aci',16.667,1),(1122,7575247,7575240,'cit',16.667,1),(1122,7575248,7575240,'ity',16.667,1),(1122,7575249,7575243,'pat',50,1),(1122,7575250,7575243,'ath',50,1),(1122,7575251,7575249,'two',100,1),(1122,7575252,7575251,'fre',14.286,1),(1122,7575253,7575251,'ree',14.286,1),(1122,7575254,7575251,'ees',14.286,1),(1122,7575255,7575251,'esp',14.286,1),(1122,7575256,7575251,'spa',14.286,1),(1122,7575257,7575251,'pac',14.286,1),(1122,7575258,7575251,'ace',14.286,1),(1122,7575259,7575252,'dis',50,1),(1122,7575260,7575252,'isk',50,1),(1122,7575261,7575259,'ind',33.333,1),(1122,7575262,7575259,'nde',33.333,1),(1122,7575263,7575259,'dex',33.333,1),(1122,7575264,7575261,'adm',8.333,1),(1122,7575265,7575261,'dmi',8.333,1),(1122,7575266,7575261,'min',8.333,1),(1122,7575267,7575261,'ini',8.333,1),(1122,7575268,7575261,'nis',8.333,1),(1122,7575269,7575261,'ist',8.333,1),(1122,7575270,7575261,'str',8.333,1),(1122,7575271,7575261,'tra',8.333,1),(1122,7575272,7575261,'rat',8.333,1),(1122,7575273,7575261,'ati',8.333,1),(1122,7575274,7575261,'tio',8.333,1),(1122,7575275,7575261,'ion',8.333,1),(1122,7575276,7575264,'sta',33.333,3),(1122,7575277,7575264,'tat',33.333,3),(1122,7575278,7575264,'ate',33.333,3),(1122,7575279,7575276,'dis',16.667,4),(1122,7575280,7575276,'isa',16.667,4),(1122,7575281,7575276,'sab',16.667,4),(1122,7575282,7575276,'abl',16.667,4),(1122,7575283,7575276,'ble',16.667,4),(1122,7575284,7575276,'led',16.667,4),(1122,7575285,7575279,'cac',33.333,1),(1122,7575286,7575279,'ach',33.333,1),(1122,7575287,7575279,'che',33.333,1),(1122,7575288,7575285,'mod',50,1),(1122,7575289,7575285,'ode',50,1),(1122,7575290,7575288,'wri',14.286,1),(1122,7575291,7575288,'rit',14.286,1),(1122,7575292,7575288,'ite',14.286,1),(1122,7575293,7575288,'tet',14.286,1),(1122,7575294,7575288,'eth',14.286,1),(1122,7575295,7575288,'thr',14.286,1),(1122,7575296,7575288,'hru',14.286,1),(1122,7575297,7575290,'ope',11.111,2),(1122,7575298,7575290,'per',11.111,2),(1122,7575299,7575290,'era',11.111,2),(1122,7575300,7575290,'rat',11.111,2),(1122,7575301,7575290,'ati',11.111,2),(1122,7575302,7575290,'tio',11.111,2),(1122,7575303,7575290,'ion',11.111,2),(1122,7575304,7575290,'ona',11.111,2),(1122,7575305,7575290,'nal',11.111,2),(1122,7575306,7575297,'mes',20,1),(1122,7575307,7575297,'ess',20,1),(1122,7575308,7575297,'ssa',20,1),(1122,7575309,7575297,'sag',20,1),(1122,7575310,7575297,'age',20,1),(1122,7575311,7575306,'per',11.111,1),(1122,7575312,7575306,'erf',11.111,1),(1122,7575313,7575306,'rfo',11.111,1),(1122,7575314,7575306,'for',11.111,1),(1122,7575315,7575306,'orm',11.111,1),(1122,7575316,7575306,'rma',11.111,1),(1122,7575317,7575306,'man',11.111,1),(1122,7575318,7575306,'anc',11.111,1),(1122,7575319,7575306,'nce',11.111,1),(1122,7575320,7575311,'ide',12.5,1),(1122,7575321,7575311,'den',12.5,1),(1122,7575322,7575311,'ent',12.5,1),(1122,7575323,7575311,'nti',12.5,1),(1122,7575324,7575311,'tif',12.5,1),(1122,7575325,7575311,'ifi',12.5,1),(1122,7575326,7575311,'fie',12.5,1),(1122,7575327,7575311,'ier',12.5,1),(1122,7575328,7575320,'vdi',33.333,3),(1122,7575329,7575320,'dis',33.333,3),(1122,7575330,7575320,'isk',33.333,3),(1122,7575331,7575328,'nam',50,1),(1122,7575332,7575328,'ame',50,1),(1122,7575333,7575331,'typ',50,1),(1122,7575334,7575331,'ype',50,1),(1122,7575335,7575333,'dir',25,1),(1122,7575336,7575333,'ire',25,1),(1122,7575337,7575333,'rec',25,1),(1122,7575338,7575333,'ect',25,1),(2,7575340,7575339,'mer',14.286,1),(2,7575341,7575339,'erc',14.286,1),(2,7575342,7575339,'rcu',14.286,1),(2,7575343,7575339,'cur',14.286,1),(2,7575344,7575339,'ury',14.286,1),(2,7575345,7575339,'ryv',14.286,1),(2,7575346,7575339,'yvc',14.286,1),(2,7575347,7575340,'nan',50,1),(2,7575348,7575340,'ane',50,1),(2,7575349,7575347,'net',25,1),(2,7575350,7575347,'eta',25,1),(2,7575351,7575347,'tap',25,1),(2,7575352,7575347,'app',25,1),(2,7575353,7575349,'com',100,1),(3,7575355,7575354,'hgx',20,1),(3,7575356,7575354,'gx3',20,1),(3,7575357,7575354,'x36',20,1),(3,7575358,7575354,'369',20,1),(3,7575359,7575354,'690',20,1),(4,7575361,7575360,'reg',12.5,1),(4,7575362,7575360,'egr',12.5,1),(4,7575363,7575360,'gre',12.5,1),(4,7575364,7575360,'res',12.5,1),(4,7575365,7575360,'ess',12.5,1),(4,7575366,7575360,'ssi',12.5,1),(4,7575367,7575360,'sio',12.5,1),(4,7575368,7575360,'ion',12.5,1),(4,7575369,7575361,'lab',100,1),(5,7575371,7575370,'hgr',20,1),(5,7575372,7575370,'grx',20,1),(5,7575373,7575370,'rx3',20,1),(5,7575374,7575370,'x30',20,1),(5,7575375,7575370,'300',20,1),(6,7575377,7575376,'hgu',14.286,1),(6,7575378,7575376,'guc',14.286,1),(6,7575379,7575376,'ucs',14.286,1),(6,7575380,7575376,'csb',14.286,1),(6,7575381,7575376,'sb2',14.286,1),(6,7575382,7575376,'b20',14.286,1),(6,7575383,7575376,'200',14.286,1),(703,7612983,7612982,'att',12.5,1),(703,7612984,7612982,'ttr',12.5,1),(703,7612985,7612982,'tri',12.5,1),(703,7612986,7612982,'rib',12.5,1),(703,7612987,7612982,'ibu',12.5,1),(703,7612988,7612982,'but',12.5,1),(703,7612989,7612982,'ute',12.5,1),(703,7612990,7612982,'tes',12.5,1),(703,7612991,7612983,'ref',20,3),(703,7612992,7612983,'efr',20,3),(703,7612993,7612983,'fre',20,3),(703,7612994,7612983,'res',20,3),(703,7612995,7612983,'esh',20,3),(703,7612996,7612991,'hos',50,2),(703,7612997,7612991,'ost',50,2),(703,7612998,7612996,'nam',50,2),(703,7612999,7612996,'ame',50,2),(703,7613000,7612998,'hg3',9.091,1),(703,7613001,7612998,'g32',9.091,1),(703,7613002,7612998,'32v',9.091,1),(703,7613003,7612998,'2vm',9.091,1),(703,7613004,7612998,'vm9',9.091,1),(703,7613005,7612998,'m9w',9.091,1),(703,7613006,7612998,'9w2',9.091,1),(703,7613007,7612998,'w2k',9.091,1),(703,7613008,7612998,'2k8',9.091,1),(703,7613009,7612998,'k8r',9.091,1),(703,7613010,7612998,'8r2',9.091,1),(703,7613011,7613000,'gdl',100,1),(703,7613012,7613011,'eng',25,1),(703,7613013,7613011,'ngl',25,1),(703,7613014,7613011,'gla',25,1),(703,7613015,7613011,'lab',25,1),(703,7613016,7613012,'net',25,1),(703,7613017,7613012,'eta',25,1),(703,7613018,7613012,'tap',25,1),(703,7613019,7613012,'app',25,1),(703,7613020,7613016,'com',100,1),(703,7613021,7613020,'mem',25,3),(703,7613022,7613020,'emo',25,3),(703,7613023,7613020,'mor',25,3),(703,7613024,7613020,'ory',25,3),(703,7613025,7613021,'siz',50,2),(703,7613026,7613021,'ize',50,2),(703,7613027,7613025,'614',50,1),(703,7613028,7613025,'144',50,1),(703,7613029,7613027,'cpu',100,1),(703,7613030,7613029,'usa',33.333,3),(703,7613031,7613029,'sag',33.333,3),(703,7613032,7613029,'age',33.333,3),(703,7613033,7613030,'mhz',100,1),(703,7613034,7613033,'add',20,1),(703,7613035,7613033,'ddr',20,1),(703,7613036,7613033,'dre',20,1),(703,7613037,7613033,'res',20,1),(703,7613038,7613033,'ess',20,1),(703,7613039,7613034,'226',100,1),(703,7613040,7613039,'147',100,1),(703,7613041,7613040,'211',100,1),(703,7613042,7613041,'397',50,1),(703,7613043,7613041,'974',50,1),(703,7613044,7613042,'gue',33.333,2),(703,7613045,7613042,'ues',33.333,2),(703,7613046,7613042,'est',33.333,2),(703,7613047,7613044,'vmw',25,2),(703,7613048,7613044,'mwa',25,2),(703,7613049,7613044,'war',25,2),(703,7613050,7613044,'are',25,2),(703,7613051,7613047,'too',33.333,2),(703,7613052,7613047,'ool',33.333,2),(703,7613053,7613047,'ols',33.333,2),(703,7613054,7613051,'run',20,1),(703,7613055,7613051,'unn',20,1),(703,7613056,7613051,'nni',20,1),(703,7613057,7613051,'nin',20,1),(703,7613058,7613051,'ing',20,1),(703,7613059,7613054,'and',100,1),(703,7613060,7613059,'the',100,1),(703,7613061,7613060,'ver',20,2),(703,7613062,7613060,'ers',20,2),(703,7613063,7613060,'rsi',20,2),(703,7613064,7613060,'sio',20,2),(703,7613065,7613060,'ion',20,2),(703,7613066,7613061,'cur',20,1),(703,7613067,7613061,'urr',20,1),(703,7613068,7613061,'rre',20,1),(703,7613069,7613061,'ren',20,1),(703,7613070,7613061,'ent',20,1),(703,7613071,7613066,'mic',14.286,1),(703,7613072,7613066,'icr',14.286,1),(703,7613073,7613066,'cro',14.286,1),(703,7613074,7613066,'ros',14.286,1),(703,7613075,7613066,'oso',14.286,1),(703,7613076,7613066,'sof',14.286,1),(703,7613077,7613066,'oft',14.286,1),(703,7613078,7613071,'win',20,1),(703,7613079,7613071,'ind',20,1),(703,7613080,7613071,'ndo',20,1),(703,7613081,7613071,'dow',20,1),(703,7613082,7613071,'ows',20,1),(703,7613083,7613078,'ser',25,1),(703,7613084,7613078,'erv',25,1),(703,7613085,7613078,'rve',25,1),(703,7613086,7613078,'ver',25,1),(703,7613087,7613083,'200',50,1),(703,7613088,7613083,'008',50,1),(703,7613089,7613087,'64b',33.333,1),(703,7613090,7613087,'4bi',33.333,1),(703,7613091,7613087,'bit',33.333,1),(703,7613092,7613089,'pat',50,1),(703,7613093,7613089,'ath',50,1),(703,7613094,7613092,'rx6',33.333,1),(703,7613095,7613092,'x60',33.333,1),(703,7613096,7613092,'600',33.333,1),(703,7613097,7613094,'vmf',20,1),(703,7613098,7613094,'mfi',20,1),(703,7613099,7613094,'fil',20,1),(703,7613100,7613094,'ile',20,1),(703,7613101,7613094,'les',20,1),(703,7613102,7613097,'hgw',9.091,2),(703,7613103,7613097,'gw2',9.091,2),(703,7613104,7613097,'w2k',9.091,2),(703,7613105,7613097,'2k8',9.091,2),(703,7613106,7613097,'k8r',9.091,2),(703,7613107,7613097,'8r2',9.091,2),(703,7613108,7613097,'r23',9.091,2),(703,7613109,7613097,'232',9.091,2),(703,7613110,7613097,'32v',9.091,2),(703,7613111,7613097,'2vm',9.091,2),(703,7613112,7613097,'vm9',9.091,2),(703,7613113,7613102,'vmx',100,1),(703,7613114,7613113,'fla',33.333,1),(703,7613115,7613113,'las',33.333,1),(703,7613116,7613113,'ash',33.333,1),(703,7613117,7613114,'acc',33.333,1),(703,7613118,7613114,'cce',33.333,1),(703,7613119,7613114,'cel',33.333,1),(703,7613120,7613117,'con',9.091,1),(703,7613121,7613117,'onf',9.091,1),(703,7613122,7613117,'nfi',9.091,1),(703,7613123,7613117,'fig',9.091,1),(703,7613124,7613117,'igu',9.091,1),(703,7613125,7613117,'gur',9.091,1),(703,7613126,7613117,'ura',9.091,1),(703,7613127,7613117,'rat',9.091,1),(703,7613128,7613117,'ati',9.091,1),(703,7613129,7613117,'tio',9.091,1),(703,7613130,7613117,'ion',9.091,1),(703,7613131,7613120,'age',33.333,1),(703,7613132,7613120,'gen',33.333,1),(703,7613133,7613120,'ent',33.333,1),(703,7613134,7613131,'193',16.667,1),(703,7613135,7613131,'932',16.667,1),(703,7613136,7613131,'320',16.667,1),(703,7613137,7613131,'204',16.667,1),(703,7613138,7613131,'044',16.667,1),(703,7613139,7613131,'449',16.667,1),(703,7613140,7613134,'cac',33.333,3),(703,7613141,7613134,'ach',33.333,3),(703,7613142,7613134,'che',33.333,3),(703,7613143,7613140,'sta',33.333,2),(703,7613144,7613140,'tat',33.333,2),(703,7613145,7613140,'ate',33.333,2),(703,7613146,7613143,'dis',16.667,2),(703,7613147,7613143,'isa',16.667,2),(703,7613148,7613143,'sab',16.667,2),(703,7613149,7613143,'abl',16.667,2),(703,7613150,7613143,'ble',16.667,2),(703,7613151,7613143,'led',16.667,2),(703,7613152,7613146,'ope',11.111,2),(703,7613153,7613146,'per',11.111,2),(703,7613154,7613146,'era',11.111,2),(703,7613155,7613146,'rat',11.111,2),(703,7613156,7613146,'ati',11.111,2),(703,7613157,7613146,'tio',11.111,2),(703,7613158,7613146,'ion',11.111,2),(703,7613159,7613146,'ona',11.111,2),(703,7613160,7613146,'nal',11.111,2),(703,7613161,7613152,'mod',50,2),(703,7613162,7613152,'ode',50,2),(703,7613163,7613161,'wri',14.286,2),(703,7613164,7613161,'rit',14.286,2),(703,7613165,7613161,'ite',14.286,2),(703,7613166,7613161,'tet',14.286,2),(703,7613167,7613161,'eth',14.286,2),(703,7613168,7613161,'thr',14.286,2),(703,7613169,7613161,'hru',14.286,2),(703,7613170,7613163,'mes',20,1),(703,7613171,7613163,'ess',20,1),(703,7613172,7613163,'ssa',20,1),(703,7613173,7613163,'sag',20,1),(703,7613174,7613163,'age',20,1),(703,7613175,7613170,'met',20,3),(703,7613176,7613170,'etr',20,3),(703,7613177,7613170,'tri',20,3),(703,7613178,7613170,'ric',20,3),(703,7613179,7613170,'ics',20,3),(703,7613180,7613175,'ena',20,1),(703,7613181,7613175,'nab',20,1),(703,7613182,7613175,'abl',20,1),(703,7613183,7613175,'ble',20,1),(703,7613184,7613175,'led',20,1),(703,7613185,7613180,'vir',20,1),(703,7613186,7613180,'irt',20,1),(703,7613187,7613180,'rtu',20,1),(703,7613188,7613180,'tua',20,1),(703,7613189,7613180,'ual',20,1),(703,7613190,7613185,'dis',50,1),(703,7613191,7613185,'isk',50,1),(1,7621434,7621433,'rtp',100,1),(1,7621435,7621434,'use',16.667,1),(1,7621436,7621434,'ser',16.667,1),(1,7621437,7621434,'ern',16.667,1),(1,7621438,7621434,'rna',16.667,1),(1,7621439,7621434,'nam',16.667,1),(1,7621440,7621434,'ame',16.667,1),(1,7621441,7621435,'adm',9.091,1),(1,7621442,7621435,'dmi',9.091,1),(1,7621443,7621435,'min',9.091,1),(1,7621444,7621435,'ini',9.091,1),(1,7621445,7621435,'nis',9.091,1),(1,7621446,7621435,'ist',9.091,1),(1,7621447,7621435,'str',9.091,1),(1,7621448,7621435,'tra',9.091,1),(1,7621449,7621435,'rat',9.091,1),(1,7621450,7621435,'ato',9.091,1),(1,7621451,7621435,'tor',9.091,1),(1,7621452,7621441,'pas',16.667,1),(1,7621453,7621441,'ass',16.667,1),(1,7621454,7621441,'ssw',16.667,1),(1,7621455,7621441,'swo',16.667,1),(1,7621456,7621441,'wor',16.667,1),(1,7621457,7621441,'ord',16.667,1),(1,7621458,7621452,'net',20,1),(1,7621459,7621452,'eta',20,1),(1,7621460,7621452,'tap',20,1),(1,7621461,7621452,'app',20,1),(1,7621462,7621452,'pp1',20,1),(1,7621463,7621458,'red',12.5,1),(1,7621464,7621458,'edi',12.5,1),(1,7621465,7621458,'dis',12.5,1),(1,7621466,7621458,'isc',12.5,1),(1,7621467,7621458,'sco',12.5,1),(1,7621468,7621458,'cov',12.5,1),(1,7621469,7621458,'ove',12.5,1),(1,7621470,7621458,'ver',12.5,1),(1,7621471,7621463,'sta',25,1),(1,7621472,7621463,'tat',25,1),(1,7621473,7621463,'atu',25,1),(1,7621474,7621463,'tus',25,1),(1,7621475,7621471,'hos',16.667,1),(1,7621476,7621471,'ost',16.667,1),(1,7621477,7621471,'stn',16.667,1),(1,7621478,7621471,'tna',16.667,1),(1,7621479,7621471,'nam',16.667,1),(1,7621480,7621471,'ame',16.667,1),(1,7621481,7621475,'hgv',11.111,1),(1,7621482,7621475,'gvc',11.111,1),(1,7621483,7621475,'vce',11.111,1),(1,7621484,7621475,'cen',11.111,1),(1,7621485,7621475,'ent',11.111,1),(1,7621486,7621475,'nte',11.111,1),(1,7621487,7621475,'ter',11.111,1),(1,7621488,7621475,'er0',11.111,1),(1,7621489,7621475,'r01',11.111,1),(1,7621490,7621481,'gdl',100,1),(1,7621491,7621490,'eng',25,1),(1,7621492,7621490,'ngl',25,1),(1,7621493,7621490,'gla',25,1),(1,7621494,7621490,'lab',25,1),(1,7621495,7621491,'net',25,1),(1,7621496,7621491,'eta',25,1),(1,7621497,7621491,'tap',25,1),(1,7621498,7621491,'app',25,1),(1,7621499,7621495,'com',100,1);
/*!40000 ALTER TABLE `fuzzysearch_default_fuzzysearch_index_search_api_viewed` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fuzzysearch_default_fuzzysearch_index_status`
--

DROP TABLE IF EXISTS `fuzzysearch_default_fuzzysearch_index_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fuzzysearch_default_fuzzysearch_index_status` (
  `item_id` int(11) NOT NULL COMMENT 'The primary identifier of the entity.',
  `value` tinyint(4) DEFAULT NULL COMMENT 'The field’s value for this item.',
  PRIMARY KEY (`item_id`),
  KEY `value` (`value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fuzzysearch_default_fuzzysearch_index_status`
--

LOCK TABLES `fuzzysearch_default_fuzzysearch_index_status` WRITE;
/*!40000 ALTER TABLE `fuzzysearch_default_fuzzysearch_index_status` DISABLE KEYS */;
INSERT INTO `fuzzysearch_default_fuzzysearch_index_status` VALUES (1,1),(2,1),(3,1),(4,1),(5,1),(6,1),(7,1),(8,1),(9,1),(10,1),(11,1),(12,1),(13,1),(14,1),(15,1),(16,1),(17,1),(18,1),(19,1),(20,1),(21,1),(22,1),(23,1),(24,1),(25,1),(26,1),(27,1),(28,1),(29,1),(30,1),(31,1),(32,1),(33,1),(34,1),(35,1),(36,1),(37,1),(38,1),(39,1),(40,1),(41,1),(42,1),(43,1),(44,1),(45,1),(46,1),(47,1),(48,1),(49,1),(50,1),(51,1),(52,1),(53,1),(54,1),(55,1),(56,1),(57,1),(58,1),(59,1),(60,1),(61,1),(62,1),(63,1),(64,1),(65,1),(66,1),(67,1),(68,1),(69,1),(70,1),(71,1),(72,1),(73,1),(74,1),(75,1),(76,1),(77,1),(78,1),(79,1),(80,1),(81,1),(82,1),(83,1),(84,1),(85,1),(86,1),(87,1),(88,1),(89,1),(90,1),(91,1),(92,1),(93,1),(94,1),(95,1),(96,1),(97,1),(98,1),(99,1),(100,1),(101,1),(102,1),(103,1),(104,1),(105,1),(106,1),(107,1),(108,1),(109,1),(110,1),(111,1),(112,1),(113,1),(114,1),(115,1),(116,1),(117,1),(118,1),(119,1),(120,1),(121,1),(122,1),(123,1),(124,1),(125,1),(126,1),(127,1),(128,1),(129,1),(130,1),(131,1),(132,1),(133,1),(134,1),(135,1),(136,1),(137,1),(138,1),(139,1),(140,1),(141,1),(142,1),(143,1),(144,1),(145,1),(146,1),(147,1),(148,1),(149,1),(150,1),(151,1),(152,1),(153,1),(154,1),(155,1),(156,1),(157,1),(158,1),(159,1),(160,1),(161,1),(162,1),(163,1),(164,1),(165,1),(166,1),(167,1),(168,1),(169,1),(170,1),(171,1),(172,1),(173,1),(174,1),(175,1),(176,1),(177,1),(178,1),(179,1),(180,1),(181,1),(182,1),(183,1),(184,1),(185,1),(186,1),(187,1),(188,1),(189,1),(190,1),(191,1),(192,1),(193,1),(194,1),(195,1),(196,1),(197,1),(198,1),(199,1),(200,1),(201,1),(202,1),(203,1),(204,1),(205,1),(206,1),(207,1),(208,1),(209,1),(210,1),(211,1),(212,1),(213,1),(214,1),(215,1),(216,1),(217,1),(218,1),(219,1),(220,1),(221,1),(222,1),(223,1),(224,1),(225,1),(226,1),(227,1),(228,1),(229,1),(230,1),(231,1),(232,1),(233,1),(234,1),(235,1),(236,1),(237,1),(238,1),(239,1),(240,1),(241,1),(242,1),(243,1),(244,1),(245,1),(246,1),(247,1),(248,1),(249,1),(250,1),(251,1),(252,1),(253,1),(254,1),(255,1),(256,1),(257,1),(258,1),(259,1),(260,1),(261,1),(262,1),(263,1),(264,1),(265,1),(266,1),(267,1),(268,1),(269,1),(270,1),(271,1),(272,1),(273,1),(274,1),(275,1),(276,1),(277,1),(278,1),(279,1),(280,1),(281,1),(282,1),(283,1),(284,1),(285,1),(286,1),(287,1),(288,1),(289,1),(290,1),(291,1),(292,1),(293,1),(294,1),(295,1),(296,1),(297,1),(298,1),(299,1),(300,1),(301,1),(302,1),(303,1),(304,1),(305,1),(306,1),(307,1),(308,1),(309,1),(310,1),(311,1),(312,1),(313,1),(314,1),(315,1),(316,1),(317,1),(318,1),(319,1),(320,1),(321,1),(322,1),(323,1),(324,1),(325,1),(326,1),(327,1),(328,1),(329,1),(330,1),(331,1),(332,1),(333,1),(334,1),(335,1),(336,1),(337,1),(338,1),(339,1),(340,1),(341,1),(342,1),(343,1),(344,1),(345,1),(346,1),(347,1),(348,1),(349,1),(350,1),(351,1),(352,1),(353,1),(354,1),(355,1),(356,1),(357,1),(358,1),(359,1),(360,1),(361,1),(362,1),(363,1),(364,1),(365,1),(366,1),(367,1),(368,1),(369,1),(370,1),(371,1),(372,1),(373,1),(374,1),(375,1),(376,1),(377,1),(378,1),(379,1),(380,1),(381,1),(382,1),(383,1),(384,1),(385,1),(386,1),(387,1),(388,1),(389,1),(390,1),(391,1),(392,1),(393,1),(394,1),(395,1),(396,1),(397,1),(398,1),(399,1),(400,1),(401,1),(402,1),(403,1),(404,1),(405,1),(406,1),(407,1),(408,1),(409,1),(410,1),(411,1),(412,1),(413,1),(414,1),(415,1),(416,1),(417,1),(418,1),(419,1),(420,1),(421,1),(422,1),(423,1),(424,1),(425,1),(426,1),(427,1),(428,1),(429,1),(430,1),(431,1),(432,1),(433,1),(434,1),(435,1),(436,1),(437,1),(438,1),(439,1),(440,1),(441,1),(442,1),(443,1),(444,1),(445,1),(446,1),(447,1),(448,1),(449,1),(450,1),(451,1),(452,1),(453,1),(454,1),(455,1),(456,1),(457,1),(458,1),(459,1),(460,1),(461,1),(462,1),(463,1),(464,1),(465,1),(466,1),(467,1),(468,1),(469,1),(470,1),(471,1),(472,1),(473,1),(474,1),(475,1),(476,1),(477,1),(478,1),(479,1),(480,1),(481,1),(482,1),(483,1),(484,1),(485,1),(486,1),(487,1),(488,1),(489,1),(490,1),(491,1),(492,1),(493,1),(494,1),(495,1),(496,1),(497,1),(498,1),(499,1),(500,1),(501,1),(502,1),(503,1),(504,1),(505,1),(506,1),(507,1),(508,1),(509,1),(510,1),(511,1),(512,1),(513,1),(514,1),(515,1),(516,1),(517,1),(518,1),(519,1),(520,1),(521,1),(522,1),(523,1),(524,1),(525,1),(526,1),(527,1),(528,1),(529,1),(530,1),(531,1),(532,1),(533,1),(534,1),(535,1),(536,1),(537,1),(538,1),(539,1),(540,1),(541,1),(542,1),(543,1),(544,1),(545,1),(546,1),(547,1),(548,1),(549,1),(550,1),(551,1),(552,1),(553,1),(554,1),(555,1),(556,1),(557,1),(558,1),(559,1),(560,1),(561,1),(562,1),(563,1),(564,1),(565,1),(566,1),(567,1),(568,1),(569,1),(570,1),(571,1),(572,1),(573,1),(574,1),(575,1),(576,1),(577,1),(578,1),(579,1),(580,1),(581,1),(582,1),(583,1),(584,1),(585,1),(586,1),(587,1),(588,1),(589,1),(590,1),(591,1),(592,1),(593,1),(594,1),(595,1),(596,1),(597,1),(598,1),(599,1),(600,1),(601,1),(602,1),(603,1),(604,1),(605,1),(606,1),(607,1),(608,1),(609,1),(610,1),(611,1),(612,1),(613,1),(614,1),(615,1),(616,1),(617,1),(618,1),(619,1),(620,1),(621,1),(622,1),(623,1),(624,1),(625,1),(626,1),(627,1),(628,1),(629,1),(630,1),(631,1),(632,1),(633,1),(634,1),(635,1),(636,1),(637,1),(638,1),(639,1),(640,1),(641,1),(642,1),(643,1),(644,1),(645,1),(646,1),(647,1),(648,1),(649,1),(650,1),(651,1),(652,1),(653,1),(654,1),(655,1),(656,1),(657,1),(658,1),(659,1),(660,1),(661,1),(662,1),(663,1),(664,1),(665,1),(666,1),(667,1),(668,1),(669,1),(670,1),(671,1),(672,1),(673,1),(674,1),(675,1),(676,1),(677,1),(678,1),(679,1),(680,1),(681,1),(682,1),(683,1),(684,1),(685,1),(686,1),(687,1),(688,1),(689,1),(690,1),(691,1),(692,1),(693,1),(694,1),(695,1),(696,1),(697,1),(698,1),(699,1),(700,1),(701,1),(702,1),(703,1),(704,1),(705,1),(706,1),(707,1),(708,1),(709,1),(710,1),(711,1),(712,1),(713,1),(714,1),(715,1),(716,1),(717,1),(718,1),(719,1),(720,1),(721,1),(722,1),(723,1),(724,1),(725,1),(726,1),(727,1),(728,1),(729,1),(730,1),(731,1),(732,1),(733,1),(734,1),(735,1),(736,1),(737,1),(738,1),(739,1),(740,1),(741,1),(742,1),(743,1),(744,1),(745,1),(746,1),(747,1),(748,1),(749,1),(750,1),(751,1),(752,1),(753,1),(754,1),(755,1),(756,1),(757,1),(758,1),(759,1),(760,1),(761,1),(762,1),(763,1),(764,1),(765,1),(766,1),(767,1),(768,1),(769,1),(770,1),(771,1),(772,1),(773,1),(774,1),(775,1),(776,1),(777,1),(778,1),(779,1),(780,1),(781,1),(782,1),(783,1),(784,1),(785,1),(786,1),(787,1),(788,1),(789,1),(790,1),(791,1),(792,1),(793,1),(794,1),(795,1),(796,1),(797,1),(798,1),(799,1),(800,1),(801,1),(802,1),(803,1),(804,1),(805,1),(806,1),(807,1),(808,1),(809,1),(810,1),(811,1),(812,1),(813,1),(814,1),(815,1),(816,1),(817,1),(818,1),(819,1),(820,1),(821,1),(822,1),(823,1),(824,1),(825,1),(826,1),(827,1),(828,1),(829,1),(830,1),(831,1),(832,1),(833,1),(834,1),(835,1),(836,1),(837,1),(838,1),(839,1),(840,1),(841,1),(842,1),(843,1),(844,1),(845,1),(846,1),(847,1),(848,1),(849,1),(850,1),(851,1),(852,1),(853,1),(854,1),(855,1),(856,1),(857,1),(858,1),(859,1),(860,1),(861,1),(862,1),(863,1),(864,1),(865,1),(866,1),(867,1),(868,1),(869,1),(870,1),(871,1),(872,1),(873,1),(874,1),(875,1),(876,1),(877,1),(878,1),(879,1),(880,1),(881,1),(882,1),(883,1),(884,1),(885,1),(886,1),(887,1),(888,1),(889,1),(890,1),(891,1),(892,1),(893,1),(894,1),(895,1),(896,1),(897,1),(898,1),(899,1),(900,1),(901,1),(902,1),(903,1),(904,1),(905,1),(906,1),(907,1),(908,1),(909,1),(910,1),(911,1),(912,1),(913,1),(914,1),(915,1),(916,1),(917,1),(918,1),(919,1),(920,1),(921,1),(922,1),(923,1),(924,1),(925,1),(926,1),(927,1),(928,1),(929,1),(930,1),(931,1),(932,1),(933,1),(934,1),(935,1),(936,1),(937,1),(938,1),(939,1),(940,1),(941,1),(942,1),(943,1),(944,1),(945,1),(946,1),(947,1),(948,1),(949,1),(950,1),(951,1),(952,1),(953,1),(954,1),(955,1),(956,1),(957,1),(958,1),(959,1),(960,1),(961,1),(962,1),(963,1),(964,1),(965,1),(966,1),(967,1),(968,1),(969,1),(970,1),(971,1),(972,1),(973,1),(974,1),(975,1),(976,1),(977,1),(978,1),(979,1),(980,1),(981,1),(982,1),(983,1),(984,1),(985,1),(986,1),(987,1),(988,1),(989,1),(990,1),(991,1),(992,1),(993,1),(994,1),(995,1),(996,1),(997,1),(998,1),(999,1),(1000,1),(1001,1),(1002,1),(1003,1),(1004,1),(1005,1),(1006,1),(1007,1),(1008,1),(1009,1),(1010,1),(1011,1),(1012,1),(1013,1),(1014,1),(1015,1),(1016,1),(1017,1),(1018,1),(1019,1),(1020,1),(1021,1),(1022,1),(1023,1),(1024,1),(1025,1),(1026,1),(1027,1),(1028,1),(1029,1),(1030,1),(1031,1),(1032,1),(1033,1),(1034,1),(1035,1),(1036,1),(1037,1),(1038,1),(1039,1),(1040,1),(1041,1),(1042,1),(1043,1),(1044,1),(1045,1),(1046,1),(1047,1),(1048,1),(1049,1),(1050,1),(1051,1),(1052,1),(1053,1),(1054,1),(1055,1),(1056,1),(1057,1),(1058,1),(1059,1),(1060,1),(1061,1),(1062,1),(1063,1),(1064,1),(1065,1),(1066,1),(1067,1),(1068,1),(1069,1),(1070,1),(1071,1),(1072,1),(1073,1),(1074,1),(1075,1),(1076,1),(1077,1),(1078,1),(1079,1),(1080,1),(1081,1),(1082,1),(1083,1),(1084,1),(1085,1),(1086,1),(1087,1),(1088,1),(1089,1),(1090,1),(1091,1),(1092,1),(1093,1),(1094,1),(1095,1),(1096,1),(1097,1),(1098,1),(1099,1),(1100,1),(1101,1),(1102,1),(1103,1),(1104,1),(1105,1),(1106,1),(1107,1),(1108,1),(1109,1),(1110,1),(1111,1),(1112,1),(1113,1),(1114,1),(1115,1),(1116,1),(1117,1),(1118,1),(1119,1),(1120,1),(1121,1),(1122,1);
/*!40000 ALTER TABLE `fuzzysearch_default_fuzzysearch_index_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fuzzysearch_default_fuzzysearch_index_title`
--

DROP TABLE IF EXISTS `fuzzysearch_default_fuzzysearch_index_title`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fuzzysearch_default_fuzzysearch_index_title` (
  `item_id` int(11) NOT NULL COMMENT 'The primary identifier of the entity.',
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The ngram id.',
  `word_id` int(10) unsigned NOT NULL COMMENT 'The word id.',
  `ngram` varchar(50) NOT NULL COMMENT 'The ngram.',
  `completeness` float NOT NULL COMMENT 'Completeness',
  `score` float NOT NULL COMMENT 'The score associated with this ngram.',
  PRIMARY KEY (`id`),
  KEY `ngram` (`ngram`(10)),
  KEY `completeness` (`completeness`)
) ENGINE=MyISAM AUTO_INCREMENT=40203 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fuzzysearch_default_fuzzysearch_index_title`
--

LOCK TABLES `fuzzysearch_default_fuzzysearch_index_title` WRITE;
/*!40000 ALTER TABLE `fuzzysearch_default_fuzzysearch_index_title` DISABLE KEYS */;
INSERT INTO `fuzzysearch_default_fuzzysearch_index_title` VALUES (7,51,50,'hgr',16.667,5),(7,52,50,'grx',16.667,5),(7,53,50,'rx6',16.667,5),(7,54,50,'x60',16.667,5),(7,55,50,'600',16.667,5),(7,56,50,'001',16.667,5),(7,57,51,'gdl',100,5),(7,58,57,'eng',25,5),(7,59,57,'ngl',25,5),(7,60,57,'gla',25,5),(7,61,57,'lab',25,5),(7,62,58,'net',25,5),(7,63,58,'eta',25,5),(7,64,58,'tap',25,5),(7,65,58,'app',25,5),(7,66,62,'com',100,5),(8,68,67,'net',25,5),(8,69,67,'eta',25,5),(8,70,67,'tap',25,5),(8,71,67,'app',25,5),(8,72,68,'fib',33.333,5),(8,73,68,'ibr',33.333,5),(8,74,68,'bre',33.333,5),(8,75,72,'cha',20,5),(8,76,72,'han',20,5),(8,77,72,'ann',20,5),(8,78,72,'nne',20,5),(8,79,72,'nel',20,5),(8,80,75,'dis',50,5),(8,81,75,'isk',50,5),(8,82,80,'naa',100,5),(8,83,82,'600',3.333,5),(8,84,82,'00a',3.333,5),(8,85,82,'0a0',3.333,5),(8,86,82,'a09',3.333,5),(8,87,82,'098',3.333,5),(8,88,82,'980',3.333,5),(8,89,82,'804',3.333,5),(8,90,82,'044',3.333,5),(8,91,82,'443',3.333,5),(8,92,82,'430',3.333,5),(8,93,82,'307',3.333,5),(8,94,82,'072',3.333,5),(8,95,82,'725',3.333,5),(8,96,82,'259',3.333,5),(8,97,82,'593',3.333,5),(8,98,82,'931',3.333,5),(8,99,82,'313',3.333,5),(8,100,82,'13f',3.333,5),(8,101,82,'3f3',3.333,5),(8,102,82,'f33',3.333,5),(8,103,82,'334',3.333,5),(8,104,82,'345',3.333,5),(8,105,82,'455',3.333,5),(8,106,82,'556',3.333,5),(8,107,82,'563',3.333,5),(8,108,82,'639',3.333,5),(8,109,82,'393',3.333,5),(8,110,82,'934',3.333,5),(8,111,82,'346',3.333,5),(8,112,82,'464',3.333,5),(9,114,113,'net',25,5),(9,115,113,'eta',25,5),(9,116,113,'tap',25,5),(9,117,113,'app',25,5),(9,118,114,'ser',25,5),(9,119,114,'eri',25,5),(9,120,114,'ria',25,5),(9,121,114,'ial',25,5),(9,122,118,'att',16.667,5),(9,123,118,'tta',16.667,5),(9,124,118,'tac',16.667,5),(9,125,118,'ach',16.667,5),(9,126,118,'che',16.667,5),(9,127,118,'hed',16.667,5),(9,128,122,'scs',50,5),(9,129,122,'csi',50,5),(9,130,128,'dis',50,5),(9,131,128,'isk',50,5),(9,132,130,'naa',100,5),(9,133,132,'600',3.333,5),(9,134,132,'00a',3.333,5),(9,135,132,'0a0',3.333,5),(9,136,132,'a09',3.333,5),(9,137,132,'098',3.333,5),(9,138,132,'980',3.333,5),(9,139,132,'80c',3.333,5),(9,140,132,'0c6',3.333,5),(9,141,132,'c66',3.333,5),(9,142,132,'667',3.333,5),(9,143,132,'678',3.333,5),(9,144,132,'784',3.333,5),(9,145,132,'84e',3.333,5),(9,146,132,'4ee',3.333,5),(9,147,132,'ee9',3.333,5),(9,148,132,'e99',3.333,5),(9,149,132,'99b',3.333,5),(9,150,132,'9b0',3.333,5),(9,151,132,'b04',3.333,5),(9,152,132,'04d',3.333,5),(9,153,132,'4d1',3.333,5),(9,154,132,'d11',3.333,5),(9,155,132,'117',3.333,5),(9,156,132,'17b',3.333,5),(9,157,132,'7b0',3.333,5),(9,158,132,'b0b',3.333,5),(9,159,132,'0ba',3.333,5),(9,160,132,'bab',3.333,5),(9,161,132,'aba',3.333,5),(9,162,132,'ba2',3.333,5),(10,164,163,'net',25,5),(10,165,163,'eta',25,5),(10,166,163,'tap',25,5),(10,167,163,'app',25,5),(10,168,164,'fib',33.333,5),(10,169,164,'ibr',33.333,5),(10,170,164,'bre',33.333,5),(10,171,168,'cha',20,5),(10,172,168,'han',20,5),(10,173,168,'ann',20,5),(10,174,168,'nne',20,5),(10,175,168,'nel',20,5),(10,176,171,'dis',50,5),(10,177,171,'isk',50,5),(10,178,176,'naa',100,5),(10,179,178,'600',3.333,5),(10,180,178,'00a',3.333,5),(10,181,178,'0a0',3.333,5),(10,182,178,'a09',3.333,5),(10,183,178,'098',3.333,5),(10,184,178,'980',3.333,5),(10,185,178,'804',3.333,5),(10,186,178,'044',3.333,5),(10,187,178,'443',3.333,5),(10,188,178,'430',3.333,5),(10,189,178,'307',3.333,5),(10,190,178,'072',3.333,5),(10,191,178,'725',3.333,5),(10,192,178,'259',3.333,5),(10,193,178,'593',3.333,5),(10,194,178,'931',3.333,5),(10,195,178,'313',3.333,5),(10,196,178,'13f',3.333,5),(10,197,178,'3f3',3.333,5),(10,198,178,'f33',3.333,5),(10,199,178,'334',3.333,5),(10,200,178,'345',3.333,5),(10,201,178,'455',3.333,5),(10,202,178,'556',3.333,5),(10,203,178,'563',3.333,5),(10,204,178,'639',3.333,5),(10,205,178,'393',3.333,5),(10,206,178,'934',3.333,5),(10,207,178,'346',3.333,5),(10,208,178,'465',3.333,5),(11,210,209,'net',25,5),(11,211,209,'eta',25,5),(11,212,209,'tap',25,5),(11,213,209,'app',25,5),(11,214,210,'fib',33.333,5),(11,215,210,'ibr',33.333,5),(11,216,210,'bre',33.333,5),(11,217,214,'cha',20,5),(11,218,214,'han',20,5),(11,219,214,'ann',20,5),(11,220,214,'nne',20,5),(11,221,214,'nel',20,5),(11,222,217,'dis',50,5),(11,223,217,'isk',50,5),(11,224,222,'naa',100,5),(11,225,224,'600',3.333,5),(11,226,224,'00a',3.333,5),(11,227,224,'0a0',3.333,5),(11,228,224,'a09',3.333,5),(11,229,224,'098',3.333,5),(11,230,224,'980',3.333,5),(11,231,224,'804',3.333,5),(11,232,224,'044',3.333,5),(11,233,224,'443',3.333,5),(11,234,224,'430',3.333,5),(11,235,224,'307',3.333,5),(11,236,224,'072',3.333,5),(11,237,224,'725',3.333,5),(11,238,224,'259',3.333,5),(11,239,224,'593',3.333,5),(11,240,224,'931',3.333,5),(11,241,224,'313',3.333,5),(11,242,224,'13f',3.333,5),(11,243,224,'3f3',3.333,5),(11,244,224,'f33',3.333,5),(11,245,224,'334',3.333,5),(11,246,224,'345',3.333,5),(11,247,224,'455',3.333,5),(11,248,224,'556',3.333,5),(11,249,224,'563',3.333,5),(11,250,224,'639',3.333,5),(11,251,224,'393',3.333,5),(11,252,224,'934',3.333,5),(11,253,224,'346',3.333,5),(11,254,224,'466',3.333,5),(12,256,255,'net',25,5),(12,257,255,'eta',25,5),(12,258,255,'tap',25,5),(12,259,255,'app',25,5),(12,260,256,'fib',33.333,5),(12,261,256,'ibr',33.333,5),(12,262,256,'bre',33.333,5),(12,263,260,'cha',20,5),(12,264,260,'han',20,5),(12,265,260,'ann',20,5),(12,266,260,'nne',20,5),(12,267,260,'nel',20,5),(12,268,263,'dis',50,5),(12,269,263,'isk',50,5),(12,270,268,'naa',100,5),(12,271,270,'600',3.333,5),(12,272,270,'00a',3.333,5),(12,273,270,'0a0',3.333,5),(12,274,270,'a09',3.333,5),(12,275,270,'098',3.333,5),(12,276,270,'980',3.333,5),(12,277,270,'804',3.333,5),(12,278,270,'044',3.333,5),(12,279,270,'443',3.333,5),(12,280,270,'430',3.333,5),(12,281,270,'307',3.333,5),(12,282,270,'072',3.333,5),(12,283,270,'725',3.333,5),(12,284,270,'259',3.333,5),(12,285,270,'593',3.333,5),(12,286,270,'931',3.333,5),(12,287,270,'313',3.333,5),(12,288,270,'13f',3.333,5),(12,289,270,'3f3',3.333,5),(12,290,270,'f33',3.333,5),(12,291,270,'334',3.333,5),(12,292,270,'345',3.333,5),(12,293,270,'455',3.333,5),(12,294,270,'556',3.333,5),(12,295,270,'563',3.333,5),(12,296,270,'639',3.333,5),(12,297,270,'393',3.333,5),(12,298,270,'934',3.333,5),(12,299,270,'346',3.333,5),(12,300,270,'467',3.333,5),(13,302,301,'net',25,5),(13,303,301,'eta',25,5),(13,304,301,'tap',25,5),(13,305,301,'app',25,5),(13,306,302,'fib',33.333,5),(13,307,302,'ibr',33.333,5),(13,308,302,'bre',33.333,5),(13,309,306,'cha',20,5),(13,310,306,'han',20,5),(13,311,306,'ann',20,5),(13,312,306,'nne',20,5),(13,313,306,'nel',20,5),(13,314,309,'dis',50,5),(13,315,309,'isk',50,5),(13,316,314,'naa',100,5),(13,317,316,'600',3.333,5),(13,318,316,'00a',3.333,5),(13,319,316,'0a0',3.333,5),(13,320,316,'a09',3.333,5),(13,321,316,'098',3.333,5),(13,322,316,'980',3.333,5),(13,323,316,'804',3.333,5),(13,324,316,'044',3.333,5),(13,325,316,'443',3.333,5),(13,326,316,'430',3.333,5),(13,327,316,'307',3.333,5),(13,328,316,'072',3.333,5),(13,329,316,'725',3.333,5),(13,330,316,'259',3.333,5),(13,331,316,'593',3.333,5),(13,332,316,'931',3.333,5),(13,333,316,'313',3.333,5),(13,334,316,'13f',3.333,5),(13,335,316,'3f3',3.333,5),(13,336,316,'f33',3.333,5),(13,337,316,'334',3.333,5),(13,338,316,'345',3.333,5),(13,339,316,'455',3.333,5),(13,340,316,'556',3.333,5),(13,341,316,'563',3.333,5),(13,342,316,'639',3.333,5),(13,343,316,'393',3.333,5),(13,344,316,'934',3.333,5),(13,345,316,'346',3.333,5),(13,346,316,'468',3.333,5),(14,348,347,'net',25,5),(14,349,347,'eta',25,5),(14,350,347,'tap',25,5),(14,351,347,'app',25,5),(14,352,348,'fib',33.333,5),(14,353,348,'ibr',33.333,5),(14,354,348,'bre',33.333,5),(14,355,352,'cha',20,5),(14,356,352,'han',20,5),(14,357,352,'ann',20,5),(14,358,352,'nne',20,5),(14,359,352,'nel',20,5),(14,360,355,'dis',50,5),(14,361,355,'isk',50,5),(14,362,360,'naa',100,5),(14,363,362,'600',3.333,5),(14,364,362,'00a',3.333,5),(14,365,362,'0a0',3.333,5),(14,366,362,'a09',3.333,5),(14,367,362,'098',3.333,5),(14,368,362,'980',3.333,5),(14,369,362,'804',3.333,5),(14,370,362,'044',3.333,5),(14,371,362,'443',3.333,5),(14,372,362,'430',3.333,5),(14,373,362,'307',3.333,5),(14,374,362,'072',3.333,5),(14,375,362,'725',3.333,5),(14,376,362,'259',3.333,5),(14,377,362,'593',3.333,5),(14,378,362,'931',3.333,5),(14,379,362,'313',3.333,5),(14,380,362,'13f',3.333,5),(14,381,362,'3f3',3.333,5),(14,382,362,'f33',3.333,5),(14,383,362,'334',3.333,5),(14,384,362,'345',3.333,5),(14,385,362,'455',3.333,5),(14,386,362,'556',3.333,5),(14,387,362,'563',3.333,5),(14,388,362,'639',3.333,5),(14,389,362,'393',3.333,5),(14,390,362,'934',3.333,5),(14,391,362,'346',3.333,5),(14,392,362,'469',3.333,5),(15,394,393,'net',25,5),(15,395,393,'eta',25,5),(15,396,393,'tap',25,5),(15,397,393,'app',25,5),(15,398,394,'fib',33.333,5),(15,399,394,'ibr',33.333,5),(15,400,394,'bre',33.333,5),(15,401,398,'cha',20,5),(15,402,398,'han',20,5),(15,403,398,'ann',20,5),(15,404,398,'nne',20,5),(15,405,398,'nel',20,5),(15,406,401,'dis',50,5),(15,407,401,'isk',50,5),(15,408,406,'naa',100,5),(15,409,408,'600',3.333,5),(15,410,408,'00a',3.333,5),(15,411,408,'0a0',3.333,5),(15,412,408,'a09',3.333,5),(15,413,408,'098',3.333,5),(15,414,408,'980',3.333,5),(15,415,408,'804',3.333,5),(15,416,408,'044',3.333,5),(15,417,408,'443',3.333,5),(15,418,408,'430',3.333,5),(15,419,408,'307',3.333,5),(15,420,408,'072',3.333,5),(15,421,408,'725',3.333,5),(15,422,408,'259',3.333,5),(15,423,408,'593',3.333,5),(15,424,408,'931',3.333,5),(15,425,408,'313',3.333,5),(15,426,408,'13f',3.333,5),(15,427,408,'3f3',3.333,5),(15,428,408,'f33',3.333,5),(15,429,408,'334',3.333,5),(15,430,408,'345',3.333,5),(15,431,408,'455',3.333,5),(15,432,408,'556',3.333,5),(15,433,408,'563',3.333,5),(15,434,408,'639',3.333,5),(15,435,408,'393',3.333,5),(15,436,408,'934',3.333,5),(15,437,408,'342',3.333,5),(15,438,408,'42d',3.333,5),(16,440,439,'net',25,5),(16,441,439,'eta',25,5),(16,442,439,'tap',25,5),(16,443,439,'app',25,5),(16,444,440,'fib',33.333,5),(16,445,440,'ibr',33.333,5),(16,446,440,'bre',33.333,5),(16,447,444,'cha',20,5),(16,448,444,'han',20,5),(16,449,444,'ann',20,5),(16,450,444,'nne',20,5),(16,451,444,'nel',20,5),(16,452,447,'dis',50,5),(16,453,447,'isk',50,5),(16,454,452,'naa',100,5),(16,455,454,'600',3.333,5),(16,456,454,'00a',3.333,5),(16,457,454,'0a0',3.333,5),(16,458,454,'a09',3.333,5),(16,459,454,'098',3.333,5),(16,460,454,'980',3.333,5),(16,461,454,'804',3.333,5),(16,462,454,'044',3.333,5),(16,463,454,'443',3.333,5),(16,464,454,'430',3.333,5),(16,465,454,'307',3.333,5),(16,466,454,'072',3.333,5),(16,467,454,'725',3.333,5),(16,468,454,'259',3.333,5),(16,469,454,'593',3.333,5),(16,470,454,'931',3.333,5),(16,471,454,'313',3.333,5),(16,472,454,'13f',3.333,5),(16,473,454,'3f3',3.333,5),(16,474,454,'f33',3.333,5),(16,475,454,'334',3.333,5),(16,476,454,'345',3.333,5),(16,477,454,'455',3.333,5),(16,478,454,'556',3.333,5),(16,479,454,'563',3.333,5),(16,480,454,'639',3.333,5),(16,481,454,'393',3.333,5),(16,482,454,'934',3.333,5),(16,483,454,'342',3.333,5),(16,484,454,'42f',3.333,5),(17,486,485,'net',25,5),(17,487,485,'eta',25,5),(17,488,485,'tap',25,5),(17,489,485,'app',25,5),(17,490,486,'fib',33.333,5),(17,491,486,'ibr',33.333,5),(17,492,486,'bre',33.333,5),(17,493,490,'cha',20,5),(17,494,490,'han',20,5),(17,495,490,'ann',20,5),(17,496,490,'nne',20,5),(17,497,490,'nel',20,5),(17,498,493,'dis',50,5),(17,499,493,'isk',50,5),(17,500,498,'naa',100,5),(17,501,500,'600',3.333,5),(17,502,500,'00a',3.333,5),(17,503,500,'0a0',3.333,5),(17,504,500,'a09',3.333,5),(17,505,500,'098',3.333,5),(17,506,500,'980',3.333,5),(17,507,500,'804',3.333,5),(17,508,500,'044',3.333,5),(17,509,500,'443',3.333,5),(17,510,500,'430',3.333,5),(17,511,500,'307',3.333,5),(17,512,500,'072',3.333,5),(17,513,500,'725',3.333,5),(17,514,500,'259',3.333,5),(17,515,500,'593',3.333,5),(17,516,500,'931',3.333,5),(17,517,500,'313',3.333,5),(17,518,500,'13f',3.333,5),(17,519,500,'3f3',3.333,5),(17,520,500,'f33',3.333,5),(17,521,500,'334',3.333,5),(17,522,500,'345',3.333,5),(17,523,500,'455',3.333,5),(17,524,500,'556',3.333,5),(17,525,500,'563',3.333,5),(17,526,500,'639',3.333,5),(17,527,500,'393',3.333,5),(17,528,500,'934',3.333,5),(17,529,500,'346',3.333,5),(17,530,500,'46a',3.333,5),(18,532,531,'net',25,5),(18,533,531,'eta',25,5),(18,534,531,'tap',25,5),(18,535,531,'app',25,5),(18,536,532,'fib',33.333,5),(18,537,532,'ibr',33.333,5),(18,538,532,'bre',33.333,5),(18,539,536,'cha',20,5),(18,540,536,'han',20,5),(18,541,536,'ann',20,5),(18,542,536,'nne',20,5),(18,543,536,'nel',20,5),(18,544,539,'dis',50,5),(18,545,539,'isk',50,5),(18,546,544,'naa',100,5),(18,547,546,'600',3.333,5),(18,548,546,'00a',3.333,5),(18,549,546,'0a0',3.333,5),(18,550,546,'a09',3.333,5),(18,551,546,'098',3.333,5),(18,552,546,'980',3.333,5),(18,553,546,'804',3.333,5),(18,554,546,'044',3.333,5),(18,555,546,'443',3.333,5),(18,556,546,'430',3.333,5),(18,557,546,'307',3.333,5),(18,558,546,'072',3.333,5),(18,559,546,'725',3.333,5),(18,560,546,'259',3.333,5),(18,561,546,'593',3.333,5),(18,562,546,'931',3.333,5),(18,563,546,'313',3.333,5),(18,564,546,'13f',3.333,5),(18,565,546,'3f3',3.333,5),(18,566,546,'f33',3.333,5),(18,567,546,'334',3.333,5),(18,568,546,'345',3.333,5),(18,569,546,'455',3.333,5),(18,570,546,'556',3.333,5),(18,571,546,'563',3.333,5),(18,572,546,'639',3.333,5),(18,573,546,'393',3.333,5),(18,574,546,'934',3.333,5),(18,575,546,'346',3.333,5),(18,576,546,'46b',3.333,5),(19,578,577,'net',25,5),(19,579,577,'eta',25,5),(19,580,577,'tap',25,5),(19,581,577,'app',25,5),(19,582,578,'ser',25,5),(19,583,578,'eri',25,5),(19,584,578,'ria',25,5),(19,585,578,'ial',25,5),(19,586,582,'att',16.667,5),(19,587,582,'tta',16.667,5),(19,588,582,'tac',16.667,5),(19,589,582,'ach',16.667,5),(19,590,582,'che',16.667,5),(19,591,582,'hed',16.667,5),(19,592,586,'scs',50,5),(19,593,586,'csi',50,5),(19,594,592,'dis',50,5),(19,595,592,'isk',50,5),(19,596,594,'naa',100,5),(19,597,596,'600',3.333,5),(19,598,596,'00a',3.333,5),(19,599,596,'0a0',3.333,5),(19,600,596,'a09',3.333,5),(19,601,596,'098',3.333,5),(19,602,596,'980',3.333,5),(19,603,596,'801',3.333,5),(19,604,596,'016',3.333,5),(19,605,596,'167',3.333,5),(19,606,596,'677',3.333,5),(19,607,596,'778',3.333,5),(19,608,596,'784',3.333,5),(19,609,596,'84e',3.333,5),(19,610,596,'4ee',3.333,5),(19,611,596,'eec',3.333,5),(19,612,596,'ec4',3.333,5),(19,613,596,'c4d',3.333,5),(19,614,596,'4d3',3.333,5),(19,615,596,'d34',3.333,5),(19,616,596,'341',3.333,5),(19,617,596,'411',3.333,5),(19,618,596,'111',3.333,5),(19,619,596,'117',3.333,5),(19,620,596,'17b',3.333,5),(19,621,596,'7b0',3.333,5),(19,622,596,'b0d',3.333,5),(19,623,596,'0da',3.333,5),(19,624,596,'dab',3.333,5),(19,625,596,'aba',3.333,5),(19,626,596,'ba2',3.333,5),(20,628,627,'net',25,5),(20,629,627,'eta',25,5),(20,630,627,'tap',25,5),(20,631,627,'app',25,5),(20,632,628,'fib',33.333,5),(20,633,628,'ibr',33.333,5),(20,634,628,'bre',33.333,5),(20,635,632,'cha',20,5),(20,636,632,'han',20,5),(20,637,632,'ann',20,5),(20,638,632,'nne',20,5),(20,639,632,'nel',20,5),(20,640,635,'dis',50,5),(20,641,635,'isk',50,5),(20,642,640,'naa',100,5),(20,643,642,'600',3.333,5),(20,644,642,'00a',3.333,5),(20,645,642,'0a0',3.333,5),(20,646,642,'a09',3.333,5),(20,647,642,'098',3.333,5),(20,648,642,'980',3.333,5),(20,649,642,'804',3.333,5),(20,650,642,'044',3.333,5),(20,651,642,'443',3.333,5),(20,652,642,'430',3.333,5),(20,653,642,'307',3.333,5),(20,654,642,'072',3.333,5),(20,655,642,'725',3.333,5),(20,656,642,'259',3.333,5),(20,657,642,'593',3.333,5),(20,658,642,'931',3.333,5),(20,659,642,'313',3.333,5),(20,660,642,'13f',3.333,5),(20,661,642,'3f3',3.333,5),(20,662,642,'f33',3.333,5),(20,663,642,'334',3.333,5),(20,664,642,'345',3.333,5),(20,665,642,'455',3.333,5),(20,666,642,'556',3.333,5),(20,667,642,'563',3.333,5),(20,668,642,'639',3.333,5),(20,669,642,'393',3.333,5),(20,670,642,'934',3.333,5),(20,671,642,'346',3.333,5),(20,672,642,'46c',3.333,5),(21,674,673,'net',25,5),(21,675,673,'eta',25,5),(21,676,673,'tap',25,5),(21,677,673,'app',25,5),(21,678,674,'fib',33.333,5),(21,679,674,'ibr',33.333,5),(21,680,674,'bre',33.333,5),(21,681,678,'cha',20,5),(21,682,678,'han',20,5),(21,683,678,'ann',20,5),(21,684,678,'nne',20,5),(21,685,678,'nel',20,5),(21,686,681,'dis',50,5),(21,687,681,'isk',50,5),(21,688,686,'naa',100,5),(21,689,688,'600',3.333,5),(21,690,688,'00a',3.333,5),(21,691,688,'0a0',3.333,5),(21,692,688,'a09',3.333,5),(21,693,688,'098',3.333,5),(21,694,688,'980',3.333,5),(21,695,688,'804',3.333,5),(21,696,688,'044',3.333,5),(21,697,688,'443',3.333,5),(21,698,688,'430',3.333,5),(21,699,688,'307',3.333,5),(21,700,688,'072',3.333,5),(21,701,688,'725',3.333,5),(21,702,688,'259',3.333,5),(21,703,688,'593',3.333,5),(21,704,688,'931',3.333,5),(21,705,688,'313',3.333,5),(21,706,688,'13f',3.333,5),(21,707,688,'3f3',3.333,5),(21,708,688,'f33',3.333,5),(21,709,688,'334',3.333,5),(21,710,688,'345',3.333,5),(21,711,688,'455',3.333,5),(21,712,688,'556',3.333,5),(21,713,688,'563',3.333,5),(21,714,688,'639',3.333,5),(21,715,688,'393',3.333,5),(21,716,688,'934',3.333,5),(21,717,688,'346',3.333,5),(21,718,688,'46d',3.333,5),(22,720,719,'net',25,5),(22,721,719,'eta',25,5),(22,722,719,'tap',25,5),(22,723,719,'app',25,5),(22,724,720,'fib',33.333,5),(22,725,720,'ibr',33.333,5),(22,726,720,'bre',33.333,5),(22,727,724,'cha',20,5),(22,728,724,'han',20,5),(22,729,724,'ann',20,5),(22,730,724,'nne',20,5),(22,731,724,'nel',20,5),(22,732,727,'dis',50,5),(22,733,727,'isk',50,5),(22,734,732,'naa',100,5),(22,735,734,'600',3.333,5),(22,736,734,'00a',3.333,5),(22,737,734,'0a0',3.333,5),(22,738,734,'a09',3.333,5),(22,739,734,'098',3.333,5),(22,740,734,'980',3.333,5),(22,741,734,'804',3.333,5),(22,742,734,'044',3.333,5),(22,743,734,'443',3.333,5),(22,744,734,'430',3.333,5),(22,745,734,'307',3.333,5),(22,746,734,'072',3.333,5),(22,747,734,'725',3.333,5),(22,748,734,'259',3.333,5),(22,749,734,'593',3.333,5),(22,750,734,'931',3.333,5),(22,751,734,'313',3.333,5),(22,752,734,'13f',3.333,5),(22,753,734,'3f3',3.333,5),(22,754,734,'f33',3.333,5),(22,755,734,'334',3.333,5),(22,756,734,'345',3.333,5),(22,757,734,'455',3.333,5),(22,758,734,'556',3.333,5),(22,759,734,'563',3.333,5),(22,760,734,'639',3.333,5),(22,761,734,'393',3.333,5),(22,762,734,'934',3.333,5),(22,763,734,'346',3.333,5),(22,764,734,'46e',3.333,5),(23,766,765,'net',25,5),(23,767,765,'eta',25,5),(23,768,765,'tap',25,5),(23,769,765,'app',25,5),(23,770,766,'fib',33.333,5),(23,771,766,'ibr',33.333,5),(23,772,766,'bre',33.333,5),(23,773,770,'cha',20,5),(23,774,770,'han',20,5),(23,775,770,'ann',20,5),(23,776,770,'nne',20,5),(23,777,770,'nel',20,5),(23,778,773,'dis',50,5),(23,779,773,'isk',50,5),(23,780,778,'naa',100,5),(23,781,780,'600',3.333,5),(23,782,780,'00a',3.333,5),(23,783,780,'0a0',3.333,5),(23,784,780,'a09',3.333,5),(23,785,780,'098',3.333,5),(23,786,780,'980',3.333,5),(23,787,780,'804',3.333,5),(23,788,780,'044',3.333,5),(23,789,780,'443',3.333,5),(23,790,780,'430',3.333,5),(23,791,780,'307',3.333,5),(23,792,780,'072',3.333,5),(23,793,780,'725',3.333,5),(23,794,780,'259',3.333,5),(23,795,780,'593',3.333,5),(23,796,780,'931',3.333,5),(23,797,780,'313',3.333,5),(23,798,780,'13f',3.333,5),(23,799,780,'3f3',3.333,5),(23,800,780,'f33',3.333,5),(23,801,780,'334',3.333,5),(23,802,780,'345',3.333,5),(23,803,780,'455',3.333,5),(23,804,780,'556',3.333,5),(23,805,780,'563',3.333,5),(23,806,780,'639',3.333,5),(23,807,780,'393',3.333,5),(23,808,780,'934',3.333,5),(23,809,780,'346',3.333,5),(23,810,780,'46f',3.333,5),(24,812,811,'net',25,5),(24,813,811,'eta',25,5),(24,814,811,'tap',25,5),(24,815,811,'app',25,5),(24,816,812,'fib',33.333,5),(24,817,812,'ibr',33.333,5),(24,818,812,'bre',33.333,5),(24,819,816,'cha',20,5),(24,820,816,'han',20,5),(24,821,816,'ann',20,5),(24,822,816,'nne',20,5),(24,823,816,'nel',20,5),(24,824,819,'dis',50,5),(24,825,819,'isk',50,5),(24,826,824,'naa',100,5),(24,827,826,'600',3.333,5),(24,828,826,'00a',3.333,5),(24,829,826,'0a0',3.333,5),(24,830,826,'a09',3.333,5),(24,831,826,'098',3.333,5),(24,832,826,'980',3.333,5),(24,833,826,'804',3.333,5),(24,834,826,'044',3.333,5),(24,835,826,'443',3.333,5),(24,836,826,'430',3.333,5),(24,837,826,'307',3.333,5),(24,838,826,'075',3.333,5),(24,839,826,'753',3.333,5),(24,840,826,'535',3.333,5),(24,841,826,'357',3.333,5),(24,842,826,'573',3.333,5),(24,843,826,'732',3.333,5),(24,844,826,'32b',3.333,5),(24,845,826,'2b3',3.333,5),(24,846,826,'b33',3.333,5),(24,847,826,'334',3.333,5),(24,848,826,'345',3.333,5),(24,849,826,'457',3.333,5),(24,850,826,'571',3.333,5),(24,851,826,'715',3.333,5),(24,852,826,'153',3.333,5),(24,853,826,'533',3.333,5),(24,854,826,'336',3.333,5),(24,855,826,'363',3.333,5),(24,856,826,'630',3.333,5),(25,858,857,'net',25,5),(25,859,857,'eta',25,5),(25,860,857,'tap',25,5),(25,861,857,'app',25,5),(25,862,858,'fib',33.333,5),(25,863,858,'ibr',33.333,5),(25,864,858,'bre',33.333,5),(25,865,862,'cha',20,5),(25,866,862,'han',20,5),(25,867,862,'ann',20,5),(25,868,862,'nne',20,5),(25,869,862,'nel',20,5),(25,870,865,'dis',50,5),(25,871,865,'isk',50,5),(25,872,870,'naa',100,5),(25,873,872,'600',3.333,5),(25,874,872,'00a',3.333,5),(25,875,872,'0a0',3.333,5),(25,876,872,'a09',3.333,5),(25,877,872,'098',3.333,5),(25,878,872,'980',3.333,5),(25,879,872,'804',3.333,5),(25,880,872,'044',3.333,5),(25,881,872,'443',3.333,5),(25,882,872,'430',3.333,5),(25,883,872,'307',3.333,5),(25,884,872,'075',3.333,5),(25,885,872,'753',3.333,5),(25,886,872,'535',3.333,5),(25,887,872,'357',3.333,5),(25,888,872,'573',3.333,5),(25,889,872,'732',3.333,5),(25,890,872,'32b',3.333,5),(25,891,872,'2b3',3.333,5),(25,892,872,'b33',3.333,5),(25,893,872,'334',3.333,5),(25,894,872,'345',3.333,5),(25,895,872,'457',3.333,5),(25,896,872,'571',3.333,5),(25,897,872,'715',3.333,5),(25,898,872,'153',3.333,5),(25,899,872,'533',3.333,5),(25,900,872,'336',3.333,5),(25,901,872,'363',3.333,5),(25,902,872,'631',3.333,5),(26,904,903,'net',25,5),(26,905,903,'eta',25,5),(26,906,903,'tap',25,5),(26,907,903,'app',25,5),(26,908,904,'fib',33.333,5),(26,909,904,'ibr',33.333,5),(26,910,904,'bre',33.333,5),(26,911,908,'cha',20,5),(26,912,908,'han',20,5),(26,913,908,'ann',20,5),(26,914,908,'nne',20,5),(26,915,908,'nel',20,5),(26,916,911,'dis',50,5),(26,917,911,'isk',50,5),(26,918,916,'naa',100,5),(26,919,918,'600',3.333,5),(26,920,918,'00a',3.333,5),(26,921,918,'0a0',3.333,5),(26,922,918,'a09',3.333,5),(26,923,918,'098',3.333,5),(26,924,918,'980',3.333,5),(26,925,918,'804',3.333,5),(26,926,918,'044',3.333,5),(26,927,918,'443',3.333,5),(26,928,918,'430',3.333,5),(26,929,918,'307',3.333,5),(26,930,918,'075',3.333,5),(26,931,918,'753',3.333,5),(26,932,918,'535',3.333,5),(26,933,918,'357',3.333,5),(26,934,918,'573',3.333,5),(26,935,918,'732',3.333,5),(26,936,918,'32b',3.333,5),(26,937,918,'2b3',3.333,5),(26,938,918,'b33',3.333,5),(26,939,918,'334',3.333,5),(26,940,918,'345',3.333,5),(26,941,918,'457',3.333,5),(26,942,918,'571',3.333,5),(26,943,918,'715',3.333,5),(26,944,918,'153',3.333,5),(26,945,918,'533',3.333,5),(26,946,918,'336',3.333,5),(26,947,918,'363',3.333,5),(26,948,918,'632',3.333,5),(27,950,949,'net',25,5),(27,951,949,'eta',25,5),(27,952,949,'tap',25,5),(27,953,949,'app',25,5),(27,954,950,'fib',33.333,5),(27,955,950,'ibr',33.333,5),(27,956,950,'bre',33.333,5),(27,957,954,'cha',20,5),(27,958,954,'han',20,5),(27,959,954,'ann',20,5),(27,960,954,'nne',20,5),(27,961,954,'nel',20,5),(27,962,957,'dis',50,5),(27,963,957,'isk',50,5),(27,964,962,'naa',100,5),(27,965,964,'600',3.333,5),(27,966,964,'00a',3.333,5),(27,967,964,'0a0',3.333,5),(27,968,964,'a09',3.333,5),(27,969,964,'098',3.333,5),(27,970,964,'980',3.333,5),(27,971,964,'804',3.333,5),(27,972,964,'044',3.333,5),(27,973,964,'443',3.333,5),(27,974,964,'430',3.333,5),(27,975,964,'307',3.333,5),(27,976,964,'075',3.333,5),(27,977,964,'753',3.333,5),(27,978,964,'535',3.333,5),(27,979,964,'357',3.333,5),(27,980,964,'573',3.333,5),(27,981,964,'732',3.333,5),(27,982,964,'32b',3.333,5),(27,983,964,'2b3',3.333,5),(27,984,964,'b33',3.333,5),(27,985,964,'334',3.333,5),(27,986,964,'345',3.333,5),(27,987,964,'457',3.333,5),(27,988,964,'571',3.333,5),(27,989,964,'715',3.333,5),(27,990,964,'153',3.333,5),(27,991,964,'533',3.333,5),(27,992,964,'336',3.333,5),(27,993,964,'363',3.333,5),(27,994,964,'633',3.333,5),(28,996,995,'net',25,5),(28,997,995,'eta',25,5),(28,998,995,'tap',25,5),(28,999,995,'app',25,5),(28,1000,996,'fib',33.333,5),(28,1001,996,'ibr',33.333,5),(28,1002,996,'bre',33.333,5),(28,1003,1000,'cha',20,5),(28,1004,1000,'han',20,5),(28,1005,1000,'ann',20,5),(28,1006,1000,'nne',20,5),(28,1007,1000,'nel',20,5),(28,1008,1003,'dis',50,5),(28,1009,1003,'isk',50,5),(28,1010,1008,'naa',100,5),(28,1011,1010,'600',3.333,5),(28,1012,1010,'00a',3.333,5),(28,1013,1010,'0a0',3.333,5),(28,1014,1010,'a09',3.333,5),(28,1015,1010,'098',3.333,5),(28,1016,1010,'980',3.333,5),(28,1017,1010,'804',3.333,5),(28,1018,1010,'044',3.333,5),(28,1019,1010,'443',3.333,5),(28,1020,1010,'430',3.333,5),(28,1021,1010,'307',3.333,5),(28,1022,1010,'075',3.333,5),(28,1023,1010,'753',3.333,5),(28,1024,1010,'535',3.333,5),(28,1025,1010,'357',3.333,5),(28,1026,1010,'573',3.333,5),(28,1027,1010,'732',3.333,5),(28,1028,1010,'32b',3.333,5),(28,1029,1010,'2b3',3.333,5),(28,1030,1010,'b33',3.333,5),(28,1031,1010,'334',3.333,5),(28,1032,1010,'345',3.333,5),(28,1033,1010,'457',3.333,5),(28,1034,1010,'571',3.333,5),(28,1035,1010,'715',3.333,5),(28,1036,1010,'153',3.333,5),(28,1037,1010,'533',3.333,5),(28,1038,1010,'336',3.333,5),(28,1039,1010,'363',3.333,5),(28,1040,1010,'634',3.333,5),(29,1042,1041,'net',25,5),(29,1043,1041,'eta',25,5),(29,1044,1041,'tap',25,5),(29,1045,1041,'app',25,5),(29,1046,1042,'fib',33.333,5),(29,1047,1042,'ibr',33.333,5),(29,1048,1042,'bre',33.333,5),(29,1049,1046,'cha',20,5),(29,1050,1046,'han',20,5),(29,1051,1046,'ann',20,5),(29,1052,1046,'nne',20,5),(29,1053,1046,'nel',20,5),(29,1054,1049,'dis',50,5),(29,1055,1049,'isk',50,5),(29,1056,1054,'naa',100,5),(29,1057,1056,'600',3.333,5),(29,1058,1056,'00a',3.333,5),(29,1059,1056,'0a0',3.333,5),(29,1060,1056,'a09',3.333,5),(29,1061,1056,'098',3.333,5),(29,1062,1056,'980',3.333,5),(29,1063,1056,'804',3.333,5),(29,1064,1056,'044',3.333,5),(29,1065,1056,'443',3.333,5),(29,1066,1056,'430',3.333,5),(29,1067,1056,'307',3.333,5),(29,1068,1056,'075',3.333,5),(29,1069,1056,'753',3.333,5),(29,1070,1056,'535',3.333,5),(29,1071,1056,'357',3.333,5),(29,1072,1056,'573',3.333,5),(29,1073,1056,'732',3.333,5),(29,1074,1056,'32b',3.333,5),(29,1075,1056,'2b3',3.333,5),(29,1076,1056,'b33',3.333,5),(29,1077,1056,'334',3.333,5),(29,1078,1056,'345',3.333,5),(29,1079,1056,'457',3.333,5),(29,1080,1056,'571',3.333,5),(29,1081,1056,'715',3.333,5),(29,1082,1056,'153',3.333,5),(29,1083,1056,'533',3.333,5),(29,1084,1056,'336',3.333,5),(29,1085,1056,'363',3.333,5),(29,1086,1056,'635',3.333,5),(30,1088,1087,'net',25,5),(30,1089,1087,'eta',25,5),(30,1090,1087,'tap',25,5),(30,1091,1087,'app',25,5),(30,1092,1088,'fib',33.333,5),(30,1093,1088,'ibr',33.333,5),(30,1094,1088,'bre',33.333,5),(30,1095,1092,'cha',20,5),(30,1096,1092,'han',20,5),(30,1097,1092,'ann',20,5),(30,1098,1092,'nne',20,5),(30,1099,1092,'nel',20,5),(30,1100,1095,'dis',50,5),(30,1101,1095,'isk',50,5),(30,1102,1100,'naa',100,5),(30,1103,1102,'600',3.333,5),(30,1104,1102,'00a',3.333,5),(30,1105,1102,'0a0',3.333,5),(30,1106,1102,'a09',3.333,5),(30,1107,1102,'098',3.333,5),(30,1108,1102,'980',3.333,5),(30,1109,1102,'804',3.333,5),(30,1110,1102,'044',3.333,5),(30,1111,1102,'443',3.333,5),(30,1112,1102,'430',3.333,5),(30,1113,1102,'307',3.333,5),(30,1114,1102,'075',3.333,5),(30,1115,1102,'753',3.333,5),(30,1116,1102,'535',3.333,5),(30,1117,1102,'357',3.333,5),(30,1118,1102,'573',3.333,5),(30,1119,1102,'732',3.333,5),(30,1120,1102,'32b',3.333,5),(30,1121,1102,'2b3',3.333,5),(30,1122,1102,'b33',3.333,5),(30,1123,1102,'334',3.333,5),(30,1124,1102,'345',3.333,5),(30,1125,1102,'457',3.333,5),(30,1126,1102,'571',3.333,5),(30,1127,1102,'715',3.333,5),(30,1128,1102,'153',3.333,5),(30,1129,1102,'533',3.333,5),(30,1130,1102,'336',3.333,5),(30,1131,1102,'363',3.333,5),(30,1132,1102,'636',3.333,5),(31,1134,1133,'net',25,5),(31,1135,1133,'eta',25,5),(31,1136,1133,'tap',25,5),(31,1137,1133,'app',25,5),(31,1138,1134,'fib',33.333,5),(31,1139,1134,'ibr',33.333,5),(31,1140,1134,'bre',33.333,5),(31,1141,1138,'cha',20,5),(31,1142,1138,'han',20,5),(31,1143,1138,'ann',20,5),(31,1144,1138,'nne',20,5),(31,1145,1138,'nel',20,5),(31,1146,1141,'dis',50,5),(31,1147,1141,'isk',50,5),(31,1148,1146,'naa',100,5),(31,1149,1148,'600',3.333,5),(31,1150,1148,'00a',3.333,5),(31,1151,1148,'0a0',3.333,5),(31,1152,1148,'a09',3.333,5),(31,1153,1148,'098',3.333,5),(31,1154,1148,'980',3.333,5),(31,1155,1148,'804',3.333,5),(31,1156,1148,'044',3.333,5),(31,1157,1148,'443',3.333,5),(31,1158,1148,'430',3.333,5),(31,1159,1148,'307',3.333,5),(31,1160,1148,'075',3.333,5),(31,1161,1148,'753',3.333,5),(31,1162,1148,'535',3.333,5),(31,1163,1148,'357',3.333,5),(31,1164,1148,'573',3.333,5),(31,1165,1148,'732',3.333,5),(31,1166,1148,'32b',3.333,5),(31,1167,1148,'2b3',3.333,5),(31,1168,1148,'b33',3.333,5),(31,1169,1148,'334',3.333,5),(31,1170,1148,'345',3.333,5),(31,1171,1148,'457',3.333,5),(31,1172,1148,'571',3.333,5),(31,1173,1148,'715',3.333,5),(31,1174,1148,'153',3.333,5),(31,1175,1148,'533',3.333,5),(31,1176,1148,'336',3.333,5),(31,1177,1148,'363',3.333,5),(31,1178,1148,'637',3.333,5),(32,1180,1179,'net',25,5),(32,1181,1179,'eta',25,5),(32,1182,1179,'tap',25,5),(32,1183,1179,'app',25,5),(32,1184,1180,'fib',33.333,5),(32,1185,1180,'ibr',33.333,5),(32,1186,1180,'bre',33.333,5),(32,1187,1184,'cha',20,5),(32,1188,1184,'han',20,5),(32,1189,1184,'ann',20,5),(32,1190,1184,'nne',20,5),(32,1191,1184,'nel',20,5),(32,1192,1187,'dis',50,5),(32,1193,1187,'isk',50,5),(32,1194,1192,'naa',100,5),(32,1195,1194,'600',3.333,5),(32,1196,1194,'00a',3.333,5),(32,1197,1194,'0a0',3.333,5),(32,1198,1194,'a09',3.333,5),(32,1199,1194,'098',3.333,5),(32,1200,1194,'980',3.333,5),(32,1201,1194,'804',3.333,5),(32,1202,1194,'044',3.333,5),(32,1203,1194,'443',3.333,5),(32,1204,1194,'430',3.333,5),(32,1205,1194,'307',3.333,5),(32,1206,1194,'075',3.333,5),(32,1207,1194,'753',3.333,5),(32,1208,1194,'535',3.333,5),(32,1209,1194,'357',3.333,5),(32,1210,1194,'573',3.333,5),(32,1211,1194,'732',3.333,5),(32,1212,1194,'32b',3.333,5),(32,1213,1194,'2b3',3.333,5),(32,1214,1194,'b33',3.333,5),(32,1215,1194,'334',3.333,5),(32,1216,1194,'345',3.333,5),(32,1217,1194,'457',3.333,5),(32,1218,1194,'571',3.333,5),(32,1219,1194,'715',3.333,5),(32,1220,1194,'153',3.333,5),(32,1221,1194,'533',3.333,5),(32,1222,1194,'336',3.333,5),(32,1223,1194,'363',3.333,5),(32,1224,1194,'638',3.333,5),(33,1226,1225,'net',25,5),(33,1227,1225,'eta',25,5),(33,1228,1225,'tap',25,5),(33,1229,1225,'app',25,5),(33,1230,1226,'fib',33.333,5),(33,1231,1226,'ibr',33.333,5),(33,1232,1226,'bre',33.333,5),(33,1233,1230,'cha',20,5),(33,1234,1230,'han',20,5),(33,1235,1230,'ann',20,5),(33,1236,1230,'nne',20,5),(33,1237,1230,'nel',20,5),(33,1238,1233,'dis',50,5),(33,1239,1233,'isk',50,5),(33,1240,1238,'naa',100,5),(33,1241,1240,'600',3.333,5),(33,1242,1240,'00a',3.333,5),(33,1243,1240,'0a0',3.333,5),(33,1244,1240,'a09',3.333,5),(33,1245,1240,'098',3.333,5),(33,1246,1240,'980',3.333,5),(33,1247,1240,'804',3.333,5),(33,1248,1240,'044',3.333,5),(33,1249,1240,'443',3.333,5),(33,1250,1240,'430',3.333,5),(33,1251,1240,'307',3.333,5),(33,1252,1240,'075',3.333,5),(33,1253,1240,'753',3.333,5),(33,1254,1240,'535',3.333,5),(33,1255,1240,'357',3.333,5),(33,1256,1240,'573',3.333,5),(33,1257,1240,'732',3.333,5),(33,1258,1240,'32b',3.333,5),(33,1259,1240,'2b3',3.333,5),(33,1260,1240,'b33',3.333,5),(33,1261,1240,'334',3.333,5),(33,1262,1240,'345',3.333,5),(33,1263,1240,'457',3.333,5),(33,1264,1240,'571',3.333,5),(33,1265,1240,'715',3.333,5),(33,1266,1240,'153',3.333,5),(33,1267,1240,'533',3.333,5),(33,1268,1240,'336',3.333,5),(33,1269,1240,'363',3.333,5),(33,1270,1240,'639',3.333,5),(34,1272,1271,'net',25,5),(34,1273,1271,'eta',25,5),(34,1274,1271,'tap',25,5),(34,1275,1271,'app',25,5),(34,1276,1272,'fib',33.333,5),(34,1277,1272,'ibr',33.333,5),(34,1278,1272,'bre',33.333,5),(34,1279,1276,'cha',20,5),(34,1280,1276,'han',20,5),(34,1281,1276,'ann',20,5),(34,1282,1276,'nne',20,5),(34,1283,1276,'nel',20,5),(34,1284,1279,'dis',50,5),(34,1285,1279,'isk',50,5),(34,1286,1284,'naa',100,5),(34,1287,1286,'600',3.333,5),(34,1288,1286,'00a',3.333,5),(34,1289,1286,'0a0',3.333,5),(34,1290,1286,'a09',3.333,5),(34,1291,1286,'098',3.333,5),(34,1292,1286,'980',3.333,5),(34,1293,1286,'804',3.333,5),(34,1294,1286,'044',3.333,5),(34,1295,1286,'443',3.333,5),(34,1296,1286,'430',3.333,5),(34,1297,1286,'307',3.333,5),(34,1298,1286,'075',3.333,5),(34,1299,1286,'753',3.333,5),(34,1300,1286,'535',3.333,5),(34,1301,1286,'357',3.333,5),(34,1302,1286,'573',3.333,5),(34,1303,1286,'732',3.333,5),(34,1304,1286,'32b',3.333,5),(34,1305,1286,'2b3',3.333,5),(34,1306,1286,'b33',3.333,5),(34,1307,1286,'334',3.333,5),(34,1308,1286,'345',3.333,5),(34,1309,1286,'457',3.333,5),(34,1310,1286,'571',3.333,5),(34,1311,1286,'715',3.333,5),(34,1312,1286,'153',3.333,5),(34,1313,1286,'533',3.333,5),(34,1314,1286,'336',3.333,5),(34,1315,1286,'367',3.333,5),(34,1316,1286,'670',3.333,5),(35,1318,1317,'net',25,5),(35,1319,1317,'eta',25,5),(35,1320,1317,'tap',25,5),(35,1321,1317,'app',25,5),(35,1322,1318,'fib',33.333,5),(35,1323,1318,'ibr',33.333,5),(35,1324,1318,'bre',33.333,5),(35,1325,1322,'cha',20,5),(35,1326,1322,'han',20,5),(35,1327,1322,'ann',20,5),(35,1328,1322,'nne',20,5),(35,1329,1322,'nel',20,5),(35,1330,1325,'dis',50,5),(35,1331,1325,'isk',50,5),(35,1332,1330,'naa',100,5),(35,1333,1332,'600',3.333,5),(35,1334,1332,'00a',3.333,5),(35,1335,1332,'0a0',3.333,5),(35,1336,1332,'a09',3.333,5),(35,1337,1332,'098',3.333,5),(35,1338,1332,'980',3.333,5),(35,1339,1332,'804',3.333,5),(35,1340,1332,'044',3.333,5),(35,1341,1332,'443',3.333,5),(35,1342,1332,'430',3.333,5),(35,1343,1332,'307',3.333,5),(35,1344,1332,'075',3.333,5),(35,1345,1332,'753',3.333,5),(35,1346,1332,'535',3.333,5),(35,1347,1332,'357',3.333,5),(35,1348,1332,'573',3.333,5),(35,1349,1332,'732',3.333,5),(35,1350,1332,'32b',3.333,5),(35,1351,1332,'2b3',3.333,5),(35,1352,1332,'b33',3.333,5),(35,1353,1332,'334',3.333,5),(35,1354,1332,'345',3.333,5),(35,1355,1332,'457',3.333,5),(35,1356,1332,'571',3.333,5),(35,1357,1332,'715',3.333,5),(35,1358,1332,'153',3.333,5),(35,1359,1332,'533',3.333,5),(35,1360,1332,'336',3.333,5),(35,1361,1332,'367',3.333,5),(35,1362,1332,'671',3.333,5),(36,1364,1363,'net',25,5),(36,1365,1363,'eta',25,5),(36,1366,1363,'tap',25,5),(36,1367,1363,'app',25,5),(36,1368,1364,'ser',25,5),(36,1369,1364,'eri',25,5),(36,1370,1364,'ria',25,5),(36,1371,1364,'ial',25,5),(36,1372,1368,'att',16.667,5),(36,1373,1368,'tta',16.667,5),(36,1374,1368,'tac',16.667,5),(36,1375,1368,'ach',16.667,5),(36,1376,1368,'che',16.667,5),(36,1377,1368,'hed',16.667,5),(36,1378,1372,'scs',50,5),(36,1379,1372,'csi',50,5),(36,1380,1378,'dis',50,5),(36,1381,1378,'isk',50,5),(36,1382,1380,'naa',100,5),(36,1383,1382,'600',3.333,5),(36,1384,1382,'00a',3.333,5),(36,1385,1382,'0a0',3.333,5),(36,1386,1382,'a09',3.333,5),(36,1387,1382,'098',3.333,5),(36,1388,1382,'980',3.333,5),(36,1389,1382,'80c',3.333,5),(36,1390,1382,'0c1',3.333,5),(36,1391,1382,'c15',3.333,5),(36,1392,1382,'155',3.333,5),(36,1393,1382,'558',3.333,5),(36,1394,1382,'584',3.333,5),(36,1395,1382,'84e',3.333,5),(36,1396,1382,'4ee',3.333,5),(36,1397,1382,'eeb',3.333,5),(36,1398,1382,'eb9',3.333,5),(36,1399,1382,'b98',3.333,5),(36,1400,1382,'984',3.333,5),(36,1401,1382,'844',3.333,5),(36,1402,1382,'444',3.333,5),(36,1403,1382,'441',3.333,5),(36,1404,1382,'411',3.333,5),(36,1405,1382,'117',3.333,5),(36,1406,1382,'17b',3.333,5),(36,1407,1382,'7b0',3.333,5),(36,1408,1382,'b09',3.333,5),(36,1409,1382,'09a',3.333,5),(36,1410,1382,'9ab',3.333,5),(36,1411,1382,'aba',3.333,5),(36,1412,1382,'ba2',3.333,5),(37,1414,1413,'net',25,5),(37,1415,1413,'eta',25,5),(37,1416,1413,'tap',25,5),(37,1417,1413,'app',25,5),(37,1418,1414,'ser',25,5),(37,1419,1414,'eri',25,5),(37,1420,1414,'ria',25,5),(37,1421,1414,'ial',25,5),(37,1422,1418,'att',16.667,5),(37,1423,1418,'tta',16.667,5),(37,1424,1418,'tac',16.667,5),(37,1425,1418,'ach',16.667,5),(37,1426,1418,'che',16.667,5),(37,1427,1418,'hed',16.667,5),(37,1428,1422,'scs',50,5),(37,1429,1422,'csi',50,5),(37,1430,1428,'dis',50,5),(37,1431,1428,'isk',50,5),(37,1432,1430,'naa',100,5),(37,1433,1432,'600',3.333,5),(37,1434,1432,'00a',3.333,5),(37,1435,1432,'0a0',3.333,5),(37,1436,1432,'a09',3.333,5),(37,1437,1432,'098',3.333,5),(37,1438,1432,'980',3.333,5),(37,1439,1432,'800',3.333,5),(37,1440,1432,'00b',3.333,5),(37,1441,1432,'0b5',3.333,5),(37,1442,1432,'b56',3.333,5),(37,1443,1432,'568',3.333,5),(37,1444,1432,'684',3.333,5),(37,1445,1432,'84e',3.333,5),(37,1446,1432,'4ee',3.333,5),(37,1447,1432,'ee5',3.333,5),(37,1448,1432,'e5a',3.333,5),(37,1449,1432,'5a9',3.333,5),(37,1450,1432,'a9d',3.333,5),(37,1451,1432,'9d4',3.333,5),(37,1452,1432,'d40',3.333,5),(37,1453,1432,'401',3.333,5),(37,1454,1432,'011',3.333,5),(37,1455,1432,'117',3.333,5),(37,1456,1432,'17b',3.333,5),(37,1457,1432,'7b0',3.333,5),(37,1458,1432,'b0a',3.333,5),(37,1459,1432,'0aa',3.333,5),(37,1460,1432,'aab',3.333,5),(37,1461,1432,'aba',3.333,5),(37,1462,1432,'ba2',3.333,5),(38,1464,1463,'net',25,5),(38,1465,1463,'eta',25,5),(38,1466,1463,'tap',25,5),(38,1467,1463,'app',25,5),(38,1468,1464,'ser',25,5),(38,1469,1464,'eri',25,5),(38,1470,1464,'ria',25,5),(38,1471,1464,'ial',25,5),(38,1472,1468,'att',16.667,5),(38,1473,1468,'tta',16.667,5),(38,1474,1468,'tac',16.667,5),(38,1475,1468,'ach',16.667,5),(38,1476,1468,'che',16.667,5),(38,1477,1468,'hed',16.667,5),(38,1478,1472,'scs',50,5),(38,1479,1472,'csi',50,5),(38,1480,1478,'dis',50,5),(38,1481,1478,'isk',50,5),(38,1482,1480,'naa',100,5),(38,1483,1482,'600',3.333,5),(38,1484,1482,'00a',3.333,5),(38,1485,1482,'0a0',3.333,5),(38,1486,1482,'a09',3.333,5),(38,1487,1482,'098',3.333,5),(38,1488,1482,'980',3.333,5),(38,1489,1482,'807',3.333,5),(38,1490,1482,'072',3.333,5),(38,1491,1482,'727',3.333,5),(38,1492,1482,'272',3.333,5),(38,1493,1482,'728',3.333,5),(38,1494,1482,'284',3.333,5),(38,1495,1482,'84e',3.333,5),(38,1496,1482,'4ee',3.333,5),(38,1497,1482,'ee1',3.333,5),(38,1498,1482,'e19',3.333,5),(38,1499,1482,'193',3.333,5),(38,1500,1482,'937',3.333,5),(38,1501,1482,'374',3.333,5),(38,1502,1482,'742',3.333,5),(38,1503,1482,'421',3.333,5),(38,1504,1482,'211',3.333,5),(38,1505,1482,'117',3.333,5),(38,1506,1482,'17b',3.333,5),(38,1507,1482,'7b0',3.333,5),(38,1508,1482,'b0c',3.333,5),(38,1509,1482,'0ca',3.333,5),(38,1510,1482,'cab',3.333,5),(38,1511,1482,'aba',3.333,5),(38,1512,1482,'ba2',3.333,5),(39,1514,1513,'lsi',100,5),(39,1515,1514,'ser',25,5),(39,1516,1514,'eri',25,5),(39,1517,1514,'ria',25,5),(39,1518,1514,'ial',25,5),(39,1519,1515,'att',16.667,5),(39,1520,1515,'tta',16.667,5),(39,1521,1515,'tac',16.667,5),(39,1522,1515,'ach',16.667,5),(39,1523,1515,'che',16.667,5),(39,1524,1515,'hed',16.667,5),(39,1525,1519,'scs',50,5),(39,1526,1519,'csi',50,5),(39,1527,1525,'dis',50,5),(39,1528,1525,'isk',50,5),(39,1529,1527,'naa',100,5),(39,1530,1529,'600',3.333,5),(39,1531,1529,'005',3.333,5),(39,1532,1529,'050',3.333,5),(39,1533,1529,'508',3.333,5),(39,1534,1529,'08e',3.333,5),(39,1535,1529,'8e0',3.333,5),(39,1536,1529,'e07',3.333,5),(39,1537,1529,'07e',3.333,5),(39,1538,1529,'7e7',3.333,5),(39,1539,1529,'e72',3.333,5),(39,1540,1529,'726',3.333,5),(39,1541,1529,'261',3.333,5),(39,1542,1529,'617',3.333,5),(39,1543,1529,'177',3.333,5),(39,1544,1529,'775',3.333,5),(39,1545,1529,'75c',3.333,5),(39,1546,1529,'5c3',3.333,5),(39,1547,1529,'c39',3.333,5),(39,1548,1529,'39b',3.333,5),(39,1549,1529,'9bd',3.333,5),(39,1550,1529,'bd2',3.333,5),(39,1551,1529,'d2e',3.333,5),(39,1552,1529,'2eb',3.333,5),(39,1553,1529,'eba',3.333,5),(39,1554,1529,'bac',3.333,5),(39,1555,1529,'ac3',3.333,5),(39,1556,1529,'c34',3.333,5),(39,1557,1529,'341',3.333,5),(39,1558,1529,'410',3.333,5),(39,1559,1529,'10f',3.333,5),(40,1561,1560,'net',25,5),(40,1562,1560,'eta',25,5),(40,1563,1560,'tap',25,5),(40,1564,1560,'app',25,5),(40,1565,1561,'fib',33.333,5),(40,1566,1561,'ibr',33.333,5),(40,1567,1561,'bre',33.333,5),(40,1568,1565,'cha',20,5),(40,1569,1565,'han',20,5),(40,1570,1565,'ann',20,5),(40,1571,1565,'nne',20,5),(40,1572,1565,'nel',20,5),(40,1573,1568,'dis',50,5),(40,1574,1568,'isk',50,5),(40,1575,1573,'naa',100,5),(40,1576,1575,'600',3.333,5),(40,1577,1575,'00a',3.333,5),(40,1578,1575,'0a0',3.333,5),(40,1579,1575,'a09',3.333,5),(40,1580,1575,'098',3.333,5),(40,1581,1575,'980',3.333,5),(40,1582,1575,'804',3.333,5),(40,1583,1575,'044',3.333,5),(40,1584,1575,'443',3.333,5),(40,1585,1575,'430',3.333,5),(40,1586,1575,'307',3.333,5),(40,1587,1575,'072',3.333,5),(40,1588,1575,'725',3.333,5),(40,1589,1575,'259',3.333,5),(40,1590,1575,'593',3.333,5),(40,1591,1575,'931',3.333,5),(40,1592,1575,'313',3.333,5),(40,1593,1575,'13f',3.333,5),(40,1594,1575,'3f3',3.333,5),(40,1595,1575,'f33',3.333,5),(40,1596,1575,'334',3.333,5),(40,1597,1575,'345',3.333,5),(40,1598,1575,'455',3.333,5),(40,1599,1575,'556',3.333,5),(40,1600,1575,'563',3.333,5),(40,1601,1575,'639',3.333,5),(40,1602,1575,'393',3.333,5),(40,1603,1575,'934',3.333,5),(40,1604,1575,'343',3.333,5),(40,1605,1575,'430',3.333,5),(41,1607,1606,'net',25,5),(41,1608,1606,'eta',25,5),(41,1609,1606,'tap',25,5),(41,1610,1606,'app',25,5),(41,1611,1607,'fib',33.333,5),(41,1612,1607,'ibr',33.333,5),(41,1613,1607,'bre',33.333,5),(41,1614,1611,'cha',20,5),(41,1615,1611,'han',20,5),(41,1616,1611,'ann',20,5),(41,1617,1611,'nne',20,5),(41,1618,1611,'nel',20,5),(41,1619,1614,'dis',50,5),(41,1620,1614,'isk',50,5),(41,1621,1619,'naa',100,5),(41,1622,1621,'600',3.333,5),(41,1623,1621,'00a',3.333,5),(41,1624,1621,'0a0',3.333,5),(41,1625,1621,'a09',3.333,5),(41,1626,1621,'098',3.333,5),(41,1627,1621,'980',3.333,5),(41,1628,1621,'804',3.333,5),(41,1629,1621,'044',3.333,5),(41,1630,1621,'443',3.333,5),(41,1631,1621,'430',3.333,5),(41,1632,1621,'307',3.333,5),(41,1633,1621,'072',3.333,5),(41,1634,1621,'725',3.333,5),(41,1635,1621,'259',3.333,5),(41,1636,1621,'593',3.333,5),(41,1637,1621,'931',3.333,5),(41,1638,1621,'313',3.333,5),(41,1639,1621,'13f',3.333,5),(41,1640,1621,'3f3',3.333,5),(41,1641,1621,'f33',3.333,5),(41,1642,1621,'334',3.333,5),(41,1643,1621,'345',3.333,5),(41,1644,1621,'455',3.333,5),(41,1645,1621,'556',3.333,5),(41,1646,1621,'563',3.333,5),(41,1647,1621,'639',3.333,5),(41,1648,1621,'393',3.333,5),(41,1649,1621,'934',3.333,5),(41,1650,1621,'343',3.333,5),(41,1651,1621,'431',3.333,5),(42,1653,1652,'net',25,5),(42,1654,1652,'eta',25,5),(42,1655,1652,'tap',25,5),(42,1656,1652,'app',25,5),(42,1657,1653,'fib',33.333,5),(42,1658,1653,'ibr',33.333,5),(42,1659,1653,'bre',33.333,5),(42,1660,1657,'cha',20,5),(42,1661,1657,'han',20,5),(42,1662,1657,'ann',20,5),(42,1663,1657,'nne',20,5),(42,1664,1657,'nel',20,5),(42,1665,1660,'dis',50,5),(42,1666,1660,'isk',50,5),(42,1667,1665,'naa',100,5),(42,1668,1667,'600',3.333,5),(42,1669,1667,'00a',3.333,5),(42,1670,1667,'0a0',3.333,5),(42,1671,1667,'a09',3.333,5),(42,1672,1667,'098',3.333,5),(42,1673,1667,'980',3.333,5),(42,1674,1667,'804',3.333,5),(42,1675,1667,'044',3.333,5),(42,1676,1667,'443',3.333,5),(42,1677,1667,'430',3.333,5),(42,1678,1667,'307',3.333,5),(42,1679,1667,'072',3.333,5),(42,1680,1667,'725',3.333,5),(42,1681,1667,'259',3.333,5),(42,1682,1667,'593',3.333,5),(42,1683,1667,'931',3.333,5),(42,1684,1667,'313',3.333,5),(42,1685,1667,'13f',3.333,5),(42,1686,1667,'3f3',3.333,5),(42,1687,1667,'f33',3.333,5),(42,1688,1667,'334',3.333,5),(42,1689,1667,'345',3.333,5),(42,1690,1667,'455',3.333,5),(42,1691,1667,'556',3.333,5),(42,1692,1667,'563',3.333,5),(42,1693,1667,'639',3.333,5),(42,1694,1667,'393',3.333,5),(42,1695,1667,'934',3.333,5),(42,1696,1667,'343',3.333,5),(42,1697,1667,'432',3.333,5),(43,1699,1698,'net',25,5),(43,1700,1698,'eta',25,5),(43,1701,1698,'tap',25,5),(43,1702,1698,'app',25,5),(43,1703,1699,'fib',33.333,5),(43,1704,1699,'ibr',33.333,5),(43,1705,1699,'bre',33.333,5),(43,1706,1703,'cha',20,5),(43,1707,1703,'han',20,5),(43,1708,1703,'ann',20,5),(43,1709,1703,'nne',20,5),(43,1710,1703,'nel',20,5),(43,1711,1706,'dis',50,5),(43,1712,1706,'isk',50,5),(43,1713,1711,'naa',100,5),(43,1714,1713,'600',3.333,5),(43,1715,1713,'00a',3.333,5),(43,1716,1713,'0a0',3.333,5),(43,1717,1713,'a09',3.333,5),(43,1718,1713,'098',3.333,5),(43,1719,1713,'980',3.333,5),(43,1720,1713,'804',3.333,5),(43,1721,1713,'044',3.333,5),(43,1722,1713,'443',3.333,5),(43,1723,1713,'430',3.333,5),(43,1724,1713,'307',3.333,5),(43,1725,1713,'072',3.333,5),(43,1726,1713,'725',3.333,5),(43,1727,1713,'259',3.333,5),(43,1728,1713,'593',3.333,5),(43,1729,1713,'931',3.333,5),(43,1730,1713,'313',3.333,5),(43,1731,1713,'13f',3.333,5),(43,1732,1713,'3f3',3.333,5),(43,1733,1713,'f33',3.333,5),(43,1734,1713,'334',3.333,5),(43,1735,1713,'345',3.333,5),(43,1736,1713,'455',3.333,5),(43,1737,1713,'556',3.333,5),(43,1738,1713,'563',3.333,5),(43,1739,1713,'639',3.333,5),(43,1740,1713,'393',3.333,5),(43,1741,1713,'934',3.333,5),(43,1742,1713,'343',3.333,5),(43,1743,1713,'433',3.333,5),(44,1745,1744,'net',25,5),(44,1746,1744,'eta',25,5),(44,1747,1744,'tap',25,5),(44,1748,1744,'app',25,5),(44,1749,1745,'fib',33.333,5),(44,1750,1745,'ibr',33.333,5),(44,1751,1745,'bre',33.333,5),(44,1752,1749,'cha',20,5),(44,1753,1749,'han',20,5),(44,1754,1749,'ann',20,5),(44,1755,1749,'nne',20,5),(44,1756,1749,'nel',20,5),(44,1757,1752,'dis',50,5),(44,1758,1752,'isk',50,5),(44,1759,1757,'naa',100,5),(44,1760,1759,'600',3.333,5),(44,1761,1759,'00a',3.333,5),(44,1762,1759,'0a0',3.333,5),(44,1763,1759,'a09',3.333,5),(44,1764,1759,'098',3.333,5),(44,1765,1759,'980',3.333,5),(44,1766,1759,'804',3.333,5),(44,1767,1759,'044',3.333,5),(44,1768,1759,'443',3.333,5),(44,1769,1759,'430',3.333,5),(44,1770,1759,'307',3.333,5),(44,1771,1759,'072',3.333,5),(44,1772,1759,'725',3.333,5),(44,1773,1759,'259',3.333,5),(44,1774,1759,'593',3.333,5),(44,1775,1759,'931',3.333,5),(44,1776,1759,'313',3.333,5),(44,1777,1759,'13f',3.333,5),(44,1778,1759,'3f3',3.333,5),(44,1779,1759,'f33',3.333,5),(44,1780,1759,'334',3.333,5),(44,1781,1759,'345',3.333,5),(44,1782,1759,'455',3.333,5),(44,1783,1759,'556',3.333,5),(44,1784,1759,'563',3.333,5),(44,1785,1759,'639',3.333,5),(44,1786,1759,'393',3.333,5),(44,1787,1759,'934',3.333,5),(44,1788,1759,'343',3.333,5),(44,1789,1759,'434',3.333,5),(45,1791,1790,'net',25,5),(45,1792,1790,'eta',25,5),(45,1793,1790,'tap',25,5),(45,1794,1790,'app',25,5),(45,1795,1791,'fib',33.333,5),(45,1796,1791,'ibr',33.333,5),(45,1797,1791,'bre',33.333,5),(45,1798,1795,'cha',20,5),(45,1799,1795,'han',20,5),(45,1800,1795,'ann',20,5),(45,1801,1795,'nne',20,5),(45,1802,1795,'nel',20,5),(45,1803,1798,'dis',50,5),(45,1804,1798,'isk',50,5),(45,1805,1803,'naa',100,5),(45,1806,1805,'600',3.333,5),(45,1807,1805,'00a',3.333,5),(45,1808,1805,'0a0',3.333,5),(45,1809,1805,'a09',3.333,5),(45,1810,1805,'098',3.333,5),(45,1811,1805,'980',3.333,5),(45,1812,1805,'804',3.333,5),(45,1813,1805,'044',3.333,5),(45,1814,1805,'443',3.333,5),(45,1815,1805,'430',3.333,5),(45,1816,1805,'307',3.333,5),(45,1817,1805,'072',3.333,5),(45,1818,1805,'725',3.333,5),(45,1819,1805,'259',3.333,5),(45,1820,1805,'593',3.333,5),(45,1821,1805,'931',3.333,5),(45,1822,1805,'313',3.333,5),(45,1823,1805,'13f',3.333,5),(45,1824,1805,'3f3',3.333,5),(45,1825,1805,'f33',3.333,5),(45,1826,1805,'334',3.333,5),(45,1827,1805,'345',3.333,5),(45,1828,1805,'455',3.333,5),(45,1829,1805,'556',3.333,5),(45,1830,1805,'563',3.333,5),(45,1831,1805,'639',3.333,5),(45,1832,1805,'393',3.333,5),(45,1833,1805,'934',3.333,5),(45,1834,1805,'343',3.333,5),(45,1835,1805,'435',3.333,5),(46,1837,1836,'net',25,5),(46,1838,1836,'eta',25,5),(46,1839,1836,'tap',25,5),(46,1840,1836,'app',25,5),(46,1841,1837,'fib',33.333,5),(46,1842,1837,'ibr',33.333,5),(46,1843,1837,'bre',33.333,5),(46,1844,1841,'cha',20,5),(46,1845,1841,'han',20,5),(46,1846,1841,'ann',20,5),(46,1847,1841,'nne',20,5),(46,1848,1841,'nel',20,5),(46,1849,1844,'dis',50,5),(46,1850,1844,'isk',50,5),(46,1851,1849,'naa',100,5),(46,1852,1851,'600',3.333,5),(46,1853,1851,'00a',3.333,5),(46,1854,1851,'0a0',3.333,5),(46,1855,1851,'a09',3.333,5),(46,1856,1851,'098',3.333,5),(46,1857,1851,'980',3.333,5),(46,1858,1851,'804',3.333,5),(46,1859,1851,'044',3.333,5),(46,1860,1851,'443',3.333,5),(46,1861,1851,'430',3.333,5),(46,1862,1851,'307',3.333,5),(46,1863,1851,'072',3.333,5),(46,1864,1851,'725',3.333,5),(46,1865,1851,'259',3.333,5),(46,1866,1851,'593',3.333,5),(46,1867,1851,'931',3.333,5),(46,1868,1851,'313',3.333,5),(46,1869,1851,'13f',3.333,5),(46,1870,1851,'3f3',3.333,5),(46,1871,1851,'f33',3.333,5),(46,1872,1851,'334',3.333,5),(46,1873,1851,'345',3.333,5),(46,1874,1851,'455',3.333,5),(46,1875,1851,'556',3.333,5),(46,1876,1851,'563',3.333,5),(46,1877,1851,'639',3.333,5),(46,1878,1851,'393',3.333,5),(46,1879,1851,'934',3.333,5),(46,1880,1851,'343',3.333,5),(46,1881,1851,'436',3.333,5),(47,1883,1882,'net',25,5),(47,1884,1882,'eta',25,5),(47,1885,1882,'tap',25,5),(47,1886,1882,'app',25,5),(47,1887,1883,'fib',33.333,5),(47,1888,1883,'ibr',33.333,5),(47,1889,1883,'bre',33.333,5),(47,1890,1887,'cha',20,5),(47,1891,1887,'han',20,5),(47,1892,1887,'ann',20,5),(47,1893,1887,'nne',20,5),(47,1894,1887,'nel',20,5),(47,1895,1890,'dis',50,5),(47,1896,1890,'isk',50,5),(47,1897,1895,'naa',100,5),(47,1898,1897,'600',3.333,5),(47,1899,1897,'00a',3.333,5),(47,1900,1897,'0a0',3.333,5),(47,1901,1897,'a09',3.333,5),(47,1902,1897,'098',3.333,5),(47,1903,1897,'980',3.333,5),(47,1904,1897,'804',3.333,5),(47,1905,1897,'044',3.333,5),(47,1906,1897,'443',3.333,5),(47,1907,1897,'430',3.333,5),(47,1908,1897,'307',3.333,5),(47,1909,1897,'072',3.333,5),(47,1910,1897,'725',3.333,5),(47,1911,1897,'259',3.333,5),(47,1912,1897,'593',3.333,5),(47,1913,1897,'931',3.333,5),(47,1914,1897,'313',3.333,5),(47,1915,1897,'13f',3.333,5),(47,1916,1897,'3f3',3.333,5),(47,1917,1897,'f33',3.333,5),(47,1918,1897,'334',3.333,5),(47,1919,1897,'345',3.333,5),(47,1920,1897,'455',3.333,5),(47,1921,1897,'556',3.333,5),(47,1922,1897,'563',3.333,5),(47,1923,1897,'639',3.333,5),(47,1924,1897,'393',3.333,5),(47,1925,1897,'934',3.333,5),(47,1926,1897,'343',3.333,5),(47,1927,1897,'437',3.333,5),(48,1929,1928,'net',25,5),(48,1930,1928,'eta',25,5),(48,1931,1928,'tap',25,5),(48,1932,1928,'app',25,5),(48,1933,1929,'fib',33.333,5),(48,1934,1929,'ibr',33.333,5),(48,1935,1929,'bre',33.333,5),(48,1936,1933,'cha',20,5),(48,1937,1933,'han',20,5),(48,1938,1933,'ann',20,5),(48,1939,1933,'nne',20,5),(48,1940,1933,'nel',20,5),(48,1941,1936,'dis',50,5),(48,1942,1936,'isk',50,5),(48,1943,1941,'naa',100,5),(48,1944,1943,'600',3.333,5),(48,1945,1943,'00a',3.333,5),(48,1946,1943,'0a0',3.333,5),(48,1947,1943,'a09',3.333,5),(48,1948,1943,'098',3.333,5),(48,1949,1943,'980',3.333,5),(48,1950,1943,'804',3.333,5),(48,1951,1943,'044',3.333,5),(48,1952,1943,'443',3.333,5),(48,1953,1943,'430',3.333,5),(48,1954,1943,'307',3.333,5),(48,1955,1943,'072',3.333,5),(48,1956,1943,'725',3.333,5),(48,1957,1943,'259',3.333,5),(48,1958,1943,'593',3.333,5),(48,1959,1943,'931',3.333,5),(48,1960,1943,'313',3.333,5),(48,1961,1943,'13f',3.333,5),(48,1962,1943,'3f3',3.333,5),(48,1963,1943,'f33',3.333,5),(48,1964,1943,'334',3.333,5),(48,1965,1943,'345',3.333,5),(48,1966,1943,'455',3.333,5),(48,1967,1943,'556',3.333,5),(48,1968,1943,'563',3.333,5),(48,1969,1943,'639',3.333,5),(48,1970,1943,'393',3.333,5),(48,1971,1943,'934',3.333,5),(48,1972,1943,'343',3.333,5),(48,1973,1943,'438',3.333,5),(49,1975,1974,'net',25,5),(49,1976,1974,'eta',25,5),(49,1977,1974,'tap',25,5),(49,1978,1974,'app',25,5),(49,1979,1975,'fib',33.333,5),(49,1980,1975,'ibr',33.333,5),(49,1981,1975,'bre',33.333,5),(49,1982,1979,'cha',20,5),(49,1983,1979,'han',20,5),(49,1984,1979,'ann',20,5),(49,1985,1979,'nne',20,5),(49,1986,1979,'nel',20,5),(49,1987,1982,'dis',50,5),(49,1988,1982,'isk',50,5),(49,1989,1987,'naa',100,5),(49,1990,1989,'600',3.333,5),(49,1991,1989,'00a',3.333,5),(49,1992,1989,'0a0',3.333,5),(49,1993,1989,'a09',3.333,5),(49,1994,1989,'098',3.333,5),(49,1995,1989,'980',3.333,5),(49,1996,1989,'804',3.333,5),(49,1997,1989,'044',3.333,5),(49,1998,1989,'443',3.333,5),(49,1999,1989,'430',3.333,5),(49,2000,1989,'307',3.333,5),(49,2001,1989,'072',3.333,5),(49,2002,1989,'725',3.333,5),(49,2003,1989,'259',3.333,5),(49,2004,1989,'593',3.333,5),(49,2005,1989,'931',3.333,5),(49,2006,1989,'313',3.333,5),(49,2007,1989,'13f',3.333,5),(49,2008,1989,'3f3',3.333,5),(49,2009,1989,'f33',3.333,5),(49,2010,1989,'334',3.333,5),(49,2011,1989,'345',3.333,5),(49,2012,1989,'455',3.333,5),(49,2013,1989,'556',3.333,5),(49,2014,1989,'563',3.333,5),(49,2015,1989,'639',3.333,5),(49,2016,1989,'393',3.333,5),(49,2017,1989,'934',3.333,5),(49,2018,1989,'343',3.333,5),(49,2019,1989,'439',3.333,5),(50,2021,2020,'net',25,5),(50,2022,2020,'eta',25,5),(50,2023,2020,'tap',25,5),(50,2024,2020,'app',25,5),(50,2025,2021,'fib',33.333,5),(50,2026,2021,'ibr',33.333,5),(50,2027,2021,'bre',33.333,5),(50,2028,2025,'cha',20,5),(50,2029,2025,'han',20,5),(50,2030,2025,'ann',20,5),(50,2031,2025,'nne',20,5),(50,2032,2025,'nel',20,5),(50,2033,2028,'dis',50,5),(50,2034,2028,'isk',50,5),(50,2035,2033,'naa',100,5),(50,2036,2035,'600',3.333,5),(50,2037,2035,'00a',3.333,5),(50,2038,2035,'0a0',3.333,5),(50,2039,2035,'a09',3.333,5),(50,2040,2035,'098',3.333,5),(50,2041,2035,'980',3.333,5),(50,2042,2035,'804',3.333,5),(50,2043,2035,'044',3.333,5),(50,2044,2035,'443',3.333,5),(50,2045,2035,'430',3.333,5),(50,2046,2035,'307',3.333,5),(50,2047,2035,'072',3.333,5),(50,2048,2035,'725',3.333,5),(50,2049,2035,'259',3.333,5),(50,2050,2035,'593',3.333,5),(50,2051,2035,'931',3.333,5),(50,2052,2035,'313',3.333,5),(50,2053,2035,'13f',3.333,5),(50,2054,2035,'3f3',3.333,5),(50,2055,2035,'f33',3.333,5),(50,2056,2035,'334',3.333,5),(50,2057,2035,'345',3.333,5),(50,2058,2035,'455',3.333,5),(50,2059,2035,'556',3.333,5),(50,2060,2035,'563',3.333,5),(50,2061,2035,'639',3.333,5),(50,2062,2035,'393',3.333,5),(50,2063,2035,'934',3.333,5),(50,2064,2035,'347',3.333,5),(50,2065,2035,'470',3.333,5),(51,2067,2066,'net',25,5),(51,2068,2066,'eta',25,5),(51,2069,2066,'tap',25,5),(51,2070,2066,'app',25,5),(51,2071,2067,'fib',33.333,5),(51,2072,2067,'ibr',33.333,5),(51,2073,2067,'bre',33.333,5),(51,2074,2071,'cha',20,5),(51,2075,2071,'han',20,5),(51,2076,2071,'ann',20,5),(51,2077,2071,'nne',20,5),(51,2078,2071,'nel',20,5),(51,2079,2074,'dis',50,5),(51,2080,2074,'isk',50,5),(51,2081,2079,'naa',100,5),(51,2082,2081,'600',3.333,5),(51,2083,2081,'00a',3.333,5),(51,2084,2081,'0a0',3.333,5),(51,2085,2081,'a09',3.333,5),(51,2086,2081,'098',3.333,5),(51,2087,2081,'980',3.333,5),(51,2088,2081,'804',3.333,5),(51,2089,2081,'044',3.333,5),(51,2090,2081,'443',3.333,5),(51,2091,2081,'430',3.333,5),(51,2092,2081,'307',3.333,5),(51,2093,2081,'072',3.333,5),(51,2094,2081,'725',3.333,5),(51,2095,2081,'259',3.333,5),(51,2096,2081,'593',3.333,5),(51,2097,2081,'931',3.333,5),(51,2098,2081,'313',3.333,5),(51,2099,2081,'13f',3.333,5),(51,2100,2081,'3f3',3.333,5),(51,2101,2081,'f33',3.333,5),(51,2102,2081,'334',3.333,5),(51,2103,2081,'345',3.333,5),(51,2104,2081,'455',3.333,5),(51,2105,2081,'556',3.333,5),(51,2106,2081,'563',3.333,5),(51,2107,2081,'639',3.333,5),(51,2108,2081,'393',3.333,5),(51,2109,2081,'934',3.333,5),(51,2110,2081,'347',3.333,5),(51,2111,2081,'471',3.333,5),(52,2113,2112,'net',25,5),(52,2114,2112,'eta',25,5),(52,2115,2112,'tap',25,5),(52,2116,2112,'app',25,5),(52,2117,2113,'fib',33.333,5),(52,2118,2113,'ibr',33.333,5),(52,2119,2113,'bre',33.333,5),(52,2120,2117,'cha',20,5),(52,2121,2117,'han',20,5),(52,2122,2117,'ann',20,5),(52,2123,2117,'nne',20,5),(52,2124,2117,'nel',20,5),(52,2125,2120,'dis',50,5),(52,2126,2120,'isk',50,5),(52,2127,2125,'naa',100,5),(52,2128,2127,'600',3.333,5),(52,2129,2127,'00a',3.333,5),(52,2130,2127,'0a0',3.333,5),(52,2131,2127,'a09',3.333,5),(52,2132,2127,'098',3.333,5),(52,2133,2127,'980',3.333,5),(52,2134,2127,'804',3.333,5),(52,2135,2127,'044',3.333,5),(52,2136,2127,'443',3.333,5),(52,2137,2127,'430',3.333,5),(52,2138,2127,'307',3.333,5),(52,2139,2127,'072',3.333,5),(52,2140,2127,'725',3.333,5),(52,2141,2127,'259',3.333,5),(52,2142,2127,'593',3.333,5),(52,2143,2127,'931',3.333,5),(52,2144,2127,'313',3.333,5),(52,2145,2127,'13f',3.333,5),(52,2146,2127,'3f3',3.333,5),(52,2147,2127,'f33',3.333,5),(52,2148,2127,'334',3.333,5),(52,2149,2127,'345',3.333,5),(52,2150,2127,'455',3.333,5),(52,2151,2127,'556',3.333,5),(52,2152,2127,'563',3.333,5),(52,2153,2127,'639',3.333,5),(52,2154,2127,'393',3.333,5),(52,2155,2127,'934',3.333,5),(52,2156,2127,'347',3.333,5),(52,2157,2127,'472',3.333,5),(53,2159,2158,'net',25,5),(53,2160,2158,'eta',25,5),(53,2161,2158,'tap',25,5),(53,2162,2158,'app',25,5),(53,2163,2159,'fib',33.333,5),(53,2164,2159,'ibr',33.333,5),(53,2165,2159,'bre',33.333,5),(53,2166,2163,'cha',20,5),(53,2167,2163,'han',20,5),(53,2168,2163,'ann',20,5),(53,2169,2163,'nne',20,5),(53,2170,2163,'nel',20,5),(53,2171,2166,'dis',50,5),(53,2172,2166,'isk',50,5),(53,2173,2171,'naa',100,5),(53,2174,2173,'600',3.333,5),(53,2175,2173,'00a',3.333,5),(53,2176,2173,'0a0',3.333,5),(53,2177,2173,'a09',3.333,5),(53,2178,2173,'098',3.333,5),(53,2179,2173,'980',3.333,5),(53,2180,2173,'804',3.333,5),(53,2181,2173,'044',3.333,5),(53,2182,2173,'443',3.333,5),(53,2183,2173,'430',3.333,5),(53,2184,2173,'307',3.333,5),(53,2185,2173,'072',3.333,5),(53,2186,2173,'725',3.333,5),(53,2187,2173,'259',3.333,5),(53,2188,2173,'593',3.333,5),(53,2189,2173,'931',3.333,5),(53,2190,2173,'313',3.333,5),(53,2191,2173,'13f',3.333,5),(53,2192,2173,'3f3',3.333,5),(53,2193,2173,'f33',3.333,5),(53,2194,2173,'334',3.333,5),(53,2195,2173,'345',3.333,5),(53,2196,2173,'455',3.333,5),(53,2197,2173,'556',3.333,5),(53,2198,2173,'563',3.333,5),(53,2199,2173,'639',3.333,5),(53,2200,2173,'393',3.333,5),(53,2201,2173,'934',3.333,5),(53,2202,2173,'347',3.333,5),(53,2203,2173,'473',3.333,5),(54,2205,2204,'net',25,5),(54,2206,2204,'eta',25,5),(54,2207,2204,'tap',25,5),(54,2208,2204,'app',25,5),(54,2209,2205,'fib',33.333,5),(54,2210,2205,'ibr',33.333,5),(54,2211,2205,'bre',33.333,5),(54,2212,2209,'cha',20,5),(54,2213,2209,'han',20,5),(54,2214,2209,'ann',20,5),(54,2215,2209,'nne',20,5),(54,2216,2209,'nel',20,5),(54,2217,2212,'dis',50,5),(54,2218,2212,'isk',50,5),(54,2219,2217,'naa',100,5),(54,2220,2219,'600',3.333,5),(54,2221,2219,'00a',3.333,5),(54,2222,2219,'0a0',3.333,5),(54,2223,2219,'a09',3.333,5),(54,2224,2219,'098',3.333,5),(54,2225,2219,'980',3.333,5),(54,2226,2219,'804',3.333,5),(54,2227,2219,'044',3.333,5),(54,2228,2219,'443',3.333,5),(54,2229,2219,'430',3.333,5),(54,2230,2219,'307',3.333,5),(54,2231,2219,'072',3.333,5),(54,2232,2219,'725',3.333,5),(54,2233,2219,'259',3.333,5),(54,2234,2219,'593',3.333,5),(54,2235,2219,'931',3.333,5),(54,2236,2219,'313',3.333,5),(54,2237,2219,'13f',3.333,5),(54,2238,2219,'3f3',3.333,5),(54,2239,2219,'f33',3.333,5),(54,2240,2219,'334',3.333,5),(54,2241,2219,'345',3.333,5),(54,2242,2219,'455',3.333,5),(54,2243,2219,'556',3.333,5),(54,2244,2219,'563',3.333,5),(54,2245,2219,'639',3.333,5),(54,2246,2219,'393',3.333,5),(54,2247,2219,'934',3.333,5),(54,2248,2219,'347',3.333,5),(54,2249,2219,'474',3.333,5),(55,2251,2250,'net',25,5),(55,2252,2250,'eta',25,5),(55,2253,2250,'tap',25,5),(55,2254,2250,'app',25,5),(55,2255,2251,'fib',33.333,5),(55,2256,2251,'ibr',33.333,5),(55,2257,2251,'bre',33.333,5),(55,2258,2255,'cha',20,5),(55,2259,2255,'han',20,5),(55,2260,2255,'ann',20,5),(55,2261,2255,'nne',20,5),(55,2262,2255,'nel',20,5),(55,2263,2258,'dis',50,5),(55,2264,2258,'isk',50,5),(55,2265,2263,'naa',100,5),(55,2266,2265,'600',3.333,5),(55,2267,2265,'00a',3.333,5),(55,2268,2265,'0a0',3.333,5),(55,2269,2265,'a09',3.333,5),(55,2270,2265,'098',3.333,5),(55,2271,2265,'980',3.333,5),(55,2272,2265,'804',3.333,5),(55,2273,2265,'044',3.333,5),(55,2274,2265,'443',3.333,5),(55,2275,2265,'430',3.333,5),(55,2276,2265,'307',3.333,5),(55,2277,2265,'072',3.333,5),(55,2278,2265,'725',3.333,5),(55,2279,2265,'259',3.333,5),(55,2280,2265,'593',3.333,5),(55,2281,2265,'931',3.333,5),(55,2282,2265,'313',3.333,5),(55,2283,2265,'13f',3.333,5),(55,2284,2265,'3f3',3.333,5),(55,2285,2265,'f33',3.333,5),(55,2286,2265,'334',3.333,5),(55,2287,2265,'345',3.333,5),(55,2288,2265,'455',3.333,5),(55,2289,2265,'556',3.333,5),(55,2290,2265,'563',3.333,5),(55,2291,2265,'639',3.333,5),(55,2292,2265,'393',3.333,5),(55,2293,2265,'934',3.333,5),(55,2294,2265,'347',3.333,5),(55,2295,2265,'475',3.333,5),(56,2297,2296,'net',25,5),(56,2298,2296,'eta',25,5),(56,2299,2296,'tap',25,5),(56,2300,2296,'app',25,5),(56,2301,2297,'fib',33.333,5),(56,2302,2297,'ibr',33.333,5),(56,2303,2297,'bre',33.333,5),(56,2304,2301,'cha',20,5),(56,2305,2301,'han',20,5),(56,2306,2301,'ann',20,5),(56,2307,2301,'nne',20,5),(56,2308,2301,'nel',20,5),(56,2309,2304,'dis',50,5),(56,2310,2304,'isk',50,5),(56,2311,2309,'naa',100,5),(56,2312,2311,'600',3.333,5),(56,2313,2311,'00a',3.333,5),(56,2314,2311,'0a0',3.333,5),(56,2315,2311,'a09',3.333,5),(56,2316,2311,'098',3.333,5),(56,2317,2311,'980',3.333,5),(56,2318,2311,'804',3.333,5),(56,2319,2311,'044',3.333,5),(56,2320,2311,'443',3.333,5),(56,2321,2311,'430',3.333,5),(56,2322,2311,'307',3.333,5),(56,2323,2311,'072',3.333,5),(56,2324,2311,'725',3.333,5),(56,2325,2311,'259',3.333,5),(56,2326,2311,'593',3.333,5),(56,2327,2311,'931',3.333,5),(56,2328,2311,'313',3.333,5),(56,2329,2311,'13f',3.333,5),(56,2330,2311,'3f3',3.333,5),(56,2331,2311,'f33',3.333,5),(56,2332,2311,'334',3.333,5),(56,2333,2311,'345',3.333,5),(56,2334,2311,'455',3.333,5),(56,2335,2311,'556',3.333,5),(56,2336,2311,'563',3.333,5),(56,2337,2311,'639',3.333,5),(56,2338,2311,'393',3.333,5),(56,2339,2311,'934',3.333,5),(56,2340,2311,'347',3.333,5),(56,2341,2311,'476',3.333,5),(57,2343,2342,'net',25,5),(57,2344,2342,'eta',25,5),(57,2345,2342,'tap',25,5),(57,2346,2342,'app',25,5),(57,2347,2343,'fib',33.333,5),(57,2348,2343,'ibr',33.333,5),(57,2349,2343,'bre',33.333,5),(57,2350,2347,'cha',20,5),(57,2351,2347,'han',20,5),(57,2352,2347,'ann',20,5),(57,2353,2347,'nne',20,5),(57,2354,2347,'nel',20,5),(57,2355,2350,'dis',50,5),(57,2356,2350,'isk',50,5),(57,2357,2355,'naa',100,5),(57,2358,2357,'600',3.333,5),(57,2359,2357,'00a',3.333,5),(57,2360,2357,'0a0',3.333,5),(57,2361,2357,'a09',3.333,5),(57,2362,2357,'098',3.333,5),(57,2363,2357,'980',3.333,5),(57,2364,2357,'804',3.333,5),(57,2365,2357,'044',3.333,5),(57,2366,2357,'443',3.333,5),(57,2367,2357,'430',3.333,5),(57,2368,2357,'307',3.333,5),(57,2369,2357,'072',3.333,5),(57,2370,2357,'725',3.333,5),(57,2371,2357,'259',3.333,5),(57,2372,2357,'593',3.333,5),(57,2373,2357,'931',3.333,5),(57,2374,2357,'313',3.333,5),(57,2375,2357,'13f',3.333,5),(57,2376,2357,'3f3',3.333,5),(57,2377,2357,'f33',3.333,5),(57,2378,2357,'334',3.333,5),(57,2379,2357,'345',3.333,5),(57,2380,2357,'455',3.333,5),(57,2381,2357,'556',3.333,5),(57,2382,2357,'563',3.333,5),(57,2383,2357,'639',3.333,5),(57,2384,2357,'393',3.333,5),(57,2385,2357,'934',3.333,5),(57,2386,2357,'347',3.333,5),(57,2387,2357,'477',3.333,5),(58,2389,2388,'net',25,5),(58,2390,2388,'eta',25,5),(58,2391,2388,'tap',25,5),(58,2392,2388,'app',25,5),(58,2393,2389,'ser',25,5),(58,2394,2389,'eri',25,5),(58,2395,2389,'ria',25,5),(58,2396,2389,'ial',25,5),(58,2397,2393,'att',16.667,5),(58,2398,2393,'tta',16.667,5),(58,2399,2393,'tac',16.667,5),(58,2400,2393,'ach',16.667,5),(58,2401,2393,'che',16.667,5),(58,2402,2393,'hed',16.667,5),(58,2403,2397,'scs',50,5),(58,2404,2397,'csi',50,5),(58,2405,2403,'dis',50,5),(58,2406,2403,'isk',50,5),(58,2407,2405,'naa',100,5),(58,2408,2407,'600',3.333,5),(58,2409,2407,'00a',3.333,5),(58,2410,2407,'0a0',3.333,5),(58,2411,2407,'a09',3.333,5),(58,2412,2407,'098',3.333,5),(58,2413,2407,'980',3.333,5),(58,2414,2407,'804',3.333,5),(58,2415,2407,'04c',3.333,5),(58,2416,2407,'4c5',3.333,5),(58,2417,2407,'c53',3.333,5),(58,2418,2407,'538',3.333,5),(58,2419,2407,'384',3.333,5),(58,2420,2407,'84e',3.333,5),(58,2421,2407,'4ee',3.333,5),(58,2422,2407,'ee1',3.333,5),(58,2423,2407,'e1f',3.333,5),(58,2424,2407,'1fa',3.333,5),(58,2425,2407,'fa8',3.333,5),(58,2426,2407,'a84',3.333,5),(58,2427,2407,'84a',3.333,5),(58,2428,2407,'4a1',3.333,5),(58,2429,2407,'a11',3.333,5),(58,2430,2407,'117',3.333,5),(58,2431,2407,'17b',3.333,5),(58,2432,2407,'7b0',3.333,5),(58,2433,2407,'b08',3.333,5),(58,2434,2407,'08a',3.333,5),(58,2435,2407,'8ab',3.333,5),(58,2436,2407,'aba',3.333,5),(58,2437,2407,'ba2',3.333,5),(59,2486,2485,'net',25,5),(59,2487,2485,'eta',25,5),(59,2488,2485,'tap',25,5),(59,2489,2485,'app',25,5),(59,2490,2486,'fib',33.333,5),(59,2491,2486,'ibr',33.333,5),(59,2492,2486,'bre',33.333,5),(59,2493,2490,'cha',20,5),(59,2494,2490,'han',20,5),(59,2495,2490,'ann',20,5),(59,2496,2490,'nne',20,5),(59,2497,2490,'nel',20,5),(59,2498,2493,'dis',50,5),(59,2499,2493,'isk',50,5),(59,2500,2498,'naa',100,5),(59,2501,2500,'600',3.333,5),(59,2502,2500,'00a',3.333,5),(59,2503,2500,'0a0',3.333,5),(59,2504,2500,'a09',3.333,5),(59,2505,2500,'098',3.333,5),(59,2506,2500,'980',3.333,5),(59,2507,2500,'804',3.333,5),(59,2508,2500,'044',3.333,5),(59,2509,2500,'443',3.333,5),(59,2510,2500,'430',3.333,5),(59,2511,2500,'307',3.333,5),(59,2512,2500,'072',3.333,5),(59,2513,2500,'725',3.333,5),(59,2514,2500,'259',3.333,5),(59,2515,2500,'593',3.333,5),(59,2516,2500,'931',3.333,5),(59,2517,2500,'313',3.333,5),(59,2518,2500,'13f',3.333,5),(59,2519,2500,'3f3',3.333,5),(59,2520,2500,'f33',3.333,5),(59,2521,2500,'334',3.333,5),(59,2522,2500,'345',3.333,5),(59,2523,2500,'455',3.333,5),(59,2524,2500,'556',3.333,5),(59,2525,2500,'563',3.333,5),(59,2526,2500,'639',3.333,5),(59,2527,2500,'393',3.333,5),(59,2528,2500,'934',3.333,5),(59,2529,2500,'347',3.333,5),(59,2530,2500,'478',3.333,5),(60,2532,2531,'net',25,5),(60,2533,2531,'eta',25,5),(60,2534,2531,'tap',25,5),(60,2535,2531,'app',25,5),(60,2536,2532,'fib',33.333,5),(60,2537,2532,'ibr',33.333,5),(60,2538,2532,'bre',33.333,5),(60,2539,2536,'cha',20,5),(60,2540,2536,'han',20,5),(60,2541,2536,'ann',20,5),(60,2542,2536,'nne',20,5),(60,2543,2536,'nel',20,5),(60,2544,2539,'dis',50,5),(60,2545,2539,'isk',50,5),(60,2546,2544,'naa',100,5),(60,2547,2546,'600',3.333,5),(60,2548,2546,'00a',3.333,5),(60,2549,2546,'0a0',3.333,5),(60,2550,2546,'a09',3.333,5),(60,2551,2546,'098',3.333,5),(60,2552,2546,'980',3.333,5),(60,2553,2546,'804',3.333,5),(60,2554,2546,'044',3.333,5),(60,2555,2546,'443',3.333,5),(60,2556,2546,'430',3.333,5),(60,2557,2546,'307',3.333,5),(60,2558,2546,'072',3.333,5),(60,2559,2546,'725',3.333,5),(60,2560,2546,'259',3.333,5),(60,2561,2546,'593',3.333,5),(60,2562,2546,'931',3.333,5),(60,2563,2546,'313',3.333,5),(60,2564,2546,'13f',3.333,5),(60,2565,2546,'3f3',3.333,5),(60,2566,2546,'f33',3.333,5),(60,2567,2546,'334',3.333,5),(60,2568,2546,'345',3.333,5),(60,2569,2546,'455',3.333,5),(60,2570,2546,'556',3.333,5),(60,2571,2546,'563',3.333,5),(60,2572,2546,'639',3.333,5),(60,2573,2546,'393',3.333,5),(60,2574,2546,'934',3.333,5),(60,2575,2546,'347',3.333,5),(60,2576,2546,'479',3.333,5),(61,2578,2577,'net',25,5),(61,2579,2577,'eta',25,5),(61,2580,2577,'tap',25,5),(61,2581,2577,'app',25,5),(61,2582,2578,'ser',25,5),(61,2583,2578,'eri',25,5),(61,2584,2578,'ria',25,5),(61,2585,2578,'ial',25,5),(61,2586,2582,'att',16.667,5),(61,2587,2582,'tta',16.667,5),(61,2588,2582,'tac',16.667,5),(61,2589,2582,'ach',16.667,5),(61,2590,2582,'che',16.667,5),(61,2591,2582,'hed',16.667,5),(61,2592,2586,'scs',50,5),(61,2593,2586,'csi',50,5),(61,2594,2592,'dis',50,5),(61,2595,2592,'isk',50,5),(61,2596,2594,'naa',100,5),(61,2597,2596,'600',3.333,5),(61,2598,2596,'00a',3.333,5),(61,2599,2596,'0a0',3.333,5),(61,2600,2596,'a09',3.333,5),(61,2601,2596,'098',3.333,5),(61,2602,2596,'980',3.333,5),(61,2603,2596,'803',3.333,5),(61,2604,2596,'034',3.333,5),(61,2605,2596,'343',3.333,5),(61,2606,2596,'436',3.333,5),(61,2607,2596,'368',3.333,5),(61,2608,2596,'684',3.333,5),(61,2609,2596,'84e',3.333,5),(61,2610,2596,'4ee',3.333,5),(61,2611,2596,'eef',3.333,5),(61,2612,2596,'ef3',3.333,5),(61,2613,2596,'f3e',3.333,5),(61,2614,2596,'3ed',3.333,5),(61,2615,2596,'ed3',3.333,5),(61,2616,2596,'d3f',3.333,5),(61,2617,2596,'3f1',3.333,5),(61,2618,2596,'f11',3.333,5),(61,2619,2596,'117',3.333,5),(61,2620,2596,'17b',3.333,5),(61,2621,2596,'7b0',3.333,5),(61,2622,2596,'b02',3.333,5),(61,2623,2596,'02a',3.333,5),(61,2624,2596,'2ab',3.333,5),(61,2625,2596,'aba',3.333,5),(61,2626,2596,'ba2',3.333,5),(62,2628,2627,'net',25,5),(62,2629,2627,'eta',25,5),(62,2630,2627,'tap',25,5),(62,2631,2627,'app',25,5),(62,2632,2628,'ser',25,5),(62,2633,2628,'eri',25,5),(62,2634,2628,'ria',25,5),(62,2635,2628,'ial',25,5),(62,2636,2632,'att',16.667,5),(62,2637,2632,'tta',16.667,5),(62,2638,2632,'tac',16.667,5),(62,2639,2632,'ach',16.667,5),(62,2640,2632,'che',16.667,5),(62,2641,2632,'hed',16.667,5),(62,2642,2636,'scs',50,5),(62,2643,2636,'csi',50,5),(62,2644,2642,'dis',50,5),(62,2645,2642,'isk',50,5),(62,2646,2644,'naa',100,5),(62,2647,2646,'600',3.333,5),(62,2648,2646,'00a',3.333,5),(62,2649,2646,'0a0',3.333,5),(62,2650,2646,'a09',3.333,5),(62,2651,2646,'098',3.333,5),(62,2652,2646,'980',3.333,5),(62,2653,2646,'808',3.333,5),(62,2654,2646,'08b',3.333,5),(62,2655,2646,'8b4',3.333,5),(62,2656,2646,'b4f',3.333,5),(62,2657,2646,'4f8',3.333,5),(62,2658,2646,'f84',3.333,5),(62,2659,2646,'84e',3.333,5),(62,2660,2646,'4ee',3.333,5),(62,2661,2646,'ee1',3.333,5),(62,2662,2646,'e1b',3.333,5),(62,2663,2646,'1b4',3.333,5),(62,2664,2646,'b44',3.333,5),(62,2665,2646,'444',3.333,5),(62,2666,2646,'448',3.333,5),(62,2667,2646,'481',3.333,5),(62,2668,2646,'811',3.333,5),(62,2669,2646,'117',3.333,5),(62,2670,2646,'17b',3.333,5),(62,2671,2646,'7b0',3.333,5),(62,2672,2646,'b07',3.333,5),(62,2673,2646,'07a',3.333,5),(62,2674,2646,'7ab',3.333,5),(62,2675,2646,'aba',3.333,5),(62,2676,2646,'ba2',3.333,5),(63,2678,2677,'net',25,5),(63,2679,2677,'eta',25,5),(63,2680,2677,'tap',25,5),(63,2681,2677,'app',25,5),(63,2682,2678,'fib',33.333,5),(63,2683,2678,'ibr',33.333,5),(63,2684,2678,'bre',33.333,5),(63,2685,2682,'cha',20,5),(63,2686,2682,'han',20,5),(63,2687,2682,'ann',20,5),(63,2688,2682,'nne',20,5),(63,2689,2682,'nel',20,5),(63,2690,2685,'dis',50,5),(63,2691,2685,'isk',50,5),(63,2692,2690,'naa',100,5),(63,2693,2692,'600',3.333,5),(63,2694,2692,'00a',3.333,5),(63,2695,2692,'0a0',3.333,5),(63,2696,2692,'a09',3.333,5),(63,2697,2692,'098',3.333,5),(63,2698,2692,'980',3.333,5),(63,2699,2692,'804',3.333,5),(63,2700,2692,'044',3.333,5),(63,2701,2692,'443',3.333,5),(63,2702,2692,'430',3.333,5),(63,2703,2692,'307',3.333,5),(63,2704,2692,'072',3.333,5),(63,2705,2692,'725',3.333,5),(63,2706,2692,'259',3.333,5),(63,2707,2692,'593',3.333,5),(63,2708,2692,'931',3.333,5),(63,2709,2692,'313',3.333,5),(63,2710,2692,'13f',3.333,5),(63,2711,2692,'3f3',3.333,5),(63,2712,2692,'f33',3.333,5),(63,2713,2692,'334',3.333,5),(63,2714,2692,'345',3.333,5),(63,2715,2692,'455',3.333,5),(63,2716,2692,'556',3.333,5),(63,2717,2692,'563',3.333,5),(63,2718,2692,'639',3.333,5),(63,2719,2692,'393',3.333,5),(63,2720,2692,'934',3.333,5),(63,2721,2692,'347',3.333,5),(63,2722,2692,'47a',3.333,5),(64,2724,2723,'net',25,5),(64,2725,2723,'eta',25,5),(64,2726,2723,'tap',25,5),(64,2727,2723,'app',25,5),(64,2728,2724,'fib',33.333,5),(64,2729,2724,'ibr',33.333,5),(64,2730,2724,'bre',33.333,5),(64,2731,2728,'cha',20,5),(64,2732,2728,'han',20,5),(64,2733,2728,'ann',20,5),(64,2734,2728,'nne',20,5),(64,2735,2728,'nel',20,5),(64,2736,2731,'dis',50,5),(64,2737,2731,'isk',50,5),(64,2738,2736,'naa',100,5),(64,2739,2738,'600',3.333,5),(64,2740,2738,'00a',3.333,5),(64,2741,2738,'0a0',3.333,5),(64,2742,2738,'a09',3.333,5),(64,2743,2738,'098',3.333,5),(64,2744,2738,'980',3.333,5),(64,2745,2738,'804',3.333,5),(64,2746,2738,'044',3.333,5),(64,2747,2738,'443',3.333,5),(64,2748,2738,'430',3.333,5),(64,2749,2738,'307',3.333,5),(64,2750,2738,'075',3.333,5),(64,2751,2738,'753',3.333,5),(64,2752,2738,'535',3.333,5),(64,2753,2738,'357',3.333,5),(64,2754,2738,'573',3.333,5),(64,2755,2738,'732',3.333,5),(64,2756,2738,'32b',3.333,5),(64,2757,2738,'2b3',3.333,5),(64,2758,2738,'b33',3.333,5),(64,2759,2738,'334',3.333,5),(64,2760,2738,'345',3.333,5),(64,2761,2738,'457',3.333,5),(64,2762,2738,'571',3.333,5),(64,2763,2738,'715',3.333,5),(64,2764,2738,'153',3.333,5),(64,2765,2738,'533',3.333,5),(64,2766,2738,'335',3.333,5),(64,2767,2738,'356',3.333,5),(64,2768,2738,'561',3.333,5),(65,2770,2769,'net',25,5),(65,2771,2769,'eta',25,5),(65,2772,2769,'tap',25,5),(65,2773,2769,'app',25,5),(65,2774,2770,'fib',33.333,5),(65,2775,2770,'ibr',33.333,5),(65,2776,2770,'bre',33.333,5),(65,2777,2774,'cha',20,5),(65,2778,2774,'han',20,5),(65,2779,2774,'ann',20,5),(65,2780,2774,'nne',20,5),(65,2781,2774,'nel',20,5),(65,2782,2777,'dis',50,5),(65,2783,2777,'isk',50,5),(65,2784,2782,'naa',100,5),(65,2785,2784,'600',3.333,5),(65,2786,2784,'00a',3.333,5),(65,2787,2784,'0a0',3.333,5),(65,2788,2784,'a09',3.333,5),(65,2789,2784,'098',3.333,5),(65,2790,2784,'980',3.333,5),(65,2791,2784,'804',3.333,5),(65,2792,2784,'044',3.333,5),(65,2793,2784,'443',3.333,5),(65,2794,2784,'430',3.333,5),(65,2795,2784,'307',3.333,5),(65,2796,2784,'075',3.333,5),(65,2797,2784,'753',3.333,5),(65,2798,2784,'535',3.333,5),(65,2799,2784,'357',3.333,5),(65,2800,2784,'573',3.333,5),(65,2801,2784,'732',3.333,5),(65,2802,2784,'32b',3.333,5),(65,2803,2784,'2b3',3.333,5),(65,2804,2784,'b33',3.333,5),(65,2805,2784,'334',3.333,5),(65,2806,2784,'345',3.333,5),(65,2807,2784,'457',3.333,5),(65,2808,2784,'571',3.333,5),(65,2809,2784,'715',3.333,5),(65,2810,2784,'153',3.333,5),(65,2811,2784,'533',3.333,5),(65,2812,2784,'335',3.333,5),(65,2813,2784,'356',3.333,5),(65,2814,2784,'562',3.333,5),(66,2816,2815,'net',25,5),(66,2817,2815,'eta',25,5),(66,2818,2815,'tap',25,5),(66,2819,2815,'app',25,5),(66,2820,2816,'fib',33.333,5),(66,2821,2816,'ibr',33.333,5),(66,2822,2816,'bre',33.333,5),(66,2823,2820,'cha',20,5),(66,2824,2820,'han',20,5),(66,2825,2820,'ann',20,5),(66,2826,2820,'nne',20,5),(66,2827,2820,'nel',20,5),(66,2828,2823,'dis',50,5),(66,2829,2823,'isk',50,5),(66,2830,2828,'naa',100,5),(66,2831,2830,'600',3.333,5),(66,2832,2830,'00a',3.333,5),(66,2833,2830,'0a0',3.333,5),(66,2834,2830,'a09',3.333,5),(66,2835,2830,'098',3.333,5),(66,2836,2830,'980',3.333,5),(66,2837,2830,'804',3.333,5),(66,2838,2830,'044',3.333,5),(66,2839,2830,'443',3.333,5),(66,2840,2830,'430',3.333,5),(66,2841,2830,'307',3.333,5),(66,2842,2830,'075',3.333,5),(66,2843,2830,'753',3.333,5),(66,2844,2830,'535',3.333,5),(66,2845,2830,'357',3.333,5),(66,2846,2830,'573',3.333,5),(66,2847,2830,'732',3.333,5),(66,2848,2830,'32b',3.333,5),(66,2849,2830,'2b3',3.333,5),(66,2850,2830,'b33',3.333,5),(66,2851,2830,'334',3.333,5),(66,2852,2830,'345',3.333,5),(66,2853,2830,'457',3.333,5),(66,2854,2830,'571',3.333,5),(66,2855,2830,'715',3.333,5),(66,2856,2830,'153',3.333,5),(66,2857,2830,'533',3.333,5),(66,2858,2830,'335',3.333,5),(66,2859,2830,'356',3.333,5),(66,2860,2830,'563',3.333,5),(67,2862,2861,'net',25,5),(67,2863,2861,'eta',25,5),(67,2864,2861,'tap',25,5),(67,2865,2861,'app',25,5),(67,2866,2862,'fib',33.333,5),(67,2867,2862,'ibr',33.333,5),(67,2868,2862,'bre',33.333,5),(67,2869,2866,'cha',20,5),(67,2870,2866,'han',20,5),(67,2871,2866,'ann',20,5),(67,2872,2866,'nne',20,5),(67,2873,2866,'nel',20,5),(67,2874,2869,'dis',50,5),(67,2875,2869,'isk',50,5),(67,2876,2874,'naa',100,5),(67,2877,2876,'600',3.333,5),(67,2878,2876,'00a',3.333,5),(67,2879,2876,'0a0',3.333,5),(67,2880,2876,'a09',3.333,5),(67,2881,2876,'098',3.333,5),(67,2882,2876,'980',3.333,5),(67,2883,2876,'804',3.333,5),(67,2884,2876,'044',3.333,5),(67,2885,2876,'443',3.333,5),(67,2886,2876,'430',3.333,5),(67,2887,2876,'307',3.333,5),(67,2888,2876,'075',3.333,5),(67,2889,2876,'753',3.333,5),(67,2890,2876,'535',3.333,5),(67,2891,2876,'357',3.333,5),(67,2892,2876,'573',3.333,5),(67,2893,2876,'732',3.333,5),(67,2894,2876,'32b',3.333,5),(67,2895,2876,'2b3',3.333,5),(67,2896,2876,'b33',3.333,5),(67,2897,2876,'334',3.333,5),(67,2898,2876,'345',3.333,5),(67,2899,2876,'457',3.333,5),(67,2900,2876,'571',3.333,5),(67,2901,2876,'715',3.333,5),(67,2902,2876,'153',3.333,5),(67,2903,2876,'533',3.333,5),(67,2904,2876,'335',3.333,5),(67,2905,2876,'356',3.333,5),(67,2906,2876,'564',3.333,5),(68,2908,2907,'net',25,5),(68,2909,2907,'eta',25,5),(68,2910,2907,'tap',25,5),(68,2911,2907,'app',25,5),(68,2912,2908,'fib',33.333,5),(68,2913,2908,'ibr',33.333,5),(68,2914,2908,'bre',33.333,5),(68,2915,2912,'cha',20,5),(68,2916,2912,'han',20,5),(68,2917,2912,'ann',20,5),(68,2918,2912,'nne',20,5),(68,2919,2912,'nel',20,5),(68,2920,2915,'dis',50,5),(68,2921,2915,'isk',50,5),(68,2922,2920,'naa',100,5),(68,2923,2922,'600',3.333,5),(68,2924,2922,'00a',3.333,5),(68,2925,2922,'0a0',3.333,5),(68,2926,2922,'a09',3.333,5),(68,2927,2922,'098',3.333,5),(68,2928,2922,'980',3.333,5),(68,2929,2922,'804',3.333,5),(68,2930,2922,'044',3.333,5),(68,2931,2922,'443',3.333,5),(68,2932,2922,'430',3.333,5),(68,2933,2922,'307',3.333,5),(68,2934,2922,'075',3.333,5),(68,2935,2922,'753',3.333,5),(68,2936,2922,'535',3.333,5),(68,2937,2922,'357',3.333,5),(68,2938,2922,'573',3.333,5),(68,2939,2922,'732',3.333,5),(68,2940,2922,'32b',3.333,5),(68,2941,2922,'2b3',3.333,5),(68,2942,2922,'b33',3.333,5),(68,2943,2922,'334',3.333,5),(68,2944,2922,'345',3.333,5),(68,2945,2922,'457',3.333,5),(68,2946,2922,'571',3.333,5),(68,2947,2922,'715',3.333,5),(68,2948,2922,'153',3.333,5),(68,2949,2922,'533',3.333,5),(68,2950,2922,'336',3.333,5),(68,2951,2922,'364',3.333,5),(68,2952,2922,'641',3.333,5),(69,2954,2953,'net',25,5),(69,2955,2953,'eta',25,5),(69,2956,2953,'tap',25,5),(69,2957,2953,'app',25,5),(69,2958,2954,'fib',33.333,5),(69,2959,2954,'ibr',33.333,5),(69,2960,2954,'bre',33.333,5),(69,2961,2958,'cha',20,5),(69,2962,2958,'han',20,5),(69,2963,2958,'ann',20,5),(69,2964,2958,'nne',20,5),(69,2965,2958,'nel',20,5),(69,2966,2961,'dis',50,5),(69,2967,2961,'isk',50,5),(69,2968,2966,'naa',100,5),(69,2969,2968,'600',3.333,5),(69,2970,2968,'00a',3.333,5),(69,2971,2968,'0a0',3.333,5),(69,2972,2968,'a09',3.333,5),(69,2973,2968,'098',3.333,5),(69,2974,2968,'980',3.333,5),(69,2975,2968,'804',3.333,5),(69,2976,2968,'044',3.333,5),(69,2977,2968,'443',3.333,5),(69,2978,2968,'430',3.333,5),(69,2979,2968,'307',3.333,5),(69,2980,2968,'075',3.333,5),(69,2981,2968,'753',3.333,5),(69,2982,2968,'535',3.333,5),(69,2983,2968,'357',3.333,5),(69,2984,2968,'573',3.333,5),(69,2985,2968,'732',3.333,5),(69,2986,2968,'32b',3.333,5),(69,2987,2968,'2b3',3.333,5),(69,2988,2968,'b33',3.333,5),(69,2989,2968,'334',3.333,5),(69,2990,2968,'345',3.333,5),(69,2991,2968,'457',3.333,5),(69,2992,2968,'571',3.333,5),(69,2993,2968,'715',3.333,5),(69,2994,2968,'153',3.333,5),(69,2995,2968,'533',3.333,5),(69,2996,2968,'335',3.333,5),(69,2997,2968,'356',3.333,5),(69,2998,2968,'565',3.333,5),(70,3000,2999,'net',25,5),(70,3001,2999,'eta',25,5),(70,3002,2999,'tap',25,5),(70,3003,2999,'app',25,5),(70,3004,3000,'fib',33.333,5),(70,3005,3000,'ibr',33.333,5),(70,3006,3000,'bre',33.333,5),(70,3007,3004,'cha',20,5),(70,3008,3004,'han',20,5),(70,3009,3004,'ann',20,5),(70,3010,3004,'nne',20,5),(70,3011,3004,'nel',20,5),(70,3012,3007,'dis',50,5),(70,3013,3007,'isk',50,5),(70,3014,3012,'naa',100,5),(70,3015,3014,'600',3.333,5),(70,3016,3014,'00a',3.333,5),(70,3017,3014,'0a0',3.333,5),(70,3018,3014,'a09',3.333,5),(70,3019,3014,'098',3.333,5),(70,3020,3014,'980',3.333,5),(70,3021,3014,'804',3.333,5),(70,3022,3014,'044',3.333,5),(70,3023,3014,'443',3.333,5),(70,3024,3014,'430',3.333,5),(70,3025,3014,'307',3.333,5),(70,3026,3014,'075',3.333,5),(70,3027,3014,'753',3.333,5),(70,3028,3014,'535',3.333,5),(70,3029,3014,'357',3.333,5),(70,3030,3014,'573',3.333,5),(70,3031,3014,'732',3.333,5),(70,3032,3014,'32b',3.333,5),(70,3033,3014,'2b3',3.333,5),(70,3034,3014,'b33',3.333,5),(70,3035,3014,'334',3.333,5),(70,3036,3014,'345',3.333,5),(70,3037,3014,'457',3.333,5),(70,3038,3014,'571',3.333,5),(70,3039,3014,'715',3.333,5),(70,3040,3014,'153',3.333,5),(70,3041,3014,'533',3.333,5),(70,3042,3014,'336',3.333,5),(70,3043,3014,'364',3.333,5),(70,3044,3014,'642',3.333,5),(71,3046,3045,'net',25,5),(71,3047,3045,'eta',25,5),(71,3048,3045,'tap',25,5),(71,3049,3045,'app',25,5),(71,3050,3046,'fib',33.333,5),(71,3051,3046,'ibr',33.333,5),(71,3052,3046,'bre',33.333,5),(71,3053,3050,'cha',20,5),(71,3054,3050,'han',20,5),(71,3055,3050,'ann',20,5),(71,3056,3050,'nne',20,5),(71,3057,3050,'nel',20,5),(71,3058,3053,'dis',50,5),(71,3059,3053,'isk',50,5),(71,3060,3058,'naa',100,5),(71,3061,3060,'600',3.333,5),(71,3062,3060,'00a',3.333,5),(71,3063,3060,'0a0',3.333,5),(71,3064,3060,'a09',3.333,5),(71,3065,3060,'098',3.333,5),(71,3066,3060,'980',3.333,5),(71,3067,3060,'804',3.333,5),(71,3068,3060,'044',3.333,5),(71,3069,3060,'443',3.333,5),(71,3070,3060,'430',3.333,5),(71,3071,3060,'307',3.333,5),(71,3072,3060,'075',3.333,5),(71,3073,3060,'753',3.333,5),(71,3074,3060,'535',3.333,5),(71,3075,3060,'357',3.333,5),(71,3076,3060,'573',3.333,5),(71,3077,3060,'732',3.333,5),(71,3078,3060,'32b',3.333,5),(71,3079,3060,'2b3',3.333,5),(71,3080,3060,'b33',3.333,5),(71,3081,3060,'334',3.333,5),(71,3082,3060,'345',3.333,5),(71,3083,3060,'457',3.333,5),(71,3084,3060,'571',3.333,5),(71,3085,3060,'715',3.333,5),(71,3086,3060,'153',3.333,5),(71,3087,3060,'533',3.333,5),(71,3088,3060,'335',3.333,5),(71,3089,3060,'356',3.333,5),(71,3090,3060,'566',3.333,5),(72,3092,3091,'net',25,5),(72,3093,3091,'eta',25,5),(72,3094,3091,'tap',25,5),(72,3095,3091,'app',25,5),(72,3096,3092,'fib',33.333,5),(72,3097,3092,'ibr',33.333,5),(72,3098,3092,'bre',33.333,5),(72,3099,3096,'cha',20,5),(72,3100,3096,'han',20,5),(72,3101,3096,'ann',20,5),(72,3102,3096,'nne',20,5),(72,3103,3096,'nel',20,5),(72,3104,3099,'dis',50,5),(72,3105,3099,'isk',50,5),(72,3106,3104,'naa',100,5),(72,3107,3106,'600',3.333,5),(72,3108,3106,'00a',3.333,5),(72,3109,3106,'0a0',3.333,5),(72,3110,3106,'a09',3.333,5),(72,3111,3106,'098',3.333,5),(72,3112,3106,'980',3.333,5),(72,3113,3106,'804',3.333,5),(72,3114,3106,'044',3.333,5),(72,3115,3106,'443',3.333,5),(72,3116,3106,'430',3.333,5),(72,3117,3106,'307',3.333,5),(72,3118,3106,'075',3.333,5),(72,3119,3106,'753',3.333,5),(72,3120,3106,'535',3.333,5),(72,3121,3106,'357',3.333,5),(72,3122,3106,'573',3.333,5),(72,3123,3106,'732',3.333,5),(72,3124,3106,'32b',3.333,5),(72,3125,3106,'2b3',3.333,5),(72,3126,3106,'b33',3.333,5),(72,3127,3106,'334',3.333,5),(72,3128,3106,'345',3.333,5),(72,3129,3106,'457',3.333,5),(72,3130,3106,'571',3.333,5),(72,3131,3106,'715',3.333,5),(72,3132,3106,'153',3.333,5),(72,3133,3106,'533',3.333,5),(72,3134,3106,'336',3.333,5),(72,3135,3106,'364',3.333,5),(72,3136,3106,'643',3.333,5),(73,3138,3137,'net',25,5),(73,3139,3137,'eta',25,5),(73,3140,3137,'tap',25,5),(73,3141,3137,'app',25,5),(73,3142,3138,'fib',33.333,5),(73,3143,3138,'ibr',33.333,5),(73,3144,3138,'bre',33.333,5),(73,3145,3142,'cha',20,5),(73,3146,3142,'han',20,5),(73,3147,3142,'ann',20,5),(73,3148,3142,'nne',20,5),(73,3149,3142,'nel',20,5),(73,3150,3145,'dis',50,5),(73,3151,3145,'isk',50,5),(73,3152,3150,'naa',100,5),(73,3153,3152,'600',3.333,5),(73,3154,3152,'00a',3.333,5),(73,3155,3152,'0a0',3.333,5),(73,3156,3152,'a09',3.333,5),(73,3157,3152,'098',3.333,5),(73,3158,3152,'980',3.333,5),(73,3159,3152,'804',3.333,5),(73,3160,3152,'044',3.333,5),(73,3161,3152,'443',3.333,5),(73,3162,3152,'430',3.333,5),(73,3163,3152,'307',3.333,5),(73,3164,3152,'075',3.333,5),(73,3165,3152,'753',3.333,5),(73,3166,3152,'535',3.333,5),(73,3167,3152,'357',3.333,5),(73,3168,3152,'573',3.333,5),(73,3169,3152,'732',3.333,5),(73,3170,3152,'32b',3.333,5),(73,3171,3152,'2b3',3.333,5),(73,3172,3152,'b33',3.333,5),(73,3173,3152,'334',3.333,5),(73,3174,3152,'345',3.333,5),(73,3175,3152,'457',3.333,5),(73,3176,3152,'571',3.333,5),(73,3177,3152,'715',3.333,5),(73,3178,3152,'153',3.333,5),(73,3179,3152,'533',3.333,5),(73,3180,3152,'335',3.333,5),(73,3181,3152,'356',3.333,5),(73,3182,3152,'567',3.333,5),(74,3184,3183,'net',25,5),(74,3185,3183,'eta',25,5),(74,3186,3183,'tap',25,5),(74,3187,3183,'app',25,5),(74,3188,3184,'fib',33.333,5),(74,3189,3184,'ibr',33.333,5),(74,3190,3184,'bre',33.333,5),(74,3191,3188,'cha',20,5),(74,3192,3188,'han',20,5),(74,3193,3188,'ann',20,5),(74,3194,3188,'nne',20,5),(74,3195,3188,'nel',20,5),(74,3196,3191,'dis',50,5),(74,3197,3191,'isk',50,5),(74,3198,3196,'naa',100,5),(74,3199,3198,'600',3.333,5),(74,3200,3198,'00a',3.333,5),(74,3201,3198,'0a0',3.333,5),(74,3202,3198,'a09',3.333,5),(74,3203,3198,'098',3.333,5),(74,3204,3198,'980',3.333,5),(74,3205,3198,'804',3.333,5),(74,3206,3198,'044',3.333,5),(74,3207,3198,'443',3.333,5),(74,3208,3198,'430',3.333,5),(74,3209,3198,'307',3.333,5),(74,3210,3198,'075',3.333,5),(74,3211,3198,'753',3.333,5),(74,3212,3198,'535',3.333,5),(74,3213,3198,'357',3.333,5),(74,3214,3198,'573',3.333,5),(74,3215,3198,'732',3.333,5),(74,3216,3198,'32b',3.333,5),(74,3217,3198,'2b3',3.333,5),(74,3218,3198,'b33',3.333,5),(74,3219,3198,'334',3.333,5),(74,3220,3198,'345',3.333,5),(74,3221,3198,'457',3.333,5),(74,3222,3198,'571',3.333,5),(74,3223,3198,'715',3.333,5),(74,3224,3198,'153',3.333,5),(74,3225,3198,'533',3.333,5),(74,3226,3198,'336',3.333,5),(74,3227,3198,'364',3.333,5),(74,3228,3198,'644',3.333,5),(75,3230,3229,'net',25,5),(75,3231,3229,'eta',25,5),(75,3232,3229,'tap',25,5),(75,3233,3229,'app',25,5),(75,3234,3230,'fib',33.333,5),(75,3235,3230,'ibr',33.333,5),(75,3236,3230,'bre',33.333,5),(75,3237,3234,'cha',20,5),(75,3238,3234,'han',20,5),(75,3239,3234,'ann',20,5),(75,3240,3234,'nne',20,5),(75,3241,3234,'nel',20,5),(75,3242,3237,'dis',50,5),(75,3243,3237,'isk',50,5),(75,3244,3242,'naa',100,5),(75,3245,3244,'600',3.333,5),(75,3246,3244,'00a',3.333,5),(75,3247,3244,'0a0',3.333,5),(75,3248,3244,'a09',3.333,5),(75,3249,3244,'098',3.333,5),(75,3250,3244,'980',3.333,5),(75,3251,3244,'804',3.333,5),(75,3252,3244,'044',3.333,5),(75,3253,3244,'443',3.333,5),(75,3254,3244,'430',3.333,5),(75,3255,3244,'307',3.333,5),(75,3256,3244,'075',3.333,5),(75,3257,3244,'753',3.333,5),(75,3258,3244,'535',3.333,5),(75,3259,3244,'357',3.333,5),(75,3260,3244,'573',3.333,5),(75,3261,3244,'732',3.333,5),(75,3262,3244,'32b',3.333,5),(75,3263,3244,'2b3',3.333,5),(75,3264,3244,'b33',3.333,5),(75,3265,3244,'334',3.333,5),(75,3266,3244,'345',3.333,5),(75,3267,3244,'457',3.333,5),(75,3268,3244,'571',3.333,5),(75,3269,3244,'715',3.333,5),(75,3270,3244,'153',3.333,5),(75,3271,3244,'533',3.333,5),(75,3272,3244,'335',3.333,5),(75,3273,3244,'356',3.333,5),(75,3274,3244,'568',3.333,5),(76,3276,3275,'net',25,5),(76,3277,3275,'eta',25,5),(76,3278,3275,'tap',25,5),(76,3279,3275,'app',25,5),(76,3280,3276,'fib',33.333,5),(76,3281,3276,'ibr',33.333,5),(76,3282,3276,'bre',33.333,5),(76,3283,3280,'cha',20,5),(76,3284,3280,'han',20,5),(76,3285,3280,'ann',20,5),(76,3286,3280,'nne',20,5),(76,3287,3280,'nel',20,5),(76,3288,3283,'dis',50,5),(76,3289,3283,'isk',50,5),(76,3290,3288,'naa',100,5),(76,3291,3290,'600',3.333,5),(76,3292,3290,'00a',3.333,5),(76,3293,3290,'0a0',3.333,5),(76,3294,3290,'a09',3.333,5),(76,3295,3290,'098',3.333,5),(76,3296,3290,'980',3.333,5),(76,3297,3290,'804',3.333,5),(76,3298,3290,'044',3.333,5),(76,3299,3290,'443',3.333,5),(76,3300,3290,'430',3.333,5),(76,3301,3290,'307',3.333,5),(76,3302,3290,'075',3.333,5),(76,3303,3290,'753',3.333,5),(76,3304,3290,'535',3.333,5),(76,3305,3290,'357',3.333,5),(76,3306,3290,'573',3.333,5),(76,3307,3290,'732',3.333,5),(76,3308,3290,'32b',3.333,5),(76,3309,3290,'2b3',3.333,5),(76,3310,3290,'b33',3.333,5),(76,3311,3290,'334',3.333,5),(76,3312,3290,'345',3.333,5),(76,3313,3290,'457',3.333,5),(76,3314,3290,'571',3.333,5),(76,3315,3290,'715',3.333,5),(76,3316,3290,'153',3.333,5),(76,3317,3290,'533',3.333,5),(76,3318,3290,'336',3.333,5),(76,3319,3290,'364',3.333,5),(76,3320,3290,'645',3.333,5),(77,3322,3321,'net',25,5),(77,3323,3321,'eta',25,5),(77,3324,3321,'tap',25,5),(77,3325,3321,'app',25,5),(77,3326,3322,'fib',33.333,5),(77,3327,3322,'ibr',33.333,5),(77,3328,3322,'bre',33.333,5),(77,3329,3326,'cha',20,5),(77,3330,3326,'han',20,5),(77,3331,3326,'ann',20,5),(77,3332,3326,'nne',20,5),(77,3333,3326,'nel',20,5),(77,3334,3329,'dis',50,5),(77,3335,3329,'isk',50,5),(77,3336,3334,'naa',100,5),(77,3337,3336,'600',3.333,5),(77,3338,3336,'00a',3.333,5),(77,3339,3336,'0a0',3.333,5),(77,3340,3336,'a09',3.333,5),(77,3341,3336,'098',3.333,5),(77,3342,3336,'980',3.333,5),(77,3343,3336,'804',3.333,5),(77,3344,3336,'044',3.333,5),(77,3345,3336,'443',3.333,5),(77,3346,3336,'430',3.333,5),(77,3347,3336,'307',3.333,5),(77,3348,3336,'075',3.333,5),(77,3349,3336,'753',3.333,5),(77,3350,3336,'535',3.333,5),(77,3351,3336,'357',3.333,5),(77,3352,3336,'573',3.333,5),(77,3353,3336,'732',3.333,5),(77,3354,3336,'32b',3.333,5),(77,3355,3336,'2b3',3.333,5),(77,3356,3336,'b33',3.333,5),(77,3357,3336,'334',3.333,5),(77,3358,3336,'345',3.333,5),(77,3359,3336,'457',3.333,5),(77,3360,3336,'571',3.333,5),(77,3361,3336,'715',3.333,5),(77,3362,3336,'153',3.333,5),(77,3363,3336,'533',3.333,5),(77,3364,3336,'335',3.333,5),(77,3365,3336,'356',3.333,5),(77,3366,3336,'569',3.333,5),(78,3368,3367,'net',25,5),(78,3369,3367,'eta',25,5),(78,3370,3367,'tap',25,5),(78,3371,3367,'app',25,5),(78,3372,3368,'fib',33.333,5),(78,3373,3368,'ibr',33.333,5),(78,3374,3368,'bre',33.333,5),(78,3375,3372,'cha',20,5),(78,3376,3372,'han',20,5),(78,3377,3372,'ann',20,5),(78,3378,3372,'nne',20,5),(78,3379,3372,'nel',20,5),(78,3380,3375,'dis',50,5),(78,3381,3375,'isk',50,5),(78,3382,3380,'naa',100,5),(78,3383,3382,'600',3.333,5),(78,3384,3382,'00a',3.333,5),(78,3385,3382,'0a0',3.333,5),(78,3386,3382,'a09',3.333,5),(78,3387,3382,'098',3.333,5),(78,3388,3382,'980',3.333,5),(78,3389,3382,'804',3.333,5),(78,3390,3382,'044',3.333,5),(78,3391,3382,'443',3.333,5),(78,3392,3382,'430',3.333,5),(78,3393,3382,'307',3.333,5),(78,3394,3382,'075',3.333,5),(78,3395,3382,'753',3.333,5),(78,3396,3382,'535',3.333,5),(78,3397,3382,'357',3.333,5),(78,3398,3382,'573',3.333,5),(78,3399,3382,'732',3.333,5),(78,3400,3382,'32b',3.333,5),(78,3401,3382,'2b3',3.333,5),(78,3402,3382,'b33',3.333,5),(78,3403,3382,'334',3.333,5),(78,3404,3382,'345',3.333,5),(78,3405,3382,'457',3.333,5),(78,3406,3382,'571',3.333,5),(78,3407,3382,'715',3.333,5),(78,3408,3382,'153',3.333,5),(78,3409,3382,'533',3.333,5),(78,3410,3382,'336',3.333,5),(78,3411,3382,'364',3.333,5),(78,3412,3382,'646',3.333,5),(79,3414,3413,'net',25,5),(79,3415,3413,'eta',25,5),(79,3416,3413,'tap',25,5),(79,3417,3413,'app',25,5),(79,3418,3414,'fib',33.333,5),(79,3419,3414,'ibr',33.333,5),(79,3420,3414,'bre',33.333,5),(79,3421,3418,'cha',20,5),(79,3422,3418,'han',20,5),(79,3423,3418,'ann',20,5),(79,3424,3418,'nne',20,5),(79,3425,3418,'nel',20,5),(79,3426,3421,'dis',50,5),(79,3427,3421,'isk',50,5),(79,3428,3426,'naa',100,5),(79,3429,3428,'600',3.333,5),(79,3430,3428,'00a',3.333,5),(79,3431,3428,'0a0',3.333,5),(79,3432,3428,'a09',3.333,5),(79,3433,3428,'098',3.333,5),(79,3434,3428,'980',3.333,5),(79,3435,3428,'804',3.333,5),(79,3436,3428,'044',3.333,5),(79,3437,3428,'443',3.333,5),(79,3438,3428,'430',3.333,5),(79,3439,3428,'307',3.333,5),(79,3440,3428,'075',3.333,5),(79,3441,3428,'753',3.333,5),(79,3442,3428,'535',3.333,5),(79,3443,3428,'357',3.333,5),(79,3444,3428,'573',3.333,5),(79,3445,3428,'732',3.333,5),(79,3446,3428,'32b',3.333,5),(79,3447,3428,'2b3',3.333,5),(79,3448,3428,'b33',3.333,5),(79,3449,3428,'334',3.333,5),(79,3450,3428,'345',3.333,5),(79,3451,3428,'457',3.333,5),(79,3452,3428,'571',3.333,5),(79,3453,3428,'715',3.333,5),(79,3454,3428,'153',3.333,5),(79,3455,3428,'533',3.333,5),(79,3456,3428,'336',3.333,5),(79,3457,3428,'364',3.333,5),(79,3458,3428,'647',3.333,5),(80,3460,3459,'net',25,5),(80,3461,3459,'eta',25,5),(80,3462,3459,'tap',25,5),(80,3463,3459,'app',25,5),(80,3464,3460,'fib',33.333,5),(80,3465,3460,'ibr',33.333,5),(80,3466,3460,'bre',33.333,5),(80,3467,3464,'cha',20,5),(80,3468,3464,'han',20,5),(80,3469,3464,'ann',20,5),(80,3470,3464,'nne',20,5),(80,3471,3464,'nel',20,5),(80,3472,3467,'dis',50,5),(80,3473,3467,'isk',50,5),(80,3474,3472,'naa',100,5),(80,3475,3474,'600',3.333,5),(80,3476,3474,'00a',3.333,5),(80,3477,3474,'0a0',3.333,5),(80,3478,3474,'a09',3.333,5),(80,3479,3474,'098',3.333,5),(80,3480,3474,'980',3.333,5),(80,3481,3474,'804',3.333,5),(80,3482,3474,'044',3.333,5),(80,3483,3474,'443',3.333,5),(80,3484,3474,'430',3.333,5),(80,3485,3474,'307',3.333,5),(80,3486,3474,'075',3.333,5),(80,3487,3474,'753',3.333,5),(80,3488,3474,'535',3.333,5),(80,3489,3474,'357',3.333,5),(80,3490,3474,'573',3.333,5),(80,3491,3474,'732',3.333,5),(80,3492,3474,'32b',3.333,5),(80,3493,3474,'2b3',3.333,5),(80,3494,3474,'b33',3.333,5),(80,3495,3474,'334',3.333,5),(80,3496,3474,'345',3.333,5),(80,3497,3474,'457',3.333,5),(80,3498,3474,'571',3.333,5),(80,3499,3474,'715',3.333,5),(80,3500,3474,'153',3.333,5),(80,3501,3474,'533',3.333,5),(80,3502,3474,'336',3.333,5),(80,3503,3474,'364',3.333,5),(80,3504,3474,'648',3.333,5),(81,3506,3505,'net',25,5),(81,3507,3505,'eta',25,5),(81,3508,3505,'tap',25,5),(81,3509,3505,'app',25,5),(81,3510,3506,'fib',33.333,5),(81,3511,3506,'ibr',33.333,5),(81,3512,3506,'bre',33.333,5),(81,3513,3510,'cha',20,5),(81,3514,3510,'han',20,5),(81,3515,3510,'ann',20,5),(81,3516,3510,'nne',20,5),(81,3517,3510,'nel',20,5),(81,3518,3513,'dis',50,5),(81,3519,3513,'isk',50,5),(81,3520,3518,'naa',100,5),(81,3521,3520,'600',3.333,5),(81,3522,3520,'00a',3.333,5),(81,3523,3520,'0a0',3.333,5),(81,3524,3520,'a09',3.333,5),(81,3525,3520,'098',3.333,5),(81,3526,3520,'980',3.333,5),(81,3527,3520,'804',3.333,5),(81,3528,3520,'044',3.333,5),(81,3529,3520,'443',3.333,5),(81,3530,3520,'430',3.333,5),(81,3531,3520,'307',3.333,5),(81,3532,3520,'075',3.333,5),(81,3533,3520,'753',3.333,5),(81,3534,3520,'535',3.333,5),(81,3535,3520,'357',3.333,5),(81,3536,3520,'573',3.333,5),(81,3537,3520,'732',3.333,5),(81,3538,3520,'32b',3.333,5),(81,3539,3520,'2b3',3.333,5),(81,3540,3520,'b33',3.333,5),(81,3541,3520,'334',3.333,5),(81,3542,3520,'345',3.333,5),(81,3543,3520,'457',3.333,5),(81,3544,3520,'571',3.333,5),(81,3545,3520,'715',3.333,5),(81,3546,3520,'153',3.333,5),(81,3547,3520,'533',3.333,5),(81,3548,3520,'336',3.333,5),(81,3549,3520,'364',3.333,5),(81,3550,3520,'649',3.333,5),(82,3552,3551,'net',25,5),(82,3553,3551,'eta',25,5),(82,3554,3551,'tap',25,5),(82,3555,3551,'app',25,5),(82,3556,3552,'ser',25,5),(82,3557,3552,'eri',25,5),(82,3558,3552,'ria',25,5),(82,3559,3552,'ial',25,5),(82,3560,3556,'att',16.667,5),(82,3561,3556,'tta',16.667,5),(82,3562,3556,'tac',16.667,5),(82,3563,3556,'ach',16.667,5),(82,3564,3556,'che',16.667,5),(82,3565,3556,'hed',16.667,5),(82,3566,3560,'scs',50,5),(82,3567,3560,'csi',50,5),(82,3568,3566,'dis',50,5),(82,3569,3566,'isk',50,5),(82,3570,3568,'naa',100,5),(82,3571,3570,'600',3.333,5),(82,3572,3570,'00a',3.333,5),(82,3573,3570,'0a0',3.333,5),(82,3574,3570,'a09',3.333,5),(82,3575,3570,'098',3.333,5),(82,3576,3570,'980',3.333,5),(82,3577,3570,'80d',3.333,5),(82,3578,3570,'0db',3.333,5),(82,3579,3570,'dba',3.333,5),(82,3580,3570,'ba0',3.333,5),(82,3581,3570,'a08',3.333,5),(82,3582,3570,'084',3.333,5),(82,3583,3570,'84e',3.333,5),(82,3584,3570,'4ee',3.333,5),(82,3585,3570,'eeb',3.333,5),(82,3586,3570,'ebc',3.333,5),(82,3587,3570,'bc0',3.333,5),(82,3588,3570,'c08',3.333,5),(82,3589,3570,'084',3.333,5),(82,3590,3570,'84b',3.333,5),(82,3591,3570,'4b1',3.333,5),(82,3592,3570,'b11',3.333,5),(82,3593,3570,'117',3.333,5),(82,3594,3570,'17b',3.333,5),(82,3595,3570,'7b1',3.333,5),(82,3596,3570,'b10',3.333,5),(82,3597,3570,'10a',3.333,5),(82,3598,3570,'0ab',3.333,5),(82,3599,3570,'aba',3.333,5),(82,3600,3570,'ba2',3.333,5),(83,3602,3601,'net',25,5),(83,3603,3601,'eta',25,5),(83,3604,3601,'tap',25,5),(83,3605,3601,'app',25,5),(83,3606,3602,'fib',33.333,5),(83,3607,3602,'ibr',33.333,5),(83,3608,3602,'bre',33.333,5),(83,3609,3606,'cha',20,5),(83,3610,3606,'han',20,5),(83,3611,3606,'ann',20,5),(83,3612,3606,'nne',20,5),(83,3613,3606,'nel',20,5),(83,3614,3609,'dis',50,5),(83,3615,3609,'isk',50,5),(83,3616,3614,'naa',100,5),(83,3617,3616,'600',3.333,5),(83,3618,3616,'00a',3.333,5),(83,3619,3616,'0a0',3.333,5),(83,3620,3616,'a09',3.333,5),(83,3621,3616,'098',3.333,5),(83,3622,3616,'980',3.333,5),(83,3623,3616,'804',3.333,5),(83,3624,3616,'044',3.333,5),(83,3625,3616,'443',3.333,5),(83,3626,3616,'430',3.333,5),(83,3627,3616,'307',3.333,5),(83,3628,3616,'075',3.333,5),(83,3629,3616,'753',3.333,5),(83,3630,3616,'535',3.333,5),(83,3631,3616,'357',3.333,5),(83,3632,3616,'573',3.333,5),(83,3633,3616,'732',3.333,5),(83,3634,3616,'32b',3.333,5),(83,3635,3616,'2b3',3.333,5),(83,3636,3616,'b33',3.333,5),(83,3637,3616,'334',3.333,5),(83,3638,3616,'345',3.333,5),(83,3639,3616,'457',3.333,5),(83,3640,3616,'571',3.333,5),(83,3641,3616,'715',3.333,5),(83,3642,3616,'153',3.333,5),(83,3643,3616,'533',3.333,5),(83,3644,3616,'335',3.333,5),(83,3645,3616,'356',3.333,5),(83,3646,3616,'56a',3.333,5),(84,3648,3647,'net',25,5),(84,3649,3647,'eta',25,5),(84,3650,3647,'tap',25,5),(84,3651,3647,'app',25,5),(84,3652,3648,'ser',25,5),(84,3653,3648,'eri',25,5),(84,3654,3648,'ria',25,5),(84,3655,3648,'ial',25,5),(84,3656,3652,'att',16.667,5),(84,3657,3652,'tta',16.667,5),(84,3658,3652,'tac',16.667,5),(84,3659,3652,'ach',16.667,5),(84,3660,3652,'che',16.667,5),(84,3661,3652,'hed',16.667,5),(84,3662,3656,'scs',50,5),(84,3663,3656,'csi',50,5),(84,3664,3662,'dis',50,5),(84,3665,3662,'isk',50,5),(84,3666,3664,'naa',100,5),(84,3667,3666,'600',3.333,5),(84,3668,3666,'00a',3.333,5),(84,3669,3666,'0a0',3.333,5),(84,3670,3666,'a09',3.333,5),(84,3671,3666,'098',3.333,5),(84,3672,3666,'980',3.333,5),(84,3673,3666,'803',3.333,5),(84,3674,3666,'034',3.333,5),(84,3675,3666,'34a',3.333,5),(84,3676,3666,'4a4',3.333,5),(84,3677,3666,'a48',3.333,5),(84,3678,3666,'484',3.333,5),(84,3679,3666,'84e',3.333,5),(84,3680,3666,'4ee',3.333,5),(84,3681,3666,'ee5',3.333,5),(84,3682,3666,'e5c',3.333,5),(84,3683,3666,'5ca',3.333,5),(84,3684,3666,'ca9',3.333,5),(84,3685,3666,'a94',3.333,5),(84,3686,3666,'94a',3.333,5),(84,3687,3666,'4a1',3.333,5),(84,3688,3666,'a11',3.333,5),(84,3689,3666,'117',3.333,5),(84,3690,3666,'17b',3.333,5),(84,3691,3666,'7b1',3.333,5),(84,3692,3666,'b11',3.333,5),(84,3693,3666,'11a',3.333,5),(84,3694,3666,'1ab',3.333,5),(84,3695,3666,'aba',3.333,5),(84,3696,3666,'ba2',3.333,5),(85,3698,3697,'net',25,5),(85,3699,3697,'eta',25,5),(85,3700,3697,'tap',25,5),(85,3701,3697,'app',25,5),(85,3702,3698,'fib',33.333,5),(85,3703,3698,'ibr',33.333,5),(85,3704,3698,'bre',33.333,5),(85,3705,3702,'cha',20,5),(85,3706,3702,'han',20,5),(85,3707,3702,'ann',20,5),(85,3708,3702,'nne',20,5),(85,3709,3702,'nel',20,5),(85,3710,3705,'dis',50,5),(85,3711,3705,'isk',50,5),(85,3712,3710,'naa',100,5),(85,3713,3712,'600',3.333,5),(85,3714,3712,'00a',3.333,5),(85,3715,3712,'0a0',3.333,5),(85,3716,3712,'a09',3.333,5),(85,3717,3712,'098',3.333,5),(85,3718,3712,'980',3.333,5),(85,3719,3712,'804',3.333,5),(85,3720,3712,'044',3.333,5),(85,3721,3712,'443',3.333,5),(85,3722,3712,'430',3.333,5),(85,3723,3712,'307',3.333,5),(85,3724,3712,'075',3.333,5),(85,3725,3712,'753',3.333,5),(85,3726,3712,'535',3.333,5),(85,3727,3712,'357',3.333,5),(85,3728,3712,'573',3.333,5),(85,3729,3712,'732',3.333,5),(85,3730,3712,'32b',3.333,5),(85,3731,3712,'2b3',3.333,5),(85,3732,3712,'b33',3.333,5),(85,3733,3712,'334',3.333,5),(85,3734,3712,'345',3.333,5),(85,3735,3712,'457',3.333,5),(85,3736,3712,'571',3.333,5),(85,3737,3712,'715',3.333,5),(85,3738,3712,'153',3.333,5),(85,3739,3712,'533',3.333,5),(85,3740,3712,'335',3.333,5),(85,3741,3712,'356',3.333,5),(85,3742,3712,'56b',3.333,5),(86,3744,3743,'net',25,5),(86,3745,3743,'eta',25,5),(86,3746,3743,'tap',25,5),(86,3747,3743,'app',25,5),(86,3748,3744,'fib',33.333,5),(86,3749,3744,'ibr',33.333,5),(86,3750,3744,'bre',33.333,5),(86,3751,3748,'cha',20,5),(86,3752,3748,'han',20,5),(86,3753,3748,'ann',20,5),(86,3754,3748,'nne',20,5),(86,3755,3748,'nel',20,5),(86,3756,3751,'dis',50,5),(86,3757,3751,'isk',50,5),(86,3758,3756,'naa',100,5),(86,3759,3758,'600',3.333,5),(86,3760,3758,'00a',3.333,5),(86,3761,3758,'0a0',3.333,5),(86,3762,3758,'a09',3.333,5),(86,3763,3758,'098',3.333,5),(86,3764,3758,'980',3.333,5),(86,3765,3758,'804',3.333,5),(86,3766,3758,'044',3.333,5),(86,3767,3758,'443',3.333,5),(86,3768,3758,'430',3.333,5),(86,3769,3758,'307',3.333,5),(86,3770,3758,'075',3.333,5),(86,3771,3758,'753',3.333,5),(86,3772,3758,'535',3.333,5),(86,3773,3758,'357',3.333,5),(86,3774,3758,'573',3.333,5),(86,3775,3758,'732',3.333,5),(86,3776,3758,'32b',3.333,5),(86,3777,3758,'2b3',3.333,5),(86,3778,3758,'b33',3.333,5),(86,3779,3758,'334',3.333,5),(86,3780,3758,'345',3.333,5),(86,3781,3758,'457',3.333,5),(86,3782,3758,'571',3.333,5),(86,3783,3758,'715',3.333,5),(86,3784,3758,'153',3.333,5),(86,3785,3758,'533',3.333,5),(86,3786,3758,'335',3.333,5),(86,3787,3758,'356',3.333,5),(86,3788,3758,'56c',3.333,5),(87,3790,3789,'net',25,5),(87,3791,3789,'eta',25,5),(87,3792,3789,'tap',25,5),(87,3793,3789,'app',25,5),(87,3794,3790,'fib',33.333,5),(87,3795,3790,'ibr',33.333,5),(87,3796,3790,'bre',33.333,5),(87,3797,3794,'cha',20,5),(87,3798,3794,'han',20,5),(87,3799,3794,'ann',20,5),(87,3800,3794,'nne',20,5),(87,3801,3794,'nel',20,5),(87,3802,3797,'dis',50,5),(87,3803,3797,'isk',50,5),(87,3804,3802,'naa',100,5),(87,3805,3804,'600',3.333,5),(87,3806,3804,'00a',3.333,5),(87,3807,3804,'0a0',3.333,5),(87,3808,3804,'a09',3.333,5),(87,3809,3804,'098',3.333,5),(87,3810,3804,'980',3.333,5),(87,3811,3804,'804',3.333,5),(87,3812,3804,'044',3.333,5),(87,3813,3804,'443',3.333,5),(87,3814,3804,'430',3.333,5),(87,3815,3804,'307',3.333,5),(87,3816,3804,'075',3.333,5),(87,3817,3804,'753',3.333,5),(87,3818,3804,'535',3.333,5),(87,3819,3804,'357',3.333,5),(87,3820,3804,'573',3.333,5),(87,3821,3804,'732',3.333,5),(87,3822,3804,'32b',3.333,5),(87,3823,3804,'2b3',3.333,5),(87,3824,3804,'b33',3.333,5),(87,3825,3804,'334',3.333,5),(87,3826,3804,'345',3.333,5),(87,3827,3804,'457',3.333,5),(87,3828,3804,'571',3.333,5),(87,3829,3804,'715',3.333,5),(87,3830,3804,'153',3.333,5),(87,3831,3804,'533',3.333,5),(87,3832,3804,'335',3.333,5),(87,3833,3804,'356',3.333,5),(87,3834,3804,'56d',3.333,5),(88,3836,3835,'net',25,5),(88,3837,3835,'eta',25,5),(88,3838,3835,'tap',25,5),(88,3839,3835,'app',25,5),(88,3840,3836,'fib',33.333,5),(88,3841,3836,'ibr',33.333,5),(88,3842,3836,'bre',33.333,5),(88,3843,3840,'cha',20,5),(88,3844,3840,'han',20,5),(88,3845,3840,'ann',20,5),(88,3846,3840,'nne',20,5),(88,3847,3840,'nel',20,5),(88,3848,3843,'dis',50,5),(88,3849,3843,'isk',50,5),(88,3850,3848,'naa',100,5),(88,3851,3850,'600',3.333,5),(88,3852,3850,'00a',3.333,5),(88,3853,3850,'0a0',3.333,5),(88,3854,3850,'a09',3.333,5),(88,3855,3850,'098',3.333,5),(88,3856,3850,'980',3.333,5),(88,3857,3850,'804',3.333,5),(88,3858,3850,'044',3.333,5),(88,3859,3850,'443',3.333,5),(88,3860,3850,'430',3.333,5),(88,3861,3850,'307',3.333,5),(88,3862,3850,'075',3.333,5),(88,3863,3850,'753',3.333,5),(88,3864,3850,'535',3.333,5),(88,3865,3850,'357',3.333,5),(88,3866,3850,'573',3.333,5),(88,3867,3850,'732',3.333,5),(88,3868,3850,'32b',3.333,5),(88,3869,3850,'2b3',3.333,5),(88,3870,3850,'b33',3.333,5),(88,3871,3850,'334',3.333,5),(88,3872,3850,'345',3.333,5),(88,3873,3850,'457',3.333,5),(88,3874,3850,'571',3.333,5),(88,3875,3850,'715',3.333,5),(88,3876,3850,'153',3.333,5),(88,3877,3850,'533',3.333,5),(88,3878,3850,'336',3.333,5),(88,3879,3850,'364',3.333,5),(88,3880,3850,'64a',3.333,5),(89,3882,3881,'net',25,5),(89,3883,3881,'eta',25,5),(89,3884,3881,'tap',25,5),(89,3885,3881,'app',25,5),(89,3886,3882,'fib',33.333,5),(89,3887,3882,'ibr',33.333,5),(89,3888,3882,'bre',33.333,5),(89,3889,3886,'cha',20,5),(89,3890,3886,'han',20,5),(89,3891,3886,'ann',20,5),(89,3892,3886,'nne',20,5),(89,3893,3886,'nel',20,5),(89,3894,3889,'dis',50,5),(89,3895,3889,'isk',50,5),(89,3896,3894,'naa',100,5),(89,3897,3896,'600',3.333,5),(89,3898,3896,'00a',3.333,5),(89,3899,3896,'0a0',3.333,5),(89,3900,3896,'a09',3.333,5),(89,3901,3896,'098',3.333,5),(89,3902,3896,'980',3.333,5),(89,3903,3896,'804',3.333,5),(89,3904,3896,'044',3.333,5),(89,3905,3896,'443',3.333,5),(89,3906,3896,'430',3.333,5),(89,3907,3896,'307',3.333,5),(89,3908,3896,'075',3.333,5),(89,3909,3896,'753',3.333,5),(89,3910,3896,'535',3.333,5),(89,3911,3896,'357',3.333,5),(89,3912,3896,'573',3.333,5),(89,3913,3896,'732',3.333,5),(89,3914,3896,'32b',3.333,5),(89,3915,3896,'2b3',3.333,5),(89,3916,3896,'b33',3.333,5),(89,3917,3896,'334',3.333,5),(89,3918,3896,'345',3.333,5),(89,3919,3896,'457',3.333,5),(89,3920,3896,'571',3.333,5),(89,3921,3896,'715',3.333,5),(89,3922,3896,'153',3.333,5),(89,3923,3896,'533',3.333,5),(89,3924,3896,'335',3.333,5),(89,3925,3896,'356',3.333,5),(89,3926,3896,'56e',3.333,5),(90,3928,3927,'net',25,5),(90,3929,3927,'eta',25,5),(90,3930,3927,'tap',25,5),(90,3931,3927,'app',25,5),(90,3932,3928,'fib',33.333,5),(90,3933,3928,'ibr',33.333,5),(90,3934,3928,'bre',33.333,5),(90,3935,3932,'cha',20,5),(90,3936,3932,'han',20,5),(90,3937,3932,'ann',20,5),(90,3938,3932,'nne',20,5),(90,3939,3932,'nel',20,5),(90,3940,3935,'dis',50,5),(90,3941,3935,'isk',50,5),(90,3942,3940,'naa',100,5),(90,3943,3942,'600',3.333,5),(90,3944,3942,'00a',3.333,5),(90,3945,3942,'0a0',3.333,5),(90,3946,3942,'a09',3.333,5),(90,3947,3942,'098',3.333,5),(90,3948,3942,'980',3.333,5),(90,3949,3942,'804',3.333,5),(90,3950,3942,'044',3.333,5),(90,3951,3942,'443',3.333,5),(90,3952,3942,'430',3.333,5),(90,3953,3942,'307',3.333,5),(90,3954,3942,'075',3.333,5),(90,3955,3942,'753',3.333,5),(90,3956,3942,'535',3.333,5),(90,3957,3942,'357',3.333,5),(90,3958,3942,'573',3.333,5),(90,3959,3942,'732',3.333,5),(90,3960,3942,'32b',3.333,5),(90,3961,3942,'2b3',3.333,5),(90,3962,3942,'b33',3.333,5),(90,3963,3942,'334',3.333,5),(90,3964,3942,'345',3.333,5),(90,3965,3942,'457',3.333,5),(90,3966,3942,'571',3.333,5),(90,3967,3942,'715',3.333,5),(90,3968,3942,'153',3.333,5),(90,3969,3942,'533',3.333,5),(90,3970,3942,'336',3.333,5),(90,3971,3942,'364',3.333,5),(90,3972,3942,'64b',3.333,5),(91,3974,3973,'net',25,5),(91,3975,3973,'eta',25,5),(91,3976,3973,'tap',25,5),(91,3977,3973,'app',25,5),(91,3978,3974,'fib',33.333,5),(91,3979,3974,'ibr',33.333,5),(91,3980,3974,'bre',33.333,5),(91,3981,3978,'cha',20,5),(91,3982,3978,'han',20,5),(91,3983,3978,'ann',20,5),(91,3984,3978,'nne',20,5),(91,3985,3978,'nel',20,5),(91,3986,3981,'dis',50,5),(91,3987,3981,'isk',50,5),(91,3988,3986,'naa',100,5),(91,3989,3988,'600',3.333,5),(91,3990,3988,'00a',3.333,5),(91,3991,3988,'0a0',3.333,5),(91,3992,3988,'a09',3.333,5),(91,3993,3988,'098',3.333,5),(91,3994,3988,'980',3.333,5),(91,3995,3988,'804',3.333,5),(91,3996,3988,'044',3.333,5),(91,3997,3988,'443',3.333,5),(91,3998,3988,'430',3.333,5),(91,3999,3988,'307',3.333,5),(91,4000,3988,'075',3.333,5),(91,4001,3988,'753',3.333,5),(91,4002,3988,'535',3.333,5),(91,4003,3988,'357',3.333,5),(91,4004,3988,'573',3.333,5),(91,4005,3988,'732',3.333,5),(91,4006,3988,'32b',3.333,5),(91,4007,3988,'2b3',3.333,5),(91,4008,3988,'b33',3.333,5),(91,4009,3988,'334',3.333,5),(91,4010,3988,'345',3.333,5),(91,4011,3988,'457',3.333,5),(91,4012,3988,'571',3.333,5),(91,4013,3988,'715',3.333,5),(91,4014,3988,'153',3.333,5),(91,4015,3988,'533',3.333,5),(91,4016,3988,'335',3.333,5),(91,4017,3988,'356',3.333,5),(91,4018,3988,'56f',3.333,5),(92,4020,4019,'net',25,5),(92,4021,4019,'eta',25,5),(92,4022,4019,'tap',25,5),(92,4023,4019,'app',25,5),(92,4024,4020,'fib',33.333,5),(92,4025,4020,'ibr',33.333,5),(92,4026,4020,'bre',33.333,5),(92,4027,4024,'cha',20,5),(92,4028,4024,'han',20,5),(92,4029,4024,'ann',20,5),(92,4030,4024,'nne',20,5),(92,4031,4024,'nel',20,5),(92,4032,4027,'dis',50,5),(92,4033,4027,'isk',50,5),(92,4034,4032,'naa',100,5),(92,4035,4034,'600',3.333,5),(92,4036,4034,'00a',3.333,5),(92,4037,4034,'0a0',3.333,5),(92,4038,4034,'a09',3.333,5),(92,4039,4034,'098',3.333,5),(92,4040,4034,'980',3.333,5),(92,4041,4034,'804',3.333,5),(92,4042,4034,'044',3.333,5),(92,4043,4034,'443',3.333,5),(92,4044,4034,'430',3.333,5),(92,4045,4034,'307',3.333,5),(92,4046,4034,'075',3.333,5),(92,4047,4034,'753',3.333,5),(92,4048,4034,'535',3.333,5),(92,4049,4034,'357',3.333,5),(92,4050,4034,'573',3.333,5),(92,4051,4034,'732',3.333,5),(92,4052,4034,'32b',3.333,5),(92,4053,4034,'2b3',3.333,5),(92,4054,4034,'b33',3.333,5),(92,4055,4034,'334',3.333,5),(92,4056,4034,'345',3.333,5),(92,4057,4034,'457',3.333,5),(92,4058,4034,'571',3.333,5),(92,4059,4034,'715',3.333,5),(92,4060,4034,'153',3.333,5),(92,4061,4034,'533',3.333,5),(92,4062,4034,'336',3.333,5),(92,4063,4034,'364',3.333,5),(92,4064,4034,'64c',3.333,5),(93,4066,4065,'net',25,5),(93,4067,4065,'eta',25,5),(93,4068,4065,'tap',25,5),(93,4069,4065,'app',25,5),(93,4070,4066,'fib',33.333,5),(93,4071,4066,'ibr',33.333,5),(93,4072,4066,'bre',33.333,5),(93,4073,4070,'cha',20,5),(93,4074,4070,'han',20,5),(93,4075,4070,'ann',20,5),(93,4076,4070,'nne',20,5),(93,4077,4070,'nel',20,5),(93,4078,4073,'dis',50,5),(93,4079,4073,'isk',50,5),(93,4080,4078,'naa',100,5),(93,4081,4080,'600',3.333,5),(93,4082,4080,'00a',3.333,5),(93,4083,4080,'0a0',3.333,5),(93,4084,4080,'a09',3.333,5),(93,4085,4080,'098',3.333,5),(93,4086,4080,'980',3.333,5),(93,4087,4080,'804',3.333,5),(93,4088,4080,'044',3.333,5),(93,4089,4080,'443',3.333,5),(93,4090,4080,'430',3.333,5),(93,4091,4080,'307',3.333,5),(93,4092,4080,'075',3.333,5),(93,4093,4080,'753',3.333,5),(93,4094,4080,'535',3.333,5),(93,4095,4080,'357',3.333,5),(93,4096,4080,'573',3.333,5),(93,4097,4080,'732',3.333,5),(93,4098,4080,'32b',3.333,5),(93,4099,4080,'2b3',3.333,5),(93,4100,4080,'b33',3.333,5),(93,4101,4080,'334',3.333,5),(93,4102,4080,'345',3.333,5),(93,4103,4080,'457',3.333,5),(93,4104,4080,'571',3.333,5),(93,4105,4080,'715',3.333,5),(93,4106,4080,'153',3.333,5),(93,4107,4080,'533',3.333,5),(93,4108,4080,'336',3.333,5),(93,4109,4080,'364',3.333,5),(93,4110,4080,'64d',3.333,5),(94,4112,4111,'net',25,5),(94,4113,4111,'eta',25,5),(94,4114,4111,'tap',25,5),(94,4115,4111,'app',25,5),(94,4116,4112,'fib',33.333,5),(94,4117,4112,'ibr',33.333,5),(94,4118,4112,'bre',33.333,5),(94,4119,4116,'cha',20,5),(94,4120,4116,'han',20,5),(94,4121,4116,'ann',20,5),(94,4122,4116,'nne',20,5),(94,4123,4116,'nel',20,5),(94,4124,4119,'dis',50,5),(94,4125,4119,'isk',50,5),(94,4126,4124,'naa',100,5),(94,4127,4126,'600',3.333,5),(94,4128,4126,'00a',3.333,5),(94,4129,4126,'0a0',3.333,5),(94,4130,4126,'a09',3.333,5),(94,4131,4126,'098',3.333,5),(94,4132,4126,'980',3.333,5),(94,4133,4126,'804',3.333,5),(94,4134,4126,'044',3.333,5),(94,4135,4126,'443',3.333,5),(94,4136,4126,'430',3.333,5),(94,4137,4126,'307',3.333,5),(94,4138,4126,'075',3.333,5),(94,4139,4126,'753',3.333,5),(94,4140,4126,'535',3.333,5),(94,4141,4126,'357',3.333,5),(94,4142,4126,'573',3.333,5),(94,4143,4126,'732',3.333,5),(94,4144,4126,'32b',3.333,5),(94,4145,4126,'2b3',3.333,5),(94,4146,4126,'b33',3.333,5),(94,4147,4126,'334',3.333,5),(94,4148,4126,'345',3.333,5),(94,4149,4126,'457',3.333,5),(94,4150,4126,'571',3.333,5),(94,4151,4126,'715',3.333,5),(94,4152,4126,'153',3.333,5),(94,4153,4126,'533',3.333,5),(94,4154,4126,'336',3.333,5),(94,4155,4126,'364',3.333,5),(94,4156,4126,'64e',3.333,5),(95,4158,4157,'net',25,5),(95,4159,4157,'eta',25,5),(95,4160,4157,'tap',25,5),(95,4161,4157,'app',25,5),(95,4162,4158,'fib',33.333,5),(95,4163,4158,'ibr',33.333,5),(95,4164,4158,'bre',33.333,5),(95,4165,4162,'cha',20,5),(95,4166,4162,'han',20,5),(95,4167,4162,'ann',20,5),(95,4168,4162,'nne',20,5),(95,4169,4162,'nel',20,5),(95,4170,4165,'dis',50,5),(95,4171,4165,'isk',50,5),(95,4172,4170,'naa',100,5),(95,4173,4172,'600',3.333,5),(95,4174,4172,'00a',3.333,5),(95,4175,4172,'0a0',3.333,5),(95,4176,4172,'a09',3.333,5),(95,4177,4172,'098',3.333,5),(95,4178,4172,'980',3.333,5),(95,4179,4172,'804',3.333,5),(95,4180,4172,'044',3.333,5),(95,4181,4172,'443',3.333,5),(95,4182,4172,'430',3.333,5),(95,4183,4172,'307',3.333,5),(95,4184,4172,'075',3.333,5),(95,4185,4172,'753',3.333,5),(95,4186,4172,'535',3.333,5),(95,4187,4172,'357',3.333,5),(95,4188,4172,'573',3.333,5),(95,4189,4172,'732',3.333,5),(95,4190,4172,'32b',3.333,5),(95,4191,4172,'2b3',3.333,5),(95,4192,4172,'b33',3.333,5),(95,4193,4172,'334',3.333,5),(95,4194,4172,'345',3.333,5),(95,4195,4172,'457',3.333,5),(95,4196,4172,'571',3.333,5),(95,4197,4172,'715',3.333,5),(95,4198,4172,'153',3.333,5),(95,4199,4172,'533',3.333,5),(95,4200,4172,'336',3.333,5),(95,4201,4172,'364',3.333,5),(95,4202,4172,'64f',3.333,5),(96,4204,4203,'net',25,5),(96,4205,4203,'eta',25,5),(96,4206,4203,'tap',25,5),(96,4207,4203,'app',25,5),(96,4208,4204,'fib',33.333,5),(96,4209,4204,'ibr',33.333,5),(96,4210,4204,'bre',33.333,5),(96,4211,4208,'cha',20,5),(96,4212,4208,'han',20,5),(96,4213,4208,'ann',20,5),(96,4214,4208,'nne',20,5),(96,4215,4208,'nel',20,5),(96,4216,4211,'dis',50,5),(96,4217,4211,'isk',50,5),(96,4218,4216,'naa',100,5),(96,4219,4218,'600',3.333,5),(96,4220,4218,'00a',3.333,5),(96,4221,4218,'0a0',3.333,5),(96,4222,4218,'a09',3.333,5),(96,4223,4218,'098',3.333,5),(96,4224,4218,'980',3.333,5),(96,4225,4218,'804',3.333,5),(96,4226,4218,'044',3.333,5),(96,4227,4218,'443',3.333,5),(96,4228,4218,'430',3.333,5),(96,4229,4218,'307',3.333,5),(96,4230,4218,'072',3.333,5),(96,4231,4218,'725',3.333,5),(96,4232,4218,'259',3.333,5),(96,4233,4218,'593',3.333,5),(96,4234,4218,'931',3.333,5),(96,4235,4218,'313',3.333,5),(96,4236,4218,'13f',3.333,5),(96,4237,4218,'3f3',3.333,5),(96,4238,4218,'f33',3.333,5),(96,4239,4218,'334',3.333,5),(96,4240,4218,'345',3.333,5),(96,4241,4218,'455',3.333,5),(96,4242,4218,'556',3.333,5),(96,4243,4218,'563',3.333,5),(96,4244,4218,'639',3.333,5),(96,4245,4218,'393',3.333,5),(96,4246,4218,'934',3.333,5),(96,4247,4218,'344',3.333,5),(96,4248,4218,'441',3.333,5),(97,4250,4249,'net',25,5),(97,4251,4249,'eta',25,5),(97,4252,4249,'tap',25,5),(97,4253,4249,'app',25,5),(97,4254,4250,'fib',33.333,5),(97,4255,4250,'ibr',33.333,5),(97,4256,4250,'bre',33.333,5),(97,4257,4254,'cha',20,5),(97,4258,4254,'han',20,5),(97,4259,4254,'ann',20,5),(97,4260,4254,'nne',20,5),(97,4261,4254,'nel',20,5),(97,4262,4257,'dis',50,5),(97,4263,4257,'isk',50,5),(97,4264,4262,'naa',100,5),(97,4265,4264,'600',3.333,5),(97,4266,4264,'00a',3.333,5),(97,4267,4264,'0a0',3.333,5),(97,4268,4264,'a09',3.333,5),(97,4269,4264,'098',3.333,5),(97,4270,4264,'980',3.333,5),(97,4271,4264,'804',3.333,5),(97,4272,4264,'044',3.333,5),(97,4273,4264,'443',3.333,5),(97,4274,4264,'430',3.333,5),(97,4275,4264,'307',3.333,5),(97,4276,4264,'072',3.333,5),(97,4277,4264,'725',3.333,5),(97,4278,4264,'259',3.333,5),(97,4279,4264,'593',3.333,5),(97,4280,4264,'931',3.333,5),(97,4281,4264,'313',3.333,5),(97,4282,4264,'13f',3.333,5),(97,4283,4264,'3f3',3.333,5),(97,4284,4264,'f33',3.333,5),(97,4285,4264,'334',3.333,5),(97,4286,4264,'345',3.333,5),(97,4287,4264,'455',3.333,5),(97,4288,4264,'556',3.333,5),(97,4289,4264,'563',3.333,5),(97,4290,4264,'639',3.333,5),(97,4291,4264,'393',3.333,5),(97,4292,4264,'934',3.333,5),(97,4293,4264,'344',3.333,5),(97,4294,4264,'442',3.333,5),(98,4296,4295,'net',25,5),(98,4297,4295,'eta',25,5),(98,4298,4295,'tap',25,5),(98,4299,4295,'app',25,5),(98,4300,4296,'fib',33.333,5),(98,4301,4296,'ibr',33.333,5),(98,4302,4296,'bre',33.333,5),(98,4303,4300,'cha',20,5),(98,4304,4300,'han',20,5),(98,4305,4300,'ann',20,5),(98,4306,4300,'nne',20,5),(98,4307,4300,'nel',20,5),(98,4308,4303,'dis',50,5),(98,4309,4303,'isk',50,5),(98,4310,4308,'naa',100,5),(98,4311,4310,'600',3.333,5),(98,4312,4310,'00a',3.333,5),(98,4313,4310,'0a0',3.333,5),(98,4314,4310,'a09',3.333,5),(98,4315,4310,'098',3.333,5),(98,4316,4310,'980',3.333,5),(98,4317,4310,'804',3.333,5),(98,4318,4310,'044',3.333,5),(98,4319,4310,'443',3.333,5),(98,4320,4310,'430',3.333,5),(98,4321,4310,'307',3.333,5),(98,4322,4310,'072',3.333,5),(98,4323,4310,'725',3.333,5),(98,4324,4310,'259',3.333,5),(98,4325,4310,'593',3.333,5),(98,4326,4310,'931',3.333,5),(98,4327,4310,'313',3.333,5),(98,4328,4310,'13f',3.333,5),(98,4329,4310,'3f3',3.333,5),(98,4330,4310,'f33',3.333,5),(98,4331,4310,'334',3.333,5),(98,4332,4310,'345',3.333,5),(98,4333,4310,'455',3.333,5),(98,4334,4310,'556',3.333,5),(98,4335,4310,'563',3.333,5),(98,4336,4310,'639',3.333,5),(98,4337,4310,'393',3.333,5),(98,4338,4310,'934',3.333,5),(98,4339,4310,'344',3.333,5),(98,4340,4310,'443',3.333,5),(99,4342,4341,'net',25,5),(99,4343,4341,'eta',25,5),(99,4344,4341,'tap',25,5),(99,4345,4341,'app',25,5),(99,4346,4342,'fib',33.333,5),(99,4347,4342,'ibr',33.333,5),(99,4348,4342,'bre',33.333,5),(99,4349,4346,'cha',20,5),(99,4350,4346,'han',20,5),(99,4351,4346,'ann',20,5),(99,4352,4346,'nne',20,5),(99,4353,4346,'nel',20,5),(99,4354,4349,'dis',50,5),(99,4355,4349,'isk',50,5),(99,4356,4354,'naa',100,5),(99,4357,4356,'600',3.333,5),(99,4358,4356,'00a',3.333,5),(99,4359,4356,'0a0',3.333,5),(99,4360,4356,'a09',3.333,5),(99,4361,4356,'098',3.333,5),(99,4362,4356,'980',3.333,5),(99,4363,4356,'804',3.333,5),(99,4364,4356,'044',3.333,5),(99,4365,4356,'443',3.333,5),(99,4366,4356,'430',3.333,5),(99,4367,4356,'307',3.333,5),(99,4368,4356,'075',3.333,5),(99,4369,4356,'753',3.333,5),(99,4370,4356,'535',3.333,5),(99,4371,4356,'357',3.333,5),(99,4372,4356,'573',3.333,5),(99,4373,4356,'732',3.333,5),(99,4374,4356,'32b',3.333,5),(99,4375,4356,'2b3',3.333,5),(99,4376,4356,'b33',3.333,5),(99,4377,4356,'334',3.333,5),(99,4378,4356,'345',3.333,5),(99,4379,4356,'457',3.333,5),(99,4380,4356,'571',3.333,5),(99,4381,4356,'715',3.333,5),(99,4382,4356,'152',3.333,5),(99,4383,4356,'527',3.333,5),(99,4384,4356,'275',3.333,5),(99,4385,4356,'752',3.333,5),(99,4386,4356,'52d',3.333,5),(100,4388,4387,'net',25,5),(100,4389,4387,'eta',25,5),(100,4390,4387,'tap',25,5),(100,4391,4387,'app',25,5),(100,4392,4388,'fib',33.333,5),(100,4393,4388,'ibr',33.333,5),(100,4394,4388,'bre',33.333,5),(100,4395,4392,'cha',20,5),(100,4396,4392,'han',20,5),(100,4397,4392,'ann',20,5),(100,4398,4392,'nne',20,5),(100,4399,4392,'nel',20,5),(100,4400,4395,'dis',50,5),(100,4401,4395,'isk',50,5),(100,4402,4400,'naa',100,5),(100,4403,4402,'600',3.333,5),(100,4404,4402,'00a',3.333,5),(100,4405,4402,'0a0',3.333,5),(100,4406,4402,'a09',3.333,5),(100,4407,4402,'098',3.333,5),(100,4408,4402,'980',3.333,5),(100,4409,4402,'804',3.333,5),(100,4410,4402,'044',3.333,5),(100,4411,4402,'443',3.333,5),(100,4412,4402,'430',3.333,5),(100,4413,4402,'307',3.333,5),(100,4414,4402,'072',3.333,5),(100,4415,4402,'725',3.333,5),(100,4416,4402,'259',3.333,5),(100,4417,4402,'593',3.333,5),(100,4418,4402,'931',3.333,5),(100,4419,4402,'313',3.333,5),(100,4420,4402,'13f',3.333,5),(100,4421,4402,'3f3',3.333,5),(100,4422,4402,'f33',3.333,5),(100,4423,4402,'334',3.333,5),(100,4424,4402,'345',3.333,5),(100,4425,4402,'455',3.333,5),(100,4426,4402,'556',3.333,5),(100,4427,4402,'563',3.333,5),(100,4428,4402,'639',3.333,5),(100,4429,4402,'393',3.333,5),(100,4430,4402,'934',3.333,5),(100,4431,4402,'344',3.333,5),(100,4432,4402,'444',3.333,5),(101,4434,4433,'net',25,5),(101,4435,4433,'eta',25,5),(101,4436,4433,'tap',25,5),(101,4437,4433,'app',25,5),(101,4438,4434,'fib',33.333,5),(101,4439,4434,'ibr',33.333,5),(101,4440,4434,'bre',33.333,5),(101,4441,4438,'cha',20,5),(101,4442,4438,'han',20,5),(101,4443,4438,'ann',20,5),(101,4444,4438,'nne',20,5),(101,4445,4438,'nel',20,5),(101,4446,4441,'dis',50,5),(101,4447,4441,'isk',50,5),(101,4448,4446,'naa',100,5),(101,4449,4448,'600',3.333,5),(101,4450,4448,'00a',3.333,5),(101,4451,4448,'0a0',3.333,5),(101,4452,4448,'a09',3.333,5),(101,4453,4448,'098',3.333,5),(101,4454,4448,'980',3.333,5),(101,4455,4448,'804',3.333,5),(101,4456,4448,'044',3.333,5),(101,4457,4448,'443',3.333,5),(101,4458,4448,'430',3.333,5),(101,4459,4448,'307',3.333,5),(101,4460,4448,'072',3.333,5),(101,4461,4448,'725',3.333,5),(101,4462,4448,'259',3.333,5),(101,4463,4448,'593',3.333,5),(101,4464,4448,'931',3.333,5),(101,4465,4448,'313',3.333,5),(101,4466,4448,'13f',3.333,5),(101,4467,4448,'3f3',3.333,5),(101,4468,4448,'f33',3.333,5),(101,4469,4448,'334',3.333,5),(101,4470,4448,'345',3.333,5),(101,4471,4448,'455',3.333,5),(101,4472,4448,'556',3.333,5),(101,4473,4448,'563',3.333,5),(101,4474,4448,'639',3.333,5),(101,4475,4448,'393',3.333,5),(101,4476,4448,'934',3.333,5),(101,4477,4448,'344',3.333,5),(101,4478,4448,'445',3.333,5),(102,4480,4479,'net',25,5),(102,4481,4479,'eta',25,5),(102,4482,4479,'tap',25,5),(102,4483,4479,'app',25,5),(102,4484,4480,'fib',33.333,5),(102,4485,4480,'ibr',33.333,5),(102,4486,4480,'bre',33.333,5),(102,4487,4484,'cha',20,5),(102,4488,4484,'han',20,5),(102,4489,4484,'ann',20,5),(102,4490,4484,'nne',20,5),(102,4491,4484,'nel',20,5),(102,4492,4487,'dis',50,5),(102,4493,4487,'isk',50,5),(102,4494,4492,'naa',100,5),(102,4495,4494,'600',3.333,5),(102,4496,4494,'00a',3.333,5),(102,4497,4494,'0a0',3.333,5),(102,4498,4494,'a09',3.333,5),(102,4499,4494,'098',3.333,5),(102,4500,4494,'980',3.333,5),(102,4501,4494,'804',3.333,5),(102,4502,4494,'044',3.333,5),(102,4503,4494,'443',3.333,5),(102,4504,4494,'430',3.333,5),(102,4505,4494,'307',3.333,5),(102,4506,4494,'072',3.333,5),(102,4507,4494,'725',3.333,5),(102,4508,4494,'259',3.333,5),(102,4509,4494,'593',3.333,5),(102,4510,4494,'931',3.333,5),(102,4511,4494,'313',3.333,5),(102,4512,4494,'13f',3.333,5),(102,4513,4494,'3f3',3.333,5),(102,4514,4494,'f33',3.333,5),(102,4515,4494,'334',3.333,5),(102,4516,4494,'345',3.333,5),(102,4517,4494,'455',3.333,5),(102,4518,4494,'556',3.333,5),(102,4519,4494,'563',3.333,5),(102,4520,4494,'639',3.333,5),(102,4521,4494,'393',3.333,5),(102,4522,4494,'934',3.333,5),(102,4523,4494,'344',3.333,5),(102,4524,4494,'446',3.333,5),(103,4526,4525,'net',25,5),(103,4527,4525,'eta',25,5),(103,4528,4525,'tap',25,5),(103,4529,4525,'app',25,5),(103,4530,4526,'fib',33.333,5),(103,4531,4526,'ibr',33.333,5),(103,4532,4526,'bre',33.333,5),(103,4533,4530,'cha',20,5),(103,4534,4530,'han',20,5),(103,4535,4530,'ann',20,5),(103,4536,4530,'nne',20,5),(103,4537,4530,'nel',20,5),(103,4538,4533,'dis',50,5),(103,4539,4533,'isk',50,5),(103,4540,4538,'naa',100,5),(103,4541,4540,'600',3.333,5),(103,4542,4540,'00a',3.333,5),(103,4543,4540,'0a0',3.333,5),(103,4544,4540,'a09',3.333,5),(103,4545,4540,'098',3.333,5),(103,4546,4540,'980',3.333,5),(103,4547,4540,'804',3.333,5),(103,4548,4540,'044',3.333,5),(103,4549,4540,'443',3.333,5),(103,4550,4540,'430',3.333,5),(103,4551,4540,'307',3.333,5),(103,4552,4540,'072',3.333,5),(103,4553,4540,'725',3.333,5),(103,4554,4540,'259',3.333,5),(103,4555,4540,'593',3.333,5),(103,4556,4540,'931',3.333,5),(103,4557,4540,'313',3.333,5),(103,4558,4540,'13f',3.333,5),(103,4559,4540,'3f3',3.333,5),(103,4560,4540,'f33',3.333,5),(103,4561,4540,'334',3.333,5),(103,4562,4540,'345',3.333,5),(103,4563,4540,'455',3.333,5),(103,4564,4540,'556',3.333,5),(103,4565,4540,'563',3.333,5),(103,4566,4540,'639',3.333,5),(103,4567,4540,'393',3.333,5),(103,4568,4540,'934',3.333,5),(103,4569,4540,'344',3.333,5),(103,4570,4540,'447',3.333,5),(104,4572,4571,'net',25,5),(104,4573,4571,'eta',25,5),(104,4574,4571,'tap',25,5),(104,4575,4571,'app',25,5),(104,4576,4572,'fib',33.333,5),(104,4577,4572,'ibr',33.333,5),(104,4578,4572,'bre',33.333,5),(104,4579,4576,'cha',20,5),(104,4580,4576,'han',20,5),(104,4581,4576,'ann',20,5),(104,4582,4576,'nne',20,5),(104,4583,4576,'nel',20,5),(104,4584,4579,'dis',50,5),(104,4585,4579,'isk',50,5),(104,4586,4584,'naa',100,5),(104,4587,4586,'600',3.333,5),(104,4588,4586,'00a',3.333,5),(104,4589,4586,'0a0',3.333,5),(104,4590,4586,'a09',3.333,5),(104,4591,4586,'098',3.333,5),(104,4592,4586,'980',3.333,5),(104,4593,4586,'804',3.333,5),(104,4594,4586,'044',3.333,5),(104,4595,4586,'443',3.333,5),(104,4596,4586,'430',3.333,5),(104,4597,4586,'307',3.333,5),(104,4598,4586,'072',3.333,5),(104,4599,4586,'725',3.333,5),(104,4600,4586,'259',3.333,5),(104,4601,4586,'593',3.333,5),(104,4602,4586,'931',3.333,5),(104,4603,4586,'313',3.333,5),(104,4604,4586,'13f',3.333,5),(104,4605,4586,'3f3',3.333,5),(104,4606,4586,'f33',3.333,5),(104,4607,4586,'334',3.333,5),(104,4608,4586,'345',3.333,5),(104,4609,4586,'455',3.333,5),(104,4610,4586,'556',3.333,5),(104,4611,4586,'563',3.333,5),(104,4612,4586,'639',3.333,5),(104,4613,4586,'393',3.333,5),(104,4614,4586,'934',3.333,5),(104,4615,4586,'344',3.333,5),(104,4616,4586,'448',3.333,5),(105,4618,4617,'net',25,5),(105,4619,4617,'eta',25,5),(105,4620,4617,'tap',25,5),(105,4621,4617,'app',25,5),(105,4622,4618,'fib',33.333,5),(105,4623,4618,'ibr',33.333,5),(105,4624,4618,'bre',33.333,5),(105,4625,4622,'cha',20,5),(105,4626,4622,'han',20,5),(105,4627,4622,'ann',20,5),(105,4628,4622,'nne',20,5),(105,4629,4622,'nel',20,5),(105,4630,4625,'dis',50,5),(105,4631,4625,'isk',50,5),(105,4632,4630,'naa',100,5),(105,4633,4632,'600',3.333,5),(105,4634,4632,'00a',3.333,5),(105,4635,4632,'0a0',3.333,5),(105,4636,4632,'a09',3.333,5),(105,4637,4632,'098',3.333,5),(105,4638,4632,'980',3.333,5),(105,4639,4632,'804',3.333,5),(105,4640,4632,'044',3.333,5),(105,4641,4632,'443',3.333,5),(105,4642,4632,'430',3.333,5),(105,4643,4632,'307',3.333,5),(105,4644,4632,'072',3.333,5),(105,4645,4632,'725',3.333,5),(105,4646,4632,'259',3.333,5),(105,4647,4632,'593',3.333,5),(105,4648,4632,'931',3.333,5),(105,4649,4632,'313',3.333,5),(105,4650,4632,'13f',3.333,5),(105,4651,4632,'3f3',3.333,5),(105,4652,4632,'f33',3.333,5),(105,4653,4632,'334',3.333,5),(105,4654,4632,'345',3.333,5),(105,4655,4632,'455',3.333,5),(105,4656,4632,'556',3.333,5),(105,4657,4632,'563',3.333,5),(105,4658,4632,'639',3.333,5),(105,4659,4632,'393',3.333,5),(105,4660,4632,'934',3.333,5),(105,4661,4632,'344',3.333,5),(105,4662,4632,'449',3.333,5),(106,4664,4663,'net',25,5),(106,4665,4663,'eta',25,5),(106,4666,4663,'tap',25,5),(106,4667,4663,'app',25,5),(106,4668,4664,'fib',33.333,5),(106,4669,4664,'ibr',33.333,5),(106,4670,4664,'bre',33.333,5),(106,4671,4668,'cha',20,5),(106,4672,4668,'han',20,5),(106,4673,4668,'ann',20,5),(106,4674,4668,'nne',20,5),(106,4675,4668,'nel',20,5),(106,4676,4671,'dis',50,5),(106,4677,4671,'isk',50,5),(106,4678,4676,'naa',100,5),(106,4679,4678,'600',3.333,5),(106,4680,4678,'00a',3.333,5),(106,4681,4678,'0a0',3.333,5),(106,4682,4678,'a09',3.333,5),(106,4683,4678,'098',3.333,5),(106,4684,4678,'980',3.333,5),(106,4685,4678,'804',3.333,5),(106,4686,4678,'044',3.333,5),(106,4687,4678,'443',3.333,5),(106,4688,4678,'430',3.333,5),(106,4689,4678,'307',3.333,5),(106,4690,4678,'072',3.333,5),(106,4691,4678,'725',3.333,5),(106,4692,4678,'259',3.333,5),(106,4693,4678,'593',3.333,5),(106,4694,4678,'931',3.333,5),(106,4695,4678,'313',3.333,5),(106,4696,4678,'13f',3.333,5),(106,4697,4678,'3f3',3.333,5),(106,4698,4678,'f33',3.333,5),(106,4699,4678,'334',3.333,5),(106,4700,4678,'345',3.333,5),(106,4701,4678,'455',3.333,5),(106,4702,4678,'556',3.333,5),(106,4703,4678,'563',3.333,5),(106,4704,4678,'638',3.333,5),(106,4705,4678,'387',3.333,5),(106,4706,4678,'872',3.333,5),(106,4707,4678,'724',3.333,5),(106,4708,4678,'243',3.333,5),(107,4710,4709,'net',25,5),(107,4711,4709,'eta',25,5),(107,4712,4709,'tap',25,5),(107,4713,4709,'app',25,5),(107,4714,4710,'fib',33.333,5),(107,4715,4710,'ibr',33.333,5),(107,4716,4710,'bre',33.333,5),(107,4717,4714,'cha',20,5),(107,4718,4714,'han',20,5),(107,4719,4714,'ann',20,5),(107,4720,4714,'nne',20,5),(107,4721,4714,'nel',20,5),(107,4722,4717,'dis',50,5),(107,4723,4717,'isk',50,5),(107,4724,4722,'naa',100,5),(107,4725,4724,'600',3.333,5),(107,4726,4724,'00a',3.333,5),(107,4727,4724,'0a0',3.333,5),(107,4728,4724,'a09',3.333,5),(107,4729,4724,'098',3.333,5),(107,4730,4724,'980',3.333,5),(107,4731,4724,'804',3.333,5),(107,4732,4724,'044',3.333,5),(107,4733,4724,'443',3.333,5),(107,4734,4724,'430',3.333,5),(107,4735,4724,'307',3.333,5),(107,4736,4724,'072',3.333,5),(107,4737,4724,'725',3.333,5),(107,4738,4724,'259',3.333,5),(107,4739,4724,'593',3.333,5),(107,4740,4724,'931',3.333,5),(107,4741,4724,'313',3.333,5),(107,4742,4724,'13f',3.333,5),(107,4743,4724,'3f3',3.333,5),(107,4744,4724,'f33',3.333,5),(107,4745,4724,'334',3.333,5),(107,4746,4724,'345',3.333,5),(107,4747,4724,'455',3.333,5),(107,4748,4724,'556',3.333,5),(107,4749,4724,'563',3.333,5),(107,4750,4724,'638',3.333,5),(107,4751,4724,'387',3.333,5),(107,4752,4724,'872',3.333,5),(107,4753,4724,'724',3.333,5),(107,4754,4724,'244',3.333,5),(108,4756,4755,'net',25,5),(108,4757,4755,'eta',25,5),(108,4758,4755,'tap',25,5),(108,4759,4755,'app',25,5),(108,4760,4756,'fib',33.333,5),(108,4761,4756,'ibr',33.333,5),(108,4762,4756,'bre',33.333,5),(108,4763,4760,'cha',20,5),(108,4764,4760,'han',20,5),(108,4765,4760,'ann',20,5),(108,4766,4760,'nne',20,5),(108,4767,4760,'nel',20,5),(108,4768,4763,'dis',50,5),(108,4769,4763,'isk',50,5),(108,4770,4768,'naa',100,5),(108,4771,4770,'600',3.333,5),(108,4772,4770,'00a',3.333,5),(108,4773,4770,'0a0',3.333,5),(108,4774,4770,'a09',3.333,5),(108,4775,4770,'098',3.333,5),(108,4776,4770,'980',3.333,5),(108,4777,4770,'804',3.333,5),(108,4778,4770,'044',3.333,5),(108,4779,4770,'443',3.333,5),(108,4780,4770,'430',3.333,5),(108,4781,4770,'307',3.333,5),(108,4782,4770,'072',3.333,5),(108,4783,4770,'725',3.333,5),(108,4784,4770,'259',3.333,5),(108,4785,4770,'593',3.333,5),(108,4786,4770,'931',3.333,5),(108,4787,4770,'313',3.333,5),(108,4788,4770,'13f',3.333,5),(108,4789,4770,'3f3',3.333,5),(108,4790,4770,'f33',3.333,5),(108,4791,4770,'334',3.333,5),(108,4792,4770,'345',3.333,5),(108,4793,4770,'455',3.333,5),(108,4794,4770,'556',3.333,5),(108,4795,4770,'563',3.333,5),(108,4796,4770,'638',3.333,5),(108,4797,4770,'387',3.333,5),(108,4798,4770,'872',3.333,5),(108,4799,4770,'724',3.333,5),(108,4800,4770,'245',3.333,5),(109,4802,4801,'net',25,5),(109,4803,4801,'eta',25,5),(109,4804,4801,'tap',25,5),(109,4805,4801,'app',25,5),(109,4806,4802,'fib',33.333,5),(109,4807,4802,'ibr',33.333,5),(109,4808,4802,'bre',33.333,5),(109,4809,4806,'cha',20,5),(109,4810,4806,'han',20,5),(109,4811,4806,'ann',20,5),(109,4812,4806,'nne',20,5),(109,4813,4806,'nel',20,5),(109,4814,4809,'dis',50,5),(109,4815,4809,'isk',50,5),(109,4816,4814,'naa',100,5),(109,4817,4816,'600',3.333,5),(109,4818,4816,'00a',3.333,5),(109,4819,4816,'0a0',3.333,5),(109,4820,4816,'a09',3.333,5),(109,4821,4816,'098',3.333,5),(109,4822,4816,'980',3.333,5),(109,4823,4816,'804',3.333,5),(109,4824,4816,'044',3.333,5),(109,4825,4816,'443',3.333,5),(109,4826,4816,'430',3.333,5),(109,4827,4816,'307',3.333,5),(109,4828,4816,'072',3.333,5),(109,4829,4816,'725',3.333,5),(109,4830,4816,'259',3.333,5),(109,4831,4816,'593',3.333,5),(109,4832,4816,'931',3.333,5),(109,4833,4816,'313',3.333,5),(109,4834,4816,'13f',3.333,5),(109,4835,4816,'3f3',3.333,5),(109,4836,4816,'f33',3.333,5),(109,4837,4816,'334',3.333,5),(109,4838,4816,'345',3.333,5),(109,4839,4816,'455',3.333,5),(109,4840,4816,'556',3.333,5),(109,4841,4816,'563',3.333,5),(109,4842,4816,'638',3.333,5),(109,4843,4816,'387',3.333,5),(109,4844,4816,'872',3.333,5),(109,4845,4816,'724',3.333,5),(109,4846,4816,'246',3.333,5),(110,4848,4847,'net',25,5),(110,4849,4847,'eta',25,5),(110,4850,4847,'tap',25,5),(110,4851,4847,'app',25,5),(110,4852,4848,'fib',33.333,5),(110,4853,4848,'ibr',33.333,5),(110,4854,4848,'bre',33.333,5),(110,4855,4852,'cha',20,5),(110,4856,4852,'han',20,5),(110,4857,4852,'ann',20,5),(110,4858,4852,'nne',20,5),(110,4859,4852,'nel',20,5),(110,4860,4855,'dis',50,5),(110,4861,4855,'isk',50,5),(110,4862,4860,'naa',100,5),(110,4863,4862,'600',3.333,5),(110,4864,4862,'00a',3.333,5),(110,4865,4862,'0a0',3.333,5),(110,4866,4862,'a09',3.333,5),(110,4867,4862,'098',3.333,5),(110,4868,4862,'980',3.333,5),(110,4869,4862,'804',3.333,5),(110,4870,4862,'044',3.333,5),(110,4871,4862,'443',3.333,5),(110,4872,4862,'430',3.333,5),(110,4873,4862,'307',3.333,5),(110,4874,4862,'072',3.333,5),(110,4875,4862,'725',3.333,5),(110,4876,4862,'259',3.333,5),(110,4877,4862,'593',3.333,5),(110,4878,4862,'931',3.333,5),(110,4879,4862,'313',3.333,5),(110,4880,4862,'13f',3.333,5),(110,4881,4862,'3f3',3.333,5),(110,4882,4862,'f33',3.333,5),(110,4883,4862,'334',3.333,5),(110,4884,4862,'345',3.333,5),(110,4885,4862,'455',3.333,5),(110,4886,4862,'556',3.333,5),(110,4887,4862,'563',3.333,5),(110,4888,4862,'638',3.333,5),(110,4889,4862,'387',3.333,5),(110,4890,4862,'872',3.333,5),(110,4891,4862,'724',3.333,5),(110,4892,4862,'247',3.333,5),(111,4894,4893,'net',25,5),(111,4895,4893,'eta',25,5),(111,4896,4893,'tap',25,5),(111,4897,4893,'app',25,5),(111,4898,4894,'fib',33.333,5),(111,4899,4894,'ibr',33.333,5),(111,4900,4894,'bre',33.333,5),(111,4901,4898,'cha',20,5),(111,4902,4898,'han',20,5),(111,4903,4898,'ann',20,5),(111,4904,4898,'nne',20,5),(111,4905,4898,'nel',20,5),(111,4906,4901,'dis',50,5),(111,4907,4901,'isk',50,5),(111,4908,4906,'naa',100,5),(111,4909,4908,'600',3.333,5),(111,4910,4908,'00a',3.333,5),(111,4911,4908,'0a0',3.333,5),(111,4912,4908,'a09',3.333,5),(111,4913,4908,'098',3.333,5),(111,4914,4908,'980',3.333,5),(111,4915,4908,'804',3.333,5),(111,4916,4908,'044',3.333,5),(111,4917,4908,'443',3.333,5),(111,4918,4908,'430',3.333,5),(111,4919,4908,'307',3.333,5),(111,4920,4908,'072',3.333,5),(111,4921,4908,'725',3.333,5),(111,4922,4908,'259',3.333,5),(111,4923,4908,'593',3.333,5),(111,4924,4908,'931',3.333,5),(111,4925,4908,'313',3.333,5),(111,4926,4908,'13f',3.333,5),(111,4927,4908,'3f3',3.333,5),(111,4928,4908,'f33',3.333,5),(111,4929,4908,'334',3.333,5),(111,4930,4908,'345',3.333,5),(111,4931,4908,'455',3.333,5),(111,4932,4908,'556',3.333,5),(111,4933,4908,'563',3.333,5),(111,4934,4908,'638',3.333,5),(111,4935,4908,'387',3.333,5),(111,4936,4908,'872',3.333,5),(111,4937,4908,'724',3.333,5),(111,4938,4908,'248',3.333,5),(112,4940,4939,'net',25,5),(112,4941,4939,'eta',25,5),(112,4942,4939,'tap',25,5),(112,4943,4939,'app',25,5),(112,4944,4940,'fib',33.333,5),(112,4945,4940,'ibr',33.333,5),(112,4946,4940,'bre',33.333,5),(112,4947,4944,'cha',20,5),(112,4948,4944,'han',20,5),(112,4949,4944,'ann',20,5),(112,4950,4944,'nne',20,5),(112,4951,4944,'nel',20,5),(112,4952,4947,'dis',50,5),(112,4953,4947,'isk',50,5),(112,4954,4952,'naa',100,5),(112,4955,4954,'600',3.333,5),(112,4956,4954,'00a',3.333,5),(112,4957,4954,'0a0',3.333,5),(112,4958,4954,'a09',3.333,5),(112,4959,4954,'098',3.333,5),(112,4960,4954,'980',3.333,5),(112,4961,4954,'804',3.333,5),(112,4962,4954,'044',3.333,5),(112,4963,4954,'443',3.333,5),(112,4964,4954,'430',3.333,5),(112,4965,4954,'307',3.333,5),(112,4966,4954,'072',3.333,5),(112,4967,4954,'725',3.333,5),(112,4968,4954,'259',3.333,5),(112,4969,4954,'593',3.333,5),(112,4970,4954,'931',3.333,5),(112,4971,4954,'313',3.333,5),(112,4972,4954,'13f',3.333,5),(112,4973,4954,'3f3',3.333,5),(112,4974,4954,'f33',3.333,5),(112,4975,4954,'334',3.333,5),(112,4976,4954,'345',3.333,5),(112,4977,4954,'455',3.333,5),(112,4978,4954,'556',3.333,5),(112,4979,4954,'563',3.333,5),(112,4980,4954,'638',3.333,5),(112,4981,4954,'387',3.333,5),(112,4982,4954,'872',3.333,5),(112,4983,4954,'724',3.333,5),(112,4984,4954,'249',3.333,5),(113,4986,4985,'net',25,5),(113,4987,4985,'eta',25,5),(113,4988,4985,'tap',25,5),(113,4989,4985,'app',25,5),(113,4990,4986,'ser',25,5),(113,4991,4986,'eri',25,5),(113,4992,4986,'ria',25,5),(113,4993,4986,'ial',25,5),(113,4994,4990,'att',16.667,5),(113,4995,4990,'tta',16.667,5),(113,4996,4990,'tac',16.667,5),(113,4997,4990,'ach',16.667,5),(113,4998,4990,'che',16.667,5),(113,4999,4990,'hed',16.667,5),(113,5000,4994,'scs',50,5),(113,5001,4994,'csi',50,5),(113,5002,5000,'dis',50,5),(113,5003,5000,'isk',50,5),(113,5004,5002,'naa',100,5),(113,5005,5004,'600',3.333,5),(113,5006,5004,'00a',3.333,5),(113,5007,5004,'0a0',3.333,5),(113,5008,5004,'a09',3.333,5),(113,5009,5004,'098',3.333,5),(113,5010,5004,'980',3.333,5),(113,5011,5004,'804',3.333,5),(113,5012,5004,'043',3.333,5),(113,5013,5004,'434',3.333,5),(113,5014,5004,'34e',3.333,5),(113,5015,5004,'4e8',3.333,5),(113,5016,5004,'e84',3.333,5),(113,5017,5004,'84e',3.333,5),(113,5018,5004,'4ee',3.333,5),(113,5019,5004,'ee1',3.333,5),(113,5020,5004,'e1b',3.333,5),(113,5021,5004,'1b7',3.333,5),(113,5022,5004,'b73',3.333,5),(113,5023,5004,'734',3.333,5),(113,5024,5004,'348',3.333,5),(113,5025,5004,'481',3.333,5),(113,5026,5004,'811',3.333,5),(113,5027,5004,'117',3.333,5),(113,5028,5004,'17b',3.333,5),(113,5029,5004,'7b0',3.333,5),(113,5030,5004,'b06',3.333,5),(113,5031,5004,'06a',3.333,5),(113,5032,5004,'6ab',3.333,5),(113,5033,5004,'aba',3.333,5),(113,5034,5004,'ba2',3.333,5),(114,5036,5035,'net',25,5),(114,5037,5035,'eta',25,5),(114,5038,5035,'tap',25,5),(114,5039,5035,'app',25,5),(114,5040,5036,'fib',33.333,5),(114,5041,5036,'ibr',33.333,5),(114,5042,5036,'bre',33.333,5),(114,5043,5040,'cha',20,5),(114,5044,5040,'han',20,5),(114,5045,5040,'ann',20,5),(114,5046,5040,'nne',20,5),(114,5047,5040,'nel',20,5),(114,5048,5043,'dis',50,5),(114,5049,5043,'isk',50,5),(114,5050,5048,'naa',100,5),(114,5051,5050,'600',3.333,5),(114,5052,5050,'00a',3.333,5),(114,5053,5050,'0a0',3.333,5),(114,5054,5050,'a09',3.333,5),(114,5055,5050,'098',3.333,5),(114,5056,5050,'980',3.333,5),(114,5057,5050,'804',3.333,5),(114,5058,5050,'044',3.333,5),(114,5059,5050,'443',3.333,5),(114,5060,5050,'430',3.333,5),(114,5061,5050,'307',3.333,5),(114,5062,5050,'072',3.333,5),(114,5063,5050,'725',3.333,5),(114,5064,5050,'259',3.333,5),(114,5065,5050,'593',3.333,5),(114,5066,5050,'931',3.333,5),(114,5067,5050,'313',3.333,5),(114,5068,5050,'13f',3.333,5),(114,5069,5050,'3f3',3.333,5),(114,5070,5050,'f33',3.333,5),(114,5071,5050,'334',3.333,5),(114,5072,5050,'345',3.333,5),(114,5073,5050,'455',3.333,5),(114,5074,5050,'556',3.333,5),(114,5075,5050,'563',3.333,5),(114,5076,5050,'639',3.333,5),(114,5077,5050,'393',3.333,5),(114,5078,5050,'934',3.333,5),(114,5079,5050,'344',3.333,5),(114,5080,5050,'44a',3.333,5),(115,5082,5081,'net',25,5),(115,5083,5081,'eta',25,5),(115,5084,5081,'tap',25,5),(115,5085,5081,'app',25,5),(115,5086,5082,'fib',33.333,5),(115,5087,5082,'ibr',33.333,5),(115,5088,5082,'bre',33.333,5),(115,5089,5086,'cha',20,5),(115,5090,5086,'han',20,5),(115,5091,5086,'ann',20,5),(115,5092,5086,'nne',20,5),(115,5093,5086,'nel',20,5),(115,5094,5089,'dis',50,5),(115,5095,5089,'isk',50,5),(115,5096,5094,'naa',100,5),(115,5097,5096,'600',3.333,5),(115,5098,5096,'00a',3.333,5),(115,5099,5096,'0a0',3.333,5),(115,5100,5096,'a09',3.333,5),(115,5101,5096,'098',3.333,5),(115,5102,5096,'980',3.333,5),(115,5103,5096,'804',3.333,5),(115,5104,5096,'044',3.333,5),(115,5105,5096,'443',3.333,5),(115,5106,5096,'430',3.333,5),(115,5107,5096,'307',3.333,5),(115,5108,5096,'072',3.333,5),(115,5109,5096,'725',3.333,5),(115,5110,5096,'259',3.333,5),(115,5111,5096,'593',3.333,5),(115,5112,5096,'931',3.333,5),(115,5113,5096,'313',3.333,5),(115,5114,5096,'13f',3.333,5),(115,5115,5096,'3f3',3.333,5),(115,5116,5096,'f33',3.333,5),(115,5117,5096,'334',3.333,5),(115,5118,5096,'345',3.333,5),(115,5119,5096,'455',3.333,5),(115,5120,5096,'556',3.333,5),(115,5121,5096,'563',3.333,5),(115,5122,5096,'639',3.333,5),(115,5123,5096,'393',3.333,5),(115,5124,5096,'934',3.333,5),(115,5125,5096,'344',3.333,5),(115,5126,5096,'44b',3.333,5),(116,5128,5127,'net',25,5),(116,5129,5127,'eta',25,5),(116,5130,5127,'tap',25,5),(116,5131,5127,'app',25,5),(116,5132,5128,'fib',33.333,5),(116,5133,5128,'ibr',33.333,5),(116,5134,5128,'bre',33.333,5),(116,5135,5132,'cha',20,5),(116,5136,5132,'han',20,5),(116,5137,5132,'ann',20,5),(116,5138,5132,'nne',20,5),(116,5139,5132,'nel',20,5),(116,5140,5135,'dis',50,5),(116,5141,5135,'isk',50,5),(116,5142,5140,'naa',100,5),(116,5143,5142,'600',3.333,5),(116,5144,5142,'00a',3.333,5),(116,5145,5142,'0a0',3.333,5),(116,5146,5142,'a09',3.333,5),(116,5147,5142,'098',3.333,5),(116,5148,5142,'980',3.333,5),(116,5149,5142,'804',3.333,5),(116,5150,5142,'044',3.333,5),(116,5151,5142,'443',3.333,5),(116,5152,5142,'430',3.333,5),(116,5153,5142,'307',3.333,5),(116,5154,5142,'072',3.333,5),(116,5155,5142,'725',3.333,5),(116,5156,5142,'259',3.333,5),(116,5157,5142,'593',3.333,5),(116,5158,5142,'931',3.333,5),(116,5159,5142,'313',3.333,5),(116,5160,5142,'13f',3.333,5),(116,5161,5142,'3f3',3.333,5),(116,5162,5142,'f33',3.333,5),(116,5163,5142,'334',3.333,5),(116,5164,5142,'345',3.333,5),(116,5165,5142,'455',3.333,5),(116,5166,5142,'556',3.333,5),(116,5167,5142,'563',3.333,5),(116,5168,5142,'639',3.333,5),(116,5169,5142,'393',3.333,5),(116,5170,5142,'934',3.333,5),(116,5171,5142,'344',3.333,5),(116,5172,5142,'44c',3.333,5),(117,5174,5173,'net',25,5),(117,5175,5173,'eta',25,5),(117,5176,5173,'tap',25,5),(117,5177,5173,'app',25,5),(117,5178,5174,'fib',33.333,5),(117,5179,5174,'ibr',33.333,5),(117,5180,5174,'bre',33.333,5),(117,5181,5178,'cha',20,5),(117,5182,5178,'han',20,5),(117,5183,5178,'ann',20,5),(117,5184,5178,'nne',20,5),(117,5185,5178,'nel',20,5),(117,5186,5181,'dis',50,5),(117,5187,5181,'isk',50,5),(117,5188,5186,'naa',100,5),(117,5189,5188,'600',3.333,5),(117,5190,5188,'00a',3.333,5),(117,5191,5188,'0a0',3.333,5),(117,5192,5188,'a09',3.333,5),(117,5193,5188,'098',3.333,5),(117,5194,5188,'980',3.333,5),(117,5195,5188,'804',3.333,5),(117,5196,5188,'044',3.333,5),(117,5197,5188,'443',3.333,5),(117,5198,5188,'430',3.333,5),(117,5199,5188,'307',3.333,5),(117,5200,5188,'072',3.333,5),(117,5201,5188,'725',3.333,5),(117,5202,5188,'259',3.333,5),(117,5203,5188,'593',3.333,5),(117,5204,5188,'931',3.333,5),(117,5205,5188,'313',3.333,5),(117,5206,5188,'13f',3.333,5),(117,5207,5188,'3f3',3.333,5),(117,5208,5188,'f33',3.333,5),(117,5209,5188,'334',3.333,5),(117,5210,5188,'345',3.333,5),(117,5211,5188,'455',3.333,5),(117,5212,5188,'556',3.333,5),(117,5213,5188,'563',3.333,5),(117,5214,5188,'639',3.333,5),(117,5215,5188,'393',3.333,5),(117,5216,5188,'934',3.333,5),(117,5217,5188,'344',3.333,5),(117,5218,5188,'44d',3.333,5),(118,5220,5219,'net',25,5),(118,5221,5219,'eta',25,5),(118,5222,5219,'tap',25,5),(118,5223,5219,'app',25,5),(118,5224,5220,'fib',33.333,5),(118,5225,5220,'ibr',33.333,5),(118,5226,5220,'bre',33.333,5),(118,5227,5224,'cha',20,5),(118,5228,5224,'han',20,5),(118,5229,5224,'ann',20,5),(118,5230,5224,'nne',20,5),(118,5231,5224,'nel',20,5),(118,5232,5227,'dis',50,5),(118,5233,5227,'isk',50,5),(118,5234,5232,'naa',100,5),(118,5235,5234,'600',3.333,5),(118,5236,5234,'00a',3.333,5),(118,5237,5234,'0a0',3.333,5),(118,5238,5234,'a09',3.333,5),(118,5239,5234,'098',3.333,5),(118,5240,5234,'980',3.333,5),(118,5241,5234,'804',3.333,5),(118,5242,5234,'044',3.333,5),(118,5243,5234,'443',3.333,5),(118,5244,5234,'430',3.333,5),(118,5245,5234,'307',3.333,5),(118,5246,5234,'072',3.333,5),(118,5247,5234,'725',3.333,5),(118,5248,5234,'259',3.333,5),(118,5249,5234,'593',3.333,5),(118,5250,5234,'931',3.333,5),(118,5251,5234,'313',3.333,5),(118,5252,5234,'13f',3.333,5),(118,5253,5234,'3f3',3.333,5),(118,5254,5234,'f33',3.333,5),(118,5255,5234,'334',3.333,5),(118,5256,5234,'345',3.333,5),(118,5257,5234,'455',3.333,5),(118,5258,5234,'556',3.333,5),(118,5259,5234,'563',3.333,5),(118,5260,5234,'639',3.333,5),(118,5261,5234,'393',3.333,5),(118,5262,5234,'934',3.333,5),(118,5263,5234,'344',3.333,5),(118,5264,5234,'44e',3.333,5),(119,5266,5265,'net',25,5),(119,5267,5265,'eta',25,5),(119,5268,5265,'tap',25,5),(119,5269,5265,'app',25,5),(119,5270,5266,'fib',33.333,5),(119,5271,5266,'ibr',33.333,5),(119,5272,5266,'bre',33.333,5),(119,5273,5270,'cha',20,5),(119,5274,5270,'han',20,5),(119,5275,5270,'ann',20,5),(119,5276,5270,'nne',20,5),(119,5277,5270,'nel',20,5),(119,5278,5273,'dis',50,5),(119,5279,5273,'isk',50,5),(119,5280,5278,'naa',100,5),(119,5281,5280,'600',3.333,5),(119,5282,5280,'00a',3.333,5),(119,5283,5280,'0a0',3.333,5),(119,5284,5280,'a09',3.333,5),(119,5285,5280,'098',3.333,5),(119,5286,5280,'980',3.333,5),(119,5287,5280,'804',3.333,5),(119,5288,5280,'044',3.333,5),(119,5289,5280,'443',3.333,5),(119,5290,5280,'430',3.333,5),(119,5291,5280,'307',3.333,5),(119,5292,5280,'072',3.333,5),(119,5293,5280,'725',3.333,5),(119,5294,5280,'259',3.333,5),(119,5295,5280,'593',3.333,5),(119,5296,5280,'931',3.333,5),(119,5297,5280,'313',3.333,5),(119,5298,5280,'13f',3.333,5),(119,5299,5280,'3f3',3.333,5),(119,5300,5280,'f33',3.333,5),(119,5301,5280,'334',3.333,5),(119,5302,5280,'345',3.333,5),(119,5303,5280,'455',3.333,5),(119,5304,5280,'556',3.333,5),(119,5305,5280,'563',3.333,5),(119,5306,5280,'639',3.333,5),(119,5307,5280,'393',3.333,5),(119,5308,5280,'934',3.333,5),(119,5309,5280,'344',3.333,5),(119,5310,5280,'44f',3.333,5),(120,5312,5311,'net',25,5),(120,5313,5311,'eta',25,5),(120,5314,5311,'tap',25,5),(120,5315,5311,'app',25,5),(120,5316,5312,'fib',33.333,5),(120,5317,5312,'ibr',33.333,5),(120,5318,5312,'bre',33.333,5),(120,5319,5316,'cha',20,5),(120,5320,5316,'han',20,5),(120,5321,5316,'ann',20,5),(120,5322,5316,'nne',20,5),(120,5323,5316,'nel',20,5),(120,5324,5319,'dis',50,5),(120,5325,5319,'isk',50,5),(120,5326,5324,'naa',100,5),(120,5327,5326,'600',3.333,5),(120,5328,5326,'00a',3.333,5),(120,5329,5326,'0a0',3.333,5),(120,5330,5326,'a09',3.333,5),(120,5331,5326,'098',3.333,5),(120,5332,5326,'980',3.333,5),(120,5333,5326,'804',3.333,5),(120,5334,5326,'044',3.333,5),(120,5335,5326,'443',3.333,5),(120,5336,5326,'430',3.333,5),(120,5337,5326,'307',3.333,5),(120,5338,5326,'072',3.333,5),(120,5339,5326,'725',3.333,5),(120,5340,5326,'259',3.333,5),(120,5341,5326,'593',3.333,5),(120,5342,5326,'931',3.333,5),(120,5343,5326,'313',3.333,5),(120,5344,5326,'13f',3.333,5),(120,5345,5326,'3f3',3.333,5),(120,5346,5326,'f33',3.333,5),(120,5347,5326,'334',3.333,5),(120,5348,5326,'345',3.333,5),(120,5349,5326,'455',3.333,5),(120,5350,5326,'556',3.333,5),(120,5351,5326,'563',3.333,5),(120,5352,5326,'638',3.333,5),(120,5353,5326,'387',3.333,5),(120,5354,5326,'872',3.333,5),(120,5355,5326,'724',3.333,5),(120,5356,5326,'24a',3.333,5),(121,5358,5357,'net',25,5),(121,5359,5357,'eta',25,5),(121,5360,5357,'tap',25,5),(121,5361,5357,'app',25,5),(121,5362,5358,'fib',33.333,5),(121,5363,5358,'ibr',33.333,5),(121,5364,5358,'bre',33.333,5),(121,5365,5362,'cha',20,5),(121,5366,5362,'han',20,5),(121,5367,5362,'ann',20,5),(121,5368,5362,'nne',20,5),(121,5369,5362,'nel',20,5),(121,5370,5365,'dis',50,5),(121,5371,5365,'isk',50,5),(121,5372,5370,'naa',100,5),(121,5373,5372,'600',3.333,5),(121,5374,5372,'00a',3.333,5),(121,5375,5372,'0a0',3.333,5),(121,5376,5372,'a09',3.333,5),(121,5377,5372,'098',3.333,5),(121,5378,5372,'980',3.333,5),(121,5379,5372,'804',3.333,5),(121,5380,5372,'044',3.333,5),(121,5381,5372,'443',3.333,5),(121,5382,5372,'430',3.333,5),(121,5383,5372,'307',3.333,5),(121,5384,5372,'072',3.333,5),(121,5385,5372,'725',3.333,5),(121,5386,5372,'259',3.333,5),(121,5387,5372,'593',3.333,5),(121,5388,5372,'931',3.333,5),(121,5389,5372,'313',3.333,5),(121,5390,5372,'13f',3.333,5),(121,5391,5372,'3f3',3.333,5),(121,5392,5372,'f33',3.333,5),(121,5393,5372,'334',3.333,5),(121,5394,5372,'345',3.333,5),(121,5395,5372,'455',3.333,5),(121,5396,5372,'556',3.333,5),(121,5397,5372,'563',3.333,5),(121,5398,5372,'638',3.333,5),(121,5399,5372,'387',3.333,5),(121,5400,5372,'872',3.333,5),(121,5401,5372,'724',3.333,5),(121,5402,5372,'24b',3.333,5),(122,5404,5403,'net',25,5),(122,5405,5403,'eta',25,5),(122,5406,5403,'tap',25,5),(122,5407,5403,'app',25,5),(122,5408,5404,'fib',33.333,5),(122,5409,5404,'ibr',33.333,5),(122,5410,5404,'bre',33.333,5),(122,5411,5408,'cha',20,5),(122,5412,5408,'han',20,5),(122,5413,5408,'ann',20,5),(122,5414,5408,'nne',20,5),(122,5415,5408,'nel',20,5),(122,5416,5411,'dis',50,5),(122,5417,5411,'isk',50,5),(122,5418,5416,'naa',100,5),(122,5419,5418,'600',3.333,5),(122,5420,5418,'00a',3.333,5),(122,5421,5418,'0a0',3.333,5),(122,5422,5418,'a09',3.333,5),(122,5423,5418,'098',3.333,5),(122,5424,5418,'980',3.333,5),(122,5425,5418,'804',3.333,5),(122,5426,5418,'044',3.333,5),(122,5427,5418,'443',3.333,5),(122,5428,5418,'430',3.333,5),(122,5429,5418,'307',3.333,5),(122,5430,5418,'072',3.333,5),(122,5431,5418,'725',3.333,5),(122,5432,5418,'259',3.333,5),(122,5433,5418,'593',3.333,5),(122,5434,5418,'931',3.333,5),(122,5435,5418,'313',3.333,5),(122,5436,5418,'13f',3.333,5),(122,5437,5418,'3f3',3.333,5),(122,5438,5418,'f33',3.333,5),(122,5439,5418,'334',3.333,5),(122,5440,5418,'345',3.333,5),(122,5441,5418,'455',3.333,5),(122,5442,5418,'556',3.333,5),(122,5443,5418,'563',3.333,5),(122,5444,5418,'638',3.333,5),(122,5445,5418,'387',3.333,5),(122,5446,5418,'872',3.333,5),(122,5447,5418,'724',3.333,5),(122,5448,5418,'24c',3.333,5),(123,5450,5449,'net',25,5),(123,5451,5449,'eta',25,5),(123,5452,5449,'tap',25,5),(123,5453,5449,'app',25,5),(123,5454,5450,'fib',33.333,5),(123,5455,5450,'ibr',33.333,5),(123,5456,5450,'bre',33.333,5),(123,5457,5454,'cha',20,5),(123,5458,5454,'han',20,5),(123,5459,5454,'ann',20,5),(123,5460,5454,'nne',20,5),(123,5461,5454,'nel',20,5),(123,5462,5457,'dis',50,5),(123,5463,5457,'isk',50,5),(123,5464,5462,'naa',100,5),(123,5465,5464,'600',3.333,5),(123,5466,5464,'00a',3.333,5),(123,5467,5464,'0a0',3.333,5),(123,5468,5464,'a09',3.333,5),(123,5469,5464,'098',3.333,5),(123,5470,5464,'980',3.333,5),(123,5471,5464,'804',3.333,5),(123,5472,5464,'044',3.333,5),(123,5473,5464,'443',3.333,5),(123,5474,5464,'430',3.333,5),(123,5475,5464,'307',3.333,5),(123,5476,5464,'072',3.333,5),(123,5477,5464,'725',3.333,5),(123,5478,5464,'259',3.333,5),(123,5479,5464,'593',3.333,5),(123,5480,5464,'931',3.333,5),(123,5481,5464,'313',3.333,5),(123,5482,5464,'13f',3.333,5),(123,5483,5464,'3f3',3.333,5),(123,5484,5464,'f33',3.333,5),(123,5485,5464,'334',3.333,5),(123,5486,5464,'345',3.333,5),(123,5487,5464,'455',3.333,5),(123,5488,5464,'556',3.333,5),(123,5489,5464,'563',3.333,5),(123,5490,5464,'638',3.333,5),(123,5491,5464,'387',3.333,5),(123,5492,5464,'872',3.333,5),(123,5493,5464,'724',3.333,5),(123,5494,5464,'24d',3.333,5),(124,5496,5495,'net',25,5),(124,5497,5495,'eta',25,5),(124,5498,5495,'tap',25,5),(124,5499,5495,'app',25,5),(124,5500,5496,'fib',33.333,5),(124,5501,5496,'ibr',33.333,5),(124,5502,5496,'bre',33.333,5),(124,5503,5500,'cha',20,5),(124,5504,5500,'han',20,5),(124,5505,5500,'ann',20,5),(124,5506,5500,'nne',20,5),(124,5507,5500,'nel',20,5),(124,5508,5503,'dis',50,5),(124,5509,5503,'isk',50,5),(124,5510,5508,'naa',100,5),(124,5511,5510,'600',3.333,5),(124,5512,5510,'00a',3.333,5),(124,5513,5510,'0a0',3.333,5),(124,5514,5510,'a09',3.333,5),(124,5515,5510,'098',3.333,5),(124,5516,5510,'980',3.333,5),(124,5517,5510,'804',3.333,5),(124,5518,5510,'044',3.333,5),(124,5519,5510,'443',3.333,5),(124,5520,5510,'430',3.333,5),(124,5521,5510,'307',3.333,5),(124,5522,5510,'072',3.333,5),(124,5523,5510,'725',3.333,5),(124,5524,5510,'259',3.333,5),(124,5525,5510,'593',3.333,5),(124,5526,5510,'931',3.333,5),(124,5527,5510,'313',3.333,5),(124,5528,5510,'13f',3.333,5),(124,5529,5510,'3f3',3.333,5),(124,5530,5510,'f33',3.333,5),(124,5531,5510,'334',3.333,5),(124,5532,5510,'345',3.333,5),(124,5533,5510,'455',3.333,5),(124,5534,5510,'556',3.333,5),(124,5535,5510,'563',3.333,5),(124,5536,5510,'638',3.333,5),(124,5537,5510,'387',3.333,5),(124,5538,5510,'872',3.333,5),(124,5539,5510,'724',3.333,5),(124,5540,5510,'24e',3.333,5),(125,5542,5541,'net',25,5),(125,5543,5541,'eta',25,5),(125,5544,5541,'tap',25,5),(125,5545,5541,'app',25,5),(125,5546,5542,'fib',33.333,5),(125,5547,5542,'ibr',33.333,5),(125,5548,5542,'bre',33.333,5),(125,5549,5546,'cha',20,5),(125,5550,5546,'han',20,5),(125,5551,5546,'ann',20,5),(125,5552,5546,'nne',20,5),(125,5553,5546,'nel',20,5),(125,5554,5549,'dis',50,5),(125,5555,5549,'isk',50,5),(125,5556,5554,'naa',100,5),(125,5557,5556,'600',3.333,5),(125,5558,5556,'00a',3.333,5),(125,5559,5556,'0a0',3.333,5),(125,5560,5556,'a09',3.333,5),(125,5561,5556,'098',3.333,5),(125,5562,5556,'980',3.333,5),(125,5563,5556,'804',3.333,5),(125,5564,5556,'044',3.333,5),(125,5565,5556,'443',3.333,5),(125,5566,5556,'430',3.333,5),(125,5567,5556,'307',3.333,5),(125,5568,5556,'072',3.333,5),(125,5569,5556,'725',3.333,5),(125,5570,5556,'259',3.333,5),(125,5571,5556,'593',3.333,5),(125,5572,5556,'931',3.333,5),(125,5573,5556,'313',3.333,5),(125,5574,5556,'13f',3.333,5),(125,5575,5556,'3f3',3.333,5),(125,5576,5556,'f33',3.333,5),(125,5577,5556,'334',3.333,5),(125,5578,5556,'345',3.333,5),(125,5579,5556,'455',3.333,5),(125,5580,5556,'556',3.333,5),(125,5581,5556,'563',3.333,5),(125,5582,5556,'638',3.333,5),(125,5583,5556,'387',3.333,5),(125,5584,5556,'872',3.333,5),(125,5585,5556,'724',3.333,5),(125,5586,5556,'24f',3.333,5),(126,5588,5587,'net',25,5),(126,5589,5587,'eta',25,5),(126,5590,5587,'tap',25,5),(126,5591,5587,'app',25,5),(126,5592,5588,'fib',33.333,5),(126,5593,5588,'ibr',33.333,5),(126,5594,5588,'bre',33.333,5),(126,5595,5592,'cha',20,5),(126,5596,5592,'han',20,5),(126,5597,5592,'ann',20,5),(126,5598,5592,'nne',20,5),(126,5599,5592,'nel',20,5),(126,5600,5595,'dis',50,5),(126,5601,5595,'isk',50,5),(126,5602,5600,'naa',100,5),(126,5603,5602,'600',3.333,5),(126,5604,5602,'00a',3.333,5),(126,5605,5602,'0a0',3.333,5),(126,5606,5602,'a09',3.333,5),(126,5607,5602,'098',3.333,5),(126,5608,5602,'980',3.333,5),(126,5609,5602,'804',3.333,5),(126,5610,5602,'044',3.333,5),(126,5611,5602,'443',3.333,5),(126,5612,5602,'430',3.333,5),(126,5613,5602,'307',3.333,5),(126,5614,5602,'075',3.333,5),(126,5615,5602,'753',3.333,5),(126,5616,5602,'535',3.333,5),(126,5617,5602,'357',3.333,5),(126,5618,5602,'573',3.333,5),(126,5619,5602,'732',3.333,5),(126,5620,5602,'32b',3.333,5),(126,5621,5602,'2b3',3.333,5),(126,5622,5602,'b33',3.333,5),(126,5623,5602,'334',3.333,5),(126,5624,5602,'345',3.333,5),(126,5625,5602,'457',3.333,5),(126,5626,5602,'571',3.333,5),(126,5627,5602,'715',3.333,5),(126,5628,5602,'153',3.333,5),(126,5629,5602,'533',3.333,5),(126,5630,5602,'335',3.333,5),(126,5631,5602,'357',3.333,5),(126,5632,5602,'570',3.333,5),(127,5634,5633,'net',25,5),(127,5635,5633,'eta',25,5),(127,5636,5633,'tap',25,5),(127,5637,5633,'app',25,5),(127,5638,5634,'fib',33.333,5),(127,5639,5634,'ibr',33.333,5),(127,5640,5634,'bre',33.333,5),(127,5641,5638,'cha',20,5),(127,5642,5638,'han',20,5),(127,5643,5638,'ann',20,5),(127,5644,5638,'nne',20,5),(127,5645,5638,'nel',20,5),(127,5646,5641,'dis',50,5),(127,5647,5641,'isk',50,5),(127,5648,5646,'naa',100,5),(127,5649,5648,'600',3.333,5),(127,5650,5648,'00a',3.333,5),(127,5651,5648,'0a0',3.333,5),(127,5652,5648,'a09',3.333,5),(127,5653,5648,'098',3.333,5),(127,5654,5648,'980',3.333,5),(127,5655,5648,'804',3.333,5),(127,5656,5648,'044',3.333,5),(127,5657,5648,'443',3.333,5),(127,5658,5648,'430',3.333,5),(127,5659,5648,'307',3.333,5),(127,5660,5648,'075',3.333,5),(127,5661,5648,'753',3.333,5),(127,5662,5648,'535',3.333,5),(127,5663,5648,'357',3.333,5),(127,5664,5648,'573',3.333,5),(127,5665,5648,'732',3.333,5),(127,5666,5648,'32b',3.333,5),(127,5667,5648,'2b3',3.333,5),(127,5668,5648,'b33',3.333,5),(127,5669,5648,'334',3.333,5),(127,5670,5648,'345',3.333,5),(127,5671,5648,'457',3.333,5),(127,5672,5648,'571',3.333,5),(127,5673,5648,'715',3.333,5),(127,5674,5648,'153',3.333,5),(127,5675,5648,'533',3.333,5),(127,5676,5648,'335',3.333,5),(127,5677,5648,'357',3.333,5),(127,5678,5648,'571',3.333,5),(128,5680,5679,'net',25,5),(128,5681,5679,'eta',25,5),(128,5682,5679,'tap',25,5),(128,5683,5679,'app',25,5),(128,5684,5680,'fib',33.333,5),(128,5685,5680,'ibr',33.333,5),(128,5686,5680,'bre',33.333,5),(128,5687,5684,'cha',20,5),(128,5688,5684,'han',20,5),(128,5689,5684,'ann',20,5),(128,5690,5684,'nne',20,5),(128,5691,5684,'nel',20,5),(128,5692,5687,'dis',50,5),(128,5693,5687,'isk',50,5),(128,5694,5692,'naa',100,5),(128,5695,5694,'600',3.333,5),(128,5696,5694,'00a',3.333,5),(128,5697,5694,'0a0',3.333,5),(128,5698,5694,'a09',3.333,5),(128,5699,5694,'098',3.333,5),(128,5700,5694,'980',3.333,5),(128,5701,5694,'804',3.333,5),(128,5702,5694,'044',3.333,5),(128,5703,5694,'443',3.333,5),(128,5704,5694,'430',3.333,5),(128,5705,5694,'307',3.333,5),(128,5706,5694,'075',3.333,5),(128,5707,5694,'753',3.333,5),(128,5708,5694,'535',3.333,5),(128,5709,5694,'357',3.333,5),(128,5710,5694,'573',3.333,5),(128,5711,5694,'732',3.333,5),(128,5712,5694,'32b',3.333,5),(128,5713,5694,'2b3',3.333,5),(128,5714,5694,'b33',3.333,5),(128,5715,5694,'334',3.333,5),(128,5716,5694,'345',3.333,5),(128,5717,5694,'457',3.333,5),(128,5718,5694,'571',3.333,5),(128,5719,5694,'715',3.333,5),(128,5720,5694,'153',3.333,5),(128,5721,5694,'533',3.333,5),(128,5722,5694,'335',3.333,5),(128,5723,5694,'357',3.333,5),(128,5724,5694,'572',3.333,5),(129,5726,5725,'net',25,5),(129,5727,5725,'eta',25,5),(129,5728,5725,'tap',25,5),(129,5729,5725,'app',25,5),(129,5730,5726,'fib',33.333,5),(129,5731,5726,'ibr',33.333,5),(129,5732,5726,'bre',33.333,5),(129,5733,5730,'cha',20,5),(129,5734,5730,'han',20,5),(129,5735,5730,'ann',20,5),(129,5736,5730,'nne',20,5),(129,5737,5730,'nel',20,5),(129,5738,5733,'dis',50,5),(129,5739,5733,'isk',50,5),(129,5740,5738,'naa',100,5),(129,5741,5740,'600',3.333,5),(129,5742,5740,'00a',3.333,5),(129,5743,5740,'0a0',3.333,5),(129,5744,5740,'a09',3.333,5),(129,5745,5740,'098',3.333,5),(129,5746,5740,'980',3.333,5),(129,5747,5740,'804',3.333,5),(129,5748,5740,'044',3.333,5),(129,5749,5740,'443',3.333,5),(129,5750,5740,'430',3.333,5),(129,5751,5740,'307',3.333,5),(129,5752,5740,'075',3.333,5),(129,5753,5740,'753',3.333,5),(129,5754,5740,'535',3.333,5),(129,5755,5740,'357',3.333,5),(129,5756,5740,'573',3.333,5),(129,5757,5740,'732',3.333,5),(129,5758,5740,'32b',3.333,5),(129,5759,5740,'2b3',3.333,5),(129,5760,5740,'b33',3.333,5),(129,5761,5740,'334',3.333,5),(129,5762,5740,'345',3.333,5),(129,5763,5740,'457',3.333,5),(129,5764,5740,'571',3.333,5),(129,5765,5740,'715',3.333,5),(129,5766,5740,'153',3.333,5),(129,5767,5740,'533',3.333,5),(129,5768,5740,'336',3.333,5),(129,5769,5740,'365',3.333,5),(129,5770,5740,'650',3.333,5),(130,5772,5771,'net',25,5),(130,5773,5771,'eta',25,5),(130,5774,5771,'tap',25,5),(130,5775,5771,'app',25,5),(130,5776,5772,'fib',33.333,5),(130,5777,5772,'ibr',33.333,5),(130,5778,5772,'bre',33.333,5),(130,5779,5776,'cha',20,5),(130,5780,5776,'han',20,5),(130,5781,5776,'ann',20,5),(130,5782,5776,'nne',20,5),(130,5783,5776,'nel',20,5),(130,5784,5779,'dis',50,5),(130,5785,5779,'isk',50,5),(130,5786,5784,'naa',100,5),(130,5787,5786,'600',3.333,5),(130,5788,5786,'00a',3.333,5),(130,5789,5786,'0a0',3.333,5),(130,5790,5786,'a09',3.333,5),(130,5791,5786,'098',3.333,5),(130,5792,5786,'980',3.333,5),(130,5793,5786,'804',3.333,5),(130,5794,5786,'044',3.333,5),(130,5795,5786,'443',3.333,5),(130,5796,5786,'430',3.333,5),(130,5797,5786,'307',3.333,5),(130,5798,5786,'075',3.333,5),(130,5799,5786,'753',3.333,5),(130,5800,5786,'535',3.333,5),(130,5801,5786,'357',3.333,5),(130,5802,5786,'573',3.333,5),(130,5803,5786,'732',3.333,5),(130,5804,5786,'32b',3.333,5),(130,5805,5786,'2b3',3.333,5),(130,5806,5786,'b33',3.333,5),(130,5807,5786,'334',3.333,5),(130,5808,5786,'345',3.333,5),(130,5809,5786,'457',3.333,5),(130,5810,5786,'571',3.333,5),(130,5811,5786,'715',3.333,5),(130,5812,5786,'153',3.333,5),(130,5813,5786,'533',3.333,5),(130,5814,5786,'335',3.333,5),(130,5815,5786,'357',3.333,5),(130,5816,5786,'573',3.333,5),(131,5818,5817,'net',25,5),(131,5819,5817,'eta',25,5),(131,5820,5817,'tap',25,5),(131,5821,5817,'app',25,5),(131,5822,5818,'fib',33.333,5),(131,5823,5818,'ibr',33.333,5),(131,5824,5818,'bre',33.333,5),(131,5825,5822,'cha',20,5),(131,5826,5822,'han',20,5),(131,5827,5822,'ann',20,5),(131,5828,5822,'nne',20,5),(131,5829,5822,'nel',20,5),(131,5830,5825,'dis',50,5),(131,5831,5825,'isk',50,5),(131,5832,5830,'naa',100,5),(131,5833,5832,'600',3.333,5),(131,5834,5832,'00a',3.333,5),(131,5835,5832,'0a0',3.333,5),(131,5836,5832,'a09',3.333,5),(131,5837,5832,'098',3.333,5),(131,5838,5832,'980',3.333,5),(131,5839,5832,'804',3.333,5),(131,5840,5832,'044',3.333,5),(131,5841,5832,'443',3.333,5),(131,5842,5832,'430',3.333,5),(131,5843,5832,'307',3.333,5),(131,5844,5832,'075',3.333,5),(131,5845,5832,'753',3.333,5),(131,5846,5832,'535',3.333,5),(131,5847,5832,'357',3.333,5),(131,5848,5832,'573',3.333,5),(131,5849,5832,'732',3.333,5),(131,5850,5832,'32b',3.333,5),(131,5851,5832,'2b3',3.333,5),(131,5852,5832,'b33',3.333,5),(131,5853,5832,'334',3.333,5),(131,5854,5832,'345',3.333,5),(131,5855,5832,'457',3.333,5),(131,5856,5832,'571',3.333,5),(131,5857,5832,'715',3.333,5),(131,5858,5832,'153',3.333,5),(131,5859,5832,'533',3.333,5),(131,5860,5832,'336',3.333,5),(131,5861,5832,'365',3.333,5),(131,5862,5832,'651',3.333,5),(132,5864,5863,'net',25,5),(132,5865,5863,'eta',25,5),(132,5866,5863,'tap',25,5),(132,5867,5863,'app',25,5),(132,5868,5864,'fib',33.333,5),(132,5869,5864,'ibr',33.333,5),(132,5870,5864,'bre',33.333,5),(132,5871,5868,'cha',20,5),(132,5872,5868,'han',20,5),(132,5873,5868,'ann',20,5),(132,5874,5868,'nne',20,5),(132,5875,5868,'nel',20,5),(132,5876,5871,'dis',50,5),(132,5877,5871,'isk',50,5),(132,5878,5876,'naa',100,5),(132,5879,5878,'600',3.333,5),(132,5880,5878,'00a',3.333,5),(132,5881,5878,'0a0',3.333,5),(132,5882,5878,'a09',3.333,5),(132,5883,5878,'098',3.333,5),(132,5884,5878,'980',3.333,5),(132,5885,5878,'804',3.333,5),(132,5886,5878,'044',3.333,5),(132,5887,5878,'443',3.333,5),(132,5888,5878,'430',3.333,5),(132,5889,5878,'307',3.333,5),(132,5890,5878,'075',3.333,5),(132,5891,5878,'753',3.333,5),(132,5892,5878,'535',3.333,5),(132,5893,5878,'357',3.333,5),(132,5894,5878,'573',3.333,5),(132,5895,5878,'732',3.333,5),(132,5896,5878,'32b',3.333,5),(132,5897,5878,'2b3',3.333,5),(132,5898,5878,'b33',3.333,5),(132,5899,5878,'334',3.333,5),(132,5900,5878,'345',3.333,5),(132,5901,5878,'457',3.333,5),(132,5902,5878,'571',3.333,5),(132,5903,5878,'715',3.333,5),(132,5904,5878,'153',3.333,5),(132,5905,5878,'533',3.333,5),(132,5906,5878,'335',3.333,5),(132,5907,5878,'357',3.333,5),(132,5908,5878,'574',3.333,5),(133,5910,5909,'net',25,5),(133,5911,5909,'eta',25,5),(133,5912,5909,'tap',25,5),(133,5913,5909,'app',25,5),(133,5914,5910,'fib',33.333,5),(133,5915,5910,'ibr',33.333,5),(133,5916,5910,'bre',33.333,5),(133,5917,5914,'cha',20,5),(133,5918,5914,'han',20,5),(133,5919,5914,'ann',20,5),(133,5920,5914,'nne',20,5),(133,5921,5914,'nel',20,5),(133,5922,5917,'dis',50,5),(133,5923,5917,'isk',50,5),(133,5924,5922,'naa',100,5),(133,5925,5924,'600',3.333,5),(133,5926,5924,'00a',3.333,5),(133,5927,5924,'0a0',3.333,5),(133,5928,5924,'a09',3.333,5),(133,5929,5924,'098',3.333,5),(133,5930,5924,'980',3.333,5),(133,5931,5924,'804',3.333,5),(133,5932,5924,'044',3.333,5),(133,5933,5924,'443',3.333,5),(133,5934,5924,'430',3.333,5),(133,5935,5924,'307',3.333,5),(133,5936,5924,'075',3.333,5),(133,5937,5924,'753',3.333,5),(133,5938,5924,'535',3.333,5),(133,5939,5924,'357',3.333,5),(133,5940,5924,'573',3.333,5),(133,5941,5924,'732',3.333,5),(133,5942,5924,'32b',3.333,5),(133,5943,5924,'2b3',3.333,5),(133,5944,5924,'b33',3.333,5),(133,5945,5924,'334',3.333,5),(133,5946,5924,'345',3.333,5),(133,5947,5924,'457',3.333,5),(133,5948,5924,'571',3.333,5),(133,5949,5924,'715',3.333,5),(133,5950,5924,'153',3.333,5),(133,5951,5924,'533',3.333,5),(133,5952,5924,'336',3.333,5),(133,5953,5924,'365',3.333,5),(133,5954,5924,'652',3.333,5),(134,5956,5955,'net',25,5),(134,5957,5955,'eta',25,5),(134,5958,5955,'tap',25,5),(134,5959,5955,'app',25,5),(134,5960,5956,'fib',33.333,5),(134,5961,5956,'ibr',33.333,5),(134,5962,5956,'bre',33.333,5),(134,5963,5960,'cha',20,5),(134,5964,5960,'han',20,5),(134,5965,5960,'ann',20,5),(134,5966,5960,'nne',20,5),(134,5967,5960,'nel',20,5),(134,5968,5963,'dis',50,5),(134,5969,5963,'isk',50,5),(134,5970,5968,'naa',100,5),(134,5971,5970,'600',3.333,5),(134,5972,5970,'00a',3.333,5),(134,5973,5970,'0a0',3.333,5),(134,5974,5970,'a09',3.333,5),(134,5975,5970,'098',3.333,5),(134,5976,5970,'980',3.333,5),(134,5977,5970,'804',3.333,5),(134,5978,5970,'044',3.333,5),(134,5979,5970,'443',3.333,5),(134,5980,5970,'430',3.333,5),(134,5981,5970,'307',3.333,5),(134,5982,5970,'075',3.333,5),(134,5983,5970,'753',3.333,5),(134,5984,5970,'535',3.333,5),(134,5985,5970,'357',3.333,5),(134,5986,5970,'573',3.333,5),(134,5987,5970,'732',3.333,5),(134,5988,5970,'32b',3.333,5),(134,5989,5970,'2b3',3.333,5),(134,5990,5970,'b33',3.333,5),(134,5991,5970,'334',3.333,5),(134,5992,5970,'345',3.333,5),(134,5993,5970,'457',3.333,5),(134,5994,5970,'571',3.333,5),(134,5995,5970,'715',3.333,5),(134,5996,5970,'153',3.333,5),(134,5997,5970,'533',3.333,5),(134,5998,5970,'335',3.333,5),(134,5999,5970,'357',3.333,5),(134,6000,5970,'575',3.333,5),(135,6002,6001,'net',25,5),(135,6003,6001,'eta',25,5),(135,6004,6001,'tap',25,5),(135,6005,6001,'app',25,5),(135,6006,6002,'fib',33.333,5),(135,6007,6002,'ibr',33.333,5),(135,6008,6002,'bre',33.333,5),(135,6009,6006,'cha',20,5),(135,6010,6006,'han',20,5),(135,6011,6006,'ann',20,5),(135,6012,6006,'nne',20,5),(135,6013,6006,'nel',20,5),(135,6014,6009,'dis',50,5),(135,6015,6009,'isk',50,5),(135,6016,6014,'naa',100,5),(135,6017,6016,'600',3.333,5),(135,6018,6016,'00a',3.333,5),(135,6019,6016,'0a0',3.333,5),(135,6020,6016,'a09',3.333,5),(135,6021,6016,'098',3.333,5),(135,6022,6016,'980',3.333,5),(135,6023,6016,'804',3.333,5),(135,6024,6016,'044',3.333,5),(135,6025,6016,'443',3.333,5),(135,6026,6016,'430',3.333,5),(135,6027,6016,'307',3.333,5),(135,6028,6016,'075',3.333,5),(135,6029,6016,'753',3.333,5),(135,6030,6016,'535',3.333,5),(135,6031,6016,'357',3.333,5),(135,6032,6016,'573',3.333,5),(135,6033,6016,'732',3.333,5),(135,6034,6016,'32b',3.333,5),(135,6035,6016,'2b3',3.333,5),(135,6036,6016,'b33',3.333,5),(135,6037,6016,'334',3.333,5),(135,6038,6016,'345',3.333,5),(135,6039,6016,'457',3.333,5),(135,6040,6016,'571',3.333,5),(135,6041,6016,'715',3.333,5),(135,6042,6016,'153',3.333,5),(135,6043,6016,'533',3.333,5),(135,6044,6016,'336',3.333,5),(135,6045,6016,'365',3.333,5),(135,6046,6016,'653',3.333,5),(136,6048,6047,'net',25,5),(136,6049,6047,'eta',25,5),(136,6050,6047,'tap',25,5),(136,6051,6047,'app',25,5),(136,6052,6048,'fib',33.333,5),(136,6053,6048,'ibr',33.333,5),(136,6054,6048,'bre',33.333,5),(136,6055,6052,'cha',20,5),(136,6056,6052,'han',20,5),(136,6057,6052,'ann',20,5),(136,6058,6052,'nne',20,5),(136,6059,6052,'nel',20,5),(136,6060,6055,'dis',50,5),(136,6061,6055,'isk',50,5),(136,6062,6060,'naa',100,5),(136,6063,6062,'600',3.333,5),(136,6064,6062,'00a',3.333,5),(136,6065,6062,'0a0',3.333,5),(136,6066,6062,'a09',3.333,5),(136,6067,6062,'098',3.333,5),(136,6068,6062,'980',3.333,5),(136,6069,6062,'804',3.333,5),(136,6070,6062,'044',3.333,5),(136,6071,6062,'443',3.333,5),(136,6072,6062,'430',3.333,5),(136,6073,6062,'307',3.333,5),(136,6074,6062,'075',3.333,5),(136,6075,6062,'753',3.333,5),(136,6076,6062,'535',3.333,5),(136,6077,6062,'357',3.333,5),(136,6078,6062,'573',3.333,5),(136,6079,6062,'732',3.333,5),(136,6080,6062,'32b',3.333,5),(136,6081,6062,'2b3',3.333,5),(136,6082,6062,'b33',3.333,5),(136,6083,6062,'334',3.333,5),(136,6084,6062,'345',3.333,5),(136,6085,6062,'457',3.333,5),(136,6086,6062,'571',3.333,5),(136,6087,6062,'715',3.333,5),(136,6088,6062,'153',3.333,5),(136,6089,6062,'533',3.333,5),(136,6090,6062,'335',3.333,5),(136,6091,6062,'357',3.333,5),(136,6092,6062,'576',3.333,5),(137,6094,6093,'net',25,5),(137,6095,6093,'eta',25,5),(137,6096,6093,'tap',25,5),(137,6097,6093,'app',25,5),(137,6098,6094,'fib',33.333,5),(137,6099,6094,'ibr',33.333,5),(137,6100,6094,'bre',33.333,5),(137,6101,6098,'cha',20,5),(137,6102,6098,'han',20,5),(137,6103,6098,'ann',20,5),(137,6104,6098,'nne',20,5),(137,6105,6098,'nel',20,5),(137,6106,6101,'dis',50,5),(137,6107,6101,'isk',50,5),(137,6108,6106,'naa',100,5),(137,6109,6108,'600',3.333,5),(137,6110,6108,'00a',3.333,5),(137,6111,6108,'0a0',3.333,5),(137,6112,6108,'a09',3.333,5),(137,6113,6108,'098',3.333,5),(137,6114,6108,'980',3.333,5),(137,6115,6108,'804',3.333,5),(137,6116,6108,'044',3.333,5),(137,6117,6108,'443',3.333,5),(137,6118,6108,'430',3.333,5),(137,6119,6108,'307',3.333,5),(137,6120,6108,'075',3.333,5),(137,6121,6108,'753',3.333,5),(137,6122,6108,'535',3.333,5),(137,6123,6108,'357',3.333,5),(137,6124,6108,'573',3.333,5),(137,6125,6108,'732',3.333,5),(137,6126,6108,'32b',3.333,5),(137,6127,6108,'2b3',3.333,5),(137,6128,6108,'b33',3.333,5),(137,6129,6108,'334',3.333,5),(137,6130,6108,'345',3.333,5),(137,6131,6108,'457',3.333,5),(137,6132,6108,'571',3.333,5),(137,6133,6108,'715',3.333,5),(137,6134,6108,'153',3.333,5),(137,6135,6108,'533',3.333,5),(137,6136,6108,'335',3.333,5),(137,6137,6108,'357',3.333,5),(137,6138,6108,'577',3.333,5),(138,6140,6139,'net',25,5),(138,6141,6139,'eta',25,5),(138,6142,6139,'tap',25,5),(138,6143,6139,'app',25,5),(138,6144,6140,'fib',33.333,5),(138,6145,6140,'ibr',33.333,5),(138,6146,6140,'bre',33.333,5),(138,6147,6144,'cha',20,5),(138,6148,6144,'han',20,5),(138,6149,6144,'ann',20,5),(138,6150,6144,'nne',20,5),(138,6151,6144,'nel',20,5),(138,6152,6147,'dis',50,5),(138,6153,6147,'isk',50,5),(138,6154,6152,'naa',100,5),(138,6155,6154,'600',3.333,5),(138,6156,6154,'00a',3.333,5),(138,6157,6154,'0a0',3.333,5),(138,6158,6154,'a09',3.333,5),(138,6159,6154,'098',3.333,5),(138,6160,6154,'980',3.333,5),(138,6161,6154,'804',3.333,5),(138,6162,6154,'044',3.333,5),(138,6163,6154,'443',3.333,5),(138,6164,6154,'430',3.333,5),(138,6165,6154,'307',3.333,5),(138,6166,6154,'075',3.333,5),(138,6167,6154,'753',3.333,5),(138,6168,6154,'535',3.333,5),(138,6169,6154,'357',3.333,5),(138,6170,6154,'573',3.333,5),(138,6171,6154,'732',3.333,5),(138,6172,6154,'32b',3.333,5),(138,6173,6154,'2b3',3.333,5),(138,6174,6154,'b33',3.333,5),(138,6175,6154,'334',3.333,5),(138,6176,6154,'345',3.333,5),(138,6177,6154,'457',3.333,5),(138,6178,6154,'571',3.333,5),(138,6179,6154,'715',3.333,5),(138,6180,6154,'153',3.333,5),(138,6181,6154,'533',3.333,5),(138,6182,6154,'336',3.333,5),(138,6183,6154,'365',3.333,5),(138,6184,6154,'654',3.333,5),(139,6186,6185,'net',25,5),(139,6187,6185,'eta',25,5),(139,6188,6185,'tap',25,5),(139,6189,6185,'app',25,5),(139,6190,6186,'fib',33.333,5),(139,6191,6186,'ibr',33.333,5),(139,6192,6186,'bre',33.333,5),(139,6193,6190,'cha',20,5),(139,6194,6190,'han',20,5),(139,6195,6190,'ann',20,5),(139,6196,6190,'nne',20,5),(139,6197,6190,'nel',20,5),(139,6198,6193,'dis',50,5),(139,6199,6193,'isk',50,5),(139,6200,6198,'naa',100,5),(139,6201,6200,'600',3.333,5),(139,6202,6200,'00a',3.333,5),(139,6203,6200,'0a0',3.333,5),(139,6204,6200,'a09',3.333,5),(139,6205,6200,'098',3.333,5),(139,6206,6200,'980',3.333,5),(139,6207,6200,'804',3.333,5),(139,6208,6200,'044',3.333,5),(139,6209,6200,'443',3.333,5),(139,6210,6200,'430',3.333,5),(139,6211,6200,'307',3.333,5),(139,6212,6200,'075',3.333,5),(139,6213,6200,'753',3.333,5),(139,6214,6200,'535',3.333,5),(139,6215,6200,'357',3.333,5),(139,6216,6200,'573',3.333,5),(139,6217,6200,'732',3.333,5),(139,6218,6200,'32b',3.333,5),(139,6219,6200,'2b3',3.333,5),(139,6220,6200,'b33',3.333,5),(139,6221,6200,'334',3.333,5),(139,6222,6200,'345',3.333,5),(139,6223,6200,'457',3.333,5),(139,6224,6200,'571',3.333,5),(139,6225,6200,'715',3.333,5),(139,6226,6200,'153',3.333,5),(139,6227,6200,'533',3.333,5),(139,6228,6200,'335',3.333,5),(139,6229,6200,'357',3.333,5),(139,6230,6200,'578',3.333,5),(140,6232,6231,'net',25,5),(140,6233,6231,'eta',25,5),(140,6234,6231,'tap',25,5),(140,6235,6231,'app',25,5),(140,6236,6232,'fib',33.333,5),(140,6237,6232,'ibr',33.333,5),(140,6238,6232,'bre',33.333,5),(140,6239,6236,'cha',20,5),(140,6240,6236,'han',20,5),(140,6241,6236,'ann',20,5),(140,6242,6236,'nne',20,5),(140,6243,6236,'nel',20,5),(140,6244,6239,'dis',50,5),(140,6245,6239,'isk',50,5),(140,6246,6244,'naa',100,5),(140,6247,6246,'600',3.333,5),(140,6248,6246,'00a',3.333,5),(140,6249,6246,'0a0',3.333,5),(140,6250,6246,'a09',3.333,5),(140,6251,6246,'098',3.333,5),(140,6252,6246,'980',3.333,5),(140,6253,6246,'804',3.333,5),(140,6254,6246,'044',3.333,5),(140,6255,6246,'443',3.333,5),(140,6256,6246,'430',3.333,5),(140,6257,6246,'307',3.333,5),(140,6258,6246,'075',3.333,5),(140,6259,6246,'753',3.333,5),(140,6260,6246,'535',3.333,5),(140,6261,6246,'357',3.333,5),(140,6262,6246,'573',3.333,5),(140,6263,6246,'732',3.333,5),(140,6264,6246,'32b',3.333,5),(140,6265,6246,'2b3',3.333,5),(140,6266,6246,'b33',3.333,5),(140,6267,6246,'334',3.333,5),(140,6268,6246,'345',3.333,5),(140,6269,6246,'457',3.333,5),(140,6270,6246,'571',3.333,5),(140,6271,6246,'715',3.333,5),(140,6272,6246,'153',3.333,5),(140,6273,6246,'533',3.333,5),(140,6274,6246,'336',3.333,5),(140,6275,6246,'365',3.333,5),(140,6276,6246,'655',3.333,5),(141,6278,6277,'net',25,5),(141,6279,6277,'eta',25,5),(141,6280,6277,'tap',25,5),(141,6281,6277,'app',25,5),(141,6282,6278,'fib',33.333,5),(141,6283,6278,'ibr',33.333,5),(141,6284,6278,'bre',33.333,5),(141,6285,6282,'cha',20,5),(141,6286,6282,'han',20,5),(141,6287,6282,'ann',20,5),(141,6288,6282,'nne',20,5),(141,6289,6282,'nel',20,5),(141,6290,6285,'dis',50,5),(141,6291,6285,'isk',50,5),(141,6292,6290,'naa',100,5),(141,6293,6292,'600',3.333,5),(141,6294,6292,'00a',3.333,5),(141,6295,6292,'0a0',3.333,5),(141,6296,6292,'a09',3.333,5),(141,6297,6292,'098',3.333,5),(141,6298,6292,'980',3.333,5),(141,6299,6292,'804',3.333,5),(141,6300,6292,'044',3.333,5),(141,6301,6292,'443',3.333,5),(141,6302,6292,'430',3.333,5),(141,6303,6292,'307',3.333,5),(141,6304,6292,'075',3.333,5),(141,6305,6292,'753',3.333,5),(141,6306,6292,'535',3.333,5),(141,6307,6292,'357',3.333,5),(141,6308,6292,'573',3.333,5),(141,6309,6292,'732',3.333,5),(141,6310,6292,'32b',3.333,5),(141,6311,6292,'2b3',3.333,5),(141,6312,6292,'b33',3.333,5),(141,6313,6292,'334',3.333,5),(141,6314,6292,'345',3.333,5),(141,6315,6292,'457',3.333,5),(141,6316,6292,'571',3.333,5),(141,6317,6292,'715',3.333,5),(141,6318,6292,'153',3.333,5),(141,6319,6292,'533',3.333,5),(141,6320,6292,'335',3.333,5),(141,6321,6292,'357',3.333,5),(141,6322,6292,'579',3.333,5),(142,6324,6323,'net',25,5),(142,6325,6323,'eta',25,5),(142,6326,6323,'tap',25,5),(142,6327,6323,'app',25,5),(142,6328,6324,'fib',33.333,5),(142,6329,6324,'ibr',33.333,5),(142,6330,6324,'bre',33.333,5),(142,6331,6328,'cha',20,5),(142,6332,6328,'han',20,5),(142,6333,6328,'ann',20,5),(142,6334,6328,'nne',20,5),(142,6335,6328,'nel',20,5),(142,6336,6331,'dis',50,5),(142,6337,6331,'isk',50,5),(142,6338,6336,'naa',100,5),(142,6339,6338,'600',3.333,5),(142,6340,6338,'00a',3.333,5),(142,6341,6338,'0a0',3.333,5),(142,6342,6338,'a09',3.333,5),(142,6343,6338,'098',3.333,5),(142,6344,6338,'980',3.333,5),(142,6345,6338,'804',3.333,5),(142,6346,6338,'044',3.333,5),(142,6347,6338,'443',3.333,5),(142,6348,6338,'430',3.333,5),(142,6349,6338,'307',3.333,5),(142,6350,6338,'075',3.333,5),(142,6351,6338,'753',3.333,5),(142,6352,6338,'535',3.333,5),(142,6353,6338,'357',3.333,5),(142,6354,6338,'573',3.333,5),(142,6355,6338,'732',3.333,5),(142,6356,6338,'32b',3.333,5),(142,6357,6338,'2b3',3.333,5),(142,6358,6338,'b33',3.333,5),(142,6359,6338,'334',3.333,5),(142,6360,6338,'345',3.333,5),(142,6361,6338,'457',3.333,5),(142,6362,6338,'571',3.333,5),(142,6363,6338,'715',3.333,5),(142,6364,6338,'153',3.333,5),(142,6365,6338,'533',3.333,5),(142,6366,6338,'336',3.333,5),(142,6367,6338,'365',3.333,5),(142,6368,6338,'656',3.333,5),(143,6370,6369,'net',25,5),(143,6371,6369,'eta',25,5),(143,6372,6369,'tap',25,5),(143,6373,6369,'app',25,5),(143,6374,6370,'ser',25,5),(143,6375,6370,'eri',25,5),(143,6376,6370,'ria',25,5),(143,6377,6370,'ial',25,5),(143,6378,6374,'att',16.667,5),(143,6379,6374,'tta',16.667,5),(143,6380,6374,'tac',16.667,5),(143,6381,6374,'ach',16.667,5),(143,6382,6374,'che',16.667,5),(143,6383,6374,'hed',16.667,5),(143,6384,6378,'scs',50,5),(143,6385,6378,'csi',50,5),(143,6386,6384,'dis',50,5),(143,6387,6384,'isk',50,5),(143,6388,6386,'naa',100,5),(143,6389,6388,'600',3.333,5),(143,6390,6388,'00a',3.333,5),(143,6391,6388,'0a0',3.333,5),(143,6392,6388,'a09',3.333,5),(143,6393,6388,'098',3.333,5),(143,6394,6388,'980',3.333,5),(143,6395,6388,'80b',3.333,5),(143,6396,6388,'0b6',3.333,5),(143,6397,6388,'b64',3.333,5),(143,6398,6388,'640',3.333,5),(143,6399,6388,'408',3.333,5),(143,6400,6388,'084',3.333,5),(143,6401,6388,'84e',3.333,5),(143,6402,6388,'4ee',3.333,5),(143,6403,6388,'ee9',3.333,5),(143,6404,6388,'e93',3.333,5),(143,6405,6388,'934',3.333,5),(143,6406,6388,'344',3.333,5),(143,6407,6388,'444',3.333,5),(143,6408,6388,'448',3.333,5),(143,6409,6388,'481',3.333,5),(143,6410,6388,'811',3.333,5),(143,6411,6388,'117',3.333,5),(143,6412,6388,'17b',3.333,5),(143,6413,6388,'7b0',3.333,5),(143,6414,6388,'b04',3.333,5),(143,6415,6388,'04a',3.333,5),(143,6416,6388,'4ab',3.333,5),(143,6417,6388,'aba',3.333,5),(143,6418,6388,'ba2',3.333,5),(144,6420,6419,'net',25,5),(144,6421,6419,'eta',25,5),(144,6422,6419,'tap',25,5),(144,6423,6419,'app',25,5),(144,6424,6420,'fib',33.333,5),(144,6425,6420,'ibr',33.333,5),(144,6426,6420,'bre',33.333,5),(144,6427,6424,'cha',20,5),(144,6428,6424,'han',20,5),(144,6429,6424,'ann',20,5),(144,6430,6424,'nne',20,5),(144,6431,6424,'nel',20,5),(144,6432,6427,'dis',50,5),(144,6433,6427,'isk',50,5),(144,6434,6432,'naa',100,5),(144,6435,6434,'600',3.333,5),(144,6436,6434,'00a',3.333,5),(144,6437,6434,'0a0',3.333,5),(144,6438,6434,'a09',3.333,5),(144,6439,6434,'098',3.333,5),(144,6440,6434,'980',3.333,5),(144,6441,6434,'804',3.333,5),(144,6442,6434,'044',3.333,5),(144,6443,6434,'443',3.333,5),(144,6444,6434,'430',3.333,5),(144,6445,6434,'307',3.333,5),(144,6446,6434,'075',3.333,5),(144,6447,6434,'753',3.333,5),(144,6448,6434,'535',3.333,5),(144,6449,6434,'357',3.333,5),(144,6450,6434,'573',3.333,5),(144,6451,6434,'732',3.333,5),(144,6452,6434,'32b',3.333,5),(144,6453,6434,'2b3',3.333,5),(144,6454,6434,'b33',3.333,5),(144,6455,6434,'334',3.333,5),(144,6456,6434,'345',3.333,5),(144,6457,6434,'457',3.333,5),(144,6458,6434,'571',3.333,5),(144,6459,6434,'715',3.333,5),(144,6460,6434,'153',3.333,5),(144,6461,6434,'533',3.333,5),(144,6462,6434,'336',3.333,5),(144,6463,6434,'365',3.333,5),(144,6464,6434,'657',3.333,5),(145,6466,6465,'net',25,5),(145,6467,6465,'eta',25,5),(145,6468,6465,'tap',25,5),(145,6469,6465,'app',25,5),(145,6470,6466,'fib',33.333,5),(145,6471,6466,'ibr',33.333,5),(145,6472,6466,'bre',33.333,5),(145,6473,6470,'cha',20,5),(145,6474,6470,'han',20,5),(145,6475,6470,'ann',20,5),(145,6476,6470,'nne',20,5),(145,6477,6470,'nel',20,5),(145,6478,6473,'dis',50,5),(145,6479,6473,'isk',50,5),(145,6480,6478,'naa',100,5),(145,6481,6480,'600',3.333,5),(145,6482,6480,'00a',3.333,5),(145,6483,6480,'0a0',3.333,5),(145,6484,6480,'a09',3.333,5),(145,6485,6480,'098',3.333,5),(145,6486,6480,'980',3.333,5),(145,6487,6480,'804',3.333,5),(145,6488,6480,'044',3.333,5),(145,6489,6480,'443',3.333,5),(145,6490,6480,'430',3.333,5),(145,6491,6480,'307',3.333,5),(145,6492,6480,'075',3.333,5),(145,6493,6480,'753',3.333,5),(145,6494,6480,'535',3.333,5),(145,6495,6480,'357',3.333,5),(145,6496,6480,'573',3.333,5),(145,6497,6480,'732',3.333,5),(145,6498,6480,'32b',3.333,5),(145,6499,6480,'2b3',3.333,5),(145,6500,6480,'b33',3.333,5),(145,6501,6480,'334',3.333,5),(145,6502,6480,'345',3.333,5),(145,6503,6480,'457',3.333,5),(145,6504,6480,'571',3.333,5),(145,6505,6480,'715',3.333,5),(145,6506,6480,'153',3.333,5),(145,6507,6480,'533',3.333,5),(145,6508,6480,'336',3.333,5),(145,6509,6480,'365',3.333,5),(145,6510,6480,'658',3.333,5),(146,6512,6511,'net',25,5),(146,6513,6511,'eta',25,5),(146,6514,6511,'tap',25,5),(146,6515,6511,'app',25,5),(146,6516,6512,'fib',33.333,5),(146,6517,6512,'ibr',33.333,5),(146,6518,6512,'bre',33.333,5),(146,6519,6516,'cha',20,5),(146,6520,6516,'han',20,5),(146,6521,6516,'ann',20,5),(146,6522,6516,'nne',20,5),(146,6523,6516,'nel',20,5),(146,6524,6519,'dis',50,5),(146,6525,6519,'isk',50,5),(146,6526,6524,'naa',100,5),(146,6527,6526,'600',3.333,5),(146,6528,6526,'00a',3.333,5),(146,6529,6526,'0a0',3.333,5),(146,6530,6526,'a09',3.333,5),(146,6531,6526,'098',3.333,5),(146,6532,6526,'980',3.333,5),(146,6533,6526,'804',3.333,5),(146,6534,6526,'044',3.333,5),(146,6535,6526,'443',3.333,5),(146,6536,6526,'430',3.333,5),(146,6537,6526,'307',3.333,5),(146,6538,6526,'075',3.333,5),(146,6539,6526,'753',3.333,5),(146,6540,6526,'535',3.333,5),(146,6541,6526,'357',3.333,5),(146,6542,6526,'573',3.333,5),(146,6543,6526,'732',3.333,5),(146,6544,6526,'32b',3.333,5),(146,6545,6526,'2b3',3.333,5),(146,6546,6526,'b33',3.333,5),(146,6547,6526,'334',3.333,5),(146,6548,6526,'345',3.333,5),(146,6549,6526,'457',3.333,5),(146,6550,6526,'571',3.333,5),(146,6551,6526,'715',3.333,5),(146,6552,6526,'153',3.333,5),(146,6553,6526,'533',3.333,5),(146,6554,6526,'336',3.333,5),(146,6555,6526,'365',3.333,5),(146,6556,6526,'659',3.333,5),(147,6558,6557,'net',25,5),(147,6559,6557,'eta',25,5),(147,6560,6557,'tap',25,5),(147,6561,6557,'app',25,5),(147,6562,6558,'fib',33.333,5),(147,6563,6558,'ibr',33.333,5),(147,6564,6558,'bre',33.333,5),(147,6565,6562,'cha',20,5),(147,6566,6562,'han',20,5),(147,6567,6562,'ann',20,5),(147,6568,6562,'nne',20,5),(147,6569,6562,'nel',20,5),(147,6570,6565,'dis',50,5),(147,6571,6565,'isk',50,5),(147,6572,6570,'naa',100,5),(147,6573,6572,'600',3.333,5),(147,6574,6572,'00a',3.333,5),(147,6575,6572,'0a0',3.333,5),(147,6576,6572,'a09',3.333,5),(147,6577,6572,'098',3.333,5),(147,6578,6572,'980',3.333,5),(147,6579,6572,'804',3.333,5),(147,6580,6572,'044',3.333,5),(147,6581,6572,'443',3.333,5),(147,6582,6572,'430',3.333,5),(147,6583,6572,'307',3.333,5),(147,6584,6572,'075',3.333,5),(147,6585,6572,'753',3.333,5),(147,6586,6572,'535',3.333,5),(147,6587,6572,'357',3.333,5),(147,6588,6572,'573',3.333,5),(147,6589,6572,'732',3.333,5),(147,6590,6572,'32b',3.333,5),(147,6591,6572,'2b3',3.333,5),(147,6592,6572,'b33',3.333,5),(147,6593,6572,'334',3.333,5),(147,6594,6572,'345',3.333,5),(147,6595,6572,'457',3.333,5),(147,6596,6572,'571',3.333,5),(147,6597,6572,'715',3.333,5),(147,6598,6572,'152',3.333,5),(147,6599,6572,'527',3.333,5),(147,6600,6572,'275',3.333,5),(147,6601,6572,'753',3.333,5),(147,6602,6572,'534',3.333,5),(148,6604,6603,'net',25,5),(148,6605,6603,'eta',25,5),(148,6606,6603,'tap',25,5),(148,6607,6603,'app',25,5),(148,6608,6604,'fib',33.333,5),(148,6609,6604,'ibr',33.333,5),(148,6610,6604,'bre',33.333,5),(148,6611,6608,'cha',20,5),(148,6612,6608,'han',20,5),(148,6613,6608,'ann',20,5),(148,6614,6608,'nne',20,5),(148,6615,6608,'nel',20,5),(148,6616,6611,'dis',50,5),(148,6617,6611,'isk',50,5),(148,6618,6616,'naa',100,5),(148,6619,6618,'600',3.333,5),(148,6620,6618,'00a',3.333,5),(148,6621,6618,'0a0',3.333,5),(148,6622,6618,'a09',3.333,5),(148,6623,6618,'098',3.333,5),(148,6624,6618,'980',3.333,5),(148,6625,6618,'804',3.333,5),(148,6626,6618,'044',3.333,5),(148,6627,6618,'443',3.333,5),(148,6628,6618,'430',3.333,5),(148,6629,6618,'307',3.333,5),(148,6630,6618,'075',3.333,5),(148,6631,6618,'753',3.333,5),(148,6632,6618,'535',3.333,5),(148,6633,6618,'357',3.333,5),(148,6634,6618,'573',3.333,5),(148,6635,6618,'732',3.333,5),(148,6636,6618,'32b',3.333,5),(148,6637,6618,'2b3',3.333,5),(148,6638,6618,'b33',3.333,5),(148,6639,6618,'334',3.333,5),(148,6640,6618,'345',3.333,5),(148,6641,6618,'457',3.333,5),(148,6642,6618,'571',3.333,5),(148,6643,6618,'715',3.333,5),(148,6644,6618,'152',3.333,5),(148,6645,6618,'527',3.333,5),(148,6646,6618,'275',3.333,5),(148,6647,6618,'753',3.333,5),(148,6648,6618,'535',3.333,5),(149,6650,6649,'net',25,5),(149,6651,6649,'eta',25,5),(149,6652,6649,'tap',25,5),(149,6653,6649,'app',25,5),(149,6654,6650,'fib',33.333,5),(149,6655,6650,'ibr',33.333,5),(149,6656,6650,'bre',33.333,5),(149,6657,6654,'cha',20,5),(149,6658,6654,'han',20,5),(149,6659,6654,'ann',20,5),(149,6660,6654,'nne',20,5),(149,6661,6654,'nel',20,5),(149,6662,6657,'dis',50,5),(149,6663,6657,'isk',50,5),(149,6664,6662,'naa',100,5),(149,6665,6664,'600',3.333,5),(149,6666,6664,'00a',3.333,5),(149,6667,6664,'0a0',3.333,5),(149,6668,6664,'a09',3.333,5),(149,6669,6664,'098',3.333,5),(149,6670,6664,'980',3.333,5),(149,6671,6664,'804',3.333,5),(149,6672,6664,'044',3.333,5),(149,6673,6664,'443',3.333,5),(149,6674,6664,'430',3.333,5),(149,6675,6664,'307',3.333,5),(149,6676,6664,'075',3.333,5),(149,6677,6664,'753',3.333,5),(149,6678,6664,'535',3.333,5),(149,6679,6664,'357',3.333,5),(149,6680,6664,'573',3.333,5),(149,6681,6664,'732',3.333,5),(149,6682,6664,'32b',3.333,5),(149,6683,6664,'2b3',3.333,5),(149,6684,6664,'b33',3.333,5),(149,6685,6664,'334',3.333,5),(149,6686,6664,'345',3.333,5),(149,6687,6664,'457',3.333,5),(149,6688,6664,'571',3.333,5),(149,6689,6664,'715',3.333,5),(149,6690,6664,'152',3.333,5),(149,6691,6664,'527',3.333,5),(149,6692,6664,'275',3.333,5),(149,6693,6664,'753',3.333,5),(149,6694,6664,'536',3.333,5),(150,6696,6695,'net',25,5),(150,6697,6695,'eta',25,5),(150,6698,6695,'tap',25,5),(150,6699,6695,'app',25,5),(150,6700,6696,'fib',33.333,5),(150,6701,6696,'ibr',33.333,5),(150,6702,6696,'bre',33.333,5),(150,6703,6700,'cha',20,5),(150,6704,6700,'han',20,5),(150,6705,6700,'ann',20,5),(150,6706,6700,'nne',20,5),(150,6707,6700,'nel',20,5),(150,6708,6703,'dis',50,5),(150,6709,6703,'isk',50,5),(150,6710,6708,'naa',100,5),(150,6711,6710,'600',3.333,5),(150,6712,6710,'00a',3.333,5),(150,6713,6710,'0a0',3.333,5),(150,6714,6710,'a09',3.333,5),(150,6715,6710,'098',3.333,5),(150,6716,6710,'980',3.333,5),(150,6717,6710,'804',3.333,5),(150,6718,6710,'044',3.333,5),(150,6719,6710,'443',3.333,5),(150,6720,6710,'430',3.333,5),(150,6721,6710,'307',3.333,5),(150,6722,6710,'075',3.333,5),(150,6723,6710,'753',3.333,5),(150,6724,6710,'535',3.333,5),(150,6725,6710,'357',3.333,5),(150,6726,6710,'573',3.333,5),(150,6727,6710,'732',3.333,5),(150,6728,6710,'32b',3.333,5),(150,6729,6710,'2b3',3.333,5),(150,6730,6710,'b33',3.333,5),(150,6731,6710,'334',3.333,5),(150,6732,6710,'345',3.333,5),(150,6733,6710,'457',3.333,5),(150,6734,6710,'571',3.333,5),(150,6735,6710,'715',3.333,5),(150,6736,6710,'152',3.333,5),(150,6737,6710,'527',3.333,5),(150,6738,6710,'275',3.333,5),(150,6739,6710,'753',3.333,5),(150,6740,6710,'537',3.333,5),(151,6742,6741,'net',25,5),(151,6743,6741,'eta',25,5),(151,6744,6741,'tap',25,5),(151,6745,6741,'app',25,5),(151,6746,6742,'fib',33.333,5),(151,6747,6742,'ibr',33.333,5),(151,6748,6742,'bre',33.333,5),(151,6749,6746,'cha',20,5),(151,6750,6746,'han',20,5),(151,6751,6746,'ann',20,5),(151,6752,6746,'nne',20,5),(151,6753,6746,'nel',20,5),(151,6754,6749,'dis',50,5),(151,6755,6749,'isk',50,5),(151,6756,6754,'naa',100,5),(151,6757,6756,'600',3.333,5),(151,6758,6756,'00a',3.333,5),(151,6759,6756,'0a0',3.333,5),(151,6760,6756,'a09',3.333,5),(151,6761,6756,'098',3.333,5),(151,6762,6756,'980',3.333,5),(151,6763,6756,'804',3.333,5),(151,6764,6756,'044',3.333,5),(151,6765,6756,'443',3.333,5),(151,6766,6756,'430',3.333,5),(151,6767,6756,'307',3.333,5),(151,6768,6756,'075',3.333,5),(151,6769,6756,'753',3.333,5),(151,6770,6756,'535',3.333,5),(151,6771,6756,'357',3.333,5),(151,6772,6756,'573',3.333,5),(151,6773,6756,'732',3.333,5),(151,6774,6756,'32b',3.333,5),(151,6775,6756,'2b3',3.333,5),(151,6776,6756,'b33',3.333,5),(151,6777,6756,'334',3.333,5),(151,6778,6756,'345',3.333,5),(151,6779,6756,'457',3.333,5),(151,6780,6756,'571',3.333,5),(151,6781,6756,'715',3.333,5),(151,6782,6756,'152',3.333,5),(151,6783,6756,'527',3.333,5),(151,6784,6756,'275',3.333,5),(151,6785,6756,'753',3.333,5),(151,6786,6756,'538',3.333,5),(152,6788,6787,'net',25,5),(152,6789,6787,'eta',25,5),(152,6790,6787,'tap',25,5),(152,6791,6787,'app',25,5),(152,6792,6788,'fib',33.333,5),(152,6793,6788,'ibr',33.333,5),(152,6794,6788,'bre',33.333,5),(152,6795,6792,'cha',20,5),(152,6796,6792,'han',20,5),(152,6797,6792,'ann',20,5),(152,6798,6792,'nne',20,5),(152,6799,6792,'nel',20,5),(152,6800,6795,'dis',50,5),(152,6801,6795,'isk',50,5),(152,6802,6800,'naa',100,5),(152,6803,6802,'600',3.333,5),(152,6804,6802,'00a',3.333,5),(152,6805,6802,'0a0',3.333,5),(152,6806,6802,'a09',3.333,5),(152,6807,6802,'098',3.333,5),(152,6808,6802,'980',3.333,5),(152,6809,6802,'804',3.333,5),(152,6810,6802,'044',3.333,5),(152,6811,6802,'443',3.333,5),(152,6812,6802,'430',3.333,5),(152,6813,6802,'307',3.333,5),(152,6814,6802,'075',3.333,5),(152,6815,6802,'753',3.333,5),(152,6816,6802,'535',3.333,5),(152,6817,6802,'357',3.333,5),(152,6818,6802,'573',3.333,5),(152,6819,6802,'732',3.333,5),(152,6820,6802,'32b',3.333,5),(152,6821,6802,'2b3',3.333,5),(152,6822,6802,'b33',3.333,5),(152,6823,6802,'334',3.333,5),(152,6824,6802,'345',3.333,5),(152,6825,6802,'457',3.333,5),(152,6826,6802,'571',3.333,5),(152,6827,6802,'715',3.333,5),(152,6828,6802,'152',3.333,5),(152,6829,6802,'527',3.333,5),(152,6830,6802,'275',3.333,5),(152,6831,6802,'753',3.333,5),(152,6832,6802,'539',3.333,5),(153,6834,6833,'loc',33.333,5),(153,6835,6833,'oca',33.333,5),(153,6836,6833,'cal',33.333,5),(153,6837,6834,'lsi',100,5),(153,6838,6837,'dis',50,5),(153,6839,6837,'isk',50,5),(153,6840,6838,'naa',100,5),(153,6841,6840,'600',3.333,5),(153,6842,6840,'003',3.333,5),(153,6843,6840,'030',3.333,5),(153,6844,6840,'300',3.333,5),(153,6845,6840,'005',3.333,5),(153,6846,6840,'057',3.333,5),(153,6847,6840,'570',3.333,5),(153,6848,6840,'701',3.333,5),(153,6849,6840,'014',3.333,5),(153,6850,6840,'144',3.333,5),(153,6851,6840,'448',3.333,5),(153,6852,6840,'484',3.333,5),(153,6853,6840,'849',3.333,5),(153,6854,6840,'490',3.333,5),(153,6855,6840,'901',3.333,5),(153,6856,6840,'018',3.333,5),(153,6857,6840,'186',3.333,5),(153,6858,6840,'862',3.333,5),(153,6859,6840,'622',3.333,5),(153,6860,6840,'22c',3.333,5),(153,6861,6840,'2c7',3.333,5),(153,6862,6840,'c7f',3.333,5),(153,6863,6840,'7f0',3.333,5),(153,6864,6840,'f0b',3.333,5),(153,6865,6840,'0bb',3.333,5),(153,6866,6840,'bb6',3.333,5),(153,6867,6840,'b62',3.333,5),(153,6868,6840,'624',3.333,5),(153,6869,6840,'24f',3.333,5),(153,6870,6840,'4f8',3.333,5),(154,6872,6871,'net',25,5),(154,6873,6871,'eta',25,5),(154,6874,6871,'tap',25,5),(154,6875,6871,'app',25,5),(154,6876,6872,'ser',25,5),(154,6877,6872,'eri',25,5),(154,6878,6872,'ria',25,5),(154,6879,6872,'ial',25,5),(154,6880,6876,'att',16.667,5),(154,6881,6876,'tta',16.667,5),(154,6882,6876,'tac',16.667,5),(154,6883,6876,'ach',16.667,5),(154,6884,6876,'che',16.667,5),(154,6885,6876,'hed',16.667,5),(154,6886,6880,'scs',50,5),(154,6887,6880,'csi',50,5),(154,6888,6886,'dis',50,5),(154,6889,6886,'isk',50,5),(154,6890,6888,'naa',100,5),(154,6891,6890,'600',3.333,5),(154,6892,6890,'00a',3.333,5),(154,6893,6890,'0a0',3.333,5),(154,6894,6890,'a09',3.333,5),(154,6895,6890,'098',3.333,5),(154,6896,6890,'980',3.333,5),(154,6897,6890,'80f',3.333,5),(154,6898,6890,'0f8',3.333,5),(154,6899,6890,'f87',3.333,5),(154,6900,6890,'879',3.333,5),(154,6901,6890,'798',3.333,5),(154,6902,6890,'984',3.333,5),(154,6903,6890,'84e',3.333,5),(154,6904,6890,'4ee',3.333,5),(154,6905,6890,'ee8',3.333,5),(154,6906,6890,'e8e',3.333,5),(154,6907,6890,'8e5',3.333,5),(154,6908,6890,'e52',3.333,5),(154,6909,6890,'524',3.333,5),(154,6910,6890,'24c',3.333,5),(154,6911,6890,'4c1',3.333,5),(154,6912,6890,'c11',3.333,5),(154,6913,6890,'117',3.333,5),(154,6914,6890,'17b',3.333,5),(154,6915,6890,'7b0',3.333,5),(154,6916,6890,'b0e',3.333,5),(154,6917,6890,'0ea',3.333,5),(154,6918,6890,'eab',3.333,5),(154,6919,6890,'aba',3.333,5),(154,6920,6890,'ba2',3.333,5),(155,6922,6921,'net',25,5),(155,6923,6921,'eta',25,5),(155,6924,6921,'tap',25,5),(155,6925,6921,'app',25,5),(155,6926,6922,'fib',33.333,5),(155,6927,6922,'ibr',33.333,5),(155,6928,6922,'bre',33.333,5),(155,6929,6926,'cha',20,5),(155,6930,6926,'han',20,5),(155,6931,6926,'ann',20,5),(155,6932,6926,'nne',20,5),(155,6933,6926,'nel',20,5),(155,6934,6929,'dis',50,5),(155,6935,6929,'isk',50,5),(155,6936,6934,'naa',100,5),(155,6937,6936,'600',3.333,5),(155,6938,6936,'00a',3.333,5),(155,6939,6936,'0a0',3.333,5),(155,6940,6936,'a09',3.333,5),(155,6941,6936,'098',3.333,5),(155,6942,6936,'980',3.333,5),(155,6943,6936,'804',3.333,5),(155,6944,6936,'044',3.333,5),(155,6945,6936,'443',3.333,5),(155,6946,6936,'430',3.333,5),(155,6947,6936,'307',3.333,5),(155,6948,6936,'075',3.333,5),(155,6949,6936,'753',3.333,5),(155,6950,6936,'535',3.333,5),(155,6951,6936,'357',3.333,5),(155,6952,6936,'573',3.333,5),(155,6953,6936,'732',3.333,5),(155,6954,6936,'32b',3.333,5),(155,6955,6936,'2b3',3.333,5),(155,6956,6936,'b33',3.333,5),(155,6957,6936,'334',3.333,5),(155,6958,6936,'345',3.333,5),(155,6959,6936,'457',3.333,5),(155,6960,6936,'571',3.333,5),(155,6961,6936,'715',3.333,5),(155,6962,6936,'153',3.333,5),(155,6963,6936,'533',3.333,5),(155,6964,6936,'335',3.333,5),(155,6965,6936,'357',3.333,5),(155,6966,6936,'57a',3.333,5),(156,6968,6967,'net',25,5),(156,6969,6967,'eta',25,5),(156,6970,6967,'tap',25,5),(156,6971,6967,'app',25,5),(156,6972,6968,'fib',33.333,5),(156,6973,6968,'ibr',33.333,5),(156,6974,6968,'bre',33.333,5),(156,6975,6972,'cha',20,5),(156,6976,6972,'han',20,5),(156,6977,6972,'ann',20,5),(156,6978,6972,'nne',20,5),(156,6979,6972,'nel',20,5),(156,6980,6975,'dis',50,5),(156,6981,6975,'isk',50,5),(156,6982,6980,'naa',100,5),(156,6983,6982,'600',3.333,5),(156,6984,6982,'00a',3.333,5),(156,6985,6982,'0a0',3.333,5),(156,6986,6982,'a09',3.333,5),(156,6987,6982,'098',3.333,5),(156,6988,6982,'980',3.333,5),(156,6989,6982,'804',3.333,5),(156,6990,6982,'044',3.333,5),(156,6991,6982,'443',3.333,5),(156,6992,6982,'430',3.333,5),(156,6993,6982,'307',3.333,5),(156,6994,6982,'075',3.333,5),(156,6995,6982,'753',3.333,5),(156,6996,6982,'535',3.333,5),(156,6997,6982,'357',3.333,5),(156,6998,6982,'573',3.333,5),(156,6999,6982,'732',3.333,5),(156,7000,6982,'32b',3.333,5),(156,7001,6982,'2b3',3.333,5),(156,7002,6982,'b33',3.333,5),(156,7003,6982,'334',3.333,5),(156,7004,6982,'345',3.333,5),(156,7005,6982,'457',3.333,5),(156,7006,6982,'571',3.333,5),(156,7007,6982,'715',3.333,5),(156,7008,6982,'153',3.333,5),(156,7009,6982,'533',3.333,5),(156,7010,6982,'336',3.333,5),(156,7011,6982,'365',3.333,5),(156,7012,6982,'65a',3.333,5),(157,7014,7013,'net',25,5),(157,7015,7013,'eta',25,5),(157,7016,7013,'tap',25,5),(157,7017,7013,'app',25,5),(157,7018,7014,'fib',33.333,5),(157,7019,7014,'ibr',33.333,5),(157,7020,7014,'bre',33.333,5),(157,7021,7018,'cha',20,5),(157,7022,7018,'han',20,5),(157,7023,7018,'ann',20,5),(157,7024,7018,'nne',20,5),(157,7025,7018,'nel',20,5),(157,7026,7021,'dis',50,5),(157,7027,7021,'isk',50,5),(157,7028,7026,'naa',100,5),(157,7029,7028,'600',3.333,5),(157,7030,7028,'00a',3.333,5),(157,7031,7028,'0a0',3.333,5),(157,7032,7028,'a09',3.333,5),(157,7033,7028,'098',3.333,5),(157,7034,7028,'980',3.333,5),(157,7035,7028,'804',3.333,5),(157,7036,7028,'044',3.333,5),(157,7037,7028,'443',3.333,5),(157,7038,7028,'430',3.333,5),(157,7039,7028,'307',3.333,5),(157,7040,7028,'072',3.333,5),(157,7041,7028,'725',3.333,5),(157,7042,7028,'259',3.333,5),(157,7043,7028,'593',3.333,5),(157,7044,7028,'931',3.333,5),(157,7045,7028,'313',3.333,5),(157,7046,7028,'13f',3.333,5),(157,7047,7028,'3f3',3.333,5),(157,7048,7028,'f33',3.333,5),(157,7049,7028,'334',3.333,5),(157,7050,7028,'345',3.333,5),(157,7051,7028,'455',3.333,5),(157,7052,7028,'556',3.333,5),(157,7053,7028,'563',3.333,5),(157,7054,7028,'639',3.333,5),(157,7055,7028,'393',3.333,5),(157,7056,7028,'933',3.333,5),(157,7057,7028,'337',3.333,5),(157,7058,7028,'370',3.333,5),(158,7060,7059,'net',25,5),(158,7061,7059,'eta',25,5),(158,7062,7059,'tap',25,5),(158,7063,7059,'app',25,5),(158,7064,7060,'ser',25,5),(158,7065,7060,'eri',25,5),(158,7066,7060,'ria',25,5),(158,7067,7060,'ial',25,5),(158,7068,7064,'att',16.667,5),(158,7069,7064,'tta',16.667,5),(158,7070,7064,'tac',16.667,5),(158,7071,7064,'ach',16.667,5),(158,7072,7064,'che',16.667,5),(158,7073,7064,'hed',16.667,5),(158,7074,7068,'scs',50,5),(158,7075,7068,'csi',50,5),(158,7076,7074,'dis',50,5),(158,7077,7074,'isk',50,5),(158,7078,7076,'naa',100,5),(158,7079,7078,'600',3.333,5),(158,7080,7078,'00a',3.333,5),(158,7081,7078,'0a0',3.333,5),(158,7082,7078,'a09',3.333,5),(158,7083,7078,'098',3.333,5),(158,7084,7078,'980',3.333,5),(158,7085,7078,'807',3.333,5),(158,7086,7078,'074',3.333,5),(158,7087,7078,'744',3.333,5),(158,7088,7078,'44e',3.333,5),(158,7089,7078,'4e8',3.333,5),(158,7090,7078,'e83',3.333,5),(158,7091,7078,'83e',3.333,5),(158,7092,7078,'3ee',3.333,5),(158,7093,7078,'ee1',3.333,5),(158,7094,7078,'e10',3.333,5),(158,7095,7078,'10d',3.333,5),(158,7096,7078,'0dd',3.333,5),(158,7097,7078,'dd4',3.333,5),(158,7098,7078,'d42',3.333,5),(158,7099,7078,'421',3.333,5),(158,7100,7078,'211',3.333,5),(158,7101,7078,'117',3.333,5),(158,7102,7078,'17b',3.333,5),(158,7103,7078,'7b0',3.333,5),(158,7104,7078,'b00',3.333,5),(158,7105,7078,'00a',3.333,5),(158,7106,7078,'0ab',3.333,5),(158,7107,7078,'aba',3.333,5),(158,7108,7078,'ba2',3.333,5),(159,7110,7109,'net',25,5),(159,7111,7109,'eta',25,5),(159,7112,7109,'tap',25,5),(159,7113,7109,'app',25,5),(159,7114,7110,'fib',33.333,5),(159,7115,7110,'ibr',33.333,5),(159,7116,7110,'bre',33.333,5),(159,7117,7114,'cha',20,5),(159,7118,7114,'han',20,5),(159,7119,7114,'ann',20,5),(159,7120,7114,'nne',20,5),(159,7121,7114,'nel',20,5),(159,7122,7117,'dis',50,5),(159,7123,7117,'isk',50,5),(159,7124,7122,'naa',100,5),(159,7125,7124,'600',3.333,5),(159,7126,7124,'00a',3.333,5),(159,7127,7124,'0a0',3.333,5),(159,7128,7124,'a09',3.333,5),(159,7129,7124,'098',3.333,5),(159,7130,7124,'980',3.333,5),(159,7131,7124,'804',3.333,5),(159,7132,7124,'044',3.333,5),(159,7133,7124,'443',3.333,5),(159,7134,7124,'430',3.333,5),(159,7135,7124,'307',3.333,5),(159,7136,7124,'072',3.333,5),(159,7137,7124,'725',3.333,5),(159,7138,7124,'259',3.333,5),(159,7139,7124,'593',3.333,5),(159,7140,7124,'931',3.333,5),(159,7141,7124,'313',3.333,5),(159,7142,7124,'13f',3.333,5),(159,7143,7124,'3f3',3.333,5),(159,7144,7124,'f33',3.333,5),(159,7145,7124,'334',3.333,5),(159,7146,7124,'345',3.333,5),(159,7147,7124,'455',3.333,5),(159,7148,7124,'556',3.333,5),(159,7149,7124,'563',3.333,5),(159,7150,7124,'639',3.333,5),(159,7151,7124,'393',3.333,5),(159,7152,7124,'933',3.333,5),(159,7153,7124,'337',3.333,5),(159,7154,7124,'371',3.333,5),(160,7156,7155,'net',25,5),(160,7157,7155,'eta',25,5),(160,7158,7155,'tap',25,5),(160,7159,7155,'app',25,5),(160,7160,7156,'fib',33.333,5),(160,7161,7156,'ibr',33.333,5),(160,7162,7156,'bre',33.333,5),(160,7163,7160,'cha',20,5),(160,7164,7160,'han',20,5),(160,7165,7160,'ann',20,5),(160,7166,7160,'nne',20,5),(160,7167,7160,'nel',20,5),(160,7168,7163,'dis',50,5),(160,7169,7163,'isk',50,5),(160,7170,7168,'naa',100,5),(160,7171,7170,'600',3.333,5),(160,7172,7170,'00a',3.333,5),(160,7173,7170,'0a0',3.333,5),(160,7174,7170,'a09',3.333,5),(160,7175,7170,'098',3.333,5),(160,7176,7170,'980',3.333,5),(160,7177,7170,'804',3.333,5),(160,7178,7170,'044',3.333,5),(160,7179,7170,'443',3.333,5),(160,7180,7170,'430',3.333,5),(160,7181,7170,'307',3.333,5),(160,7182,7170,'072',3.333,5),(160,7183,7170,'725',3.333,5),(160,7184,7170,'259',3.333,5),(160,7185,7170,'593',3.333,5),(160,7186,7170,'931',3.333,5),(160,7187,7170,'313',3.333,5),(160,7188,7170,'13f',3.333,5),(160,7189,7170,'3f3',3.333,5),(160,7190,7170,'f33',3.333,5),(160,7191,7170,'334',3.333,5),(160,7192,7170,'345',3.333,5),(160,7193,7170,'455',3.333,5),(160,7194,7170,'556',3.333,5),(160,7195,7170,'563',3.333,5),(160,7196,7170,'639',3.333,5),(160,7197,7170,'393',3.333,5),(160,7198,7170,'933',3.333,5),(160,7199,7170,'337',3.333,5),(160,7200,7170,'372',3.333,5),(161,7202,7201,'net',25,5),(161,7203,7201,'eta',25,5),(161,7204,7201,'tap',25,5),(161,7205,7201,'app',25,5),(161,7206,7202,'fib',33.333,5),(161,7207,7202,'ibr',33.333,5),(161,7208,7202,'bre',33.333,5),(161,7209,7206,'cha',20,5),(161,7210,7206,'han',20,5),(161,7211,7206,'ann',20,5),(161,7212,7206,'nne',20,5),(161,7213,7206,'nel',20,5),(161,7214,7209,'dis',50,5),(161,7215,7209,'isk',50,5),(161,7216,7214,'naa',100,5),(161,7217,7216,'600',3.333,5),(161,7218,7216,'00a',3.333,5),(161,7219,7216,'0a0',3.333,5),(161,7220,7216,'a09',3.333,5),(161,7221,7216,'098',3.333,5),(161,7222,7216,'980',3.333,5),(161,7223,7216,'804',3.333,5),(161,7224,7216,'044',3.333,5),(161,7225,7216,'443',3.333,5),(161,7226,7216,'430',3.333,5),(161,7227,7216,'307',3.333,5),(161,7228,7216,'072',3.333,5),(161,7229,7216,'725',3.333,5),(161,7230,7216,'259',3.333,5),(161,7231,7216,'593',3.333,5),(161,7232,7216,'931',3.333,5),(161,7233,7216,'313',3.333,5),(161,7234,7216,'13f',3.333,5),(161,7235,7216,'3f3',3.333,5),(161,7236,7216,'f33',3.333,5),(161,7237,7216,'334',3.333,5),(161,7238,7216,'345',3.333,5),(161,7239,7216,'455',3.333,5),(161,7240,7216,'556',3.333,5),(161,7241,7216,'563',3.333,5),(161,7242,7216,'639',3.333,5),(161,7243,7216,'393',3.333,5),(161,7244,7216,'933',3.333,5),(161,7245,7216,'337',3.333,5),(161,7246,7216,'373',3.333,5),(162,7248,7247,'net',25,5),(162,7249,7247,'eta',25,5),(162,7250,7247,'tap',25,5),(162,7251,7247,'app',25,5),(162,7252,7248,'fib',33.333,5),(162,7253,7248,'ibr',33.333,5),(162,7254,7248,'bre',33.333,5),(162,7255,7252,'cha',20,5),(162,7256,7252,'han',20,5),(162,7257,7252,'ann',20,5),(162,7258,7252,'nne',20,5),(162,7259,7252,'nel',20,5),(162,7260,7255,'dis',50,5),(162,7261,7255,'isk',50,5),(162,7262,7260,'naa',100,5),(162,7263,7262,'600',3.333,5),(162,7264,7262,'00a',3.333,5),(162,7265,7262,'0a0',3.333,5),(162,7266,7262,'a09',3.333,5),(162,7267,7262,'098',3.333,5),(162,7268,7262,'980',3.333,5),(162,7269,7262,'804',3.333,5),(162,7270,7262,'044',3.333,5),(162,7271,7262,'443',3.333,5),(162,7272,7262,'430',3.333,5),(162,7273,7262,'307',3.333,5),(162,7274,7262,'072',3.333,5),(162,7275,7262,'725',3.333,5),(162,7276,7262,'259',3.333,5),(162,7277,7262,'593',3.333,5),(162,7278,7262,'931',3.333,5),(162,7279,7262,'313',3.333,5),(162,7280,7262,'13f',3.333,5),(162,7281,7262,'3f3',3.333,5),(162,7282,7262,'f33',3.333,5),(162,7283,7262,'334',3.333,5),(162,7284,7262,'345',3.333,5),(162,7285,7262,'455',3.333,5),(162,7286,7262,'556',3.333,5),(162,7287,7262,'563',3.333,5),(162,7288,7262,'639',3.333,5),(162,7289,7262,'393',3.333,5),(162,7290,7262,'934',3.333,5),(162,7291,7262,'345',3.333,5),(162,7292,7262,'450',3.333,5),(163,7294,7293,'net',25,5),(163,7295,7293,'eta',25,5),(163,7296,7293,'tap',25,5),(163,7297,7293,'app',25,5),(163,7298,7294,'fib',33.333,5),(163,7299,7294,'ibr',33.333,5),(163,7300,7294,'bre',33.333,5),(163,7301,7298,'cha',20,5),(163,7302,7298,'han',20,5),(163,7303,7298,'ann',20,5),(163,7304,7298,'nne',20,5),(163,7305,7298,'nel',20,5),(163,7306,7301,'dis',50,5),(163,7307,7301,'isk',50,5),(163,7308,7306,'naa',100,5),(163,7309,7308,'600',3.333,5),(163,7310,7308,'00a',3.333,5),(163,7311,7308,'0a0',3.333,5),(163,7312,7308,'a09',3.333,5),(163,7313,7308,'098',3.333,5),(163,7314,7308,'980',3.333,5),(163,7315,7308,'804',3.333,5),(163,7316,7308,'044',3.333,5),(163,7317,7308,'443',3.333,5),(163,7318,7308,'430',3.333,5),(163,7319,7308,'307',3.333,5),(163,7320,7308,'072',3.333,5),(163,7321,7308,'725',3.333,5),(163,7322,7308,'259',3.333,5),(163,7323,7308,'593',3.333,5),(163,7324,7308,'931',3.333,5),(163,7325,7308,'313',3.333,5),(163,7326,7308,'13f',3.333,5),(163,7327,7308,'3f3',3.333,5),(163,7328,7308,'f33',3.333,5),(163,7329,7308,'334',3.333,5),(163,7330,7308,'345',3.333,5),(163,7331,7308,'455',3.333,5),(163,7332,7308,'556',3.333,5),(163,7333,7308,'563',3.333,5),(163,7334,7308,'639',3.333,5),(163,7335,7308,'393',3.333,5),(163,7336,7308,'933',3.333,5),(163,7337,7308,'337',3.333,5),(163,7338,7308,'374',3.333,5),(164,7340,7339,'net',25,5),(164,7341,7339,'eta',25,5),(164,7342,7339,'tap',25,5),(164,7343,7339,'app',25,5),(164,7344,7340,'fib',33.333,5),(164,7345,7340,'ibr',33.333,5),(164,7346,7340,'bre',33.333,5),(164,7347,7344,'cha',20,5),(164,7348,7344,'han',20,5),(164,7349,7344,'ann',20,5),(164,7350,7344,'nne',20,5),(164,7351,7344,'nel',20,5),(164,7352,7347,'dis',50,5),(164,7353,7347,'isk',50,5),(164,7354,7352,'naa',100,5),(164,7355,7354,'600',3.333,5),(164,7356,7354,'00a',3.333,5),(164,7357,7354,'0a0',3.333,5),(164,7358,7354,'a09',3.333,5),(164,7359,7354,'098',3.333,5),(164,7360,7354,'980',3.333,5),(164,7361,7354,'804',3.333,5),(164,7362,7354,'044',3.333,5),(164,7363,7354,'443',3.333,5),(164,7364,7354,'430',3.333,5),(164,7365,7354,'307',3.333,5),(164,7366,7354,'072',3.333,5),(164,7367,7354,'725',3.333,5),(164,7368,7354,'259',3.333,5),(164,7369,7354,'593',3.333,5),(164,7370,7354,'931',3.333,5),(164,7371,7354,'313',3.333,5),(164,7372,7354,'13f',3.333,5),(164,7373,7354,'3f3',3.333,5),(164,7374,7354,'f33',3.333,5),(164,7375,7354,'334',3.333,5),(164,7376,7354,'345',3.333,5),(164,7377,7354,'455',3.333,5),(164,7378,7354,'556',3.333,5),(164,7379,7354,'563',3.333,5),(164,7380,7354,'639',3.333,5),(164,7381,7354,'393',3.333,5),(164,7382,7354,'934',3.333,5),(164,7383,7354,'345',3.333,5),(164,7384,7354,'451',3.333,5),(165,7386,7385,'net',25,5),(165,7387,7385,'eta',25,5),(165,7388,7385,'tap',25,5),(165,7389,7385,'app',25,5),(165,7390,7386,'fib',33.333,5),(165,7391,7386,'ibr',33.333,5),(165,7392,7386,'bre',33.333,5),(165,7393,7390,'cha',20,5),(165,7394,7390,'han',20,5),(165,7395,7390,'ann',20,5),(165,7396,7390,'nne',20,5),(165,7397,7390,'nel',20,5),(165,7398,7393,'dis',50,5),(165,7399,7393,'isk',50,5),(165,7400,7398,'naa',100,5),(165,7401,7400,'600',3.333,5),(165,7402,7400,'00a',3.333,5),(165,7403,7400,'0a0',3.333,5),(165,7404,7400,'a09',3.333,5),(165,7405,7400,'098',3.333,5),(165,7406,7400,'980',3.333,5),(165,7407,7400,'804',3.333,5),(165,7408,7400,'044',3.333,5),(165,7409,7400,'443',3.333,5),(165,7410,7400,'430',3.333,5),(165,7411,7400,'307',3.333,5),(165,7412,7400,'072',3.333,5),(165,7413,7400,'725',3.333,5),(165,7414,7400,'259',3.333,5),(165,7415,7400,'593',3.333,5),(165,7416,7400,'931',3.333,5),(165,7417,7400,'313',3.333,5),(165,7418,7400,'13f',3.333,5),(165,7419,7400,'3f3',3.333,5),(165,7420,7400,'f33',3.333,5),(165,7421,7400,'334',3.333,5),(165,7422,7400,'345',3.333,5),(165,7423,7400,'455',3.333,5),(165,7424,7400,'556',3.333,5),(165,7425,7400,'563',3.333,5),(165,7426,7400,'639',3.333,5),(165,7427,7400,'393',3.333,5),(165,7428,7400,'933',3.333,5),(165,7429,7400,'337',3.333,5),(165,7430,7400,'375',3.333,5),(166,7432,7431,'net',25,5),(166,7433,7431,'eta',25,5),(166,7434,7431,'tap',25,5),(166,7435,7431,'app',25,5),(166,7436,7432,'fib',33.333,5),(166,7437,7432,'ibr',33.333,5),(166,7438,7432,'bre',33.333,5),(166,7439,7436,'cha',20,5),(166,7440,7436,'han',20,5),(166,7441,7436,'ann',20,5),(166,7442,7436,'nne',20,5),(166,7443,7436,'nel',20,5),(166,7444,7439,'dis',50,5),(166,7445,7439,'isk',50,5),(166,7446,7444,'naa',100,5),(166,7447,7446,'600',3.333,5),(166,7448,7446,'00a',3.333,5),(166,7449,7446,'0a0',3.333,5),(166,7450,7446,'a09',3.333,5),(166,7451,7446,'098',3.333,5),(166,7452,7446,'980',3.333,5),(166,7453,7446,'804',3.333,5),(166,7454,7446,'044',3.333,5),(166,7455,7446,'443',3.333,5),(166,7456,7446,'430',3.333,5),(166,7457,7446,'307',3.333,5),(166,7458,7446,'072',3.333,5),(166,7459,7446,'725',3.333,5),(166,7460,7446,'259',3.333,5),(166,7461,7446,'593',3.333,5),(166,7462,7446,'931',3.333,5),(166,7463,7446,'313',3.333,5),(166,7464,7446,'13f',3.333,5),(166,7465,7446,'3f3',3.333,5),(166,7466,7446,'f33',3.333,5),(166,7467,7446,'334',3.333,5),(166,7468,7446,'345',3.333,5),(166,7469,7446,'455',3.333,5),(166,7470,7446,'556',3.333,5),(166,7471,7446,'563',3.333,5),(166,7472,7446,'639',3.333,5),(166,7473,7446,'393',3.333,5),(166,7474,7446,'934',3.333,5),(166,7475,7446,'345',3.333,5),(166,7476,7446,'452',3.333,5),(167,7478,7477,'net',25,5),(167,7479,7477,'eta',25,5),(167,7480,7477,'tap',25,5),(167,7481,7477,'app',25,5),(167,7482,7478,'fib',33.333,5),(167,7483,7478,'ibr',33.333,5),(167,7484,7478,'bre',33.333,5),(167,7485,7482,'cha',20,5),(167,7486,7482,'han',20,5),(167,7487,7482,'ann',20,5),(167,7488,7482,'nne',20,5),(167,7489,7482,'nel',20,5),(167,7490,7485,'dis',50,5),(167,7491,7485,'isk',50,5),(167,7492,7490,'naa',100,5),(167,7493,7492,'600',3.333,5),(167,7494,7492,'00a',3.333,5),(167,7495,7492,'0a0',3.333,5),(167,7496,7492,'a09',3.333,5),(167,7497,7492,'098',3.333,5),(167,7498,7492,'980',3.333,5),(167,7499,7492,'804',3.333,5),(167,7500,7492,'044',3.333,5),(167,7501,7492,'443',3.333,5),(167,7502,7492,'430',3.333,5),(167,7503,7492,'307',3.333,5),(167,7504,7492,'072',3.333,5),(167,7505,7492,'725',3.333,5),(167,7506,7492,'259',3.333,5),(167,7507,7492,'593',3.333,5),(167,7508,7492,'931',3.333,5),(167,7509,7492,'313',3.333,5),(167,7510,7492,'13f',3.333,5),(167,7511,7492,'3f3',3.333,5),(167,7512,7492,'f33',3.333,5),(167,7513,7492,'334',3.333,5),(167,7514,7492,'345',3.333,5),(167,7515,7492,'455',3.333,5),(167,7516,7492,'556',3.333,5),(167,7517,7492,'563',3.333,5),(167,7518,7492,'639',3.333,5),(167,7519,7492,'393',3.333,5),(167,7520,7492,'933',3.333,5),(167,7521,7492,'337',3.333,5),(167,7522,7492,'376',3.333,5),(168,7524,7523,'net',25,5),(168,7525,7523,'eta',25,5),(168,7526,7523,'tap',25,5),(168,7527,7523,'app',25,5),(168,7528,7524,'fib',33.333,5),(168,7529,7524,'ibr',33.333,5),(168,7530,7524,'bre',33.333,5),(168,7531,7528,'cha',20,5),(168,7532,7528,'han',20,5),(168,7533,7528,'ann',20,5),(168,7534,7528,'nne',20,5),(168,7535,7528,'nel',20,5),(168,7536,7531,'dis',50,5),(168,7537,7531,'isk',50,5),(168,7538,7536,'naa',100,5),(168,7539,7538,'600',3.333,5),(168,7540,7538,'00a',3.333,5),(168,7541,7538,'0a0',3.333,5),(168,7542,7538,'a09',3.333,5),(168,7543,7538,'098',3.333,5),(168,7544,7538,'980',3.333,5),(168,7545,7538,'804',3.333,5),(168,7546,7538,'044',3.333,5),(168,7547,7538,'443',3.333,5),(168,7548,7538,'430',3.333,5),(168,7549,7538,'307',3.333,5),(168,7550,7538,'072',3.333,5),(168,7551,7538,'725',3.333,5),(168,7552,7538,'259',3.333,5),(168,7553,7538,'593',3.333,5),(168,7554,7538,'931',3.333,5),(168,7555,7538,'313',3.333,5),(168,7556,7538,'13f',3.333,5),(168,7557,7538,'3f3',3.333,5),(168,7558,7538,'f33',3.333,5),(168,7559,7538,'334',3.333,5),(168,7560,7538,'345',3.333,5),(168,7561,7538,'455',3.333,5),(168,7562,7538,'556',3.333,5),(168,7563,7538,'563',3.333,5),(168,7564,7538,'639',3.333,5),(168,7565,7538,'393',3.333,5),(168,7566,7538,'934',3.333,5),(168,7567,7538,'345',3.333,5),(168,7568,7538,'453',3.333,5),(169,7570,7569,'net',25,5),(169,7571,7569,'eta',25,5),(169,7572,7569,'tap',25,5),(169,7573,7569,'app',25,5),(169,7574,7570,'fib',33.333,5),(169,7575,7570,'ibr',33.333,5),(169,7576,7570,'bre',33.333,5),(169,7577,7574,'cha',20,5),(169,7578,7574,'han',20,5),(169,7579,7574,'ann',20,5),(169,7580,7574,'nne',20,5),(169,7581,7574,'nel',20,5),(169,7582,7577,'dis',50,5),(169,7583,7577,'isk',50,5),(169,7584,7582,'naa',100,5),(169,7585,7584,'600',3.333,5),(169,7586,7584,'00a',3.333,5),(169,7587,7584,'0a0',3.333,5),(169,7588,7584,'a09',3.333,5),(169,7589,7584,'098',3.333,5),(169,7590,7584,'980',3.333,5),(169,7591,7584,'804',3.333,5),(169,7592,7584,'044',3.333,5),(169,7593,7584,'443',3.333,5),(169,7594,7584,'430',3.333,5),(169,7595,7584,'307',3.333,5),(169,7596,7584,'072',3.333,5),(169,7597,7584,'725',3.333,5),(169,7598,7584,'259',3.333,5),(169,7599,7584,'593',3.333,5),(169,7600,7584,'931',3.333,5),(169,7601,7584,'313',3.333,5),(169,7602,7584,'13f',3.333,5),(169,7603,7584,'3f3',3.333,5),(169,7604,7584,'f33',3.333,5),(169,7605,7584,'334',3.333,5),(169,7606,7584,'345',3.333,5),(169,7607,7584,'455',3.333,5),(169,7608,7584,'556',3.333,5),(169,7609,7584,'563',3.333,5),(169,7610,7584,'639',3.333,5),(169,7611,7584,'393',3.333,5),(169,7612,7584,'935',3.333,5),(169,7613,7584,'353',3.333,5),(169,7614,7584,'530',3.333,5),(170,7616,7615,'net',25,5),(170,7617,7615,'eta',25,5),(170,7618,7615,'tap',25,5),(170,7619,7615,'app',25,5),(170,7620,7616,'fib',33.333,5),(170,7621,7616,'ibr',33.333,5),(170,7622,7616,'bre',33.333,5),(170,7623,7620,'cha',20,5),(170,7624,7620,'han',20,5),(170,7625,7620,'ann',20,5),(170,7626,7620,'nne',20,5),(170,7627,7620,'nel',20,5),(170,7628,7623,'dis',50,5),(170,7629,7623,'isk',50,5),(170,7630,7628,'naa',100,5),(170,7631,7630,'600',3.333,5),(170,7632,7630,'00a',3.333,5),(170,7633,7630,'0a0',3.333,5),(170,7634,7630,'a09',3.333,5),(170,7635,7630,'098',3.333,5),(170,7636,7630,'980',3.333,5),(170,7637,7630,'804',3.333,5),(170,7638,7630,'044',3.333,5),(170,7639,7630,'443',3.333,5),(170,7640,7630,'430',3.333,5),(170,7641,7630,'307',3.333,5),(170,7642,7630,'072',3.333,5),(170,7643,7630,'725',3.333,5),(170,7644,7630,'259',3.333,5),(170,7645,7630,'593',3.333,5),(170,7646,7630,'931',3.333,5),(170,7647,7630,'313',3.333,5),(170,7648,7630,'13f',3.333,5),(170,7649,7630,'3f3',3.333,5),(170,7650,7630,'f33',3.333,5),(170,7651,7630,'334',3.333,5),(170,7652,7630,'345',3.333,5),(170,7653,7630,'455',3.333,5),(170,7654,7630,'556',3.333,5),(170,7655,7630,'563',3.333,5),(170,7656,7630,'639',3.333,5),(170,7657,7630,'393',3.333,5),(170,7658,7630,'933',3.333,5),(170,7659,7630,'337',3.333,5),(170,7660,7630,'377',3.333,5),(171,7662,7661,'net',25,5),(171,7663,7661,'eta',25,5),(171,7664,7661,'tap',25,5),(171,7665,7661,'app',25,5),(171,7666,7662,'fib',33.333,5),(171,7667,7662,'ibr',33.333,5),(171,7668,7662,'bre',33.333,5),(171,7669,7666,'cha',20,5),(171,7670,7666,'han',20,5),(171,7671,7666,'ann',20,5),(171,7672,7666,'nne',20,5),(171,7673,7666,'nel',20,5),(171,7674,7669,'dis',50,5),(171,7675,7669,'isk',50,5),(171,7676,7674,'naa',100,5),(171,7677,7676,'600',3.333,5),(171,7678,7676,'00a',3.333,5),(171,7679,7676,'0a0',3.333,5),(171,7680,7676,'a09',3.333,5),(171,7681,7676,'098',3.333,5),(171,7682,7676,'980',3.333,5),(171,7683,7676,'804',3.333,5),(171,7684,7676,'044',3.333,5),(171,7685,7676,'443',3.333,5),(171,7686,7676,'430',3.333,5),(171,7687,7676,'307',3.333,5),(171,7688,7676,'072',3.333,5),(171,7689,7676,'725',3.333,5),(171,7690,7676,'259',3.333,5),(171,7691,7676,'593',3.333,5),(171,7692,7676,'931',3.333,5),(171,7693,7676,'313',3.333,5),(171,7694,7676,'13f',3.333,5),(171,7695,7676,'3f3',3.333,5),(171,7696,7676,'f33',3.333,5),(171,7697,7676,'334',3.333,5),(171,7698,7676,'345',3.333,5),(171,7699,7676,'455',3.333,5),(171,7700,7676,'556',3.333,5),(171,7701,7676,'563',3.333,5),(171,7702,7676,'639',3.333,5),(171,7703,7676,'393',3.333,5),(171,7704,7676,'935',3.333,5),(171,7705,7676,'353',3.333,5),(171,7706,7676,'531',3.333,5),(172,7708,7707,'net',25,5),(172,7709,7707,'eta',25,5),(172,7710,7707,'tap',25,5),(172,7711,7707,'app',25,5),(172,7712,7708,'fib',33.333,5),(172,7713,7708,'ibr',33.333,5),(172,7714,7708,'bre',33.333,5),(172,7715,7712,'cha',20,5),(172,7716,7712,'han',20,5),(172,7717,7712,'ann',20,5),(172,7718,7712,'nne',20,5),(172,7719,7712,'nel',20,5),(172,7720,7715,'dis',50,5),(172,7721,7715,'isk',50,5),(172,7722,7720,'naa',100,5),(172,7723,7722,'600',3.333,5),(172,7724,7722,'00a',3.333,5),(172,7725,7722,'0a0',3.333,5),(172,7726,7722,'a09',3.333,5),(172,7727,7722,'098',3.333,5),(172,7728,7722,'980',3.333,5),(172,7729,7722,'804',3.333,5),(172,7730,7722,'044',3.333,5),(172,7731,7722,'443',3.333,5),(172,7732,7722,'430',3.333,5),(172,7733,7722,'307',3.333,5),(172,7734,7722,'072',3.333,5),(172,7735,7722,'725',3.333,5),(172,7736,7722,'259',3.333,5),(172,7737,7722,'593',3.333,5),(172,7738,7722,'931',3.333,5),(172,7739,7722,'313',3.333,5),(172,7740,7722,'13f',3.333,5),(172,7741,7722,'3f3',3.333,5),(172,7742,7722,'f33',3.333,5),(172,7743,7722,'334',3.333,5),(172,7744,7722,'345',3.333,5),(172,7745,7722,'455',3.333,5),(172,7746,7722,'556',3.333,5),(172,7747,7722,'563',3.333,5),(172,7748,7722,'639',3.333,5),(172,7749,7722,'393',3.333,5),(172,7750,7722,'934',3.333,5),(172,7751,7722,'345',3.333,5),(172,7752,7722,'454',3.333,5),(173,7754,7753,'net',25,5),(173,7755,7753,'eta',25,5),(173,7756,7753,'tap',25,5),(173,7757,7753,'app',25,5),(173,7758,7754,'fib',33.333,5),(173,7759,7754,'ibr',33.333,5),(173,7760,7754,'bre',33.333,5),(173,7761,7758,'cha',20,5),(173,7762,7758,'han',20,5),(173,7763,7758,'ann',20,5),(173,7764,7758,'nne',20,5),(173,7765,7758,'nel',20,5),(173,7766,7761,'dis',50,5),(173,7767,7761,'isk',50,5),(173,7768,7766,'naa',100,5),(173,7769,7768,'600',3.333,5),(173,7770,7768,'00a',3.333,5),(173,7771,7768,'0a0',3.333,5),(173,7772,7768,'a09',3.333,5),(173,7773,7768,'098',3.333,5),(173,7774,7768,'980',3.333,5),(173,7775,7768,'804',3.333,5),(173,7776,7768,'044',3.333,5),(173,7777,7768,'443',3.333,5),(173,7778,7768,'430',3.333,5),(173,7779,7768,'307',3.333,5),(173,7780,7768,'072',3.333,5),(173,7781,7768,'725',3.333,5),(173,7782,7768,'259',3.333,5),(173,7783,7768,'593',3.333,5),(173,7784,7768,'931',3.333,5),(173,7785,7768,'313',3.333,5),(173,7786,7768,'13f',3.333,5),(173,7787,7768,'3f3',3.333,5),(173,7788,7768,'f33',3.333,5),(173,7789,7768,'334',3.333,5),(173,7790,7768,'345',3.333,5),(173,7791,7768,'455',3.333,5),(173,7792,7768,'556',3.333,5),(173,7793,7768,'563',3.333,5),(173,7794,7768,'639',3.333,5),(173,7795,7768,'393',3.333,5),(173,7796,7768,'933',3.333,5),(173,7797,7768,'337',3.333,5),(173,7798,7768,'378',3.333,5),(174,7800,7799,'net',25,5),(174,7801,7799,'eta',25,5),(174,7802,7799,'tap',25,5),(174,7803,7799,'app',25,5),(174,7804,7800,'fib',33.333,5),(174,7805,7800,'ibr',33.333,5),(174,7806,7800,'bre',33.333,5),(174,7807,7804,'cha',20,5),(174,7808,7804,'han',20,5),(174,7809,7804,'ann',20,5),(174,7810,7804,'nne',20,5),(174,7811,7804,'nel',20,5),(174,7812,7807,'dis',50,5),(174,7813,7807,'isk',50,5),(174,7814,7812,'naa',100,5),(174,7815,7814,'600',3.333,5),(174,7816,7814,'00a',3.333,5),(174,7817,7814,'0a0',3.333,5),(174,7818,7814,'a09',3.333,5),(174,7819,7814,'098',3.333,5),(174,7820,7814,'980',3.333,5),(174,7821,7814,'804',3.333,5),(174,7822,7814,'044',3.333,5),(174,7823,7814,'443',3.333,5),(174,7824,7814,'430',3.333,5),(174,7825,7814,'307',3.333,5),(174,7826,7814,'072',3.333,5),(174,7827,7814,'725',3.333,5),(174,7828,7814,'259',3.333,5),(174,7829,7814,'593',3.333,5),(174,7830,7814,'931',3.333,5),(174,7831,7814,'313',3.333,5),(174,7832,7814,'13f',3.333,5),(174,7833,7814,'3f3',3.333,5),(174,7834,7814,'f33',3.333,5),(174,7835,7814,'334',3.333,5),(174,7836,7814,'345',3.333,5),(174,7837,7814,'455',3.333,5),(174,7838,7814,'556',3.333,5),(174,7839,7814,'563',3.333,5),(174,7840,7814,'639',3.333,5),(174,7841,7814,'393',3.333,5),(174,7842,7814,'935',3.333,5),(174,7843,7814,'353',3.333,5),(174,7844,7814,'532',3.333,5),(175,7846,7845,'net',25,5),(175,7847,7845,'eta',25,5),(175,7848,7845,'tap',25,5),(175,7849,7845,'app',25,5),(175,7850,7846,'fib',33.333,5),(175,7851,7846,'ibr',33.333,5),(175,7852,7846,'bre',33.333,5),(175,7853,7850,'cha',20,5),(175,7854,7850,'han',20,5),(175,7855,7850,'ann',20,5),(175,7856,7850,'nne',20,5),(175,7857,7850,'nel',20,5),(175,7858,7853,'dis',50,5),(175,7859,7853,'isk',50,5),(175,7860,7858,'naa',100,5),(175,7861,7860,'600',3.333,5),(175,7862,7860,'00a',3.333,5),(175,7863,7860,'0a0',3.333,5),(175,7864,7860,'a09',3.333,5),(175,7865,7860,'098',3.333,5),(175,7866,7860,'980',3.333,5),(175,7867,7860,'804',3.333,5),(175,7868,7860,'044',3.333,5),(175,7869,7860,'443',3.333,5),(175,7870,7860,'430',3.333,5),(175,7871,7860,'307',3.333,5),(175,7872,7860,'072',3.333,5),(175,7873,7860,'725',3.333,5),(175,7874,7860,'259',3.333,5),(175,7875,7860,'593',3.333,5),(175,7876,7860,'931',3.333,5),(175,7877,7860,'313',3.333,5),(175,7878,7860,'13f',3.333,5),(175,7879,7860,'3f3',3.333,5),(175,7880,7860,'f33',3.333,5),(175,7881,7860,'334',3.333,5),(175,7882,7860,'345',3.333,5),(175,7883,7860,'455',3.333,5),(175,7884,7860,'556',3.333,5),(175,7885,7860,'563',3.333,5),(175,7886,7860,'639',3.333,5),(175,7887,7860,'393',3.333,5),(175,7888,7860,'934',3.333,5),(175,7889,7860,'345',3.333,5),(175,7890,7860,'455',3.333,5),(176,7892,7891,'net',25,5),(176,7893,7891,'eta',25,5),(176,7894,7891,'tap',25,5),(176,7895,7891,'app',25,5),(176,7896,7892,'fib',33.333,5),(176,7897,7892,'ibr',33.333,5),(176,7898,7892,'bre',33.333,5),(176,7899,7896,'cha',20,5),(176,7900,7896,'han',20,5),(176,7901,7896,'ann',20,5),(176,7902,7896,'nne',20,5),(176,7903,7896,'nel',20,5),(176,7904,7899,'dis',50,5),(176,7905,7899,'isk',50,5),(176,7906,7904,'naa',100,5),(176,7907,7906,'600',3.333,5),(176,7908,7906,'00a',3.333,5),(176,7909,7906,'0a0',3.333,5),(176,7910,7906,'a09',3.333,5),(176,7911,7906,'098',3.333,5),(176,7912,7906,'980',3.333,5),(176,7913,7906,'804',3.333,5),(176,7914,7906,'044',3.333,5),(176,7915,7906,'443',3.333,5),(176,7916,7906,'430',3.333,5),(176,7917,7906,'307',3.333,5),(176,7918,7906,'072',3.333,5),(176,7919,7906,'725',3.333,5),(176,7920,7906,'259',3.333,5),(176,7921,7906,'593',3.333,5),(176,7922,7906,'931',3.333,5),(176,7923,7906,'313',3.333,5),(176,7924,7906,'13f',3.333,5),(176,7925,7906,'3f3',3.333,5),(176,7926,7906,'f33',3.333,5),(176,7927,7906,'334',3.333,5),(176,7928,7906,'345',3.333,5),(176,7929,7906,'455',3.333,5),(176,7930,7906,'556',3.333,5),(176,7931,7906,'563',3.333,5),(176,7932,7906,'639',3.333,5),(176,7933,7906,'393',3.333,5),(176,7934,7906,'933',3.333,5),(176,7935,7906,'337',3.333,5),(176,7936,7906,'379',3.333,5),(177,7938,7937,'net',25,5),(177,7939,7937,'eta',25,5),(177,7940,7937,'tap',25,5),(177,7941,7937,'app',25,5),(177,7942,7938,'fib',33.333,5),(177,7943,7938,'ibr',33.333,5),(177,7944,7938,'bre',33.333,5),(177,7945,7942,'cha',20,5),(177,7946,7942,'han',20,5),(177,7947,7942,'ann',20,5),(177,7948,7942,'nne',20,5),(177,7949,7942,'nel',20,5),(177,7950,7945,'dis',50,5),(177,7951,7945,'isk',50,5),(177,7952,7950,'naa',100,5),(177,7953,7952,'600',3.333,5),(177,7954,7952,'00a',3.333,5),(177,7955,7952,'0a0',3.333,5),(177,7956,7952,'a09',3.333,5),(177,7957,7952,'098',3.333,5),(177,7958,7952,'980',3.333,5),(177,7959,7952,'804',3.333,5),(177,7960,7952,'044',3.333,5),(177,7961,7952,'443',3.333,5),(177,7962,7952,'430',3.333,5),(177,7963,7952,'307',3.333,5),(177,7964,7952,'072',3.333,5),(177,7965,7952,'725',3.333,5),(177,7966,7952,'259',3.333,5),(177,7967,7952,'593',3.333,5),(177,7968,7952,'931',3.333,5),(177,7969,7952,'313',3.333,5),(177,7970,7952,'13f',3.333,5),(177,7971,7952,'3f3',3.333,5),(177,7972,7952,'f33',3.333,5),(177,7973,7952,'334',3.333,5),(177,7974,7952,'345',3.333,5),(177,7975,7952,'455',3.333,5),(177,7976,7952,'556',3.333,5),(177,7977,7952,'563',3.333,5),(177,7978,7952,'639',3.333,5),(177,7979,7952,'393',3.333,5),(177,7980,7952,'935',3.333,5),(177,7981,7952,'353',3.333,5),(177,7982,7952,'533',3.333,5),(178,7984,7983,'net',25,5),(178,7985,7983,'eta',25,5),(178,7986,7983,'tap',25,5),(178,7987,7983,'app',25,5),(178,7988,7984,'fib',33.333,5),(178,7989,7984,'ibr',33.333,5),(178,7990,7984,'bre',33.333,5),(178,7991,7988,'cha',20,5),(178,7992,7988,'han',20,5),(178,7993,7988,'ann',20,5),(178,7994,7988,'nne',20,5),(178,7995,7988,'nel',20,5),(178,7996,7991,'dis',50,5),(178,7997,7991,'isk',50,5),(178,7998,7996,'naa',100,5),(178,7999,7998,'600',3.333,5),(178,8000,7998,'00a',3.333,5),(178,8001,7998,'0a0',3.333,5),(178,8002,7998,'a09',3.333,5),(178,8003,7998,'098',3.333,5),(178,8004,7998,'980',3.333,5),(178,8005,7998,'804',3.333,5),(178,8006,7998,'044',3.333,5),(178,8007,7998,'443',3.333,5),(178,8008,7998,'430',3.333,5),(178,8009,7998,'307',3.333,5),(178,8010,7998,'072',3.333,5),(178,8011,7998,'725',3.333,5),(178,8012,7998,'259',3.333,5),(178,8013,7998,'593',3.333,5),(178,8014,7998,'931',3.333,5),(178,8015,7998,'313',3.333,5),(178,8016,7998,'13f',3.333,5),(178,8017,7998,'3f3',3.333,5),(178,8018,7998,'f33',3.333,5),(178,8019,7998,'334',3.333,5),(178,8020,7998,'345',3.333,5),(178,8021,7998,'455',3.333,5),(178,8022,7998,'556',3.333,5),(178,8023,7998,'563',3.333,5),(178,8024,7998,'639',3.333,5),(178,8025,7998,'393',3.333,5),(178,8026,7998,'934',3.333,5),(178,8027,7998,'345',3.333,5),(178,8028,7998,'456',3.333,5),(179,8030,8029,'net',25,5),(179,8031,8029,'eta',25,5),(179,8032,8029,'tap',25,5),(179,8033,8029,'app',25,5),(179,8034,8030,'fib',33.333,5),(179,8035,8030,'ibr',33.333,5),(179,8036,8030,'bre',33.333,5),(179,8037,8034,'cha',20,5),(179,8038,8034,'han',20,5),(179,8039,8034,'ann',20,5),(179,8040,8034,'nne',20,5),(179,8041,8034,'nel',20,5),(179,8042,8037,'dis',50,5),(179,8043,8037,'isk',50,5),(179,8044,8042,'naa',100,5),(179,8045,8044,'600',3.333,5),(179,8046,8044,'00a',3.333,5),(179,8047,8044,'0a0',3.333,5),(179,8048,8044,'a09',3.333,5),(179,8049,8044,'098',3.333,5),(179,8050,8044,'980',3.333,5),(179,8051,8044,'804',3.333,5),(179,8052,8044,'044',3.333,5),(179,8053,8044,'443',3.333,5),(179,8054,8044,'430',3.333,5),(179,8055,8044,'307',3.333,5),(179,8056,8044,'072',3.333,5),(179,8057,8044,'725',3.333,5),(179,8058,8044,'259',3.333,5),(179,8059,8044,'593',3.333,5),(179,8060,8044,'931',3.333,5),(179,8061,8044,'313',3.333,5),(179,8062,8044,'13f',3.333,5),(179,8063,8044,'3f3',3.333,5),(179,8064,8044,'f33',3.333,5),(179,8065,8044,'334',3.333,5),(179,8066,8044,'345',3.333,5),(179,8067,8044,'455',3.333,5),(179,8068,8044,'556',3.333,5),(179,8069,8044,'563',3.333,5),(179,8070,8044,'639',3.333,5),(179,8071,8044,'393',3.333,5),(179,8072,8044,'935',3.333,5),(179,8073,8044,'353',3.333,5),(179,8074,8044,'534',3.333,5),(180,8076,8075,'net',25,5),(180,8077,8075,'eta',25,5),(180,8078,8075,'tap',25,5),(180,8079,8075,'app',25,5),(180,8080,8076,'fib',33.333,5),(180,8081,8076,'ibr',33.333,5),(180,8082,8076,'bre',33.333,5),(180,8083,8080,'cha',20,5),(180,8084,8080,'han',20,5),(180,8085,8080,'ann',20,5),(180,8086,8080,'nne',20,5),(180,8087,8080,'nel',20,5),(180,8088,8083,'dis',50,5),(180,8089,8083,'isk',50,5),(180,8090,8088,'naa',100,5),(180,8091,8090,'600',3.333,5),(180,8092,8090,'00a',3.333,5),(180,8093,8090,'0a0',3.333,5),(180,8094,8090,'a09',3.333,5),(180,8095,8090,'098',3.333,5),(180,8096,8090,'980',3.333,5),(180,8097,8090,'804',3.333,5),(180,8098,8090,'044',3.333,5),(180,8099,8090,'443',3.333,5),(180,8100,8090,'430',3.333,5),(180,8101,8090,'307',3.333,5),(180,8102,8090,'072',3.333,5),(180,8103,8090,'725',3.333,5),(180,8104,8090,'259',3.333,5),(180,8105,8090,'593',3.333,5),(180,8106,8090,'931',3.333,5),(180,8107,8090,'313',3.333,5),(180,8108,8090,'13f',3.333,5),(180,8109,8090,'3f3',3.333,5),(180,8110,8090,'f33',3.333,5),(180,8111,8090,'334',3.333,5),(180,8112,8090,'345',3.333,5),(180,8113,8090,'455',3.333,5),(180,8114,8090,'556',3.333,5),(180,8115,8090,'563',3.333,5),(180,8116,8090,'639',3.333,5),(180,8117,8090,'393',3.333,5),(180,8118,8090,'934',3.333,5),(180,8119,8090,'345',3.333,5),(180,8120,8090,'457',3.333,5),(181,8122,8121,'net',25,5),(181,8123,8121,'eta',25,5),(181,8124,8121,'tap',25,5),(181,8125,8121,'app',25,5),(181,8126,8122,'fib',33.333,5),(181,8127,8122,'ibr',33.333,5),(181,8128,8122,'bre',33.333,5),(181,8129,8126,'cha',20,5),(181,8130,8126,'han',20,5),(181,8131,8126,'ann',20,5),(181,8132,8126,'nne',20,5),(181,8133,8126,'nel',20,5),(181,8134,8129,'dis',50,5),(181,8135,8129,'isk',50,5),(181,8136,8134,'naa',100,5),(181,8137,8136,'600',3.333,5),(181,8138,8136,'00a',3.333,5),(181,8139,8136,'0a0',3.333,5),(181,8140,8136,'a09',3.333,5),(181,8141,8136,'098',3.333,5),(181,8142,8136,'980',3.333,5),(181,8143,8136,'804',3.333,5),(181,8144,8136,'044',3.333,5),(181,8145,8136,'443',3.333,5),(181,8146,8136,'430',3.333,5),(181,8147,8136,'307',3.333,5),(181,8148,8136,'072',3.333,5),(181,8149,8136,'725',3.333,5),(181,8150,8136,'259',3.333,5),(181,8151,8136,'593',3.333,5),(181,8152,8136,'931',3.333,5),(181,8153,8136,'313',3.333,5),(181,8154,8136,'13f',3.333,5),(181,8155,8136,'3f3',3.333,5),(181,8156,8136,'f33',3.333,5),(181,8157,8136,'334',3.333,5),(181,8158,8136,'345',3.333,5),(181,8159,8136,'455',3.333,5),(181,8160,8136,'556',3.333,5),(181,8161,8136,'563',3.333,5),(181,8162,8136,'639',3.333,5),(181,8163,8136,'393',3.333,5),(181,8164,8136,'934',3.333,5),(181,8165,8136,'345',3.333,5),(181,8166,8136,'458',3.333,5),(182,8168,8167,'net',25,5),(182,8169,8167,'eta',25,5),(182,8170,8167,'tap',25,5),(182,8171,8167,'app',25,5),(182,8172,8168,'fib',33.333,5),(182,8173,8168,'ibr',33.333,5),(182,8174,8168,'bre',33.333,5),(182,8175,8172,'cha',20,5),(182,8176,8172,'han',20,5),(182,8177,8172,'ann',20,5),(182,8178,8172,'nne',20,5),(182,8179,8172,'nel',20,5),(182,8180,8175,'dis',50,5),(182,8181,8175,'isk',50,5),(182,8182,8180,'naa',100,5),(182,8183,8182,'600',3.333,5),(182,8184,8182,'00a',3.333,5),(182,8185,8182,'0a0',3.333,5),(182,8186,8182,'a09',3.333,5),(182,8187,8182,'098',3.333,5),(182,8188,8182,'980',3.333,5),(182,8189,8182,'804',3.333,5),(182,8190,8182,'044',3.333,5),(182,8191,8182,'443',3.333,5),(182,8192,8182,'430',3.333,5),(182,8193,8182,'307',3.333,5),(182,8194,8182,'072',3.333,5),(182,8195,8182,'725',3.333,5),(182,8196,8182,'259',3.333,5),(182,8197,8182,'593',3.333,5),(182,8198,8182,'931',3.333,5),(182,8199,8182,'313',3.333,5),(182,8200,8182,'13f',3.333,5),(182,8201,8182,'3f3',3.333,5),(182,8202,8182,'f33',3.333,5),(182,8203,8182,'334',3.333,5),(182,8204,8182,'345',3.333,5),(182,8205,8182,'455',3.333,5),(182,8206,8182,'556',3.333,5),(182,8207,8182,'563',3.333,5),(182,8208,8182,'639',3.333,5),(182,8209,8182,'393',3.333,5),(182,8210,8182,'934',3.333,5),(182,8211,8182,'345',3.333,5),(182,8212,8182,'459',3.333,5),(183,8214,8213,'net',25,5),(183,8215,8213,'eta',25,5),(183,8216,8213,'tap',25,5),(183,8217,8213,'app',25,5),(183,8218,8214,'fib',33.333,5),(183,8219,8214,'ibr',33.333,5),(183,8220,8214,'bre',33.333,5),(183,8221,8218,'cha',20,5),(183,8222,8218,'han',20,5),(183,8223,8218,'ann',20,5),(183,8224,8218,'nne',20,5),(183,8225,8218,'nel',20,5),(183,8226,8221,'dis',50,5),(183,8227,8221,'isk',50,5),(183,8228,8226,'naa',100,5),(183,8229,8228,'600',3.333,5),(183,8230,8228,'00a',3.333,5),(183,8231,8228,'0a0',3.333,5),(183,8232,8228,'a09',3.333,5),(183,8233,8228,'098',3.333,5),(183,8234,8228,'980',3.333,5),(183,8235,8228,'804',3.333,5),(183,8236,8228,'044',3.333,5),(183,8237,8228,'443',3.333,5),(183,8238,8228,'430',3.333,5),(183,8239,8228,'307',3.333,5),(183,8240,8228,'072',3.333,5),(183,8241,8228,'725',3.333,5),(183,8242,8228,'259',3.333,5),(183,8243,8228,'593',3.333,5),(183,8244,8228,'931',3.333,5),(183,8245,8228,'313',3.333,5),(183,8246,8228,'13f',3.333,5),(183,8247,8228,'3f3',3.333,5),(183,8248,8228,'f33',3.333,5),(183,8249,8228,'334',3.333,5),(183,8250,8228,'345',3.333,5),(183,8251,8228,'455',3.333,5),(183,8252,8228,'556',3.333,5),(183,8253,8228,'563',3.333,5),(183,8254,8228,'638',3.333,5),(183,8255,8228,'387',3.333,5),(183,8256,8228,'872',3.333,5),(183,8257,8228,'725',3.333,5),(183,8258,8228,'250',3.333,5),(184,8260,8259,'net',25,5),(184,8261,8259,'eta',25,5),(184,8262,8259,'tap',25,5),(184,8263,8259,'app',25,5),(184,8264,8260,'fib',33.333,5),(184,8265,8260,'ibr',33.333,5),(184,8266,8260,'bre',33.333,5),(184,8267,8264,'cha',20,5),(184,8268,8264,'han',20,5),(184,8269,8264,'ann',20,5),(184,8270,8264,'nne',20,5),(184,8271,8264,'nel',20,5),(184,8272,8267,'dis',50,5),(184,8273,8267,'isk',50,5),(184,8274,8272,'naa',100,5),(184,8275,8274,'600',3.333,5),(184,8276,8274,'00a',3.333,5),(184,8277,8274,'0a0',3.333,5),(184,8278,8274,'a09',3.333,5),(184,8279,8274,'098',3.333,5),(184,8280,8274,'980',3.333,5),(184,8281,8274,'804',3.333,5),(184,8282,8274,'044',3.333,5),(184,8283,8274,'443',3.333,5),(184,8284,8274,'430',3.333,5),(184,8285,8274,'307',3.333,5),(184,8286,8274,'072',3.333,5),(184,8287,8274,'725',3.333,5),(184,8288,8274,'259',3.333,5),(184,8289,8274,'593',3.333,5),(184,8290,8274,'931',3.333,5),(184,8291,8274,'313',3.333,5),(184,8292,8274,'13f',3.333,5),(184,8293,8274,'3f3',3.333,5),(184,8294,8274,'f33',3.333,5),(184,8295,8274,'334',3.333,5),(184,8296,8274,'345',3.333,5),(184,8297,8274,'455',3.333,5),(184,8298,8274,'556',3.333,5),(184,8299,8274,'563',3.333,5),(184,8300,8274,'638',3.333,5),(184,8301,8274,'387',3.333,5),(184,8302,8274,'872',3.333,5),(184,8303,8274,'725',3.333,5),(184,8304,8274,'251',3.333,5),(185,8306,8305,'net',25,5),(185,8307,8305,'eta',25,5),(185,8308,8305,'tap',25,5),(185,8309,8305,'app',25,5),(185,8310,8306,'fib',33.333,5),(185,8311,8306,'ibr',33.333,5),(185,8312,8306,'bre',33.333,5),(185,8313,8310,'cha',20,5),(185,8314,8310,'han',20,5),(185,8315,8310,'ann',20,5),(185,8316,8310,'nne',20,5),(185,8317,8310,'nel',20,5),(185,8318,8313,'dis',50,5),(185,8319,8313,'isk',50,5),(185,8320,8318,'naa',100,5),(185,8321,8320,'600',3.333,5),(185,8322,8320,'00a',3.333,5),(185,8323,8320,'0a0',3.333,5),(185,8324,8320,'a09',3.333,5),(185,8325,8320,'098',3.333,5),(185,8326,8320,'980',3.333,5),(185,8327,8320,'804',3.333,5),(185,8328,8320,'044',3.333,5),(185,8329,8320,'443',3.333,5),(185,8330,8320,'430',3.333,5),(185,8331,8320,'307',3.333,5),(185,8332,8320,'072',3.333,5),(185,8333,8320,'725',3.333,5),(185,8334,8320,'259',3.333,5),(185,8335,8320,'593',3.333,5),(185,8336,8320,'931',3.333,5),(185,8337,8320,'313',3.333,5),(185,8338,8320,'13f',3.333,5),(185,8339,8320,'3f3',3.333,5),(185,8340,8320,'f33',3.333,5),(185,8341,8320,'334',3.333,5),(185,8342,8320,'345',3.333,5),(185,8343,8320,'455',3.333,5),(185,8344,8320,'556',3.333,5),(185,8345,8320,'563',3.333,5),(185,8346,8320,'638',3.333,5),(185,8347,8320,'387',3.333,5),(185,8348,8320,'872',3.333,5),(185,8349,8320,'725',3.333,5),(185,8350,8320,'252',3.333,5),(186,8352,8351,'net',25,5),(186,8353,8351,'eta',25,5),(186,8354,8351,'tap',25,5),(186,8355,8351,'app',25,5),(186,8356,8352,'fib',33.333,5),(186,8357,8352,'ibr',33.333,5),(186,8358,8352,'bre',33.333,5),(186,8359,8356,'cha',20,5),(186,8360,8356,'han',20,5),(186,8361,8356,'ann',20,5),(186,8362,8356,'nne',20,5),(186,8363,8356,'nel',20,5),(186,8364,8359,'dis',50,5),(186,8365,8359,'isk',50,5),(186,8366,8364,'naa',100,5),(186,8367,8366,'600',3.333,5),(186,8368,8366,'00a',3.333,5),(186,8369,8366,'0a0',3.333,5),(186,8370,8366,'a09',3.333,5),(186,8371,8366,'098',3.333,5),(186,8372,8366,'980',3.333,5),(186,8373,8366,'804',3.333,5),(186,8374,8366,'044',3.333,5),(186,8375,8366,'443',3.333,5),(186,8376,8366,'430',3.333,5),(186,8377,8366,'307',3.333,5),(186,8378,8366,'072',3.333,5),(186,8379,8366,'725',3.333,5),(186,8380,8366,'259',3.333,5),(186,8381,8366,'593',3.333,5),(186,8382,8366,'931',3.333,5),(186,8383,8366,'313',3.333,5),(186,8384,8366,'13f',3.333,5),(186,8385,8366,'3f3',3.333,5),(186,8386,8366,'f33',3.333,5),(186,8387,8366,'334',3.333,5),(186,8388,8366,'345',3.333,5),(186,8389,8366,'455',3.333,5),(186,8390,8366,'556',3.333,5),(186,8391,8366,'563',3.333,5),(186,8392,8366,'639',3.333,5),(186,8393,8366,'393',3.333,5),(186,8394,8366,'933',3.333,5),(186,8395,8366,'337',3.333,5),(186,8396,8366,'37a',3.333,5),(187,8398,8397,'net',25,5),(187,8399,8397,'eta',25,5),(187,8400,8397,'tap',25,5),(187,8401,8397,'app',25,5),(187,8402,8398,'fib',33.333,5),(187,8403,8398,'ibr',33.333,5),(187,8404,8398,'bre',33.333,5),(187,8405,8402,'cha',20,5),(187,8406,8402,'han',20,5),(187,8407,8402,'ann',20,5),(187,8408,8402,'nne',20,5),(187,8409,8402,'nel',20,5),(187,8410,8405,'dis',50,5),(187,8411,8405,'isk',50,5),(187,8412,8410,'naa',100,5),(187,8413,8412,'600',3.333,5),(187,8414,8412,'00a',3.333,5),(187,8415,8412,'0a0',3.333,5),(187,8416,8412,'a09',3.333,5),(187,8417,8412,'098',3.333,5),(187,8418,8412,'980',3.333,5),(187,8419,8412,'804',3.333,5),(187,8420,8412,'044',3.333,5),(187,8421,8412,'443',3.333,5),(187,8422,8412,'430',3.333,5),(187,8423,8412,'307',3.333,5),(187,8424,8412,'072',3.333,5),(187,8425,8412,'725',3.333,5),(187,8426,8412,'259',3.333,5),(187,8427,8412,'593',3.333,5),(187,8428,8412,'931',3.333,5),(187,8429,8412,'313',3.333,5),(187,8430,8412,'13f',3.333,5),(187,8431,8412,'3f3',3.333,5),(187,8432,8412,'f33',3.333,5),(187,8433,8412,'334',3.333,5),(187,8434,8412,'345',3.333,5),(187,8435,8412,'455',3.333,5),(187,8436,8412,'556',3.333,5),(187,8437,8412,'563',3.333,5),(187,8438,8412,'639',3.333,5),(187,8439,8412,'393',3.333,5),(187,8440,8412,'934',3.333,5),(187,8441,8412,'345',3.333,5),(187,8442,8412,'45a',3.333,5),(188,8444,8443,'net',25,5),(188,8445,8443,'eta',25,5),(188,8446,8443,'tap',25,5),(188,8447,8443,'app',25,5),(188,8448,8444,'ser',25,5),(188,8449,8444,'eri',25,5),(188,8450,8444,'ria',25,5),(188,8451,8444,'ial',25,5),(188,8452,8448,'att',16.667,5),(188,8453,8448,'tta',16.667,5),(188,8454,8448,'tac',16.667,5),(188,8455,8448,'ach',16.667,5),(188,8456,8448,'che',16.667,5),(188,8457,8448,'hed',16.667,5),(188,8458,8452,'scs',50,5),(188,8459,8452,'csi',50,5),(188,8460,8458,'dis',50,5),(188,8461,8458,'isk',50,5),(188,8462,8460,'naa',100,5),(188,8463,8462,'600',3.333,5),(188,8464,8462,'00a',3.333,5),(188,8465,8462,'0a0',3.333,5),(188,8466,8462,'a09',3.333,5),(188,8467,8462,'098',3.333,5),(188,8468,8462,'980',3.333,5),(188,8469,8462,'805',3.333,5),(188,8470,8462,'052',3.333,5),(188,8471,8462,'527',3.333,5),(188,8472,8462,'27b',3.333,5),(188,8473,8462,'7b8',3.333,5),(188,8474,8462,'b84',3.333,5),(188,8475,8462,'84e',3.333,5),(188,8476,8462,'4ee',3.333,5),(188,8477,8462,'eeb',3.333,5),(188,8478,8462,'eba',3.333,5),(188,8479,8462,'bad',3.333,5),(188,8480,8462,'ad7',3.333,5),(188,8481,8462,'d74',3.333,5),(188,8482,8462,'742',3.333,5),(188,8483,8462,'421',3.333,5),(188,8484,8462,'211',3.333,5),(188,8485,8462,'117',3.333,5),(188,8486,8462,'17b',3.333,5),(188,8487,8462,'7b0',3.333,5),(188,8488,8462,'b0f',3.333,5),(188,8489,8462,'0fa',3.333,5),(188,8490,8462,'fab',3.333,5),(188,8491,8462,'aba',3.333,5),(188,8492,8462,'ba2',3.333,5),(189,8494,8493,'net',25,5),(189,8495,8493,'eta',25,5),(189,8496,8493,'tap',25,5),(189,8497,8493,'app',25,5),(189,8498,8494,'ser',25,5),(189,8499,8494,'eri',25,5),(189,8500,8494,'ria',25,5),(189,8501,8494,'ial',25,5),(189,8502,8498,'att',16.667,5),(189,8503,8498,'tta',16.667,5),(189,8504,8498,'tac',16.667,5),(189,8505,8498,'ach',16.667,5),(189,8506,8498,'che',16.667,5),(189,8507,8498,'hed',16.667,5),(189,8508,8502,'scs',50,5),(189,8509,8502,'csi',50,5),(189,8510,8508,'dis',50,5),(189,8511,8508,'isk',50,5),(189,8512,8510,'naa',100,5),(189,8513,8512,'600',3.333,5),(189,8514,8512,'00a',3.333,5),(189,8515,8512,'0a0',3.333,5),(189,8516,8512,'a09',3.333,5),(189,8517,8512,'098',3.333,5),(189,8518,8512,'980',3.333,5),(189,8519,8512,'807',3.333,5),(189,8520,8512,'078',3.333,5),(189,8521,8512,'785',3.333,5),(189,8522,8512,'853',3.333,5),(189,8523,8512,'538',3.333,5),(189,8524,8512,'383',3.333,5),(189,8525,8512,'83e',3.333,5),(189,8526,8512,'3ee',3.333,5),(189,8527,8512,'eee',3.333,5),(189,8528,8512,'ee6',3.333,5),(189,8529,8512,'e61',3.333,5),(189,8530,8512,'617',3.333,5),(189,8531,8512,'174',3.333,5),(189,8532,8512,'74a',3.333,5),(189,8533,8512,'4a1',3.333,5),(189,8534,8512,'a11',3.333,5),(189,8535,8512,'117',3.333,5),(189,8536,8512,'17b',3.333,5),(189,8537,8512,'7b0',3.333,5),(189,8538,8512,'b01',3.333,5),(189,8539,8512,'01a',3.333,5),(189,8540,8512,'1ab',3.333,5),(189,8541,8512,'aba',3.333,5),(189,8542,8512,'ba2',3.333,5),(190,8544,8543,'net',25,5),(190,8545,8543,'eta',25,5),(190,8546,8543,'tap',25,5),(190,8547,8543,'app',25,5),(190,8548,8544,'fib',33.333,5),(190,8549,8544,'ibr',33.333,5),(190,8550,8544,'bre',33.333,5),(190,8551,8548,'cha',20,5),(190,8552,8548,'han',20,5),(190,8553,8548,'ann',20,5),(190,8554,8548,'nne',20,5),(190,8555,8548,'nel',20,5),(190,8556,8551,'dis',50,5),(190,8557,8551,'isk',50,5),(190,8558,8556,'naa',100,5),(190,8559,8558,'600',3.333,5),(190,8560,8558,'00a',3.333,5),(190,8561,8558,'0a0',3.333,5),(190,8562,8558,'a09',3.333,5),(190,8563,8558,'098',3.333,5),(190,8564,8558,'980',3.333,5),(190,8565,8558,'804',3.333,5),(190,8566,8558,'044',3.333,5),(190,8567,8558,'443',3.333,5),(190,8568,8558,'430',3.333,5),(190,8569,8558,'307',3.333,5),(190,8570,8558,'075',3.333,5),(190,8571,8558,'753',3.333,5),(190,8572,8558,'535',3.333,5),(190,8573,8558,'357',3.333,5),(190,8574,8558,'573',3.333,5),(190,8575,8558,'732',3.333,5),(190,8576,8558,'32b',3.333,5),(190,8577,8558,'2b3',3.333,5),(190,8578,8558,'b33',3.333,5),(190,8579,8558,'334',3.333,5),(190,8580,8558,'345',3.333,5),(190,8581,8558,'457',3.333,5),(190,8582,8558,'571',3.333,5),(190,8583,8558,'715',3.333,5),(190,8584,8558,'153',3.333,5),(190,8585,8558,'533',3.333,5),(190,8586,8558,'336',3.333,5),(190,8587,8558,'366',3.333,5),(190,8588,8558,'661',3.333,5),(191,8590,8589,'net',25,5),(191,8591,8589,'eta',25,5),(191,8592,8589,'tap',25,5),(191,8593,8589,'app',25,5),(191,8594,8590,'fib',33.333,5),(191,8595,8590,'ibr',33.333,5),(191,8596,8590,'bre',33.333,5),(191,8597,8594,'cha',20,5),(191,8598,8594,'han',20,5),(191,8599,8594,'ann',20,5),(191,8600,8594,'nne',20,5),(191,8601,8594,'nel',20,5),(191,8602,8597,'dis',50,5),(191,8603,8597,'isk',50,5),(191,8604,8602,'naa',100,5),(191,8605,8604,'600',3.333,5),(191,8606,8604,'00a',3.333,5),(191,8607,8604,'0a0',3.333,5),(191,8608,8604,'a09',3.333,5),(191,8609,8604,'098',3.333,5),(191,8610,8604,'980',3.333,5),(191,8611,8604,'804',3.333,5),(191,8612,8604,'044',3.333,5),(191,8613,8604,'443',3.333,5),(191,8614,8604,'430',3.333,5),(191,8615,8604,'307',3.333,5),(191,8616,8604,'075',3.333,5),(191,8617,8604,'753',3.333,5),(191,8618,8604,'535',3.333,5),(191,8619,8604,'357',3.333,5),(191,8620,8604,'573',3.333,5),(191,8621,8604,'732',3.333,5),(191,8622,8604,'32b',3.333,5),(191,8623,8604,'2b3',3.333,5),(191,8624,8604,'b33',3.333,5),(191,8625,8604,'334',3.333,5),(191,8626,8604,'345',3.333,5),(191,8627,8604,'457',3.333,5),(191,8628,8604,'571',3.333,5),(191,8629,8604,'715',3.333,5),(191,8630,8604,'153',3.333,5),(191,8631,8604,'533',3.333,5),(191,8632,8604,'336',3.333,5),(191,8633,8604,'366',3.333,5),(191,8634,8604,'662',3.333,5),(192,8636,8635,'net',25,5),(192,8637,8635,'eta',25,5),(192,8638,8635,'tap',25,5),(192,8639,8635,'app',25,5),(192,8640,8636,'fib',33.333,5),(192,8641,8636,'ibr',33.333,5),(192,8642,8636,'bre',33.333,5),(192,8643,8640,'cha',20,5),(192,8644,8640,'han',20,5),(192,8645,8640,'ann',20,5),(192,8646,8640,'nne',20,5),(192,8647,8640,'nel',20,5),(192,8648,8643,'dis',50,5),(192,8649,8643,'isk',50,5),(192,8650,8648,'naa',100,5),(192,8651,8650,'600',3.333,5),(192,8652,8650,'00a',3.333,5),(192,8653,8650,'0a0',3.333,5),(192,8654,8650,'a09',3.333,5),(192,8655,8650,'098',3.333,5),(192,8656,8650,'980',3.333,5),(192,8657,8650,'804',3.333,5),(192,8658,8650,'044',3.333,5),(192,8659,8650,'443',3.333,5),(192,8660,8650,'430',3.333,5),(192,8661,8650,'307',3.333,5),(192,8662,8650,'075',3.333,5),(192,8663,8650,'753',3.333,5),(192,8664,8650,'535',3.333,5),(192,8665,8650,'357',3.333,5),(192,8666,8650,'573',3.333,5),(192,8667,8650,'732',3.333,5),(192,8668,8650,'32b',3.333,5),(192,8669,8650,'2b3',3.333,5),(192,8670,8650,'b33',3.333,5),(192,8671,8650,'334',3.333,5),(192,8672,8650,'345',3.333,5),(192,8673,8650,'457',3.333,5),(192,8674,8650,'571',3.333,5),(192,8675,8650,'715',3.333,5),(192,8676,8650,'153',3.333,5),(192,8677,8650,'533',3.333,5),(192,8678,8650,'336',3.333,5),(192,8679,8650,'366',3.333,5),(192,8680,8650,'663',3.333,5),(193,8682,8681,'net',25,5),(193,8683,8681,'eta',25,5),(193,8684,8681,'tap',25,5),(193,8685,8681,'app',25,5),(193,8686,8682,'fib',33.333,5),(193,8687,8682,'ibr',33.333,5),(193,8688,8682,'bre',33.333,5),(193,8689,8686,'cha',20,5),(193,8690,8686,'han',20,5),(193,8691,8686,'ann',20,5),(193,8692,8686,'nne',20,5),(193,8693,8686,'nel',20,5),(193,8694,8689,'dis',50,5),(193,8695,8689,'isk',50,5),(193,8696,8694,'naa',100,5),(193,8697,8696,'600',3.333,5),(193,8698,8696,'00a',3.333,5),(193,8699,8696,'0a0',3.333,5),(193,8700,8696,'a09',3.333,5),(193,8701,8696,'098',3.333,5),(193,8702,8696,'980',3.333,5),(193,8703,8696,'804',3.333,5),(193,8704,8696,'044',3.333,5),(193,8705,8696,'443',3.333,5),(193,8706,8696,'430',3.333,5),(193,8707,8696,'307',3.333,5),(193,8708,8696,'075',3.333,5),(193,8709,8696,'753',3.333,5),(193,8710,8696,'535',3.333,5),(193,8711,8696,'357',3.333,5),(193,8712,8696,'573',3.333,5),(193,8713,8696,'732',3.333,5),(193,8714,8696,'32b',3.333,5),(193,8715,8696,'2b3',3.333,5),(193,8716,8696,'b33',3.333,5),(193,8717,8696,'334',3.333,5),(193,8718,8696,'345',3.333,5),(193,8719,8696,'457',3.333,5),(193,8720,8696,'571',3.333,5),(193,8721,8696,'715',3.333,5),(193,8722,8696,'153',3.333,5),(193,8723,8696,'533',3.333,5),(193,8724,8696,'336',3.333,5),(193,8725,8696,'366',3.333,5),(193,8726,8696,'664',3.333,5),(194,8728,8727,'net',25,5),(194,8729,8727,'eta',25,5),(194,8730,8727,'tap',25,5),(194,8731,8727,'app',25,5),(194,8732,8728,'fib',33.333,5),(194,8733,8728,'ibr',33.333,5),(194,8734,8728,'bre',33.333,5),(194,8735,8732,'cha',20,5),(194,8736,8732,'han',20,5),(194,8737,8732,'ann',20,5),(194,8738,8732,'nne',20,5),(194,8739,8732,'nel',20,5),(194,8740,8735,'dis',50,5),(194,8741,8735,'isk',50,5),(194,8742,8740,'naa',100,5),(194,8743,8742,'600',3.333,5),(194,8744,8742,'00a',3.333,5),(194,8745,8742,'0a0',3.333,5),(194,8746,8742,'a09',3.333,5),(194,8747,8742,'098',3.333,5),(194,8748,8742,'980',3.333,5),(194,8749,8742,'804',3.333,5),(194,8750,8742,'044',3.333,5),(194,8751,8742,'443',3.333,5),(194,8752,8742,'430',3.333,5),(194,8753,8742,'307',3.333,5),(194,8754,8742,'075',3.333,5),(194,8755,8742,'753',3.333,5),(194,8756,8742,'535',3.333,5),(194,8757,8742,'357',3.333,5),(194,8758,8742,'573',3.333,5),(194,8759,8742,'732',3.333,5),(194,8760,8742,'32b',3.333,5),(194,8761,8742,'2b3',3.333,5),(194,8762,8742,'b33',3.333,5),(194,8763,8742,'334',3.333,5),(194,8764,8742,'345',3.333,5),(194,8765,8742,'457',3.333,5),(194,8766,8742,'571',3.333,5),(194,8767,8742,'715',3.333,5),(194,8768,8742,'153',3.333,5),(194,8769,8742,'533',3.333,5),(194,8770,8742,'336',3.333,5),(194,8771,8742,'366',3.333,5),(194,8772,8742,'665',3.333,5),(195,8774,8773,'net',25,5),(195,8775,8773,'eta',25,5),(195,8776,8773,'tap',25,5),(195,8777,8773,'app',25,5),(195,8778,8774,'fib',33.333,5),(195,8779,8774,'ibr',33.333,5),(195,8780,8774,'bre',33.333,5),(195,8781,8778,'cha',20,5),(195,8782,8778,'han',20,5),(195,8783,8778,'ann',20,5),(195,8784,8778,'nne',20,5),(195,8785,8778,'nel',20,5),(195,8786,8781,'dis',50,5),(195,8787,8781,'isk',50,5),(195,8788,8786,'naa',100,5),(195,8789,8788,'600',3.333,5),(195,8790,8788,'00a',3.333,5),(195,8791,8788,'0a0',3.333,5),(195,8792,8788,'a09',3.333,5),(195,8793,8788,'098',3.333,5),(195,8794,8788,'980',3.333,5),(195,8795,8788,'804',3.333,5),(195,8796,8788,'044',3.333,5),(195,8797,8788,'443',3.333,5),(195,8798,8788,'430',3.333,5),(195,8799,8788,'307',3.333,5),(195,8800,8788,'075',3.333,5),(195,8801,8788,'753',3.333,5),(195,8802,8788,'535',3.333,5),(195,8803,8788,'357',3.333,5),(195,8804,8788,'573',3.333,5),(195,8805,8788,'732',3.333,5),(195,8806,8788,'32b',3.333,5),(195,8807,8788,'2b3',3.333,5),(195,8808,8788,'b33',3.333,5),(195,8809,8788,'334',3.333,5),(195,8810,8788,'345',3.333,5),(195,8811,8788,'457',3.333,5),(195,8812,8788,'571',3.333,5),(195,8813,8788,'715',3.333,5),(195,8814,8788,'153',3.333,5),(195,8815,8788,'533',3.333,5),(195,8816,8788,'336',3.333,5),(195,8817,8788,'366',3.333,5),(195,8818,8788,'666',3.333,5),(196,8820,8819,'net',25,5),(196,8821,8819,'eta',25,5),(196,8822,8819,'tap',25,5),(196,8823,8819,'app',25,5),(196,8824,8820,'fib',33.333,5),(196,8825,8820,'ibr',33.333,5),(196,8826,8820,'bre',33.333,5),(196,8827,8824,'cha',20,5),(196,8828,8824,'han',20,5),(196,8829,8824,'ann',20,5),(196,8830,8824,'nne',20,5),(196,8831,8824,'nel',20,5),(196,8832,8827,'dis',50,5),(196,8833,8827,'isk',50,5),(196,8834,8832,'naa',100,5),(196,8835,8834,'600',3.333,5),(196,8836,8834,'00a',3.333,5),(196,8837,8834,'0a0',3.333,5),(196,8838,8834,'a09',3.333,5),(196,8839,8834,'098',3.333,5),(196,8840,8834,'980',3.333,5),(196,8841,8834,'804',3.333,5),(196,8842,8834,'044',3.333,5),(196,8843,8834,'443',3.333,5),(196,8844,8834,'430',3.333,5),(196,8845,8834,'307',3.333,5),(196,8846,8834,'075',3.333,5),(196,8847,8834,'753',3.333,5),(196,8848,8834,'535',3.333,5),(196,8849,8834,'357',3.333,5),(196,8850,8834,'573',3.333,5),(196,8851,8834,'732',3.333,5),(196,8852,8834,'32b',3.333,5),(196,8853,8834,'2b3',3.333,5),(196,8854,8834,'b33',3.333,5),(196,8855,8834,'334',3.333,5),(196,8856,8834,'345',3.333,5),(196,8857,8834,'457',3.333,5),(196,8858,8834,'571',3.333,5),(196,8859,8834,'715',3.333,5),(196,8860,8834,'153',3.333,5),(196,8861,8834,'533',3.333,5),(196,8862,8834,'336',3.333,5),(196,8863,8834,'366',3.333,5),(196,8864,8834,'667',3.333,5),(197,8866,8865,'net',25,5),(197,8867,8865,'eta',25,5),(197,8868,8865,'tap',25,5),(197,8869,8865,'app',25,5),(197,8870,8866,'fib',33.333,5),(197,8871,8866,'ibr',33.333,5),(197,8872,8866,'bre',33.333,5),(197,8873,8870,'cha',20,5),(197,8874,8870,'han',20,5),(197,8875,8870,'ann',20,5),(197,8876,8870,'nne',20,5),(197,8877,8870,'nel',20,5),(197,8878,8873,'dis',50,5),(197,8879,8873,'isk',50,5),(197,8880,8878,'naa',100,5),(197,8881,8880,'600',3.333,5),(197,8882,8880,'00a',3.333,5),(197,8883,8880,'0a0',3.333,5),(197,8884,8880,'a09',3.333,5),(197,8885,8880,'098',3.333,5),(197,8886,8880,'980',3.333,5),(197,8887,8880,'804',3.333,5),(197,8888,8880,'044',3.333,5),(197,8889,8880,'443',3.333,5),(197,8890,8880,'430',3.333,5),(197,8891,8880,'307',3.333,5),(197,8892,8880,'075',3.333,5),(197,8893,8880,'753',3.333,5),(197,8894,8880,'535',3.333,5),(197,8895,8880,'357',3.333,5),(197,8896,8880,'573',3.333,5),(197,8897,8880,'732',3.333,5),(197,8898,8880,'32b',3.333,5),(197,8899,8880,'2b3',3.333,5),(197,8900,8880,'b33',3.333,5),(197,8901,8880,'334',3.333,5),(197,8902,8880,'345',3.333,5),(197,8903,8880,'457',3.333,5),(197,8904,8880,'571',3.333,5),(197,8905,8880,'715',3.333,5),(197,8906,8880,'153',3.333,5),(197,8907,8880,'533',3.333,5),(197,8908,8880,'336',3.333,5),(197,8909,8880,'366',3.333,5),(197,8910,8880,'668',3.333,5),(198,8912,8911,'net',25,5),(198,8913,8911,'eta',25,5),(198,8914,8911,'tap',25,5),(198,8915,8911,'app',25,5),(198,8916,8912,'fib',33.333,5),(198,8917,8912,'ibr',33.333,5),(198,8918,8912,'bre',33.333,5),(198,8919,8916,'cha',20,5),(198,8920,8916,'han',20,5),(198,8921,8916,'ann',20,5),(198,8922,8916,'nne',20,5),(198,8923,8916,'nel',20,5),(198,8924,8919,'dis',50,5),(198,8925,8919,'isk',50,5),(198,8926,8924,'naa',100,5),(198,8927,8926,'600',3.333,5),(198,8928,8926,'00a',3.333,5),(198,8929,8926,'0a0',3.333,5),(198,8930,8926,'a09',3.333,5),(198,8931,8926,'098',3.333,5),(198,8932,8926,'980',3.333,5),(198,8933,8926,'804',3.333,5),(198,8934,8926,'044',3.333,5),(198,8935,8926,'443',3.333,5),(198,8936,8926,'430',3.333,5),(198,8937,8926,'307',3.333,5),(198,8938,8926,'075',3.333,5),(198,8939,8926,'753',3.333,5),(198,8940,8926,'535',3.333,5),(198,8941,8926,'357',3.333,5),(198,8942,8926,'573',3.333,5),(198,8943,8926,'732',3.333,5),(198,8944,8926,'32b',3.333,5),(198,8945,8926,'2b3',3.333,5),(198,8946,8926,'b33',3.333,5),(198,8947,8926,'334',3.333,5),(198,8948,8926,'345',3.333,5),(198,8949,8926,'457',3.333,5),(198,8950,8926,'571',3.333,5),(198,8951,8926,'715',3.333,5),(198,8952,8926,'153',3.333,5),(198,8953,8926,'533',3.333,5),(198,8954,8926,'336',3.333,5),(198,8955,8926,'366',3.333,5),(198,8956,8926,'669',3.333,5),(199,8958,8957,'net',25,5),(199,8959,8957,'eta',25,5),(199,8960,8957,'tap',25,5),(199,8961,8957,'app',25,5),(199,8962,8958,'fib',33.333,5),(199,8963,8958,'ibr',33.333,5),(199,8964,8958,'bre',33.333,5),(199,8965,8962,'cha',20,5),(199,8966,8962,'han',20,5),(199,8967,8962,'ann',20,5),(199,8968,8962,'nne',20,5),(199,8969,8962,'nel',20,5),(199,8970,8965,'dis',50,5),(199,8971,8965,'isk',50,5),(199,8972,8970,'naa',100,5),(199,8973,8972,'600',3.333,5),(199,8974,8972,'00a',3.333,5),(199,8975,8972,'0a0',3.333,5),(199,8976,8972,'a09',3.333,5),(199,8977,8972,'098',3.333,5),(199,8978,8972,'980',3.333,5),(199,8979,8972,'804',3.333,5),(199,8980,8972,'044',3.333,5),(199,8981,8972,'443',3.333,5),(199,8982,8972,'430',3.333,5),(199,8983,8972,'307',3.333,5),(199,8984,8972,'075',3.333,5),(199,8985,8972,'753',3.333,5),(199,8986,8972,'535',3.333,5),(199,8987,8972,'357',3.333,5),(199,8988,8972,'573',3.333,5),(199,8989,8972,'732',3.333,5),(199,8990,8972,'32b',3.333,5),(199,8991,8972,'2b3',3.333,5),(199,8992,8972,'b33',3.333,5),(199,8993,8972,'334',3.333,5),(199,8994,8972,'345',3.333,5),(199,8995,8972,'457',3.333,5),(199,8996,8972,'571',3.333,5),(199,8997,8972,'715',3.333,5),(199,8998,8972,'152',3.333,5),(199,8999,8972,'527',3.333,5),(199,9000,8972,'275',3.333,5),(199,9001,8972,'754',3.333,5),(199,9002,8972,'541',3.333,5),(200,9004,9003,'net',25,5),(200,9005,9003,'eta',25,5),(200,9006,9003,'tap',25,5),(200,9007,9003,'app',25,5),(200,9008,9004,'fib',33.333,5),(200,9009,9004,'ibr',33.333,5),(200,9010,9004,'bre',33.333,5),(200,9011,9008,'cha',20,5),(200,9012,9008,'han',20,5),(200,9013,9008,'ann',20,5),(200,9014,9008,'nne',20,5),(200,9015,9008,'nel',20,5),(200,9016,9011,'dis',50,5),(200,9017,9011,'isk',50,5),(200,9018,9016,'naa',100,5),(200,9019,9018,'600',3.333,5),(200,9020,9018,'00a',3.333,5),(200,9021,9018,'0a0',3.333,5),(200,9022,9018,'a09',3.333,5),(200,9023,9018,'098',3.333,5),(200,9024,9018,'980',3.333,5),(200,9025,9018,'804',3.333,5),(200,9026,9018,'044',3.333,5),(200,9027,9018,'443',3.333,5),(200,9028,9018,'430',3.333,5),(200,9029,9018,'307',3.333,5),(200,9030,9018,'075',3.333,5),(200,9031,9018,'753',3.333,5),(200,9032,9018,'535',3.333,5),(200,9033,9018,'357',3.333,5),(200,9034,9018,'573',3.333,5),(200,9035,9018,'732',3.333,5),(200,9036,9018,'32b',3.333,5),(200,9037,9018,'2b3',3.333,5),(200,9038,9018,'b33',3.333,5),(200,9039,9018,'334',3.333,5),(200,9040,9018,'345',3.333,5),(200,9041,9018,'457',3.333,5),(200,9042,9018,'571',3.333,5),(200,9043,9018,'715',3.333,5),(200,9044,9018,'152',3.333,5),(200,9045,9018,'527',3.333,5),(200,9046,9018,'275',3.333,5),(200,9047,9018,'754',3.333,5),(200,9048,9018,'542',3.333,5),(201,9050,9049,'net',25,5),(201,9051,9049,'eta',25,5),(201,9052,9049,'tap',25,5),(201,9053,9049,'app',25,5),(201,9054,9050,'fib',33.333,5),(201,9055,9050,'ibr',33.333,5),(201,9056,9050,'bre',33.333,5),(201,9057,9054,'cha',20,5),(201,9058,9054,'han',20,5),(201,9059,9054,'ann',20,5),(201,9060,9054,'nne',20,5),(201,9061,9054,'nel',20,5),(201,9062,9057,'dis',50,5),(201,9063,9057,'isk',50,5),(201,9064,9062,'naa',100,5),(201,9065,9064,'600',3.333,5),(201,9066,9064,'00a',3.333,5),(201,9067,9064,'0a0',3.333,5),(201,9068,9064,'a09',3.333,5),(201,9069,9064,'098',3.333,5),(201,9070,9064,'980',3.333,5),(201,9071,9064,'804',3.333,5),(201,9072,9064,'044',3.333,5),(201,9073,9064,'443',3.333,5),(201,9074,9064,'430',3.333,5),(201,9075,9064,'307',3.333,5),(201,9076,9064,'075',3.333,5),(201,9077,9064,'753',3.333,5),(201,9078,9064,'535',3.333,5),(201,9079,9064,'357',3.333,5),(201,9080,9064,'573',3.333,5),(201,9081,9064,'732',3.333,5),(201,9082,9064,'32b',3.333,5),(201,9083,9064,'2b3',3.333,5),(201,9084,9064,'b33',3.333,5),(201,9085,9064,'334',3.333,5),(201,9086,9064,'345',3.333,5),(201,9087,9064,'457',3.333,5),(201,9088,9064,'571',3.333,5),(201,9089,9064,'715',3.333,5),(201,9090,9064,'152',3.333,5),(201,9091,9064,'527',3.333,5),(201,9092,9064,'275',3.333,5),(201,9093,9064,'754',3.333,5),(201,9094,9064,'543',3.333,5),(202,9096,9095,'net',25,5),(202,9097,9095,'eta',25,5),(202,9098,9095,'tap',25,5),(202,9099,9095,'app',25,5),(202,9100,9096,'fib',33.333,5),(202,9101,9096,'ibr',33.333,5),(202,9102,9096,'bre',33.333,5),(202,9103,9100,'cha',20,5),(202,9104,9100,'han',20,5),(202,9105,9100,'ann',20,5),(202,9106,9100,'nne',20,5),(202,9107,9100,'nel',20,5),(202,9108,9103,'dis',50,5),(202,9109,9103,'isk',50,5),(202,9110,9108,'naa',100,5),(202,9111,9110,'600',3.333,5),(202,9112,9110,'00a',3.333,5),(202,9113,9110,'0a0',3.333,5),(202,9114,9110,'a09',3.333,5),(202,9115,9110,'098',3.333,5),(202,9116,9110,'980',3.333,5),(202,9117,9110,'804',3.333,5),(202,9118,9110,'044',3.333,5),(202,9119,9110,'443',3.333,5),(202,9120,9110,'430',3.333,5),(202,9121,9110,'307',3.333,5),(202,9122,9110,'075',3.333,5),(202,9123,9110,'753',3.333,5),(202,9124,9110,'535',3.333,5),(202,9125,9110,'357',3.333,5),(202,9126,9110,'573',3.333,5),(202,9127,9110,'732',3.333,5),(202,9128,9110,'32b',3.333,5),(202,9129,9110,'2b3',3.333,5),(202,9130,9110,'b33',3.333,5),(202,9131,9110,'334',3.333,5),(202,9132,9110,'345',3.333,5),(202,9133,9110,'457',3.333,5),(202,9134,9110,'571',3.333,5),(202,9135,9110,'715',3.333,5),(202,9136,9110,'152',3.333,5),(202,9137,9110,'527',3.333,5),(202,9138,9110,'275',3.333,5),(202,9139,9110,'754',3.333,5),(202,9140,9110,'544',3.333,5),(203,9142,9141,'net',25,5),(203,9143,9141,'eta',25,5),(203,9144,9141,'tap',25,5),(203,9145,9141,'app',25,5),(203,9146,9142,'fib',33.333,5),(203,9147,9142,'ibr',33.333,5),(203,9148,9142,'bre',33.333,5),(203,9149,9146,'cha',20,5),(203,9150,9146,'han',20,5),(203,9151,9146,'ann',20,5),(203,9152,9146,'nne',20,5),(203,9153,9146,'nel',20,5),(203,9154,9149,'dis',50,5),(203,9155,9149,'isk',50,5),(203,9156,9154,'naa',100,5),(203,9157,9156,'600',3.333,5),(203,9158,9156,'00a',3.333,5),(203,9159,9156,'0a0',3.333,5),(203,9160,9156,'a09',3.333,5),(203,9161,9156,'098',3.333,5),(203,9162,9156,'980',3.333,5),(203,9163,9156,'804',3.333,5),(203,9164,9156,'044',3.333,5),(203,9165,9156,'443',3.333,5),(203,9166,9156,'430',3.333,5),(203,9167,9156,'307',3.333,5),(203,9168,9156,'075',3.333,5),(203,9169,9156,'753',3.333,5),(203,9170,9156,'535',3.333,5),(203,9171,9156,'357',3.333,5),(203,9172,9156,'573',3.333,5),(203,9173,9156,'732',3.333,5),(203,9174,9156,'32b',3.333,5),(203,9175,9156,'2b3',3.333,5),(203,9176,9156,'b33',3.333,5),(203,9177,9156,'334',3.333,5),(203,9178,9156,'345',3.333,5),(203,9179,9156,'457',3.333,5),(203,9180,9156,'571',3.333,5),(203,9181,9156,'715',3.333,5),(203,9182,9156,'152',3.333,5),(203,9183,9156,'527',3.333,5),(203,9184,9156,'275',3.333,5),(203,9185,9156,'754',3.333,5),(203,9186,9156,'545',3.333,5),(204,9188,9187,'net',25,5),(204,9189,9187,'eta',25,5),(204,9190,9187,'tap',25,5),(204,9191,9187,'app',25,5),(204,9192,9188,'fib',33.333,5),(204,9193,9188,'ibr',33.333,5),(204,9194,9188,'bre',33.333,5),(204,9195,9192,'cha',20,5),(204,9196,9192,'han',20,5),(204,9197,9192,'ann',20,5),(204,9198,9192,'nne',20,5),(204,9199,9192,'nel',20,5),(204,9200,9195,'dis',50,5),(204,9201,9195,'isk',50,5),(204,9202,9200,'naa',100,5),(204,9203,9202,'600',3.333,5),(204,9204,9202,'00a',3.333,5),(204,9205,9202,'0a0',3.333,5),(204,9206,9202,'a09',3.333,5),(204,9207,9202,'098',3.333,5),(204,9208,9202,'980',3.333,5),(204,9209,9202,'804',3.333,5),(204,9210,9202,'044',3.333,5),(204,9211,9202,'443',3.333,5),(204,9212,9202,'430',3.333,5),(204,9213,9202,'307',3.333,5),(204,9214,9202,'075',3.333,5),(204,9215,9202,'753',3.333,5),(204,9216,9202,'535',3.333,5),(204,9217,9202,'357',3.333,5),(204,9218,9202,'573',3.333,5),(204,9219,9202,'732',3.333,5),(204,9220,9202,'32b',3.333,5),(204,9221,9202,'2b3',3.333,5),(204,9222,9202,'b33',3.333,5),(204,9223,9202,'334',3.333,5),(204,9224,9202,'345',3.333,5),(204,9225,9202,'457',3.333,5),(204,9226,9202,'571',3.333,5),(204,9227,9202,'715',3.333,5),(204,9228,9202,'152',3.333,5),(204,9229,9202,'527',3.333,5),(204,9230,9202,'275',3.333,5),(204,9231,9202,'754',3.333,5),(204,9232,9202,'546',3.333,5),(205,9234,9233,'net',25,5),(205,9235,9233,'eta',25,5),(205,9236,9233,'tap',25,5),(205,9237,9233,'app',25,5),(205,9238,9234,'fib',33.333,5),(205,9239,9234,'ibr',33.333,5),(205,9240,9234,'bre',33.333,5),(205,9241,9238,'cha',20,5),(205,9242,9238,'han',20,5),(205,9243,9238,'ann',20,5),(205,9244,9238,'nne',20,5),(205,9245,9238,'nel',20,5),(205,9246,9241,'dis',50,5),(205,9247,9241,'isk',50,5),(205,9248,9246,'naa',100,5),(205,9249,9248,'600',3.333,5),(205,9250,9248,'00a',3.333,5),(205,9251,9248,'0a0',3.333,5),(205,9252,9248,'a09',3.333,5),(205,9253,9248,'098',3.333,5),(205,9254,9248,'980',3.333,5),(205,9255,9248,'804',3.333,5),(205,9256,9248,'044',3.333,5),(205,9257,9248,'443',3.333,5),(205,9258,9248,'430',3.333,5),(205,9259,9248,'307',3.333,5),(205,9260,9248,'075',3.333,5),(205,9261,9248,'753',3.333,5),(205,9262,9248,'535',3.333,5),(205,9263,9248,'357',3.333,5),(205,9264,9248,'573',3.333,5),(205,9265,9248,'732',3.333,5),(205,9266,9248,'32b',3.333,5),(205,9267,9248,'2b3',3.333,5),(205,9268,9248,'b33',3.333,5),(205,9269,9248,'334',3.333,5),(205,9270,9248,'345',3.333,5),(205,9271,9248,'457',3.333,5),(205,9272,9248,'571',3.333,5),(205,9273,9248,'715',3.333,5),(205,9274,9248,'152',3.333,5),(205,9275,9248,'527',3.333,5),(205,9276,9248,'275',3.333,5),(205,9277,9248,'754',3.333,5),(205,9278,9248,'547',3.333,5),(206,9280,9279,'net',25,5),(206,9281,9279,'eta',25,5),(206,9282,9279,'tap',25,5),(206,9283,9279,'app',25,5),(206,9284,9280,'fib',33.333,5),(206,9285,9280,'ibr',33.333,5),(206,9286,9280,'bre',33.333,5),(206,9287,9284,'cha',20,5),(206,9288,9284,'han',20,5),(206,9289,9284,'ann',20,5),(206,9290,9284,'nne',20,5),(206,9291,9284,'nel',20,5),(206,9292,9287,'dis',50,5),(206,9293,9287,'isk',50,5),(206,9294,9292,'naa',100,5),(206,9295,9294,'600',3.333,5),(206,9296,9294,'00a',3.333,5),(206,9297,9294,'0a0',3.333,5),(206,9298,9294,'a09',3.333,5),(206,9299,9294,'098',3.333,5),(206,9300,9294,'980',3.333,5),(206,9301,9294,'804',3.333,5),(206,9302,9294,'044',3.333,5),(206,9303,9294,'443',3.333,5),(206,9304,9294,'430',3.333,5),(206,9305,9294,'307',3.333,5),(206,9306,9294,'075',3.333,5),(206,9307,9294,'753',3.333,5),(206,9308,9294,'535',3.333,5),(206,9309,9294,'357',3.333,5),(206,9310,9294,'573',3.333,5),(206,9311,9294,'732',3.333,5),(206,9312,9294,'32b',3.333,5),(206,9313,9294,'2b3',3.333,5),(206,9314,9294,'b33',3.333,5),(206,9315,9294,'334',3.333,5),(206,9316,9294,'345',3.333,5),(206,9317,9294,'457',3.333,5),(206,9318,9294,'571',3.333,5),(206,9319,9294,'715',3.333,5),(206,9320,9294,'152',3.333,5),(206,9321,9294,'527',3.333,5),(206,9322,9294,'275',3.333,5),(206,9323,9294,'754',3.333,5),(206,9324,9294,'548',3.333,5),(207,9326,9325,'net',25,5),(207,9327,9325,'eta',25,5),(207,9328,9325,'tap',25,5),(207,9329,9325,'app',25,5),(207,9330,9326,'fib',33.333,5),(207,9331,9326,'ibr',33.333,5),(207,9332,9326,'bre',33.333,5),(207,9333,9330,'cha',20,5),(207,9334,9330,'han',20,5),(207,9335,9330,'ann',20,5),(207,9336,9330,'nne',20,5),(207,9337,9330,'nel',20,5),(207,9338,9333,'dis',50,5),(207,9339,9333,'isk',50,5),(207,9340,9338,'naa',100,5),(207,9341,9340,'600',3.333,5),(207,9342,9340,'00a',3.333,5),(207,9343,9340,'0a0',3.333,5),(207,9344,9340,'a09',3.333,5),(207,9345,9340,'098',3.333,5),(207,9346,9340,'980',3.333,5),(207,9347,9340,'804',3.333,5),(207,9348,9340,'044',3.333,5),(207,9349,9340,'443',3.333,5),(207,9350,9340,'430',3.333,5),(207,9351,9340,'307',3.333,5),(207,9352,9340,'075',3.333,5),(207,9353,9340,'753',3.333,5),(207,9354,9340,'535',3.333,5),(207,9355,9340,'357',3.333,5),(207,9356,9340,'573',3.333,5),(207,9357,9340,'732',3.333,5),(207,9358,9340,'32b',3.333,5),(207,9359,9340,'2b3',3.333,5),(207,9360,9340,'b33',3.333,5),(207,9361,9340,'334',3.333,5),(207,9362,9340,'345',3.333,5),(207,9363,9340,'457',3.333,5),(207,9364,9340,'571',3.333,5),(207,9365,9340,'715',3.333,5),(207,9366,9340,'152',3.333,5),(207,9367,9340,'527',3.333,5),(207,9368,9340,'275',3.333,5),(207,9369,9340,'754',3.333,5),(207,9370,9340,'549',3.333,5),(208,9372,9371,'net',25,5),(208,9373,9371,'eta',25,5),(208,9374,9371,'tap',25,5),(208,9375,9371,'app',25,5),(208,9376,9372,'fib',33.333,5),(208,9377,9372,'ibr',33.333,5),(208,9378,9372,'bre',33.333,5),(208,9379,9376,'cha',20,5),(208,9380,9376,'han',20,5),(208,9381,9376,'ann',20,5),(208,9382,9376,'nne',20,5),(208,9383,9376,'nel',20,5),(208,9384,9379,'dis',50,5),(208,9385,9379,'isk',50,5),(208,9386,9384,'naa',100,5),(208,9387,9386,'600',3.333,5),(208,9388,9386,'00a',3.333,5),(208,9389,9386,'0a0',3.333,5),(208,9390,9386,'a09',3.333,5),(208,9391,9386,'098',3.333,5),(208,9392,9386,'980',3.333,5),(208,9393,9386,'804',3.333,5),(208,9394,9386,'044',3.333,5),(208,9395,9386,'443',3.333,5),(208,9396,9386,'430',3.333,5),(208,9397,9386,'307',3.333,5),(208,9398,9386,'075',3.333,5),(208,9399,9386,'753',3.333,5),(208,9400,9386,'535',3.333,5),(208,9401,9386,'357',3.333,5),(208,9402,9386,'573',3.333,5),(208,9403,9386,'732',3.333,5),(208,9404,9386,'32b',3.333,5),(208,9405,9386,'2b3',3.333,5),(208,9406,9386,'b33',3.333,5),(208,9407,9386,'334',3.333,5),(208,9408,9386,'345',3.333,5),(208,9409,9386,'457',3.333,5),(208,9410,9386,'571',3.333,5),(208,9411,9386,'715',3.333,5),(208,9412,9386,'153',3.333,5),(208,9413,9386,'533',3.333,5),(208,9414,9386,'336',3.333,5),(208,9415,9386,'362',3.333,5),(208,9416,9386,'62d',3.333,5),(209,9418,9417,'net',25,5),(209,9419,9417,'eta',25,5),(209,9420,9417,'tap',25,5),(209,9421,9417,'app',25,5),(209,9422,9418,'fib',33.333,5),(209,9423,9418,'ibr',33.333,5),(209,9424,9418,'bre',33.333,5),(209,9425,9422,'cha',20,5),(209,9426,9422,'han',20,5),(209,9427,9422,'ann',20,5),(209,9428,9422,'nne',20,5),(209,9429,9422,'nel',20,5),(209,9430,9425,'dis',50,5),(209,9431,9425,'isk',50,5),(209,9432,9430,'naa',100,5),(209,9433,9432,'600',3.333,5),(209,9434,9432,'00a',3.333,5),(209,9435,9432,'0a0',3.333,5),(209,9436,9432,'a09',3.333,5),(209,9437,9432,'098',3.333,5),(209,9438,9432,'980',3.333,5),(209,9439,9432,'804',3.333,5),(209,9440,9432,'044',3.333,5),(209,9441,9432,'443',3.333,5),(209,9442,9432,'430',3.333,5),(209,9443,9432,'307',3.333,5),(209,9444,9432,'075',3.333,5),(209,9445,9432,'753',3.333,5),(209,9446,9432,'535',3.333,5),(209,9447,9432,'357',3.333,5),(209,9448,9432,'573',3.333,5),(209,9449,9432,'732',3.333,5),(209,9450,9432,'32b',3.333,5),(209,9451,9432,'2b3',3.333,5),(209,9452,9432,'b33',3.333,5),(209,9453,9432,'334',3.333,5),(209,9454,9432,'345',3.333,5),(209,9455,9432,'457',3.333,5),(209,9456,9432,'571',3.333,5),(209,9457,9432,'715',3.333,5),(209,9458,9432,'153',3.333,5),(209,9459,9432,'533',3.333,5),(209,9460,9432,'336',3.333,5),(209,9461,9432,'362',3.333,5),(209,9462,9432,'62f',3.333,5),(210,9464,9463,'net',25,5),(210,9465,9463,'eta',25,5),(210,9466,9463,'tap',25,5),(210,9467,9463,'app',25,5),(210,9468,9464,'ser',25,5),(210,9469,9464,'eri',25,5),(210,9470,9464,'ria',25,5),(210,9471,9464,'ial',25,5),(210,9472,9468,'att',16.667,5),(210,9473,9468,'tta',16.667,5),(210,9474,9468,'tac',16.667,5),(210,9475,9468,'ach',16.667,5),(210,9476,9468,'che',16.667,5),(210,9477,9468,'hed',16.667,5),(210,9478,9472,'scs',50,5),(210,9479,9472,'csi',50,5),(210,9480,9478,'dis',50,5),(210,9481,9478,'isk',50,5),(210,9482,9480,'naa',100,5),(210,9483,9482,'600',3.333,5),(210,9484,9482,'00a',3.333,5),(210,9485,9482,'0a0',3.333,5),(210,9486,9482,'a09',3.333,5),(210,9487,9482,'098',3.333,5),(210,9488,9482,'980',3.333,5),(210,9489,9482,'80a',3.333,5),(210,9490,9482,'0a6',3.333,5),(210,9491,9482,'a64',3.333,5),(210,9492,9482,'64c',3.333,5),(210,9493,9482,'4c8',3.333,5),(210,9494,9482,'c84',3.333,5),(210,9495,9482,'84e',3.333,5),(210,9496,9482,'4ee',3.333,5),(210,9497,9482,'ee0',3.333,5),(210,9498,9482,'e03',3.333,5),(210,9499,9482,'034',3.333,5),(210,9500,9482,'347',3.333,5),(210,9501,9482,'474',3.333,5),(210,9502,9482,'743',3.333,5),(210,9503,9482,'431',3.333,5),(210,9504,9482,'311',3.333,5),(210,9505,9482,'117',3.333,5),(210,9506,9482,'17b',3.333,5),(210,9507,9482,'7b0',3.333,5),(210,9508,9482,'b05',3.333,5),(210,9509,9482,'05a',3.333,5),(210,9510,9482,'5ab',3.333,5),(210,9511,9482,'aba',3.333,5),(210,9512,9482,'ba2',3.333,5),(211,9514,9513,'net',25,5),(211,9515,9513,'eta',25,5),(211,9516,9513,'tap',25,5),(211,9517,9513,'app',25,5),(211,9518,9514,'fib',33.333,5),(211,9519,9514,'ibr',33.333,5),(211,9520,9514,'bre',33.333,5),(211,9521,9518,'cha',20,5),(211,9522,9518,'han',20,5),(211,9523,9518,'ann',20,5),(211,9524,9518,'nne',20,5),(211,9525,9518,'nel',20,5),(211,9526,9521,'dis',50,5),(211,9527,9521,'isk',50,5),(211,9528,9526,'naa',100,5),(211,9529,9528,'600',3.333,5),(211,9530,9528,'00a',3.333,5),(211,9531,9528,'0a0',3.333,5),(211,9532,9528,'a09',3.333,5),(211,9533,9528,'098',3.333,5),(211,9534,9528,'980',3.333,5),(211,9535,9528,'804',3.333,5),(211,9536,9528,'044',3.333,5),(211,9537,9528,'443',3.333,5),(211,9538,9528,'430',3.333,5),(211,9539,9528,'307',3.333,5),(211,9540,9528,'075',3.333,5),(211,9541,9528,'753',3.333,5),(211,9542,9528,'535',3.333,5),(211,9543,9528,'357',3.333,5),(211,9544,9528,'573',3.333,5),(211,9545,9528,'732',3.333,5),(211,9546,9528,'32b',3.333,5),(211,9547,9528,'2b3',3.333,5),(211,9548,9528,'b33',3.333,5),(211,9549,9528,'334',3.333,5),(211,9550,9528,'345',3.333,5),(211,9551,9528,'457',3.333,5),(211,9552,9528,'571',3.333,5),(211,9553,9528,'715',3.333,5),(211,9554,9528,'153',3.333,5),(211,9555,9528,'533',3.333,5),(211,9556,9528,'336',3.333,5),(211,9557,9528,'366',3.333,5),(211,9558,9528,'66a',3.333,5),(212,9560,9559,'net',25,5),(212,9561,9559,'eta',25,5),(212,9562,9559,'tap',25,5),(212,9563,9559,'app',25,5),(212,9564,9560,'fib',33.333,5),(212,9565,9560,'ibr',33.333,5),(212,9566,9560,'bre',33.333,5),(212,9567,9564,'cha',20,5),(212,9568,9564,'han',20,5),(212,9569,9564,'ann',20,5),(212,9570,9564,'nne',20,5),(212,9571,9564,'nel',20,5),(212,9572,9567,'dis',50,5),(212,9573,9567,'isk',50,5),(212,9574,9572,'naa',100,5),(212,9575,9574,'600',3.333,5),(212,9576,9574,'00a',3.333,5),(212,9577,9574,'0a0',3.333,5),(212,9578,9574,'a09',3.333,5),(212,9579,9574,'098',3.333,5),(212,9580,9574,'980',3.333,5),(212,9581,9574,'804',3.333,5),(212,9582,9574,'044',3.333,5),(212,9583,9574,'443',3.333,5),(212,9584,9574,'430',3.333,5),(212,9585,9574,'307',3.333,5),(212,9586,9574,'075',3.333,5),(212,9587,9574,'753',3.333,5),(212,9588,9574,'535',3.333,5),(212,9589,9574,'357',3.333,5),(212,9590,9574,'573',3.333,5),(212,9591,9574,'732',3.333,5),(212,9592,9574,'32b',3.333,5),(212,9593,9574,'2b3',3.333,5),(212,9594,9574,'b33',3.333,5),(212,9595,9574,'334',3.333,5),(212,9596,9574,'345',3.333,5),(212,9597,9574,'457',3.333,5),(212,9598,9574,'571',3.333,5),(212,9599,9574,'715',3.333,5),(212,9600,9574,'153',3.333,5),(212,9601,9574,'533',3.333,5),(212,9602,9574,'336',3.333,5),(212,9603,9574,'366',3.333,5),(212,9604,9574,'66b',3.333,5),(213,9606,9605,'net',25,5),(213,9607,9605,'eta',25,5),(213,9608,9605,'tap',25,5),(213,9609,9605,'app',25,5),(213,9610,9606,'ser',25,5),(213,9611,9606,'eri',25,5),(213,9612,9606,'ria',25,5),(213,9613,9606,'ial',25,5),(213,9614,9610,'att',16.667,5),(213,9615,9610,'tta',16.667,5),(213,9616,9610,'tac',16.667,5),(213,9617,9610,'ach',16.667,5),(213,9618,9610,'che',16.667,5),(213,9619,9610,'hed',16.667,5),(213,9620,9614,'scs',50,5),(213,9621,9614,'csi',50,5),(213,9622,9620,'dis',50,5),(213,9623,9620,'isk',50,5),(213,9624,9622,'naa',100,5),(213,9625,9624,'600',3.333,5),(213,9626,9624,'00a',3.333,5),(213,9627,9624,'0a0',3.333,5),(213,9628,9624,'a09',3.333,5),(213,9629,9624,'098',3.333,5),(213,9630,9624,'980',3.333,5),(213,9631,9624,'80d',3.333,5),(213,9632,9624,'0d8',3.333,5),(213,9633,9624,'d83',3.333,5),(213,9634,9624,'83a',3.333,5),(213,9635,9624,'3a8',3.333,5),(213,9636,9624,'a84',3.333,5),(213,9637,9624,'84e',3.333,5),(213,9638,9624,'4ee',3.333,5),(213,9639,9624,'ee9',3.333,5),(213,9640,9624,'e93',3.333,5),(213,9641,9624,'930',3.333,5),(213,9642,9624,'305',3.333,5),(213,9643,9624,'054',3.333,5),(213,9644,9624,'545',3.333,5),(213,9645,9624,'451',3.333,5),(213,9646,9624,'511',3.333,5),(213,9647,9624,'117',3.333,5),(213,9648,9624,'17b',3.333,5),(213,9649,9624,'7b0',3.333,5),(213,9650,9624,'b03',3.333,5),(213,9651,9624,'03a',3.333,5),(213,9652,9624,'3ab',3.333,5),(213,9653,9624,'aba',3.333,5),(213,9654,9624,'ba2',3.333,5),(214,9656,9655,'net',25,5),(214,9657,9655,'eta',25,5),(214,9658,9655,'tap',25,5),(214,9659,9655,'app',25,5),(214,9660,9656,'fib',33.333,5),(214,9661,9656,'ibr',33.333,5),(214,9662,9656,'bre',33.333,5),(214,9663,9660,'cha',20,5),(214,9664,9660,'han',20,5),(214,9665,9660,'ann',20,5),(214,9666,9660,'nne',20,5),(214,9667,9660,'nel',20,5),(214,9668,9663,'dis',50,5),(214,9669,9663,'isk',50,5),(214,9670,9668,'naa',100,5),(214,9671,9670,'600',3.333,5),(214,9672,9670,'00a',3.333,5),(214,9673,9670,'0a0',3.333,5),(214,9674,9670,'a09',3.333,5),(214,9675,9670,'098',3.333,5),(214,9676,9670,'980',3.333,5),(214,9677,9670,'804',3.333,5),(214,9678,9670,'044',3.333,5),(214,9679,9670,'443',3.333,5),(214,9680,9670,'430',3.333,5),(214,9681,9670,'307',3.333,5),(214,9682,9670,'075',3.333,5),(214,9683,9670,'753',3.333,5),(214,9684,9670,'535',3.333,5),(214,9685,9670,'357',3.333,5),(214,9686,9670,'573',3.333,5),(214,9687,9670,'732',3.333,5),(214,9688,9670,'32b',3.333,5),(214,9689,9670,'2b3',3.333,5),(214,9690,9670,'b33',3.333,5),(214,9691,9670,'334',3.333,5),(214,9692,9670,'345',3.333,5),(214,9693,9670,'457',3.333,5),(214,9694,9670,'571',3.333,5),(214,9695,9670,'715',3.333,5),(214,9696,9670,'153',3.333,5),(214,9697,9670,'533',3.333,5),(214,9698,9670,'336',3.333,5),(214,9699,9670,'366',3.333,5),(214,9700,9670,'66c',3.333,5),(215,9702,9701,'net',25,5),(215,9703,9701,'eta',25,5),(215,9704,9701,'tap',25,5),(215,9705,9701,'app',25,5),(215,9706,9702,'fib',33.333,5),(215,9707,9702,'ibr',33.333,5),(215,9708,9702,'bre',33.333,5),(215,9709,9706,'cha',20,5),(215,9710,9706,'han',20,5),(215,9711,9706,'ann',20,5),(215,9712,9706,'nne',20,5),(215,9713,9706,'nel',20,5),(215,9714,9709,'dis',50,5),(215,9715,9709,'isk',50,5),(215,9716,9714,'naa',100,5),(215,9717,9716,'600',3.333,5),(215,9718,9716,'00a',3.333,5),(215,9719,9716,'0a0',3.333,5),(215,9720,9716,'a09',3.333,5),(215,9721,9716,'098',3.333,5),(215,9722,9716,'980',3.333,5),(215,9723,9716,'804',3.333,5),(215,9724,9716,'044',3.333,5),(215,9725,9716,'443',3.333,5),(215,9726,9716,'430',3.333,5),(215,9727,9716,'307',3.333,5),(215,9728,9716,'075',3.333,5),(215,9729,9716,'753',3.333,5),(215,9730,9716,'535',3.333,5),(215,9731,9716,'357',3.333,5),(215,9732,9716,'573',3.333,5),(215,9733,9716,'732',3.333,5),(215,9734,9716,'32b',3.333,5),(215,9735,9716,'2b3',3.333,5),(215,9736,9716,'b33',3.333,5),(215,9737,9716,'334',3.333,5),(215,9738,9716,'345',3.333,5),(215,9739,9716,'457',3.333,5),(215,9740,9716,'571',3.333,5),(215,9741,9716,'715',3.333,5),(215,9742,9716,'153',3.333,5),(215,9743,9716,'533',3.333,5),(215,9744,9716,'336',3.333,5),(215,9745,9716,'366',3.333,5),(215,9746,9716,'66d',3.333,5),(216,9748,9747,'net',25,5),(216,9749,9747,'eta',25,5),(216,9750,9747,'tap',25,5),(216,9751,9747,'app',25,5),(216,9752,9748,'fib',33.333,5),(216,9753,9748,'ibr',33.333,5),(216,9754,9748,'bre',33.333,5),(216,9755,9752,'cha',20,5),(216,9756,9752,'han',20,5),(216,9757,9752,'ann',20,5),(216,9758,9752,'nne',20,5),(216,9759,9752,'nel',20,5),(216,9760,9755,'dis',50,5),(216,9761,9755,'isk',50,5),(216,9762,9760,'naa',100,5),(216,9763,9762,'600',3.333,5),(216,9764,9762,'00a',3.333,5),(216,9765,9762,'0a0',3.333,5),(216,9766,9762,'a09',3.333,5),(216,9767,9762,'098',3.333,5),(216,9768,9762,'980',3.333,5),(216,9769,9762,'804',3.333,5),(216,9770,9762,'044',3.333,5),(216,9771,9762,'443',3.333,5),(216,9772,9762,'430',3.333,5),(216,9773,9762,'307',3.333,5),(216,9774,9762,'075',3.333,5),(216,9775,9762,'753',3.333,5),(216,9776,9762,'535',3.333,5),(216,9777,9762,'357',3.333,5),(216,9778,9762,'573',3.333,5),(216,9779,9762,'732',3.333,5),(216,9780,9762,'32b',3.333,5),(216,9781,9762,'2b3',3.333,5),(216,9782,9762,'b33',3.333,5),(216,9783,9762,'334',3.333,5),(216,9784,9762,'345',3.333,5),(216,9785,9762,'457',3.333,5),(216,9786,9762,'571',3.333,5),(216,9787,9762,'715',3.333,5),(216,9788,9762,'153',3.333,5),(216,9789,9762,'533',3.333,5),(216,9790,9762,'336',3.333,5),(216,9791,9762,'366',3.333,5),(216,9792,9762,'66e',3.333,5),(217,9794,9793,'net',25,5),(217,9795,9793,'eta',25,5),(217,9796,9793,'tap',25,5),(217,9797,9793,'app',25,5),(217,9798,9794,'fib',33.333,5),(217,9799,9794,'ibr',33.333,5),(217,9800,9794,'bre',33.333,5),(217,9801,9798,'cha',20,5),(217,9802,9798,'han',20,5),(217,9803,9798,'ann',20,5),(217,9804,9798,'nne',20,5),(217,9805,9798,'nel',20,5),(217,9806,9801,'dis',50,5),(217,9807,9801,'isk',50,5),(217,9808,9806,'naa',100,5),(217,9809,9808,'600',3.333,5),(217,9810,9808,'00a',3.333,5),(217,9811,9808,'0a0',3.333,5),(217,9812,9808,'a09',3.333,5),(217,9813,9808,'098',3.333,5),(217,9814,9808,'980',3.333,5),(217,9815,9808,'804',3.333,5),(217,9816,9808,'044',3.333,5),(217,9817,9808,'443',3.333,5),(217,9818,9808,'430',3.333,5),(217,9819,9808,'307',3.333,5),(217,9820,9808,'075',3.333,5),(217,9821,9808,'753',3.333,5),(217,9822,9808,'535',3.333,5),(217,9823,9808,'357',3.333,5),(217,9824,9808,'573',3.333,5),(217,9825,9808,'732',3.333,5),(217,9826,9808,'32b',3.333,5),(217,9827,9808,'2b3',3.333,5),(217,9828,9808,'b33',3.333,5),(217,9829,9808,'334',3.333,5),(217,9830,9808,'345',3.333,5),(217,9831,9808,'457',3.333,5),(217,9832,9808,'571',3.333,5),(217,9833,9808,'715',3.333,5),(217,9834,9808,'153',3.333,5),(217,9835,9808,'533',3.333,5),(217,9836,9808,'336',3.333,5),(217,9837,9808,'366',3.333,5),(217,9838,9808,'66f',3.333,5),(218,9840,9839,'net',25,5),(218,9841,9839,'eta',25,5),(218,9842,9839,'tap',25,5),(218,9843,9839,'app',25,5),(218,9844,9840,'fib',33.333,5),(218,9845,9840,'ibr',33.333,5),(218,9846,9840,'bre',33.333,5),(218,9847,9844,'cha',20,5),(218,9848,9844,'han',20,5),(218,9849,9844,'ann',20,5),(218,9850,9844,'nne',20,5),(218,9851,9844,'nel',20,5),(218,9852,9847,'dis',50,5),(218,9853,9847,'isk',50,5),(218,9854,9852,'naa',100,5),(218,9855,9854,'600',3.333,5),(218,9856,9854,'00a',3.333,5),(218,9857,9854,'0a0',3.333,5),(218,9858,9854,'a09',3.333,5),(218,9859,9854,'098',3.333,5),(218,9860,9854,'980',3.333,5),(218,9861,9854,'804',3.333,5),(218,9862,9854,'044',3.333,5),(218,9863,9854,'443',3.333,5),(218,9864,9854,'430',3.333,5),(218,9865,9854,'307',3.333,5),(218,9866,9854,'075',3.333,5),(218,9867,9854,'753',3.333,5),(218,9868,9854,'535',3.333,5),(218,9869,9854,'357',3.333,5),(218,9870,9854,'573',3.333,5),(218,9871,9854,'732',3.333,5),(218,9872,9854,'32b',3.333,5),(218,9873,9854,'2b3',3.333,5),(218,9874,9854,'b33',3.333,5),(218,9875,9854,'334',3.333,5),(218,9876,9854,'345',3.333,5),(218,9877,9854,'457',3.333,5),(218,9878,9854,'571',3.333,5),(218,9879,9854,'715',3.333,5),(218,9880,9854,'152',3.333,5),(218,9881,9854,'527',3.333,5),(218,9882,9854,'275',3.333,5),(218,9883,9854,'754',3.333,5),(218,9884,9854,'54a',3.333,5),(219,9886,9885,'net',25,5),(219,9887,9885,'eta',25,5),(219,9888,9885,'tap',25,5),(219,9889,9885,'app',25,5),(219,9890,9886,'fib',33.333,5),(219,9891,9886,'ibr',33.333,5),(219,9892,9886,'bre',33.333,5),(219,9893,9890,'cha',20,5),(219,9894,9890,'han',20,5),(219,9895,9890,'ann',20,5),(219,9896,9890,'nne',20,5),(219,9897,9890,'nel',20,5),(219,9898,9893,'dis',50,5),(219,9899,9893,'isk',50,5),(219,9900,9898,'naa',100,5),(219,9901,9900,'600',3.333,5),(219,9902,9900,'00a',3.333,5),(219,9903,9900,'0a0',3.333,5),(219,9904,9900,'a09',3.333,5),(219,9905,9900,'098',3.333,5),(219,9906,9900,'980',3.333,5),(219,9907,9900,'804',3.333,5),(219,9908,9900,'044',3.333,5),(219,9909,9900,'443',3.333,5),(219,9910,9900,'430',3.333,5),(219,9911,9900,'307',3.333,5),(219,9912,9900,'072',3.333,5),(219,9913,9900,'725',3.333,5),(219,9914,9900,'259',3.333,5),(219,9915,9900,'593',3.333,5),(219,9916,9900,'931',3.333,5),(219,9917,9900,'313',3.333,5),(219,9918,9900,'13f',3.333,5),(219,9919,9900,'3f3',3.333,5),(219,9920,9900,'f33',3.333,5),(219,9921,9900,'334',3.333,5),(219,9922,9900,'345',3.333,5),(219,9923,9900,'455',3.333,5),(219,9924,9900,'556',3.333,5),(219,9925,9900,'563',3.333,5),(219,9926,9900,'639',3.333,5),(219,9927,9900,'393',3.333,5),(219,9928,9900,'934',3.333,5),(219,9929,9900,'346',3.333,5),(219,9930,9900,'461',3.333,5),(220,9932,9931,'net',25,5),(220,9933,9931,'eta',25,5),(220,9934,9931,'tap',25,5),(220,9935,9931,'app',25,5),(220,9936,9932,'fib',33.333,5),(220,9937,9932,'ibr',33.333,5),(220,9938,9932,'bre',33.333,5),(220,9939,9936,'cha',20,5),(220,9940,9936,'han',20,5),(220,9941,9936,'ann',20,5),(220,9942,9936,'nne',20,5),(220,9943,9936,'nel',20,5),(220,9944,9939,'dis',50,5),(220,9945,9939,'isk',50,5),(220,9946,9944,'naa',100,5),(220,9947,9946,'600',3.333,5),(220,9948,9946,'00a',3.333,5),(220,9949,9946,'0a0',3.333,5),(220,9950,9946,'a09',3.333,5),(220,9951,9946,'098',3.333,5),(220,9952,9946,'980',3.333,5),(220,9953,9946,'804',3.333,5),(220,9954,9946,'044',3.333,5),(220,9955,9946,'443',3.333,5),(220,9956,9946,'430',3.333,5),(220,9957,9946,'307',3.333,5),(220,9958,9946,'075',3.333,5),(220,9959,9946,'753',3.333,5),(220,9960,9946,'535',3.333,5),(220,9961,9946,'357',3.333,5),(220,9962,9946,'573',3.333,5),(220,9963,9946,'732',3.333,5),(220,9964,9946,'32b',3.333,5),(220,9965,9946,'2b3',3.333,5),(220,9966,9946,'b33',3.333,5),(220,9967,9946,'334',3.333,5),(220,9968,9946,'345',3.333,5),(220,9969,9946,'457',3.333,5),(220,9970,9946,'571',3.333,5),(220,9971,9946,'715',3.333,5),(220,9972,9946,'152',3.333,5),(220,9973,9946,'527',3.333,5),(220,9974,9946,'275',3.333,5),(220,9975,9946,'754',3.333,5),(220,9976,9946,'54b',3.333,5),(221,9978,9977,'net',25,5),(221,9979,9977,'eta',25,5),(221,9980,9977,'tap',25,5),(221,9981,9977,'app',25,5),(221,9982,9978,'fib',33.333,5),(221,9983,9978,'ibr',33.333,5),(221,9984,9978,'bre',33.333,5),(221,9985,9982,'cha',20,5),(221,9986,9982,'han',20,5),(221,9987,9982,'ann',20,5),(221,9988,9982,'nne',20,5),(221,9989,9982,'nel',20,5),(221,9990,9985,'dis',50,5),(221,9991,9985,'isk',50,5),(221,9992,9990,'naa',100,5),(221,9993,9992,'600',3.333,5),(221,9994,9992,'00a',3.333,5),(221,9995,9992,'0a0',3.333,5),(221,9996,9992,'a09',3.333,5),(221,9997,9992,'098',3.333,5),(221,9998,9992,'980',3.333,5),(221,9999,9992,'804',3.333,5),(221,10000,9992,'044',3.333,5),(221,10001,9992,'443',3.333,5),(221,10002,9992,'430',3.333,5),(221,10003,9992,'307',3.333,5),(221,10004,9992,'072',3.333,5),(221,10005,9992,'725',3.333,5),(221,10006,9992,'259',3.333,5),(221,10007,9992,'593',3.333,5),(221,10008,9992,'931',3.333,5),(221,10009,9992,'313',3.333,5),(221,10010,9992,'13f',3.333,5),(221,10011,9992,'3f3',3.333,5),(221,10012,9992,'f33',3.333,5),(221,10013,9992,'334',3.333,5),(221,10014,9992,'345',3.333,5),(221,10015,9992,'455',3.333,5),(221,10016,9992,'556',3.333,5),(221,10017,9992,'563',3.333,5),(221,10018,9992,'639',3.333,5),(221,10019,9992,'393',3.333,5),(221,10020,9992,'934',3.333,5),(221,10021,9992,'346',3.333,5),(221,10022,9992,'462',3.333,5),(222,10024,10023,'net',25,5),(222,10025,10023,'eta',25,5),(222,10026,10023,'tap',25,5),(222,10027,10023,'app',25,5),(222,10028,10024,'fib',33.333,5),(222,10029,10024,'ibr',33.333,5),(222,10030,10024,'bre',33.333,5),(222,10031,10028,'cha',20,5),(222,10032,10028,'han',20,5),(222,10033,10028,'ann',20,5),(222,10034,10028,'nne',20,5),(222,10035,10028,'nel',20,5),(222,10036,10031,'dis',50,5),(222,10037,10031,'isk',50,5),(222,10038,10036,'naa',100,5),(222,10039,10038,'600',3.333,5),(222,10040,10038,'00a',3.333,5),(222,10041,10038,'0a0',3.333,5),(222,10042,10038,'a09',3.333,5),(222,10043,10038,'098',3.333,5),(222,10044,10038,'980',3.333,5),(222,10045,10038,'804',3.333,5),(222,10046,10038,'044',3.333,5),(222,10047,10038,'443',3.333,5),(222,10048,10038,'430',3.333,5),(222,10049,10038,'307',3.333,5),(222,10050,10038,'072',3.333,5),(222,10051,10038,'725',3.333,5),(222,10052,10038,'259',3.333,5),(222,10053,10038,'593',3.333,5),(222,10054,10038,'931',3.333,5),(222,10055,10038,'313',3.333,5),(222,10056,10038,'13f',3.333,5),(222,10057,10038,'3f3',3.333,5),(222,10058,10038,'f33',3.333,5),(222,10059,10038,'334',3.333,5),(222,10060,10038,'345',3.333,5),(222,10061,10038,'455',3.333,5),(222,10062,10038,'556',3.333,5),(222,10063,10038,'563',3.333,5),(222,10064,10038,'639',3.333,5),(222,10065,10038,'393',3.333,5),(222,10066,10038,'934',3.333,5),(222,10067,10038,'346',3.333,5),(222,10068,10038,'463',3.333,5),(223,10070,10069,'hgw',9.091,5),(223,10071,10069,'gw2',9.091,5),(223,10072,10069,'w2k',9.091,5),(223,10073,10069,'2k8',9.091,5),(223,10074,10069,'k8r',9.091,5),(223,10075,10069,'8r2',9.091,5),(223,10076,10069,'r23',9.091,5),(223,10077,10069,'232',9.091,5),(223,10078,10069,'32v',9.091,5),(223,10079,10069,'2vm',9.091,5),(223,10080,10069,'vm2',9.091,5),(224,10082,10081,'naa',100,5),(224,10083,10082,'600',3.333,5),(224,10084,10082,'000',3.333,5),(224,10085,10082,'00c',3.333,5),(224,10086,10082,'0c2',3.333,5),(224,10087,10082,'c29',3.333,5),(224,10088,10082,'299',3.333,5),(224,10089,10082,'992',3.333,5),(224,10090,10082,'924',3.333,5),(224,10091,10082,'242',3.333,5),(224,10092,10082,'42f',3.333,5),(224,10093,10082,'2f2',3.333,5),(224,10094,10082,'f2f',3.333,5),(224,10095,10082,'2fc',3.333,5),(224,10096,10082,'fcb',3.333,5),(224,10097,10082,'cb2',3.333,5),(224,10098,10082,'b24',3.333,5),(224,10099,10082,'24b',3.333,5),(224,10100,10082,'4b7',3.333,5),(224,10101,10082,'b70',3.333,5),(224,10102,10082,'70a',3.333,5),(224,10103,10082,'0a8',3.333,5),(224,10104,10082,'a80',3.333,5),(224,10105,10082,'806',3.333,5),(224,10106,10082,'06c',3.333,5),(224,10107,10082,'6cf',3.333,5),(224,10108,10082,'cfd',3.333,5),(224,10109,10082,'fd6',3.333,5),(224,10110,10082,'d64',3.333,5),(224,10111,10082,'648',3.333,5),(224,10112,10082,'483',3.333,5),(225,10114,10113,'naa',100,5),(225,10115,10114,'600',3.333,5),(225,10116,10114,'00a',3.333,5),(225,10117,10114,'0a0',3.333,5),(225,10118,10114,'a09',3.333,5),(225,10119,10114,'098',3.333,5),(225,10120,10114,'980',3.333,5),(225,10121,10114,'804',3.333,5),(225,10122,10114,'044',3.333,5),(225,10123,10114,'443',3.333,5),(225,10124,10114,'430',3.333,5),(225,10125,10114,'307',3.333,5),(225,10126,10114,'072',3.333,5),(225,10127,10114,'725',3.333,5),(225,10128,10114,'259',3.333,5),(225,10129,10114,'593',3.333,5),(225,10130,10114,'931',3.333,5),(225,10131,10114,'313',3.333,5),(225,10132,10114,'13f',3.333,5),(225,10133,10114,'3f3',3.333,5),(225,10134,10114,'f33',3.333,5),(225,10135,10114,'334',3.333,5),(225,10136,10114,'345',3.333,5),(225,10137,10114,'455',3.333,5),(225,10138,10114,'556',3.333,5),(225,10139,10114,'563',3.333,5),(225,10140,10114,'639',3.333,5),(225,10141,10114,'393',3.333,5),(225,10142,10114,'934',3.333,5),(225,10143,10114,'343',3.333,5),(225,10144,10114,'437',3.333,5),(226,10146,10145,'naa',100,5),(226,10147,10146,'600',3.333,5),(226,10148,10146,'00a',3.333,5),(226,10149,10146,'0a0',3.333,5),(226,10150,10146,'a09',3.333,5),(226,10151,10146,'098',3.333,5),(226,10152,10146,'980',3.333,5),(226,10153,10146,'804',3.333,5),(226,10154,10146,'044',3.333,5),(226,10155,10146,'443',3.333,5),(226,10156,10146,'430',3.333,5),(226,10157,10146,'307',3.333,5),(226,10158,10146,'075',3.333,5),(226,10159,10146,'753',3.333,5),(226,10160,10146,'535',3.333,5),(226,10161,10146,'357',3.333,5),(226,10162,10146,'573',3.333,5),(226,10163,10146,'732',3.333,5),(226,10164,10146,'32b',3.333,5),(226,10165,10146,'2b3',3.333,5),(226,10166,10146,'b33',3.333,5),(226,10167,10146,'334',3.333,5),(226,10168,10146,'345',3.333,5),(226,10169,10146,'457',3.333,5),(226,10170,10146,'571',3.333,5),(226,10171,10146,'715',3.333,5),(226,10172,10146,'153',3.333,5),(226,10173,10146,'533',3.333,5),(226,10174,10146,'335',3.333,5),(226,10175,10146,'357',3.333,5),(226,10176,10146,'573',3.333,5),(227,10178,10177,'naa',100,5),(227,10179,10178,'600',3.333,5),(227,10180,10178,'00a',3.333,5),(227,10181,10178,'0a0',3.333,5),(227,10182,10178,'a09',3.333,5),(227,10183,10178,'098',3.333,5),(227,10184,10178,'980',3.333,5),(227,10185,10178,'804',3.333,5),(227,10186,10178,'044',3.333,5),(227,10187,10178,'443',3.333,5),(227,10188,10178,'430',3.333,5),(227,10189,10178,'307',3.333,5),(227,10190,10178,'072',3.333,5),(227,10191,10178,'725',3.333,5),(227,10192,10178,'259',3.333,5),(227,10193,10178,'593',3.333,5),(227,10194,10178,'931',3.333,5),(227,10195,10178,'313',3.333,5),(227,10196,10178,'13f',3.333,5),(227,10197,10178,'3f3',3.333,5),(227,10198,10178,'f33',3.333,5),(227,10199,10178,'334',3.333,5),(227,10200,10178,'345',3.333,5),(227,10201,10178,'455',3.333,5),(227,10202,10178,'556',3.333,5),(227,10203,10178,'563',3.333,5),(227,10204,10178,'639',3.333,5),(227,10205,10178,'393',3.333,5),(227,10206,10178,'934',3.333,5),(227,10207,10178,'343',3.333,5),(227,10208,10178,'438',3.333,5),(228,10210,10209,'naa',100,5),(228,10211,10210,'600',3.333,5),(228,10212,10210,'00a',3.333,5),(228,10213,10210,'0a0',3.333,5),(228,10214,10210,'a09',3.333,5),(228,10215,10210,'098',3.333,5),(228,10216,10210,'980',3.333,5),(228,10217,10210,'804',3.333,5),(228,10218,10210,'044',3.333,5),(228,10219,10210,'443',3.333,5),(228,10220,10210,'430',3.333,5),(228,10221,10210,'307',3.333,5),(228,10222,10210,'075',3.333,5),(228,10223,10210,'753',3.333,5),(228,10224,10210,'535',3.333,5),(228,10225,10210,'357',3.333,5),(228,10226,10210,'573',3.333,5),(228,10227,10210,'732',3.333,5),(228,10228,10210,'32b',3.333,5),(228,10229,10210,'2b3',3.333,5),(228,10230,10210,'b33',3.333,5),(228,10231,10210,'334',3.333,5),(228,10232,10210,'345',3.333,5),(228,10233,10210,'457',3.333,5),(228,10234,10210,'571',3.333,5),(228,10235,10210,'715',3.333,5),(228,10236,10210,'153',3.333,5),(228,10237,10210,'533',3.333,5),(228,10238,10210,'335',3.333,5),(228,10239,10210,'357',3.333,5),(228,10240,10210,'574',3.333,5),(229,10242,10241,'naa',100,5),(229,10243,10242,'600',3.333,5),(229,10244,10242,'000',3.333,5),(229,10245,10242,'00c',3.333,5),(229,10246,10242,'0c2',3.333,5),(229,10247,10242,'c29',3.333,5),(229,10248,10242,'296',3.333,5),(229,10249,10242,'96b',3.333,5),(229,10250,10242,'6b3',3.333,5),(229,10251,10242,'b36',3.333,5),(229,10252,10242,'36c',3.333,5),(229,10253,10242,'6c8',3.333,5),(229,10254,10242,'c88',3.333,5),(229,10255,10242,'887',3.333,5),(229,10256,10242,'87c',3.333,5),(229,10257,10242,'7ce',3.333,5),(229,10258,10242,'cee',3.333,5),(229,10259,10242,'eec',3.333,5),(229,10260,10242,'ec4',3.333,5),(229,10261,10242,'c41',3.333,5),(229,10262,10242,'41b',3.333,5),(229,10263,10242,'1b5',3.333,5),(229,10264,10242,'b5e',3.333,5),(229,10265,10242,'5e4',3.333,5),(229,10266,10242,'e40',3.333,5),(229,10267,10242,'405',3.333,5),(229,10268,10242,'054',3.333,5),(229,10269,10242,'543',3.333,5),(229,10270,10242,'43c',3.333,5),(229,10271,10242,'3c6',3.333,5),(229,10272,10242,'c63',3.333,5),(230,10274,10273,'naa',100,5),(230,10275,10274,'600',3.333,5),(230,10276,10274,'000',3.333,5),(230,10277,10274,'00c',3.333,5),(230,10278,10274,'0c2',3.333,5),(230,10279,10274,'c29',3.333,5),(230,10280,10274,'29a',3.333,5),(230,10281,10274,'9a7',3.333,5),(230,10282,10274,'a76',3.333,5),(230,10283,10274,'765',3.333,5),(230,10284,10274,'65b',3.333,5),(230,10285,10274,'5bf',3.333,5),(230,10286,10274,'bf9',3.333,5),(230,10287,10274,'f9d',3.333,5),(230,10288,10274,'9dd',3.333,5),(230,10289,10274,'dd2',3.333,5),(230,10290,10274,'d27',3.333,5),(230,10291,10274,'273',3.333,5),(230,10292,10274,'734',3.333,5),(230,10293,10274,'349',3.333,5),(230,10294,10274,'49f',3.333,5),(230,10295,10274,'9f0',3.333,5),(230,10296,10274,'f08',3.333,5),(230,10297,10274,'08f',3.333,5),(230,10298,10274,'8fc',3.333,5),(230,10299,10274,'fcc',3.333,5),(230,10300,10274,'ccc',3.333,5),(230,10301,10274,'cc8',3.333,5),(230,10302,10274,'c80',3.333,5),(230,10303,10274,'80c',3.333,5),(230,10304,10274,'0c9',3.333,5),(231,10306,10305,'naa',100,5),(231,10307,10306,'600',3.333,5),(231,10308,10306,'000',3.333,5),(231,10309,10306,'00c',3.333,5),(231,10310,10306,'0c2',3.333,5),(231,10311,10306,'c29',3.333,5),(231,10312,10306,'29b',3.333,5),(231,10313,10306,'9b3',3.333,5),(231,10314,10306,'b32',3.333,5),(231,10315,10306,'322',3.333,5),(231,10316,10306,'222',3.333,5),(231,10317,10306,'229',3.333,5),(231,10318,10306,'295',3.333,5),(231,10319,10306,'956',3.333,5),(231,10320,10306,'568',3.333,5),(231,10321,10306,'685',3.333,5),(231,10322,10306,'854',3.333,5),(231,10323,10306,'548',3.333,5),(231,10324,10306,'487',3.333,5),(231,10325,10306,'879',3.333,5),(231,10326,10306,'794',3.333,5),(231,10327,10306,'946',3.333,5),(231,10328,10306,'461',3.333,5),(231,10329,10306,'61d',3.333,5),(231,10330,10306,'1dd',3.333,5),(231,10331,10306,'dd9',3.333,5),(231,10332,10306,'d96',3.333,5),(231,10333,10306,'964',3.333,5),(231,10334,10306,'64e',3.333,5),(231,10335,10306,'4e8',3.333,5),(231,10336,10306,'e80',3.333,5),(232,10338,10337,'naa',100,5),(232,10339,10338,'600',3.333,5),(232,10340,10338,'000',3.333,5),(232,10341,10338,'00c',3.333,5),(232,10342,10338,'0c2',3.333,5),(232,10343,10338,'c29',3.333,5),(232,10344,10338,'292',3.333,5),(232,10345,10338,'92e',3.333,5),(232,10346,10338,'2e0',3.333,5),(232,10347,10338,'e06',3.333,5),(232,10348,10338,'063',3.333,5),(232,10349,10338,'633',3.333,5),(232,10350,10338,'33d',3.333,5),(232,10351,10338,'3db',3.333,5),(232,10352,10338,'db9',3.333,5),(232,10353,10338,'b9e',3.333,5),(232,10354,10338,'9e8',3.333,5),(232,10355,10338,'e8f',3.333,5),(232,10356,10338,'8f9',3.333,5),(232,10357,10338,'f95',3.333,5),(232,10358,10338,'955',3.333,5),(232,10359,10338,'555',3.333,5),(232,10360,10338,'55d',3.333,5),(232,10361,10338,'5d6',3.333,5),(232,10362,10338,'d65',3.333,5),(232,10363,10338,'658',3.333,5),(232,10364,10338,'58a',3.333,5),(232,10365,10338,'8ad',3.333,5),(232,10366,10338,'ad2',3.333,5),(232,10367,10338,'d2c',3.333,5),(232,10368,10338,'2ca',3.333,5),(233,10370,10369,'naa',100,5),(233,10371,10370,'600',3.333,5),(233,10372,10370,'000',3.333,5),(233,10373,10370,'00c',3.333,5),(233,10374,10370,'0c2',3.333,5),(233,10375,10370,'c29',3.333,5),(233,10376,10370,'293',3.333,5),(233,10377,10370,'936',3.333,5),(233,10378,10370,'362',3.333,5),(233,10379,10370,'62e',3.333,5),(233,10380,10370,'2e5',3.333,5),(233,10381,10370,'e53',3.333,5),(233,10382,10370,'532',3.333,5),(233,10383,10370,'32d',3.333,5),(233,10384,10370,'2d0',3.333,5),(233,10385,10370,'d04',3.333,5),(233,10386,10370,'043',3.333,5),(233,10387,10370,'433',3.333,5),(233,10388,10370,'33c',3.333,5),(233,10389,10370,'3c7',3.333,5),(233,10390,10370,'c7b',3.333,5),(233,10391,10370,'7b0',3.333,5),(233,10392,10370,'b0f',3.333,5),(233,10393,10370,'0f3',3.333,5),(233,10394,10370,'f3f',3.333,5),(233,10395,10370,'3f4',3.333,5),(233,10396,10370,'f44',3.333,5),(233,10397,10370,'444',3.333,5),(233,10398,10370,'448',3.333,5),(233,10399,10370,'480',3.333,5),(233,10400,10370,'807',3.333,5),(234,10402,10401,'naa',100,5),(234,10403,10402,'600',3.333,5),(234,10404,10402,'000',3.333,5),(234,10405,10402,'00c',3.333,5),(234,10406,10402,'0c2',3.333,5),(234,10407,10402,'c29',3.333,5),(234,10408,10402,'295',3.333,5),(234,10409,10402,'953',3.333,5),(234,10410,10402,'532',3.333,5),(234,10411,10402,'32d',3.333,5),(234,10412,10402,'2d9',3.333,5),(234,10413,10402,'d9e',3.333,5),(234,10414,10402,'9e7',3.333,5),(234,10415,10402,'e75',3.333,5),(234,10416,10402,'757',3.333,5),(234,10417,10402,'575',3.333,5),(234,10418,10402,'758',3.333,5),(234,10419,10402,'580',3.333,5),(234,10420,10402,'806',3.333,5),(234,10421,10402,'061',3.333,5),(234,10422,10402,'61c',3.333,5),(234,10423,10402,'1ca',3.333,5),(234,10424,10402,'ca5',3.333,5),(234,10425,10402,'a5a',3.333,5),(234,10426,10402,'5a9',3.333,5),(234,10427,10402,'a90',3.333,5),(234,10428,10402,'90c',3.333,5),(234,10429,10402,'0c3',3.333,5),(234,10430,10402,'c37',3.333,5),(234,10431,10402,'374',3.333,5),(234,10432,10402,'743',3.333,5),(235,10434,10433,'naa',100,5),(235,10435,10434,'600',3.333,5),(235,10436,10434,'000',3.333,5),(235,10437,10434,'00c',3.333,5),(235,10438,10434,'0c2',3.333,5),(235,10439,10434,'c29',3.333,5),(235,10440,10434,'290',3.333,5),(235,10441,10434,'902',3.333,5),(235,10442,10434,'02d',3.333,5),(235,10443,10434,'2d5',3.333,5),(235,10444,10434,'d5b',3.333,5),(235,10445,10434,'5ba',3.333,5),(235,10446,10434,'ba8',3.333,5),(235,10447,10434,'a8b',3.333,5),(235,10448,10434,'8be',3.333,5),(235,10449,10434,'be5',3.333,5),(235,10450,10434,'e59',3.333,5),(235,10451,10434,'596',3.333,5),(235,10452,10434,'966',3.333,5),(235,10453,10434,'660',3.333,5),(235,10454,10434,'605',3.333,5),(235,10455,10434,'051',3.333,5),(235,10456,10434,'517',3.333,5),(235,10457,10434,'177',3.333,5),(235,10458,10434,'779',3.333,5),(235,10459,10434,'79f',3.333,5),(235,10460,10434,'9f7',3.333,5),(235,10461,10434,'f73',3.333,5),(235,10462,10434,'739',3.333,5),(235,10463,10434,'394',3.333,5),(235,10464,10434,'945',3.333,5),(236,10466,10465,'naa',100,5),(236,10467,10466,'600',3.333,5),(236,10468,10466,'000',3.333,5),(236,10469,10466,'00c',3.333,5),(236,10470,10466,'0c2',3.333,5),(236,10471,10466,'c29',3.333,5),(236,10472,10466,'293',3.333,5),(236,10473,10466,'93d',3.333,5),(236,10474,10466,'3d2',3.333,5),(236,10475,10466,'d27',3.333,5),(236,10476,10466,'272',3.333,5),(236,10477,10466,'725',3.333,5),(236,10478,10466,'251',3.333,5),(236,10479,10466,'51a',3.333,5),(236,10480,10466,'1a8',3.333,5),(236,10481,10466,'a8a',3.333,5),(236,10482,10466,'8a3',3.333,5),(236,10483,10466,'a3f',3.333,5),(236,10484,10466,'3f1',3.333,5),(236,10485,10466,'f12',3.333,5),(236,10486,10466,'12a',3.333,5),(236,10487,10466,'2ac',3.333,5),(236,10488,10466,'acc',3.333,5),(236,10489,10466,'ccf',3.333,5),(236,10490,10466,'cfb',3.333,5),(236,10491,10466,'fb9',3.333,5),(236,10492,10466,'b90',3.333,5),(236,10493,10466,'90b',3.333,5),(236,10494,10466,'0bf',3.333,5),(236,10495,10466,'bfc',3.333,5),(236,10496,10466,'fc3',3.333,5),(237,10498,10497,'naa',100,5),(237,10499,10498,'600',3.333,5),(237,10500,10498,'000',3.333,5),(237,10501,10498,'00c',3.333,5),(237,10502,10498,'0c2',3.333,5),(237,10503,10498,'c29',3.333,5),(237,10504,10498,'29a',3.333,5),(237,10505,10498,'9a2',3.333,5),(237,10506,10498,'a2e',3.333,5),(237,10507,10498,'2ed',3.333,5),(237,10508,10498,'eda',3.333,5),(237,10509,10498,'dac',3.333,5),(237,10510,10498,'ac2',3.333,5),(237,10511,10498,'c2d',3.333,5),(237,10512,10498,'2d4',3.333,5),(237,10513,10498,'d4e',3.333,5),(237,10514,10498,'4e7',3.333,5),(237,10515,10498,'e7c',3.333,5),(237,10516,10498,'7c2',3.333,5),(237,10517,10498,'c2f',3.333,5),(237,10518,10498,'2f0',3.333,5),(237,10519,10498,'f01',3.333,5),(237,10520,10498,'015',3.333,5),(237,10521,10498,'15c',3.333,5),(237,10522,10498,'5ce',3.333,5),(237,10523,10498,'ced',3.333,5),(237,10524,10498,'ed5',3.333,5),(237,10525,10498,'d57',3.333,5),(237,10526,10498,'57b',3.333,5),(237,10527,10498,'7b6',3.333,5),(237,10528,10498,'b68',3.333,5),(238,10530,10529,'naa',100,5),(238,10531,10530,'600',3.333,5),(238,10532,10530,'000',3.333,5),(238,10533,10530,'00c',3.333,5),(238,10534,10530,'0c2',3.333,5),(238,10535,10530,'c29',3.333,5),(238,10536,10530,'29d',3.333,5),(238,10537,10530,'9dc',3.333,5),(238,10538,10530,'dc6',3.333,5),(238,10539,10530,'c66',3.333,5),(238,10540,10530,'66f',3.333,5),(238,10541,10530,'6f1',3.333,5),(238,10542,10530,'f18',3.333,5),(238,10543,10530,'186',3.333,5),(238,10544,10530,'867',3.333,5),(238,10545,10530,'679',3.333,5),(238,10546,10530,'790',3.333,5),(238,10547,10530,'90f',3.333,5),(238,10548,10530,'0f6',3.333,5),(238,10549,10530,'f6c',3.333,5),(238,10550,10530,'6c6',3.333,5),(238,10551,10530,'c65',3.333,5),(238,10552,10530,'654',3.333,5),(238,10553,10530,'544',3.333,5),(238,10554,10530,'449',3.333,5),(238,10555,10530,'494',3.333,5),(238,10556,10530,'94f',3.333,5),(238,10557,10530,'4fe',3.333,5),(238,10558,10530,'feb',3.333,5),(238,10559,10530,'eb0',3.333,5),(238,10560,10530,'b0f',3.333,5),(239,10562,10561,'naa',100,5),(239,10563,10562,'600',3.333,5),(239,10564,10562,'000',3.333,5),(239,10565,10562,'00c',3.333,5),(239,10566,10562,'0c2',3.333,5),(239,10567,10562,'c29',3.333,5),(239,10568,10562,'298',3.333,5),(239,10569,10562,'983',3.333,5),(239,10570,10562,'83a',3.333,5),(239,10571,10562,'3a5',3.333,5),(239,10572,10562,'a52',3.333,5),(239,10573,10562,'528',3.333,5),(239,10574,10562,'286',3.333,5),(239,10575,10562,'862',3.333,5),(239,10576,10562,'624',3.333,5),(239,10577,10562,'249',3.333,5),(239,10578,10562,'49c',3.333,5),(239,10579,10562,'9c3',3.333,5),(239,10580,10562,'c37',3.333,5),(239,10581,10562,'37e',3.333,5),(239,10582,10562,'7e5',3.333,5),(239,10583,10562,'e5d',3.333,5),(239,10584,10562,'5d0',3.333,5),(239,10585,10562,'d02',3.333,5),(239,10586,10562,'021',3.333,5),(239,10587,10562,'219',3.333,5),(239,10588,10562,'190',3.333,5),(239,10589,10562,'904',3.333,5),(239,10590,10562,'04a',3.333,5),(239,10591,10562,'4aa',3.333,5),(239,10592,10562,'aaa',3.333,5),(240,10594,10593,'naa',100,5),(240,10595,10594,'600',3.333,5),(240,10596,10594,'000',3.333,5),(240,10597,10594,'00c',3.333,5),(240,10598,10594,'0c2',3.333,5),(240,10599,10594,'c29',3.333,5),(240,10600,10594,'294',3.333,5),(240,10601,10594,'94e',3.333,5),(240,10602,10594,'4e3',3.333,5),(240,10603,10594,'e3b',3.333,5),(240,10604,10594,'3b5',3.333,5),(240,10605,10594,'b59',3.333,5),(240,10606,10594,'594',3.333,5),(240,10607,10594,'94e',3.333,5),(240,10608,10594,'4ec',3.333,5),(240,10609,10594,'ec7',3.333,5),(240,10610,10594,'c72',3.333,5),(240,10611,10594,'724',3.333,5),(240,10612,10594,'24e',3.333,5),(240,10613,10594,'4e3',3.333,5),(240,10614,10594,'e3a',3.333,5),(240,10615,10594,'3a4',3.333,5),(240,10616,10594,'a4d',3.333,5),(240,10617,10594,'4db',3.333,5),(240,10618,10594,'db1',3.333,5),(240,10619,10594,'b1a',3.333,5),(240,10620,10594,'1a4',3.333,5),(240,10621,10594,'a45',3.333,5),(240,10622,10594,'451',3.333,5),(240,10623,10594,'516',3.333,5),(240,10624,10594,'16c',3.333,5),(241,10626,10625,'naa',100,5),(241,10627,10626,'600',3.333,5),(241,10628,10626,'000',3.333,5),(241,10629,10626,'00c',3.333,5),(241,10630,10626,'0c2',3.333,5),(241,10631,10626,'c29',3.333,5),(241,10632,10626,'290',3.333,5),(241,10633,10626,'90a',3.333,5),(241,10634,10626,'0a1',3.333,5),(241,10635,10626,'a1e',3.333,5),(241,10636,10626,'1e6',3.333,5),(241,10637,10626,'e6f',3.333,5),(241,10638,10626,'6f7',3.333,5),(241,10639,10626,'f7d',3.333,5),(241,10640,10626,'7dc',3.333,5),(241,10641,10626,'dcd',3.333,5),(241,10642,10626,'cd6',3.333,5),(241,10643,10626,'d64',3.333,5),(241,10644,10626,'64b',3.333,5),(241,10645,10626,'4ba',3.333,5),(241,10646,10626,'bad',3.333,5),(241,10647,10626,'ad2',3.333,5),(241,10648,10626,'d2f',3.333,5),(241,10649,10626,'2f0',3.333,5),(241,10650,10626,'f05',3.333,5),(241,10651,10626,'050',3.333,5),(241,10652,10626,'508',3.333,5),(241,10653,10626,'08e',3.333,5),(241,10654,10626,'8e1',3.333,5),(241,10655,10626,'e1e',3.333,5),(241,10656,10626,'1ea',3.333,5),(242,10658,10657,'naa',100,5),(242,10659,10658,'600',3.333,5),(242,10660,10658,'000',3.333,5),(242,10661,10658,'00c',3.333,5),(242,10662,10658,'0c2',3.333,5),(242,10663,10658,'c29',3.333,5),(242,10664,10658,'294',3.333,5),(242,10665,10658,'947',3.333,5),(242,10666,10658,'475',3.333,5),(242,10667,10658,'75b',3.333,5),(242,10668,10658,'5b9',3.333,5),(242,10669,10658,'b97',3.333,5),(242,10670,10658,'97b',3.333,5),(242,10671,10658,'7b7',3.333,5),(242,10672,10658,'b7e',3.333,5),(242,10673,10658,'7e2',3.333,5),(242,10674,10658,'e2d',3.333,5),(242,10675,10658,'2d7',3.333,5),(242,10676,10658,'d72',3.333,5),(242,10677,10658,'72a',3.333,5),(242,10678,10658,'2ab',3.333,5),(242,10679,10658,'ab1',3.333,5),(242,10680,10658,'b1a',3.333,5),(242,10681,10658,'1a2',3.333,5),(242,10682,10658,'a29',3.333,5),(242,10683,10658,'29b',3.333,5),(242,10684,10658,'9ba',3.333,5),(242,10685,10658,'ba0',3.333,5),(242,10686,10658,'a04',3.333,5),(242,10687,10658,'04a',3.333,5),(242,10688,10658,'4a0',3.333,5),(243,10690,10689,'naa',100,5),(243,10691,10690,'600',3.333,5),(243,10692,10690,'000',3.333,5),(243,10693,10690,'00c',3.333,5),(243,10694,10690,'0c2',3.333,5),(243,10695,10690,'c29',3.333,5),(243,10696,10690,'291',3.333,5),(243,10697,10690,'916',3.333,5),(243,10698,10690,'163',3.333,5),(243,10699,10690,'630',3.333,5),(243,10700,10690,'30b',3.333,5),(243,10701,10690,'0bf',3.333,5),(243,10702,10690,'bfd',3.333,5),(243,10703,10690,'fde',3.333,5),(243,10704,10690,'de3',3.333,5),(243,10705,10690,'e37',3.333,5),(243,10706,10690,'372',3.333,5),(243,10707,10690,'725',3.333,5),(243,10708,10690,'25b',3.333,5),(243,10709,10690,'5bb',3.333,5),(243,10710,10690,'bb0',3.333,5),(243,10711,10690,'b05',3.333,5),(243,10712,10690,'058',3.333,5),(243,10713,10690,'588',3.333,5),(243,10714,10690,'887',3.333,5),(243,10715,10690,'877',3.333,5),(243,10716,10690,'773',3.333,5),(243,10717,10690,'739',3.333,5),(243,10718,10690,'39b',3.333,5),(243,10719,10690,'9ba',3.333,5),(243,10720,10690,'ba8',3.333,5),(244,10722,10721,'naa',100,5),(244,10723,10722,'600',3.333,5),(244,10724,10722,'000',3.333,5),(244,10725,10722,'00c',3.333,5),(244,10726,10722,'0c2',3.333,5),(244,10727,10722,'c29',3.333,5),(244,10728,10722,'299',3.333,5),(244,10729,10722,'990',3.333,5),(244,10730,10722,'909',3.333,5),(244,10731,10722,'09b',3.333,5),(244,10732,10722,'9ba',3.333,5),(244,10733,10722,'baa',3.333,5),(244,10734,10722,'aac',3.333,5),(244,10735,10722,'ac3',3.333,5),(244,10736,10722,'c34',3.333,5),(244,10737,10722,'34d',3.333,5),(244,10738,10722,'4d1',3.333,5),(244,10739,10722,'d17',3.333,5),(244,10740,10722,'177',3.333,5),(244,10741,10722,'77a',3.333,5),(244,10742,10722,'7a4',3.333,5),(244,10743,10722,'a4a',3.333,5),(244,10744,10722,'4a3',3.333,5),(244,10745,10722,'a38',3.333,5),(244,10746,10722,'384',3.333,5),(244,10747,10722,'840',3.333,5),(244,10748,10722,'403',3.333,5),(244,10749,10722,'032',3.333,5),(244,10750,10722,'328',3.333,5),(244,10751,10722,'28b',3.333,5),(244,10752,10722,'8b8',3.333,5),(245,10754,10753,'naa',100,5),(245,10755,10754,'600',3.333,5),(245,10756,10754,'000',3.333,5),(245,10757,10754,'00c',3.333,5),(245,10758,10754,'0c2',3.333,5),(245,10759,10754,'c29',3.333,5),(245,10760,10754,'292',3.333,5),(245,10761,10754,'925',3.333,5),(245,10762,10754,'25e',3.333,5),(245,10763,10754,'5e6',3.333,5),(245,10764,10754,'e67',3.333,5),(245,10765,10754,'675',3.333,5),(245,10766,10754,'758',3.333,5),(245,10767,10754,'588',3.333,5),(245,10768,10754,'888',3.333,5),(245,10769,10754,'884',3.333,5),(245,10770,10754,'84a',3.333,5),(245,10771,10754,'4ac',3.333,5),(245,10772,10754,'ac5',3.333,5),(245,10773,10754,'c57',3.333,5),(245,10774,10754,'57c',3.333,5),(245,10775,10754,'7c7',3.333,5),(245,10776,10754,'c7a',3.333,5),(245,10777,10754,'7ae',3.333,5),(245,10778,10754,'ae8',3.333,5),(245,10779,10754,'e89',3.333,5),(245,10780,10754,'894',3.333,5),(245,10781,10754,'94e',3.333,5),(245,10782,10754,'4ee',3.333,5),(245,10783,10754,'ee8',3.333,5),(245,10784,10754,'e86',3.333,5),(246,10786,10785,'naa',100,5),(246,10787,10786,'600',3.333,5),(246,10788,10786,'000',3.333,5),(246,10789,10786,'00c',3.333,5),(246,10790,10786,'0c2',3.333,5),(246,10791,10786,'c29',3.333,5),(246,10792,10786,'295',3.333,5),(246,10793,10786,'950',3.333,5),(246,10794,10786,'509',3.333,5),(246,10795,10786,'09f',3.333,5),(246,10796,10786,'9fa',3.333,5),(246,10797,10786,'fa9',3.333,5),(246,10798,10786,'a9a',3.333,5),(246,10799,10786,'9ac',3.333,5),(246,10800,10786,'ac4',3.333,5),(246,10801,10786,'c43',3.333,5),(246,10802,10786,'43e',3.333,5),(246,10803,10786,'3eb',3.333,5),(246,10804,10786,'eb7',3.333,5),(246,10805,10786,'b73',3.333,5),(246,10806,10786,'732',3.333,5),(246,10807,10786,'32b',3.333,5),(246,10808,10786,'2b1',3.333,5),(246,10809,10786,'b1b',3.333,5),(246,10810,10786,'1b2',3.333,5),(246,10811,10786,'b2d',3.333,5),(246,10812,10786,'2d9',3.333,5),(246,10813,10786,'d9a',3.333,5),(246,10814,10786,'9a0',3.333,5),(246,10815,10786,'a0f',3.333,5),(246,10816,10786,'0f4',3.333,5),(247,10818,10817,'naa',100,5),(247,10819,10818,'600',3.333,5),(247,10820,10818,'000',3.333,5),(247,10821,10818,'00c',3.333,5),(247,10822,10818,'0c2',3.333,5),(247,10823,10818,'c29',3.333,5),(247,10824,10818,'296',3.333,5),(247,10825,10818,'965',3.333,5),(247,10826,10818,'659',3.333,5),(247,10827,10818,'59d',3.333,5),(247,10828,10818,'9d5',3.333,5),(247,10829,10818,'d5e',3.333,5),(247,10830,10818,'5ed',3.333,5),(247,10831,10818,'ed1',3.333,5),(247,10832,10818,'d1d',3.333,5),(247,10833,10818,'1d9',3.333,5),(247,10834,10818,'d99',3.333,5),(247,10835,10818,'994',3.333,5),(247,10836,10818,'94f',3.333,5),(247,10837,10818,'4fe',3.333,5),(247,10838,10818,'feb',3.333,5),(247,10839,10818,'eb8',3.333,5),(247,10840,10818,'b86',3.333,5),(247,10841,10818,'862',3.333,5),(247,10842,10818,'62b',3.333,5),(247,10843,10818,'2b3',3.333,5),(247,10844,10818,'b35',3.333,5),(247,10845,10818,'35f',3.333,5),(247,10846,10818,'5f5',3.333,5),(247,10847,10818,'f56',3.333,5),(247,10848,10818,'563',3.333,5),(248,10850,10849,'naa',100,5),(248,10851,10850,'600',3.333,5),(248,10852,10850,'000',3.333,5),(248,10853,10850,'00c',3.333,5),(248,10854,10850,'0c2',3.333,5),(248,10855,10850,'c29',3.333,5),(248,10856,10850,'297',3.333,5),(248,10857,10850,'97f',3.333,5),(248,10858,10850,'7f0',3.333,5),(248,10859,10850,'f07',3.333,5),(248,10860,10850,'078',3.333,5),(248,10861,10850,'78b',3.333,5),(248,10862,10850,'8b4',3.333,5),(248,10863,10850,'b46',3.333,5),(248,10864,10850,'46c',3.333,5),(248,10865,10850,'6cc',3.333,5),(248,10866,10850,'cc9',3.333,5),(248,10867,10850,'c95',3.333,5),(248,10868,10850,'95f',3.333,5),(248,10869,10850,'5f6',3.333,5),(248,10870,10850,'f68',3.333,5),(248,10871,10850,'683',3.333,5),(248,10872,10850,'83d',3.333,5),(248,10873,10850,'3d3',3.333,5),(248,10874,10850,'d3f',3.333,5),(248,10875,10850,'3fa',3.333,5),(248,10876,10850,'fad',3.333,5),(248,10877,10850,'ad2',3.333,5),(248,10878,10850,'d23',3.333,5),(248,10879,10850,'230',3.333,5),(248,10880,10850,'304',3.333,5),(249,10882,10881,'naa',100,5),(249,10883,10882,'600',3.333,5),(249,10884,10882,'000',3.333,5),(249,10885,10882,'00c',3.333,5),(249,10886,10882,'0c2',3.333,5),(249,10887,10882,'c29',3.333,5),(249,10888,10882,'292',3.333,5),(249,10889,10882,'92d',3.333,5),(249,10890,10882,'2da',3.333,5),(249,10891,10882,'da5',3.333,5),(249,10892,10882,'a51',3.333,5),(249,10893,10882,'51f',3.333,5),(249,10894,10882,'1f1',3.333,5),(249,10895,10882,'f1a',3.333,5),(249,10896,10882,'1aa',3.333,5),(249,10897,10882,'aa3',3.333,5),(249,10898,10882,'a36',3.333,5),(249,10899,10882,'36a',3.333,5),(249,10900,10882,'6aa',3.333,5),(249,10901,10882,'aa0',3.333,5),(249,10902,10882,'a0f',3.333,5),(249,10903,10882,'0f8',3.333,5),(249,10904,10882,'f8f',3.333,5),(249,10905,10882,'8f3',3.333,5),(249,10906,10882,'f36',3.333,5),(249,10907,10882,'36a',3.333,5),(249,10908,10882,'6ab',3.333,5),(249,10909,10882,'ab6',3.333,5),(249,10910,10882,'b63',3.333,5),(249,10911,10882,'63a',3.333,5),(249,10912,10882,'3a1',3.333,5),(250,10914,10913,'naa',100,5),(250,10915,10914,'600',3.333,5),(250,10916,10914,'000',3.333,5),(250,10917,10914,'00c',3.333,5),(250,10918,10914,'0c2',3.333,5),(250,10919,10914,'c29',3.333,5),(250,10920,10914,'290',3.333,5),(250,10921,10914,'90b',3.333,5),(250,10922,10914,'0b4',3.333,5),(250,10923,10914,'b44',3.333,5),(250,10924,10914,'447',3.333,5),(250,10925,10914,'472',3.333,5),(250,10926,10914,'722',3.333,5),(250,10927,10914,'224',3.333,5),(250,10928,10914,'24a',3.333,5),(250,10929,10914,'4a3',3.333,5),(250,10930,10914,'a36',3.333,5),(250,10931,10914,'367',3.333,5),(250,10932,10914,'67a',3.333,5),(250,10933,10914,'7ae',3.333,5),(250,10934,10914,'ae8',3.333,5),(250,10935,10914,'e88',3.333,5),(250,10936,10914,'887',3.333,5),(250,10937,10914,'872',3.333,5),(250,10938,10914,'729',3.333,5),(250,10939,10914,'29a',3.333,5),(250,10940,10914,'9a1',3.333,5),(250,10941,10914,'a10',3.333,5),(250,10942,10914,'104',3.333,5),(250,10943,10914,'048',3.333,5),(250,10944,10914,'481',3.333,5),(251,10946,10945,'naa',100,5),(251,10947,10946,'600',3.333,5),(251,10948,10946,'000',3.333,5),(251,10949,10946,'00c',3.333,5),(251,10950,10946,'0c2',3.333,5),(251,10951,10946,'c29',3.333,5),(251,10952,10946,'295',3.333,5),(251,10953,10946,'95e',3.333,5),(251,10954,10946,'5e3',3.333,5),(251,10955,10946,'e3f',3.333,5),(251,10956,10946,'3f8',3.333,5),(251,10957,10946,'f8a',3.333,5),(251,10958,10946,'8a5',3.333,5),(251,10959,10946,'a5d',3.333,5),(251,10960,10946,'5d4',3.333,5),(251,10961,10946,'d41',3.333,5),(251,10962,10946,'411',3.333,5),(251,10963,10946,'112',3.333,5),(251,10964,10946,'12e',3.333,5),(251,10965,10946,'2ee',3.333,5),(251,10966,10946,'eea',3.333,5),(251,10967,10946,'ea7',3.333,5),(251,10968,10946,'a72',3.333,5),(251,10969,10946,'727',3.333,5),(251,10970,10946,'271',3.333,5),(251,10971,10946,'713',3.333,5),(251,10972,10946,'13d',3.333,5),(251,10973,10946,'3da',3.333,5),(251,10974,10946,'daf',3.333,5),(251,10975,10946,'afc',3.333,5),(251,10976,10946,'fc7',3.333,5),(252,10978,10977,'naa',100,5),(252,10979,10978,'600',3.333,5),(252,10980,10978,'000',3.333,5),(252,10981,10978,'00c',3.333,5),(252,10982,10978,'0c2',3.333,5),(252,10983,10978,'c29',3.333,5),(252,10984,10978,'292',3.333,5),(252,10985,10978,'928',3.333,5),(252,10986,10978,'28d',3.333,5),(252,10987,10978,'8d3',3.333,5),(252,10988,10978,'d38',3.333,5),(252,10989,10978,'384',3.333,5),(252,10990,10978,'847',3.333,5),(252,10991,10978,'47d',3.333,5),(252,10992,10978,'7de',3.333,5),(252,10993,10978,'de8',3.333,5),(252,10994,10978,'e8b',3.333,5),(252,10995,10978,'8b7',3.333,5),(252,10996,10978,'b71',3.333,5),(252,10997,10978,'714',3.333,5),(252,10998,10978,'149',3.333,5),(252,10999,10978,'494',3.333,5),(252,11000,10978,'947',3.333,5),(252,11001,10978,'47e',3.333,5),(252,11002,10978,'7eb',3.333,5),(252,11003,10978,'ebe',3.333,5),(252,11004,10978,'be8',3.333,5),(252,11005,10978,'e88',3.333,5),(252,11006,10978,'881',3.333,5),(252,11007,10978,'813',3.333,5),(252,11008,10978,'135',3.333,5),(253,11010,11009,'naa',100,5),(253,11011,11010,'600',3.333,5),(253,11012,11010,'000',3.333,5),(253,11013,11010,'00c',3.333,5),(253,11014,11010,'0c2',3.333,5),(253,11015,11010,'c29',3.333,5),(253,11016,11010,'296',3.333,5),(253,11017,11010,'962',3.333,5),(253,11018,11010,'625',3.333,5),(253,11019,11010,'25d',3.333,5),(253,11020,11010,'5d8',3.333,5),(253,11021,11010,'d80',3.333,5),(253,11022,11010,'808',3.333,5),(253,11023,11010,'08e',3.333,5),(253,11024,11010,'8ed',3.333,5),(253,11025,11010,'ede',3.333,5),(253,11026,11010,'de9',3.333,5),(253,11027,11010,'e95',3.333,5),(253,11028,11010,'952',3.333,5),(253,11029,11010,'52e',3.333,5),(253,11030,11010,'2e2',3.333,5),(253,11031,11010,'e2c',3.333,5),(253,11032,11010,'2c0',3.333,5),(253,11033,11010,'c05',3.333,5),(253,11034,11010,'058',3.333,5),(253,11035,11010,'58c',3.333,5),(253,11036,11010,'8cf',3.333,5),(253,11037,11010,'cf1',3.333,5),(253,11038,11010,'f1a',3.333,5),(253,11039,11010,'1a3',3.333,5),(253,11040,11010,'a34',3.333,5),(254,11042,11041,'naa',100,5),(254,11043,11042,'600',3.333,5),(254,11044,11042,'000',3.333,5),(254,11045,11042,'00c',3.333,5),(254,11046,11042,'0c2',3.333,5),(254,11047,11042,'c29',3.333,5),(254,11048,11042,'297',3.333,5),(254,11049,11042,'973',3.333,5),(254,11050,11042,'73f',3.333,5),(254,11051,11042,'3fc',3.333,5),(254,11052,11042,'fc3',3.333,5),(254,11053,11042,'c35',3.333,5),(254,11054,11042,'357',3.333,5),(254,11055,11042,'578',3.333,5),(254,11056,11042,'786',3.333,5),(254,11057,11042,'862',3.333,5),(254,11058,11042,'62a',3.333,5),(254,11059,11042,'2a1',3.333,5),(254,11060,11042,'a1d',3.333,5),(254,11061,11042,'1d1',3.333,5),(254,11062,11042,'d1f',3.333,5),(254,11063,11042,'1f9',3.333,5),(254,11064,11042,'f9a',3.333,5),(254,11065,11042,'9aa',3.333,5),(254,11066,11042,'aad',3.333,5),(254,11067,11042,'ad0',3.333,5),(254,11068,11042,'d0e',3.333,5),(254,11069,11042,'0ee',3.333,5),(254,11070,11042,'ee3',3.333,5),(254,11071,11042,'e35',3.333,5),(254,11072,11042,'35d',3.333,5),(255,11074,11073,'naa',100,5),(255,11075,11074,'600',3.333,5),(255,11076,11074,'000',3.333,5),(255,11077,11074,'00c',3.333,5),(255,11078,11074,'0c2',3.333,5),(255,11079,11074,'c29',3.333,5),(255,11080,11074,'292',3.333,5),(255,11081,11074,'92d',3.333,5),(255,11082,11074,'2dc',3.333,5),(255,11083,11074,'dc5',3.333,5),(255,11084,11074,'c5b',3.333,5),(255,11085,11074,'5b7',3.333,5),(255,11086,11074,'b74',3.333,5),(255,11087,11074,'74e',3.333,5),(255,11088,11074,'4ee',3.333,5),(255,11089,11074,'eee',3.333,5),(255,11090,11074,'eed',3.333,5),(255,11091,11074,'ed4',3.333,5),(255,11092,11074,'d4b',3.333,5),(255,11093,11074,'4bd',3.333,5),(255,11094,11074,'bd4',3.333,5),(255,11095,11074,'d44',3.333,5),(255,11096,11074,'445',3.333,5),(255,11097,11074,'459',3.333,5),(255,11098,11074,'591',3.333,5),(255,11099,11074,'913',3.333,5),(255,11100,11074,'134',3.333,5),(255,11101,11074,'340',3.333,5),(255,11102,11074,'40e',3.333,5),(255,11103,11074,'0e1',3.333,5),(255,11104,11074,'e16',3.333,5),(256,11106,11105,'naa',100,5),(256,11107,11106,'600',3.333,5),(256,11108,11106,'000',3.333,5),(256,11109,11106,'00c',3.333,5),(256,11110,11106,'0c2',3.333,5),(256,11111,11106,'c29',3.333,5),(256,11112,11106,'29c',3.333,5),(256,11113,11106,'9c2',3.333,5),(256,11114,11106,'c21',3.333,5),(256,11115,11106,'21b',3.333,5),(256,11116,11106,'1bb',3.333,5),(256,11117,11106,'bb9',3.333,5),(256,11118,11106,'b97',3.333,5),(256,11119,11106,'973',3.333,5),(256,11120,11106,'73e',3.333,5),(256,11121,11106,'3e9',3.333,5),(256,11122,11106,'e92',3.333,5),(256,11123,11106,'92f',3.333,5),(256,11124,11106,'2f9',3.333,5),(256,11125,11106,'f99',3.333,5),(256,11126,11106,'998',3.333,5),(256,11127,11106,'98b',3.333,5),(256,11128,11106,'8be',3.333,5),(256,11129,11106,'bea',3.333,5),(256,11130,11106,'ea1',3.333,5),(256,11131,11106,'a19',3.333,5),(256,11132,11106,'193',3.333,5),(256,11133,11106,'93d',3.333,5),(256,11134,11106,'3dd',3.333,5),(256,11135,11106,'dd1',3.333,5),(256,11136,11106,'d18',3.333,5),(257,11138,11137,'naa',100,5),(257,11139,11138,'600',3.333,5),(257,11140,11138,'000',3.333,5),(257,11141,11138,'00c',3.333,5),(257,11142,11138,'0c2',3.333,5),(257,11143,11138,'c29',3.333,5),(257,11144,11138,'291',3.333,5),(257,11145,11138,'91a',3.333,5),(257,11146,11138,'1ad',3.333,5),(257,11147,11138,'ad1',3.333,5),(257,11148,11138,'d1e',3.333,5),(257,11149,11138,'1e4',3.333,5),(257,11150,11138,'e48',3.333,5),(257,11151,11138,'480',3.333,5),(257,11152,11138,'80e',3.333,5),(257,11153,11138,'0ea',3.333,5),(257,11154,11138,'ea3',3.333,5),(257,11155,11138,'a3b',3.333,5),(257,11156,11138,'3b8',3.333,5),(257,11157,11138,'b8d',3.333,5),(257,11158,11138,'8d7',3.333,5),(257,11159,11138,'d79',3.333,5),(257,11160,11138,'793',3.333,5),(257,11161,11138,'93f',3.333,5),(257,11162,11138,'3ff',3.333,5),(257,11163,11138,'ff8',3.333,5),(257,11164,11138,'f80',3.333,5),(257,11165,11138,'800',3.333,5),(257,11166,11138,'001',3.333,5),(257,11167,11138,'01c',3.333,5),(257,11168,11138,'1cd',3.333,5),(258,11170,11169,'naa',100,5),(258,11171,11170,'600',3.333,5),(258,11172,11170,'000',3.333,5),(258,11173,11170,'00c',3.333,5),(258,11174,11170,'0c2',3.333,5),(258,11175,11170,'c29',3.333,5),(258,11176,11170,'29b',3.333,5),(258,11177,11170,'9b9',3.333,5),(258,11178,11170,'b9d',3.333,5),(258,11179,11170,'9d2',3.333,5),(258,11180,11170,'d27',3.333,5),(258,11181,11170,'272',3.333,5),(258,11182,11170,'725',3.333,5),(258,11183,11170,'250',3.333,5),(258,11184,11170,'503',3.333,5),(258,11185,11170,'034',3.333,5),(258,11186,11170,'346',3.333,5),(258,11187,11170,'46d',3.333,5),(258,11188,11170,'6d3',3.333,5),(258,11189,11170,'d3e',3.333,5),(258,11190,11170,'3e0',3.333,5),(258,11191,11170,'e02',3.333,5),(258,11192,11170,'028',3.333,5),(258,11193,11170,'286',3.333,5),(258,11194,11170,'86e',3.333,5),(258,11195,11170,'6ee',3.333,5),(258,11196,11170,'ee2',3.333,5),(258,11197,11170,'e28',3.333,5),(258,11198,11170,'28a',3.333,5),(258,11199,11170,'8a4',3.333,5),(258,11200,11170,'a49',3.333,5),(259,11202,11201,'naa',100,5),(259,11203,11202,'600',3.333,5),(259,11204,11202,'000',3.333,5),(259,11205,11202,'00c',3.333,5),(259,11206,11202,'0c2',3.333,5),(259,11207,11202,'c29',3.333,5),(259,11208,11202,'29b',3.333,5),(259,11209,11202,'9b4',3.333,5),(259,11210,11202,'b45',3.333,5),(259,11211,11202,'45f',3.333,5),(259,11212,11202,'5fb',3.333,5),(259,11213,11202,'fb5',3.333,5),(259,11214,11202,'b59',3.333,5),(259,11215,11202,'593',3.333,5),(259,11216,11202,'930',3.333,5),(259,11217,11202,'308',3.333,5),(259,11218,11202,'085',3.333,5),(259,11219,11202,'85a',3.333,5),(259,11220,11202,'5a2',3.333,5),(259,11221,11202,'a2c',3.333,5),(259,11222,11202,'2c4',3.333,5),(259,11223,11202,'c48',3.333,5),(259,11224,11202,'487',3.333,5),(259,11225,11202,'878',3.333,5),(259,11226,11202,'782',3.333,5),(259,11227,11202,'82b',3.333,5),(259,11228,11202,'2b0',3.333,5),(259,11229,11202,'b02',3.333,5),(259,11230,11202,'020',3.333,5),(259,11231,11202,'204',3.333,5),(259,11232,11202,'044',3.333,5),(260,11234,11233,'naa',100,5),(260,11235,11234,'600',3.333,5),(260,11236,11234,'000',3.333,5),(260,11237,11234,'00c',3.333,5),(260,11238,11234,'0c2',3.333,5),(260,11239,11234,'c29',3.333,5),(260,11240,11234,'29a',3.333,5),(260,11241,11234,'9a5',3.333,5),(260,11242,11234,'a50',3.333,5),(260,11243,11234,'50c',3.333,5),(260,11244,11234,'0c7',3.333,5),(260,11245,11234,'c74',3.333,5),(260,11246,11234,'74f',3.333,5),(260,11247,11234,'4f6',3.333,5),(260,11248,11234,'f6a',3.333,5),(260,11249,11234,'6a4',3.333,5),(260,11250,11234,'a44',3.333,5),(260,11251,11234,'449',3.333,5),(260,11252,11234,'499',3.333,5),(260,11253,11234,'99c',3.333,5),(260,11254,11234,'9cc',3.333,5),(260,11255,11234,'cc6',3.333,5),(260,11256,11234,'c61',3.333,5),(260,11257,11234,'613',3.333,5),(260,11258,11234,'13e',3.333,5),(260,11259,11234,'3e4',3.333,5),(260,11260,11234,'e47',3.333,5),(260,11261,11234,'475',3.333,5),(260,11262,11234,'75e',3.333,5),(260,11263,11234,'5ef',3.333,5),(260,11264,11234,'ef4',3.333,5),(261,11266,11265,'naa',100,5),(261,11267,11266,'600',3.333,5),(261,11268,11266,'000',3.333,5),(261,11269,11266,'00c',3.333,5),(261,11270,11266,'0c2',3.333,5),(261,11271,11266,'c29',3.333,5),(261,11272,11266,'294',3.333,5),(261,11273,11266,'94c',3.333,5),(261,11274,11266,'4c5',3.333,5),(261,11275,11266,'c58',3.333,5),(261,11276,11266,'580',3.333,5),(261,11277,11266,'800',3.333,5),(261,11278,11266,'007',3.333,5),(261,11279,11266,'070',3.333,5),(261,11280,11266,'706',3.333,5),(261,11281,11266,'06f',3.333,5),(261,11282,11266,'6fe',3.333,5),(261,11283,11266,'fe0',3.333,5),(261,11284,11266,'e07',3.333,5),(261,11285,11266,'07f',3.333,5),(261,11286,11266,'7fe',3.333,5),(261,11287,11266,'fe7',3.333,5),(261,11288,11266,'e7b',3.333,5),(261,11289,11266,'7bd',3.333,5),(261,11290,11266,'bde',3.333,5),(261,11291,11266,'dec',3.333,5),(261,11292,11266,'ec0',3.333,5),(261,11293,11266,'c0b',3.333,5),(261,11294,11266,'0b5',3.333,5),(261,11295,11266,'b54',3.333,5),(261,11296,11266,'542',3.333,5),(262,11298,11297,'naa',100,5),(262,11299,11298,'600',3.333,5),(262,11300,11298,'000',3.333,5),(262,11301,11298,'00c',3.333,5),(262,11302,11298,'0c2',3.333,5),(262,11303,11298,'c29',3.333,5),(262,11304,11298,'296',3.333,5),(262,11305,11298,'965',3.333,5),(262,11306,11298,'65c',3.333,5),(262,11307,11298,'5ca',3.333,5),(262,11308,11298,'ca4',3.333,5),(262,11309,11298,'a4c',3.333,5),(262,11310,11298,'4cd',3.333,5),(262,11311,11298,'cd7',3.333,5),(262,11312,11298,'d7c',3.333,5),(262,11313,11298,'7c5',3.333,5),(262,11314,11298,'c53',3.333,5),(262,11315,11298,'538',3.333,5),(262,11316,11298,'381',3.333,5),(262,11317,11298,'811',3.333,5),(262,11318,11298,'117',3.333,5),(262,11319,11298,'170',3.333,5),(262,11320,11298,'704',3.333,5),(262,11321,11298,'04f',3.333,5),(262,11322,11298,'4f7',3.333,5),(262,11323,11298,'f77',3.333,5),(262,11324,11298,'77b',3.333,5),(262,11325,11298,'7b5',3.333,5),(262,11326,11298,'b5d',3.333,5),(262,11327,11298,'5d6',3.333,5),(262,11328,11298,'d65',3.333,5),(263,11330,11329,'naa',100,5),(263,11331,11330,'600',3.333,5),(263,11332,11330,'000',3.333,5),(263,11333,11330,'00c',3.333,5),(263,11334,11330,'0c2',3.333,5),(263,11335,11330,'c29',3.333,5),(263,11336,11330,'299',3.333,5),(263,11337,11330,'992',3.333,5),(263,11338,11330,'929',3.333,5),(263,11339,11330,'29c',3.333,5),(263,11340,11330,'9cb',3.333,5),(263,11341,11330,'cb6',3.333,5),(263,11342,11330,'b62',3.333,5),(263,11343,11330,'627',3.333,5),(263,11344,11330,'278',3.333,5),(263,11345,11330,'783',3.333,5),(263,11346,11330,'838',3.333,5),(263,11347,11330,'386',3.333,5),(263,11348,11330,'86c',3.333,5),(263,11349,11330,'6c2',3.333,5),(263,11350,11330,'c23',3.333,5),(263,11351,11330,'231',3.333,5),(263,11352,11330,'319',3.333,5),(263,11353,11330,'19e',3.333,5),(263,11354,11330,'9ec',3.333,5),(263,11355,11330,'ec3',3.333,5),(263,11356,11330,'c3c',3.333,5),(263,11357,11330,'3c3',3.333,5),(263,11358,11330,'c3b',3.333,5),(263,11359,11330,'3b6',3.333,5),(263,11360,11330,'b6e',3.333,5),(264,11362,11361,'naa',100,5),(264,11363,11362,'600',3.333,5),(264,11364,11362,'000',3.333,5),(264,11365,11362,'00c',3.333,5),(264,11366,11362,'0c2',3.333,5),(264,11367,11362,'c29',3.333,5),(264,11368,11362,'295',3.333,5),(264,11369,11362,'958',3.333,5),(264,11370,11362,'581',3.333,5),(264,11371,11362,'81a',3.333,5),(264,11372,11362,'1ab',3.333,5),(264,11373,11362,'ab8',3.333,5),(264,11374,11362,'b8a',3.333,5),(264,11375,11362,'8a2',3.333,5),(264,11376,11362,'a2d',3.333,5),(264,11377,11362,'2d1',3.333,5),(264,11378,11362,'d1e',3.333,5),(264,11379,11362,'1e2',3.333,5),(264,11380,11362,'e21',3.333,5),(264,11381,11362,'213',3.333,5),(264,11382,11362,'13a',3.333,5),(264,11383,11362,'3ab',3.333,5),(264,11384,11362,'ab7',3.333,5),(264,11385,11362,'b7a',3.333,5),(264,11386,11362,'7a5',3.333,5),(264,11387,11362,'a50',3.333,5),(264,11388,11362,'509',3.333,5),(264,11389,11362,'097',3.333,5),(264,11390,11362,'97f',3.333,5),(264,11391,11362,'7f2',3.333,5),(264,11392,11362,'f25',3.333,5),(265,11394,11393,'naa',100,5),(265,11395,11394,'600',3.333,5),(265,11396,11394,'000',3.333,5),(265,11397,11394,'00c',3.333,5),(265,11398,11394,'0c2',3.333,5),(265,11399,11394,'c29',3.333,5),(265,11400,11394,'297',3.333,5),(265,11401,11394,'979',3.333,5),(265,11402,11394,'79d',3.333,5),(265,11403,11394,'9d4',3.333,5),(265,11404,11394,'d4a',3.333,5),(265,11405,11394,'4a2',3.333,5),(265,11406,11394,'a26',3.333,5),(265,11407,11394,'269',3.333,5),(265,11408,11394,'69d',3.333,5),(265,11409,11394,'9d6',3.333,5),(265,11410,11394,'d68',3.333,5),(265,11411,11394,'687',3.333,5),(265,11412,11394,'872',3.333,5),(265,11413,11394,'725',3.333,5),(265,11414,11394,'256',3.333,5),(265,11415,11394,'562',3.333,5),(265,11416,11394,'625',3.333,5),(265,11417,11394,'255',3.333,5),(265,11418,11394,'552',3.333,5),(265,11419,11394,'529',3.333,5),(265,11420,11394,'295',3.333,5),(265,11421,11394,'952',3.333,5),(265,11422,11394,'52c',3.333,5),(265,11423,11394,'2c8',3.333,5),(265,11424,11394,'c80',3.333,5),(266,11426,11425,'naa',100,5),(266,11427,11426,'600',3.333,5),(266,11428,11426,'000',3.333,5),(266,11429,11426,'00c',3.333,5),(266,11430,11426,'0c2',3.333,5),(266,11431,11426,'c29',3.333,5),(266,11432,11426,'29f',3.333,5),(266,11433,11426,'9f6',3.333,5),(266,11434,11426,'f67',3.333,5),(266,11435,11426,'674',3.333,5),(266,11436,11426,'74e',3.333,5),(266,11437,11426,'4e5',3.333,5),(266,11438,11426,'e59',3.333,5),(266,11439,11426,'592',3.333,5),(266,11440,11426,'927',3.333,5),(266,11441,11426,'273',3.333,5),(266,11442,11426,'736',3.333,5),(266,11443,11426,'363',3.333,5),(266,11444,11426,'634',3.333,5),(266,11445,11426,'34e',3.333,5),(266,11446,11426,'4ef',3.333,5),(266,11447,11426,'ef0',3.333,5),(266,11448,11426,'f0b',3.333,5),(266,11449,11426,'0b5',3.333,5),(266,11450,11426,'b57',3.333,5),(266,11451,11426,'579',3.333,5),(266,11452,11426,'79e',3.333,5),(266,11453,11426,'9e3',3.333,5),(266,11454,11426,'e36',3.333,5),(266,11455,11426,'36b',3.333,5),(266,11456,11426,'6b7',3.333,5),(267,11458,11457,'naa',100,5),(267,11459,11458,'600',3.333,5),(267,11460,11458,'000',3.333,5),(267,11461,11458,'00c',3.333,5),(267,11462,11458,'0c2',3.333,5),(267,11463,11458,'c29',3.333,5),(267,11464,11458,'29e',3.333,5),(267,11465,11458,'9e2',3.333,5),(267,11466,11458,'e26',3.333,5),(267,11467,11458,'268',3.333,5),(267,11468,11458,'682',3.333,5),(267,11469,11458,'82f',3.333,5),(267,11470,11458,'2f4',3.333,5),(267,11471,11458,'f4d',3.333,5),(267,11472,11458,'4db',3.333,5),(267,11473,11458,'db1',3.333,5),(267,11474,11458,'b15',3.333,5),(267,11475,11458,'151',3.333,5),(267,11476,11458,'511',3.333,5),(267,11477,11458,'114',3.333,5),(267,11478,11458,'14d',3.333,5),(267,11479,11458,'4dd',3.333,5),(267,11480,11458,'dd9',3.333,5),(267,11481,11458,'d94',3.333,5),(267,11482,11458,'944',3.333,5),(267,11483,11458,'441',3.333,5),(267,11484,11458,'41e',3.333,5),(267,11485,11458,'1e9',3.333,5),(267,11486,11458,'e9c',3.333,5),(267,11487,11458,'9c1',3.333,5),(267,11488,11458,'c15',3.333,5),(268,11490,11489,'naa',100,5),(268,11491,11490,'600',3.333,5),(268,11492,11490,'000',3.333,5),(268,11493,11490,'00c',3.333,5),(268,11494,11490,'0c2',3.333,5),(268,11495,11490,'c29',3.333,5),(268,11496,11490,'290',3.333,5),(268,11497,11490,'904',3.333,5),(268,11498,11490,'047',3.333,5),(268,11499,11490,'478',3.333,5),(268,11500,11490,'789',3.333,5),(268,11501,11490,'896',3.333,5),(268,11502,11490,'96a',3.333,5),(268,11503,11490,'6a9',3.333,5),(268,11504,11490,'a98',3.333,5),(268,11505,11490,'98a',3.333,5),(268,11506,11490,'8ad',3.333,5),(268,11507,11490,'adc',3.333,5),(268,11508,11490,'dc8',3.333,5),(268,11509,11490,'c87',3.333,5),(268,11510,11490,'870',3.333,5),(268,11511,11490,'70d',3.333,5),(268,11512,11490,'0df',3.333,5),(268,11513,11490,'dfb',3.333,5),(268,11514,11490,'fbe',3.333,5),(268,11515,11490,'beb',3.333,5),(268,11516,11490,'eba',3.333,5),(268,11517,11490,'bae',3.333,5),(268,11518,11490,'aea',3.333,5),(268,11519,11490,'eac',3.333,5),(268,11520,11490,'ac2',3.333,5),(269,11522,11521,'naa',100,5),(269,11523,11522,'600',3.333,5),(269,11524,11522,'000',3.333,5),(269,11525,11522,'00c',3.333,5),(269,11526,11522,'0c2',3.333,5),(269,11527,11522,'c29',3.333,5),(269,11528,11522,'293',3.333,5),(269,11529,11522,'930',3.333,5),(269,11530,11522,'306',3.333,5),(269,11531,11522,'069',3.333,5),(269,11532,11522,'690',3.333,5),(269,11533,11522,'908',3.333,5),(269,11534,11522,'084',3.333,5),(269,11535,11522,'849',3.333,5),(269,11536,11522,'49f',3.333,5),(269,11537,11522,'9f0',3.333,5),(269,11538,11522,'f0f',3.333,5),(269,11539,11522,'0f0',3.333,5),(269,11540,11522,'f02',3.333,5),(269,11541,11522,'027',3.333,5),(269,11542,11522,'27e',3.333,5),(269,11543,11522,'7e2',3.333,5),(269,11544,11522,'e2b',3.333,5),(269,11545,11522,'2bd',3.333,5),(269,11546,11522,'bde',3.333,5),(269,11547,11522,'dea',3.333,5),(269,11548,11522,'ea1',3.333,5),(269,11549,11522,'a15',3.333,5),(269,11550,11522,'159',3.333,5),(269,11551,11522,'597',3.333,5),(269,11552,11522,'971',3.333,5),(270,11554,11553,'naa',100,5),(270,11555,11554,'600',3.333,5),(270,11556,11554,'000',3.333,5),(270,11557,11554,'00c',3.333,5),(270,11558,11554,'0c2',3.333,5),(270,11559,11554,'c29',3.333,5),(270,11560,11554,'29f',3.333,5),(270,11561,11554,'9f5',3.333,5),(270,11562,11554,'f57',3.333,5),(270,11563,11554,'57c',3.333,5),(270,11564,11554,'7cc',3.333,5),(270,11565,11554,'cc9',3.333,5),(270,11566,11554,'c96',3.333,5),(270,11567,11554,'968',3.333,5),(270,11568,11554,'68b',3.333,5),(270,11569,11554,'8bf',3.333,5),(270,11570,11554,'bfb',3.333,5),(270,11571,11554,'fbb',3.333,5),(270,11572,11554,'bb5',3.333,5),(270,11573,11554,'b54',3.333,5),(270,11574,11554,'545',3.333,5),(270,11575,11554,'45d',3.333,5),(270,11576,11554,'5db',3.333,5),(270,11577,11554,'dbf',3.333,5),(270,11578,11554,'bf2',3.333,5),(270,11579,11554,'f20',3.333,5),(270,11580,11554,'20a',3.333,5),(270,11581,11554,'0a1',3.333,5),(270,11582,11554,'a18',3.333,5),(270,11583,11554,'188',3.333,5),(270,11584,11554,'886',3.333,5),(271,11586,11585,'naa',100,5),(271,11587,11586,'600',3.333,5),(271,11588,11586,'000',3.333,5),(271,11589,11586,'00c',3.333,5),(271,11590,11586,'0c2',3.333,5),(271,11591,11586,'c29',3.333,5),(271,11592,11586,'296',3.333,5),(271,11593,11586,'96c',3.333,5),(271,11594,11586,'6c4',3.333,5),(271,11595,11586,'c4b',3.333,5),(271,11596,11586,'4b8',3.333,5),(271,11597,11586,'b84',3.333,5),(271,11598,11586,'84c',3.333,5),(271,11599,11586,'4cf',3.333,5),(271,11600,11586,'cf9',3.333,5),(271,11601,11586,'f9c',3.333,5),(271,11602,11586,'9c0',3.333,5),(271,11603,11586,'c02',3.333,5),(271,11604,11586,'023',3.333,5),(271,11605,11586,'23f',3.333,5),(271,11606,11586,'3f5',3.333,5),(271,11607,11586,'f5b',3.333,5),(271,11608,11586,'5bd',3.333,5),(271,11609,11586,'bd4',3.333,5),(271,11610,11586,'d4f',3.333,5),(271,11611,11586,'4f7',3.333,5),(271,11612,11586,'f7e',3.333,5),(271,11613,11586,'7ed',3.333,5),(271,11614,11586,'ed0',3.333,5),(271,11615,11586,'d00',3.333,5),(271,11616,11586,'00f',3.333,5),(272,11618,11617,'naa',100,5),(272,11619,11618,'600',3.333,5),(272,11620,11618,'000',3.333,5),(272,11621,11618,'00c',3.333,5),(272,11622,11618,'0c2',3.333,5),(272,11623,11618,'c29',3.333,5),(272,11624,11618,'295',3.333,5),(272,11625,11618,'954',3.333,5),(272,11626,11618,'548',3.333,5),(272,11627,11618,'48b',3.333,5),(272,11628,11618,'8b2',3.333,5),(272,11629,11618,'b21',3.333,5),(272,11630,11618,'21a',3.333,5),(272,11631,11618,'1a5',3.333,5),(272,11632,11618,'a50',3.333,5),(272,11633,11618,'50f',3.333,5),(272,11634,11618,'0f8',3.333,5),(272,11635,11618,'f85',3.333,5),(272,11636,11618,'856',3.333,5),(272,11637,11618,'567',3.333,5),(272,11638,11618,'67f',3.333,5),(272,11639,11618,'7f2',3.333,5),(272,11640,11618,'f2f',3.333,5),(272,11641,11618,'2f9',3.333,5),(272,11642,11618,'f98',3.333,5),(272,11643,11618,'98d',3.333,5),(272,11644,11618,'8d6',3.333,5),(272,11645,11618,'d65',3.333,5),(272,11646,11618,'657',3.333,5),(272,11647,11618,'570',3.333,5),(272,11648,11618,'703',3.333,5),(273,11650,11649,'naa',100,5),(273,11651,11650,'600',3.333,5),(273,11652,11650,'000',3.333,5),(273,11653,11650,'00c',3.333,5),(273,11654,11650,'0c2',3.333,5),(273,11655,11650,'c29',3.333,5),(273,11656,11650,'29c',3.333,5),(273,11657,11650,'9ca',3.333,5),(273,11658,11650,'ca9',3.333,5),(273,11659,11650,'a95',3.333,5),(273,11660,11650,'954',3.333,5),(273,11661,11650,'543',3.333,5),(273,11662,11650,'433',3.333,5),(273,11663,11650,'33a',3.333,5),(273,11664,11650,'3a3',3.333,5),(273,11665,11650,'a3c',3.333,5),(273,11666,11650,'3c2',3.333,5),(273,11667,11650,'c26',3.333,5),(273,11668,11650,'26a',3.333,5),(273,11669,11650,'6ac',3.333,5),(273,11670,11650,'ac5',3.333,5),(273,11671,11650,'c50',3.333,5),(273,11672,11650,'500',3.333,5),(273,11673,11650,'006',3.333,5),(273,11674,11650,'06f',3.333,5),(273,11675,11650,'6f2',3.333,5),(273,11676,11650,'f2c',3.333,5),(273,11677,11650,'2c6',3.333,5),(273,11678,11650,'c6b',3.333,5),(273,11679,11650,'6bb',3.333,5),(273,11680,11650,'bbf',3.333,5),(274,11682,11681,'naa',100,5),(274,11683,11682,'600',3.333,5),(274,11684,11682,'000',3.333,5),(274,11685,11682,'00c',3.333,5),(274,11686,11682,'0c2',3.333,5),(274,11687,11682,'c29',3.333,5),(274,11688,11682,'298',3.333,5),(274,11689,11682,'985',3.333,5),(274,11690,11682,'859',3.333,5),(274,11691,11682,'59f',3.333,5),(274,11692,11682,'9fd',3.333,5),(274,11693,11682,'fd5',3.333,5),(274,11694,11682,'d51',3.333,5),(274,11695,11682,'519',3.333,5),(274,11696,11682,'19d',3.333,5),(274,11697,11682,'9d8',3.333,5),(274,11698,11682,'d86',3.333,5),(274,11699,11682,'867',3.333,5),(274,11700,11682,'672',3.333,5),(274,11701,11682,'729',3.333,5),(274,11702,11682,'292',3.333,5),(274,11703,11682,'92b',3.333,5),(274,11704,11682,'2b2',3.333,5),(274,11705,11682,'b2a',3.333,5),(274,11706,11682,'2a2',3.333,5),(274,11707,11682,'a20',3.333,5),(274,11708,11682,'206',3.333,5),(274,11709,11682,'06e',3.333,5),(274,11710,11682,'6e3',3.333,5),(274,11711,11682,'e33',3.333,5),(274,11712,11682,'338',3.333,5),(275,11714,11713,'naa',100,5),(275,11715,11714,'600',3.333,5),(275,11716,11714,'000',3.333,5),(275,11717,11714,'00c',3.333,5),(275,11718,11714,'0c2',3.333,5),(275,11719,11714,'c29',3.333,5),(275,11720,11714,'294',3.333,5),(275,11721,11714,'94b',3.333,5),(275,11722,11714,'4b2',3.333,5),(275,11723,11714,'b2c',3.333,5),(275,11724,11714,'2c5',3.333,5),(275,11725,11714,'c52',3.333,5),(275,11726,11714,'528',3.333,5),(275,11727,11714,'28e',3.333,5),(275,11728,11714,'8ee',3.333,5),(275,11729,11714,'ee4',3.333,5),(275,11730,11714,'e47',3.333,5),(275,11731,11714,'471',3.333,5),(275,11732,11714,'718',3.333,5),(275,11733,11714,'189',3.333,5),(275,11734,11714,'899',3.333,5),(275,11735,11714,'99a',3.333,5),(275,11736,11714,'9a0',3.333,5),(275,11737,11714,'a0c',3.333,5),(275,11738,11714,'0c8',3.333,5),(275,11739,11714,'c83',3.333,5),(275,11740,11714,'832',3.333,5),(275,11741,11714,'328',3.333,5),(275,11742,11714,'28b',3.333,5),(275,11743,11714,'8b4',3.333,5),(275,11744,11714,'b4b',3.333,5),(276,11746,11745,'naa',100,5),(276,11747,11746,'600',3.333,5),(276,11748,11746,'000',3.333,5),(276,11749,11746,'00c',3.333,5),(276,11750,11746,'0c2',3.333,5),(276,11751,11746,'c29',3.333,5),(276,11752,11746,'29b',3.333,5),(276,11753,11746,'9be',3.333,5),(276,11754,11746,'be9',3.333,5),(276,11755,11746,'e9c',3.333,5),(276,11756,11746,'9c8',3.333,5),(276,11757,11746,'c8a',3.333,5),(276,11758,11746,'8af',3.333,5),(276,11759,11746,'af4',3.333,5),(276,11760,11746,'f40',3.333,5),(276,11761,11746,'40d',3.333,5),(276,11762,11746,'0d3',3.333,5),(276,11763,11746,'d3e',3.333,5),(276,11764,11746,'3e0',3.333,5),(276,11765,11746,'e0d',3.333,5),(276,11766,11746,'0d5',3.333,5),(276,11767,11746,'d59',3.333,5),(276,11768,11746,'593',3.333,5),(276,11769,11746,'938',3.333,5),(276,11770,11746,'38c',3.333,5),(276,11771,11746,'8c1',3.333,5),(276,11772,11746,'c1f',3.333,5),(276,11773,11746,'1f9',3.333,5),(276,11774,11746,'f98',3.333,5),(276,11775,11746,'980',3.333,5),(276,11776,11746,'80e',3.333,5),(277,11778,11777,'naa',100,5),(277,11779,11778,'600',3.333,5),(277,11780,11778,'000',3.333,5),(277,11781,11778,'00c',3.333,5),(277,11782,11778,'0c2',3.333,5),(277,11783,11778,'c29',3.333,5),(277,11784,11778,'29e',3.333,5),(277,11785,11778,'9ef',3.333,5),(277,11786,11778,'efd',3.333,5),(277,11787,11778,'fde',3.333,5),(277,11788,11778,'dea',3.333,5),(277,11789,11778,'ea6',3.333,5),(277,11790,11778,'a63',3.333,5),(277,11791,11778,'638',3.333,5),(277,11792,11778,'383',3.333,5),(277,11793,11778,'83c',3.333,5),(277,11794,11778,'3c6',3.333,5),(277,11795,11778,'c63',3.333,5),(277,11796,11778,'636',3.333,5),(277,11797,11778,'36e',3.333,5),(277,11798,11778,'6eb',3.333,5),(277,11799,11778,'eb6',3.333,5),(277,11800,11778,'b6f',3.333,5),(277,11801,11778,'6f5',3.333,5),(277,11802,11778,'f52',3.333,5),(277,11803,11778,'529',3.333,5),(277,11804,11778,'293',3.333,5),(277,11805,11778,'93b',3.333,5),(277,11806,11778,'3bb',3.333,5),(277,11807,11778,'bb1',3.333,5),(277,11808,11778,'b18',3.333,5),(278,11810,11809,'naa',100,5),(278,11811,11810,'600',3.333,5),(278,11812,11810,'000',3.333,5),(278,11813,11810,'00c',3.333,5),(278,11814,11810,'0c2',3.333,5),(278,11815,11810,'c29',3.333,5),(278,11816,11810,'299',3.333,5),(278,11817,11810,'99f',3.333,5),(278,11818,11810,'9fb',3.333,5),(278,11819,11810,'fb2',3.333,5),(278,11820,11810,'b24',3.333,5),(278,11821,11810,'242',3.333,5),(278,11822,11810,'42f',3.333,5),(278,11823,11810,'2f2',3.333,5),(278,11824,11810,'f20',3.333,5),(278,11825,11810,'20b',3.333,5),(278,11826,11810,'0bd',3.333,5),(278,11827,11810,'bd0',3.333,5),(278,11828,11810,'d0d',3.333,5),(278,11829,11810,'0dc',3.333,5),(278,11830,11810,'dcb',3.333,5),(278,11831,11810,'cbf',3.333,5),(278,11832,11810,'bf8',3.333,5),(278,11833,11810,'f87',3.333,5),(278,11834,11810,'875',3.333,5),(278,11835,11810,'751',3.333,5),(278,11836,11810,'512',3.333,5),(278,11837,11810,'123',3.333,5),(278,11838,11810,'233',3.333,5),(278,11839,11810,'336',3.333,5),(278,11840,11810,'360',3.333,5),(279,11842,11841,'naa',100,5),(279,11843,11842,'600',3.333,5),(279,11844,11842,'000',3.333,5),(279,11845,11842,'00c',3.333,5),(279,11846,11842,'0c2',3.333,5),(279,11847,11842,'c29',3.333,5),(279,11848,11842,'29c',3.333,5),(279,11849,11842,'9c5',3.333,5),(279,11850,11842,'c50',3.333,5),(279,11851,11842,'50c',3.333,5),(279,11852,11842,'0c1',3.333,5),(279,11853,11842,'c16',3.333,5),(279,11854,11842,'162',3.333,5),(279,11855,11842,'627',3.333,5),(279,11856,11842,'277',3.333,5),(279,11857,11842,'77f',3.333,5),(279,11858,11842,'7f5',3.333,5),(279,11859,11842,'f5b',3.333,5),(279,11860,11842,'5b8',3.333,5),(279,11861,11842,'b82',3.333,5),(279,11862,11842,'82e',3.333,5),(279,11863,11842,'2ee',3.333,5),(279,11864,11842,'ee5',3.333,5),(279,11865,11842,'e57',3.333,5),(279,11866,11842,'573',3.333,5),(279,11867,11842,'733',3.333,5),(279,11868,11842,'335',3.333,5),(279,11869,11842,'35f',3.333,5),(279,11870,11842,'5fc',3.333,5),(279,11871,11842,'fc8',3.333,5),(279,11872,11842,'c8a',3.333,5),(280,11874,11873,'naa',100,5),(280,11875,11874,'600',3.333,5),(280,11876,11874,'000',3.333,5),(280,11877,11874,'00c',3.333,5),(280,11878,11874,'0c2',3.333,5),(280,11879,11874,'c29',3.333,5),(280,11880,11874,'29d',3.333,5),(280,11881,11874,'9d7',3.333,5),(280,11882,11874,'d7c',3.333,5),(280,11883,11874,'7c3',3.333,5),(280,11884,11874,'c36',3.333,5),(280,11885,11874,'364',3.333,5),(280,11886,11874,'64b',3.333,5),(280,11887,11874,'4b0',3.333,5),(280,11888,11874,'b06',3.333,5),(280,11889,11874,'06d',3.333,5),(280,11890,11874,'6de',3.333,5),(280,11891,11874,'ded',3.333,5),(280,11892,11874,'ed4',3.333,5),(280,11893,11874,'d47',3.333,5),(280,11894,11874,'47c',3.333,5),(280,11895,11874,'7c1',3.333,5),(280,11896,11874,'c1f',3.333,5),(280,11897,11874,'1f5',3.333,5),(280,11898,11874,'f57',3.333,5),(280,11899,11874,'570',3.333,5),(280,11900,11874,'70b',3.333,5),(280,11901,11874,'0bc',3.333,5),(280,11902,11874,'bc2',3.333,5),(280,11903,11874,'c2e',3.333,5),(280,11904,11874,'2e3',3.333,5),(281,11906,11905,'naa',100,5),(281,11907,11906,'600',3.333,5),(281,11908,11906,'000',3.333,5),(281,11909,11906,'00c',3.333,5),(281,11910,11906,'0c2',3.333,5),(281,11911,11906,'c29',3.333,5),(281,11912,11906,'294',3.333,5),(281,11913,11906,'94d',3.333,5),(281,11914,11906,'4d1',3.333,5),(281,11915,11906,'d1d',3.333,5),(281,11916,11906,'1df',3.333,5),(281,11917,11906,'df8',3.333,5),(281,11918,11906,'f89',3.333,5),(281,11919,11906,'893',3.333,5),(281,11920,11906,'93c',3.333,5),(281,11921,11906,'3cf',3.333,5),(281,11922,11906,'cff',3.333,5),(281,11923,11906,'ff4',3.333,5),(281,11924,11906,'f41',3.333,5),(281,11925,11906,'413',3.333,5),(281,11926,11906,'138',3.333,5),(281,11927,11906,'38d',3.333,5),(281,11928,11906,'8d2',3.333,5),(281,11929,11906,'d2e',3.333,5),(281,11930,11906,'2e4',3.333,5),(281,11931,11906,'e47',3.333,5),(281,11932,11906,'478',3.333,5),(281,11933,11906,'78e',3.333,5),(281,11934,11906,'8e2',3.333,5),(281,11935,11906,'e29',3.333,5),(281,11936,11906,'299',3.333,5),(282,11938,11937,'naa',100,5),(282,11939,11938,'600',3.333,5),(282,11940,11938,'000',3.333,5),(282,11941,11938,'00c',3.333,5),(282,11942,11938,'0c2',3.333,5),(282,11943,11938,'c29',3.333,5),(282,11944,11938,'296',3.333,5),(282,11945,11938,'962',3.333,5),(282,11946,11938,'62f',3.333,5),(282,11947,11938,'2f4',3.333,5),(282,11948,11938,'f4f',3.333,5),(282,11949,11938,'4f2',3.333,5),(282,11950,11938,'f2e',3.333,5),(282,11951,11938,'2ea',3.333,5),(282,11952,11938,'ea1',3.333,5),(282,11953,11938,'a11',3.333,5),(282,11954,11938,'11e',3.333,5),(282,11955,11938,'1e8',3.333,5),(282,11956,11938,'e83',3.333,5),(282,11957,11938,'838',3.333,5),(282,11958,11938,'380',3.333,5),(282,11959,11938,'80e',3.333,5),(282,11960,11938,'0e9',3.333,5),(282,11961,11938,'e97',3.333,5),(282,11962,11938,'978',3.333,5),(282,11963,11938,'78d',3.333,5),(282,11964,11938,'8da',3.333,5),(282,11965,11938,'daf',3.333,5),(282,11966,11938,'af5',3.333,5),(282,11967,11938,'f56',3.333,5),(282,11968,11938,'567',3.333,5),(283,11970,11969,'hgw',9.091,5),(283,11971,11969,'gw2',9.091,5),(283,11972,11969,'w2k',9.091,5),(283,11973,11969,'2k8',9.091,5),(283,11974,11969,'k8r',9.091,5),(283,11975,11969,'8r2',9.091,5),(283,11976,11969,'r23',9.091,5),(283,11977,11969,'232',9.091,5),(283,11978,11969,'32v',9.091,5),(283,11979,11969,'2vm',9.091,5),(283,11980,11969,'vm3',9.091,5),(284,11982,11981,'naa',100,5),(284,11983,11982,'600',3.333,5),(284,11984,11982,'000',3.333,5),(284,11985,11982,'00c',3.333,5),(284,11986,11982,'0c2',3.333,5),(284,11987,11982,'c29',3.333,5),(284,11988,11982,'29a',3.333,5),(284,11989,11982,'9a9',3.333,5),(284,11990,11982,'a9b',3.333,5),(284,11991,11982,'9b1',3.333,5),(284,11992,11982,'b11',3.333,5),(284,11993,11982,'113',3.333,5),(284,11994,11982,'130',3.333,5),(284,11995,11982,'305',3.333,5),(284,11996,11982,'056',3.333,5),(284,11997,11982,'567',3.333,5),(284,11998,11982,'673',3.333,5),(284,11999,11982,'731',3.333,5),(284,12000,11982,'314',3.333,5),(284,12001,11982,'146',3.333,5),(284,12002,11982,'46d',3.333,5),(284,12003,11982,'6d9',3.333,5),(284,12004,11982,'d99',3.333,5),(284,12005,11982,'99b',3.333,5),(284,12006,11982,'9b4',3.333,5),(284,12007,11982,'b45',3.333,5),(284,12008,11982,'450',3.333,5),(284,12009,11982,'507',3.333,5),(284,12010,11982,'072',3.333,5),(284,12011,11982,'723',3.333,5),(284,12012,11982,'23c',3.333,5),(285,12014,12013,'naa',100,5),(285,12015,12014,'600',3.333,5),(285,12016,12014,'00a',3.333,5),(285,12017,12014,'0a0',3.333,5),(285,12018,12014,'a09',3.333,5),(285,12019,12014,'098',3.333,5),(285,12020,12014,'980',3.333,5),(285,12021,12014,'804',3.333,5),(285,12022,12014,'044',3.333,5),(285,12023,12014,'443',3.333,5),(285,12024,12014,'430',3.333,5),(285,12025,12014,'307',3.333,5),(285,12026,12014,'075',3.333,5),(285,12027,12014,'753',3.333,5),(285,12028,12014,'535',3.333,5),(285,12029,12014,'357',3.333,5),(285,12030,12014,'573',3.333,5),(285,12031,12014,'732',3.333,5),(285,12032,12014,'32b',3.333,5),(285,12033,12014,'2b3',3.333,5),(285,12034,12014,'b33',3.333,5),(285,12035,12014,'334',3.333,5),(285,12036,12014,'345',3.333,5),(285,12037,12014,'457',3.333,5),(285,12038,12014,'571',3.333,5),(285,12039,12014,'715',3.333,5),(285,12040,12014,'153',3.333,5),(285,12041,12014,'533',3.333,5),(285,12042,12014,'335',3.333,5),(285,12043,12014,'357',3.333,5),(285,12044,12014,'575',3.333,5),(286,12046,12045,'naa',100,5),(286,12047,12046,'600',3.333,5),(286,12048,12046,'00a',3.333,5),(286,12049,12046,'0a0',3.333,5),(286,12050,12046,'a09',3.333,5),(286,12051,12046,'098',3.333,5),(286,12052,12046,'980',3.333,5),(286,12053,12046,'804',3.333,5),(286,12054,12046,'044',3.333,5),(286,12055,12046,'443',3.333,5),(286,12056,12046,'430',3.333,5),(286,12057,12046,'307',3.333,5),(286,12058,12046,'072',3.333,5),(286,12059,12046,'725',3.333,5),(286,12060,12046,'259',3.333,5),(286,12061,12046,'593',3.333,5),(286,12062,12046,'931',3.333,5),(286,12063,12046,'313',3.333,5),(286,12064,12046,'13f',3.333,5),(286,12065,12046,'3f3',3.333,5),(286,12066,12046,'f33',3.333,5),(286,12067,12046,'334',3.333,5),(286,12068,12046,'345',3.333,5),(286,12069,12046,'455',3.333,5),(286,12070,12046,'556',3.333,5),(286,12071,12046,'563',3.333,5),(286,12072,12046,'639',3.333,5),(286,12073,12046,'393',3.333,5),(286,12074,12046,'934',3.333,5),(286,12075,12046,'342',3.333,5),(286,12076,12046,'42d',3.333,5),(287,12078,12077,'naa',100,5),(287,12079,12078,'600',3.333,5),(287,12080,12078,'00a',3.333,5),(287,12081,12078,'0a0',3.333,5),(287,12082,12078,'a09',3.333,5),(287,12083,12078,'098',3.333,5),(287,12084,12078,'980',3.333,5),(287,12085,12078,'804',3.333,5),(287,12086,12078,'044',3.333,5),(287,12087,12078,'443',3.333,5),(287,12088,12078,'430',3.333,5),(287,12089,12078,'307',3.333,5),(287,12090,12078,'075',3.333,5),(287,12091,12078,'753',3.333,5),(287,12092,12078,'535',3.333,5),(287,12093,12078,'357',3.333,5),(287,12094,12078,'573',3.333,5),(287,12095,12078,'732',3.333,5),(287,12096,12078,'32b',3.333,5),(287,12097,12078,'2b3',3.333,5),(287,12098,12078,'b33',3.333,5),(287,12099,12078,'334',3.333,5),(287,12100,12078,'345',3.333,5),(287,12101,12078,'457',3.333,5),(287,12102,12078,'571',3.333,5),(287,12103,12078,'715',3.333,5),(287,12104,12078,'153',3.333,5),(287,12105,12078,'533',3.333,5),(287,12106,12078,'335',3.333,5),(287,12107,12078,'357',3.333,5),(287,12108,12078,'576',3.333,5),(288,12110,12109,'naa',100,5),(288,12111,12110,'600',3.333,5),(288,12112,12110,'00a',3.333,5),(288,12113,12110,'0a0',3.333,5),(288,12114,12110,'a09',3.333,5),(288,12115,12110,'098',3.333,5),(288,12116,12110,'980',3.333,5),(288,12117,12110,'804',3.333,5),(288,12118,12110,'044',3.333,5),(288,12119,12110,'443',3.333,5),(288,12120,12110,'430',3.333,5),(288,12121,12110,'307',3.333,5),(288,12122,12110,'072',3.333,5),(288,12123,12110,'725',3.333,5),(288,12124,12110,'259',3.333,5),(288,12125,12110,'593',3.333,5),(288,12126,12110,'931',3.333,5),(288,12127,12110,'313',3.333,5),(288,12128,12110,'13f',3.333,5),(288,12129,12110,'3f3',3.333,5),(288,12130,12110,'f33',3.333,5),(288,12131,12110,'334',3.333,5),(288,12132,12110,'345',3.333,5),(288,12133,12110,'455',3.333,5),(288,12134,12110,'556',3.333,5),(288,12135,12110,'563',3.333,5),(288,12136,12110,'639',3.333,5),(288,12137,12110,'393',3.333,5),(288,12138,12110,'934',3.333,5),(288,12139,12110,'343',3.333,5),(288,12140,12110,'439',3.333,5),(289,12142,12141,'naa',100,5),(289,12143,12142,'600',3.333,5),(289,12144,12142,'000',3.333,5),(289,12145,12142,'00c',3.333,5),(289,12146,12142,'0c2',3.333,5),(289,12147,12142,'c29',3.333,5),(289,12148,12142,'29d',3.333,5),(289,12149,12142,'9dd',3.333,5),(289,12150,12142,'dd1',3.333,5),(289,12151,12142,'d17',3.333,5),(289,12152,12142,'17f',3.333,5),(289,12153,12142,'7f5',3.333,5),(289,12154,12142,'f56',3.333,5),(289,12155,12142,'56e',3.333,5),(289,12156,12142,'6e3',3.333,5),(289,12157,12142,'e30',3.333,5),(289,12158,12142,'30f',3.333,5),(289,12159,12142,'0f1',3.333,5),(289,12160,12142,'f12',3.333,5),(289,12161,12142,'12a',3.333,5),(289,12162,12142,'2a8',3.333,5),(289,12163,12142,'a86',3.333,5),(289,12164,12142,'86a',3.333,5),(289,12165,12142,'6aa',3.333,5),(289,12166,12142,'aa0',3.333,5),(289,12167,12142,'a07',3.333,5),(289,12168,12142,'07e',3.333,5),(289,12169,12142,'7ef',3.333,5),(289,12170,12142,'ef6',3.333,5),(289,12171,12142,'f6d',3.333,5),(289,12172,12142,'6da',3.333,5),(290,12174,12173,'naa',100,5),(290,12175,12174,'600',3.333,5),(290,12176,12174,'000',3.333,5),(290,12177,12174,'00c',3.333,5),(290,12178,12174,'0c2',3.333,5),(290,12179,12174,'c29',3.333,5),(290,12180,12174,'29e',3.333,5),(290,12181,12174,'9e3',3.333,5),(290,12182,12174,'e33',3.333,5),(290,12183,12174,'337',3.333,5),(290,12184,12174,'371',3.333,5),(290,12185,12174,'71e',3.333,5),(290,12186,12174,'1e5',3.333,5),(290,12187,12174,'e54',3.333,5),(290,12188,12174,'54a',3.333,5),(290,12189,12174,'4aa',3.333,5),(290,12190,12174,'aa5',3.333,5),(290,12191,12174,'a56',3.333,5),(290,12192,12174,'56b',3.333,5),(290,12193,12174,'6bb',3.333,5),(290,12194,12174,'bb0',3.333,5),(290,12195,12174,'b09',3.333,5),(290,12196,12174,'097',3.333,5),(290,12197,12174,'971',3.333,5),(290,12198,12174,'710',3.333,5),(290,12199,12174,'103',3.333,5),(290,12200,12174,'032',3.333,5),(290,12201,12174,'32e',3.333,5),(290,12202,12174,'2e0',3.333,5),(290,12203,12174,'e08',3.333,5),(290,12204,12174,'089',3.333,5),(291,12206,12205,'naa',100,5),(291,12207,12206,'600',3.333,5),(291,12208,12206,'000',3.333,5),(291,12209,12206,'00c',3.333,5),(291,12210,12206,'0c2',3.333,5),(291,12211,12206,'c29',3.333,5),(291,12212,12206,'29e',3.333,5),(291,12213,12206,'9e3',3.333,5),(291,12214,12206,'e35',3.333,5),(291,12215,12206,'353',3.333,5),(291,12216,12206,'53d',3.333,5),(291,12217,12206,'3d1',3.333,5),(291,12218,12206,'d1d',3.333,5),(291,12219,12206,'1df',3.333,5),(291,12220,12206,'df4',3.333,5),(291,12221,12206,'f47',3.333,5),(291,12222,12206,'472',3.333,5),(291,12223,12206,'72e',3.333,5),(291,12224,12206,'2e2',3.333,5),(291,12225,12206,'e29',3.333,5),(291,12226,12206,'290',3.333,5),(291,12227,12206,'908',3.333,5),(291,12228,12206,'083',3.333,5),(291,12229,12206,'83d',3.333,5),(291,12230,12206,'3d0',3.333,5),(291,12231,12206,'d0d',3.333,5),(291,12232,12206,'0de',3.333,5),(291,12233,12206,'de0',3.333,5),(291,12234,12206,'e00',3.333,5),(291,12235,12206,'007',3.333,5),(291,12236,12206,'077',3.333,5),(292,12238,12237,'naa',100,5),(292,12239,12238,'600',3.333,5),(292,12240,12238,'000',3.333,5),(292,12241,12238,'00c',3.333,5),(292,12242,12238,'0c2',3.333,5),(292,12243,12238,'c29',3.333,5),(292,12244,12238,'296',3.333,5),(292,12245,12238,'960',3.333,5),(292,12246,12238,'60b',3.333,5),(292,12247,12238,'0b0',3.333,5),(292,12248,12238,'b02',3.333,5),(292,12249,12238,'02c',3.333,5),(292,12250,12238,'2c3',3.333,5),(292,12251,12238,'c3a',3.333,5),(292,12252,12238,'3a9',3.333,5),(292,12253,12238,'a9e',3.333,5),(292,12254,12238,'9e5',3.333,5),(292,12255,12238,'e54',3.333,5),(292,12256,12238,'54e',3.333,5),(292,12257,12238,'4ed',3.333,5),(292,12258,12238,'eda',3.333,5),(292,12259,12238,'da5',3.333,5),(292,12260,12238,'a5f',3.333,5),(292,12261,12238,'5f3',3.333,5),(292,12262,12238,'f39',3.333,5),(292,12263,12238,'394',3.333,5),(292,12264,12238,'94a',3.333,5),(292,12265,12238,'4a8',3.333,5),(292,12266,12238,'a83',3.333,5),(292,12267,12238,'838',3.333,5),(292,12268,12238,'38a',3.333,5),(293,12270,12269,'naa',100,5),(293,12271,12270,'600',3.333,5),(293,12272,12270,'000',3.333,5),(293,12273,12270,'00c',3.333,5),(293,12274,12270,'0c2',3.333,5),(293,12275,12270,'c29',3.333,5),(293,12276,12270,'298',3.333,5),(293,12277,12270,'989',3.333,5),(293,12278,12270,'891',3.333,5),(293,12279,12270,'91c',3.333,5),(293,12280,12270,'1c7',3.333,5),(293,12281,12270,'c7b',3.333,5),(293,12282,12270,'7bf',3.333,5),(293,12283,12270,'bfb',3.333,5),(293,12284,12270,'fbf',3.333,5),(293,12285,12270,'bf1',3.333,5),(293,12286,12270,'f1d',3.333,5),(293,12287,12270,'1d5',3.333,5),(293,12288,12270,'d5b',3.333,5),(293,12289,12270,'5b5',3.333,5),(293,12290,12270,'b50',3.333,5),(293,12291,12270,'509',3.333,5),(293,12292,12270,'094',3.333,5),(293,12293,12270,'941',3.333,5),(293,12294,12270,'415',3.333,5),(293,12295,12270,'15e',3.333,5),(293,12296,12270,'5e5',3.333,5),(293,12297,12270,'e5e',3.333,5),(293,12298,12270,'5e8',3.333,5),(293,12299,12270,'e8e',3.333,5),(293,12300,12270,'8e9',3.333,5),(294,12302,12301,'naa',100,5),(294,12303,12302,'600',3.333,5),(294,12304,12302,'000',3.333,5),(294,12305,12302,'00c',3.333,5),(294,12306,12302,'0c2',3.333,5),(294,12307,12302,'c29',3.333,5),(294,12308,12302,'291',3.333,5),(294,12309,12302,'917',3.333,5),(294,12310,12302,'173',3.333,5),(294,12311,12302,'737',3.333,5),(294,12312,12302,'37b',3.333,5),(294,12313,12302,'7bb',3.333,5),(294,12314,12302,'bb4',3.333,5),(294,12315,12302,'b4c',3.333,5),(294,12316,12302,'4cb',3.333,5),(294,12317,12302,'cb6',3.333,5),(294,12318,12302,'b6f',3.333,5),(294,12319,12302,'6f8',3.333,5),(294,12320,12302,'f8e',3.333,5),(294,12321,12302,'8e9',3.333,5),(294,12322,12302,'e9f',3.333,5),(294,12323,12302,'9f8',3.333,5),(294,12324,12302,'f8e',3.333,5),(294,12325,12302,'8eb',3.333,5),(294,12326,12302,'eb5',3.333,5),(294,12327,12302,'b55',3.333,5),(294,12328,12302,'55f',3.333,5),(294,12329,12302,'5ff',3.333,5),(294,12330,12302,'ff3',3.333,5),(294,12331,12302,'f3f',3.333,5),(294,12332,12302,'3fe',3.333,5),(295,12334,12333,'naa',100,5),(295,12335,12334,'600',3.333,5),(295,12336,12334,'000',3.333,5),(295,12337,12334,'00c',3.333,5),(295,12338,12334,'0c2',3.333,5),(295,12339,12334,'c29',3.333,5),(295,12340,12334,'291',3.333,5),(295,12341,12334,'917',3.333,5),(295,12342,12334,'17d',3.333,5),(295,12343,12334,'7d5',3.333,5),(295,12344,12334,'d55',3.333,5),(295,12345,12334,'55d',3.333,5),(295,12346,12334,'5d8',3.333,5),(295,12347,12334,'d87',3.333,5),(295,12348,12334,'870',3.333,5),(295,12349,12334,'704',3.333,5),(295,12350,12334,'040',3.333,5),(295,12351,12334,'400',3.333,5),(295,12352,12334,'00e',3.333,5),(295,12353,12334,'0ec',3.333,5),(295,12354,12334,'ecc',3.333,5),(295,12355,12334,'cc0',3.333,5),(295,12356,12334,'c07',3.333,5),(295,12357,12334,'070',3.333,5),(295,12358,12334,'701',3.333,5),(295,12359,12334,'01a',3.333,5),(295,12360,12334,'1ae',3.333,5),(295,12361,12334,'aec',3.333,5),(295,12362,12334,'ece',3.333,5),(295,12363,12334,'ce3',3.333,5),(295,12364,12334,'e3c',3.333,5),(296,12366,12365,'naa',100,5),(296,12367,12366,'600',3.333,5),(296,12368,12366,'000',3.333,5),(296,12369,12366,'00c',3.333,5),(296,12370,12366,'0c2',3.333,5),(296,12371,12366,'c29',3.333,5),(296,12372,12366,'293',3.333,5),(296,12373,12366,'93b',3.333,5),(296,12374,12366,'3b0',3.333,5),(296,12375,12366,'b01',3.333,5),(296,12376,12366,'01b',3.333,5),(296,12377,12366,'1b8',3.333,5),(296,12378,12366,'b8a',3.333,5),(296,12379,12366,'8a3',3.333,5),(296,12380,12366,'a37',3.333,5),(296,12381,12366,'378',3.333,5),(296,12382,12366,'782',3.333,5),(296,12383,12366,'82a',3.333,5),(296,12384,12366,'2ae',3.333,5),(296,12385,12366,'aed',3.333,5),(296,12386,12366,'ed2',3.333,5),(296,12387,12366,'d28',3.333,5),(296,12388,12366,'28f',3.333,5),(296,12389,12366,'8fa',3.333,5),(296,12390,12366,'fa5',3.333,5),(296,12391,12366,'a50',3.333,5),(296,12392,12366,'505',3.333,5),(296,12393,12366,'05d',3.333,5),(296,12394,12366,'5d3',3.333,5),(296,12395,12366,'d31',3.333,5),(296,12396,12366,'311',3.333,5),(297,12398,12397,'naa',100,5),(297,12399,12398,'600',3.333,5),(297,12400,12398,'000',3.333,5),(297,12401,12398,'00c',3.333,5),(297,12402,12398,'0c2',3.333,5),(297,12403,12398,'c29',3.333,5),(297,12404,12398,'294',3.333,5),(297,12405,12398,'942',3.333,5),(297,12406,12398,'422',3.333,5),(297,12407,12398,'223',3.333,5),(297,12408,12398,'23f',3.333,5),(297,12409,12398,'3f0',3.333,5),(297,12410,12398,'f07',3.333,5),(297,12411,12398,'07c',3.333,5),(297,12412,12398,'7cf',3.333,5),(297,12413,12398,'cf9',3.333,5),(297,12414,12398,'f93',3.333,5),(297,12415,12398,'933',3.333,5),(297,12416,12398,'331',3.333,5),(297,12417,12398,'31c',3.333,5),(297,12418,12398,'1c3',3.333,5),(297,12419,12398,'c3f',3.333,5),(297,12420,12398,'3fa',3.333,5),(297,12421,12398,'fa7',3.333,5),(297,12422,12398,'a76',3.333,5),(297,12423,12398,'766',3.333,5),(297,12424,12398,'664',3.333,5),(297,12425,12398,'649',3.333,5),(297,12426,12398,'49f',3.333,5),(297,12427,12398,'9fc',3.333,5),(297,12428,12398,'fc0',3.333,5),(298,12430,12429,'naa',100,5),(298,12431,12430,'600',3.333,5),(298,12432,12430,'000',3.333,5),(298,12433,12430,'00c',3.333,5),(298,12434,12430,'0c2',3.333,5),(298,12435,12430,'c29',3.333,5),(298,12436,12430,'29a',3.333,5),(298,12437,12430,'9aa',3.333,5),(298,12438,12430,'aac',3.333,5),(298,12439,12430,'ac0',3.333,5),(298,12440,12430,'c08',3.333,5),(298,12441,12430,'086',3.333,5),(298,12442,12430,'864',3.333,5),(298,12443,12430,'648',3.333,5),(298,12444,12430,'487',3.333,5),(298,12445,12430,'875',3.333,5),(298,12446,12430,'754',3.333,5),(298,12447,12430,'546',3.333,5),(298,12448,12430,'46a',3.333,5),(298,12449,12430,'6a2',3.333,5),(298,12450,12430,'a2c',3.333,5),(298,12451,12430,'2ca',3.333,5),(298,12452,12430,'ca8',3.333,5),(298,12453,12430,'a8d',3.333,5),(298,12454,12430,'8dd',3.333,5),(298,12455,12430,'dd2',3.333,5),(298,12456,12430,'d2e',3.333,5),(298,12457,12430,'2eb',3.333,5),(298,12458,12430,'ebd',3.333,5),(298,12459,12430,'bd5',3.333,5),(298,12460,12430,'d5a',3.333,5),(299,12462,12461,'naa',100,5),(299,12463,12462,'600',3.333,5),(299,12464,12462,'000',3.333,5),(299,12465,12462,'00c',3.333,5),(299,12466,12462,'0c2',3.333,5),(299,12467,12462,'c29',3.333,5),(299,12468,12462,'29e',3.333,5),(299,12469,12462,'9e2',3.333,5),(299,12470,12462,'e20',3.333,5),(299,12471,12462,'200',3.333,5),(299,12472,12462,'00b',3.333,5),(299,12473,12462,'0b5',3.333,5),(299,12474,12462,'b55',3.333,5),(299,12475,12462,'558',3.333,5),(299,12476,12462,'58b',3.333,5),(299,12477,12462,'8b2',3.333,5),(299,12478,12462,'b2c',3.333,5),(299,12479,12462,'2cc',3.333,5),(299,12480,12462,'cc9',3.333,5),(299,12481,12462,'c9c',3.333,5),(299,12482,12462,'9c3',3.333,5),(299,12483,12462,'c39',3.333,5),(299,12484,12462,'39c',3.333,5),(299,12485,12462,'9ce',3.333,5),(299,12486,12462,'ced',3.333,5),(299,12487,12462,'ed4',3.333,5),(299,12488,12462,'d49',3.333,5),(299,12489,12462,'495',3.333,5),(299,12490,12462,'952',3.333,5),(299,12491,12462,'529',3.333,5),(299,12492,12462,'29c',3.333,5),(300,12494,12493,'naa',100,5),(300,12495,12494,'600',3.333,5),(300,12496,12494,'000',3.333,5),(300,12497,12494,'00c',3.333,5),(300,12498,12494,'0c2',3.333,5),(300,12499,12494,'c29',3.333,5),(300,12500,12494,'29f',3.333,5),(300,12501,12494,'9fe',3.333,5),(300,12502,12494,'fe3',3.333,5),(300,12503,12494,'e33',3.333,5),(300,12504,12494,'339',3.333,5),(300,12505,12494,'390',3.333,5),(300,12506,12494,'90e',3.333,5),(300,12507,12494,'0e7',3.333,5),(300,12508,12494,'e79',3.333,5),(300,12509,12494,'795',3.333,5),(300,12510,12494,'95d',3.333,5),(300,12511,12494,'5d8',3.333,5),(300,12512,12494,'d8c',3.333,5),(300,12513,12494,'8c5',3.333,5),(300,12514,12494,'c59',3.333,5),(300,12515,12494,'591',3.333,5),(300,12516,12494,'911',3.333,5),(300,12517,12494,'113',3.333,5),(300,12518,12494,'136',3.333,5),(300,12519,12494,'360',3.333,5),(300,12520,12494,'608',3.333,5),(300,12521,12494,'084',3.333,5),(300,12522,12494,'848',3.333,5),(300,12523,12494,'489',3.333,5),(300,12524,12494,'897',3.333,5),(301,12526,12525,'naa',100,5),(301,12527,12526,'600',3.333,5),(301,12528,12526,'000',3.333,5),(301,12529,12526,'00c',3.333,5),(301,12530,12526,'0c2',3.333,5),(301,12531,12526,'c29',3.333,5),(301,12532,12526,'29a',3.333,5),(301,12533,12526,'9a1',3.333,5),(301,12534,12526,'a13',3.333,5),(301,12535,12526,'137',3.333,5),(301,12536,12526,'37b',3.333,5),(301,12537,12526,'7ba',3.333,5),(301,12538,12526,'ba8',3.333,5),(301,12539,12526,'a86',3.333,5),(301,12540,12526,'86b',3.333,5),(301,12541,12526,'6b5',3.333,5),(301,12542,12526,'b53',3.333,5),(301,12543,12526,'534',3.333,5),(301,12544,12526,'349',3.333,5),(301,12545,12526,'498',3.333,5),(301,12546,12526,'98f',3.333,5),(301,12547,12526,'8f0',3.333,5),(301,12548,12526,'f02',3.333,5),(301,12549,12526,'023',3.333,5),(301,12550,12526,'230',3.333,5),(301,12551,12526,'301',3.333,5),(301,12552,12526,'015',3.333,5),(301,12553,12526,'152',3.333,5),(301,12554,12526,'52b',3.333,5),(301,12555,12526,'2ba',3.333,5),(301,12556,12526,'ba2',3.333,5),(302,12558,12557,'naa',100,5),(302,12559,12558,'600',3.333,5),(302,12560,12558,'000',3.333,5),(302,12561,12558,'00c',3.333,5),(302,12562,12558,'0c2',3.333,5),(302,12563,12558,'c29',3.333,5),(302,12564,12558,'29b',3.333,5),(302,12565,12558,'9b4',3.333,5),(302,12566,12558,'b45',3.333,5),(302,12567,12558,'454',3.333,5),(302,12568,12558,'543',3.333,5),(302,12569,12558,'43f',3.333,5),(302,12570,12558,'3f3',3.333,5),(302,12571,12558,'f3d',3.333,5),(302,12572,12558,'3d3',3.333,5),(302,12573,12558,'d3e',3.333,5),(302,12574,12558,'3e3',3.333,5),(302,12575,12558,'e3e',3.333,5),(302,12576,12558,'3ec',3.333,5),(302,12577,12558,'ecb',3.333,5),(302,12578,12558,'cbe',3.333,5),(302,12579,12558,'bea',3.333,5),(302,12580,12558,'ea6',3.333,5),(302,12581,12558,'a61',3.333,5),(302,12582,12558,'612',3.333,5),(302,12583,12558,'126',3.333,5),(302,12584,12558,'26c',3.333,5),(302,12585,12558,'6ce',3.333,5),(302,12586,12558,'ce7',3.333,5),(302,12587,12558,'e7a',3.333,5),(302,12588,12558,'7a5',3.333,5),(303,12590,12589,'naa',100,5),(303,12591,12590,'600',3.333,5),(303,12592,12590,'000',3.333,5),(303,12593,12590,'00c',3.333,5),(303,12594,12590,'0c2',3.333,5),(303,12595,12590,'c29',3.333,5),(303,12596,12590,'291',3.333,5),(303,12597,12590,'91d',3.333,5),(303,12598,12590,'1dd',3.333,5),(303,12599,12590,'dd7',3.333,5),(303,12600,12590,'d7f',3.333,5),(303,12601,12590,'7f6',3.333,5),(303,12602,12590,'f6a',3.333,5),(303,12603,12590,'6a5',3.333,5),(303,12604,12590,'a5d',3.333,5),(303,12605,12590,'5d9',3.333,5),(303,12606,12590,'d94',3.333,5),(303,12607,12590,'940',3.333,5),(303,12608,12590,'401',3.333,5),(303,12609,12590,'01f',3.333,5),(303,12610,12590,'1fc',3.333,5),(303,12611,12590,'fc7',3.333,5),(303,12612,12590,'c71',3.333,5),(303,12613,12590,'71d',3.333,5),(303,12614,12590,'1d5',3.333,5),(303,12615,12590,'d54',3.333,5),(303,12616,12590,'54a',3.333,5),(303,12617,12590,'4ad',3.333,5),(303,12618,12590,'adb',3.333,5),(303,12619,12590,'dbb',3.333,5),(303,12620,12590,'bb6',3.333,5),(304,12622,12621,'naa',100,5),(304,12623,12622,'600',3.333,5),(304,12624,12622,'000',3.333,5),(304,12625,12622,'00c',3.333,5),(304,12626,12622,'0c2',3.333,5),(304,12627,12622,'c29',3.333,5),(304,12628,12622,'29b',3.333,5),(304,12629,12622,'9b6',3.333,5),(304,12630,12622,'b6e',3.333,5),(304,12631,12622,'6e7',3.333,5),(304,12632,12622,'e74',3.333,5),(304,12633,12622,'740',3.333,5),(304,12634,12622,'404',3.333,5),(304,12635,12622,'04d',3.333,5),(304,12636,12622,'4dd',3.333,5),(304,12637,12622,'ddd',3.333,5),(304,12638,12622,'dd6',3.333,5),(304,12639,12622,'d6b',3.333,5),(304,12640,12622,'6b6',3.333,5),(304,12641,12622,'b61',3.333,5),(304,12642,12622,'61e',3.333,5),(304,12643,12622,'1e5',3.333,5),(304,12644,12622,'e58',3.333,5),(304,12645,12622,'58e',3.333,5),(304,12646,12622,'8e7',3.333,5),(304,12647,12622,'e78',3.333,5),(304,12648,12622,'787',3.333,5),(304,12649,12622,'87d',3.333,5),(304,12650,12622,'7d9',3.333,5),(304,12651,12622,'d9d',3.333,5),(304,12652,12622,'9d9',3.333,5),(305,12654,12653,'naa',100,5),(305,12655,12654,'600',3.333,5),(305,12656,12654,'000',3.333,5),(305,12657,12654,'00c',3.333,5),(305,12658,12654,'0c2',3.333,5),(305,12659,12654,'c29',3.333,5),(305,12660,12654,'29d',3.333,5),(305,12661,12654,'9dd',3.333,5),(305,12662,12654,'dd4',3.333,5),(305,12663,12654,'d43',3.333,5),(305,12664,12654,'436',3.333,5),(305,12665,12654,'369',3.333,5),(305,12666,12654,'697',3.333,5),(305,12667,12654,'978',3.333,5),(305,12668,12654,'787',3.333,5),(305,12669,12654,'87c',3.333,5),(305,12670,12654,'7c5',3.333,5),(305,12671,12654,'c56',3.333,5),(305,12672,12654,'560',3.333,5),(305,12673,12654,'60b',3.333,5),(305,12674,12654,'0bd',3.333,5),(305,12675,12654,'bd4',3.333,5),(305,12676,12654,'d4b',3.333,5),(305,12677,12654,'4be',3.333,5),(305,12678,12654,'bea',3.333,5),(305,12679,12654,'eac',3.333,5),(305,12680,12654,'acc',3.333,5),(305,12681,12654,'cce',3.333,5),(305,12682,12654,'ce1',3.333,5),(305,12683,12654,'e11',3.333,5),(305,12684,12654,'114',3.333,5),(306,12686,12685,'naa',100,5),(306,12687,12686,'600',3.333,5),(306,12688,12686,'000',3.333,5),(306,12689,12686,'00c',3.333,5),(306,12690,12686,'0c2',3.333,5),(306,12691,12686,'c29',3.333,5),(306,12692,12686,'296',3.333,5),(306,12693,12686,'964',3.333,5),(306,12694,12686,'642',3.333,5),(306,12695,12686,'427',3.333,5),(306,12696,12686,'274',3.333,5),(306,12697,12686,'741',3.333,5),(306,12698,12686,'418',3.333,5),(306,12699,12686,'185',3.333,5),(306,12700,12686,'85b',3.333,5),(306,12701,12686,'5ba',3.333,5),(306,12702,12686,'ba9',3.333,5),(306,12703,12686,'a96',3.333,5),(306,12704,12686,'96c',3.333,5),(306,12705,12686,'6cd',3.333,5),(306,12706,12686,'cd4',3.333,5),(306,12707,12686,'d4d',3.333,5),(306,12708,12686,'4db',3.333,5),(306,12709,12686,'dbf',3.333,5),(306,12710,12686,'bf8',3.333,5),(306,12711,12686,'f8e',3.333,5),(306,12712,12686,'8ef',3.333,5),(306,12713,12686,'ef5',3.333,5),(306,12714,12686,'f50',3.333,5),(306,12715,12686,'50e',3.333,5),(306,12716,12686,'0eb',3.333,5),(307,12718,12717,'naa',100,5),(307,12719,12718,'600',3.333,5),(307,12720,12718,'000',3.333,5),(307,12721,12718,'00c',3.333,5),(307,12722,12718,'0c2',3.333,5),(307,12723,12718,'c29',3.333,5),(307,12724,12718,'292',3.333,5),(307,12725,12718,'929',3.333,5),(307,12726,12718,'295',3.333,5),(307,12727,12718,'953',3.333,5),(307,12728,12718,'533',3.333,5),(307,12729,12718,'33f',3.333,5),(307,12730,12718,'3fd',3.333,5),(307,12731,12718,'fd5',3.333,5),(307,12732,12718,'d5b',3.333,5),(307,12733,12718,'5be',3.333,5),(307,12734,12718,'be2',3.333,5),(307,12735,12718,'e20',3.333,5),(307,12736,12718,'20e',3.333,5),(307,12737,12718,'0eb',3.333,5),(307,12738,12718,'eb5',3.333,5),(307,12739,12718,'b5c',3.333,5),(307,12740,12718,'5cc',3.333,5),(307,12741,12718,'cc8',3.333,5),(307,12742,12718,'c84',3.333,5),(307,12743,12718,'847',3.333,5),(307,12744,12718,'47a',3.333,5),(307,12745,12718,'7a1',3.333,5),(307,12746,12718,'a13',3.333,5),(307,12747,12718,'13e',3.333,5),(307,12748,12718,'3ed',3.333,5),(308,12750,12749,'naa',100,5),(308,12751,12750,'600',3.333,5),(308,12752,12750,'000',3.333,5),(308,12753,12750,'00c',3.333,5),(308,12754,12750,'0c2',3.333,5),(308,12755,12750,'c29',3.333,5),(308,12756,12750,'298',3.333,5),(308,12757,12750,'98a',3.333,5),(308,12758,12750,'8a3',3.333,5),(308,12759,12750,'a30',3.333,5),(308,12760,12750,'30b',3.333,5),(308,12761,12750,'0b9',3.333,5),(308,12762,12750,'b94',3.333,5),(308,12763,12750,'947',3.333,5),(308,12764,12750,'471',3.333,5),(308,12765,12750,'717',3.333,5),(308,12766,12750,'17e',3.333,5),(308,12767,12750,'7e0',3.333,5),(308,12768,12750,'e0a',3.333,5),(308,12769,12750,'0a7',3.333,5),(308,12770,12750,'a7b',3.333,5),(308,12771,12750,'7b8',3.333,5),(308,12772,12750,'b89',3.333,5),(308,12773,12750,'89a',3.333,5),(308,12774,12750,'9a2',3.333,5),(308,12775,12750,'a24',3.333,5),(308,12776,12750,'247',3.333,5),(308,12777,12750,'473',3.333,5),(308,12778,12750,'73c',3.333,5),(308,12779,12750,'3c2',3.333,5),(308,12780,12750,'c29',3.333,5),(309,12782,12781,'naa',100,5),(309,12783,12782,'600',3.333,5),(309,12784,12782,'000',3.333,5),(309,12785,12782,'00c',3.333,5),(309,12786,12782,'0c2',3.333,5),(309,12787,12782,'c29',3.333,5),(309,12788,12782,'29b',3.333,5),(309,12789,12782,'9ba',3.333,5),(309,12790,12782,'ba4',3.333,5),(309,12791,12782,'a45',3.333,5),(309,12792,12782,'450',3.333,5),(309,12793,12782,'507',3.333,5),(309,12794,12782,'079',3.333,5),(309,12795,12782,'796',3.333,5),(309,12796,12782,'964',3.333,5),(309,12797,12782,'64d',3.333,5),(309,12798,12782,'4df',3.333,5),(309,12799,12782,'dff',3.333,5),(309,12800,12782,'ff0',3.333,5),(309,12801,12782,'f0a',3.333,5),(309,12802,12782,'0ad',3.333,5),(309,12803,12782,'ad7',3.333,5),(309,12804,12782,'d72',3.333,5),(309,12805,12782,'72b',3.333,5),(309,12806,12782,'2b7',3.333,5),(309,12807,12782,'b70',3.333,5),(309,12808,12782,'70a',3.333,5),(309,12809,12782,'0af',3.333,5),(309,12810,12782,'afb',3.333,5),(309,12811,12782,'fbb',3.333,5),(309,12812,12782,'bbe',3.333,5),(310,12814,12813,'naa',100,5),(310,12815,12814,'600',3.333,5),(310,12816,12814,'000',3.333,5),(310,12817,12814,'00c',3.333,5),(310,12818,12814,'0c2',3.333,5),(310,12819,12814,'c29',3.333,5),(310,12820,12814,'298',3.333,5),(310,12821,12814,'98d',3.333,5),(310,12822,12814,'8d5',3.333,5),(310,12823,12814,'d5e',3.333,5),(310,12824,12814,'5ef',3.333,5),(310,12825,12814,'ef3',3.333,5),(310,12826,12814,'f35',3.333,5),(310,12827,12814,'350',3.333,5),(310,12828,12814,'507',3.333,5),(310,12829,12814,'077',3.333,5),(310,12830,12814,'777',3.333,5),(310,12831,12814,'77b',3.333,5),(310,12832,12814,'7b9',3.333,5),(310,12833,12814,'b9f',3.333,5),(310,12834,12814,'9f2',3.333,5),(310,12835,12814,'f2b',3.333,5),(310,12836,12814,'2be',3.333,5),(310,12837,12814,'be8',3.333,5),(310,12838,12814,'e8b',3.333,5),(310,12839,12814,'8ba',3.333,5),(310,12840,12814,'ba3',3.333,5),(310,12841,12814,'a3e',3.333,5),(310,12842,12814,'3ef',3.333,5),(310,12843,12814,'ef9',3.333,5),(310,12844,12814,'f94',3.333,5),(311,12846,12845,'naa',100,5),(311,12847,12846,'600',3.333,5),(311,12848,12846,'000',3.333,5),(311,12849,12846,'00c',3.333,5),(311,12850,12846,'0c2',3.333,5),(311,12851,12846,'c29',3.333,5),(311,12852,12846,'294',3.333,5),(311,12853,12846,'941',3.333,5),(311,12854,12846,'41f',3.333,5),(311,12855,12846,'1f9',3.333,5),(311,12856,12846,'f98',3.333,5),(311,12857,12846,'98a',3.333,5),(311,12858,12846,'8a8',3.333,5),(311,12859,12846,'a8f',3.333,5),(311,12860,12846,'8f5',3.333,5),(311,12861,12846,'f55',3.333,5),(311,12862,12846,'551',3.333,5),(311,12863,12846,'513',3.333,5),(311,12864,12846,'137',3.333,5),(311,12865,12846,'379',3.333,5),(311,12866,12846,'79b',3.333,5),(311,12867,12846,'9b3',3.333,5),(311,12868,12846,'b37',3.333,5),(311,12869,12846,'37f',3.333,5),(311,12870,12846,'7f7',3.333,5),(311,12871,12846,'f77',3.333,5),(311,12872,12846,'771',3.333,5),(311,12873,12846,'715',3.333,5),(311,12874,12846,'15f',3.333,5),(311,12875,12846,'5f1',3.333,5),(311,12876,12846,'f14',3.333,5),(312,12878,12877,'naa',100,5),(312,12879,12878,'600',3.333,5),(312,12880,12878,'000',3.333,5),(312,12881,12878,'00c',3.333,5),(312,12882,12878,'0c2',3.333,5),(312,12883,12878,'c29',3.333,5),(312,12884,12878,'296',3.333,5),(312,12885,12878,'96e',3.333,5),(312,12886,12878,'6ef',3.333,5),(312,12887,12878,'efb',3.333,5),(312,12888,12878,'fb8',3.333,5),(312,12889,12878,'b83',3.333,5),(312,12890,12878,'831',3.333,5),(312,12891,12878,'31d',3.333,5),(312,12892,12878,'1d1',3.333,5),(312,12893,12878,'d18',3.333,5),(312,12894,12878,'187',3.333,5),(312,12895,12878,'874',3.333,5),(312,12896,12878,'740',3.333,5),(312,12897,12878,'40d',3.333,5),(312,12898,12878,'0de',3.333,5),(312,12899,12878,'de6',3.333,5),(312,12900,12878,'e67',3.333,5),(312,12901,12878,'67a',3.333,5),(312,12902,12878,'7a8',3.333,5),(312,12903,12878,'a82',3.333,5),(312,12904,12878,'821',3.333,5),(312,12905,12878,'212',3.333,5),(312,12906,12878,'12b',3.333,5),(312,12907,12878,'2ba',3.333,5),(312,12908,12878,'ba3',3.333,5),(313,12910,12909,'naa',100,5),(313,12911,12910,'600',3.333,5),(313,12912,12910,'000',3.333,5),(313,12913,12910,'00c',3.333,5),(313,12914,12910,'0c2',3.333,5),(313,12915,12910,'c29',3.333,5),(313,12916,12910,'29e',3.333,5),(313,12917,12910,'9ef',3.333,5),(313,12918,12910,'ef7',3.333,5),(313,12919,12910,'f7c',3.333,5),(313,12920,12910,'7c7',3.333,5),(313,12921,12910,'c74',3.333,5),(313,12922,12910,'743',3.333,5),(313,12923,12910,'43e',3.333,5),(313,12924,12910,'3ec',3.333,5),(313,12925,12910,'ec1',3.333,5),(313,12926,12910,'c1f',3.333,5),(313,12927,12910,'1f1',3.333,5),(313,12928,12910,'f1a',3.333,5),(313,12929,12910,'1ae',3.333,5),(313,12930,12910,'ae7',3.333,5),(313,12931,12910,'e77',3.333,5),(313,12932,12910,'77f',3.333,5),(313,12933,12910,'7fc',3.333,5),(313,12934,12910,'fc0',3.333,5),(313,12935,12910,'c08',3.333,5),(313,12936,12910,'08b',3.333,5),(313,12937,12910,'8b4',3.333,5),(313,12938,12910,'b4c',3.333,5),(313,12939,12910,'4c8',3.333,5),(313,12940,12910,'c8a',3.333,5),(314,12942,12941,'naa',100,5),(314,12943,12942,'600',3.333,5),(314,12944,12942,'000',3.333,5),(314,12945,12942,'00c',3.333,5),(314,12946,12942,'0c2',3.333,5),(314,12947,12942,'c29',3.333,5),(314,12948,12942,'299',3.333,5),(314,12949,12942,'99c',3.333,5),(314,12950,12942,'9cd',3.333,5),(314,12951,12942,'cde',3.333,5),(314,12952,12942,'ded',3.333,5),(314,12953,12942,'ed2',3.333,5),(314,12954,12942,'d2c',3.333,5),(314,12955,12942,'2c9',3.333,5),(314,12956,12942,'c9a',3.333,5),(314,12957,12942,'9ad',3.333,5),(314,12958,12942,'adf',3.333,5),(314,12959,12942,'df6',3.333,5),(314,12960,12942,'f69',3.333,5),(314,12961,12942,'690',3.333,5),(314,12962,12942,'90a',3.333,5),(314,12963,12942,'0ae',3.333,5),(314,12964,12942,'ae5',3.333,5),(314,12965,12942,'e5b',3.333,5),(314,12966,12942,'5be',3.333,5),(314,12967,12942,'be3',3.333,5),(314,12968,12942,'e38',3.333,5),(314,12969,12942,'386',3.333,5),(314,12970,12942,'86c',3.333,5),(314,12971,12942,'6c2',3.333,5),(314,12972,12942,'c24',3.333,5),(315,12974,12973,'naa',100,5),(315,12975,12974,'600',3.333,5),(315,12976,12974,'000',3.333,5),(315,12977,12974,'00c',3.333,5),(315,12978,12974,'0c2',3.333,5),(315,12979,12974,'c29',3.333,5),(315,12980,12974,'29a',3.333,5),(315,12981,12974,'9a8',3.333,5),(315,12982,12974,'a85',3.333,5),(315,12983,12974,'85c',3.333,5),(315,12984,12974,'5ce',3.333,5),(315,12985,12974,'ce1',3.333,5),(315,12986,12974,'e16',3.333,5),(315,12987,12974,'165',3.333,5),(315,12988,12974,'65a',3.333,5),(315,12989,12974,'5a8',3.333,5),(315,12990,12974,'a8d',3.333,5),(315,12991,12974,'8d9',3.333,5),(315,12992,12974,'d96',3.333,5),(315,12993,12974,'96c',3.333,5),(315,12994,12974,'6ca',3.333,5),(315,12995,12974,'caf',3.333,5),(315,12996,12974,'af4',3.333,5),(315,12997,12974,'f46',3.333,5),(315,12998,12974,'467',3.333,5),(315,12999,12974,'67e',3.333,5),(315,13000,12974,'7e2',3.333,5),(315,13001,12974,'e2b',3.333,5),(315,13002,12974,'2b8',3.333,5),(315,13003,12974,'b8c',3.333,5),(315,13004,12974,'8c2',3.333,5),(316,13006,13005,'naa',100,5),(316,13007,13006,'600',3.333,5),(316,13008,13006,'000',3.333,5),(316,13009,13006,'00c',3.333,5),(316,13010,13006,'0c2',3.333,5),(316,13011,13006,'c29',3.333,5),(316,13012,13006,'29f',3.333,5),(316,13013,13006,'9f3',3.333,5),(316,13014,13006,'f3e',3.333,5),(316,13015,13006,'3eb',3.333,5),(316,13016,13006,'ebb',3.333,5),(316,13017,13006,'bb0',3.333,5),(316,13018,13006,'b0d',3.333,5),(316,13019,13006,'0d5',3.333,5),(316,13020,13006,'d58',3.333,5),(316,13021,13006,'585',3.333,5),(316,13022,13006,'85f',3.333,5),(316,13023,13006,'5f0',3.333,5),(316,13024,13006,'f0e',3.333,5),(316,13025,13006,'0ed',3.333,5),(316,13026,13006,'ed9',3.333,5),(316,13027,13006,'d94',3.333,5),(316,13028,13006,'942',3.333,5),(316,13029,13006,'422',3.333,5),(316,13030,13006,'22d',3.333,5),(316,13031,13006,'2d6',3.333,5),(316,13032,13006,'d66',3.333,5),(316,13033,13006,'664',3.333,5),(316,13034,13006,'640',3.333,5),(316,13035,13006,'405',3.333,5),(316,13036,13006,'057',3.333,5),(317,13038,13037,'naa',100,5),(317,13039,13038,'600',3.333,5),(317,13040,13038,'000',3.333,5),(317,13041,13038,'00c',3.333,5),(317,13042,13038,'0c2',3.333,5),(317,13043,13038,'c29',3.333,5),(317,13044,13038,'292',3.333,5),(317,13045,13038,'921',3.333,5),(317,13046,13038,'210',3.333,5),(317,13047,13038,'106',3.333,5),(317,13048,13038,'063',3.333,5),(317,13049,13038,'632',3.333,5),(317,13050,13038,'325',3.333,5),(317,13051,13038,'252',3.333,5),(317,13052,13038,'526',3.333,5),(317,13053,13038,'267',3.333,5),(317,13054,13038,'676',3.333,5),(317,13055,13038,'769',3.333,5),(317,13056,13038,'69e',3.333,5),(317,13057,13038,'9e2',3.333,5),(317,13058,13038,'e22',3.333,5),(317,13059,13038,'22c',3.333,5),(317,13060,13038,'2c7',3.333,5),(317,13061,13038,'c7c',3.333,5),(317,13062,13038,'7c3',3.333,5),(317,13063,13038,'c31',3.333,5),(317,13064,13038,'31f',3.333,5),(317,13065,13038,'1ff',3.333,5),(317,13066,13038,'ff3',3.333,5),(317,13067,13038,'f32',3.333,5),(317,13068,13038,'326',3.333,5),(318,13070,13069,'naa',100,5),(318,13071,13070,'600',3.333,5),(318,13072,13070,'000',3.333,5),(318,13073,13070,'00c',3.333,5),(318,13074,13070,'0c2',3.333,5),(318,13075,13070,'c29',3.333,5),(318,13076,13070,'293',3.333,5),(318,13077,13070,'935',3.333,5),(318,13078,13070,'350',3.333,5),(318,13079,13070,'508',3.333,5),(318,13080,13070,'081',3.333,5),(318,13081,13070,'81e',3.333,5),(318,13082,13070,'1e5',3.333,5),(318,13083,13070,'e51',3.333,5),(318,13084,13070,'51a',3.333,5),(318,13085,13070,'1a2',3.333,5),(318,13086,13070,'a22',3.333,5),(318,13087,13070,'220',3.333,5),(318,13088,13070,'200',3.333,5),(318,13089,13070,'00a',3.333,5),(318,13090,13070,'0a7',3.333,5),(318,13091,13070,'a7f',3.333,5),(318,13092,13070,'7f5',3.333,5),(318,13093,13070,'f51',3.333,5),(318,13094,13070,'512',3.333,5),(318,13095,13070,'126',3.333,5),(318,13096,13070,'268',3.333,5),(318,13097,13070,'68b',3.333,5),(318,13098,13070,'8b8',3.333,5),(318,13099,13070,'b89',3.333,5),(318,13100,13070,'899',3.333,5),(319,13102,13101,'naa',100,5),(319,13103,13102,'600',3.333,5),(319,13104,13102,'000',3.333,5),(319,13105,13102,'00c',3.333,5),(319,13106,13102,'0c2',3.333,5),(319,13107,13102,'c29',3.333,5),(319,13108,13102,'29a',3.333,5),(319,13109,13102,'9a9',3.333,5),(319,13110,13102,'a98',3.333,5),(319,13111,13102,'98d',3.333,5),(319,13112,13102,'8d1',3.333,5),(319,13113,13102,'d15',3.333,5),(319,13114,13102,'150',3.333,5),(319,13115,13102,'500',3.333,5),(319,13116,13102,'00a',3.333,5),(319,13117,13102,'0a7',3.333,5),(319,13118,13102,'a78',3.333,5),(319,13119,13102,'789',3.333,5),(319,13120,13102,'899',3.333,5),(319,13121,13102,'993',3.333,5),(319,13122,13102,'935',3.333,5),(319,13123,13102,'35c',3.333,5),(319,13124,13102,'5c2',3.333,5),(319,13125,13102,'c21',3.333,5),(319,13126,13102,'211',3.333,5),(319,13127,13102,'11a',3.333,5),(319,13128,13102,'1af',3.333,5),(319,13129,13102,'afc',3.333,5),(319,13130,13102,'fcf',3.333,5),(319,13131,13102,'cfa',3.333,5),(319,13132,13102,'fa4',3.333,5),(320,13134,13133,'naa',100,5),(320,13135,13134,'600',3.333,5),(320,13136,13134,'000',3.333,5),(320,13137,13134,'00c',3.333,5),(320,13138,13134,'0c2',3.333,5),(320,13139,13134,'c29',3.333,5),(320,13140,13134,'293',3.333,5),(320,13141,13134,'93f',3.333,5),(320,13142,13134,'3f2',3.333,5),(320,13143,13134,'f22',3.333,5),(320,13144,13134,'222',3.333,5),(320,13145,13134,'224',3.333,5),(320,13146,13134,'245',3.333,5),(320,13147,13134,'457',3.333,5),(320,13148,13134,'57d',3.333,5),(320,13149,13134,'7d8',3.333,5),(320,13150,13134,'d87',3.333,5),(320,13151,13134,'87a',3.333,5),(320,13152,13134,'7ad',3.333,5),(320,13153,13134,'adc',3.333,5),(320,13154,13134,'dc2',3.333,5),(320,13155,13134,'c26',3.333,5),(320,13156,13134,'267',3.333,5),(320,13157,13134,'67e',3.333,5),(320,13158,13134,'7ec',3.333,5),(320,13159,13134,'ecc',3.333,5),(320,13160,13134,'cca',3.333,5),(320,13161,13134,'cab',3.333,5),(320,13162,13134,'abf',3.333,5),(320,13163,13134,'bf1',3.333,5),(320,13164,13134,'f11',3.333,5),(321,13166,13165,'naa',100,5),(321,13167,13166,'600',3.333,5),(321,13168,13166,'000',3.333,5),(321,13169,13166,'00c',3.333,5),(321,13170,13166,'0c2',3.333,5),(321,13171,13166,'c29',3.333,5),(321,13172,13166,'297',3.333,5),(321,13173,13166,'97c',3.333,5),(321,13174,13166,'7ce',3.333,5),(321,13175,13166,'ce2',3.333,5),(321,13176,13166,'e25',3.333,5),(321,13177,13166,'254',3.333,5),(321,13178,13166,'54a',3.333,5),(321,13179,13166,'4a9',3.333,5),(321,13180,13166,'a93',3.333,5),(321,13181,13166,'93f',3.333,5),(321,13182,13166,'3f0',3.333,5),(321,13183,13166,'f01',3.333,5),(321,13184,13166,'01e',3.333,5),(321,13185,13166,'1e4',3.333,5),(321,13186,13166,'e4b',3.333,5),(321,13187,13166,'4bd',3.333,5),(321,13188,13166,'bda',3.333,5),(321,13189,13166,'da7',3.333,5),(321,13190,13166,'a77',3.333,5),(321,13191,13166,'775',3.333,5),(321,13192,13166,'755',3.333,5),(321,13193,13166,'55f',3.333,5),(321,13194,13166,'5f8',3.333,5),(321,13195,13166,'f8b',3.333,5),(321,13196,13166,'8b1',3.333,5),(322,13198,13197,'naa',100,5),(322,13199,13198,'600',3.333,5),(322,13200,13198,'000',3.333,5),(322,13201,13198,'00c',3.333,5),(322,13202,13198,'0c2',3.333,5),(322,13203,13198,'c29',3.333,5),(322,13204,13198,'294',3.333,5),(322,13205,13198,'94c',3.333,5),(322,13206,13198,'4cc',3.333,5),(322,13207,13198,'cc7',3.333,5),(322,13208,13198,'c74',3.333,5),(322,13209,13198,'74c',3.333,5),(322,13210,13198,'4c7',3.333,5),(322,13211,13198,'c70',3.333,5),(322,13212,13198,'700',3.333,5),(322,13213,13198,'000',3.333,5),(322,13214,13198,'006',3.333,5),(322,13215,13198,'060',3.333,5),(322,13216,13198,'608',3.333,5),(322,13217,13198,'08f',3.333,5),(322,13218,13198,'8f5',3.333,5),(322,13219,13198,'f59',3.333,5),(322,13220,13198,'59a',3.333,5),(322,13221,13198,'9a1',3.333,5),(322,13222,13198,'a1e',3.333,5),(322,13223,13198,'1e6',3.333,5),(322,13224,13198,'e6e',3.333,5),(322,13225,13198,'6e6',3.333,5),(322,13226,13198,'e6c',3.333,5),(322,13227,13198,'6cc',3.333,5),(322,13228,13198,'cc5',3.333,5),(323,13230,13229,'naa',100,5),(323,13231,13230,'600',3.333,5),(323,13232,13230,'000',3.333,5),(323,13233,13230,'00c',3.333,5),(323,13234,13230,'0c2',3.333,5),(323,13235,13230,'c29',3.333,5),(323,13236,13230,'29b',3.333,5),(323,13237,13230,'9bd',3.333,5),(323,13238,13230,'bd7',3.333,5),(323,13239,13230,'d75',3.333,5),(323,13240,13230,'75f',3.333,5),(323,13241,13230,'5f2',3.333,5),(323,13242,13230,'f23',3.333,5),(323,13243,13230,'23c',3.333,5),(323,13244,13230,'3cc',3.333,5),(323,13245,13230,'cc1',3.333,5),(323,13246,13230,'c16',3.333,5),(323,13247,13230,'168',3.333,5),(323,13248,13230,'68d',3.333,5),(323,13249,13230,'8d1',3.333,5),(323,13250,13230,'d13',3.333,5),(323,13251,13230,'132',3.333,5),(323,13252,13230,'322',3.333,5),(323,13253,13230,'228',3.333,5),(323,13254,13230,'28c',3.333,5),(323,13255,13230,'8cf',3.333,5),(323,13256,13230,'cfd',3.333,5),(323,13257,13230,'fd1',3.333,5),(323,13258,13230,'d11',3.333,5),(323,13259,13230,'118',3.333,5),(323,13260,13230,'188',3.333,5),(324,13262,13261,'naa',100,5),(324,13263,13262,'600',3.333,5),(324,13264,13262,'000',3.333,5),(324,13265,13262,'00c',3.333,5),(324,13266,13262,'0c2',3.333,5),(324,13267,13262,'c29',3.333,5),(324,13268,13262,'294',3.333,5),(324,13269,13262,'944',3.333,5),(324,13270,13262,'449',3.333,5),(324,13271,13262,'49c',3.333,5),(324,13272,13262,'9c9',3.333,5),(324,13273,13262,'c9f',3.333,5),(324,13274,13262,'9f7',3.333,5),(324,13275,13262,'f7c',3.333,5),(324,13276,13262,'7c6',3.333,5),(324,13277,13262,'c6c',3.333,5),(324,13278,13262,'6cc',3.333,5),(324,13279,13262,'cce',3.333,5),(324,13280,13262,'cee',3.333,5),(324,13281,13262,'ee2',3.333,5),(324,13282,13262,'e27',3.333,5),(324,13283,13262,'27d',3.333,5),(324,13284,13262,'7d6',3.333,5),(324,13285,13262,'d61',3.333,5),(324,13286,13262,'61d',3.333,5),(324,13287,13262,'1d6',3.333,5),(324,13288,13262,'d6b',3.333,5),(324,13289,13262,'6b5',3.333,5),(324,13290,13262,'b54',3.333,5),(324,13291,13262,'548',3.333,5),(324,13292,13262,'48a',3.333,5),(325,13294,13293,'naa',100,5),(325,13295,13294,'600',3.333,5),(325,13296,13294,'000',3.333,5),(325,13297,13294,'00c',3.333,5),(325,13298,13294,'0c2',3.333,5),(325,13299,13294,'c29',3.333,5),(325,13300,13294,'299',3.333,5),(325,13301,13294,'99c',3.333,5),(325,13302,13294,'9cd',3.333,5),(325,13303,13294,'cd2',3.333,5),(325,13304,13294,'d2c',3.333,5),(325,13305,13294,'2c7',3.333,5),(325,13306,13294,'c79',3.333,5),(325,13307,13294,'79e',3.333,5),(325,13308,13294,'9e0',3.333,5),(325,13309,13294,'e03',3.333,5),(325,13310,13294,'031',3.333,5),(325,13311,13294,'319',3.333,5),(325,13312,13294,'192',3.333,5),(325,13313,13294,'925',3.333,5),(325,13314,13294,'25c',3.333,5),(325,13315,13294,'5c1',3.333,5),(325,13316,13294,'c13',3.333,5),(325,13317,13294,'135',3.333,5),(325,13318,13294,'358',3.333,5),(325,13319,13294,'58c',3.333,5),(325,13320,13294,'8c4',3.333,5),(325,13321,13294,'c47',3.333,5),(325,13322,13294,'473',3.333,5),(325,13323,13294,'73e',3.333,5),(325,13324,13294,'3e6',3.333,5),(326,13326,13325,'naa',100,5),(326,13327,13326,'600',3.333,5),(326,13328,13326,'000',3.333,5),(326,13329,13326,'00c',3.333,5),(326,13330,13326,'0c2',3.333,5),(326,13331,13326,'c29',3.333,5),(326,13332,13326,'297',3.333,5),(326,13333,13326,'973',3.333,5),(326,13334,13326,'733',3.333,5),(326,13335,13326,'33b',3.333,5),(326,13336,13326,'3b0',3.333,5),(326,13337,13326,'b03',3.333,5),(326,13338,13326,'036',3.333,5),(326,13339,13326,'365',3.333,5),(326,13340,13326,'657',3.333,5),(326,13341,13326,'570',3.333,5),(326,13342,13326,'706',3.333,5),(326,13343,13326,'06a',3.333,5),(326,13344,13326,'6a5',3.333,5),(326,13345,13326,'a54',3.333,5),(326,13346,13326,'54a',3.333,5),(326,13347,13326,'4a9',3.333,5),(326,13348,13326,'a9a',3.333,5),(326,13349,13326,'9a5',3.333,5),(326,13350,13326,'a5c',3.333,5),(326,13351,13326,'5c2',3.333,5),(326,13352,13326,'c24',3.333,5),(326,13353,13326,'247',3.333,5),(326,13354,13326,'471',3.333,5),(326,13355,13326,'71d',3.333,5),(326,13356,13326,'1db',3.333,5),(327,13358,13357,'naa',100,5),(327,13359,13358,'600',3.333,5),(327,13360,13358,'000',3.333,5),(327,13361,13358,'00c',3.333,5),(327,13362,13358,'0c2',3.333,5),(327,13363,13358,'c29',3.333,5),(327,13364,13358,'291',3.333,5),(327,13365,13358,'91c',3.333,5),(327,13366,13358,'1c6',3.333,5),(327,13367,13358,'c6a',3.333,5),(327,13368,13358,'6a3',3.333,5),(327,13369,13358,'a36',3.333,5),(327,13370,13358,'366',3.333,5),(327,13371,13358,'669',3.333,5),(327,13372,13358,'69e',3.333,5),(327,13373,13358,'9ea',3.333,5),(327,13374,13358,'ea9',3.333,5),(327,13375,13358,'a9c',3.333,5),(327,13376,13358,'9c1',3.333,5),(327,13377,13358,'c11',3.333,5),(327,13378,13358,'11a',3.333,5),(327,13379,13358,'1a4',3.333,5),(327,13380,13358,'a42',3.333,5),(327,13381,13358,'428',3.333,5),(327,13382,13358,'284',3.333,5),(327,13383,13358,'842',3.333,5),(327,13384,13358,'428',3.333,5),(327,13385,13358,'28f',3.333,5),(327,13386,13358,'8f0',3.333,5),(327,13387,13358,'f0c',3.333,5),(327,13388,13358,'0c0',3.333,5),(328,13390,13389,'naa',100,5),(328,13391,13390,'600',3.333,5),(328,13392,13390,'000',3.333,5),(328,13393,13390,'00c',3.333,5),(328,13394,13390,'0c2',3.333,5),(328,13395,13390,'c29',3.333,5),(328,13396,13390,'29a',3.333,5),(328,13397,13390,'9ae',3.333,5),(328,13398,13390,'ae3',3.333,5),(328,13399,13390,'e3e',3.333,5),(328,13400,13390,'3e1',3.333,5),(328,13401,13390,'e10',3.333,5),(328,13402,13390,'105',3.333,5),(328,13403,13390,'05b',3.333,5),(328,13404,13390,'5be',3.333,5),(328,13405,13390,'bef',3.333,5),(328,13406,13390,'ef4',3.333,5),(328,13407,13390,'f45',3.333,5),(328,13408,13390,'458',3.333,5),(328,13409,13390,'581',3.333,5),(328,13410,13390,'810',3.333,5),(328,13411,13390,'100',3.333,5),(328,13412,13390,'00c',3.333,5),(328,13413,13390,'0c4',3.333,5),(328,13414,13390,'c41',3.333,5),(328,13415,13390,'41d',3.333,5),(328,13416,13390,'1d9',3.333,5),(328,13417,13390,'d96',3.333,5),(328,13418,13390,'96e',3.333,5),(328,13419,13390,'6e5',3.333,5),(328,13420,13390,'e5e',3.333,5),(329,13422,13421,'naa',100,5),(329,13423,13422,'600',3.333,5),(329,13424,13422,'000',3.333,5),(329,13425,13422,'00c',3.333,5),(329,13426,13422,'0c2',3.333,5),(329,13427,13422,'c29',3.333,5),(329,13428,13422,'29d',3.333,5),(329,13429,13422,'9d4',3.333,5),(329,13430,13422,'d41',3.333,5),(329,13431,13422,'410',3.333,5),(329,13432,13422,'104',3.333,5),(329,13433,13422,'04d',3.333,5),(329,13434,13422,'4df',3.333,5),(329,13435,13422,'df0',3.333,5),(329,13436,13422,'f0c',3.333,5),(329,13437,13422,'0cf',3.333,5),(329,13438,13422,'cf1',3.333,5),(329,13439,13422,'f1b',3.333,5),(329,13440,13422,'1b6',3.333,5),(329,13441,13422,'b6e',3.333,5),(329,13442,13422,'6eb',3.333,5),(329,13443,13422,'ebc',3.333,5),(329,13444,13422,'bc4',3.333,5),(329,13445,13422,'c4f',3.333,5),(329,13446,13422,'4fb',3.333,5),(329,13447,13422,'fb7',3.333,5),(329,13448,13422,'b7e',3.333,5),(329,13449,13422,'7e6',3.333,5),(329,13450,13422,'e62',3.333,5),(329,13451,13422,'62e',3.333,5),(329,13452,13422,'2ea',3.333,5),(330,13454,13453,'naa',100,5),(330,13455,13454,'600',3.333,5),(330,13456,13454,'000',3.333,5),(330,13457,13454,'00c',3.333,5),(330,13458,13454,'0c2',3.333,5),(330,13459,13454,'c29',3.333,5),(330,13460,13454,'298',3.333,5),(330,13461,13454,'980',3.333,5),(330,13462,13454,'801',3.333,5),(330,13463,13454,'015',3.333,5),(330,13464,13454,'15b',3.333,5),(330,13465,13454,'5b7',3.333,5),(330,13466,13454,'b74',3.333,5),(330,13467,13454,'746',3.333,5),(330,13468,13454,'467',3.333,5),(330,13469,13454,'673',3.333,5),(330,13470,13454,'737',3.333,5),(330,13471,13454,'377',3.333,5),(330,13472,13454,'771',3.333,5),(330,13473,13454,'71e',3.333,5),(330,13474,13454,'1ea',3.333,5),(330,13475,13454,'ea3',3.333,5),(330,13476,13454,'a38',3.333,5),(330,13477,13454,'38b',3.333,5),(330,13478,13454,'8b8',3.333,5),(330,13479,13454,'b87',3.333,5),(330,13480,13454,'876',3.333,5),(330,13481,13454,'763',3.333,5),(330,13482,13454,'63c',3.333,5),(330,13483,13454,'3c6',3.333,5),(330,13484,13454,'c63',3.333,5),(331,13486,13485,'naa',100,5),(331,13487,13486,'600',3.333,5),(331,13488,13486,'000',3.333,5),(331,13489,13486,'00c',3.333,5),(331,13490,13486,'0c2',3.333,5),(331,13491,13486,'c29',3.333,5),(331,13492,13486,'29a',3.333,5),(331,13493,13486,'9aa',3.333,5),(331,13494,13486,'aa5',3.333,5),(331,13495,13486,'a56',3.333,5),(331,13496,13486,'563',3.333,5),(331,13497,13486,'634',3.333,5),(331,13498,13486,'348',3.333,5),(331,13499,13486,'48f',3.333,5),(331,13500,13486,'8f8',3.333,5),(331,13501,13486,'f8c',3.333,5),(331,13502,13486,'8c5',3.333,5),(331,13503,13486,'c52',3.333,5),(331,13504,13486,'52a',3.333,5),(331,13505,13486,'2aa',3.333,5),(331,13506,13486,'aa9',3.333,5),(331,13507,13486,'a98',3.333,5),(331,13508,13486,'982',3.333,5),(331,13509,13486,'82d',3.333,5),(331,13510,13486,'2d6',3.333,5),(331,13511,13486,'d67',3.333,5),(331,13512,13486,'67a',3.333,5),(331,13513,13486,'7a4',3.333,5),(331,13514,13486,'a43',3.333,5),(331,13515,13486,'435',3.333,5),(331,13516,13486,'35c',3.333,5),(332,13518,13517,'naa',100,5),(332,13519,13518,'600',3.333,5),(332,13520,13518,'000',3.333,5),(332,13521,13518,'00c',3.333,5),(332,13522,13518,'0c2',3.333,5),(332,13523,13518,'c29',3.333,5),(332,13524,13518,'295',3.333,5),(332,13525,13518,'950',3.333,5),(332,13526,13518,'50d',3.333,5),(332,13527,13518,'0d6',3.333,5),(332,13528,13518,'d69',3.333,5),(332,13529,13518,'69f',3.333,5),(332,13530,13518,'9f6',3.333,5),(332,13531,13518,'f69',3.333,5),(332,13532,13518,'69a',3.333,5),(332,13533,13518,'9a7',3.333,5),(332,13534,13518,'a7e',3.333,5),(332,13535,13518,'7e0',3.333,5),(332,13536,13518,'e00',3.333,5),(332,13537,13518,'008',3.333,5),(332,13538,13518,'086',3.333,5),(332,13539,13518,'862',3.333,5),(332,13540,13518,'627',3.333,5),(332,13541,13518,'277',3.333,5),(332,13542,13518,'77a',3.333,5),(332,13543,13518,'7a1',3.333,5),(332,13544,13518,'a15',3.333,5),(332,13545,13518,'153',3.333,5),(332,13546,13518,'537',3.333,5),(332,13547,13518,'37b',3.333,5),(332,13548,13518,'7b6',3.333,5),(333,13550,13549,'naa',100,5),(333,13551,13550,'600',3.333,5),(333,13552,13550,'000',3.333,5),(333,13553,13550,'00c',3.333,5),(333,13554,13550,'0c2',3.333,5),(333,13555,13550,'c29',3.333,5),(333,13556,13550,'29a',3.333,5),(333,13557,13550,'9a5',3.333,5),(333,13558,13550,'a54',3.333,5),(333,13559,13550,'54a',3.333,5),(333,13560,13550,'4a9',3.333,5),(333,13561,13550,'a9d',3.333,5),(333,13562,13550,'9df',3.333,5),(333,13563,13550,'df1',3.333,5),(333,13564,13550,'f10',3.333,5),(333,13565,13550,'10c',3.333,5),(333,13566,13550,'0c1',3.333,5),(333,13567,13550,'c14',3.333,5),(333,13568,13550,'149',3.333,5),(333,13569,13550,'490',3.333,5),(333,13570,13550,'901',3.333,5),(333,13571,13550,'01a',3.333,5),(333,13572,13550,'1ab',3.333,5),(333,13573,13550,'abe',3.333,5),(333,13574,13550,'be2',3.333,5),(333,13575,13550,'e20',3.333,5),(333,13576,13550,'20b',3.333,5),(333,13577,13550,'0b4',3.333,5),(333,13578,13550,'b48',3.333,5),(333,13579,13550,'484',3.333,5),(333,13580,13550,'848',3.333,5),(334,13582,13581,'naa',100,5),(334,13583,13582,'600',3.333,5),(334,13584,13582,'000',3.333,5),(334,13585,13582,'00c',3.333,5),(334,13586,13582,'0c2',3.333,5),(334,13587,13582,'c29',3.333,5),(334,13588,13582,'293',3.333,5),(334,13589,13582,'93d',3.333,5),(334,13590,13582,'3d4',3.333,5),(334,13591,13582,'d46',3.333,5),(334,13592,13582,'46d',3.333,5),(334,13593,13582,'6dc',3.333,5),(334,13594,13582,'dcd',3.333,5),(334,13595,13582,'cde',3.333,5),(334,13596,13582,'def',3.333,5),(334,13597,13582,'ef1',3.333,5),(334,13598,13582,'f17',3.333,5),(334,13599,13582,'171',3.333,5),(334,13600,13582,'713',3.333,5),(334,13601,13582,'137',3.333,5),(334,13602,13582,'37a',3.333,5),(334,13603,13582,'7ae',3.333,5),(334,13604,13582,'ae4',3.333,5),(334,13605,13582,'e44',3.333,5),(334,13606,13582,'44b',3.333,5),(334,13607,13582,'4b3',3.333,5),(334,13608,13582,'b3e',3.333,5),(334,13609,13582,'3e6',3.333,5),(334,13610,13582,'e63',3.333,5),(334,13611,13582,'63b',3.333,5),(334,13612,13582,'3b3',3.333,5),(335,13614,13613,'naa',100,5),(335,13615,13614,'600',3.333,5),(335,13616,13614,'000',3.333,5),(335,13617,13614,'00c',3.333,5),(335,13618,13614,'0c2',3.333,5),(335,13619,13614,'c29',3.333,5),(335,13620,13614,'298',3.333,5),(335,13621,13614,'987',3.333,5),(335,13622,13614,'879',3.333,5),(335,13623,13614,'79c',3.333,5),(335,13624,13614,'9c5',3.333,5),(335,13625,13614,'c54',3.333,5),(335,13626,13614,'542',3.333,5),(335,13627,13614,'426',3.333,5),(335,13628,13614,'262',3.333,5),(335,13629,13614,'625',3.333,5),(335,13630,13614,'25d',3.333,5),(335,13631,13614,'5d4',3.333,5),(335,13632,13614,'d4b',3.333,5),(335,13633,13614,'4b6',3.333,5),(335,13634,13614,'b60',3.333,5),(335,13635,13614,'608',3.333,5),(335,13636,13614,'088',3.333,5),(335,13637,13614,'88c',3.333,5),(335,13638,13614,'8cd',3.333,5),(335,13639,13614,'cdc',3.333,5),(335,13640,13614,'dc6',3.333,5),(335,13641,13614,'c6d',3.333,5),(335,13642,13614,'6db',3.333,5),(335,13643,13614,'db0',3.333,5),(335,13644,13614,'b0d',3.333,5),(336,13646,13645,'naa',100,5),(336,13647,13646,'600',3.333,5),(336,13648,13646,'000',3.333,5),(336,13649,13646,'00c',3.333,5),(336,13650,13646,'0c2',3.333,5),(336,13651,13646,'c29',3.333,5),(336,13652,13646,'299',3.333,5),(336,13653,13646,'997',3.333,5),(336,13654,13646,'97e',3.333,5),(336,13655,13646,'7ed',3.333,5),(336,13656,13646,'ed7',3.333,5),(336,13657,13646,'d7e',3.333,5),(336,13658,13646,'7ef',3.333,5),(336,13659,13646,'efd',3.333,5),(336,13660,13646,'fd8',3.333,5),(336,13661,13646,'d8c',3.333,5),(336,13662,13646,'8c6',3.333,5),(336,13663,13646,'c63',3.333,5),(336,13664,13646,'63e',3.333,5),(336,13665,13646,'3e8',3.333,5),(336,13666,13646,'e88',3.333,5),(336,13667,13646,'88f',3.333,5),(336,13668,13646,'8f7',3.333,5),(336,13669,13646,'f76',3.333,5),(336,13670,13646,'767',3.333,5),(336,13671,13646,'671',3.333,5),(336,13672,13646,'714',3.333,5),(336,13673,13646,'14c',3.333,5),(336,13674,13646,'4c2',3.333,5),(336,13675,13646,'c24',3.333,5),(336,13676,13646,'242',3.333,5),(337,13678,13677,'naa',100,5),(337,13679,13678,'600',3.333,5),(337,13680,13678,'000',3.333,5),(337,13681,13678,'00c',3.333,5),(337,13682,13678,'0c2',3.333,5),(337,13683,13678,'c29',3.333,5),(337,13684,13678,'294',3.333,5),(337,13685,13678,'942',3.333,5),(337,13686,13678,'42d',3.333,5),(337,13687,13678,'2d7',3.333,5),(337,13688,13678,'d74',3.333,5),(337,13689,13678,'742',3.333,5),(337,13690,13678,'42d',3.333,5),(337,13691,13678,'2da',3.333,5),(337,13692,13678,'dac',3.333,5),(337,13693,13678,'ac8',3.333,5),(337,13694,13678,'c85',3.333,5),(337,13695,13678,'850',3.333,5),(337,13696,13678,'505',3.333,5),(337,13697,13678,'058',3.333,5),(337,13698,13678,'584',3.333,5),(337,13699,13678,'84b',3.333,5),(337,13700,13678,'4b0',3.333,5),(337,13701,13678,'b05',3.333,5),(337,13702,13678,'052',3.333,5),(337,13703,13678,'525',3.333,5),(337,13704,13678,'255',3.333,5),(337,13705,13678,'554',3.333,5),(337,13706,13678,'54e',3.333,5),(337,13707,13678,'4ee',3.333,5),(337,13708,13678,'ee1',3.333,5),(338,13710,13709,'naa',100,5),(338,13711,13710,'600',3.333,5),(338,13712,13710,'000',3.333,5),(338,13713,13710,'00c',3.333,5),(338,13714,13710,'0c2',3.333,5),(338,13715,13710,'c29',3.333,5),(338,13716,13710,'290',3.333,5),(338,13717,13710,'901',3.333,5),(338,13718,13710,'01a',3.333,5),(338,13719,13710,'1a3',3.333,5),(338,13720,13710,'a38',3.333,5),(338,13721,13710,'38e',3.333,5),(338,13722,13710,'8e7',3.333,5),(338,13723,13710,'e75',3.333,5),(338,13724,13710,'752',3.333,5),(338,13725,13710,'528',3.333,5),(338,13726,13710,'283',3.333,5),(338,13727,13710,'833',3.333,5),(338,13728,13710,'335',3.333,5),(338,13729,13710,'35d',3.333,5),(338,13730,13710,'5db',3.333,5),(338,13731,13710,'db9',3.333,5),(338,13732,13710,'b9a',3.333,5),(338,13733,13710,'9a8',3.333,5),(338,13734,13710,'a8d',3.333,5),(338,13735,13710,'8d1',3.333,5),(338,13736,13710,'d1b',3.333,5),(338,13737,13710,'1b5',3.333,5),(338,13738,13710,'b55',3.333,5),(338,13739,13710,'55a',3.333,5),(338,13740,13710,'5a9',3.333,5),(339,13742,13741,'naa',100,5),(339,13743,13742,'600',3.333,5),(339,13744,13742,'000',3.333,5),(339,13745,13742,'00c',3.333,5),(339,13746,13742,'0c2',3.333,5),(339,13747,13742,'c29',3.333,5),(339,13748,13742,'293',3.333,5),(339,13749,13742,'93a',3.333,5),(339,13750,13742,'3a3',3.333,5),(339,13751,13742,'a34',3.333,5),(339,13752,13742,'34e',3.333,5),(339,13753,13742,'4e4',3.333,5),(339,13754,13742,'e4f',3.333,5),(339,13755,13742,'4ff',3.333,5),(339,13756,13742,'ff9',3.333,5),(339,13757,13742,'f97',3.333,5),(339,13758,13742,'971',3.333,5),(339,13759,13742,'71e',3.333,5),(339,13760,13742,'1e1',3.333,5),(339,13761,13742,'e1b',3.333,5),(339,13762,13742,'1b1',3.333,5),(339,13763,13742,'b11',3.333,5),(339,13764,13742,'11d',3.333,5),(339,13765,13742,'1d4',3.333,5),(339,13766,13742,'d44',3.333,5),(339,13767,13742,'447',3.333,5),(339,13768,13742,'47e',3.333,5),(339,13769,13742,'7e4',3.333,5),(339,13770,13742,'e4a',3.333,5),(339,13771,13742,'4a4',3.333,5),(339,13772,13742,'a42',3.333,5),(340,13774,13773,'naa',100,5),(340,13775,13774,'600',3.333,5),(340,13776,13774,'000',3.333,5),(340,13777,13774,'00c',3.333,5),(340,13778,13774,'0c2',3.333,5),(340,13779,13774,'c29',3.333,5),(340,13780,13774,'293',3.333,5),(340,13781,13774,'932',3.333,5),(340,13782,13774,'327',3.333,5),(340,13783,13774,'272',3.333,5),(340,13784,13774,'722',3.333,5),(340,13785,13774,'22f',3.333,5),(340,13786,13774,'2fb',3.333,5),(340,13787,13774,'fba',3.333,5),(340,13788,13774,'ba5',3.333,5),(340,13789,13774,'a55',3.333,5),(340,13790,13774,'553',3.333,5),(340,13791,13774,'532',3.333,5),(340,13792,13774,'32a',3.333,5),(340,13793,13774,'2a5',3.333,5),(340,13794,13774,'a5b',3.333,5),(340,13795,13774,'5b3',3.333,5),(340,13796,13774,'b3c',3.333,5),(340,13797,13774,'3cd',3.333,5),(340,13798,13774,'cde',3.333,5),(340,13799,13774,'de7',3.333,5),(340,13800,13774,'e7c',3.333,5),(340,13801,13774,'7c0',3.333,5),(340,13802,13774,'c0c',3.333,5),(340,13803,13774,'0c6',3.333,5),(340,13804,13774,'c63',3.333,5),(341,13806,13805,'naa',100,5),(341,13807,13806,'600',3.333,5),(341,13808,13806,'000',3.333,5),(341,13809,13806,'00c',3.333,5),(341,13810,13806,'0c2',3.333,5),(341,13811,13806,'c29',3.333,5),(341,13812,13806,'29c',3.333,5),(341,13813,13806,'9c2',3.333,5),(341,13814,13806,'c2a',3.333,5),(341,13815,13806,'2a0',3.333,5),(341,13816,13806,'a03',3.333,5),(341,13817,13806,'035',3.333,5),(341,13818,13806,'35d',3.333,5),(341,13819,13806,'5de',3.333,5),(341,13820,13806,'dec',3.333,5),(341,13821,13806,'ec0',3.333,5),(341,13822,13806,'c0c',3.333,5),(341,13823,13806,'0cb',3.333,5),(341,13824,13806,'cb7',3.333,5),(341,13825,13806,'b7c',3.333,5),(341,13826,13806,'7cf',3.333,5),(341,13827,13806,'cf2',3.333,5),(341,13828,13806,'f21',3.333,5),(341,13829,13806,'218',3.333,5),(341,13830,13806,'184',3.333,5),(341,13831,13806,'841',3.333,5),(341,13832,13806,'419',3.333,5),(341,13833,13806,'192',3.333,5),(341,13834,13806,'926',3.333,5),(341,13835,13806,'267',3.333,5),(341,13836,13806,'67b',3.333,5),(342,13838,13837,'naa',100,5),(342,13839,13838,'600',3.333,5),(342,13840,13838,'000',3.333,5),(342,13841,13838,'00c',3.333,5),(342,13842,13838,'0c2',3.333,5),(342,13843,13838,'c29',3.333,5),(342,13844,13838,'29d',3.333,5),(342,13845,13838,'9db',3.333,5),(342,13846,13838,'db0',3.333,5),(342,13847,13838,'b0b',3.333,5),(342,13848,13838,'0b2',3.333,5),(342,13849,13838,'b2f',3.333,5),(342,13850,13838,'2f9',3.333,5),(342,13851,13838,'f97',3.333,5),(342,13852,13838,'97b',3.333,5),(342,13853,13838,'7bc',3.333,5),(342,13854,13838,'bc7',3.333,5),(342,13855,13838,'c78',3.333,5),(342,13856,13838,'785',3.333,5),(342,13857,13838,'852',3.333,5),(342,13858,13838,'52b',3.333,5),(342,13859,13838,'2ba',3.333,5),(342,13860,13838,'ba8',3.333,5),(342,13861,13838,'a85',3.333,5),(342,13862,13838,'854',3.333,5),(342,13863,13838,'54b',3.333,5),(342,13864,13838,'4bc',3.333,5),(342,13865,13838,'bc5',3.333,5),(342,13866,13838,'c5a',3.333,5),(342,13867,13838,'5a0',3.333,5),(342,13868,13838,'a0f',3.333,5),(343,13870,13869,'hgw',9.091,5),(343,13871,13869,'gw2',9.091,5),(343,13872,13869,'w2k',9.091,5),(343,13873,13869,'2k8',9.091,5),(343,13874,13869,'k8r',9.091,5),(343,13875,13869,'8r2',9.091,5),(343,13876,13869,'r23',9.091,5),(343,13877,13869,'232',9.091,5),(343,13878,13869,'32v',9.091,5),(343,13879,13869,'2vm',9.091,5),(343,13880,13869,'vm4',9.091,5),(344,13882,13881,'naa',100,5),(344,13883,13882,'600',3.333,5),(344,13884,13882,'000',3.333,5),(344,13885,13882,'00c',3.333,5),(344,13886,13882,'0c2',3.333,5),(344,13887,13882,'c29',3.333,5),(344,13888,13882,'29f',3.333,5),(344,13889,13882,'9f6',3.333,5),(344,13890,13882,'f6f',3.333,5),(344,13891,13882,'6fd',3.333,5),(344,13892,13882,'fd3',3.333,5),(344,13893,13882,'d3e',3.333,5),(344,13894,13882,'3eb',3.333,5),(344,13895,13882,'eb9',3.333,5),(344,13896,13882,'b98',3.333,5),(344,13897,13882,'986',3.333,5),(344,13898,13882,'866',3.333,5),(344,13899,13882,'66c',3.333,5),(344,13900,13882,'6c0',3.333,5),(344,13901,13882,'c05',3.333,5),(344,13902,13882,'057',3.333,5),(344,13903,13882,'578',3.333,5),(344,13904,13882,'783',3.333,5),(344,13905,13882,'835',3.333,5),(344,13906,13882,'35e',3.333,5),(344,13907,13882,'5e2',3.333,5),(344,13908,13882,'e2b',3.333,5),(344,13909,13882,'2bc',3.333,5),(344,13910,13882,'bc5',3.333,5),(344,13911,13882,'c58',3.333,5),(344,13912,13882,'58a',3.333,5),(345,13914,13913,'naa',100,5),(345,13915,13914,'600',3.333,5),(345,13916,13914,'00a',3.333,5),(345,13917,13914,'0a0',3.333,5),(345,13918,13914,'a09',3.333,5),(345,13919,13914,'098',3.333,5),(345,13920,13914,'980',3.333,5),(345,13921,13914,'804',3.333,5),(345,13922,13914,'044',3.333,5),(345,13923,13914,'443',3.333,5),(345,13924,13914,'430',3.333,5),(345,13925,13914,'307',3.333,5),(345,13926,13914,'072',3.333,5),(345,13927,13914,'725',3.333,5),(345,13928,13914,'259',3.333,5),(345,13929,13914,'593',3.333,5),(345,13930,13914,'931',3.333,5),(345,13931,13914,'313',3.333,5),(345,13932,13914,'13f',3.333,5),(345,13933,13914,'3f3',3.333,5),(345,13934,13914,'f33',3.333,5),(345,13935,13914,'334',3.333,5),(345,13936,13914,'345',3.333,5),(345,13937,13914,'455',3.333,5),(345,13938,13914,'556',3.333,5),(345,13939,13914,'563',3.333,5),(345,13940,13914,'639',3.333,5),(345,13941,13914,'393',3.333,5),(345,13942,13914,'934',3.333,5),(345,13943,13914,'344',3.333,5),(345,13944,13914,'441',3.333,5),(346,13946,13945,'naa',100,5),(346,13947,13946,'600',3.333,5),(346,13948,13946,'00a',3.333,5),(346,13949,13946,'0a0',3.333,5),(346,13950,13946,'a09',3.333,5),(346,13951,13946,'098',3.333,5),(346,13952,13946,'980',3.333,5),(346,13953,13946,'804',3.333,5),(346,13954,13946,'044',3.333,5),(346,13955,13946,'443',3.333,5),(346,13956,13946,'430',3.333,5),(346,13957,13946,'307',3.333,5),(346,13958,13946,'072',3.333,5),(346,13959,13946,'725',3.333,5),(346,13960,13946,'259',3.333,5),(346,13961,13946,'593',3.333,5),(346,13962,13946,'931',3.333,5),(346,13963,13946,'313',3.333,5),(346,13964,13946,'13f',3.333,5),(346,13965,13946,'3f3',3.333,5),(346,13966,13946,'f33',3.333,5),(346,13967,13946,'334',3.333,5),(346,13968,13946,'345',3.333,5),(346,13969,13946,'455',3.333,5),(346,13970,13946,'556',3.333,5),(346,13971,13946,'563',3.333,5),(346,13972,13946,'639',3.333,5),(346,13973,13946,'393',3.333,5),(346,13974,13946,'934',3.333,5),(346,13975,13946,'344',3.333,5),(346,13976,13946,'442',3.333,5),(347,13978,13977,'naa',100,5),(347,13979,13978,'600',3.333,5),(347,13980,13978,'00a',3.333,5),(347,13981,13978,'0a0',3.333,5),(347,13982,13978,'a09',3.333,5),(347,13983,13978,'098',3.333,5),(347,13984,13978,'980',3.333,5),(347,13985,13978,'804',3.333,5),(347,13986,13978,'044',3.333,5),(347,13987,13978,'443',3.333,5),(347,13988,13978,'430',3.333,5),(347,13989,13978,'307',3.333,5),(347,13990,13978,'075',3.333,5),(347,13991,13978,'753',3.333,5),(347,13992,13978,'535',3.333,5),(347,13993,13978,'357',3.333,5),(347,13994,13978,'573',3.333,5),(347,13995,13978,'732',3.333,5),(347,13996,13978,'32b',3.333,5),(347,13997,13978,'2b3',3.333,5),(347,13998,13978,'b33',3.333,5),(347,13999,13978,'334',3.333,5),(347,14000,13978,'345',3.333,5),(347,14001,13978,'457',3.333,5),(347,14002,13978,'571',3.333,5),(347,14003,13978,'715',3.333,5),(347,14004,13978,'153',3.333,5),(347,14005,13978,'533',3.333,5),(347,14006,13978,'335',3.333,5),(347,14007,13978,'357',3.333,5),(347,14008,13978,'577',3.333,5),(348,14010,14009,'naa',100,5),(348,14011,14010,'600',3.333,5),(348,14012,14010,'00a',3.333,5),(348,14013,14010,'0a0',3.333,5),(348,14014,14010,'a09',3.333,5),(348,14015,14010,'098',3.333,5),(348,14016,14010,'980',3.333,5),(348,14017,14010,'804',3.333,5),(348,14018,14010,'044',3.333,5),(348,14019,14010,'443',3.333,5),(348,14020,14010,'430',3.333,5),(348,14021,14010,'307',3.333,5),(348,14022,14010,'075',3.333,5),(348,14023,14010,'753',3.333,5),(348,14024,14010,'535',3.333,5),(348,14025,14010,'357',3.333,5),(348,14026,14010,'573',3.333,5),(348,14027,14010,'732',3.333,5),(348,14028,14010,'32b',3.333,5),(348,14029,14010,'2b3',3.333,5),(348,14030,14010,'b33',3.333,5),(348,14031,14010,'334',3.333,5),(348,14032,14010,'345',3.333,5),(348,14033,14010,'457',3.333,5),(348,14034,14010,'571',3.333,5),(348,14035,14010,'715',3.333,5),(348,14036,14010,'153',3.333,5),(348,14037,14010,'533',3.333,5),(348,14038,14010,'335',3.333,5),(348,14039,14010,'357',3.333,5),(348,14040,14010,'578',3.333,5),(349,14042,14041,'naa',100,5),(349,14043,14042,'600',3.333,5),(349,14044,14042,'000',3.333,5),(349,14045,14042,'00c',3.333,5),(349,14046,14042,'0c2',3.333,5),(349,14047,14042,'c29',3.333,5),(349,14048,14042,'292',3.333,5),(349,14049,14042,'92e',3.333,5),(349,14050,14042,'2e0',3.333,5),(349,14051,14042,'e02',3.333,5),(349,14052,14042,'02e',3.333,5),(349,14053,14042,'2e6',3.333,5),(349,14054,14042,'e62',3.333,5),(349,14055,14042,'62a',3.333,5),(349,14056,14042,'2a7',3.333,5),(349,14057,14042,'a7e',3.333,5),(349,14058,14042,'7ea',3.333,5),(349,14059,14042,'ea5',3.333,5),(349,14060,14042,'a5f',3.333,5),(349,14061,14042,'5fc',3.333,5),(349,14062,14042,'fcc',3.333,5),(349,14063,14042,'cc7',3.333,5),(349,14064,14042,'c7e',3.333,5),(349,14065,14042,'7e2',3.333,5),(349,14066,14042,'e2a',3.333,5),(349,14067,14042,'2ac',3.333,5),(349,14068,14042,'ac6',3.333,5),(349,14069,14042,'c6d',3.333,5),(349,14070,14042,'6da',3.333,5),(349,14071,14042,'dac',3.333,5),(349,14072,14042,'ac2',3.333,5),(350,14074,14073,'naa',100,5),(350,14075,14074,'600',3.333,5),(350,14076,14074,'000',3.333,5),(350,14077,14074,'00c',3.333,5),(350,14078,14074,'0c2',3.333,5),(350,14079,14074,'c29',3.333,5),(350,14080,14074,'293',3.333,5),(350,14081,14074,'933',3.333,5),(350,14082,14074,'33e',3.333,5),(350,14083,14074,'3e3',3.333,5),(350,14084,14074,'e34',3.333,5),(350,14085,14074,'34e',3.333,5),(350,14086,14074,'4e6',3.333,5),(350,14087,14074,'e61',3.333,5),(350,14088,14074,'611',3.333,5),(350,14089,14074,'114',3.333,5),(350,14090,14074,'14d',3.333,5),(350,14091,14074,'4d0',3.333,5),(350,14092,14074,'d05',3.333,5),(350,14093,14074,'05c',3.333,5),(350,14094,14074,'5cd',3.333,5),(350,14095,14074,'cd5',3.333,5),(350,14096,14074,'d55',3.333,5),(350,14097,14074,'550',3.333,5),(350,14098,14074,'50d',3.333,5),(350,14099,14074,'0d6',3.333,5),(350,14100,14074,'d62',3.333,5),(350,14101,14074,'620',3.333,5),(350,14102,14074,'203',3.333,5),(350,14103,14074,'03a',3.333,5),(350,14104,14074,'3a2',3.333,5),(351,14106,14105,'naa',100,5),(351,14107,14106,'600',3.333,5),(351,14108,14106,'000',3.333,5),(351,14109,14106,'00c',3.333,5),(351,14110,14106,'0c2',3.333,5),(351,14111,14106,'c29',3.333,5),(351,14112,14106,'299',3.333,5),(351,14113,14106,'993',3.333,5),(351,14114,14106,'932',3.333,5),(351,14115,14106,'32d',3.333,5),(351,14116,14106,'2d1',3.333,5),(351,14117,14106,'d18',3.333,5),(351,14118,14106,'18c',3.333,5),(351,14119,14106,'8cc',3.333,5),(351,14120,14106,'cc5',3.333,5),(351,14121,14106,'c52',3.333,5),(351,14122,14106,'52a',3.333,5),(351,14123,14106,'2aa',3.333,5),(351,14124,14106,'aa4',3.333,5),(351,14125,14106,'a43',3.333,5),(351,14126,14106,'430',3.333,5),(351,14127,14106,'303',3.333,5),(351,14128,14106,'03f',3.333,5),(351,14129,14106,'3fb',3.333,5),(351,14130,14106,'fbb',3.333,5),(351,14131,14106,'bb5',3.333,5),(351,14132,14106,'b5e',3.333,5),(351,14133,14106,'5eb',3.333,5),(351,14134,14106,'eb3',3.333,5),(351,14135,14106,'b3c',3.333,5),(351,14136,14106,'3c8',3.333,5),(352,14138,14137,'naa',100,5),(352,14139,14138,'600',3.333,5),(352,14140,14138,'000',3.333,5),(352,14141,14138,'00c',3.333,5),(352,14142,14138,'0c2',3.333,5),(352,14143,14138,'c29',3.333,5),(352,14144,14138,'29f',3.333,5),(352,14145,14138,'9ff',3.333,5),(352,14146,14138,'ffd',3.333,5),(352,14147,14138,'fdb',3.333,5),(352,14148,14138,'dbb',3.333,5),(352,14149,14138,'bb1',3.333,5),(352,14150,14138,'b14',3.333,5),(352,14151,14138,'148',3.333,5),(352,14152,14138,'481',3.333,5),(352,14153,14138,'815',3.333,5),(352,14154,14138,'155',3.333,5),(352,14155,14138,'55d',3.333,5),(352,14156,14138,'5d0',3.333,5),(352,14157,14138,'d03',3.333,5),(352,14158,14138,'03e',3.333,5),(352,14159,14138,'3e2',3.333,5),(352,14160,14138,'e24',3.333,5),(352,14161,14138,'247',3.333,5),(352,14162,14138,'476',3.333,5),(352,14163,14138,'761',3.333,5),(352,14164,14138,'616',3.333,5),(352,14165,14138,'161',3.333,5),(352,14166,14138,'61c',3.333,5),(352,14167,14138,'1cb',3.333,5),(352,14168,14138,'cb4',3.333,5),(353,14170,14169,'naa',100,5),(353,14171,14170,'600',3.333,5),(353,14172,14170,'000',3.333,5),(353,14173,14170,'00c',3.333,5),(353,14174,14170,'0c2',3.333,5),(353,14175,14170,'c29',3.333,5),(353,14176,14170,'29b',3.333,5),(353,14177,14170,'9b6',3.333,5),(353,14178,14170,'b66',3.333,5),(353,14179,14170,'66d',3.333,5),(353,14180,14170,'6d5',3.333,5),(353,14181,14170,'d5f',3.333,5),(353,14182,14170,'5ff',3.333,5),(353,14183,14170,'ffd',3.333,5),(353,14184,14170,'fd2',3.333,5),(353,14185,14170,'d22',3.333,5),(353,14186,14170,'22d',3.333,5),(353,14187,14170,'2d0',3.333,5),(353,14188,14170,'d0d',3.333,5),(353,14189,14170,'0dd',3.333,5),(353,14190,14170,'dd7',3.333,5),(353,14191,14170,'d7c',3.333,5),(353,14192,14170,'7c0',3.333,5),(353,14193,14170,'c09',3.333,5),(353,14194,14170,'09b',3.333,5),(353,14195,14170,'9b5',3.333,5),(353,14196,14170,'b51',3.333,5),(353,14197,14170,'517',3.333,5),(353,14198,14170,'17e',3.333,5),(353,14199,14170,'7e5',3.333,5),(353,14200,14170,'e52',3.333,5),(354,14202,14201,'naa',100,5),(354,14203,14202,'600',3.333,5),(354,14204,14202,'000',3.333,5),(354,14205,14202,'00c',3.333,5),(354,14206,14202,'0c2',3.333,5),(354,14207,14202,'c29',3.333,5),(354,14208,14202,'298',3.333,5),(354,14209,14202,'98c',3.333,5),(354,14210,14202,'8cc',3.333,5),(354,14211,14202,'ccb',3.333,5),(354,14212,14202,'cbc',3.333,5),(354,14213,14202,'bcb',3.333,5),(354,14214,14202,'cb8',3.333,5),(354,14215,14202,'b85',3.333,5),(354,14216,14202,'856',3.333,5),(354,14217,14202,'562',3.333,5),(354,14218,14202,'621',3.333,5),(354,14219,14202,'219',3.333,5),(354,14220,14202,'196',3.333,5),(354,14221,14202,'96b',3.333,5),(354,14222,14202,'6ba',3.333,5),(354,14223,14202,'baa',3.333,5),(354,14224,14202,'aab',3.333,5),(354,14225,14202,'ab2',3.333,5),(354,14226,14202,'b20',3.333,5),(354,14227,14202,'201',3.333,5),(354,14228,14202,'010',3.333,5),(354,14229,14202,'10f',3.333,5),(354,14230,14202,'0f8',3.333,5),(354,14231,14202,'f8f',3.333,5),(354,14232,14202,'8ff',3.333,5),(355,14234,14233,'naa',100,5),(355,14235,14234,'600',3.333,5),(355,14236,14234,'000',3.333,5),(355,14237,14234,'00c',3.333,5),(355,14238,14234,'0c2',3.333,5),(355,14239,14234,'c29',3.333,5),(355,14240,14234,'293',3.333,5),(355,14241,14234,'935',3.333,5),(355,14242,14234,'35d',3.333,5),(355,14243,14234,'5dd',3.333,5),(355,14244,14234,'ddc',3.333,5),(355,14245,14234,'dc9',3.333,5),(355,14246,14234,'c92',3.333,5),(355,14247,14234,'92f',3.333,5),(355,14248,14234,'2f1',3.333,5),(355,14249,14234,'f10',3.333,5),(355,14250,14234,'104',3.333,5),(355,14251,14234,'043',3.333,5),(355,14252,14234,'433',3.333,5),(355,14253,14234,'33d',3.333,5),(355,14254,14234,'3d1',3.333,5),(355,14255,14234,'d19',3.333,5),(355,14256,14234,'19f',3.333,5),(355,14257,14234,'9f2',3.333,5),(355,14258,14234,'f2b',3.333,5),(355,14259,14234,'2bb',3.333,5),(355,14260,14234,'bb8',3.333,5),(355,14261,14234,'b80',3.333,5),(355,14262,14234,'80a',3.333,5),(355,14263,14234,'0a9',3.333,5),(355,14264,14234,'a9b',3.333,5),(356,14266,14265,'naa',100,5),(356,14267,14266,'600',3.333,5),(356,14268,14266,'000',3.333,5),(356,14269,14266,'00c',3.333,5),(356,14270,14266,'0c2',3.333,5),(356,14271,14266,'c29',3.333,5),(356,14272,14266,'293',3.333,5),(356,14273,14266,'93d',3.333,5),(356,14274,14266,'3d4',3.333,5),(356,14275,14266,'d49',3.333,5),(356,14276,14266,'496',3.333,5),(356,14277,14266,'96c',3.333,5),(356,14278,14266,'6c4',3.333,5),(356,14279,14266,'c4a',3.333,5),(356,14280,14266,'4a7',3.333,5),(356,14281,14266,'a7d',3.333,5),(356,14282,14266,'7d9',3.333,5),(356,14283,14266,'d9a',3.333,5),(356,14284,14266,'9a1',3.333,5),(356,14285,14266,'a1f',3.333,5),(356,14286,14266,'1f8',3.333,5),(356,14287,14266,'f8a',3.333,5),(356,14288,14266,'8af',3.333,5),(356,14289,14266,'af3',3.333,5),(356,14290,14266,'f3d',3.333,5),(356,14291,14266,'3d2',3.333,5),(356,14292,14266,'d22',3.333,5),(356,14293,14266,'22e',3.333,5),(356,14294,14266,'2ef',3.333,5),(356,14295,14266,'ef1',3.333,5),(356,14296,14266,'f12',3.333,5),(357,14298,14297,'naa',100,5),(357,14299,14298,'600',3.333,5),(357,14300,14298,'000',3.333,5),(357,14301,14298,'00c',3.333,5),(357,14302,14298,'0c2',3.333,5),(357,14303,14298,'c29',3.333,5),(357,14304,14298,'296',3.333,5),(357,14305,14298,'960',3.333,5),(357,14306,14298,'60a',3.333,5),(357,14307,14298,'0ac',3.333,5),(357,14308,14298,'acd',3.333,5),(357,14309,14298,'cd1',3.333,5),(357,14310,14298,'d1e',3.333,5),(357,14311,14298,'1e4',3.333,5),(357,14312,14298,'e40',3.333,5),(357,14313,14298,'402',3.333,5),(357,14314,14298,'028',3.333,5),(357,14315,14298,'28a',3.333,5),(357,14316,14298,'8a9',3.333,5),(357,14317,14298,'a94',3.333,5),(357,14318,14298,'94d',3.333,5),(357,14319,14298,'4d4',3.333,5),(357,14320,14298,'d47',3.333,5),(357,14321,14298,'476',3.333,5),(357,14322,14298,'76e',3.333,5),(357,14323,14298,'6ec',3.333,5),(357,14324,14298,'ecd',3.333,5),(357,14325,14298,'cdc',3.333,5),(357,14326,14298,'dc6',3.333,5),(357,14327,14298,'c66',3.333,5),(357,14328,14298,'668',3.333,5),(358,14330,14329,'naa',100,5),(358,14331,14330,'600',3.333,5),(358,14332,14330,'000',3.333,5),(358,14333,14330,'00c',3.333,5),(358,14334,14330,'0c2',3.333,5),(358,14335,14330,'c29',3.333,5),(358,14336,14330,'299',3.333,5),(358,14337,14330,'995',3.333,5),(358,14338,14330,'957',3.333,5),(358,14339,14330,'57b',3.333,5),(358,14340,14330,'7b3',3.333,5),(358,14341,14330,'b3d',3.333,5),(358,14342,14330,'3d5',3.333,5),(358,14343,14330,'d5f',3.333,5),(358,14344,14330,'5f5',3.333,5),(358,14345,14330,'f52',3.333,5),(358,14346,14330,'525',3.333,5),(358,14347,14330,'25e',3.333,5),(358,14348,14330,'5e3',3.333,5),(358,14349,14330,'e35',3.333,5),(358,14350,14330,'35e',3.333,5),(358,14351,14330,'5e7',3.333,5),(358,14352,14330,'e73',3.333,5),(358,14353,14330,'73b',3.333,5),(358,14354,14330,'3b0',3.333,5),(358,14355,14330,'b01',3.333,5),(358,14356,14330,'014',3.333,5),(358,14357,14330,'141',3.333,5),(358,14358,14330,'41a',3.333,5),(358,14359,14330,'1a8',3.333,5),(358,14360,14330,'a8e',3.333,5),(359,14362,14361,'naa',100,5),(359,14363,14362,'600',3.333,5),(359,14364,14362,'000',3.333,5),(359,14365,14362,'00c',3.333,5),(359,14366,14362,'0c2',3.333,5),(359,14367,14362,'c29',3.333,5),(359,14368,14362,'29d',3.333,5),(359,14369,14362,'9d4',3.333,5),(359,14370,14362,'d49',3.333,5),(359,14371,14362,'497',3.333,5),(359,14372,14362,'979',3.333,5),(359,14373,14362,'798',3.333,5),(359,14374,14362,'984',3.333,5),(359,14375,14362,'84f',3.333,5),(359,14376,14362,'4f4',3.333,5),(359,14377,14362,'f47',3.333,5),(359,14378,14362,'472',3.333,5),(359,14379,14362,'722',3.333,5),(359,14380,14362,'22f',3.333,5),(359,14381,14362,'2f3',3.333,5),(359,14382,14362,'f3a',3.333,5),(359,14383,14362,'3ac',3.333,5),(359,14384,14362,'ac9',3.333,5),(359,14385,14362,'c9d',3.333,5),(359,14386,14362,'9dd',3.333,5),(359,14387,14362,'dd4',3.333,5),(359,14388,14362,'d47',3.333,5),(359,14389,14362,'476',3.333,5),(359,14390,14362,'76b',3.333,5),(359,14391,14362,'6b1',3.333,5),(359,14392,14362,'b19',3.333,5),(360,14394,14393,'naa',100,5),(360,14395,14394,'600',3.333,5),(360,14396,14394,'000',3.333,5),(360,14397,14394,'00c',3.333,5),(360,14398,14394,'0c2',3.333,5),(360,14399,14394,'c29',3.333,5),(360,14400,14394,'298',3.333,5),(360,14401,14394,'98c',3.333,5),(360,14402,14394,'8c4',3.333,5),(360,14403,14394,'c48',3.333,5),(360,14404,14394,'485',3.333,5),(360,14405,14394,'851',3.333,5),(360,14406,14394,'515',3.333,5),(360,14407,14394,'15e',3.333,5),(360,14408,14394,'5e7',3.333,5),(360,14409,14394,'e76',3.333,5),(360,14410,14394,'76c',3.333,5),(360,14411,14394,'6cb',3.333,5),(360,14412,14394,'cb4',3.333,5),(360,14413,14394,'b42',3.333,5),(360,14414,14394,'427',3.333,5),(360,14415,14394,'276',3.333,5),(360,14416,14394,'76a',3.333,5),(360,14417,14394,'6ac',3.333,5),(360,14418,14394,'acf',3.333,5),(360,14419,14394,'cf0',3.333,5),(360,14420,14394,'f0d',3.333,5),(360,14421,14394,'0d2',3.333,5),(360,14422,14394,'d25',3.333,5),(360,14423,14394,'25a',3.333,5),(360,14424,14394,'5ab',3.333,5),(361,14426,14425,'naa',100,5),(361,14427,14426,'600',3.333,5),(361,14428,14426,'000',3.333,5),(361,14429,14426,'00c',3.333,5),(361,14430,14426,'0c2',3.333,5),(361,14431,14426,'c29',3.333,5),(361,14432,14426,'29c',3.333,5),(361,14433,14426,'9cb',3.333,5),(361,14434,14426,'cb5',3.333,5),(361,14435,14426,'b55',3.333,5),(361,14436,14426,'55e',3.333,5),(361,14437,14426,'5e1',3.333,5),(361,14438,14426,'e1f',3.333,5),(361,14439,14426,'1f2',3.333,5),(361,14440,14426,'f2d',3.333,5),(361,14441,14426,'2d2',3.333,5),(361,14442,14426,'d29',3.333,5),(361,14443,14426,'29a',3.333,5),(361,14444,14426,'9a6',3.333,5),(361,14445,14426,'a6e',3.333,5),(361,14446,14426,'6ef',3.333,5),(361,14447,14426,'efd',3.333,5),(361,14448,14426,'fd5',3.333,5),(361,14449,14426,'d5f',3.333,5),(361,14450,14426,'5f2',3.333,5),(361,14451,14426,'f2d',3.333,5),(361,14452,14426,'2d4',3.333,5),(361,14453,14426,'d46',3.333,5),(361,14454,14426,'468',3.333,5),(361,14455,14426,'689',3.333,5),(361,14456,14426,'898',3.333,5),(362,14458,14457,'naa',100,5),(362,14459,14458,'600',3.333,5),(362,14460,14458,'000',3.333,5),(362,14461,14458,'00c',3.333,5),(362,14462,14458,'0c2',3.333,5),(362,14463,14458,'c29',3.333,5),(362,14464,14458,'29d',3.333,5),(362,14465,14458,'9d3',3.333,5),(362,14466,14458,'d3d',3.333,5),(362,14467,14458,'3d2',3.333,5),(362,14468,14458,'d23',3.333,5),(362,14469,14458,'23a',3.333,5),(362,14470,14458,'3a1',3.333,5),(362,14471,14458,'a13',3.333,5),(362,14472,14458,'134',3.333,5),(362,14473,14458,'343',3.333,5),(362,14474,14458,'432',3.333,5),(362,14475,14458,'327',3.333,5),(362,14476,14458,'27e',3.333,5),(362,14477,14458,'7ee',3.333,5),(362,14478,14458,'ee8',3.333,5),(362,14479,14458,'e85',3.333,5),(362,14480,14458,'853',3.333,5),(362,14481,14458,'536',3.333,5),(362,14482,14458,'362',3.333,5),(362,14483,14458,'627',3.333,5),(362,14484,14458,'278',3.333,5),(362,14485,14458,'78c',3.333,5),(362,14486,14458,'8c1',3.333,5),(362,14487,14458,'c13',3.333,5),(362,14488,14458,'134',3.333,5),(363,14490,14489,'naa',100,5),(363,14491,14490,'600',3.333,5),(363,14492,14490,'000',3.333,5),(363,14493,14490,'00c',3.333,5),(363,14494,14490,'0c2',3.333,5),(363,14495,14490,'c29',3.333,5),(363,14496,14490,'294',3.333,5),(363,14497,14490,'94b',3.333,5),(363,14498,14490,'4b1',3.333,5),(363,14499,14490,'b16',3.333,5),(363,14500,14490,'160',3.333,5),(363,14501,14490,'60f',3.333,5),(363,14502,14490,'0ff',3.333,5),(363,14503,14490,'ff1',3.333,5),(363,14504,14490,'f10',3.333,5),(363,14505,14490,'10b',3.333,5),(363,14506,14490,'0b8',3.333,5),(363,14507,14490,'b82',3.333,5),(363,14508,14490,'82c',3.333,5),(363,14509,14490,'2c3',3.333,5),(363,14510,14490,'c3b',3.333,5),(363,14511,14490,'3b3',3.333,5),(363,14512,14490,'b31',3.333,5),(363,14513,14490,'316',3.333,5),(363,14514,14490,'164',3.333,5),(363,14515,14490,'645',3.333,5),(363,14516,14490,'453',3.333,5),(363,14517,14490,'532',3.333,5),(363,14518,14490,'32f',3.333,5),(363,14519,14490,'2f5',3.333,5),(363,14520,14490,'f5c',3.333,5),(364,14522,14521,'naa',100,5),(364,14523,14522,'600',3.333,5),(364,14524,14522,'000',3.333,5),(364,14525,14522,'00c',3.333,5),(364,14526,14522,'0c2',3.333,5),(364,14527,14522,'c29',3.333,5),(364,14528,14522,'297',3.333,5),(364,14529,14522,'97c',3.333,5),(364,14530,14522,'7cd',3.333,5),(364,14531,14522,'cdc',3.333,5),(364,14532,14522,'dc7',3.333,5),(364,14533,14522,'c78',3.333,5),(364,14534,14522,'780',3.333,5),(364,14535,14522,'80e',3.333,5),(364,14536,14522,'0e3',3.333,5),(364,14537,14522,'e3c',3.333,5),(364,14538,14522,'3c1',3.333,5),(364,14539,14522,'c13',3.333,5),(364,14540,14522,'13e',3.333,5),(364,14541,14522,'3ee',3.333,5),(364,14542,14522,'ee5',3.333,5),(364,14543,14522,'e56',3.333,5),(364,14544,14522,'563',3.333,5),(364,14545,14522,'63f',3.333,5),(364,14546,14522,'3f2',3.333,5),(364,14547,14522,'f29',3.333,5),(364,14548,14522,'29d',3.333,5),(364,14549,14522,'9dc',3.333,5),(364,14550,14522,'dc5',3.333,5),(364,14551,14522,'c51',3.333,5),(364,14552,14522,'515',3.333,5),(365,14554,14553,'naa',100,5),(365,14555,14554,'600',3.333,5),(365,14556,14554,'000',3.333,5),(365,14557,14554,'00c',3.333,5),(365,14558,14554,'0c2',3.333,5),(365,14559,14554,'c29',3.333,5),(365,14560,14554,'29f',3.333,5),(365,14561,14554,'9fe',3.333,5),(365,14562,14554,'fe7',3.333,5),(365,14563,14554,'e77',3.333,5),(365,14564,14554,'774',3.333,5),(365,14565,14554,'749',3.333,5),(365,14566,14554,'494',3.333,5),(365,14567,14554,'94a',3.333,5),(365,14568,14554,'4a3',3.333,5),(365,14569,14554,'a31',3.333,5),(365,14570,14554,'31a',3.333,5),(365,14571,14554,'1a5',3.333,5),(365,14572,14554,'a50',3.333,5),(365,14573,14554,'50f',3.333,5),(365,14574,14554,'0f7',3.333,5),(365,14575,14554,'f7f',3.333,5),(365,14576,14554,'7fb',3.333,5),(365,14577,14554,'fb7',3.333,5),(365,14578,14554,'b70',3.333,5),(365,14579,14554,'700',3.333,5),(365,14580,14554,'00f',3.333,5),(365,14581,14554,'0fd',3.333,5),(365,14582,14554,'fd7',3.333,5),(365,14583,14554,'d79',3.333,5),(365,14584,14554,'794',3.333,5),(366,14586,14585,'naa',100,5),(366,14587,14586,'600',3.333,5),(366,14588,14586,'000',3.333,5),(366,14589,14586,'00c',3.333,5),(366,14590,14586,'0c2',3.333,5),(366,14591,14586,'c29',3.333,5),(366,14592,14586,'296',3.333,5),(366,14593,14586,'961',3.333,5),(366,14594,14586,'61a',3.333,5),(366,14595,14586,'1aa',3.333,5),(366,14596,14586,'aac',3.333,5),(366,14597,14586,'ac2',3.333,5),(366,14598,14586,'c25',3.333,5),(366,14599,14586,'254',3.333,5),(366,14600,14586,'54c',3.333,5),(366,14601,14586,'4c5',3.333,5),(366,14602,14586,'c50',3.333,5),(366,14603,14586,'504',3.333,5),(366,14604,14586,'04c',3.333,5),(366,14605,14586,'4c6',3.333,5),(366,14606,14586,'c6d',3.333,5),(366,14607,14586,'6d6',3.333,5),(366,14608,14586,'d67',3.333,5),(366,14609,14586,'67e',3.333,5),(366,14610,14586,'7ec',3.333,5),(366,14611,14586,'ecb',3.333,5),(366,14612,14586,'cb5',3.333,5),(366,14613,14586,'b5f',3.333,5),(366,14614,14586,'5f8',3.333,5),(366,14615,14586,'f8a',3.333,5),(366,14616,14586,'8ac',3.333,5),(367,14618,14617,'naa',100,5),(367,14619,14618,'600',3.333,5),(367,14620,14618,'000',3.333,5),(367,14621,14618,'00c',3.333,5),(367,14622,14618,'0c2',3.333,5),(367,14623,14618,'c29',3.333,5),(367,14624,14618,'29e',3.333,5),(367,14625,14618,'9e2',3.333,5),(367,14626,14618,'e27',3.333,5),(367,14627,14618,'279',3.333,5),(367,14628,14618,'79d',3.333,5),(367,14629,14618,'9da',3.333,5),(367,14630,14618,'da2',3.333,5),(367,14631,14618,'a2c',3.333,5),(367,14632,14618,'2c2',3.333,5),(367,14633,14618,'c2e',3.333,5),(367,14634,14618,'2ed',3.333,5),(367,14635,14618,'ed1',3.333,5),(367,14636,14618,'d11',3.333,5),(367,14637,14618,'11b',3.333,5),(367,14638,14618,'1b7',3.333,5),(367,14639,14618,'b70',3.333,5),(367,14640,14618,'70e',3.333,5),(367,14641,14618,'0ea',3.333,5),(367,14642,14618,'ea5',3.333,5),(367,14643,14618,'a5d',3.333,5),(367,14644,14618,'5d8',3.333,5),(367,14645,14618,'d8c',3.333,5),(367,14646,14618,'8c5',3.333,5),(367,14647,14618,'c56',3.333,5),(367,14648,14618,'56a',3.333,5),(368,14650,14649,'naa',100,5),(368,14651,14650,'600',3.333,5),(368,14652,14650,'000',3.333,5),(368,14653,14650,'00c',3.333,5),(368,14654,14650,'0c2',3.333,5),(368,14655,14650,'c29',3.333,5),(368,14656,14650,'296',3.333,5),(368,14657,14650,'966',3.333,5),(368,14658,14650,'660',3.333,5),(368,14659,14650,'600',3.333,5),(368,14660,14650,'00c',3.333,5),(368,14661,14650,'0c8',3.333,5),(368,14662,14650,'c8d',3.333,5),(368,14663,14650,'8da',3.333,5),(368,14664,14650,'dae',3.333,5),(368,14665,14650,'ae9',3.333,5),(368,14666,14650,'e9d',3.333,5),(368,14667,14650,'9d7',3.333,5),(368,14668,14650,'d74',3.333,5),(368,14669,14650,'742',3.333,5),(368,14670,14650,'42e',3.333,5),(368,14671,14650,'2ee',3.333,5),(368,14672,14650,'ee0',3.333,5),(368,14673,14650,'e0c',3.333,5),(368,14674,14650,'0c1',3.333,5),(368,14675,14650,'c1b',3.333,5),(368,14676,14650,'1bd',3.333,5),(368,14677,14650,'bdc',3.333,5),(368,14678,14650,'dc4',3.333,5),(368,14679,14650,'c4e',3.333,5),(368,14680,14650,'4e9',3.333,5),(369,14682,14681,'naa',100,5),(369,14683,14682,'600',3.333,5),(369,14684,14682,'000',3.333,5),(369,14685,14682,'00c',3.333,5),(369,14686,14682,'0c2',3.333,5),(369,14687,14682,'c29',3.333,5),(369,14688,14682,'293',3.333,5),(369,14689,14682,'931',3.333,5),(369,14690,14682,'31b',3.333,5),(369,14691,14682,'1b0',3.333,5),(369,14692,14682,'b0f',3.333,5),(369,14693,14682,'0ff',3.333,5),(369,14694,14682,'ffc',3.333,5),(369,14695,14682,'fc6',3.333,5),(369,14696,14682,'c67',3.333,5),(369,14697,14682,'674',3.333,5),(369,14698,14682,'74d',3.333,5),(369,14699,14682,'4dc',3.333,5),(369,14700,14682,'dcc',3.333,5),(369,14701,14682,'cc8',3.333,5),(369,14702,14682,'c8e',3.333,5),(369,14703,14682,'8e3',3.333,5),(369,14704,14682,'e35',3.333,5),(369,14705,14682,'359',3.333,5),(369,14706,14682,'598',3.333,5),(369,14707,14682,'981',3.333,5),(369,14708,14682,'817',3.333,5),(369,14709,14682,'171',3.333,5),(369,14710,14682,'71d',3.333,5),(369,14711,14682,'1da',3.333,5),(369,14712,14682,'dad',3.333,5),(370,14714,14713,'naa',100,5),(370,14715,14714,'600',3.333,5),(370,14716,14714,'000',3.333,5),(370,14717,14714,'00c',3.333,5),(370,14718,14714,'0c2',3.333,5),(370,14719,14714,'c29',3.333,5),(370,14720,14714,'29d',3.333,5),(370,14721,14714,'9d4',3.333,5),(370,14722,14714,'d46',3.333,5),(370,14723,14714,'46d',3.333,5),(370,14724,14714,'6de',3.333,5),(370,14725,14714,'de4',3.333,5),(370,14726,14714,'e48',3.333,5),(370,14727,14714,'489',3.333,5),(370,14728,14714,'895',3.333,5),(370,14729,14714,'951',3.333,5),(370,14730,14714,'51f',3.333,5),(370,14731,14714,'1fc',3.333,5),(370,14732,14714,'fc5',3.333,5),(370,14733,14714,'c58',3.333,5),(370,14734,14714,'586',3.333,5),(370,14735,14714,'86e',3.333,5),(370,14736,14714,'6e9',3.333,5),(370,14737,14714,'e98',3.333,5),(370,14738,14714,'982',3.333,5),(370,14739,14714,'822',3.333,5),(370,14740,14714,'226',3.333,5),(370,14741,14714,'26d',3.333,5),(370,14742,14714,'6d5',3.333,5),(370,14743,14714,'d5e',3.333,5),(370,14744,14714,'5ec',3.333,5),(371,14746,14745,'naa',100,5),(371,14747,14746,'600',3.333,5),(371,14748,14746,'000',3.333,5),(371,14749,14746,'00c',3.333,5),(371,14750,14746,'0c2',3.333,5),(371,14751,14746,'c29',3.333,5),(371,14752,14746,'29e',3.333,5),(371,14753,14746,'9e3',3.333,5),(371,14754,14746,'e33',3.333,5),(371,14755,14746,'335',3.333,5),(371,14756,14746,'350',3.333,5),(371,14757,14746,'501',3.333,5),(371,14758,14746,'014',3.333,5),(371,14759,14746,'14b',3.333,5),(371,14760,14746,'4bb',3.333,5),(371,14761,14746,'bb1',3.333,5),(371,14762,14746,'b17',3.333,5),(371,14763,14746,'174',3.333,5),(371,14764,14746,'741',3.333,5),(371,14765,14746,'415',3.333,5),(371,14766,14746,'151',3.333,5),(371,14767,14746,'51c',3.333,5),(371,14768,14746,'1c6',3.333,5),(371,14769,14746,'c6f',3.333,5),(371,14770,14746,'6fe',3.333,5),(371,14771,14746,'fef',3.333,5),(371,14772,14746,'ef6',3.333,5),(371,14773,14746,'f61',3.333,5),(371,14774,14746,'619',3.333,5),(371,14775,14746,'196',3.333,5),(371,14776,14746,'968',3.333,5),(372,14778,14777,'naa',100,5),(372,14779,14778,'600',3.333,5),(372,14780,14778,'000',3.333,5),(372,14781,14778,'00c',3.333,5),(372,14782,14778,'0c2',3.333,5),(372,14783,14778,'c29',3.333,5),(372,14784,14778,'29e',3.333,5),(372,14785,14778,'9e5',3.333,5),(372,14786,14778,'e54',3.333,5),(372,14787,14778,'543',3.333,5),(372,14788,14778,'433',3.333,5),(372,14789,14778,'336',3.333,5),(372,14790,14778,'36b',3.333,5),(372,14791,14778,'6b5',3.333,5),(372,14792,14778,'b52',3.333,5),(372,14793,14778,'52a',3.333,5),(372,14794,14778,'2aa',3.333,5),(372,14795,14778,'aa7',3.333,5),(372,14796,14778,'a76',3.333,5),(372,14797,14778,'766',3.333,5),(372,14798,14778,'66c',3.333,5),(372,14799,14778,'6cc',3.333,5),(372,14800,14778,'cc0',3.333,5),(372,14801,14778,'c06',3.333,5),(372,14802,14778,'061',3.333,5),(372,14803,14778,'618',3.333,5),(372,14804,14778,'180',3.333,5),(372,14805,14778,'802',3.333,5),(372,14806,14778,'02e',3.333,5),(372,14807,14778,'2e5',3.333,5),(372,14808,14778,'e54',3.333,5),(373,14810,14809,'naa',100,5),(373,14811,14810,'600',3.333,5),(373,14812,14810,'000',3.333,5),(373,14813,14810,'00c',3.333,5),(373,14814,14810,'0c2',3.333,5),(373,14815,14810,'c29',3.333,5),(373,14816,14810,'294',3.333,5),(373,14817,14810,'945',3.333,5),(373,14818,14810,'459',3.333,5),(373,14819,14810,'59e',3.333,5),(373,14820,14810,'9e8',3.333,5),(373,14821,14810,'e8c',3.333,5),(373,14822,14810,'8c5',3.333,5),(373,14823,14810,'c5d',3.333,5),(373,14824,14810,'5d4',3.333,5),(373,14825,14810,'d43',3.333,5),(373,14826,14810,'431',3.333,5),(373,14827,14810,'31d',3.333,5),(373,14828,14810,'1d1',3.333,5),(373,14829,14810,'d18',3.333,5),(373,14830,14810,'188',3.333,5),(373,14831,14810,'887',3.333,5),(373,14832,14810,'870',3.333,5),(373,14833,14810,'70e',3.333,5),(373,14834,14810,'0e9',3.333,5),(373,14835,14810,'e9e',3.333,5),(373,14836,14810,'9eb',3.333,5),(373,14837,14810,'eba',3.333,5),(373,14838,14810,'ba0',3.333,5),(373,14839,14810,'a06',3.333,5),(373,14840,14810,'06f',3.333,5),(374,14842,14841,'naa',100,5),(374,14843,14842,'600',3.333,5),(374,14844,14842,'000',3.333,5),(374,14845,14842,'00c',3.333,5),(374,14846,14842,'0c2',3.333,5),(374,14847,14842,'c29',3.333,5),(374,14848,14842,'296',3.333,5),(374,14849,14842,'961',3.333,5),(374,14850,14842,'614',3.333,5),(374,14851,14842,'145',3.333,5),(374,14852,14842,'459',3.333,5),(374,14853,14842,'597',3.333,5),(374,14854,14842,'978',3.333,5),(374,14855,14842,'78d',3.333,5),(374,14856,14842,'8d1',3.333,5),(374,14857,14842,'d11',3.333,5),(374,14858,14842,'116',3.333,5),(374,14859,14842,'16a',3.333,5),(374,14860,14842,'6a1',3.333,5),(374,14861,14842,'a1d',3.333,5),(374,14862,14842,'1da',3.333,5),(374,14863,14842,'dad',3.333,5),(374,14864,14842,'adb',3.333,5),(374,14865,14842,'db3',3.333,5),(374,14866,14842,'b39',3.333,5),(374,14867,14842,'39c',3.333,5),(374,14868,14842,'9ca',3.333,5),(374,14869,14842,'cae',3.333,5),(374,14870,14842,'ae9',3.333,5),(374,14871,14842,'e94',3.333,5),(374,14872,14842,'949',3.333,5),(375,14874,14873,'naa',100,5),(375,14875,14874,'600',3.333,5),(375,14876,14874,'000',3.333,5),(375,14877,14874,'00c',3.333,5),(375,14878,14874,'0c2',3.333,5),(375,14879,14874,'c29',3.333,5),(375,14880,14874,'297',3.333,5),(375,14881,14874,'979',3.333,5),(375,14882,14874,'790',3.333,5),(375,14883,14874,'907',3.333,5),(375,14884,14874,'079',3.333,5),(375,14885,14874,'79a',3.333,5),(375,14886,14874,'9a8',3.333,5),(375,14887,14874,'a87',3.333,5),(375,14888,14874,'872',3.333,5),(375,14889,14874,'72b',3.333,5),(375,14890,14874,'2bc',3.333,5),(375,14891,14874,'bc7',3.333,5),(375,14892,14874,'c7b',3.333,5),(375,14893,14874,'7b0',3.333,5),(375,14894,14874,'b01',3.333,5),(375,14895,14874,'010',3.333,5),(375,14896,14874,'10e',3.333,5),(375,14897,14874,'0e0',3.333,5),(375,14898,14874,'e09',3.333,5),(375,14899,14874,'099',3.333,5),(375,14900,14874,'990',3.333,5),(375,14901,14874,'903',3.333,5),(375,14902,14874,'038',3.333,5),(375,14903,14874,'382',3.333,5),(375,14904,14874,'82e',3.333,5),(376,14906,14905,'naa',100,5),(376,14907,14906,'600',3.333,5),(376,14908,14906,'000',3.333,5),(376,14909,14906,'00c',3.333,5),(376,14910,14906,'0c2',3.333,5),(376,14911,14906,'c29',3.333,5),(376,14912,14906,'299',3.333,5),(376,14913,14906,'99a',3.333,5),(376,14914,14906,'9a4',3.333,5),(376,14915,14906,'a4e',3.333,5),(376,14916,14906,'4eb',3.333,5),(376,14917,14906,'eb2',3.333,5),(376,14918,14906,'b2d',3.333,5),(376,14919,14906,'2d1',3.333,5),(376,14920,14906,'d1a',3.333,5),(376,14921,14906,'1ab',3.333,5),(376,14922,14906,'abc',3.333,5),(376,14923,14906,'bcf',3.333,5),(376,14924,14906,'cfd',3.333,5),(376,14925,14906,'fd9',3.333,5),(376,14926,14906,'d91',3.333,5),(376,14927,14906,'916',3.333,5),(376,14928,14906,'161',3.333,5),(376,14929,14906,'611',3.333,5),(376,14930,14906,'114',3.333,5),(376,14931,14906,'14b',3.333,5),(376,14932,14906,'4b8',3.333,5),(376,14933,14906,'b89',3.333,5),(376,14934,14906,'897',3.333,5),(376,14935,14906,'97a',3.333,5),(376,14936,14906,'7a2',3.333,5),(377,14938,14937,'naa',100,5),(377,14939,14938,'600',3.333,5),(377,14940,14938,'000',3.333,5),(377,14941,14938,'00c',3.333,5),(377,14942,14938,'0c2',3.333,5),(377,14943,14938,'c29',3.333,5),(377,14944,14938,'293',3.333,5),(377,14945,14938,'932',3.333,5),(377,14946,14938,'325',3.333,5),(377,14947,14938,'253',3.333,5),(377,14948,14938,'53c',3.333,5),(377,14949,14938,'3c4',3.333,5),(377,14950,14938,'c45',3.333,5),(377,14951,14938,'456',3.333,5),(377,14952,14938,'56e',3.333,5),(377,14953,14938,'6ea',3.333,5),(377,14954,14938,'ea7',3.333,5),(377,14955,14938,'a75',3.333,5),(377,14956,14938,'75b',3.333,5),(377,14957,14938,'5b9',3.333,5),(377,14958,14938,'b96',3.333,5),(377,14959,14938,'96f',3.333,5),(377,14960,14938,'6f9',3.333,5),(377,14961,14938,'f93',3.333,5),(377,14962,14938,'934',3.333,5),(377,14963,14938,'347',3.333,5),(377,14964,14938,'473',3.333,5),(377,14965,14938,'730',3.333,5),(377,14966,14938,'30b',3.333,5),(377,14967,14938,'0b7',3.333,5),(377,14968,14938,'b77',3.333,5),(378,14970,14969,'naa',100,5),(378,14971,14970,'600',3.333,5),(378,14972,14970,'000',3.333,5),(378,14973,14970,'00c',3.333,5),(378,14974,14970,'0c2',3.333,5),(378,14975,14970,'c29',3.333,5),(378,14976,14970,'292',3.333,5),(378,14977,14970,'929',3.333,5),(378,14978,14970,'293',3.333,5),(378,14979,14970,'93d',3.333,5),(378,14980,14970,'3df',3.333,5),(378,14981,14970,'df6',3.333,5),(378,14982,14970,'f62',3.333,5),(378,14983,14970,'626',3.333,5),(378,14984,14970,'26e',3.333,5),(378,14985,14970,'6e2',3.333,5),(378,14986,14970,'e23',3.333,5),(378,14987,14970,'239',3.333,5),(378,14988,14970,'39b',3.333,5),(378,14989,14970,'9be',3.333,5),(378,14990,14970,'bea',3.333,5),(378,14991,14970,'ea9',3.333,5),(378,14992,14970,'a90',3.333,5),(378,14993,14970,'90f',3.333,5),(378,14994,14970,'0f3',3.333,5),(378,14995,14970,'f33',3.333,5),(378,14996,14970,'331',3.333,5),(378,14997,14970,'31f',3.333,5),(378,14998,14970,'1fb',3.333,5),(378,14999,14970,'fbf',3.333,5),(378,15000,14970,'bff',3.333,5),(379,15002,15001,'naa',100,5),(379,15003,15002,'600',3.333,5),(379,15004,15002,'000',3.333,5),(379,15005,15002,'00c',3.333,5),(379,15006,15002,'0c2',3.333,5),(379,15007,15002,'c29',3.333,5),(379,15008,15002,'29e',3.333,5),(379,15009,15002,'9e0',3.333,5),(379,15010,15002,'e04',3.333,5),(379,15011,15002,'046',3.333,5),(379,15012,15002,'464',3.333,5),(379,15013,15002,'64e',3.333,5),(379,15014,15002,'4e5',3.333,5),(379,15015,15002,'e56',3.333,5),(379,15016,15002,'562',3.333,5),(379,15017,15002,'62d',3.333,5),(379,15018,15002,'2dc',3.333,5),(379,15019,15002,'dcc',3.333,5),(379,15020,15002,'ccd',3.333,5),(379,15021,15002,'cd3',3.333,5),(379,15022,15002,'d37',3.333,5),(379,15023,15002,'37a',3.333,5),(379,15024,15002,'7ac',3.333,5),(379,15025,15002,'ac9',3.333,5),(379,15026,15002,'c96',3.333,5),(379,15027,15002,'96b',3.333,5),(379,15028,15002,'6b0',3.333,5),(379,15029,15002,'b0e',3.333,5),(379,15030,15002,'0e1',3.333,5),(379,15031,15002,'e1d',3.333,5),(379,15032,15002,'1dd',3.333,5),(380,15034,15033,'naa',100,5),(380,15035,15034,'600',3.333,5),(380,15036,15034,'000',3.333,5),(380,15037,15034,'00c',3.333,5),(380,15038,15034,'0c2',3.333,5),(380,15039,15034,'c29',3.333,5),(380,15040,15034,'291',3.333,5),(380,15041,15034,'916',3.333,5),(380,15042,15034,'16a',3.333,5),(380,15043,15034,'6a2',3.333,5),(380,15044,15034,'a26',3.333,5),(380,15045,15034,'269',3.333,5),(380,15046,15034,'69a',3.333,5),(380,15047,15034,'9a0',3.333,5),(380,15048,15034,'a0a',3.333,5),(380,15049,15034,'0ab',3.333,5),(380,15050,15034,'abd',3.333,5),(380,15051,15034,'bd1',3.333,5),(380,15052,15034,'d15',3.333,5),(380,15053,15034,'152',3.333,5),(380,15054,15034,'525',3.333,5),(380,15055,15034,'25c',3.333,5),(380,15056,15034,'5c1',3.333,5),(380,15057,15034,'c15',3.333,5),(380,15058,15034,'152',3.333,5),(380,15059,15034,'524',3.333,5),(380,15060,15034,'24c',3.333,5),(380,15061,15034,'4ce',3.333,5),(380,15062,15034,'ce6',3.333,5),(380,15063,15034,'e67',3.333,5),(380,15064,15034,'67c',3.333,5),(381,15066,15065,'naa',100,5),(381,15067,15066,'600',3.333,5),(381,15068,15066,'000',3.333,5),(381,15069,15066,'00c',3.333,5),(381,15070,15066,'0c2',3.333,5),(381,15071,15066,'c29',3.333,5),(381,15072,15066,'29c',3.333,5),(381,15073,15066,'9c2',3.333,5),(381,15074,15066,'c25',3.333,5),(381,15075,15066,'258',3.333,5),(381,15076,15066,'58d',3.333,5),(381,15077,15066,'8d0',3.333,5),(381,15078,15066,'d04',3.333,5),(381,15079,15066,'048',3.333,5),(381,15080,15066,'48d',3.333,5),(381,15081,15066,'8db',3.333,5),(381,15082,15066,'db9',3.333,5),(381,15083,15066,'b92',3.333,5),(381,15084,15066,'925',3.333,5),(381,15085,15066,'253',3.333,5),(381,15086,15066,'532',3.333,5),(381,15087,15066,'326',3.333,5),(381,15088,15066,'260',3.333,5),(381,15089,15066,'600',3.333,5),(381,15090,15066,'003',3.333,5),(381,15091,15066,'039',3.333,5),(381,15092,15066,'399',3.333,5),(381,15093,15066,'99c',3.333,5),(381,15094,15066,'9cc',3.333,5),(381,15095,15066,'cc4',3.333,5),(381,15096,15066,'c4f',3.333,5),(382,15098,15097,'naa',100,5),(382,15099,15098,'600',3.333,5),(382,15100,15098,'000',3.333,5),(382,15101,15098,'00c',3.333,5),(382,15102,15098,'0c2',3.333,5),(382,15103,15098,'c29',3.333,5),(382,15104,15098,'297',3.333,5),(382,15105,15098,'97b',3.333,5),(382,15106,15098,'7b7',3.333,5),(382,15107,15098,'b71',3.333,5),(382,15108,15098,'719',3.333,5),(382,15109,15098,'195',3.333,5),(382,15110,15098,'957',3.333,5),(382,15111,15098,'579',3.333,5),(382,15112,15098,'790',3.333,5),(382,15113,15098,'901',3.333,5),(382,15114,15098,'011',3.333,5),(382,15115,15098,'11f',3.333,5),(382,15116,15098,'1fa',3.333,5),(382,15117,15098,'fa5',3.333,5),(382,15118,15098,'a5a',3.333,5),(382,15119,15098,'5a7',3.333,5),(382,15120,15098,'a72',3.333,5),(382,15121,15098,'723',3.333,5),(382,15122,15098,'23f',3.333,5),(382,15123,15098,'3f8',3.333,5),(382,15124,15098,'f8e',3.333,5),(382,15125,15098,'8e0',3.333,5),(382,15126,15098,'e00',3.333,5),(382,15127,15098,'006',3.333,5),(382,15128,15098,'066',3.333,5),(383,15130,15129,'naa',100,5),(383,15131,15130,'600',3.333,5),(383,15132,15130,'000',3.333,5),(383,15133,15130,'00c',3.333,5),(383,15134,15130,'0c2',3.333,5),(383,15135,15130,'c29',3.333,5),(383,15136,15130,'29f',3.333,5),(383,15137,15130,'9fe',3.333,5),(383,15138,15130,'fe6',3.333,5),(383,15139,15130,'e6b',3.333,5),(383,15140,15130,'6b1',3.333,5),(383,15141,15130,'b17',3.333,5),(383,15142,15130,'177',3.333,5),(383,15143,15130,'775',3.333,5),(383,15144,15130,'759',3.333,5),(383,15145,15130,'596',3.333,5),(383,15146,15130,'96c',3.333,5),(383,15147,15130,'6c1',3.333,5),(383,15148,15130,'c1c',3.333,5),(383,15149,15130,'1c4',3.333,5),(383,15150,15130,'c4b',3.333,5),(383,15151,15130,'4b5',3.333,5),(383,15152,15130,'b55',3.333,5),(383,15153,15130,'553',3.333,5),(383,15154,15130,'53c',3.333,5),(383,15155,15130,'3ca',3.333,5),(383,15156,15130,'ca4',3.333,5),(383,15157,15130,'a45',3.333,5),(383,15158,15130,'45a',3.333,5),(383,15159,15130,'5a3',3.333,5),(383,15160,15130,'a3f',3.333,5),(384,15162,15161,'naa',100,5),(384,15163,15162,'600',3.333,5),(384,15164,15162,'000',3.333,5),(384,15165,15162,'00c',3.333,5),(384,15166,15162,'0c2',3.333,5),(384,15167,15162,'c29',3.333,5),(384,15168,15162,'293',3.333,5),(384,15169,15162,'93a',3.333,5),(384,15170,15162,'3a7',3.333,5),(384,15171,15162,'a79',3.333,5),(384,15172,15162,'796',3.333,5),(384,15173,15162,'965',3.333,5),(384,15174,15162,'653',3.333,5),(384,15175,15162,'53f',3.333,5),(384,15176,15162,'3f2',3.333,5),(384,15177,15162,'f23',3.333,5),(384,15178,15162,'23a',3.333,5),(384,15179,15162,'3ad',3.333,5),(384,15180,15162,'ada',3.333,5),(384,15181,15162,'dac',3.333,5),(384,15182,15162,'aca',3.333,5),(384,15183,15162,'cab',3.333,5),(384,15184,15162,'ab3',3.333,5),(384,15185,15162,'b30',3.333,5),(384,15186,15162,'302',3.333,5),(384,15187,15162,'02a',3.333,5),(384,15188,15162,'2a3',3.333,5),(384,15189,15162,'a35',3.333,5),(384,15190,15162,'35b',3.333,5),(384,15191,15162,'5b4',3.333,5),(384,15192,15162,'b4c',3.333,5),(385,15194,15193,'naa',100,5),(385,15195,15194,'600',3.333,5),(385,15196,15194,'000',3.333,5),(385,15197,15194,'00c',3.333,5),(385,15198,15194,'0c2',3.333,5),(385,15199,15194,'c29',3.333,5),(385,15200,15194,'293',3.333,5),(385,15201,15194,'938',3.333,5),(385,15202,15194,'38d',3.333,5),(385,15203,15194,'8d6',3.333,5),(385,15204,15194,'d61',3.333,5),(385,15205,15194,'61e',3.333,5),(385,15206,15194,'1e7',3.333,5),(385,15207,15194,'e77',3.333,5),(385,15208,15194,'772',3.333,5),(385,15209,15194,'72e',3.333,5),(385,15210,15194,'2e9',3.333,5),(385,15211,15194,'e92',3.333,5),(385,15212,15194,'92d',3.333,5),(385,15213,15194,'2d2',3.333,5),(385,15214,15194,'d24',3.333,5),(385,15215,15194,'242',3.333,5),(385,15216,15194,'42e',3.333,5),(385,15217,15194,'2e8',3.333,5),(385,15218,15194,'e8f',3.333,5),(385,15219,15194,'8f6',3.333,5),(385,15220,15194,'f61',3.333,5),(385,15221,15194,'616',3.333,5),(385,15222,15194,'16b',3.333,5),(385,15223,15194,'6bc',3.333,5),(385,15224,15194,'bc8',3.333,5),(386,15226,15225,'naa',100,5),(386,15227,15226,'600',3.333,5),(386,15228,15226,'000',3.333,5),(386,15229,15226,'00c',3.333,5),(386,15230,15226,'0c2',3.333,5),(386,15231,15226,'c29',3.333,5),(386,15232,15226,'295',3.333,5),(386,15233,15226,'954',3.333,5),(386,15234,15226,'547',3.333,5),(386,15235,15226,'475',3.333,5),(386,15236,15226,'75d',3.333,5),(386,15237,15226,'5d0',3.333,5),(386,15238,15226,'d09',3.333,5),(386,15239,15226,'09a',3.333,5),(386,15240,15226,'9ab',3.333,5),(386,15241,15226,'ab8',3.333,5),(386,15242,15226,'b8a',3.333,5),(386,15243,15226,'8ae',3.333,5),(386,15244,15226,'ae1',3.333,5),(386,15245,15226,'e1d',3.333,5),(386,15246,15226,'1de',3.333,5),(386,15247,15226,'de9',3.333,5),(386,15248,15226,'e90',3.333,5),(386,15249,15226,'90a',3.333,5),(386,15250,15226,'0a7',3.333,5),(386,15251,15226,'a71',3.333,5),(386,15252,15226,'71d',3.333,5),(386,15253,15226,'1de',3.333,5),(386,15254,15226,'dec',3.333,5),(386,15255,15226,'ec6',3.333,5),(386,15256,15226,'c6f',3.333,5),(387,15258,15257,'naa',100,5),(387,15259,15258,'600',3.333,5),(387,15260,15258,'000',3.333,5),(387,15261,15258,'00c',3.333,5),(387,15262,15258,'0c2',3.333,5),(387,15263,15258,'c29',3.333,5),(387,15264,15258,'294',3.333,5),(387,15265,15258,'948',3.333,5),(387,15266,15258,'48c',3.333,5),(387,15267,15258,'8ce',3.333,5),(387,15268,15258,'cee',3.333,5),(387,15269,15258,'ee8',3.333,5),(387,15270,15258,'e8e',3.333,5),(387,15271,15258,'8e3',3.333,5),(387,15272,15258,'e30',3.333,5),(387,15273,15258,'308',3.333,5),(387,15274,15258,'082',3.333,5),(387,15275,15258,'822',3.333,5),(387,15276,15258,'227',3.333,5),(387,15277,15258,'27c',3.333,5),(387,15278,15258,'7c1',3.333,5),(387,15279,15258,'c11',3.333,5),(387,15280,15258,'117',3.333,5),(387,15281,15258,'172',3.333,5),(387,15282,15258,'728',3.333,5),(387,15283,15258,'28d',3.333,5),(387,15284,15258,'8d1',3.333,5),(387,15285,15258,'d12',3.333,5),(387,15286,15258,'129',3.333,5),(387,15287,15258,'299',3.333,5),(387,15288,15258,'994',3.333,5),(388,15290,15289,'naa',100,5),(388,15291,15290,'600',3.333,5),(388,15292,15290,'000',3.333,5),(388,15293,15290,'00c',3.333,5),(388,15294,15290,'0c2',3.333,5),(388,15295,15290,'c29',3.333,5),(388,15296,15290,'291',3.333,5),(388,15297,15290,'91e',3.333,5),(388,15298,15290,'1e7',3.333,5),(388,15299,15290,'e76',3.333,5),(388,15300,15290,'766',3.333,5),(388,15301,15290,'664',3.333,5),(388,15302,15290,'64b',3.333,5),(388,15303,15290,'4b3',3.333,5),(388,15304,15290,'b34',3.333,5),(388,15305,15290,'34d',3.333,5),(388,15306,15290,'4dc',3.333,5),(388,15307,15290,'dc2',3.333,5),(388,15308,15290,'c23',3.333,5),(388,15309,15290,'236',3.333,5),(388,15310,15290,'36a',3.333,5),(388,15311,15290,'6a7',3.333,5),(388,15312,15290,'a78',3.333,5),(388,15313,15290,'785',3.333,5),(388,15314,15290,'85a',3.333,5),(388,15315,15290,'5a1',3.333,5),(388,15316,15290,'a15',3.333,5),(388,15317,15290,'15a',3.333,5),(388,15318,15290,'5a7',3.333,5),(388,15319,15290,'a71',3.333,5),(388,15320,15290,'710',3.333,5),(389,15322,15321,'naa',100,5),(389,15323,15322,'600',3.333,5),(389,15324,15322,'000',3.333,5),(389,15325,15322,'00c',3.333,5),(389,15326,15322,'0c2',3.333,5),(389,15327,15322,'c29',3.333,5),(389,15328,15322,'297',3.333,5),(389,15329,15322,'978',3.333,5),(389,15330,15322,'783',3.333,5),(389,15331,15322,'83f',3.333,5),(389,15332,15322,'3fc',3.333,5),(389,15333,15322,'fc4',3.333,5),(389,15334,15322,'c4f',3.333,5),(389,15335,15322,'4f9',3.333,5),(389,15336,15322,'f97',3.333,5),(389,15337,15322,'972',3.333,5),(389,15338,15322,'72a',3.333,5),(389,15339,15322,'2a0',3.333,5),(389,15340,15322,'a0e',3.333,5),(389,15341,15322,'0e2',3.333,5),(389,15342,15322,'e2a',3.333,5),(389,15343,15322,'2aa',3.333,5),(389,15344,15322,'aa7',3.333,5),(389,15345,15322,'a7a',3.333,5),(389,15346,15322,'7af',3.333,5),(389,15347,15322,'af5',3.333,5),(389,15348,15322,'f5c',3.333,5),(389,15349,15322,'5c9',3.333,5),(389,15350,15322,'c9e',3.333,5),(389,15351,15322,'9eb',3.333,5),(389,15352,15322,'ebc',3.333,5),(390,15354,15353,'naa',100,5),(390,15355,15354,'600',3.333,5),(390,15356,15354,'000',3.333,5),(390,15357,15354,'00c',3.333,5),(390,15358,15354,'0c2',3.333,5),(390,15359,15354,'c29',3.333,5),(390,15360,15354,'29d',3.333,5),(390,15361,15354,'9de',3.333,5),(390,15362,15354,'de2',3.333,5),(390,15363,15354,'e23',3.333,5),(390,15364,15354,'233',3.333,5),(390,15365,15354,'33a',3.333,5),(390,15366,15354,'3a6',3.333,5),(390,15367,15354,'a6c',3.333,5),(390,15368,15354,'6cb',3.333,5),(390,15369,15354,'cbb',3.333,5),(390,15370,15354,'bb6',3.333,5),(390,15371,15354,'b6e',3.333,5),(390,15372,15354,'6e5',3.333,5),(390,15373,15354,'e5b',3.333,5),(390,15374,15354,'5b7',3.333,5),(390,15375,15354,'b79',3.333,5),(390,15376,15354,'795',3.333,5),(390,15377,15354,'951',3.333,5),(390,15378,15354,'519',3.333,5),(390,15379,15354,'19e',3.333,5),(390,15380,15354,'9ee',3.333,5),(390,15381,15354,'ee3',3.333,5),(390,15382,15354,'e35',3.333,5),(390,15383,15354,'353',3.333,5),(390,15384,15354,'53a',3.333,5),(391,15386,15385,'naa',100,5),(391,15387,15386,'600',3.333,5),(391,15388,15386,'000',3.333,5),(391,15389,15386,'00c',3.333,5),(391,15390,15386,'0c2',3.333,5),(391,15391,15386,'c29',3.333,5),(391,15392,15386,'29b',3.333,5),(391,15393,15386,'9b2',3.333,5),(391,15394,15386,'b26',3.333,5),(391,15395,15386,'26a',3.333,5),(391,15396,15386,'6a3',3.333,5),(391,15397,15386,'a38',3.333,5),(391,15398,15386,'383',3.333,5),(391,15399,15386,'835',3.333,5),(391,15400,15386,'35e',3.333,5),(391,15401,15386,'5e0',3.333,5),(391,15402,15386,'e07',3.333,5),(391,15403,15386,'07a',3.333,5),(391,15404,15386,'7a5',3.333,5),(391,15405,15386,'a5d',3.333,5),(391,15406,15386,'5d3',3.333,5),(391,15407,15386,'d36',3.333,5),(391,15408,15386,'36f',3.333,5),(391,15409,15386,'6f5',3.333,5),(391,15410,15386,'f58',3.333,5),(391,15411,15386,'583',3.333,5),(391,15412,15386,'837',3.333,5),(391,15413,15386,'37b',3.333,5),(391,15414,15386,'7bb',3.333,5),(391,15415,15386,'bba',3.333,5),(391,15416,15386,'ba5',3.333,5),(392,15418,15417,'naa',100,5),(392,15419,15418,'600',3.333,5),(392,15420,15418,'000',3.333,5),(392,15421,15418,'00c',3.333,5),(392,15422,15418,'0c2',3.333,5),(392,15423,15418,'c29',3.333,5),(392,15424,15418,'29a',3.333,5),(392,15425,15418,'9a1',3.333,5),(392,15426,15418,'a1f',3.333,5),(392,15427,15418,'1f5',3.333,5),(392,15428,15418,'f5f',3.333,5),(392,15429,15418,'5f7',3.333,5),(392,15430,15418,'f7d',3.333,5),(392,15431,15418,'7d2',3.333,5),(392,15432,15418,'d26',3.333,5),(392,15433,15418,'26f',3.333,5),(392,15434,15418,'6f2',3.333,5),(392,15435,15418,'f2a',3.333,5),(392,15436,15418,'2a7',3.333,5),(392,15437,15418,'a75',3.333,5),(392,15438,15418,'75f',3.333,5),(392,15439,15418,'5fb',3.333,5),(392,15440,15418,'fb1',3.333,5),(392,15441,15418,'b16',3.333,5),(392,15442,15418,'162',3.333,5),(392,15443,15418,'621',3.333,5),(392,15444,15418,'217',3.333,5),(392,15445,15418,'17d',3.333,5),(392,15446,15418,'7d5',3.333,5),(392,15447,15418,'d54',3.333,5),(392,15448,15418,'54e',3.333,5),(393,15450,15449,'naa',100,5),(393,15451,15450,'600',3.333,5),(393,15452,15450,'000',3.333,5),(393,15453,15450,'00c',3.333,5),(393,15454,15450,'0c2',3.333,5),(393,15455,15450,'c29',3.333,5),(393,15456,15450,'292',3.333,5),(393,15457,15450,'927',3.333,5),(393,15458,15450,'277',3.333,5),(393,15459,15450,'77c',3.333,5),(393,15460,15450,'7c4',3.333,5),(393,15461,15450,'c45',3.333,5),(393,15462,15450,'458',3.333,5),(393,15463,15450,'580',3.333,5),(393,15464,15450,'809',3.333,5),(393,15465,15450,'094',3.333,5),(393,15466,15450,'946',3.333,5),(393,15467,15450,'46c',3.333,5),(393,15468,15450,'6c7',3.333,5),(393,15469,15450,'c7a',3.333,5),(393,15470,15450,'7ad',3.333,5),(393,15471,15450,'add',3.333,5),(393,15472,15450,'dda',3.333,5),(393,15473,15450,'da2',3.333,5),(393,15474,15450,'a24',3.333,5),(393,15475,15450,'249',3.333,5),(393,15476,15450,'497',3.333,5),(393,15477,15450,'978',3.333,5),(393,15478,15450,'783',3.333,5),(393,15479,15450,'83a',3.333,5),(393,15480,15450,'3a0',3.333,5),(394,15482,15481,'naa',100,5),(394,15483,15482,'600',3.333,5),(394,15484,15482,'000',3.333,5),(394,15485,15482,'00c',3.333,5),(394,15486,15482,'0c2',3.333,5),(394,15487,15482,'c29',3.333,5),(394,15488,15482,'299',3.333,5),(394,15489,15482,'998',3.333,5),(394,15490,15482,'980',3.333,5),(394,15491,15482,'80b',3.333,5),(394,15492,15482,'0b8',3.333,5),(394,15493,15482,'b86',3.333,5),(394,15494,15482,'861',3.333,5),(394,15495,15482,'614',3.333,5),(394,15496,15482,'140',3.333,5),(394,15497,15482,'40c',3.333,5),(394,15498,15482,'0cc',3.333,5),(394,15499,15482,'cc0',3.333,5),(394,15500,15482,'c05',3.333,5),(394,15501,15482,'05e',3.333,5),(394,15502,15482,'5e5',3.333,5),(394,15503,15482,'e5c',3.333,5),(394,15504,15482,'5ce',3.333,5),(394,15505,15482,'ce0',3.333,5),(394,15506,15482,'e0e',3.333,5),(394,15507,15482,'0e9',3.333,5),(394,15508,15482,'e9e',3.333,5),(394,15509,15482,'9e4',3.333,5),(394,15510,15482,'e43',3.333,5),(394,15511,15482,'43b',3.333,5),(394,15512,15482,'3b1',3.333,5),(395,15514,15513,'naa',100,5),(395,15515,15514,'600',3.333,5),(395,15516,15514,'000',3.333,5),(395,15517,15514,'00c',3.333,5),(395,15518,15514,'0c2',3.333,5),(395,15519,15514,'c29',3.333,5),(395,15520,15514,'291',3.333,5),(395,15521,15514,'918',3.333,5),(395,15522,15514,'18b',3.333,5),(395,15523,15514,'8b7',3.333,5),(395,15524,15514,'b7a',3.333,5),(395,15525,15514,'7a0',3.333,5),(395,15526,15514,'a0a',3.333,5),(395,15527,15514,'0a8',3.333,5),(395,15528,15514,'a89',3.333,5),(395,15529,15514,'89b',3.333,5),(395,15530,15514,'9bc',3.333,5),(395,15531,15514,'bc9',3.333,5),(395,15532,15514,'c9c',3.333,5),(395,15533,15514,'9c6',3.333,5),(395,15534,15514,'c6f',3.333,5),(395,15535,15514,'6ff',3.333,5),(395,15536,15514,'ffe',3.333,5),(395,15537,15514,'fe1',3.333,5),(395,15538,15514,'e16',3.333,5),(395,15539,15514,'16e',3.333,5),(395,15540,15514,'6eb',3.333,5),(395,15541,15514,'eb9',3.333,5),(395,15542,15514,'b98',3.333,5),(395,15543,15514,'987',3.333,5),(395,15544,15514,'871',3.333,5),(396,15546,15545,'naa',100,5),(396,15547,15546,'600',3.333,5),(396,15548,15546,'000',3.333,5),(396,15549,15546,'00c',3.333,5),(396,15550,15546,'0c2',3.333,5),(396,15551,15546,'c29',3.333,5),(396,15552,15546,'299',3.333,5),(396,15553,15546,'99d',3.333,5),(396,15554,15546,'9d3',3.333,5),(396,15555,15546,'d3a',3.333,5),(396,15556,15546,'3ae',3.333,5),(396,15557,15546,'ae3',3.333,5),(396,15558,15546,'e33',3.333,5),(396,15559,15546,'339',3.333,5),(396,15560,15546,'39d',3.333,5),(396,15561,15546,'9df',3.333,5),(396,15562,15546,'df8',3.333,5),(396,15563,15546,'f86',3.333,5),(396,15564,15546,'867',3.333,5),(396,15565,15546,'67c',3.333,5),(396,15566,15546,'7c0',3.333,5),(396,15567,15546,'c0d',3.333,5),(396,15568,15546,'0de',3.333,5),(396,15569,15546,'de4',3.333,5),(396,15570,15546,'e47',3.333,5),(396,15571,15546,'47a',3.333,5),(396,15572,15546,'7a2',3.333,5),(396,15573,15546,'a27',3.333,5),(396,15574,15546,'27d',3.333,5),(396,15575,15546,'7d8',3.333,5),(396,15576,15546,'d80',3.333,5),(397,15578,15577,'naa',100,5),(397,15579,15578,'600',3.333,5),(397,15580,15578,'000',3.333,5),(397,15581,15578,'00c',3.333,5),(397,15582,15578,'0c2',3.333,5),(397,15583,15578,'c29',3.333,5),(397,15584,15578,'29a',3.333,5),(397,15585,15578,'9a5',3.333,5),(397,15586,15578,'a5e',3.333,5),(397,15587,15578,'5e8',3.333,5),(397,15588,15578,'e87',3.333,5),(397,15589,15578,'879',3.333,5),(397,15590,15578,'79b',3.333,5),(397,15591,15578,'9be',3.333,5),(397,15592,15578,'be9',3.333,5),(397,15593,15578,'e9a',3.333,5),(397,15594,15578,'9ae',3.333,5),(397,15595,15578,'aef',3.333,5),(397,15596,15578,'eff',3.333,5),(397,15597,15578,'ff8',3.333,5),(397,15598,15578,'f82',3.333,5),(397,15599,15578,'82e',3.333,5),(397,15600,15578,'2ec',3.333,5),(397,15601,15578,'ec4',3.333,5),(397,15602,15578,'c40',3.333,5),(397,15603,15578,'407',3.333,5),(397,15604,15578,'073',3.333,5),(397,15605,15578,'734',3.333,5),(397,15606,15578,'348',3.333,5),(397,15607,15578,'485',3.333,5),(397,15608,15578,'85e',3.333,5),(398,15610,15609,'naa',100,5),(398,15611,15610,'600',3.333,5),(398,15612,15610,'000',3.333,5),(398,15613,15610,'00c',3.333,5),(398,15614,15610,'0c2',3.333,5),(398,15615,15610,'c29',3.333,5),(398,15616,15610,'295',3.333,5),(398,15617,15610,'950',3.333,5),(398,15618,15610,'50a',3.333,5),(398,15619,15610,'0a1',3.333,5),(398,15620,15610,'a1a',3.333,5),(398,15621,15610,'1a5',3.333,5),(398,15622,15610,'a5a',3.333,5),(398,15623,15610,'5ab',3.333,5),(398,15624,15610,'ab3',3.333,5),(398,15625,15610,'b36',3.333,5),(398,15626,15610,'366',3.333,5),(398,15627,15610,'66b',3.333,5),(398,15628,15610,'6bf',3.333,5),(398,15629,15610,'bf0',3.333,5),(398,15630,15610,'f05',3.333,5),(398,15631,15610,'05b',3.333,5),(398,15632,15610,'5b6',3.333,5),(398,15633,15610,'b66',3.333,5),(398,15634,15610,'669',3.333,5),(398,15635,15610,'692',3.333,5),(398,15636,15610,'92f',3.333,5),(398,15637,15610,'2f2',3.333,5),(398,15638,15610,'f20',3.333,5),(398,15639,15610,'207',3.333,5),(398,15640,15610,'079',3.333,5),(399,15642,15641,'naa',100,5),(399,15643,15642,'600',3.333,5),(399,15644,15642,'000',3.333,5),(399,15645,15642,'00c',3.333,5),(399,15646,15642,'0c2',3.333,5),(399,15647,15642,'c29',3.333,5),(399,15648,15642,'293',3.333,5),(399,15649,15642,'938',3.333,5),(399,15650,15642,'38b',3.333,5),(399,15651,15642,'8bb',3.333,5),(399,15652,15642,'bb4',3.333,5),(399,15653,15642,'b49',3.333,5),(399,15654,15642,'49a',3.333,5),(399,15655,15642,'9a8',3.333,5),(399,15656,15642,'a8d',3.333,5),(399,15657,15642,'8d2',3.333,5),(399,15658,15642,'d2e',3.333,5),(399,15659,15642,'2e5',3.333,5),(399,15660,15642,'e5d',3.333,5),(399,15661,15642,'5d4',3.333,5),(399,15662,15642,'d49',3.333,5),(399,15663,15642,'49b',3.333,5),(399,15664,15642,'9b4',3.333,5),(399,15665,15642,'b47',3.333,5),(399,15666,15642,'476',3.333,5),(399,15667,15642,'76c',3.333,5),(399,15668,15642,'6c9',3.333,5),(399,15669,15642,'c92',3.333,5),(399,15670,15642,'92c',3.333,5),(399,15671,15642,'2cf',3.333,5),(399,15672,15642,'cf9',3.333,5),(400,15674,15673,'naa',100,5),(400,15675,15674,'600',3.333,5),(400,15676,15674,'000',3.333,5),(400,15677,15674,'00c',3.333,5),(400,15678,15674,'0c2',3.333,5),(400,15679,15674,'c29',3.333,5),(400,15680,15674,'29b',3.333,5),(400,15681,15674,'9b2',3.333,5),(400,15682,15674,'b23',3.333,5),(400,15683,15674,'235',3.333,5),(400,15684,15674,'356',3.333,5),(400,15685,15674,'567',3.333,5),(400,15686,15674,'672',3.333,5),(400,15687,15674,'727',3.333,5),(400,15688,15674,'272',3.333,5),(400,15689,15674,'72d',3.333,5),(400,15690,15674,'2d0',3.333,5),(400,15691,15674,'d0e',3.333,5),(400,15692,15674,'0e5',3.333,5),(400,15693,15674,'e58',3.333,5),(400,15694,15674,'586',3.333,5),(400,15695,15674,'862',3.333,5),(400,15696,15674,'620',3.333,5),(400,15697,15674,'205',3.333,5),(400,15698,15674,'05d',3.333,5),(400,15699,15674,'5dc',3.333,5),(400,15700,15674,'dcc',3.333,5),(400,15701,15674,'cc3',3.333,5),(400,15702,15674,'c32',3.333,5),(400,15703,15674,'32c',3.333,5),(400,15704,15674,'2cf',3.333,5),(401,15706,15705,'naa',100,5),(401,15707,15706,'600',3.333,5),(401,15708,15706,'000',3.333,5),(401,15709,15706,'00c',3.333,5),(401,15710,15706,'0c2',3.333,5),(401,15711,15706,'c29',3.333,5),(401,15712,15706,'295',3.333,5),(401,15713,15706,'95e',3.333,5),(401,15714,15706,'5e8',3.333,5),(401,15715,15706,'e8b',3.333,5),(401,15716,15706,'8b4',3.333,5),(401,15717,15706,'b49',3.333,5),(401,15718,15706,'49c',3.333,5),(401,15719,15706,'9c5',3.333,5),(401,15720,15706,'c56',3.333,5),(401,15721,15706,'56d',3.333,5),(401,15722,15706,'6dd',3.333,5),(401,15723,15706,'dd6',3.333,5),(401,15724,15706,'d68',3.333,5),(401,15725,15706,'682',3.333,5),(401,15726,15706,'827',3.333,5),(401,15727,15706,'27f',3.333,5),(401,15728,15706,'7fe',3.333,5),(401,15729,15706,'fe4',3.333,5),(401,15730,15706,'e41',3.333,5),(401,15731,15706,'418',3.333,5),(401,15732,15706,'18e',3.333,5),(401,15733,15706,'8ea',3.333,5),(401,15734,15706,'ea7',3.333,5),(401,15735,15706,'a71',3.333,5),(401,15736,15706,'715',3.333,5),(402,15738,15737,'naa',100,5),(402,15739,15738,'600',3.333,5),(402,15740,15738,'000',3.333,5),(402,15741,15738,'00c',3.333,5),(402,15742,15738,'0c2',3.333,5),(402,15743,15738,'c29',3.333,5),(402,15744,15738,'298',3.333,5),(402,15745,15738,'981',3.333,5),(402,15746,15738,'81d',3.333,5),(402,15747,15738,'1d5',3.333,5),(402,15748,15738,'d55',3.333,5),(402,15749,15738,'553',3.333,5),(402,15750,15738,'53a',3.333,5),(402,15751,15738,'3aa',3.333,5),(402,15752,15738,'aa2',3.333,5),(402,15753,15738,'a25',3.333,5),(402,15754,15738,'25c',3.333,5),(402,15755,15738,'5cf',3.333,5),(402,15756,15738,'cfe',3.333,5),(402,15757,15738,'fef',3.333,5),(402,15758,15738,'efe',3.333,5),(402,15759,15738,'fee',3.333,5),(402,15760,15738,'eeb',3.333,5),(402,15761,15738,'eb7',3.333,5),(402,15762,15738,'b7b',3.333,5),(402,15763,15738,'7b4',3.333,5),(402,15764,15738,'b4b',3.333,5),(402,15765,15738,'4bc',3.333,5),(402,15766,15738,'bc2',3.333,5),(402,15767,15738,'c25',3.333,5),(402,15768,15738,'25e',3.333,5),(404,15782,15781,'naa',100,5),(404,15783,15782,'600',3.333,5),(404,15784,15782,'000',3.333,5),(404,15785,15782,'00c',3.333,5),(404,15786,15782,'0c2',3.333,5),(404,15787,15782,'c29',3.333,5),(404,15788,15782,'293',3.333,5),(404,15789,15782,'937',3.333,5),(404,15790,15782,'37a',3.333,5),(404,15791,15782,'7ae',3.333,5),(404,15792,15782,'aed',3.333,5),(404,15793,15782,'edb',3.333,5),(404,15794,15782,'dbf',3.333,5),(404,15795,15782,'bf2',3.333,5),(404,15796,15782,'f22',3.333,5),(404,15797,15782,'22b',3.333,5),(404,15798,15782,'2b1',3.333,5),(404,15799,15782,'b1b',3.333,5),(404,15800,15782,'1bf',3.333,5),(404,15801,15782,'bf4',3.333,5),(404,15802,15782,'f4f',3.333,5),(404,15803,15782,'4f8',3.333,5),(404,15804,15782,'f87',3.333,5),(404,15805,15782,'872',3.333,5),(404,15806,15782,'72c',3.333,5),(404,15807,15782,'2c4',3.333,5),(404,15808,15782,'c47',3.333,5),(404,15809,15782,'476',3.333,5),(404,15810,15782,'765',3.333,5),(404,15811,15782,'65d',3.333,5),(404,15812,15782,'5df',3.333,5),(405,15814,15813,'naa',100,5),(405,15815,15814,'600',3.333,5),(405,15816,15814,'00a',3.333,5),(405,15817,15814,'0a0',3.333,5),(405,15818,15814,'a09',3.333,5),(405,15819,15814,'098',3.333,5),(405,15820,15814,'980',3.333,5),(405,15821,15814,'804',3.333,5),(405,15822,15814,'044',3.333,5),(405,15823,15814,'443',3.333,5),(405,15824,15814,'430',3.333,5),(405,15825,15814,'307',3.333,5),(405,15826,15814,'072',3.333,5),(405,15827,15814,'725',3.333,5),(405,15828,15814,'259',3.333,5),(405,15829,15814,'593',3.333,5),(405,15830,15814,'931',3.333,5),(405,15831,15814,'313',3.333,5),(405,15832,15814,'13f',3.333,5),(405,15833,15814,'3f3',3.333,5),(405,15834,15814,'f33',3.333,5),(405,15835,15814,'334',3.333,5),(405,15836,15814,'345',3.333,5),(405,15837,15814,'455',3.333,5),(405,15838,15814,'556',3.333,5),(405,15839,15814,'563',3.333,5),(405,15840,15814,'639',3.333,5),(405,15841,15814,'393',3.333,5),(405,15842,15814,'934',3.333,5),(405,15843,15814,'344',3.333,5),(405,15844,15814,'443',3.333,5),(406,15846,15845,'naa',100,5),(406,15847,15846,'600',3.333,5),(406,15848,15846,'00a',3.333,5),(406,15849,15846,'0a0',3.333,5),(406,15850,15846,'a09',3.333,5),(406,15851,15846,'098',3.333,5),(406,15852,15846,'980',3.333,5),(406,15853,15846,'804',3.333,5),(406,15854,15846,'044',3.333,5),(406,15855,15846,'443',3.333,5),(406,15856,15846,'430',3.333,5),(406,15857,15846,'307',3.333,5),(406,15858,15846,'072',3.333,5),(406,15859,15846,'725',3.333,5),(406,15860,15846,'259',3.333,5),(406,15861,15846,'593',3.333,5),(406,15862,15846,'931',3.333,5),(406,15863,15846,'313',3.333,5),(406,15864,15846,'13f',3.333,5),(406,15865,15846,'3f3',3.333,5),(406,15866,15846,'f33',3.333,5),(406,15867,15846,'334',3.333,5),(406,15868,15846,'345',3.333,5),(406,15869,15846,'455',3.333,5),(406,15870,15846,'556',3.333,5),(406,15871,15846,'563',3.333,5),(406,15872,15846,'639',3.333,5),(406,15873,15846,'393',3.333,5),(406,15874,15846,'934',3.333,5),(406,15875,15846,'344',3.333,5),(406,15876,15846,'444',3.333,5),(407,15878,15877,'naa',100,5),(407,15879,15878,'600',3.333,5),(407,15880,15878,'00a',3.333,5),(407,15881,15878,'0a0',3.333,5),(407,15882,15878,'a09',3.333,5),(407,15883,15878,'098',3.333,5),(407,15884,15878,'980',3.333,5),(407,15885,15878,'804',3.333,5),(407,15886,15878,'044',3.333,5),(407,15887,15878,'443',3.333,5),(407,15888,15878,'430',3.333,5),(407,15889,15878,'307',3.333,5),(407,15890,15878,'075',3.333,5),(407,15891,15878,'753',3.333,5),(407,15892,15878,'535',3.333,5),(407,15893,15878,'357',3.333,5),(407,15894,15878,'573',3.333,5),(407,15895,15878,'732',3.333,5),(407,15896,15878,'32b',3.333,5),(407,15897,15878,'2b3',3.333,5),(407,15898,15878,'b33',3.333,5),(407,15899,15878,'334',3.333,5),(407,15900,15878,'345',3.333,5),(407,15901,15878,'457',3.333,5),(407,15902,15878,'571',3.333,5),(407,15903,15878,'715',3.333,5),(407,15904,15878,'153',3.333,5),(407,15905,15878,'533',3.333,5),(407,15906,15878,'335',3.333,5),(407,15907,15878,'357',3.333,5),(407,15908,15878,'579',3.333,5),(408,15910,15909,'naa',100,5),(408,15911,15910,'600',3.333,5),(408,15912,15910,'00a',3.333,5),(408,15913,15910,'0a0',3.333,5),(408,15914,15910,'a09',3.333,5),(408,15915,15910,'098',3.333,5),(408,15916,15910,'980',3.333,5),(408,15917,15910,'804',3.333,5),(408,15918,15910,'044',3.333,5),(408,15919,15910,'443',3.333,5),(408,15920,15910,'430',3.333,5),(408,15921,15910,'307',3.333,5),(408,15922,15910,'075',3.333,5),(408,15923,15910,'753',3.333,5),(408,15924,15910,'535',3.333,5),(408,15925,15910,'357',3.333,5),(408,15926,15910,'573',3.333,5),(408,15927,15910,'732',3.333,5),(408,15928,15910,'32b',3.333,5),(408,15929,15910,'2b3',3.333,5),(408,15930,15910,'b33',3.333,5),(408,15931,15910,'334',3.333,5),(408,15932,15910,'345',3.333,5),(408,15933,15910,'457',3.333,5),(408,15934,15910,'571',3.333,5),(408,15935,15910,'715',3.333,5),(408,15936,15910,'153',3.333,5),(408,15937,15910,'533',3.333,5),(408,15938,15910,'335',3.333,5),(408,15939,15910,'357',3.333,5),(408,15940,15910,'57a',3.333,5),(409,15942,15941,'naa',100,5),(409,15943,15942,'600',3.333,5),(409,15944,15942,'000',3.333,5),(409,15945,15942,'00c',3.333,5),(409,15946,15942,'0c2',3.333,5),(409,15947,15942,'c29',3.333,5),(409,15948,15942,'29d',3.333,5),(409,15949,15942,'9d1',3.333,5),(409,15950,15942,'d1b',3.333,5),(409,15951,15942,'1b1',3.333,5),(409,15952,15942,'b17',3.333,5),(409,15953,15942,'174',3.333,5),(409,15954,15942,'743',3.333,5),(409,15955,15942,'437',3.333,5),(409,15956,15942,'37c',3.333,5),(409,15957,15942,'7c7',3.333,5),(409,15958,15942,'c7a',3.333,5),(409,15959,15942,'7a0',3.333,5),(409,15960,15942,'a01',3.333,5),(409,15961,15942,'014',3.333,5),(409,15962,15942,'141',3.333,5),(409,15963,15942,'41d',3.333,5),(409,15964,15942,'1d3',3.333,5),(409,15965,15942,'d38',3.333,5),(409,15966,15942,'38f',3.333,5),(409,15967,15942,'8fc',3.333,5),(409,15968,15942,'fca',3.333,5),(409,15969,15942,'ca7',3.333,5),(409,15970,15942,'a7c',3.333,5),(409,15971,15942,'7c0',3.333,5),(409,15972,15942,'c0e',3.333,5),(410,15974,15973,'naa',100,5),(410,15975,15974,'600',3.333,5),(410,15976,15974,'000',3.333,5),(410,15977,15974,'00c',3.333,5),(410,15978,15974,'0c2',3.333,5),(410,15979,15974,'c29',3.333,5),(410,15980,15974,'295',3.333,5),(410,15981,15974,'959',3.333,5),(410,15982,15974,'59a',3.333,5),(410,15983,15974,'9aa',3.333,5),(410,15984,15974,'aa2',3.333,5),(410,15985,15974,'a2b',3.333,5),(410,15986,15974,'2b0',3.333,5),(410,15987,15974,'b05',3.333,5),(410,15988,15974,'054',3.333,5),(410,15989,15974,'543',3.333,5),(410,15990,15974,'435',3.333,5),(410,15991,15974,'351',3.333,5),(410,15992,15974,'51c',3.333,5),(410,15993,15974,'1c4',3.333,5),(410,15994,15974,'c42',3.333,5),(410,15995,15974,'424',3.333,5),(410,15996,15974,'24d',3.333,5),(410,15997,15974,'4d3',3.333,5),(410,15998,15974,'d30',3.333,5),(410,15999,15974,'309',3.333,5),(410,16000,15974,'096',3.333,5),(410,16001,15974,'964',3.333,5),(410,16002,15974,'64b',3.333,5),(410,16003,15974,'4b0',3.333,5),(410,16004,15974,'b08',3.333,5),(411,16006,16005,'naa',100,5),(411,16007,16006,'600',3.333,5),(411,16008,16006,'000',3.333,5),(411,16009,16006,'00c',3.333,5),(411,16010,16006,'0c2',3.333,5),(411,16011,16006,'c29',3.333,5),(411,16012,16006,'294',3.333,5),(411,16013,16006,'94f',3.333,5),(411,16014,16006,'4f1',3.333,5),(411,16015,16006,'f1c',3.333,5),(411,16016,16006,'1ce',3.333,5),(411,16017,16006,'cee',3.333,5),(411,16018,16006,'eee',3.333,5),(411,16019,16006,'eef',3.333,5),(411,16020,16006,'efa',3.333,5),(411,16021,16006,'fa4',3.333,5),(411,16022,16006,'a4a',3.333,5),(411,16023,16006,'4a2',3.333,5),(411,16024,16006,'a2b',3.333,5),(411,16025,16006,'2be',3.333,5),(411,16026,16006,'bef',3.333,5),(411,16027,16006,'eff',3.333,5),(411,16028,16006,'ff5',3.333,5),(411,16029,16006,'f5f',3.333,5),(411,16030,16006,'5f5',3.333,5),(411,16031,16006,'f55',3.333,5),(411,16032,16006,'555',3.333,5),(411,16033,16006,'558',3.333,5),(411,16034,16006,'584',3.333,5),(411,16035,16006,'84f',3.333,5),(411,16036,16006,'4fc',3.333,5),(412,16038,16037,'naa',100,5),(412,16039,16038,'600',3.333,5),(412,16040,16038,'000',3.333,5),(412,16041,16038,'00c',3.333,5),(412,16042,16038,'0c2',3.333,5),(412,16043,16038,'c29',3.333,5),(412,16044,16038,'297',3.333,5),(412,16045,16038,'976',3.333,5),(412,16046,16038,'768',3.333,5),(412,16047,16038,'683',3.333,5),(412,16048,16038,'833',3.333,5),(412,16049,16038,'334',3.333,5),(412,16050,16038,'34a',3.333,5),(412,16051,16038,'4a8',3.333,5),(412,16052,16038,'a86',3.333,5),(412,16053,16038,'860',3.333,5),(412,16054,16038,'60a',3.333,5),(412,16055,16038,'0ab',3.333,5),(412,16056,16038,'ab2',3.333,5),(412,16057,16038,'b2d',3.333,5),(412,16058,16038,'2d4',3.333,5),(412,16059,16038,'d40',3.333,5),(412,16060,16038,'408',3.333,5),(412,16061,16038,'08c',3.333,5),(412,16062,16038,'8c8',3.333,5),(412,16063,16038,'c83',3.333,5),(412,16064,16038,'832',3.333,5),(412,16065,16038,'32c',3.333,5),(412,16066,16038,'2c1',3.333,5),(412,16067,16038,'c17',3.333,5),(412,16068,16038,'177',3.333,5),(413,16070,16069,'naa',100,5),(413,16071,16070,'600',3.333,5),(413,16072,16070,'000',3.333,5),(413,16073,16070,'00c',3.333,5),(413,16074,16070,'0c2',3.333,5),(413,16075,16070,'c29',3.333,5),(413,16076,16070,'294',3.333,5),(413,16077,16070,'94d',3.333,5),(413,16078,16070,'4db',3.333,5),(413,16079,16070,'dbd',3.333,5),(413,16080,16070,'bda',3.333,5),(413,16081,16070,'da2',3.333,5),(413,16082,16070,'a2a',3.333,5),(413,16083,16070,'2a3',3.333,5),(413,16084,16070,'a3d',3.333,5),(413,16085,16070,'3d6',3.333,5),(413,16086,16070,'d6a',3.333,5),(413,16087,16070,'6a7',3.333,5),(413,16088,16070,'a78',3.333,5),(413,16089,16070,'789',3.333,5),(413,16090,16070,'892',3.333,5),(413,16091,16070,'92f',3.333,5),(413,16092,16070,'2f1',3.333,5),(413,16093,16070,'f17',3.333,5),(413,16094,16070,'173',3.333,5),(413,16095,16070,'734',3.333,5),(413,16096,16070,'34c',3.333,5),(413,16097,16070,'4c7',3.333,5),(413,16098,16070,'c71',3.333,5),(413,16099,16070,'71f',3.333,5),(413,16100,16070,'1fe',3.333,5),(414,16102,16101,'naa',100,5),(414,16103,16102,'600',3.333,5),(414,16104,16102,'000',3.333,5),(414,16105,16102,'00c',3.333,5),(414,16106,16102,'0c2',3.333,5),(414,16107,16102,'c29',3.333,5),(414,16108,16102,'292',3.333,5),(414,16109,16102,'92c',3.333,5),(414,16110,16102,'2c1',3.333,5),(414,16111,16102,'c14',3.333,5),(414,16112,16102,'148',3.333,5),(414,16113,16102,'48a',3.333,5),(414,16114,16102,'8a7',3.333,5),(414,16115,16102,'a7d',3.333,5),(414,16116,16102,'7d3',3.333,5),(414,16117,16102,'d33',3.333,5),(414,16118,16102,'33c',3.333,5),(414,16119,16102,'3c2',3.333,5),(414,16120,16102,'c25',3.333,5),(414,16121,16102,'254',3.333,5),(414,16122,16102,'540',3.333,5),(414,16123,16102,'40a',3.333,5),(414,16124,16102,'0a9',3.333,5),(414,16125,16102,'a97',3.333,5),(414,16126,16102,'976',3.333,5),(414,16127,16102,'767',3.333,5),(414,16128,16102,'67a',3.333,5),(414,16129,16102,'7aa',3.333,5),(414,16130,16102,'aa8',3.333,5),(414,16131,16102,'a82',3.333,5),(414,16132,16102,'824',3.333,5),(415,16134,16133,'naa',100,5),(415,16135,16134,'600',3.333,5),(415,16136,16134,'000',3.333,5),(415,16137,16134,'00c',3.333,5),(415,16138,16134,'0c2',3.333,5),(415,16139,16134,'c29',3.333,5),(415,16140,16134,'290',3.333,5),(415,16141,16134,'900',3.333,5),(415,16142,16134,'00b',3.333,5),(415,16143,16134,'0ba',3.333,5),(415,16144,16134,'ba3',3.333,5),(415,16145,16134,'a30',3.333,5),(415,16146,16134,'30f',3.333,5),(415,16147,16134,'0f9',3.333,5),(415,16148,16134,'f9c',3.333,5),(415,16149,16134,'9c0',3.333,5),(415,16150,16134,'c04',3.333,5),(415,16151,16134,'047',3.333,5),(415,16152,16134,'476',3.333,5),(415,16153,16134,'761',3.333,5),(415,16154,16134,'61e',3.333,5),(415,16155,16134,'1e6',3.333,5),(415,16156,16134,'e67',3.333,5),(415,16157,16134,'67e',3.333,5),(415,16158,16134,'7e7',3.333,5),(415,16159,16134,'e7b',3.333,5),(415,16160,16134,'7ba',3.333,5),(415,16161,16134,'ba6',3.333,5),(415,16162,16134,'a6c',3.333,5),(415,16163,16134,'6cc',3.333,5),(415,16164,16134,'cce',3.333,5),(416,16166,16165,'naa',100,5),(416,16167,16166,'600',3.333,5),(416,16168,16166,'000',3.333,5),(416,16169,16166,'00c',3.333,5),(416,16170,16166,'0c2',3.333,5),(416,16171,16166,'c29',3.333,5),(416,16172,16166,'290',3.333,5),(416,16173,16166,'908',3.333,5),(416,16174,16166,'083',3.333,5),(416,16175,16166,'839',3.333,5),(416,16176,16166,'395',3.333,5),(416,16177,16166,'952',3.333,5),(416,16178,16166,'52d',3.333,5),(416,16179,16166,'2de',3.333,5),(416,16180,16166,'def',3.333,5),(416,16181,16166,'ef6',3.333,5),(416,16182,16166,'f68',3.333,5),(416,16183,16166,'68e',3.333,5),(416,16184,16166,'8e3',3.333,5),(416,16185,16166,'e3e',3.333,5),(416,16186,16166,'3e9',3.333,5),(416,16187,16166,'e9f',3.333,5),(416,16188,16166,'9ff',3.333,5),(416,16189,16166,'ffd',3.333,5),(416,16190,16166,'fd1',3.333,5),(416,16191,16166,'d16',3.333,5),(416,16192,16166,'165',3.333,5),(416,16193,16166,'651',3.333,5),(416,16194,16166,'517',3.333,5),(416,16195,16166,'17b',3.333,5),(416,16196,16166,'7b9',3.333,5),(417,16198,16197,'naa',100,5),(417,16199,16198,'600',3.333,5),(417,16200,16198,'000',3.333,5),(417,16201,16198,'00c',3.333,5),(417,16202,16198,'0c2',3.333,5),(417,16203,16198,'c29',3.333,5),(417,16204,16198,'291',3.333,5),(417,16205,16198,'91d',3.333,5),(417,16206,16198,'1d7',3.333,5),(417,16207,16198,'d75',3.333,5),(417,16208,16198,'75a',3.333,5),(417,16209,16198,'5a3',3.333,5),(417,16210,16198,'a37',3.333,5),(417,16211,16198,'370',3.333,5),(417,16212,16198,'708',3.333,5),(417,16213,16198,'08a',3.333,5),(417,16214,16198,'8a8',3.333,5),(417,16215,16198,'a84',3.333,5),(417,16216,16198,'841',3.333,5),(417,16217,16198,'41e',3.333,5),(417,16218,16198,'1e1',3.333,5),(417,16219,16198,'e1e',3.333,5),(417,16220,16198,'1ee',3.333,5),(417,16221,16198,'ee0',3.333,5),(417,16222,16198,'e07',3.333,5),(417,16223,16198,'07a',3.333,5),(417,16224,16198,'7a0',3.333,5),(417,16225,16198,'a01',3.333,5),(417,16226,16198,'014',3.333,5),(417,16227,16198,'14f',3.333,5),(417,16228,16198,'4f1',3.333,5),(418,16230,16229,'naa',100,5),(418,16231,16230,'600',3.333,5),(418,16232,16230,'000',3.333,5),(418,16233,16230,'00c',3.333,5),(418,16234,16230,'0c2',3.333,5),(418,16235,16230,'c29',3.333,5),(418,16236,16230,'29d',3.333,5),(418,16237,16230,'9d4',3.333,5),(418,16238,16230,'d47',3.333,5),(418,16239,16230,'47d',3.333,5),(418,16240,16230,'7d7',3.333,5),(418,16241,16230,'d77',3.333,5),(418,16242,16230,'77c',3.333,5),(418,16243,16230,'7c0',3.333,5),(418,16244,16230,'c0c',3.333,5),(418,16245,16230,'0cd',3.333,5),(418,16246,16230,'cd2',3.333,5),(418,16247,16230,'d20',3.333,5),(418,16248,16230,'202',3.333,5),(418,16249,16230,'025',3.333,5),(418,16250,16230,'25e',3.333,5),(418,16251,16230,'5e1',3.333,5),(418,16252,16230,'e19',3.333,5),(418,16253,16230,'197',3.333,5),(418,16254,16230,'971',3.333,5),(418,16255,16230,'711',3.333,5),(418,16256,16230,'110',3.333,5),(418,16257,16230,'109',3.333,5),(418,16258,16230,'09d',3.333,5),(418,16259,16230,'9dd',3.333,5),(418,16260,16230,'dd6',3.333,5),(419,16262,16261,'naa',100,5),(419,16263,16262,'600',3.333,5),(419,16264,16262,'000',3.333,5),(419,16265,16262,'00c',3.333,5),(419,16266,16262,'0c2',3.333,5),(419,16267,16262,'c29',3.333,5),(419,16268,16262,'29d',3.333,5),(419,16269,16262,'9dd',3.333,5),(419,16270,16262,'dd0',3.333,5),(419,16271,16262,'d01',3.333,5),(419,16272,16262,'01e',3.333,5),(419,16273,16262,'1ef',3.333,5),(419,16274,16262,'ef3',3.333,5),(419,16275,16262,'f31',3.333,5),(419,16276,16262,'319',3.333,5),(419,16277,16262,'192',3.333,5),(419,16278,16262,'92b',3.333,5),(419,16279,16262,'2bf',3.333,5),(419,16280,16262,'bf1',3.333,5),(419,16281,16262,'f1f',3.333,5),(419,16282,16262,'1ff',3.333,5),(419,16283,16262,'ffa',3.333,5),(419,16284,16262,'fa1',3.333,5),(419,16285,16262,'a13',3.333,5),(419,16286,16262,'13e',3.333,5),(419,16287,16262,'3e5',3.333,5),(419,16288,16262,'e5c',3.333,5),(419,16289,16262,'5c7',3.333,5),(419,16290,16262,'c71',3.333,5),(419,16291,16262,'71a',3.333,5),(419,16292,16262,'1a2',3.333,5),(420,16294,16293,'naa',100,5),(420,16295,16294,'600',3.333,5),(420,16296,16294,'000',3.333,5),(420,16297,16294,'00c',3.333,5),(420,16298,16294,'0c2',3.333,5),(420,16299,16294,'c29',3.333,5),(420,16300,16294,'294',3.333,5),(420,16301,16294,'94c',3.333,5),(420,16302,16294,'4c7',3.333,5),(420,16303,16294,'c70',3.333,5),(420,16304,16294,'701',3.333,5),(420,16305,16294,'019',3.333,5),(420,16306,16294,'199',3.333,5),(420,16307,16294,'996',3.333,5),(420,16308,16294,'963',3.333,5),(420,16309,16294,'63f',3.333,5),(420,16310,16294,'3f0',3.333,5),(420,16311,16294,'f07',3.333,5),(420,16312,16294,'076',3.333,5),(420,16313,16294,'760',3.333,5),(420,16314,16294,'607',3.333,5),(420,16315,16294,'07c',3.333,5),(420,16316,16294,'7c8',3.333,5),(420,16317,16294,'c89',3.333,5),(420,16318,16294,'89d',3.333,5),(420,16319,16294,'9dc',3.333,5),(420,16320,16294,'dc4',3.333,5),(420,16321,16294,'c46',3.333,5),(420,16322,16294,'466',3.333,5),(420,16323,16294,'666',3.333,5),(420,16324,16294,'66a',3.333,5),(421,16326,16325,'naa',100,5),(421,16327,16326,'600',3.333,5),(421,16328,16326,'000',3.333,5),(421,16329,16326,'00c',3.333,5),(421,16330,16326,'0c2',3.333,5),(421,16331,16326,'c29',3.333,5),(421,16332,16326,'29b',3.333,5),(421,16333,16326,'9bf',3.333,5),(421,16334,16326,'bf5',3.333,5),(421,16335,16326,'f50',3.333,5),(421,16336,16326,'50a',3.333,5),(421,16337,16326,'0a0',3.333,5),(421,16338,16326,'a0e',3.333,5),(421,16339,16326,'0ed',3.333,5),(421,16340,16326,'ed8',3.333,5),(421,16341,16326,'d84',3.333,5),(421,16342,16326,'840',3.333,5),(421,16343,16326,'408',3.333,5),(421,16344,16326,'087',3.333,5),(421,16345,16326,'870',3.333,5),(421,16346,16326,'706',3.333,5),(421,16347,16326,'062',3.333,5),(421,16348,16326,'620',3.333,5),(421,16349,16326,'208',3.333,5),(421,16350,16326,'08f',3.333,5),(421,16351,16326,'8f3',3.333,5),(421,16352,16326,'f3a',3.333,5),(421,16353,16326,'3ae',3.333,5),(421,16354,16326,'ae8',3.333,5),(421,16355,16326,'e81',3.333,5),(421,16356,16326,'812',3.333,5),(422,16358,16357,'naa',100,5),(422,16359,16358,'600',3.333,5),(422,16360,16358,'000',3.333,5),(422,16361,16358,'00c',3.333,5),(422,16362,16358,'0c2',3.333,5),(422,16363,16358,'c29',3.333,5),(422,16364,16358,'29a',3.333,5),(422,16365,16358,'9a4',3.333,5),(422,16366,16358,'a43',3.333,5),(422,16367,16358,'437',3.333,5),(422,16368,16358,'374',3.333,5),(422,16369,16358,'74a',3.333,5),(422,16370,16358,'4a6',3.333,5),(422,16371,16358,'a6f',3.333,5),(422,16372,16358,'6fc',3.333,5),(422,16373,16358,'fc9',3.333,5),(422,16374,16358,'c98',3.333,5),(422,16375,16358,'984',3.333,5),(422,16376,16358,'84c',3.333,5),(422,16377,16358,'4cc',3.333,5),(422,16378,16358,'cc3',3.333,5),(422,16379,16358,'c3d',3.333,5),(422,16380,16358,'3df',3.333,5),(422,16381,16358,'df4',3.333,5),(422,16382,16358,'f42',3.333,5),(422,16383,16358,'423',3.333,5),(422,16384,16358,'23d',3.333,5),(422,16385,16358,'3d7',3.333,5),(422,16386,16358,'d78',3.333,5),(422,16387,16358,'782',3.333,5),(422,16388,16358,'826',3.333,5),(423,16390,16389,'naa',100,5),(423,16391,16390,'600',3.333,5),(423,16392,16390,'000',3.333,5),(423,16393,16390,'00c',3.333,5),(423,16394,16390,'0c2',3.333,5),(423,16395,16390,'c29',3.333,5),(423,16396,16390,'294',3.333,5),(423,16397,16390,'94d',3.333,5),(423,16398,16390,'4dd',3.333,5),(423,16399,16390,'dd9',3.333,5),(423,16400,16390,'d93',3.333,5),(423,16401,16390,'93e',3.333,5),(423,16402,16390,'3e7',3.333,5),(423,16403,16390,'e79',3.333,5),(423,16404,16390,'797',3.333,5),(423,16405,16390,'979',3.333,5),(423,16406,16390,'791',3.333,5),(423,16407,16390,'915',3.333,5),(423,16408,16390,'152',3.333,5),(423,16409,16390,'523',3.333,5),(423,16410,16390,'23a',3.333,5),(423,16411,16390,'3ad',3.333,5),(423,16412,16390,'ad9',3.333,5),(423,16413,16390,'d94',3.333,5),(423,16414,16390,'946',3.333,5),(423,16415,16390,'469',3.333,5),(423,16416,16390,'69f',3.333,5),(423,16417,16390,'9f1',3.333,5),(423,16418,16390,'f15',3.333,5),(423,16419,16390,'153',3.333,5),(423,16420,16390,'531',3.333,5),(424,16422,16421,'naa',100,5),(424,16423,16422,'600',3.333,5),(424,16424,16422,'000',3.333,5),(424,16425,16422,'00c',3.333,5),(424,16426,16422,'0c2',3.333,5),(424,16427,16422,'c29',3.333,5),(424,16428,16422,'296',3.333,5),(424,16429,16422,'967',3.333,5),(424,16430,16422,'678',3.333,5),(424,16431,16422,'784',3.333,5),(424,16432,16422,'84e',3.333,5),(424,16433,16422,'4e9',3.333,5),(424,16434,16422,'e9d',3.333,5),(424,16435,16422,'9dc',3.333,5),(424,16436,16422,'dc1',3.333,5),(424,16437,16422,'c12',3.333,5),(424,16438,16422,'125',3.333,5),(424,16439,16422,'250',3.333,5),(424,16440,16422,'50b',3.333,5),(424,16441,16422,'0b3',3.333,5),(424,16442,16422,'b32',3.333,5),(424,16443,16422,'321',3.333,5),(424,16444,16422,'216',3.333,5),(424,16445,16422,'167',3.333,5),(424,16446,16422,'678',3.333,5),(424,16447,16422,'789',3.333,5),(424,16448,16422,'896',3.333,5),(424,16449,16422,'969',3.333,5),(424,16450,16422,'698',3.333,5),(424,16451,16422,'98b',3.333,5),(424,16452,16422,'8b6',3.333,5),(425,16454,16453,'naa',100,5),(425,16455,16454,'600',3.333,5),(425,16456,16454,'000',3.333,5),(425,16457,16454,'00c',3.333,5),(425,16458,16454,'0c2',3.333,5),(425,16459,16454,'c29',3.333,5),(425,16460,16454,'296',3.333,5),(425,16461,16454,'963',3.333,5),(425,16462,16454,'630',3.333,5),(425,16463,16454,'30b',3.333,5),(425,16464,16454,'0b2',3.333,5),(425,16465,16454,'b20',3.333,5),(425,16466,16454,'208',3.333,5),(425,16467,16454,'08c',3.333,5),(425,16468,16454,'8cc',3.333,5),(425,16469,16454,'cce',3.333,5),(425,16470,16454,'cee',3.333,5),(425,16471,16454,'ee2',3.333,5),(425,16472,16454,'e2b',3.333,5),(425,16473,16454,'2b1',3.333,5),(425,16474,16454,'b19',3.333,5),(425,16475,16454,'19c',3.333,5),(425,16476,16454,'9c7',3.333,5),(425,16477,16454,'c70',3.333,5),(425,16478,16454,'705',3.333,5),(425,16479,16454,'051',3.333,5),(425,16480,16454,'51c',3.333,5),(425,16481,16454,'1c2',3.333,5),(425,16482,16454,'c21',3.333,5),(425,16483,16454,'217',3.333,5),(425,16484,16454,'179',3.333,5),(426,16486,16485,'naa',100,5),(426,16487,16486,'600',3.333,5),(426,16488,16486,'000',3.333,5),(426,16489,16486,'00c',3.333,5),(426,16490,16486,'0c2',3.333,5),(426,16491,16486,'c29',3.333,5),(426,16492,16486,'29a',3.333,5),(426,16493,16486,'9a8',3.333,5),(426,16494,16486,'a8f',3.333,5),(426,16495,16486,'8fe',3.333,5),(426,16496,16486,'feb',3.333,5),(426,16497,16486,'eb6',3.333,5),(426,16498,16486,'b68',3.333,5),(426,16499,16486,'685',3.333,5),(426,16500,16486,'850',3.333,5),(426,16501,16486,'507',3.333,5),(426,16502,16486,'079',3.333,5),(426,16503,16486,'799',3.333,5),(426,16504,16486,'998',3.333,5),(426,16505,16486,'98c',3.333,5),(426,16506,16486,'8c1',3.333,5),(426,16507,16486,'c1e',3.333,5),(426,16508,16486,'1e5',3.333,5),(426,16509,16486,'e50',3.333,5),(426,16510,16486,'500',3.333,5),(426,16511,16486,'005',3.333,5),(426,16512,16486,'05c',3.333,5),(426,16513,16486,'5c8',3.333,5),(426,16514,16486,'c8d',3.333,5),(426,16515,16486,'8d6',3.333,5),(426,16516,16486,'d6a',3.333,5),(427,16518,16517,'naa',100,5),(427,16519,16518,'600',3.333,5),(427,16520,16518,'000',3.333,5),(427,16521,16518,'00c',3.333,5),(427,16522,16518,'0c2',3.333,5),(427,16523,16518,'c29',3.333,5),(427,16524,16518,'294',3.333,5),(427,16525,16518,'942',3.333,5),(427,16526,16518,'428',3.333,5),(427,16527,16518,'28a',3.333,5),(427,16528,16518,'8a9',3.333,5),(427,16529,16518,'a92',3.333,5),(427,16530,16518,'929',3.333,5),(427,16531,16518,'292',3.333,5),(427,16532,16518,'925',3.333,5),(427,16533,16518,'259',3.333,5),(427,16534,16518,'59b',3.333,5),(427,16535,16518,'9bd',3.333,5),(427,16536,16518,'bdf',3.333,5),(427,16537,16518,'df1',3.333,5),(427,16538,16518,'f1e',3.333,5),(427,16539,16518,'1e3',3.333,5),(427,16540,16518,'e33',3.333,5),(427,16541,16518,'335',3.333,5),(427,16542,16518,'35a',3.333,5),(427,16543,16518,'5a6',3.333,5),(427,16544,16518,'a6a',3.333,5),(427,16545,16518,'6a0',3.333,5),(427,16546,16518,'a0c',3.333,5),(427,16547,16518,'0cf',3.333,5),(427,16548,16518,'cf3',3.333,5),(428,16550,16549,'naa',100,5),(428,16551,16550,'600',3.333,5),(428,16552,16550,'000',3.333,5),(428,16553,16550,'00c',3.333,5),(428,16554,16550,'0c2',3.333,5),(428,16555,16550,'c29',3.333,5),(428,16556,16550,'29f',3.333,5),(428,16557,16550,'9f5',3.333,5),(428,16558,16550,'f51',3.333,5),(428,16559,16550,'518',3.333,5),(428,16560,16550,'18a',3.333,5),(428,16561,16550,'8a6',3.333,5),(428,16562,16550,'a6b',3.333,5),(428,16563,16550,'6ba',3.333,5),(428,16564,16550,'ba4',3.333,5),(428,16565,16550,'a4c',3.333,5),(428,16566,16550,'4ce',3.333,5),(428,16567,16550,'ce7',3.333,5),(428,16568,16550,'e7d',3.333,5),(428,16569,16550,'7d3',3.333,5),(428,16570,16550,'d35',3.333,5),(428,16571,16550,'35a',3.333,5),(428,16572,16550,'5ae',3.333,5),(428,16573,16550,'ae9',3.333,5),(428,16574,16550,'e9a',3.333,5),(428,16575,16550,'9a5',3.333,5),(428,16576,16550,'a59',3.333,5),(428,16577,16550,'59d',3.333,5),(428,16578,16550,'9df',3.333,5),(428,16579,16550,'df2',3.333,5),(428,16580,16550,'f2f',3.333,5),(429,16582,16581,'naa',100,5),(429,16583,16582,'600',3.333,5),(429,16584,16582,'000',3.333,5),(429,16585,16582,'00c',3.333,5),(429,16586,16582,'0c2',3.333,5),(429,16587,16582,'c29',3.333,5),(429,16588,16582,'295',3.333,5),(429,16589,16582,'95a',3.333,5),(429,16590,16582,'5a0',3.333,5),(429,16591,16582,'a0e',3.333,5),(429,16592,16582,'0ee',3.333,5),(429,16593,16582,'eeb',3.333,5),(429,16594,16582,'eb2',3.333,5),(429,16595,16582,'b2a',3.333,5),(429,16596,16582,'2a3',3.333,5),(429,16597,16582,'a32',3.333,5),(429,16598,16582,'325',3.333,5),(429,16599,16582,'25c',3.333,5),(429,16600,16582,'5ce',3.333,5),(429,16601,16582,'ce8',3.333,5),(429,16602,16582,'e87',3.333,5),(429,16603,16582,'87c',3.333,5),(429,16604,16582,'7cb',3.333,5),(429,16605,16582,'cb2',3.333,5),(429,16606,16582,'b26',3.333,5),(429,16607,16582,'26a',3.333,5),(429,16608,16582,'6a5',3.333,5),(429,16609,16582,'a56',3.333,5),(429,16610,16582,'569',3.333,5),(429,16611,16582,'69c',3.333,5),(429,16612,16582,'9cc',3.333,5),(430,16614,16613,'naa',100,5),(430,16615,16614,'600',3.333,5),(430,16616,16614,'000',3.333,5),(430,16617,16614,'00c',3.333,5),(430,16618,16614,'0c2',3.333,5),(430,16619,16614,'c29',3.333,5),(430,16620,16614,'29f',3.333,5),(430,16621,16614,'9f0',3.333,5),(430,16622,16614,'f0e',3.333,5),(430,16623,16614,'0e1',3.333,5),(430,16624,16614,'e12',3.333,5),(430,16625,16614,'122',3.333,5),(430,16626,16614,'22c',3.333,5),(430,16627,16614,'2c0',3.333,5),(430,16628,16614,'c0c',3.333,5),(430,16629,16614,'0c6',3.333,5),(430,16630,16614,'c69',3.333,5),(430,16631,16614,'693',3.333,5),(430,16632,16614,'93e',3.333,5),(430,16633,16614,'3e1',3.333,5),(430,16634,16614,'e1a',3.333,5),(430,16635,16614,'1a1',3.333,5),(430,16636,16614,'a11',3.333,5),(430,16637,16614,'11e',3.333,5),(430,16638,16614,'1e5',3.333,5),(430,16639,16614,'e56',3.333,5),(430,16640,16614,'56d',3.333,5),(430,16641,16614,'6d3',3.333,5),(430,16642,16614,'d3b',3.333,5),(430,16643,16614,'3b5',3.333,5),(430,16644,16614,'b50',3.333,5),(431,16646,16645,'naa',100,5),(431,16647,16646,'600',3.333,5),(431,16648,16646,'000',3.333,5),(431,16649,16646,'00c',3.333,5),(431,16650,16646,'0c2',3.333,5),(431,16651,16646,'c29',3.333,5),(431,16652,16646,'296',3.333,5),(431,16653,16646,'968',3.333,5),(431,16654,16646,'68e',3.333,5),(431,16655,16646,'8e8',3.333,5),(431,16656,16646,'e87',3.333,5),(431,16657,16646,'87a',3.333,5),(431,16658,16646,'7a4',3.333,5),(431,16659,16646,'a40',3.333,5),(431,16660,16646,'405',3.333,5),(431,16661,16646,'052',3.333,5),(431,16662,16646,'52e',3.333,5),(431,16663,16646,'2ea',3.333,5),(431,16664,16646,'eae',3.333,5),(431,16665,16646,'aeb',3.333,5),(431,16666,16646,'ebe',3.333,5),(431,16667,16646,'be9',3.333,5),(431,16668,16646,'e93',3.333,5),(431,16669,16646,'934',3.333,5),(431,16670,16646,'34c',3.333,5),(431,16671,16646,'4cd',3.333,5),(431,16672,16646,'cd1',3.333,5),(431,16673,16646,'d10',3.333,5),(431,16674,16646,'108',3.333,5),(431,16675,16646,'08c',3.333,5),(431,16676,16646,'8c9',3.333,5),(432,16678,16677,'naa',100,5),(432,16679,16678,'600',3.333,5),(432,16680,16678,'000',3.333,5),(432,16681,16678,'00c',3.333,5),(432,16682,16678,'0c2',3.333,5),(432,16683,16678,'c29',3.333,5),(432,16684,16678,'29a',3.333,5),(432,16685,16678,'9ac',3.333,5),(432,16686,16678,'acd',3.333,5),(432,16687,16678,'cdc',3.333,5),(432,16688,16678,'dcf',3.333,5),(432,16689,16678,'cfc',3.333,5),(432,16690,16678,'fc3',3.333,5),(432,16691,16678,'c37',3.333,5),(432,16692,16678,'373',3.333,5),(432,16693,16678,'731',3.333,5),(432,16694,16678,'310',3.333,5),(432,16695,16678,'106',3.333,5),(432,16696,16678,'068',3.333,5),(432,16697,16678,'68d',3.333,5),(432,16698,16678,'8d1',3.333,5),(432,16699,16678,'d11',3.333,5),(432,16700,16678,'112',3.333,5),(432,16701,16678,'12b',3.333,5),(432,16702,16678,'2b9',3.333,5),(432,16703,16678,'b92',3.333,5),(432,16704,16678,'925',3.333,5),(432,16705,16678,'25c',3.333,5),(432,16706,16678,'5c1',3.333,5),(432,16707,16678,'c11',3.333,5),(432,16708,16678,'117',3.333,5),(433,16710,16709,'naa',100,5),(433,16711,16710,'600',3.333,5),(433,16712,16710,'000',3.333,5),(433,16713,16710,'00c',3.333,5),(433,16714,16710,'0c2',3.333,5),(433,16715,16710,'c29',3.333,5),(433,16716,16710,'299',3.333,5),(433,16717,16710,'992',3.333,5),(433,16718,16710,'927',3.333,5),(433,16719,16710,'273',3.333,5),(433,16720,16710,'73f',3.333,5),(433,16721,16710,'3ff',3.333,5),(433,16722,16710,'ff0',3.333,5),(433,16723,16710,'f09',3.333,5),(433,16724,16710,'095',3.333,5),(433,16725,16710,'958',3.333,5),(433,16726,16710,'587',3.333,5),(433,16727,16710,'87c',3.333,5),(433,16728,16710,'7c8',3.333,5),(433,16729,16710,'c8a',3.333,5),(433,16730,16710,'8a7',3.333,5),(433,16731,16710,'a7d',3.333,5),(433,16732,16710,'7d7',3.333,5),(433,16733,16710,'d75',3.333,5),(433,16734,16710,'753',3.333,5),(433,16735,16710,'53e',3.333,5),(433,16736,16710,'3e6',3.333,5),(433,16737,16710,'e6c',3.333,5),(433,16738,16710,'6cb',3.333,5),(433,16739,16710,'cba',3.333,5),(433,16740,16710,'bad',3.333,5),(434,16742,16741,'naa',100,5),(434,16743,16742,'600',3.333,5),(434,16744,16742,'000',3.333,5),(434,16745,16742,'00c',3.333,5),(434,16746,16742,'0c2',3.333,5),(434,16747,16742,'c29',3.333,5),(434,16748,16742,'299',3.333,5),(434,16749,16742,'99f',3.333,5),(434,16750,16742,'9fd',3.333,5),(434,16751,16742,'fd4',3.333,5),(434,16752,16742,'d49',3.333,5),(434,16753,16742,'491',3.333,5),(434,16754,16742,'914',3.333,5),(434,16755,16742,'141',3.333,5),(434,16756,16742,'414',3.333,5),(434,16757,16742,'145',3.333,5),(434,16758,16742,'45c',3.333,5),(434,16759,16742,'5c4',3.333,5),(434,16760,16742,'c44',3.333,5),(434,16761,16742,'44d',3.333,5),(434,16762,16742,'4d7',3.333,5),(434,16763,16742,'d7f',3.333,5),(434,16764,16742,'7f0',3.333,5),(434,16765,16742,'f0c',3.333,5),(434,16766,16742,'0cb',3.333,5),(434,16767,16742,'cb9',3.333,5),(434,16768,16742,'b9b',3.333,5),(434,16769,16742,'9bb',3.333,5),(434,16770,16742,'bbb',3.333,5),(434,16771,16742,'bb6',3.333,5),(434,16772,16742,'b61',3.333,5),(435,16774,16773,'naa',100,5),(435,16775,16774,'600',3.333,5),(435,16776,16774,'000',3.333,5),(435,16777,16774,'00c',3.333,5),(435,16778,16774,'0c2',3.333,5),(435,16779,16774,'c29',3.333,5),(435,16780,16774,'298',3.333,5),(435,16781,16774,'989',3.333,5),(435,16782,16774,'89e',3.333,5),(435,16783,16774,'9e0',3.333,5),(435,16784,16774,'e01',3.333,5),(435,16785,16774,'012',3.333,5),(435,16786,16774,'12f',3.333,5),(435,16787,16774,'2f7',3.333,5),(435,16788,16774,'f7d',3.333,5),(435,16789,16774,'7d7',3.333,5),(435,16790,16774,'d70',3.333,5),(435,16791,16774,'700',3.333,5),(435,16792,16774,'003',3.333,5),(435,16793,16774,'034',3.333,5),(435,16794,16774,'34f',3.333,5),(435,16795,16774,'4f5',3.333,5),(435,16796,16774,'f59',3.333,5),(435,16797,16774,'596',3.333,5),(435,16798,16774,'968',3.333,5),(435,16799,16774,'682',3.333,5),(435,16800,16774,'82d',3.333,5),(435,16801,16774,'2da',3.333,5),(435,16802,16774,'da7',3.333,5),(435,16803,16774,'a73',3.333,5),(435,16804,16774,'73f',3.333,5),(436,16806,16805,'naa',100,5),(436,16807,16806,'600',3.333,5),(436,16808,16806,'000',3.333,5),(436,16809,16806,'00c',3.333,5),(436,16810,16806,'0c2',3.333,5),(436,16811,16806,'c29',3.333,5),(436,16812,16806,'29b',3.333,5),(436,16813,16806,'9b8',3.333,5),(436,16814,16806,'b82',3.333,5),(436,16815,16806,'829',3.333,5),(436,16816,16806,'296',3.333,5),(436,16817,16806,'965',3.333,5),(436,16818,16806,'653',3.333,5),(436,16819,16806,'536',3.333,5),(436,16820,16806,'36e',3.333,5),(436,16821,16806,'6ec',3.333,5),(436,16822,16806,'ec7',3.333,5),(436,16823,16806,'c78',3.333,5),(436,16824,16806,'781',3.333,5),(436,16825,16806,'810',3.333,5),(436,16826,16806,'10e',3.333,5),(436,16827,16806,'0e7',3.333,5),(436,16828,16806,'e73',3.333,5),(436,16829,16806,'73a',3.333,5),(436,16830,16806,'3af',3.333,5),(436,16831,16806,'af9',3.333,5),(436,16832,16806,'f9e',3.333,5),(436,16833,16806,'9e6',3.333,5),(436,16834,16806,'e6c',3.333,5),(436,16835,16806,'6c3',3.333,5),(436,16836,16806,'c3a',3.333,5),(437,16838,16837,'naa',100,5),(437,16839,16838,'600',3.333,5),(437,16840,16838,'000',3.333,5),(437,16841,16838,'00c',3.333,5),(437,16842,16838,'0c2',3.333,5),(437,16843,16838,'c29',3.333,5),(437,16844,16838,'294',3.333,5),(437,16845,16838,'94b',3.333,5),(437,16846,16838,'4bb',3.333,5),(437,16847,16838,'bb4',3.333,5),(437,16848,16838,'b43',3.333,5),(437,16849,16838,'435',3.333,5),(437,16850,16838,'353',3.333,5),(437,16851,16838,'532',3.333,5),(437,16852,16838,'32c',3.333,5),(437,16853,16838,'2c8',3.333,5),(437,16854,16838,'c86',3.333,5),(437,16855,16838,'863',3.333,5),(437,16856,16838,'63a',3.333,5),(437,16857,16838,'3ae',3.333,5),(437,16858,16838,'aee',3.333,5),(437,16859,16838,'ee4',3.333,5),(437,16860,16838,'e47',3.333,5),(437,16861,16838,'47b',3.333,5),(437,16862,16838,'7b5',3.333,5),(437,16863,16838,'b5f',3.333,5),(437,16864,16838,'5f5',3.333,5),(437,16865,16838,'f50',3.333,5),(437,16866,16838,'504',3.333,5),(437,16867,16838,'049',3.333,5),(437,16868,16838,'49f',3.333,5),(438,16870,16869,'naa',100,5),(438,16871,16870,'600',3.333,5),(438,16872,16870,'000',3.333,5),(438,16873,16870,'00c',3.333,5),(438,16874,16870,'0c2',3.333,5),(438,16875,16870,'c29',3.333,5),(438,16876,16870,'29f',3.333,5),(438,16877,16870,'9f1',3.333,5),(438,16878,16870,'f15',3.333,5),(438,16879,16870,'155',3.333,5),(438,16880,16870,'55e',3.333,5),(438,16881,16870,'5ed',3.333,5),(438,16882,16870,'edb',3.333,5),(438,16883,16870,'dba',3.333,5),(438,16884,16870,'ba6',3.333,5),(438,16885,16870,'a69',3.333,5),(438,16886,16870,'699',3.333,5),(438,16887,16870,'99a',3.333,5),(438,16888,16870,'9af',3.333,5),(438,16889,16870,'afe',3.333,5),(438,16890,16870,'fe8',3.333,5),(438,16891,16870,'e8c',3.333,5),(438,16892,16870,'8c5',3.333,5),(438,16893,16870,'c5a',3.333,5),(438,16894,16870,'5ae',3.333,5),(438,16895,16870,'ae9',3.333,5),(438,16896,16870,'e93',3.333,5),(438,16897,16870,'930',3.333,5),(438,16898,16870,'301',3.333,5),(438,16899,16870,'014',3.333,5),(438,16900,16870,'141',3.333,5),(439,16902,16901,'naa',100,5),(439,16903,16902,'600',3.333,5),(439,16904,16902,'000',3.333,5),(439,16905,16902,'00c',3.333,5),(439,16906,16902,'0c2',3.333,5),(439,16907,16902,'c29',3.333,5),(439,16908,16902,'296',3.333,5),(439,16909,16902,'96c',3.333,5),(439,16910,16902,'6cc',3.333,5),(439,16911,16902,'ccd',3.333,5),(439,16912,16902,'cde',3.333,5),(439,16913,16902,'deb',3.333,5),(439,16914,16902,'eb9',3.333,5),(439,16915,16902,'b94',3.333,5),(439,16916,16902,'945',3.333,5),(439,16917,16902,'458',3.333,5),(439,16918,16902,'58e',3.333,5),(439,16919,16902,'8e6',3.333,5),(439,16920,16902,'e68',3.333,5),(439,16921,16902,'68e',3.333,5),(439,16922,16902,'8e3',3.333,5),(439,16923,16902,'e33',3.333,5),(439,16924,16902,'338',3.333,5),(439,16925,16902,'38f',3.333,5),(439,16926,16902,'8f3',3.333,5),(439,16927,16902,'f3c',3.333,5),(439,16928,16902,'3cd',3.333,5),(439,16929,16902,'cd6',3.333,5),(439,16930,16902,'d6a',3.333,5),(439,16931,16902,'6a8',3.333,5),(439,16932,16902,'a82',3.333,5),(440,16934,16933,'naa',100,5),(440,16935,16934,'600',3.333,5),(440,16936,16934,'000',3.333,5),(440,16937,16934,'00c',3.333,5),(440,16938,16934,'0c2',3.333,5),(440,16939,16934,'c29',3.333,5),(440,16940,16934,'29f',3.333,5),(440,16941,16934,'9fb',3.333,5),(440,16942,16934,'fb5',3.333,5),(440,16943,16934,'b54',3.333,5),(440,16944,16934,'547',3.333,5),(440,16945,16934,'474',3.333,5),(440,16946,16934,'74c',3.333,5),(440,16947,16934,'4c2',3.333,5),(440,16948,16934,'c24',3.333,5),(440,16949,16934,'246',3.333,5),(440,16950,16934,'46b',3.333,5),(440,16951,16934,'6b5',3.333,5),(440,16952,16934,'b50',3.333,5),(440,16953,16934,'501',3.333,5),(440,16954,16934,'01f',3.333,5),(440,16955,16934,'1f6',3.333,5),(440,16956,16934,'f64',3.333,5),(440,16957,16934,'641',3.333,5),(440,16958,16934,'412',3.333,5),(440,16959,16934,'126',3.333,5),(440,16960,16934,'260',3.333,5),(440,16961,16934,'606',3.333,5),(440,16962,16934,'061',3.333,5),(440,16963,16934,'617',3.333,5),(440,16964,16934,'177',3.333,5),(441,16966,16965,'naa',100,5),(441,16967,16966,'600',3.333,5),(441,16968,16966,'000',3.333,5),(441,16969,16966,'00c',3.333,5),(441,16970,16966,'0c2',3.333,5),(441,16971,16966,'c29',3.333,5),(441,16972,16966,'29e',3.333,5),(441,16973,16966,'9e9',3.333,5),(441,16974,16966,'e90',3.333,5),(441,16975,16966,'902',3.333,5),(441,16976,16966,'026',3.333,5),(441,16977,16966,'267',3.333,5),(441,16978,16966,'67a',3.333,5),(441,16979,16966,'7af',3.333,5),(441,16980,16966,'af7',3.333,5),(441,16981,16966,'f74',3.333,5),(441,16982,16966,'746',3.333,5),(441,16983,16966,'461',3.333,5),(441,16984,16966,'612',3.333,5),(441,16985,16966,'12b',3.333,5),(441,16986,16966,'2bf',3.333,5),(441,16987,16966,'bf0',3.333,5),(441,16988,16966,'f02',3.333,5),(441,16989,16966,'02c',3.333,5),(441,16990,16966,'2c8',3.333,5),(441,16991,16966,'c86',3.333,5),(441,16992,16966,'867',3.333,5),(441,16993,16966,'67a',3.333,5),(441,16994,16966,'7a8',3.333,5),(441,16995,16966,'a8a',3.333,5),(441,16996,16966,'8a9',3.333,5),(442,16998,16997,'naa',100,5),(442,16999,16998,'600',3.333,5),(442,17000,16998,'000',3.333,5),(442,17001,16998,'00c',3.333,5),(442,17002,16998,'0c2',3.333,5),(442,17003,16998,'c29',3.333,5),(442,17004,16998,'29b',3.333,5),(442,17005,16998,'9bf',3.333,5),(442,17006,16998,'bf7',3.333,5),(442,17007,16998,'f70',3.333,5),(442,17008,16998,'708',3.333,5),(442,17009,16998,'087',3.333,5),(442,17010,16998,'877',3.333,5),(442,17011,16998,'777',3.333,5),(442,17012,16998,'777',3.333,5),(442,17013,16998,'77c',3.333,5),(442,17014,16998,'7c6',3.333,5),(442,17015,16998,'c6b',3.333,5),(442,17016,16998,'6b1',3.333,5),(442,17017,16998,'b1a',3.333,5),(442,17018,16998,'1a0',3.333,5),(442,17019,16998,'a06',3.333,5),(442,17020,16998,'06a',3.333,5),(442,17021,16998,'6aa',3.333,5),(442,17022,16998,'aa3',3.333,5),(442,17023,16998,'a36',3.333,5),(442,17024,16998,'36a',3.333,5),(442,17025,16998,'6aa',3.333,5),(442,17026,16998,'aa0',3.333,5),(442,17027,16998,'a01',3.333,5),(442,17028,16998,'01b',3.333,5),(443,17030,17029,'naa',100,5),(443,17031,17030,'600',3.333,5),(443,17032,17030,'000',3.333,5),(443,17033,17030,'00c',3.333,5),(443,17034,17030,'0c2',3.333,5),(443,17035,17030,'c29',3.333,5),(443,17036,17030,'296',3.333,5),(443,17037,17030,'96d',3.333,5),(443,17038,17030,'6d6',3.333,5),(443,17039,17030,'d61',3.333,5),(443,17040,17030,'616',3.333,5),(443,17041,17030,'16c',3.333,5),(443,17042,17030,'6c2',3.333,5),(443,17043,17030,'c27',3.333,5),(443,17044,17030,'278',3.333,5),(443,17045,17030,'780',3.333,5),(443,17046,17030,'808',3.333,5),(443,17047,17030,'083',3.333,5),(443,17048,17030,'83d',3.333,5),(443,17049,17030,'3d4',3.333,5),(443,17050,17030,'d43',3.333,5),(443,17051,17030,'439',3.333,5),(443,17052,17030,'392',3.333,5),(443,17053,17030,'923',3.333,5),(443,17054,17030,'231',3.333,5),(443,17055,17030,'319',3.333,5),(443,17056,17030,'197',3.333,5),(443,17057,17030,'976',3.333,5),(443,17058,17030,'761',3.333,5),(443,17059,17030,'613',3.333,5),(443,17060,17030,'13d',3.333,5),(444,17062,17061,'naa',100,5),(444,17063,17062,'600',3.333,5),(444,17064,17062,'000',3.333,5),(444,17065,17062,'00c',3.333,5),(444,17066,17062,'0c2',3.333,5),(444,17067,17062,'c29',3.333,5),(444,17068,17062,'292',3.333,5),(444,17069,17062,'92e',3.333,5),(444,17070,17062,'2e5',3.333,5),(444,17071,17062,'e52',3.333,5),(444,17072,17062,'526',3.333,5),(444,17073,17062,'269',3.333,5),(444,17074,17062,'69f',3.333,5),(444,17075,17062,'9fc',3.333,5),(444,17076,17062,'fcf',3.333,5),(444,17077,17062,'cf7',3.333,5),(444,17078,17062,'f7b',3.333,5),(444,17079,17062,'7b9',3.333,5),(444,17080,17062,'b9a',3.333,5),(444,17081,17062,'9ac',3.333,5),(444,17082,17062,'ac9',3.333,5),(444,17083,17062,'c98',3.333,5),(444,17084,17062,'98f',3.333,5),(444,17085,17062,'8f5',3.333,5),(444,17086,17062,'f5a',3.333,5),(444,17087,17062,'5a5',3.333,5),(444,17088,17062,'a58',3.333,5),(444,17089,17062,'58d',3.333,5),(444,17090,17062,'8d9',3.333,5),(444,17091,17062,'d98',3.333,5),(444,17092,17062,'98d',3.333,5),(445,17094,17093,'naa',100,5),(445,17095,17094,'600',3.333,5),(445,17096,17094,'000',3.333,5),(445,17097,17094,'00c',3.333,5),(445,17098,17094,'0c2',3.333,5),(445,17099,17094,'c29',3.333,5),(445,17100,17094,'294',3.333,5),(445,17101,17094,'948',3.333,5),(445,17102,17094,'487',3.333,5),(445,17103,17094,'87a',3.333,5),(445,17104,17094,'7a8',3.333,5),(445,17105,17094,'a81',3.333,5),(445,17106,17094,'818',3.333,5),(445,17107,17094,'181',3.333,5),(445,17108,17094,'812',3.333,5),(445,17109,17094,'12d',3.333,5),(445,17110,17094,'2d7',3.333,5),(445,17111,17094,'d7f',3.333,5),(445,17112,17094,'7fc',3.333,5),(445,17113,17094,'fcd',3.333,5),(445,17114,17094,'cd4',3.333,5),(445,17115,17094,'d47',3.333,5),(445,17116,17094,'470',3.333,5),(445,17117,17094,'70b',3.333,5),(445,17118,17094,'0b1',3.333,5),(445,17119,17094,'b1f',3.333,5),(445,17120,17094,'1f0',3.333,5),(445,17121,17094,'f05',3.333,5),(445,17122,17094,'05b',3.333,5),(445,17123,17094,'5b9',3.333,5),(445,17124,17094,'b92',3.333,5),(446,17126,17125,'naa',100,5),(446,17127,17126,'600',3.333,5),(446,17128,17126,'000',3.333,5),(446,17129,17126,'00c',3.333,5),(446,17130,17126,'0c2',3.333,5),(446,17131,17126,'c29',3.333,5),(446,17132,17126,'29b',3.333,5),(446,17133,17126,'9bf',3.333,5),(446,17134,17126,'bf6',3.333,5),(446,17135,17126,'f6e',3.333,5),(446,17136,17126,'6e0',3.333,5),(446,17137,17126,'e0f',3.333,5),(446,17138,17126,'0f4',3.333,5),(446,17139,17126,'f4f',3.333,5),(446,17140,17126,'4fe',3.333,5),(446,17141,17126,'fed',3.333,5),(446,17142,17126,'edb',3.333,5),(446,17143,17126,'dbe',3.333,5),(446,17144,17126,'be7',3.333,5),(446,17145,17126,'e7d',3.333,5),(446,17146,17126,'7da',3.333,5),(446,17147,17126,'daf',3.333,5),(446,17148,17126,'af1',3.333,5),(446,17149,17126,'f1e',3.333,5),(446,17150,17126,'1e1',3.333,5),(446,17151,17126,'e17',3.333,5),(446,17152,17126,'175',3.333,5),(446,17153,17126,'752',3.333,5),(446,17154,17126,'528',3.333,5),(446,17155,17126,'285',3.333,5),(446,17156,17126,'859',3.333,5),(447,17158,17157,'naa',100,5),(447,17159,17158,'600',3.333,5),(447,17160,17158,'000',3.333,5),(447,17161,17158,'00c',3.333,5),(447,17162,17158,'0c2',3.333,5),(447,17163,17158,'c29',3.333,5),(447,17164,17158,'29e',3.333,5),(447,17165,17158,'9e7',3.333,5),(447,17166,17158,'e72',3.333,5),(447,17167,17158,'72b',3.333,5),(447,17168,17158,'2b2',3.333,5),(447,17169,17158,'b20',3.333,5),(447,17170,17158,'201',3.333,5),(447,17171,17158,'01a',3.333,5),(447,17172,17158,'1ae',3.333,5),(447,17173,17158,'aed',3.333,5),(447,17174,17158,'edf',3.333,5),(447,17175,17158,'dfc',3.333,5),(447,17176,17158,'fc8',3.333,5),(447,17177,17158,'c8a',3.333,5),(447,17178,17158,'8a9',3.333,5),(447,17179,17158,'a95',3.333,5),(447,17180,17158,'958',3.333,5),(447,17181,17158,'589',3.333,5),(447,17182,17158,'897',3.333,5),(447,17183,17158,'975',3.333,5),(447,17184,17158,'75f',3.333,5),(447,17185,17158,'5f2',3.333,5),(447,17186,17158,'f29',3.333,5),(447,17187,17158,'29c',3.333,5),(447,17188,17158,'9c5',3.333,5),(448,17190,17189,'naa',100,5),(448,17191,17190,'600',3.333,5),(448,17192,17190,'000',3.333,5),(448,17193,17190,'00c',3.333,5),(448,17194,17190,'0c2',3.333,5),(448,17195,17190,'c29',3.333,5),(448,17196,17190,'298',3.333,5),(448,17197,17190,'98b',3.333,5),(448,17198,17190,'8ba',3.333,5),(448,17199,17190,'bad',3.333,5),(448,17200,17190,'add',3.333,5),(448,17201,17190,'dd9',3.333,5),(448,17202,17190,'d99',3.333,5),(448,17203,17190,'992',3.333,5),(448,17204,17190,'92c',3.333,5),(448,17205,17190,'2c7',3.333,5),(448,17206,17190,'c7d',3.333,5),(448,17207,17190,'7df',3.333,5),(448,17208,17190,'dfa',3.333,5),(448,17209,17190,'fa3',3.333,5),(448,17210,17190,'a3d',3.333,5),(448,17211,17190,'3d3',3.333,5),(448,17212,17190,'d31',3.333,5),(448,17213,17190,'313',3.333,5),(448,17214,17190,'13a',3.333,5),(448,17215,17190,'3aa',3.333,5),(448,17216,17190,'aaf',3.333,5),(448,17217,17190,'af4',3.333,5),(448,17218,17190,'f43',3.333,5),(448,17219,17190,'430',3.333,5),(448,17220,17190,'308',3.333,5),(449,17222,17221,'naa',100,5),(449,17223,17222,'600',3.333,5),(449,17224,17222,'000',3.333,5),(449,17225,17222,'00c',3.333,5),(449,17226,17222,'0c2',3.333,5),(449,17227,17222,'c29',3.333,5),(449,17228,17222,'29a',3.333,5),(449,17229,17222,'9a5',3.333,5),(449,17230,17222,'a55',3.333,5),(449,17231,17222,'551',3.333,5),(449,17232,17222,'514',3.333,5),(449,17233,17222,'144',3.333,5),(449,17234,17222,'44d',3.333,5),(449,17235,17222,'4da',3.333,5),(449,17236,17222,'da0',3.333,5),(449,17237,17222,'a0c',3.333,5),(449,17238,17222,'0ca',3.333,5),(449,17239,17222,'ca5',3.333,5),(449,17240,17222,'a59',3.333,5),(449,17241,17222,'59b',3.333,5),(449,17242,17222,'9bf',3.333,5),(449,17243,17222,'bf6',3.333,5),(449,17244,17222,'f68',3.333,5),(449,17245,17222,'685',3.333,5),(449,17246,17222,'854',3.333,5),(449,17247,17222,'548',3.333,5),(449,17248,17222,'487',3.333,5),(449,17249,17222,'874',3.333,5),(449,17250,17222,'743',3.333,5),(449,17251,17222,'43f',3.333,5),(449,17252,17222,'3f1',3.333,5),(450,17254,17253,'naa',100,5),(450,17255,17254,'600',3.333,5),(450,17256,17254,'000',3.333,5),(450,17257,17254,'00c',3.333,5),(450,17258,17254,'0c2',3.333,5),(450,17259,17254,'c29',3.333,5),(450,17260,17254,'292',3.333,5),(450,17261,17254,'92d',3.333,5),(450,17262,17254,'2d1',3.333,5),(450,17263,17254,'d1e',3.333,5),(450,17264,17254,'1e0',3.333,5),(450,17265,17254,'e0b',3.333,5),(450,17266,17254,'0ba',3.333,5),(450,17267,17254,'ba3',3.333,5),(450,17268,17254,'a34',3.333,5),(450,17269,17254,'34f',3.333,5),(450,17270,17254,'4fc',3.333,5),(450,17271,17254,'fcd',3.333,5),(450,17272,17254,'cd6',3.333,5),(450,17273,17254,'d69',3.333,5),(450,17274,17254,'69f',3.333,5),(450,17275,17254,'9f4',3.333,5),(450,17276,17254,'f4a',3.333,5),(450,17277,17254,'4a7',3.333,5),(450,17278,17254,'a7d',3.333,5),(450,17279,17254,'7dd',3.333,5),(450,17280,17254,'ddb',3.333,5),(450,17281,17254,'db7',3.333,5),(450,17282,17254,'b79',3.333,5),(450,17283,17254,'796',3.333,5),(450,17284,17254,'966',3.333,5),(451,17286,17285,'naa',100,5),(451,17287,17286,'600',3.333,5),(451,17288,17286,'000',3.333,5),(451,17289,17286,'00c',3.333,5),(451,17290,17286,'0c2',3.333,5),(451,17291,17286,'c29',3.333,5),(451,17292,17286,'292',3.333,5),(451,17293,17286,'92b',3.333,5),(451,17294,17286,'2b3',3.333,5),(451,17295,17286,'b38',3.333,5),(451,17296,17286,'387',3.333,5),(451,17297,17286,'871',3.333,5),(451,17298,17286,'715',3.333,5),(451,17299,17286,'15a',3.333,5),(451,17300,17286,'5a4',3.333,5),(451,17301,17286,'a4b',3.333,5),(451,17302,17286,'4bf',3.333,5),(451,17303,17286,'bf5',3.333,5),(451,17304,17286,'f5d',3.333,5),(451,17305,17286,'5db',3.333,5),(451,17306,17286,'db1',3.333,5),(451,17307,17286,'b11',3.333,5),(451,17308,17286,'11a',3.333,5),(451,17309,17286,'1a0',3.333,5),(451,17310,17286,'a06',3.333,5),(451,17311,17286,'06a',3.333,5),(451,17312,17286,'6a6',3.333,5),(451,17313,17286,'a63',3.333,5),(451,17314,17286,'63e',3.333,5),(451,17315,17286,'3e3',3.333,5),(451,17316,17286,'e31',3.333,5),(452,17318,17317,'naa',100,5),(452,17319,17318,'600',3.333,5),(452,17320,17318,'000',3.333,5),(452,17321,17318,'00c',3.333,5),(452,17322,17318,'0c2',3.333,5),(452,17323,17318,'c29',3.333,5),(452,17324,17318,'297',3.333,5),(452,17325,17318,'972',3.333,5),(452,17326,17318,'72f',3.333,5),(452,17327,17318,'2f5',3.333,5),(452,17328,17318,'f5e',3.333,5),(452,17329,17318,'5eb',3.333,5),(452,17330,17318,'eb0',3.333,5),(452,17331,17318,'b0f',3.333,5),(452,17332,17318,'0f1',3.333,5),(452,17333,17318,'f1a',3.333,5),(452,17334,17318,'1ac',3.333,5),(452,17335,17318,'aca',3.333,5),(452,17336,17318,'cad',3.333,5),(452,17337,17318,'ad2',3.333,5),(452,17338,17318,'d26',3.333,5),(452,17339,17318,'260',3.333,5),(452,17340,17318,'605',3.333,5),(452,17341,17318,'055',3.333,5),(452,17342,17318,'55f',3.333,5),(452,17343,17318,'5f5',3.333,5),(452,17344,17318,'f51',3.333,5),(452,17345,17318,'514',3.333,5),(452,17346,17318,'14f',3.333,5),(452,17347,17318,'4f6',3.333,5),(452,17348,17318,'f6d',3.333,5),(453,17350,17349,'naa',100,5),(453,17351,17350,'600',3.333,5),(453,17352,17350,'000',3.333,5),(453,17353,17350,'00c',3.333,5),(453,17354,17350,'0c2',3.333,5),(453,17355,17350,'c29',3.333,5),(453,17356,17350,'29c',3.333,5),(453,17357,17350,'9ce',3.333,5),(453,17358,17350,'ce3',3.333,5),(453,17359,17350,'e39',3.333,5),(453,17360,17350,'399',3.333,5),(453,17361,17350,'999',3.333,5),(453,17362,17350,'995',3.333,5),(453,17363,17350,'95d',3.333,5),(453,17364,17350,'5d2',3.333,5),(453,17365,17350,'d21',3.333,5),(453,17366,17350,'215',3.333,5),(453,17367,17350,'15b',3.333,5),(453,17368,17350,'5bd',3.333,5),(453,17369,17350,'bdb',3.333,5),(453,17370,17350,'dbe',3.333,5),(453,17371,17350,'be8',3.333,5),(453,17372,17350,'e84',3.333,5),(453,17373,17350,'84b',3.333,5),(453,17374,17350,'4b1',3.333,5),(453,17375,17350,'b1a',3.333,5),(453,17376,17350,'1a5',3.333,5),(453,17377,17350,'a58',3.333,5),(453,17378,17350,'58c',3.333,5),(453,17379,17350,'8c1',3.333,5),(453,17380,17350,'c17',3.333,5),(454,17382,17381,'naa',100,5),(454,17383,17382,'600',3.333,5),(454,17384,17382,'000',3.333,5),(454,17385,17382,'00c',3.333,5),(454,17386,17382,'0c2',3.333,5),(454,17387,17382,'c29',3.333,5),(454,17388,17382,'29a',3.333,5),(454,17389,17382,'9a8',3.333,5),(454,17390,17382,'a87',3.333,5),(454,17391,17382,'877',3.333,5),(454,17392,17382,'772',3.333,5),(454,17393,17382,'723',3.333,5),(454,17394,17382,'23e',3.333,5),(454,17395,17382,'3ee',3.333,5),(454,17396,17382,'ee3',3.333,5),(454,17397,17382,'e33',3.333,5),(454,17398,17382,'338',3.333,5),(454,17399,17382,'383',3.333,5),(454,17400,17382,'835',3.333,5),(454,17401,17382,'351',3.333,5),(454,17402,17382,'51b',3.333,5),(454,17403,17382,'1be',3.333,5),(454,17404,17382,'bee',3.333,5),(454,17405,17382,'eef',3.333,5),(454,17406,17382,'eff',3.333,5),(454,17407,17382,'fff',3.333,5),(454,17408,17382,'ff3',3.333,5),(454,17409,17382,'f3a',3.333,5),(454,17410,17382,'3a7',3.333,5),(454,17411,17382,'a76',3.333,5),(454,17412,17382,'76a',3.333,5),(455,17414,17413,'naa',100,5),(455,17415,17414,'600',3.333,5),(455,17416,17414,'000',3.333,5),(455,17417,17414,'00c',3.333,5),(455,17418,17414,'0c2',3.333,5),(455,17419,17414,'c29',3.333,5),(455,17420,17414,'29b',3.333,5),(455,17421,17414,'9be',3.333,5),(455,17422,17414,'be9',3.333,5),(455,17423,17414,'e91',3.333,5),(455,17424,17414,'91a',3.333,5),(455,17425,17414,'1af',3.333,5),(455,17426,17414,'afe',3.333,5),(455,17427,17414,'fe4',3.333,5),(455,17428,17414,'e40',3.333,5),(455,17429,17414,'402',3.333,5),(455,17430,17414,'02a',3.333,5),(455,17431,17414,'2ae',3.333,5),(455,17432,17414,'ae9',3.333,5),(455,17433,17414,'e96',3.333,5),(455,17434,17414,'96f',3.333,5),(455,17435,17414,'6fe',3.333,5),(455,17436,17414,'fef',3.333,5),(455,17437,17414,'ef3',3.333,5),(455,17438,17414,'f3a',3.333,5),(455,17439,17414,'3af',3.333,5),(455,17440,17414,'aff',3.333,5),(455,17441,17414,'ffb',3.333,5),(455,17442,17414,'fb2',3.333,5),(455,17443,17414,'b26',3.333,5),(455,17444,17414,'26e',3.333,5),(456,17446,17445,'naa',100,5),(456,17447,17446,'600',3.333,5),(456,17448,17446,'000',3.333,5),(456,17449,17446,'00c',3.333,5),(456,17450,17446,'0c2',3.333,5),(456,17451,17446,'c29',3.333,5),(456,17452,17446,'298',3.333,5),(456,17453,17446,'984',3.333,5),(456,17454,17446,'843',3.333,5),(456,17455,17446,'434',3.333,5),(456,17456,17446,'349',3.333,5),(456,17457,17446,'495',3.333,5),(456,17458,17446,'95e',3.333,5),(456,17459,17446,'5e0',3.333,5),(456,17460,17446,'e04',3.333,5),(456,17461,17446,'04f',3.333,5),(456,17462,17446,'4fb',3.333,5),(456,17463,17446,'fb9',3.333,5),(456,17464,17446,'b98',3.333,5),(456,17465,17446,'98b',3.333,5),(456,17466,17446,'8bb',3.333,5),(456,17467,17446,'bb2',3.333,5),(456,17468,17446,'b2a',3.333,5),(456,17469,17446,'2a0',3.333,5),(456,17470,17446,'a0d',3.333,5),(456,17471,17446,'0dc',3.333,5),(456,17472,17446,'dc2',3.333,5),(456,17473,17446,'c23',3.333,5),(456,17474,17446,'233',3.333,5),(456,17475,17446,'332',3.333,5),(456,17476,17446,'32c',3.333,5),(457,17478,17477,'naa',100,5),(457,17479,17478,'600',3.333,5),(457,17480,17478,'000',3.333,5),(457,17481,17478,'00c',3.333,5),(457,17482,17478,'0c2',3.333,5),(457,17483,17478,'c29',3.333,5),(457,17484,17478,'29b',3.333,5),(457,17485,17478,'9b8',3.333,5),(457,17486,17478,'b80',3.333,5),(457,17487,17478,'807',3.333,5),(457,17488,17478,'07b',3.333,5),(457,17489,17478,'7b8',3.333,5),(457,17490,17478,'b80',3.333,5),(457,17491,17478,'80b',3.333,5),(457,17492,17478,'0b7',3.333,5),(457,17493,17478,'b72',3.333,5),(457,17494,17478,'721',3.333,5),(457,17495,17478,'213',3.333,5),(457,17496,17478,'131',3.333,5),(457,17497,17478,'310',3.333,5),(457,17498,17478,'104',3.333,5),(457,17499,17478,'045',3.333,5),(457,17500,17478,'459',3.333,5),(457,17501,17478,'591',3.333,5),(457,17502,17478,'915',3.333,5),(457,17503,17478,'15c',3.333,5),(457,17504,17478,'5c5',3.333,5),(457,17505,17478,'c52',3.333,5),(457,17506,17478,'52f',3.333,5),(457,17507,17478,'2ff',3.333,5),(457,17508,17478,'ffc',3.333,5),(458,17510,17509,'naa',100,5),(458,17511,17510,'600',3.333,5),(458,17512,17510,'000',3.333,5),(458,17513,17510,'00c',3.333,5),(458,17514,17510,'0c2',3.333,5),(458,17515,17510,'c29',3.333,5),(458,17516,17510,'29f',3.333,5),(458,17517,17510,'9fc',3.333,5),(458,17518,17510,'fc9',3.333,5),(458,17519,17510,'c92',3.333,5),(458,17520,17510,'92d',3.333,5),(458,17521,17510,'2dc',3.333,5),(458,17522,17510,'dc7',3.333,5),(458,17523,17510,'c78',3.333,5),(458,17524,17510,'78e',3.333,5),(458,17525,17510,'8e1',3.333,5),(458,17526,17510,'e10',3.333,5),(458,17527,17510,'108',3.333,5),(458,17528,17510,'084',3.333,5),(458,17529,17510,'840',3.333,5),(458,17530,17510,'403',3.333,5),(458,17531,17510,'03d',3.333,5),(458,17532,17510,'3df',3.333,5),(458,17533,17510,'dfc',3.333,5),(458,17534,17510,'fc0',3.333,5),(458,17535,17510,'c0d',3.333,5),(458,17536,17510,'0dc',3.333,5),(458,17537,17510,'dc5',3.333,5),(458,17538,17510,'c50',3.333,5),(458,17539,17510,'500',3.333,5),(458,17540,17510,'004',3.333,5),(459,17542,17541,'naa',100,5),(459,17543,17542,'600',3.333,5),(459,17544,17542,'000',3.333,5),(459,17545,17542,'00c',3.333,5),(459,17546,17542,'0c2',3.333,5),(459,17547,17542,'c29',3.333,5),(459,17548,17542,'29e',3.333,5),(459,17549,17542,'9e6',3.333,5),(459,17550,17542,'e6c',3.333,5),(459,17551,17542,'6c8',3.333,5),(459,17552,17542,'c82',3.333,5),(459,17553,17542,'826',3.333,5),(459,17554,17542,'266',3.333,5),(459,17555,17542,'66f',3.333,5),(459,17556,17542,'6f8',3.333,5),(459,17557,17542,'f8f',3.333,5),(459,17558,17542,'8ff',3.333,5),(459,17559,17542,'ff0',3.333,5),(459,17560,17542,'f0e',3.333,5),(459,17561,17542,'0e9',3.333,5),(459,17562,17542,'e9d',3.333,5),(459,17563,17542,'9dd',3.333,5),(459,17564,17542,'ddc',3.333,5),(459,17565,17542,'dc2',3.333,5),(459,17566,17542,'c23',3.333,5),(459,17567,17542,'236',3.333,5),(459,17568,17542,'367',3.333,5),(459,17569,17542,'67c',3.333,5),(459,17570,17542,'7c5',3.333,5),(459,17571,17542,'c59',3.333,5),(459,17572,17542,'593',3.333,5),(460,17574,17573,'naa',100,5),(460,17575,17574,'600',3.333,5),(460,17576,17574,'000',3.333,5),(460,17577,17574,'00c',3.333,5),(460,17578,17574,'0c2',3.333,5),(460,17579,17574,'c29',3.333,5),(460,17580,17574,'297',3.333,5),(460,17581,17574,'978',3.333,5),(460,17582,17574,'780',3.333,5),(460,17583,17574,'805',3.333,5),(460,17584,17574,'055',3.333,5),(460,17585,17574,'558',3.333,5),(460,17586,17574,'587',3.333,5),(460,17587,17574,'874',3.333,5),(460,17588,17574,'74f',3.333,5),(460,17589,17574,'4f2',3.333,5),(460,17590,17574,'f2d',3.333,5),(460,17591,17574,'2dc',3.333,5),(460,17592,17574,'dce',3.333,5),(460,17593,17574,'ceb',3.333,5),(460,17594,17574,'eb2',3.333,5),(460,17595,17574,'b27',3.333,5),(460,17596,17574,'272',3.333,5),(460,17597,17574,'72e',3.333,5),(460,17598,17574,'2e9',3.333,5),(460,17599,17574,'e9b',3.333,5),(460,17600,17574,'9b8',3.333,5),(460,17601,17574,'b89',3.333,5),(460,17602,17574,'891',3.333,5),(460,17603,17574,'910',3.333,5),(460,17604,17574,'104',3.333,5),(461,17606,17605,'naa',100,5),(461,17607,17606,'600',3.333,5),(461,17608,17606,'000',3.333,5),(461,17609,17606,'00c',3.333,5),(461,17610,17606,'0c2',3.333,5),(461,17611,17606,'c29',3.333,5),(461,17612,17606,'297',3.333,5),(461,17613,17606,'97e',3.333,5),(461,17614,17606,'7ed',3.333,5),(461,17615,17606,'ed5',3.333,5),(461,17616,17606,'d59',3.333,5),(461,17617,17606,'59d',3.333,5),(461,17618,17606,'9db',3.333,5),(461,17619,17606,'dbc',3.333,5),(461,17620,17606,'bc3',3.333,5),(461,17621,17606,'c39',3.333,5),(461,17622,17606,'39a',3.333,5),(461,17623,17606,'9a6',3.333,5),(461,17624,17606,'a6b',3.333,5),(461,17625,17606,'6bb',3.333,5),(461,17626,17606,'bbb',3.333,5),(461,17627,17606,'bb8',3.333,5),(461,17628,17606,'b80',3.333,5),(461,17629,17606,'805',3.333,5),(461,17630,17606,'05c',3.333,5),(461,17631,17606,'5c2',3.333,5),(461,17632,17606,'c2f',3.333,5),(461,17633,17606,'2fb',3.333,5),(461,17634,17606,'fb8',3.333,5),(461,17635,17606,'b80',3.333,5),(461,17636,17606,'800',3.333,5),(462,17638,17637,'naa',100,5),(462,17639,17638,'600',3.333,5),(462,17640,17638,'000',3.333,5),(462,17641,17638,'00c',3.333,5),(462,17642,17638,'0c2',3.333,5),(462,17643,17638,'c29',3.333,5),(462,17644,17638,'293',3.333,5),(462,17645,17638,'939',3.333,5),(462,17646,17638,'39e',3.333,5),(462,17647,17638,'9ea',3.333,5),(462,17648,17638,'eab',3.333,5),(462,17649,17638,'abe',3.333,5),(462,17650,17638,'be4',3.333,5),(462,17651,17638,'e43',3.333,5),(462,17652,17638,'43e',3.333,5),(462,17653,17638,'3ec',3.333,5),(462,17654,17638,'ec0',3.333,5),(462,17655,17638,'c04',3.333,5),(462,17656,17638,'040',3.333,5),(462,17657,17638,'406',3.333,5),(462,17658,17638,'06d',3.333,5),(462,17659,17638,'6da',3.333,5),(462,17660,17638,'da8',3.333,5),(462,17661,17638,'a8c',3.333,5),(462,17662,17638,'8cf',3.333,5),(462,17663,17638,'cf7',3.333,5),(462,17664,17638,'f74',3.333,5),(462,17665,17638,'74e',3.333,5),(462,17666,17638,'4e5',3.333,5),(462,17667,17638,'e5f',3.333,5),(462,17668,17638,'5fd',3.333,5),(403,17682,17681,'hgw',9.091,5),(403,17683,17681,'gw2',9.091,5),(403,17684,17681,'w2k',9.091,5),(403,17685,17681,'2k8',9.091,5),(403,17686,17681,'k8r',9.091,5),(403,17687,17681,'8r2',9.091,5),(403,17688,17681,'r23',9.091,5),(403,17689,17681,'232',9.091,5),(403,17690,17681,'32v',9.091,5),(403,17691,17681,'2vm',9.091,5),(403,17692,17681,'vm5',9.091,5),(464,17694,17693,'naa',100,5),(464,17695,17694,'600',3.333,5),(464,17696,17694,'000',3.333,5),(464,17697,17694,'00c',3.333,5),(464,17698,17694,'0c2',3.333,5),(464,17699,17694,'c29',3.333,5),(464,17700,17694,'290',3.333,5),(464,17701,17694,'905',3.333,5),(464,17702,17694,'050',3.333,5),(464,17703,17694,'50a',3.333,5),(464,17704,17694,'0aa',3.333,5),(464,17705,17694,'aa8',3.333,5),(464,17706,17694,'a8b',3.333,5),(464,17707,17694,'8bf',3.333,5),(464,17708,17694,'bf9',3.333,5),(464,17709,17694,'f9c',3.333,5),(464,17710,17694,'9c1',3.333,5),(464,17711,17694,'c16',3.333,5),(464,17712,17694,'160',3.333,5),(464,17713,17694,'605',3.333,5),(464,17714,17694,'05e',3.333,5),(464,17715,17694,'5e8',3.333,5),(464,17716,17694,'e83',3.333,5),(464,17717,17694,'834',3.333,5),(464,17718,17694,'349',3.333,5),(464,17719,17694,'49c',3.333,5),(464,17720,17694,'9c1',3.333,5),(464,17721,17694,'c1a',3.333,5),(464,17722,17694,'1a1',3.333,5),(464,17723,17694,'a18',3.333,5),(464,17724,17694,'183',3.333,5),(465,17726,17725,'naa',100,5),(465,17727,17726,'600',3.333,5),(465,17728,17726,'00a',3.333,5),(465,17729,17726,'0a0',3.333,5),(465,17730,17726,'a09',3.333,5),(465,17731,17726,'098',3.333,5),(465,17732,17726,'980',3.333,5),(465,17733,17726,'804',3.333,5),(465,17734,17726,'044',3.333,5),(465,17735,17726,'443',3.333,5),(465,17736,17726,'430',3.333,5),(465,17737,17726,'307',3.333,5),(465,17738,17726,'072',3.333,5),(465,17739,17726,'725',3.333,5),(465,17740,17726,'259',3.333,5),(465,17741,17726,'593',3.333,5),(465,17742,17726,'931',3.333,5),(465,17743,17726,'313',3.333,5),(465,17744,17726,'13f',3.333,5),(465,17745,17726,'3f3',3.333,5),(465,17746,17726,'f33',3.333,5),(465,17747,17726,'334',3.333,5),(465,17748,17726,'345',3.333,5),(465,17749,17726,'455',3.333,5),(465,17750,17726,'556',3.333,5),(465,17751,17726,'563',3.333,5),(465,17752,17726,'639',3.333,5),(465,17753,17726,'393',3.333,5),(465,17754,17726,'934',3.333,5),(465,17755,17726,'344',3.333,5),(465,17756,17726,'445',3.333,5),(466,17758,17757,'naa',100,5),(466,17759,17758,'600',3.333,5),(466,17760,17758,'00a',3.333,5),(466,17761,17758,'0a0',3.333,5),(466,17762,17758,'a09',3.333,5),(466,17763,17758,'098',3.333,5),(466,17764,17758,'980',3.333,5),(466,17765,17758,'804',3.333,5),(466,17766,17758,'044',3.333,5),(466,17767,17758,'443',3.333,5),(466,17768,17758,'430',3.333,5),(466,17769,17758,'307',3.333,5),(466,17770,17758,'072',3.333,5),(466,17771,17758,'725',3.333,5),(466,17772,17758,'259',3.333,5),(466,17773,17758,'593',3.333,5),(466,17774,17758,'931',3.333,5),(466,17775,17758,'313',3.333,5),(466,17776,17758,'13f',3.333,5),(466,17777,17758,'3f3',3.333,5),(466,17778,17758,'f33',3.333,5),(466,17779,17758,'334',3.333,5),(466,17780,17758,'345',3.333,5),(466,17781,17758,'455',3.333,5),(466,17782,17758,'556',3.333,5),(466,17783,17758,'563',3.333,5),(466,17784,17758,'639',3.333,5),(466,17785,17758,'393',3.333,5),(466,17786,17758,'934',3.333,5),(466,17787,17758,'344',3.333,5),(466,17788,17758,'446',3.333,5),(467,17790,17789,'naa',100,5),(467,17791,17790,'600',3.333,5),(467,17792,17790,'00a',3.333,5),(467,17793,17790,'0a0',3.333,5),(467,17794,17790,'a09',3.333,5),(467,17795,17790,'098',3.333,5),(467,17796,17790,'980',3.333,5),(467,17797,17790,'804',3.333,5),(467,17798,17790,'044',3.333,5),(467,17799,17790,'443',3.333,5),(467,17800,17790,'430',3.333,5),(467,17801,17790,'307',3.333,5),(467,17802,17790,'075',3.333,5),(467,17803,17790,'753',3.333,5),(467,17804,17790,'535',3.333,5),(467,17805,17790,'357',3.333,5),(467,17806,17790,'573',3.333,5),(467,17807,17790,'732',3.333,5),(467,17808,17790,'32b',3.333,5),(467,17809,17790,'2b3',3.333,5),(467,17810,17790,'b33',3.333,5),(467,17811,17790,'334',3.333,5),(467,17812,17790,'345',3.333,5),(467,17813,17790,'457',3.333,5),(467,17814,17790,'571',3.333,5),(467,17815,17790,'715',3.333,5),(467,17816,17790,'153',3.333,5),(467,17817,17790,'533',3.333,5),(467,17818,17790,'336',3.333,5),(467,17819,17790,'363',3.333,5),(467,17820,17790,'630',3.333,5),(468,17822,17821,'naa',100,5),(468,17823,17822,'600',3.333,5),(468,17824,17822,'00a',3.333,5),(468,17825,17822,'0a0',3.333,5),(468,17826,17822,'a09',3.333,5),(468,17827,17822,'098',3.333,5),(468,17828,17822,'980',3.333,5),(468,17829,17822,'804',3.333,5),(468,17830,17822,'044',3.333,5),(468,17831,17822,'443',3.333,5),(468,17832,17822,'430',3.333,5),(468,17833,17822,'307',3.333,5),(468,17834,17822,'075',3.333,5),(468,17835,17822,'753',3.333,5),(468,17836,17822,'535',3.333,5),(468,17837,17822,'357',3.333,5),(468,17838,17822,'573',3.333,5),(468,17839,17822,'732',3.333,5),(468,17840,17822,'32b',3.333,5),(468,17841,17822,'2b3',3.333,5),(468,17842,17822,'b33',3.333,5),(468,17843,17822,'334',3.333,5),(468,17844,17822,'345',3.333,5),(468,17845,17822,'457',3.333,5),(468,17846,17822,'571',3.333,5),(468,17847,17822,'715',3.333,5),(468,17848,17822,'153',3.333,5),(468,17849,17822,'533',3.333,5),(468,17850,17822,'336',3.333,5),(468,17851,17822,'363',3.333,5),(468,17852,17822,'631',3.333,5),(469,17854,17853,'naa',100,5),(469,17855,17854,'600',3.333,5),(469,17856,17854,'000',3.333,5),(469,17857,17854,'00c',3.333,5),(469,17858,17854,'0c2',3.333,5),(469,17859,17854,'c29',3.333,5),(469,17860,17854,'29d',3.333,5),(469,17861,17854,'9de',3.333,5),(469,17862,17854,'de6',3.333,5),(469,17863,17854,'e6e',3.333,5),(469,17864,17854,'6ea',3.333,5),(469,17865,17854,'ead',3.333,5),(469,17866,17854,'ad9',3.333,5),(469,17867,17854,'d96',3.333,5),(469,17868,17854,'965',3.333,5),(469,17869,17854,'658',3.333,5),(469,17870,17854,'581',3.333,5),(469,17871,17854,'81a',3.333,5),(469,17872,17854,'1a1',3.333,5),(469,17873,17854,'a14',3.333,5),(469,17874,17854,'142',3.333,5),(469,17875,17854,'429',3.333,5),(469,17876,17854,'299',3.333,5),(469,17877,17854,'99a',3.333,5),(469,17878,17854,'9ae',3.333,5),(469,17879,17854,'ae7',3.333,5),(469,17880,17854,'e7f',3.333,5),(469,17881,17854,'7f1',3.333,5),(469,17882,17854,'f1a',3.333,5),(469,17883,17854,'1ac',3.333,5),(469,17884,17854,'acf',3.333,5),(470,17886,17885,'naa',100,5),(470,17887,17886,'600',3.333,5),(470,17888,17886,'000',3.333,5),(470,17889,17886,'00c',3.333,5),(470,17890,17886,'0c2',3.333,5),(470,17891,17886,'c29',3.333,5),(470,17892,17886,'294',3.333,5),(470,17893,17886,'945',3.333,5),(470,17894,17886,'45e',3.333,5),(470,17895,17886,'5e8',3.333,5),(470,17896,17886,'e8e',3.333,5),(470,17897,17886,'8e9',3.333,5),(470,17898,17886,'e98',3.333,5),(470,17899,17886,'988',3.333,5),(470,17900,17886,'884',3.333,5),(470,17901,17886,'84e',3.333,5),(470,17902,17886,'4e0',3.333,5),(470,17903,17886,'e0f',3.333,5),(470,17904,17886,'0ff',3.333,5),(470,17905,17886,'ff5',3.333,5),(470,17906,17886,'f5f',3.333,5),(470,17907,17886,'5f1',3.333,5),(470,17908,17886,'f1a',3.333,5),(470,17909,17886,'1ae',3.333,5),(470,17910,17886,'aed',3.333,5),(470,17911,17886,'ed5',3.333,5),(470,17912,17886,'d59',3.333,5),(470,17913,17886,'59e',3.333,5),(470,17914,17886,'9e8',3.333,5),(470,17915,17886,'e8a',3.333,5),(470,17916,17886,'8a8',3.333,5),(471,17918,17917,'naa',100,5),(471,17919,17918,'600',3.333,5),(471,17920,17918,'000',3.333,5),(471,17921,17918,'00c',3.333,5),(471,17922,17918,'0c2',3.333,5),(471,17923,17918,'c29',3.333,5),(471,17924,17918,'29b',3.333,5),(471,17925,17918,'9b4',3.333,5),(471,17926,17918,'b4d',3.333,5),(471,17927,17918,'4dc',3.333,5),(471,17928,17918,'dcf',3.333,5),(471,17929,17918,'cf0',3.333,5),(471,17930,17918,'f00',3.333,5),(471,17931,17918,'00e',3.333,5),(471,17932,17918,'0e0',3.333,5),(471,17933,17918,'e00',3.333,5),(471,17934,17918,'003',3.333,5),(471,17935,17918,'03c',3.333,5),(471,17936,17918,'3cb',3.333,5),(471,17937,17918,'cba',3.333,5),(471,17938,17918,'ba8',3.333,5),(471,17939,17918,'a87',3.333,5),(471,17940,17918,'875',3.333,5),(471,17941,17918,'75c',3.333,5),(471,17942,17918,'5cc',3.333,5),(471,17943,17918,'cc3',3.333,5),(471,17944,17918,'c3e',3.333,5),(471,17945,17918,'3e4',3.333,5),(471,17946,17918,'e4a',3.333,5),(471,17947,17918,'4ac',3.333,5),(471,17948,17918,'ac6',3.333,5),(472,17950,17949,'naa',100,5),(472,17951,17950,'600',3.333,5),(472,17952,17950,'000',3.333,5),(472,17953,17950,'00c',3.333,5),(472,17954,17950,'0c2',3.333,5),(472,17955,17950,'c29',3.333,5),(472,17956,17950,'29f',3.333,5),(472,17957,17950,'9f0',3.333,5),(472,17958,17950,'f06',3.333,5),(472,17959,17950,'064',3.333,5),(472,17960,17950,'648',3.333,5),(472,17961,17950,'482',3.333,5),(472,17962,17950,'82d',3.333,5),(472,17963,17950,'2dd',3.333,5),(472,17964,17950,'dd8',3.333,5),(472,17965,17950,'d83',3.333,5),(472,17966,17950,'83b',3.333,5),(472,17967,17950,'3b3',3.333,5),(472,17968,17950,'b3a',3.333,5),(472,17969,17950,'3a6',3.333,5),(472,17970,17950,'a64',3.333,5),(472,17971,17950,'643',3.333,5),(472,17972,17950,'43b',3.333,5),(472,17973,17950,'3b6',3.333,5),(472,17974,17950,'b64',3.333,5),(472,17975,17950,'645',3.333,5),(472,17976,17950,'451',3.333,5),(472,17977,17950,'51a',3.333,5),(472,17978,17950,'1af',3.333,5),(472,17979,17950,'af2',3.333,5),(472,17980,17950,'f27',3.333,5),(473,17982,17981,'naa',100,5),(473,17983,17982,'600',3.333,5),(473,17984,17982,'000',3.333,5),(473,17985,17982,'00c',3.333,5),(473,17986,17982,'0c2',3.333,5),(473,17987,17982,'c29',3.333,5),(473,17988,17982,'29a',3.333,5),(473,17989,17982,'9a5',3.333,5),(473,17990,17982,'a5c',3.333,5),(473,17991,17982,'5c5',3.333,5),(473,17992,17982,'c51',3.333,5),(473,17993,17982,'519',3.333,5),(473,17994,17982,'19d',3.333,5),(473,17995,17982,'9d5',3.333,5),(473,17996,17982,'d58',3.333,5),(473,17997,17982,'58f',3.333,5),(473,17998,17982,'8f8',3.333,5),(473,17999,17982,'f81',3.333,5),(473,18000,17982,'812',3.333,5),(473,18001,17982,'121',3.333,5),(473,18002,17982,'21f',3.333,5),(473,18003,17982,'1fb',3.333,5),(473,18004,17982,'fb9',3.333,5),(473,18005,17982,'b96',3.333,5),(473,18006,17982,'964',3.333,5),(473,18007,17982,'64f',3.333,5),(473,18008,17982,'4ff',3.333,5),(473,18009,17982,'ffe',3.333,5),(473,18010,17982,'feb',3.333,5),(473,18011,17982,'ebd',3.333,5),(473,18012,17982,'bd0',3.333,5),(474,18014,18013,'naa',100,5),(474,18015,18014,'600',3.333,5),(474,18016,18014,'000',3.333,5),(474,18017,18014,'00c',3.333,5),(474,18018,18014,'0c2',3.333,5),(474,18019,18014,'c29',3.333,5),(474,18020,18014,'294',3.333,5),(474,18021,18014,'949',3.333,5),(474,18022,18014,'490',3.333,5),(474,18023,18014,'903',3.333,5),(474,18024,18014,'030',3.333,5),(474,18025,18014,'301',3.333,5),(474,18026,18014,'01b',3.333,5),(474,18027,18014,'1b4',3.333,5),(474,18028,18014,'b4e',3.333,5),(474,18029,18014,'4e6',3.333,5),(474,18030,18014,'e60',3.333,5),(474,18031,18014,'605',3.333,5),(474,18032,18014,'052',3.333,5),(474,18033,18014,'524',3.333,5),(474,18034,18014,'24d',3.333,5),(474,18035,18014,'4df',3.333,5),(474,18036,18014,'df4',3.333,5),(474,18037,18014,'f46',3.333,5),(474,18038,18014,'467',3.333,5),(474,18039,18014,'67f',3.333,5),(474,18040,18014,'7fb',3.333,5),(474,18041,18014,'fb6',3.333,5),(474,18042,18014,'b65',3.333,5),(474,18043,18014,'65f',3.333,5),(474,18044,18014,'5f9',3.333,5),(475,18046,18045,'naa',100,5),(475,18047,18046,'600',3.333,5),(475,18048,18046,'000',3.333,5),(475,18049,18046,'00c',3.333,5),(475,18050,18046,'0c2',3.333,5),(475,18051,18046,'c29',3.333,5),(475,18052,18046,'29b',3.333,5),(475,18053,18046,'9ba',3.333,5),(475,18054,18046,'bae',3.333,5),(475,18055,18046,'ae5',3.333,5),(475,18056,18046,'e59',3.333,5),(475,18057,18046,'590',3.333,5),(475,18058,18046,'90d',3.333,5),(475,18059,18046,'0d6',3.333,5),(475,18060,18046,'d69',3.333,5),(475,18061,18046,'69a',3.333,5),(475,18062,18046,'9a5',3.333,5),(475,18063,18046,'a5a',3.333,5),(475,18064,18046,'5ad',3.333,5),(475,18065,18046,'ad7',3.333,5),(475,18066,18046,'d76',3.333,5),(475,18067,18046,'76d',3.333,5),(475,18068,18046,'6d9',3.333,5),(475,18069,18046,'d94',3.333,5),(475,18070,18046,'948',3.333,5),(475,18071,18046,'482',3.333,5),(475,18072,18046,'82d',3.333,5),(475,18073,18046,'2d6',3.333,5),(475,18074,18046,'d68',3.333,5),(475,18075,18046,'682',3.333,5),(475,18076,18046,'823',3.333,5),(476,18078,18077,'naa',100,5),(476,18079,18078,'600',3.333,5),(476,18080,18078,'000',3.333,5),(476,18081,18078,'00c',3.333,5),(476,18082,18078,'0c2',3.333,5),(476,18083,18078,'c29',3.333,5),(476,18084,18078,'297',3.333,5),(476,18085,18078,'976',3.333,5),(476,18086,18078,'766',3.333,5),(476,18087,18078,'661',3.333,5),(476,18088,18078,'618',3.333,5),(476,18089,18078,'184',3.333,5),(476,18090,18078,'848',3.333,5),(476,18091,18078,'483',3.333,5),(476,18092,18078,'835',3.333,5),(476,18093,18078,'358',3.333,5),(476,18094,18078,'584',3.333,5),(476,18095,18078,'845',3.333,5),(476,18096,18078,'457',3.333,5),(476,18097,18078,'57a',3.333,5),(476,18098,18078,'7a9',3.333,5),(476,18099,18078,'a9e',3.333,5),(476,18100,18078,'9ec',3.333,5),(476,18101,18078,'ec6',3.333,5),(476,18102,18078,'c69',3.333,5),(476,18103,18078,'697',3.333,5),(476,18104,18078,'97c',3.333,5),(476,18105,18078,'7c1',3.333,5),(476,18106,18078,'c16',3.333,5),(476,18107,18078,'166',3.333,5),(476,18108,18078,'661',3.333,5),(477,18110,18109,'naa',100,5),(477,18111,18110,'600',3.333,5),(477,18112,18110,'000',3.333,5),(477,18113,18110,'00c',3.333,5),(477,18114,18110,'0c2',3.333,5),(477,18115,18110,'c29',3.333,5),(477,18116,18110,'295',3.333,5),(477,18117,18110,'958',3.333,5),(477,18118,18110,'584',3.333,5),(477,18119,18110,'849',3.333,5),(477,18120,18110,'495',3.333,5),(477,18121,18110,'955',3.333,5),(477,18122,18110,'553',3.333,5),(477,18123,18110,'536',3.333,5),(477,18124,18110,'36a',3.333,5),(477,18125,18110,'6a5',3.333,5),(477,18126,18110,'a5b',3.333,5),(477,18127,18110,'5b0',3.333,5),(477,18128,18110,'b02',3.333,5),(477,18129,18110,'026',3.333,5),(477,18130,18110,'261',3.333,5),(477,18131,18110,'614',3.333,5),(477,18132,18110,'14f',3.333,5),(477,18133,18110,'4f0',3.333,5),(477,18134,18110,'f0b',3.333,5),(477,18135,18110,'0b1',3.333,5),(477,18136,18110,'b11',3.333,5),(477,18137,18110,'11a',3.333,5),(477,18138,18110,'1a1',3.333,5),(477,18139,18110,'a10',3.333,5),(477,18140,18110,'10f',3.333,5),(478,18142,18141,'naa',100,5),(478,18143,18142,'600',3.333,5),(478,18144,18142,'000',3.333,5),(478,18145,18142,'00c',3.333,5),(478,18146,18142,'0c2',3.333,5),(478,18147,18142,'c29',3.333,5),(478,18148,18142,'293',3.333,5),(478,18149,18142,'936',3.333,5),(478,18150,18142,'36c',3.333,5),(478,18151,18142,'6c6',3.333,5),(478,18152,18142,'c67',3.333,5),(478,18153,18142,'67b',3.333,5),(478,18154,18142,'7b6',3.333,5),(478,18155,18142,'b6d',3.333,5),(478,18156,18142,'6d6',3.333,5),(478,18157,18142,'d6d',3.333,5),(478,18158,18142,'6d7',3.333,5),(478,18159,18142,'d73',3.333,5),(478,18160,18142,'73a',3.333,5),(478,18161,18142,'3a6',3.333,5),(478,18162,18142,'a62',3.333,5),(478,18163,18142,'62e',3.333,5),(478,18164,18142,'2e5',3.333,5),(478,18165,18142,'e5c',3.333,5),(478,18166,18142,'5c5',3.333,5),(478,18167,18142,'c58',3.333,5),(478,18168,18142,'58a',3.333,5),(478,18169,18142,'8a4',3.333,5),(478,18170,18142,'a4e',3.333,5),(478,18171,18142,'4e6',3.333,5),(478,18172,18142,'e67',3.333,5),(479,18174,18173,'naa',100,5),(479,18175,18174,'600',3.333,5),(479,18176,18174,'000',3.333,5),(479,18177,18174,'00c',3.333,5),(479,18178,18174,'0c2',3.333,5),(479,18179,18174,'c29',3.333,5),(479,18180,18174,'29a',3.333,5),(479,18181,18174,'9af',3.333,5),(479,18182,18174,'afc',3.333,5),(479,18183,18174,'fce',3.333,5),(479,18184,18174,'cef',3.333,5),(479,18185,18174,'efe',3.333,5),(479,18186,18174,'fec',3.333,5),(479,18187,18174,'ecb',3.333,5),(479,18188,18174,'cb7',3.333,5),(479,18189,18174,'b7a',3.333,5),(479,18190,18174,'7a5',3.333,5),(479,18191,18174,'a5e',3.333,5),(479,18192,18174,'5e8',3.333,5),(479,18193,18174,'e84',3.333,5),(479,18194,18174,'84f',3.333,5),(479,18195,18174,'4f9',3.333,5),(479,18196,18174,'f9e',3.333,5),(479,18197,18174,'9ec',3.333,5),(479,18198,18174,'ecd',3.333,5),(479,18199,18174,'cd9',3.333,5),(479,18200,18174,'d9c',3.333,5),(479,18201,18174,'9c4',3.333,5),(479,18202,18174,'c40',3.333,5),(479,18203,18174,'40e',3.333,5),(479,18204,18174,'0ea',3.333,5),(480,18206,18205,'naa',100,5),(480,18207,18206,'600',3.333,5),(480,18208,18206,'000',3.333,5),(480,18209,18206,'00c',3.333,5),(480,18210,18206,'0c2',3.333,5),(480,18211,18206,'c29',3.333,5),(480,18212,18206,'296',3.333,5),(480,18213,18206,'967',3.333,5),(480,18214,18206,'67d',3.333,5),(480,18215,18206,'7dc',3.333,5),(480,18216,18206,'dc3',3.333,5),(480,18217,18206,'c3a',3.333,5),(480,18218,18206,'3ab',3.333,5),(480,18219,18206,'ab7',3.333,5),(480,18220,18206,'b79',3.333,5),(480,18221,18206,'79d',3.333,5),(480,18222,18206,'9d3',3.333,5),(480,18223,18206,'d33',3.333,5),(480,18224,18206,'33d',3.333,5),(480,18225,18206,'3dc',3.333,5),(480,18226,18206,'dc7',3.333,5),(480,18227,18206,'c79',3.333,5),(480,18228,18206,'793',3.333,5),(480,18229,18206,'93d',3.333,5),(480,18230,18206,'3d0',3.333,5),(480,18231,18206,'d03',3.333,5),(480,18232,18206,'037',3.333,5),(480,18233,18206,'379',3.333,5),(480,18234,18206,'79f',3.333,5),(480,18235,18206,'9fc',3.333,5),(480,18236,18206,'fc6',3.333,5),(481,18238,18237,'naa',100,5),(481,18239,18238,'600',3.333,5),(481,18240,18238,'000',3.333,5),(481,18241,18238,'00c',3.333,5),(481,18242,18238,'0c2',3.333,5),(481,18243,18238,'c29',3.333,5),(481,18244,18238,'295',3.333,5),(481,18245,18238,'95c',3.333,5),(481,18246,18238,'5c8',3.333,5),(481,18247,18238,'c86',3.333,5),(481,18248,18238,'862',3.333,5),(481,18249,18238,'622',3.333,5),(481,18250,18238,'222',3.333,5),(481,18251,18238,'22f',3.333,5),(481,18252,18238,'2f4',3.333,5),(481,18253,18238,'f42',3.333,5),(481,18254,18238,'426',3.333,5),(481,18255,18238,'260',3.333,5),(481,18256,18238,'604',3.333,5),(481,18257,18238,'042',3.333,5),(481,18258,18238,'427',3.333,5),(481,18259,18238,'27b',3.333,5),(481,18260,18238,'7b7',3.333,5),(481,18261,18238,'b7b',3.333,5),(481,18262,18238,'7b7',3.333,5),(481,18263,18238,'b75',3.333,5),(481,18264,18238,'752',3.333,5),(481,18265,18238,'521',3.333,5),(481,18266,18238,'214',3.333,5),(481,18267,18238,'14f',3.333,5),(481,18268,18238,'4fd',3.333,5),(482,18270,18269,'naa',100,5),(482,18271,18270,'600',3.333,5),(482,18272,18270,'000',3.333,5),(482,18273,18270,'00c',3.333,5),(482,18274,18270,'0c2',3.333,5),(482,18275,18270,'c29',3.333,5),(482,18276,18270,'29b',3.333,5),(482,18277,18270,'9b1',3.333,5),(482,18278,18270,'b14',3.333,5),(482,18279,18270,'14f',3.333,5),(482,18280,18270,'4ff',3.333,5),(482,18281,18270,'ffb',3.333,5),(482,18282,18270,'fb8',3.333,5),(482,18283,18270,'b86',3.333,5),(482,18284,18270,'866',3.333,5),(482,18285,18270,'666',3.333,5),(482,18286,18270,'669',3.333,5),(482,18287,18270,'697',3.333,5),(482,18288,18270,'976',3.333,5),(482,18289,18270,'769',3.333,5),(482,18290,18270,'691',3.333,5),(482,18291,18270,'915',3.333,5),(482,18292,18270,'15f',3.333,5),(482,18293,18270,'5fe',3.333,5),(482,18294,18270,'fed',3.333,5),(482,18295,18270,'ed3',3.333,5),(482,18296,18270,'d34',3.333,5),(482,18297,18270,'342',3.333,5),(482,18298,18270,'421',3.333,5),(482,18299,18270,'21d',3.333,5),(482,18300,18270,'1d9',3.333,5),(483,18302,18301,'naa',100,5),(483,18303,18302,'600',3.333,5),(483,18304,18302,'000',3.333,5),(483,18305,18302,'00c',3.333,5),(483,18306,18302,'0c2',3.333,5),(483,18307,18302,'c29',3.333,5),(483,18308,18302,'293',3.333,5),(483,18309,18302,'93f',3.333,5),(483,18310,18302,'3f3',3.333,5),(483,18311,18302,'f3c',3.333,5),(483,18312,18302,'3ce',3.333,5),(483,18313,18302,'cea',3.333,5),(483,18314,18302,'ead',3.333,5),(483,18315,18302,'ad6',3.333,5),(483,18316,18302,'d67',3.333,5),(483,18317,18302,'675',3.333,5),(483,18318,18302,'75c',3.333,5),(483,18319,18302,'5c0',3.333,5),(483,18320,18302,'c0b',3.333,5),(483,18321,18302,'0b6',3.333,5),(483,18322,18302,'b69',3.333,5),(483,18323,18302,'694',3.333,5),(483,18324,18302,'945',3.333,5),(483,18325,18302,'45c',3.333,5),(483,18326,18302,'5c6',3.333,5),(483,18327,18302,'c6f',3.333,5),(483,18328,18302,'6f8',3.333,5),(483,18329,18302,'f8b',3.333,5),(483,18330,18302,'8b7',3.333,5),(483,18331,18302,'b7a',3.333,5),(483,18332,18302,'7a1',3.333,5),(484,18334,18333,'naa',100,5),(484,18335,18334,'600',3.333,5),(484,18336,18334,'000',3.333,5),(484,18337,18334,'00c',3.333,5),(484,18338,18334,'0c2',3.333,5),(484,18339,18334,'c29',3.333,5),(484,18340,18334,'297',3.333,5),(484,18341,18334,'97d',3.333,5),(484,18342,18334,'7db',3.333,5),(484,18343,18334,'db8',3.333,5),(484,18344,18334,'b85',3.333,5),(484,18345,18334,'857',3.333,5),(484,18346,18334,'572',3.333,5),(484,18347,18334,'72f',3.333,5),(484,18348,18334,'2f2',3.333,5),(484,18349,18334,'f20',3.333,5),(484,18350,18334,'20f',3.333,5),(484,18351,18334,'0fe',3.333,5),(484,18352,18334,'fe1',3.333,5),(484,18353,18334,'e1b',3.333,5),(484,18354,18334,'1b8',3.333,5),(484,18355,18334,'b87',3.333,5),(484,18356,18334,'87b',3.333,5),(484,18357,18334,'7b0',3.333,5),(484,18358,18334,'b09',3.333,5),(484,18359,18334,'09b',3.333,5),(484,18360,18334,'9b0',3.333,5),(484,18361,18334,'b0e',3.333,5),(484,18362,18334,'0ea',3.333,5),(484,18363,18334,'ea2',3.333,5),(484,18364,18334,'a2e',3.333,5),(485,18366,18365,'naa',100,5),(485,18367,18366,'600',3.333,5),(485,18368,18366,'000',3.333,5),(485,18369,18366,'00c',3.333,5),(485,18370,18366,'0c2',3.333,5),(485,18371,18366,'c29',3.333,5),(485,18372,18366,'29a',3.333,5),(485,18373,18366,'9a1',3.333,5),(485,18374,18366,'a1b',3.333,5),(485,18375,18366,'1b2',3.333,5),(485,18376,18366,'b25',3.333,5),(485,18377,18366,'256',3.333,5),(485,18378,18366,'56e',3.333,5),(485,18379,18366,'6ef',3.333,5),(485,18380,18366,'ef4',3.333,5),(485,18381,18366,'f44',3.333,5),(485,18382,18366,'440',3.333,5),(485,18383,18366,'400',3.333,5),(485,18384,18366,'000',3.333,5),(485,18385,18366,'00e',3.333,5),(485,18386,18366,'0e6',3.333,5),(485,18387,18366,'e6c',3.333,5),(485,18388,18366,'6c4',3.333,5),(485,18389,18366,'c4e',3.333,5),(485,18390,18366,'4ed',3.333,5),(485,18391,18366,'edc',3.333,5),(485,18392,18366,'dc9',3.333,5),(485,18393,18366,'c94',3.333,5),(485,18394,18366,'94e',3.333,5),(485,18395,18366,'4e6',3.333,5),(485,18396,18366,'e65',3.333,5),(486,18398,18397,'naa',100,5),(486,18399,18398,'600',3.333,5),(486,18400,18398,'000',3.333,5),(486,18401,18398,'00c',3.333,5),(486,18402,18398,'0c2',3.333,5),(486,18403,18398,'c29',3.333,5),(486,18404,18398,'29b',3.333,5),(486,18405,18398,'9b1',3.333,5),(486,18406,18398,'b1a',3.333,5),(486,18407,18398,'1ab',3.333,5),(486,18408,18398,'ab4',3.333,5),(486,18409,18398,'b45',3.333,5),(486,18410,18398,'452',3.333,5),(486,18411,18398,'52b',3.333,5),(486,18412,18398,'2b7',3.333,5),(486,18413,18398,'b7b',3.333,5),(486,18414,18398,'7bc',3.333,5),(486,18415,18398,'bca',3.333,5),(486,18416,18398,'caf',3.333,5),(486,18417,18398,'af1',3.333,5),(486,18418,18398,'f12',3.333,5),(486,18419,18398,'124',3.333,5),(486,18420,18398,'24f',3.333,5),(486,18421,18398,'4fa',3.333,5),(486,18422,18398,'faf',3.333,5),(486,18423,18398,'afc',3.333,5),(486,18424,18398,'fc1',3.333,5),(486,18425,18398,'c17',3.333,5),(486,18426,18398,'178',3.333,5),(486,18427,18398,'78d',3.333,5),(486,18428,18398,'8d9',3.333,5),(487,18430,18429,'naa',100,5),(487,18431,18430,'600',3.333,5),(487,18432,18430,'000',3.333,5),(487,18433,18430,'00c',3.333,5),(487,18434,18430,'0c2',3.333,5),(487,18435,18430,'c29',3.333,5),(487,18436,18430,'29d',3.333,5),(487,18437,18430,'9d0',3.333,5),(487,18438,18430,'d04',3.333,5),(487,18439,18430,'04e',3.333,5),(487,18440,18430,'4ef',3.333,5),(487,18441,18430,'efa',3.333,5),(487,18442,18430,'fa8',3.333,5),(487,18443,18430,'a8f',3.333,5),(487,18444,18430,'8f2',3.333,5),(487,18445,18430,'f21',3.333,5),(487,18446,18430,'211',3.333,5),(487,18447,18430,'118',3.333,5),(487,18448,18430,'182',3.333,5),(487,18449,18430,'82c',3.333,5),(487,18450,18430,'2c9',3.333,5),(487,18451,18430,'c94',3.333,5),(487,18452,18430,'941',3.333,5),(487,18453,18430,'416',3.333,5),(487,18454,18430,'16e',3.333,5),(487,18455,18430,'6e1',3.333,5),(487,18456,18430,'e17',3.333,5),(487,18457,18430,'176',3.333,5),(487,18458,18430,'767',3.333,5),(487,18459,18430,'67c',3.333,5),(487,18460,18430,'7c0',3.333,5),(488,18462,18461,'naa',100,5),(488,18463,18462,'600',3.333,5),(488,18464,18462,'000',3.333,5),(488,18465,18462,'00c',3.333,5),(488,18466,18462,'0c2',3.333,5),(488,18467,18462,'c29',3.333,5),(488,18468,18462,'295',3.333,5),(488,18469,18462,'950',3.333,5),(488,18470,18462,'50c',3.333,5),(488,18471,18462,'0c1',3.333,5),(488,18472,18462,'c17',3.333,5),(488,18473,18462,'176',3.333,5),(488,18474,18462,'76d',3.333,5),(488,18475,18462,'6da',3.333,5),(488,18476,18462,'dac',3.333,5),(488,18477,18462,'ace',3.333,5),(488,18478,18462,'ced',3.333,5),(488,18479,18462,'ed3',3.333,5),(488,18480,18462,'d39',3.333,5),(488,18481,18462,'39c',3.333,5),(488,18482,18462,'9cb',3.333,5),(488,18483,18462,'cb8',3.333,5),(488,18484,18462,'b8e',3.333,5),(488,18485,18462,'8e1',3.333,5),(488,18486,18462,'e19',3.333,5),(488,18487,18462,'19a',3.333,5),(488,18488,18462,'9a5',3.333,5),(488,18489,18462,'a55',3.333,5),(488,18490,18462,'55c',3.333,5),(488,18491,18462,'5cc',3.333,5),(488,18492,18462,'cce',3.333,5),(489,18494,18493,'naa',100,5),(489,18495,18494,'600',3.333,5),(489,18496,18494,'000',3.333,5),(489,18497,18494,'00c',3.333,5),(489,18498,18494,'0c2',3.333,5),(489,18499,18494,'c29',3.333,5),(489,18500,18494,'29d',3.333,5),(489,18501,18494,'9dc',3.333,5),(489,18502,18494,'dc5',3.333,5),(489,18503,18494,'c5f',3.333,5),(489,18504,18494,'5fc',3.333,5),(489,18505,18494,'fc4',3.333,5),(489,18506,18494,'c46',3.333,5),(489,18507,18494,'46b',3.333,5),(489,18508,18494,'6b4',3.333,5),(489,18509,18494,'b44',3.333,5),(489,18510,18494,'447',3.333,5),(489,18511,18494,'479',3.333,5),(489,18512,18494,'795',3.333,5),(489,18513,18494,'95b',3.333,5),(489,18514,18494,'5bd',3.333,5),(489,18515,18494,'bde',3.333,5),(489,18516,18494,'deb',3.333,5),(489,18517,18494,'eb2',3.333,5),(489,18518,18494,'b24',3.333,5),(489,18519,18494,'241',3.333,5),(489,18520,18494,'41c',3.333,5),(489,18521,18494,'1c2',3.333,5),(489,18522,18494,'c2b',3.333,5),(489,18523,18494,'2bc',3.333,5),(489,18524,18494,'bcb',3.333,5),(490,18526,18525,'naa',100,5),(490,18527,18526,'600',3.333,5),(490,18528,18526,'000',3.333,5),(490,18529,18526,'00c',3.333,5),(490,18530,18526,'0c2',3.333,5),(490,18531,18526,'c29',3.333,5),(490,18532,18526,'298',3.333,5),(490,18533,18526,'980',3.333,5),(490,18534,18526,'807',3.333,5),(490,18535,18526,'071',3.333,5),(490,18536,18526,'718',3.333,5),(490,18537,18526,'18d',3.333,5),(490,18538,18526,'8d4',3.333,5),(490,18539,18526,'d46',3.333,5),(490,18540,18526,'464',3.333,5),(490,18541,18526,'640',3.333,5),(490,18542,18526,'40b',3.333,5),(490,18543,18526,'0b8',3.333,5),(490,18544,18526,'b87',3.333,5),(490,18545,18526,'87f',3.333,5),(490,18546,18526,'7ff',3.333,5),(490,18547,18526,'ff8',3.333,5),(490,18548,18526,'f80',3.333,5),(490,18549,18526,'805',3.333,5),(490,18550,18526,'05b',3.333,5),(490,18551,18526,'5b1',3.333,5),(490,18552,18526,'b1b',3.333,5),(490,18553,18526,'1ba',3.333,5),(490,18554,18526,'baa',3.333,5),(490,18555,18526,'aae',3.333,5),(490,18556,18526,'ae5',3.333,5),(491,18558,18557,'naa',100,5),(491,18559,18558,'600',3.333,5),(491,18560,18558,'000',3.333,5),(491,18561,18558,'00c',3.333,5),(491,18562,18558,'0c2',3.333,5),(491,18563,18558,'c29',3.333,5),(491,18564,18558,'295',3.333,5),(491,18565,18558,'952',3.333,5),(491,18566,18558,'52a',3.333,5),(491,18567,18558,'2af',3.333,5),(491,18568,18558,'aff',3.333,5),(491,18569,18558,'ff7',3.333,5),(491,18570,18558,'f74',3.333,5),(491,18571,18558,'74f',3.333,5),(491,18572,18558,'4f3',3.333,5),(491,18573,18558,'f31',3.333,5),(491,18574,18558,'310',3.333,5),(491,18575,18558,'10e',3.333,5),(491,18576,18558,'0e6',3.333,5),(491,18577,18558,'e69',3.333,5),(491,18578,18558,'69d',3.333,5),(491,18579,18558,'9dc',3.333,5),(491,18580,18558,'dca',3.333,5),(491,18581,18558,'cac',3.333,5),(491,18582,18558,'acb',3.333,5),(491,18583,18558,'cb9',3.333,5),(491,18584,18558,'b93',3.333,5),(491,18585,18558,'938',3.333,5),(491,18586,18558,'38d',3.333,5),(491,18587,18558,'8d2',3.333,5),(491,18588,18558,'d2f',3.333,5),(492,18590,18589,'naa',100,5),(492,18591,18590,'600',3.333,5),(492,18592,18590,'000',3.333,5),(492,18593,18590,'00c',3.333,5),(492,18594,18590,'0c2',3.333,5),(492,18595,18590,'c29',3.333,5),(492,18596,18590,'292',3.333,5),(492,18597,18590,'92e',3.333,5),(492,18598,18590,'2e7',3.333,5),(492,18599,18590,'e7e',3.333,5),(492,18600,18590,'7ea',3.333,5),(492,18601,18590,'ea6',3.333,5),(492,18602,18590,'a6d',3.333,5),(492,18603,18590,'6d7',3.333,5),(492,18604,18590,'d75',3.333,5),(492,18605,18590,'754',3.333,5),(492,18606,18590,'54e',3.333,5),(492,18607,18590,'4e9',3.333,5),(492,18608,18590,'e93',3.333,5),(492,18609,18590,'936',3.333,5),(492,18610,18590,'364',3.333,5),(492,18611,18590,'64a',3.333,5),(492,18612,18590,'4ab',3.333,5),(492,18613,18590,'aba',3.333,5),(492,18614,18590,'ba8',3.333,5),(492,18615,18590,'a88',3.333,5),(492,18616,18590,'882',3.333,5),(492,18617,18590,'825',3.333,5),(492,18618,18590,'257',3.333,5),(492,18619,18590,'57d',3.333,5),(492,18620,18590,'7d6',3.333,5),(493,18622,18621,'naa',100,5),(493,18623,18622,'600',3.333,5),(493,18624,18622,'000',3.333,5),(493,18625,18622,'00c',3.333,5),(493,18626,18622,'0c2',3.333,5),(493,18627,18622,'c29',3.333,5),(493,18628,18622,'29e',3.333,5),(493,18629,18622,'9ea',3.333,5),(493,18630,18622,'eaf',3.333,5),(493,18631,18622,'afe',3.333,5),(493,18632,18622,'fe4',3.333,5),(493,18633,18622,'e4b',3.333,5),(493,18634,18622,'4b7',3.333,5),(493,18635,18622,'b71',3.333,5),(493,18636,18622,'71c',3.333,5),(493,18637,18622,'1cf',3.333,5),(493,18638,18622,'cf7',3.333,5),(493,18639,18622,'f73',3.333,5),(493,18640,18622,'739',3.333,5),(493,18641,18622,'397',3.333,5),(493,18642,18622,'979',3.333,5),(493,18643,18622,'794',3.333,5),(493,18644,18622,'947',3.333,5),(493,18645,18622,'472',3.333,5),(493,18646,18622,'727',3.333,5),(493,18647,18622,'274',3.333,5),(493,18648,18622,'745',3.333,5),(493,18649,18622,'45f',3.333,5),(493,18650,18622,'5f9',3.333,5),(493,18651,18622,'f9e',3.333,5),(493,18652,18622,'9e1',3.333,5),(494,18654,18653,'naa',100,5),(494,18655,18654,'600',3.333,5),(494,18656,18654,'000',3.333,5),(494,18657,18654,'00c',3.333,5),(494,18658,18654,'0c2',3.333,5),(494,18659,18654,'c29',3.333,5),(494,18660,18654,'297',3.333,5),(494,18661,18654,'976',3.333,5),(494,18662,18654,'769',3.333,5),(494,18663,18654,'695',3.333,5),(494,18664,18654,'95f',3.333,5),(494,18665,18654,'5f9',3.333,5),(494,18666,18654,'f97',3.333,5),(494,18667,18654,'97f',3.333,5),(494,18668,18654,'7f9',3.333,5),(494,18669,18654,'f9b',3.333,5),(494,18670,18654,'9bc',3.333,5),(494,18671,18654,'bc5',3.333,5),(494,18672,18654,'c51',3.333,5),(494,18673,18654,'51e',3.333,5),(494,18674,18654,'1e6',3.333,5),(494,18675,18654,'e6a',3.333,5),(494,18676,18654,'6ab',3.333,5),(494,18677,18654,'ab3',3.333,5),(494,18678,18654,'b3b',3.333,5),(494,18679,18654,'3bc',3.333,5),(494,18680,18654,'bcf',3.333,5),(494,18681,18654,'cfb',3.333,5),(494,18682,18654,'fb5',3.333,5),(494,18683,18654,'b55',3.333,5),(494,18684,18654,'556',3.333,5),(495,18686,18685,'naa',100,5),(495,18687,18686,'600',3.333,5),(495,18688,18686,'000',3.333,5),(495,18689,18686,'00c',3.333,5),(495,18690,18686,'0c2',3.333,5),(495,18691,18686,'c29',3.333,5),(495,18692,18686,'299',3.333,5),(495,18693,18686,'998',3.333,5),(495,18694,18686,'98f',3.333,5),(495,18695,18686,'8f8',3.333,5),(495,18696,18686,'f84',3.333,5),(495,18697,18686,'840',3.333,5),(495,18698,18686,'402',3.333,5),(495,18699,18686,'024',3.333,5),(495,18700,18686,'242',3.333,5),(495,18701,18686,'422',3.333,5),(495,18702,18686,'228',3.333,5),(495,18703,18686,'280',3.333,5),(495,18704,18686,'80b',3.333,5),(495,18705,18686,'0b6',3.333,5),(495,18706,18686,'b6e',3.333,5),(495,18707,18686,'6e3',3.333,5),(495,18708,18686,'e35',3.333,5),(495,18709,18686,'35d',3.333,5),(495,18710,18686,'5d0',3.333,5),(495,18711,18686,'d08',3.333,5),(495,18712,18686,'084',3.333,5),(495,18713,18686,'840',3.333,5),(495,18714,18686,'405',3.333,5),(495,18715,18686,'050',3.333,5),(495,18716,18686,'505',3.333,5),(496,18718,18717,'naa',100,5),(496,18719,18718,'600',3.333,5),(496,18720,18718,'000',3.333,5),(496,18721,18718,'00c',3.333,5),(496,18722,18718,'0c2',3.333,5),(496,18723,18718,'c29',3.333,5),(496,18724,18718,'292',3.333,5),(496,18725,18718,'92e',3.333,5),(496,18726,18718,'2ef',3.333,5),(496,18727,18718,'eff',3.333,5),(496,18728,18718,'ff8',3.333,5),(496,18729,18718,'f8c',3.333,5),(496,18730,18718,'8ce',3.333,5),(496,18731,18718,'cec',3.333,5),(496,18732,18718,'eca',3.333,5),(496,18733,18718,'cad',3.333,5),(496,18734,18718,'ad5',3.333,5),(496,18735,18718,'d50',3.333,5),(496,18736,18718,'500',3.333,5),(496,18737,18718,'001',3.333,5),(496,18738,18718,'01c',3.333,5),(496,18739,18718,'1c0',3.333,5),(496,18740,18718,'c09',3.333,5),(496,18741,18718,'090',3.333,5),(496,18742,18718,'906',3.333,5),(496,18743,18718,'068',3.333,5),(496,18744,18718,'684',3.333,5),(496,18745,18718,'842',3.333,5),(496,18746,18718,'42e',3.333,5),(496,18747,18718,'2e8',3.333,5),(496,18748,18718,'e87',3.333,5),(497,18750,18749,'naa',100,5),(497,18751,18750,'600',3.333,5),(497,18752,18750,'000',3.333,5),(497,18753,18750,'00c',3.333,5),(497,18754,18750,'0c2',3.333,5),(497,18755,18750,'c29',3.333,5),(497,18756,18750,'29a',3.333,5),(497,18757,18750,'9a3',3.333,5),(497,18758,18750,'a39',3.333,5),(497,18759,18750,'39d',3.333,5),(497,18760,18750,'9de',3.333,5),(497,18761,18750,'ded',3.333,5),(497,18762,18750,'ed4',3.333,5),(497,18763,18750,'d41',3.333,5),(497,18764,18750,'41d',3.333,5),(497,18765,18750,'1de',3.333,5),(497,18766,18750,'de2',3.333,5),(497,18767,18750,'e2e',3.333,5),(497,18768,18750,'2ea',3.333,5),(497,18769,18750,'eac',3.333,5),(497,18770,18750,'ac7',3.333,5),(497,18771,18750,'c70',3.333,5),(497,18772,18750,'701',3.333,5),(497,18773,18750,'019',3.333,5),(497,18774,18750,'19e',3.333,5),(497,18775,18750,'9e3',3.333,5),(497,18776,18750,'e34',3.333,5),(497,18777,18750,'34e',3.333,5),(497,18778,18750,'4e4',3.333,5),(497,18779,18750,'e42',3.333,5),(497,18780,18750,'426',3.333,5),(498,18782,18781,'naa',100,5),(498,18783,18782,'600',3.333,5),(498,18784,18782,'000',3.333,5),(498,18785,18782,'00c',3.333,5),(498,18786,18782,'0c2',3.333,5),(498,18787,18782,'c29',3.333,5),(498,18788,18782,'298',3.333,5),(498,18789,18782,'988',3.333,5),(498,18790,18782,'889',3.333,5),(498,18791,18782,'89b',3.333,5),(498,18792,18782,'9b8',3.333,5),(498,18793,18782,'b8c',3.333,5),(498,18794,18782,'8ce',3.333,5),(498,18795,18782,'ce3',3.333,5),(498,18796,18782,'e3a',3.333,5),(498,18797,18782,'3ab',3.333,5),(498,18798,18782,'ab8',3.333,5),(498,18799,18782,'b87',3.333,5),(498,18800,18782,'879',3.333,5),(498,18801,18782,'791',3.333,5),(498,18802,18782,'913',3.333,5),(498,18803,18782,'132',3.333,5),(498,18804,18782,'32f',3.333,5),(498,18805,18782,'2fb',3.333,5),(498,18806,18782,'fb2',3.333,5),(498,18807,18782,'b22',3.333,5),(498,18808,18782,'22a',3.333,5),(498,18809,18782,'2ab',3.333,5),(498,18810,18782,'ab3',3.333,5),(498,18811,18782,'b3a',3.333,5),(498,18812,18782,'3ae',3.333,5),(499,18814,18813,'naa',100,5),(499,18815,18814,'600',3.333,5),(499,18816,18814,'000',3.333,5),(499,18817,18814,'00c',3.333,5),(499,18818,18814,'0c2',3.333,5),(499,18819,18814,'c29',3.333,5),(499,18820,18814,'293',3.333,5),(499,18821,18814,'93b',3.333,5),(499,18822,18814,'3bd',3.333,5),(499,18823,18814,'bd0',3.333,5),(499,18824,18814,'d0a',3.333,5),(499,18825,18814,'0ae',3.333,5),(499,18826,18814,'ae1',3.333,5),(499,18827,18814,'e13',3.333,5),(499,18828,18814,'133',3.333,5),(499,18829,18814,'330',3.333,5),(499,18830,18814,'306',3.333,5),(499,18831,18814,'063',3.333,5),(499,18832,18814,'633',3.333,5),(499,18833,18814,'339',3.333,5),(499,18834,18814,'395',3.333,5),(499,18835,18814,'95b',3.333,5),(499,18836,18814,'5b9',3.333,5),(499,18837,18814,'b98',3.333,5),(499,18838,18814,'985',3.333,5),(499,18839,18814,'852',3.333,5),(499,18840,18814,'525',3.333,5),(499,18841,18814,'259',3.333,5),(499,18842,18814,'599',3.333,5),(499,18843,18814,'99d',3.333,5),(499,18844,18814,'9d9',3.333,5),(500,18846,18845,'naa',100,5),(500,18847,18846,'600',3.333,5),(500,18848,18846,'000',3.333,5),(500,18849,18846,'00c',3.333,5),(500,18850,18846,'0c2',3.333,5),(500,18851,18846,'c29',3.333,5),(500,18852,18846,'29f',3.333,5),(500,18853,18846,'9fe',3.333,5),(500,18854,18846,'fe6',3.333,5),(500,18855,18846,'e6a',3.333,5),(500,18856,18846,'6af',3.333,5),(500,18857,18846,'af6',3.333,5),(500,18858,18846,'f6e',3.333,5),(500,18859,18846,'6e6',3.333,5),(500,18860,18846,'e68',3.333,5),(500,18861,18846,'689',3.333,5),(500,18862,18846,'89f',3.333,5),(500,18863,18846,'9fe',3.333,5),(500,18864,18846,'fe2',3.333,5),(500,18865,18846,'e22',3.333,5),(500,18866,18846,'223',3.333,5),(500,18867,18846,'23d',3.333,5),(500,18868,18846,'3d0',3.333,5),(500,18869,18846,'d09',3.333,5),(500,18870,18846,'09a',3.333,5),(500,18871,18846,'9a2',3.333,5),(500,18872,18846,'a26',3.333,5),(500,18873,18846,'26c',3.333,5),(500,18874,18846,'6cb',3.333,5),(500,18875,18846,'cb3',3.333,5),(500,18876,18846,'b3b',3.333,5),(501,18878,18877,'naa',100,5),(501,18879,18878,'600',3.333,5),(501,18880,18878,'000',3.333,5),(501,18881,18878,'00c',3.333,5),(501,18882,18878,'0c2',3.333,5),(501,18883,18878,'c29',3.333,5),(501,18884,18878,'298',3.333,5),(501,18885,18878,'98f',3.333,5),(501,18886,18878,'8f8',3.333,5),(501,18887,18878,'f88',3.333,5),(501,18888,18878,'880',3.333,5),(501,18889,18878,'809',3.333,5),(501,18890,18878,'094',3.333,5),(501,18891,18878,'945',3.333,5),(501,18892,18878,'453',3.333,5),(501,18893,18878,'53b',3.333,5),(501,18894,18878,'3b3',3.333,5),(501,18895,18878,'b3b',3.333,5),(501,18896,18878,'3bb',3.333,5),(501,18897,18878,'bb1',3.333,5),(501,18898,18878,'b18',3.333,5),(501,18899,18878,'188',3.333,5),(501,18900,18878,'886',3.333,5),(501,18901,18878,'86f',3.333,5),(501,18902,18878,'6f1',3.333,5),(501,18903,18878,'f1d',3.333,5),(501,18904,18878,'1dd',3.333,5),(501,18905,18878,'dd1',3.333,5),(501,18906,18878,'d1a',3.333,5),(501,18907,18878,'1a1',3.333,5),(501,18908,18878,'a1f',3.333,5),(502,18910,18909,'naa',100,5),(502,18911,18910,'600',3.333,5),(502,18912,18910,'000',3.333,5),(502,18913,18910,'00c',3.333,5),(502,18914,18910,'0c2',3.333,5),(502,18915,18910,'c29',3.333,5),(502,18916,18910,'296',3.333,5),(502,18917,18910,'962',3.333,5),(502,18918,18910,'625',3.333,5),(502,18919,18910,'254',3.333,5),(502,18920,18910,'542',3.333,5),(502,18921,18910,'427',3.333,5),(502,18922,18910,'27a',3.333,5),(502,18923,18910,'7a3',3.333,5),(502,18924,18910,'a3e',3.333,5),(502,18925,18910,'3e2',3.333,5),(502,18926,18910,'e24',3.333,5),(502,18927,18910,'243',3.333,5),(502,18928,18910,'437',3.333,5),(502,18929,18910,'372',3.333,5),(502,18930,18910,'721',3.333,5),(502,18931,18910,'217',3.333,5),(502,18932,18910,'176',3.333,5),(502,18933,18910,'760',3.333,5),(502,18934,18910,'60c',3.333,5),(502,18935,18910,'0c8',3.333,5),(502,18936,18910,'c88',3.333,5),(502,18937,18910,'88d',3.333,5),(502,18938,18910,'8d3',3.333,5),(502,18939,18910,'d30',3.333,5),(502,18940,18910,'306',3.333,5),(503,18942,18941,'naa',100,5),(503,18943,18942,'600',3.333,5),(503,18944,18942,'000',3.333,5),(503,18945,18942,'00c',3.333,5),(503,18946,18942,'0c2',3.333,5),(503,18947,18942,'c29',3.333,5),(503,18948,18942,'298',3.333,5),(503,18949,18942,'98e',3.333,5),(503,18950,18942,'8e6',3.333,5),(503,18951,18942,'e66',3.333,5),(503,18952,18942,'66d',3.333,5),(503,18953,18942,'6d0',3.333,5),(503,18954,18942,'d04',3.333,5),(503,18955,18942,'040',3.333,5),(503,18956,18942,'40f',3.333,5),(503,18957,18942,'0f6',3.333,5),(503,18958,18942,'f64',3.333,5),(503,18959,18942,'640',3.333,5),(503,18960,18942,'407',3.333,5),(503,18961,18942,'07b',3.333,5),(503,18962,18942,'7b6',3.333,5),(503,18963,18942,'b68',3.333,5),(503,18964,18942,'68e',3.333,5),(503,18965,18942,'8e0',3.333,5),(503,18966,18942,'e09',3.333,5),(503,18967,18942,'099',3.333,5),(503,18968,18942,'99c',3.333,5),(503,18969,18942,'9c7',3.333,5),(503,18970,18942,'c7c',3.333,5),(503,18971,18942,'7cc',3.333,5),(503,18972,18942,'cc2',3.333,5),(504,18974,18973,'naa',100,5),(504,18975,18974,'600',3.333,5),(504,18976,18974,'000',3.333,5),(504,18977,18974,'00c',3.333,5),(504,18978,18974,'0c2',3.333,5),(504,18979,18974,'c29',3.333,5),(504,18980,18974,'298',3.333,5),(504,18981,18974,'98a',3.333,5),(504,18982,18974,'8a2',3.333,5),(504,18983,18974,'a25',3.333,5),(504,18984,18974,'254',3.333,5),(504,18985,18974,'541',3.333,5),(504,18986,18974,'412',3.333,5),(504,18987,18974,'123',3.333,5),(504,18988,18974,'238',3.333,5),(504,18989,18974,'38d',3.333,5),(504,18990,18974,'8d7',3.333,5),(504,18991,18974,'d78',3.333,5),(504,18992,18974,'788',3.333,5),(504,18993,18974,'88c',3.333,5),(504,18994,18974,'8cb',3.333,5),(504,18995,18974,'cbb',3.333,5),(504,18996,18974,'bb9',3.333,5),(504,18997,18974,'b96',3.333,5),(504,18998,18974,'96c',3.333,5),(504,18999,18974,'6c8',3.333,5),(504,19000,18974,'c8f',3.333,5),(504,19001,18974,'8fe',3.333,5),(504,19002,18974,'fe7',3.333,5),(504,19003,18974,'e7f',3.333,5),(504,19004,18974,'7f0',3.333,5),(505,19006,19005,'naa',100,5),(505,19007,19006,'600',3.333,5),(505,19008,19006,'000',3.333,5),(505,19009,19006,'00c',3.333,5),(505,19010,19006,'0c2',3.333,5),(505,19011,19006,'c29',3.333,5),(505,19012,19006,'295',3.333,5),(505,19013,19006,'95a',3.333,5),(505,19014,19006,'5ad',3.333,5),(505,19015,19006,'adc',3.333,5),(505,19016,19006,'dcf',3.333,5),(505,19017,19006,'cf4',3.333,5),(505,19018,19006,'f47',3.333,5),(505,19019,19006,'475',3.333,5),(505,19020,19006,'751',3.333,5),(505,19021,19006,'515',3.333,5),(505,19022,19006,'15b',3.333,5),(505,19023,19006,'5bb',3.333,5),(505,19024,19006,'bb2',3.333,5),(505,19025,19006,'b2a',3.333,5),(505,19026,19006,'2ac',3.333,5),(505,19027,19006,'ac6',3.333,5),(505,19028,19006,'c64',3.333,5),(505,19029,19006,'64a',3.333,5),(505,19030,19006,'4aa',3.333,5),(505,19031,19006,'aa6',3.333,5),(505,19032,19006,'a68',3.333,5),(505,19033,19006,'689',3.333,5),(505,19034,19006,'894',3.333,5),(505,19035,19006,'943',3.333,5),(505,19036,19006,'437',3.333,5),(506,19038,19037,'naa',100,5),(506,19039,19038,'600',3.333,5),(506,19040,19038,'000',3.333,5),(506,19041,19038,'00c',3.333,5),(506,19042,19038,'0c2',3.333,5),(506,19043,19038,'c29',3.333,5),(506,19044,19038,'296',3.333,5),(506,19045,19038,'966',3.333,5),(506,19046,19038,'664',3.333,5),(506,19047,19038,'644',3.333,5),(506,19048,19038,'44a',3.333,5),(506,19049,19038,'4a5',3.333,5),(506,19050,19038,'a5b',3.333,5),(506,19051,19038,'5bb',3.333,5),(506,19052,19038,'bb9',3.333,5),(506,19053,19038,'b97',3.333,5),(506,19054,19038,'970',3.333,5),(506,19055,19038,'70e',3.333,5),(506,19056,19038,'0eb',3.333,5),(506,19057,19038,'eba',3.333,5),(506,19058,19038,'ba9',3.333,5),(506,19059,19038,'a98',3.333,5),(506,19060,19038,'985',3.333,5),(506,19061,19038,'850',3.333,5),(506,19062,19038,'50a',3.333,5),(506,19063,19038,'0a0',3.333,5),(506,19064,19038,'a03',3.333,5),(506,19065,19038,'035',3.333,5),(506,19066,19038,'35b',3.333,5),(506,19067,19038,'5b0',3.333,5),(506,19068,19038,'b0a',3.333,5),(507,19070,19069,'naa',100,5),(507,19071,19070,'600',3.333,5),(507,19072,19070,'000',3.333,5),(507,19073,19070,'00c',3.333,5),(507,19074,19070,'0c2',3.333,5),(507,19075,19070,'c29',3.333,5),(507,19076,19070,'292',3.333,5),(507,19077,19070,'928',3.333,5),(507,19078,19070,'288',3.333,5),(507,19079,19070,'889',3.333,5),(507,19080,19070,'899',3.333,5),(507,19081,19070,'997',3.333,5),(507,19082,19070,'97a',3.333,5),(507,19083,19070,'7a1',3.333,5),(507,19084,19070,'a1a',3.333,5),(507,19085,19070,'1a6',3.333,5),(507,19086,19070,'a68',3.333,5),(507,19087,19070,'686',3.333,5),(507,19088,19070,'86f',3.333,5),(507,19089,19070,'6f8',3.333,5),(507,19090,19070,'f82',3.333,5),(507,19091,19070,'826',3.333,5),(507,19092,19070,'263',3.333,5),(507,19093,19070,'632',3.333,5),(507,19094,19070,'326',3.333,5),(507,19095,19070,'26d',3.333,5),(507,19096,19070,'6df',3.333,5),(507,19097,19070,'dff',3.333,5),(507,19098,19070,'ffa',3.333,5),(507,19099,19070,'fac',3.333,5),(507,19100,19070,'acd',3.333,5),(508,19102,19101,'naa',100,5),(508,19103,19102,'600',3.333,5),(508,19104,19102,'000',3.333,5),(508,19105,19102,'00c',3.333,5),(508,19106,19102,'0c2',3.333,5),(508,19107,19102,'c29',3.333,5),(508,19108,19102,'295',3.333,5),(508,19109,19102,'959',3.333,5),(508,19110,19102,'597',3.333,5),(508,19111,19102,'972',3.333,5),(508,19112,19102,'72e',3.333,5),(508,19113,19102,'2ed',3.333,5),(508,19114,19102,'ed7',3.333,5),(508,19115,19102,'d7c',3.333,5),(508,19116,19102,'7c6',3.333,5),(508,19117,19102,'c64',3.333,5),(508,19118,19102,'64e',3.333,5),(508,19119,19102,'4eb',3.333,5),(508,19120,19102,'eb4',3.333,5),(508,19121,19102,'b4e',3.333,5),(508,19122,19102,'4e8',3.333,5),(508,19123,19102,'e80',3.333,5),(508,19124,19102,'809',3.333,5),(508,19125,19102,'09d',3.333,5),(508,19126,19102,'9d4',3.333,5),(508,19127,19102,'d43',3.333,5),(508,19128,19102,'435',3.333,5),(508,19129,19102,'355',3.333,5),(508,19130,19102,'55e',3.333,5),(508,19131,19102,'5e9',3.333,5),(508,19132,19102,'e91',3.333,5),(509,19134,19133,'naa',100,5),(509,19135,19134,'600',3.333,5),(509,19136,19134,'000',3.333,5),(509,19137,19134,'00c',3.333,5),(509,19138,19134,'0c2',3.333,5),(509,19139,19134,'c29',3.333,5),(509,19140,19134,'291',3.333,5),(509,19141,19134,'91e',3.333,5),(509,19142,19134,'1e4',3.333,5),(509,19143,19134,'e46',3.333,5),(509,19144,19134,'46b',3.333,5),(509,19145,19134,'6b1',3.333,5),(509,19146,19134,'b12',3.333,5),(509,19147,19134,'125',3.333,5),(509,19148,19134,'25f',3.333,5),(509,19149,19134,'5f9',3.333,5),(509,19150,19134,'f9f',3.333,5),(509,19151,19134,'9f1',3.333,5),(509,19152,19134,'f16',3.333,5),(509,19153,19134,'16b',3.333,5),(509,19154,19134,'6b3',3.333,5),(509,19155,19134,'b31',3.333,5),(509,19156,19134,'314',3.333,5),(509,19157,19134,'14d',3.333,5),(509,19158,19134,'4d0',3.333,5),(509,19159,19134,'d0e',3.333,5),(509,19160,19134,'0ee',3.333,5),(509,19161,19134,'ee4',3.333,5),(509,19162,19134,'e46',3.333,5),(509,19163,19134,'46f',3.333,5),(509,19164,19134,'6fa',3.333,5),(510,19166,19165,'naa',100,5),(510,19167,19166,'600',3.333,5),(510,19168,19166,'000',3.333,5),(510,19169,19166,'00c',3.333,5),(510,19170,19166,'0c2',3.333,5),(510,19171,19166,'c29',3.333,5),(510,19172,19166,'298',3.333,5),(510,19173,19166,'980',3.333,5),(510,19174,19166,'801',3.333,5),(510,19175,19166,'015',3.333,5),(510,19176,19166,'151',3.333,5),(510,19177,19166,'51d',3.333,5),(510,19178,19166,'1d0',3.333,5),(510,19179,19166,'d0a',3.333,5),(510,19180,19166,'0a1',3.333,5),(510,19181,19166,'a19',3.333,5),(510,19182,19166,'19a',3.333,5),(510,19183,19166,'9a5',3.333,5),(510,19184,19166,'a59',3.333,5),(510,19185,19166,'59e',3.333,5),(510,19186,19166,'9e8',3.333,5),(510,19187,19166,'e81',3.333,5),(510,19188,19166,'81d',3.333,5),(510,19189,19166,'1d7',3.333,5),(510,19190,19166,'d7d',3.333,5),(510,19191,19166,'7d5',3.333,5),(510,19192,19166,'d58',3.333,5),(510,19193,19166,'589',3.333,5),(510,19194,19166,'892',3.333,5),(510,19195,19166,'92e',3.333,5),(510,19196,19166,'2eb',3.333,5),(511,19198,19197,'naa',100,5),(511,19199,19198,'600',3.333,5),(511,19200,19198,'000',3.333,5),(511,19201,19198,'00c',3.333,5),(511,19202,19198,'0c2',3.333,5),(511,19203,19198,'c29',3.333,5),(511,19204,19198,'29c',3.333,5),(511,19205,19198,'9cc',3.333,5),(511,19206,19198,'cc9',3.333,5),(511,19207,19198,'c9e',3.333,5),(511,19208,19198,'9ef',3.333,5),(511,19209,19198,'efd',3.333,5),(511,19210,19198,'fda',3.333,5),(511,19211,19198,'dad',3.333,5),(511,19212,19198,'ad2',3.333,5),(511,19213,19198,'d27',3.333,5),(511,19214,19198,'275',3.333,5),(511,19215,19198,'755',3.333,5),(511,19216,19198,'55b',3.333,5),(511,19217,19198,'5b3',3.333,5),(511,19218,19198,'b31',3.333,5),(511,19219,19198,'311',3.333,5),(511,19220,19198,'117',3.333,5),(511,19221,19198,'178',3.333,5),(511,19222,19198,'785',3.333,5),(511,19223,19198,'854',3.333,5),(511,19224,19198,'54b',3.333,5),(511,19225,19198,'4b1',3.333,5),(511,19226,19198,'b10',3.333,5),(511,19227,19198,'10b',3.333,5),(511,19228,19198,'0be',3.333,5),(512,19230,19229,'naa',100,5),(512,19231,19230,'600',3.333,5),(512,19232,19230,'000',3.333,5),(512,19233,19230,'00c',3.333,5),(512,19234,19230,'0c2',3.333,5),(512,19235,19230,'c29',3.333,5),(512,19236,19230,'29f',3.333,5),(512,19237,19230,'9fd',3.333,5),(512,19238,19230,'fda',3.333,5),(512,19239,19230,'dad',3.333,5),(512,19240,19230,'ad1',3.333,5),(512,19241,19230,'d13',3.333,5),(512,19242,19230,'130',3.333,5),(512,19243,19230,'300',3.333,5),(512,19244,19230,'000',3.333,5),(512,19245,19230,'009',3.333,5),(512,19246,19230,'09d',3.333,5),(512,19247,19230,'9d0',3.333,5),(512,19248,19230,'d07',3.333,5),(512,19249,19230,'07a',3.333,5),(512,19250,19230,'7ab',3.333,5),(512,19251,19230,'ab0',3.333,5),(512,19252,19230,'b02',3.333,5),(512,19253,19230,'021',3.333,5),(512,19254,19230,'21f',3.333,5),(512,19255,19230,'1f2',3.333,5),(512,19256,19230,'f2f',3.333,5),(512,19257,19230,'2f3',3.333,5),(512,19258,19230,'f39',3.333,5),(512,19259,19230,'390',3.333,5),(512,19260,19230,'90b',3.333,5),(513,19262,19261,'naa',100,5),(513,19263,19262,'600',3.333,5),(513,19264,19262,'000',3.333,5),(513,19265,19262,'00c',3.333,5),(513,19266,19262,'0c2',3.333,5),(513,19267,19262,'c29',3.333,5),(513,19268,19262,'297',3.333,5),(513,19269,19262,'977',3.333,5),(513,19270,19262,'774',3.333,5),(513,19271,19262,'74d',3.333,5),(513,19272,19262,'4da',3.333,5),(513,19273,19262,'dac',3.333,5),(513,19274,19262,'ac9',3.333,5),(513,19275,19262,'c90',3.333,5),(513,19276,19262,'904',3.333,5),(513,19277,19262,'047',3.333,5),(513,19278,19262,'471',3.333,5),(513,19279,19262,'714',3.333,5),(513,19280,19262,'14d',3.333,5),(513,19281,19262,'4dc',3.333,5),(513,19282,19262,'dce',3.333,5),(513,19283,19262,'cee',3.333,5),(513,19284,19262,'eef',3.333,5),(513,19285,19262,'ef0',3.333,5),(513,19286,19262,'f03',3.333,5),(513,19287,19262,'034',3.333,5),(513,19288,19262,'34d',3.333,5),(513,19289,19262,'4d2',3.333,5),(513,19290,19262,'d2e',3.333,5),(513,19291,19262,'2e3',3.333,5),(513,19292,19262,'e3e',3.333,5),(514,19294,19293,'naa',100,5),(514,19295,19294,'600',3.333,5),(514,19296,19294,'000',3.333,5),(514,19297,19294,'00c',3.333,5),(514,19298,19294,'0c2',3.333,5),(514,19299,19294,'c29',3.333,5),(514,19300,19294,'29c',3.333,5),(514,19301,19294,'9c8',3.333,5),(514,19302,19294,'c89',3.333,5),(514,19303,19294,'89d',3.333,5),(514,19304,19294,'9d4',3.333,5),(514,19305,19294,'d41',3.333,5),(514,19306,19294,'416',3.333,5),(514,19307,19294,'168',3.333,5),(514,19308,19294,'689',3.333,5),(514,19309,19294,'898',3.333,5),(514,19310,19294,'984',3.333,5),(514,19311,19294,'845',3.333,5),(514,19312,19294,'450',3.333,5),(514,19313,19294,'50d',3.333,5),(514,19314,19294,'0da',3.333,5),(514,19315,19294,'dab',3.333,5),(514,19316,19294,'abe',3.333,5),(514,19317,19294,'be9',3.333,5),(514,19318,19294,'e98',3.333,5),(514,19319,19294,'986',3.333,5),(514,19320,19294,'86f',3.333,5),(514,19321,19294,'6f0',3.333,5),(514,19322,19294,'f0e',3.333,5),(514,19323,19294,'0e9',3.333,5),(514,19324,19294,'e9b',3.333,5),(515,19326,19325,'naa',100,5),(515,19327,19326,'600',3.333,5),(515,19328,19326,'000',3.333,5),(515,19329,19326,'00c',3.333,5),(515,19330,19326,'0c2',3.333,5),(515,19331,19326,'c29',3.333,5),(515,19332,19326,'292',3.333,5),(515,19333,19326,'925',3.333,5),(515,19334,19326,'255',3.333,5),(515,19335,19326,'55d',3.333,5),(515,19336,19326,'5da',3.333,5),(515,19337,19326,'da6',3.333,5),(515,19338,19326,'a6e',3.333,5),(515,19339,19326,'6e4',3.333,5),(515,19340,19326,'e49',3.333,5),(515,19341,19326,'492',3.333,5),(515,19342,19326,'92b',3.333,5),(515,19343,19326,'2bc',3.333,5),(515,19344,19326,'bc9',3.333,5),(515,19345,19326,'c9d',3.333,5),(515,19346,19326,'9d5',3.333,5),(515,19347,19326,'d55',3.333,5),(515,19348,19326,'551',3.333,5),(515,19349,19326,'51b',3.333,5),(515,19350,19326,'1bd',3.333,5),(515,19351,19326,'bdf',3.333,5),(515,19352,19326,'dfe',3.333,5),(515,19353,19326,'fe1',3.333,5),(515,19354,19326,'e17',3.333,5),(515,19355,19326,'174',3.333,5),(515,19356,19326,'748',3.333,5),(516,19358,19357,'naa',100,5),(516,19359,19358,'600',3.333,5),(516,19360,19358,'000',3.333,5),(516,19361,19358,'00c',3.333,5),(516,19362,19358,'0c2',3.333,5),(516,19363,19358,'c29',3.333,5),(516,19364,19358,'29c',3.333,5),(516,19365,19358,'9c1',3.333,5),(516,19366,19358,'c15',3.333,5),(516,19367,19358,'15f',3.333,5),(516,19368,19358,'5f9',3.333,5),(516,19369,19358,'f92',3.333,5),(516,19370,19358,'925',3.333,5),(516,19371,19358,'25f',3.333,5),(516,19372,19358,'5f4',3.333,5),(516,19373,19358,'f48',3.333,5),(516,19374,19358,'48f',3.333,5),(516,19375,19358,'8fa',3.333,5),(516,19376,19358,'fa9',3.333,5),(516,19377,19358,'a9b',3.333,5),(516,19378,19358,'9b3',3.333,5),(516,19379,19358,'b3e',3.333,5),(516,19380,19358,'3e4',3.333,5),(516,19381,19358,'e48',3.333,5),(516,19382,19358,'488',3.333,5),(516,19383,19358,'889',3.333,5),(516,19384,19358,'89c',3.333,5),(516,19385,19358,'9c0',3.333,5),(516,19386,19358,'c03',3.333,5),(516,19387,19358,'037',3.333,5),(516,19388,19358,'379',3.333,5),(517,19390,19389,'naa',100,5),(517,19391,19390,'600',3.333,5),(517,19392,19390,'000',3.333,5),(517,19393,19390,'00c',3.333,5),(517,19394,19390,'0c2',3.333,5),(517,19395,19390,'c29',3.333,5),(517,19396,19390,'293',3.333,5),(517,19397,19390,'93f',3.333,5),(517,19398,19390,'3f8',3.333,5),(517,19399,19390,'f80',3.333,5),(517,19400,19390,'80f',3.333,5),(517,19401,19390,'0fe',3.333,5),(517,19402,19390,'fe9',3.333,5),(517,19403,19390,'e9e',3.333,5),(517,19404,19390,'9e8',3.333,5),(517,19405,19390,'e83',3.333,5),(517,19406,19390,'83d',3.333,5),(517,19407,19390,'3d5',3.333,5),(517,19408,19390,'d54',3.333,5),(517,19409,19390,'54e',3.333,5),(517,19410,19390,'4ec',3.333,5),(517,19411,19390,'ece',3.333,5),(517,19412,19390,'ce0',3.333,5),(517,19413,19390,'e0f',3.333,5),(517,19414,19390,'0fd',3.333,5),(517,19415,19390,'fd2',3.333,5),(517,19416,19390,'d2f',3.333,5),(517,19417,19390,'2fc',3.333,5),(517,19418,19390,'fc6',3.333,5),(517,19419,19390,'c6d',3.333,5),(517,19420,19390,'6d9',3.333,5),(518,19422,19421,'naa',100,5),(518,19423,19422,'600',3.333,5),(518,19424,19422,'000',3.333,5),(518,19425,19422,'00c',3.333,5),(518,19426,19422,'0c2',3.333,5),(518,19427,19422,'c29',3.333,5),(518,19428,19422,'298',3.333,5),(518,19429,19422,'98e',3.333,5),(518,19430,19422,'8e3',3.333,5),(518,19431,19422,'e30',3.333,5),(518,19432,19422,'302',3.333,5),(518,19433,19422,'02b',3.333,5),(518,19434,19422,'2ba',3.333,5),(518,19435,19422,'ba4',3.333,5),(518,19436,19422,'a4c',3.333,5),(518,19437,19422,'4c2',3.333,5),(518,19438,19422,'c24',3.333,5),(518,19439,19422,'24c',3.333,5),(518,19440,19422,'4cc',3.333,5),(518,19441,19422,'cc8',3.333,5),(518,19442,19422,'c8f',3.333,5),(518,19443,19422,'8fb',3.333,5),(518,19444,19422,'fb7',3.333,5),(518,19445,19422,'b72',3.333,5),(518,19446,19422,'726',3.333,5),(518,19447,19422,'263',3.333,5),(518,19448,19422,'63a',3.333,5),(518,19449,19422,'3aa',3.333,5),(518,19450,19422,'aa4',3.333,5),(518,19451,19422,'a4c',3.333,5),(518,19452,19422,'4c6',3.333,5),(519,19454,19453,'naa',100,5),(519,19455,19454,'600',3.333,5),(519,19456,19454,'000',3.333,5),(519,19457,19454,'00c',3.333,5),(519,19458,19454,'0c2',3.333,5),(519,19459,19454,'c29',3.333,5),(519,19460,19454,'29e',3.333,5),(519,19461,19454,'9e3',3.333,5),(519,19462,19454,'e3c',3.333,5),(519,19463,19454,'3c7',3.333,5),(519,19464,19454,'c70',3.333,5),(519,19465,19454,'70e',3.333,5),(519,19466,19454,'0e5',3.333,5),(519,19467,19454,'e53',3.333,5),(519,19468,19454,'53c',3.333,5),(519,19469,19454,'3cf',3.333,5),(519,19470,19454,'cf0',3.333,5),(519,19471,19454,'f01',3.333,5),(519,19472,19454,'012',3.333,5),(519,19473,19454,'121',3.333,5),(519,19474,19454,'215',3.333,5),(519,19475,19454,'15c',3.333,5),(519,19476,19454,'5cc',3.333,5),(519,19477,19454,'cc5',3.333,5),(519,19478,19454,'c52',3.333,5),(519,19479,19454,'524',3.333,5),(519,19480,19454,'243',3.333,5),(519,19481,19454,'433',3.333,5),(519,19482,19454,'331',3.333,5),(519,19483,19454,'31d',3.333,5),(519,19484,19454,'1d9',3.333,5),(520,19486,19485,'naa',100,5),(520,19487,19486,'600',3.333,5),(520,19488,19486,'000',3.333,5),(520,19489,19486,'00c',3.333,5),(520,19490,19486,'0c2',3.333,5),(520,19491,19486,'c29',3.333,5),(520,19492,19486,'294',3.333,5),(520,19493,19486,'949',3.333,5),(520,19494,19486,'49b',3.333,5),(520,19495,19486,'9bf',3.333,5),(520,19496,19486,'bf6',3.333,5),(520,19497,19486,'f61',3.333,5),(520,19498,19486,'61f',3.333,5),(520,19499,19486,'1f9',3.333,5),(520,19500,19486,'f97',3.333,5),(520,19501,19486,'978',3.333,5),(520,19502,19486,'78c',3.333,5),(520,19503,19486,'8c9',3.333,5),(520,19504,19486,'c9c',3.333,5),(520,19505,19486,'9cf',3.333,5),(520,19506,19486,'cf5',3.333,5),(520,19507,19486,'f55',3.333,5),(520,19508,19486,'559',3.333,5),(520,19509,19486,'594',3.333,5),(520,19510,19486,'947',3.333,5),(520,19511,19486,'474',3.333,5),(520,19512,19486,'74e',3.333,5),(520,19513,19486,'4ef',3.333,5),(520,19514,19486,'efa',3.333,5),(520,19515,19486,'faa',3.333,5),(520,19516,19486,'aaa',3.333,5),(521,19518,19517,'naa',100,5),(521,19519,19518,'600',3.333,5),(521,19520,19518,'000',3.333,5),(521,19521,19518,'00c',3.333,5),(521,19522,19518,'0c2',3.333,5),(521,19523,19518,'c29',3.333,5),(521,19524,19518,'29b',3.333,5),(521,19525,19518,'9b4',3.333,5),(521,19526,19518,'b44',3.333,5),(521,19527,19518,'440',3.333,5),(521,19528,19518,'40b',3.333,5),(521,19529,19518,'0b8',3.333,5),(521,19530,19518,'b86',3.333,5),(521,19531,19518,'86f',3.333,5),(521,19532,19518,'6f4',3.333,5),(521,19533,19518,'f41',3.333,5),(521,19534,19518,'419',3.333,5),(521,19535,19518,'194',3.333,5),(521,19536,19518,'942',3.333,5),(521,19537,19518,'42c',3.333,5),(521,19538,19518,'2cb',3.333,5),(521,19539,19518,'cb1',3.333,5),(521,19540,19518,'b1a',3.333,5),(521,19541,19518,'1a8',3.333,5),(521,19542,19518,'a87',3.333,5),(521,19543,19518,'871',3.333,5),(521,19544,19518,'719',3.333,5),(521,19545,19518,'19b',3.333,5),(521,19546,19518,'9b7',3.333,5),(521,19547,19518,'b73',3.333,5),(521,19548,19518,'736',3.333,5),(522,19550,19549,'naa',100,5),(522,19551,19550,'600',3.333,5),(522,19552,19550,'000',3.333,5),(522,19553,19550,'00c',3.333,5),(522,19554,19550,'0c2',3.333,5),(522,19555,19550,'c29',3.333,5),(522,19556,19550,'29c',3.333,5),(522,19557,19550,'9c2',3.333,5),(522,19558,19550,'c20',3.333,5),(522,19559,19550,'20b',3.333,5),(522,19560,19550,'0bb',3.333,5),(522,19561,19550,'bb6',3.333,5),(522,19562,19550,'b68',3.333,5),(522,19563,19550,'68b',3.333,5),(522,19564,19550,'8b2',3.333,5),(522,19565,19550,'b20',3.333,5),(522,19566,19550,'200',3.333,5),(522,19567,19550,'004',3.333,5),(522,19568,19550,'04d',3.333,5),(522,19569,19550,'4de',3.333,5),(522,19570,19550,'de0',3.333,5),(522,19571,19550,'e02',3.333,5),(522,19572,19550,'026',3.333,5),(522,19573,19550,'260',3.333,5),(522,19574,19550,'608',3.333,5),(522,19575,19550,'08b',3.333,5),(522,19576,19550,'8bd',3.333,5),(522,19577,19550,'bda',3.333,5),(522,19578,19550,'da3',3.333,5),(522,19579,19550,'a32',3.333,5),(522,19580,19550,'325',3.333,5),(523,19582,19581,'hgw',9.091,5),(523,19583,19581,'gw2',9.091,5),(523,19584,19581,'w2k',9.091,5),(523,19585,19581,'2k8',9.091,5),(523,19586,19581,'k8r',9.091,5),(523,19587,19581,'8r2',9.091,5),(523,19588,19581,'r23',9.091,5),(523,19589,19581,'232',9.091,5),(523,19590,19581,'32v',9.091,5),(523,19591,19581,'2vm',9.091,5),(523,19592,19581,'vm1',9.091,5),(524,19594,19593,'naa',100,5),(524,19595,19594,'600',3.333,5),(524,19596,19594,'000',3.333,5),(524,19597,19594,'00c',3.333,5),(524,19598,19594,'0c2',3.333,5),(524,19599,19594,'c29',3.333,5),(524,19600,19594,'293',3.333,5),(524,19601,19594,'93a',3.333,5),(524,19602,19594,'3a3',3.333,5),(524,19603,19594,'a33',3.333,5),(524,19604,19594,'337',3.333,5),(524,19605,19594,'37f',3.333,5),(524,19606,19594,'7fc',3.333,5),(524,19607,19594,'fcf',3.333,5),(524,19608,19594,'cf5',3.333,5),(524,19609,19594,'f57',3.333,5),(524,19610,19594,'57f',3.333,5),(524,19611,19594,'7f8',3.333,5),(524,19612,19594,'f8e',3.333,5),(524,19613,19594,'8ea',3.333,5),(524,19614,19594,'ea9',3.333,5),(524,19615,19594,'a97',3.333,5),(524,19616,19594,'976',3.333,5),(524,19617,19594,'762',3.333,5),(524,19618,19594,'623',3.333,5),(524,19619,19594,'230',3.333,5),(524,19620,19594,'309',3.333,5),(524,19621,19594,'09f',3.333,5),(524,19622,19594,'9fd',3.333,5),(524,19623,19594,'fd5',3.333,5),(524,19624,19594,'d54',3.333,5),(525,19626,19625,'naa',100,5),(525,19627,19626,'600',3.333,5),(525,19628,19626,'00a',3.333,5),(525,19629,19626,'0a0',3.333,5),(525,19630,19626,'a09',3.333,5),(525,19631,19626,'098',3.333,5),(525,19632,19626,'980',3.333,5),(525,19633,19626,'804',3.333,5),(525,19634,19626,'044',3.333,5),(525,19635,19626,'443',3.333,5),(525,19636,19626,'430',3.333,5),(525,19637,19626,'307',3.333,5),(525,19638,19626,'075',3.333,5),(525,19639,19626,'753',3.333,5),(525,19640,19626,'535',3.333,5),(525,19641,19626,'357',3.333,5),(525,19642,19626,'573',3.333,5),(525,19643,19626,'732',3.333,5),(525,19644,19626,'32b',3.333,5),(525,19645,19626,'2b3',3.333,5),(525,19646,19626,'b33',3.333,5),(525,19647,19626,'334',3.333,5),(525,19648,19626,'345',3.333,5),(525,19649,19626,'457',3.333,5),(525,19650,19626,'571',3.333,5),(525,19651,19626,'715',3.333,5),(525,19652,19626,'153',3.333,5),(525,19653,19626,'533',3.333,5),(525,19654,19626,'335',3.333,5),(525,19655,19626,'357',3.333,5),(525,19656,19626,'572',3.333,5),(526,19658,19657,'naa',100,5),(526,19659,19658,'600',3.333,5),(526,19660,19658,'00a',3.333,5),(526,19661,19658,'0a0',3.333,5),(526,19662,19658,'a09',3.333,5),(526,19663,19658,'098',3.333,5),(526,19664,19658,'980',3.333,5),(526,19665,19658,'804',3.333,5),(526,19666,19658,'044',3.333,5),(526,19667,19658,'443',3.333,5),(526,19668,19658,'430',3.333,5),(526,19669,19658,'307',3.333,5),(526,19670,19658,'072',3.333,5),(526,19671,19658,'725',3.333,5),(526,19672,19658,'259',3.333,5),(526,19673,19658,'593',3.333,5),(526,19674,19658,'931',3.333,5),(526,19675,19658,'313',3.333,5),(526,19676,19658,'13f',3.333,5),(526,19677,19658,'3f3',3.333,5),(526,19678,19658,'f33',3.333,5),(526,19679,19658,'334',3.333,5),(526,19680,19658,'345',3.333,5),(526,19681,19658,'455',3.333,5),(526,19682,19658,'556',3.333,5),(526,19683,19658,'563',3.333,5),(526,19684,19658,'639',3.333,5),(526,19685,19658,'393',3.333,5),(526,19686,19658,'934',3.333,5),(526,19687,19658,'343',3.333,5),(526,19688,19658,'436',3.333,5),(527,19690,19689,'naa',100,5),(527,19691,19690,'600',3.333,5),(527,19692,19690,'00a',3.333,5),(527,19693,19690,'0a0',3.333,5),(527,19694,19690,'a09',3.333,5),(527,19695,19690,'098',3.333,5),(527,19696,19690,'980',3.333,5),(527,19697,19690,'804',3.333,5),(527,19698,19690,'044',3.333,5),(527,19699,19690,'443',3.333,5),(527,19700,19690,'430',3.333,5),(527,19701,19690,'307',3.333,5),(527,19702,19690,'075',3.333,5),(527,19703,19690,'753',3.333,5),(527,19704,19690,'535',3.333,5),(527,19705,19690,'357',3.333,5),(527,19706,19690,'573',3.333,5),(527,19707,19690,'732',3.333,5),(527,19708,19690,'32b',3.333,5),(527,19709,19690,'2b3',3.333,5),(527,19710,19690,'b33',3.333,5),(527,19711,19690,'334',3.333,5),(527,19712,19690,'345',3.333,5),(527,19713,19690,'457',3.333,5),(527,19714,19690,'571',3.333,5),(527,19715,19690,'715',3.333,5),(527,19716,19690,'153',3.333,5),(527,19717,19690,'533',3.333,5),(527,19718,19690,'335',3.333,5),(527,19719,19690,'357',3.333,5),(527,19720,19690,'571',3.333,5),(528,19722,19721,'naa',100,5),(528,19723,19722,'600',3.333,5),(528,19724,19722,'00a',3.333,5),(528,19725,19722,'0a0',3.333,5),(528,19726,19722,'a09',3.333,5),(528,19727,19722,'098',3.333,5),(528,19728,19722,'980',3.333,5),(528,19729,19722,'804',3.333,5),(528,19730,19722,'044',3.333,5),(528,19731,19722,'443',3.333,5),(528,19732,19722,'430',3.333,5),(528,19733,19722,'307',3.333,5),(528,19734,19722,'072',3.333,5),(528,19735,19722,'725',3.333,5),(528,19736,19722,'259',3.333,5),(528,19737,19722,'593',3.333,5),(528,19738,19722,'931',3.333,5),(528,19739,19722,'313',3.333,5),(528,19740,19722,'13f',3.333,5),(528,19741,19722,'3f3',3.333,5),(528,19742,19722,'f33',3.333,5),(528,19743,19722,'334',3.333,5),(528,19744,19722,'345',3.333,5),(528,19745,19722,'455',3.333,5),(528,19746,19722,'556',3.333,5),(528,19747,19722,'563',3.333,5),(528,19748,19722,'639',3.333,5),(528,19749,19722,'393',3.333,5),(528,19750,19722,'934',3.333,5),(528,19751,19722,'343',3.333,5),(528,19752,19722,'435',3.333,5),(529,19754,19753,'naa',100,5),(529,19755,19754,'600',3.333,5),(529,19756,19754,'000',3.333,5),(529,19757,19754,'00c',3.333,5),(529,19758,19754,'0c2',3.333,5),(529,19759,19754,'c29',3.333,5),(529,19760,19754,'290',3.333,5),(529,19761,19754,'908',3.333,5),(529,19762,19754,'084',3.333,5),(529,19763,19754,'840',3.333,5),(529,19764,19754,'408',3.333,5),(529,19765,19754,'08d',3.333,5),(529,19766,19754,'8da',3.333,5),(529,19767,19754,'da1',3.333,5),(529,19768,19754,'a15',3.333,5),(529,19769,19754,'158',3.333,5),(529,19770,19754,'58a',3.333,5),(529,19771,19754,'8a5',3.333,5),(529,19772,19754,'a5c',3.333,5),(529,19773,19754,'5c3',3.333,5),(529,19774,19754,'c3b',3.333,5),(529,19775,19754,'3bf',3.333,5),(529,19776,19754,'bfb',3.333,5),(529,19777,19754,'fb6',3.333,5),(529,19778,19754,'b61',3.333,5),(529,19779,19754,'61c',3.333,5),(529,19780,19754,'1c0',3.333,5),(529,19781,19754,'c07',3.333,5),(529,19782,19754,'078',3.333,5),(529,19783,19754,'787',3.333,5),(529,19784,19754,'879',3.333,5),(530,19786,19785,'naa',100,5),(530,19787,19786,'600',3.333,5),(530,19788,19786,'000',3.333,5),(530,19789,19786,'00c',3.333,5),(530,19790,19786,'0c2',3.333,5),(530,19791,19786,'c29',3.333,5),(530,19792,19786,'29e',3.333,5),(530,19793,19786,'9ef',3.333,5),(530,19794,19786,'efa',3.333,5),(530,19795,19786,'faa',3.333,5),(530,19796,19786,'aa2',3.333,5),(530,19797,19786,'a27',3.333,5),(530,19798,19786,'27d',3.333,5),(530,19799,19786,'7da',3.333,5),(530,19800,19786,'da2',3.333,5),(530,19801,19786,'a23',3.333,5),(530,19802,19786,'235',3.333,5),(530,19803,19786,'35f',3.333,5),(530,19804,19786,'5fd',3.333,5),(530,19805,19786,'fda',3.333,5),(530,19806,19786,'da6',3.333,5),(530,19807,19786,'a64',3.333,5),(530,19808,19786,'642',3.333,5),(530,19809,19786,'42d',3.333,5),(530,19810,19786,'2d9',3.333,5),(530,19811,19786,'d90',3.333,5),(530,19812,19786,'90b',3.333,5),(530,19813,19786,'0b0',3.333,5),(530,19814,19786,'b09',3.333,5),(530,19815,19786,'098',3.333,5),(530,19816,19786,'98e',3.333,5),(531,19818,19817,'naa',100,5),(531,19819,19818,'600',3.333,5),(531,19820,19818,'000',3.333,5),(531,19821,19818,'00c',3.333,5),(531,19822,19818,'0c2',3.333,5),(531,19823,19818,'c29',3.333,5),(531,19824,19818,'298',3.333,5),(531,19825,19818,'984',3.333,5),(531,19826,19818,'84c',3.333,5),(531,19827,19818,'4c0',3.333,5),(531,19828,19818,'c02',3.333,5),(531,19829,19818,'024',3.333,5),(531,19830,19818,'245',3.333,5),(531,19831,19818,'45d',3.333,5),(531,19832,19818,'5d2',3.333,5),(531,19833,19818,'d26',3.333,5),(531,19834,19818,'266',3.333,5),(531,19835,19818,'661',3.333,5),(531,19836,19818,'616',3.333,5),(531,19837,19818,'169',3.333,5),(531,19838,19818,'69b',3.333,5),(531,19839,19818,'9b9',3.333,5),(531,19840,19818,'b96',3.333,5),(531,19841,19818,'968',3.333,5),(531,19842,19818,'686',3.333,5),(531,19843,19818,'86a',3.333,5),(531,19844,19818,'6a2',3.333,5),(531,19845,19818,'a2e',3.333,5),(531,19846,19818,'2e0',3.333,5),(531,19847,19818,'e0c',3.333,5),(531,19848,19818,'0c5',3.333,5),(532,19850,19849,'naa',100,5),(532,19851,19850,'600',3.333,5),(532,19852,19850,'000',3.333,5),(532,19853,19850,'00c',3.333,5),(532,19854,19850,'0c2',3.333,5),(532,19855,19850,'c29',3.333,5),(532,19856,19850,'296',3.333,5),(532,19857,19850,'968',3.333,5),(532,19858,19850,'682',3.333,5),(532,19859,19850,'82c',3.333,5),(532,19860,19850,'2c7',3.333,5),(532,19861,19850,'c74',3.333,5),(532,19862,19850,'740',3.333,5),(532,19863,19850,'40d',3.333,5),(532,19864,19850,'0d6',3.333,5),(532,19865,19850,'d63',3.333,5),(532,19866,19850,'63a',3.333,5),(532,19867,19850,'3af',3.333,5),(532,19868,19850,'afb',3.333,5),(532,19869,19850,'fb5',3.333,5),(532,19870,19850,'b53',3.333,5),(532,19871,19850,'534',3.333,5),(532,19872,19850,'346',3.333,5),(532,19873,19850,'463',3.333,5),(532,19874,19850,'636',3.333,5),(532,19875,19850,'367',3.333,5),(532,19876,19850,'670',3.333,5),(532,19877,19850,'704',3.333,5),(532,19878,19850,'046',3.333,5),(532,19879,19850,'466',3.333,5),(532,19880,19850,'664',3.333,5),(533,19882,19881,'naa',100,5),(533,19883,19882,'600',3.333,5),(533,19884,19882,'000',3.333,5),(533,19885,19882,'00c',3.333,5),(533,19886,19882,'0c2',3.333,5),(533,19887,19882,'c29',3.333,5),(533,19888,19882,'29c',3.333,5),(533,19889,19882,'9c7',3.333,5),(533,19890,19882,'c77',3.333,5),(533,19891,19882,'778',3.333,5),(533,19892,19882,'782',3.333,5),(533,19893,19882,'825',3.333,5),(533,19894,19882,'256',3.333,5),(533,19895,19882,'56e',3.333,5),(533,19896,19882,'6eb',3.333,5),(533,19897,19882,'eb8',3.333,5),(533,19898,19882,'b8f',3.333,5),(533,19899,19882,'8f4',3.333,5),(533,19900,19882,'f4b',3.333,5),(533,19901,19882,'4b6',3.333,5),(533,19902,19882,'b6c',3.333,5),(533,19903,19882,'6c1',3.333,5),(533,19904,19882,'c1a',3.333,5),(533,19905,19882,'1a1',3.333,5),(533,19906,19882,'a1d',3.333,5),(533,19907,19882,'1dc',3.333,5),(533,19908,19882,'dce',3.333,5),(533,19909,19882,'ce5',3.333,5),(533,19910,19882,'e5f',3.333,5),(533,19911,19882,'5fc',3.333,5),(533,19912,19882,'fcb',3.333,5),(534,19914,19913,'naa',100,5),(534,19915,19914,'600',3.333,5),(534,19916,19914,'000',3.333,5),(534,19917,19914,'00c',3.333,5),(534,19918,19914,'0c2',3.333,5),(534,19919,19914,'c29',3.333,5),(534,19920,19914,'296',3.333,5),(534,19921,19914,'968',3.333,5),(534,19922,19914,'683',3.333,5),(534,19923,19914,'839',3.333,5),(534,19924,19914,'39c',3.333,5),(534,19925,19914,'9ce',3.333,5),(534,19926,19914,'ce8',3.333,5),(534,19927,19914,'e8d',3.333,5),(534,19928,19914,'8de',3.333,5),(534,19929,19914,'de1',3.333,5),(534,19930,19914,'e1e',3.333,5),(534,19931,19914,'1e6',3.333,5),(534,19932,19914,'e69',3.333,5),(534,19933,19914,'698',3.333,5),(534,19934,19914,'98a',3.333,5),(534,19935,19914,'8a3',3.333,5),(534,19936,19914,'a38',3.333,5),(534,19937,19914,'38b',3.333,5),(534,19938,19914,'8b6',3.333,5),(534,19939,19914,'b6f',3.333,5),(534,19940,19914,'6fc',3.333,5),(534,19941,19914,'fc7',3.333,5),(534,19942,19914,'c71',3.333,5),(534,19943,19914,'717',3.333,5),(534,19944,19914,'173',3.333,5),(535,19946,19945,'naa',100,5),(535,19947,19946,'600',3.333,5),(535,19948,19946,'000',3.333,5),(535,19949,19946,'00c',3.333,5),(535,19950,19946,'0c2',3.333,5),(535,19951,19946,'c29',3.333,5),(535,19952,19946,'29b',3.333,5),(535,19953,19946,'9b1',3.333,5),(535,19954,19946,'b18',3.333,5),(535,19955,19946,'183',3.333,5),(535,19956,19946,'831',3.333,5),(535,19957,19946,'316',3.333,5),(535,19958,19946,'16a',3.333,5),(535,19959,19946,'6ab',3.333,5),(535,19960,19946,'ab1',3.333,5),(535,19961,19946,'b18',3.333,5),(535,19962,19946,'182',3.333,5),(535,19963,19946,'823',3.333,5),(535,19964,19946,'231',3.333,5),(535,19965,19946,'310',3.333,5),(535,19966,19946,'10d',3.333,5),(535,19967,19946,'0d0',3.333,5),(535,19968,19946,'d09',3.333,5),(535,19969,19946,'09e',3.333,5),(535,19970,19946,'9e0',3.333,5),(535,19971,19946,'e03',3.333,5),(535,19972,19946,'03d',3.333,5),(535,19973,19946,'3d2',3.333,5),(535,19974,19946,'d2b',3.333,5),(535,19975,19946,'2b2',3.333,5),(535,19976,19946,'b2a',3.333,5),(536,19978,19977,'naa',100,5),(536,19979,19978,'600',3.333,5),(536,19980,19978,'000',3.333,5),(536,19981,19978,'00c',3.333,5),(536,19982,19978,'0c2',3.333,5),(536,19983,19978,'c29',3.333,5),(536,19984,19978,'29f',3.333,5),(536,19985,19978,'9ff',3.333,5),(536,19986,19978,'ff0',3.333,5),(536,19987,19978,'f0e',3.333,5),(536,19988,19978,'0e8',3.333,5),(536,19989,19978,'e80',3.333,5),(536,19990,19978,'809',3.333,5),(536,19991,19978,'09d',3.333,5),(536,19992,19978,'9d5',3.333,5),(536,19993,19978,'d5b',3.333,5),(536,19994,19978,'5b2',3.333,5),(536,19995,19978,'b2a',3.333,5),(536,19996,19978,'2af',3.333,5),(536,19997,19978,'af0',3.333,5),(536,19998,19978,'f05',3.333,5),(536,19999,19978,'05c',3.333,5),(536,20000,19978,'5c5',3.333,5),(536,20001,19978,'c57',3.333,5),(536,20002,19978,'576',3.333,5),(536,20003,19978,'768',3.333,5),(536,20004,19978,'68c',3.333,5),(536,20005,19978,'8c5',3.333,5),(536,20006,19978,'c5c',3.333,5),(536,20007,19978,'5cf',3.333,5),(536,20008,19978,'cff',3.333,5),(537,20010,20009,'naa',100,5),(537,20011,20010,'600',3.333,5),(537,20012,20010,'000',3.333,5),(537,20013,20010,'00c',3.333,5),(537,20014,20010,'0c2',3.333,5),(537,20015,20010,'c29',3.333,5),(537,20016,20010,'299',3.333,5),(537,20017,20010,'997',3.333,5),(537,20018,20010,'97b',3.333,5),(537,20019,20010,'7b6',3.333,5),(537,20020,20010,'b69',3.333,5),(537,20021,20010,'696',3.333,5),(537,20022,20010,'962',3.333,5),(537,20023,20010,'62f',3.333,5),(537,20024,20010,'2f3',3.333,5),(537,20025,20010,'f32',3.333,5),(537,20026,20010,'32a',3.333,5),(537,20027,20010,'2a2',3.333,5),(537,20028,20010,'a26',3.333,5),(537,20029,20010,'26b',3.333,5),(537,20030,20010,'6b7',3.333,5),(537,20031,20010,'b73',3.333,5),(537,20032,20010,'73d',3.333,5),(537,20033,20010,'3da',3.333,5),(537,20034,20010,'da8',3.333,5),(537,20035,20010,'a8e',3.333,5),(537,20036,20010,'8e6',3.333,5),(537,20037,20010,'e61',3.333,5),(537,20038,20010,'611',3.333,5),(537,20039,20010,'111',3.333,5),(537,20040,20010,'119',3.333,5),(538,20042,20041,'naa',100,5),(538,20043,20042,'600',3.333,5),(538,20044,20042,'000',3.333,5),(538,20045,20042,'00c',3.333,5),(538,20046,20042,'0c2',3.333,5),(538,20047,20042,'c29',3.333,5),(538,20048,20042,'298',3.333,5),(538,20049,20042,'98c',3.333,5),(538,20050,20042,'8ce',3.333,5),(538,20051,20042,'ceb',3.333,5),(538,20052,20042,'eb3',3.333,5),(538,20053,20042,'b3a',3.333,5),(538,20054,20042,'3a9',3.333,5),(538,20055,20042,'a9e',3.333,5),(538,20056,20042,'9e5',3.333,5),(538,20057,20042,'e5a',3.333,5),(538,20058,20042,'5a4',3.333,5),(538,20059,20042,'a4b',3.333,5),(538,20060,20042,'4bd',3.333,5),(538,20061,20042,'bd6',3.333,5),(538,20062,20042,'d63',3.333,5),(538,20063,20042,'63b',3.333,5),(538,20064,20042,'3b8',3.333,5),(538,20065,20042,'b85',3.333,5),(538,20066,20042,'854',3.333,5),(538,20067,20042,'548',3.333,5),(538,20068,20042,'488',3.333,5),(538,20069,20042,'88b',3.333,5),(538,20070,20042,'8b9',3.333,5),(538,20071,20042,'b9e',3.333,5),(538,20072,20042,'9e6',3.333,5),(539,20074,20073,'naa',100,5),(539,20075,20074,'600',3.333,5),(539,20076,20074,'000',3.333,5),(539,20077,20074,'00c',3.333,5),(539,20078,20074,'0c2',3.333,5),(539,20079,20074,'c29',3.333,5),(539,20080,20074,'295',3.333,5),(539,20081,20074,'956',3.333,5),(539,20082,20074,'56b',3.333,5),(539,20083,20074,'6b7',3.333,5),(539,20084,20074,'b7d',3.333,5),(539,20085,20074,'7de',3.333,5),(539,20086,20074,'de2',3.333,5),(539,20087,20074,'e21',3.333,5),(539,20088,20074,'21f',3.333,5),(539,20089,20074,'1f1',3.333,5),(539,20090,20074,'f10',3.333,5),(539,20091,20074,'10d',3.333,5),(539,20092,20074,'0dd',3.333,5),(539,20093,20074,'dd9',3.333,5),(539,20094,20074,'d9f',3.333,5),(539,20095,20074,'9f2',3.333,5),(539,20096,20074,'f26',3.333,5),(539,20097,20074,'262',3.333,5),(539,20098,20074,'621',3.333,5),(539,20099,20074,'214',3.333,5),(539,20100,20074,'140',3.333,5),(539,20101,20074,'408',3.333,5),(539,20102,20074,'08e',3.333,5),(539,20103,20074,'8e5',3.333,5),(539,20104,20074,'e5a',3.333,5),(540,20106,20105,'naa',100,5),(540,20107,20106,'600',3.333,5),(540,20108,20106,'000',3.333,5),(540,20109,20106,'00c',3.333,5),(540,20110,20106,'0c2',3.333,5),(540,20111,20106,'c29',3.333,5),(540,20112,20106,'295',3.333,5),(540,20113,20106,'950',3.333,5),(540,20114,20106,'50d',3.333,5),(540,20115,20106,'0d4',3.333,5),(540,20116,20106,'d47',3.333,5),(540,20117,20106,'47c',3.333,5),(540,20118,20106,'7cd',3.333,5),(540,20119,20106,'cda',3.333,5),(540,20120,20106,'daa',3.333,5),(540,20121,20106,'aa9',3.333,5),(540,20122,20106,'a94',3.333,5),(540,20123,20106,'94a',3.333,5),(540,20124,20106,'4a6',3.333,5),(540,20125,20106,'a63',3.333,5),(540,20126,20106,'633',3.333,5),(540,20127,20106,'334',3.333,5),(540,20128,20106,'348',3.333,5),(540,20129,20106,'480',3.333,5),(540,20130,20106,'806',3.333,5),(540,20131,20106,'060',3.333,5),(540,20132,20106,'603',3.333,5),(540,20133,20106,'03d',3.333,5),(540,20134,20106,'3dd',3.333,5),(540,20135,20106,'dd7',3.333,5),(540,20136,20106,'d7e',3.333,5),(541,20138,20137,'naa',100,5),(541,20139,20138,'600',3.333,5),(541,20140,20138,'000',3.333,5),(541,20141,20138,'00c',3.333,5),(541,20142,20138,'0c2',3.333,5),(541,20143,20138,'c29',3.333,5),(541,20144,20138,'296',3.333,5),(541,20145,20138,'967',3.333,5),(541,20146,20138,'675',3.333,5),(541,20147,20138,'75d',3.333,5),(541,20148,20138,'5dd',3.333,5),(541,20149,20138,'dd7',3.333,5),(541,20150,20138,'d7a',3.333,5),(541,20151,20138,'7a7',3.333,5),(541,20152,20138,'a7e',3.333,5),(541,20153,20138,'7e9',3.333,5),(541,20154,20138,'e99',3.333,5),(541,20155,20138,'994',3.333,5),(541,20156,20138,'94b',3.333,5),(541,20157,20138,'4be',3.333,5),(541,20158,20138,'bee',3.333,5),(541,20159,20138,'eef',3.333,5),(541,20160,20138,'efc',3.333,5),(541,20161,20138,'fc8',3.333,5),(541,20162,20138,'c89',3.333,5),(541,20163,20138,'89f',3.333,5),(541,20164,20138,'9fb',3.333,5),(541,20165,20138,'fb5',3.333,5),(541,20166,20138,'b55',3.333,5),(541,20167,20138,'558',3.333,5),(541,20168,20138,'588',3.333,5),(542,20170,20169,'naa',100,5),(542,20171,20170,'600',3.333,5),(542,20172,20170,'000',3.333,5),(542,20173,20170,'00c',3.333,5),(542,20174,20170,'0c2',3.333,5),(542,20175,20170,'c29',3.333,5),(542,20176,20170,'29b',3.333,5),(542,20177,20170,'9bf',3.333,5),(542,20178,20170,'bf5',3.333,5),(542,20179,20170,'f5e',3.333,5),(542,20180,20170,'5e0',3.333,5),(542,20181,20170,'e02',3.333,5),(542,20182,20170,'027',3.333,5),(542,20183,20170,'27a',3.333,5),(542,20184,20170,'7a6',3.333,5),(542,20185,20170,'a66',3.333,5),(542,20186,20170,'66f',3.333,5),(542,20187,20170,'6f2',3.333,5),(542,20188,20170,'f21',3.333,5),(542,20189,20170,'21c',3.333,5),(542,20190,20170,'1c8',3.333,5),(542,20191,20170,'c82',3.333,5),(542,20192,20170,'82d',3.333,5),(542,20193,20170,'2dc',3.333,5),(542,20194,20170,'dcb',3.333,5),(542,20195,20170,'cb9',3.333,5),(542,20196,20170,'b90',3.333,5),(542,20197,20170,'90d',3.333,5),(542,20198,20170,'0d5',3.333,5),(542,20199,20170,'d5f',3.333,5),(542,20200,20170,'5f2',3.333,5),(543,20202,20201,'naa',100,5),(543,20203,20202,'600',3.333,5),(543,20204,20202,'000',3.333,5),(543,20205,20202,'00c',3.333,5),(543,20206,20202,'0c2',3.333,5),(543,20207,20202,'c29',3.333,5),(543,20208,20202,'290',3.333,5),(543,20209,20202,'909',3.333,5),(543,20210,20202,'095',3.333,5),(543,20211,20202,'953',3.333,5),(543,20212,20202,'53d',3.333,5),(543,20213,20202,'3db',3.333,5),(543,20214,20202,'dbf',3.333,5),(543,20215,20202,'bf4',3.333,5),(543,20216,20202,'f42',3.333,5),(543,20217,20202,'42f',3.333,5),(543,20218,20202,'2f2',3.333,5),(543,20219,20202,'f2b',3.333,5),(543,20220,20202,'2b9',3.333,5),(543,20221,20202,'b92',3.333,5),(543,20222,20202,'92e',3.333,5),(543,20223,20202,'2e4',3.333,5),(543,20224,20202,'e41',3.333,5),(543,20225,20202,'416',3.333,5),(543,20226,20202,'16d',3.333,5),(543,20227,20202,'6d9',3.333,5),(543,20228,20202,'d97',3.333,5),(543,20229,20202,'97f',3.333,5),(543,20230,20202,'7f3',3.333,5),(543,20231,20202,'f3d',3.333,5),(543,20232,20202,'3d6',3.333,5),(544,20234,20233,'naa',100,5),(544,20235,20234,'600',3.333,5),(544,20236,20234,'000',3.333,5),(544,20237,20234,'00c',3.333,5),(544,20238,20234,'0c2',3.333,5),(544,20239,20234,'c29',3.333,5),(544,20240,20234,'29d',3.333,5),(544,20241,20234,'9df',3.333,5),(544,20242,20234,'df6',3.333,5),(544,20243,20234,'f64',3.333,5),(544,20244,20234,'644',3.333,5),(544,20245,20234,'44d',3.333,5),(544,20246,20234,'4dc',3.333,5),(544,20247,20234,'dce',3.333,5),(544,20248,20234,'ce6',3.333,5),(544,20249,20234,'e63',3.333,5),(544,20250,20234,'63f',3.333,5),(544,20251,20234,'3fd',3.333,5),(544,20252,20234,'fd9',3.333,5),(544,20253,20234,'d96',3.333,5),(544,20254,20234,'960',3.333,5),(544,20255,20234,'60a',3.333,5),(544,20256,20234,'0a3',3.333,5),(544,20257,20234,'a3b',3.333,5),(544,20258,20234,'3bf',3.333,5),(544,20259,20234,'bf1',3.333,5),(544,20260,20234,'f12',3.333,5),(544,20261,20234,'12b',3.333,5),(544,20262,20234,'2b1',3.333,5),(544,20263,20234,'b1d',3.333,5),(544,20264,20234,'1d5',3.333,5),(545,20266,20265,'naa',100,5),(545,20267,20266,'600',3.333,5),(545,20268,20266,'000',3.333,5),(545,20269,20266,'00c',3.333,5),(545,20270,20266,'0c2',3.333,5),(545,20271,20266,'c29',3.333,5),(545,20272,20266,'294',3.333,5),(545,20273,20266,'94f',3.333,5),(545,20274,20266,'4f5',3.333,5),(545,20275,20266,'f5d',3.333,5),(545,20276,20266,'5dd',3.333,5),(545,20277,20266,'dd6',3.333,5),(545,20278,20266,'d6c',3.333,5),(545,20279,20266,'6c0',3.333,5),(545,20280,20266,'c07',3.333,5),(545,20281,20266,'075',3.333,5),(545,20282,20266,'75c',3.333,5),(545,20283,20266,'5c7',3.333,5),(545,20284,20266,'c76',3.333,5),(545,20285,20266,'769',3.333,5),(545,20286,20266,'69d',3.333,5),(545,20287,20266,'9db',3.333,5),(545,20288,20266,'db0',3.333,5),(545,20289,20266,'b03',3.333,5),(545,20290,20266,'031',3.333,5),(545,20291,20266,'311',3.333,5),(545,20292,20266,'11d',3.333,5),(545,20293,20266,'1d7',3.333,5),(545,20294,20266,'d79',3.333,5),(545,20295,20266,'791',3.333,5),(545,20296,20266,'918',3.333,5),(546,20298,20297,'naa',100,5),(546,20299,20298,'600',3.333,5),(546,20300,20298,'000',3.333,5),(546,20301,20298,'00c',3.333,5),(546,20302,20298,'0c2',3.333,5),(546,20303,20298,'c29',3.333,5),(546,20304,20298,'29e',3.333,5),(546,20305,20298,'9e9',3.333,5),(546,20306,20298,'e9e',3.333,5),(546,20307,20298,'9e8',3.333,5),(546,20308,20298,'e80',3.333,5),(546,20309,20298,'802',3.333,5),(546,20310,20298,'02f',3.333,5),(546,20311,20298,'2ff',3.333,5),(546,20312,20298,'ff9',3.333,5),(546,20313,20298,'f92',3.333,5),(546,20314,20298,'92a',3.333,5),(546,20315,20298,'2aa',3.333,5),(546,20316,20298,'aa3',3.333,5),(546,20317,20298,'a3e',3.333,5),(546,20318,20298,'3e9',3.333,5),(546,20319,20298,'e97',3.333,5),(546,20320,20298,'975',3.333,5),(546,20321,20298,'751',3.333,5),(546,20322,20298,'51b',3.333,5),(546,20323,20298,'1bb',3.333,5),(546,20324,20298,'bb1',3.333,5),(546,20325,20298,'b1c',3.333,5),(546,20326,20298,'1cc',3.333,5),(546,20327,20298,'ccf',3.333,5),(546,20328,20298,'cf8',3.333,5),(547,20330,20329,'naa',100,5),(547,20331,20330,'600',3.333,5),(547,20332,20330,'000',3.333,5),(547,20333,20330,'00c',3.333,5),(547,20334,20330,'0c2',3.333,5),(547,20335,20330,'c29',3.333,5),(547,20336,20330,'290',3.333,5),(547,20337,20330,'90d',3.333,5),(547,20338,20330,'0d6',3.333,5),(547,20339,20330,'d6a',3.333,5),(547,20340,20330,'6a7',3.333,5),(547,20341,20330,'a78',3.333,5),(547,20342,20330,'786',3.333,5),(547,20343,20330,'869',3.333,5),(547,20344,20330,'699',3.333,5),(547,20345,20330,'993',3.333,5),(547,20346,20330,'93a',3.333,5),(547,20347,20330,'3a2',3.333,5),(547,20348,20330,'a27',3.333,5),(547,20349,20330,'278',3.333,5),(547,20350,20330,'784',3.333,5),(547,20351,20330,'840',3.333,5),(547,20352,20330,'40b',3.333,5),(547,20353,20330,'0bc',3.333,5),(547,20354,20330,'bc7',3.333,5),(547,20355,20330,'c7e',3.333,5),(547,20356,20330,'7e7',3.333,5),(547,20357,20330,'e74',3.333,5),(547,20358,20330,'742',3.333,5),(547,20359,20330,'421',3.333,5),(547,20360,20330,'219',3.333,5),(548,20362,20361,'naa',100,5),(548,20363,20362,'600',3.333,5),(548,20364,20362,'000',3.333,5),(548,20365,20362,'00c',3.333,5),(548,20366,20362,'0c2',3.333,5),(548,20367,20362,'c29',3.333,5),(548,20368,20362,'292',3.333,5),(548,20369,20362,'92f',3.333,5),(548,20370,20362,'2f6',3.333,5),(548,20371,20362,'f66',3.333,5),(548,20372,20362,'663',3.333,5),(548,20373,20362,'633',3.333,5),(548,20374,20362,'33b',3.333,5),(548,20375,20362,'3bc',3.333,5),(548,20376,20362,'bcf',3.333,5),(548,20377,20362,'cff',3.333,5),(548,20378,20362,'ff2',3.333,5),(548,20379,20362,'f21',3.333,5),(548,20380,20362,'218',3.333,5),(548,20381,20362,'180',3.333,5),(548,20382,20362,'80b',3.333,5),(548,20383,20362,'0b7',3.333,5),(548,20384,20362,'b75',3.333,5),(548,20385,20362,'752',3.333,5),(548,20386,20362,'520',3.333,5),(548,20387,20362,'206',3.333,5),(548,20388,20362,'06f',3.333,5),(548,20389,20362,'6f0',3.333,5),(548,20390,20362,'f06',3.333,5),(548,20391,20362,'066',3.333,5),(548,20392,20362,'661',3.333,5),(549,20394,20393,'naa',100,5),(549,20395,20394,'600',3.333,5),(549,20396,20394,'000',3.333,5),(549,20397,20394,'00c',3.333,5),(549,20398,20394,'0c2',3.333,5),(549,20399,20394,'c29',3.333,5),(549,20400,20394,'296',3.333,5),(549,20401,20394,'961',3.333,5),(549,20402,20394,'61e',3.333,5),(549,20403,20394,'1e7',3.333,5),(549,20404,20394,'e79',3.333,5),(549,20405,20394,'793',3.333,5),(549,20406,20394,'93f',3.333,5),(549,20407,20394,'3fe',3.333,5),(549,20408,20394,'feb',3.333,5),(549,20409,20394,'ebf',3.333,5),(549,20410,20394,'bff',3.333,5),(549,20411,20394,'ff8',3.333,5),(549,20412,20394,'f84',3.333,5),(549,20413,20394,'84f',3.333,5),(549,20414,20394,'4f5',3.333,5),(549,20415,20394,'f5c',3.333,5),(549,20416,20394,'5ce',3.333,5),(549,20417,20394,'ced',3.333,5),(549,20418,20394,'ed5',3.333,5),(549,20419,20394,'d5c',3.333,5),(549,20420,20394,'5c5',3.333,5),(549,20421,20394,'c58',3.333,5),(549,20422,20394,'58b',3.333,5),(549,20423,20394,'8b2',3.333,5),(549,20424,20394,'b21',3.333,5),(550,20426,20425,'naa',100,5),(550,20427,20426,'600',3.333,5),(550,20428,20426,'000',3.333,5),(550,20429,20426,'00c',3.333,5),(550,20430,20426,'0c2',3.333,5),(550,20431,20426,'c29',3.333,5),(550,20432,20426,'29b',3.333,5),(550,20433,20426,'9bc',3.333,5),(550,20434,20426,'bc4',3.333,5),(550,20435,20426,'c48',3.333,5),(550,20436,20426,'48a',3.333,5),(550,20437,20426,'8a1',3.333,5),(550,20438,20426,'a17',3.333,5),(550,20439,20426,'170',3.333,5),(550,20440,20426,'708',3.333,5),(550,20441,20426,'080',3.333,5),(550,20442,20426,'800',3.333,5),(550,20443,20426,'006',3.333,5),(550,20444,20426,'060',3.333,5),(550,20445,20426,'60b',3.333,5),(550,20446,20426,'0b2',3.333,5),(550,20447,20426,'b2a',3.333,5),(550,20448,20426,'2a7',3.333,5),(550,20449,20426,'a7a',3.333,5),(550,20450,20426,'7a0',3.333,5),(550,20451,20426,'a04',3.333,5),(550,20452,20426,'040',3.333,5),(550,20453,20426,'400',3.333,5),(550,20454,20426,'002',3.333,5),(550,20455,20426,'02f',3.333,5),(550,20456,20426,'2fc',3.333,5),(551,20458,20457,'naa',100,5),(551,20459,20458,'600',3.333,5),(551,20460,20458,'000',3.333,5),(551,20461,20458,'00c',3.333,5),(551,20462,20458,'0c2',3.333,5),(551,20463,20458,'c29',3.333,5),(551,20464,20458,'291',3.333,5),(551,20465,20458,'912',3.333,5),(551,20466,20458,'121',3.333,5),(551,20467,20458,'21e',3.333,5),(551,20468,20458,'1e6',3.333,5),(551,20469,20458,'e66',3.333,5),(551,20470,20458,'66c',3.333,5),(551,20471,20458,'6c0',3.333,5),(551,20472,20458,'c0d',3.333,5),(551,20473,20458,'0d7',3.333,5),(551,20474,20458,'d79',3.333,5),(551,20475,20458,'79b',3.333,5),(551,20476,20458,'9b6',3.333,5),(551,20477,20458,'b62',3.333,5),(551,20478,20458,'623',3.333,5),(551,20479,20458,'23d',3.333,5),(551,20480,20458,'3de',3.333,5),(551,20481,20458,'de3',3.333,5),(551,20482,20458,'e30',3.333,5),(551,20483,20458,'305',3.333,5),(551,20484,20458,'052',3.333,5),(551,20485,20458,'52d',3.333,5),(551,20486,20458,'2d4',3.333,5),(551,20487,20458,'d40',3.333,5),(551,20488,20458,'405',3.333,5),(552,20490,20489,'naa',100,5),(552,20491,20490,'600',3.333,5),(552,20492,20490,'000',3.333,5),(552,20493,20490,'00c',3.333,5),(552,20494,20490,'0c2',3.333,5),(552,20495,20490,'c29',3.333,5),(552,20496,20490,'297',3.333,5),(552,20497,20490,'970',3.333,5),(552,20498,20490,'706',3.333,5),(552,20499,20490,'064',3.333,5),(552,20500,20490,'64a',3.333,5),(552,20501,20490,'4a1',3.333,5),(552,20502,20490,'a18',3.333,5),(552,20503,20490,'18d',3.333,5),(552,20504,20490,'8df',3.333,5),(552,20505,20490,'dfa',3.333,5),(552,20506,20490,'fa8',3.333,5),(552,20507,20490,'a88',3.333,5),(552,20508,20490,'88e',3.333,5),(552,20509,20490,'8ec',3.333,5),(552,20510,20490,'ece',3.333,5),(552,20511,20490,'ced',3.333,5),(552,20512,20490,'ed6',3.333,5),(552,20513,20490,'d6b',3.333,5),(552,20514,20490,'6be',3.333,5),(552,20515,20490,'be5',3.333,5),(552,20516,20490,'e50',3.333,5),(552,20517,20490,'50e',3.333,5),(552,20518,20490,'0e0',3.333,5),(552,20519,20490,'e05',3.333,5),(552,20520,20490,'057',3.333,5),(553,20522,20521,'naa',100,5),(553,20523,20522,'600',3.333,5),(553,20524,20522,'000',3.333,5),(553,20525,20522,'00c',3.333,5),(553,20526,20522,'0c2',3.333,5),(553,20527,20522,'c29',3.333,5),(553,20528,20522,'295',3.333,5),(553,20529,20522,'950',3.333,5),(553,20530,20522,'50c',3.333,5),(553,20531,20522,'0ca',3.333,5),(553,20532,20522,'cab',3.333,5),(553,20533,20522,'abe',3.333,5),(553,20534,20522,'be6',3.333,5),(553,20535,20522,'e6e',3.333,5),(553,20536,20522,'6ec',3.333,5),(553,20537,20522,'ece',3.333,5),(553,20538,20522,'ce9',3.333,5),(553,20539,20522,'e93',3.333,5),(553,20540,20522,'937',3.333,5),(553,20541,20522,'37d',3.333,5),(553,20542,20522,'7dc',3.333,5),(553,20543,20522,'dc6',3.333,5),(553,20544,20522,'c69',3.333,5),(553,20545,20522,'69d',3.333,5),(553,20546,20522,'9d9',3.333,5),(553,20547,20522,'d95',3.333,5),(553,20548,20522,'952',3.333,5),(553,20549,20522,'52a',3.333,5),(553,20550,20522,'2ae',3.333,5),(553,20551,20522,'ae4',3.333,5),(553,20552,20522,'e4e',3.333,5),(554,20554,20553,'naa',100,5),(554,20555,20554,'600',3.333,5),(554,20556,20554,'000',3.333,5),(554,20557,20554,'00c',3.333,5),(554,20558,20554,'0c2',3.333,5),(554,20559,20554,'c29',3.333,5),(554,20560,20554,'29e',3.333,5),(554,20561,20554,'9ee',3.333,5),(554,20562,20554,'eec',3.333,5),(554,20563,20554,'ecc',3.333,5),(554,20564,20554,'cc6',3.333,5),(554,20565,20554,'c6e',3.333,5),(554,20566,20554,'6e9',3.333,5),(554,20567,20554,'e9a',3.333,5),(554,20568,20554,'9ad',3.333,5),(554,20569,20554,'adb',3.333,5),(554,20570,20554,'dbb',3.333,5),(554,20571,20554,'bb0',3.333,5),(554,20572,20554,'b01',3.333,5),(554,20573,20554,'013',3.333,5),(554,20574,20554,'132',3.333,5),(554,20575,20554,'32e',3.333,5),(554,20576,20554,'2e3',3.333,5),(554,20577,20554,'e3b',3.333,5),(554,20578,20554,'3b3',3.333,5),(554,20579,20554,'b3f',3.333,5),(554,20580,20554,'3ff',3.333,5),(554,20581,20554,'ff7',3.333,5),(554,20582,20554,'f7d',3.333,5),(554,20583,20554,'7d2',3.333,5),(554,20584,20554,'d22',3.333,5),(555,20586,20585,'naa',100,5),(555,20587,20586,'600',3.333,5),(555,20588,20586,'000',3.333,5),(555,20589,20586,'00c',3.333,5),(555,20590,20586,'0c2',3.333,5),(555,20591,20586,'c29',3.333,5),(555,20592,20586,'291',3.333,5),(555,20593,20586,'91f',3.333,5),(555,20594,20586,'1fd',3.333,5),(555,20595,20586,'fd2',3.333,5),(555,20596,20586,'d23',3.333,5),(555,20597,20586,'239',3.333,5),(555,20598,20586,'395',3.333,5),(555,20599,20586,'95f',3.333,5),(555,20600,20586,'5fe',3.333,5),(555,20601,20586,'fe3',3.333,5),(555,20602,20586,'e3c',3.333,5),(555,20603,20586,'3c1',3.333,5),(555,20604,20586,'c19',3.333,5),(555,20605,20586,'199',3.333,5),(555,20606,20586,'997',3.333,5),(555,20607,20586,'979',3.333,5),(555,20608,20586,'795',3.333,5),(555,20609,20586,'950',3.333,5),(555,20610,20586,'50b',3.333,5),(555,20611,20586,'0b8',3.333,5),(555,20612,20586,'b8a',3.333,5),(555,20613,20586,'8a8',3.333,5),(555,20614,20586,'a8c',3.333,5),(555,20615,20586,'8c0',3.333,5),(555,20616,20586,'c0c',3.333,5),(556,20618,20617,'naa',100,5),(556,20619,20618,'600',3.333,5),(556,20620,20618,'000',3.333,5),(556,20621,20618,'00c',3.333,5),(556,20622,20618,'0c2',3.333,5),(556,20623,20618,'c29',3.333,5),(556,20624,20618,'296',3.333,5),(556,20625,20618,'967',3.333,5),(556,20626,20618,'674',3.333,5),(556,20627,20618,'743',3.333,5),(556,20628,20618,'439',3.333,5),(556,20629,20618,'398',3.333,5),(556,20630,20618,'988',3.333,5),(556,20631,20618,'883',3.333,5),(556,20632,20618,'83f',3.333,5),(556,20633,20618,'3ff',3.333,5),(556,20634,20618,'ffd',3.333,5),(556,20635,20618,'fd8',3.333,5),(556,20636,20618,'d8a',3.333,5),(556,20637,20618,'8ad',3.333,5),(556,20638,20618,'ad9',3.333,5),(556,20639,20618,'d92',3.333,5),(556,20640,20618,'92e',3.333,5),(556,20641,20618,'2ee',3.333,5),(556,20642,20618,'ee6',3.333,5),(556,20643,20618,'e6d',3.333,5),(556,20644,20618,'6de',3.333,5),(556,20645,20618,'de2',3.333,5),(556,20646,20618,'e2a',3.333,5),(556,20647,20618,'2a3',3.333,5),(556,20648,20618,'a3c',3.333,5),(557,20650,20649,'naa',100,5),(557,20651,20650,'600',3.333,5),(557,20652,20650,'000',3.333,5),(557,20653,20650,'00c',3.333,5),(557,20654,20650,'0c2',3.333,5),(557,20655,20650,'c29',3.333,5),(557,20656,20650,'29a',3.333,5),(557,20657,20650,'9a8',3.333,5),(557,20658,20650,'a8d',3.333,5),(557,20659,20650,'8d2',3.333,5),(557,20660,20650,'d23',3.333,5),(557,20661,20650,'234',3.333,5),(557,20662,20650,'346',3.333,5),(557,20663,20650,'467',3.333,5),(557,20664,20650,'67d',3.333,5),(557,20665,20650,'7de',3.333,5),(557,20666,20650,'ded',3.333,5),(557,20667,20650,'edb',3.333,5),(557,20668,20650,'db9',3.333,5),(557,20669,20650,'b9b',3.333,5),(557,20670,20650,'9b0',3.333,5),(557,20671,20650,'b0a',3.333,5),(557,20672,20650,'0a5',3.333,5),(557,20673,20650,'a50',3.333,5),(557,20674,20650,'508',3.333,5),(557,20675,20650,'08a',3.333,5),(557,20676,20650,'8ab',3.333,5),(557,20677,20650,'ab6',3.333,5),(557,20678,20650,'b6f',3.333,5),(557,20679,20650,'6f9',3.333,5),(557,20680,20650,'f92',3.333,5),(558,20682,20681,'naa',100,5),(558,20683,20682,'600',3.333,5),(558,20684,20682,'000',3.333,5),(558,20685,20682,'00c',3.333,5),(558,20686,20682,'0c2',3.333,5),(558,20687,20682,'c29',3.333,5),(558,20688,20682,'290',3.333,5),(558,20689,20682,'90a',3.333,5),(558,20690,20682,'0ab',3.333,5),(558,20691,20682,'abf',3.333,5),(558,20692,20682,'bfa',3.333,5),(558,20693,20682,'faf',3.333,5),(558,20694,20682,'af5',3.333,5),(558,20695,20682,'f53',3.333,5),(558,20696,20682,'53c',3.333,5),(558,20697,20682,'3c3',3.333,5),(558,20698,20682,'c3b',3.333,5),(558,20699,20682,'3b2',3.333,5),(558,20700,20682,'b2c',3.333,5),(558,20701,20682,'2c6',3.333,5),(558,20702,20682,'c64',3.333,5),(558,20703,20682,'643',3.333,5),(558,20704,20682,'43b',3.333,5),(558,20705,20682,'3b6',3.333,5),(558,20706,20682,'b60',3.333,5),(558,20707,20682,'607',3.333,5),(558,20708,20682,'070',3.333,5),(558,20709,20682,'703',3.333,5),(558,20710,20682,'038',3.333,5),(558,20711,20682,'38b',3.333,5),(558,20712,20682,'8bf',3.333,5),(559,20714,20713,'naa',100,5),(559,20715,20714,'600',3.333,5),(559,20716,20714,'000',3.333,5),(559,20717,20714,'00c',3.333,5),(559,20718,20714,'0c2',3.333,5),(559,20719,20714,'c29',3.333,5),(559,20720,20714,'295',3.333,5),(559,20721,20714,'953',3.333,5),(559,20722,20714,'53e',3.333,5),(559,20723,20714,'3e4',3.333,5),(559,20724,20714,'e4b',3.333,5),(559,20725,20714,'4b5',3.333,5),(559,20726,20714,'b58',3.333,5),(559,20727,20714,'58e',3.333,5),(559,20728,20714,'8e3',3.333,5),(559,20729,20714,'e32',3.333,5),(559,20730,20714,'326',3.333,5),(559,20731,20714,'268',3.333,5),(559,20732,20714,'68b',3.333,5),(559,20733,20714,'8b2',3.333,5),(559,20734,20714,'b22',3.333,5),(559,20735,20714,'227',3.333,5),(559,20736,20714,'275',3.333,5),(559,20737,20714,'75f',3.333,5),(559,20738,20714,'5f6',3.333,5),(559,20739,20714,'f65',3.333,5),(559,20740,20714,'65c',3.333,5),(559,20741,20714,'5c0',3.333,5),(559,20742,20714,'c00',3.333,5),(559,20743,20714,'00b',3.333,5),(559,20744,20714,'0b3',3.333,5),(560,20746,20745,'naa',100,5),(560,20747,20746,'600',3.333,5),(560,20748,20746,'000',3.333,5),(560,20749,20746,'00c',3.333,5),(560,20750,20746,'0c2',3.333,5),(560,20751,20746,'c29',3.333,5),(560,20752,20746,'29a',3.333,5),(560,20753,20746,'9a0',3.333,5),(560,20754,20746,'a09',3.333,5),(560,20755,20746,'09f',3.333,5),(560,20756,20746,'9f2',3.333,5),(560,20757,20746,'f27',3.333,5),(560,20758,20746,'274',3.333,5),(560,20759,20746,'74b',3.333,5),(560,20760,20746,'4bc',3.333,5),(560,20761,20746,'bcd',3.333,5),(560,20762,20746,'cd4',3.333,5),(560,20763,20746,'d4b',3.333,5),(560,20764,20746,'4bb',3.333,5),(560,20765,20746,'bbf',3.333,5),(560,20766,20746,'bf3',3.333,5),(560,20767,20746,'f3a',3.333,5),(560,20768,20746,'3ae',3.333,5),(560,20769,20746,'ae4',3.333,5),(560,20770,20746,'e48',3.333,5),(560,20771,20746,'484',3.333,5),(560,20772,20746,'84e',3.333,5),(560,20773,20746,'4e5',3.333,5),(560,20774,20746,'e5e',3.333,5),(560,20775,20746,'5e7',3.333,5),(560,20776,20746,'e7a',3.333,5),(561,20778,20777,'naa',100,5),(561,20779,20778,'600',3.333,5),(561,20780,20778,'000',3.333,5),(561,20781,20778,'00c',3.333,5),(561,20782,20778,'0c2',3.333,5),(561,20783,20778,'c29',3.333,5),(561,20784,20778,'29a',3.333,5),(561,20785,20778,'9ac',3.333,5),(561,20786,20778,'ac8',3.333,5),(561,20787,20778,'c85',3.333,5),(561,20788,20778,'85e',3.333,5),(561,20789,20778,'5e6',3.333,5),(561,20790,20778,'e6f',3.333,5),(561,20791,20778,'6f8',3.333,5),(561,20792,20778,'f88',3.333,5),(561,20793,20778,'88a',3.333,5),(561,20794,20778,'8af',3.333,5),(561,20795,20778,'af7',3.333,5),(561,20796,20778,'f7b',3.333,5),(561,20797,20778,'7b4',3.333,5),(561,20798,20778,'b4f',3.333,5),(561,20799,20778,'4f6',3.333,5),(561,20800,20778,'f68',3.333,5),(561,20801,20778,'686',3.333,5),(561,20802,20778,'868',3.333,5),(561,20803,20778,'68f',3.333,5),(561,20804,20778,'8fb',3.333,5),(561,20805,20778,'fbe',3.333,5),(561,20806,20778,'be8',3.333,5),(561,20807,20778,'e87',3.333,5),(561,20808,20778,'87a',3.333,5),(562,20810,20809,'naa',100,5),(562,20811,20810,'600',3.333,5),(562,20812,20810,'000',3.333,5),(562,20813,20810,'00c',3.333,5),(562,20814,20810,'0c2',3.333,5),(562,20815,20810,'c29',3.333,5),(562,20816,20810,'294',3.333,5),(562,20817,20810,'940',3.333,5),(562,20818,20810,'40c',3.333,5),(562,20819,20810,'0cc',3.333,5),(562,20820,20810,'cc5',3.333,5),(562,20821,20810,'c5b',3.333,5),(562,20822,20810,'5bf',3.333,5),(562,20823,20810,'bf4',3.333,5),(562,20824,20810,'f41',3.333,5),(562,20825,20810,'413',3.333,5),(562,20826,20810,'131',3.333,5),(562,20827,20810,'316',3.333,5),(562,20828,20810,'16a',3.333,5),(562,20829,20810,'6a5',3.333,5),(562,20830,20810,'a55',3.333,5),(562,20831,20810,'55e',3.333,5),(562,20832,20810,'5e0',3.333,5),(562,20833,20810,'e0c',3.333,5),(562,20834,20810,'0c9',3.333,5),(562,20835,20810,'c94',3.333,5),(562,20836,20810,'949',3.333,5),(562,20837,20810,'495',3.333,5),(562,20838,20810,'957',3.333,5),(562,20839,20810,'57c',3.333,5),(562,20840,20810,'7c8',3.333,5),(563,20842,20841,'naa',100,5),(563,20843,20842,'600',3.333,5),(563,20844,20842,'000',3.333,5),(563,20845,20842,'00c',3.333,5),(563,20846,20842,'0c2',3.333,5),(563,20847,20842,'c29',3.333,5),(563,20848,20842,'29d',3.333,5),(563,20849,20842,'9d4',3.333,5),(563,20850,20842,'d4e',3.333,5),(563,20851,20842,'4e2',3.333,5),(563,20852,20842,'e2c',3.333,5),(563,20853,20842,'2ce',3.333,5),(563,20854,20842,'ce7',3.333,5),(563,20855,20842,'e7b',3.333,5),(563,20856,20842,'7b7',3.333,5),(563,20857,20842,'b70',3.333,5),(563,20858,20842,'705',3.333,5),(563,20859,20842,'05f',3.333,5),(563,20860,20842,'5f6',3.333,5),(563,20861,20842,'f66',3.333,5),(563,20862,20842,'66f',3.333,5),(563,20863,20842,'6fd',3.333,5),(563,20864,20842,'fdb',3.333,5),(563,20865,20842,'dbd',3.333,5),(563,20866,20842,'bdb',3.333,5),(563,20867,20842,'db4',3.333,5),(563,20868,20842,'b46',3.333,5),(563,20869,20842,'461',3.333,5),(563,20870,20842,'613',3.333,5),(563,20871,20842,'131',3.333,5),(563,20872,20842,'313',3.333,5),(564,20874,20873,'naa',100,5),(564,20875,20874,'600',3.333,5),(564,20876,20874,'000',3.333,5),(564,20877,20874,'00c',3.333,5),(564,20878,20874,'0c2',3.333,5),(564,20879,20874,'c29',3.333,5),(564,20880,20874,'29a',3.333,5),(564,20881,20874,'9aa',3.333,5),(564,20882,20874,'aab',3.333,5),(564,20883,20874,'ab2',3.333,5),(564,20884,20874,'b2e',3.333,5),(564,20885,20874,'2e0',3.333,5),(564,20886,20874,'e04',3.333,5),(564,20887,20874,'04f',3.333,5),(564,20888,20874,'4f2',3.333,5),(564,20889,20874,'f25',3.333,5),(564,20890,20874,'257',3.333,5),(564,20891,20874,'571',3.333,5),(564,20892,20874,'71c',3.333,5),(564,20893,20874,'1c7',3.333,5),(564,20894,20874,'c7c',3.333,5),(564,20895,20874,'7c6',3.333,5),(564,20896,20874,'c60',3.333,5),(564,20897,20874,'605',3.333,5),(564,20898,20874,'050',3.333,5),(564,20899,20874,'50e',3.333,5),(564,20900,20874,'0ee',3.333,5),(564,20901,20874,'ee8',3.333,5),(564,20902,20874,'e83',3.333,5),(564,20903,20874,'835',3.333,5),(564,20904,20874,'353',3.333,5),(565,20906,20905,'naa',100,5),(565,20907,20906,'600',3.333,5),(565,20908,20906,'000',3.333,5),(565,20909,20906,'00c',3.333,5),(565,20910,20906,'0c2',3.333,5),(565,20911,20906,'c29',3.333,5),(565,20912,20906,'294',3.333,5),(565,20913,20906,'940',3.333,5),(565,20914,20906,'406',3.333,5),(565,20915,20906,'064',3.333,5),(565,20916,20906,'64b',3.333,5),(565,20917,20906,'4b8',3.333,5),(565,20918,20906,'b8b',3.333,5),(565,20919,20906,'8b3',3.333,5),(565,20920,20906,'b30',3.333,5),(565,20921,20906,'30c',3.333,5),(565,20922,20906,'0c8',3.333,5),(565,20923,20906,'c84',3.333,5),(565,20924,20906,'845',3.333,5),(565,20925,20906,'452',3.333,5),(565,20926,20906,'52c',3.333,5),(565,20927,20906,'2ce',3.333,5),(565,20928,20906,'cef',3.333,5),(565,20929,20906,'ef9',3.333,5),(565,20930,20906,'f95',3.333,5),(565,20931,20906,'950',3.333,5),(565,20932,20906,'506',3.333,5),(565,20933,20906,'062',3.333,5),(565,20934,20906,'62d',3.333,5),(565,20935,20906,'2d7',3.333,5),(565,20936,20906,'d75',3.333,5),(566,20938,20937,'naa',100,5),(566,20939,20938,'600',3.333,5),(566,20940,20938,'000',3.333,5),(566,20941,20938,'00c',3.333,5),(566,20942,20938,'0c2',3.333,5),(566,20943,20938,'c29',3.333,5),(566,20944,20938,'29a',3.333,5),(566,20945,20938,'9a1',3.333,5),(566,20946,20938,'a1b',3.333,5),(566,20947,20938,'1b4',3.333,5),(566,20948,20938,'b45',3.333,5),(566,20949,20938,'45e',3.333,5),(566,20950,20938,'5ee',3.333,5),(566,20951,20938,'eea',3.333,5),(566,20952,20938,'eac',3.333,5),(566,20953,20938,'ace',3.333,5),(566,20954,20938,'ce0',3.333,5),(566,20955,20938,'e00',3.333,5),(566,20956,20938,'004',3.333,5),(566,20957,20938,'049',3.333,5),(566,20958,20938,'496',3.333,5),(566,20959,20938,'969',3.333,5),(566,20960,20938,'699',3.333,5),(566,20961,20938,'99f',3.333,5),(566,20962,20938,'9f7',3.333,5),(566,20963,20938,'f71',3.333,5),(566,20964,20938,'712',3.333,5),(566,20965,20938,'123',3.333,5),(566,20966,20938,'23c',3.333,5),(566,20967,20938,'3c2',3.333,5),(566,20968,20938,'c20',3.333,5),(567,20970,20969,'naa',100,5),(567,20971,20970,'600',3.333,5),(567,20972,20970,'000',3.333,5),(567,20973,20970,'00c',3.333,5),(567,20974,20970,'0c2',3.333,5),(567,20975,20970,'c29',3.333,5),(567,20976,20970,'296',3.333,5),(567,20977,20970,'96b',3.333,5),(567,20978,20970,'6b4',3.333,5),(567,20979,20970,'b48',3.333,5),(567,20980,20970,'486',3.333,5),(567,20981,20970,'86b',3.333,5),(567,20982,20970,'6ba',3.333,5),(567,20983,20970,'ba6',3.333,5),(567,20984,20970,'a69',3.333,5),(567,20985,20970,'69a',3.333,5),(567,20986,20970,'9a3',3.333,5),(567,20987,20970,'a3f',3.333,5),(567,20988,20970,'3f7',3.333,5),(567,20989,20970,'f71',3.333,5),(567,20990,20970,'71b',3.333,5),(567,20991,20970,'1bb',3.333,5),(567,20992,20970,'bba',3.333,5),(567,20993,20970,'baf',3.333,5),(567,20994,20970,'afc',3.333,5),(567,20995,20970,'fc3',3.333,5),(567,20996,20970,'c3e',3.333,5),(567,20997,20970,'3e5',3.333,5),(567,20998,20970,'e5f',3.333,5),(567,20999,20970,'5f1',3.333,5),(567,21000,20970,'f15',3.333,5),(568,21002,21001,'naa',100,5),(568,21003,21002,'600',3.333,5),(568,21004,21002,'000',3.333,5),(568,21005,21002,'00c',3.333,5),(568,21006,21002,'0c2',3.333,5),(568,21007,21002,'c29',3.333,5),(568,21008,21002,'298',3.333,5),(568,21009,21002,'986',3.333,5),(568,21010,21002,'869',3.333,5),(568,21011,21002,'693',3.333,5),(568,21012,21002,'93d',3.333,5),(568,21013,21002,'3d2',3.333,5),(568,21014,21002,'d22',3.333,5),(568,21015,21002,'22a',3.333,5),(568,21016,21002,'2a7',3.333,5),(568,21017,21002,'a71',3.333,5),(568,21018,21002,'716',3.333,5),(568,21019,21002,'166',3.333,5),(568,21020,21002,'664',3.333,5),(568,21021,21002,'644',3.333,5),(568,21022,21002,'446',3.333,5),(568,21023,21002,'466',3.333,5),(568,21024,21002,'668',3.333,5),(568,21025,21002,'68f',3.333,5),(568,21026,21002,'8f8',3.333,5),(568,21027,21002,'f80',3.333,5),(568,21028,21002,'808',3.333,5),(568,21029,21002,'08b',3.333,5),(568,21030,21002,'8bc',3.333,5),(568,21031,21002,'bc1',3.333,5),(568,21032,21002,'c18',3.333,5),(569,21034,21033,'naa',100,5),(569,21035,21034,'600',3.333,5),(569,21036,21034,'000',3.333,5),(569,21037,21034,'00c',3.333,5),(569,21038,21034,'0c2',3.333,5),(569,21039,21034,'c29',3.333,5),(569,21040,21034,'29a',3.333,5),(569,21041,21034,'9af',3.333,5),(569,21042,21034,'af0',3.333,5),(569,21043,21034,'f0b',3.333,5),(569,21044,21034,'0bf',3.333,5),(569,21045,21034,'bf9',3.333,5),(569,21046,21034,'f91',3.333,5),(569,21047,21034,'917',3.333,5),(569,21048,21034,'17f',3.333,5),(569,21049,21034,'7f4',3.333,5),(569,21050,21034,'f42',3.333,5),(569,21051,21034,'423',3.333,5),(569,21052,21034,'23b',3.333,5),(569,21053,21034,'3b0',3.333,5),(569,21054,21034,'b0f',3.333,5),(569,21055,21034,'0f7',3.333,5),(569,21056,21034,'f7b',3.333,5),(569,21057,21034,'7b4',3.333,5),(569,21058,21034,'b4d',3.333,5),(569,21059,21034,'4d5',3.333,5),(569,21060,21034,'d54',3.333,5),(569,21061,21034,'54e',3.333,5),(569,21062,21034,'4e7',3.333,5),(569,21063,21034,'e79',3.333,5),(569,21064,21034,'792',3.333,5),(570,21066,21065,'naa',100,5),(570,21067,21066,'600',3.333,5),(570,21068,21066,'000',3.333,5),(570,21069,21066,'00c',3.333,5),(570,21070,21066,'0c2',3.333,5),(570,21071,21066,'c29',3.333,5),(570,21072,21066,'299',3.333,5),(570,21073,21066,'99e',3.333,5),(570,21074,21066,'9e6',3.333,5),(570,21075,21066,'e65',3.333,5),(570,21076,21066,'656',3.333,5),(570,21077,21066,'567',3.333,5),(570,21078,21066,'677',3.333,5),(570,21079,21066,'777',3.333,5),(570,21080,21066,'770',3.333,5),(570,21081,21066,'701',3.333,5),(570,21082,21066,'01b',3.333,5),(570,21083,21066,'1b2',3.333,5),(570,21084,21066,'b27',3.333,5),(570,21085,21066,'273',3.333,5),(570,21086,21066,'73f',3.333,5),(570,21087,21066,'3f9',3.333,5),(570,21088,21066,'f92',3.333,5),(570,21089,21066,'929',3.333,5),(570,21090,21066,'29a',3.333,5),(570,21091,21066,'9ad',3.333,5),(570,21092,21066,'adb',3.333,5),(570,21093,21066,'dbc',3.333,5),(570,21094,21066,'bcc',3.333,5),(570,21095,21066,'cc1',3.333,5),(570,21096,21066,'c1f',3.333,5),(571,21098,21097,'naa',100,5),(571,21099,21098,'600',3.333,5),(571,21100,21098,'000',3.333,5),(571,21101,21098,'00c',3.333,5),(571,21102,21098,'0c2',3.333,5),(571,21103,21098,'c29',3.333,5),(571,21104,21098,'297',3.333,5),(571,21105,21098,'97b',3.333,5),(571,21106,21098,'7b4',3.333,5),(571,21107,21098,'b44',3.333,5),(571,21108,21098,'449',3.333,5),(571,21109,21098,'49a',3.333,5),(571,21110,21098,'9a2',3.333,5),(571,21111,21098,'a23',3.333,5),(571,21112,21098,'234',3.333,5),(571,21113,21098,'34f',3.333,5),(571,21114,21098,'4fa',3.333,5),(571,21115,21098,'fac',3.333,5),(571,21116,21098,'ac7',3.333,5),(571,21117,21098,'c7c',3.333,5),(571,21118,21098,'7c8',3.333,5),(571,21119,21098,'c88',3.333,5),(571,21120,21098,'88a',3.333,5),(571,21121,21098,'8a0',3.333,5),(571,21122,21098,'a0c',3.333,5),(571,21123,21098,'0cb',3.333,5),(571,21124,21098,'cbe',3.333,5),(571,21125,21098,'beb',3.333,5),(571,21126,21098,'eb7',3.333,5),(571,21127,21098,'b75',3.333,5),(571,21128,21098,'75e',3.333,5),(572,21130,21129,'naa',100,5),(572,21131,21130,'600',3.333,5),(572,21132,21130,'000',3.333,5),(572,21133,21130,'00c',3.333,5),(572,21134,21130,'0c2',3.333,5),(572,21135,21130,'c29',3.333,5),(572,21136,21130,'29c',3.333,5),(572,21137,21130,'9c8',3.333,5),(572,21138,21130,'c81',3.333,5),(572,21139,21130,'812',3.333,5),(572,21140,21130,'124',3.333,5),(572,21141,21130,'24b',3.333,5),(572,21142,21130,'4bd',3.333,5),(572,21143,21130,'bd2',3.333,5),(572,21144,21130,'d22',3.333,5),(572,21145,21130,'229',3.333,5),(572,21146,21130,'298',3.333,5),(572,21147,21130,'98e',3.333,5),(572,21148,21130,'8ec',3.333,5),(572,21149,21130,'ece',3.333,5),(572,21150,21130,'cec',3.333,5),(572,21151,21130,'ecb',3.333,5),(572,21152,21130,'cba',3.333,5),(572,21153,21130,'ba4',3.333,5),(572,21154,21130,'a4c',3.333,5),(572,21155,21130,'4c3',3.333,5),(572,21156,21130,'c37',3.333,5),(572,21157,21130,'378',3.333,5),(572,21158,21130,'782',3.333,5),(572,21159,21130,'82b',3.333,5),(572,21160,21130,'2b1',3.333,5),(573,21162,21161,'naa',100,5),(573,21163,21162,'600',3.333,5),(573,21164,21162,'000',3.333,5),(573,21165,21162,'00c',3.333,5),(573,21166,21162,'0c2',3.333,5),(573,21167,21162,'c29',3.333,5),(573,21168,21162,'29b',3.333,5),(573,21169,21162,'9b3',3.333,5),(573,21170,21162,'b3f',3.333,5),(573,21171,21162,'3fe',3.333,5),(573,21172,21162,'fec',3.333,5),(573,21173,21162,'ec7',3.333,5),(573,21174,21162,'c74',3.333,5),(573,21175,21162,'74f',3.333,5),(573,21176,21162,'4f2',3.333,5),(573,21177,21162,'f23',3.333,5),(573,21178,21162,'237',3.333,5),(573,21179,21162,'37a',3.333,5),(573,21180,21162,'7a6',3.333,5),(573,21181,21162,'a67',3.333,5),(573,21182,21162,'67a',3.333,5),(573,21183,21162,'7af',3.333,5),(573,21184,21162,'afa',3.333,5),(573,21185,21162,'fa7',3.333,5),(573,21186,21162,'a74',3.333,5),(573,21187,21162,'746',3.333,5),(573,21188,21162,'46f',3.333,5),(573,21189,21162,'6f5',3.333,5),(573,21190,21162,'f5d',3.333,5),(573,21191,21162,'5d5',3.333,5),(573,21192,21162,'d55',3.333,5),(574,21194,21193,'naa',100,5),(574,21195,21194,'600',3.333,5),(574,21196,21194,'000',3.333,5),(574,21197,21194,'00c',3.333,5),(574,21198,21194,'0c2',3.333,5),(574,21199,21194,'c29',3.333,5),(574,21200,21194,'293',3.333,5),(574,21201,21194,'935',3.333,5),(574,21202,21194,'35c',3.333,5),(574,21203,21194,'5c4',3.333,5),(574,21204,21194,'c4a',3.333,5),(574,21205,21194,'4a6',3.333,5),(574,21206,21194,'a69',3.333,5),(574,21207,21194,'694',3.333,5),(574,21208,21194,'942',3.333,5),(574,21209,21194,'42c',3.333,5),(574,21210,21194,'2cc',3.333,5),(574,21211,21194,'cc0',3.333,5),(574,21212,21194,'c0c',3.333,5),(574,21213,21194,'0cd',3.333,5),(574,21214,21194,'cd0',3.333,5),(574,21215,21194,'d05',3.333,5),(574,21216,21194,'05e',3.333,5),(574,21217,21194,'5e1',3.333,5),(574,21218,21194,'e18',3.333,5),(574,21219,21194,'188',3.333,5),(574,21220,21194,'88c',3.333,5),(574,21221,21194,'8cf',3.333,5),(574,21222,21194,'cf9',3.333,5),(574,21223,21194,'f9b',3.333,5),(574,21224,21194,'9ba',3.333,5),(575,21226,21225,'naa',100,5),(575,21227,21226,'600',3.333,5),(575,21228,21226,'000',3.333,5),(575,21229,21226,'00c',3.333,5),(575,21230,21226,'0c2',3.333,5),(575,21231,21226,'c29',3.333,5),(575,21232,21226,'29c',3.333,5),(575,21233,21226,'9c5',3.333,5),(575,21234,21226,'c58',3.333,5),(575,21235,21226,'58d',3.333,5),(575,21236,21226,'8d9',3.333,5),(575,21237,21226,'d9d',3.333,5),(575,21238,21226,'9db',3.333,5),(575,21239,21226,'db2',3.333,5),(575,21240,21226,'b25',3.333,5),(575,21241,21226,'25e',3.333,5),(575,21242,21226,'5ed',3.333,5),(575,21243,21226,'ed3',3.333,5),(575,21244,21226,'d3a',3.333,5),(575,21245,21226,'3a3',3.333,5),(575,21246,21226,'a37',3.333,5),(575,21247,21226,'37b',3.333,5),(575,21248,21226,'7b0',3.333,5),(575,21249,21226,'b02',3.333,5),(575,21250,21226,'024',3.333,5),(575,21251,21226,'24d',3.333,5),(575,21252,21226,'4d2',3.333,5),(575,21253,21226,'d23',3.333,5),(575,21254,21226,'238',3.333,5),(575,21255,21226,'384',3.333,5),(575,21256,21226,'841',3.333,5),(576,21258,21257,'naa',100,5),(576,21259,21258,'600',3.333,5),(576,21260,21258,'000',3.333,5),(576,21261,21258,'00c',3.333,5),(576,21262,21258,'0c2',3.333,5),(576,21263,21258,'c29',3.333,5),(576,21264,21258,'295',3.333,5),(576,21265,21258,'95e',3.333,5),(576,21266,21258,'5ea',3.333,5),(576,21267,21258,'eaa',3.333,5),(576,21268,21258,'aa5',3.333,5),(576,21269,21258,'a5d',3.333,5),(576,21270,21258,'5dc',3.333,5),(576,21271,21258,'dcc',3.333,5),(576,21272,21258,'ccf',3.333,5),(576,21273,21258,'cf4',3.333,5),(576,21274,21258,'f46',3.333,5),(576,21275,21258,'467',3.333,5),(576,21276,21258,'67b',3.333,5),(576,21277,21258,'7bb',3.333,5),(576,21278,21258,'bba',3.333,5),(576,21279,21258,'bae',3.333,5),(576,21280,21258,'ae8',3.333,5),(576,21281,21258,'e80',3.333,5),(576,21282,21258,'804',3.333,5),(576,21283,21258,'044',3.333,5),(576,21284,21258,'444',3.333,5),(576,21285,21258,'441',3.333,5),(576,21286,21258,'414',3.333,5),(576,21287,21258,'14c',3.333,5),(576,21288,21258,'4ce',3.333,5),(577,21290,21289,'naa',100,5),(577,21291,21290,'600',3.333,5),(577,21292,21290,'000',3.333,5),(577,21293,21290,'00c',3.333,5),(577,21294,21290,'0c2',3.333,5),(577,21295,21290,'c29',3.333,5),(577,21296,21290,'29b',3.333,5),(577,21297,21290,'9b2',3.333,5),(577,21298,21290,'b20',3.333,5),(577,21299,21290,'205',3.333,5),(577,21300,21290,'058',3.333,5),(577,21301,21290,'583',3.333,5),(577,21302,21290,'838',3.333,5),(577,21303,21290,'38c',3.333,5),(577,21304,21290,'8c4',3.333,5),(577,21305,21290,'c4c',3.333,5),(577,21306,21290,'4c5',3.333,5),(577,21307,21290,'c55',3.333,5),(577,21308,21290,'55a',3.333,5),(577,21309,21290,'5aa',3.333,5),(577,21310,21290,'aaa',3.333,5),(577,21311,21290,'aaf',3.333,5),(577,21312,21290,'afd',3.333,5),(577,21313,21290,'fda',3.333,5),(577,21314,21290,'da2',3.333,5),(577,21315,21290,'a23',3.333,5),(577,21316,21290,'23e',3.333,5),(577,21317,21290,'3ee',3.333,5),(577,21318,21290,'eed',3.333,5),(577,21319,21290,'ed7',3.333,5),(577,21320,21290,'d79',3.333,5),(578,21322,21321,'naa',100,5),(578,21323,21322,'600',3.333,5),(578,21324,21322,'000',3.333,5),(578,21325,21322,'00c',3.333,5),(578,21326,21322,'0c2',3.333,5),(578,21327,21322,'c29',3.333,5),(578,21328,21322,'29a',3.333,5),(578,21329,21322,'9a0',3.333,5),(578,21330,21322,'a03',3.333,5),(578,21331,21322,'03b',3.333,5),(578,21332,21322,'3b6',3.333,5),(578,21333,21322,'b63',3.333,5),(578,21334,21322,'63f',3.333,5),(578,21335,21322,'3f9',3.333,5),(578,21336,21322,'f95',3.333,5),(578,21337,21322,'95b',3.333,5),(578,21338,21322,'5b8',3.333,5),(578,21339,21322,'b8f',3.333,5),(578,21340,21322,'8f5',3.333,5),(578,21341,21322,'f59',3.333,5),(578,21342,21322,'592',3.333,5),(578,21343,21322,'92f',3.333,5),(578,21344,21322,'2f1',3.333,5),(578,21345,21322,'f18',3.333,5),(578,21346,21322,'18d',3.333,5),(578,21347,21322,'8d6',3.333,5),(578,21348,21322,'d63',3.333,5),(578,21349,21322,'630',3.333,5),(578,21350,21322,'30b',3.333,5),(578,21351,21322,'0b8',3.333,5),(578,21352,21322,'b86',3.333,5),(579,21354,21353,'naa',100,5),(579,21355,21354,'600',3.333,5),(579,21356,21354,'000',3.333,5),(579,21357,21354,'00c',3.333,5),(579,21358,21354,'0c2',3.333,5),(579,21359,21354,'c29',3.333,5),(579,21360,21354,'29b',3.333,5),(579,21361,21354,'9b4',3.333,5),(579,21362,21354,'b4b',3.333,5),(579,21363,21354,'4b8',3.333,5),(579,21364,21354,'b82',3.333,5),(579,21365,21354,'82c',3.333,5),(579,21366,21354,'2c4',3.333,5),(579,21367,21354,'c4c',3.333,5),(579,21368,21354,'4cc',3.333,5),(579,21369,21354,'cc1',3.333,5),(579,21370,21354,'c19',3.333,5),(579,21371,21354,'194',3.333,5),(579,21372,21354,'945',3.333,5),(579,21373,21354,'45e',3.333,5),(579,21374,21354,'5e2',3.333,5),(579,21375,21354,'e2d',3.333,5),(579,21376,21354,'2db',3.333,5),(579,21377,21354,'db1',3.333,5),(579,21378,21354,'b12',3.333,5),(579,21379,21354,'126',3.333,5),(579,21380,21354,'267',3.333,5),(579,21381,21354,'671',3.333,5),(579,21382,21354,'718',3.333,5),(579,21383,21354,'182',3.333,5),(579,21384,21354,'829',3.333,5),(580,21386,21385,'naa',100,5),(580,21387,21386,'600',3.333,5),(580,21388,21386,'000',3.333,5),(580,21389,21386,'00c',3.333,5),(580,21390,21386,'0c2',3.333,5),(580,21391,21386,'c29',3.333,5),(580,21392,21386,'29e',3.333,5),(580,21393,21386,'9e0',3.333,5),(580,21394,21386,'e08',3.333,5),(580,21395,21386,'08c',3.333,5),(580,21396,21386,'8ce',3.333,5),(580,21397,21386,'ce8',3.333,5),(580,21398,21386,'e8c',3.333,5),(580,21399,21386,'8c4',3.333,5),(580,21400,21386,'c49',3.333,5),(580,21401,21386,'49f',3.333,5),(580,21402,21386,'9f3',3.333,5),(580,21403,21386,'f38',3.333,5),(580,21404,21386,'388',3.333,5),(580,21405,21386,'881',3.333,5),(580,21406,21386,'81f',3.333,5),(580,21407,21386,'1f5',3.333,5),(580,21408,21386,'f5e',3.333,5),(580,21409,21386,'5e5',3.333,5),(580,21410,21386,'e54',3.333,5),(580,21411,21386,'545',3.333,5),(580,21412,21386,'458',3.333,5),(580,21413,21386,'58a',3.333,5),(580,21414,21386,'8ac',3.333,5),(580,21415,21386,'acd',3.333,5),(580,21416,21386,'cda',3.333,5),(581,21418,21417,'naa',100,5),(581,21419,21418,'600',3.333,5),(581,21420,21418,'000',3.333,5),(581,21421,21418,'00c',3.333,5),(581,21422,21418,'0c2',3.333,5),(581,21423,21418,'c29',3.333,5),(581,21424,21418,'29b',3.333,5),(581,21425,21418,'9be',3.333,5),(581,21426,21418,'beb',3.333,5),(581,21427,21418,'eb3',3.333,5),(581,21428,21418,'b32',3.333,5),(581,21429,21418,'328',3.333,5),(581,21430,21418,'28c',3.333,5),(581,21431,21418,'8cf',3.333,5),(581,21432,21418,'cfb',3.333,5),(581,21433,21418,'fb5',3.333,5),(581,21434,21418,'b51',3.333,5),(581,21435,21418,'51b',3.333,5),(581,21436,21418,'1bf',3.333,5),(581,21437,21418,'bf0',3.333,5),(581,21438,21418,'f06',3.333,5),(581,21439,21418,'068',3.333,5),(581,21440,21418,'683',3.333,5),(581,21441,21418,'835',3.333,5),(581,21442,21418,'35a',3.333,5),(581,21443,21418,'5ac',3.333,5),(581,21444,21418,'ac5',3.333,5),(581,21445,21418,'c5e',3.333,5),(581,21446,21418,'5ed',3.333,5),(581,21447,21418,'ed5',3.333,5),(581,21448,21418,'d52',3.333,5),(582,21450,21449,'naa',100,5),(582,21451,21450,'600',3.333,5),(582,21452,21450,'000',3.333,5),(582,21453,21450,'00c',3.333,5),(582,21454,21450,'0c2',3.333,5),(582,21455,21450,'c29',3.333,5),(582,21456,21450,'292',3.333,5),(582,21457,21450,'921',3.333,5),(582,21458,21450,'21d',3.333,5),(582,21459,21450,'1dd',3.333,5),(582,21460,21450,'dd7',3.333,5),(582,21461,21450,'d7b',3.333,5),(582,21462,21450,'7be',3.333,5),(582,21463,21450,'be4',3.333,5),(582,21464,21450,'e48',3.333,5),(582,21465,21450,'482',3.333,5),(582,21466,21450,'825',3.333,5),(582,21467,21450,'256',3.333,5),(582,21468,21450,'56a',3.333,5),(582,21469,21450,'6aa',3.333,5),(582,21470,21450,'aa0',3.333,5),(582,21471,21450,'a02',3.333,5),(582,21472,21450,'020',3.333,5),(582,21473,21450,'206',3.333,5),(582,21474,21450,'064',3.333,5),(582,21475,21450,'64b',3.333,5),(582,21476,21450,'4b5',3.333,5),(582,21477,21450,'b5d',3.333,5),(582,21478,21450,'5d0',3.333,5),(582,21479,21450,'d01',3.333,5),(582,21480,21450,'01d',3.333,5),(463,21482,21481,'hgw',9.091,5),(463,21483,21481,'gw2',9.091,5),(463,21484,21481,'w2k',9.091,5),(463,21485,21481,'2k8',9.091,5),(463,21486,21481,'k8r',9.091,5),(463,21487,21481,'8r2',9.091,5),(463,21488,21481,'r23',9.091,5),(463,21489,21481,'232',9.091,5),(463,21490,21481,'32v',9.091,5),(463,21491,21481,'2vm',9.091,5),(463,21492,21481,'vm6',9.091,5),(584,21506,21505,'naa',100,5),(584,21507,21506,'600',3.333,5),(584,21508,21506,'000',3.333,5),(584,21509,21506,'00c',3.333,5),(584,21510,21506,'0c2',3.333,5),(584,21511,21506,'c29',3.333,5),(584,21512,21506,'292',3.333,5),(584,21513,21506,'926',3.333,5),(584,21514,21506,'26d',3.333,5),(584,21515,21506,'6da',3.333,5),(584,21516,21506,'daf',3.333,5),(584,21517,21506,'aff',3.333,5),(584,21518,21506,'ff7',3.333,5),(584,21519,21506,'f77',3.333,5),(584,21520,21506,'777',3.333,5),(584,21521,21506,'773',3.333,5),(584,21522,21506,'732',3.333,5),(584,21523,21506,'326',3.333,5),(584,21524,21506,'26a',3.333,5),(584,21525,21506,'6ac',3.333,5),(584,21526,21506,'ac2',3.333,5),(584,21527,21506,'c23',3.333,5),(584,21528,21506,'239',3.333,5),(584,21529,21506,'392',3.333,5),(584,21530,21506,'92e',3.333,5),(584,21531,21506,'2ef',3.333,5),(584,21532,21506,'ef5',3.333,5),(584,21533,21506,'f5b',3.333,5),(584,21534,21506,'5b8',3.333,5),(584,21535,21506,'b81',3.333,5),(584,21536,21506,'810',3.333,5),(585,21538,21537,'naa',100,5),(585,21539,21538,'600',3.333,5),(585,21540,21538,'00a',3.333,5),(585,21541,21538,'0a0',3.333,5),(585,21542,21538,'a09',3.333,5),(585,21543,21538,'098',3.333,5),(585,21544,21538,'980',3.333,5),(585,21545,21538,'804',3.333,5),(585,21546,21538,'044',3.333,5),(585,21547,21538,'443',3.333,5),(585,21548,21538,'430',3.333,5),(585,21549,21538,'307',3.333,5),(585,21550,21538,'072',3.333,5),(585,21551,21538,'725',3.333,5),(585,21552,21538,'259',3.333,5),(585,21553,21538,'593',3.333,5),(585,21554,21538,'931',3.333,5),(585,21555,21538,'313',3.333,5),(585,21556,21538,'13f',3.333,5),(585,21557,21538,'3f3',3.333,5),(585,21558,21538,'f33',3.333,5),(585,21559,21538,'334',3.333,5),(585,21560,21538,'345',3.333,5),(585,21561,21538,'455',3.333,5),(585,21562,21538,'556',3.333,5),(585,21563,21538,'563',3.333,5),(585,21564,21538,'639',3.333,5),(585,21565,21538,'393',3.333,5),(585,21566,21538,'934',3.333,5),(585,21567,21538,'344',3.333,5),(585,21568,21538,'447',3.333,5),(586,21570,21569,'naa',100,5),(586,21571,21570,'600',3.333,5),(586,21572,21570,'00a',3.333,5),(586,21573,21570,'0a0',3.333,5),(586,21574,21570,'a09',3.333,5),(586,21575,21570,'098',3.333,5),(586,21576,21570,'980',3.333,5),(586,21577,21570,'804',3.333,5),(586,21578,21570,'044',3.333,5),(586,21579,21570,'443',3.333,5),(586,21580,21570,'430',3.333,5),(586,21581,21570,'307',3.333,5),(586,21582,21570,'072',3.333,5),(586,21583,21570,'725',3.333,5),(586,21584,21570,'259',3.333,5),(586,21585,21570,'593',3.333,5),(586,21586,21570,'931',3.333,5),(586,21587,21570,'313',3.333,5),(586,21588,21570,'13f',3.333,5),(586,21589,21570,'3f3',3.333,5),(586,21590,21570,'f33',3.333,5),(586,21591,21570,'334',3.333,5),(586,21592,21570,'345',3.333,5),(586,21593,21570,'455',3.333,5),(586,21594,21570,'556',3.333,5),(586,21595,21570,'563',3.333,5),(586,21596,21570,'639',3.333,5),(586,21597,21570,'393',3.333,5),(586,21598,21570,'934',3.333,5),(586,21599,21570,'344',3.333,5),(586,21600,21570,'448',3.333,5),(587,21602,21601,'naa',100,5),(587,21603,21602,'600',3.333,5),(587,21604,21602,'00a',3.333,5),(587,21605,21602,'0a0',3.333,5),(587,21606,21602,'a09',3.333,5),(587,21607,21602,'098',3.333,5),(587,21608,21602,'980',3.333,5),(587,21609,21602,'804',3.333,5),(587,21610,21602,'044',3.333,5),(587,21611,21602,'443',3.333,5),(587,21612,21602,'430',3.333,5),(587,21613,21602,'307',3.333,5),(587,21614,21602,'075',3.333,5),(587,21615,21602,'753',3.333,5),(587,21616,21602,'535',3.333,5),(587,21617,21602,'357',3.333,5),(587,21618,21602,'573',3.333,5),(587,21619,21602,'732',3.333,5),(587,21620,21602,'32b',3.333,5),(587,21621,21602,'2b3',3.333,5),(587,21622,21602,'b33',3.333,5),(587,21623,21602,'334',3.333,5),(587,21624,21602,'345',3.333,5),(587,21625,21602,'457',3.333,5),(587,21626,21602,'571',3.333,5),(587,21627,21602,'715',3.333,5),(587,21628,21602,'153',3.333,5),(587,21629,21602,'533',3.333,5),(587,21630,21602,'336',3.333,5),(587,21631,21602,'363',3.333,5),(587,21632,21602,'632',3.333,5),(588,21634,21633,'naa',100,5),(588,21635,21634,'600',3.333,5),(588,21636,21634,'00a',3.333,5),(588,21637,21634,'0a0',3.333,5),(588,21638,21634,'a09',3.333,5),(588,21639,21634,'098',3.333,5),(588,21640,21634,'980',3.333,5),(588,21641,21634,'804',3.333,5),(588,21642,21634,'044',3.333,5),(588,21643,21634,'443',3.333,5),(588,21644,21634,'430',3.333,5),(588,21645,21634,'307',3.333,5),(588,21646,21634,'075',3.333,5),(588,21647,21634,'753',3.333,5),(588,21648,21634,'535',3.333,5),(588,21649,21634,'357',3.333,5),(588,21650,21634,'573',3.333,5),(588,21651,21634,'732',3.333,5),(588,21652,21634,'32b',3.333,5),(588,21653,21634,'2b3',3.333,5),(588,21654,21634,'b33',3.333,5),(588,21655,21634,'334',3.333,5),(588,21656,21634,'345',3.333,5),(588,21657,21634,'457',3.333,5),(588,21658,21634,'571',3.333,5),(588,21659,21634,'715',3.333,5),(588,21660,21634,'153',3.333,5),(588,21661,21634,'533',3.333,5),(588,21662,21634,'336',3.333,5),(588,21663,21634,'363',3.333,5),(588,21664,21634,'633',3.333,5),(589,21666,21665,'naa',100,5),(589,21667,21666,'600',3.333,5),(589,21668,21666,'000',3.333,5),(589,21669,21666,'00c',3.333,5),(589,21670,21666,'0c2',3.333,5),(589,21671,21666,'c29',3.333,5),(589,21672,21666,'292',3.333,5),(589,21673,21666,'92e',3.333,5),(589,21674,21666,'2e0',3.333,5),(589,21675,21666,'e0c',3.333,5),(589,21676,21666,'0c8',3.333,5),(589,21677,21666,'c82',3.333,5),(589,21678,21666,'82d',3.333,5),(589,21679,21666,'2da',3.333,5),(589,21680,21666,'da5',3.333,5),(589,21681,21666,'a59',3.333,5),(589,21682,21666,'59d',3.333,5),(589,21683,21666,'9d9',3.333,5),(589,21684,21666,'d94',3.333,5),(589,21685,21666,'94c',3.333,5),(589,21686,21666,'4c8',3.333,5),(589,21687,21666,'c8f',3.333,5),(589,21688,21666,'8f6',3.333,5),(589,21689,21666,'f6e',3.333,5),(589,21690,21666,'6ec',3.333,5),(589,21691,21666,'ec8',3.333,5),(589,21692,21666,'c88',3.333,5),(589,21693,21666,'886',3.333,5),(589,21694,21666,'86f',3.333,5),(589,21695,21666,'6fe',3.333,5),(589,21696,21666,'fe2',3.333,5),(590,21698,21697,'naa',100,5),(590,21699,21698,'600',3.333,5),(590,21700,21698,'000',3.333,5),(590,21701,21698,'00c',3.333,5),(590,21702,21698,'0c2',3.333,5),(590,21703,21698,'c29',3.333,5),(590,21704,21698,'297',3.333,5),(590,21705,21698,'97b',3.333,5),(590,21706,21698,'7bc',3.333,5),(590,21707,21698,'bce',3.333,5),(590,21708,21698,'ce6',3.333,5),(590,21709,21698,'e62',3.333,5),(590,21710,21698,'62b',3.333,5),(590,21711,21698,'2b3',3.333,5),(590,21712,21698,'b31',3.333,5),(590,21713,21698,'315',3.333,5),(590,21714,21698,'15a',3.333,5),(590,21715,21698,'5a5',3.333,5),(590,21716,21698,'a50',3.333,5),(590,21717,21698,'50c',3.333,5),(590,21718,21698,'0c4',3.333,5),(590,21719,21698,'c40',3.333,5),(590,21720,21698,'40d',3.333,5),(590,21721,21698,'0df',3.333,5),(590,21722,21698,'df1',3.333,5),(590,21723,21698,'f13',3.333,5),(590,21724,21698,'13c',3.333,5),(590,21725,21698,'3c2',3.333,5),(590,21726,21698,'c2d',3.333,5),(590,21727,21698,'2dd',3.333,5),(590,21728,21698,'dd6',3.333,5),(591,21730,21729,'naa',100,5),(591,21731,21730,'600',3.333,5),(591,21732,21730,'000',3.333,5),(591,21733,21730,'00c',3.333,5),(591,21734,21730,'0c2',3.333,5),(591,21735,21730,'c29',3.333,5),(591,21736,21730,'298',3.333,5),(591,21737,21730,'985',3.333,5),(591,21738,21730,'85b',3.333,5),(591,21739,21730,'5bf',3.333,5),(591,21740,21730,'bfc',3.333,5),(591,21741,21730,'fcf',3.333,5),(591,21742,21730,'cf5',3.333,5),(591,21743,21730,'f5e',3.333,5),(591,21744,21730,'5ee',3.333,5),(591,21745,21730,'ee2',3.333,5),(591,21746,21730,'e2f',3.333,5),(591,21747,21730,'2f6',3.333,5),(591,21748,21730,'f63',3.333,5),(591,21749,21730,'634',3.333,5),(591,21750,21730,'34c',3.333,5),(591,21751,21730,'4c9',3.333,5),(591,21752,21730,'c9b',3.333,5),(591,21753,21730,'9ba',3.333,5),(591,21754,21730,'bae',3.333,5),(591,21755,21730,'ae5',3.333,5),(591,21756,21730,'e55',3.333,5),(591,21757,21730,'55d',3.333,5),(591,21758,21730,'5dd',3.333,5),(591,21759,21730,'ddc',3.333,5),(591,21760,21730,'dc5',3.333,5),(592,21762,21761,'naa',100,5),(592,21763,21762,'600',3.333,5),(592,21764,21762,'000',3.333,5),(592,21765,21762,'00c',3.333,5),(592,21766,21762,'0c2',3.333,5),(592,21767,21762,'c29',3.333,5),(592,21768,21762,'295',3.333,5),(592,21769,21762,'953',3.333,5),(592,21770,21762,'539',3.333,5),(592,21771,21762,'39e',3.333,5),(592,21772,21762,'9e3',3.333,5),(592,21773,21762,'e34',3.333,5),(592,21774,21762,'341',3.333,5),(592,21775,21762,'41c',3.333,5),(592,21776,21762,'1cf',3.333,5),(592,21777,21762,'cf0',3.333,5),(592,21778,21762,'f08',3.333,5),(592,21779,21762,'088',3.333,5),(592,21780,21762,'88e',3.333,5),(592,21781,21762,'8ec',3.333,5),(592,21782,21762,'ec7',3.333,5),(592,21783,21762,'c7e',3.333,5),(592,21784,21762,'7e2',3.333,5),(592,21785,21762,'e27',3.333,5),(592,21786,21762,'27d',3.333,5),(592,21787,21762,'7dd',3.333,5),(592,21788,21762,'ddc',3.333,5),(592,21789,21762,'dc3',3.333,5),(592,21790,21762,'c37',3.333,5),(592,21791,21762,'371',3.333,5),(592,21792,21762,'719',3.333,5),(593,21794,21793,'naa',100,5),(593,21795,21794,'600',3.333,5),(593,21796,21794,'000',3.333,5),(593,21797,21794,'00c',3.333,5),(593,21798,21794,'0c2',3.333,5),(593,21799,21794,'c29',3.333,5),(593,21800,21794,'29f',3.333,5),(593,21801,21794,'9fa',3.333,5),(593,21802,21794,'fad',3.333,5),(593,21803,21794,'ad6',3.333,5),(593,21804,21794,'d65',3.333,5),(593,21805,21794,'652',3.333,5),(593,21806,21794,'526',3.333,5),(593,21807,21794,'26e',3.333,5),(593,21808,21794,'6e1',3.333,5),(593,21809,21794,'e16',3.333,5),(593,21810,21794,'164',3.333,5),(593,21811,21794,'641',3.333,5),(593,21812,21794,'41f',3.333,5),(593,21813,21794,'1f7',3.333,5),(593,21814,21794,'f7d',3.333,5),(593,21815,21794,'7d2',3.333,5),(593,21816,21794,'d24',3.333,5),(593,21817,21794,'243',3.333,5),(593,21818,21794,'43c',3.333,5),(593,21819,21794,'3cb',3.333,5),(593,21820,21794,'cbf',3.333,5),(593,21821,21794,'bff',3.333,5),(593,21822,21794,'ff5',3.333,5),(593,21823,21794,'f55',3.333,5),(593,21824,21794,'553',3.333,5),(594,21826,21825,'naa',100,5),(594,21827,21826,'600',3.333,5),(594,21828,21826,'000',3.333,5),(594,21829,21826,'00c',3.333,5),(594,21830,21826,'0c2',3.333,5),(594,21831,21826,'c29',3.333,5),(594,21832,21826,'29c',3.333,5),(594,21833,21826,'9cc',3.333,5),(594,21834,21826,'ccd',3.333,5),(594,21835,21826,'cdb',3.333,5),(594,21836,21826,'db2',3.333,5),(594,21837,21826,'b24',3.333,5),(594,21838,21826,'24e',3.333,5),(594,21839,21826,'4e2',3.333,5),(594,21840,21826,'e24',3.333,5),(594,21841,21826,'24d',3.333,5),(594,21842,21826,'4da',3.333,5),(594,21843,21826,'da4',3.333,5),(594,21844,21826,'a43',3.333,5),(594,21845,21826,'43e',3.333,5),(594,21846,21826,'3eb',3.333,5),(594,21847,21826,'ebd',3.333,5),(594,21848,21826,'bd4',3.333,5),(594,21849,21826,'d4a',3.333,5),(594,21850,21826,'4a5',3.333,5),(594,21851,21826,'a54',3.333,5),(594,21852,21826,'54f',3.333,5),(594,21853,21826,'4f1',3.333,5),(594,21854,21826,'f1c',3.333,5),(594,21855,21826,'1c7',3.333,5),(594,21856,21826,'c78',3.333,5),(595,21858,21857,'naa',100,5),(595,21859,21858,'600',3.333,5),(595,21860,21858,'000',3.333,5),(595,21861,21858,'00c',3.333,5),(595,21862,21858,'0c2',3.333,5),(595,21863,21858,'c29',3.333,5),(595,21864,21858,'29b',3.333,5),(595,21865,21858,'9be',3.333,5),(595,21866,21858,'be6',3.333,5),(595,21867,21858,'e68',3.333,5),(595,21868,21858,'68a',3.333,5),(595,21869,21858,'8a7',3.333,5),(595,21870,21858,'a76',3.333,5),(595,21871,21858,'767',3.333,5),(595,21872,21858,'67f',3.333,5),(595,21873,21858,'7f4',3.333,5),(595,21874,21858,'f4f',3.333,5),(595,21875,21858,'4fe',3.333,5),(595,21876,21858,'fe5',3.333,5),(595,21877,21858,'e5f',3.333,5),(595,21878,21858,'5f4',3.333,5),(595,21879,21858,'f4c',3.333,5),(595,21880,21858,'4c7',3.333,5),(595,21881,21858,'c7a',3.333,5),(595,21882,21858,'7af',3.333,5),(595,21883,21858,'af1',3.333,5),(595,21884,21858,'f1d',3.333,5),(595,21885,21858,'1d7',3.333,5),(595,21886,21858,'d78',3.333,5),(595,21887,21858,'783',3.333,5),(595,21888,21858,'830',3.333,5),(596,21890,21889,'naa',100,5),(596,21891,21890,'600',3.333,5),(596,21892,21890,'000',3.333,5),(596,21893,21890,'00c',3.333,5),(596,21894,21890,'0c2',3.333,5),(596,21895,21890,'c29',3.333,5),(596,21896,21890,'291',3.333,5),(596,21897,21890,'91d',3.333,5),(596,21898,21890,'1dc',3.333,5),(596,21899,21890,'dcc',3.333,5),(596,21900,21890,'cc5',3.333,5),(596,21901,21890,'c59',3.333,5),(596,21902,21890,'59a',3.333,5),(596,21903,21890,'9ac',3.333,5),(596,21904,21890,'ac0',3.333,5),(596,21905,21890,'c0b',3.333,5),(596,21906,21890,'0bb',3.333,5),(596,21907,21890,'bb9',3.333,5),(596,21908,21890,'b91',3.333,5),(596,21909,21890,'919',3.333,5),(596,21910,21890,'19a',3.333,5),(596,21911,21890,'9ac',3.333,5),(596,21912,21890,'aca',3.333,5),(596,21913,21890,'ca5',3.333,5),(596,21914,21890,'a5b',3.333,5),(596,21915,21890,'5b6',3.333,5),(596,21916,21890,'b69',3.333,5),(596,21917,21890,'69a',3.333,5),(596,21918,21890,'9a8',3.333,5),(596,21919,21890,'a81',3.333,5),(596,21920,21890,'810',3.333,5),(597,21922,21921,'naa',100,5),(597,21923,21922,'600',3.333,5),(597,21924,21922,'000',3.333,5),(597,21925,21922,'00c',3.333,5),(597,21926,21922,'0c2',3.333,5),(597,21927,21922,'c29',3.333,5),(597,21928,21922,'292',3.333,5),(597,21929,21922,'92b',3.333,5),(597,21930,21922,'2b2',3.333,5),(597,21931,21922,'b26',3.333,5),(597,21932,21922,'265',3.333,5),(597,21933,21922,'655',3.333,5),(597,21934,21922,'556',3.333,5),(597,21935,21922,'560',3.333,5),(597,21936,21922,'605',3.333,5),(597,21937,21922,'05e',3.333,5),(597,21938,21922,'5e5',3.333,5),(597,21939,21922,'e50',3.333,5),(597,21940,21922,'504',3.333,5),(597,21941,21922,'04b',3.333,5),(597,21942,21922,'4b7',3.333,5),(597,21943,21922,'b79',3.333,5),(597,21944,21922,'790',3.333,5),(597,21945,21922,'90b',3.333,5),(597,21946,21922,'0b6',3.333,5),(597,21947,21922,'b6e',3.333,5),(597,21948,21922,'6e0',3.333,5),(597,21949,21922,'e0b',3.333,5),(597,21950,21922,'0b4',3.333,5),(597,21951,21922,'b43',3.333,5),(597,21952,21922,'437',3.333,5),(598,21954,21953,'naa',100,5),(598,21955,21954,'600',3.333,5),(598,21956,21954,'000',3.333,5),(598,21957,21954,'00c',3.333,5),(598,21958,21954,'0c2',3.333,5),(598,21959,21954,'c29',3.333,5),(598,21960,21954,'290',3.333,5),(598,21961,21954,'905',3.333,5),(598,21962,21954,'05c',3.333,5),(598,21963,21954,'5c8',3.333,5),(598,21964,21954,'c8a',3.333,5),(598,21965,21954,'8ab',3.333,5),(598,21966,21954,'ab6',3.333,5),(598,21967,21954,'b63',3.333,5),(598,21968,21954,'634',3.333,5),(598,21969,21954,'341',3.333,5),(598,21970,21954,'411',3.333,5),(598,21971,21954,'112',3.333,5),(598,21972,21954,'127',3.333,5),(598,21973,21954,'274',3.333,5),(598,21974,21954,'748',3.333,5),(598,21975,21954,'48f',3.333,5),(598,21976,21954,'8f7',3.333,5),(598,21977,21954,'f71',3.333,5),(598,21978,21954,'71f',3.333,5),(598,21979,21954,'1f8',3.333,5),(598,21980,21954,'f8d',3.333,5),(598,21981,21954,'8db',3.333,5),(598,21982,21954,'db6',3.333,5),(598,21983,21954,'b6d',3.333,5),(598,21984,21954,'6df',3.333,5),(599,21986,21985,'naa',100,5),(599,21987,21986,'600',3.333,5),(599,21988,21986,'000',3.333,5),(599,21989,21986,'00c',3.333,5),(599,21990,21986,'0c2',3.333,5),(599,21991,21986,'c29',3.333,5),(599,21992,21986,'29d',3.333,5),(599,21993,21986,'9de',3.333,5),(599,21994,21986,'dec',3.333,5),(599,21995,21986,'ec9',3.333,5),(599,21996,21986,'c91',3.333,5),(599,21997,21986,'91c',3.333,5),(599,21998,21986,'1ce',3.333,5),(599,21999,21986,'ceb',3.333,5),(599,22000,21986,'eb4',3.333,5),(599,22001,21986,'b40',3.333,5),(599,22002,21986,'40a',3.333,5),(599,22003,21986,'0a9',3.333,5),(599,22004,21986,'a9a',3.333,5),(599,22005,21986,'9a0',3.333,5),(599,22006,21986,'a04',3.333,5),(599,22007,21986,'04b',3.333,5),(599,22008,21986,'4b1',3.333,5),(599,22009,21986,'b1d',3.333,5),(599,22010,21986,'1d7',3.333,5),(599,22011,21986,'d7d',3.333,5),(599,22012,21986,'7d8',3.333,5),(599,22013,21986,'d8d',3.333,5),(599,22014,21986,'8d2',3.333,5),(599,22015,21986,'d2c',3.333,5),(599,22016,21986,'2c0',3.333,5),(600,22018,22017,'naa',100,5),(600,22019,22018,'600',3.333,5),(600,22020,22018,'000',3.333,5),(600,22021,22018,'00c',3.333,5),(600,22022,22018,'0c2',3.333,5),(600,22023,22018,'c29',3.333,5),(600,22024,22018,'292',3.333,5),(600,22025,22018,'92a',3.333,5),(600,22026,22018,'2a3',3.333,5),(600,22027,22018,'a39',3.333,5),(600,22028,22018,'39d',3.333,5),(600,22029,22018,'9dc',3.333,5),(600,22030,22018,'dc2',3.333,5),(600,22031,22018,'c2d',3.333,5),(600,22032,22018,'2dc',3.333,5),(600,22033,22018,'dc4',3.333,5),(600,22034,22018,'c49',3.333,5),(600,22035,22018,'490',3.333,5),(600,22036,22018,'908',3.333,5),(600,22037,22018,'084',3.333,5),(600,22038,22018,'846',3.333,5),(600,22039,22018,'46e',3.333,5),(600,22040,22018,'6e2',3.333,5),(600,22041,22018,'e26',3.333,5),(600,22042,22018,'262',3.333,5),(600,22043,22018,'626',3.333,5),(600,22044,22018,'262',3.333,5),(600,22045,22018,'626',3.333,5),(600,22046,22018,'26f',3.333,5),(600,22047,22018,'6fe',3.333,5),(600,22048,22018,'fee',3.333,5),(601,22050,22049,'naa',100,5),(601,22051,22050,'600',3.333,5),(601,22052,22050,'000',3.333,5),(601,22053,22050,'00c',3.333,5),(601,22054,22050,'0c2',3.333,5),(601,22055,22050,'c29',3.333,5),(601,22056,22050,'29d',3.333,5),(601,22057,22050,'9d9',3.333,5),(601,22058,22050,'d95',3.333,5),(601,22059,22050,'95b',3.333,5),(601,22060,22050,'5b6',3.333,5),(601,22061,22050,'b6f',3.333,5),(601,22062,22050,'6fa',3.333,5),(601,22063,22050,'fa4',3.333,5),(601,22064,22050,'a44',3.333,5),(601,22065,22050,'441',3.333,5),(601,22066,22050,'412',3.333,5),(601,22067,22050,'126',3.333,5),(601,22068,22050,'264',3.333,5),(601,22069,22050,'64f',3.333,5),(601,22070,22050,'4f6',3.333,5),(601,22071,22050,'f68',3.333,5),(601,22072,22050,'688',3.333,5),(601,22073,22050,'881',3.333,5),(601,22074,22050,'818',3.333,5),(601,22075,22050,'186',3.333,5),(601,22076,22050,'868',3.333,5),(601,22077,22050,'680',3.333,5),(601,22078,22050,'802',3.333,5),(601,22079,22050,'024',3.333,5),(601,22080,22050,'24e',3.333,5),(602,22082,22081,'naa',100,5),(602,22083,22082,'600',3.333,5),(602,22084,22082,'000',3.333,5),(602,22085,22082,'00c',3.333,5),(602,22086,22082,'0c2',3.333,5),(602,22087,22082,'c29',3.333,5),(602,22088,22082,'296',3.333,5),(602,22089,22082,'96a',3.333,5),(602,22090,22082,'6ab',3.333,5),(602,22091,22082,'abe',3.333,5),(602,22092,22082,'be6',3.333,5),(602,22093,22082,'e69',3.333,5),(602,22094,22082,'696',3.333,5),(602,22095,22082,'96d',3.333,5),(602,22096,22082,'6dd',3.333,5),(602,22097,22082,'dd2',3.333,5),(602,22098,22082,'d22',3.333,5),(602,22099,22082,'22c',3.333,5),(602,22100,22082,'2c1',3.333,5),(602,22101,22082,'c14',3.333,5),(602,22102,22082,'14c',3.333,5),(602,22103,22082,'4cc',3.333,5),(602,22104,22082,'cc7',3.333,5),(602,22105,22082,'c77',3.333,5),(602,22106,22082,'776',3.333,5),(602,22107,22082,'767',3.333,5),(602,22108,22082,'672',3.333,5),(602,22109,22082,'72d',3.333,5),(602,22110,22082,'2d2',3.333,5),(602,22111,22082,'d24',3.333,5),(602,22112,22082,'24b',3.333,5),(603,22114,22113,'naa',100,5),(603,22115,22114,'600',3.333,5),(603,22116,22114,'000',3.333,5),(603,22117,22114,'00c',3.333,5),(603,22118,22114,'0c2',3.333,5),(603,22119,22114,'c29',3.333,5),(603,22120,22114,'293',3.333,5),(603,22121,22114,'934',3.333,5),(603,22122,22114,'34d',3.333,5),(603,22123,22114,'4d3',3.333,5),(603,22124,22114,'d39',3.333,5),(603,22125,22114,'393',3.333,5),(603,22126,22114,'93e',3.333,5),(603,22127,22114,'3e4',3.333,5),(603,22128,22114,'e43',3.333,5),(603,22129,22114,'432',3.333,5),(603,22130,22114,'324',3.333,5),(603,22131,22114,'24b',3.333,5),(603,22132,22114,'4b6',3.333,5),(603,22133,22114,'b62',3.333,5),(603,22134,22114,'621',3.333,5),(603,22135,22114,'21b',3.333,5),(603,22136,22114,'1b2',3.333,5),(603,22137,22114,'b20',3.333,5),(603,22138,22114,'201',3.333,5),(603,22139,22114,'01a',3.333,5),(603,22140,22114,'1a4',3.333,5),(603,22141,22114,'a4c',3.333,5),(603,22142,22114,'4cc',3.333,5),(603,22143,22114,'cc0',3.333,5),(603,22144,22114,'c0a',3.333,5),(604,22146,22145,'naa',100,5),(604,22147,22146,'600',3.333,5),(604,22148,22146,'000',3.333,5),(604,22149,22146,'00c',3.333,5),(604,22150,22146,'0c2',3.333,5),(604,22151,22146,'c29',3.333,5),(604,22152,22146,'290',3.333,5),(604,22153,22146,'907',3.333,5),(604,22154,22146,'07e',3.333,5),(604,22155,22146,'7e1',3.333,5),(604,22156,22146,'e15',3.333,5),(604,22157,22146,'157',3.333,5),(604,22158,22146,'57e',3.333,5),(604,22159,22146,'7e3',3.333,5),(604,22160,22146,'e33',3.333,5),(604,22161,22146,'338',3.333,5),(604,22162,22146,'381',3.333,5),(604,22163,22146,'814',3.333,5),(604,22164,22146,'143',3.333,5),(604,22165,22146,'43d',3.333,5),(604,22166,22146,'3dc',3.333,5),(604,22167,22146,'dc2',3.333,5),(604,22168,22146,'c24',3.333,5),(604,22169,22146,'248',3.333,5),(604,22170,22146,'48f',3.333,5),(604,22171,22146,'8f1',3.333,5),(604,22172,22146,'f1f',3.333,5),(604,22173,22146,'1f2',3.333,5),(604,22174,22146,'f27',3.333,5),(604,22175,22146,'278',3.333,5),(604,22176,22146,'78e',3.333,5),(605,22178,22177,'naa',100,5),(605,22179,22178,'600',3.333,5),(605,22180,22178,'000',3.333,5),(605,22181,22178,'00c',3.333,5),(605,22182,22178,'0c2',3.333,5),(605,22183,22178,'c29',3.333,5),(605,22184,22178,'290',3.333,5),(605,22185,22178,'90b',3.333,5),(605,22186,22178,'0be',3.333,5),(605,22187,22178,'bec',3.333,5),(605,22188,22178,'ec0',3.333,5),(605,22189,22178,'c05',3.333,5),(605,22190,22178,'05e',3.333,5),(605,22191,22178,'5e4',3.333,5),(605,22192,22178,'e4c',3.333,5),(605,22193,22178,'4c5',3.333,5),(605,22194,22178,'c53',3.333,5),(605,22195,22178,'53d',3.333,5),(605,22196,22178,'3d2',3.333,5),(605,22197,22178,'d26',3.333,5),(605,22198,22178,'26c',3.333,5),(605,22199,22178,'6c5',3.333,5),(605,22200,22178,'c59',3.333,5),(605,22201,22178,'595',3.333,5),(605,22202,22178,'95a',3.333,5),(605,22203,22178,'5a4',3.333,5),(605,22204,22178,'a45',3.333,5),(605,22205,22178,'450',3.333,5),(605,22206,22178,'50b',3.333,5),(605,22207,22178,'0b6',3.333,5),(605,22208,22178,'b64',3.333,5),(606,22210,22209,'naa',100,5),(606,22211,22210,'600',3.333,5),(606,22212,22210,'000',3.333,5),(606,22213,22210,'00c',3.333,5),(606,22214,22210,'0c2',3.333,5),(606,22215,22210,'c29',3.333,5),(606,22216,22210,'29b',3.333,5),(606,22217,22210,'9b5',3.333,5),(606,22218,22210,'b5c',3.333,5),(606,22219,22210,'5cc',3.333,5),(606,22220,22210,'cc8',3.333,5),(606,22221,22210,'c8a',3.333,5),(606,22222,22210,'8a1',3.333,5),(606,22223,22210,'a16',3.333,5),(606,22224,22210,'169',3.333,5),(606,22225,22210,'694',3.333,5),(606,22226,22210,'94c',3.333,5),(606,22227,22210,'4cb',3.333,5),(606,22228,22210,'cb9',3.333,5),(606,22229,22210,'b91',3.333,5),(606,22230,22210,'91e',3.333,5),(606,22231,22210,'1e7',3.333,5),(606,22232,22210,'e78',3.333,5),(606,22233,22210,'785',3.333,5),(606,22234,22210,'854',3.333,5),(606,22235,22210,'54d',3.333,5),(606,22236,22210,'4df',3.333,5),(606,22237,22210,'dfe',3.333,5),(606,22238,22210,'fe4',3.333,5),(606,22239,22210,'e46',3.333,5),(606,22240,22210,'465',3.333,5),(607,22242,22241,'naa',100,5),(607,22243,22242,'600',3.333,5),(607,22244,22242,'000',3.333,5),(607,22245,22242,'00c',3.333,5),(607,22246,22242,'0c2',3.333,5),(607,22247,22242,'c29',3.333,5),(607,22248,22242,'29f',3.333,5),(607,22249,22242,'9f0',3.333,5),(607,22250,22242,'f0c',3.333,5),(607,22251,22242,'0c2',3.333,5),(607,22252,22242,'c28',3.333,5),(607,22253,22242,'28d',3.333,5),(607,22254,22242,'8dd',3.333,5),(607,22255,22242,'ddf',3.333,5),(607,22256,22242,'df2',3.333,5),(607,22257,22242,'f27',3.333,5),(607,22258,22242,'273',3.333,5),(607,22259,22242,'736',3.333,5),(607,22260,22242,'368',3.333,5),(607,22261,22242,'684',3.333,5),(607,22262,22242,'844',3.333,5),(607,22263,22242,'441',3.333,5),(607,22264,22242,'411',3.333,5),(607,22265,22242,'118',3.333,5),(607,22266,22242,'189',3.333,5),(607,22267,22242,'893',3.333,5),(607,22268,22242,'938',3.333,5),(607,22269,22242,'38f',3.333,5),(607,22270,22242,'8fd',3.333,5),(607,22271,22242,'fdf',3.333,5),(607,22272,22242,'dfd',3.333,5),(608,22274,22273,'naa',100,5),(608,22275,22274,'600',3.333,5),(608,22276,22274,'000',3.333,5),(608,22277,22274,'00c',3.333,5),(608,22278,22274,'0c2',3.333,5),(608,22279,22274,'c29',3.333,5),(608,22280,22274,'29e',3.333,5),(608,22281,22274,'9eb',3.333,5),(608,22282,22274,'eb7',3.333,5),(608,22283,22274,'b7a',3.333,5),(608,22284,22274,'7a5',3.333,5),(608,22285,22274,'a58',3.333,5),(608,22286,22274,'58a',3.333,5),(608,22287,22274,'8aa',3.333,5),(608,22288,22274,'aa7',3.333,5),(608,22289,22274,'a71',3.333,5),(608,22290,22274,'710',3.333,5),(608,22291,22274,'101',3.333,5),(608,22292,22274,'016',3.333,5),(608,22293,22274,'16c',3.333,5),(608,22294,22274,'6c9',3.333,5),(608,22295,22274,'c95',3.333,5),(608,22296,22274,'952',3.333,5),(608,22297,22274,'521',3.333,5),(608,22298,22274,'21d',3.333,5),(608,22299,22274,'1db',3.333,5),(608,22300,22274,'db7',3.333,5),(608,22301,22274,'b7d',3.333,5),(608,22302,22274,'7d3',3.333,5),(608,22303,22274,'d3a',3.333,5),(608,22304,22274,'3a6',3.333,5),(609,22306,22305,'naa',100,5),(609,22307,22306,'600',3.333,5),(609,22308,22306,'000',3.333,5),(609,22309,22306,'00c',3.333,5),(609,22310,22306,'0c2',3.333,5),(609,22311,22306,'c29',3.333,5),(609,22312,22306,'298',3.333,5),(609,22313,22306,'986',3.333,5),(609,22314,22306,'866',3.333,5),(609,22315,22306,'669',3.333,5),(609,22316,22306,'695',3.333,5),(609,22317,22306,'95b',3.333,5),(609,22318,22306,'5b7',3.333,5),(609,22319,22306,'b7f',3.333,5),(609,22320,22306,'7f1',3.333,5),(609,22321,22306,'f12',3.333,5),(609,22322,22306,'12f',3.333,5),(609,22323,22306,'2fd',3.333,5),(609,22324,22306,'fd4',3.333,5),(609,22325,22306,'d45',3.333,5),(609,22326,22306,'45d',3.333,5),(609,22327,22306,'5d2',3.333,5),(609,22328,22306,'d2c',3.333,5),(609,22329,22306,'2c6',3.333,5),(609,22330,22306,'c66',3.333,5),(609,22331,22306,'66d',3.333,5),(609,22332,22306,'6d9',3.333,5),(609,22333,22306,'d92',3.333,5),(609,22334,22306,'921',3.333,5),(609,22335,22306,'211',3.333,5),(609,22336,22306,'112',3.333,5),(610,22338,22337,'naa',100,5),(610,22339,22338,'600',3.333,5),(610,22340,22338,'000',3.333,5),(610,22341,22338,'00c',3.333,5),(610,22342,22338,'0c2',3.333,5),(610,22343,22338,'c29',3.333,5),(610,22344,22338,'295',3.333,5),(610,22345,22338,'95e',3.333,5),(610,22346,22338,'5e4',3.333,5),(610,22347,22338,'e45',3.333,5),(610,22348,22338,'45c',3.333,5),(610,22349,22338,'5c7',3.333,5),(610,22350,22338,'c7f',3.333,5),(610,22351,22338,'7f9',3.333,5),(610,22352,22338,'f98',3.333,5),(610,22353,22338,'987',3.333,5),(610,22354,22338,'873',3.333,5),(610,22355,22338,'73f',3.333,5),(610,22356,22338,'3f4',3.333,5),(610,22357,22338,'f48',3.333,5),(610,22358,22338,'48b',3.333,5),(610,22359,22338,'8b1',3.333,5),(610,22360,22338,'b14',3.333,5),(610,22361,22338,'14f',3.333,5),(610,22362,22338,'4fa',3.333,5),(610,22363,22338,'fac',3.333,5),(610,22364,22338,'ac7',3.333,5),(610,22365,22338,'c7e',3.333,5),(610,22366,22338,'7eb',3.333,5),(610,22367,22338,'eb8',3.333,5),(610,22368,22338,'b8d',3.333,5),(611,22370,22369,'naa',100,5),(611,22371,22370,'600',3.333,5),(611,22372,22370,'000',3.333,5),(611,22373,22370,'00c',3.333,5),(611,22374,22370,'0c2',3.333,5),(611,22375,22370,'c29',3.333,5),(611,22376,22370,'291',3.333,5),(611,22377,22370,'91b',3.333,5),(611,22378,22370,'1bf',3.333,5),(611,22379,22370,'bf4',3.333,5),(611,22380,22370,'f43',3.333,5),(611,22381,22370,'435',3.333,5),(611,22382,22370,'355',3.333,5),(611,22383,22370,'551',3.333,5),(611,22384,22370,'517',3.333,5),(611,22385,22370,'177',3.333,5),(611,22386,22370,'77d',3.333,5),(611,22387,22370,'7dd',3.333,5),(611,22388,22370,'dde',3.333,5),(611,22389,22370,'de9',3.333,5),(611,22390,22370,'e92',3.333,5),(611,22391,22370,'924',3.333,5),(611,22392,22370,'242',3.333,5),(611,22393,22370,'42a',3.333,5),(611,22394,22370,'2a6',3.333,5),(611,22395,22370,'a67',3.333,5),(611,22396,22370,'672',3.333,5),(611,22397,22370,'720',3.333,5),(611,22398,22370,'202',3.333,5),(611,22399,22370,'026',3.333,5),(611,22400,22370,'26c',3.333,5),(612,22402,22401,'naa',100,5),(612,22403,22402,'600',3.333,5),(612,22404,22402,'000',3.333,5),(612,22405,22402,'00c',3.333,5),(612,22406,22402,'0c2',3.333,5),(612,22407,22402,'c29',3.333,5),(612,22408,22402,'29f',3.333,5),(612,22409,22402,'9f8',3.333,5),(612,22410,22402,'f80',3.333,5),(612,22411,22402,'800',3.333,5),(612,22412,22402,'008',3.333,5),(612,22413,22402,'084',3.333,5),(612,22414,22402,'84c',3.333,5),(612,22415,22402,'4ce',3.333,5),(612,22416,22402,'ce0',3.333,5),(612,22417,22402,'e07',3.333,5),(612,22418,22402,'07e',3.333,5),(612,22419,22402,'7ee',3.333,5),(612,22420,22402,'ee9',3.333,5),(612,22421,22402,'e9e',3.333,5),(612,22422,22402,'9e4',3.333,5),(612,22423,22402,'e40',3.333,5),(612,22424,22402,'40e',3.333,5),(612,22425,22402,'0e3',3.333,5),(612,22426,22402,'e3c',3.333,5),(612,22427,22402,'3c5',3.333,5),(612,22428,22402,'c5f',3.333,5),(612,22429,22402,'5fb',3.333,5),(612,22430,22402,'fb9',3.333,5),(612,22431,22402,'b98',3.333,5),(612,22432,22402,'988',3.333,5),(613,22434,22433,'naa',100,5),(613,22435,22434,'600',3.333,5),(613,22436,22434,'000',3.333,5),(613,22437,22434,'00c',3.333,5),(613,22438,22434,'0c2',3.333,5),(613,22439,22434,'c29',3.333,5),(613,22440,22434,'29a',3.333,5),(613,22441,22434,'9ac',3.333,5),(613,22442,22434,'acf',3.333,5),(613,22443,22434,'cff',3.333,5),(613,22444,22434,'ff7',3.333,5),(613,22445,22434,'f78',3.333,5),(613,22446,22434,'780',3.333,5),(613,22447,22434,'800',3.333,5),(613,22448,22434,'002',3.333,5),(613,22449,22434,'028',3.333,5),(613,22450,22434,'281',3.333,5),(613,22451,22434,'81e',3.333,5),(613,22452,22434,'1eb',3.333,5),(613,22453,22434,'eb8',3.333,5),(613,22454,22434,'b8c',3.333,5),(613,22455,22434,'8c0',3.333,5),(613,22456,22434,'c0a',3.333,5),(613,22457,22434,'0a1',3.333,5),(613,22458,22434,'a19',3.333,5),(613,22459,22434,'19e',3.333,5),(613,22460,22434,'9ec',3.333,5),(613,22461,22434,'ec6',3.333,5),(613,22462,22434,'c64',3.333,5),(613,22463,22434,'64a',3.333,5),(613,22464,22434,'4a0',3.333,5),(614,22466,22465,'naa',100,5),(614,22467,22466,'600',3.333,5),(614,22468,22466,'000',3.333,5),(614,22469,22466,'00c',3.333,5),(614,22470,22466,'0c2',3.333,5),(614,22471,22466,'c29',3.333,5),(614,22472,22466,'297',3.333,5),(614,22473,22466,'979',3.333,5),(614,22474,22466,'79b',3.333,5),(614,22475,22466,'9b8',3.333,5),(614,22476,22466,'b8c',3.333,5),(614,22477,22466,'8cd',3.333,5),(614,22478,22466,'cd0',3.333,5),(614,22479,22466,'d0e',3.333,5),(614,22480,22466,'0e5',3.333,5),(614,22481,22466,'e54',3.333,5),(614,22482,22466,'544',3.333,5),(614,22483,22466,'447',3.333,5),(614,22484,22466,'47d',3.333,5),(614,22485,22466,'7dd',3.333,5),(614,22486,22466,'dd2',3.333,5),(614,22487,22466,'d20',3.333,5),(614,22488,22466,'20a',3.333,5),(614,22489,22466,'0a5',3.333,5),(614,22490,22466,'a58',3.333,5),(614,22491,22466,'58c',3.333,5),(614,22492,22466,'8ca',3.333,5),(614,22493,22466,'ca6',3.333,5),(614,22494,22466,'a69',3.333,5),(614,22495,22466,'69b',3.333,5),(614,22496,22466,'9bc',3.333,5),(615,22498,22497,'naa',100,5),(615,22499,22498,'600',3.333,5),(615,22500,22498,'000',3.333,5),(615,22501,22498,'00c',3.333,5),(615,22502,22498,'0c2',3.333,5),(615,22503,22498,'c29',3.333,5),(615,22504,22498,'295',3.333,5),(615,22505,22498,'958',3.333,5),(615,22506,22498,'58d',3.333,5),(615,22507,22498,'8de',3.333,5),(615,22508,22498,'de8',3.333,5),(615,22509,22498,'e89',3.333,5),(615,22510,22498,'897',3.333,5),(615,22511,22498,'978',3.333,5),(615,22512,22498,'78e',3.333,5),(615,22513,22498,'8e8',3.333,5),(615,22514,22498,'e82',3.333,5),(615,22515,22498,'829',3.333,5),(615,22516,22498,'299',3.333,5),(615,22517,22498,'99a',3.333,5),(615,22518,22498,'9ad',3.333,5),(615,22519,22498,'ad3',3.333,5),(615,22520,22498,'d35',3.333,5),(615,22521,22498,'357',3.333,5),(615,22522,22498,'573',3.333,5),(615,22523,22498,'739',3.333,5),(615,22524,22498,'39e',3.333,5),(615,22525,22498,'9ed',3.333,5),(615,22526,22498,'ed1',3.333,5),(615,22527,22498,'d1a',3.333,5),(615,22528,22498,'1ab',3.333,5),(616,22530,22529,'naa',100,5),(616,22531,22530,'600',3.333,5),(616,22532,22530,'000',3.333,5),(616,22533,22530,'00c',3.333,5),(616,22534,22530,'0c2',3.333,5),(616,22535,22530,'c29',3.333,5),(616,22536,22530,'299',3.333,5),(616,22537,22530,'99b',3.333,5),(616,22538,22530,'9be',3.333,5),(616,22539,22530,'bed',3.333,5),(616,22540,22530,'edb',3.333,5),(616,22541,22530,'dbe',3.333,5),(616,22542,22530,'bed',3.333,5),(616,22543,22530,'edf',3.333,5),(616,22544,22530,'df7',3.333,5),(616,22545,22530,'f75',3.333,5),(616,22546,22530,'75a',3.333,5),(616,22547,22530,'5af',3.333,5),(616,22548,22530,'afc',3.333,5),(616,22549,22530,'fce',3.333,5),(616,22550,22530,'ce5',3.333,5),(616,22551,22530,'e59',3.333,5),(616,22552,22530,'591',3.333,5),(616,22553,22530,'913',3.333,5),(616,22554,22530,'132',3.333,5),(616,22555,22530,'32f',3.333,5),(616,22556,22530,'2f4',3.333,5),(616,22557,22530,'f4e',3.333,5),(616,22558,22530,'4eb',3.333,5),(616,22559,22530,'eb9',3.333,5),(616,22560,22530,'b96',3.333,5),(617,22562,22561,'naa',100,5),(617,22563,22562,'600',3.333,5),(617,22564,22562,'000',3.333,5),(617,22565,22562,'00c',3.333,5),(617,22566,22562,'0c2',3.333,5),(617,22567,22562,'c29',3.333,5),(617,22568,22562,'298',3.333,5),(617,22569,22562,'987',3.333,5),(617,22570,22562,'873',3.333,5),(617,22571,22562,'734',3.333,5),(617,22572,22562,'347',3.333,5),(617,22573,22562,'47d',3.333,5),(617,22574,22562,'7db',3.333,5),(617,22575,22562,'db6',3.333,5),(617,22576,22562,'b64',3.333,5),(617,22577,22562,'64d',3.333,5),(617,22578,22562,'4d3',3.333,5),(617,22579,22562,'d3d',3.333,5),(617,22580,22562,'3d6',3.333,5),(617,22581,22562,'d63',3.333,5),(617,22582,22562,'63b',3.333,5),(617,22583,22562,'3bc',3.333,5),(617,22584,22562,'bca',3.333,5),(617,22585,22562,'ca6',3.333,5),(617,22586,22562,'a6e',3.333,5),(617,22587,22562,'6e6',3.333,5),(617,22588,22562,'e6f',3.333,5),(617,22589,22562,'6f5',3.333,5),(617,22590,22562,'f5b',3.333,5),(617,22591,22562,'5b2',3.333,5),(617,22592,22562,'b20',3.333,5),(618,22594,22593,'naa',100,5),(618,22595,22594,'600',3.333,5),(618,22596,22594,'000',3.333,5),(618,22597,22594,'00c',3.333,5),(618,22598,22594,'0c2',3.333,5),(618,22599,22594,'c29',3.333,5),(618,22600,22594,'294',3.333,5),(618,22601,22594,'94d',3.333,5),(618,22602,22594,'4df',3.333,5),(618,22603,22594,'df3',3.333,5),(618,22604,22594,'f32',3.333,5),(618,22605,22594,'32d',3.333,5),(618,22606,22594,'2d5',3.333,5),(618,22607,22594,'d51',3.333,5),(618,22608,22594,'51c',3.333,5),(618,22609,22594,'1c4',3.333,5),(618,22610,22594,'c47',3.333,5),(618,22611,22594,'477',3.333,5),(618,22612,22594,'77f',3.333,5),(618,22613,22594,'7fe',3.333,5),(618,22614,22594,'fe2',3.333,5),(618,22615,22594,'e28',3.333,5),(618,22616,22594,'285',3.333,5),(618,22617,22594,'851',3.333,5),(618,22618,22594,'517',3.333,5),(618,22619,22594,'171',3.333,5),(618,22620,22594,'716',3.333,5),(618,22621,22594,'168',3.333,5),(618,22622,22594,'685',3.333,5),(618,22623,22594,'851',3.333,5),(618,22624,22594,'51c',3.333,5),(619,22626,22625,'naa',100,5),(619,22627,22626,'600',3.333,5),(619,22628,22626,'000',3.333,5),(619,22629,22626,'00c',3.333,5),(619,22630,22626,'0c2',3.333,5),(619,22631,22626,'c29',3.333,5),(619,22632,22626,'293',3.333,5),(619,22633,22626,'931',3.333,5),(619,22634,22626,'31e',3.333,5),(619,22635,22626,'1ef',3.333,5),(619,22636,22626,'ef6',3.333,5),(619,22637,22626,'f6f',3.333,5),(619,22638,22626,'6fc',3.333,5),(619,22639,22626,'fc4',3.333,5),(619,22640,22626,'c47',3.333,5),(619,22641,22626,'475',3.333,5),(619,22642,22626,'75f',3.333,5),(619,22643,22626,'5f1',3.333,5),(619,22644,22626,'f1b',3.333,5),(619,22645,22626,'1bc',3.333,5),(619,22646,22626,'bcb',3.333,5),(619,22647,22626,'cb2',3.333,5),(619,22648,22626,'b2a',3.333,5),(619,22649,22626,'2a1',3.333,5),(619,22650,22626,'a17',3.333,5),(619,22651,22626,'17b',3.333,5),(619,22652,22626,'7b0',3.333,5),(619,22653,22626,'b07',3.333,5),(619,22654,22626,'07e',3.333,5),(619,22655,22626,'7e4',3.333,5),(619,22656,22626,'e44',3.333,5),(620,22658,22657,'naa',100,5),(620,22659,22658,'600',3.333,5),(620,22660,22658,'000',3.333,5),(620,22661,22658,'00c',3.333,5),(620,22662,22658,'0c2',3.333,5),(620,22663,22658,'c29',3.333,5),(620,22664,22658,'293',3.333,5),(620,22665,22658,'937',3.333,5),(620,22666,22658,'37b',3.333,5),(620,22667,22658,'7bd',3.333,5),(620,22668,22658,'bdd',3.333,5),(620,22669,22658,'dde',3.333,5),(620,22670,22658,'de3',3.333,5),(620,22671,22658,'e3b',3.333,5),(620,22672,22658,'3bb',3.333,5),(620,22673,22658,'bb9',3.333,5),(620,22674,22658,'b9b',3.333,5),(620,22675,22658,'9bc',3.333,5),(620,22676,22658,'bc7',3.333,5),(620,22677,22658,'c75',3.333,5),(620,22678,22658,'757',3.333,5),(620,22679,22658,'576',3.333,5),(620,22680,22658,'76d',3.333,5),(620,22681,22658,'6d6',3.333,5),(620,22682,22658,'d6f',3.333,5),(620,22683,22658,'6f8',3.333,5),(620,22684,22658,'f82',3.333,5),(620,22685,22658,'82a',3.333,5),(620,22686,22658,'2af',3.333,5),(620,22687,22658,'af2',3.333,5),(620,22688,22658,'f2b',3.333,5),(621,22690,22689,'naa',100,5),(621,22691,22690,'600',3.333,5),(621,22692,22690,'000',3.333,5),(621,22693,22690,'00c',3.333,5),(621,22694,22690,'0c2',3.333,5),(621,22695,22690,'c29',3.333,5),(621,22696,22690,'290',3.333,5),(621,22697,22690,'90c',3.333,5),(621,22698,22690,'0c1',3.333,5),(621,22699,22690,'c1b',3.333,5),(621,22700,22690,'1b4',3.333,5),(621,22701,22690,'b46',3.333,5),(621,22702,22690,'465',3.333,5),(621,22703,22690,'652',3.333,5),(621,22704,22690,'52f',3.333,5),(621,22705,22690,'2f4',3.333,5),(621,22706,22690,'f44',3.333,5),(621,22707,22690,'44d',3.333,5),(621,22708,22690,'4da',3.333,5),(621,22709,22690,'dae',3.333,5),(621,22710,22690,'aeb',3.333,5),(621,22711,22690,'eb7',3.333,5),(621,22712,22690,'b75',3.333,5),(621,22713,22690,'751',3.333,5),(621,22714,22690,'51a',3.333,5),(621,22715,22690,'1ad',3.333,5),(621,22716,22690,'ad9',3.333,5),(621,22717,22690,'d98',3.333,5),(621,22718,22690,'985',3.333,5),(621,22719,22690,'854',3.333,5),(621,22720,22690,'54d',3.333,5),(622,22722,22721,'naa',100,5),(622,22723,22722,'600',3.333,5),(622,22724,22722,'000',3.333,5),(622,22725,22722,'00c',3.333,5),(622,22726,22722,'0c2',3.333,5),(622,22727,22722,'c29',3.333,5),(622,22728,22722,'29e',3.333,5),(622,22729,22722,'9ed',3.333,5),(622,22730,22722,'ed0',3.333,5),(622,22731,22722,'d0f',3.333,5),(622,22732,22722,'0f8',3.333,5),(622,22733,22722,'f81',3.333,5),(622,22734,22722,'819',3.333,5),(622,22735,22722,'19c',3.333,5),(622,22736,22722,'9ca',3.333,5),(622,22737,22722,'ca5',3.333,5),(622,22738,22722,'a5a',3.333,5),(622,22739,22722,'5a1',3.333,5),(622,22740,22722,'a1e',3.333,5),(622,22741,22722,'1e2',3.333,5),(622,22742,22722,'e23',3.333,5),(622,22743,22722,'23b',3.333,5),(622,22744,22722,'3b3',3.333,5),(622,22745,22722,'b3c',3.333,5),(622,22746,22722,'3c2',3.333,5),(622,22747,22722,'c25',3.333,5),(622,22748,22722,'254',3.333,5),(622,22749,22722,'54c',3.333,5),(622,22750,22722,'4cc',3.333,5),(622,22751,22722,'cc4',3.333,5),(622,22752,22722,'c4a',3.333,5),(623,22754,22753,'naa',100,5),(623,22755,22754,'600',3.333,5),(623,22756,22754,'000',3.333,5),(623,22757,22754,'00c',3.333,5),(623,22758,22754,'0c2',3.333,5),(623,22759,22754,'c29',3.333,5),(623,22760,22754,'299',3.333,5),(623,22761,22754,'999',3.333,5),(623,22762,22754,'996',3.333,5),(623,22763,22754,'966',3.333,5),(623,22764,22754,'66a',3.333,5),(623,22765,22754,'6a3',3.333,5),(623,22766,22754,'a35',3.333,5),(623,22767,22754,'352',3.333,5),(623,22768,22754,'52c',3.333,5),(623,22769,22754,'2c5',3.333,5),(623,22770,22754,'c5b',3.333,5),(623,22771,22754,'5bf',3.333,5),(623,22772,22754,'bf2',3.333,5),(623,22773,22754,'f24',3.333,5),(623,22774,22754,'244',3.333,5),(623,22775,22754,'44e',3.333,5),(623,22776,22754,'4e5',3.333,5),(623,22777,22754,'e5a',3.333,5),(623,22778,22754,'5a2',3.333,5),(623,22779,22754,'a26',3.333,5),(623,22780,22754,'267',3.333,5),(623,22781,22754,'672',3.333,5),(623,22782,22754,'720',3.333,5),(623,22783,22754,'20a',3.333,5),(623,22784,22754,'0a7',3.333,5),(624,22786,22785,'naa',100,5),(624,22787,22786,'600',3.333,5),(624,22788,22786,'000',3.333,5),(624,22789,22786,'00c',3.333,5),(624,22790,22786,'0c2',3.333,5),(624,22791,22786,'c29',3.333,5),(624,22792,22786,'291',3.333,5),(624,22793,22786,'916',3.333,5),(624,22794,22786,'16e',3.333,5),(624,22795,22786,'6ee',3.333,5),(624,22796,22786,'eea',3.333,5),(624,22797,22786,'ea5',3.333,5),(624,22798,22786,'a58',3.333,5),(624,22799,22786,'587',3.333,5),(624,22800,22786,'870',3.333,5),(624,22801,22786,'704',3.333,5),(624,22802,22786,'046',3.333,5),(624,22803,22786,'46f',3.333,5),(624,22804,22786,'6f1',3.333,5),(624,22805,22786,'f1c',3.333,5),(624,22806,22786,'1c7',3.333,5),(624,22807,22786,'c71',3.333,5),(624,22808,22786,'71a',3.333,5),(624,22809,22786,'1a3',3.333,5),(624,22810,22786,'a36',3.333,5),(624,22811,22786,'36b',3.333,5),(624,22812,22786,'6be',3.333,5),(624,22813,22786,'be3',3.333,5),(624,22814,22786,'e34',3.333,5),(624,22815,22786,'347',3.333,5),(624,22816,22786,'47e',3.333,5),(625,22818,22817,'naa',100,5),(625,22819,22818,'600',3.333,5),(625,22820,22818,'000',3.333,5),(625,22821,22818,'00c',3.333,5),(625,22822,22818,'0c2',3.333,5),(625,22823,22818,'c29',3.333,5),(625,22824,22818,'29f',3.333,5),(625,22825,22818,'9f9',3.333,5),(625,22826,22818,'f9b',3.333,5),(625,22827,22818,'9b5',3.333,5),(625,22828,22818,'b54',3.333,5),(625,22829,22818,'545',3.333,5),(625,22830,22818,'455',3.333,5),(625,22831,22818,'550',3.333,5),(625,22832,22818,'508',3.333,5),(625,22833,22818,'08d',3.333,5),(625,22834,22818,'8d4',3.333,5),(625,22835,22818,'d43',3.333,5),(625,22836,22818,'434',3.333,5),(625,22837,22818,'347',3.333,5),(625,22838,22818,'479',3.333,5),(625,22839,22818,'79c',3.333,5),(625,22840,22818,'9ce',3.333,5),(625,22841,22818,'cef',3.333,5),(625,22842,22818,'ef2',3.333,5),(625,22843,22818,'f2a',3.333,5),(625,22844,22818,'2af',3.333,5),(625,22845,22818,'afd',3.333,5),(625,22846,22818,'fd0',3.333,5),(625,22847,22818,'d0e',3.333,5),(625,22848,22818,'0ec',3.333,5),(626,22850,22849,'naa',100,5),(626,22851,22850,'600',3.333,5),(626,22852,22850,'000',3.333,5),(626,22853,22850,'00c',3.333,5),(626,22854,22850,'0c2',3.333,5),(626,22855,22850,'c29',3.333,5),(626,22856,22850,'294',3.333,5),(626,22857,22850,'946',3.333,5),(626,22858,22850,'467',3.333,5),(626,22859,22850,'674',3.333,5),(626,22860,22850,'740',3.333,5),(626,22861,22850,'40d',3.333,5),(626,22862,22850,'0d6',3.333,5),(626,22863,22850,'d63',3.333,5),(626,22864,22850,'632',3.333,5),(626,22865,22850,'32b',3.333,5),(626,22866,22850,'2b6',3.333,5),(626,22867,22850,'b60',3.333,5),(626,22868,22850,'606',3.333,5),(626,22869,22850,'069',3.333,5),(626,22870,22850,'696',3.333,5),(626,22871,22850,'96f',3.333,5),(626,22872,22850,'6f5',3.333,5),(626,22873,22850,'f5a',3.333,5),(626,22874,22850,'5a4',3.333,5),(626,22875,22850,'a46',3.333,5),(626,22876,22850,'46b',3.333,5),(626,22877,22850,'6b3',3.333,5),(626,22878,22850,'b35',3.333,5),(626,22879,22850,'359',3.333,5),(626,22880,22850,'596',3.333,5),(627,22882,22881,'naa',100,5),(627,22883,22882,'600',3.333,5),(627,22884,22882,'000',3.333,5),(627,22885,22882,'00c',3.333,5),(627,22886,22882,'0c2',3.333,5),(627,22887,22882,'c29',3.333,5),(627,22888,22882,'291',3.333,5),(627,22889,22882,'911',3.333,5),(627,22890,22882,'119',3.333,5),(627,22891,22882,'190',3.333,5),(627,22892,22882,'900',3.333,5),(627,22893,22882,'00b',3.333,5),(627,22894,22882,'0b3',3.333,5),(627,22895,22882,'b3d',3.333,5),(627,22896,22882,'3de',3.333,5),(627,22897,22882,'de1',3.333,5),(627,22898,22882,'e1e',3.333,5),(627,22899,22882,'1ef',3.333,5),(627,22900,22882,'eff',3.333,5),(627,22901,22882,'ff8',3.333,5),(627,22902,22882,'f8a',3.333,5),(627,22903,22882,'8ae',3.333,5),(627,22904,22882,'ae7',3.333,5),(627,22905,22882,'e74',3.333,5),(627,22906,22882,'74b',3.333,5),(627,22907,22882,'4b1',3.333,5),(627,22908,22882,'b10',3.333,5),(627,22909,22882,'10f',3.333,5),(627,22910,22882,'0f1',3.333,5),(627,22911,22882,'f18',3.333,5),(627,22912,22882,'187',3.333,5),(628,22914,22913,'naa',100,5),(628,22915,22914,'600',3.333,5),(628,22916,22914,'000',3.333,5),(628,22917,22914,'00c',3.333,5),(628,22918,22914,'0c2',3.333,5),(628,22919,22914,'c29',3.333,5),(628,22920,22914,'29a',3.333,5),(628,22921,22914,'9a1',3.333,5),(628,22922,22914,'a18',3.333,5),(628,22923,22914,'18c',3.333,5),(628,22924,22914,'8cd',3.333,5),(628,22925,22914,'cdf',3.333,5),(628,22926,22914,'df8',3.333,5),(628,22927,22914,'f86',3.333,5),(628,22928,22914,'868',3.333,5),(628,22929,22914,'683',3.333,5),(628,22930,22914,'83f',3.333,5),(628,22931,22914,'3f5',3.333,5),(628,22932,22914,'f58',3.333,5),(628,22933,22914,'585',3.333,5),(628,22934,22914,'853',3.333,5),(628,22935,22914,'532',3.333,5),(628,22936,22914,'323',3.333,5),(628,22937,22914,'237',3.333,5),(628,22938,22914,'377',3.333,5),(628,22939,22914,'772',3.333,5),(628,22940,22914,'728',3.333,5),(628,22941,22914,'284',3.333,5),(628,22942,22914,'842',3.333,5),(628,22943,22914,'427',3.333,5),(628,22944,22914,'275',3.333,5),(629,22946,22945,'naa',100,5),(629,22947,22946,'600',3.333,5),(629,22948,22946,'000',3.333,5),(629,22949,22946,'00c',3.333,5),(629,22950,22946,'0c2',3.333,5),(629,22951,22946,'c29',3.333,5),(629,22952,22946,'294',3.333,5),(629,22953,22946,'945',3.333,5),(629,22954,22946,'458',3.333,5),(629,22955,22946,'584',3.333,5),(629,22956,22946,'84f',3.333,5),(629,22957,22946,'4fd',3.333,5),(629,22958,22946,'fdb',3.333,5),(629,22959,22946,'dbb',3.333,5),(629,22960,22946,'bbc',3.333,5),(629,22961,22946,'bcd',3.333,5),(629,22962,22946,'cd1',3.333,5),(629,22963,22946,'d1d',3.333,5),(629,22964,22946,'1d7',3.333,5),(629,22965,22946,'d71',3.333,5),(629,22966,22946,'71b',3.333,5),(629,22967,22946,'1b7',3.333,5),(629,22968,22946,'b79',3.333,5),(629,22969,22946,'792',3.333,5),(629,22970,22946,'923',3.333,5),(629,22971,22946,'236',3.333,5),(629,22972,22946,'36b',3.333,5),(629,22973,22946,'6b3',3.333,5),(629,22974,22946,'b37',3.333,5),(629,22975,22946,'37f',3.333,5),(629,22976,22946,'7f0',3.333,5),(630,22978,22977,'naa',100,5),(630,22979,22978,'600',3.333,5),(630,22980,22978,'000',3.333,5),(630,22981,22978,'00c',3.333,5),(630,22982,22978,'0c2',3.333,5),(630,22983,22978,'c29',3.333,5),(630,22984,22978,'292',3.333,5),(630,22985,22978,'92d',3.333,5),(630,22986,22978,'2d7',3.333,5),(630,22987,22978,'d7e',3.333,5),(630,22988,22978,'7ed',3.333,5),(630,22989,22978,'ed5',3.333,5),(630,22990,22978,'d50',3.333,5),(630,22991,22978,'50d',3.333,5),(630,22992,22978,'0d6',3.333,5),(630,22993,22978,'d69',3.333,5),(630,22994,22978,'69a',3.333,5),(630,22995,22978,'9ae',3.333,5),(630,22996,22978,'ae5',3.333,5),(630,22997,22978,'e5d',3.333,5),(630,22998,22978,'5d7',3.333,5),(630,22999,22978,'d79',3.333,5),(630,23000,22978,'793',3.333,5),(630,23001,22978,'93e',3.333,5),(630,23002,22978,'3ef',3.333,5),(630,23003,22978,'ef3',3.333,5),(630,23004,22978,'f30',3.333,5),(630,23005,22978,'306',3.333,5),(630,23006,22978,'068',3.333,5),(630,23007,22978,'68a',3.333,5),(630,23008,22978,'8a0',3.333,5),(631,23010,23009,'naa',100,5),(631,23011,23010,'600',3.333,5),(631,23012,23010,'000',3.333,5),(631,23013,23010,'00c',3.333,5),(631,23014,23010,'0c2',3.333,5),(631,23015,23010,'c29',3.333,5),(631,23016,23010,'297',3.333,5),(631,23017,23010,'972',3.333,5),(631,23018,23010,'720',3.333,5),(631,23019,23010,'206',3.333,5),(631,23020,23010,'06f',3.333,5),(631,23021,23010,'6fa',3.333,5),(631,23022,23010,'fa8',3.333,5),(631,23023,23010,'a8a',3.333,5),(631,23024,23010,'8af',3.333,5),(631,23025,23010,'af8',3.333,5),(631,23026,23010,'f8b',3.333,5),(631,23027,23010,'8b2',3.333,5),(631,23028,23010,'b2c',3.333,5),(631,23029,23010,'2c6',3.333,5),(631,23030,23010,'c6b',3.333,5),(631,23031,23010,'6bd',3.333,5),(631,23032,23010,'bdb',3.333,5),(631,23033,23010,'db5',3.333,5),(631,23034,23010,'b53',3.333,5),(631,23035,23010,'530',3.333,5),(631,23036,23010,'307',3.333,5),(631,23037,23010,'079',3.333,5),(631,23038,23010,'795',3.333,5),(631,23039,23010,'957',3.333,5),(631,23040,23010,'576',3.333,5),(632,23042,23041,'naa',100,5),(632,23043,23042,'600',3.333,5),(632,23044,23042,'000',3.333,5),(632,23045,23042,'00c',3.333,5),(632,23046,23042,'0c2',3.333,5),(632,23047,23042,'c29',3.333,5),(632,23048,23042,'29e',3.333,5),(632,23049,23042,'9e9',3.333,5),(632,23050,23042,'e96',3.333,5),(632,23051,23042,'96c',3.333,5),(632,23052,23042,'6c8',3.333,5),(632,23053,23042,'c8e',3.333,5),(632,23054,23042,'8eb',3.333,5),(632,23055,23042,'eb9',3.333,5),(632,23056,23042,'b97',3.333,5),(632,23057,23042,'97d',3.333,5),(632,23058,23042,'7dd',3.333,5),(632,23059,23042,'ddc',3.333,5),(632,23060,23042,'dc1',3.333,5),(632,23061,23042,'c11',3.333,5),(632,23062,23042,'117',3.333,5),(632,23063,23042,'173',3.333,5),(632,23064,23042,'73c',3.333,5),(632,23065,23042,'3c2',3.333,5),(632,23066,23042,'c23',3.333,5),(632,23067,23042,'235',3.333,5),(632,23068,23042,'35d',3.333,5),(632,23069,23042,'5d3',3.333,5),(632,23070,23042,'d3a',3.333,5),(632,23071,23042,'3a8',3.333,5),(632,23072,23042,'a8b',3.333,5),(633,23074,23073,'naa',100,5),(633,23075,23074,'600',3.333,5),(633,23076,23074,'000',3.333,5),(633,23077,23074,'00c',3.333,5),(633,23078,23074,'0c2',3.333,5),(633,23079,23074,'c29',3.333,5),(633,23080,23074,'298',3.333,5),(633,23081,23074,'98f',3.333,5),(633,23082,23074,'8f8',3.333,5),(633,23083,23074,'f8b',3.333,5),(633,23084,23074,'8bb',3.333,5),(633,23085,23074,'bb8',3.333,5),(633,23086,23074,'b89',3.333,5),(633,23087,23074,'894',3.333,5),(633,23088,23074,'94b',3.333,5),(633,23089,23074,'4b2',3.333,5),(633,23090,23074,'b2f',3.333,5),(633,23091,23074,'2f1',3.333,5),(633,23092,23074,'f1e',3.333,5),(633,23093,23074,'1e8',3.333,5),(633,23094,23074,'e84',3.333,5),(633,23095,23074,'84f',3.333,5),(633,23096,23074,'4fb',3.333,5),(633,23097,23074,'fb6',3.333,5),(633,23098,23074,'b63',3.333,5),(633,23099,23074,'630',3.333,5),(633,23100,23074,'30a',3.333,5),(633,23101,23074,'0a1',3.333,5),(633,23102,23074,'a1d',3.333,5),(633,23103,23074,'1dd',3.333,5),(633,23104,23074,'ddc',3.333,5),(634,23106,23105,'naa',100,5),(634,23107,23106,'600',3.333,5),(634,23108,23106,'000',3.333,5),(634,23109,23106,'00c',3.333,5),(634,23110,23106,'0c2',3.333,5),(634,23111,23106,'c29',3.333,5),(634,23112,23106,'291',3.333,5),(634,23113,23106,'919',3.333,5),(634,23114,23106,'19a',3.333,5),(634,23115,23106,'9a7',3.333,5),(634,23116,23106,'a74',3.333,5),(634,23117,23106,'744',3.333,5),(634,23118,23106,'440',3.333,5),(634,23119,23106,'402',3.333,5),(634,23120,23106,'022',3.333,5),(634,23121,23106,'22d',3.333,5),(634,23122,23106,'2df',3.333,5),(634,23123,23106,'df5',3.333,5),(634,23124,23106,'f59',3.333,5),(634,23125,23106,'59d',3.333,5),(634,23126,23106,'9d4',3.333,5),(634,23127,23106,'d44',3.333,5),(634,23128,23106,'44c',3.333,5),(634,23129,23106,'4ca',3.333,5),(634,23130,23106,'ca5',3.333,5),(634,23131,23106,'a5c',3.333,5),(634,23132,23106,'5cc',3.333,5),(634,23133,23106,'cc2',3.333,5),(634,23134,23106,'c26',3.333,5),(634,23135,23106,'262',3.333,5),(634,23136,23106,'62c',3.333,5),(635,23138,23137,'naa',100,5),(635,23139,23138,'600',3.333,5),(635,23140,23138,'000',3.333,5),(635,23141,23138,'00c',3.333,5),(635,23142,23138,'0c2',3.333,5),(635,23143,23138,'c29',3.333,5),(635,23144,23138,'296',3.333,5),(635,23145,23138,'967',3.333,5),(635,23146,23138,'670',3.333,5),(635,23147,23138,'70b',3.333,5),(635,23148,23138,'0b4',3.333,5),(635,23149,23138,'b45',3.333,5),(635,23150,23138,'45b',3.333,5),(635,23151,23138,'5b9',3.333,5),(635,23152,23138,'b96',3.333,5),(635,23153,23138,'960',3.333,5),(635,23154,23138,'600',3.333,5),(635,23155,23138,'003',3.333,5),(635,23156,23138,'036',3.333,5),(635,23157,23138,'367',3.333,5),(635,23158,23138,'670',3.333,5),(635,23159,23138,'70f',3.333,5),(635,23160,23138,'0f4',3.333,5),(635,23161,23138,'f42',3.333,5),(635,23162,23138,'424',3.333,5),(635,23163,23138,'246',3.333,5),(635,23164,23138,'461',3.333,5),(635,23165,23138,'61a',3.333,5),(635,23166,23138,'1a7',3.333,5),(635,23167,23138,'a75',3.333,5),(635,23168,23138,'757',3.333,5),(636,23170,23169,'naa',100,5),(636,23171,23170,'600',3.333,5),(636,23172,23170,'000',3.333,5),(636,23173,23170,'00c',3.333,5),(636,23174,23170,'0c2',3.333,5),(636,23175,23170,'c29',3.333,5),(636,23176,23170,'293',3.333,5),(636,23177,23170,'936',3.333,5),(636,23178,23170,'36a',3.333,5),(636,23179,23170,'6a1',3.333,5),(636,23180,23170,'a1d',3.333,5),(636,23181,23170,'1d8',3.333,5),(636,23182,23170,'d8d',3.333,5),(636,23183,23170,'8d7',3.333,5),(636,23184,23170,'d75',3.333,5),(636,23185,23170,'750',3.333,5),(636,23186,23170,'502',3.333,5),(636,23187,23170,'023',3.333,5),(636,23188,23170,'23a',3.333,5),(636,23189,23170,'3a6',3.333,5),(636,23190,23170,'a67',3.333,5),(636,23191,23170,'672',3.333,5),(636,23192,23170,'72a',3.333,5),(636,23193,23170,'2ab',3.333,5),(636,23194,23170,'ab6',3.333,5),(636,23195,23170,'b6a',3.333,5),(636,23196,23170,'6ac',3.333,5),(636,23197,23170,'ac4',3.333,5),(636,23198,23170,'c4b',3.333,5),(636,23199,23170,'4bc',3.333,5),(636,23200,23170,'bc6',3.333,5),(637,23202,23201,'naa',100,5),(637,23203,23202,'600',3.333,5),(637,23204,23202,'000',3.333,5),(637,23205,23202,'00c',3.333,5),(637,23206,23202,'0c2',3.333,5),(637,23207,23202,'c29',3.333,5),(637,23208,23202,'29c',3.333,5),(637,23209,23202,'9c0',3.333,5),(637,23210,23202,'c0b',3.333,5),(637,23211,23202,'0b0',3.333,5),(637,23212,23202,'b0f',3.333,5),(637,23213,23202,'0f8',3.333,5),(637,23214,23202,'f8d',3.333,5),(637,23215,23202,'8d4',3.333,5),(637,23216,23202,'d4b',3.333,5),(637,23217,23202,'4b8',3.333,5),(637,23218,23202,'b83',3.333,5),(637,23219,23202,'83b',3.333,5),(637,23220,23202,'3b2',3.333,5),(637,23221,23202,'b2c',3.333,5),(637,23222,23202,'2c2',3.333,5),(637,23223,23202,'c22',3.333,5),(637,23224,23202,'228',3.333,5),(637,23225,23202,'284',3.333,5),(637,23226,23202,'846',3.333,5),(637,23227,23202,'465',3.333,5),(637,23228,23202,'659',3.333,5),(637,23229,23202,'59d',3.333,5),(637,23230,23202,'9d8',3.333,5),(637,23231,23202,'d85',3.333,5),(637,23232,23202,'853',3.333,5),(638,23234,23233,'naa',100,5),(638,23235,23234,'600',3.333,5),(638,23236,23234,'000',3.333,5),(638,23237,23234,'00c',3.333,5),(638,23238,23234,'0c2',3.333,5),(638,23239,23234,'c29',3.333,5),(638,23240,23234,'298',3.333,5),(638,23241,23234,'981',3.333,5),(638,23242,23234,'811',3.333,5),(638,23243,23234,'117',3.333,5),(638,23244,23234,'172',3.333,5),(638,23245,23234,'72d',3.333,5),(638,23246,23234,'2da',3.333,5),(638,23247,23234,'da9',3.333,5),(638,23248,23234,'a9f',3.333,5),(638,23249,23234,'9fa',3.333,5),(638,23250,23234,'fa3',3.333,5),(638,23251,23234,'a3b',3.333,5),(638,23252,23234,'3be',3.333,5),(638,23253,23234,'bec',3.333,5),(638,23254,23234,'eca',3.333,5),(638,23255,23234,'ca9',3.333,5),(638,23256,23234,'a9c',3.333,5),(638,23257,23234,'9c6',3.333,5),(638,23258,23234,'c60',3.333,5),(638,23259,23234,'608',3.333,5),(638,23260,23234,'081',3.333,5),(638,23261,23234,'814',3.333,5),(638,23262,23234,'14a',3.333,5),(638,23263,23234,'4a6',3.333,5),(638,23264,23234,'a6c',3.333,5),(639,23266,23265,'naa',100,5),(639,23267,23266,'600',3.333,5),(639,23268,23266,'000',3.333,5),(639,23269,23266,'00c',3.333,5),(639,23270,23266,'0c2',3.333,5),(639,23271,23266,'c29',3.333,5),(639,23272,23266,'294',3.333,5),(639,23273,23266,'94c',3.333,5),(639,23274,23266,'4cd',3.333,5),(639,23275,23266,'cd2',3.333,5),(639,23276,23266,'d21',3.333,5),(639,23277,23266,'213',3.333,5),(639,23278,23266,'130',3.333,5),(639,23279,23266,'308',3.333,5),(639,23280,23266,'08e',3.333,5),(639,23281,23266,'8ec',3.333,5),(639,23282,23266,'ece',3.333,5),(639,23283,23266,'ce6',3.333,5),(639,23284,23266,'e62',3.333,5),(639,23285,23266,'62f',3.333,5),(639,23286,23266,'2f8',3.333,5),(639,23287,23266,'f84',3.333,5),(639,23288,23266,'84a',3.333,5),(639,23289,23266,'4ac',3.333,5),(639,23290,23266,'aca',3.333,5),(639,23291,23266,'ca9',3.333,5),(639,23292,23266,'a90',3.333,5),(639,23293,23266,'90d',3.333,5),(639,23294,23266,'0de',3.333,5),(639,23295,23266,'de7',3.333,5),(639,23296,23266,'e79',3.333,5),(640,23298,23297,'naa',100,5),(640,23299,23298,'600',3.333,5),(640,23300,23298,'000',3.333,5),(640,23301,23298,'00c',3.333,5),(640,23302,23298,'0c2',3.333,5),(640,23303,23298,'c29',3.333,5),(640,23304,23298,'299',3.333,5),(640,23305,23298,'99e',3.333,5),(640,23306,23298,'9e8',3.333,5),(640,23307,23298,'e86',3.333,5),(640,23308,23298,'863',3.333,5),(640,23309,23298,'636',3.333,5),(640,23310,23298,'36b',3.333,5),(640,23311,23298,'6bf',3.333,5),(640,23312,23298,'bf1',3.333,5),(640,23313,23298,'f10',3.333,5),(640,23314,23298,'105',3.333,5),(640,23315,23298,'055',3.333,5),(640,23316,23298,'553',3.333,5),(640,23317,23298,'535',3.333,5),(640,23318,23298,'358',3.333,5),(640,23319,23298,'58e',3.333,5),(640,23320,23298,'8ea',3.333,5),(640,23321,23298,'ea3',3.333,5),(640,23322,23298,'a35',3.333,5),(640,23323,23298,'354',3.333,5),(640,23324,23298,'547',3.333,5),(640,23325,23298,'479',3.333,5),(640,23326,23298,'792',3.333,5),(640,23327,23298,'92e',3.333,5),(640,23328,23298,'2e3',3.333,5),(641,23330,23329,'naa',100,5),(641,23331,23330,'600',3.333,5),(641,23332,23330,'000',3.333,5),(641,23333,23330,'00c',3.333,5),(641,23334,23330,'0c2',3.333,5),(641,23335,23330,'c29',3.333,5),(641,23336,23330,'295',3.333,5),(641,23337,23330,'950',3.333,5),(641,23338,23330,'504',3.333,5),(641,23339,23330,'044',3.333,5),(641,23340,23330,'44e',3.333,5),(641,23341,23330,'4e2',3.333,5),(641,23342,23330,'e28',3.333,5),(641,23343,23330,'287',3.333,5),(641,23344,23330,'87d',3.333,5),(641,23345,23330,'7d8',3.333,5),(641,23346,23330,'d8f',3.333,5),(641,23347,23330,'8f8',3.333,5),(641,23348,23330,'f88',3.333,5),(641,23349,23330,'880',3.333,5),(641,23350,23330,'800',3.333,5),(641,23351,23330,'00c',3.333,5),(641,23352,23330,'0ca',3.333,5),(641,23353,23330,'ca1',3.333,5),(641,23354,23330,'a1a',3.333,5),(641,23355,23330,'1a1',3.333,5),(641,23356,23330,'a17',3.333,5),(641,23357,23330,'179',3.333,5),(641,23358,23330,'793',3.333,5),(641,23359,23330,'930',3.333,5),(641,23360,23330,'30a',3.333,5),(642,23362,23361,'naa',100,5),(642,23363,23362,'600',3.333,5),(642,23364,23362,'000',3.333,5),(642,23365,23362,'00c',3.333,5),(642,23366,23362,'0c2',3.333,5),(642,23367,23362,'c29',3.333,5),(642,23368,23362,'292',3.333,5),(642,23369,23362,'922',3.333,5),(642,23370,23362,'22c',3.333,5),(642,23371,23362,'2ca',3.333,5),(642,23372,23362,'ca3',3.333,5),(642,23373,23362,'a33',3.333,5),(642,23374,23362,'33e',3.333,5),(642,23375,23362,'3e3',3.333,5),(642,23376,23362,'e3f',3.333,5),(642,23377,23362,'3ff',3.333,5),(642,23378,23362,'ff4',3.333,5),(642,23379,23362,'f4c',3.333,5),(642,23380,23362,'4c6',3.333,5),(642,23381,23362,'c6b',3.333,5),(642,23382,23362,'6b2',3.333,5),(642,23383,23362,'b2d',3.333,5),(642,23384,23362,'2d2',3.333,5),(642,23385,23362,'d25',3.333,5),(642,23386,23362,'251',3.333,5),(642,23387,23362,'511',3.333,5),(642,23388,23362,'11b',3.333,5),(642,23389,23362,'1bf',3.333,5),(642,23390,23362,'bf8',3.333,5),(642,23391,23362,'f80',3.333,5),(642,23392,23362,'80b',3.333,5),(583,23406,23405,'hgw',9.091,5),(583,23407,23405,'gw2',9.091,5),(583,23408,23405,'w2k',9.091,5),(583,23409,23405,'2k8',9.091,5),(583,23410,23405,'k8r',9.091,5),(583,23411,23405,'8r2',9.091,5),(583,23412,23405,'r23',9.091,5),(583,23413,23405,'232',9.091,5),(583,23414,23405,'32v',9.091,5),(583,23415,23405,'2vm',9.091,5),(583,23416,23405,'vm7',9.091,5),(644,23463,23462,'naa',100,5),(644,23464,23463,'600',3.333,5),(644,23465,23463,'000',3.333,5),(644,23466,23463,'00c',3.333,5),(644,23467,23463,'0c2',3.333,5),(644,23468,23463,'c29',3.333,5),(644,23469,23463,'294',3.333,5),(644,23470,23463,'94d',3.333,5),(644,23471,23463,'4d6',3.333,5),(644,23472,23463,'d6d',3.333,5),(644,23473,23463,'6d0',3.333,5),(644,23474,23463,'d0c',3.333,5),(644,23475,23463,'0c3',3.333,5),(644,23476,23463,'c3e',3.333,5),(644,23477,23463,'3ee',3.333,5),(644,23478,23463,'eec',3.333,5),(644,23479,23463,'ecd',3.333,5),(644,23480,23463,'cde',3.333,5),(644,23481,23463,'def',3.333,5),(644,23482,23463,'efa',3.333,5),(644,23483,23463,'fa1',3.333,5),(644,23484,23463,'a1a',3.333,5),(644,23485,23463,'1a4',3.333,5),(644,23486,23463,'a4c',3.333,5),(644,23487,23463,'4c7',3.333,5),(644,23488,23463,'c7c',3.333,5),(644,23489,23463,'7ce',3.333,5),(644,23490,23463,'cea',3.333,5),(644,23491,23463,'ea8',3.333,5),(644,23492,23463,'a82',3.333,5),(644,23493,23463,'820',3.333,5),(645,23495,23494,'naa',100,5),(645,23496,23495,'600',3.333,5),(645,23497,23495,'00a',3.333,5),(645,23498,23495,'0a0',3.333,5),(645,23499,23495,'a09',3.333,5),(645,23500,23495,'098',3.333,5),(645,23501,23495,'980',3.333,5),(645,23502,23495,'804',3.333,5),(645,23503,23495,'044',3.333,5),(645,23504,23495,'443',3.333,5),(645,23505,23495,'430',3.333,5),(645,23506,23495,'307',3.333,5),(645,23507,23495,'072',3.333,5),(645,23508,23495,'725',3.333,5),(645,23509,23495,'259',3.333,5),(645,23510,23495,'593',3.333,5),(645,23511,23495,'931',3.333,5),(645,23512,23495,'313',3.333,5),(645,23513,23495,'13f',3.333,5),(645,23514,23495,'3f3',3.333,5),(645,23515,23495,'f33',3.333,5),(645,23516,23495,'334',3.333,5),(645,23517,23495,'345',3.333,5),(645,23518,23495,'455',3.333,5),(645,23519,23495,'556',3.333,5),(645,23520,23495,'563',3.333,5),(645,23521,23495,'639',3.333,5),(645,23522,23495,'393',3.333,5),(645,23523,23495,'934',3.333,5),(645,23524,23495,'344',3.333,5),(645,23525,23495,'449',3.333,5),(646,23527,23526,'naa',100,5),(646,23528,23527,'600',3.333,5),(646,23529,23527,'00a',3.333,5),(646,23530,23527,'0a0',3.333,5),(646,23531,23527,'a09',3.333,5),(646,23532,23527,'098',3.333,5),(646,23533,23527,'980',3.333,5),(646,23534,23527,'804',3.333,5),(646,23535,23527,'044',3.333,5),(646,23536,23527,'443',3.333,5),(646,23537,23527,'430',3.333,5),(646,23538,23527,'307',3.333,5),(646,23539,23527,'072',3.333,5),(646,23540,23527,'725',3.333,5),(646,23541,23527,'259',3.333,5),(646,23542,23527,'593',3.333,5),(646,23543,23527,'931',3.333,5),(646,23544,23527,'313',3.333,5),(646,23545,23527,'13f',3.333,5),(646,23546,23527,'3f3',3.333,5),(646,23547,23527,'f33',3.333,5),(646,23548,23527,'334',3.333,5),(646,23549,23527,'345',3.333,5),(646,23550,23527,'455',3.333,5),(646,23551,23527,'556',3.333,5),(646,23552,23527,'563',3.333,5),(646,23553,23527,'639',3.333,5),(646,23554,23527,'393',3.333,5),(646,23555,23527,'934',3.333,5),(646,23556,23527,'344',3.333,5),(646,23557,23527,'44a',3.333,5),(647,23559,23558,'naa',100,5),(647,23560,23559,'600',3.333,5),(647,23561,23559,'00a',3.333,5),(647,23562,23559,'0a0',3.333,5),(647,23563,23559,'a09',3.333,5),(647,23564,23559,'098',3.333,5),(647,23565,23559,'980',3.333,5),(647,23566,23559,'804',3.333,5),(647,23567,23559,'044',3.333,5),(647,23568,23559,'443',3.333,5),(647,23569,23559,'430',3.333,5),(647,23570,23559,'307',3.333,5),(647,23571,23559,'075',3.333,5),(647,23572,23559,'753',3.333,5),(647,23573,23559,'535',3.333,5),(647,23574,23559,'357',3.333,5),(647,23575,23559,'573',3.333,5),(647,23576,23559,'732',3.333,5),(647,23577,23559,'32b',3.333,5),(647,23578,23559,'2b3',3.333,5),(647,23579,23559,'b33',3.333,5),(647,23580,23559,'334',3.333,5),(647,23581,23559,'345',3.333,5),(647,23582,23559,'457',3.333,5),(647,23583,23559,'571',3.333,5),(647,23584,23559,'715',3.333,5),(647,23585,23559,'153',3.333,5),(647,23586,23559,'533',3.333,5),(647,23587,23559,'336',3.333,5),(647,23588,23559,'363',3.333,5),(647,23589,23559,'634',3.333,5),(648,23591,23590,'naa',100,5),(648,23592,23591,'600',3.333,5),(648,23593,23591,'00a',3.333,5),(648,23594,23591,'0a0',3.333,5),(648,23595,23591,'a09',3.333,5),(648,23596,23591,'098',3.333,5),(648,23597,23591,'980',3.333,5),(648,23598,23591,'804',3.333,5),(648,23599,23591,'044',3.333,5),(648,23600,23591,'443',3.333,5),(648,23601,23591,'430',3.333,5),(648,23602,23591,'307',3.333,5),(648,23603,23591,'075',3.333,5),(648,23604,23591,'753',3.333,5),(648,23605,23591,'535',3.333,5),(648,23606,23591,'357',3.333,5),(648,23607,23591,'573',3.333,5),(648,23608,23591,'732',3.333,5),(648,23609,23591,'32b',3.333,5),(648,23610,23591,'2b3',3.333,5),(648,23611,23591,'b33',3.333,5),(648,23612,23591,'334',3.333,5),(648,23613,23591,'345',3.333,5),(648,23614,23591,'457',3.333,5),(648,23615,23591,'571',3.333,5),(648,23616,23591,'715',3.333,5),(648,23617,23591,'153',3.333,5),(648,23618,23591,'533',3.333,5),(648,23619,23591,'336',3.333,5),(648,23620,23591,'363',3.333,5),(648,23621,23591,'635',3.333,5),(649,23623,23622,'naa',100,5),(649,23624,23623,'600',3.333,5),(649,23625,23623,'000',3.333,5),(649,23626,23623,'00c',3.333,5),(649,23627,23623,'0c2',3.333,5),(649,23628,23623,'c29',3.333,5),(649,23629,23623,'297',3.333,5),(649,23630,23623,'97b',3.333,5),(649,23631,23623,'7bf',3.333,5),(649,23632,23623,'bf2',3.333,5),(649,23633,23623,'f2a',3.333,5),(649,23634,23623,'2a2',3.333,5),(649,23635,23623,'a22',3.333,5),(649,23636,23623,'226',3.333,5),(649,23637,23623,'264',3.333,5),(649,23638,23623,'641',3.333,5),(649,23639,23623,'419',3.333,5),(649,23640,23623,'198',3.333,5),(649,23641,23623,'982',3.333,5),(649,23642,23623,'82c',3.333,5),(649,23643,23623,'2c5',3.333,5),(649,23644,23623,'c56',3.333,5),(649,23645,23623,'567',3.333,5),(649,23646,23623,'67d',3.333,5),(649,23647,23623,'7dc',3.333,5),(649,23648,23623,'dc3',3.333,5),(649,23649,23623,'c31',3.333,5),(649,23650,23623,'310',3.333,5),(649,23651,23623,'10a',3.333,5),(649,23652,23623,'0a9',3.333,5),(649,23653,23623,'a9a',3.333,5),(650,23655,23654,'naa',100,5),(650,23656,23655,'600',3.333,5),(650,23657,23655,'000',3.333,5),(650,23658,23655,'00c',3.333,5),(650,23659,23655,'0c2',3.333,5),(650,23660,23655,'c29',3.333,5),(650,23661,23655,'297',3.333,5),(650,23662,23655,'97a',3.333,5),(650,23663,23655,'7a5',3.333,5),(650,23664,23655,'a50',3.333,5),(650,23665,23655,'50c',3.333,5),(650,23666,23655,'0ca',3.333,5),(650,23667,23655,'ca9',3.333,5),(650,23668,23655,'a99',3.333,5),(650,23669,23655,'99c',3.333,5),(650,23670,23655,'9cb',3.333,5),(650,23671,23655,'cb2',3.333,5),(650,23672,23655,'b26',3.333,5),(650,23673,23655,'263',3.333,5),(650,23674,23655,'638',3.333,5),(650,23675,23655,'387',3.333,5),(650,23676,23655,'874',3.333,5),(650,23677,23655,'746',3.333,5),(650,23678,23655,'462',3.333,5),(650,23679,23655,'628',3.333,5),(650,23680,23655,'28b',3.333,5),(650,23681,23655,'8b9',3.333,5),(650,23682,23655,'b95',3.333,5),(650,23683,23655,'956',3.333,5),(650,23684,23655,'565',3.333,5),(650,23685,23655,'65b',3.333,5),(651,23687,23686,'naa',100,5),(651,23688,23687,'600',3.333,5),(651,23689,23687,'000',3.333,5),(651,23690,23687,'00c',3.333,5),(651,23691,23687,'0c2',3.333,5),(651,23692,23687,'c29',3.333,5),(651,23693,23687,'29e',3.333,5),(651,23694,23687,'9ea',3.333,5),(651,23695,23687,'ead',3.333,5),(651,23696,23687,'adf',3.333,5),(651,23697,23687,'dfa',3.333,5),(651,23698,23687,'fae',3.333,5),(651,23699,23687,'ae7',3.333,5),(651,23700,23687,'e74',3.333,5),(651,23701,23687,'742',3.333,5),(651,23702,23687,'42d',3.333,5),(651,23703,23687,'2de',3.333,5),(651,23704,23687,'deb',3.333,5),(651,23705,23687,'eb3',3.333,5),(651,23706,23687,'b3e',3.333,5),(651,23707,23687,'3e0',3.333,5),(651,23708,23687,'e0d',3.333,5),(651,23709,23687,'0d4',3.333,5),(651,23710,23687,'d4a',3.333,5),(651,23711,23687,'4a7',3.333,5),(651,23712,23687,'a7e',3.333,5),(651,23713,23687,'7e1',3.333,5),(651,23714,23687,'e17',3.333,5),(651,23715,23687,'17d',3.333,5),(651,23716,23687,'7d8',3.333,5),(651,23717,23687,'d8c',3.333,5),(652,23719,23718,'naa',100,5),(652,23720,23719,'600',3.333,5),(652,23721,23719,'000',3.333,5),(652,23722,23719,'00c',3.333,5),(652,23723,23719,'0c2',3.333,5),(652,23724,23719,'c29',3.333,5),(652,23725,23719,'292',3.333,5),(652,23726,23719,'92d',3.333,5),(652,23727,23719,'2d0',3.333,5),(652,23728,23719,'d05',3.333,5),(652,23729,23719,'051',3.333,5),(652,23730,23719,'514',3.333,5),(652,23731,23719,'140',3.333,5),(652,23732,23719,'400',3.333,5),(652,23733,23719,'006',3.333,5),(652,23734,23719,'063',3.333,5),(652,23735,23719,'636',3.333,5),(652,23736,23719,'362',3.333,5),(652,23737,23719,'62f',3.333,5),(652,23738,23719,'2f9',3.333,5),(652,23739,23719,'f90',3.333,5),(652,23740,23719,'906',3.333,5),(652,23741,23719,'06e',3.333,5),(652,23742,23719,'6e2',3.333,5),(652,23743,23719,'e2f',3.333,5),(652,23744,23719,'2f7',3.333,5),(652,23745,23719,'f7f',3.333,5),(652,23746,23719,'7f3',3.333,5),(652,23747,23719,'f3c',3.333,5),(652,23748,23719,'3c1',3.333,5),(652,23749,23719,'c10',3.333,5),(653,23751,23750,'naa',100,5),(653,23752,23751,'600',3.333,5),(653,23753,23751,'000',3.333,5),(653,23754,23751,'00c',3.333,5),(653,23755,23751,'0c2',3.333,5),(653,23756,23751,'c29',3.333,5),(653,23757,23751,'293',3.333,5),(653,23758,23751,'938',3.333,5),(653,23759,23751,'38d',3.333,5),(653,23760,23751,'8d8',3.333,5),(653,23761,23751,'d85',3.333,5),(653,23762,23751,'85b',3.333,5),(653,23763,23751,'5ba',3.333,5),(653,23764,23751,'bac',3.333,5),(653,23765,23751,'ac2',3.333,5),(653,23766,23751,'c2f',3.333,5),(653,23767,23751,'2fa',3.333,5),(653,23768,23751,'fa6',3.333,5),(653,23769,23751,'a64',3.333,5),(653,23770,23751,'648',3.333,5),(653,23771,23751,'48a',3.333,5),(653,23772,23751,'8a5',3.333,5),(653,23773,23751,'a5f',3.333,5),(653,23774,23751,'5fc',3.333,5),(653,23775,23751,'fc4',3.333,5),(653,23776,23751,'c45',3.333,5),(653,23777,23751,'45a',3.333,5),(653,23778,23751,'5af',3.333,5),(653,23779,23751,'af3',3.333,5),(653,23780,23751,'f32',3.333,5),(653,23781,23751,'329',3.333,5),(654,23783,23782,'naa',100,5),(654,23784,23783,'600',3.333,5),(654,23785,23783,'000',3.333,5),(654,23786,23783,'00c',3.333,5),(654,23787,23783,'0c2',3.333,5),(654,23788,23783,'c29',3.333,5),(654,23789,23783,'290',3.333,5),(654,23790,23783,'909',3.333,5),(654,23791,23783,'093',3.333,5),(654,23792,23783,'939',3.333,5),(654,23793,23783,'395',3.333,5),(654,23794,23783,'959',3.333,5),(654,23795,23783,'591',3.333,5),(654,23796,23783,'91e',3.333,5),(654,23797,23783,'1e7',3.333,5),(654,23798,23783,'e72',3.333,5),(654,23799,23783,'72b',3.333,5),(654,23800,23783,'2bb',3.333,5),(654,23801,23783,'bb0',3.333,5),(654,23802,23783,'b04',3.333,5),(654,23803,23783,'049',3.333,5),(654,23804,23783,'49e',3.333,5),(654,23805,23783,'9e6',3.333,5),(654,23806,23783,'e6e',3.333,5),(654,23807,23783,'6ee',3.333,5),(654,23808,23783,'ee2',3.333,5),(654,23809,23783,'e2d',3.333,5),(654,23810,23783,'2d1',3.333,5),(654,23811,23783,'d19',3.333,5),(654,23812,23783,'19b',3.333,5),(654,23813,23783,'9b3',3.333,5),(655,23815,23814,'naa',100,5),(655,23816,23815,'600',3.333,5),(655,23817,23815,'000',3.333,5),(655,23818,23815,'00c',3.333,5),(655,23819,23815,'0c2',3.333,5),(655,23820,23815,'c29',3.333,5),(655,23821,23815,'294',3.333,5),(655,23822,23815,'945',3.333,5),(655,23823,23815,'456',3.333,5),(655,23824,23815,'560',3.333,5),(655,23825,23815,'605',3.333,5),(655,23826,23815,'056',3.333,5),(655,23827,23815,'564',3.333,5),(655,23828,23815,'64a',3.333,5),(655,23829,23815,'4a3',3.333,5),(655,23830,23815,'a33',3.333,5),(655,23831,23815,'330',3.333,5),(655,23832,23815,'30a',3.333,5),(655,23833,23815,'0a5',3.333,5),(655,23834,23815,'a53',3.333,5),(655,23835,23815,'53c',3.333,5),(655,23836,23815,'3cc',3.333,5),(655,23837,23815,'cca',3.333,5),(655,23838,23815,'caf',3.333,5),(655,23839,23815,'af9',3.333,5),(655,23840,23815,'f97',3.333,5),(655,23841,23815,'97e',3.333,5),(655,23842,23815,'7e6',3.333,5),(655,23843,23815,'e64',3.333,5),(655,23844,23815,'646',3.333,5),(655,23845,23815,'461',3.333,5),(656,23847,23846,'naa',100,5),(656,23848,23847,'600',3.333,5),(656,23849,23847,'000',3.333,5),(656,23850,23847,'00c',3.333,5),(656,23851,23847,'0c2',3.333,5),(656,23852,23847,'c29',3.333,5),(656,23853,23847,'297',3.333,5),(656,23854,23847,'974',3.333,5),(656,23855,23847,'747',3.333,5),(656,23856,23847,'471',3.333,5),(656,23857,23847,'71e',3.333,5),(656,23858,23847,'1ed',3.333,5),(656,23859,23847,'ed7',3.333,5),(656,23860,23847,'d7b',3.333,5),(656,23861,23847,'7be',3.333,5),(656,23862,23847,'be5',3.333,5),(656,23863,23847,'e5b',3.333,5),(656,23864,23847,'5ba',3.333,5),(656,23865,23847,'ba7',3.333,5),(656,23866,23847,'a7d',3.333,5),(656,23867,23847,'7db',3.333,5),(656,23868,23847,'db5',3.333,5),(656,23869,23847,'b50',3.333,5),(656,23870,23847,'50e',3.333,5),(656,23871,23847,'0e9',3.333,5),(656,23872,23847,'e90',3.333,5),(656,23873,23847,'90b',3.333,5),(656,23874,23847,'0bb',3.333,5),(656,23875,23847,'bb9',3.333,5),(656,23876,23847,'b9d',3.333,5),(656,23877,23847,'9df',3.333,5),(657,23879,23878,'naa',100,5),(657,23880,23879,'600',3.333,5),(657,23881,23879,'000',3.333,5),(657,23882,23879,'00c',3.333,5),(657,23883,23879,'0c2',3.333,5),(657,23884,23879,'c29',3.333,5),(657,23885,23879,'29a',3.333,5),(657,23886,23879,'9a0',3.333,5),(657,23887,23879,'a0d',3.333,5),(657,23888,23879,'0d8',3.333,5),(657,23889,23879,'d86',3.333,5),(657,23890,23879,'861',3.333,5),(657,23891,23879,'61f',3.333,5),(657,23892,23879,'1f5',3.333,5),(657,23893,23879,'f56',3.333,5),(657,23894,23879,'565',3.333,5),(657,23895,23879,'659',3.333,5),(657,23896,23879,'590',3.333,5),(657,23897,23879,'909',3.333,5),(657,23898,23879,'097',3.333,5),(657,23899,23879,'970',3.333,5),(657,23900,23879,'700',3.333,5),(657,23901,23879,'00f',3.333,5),(657,23902,23879,'0f4',3.333,5),(657,23903,23879,'f49',3.333,5),(657,23904,23879,'490',3.333,5),(657,23905,23879,'906',3.333,5),(657,23906,23879,'068',3.333,5),(657,23907,23879,'68a',3.333,5),(657,23908,23879,'8ae',3.333,5),(657,23909,23879,'ae5',3.333,5),(658,23911,23910,'naa',100,5),(658,23912,23911,'600',3.333,5),(658,23913,23911,'000',3.333,5),(658,23914,23911,'00c',3.333,5),(658,23915,23911,'0c2',3.333,5),(658,23916,23911,'c29',3.333,5),(658,23917,23911,'296',3.333,5),(658,23918,23911,'965',3.333,5),(658,23919,23911,'65b',3.333,5),(658,23920,23911,'5ba',3.333,5),(658,23921,23911,'ba2',3.333,5),(658,23922,23911,'a28',3.333,5),(658,23923,23911,'287',3.333,5),(658,23924,23911,'87f',3.333,5),(658,23925,23911,'7f8',3.333,5),(658,23926,23911,'f8c',3.333,5),(658,23927,23911,'8cc',3.333,5),(658,23928,23911,'cc8',3.333,5),(658,23929,23911,'c86',3.333,5),(658,23930,23911,'861',3.333,5),(658,23931,23911,'611',3.333,5),(658,23932,23911,'11d',3.333,5),(658,23933,23911,'1d1',3.333,5),(658,23934,23911,'d19',3.333,5),(658,23935,23911,'19b',3.333,5),(658,23936,23911,'9bb',3.333,5),(658,23937,23911,'bb1',3.333,5),(658,23938,23911,'b13',3.333,5),(658,23939,23911,'13a',3.333,5),(658,23940,23911,'3a6',3.333,5),(658,23941,23911,'a69',3.333,5),(659,23943,23942,'naa',100,5),(659,23944,23943,'600',3.333,5),(659,23945,23943,'000',3.333,5),(659,23946,23943,'00c',3.333,5),(659,23947,23943,'0c2',3.333,5),(659,23948,23943,'c29',3.333,5),(659,23949,23943,'291',3.333,5),(659,23950,23943,'912',3.333,5),(659,23951,23943,'12b',3.333,5),(659,23952,23943,'2b7',3.333,5),(659,23953,23943,'b76',3.333,5),(659,23954,23943,'76c',3.333,5),(659,23955,23943,'6c5',3.333,5),(659,23956,23943,'c5e',3.333,5),(659,23957,23943,'5e4',3.333,5),(659,23958,23943,'e4a',3.333,5),(659,23959,23943,'4ad',3.333,5),(659,23960,23943,'ad6',3.333,5),(659,23961,23943,'d6b',3.333,5),(659,23962,23943,'6bf',3.333,5),(659,23963,23943,'bf6',3.333,5),(659,23964,23943,'f67',3.333,5),(659,23965,23943,'674',3.333,5),(659,23966,23943,'749',3.333,5),(659,23967,23943,'49b',3.333,5),(659,23968,23943,'9bb',3.333,5),(659,23969,23943,'bb7',3.333,5),(659,23970,23943,'b7d',3.333,5),(659,23971,23943,'7d5',3.333,5),(659,23972,23943,'d57',3.333,5),(659,23973,23943,'57a',3.333,5),(660,23975,23974,'naa',100,5),(660,23976,23975,'600',3.333,5),(660,23977,23975,'000',3.333,5),(660,23978,23975,'00c',3.333,5),(660,23979,23975,'0c2',3.333,5),(660,23980,23975,'c29',3.333,5),(660,23981,23975,'292',3.333,5),(660,23982,23975,'92a',3.333,5),(660,23983,23975,'2ae',3.333,5),(660,23984,23975,'ae2',3.333,5),(660,23985,23975,'e22',3.333,5),(660,23986,23975,'22c',3.333,5),(660,23987,23975,'2c9',3.333,5),(660,23988,23975,'c90',3.333,5),(660,23989,23975,'90a',3.333,5),(660,23990,23975,'0ac',3.333,5),(660,23991,23975,'acc',3.333,5),(660,23992,23975,'ccb',3.333,5),(660,23993,23975,'cbe',3.333,5),(660,23994,23975,'bea',3.333,5),(660,23995,23975,'eaf',3.333,5),(660,23996,23975,'afe',3.333,5),(660,23997,23975,'fef',3.333,5),(660,23998,23975,'efc',3.333,5),(660,23999,23975,'fcd',3.333,5),(660,24000,23975,'cde',3.333,5),(660,24001,23975,'dee',3.333,5),(660,24002,23975,'ee6',3.333,5),(660,24003,23975,'e61',3.333,5),(660,24004,23975,'611',3.333,5),(660,24005,23975,'112',3.333,5),(661,24007,24006,'naa',100,5),(661,24008,24007,'600',3.333,5),(661,24009,24007,'000',3.333,5),(661,24010,24007,'00c',3.333,5),(661,24011,24007,'0c2',3.333,5),(661,24012,24007,'c29',3.333,5),(661,24013,24007,'294',3.333,5),(661,24014,24007,'94b',3.333,5),(661,24015,24007,'4b6',3.333,5),(661,24016,24007,'b69',3.333,5),(661,24017,24007,'69e',3.333,5),(661,24018,24007,'9ea',3.333,5),(661,24019,24007,'ea9',3.333,5),(661,24020,24007,'a93',3.333,5),(661,24021,24007,'931',3.333,5),(661,24022,24007,'31c',3.333,5),(661,24023,24007,'1c1',3.333,5),(661,24024,24007,'c10',3.333,5),(661,24025,24007,'10b',3.333,5),(661,24026,24007,'0bb',3.333,5),(661,24027,24007,'bb9',3.333,5),(661,24028,24007,'b93',3.333,5),(661,24029,24007,'934',3.333,5),(661,24030,24007,'34e',3.333,5),(661,24031,24007,'4e4',3.333,5),(661,24032,24007,'e41',3.333,5),(661,24033,24007,'412',3.333,5),(661,24034,24007,'123',3.333,5),(661,24035,24007,'232',3.333,5),(661,24036,24007,'326',3.333,5),(661,24037,24007,'26b',3.333,5),(662,24039,24038,'naa',100,5),(662,24040,24039,'600',3.333,5),(662,24041,24039,'000',3.333,5),(662,24042,24039,'00c',3.333,5),(662,24043,24039,'0c2',3.333,5),(662,24044,24039,'c29',3.333,5),(662,24045,24039,'29d',3.333,5),(662,24046,24039,'9d3',3.333,5),(662,24047,24039,'d30',3.333,5),(662,24048,24039,'30c',3.333,5),(662,24049,24039,'0c0',3.333,5),(662,24050,24039,'c02',3.333,5),(662,24051,24039,'029',3.333,5),(662,24052,24039,'295',3.333,5),(662,24053,24039,'957',3.333,5),(662,24054,24039,'578',3.333,5),(662,24055,24039,'78a',3.333,5),(662,24056,24039,'8a6',3.333,5),(662,24057,24039,'a6c',3.333,5),(662,24058,24039,'6c0',3.333,5),(662,24059,24039,'c00',3.333,5),(662,24060,24039,'00f',3.333,5),(662,24061,24039,'0f4',3.333,5),(662,24062,24039,'f4b',3.333,5),(662,24063,24039,'4b5',3.333,5),(662,24064,24039,'b57',3.333,5),(662,24065,24039,'579',3.333,5),(662,24066,24039,'795',3.333,5),(662,24067,24039,'957',3.333,5),(662,24068,24039,'57c',3.333,5),(662,24069,24039,'7c8',3.333,5),(663,24071,24070,'naa',100,5),(663,24072,24071,'600',3.333,5),(663,24073,24071,'000',3.333,5),(663,24074,24071,'00c',3.333,5),(663,24075,24071,'0c2',3.333,5),(663,24076,24071,'c29',3.333,5),(663,24077,24071,'29c',3.333,5),(663,24078,24071,'9c6',3.333,5),(663,24079,24071,'c65',3.333,5),(663,24080,24071,'65e',3.333,5),(663,24081,24071,'5e2',3.333,5),(663,24082,24071,'e26',3.333,5),(663,24083,24071,'262',3.333,5),(663,24084,24071,'62d',3.333,5),(663,24085,24071,'2d4',3.333,5),(663,24086,24071,'d43',3.333,5),(663,24087,24071,'438',3.333,5),(663,24088,24071,'380',3.333,5),(663,24089,24071,'80d',3.333,5),(663,24090,24071,'0d8',3.333,5),(663,24091,24071,'d8d',3.333,5),(663,24092,24071,'8d1',3.333,5),(663,24093,24071,'d19',3.333,5),(663,24094,24071,'197',3.333,5),(663,24095,24071,'97d',3.333,5),(663,24096,24071,'7dc',3.333,5),(663,24097,24071,'dca',3.333,5),(663,24098,24071,'ca5',3.333,5),(663,24099,24071,'a5a',3.333,5),(663,24100,24071,'5ab',3.333,5),(663,24101,24071,'ab9',3.333,5),(664,24103,24102,'naa',100,5),(664,24104,24103,'600',3.333,5),(664,24105,24103,'000',3.333,5),(664,24106,24103,'00c',3.333,5),(664,24107,24103,'0c2',3.333,5),(664,24108,24103,'c29',3.333,5),(664,24109,24103,'293',3.333,5),(664,24110,24103,'930',3.333,5),(664,24111,24103,'30a',3.333,5),(664,24112,24103,'0ac',3.333,5),(664,24113,24103,'ac9',3.333,5),(664,24114,24103,'c93',3.333,5),(664,24115,24103,'93f',3.333,5),(664,24116,24103,'3f6',3.333,5),(664,24117,24103,'f66',3.333,5),(664,24118,24103,'663',3.333,5),(664,24119,24103,'632',3.333,5),(664,24120,24103,'327',3.333,5),(664,24121,24103,'271',3.333,5),(664,24122,24103,'712',3.333,5),(664,24123,24103,'123',3.333,5),(664,24124,24103,'23c',3.333,5),(664,24125,24103,'3cc',3.333,5),(664,24126,24103,'cc9',3.333,5),(664,24127,24103,'c90',3.333,5),(664,24128,24103,'90b',3.333,5),(664,24129,24103,'0ba',3.333,5),(664,24130,24103,'baa',3.333,5),(664,24131,24103,'aaa',3.333,5),(664,24132,24103,'aad',3.333,5),(664,24133,24103,'adc',3.333,5),(665,24135,24134,'naa',100,5),(665,24136,24135,'600',3.333,5),(665,24137,24135,'000',3.333,5),(665,24138,24135,'00c',3.333,5),(665,24139,24135,'0c2',3.333,5),(665,24140,24135,'c29',3.333,5),(665,24141,24135,'29f',3.333,5),(665,24142,24135,'9f7',3.333,5),(665,24143,24135,'f73',3.333,5),(665,24144,24135,'737',3.333,5),(665,24145,24135,'37d',3.333,5),(665,24146,24135,'7dc',3.333,5),(665,24147,24135,'dc0',3.333,5),(665,24148,24135,'c0c',3.333,5),(665,24149,24135,'0cb',3.333,5),(665,24150,24135,'cb6',3.333,5),(665,24151,24135,'b6f',3.333,5),(665,24152,24135,'6f6',3.333,5),(665,24153,24135,'f64',3.333,5),(665,24154,24135,'64b',3.333,5),(665,24155,24135,'4bd',3.333,5),(665,24156,24135,'bda',3.333,5),(665,24157,24135,'dad',3.333,5),(665,24158,24135,'ad7',3.333,5),(665,24159,24135,'d73',3.333,5),(665,24160,24135,'73e',3.333,5),(665,24161,24135,'3e4',3.333,5),(665,24162,24135,'e43',3.333,5),(665,24163,24135,'438',3.333,5),(665,24164,24135,'385',3.333,5),(665,24165,24135,'855',3.333,5),(666,24167,24166,'naa',100,5),(666,24168,24167,'600',3.333,5),(666,24169,24167,'000',3.333,5),(666,24170,24167,'00c',3.333,5),(666,24171,24167,'0c2',3.333,5),(666,24172,24167,'c29',3.333,5),(666,24173,24167,'294',3.333,5),(666,24174,24167,'945',3.333,5),(666,24175,24167,'45d',3.333,5),(666,24176,24167,'5d8',3.333,5),(666,24177,24167,'d81',3.333,5),(666,24178,24167,'81c',3.333,5),(666,24179,24167,'1cc',3.333,5),(666,24180,24167,'cc1',3.333,5),(666,24181,24167,'c14',3.333,5),(666,24182,24167,'140',3.333,5),(666,24183,24167,'40b',3.333,5),(666,24184,24167,'0b9',3.333,5),(666,24185,24167,'b98',3.333,5),(666,24186,24167,'98e',3.333,5),(666,24187,24167,'8ed',3.333,5),(666,24188,24167,'ed4',3.333,5),(666,24189,24167,'d46',3.333,5),(666,24190,24167,'463',3.333,5),(666,24191,24167,'633',3.333,5),(666,24192,24167,'330',3.333,5),(666,24193,24167,'309',3.333,5),(666,24194,24167,'099',3.333,5),(666,24195,24167,'99d',3.333,5),(666,24196,24167,'9d8',3.333,5),(666,24197,24167,'d86',3.333,5),(667,24199,24198,'naa',100,5),(667,24200,24199,'600',3.333,5),(667,24201,24199,'000',3.333,5),(667,24202,24199,'00c',3.333,5),(667,24203,24199,'0c2',3.333,5),(667,24204,24199,'c29',3.333,5),(667,24205,24199,'298',3.333,5),(667,24206,24199,'986',3.333,5),(667,24207,24199,'861',3.333,5),(667,24208,24199,'617',3.333,5),(667,24209,24199,'176',3.333,5),(667,24210,24199,'767',3.333,5),(667,24211,24199,'67e',3.333,5),(667,24212,24199,'7e1',3.333,5),(667,24213,24199,'e19',3.333,5),(667,24214,24199,'19c',3.333,5),(667,24215,24199,'9cc',3.333,5),(667,24216,24199,'ccb',3.333,5),(667,24217,24199,'cb7',3.333,5),(667,24218,24199,'b73',3.333,5),(667,24219,24199,'73e',3.333,5),(667,24220,24199,'3ef',3.333,5),(667,24221,24199,'eff',3.333,5),(667,24222,24199,'ff1',3.333,5),(667,24223,24199,'f1d',3.333,5),(667,24224,24199,'1db',3.333,5),(667,24225,24199,'db2',3.333,5),(667,24226,24199,'b2b',3.333,5),(667,24227,24199,'2b6',3.333,5),(667,24228,24199,'b6d',3.333,5),(667,24229,24199,'6d7',3.333,5),(668,24231,24230,'naa',100,5),(668,24232,24231,'600',3.333,5),(668,24233,24231,'000',3.333,5),(668,24234,24231,'00c',3.333,5),(668,24235,24231,'0c2',3.333,5),(668,24236,24231,'c29',3.333,5),(668,24237,24231,'292',3.333,5),(668,24238,24231,'929',3.333,5),(668,24239,24231,'298',3.333,5),(668,24240,24231,'98e',3.333,5),(668,24241,24231,'8e3',3.333,5),(668,24242,24231,'e39',3.333,5),(668,24243,24231,'394',3.333,5),(668,24244,24231,'941',3.333,5),(668,24245,24231,'41b',3.333,5),(668,24246,24231,'1ba',3.333,5),(668,24247,24231,'bae',3.333,5),(668,24248,24231,'ae5',3.333,5),(668,24249,24231,'e5b',3.333,5),(668,24250,24231,'5b9',3.333,5),(668,24251,24231,'b93',3.333,5),(668,24252,24231,'939',3.333,5),(668,24253,24231,'398',3.333,5),(668,24254,24231,'985',3.333,5),(668,24255,24231,'85f',3.333,5),(668,24256,24231,'5f4',3.333,5),(668,24257,24231,'f4a',3.333,5),(668,24258,24231,'4a0',3.333,5),(668,24259,24231,'a05',3.333,5),(668,24260,24231,'057',3.333,5),(668,24261,24231,'577',3.333,5),(669,24263,24262,'naa',100,5),(669,24264,24263,'600',3.333,5),(669,24265,24263,'000',3.333,5),(669,24266,24263,'00c',3.333,5),(669,24267,24263,'0c2',3.333,5),(669,24268,24263,'c29',3.333,5),(669,24269,24263,'297',3.333,5),(669,24270,24263,'975',3.333,5),(669,24271,24263,'75b',3.333,5),(669,24272,24263,'5bb',3.333,5),(669,24273,24263,'bba',3.333,5),(669,24274,24263,'bae',3.333,5),(669,24275,24263,'ae0',3.333,5),(669,24276,24263,'e0e',3.333,5),(669,24277,24263,'0ee',3.333,5),(669,24278,24263,'ee3',3.333,5),(669,24279,24263,'e3e',3.333,5),(669,24280,24263,'3ec',3.333,5),(669,24281,24263,'ece',3.333,5),(669,24282,24263,'ce6',3.333,5),(669,24283,24263,'e62',3.333,5),(669,24284,24263,'62b',3.333,5),(669,24285,24263,'2b0',3.333,5),(669,24286,24263,'b06',3.333,5),(669,24287,24263,'06a',3.333,5),(669,24288,24263,'6a5',3.333,5),(669,24289,24263,'a57',3.333,5),(669,24290,24263,'573',3.333,5),(669,24291,24263,'731',3.333,5),(669,24292,24263,'316',3.333,5),(669,24293,24263,'168',3.333,5),(670,24295,24294,'naa',100,5),(670,24296,24295,'600',3.333,5),(670,24297,24295,'000',3.333,5),(670,24298,24295,'00c',3.333,5),(670,24299,24295,'0c2',3.333,5),(670,24300,24295,'c29',3.333,5),(670,24301,24295,'298',3.333,5),(670,24302,24295,'983',3.333,5),(670,24303,24295,'835',3.333,5),(670,24304,24295,'35a',3.333,5),(670,24305,24295,'5a9',3.333,5),(670,24306,24295,'a94',3.333,5),(670,24307,24295,'945',3.333,5),(670,24308,24295,'454',3.333,5),(670,24309,24295,'549',3.333,5),(670,24310,24295,'495',3.333,5),(670,24311,24295,'950',3.333,5),(670,24312,24295,'506',3.333,5),(670,24313,24295,'068',3.333,5),(670,24314,24295,'684',3.333,5),(670,24315,24295,'84e',3.333,5),(670,24316,24295,'4ea',3.333,5),(670,24317,24295,'ea4',3.333,5),(670,24318,24295,'a4d',3.333,5),(670,24319,24295,'4d3',3.333,5),(670,24320,24295,'d30',3.333,5),(670,24321,24295,'30b',3.333,5),(670,24322,24295,'0b0',3.333,5),(670,24323,24295,'b05',3.333,5),(670,24324,24295,'05d',3.333,5),(670,24325,24295,'5d7',3.333,5),(671,24327,24326,'naa',100,5),(671,24328,24327,'600',3.333,5),(671,24329,24327,'000',3.333,5),(671,24330,24327,'00c',3.333,5),(671,24331,24327,'0c2',3.333,5),(671,24332,24327,'c29',3.333,5),(671,24333,24327,'293',3.333,5),(671,24334,24327,'939',3.333,5),(671,24335,24327,'393',3.333,5),(671,24336,24327,'932',3.333,5),(671,24337,24327,'32c',3.333,5),(671,24338,24327,'2ca',3.333,5),(671,24339,24327,'cae',3.333,5),(671,24340,24327,'aee',3.333,5),(671,24341,24327,'ee6',3.333,5),(671,24342,24327,'e64',3.333,5),(671,24343,24327,'64c',3.333,5),(671,24344,24327,'4c1',3.333,5),(671,24345,24327,'c16',3.333,5),(671,24346,24327,'16b',3.333,5),(671,24347,24327,'6bb',3.333,5),(671,24348,24327,'bb3',3.333,5),(671,24349,24327,'b3b',3.333,5),(671,24350,24327,'3be',3.333,5),(671,24351,24327,'bef',3.333,5),(671,24352,24327,'ef7',3.333,5),(671,24353,24327,'f77',3.333,5),(671,24354,24327,'770',3.333,5),(671,24355,24327,'70e',3.333,5),(671,24356,24327,'0e6',3.333,5),(671,24357,24327,'e68',3.333,5),(672,24359,24358,'naa',100,5),(672,24360,24359,'600',3.333,5),(672,24361,24359,'000',3.333,5),(672,24362,24359,'00c',3.333,5),(672,24363,24359,'0c2',3.333,5),(672,24364,24359,'c29',3.333,5),(672,24365,24359,'298',3.333,5),(672,24366,24359,'985',3.333,5),(672,24367,24359,'853',3.333,5),(672,24368,24359,'53d',3.333,5),(672,24369,24359,'3db',3.333,5),(672,24370,24359,'db4',3.333,5),(672,24371,24359,'b46',3.333,5),(672,24372,24359,'46f',3.333,5),(672,24373,24359,'6f1',3.333,5),(672,24374,24359,'f1c',3.333,5),(672,24375,24359,'1ce',3.333,5),(672,24376,24359,'ce5',3.333,5),(672,24377,24359,'e5c',3.333,5),(672,24378,24359,'5c0',3.333,5),(672,24379,24359,'c00',3.333,5),(672,24380,24359,'003',3.333,5),(672,24381,24359,'03e',3.333,5),(672,24382,24359,'3e9',3.333,5),(672,24383,24359,'e98',3.333,5),(672,24384,24359,'981',3.333,5),(672,24385,24359,'814',3.333,5),(672,24386,24359,'14e',3.333,5),(672,24387,24359,'4ea',3.333,5),(672,24388,24359,'ea4',3.333,5),(672,24389,24359,'a46',3.333,5),(673,24391,24390,'naa',100,5),(673,24392,24391,'600',3.333,5),(673,24393,24391,'000',3.333,5),(673,24394,24391,'00c',3.333,5),(673,24395,24391,'0c2',3.333,5),(673,24396,24391,'c29',3.333,5),(673,24397,24391,'297',3.333,5),(673,24398,24391,'975',3.333,5),(673,24399,24391,'756',3.333,5),(673,24400,24391,'567',3.333,5),(673,24401,24391,'673',3.333,5),(673,24402,24391,'730',3.333,5),(673,24403,24391,'304',3.333,5),(673,24404,24391,'047',3.333,5),(673,24405,24391,'477',3.333,5),(673,24406,24391,'77a',3.333,5),(673,24407,24391,'7aa',3.333,5),(673,24408,24391,'aa8',3.333,5),(673,24409,24391,'a83',3.333,5),(673,24410,24391,'83f',3.333,5),(673,24411,24391,'3f9',3.333,5),(673,24412,24391,'f90',3.333,5),(673,24413,24391,'902',3.333,5),(673,24414,24391,'026',3.333,5),(673,24415,24391,'267',3.333,5),(673,24416,24391,'67d',3.333,5),(673,24417,24391,'7d9',3.333,5),(673,24418,24391,'d97',3.333,5),(673,24419,24391,'97a',3.333,5),(673,24420,24391,'7a2',3.333,5),(673,24421,24391,'a27',3.333,5),(674,24423,24422,'naa',100,5),(674,24424,24423,'600',3.333,5),(674,24425,24423,'000',3.333,5),(674,24426,24423,'00c',3.333,5),(674,24427,24423,'0c2',3.333,5),(674,24428,24423,'c29',3.333,5),(674,24429,24423,'298',3.333,5),(674,24430,24423,'98d',3.333,5),(674,24431,24423,'8d7',3.333,5),(674,24432,24423,'d7c',3.333,5),(674,24433,24423,'7c0',3.333,5),(674,24434,24423,'c0d',3.333,5),(674,24435,24423,'0db',3.333,5),(674,24436,24423,'db9',3.333,5),(674,24437,24423,'b98',3.333,5),(674,24438,24423,'985',3.333,5),(674,24439,24423,'85c',3.333,5),(674,24440,24423,'5c4',3.333,5),(674,24441,24423,'c4c',3.333,5),(674,24442,24423,'4cc',3.333,5),(674,24443,24423,'cc2',3.333,5),(674,24444,24423,'c29',3.333,5),(674,24445,24423,'29e',3.333,5),(674,24446,24423,'9e4',3.333,5),(674,24447,24423,'e41',3.333,5),(674,24448,24423,'41f',3.333,5),(674,24449,24423,'1f6',3.333,5),(674,24450,24423,'f6b',3.333,5),(674,24451,24423,'6bb',3.333,5),(674,24452,24423,'bb3',3.333,5),(674,24453,24423,'b35',3.333,5),(675,24455,24454,'naa',100,5),(675,24456,24455,'600',3.333,5),(675,24457,24455,'000',3.333,5),(675,24458,24455,'00c',3.333,5),(675,24459,24455,'0c2',3.333,5),(675,24460,24455,'c29',3.333,5),(675,24461,24455,'295',3.333,5),(675,24462,24455,'952',3.333,5),(675,24463,24455,'52a',3.333,5),(675,24464,24455,'2aa',3.333,5),(675,24465,24455,'aab',3.333,5),(675,24466,24455,'abb',3.333,5),(675,24467,24455,'bbb',3.333,5),(675,24468,24455,'bb8',3.333,5),(675,24469,24455,'b8b',3.333,5),(675,24470,24455,'8bc',3.333,5),(675,24471,24455,'bcb',3.333,5),(675,24472,24455,'cb3',3.333,5),(675,24473,24455,'b32',3.333,5),(675,24474,24455,'32a',3.333,5),(675,24475,24455,'2a5',3.333,5),(675,24476,24455,'a5e',3.333,5),(675,24477,24455,'5e4',3.333,5),(675,24478,24455,'e42',3.333,5),(675,24479,24455,'42d',3.333,5),(675,24480,24455,'2df',3.333,5),(675,24481,24455,'df8',3.333,5),(675,24482,24455,'f89',3.333,5),(675,24483,24455,'89c',3.333,5),(675,24484,24455,'9c0',3.333,5),(675,24485,24455,'c00',3.333,5),(676,24487,24486,'naa',100,5),(676,24488,24487,'600',3.333,5),(676,24489,24487,'000',3.333,5),(676,24490,24487,'00c',3.333,5),(676,24491,24487,'0c2',3.333,5),(676,24492,24487,'c29',3.333,5),(676,24493,24487,'290',3.333,5),(676,24494,24487,'90f',3.333,5),(676,24495,24487,'0fd',3.333,5),(676,24496,24487,'fd2',3.333,5),(676,24497,24487,'d26',3.333,5),(676,24498,24487,'26c',3.333,5),(676,24499,24487,'6c0',3.333,5),(676,24500,24487,'c01',3.333,5),(676,24501,24487,'01b',3.333,5),(676,24502,24487,'1b5',3.333,5),(676,24503,24487,'b50',3.333,5),(676,24504,24487,'506',3.333,5),(676,24505,24487,'064',3.333,5),(676,24506,24487,'640',3.333,5),(676,24507,24487,'405',3.333,5),(676,24508,24487,'05e',3.333,5),(676,24509,24487,'5e8',3.333,5),(676,24510,24487,'e8c',3.333,5),(676,24511,24487,'8ca',3.333,5),(676,24512,24487,'cae',3.333,5),(676,24513,24487,'ae4',3.333,5),(676,24514,24487,'e40',3.333,5),(676,24515,24487,'405',3.333,5),(676,24516,24487,'05f',3.333,5),(676,24517,24487,'5f4',3.333,5),(677,24519,24518,'naa',100,5),(677,24520,24519,'600',3.333,5),(677,24521,24519,'000',3.333,5),(677,24522,24519,'00c',3.333,5),(677,24523,24519,'0c2',3.333,5),(677,24524,24519,'c29',3.333,5),(677,24525,24519,'29f',3.333,5),(677,24526,24519,'9f4',3.333,5),(677,24527,24519,'f42',3.333,5),(677,24528,24519,'42d',3.333,5),(677,24529,24519,'2da',3.333,5),(677,24530,24519,'da8',3.333,5),(677,24531,24519,'a81',3.333,5),(677,24532,24519,'819',3.333,5),(677,24533,24519,'199',3.333,5),(677,24534,24519,'99b',3.333,5),(677,24535,24519,'9be',3.333,5),(677,24536,24519,'be3',3.333,5),(677,24537,24519,'e34',3.333,5),(677,24538,24519,'348',3.333,5),(677,24539,24519,'48d',3.333,5),(677,24540,24519,'8da',3.333,5),(677,24541,24519,'da7',3.333,5),(677,24542,24519,'a7e',3.333,5),(677,24543,24519,'7ef',3.333,5),(677,24544,24519,'ef6',3.333,5),(677,24545,24519,'f61',3.333,5),(677,24546,24519,'618',3.333,5),(677,24547,24519,'18f',3.333,5),(677,24548,24519,'8f9',3.333,5),(677,24549,24519,'f91',3.333,5),(678,24551,24550,'naa',100,5),(678,24552,24551,'600',3.333,5),(678,24553,24551,'000',3.333,5),(678,24554,24551,'00c',3.333,5),(678,24555,24551,'0c2',3.333,5),(678,24556,24551,'c29',3.333,5),(678,24557,24551,'290',3.333,5),(678,24558,24551,'908',3.333,5),(678,24559,24551,'089',3.333,5),(678,24560,24551,'89d',3.333,5),(678,24561,24551,'9d7',3.333,5),(678,24562,24551,'d73',3.333,5),(678,24563,24551,'730',3.333,5),(678,24564,24551,'30f',3.333,5),(678,24565,24551,'0f1',3.333,5),(678,24566,24551,'f12',3.333,5),(678,24567,24551,'128',3.333,5),(678,24568,24551,'28d',3.333,5),(678,24569,24551,'8d9',3.333,5),(678,24570,24551,'d97',3.333,5),(678,24571,24551,'975',3.333,5),(678,24572,24551,'751',3.333,5),(678,24573,24551,'510',3.333,5),(678,24574,24551,'10a',3.333,5),(678,24575,24551,'0ad',3.333,5),(678,24576,24551,'ade',3.333,5),(678,24577,24551,'de8',3.333,5),(678,24578,24551,'e8a',3.333,5),(678,24579,24551,'8ae',3.333,5),(678,24580,24551,'ae2',3.333,5),(678,24581,24551,'e24',3.333,5),(679,24583,24582,'naa',100,5),(679,24584,24583,'600',3.333,5),(679,24585,24583,'000',3.333,5),(679,24586,24583,'00c',3.333,5),(679,24587,24583,'0c2',3.333,5),(679,24588,24583,'c29',3.333,5),(679,24589,24583,'294',3.333,5),(679,24590,24583,'947',3.333,5),(679,24591,24583,'474',3.333,5),(679,24592,24583,'74d',3.333,5),(679,24593,24583,'4db',3.333,5),(679,24594,24583,'dbb',3.333,5),(679,24595,24583,'bbf',3.333,5),(679,24596,24583,'bff',3.333,5),(679,24597,24583,'ff7',3.333,5),(679,24598,24583,'f7d',3.333,5),(679,24599,24583,'7d5',3.333,5),(679,24600,24583,'d52',3.333,5),(679,24601,24583,'522',3.333,5),(679,24602,24583,'221',3.333,5),(679,24603,24583,'210',3.333,5),(679,24604,24583,'105',3.333,5),(679,24605,24583,'054',3.333,5),(679,24606,24583,'54c',3.333,5),(679,24607,24583,'4c6',3.333,5),(679,24608,24583,'c67',3.333,5),(679,24609,24583,'675',3.333,5),(679,24610,24583,'75b',3.333,5),(679,24611,24583,'5ba',3.333,5),(679,24612,24583,'ba9',3.333,5),(679,24613,24583,'a9e',3.333,5),(680,24615,24614,'naa',100,5),(680,24616,24615,'600',3.333,5),(680,24617,24615,'000',3.333,5),(680,24618,24615,'00c',3.333,5),(680,24619,24615,'0c2',3.333,5),(680,24620,24615,'c29',3.333,5),(680,24621,24615,'297',3.333,5),(680,24622,24615,'97f',3.333,5),(680,24623,24615,'7f0',3.333,5),(680,24624,24615,'f07',3.333,5),(680,24625,24615,'077',3.333,5),(680,24626,24615,'773',3.333,5),(680,24627,24615,'730',3.333,5),(680,24628,24615,'307',3.333,5),(680,24629,24615,'07e',3.333,5),(680,24630,24615,'7e1',3.333,5),(680,24631,24615,'e1a',3.333,5),(680,24632,24615,'1ad',3.333,5),(680,24633,24615,'ad0',3.333,5),(680,24634,24615,'d01',3.333,5),(680,24635,24615,'014',3.333,5),(680,24636,24615,'144',3.333,5),(680,24637,24615,'44a',3.333,5),(680,24638,24615,'4aa',3.333,5),(680,24639,24615,'aa4',3.333,5),(680,24640,24615,'a43',3.333,5),(680,24641,24615,'437',3.333,5),(680,24642,24615,'379',3.333,5),(680,24643,24615,'797',3.333,5),(680,24644,24615,'971',3.333,5),(680,24645,24615,'718',3.333,5),(681,24647,24646,'naa',100,5),(681,24648,24647,'600',3.333,5),(681,24649,24647,'000',3.333,5),(681,24650,24647,'00c',3.333,5),(681,24651,24647,'0c2',3.333,5),(681,24652,24647,'c29',3.333,5),(681,24653,24647,'299',3.333,5),(681,24654,24647,'995',3.333,5),(681,24655,24647,'950',3.333,5),(681,24656,24647,'508',3.333,5),(681,24657,24647,'084',3.333,5),(681,24658,24647,'844',3.333,5),(681,24659,24647,'440',3.333,5),(681,24660,24647,'402',3.333,5),(681,24661,24647,'028',3.333,5),(681,24662,24647,'28f',3.333,5),(681,24663,24647,'8fa',3.333,5),(681,24664,24647,'fa8',3.333,5),(681,24665,24647,'a82',3.333,5),(681,24666,24647,'827',3.333,5),(681,24667,24647,'275',3.333,5),(681,24668,24647,'75f',3.333,5),(681,24669,24647,'5f0',3.333,5),(681,24670,24647,'f03',3.333,5),(681,24671,24647,'032',3.333,5),(681,24672,24647,'320',3.333,5),(681,24673,24647,'208',3.333,5),(681,24674,24647,'088',3.333,5),(681,24675,24647,'885',3.333,5),(681,24676,24647,'852',3.333,5),(681,24677,24647,'52d',3.333,5),(682,24679,24678,'naa',100,5),(682,24680,24679,'600',3.333,5),(682,24681,24679,'000',3.333,5),(682,24682,24679,'00c',3.333,5),(682,24683,24679,'0c2',3.333,5),(682,24684,24679,'c29',3.333,5),(682,24685,24679,'296',3.333,5),(682,24686,24679,'969',3.333,5),(682,24687,24679,'691',3.333,5),(682,24688,24679,'911',3.333,5),(682,24689,24679,'11c',3.333,5),(682,24690,24679,'1c2',3.333,5),(682,24691,24679,'c21',3.333,5),(682,24692,24679,'21a',3.333,5),(682,24693,24679,'1ad',3.333,5),(682,24694,24679,'adc',3.333,5),(682,24695,24679,'dcd',3.333,5),(682,24696,24679,'cd1',3.333,5),(682,24697,24679,'d17',3.333,5),(682,24698,24679,'173',3.333,5),(682,24699,24679,'73a',3.333,5),(682,24700,24679,'3a8',3.333,5),(682,24701,24679,'a89',3.333,5),(682,24702,24679,'89d',3.333,5),(682,24703,24679,'9d3',3.333,5),(682,24704,24679,'d35',3.333,5),(682,24705,24679,'35e',3.333,5),(682,24706,24679,'5ed',3.333,5),(682,24707,24679,'ed1',3.333,5),(682,24708,24679,'d1f',3.333,5),(682,24709,24679,'1ff',3.333,5),(683,24711,24710,'naa',100,5),(683,24712,24711,'600',3.333,5),(683,24713,24711,'000',3.333,5),(683,24714,24711,'00c',3.333,5),(683,24715,24711,'0c2',3.333,5),(683,24716,24711,'c29',3.333,5),(683,24717,24711,'293',3.333,5),(683,24718,24711,'938',3.333,5),(683,24719,24711,'38c',3.333,5),(683,24720,24711,'8cc',3.333,5),(683,24721,24711,'cc1',3.333,5),(683,24722,24711,'c18',3.333,5),(683,24723,24711,'185',3.333,5),(683,24724,24711,'851',3.333,5),(683,24725,24711,'51b',3.333,5),(683,24726,24711,'1b4',3.333,5),(683,24727,24711,'b41',3.333,5),(683,24728,24711,'41a',3.333,5),(683,24729,24711,'1a5',3.333,5),(683,24730,24711,'a5b',3.333,5),(683,24731,24711,'5bb',3.333,5),(683,24732,24711,'bbb',3.333,5),(683,24733,24711,'bb9',3.333,5),(683,24734,24711,'b9c',3.333,5),(683,24735,24711,'9cd',3.333,5),(683,24736,24711,'cdd',3.333,5),(683,24737,24711,'dd4',3.333,5),(683,24738,24711,'d43',3.333,5),(683,24739,24711,'430',3.333,5),(683,24740,24711,'30d',3.333,5),(683,24741,24711,'0df',3.333,5),(684,24743,24742,'naa',100,5),(684,24744,24743,'600',3.333,5),(684,24745,24743,'000',3.333,5),(684,24746,24743,'00c',3.333,5),(684,24747,24743,'0c2',3.333,5),(684,24748,24743,'c29',3.333,5),(684,24749,24743,'29f',3.333,5),(684,24750,24743,'9f0',3.333,5),(684,24751,24743,'f03',3.333,5),(684,24752,24743,'035',3.333,5),(684,24753,24743,'353',3.333,5),(684,24754,24743,'535',3.333,5),(684,24755,24743,'358',3.333,5),(684,24756,24743,'58f',3.333,5),(684,24757,24743,'8fb',3.333,5),(684,24758,24743,'fbf',3.333,5),(684,24759,24743,'bf3',3.333,5),(684,24760,24743,'f3c',3.333,5),(684,24761,24743,'3c6',3.333,5),(684,24762,24743,'c60',3.333,5),(684,24763,24743,'60d',3.333,5),(684,24764,24743,'0d3',3.333,5),(684,24765,24743,'d36',3.333,5),(684,24766,24743,'368',3.333,5),(684,24767,24743,'689',3.333,5),(684,24768,24743,'899',3.333,5),(684,24769,24743,'996',3.333,5),(684,24770,24743,'963',3.333,5),(684,24771,24743,'639',3.333,5),(684,24772,24743,'396',3.333,5),(684,24773,24743,'96a',3.333,5),(685,24775,24774,'naa',100,5),(685,24776,24775,'600',3.333,5),(685,24777,24775,'000',3.333,5),(685,24778,24775,'00c',3.333,5),(685,24779,24775,'0c2',3.333,5),(685,24780,24775,'c29',3.333,5),(685,24781,24775,'299',3.333,5),(685,24782,24775,'99b',3.333,5),(685,24783,24775,'9bc',3.333,5),(685,24784,24775,'bcf',3.333,5),(685,24785,24775,'cfa',3.333,5),(685,24786,24775,'fa1',3.333,5),(685,24787,24775,'a1e',3.333,5),(685,24788,24775,'1e2',3.333,5),(685,24789,24775,'e2d',3.333,5),(685,24790,24775,'2dc',3.333,5),(685,24791,24775,'dca',3.333,5),(685,24792,24775,'ca1',3.333,5),(685,24793,24775,'a1c',3.333,5),(685,24794,24775,'1c1',3.333,5),(685,24795,24775,'c12',3.333,5),(685,24796,24775,'12a',3.333,5),(685,24797,24775,'2a2',3.333,5),(685,24798,24775,'a24',3.333,5),(685,24799,24775,'246',3.333,5),(685,24800,24775,'46b',3.333,5),(685,24801,24775,'6bb',3.333,5),(685,24802,24775,'bb3',3.333,5),(685,24803,24775,'b38',3.333,5),(685,24804,24775,'38b',3.333,5),(685,24805,24775,'8b3',3.333,5),(686,24807,24806,'naa',100,5),(686,24808,24807,'600',3.333,5),(686,24809,24807,'000',3.333,5),(686,24810,24807,'00c',3.333,5),(686,24811,24807,'0c2',3.333,5),(686,24812,24807,'c29',3.333,5),(686,24813,24807,'293',3.333,5),(686,24814,24807,'93f',3.333,5),(686,24815,24807,'3fb',3.333,5),(686,24816,24807,'fb3',3.333,5),(686,24817,24807,'b36',3.333,5),(686,24818,24807,'36e',3.333,5),(686,24819,24807,'6e8',3.333,5),(686,24820,24807,'e8a',3.333,5),(686,24821,24807,'8a0',3.333,5),(686,24822,24807,'a07',3.333,5),(686,24823,24807,'077',3.333,5),(686,24824,24807,'775',3.333,5),(686,24825,24807,'75b',3.333,5),(686,24826,24807,'5b9',3.333,5),(686,24827,24807,'b9c',3.333,5),(686,24828,24807,'9cb',3.333,5),(686,24829,24807,'cbb',3.333,5),(686,24830,24807,'bbe',3.333,5),(686,24831,24807,'be1',3.333,5),(686,24832,24807,'e11',3.333,5),(686,24833,24807,'11b',3.333,5),(686,24834,24807,'1b6',3.333,5),(686,24835,24807,'b63',3.333,5),(686,24836,24807,'630',3.333,5),(686,24837,24807,'305',3.333,5),(687,24839,24838,'naa',100,5),(687,24840,24839,'600',3.333,5),(687,24841,24839,'000',3.333,5),(687,24842,24839,'00c',3.333,5),(687,24843,24839,'0c2',3.333,5),(687,24844,24839,'c29',3.333,5),(687,24845,24839,'29f',3.333,5),(687,24846,24839,'9f7',3.333,5),(687,24847,24839,'f7c',3.333,5),(687,24848,24839,'7ce',3.333,5),(687,24849,24839,'ce0',3.333,5),(687,24850,24839,'e0c',3.333,5),(687,24851,24839,'0c9',3.333,5),(687,24852,24839,'c90',3.333,5),(687,24853,24839,'905',3.333,5),(687,24854,24839,'052',3.333,5),(687,24855,24839,'52b',3.333,5),(687,24856,24839,'2b7',3.333,5),(687,24857,24839,'b74',3.333,5),(687,24858,24839,'746',3.333,5),(687,24859,24839,'461',3.333,5),(687,24860,24839,'61c',3.333,5),(687,24861,24839,'1c1',3.333,5),(687,24862,24839,'c1a',3.333,5),(687,24863,24839,'1a1',3.333,5),(687,24864,24839,'a10',3.333,5),(687,24865,24839,'108',3.333,5),(687,24866,24839,'08d',3.333,5),(687,24867,24839,'8d7',3.333,5),(687,24868,24839,'d71',3.333,5),(687,24869,24839,'71f',3.333,5),(688,24871,24870,'naa',100,5),(688,24872,24871,'600',3.333,5),(688,24873,24871,'000',3.333,5),(688,24874,24871,'00c',3.333,5),(688,24875,24871,'0c2',3.333,5),(688,24876,24871,'c29',3.333,5),(688,24877,24871,'29f',3.333,5),(688,24878,24871,'9f1',3.333,5),(688,24879,24871,'f17',3.333,5),(688,24880,24871,'173',3.333,5),(688,24881,24871,'731',3.333,5),(688,24882,24871,'314',3.333,5),(688,24883,24871,'142',3.333,5),(688,24884,24871,'425',3.333,5),(688,24885,24871,'252',3.333,5),(688,24886,24871,'521',3.333,5),(688,24887,24871,'21d',3.333,5),(688,24888,24871,'1d0',3.333,5),(688,24889,24871,'d0b',3.333,5),(688,24890,24871,'0b6',3.333,5),(688,24891,24871,'b6d',3.333,5),(688,24892,24871,'6de',3.333,5),(688,24893,24871,'dee',3.333,5),(688,24894,24871,'eed',3.333,5),(688,24895,24871,'ed7',3.333,5),(688,24896,24871,'d79',3.333,5),(688,24897,24871,'795',3.333,5),(688,24898,24871,'956',3.333,5),(688,24899,24871,'560',3.333,5),(688,24900,24871,'609',3.333,5),(688,24901,24871,'09d',3.333,5),(689,24903,24902,'naa',100,5),(689,24904,24903,'600',3.333,5),(689,24905,24903,'000',3.333,5),(689,24906,24903,'00c',3.333,5),(689,24907,24903,'0c2',3.333,5),(689,24908,24903,'c29',3.333,5),(689,24909,24903,'295',3.333,5),(689,24910,24903,'95b',3.333,5),(689,24911,24903,'5b7',3.333,5),(689,24912,24903,'b71',3.333,5),(689,24913,24903,'71f',3.333,5),(689,24914,24903,'1f7',3.333,5),(689,24915,24903,'f71',3.333,5),(689,24916,24903,'715',3.333,5),(689,24917,24903,'15f',3.333,5),(689,24918,24903,'5f8',3.333,5),(689,24919,24903,'f89',3.333,5),(689,24920,24903,'89e',3.333,5),(689,24921,24903,'9e7',3.333,5),(689,24922,24903,'e72',3.333,5),(689,24923,24903,'724',3.333,5),(689,24924,24903,'240',3.333,5),(689,24925,24903,'406',3.333,5),(689,24926,24903,'063',3.333,5),(689,24927,24903,'63e',3.333,5),(689,24928,24903,'3eb',3.333,5),(689,24929,24903,'ebb',3.333,5),(689,24930,24903,'bb2',3.333,5),(689,24931,24903,'b2c',3.333,5),(689,24932,24903,'2c1',3.333,5),(689,24933,24903,'c1a',3.333,5),(690,24935,24934,'naa',100,5),(690,24936,24935,'600',3.333,5),(690,24937,24935,'000',3.333,5),(690,24938,24935,'00c',3.333,5),(690,24939,24935,'0c2',3.333,5),(690,24940,24935,'c29',3.333,5),(690,24941,24935,'29f',3.333,5),(690,24942,24935,'9f7',3.333,5),(690,24943,24935,'f71',3.333,5),(690,24944,24935,'710',3.333,5),(690,24945,24935,'101',3.333,5),(690,24946,24935,'011',3.333,5),(690,24947,24935,'113',3.333,5),(690,24948,24935,'13c',3.333,5),(690,24949,24935,'3ca',3.333,5),(690,24950,24935,'ca8',3.333,5),(690,24951,24935,'a8f',3.333,5),(690,24952,24935,'8f9',3.333,5),(690,24953,24935,'f91',3.333,5),(690,24954,24935,'912',3.333,5),(690,24955,24935,'127',3.333,5),(690,24956,24935,'277',3.333,5),(690,24957,24935,'77f',3.333,5),(690,24958,24935,'7f4',3.333,5),(690,24959,24935,'f42',3.333,5),(690,24960,24935,'42f',3.333,5),(690,24961,24935,'2fa',3.333,5),(690,24962,24935,'fa5',3.333,5),(690,24963,24935,'a52',3.333,5),(690,24964,24935,'529',3.333,5),(690,24965,24935,'29d',3.333,5),(691,24967,24966,'naa',100,5),(691,24968,24967,'600',3.333,5),(691,24969,24967,'000',3.333,5),(691,24970,24967,'00c',3.333,5),(691,24971,24967,'0c2',3.333,5),(691,24972,24967,'c29',3.333,5),(691,24973,24967,'29b',3.333,5),(691,24974,24967,'9b0',3.333,5),(691,24975,24967,'b0f',3.333,5),(691,24976,24967,'0f9',3.333,5),(691,24977,24967,'f9f',3.333,5),(691,24978,24967,'9f1',3.333,5),(691,24979,24967,'f1a',3.333,5),(691,24980,24967,'1a3',3.333,5),(691,24981,24967,'a3b',3.333,5),(691,24982,24967,'3b2',3.333,5),(691,24983,24967,'b2e',3.333,5),(691,24984,24967,'2e4',3.333,5),(691,24985,24967,'e4f',3.333,5),(691,24986,24967,'4ff',3.333,5),(691,24987,24967,'ff9',3.333,5),(691,24988,24967,'f91',3.333,5),(691,24989,24967,'91f',3.333,5),(691,24990,24967,'1f6',3.333,5),(691,24991,24967,'f6e',3.333,5),(691,24992,24967,'6ef',3.333,5),(691,24993,24967,'eff',3.333,5),(691,24994,24967,'ffb',3.333,5),(691,24995,24967,'fb5',3.333,5),(691,24996,24967,'b54',3.333,5),(691,24997,24967,'54d',3.333,5),(692,24999,24998,'naa',100,5),(692,25000,24999,'600',3.333,5),(692,25001,24999,'000',3.333,5),(692,25002,24999,'00c',3.333,5),(692,25003,24999,'0c2',3.333,5),(692,25004,24999,'c29',3.333,5),(692,25005,24999,'29c',3.333,5),(692,25006,24999,'9c3',3.333,5),(692,25007,24999,'c3a',3.333,5),(692,25008,24999,'3a9',3.333,5),(692,25009,24999,'a99',3.333,5),(692,25010,24999,'99f',3.333,5),(692,25011,24999,'9f5',3.333,5),(692,25012,24999,'f55',3.333,5),(692,25013,24999,'557',3.333,5),(692,25014,24999,'57d',3.333,5),(692,25015,24999,'7da',3.333,5),(692,25016,24999,'da1',3.333,5),(692,25017,24999,'a10',3.333,5),(692,25018,24999,'107',3.333,5),(692,25019,24999,'077',3.333,5),(692,25020,24999,'778',3.333,5),(692,25021,24999,'784',3.333,5),(692,25022,24999,'84e',3.333,5),(692,25023,24999,'4e0',3.333,5),(692,25024,24999,'e0e',3.333,5),(692,25025,24999,'0e7',3.333,5),(692,25026,24999,'e76',3.333,5),(692,25027,24999,'76d',3.333,5),(692,25028,24999,'6df',3.333,5),(692,25029,24999,'df4',3.333,5),(693,25031,25030,'naa',100,5),(693,25032,25031,'600',3.333,5),(693,25033,25031,'000',3.333,5),(693,25034,25031,'00c',3.333,5),(693,25035,25031,'0c2',3.333,5),(693,25036,25031,'c29',3.333,5),(693,25037,25031,'29f',3.333,5),(693,25038,25031,'9fc',3.333,5),(693,25039,25031,'fce',3.333,5),(693,25040,25031,'ce8',3.333,5),(693,25041,25031,'e80',3.333,5),(693,25042,25031,'80c',3.333,5),(693,25043,25031,'0cd',3.333,5),(693,25044,25031,'cd6',3.333,5),(693,25045,25031,'d6e',3.333,5),(693,25046,25031,'6e1',3.333,5),(693,25047,25031,'e14',3.333,5),(693,25048,25031,'14c',3.333,5),(693,25049,25031,'4c8',3.333,5),(693,25050,25031,'c85',3.333,5),(693,25051,25031,'85e',3.333,5),(693,25052,25031,'5e9',3.333,5),(693,25053,25031,'e9f',3.333,5),(693,25054,25031,'9f0',3.333,5),(693,25055,25031,'f08',3.333,5),(693,25056,25031,'08c',3.333,5),(693,25057,25031,'8cc',3.333,5),(693,25058,25031,'cc2',3.333,5),(693,25059,25031,'c2c',3.333,5),(693,25060,25031,'2c5',3.333,5),(693,25061,25031,'c5c',3.333,5),(694,25063,25062,'naa',100,5),(694,25064,25063,'600',3.333,5),(694,25065,25063,'000',3.333,5),(694,25066,25063,'00c',3.333,5),(694,25067,25063,'0c2',3.333,5),(694,25068,25063,'c29',3.333,5),(694,25069,25063,'293',3.333,5),(694,25070,25063,'931',3.333,5),(694,25071,25063,'31e',3.333,5),(694,25072,25063,'1ec',3.333,5),(694,25073,25063,'ec1',3.333,5),(694,25074,25063,'c11',3.333,5),(694,25075,25063,'111',3.333,5),(694,25076,25063,'11e',3.333,5),(694,25077,25063,'1ed',3.333,5),(694,25078,25063,'ed6',3.333,5),(694,25079,25063,'d6d',3.333,5),(694,25080,25063,'6df',3.333,5),(694,25081,25063,'df3',3.333,5),(694,25082,25063,'f32',3.333,5),(694,25083,25063,'32f',3.333,5),(694,25084,25063,'2fb',3.333,5),(694,25085,25063,'fb8',3.333,5),(694,25086,25063,'b87',3.333,5),(694,25087,25063,'87f',3.333,5),(694,25088,25063,'7fe',3.333,5),(694,25089,25063,'fe0',3.333,5),(694,25090,25063,'e07',3.333,5),(694,25091,25063,'078',3.333,5),(694,25092,25063,'78e',3.333,5),(694,25093,25063,'8ec',3.333,5),(695,25095,25094,'naa',100,5),(695,25096,25095,'600',3.333,5),(695,25097,25095,'000',3.333,5),(695,25098,25095,'00c',3.333,5),(695,25099,25095,'0c2',3.333,5),(695,25100,25095,'c29',3.333,5),(695,25101,25095,'291',3.333,5),(695,25102,25095,'919',3.333,5),(695,25103,25095,'19b',3.333,5),(695,25104,25095,'9b6',3.333,5),(695,25105,25095,'b60',3.333,5),(695,25106,25095,'604',3.333,5),(695,25107,25095,'048',3.333,5),(695,25108,25095,'483',3.333,5),(695,25109,25095,'83d',3.333,5),(695,25110,25095,'3d8',3.333,5),(695,25111,25095,'d89',3.333,5),(695,25112,25095,'890',3.333,5),(695,25113,25095,'900',3.333,5),(695,25114,25095,'005',3.333,5),(695,25115,25095,'051',3.333,5),(695,25116,25095,'510',3.333,5),(695,25117,25095,'104',3.333,5),(695,25118,25095,'04a',3.333,5),(695,25119,25095,'4ac',3.333,5),(695,25120,25095,'acc',3.333,5),(695,25121,25095,'cc7',3.333,5),(695,25122,25095,'c70',3.333,5),(695,25123,25095,'708',3.333,5),(695,25124,25095,'086',3.333,5),(695,25125,25095,'86c',3.333,5),(696,25127,25126,'naa',100,5),(696,25128,25127,'600',3.333,5),(696,25129,25127,'000',3.333,5),(696,25130,25127,'00c',3.333,5),(696,25131,25127,'0c2',3.333,5),(696,25132,25127,'c29',3.333,5),(696,25133,25127,'298',3.333,5),(696,25134,25127,'98c',3.333,5),(696,25135,25127,'8c7',3.333,5),(696,25136,25127,'c79',3.333,5),(696,25137,25127,'790',3.333,5),(696,25138,25127,'906',3.333,5),(696,25139,25127,'06e',3.333,5),(696,25140,25127,'6e2',3.333,5),(696,25141,25127,'e21',3.333,5),(696,25142,25127,'216',3.333,5),(696,25143,25127,'16e',3.333,5),(696,25144,25127,'6ef',3.333,5),(696,25145,25127,'ef0',3.333,5),(696,25146,25127,'f02',3.333,5),(696,25147,25127,'02e',3.333,5),(696,25148,25127,'2eb',3.333,5),(696,25149,25127,'ebe',3.333,5),(696,25150,25127,'be5',3.333,5),(696,25151,25127,'e5c',3.333,5),(696,25152,25127,'5c8',3.333,5),(696,25153,25127,'c8a',3.333,5),(696,25154,25127,'8a0',3.333,5),(696,25155,25127,'a07',3.333,5),(696,25156,25127,'072',3.333,5),(696,25157,25127,'72e',3.333,5),(697,25159,25158,'naa',100,5),(697,25160,25159,'600',3.333,5),(697,25161,25159,'000',3.333,5),(697,25162,25159,'00c',3.333,5),(697,25163,25159,'0c2',3.333,5),(697,25164,25159,'c29',3.333,5),(697,25165,25159,'299',3.333,5),(697,25166,25159,'995',3.333,5),(697,25167,25159,'952',3.333,5),(697,25168,25159,'521',3.333,5),(697,25169,25159,'215',3.333,5),(697,25170,25159,'15e',3.333,5),(697,25171,25159,'5e4',3.333,5),(697,25172,25159,'e42',3.333,5),(697,25173,25159,'42f',3.333,5),(697,25174,25159,'2f5',3.333,5),(697,25175,25159,'f5f',3.333,5),(697,25176,25159,'5f2',3.333,5),(697,25177,25159,'f29',3.333,5),(697,25178,25159,'29e',3.333,5),(697,25179,25159,'9ea',3.333,5),(697,25180,25159,'ea7',3.333,5),(697,25181,25159,'a7c',3.333,5),(697,25182,25159,'7c0',3.333,5),(697,25183,25159,'c0a',3.333,5),(697,25184,25159,'0a3',3.333,5),(697,25185,25159,'a3f',3.333,5),(697,25186,25159,'3f1',3.333,5),(697,25187,25159,'f13',3.333,5),(697,25188,25159,'130',3.333,5),(697,25189,25159,'30e',3.333,5),(698,25191,25190,'naa',100,5),(698,25192,25191,'600',3.333,5),(698,25193,25191,'000',3.333,5),(698,25194,25191,'00c',3.333,5),(698,25195,25191,'0c2',3.333,5),(698,25196,25191,'c29',3.333,5),(698,25197,25191,'29d',3.333,5),(698,25198,25191,'9d0',3.333,5),(698,25199,25191,'d0b',3.333,5),(698,25200,25191,'0bd',3.333,5),(698,25201,25191,'bdf',3.333,5),(698,25202,25191,'dfb',3.333,5),(698,25203,25191,'fb2',3.333,5),(698,25204,25191,'b23',3.333,5),(698,25205,25191,'234',3.333,5),(698,25206,25191,'340',3.333,5),(698,25207,25191,'40f',3.333,5),(698,25208,25191,'0f4',3.333,5),(698,25209,25191,'f41',3.333,5),(698,25210,25191,'414',3.333,5),(698,25211,25191,'148',3.333,5),(698,25212,25191,'48b',3.333,5),(698,25213,25191,'8bb',3.333,5),(698,25214,25191,'bb8',3.333,5),(698,25215,25191,'b8a',3.333,5),(698,25216,25191,'8a1',3.333,5),(698,25217,25191,'a19',3.333,5),(698,25218,25191,'198',3.333,5),(698,25219,25191,'985',3.333,5),(698,25220,25191,'857',3.333,5),(698,25221,25191,'57e',3.333,5),(699,25223,25222,'naa',100,5),(699,25224,25223,'600',3.333,5),(699,25225,25223,'000',3.333,5),(699,25226,25223,'00c',3.333,5),(699,25227,25223,'0c2',3.333,5),(699,25228,25223,'c29',3.333,5),(699,25229,25223,'29d',3.333,5),(699,25230,25223,'9d4',3.333,5),(699,25231,25223,'d45',3.333,5),(699,25232,25223,'45c',3.333,5),(699,25233,25223,'5c3',3.333,5),(699,25234,25223,'c31',3.333,5),(699,25235,25223,'311',3.333,5),(699,25236,25223,'110',3.333,5),(699,25237,25223,'106',3.333,5),(699,25238,25223,'06b',3.333,5),(699,25239,25223,'6be',3.333,5),(699,25240,25223,'bef',3.333,5),(699,25241,25223,'eff',3.333,5),(699,25242,25223,'fff',3.333,5),(699,25243,25223,'ff4',3.333,5),(699,25244,25223,'f47',3.333,5),(699,25245,25223,'47a',3.333,5),(699,25246,25223,'7ab',3.333,5),(699,25247,25223,'abc',3.333,5),(699,25248,25223,'bc8',3.333,5),(699,25249,25223,'c85',3.333,5),(699,25250,25223,'857',3.333,5),(699,25251,25223,'57a',3.333,5),(699,25252,25223,'7a9',3.333,5),(699,25253,25223,'a9f',3.333,5),(700,25255,25254,'naa',100,5),(700,25256,25255,'600',3.333,5),(700,25257,25255,'000',3.333,5),(700,25258,25255,'00c',3.333,5),(700,25259,25255,'0c2',3.333,5),(700,25260,25255,'c29',3.333,5),(700,25261,25255,'296',3.333,5),(700,25262,25255,'968',3.333,5),(700,25263,25255,'688',3.333,5),(700,25264,25255,'88e',3.333,5),(700,25265,25255,'8e0',3.333,5),(700,25266,25255,'e00',3.333,5),(700,25267,25255,'00a',3.333,5),(700,25268,25255,'0a8',3.333,5),(700,25269,25255,'a8a',3.333,5),(700,25270,25255,'8a5',3.333,5),(700,25271,25255,'a55',3.333,5),(700,25272,25255,'55f',3.333,5),(700,25273,25255,'5f1',3.333,5),(700,25274,25255,'f1e',3.333,5),(700,25275,25255,'1e8',3.333,5),(700,25276,25255,'e8d',3.333,5),(700,25277,25255,'8de',3.333,5),(700,25278,25255,'dec',3.333,5),(700,25279,25255,'ec4',3.333,5),(700,25280,25255,'c46',3.333,5),(700,25281,25255,'469',3.333,5),(700,25282,25255,'69e',3.333,5),(700,25283,25255,'9e8',3.333,5),(700,25284,25255,'e87',3.333,5),(700,25285,25255,'878',3.333,5),(701,25287,25286,'naa',100,5),(701,25288,25287,'600',3.333,5),(701,25289,25287,'000',3.333,5),(701,25290,25287,'00c',3.333,5),(701,25291,25287,'0c2',3.333,5),(701,25292,25287,'c29',3.333,5),(701,25293,25287,'29e',3.333,5),(701,25294,25287,'9e7',3.333,5),(701,25295,25287,'e74',3.333,5),(701,25296,25287,'741',3.333,5),(701,25297,25287,'41b',3.333,5),(701,25298,25287,'1bd',3.333,5),(701,25299,25287,'bd1',3.333,5),(701,25300,25287,'d1f',3.333,5),(701,25301,25287,'1fa',3.333,5),(701,25302,25287,'fad',3.333,5),(701,25303,25287,'adb',3.333,5),(701,25304,25287,'db7',3.333,5),(701,25305,25287,'b71',3.333,5),(701,25306,25287,'711',3.333,5),(701,25307,25287,'11c',3.333,5),(701,25308,25287,'1c4',3.333,5),(701,25309,25287,'c48',3.333,5),(701,25310,25287,'48b',3.333,5),(701,25311,25287,'8be',3.333,5),(701,25312,25287,'be2',3.333,5),(701,25313,25287,'e21',3.333,5),(701,25314,25287,'212',3.333,5),(701,25315,25287,'129',3.333,5),(701,25316,25287,'29d',3.333,5),(701,25317,25287,'9d8',3.333,5),(702,25319,25318,'naa',100,5),(702,25320,25319,'600',3.333,5),(702,25321,25319,'000',3.333,5),(702,25322,25319,'00c',3.333,5),(702,25323,25319,'0c2',3.333,5),(702,25324,25319,'c29',3.333,5),(702,25325,25319,'291',3.333,5),(702,25326,25319,'91d',3.333,5),(702,25327,25319,'1dc',3.333,5),(702,25328,25319,'dcf',3.333,5),(702,25329,25319,'cf2',3.333,5),(702,25330,25319,'f2c',3.333,5),(702,25331,25319,'2c1',3.333,5),(702,25332,25319,'c1d',3.333,5),(702,25333,25319,'1df',3.333,5),(702,25334,25319,'df7',3.333,5),(702,25335,25319,'f7c',3.333,5),(702,25336,25319,'7cf',3.333,5),(702,25337,25319,'cfb',3.333,5),(702,25338,25319,'fb2',3.333,5),(702,25339,25319,'b20',3.333,5),(702,25340,25319,'205',3.333,5),(702,25341,25319,'05a',3.333,5),(702,25342,25319,'5a2',3.333,5),(702,25343,25319,'a2e',3.333,5),(702,25344,25319,'2e1',3.333,5),(702,25345,25319,'e11',3.333,5),(702,25346,25319,'11f',3.333,5),(702,25347,25319,'1ff',3.333,5),(702,25348,25319,'ffa',3.333,5),(702,25349,25319,'faf',3.333,5),(643,25363,25362,'hgw',9.091,5),(643,25364,25362,'gw2',9.091,5),(643,25365,25362,'w2k',9.091,5),(643,25366,25362,'2k8',9.091,5),(643,25367,25362,'k8r',9.091,5),(643,25368,25362,'8r2',9.091,5),(643,25369,25362,'r23',9.091,5),(643,25370,25362,'232',9.091,5),(643,25371,25362,'32v',9.091,5),(643,25372,25362,'2vm',9.091,5),(643,25373,25362,'vm8',9.091,5),(704,25420,25419,'naa',100,5),(704,25421,25420,'600',3.333,5),(704,25422,25420,'000',3.333,5),(704,25423,25420,'00c',3.333,5),(704,25424,25420,'0c2',3.333,5),(704,25425,25420,'c29',3.333,5),(704,25426,25420,'292',3.333,5),(704,25427,25420,'923',3.333,5),(704,25428,25420,'233',3.333,5),(704,25429,25420,'334',3.333,5),(704,25430,25420,'348',3.333,5),(704,25431,25420,'488',3.333,5),(704,25432,25420,'88e',3.333,5),(704,25433,25420,'8ec',3.333,5),(704,25434,25420,'ecd',3.333,5),(704,25435,25420,'cd7',3.333,5),(704,25436,25420,'d7d',3.333,5),(704,25437,25420,'7db',3.333,5),(704,25438,25420,'db1',3.333,5),(704,25439,25420,'b18',3.333,5),(704,25440,25420,'18a',3.333,5),(704,25441,25420,'8a6',3.333,5),(704,25442,25420,'a64',3.333,5),(704,25443,25420,'641',3.333,5),(704,25444,25420,'41f',3.333,5),(704,25445,25420,'1f4',3.333,5),(704,25446,25420,'f4f',3.333,5),(704,25447,25420,'4f0',3.333,5),(704,25448,25420,'f01',3.333,5),(704,25449,25420,'019',3.333,5),(704,25450,25420,'194',3.333,5),(705,25452,25451,'naa',100,5),(705,25453,25452,'600',3.333,5),(705,25454,25452,'00a',3.333,5),(705,25455,25452,'0a0',3.333,5),(705,25456,25452,'a09',3.333,5),(705,25457,25452,'098',3.333,5),(705,25458,25452,'980',3.333,5),(705,25459,25452,'804',3.333,5),(705,25460,25452,'044',3.333,5),(705,25461,25452,'443',3.333,5),(705,25462,25452,'430',3.333,5),(705,25463,25452,'307',3.333,5),(705,25464,25452,'072',3.333,5),(705,25465,25452,'725',3.333,5),(705,25466,25452,'259',3.333,5),(705,25467,25452,'593',3.333,5),(705,25468,25452,'931',3.333,5),(705,25469,25452,'313',3.333,5),(705,25470,25452,'13f',3.333,5),(705,25471,25452,'3f3',3.333,5),(705,25472,25452,'f33',3.333,5),(705,25473,25452,'334',3.333,5),(705,25474,25452,'345',3.333,5),(705,25475,25452,'455',3.333,5),(705,25476,25452,'556',3.333,5),(705,25477,25452,'563',3.333,5),(705,25478,25452,'639',3.333,5),(705,25479,25452,'393',3.333,5),(705,25480,25452,'934',3.333,5),(705,25481,25452,'344',3.333,5),(705,25482,25452,'44b',3.333,5),(706,25484,25483,'naa',100,5),(706,25485,25484,'600',3.333,5),(706,25486,25484,'00a',3.333,5),(706,25487,25484,'0a0',3.333,5),(706,25488,25484,'a09',3.333,5),(706,25489,25484,'098',3.333,5),(706,25490,25484,'980',3.333,5),(706,25491,25484,'804',3.333,5),(706,25492,25484,'044',3.333,5),(706,25493,25484,'443',3.333,5),(706,25494,25484,'430',3.333,5),(706,25495,25484,'307',3.333,5),(706,25496,25484,'072',3.333,5),(706,25497,25484,'725',3.333,5),(706,25498,25484,'259',3.333,5),(706,25499,25484,'593',3.333,5),(706,25500,25484,'931',3.333,5),(706,25501,25484,'313',3.333,5),(706,25502,25484,'13f',3.333,5),(706,25503,25484,'3f3',3.333,5),(706,25504,25484,'f33',3.333,5),(706,25505,25484,'334',3.333,5),(706,25506,25484,'345',3.333,5),(706,25507,25484,'455',3.333,5),(706,25508,25484,'556',3.333,5),(706,25509,25484,'563',3.333,5),(706,25510,25484,'639',3.333,5),(706,25511,25484,'393',3.333,5),(706,25512,25484,'934',3.333,5),(706,25513,25484,'344',3.333,5),(706,25514,25484,'44c',3.333,5),(707,25516,25515,'naa',100,5),(707,25517,25516,'600',3.333,5),(707,25518,25516,'00a',3.333,5),(707,25519,25516,'0a0',3.333,5),(707,25520,25516,'a09',3.333,5),(707,25521,25516,'098',3.333,5),(707,25522,25516,'980',3.333,5),(707,25523,25516,'804',3.333,5),(707,25524,25516,'044',3.333,5),(707,25525,25516,'443',3.333,5),(707,25526,25516,'430',3.333,5),(707,25527,25516,'307',3.333,5),(707,25528,25516,'075',3.333,5),(707,25529,25516,'753',3.333,5),(707,25530,25516,'535',3.333,5),(707,25531,25516,'357',3.333,5),(707,25532,25516,'573',3.333,5),(707,25533,25516,'732',3.333,5),(707,25534,25516,'32b',3.333,5),(707,25535,25516,'2b3',3.333,5),(707,25536,25516,'b33',3.333,5),(707,25537,25516,'334',3.333,5),(707,25538,25516,'345',3.333,5),(707,25539,25516,'457',3.333,5),(707,25540,25516,'571',3.333,5),(707,25541,25516,'715',3.333,5),(707,25542,25516,'153',3.333,5),(707,25543,25516,'533',3.333,5),(707,25544,25516,'336',3.333,5),(707,25545,25516,'363',3.333,5),(707,25546,25516,'636',3.333,5),(708,25548,25547,'naa',100,5),(708,25549,25548,'600',3.333,5),(708,25550,25548,'00a',3.333,5),(708,25551,25548,'0a0',3.333,5),(708,25552,25548,'a09',3.333,5),(708,25553,25548,'098',3.333,5),(708,25554,25548,'980',3.333,5),(708,25555,25548,'804',3.333,5),(708,25556,25548,'044',3.333,5),(708,25557,25548,'443',3.333,5),(708,25558,25548,'430',3.333,5),(708,25559,25548,'307',3.333,5),(708,25560,25548,'075',3.333,5),(708,25561,25548,'753',3.333,5),(708,25562,25548,'535',3.333,5),(708,25563,25548,'357',3.333,5),(708,25564,25548,'573',3.333,5),(708,25565,25548,'732',3.333,5),(708,25566,25548,'32b',3.333,5),(708,25567,25548,'2b3',3.333,5),(708,25568,25548,'b33',3.333,5),(708,25569,25548,'334',3.333,5),(708,25570,25548,'345',3.333,5),(708,25571,25548,'457',3.333,5),(708,25572,25548,'571',3.333,5),(708,25573,25548,'715',3.333,5),(708,25574,25548,'153',3.333,5),(708,25575,25548,'533',3.333,5),(708,25576,25548,'336',3.333,5),(708,25577,25548,'363',3.333,5),(708,25578,25548,'637',3.333,5),(709,25580,25579,'naa',100,5),(709,25581,25580,'600',3.333,5),(709,25582,25580,'000',3.333,5),(709,25583,25580,'00c',3.333,5),(709,25584,25580,'0c2',3.333,5),(709,25585,25580,'c29',3.333,5),(709,25586,25580,'29c',3.333,5),(709,25587,25580,'9cd',3.333,5),(709,25588,25580,'cda',3.333,5),(709,25589,25580,'da5',3.333,5),(709,25590,25580,'a5a',3.333,5),(709,25591,25580,'5a7',3.333,5),(709,25592,25580,'a79',3.333,5),(709,25593,25580,'79f',3.333,5),(709,25594,25580,'9fb',3.333,5),(709,25595,25580,'fbb',3.333,5),(709,25596,25580,'bbc',3.333,5),(709,25597,25580,'bc7',3.333,5),(709,25598,25580,'c72',3.333,5),(709,25599,25580,'72d',3.333,5),(709,25600,25580,'2dc',3.333,5),(709,25601,25580,'dca',3.333,5),(709,25602,25580,'cae',3.333,5),(709,25603,25580,'aea',3.333,5),(709,25604,25580,'ea7',3.333,5),(709,25605,25580,'a73',3.333,5),(709,25606,25580,'731',3.333,5),(709,25607,25580,'317',3.333,5),(709,25608,25580,'176',3.333,5),(709,25609,25580,'76c',3.333,5),(709,25610,25580,'6c3',3.333,5),(710,25612,25611,'naa',100,5),(710,25613,25612,'600',3.333,5),(710,25614,25612,'000',3.333,5),(710,25615,25612,'00c',3.333,5),(710,25616,25612,'0c2',3.333,5),(710,25617,25612,'c29',3.333,5),(710,25618,25612,'294',3.333,5),(710,25619,25612,'944',3.333,5),(710,25620,25612,'44a',3.333,5),(710,25621,25612,'4a6',3.333,5),(710,25622,25612,'a65',3.333,5),(710,25623,25612,'65a',3.333,5),(710,25624,25612,'5ad',3.333,5),(710,25625,25612,'ade',3.333,5),(710,25626,25612,'def',3.333,5),(710,25627,25612,'ef7',3.333,5),(710,25628,25612,'f76',3.333,5),(710,25629,25612,'760',3.333,5),(710,25630,25612,'604',3.333,5),(710,25631,25612,'043',3.333,5),(710,25632,25612,'43c',3.333,5),(710,25633,25612,'3c4',3.333,5),(710,25634,25612,'c47',3.333,5),(710,25635,25612,'47c',3.333,5),(710,25636,25612,'7c6',3.333,5),(710,25637,25612,'c69',3.333,5),(710,25638,25612,'699',3.333,5),(710,25639,25612,'994',3.333,5),(710,25640,25612,'941',3.333,5),(710,25641,25612,'41f',3.333,5),(710,25642,25612,'1f7',3.333,5),(711,25644,25643,'naa',100,5),(711,25645,25644,'600',3.333,5),(711,25646,25644,'000',3.333,5),(711,25647,25644,'00c',3.333,5),(711,25648,25644,'0c2',3.333,5),(711,25649,25644,'c29',3.333,5),(711,25650,25644,'296',3.333,5),(711,25651,25644,'969',3.333,5),(711,25652,25644,'696',3.333,5),(711,25653,25644,'962',3.333,5),(711,25654,25644,'621',3.333,5),(711,25655,25644,'219',3.333,5),(711,25656,25644,'195',3.333,5),(711,25657,25644,'95a',3.333,5),(711,25658,25644,'5a7',3.333,5),(711,25659,25644,'a7d',3.333,5),(711,25660,25644,'7df',3.333,5),(711,25661,25644,'dfd',3.333,5),(711,25662,25644,'fd0',3.333,5),(711,25663,25644,'d0b',3.333,5),(711,25664,25644,'0b5',3.333,5),(711,25665,25644,'b53',3.333,5),(711,25666,25644,'53d',3.333,5),(711,25667,25644,'3df',3.333,5),(711,25668,25644,'dfd',3.333,5),(711,25669,25644,'fd3',3.333,5),(711,25670,25644,'d31',3.333,5),(711,25671,25644,'31e',3.333,5),(711,25672,25644,'1e8',3.333,5),(711,25673,25644,'e80',3.333,5),(711,25674,25644,'805',3.333,5),(712,25676,25675,'naa',100,5),(712,25677,25676,'600',3.333,5),(712,25678,25676,'000',3.333,5),(712,25679,25676,'00c',3.333,5),(712,25680,25676,'0c2',3.333,5),(712,25681,25676,'c29',3.333,5),(712,25682,25676,'290',3.333,5),(712,25683,25676,'908',3.333,5),(712,25684,25676,'08f',3.333,5),(712,25685,25676,'8f6',3.333,5),(712,25686,25676,'f67',3.333,5),(712,25687,25676,'674',3.333,5),(712,25688,25676,'746',3.333,5),(712,25689,25676,'46f',3.333,5),(712,25690,25676,'6fa',3.333,5),(712,25691,25676,'fa8',3.333,5),(712,25692,25676,'a81',3.333,5),(712,25693,25676,'81a',3.333,5),(712,25694,25676,'1a2',3.333,5),(712,25695,25676,'a29',3.333,5),(712,25696,25676,'291',3.333,5),(712,25697,25676,'91e',3.333,5),(712,25698,25676,'1e3',3.333,5),(712,25699,25676,'e3d',3.333,5),(712,25700,25676,'3d8',3.333,5),(712,25701,25676,'d84',3.333,5),(712,25702,25676,'844',3.333,5),(712,25703,25676,'44d',3.333,5),(712,25704,25676,'4dc',3.333,5),(712,25705,25676,'dc6',3.333,5),(712,25706,25676,'c68',3.333,5),(713,25708,25707,'naa',100,5),(713,25709,25708,'600',3.333,5),(713,25710,25708,'000',3.333,5),(713,25711,25708,'00c',3.333,5),(713,25712,25708,'0c2',3.333,5),(713,25713,25708,'c29',3.333,5),(713,25714,25708,'29d',3.333,5),(713,25715,25708,'9da',3.333,5),(713,25716,25708,'da8',3.333,5),(713,25717,25708,'a85',3.333,5),(713,25718,25708,'85a',3.333,5),(713,25719,25708,'5a9',3.333,5),(713,25720,25708,'a95',3.333,5),(713,25721,25708,'952',3.333,5),(713,25722,25708,'52a',3.333,5),(713,25723,25708,'2ac',3.333,5),(713,25724,25708,'ac8',3.333,5),(713,25725,25708,'c89',3.333,5),(713,25726,25708,'89e',3.333,5),(713,25727,25708,'9ec',3.333,5),(713,25728,25708,'ecf',3.333,5),(713,25729,25708,'cf1',3.333,5),(713,25730,25708,'f11',3.333,5),(713,25731,25708,'112',3.333,5),(713,25732,25708,'129',3.333,5),(713,25733,25708,'290',3.333,5),(713,25734,25708,'90e',3.333,5),(713,25735,25708,'0e1',3.333,5),(713,25736,25708,'e1d',3.333,5),(713,25737,25708,'1dd',3.333,5),(713,25738,25708,'dde',3.333,5),(714,25740,25739,'naa',100,5),(714,25741,25740,'600',3.333,5),(714,25742,25740,'000',3.333,5),(714,25743,25740,'00c',3.333,5),(714,25744,25740,'0c2',3.333,5),(714,25745,25740,'c29',3.333,5),(714,25746,25740,'299',3.333,5),(714,25747,25740,'999',3.333,5),(714,25748,25740,'99a',3.333,5),(714,25749,25740,'9a4',3.333,5),(714,25750,25740,'a42',3.333,5),(714,25751,25740,'42c',3.333,5),(714,25752,25740,'2c6',3.333,5),(714,25753,25740,'c65',3.333,5),(714,25754,25740,'659',3.333,5),(714,25755,25740,'59a',3.333,5),(714,25756,25740,'9a4',3.333,5),(714,25757,25740,'a4f',3.333,5),(714,25758,25740,'4fe',3.333,5),(714,25759,25740,'fee',3.333,5),(714,25760,25740,'ee5',3.333,5),(714,25761,25740,'e57',3.333,5),(714,25762,25740,'57e',3.333,5),(714,25763,25740,'7ef',3.333,5),(714,25764,25740,'eff',3.333,5),(714,25765,25740,'ff5',3.333,5),(714,25766,25740,'f5c',3.333,5),(714,25767,25740,'5c0',3.333,5),(714,25768,25740,'c09',3.333,5),(714,25769,25740,'096',3.333,5),(714,25770,25740,'967',3.333,5),(715,25772,25771,'naa',100,5),(715,25773,25772,'600',3.333,5),(715,25774,25772,'000',3.333,5),(715,25775,25772,'00c',3.333,5),(715,25776,25772,'0c2',3.333,5),(715,25777,25772,'c29',3.333,5),(715,25778,25772,'293',3.333,5),(715,25779,25772,'939',3.333,5),(715,25780,25772,'39d',3.333,5),(715,25781,25772,'9dc',3.333,5),(715,25782,25772,'dc7',3.333,5),(715,25783,25772,'c73',3.333,5),(715,25784,25772,'736',3.333,5),(715,25785,25772,'363',3.333,5),(715,25786,25772,'633',3.333,5),(715,25787,25772,'33c',3.333,5),(715,25788,25772,'3c5',3.333,5),(715,25789,25772,'c5a',3.333,5),(715,25790,25772,'5a8',3.333,5),(715,25791,25772,'a88',3.333,5),(715,25792,25772,'882',3.333,5),(715,25793,25772,'824',3.333,5),(715,25794,25772,'24c',3.333,5),(715,25795,25772,'4c5',3.333,5),(715,25796,25772,'c53',3.333,5),(715,25797,25772,'53e',3.333,5),(715,25798,25772,'3e8',3.333,5),(715,25799,25772,'e82',3.333,5),(715,25800,25772,'82c',3.333,5),(715,25801,25772,'2c1',3.333,5),(715,25802,25772,'c1f',3.333,5),(716,25804,25803,'naa',100,5),(716,25805,25804,'600',3.333,5),(716,25806,25804,'000',3.333,5),(716,25807,25804,'00c',3.333,5),(716,25808,25804,'0c2',3.333,5),(716,25809,25804,'c29',3.333,5),(716,25810,25804,'299',3.333,5),(716,25811,25804,'991',3.333,5),(716,25812,25804,'914',3.333,5),(716,25813,25804,'14a',3.333,5),(716,25814,25804,'4a2',3.333,5),(716,25815,25804,'a2b',3.333,5),(716,25816,25804,'2b4',3.333,5),(716,25817,25804,'b49',3.333,5),(716,25818,25804,'49d',3.333,5),(716,25819,25804,'9d0',3.333,5),(716,25820,25804,'d0a',3.333,5),(716,25821,25804,'0a9',3.333,5),(716,25822,25804,'a91',3.333,5),(716,25823,25804,'918',3.333,5),(716,25824,25804,'187',3.333,5),(716,25825,25804,'872',3.333,5),(716,25826,25804,'72f',3.333,5),(716,25827,25804,'2f3',3.333,5),(716,25828,25804,'f34',3.333,5),(716,25829,25804,'341',3.333,5),(716,25830,25804,'41a',3.333,5),(716,25831,25804,'1ac',3.333,5),(716,25832,25804,'ac2',3.333,5),(716,25833,25804,'c23',3.333,5),(716,25834,25804,'237',3.333,5),(717,25836,25835,'naa',100,5),(717,25837,25836,'600',3.333,5),(717,25838,25836,'000',3.333,5),(717,25839,25836,'00c',3.333,5),(717,25840,25836,'0c2',3.333,5),(717,25841,25836,'c29',3.333,5),(717,25842,25836,'292',3.333,5),(717,25843,25836,'922',3.333,5),(717,25844,25836,'228',3.333,5),(717,25845,25836,'281',3.333,5),(717,25846,25836,'811',3.333,5),(717,25847,25836,'11b',3.333,5),(717,25848,25836,'1b5',3.333,5),(717,25849,25836,'b56',3.333,5),(717,25850,25836,'569',3.333,5),(717,25851,25836,'694',3.333,5),(717,25852,25836,'94f',3.333,5),(717,25853,25836,'4f1',3.333,5),(717,25854,25836,'f19',3.333,5),(717,25855,25836,'190',3.333,5),(717,25856,25836,'90b',3.333,5),(717,25857,25836,'0be',3.333,5),(717,25858,25836,'be4',3.333,5),(717,25859,25836,'e49',3.333,5),(717,25860,25836,'490',3.333,5),(717,25861,25836,'90d',3.333,5),(717,25862,25836,'0da',3.333,5),(717,25863,25836,'da4',3.333,5),(717,25864,25836,'a4a',3.333,5),(717,25865,25836,'4a9',3.333,5),(717,25866,25836,'a93',3.333,5),(718,25868,25867,'naa',100,5),(718,25869,25868,'600',3.333,5),(718,25870,25868,'000',3.333,5),(718,25871,25868,'00c',3.333,5),(718,25872,25868,'0c2',3.333,5),(718,25873,25868,'c29',3.333,5),(718,25874,25868,'297',3.333,5),(718,25875,25868,'972',3.333,5),(718,25876,25868,'721',3.333,5),(718,25877,25868,'21c',3.333,5),(718,25878,25868,'1c1',3.333,5),(718,25879,25868,'c1d',3.333,5),(718,25880,25868,'1dc',3.333,5),(718,25881,25868,'dc1',3.333,5),(718,25882,25868,'c12',3.333,5),(718,25883,25868,'120',3.333,5),(718,25884,25868,'201',3.333,5),(718,25885,25868,'018',3.333,5),(718,25886,25868,'18d',3.333,5),(718,25887,25868,'8db',3.333,5),(718,25888,25868,'db7',3.333,5),(718,25889,25868,'b73',3.333,5),(718,25890,25868,'733',3.333,5),(718,25891,25868,'334',3.333,5),(718,25892,25868,'34e',3.333,5),(718,25893,25868,'4e2',3.333,5),(718,25894,25868,'e29',3.333,5),(718,25895,25868,'293',3.333,5),(718,25896,25868,'93b',3.333,5),(718,25897,25868,'3b4',3.333,5),(718,25898,25868,'b4b',3.333,5),(719,25900,25899,'naa',100,5),(719,25901,25900,'600',3.333,5),(719,25902,25900,'000',3.333,5),(719,25903,25900,'00c',3.333,5),(719,25904,25900,'0c2',3.333,5),(719,25905,25900,'c29',3.333,5),(719,25906,25900,'29f',3.333,5),(719,25907,25900,'9f0',3.333,5),(719,25908,25900,'f0e',3.333,5),(719,25909,25900,'0ee',3.333,5),(719,25910,25900,'eed',3.333,5),(719,25911,25900,'ed3',3.333,5),(719,25912,25900,'d3e',3.333,5),(719,25913,25900,'3ee',3.333,5),(719,25914,25900,'ee7',3.333,5),(719,25915,25900,'e74',3.333,5),(719,25916,25900,'74a',3.333,5),(719,25917,25900,'4ab',3.333,5),(719,25918,25900,'ab8',3.333,5),(719,25919,25900,'b8c',3.333,5),(719,25920,25900,'8c2',3.333,5),(719,25921,25900,'c28',3.333,5),(719,25922,25900,'28b',3.333,5),(719,25923,25900,'8b0',3.333,5),(719,25924,25900,'b06',3.333,5),(719,25925,25900,'06e',3.333,5),(719,25926,25900,'6e7',3.333,5),(719,25927,25900,'e75',3.333,5),(719,25928,25900,'75d',3.333,5),(719,25929,25900,'5d6',3.333,5),(719,25930,25900,'d62',3.333,5),(720,25932,25931,'naa',100,5),(720,25933,25932,'600',3.333,5),(720,25934,25932,'000',3.333,5),(720,25935,25932,'00c',3.333,5),(720,25936,25932,'0c2',3.333,5),(720,25937,25932,'c29',3.333,5),(720,25938,25932,'295',3.333,5),(720,25939,25932,'957',3.333,5),(720,25940,25932,'573',3.333,5),(720,25941,25932,'731',3.333,5),(720,25942,25932,'313',3.333,5),(720,25943,25932,'133',3.333,5),(720,25944,25932,'33f',3.333,5),(720,25945,25932,'3fc',3.333,5),(720,25946,25932,'fc5',3.333,5),(720,25947,25932,'c59',3.333,5),(720,25948,25932,'593',3.333,5),(720,25949,25932,'938',3.333,5),(720,25950,25932,'384',3.333,5),(720,25951,25932,'843',3.333,5),(720,25952,25932,'43b',3.333,5),(720,25953,25932,'3b9',3.333,5),(720,25954,25932,'b9b',3.333,5),(720,25955,25932,'9b8',3.333,5),(720,25956,25932,'b8e',3.333,5),(720,25957,25932,'8ed',3.333,5),(720,25958,25932,'ed7',3.333,5),(720,25959,25932,'d7d',3.333,5),(720,25960,25932,'7d1',3.333,5),(720,25961,25932,'d15',3.333,5),(720,25962,25932,'15b',3.333,5),(721,25964,25963,'naa',100,5),(721,25965,25964,'600',3.333,5),(721,25966,25964,'000',3.333,5),(721,25967,25964,'00c',3.333,5),(721,25968,25964,'0c2',3.333,5),(721,25969,25964,'c29',3.333,5),(721,25970,25964,'296',3.333,5),(721,25971,25964,'96d',3.333,5),(721,25972,25964,'6d9',3.333,5),(721,25973,25964,'d90',3.333,5),(721,25974,25964,'901',3.333,5),(721,25975,25964,'01f',3.333,5),(721,25976,25964,'1f7',3.333,5),(721,25977,25964,'f7d',3.333,5),(721,25978,25964,'7d5',3.333,5),(721,25979,25964,'d51',3.333,5),(721,25980,25964,'51f',3.333,5),(721,25981,25964,'1fb',3.333,5),(721,25982,25964,'fb4',3.333,5),(721,25983,25964,'b45',3.333,5),(721,25984,25964,'457',3.333,5),(721,25985,25964,'57e',3.333,5),(721,25986,25964,'7e7',3.333,5),(721,25987,25964,'e70',3.333,5),(721,25988,25964,'704',3.333,5),(721,25989,25964,'041',3.333,5),(721,25990,25964,'41f',3.333,5),(721,25991,25964,'1f2',3.333,5),(721,25992,25964,'f2f',3.333,5),(721,25993,25964,'2ff',3.333,5),(721,25994,25964,'ff0',3.333,5),(722,25996,25995,'naa',100,5),(722,25997,25996,'600',3.333,5),(722,25998,25996,'000',3.333,5),(722,25999,25996,'00c',3.333,5),(722,26000,25996,'0c2',3.333,5),(722,26001,25996,'c29',3.333,5),(722,26002,25996,'29e',3.333,5),(722,26003,25996,'9ea',3.333,5),(722,26004,25996,'ea4',3.333,5),(722,26005,25996,'a41',3.333,5),(722,26006,25996,'41a',3.333,5),(722,26007,25996,'1a1',3.333,5),(722,26008,25996,'a1e',3.333,5),(722,26009,25996,'1e3',3.333,5),(722,26010,25996,'e31',3.333,5),(722,26011,25996,'311',3.333,5),(722,26012,25996,'112',3.333,5),(722,26013,25996,'12d',3.333,5),(722,26014,25996,'2d7',3.333,5),(722,26015,25996,'d78',3.333,5),(722,26016,25996,'78a',3.333,5),(722,26017,25996,'8af',3.333,5),(722,26018,25996,'af3',3.333,5),(722,26019,25996,'f33',3.333,5),(722,26020,25996,'33e',3.333,5),(722,26021,25996,'3e4',3.333,5),(722,26022,25996,'e44',3.333,5),(722,26023,25996,'447',3.333,5),(722,26024,25996,'47f',3.333,5),(722,26025,25996,'7f7',3.333,5),(722,26026,25996,'f71',3.333,5),(723,26028,26027,'naa',100,5),(723,26029,26028,'600',3.333,5),(723,26030,26028,'000',3.333,5),(723,26031,26028,'00c',3.333,5),(723,26032,26028,'0c2',3.333,5),(723,26033,26028,'c29',3.333,5),(723,26034,26028,'292',3.333,5),(723,26035,26028,'926',3.333,5),(723,26036,26028,'269',3.333,5),(723,26037,26028,'69e',3.333,5),(723,26038,26028,'9ea',3.333,5),(723,26039,26028,'ea8',3.333,5),(723,26040,26028,'a82',3.333,5),(723,26041,26028,'82c',3.333,5),(723,26042,26028,'2ce',3.333,5),(723,26043,26028,'ce8',3.333,5),(723,26044,26028,'e84',3.333,5),(723,26045,26028,'84d',3.333,5),(723,26046,26028,'4df',3.333,5),(723,26047,26028,'df2',3.333,5),(723,26048,26028,'f2f',3.333,5),(723,26049,26028,'2f7',3.333,5),(723,26050,26028,'f7d',3.333,5),(723,26051,26028,'7de',3.333,5),(723,26052,26028,'dec',3.333,5),(723,26053,26028,'ec2',3.333,5),(723,26054,26028,'c29',3.333,5),(723,26055,26028,'293',3.333,5),(723,26056,26028,'939',3.333,5),(723,26057,26028,'398',3.333,5),(723,26058,26028,'987',3.333,5),(724,26060,26059,'naa',100,5),(724,26061,26060,'600',3.333,5),(724,26062,26060,'000',3.333,5),(724,26063,26060,'00c',3.333,5),(724,26064,26060,'0c2',3.333,5),(724,26065,26060,'c29',3.333,5),(724,26066,26060,'29f',3.333,5),(724,26067,26060,'9fa',3.333,5),(724,26068,26060,'fa7',3.333,5),(724,26069,26060,'a71',3.333,5),(724,26070,26060,'718',3.333,5),(724,26071,26060,'18e',3.333,5),(724,26072,26060,'8ee',3.333,5),(724,26073,26060,'ee7',3.333,5),(724,26074,26060,'e7a',3.333,5),(724,26075,26060,'7a1',3.333,5),(724,26076,26060,'a1b',3.333,5),(724,26077,26060,'1b6',3.333,5),(724,26078,26060,'b61',3.333,5),(724,26079,26060,'618',3.333,5),(724,26080,26060,'182',3.333,5),(724,26081,26060,'82b',3.333,5),(724,26082,26060,'2b8',3.333,5),(724,26083,26060,'b8b',3.333,5),(724,26084,26060,'8b7',3.333,5),(724,26085,26060,'b73',3.333,5),(724,26086,26060,'732',3.333,5),(724,26087,26060,'32d',3.333,5),(724,26088,26060,'2dc',3.333,5),(724,26089,26060,'dca',3.333,5),(724,26090,26060,'ca1',3.333,5),(725,26092,26091,'naa',100,5),(725,26093,26092,'600',3.333,5),(725,26094,26092,'000',3.333,5),(725,26095,26092,'00c',3.333,5),(725,26096,26092,'0c2',3.333,5),(725,26097,26092,'c29',3.333,5),(725,26098,26092,'297',3.333,5),(725,26099,26092,'978',3.333,5),(725,26100,26092,'78f',3.333,5),(725,26101,26092,'8f3',3.333,5),(725,26102,26092,'f3a',3.333,5),(725,26103,26092,'3a8',3.333,5),(725,26104,26092,'a8c',3.333,5),(725,26105,26092,'8cb',3.333,5),(725,26106,26092,'cb7',3.333,5),(725,26107,26092,'b75',3.333,5),(725,26108,26092,'758',3.333,5),(725,26109,26092,'587',3.333,5),(725,26110,26092,'874',3.333,5),(725,26111,26092,'742',3.333,5),(725,26112,26092,'429',3.333,5),(725,26113,26092,'299',3.333,5),(725,26114,26092,'990',3.333,5),(725,26115,26092,'907',3.333,5),(725,26116,26092,'072',3.333,5),(725,26117,26092,'723',3.333,5),(725,26118,26092,'235',3.333,5),(725,26119,26092,'354',3.333,5),(725,26120,26092,'54b',3.333,5),(725,26121,26092,'4b5',3.333,5),(725,26122,26092,'b5c',3.333,5),(726,26124,26123,'naa',100,5),(726,26125,26124,'600',3.333,5),(726,26126,26124,'000',3.333,5),(726,26127,26124,'00c',3.333,5),(726,26128,26124,'0c2',3.333,5),(726,26129,26124,'c29',3.333,5),(726,26130,26124,'29e',3.333,5),(726,26131,26124,'9e3',3.333,5),(726,26132,26124,'e37',3.333,5),(726,26133,26124,'376',3.333,5),(726,26134,26124,'768',3.333,5),(726,26135,26124,'680',3.333,5),(726,26136,26124,'80f',3.333,5),(726,26137,26124,'0f4',3.333,5),(726,26138,26124,'f4a',3.333,5),(726,26139,26124,'4ab',3.333,5),(726,26140,26124,'ab9',3.333,5),(726,26141,26124,'b96',3.333,5),(726,26142,26124,'96d',3.333,5),(726,26143,26124,'6d3',3.333,5),(726,26144,26124,'d31',3.333,5),(726,26145,26124,'31b',3.333,5),(726,26146,26124,'1b0',3.333,5),(726,26147,26124,'b09',3.333,5),(726,26148,26124,'09a',3.333,5),(726,26149,26124,'9ae',3.333,5),(726,26150,26124,'ae7',3.333,5),(726,26151,26124,'e74',3.333,5),(726,26152,26124,'749',3.333,5),(726,26153,26124,'494',3.333,5),(726,26154,26124,'943',3.333,5),(727,26156,26155,'naa',100,5),(727,26157,26156,'600',3.333,5),(727,26158,26156,'000',3.333,5),(727,26159,26156,'00c',3.333,5),(727,26160,26156,'0c2',3.333,5),(727,26161,26156,'c29',3.333,5),(727,26162,26156,'298',3.333,5),(727,26163,26156,'98e',3.333,5),(727,26164,26156,'8ed',3.333,5),(727,26165,26156,'edc',3.333,5),(727,26166,26156,'dcf',3.333,5),(727,26167,26156,'cff',3.333,5),(727,26168,26156,'ffb',3.333,5),(727,26169,26156,'fb0',3.333,5),(727,26170,26156,'b01',3.333,5),(727,26171,26156,'01c',3.333,5),(727,26172,26156,'1c9',3.333,5),(727,26173,26156,'c9d',3.333,5),(727,26174,26156,'9dd',3.333,5),(727,26175,26156,'dda',3.333,5),(727,26176,26156,'da0',3.333,5),(727,26177,26156,'a05',3.333,5),(727,26178,26156,'058',3.333,5),(727,26179,26156,'581',3.333,5),(727,26180,26156,'818',3.333,5),(727,26181,26156,'18c',3.333,5),(727,26182,26156,'8cc',3.333,5),(727,26183,26156,'cc7',3.333,5),(727,26184,26156,'c73',3.333,5),(727,26185,26156,'73b',3.333,5),(727,26186,26156,'3b2',3.333,5),(728,26188,26187,'naa',100,5),(728,26189,26188,'600',3.333,5),(728,26190,26188,'000',3.333,5),(728,26191,26188,'00c',3.333,5),(728,26192,26188,'0c2',3.333,5),(728,26193,26188,'c29',3.333,5),(728,26194,26188,'29f',3.333,5),(728,26195,26188,'9f5',3.333,5),(728,26196,26188,'f5f',3.333,5),(728,26197,26188,'5f2',3.333,5),(728,26198,26188,'f27',3.333,5),(728,26199,26188,'27e',3.333,5),(728,26200,26188,'7ed',3.333,5),(728,26201,26188,'ed5',3.333,5),(728,26202,26188,'d5e',3.333,5),(728,26203,26188,'5e3',3.333,5),(728,26204,26188,'e31',3.333,5),(728,26205,26188,'316',3.333,5),(728,26206,26188,'164',3.333,5),(728,26207,26188,'645',3.333,5),(728,26208,26188,'45e',3.333,5),(728,26209,26188,'5e4',3.333,5),(728,26210,26188,'e45',3.333,5),(728,26211,26188,'458',3.333,5),(728,26212,26188,'58e',3.333,5),(728,26213,26188,'8e6',3.333,5),(728,26214,26188,'e61',3.333,5),(728,26215,26188,'610',3.333,5),(728,26216,26188,'102',3.333,5),(728,26217,26188,'027',3.333,5),(728,26218,26188,'275',3.333,5),(729,26220,26219,'naa',100,5),(729,26221,26220,'600',3.333,5),(729,26222,26220,'000',3.333,5),(729,26223,26220,'00c',3.333,5),(729,26224,26220,'0c2',3.333,5),(729,26225,26220,'c29',3.333,5),(729,26226,26220,'294',3.333,5),(729,26227,26220,'948',3.333,5),(729,26228,26220,'482',3.333,5),(729,26229,26220,'82b',3.333,5),(729,26230,26220,'2bd',3.333,5),(729,26231,26220,'bde',3.333,5),(729,26232,26220,'ded',3.333,5),(729,26233,26220,'edd',3.333,5),(729,26234,26220,'ddf',3.333,5),(729,26235,26220,'dfc',3.333,5),(729,26236,26220,'fc5',3.333,5),(729,26237,26220,'c52',3.333,5),(729,26238,26220,'521',3.333,5),(729,26239,26220,'216',3.333,5),(729,26240,26220,'16c',3.333,5),(729,26241,26220,'6c1',3.333,5),(729,26242,26220,'c1b',3.333,5),(729,26243,26220,'1b5',3.333,5),(729,26244,26220,'b55',3.333,5),(729,26245,26220,'554',3.333,5),(729,26246,26220,'54d',3.333,5),(729,26247,26220,'4db',3.333,5),(729,26248,26220,'db3',3.333,5),(729,26249,26220,'b37',3.333,5),(729,26250,26220,'37a',3.333,5),(730,26252,26251,'naa',100,5),(730,26253,26252,'600',3.333,5),(730,26254,26252,'000',3.333,5),(730,26255,26252,'00c',3.333,5),(730,26256,26252,'0c2',3.333,5),(730,26257,26252,'c29',3.333,5),(730,26258,26252,'295',3.333,5),(730,26259,26252,'951',3.333,5),(730,26260,26252,'515',3.333,5),(730,26261,26252,'153',3.333,5),(730,26262,26252,'53f',3.333,5),(730,26263,26252,'3f5',3.333,5),(730,26264,26252,'f52',3.333,5),(730,26265,26252,'529',3.333,5),(730,26266,26252,'29a',3.333,5),(730,26267,26252,'9a6',3.333,5),(730,26268,26252,'a61',3.333,5),(730,26269,26252,'613',3.333,5),(730,26270,26252,'135',3.333,5),(730,26271,26252,'35f',3.333,5),(730,26272,26252,'5fc',3.333,5),(730,26273,26252,'fc6',3.333,5),(730,26274,26252,'c6d',3.333,5),(730,26275,26252,'6de',3.333,5),(730,26276,26252,'de0',3.333,5),(730,26277,26252,'e04',3.333,5),(730,26278,26252,'044',3.333,5),(730,26279,26252,'446',3.333,5),(730,26280,26252,'46b',3.333,5),(730,26281,26252,'6ba',3.333,5),(730,26282,26252,'bae',3.333,5),(731,26284,26283,'naa',100,5),(731,26285,26284,'600',3.333,5),(731,26286,26284,'000',3.333,5),(731,26287,26284,'00c',3.333,5),(731,26288,26284,'0c2',3.333,5),(731,26289,26284,'c29',3.333,5),(731,26290,26284,'293',3.333,5),(731,26291,26284,'931',3.333,5),(731,26292,26284,'31b',3.333,5),(731,26293,26284,'1b5',3.333,5),(731,26294,26284,'b54',3.333,5),(731,26295,26284,'541',3.333,5),(731,26296,26284,'414',3.333,5),(731,26297,26284,'148',3.333,5),(731,26298,26284,'483',3.333,5),(731,26299,26284,'83d',3.333,5),(731,26300,26284,'3d3',3.333,5),(731,26301,26284,'d3f',3.333,5),(731,26302,26284,'3f0',3.333,5),(731,26303,26284,'f05',3.333,5),(731,26304,26284,'05b',3.333,5),(731,26305,26284,'5b9',3.333,5),(731,26306,26284,'b95',3.333,5),(731,26307,26284,'955',3.333,5),(731,26308,26284,'55e',3.333,5),(731,26309,26284,'5ed',3.333,5),(731,26310,26284,'ed0',3.333,5),(731,26311,26284,'d0b',3.333,5),(731,26312,26284,'0ba',3.333,5),(731,26313,26284,'baa',3.333,5),(731,26314,26284,'aaf',3.333,5),(732,26316,26315,'naa',100,5),(732,26317,26316,'600',3.333,5),(732,26318,26316,'000',3.333,5),(732,26319,26316,'00c',3.333,5),(732,26320,26316,'0c2',3.333,5),(732,26321,26316,'c29',3.333,5),(732,26322,26316,'29d',3.333,5),(732,26323,26316,'9d7',3.333,5),(732,26324,26316,'d71',3.333,5),(732,26325,26316,'712',3.333,5),(732,26326,26316,'12f',3.333,5),(732,26327,26316,'2fa',3.333,5),(732,26328,26316,'fae',3.333,5),(732,26329,26316,'ae5',3.333,5),(732,26330,26316,'e50',3.333,5),(732,26331,26316,'504',3.333,5),(732,26332,26316,'04c',3.333,5),(732,26333,26316,'4cd',3.333,5),(732,26334,26316,'cd1',3.333,5),(732,26335,26316,'d10',3.333,5),(732,26336,26316,'10e',3.333,5),(732,26337,26316,'0e0',3.333,5),(732,26338,26316,'e02',3.333,5),(732,26339,26316,'02c',3.333,5),(732,26340,26316,'2ca',3.333,5),(732,26341,26316,'ca6',3.333,5),(732,26342,26316,'a68',3.333,5),(732,26343,26316,'68a',3.333,5),(732,26344,26316,'8ae',3.333,5),(732,26345,26316,'aec',3.333,5),(732,26346,26316,'ecc',3.333,5),(733,26348,26347,'naa',100,5),(733,26349,26348,'600',3.333,5),(733,26350,26348,'000',3.333,5),(733,26351,26348,'00c',3.333,5),(733,26352,26348,'0c2',3.333,5),(733,26353,26348,'c29',3.333,5),(733,26354,26348,'29f',3.333,5),(733,26355,26348,'9f3',3.333,5),(733,26356,26348,'f30',3.333,5),(733,26357,26348,'30c',3.333,5),(733,26358,26348,'0c0',3.333,5),(733,26359,26348,'c0b',3.333,5),(733,26360,26348,'0bc',3.333,5),(733,26361,26348,'bce',3.333,5),(733,26362,26348,'ce2',3.333,5),(733,26363,26348,'e25',3.333,5),(733,26364,26348,'254',3.333,5),(733,26365,26348,'54f',3.333,5),(733,26366,26348,'4f2',3.333,5),(733,26367,26348,'f21',3.333,5),(733,26368,26348,'21f',3.333,5),(733,26369,26348,'1f8',3.333,5),(733,26370,26348,'f8f',3.333,5),(733,26371,26348,'8fa',3.333,5),(733,26372,26348,'fa5',3.333,5),(733,26373,26348,'a53',3.333,5),(733,26374,26348,'53e',3.333,5),(733,26375,26348,'3e8',3.333,5),(733,26376,26348,'e80',3.333,5),(733,26377,26348,'808',3.333,5),(733,26378,26348,'083',3.333,5),(734,26380,26379,'naa',100,5),(734,26381,26380,'600',3.333,5),(734,26382,26380,'000',3.333,5),(734,26383,26380,'00c',3.333,5),(734,26384,26380,'0c2',3.333,5),(734,26385,26380,'c29',3.333,5),(734,26386,26380,'298',3.333,5),(734,26387,26380,'98f',3.333,5),(734,26388,26380,'8f3',3.333,5),(734,26389,26380,'f3e',3.333,5),(734,26390,26380,'3ee',3.333,5),(734,26391,26380,'ee1',3.333,5),(734,26392,26380,'e19',3.333,5),(734,26393,26380,'198',3.333,5),(734,26394,26380,'989',3.333,5),(734,26395,26380,'893',3.333,5),(734,26396,26380,'932',3.333,5),(734,26397,26380,'32e',3.333,5),(734,26398,26380,'2eb',3.333,5),(734,26399,26380,'eb1',3.333,5),(734,26400,26380,'b16',3.333,5),(734,26401,26380,'164',3.333,5),(734,26402,26380,'649',3.333,5),(734,26403,26380,'496',3.333,5),(734,26404,26380,'96a',3.333,5),(734,26405,26380,'6aa',3.333,5),(734,26406,26380,'aa5',3.333,5),(734,26407,26380,'a5d',3.333,5),(734,26408,26380,'5d3',3.333,5),(734,26409,26380,'d34',3.333,5),(734,26410,26380,'345',3.333,5),(735,26412,26411,'naa',100,5),(735,26413,26412,'600',3.333,5),(735,26414,26412,'000',3.333,5),(735,26415,26412,'00c',3.333,5),(735,26416,26412,'0c2',3.333,5),(735,26417,26412,'c29',3.333,5),(735,26418,26412,'290',3.333,5),(735,26419,26412,'90d',3.333,5),(735,26420,26412,'0d6',3.333,5),(735,26421,26412,'d64',3.333,5),(735,26422,26412,'64d',3.333,5),(735,26423,26412,'4d4',3.333,5),(735,26424,26412,'d4f',3.333,5),(735,26425,26412,'4fc',3.333,5),(735,26426,26412,'fce',3.333,5),(735,26427,26412,'ce9',3.333,5),(735,26428,26412,'e99',3.333,5),(735,26429,26412,'997',3.333,5),(735,26430,26412,'97d',3.333,5),(735,26431,26412,'7d2',3.333,5),(735,26432,26412,'d2a',3.333,5),(735,26433,26412,'2ab',3.333,5),(735,26434,26412,'ab2',3.333,5),(735,26435,26412,'b24',3.333,5),(735,26436,26412,'241',3.333,5),(735,26437,26412,'419',3.333,5),(735,26438,26412,'194',3.333,5),(735,26439,26412,'94d',3.333,5),(735,26440,26412,'4d3',3.333,5),(735,26441,26412,'d3e',3.333,5),(735,26442,26412,'3e8',3.333,5),(736,26444,26443,'naa',100,5),(736,26445,26444,'600',3.333,5),(736,26446,26444,'000',3.333,5),(736,26447,26444,'00c',3.333,5),(736,26448,26444,'0c2',3.333,5),(736,26449,26444,'c29',3.333,5),(736,26450,26444,'294',3.333,5),(736,26451,26444,'949',3.333,5),(736,26452,26444,'49a',3.333,5),(736,26453,26444,'9a8',3.333,5),(736,26454,26444,'a8a',3.333,5),(736,26455,26444,'8a2',3.333,5),(736,26456,26444,'a21',3.333,5),(736,26457,26444,'214',3.333,5),(736,26458,26444,'148',3.333,5),(736,26459,26444,'484',3.333,5),(736,26460,26444,'842',3.333,5),(736,26461,26444,'42b',3.333,5),(736,26462,26444,'2b5',3.333,5),(736,26463,26444,'b5f',3.333,5),(736,26464,26444,'5fd',3.333,5),(736,26465,26444,'fd5',3.333,5),(736,26466,26444,'d54',3.333,5),(736,26467,26444,'54d',3.333,5),(736,26468,26444,'4df',3.333,5),(736,26469,26444,'df8',3.333,5),(736,26470,26444,'f89',3.333,5),(736,26471,26444,'89e',3.333,5),(736,26472,26444,'9ed',3.333,5),(736,26473,26444,'ed4',3.333,5),(736,26474,26444,'d47',3.333,5),(737,26476,26475,'naa',100,5),(737,26477,26476,'600',3.333,5),(737,26478,26476,'000',3.333,5),(737,26479,26476,'00c',3.333,5),(737,26480,26476,'0c2',3.333,5),(737,26481,26476,'c29',3.333,5),(737,26482,26476,'294',3.333,5),(737,26483,26476,'94c',3.333,5),(737,26484,26476,'4c4',3.333,5),(737,26485,26476,'c45',3.333,5),(737,26486,26476,'453',3.333,5),(737,26487,26476,'532',3.333,5),(737,26488,26476,'323',3.333,5),(737,26489,26476,'233',3.333,5),(737,26490,26476,'330',3.333,5),(737,26491,26476,'30d',3.333,5),(737,26492,26476,'0df',3.333,5),(737,26493,26476,'df9',3.333,5),(737,26494,26476,'f93',3.333,5),(737,26495,26476,'933',3.333,5),(737,26496,26476,'335',3.333,5),(737,26497,26476,'35f',3.333,5),(737,26498,26476,'5f1',3.333,5),(737,26499,26476,'f1a',3.333,5),(737,26500,26476,'1ad',3.333,5),(737,26501,26476,'ada',3.333,5),(737,26502,26476,'da2',3.333,5),(737,26503,26476,'a2d',3.333,5),(737,26504,26476,'2dc',3.333,5),(737,26505,26476,'dc3',3.333,5),(737,26506,26476,'c3a',3.333,5),(738,26508,26507,'naa',100,5),(738,26509,26508,'600',3.333,5),(738,26510,26508,'000',3.333,5),(738,26511,26508,'00c',3.333,5),(738,26512,26508,'0c2',3.333,5),(738,26513,26508,'c29',3.333,5),(738,26514,26508,'29a',3.333,5),(738,26515,26508,'9a7',3.333,5),(738,26516,26508,'a77',3.333,5),(738,26517,26508,'77e',3.333,5),(738,26518,26508,'7e9',3.333,5),(738,26519,26508,'e9f',3.333,5),(738,26520,26508,'9fe',3.333,5),(738,26521,26508,'fea',3.333,5),(738,26522,26508,'ea9',3.333,5),(738,26523,26508,'a97',3.333,5),(738,26524,26508,'979',3.333,5),(738,26525,26508,'79e',3.333,5),(738,26526,26508,'9ee',3.333,5),(738,26527,26508,'ee0',3.333,5),(738,26528,26508,'e0e',3.333,5),(738,26529,26508,'0ee',3.333,5),(738,26530,26508,'ee8',3.333,5),(738,26531,26508,'e8e',3.333,5),(738,26532,26508,'8ee',3.333,5),(738,26533,26508,'ee6',3.333,5),(738,26534,26508,'e64',3.333,5),(738,26535,26508,'642',3.333,5),(738,26536,26508,'424',3.333,5),(738,26537,26508,'243',3.333,5),(738,26538,26508,'439',3.333,5),(739,26540,26539,'naa',100,5),(739,26541,26540,'600',3.333,5),(739,26542,26540,'000',3.333,5),(739,26543,26540,'00c',3.333,5),(739,26544,26540,'0c2',3.333,5),(739,26545,26540,'c29',3.333,5),(739,26546,26540,'293',3.333,5),(739,26547,26540,'93c',3.333,5),(739,26548,26540,'3c7',3.333,5),(739,26549,26540,'c7c',3.333,5),(739,26550,26540,'7c1',3.333,5),(739,26551,26540,'c1d',3.333,5),(739,26552,26540,'1d8',3.333,5),(739,26553,26540,'d8b',3.333,5),(739,26554,26540,'8bd',3.333,5),(739,26555,26540,'bd8',3.333,5),(739,26556,26540,'d8a',3.333,5),(739,26557,26540,'8a0',3.333,5),(739,26558,26540,'a00',3.333,5),(739,26559,26540,'001',3.333,5),(739,26560,26540,'017',3.333,5),(739,26561,26540,'17c',3.333,5),(739,26562,26540,'7cd',3.333,5),(739,26563,26540,'cd4',3.333,5),(739,26564,26540,'d40',3.333,5),(739,26565,26540,'402',3.333,5),(739,26566,26540,'023',3.333,5),(739,26567,26540,'233',3.333,5),(739,26568,26540,'333',3.333,5),(739,26569,26540,'337',3.333,5),(739,26570,26540,'371',3.333,5),(740,26572,26571,'naa',100,5),(740,26573,26572,'600',3.333,5),(740,26574,26572,'000',3.333,5),(740,26575,26572,'00c',3.333,5),(740,26576,26572,'0c2',3.333,5),(740,26577,26572,'c29',3.333,5),(740,26578,26572,'29b',3.333,5),(740,26579,26572,'9b3',3.333,5),(740,26580,26572,'b32',3.333,5),(740,26581,26572,'32b',3.333,5),(740,26582,26572,'2b4',3.333,5),(740,26583,26572,'b4b',3.333,5),(740,26584,26572,'4b9',3.333,5),(740,26585,26572,'b94',3.333,5),(740,26586,26572,'94b',3.333,5),(740,26587,26572,'4bb',3.333,5),(740,26588,26572,'bb6',3.333,5),(740,26589,26572,'b61',3.333,5),(740,26590,26572,'61d',3.333,5),(740,26591,26572,'1db',3.333,5),(740,26592,26572,'db4',3.333,5),(740,26593,26572,'b4f',3.333,5),(740,26594,26572,'4f0',3.333,5),(740,26595,26572,'f0f',3.333,5),(740,26596,26572,'0fd',3.333,5),(740,26597,26572,'fd1',3.333,5),(740,26598,26572,'d16',3.333,5),(740,26599,26572,'166',3.333,5),(740,26600,26572,'666',3.333,5),(740,26601,26572,'66c',3.333,5),(740,26602,26572,'6c7',3.333,5),(741,26604,26603,'naa',100,5),(741,26605,26604,'600',3.333,5),(741,26606,26604,'000',3.333,5),(741,26607,26604,'00c',3.333,5),(741,26608,26604,'0c2',3.333,5),(741,26609,26604,'c29',3.333,5),(741,26610,26604,'29d',3.333,5),(741,26611,26604,'9d3',3.333,5),(741,26612,26604,'d31',3.333,5),(741,26613,26604,'31d',3.333,5),(741,26614,26604,'1d7',3.333,5),(741,26615,26604,'d70',3.333,5),(741,26616,26604,'701',3.333,5),(741,26617,26604,'019',3.333,5),(741,26618,26604,'190',3.333,5),(741,26619,26604,'90a',3.333,5),(741,26620,26604,'0a3',3.333,5),(741,26621,26604,'a36',3.333,5),(741,26622,26604,'36e',3.333,5),(741,26623,26604,'6e4',3.333,5),(741,26624,26604,'e41',3.333,5),(741,26625,26604,'419',3.333,5),(741,26626,26604,'192',3.333,5),(741,26627,26604,'924',3.333,5),(741,26628,26604,'24b',3.333,5),(741,26629,26604,'4bc',3.333,5),(741,26630,26604,'bce',3.333,5),(741,26631,26604,'ceb',3.333,5),(741,26632,26604,'ebc',3.333,5),(741,26633,26604,'bc8',3.333,5),(741,26634,26604,'c8f',3.333,5),(742,26636,26635,'naa',100,5),(742,26637,26636,'600',3.333,5),(742,26638,26636,'000',3.333,5),(742,26639,26636,'00c',3.333,5),(742,26640,26636,'0c2',3.333,5),(742,26641,26636,'c29',3.333,5),(742,26642,26636,'295',3.333,5),(742,26643,26636,'95b',3.333,5),(742,26644,26636,'5bd',3.333,5),(742,26645,26636,'bd7',3.333,5),(742,26646,26636,'d71',3.333,5),(742,26647,26636,'71e',3.333,5),(742,26648,26636,'1ea',3.333,5),(742,26649,26636,'ea9',3.333,5),(742,26650,26636,'a93',3.333,5),(742,26651,26636,'930',3.333,5),(742,26652,26636,'302',3.333,5),(742,26653,26636,'024',3.333,5),(742,26654,26636,'240',3.333,5),(742,26655,26636,'404',3.333,5),(742,26656,26636,'042',3.333,5),(742,26657,26636,'422',3.333,5),(742,26658,26636,'223',3.333,5),(742,26659,26636,'23a',3.333,5),(742,26660,26636,'3ae',3.333,5),(742,26661,26636,'ae2',3.333,5),(742,26662,26636,'e29',3.333,5),(742,26663,26636,'299',3.333,5),(742,26664,26636,'99e',3.333,5),(742,26665,26636,'9e5',3.333,5),(742,26666,26636,'e52',3.333,5),(743,26668,26667,'naa',100,5),(743,26669,26668,'600',3.333,5),(743,26670,26668,'000',3.333,5),(743,26671,26668,'00c',3.333,5),(743,26672,26668,'0c2',3.333,5),(743,26673,26668,'c29',3.333,5),(743,26674,26668,'297',3.333,5),(743,26675,26668,'974',3.333,5),(743,26676,26668,'743',3.333,5),(743,26677,26668,'433',3.333,5),(743,26678,26668,'337',3.333,5),(743,26679,26668,'377',3.333,5),(743,26680,26668,'77a',3.333,5),(743,26681,26668,'7ae',3.333,5),(743,26682,26668,'ae4',3.333,5),(743,26683,26668,'e4f',3.333,5),(743,26684,26668,'4f0',3.333,5),(743,26685,26668,'f0c',3.333,5),(743,26686,26668,'0c1',3.333,5),(743,26687,26668,'c10',3.333,5),(743,26688,26668,'103',3.333,5),(743,26689,26668,'03a',3.333,5),(743,26690,26668,'3a1',3.333,5),(743,26691,26668,'a18',3.333,5),(743,26692,26668,'18d',3.333,5),(743,26693,26668,'8da',3.333,5),(743,26694,26668,'da8',3.333,5),(743,26695,26668,'a88',3.333,5),(743,26696,26668,'881',3.333,5),(743,26697,26668,'816',3.333,5),(743,26698,26668,'16e',3.333,5),(744,26700,26699,'naa',100,5),(744,26701,26700,'600',3.333,5),(744,26702,26700,'000',3.333,5),(744,26703,26700,'00c',3.333,5),(744,26704,26700,'0c2',3.333,5),(744,26705,26700,'c29',3.333,5),(744,26706,26700,'298',3.333,5),(744,26707,26700,'98d',3.333,5),(744,26708,26700,'8d6',3.333,5),(744,26709,26700,'d67',3.333,5),(744,26710,26700,'673',3.333,5),(744,26711,26700,'733',3.333,5),(744,26712,26700,'331',3.333,5),(744,26713,26700,'31d',3.333,5),(744,26714,26700,'1d3',3.333,5),(744,26715,26700,'d38',3.333,5),(744,26716,26700,'38e',3.333,5),(744,26717,26700,'8e6',3.333,5),(744,26718,26700,'e6b',3.333,5),(744,26719,26700,'6b9',3.333,5),(744,26720,26700,'b9f',3.333,5),(744,26721,26700,'9fb',3.333,5),(744,26722,26700,'fb1',3.333,5),(744,26723,26700,'b12',3.333,5),(744,26724,26700,'12c',3.333,5),(744,26725,26700,'2cd',3.333,5),(744,26726,26700,'cd3',3.333,5),(744,26727,26700,'d32',3.333,5),(744,26728,26700,'32f',3.333,5),(744,26729,26700,'2fa',3.333,5),(744,26730,26700,'fa1',3.333,5),(745,26732,26731,'naa',100,5),(745,26733,26732,'600',3.333,5),(745,26734,26732,'000',3.333,5),(745,26735,26732,'00c',3.333,5),(745,26736,26732,'0c2',3.333,5),(745,26737,26732,'c29',3.333,5),(745,26738,26732,'29e',3.333,5),(745,26739,26732,'9e6',3.333,5),(745,26740,26732,'e62',3.333,5),(745,26741,26732,'625',3.333,5),(745,26742,26732,'253',3.333,5),(745,26743,26732,'530',3.333,5),(745,26744,26732,'30d',3.333,5),(745,26745,26732,'0df',3.333,5),(745,26746,26732,'df2',3.333,5),(745,26747,26732,'f24',3.333,5),(745,26748,26732,'24d',3.333,5),(745,26749,26732,'4de',3.333,5),(745,26750,26732,'def',3.333,5),(745,26751,26732,'efa',3.333,5),(745,26752,26732,'fa1',3.333,5),(745,26753,26732,'a1a',3.333,5),(745,26754,26732,'1a2',3.333,5),(745,26755,26732,'a28',3.333,5),(745,26756,26732,'28f',3.333,5),(745,26757,26732,'8fe',3.333,5),(745,26758,26732,'fed',3.333,5),(745,26759,26732,'ed1',3.333,5),(745,26760,26732,'d12',3.333,5),(745,26761,26732,'124',3.333,5),(745,26762,26732,'24c',3.333,5),(746,26764,26763,'naa',100,5),(746,26765,26764,'600',3.333,5),(746,26766,26764,'000',3.333,5),(746,26767,26764,'00c',3.333,5),(746,26768,26764,'0c2',3.333,5),(746,26769,26764,'c29',3.333,5),(746,26770,26764,'299',3.333,5),(746,26771,26764,'993',3.333,5),(746,26772,26764,'931',3.333,5),(746,26773,26764,'316',3.333,5),(746,26774,26764,'166',3.333,5),(746,26775,26764,'663',3.333,5),(746,26776,26764,'63a',3.333,5),(746,26777,26764,'3a5',3.333,5),(746,26778,26764,'a51',3.333,5),(746,26779,26764,'51a',3.333,5),(746,26780,26764,'1a1',3.333,5),(746,26781,26764,'a17',3.333,5),(746,26782,26764,'171',3.333,5),(746,26783,26764,'710',3.333,5),(746,26784,26764,'102',3.333,5),(746,26785,26764,'021',3.333,5),(746,26786,26764,'210',3.333,5),(746,26787,26764,'109',3.333,5),(746,26788,26764,'098',3.333,5),(746,26789,26764,'98e',3.333,5),(746,26790,26764,'8ec',3.333,5),(746,26791,26764,'ecb',3.333,5),(746,26792,26764,'cb1',3.333,5),(746,26793,26764,'b12',3.333,5),(746,26794,26764,'12b',3.333,5),(747,26796,26795,'naa',100,5),(747,26797,26796,'600',3.333,5),(747,26798,26796,'000',3.333,5),(747,26799,26796,'00c',3.333,5),(747,26800,26796,'0c2',3.333,5),(747,26801,26796,'c29',3.333,5),(747,26802,26796,'296',3.333,5),(747,26803,26796,'968',3.333,5),(747,26804,26796,'68d',3.333,5),(747,26805,26796,'8d7',3.333,5),(747,26806,26796,'d72',3.333,5),(747,26807,26796,'72c',3.333,5),(747,26808,26796,'2c9',3.333,5),(747,26809,26796,'c99',3.333,5),(747,26810,26796,'996',3.333,5),(747,26811,26796,'96a',3.333,5),(747,26812,26796,'6a3',3.333,5),(747,26813,26796,'a3a',3.333,5),(747,26814,26796,'3a2',3.333,5),(747,26815,26796,'a26',3.333,5),(747,26816,26796,'263',3.333,5),(747,26817,26796,'631',3.333,5),(747,26818,26796,'31e',3.333,5),(747,26819,26796,'1e1',3.333,5),(747,26820,26796,'e1e',3.333,5),(747,26821,26796,'1ef',3.333,5),(747,26822,26796,'ef0',3.333,5),(747,26823,26796,'f00',3.333,5),(747,26824,26796,'007',3.333,5),(747,26825,26796,'078',3.333,5),(747,26826,26796,'780',3.333,5),(748,26828,26827,'naa',100,5),(748,26829,26828,'600',3.333,5),(748,26830,26828,'000',3.333,5),(748,26831,26828,'00c',3.333,5),(748,26832,26828,'0c2',3.333,5),(748,26833,26828,'c29',3.333,5),(748,26834,26828,'299',3.333,5),(748,26835,26828,'999',3.333,5),(748,26836,26828,'99b',3.333,5),(748,26837,26828,'9bd',3.333,5),(748,26838,26828,'bd2',3.333,5),(748,26839,26828,'d2d',3.333,5),(748,26840,26828,'2d2',3.333,5),(748,26841,26828,'d25',3.333,5),(748,26842,26828,'25a',3.333,5),(748,26843,26828,'5a8',3.333,5),(748,26844,26828,'a85',3.333,5),(748,26845,26828,'856',3.333,5),(748,26846,26828,'56f',3.333,5),(748,26847,26828,'6fd',3.333,5),(748,26848,26828,'fdb',3.333,5),(748,26849,26828,'dbd',3.333,5),(748,26850,26828,'bd7',3.333,5),(748,26851,26828,'d71',3.333,5),(748,26852,26828,'71a',3.333,5),(748,26853,26828,'1af',3.333,5),(748,26854,26828,'af8',3.333,5),(748,26855,26828,'f8e',3.333,5),(748,26856,26828,'8e5',3.333,5),(748,26857,26828,'e54',3.333,5),(748,26858,26828,'54e',3.333,5),(749,26860,26859,'naa',100,5),(749,26861,26860,'600',3.333,5),(749,26862,26860,'000',3.333,5),(749,26863,26860,'00c',3.333,5),(749,26864,26860,'0c2',3.333,5),(749,26865,26860,'c29',3.333,5),(749,26866,26860,'29a',3.333,5),(749,26867,26860,'9ae',3.333,5),(749,26868,26860,'ae5',3.333,5),(749,26869,26860,'e5a',3.333,5),(749,26870,26860,'5ae',3.333,5),(749,26871,26860,'ae5',3.333,5),(749,26872,26860,'e56',3.333,5),(749,26873,26860,'567',3.333,5),(749,26874,26860,'674',3.333,5),(749,26875,26860,'74f',3.333,5),(749,26876,26860,'4f7',3.333,5),(749,26877,26860,'f7e',3.333,5),(749,26878,26860,'7e2',3.333,5),(749,26879,26860,'e28',3.333,5),(749,26880,26860,'283',3.333,5),(749,26881,26860,'83d',3.333,5),(749,26882,26860,'3da',3.333,5),(749,26883,26860,'da1',3.333,5),(749,26884,26860,'a16',3.333,5),(749,26885,26860,'169',3.333,5),(749,26886,26860,'69b',3.333,5),(749,26887,26860,'9b8',3.333,5),(749,26888,26860,'b88',3.333,5),(749,26889,26860,'889',3.333,5),(749,26890,26860,'898',3.333,5),(750,26892,26891,'naa',100,5),(750,26893,26892,'600',3.333,5),(750,26894,26892,'000',3.333,5),(750,26895,26892,'00c',3.333,5),(750,26896,26892,'0c2',3.333,5),(750,26897,26892,'c29',3.333,5),(750,26898,26892,'29f',3.333,5),(750,26899,26892,'9f9',3.333,5),(750,26900,26892,'f98',3.333,5),(750,26901,26892,'98c',3.333,5),(750,26902,26892,'8c3',3.333,5),(750,26903,26892,'c3a',3.333,5),(750,26904,26892,'3a7',3.333,5),(750,26905,26892,'a71',3.333,5),(750,26906,26892,'711',3.333,5),(750,26907,26892,'115',3.333,5),(750,26908,26892,'154',3.333,5),(750,26909,26892,'542',3.333,5),(750,26910,26892,'423',3.333,5),(750,26911,26892,'232',3.333,5),(750,26912,26892,'327',3.333,5),(750,26913,26892,'275',3.333,5),(750,26914,26892,'75b',3.333,5),(750,26915,26892,'5b8',3.333,5),(750,26916,26892,'b86',3.333,5),(750,26917,26892,'867',3.333,5),(750,26918,26892,'679',3.333,5),(750,26919,26892,'794',3.333,5),(750,26920,26892,'943',3.333,5),(750,26921,26892,'436',3.333,5),(750,26922,26892,'364',3.333,5),(751,26924,26923,'naa',100,5),(751,26925,26924,'600',3.333,5),(751,26926,26924,'000',3.333,5),(751,26927,26924,'00c',3.333,5),(751,26928,26924,'0c2',3.333,5),(751,26929,26924,'c29',3.333,5),(751,26930,26924,'29d',3.333,5),(751,26931,26924,'9d7',3.333,5),(751,26932,26924,'d7d',3.333,5),(751,26933,26924,'7d9',3.333,5),(751,26934,26924,'d95',3.333,5),(751,26935,26924,'95e',3.333,5),(751,26936,26924,'5e0',3.333,5),(751,26937,26924,'e07',3.333,5),(751,26938,26924,'071',3.333,5),(751,26939,26924,'712',3.333,5),(751,26940,26924,'125',3.333,5),(751,26941,26924,'25c',3.333,5),(751,26942,26924,'5c1',3.333,5),(751,26943,26924,'c14',3.333,5),(751,26944,26924,'145',3.333,5),(751,26945,26924,'453',3.333,5),(751,26946,26924,'536',3.333,5),(751,26947,26924,'361',3.333,5),(751,26948,26924,'61f',3.333,5),(751,26949,26924,'1fd',3.333,5),(751,26950,26924,'fd0',3.333,5),(751,26951,26924,'d07',3.333,5),(751,26952,26924,'07b',3.333,5),(751,26953,26924,'7ba',3.333,5),(751,26954,26924,'ba6',3.333,5),(752,26956,26955,'naa',100,5),(752,26957,26956,'600',3.333,5),(752,26958,26956,'000',3.333,5),(752,26959,26956,'00c',3.333,5),(752,26960,26956,'0c2',3.333,5),(752,26961,26956,'c29',3.333,5),(752,26962,26956,'29a',3.333,5),(752,26963,26956,'9a6',3.333,5),(752,26964,26956,'a60',3.333,5),(752,26965,26956,'602',3.333,5),(752,26966,26956,'02a',3.333,5),(752,26967,26956,'2a1',3.333,5),(752,26968,26956,'a1d',3.333,5),(752,26969,26956,'1dc',3.333,5),(752,26970,26956,'dc8',3.333,5),(752,26971,26956,'c8c',3.333,5),(752,26972,26956,'8c9',3.333,5),(752,26973,26956,'c99',3.333,5),(752,26974,26956,'99c',3.333,5),(752,26975,26956,'9cc',3.333,5),(752,26976,26956,'ccf',3.333,5),(752,26977,26956,'cf6',3.333,5),(752,26978,26956,'f64',3.333,5),(752,26979,26956,'649',3.333,5),(752,26980,26956,'496',3.333,5),(752,26981,26956,'960',3.333,5),(752,26982,26956,'607',3.333,5),(752,26983,26956,'07d',3.333,5),(752,26984,26956,'7d2',3.333,5),(752,26985,26956,'d24',3.333,5),(752,26986,26956,'24b',3.333,5),(753,26988,26987,'naa',100,5),(753,26989,26988,'600',3.333,5),(753,26990,26988,'000',3.333,5),(753,26991,26988,'00c',3.333,5),(753,26992,26988,'0c2',3.333,5),(753,26993,26988,'c29',3.333,5),(753,26994,26988,'29e',3.333,5),(753,26995,26988,'9e0',3.333,5),(753,26996,26988,'e0d',3.333,5),(753,26997,26988,'0d9',3.333,5),(753,26998,26988,'d93',3.333,5),(753,26999,26988,'938',3.333,5),(753,27000,26988,'381',3.333,5),(753,27001,26988,'817',3.333,5),(753,27002,26988,'175',3.333,5),(753,27003,26988,'756',3.333,5),(753,27004,26988,'56d',3.333,5),(753,27005,26988,'6dd',3.333,5),(753,27006,26988,'dd6',3.333,5),(753,27007,26988,'d66',3.333,5),(753,27008,26988,'66c',3.333,5),(753,27009,26988,'6c2',3.333,5),(753,27010,26988,'c2f',3.333,5),(753,27011,26988,'2f5',3.333,5),(753,27012,26988,'f52',3.333,5),(753,27013,26988,'521',3.333,5),(753,27014,26988,'217',3.333,5),(753,27015,26988,'172',3.333,5),(753,27016,26988,'722',3.333,5),(753,27017,26988,'227',3.333,5),(753,27018,26988,'275',3.333,5),(754,27020,27019,'naa',100,5),(754,27021,27020,'600',3.333,5),(754,27022,27020,'000',3.333,5),(754,27023,27020,'00c',3.333,5),(754,27024,27020,'0c2',3.333,5),(754,27025,27020,'c29',3.333,5),(754,27026,27020,'298',3.333,5),(754,27027,27020,'989',3.333,5),(754,27028,27020,'893',3.333,5),(754,27029,27020,'931',3.333,5),(754,27030,27020,'31b',3.333,5),(754,27031,27020,'1bb',3.333,5),(754,27032,27020,'bbd',3.333,5),(754,27033,27020,'bd4',3.333,5),(754,27034,27020,'d40',3.333,5),(754,27035,27020,'405',3.333,5),(754,27036,27020,'051',3.333,5),(754,27037,27020,'51e',3.333,5),(754,27038,27020,'1e9',3.333,5),(754,27039,27020,'e93',3.333,5),(754,27040,27020,'93e',3.333,5),(754,27041,27020,'3ea',3.333,5),(754,27042,27020,'eac',3.333,5),(754,27043,27020,'ac1',3.333,5),(754,27044,27020,'c15',3.333,5),(754,27045,27020,'150',3.333,5),(754,27046,27020,'500',3.333,5),(754,27047,27020,'008',3.333,5),(754,27048,27020,'08f',3.333,5),(754,27049,27020,'8fd',3.333,5),(754,27050,27020,'fd6',3.333,5),(755,27052,27051,'naa',100,5),(755,27053,27052,'600',3.333,5),(755,27054,27052,'000',3.333,5),(755,27055,27052,'00c',3.333,5),(755,27056,27052,'0c2',3.333,5),(755,27057,27052,'c29',3.333,5),(755,27058,27052,'29d',3.333,5),(755,27059,27052,'9da',3.333,5),(755,27060,27052,'dad',3.333,5),(755,27061,27052,'ad6',3.333,5),(755,27062,27052,'d6f',3.333,5),(755,27063,27052,'6ff',3.333,5),(755,27064,27052,'ff9',3.333,5),(755,27065,27052,'f96',3.333,5),(755,27066,27052,'96c',3.333,5),(755,27067,27052,'6c7',3.333,5),(755,27068,27052,'c7d',3.333,5),(755,27069,27052,'7d7',3.333,5),(755,27070,27052,'d74',3.333,5),(755,27071,27052,'74b',3.333,5),(755,27072,27052,'4b2',3.333,5),(755,27073,27052,'b2b',3.333,5),(755,27074,27052,'2bd',3.333,5),(755,27075,27052,'bd1',3.333,5),(755,27076,27052,'d1c',3.333,5),(755,27077,27052,'1c9',3.333,5),(755,27078,27052,'c96',3.333,5),(755,27079,27052,'969',3.333,5),(755,27080,27052,'697',3.333,5),(755,27081,27052,'970',3.333,5),(755,27082,27052,'70a',3.333,5),(756,27084,27083,'naa',100,5),(756,27085,27084,'600',3.333,5),(756,27086,27084,'000',3.333,5),(756,27087,27084,'00c',3.333,5),(756,27088,27084,'0c2',3.333,5),(756,27089,27084,'c29',3.333,5),(756,27090,27084,'298',3.333,5),(756,27091,27084,'98a',3.333,5),(756,27092,27084,'8a1',3.333,5),(756,27093,27084,'a15',3.333,5),(756,27094,27084,'158',3.333,5),(756,27095,27084,'583',3.333,5),(756,27096,27084,'839',3.333,5),(756,27097,27084,'399',3.333,5),(756,27098,27084,'99a',3.333,5),(756,27099,27084,'9a8',3.333,5),(756,27100,27084,'a8c',3.333,5),(756,27101,27084,'8cf',3.333,5),(756,27102,27084,'cf0',3.333,5),(756,27103,27084,'f00',3.333,5),(756,27104,27084,'00e',3.333,5),(756,27105,27084,'0e9',3.333,5),(756,27106,27084,'e9c',3.333,5),(756,27107,27084,'9c9',3.333,5),(756,27108,27084,'c9b',3.333,5),(756,27109,27084,'9bc',3.333,5),(756,27110,27084,'bc3',3.333,5),(756,27111,27084,'c3c',3.333,5),(756,27112,27084,'3c9',3.333,5),(756,27113,27084,'c9e',3.333,5),(756,27114,27084,'9e5',3.333,5),(757,27116,27115,'naa',100,5),(757,27117,27116,'600',3.333,5),(757,27118,27116,'000',3.333,5),(757,27119,27116,'00c',3.333,5),(757,27120,27116,'0c2',3.333,5),(757,27121,27116,'c29',3.333,5),(757,27122,27116,'292',3.333,5),(757,27123,27116,'923',3.333,5),(757,27124,27116,'23c',3.333,5),(757,27125,27116,'3c7',3.333,5),(757,27126,27116,'c7d',3.333,5),(757,27127,27116,'7d4',3.333,5),(757,27128,27116,'d40',3.333,5),(757,27129,27116,'402',3.333,5),(757,27130,27116,'020',3.333,5),(757,27131,27116,'204',3.333,5),(757,27132,27116,'046',3.333,5),(757,27133,27116,'46f',3.333,5),(757,27134,27116,'6fb',3.333,5),(757,27135,27116,'fbc',3.333,5),(757,27136,27116,'bcd',3.333,5),(757,27137,27116,'cdb',3.333,5),(757,27138,27116,'dbe',3.333,5),(757,27139,27116,'beb',3.333,5),(757,27140,27116,'eb5',3.333,5),(757,27141,27116,'b55',3.333,5),(757,27142,27116,'556',3.333,5),(757,27143,27116,'56d',3.333,5),(757,27144,27116,'6df',3.333,5),(757,27145,27116,'df8',3.333,5),(757,27146,27116,'f8a',3.333,5),(758,27148,27147,'naa',100,5),(758,27149,27148,'600',3.333,5),(758,27150,27148,'000',3.333,5),(758,27151,27148,'00c',3.333,5),(758,27152,27148,'0c2',3.333,5),(758,27153,27148,'c29',3.333,5),(758,27154,27148,'299',3.333,5),(758,27155,27148,'99a',3.333,5),(758,27156,27148,'9aa',3.333,5),(758,27157,27148,'aa8',3.333,5),(758,27158,27148,'a8d',3.333,5),(758,27159,27148,'8df',3.333,5),(758,27160,27148,'dfd',3.333,5),(758,27161,27148,'fda',3.333,5),(758,27162,27148,'dac',3.333,5),(758,27163,27148,'ac2',3.333,5),(758,27164,27148,'c2d',3.333,5),(758,27165,27148,'2dc',3.333,5),(758,27166,27148,'dc3',3.333,5),(758,27167,27148,'c36',3.333,5),(758,27168,27148,'36b',3.333,5),(758,27169,27148,'6b1',3.333,5),(758,27170,27148,'b17',3.333,5),(758,27171,27148,'17a',3.333,5),(758,27172,27148,'7a1',3.333,5),(758,27173,27148,'a1f',3.333,5),(758,27174,27148,'1f7',3.333,5),(758,27175,27148,'f72',3.333,5),(758,27176,27148,'727',3.333,5),(758,27177,27148,'27d',3.333,5),(758,27178,27148,'7d5',3.333,5),(759,27180,27179,'naa',100,5),(759,27181,27180,'600',3.333,5),(759,27182,27180,'000',3.333,5),(759,27183,27180,'00c',3.333,5),(759,27184,27180,'0c2',3.333,5),(759,27185,27180,'c29',3.333,5),(759,27186,27180,'295',3.333,5),(759,27187,27180,'95c',3.333,5),(759,27188,27180,'5c5',3.333,5),(759,27189,27180,'c52',3.333,5),(759,27190,27180,'524',3.333,5),(759,27191,27180,'242',3.333,5),(759,27192,27180,'427',3.333,5),(759,27193,27180,'272',3.333,5),(759,27194,27180,'72b',3.333,5),(759,27195,27180,'2be',3.333,5),(759,27196,27180,'be4',3.333,5),(759,27197,27180,'e4e',3.333,5),(759,27198,27180,'4ed',3.333,5),(759,27199,27180,'edc',3.333,5),(759,27200,27180,'dca',3.333,5),(759,27201,27180,'ca5',3.333,5),(759,27202,27180,'a50',3.333,5),(759,27203,27180,'509',3.333,5),(759,27204,27180,'093',3.333,5),(759,27205,27180,'938',3.333,5),(759,27206,27180,'38d',3.333,5),(759,27207,27180,'8dc',3.333,5),(759,27208,27180,'dc5',3.333,5),(759,27209,27180,'c55',3.333,5),(759,27210,27180,'55c',3.333,5),(760,27212,27211,'naa',100,5),(760,27213,27212,'600',3.333,5),(760,27214,27212,'000',3.333,5),(760,27215,27212,'00c',3.333,5),(760,27216,27212,'0c2',3.333,5),(760,27217,27212,'c29',3.333,5),(760,27218,27212,'292',3.333,5),(760,27219,27212,'923',3.333,5),(760,27220,27212,'23f',3.333,5),(760,27221,27212,'3fc',3.333,5),(760,27222,27212,'fc6',3.333,5),(760,27223,27212,'c65',3.333,5),(760,27224,27212,'65a',3.333,5),(760,27225,27212,'5a0',3.333,5),(760,27226,27212,'a00',3.333,5),(760,27227,27212,'00d',3.333,5),(760,27228,27212,'0d2',3.333,5),(760,27229,27212,'d27',3.333,5),(760,27230,27212,'275',3.333,5),(760,27231,27212,'75b',3.333,5),(760,27232,27212,'5ba',3.333,5),(760,27233,27212,'bae',3.333,5),(760,27234,27212,'aed',3.333,5),(760,27235,27212,'ed3',3.333,5),(760,27236,27212,'d36',3.333,5),(760,27237,27212,'362',3.333,5),(760,27238,27212,'622',3.333,5),(760,27239,27212,'22d',3.333,5),(760,27240,27212,'2dc',3.333,5),(760,27241,27212,'dc0',3.333,5),(760,27242,27212,'c0f',3.333,5),(761,27244,27243,'naa',100,5),(761,27245,27244,'600',3.333,5),(761,27246,27244,'000',3.333,5),(761,27247,27244,'00c',3.333,5),(761,27248,27244,'0c2',3.333,5),(761,27249,27244,'c29',3.333,5),(761,27250,27244,'296',3.333,5),(761,27251,27244,'964',3.333,5),(761,27252,27244,'642',3.333,5),(761,27253,27244,'421',3.333,5),(761,27254,27244,'212',3.333,5),(761,27255,27244,'120',3.333,5),(761,27256,27244,'20f',3.333,5),(761,27257,27244,'0f6',3.333,5),(761,27258,27244,'f6b',3.333,5),(761,27259,27244,'6b2',3.333,5),(761,27260,27244,'b23',3.333,5),(761,27261,27244,'23b',3.333,5),(761,27262,27244,'3b0',3.333,5),(761,27263,27244,'b07',3.333,5),(761,27264,27244,'074',3.333,5),(761,27265,27244,'74a',3.333,5),(761,27266,27244,'4ae',3.333,5),(761,27267,27244,'aef',3.333,5),(761,27268,27244,'ef6',3.333,5),(761,27269,27244,'f6d',3.333,5),(761,27270,27244,'6d0',3.333,5),(761,27271,27244,'d06',3.333,5),(761,27272,27244,'06f',3.333,5),(761,27273,27244,'6f5',3.333,5),(761,27274,27244,'f5e',3.333,5),(762,27276,27275,'naa',100,5),(762,27277,27276,'600',3.333,5),(762,27278,27276,'000',3.333,5),(762,27279,27276,'00c',3.333,5),(762,27280,27276,'0c2',3.333,5),(762,27281,27276,'c29',3.333,5),(762,27282,27276,'293',3.333,5),(762,27283,27276,'93b',3.333,5),(762,27284,27276,'3b2',3.333,5),(762,27285,27276,'b2d',3.333,5),(762,27286,27276,'2dc',3.333,5),(762,27287,27276,'dc5',3.333,5),(762,27288,27276,'c59',3.333,5),(762,27289,27276,'597',3.333,5),(762,27290,27276,'97b',3.333,5),(762,27291,27276,'7bc',3.333,5),(762,27292,27276,'bc3',3.333,5),(762,27293,27276,'c34',3.333,5),(762,27294,27276,'342',3.333,5),(762,27295,27276,'428',3.333,5),(762,27296,27276,'281',3.333,5),(762,27297,27276,'818',3.333,5),(762,27298,27276,'189',3.333,5),(762,27299,27276,'893',3.333,5),(762,27300,27276,'935',3.333,5),(762,27301,27276,'354',3.333,5),(762,27302,27276,'54d',3.333,5),(762,27303,27276,'4d0',3.333,5),(762,27304,27276,'d0b',3.333,5),(762,27305,27276,'0bd',3.333,5),(762,27306,27276,'bd2',3.333,5),(763,27308,27307,'hgw',8.333,5),(763,27309,27307,'gw2',8.333,5),(763,27310,27307,'w2k',8.333,5),(763,27311,27307,'2k8',8.333,5),(763,27312,27307,'k8r',8.333,5),(763,27313,27307,'8r2',8.333,5),(763,27314,27307,'r23',8.333,5),(763,27315,27307,'232',8.333,5),(763,27316,27307,'32v',8.333,5),(763,27317,27307,'2vm',8.333,5),(763,27318,27307,'vm1',8.333,5),(763,27319,27307,'m10',8.333,5),(764,27321,27320,'naa',100,5),(764,27322,27321,'600',3.333,5),(764,27323,27321,'000',3.333,5),(764,27324,27321,'00c',3.333,5),(764,27325,27321,'0c2',3.333,5),(764,27326,27321,'c29',3.333,5),(764,27327,27321,'296',3.333,5),(764,27328,27321,'96d',3.333,5),(764,27329,27321,'6d2',3.333,5),(764,27330,27321,'d29',3.333,5),(764,27331,27321,'290',3.333,5),(764,27332,27321,'905',3.333,5),(764,27333,27321,'053',3.333,5),(764,27334,27321,'531',3.333,5),(764,27335,27321,'311',3.333,5),(764,27336,27321,'11b',3.333,5),(764,27337,27321,'1bb',3.333,5),(764,27338,27321,'bb2',3.333,5),(764,27339,27321,'b23',3.333,5),(764,27340,27321,'23b',3.333,5),(764,27341,27321,'3b1',3.333,5),(764,27342,27321,'b17',3.333,5),(764,27343,27321,'17e',3.333,5),(764,27344,27321,'7ed',3.333,5),(764,27345,27321,'ed0',3.333,5),(764,27346,27321,'d00',3.333,5),(764,27347,27321,'002',3.333,5),(764,27348,27321,'027',3.333,5),(764,27349,27321,'278',3.333,5),(764,27350,27321,'786',3.333,5),(764,27351,27321,'86b',3.333,5),(765,27353,27352,'naa',100,5),(765,27354,27353,'600',3.333,5),(765,27355,27353,'00a',3.333,5),(765,27356,27353,'0a0',3.333,5),(765,27357,27353,'a09',3.333,5),(765,27358,27353,'098',3.333,5),(765,27359,27353,'980',3.333,5),(765,27360,27353,'804',3.333,5),(765,27361,27353,'044',3.333,5),(765,27362,27353,'443',3.333,5),(765,27363,27353,'430',3.333,5),(765,27364,27353,'307',3.333,5),(765,27365,27353,'072',3.333,5),(765,27366,27353,'725',3.333,5),(765,27367,27353,'259',3.333,5),(765,27368,27353,'593',3.333,5),(765,27369,27353,'931',3.333,5),(765,27370,27353,'313',3.333,5),(765,27371,27353,'13f',3.333,5),(765,27372,27353,'3f3',3.333,5),(765,27373,27353,'f33',3.333,5),(765,27374,27353,'334',3.333,5),(765,27375,27353,'345',3.333,5),(765,27376,27353,'455',3.333,5),(765,27377,27353,'556',3.333,5),(765,27378,27353,'563',3.333,5),(765,27379,27353,'639',3.333,5),(765,27380,27353,'393',3.333,5),(765,27381,27353,'934',3.333,5),(765,27382,27353,'344',3.333,5),(765,27383,27353,'44d',3.333,5),(766,27385,27384,'naa',100,5),(766,27386,27385,'600',3.333,5),(766,27387,27385,'00a',3.333,5),(766,27388,27385,'0a0',3.333,5),(766,27389,27385,'a09',3.333,5),(766,27390,27385,'098',3.333,5),(766,27391,27385,'980',3.333,5),(766,27392,27385,'804',3.333,5),(766,27393,27385,'044',3.333,5),(766,27394,27385,'443',3.333,5),(766,27395,27385,'430',3.333,5),(766,27396,27385,'307',3.333,5),(766,27397,27385,'072',3.333,5),(766,27398,27385,'725',3.333,5),(766,27399,27385,'259',3.333,5),(766,27400,27385,'593',3.333,5),(766,27401,27385,'931',3.333,5),(766,27402,27385,'313',3.333,5),(766,27403,27385,'13f',3.333,5),(766,27404,27385,'3f3',3.333,5),(766,27405,27385,'f33',3.333,5),(766,27406,27385,'334',3.333,5),(766,27407,27385,'345',3.333,5),(766,27408,27385,'455',3.333,5),(766,27409,27385,'556',3.333,5),(766,27410,27385,'563',3.333,5),(766,27411,27385,'639',3.333,5),(766,27412,27385,'393',3.333,5),(766,27413,27385,'934',3.333,5),(766,27414,27385,'344',3.333,5),(766,27415,27385,'44e',3.333,5),(767,27417,27416,'naa',100,5),(767,27418,27417,'600',3.333,5),(767,27419,27417,'00a',3.333,5),(767,27420,27417,'0a0',3.333,5),(767,27421,27417,'a09',3.333,5),(767,27422,27417,'098',3.333,5),(767,27423,27417,'980',3.333,5),(767,27424,27417,'804',3.333,5),(767,27425,27417,'044',3.333,5),(767,27426,27417,'443',3.333,5),(767,27427,27417,'430',3.333,5),(767,27428,27417,'307',3.333,5),(767,27429,27417,'075',3.333,5),(767,27430,27417,'753',3.333,5),(767,27431,27417,'535',3.333,5),(767,27432,27417,'357',3.333,5),(767,27433,27417,'573',3.333,5),(767,27434,27417,'732',3.333,5),(767,27435,27417,'32b',3.333,5),(767,27436,27417,'2b3',3.333,5),(767,27437,27417,'b33',3.333,5),(767,27438,27417,'334',3.333,5),(767,27439,27417,'345',3.333,5),(767,27440,27417,'457',3.333,5),(767,27441,27417,'571',3.333,5),(767,27442,27417,'715',3.333,5),(767,27443,27417,'153',3.333,5),(767,27444,27417,'533',3.333,5),(767,27445,27417,'336',3.333,5),(767,27446,27417,'363',3.333,5),(767,27447,27417,'638',3.333,5),(768,27449,27448,'naa',100,5),(768,27450,27449,'600',3.333,5),(768,27451,27449,'00a',3.333,5),(768,27452,27449,'0a0',3.333,5),(768,27453,27449,'a09',3.333,5),(768,27454,27449,'098',3.333,5),(768,27455,27449,'980',3.333,5),(768,27456,27449,'804',3.333,5),(768,27457,27449,'044',3.333,5),(768,27458,27449,'443',3.333,5),(768,27459,27449,'430',3.333,5),(768,27460,27449,'307',3.333,5),(768,27461,27449,'075',3.333,5),(768,27462,27449,'753',3.333,5),(768,27463,27449,'535',3.333,5),(768,27464,27449,'357',3.333,5),(768,27465,27449,'573',3.333,5),(768,27466,27449,'732',3.333,5),(768,27467,27449,'32b',3.333,5),(768,27468,27449,'2b3',3.333,5),(768,27469,27449,'b33',3.333,5),(768,27470,27449,'334',3.333,5),(768,27471,27449,'345',3.333,5),(768,27472,27449,'457',3.333,5),(768,27473,27449,'571',3.333,5),(768,27474,27449,'715',3.333,5),(768,27475,27449,'153',3.333,5),(768,27476,27449,'533',3.333,5),(768,27477,27449,'336',3.333,5),(768,27478,27449,'363',3.333,5),(768,27479,27449,'639',3.333,5),(769,27481,27480,'naa',100,5),(769,27482,27481,'600',3.333,5),(769,27483,27481,'000',3.333,5),(769,27484,27481,'00c',3.333,5),(769,27485,27481,'0c2',3.333,5),(769,27486,27481,'c29',3.333,5),(769,27487,27481,'29c',3.333,5),(769,27488,27481,'9c7',3.333,5),(769,27489,27481,'c74',3.333,5),(769,27490,27481,'740',3.333,5),(769,27491,27481,'401',3.333,5),(769,27492,27481,'018',3.333,5),(769,27493,27481,'184',3.333,5),(769,27494,27481,'84c',3.333,5),(769,27495,27481,'4c4',3.333,5),(769,27496,27481,'c44',3.333,5),(769,27497,27481,'44f',3.333,5),(769,27498,27481,'4fc',3.333,5),(769,27499,27481,'fc2',3.333,5),(769,27500,27481,'c28',3.333,5),(769,27501,27481,'287',3.333,5),(769,27502,27481,'874',3.333,5),(769,27503,27481,'740',3.333,5),(769,27504,27481,'405',3.333,5),(769,27505,27481,'05b',3.333,5),(769,27506,27481,'5b0',3.333,5),(769,27507,27481,'b08',3.333,5),(769,27508,27481,'08e',3.333,5),(769,27509,27481,'8ea',3.333,5),(769,27510,27481,'ea0',3.333,5),(769,27511,27481,'a0e',3.333,5),(770,27513,27512,'naa',100,5),(770,27514,27513,'600',3.333,5),(770,27515,27513,'000',3.333,5),(770,27516,27513,'00c',3.333,5),(770,27517,27513,'0c2',3.333,5),(770,27518,27513,'c29',3.333,5),(770,27519,27513,'29b',3.333,5),(770,27520,27513,'9b0',3.333,5),(770,27521,27513,'b0b',3.333,5),(770,27522,27513,'0b3',3.333,5),(770,27523,27513,'b3d',3.333,5),(770,27524,27513,'3d1',3.333,5),(770,27525,27513,'d1f',3.333,5),(770,27526,27513,'1f1',3.333,5),(770,27527,27513,'f12',3.333,5),(770,27528,27513,'124',3.333,5),(770,27529,27513,'243',3.333,5),(770,27530,27513,'430',3.333,5),(770,27531,27513,'309',3.333,5),(770,27532,27513,'096',3.333,5),(770,27533,27513,'96c',3.333,5),(770,27534,27513,'6c4',3.333,5),(770,27535,27513,'c49',3.333,5),(770,27536,27513,'496',3.333,5),(770,27537,27513,'96d',3.333,5),(770,27538,27513,'6dc',3.333,5),(770,27539,27513,'dce',3.333,5),(770,27540,27513,'ce1',3.333,5),(770,27541,27513,'e13',3.333,5),(770,27542,27513,'132',3.333,5),(770,27543,27513,'32e',3.333,5),(771,27545,27544,'naa',100,5),(771,27546,27545,'600',3.333,5),(771,27547,27545,'000',3.333,5),(771,27548,27545,'00c',3.333,5),(771,27549,27545,'0c2',3.333,5),(771,27550,27545,'c29',3.333,5),(771,27551,27545,'29b',3.333,5),(771,27552,27545,'9be',3.333,5),(771,27553,27545,'beb',3.333,5),(771,27554,27545,'eb1',3.333,5),(771,27555,27545,'b1d',3.333,5),(771,27556,27545,'1dc',3.333,5),(771,27557,27545,'dcf',3.333,5),(771,27558,27545,'cfb',3.333,5),(771,27559,27545,'fb3',3.333,5),(771,27560,27545,'b37',3.333,5),(771,27561,27545,'37d',3.333,5),(771,27562,27545,'7d0',3.333,5),(771,27563,27545,'d0c',3.333,5),(771,27564,27545,'0c5',3.333,5),(771,27565,27545,'c59',3.333,5),(771,27566,27545,'596',3.333,5),(771,27567,27545,'961',3.333,5),(771,27568,27545,'616',3.333,5),(771,27569,27545,'168',3.333,5),(771,27570,27545,'685',3.333,5),(771,27571,27545,'852',3.333,5),(771,27572,27545,'523',3.333,5),(771,27573,27545,'231',3.333,5),(771,27574,27545,'311',3.333,5),(771,27575,27545,'11d',3.333,5),(772,27577,27576,'naa',100,5),(772,27578,27577,'600',3.333,5),(772,27579,27577,'000',3.333,5),(772,27580,27577,'00c',3.333,5),(772,27581,27577,'0c2',3.333,5),(772,27582,27577,'c29',3.333,5),(772,27583,27577,'29b',3.333,5),(772,27584,27577,'9bc',3.333,5),(772,27585,27577,'bc7',3.333,5),(772,27586,27577,'c7b',3.333,5),(772,27587,27577,'7bb',3.333,5),(772,27588,27577,'bba',3.333,5),(772,27589,27577,'ba5',3.333,5),(772,27590,27577,'a5d',3.333,5),(772,27591,27577,'5dc',3.333,5),(772,27592,27577,'dcf',3.333,5),(772,27593,27577,'cf3',3.333,5),(772,27594,27577,'f37',3.333,5),(772,27595,27577,'37a',3.333,5),(772,27596,27577,'7a1',3.333,5),(772,27597,27577,'a19',3.333,5),(772,27598,27577,'19b',3.333,5),(772,27599,27577,'9ba',3.333,5),(772,27600,27577,'bae',3.333,5),(772,27601,27577,'aed',3.333,5),(772,27602,27577,'edb',3.333,5),(772,27603,27577,'db7',3.333,5),(772,27604,27577,'b71',3.333,5),(772,27605,27577,'71d',3.333,5),(772,27606,27577,'1df',3.333,5),(772,27607,27577,'df5',3.333,5),(773,27609,27608,'naa',100,5),(773,27610,27609,'600',3.333,5),(773,27611,27609,'000',3.333,5),(773,27612,27609,'00c',3.333,5),(773,27613,27609,'0c2',3.333,5),(773,27614,27609,'c29',3.333,5),(773,27615,27609,'291',3.333,5),(773,27616,27609,'918',3.333,5),(773,27617,27609,'188',3.333,5),(773,27618,27609,'887',3.333,5),(773,27619,27609,'872',3.333,5),(773,27620,27609,'72b',3.333,5),(773,27621,27609,'2bc',3.333,5),(773,27622,27609,'bcf',3.333,5),(773,27623,27609,'cf9',3.333,5),(773,27624,27609,'f97',3.333,5),(773,27625,27609,'977',3.333,5),(773,27626,27609,'770',3.333,5),(773,27627,27609,'707',3.333,5),(773,27628,27609,'070',3.333,5),(773,27629,27609,'703',3.333,5),(773,27630,27609,'036',3.333,5),(773,27631,27609,'36d',3.333,5),(773,27632,27609,'6dd',3.333,5),(773,27633,27609,'ddc',3.333,5),(773,27634,27609,'dca',3.333,5),(773,27635,27609,'cab',3.333,5),(773,27636,27609,'ab5',3.333,5),(773,27637,27609,'b55',3.333,5),(773,27638,27609,'55a',3.333,5),(773,27639,27609,'5a5',3.333,5),(774,27641,27640,'naa',100,5),(774,27642,27641,'600',3.333,5),(774,27643,27641,'000',3.333,5),(774,27644,27641,'00c',3.333,5),(774,27645,27641,'0c2',3.333,5),(774,27646,27641,'c29',3.333,5),(774,27647,27641,'29e',3.333,5),(774,27648,27641,'9eb',3.333,5),(774,27649,27641,'eba',3.333,5),(774,27650,27641,'ba1',3.333,5),(774,27651,27641,'a1e',3.333,5),(774,27652,27641,'1e8',3.333,5),(774,27653,27641,'e8c',3.333,5),(774,27654,27641,'8c6',3.333,5),(774,27655,27641,'c67',3.333,5),(774,27656,27641,'67d',3.333,5),(774,27657,27641,'7de',3.333,5),(774,27658,27641,'de0',3.333,5),(774,27659,27641,'e05',3.333,5),(774,27660,27641,'050',3.333,5),(774,27661,27641,'500',3.333,5),(774,27662,27641,'002',3.333,5),(774,27663,27641,'027',3.333,5),(774,27664,27641,'274',3.333,5),(774,27665,27641,'74d',3.333,5),(774,27666,27641,'4d7',3.333,5),(774,27667,27641,'d74',3.333,5),(774,27668,27641,'74d',3.333,5),(774,27669,27641,'4d9',3.333,5),(774,27670,27641,'d91',3.333,5),(774,27671,27641,'91c',3.333,5),(775,27673,27672,'naa',100,5),(775,27674,27673,'600',3.333,5),(775,27675,27673,'000',3.333,5),(775,27676,27673,'00c',3.333,5),(775,27677,27673,'0c2',3.333,5),(775,27678,27673,'c29',3.333,5),(775,27679,27673,'29e',3.333,5),(775,27680,27673,'9ee',3.333,5),(775,27681,27673,'eed',3.333,5),(775,27682,27673,'ed0',3.333,5),(775,27683,27673,'d0b',3.333,5),(775,27684,27673,'0bf',3.333,5),(775,27685,27673,'bfd',3.333,5),(775,27686,27673,'fd9',3.333,5),(775,27687,27673,'d96',3.333,5),(775,27688,27673,'962',3.333,5),(775,27689,27673,'62b',3.333,5),(775,27690,27673,'2b5',3.333,5),(775,27691,27673,'b59',3.333,5),(775,27692,27673,'59b',3.333,5),(775,27693,27673,'9bd',3.333,5),(775,27694,27673,'bdb',3.333,5),(775,27695,27673,'db1',3.333,5),(775,27696,27673,'b13',3.333,5),(775,27697,27673,'134',3.333,5),(775,27698,27673,'346',3.333,5),(775,27699,27673,'46b',3.333,5),(775,27700,27673,'6b8',3.333,5),(775,27701,27673,'b89',3.333,5),(775,27702,27673,'89c',3.333,5),(775,27703,27673,'9cc',3.333,5),(776,27705,27704,'naa',100,5),(776,27706,27705,'600',3.333,5),(776,27707,27705,'000',3.333,5),(776,27708,27705,'00c',3.333,5),(776,27709,27705,'0c2',3.333,5),(776,27710,27705,'c29',3.333,5),(776,27711,27705,'293',3.333,5),(776,27712,27705,'93b',3.333,5),(776,27713,27705,'3b7',3.333,5),(776,27714,27705,'b7c',3.333,5),(776,27715,27705,'7c5',3.333,5),(776,27716,27705,'c50',3.333,5),(776,27717,27705,'50a',3.333,5),(776,27718,27705,'0af',3.333,5),(776,27719,27705,'afc',3.333,5),(776,27720,27705,'fc9',3.333,5),(776,27721,27705,'c97',3.333,5),(776,27722,27705,'974',3.333,5),(776,27723,27705,'74b',3.333,5),(776,27724,27705,'4bc',3.333,5),(776,27725,27705,'bc9',3.333,5),(776,27726,27705,'c97',3.333,5),(776,27727,27705,'978',3.333,5),(776,27728,27705,'789',3.333,5),(776,27729,27705,'89a',3.333,5),(776,27730,27705,'9a9',3.333,5),(776,27731,27705,'a95',3.333,5),(776,27732,27705,'95c',3.333,5),(776,27733,27705,'5cd',3.333,5),(776,27734,27705,'cd9',3.333,5),(776,27735,27705,'d97',3.333,5),(777,27737,27736,'naa',100,5),(777,27738,27737,'600',3.333,5),(777,27739,27737,'000',3.333,5),(777,27740,27737,'00c',3.333,5),(777,27741,27737,'0c2',3.333,5),(777,27742,27737,'c29',3.333,5),(777,27743,27737,'294',3.333,5),(777,27744,27737,'942',3.333,5),(777,27745,27737,'42b',3.333,5),(777,27746,27737,'2b3',3.333,5),(777,27747,27737,'b3d',3.333,5),(777,27748,27737,'3d3',3.333,5),(777,27749,27737,'d3b',3.333,5),(777,27750,27737,'3b4',3.333,5),(777,27751,27737,'b4c',3.333,5),(777,27752,27737,'4cd',3.333,5),(777,27753,27737,'cd3',3.333,5),(777,27754,27737,'d3f',3.333,5),(777,27755,27737,'3fd',3.333,5),(777,27756,27737,'fde',3.333,5),(777,27757,27737,'dea',3.333,5),(777,27758,27737,'eae',3.333,5),(777,27759,27737,'aea',3.333,5),(777,27760,27737,'ea5',3.333,5),(777,27761,27737,'a5f',3.333,5),(777,27762,27737,'5f0',3.333,5),(777,27763,27737,'f01',3.333,5),(777,27764,27737,'01d',3.333,5),(777,27765,27737,'1d7',3.333,5),(777,27766,27737,'d79',3.333,5),(777,27767,27737,'793',3.333,5),(778,27769,27768,'naa',100,5),(778,27770,27769,'600',3.333,5),(778,27771,27769,'000',3.333,5),(778,27772,27769,'00c',3.333,5),(778,27773,27769,'0c2',3.333,5),(778,27774,27769,'c29',3.333,5),(778,27775,27769,'29f',3.333,5),(778,27776,27769,'9fe',3.333,5),(778,27777,27769,'feb',3.333,5),(778,27778,27769,'eb8',3.333,5),(778,27779,27769,'b8a',3.333,5),(778,27780,27769,'8a5',3.333,5),(778,27781,27769,'a56',3.333,5),(778,27782,27769,'569',3.333,5),(778,27783,27769,'69f',3.333,5),(778,27784,27769,'9f7',3.333,5),(778,27785,27769,'f7f',3.333,5),(778,27786,27769,'7ff',3.333,5),(778,27787,27769,'ff3',3.333,5),(778,27788,27769,'f3b',3.333,5),(778,27789,27769,'3b2',3.333,5),(778,27790,27769,'b23',3.333,5),(778,27791,27769,'23e',3.333,5),(778,27792,27769,'3e0',3.333,5),(778,27793,27769,'e03',3.333,5),(778,27794,27769,'035',3.333,5),(778,27795,27769,'353',3.333,5),(778,27796,27769,'532',3.333,5),(778,27797,27769,'320',3.333,5),(778,27798,27769,'20e',3.333,5),(778,27799,27769,'0e6',3.333,5),(779,27801,27800,'naa',100,5),(779,27802,27801,'600',3.333,5),(779,27803,27801,'000',3.333,5),(779,27804,27801,'00c',3.333,5),(779,27805,27801,'0c2',3.333,5),(779,27806,27801,'c29',3.333,5),(779,27807,27801,'29b',3.333,5),(779,27808,27801,'9b3',3.333,5),(779,27809,27801,'b31',3.333,5),(779,27810,27801,'318',3.333,5),(779,27811,27801,'184',3.333,5),(779,27812,27801,'842',3.333,5),(779,27813,27801,'420',3.333,5),(779,27814,27801,'207',3.333,5),(779,27815,27801,'07e',3.333,5),(779,27816,27801,'7e0',3.333,5),(779,27817,27801,'e03',3.333,5),(779,27818,27801,'034',3.333,5),(779,27819,27801,'34d',3.333,5),(779,27820,27801,'4da',3.333,5),(779,27821,27801,'da1',3.333,5),(779,27822,27801,'a17',3.333,5),(779,27823,27801,'177',3.333,5),(779,27824,27801,'77f',3.333,5),(779,27825,27801,'7ff',3.333,5),(779,27826,27801,'ffe',3.333,5),(779,27827,27801,'fe3',3.333,5),(779,27828,27801,'e3a',3.333,5),(779,27829,27801,'3a9',3.333,5),(779,27830,27801,'a9b',3.333,5),(779,27831,27801,'9b9',3.333,5),(780,27833,27832,'naa',100,5),(780,27834,27833,'600',3.333,5),(780,27835,27833,'000',3.333,5),(780,27836,27833,'00c',3.333,5),(780,27837,27833,'0c2',3.333,5),(780,27838,27833,'c29',3.333,5),(780,27839,27833,'291',3.333,5),(780,27840,27833,'914',3.333,5),(780,27841,27833,'148',3.333,5),(780,27842,27833,'489',3.333,5),(780,27843,27833,'896',3.333,5),(780,27844,27833,'969',3.333,5),(780,27845,27833,'69c',3.333,5),(780,27846,27833,'9cd',3.333,5),(780,27847,27833,'cd1',3.333,5),(780,27848,27833,'d18',3.333,5),(780,27849,27833,'182',3.333,5),(780,27850,27833,'823',3.333,5),(780,27851,27833,'234',3.333,5),(780,27852,27833,'347',3.333,5),(780,27853,27833,'471',3.333,5),(780,27854,27833,'71f',3.333,5),(780,27855,27833,'1f8',3.333,5),(780,27856,27833,'f87',3.333,5),(780,27857,27833,'877',3.333,5),(780,27858,27833,'777',3.333,5),(780,27859,27833,'776',3.333,5),(780,27860,27833,'761',3.333,5),(780,27861,27833,'618',3.333,5),(780,27862,27833,'18b',3.333,5),(780,27863,27833,'8b3',3.333,5),(781,27865,27864,'naa',100,5),(781,27866,27865,'600',3.333,5),(781,27867,27865,'000',3.333,5),(781,27868,27865,'00c',3.333,5),(781,27869,27865,'0c2',3.333,5),(781,27870,27865,'c29',3.333,5),(781,27871,27865,'295',3.333,5),(781,27872,27865,'954',3.333,5),(781,27873,27865,'54a',3.333,5),(781,27874,27865,'4a0',3.333,5),(781,27875,27865,'a0e',3.333,5),(781,27876,27865,'0e6',3.333,5),(781,27877,27865,'e69',3.333,5),(781,27878,27865,'69e',3.333,5),(781,27879,27865,'9e1',3.333,5),(781,27880,27865,'e1f',3.333,5),(781,27881,27865,'1fb',3.333,5),(781,27882,27865,'fbd',3.333,5),(781,27883,27865,'bd0',3.333,5),(781,27884,27865,'d0d',3.333,5),(781,27885,27865,'0db',3.333,5),(781,27886,27865,'db6',3.333,5),(781,27887,27865,'b65',3.333,5),(781,27888,27865,'650',3.333,5),(781,27889,27865,'505',3.333,5),(781,27890,27865,'05f',3.333,5),(781,27891,27865,'5f6',3.333,5),(781,27892,27865,'f68',3.333,5),(781,27893,27865,'683',3.333,5),(781,27894,27865,'833',3.333,5),(781,27895,27865,'334',3.333,5),(782,27897,27896,'naa',100,5),(782,27898,27897,'600',3.333,5),(782,27899,27897,'000',3.333,5),(782,27900,27897,'00c',3.333,5),(782,27901,27897,'0c2',3.333,5),(782,27902,27897,'c29',3.333,5),(782,27903,27897,'296',3.333,5),(782,27904,27897,'966',3.333,5),(782,27905,27897,'667',3.333,5),(782,27906,27897,'67a',3.333,5),(782,27907,27897,'7a0',3.333,5),(782,27908,27897,'a08',3.333,5),(782,27909,27897,'08a',3.333,5),(782,27910,27897,'8a4',3.333,5),(782,27911,27897,'a48',3.333,5),(782,27912,27897,'486',3.333,5),(782,27913,27897,'867',3.333,5),(782,27914,27897,'679',3.333,5),(782,27915,27897,'79f',3.333,5),(782,27916,27897,'9fc',3.333,5),(782,27917,27897,'fc2',3.333,5),(782,27918,27897,'c22',3.333,5),(782,27919,27897,'22a',3.333,5),(782,27920,27897,'2a3',3.333,5),(782,27921,27897,'a32',3.333,5),(782,27922,27897,'32e',3.333,5),(782,27923,27897,'2eb',3.333,5),(782,27924,27897,'eb0',3.333,5),(782,27925,27897,'b07',3.333,5),(782,27926,27897,'07d',3.333,5),(782,27927,27897,'7d9',3.333,5),(783,27929,27928,'naa',100,5),(783,27930,27929,'600',3.333,5),(783,27931,27929,'000',3.333,5),(783,27932,27929,'00c',3.333,5),(783,27933,27929,'0c2',3.333,5),(783,27934,27929,'c29',3.333,5),(783,27935,27929,'294',3.333,5),(783,27936,27929,'943',3.333,5),(783,27937,27929,'43e',3.333,5),(783,27938,27929,'3e5',3.333,5),(783,27939,27929,'e5d',3.333,5),(783,27940,27929,'5d5',3.333,5),(783,27941,27929,'d58',3.333,5),(783,27942,27929,'58a',3.333,5),(783,27943,27929,'8a1',3.333,5),(783,27944,27929,'a1e',3.333,5),(783,27945,27929,'1e4',3.333,5),(783,27946,27929,'e45',3.333,5),(783,27947,27929,'450',3.333,5),(783,27948,27929,'500',3.333,5),(783,27949,27929,'009',3.333,5),(783,27950,27929,'093',3.333,5),(783,27951,27929,'937',3.333,5),(783,27952,27929,'373',3.333,5),(783,27953,27929,'737',3.333,5),(783,27954,27929,'37e',3.333,5),(783,27955,27929,'7e8',3.333,5),(783,27956,27929,'e82',3.333,5),(783,27957,27929,'820',3.333,5),(783,27958,27929,'209',3.333,5),(783,27959,27929,'09b',3.333,5),(784,27961,27960,'naa',100,5),(784,27962,27961,'600',3.333,5),(784,27963,27961,'000',3.333,5),(784,27964,27961,'00c',3.333,5),(784,27965,27961,'0c2',3.333,5),(784,27966,27961,'c29',3.333,5),(784,27967,27961,'29b',3.333,5),(784,27968,27961,'9b7',3.333,5),(784,27969,27961,'b78',3.333,5),(784,27970,27961,'788',3.333,5),(784,27971,27961,'885',3.333,5),(784,27972,27961,'85f',3.333,5),(784,27973,27961,'5fa',3.333,5),(784,27974,27961,'fa7',3.333,5),(784,27975,27961,'a79',3.333,5),(784,27976,27961,'792',3.333,5),(784,27977,27961,'92f',3.333,5),(784,27978,27961,'2f8',3.333,5),(784,27979,27961,'f8f',3.333,5),(784,27980,27961,'8f9',3.333,5),(784,27981,27961,'f91',3.333,5),(784,27982,27961,'91f',3.333,5),(784,27983,27961,'1fe',3.333,5),(784,27984,27961,'fe5',3.333,5),(784,27985,27961,'e51',3.333,5),(784,27986,27961,'51a',3.333,5),(784,27987,27961,'1a5',3.333,5),(784,27988,27961,'a52',3.333,5),(784,27989,27961,'528',3.333,5),(784,27990,27961,'28d',3.333,5),(784,27991,27961,'8d0',3.333,5),(785,27993,27992,'naa',100,5),(785,27994,27993,'600',3.333,5),(785,27995,27993,'000',3.333,5),(785,27996,27993,'00c',3.333,5),(785,27997,27993,'0c2',3.333,5),(785,27998,27993,'c29',3.333,5),(785,27999,27993,'290',3.333,5),(785,28000,27993,'90a',3.333,5),(785,28001,27993,'0aa',3.333,5),(785,28002,27993,'aa5',3.333,5),(785,28003,27993,'a50',3.333,5),(785,28004,27993,'507',3.333,5),(785,28005,27993,'072',3.333,5),(785,28006,27993,'725',3.333,5),(785,28007,27993,'259',3.333,5),(785,28008,27993,'599',3.333,5),(785,28009,27993,'99e',3.333,5),(785,28010,27993,'9e1',3.333,5),(785,28011,27993,'e1d',3.333,5),(785,28012,27993,'1d6',3.333,5),(785,28013,27993,'d6a',3.333,5),(785,28014,27993,'6ac',3.333,5),(785,28015,27993,'ac3',3.333,5),(785,28016,27993,'c35',3.333,5),(785,28017,27993,'356',3.333,5),(785,28018,27993,'567',3.333,5),(785,28019,27993,'676',3.333,5),(785,28020,27993,'767',3.333,5),(785,28021,27993,'67a',3.333,5),(785,28022,27993,'7af',3.333,5),(785,28023,27993,'af2',3.333,5),(786,28025,28024,'naa',100,5),(786,28026,28025,'600',3.333,5),(786,28027,28025,'000',3.333,5),(786,28028,28025,'00c',3.333,5),(786,28029,28025,'0c2',3.333,5),(786,28030,28025,'c29',3.333,5),(786,28031,28025,'290',3.333,5),(786,28032,28025,'905',3.333,5),(786,28033,28025,'053',3.333,5),(786,28034,28025,'538',3.333,5),(786,28035,28025,'383',3.333,5),(786,28036,28025,'83d',3.333,5),(786,28037,28025,'3da',3.333,5),(786,28038,28025,'daf',3.333,5),(786,28039,28025,'afa',3.333,5),(786,28040,28025,'fa9',3.333,5),(786,28041,28025,'a9a',3.333,5),(786,28042,28025,'9ac',3.333,5),(786,28043,28025,'aca',3.333,5),(786,28044,28025,'cac',3.333,5),(786,28045,28025,'aca',3.333,5),(786,28046,28025,'ca8',3.333,5),(786,28047,28025,'a8d',3.333,5),(786,28048,28025,'8da',3.333,5),(786,28049,28025,'da0',3.333,5),(786,28050,28025,'a0e',3.333,5),(786,28051,28025,'0ec',3.333,5),(786,28052,28025,'ecb',3.333,5),(786,28053,28025,'cbb',3.333,5),(786,28054,28025,'bb7',3.333,5),(786,28055,28025,'b70',3.333,5),(787,28057,28056,'naa',100,5),(787,28058,28057,'600',3.333,5),(787,28059,28057,'000',3.333,5),(787,28060,28057,'00c',3.333,5),(787,28061,28057,'0c2',3.333,5),(787,28062,28057,'c29',3.333,5),(787,28063,28057,'297',3.333,5),(787,28064,28057,'97e',3.333,5),(787,28065,28057,'7e6',3.333,5),(787,28066,28057,'e6b',3.333,5),(787,28067,28057,'6b0',3.333,5),(787,28068,28057,'b0b',3.333,5),(787,28069,28057,'0b6',3.333,5),(787,28070,28057,'b6d',3.333,5),(787,28071,28057,'6d4',3.333,5),(787,28072,28057,'d45',3.333,5),(787,28073,28057,'452',3.333,5),(787,28074,28057,'523',3.333,5),(787,28075,28057,'23a',3.333,5),(787,28076,28057,'3a9',3.333,5),(787,28077,28057,'a96',3.333,5),(787,28078,28057,'96c',3.333,5),(787,28079,28057,'6c6',3.333,5),(787,28080,28057,'c6a',3.333,5),(787,28081,28057,'6a6',3.333,5),(787,28082,28057,'a6f',3.333,5),(787,28083,28057,'6fa',3.333,5),(787,28084,28057,'fad',3.333,5),(787,28085,28057,'ad4',3.333,5),(787,28086,28057,'d4e',3.333,5),(787,28087,28057,'4eb',3.333,5),(788,28089,28088,'naa',100,5),(788,28090,28089,'600',3.333,5),(788,28091,28089,'000',3.333,5),(788,28092,28089,'00c',3.333,5),(788,28093,28089,'0c2',3.333,5),(788,28094,28089,'c29',3.333,5),(788,28095,28089,'29b',3.333,5),(788,28096,28089,'9ba',3.333,5),(788,28097,28089,'ba5',3.333,5),(788,28098,28089,'a58',3.333,5),(788,28099,28089,'588',3.333,5),(788,28100,28089,'88c',3.333,5),(788,28101,28089,'8cd',3.333,5),(788,28102,28089,'cd4',3.333,5),(788,28103,28089,'d4f',3.333,5),(788,28104,28089,'4fa',3.333,5),(788,28105,28089,'fab',3.333,5),(788,28106,28089,'abe',3.333,5),(788,28107,28089,'be2',3.333,5),(788,28108,28089,'e26',3.333,5),(788,28109,28089,'268',3.333,5),(788,28110,28089,'68e',3.333,5),(788,28111,28089,'8e7',3.333,5),(788,28112,28089,'e7d',3.333,5),(788,28113,28089,'7d0',3.333,5),(788,28114,28089,'d0d',3.333,5),(788,28115,28089,'0de',3.333,5),(788,28116,28089,'de1',3.333,5),(788,28117,28089,'e15',3.333,5),(788,28118,28089,'151',3.333,5),(788,28119,28089,'517',3.333,5),(789,28121,28120,'naa',100,5),(789,28122,28121,'600',3.333,5),(789,28123,28121,'000',3.333,5),(789,28124,28121,'00c',3.333,5),(789,28125,28121,'0c2',3.333,5),(789,28126,28121,'c29',3.333,5),(789,28127,28121,'296',3.333,5),(789,28128,28121,'96d',3.333,5),(789,28129,28121,'6d4',3.333,5),(789,28130,28121,'d44',3.333,5),(789,28131,28121,'440',3.333,5),(789,28132,28121,'404',3.333,5),(789,28133,28121,'040',3.333,5),(789,28134,28121,'40c',3.333,5),(789,28135,28121,'0c4',3.333,5),(789,28136,28121,'c46',3.333,5),(789,28137,28121,'46a',3.333,5),(789,28138,28121,'6a2',3.333,5),(789,28139,28121,'a27',3.333,5),(789,28140,28121,'278',3.333,5),(789,28141,28121,'78d',3.333,5),(789,28142,28121,'8df',3.333,5),(789,28143,28121,'df1',3.333,5),(789,28144,28121,'f1e',3.333,5),(789,28145,28121,'1e0',3.333,5),(789,28146,28121,'e0d',3.333,5),(789,28147,28121,'0df',3.333,5),(789,28148,28121,'df2',3.333,5),(789,28149,28121,'f21',3.333,5),(789,28150,28121,'211',3.333,5),(789,28151,28121,'11b',3.333,5),(790,28153,28152,'naa',100,5),(790,28154,28153,'600',3.333,5),(790,28155,28153,'000',3.333,5),(790,28156,28153,'00c',3.333,5),(790,28157,28153,'0c2',3.333,5),(790,28158,28153,'c29',3.333,5),(790,28159,28153,'29d',3.333,5),(790,28160,28153,'9db',3.333,5),(790,28161,28153,'db6',3.333,5),(790,28162,28153,'b6a',3.333,5),(790,28163,28153,'6af',3.333,5),(790,28164,28153,'afd',3.333,5),(790,28165,28153,'fd9',3.333,5),(790,28166,28153,'d90',3.333,5),(790,28167,28153,'903',3.333,5),(790,28168,28153,'03d',3.333,5),(790,28169,28153,'3d9',3.333,5),(790,28170,28153,'d90',3.333,5),(790,28171,28153,'907',3.333,5),(790,28172,28153,'07c',3.333,5),(790,28173,28153,'7cb',3.333,5),(790,28174,28153,'cbf',3.333,5),(790,28175,28153,'bf7',3.333,5),(790,28176,28153,'f7b',3.333,5),(790,28177,28153,'7bc',3.333,5),(790,28178,28153,'bce',3.333,5),(790,28179,28153,'cec',3.333,5),(790,28180,28153,'ec9',3.333,5),(790,28181,28153,'c91',3.333,5),(790,28182,28153,'91e',3.333,5),(790,28183,28153,'1e0',3.333,5),(791,28185,28184,'naa',100,5),(791,28186,28185,'600',3.333,5),(791,28187,28185,'000',3.333,5),(791,28188,28185,'00c',3.333,5),(791,28189,28185,'0c2',3.333,5),(791,28190,28185,'c29',3.333,5),(791,28191,28185,'29a',3.333,5),(791,28192,28185,'9ae',3.333,5),(791,28193,28185,'aee',3.333,5),(791,28194,28185,'eef',3.333,5),(791,28195,28185,'ef7',3.333,5),(791,28196,28185,'f71',3.333,5),(791,28197,28185,'712',3.333,5),(791,28198,28185,'125',3.333,5),(791,28199,28185,'25d',3.333,5),(791,28200,28185,'5d5',3.333,5),(791,28201,28185,'d58',3.333,5),(791,28202,28185,'583',3.333,5),(791,28203,28185,'830',3.333,5),(791,28204,28185,'301',3.333,5),(791,28205,28185,'019',3.333,5),(791,28206,28185,'19e',3.333,5),(791,28207,28185,'9ef',3.333,5),(791,28208,28185,'ef0',3.333,5),(791,28209,28185,'f0e',3.333,5),(791,28210,28185,'0ea',3.333,5),(791,28211,28185,'ea0',3.333,5),(791,28212,28185,'a0e',3.333,5),(791,28213,28185,'0e5',3.333,5),(791,28214,28185,'e5a',3.333,5),(791,28215,28185,'5a6',3.333,5),(792,28217,28216,'naa',100,5),(792,28218,28217,'600',3.333,5),(792,28219,28217,'000',3.333,5),(792,28220,28217,'00c',3.333,5),(792,28221,28217,'0c2',3.333,5),(792,28222,28217,'c29',3.333,5),(792,28223,28217,'290',3.333,5),(792,28224,28217,'908',3.333,5),(792,28225,28217,'082',3.333,5),(792,28226,28217,'82b',3.333,5),(792,28227,28217,'2bb',3.333,5),(792,28228,28217,'bb3',3.333,5),(792,28229,28217,'b3d',3.333,5),(792,28230,28217,'3d9',3.333,5),(792,28231,28217,'d91',3.333,5),(792,28232,28217,'91f',3.333,5),(792,28233,28217,'1f4',3.333,5),(792,28234,28217,'f4c',3.333,5),(792,28235,28217,'4c3',3.333,5),(792,28236,28217,'c3e',3.333,5),(792,28237,28217,'3ef',3.333,5),(792,28238,28217,'eff',3.333,5),(792,28239,28217,'ff0',3.333,5),(792,28240,28217,'f0c',3.333,5),(792,28241,28217,'0c9',3.333,5),(792,28242,28217,'c99',3.333,5),(792,28243,28217,'99c',3.333,5),(792,28244,28217,'9c2',3.333,5),(792,28245,28217,'c27',3.333,5),(792,28246,28217,'275',3.333,5),(792,28247,28217,'756',3.333,5),(793,28249,28248,'naa',100,5),(793,28250,28249,'600',3.333,5),(793,28251,28249,'000',3.333,5),(793,28252,28249,'00c',3.333,5),(793,28253,28249,'0c2',3.333,5),(793,28254,28249,'c29',3.333,5),(793,28255,28249,'294',3.333,5),(793,28256,28249,'94b',3.333,5),(793,28257,28249,'4b9',3.333,5),(793,28258,28249,'b96',3.333,5),(793,28259,28249,'96e',3.333,5),(793,28260,28249,'6e5',3.333,5),(793,28261,28249,'e5c',3.333,5),(793,28262,28249,'5cd',3.333,5),(793,28263,28249,'cdb',3.333,5),(793,28264,28249,'dbb',3.333,5),(793,28265,28249,'bbe',3.333,5),(793,28266,28249,'be6',3.333,5),(793,28267,28249,'e6a',3.333,5),(793,28268,28249,'6ab',3.333,5),(793,28269,28249,'ab1',3.333,5),(793,28270,28249,'b14',3.333,5),(793,28271,28249,'140',3.333,5),(793,28272,28249,'409',3.333,5),(793,28273,28249,'09c',3.333,5),(793,28274,28249,'9c1',3.333,5),(793,28275,28249,'c17',3.333,5),(793,28276,28249,'17c',3.333,5),(793,28277,28249,'7cd',3.333,5),(793,28278,28249,'cd2',3.333,5),(793,28279,28249,'d29',3.333,5),(794,28281,28280,'naa',100,5),(794,28282,28281,'600',3.333,5),(794,28283,28281,'000',3.333,5),(794,28284,28281,'00c',3.333,5),(794,28285,28281,'0c2',3.333,5),(794,28286,28281,'c29',3.333,5),(794,28287,28281,'29d',3.333,5),(794,28288,28281,'9d4',3.333,5),(794,28289,28281,'d46',3.333,5),(794,28290,28281,'460',3.333,5),(794,28291,28281,'609',3.333,5),(794,28292,28281,'095',3.333,5),(794,28293,28281,'95e',3.333,5),(794,28294,28281,'5e4',3.333,5),(794,28295,28281,'e4d',3.333,5),(794,28296,28281,'4dd',3.333,5),(794,28297,28281,'dd7',3.333,5),(794,28298,28281,'d7c',3.333,5),(794,28299,28281,'7c4',3.333,5),(794,28300,28281,'c4a',3.333,5),(794,28301,28281,'4a9',3.333,5),(794,28302,28281,'a96',3.333,5),(794,28303,28281,'96a',3.333,5),(794,28304,28281,'6ae',3.333,5),(794,28305,28281,'ae2',3.333,5),(794,28306,28281,'e24',3.333,5),(794,28307,28281,'24a',3.333,5),(794,28308,28281,'4a5',3.333,5),(794,28309,28281,'a53',3.333,5),(794,28310,28281,'530',3.333,5),(794,28311,28281,'30f',3.333,5),(795,28313,28312,'naa',100,5),(795,28314,28313,'600',3.333,5),(795,28315,28313,'000',3.333,5),(795,28316,28313,'00c',3.333,5),(795,28317,28313,'0c2',3.333,5),(795,28318,28313,'c29',3.333,5),(795,28319,28313,'292',3.333,5),(795,28320,28313,'929',3.333,5),(795,28321,28313,'294',3.333,5),(795,28322,28313,'94a',3.333,5),(795,28323,28313,'4a1',3.333,5),(795,28324,28313,'a12',3.333,5),(795,28325,28313,'122',3.333,5),(795,28326,28313,'22c',3.333,5),(795,28327,28313,'2c4',3.333,5),(795,28328,28313,'c40',3.333,5),(795,28329,28313,'40f',3.333,5),(795,28330,28313,'0fa',3.333,5),(795,28331,28313,'fab',3.333,5),(795,28332,28313,'aba',3.333,5),(795,28333,28313,'bad',3.333,5),(795,28334,28313,'ad4',3.333,5),(795,28335,28313,'d4c',3.333,5),(795,28336,28313,'4c2',3.333,5),(795,28337,28313,'c28',3.333,5),(795,28338,28313,'285',3.333,5),(795,28339,28313,'85f',3.333,5),(795,28340,28313,'5f8',3.333,5),(795,28341,28313,'f81',3.333,5),(795,28342,28313,'811',3.333,5),(795,28343,28313,'119',3.333,5),(796,28345,28344,'naa',100,5),(796,28346,28345,'600',3.333,5),(796,28347,28345,'000',3.333,5),(796,28348,28345,'00c',3.333,5),(796,28349,28345,'0c2',3.333,5),(796,28350,28345,'c29',3.333,5),(796,28351,28345,'29e',3.333,5),(796,28352,28345,'9e6',3.333,5),(796,28353,28345,'e6f',3.333,5),(796,28354,28345,'6fd',3.333,5),(796,28355,28345,'fd8',3.333,5),(796,28356,28345,'d82',3.333,5),(796,28357,28345,'820',3.333,5),(796,28358,28345,'20d',3.333,5),(796,28359,28345,'0db',3.333,5),(796,28360,28345,'dbe',3.333,5),(796,28361,28345,'be9',3.333,5),(796,28362,28345,'e9c',3.333,5),(796,28363,28345,'9ce',3.333,5),(796,28364,28345,'ced',3.333,5),(796,28365,28345,'ed8',3.333,5),(796,28366,28345,'d81',3.333,5),(796,28367,28345,'81a',3.333,5),(796,28368,28345,'1a9',3.333,5),(796,28369,28345,'a9a',3.333,5),(796,28370,28345,'9a1',3.333,5),(796,28371,28345,'a18',3.333,5),(796,28372,28345,'185',3.333,5),(796,28373,28345,'85c',3.333,5),(796,28374,28345,'5c8',3.333,5),(796,28375,28345,'c8e',3.333,5),(797,28377,28376,'naa',100,5),(797,28378,28377,'600',3.333,5),(797,28379,28377,'000',3.333,5),(797,28380,28377,'00c',3.333,5),(797,28381,28377,'0c2',3.333,5),(797,28382,28377,'c29',3.333,5),(797,28383,28377,'299',3.333,5),(797,28384,28377,'999',3.333,5),(797,28385,28377,'99e',3.333,5),(797,28386,28377,'9ef',3.333,5),(797,28387,28377,'ef1',3.333,5),(797,28388,28377,'f14',3.333,5),(797,28389,28377,'14a',3.333,5),(797,28390,28377,'4a3',3.333,5),(797,28391,28377,'a35',3.333,5),(797,28392,28377,'35e',3.333,5),(797,28393,28377,'5ef',3.333,5),(797,28394,28377,'ef8',3.333,5),(797,28395,28377,'f86',3.333,5),(797,28396,28377,'86c',3.333,5),(797,28397,28377,'6c4',3.333,5),(797,28398,28377,'c4f',3.333,5),(797,28399,28377,'4f2',3.333,5),(797,28400,28377,'f24',3.333,5),(797,28401,28377,'24b',3.333,5),(797,28402,28377,'4be',3.333,5),(797,28403,28377,'bed',3.333,5),(797,28404,28377,'ed9',3.333,5),(797,28405,28377,'d9f',3.333,5),(797,28406,28377,'9f0',3.333,5),(797,28407,28377,'f09',3.333,5),(798,28409,28408,'naa',100,5),(798,28410,28409,'600',3.333,5),(798,28411,28409,'000',3.333,5),(798,28412,28409,'00c',3.333,5),(798,28413,28409,'0c2',3.333,5),(798,28414,28409,'c29',3.333,5),(798,28415,28409,'29a',3.333,5),(798,28416,28409,'9a0',3.333,5),(798,28417,28409,'a07',3.333,5),(798,28418,28409,'07d',3.333,5),(798,28419,28409,'7dd',3.333,5),(798,28420,28409,'ddf',3.333,5),(798,28421,28409,'df4',3.333,5),(798,28422,28409,'f44',3.333,5),(798,28423,28409,'44e',3.333,5),(798,28424,28409,'4ec',3.333,5),(798,28425,28409,'ec3',3.333,5),(798,28426,28409,'c3d',3.333,5),(798,28427,28409,'3d5',3.333,5),(798,28428,28409,'d5c',3.333,5),(798,28429,28409,'5c4',3.333,5),(798,28430,28409,'c44',3.333,5),(798,28431,28409,'44d',3.333,5),(798,28432,28409,'4dd',3.333,5),(798,28433,28409,'dd2',3.333,5),(798,28434,28409,'d21',3.333,5),(798,28435,28409,'213',3.333,5),(798,28436,28409,'13f',3.333,5),(798,28437,28409,'3f6',3.333,5),(798,28438,28409,'f67',3.333,5),(798,28439,28409,'67a',3.333,5),(799,28441,28440,'naa',100,5),(799,28442,28441,'600',3.333,5),(799,28443,28441,'000',3.333,5),(799,28444,28441,'00c',3.333,5),(799,28445,28441,'0c2',3.333,5),(799,28446,28441,'c29',3.333,5),(799,28447,28441,'295',3.333,5),(799,28448,28441,'951',3.333,5),(799,28449,28441,'517',3.333,5),(799,28450,28441,'17e',3.333,5),(799,28451,28441,'7e3',3.333,5),(799,28452,28441,'e36',3.333,5),(799,28453,28441,'367',3.333,5),(799,28454,28441,'67c',3.333,5),(799,28455,28441,'7ce',3.333,5),(799,28456,28441,'ce3',3.333,5),(799,28457,28441,'e35',3.333,5),(799,28458,28441,'353',3.333,5),(799,28459,28441,'538',3.333,5),(799,28460,28441,'383',3.333,5),(799,28461,28441,'83f',3.333,5),(799,28462,28441,'3f5',3.333,5),(799,28463,28441,'f53',3.333,5),(799,28464,28441,'53e',3.333,5),(799,28465,28441,'3e2',3.333,5),(799,28466,28441,'e2c',3.333,5),(799,28467,28441,'2c1',3.333,5),(799,28468,28441,'c1b',3.333,5),(799,28469,28441,'1bf',3.333,5),(799,28470,28441,'bfd',3.333,5),(799,28471,28441,'fd8',3.333,5),(800,28473,28472,'naa',100,5),(800,28474,28473,'600',3.333,5),(800,28475,28473,'000',3.333,5),(800,28476,28473,'00c',3.333,5),(800,28477,28473,'0c2',3.333,5),(800,28478,28473,'c29',3.333,5),(800,28479,28473,'299',3.333,5),(800,28480,28473,'99c',3.333,5),(800,28481,28473,'9c9',3.333,5),(800,28482,28473,'c9f',3.333,5),(800,28483,28473,'9f8',3.333,5),(800,28484,28473,'f8c',3.333,5),(800,28485,28473,'8c7',3.333,5),(800,28486,28473,'c78',3.333,5),(800,28487,28473,'780',3.333,5),(800,28488,28473,'805',3.333,5),(800,28489,28473,'05b',3.333,5),(800,28490,28473,'5bd',3.333,5),(800,28491,28473,'bd6',3.333,5),(800,28492,28473,'d61',3.333,5),(800,28493,28473,'614',3.333,5),(800,28494,28473,'14f',3.333,5),(800,28495,28473,'4f4',3.333,5),(800,28496,28473,'f4b',3.333,5),(800,28497,28473,'4b7',3.333,5),(800,28498,28473,'b70',3.333,5),(800,28499,28473,'707',3.333,5),(800,28500,28473,'078',3.333,5),(800,28501,28473,'789',3.333,5),(800,28502,28473,'896',3.333,5),(800,28503,28473,'960',3.333,5),(801,28505,28504,'naa',100,5),(801,28506,28505,'600',3.333,5),(801,28507,28505,'000',3.333,5),(801,28508,28505,'00c',3.333,5),(801,28509,28505,'0c2',3.333,5),(801,28510,28505,'c29',3.333,5),(801,28511,28505,'29d',3.333,5),(801,28512,28505,'9d4',3.333,5),(801,28513,28505,'d4d',3.333,5),(801,28514,28505,'4da',3.333,5),(801,28515,28505,'dab',3.333,5),(801,28516,28505,'abb',3.333,5),(801,28517,28505,'bb7',3.333,5),(801,28518,28505,'b70',3.333,5),(801,28519,28505,'70c',3.333,5),(801,28520,28505,'0c3',3.333,5),(801,28521,28505,'c33',3.333,5),(801,28522,28505,'330',3.333,5),(801,28523,28505,'30b',3.333,5),(801,28524,28505,'0bd',3.333,5),(801,28525,28505,'bdd',3.333,5),(801,28526,28505,'dd4',3.333,5),(801,28527,28505,'d4a',3.333,5),(801,28528,28505,'4a4',3.333,5),(801,28529,28505,'a4c',3.333,5),(801,28530,28505,'4c4',3.333,5),(801,28531,28505,'c47',3.333,5),(801,28532,28505,'479',3.333,5),(801,28533,28505,'79e',3.333,5),(801,28534,28505,'9e4',3.333,5),(801,28535,28505,'e4f',3.333,5),(802,28537,28536,'naa',100,5),(802,28538,28537,'600',3.333,5),(802,28539,28537,'000',3.333,5),(802,28540,28537,'00c',3.333,5),(802,28541,28537,'0c2',3.333,5),(802,28542,28537,'c29',3.333,5),(802,28543,28537,'29b',3.333,5),(802,28544,28537,'9bc',3.333,5),(802,28545,28537,'bcf',3.333,5),(802,28546,28537,'cfd',3.333,5),(802,28547,28537,'fd9',3.333,5),(802,28548,28537,'d93',3.333,5),(802,28549,28537,'934',3.333,5),(802,28550,28537,'348',3.333,5),(802,28551,28537,'482',3.333,5),(802,28552,28537,'82b',3.333,5),(802,28553,28537,'2b6',3.333,5),(802,28554,28537,'b65',3.333,5),(802,28555,28537,'655',3.333,5),(802,28556,28537,'558',3.333,5),(802,28557,28537,'589',3.333,5),(802,28558,28537,'893',3.333,5),(802,28559,28537,'939',3.333,5),(802,28560,28537,'397',3.333,5),(802,28561,28537,'97a',3.333,5),(802,28562,28537,'7a6',3.333,5),(802,28563,28537,'a68',3.333,5),(802,28564,28537,'68f',3.333,5),(802,28565,28537,'8f5',3.333,5),(802,28566,28537,'f5f',3.333,5),(802,28567,28537,'5fb',3.333,5),(803,28569,28568,'naa',100,5),(803,28570,28569,'600',3.333,5),(803,28571,28569,'000',3.333,5),(803,28572,28569,'00c',3.333,5),(803,28573,28569,'0c2',3.333,5),(803,28574,28569,'c29',3.333,5),(803,28575,28569,'296',3.333,5),(803,28576,28569,'96d',3.333,5),(803,28577,28569,'6dc',3.333,5),(803,28578,28569,'dcd',3.333,5),(803,28579,28569,'cdc',3.333,5),(803,28580,28569,'dc6',3.333,5),(803,28581,28569,'c63',3.333,5),(803,28582,28569,'636',3.333,5),(803,28583,28569,'368',3.333,5),(803,28584,28569,'680',3.333,5),(803,28585,28569,'809',3.333,5),(803,28586,28569,'096',3.333,5),(803,28587,28569,'963',3.333,5),(803,28588,28569,'63b',3.333,5),(803,28589,28569,'3ba',3.333,5),(803,28590,28569,'bad',3.333,5),(803,28591,28569,'adf',3.333,5),(803,28592,28569,'df9',3.333,5),(803,28593,28569,'f9a',3.333,5),(803,28594,28569,'9a2',3.333,5),(803,28595,28569,'a2a',3.333,5),(803,28596,28569,'2a5',3.333,5),(803,28597,28569,'a57',3.333,5),(803,28598,28569,'574',3.333,5),(803,28599,28569,'74e',3.333,5),(804,28601,28600,'naa',100,5),(804,28602,28601,'600',3.333,5),(804,28603,28601,'000',3.333,5),(804,28604,28601,'00c',3.333,5),(804,28605,28601,'0c2',3.333,5),(804,28606,28601,'c29',3.333,5),(804,28607,28601,'29d',3.333,5),(804,28608,28601,'9dd',3.333,5),(804,28609,28601,'dd8',3.333,5),(804,28610,28601,'d89',3.333,5),(804,28611,28601,'89a',3.333,5),(804,28612,28601,'9a0',3.333,5),(804,28613,28601,'a0d',3.333,5),(804,28614,28601,'0d9',3.333,5),(804,28615,28601,'d9d',3.333,5),(804,28616,28601,'9db',3.333,5),(804,28617,28601,'db7',3.333,5),(804,28618,28601,'b72',3.333,5),(804,28619,28601,'721',3.333,5),(804,28620,28601,'210',3.333,5),(804,28621,28601,'104',3.333,5),(804,28622,28601,'04e',3.333,5),(804,28623,28601,'4ef',3.333,5),(804,28624,28601,'ef5',3.333,5),(804,28625,28601,'f5b',3.333,5),(804,28626,28601,'5b4',3.333,5),(804,28627,28601,'b40',3.333,5),(804,28628,28601,'40a',3.333,5),(804,28629,28601,'0ad',3.333,5),(804,28630,28601,'ad6',3.333,5),(804,28631,28601,'d66',3.333,5),(805,28633,28632,'naa',100,5),(805,28634,28633,'600',3.333,5),(805,28635,28633,'000',3.333,5),(805,28636,28633,'00c',3.333,5),(805,28637,28633,'0c2',3.333,5),(805,28638,28633,'c29',3.333,5),(805,28639,28633,'291',3.333,5),(805,28640,28633,'913',3.333,5),(805,28641,28633,'132',3.333,5),(805,28642,28633,'327',3.333,5),(805,28643,28633,'27d',3.333,5),(805,28644,28633,'7d9',3.333,5),(805,28645,28633,'d90',3.333,5),(805,28646,28633,'908',3.333,5),(805,28647,28633,'08b',3.333,5),(805,28648,28633,'8b9',3.333,5),(805,28649,28633,'b97',3.333,5),(805,28650,28633,'97d',3.333,5),(805,28651,28633,'7df',3.333,5),(805,28652,28633,'dff',3.333,5),(805,28653,28633,'ff3',3.333,5),(805,28654,28633,'f3d',3.333,5),(805,28655,28633,'3dd',3.333,5),(805,28656,28633,'ddc',3.333,5),(805,28657,28633,'dc2',3.333,5),(805,28658,28633,'c2a',3.333,5),(805,28659,28633,'2a0',3.333,5),(805,28660,28633,'a07',3.333,5),(805,28661,28633,'071',3.333,5),(805,28662,28633,'712',3.333,5),(805,28663,28633,'120',3.333,5),(806,28665,28664,'naa',100,5),(806,28666,28665,'600',3.333,5),(806,28667,28665,'000',3.333,5),(806,28668,28665,'00c',3.333,5),(806,28669,28665,'0c2',3.333,5),(806,28670,28665,'c29',3.333,5),(806,28671,28665,'295',3.333,5),(806,28672,28665,'952',3.333,5),(806,28673,28665,'52e',3.333,5),(806,28674,28665,'2e5',3.333,5),(806,28675,28665,'e55',3.333,5),(806,28676,28665,'552',3.333,5),(806,28677,28665,'524',3.333,5),(806,28678,28665,'242',3.333,5),(806,28679,28665,'426',3.333,5),(806,28680,28665,'26e',3.333,5),(806,28681,28665,'6e7',3.333,5),(806,28682,28665,'e7a',3.333,5),(806,28683,28665,'7a0',3.333,5),(806,28684,28665,'a07',3.333,5),(806,28685,28665,'073',3.333,5),(806,28686,28665,'737',3.333,5),(806,28687,28665,'379',3.333,5),(806,28688,28665,'79e',3.333,5),(806,28689,28665,'9ee',3.333,5),(806,28690,28665,'ee4',3.333,5),(806,28691,28665,'e4b',3.333,5),(806,28692,28665,'4bd',3.333,5),(806,28693,28665,'bd6',3.333,5),(806,28694,28665,'d61',3.333,5),(806,28695,28665,'61a',3.333,5),(807,28697,28696,'naa',100,5),(807,28698,28697,'600',3.333,5),(807,28699,28697,'000',3.333,5),(807,28700,28697,'00c',3.333,5),(807,28701,28697,'0c2',3.333,5),(807,28702,28697,'c29',3.333,5),(807,28703,28697,'294',3.333,5),(807,28704,28697,'94c',3.333,5),(807,28705,28697,'4c3',3.333,5),(807,28706,28697,'c36',3.333,5),(807,28707,28697,'368',3.333,5),(807,28708,28697,'685',3.333,5),(807,28709,28697,'852',3.333,5),(807,28710,28697,'524',3.333,5),(807,28711,28697,'247',3.333,5),(807,28712,28697,'47d',3.333,5),(807,28713,28697,'7d2',3.333,5),(807,28714,28697,'d27',3.333,5),(807,28715,28697,'273',3.333,5),(807,28716,28697,'735',3.333,5),(807,28717,28697,'351',3.333,5),(807,28718,28697,'51f',3.333,5),(807,28719,28697,'1f7',3.333,5),(807,28720,28697,'f7c',3.333,5),(807,28721,28697,'7c0',3.333,5),(807,28722,28697,'c0d',3.333,5),(807,28723,28697,'0d9',3.333,5),(807,28724,28697,'d95',3.333,5),(807,28725,28697,'95c',3.333,5),(807,28726,28697,'5c7',3.333,5),(807,28727,28697,'c72',3.333,5),(808,28729,28728,'naa',100,5),(808,28730,28729,'600',3.333,5),(808,28731,28729,'000',3.333,5),(808,28732,28729,'00c',3.333,5),(808,28733,28729,'0c2',3.333,5),(808,28734,28729,'c29',3.333,5),(808,28735,28729,'297',3.333,5),(808,28736,28729,'973',3.333,5),(808,28737,28729,'73f',3.333,5),(808,28738,28729,'3f0',3.333,5),(808,28739,28729,'f01',3.333,5),(808,28740,28729,'019',3.333,5),(808,28741,28729,'19f',3.333,5),(808,28742,28729,'9fa',3.333,5),(808,28743,28729,'fab',3.333,5),(808,28744,28729,'ab5',3.333,5),(808,28745,28729,'b5f',3.333,5),(808,28746,28729,'5fc',3.333,5),(808,28747,28729,'fc7',3.333,5),(808,28748,28729,'c73',3.333,5),(808,28749,28729,'734',3.333,5),(808,28750,28729,'349',3.333,5),(808,28751,28729,'49d',3.333,5),(808,28752,28729,'9d6',3.333,5),(808,28753,28729,'d65',3.333,5),(808,28754,28729,'651',3.333,5),(808,28755,28729,'518',3.333,5),(808,28756,28729,'18a',3.333,5),(808,28757,28729,'8af',3.333,5),(808,28758,28729,'afd',3.333,5),(808,28759,28729,'fd1',3.333,5),(809,28761,28760,'naa',100,5),(809,28762,28761,'600',3.333,5),(809,28763,28761,'000',3.333,5),(809,28764,28761,'00c',3.333,5),(809,28765,28761,'0c2',3.333,5),(809,28766,28761,'c29',3.333,5),(809,28767,28761,'296',3.333,5),(809,28768,28761,'967',3.333,5),(809,28769,28761,'67c',3.333,5),(809,28770,28761,'7c9',3.333,5),(809,28771,28761,'c9b',3.333,5),(809,28772,28761,'9b9',3.333,5),(809,28773,28761,'b9d',3.333,5),(809,28774,28761,'9dd',3.333,5),(809,28775,28761,'dd9',3.333,5),(809,28776,28761,'d92',3.333,5),(809,28777,28761,'929',3.333,5),(809,28778,28761,'29c',3.333,5),(809,28779,28761,'9cd',3.333,5),(809,28780,28761,'cd3',3.333,5),(809,28781,28761,'d31',3.333,5),(809,28782,28761,'319',3.333,5),(809,28783,28761,'197',3.333,5),(809,28784,28761,'973',3.333,5),(809,28785,28761,'73a',3.333,5),(809,28786,28761,'3a2',3.333,5),(809,28787,28761,'a2e',3.333,5),(809,28788,28761,'2e7',3.333,5),(809,28789,28761,'e75',3.333,5),(809,28790,28761,'753',3.333,5),(809,28791,28761,'53a',3.333,5),(810,28793,28792,'naa',100,5),(810,28794,28793,'600',3.333,5),(810,28795,28793,'000',3.333,5),(810,28796,28793,'00c',3.333,5),(810,28797,28793,'0c2',3.333,5),(810,28798,28793,'c29',3.333,5),(810,28799,28793,'29b',3.333,5),(810,28800,28793,'9b8',3.333,5),(810,28801,28793,'b8b',3.333,5),(810,28802,28793,'8b6',3.333,5),(810,28803,28793,'b6c',3.333,5),(810,28804,28793,'6c8',3.333,5),(810,28805,28793,'c89',3.333,5),(810,28806,28793,'899',3.333,5),(810,28807,28793,'995',3.333,5),(810,28808,28793,'958',3.333,5),(810,28809,28793,'589',3.333,5),(810,28810,28793,'89c',3.333,5),(810,28811,28793,'9c0',3.333,5),(810,28812,28793,'c0b',3.333,5),(810,28813,28793,'0bb',3.333,5),(810,28814,28793,'bb3',3.333,5),(810,28815,28793,'b32',3.333,5),(810,28816,28793,'321',3.333,5),(810,28817,28793,'21f',3.333,5),(810,28818,28793,'1f7',3.333,5),(810,28819,28793,'f75',3.333,5),(810,28820,28793,'751',3.333,5),(810,28821,28793,'516',3.333,5),(810,28822,28793,'163',3.333,5),(810,28823,28793,'639',3.333,5),(811,28825,28824,'naa',100,5),(811,28826,28825,'600',3.333,5),(811,28827,28825,'000',3.333,5),(811,28828,28825,'00c',3.333,5),(811,28829,28825,'0c2',3.333,5),(811,28830,28825,'c29',3.333,5),(811,28831,28825,'29e',3.333,5),(811,28832,28825,'9e0',3.333,5),(811,28833,28825,'e05',3.333,5),(811,28834,28825,'056',3.333,5),(811,28835,28825,'567',3.333,5),(811,28836,28825,'67a',3.333,5),(811,28837,28825,'7ab',3.333,5),(811,28838,28825,'ab2',3.333,5),(811,28839,28825,'b2b',3.333,5),(811,28840,28825,'2be',3.333,5),(811,28841,28825,'bee',3.333,5),(811,28842,28825,'eec',3.333,5),(811,28843,28825,'ec5',3.333,5),(811,28844,28825,'c55',3.333,5),(811,28845,28825,'55a',3.333,5),(811,28846,28825,'5ae',3.333,5),(811,28847,28825,'aeb',3.333,5),(811,28848,28825,'ebf',3.333,5),(811,28849,28825,'bf8',3.333,5),(811,28850,28825,'f8f',3.333,5),(811,28851,28825,'8fb',3.333,5),(811,28852,28825,'fbf',3.333,5),(811,28853,28825,'bf9',3.333,5),(811,28854,28825,'f97',3.333,5),(811,28855,28825,'971',3.333,5),(812,28857,28856,'naa',100,5),(812,28858,28857,'600',3.333,5),(812,28859,28857,'000',3.333,5),(812,28860,28857,'00c',3.333,5),(812,28861,28857,'0c2',3.333,5),(812,28862,28857,'c29',3.333,5),(812,28863,28857,'294',3.333,5),(812,28864,28857,'94e',3.333,5),(812,28865,28857,'4e3',3.333,5),(812,28866,28857,'e31',3.333,5),(812,28867,28857,'315',3.333,5),(812,28868,28857,'154',3.333,5),(812,28869,28857,'54e',3.333,5),(812,28870,28857,'4e8',3.333,5),(812,28871,28857,'e87',3.333,5),(812,28872,28857,'874',3.333,5),(812,28873,28857,'741',3.333,5),(812,28874,28857,'415',3.333,5),(812,28875,28857,'15c',3.333,5),(812,28876,28857,'5c3',3.333,5),(812,28877,28857,'c31',3.333,5),(812,28878,28857,'310',3.333,5),(812,28879,28857,'10e',3.333,5),(812,28880,28857,'0e2',3.333,5),(812,28881,28857,'e24',3.333,5),(812,28882,28857,'244',3.333,5),(812,28883,28857,'449',3.333,5),(812,28884,28857,'499',3.333,5),(812,28885,28857,'997',3.333,5),(812,28886,28857,'971',3.333,5),(812,28887,28857,'716',3.333,5),(813,28889,28888,'naa',100,5),(813,28890,28889,'600',3.333,5),(813,28891,28889,'000',3.333,5),(813,28892,28889,'00c',3.333,5),(813,28893,28889,'0c2',3.333,5),(813,28894,28889,'c29',3.333,5),(813,28895,28889,'290',3.333,5),(813,28896,28889,'909',3.333,5),(813,28897,28889,'097',3.333,5),(813,28898,28889,'977',3.333,5),(813,28899,28889,'77b',3.333,5),(813,28900,28889,'7b7',3.333,5),(813,28901,28889,'b7c',3.333,5),(813,28902,28889,'7ce',3.333,5),(813,28903,28889,'cef',3.333,5),(813,28904,28889,'efe',3.333,5),(813,28905,28889,'fe7',3.333,5),(813,28906,28889,'e75',3.333,5),(813,28907,28889,'75c',3.333,5),(813,28908,28889,'5cb',3.333,5),(813,28909,28889,'cbe',3.333,5),(813,28910,28889,'be5',3.333,5),(813,28911,28889,'e5e',3.333,5),(813,28912,28889,'5e1',3.333,5),(813,28913,28889,'e19',3.333,5),(813,28914,28889,'196',3.333,5),(813,28915,28889,'964',3.333,5),(813,28916,28889,'649',3.333,5),(813,28917,28889,'49f',3.333,5),(813,28918,28889,'9f3',3.333,5),(813,28919,28889,'f3d',3.333,5),(814,28921,28920,'naa',100,5),(814,28922,28921,'600',3.333,5),(814,28923,28921,'000',3.333,5),(814,28924,28921,'00c',3.333,5),(814,28925,28921,'0c2',3.333,5),(814,28926,28921,'c29',3.333,5),(814,28927,28921,'294',3.333,5),(814,28928,28921,'947',3.333,5),(814,28929,28921,'475',3.333,5),(814,28930,28921,'75a',3.333,5),(814,28931,28921,'5a7',3.333,5),(814,28932,28921,'a78',3.333,5),(814,28933,28921,'783',3.333,5),(814,28934,28921,'836',3.333,5),(814,28935,28921,'36c',3.333,5),(814,28936,28921,'6ca',3.333,5),(814,28937,28921,'ca4',3.333,5),(814,28938,28921,'a48',3.333,5),(814,28939,28921,'48b',3.333,5),(814,28940,28921,'8b5',3.333,5),(814,28941,28921,'b51',3.333,5),(814,28942,28921,'516',3.333,5),(814,28943,28921,'163',3.333,5),(814,28944,28921,'631',3.333,5),(814,28945,28921,'318',3.333,5),(814,28946,28921,'189',3.333,5),(814,28947,28921,'89f',3.333,5),(814,28948,28921,'9fe',3.333,5),(814,28949,28921,'fe9',3.333,5),(814,28950,28921,'e98',3.333,5),(814,28951,28921,'986',3.333,5),(815,28953,28952,'naa',100,5),(815,28954,28953,'600',3.333,5),(815,28955,28953,'000',3.333,5),(815,28956,28953,'00c',3.333,5),(815,28957,28953,'0c2',3.333,5),(815,28958,28953,'c29',3.333,5),(815,28959,28953,'29e',3.333,5),(815,28960,28953,'9e5',3.333,5),(815,28961,28953,'e55',3.333,5),(815,28962,28953,'55d',3.333,5),(815,28963,28953,'5da',3.333,5),(815,28964,28953,'da9',3.333,5),(815,28965,28953,'a9a',3.333,5),(815,28966,28953,'9a7',3.333,5),(815,28967,28953,'a7e',3.333,5),(815,28968,28953,'7eb',3.333,5),(815,28969,28953,'eb2',3.333,5),(815,28970,28953,'b2b',3.333,5),(815,28971,28953,'2b7',3.333,5),(815,28972,28953,'b7e',3.333,5),(815,28973,28953,'7ef',3.333,5),(815,28974,28953,'ef2',3.333,5),(815,28975,28953,'f27',3.333,5),(815,28976,28953,'27c',3.333,5),(815,28977,28953,'7c6',3.333,5),(815,28978,28953,'c67',3.333,5),(815,28979,28953,'671',3.333,5),(815,28980,28953,'71f',3.333,5),(815,28981,28953,'1f9',3.333,5),(815,28982,28953,'f9f',3.333,5),(815,28983,28953,'9f0',3.333,5),(816,28985,28984,'naa',100,5),(816,28986,28985,'600',3.333,5),(816,28987,28985,'000',3.333,5),(816,28988,28985,'00c',3.333,5),(816,28989,28985,'0c2',3.333,5),(816,28990,28985,'c29',3.333,5),(816,28991,28985,'29b',3.333,5),(816,28992,28985,'9b4',3.333,5),(816,28993,28985,'b4c',3.333,5),(816,28994,28985,'4c2',3.333,5),(816,28995,28985,'c2c',3.333,5),(816,28996,28985,'2c6',3.333,5),(816,28997,28985,'c63',3.333,5),(816,28998,28985,'63b',3.333,5),(816,28999,28985,'3b2',3.333,5),(816,29000,28985,'b20',3.333,5),(816,29001,28985,'200',3.333,5),(816,29002,28985,'001',3.333,5),(816,29003,28985,'018',3.333,5),(816,29004,28985,'181',3.333,5),(816,29005,28985,'817',3.333,5),(816,29006,28985,'178',3.333,5),(816,29007,28985,'786',3.333,5),(816,29008,28985,'869',3.333,5),(816,29009,28985,'698',3.333,5),(816,29010,28985,'984',3.333,5),(816,29011,28985,'84d',3.333,5),(816,29012,28985,'4d6',3.333,5),(816,29013,28985,'d60',3.333,5),(816,29014,28985,'60a',3.333,5),(816,29015,28985,'0a9',3.333,5),(817,29017,29016,'naa',100,5),(817,29018,29017,'600',3.333,5),(817,29019,29017,'000',3.333,5),(817,29020,29017,'00c',3.333,5),(817,29021,29017,'0c2',3.333,5),(817,29022,29017,'c29',3.333,5),(817,29023,29017,'292',3.333,5),(817,29024,29017,'921',3.333,5),(817,29025,29017,'21f',3.333,5),(817,29026,29017,'1f4',3.333,5),(817,29027,29017,'f4d',3.333,5),(817,29028,29017,'4d2',3.333,5),(817,29029,29017,'d2b',3.333,5),(817,29030,29017,'2b0',3.333,5),(817,29031,29017,'b0b',3.333,5),(817,29032,29017,'0b9',3.333,5),(817,29033,29017,'b9e',3.333,5),(817,29034,29017,'9ee',3.333,5),(817,29035,29017,'ee2',3.333,5),(817,29036,29017,'e2c',3.333,5),(817,29037,29017,'2ce',3.333,5),(817,29038,29017,'ce1',3.333,5),(817,29039,29017,'e19',3.333,5),(817,29040,29017,'198',3.333,5),(817,29041,29017,'98e',3.333,5),(817,29042,29017,'8ec',3.333,5),(817,29043,29017,'ecd',3.333,5),(817,29044,29017,'cdd',3.333,5),(817,29045,29017,'dde',3.333,5),(817,29046,29017,'dea',3.333,5),(817,29047,29017,'ea0',3.333,5),(818,29049,29048,'naa',100,5),(818,29050,29049,'600',3.333,5),(818,29051,29049,'000',3.333,5),(818,29052,29049,'00c',3.333,5),(818,29053,29049,'0c2',3.333,5),(818,29054,29049,'c29',3.333,5),(818,29055,29049,'290',3.333,5),(818,29056,29049,'903',3.333,5),(818,29057,29049,'03d',3.333,5),(818,29058,29049,'3d1',3.333,5),(818,29059,29049,'d16',3.333,5),(818,29060,29049,'169',3.333,5),(818,29061,29049,'696',3.333,5),(818,29062,29049,'96c',3.333,5),(818,29063,29049,'6c7',3.333,5),(818,29064,29049,'c7b',3.333,5),(818,29065,29049,'7b9',3.333,5),(818,29066,29049,'b98',3.333,5),(818,29067,29049,'983',3.333,5),(818,29068,29049,'831',3.333,5),(818,29069,29049,'318',3.333,5),(818,29070,29049,'18a',3.333,5),(818,29071,29049,'8aa',3.333,5),(818,29072,29049,'aae',3.333,5),(818,29073,29049,'ae2',3.333,5),(818,29074,29049,'e2f',3.333,5),(818,29075,29049,'2f0',3.333,5),(818,29076,29049,'f09',3.333,5),(818,29077,29049,'09d',3.333,5),(818,29078,29049,'9dc',3.333,5),(818,29079,29049,'dc4',3.333,5),(819,29081,29080,'naa',100,5),(819,29082,29081,'600',3.333,5),(819,29083,29081,'000',3.333,5),(819,29084,29081,'00c',3.333,5),(819,29085,29081,'0c2',3.333,5),(819,29086,29081,'c29',3.333,5),(819,29087,29081,'29b',3.333,5),(819,29088,29081,'9ba',3.333,5),(819,29089,29081,'ba7',3.333,5),(819,29090,29081,'a7a',3.333,5),(819,29091,29081,'7a8',3.333,5),(819,29092,29081,'a8e',3.333,5),(819,29093,29081,'8ed',3.333,5),(819,29094,29081,'ed1',3.333,5),(819,29095,29081,'d1b',3.333,5),(819,29096,29081,'1b3',3.333,5),(819,29097,29081,'b37',3.333,5),(819,29098,29081,'376',3.333,5),(819,29099,29081,'76a',3.333,5),(819,29100,29081,'6a1',3.333,5),(819,29101,29081,'a1a',3.333,5),(819,29102,29081,'1a5',3.333,5),(819,29103,29081,'a54',3.333,5),(819,29104,29081,'54d',3.333,5),(819,29105,29081,'4de',3.333,5),(819,29106,29081,'dec',3.333,5),(819,29107,29081,'ec2',3.333,5),(819,29108,29081,'c2e',3.333,5),(819,29109,29081,'2ee',3.333,5),(819,29110,29081,'ee8',3.333,5),(819,29111,29081,'e87',3.333,5),(820,29113,29112,'naa',100,5),(820,29114,29113,'600',3.333,5),(820,29115,29113,'000',3.333,5),(820,29116,29113,'00c',3.333,5),(820,29117,29113,'0c2',3.333,5),(820,29118,29113,'c29',3.333,5),(820,29119,29113,'29f',3.333,5),(820,29120,29113,'9fc',3.333,5),(820,29121,29113,'fc9',3.333,5),(820,29122,29113,'c94',3.333,5),(820,29123,29113,'94a',3.333,5),(820,29124,29113,'4a1',3.333,5),(820,29125,29113,'a17',3.333,5),(820,29126,29113,'179',3.333,5),(820,29127,29113,'79b',3.333,5),(820,29128,29113,'9b7',3.333,5),(820,29129,29113,'b70',3.333,5),(820,29130,29113,'70b',3.333,5),(820,29131,29113,'0b4',3.333,5),(820,29132,29113,'b4e',3.333,5),(820,29133,29113,'4ee',3.333,5),(820,29134,29113,'ee8',3.333,5),(820,29135,29113,'e8e',3.333,5),(820,29136,29113,'8ef',3.333,5),(820,29137,29113,'ef2',3.333,5),(820,29138,29113,'f2c',3.333,5),(820,29139,29113,'2cb',3.333,5),(820,29140,29113,'cbc',3.333,5),(820,29141,29113,'bc4',3.333,5),(820,29142,29113,'c4e',3.333,5),(820,29143,29113,'4e8',3.333,5),(821,29145,29144,'naa',100,5),(821,29146,29145,'600',3.333,5),(821,29147,29145,'000',3.333,5),(821,29148,29145,'00c',3.333,5),(821,29149,29145,'0c2',3.333,5),(821,29150,29145,'c29',3.333,5),(821,29151,29145,'29a',3.333,5),(821,29152,29145,'9af',3.333,5),(821,29153,29145,'afe',3.333,5),(821,29154,29145,'fe5',3.333,5),(821,29155,29145,'e5d',3.333,5),(821,29156,29145,'5d5',3.333,5),(821,29157,29145,'d55',3.333,5),(821,29158,29145,'55b',3.333,5),(821,29159,29145,'5b8',3.333,5),(821,29160,29145,'b8f',3.333,5),(821,29161,29145,'8f3',3.333,5),(821,29162,29145,'f3a',3.333,5),(821,29163,29145,'3a6',3.333,5),(821,29164,29145,'a66',3.333,5),(821,29165,29145,'662',3.333,5),(821,29166,29145,'62f',3.333,5),(821,29167,29145,'2f0',3.333,5),(821,29168,29145,'f07',3.333,5),(821,29169,29145,'07c',3.333,5),(821,29170,29145,'7c7',3.333,5),(821,29171,29145,'c7f',3.333,5),(821,29172,29145,'7fa',3.333,5),(821,29173,29145,'fae',3.333,5),(821,29174,29145,'ae2',3.333,5),(821,29175,29145,'e2c',3.333,5),(822,29177,29176,'naa',100,5),(822,29178,29177,'600',3.333,5),(822,29179,29177,'000',3.333,5),(822,29180,29177,'00c',3.333,5),(822,29181,29177,'0c2',3.333,5),(822,29182,29177,'c29',3.333,5),(822,29183,29177,'293',3.333,5),(822,29184,29177,'93d',3.333,5),(822,29185,29177,'3dc',3.333,5),(822,29186,29177,'dc4',3.333,5),(822,29187,29177,'c43',3.333,5),(822,29188,29177,'43c',3.333,5),(822,29189,29177,'3c8',3.333,5),(822,29190,29177,'c87',3.333,5),(822,29191,29177,'874',3.333,5),(822,29192,29177,'748',3.333,5),(822,29193,29177,'483',3.333,5),(822,29194,29177,'836',3.333,5),(822,29195,29177,'36a',3.333,5),(822,29196,29177,'6a2',3.333,5),(822,29197,29177,'a25',3.333,5),(822,29198,29177,'257',3.333,5),(822,29199,29177,'57b',3.333,5),(822,29200,29177,'7b3',3.333,5),(822,29201,29177,'b3b',3.333,5),(822,29202,29177,'3bf',3.333,5),(822,29203,29177,'bf4',3.333,5),(822,29204,29177,'f4c',3.333,5),(822,29205,29177,'4c5',3.333,5),(822,29206,29177,'c5f',3.333,5),(822,29207,29177,'5f8',3.333,5),(823,29221,29220,'hgw',8.333,5),(823,29222,29220,'gw2',8.333,5),(823,29223,29220,'w2k',8.333,5),(823,29224,29220,'2k8',8.333,5),(823,29225,29220,'k8r',8.333,5),(823,29226,29220,'8r2',8.333,5),(823,29227,29220,'r23',8.333,5),(823,29228,29220,'232',8.333,5),(823,29229,29220,'32v',8.333,5),(823,29230,29220,'2vm',8.333,5),(823,29231,29220,'vm1',8.333,5),(823,29232,29220,'m11',8.333,5),(824,29234,29233,'naa',100,5),(824,29235,29234,'600',3.333,5),(824,29236,29234,'000',3.333,5),(824,29237,29234,'00c',3.333,5),(824,29238,29234,'0c2',3.333,5),(824,29239,29234,'c29',3.333,5),(824,29240,29234,'29a',3.333,5),(824,29241,29234,'9a1',3.333,5),(824,29242,29234,'a17',3.333,5),(824,29243,29234,'173',3.333,5),(824,29244,29234,'737',3.333,5),(824,29245,29234,'373',3.333,5),(824,29246,29234,'733',3.333,5),(824,29247,29234,'331',3.333,5),(824,29248,29234,'31e',3.333,5),(824,29249,29234,'1e5',3.333,5),(824,29250,29234,'e5a',3.333,5),(824,29251,29234,'5a5',3.333,5),(824,29252,29234,'a59',3.333,5),(824,29253,29234,'597',3.333,5),(824,29254,29234,'97f',3.333,5),(824,29255,29234,'7f4',3.333,5),(824,29256,29234,'f48',3.333,5),(824,29257,29234,'480',3.333,5),(824,29258,29234,'802',3.333,5),(824,29259,29234,'025',3.333,5),(824,29260,29234,'253',3.333,5),(824,29261,29234,'539',3.333,5),(824,29262,29234,'399',3.333,5),(824,29263,29234,'998',3.333,5),(824,29264,29234,'980',3.333,5),(825,29266,29265,'naa',100,5),(825,29267,29266,'600',3.333,5),(825,29268,29266,'00a',3.333,5),(825,29269,29266,'0a0',3.333,5),(825,29270,29266,'a09',3.333,5),(825,29271,29266,'098',3.333,5),(825,29272,29266,'980',3.333,5),(825,29273,29266,'804',3.333,5),(825,29274,29266,'044',3.333,5),(825,29275,29266,'443',3.333,5),(825,29276,29266,'430',3.333,5),(825,29277,29266,'307',3.333,5),(825,29278,29266,'072',3.333,5),(825,29279,29266,'725',3.333,5),(825,29280,29266,'259',3.333,5),(825,29281,29266,'593',3.333,5),(825,29282,29266,'931',3.333,5),(825,29283,29266,'313',3.333,5),(825,29284,29266,'13f',3.333,5),(825,29285,29266,'3f3',3.333,5),(825,29286,29266,'f33',3.333,5),(825,29287,29266,'334',3.333,5),(825,29288,29266,'345',3.333,5),(825,29289,29266,'455',3.333,5),(825,29290,29266,'556',3.333,5),(825,29291,29266,'563',3.333,5),(825,29292,29266,'639',3.333,5),(825,29293,29266,'393',3.333,5),(825,29294,29266,'934',3.333,5),(825,29295,29266,'344',3.333,5),(825,29296,29266,'44f',3.333,5),(826,29298,29297,'naa',100,5),(826,29299,29298,'600',3.333,5),(826,29300,29298,'00a',3.333,5),(826,29301,29298,'0a0',3.333,5),(826,29302,29298,'a09',3.333,5),(826,29303,29298,'098',3.333,5),(826,29304,29298,'980',3.333,5),(826,29305,29298,'804',3.333,5),(826,29306,29298,'044',3.333,5),(826,29307,29298,'443',3.333,5),(826,29308,29298,'430',3.333,5),(826,29309,29298,'307',3.333,5),(826,29310,29298,'072',3.333,5),(826,29311,29298,'725',3.333,5),(826,29312,29298,'259',3.333,5),(826,29313,29298,'593',3.333,5),(826,29314,29298,'931',3.333,5),(826,29315,29298,'313',3.333,5),(826,29316,29298,'13f',3.333,5),(826,29317,29298,'3f3',3.333,5),(826,29318,29298,'f33',3.333,5),(826,29319,29298,'334',3.333,5),(826,29320,29298,'345',3.333,5),(826,29321,29298,'455',3.333,5),(826,29322,29298,'556',3.333,5),(826,29323,29298,'563',3.333,5),(826,29324,29298,'639',3.333,5),(826,29325,29298,'393',3.333,5),(826,29326,29298,'934',3.333,5),(826,29327,29298,'345',3.333,5),(826,29328,29298,'450',3.333,5),(827,29330,29329,'naa',100,5),(827,29331,29330,'600',3.333,5),(827,29332,29330,'00a',3.333,5),(827,29333,29330,'0a0',3.333,5),(827,29334,29330,'a09',3.333,5),(827,29335,29330,'098',3.333,5),(827,29336,29330,'980',3.333,5),(827,29337,29330,'804',3.333,5),(827,29338,29330,'044',3.333,5),(827,29339,29330,'443',3.333,5),(827,29340,29330,'430',3.333,5),(827,29341,29330,'307',3.333,5),(827,29342,29330,'075',3.333,5),(827,29343,29330,'753',3.333,5),(827,29344,29330,'535',3.333,5),(827,29345,29330,'357',3.333,5),(827,29346,29330,'573',3.333,5),(827,29347,29330,'732',3.333,5),(827,29348,29330,'32b',3.333,5),(827,29349,29330,'2b3',3.333,5),(827,29350,29330,'b33',3.333,5),(827,29351,29330,'334',3.333,5),(827,29352,29330,'345',3.333,5),(827,29353,29330,'457',3.333,5),(827,29354,29330,'571',3.333,5),(827,29355,29330,'715',3.333,5),(827,29356,29330,'153',3.333,5),(827,29357,29330,'533',3.333,5),(827,29358,29330,'336',3.333,5),(827,29359,29330,'362',3.333,5),(827,29360,29330,'62d',3.333,5),(828,29362,29361,'naa',100,5),(828,29363,29362,'600',3.333,5),(828,29364,29362,'00a',3.333,5),(828,29365,29362,'0a0',3.333,5),(828,29366,29362,'a09',3.333,5),(828,29367,29362,'098',3.333,5),(828,29368,29362,'980',3.333,5),(828,29369,29362,'804',3.333,5),(828,29370,29362,'044',3.333,5),(828,29371,29362,'443',3.333,5),(828,29372,29362,'430',3.333,5),(828,29373,29362,'307',3.333,5),(828,29374,29362,'075',3.333,5),(828,29375,29362,'753',3.333,5),(828,29376,29362,'535',3.333,5),(828,29377,29362,'357',3.333,5),(828,29378,29362,'573',3.333,5),(828,29379,29362,'732',3.333,5),(828,29380,29362,'32b',3.333,5),(828,29381,29362,'2b3',3.333,5),(828,29382,29362,'b33',3.333,5),(828,29383,29362,'334',3.333,5),(828,29384,29362,'345',3.333,5),(828,29385,29362,'457',3.333,5),(828,29386,29362,'571',3.333,5),(828,29387,29362,'715',3.333,5),(828,29388,29362,'153',3.333,5),(828,29389,29362,'533',3.333,5),(828,29390,29362,'336',3.333,5),(828,29391,29362,'364',3.333,5),(828,29392,29362,'641',3.333,5),(829,29394,29393,'naa',100,5),(829,29395,29394,'600',3.333,5),(829,29396,29394,'000',3.333,5),(829,29397,29394,'00c',3.333,5),(829,29398,29394,'0c2',3.333,5),(829,29399,29394,'c29',3.333,5),(829,29400,29394,'294',3.333,5),(829,29401,29394,'944',3.333,5),(829,29402,29394,'446',3.333,5),(829,29403,29394,'46d',3.333,5),(829,29404,29394,'6d8',3.333,5),(829,29405,29394,'d8b',3.333,5),(829,29406,29394,'8be',3.333,5),(829,29407,29394,'be4',3.333,5),(829,29408,29394,'e48',3.333,5),(829,29409,29394,'485',3.333,5),(829,29410,29394,'859',3.333,5),(829,29411,29394,'598',3.333,5),(829,29412,29394,'98a',3.333,5),(829,29413,29394,'8a2',3.333,5),(829,29414,29394,'a23',3.333,5),(829,29415,29394,'231',3.333,5),(829,29416,29394,'311',3.333,5),(829,29417,29394,'11f',3.333,5),(829,29418,29394,'1fc',3.333,5),(829,29419,29394,'fcf',3.333,5),(829,29420,29394,'cf7',3.333,5),(829,29421,29394,'f73',3.333,5),(829,29422,29394,'73a',3.333,5),(829,29423,29394,'3af',3.333,5),(829,29424,29394,'af6',3.333,5),(830,29426,29425,'naa',100,5),(830,29427,29426,'600',3.333,5),(830,29428,29426,'000',3.333,5),(830,29429,29426,'00c',3.333,5),(830,29430,29426,'0c2',3.333,5),(830,29431,29426,'c29',3.333,5),(830,29432,29426,'290',3.333,5),(830,29433,29426,'90c',3.333,5),(830,29434,29426,'0c0',3.333,5),(830,29435,29426,'c05',3.333,5),(830,29436,29426,'056',3.333,5),(830,29437,29426,'562',3.333,5),(830,29438,29426,'629',3.333,5),(830,29439,29426,'296',3.333,5),(830,29440,29426,'964',3.333,5),(830,29441,29426,'64c',3.333,5),(830,29442,29426,'4c2',3.333,5),(830,29443,29426,'c2e',3.333,5),(830,29444,29426,'2ef',3.333,5),(830,29445,29426,'ef0',3.333,5),(830,29446,29426,'f06',3.333,5),(830,29447,29426,'068',3.333,5),(830,29448,29426,'68c',3.333,5),(830,29449,29426,'8c9',3.333,5),(830,29450,29426,'c9a',3.333,5),(830,29451,29426,'9ae',3.333,5),(830,29452,29426,'aed',3.333,5),(830,29453,29426,'ed2',3.333,5),(830,29454,29426,'d2a',3.333,5),(830,29455,29426,'2aa',3.333,5),(830,29456,29426,'aab',3.333,5),(831,29458,29457,'naa',100,5),(831,29459,29458,'600',3.333,5),(831,29460,29458,'000',3.333,5),(831,29461,29458,'00c',3.333,5),(831,29462,29458,'0c2',3.333,5),(831,29463,29458,'c29',3.333,5),(831,29464,29458,'29e',3.333,5),(831,29465,29458,'9ec',3.333,5),(831,29466,29458,'ecb',3.333,5),(831,29467,29458,'cb8',3.333,5),(831,29468,29458,'b82',3.333,5),(831,29469,29458,'820',3.333,5),(831,29470,29458,'200',3.333,5),(831,29471,29458,'007',3.333,5),(831,29472,29458,'072',3.333,5),(831,29473,29458,'724',3.333,5),(831,29474,29458,'24c',3.333,5),(831,29475,29458,'4c2',3.333,5),(831,29476,29458,'c2a',3.333,5),(831,29477,29458,'2a4',3.333,5),(831,29478,29458,'a43',3.333,5),(831,29479,29458,'43c',3.333,5),(831,29480,29458,'3c3',3.333,5),(831,29481,29458,'c36',3.333,5),(831,29482,29458,'366',3.333,5),(831,29483,29458,'66c',3.333,5),(831,29484,29458,'6cc',3.333,5),(831,29485,29458,'cc0',3.333,5),(831,29486,29458,'c05',3.333,5),(831,29487,29458,'059',3.333,5),(831,29488,29458,'593',3.333,5),(832,29490,29489,'naa',100,5),(832,29491,29490,'600',3.333,5),(832,29492,29490,'000',3.333,5),(832,29493,29490,'00c',3.333,5),(832,29494,29490,'0c2',3.333,5),(832,29495,29490,'c29',3.333,5),(832,29496,29490,'291',3.333,5),(832,29497,29490,'914',3.333,5),(832,29498,29490,'140',3.333,5),(832,29499,29490,'40c',3.333,5),(832,29500,29490,'0c3',3.333,5),(832,29501,29490,'c3d',3.333,5),(832,29502,29490,'3da',3.333,5),(832,29503,29490,'dab',3.333,5),(832,29504,29490,'ab4',3.333,5),(832,29505,29490,'b45',3.333,5),(832,29506,29490,'450',3.333,5),(832,29507,29490,'501',3.333,5),(832,29508,29490,'018',3.333,5),(832,29509,29490,'185',3.333,5),(832,29510,29490,'85a',3.333,5),(832,29511,29490,'5ad',3.333,5),(832,29512,29490,'ad0',3.333,5),(832,29513,29490,'d07',3.333,5),(832,29514,29490,'075',3.333,5),(832,29515,29490,'75d',3.333,5),(832,29516,29490,'5d1',3.333,5),(832,29517,29490,'d16',3.333,5),(832,29518,29490,'163',3.333,5),(832,29519,29490,'639',3.333,5),(832,29520,29490,'390',3.333,5),(833,29522,29521,'naa',100,5),(833,29523,29522,'600',3.333,5),(833,29524,29522,'000',3.333,5),(833,29525,29522,'00c',3.333,5),(833,29526,29522,'0c2',3.333,5),(833,29527,29522,'c29',3.333,5),(833,29528,29522,'29a',3.333,5),(833,29529,29522,'9a3',3.333,5),(833,29530,29522,'a30',3.333,5),(833,29531,29522,'303',3.333,5),(833,29532,29522,'037',3.333,5),(833,29533,29522,'373',3.333,5),(833,29534,29522,'735',3.333,5),(833,29535,29522,'352',3.333,5),(833,29536,29522,'524',3.333,5),(833,29537,29522,'240',3.333,5),(833,29538,29522,'403',3.333,5),(833,29539,29522,'03e',3.333,5),(833,29540,29522,'3ee',3.333,5),(833,29541,29522,'ee1',3.333,5),(833,29542,29522,'e17',3.333,5),(833,29543,29522,'17c',3.333,5),(833,29544,29522,'7ce',3.333,5),(833,29545,29522,'ce7',3.333,5),(833,29546,29522,'e72',3.333,5),(833,29547,29522,'722',3.333,5),(833,29548,29522,'22c',3.333,5),(833,29549,29522,'2ca',3.333,5),(833,29550,29522,'cad',3.333,5),(833,29551,29522,'ad6',3.333,5),(833,29552,29522,'d69',3.333,5),(834,29554,29553,'naa',100,5),(834,29555,29554,'600',3.333,5),(834,29556,29554,'000',3.333,5),(834,29557,29554,'00c',3.333,5),(834,29558,29554,'0c2',3.333,5),(834,29559,29554,'c29',3.333,5),(834,29560,29554,'295',3.333,5),(834,29561,29554,'953',3.333,5),(834,29562,29554,'532',3.333,5),(834,29563,29554,'321',3.333,5),(834,29564,29554,'21c',3.333,5),(834,29565,29554,'1ca',3.333,5),(834,29566,29554,'ca5',3.333,5),(834,29567,29554,'a5a',3.333,5),(834,29568,29554,'5a2',3.333,5),(834,29569,29554,'a23',3.333,5),(834,29570,29554,'23b',3.333,5),(834,29571,29554,'3b0',3.333,5),(834,29572,29554,'b07',3.333,5),(834,29573,29554,'07f',3.333,5),(834,29574,29554,'7f0',3.333,5),(834,29575,29554,'f07',3.333,5),(834,29576,29554,'07a',3.333,5),(834,29577,29554,'7ae',3.333,5),(834,29578,29554,'aed',3.333,5),(834,29579,29554,'ede',3.333,5),(834,29580,29554,'def',3.333,5),(834,29581,29554,'efc',3.333,5),(834,29582,29554,'fca',3.333,5),(834,29583,29554,'ca7',3.333,5),(834,29584,29554,'a73',3.333,5),(835,29586,29585,'naa',100,5),(835,29587,29586,'600',3.333,5),(835,29588,29586,'000',3.333,5),(835,29589,29586,'00c',3.333,5),(835,29590,29586,'0c2',3.333,5),(835,29591,29586,'c29',3.333,5),(835,29592,29586,'29f',3.333,5),(835,29593,29586,'9fa',3.333,5),(835,29594,29586,'fad',3.333,5),(835,29595,29586,'adc',3.333,5),(835,29596,29586,'dca',3.333,5),(835,29597,29586,'ca4',3.333,5),(835,29598,29586,'a4c',3.333,5),(835,29599,29586,'4c6',3.333,5),(835,29600,29586,'c6c',3.333,5),(835,29601,29586,'6ce',3.333,5),(835,29602,29586,'cea',3.333,5),(835,29603,29586,'ea8',3.333,5),(835,29604,29586,'a8a',3.333,5),(835,29605,29586,'8a3',3.333,5),(835,29606,29586,'a30',3.333,5),(835,29607,29586,'304',3.333,5),(835,29608,29586,'046',3.333,5),(835,29609,29586,'46a',3.333,5),(835,29610,29586,'6ae',3.333,5),(835,29611,29586,'aee',3.333,5),(835,29612,29586,'ee5',3.333,5),(835,29613,29586,'e5e',3.333,5),(835,29614,29586,'5e3',3.333,5),(835,29615,29586,'e33',3.333,5),(835,29616,29586,'336',3.333,5),(836,29618,29617,'naa',100,5),(836,29619,29618,'600',3.333,5),(836,29620,29618,'000',3.333,5),(836,29621,29618,'00c',3.333,5),(836,29622,29618,'0c2',3.333,5),(836,29623,29618,'c29',3.333,5),(836,29624,29618,'29d',3.333,5),(836,29625,29618,'9d4',3.333,5),(836,29626,29618,'d43',3.333,5),(836,29627,29618,'43a',3.333,5),(836,29628,29618,'3a0',3.333,5),(836,29629,29618,'a06',3.333,5),(836,29630,29618,'06e',3.333,5),(836,29631,29618,'6ed',3.333,5),(836,29632,29618,'ed5',3.333,5),(836,29633,29618,'d53',3.333,5),(836,29634,29618,'53a',3.333,5),(836,29635,29618,'3a3',3.333,5),(836,29636,29618,'a38',3.333,5),(836,29637,29618,'38f',3.333,5),(836,29638,29618,'8f8',3.333,5),(836,29639,29618,'f81',3.333,5),(836,29640,29618,'81f',3.333,5),(836,29641,29618,'1fb',3.333,5),(836,29642,29618,'fb2',3.333,5),(836,29643,29618,'b2d',3.333,5),(836,29644,29618,'2de',3.333,5),(836,29645,29618,'de9',3.333,5),(836,29646,29618,'e94',3.333,5),(836,29647,29618,'943',3.333,5),(836,29648,29618,'434',3.333,5),(837,29650,29649,'naa',100,5),(837,29651,29650,'600',3.333,5),(837,29652,29650,'000',3.333,5),(837,29653,29650,'00c',3.333,5),(837,29654,29650,'0c2',3.333,5),(837,29655,29650,'c29',3.333,5),(837,29656,29650,'295',3.333,5),(837,29657,29650,'952',3.333,5),(837,29658,29650,'52b',3.333,5),(837,29659,29650,'2b0',3.333,5),(837,29660,29650,'b0f',3.333,5),(837,29661,29650,'0ff',3.333,5),(837,29662,29650,'ff0',3.333,5),(837,29663,29650,'f0b',3.333,5),(837,29664,29650,'0b8',3.333,5),(837,29665,29650,'b8f',3.333,5),(837,29666,29650,'8fc',3.333,5),(837,29667,29650,'fc5',3.333,5),(837,29668,29650,'c5f',3.333,5),(837,29669,29650,'5fb',3.333,5),(837,29670,29650,'fbf',3.333,5),(837,29671,29650,'bf4',3.333,5),(837,29672,29650,'f4c',3.333,5),(837,29673,29650,'4cd',3.333,5),(837,29674,29650,'cde',3.333,5),(837,29675,29650,'dea',3.333,5),(837,29676,29650,'eaf',3.333,5),(837,29677,29650,'afa',3.333,5),(837,29678,29650,'fa8',3.333,5),(837,29679,29650,'a83',3.333,5),(837,29680,29650,'834',3.333,5),(838,29682,29681,'naa',100,5),(838,29683,29682,'600',3.333,5),(838,29684,29682,'000',3.333,5),(838,29685,29682,'00c',3.333,5),(838,29686,29682,'0c2',3.333,5),(838,29687,29682,'c29',3.333,5),(838,29688,29682,'292',3.333,5),(838,29689,29682,'923',3.333,5),(838,29690,29682,'232',3.333,5),(838,29691,29682,'32d',3.333,5),(838,29692,29682,'2df',3.333,5),(838,29693,29682,'df3',3.333,5),(838,29694,29682,'f39',3.333,5),(838,29695,29682,'398',3.333,5),(838,29696,29682,'986',3.333,5),(838,29697,29682,'866',3.333,5),(838,29698,29682,'668',3.333,5),(838,29699,29682,'68d',3.333,5),(838,29700,29682,'8d6',3.333,5),(838,29701,29682,'d62',3.333,5),(838,29702,29682,'621',3.333,5),(838,29703,29682,'21e',3.333,5),(838,29704,29682,'1e0',3.333,5),(838,29705,29682,'e04',3.333,5),(838,29706,29682,'04f',3.333,5),(838,29707,29682,'4fa',3.333,5),(838,29708,29682,'fa5',3.333,5),(838,29709,29682,'a57',3.333,5),(838,29710,29682,'57b',3.333,5),(838,29711,29682,'7b8',3.333,5),(838,29712,29682,'b8f',3.333,5),(839,29714,29713,'naa',100,5),(839,29715,29714,'600',3.333,5),(839,29716,29714,'000',3.333,5),(839,29717,29714,'00c',3.333,5),(839,29718,29714,'0c2',3.333,5),(839,29719,29714,'c29',3.333,5),(839,29720,29714,'290',3.333,5),(839,29721,29714,'90a',3.333,5),(839,29722,29714,'0ac',3.333,5),(839,29723,29714,'ac3',3.333,5),(839,29724,29714,'c38',3.333,5),(839,29725,29714,'38c',3.333,5),(839,29726,29714,'8c3',3.333,5),(839,29727,29714,'c3c',3.333,5),(839,29728,29714,'3c8',3.333,5),(839,29729,29714,'c85',3.333,5),(839,29730,29714,'85b',3.333,5),(839,29731,29714,'5b7',3.333,5),(839,29732,29714,'b79',3.333,5),(839,29733,29714,'795',3.333,5),(839,29734,29714,'958',3.333,5),(839,29735,29714,'584',3.333,5),(839,29736,29714,'842',3.333,5),(839,29737,29714,'42d',3.333,5),(839,29738,29714,'2da',3.333,5),(839,29739,29714,'daa',3.333,5),(839,29740,29714,'aa6',3.333,5),(839,29741,29714,'a62',3.333,5),(839,29742,29714,'62d',3.333,5),(839,29743,29714,'2d3',3.333,5),(839,29744,29714,'d39',3.333,5),(840,29746,29745,'naa',100,5),(840,29747,29746,'600',3.333,5),(840,29748,29746,'000',3.333,5),(840,29749,29746,'00c',3.333,5),(840,29750,29746,'0c2',3.333,5),(840,29751,29746,'c29',3.333,5),(840,29752,29746,'298',3.333,5),(840,29753,29746,'988',3.333,5),(840,29754,29746,'88e',3.333,5),(840,29755,29746,'8e0',3.333,5),(840,29756,29746,'e09',3.333,5),(840,29757,29746,'091',3.333,5),(840,29758,29746,'91e',3.333,5),(840,29759,29746,'1ec',3.333,5),(840,29760,29746,'ecf',3.333,5),(840,29761,29746,'cf8',3.333,5),(840,29762,29746,'f82',3.333,5),(840,29763,29746,'822',3.333,5),(840,29764,29746,'224',3.333,5),(840,29765,29746,'24c',3.333,5),(840,29766,29746,'4c9',3.333,5),(840,29767,29746,'c9c',3.333,5),(840,29768,29746,'9c9',3.333,5),(840,29769,29746,'c97',3.333,5),(840,29770,29746,'979',3.333,5),(840,29771,29746,'794',3.333,5),(840,29772,29746,'945',3.333,5),(840,29773,29746,'45f',3.333,5),(840,29774,29746,'5ff',3.333,5),(840,29775,29746,'fff',3.333,5),(840,29776,29746,'ffd',3.333,5),(841,29778,29777,'naa',100,5),(841,29779,29778,'600',3.333,5),(841,29780,29778,'000',3.333,5),(841,29781,29778,'00c',3.333,5),(841,29782,29778,'0c2',3.333,5),(841,29783,29778,'c29',3.333,5),(841,29784,29778,'29d',3.333,5),(841,29785,29778,'9d2',3.333,5),(841,29786,29778,'d25',3.333,5),(841,29787,29778,'258',3.333,5),(841,29788,29778,'584',3.333,5),(841,29789,29778,'84c',3.333,5),(841,29790,29778,'4c6',3.333,5),(841,29791,29778,'c64',3.333,5),(841,29792,29778,'649',3.333,5),(841,29793,29778,'498',3.333,5),(841,29794,29778,'988',3.333,5),(841,29795,29778,'88a',3.333,5),(841,29796,29778,'8aa',3.333,5),(841,29797,29778,'aa5',3.333,5),(841,29798,29778,'a5f',3.333,5),(841,29799,29778,'5ff',3.333,5),(841,29800,29778,'ff3',3.333,5),(841,29801,29778,'f35',3.333,5),(841,29802,29778,'357',3.333,5),(841,29803,29778,'579',3.333,5),(841,29804,29778,'795',3.333,5),(841,29805,29778,'954',3.333,5),(841,29806,29778,'54a',3.333,5),(841,29807,29778,'4a3',3.333,5),(841,29808,29778,'a37',3.333,5),(842,29810,29809,'naa',100,5),(842,29811,29810,'600',3.333,5),(842,29812,29810,'000',3.333,5),(842,29813,29810,'00c',3.333,5),(842,29814,29810,'0c2',3.333,5),(842,29815,29810,'c29',3.333,5),(842,29816,29810,'297',3.333,5),(842,29817,29810,'978',3.333,5),(842,29818,29810,'789',3.333,5),(842,29819,29810,'89c',3.333,5),(842,29820,29810,'9c2',3.333,5),(842,29821,29810,'c2b',3.333,5),(842,29822,29810,'2b2',3.333,5),(842,29823,29810,'b2c',3.333,5),(842,29824,29810,'2cf',3.333,5),(842,29825,29810,'cfc',3.333,5),(842,29826,29810,'fce',3.333,5),(842,29827,29810,'ce2',3.333,5),(842,29828,29810,'e21',3.333,5),(842,29829,29810,'212',3.333,5),(842,29830,29810,'129',3.333,5),(842,29831,29810,'29e',3.333,5),(842,29832,29810,'9eb',3.333,5),(842,29833,29810,'eb5',3.333,5),(842,29834,29810,'b56',3.333,5),(842,29835,29810,'56a',3.333,5),(842,29836,29810,'6aa',3.333,5),(842,29837,29810,'aa1',3.333,5),(842,29838,29810,'a16',3.333,5),(842,29839,29810,'16c',3.333,5),(842,29840,29810,'6cb',3.333,5),(843,29842,29841,'naa',100,5),(843,29843,29842,'600',3.333,5),(843,29844,29842,'000',3.333,5),(843,29845,29842,'00c',3.333,5),(843,29846,29842,'0c2',3.333,5),(843,29847,29842,'c29',3.333,5),(843,29848,29842,'29a',3.333,5),(843,29849,29842,'9ab',3.333,5),(843,29850,29842,'ab5',3.333,5),(843,29851,29842,'b54',3.333,5),(843,29852,29842,'543',3.333,5),(843,29853,29842,'436',3.333,5),(843,29854,29842,'361',3.333,5),(843,29855,29842,'61f',3.333,5),(843,29856,29842,'1f5',3.333,5),(843,29857,29842,'f5d',3.333,5),(843,29858,29842,'5dd',3.333,5),(843,29859,29842,'dd7',3.333,5),(843,29860,29842,'d7d',3.333,5),(843,29861,29842,'7d0',3.333,5),(843,29862,29842,'d01',3.333,5),(843,29863,29842,'010',3.333,5),(843,29864,29842,'106',3.333,5),(843,29865,29842,'062',3.333,5),(843,29866,29842,'629',3.333,5),(843,29867,29842,'299',3.333,5),(843,29868,29842,'992',3.333,5),(843,29869,29842,'92c',3.333,5),(843,29870,29842,'2c7',3.333,5),(843,29871,29842,'c7e',3.333,5),(843,29872,29842,'7e8',3.333,5),(844,29874,29873,'naa',100,5),(844,29875,29874,'600',3.333,5),(844,29876,29874,'000',3.333,5),(844,29877,29874,'00c',3.333,5),(844,29878,29874,'0c2',3.333,5),(844,29879,29874,'c29',3.333,5),(844,29880,29874,'29c',3.333,5),(844,29881,29874,'9c5',3.333,5),(844,29882,29874,'c5f',3.333,5),(844,29883,29874,'5f7',3.333,5),(844,29884,29874,'f71',3.333,5),(844,29885,29874,'71d',3.333,5),(844,29886,29874,'1d3',3.333,5),(844,29887,29874,'d31',3.333,5),(844,29888,29874,'312',3.333,5),(844,29889,29874,'121',3.333,5),(844,29890,29874,'211',3.333,5),(844,29891,29874,'11c',3.333,5),(844,29892,29874,'1c8',3.333,5),(844,29893,29874,'c80',3.333,5),(844,29894,29874,'804',3.333,5),(844,29895,29874,'044',3.333,5),(844,29896,29874,'44a',3.333,5),(844,29897,29874,'4aa',3.333,5),(844,29898,29874,'aa1',3.333,5),(844,29899,29874,'a17',3.333,5),(844,29900,29874,'177',3.333,5),(844,29901,29874,'77b',3.333,5),(844,29902,29874,'7b9',3.333,5),(844,29903,29874,'b95',3.333,5),(844,29904,29874,'959',3.333,5),(845,29906,29905,'naa',100,5),(845,29907,29906,'600',3.333,5),(845,29908,29906,'000',3.333,5),(845,29909,29906,'00c',3.333,5),(845,29910,29906,'0c2',3.333,5),(845,29911,29906,'c29',3.333,5),(845,29912,29906,'291',3.333,5),(845,29913,29906,'91a',3.333,5),(845,29914,29906,'1a3',3.333,5),(845,29915,29906,'a34',3.333,5),(845,29916,29906,'343',3.333,5),(845,29917,29906,'43a',3.333,5),(845,29918,29906,'3ac',3.333,5),(845,29919,29906,'ac8',3.333,5),(845,29920,29906,'c8e',3.333,5),(845,29921,29906,'8e5',3.333,5),(845,29922,29906,'e52',3.333,5),(845,29923,29906,'528',3.333,5),(845,29924,29906,'28e',3.333,5),(845,29925,29906,'8e7',3.333,5),(845,29926,29906,'e7d',3.333,5),(845,29927,29906,'7df',3.333,5),(845,29928,29906,'df5',3.333,5),(845,29929,29906,'f55',3.333,5),(845,29930,29906,'557',3.333,5),(845,29931,29906,'57a',3.333,5),(845,29932,29906,'7a1',3.333,5),(845,29933,29906,'a13',3.333,5),(845,29934,29906,'13d',3.333,5),(845,29935,29906,'3d6',3.333,5),(845,29936,29906,'d6d',3.333,5),(846,29938,29937,'naa',100,5),(846,29939,29938,'600',3.333,5),(846,29940,29938,'000',3.333,5),(846,29941,29938,'00c',3.333,5),(846,29942,29938,'0c2',3.333,5),(846,29943,29938,'c29',3.333,5),(846,29944,29938,'292',3.333,5),(846,29945,29938,'928',3.333,5),(846,29946,29938,'28e',3.333,5),(846,29947,29938,'8ec',3.333,5),(846,29948,29938,'ec0',3.333,5),(846,29949,29938,'c00',3.333,5),(846,29950,29938,'001',3.333,5),(846,29951,29938,'011',3.333,5),(846,29952,29938,'11b',3.333,5),(846,29953,29938,'1bd',3.333,5),(846,29954,29938,'bdf',3.333,5),(846,29955,29938,'dfc',3.333,5),(846,29956,29938,'fca',3.333,5),(846,29957,29938,'ca7',3.333,5),(846,29958,29938,'a77',3.333,5),(846,29959,29938,'772',3.333,5),(846,29960,29938,'72c',3.333,5),(846,29961,29938,'2c4',3.333,5),(846,29962,29938,'c4f',3.333,5),(846,29963,29938,'4f9',3.333,5),(846,29964,29938,'f9d',3.333,5),(846,29965,29938,'9dc',3.333,5),(846,29966,29938,'dce',3.333,5),(846,29967,29938,'ce0',3.333,5),(846,29968,29938,'e07',3.333,5),(847,29970,29969,'naa',100,5),(847,29971,29970,'600',3.333,5),(847,29972,29970,'000',3.333,5),(847,29973,29970,'00c',3.333,5),(847,29974,29970,'0c2',3.333,5),(847,29975,29970,'c29',3.333,5),(847,29976,29970,'298',3.333,5),(847,29977,29970,'983',3.333,5),(847,29978,29970,'83a',3.333,5),(847,29979,29970,'3ae',3.333,5),(847,29980,29970,'ae6',3.333,5),(847,29981,29970,'e64',3.333,5),(847,29982,29970,'648',3.333,5),(847,29983,29970,'482',3.333,5),(847,29984,29970,'82f',3.333,5),(847,29985,29970,'2f7',3.333,5),(847,29986,29970,'f7d',3.333,5),(847,29987,29970,'7da',3.333,5),(847,29988,29970,'da6',3.333,5),(847,29989,29970,'a67',3.333,5),(847,29990,29970,'675',3.333,5),(847,29991,29970,'75d',3.333,5),(847,29992,29970,'5d3',3.333,5),(847,29993,29970,'d39',3.333,5),(847,29994,29970,'394',3.333,5),(847,29995,29970,'942',3.333,5),(847,29996,29970,'428',3.333,5),(847,29997,29970,'28e',3.333,5),(847,29998,29970,'8e4',3.333,5),(847,29999,29970,'e4e',3.333,5),(847,30000,29970,'4e7',3.333,5),(848,30002,30001,'naa',100,5),(848,30003,30002,'600',3.333,5),(848,30004,30002,'000',3.333,5),(848,30005,30002,'00c',3.333,5),(848,30006,30002,'0c2',3.333,5),(848,30007,30002,'c29',3.333,5),(848,30008,30002,'292',3.333,5),(848,30009,30002,'92e',3.333,5),(848,30010,30002,'2e1',3.333,5),(848,30011,30002,'e1e',3.333,5),(848,30012,30002,'1e1',3.333,5),(848,30013,30002,'e10',3.333,5),(848,30014,30002,'106',3.333,5),(848,30015,30002,'060',3.333,5),(848,30016,30002,'608',3.333,5),(848,30017,30002,'088',3.333,5),(848,30018,30002,'882',3.333,5),(848,30019,30002,'82d',3.333,5),(848,30020,30002,'2d5',3.333,5),(848,30021,30002,'d56',3.333,5),(848,30022,30002,'564',3.333,5),(848,30023,30002,'649',3.333,5),(848,30024,30002,'49b',3.333,5),(848,30025,30002,'9b0',3.333,5),(848,30026,30002,'b09',3.333,5),(848,30027,30002,'095',3.333,5),(848,30028,30002,'958',3.333,5),(848,30029,30002,'58a',3.333,5),(848,30030,30002,'8ae',3.333,5),(848,30031,30002,'aec',3.333,5),(848,30032,30002,'ecd',3.333,5),(849,30034,30033,'naa',100,5),(849,30035,30034,'600',3.333,5),(849,30036,30034,'000',3.333,5),(849,30037,30034,'00c',3.333,5),(849,30038,30034,'0c2',3.333,5),(849,30039,30034,'c29',3.333,5),(849,30040,30034,'29d',3.333,5),(849,30041,30034,'9dd',3.333,5),(849,30042,30034,'dd7',3.333,5),(849,30043,30034,'d7d',3.333,5),(849,30044,30034,'7d2',3.333,5),(849,30045,30034,'d2c',3.333,5),(849,30046,30034,'2cb',3.333,5),(849,30047,30034,'cbb',3.333,5),(849,30048,30034,'bbd',3.333,5),(849,30049,30034,'bde',3.333,5),(849,30050,30034,'de8',3.333,5),(849,30051,30034,'e8b',3.333,5),(849,30052,30034,'8bc',3.333,5),(849,30053,30034,'bcd',3.333,5),(849,30054,30034,'cd7',3.333,5),(849,30055,30034,'d79',3.333,5),(849,30056,30034,'791',3.333,5),(849,30057,30034,'91a',3.333,5),(849,30058,30034,'1a5',3.333,5),(849,30059,30034,'a58',3.333,5),(849,30060,30034,'583',3.333,5),(849,30061,30034,'833',3.333,5),(849,30062,30034,'338',3.333,5),(849,30063,30034,'38c',3.333,5),(849,30064,30034,'8cb',3.333,5),(850,30066,30065,'naa',100,5),(850,30067,30066,'600',3.333,5),(850,30068,30066,'000',3.333,5),(850,30069,30066,'00c',3.333,5),(850,30070,30066,'0c2',3.333,5),(850,30071,30066,'c29',3.333,5),(850,30072,30066,'292',3.333,5),(850,30073,30066,'92e',3.333,5),(850,30074,30066,'2ec',3.333,5),(850,30075,30066,'ec7',3.333,5),(850,30076,30066,'c7f',3.333,5),(850,30077,30066,'7ff',3.333,5),(850,30078,30066,'ffa',3.333,5),(850,30079,30066,'fa1',3.333,5),(850,30080,30066,'a1b',3.333,5),(850,30081,30066,'1be',3.333,5),(850,30082,30066,'beb',3.333,5),(850,30083,30066,'ebe',3.333,5),(850,30084,30066,'be5',3.333,5),(850,30085,30066,'e5b',3.333,5),(850,30086,30066,'5b1',3.333,5),(850,30087,30066,'b13',3.333,5),(850,30088,30066,'133',3.333,5),(850,30089,30066,'336',3.333,5),(850,30090,30066,'363',3.333,5),(850,30091,30066,'635',3.333,5),(850,30092,30066,'351',3.333,5),(850,30093,30066,'511',3.333,5),(850,30094,30066,'110',3.333,5),(850,30095,30066,'109',3.333,5),(850,30096,30066,'091',3.333,5),(851,30098,30097,'naa',100,5),(851,30099,30098,'600',3.333,5),(851,30100,30098,'000',3.333,5),(851,30101,30098,'00c',3.333,5),(851,30102,30098,'0c2',3.333,5),(851,30103,30098,'c29',3.333,5),(851,30104,30098,'299',3.333,5),(851,30105,30098,'999',3.333,5),(851,30106,30098,'995',3.333,5),(851,30107,30098,'95d',3.333,5),(851,30108,30098,'5d3',3.333,5),(851,30109,30098,'d3d',3.333,5),(851,30110,30098,'3dc',3.333,5),(851,30111,30098,'dcb',3.333,5),(851,30112,30098,'cbf',3.333,5),(851,30113,30098,'bf9',3.333,5),(851,30114,30098,'f9c',3.333,5),(851,30115,30098,'9c5',3.333,5),(851,30116,30098,'c51',3.333,5),(851,30117,30098,'519',3.333,5),(851,30118,30098,'19c',3.333,5),(851,30119,30098,'9c1',3.333,5),(851,30120,30098,'c1d',3.333,5),(851,30121,30098,'1d2',3.333,5),(851,30122,30098,'d2d',3.333,5),(851,30123,30098,'2d3',3.333,5),(851,30124,30098,'d32',3.333,5),(851,30125,30098,'32d',3.333,5),(851,30126,30098,'2d6',3.333,5),(851,30127,30098,'d6d',3.333,5),(851,30128,30098,'6d1',3.333,5),(852,30130,30129,'naa',100,5),(852,30131,30130,'600',3.333,5),(852,30132,30130,'000',3.333,5),(852,30133,30130,'00c',3.333,5),(852,30134,30130,'0c2',3.333,5),(852,30135,30130,'c29',3.333,5),(852,30136,30130,'29a',3.333,5),(852,30137,30130,'9a7',3.333,5),(852,30138,30130,'a74',3.333,5),(852,30139,30130,'740',3.333,5),(852,30140,30130,'40d',3.333,5),(852,30141,30130,'0d7',3.333,5),(852,30142,30130,'d71',3.333,5),(852,30143,30130,'71c',3.333,5),(852,30144,30130,'1ce',3.333,5),(852,30145,30130,'ce5',3.333,5),(852,30146,30130,'e54',3.333,5),(852,30147,30130,'548',3.333,5),(852,30148,30130,'48b',3.333,5),(852,30149,30130,'8bc',3.333,5),(852,30150,30130,'bc6',3.333,5),(852,30151,30130,'c61',3.333,5),(852,30152,30130,'614',3.333,5),(852,30153,30130,'146',3.333,5),(852,30154,30130,'46f',3.333,5),(852,30155,30130,'6fe',3.333,5),(852,30156,30130,'fe9',3.333,5),(852,30157,30130,'e94',3.333,5),(852,30158,30130,'94e',3.333,5),(852,30159,30130,'4e0',3.333,5),(852,30160,30130,'e05',3.333,5),(853,30162,30161,'naa',100,5),(853,30163,30162,'600',3.333,5),(853,30164,30162,'000',3.333,5),(853,30165,30162,'00c',3.333,5),(853,30166,30162,'0c2',3.333,5),(853,30167,30162,'c29',3.333,5),(853,30168,30162,'29f',3.333,5),(853,30169,30162,'9fd',3.333,5),(853,30170,30162,'fd6',3.333,5),(853,30171,30162,'d6f',3.333,5),(853,30172,30162,'6ff',3.333,5),(853,30173,30162,'ffe',3.333,5),(853,30174,30162,'fe8',3.333,5),(853,30175,30162,'e8f',3.333,5),(853,30176,30162,'8f6',3.333,5),(853,30177,30162,'f63',3.333,5),(853,30178,30162,'638',3.333,5),(853,30179,30162,'38b',3.333,5),(853,30180,30162,'8b3',3.333,5),(853,30181,30162,'b37',3.333,5),(853,30182,30162,'37c',3.333,5),(853,30183,30162,'7c6',3.333,5),(853,30184,30162,'c62',3.333,5),(853,30185,30162,'620',3.333,5),(853,30186,30162,'20e',3.333,5),(853,30187,30162,'0e3',3.333,5),(853,30188,30162,'e32',3.333,5),(853,30189,30162,'32b',3.333,5),(853,30190,30162,'2b5',3.333,5),(853,30191,30162,'b5f',3.333,5),(853,30192,30162,'5f9',3.333,5),(854,30194,30193,'naa',100,5),(854,30195,30194,'600',3.333,5),(854,30196,30194,'000',3.333,5),(854,30197,30194,'00c',3.333,5),(854,30198,30194,'0c2',3.333,5),(854,30199,30194,'c29',3.333,5),(854,30200,30194,'29e',3.333,5),(854,30201,30194,'9e5',3.333,5),(854,30202,30194,'e54',3.333,5),(854,30203,30194,'54b',3.333,5),(854,30204,30194,'4b9',3.333,5),(854,30205,30194,'b95',3.333,5),(854,30206,30194,'950',3.333,5),(854,30207,30194,'508',3.333,5),(854,30208,30194,'08d',3.333,5),(854,30209,30194,'8d9',3.333,5),(854,30210,30194,'d93',3.333,5),(854,30211,30194,'939',3.333,5),(854,30212,30194,'390',3.333,5),(854,30213,30194,'905',3.333,5),(854,30214,30194,'052',3.333,5),(854,30215,30194,'521',3.333,5),(854,30216,30194,'219',3.333,5),(854,30217,30194,'19f',3.333,5),(854,30218,30194,'9fe',3.333,5),(854,30219,30194,'fe1',3.333,5),(854,30220,30194,'e17',3.333,5),(854,30221,30194,'171',3.333,5),(854,30222,30194,'710',3.333,5),(854,30223,30194,'10c',3.333,5),(854,30224,30194,'0c0',3.333,5),(855,30226,30225,'naa',100,5),(855,30227,30226,'600',3.333,5),(855,30228,30226,'000',3.333,5),(855,30229,30226,'00c',3.333,5),(855,30230,30226,'0c2',3.333,5),(855,30231,30226,'c29',3.333,5),(855,30232,30226,'29e',3.333,5),(855,30233,30226,'9e6',3.333,5),(855,30234,30226,'e6a',3.333,5),(855,30235,30226,'6ae',3.333,5),(855,30236,30226,'aee',3.333,5),(855,30237,30226,'ee1',3.333,5),(855,30238,30226,'e12',3.333,5),(855,30239,30226,'123',3.333,5),(855,30240,30226,'234',3.333,5),(855,30241,30226,'348',3.333,5),(855,30242,30226,'48d',3.333,5),(855,30243,30226,'8d2',3.333,5),(855,30244,30226,'d28',3.333,5),(855,30245,30226,'28d',3.333,5),(855,30246,30226,'8d3',3.333,5),(855,30247,30226,'d3f',3.333,5),(855,30248,30226,'3f0',3.333,5),(855,30249,30226,'f0c',3.333,5),(855,30250,30226,'0ce',3.333,5),(855,30251,30226,'cea',3.333,5),(855,30252,30226,'eaf',3.333,5),(855,30253,30226,'af3',3.333,5),(855,30254,30226,'f3f',3.333,5),(855,30255,30226,'3f5',3.333,5),(855,30256,30226,'f54',3.333,5),(856,30258,30257,'naa',100,5),(856,30259,30258,'600',3.333,5),(856,30260,30258,'000',3.333,5),(856,30261,30258,'00c',3.333,5),(856,30262,30258,'0c2',3.333,5),(856,30263,30258,'c29',3.333,5),(856,30264,30258,'29f',3.333,5),(856,30265,30258,'9f4',3.333,5),(856,30266,30258,'f48',3.333,5),(856,30267,30258,'48c',3.333,5),(856,30268,30258,'8ca',3.333,5),(856,30269,30258,'ca9',3.333,5),(856,30270,30258,'a92',3.333,5),(856,30271,30258,'928',3.333,5),(856,30272,30258,'28d',3.333,5),(856,30273,30258,'8dc',3.333,5),(856,30274,30258,'dc5',3.333,5),(856,30275,30258,'c5a',3.333,5),(856,30276,30258,'5a8',3.333,5),(856,30277,30258,'a8e',3.333,5),(856,30278,30258,'8e5',3.333,5),(856,30279,30258,'e5f',3.333,5),(856,30280,30258,'5f2',3.333,5),(856,30281,30258,'f27',3.333,5),(856,30282,30258,'27b',3.333,5),(856,30283,30258,'7b5',3.333,5),(856,30284,30258,'b56',3.333,5),(856,30285,30258,'561',3.333,5),(856,30286,30258,'61c',3.333,5),(856,30287,30258,'1cb',3.333,5),(856,30288,30258,'cba',3.333,5),(857,30290,30289,'naa',100,5),(857,30291,30290,'600',3.333,5),(857,30292,30290,'000',3.333,5),(857,30293,30290,'00c',3.333,5),(857,30294,30290,'0c2',3.333,5),(857,30295,30290,'c29',3.333,5),(857,30296,30290,'298',3.333,5),(857,30297,30290,'989',3.333,5),(857,30298,30290,'896',3.333,5),(857,30299,30290,'96b',3.333,5),(857,30300,30290,'6ba',3.333,5),(857,30301,30290,'ba2',3.333,5),(857,30302,30290,'a22',3.333,5),(857,30303,30290,'229',3.333,5),(857,30304,30290,'297',3.333,5),(857,30305,30290,'978',3.333,5),(857,30306,30290,'78c',3.333,5),(857,30307,30290,'8cb',3.333,5),(857,30308,30290,'cb4',3.333,5),(857,30309,30290,'b4f',3.333,5),(857,30310,30290,'4f3',3.333,5),(857,30311,30290,'f34',3.333,5),(857,30312,30290,'346',3.333,5),(857,30313,30290,'465',3.333,5),(857,30314,30290,'65f',3.333,5),(857,30315,30290,'5f9',3.333,5),(857,30316,30290,'f9d',3.333,5),(857,30317,30290,'9d5',3.333,5),(857,30318,30290,'d54',3.333,5),(857,30319,30290,'549',3.333,5),(857,30320,30290,'494',3.333,5),(858,30322,30321,'naa',100,5),(858,30323,30322,'600',3.333,5),(858,30324,30322,'000',3.333,5),(858,30325,30322,'00c',3.333,5),(858,30326,30322,'0c2',3.333,5),(858,30327,30322,'c29',3.333,5),(858,30328,30322,'294',3.333,5),(858,30329,30322,'94e',3.333,5),(858,30330,30322,'4ec',3.333,5),(858,30331,30322,'ec7',3.333,5),(858,30332,30322,'c75',3.333,5),(858,30333,30322,'75f',3.333,5),(858,30334,30322,'5f8',3.333,5),(858,30335,30322,'f8c',3.333,5),(858,30336,30322,'8cb',3.333,5),(858,30337,30322,'cb3',3.333,5),(858,30338,30322,'b3c',3.333,5),(858,30339,30322,'3c9',3.333,5),(858,30340,30322,'c94',3.333,5),(858,30341,30322,'94b',3.333,5),(858,30342,30322,'4bb',3.333,5),(858,30343,30322,'bb6',3.333,5),(858,30344,30322,'b69',3.333,5),(858,30345,30322,'69b',3.333,5),(858,30346,30322,'9b2',3.333,5),(858,30347,30322,'b24',3.333,5),(858,30348,30322,'247',3.333,5),(858,30349,30322,'471',3.333,5),(858,30350,30322,'717',3.333,5),(858,30351,30322,'177',3.333,5),(858,30352,30322,'779',3.333,5),(859,30354,30353,'naa',100,5),(859,30355,30354,'600',3.333,5),(859,30356,30354,'000',3.333,5),(859,30357,30354,'00c',3.333,5),(859,30358,30354,'0c2',3.333,5),(859,30359,30354,'c29',3.333,5),(859,30360,30354,'29b',3.333,5),(859,30361,30354,'9bb',3.333,5),(859,30362,30354,'bbc',3.333,5),(859,30363,30354,'bca',3.333,5),(859,30364,30354,'ca0',3.333,5),(859,30365,30354,'a00',3.333,5),(859,30366,30354,'005',3.333,5),(859,30367,30354,'05f',3.333,5),(859,30368,30354,'5f5',3.333,5),(859,30369,30354,'f5c',3.333,5),(859,30370,30354,'5c3',3.333,5),(859,30371,30354,'c32',3.333,5),(859,30372,30354,'32a',3.333,5),(859,30373,30354,'2a0',3.333,5),(859,30374,30354,'a0e',3.333,5),(859,30375,30354,'0e3',3.333,5),(859,30376,30354,'e3b',3.333,5),(859,30377,30354,'3b7',3.333,5),(859,30378,30354,'b7c',3.333,5),(859,30379,30354,'7c8',3.333,5),(859,30380,30354,'c84',3.333,5),(859,30381,30354,'849',3.333,5),(859,30382,30354,'49f',3.333,5),(859,30383,30354,'9f4',3.333,5),(859,30384,30354,'f4f',3.333,5),(860,30386,30385,'naa',100,5),(860,30387,30386,'600',3.333,5),(860,30388,30386,'000',3.333,5),(860,30389,30386,'00c',3.333,5),(860,30390,30386,'0c2',3.333,5),(860,30391,30386,'c29',3.333,5),(860,30392,30386,'29a',3.333,5),(860,30393,30386,'9aa',3.333,5),(860,30394,30386,'aaf',3.333,5),(860,30395,30386,'af5',3.333,5),(860,30396,30386,'f50',3.333,5),(860,30397,30386,'50b',3.333,5),(860,30398,30386,'0bb',3.333,5),(860,30399,30386,'bbb',3.333,5),(860,30400,30386,'bb5',3.333,5),(860,30401,30386,'b5a',3.333,5),(860,30402,30386,'5a2',3.333,5),(860,30403,30386,'a25',3.333,5),(860,30404,30386,'258',3.333,5),(860,30405,30386,'589',3.333,5),(860,30406,30386,'892',3.333,5),(860,30407,30386,'92e',3.333,5),(860,30408,30386,'2ef',3.333,5),(860,30409,30386,'efe',3.333,5),(860,30410,30386,'fe9',3.333,5),(860,30411,30386,'e93',3.333,5),(860,30412,30386,'936',3.333,5),(860,30413,30386,'369',3.333,5),(860,30414,30386,'697',3.333,5),(860,30415,30386,'976',3.333,5),(860,30416,30386,'76a',3.333,5),(861,30418,30417,'naa',100,5),(861,30419,30418,'600',3.333,5),(861,30420,30418,'000',3.333,5),(861,30421,30418,'00c',3.333,5),(861,30422,30418,'0c2',3.333,5),(861,30423,30418,'c29',3.333,5),(861,30424,30418,'296',3.333,5),(861,30425,30418,'961',3.333,5),(861,30426,30418,'61b',3.333,5),(861,30427,30418,'1bf',3.333,5),(861,30428,30418,'bf5',3.333,5),(861,30429,30418,'f59',3.333,5),(861,30430,30418,'59b',3.333,5),(861,30431,30418,'9bb',3.333,5),(861,30432,30418,'bb3',3.333,5),(861,30433,30418,'b3b',3.333,5),(861,30434,30418,'3b1',3.333,5),(861,30435,30418,'b13',3.333,5),(861,30436,30418,'13d',3.333,5),(861,30437,30418,'3d3',3.333,5),(861,30438,30418,'d35',3.333,5),(861,30439,30418,'357',3.333,5),(861,30440,30418,'571',3.333,5),(861,30441,30418,'717',3.333,5),(861,30442,30418,'174',3.333,5),(861,30443,30418,'74d',3.333,5),(861,30444,30418,'4db',3.333,5),(861,30445,30418,'db4',3.333,5),(861,30446,30418,'b4a',3.333,5),(861,30447,30418,'4a4',3.333,5),(861,30448,30418,'a41',3.333,5),(862,30450,30449,'naa',100,5),(862,30451,30450,'600',3.333,5),(862,30452,30450,'000',3.333,5),(862,30453,30450,'00c',3.333,5),(862,30454,30450,'0c2',3.333,5),(862,30455,30450,'c29',3.333,5),(862,30456,30450,'298',3.333,5),(862,30457,30450,'982',3.333,5),(862,30458,30450,'82b',3.333,5),(862,30459,30450,'2b8',3.333,5),(862,30460,30450,'b89',3.333,5),(862,30461,30450,'895',3.333,5),(862,30462,30450,'957',3.333,5),(862,30463,30450,'57b',3.333,5),(862,30464,30450,'7be',3.333,5),(862,30465,30450,'be5',3.333,5),(862,30466,30450,'e55',3.333,5),(862,30467,30450,'551',3.333,5),(862,30468,30450,'514',3.333,5),(862,30469,30450,'146',3.333,5),(862,30470,30450,'460',3.333,5),(862,30471,30450,'601',3.333,5),(862,30472,30450,'01f',3.333,5),(862,30473,30450,'1fd',3.333,5),(862,30474,30450,'fd8',3.333,5),(862,30475,30450,'d86',3.333,5),(862,30476,30450,'861',3.333,5),(862,30477,30450,'61b',3.333,5),(862,30478,30450,'1b7',3.333,5),(862,30479,30450,'b77',3.333,5),(862,30480,30450,'775',3.333,5),(863,30482,30481,'naa',100,5),(863,30483,30482,'600',3.333,5),(863,30484,30482,'000',3.333,5),(863,30485,30482,'00c',3.333,5),(863,30486,30482,'0c2',3.333,5),(863,30487,30482,'c29',3.333,5),(863,30488,30482,'293',3.333,5),(863,30489,30482,'930',3.333,5),(863,30490,30482,'300',3.333,5),(863,30491,30482,'007',3.333,5),(863,30492,30482,'077',3.333,5),(863,30493,30482,'77f',3.333,5),(863,30494,30482,'7f3',3.333,5),(863,30495,30482,'f3b',3.333,5),(863,30496,30482,'3ba',3.333,5),(863,30497,30482,'ba9',3.333,5),(863,30498,30482,'a9a',3.333,5),(863,30499,30482,'9ab',3.333,5),(863,30500,30482,'ab2',3.333,5),(863,30501,30482,'b21',3.333,5),(863,30502,30482,'213',3.333,5),(863,30503,30482,'134',3.333,5),(863,30504,30482,'34f',3.333,5),(863,30505,30482,'4fa',3.333,5),(863,30506,30482,'fa8',3.333,5),(863,30507,30482,'a8c',3.333,5),(863,30508,30482,'8cc',3.333,5),(863,30509,30482,'cc4',3.333,5),(863,30510,30482,'c46',3.333,5),(863,30511,30482,'462',3.333,5),(863,30512,30482,'624',3.333,5),(864,30514,30513,'naa',100,5),(864,30515,30514,'600',3.333,5),(864,30516,30514,'000',3.333,5),(864,30517,30514,'00c',3.333,5),(864,30518,30514,'0c2',3.333,5),(864,30519,30514,'c29',3.333,5),(864,30520,30514,'29b',3.333,5),(864,30521,30514,'9b5',3.333,5),(864,30522,30514,'b57',3.333,5),(864,30523,30514,'57a',3.333,5),(864,30524,30514,'7ad',3.333,5),(864,30525,30514,'ad7',3.333,5),(864,30526,30514,'d76',3.333,5),(864,30527,30514,'763',3.333,5),(864,30528,30514,'639',3.333,5),(864,30529,30514,'397',3.333,5),(864,30530,30514,'97d',3.333,5),(864,30531,30514,'7d0',3.333,5),(864,30532,30514,'d0f',3.333,5),(864,30533,30514,'0f4',3.333,5),(864,30534,30514,'f4d',3.333,5),(864,30535,30514,'4df',3.333,5),(864,30536,30514,'df3',3.333,5),(864,30537,30514,'f38',3.333,5),(864,30538,30514,'38d',3.333,5),(864,30539,30514,'8d6',3.333,5),(864,30540,30514,'d63',3.333,5),(864,30541,30514,'638',3.333,5),(864,30542,30514,'381',3.333,5),(864,30543,30514,'81f',3.333,5),(864,30544,30514,'1ff',3.333,5),(865,30546,30545,'naa',100,5),(865,30547,30546,'600',3.333,5),(865,30548,30546,'000',3.333,5),(865,30549,30546,'00c',3.333,5),(865,30550,30546,'0c2',3.333,5),(865,30551,30546,'c29',3.333,5),(865,30552,30546,'298',3.333,5),(865,30553,30546,'981',3.333,5),(865,30554,30546,'812',3.333,5),(865,30555,30546,'12a',3.333,5),(865,30556,30546,'2a2',3.333,5),(865,30557,30546,'a2a',3.333,5),(865,30558,30546,'2ae',3.333,5),(865,30559,30546,'aed',3.333,5),(865,30560,30546,'ed3',3.333,5),(865,30561,30546,'d38',3.333,5),(865,30562,30546,'38a',3.333,5),(865,30563,30546,'8ae',3.333,5),(865,30564,30546,'aef',3.333,5),(865,30565,30546,'ef1',3.333,5),(865,30566,30546,'f11',3.333,5),(865,30567,30546,'118',3.333,5),(865,30568,30546,'18c',3.333,5),(865,30569,30546,'8c4',3.333,5),(865,30570,30546,'c4d',3.333,5),(865,30571,30546,'4dc',3.333,5),(865,30572,30546,'dcf',3.333,5),(865,30573,30546,'cf9',3.333,5),(865,30574,30546,'f94',3.333,5),(865,30575,30546,'944',3.333,5),(865,30576,30546,'44a',3.333,5),(866,30578,30577,'naa',100,5),(866,30579,30578,'600',3.333,5),(866,30580,30578,'000',3.333,5),(866,30581,30578,'00c',3.333,5),(866,30582,30578,'0c2',3.333,5),(866,30583,30578,'c29',3.333,5),(866,30584,30578,'29d',3.333,5),(866,30585,30578,'9d8',3.333,5),(866,30586,30578,'d88',3.333,5),(866,30587,30578,'880',3.333,5),(866,30588,30578,'80c',3.333,5),(866,30589,30578,'0c9',3.333,5),(866,30590,30578,'c9b',3.333,5),(866,30591,30578,'9b7',3.333,5),(866,30592,30578,'b78',3.333,5),(866,30593,30578,'78d',3.333,5),(866,30594,30578,'8d3',3.333,5),(866,30595,30578,'d30',3.333,5),(866,30596,30578,'301',3.333,5),(866,30597,30578,'018',3.333,5),(866,30598,30578,'189',3.333,5),(866,30599,30578,'89e',3.333,5),(866,30600,30578,'9e6',3.333,5),(866,30601,30578,'e62',3.333,5),(866,30602,30578,'623',3.333,5),(866,30603,30578,'238',3.333,5),(866,30604,30578,'38c',3.333,5),(866,30605,30578,'8c3',3.333,5),(866,30606,30578,'c36',3.333,5),(866,30607,30578,'367',3.333,5),(866,30608,30578,'670',3.333,5),(867,30610,30609,'naa',100,5),(867,30611,30610,'600',3.333,5),(867,30612,30610,'000',3.333,5),(867,30613,30610,'00c',3.333,5),(867,30614,30610,'0c2',3.333,5),(867,30615,30610,'c29',3.333,5),(867,30616,30610,'298',3.333,5),(867,30617,30610,'98e',3.333,5),(867,30618,30610,'8ea',3.333,5),(867,30619,30610,'eaa',3.333,5),(867,30620,30610,'aa2',3.333,5),(867,30621,30610,'a2a',3.333,5),(867,30622,30610,'2ab',3.333,5),(867,30623,30610,'ab5',3.333,5),(867,30624,30610,'b5d',3.333,5),(867,30625,30610,'5de',3.333,5),(867,30626,30610,'de5',3.333,5),(867,30627,30610,'e50',3.333,5),(867,30628,30610,'509',3.333,5),(867,30629,30610,'09f',3.333,5),(867,30630,30610,'9f8',3.333,5),(867,30631,30610,'f83',3.333,5),(867,30632,30610,'831',3.333,5),(867,30633,30610,'310',3.333,5),(867,30634,30610,'10c',3.333,5),(867,30635,30610,'0c7',3.333,5),(867,30636,30610,'c72',3.333,5),(867,30637,30610,'727',3.333,5),(867,30638,30610,'27b',3.333,5),(867,30639,30610,'7bc',3.333,5),(867,30640,30610,'bc3',3.333,5),(868,30642,30641,'naa',100,5),(868,30643,30642,'600',3.333,5),(868,30644,30642,'000',3.333,5),(868,30645,30642,'00c',3.333,5),(868,30646,30642,'0c2',3.333,5),(868,30647,30642,'c29',3.333,5),(868,30648,30642,'291',3.333,5),(868,30649,30642,'919',3.333,5),(868,30650,30642,'19e',3.333,5),(868,30651,30642,'9eb',3.333,5),(868,30652,30642,'eb5',3.333,5),(868,30653,30642,'b54',3.333,5),(868,30654,30642,'54d',3.333,5),(868,30655,30642,'4d4',3.333,5),(868,30656,30642,'d4b',3.333,5),(868,30657,30642,'4bb',3.333,5),(868,30658,30642,'bb7',3.333,5),(868,30659,30642,'b75',3.333,5),(868,30660,30642,'75e',3.333,5),(868,30661,30642,'5ea',3.333,5),(868,30662,30642,'ea1',3.333,5),(868,30663,30642,'a18',3.333,5),(868,30664,30642,'18a',3.333,5),(868,30665,30642,'8a8',3.333,5),(868,30666,30642,'a8f',3.333,5),(868,30667,30642,'8f9',3.333,5),(868,30668,30642,'f9e',3.333,5),(868,30669,30642,'9e3',3.333,5),(868,30670,30642,'e3b',3.333,5),(868,30671,30642,'3b6',3.333,5),(868,30672,30642,'b67',3.333,5),(869,30674,30673,'naa',100,5),(869,30675,30674,'600',3.333,5),(869,30676,30674,'000',3.333,5),(869,30677,30674,'00c',3.333,5),(869,30678,30674,'0c2',3.333,5),(869,30679,30674,'c29',3.333,5),(869,30680,30674,'295',3.333,5),(869,30681,30674,'95e',3.333,5),(869,30682,30674,'5e3',3.333,5),(869,30683,30674,'e3f',3.333,5),(869,30684,30674,'3f6',3.333,5),(869,30685,30674,'f6c',3.333,5),(869,30686,30674,'6ce',3.333,5),(869,30687,30674,'ce2',3.333,5),(869,30688,30674,'e22',3.333,5),(869,30689,30674,'22c',3.333,5),(869,30690,30674,'2c6',3.333,5),(869,30691,30674,'c64',3.333,5),(869,30692,30674,'643',3.333,5),(869,30693,30674,'437',3.333,5),(869,30694,30674,'375',3.333,5),(869,30695,30674,'756',3.333,5),(869,30696,30674,'56d',3.333,5),(869,30697,30674,'6de',3.333,5),(869,30698,30674,'deb',3.333,5),(869,30699,30674,'eb0',3.333,5),(869,30700,30674,'b04',3.333,5),(869,30701,30674,'045',3.333,5),(869,30702,30674,'459',3.333,5),(869,30703,30674,'591',3.333,5),(869,30704,30674,'910',3.333,5),(870,30706,30705,'naa',100,5),(870,30707,30706,'600',3.333,5),(870,30708,30706,'000',3.333,5),(870,30709,30706,'00c',3.333,5),(870,30710,30706,'0c2',3.333,5),(870,30711,30706,'c29',3.333,5),(870,30712,30706,'298',3.333,5),(870,30713,30706,'987',3.333,5),(870,30714,30706,'87e',3.333,5),(870,30715,30706,'7e7',3.333,5),(870,30716,30706,'e75',3.333,5),(870,30717,30706,'755',3.333,5),(870,30718,30706,'551',3.333,5),(870,30719,30706,'51e',3.333,5),(870,30720,30706,'1e6',3.333,5),(870,30721,30706,'e65',3.333,5),(870,30722,30706,'653',3.333,5),(870,30723,30706,'534',3.333,5),(870,30724,30706,'347',3.333,5),(870,30725,30706,'475',3.333,5),(870,30726,30706,'752',3.333,5),(870,30727,30706,'52f',3.333,5),(870,30728,30706,'2f1',3.333,5),(870,30729,30706,'f1b',3.333,5),(870,30730,30706,'1b3',3.333,5),(870,30731,30706,'b37',3.333,5),(870,30732,30706,'379',3.333,5),(870,30733,30706,'792',3.333,5),(870,30734,30706,'921',3.333,5),(870,30735,30706,'216',3.333,5),(870,30736,30706,'166',3.333,5),(871,30738,30737,'naa',100,5),(871,30739,30738,'600',3.333,5),(871,30740,30738,'000',3.333,5),(871,30741,30738,'00c',3.333,5),(871,30742,30738,'0c2',3.333,5),(871,30743,30738,'c29',3.333,5),(871,30744,30738,'29b',3.333,5),(871,30745,30738,'9b6',3.333,5),(871,30746,30738,'b6c',3.333,5),(871,30747,30738,'6c9',3.333,5),(871,30748,30738,'c93',3.333,5),(871,30749,30738,'932',3.333,5),(871,30750,30738,'32b',3.333,5),(871,30751,30738,'2b2',3.333,5),(871,30752,30738,'b24',3.333,5),(871,30753,30738,'245',3.333,5),(871,30754,30738,'45b',3.333,5),(871,30755,30738,'5b0',3.333,5),(871,30756,30738,'b0a',3.333,5),(871,30757,30738,'0a1',3.333,5),(871,30758,30738,'a1d',3.333,5),(871,30759,30738,'1d3',3.333,5),(871,30760,30738,'d33',3.333,5),(871,30761,30738,'337',3.333,5),(871,30762,30738,'37c',3.333,5),(871,30763,30738,'7cf',3.333,5),(871,30764,30738,'cf0',3.333,5),(871,30765,30738,'f0d',3.333,5),(871,30766,30738,'0d4',3.333,5),(871,30767,30738,'d49',3.333,5),(871,30768,30738,'499',3.333,5),(872,30770,30769,'naa',100,5),(872,30771,30770,'600',3.333,5),(872,30772,30770,'000',3.333,5),(872,30773,30770,'00c',3.333,5),(872,30774,30770,'0c2',3.333,5),(872,30775,30770,'c29',3.333,5),(872,30776,30770,'29e',3.333,5),(872,30777,30770,'9e6',3.333,5),(872,30778,30770,'e68',3.333,5),(872,30779,30770,'68f',3.333,5),(872,30780,30770,'8f6',3.333,5),(872,30781,30770,'f62',3.333,5),(872,30782,30770,'624',3.333,5),(872,30783,30770,'24e',3.333,5),(872,30784,30770,'4ed',3.333,5),(872,30785,30770,'ed3',3.333,5),(872,30786,30770,'d30',3.333,5),(872,30787,30770,'301',3.333,5),(872,30788,30770,'011',3.333,5),(872,30789,30770,'11a',3.333,5),(872,30790,30770,'1af',3.333,5),(872,30791,30770,'af7',3.333,5),(872,30792,30770,'f72',3.333,5),(872,30793,30770,'728',3.333,5),(872,30794,30770,'289',3.333,5),(872,30795,30770,'896',3.333,5),(872,30796,30770,'96a',3.333,5),(872,30797,30770,'6a6',3.333,5),(872,30798,30770,'a64',3.333,5),(872,30799,30770,'64f',3.333,5),(872,30800,30770,'4f7',3.333,5),(873,30802,30801,'naa',100,5),(873,30803,30802,'600',3.333,5),(873,30804,30802,'000',3.333,5),(873,30805,30802,'00c',3.333,5),(873,30806,30802,'0c2',3.333,5),(873,30807,30802,'c29',3.333,5),(873,30808,30802,'29b',3.333,5),(873,30809,30802,'9b0',3.333,5),(873,30810,30802,'b09',3.333,5),(873,30811,30802,'09b',3.333,5),(873,30812,30802,'9bc',3.333,5),(873,30813,30802,'bc5',3.333,5),(873,30814,30802,'c57',3.333,5),(873,30815,30802,'576',3.333,5),(873,30816,30802,'76a',3.333,5),(873,30817,30802,'6a5',3.333,5),(873,30818,30802,'a59',3.333,5),(873,30819,30802,'592',3.333,5),(873,30820,30802,'92e',3.333,5),(873,30821,30802,'2e0',3.333,5),(873,30822,30802,'e0d',3.333,5),(873,30823,30802,'0d3',3.333,5),(873,30824,30802,'d3b',3.333,5),(873,30825,30802,'3b5',3.333,5),(873,30826,30802,'b5e',3.333,5),(873,30827,30802,'5e7',3.333,5),(873,30828,30802,'e7f',3.333,5),(873,30829,30802,'7ff',3.333,5),(873,30830,30802,'ff6',3.333,5),(873,30831,30802,'f6d',3.333,5),(873,30832,30802,'6d4',3.333,5),(874,30834,30833,'naa',100,5),(874,30835,30834,'600',3.333,5),(874,30836,30834,'000',3.333,5),(874,30837,30834,'00c',3.333,5),(874,30838,30834,'0c2',3.333,5),(874,30839,30834,'c29',3.333,5),(874,30840,30834,'297',3.333,5),(874,30841,30834,'97f',3.333,5),(874,30842,30834,'7fe',3.333,5),(874,30843,30834,'fe4',3.333,5),(874,30844,30834,'e44',3.333,5),(874,30845,30834,'449',3.333,5),(874,30846,30834,'499',3.333,5),(874,30847,30834,'993',3.333,5),(874,30848,30834,'939',3.333,5),(874,30849,30834,'39f',3.333,5),(874,30850,30834,'9fa',3.333,5),(874,30851,30834,'fa1',3.333,5),(874,30852,30834,'a1a',3.333,5),(874,30853,30834,'1a2',3.333,5),(874,30854,30834,'a23',3.333,5),(874,30855,30834,'231',3.333,5),(874,30856,30834,'318',3.333,5),(874,30857,30834,'187',3.333,5),(874,30858,30834,'871',3.333,5),(874,30859,30834,'719',3.333,5),(874,30860,30834,'197',3.333,5),(874,30861,30834,'97d',3.333,5),(874,30862,30834,'7dc',3.333,5),(874,30863,30834,'dc0',3.333,5),(874,30864,30834,'c05',3.333,5),(875,30866,30865,'naa',100,5),(875,30867,30866,'600',3.333,5),(875,30868,30866,'000',3.333,5),(875,30869,30866,'00c',3.333,5),(875,30870,30866,'0c2',3.333,5),(875,30871,30866,'c29',3.333,5),(875,30872,30866,'29b',3.333,5),(875,30873,30866,'9bf',3.333,5),(875,30874,30866,'bfc',3.333,5),(875,30875,30866,'fce',3.333,5),(875,30876,30866,'cef',3.333,5),(875,30877,30866,'efd',3.333,5),(875,30878,30866,'fdb',3.333,5),(875,30879,30866,'db0',3.333,5),(875,30880,30866,'b01',3.333,5),(875,30881,30866,'01d',3.333,5),(875,30882,30866,'1d7',3.333,5),(875,30883,30866,'d71',3.333,5),(875,30884,30866,'71a',3.333,5),(875,30885,30866,'1ac',3.333,5),(875,30886,30866,'acb',3.333,5),(875,30887,30866,'cb8',3.333,5),(875,30888,30866,'b80',3.333,5),(875,30889,30866,'809',3.333,5),(875,30890,30866,'090',3.333,5),(875,30891,30866,'90d',3.333,5),(875,30892,30866,'0dc',3.333,5),(875,30893,30866,'dc8',3.333,5),(875,30894,30866,'c8b',3.333,5),(875,30895,30866,'8b7',3.333,5),(875,30896,30866,'b7d',3.333,5),(876,30898,30897,'naa',100,5),(876,30899,30898,'600',3.333,5),(876,30900,30898,'000',3.333,5),(876,30901,30898,'00c',3.333,5),(876,30902,30898,'0c2',3.333,5),(876,30903,30898,'c29',3.333,5),(876,30904,30898,'298',3.333,5),(876,30905,30898,'987',3.333,5),(876,30906,30898,'873',3.333,5),(876,30907,30898,'730',3.333,5),(876,30908,30898,'30a',3.333,5),(876,30909,30898,'0a9',3.333,5),(876,30910,30898,'a93',3.333,5),(876,30911,30898,'935',3.333,5),(876,30912,30898,'35e',3.333,5),(876,30913,30898,'5ef',3.333,5),(876,30914,30898,'ef2',3.333,5),(876,30915,30898,'f28',3.333,5),(876,30916,30898,'28f',3.333,5),(876,30917,30898,'8fb',3.333,5),(876,30918,30898,'fb3',3.333,5),(876,30919,30898,'b35',3.333,5),(876,30920,30898,'351',3.333,5),(876,30921,30898,'51d',3.333,5),(876,30922,30898,'1de',3.333,5),(876,30923,30898,'de7',3.333,5),(876,30924,30898,'e76',3.333,5),(876,30925,30898,'76d',3.333,5),(876,30926,30898,'6d3',3.333,5),(876,30927,30898,'d39',3.333,5),(876,30928,30898,'397',3.333,5),(877,30930,30929,'naa',100,5),(877,30931,30930,'600',3.333,5),(877,30932,30930,'000',3.333,5),(877,30933,30930,'00c',3.333,5),(877,30934,30930,'0c2',3.333,5),(877,30935,30930,'c29',3.333,5),(877,30936,30930,'29e',3.333,5),(877,30937,30930,'9e9',3.333,5),(877,30938,30930,'e96',3.333,5),(877,30939,30930,'961',3.333,5),(877,30940,30930,'616',3.333,5),(877,30941,30930,'166',3.333,5),(877,30942,30930,'668',3.333,5),(877,30943,30930,'689',3.333,5),(877,30944,30930,'89b',3.333,5),(877,30945,30930,'9b1',3.333,5),(877,30946,30930,'b1a',3.333,5),(877,30947,30930,'1a5',3.333,5),(877,30948,30930,'a50',3.333,5),(877,30949,30930,'503',3.333,5),(877,30950,30930,'034',3.333,5),(877,30951,30930,'340',3.333,5),(877,30952,30930,'40c',3.333,5),(877,30953,30930,'0c8',3.333,5),(877,30954,30930,'c81',3.333,5),(877,30955,30930,'81f',3.333,5),(877,30956,30930,'1f7',3.333,5),(877,30957,30930,'f7f',3.333,5),(877,30958,30930,'7f9',3.333,5),(877,30959,30930,'f96',3.333,5),(877,30960,30930,'96c',3.333,5),(878,30962,30961,'naa',100,5),(878,30963,30962,'600',3.333,5),(878,30964,30962,'000',3.333,5),(878,30965,30962,'00c',3.333,5),(878,30966,30962,'0c2',3.333,5),(878,30967,30962,'c29',3.333,5),(878,30968,30962,'296',3.333,5),(878,30969,30962,'966',3.333,5),(878,30970,30962,'66f',3.333,5),(878,30971,30962,'6f0',3.333,5),(878,30972,30962,'f0a',3.333,5),(878,30973,30962,'0ac',3.333,5),(878,30974,30962,'acd',3.333,5),(878,30975,30962,'cd1',3.333,5),(878,30976,30962,'d1e',3.333,5),(878,30977,30962,'1e9',3.333,5),(878,30978,30962,'e99',3.333,5),(878,30979,30962,'999',3.333,5),(878,30980,30962,'998',3.333,5),(878,30981,30962,'98e',3.333,5),(878,30982,30962,'8ec',3.333,5),(878,30983,30962,'ecb',3.333,5),(878,30984,30962,'cb9',3.333,5),(878,30985,30962,'b9c',3.333,5),(878,30986,30962,'9c2',3.333,5),(878,30987,30962,'c25',3.333,5),(878,30988,30962,'25b',3.333,5),(878,30989,30962,'5b8',3.333,5),(878,30990,30962,'b8c',3.333,5),(878,30991,30962,'8c2',3.333,5),(878,30992,30962,'c2a',3.333,5),(879,30994,30993,'naa',100,5),(879,30995,30994,'600',3.333,5),(879,30996,30994,'000',3.333,5),(879,30997,30994,'00c',3.333,5),(879,30998,30994,'0c2',3.333,5),(879,30999,30994,'c29',3.333,5),(879,31000,30994,'295',3.333,5),(879,31001,30994,'957',3.333,5),(879,31002,30994,'570',3.333,5),(879,31003,30994,'705',3.333,5),(879,31004,30994,'057',3.333,5),(879,31005,30994,'57e',3.333,5),(879,31006,30994,'7ea',3.333,5),(879,31007,30994,'eac',3.333,5),(879,31008,30994,'ac0',3.333,5),(879,31009,30994,'c03',3.333,5),(879,31010,30994,'038',3.333,5),(879,31011,30994,'38b',3.333,5),(879,31012,30994,'8b4',3.333,5),(879,31013,30994,'b48',3.333,5),(879,31014,30994,'488',3.333,5),(879,31015,30994,'882',3.333,5),(879,31016,30994,'827',3.333,5),(879,31017,30994,'27b',3.333,5),(879,31018,30994,'7bc',3.333,5),(879,31019,30994,'bc4',3.333,5),(879,31020,30994,'c4b',3.333,5),(879,31021,30994,'4b8',3.333,5),(879,31022,30994,'b87',3.333,5),(879,31023,30994,'879',3.333,5),(879,31024,30994,'794',3.333,5),(880,31026,31025,'naa',100,5),(880,31027,31026,'600',3.333,5),(880,31028,31026,'000',3.333,5),(880,31029,31026,'00c',3.333,5),(880,31030,31026,'0c2',3.333,5),(880,31031,31026,'c29',3.333,5),(880,31032,31026,'29e',3.333,5),(880,31033,31026,'9ed',3.333,5),(880,31034,31026,'ed5',3.333,5),(880,31035,31026,'d56',3.333,5),(880,31036,31026,'56b',3.333,5),(880,31037,31026,'6b7',3.333,5),(880,31038,31026,'b7b',3.333,5),(880,31039,31026,'7be',3.333,5),(880,31040,31026,'bee',3.333,5),(880,31041,31026,'eef',3.333,5),(880,31042,31026,'ef1',3.333,5),(880,31043,31026,'f13',3.333,5),(880,31044,31026,'13a',3.333,5),(880,31045,31026,'3a5',3.333,5),(880,31046,31026,'a5c',3.333,5),(880,31047,31026,'5cf',3.333,5),(880,31048,31026,'cf7',3.333,5),(880,31049,31026,'f7f',3.333,5),(880,31050,31026,'7f3',3.333,5),(880,31051,31026,'f35',3.333,5),(880,31052,31026,'350',3.333,5),(880,31053,31026,'50a',3.333,5),(880,31054,31026,'0af',3.333,5),(880,31055,31026,'af5',3.333,5),(880,31056,31026,'f50',3.333,5),(881,31058,31057,'naa',100,5),(881,31059,31058,'600',3.333,5),(881,31060,31058,'000',3.333,5),(881,31061,31058,'00c',3.333,5),(881,31062,31058,'0c2',3.333,5),(881,31063,31058,'c29',3.333,5),(881,31064,31058,'295',3.333,5),(881,31065,31058,'95a',3.333,5),(881,31066,31058,'5a5',3.333,5),(881,31067,31058,'a58',3.333,5),(881,31068,31058,'581',3.333,5),(881,31069,31058,'819',3.333,5),(881,31070,31058,'192',3.333,5),(881,31071,31058,'929',3.333,5),(881,31072,31058,'295',3.333,5),(881,31073,31058,'955',3.333,5),(881,31074,31058,'551',3.333,5),(881,31075,31058,'510',3.333,5),(881,31076,31058,'10f',3.333,5),(881,31077,31058,'0f6',3.333,5),(881,31078,31058,'f68',3.333,5),(881,31079,31058,'68c',3.333,5),(881,31080,31058,'8c2',3.333,5),(881,31081,31058,'c2c',3.333,5),(881,31082,31058,'2c2',3.333,5),(881,31083,31058,'c2f',3.333,5),(881,31084,31058,'2f3',3.333,5),(881,31085,31058,'f39',3.333,5),(881,31086,31058,'395',3.333,5),(881,31087,31058,'95d',3.333,5),(881,31088,31058,'5d1',3.333,5),(882,31090,31089,'naa',100,5),(882,31091,31090,'600',3.333,5),(882,31092,31090,'000',3.333,5),(882,31093,31090,'00c',3.333,5),(882,31094,31090,'0c2',3.333,5),(882,31095,31090,'c29',3.333,5),(882,31096,31090,'299',3.333,5),(882,31097,31090,'995',3.333,5),(882,31098,31090,'953',3.333,5),(882,31099,31090,'532',3.333,5),(882,31100,31090,'325',3.333,5),(882,31101,31090,'259',3.333,5),(882,31102,31090,'590',3.333,5),(882,31103,31090,'909',3.333,5),(882,31104,31090,'09e',3.333,5),(882,31105,31090,'9e8',3.333,5),(882,31106,31090,'e86',3.333,5),(882,31107,31090,'861',3.333,5),(882,31108,31090,'611',3.333,5),(882,31109,31090,'110',3.333,5),(882,31110,31090,'103',3.333,5),(882,31111,31090,'03d',3.333,5),(882,31112,31090,'3d9',3.333,5),(882,31113,31090,'d9a',3.333,5),(882,31114,31090,'9a2',3.333,5),(882,31115,31090,'a20',3.333,5),(882,31116,31090,'20f',3.333,5),(882,31117,31090,'0f0',3.333,5),(882,31118,31090,'f02',3.333,5),(882,31119,31090,'024',3.333,5),(882,31120,31090,'242',3.333,5),(883,31122,31121,'hgw',8.333,5),(883,31123,31121,'gw2',8.333,5),(883,31124,31121,'w2k',8.333,5),(883,31125,31121,'2k8',8.333,5),(883,31126,31121,'k8r',8.333,5),(883,31127,31121,'8r2',8.333,5),(883,31128,31121,'r23',8.333,5),(883,31129,31121,'232',8.333,5),(883,31130,31121,'32v',8.333,5),(883,31131,31121,'2vm',8.333,5),(883,31132,31121,'vm1',8.333,5),(883,31133,31121,'m12',8.333,5),(884,31180,31179,'naa',100,5),(884,31181,31180,'600',3.333,5),(884,31182,31180,'000',3.333,5),(884,31183,31180,'00c',3.333,5),(884,31184,31180,'0c2',3.333,5),(884,31185,31180,'c29',3.333,5),(884,31186,31180,'294',3.333,5),(884,31187,31180,'948',3.333,5),(884,31188,31180,'486',3.333,5),(884,31189,31180,'861',3.333,5),(884,31190,31180,'615',3.333,5),(884,31191,31180,'15d',3.333,5),(884,31192,31180,'5dc',3.333,5),(884,31193,31180,'dcd',3.333,5),(884,31194,31180,'cd7',3.333,5),(884,31195,31180,'d7f',3.333,5),(884,31196,31180,'7fa',3.333,5),(884,31197,31180,'fa3',3.333,5),(884,31198,31180,'a38',3.333,5),(884,31199,31180,'38e',3.333,5),(884,31200,31180,'8e5',3.333,5),(884,31201,31180,'e54',3.333,5),(884,31202,31180,'540',3.333,5),(884,31203,31180,'406',3.333,5),(884,31204,31180,'061',3.333,5),(884,31205,31180,'61d',3.333,5),(884,31206,31180,'1d7',3.333,5),(884,31207,31180,'d7c',3.333,5),(884,31208,31180,'7cb',3.333,5),(884,31209,31180,'cbd',3.333,5),(884,31210,31180,'bd2',3.333,5),(885,31212,31211,'naa',100,5),(885,31213,31212,'600',3.333,5),(885,31214,31212,'00a',3.333,5),(885,31215,31212,'0a0',3.333,5),(885,31216,31212,'a09',3.333,5),(885,31217,31212,'098',3.333,5),(885,31218,31212,'980',3.333,5),(885,31219,31212,'804',3.333,5),(885,31220,31212,'044',3.333,5),(885,31221,31212,'443',3.333,5),(885,31222,31212,'430',3.333,5),(885,31223,31212,'307',3.333,5),(885,31224,31212,'072',3.333,5),(885,31225,31212,'725',3.333,5),(885,31226,31212,'259',3.333,5),(885,31227,31212,'593',3.333,5),(885,31228,31212,'931',3.333,5),(885,31229,31212,'313',3.333,5),(885,31230,31212,'13f',3.333,5),(885,31231,31212,'3f3',3.333,5),(885,31232,31212,'f33',3.333,5),(885,31233,31212,'334',3.333,5),(885,31234,31212,'345',3.333,5),(885,31235,31212,'455',3.333,5),(885,31236,31212,'556',3.333,5),(885,31237,31212,'563',3.333,5),(885,31238,31212,'639',3.333,5),(885,31239,31212,'393',3.333,5),(885,31240,31212,'934',3.333,5),(885,31241,31212,'345',3.333,5),(885,31242,31212,'451',3.333,5),(886,31244,31243,'naa',100,5),(886,31245,31244,'600',3.333,5),(886,31246,31244,'00a',3.333,5),(886,31247,31244,'0a0',3.333,5),(886,31248,31244,'a09',3.333,5),(886,31249,31244,'098',3.333,5),(886,31250,31244,'980',3.333,5),(886,31251,31244,'804',3.333,5),(886,31252,31244,'044',3.333,5),(886,31253,31244,'443',3.333,5),(886,31254,31244,'430',3.333,5),(886,31255,31244,'307',3.333,5),(886,31256,31244,'072',3.333,5),(886,31257,31244,'725',3.333,5),(886,31258,31244,'259',3.333,5),(886,31259,31244,'593',3.333,5),(886,31260,31244,'931',3.333,5),(886,31261,31244,'313',3.333,5),(886,31262,31244,'13f',3.333,5),(886,31263,31244,'3f3',3.333,5),(886,31264,31244,'f33',3.333,5),(886,31265,31244,'334',3.333,5),(886,31266,31244,'345',3.333,5),(886,31267,31244,'455',3.333,5),(886,31268,31244,'556',3.333,5),(886,31269,31244,'563',3.333,5),(886,31270,31244,'639',3.333,5),(886,31271,31244,'393',3.333,5),(886,31272,31244,'934',3.333,5),(886,31273,31244,'345',3.333,5),(886,31274,31244,'452',3.333,5),(887,31276,31275,'naa',100,5),(887,31277,31276,'600',3.333,5),(887,31278,31276,'00a',3.333,5),(887,31279,31276,'0a0',3.333,5),(887,31280,31276,'a09',3.333,5),(887,31281,31276,'098',3.333,5),(887,31282,31276,'980',3.333,5),(887,31283,31276,'804',3.333,5),(887,31284,31276,'044',3.333,5),(887,31285,31276,'443',3.333,5),(887,31286,31276,'430',3.333,5),(887,31287,31276,'307',3.333,5),(887,31288,31276,'075',3.333,5),(887,31289,31276,'753',3.333,5),(887,31290,31276,'535',3.333,5),(887,31291,31276,'357',3.333,5),(887,31292,31276,'573',3.333,5),(887,31293,31276,'732',3.333,5),(887,31294,31276,'32b',3.333,5),(887,31295,31276,'2b3',3.333,5),(887,31296,31276,'b33',3.333,5),(887,31297,31276,'334',3.333,5),(887,31298,31276,'345',3.333,5),(887,31299,31276,'457',3.333,5),(887,31300,31276,'571',3.333,5),(887,31301,31276,'715',3.333,5),(887,31302,31276,'153',3.333,5),(887,31303,31276,'533',3.333,5),(887,31304,31276,'336',3.333,5),(887,31305,31276,'364',3.333,5),(887,31306,31276,'642',3.333,5),(888,31308,31307,'naa',100,5),(888,31309,31308,'600',3.333,5),(888,31310,31308,'00a',3.333,5),(888,31311,31308,'0a0',3.333,5),(888,31312,31308,'a09',3.333,5),(888,31313,31308,'098',3.333,5),(888,31314,31308,'980',3.333,5),(888,31315,31308,'804',3.333,5),(888,31316,31308,'044',3.333,5),(888,31317,31308,'443',3.333,5),(888,31318,31308,'430',3.333,5),(888,31319,31308,'307',3.333,5),(888,31320,31308,'075',3.333,5),(888,31321,31308,'753',3.333,5),(888,31322,31308,'535',3.333,5),(888,31323,31308,'357',3.333,5),(888,31324,31308,'573',3.333,5),(888,31325,31308,'732',3.333,5),(888,31326,31308,'32b',3.333,5),(888,31327,31308,'2b3',3.333,5),(888,31328,31308,'b33',3.333,5),(888,31329,31308,'334',3.333,5),(888,31330,31308,'345',3.333,5),(888,31331,31308,'457',3.333,5),(888,31332,31308,'571',3.333,5),(888,31333,31308,'715',3.333,5),(888,31334,31308,'153',3.333,5),(888,31335,31308,'533',3.333,5),(888,31336,31308,'336',3.333,5),(888,31337,31308,'364',3.333,5),(888,31338,31308,'643',3.333,5),(889,31340,31339,'naa',100,5),(889,31341,31340,'600',3.333,5),(889,31342,31340,'000',3.333,5),(889,31343,31340,'00c',3.333,5),(889,31344,31340,'0c2',3.333,5),(889,31345,31340,'c29',3.333,5),(889,31346,31340,'29b',3.333,5),(889,31347,31340,'9b2',3.333,5),(889,31348,31340,'b20',3.333,5),(889,31349,31340,'207',3.333,5),(889,31350,31340,'07d',3.333,5),(889,31351,31340,'7d3',3.333,5),(889,31352,31340,'d32',3.333,5),(889,31353,31340,'32e',3.333,5),(889,31354,31340,'2e1',3.333,5),(889,31355,31340,'e12',3.333,5),(889,31356,31340,'12e',3.333,5),(889,31357,31340,'2ea',3.333,5),(889,31358,31340,'ea2',3.333,5),(889,31359,31340,'a2d',3.333,5),(889,31360,31340,'2d6',3.333,5),(889,31361,31340,'d6a',3.333,5),(889,31362,31340,'6a6',3.333,5),(889,31363,31340,'a66',3.333,5),(889,31364,31340,'664',3.333,5),(889,31365,31340,'64b',3.333,5),(889,31366,31340,'4bf',3.333,5),(889,31367,31340,'bf5',3.333,5),(889,31368,31340,'f55',3.333,5),(889,31369,31340,'553',3.333,5),(889,31370,31340,'53d',3.333,5),(890,31372,31371,'naa',100,5),(890,31373,31372,'600',3.333,5),(890,31374,31372,'000',3.333,5),(890,31375,31372,'00c',3.333,5),(890,31376,31372,'0c2',3.333,5),(890,31377,31372,'c29',3.333,5),(890,31378,31372,'29d',3.333,5),(890,31379,31372,'9d8',3.333,5),(890,31380,31372,'d80',3.333,5),(890,31381,31372,'80c',3.333,5),(890,31382,31372,'0c3',3.333,5),(890,31383,31372,'c35',3.333,5),(890,31384,31372,'35d',3.333,5),(890,31385,31372,'5d1',3.333,5),(890,31386,31372,'d1a',3.333,5),(890,31387,31372,'1a2',3.333,5),(890,31388,31372,'a2c',3.333,5),(890,31389,31372,'2cf',3.333,5),(890,31390,31372,'cfd',3.333,5),(890,31391,31372,'fda',3.333,5),(890,31392,31372,'daa',3.333,5),(890,31393,31372,'aa2',3.333,5),(890,31394,31372,'a2f',3.333,5),(890,31395,31372,'2f6',3.333,5),(890,31396,31372,'f6d',3.333,5),(890,31397,31372,'6dc',3.333,5),(890,31398,31372,'dc9',3.333,5),(890,31399,31372,'c96',3.333,5),(890,31400,31372,'96d',3.333,5),(890,31401,31372,'6d9',3.333,5),(890,31402,31372,'d96',3.333,5),(891,31404,31403,'naa',100,5),(891,31405,31404,'600',3.333,5),(891,31406,31404,'000',3.333,5),(891,31407,31404,'00c',3.333,5),(891,31408,31404,'0c2',3.333,5),(891,31409,31404,'c29',3.333,5),(891,31410,31404,'296',3.333,5),(891,31411,31404,'96e',3.333,5),(891,31412,31404,'6ef',3.333,5),(891,31413,31404,'efe',3.333,5),(891,31414,31404,'fe9',3.333,5),(891,31415,31404,'e98',3.333,5),(891,31416,31404,'987',3.333,5),(891,31417,31404,'878',3.333,5),(891,31418,31404,'782',3.333,5),(891,31419,31404,'826',3.333,5),(891,31420,31404,'261',3.333,5),(891,31421,31404,'618',3.333,5),(891,31422,31404,'182',3.333,5),(891,31423,31404,'824',3.333,5),(891,31424,31404,'245',3.333,5),(891,31425,31404,'454',3.333,5),(891,31426,31404,'544',3.333,5),(891,31427,31404,'443',3.333,5),(891,31428,31404,'43e',3.333,5),(891,31429,31404,'3e7',3.333,5),(891,31430,31404,'e77',3.333,5),(891,31431,31404,'772',3.333,5),(891,31432,31404,'72b',3.333,5),(891,31433,31404,'2be',3.333,5),(891,31434,31404,'bec',3.333,5),(892,31436,31435,'naa',100,5),(892,31437,31436,'600',3.333,5),(892,31438,31436,'000',3.333,5),(892,31439,31436,'00c',3.333,5),(892,31440,31436,'0c2',3.333,5),(892,31441,31436,'c29',3.333,5),(892,31442,31436,'29f',3.333,5),(892,31443,31436,'9f2',3.333,5),(892,31444,31436,'f22',3.333,5),(892,31445,31436,'224',3.333,5),(892,31446,31436,'24d',3.333,5),(892,31447,31436,'4d5',3.333,5),(892,31448,31436,'d52',3.333,5),(892,31449,31436,'52b',3.333,5),(892,31450,31436,'2b1',3.333,5),(892,31451,31436,'b11',3.333,5),(892,31452,31436,'113',3.333,5),(892,31453,31436,'13f',3.333,5),(892,31454,31436,'3f5',3.333,5),(892,31455,31436,'f5e',3.333,5),(892,31456,31436,'5e0',3.333,5),(892,31457,31436,'e05',3.333,5),(892,31458,31436,'05c',3.333,5),(892,31459,31436,'5c2',3.333,5),(892,31460,31436,'c2c',3.333,5),(892,31461,31436,'2cd',3.333,5),(892,31462,31436,'cda',3.333,5),(892,31463,31436,'da0',3.333,5),(892,31464,31436,'a0e',3.333,5),(892,31465,31436,'0ed',3.333,5),(892,31466,31436,'ed8',3.333,5),(893,31468,31467,'naa',100,5),(893,31469,31468,'600',3.333,5),(893,31470,31468,'000',3.333,5),(893,31471,31468,'00c',3.333,5),(893,31472,31468,'0c2',3.333,5),(893,31473,31468,'c29',3.333,5),(893,31474,31468,'295',3.333,5),(893,31475,31468,'954',3.333,5),(893,31476,31468,'54c',3.333,5),(893,31477,31468,'4ce',3.333,5),(893,31478,31468,'ce7',3.333,5),(893,31479,31468,'e76',3.333,5),(893,31480,31468,'76e',3.333,5),(893,31481,31468,'6e0',3.333,5),(893,31482,31468,'e04',3.333,5),(893,31483,31468,'046',3.333,5),(893,31484,31468,'46b',3.333,5),(893,31485,31468,'6bb',3.333,5),(893,31486,31468,'bbd',3.333,5),(893,31487,31468,'bd7',3.333,5),(893,31488,31468,'d76',3.333,5),(893,31489,31468,'765',3.333,5),(893,31490,31468,'65c',3.333,5),(893,31491,31468,'5c0',3.333,5),(893,31492,31468,'c07',3.333,5),(893,31493,31468,'073',3.333,5),(893,31494,31468,'736',3.333,5),(893,31495,31468,'360',3.333,5),(893,31496,31468,'609',3.333,5),(893,31497,31468,'09d',3.333,5),(893,31498,31468,'9dd',3.333,5),(894,31500,31499,'naa',100,5),(894,31501,31500,'600',3.333,5),(894,31502,31500,'000',3.333,5),(894,31503,31500,'00c',3.333,5),(894,31504,31500,'0c2',3.333,5),(894,31505,31500,'c29',3.333,5),(894,31506,31500,'29b',3.333,5),(894,31507,31500,'9be',3.333,5),(894,31508,31500,'be3',3.333,5),(894,31509,31500,'e3a',3.333,5),(894,31510,31500,'3a2',3.333,5),(894,31511,31500,'a23',3.333,5),(894,31512,31500,'234',3.333,5),(894,31513,31500,'341',3.333,5),(894,31514,31500,'414',3.333,5),(894,31515,31500,'14f',3.333,5),(894,31516,31500,'4f4',3.333,5),(894,31517,31500,'f49',3.333,5),(894,31518,31500,'493',3.333,5),(894,31519,31500,'934',3.333,5),(894,31520,31500,'349',3.333,5),(894,31521,31500,'49e',3.333,5),(894,31522,31500,'9e0',3.333,5),(894,31523,31500,'e00',3.333,5),(894,31524,31500,'001',3.333,5),(894,31525,31500,'019',3.333,5),(894,31526,31500,'19a',3.333,5),(894,31527,31500,'9ab',3.333,5),(894,31528,31500,'ab9',3.333,5),(894,31529,31500,'b98',3.333,5),(894,31530,31500,'982',3.333,5),(895,31532,31531,'naa',100,5),(895,31533,31532,'600',3.333,5),(895,31534,31532,'000',3.333,5),(895,31535,31532,'00c',3.333,5),(895,31536,31532,'0c2',3.333,5),(895,31537,31532,'c29',3.333,5),(895,31538,31532,'29e',3.333,5),(895,31539,31532,'9e6',3.333,5),(895,31540,31532,'e65',3.333,5),(895,31541,31532,'657',3.333,5),(895,31542,31532,'57f',3.333,5),(895,31543,31532,'7fc',3.333,5),(895,31544,31532,'fce',3.333,5),(895,31545,31532,'ceb',3.333,5),(895,31546,31532,'eb9',3.333,5),(895,31547,31532,'b93',3.333,5),(895,31548,31532,'93f',3.333,5),(895,31549,31532,'3f7',3.333,5),(895,31550,31532,'f7a',3.333,5),(895,31551,31532,'7a3',3.333,5),(895,31552,31532,'a3f',3.333,5),(895,31553,31532,'3f0',3.333,5),(895,31554,31532,'f00',3.333,5),(895,31555,31532,'001',3.333,5),(895,31556,31532,'013',3.333,5),(895,31557,31532,'139',3.333,5),(895,31558,31532,'395',3.333,5),(895,31559,31532,'95a',3.333,5),(895,31560,31532,'5a6',3.333,5),(895,31561,31532,'a64',3.333,5),(895,31562,31532,'64e',3.333,5),(896,31564,31563,'naa',100,5),(896,31565,31564,'600',3.333,5),(896,31566,31564,'000',3.333,5),(896,31567,31564,'00c',3.333,5),(896,31568,31564,'0c2',3.333,5),(896,31569,31564,'c29',3.333,5),(896,31570,31564,'293',3.333,5),(896,31571,31564,'93f',3.333,5),(896,31572,31564,'3f5',3.333,5),(896,31573,31564,'f59',3.333,5),(896,31574,31564,'590',3.333,5),(896,31575,31564,'905',3.333,5),(896,31576,31564,'05a',3.333,5),(896,31577,31564,'5ac',3.333,5),(896,31578,31564,'acb',3.333,5),(896,31579,31564,'cb8',3.333,5),(896,31580,31564,'b80',3.333,5),(896,31581,31564,'80c',3.333,5),(896,31582,31564,'0c4',3.333,5),(896,31583,31564,'c41',3.333,5),(896,31584,31564,'411',3.333,5),(896,31585,31564,'114',3.333,5),(896,31586,31564,'14f',3.333,5),(896,31587,31564,'4f6',3.333,5),(896,31588,31564,'f67',3.333,5),(896,31589,31564,'679',3.333,5),(896,31590,31564,'791',3.333,5),(896,31591,31564,'917',3.333,5),(896,31592,31564,'176',3.333,5),(896,31593,31564,'764',3.333,5),(896,31594,31564,'640',3.333,5),(897,31596,31595,'naa',100,5),(897,31597,31596,'600',3.333,5),(897,31598,31596,'000',3.333,5),(897,31599,31596,'00c',3.333,5),(897,31600,31596,'0c2',3.333,5),(897,31601,31596,'c29',3.333,5),(897,31602,31596,'29e',3.333,5),(897,31603,31596,'9e4',3.333,5),(897,31604,31596,'e40',3.333,5),(897,31605,31596,'407',3.333,5),(897,31606,31596,'078',3.333,5),(897,31607,31596,'78c',3.333,5),(897,31608,31596,'8cf',3.333,5),(897,31609,31596,'cf4',3.333,5),(897,31610,31596,'f49',3.333,5),(897,31611,31596,'496',3.333,5),(897,31612,31596,'962',3.333,5),(897,31613,31596,'625',3.333,5),(897,31614,31596,'25e',3.333,5),(897,31615,31596,'5e3',3.333,5),(897,31616,31596,'e3e',3.333,5),(897,31617,31596,'3ee',3.333,5),(897,31618,31596,'ee8',3.333,5),(897,31619,31596,'e82',3.333,5),(897,31620,31596,'82e',3.333,5),(897,31621,31596,'2e5',3.333,5),(897,31622,31596,'e57',3.333,5),(897,31623,31596,'576',3.333,5),(897,31624,31596,'761',3.333,5),(897,31625,31596,'61d',3.333,5),(897,31626,31596,'1d9',3.333,5),(898,31628,31627,'naa',100,5),(898,31629,31628,'600',3.333,5),(898,31630,31628,'000',3.333,5),(898,31631,31628,'00c',3.333,5),(898,31632,31628,'0c2',3.333,5),(898,31633,31628,'c29',3.333,5),(898,31634,31628,'291',3.333,5),(898,31635,31628,'91c',3.333,5),(898,31636,31628,'1c6',3.333,5),(898,31637,31628,'c65',3.333,5),(898,31638,31628,'65e',3.333,5),(898,31639,31628,'5ea',3.333,5),(898,31640,31628,'ea1',3.333,5),(898,31641,31628,'a12',3.333,5),(898,31642,31628,'129',3.333,5),(898,31643,31628,'29b',3.333,5),(898,31644,31628,'9b7',3.333,5),(898,31645,31628,'b7c',3.333,5),(898,31646,31628,'7ce',3.333,5),(898,31647,31628,'cee',3.333,5),(898,31648,31628,'ee8',3.333,5),(898,31649,31628,'e80',3.333,5),(898,31650,31628,'802',3.333,5),(898,31651,31628,'02f',3.333,5),(898,31652,31628,'2f4',3.333,5),(898,31653,31628,'f4c',3.333,5),(898,31654,31628,'4cd',3.333,5),(898,31655,31628,'cdb',3.333,5),(898,31656,31628,'dbc',3.333,5),(898,31657,31628,'bc3',3.333,5),(898,31658,31628,'c3e',3.333,5),(899,31660,31659,'naa',100,5),(899,31661,31660,'600',3.333,5),(899,31662,31660,'000',3.333,5),(899,31663,31660,'00c',3.333,5),(899,31664,31660,'0c2',3.333,5),(899,31665,31660,'c29',3.333,5),(899,31666,31660,'291',3.333,5),(899,31667,31660,'915',3.333,5),(899,31668,31660,'159',3.333,5),(899,31669,31660,'59c',3.333,5),(899,31670,31660,'9ce',3.333,5),(899,31671,31660,'cee',3.333,5),(899,31672,31660,'eea',3.333,5),(899,31673,31660,'eaa',3.333,5),(899,31674,31660,'aa2',3.333,5),(899,31675,31660,'a2d',3.333,5),(899,31676,31660,'2db',3.333,5),(899,31677,31660,'db1',3.333,5),(899,31678,31660,'b18',3.333,5),(899,31679,31660,'18c',3.333,5),(899,31680,31660,'8c5',3.333,5),(899,31681,31660,'c5b',3.333,5),(899,31682,31660,'5b0',3.333,5),(899,31683,31660,'b00',3.333,5),(899,31684,31660,'00e',3.333,5),(899,31685,31660,'0eb',3.333,5),(899,31686,31660,'eb7',3.333,5),(899,31687,31660,'b77',3.333,5),(899,31688,31660,'77c',3.333,5),(899,31689,31660,'7ca',3.333,5),(899,31690,31660,'cac',3.333,5),(900,31692,31691,'naa',100,5),(900,31693,31692,'600',3.333,5),(900,31694,31692,'000',3.333,5),(900,31695,31692,'00c',3.333,5),(900,31696,31692,'0c2',3.333,5),(900,31697,31692,'c29',3.333,5),(900,31698,31692,'29e',3.333,5),(900,31699,31692,'9e2',3.333,5),(900,31700,31692,'e28',3.333,5),(900,31701,31692,'28d',3.333,5),(900,31702,31692,'8df',3.333,5),(900,31703,31692,'df1',3.333,5),(900,31704,31692,'f12',3.333,5),(900,31705,31692,'12d',3.333,5),(900,31706,31692,'2df',3.333,5),(900,31707,31692,'dfd',3.333,5),(900,31708,31692,'fd2',3.333,5),(900,31709,31692,'d28',3.333,5),(900,31710,31692,'283',3.333,5),(900,31711,31692,'83a',3.333,5),(900,31712,31692,'3aa',3.333,5),(900,31713,31692,'aaa',3.333,5),(900,31714,31692,'aa8',3.333,5),(900,31715,31692,'a8e',3.333,5),(900,31716,31692,'8ea',3.333,5),(900,31717,31692,'ea2',3.333,5),(900,31718,31692,'a29',3.333,5),(900,31719,31692,'29b',3.333,5),(900,31720,31692,'9b5',3.333,5),(900,31721,31692,'b5b',3.333,5),(900,31722,31692,'5bf',3.333,5),(901,31724,31723,'naa',100,5),(901,31725,31724,'600',3.333,5),(901,31726,31724,'000',3.333,5),(901,31727,31724,'00c',3.333,5),(901,31728,31724,'0c2',3.333,5),(901,31729,31724,'c29',3.333,5),(901,31730,31724,'29b',3.333,5),(901,31731,31724,'9ba',3.333,5),(901,31732,31724,'ba0',3.333,5),(901,31733,31724,'a09',3.333,5),(901,31734,31724,'09c',3.333,5),(901,31735,31724,'9cb',3.333,5),(901,31736,31724,'cbd',3.333,5),(901,31737,31724,'bd0',3.333,5),(901,31738,31724,'d0b',3.333,5),(901,31739,31724,'0ba',3.333,5),(901,31740,31724,'ba1',3.333,5),(901,31741,31724,'a1f',3.333,5),(901,31742,31724,'1fc',3.333,5),(901,31743,31724,'fc5',3.333,5),(901,31744,31724,'c5e',3.333,5),(901,31745,31724,'5ee',3.333,5),(901,31746,31724,'ee4',3.333,5),(901,31747,31724,'e4b',3.333,5),(901,31748,31724,'4b1',3.333,5),(901,31749,31724,'b10',3.333,5),(901,31750,31724,'10b',3.333,5),(901,31751,31724,'0b8',3.333,5),(901,31752,31724,'b8e',3.333,5),(901,31753,31724,'8eb',3.333,5),(901,31754,31724,'ebe',3.333,5),(902,31756,31755,'naa',100,5),(902,31757,31756,'600',3.333,5),(902,31758,31756,'000',3.333,5),(902,31759,31756,'00c',3.333,5),(902,31760,31756,'0c2',3.333,5),(902,31761,31756,'c29',3.333,5),(902,31762,31756,'29e',3.333,5),(902,31763,31756,'9e5',3.333,5),(902,31764,31756,'e52',3.333,5),(902,31765,31756,'52c',3.333,5),(902,31766,31756,'2c9',3.333,5),(902,31767,31756,'c9c',3.333,5),(902,31768,31756,'9c7',3.333,5),(902,31769,31756,'c71',3.333,5),(902,31770,31756,'716',3.333,5),(902,31771,31756,'16b',3.333,5),(902,31772,31756,'6b6',3.333,5),(902,31773,31756,'b69',3.333,5),(902,31774,31756,'698',3.333,5),(902,31775,31756,'987',3.333,5),(902,31776,31756,'87f',3.333,5),(902,31777,31756,'7f9',3.333,5),(902,31778,31756,'f97',3.333,5),(902,31779,31756,'975',3.333,5),(902,31780,31756,'75c',3.333,5),(902,31781,31756,'5cd',3.333,5),(902,31782,31756,'cd7',3.333,5),(902,31783,31756,'d71',3.333,5),(902,31784,31756,'717',3.333,5),(902,31785,31756,'170',3.333,5),(902,31786,31756,'70a',3.333,5),(903,31788,31787,'naa',100,5),(903,31789,31788,'600',3.333,5),(903,31790,31788,'000',3.333,5),(903,31791,31788,'00c',3.333,5),(903,31792,31788,'0c2',3.333,5),(903,31793,31788,'c29',3.333,5),(903,31794,31788,'293',3.333,5),(903,31795,31788,'93d',3.333,5),(903,31796,31788,'3d6',3.333,5),(903,31797,31788,'d60',3.333,5),(903,31798,31788,'60f',3.333,5),(903,31799,31788,'0f9',3.333,5),(903,31800,31788,'f9e',3.333,5),(903,31801,31788,'9e6',3.333,5),(903,31802,31788,'e6c',3.333,5),(903,31803,31788,'6ce',3.333,5),(903,31804,31788,'ce3',3.333,5),(903,31805,31788,'e3f',3.333,5),(903,31806,31788,'3fa',3.333,5),(903,31807,31788,'fa1',3.333,5),(903,31808,31788,'a13',3.333,5),(903,31809,31788,'138',3.333,5),(903,31810,31788,'388',3.333,5),(903,31811,31788,'88e',3.333,5),(903,31812,31788,'8ed',3.333,5),(903,31813,31788,'edd',3.333,5),(903,31814,31788,'ddf',3.333,5),(903,31815,31788,'df3',3.333,5),(903,31816,31788,'f33',3.333,5),(903,31817,31788,'331',3.333,5),(903,31818,31788,'311',3.333,5),(904,31820,31819,'naa',100,5),(904,31821,31820,'600',3.333,5),(904,31822,31820,'000',3.333,5),(904,31823,31820,'00c',3.333,5),(904,31824,31820,'0c2',3.333,5),(904,31825,31820,'c29',3.333,5),(904,31826,31820,'29b',3.333,5),(904,31827,31820,'9b3',3.333,5),(904,31828,31820,'b3d',3.333,5),(904,31829,31820,'3d3',3.333,5),(904,31830,31820,'d3a',3.333,5),(904,31831,31820,'3a5',3.333,5),(904,31832,31820,'a5c',3.333,5),(904,31833,31820,'5ce',3.333,5),(904,31834,31820,'cea',3.333,5),(904,31835,31820,'eaf',3.333,5),(904,31836,31820,'afd',3.333,5),(904,31837,31820,'fd2',3.333,5),(904,31838,31820,'d2f',3.333,5),(904,31839,31820,'2fd',3.333,5),(904,31840,31820,'fd1',3.333,5),(904,31841,31820,'d1f',3.333,5),(904,31842,31820,'1fb',3.333,5),(904,31843,31820,'fb7',3.333,5),(904,31844,31820,'b71',3.333,5),(904,31845,31820,'711',3.333,5),(904,31846,31820,'11f',3.333,5),(904,31847,31820,'1fe',3.333,5),(904,31848,31820,'fe6',3.333,5),(904,31849,31820,'e64',3.333,5),(904,31850,31820,'64c',3.333,5),(905,31852,31851,'naa',100,5),(905,31853,31852,'600',3.333,5),(905,31854,31852,'000',3.333,5),(905,31855,31852,'00c',3.333,5),(905,31856,31852,'0c2',3.333,5),(905,31857,31852,'c29',3.333,5),(905,31858,31852,'294',3.333,5),(905,31859,31852,'943',3.333,5),(905,31860,31852,'43c',3.333,5),(905,31861,31852,'3c2',3.333,5),(905,31862,31852,'c2d',3.333,5),(905,31863,31852,'2d4',3.333,5),(905,31864,31852,'d46',3.333,5),(905,31865,31852,'465',3.333,5),(905,31866,31852,'653',3.333,5),(905,31867,31852,'536',3.333,5),(905,31868,31852,'369',3.333,5),(905,31869,31852,'69a',3.333,5),(905,31870,31852,'9af',3.333,5),(905,31871,31852,'af4',3.333,5),(905,31872,31852,'f4e',3.333,5),(905,31873,31852,'4e6',3.333,5),(905,31874,31852,'e60',3.333,5),(905,31875,31852,'603',3.333,5),(905,31876,31852,'03e',3.333,5),(905,31877,31852,'3e6',3.333,5),(905,31878,31852,'e6a',3.333,5),(905,31879,31852,'6a5',3.333,5),(905,31880,31852,'a55',3.333,5),(905,31881,31852,'554',3.333,5),(905,31882,31852,'54b',3.333,5),(906,31884,31883,'naa',100,5),(906,31885,31884,'600',3.333,5),(906,31886,31884,'000',3.333,5),(906,31887,31884,'00c',3.333,5),(906,31888,31884,'0c2',3.333,5),(906,31889,31884,'c29',3.333,5),(906,31890,31884,'297',3.333,5),(906,31891,31884,'97c',3.333,5),(906,31892,31884,'7c2',3.333,5),(906,31893,31884,'c23',3.333,5),(906,31894,31884,'23c',3.333,5),(906,31895,31884,'3ce',3.333,5),(906,31896,31884,'ce5',3.333,5),(906,31897,31884,'e56',3.333,5),(906,31898,31884,'566',3.333,5),(906,31899,31884,'66e',3.333,5),(906,31900,31884,'6ef',3.333,5),(906,31901,31884,'ef1',3.333,5),(906,31902,31884,'f1d',3.333,5),(906,31903,31884,'1d1',3.333,5),(906,31904,31884,'d11',3.333,5),(906,31905,31884,'11f',3.333,5),(906,31906,31884,'1f9',3.333,5),(906,31907,31884,'f9c',3.333,5),(906,31908,31884,'9c4',3.333,5),(906,31909,31884,'c4f',3.333,5),(906,31910,31884,'4ff',3.333,5),(906,31911,31884,'ffc',3.333,5),(906,31912,31884,'fc5',3.333,5),(906,31913,31884,'c54',3.333,5),(906,31914,31884,'54b',3.333,5),(907,31916,31915,'naa',100,5),(907,31917,31916,'600',3.333,5),(907,31918,31916,'000',3.333,5),(907,31919,31916,'00c',3.333,5),(907,31920,31916,'0c2',3.333,5),(907,31921,31916,'c29',3.333,5),(907,31922,31916,'294',3.333,5),(907,31923,31916,'94b',3.333,5),(907,31924,31916,'4be',3.333,5),(907,31925,31916,'be0',3.333,5),(907,31926,31916,'e07',3.333,5),(907,31927,31916,'075',3.333,5),(907,31928,31916,'75e',3.333,5),(907,31929,31916,'5e9',3.333,5),(907,31930,31916,'e9a',3.333,5),(907,31931,31916,'9ad',3.333,5),(907,31932,31916,'ad0',3.333,5),(907,31933,31916,'d0f',3.333,5),(907,31934,31916,'0f8',3.333,5),(907,31935,31916,'f8b',3.333,5),(907,31936,31916,'8b6',3.333,5),(907,31937,31916,'b6e',3.333,5),(907,31938,31916,'6e2',3.333,5),(907,31939,31916,'e2f',3.333,5),(907,31940,31916,'2f4',3.333,5),(907,31941,31916,'f4f',3.333,5),(907,31942,31916,'4f0',3.333,5),(907,31943,31916,'f04',3.333,5),(907,31944,31916,'04f',3.333,5),(907,31945,31916,'4fe',3.333,5),(907,31946,31916,'fe8',3.333,5),(908,31948,31947,'naa',100,5),(908,31949,31948,'600',3.333,5),(908,31950,31948,'000',3.333,5),(908,31951,31948,'00c',3.333,5),(908,31952,31948,'0c2',3.333,5),(908,31953,31948,'c29',3.333,5),(908,31954,31948,'29b',3.333,5),(908,31955,31948,'9b4',3.333,5),(908,31956,31948,'b4f',3.333,5),(908,31957,31948,'4f3',3.333,5),(908,31958,31948,'f3a',3.333,5),(908,31959,31948,'3a5',3.333,5),(908,31960,31948,'a57',3.333,5),(908,31961,31948,'571',3.333,5),(908,31962,31948,'71c',3.333,5),(908,31963,31948,'1cc',3.333,5),(908,31964,31948,'cce',3.333,5),(908,31965,31948,'ce0',3.333,5),(908,31966,31948,'e0d',3.333,5),(908,31967,31948,'0de',3.333,5),(908,31968,31948,'de2',3.333,5),(908,31969,31948,'e24',3.333,5),(908,31970,31948,'242',3.333,5),(908,31971,31948,'42b',3.333,5),(908,31972,31948,'2b5',3.333,5),(908,31973,31948,'b50',3.333,5),(908,31974,31948,'50c',3.333,5),(908,31975,31948,'0cb',3.333,5),(908,31976,31948,'cb4',3.333,5),(908,31977,31948,'b4d',3.333,5),(908,31978,31948,'4df',3.333,5),(909,31980,31979,'naa',100,5),(909,31981,31980,'600',3.333,5),(909,31982,31980,'000',3.333,5),(909,31983,31980,'00c',3.333,5),(909,31984,31980,'0c2',3.333,5),(909,31985,31980,'c29',3.333,5),(909,31986,31980,'296',3.333,5),(909,31987,31980,'960',3.333,5),(909,31988,31980,'601',3.333,5),(909,31989,31980,'01b',3.333,5),(909,31990,31980,'1bd',3.333,5),(909,31991,31980,'bd2',3.333,5),(909,31992,31980,'d24',3.333,5),(909,31993,31980,'24c',3.333,5),(909,31994,31980,'4c6',3.333,5),(909,31995,31980,'c6c',3.333,5),(909,31996,31980,'6c5',3.333,5),(909,31997,31980,'c5e',3.333,5),(909,31998,31980,'5e2',3.333,5),(909,31999,31980,'e2d',3.333,5),(909,32000,31980,'2d0',3.333,5),(909,32001,31980,'d09',3.333,5),(909,32002,31980,'09f',3.333,5),(909,32003,31980,'9f2',3.333,5),(909,32004,31980,'f27',3.333,5),(909,32005,31980,'27b',3.333,5),(909,32006,31980,'7b5',3.333,5),(909,32007,31980,'b5c',3.333,5),(909,32008,31980,'5c6',3.333,5),(909,32009,31980,'c63',3.333,5),(909,32010,31980,'634',3.333,5),(910,32012,32011,'naa',100,5),(910,32013,32012,'600',3.333,5),(910,32014,32012,'000',3.333,5),(910,32015,32012,'00c',3.333,5),(910,32016,32012,'0c2',3.333,5),(910,32017,32012,'c29',3.333,5),(910,32018,32012,'290',3.333,5),(910,32019,32012,'90a',3.333,5),(910,32020,32012,'0ad',3.333,5),(910,32021,32012,'ad1',3.333,5),(910,32022,32012,'d1f',3.333,5),(910,32023,32012,'1f6',3.333,5),(910,32024,32012,'f63',3.333,5),(910,32025,32012,'634',3.333,5),(910,32026,32012,'341',3.333,5),(910,32027,32012,'412',3.333,5),(910,32028,32012,'12f',3.333,5),(910,32029,32012,'2f7',3.333,5),(910,32030,32012,'f7c',3.333,5),(910,32031,32012,'7c1',3.333,5),(910,32032,32012,'c1e',3.333,5),(910,32033,32012,'1e6',3.333,5),(910,32034,32012,'e6e',3.333,5),(910,32035,32012,'6ef',3.333,5),(910,32036,32012,'ef5',3.333,5),(910,32037,32012,'f51',3.333,5),(910,32038,32012,'51c',3.333,5),(910,32039,32012,'1ca',3.333,5),(910,32040,32012,'ca3',3.333,5),(910,32041,32012,'a3d',3.333,5),(910,32042,32012,'3d6',3.333,5),(911,32044,32043,'naa',100,5),(911,32045,32044,'600',3.333,5),(911,32046,32044,'000',3.333,5),(911,32047,32044,'00c',3.333,5),(911,32048,32044,'0c2',3.333,5),(911,32049,32044,'c29',3.333,5),(911,32050,32044,'29a',3.333,5),(911,32051,32044,'9ae',3.333,5),(911,32052,32044,'ae0',3.333,5),(911,32053,32044,'e0f',3.333,5),(911,32054,32044,'0ff',3.333,5),(911,32055,32044,'ff2',3.333,5),(911,32056,32044,'f24',3.333,5),(911,32057,32044,'248',3.333,5),(911,32058,32044,'484',3.333,5),(911,32059,32044,'843',3.333,5),(911,32060,32044,'43a',3.333,5),(911,32061,32044,'3a0',3.333,5),(911,32062,32044,'a00',3.333,5),(911,32063,32044,'007',3.333,5),(911,32064,32044,'077',3.333,5),(911,32065,32044,'774',3.333,5),(911,32066,32044,'740',3.333,5),(911,32067,32044,'40f',3.333,5),(911,32068,32044,'0f7',3.333,5),(911,32069,32044,'f7d',3.333,5),(911,32070,32044,'7da',3.333,5),(911,32071,32044,'dab',3.333,5),(911,32072,32044,'ab9',3.333,5),(911,32073,32044,'b90',3.333,5),(911,32074,32044,'901',3.333,5),(912,32076,32075,'naa',100,5),(912,32077,32076,'600',3.333,5),(912,32078,32076,'000',3.333,5),(912,32079,32076,'00c',3.333,5),(912,32080,32076,'0c2',3.333,5),(912,32081,32076,'c29',3.333,5),(912,32082,32076,'29c',3.333,5),(912,32083,32076,'9c4',3.333,5),(912,32084,32076,'c47',3.333,5),(912,32085,32076,'473',3.333,5),(912,32086,32076,'73f',3.333,5),(912,32087,32076,'3f8',3.333,5),(912,32088,32076,'f82',3.333,5),(912,32089,32076,'82e',3.333,5),(912,32090,32076,'2ed',3.333,5),(912,32091,32076,'eda',3.333,5),(912,32092,32076,'da5',3.333,5),(912,32093,32076,'a53',3.333,5),(912,32094,32076,'53e',3.333,5),(912,32095,32076,'3e7',3.333,5),(912,32096,32076,'e71',3.333,5),(912,32097,32076,'711',3.333,5),(912,32098,32076,'11e',3.333,5),(912,32099,32076,'1e7',3.333,5),(912,32100,32076,'e79',3.333,5),(912,32101,32076,'79d',3.333,5),(912,32102,32076,'9d2',3.333,5),(912,32103,32076,'d28',3.333,5),(912,32104,32076,'28f',3.333,5),(912,32105,32076,'8f2',3.333,5),(912,32106,32076,'f21',3.333,5),(913,32108,32107,'naa',100,5),(913,32109,32108,'600',3.333,5),(913,32110,32108,'000',3.333,5),(913,32111,32108,'00c',3.333,5),(913,32112,32108,'0c2',3.333,5),(913,32113,32108,'c29',3.333,5),(913,32114,32108,'296',3.333,5),(913,32115,32108,'966',3.333,5),(913,32116,32108,'66b',3.333,5),(913,32117,32108,'6b6',3.333,5),(913,32118,32108,'b63',3.333,5),(913,32119,32108,'63a',3.333,5),(913,32120,32108,'3ac',3.333,5),(913,32121,32108,'acc',3.333,5),(913,32122,32108,'cca',3.333,5),(913,32123,32108,'ca9',3.333,5),(913,32124,32108,'a96',3.333,5),(913,32125,32108,'968',3.333,5),(913,32126,32108,'680',3.333,5),(913,32127,32108,'800',3.333,5),(913,32128,32108,'00a',3.333,5),(913,32129,32108,'0a1',3.333,5),(913,32130,32108,'a10',3.333,5),(913,32131,32108,'10b',3.333,5),(913,32132,32108,'0b1',3.333,5),(913,32133,32108,'b19',3.333,5),(913,32134,32108,'19d',3.333,5),(913,32135,32108,'9d1',3.333,5),(913,32136,32108,'d16',3.333,5),(913,32137,32108,'162',3.333,5),(913,32138,32108,'626',3.333,5),(914,32140,32139,'naa',100,5),(914,32141,32140,'600',3.333,5),(914,32142,32140,'000',3.333,5),(914,32143,32140,'00c',3.333,5),(914,32144,32140,'0c2',3.333,5),(914,32145,32140,'c29',3.333,5),(914,32146,32140,'291',3.333,5),(914,32147,32140,'916',3.333,5),(914,32148,32140,'16d',3.333,5),(914,32149,32140,'6db',3.333,5),(914,32150,32140,'db7',3.333,5),(914,32151,32140,'b73',3.333,5),(914,32152,32140,'738',3.333,5),(914,32153,32140,'38c',3.333,5),(914,32154,32140,'8c3',3.333,5),(914,32155,32140,'c3b',3.333,5),(914,32156,32140,'3b0',3.333,5),(914,32157,32140,'b0b',3.333,5),(914,32158,32140,'0b9',3.333,5),(914,32159,32140,'b9b',3.333,5),(914,32160,32140,'9b0',3.333,5),(914,32161,32140,'b0d',3.333,5),(914,32162,32140,'0d8',3.333,5),(914,32163,32140,'d87',3.333,5),(914,32164,32140,'877',3.333,5),(914,32165,32140,'77b',3.333,5),(914,32166,32140,'7bb',3.333,5),(914,32167,32140,'bb2',3.333,5),(914,32168,32140,'b23',3.333,5),(914,32169,32140,'23c',3.333,5),(914,32170,32140,'3c8',3.333,5),(915,32172,32171,'naa',100,5),(915,32173,32172,'600',3.333,5),(915,32174,32172,'000',3.333,5),(915,32175,32172,'00c',3.333,5),(915,32176,32172,'0c2',3.333,5),(915,32177,32172,'c29',3.333,5),(915,32178,32172,'29a',3.333,5),(915,32179,32172,'9a4',3.333,5),(915,32180,32172,'a42',3.333,5),(915,32181,32172,'42a',3.333,5),(915,32182,32172,'2a7',3.333,5),(915,32183,32172,'a7d',3.333,5),(915,32184,32172,'7db',3.333,5),(915,32185,32172,'db7',3.333,5),(915,32186,32172,'b75',3.333,5),(915,32187,32172,'759',3.333,5),(915,32188,32172,'59e',3.333,5),(915,32189,32172,'9ee',3.333,5),(915,32190,32172,'ee2',3.333,5),(915,32191,32172,'e20',3.333,5),(915,32192,32172,'209',3.333,5),(915,32193,32172,'09a',3.333,5),(915,32194,32172,'9a8',3.333,5),(915,32195,32172,'a8d',3.333,5),(915,32196,32172,'8da',3.333,5),(915,32197,32172,'da9',3.333,5),(915,32198,32172,'a9b',3.333,5),(915,32199,32172,'9bc',3.333,5),(915,32200,32172,'bc9',3.333,5),(915,32201,32172,'c94',3.333,5),(915,32202,32172,'945',3.333,5),(916,32204,32203,'naa',100,5),(916,32205,32204,'600',3.333,5),(916,32206,32204,'000',3.333,5),(916,32207,32204,'00c',3.333,5),(916,32208,32204,'0c2',3.333,5),(916,32209,32204,'c29',3.333,5),(916,32210,32204,'290',3.333,5),(916,32211,32204,'902',3.333,5),(916,32212,32204,'02a',3.333,5),(916,32213,32204,'2ac',3.333,5),(916,32214,32204,'ac5',3.333,5),(916,32215,32204,'c56',3.333,5),(916,32216,32204,'56e',3.333,5),(916,32217,32204,'6e6',3.333,5),(916,32218,32204,'e6f',3.333,5),(916,32219,32204,'6f4',3.333,5),(916,32220,32204,'f4f',3.333,5),(916,32221,32204,'4fb',3.333,5),(916,32222,32204,'fb3',3.333,5),(916,32223,32204,'b3e',3.333,5),(916,32224,32204,'3ec',3.333,5),(916,32225,32204,'ec2',3.333,5),(916,32226,32204,'c25',3.333,5),(916,32227,32204,'25a',3.333,5),(916,32228,32204,'5a9',3.333,5),(916,32229,32204,'a93',3.333,5),(916,32230,32204,'938',3.333,5),(916,32231,32204,'38e',3.333,5),(916,32232,32204,'8e5',3.333,5),(916,32233,32204,'e50',3.333,5),(916,32234,32204,'509',3.333,5),(917,32236,32235,'naa',100,5),(917,32237,32236,'600',3.333,5),(917,32238,32236,'000',3.333,5),(917,32239,32236,'00c',3.333,5),(917,32240,32236,'0c2',3.333,5),(917,32241,32236,'c29',3.333,5),(917,32242,32236,'29d',3.333,5),(917,32243,32236,'9d2',3.333,5),(917,32244,32236,'d25',3.333,5),(917,32245,32236,'250',3.333,5),(917,32246,32236,'50c',3.333,5),(917,32247,32236,'0cc',3.333,5),(917,32248,32236,'ccb',3.333,5),(917,32249,32236,'cbb',3.333,5),(917,32250,32236,'bb2',3.333,5),(917,32251,32236,'b2e',3.333,5),(917,32252,32236,'2ef',3.333,5),(917,32253,32236,'ef4',3.333,5),(917,32254,32236,'f4f',3.333,5),(917,32255,32236,'4f9',3.333,5),(917,32256,32236,'f95',3.333,5),(917,32257,32236,'957',3.333,5),(917,32258,32236,'57e',3.333,5),(917,32259,32236,'7e9',3.333,5),(917,32260,32236,'e90',3.333,5),(917,32261,32236,'90b',3.333,5),(917,32262,32236,'0ba',3.333,5),(917,32263,32236,'ba8',3.333,5),(917,32264,32236,'a8b',3.333,5),(917,32265,32236,'8b8',3.333,5),(917,32266,32236,'b86',3.333,5),(918,32268,32267,'naa',100,5),(918,32269,32268,'600',3.333,5),(918,32270,32268,'000',3.333,5),(918,32271,32268,'00c',3.333,5),(918,32272,32268,'0c2',3.333,5),(918,32273,32268,'c29',3.333,5),(918,32274,32268,'291',3.333,5),(918,32275,32268,'914',3.333,5),(918,32276,32268,'14a',3.333,5),(918,32277,32268,'4a3',3.333,5),(918,32278,32268,'a3a',3.333,5),(918,32279,32268,'3ae',3.333,5),(918,32280,32268,'ae9',3.333,5),(918,32281,32268,'e96',3.333,5),(918,32282,32268,'960',3.333,5),(918,32283,32268,'608',3.333,5),(918,32284,32268,'08b',3.333,5),(918,32285,32268,'8b2',3.333,5),(918,32286,32268,'b24',3.333,5),(918,32287,32268,'24b',3.333,5),(918,32288,32268,'4b8',3.333,5),(918,32289,32268,'b84',3.333,5),(918,32290,32268,'846',3.333,5),(918,32291,32268,'469',3.333,5),(918,32292,32268,'69a',3.333,5),(918,32293,32268,'9af',3.333,5),(918,32294,32268,'af3',3.333,5),(918,32295,32268,'f3c',3.333,5),(918,32296,32268,'3ca',3.333,5),(918,32297,32268,'caa',3.333,5),(918,32298,32268,'aa2',3.333,5),(919,32300,32299,'naa',100,5),(919,32301,32300,'600',3.333,5),(919,32302,32300,'000',3.333,5),(919,32303,32300,'00c',3.333,5),(919,32304,32300,'0c2',3.333,5),(919,32305,32300,'c29',3.333,5),(919,32306,32300,'293',3.333,5),(919,32307,32300,'93c',3.333,5),(919,32308,32300,'3c2',3.333,5),(919,32309,32300,'c2d',3.333,5),(919,32310,32300,'2d4',3.333,5),(919,32311,32300,'d46',3.333,5),(919,32312,32300,'469',3.333,5),(919,32313,32300,'692',3.333,5),(919,32314,32300,'920',3.333,5),(919,32315,32300,'20c',3.333,5),(919,32316,32300,'0c8',3.333,5),(919,32317,32300,'c80',3.333,5),(919,32318,32300,'803',3.333,5),(919,32319,32300,'03e',3.333,5),(919,32320,32300,'3ed',3.333,5),(919,32321,32300,'eda',3.333,5),(919,32322,32300,'da9',3.333,5),(919,32323,32300,'a9c',3.333,5),(919,32324,32300,'9c3',3.333,5),(919,32325,32300,'c3e',3.333,5),(919,32326,32300,'3e2',3.333,5),(919,32327,32300,'e20',3.333,5),(919,32328,32300,'207',3.333,5),(919,32329,32300,'07e',3.333,5),(919,32330,32300,'7e9',3.333,5),(920,32332,32331,'naa',100,5),(920,32333,32332,'600',3.333,5),(920,32334,32332,'000',3.333,5),(920,32335,32332,'00c',3.333,5),(920,32336,32332,'0c2',3.333,5),(920,32337,32332,'c29',3.333,5),(920,32338,32332,'299',3.333,5),(920,32339,32332,'991',3.333,5),(920,32340,32332,'919',3.333,5),(920,32341,32332,'191',3.333,5),(920,32342,32332,'91b',3.333,5),(920,32343,32332,'1bf',3.333,5),(920,32344,32332,'bfe',3.333,5),(920,32345,32332,'fef',3.333,5),(920,32346,32332,'ef2',3.333,5),(920,32347,32332,'f29',3.333,5),(920,32348,32332,'296',3.333,5),(920,32349,32332,'969',3.333,5),(920,32350,32332,'694',3.333,5),(920,32351,32332,'94d',3.333,5),(920,32352,32332,'4d6',3.333,5),(920,32353,32332,'d60',3.333,5),(920,32354,32332,'608',3.333,5),(920,32355,32332,'089',3.333,5),(920,32356,32332,'89d',3.333,5),(920,32357,32332,'9d6',3.333,5),(920,32358,32332,'d6d',3.333,5),(920,32359,32332,'6d3',3.333,5),(920,32360,32332,'d38',3.333,5),(920,32361,32332,'38a',3.333,5),(920,32362,32332,'8ac',3.333,5),(921,32364,32363,'naa',100,5),(921,32365,32364,'600',3.333,5),(921,32366,32364,'000',3.333,5),(921,32367,32364,'00c',3.333,5),(921,32368,32364,'0c2',3.333,5),(921,32369,32364,'c29',3.333,5),(921,32370,32364,'295',3.333,5),(921,32371,32364,'959',3.333,5),(921,32372,32364,'598',3.333,5),(921,32373,32364,'983',3.333,5),(921,32374,32364,'83d',3.333,5),(921,32375,32364,'3d7',3.333,5),(921,32376,32364,'d7f',3.333,5),(921,32377,32364,'7f1',3.333,5),(921,32378,32364,'f15',3.333,5),(921,32379,32364,'15b',3.333,5),(921,32380,32364,'5bb',3.333,5),(921,32381,32364,'bbe',3.333,5),(921,32382,32364,'bec',3.333,5),(921,32383,32364,'ec8',3.333,5),(921,32384,32364,'c87',3.333,5),(921,32385,32364,'874',3.333,5),(921,32386,32364,'748',3.333,5),(921,32387,32364,'485',3.333,5),(921,32388,32364,'853',3.333,5),(921,32389,32364,'53c',3.333,5),(921,32390,32364,'3cb',3.333,5),(921,32391,32364,'cbe',3.333,5),(921,32392,32364,'be8',3.333,5),(921,32393,32364,'e80',3.333,5),(921,32394,32364,'80d',3.333,5),(922,32396,32395,'naa',100,5),(922,32397,32396,'600',3.333,5),(922,32398,32396,'000',3.333,5),(922,32399,32396,'00c',3.333,5),(922,32400,32396,'0c2',3.333,5),(922,32401,32396,'c29',3.333,5),(922,32402,32396,'29d',3.333,5),(922,32403,32396,'9d1',3.333,5),(922,32404,32396,'d1f',3.333,5),(922,32405,32396,'1f0',3.333,5),(922,32406,32396,'f08',3.333,5),(922,32407,32396,'082',3.333,5),(922,32408,32396,'820',3.333,5),(922,32409,32396,'209',3.333,5),(922,32410,32396,'09d',3.333,5),(922,32411,32396,'9d8',3.333,5),(922,32412,32396,'d84',3.333,5),(922,32413,32396,'84b',3.333,5),(922,32414,32396,'4b2',3.333,5),(922,32415,32396,'b20',3.333,5),(922,32416,32396,'20a',3.333,5),(922,32417,32396,'0a5',3.333,5),(922,32418,32396,'a5d',3.333,5),(922,32419,32396,'5de',3.333,5),(922,32420,32396,'dea',3.333,5),(922,32421,32396,'ea2',3.333,5),(922,32422,32396,'a24',3.333,5),(922,32423,32396,'244',3.333,5),(922,32424,32396,'44b',3.333,5),(922,32425,32396,'4bc',3.333,5),(922,32426,32396,'bcd',3.333,5),(923,32428,32427,'naa',100,5),(923,32429,32428,'600',3.333,5),(923,32430,32428,'000',3.333,5),(923,32431,32428,'00c',3.333,5),(923,32432,32428,'0c2',3.333,5),(923,32433,32428,'c29',3.333,5),(923,32434,32428,'29c',3.333,5),(923,32435,32428,'9cb',3.333,5),(923,32436,32428,'cba',3.333,5),(923,32437,32428,'ba7',3.333,5),(923,32438,32428,'a7d',3.333,5),(923,32439,32428,'7d9',3.333,5),(923,32440,32428,'d97',3.333,5),(923,32441,32428,'97b',3.333,5),(923,32442,32428,'7b8',3.333,5),(923,32443,32428,'b87',3.333,5),(923,32444,32428,'877',3.333,5),(923,32445,32428,'77a',3.333,5),(923,32446,32428,'7aa',3.333,5),(923,32447,32428,'aa1',3.333,5),(923,32448,32428,'a1f',3.333,5),(923,32449,32428,'1f4',3.333,5),(923,32450,32428,'f49',3.333,5),(923,32451,32428,'49c',3.333,5),(923,32452,32428,'9c4',3.333,5),(923,32453,32428,'c49',3.333,5),(923,32454,32428,'49c',3.333,5),(923,32455,32428,'9c5',3.333,5),(923,32456,32428,'c5f',3.333,5),(923,32457,32428,'5f3',3.333,5),(923,32458,32428,'f3d',3.333,5),(924,32460,32459,'naa',100,5),(924,32461,32460,'600',3.333,5),(924,32462,32460,'000',3.333,5),(924,32463,32460,'00c',3.333,5),(924,32464,32460,'0c2',3.333,5),(924,32465,32460,'c29',3.333,5),(924,32466,32460,'297',3.333,5),(924,32467,32460,'975',3.333,5),(924,32468,32460,'75f',3.333,5),(924,32469,32460,'5f3',3.333,5),(924,32470,32460,'f31',3.333,5),(924,32471,32460,'315',3.333,5),(924,32472,32460,'156',3.333,5),(924,32473,32460,'564',3.333,5),(924,32474,32460,'647',3.333,5),(924,32475,32460,'471',3.333,5),(924,32476,32460,'717',3.333,5),(924,32477,32460,'17f',3.333,5),(924,32478,32460,'7f5',3.333,5),(924,32479,32460,'f58',3.333,5),(924,32480,32460,'585',3.333,5),(924,32481,32460,'857',3.333,5),(924,32482,32460,'570',3.333,5),(924,32483,32460,'702',3.333,5),(924,32484,32460,'027',3.333,5),(924,32485,32460,'275',3.333,5),(924,32486,32460,'758',3.333,5),(924,32487,32460,'586',3.333,5),(924,32488,32460,'86c',3.333,5),(924,32489,32460,'6cc',3.333,5),(924,32490,32460,'cc1',3.333,5),(925,32492,32491,'naa',100,5),(925,32493,32492,'600',3.333,5),(925,32494,32492,'000',3.333,5),(925,32495,32492,'00c',3.333,5),(925,32496,32492,'0c2',3.333,5),(925,32497,32492,'c29',3.333,5),(925,32498,32492,'298',3.333,5),(925,32499,32492,'987',3.333,5),(925,32500,32492,'87b',3.333,5),(925,32501,32492,'7bf',3.333,5),(925,32502,32492,'bf4',3.333,5),(925,32503,32492,'f4e',3.333,5),(925,32504,32492,'4e8',3.333,5),(925,32505,32492,'e8d',3.333,5),(925,32506,32492,'8d2',3.333,5),(925,32507,32492,'d23',3.333,5),(925,32508,32492,'238',3.333,5),(925,32509,32492,'383',3.333,5),(925,32510,32492,'83d',3.333,5),(925,32511,32492,'3da',3.333,5),(925,32512,32492,'dac',3.333,5),(925,32513,32492,'ace',3.333,5),(925,32514,32492,'cee',3.333,5),(925,32515,32492,'eec',3.333,5),(925,32516,32492,'ecc',3.333,5),(925,32517,32492,'cc5',3.333,5),(925,32518,32492,'c5f',3.333,5),(925,32519,32492,'5f6',3.333,5),(925,32520,32492,'f65',3.333,5),(925,32521,32492,'65d',3.333,5),(925,32522,32492,'5d9',3.333,5),(926,32524,32523,'naa',100,5),(926,32525,32524,'600',3.333,5),(926,32526,32524,'000',3.333,5),(926,32527,32524,'00c',3.333,5),(926,32528,32524,'0c2',3.333,5),(926,32529,32524,'c29',3.333,5),(926,32530,32524,'295',3.333,5),(926,32531,32524,'95f',3.333,5),(926,32532,32524,'5f1',3.333,5),(926,32533,32524,'f19',3.333,5),(926,32534,32524,'19d',3.333,5),(926,32535,32524,'9d5',3.333,5),(926,32536,32524,'d58',3.333,5),(926,32537,32524,'58d',3.333,5),(926,32538,32524,'8dc',3.333,5),(926,32539,32524,'dcb',3.333,5),(926,32540,32524,'cb2',3.333,5),(926,32541,32524,'b23',3.333,5),(926,32542,32524,'237',3.333,5),(926,32543,32524,'371',3.333,5),(926,32544,32524,'716',3.333,5),(926,32545,32524,'16e',3.333,5),(926,32546,32524,'6e9',3.333,5),(926,32547,32524,'e9c',3.333,5),(926,32548,32524,'9c2',3.333,5),(926,32549,32524,'c26',3.333,5),(926,32550,32524,'267',3.333,5),(926,32551,32524,'67d',3.333,5),(926,32552,32524,'7d3',3.333,5),(926,32553,32524,'d3e',3.333,5),(926,32554,32524,'3e0',3.333,5),(927,32556,32555,'naa',100,5),(927,32557,32556,'600',3.333,5),(927,32558,32556,'000',3.333,5),(927,32559,32556,'00c',3.333,5),(927,32560,32556,'0c2',3.333,5),(927,32561,32556,'c29',3.333,5),(927,32562,32556,'29d',3.333,5),(927,32563,32556,'9df',3.333,5),(927,32564,32556,'dfd',3.333,5),(927,32565,32556,'fdb',3.333,5),(927,32566,32556,'dbf',3.333,5),(927,32567,32556,'bf2',3.333,5),(927,32568,32556,'f2e',3.333,5),(927,32569,32556,'2ee',3.333,5),(927,32570,32556,'eea',3.333,5),(927,32571,32556,'ea9',3.333,5),(927,32572,32556,'a9c',3.333,5),(927,32573,32556,'9ca',3.333,5),(927,32574,32556,'ca8',3.333,5),(927,32575,32556,'a82',3.333,5),(927,32576,32556,'82d',3.333,5),(927,32577,32556,'2d3',3.333,5),(927,32578,32556,'d33',3.333,5),(927,32579,32556,'337',3.333,5),(927,32580,32556,'375',3.333,5),(927,32581,32556,'750',3.333,5),(927,32582,32556,'50f',3.333,5),(927,32583,32556,'0f8',3.333,5),(927,32584,32556,'f86',3.333,5),(927,32585,32556,'867',3.333,5),(927,32586,32556,'671',3.333,5),(928,32588,32587,'naa',100,5),(928,32589,32588,'600',3.333,5),(928,32590,32588,'000',3.333,5),(928,32591,32588,'00c',3.333,5),(928,32592,32588,'0c2',3.333,5),(928,32593,32588,'c29',3.333,5),(928,32594,32588,'29f',3.333,5),(928,32595,32588,'9f1',3.333,5),(928,32596,32588,'f11',3.333,5),(928,32597,32588,'11c',3.333,5),(928,32598,32588,'1cd',3.333,5),(928,32599,32588,'cdd',3.333,5),(928,32600,32588,'dda',3.333,5),(928,32601,32588,'da4',3.333,5),(928,32602,32588,'a49',3.333,5),(928,32603,32588,'490',3.333,5),(928,32604,32588,'905',3.333,5),(928,32605,32588,'053',3.333,5),(928,32606,32588,'536',3.333,5),(928,32607,32588,'36b',3.333,5),(928,32608,32588,'6bb',3.333,5),(928,32609,32588,'bb8',3.333,5),(928,32610,32588,'b87',3.333,5),(928,32611,32588,'874',3.333,5),(928,32612,32588,'742',3.333,5),(928,32613,32588,'42a',3.333,5),(928,32614,32588,'2a5',3.333,5),(928,32615,32588,'a53',3.333,5),(928,32616,32588,'532',3.333,5),(928,32617,32588,'323',3.333,5),(928,32618,32588,'23f',3.333,5),(929,32620,32619,'naa',100,5),(929,32621,32620,'600',3.333,5),(929,32622,32620,'000',3.333,5),(929,32623,32620,'00c',3.333,5),(929,32624,32620,'0c2',3.333,5),(929,32625,32620,'c29',3.333,5),(929,32626,32620,'294',3.333,5),(929,32627,32620,'948',3.333,5),(929,32628,32620,'48a',3.333,5),(929,32629,32620,'8a3',3.333,5),(929,32630,32620,'a3a',3.333,5),(929,32631,32620,'3aa',3.333,5),(929,32632,32620,'aaf',3.333,5),(929,32633,32620,'afa',3.333,5),(929,32634,32620,'fa7',3.333,5),(929,32635,32620,'a72',3.333,5),(929,32636,32620,'726',3.333,5),(929,32637,32620,'26f',3.333,5),(929,32638,32620,'6f2',3.333,5),(929,32639,32620,'f28',3.333,5),(929,32640,32620,'28d',3.333,5),(929,32641,32620,'8d0',3.333,5),(929,32642,32620,'d08',3.333,5),(929,32643,32620,'084',3.333,5),(929,32644,32620,'84e',3.333,5),(929,32645,32620,'4ec',3.333,5),(929,32646,32620,'ec0',3.333,5),(929,32647,32620,'c04',3.333,5),(929,32648,32620,'04e',3.333,5),(929,32649,32620,'4e3',3.333,5),(929,32650,32620,'e36',3.333,5),(930,32652,32651,'naa',100,5),(930,32653,32652,'600',3.333,5),(930,32654,32652,'000',3.333,5),(930,32655,32652,'00c',3.333,5),(930,32656,32652,'0c2',3.333,5),(930,32657,32652,'c29',3.333,5),(930,32658,32652,'296',3.333,5),(930,32659,32652,'966',3.333,5),(930,32660,32652,'661',3.333,5),(930,32661,32652,'614',3.333,5),(930,32662,32652,'148',3.333,5),(930,32663,32652,'482',3.333,5),(930,32664,32652,'827',3.333,5),(930,32665,32652,'279',3.333,5),(930,32666,32652,'792',3.333,5),(930,32667,32652,'925',3.333,5),(930,32668,32652,'25f',3.333,5),(930,32669,32652,'5fc',3.333,5),(930,32670,32652,'fc5',3.333,5),(930,32671,32652,'c5d',3.333,5),(930,32672,32652,'5d2',3.333,5),(930,32673,32652,'d22',3.333,5),(930,32674,32652,'228',3.333,5),(930,32675,32652,'285',3.333,5),(930,32676,32652,'850',3.333,5),(930,32677,32652,'509',3.333,5),(930,32678,32652,'091',3.333,5),(930,32679,32652,'912',3.333,5),(930,32680,32652,'129',3.333,5),(930,32681,32652,'299',3.333,5),(930,32682,32652,'99a',3.333,5),(931,32684,32683,'naa',100,5),(931,32685,32684,'600',3.333,5),(931,32686,32684,'000',3.333,5),(931,32687,32684,'00c',3.333,5),(931,32688,32684,'0c2',3.333,5),(931,32689,32684,'c29',3.333,5),(931,32690,32684,'290',3.333,5),(931,32691,32684,'90e',3.333,5),(931,32692,32684,'0e0',3.333,5),(931,32693,32684,'e01',3.333,5),(931,32694,32684,'01b',3.333,5),(931,32695,32684,'1b4',3.333,5),(931,32696,32684,'b46',3.333,5),(931,32697,32684,'46d',3.333,5),(931,32698,32684,'6d7',3.333,5),(931,32699,32684,'d74',3.333,5),(931,32700,32684,'749',3.333,5),(931,32701,32684,'496',3.333,5),(931,32702,32684,'969',3.333,5),(931,32703,32684,'69a',3.333,5),(931,32704,32684,'9ab',3.333,5),(931,32705,32684,'aba',3.333,5),(931,32706,32684,'ba3',3.333,5),(931,32707,32684,'a33',3.333,5),(931,32708,32684,'33a',3.333,5),(931,32709,32684,'3a9',3.333,5),(931,32710,32684,'a9c',3.333,5),(931,32711,32684,'9cb',3.333,5),(931,32712,32684,'cb2',3.333,5),(931,32713,32684,'b26',3.333,5),(931,32714,32684,'26b',3.333,5),(932,32716,32715,'naa',100,5),(932,32717,32716,'600',3.333,5),(932,32718,32716,'000',3.333,5),(932,32719,32716,'00c',3.333,5),(932,32720,32716,'0c2',3.333,5),(932,32721,32716,'c29',3.333,5),(932,32722,32716,'29f',3.333,5),(932,32723,32716,'9f9',3.333,5),(932,32724,32716,'f9d',3.333,5),(932,32725,32716,'9d5',3.333,5),(932,32726,32716,'d5e',3.333,5),(932,32727,32716,'5e6',3.333,5),(932,32728,32716,'e68',3.333,5),(932,32729,32716,'683',3.333,5),(932,32730,32716,'83f',3.333,5),(932,32731,32716,'3ff',3.333,5),(932,32732,32716,'ffa',3.333,5),(932,32733,32716,'fa7',3.333,5),(932,32734,32716,'a70',3.333,5),(932,32735,32716,'705',3.333,5),(932,32736,32716,'053',3.333,5),(932,32737,32716,'535',3.333,5),(932,32738,32716,'356',3.333,5),(932,32739,32716,'56c',3.333,5),(932,32740,32716,'6cb',3.333,5),(932,32741,32716,'cbb',3.333,5),(932,32742,32716,'bb3',3.333,5),(932,32743,32716,'b38',3.333,5),(932,32744,32716,'38d',3.333,5),(932,32745,32716,'8de',3.333,5),(932,32746,32716,'def',3.333,5),(933,32748,32747,'naa',100,5),(933,32749,32748,'600',3.333,5),(933,32750,32748,'000',3.333,5),(933,32751,32748,'00c',3.333,5),(933,32752,32748,'0c2',3.333,5),(933,32753,32748,'c29',3.333,5),(933,32754,32748,'290',3.333,5),(933,32755,32748,'904',3.333,5),(933,32756,32748,'049',3.333,5),(933,32757,32748,'495',3.333,5),(933,32758,32748,'95d',3.333,5),(933,32759,32748,'5db',3.333,5),(933,32760,32748,'db6',3.333,5),(933,32761,32748,'b67',3.333,5),(933,32762,32748,'67c',3.333,5),(933,32763,32748,'7ce',3.333,5),(933,32764,32748,'ce2',3.333,5),(933,32765,32748,'e2e',3.333,5),(933,32766,32748,'2e2',3.333,5),(933,32767,32748,'e2d',3.333,5),(933,32768,32748,'2d9',3.333,5),(933,32769,32748,'d9d',3.333,5),(933,32770,32748,'9d4',3.333,5),(933,32771,32748,'d4c',3.333,5),(933,32772,32748,'4c8',3.333,5),(933,32773,32748,'c8d',3.333,5),(933,32774,32748,'8d2',3.333,5),(933,32775,32748,'d29',3.333,5),(933,32776,32748,'29e',3.333,5),(933,32777,32748,'9e1',3.333,5),(933,32778,32748,'e1f',3.333,5),(934,32780,32779,'naa',100,5),(934,32781,32780,'600',3.333,5),(934,32782,32780,'000',3.333,5),(934,32783,32780,'00c',3.333,5),(934,32784,32780,'0c2',3.333,5),(934,32785,32780,'c29',3.333,5),(934,32786,32780,'29c',3.333,5),(934,32787,32780,'9c5',3.333,5),(934,32788,32780,'c57',3.333,5),(934,32789,32780,'574',3.333,5),(934,32790,32780,'744',3.333,5),(934,32791,32780,'448',3.333,5),(934,32792,32780,'489',3.333,5),(934,32793,32780,'89c',3.333,5),(934,32794,32780,'9c3',3.333,5),(934,32795,32780,'c33',3.333,5),(934,32796,32780,'331',3.333,5),(934,32797,32780,'31c',3.333,5),(934,32798,32780,'1ce',3.333,5),(934,32799,32780,'ceb',3.333,5),(934,32800,32780,'ebc',3.333,5),(934,32801,32780,'bc2',3.333,5),(934,32802,32780,'c20',3.333,5),(934,32803,32780,'20d',3.333,5),(934,32804,32780,'0d4',3.333,5),(934,32805,32780,'d4b',3.333,5),(934,32806,32780,'4b0',3.333,5),(934,32807,32780,'b0d',3.333,5),(934,32808,32780,'0d4',3.333,5),(934,32809,32780,'d48',3.333,5),(934,32810,32780,'481',3.333,5),(935,32812,32811,'naa',100,5),(935,32813,32812,'600',3.333,5),(935,32814,32812,'000',3.333,5),(935,32815,32812,'00c',3.333,5),(935,32816,32812,'0c2',3.333,5),(935,32817,32812,'c29',3.333,5),(935,32818,32812,'293',3.333,5),(935,32819,32812,'939',3.333,5),(935,32820,32812,'399',3.333,5),(935,32821,32812,'99e',3.333,5),(935,32822,32812,'9e1',3.333,5),(935,32823,32812,'e19',3.333,5),(935,32824,32812,'19a',3.333,5),(935,32825,32812,'9ae',3.333,5),(935,32826,32812,'aec',3.333,5),(935,32827,32812,'ece',3.333,5),(935,32828,32812,'cea',3.333,5),(935,32829,32812,'ea0',3.333,5),(935,32830,32812,'a00',3.333,5),(935,32831,32812,'005',3.333,5),(935,32832,32812,'054',3.333,5),(935,32833,32812,'54a',3.333,5),(935,32834,32812,'4ad',3.333,5),(935,32835,32812,'ad6',3.333,5),(935,32836,32812,'d62',3.333,5),(935,32837,32812,'62a',3.333,5),(935,32838,32812,'2ab',3.333,5),(935,32839,32812,'ab6',3.333,5),(935,32840,32812,'b6d',3.333,5),(935,32841,32812,'6db',3.333,5),(935,32842,32812,'db7',3.333,5),(936,32844,32843,'naa',100,5),(936,32845,32844,'600',3.333,5),(936,32846,32844,'000',3.333,5),(936,32847,32844,'00c',3.333,5),(936,32848,32844,'0c2',3.333,5),(936,32849,32844,'c29',3.333,5),(936,32850,32844,'29e',3.333,5),(936,32851,32844,'9ea',3.333,5),(936,32852,32844,'ea9',3.333,5),(936,32853,32844,'a91',3.333,5),(936,32854,32844,'912',3.333,5),(936,32855,32844,'129',3.333,5),(936,32856,32844,'295',3.333,5),(936,32857,32844,'954',3.333,5),(936,32858,32844,'54e',3.333,5),(936,32859,32844,'4ea',3.333,5),(936,32860,32844,'eae',3.333,5),(936,32861,32844,'ae0',3.333,5),(936,32862,32844,'e08',3.333,5),(936,32863,32844,'087',3.333,5),(936,32864,32844,'87f',3.333,5),(936,32865,32844,'7fd',3.333,5),(936,32866,32844,'fd5',3.333,5),(936,32867,32844,'d58',3.333,5),(936,32868,32844,'58a',3.333,5),(936,32869,32844,'8a9',3.333,5),(936,32870,32844,'a9c',3.333,5),(936,32871,32844,'9c1',3.333,5),(936,32872,32844,'c13',3.333,5),(936,32873,32844,'137',3.333,5),(936,32874,32844,'37d',3.333,5),(937,32876,32875,'naa',100,5),(937,32877,32876,'600',3.333,5),(937,32878,32876,'000',3.333,5),(937,32879,32876,'00c',3.333,5),(937,32880,32876,'0c2',3.333,5),(937,32881,32876,'c29',3.333,5),(937,32882,32876,'296',3.333,5),(937,32883,32876,'967',3.333,5),(937,32884,32876,'671',3.333,5),(937,32885,32876,'71e',3.333,5),(937,32886,32876,'1ee',3.333,5),(937,32887,32876,'ee8',3.333,5),(937,32888,32876,'e88',3.333,5),(937,32889,32876,'88b',3.333,5),(937,32890,32876,'8bf',3.333,5),(937,32891,32876,'bfa',3.333,5),(937,32892,32876,'fa2',3.333,5),(937,32893,32876,'a2b',3.333,5),(937,32894,32876,'2b2',3.333,5),(937,32895,32876,'b2c',3.333,5),(937,32896,32876,'2c5',3.333,5),(937,32897,32876,'c5f',3.333,5),(937,32898,32876,'5f5',3.333,5),(937,32899,32876,'f5c',3.333,5),(937,32900,32876,'5c3',3.333,5),(937,32901,32876,'c38',3.333,5),(937,32902,32876,'383',3.333,5),(937,32903,32876,'832',3.333,5),(937,32904,32876,'322',3.333,5),(937,32905,32876,'225',3.333,5),(937,32906,32876,'25b',3.333,5),(938,32908,32907,'naa',100,5),(938,32909,32908,'600',3.333,5),(938,32910,32908,'000',3.333,5),(938,32911,32908,'00c',3.333,5),(938,32912,32908,'0c2',3.333,5),(938,32913,32908,'c29',3.333,5),(938,32914,32908,'290',3.333,5),(938,32915,32908,'906',3.333,5),(938,32916,32908,'066',3.333,5),(938,32917,32908,'66c',3.333,5),(938,32918,32908,'6c5',3.333,5),(938,32919,32908,'c56',3.333,5),(938,32920,32908,'562',3.333,5),(938,32921,32908,'626',3.333,5),(938,32922,32908,'264',3.333,5),(938,32923,32908,'64b',3.333,5),(938,32924,32908,'4b0',3.333,5),(938,32925,32908,'b08',3.333,5),(938,32926,32908,'08c',3.333,5),(938,32927,32908,'8c2',3.333,5),(938,32928,32908,'c29',3.333,5),(938,32929,32908,'29e',3.333,5),(938,32930,32908,'9e9',3.333,5),(938,32931,32908,'e90',3.333,5),(938,32932,32908,'904',3.333,5),(938,32933,32908,'048',3.333,5),(938,32934,32908,'48b',3.333,5),(938,32935,32908,'8b1',3.333,5),(938,32936,32908,'b1c',3.333,5),(938,32937,32908,'1c9',3.333,5),(938,32938,32908,'c99',3.333,5),(939,32940,32939,'naa',100,5),(939,32941,32940,'600',3.333,5),(939,32942,32940,'000',3.333,5),(939,32943,32940,'00c',3.333,5),(939,32944,32940,'0c2',3.333,5),(939,32945,32940,'c29',3.333,5),(939,32946,32940,'297',3.333,5),(939,32947,32940,'974',3.333,5),(939,32948,32940,'74f',3.333,5),(939,32949,32940,'4fc',3.333,5),(939,32950,32940,'fca',3.333,5),(939,32951,32940,'ca4',3.333,5),(939,32952,32940,'a4d',3.333,5),(939,32953,32940,'4d4',3.333,5),(939,32954,32940,'d45',3.333,5),(939,32955,32940,'450',3.333,5),(939,32956,32940,'504',3.333,5),(939,32957,32940,'046',3.333,5),(939,32958,32940,'468',3.333,5),(939,32959,32940,'68b',3.333,5),(939,32960,32940,'8b7',3.333,5),(939,32961,32940,'b7b',3.333,5),(939,32962,32940,'7bb',3.333,5),(939,32963,32940,'bb1',3.333,5),(939,32964,32940,'b14',3.333,5),(939,32965,32940,'140',3.333,5),(939,32966,32940,'401',3.333,5),(939,32967,32940,'017',3.333,5),(939,32968,32940,'170',3.333,5),(939,32969,32940,'708',3.333,5),(939,32970,32940,'08b',3.333,5),(940,32972,32971,'naa',100,5),(940,32973,32972,'600',3.333,5),(940,32974,32972,'000',3.333,5),(940,32975,32972,'00c',3.333,5),(940,32976,32972,'0c2',3.333,5),(940,32977,32972,'c29',3.333,5),(940,32978,32972,'29a',3.333,5),(940,32979,32972,'9af',3.333,5),(940,32980,32972,'af2',3.333,5),(940,32981,32972,'f2c',3.333,5),(940,32982,32972,'2cf',3.333,5),(940,32983,32972,'cf7',3.333,5),(940,32984,32972,'f77',3.333,5),(940,32985,32972,'773',3.333,5),(940,32986,32972,'733',3.333,5),(940,32987,32972,'330',3.333,5),(940,32988,32972,'307',3.333,5),(940,32989,32972,'07e',3.333,5),(940,32990,32972,'7e9',3.333,5),(940,32991,32972,'e9c',3.333,5),(940,32992,32972,'9ca',3.333,5),(940,32993,32972,'ca4',3.333,5),(940,32994,32972,'a42',3.333,5),(940,32995,32972,'427',3.333,5),(940,32996,32972,'27a',3.333,5),(940,32997,32972,'7ad',3.333,5),(940,32998,32972,'ad5',3.333,5),(940,32999,32972,'d5d',3.333,5),(940,33000,32972,'5d7',3.333,5),(940,33001,32972,'d70',3.333,5),(940,33002,32972,'70c',3.333,5),(941,33004,33003,'naa',100,5),(941,33005,33004,'600',3.333,5),(941,33006,33004,'000',3.333,5),(941,33007,33004,'00c',3.333,5),(941,33008,33004,'0c2',3.333,5),(941,33009,33004,'c29',3.333,5),(941,33010,33004,'294',3.333,5),(941,33011,33004,'940',3.333,5),(941,33012,33004,'404',3.333,5),(941,33013,33004,'046',3.333,5),(941,33014,33004,'46f',3.333,5),(941,33015,33004,'6f8',3.333,5),(941,33016,33004,'f87',3.333,5),(941,33017,33004,'87f',3.333,5),(941,33018,33004,'7fc',3.333,5),(941,33019,33004,'fc5',3.333,5),(941,33020,33004,'c5f',3.333,5),(941,33021,33004,'5fd',3.333,5),(941,33022,33004,'fdc',3.333,5),(941,33023,33004,'dc0',3.333,5),(941,33024,33004,'c0a',3.333,5),(941,33025,33004,'0aa',3.333,5),(941,33026,33004,'aa9',3.333,5),(941,33027,33004,'a9b',3.333,5),(941,33028,33004,'9b5',3.333,5),(941,33029,33004,'b55',3.333,5),(941,33030,33004,'55b',3.333,5),(941,33031,33004,'5b6',3.333,5),(941,33032,33004,'b60',3.333,5),(941,33033,33004,'606',3.333,5),(941,33034,33004,'062',3.333,5),(942,33036,33035,'naa',100,5),(942,33037,33036,'600',3.333,5),(942,33038,33036,'000',3.333,5),(942,33039,33036,'00c',3.333,5),(942,33040,33036,'0c2',3.333,5),(942,33041,33036,'c29',3.333,5),(942,33042,33036,'29b',3.333,5),(942,33043,33036,'9b3',3.333,5),(942,33044,33036,'b3e',3.333,5),(942,33045,33036,'3ec',3.333,5),(942,33046,33036,'ec8',3.333,5),(942,33047,33036,'c81',3.333,5),(942,33048,33036,'816',3.333,5),(942,33049,33036,'16a',3.333,5),(942,33050,33036,'6a0',3.333,5),(942,33051,33036,'a0b',3.333,5),(942,33052,33036,'0b6',3.333,5),(942,33053,33036,'b6f',3.333,5),(942,33054,33036,'6f9',3.333,5),(942,33055,33036,'f9c',3.333,5),(942,33056,33036,'9c1',3.333,5),(942,33057,33036,'c12',3.333,5),(942,33058,33036,'12e',3.333,5),(942,33059,33036,'2e2',3.333,5),(942,33060,33036,'e22',3.333,5),(942,33061,33036,'22c',3.333,5),(942,33062,33036,'2cf',3.333,5),(942,33063,33036,'cf0',3.333,5),(942,33064,33036,'f07',3.333,5),(942,33065,33036,'070',3.333,5),(942,33066,33036,'700',3.333,5),(943,33068,33067,'hgw',8.333,5),(943,33069,33067,'gw2',8.333,5),(943,33070,33067,'w2k',8.333,5),(943,33071,33067,'2k8',8.333,5),(943,33072,33067,'k8r',8.333,5),(943,33073,33067,'8r2',8.333,5),(943,33074,33067,'r23',8.333,5),(943,33075,33067,'232',8.333,5),(943,33076,33067,'32v',8.333,5),(943,33077,33067,'2vm',8.333,5),(943,33078,33067,'vm1',8.333,5),(943,33079,33067,'m13',8.333,5),(944,33081,33080,'naa',100,5),(944,33082,33081,'600',3.333,5),(944,33083,33081,'000',3.333,5),(944,33084,33081,'00c',3.333,5),(944,33085,33081,'0c2',3.333,5),(944,33086,33081,'c29',3.333,5),(944,33087,33081,'29f',3.333,5),(944,33088,33081,'9fd',3.333,5),(944,33089,33081,'fd7',3.333,5),(944,33090,33081,'d79',3.333,5),(944,33091,33081,'797',3.333,5),(944,33092,33081,'972',3.333,5),(944,33093,33081,'728',3.333,5),(944,33094,33081,'287',3.333,5),(944,33095,33081,'878',3.333,5),(944,33096,33081,'787',3.333,5),(944,33097,33081,'875',3.333,5),(944,33098,33081,'756',3.333,5),(944,33099,33081,'561',3.333,5),(944,33100,33081,'615',3.333,5),(944,33101,33081,'159',3.333,5),(944,33102,33081,'590',3.333,5),(944,33103,33081,'903',3.333,5),(944,33104,33081,'039',3.333,5),(944,33105,33081,'39f',3.333,5),(944,33106,33081,'9f9',3.333,5),(944,33107,33081,'f96',3.333,5),(944,33108,33081,'96d',3.333,5),(944,33109,33081,'6d9',3.333,5),(944,33110,33081,'d92',3.333,5),(944,33111,33081,'925',3.333,5),(945,33113,33112,'naa',100,5),(945,33114,33113,'600',3.333,5),(945,33115,33113,'00a',3.333,5),(945,33116,33113,'0a0',3.333,5),(945,33117,33113,'a09',3.333,5),(945,33118,33113,'098',3.333,5),(945,33119,33113,'980',3.333,5),(945,33120,33113,'804',3.333,5),(945,33121,33113,'044',3.333,5),(945,33122,33113,'443',3.333,5),(945,33123,33113,'430',3.333,5),(945,33124,33113,'307',3.333,5),(945,33125,33113,'072',3.333,5),(945,33126,33113,'725',3.333,5),(945,33127,33113,'259',3.333,5),(945,33128,33113,'593',3.333,5),(945,33129,33113,'931',3.333,5),(945,33130,33113,'313',3.333,5),(945,33131,33113,'13f',3.333,5),(945,33132,33113,'3f3',3.333,5),(945,33133,33113,'f33',3.333,5),(945,33134,33113,'334',3.333,5),(945,33135,33113,'345',3.333,5),(945,33136,33113,'455',3.333,5),(945,33137,33113,'556',3.333,5),(945,33138,33113,'563',3.333,5),(945,33139,33113,'639',3.333,5),(945,33140,33113,'393',3.333,5),(945,33141,33113,'934',3.333,5),(945,33142,33113,'345',3.333,5),(945,33143,33113,'453',3.333,5),(946,33145,33144,'naa',100,5),(946,33146,33145,'600',3.333,5),(946,33147,33145,'00a',3.333,5),(946,33148,33145,'0a0',3.333,5),(946,33149,33145,'a09',3.333,5),(946,33150,33145,'098',3.333,5),(946,33151,33145,'980',3.333,5),(946,33152,33145,'804',3.333,5),(946,33153,33145,'044',3.333,5),(946,33154,33145,'443',3.333,5),(946,33155,33145,'430',3.333,5),(946,33156,33145,'307',3.333,5),(946,33157,33145,'072',3.333,5),(946,33158,33145,'725',3.333,5),(946,33159,33145,'259',3.333,5),(946,33160,33145,'593',3.333,5),(946,33161,33145,'931',3.333,5),(946,33162,33145,'313',3.333,5),(946,33163,33145,'13f',3.333,5),(946,33164,33145,'3f3',3.333,5),(946,33165,33145,'f33',3.333,5),(946,33166,33145,'334',3.333,5),(946,33167,33145,'345',3.333,5),(946,33168,33145,'455',3.333,5),(946,33169,33145,'556',3.333,5),(946,33170,33145,'563',3.333,5),(946,33171,33145,'639',3.333,5),(946,33172,33145,'393',3.333,5),(946,33173,33145,'934',3.333,5),(946,33174,33145,'345',3.333,5),(946,33175,33145,'454',3.333,5),(947,33177,33176,'naa',100,5),(947,33178,33177,'600',3.333,5),(947,33179,33177,'00a',3.333,5),(947,33180,33177,'0a0',3.333,5),(947,33181,33177,'a09',3.333,5),(947,33182,33177,'098',3.333,5),(947,33183,33177,'980',3.333,5),(947,33184,33177,'804',3.333,5),(947,33185,33177,'044',3.333,5),(947,33186,33177,'443',3.333,5),(947,33187,33177,'430',3.333,5),(947,33188,33177,'307',3.333,5),(947,33189,33177,'075',3.333,5),(947,33190,33177,'753',3.333,5),(947,33191,33177,'535',3.333,5),(947,33192,33177,'357',3.333,5),(947,33193,33177,'573',3.333,5),(947,33194,33177,'732',3.333,5),(947,33195,33177,'32b',3.333,5),(947,33196,33177,'2b3',3.333,5),(947,33197,33177,'b33',3.333,5),(947,33198,33177,'334',3.333,5),(947,33199,33177,'345',3.333,5),(947,33200,33177,'457',3.333,5),(947,33201,33177,'571',3.333,5),(947,33202,33177,'715',3.333,5),(947,33203,33177,'153',3.333,5),(947,33204,33177,'533',3.333,5),(947,33205,33177,'336',3.333,5),(947,33206,33177,'364',3.333,5),(947,33207,33177,'644',3.333,5),(948,33209,33208,'naa',100,5),(948,33210,33209,'600',3.333,5),(948,33211,33209,'00a',3.333,5),(948,33212,33209,'0a0',3.333,5),(948,33213,33209,'a09',3.333,5),(948,33214,33209,'098',3.333,5),(948,33215,33209,'980',3.333,5),(948,33216,33209,'804',3.333,5),(948,33217,33209,'044',3.333,5),(948,33218,33209,'443',3.333,5),(948,33219,33209,'430',3.333,5),(948,33220,33209,'307',3.333,5),(948,33221,33209,'075',3.333,5),(948,33222,33209,'753',3.333,5),(948,33223,33209,'535',3.333,5),(948,33224,33209,'357',3.333,5),(948,33225,33209,'573',3.333,5),(948,33226,33209,'732',3.333,5),(948,33227,33209,'32b',3.333,5),(948,33228,33209,'2b3',3.333,5),(948,33229,33209,'b33',3.333,5),(948,33230,33209,'334',3.333,5),(948,33231,33209,'345',3.333,5),(948,33232,33209,'457',3.333,5),(948,33233,33209,'571',3.333,5),(948,33234,33209,'715',3.333,5),(948,33235,33209,'153',3.333,5),(948,33236,33209,'533',3.333,5),(948,33237,33209,'336',3.333,5),(948,33238,33209,'364',3.333,5),(948,33239,33209,'645',3.333,5),(949,33241,33240,'naa',100,5),(949,33242,33241,'600',3.333,5),(949,33243,33241,'000',3.333,5),(949,33244,33241,'00c',3.333,5),(949,33245,33241,'0c2',3.333,5),(949,33246,33241,'c29',3.333,5),(949,33247,33241,'29b',3.333,5),(949,33248,33241,'9b9',3.333,5),(949,33249,33241,'b9f',3.333,5),(949,33250,33241,'9fd',3.333,5),(949,33251,33241,'fd2',3.333,5),(949,33252,33241,'d25',3.333,5),(949,33253,33241,'259',3.333,5),(949,33254,33241,'59d',3.333,5),(949,33255,33241,'9d2',3.333,5),(949,33256,33241,'d20',3.333,5),(949,33257,33241,'208',3.333,5),(949,33258,33241,'08e',3.333,5),(949,33259,33241,'8e4',3.333,5),(949,33260,33241,'e44',3.333,5),(949,33261,33241,'444',3.333,5),(949,33262,33241,'444',3.333,5),(949,33263,33241,'442',3.333,5),(949,33264,33241,'42f',3.333,5),(949,33265,33241,'2f3',3.333,5),(949,33266,33241,'f34',3.333,5),(949,33267,33241,'341',3.333,5),(949,33268,33241,'418',3.333,5),(949,33269,33241,'188',3.333,5),(949,33270,33241,'887',3.333,5),(949,33271,33241,'873',3.333,5),(950,33273,33272,'naa',100,5),(950,33274,33273,'600',3.333,5),(950,33275,33273,'000',3.333,5),(950,33276,33273,'00c',3.333,5),(950,33277,33273,'0c2',3.333,5),(950,33278,33273,'c29',3.333,5),(950,33279,33273,'295',3.333,5),(950,33280,33273,'95c',3.333,5),(950,33281,33273,'5c0',3.333,5),(950,33282,33273,'c0f',3.333,5),(950,33283,33273,'0fc',3.333,5),(950,33284,33273,'fce',3.333,5),(950,33285,33273,'ce5',3.333,5),(950,33286,33273,'e57',3.333,5),(950,33287,33273,'57f',3.333,5),(950,33288,33273,'7fd',3.333,5),(950,33289,33273,'fd2',3.333,5),(950,33290,33273,'d2e',3.333,5),(950,33291,33273,'2e7',3.333,5),(950,33292,33273,'e75',3.333,5),(950,33293,33273,'753',3.333,5),(950,33294,33273,'535',3.333,5),(950,33295,33273,'355',3.333,5),(950,33296,33273,'554',3.333,5),(950,33297,33273,'542',3.333,5),(950,33298,33273,'42a',3.333,5),(950,33299,33273,'2a8',3.333,5),(950,33300,33273,'a85',3.333,5),(950,33301,33273,'851',3.333,5),(950,33302,33273,'516',3.333,5),(950,33303,33273,'16a',3.333,5),(951,33305,33304,'naa',100,5),(951,33306,33305,'600',3.333,5),(951,33307,33305,'000',3.333,5),(951,33308,33305,'00c',3.333,5),(951,33309,33305,'0c2',3.333,5),(951,33310,33305,'c29',3.333,5),(951,33311,33305,'294',3.333,5),(951,33312,33305,'949',3.333,5),(951,33313,33305,'497',3.333,5),(951,33314,33305,'977',3.333,5),(951,33315,33305,'772',3.333,5),(951,33316,33305,'727',3.333,5),(951,33317,33305,'277',3.333,5),(951,33318,33305,'770',3.333,5),(951,33319,33305,'709',3.333,5),(951,33320,33305,'095',3.333,5),(951,33321,33305,'95f',3.333,5),(951,33322,33305,'5fb',3.333,5),(951,33323,33305,'fb9',3.333,5),(951,33324,33305,'b92',3.333,5),(951,33325,33305,'92e',3.333,5),(951,33326,33305,'2e5',3.333,5),(951,33327,33305,'e5f',3.333,5),(951,33328,33305,'5f0',3.333,5),(951,33329,33305,'f0e',3.333,5),(951,33330,33305,'0eb',3.333,5),(951,33331,33305,'eb7',3.333,5),(951,33332,33305,'b7a',3.333,5),(951,33333,33305,'7ad',3.333,5),(951,33334,33305,'ada',3.333,5),(951,33335,33305,'da9',3.333,5),(952,33337,33336,'naa',100,5),(952,33338,33337,'600',3.333,5),(952,33339,33337,'000',3.333,5),(952,33340,33337,'00c',3.333,5),(952,33341,33337,'0c2',3.333,5),(952,33342,33337,'c29',3.333,5),(952,33343,33337,'29b',3.333,5),(952,33344,33337,'9bc',3.333,5),(952,33345,33337,'bcb',3.333,5),(952,33346,33337,'cb6',3.333,5),(952,33347,33337,'b6f',3.333,5),(952,33348,33337,'6f6',3.333,5),(952,33349,33337,'f6c',3.333,5),(952,33350,33337,'6ce',3.333,5),(952,33351,33337,'ced',3.333,5),(952,33352,33337,'ed8',3.333,5),(952,33353,33337,'d8a',3.333,5),(952,33354,33337,'8ab',3.333,5),(952,33355,33337,'ab1',3.333,5),(952,33356,33337,'b1d',3.333,5),(952,33357,33337,'1d5',3.333,5),(952,33358,33337,'d52',3.333,5),(952,33359,33337,'52e',3.333,5),(952,33360,33337,'2e9',3.333,5),(952,33361,33337,'e95',3.333,5),(952,33362,33337,'954',3.333,5),(952,33363,33337,'54a',3.333,5),(952,33364,33337,'4a8',3.333,5),(952,33365,33337,'a88',3.333,5),(952,33366,33337,'883',3.333,5),(952,33367,33337,'833',3.333,5),(953,33369,33368,'naa',100,5),(953,33370,33369,'600',3.333,5),(953,33371,33369,'000',3.333,5),(953,33372,33369,'00c',3.333,5),(953,33373,33369,'0c2',3.333,5),(953,33374,33369,'c29',3.333,5),(953,33375,33369,'29a',3.333,5),(953,33376,33369,'9aa',3.333,5),(953,33377,33369,'aad',3.333,5),(953,33378,33369,'adc',3.333,5),(953,33379,33369,'dc1',3.333,5),(953,33380,33369,'c13',3.333,5),(953,33381,33369,'132',3.333,5),(953,33382,33369,'328',3.333,5),(953,33383,33369,'286',3.333,5),(953,33384,33369,'862',3.333,5),(953,33385,33369,'62a',3.333,5),(953,33386,33369,'2ab',3.333,5),(953,33387,33369,'ab5',3.333,5),(953,33388,33369,'b5a',3.333,5),(953,33389,33369,'5a0',3.333,5),(953,33390,33369,'a04',3.333,5),(953,33391,33369,'049',3.333,5),(953,33392,33369,'493',3.333,5),(953,33393,33369,'93d',3.333,5),(953,33394,33369,'3d8',3.333,5),(953,33395,33369,'d83',3.333,5),(953,33396,33369,'832',3.333,5),(953,33397,33369,'32a',3.333,5),(953,33398,33369,'2a5',3.333,5),(953,33399,33369,'a58',3.333,5),(954,33401,33400,'naa',100,5),(954,33402,33401,'600',3.333,5),(954,33403,33401,'000',3.333,5),(954,33404,33401,'00c',3.333,5),(954,33405,33401,'0c2',3.333,5),(954,33406,33401,'c29',3.333,5),(954,33407,33401,'292',3.333,5),(954,33408,33401,'92d',3.333,5),(954,33409,33401,'2d8',3.333,5),(954,33410,33401,'d82',3.333,5),(954,33411,33401,'82e',3.333,5),(954,33412,33401,'2e3',3.333,5),(954,33413,33401,'e31',3.333,5),(954,33414,33401,'316',3.333,5),(954,33415,33401,'164',3.333,5),(954,33416,33401,'647',3.333,5),(954,33417,33401,'474',3.333,5),(954,33418,33401,'745',3.333,5),(954,33419,33401,'45d',3.333,5),(954,33420,33401,'5d8',3.333,5),(954,33421,33401,'d8c',3.333,5),(954,33422,33401,'8ca',3.333,5),(954,33423,33401,'ca6',3.333,5),(954,33424,33401,'a63',3.333,5),(954,33425,33401,'63e',3.333,5),(954,33426,33401,'3e7',3.333,5),(954,33427,33401,'e78',3.333,5),(954,33428,33401,'78d',3.333,5),(954,33429,33401,'8d3',3.333,5),(954,33430,33401,'d3a',3.333,5),(954,33431,33401,'3a8',3.333,5),(955,33433,33432,'naa',100,5),(955,33434,33433,'600',3.333,5),(955,33435,33433,'000',3.333,5),(955,33436,33433,'00c',3.333,5),(955,33437,33433,'0c2',3.333,5),(955,33438,33433,'c29',3.333,5),(955,33439,33433,'29a',3.333,5),(955,33440,33433,'9a1',3.333,5),(955,33441,33433,'a12',3.333,5),(955,33442,33433,'120',3.333,5),(955,33443,33433,'202',3.333,5),(955,33444,33433,'02e',3.333,5),(955,33445,33433,'2e1',3.333,5),(955,33446,33433,'e13',3.333,5),(955,33447,33433,'136',3.333,5),(955,33448,33433,'36e',3.333,5),(955,33449,33433,'6e4',3.333,5),(955,33450,33433,'e42',3.333,5),(955,33451,33433,'420',3.333,5),(955,33452,33433,'201',3.333,5),(955,33453,33433,'011',3.333,5),(955,33454,33433,'11c',3.333,5),(955,33455,33433,'1c5',3.333,5),(955,33456,33433,'c5e',3.333,5),(955,33457,33433,'5ea',3.333,5),(955,33458,33433,'ea0',3.333,5),(955,33459,33433,'a0f',3.333,5),(955,33460,33433,'0ff',3.333,5),(955,33461,33433,'ffd',3.333,5),(955,33462,33433,'fda',3.333,5),(955,33463,33433,'daf',3.333,5),(956,33465,33464,'naa',100,5),(956,33466,33465,'600',3.333,5),(956,33467,33465,'000',3.333,5),(956,33468,33465,'00c',3.333,5),(956,33469,33465,'0c2',3.333,5),(956,33470,33465,'c29',3.333,5),(956,33471,33465,'296',3.333,5),(956,33472,33465,'961',3.333,5),(956,33473,33465,'61e',3.333,5),(956,33474,33465,'1e0',3.333,5),(956,33475,33465,'e08',3.333,5),(956,33476,33465,'089',3.333,5),(956,33477,33465,'89e',3.333,5),(956,33478,33465,'9e5',3.333,5),(956,33479,33465,'e5f',3.333,5),(956,33480,33465,'5fd',3.333,5),(956,33481,33465,'fd0',3.333,5),(956,33482,33465,'d03',3.333,5),(956,33483,33465,'03b',3.333,5),(956,33484,33465,'3b5',3.333,5),(956,33485,33465,'b53',3.333,5),(956,33486,33465,'531',3.333,5),(956,33487,33465,'31b',3.333,5),(956,33488,33465,'1b7',3.333,5),(956,33489,33465,'b79',3.333,5),(956,33490,33465,'790',3.333,5),(956,33491,33465,'90d',3.333,5),(956,33492,33465,'0d2',3.333,5),(956,33493,33465,'d24',3.333,5),(956,33494,33465,'249',3.333,5),(956,33495,33465,'491',3.333,5),(957,33497,33496,'naa',100,5),(957,33498,33497,'600',3.333,5),(957,33499,33497,'000',3.333,5),(957,33500,33497,'00c',3.333,5),(957,33501,33497,'0c2',3.333,5),(957,33502,33497,'c29',3.333,5),(957,33503,33497,'295',3.333,5),(957,33504,33497,'950',3.333,5),(957,33505,33497,'502',3.333,5),(957,33506,33497,'029',3.333,5),(957,33507,33497,'298',3.333,5),(957,33508,33497,'98e',3.333,5),(957,33509,33497,'8e9',3.333,5),(957,33510,33497,'e9c',3.333,5),(957,33511,33497,'9c6',3.333,5),(957,33512,33497,'c62',3.333,5),(957,33513,33497,'62a',3.333,5),(957,33514,33497,'2a6',3.333,5),(957,33515,33497,'a66',3.333,5),(957,33516,33497,'660',3.333,5),(957,33517,33497,'606',3.333,5),(957,33518,33497,'069',3.333,5),(957,33519,33497,'699',3.333,5),(957,33520,33497,'996',3.333,5),(957,33521,33497,'965',3.333,5),(957,33522,33497,'650',3.333,5),(957,33523,33497,'500',3.333,5),(957,33524,33497,'00d',3.333,5),(957,33525,33497,'0d9',3.333,5),(957,33526,33497,'d9c',3.333,5),(957,33527,33497,'9ce',3.333,5),(958,33529,33528,'naa',100,5),(958,33530,33529,'600',3.333,5),(958,33531,33529,'000',3.333,5),(958,33532,33529,'00c',3.333,5),(958,33533,33529,'0c2',3.333,5),(958,33534,33529,'c29',3.333,5),(958,33535,33529,'29a',3.333,5),(958,33536,33529,'9a2',3.333,5),(958,33537,33529,'a26',3.333,5),(958,33538,33529,'265',3.333,5),(958,33539,33529,'65f',3.333,5),(958,33540,33529,'5fa',3.333,5),(958,33541,33529,'fa2',3.333,5),(958,33542,33529,'a20',3.333,5),(958,33543,33529,'205',3.333,5),(958,33544,33529,'05d',3.333,5),(958,33545,33529,'5d5',3.333,5),(958,33546,33529,'d59',3.333,5),(958,33547,33529,'59c',3.333,5),(958,33548,33529,'9ca',3.333,5),(958,33549,33529,'ca8',3.333,5),(958,33550,33529,'a8c',3.333,5),(958,33551,33529,'8c6',3.333,5),(958,33552,33529,'c61',3.333,5),(958,33553,33529,'61f',3.333,5),(958,33554,33529,'1fb',3.333,5),(958,33555,33529,'fb3',3.333,5),(958,33556,33529,'b37',3.333,5),(958,33557,33529,'375',3.333,5),(958,33558,33529,'757',3.333,5),(958,33559,33529,'571',3.333,5),(959,33561,33560,'naa',100,5),(959,33562,33561,'600',3.333,5),(959,33563,33561,'000',3.333,5),(959,33564,33561,'00c',3.333,5),(959,33565,33561,'0c2',3.333,5),(959,33566,33561,'c29',3.333,5),(959,33567,33561,'293',3.333,5),(959,33568,33561,'932',3.333,5),(959,33569,33561,'32a',3.333,5),(959,33570,33561,'2a6',3.333,5),(959,33571,33561,'a6d',3.333,5),(959,33572,33561,'6d6',3.333,5),(959,33573,33561,'d62',3.333,5),(959,33574,33561,'626',3.333,5),(959,33575,33561,'268',3.333,5),(959,33576,33561,'68d',3.333,5),(959,33577,33561,'8df',3.333,5),(959,33578,33561,'df5',3.333,5),(959,33579,33561,'f53',3.333,5),(959,33580,33561,'53d',3.333,5),(959,33581,33561,'3d0',3.333,5),(959,33582,33561,'d03',3.333,5),(959,33583,33561,'03c',3.333,5),(959,33584,33561,'3c6',3.333,5),(959,33585,33561,'c65',3.333,5),(959,33586,33561,'655',3.333,5),(959,33587,33561,'557',3.333,5),(959,33588,33561,'577',3.333,5),(959,33589,33561,'776',3.333,5),(959,33590,33561,'76f',3.333,5),(959,33591,33561,'6ff',3.333,5),(960,33593,33592,'naa',100,5),(960,33594,33593,'600',3.333,5),(960,33595,33593,'000',3.333,5),(960,33596,33593,'00c',3.333,5),(960,33597,33593,'0c2',3.333,5),(960,33598,33593,'c29',3.333,5),(960,33599,33593,'299',3.333,5),(960,33600,33593,'99b',3.333,5),(960,33601,33593,'9bb',3.333,5),(960,33602,33593,'bb9',3.333,5),(960,33603,33593,'b9d',3.333,5),(960,33604,33593,'9da',3.333,5),(960,33605,33593,'daf',3.333,5),(960,33606,33593,'af8',3.333,5),(960,33607,33593,'f8c',3.333,5),(960,33608,33593,'8c3',3.333,5),(960,33609,33593,'c37',3.333,5),(960,33610,33593,'372',3.333,5),(960,33611,33593,'720',3.333,5),(960,33612,33593,'20b',3.333,5),(960,33613,33593,'0bf',3.333,5),(960,33614,33593,'bf3',3.333,5),(960,33615,33593,'f3a',3.333,5),(960,33616,33593,'3a1',3.333,5),(960,33617,33593,'a18',3.333,5),(960,33618,33593,'184',3.333,5),(960,33619,33593,'843',3.333,5),(960,33620,33593,'43f',3.333,5),(960,33621,33593,'3ff',3.333,5),(960,33622,33593,'ff2',3.333,5),(960,33623,33593,'f2a',3.333,5),(961,33625,33624,'naa',100,5),(961,33626,33625,'600',3.333,5),(961,33627,33625,'000',3.333,5),(961,33628,33625,'00c',3.333,5),(961,33629,33625,'0c2',3.333,5),(961,33630,33625,'c29',3.333,5),(961,33631,33625,'299',3.333,5),(961,33632,33625,'99f',3.333,5),(961,33633,33625,'9f0',3.333,5),(961,33634,33625,'f04',3.333,5),(961,33635,33625,'049',3.333,5),(961,33636,33625,'492',3.333,5),(961,33637,33625,'920',3.333,5),(961,33638,33625,'206',3.333,5),(961,33639,33625,'069',3.333,5),(961,33640,33625,'69f',3.333,5),(961,33641,33625,'9f0',3.333,5),(961,33642,33625,'f0b',3.333,5),(961,33643,33625,'0bd',3.333,5),(961,33644,33625,'bd7',3.333,5),(961,33645,33625,'d79',3.333,5),(961,33646,33625,'792',3.333,5),(961,33647,33625,'928',3.333,5),(961,33648,33625,'280',3.333,5),(961,33649,33625,'805',3.333,5),(961,33650,33625,'05d',3.333,5),(961,33651,33625,'5dc',3.333,5),(961,33652,33625,'dcc',3.333,5),(961,33653,33625,'cc8',3.333,5),(961,33654,33625,'c86',3.333,5),(961,33655,33625,'86a',3.333,5),(962,33657,33656,'naa',100,5),(962,33658,33657,'600',3.333,5),(962,33659,33657,'000',3.333,5),(962,33660,33657,'00c',3.333,5),(962,33661,33657,'0c2',3.333,5),(962,33662,33657,'c29',3.333,5),(962,33663,33657,'291',3.333,5),(962,33664,33657,'910',3.333,5),(962,33665,33657,'10f',3.333,5),(962,33666,33657,'0fc',3.333,5),(962,33667,33657,'fc5',3.333,5),(962,33668,33657,'c56',3.333,5),(962,33669,33657,'564',3.333,5),(962,33670,33657,'64b',3.333,5),(962,33671,33657,'4b7',3.333,5),(962,33672,33657,'b72',3.333,5),(962,33673,33657,'724',3.333,5),(962,33674,33657,'245',3.333,5),(962,33675,33657,'450',3.333,5),(962,33676,33657,'506',3.333,5),(962,33677,33657,'06a',3.333,5),(962,33678,33657,'6a9',3.333,5),(962,33679,33657,'a91',3.333,5),(962,33680,33657,'917',3.333,5),(962,33681,33657,'175',3.333,5),(962,33682,33657,'750',3.333,5),(962,33683,33657,'509',3.333,5),(962,33684,33657,'093',3.333,5),(962,33685,33657,'936',3.333,5),(962,33686,33657,'361',3.333,5),(962,33687,33657,'614',3.333,5),(963,33689,33688,'naa',100,5),(963,33690,33689,'600',3.333,5),(963,33691,33689,'000',3.333,5),(963,33692,33689,'00c',3.333,5),(963,33693,33689,'0c2',3.333,5),(963,33694,33689,'c29',3.333,5),(963,33695,33689,'295',3.333,5),(963,33696,33689,'95d',3.333,5),(963,33697,33689,'5dc',3.333,5),(963,33698,33689,'dce',3.333,5),(963,33699,33689,'ce9',3.333,5),(963,33700,33689,'e93',3.333,5),(963,33701,33689,'93e',3.333,5),(963,33702,33689,'3e4',3.333,5),(963,33703,33689,'e4e',3.333,5),(963,33704,33689,'4ee',3.333,5),(963,33705,33689,'ee6',3.333,5),(963,33706,33689,'e61',3.333,5),(963,33707,33689,'616',3.333,5),(963,33708,33689,'161',3.333,5),(963,33709,33689,'61b',3.333,5),(963,33710,33689,'1be',3.333,5),(963,33711,33689,'bed',3.333,5),(963,33712,33689,'edc',3.333,5),(963,33713,33689,'dcf',3.333,5),(963,33714,33689,'cf9',3.333,5),(963,33715,33689,'f94',3.333,5),(963,33716,33689,'946',3.333,5),(963,33717,33689,'46e',3.333,5),(963,33718,33689,'6ec',3.333,5),(963,33719,33689,'ec1',3.333,5),(964,33721,33720,'naa',100,5),(964,33722,33721,'600',3.333,5),(964,33723,33721,'000',3.333,5),(964,33724,33721,'00c',3.333,5),(964,33725,33721,'0c2',3.333,5),(964,33726,33721,'c29',3.333,5),(964,33727,33721,'29a',3.333,5),(964,33728,33721,'9aa',3.333,5),(964,33729,33721,'aa0',3.333,5),(964,33730,33721,'a00',3.333,5),(964,33731,33721,'002',3.333,5),(964,33732,33721,'023',3.333,5),(964,33733,33721,'237',3.333,5),(964,33734,33721,'371',3.333,5),(964,33735,33721,'715',3.333,5),(964,33736,33721,'153',3.333,5),(964,33737,33721,'532',3.333,5),(964,33738,33721,'32e',3.333,5),(964,33739,33721,'2e6',3.333,5),(964,33740,33721,'e6e',3.333,5),(964,33741,33721,'6e7',3.333,5),(964,33742,33721,'e7e',3.333,5),(964,33743,33721,'7ed',3.333,5),(964,33744,33721,'ed5',3.333,5),(964,33745,33721,'d55',3.333,5),(964,33746,33721,'554',3.333,5),(964,33747,33721,'541',3.333,5),(964,33748,33721,'41b',3.333,5),(964,33749,33721,'1bc',3.333,5),(964,33750,33721,'bcc',3.333,5),(964,33751,33721,'cc0',3.333,5),(965,33753,33752,'naa',100,5),(965,33754,33753,'600',3.333,5),(965,33755,33753,'000',3.333,5),(965,33756,33753,'00c',3.333,5),(965,33757,33753,'0c2',3.333,5),(965,33758,33753,'c29',3.333,5),(965,33759,33753,'293',3.333,5),(965,33760,33753,'938',3.333,5),(965,33761,33753,'385',3.333,5),(965,33762,33753,'857',3.333,5),(965,33763,33753,'57b',3.333,5),(965,33764,33753,'7bb',3.333,5),(965,33765,33753,'bb8',3.333,5),(965,33766,33753,'b81',3.333,5),(965,33767,33753,'81f',3.333,5),(965,33768,33753,'1f2',3.333,5),(965,33769,33753,'f26',3.333,5),(965,33770,33753,'26e',3.333,5),(965,33771,33753,'6e5',3.333,5),(965,33772,33753,'e51',3.333,5),(965,33773,33753,'51b',3.333,5),(965,33774,33753,'1b8',3.333,5),(965,33775,33753,'b8a',3.333,5),(965,33776,33753,'8ac',3.333,5),(965,33777,33753,'ac5',3.333,5),(965,33778,33753,'c54',3.333,5),(965,33779,33753,'549',3.333,5),(965,33780,33753,'49a',3.333,5),(965,33781,33753,'9a1',3.333,5),(965,33782,33753,'a1c',3.333,5),(965,33783,33753,'1c0',3.333,5),(966,33785,33784,'naa',100,5),(966,33786,33785,'600',3.333,5),(966,33787,33785,'000',3.333,5),(966,33788,33785,'00c',3.333,5),(966,33789,33785,'0c2',3.333,5),(966,33790,33785,'c29',3.333,5),(966,33791,33785,'297',3.333,5),(966,33792,33785,'977',3.333,5),(966,33793,33785,'779',3.333,5),(966,33794,33785,'795',3.333,5),(966,33795,33785,'95b',3.333,5),(966,33796,33785,'5b4',3.333,5),(966,33797,33785,'b43',3.333,5),(966,33798,33785,'43f',3.333,5),(966,33799,33785,'3f0',3.333,5),(966,33800,33785,'f00',3.333,5),(966,33801,33785,'004',3.333,5),(966,33802,33785,'041',3.333,5),(966,33803,33785,'417',3.333,5),(966,33804,33785,'176',3.333,5),(966,33805,33785,'761',3.333,5),(966,33806,33785,'61f',3.333,5),(966,33807,33785,'1fc',3.333,5),(966,33808,33785,'fc1',3.333,5),(966,33809,33785,'c17',3.333,5),(966,33810,33785,'171',3.333,5),(966,33811,33785,'71e',3.333,5),(966,33812,33785,'1ef',3.333,5),(966,33813,33785,'ef9',3.333,5),(966,33814,33785,'f90',3.333,5),(966,33815,33785,'906',3.333,5),(967,33817,33816,'naa',100,5),(967,33818,33817,'600',3.333,5),(967,33819,33817,'000',3.333,5),(967,33820,33817,'00c',3.333,5),(967,33821,33817,'0c2',3.333,5),(967,33822,33817,'c29',3.333,5),(967,33823,33817,'29b',3.333,5),(967,33824,33817,'9b1',3.333,5),(967,33825,33817,'b1a',3.333,5),(967,33826,33817,'1a9',3.333,5),(967,33827,33817,'a9e',3.333,5),(967,33828,33817,'9eb',3.333,5),(967,33829,33817,'eb1',3.333,5),(967,33830,33817,'b17',3.333,5),(967,33831,33817,'171',3.333,5),(967,33832,33817,'71f',3.333,5),(967,33833,33817,'1ff',3.333,5),(967,33834,33817,'ff6',3.333,5),(967,33835,33817,'f6e',3.333,5),(967,33836,33817,'6e1',3.333,5),(967,33837,33817,'e1a',3.333,5),(967,33838,33817,'1a7',3.333,5),(967,33839,33817,'a7e',3.333,5),(967,33840,33817,'7ec',3.333,5),(967,33841,33817,'ec5',3.333,5),(967,33842,33817,'c51',3.333,5),(967,33843,33817,'515',3.333,5),(967,33844,33817,'154',3.333,5),(967,33845,33817,'54c',3.333,5),(967,33846,33817,'4c0',3.333,5),(967,33847,33817,'c06',3.333,5),(968,33849,33848,'naa',100,5),(968,33850,33849,'600',3.333,5),(968,33851,33849,'000',3.333,5),(968,33852,33849,'00c',3.333,5),(968,33853,33849,'0c2',3.333,5),(968,33854,33849,'c29',3.333,5),(968,33855,33849,'293',3.333,5),(968,33856,33849,'936',3.333,5),(968,33857,33849,'369',3.333,5),(968,33858,33849,'690',3.333,5),(968,33859,33849,'901',3.333,5),(968,33860,33849,'01f',3.333,5),(968,33861,33849,'1f1',3.333,5),(968,33862,33849,'f19',3.333,5),(968,33863,33849,'19d',3.333,5),(968,33864,33849,'9d6',3.333,5),(968,33865,33849,'d63',3.333,5),(968,33866,33849,'63c',3.333,5),(968,33867,33849,'3cd',3.333,5),(968,33868,33849,'cd9',3.333,5),(968,33869,33849,'d9e',3.333,5),(968,33870,33849,'9e1',3.333,5),(968,33871,33849,'e18',3.333,5),(968,33872,33849,'18d',3.333,5),(968,33873,33849,'8d9',3.333,5),(968,33874,33849,'d96',3.333,5),(968,33875,33849,'96f',3.333,5),(968,33876,33849,'6f9',3.333,5),(968,33877,33849,'f91',3.333,5),(968,33878,33849,'91b',3.333,5),(968,33879,33849,'1bd',3.333,5),(969,33881,33880,'naa',100,5),(969,33882,33881,'600',3.333,5),(969,33883,33881,'000',3.333,5),(969,33884,33881,'00c',3.333,5),(969,33885,33881,'0c2',3.333,5),(969,33886,33881,'c29',3.333,5),(969,33887,33881,'295',3.333,5),(969,33888,33881,'95c',3.333,5),(969,33889,33881,'5c9',3.333,5),(969,33890,33881,'c9e',3.333,5),(969,33891,33881,'9e3',3.333,5),(969,33892,33881,'e3e',3.333,5),(969,33893,33881,'3e0',3.333,5),(969,33894,33881,'e07',3.333,5),(969,33895,33881,'075',3.333,5),(969,33896,33881,'759',3.333,5),(969,33897,33881,'59c',3.333,5),(969,33898,33881,'9c9',3.333,5),(969,33899,33881,'c91',3.333,5),(969,33900,33881,'91e',3.333,5),(969,33901,33881,'1e7',3.333,5),(969,33902,33881,'e74',3.333,5),(969,33903,33881,'744',3.333,5),(969,33904,33881,'447',3.333,5),(969,33905,33881,'47d',3.333,5),(969,33906,33881,'7d0',3.333,5),(969,33907,33881,'d0a',3.333,5),(969,33908,33881,'0ad',3.333,5),(969,33909,33881,'adc',3.333,5),(969,33910,33881,'dc1',3.333,5),(969,33911,33881,'c16',3.333,5),(970,33913,33912,'naa',100,5),(970,33914,33913,'600',3.333,5),(970,33915,33913,'000',3.333,5),(970,33916,33913,'00c',3.333,5),(970,33917,33913,'0c2',3.333,5),(970,33918,33913,'c29',3.333,5),(970,33919,33913,'29f',3.333,5),(970,33920,33913,'9f0',3.333,5),(970,33921,33913,'f0a',3.333,5),(970,33922,33913,'0ab',3.333,5),(970,33923,33913,'ab6',3.333,5),(970,33924,33913,'b61',3.333,5),(970,33925,33913,'61d',3.333,5),(970,33926,33913,'1d0',3.333,5),(970,33927,33913,'d06',3.333,5),(970,33928,33913,'065',3.333,5),(970,33929,33913,'657',3.333,5),(970,33930,33913,'578',3.333,5),(970,33931,33913,'78e',3.333,5),(970,33932,33913,'8e5',3.333,5),(970,33933,33913,'e5b',3.333,5),(970,33934,33913,'5b6',3.333,5),(970,33935,33913,'b6d',3.333,5),(970,33936,33913,'6d3',3.333,5),(970,33937,33913,'d3f',3.333,5),(970,33938,33913,'3fb',3.333,5),(970,33939,33913,'fbe',3.333,5),(970,33940,33913,'beb',3.333,5),(970,33941,33913,'eb6',3.333,5),(970,33942,33913,'b65',3.333,5),(970,33943,33913,'65c',3.333,5),(971,33945,33944,'naa',100,5),(971,33946,33945,'600',3.333,5),(971,33947,33945,'000',3.333,5),(971,33948,33945,'00c',3.333,5),(971,33949,33945,'0c2',3.333,5),(971,33950,33945,'c29',3.333,5),(971,33951,33945,'299',3.333,5),(971,33952,33945,'99c',3.333,5),(971,33953,33945,'9c9',3.333,5),(971,33954,33945,'c95',3.333,5),(971,33955,33945,'956',3.333,5),(971,33956,33945,'568',3.333,5),(971,33957,33945,'682',3.333,5),(971,33958,33945,'82a',3.333,5),(971,33959,33945,'2aa',3.333,5),(971,33960,33945,'aa3',3.333,5),(971,33961,33945,'a38',3.333,5),(971,33962,33945,'388',3.333,5),(971,33963,33945,'887',3.333,5),(971,33964,33945,'878',3.333,5),(971,33965,33945,'78d',3.333,5),(971,33966,33945,'8d5',3.333,5),(971,33967,33945,'d51',3.333,5),(971,33968,33945,'512',3.333,5),(971,33969,33945,'124',3.333,5),(971,33970,33945,'240',3.333,5),(971,33971,33945,'407',3.333,5),(971,33972,33945,'07b',3.333,5),(971,33973,33945,'7b4',3.333,5),(971,33974,33945,'b4c',3.333,5),(971,33975,33945,'4c1',3.333,5),(972,33977,33976,'naa',100,5),(972,33978,33977,'600',3.333,5),(972,33979,33977,'000',3.333,5),(972,33980,33977,'00c',3.333,5),(972,33981,33977,'0c2',3.333,5),(972,33982,33977,'c29',3.333,5),(972,33983,33977,'297',3.333,5),(972,33984,33977,'97c',3.333,5),(972,33985,33977,'7c8',3.333,5),(972,33986,33977,'c88',3.333,5),(972,33987,33977,'882',3.333,5),(972,33988,33977,'821',3.333,5),(972,33989,33977,'213',3.333,5),(972,33990,33977,'13a',3.333,5),(972,33991,33977,'3a0',3.333,5),(972,33992,33977,'a03',3.333,5),(972,33993,33977,'03f',3.333,5),(972,33994,33977,'3f3',3.333,5),(972,33995,33977,'f32',3.333,5),(972,33996,33977,'328',3.333,5),(972,33997,33977,'28b',3.333,5),(972,33998,33977,'8b1',3.333,5),(972,33999,33977,'b13',3.333,5),(972,34000,33977,'13d',3.333,5),(972,34001,33977,'3d6',3.333,5),(972,34002,33977,'d6e',3.333,5),(972,34003,33977,'6e9',3.333,5),(972,34004,33977,'e96',3.333,5),(972,34005,33977,'962',3.333,5),(972,34006,33977,'628',3.333,5),(972,34007,33977,'285',3.333,5),(973,34009,34008,'naa',100,5),(973,34010,34009,'600',3.333,5);
INSERT INTO `fuzzysearch_default_fuzzysearch_index_title` VALUES (973,34011,34009,'000',3.333,5),(973,34012,34009,'00c',3.333,5),(973,34013,34009,'0c2',3.333,5),(973,34014,34009,'c29',3.333,5),(973,34015,34009,'29b',3.333,5),(973,34016,34009,'9b5',3.333,5),(973,34017,34009,'b52',3.333,5),(973,34018,34009,'528',3.333,5),(973,34019,34009,'283',3.333,5),(973,34020,34009,'834',3.333,5),(973,34021,34009,'340',3.333,5),(973,34022,34009,'40c',3.333,5),(973,34023,34009,'0c4',3.333,5),(973,34024,34009,'c40',3.333,5),(973,34025,34009,'407',3.333,5),(973,34026,34009,'07f',3.333,5),(973,34027,34009,'7f0',3.333,5),(973,34028,34009,'f0d',3.333,5),(973,34029,34009,'0dc',3.333,5),(973,34030,34009,'dcf',3.333,5),(973,34031,34009,'cfa',3.333,5),(973,34032,34009,'fa0',3.333,5),(973,34033,34009,'a0f',3.333,5),(973,34034,34009,'0f1',3.333,5),(973,34035,34009,'f12',3.333,5),(973,34036,34009,'125',3.333,5),(973,34037,34009,'25e',3.333,5),(973,34038,34009,'5e6',3.333,5),(973,34039,34009,'e6b',3.333,5),(974,34041,34040,'naa',100,5),(974,34042,34041,'600',3.333,5),(974,34043,34041,'000',3.333,5),(974,34044,34041,'00c',3.333,5),(974,34045,34041,'0c2',3.333,5),(974,34046,34041,'c29',3.333,5),(974,34047,34041,'29e',3.333,5),(974,34048,34041,'9e1',3.333,5),(974,34049,34041,'e17',3.333,5),(974,34050,34041,'178',3.333,5),(974,34051,34041,'786',3.333,5),(974,34052,34041,'869',3.333,5),(974,34053,34041,'690',3.333,5),(974,34054,34041,'909',3.333,5),(974,34055,34041,'09e',3.333,5),(974,34056,34041,'9ea',3.333,5),(974,34057,34041,'eac',3.333,5),(974,34058,34041,'acd',3.333,5),(974,34059,34041,'cd0',3.333,5),(974,34060,34041,'d0a',3.333,5),(974,34061,34041,'0ac',3.333,5),(974,34062,34041,'ac6',3.333,5),(974,34063,34041,'c6c',3.333,5),(974,34064,34041,'6c9',3.333,5),(974,34065,34041,'c94',3.333,5),(974,34066,34041,'946',3.333,5),(974,34067,34041,'46a',3.333,5),(974,34068,34041,'6a7',3.333,5),(974,34069,34041,'a7c',3.333,5),(974,34070,34041,'7c4',3.333,5),(974,34071,34041,'c4e',3.333,5),(975,34073,34072,'naa',100,5),(975,34074,34073,'600',3.333,5),(975,34075,34073,'000',3.333,5),(975,34076,34073,'00c',3.333,5),(975,34077,34073,'0c2',3.333,5),(975,34078,34073,'c29',3.333,5),(975,34079,34073,'29b',3.333,5),(975,34080,34073,'9bc',3.333,5),(975,34081,34073,'bce',3.333,5),(975,34082,34073,'ce8',3.333,5),(975,34083,34073,'e87',3.333,5),(975,34084,34073,'87d',3.333,5),(975,34085,34073,'7d2',3.333,5),(975,34086,34073,'d23',3.333,5),(975,34087,34073,'234',3.333,5),(975,34088,34073,'344',3.333,5),(975,34089,34073,'448',3.333,5),(975,34090,34073,'48b',3.333,5),(975,34091,34073,'8b7',3.333,5),(975,34092,34073,'b7f',3.333,5),(975,34093,34073,'7f0',3.333,5),(975,34094,34073,'f07',3.333,5),(975,34095,34073,'070',3.333,5),(975,34096,34073,'704',3.333,5),(975,34097,34073,'04f',3.333,5),(975,34098,34073,'4ff',3.333,5),(975,34099,34073,'ffd',3.333,5),(975,34100,34073,'fd0',3.333,5),(975,34101,34073,'d08',3.333,5),(975,34102,34073,'087',3.333,5),(975,34103,34073,'877',3.333,5),(976,34105,34104,'naa',100,5),(976,34106,34105,'600',3.333,5),(976,34107,34105,'000',3.333,5),(976,34108,34105,'00c',3.333,5),(976,34109,34105,'0c2',3.333,5),(976,34110,34105,'c29',3.333,5),(976,34111,34105,'29f',3.333,5),(976,34112,34105,'9fc',3.333,5),(976,34113,34105,'fc9',3.333,5),(976,34114,34105,'c99',3.333,5),(976,34115,34105,'994',3.333,5),(976,34116,34105,'940',3.333,5),(976,34117,34105,'40c',3.333,5),(976,34118,34105,'0c6',3.333,5),(976,34119,34105,'c64',3.333,5),(976,34120,34105,'64a',3.333,5),(976,34121,34105,'4a7',3.333,5),(976,34122,34105,'a72',3.333,5),(976,34123,34105,'72c',3.333,5),(976,34124,34105,'2c8',3.333,5),(976,34125,34105,'c80',3.333,5),(976,34126,34105,'804',3.333,5),(976,34127,34105,'04e',3.333,5),(976,34128,34105,'4e3',3.333,5),(976,34129,34105,'e3f',3.333,5),(976,34130,34105,'3fb',3.333,5),(976,34131,34105,'fbd',3.333,5),(976,34132,34105,'bd6',3.333,5),(976,34133,34105,'d65',3.333,5),(976,34134,34105,'650',3.333,5),(976,34135,34105,'50f',3.333,5),(977,34137,34136,'naa',100,5),(977,34138,34137,'600',3.333,5),(977,34139,34137,'000',3.333,5),(977,34140,34137,'00c',3.333,5),(977,34141,34137,'0c2',3.333,5),(977,34142,34137,'c29',3.333,5),(977,34143,34137,'29a',3.333,5),(977,34144,34137,'9af',3.333,5),(977,34145,34137,'af1',3.333,5),(977,34146,34137,'f1e',3.333,5),(977,34147,34137,'1e2',3.333,5),(977,34148,34137,'e23',3.333,5),(977,34149,34137,'23d',3.333,5),(977,34150,34137,'3d5',3.333,5),(977,34151,34137,'d56',3.333,5),(977,34152,34137,'56d',3.333,5),(977,34153,34137,'6d1',3.333,5),(977,34154,34137,'d15',3.333,5),(977,34155,34137,'15d',3.333,5),(977,34156,34137,'5d8',3.333,5),(977,34157,34137,'d8e',3.333,5),(977,34158,34137,'8e5',3.333,5),(977,34159,34137,'e53',3.333,5),(977,34160,34137,'530',3.333,5),(977,34161,34137,'30f',3.333,5),(977,34162,34137,'0f1',3.333,5),(977,34163,34137,'f1d',3.333,5),(977,34164,34137,'1dc',3.333,5),(977,34165,34137,'dc7',3.333,5),(977,34166,34137,'c77',3.333,5),(977,34167,34137,'77f',3.333,5),(978,34169,34168,'naa',100,5),(978,34170,34169,'600',3.333,5),(978,34171,34169,'000',3.333,5),(978,34172,34169,'00c',3.333,5),(978,34173,34169,'0c2',3.333,5),(978,34174,34169,'c29',3.333,5),(978,34175,34169,'291',3.333,5),(978,34176,34169,'91c',3.333,5),(978,34177,34169,'1cb',3.333,5),(978,34178,34169,'cb0',3.333,5),(978,34179,34169,'b0a',3.333,5),(978,34180,34169,'0ad',3.333,5),(978,34181,34169,'ad3',3.333,5),(978,34182,34169,'d33',3.333,5),(978,34183,34169,'336',3.333,5),(978,34184,34169,'366',3.333,5),(978,34185,34169,'667',3.333,5),(978,34186,34169,'67e',3.333,5),(978,34187,34169,'7e4',3.333,5),(978,34188,34169,'e46',3.333,5),(978,34189,34169,'464',3.333,5),(978,34190,34169,'64f',3.333,5),(978,34191,34169,'4fe',3.333,5),(978,34192,34169,'feb',3.333,5),(978,34193,34169,'ebe',3.333,5),(978,34194,34169,'bef',3.333,5),(978,34195,34169,'ef4',3.333,5),(978,34196,34169,'f4e',3.333,5),(978,34197,34169,'4e7',3.333,5),(978,34198,34169,'e7d',3.333,5),(978,34199,34169,'7d5',3.333,5),(979,34201,34200,'naa',100,5),(979,34202,34201,'600',3.333,5),(979,34203,34201,'000',3.333,5),(979,34204,34201,'00c',3.333,5),(979,34205,34201,'0c2',3.333,5),(979,34206,34201,'c29',3.333,5),(979,34207,34201,'29f',3.333,5),(979,34208,34201,'9f6',3.333,5),(979,34209,34201,'f6d',3.333,5),(979,34210,34201,'6dd',3.333,5),(979,34211,34201,'dda',3.333,5),(979,34212,34201,'da1',3.333,5),(979,34213,34201,'a19',3.333,5),(979,34214,34201,'197',3.333,5),(979,34215,34201,'974',3.333,5),(979,34216,34201,'74b',3.333,5),(979,34217,34201,'4be',3.333,5),(979,34218,34201,'bec',3.333,5),(979,34219,34201,'ec5',3.333,5),(979,34220,34201,'c54',3.333,5),(979,34221,34201,'549',3.333,5),(979,34222,34201,'492',3.333,5),(979,34223,34201,'927',3.333,5),(979,34224,34201,'273',3.333,5),(979,34225,34201,'739',3.333,5),(979,34226,34201,'392',3.333,5),(979,34227,34201,'92f',3.333,5),(979,34228,34201,'2f4',3.333,5),(979,34229,34201,'f4f',3.333,5),(979,34230,34201,'4fd',3.333,5),(979,34231,34201,'fda',3.333,5),(980,34233,34232,'naa',100,5),(980,34234,34233,'600',3.333,5),(980,34235,34233,'000',3.333,5),(980,34236,34233,'00c',3.333,5),(980,34237,34233,'0c2',3.333,5),(980,34238,34233,'c29',3.333,5),(980,34239,34233,'295',3.333,5),(980,34240,34233,'95e',3.333,5),(980,34241,34233,'5e7',3.333,5),(980,34242,34233,'e76',3.333,5),(980,34243,34233,'768',3.333,5),(980,34244,34233,'68f',3.333,5),(980,34245,34233,'8f9',3.333,5),(980,34246,34233,'f98',3.333,5),(980,34247,34233,'989',3.333,5),(980,34248,34233,'890',3.333,5),(980,34249,34233,'900',3.333,5),(980,34250,34233,'004',3.333,5),(980,34251,34233,'04a',3.333,5),(980,34252,34233,'4a3',3.333,5),(980,34253,34233,'a32',3.333,5),(980,34254,34233,'32a',3.333,5),(980,34255,34233,'2a4',3.333,5),(980,34256,34233,'a49',3.333,5),(980,34257,34233,'49f',3.333,5),(980,34258,34233,'9fc',3.333,5),(980,34259,34233,'fc8',3.333,5),(980,34260,34233,'c8d',3.333,5),(980,34261,34233,'8db',3.333,5),(980,34262,34233,'db8',3.333,5),(980,34263,34233,'b81',3.333,5),(981,34265,34264,'naa',100,5),(981,34266,34265,'600',3.333,5),(981,34267,34265,'000',3.333,5),(981,34268,34265,'00c',3.333,5),(981,34269,34265,'0c2',3.333,5),(981,34270,34265,'c29',3.333,5),(981,34271,34265,'291',3.333,5),(981,34272,34265,'91d',3.333,5),(981,34273,34265,'1d5',3.333,5),(981,34274,34265,'d52',3.333,5),(981,34275,34265,'520',3.333,5),(981,34276,34265,'208',3.333,5),(981,34277,34265,'08d',3.333,5),(981,34278,34265,'8d1',3.333,5),(981,34279,34265,'d12',3.333,5),(981,34280,34265,'122',3.333,5),(981,34281,34265,'227',3.333,5),(981,34282,34265,'27d',3.333,5),(981,34283,34265,'7d0',3.333,5),(981,34284,34265,'d0c',3.333,5),(981,34285,34265,'0cd',3.333,5),(981,34286,34265,'cd9',3.333,5),(981,34287,34265,'d96',3.333,5),(981,34288,34265,'96b',3.333,5),(981,34289,34265,'6b3',3.333,5),(981,34290,34265,'b39',3.333,5),(981,34291,34265,'395',3.333,5),(981,34292,34265,'95a',3.333,5),(981,34293,34265,'5a1',3.333,5),(981,34294,34265,'a1b',3.333,5),(981,34295,34265,'1b3',3.333,5),(982,34297,34296,'naa',100,5),(982,34298,34297,'600',3.333,5),(982,34299,34297,'000',3.333,5),(982,34300,34297,'00c',3.333,5),(982,34301,34297,'0c2',3.333,5),(982,34302,34297,'c29',3.333,5),(982,34303,34297,'293',3.333,5),(982,34304,34297,'938',3.333,5),(982,34305,34297,'387',3.333,5),(982,34306,34297,'872',3.333,5),(982,34307,34297,'723',3.333,5),(982,34308,34297,'234',3.333,5),(982,34309,34297,'34c',3.333,5),(982,34310,34297,'4c5',3.333,5),(982,34311,34297,'c59',3.333,5),(982,34312,34297,'597',3.333,5),(982,34313,34297,'97d',3.333,5),(982,34314,34297,'7d0',3.333,5),(982,34315,34297,'d0f',3.333,5),(982,34316,34297,'0f1',3.333,5),(982,34317,34297,'f18',3.333,5),(982,34318,34297,'181',3.333,5),(982,34319,34297,'812',3.333,5),(982,34320,34297,'12d',3.333,5),(982,34321,34297,'2d8',3.333,5),(982,34322,34297,'d88',3.333,5),(982,34323,34297,'885',3.333,5),(982,34324,34297,'850',3.333,5),(982,34325,34297,'50b',3.333,5),(982,34326,34297,'0b9',3.333,5),(982,34327,34297,'b9b',3.333,5),(983,34329,34328,'naa',100,5),(983,34330,34329,'600',3.333,5),(983,34331,34329,'000',3.333,5),(983,34332,34329,'00c',3.333,5),(983,34333,34329,'0c2',3.333,5),(983,34334,34329,'c29',3.333,5),(983,34335,34329,'290',3.333,5),(983,34336,34329,'902',3.333,5),(983,34337,34329,'02a',3.333,5),(983,34338,34329,'2ad',3.333,5),(983,34339,34329,'adb',3.333,5),(983,34340,34329,'db6',3.333,5),(983,34341,34329,'b68',3.333,5),(983,34342,34329,'689',3.333,5),(983,34343,34329,'89f',3.333,5),(983,34344,34329,'9f1',3.333,5),(983,34345,34329,'f12',3.333,5),(983,34346,34329,'12c',3.333,5),(983,34347,34329,'2c0',3.333,5),(983,34348,34329,'c0a',3.333,5),(983,34349,34329,'0a9',3.333,5),(983,34350,34329,'a98',3.333,5),(983,34351,34329,'98c',3.333,5),(983,34352,34329,'8cf',3.333,5),(983,34353,34329,'cfc',3.333,5),(983,34354,34329,'fc3',3.333,5),(983,34355,34329,'c3f',3.333,5),(983,34356,34329,'3f2',3.333,5),(983,34357,34329,'f22',3.333,5),(983,34358,34329,'22f',3.333,5),(983,34359,34329,'2f4',3.333,5),(984,34361,34360,'naa',100,5),(984,34362,34361,'600',3.333,5),(984,34363,34361,'000',3.333,5),(984,34364,34361,'00c',3.333,5),(984,34365,34361,'0c2',3.333,5),(984,34366,34361,'c29',3.333,5),(984,34367,34361,'29c',3.333,5),(984,34368,34361,'9c0',3.333,5),(984,34369,34361,'c00',3.333,5),(984,34370,34361,'00f',3.333,5),(984,34371,34361,'0fb',3.333,5),(984,34372,34361,'fbf',3.333,5),(984,34373,34361,'bfc',3.333,5),(984,34374,34361,'fc2',3.333,5),(984,34375,34361,'c2e',3.333,5),(984,34376,34361,'2e9',3.333,5),(984,34377,34361,'e91',3.333,5),(984,34378,34361,'913',3.333,5),(984,34379,34361,'134',3.333,5),(984,34380,34361,'342',3.333,5),(984,34381,34361,'428',3.333,5),(984,34382,34361,'289',3.333,5),(984,34383,34361,'89c',3.333,5),(984,34384,34361,'9c0',3.333,5),(984,34385,34361,'c06',3.333,5),(984,34386,34361,'06d',3.333,5),(984,34387,34361,'6d3',3.333,5),(984,34388,34361,'d33',3.333,5),(984,34389,34361,'335',3.333,5),(984,34390,34361,'356',3.333,5),(984,34391,34361,'563',3.333,5),(985,34393,34392,'naa',100,5),(985,34394,34393,'600',3.333,5),(985,34395,34393,'000',3.333,5),(985,34396,34393,'00c',3.333,5),(985,34397,34393,'0c2',3.333,5),(985,34398,34393,'c29',3.333,5),(985,34399,34393,'296',3.333,5),(985,34400,34393,'960',3.333,5),(985,34401,34393,'608',3.333,5),(985,34402,34393,'083',3.333,5),(985,34403,34393,'834',3.333,5),(985,34404,34393,'348',3.333,5),(985,34405,34393,'481',3.333,5),(985,34406,34393,'817',3.333,5),(985,34407,34393,'17d',3.333,5),(985,34408,34393,'7d1',3.333,5),(985,34409,34393,'d18',3.333,5),(985,34410,34393,'188',3.333,5),(985,34411,34393,'881',3.333,5),(985,34412,34393,'81d',3.333,5),(985,34413,34393,'1d6',3.333,5),(985,34414,34393,'d64',3.333,5),(985,34415,34393,'640',3.333,5),(985,34416,34393,'40e',3.333,5),(985,34417,34393,'0e5',3.333,5),(985,34418,34393,'e59',3.333,5),(985,34419,34393,'597',3.333,5),(985,34420,34393,'97f',3.333,5),(985,34421,34393,'7f4',3.333,5),(985,34422,34393,'f45',3.333,5),(985,34423,34393,'45c',3.333,5),(986,34425,34424,'naa',100,5),(986,34426,34425,'600',3.333,5),(986,34427,34425,'000',3.333,5),(986,34428,34425,'00c',3.333,5),(986,34429,34425,'0c2',3.333,5),(986,34430,34425,'c29',3.333,5),(986,34431,34425,'293',3.333,5),(986,34432,34425,'939',3.333,5),(986,34433,34425,'396',3.333,5),(986,34434,34425,'964',3.333,5),(986,34435,34425,'642',3.333,5),(986,34436,34425,'42f',3.333,5),(986,34437,34425,'2f3',3.333,5),(986,34438,34425,'f3d',3.333,5),(986,34439,34425,'3de',3.333,5),(986,34440,34425,'de3',3.333,5),(986,34441,34425,'e31',3.333,5),(986,34442,34425,'31b',3.333,5),(986,34443,34425,'1b1',3.333,5),(986,34444,34425,'b1c',3.333,5),(986,34445,34425,'1ca',3.333,5),(986,34446,34425,'ca3',3.333,5),(986,34447,34425,'a33',3.333,5),(986,34448,34425,'334',3.333,5),(986,34449,34425,'344',3.333,5),(986,34450,34425,'440',3.333,5),(986,34451,34425,'402',3.333,5),(986,34452,34425,'02b',3.333,5),(986,34453,34425,'2ba',3.333,5),(986,34454,34425,'ba9',3.333,5),(986,34455,34425,'a96',3.333,5),(987,34457,34456,'naa',100,5),(987,34458,34457,'600',3.333,5),(987,34459,34457,'000',3.333,5),(987,34460,34457,'00c',3.333,5),(987,34461,34457,'0c2',3.333,5),(987,34462,34457,'c29',3.333,5),(987,34463,34457,'295',3.333,5),(987,34464,34457,'950',3.333,5),(987,34465,34457,'50b',3.333,5),(987,34466,34457,'0b2',3.333,5),(987,34467,34457,'b2c',3.333,5),(987,34468,34457,'2ca',3.333,5),(987,34469,34457,'ca4',3.333,5),(987,34470,34457,'a4d',3.333,5),(987,34471,34457,'4d0',3.333,5),(987,34472,34457,'d06',3.333,5),(987,34473,34457,'06e',3.333,5),(987,34474,34457,'6e6',3.333,5),(987,34475,34457,'e64',3.333,5),(987,34476,34457,'64c',3.333,5),(987,34477,34457,'4c3',3.333,5),(987,34478,34457,'c30',3.333,5),(987,34479,34457,'304',3.333,5),(987,34480,34457,'041',3.333,5),(987,34481,34457,'41a',3.333,5),(987,34482,34457,'1a2',3.333,5),(987,34483,34457,'a23',3.333,5),(987,34484,34457,'235',3.333,5),(987,34485,34457,'35f',3.333,5),(987,34486,34457,'5fd',3.333,5),(987,34487,34457,'fd2',3.333,5),(988,34489,34488,'naa',100,5),(988,34490,34489,'600',3.333,5),(988,34491,34489,'000',3.333,5),(988,34492,34489,'00c',3.333,5),(988,34493,34489,'0c2',3.333,5),(988,34494,34489,'c29',3.333,5),(988,34495,34489,'293',3.333,5),(988,34496,34489,'931',3.333,5),(988,34497,34489,'316',3.333,5),(988,34498,34489,'163',3.333,5),(988,34499,34489,'630',3.333,5),(988,34500,34489,'30a',3.333,5),(988,34501,34489,'0a5',3.333,5),(988,34502,34489,'a5e',3.333,5),(988,34503,34489,'5eb',3.333,5),(988,34504,34489,'ebc',3.333,5),(988,34505,34489,'bcc',3.333,5),(988,34506,34489,'cc7',3.333,5),(988,34507,34489,'c75',3.333,5),(988,34508,34489,'751',3.333,5),(988,34509,34489,'512',3.333,5),(988,34510,34489,'127',3.333,5),(988,34511,34489,'279',3.333,5),(988,34512,34489,'796',3.333,5),(988,34513,34489,'96d',3.333,5),(988,34514,34489,'6d7',3.333,5),(988,34515,34489,'d77',3.333,5),(988,34516,34489,'77d',3.333,5),(988,34517,34489,'7dc',3.333,5),(988,34518,34489,'dcf',3.333,5),(988,34519,34489,'cf1',3.333,5),(989,34521,34520,'naa',100,5),(989,34522,34521,'600',3.333,5),(989,34523,34521,'000',3.333,5),(989,34524,34521,'00c',3.333,5),(989,34525,34521,'0c2',3.333,5),(989,34526,34521,'c29',3.333,5),(989,34527,34521,'29d',3.333,5),(989,34528,34521,'9d8',3.333,5),(989,34529,34521,'d89',3.333,5),(989,34530,34521,'891',3.333,5),(989,34531,34521,'91e',3.333,5),(989,34532,34521,'1e6',3.333,5),(989,34533,34521,'e6b',3.333,5),(989,34534,34521,'6b3',3.333,5),(989,34535,34521,'b3d',3.333,5),(989,34536,34521,'3dd',3.333,5),(989,34537,34521,'dd2',3.333,5),(989,34538,34521,'d21',3.333,5),(989,34539,34521,'217',3.333,5),(989,34540,34521,'175',3.333,5),(989,34541,34521,'758',3.333,5),(989,34542,34521,'582',3.333,5),(989,34543,34521,'825',3.333,5),(989,34544,34521,'253',3.333,5),(989,34545,34521,'536',3.333,5),(989,34546,34521,'360',3.333,5),(989,34547,34521,'605',3.333,5),(989,34548,34521,'05b',3.333,5),(989,34549,34521,'5bd',3.333,5),(989,34550,34521,'bdd',3.333,5),(989,34551,34521,'dd3',3.333,5),(990,34553,34552,'naa',100,5),(990,34554,34553,'600',3.333,5),(990,34555,34553,'000',3.333,5),(990,34556,34553,'00c',3.333,5),(990,34557,34553,'0c2',3.333,5),(990,34558,34553,'c29',3.333,5),(990,34559,34553,'29b',3.333,5),(990,34560,34553,'9b4',3.333,5),(990,34561,34553,'b43',3.333,5),(990,34562,34553,'43b',3.333,5),(990,34563,34553,'3b4',3.333,5),(990,34564,34553,'b41',3.333,5),(990,34565,34553,'41c',3.333,5),(990,34566,34553,'1c5',3.333,5),(990,34567,34553,'c53',3.333,5),(990,34568,34553,'539',3.333,5),(990,34569,34553,'392',3.333,5),(990,34570,34553,'929',3.333,5),(990,34571,34553,'294',3.333,5),(990,34572,34553,'948',3.333,5),(990,34573,34553,'489',3.333,5),(990,34574,34553,'891',3.333,5),(990,34575,34553,'91c',3.333,5),(990,34576,34553,'1cd',3.333,5),(990,34577,34553,'cdc',3.333,5),(990,34578,34553,'dca',3.333,5),(990,34579,34553,'ca3',3.333,5),(990,34580,34553,'a3b',3.333,5),(990,34581,34553,'3b8',3.333,5),(990,34582,34553,'b86',3.333,5),(990,34583,34553,'86e',3.333,5),(991,34585,34584,'naa',100,5),(991,34586,34585,'600',3.333,5),(991,34587,34585,'000',3.333,5),(991,34588,34585,'00c',3.333,5),(991,34589,34585,'0c2',3.333,5),(991,34590,34585,'c29',3.333,5),(991,34591,34585,'292',3.333,5),(991,34592,34585,'92d',3.333,5),(991,34593,34585,'2dd',3.333,5),(991,34594,34585,'dd9',3.333,5),(991,34595,34585,'d95',3.333,5),(991,34596,34585,'95e',3.333,5),(991,34597,34585,'5e0',3.333,5),(991,34598,34585,'e04',3.333,5),(991,34599,34585,'048',3.333,5),(991,34600,34585,'48f',3.333,5),(991,34601,34585,'8f3',3.333,5),(991,34602,34585,'f36',3.333,5),(991,34603,34585,'367',3.333,5),(991,34604,34585,'67e',3.333,5),(991,34605,34585,'7e5',3.333,5),(991,34606,34585,'e5c',3.333,5),(991,34607,34585,'5c7',3.333,5),(991,34608,34585,'c78',3.333,5),(991,34609,34585,'78b',3.333,5),(991,34610,34585,'8b1',3.333,5),(991,34611,34585,'b13',3.333,5),(991,34612,34585,'13d',3.333,5),(991,34613,34585,'3d0',3.333,5),(991,34614,34585,'d0a',3.333,5),(991,34615,34585,'0a1',3.333,5),(992,34617,34616,'naa',100,5),(992,34618,34617,'600',3.333,5),(992,34619,34617,'000',3.333,5),(992,34620,34617,'00c',3.333,5),(992,34621,34617,'0c2',3.333,5),(992,34622,34617,'c29',3.333,5),(992,34623,34617,'290',3.333,5),(992,34624,34617,'90f',3.333,5),(992,34625,34617,'0f0',3.333,5),(992,34626,34617,'f0e',3.333,5),(992,34627,34617,'0e6',3.333,5),(992,34628,34617,'e66',3.333,5),(992,34629,34617,'66c',3.333,5),(992,34630,34617,'6c0',3.333,5),(992,34631,34617,'c07',3.333,5),(992,34632,34617,'076',3.333,5),(992,34633,34617,'764',3.333,5),(992,34634,34617,'643',3.333,5),(992,34635,34617,'432',3.333,5),(992,34636,34617,'326',3.333,5),(992,34637,34617,'266',3.333,5),(992,34638,34617,'66c',3.333,5),(992,34639,34617,'6ca',3.333,5),(992,34640,34617,'ca9',3.333,5),(992,34641,34617,'a98',3.333,5),(992,34642,34617,'983',3.333,5),(992,34643,34617,'83f',3.333,5),(992,34644,34617,'3fb',3.333,5),(992,34645,34617,'fb4',3.333,5),(992,34646,34617,'b48',3.333,5),(992,34647,34617,'486',3.333,5),(993,34649,34648,'naa',100,5),(993,34650,34649,'600',3.333,5),(993,34651,34649,'000',3.333,5),(993,34652,34649,'00c',3.333,5),(993,34653,34649,'0c2',3.333,5),(993,34654,34649,'c29',3.333,5),(993,34655,34649,'29f',3.333,5),(993,34656,34649,'9ff',3.333,5),(993,34657,34649,'ff4',3.333,5),(993,34658,34649,'f48',3.333,5),(993,34659,34649,'48e',3.333,5),(993,34660,34649,'8e0',3.333,5),(993,34661,34649,'e06',3.333,5),(993,34662,34649,'067',3.333,5),(993,34663,34649,'67f',3.333,5),(993,34664,34649,'7f9',3.333,5),(993,34665,34649,'f9d',3.333,5),(993,34666,34649,'9d0',3.333,5),(993,34667,34649,'d0d',3.333,5),(993,34668,34649,'0d0',3.333,5),(993,34669,34649,'d0a',3.333,5),(993,34670,34649,'0a6',3.333,5),(993,34671,34649,'a61',3.333,5),(993,34672,34649,'616',3.333,5),(993,34673,34649,'16a',3.333,5),(993,34674,34649,'6a5',3.333,5),(993,34675,34649,'a54',3.333,5),(993,34676,34649,'54b',3.333,5),(993,34677,34649,'4b1',3.333,5),(993,34678,34649,'b15',3.333,5),(993,34679,34649,'157',3.333,5),(994,34681,34680,'naa',100,5),(994,34682,34681,'600',3.333,5),(994,34683,34681,'000',3.333,5),(994,34684,34681,'00c',3.333,5),(994,34685,34681,'0c2',3.333,5),(994,34686,34681,'c29',3.333,5),(994,34687,34681,'29c',3.333,5),(994,34688,34681,'9c4',3.333,5),(994,34689,34681,'c4a',3.333,5),(994,34690,34681,'4a7',3.333,5),(994,34691,34681,'a74',3.333,5),(994,34692,34681,'74e',3.333,5),(994,34693,34681,'4e8',3.333,5),(994,34694,34681,'e8a',3.333,5),(994,34695,34681,'8ae',3.333,5),(994,34696,34681,'ae0',3.333,5),(994,34697,34681,'e03',3.333,5),(994,34698,34681,'037',3.333,5),(994,34699,34681,'379',3.333,5),(994,34700,34681,'797',3.333,5),(994,34701,34681,'97a',3.333,5),(994,34702,34681,'7a2',3.333,5),(994,34703,34681,'a27',3.333,5),(994,34704,34681,'270',3.333,5),(994,34705,34681,'706',3.333,5),(994,34706,34681,'06c',3.333,5),(994,34707,34681,'6ca',3.333,5),(994,34708,34681,'ca4',3.333,5),(994,34709,34681,'a4c',3.333,5),(994,34710,34681,'4ca',3.333,5),(994,34711,34681,'caa',3.333,5),(995,34713,34712,'naa',100,5),(995,34714,34713,'600',3.333,5),(995,34715,34713,'000',3.333,5),(995,34716,34713,'00c',3.333,5),(995,34717,34713,'0c2',3.333,5),(995,34718,34713,'c29',3.333,5),(995,34719,34713,'291',3.333,5),(995,34720,34713,'912',3.333,5),(995,34721,34713,'127',3.333,5),(995,34722,34713,'275',3.333,5),(995,34723,34713,'752',3.333,5),(995,34724,34713,'528',3.333,5),(995,34725,34713,'28e',3.333,5),(995,34726,34713,'8e2',3.333,5),(995,34727,34713,'e23',3.333,5),(995,34728,34713,'230',3.333,5),(995,34729,34713,'303',3.333,5),(995,34730,34713,'039',3.333,5),(995,34731,34713,'39b',3.333,5),(995,34732,34713,'9b3',3.333,5),(995,34733,34713,'b3e',3.333,5),(995,34734,34713,'3e8',3.333,5),(995,34735,34713,'e8c',3.333,5),(995,34736,34713,'8ca',3.333,5),(995,34737,34713,'ca7',3.333,5),(995,34738,34713,'a73',3.333,5),(995,34739,34713,'731',3.333,5),(995,34740,34713,'311',3.333,5),(995,34741,34713,'118',3.333,5),(995,34742,34713,'180',3.333,5),(995,34743,34713,'805',3.333,5),(996,34745,34744,'naa',100,5),(996,34746,34745,'600',3.333,5),(996,34747,34745,'000',3.333,5),(996,34748,34745,'00c',3.333,5),(996,34749,34745,'0c2',3.333,5),(996,34750,34745,'c29',3.333,5),(996,34751,34745,'29d',3.333,5),(996,34752,34745,'9d6',3.333,5),(996,34753,34745,'d65',3.333,5),(996,34754,34745,'65e',3.333,5),(996,34755,34745,'5e1',3.333,5),(996,34756,34745,'e18',3.333,5),(996,34757,34745,'186',3.333,5),(996,34758,34745,'863',3.333,5),(996,34759,34745,'633',3.333,5),(996,34760,34745,'331',3.333,5),(996,34761,34745,'31f',3.333,5),(996,34762,34745,'1fc',3.333,5),(996,34763,34745,'fc2',3.333,5),(996,34764,34745,'c2c',3.333,5),(996,34765,34745,'2c0',3.333,5),(996,34766,34745,'c02',3.333,5),(996,34767,34745,'025',3.333,5),(996,34768,34745,'255',3.333,5),(996,34769,34745,'55c',3.333,5),(996,34770,34745,'5c5',3.333,5),(996,34771,34745,'c5b',3.333,5),(996,34772,34745,'5b2',3.333,5),(996,34773,34745,'b2b',3.333,5),(996,34774,34745,'2b7',3.333,5),(996,34775,34745,'b7a',3.333,5),(997,34777,34776,'naa',100,5),(997,34778,34777,'600',3.333,5),(997,34779,34777,'000',3.333,5),(997,34780,34777,'00c',3.333,5),(997,34781,34777,'0c2',3.333,5),(997,34782,34777,'c29',3.333,5),(997,34783,34777,'29a',3.333,5),(997,34784,34777,'9a7',3.333,5),(997,34785,34777,'a76',3.333,5),(997,34786,34777,'764',3.333,5),(997,34787,34777,'64b',3.333,5),(997,34788,34777,'4b4',3.333,5),(997,34789,34777,'b4a',3.333,5),(997,34790,34777,'4a8',3.333,5),(997,34791,34777,'a81',3.333,5),(997,34792,34777,'818',3.333,5),(997,34793,34777,'182',3.333,5),(997,34794,34777,'824',3.333,5),(997,34795,34777,'24b',3.333,5),(997,34796,34777,'4b3',3.333,5),(997,34797,34777,'b36',3.333,5),(997,34798,34777,'362',3.333,5),(997,34799,34777,'62b',3.333,5),(997,34800,34777,'2b6',3.333,5),(997,34801,34777,'b61',3.333,5),(997,34802,34777,'615',3.333,5),(997,34803,34777,'151',3.333,5),(997,34804,34777,'519',3.333,5),(997,34805,34777,'194',3.333,5),(997,34806,34777,'940',3.333,5),(997,34807,34777,'40c',3.333,5),(998,34809,34808,'naa',100,5),(998,34810,34809,'600',3.333,5),(998,34811,34809,'000',3.333,5),(998,34812,34809,'00c',3.333,5),(998,34813,34809,'0c2',3.333,5),(998,34814,34809,'c29',3.333,5),(998,34815,34809,'297',3.333,5),(998,34816,34809,'973',3.333,5),(998,34817,34809,'734',3.333,5),(998,34818,34809,'344',3.333,5),(998,34819,34809,'44e',3.333,5),(998,34820,34809,'4e7',3.333,5),(998,34821,34809,'e72',3.333,5),(998,34822,34809,'721',3.333,5),(998,34823,34809,'21e',3.333,5),(998,34824,34809,'1ec',3.333,5),(998,34825,34809,'ec7',3.333,5),(998,34826,34809,'c77',3.333,5),(998,34827,34809,'77b',3.333,5),(998,34828,34809,'7b9',3.333,5),(998,34829,34809,'b99',3.333,5),(998,34830,34809,'99e',3.333,5),(998,34831,34809,'9ea',3.333,5),(998,34832,34809,'ea7',3.333,5),(998,34833,34809,'a74',3.333,5),(998,34834,34809,'740',3.333,5),(998,34835,34809,'407',3.333,5),(998,34836,34809,'073',3.333,5),(998,34837,34809,'73d',3.333,5),(998,34838,34809,'3df',3.333,5),(998,34839,34809,'df4',3.333,5),(999,34841,34840,'naa',100,5),(999,34842,34841,'600',3.333,5),(999,34843,34841,'000',3.333,5),(999,34844,34841,'00c',3.333,5),(999,34845,34841,'0c2',3.333,5),(999,34846,34841,'c29',3.333,5),(999,34847,34841,'29a',3.333,5),(999,34848,34841,'9a8',3.333,5),(999,34849,34841,'a8e',3.333,5),(999,34850,34841,'8ee',3.333,5),(999,34851,34841,'eec',3.333,5),(999,34852,34841,'eca',3.333,5),(999,34853,34841,'ca7',3.333,5),(999,34854,34841,'a70',3.333,5),(999,34855,34841,'70f',3.333,5),(999,34856,34841,'0ff',3.333,5),(999,34857,34841,'ff3',3.333,5),(999,34858,34841,'f30',3.333,5),(999,34859,34841,'304',3.333,5),(999,34860,34841,'047',3.333,5),(999,34861,34841,'471',3.333,5),(999,34862,34841,'715',3.333,5),(999,34863,34841,'155',3.333,5),(999,34864,34841,'55c',3.333,5),(999,34865,34841,'5c0',3.333,5),(999,34866,34841,'c0a',3.333,5),(999,34867,34841,'0ac',3.333,5),(999,34868,34841,'ac7',3.333,5),(999,34869,34841,'c7e',3.333,5),(999,34870,34841,'7e5',3.333,5),(999,34871,34841,'e57',3.333,5),(1000,34873,34872,'naa',100,5),(1000,34874,34873,'600',3.333,5),(1000,34875,34873,'000',3.333,5),(1000,34876,34873,'00c',3.333,5),(1000,34877,34873,'0c2',3.333,5),(1000,34878,34873,'c29',3.333,5),(1000,34879,34873,'295',3.333,5),(1000,34880,34873,'952',3.333,5),(1000,34881,34873,'521',3.333,5),(1000,34882,34873,'21b',3.333,5),(1000,34883,34873,'1b0',3.333,5),(1000,34884,34873,'b01',3.333,5),(1000,34885,34873,'010',3.333,5),(1000,34886,34873,'105',3.333,5),(1000,34887,34873,'054',3.333,5),(1000,34888,34873,'541',3.333,5),(1000,34889,34873,'41c',3.333,5),(1000,34890,34873,'1c5',3.333,5),(1000,34891,34873,'c53',3.333,5),(1000,34892,34873,'537',3.333,5),(1000,34893,34873,'37b',3.333,5),(1000,34894,34873,'7b3',3.333,5),(1000,34895,34873,'b3c',3.333,5),(1000,34896,34873,'3ca',3.333,5),(1000,34897,34873,'ca3',3.333,5),(1000,34898,34873,'a32',3.333,5),(1000,34899,34873,'327',3.333,5),(1000,34900,34873,'275',3.333,5),(1000,34901,34873,'75e',3.333,5),(1000,34902,34873,'5e7',3.333,5),(1000,34903,34873,'e7f',3.333,5),(1001,34905,34904,'naa',100,5),(1001,34906,34905,'600',3.333,5),(1001,34907,34905,'000',3.333,5),(1001,34908,34905,'00c',3.333,5),(1001,34909,34905,'0c2',3.333,5),(1001,34910,34905,'c29',3.333,5),(1001,34911,34905,'299',3.333,5),(1001,34912,34905,'997',3.333,5),(1001,34913,34905,'977',3.333,5),(1001,34914,34905,'77a',3.333,5),(1001,34915,34905,'7a5',3.333,5),(1001,34916,34905,'a59',3.333,5),(1001,34917,34905,'592',3.333,5),(1001,34918,34905,'924',3.333,5),(1001,34919,34905,'24d',3.333,5),(1001,34920,34905,'4d5',3.333,5),(1001,34921,34905,'d52',3.333,5),(1001,34922,34905,'527',3.333,5),(1001,34923,34905,'274',3.333,5),(1001,34924,34905,'74e',3.333,5),(1001,34925,34905,'4e2',3.333,5),(1001,34926,34905,'e2f',3.333,5),(1001,34927,34905,'2f7',3.333,5),(1001,34928,34905,'f79',3.333,5),(1001,34929,34905,'79e',3.333,5),(1001,34930,34905,'9ec',3.333,5),(1001,34931,34905,'ecf',3.333,5),(1001,34932,34905,'cf8',3.333,5),(1001,34933,34905,'f83',3.333,5),(1001,34934,34905,'83a',3.333,5),(1001,34935,34905,'3aa',3.333,5),(1002,34937,34936,'naa',100,5),(1002,34938,34937,'600',3.333,5),(1002,34939,34937,'000',3.333,5),(1002,34940,34937,'00c',3.333,5),(1002,34941,34937,'0c2',3.333,5),(1002,34942,34937,'c29',3.333,5),(1002,34943,34937,'294',3.333,5),(1002,34944,34937,'94b',3.333,5),(1002,34945,34937,'4bb',3.333,5),(1002,34946,34937,'bba',3.333,5),(1002,34947,34937,'baf',3.333,5),(1002,34948,34937,'af3',3.333,5),(1002,34949,34937,'f30',3.333,5),(1002,34950,34937,'300',3.333,5),(1002,34951,34937,'00f',3.333,5),(1002,34952,34937,'0f4',3.333,5),(1002,34953,34937,'f47',3.333,5),(1002,34954,34937,'47a',3.333,5),(1002,34955,34937,'7ad',3.333,5),(1002,34956,34937,'ad2',3.333,5),(1002,34957,34937,'d28',3.333,5),(1002,34958,34937,'28c',3.333,5),(1002,34959,34937,'8cd',3.333,5),(1002,34960,34937,'cd5',3.333,5),(1002,34961,34937,'d59',3.333,5),(1002,34962,34937,'59c',3.333,5),(1002,34963,34937,'9c4',3.333,5),(1002,34964,34937,'c46',3.333,5),(1002,34965,34937,'462',3.333,5),(1002,34966,34937,'620',3.333,5),(1002,34967,34937,'204',3.333,5),(1003,34969,34968,'hgw',8.333,5),(1003,34970,34968,'gw2',8.333,5),(1003,34971,34968,'w2k',8.333,5),(1003,34972,34968,'2k8',8.333,5),(1003,34973,34968,'k8r',8.333,5),(1003,34974,34968,'8r2',8.333,5),(1003,34975,34968,'r23',8.333,5),(1003,34976,34968,'232',8.333,5),(1003,34977,34968,'32v',8.333,5),(1003,34978,34968,'2vm',8.333,5),(1003,34979,34968,'vm1',8.333,5),(1003,34980,34968,'m14',8.333,5),(1004,34982,34981,'naa',100,5),(1004,34983,34982,'600',3.333,5),(1004,34984,34982,'000',3.333,5),(1004,34985,34982,'00c',3.333,5),(1004,34986,34982,'0c2',3.333,5),(1004,34987,34982,'c29',3.333,5),(1004,34988,34982,'29a',3.333,5),(1004,34989,34982,'9aa',3.333,5),(1004,34990,34982,'aa3',3.333,5),(1004,34991,34982,'a3c',3.333,5),(1004,34992,34982,'3c7',3.333,5),(1004,34993,34982,'c79',3.333,5),(1004,34994,34982,'79a',3.333,5),(1004,34995,34982,'9a2',3.333,5),(1004,34996,34982,'a20',3.333,5),(1004,34997,34982,'209',3.333,5),(1004,34998,34982,'091',3.333,5),(1004,34999,34982,'91c',3.333,5),(1004,35000,34982,'1c7',3.333,5),(1004,35001,34982,'c73',3.333,5),(1004,35002,34982,'73e',3.333,5),(1004,35003,34982,'3e2',3.333,5),(1004,35004,34982,'e22',3.333,5),(1004,35005,34982,'22a',3.333,5),(1004,35006,34982,'2a5',3.333,5),(1004,35007,34982,'a5d',3.333,5),(1004,35008,34982,'5d9',3.333,5),(1004,35009,34982,'d98',3.333,5),(1004,35010,34982,'98d',3.333,5),(1004,35011,34982,'8d2',3.333,5),(1004,35012,34982,'d2c',3.333,5),(1005,35014,35013,'naa',100,5),(1005,35015,35014,'600',3.333,5),(1005,35016,35014,'00a',3.333,5),(1005,35017,35014,'0a0',3.333,5),(1005,35018,35014,'a09',3.333,5),(1005,35019,35014,'098',3.333,5),(1005,35020,35014,'980',3.333,5),(1005,35021,35014,'804',3.333,5),(1005,35022,35014,'044',3.333,5),(1005,35023,35014,'443',3.333,5),(1005,35024,35014,'430',3.333,5),(1005,35025,35014,'307',3.333,5),(1005,35026,35014,'072',3.333,5),(1005,35027,35014,'725',3.333,5),(1005,35028,35014,'259',3.333,5),(1005,35029,35014,'593',3.333,5),(1005,35030,35014,'931',3.333,5),(1005,35031,35014,'313',3.333,5),(1005,35032,35014,'13f',3.333,5),(1005,35033,35014,'3f3',3.333,5),(1005,35034,35014,'f33',3.333,5),(1005,35035,35014,'334',3.333,5),(1005,35036,35014,'345',3.333,5),(1005,35037,35014,'455',3.333,5),(1005,35038,35014,'556',3.333,5),(1005,35039,35014,'563',3.333,5),(1005,35040,35014,'639',3.333,5),(1005,35041,35014,'393',3.333,5),(1005,35042,35014,'934',3.333,5),(1005,35043,35014,'345',3.333,5),(1005,35044,35014,'455',3.333,5),(1006,35046,35045,'naa',100,5),(1006,35047,35046,'600',3.333,5),(1006,35048,35046,'00a',3.333,5),(1006,35049,35046,'0a0',3.333,5),(1006,35050,35046,'a09',3.333,5),(1006,35051,35046,'098',3.333,5),(1006,35052,35046,'980',3.333,5),(1006,35053,35046,'804',3.333,5),(1006,35054,35046,'044',3.333,5),(1006,35055,35046,'443',3.333,5),(1006,35056,35046,'430',3.333,5),(1006,35057,35046,'307',3.333,5),(1006,35058,35046,'072',3.333,5),(1006,35059,35046,'725',3.333,5),(1006,35060,35046,'259',3.333,5),(1006,35061,35046,'593',3.333,5),(1006,35062,35046,'931',3.333,5),(1006,35063,35046,'313',3.333,5),(1006,35064,35046,'13f',3.333,5),(1006,35065,35046,'3f3',3.333,5),(1006,35066,35046,'f33',3.333,5),(1006,35067,35046,'334',3.333,5),(1006,35068,35046,'345',3.333,5),(1006,35069,35046,'455',3.333,5),(1006,35070,35046,'556',3.333,5),(1006,35071,35046,'563',3.333,5),(1006,35072,35046,'639',3.333,5),(1006,35073,35046,'393',3.333,5),(1006,35074,35046,'934',3.333,5),(1006,35075,35046,'345',3.333,5),(1006,35076,35046,'456',3.333,5),(1007,35078,35077,'naa',100,5),(1007,35079,35078,'600',3.333,5),(1007,35080,35078,'00a',3.333,5),(1007,35081,35078,'0a0',3.333,5),(1007,35082,35078,'a09',3.333,5),(1007,35083,35078,'098',3.333,5),(1007,35084,35078,'980',3.333,5),(1007,35085,35078,'804',3.333,5),(1007,35086,35078,'044',3.333,5),(1007,35087,35078,'443',3.333,5),(1007,35088,35078,'430',3.333,5),(1007,35089,35078,'307',3.333,5),(1007,35090,35078,'075',3.333,5),(1007,35091,35078,'753',3.333,5),(1007,35092,35078,'535',3.333,5),(1007,35093,35078,'357',3.333,5),(1007,35094,35078,'573',3.333,5),(1007,35095,35078,'732',3.333,5),(1007,35096,35078,'32b',3.333,5),(1007,35097,35078,'2b3',3.333,5),(1007,35098,35078,'b33',3.333,5),(1007,35099,35078,'334',3.333,5),(1007,35100,35078,'345',3.333,5),(1007,35101,35078,'457',3.333,5),(1007,35102,35078,'571',3.333,5),(1007,35103,35078,'715',3.333,5),(1007,35104,35078,'153',3.333,5),(1007,35105,35078,'533',3.333,5),(1007,35106,35078,'336',3.333,5),(1007,35107,35078,'364',3.333,5),(1007,35108,35078,'646',3.333,5),(1008,35110,35109,'naa',100,5),(1008,35111,35110,'600',3.333,5),(1008,35112,35110,'00a',3.333,5),(1008,35113,35110,'0a0',3.333,5),(1008,35114,35110,'a09',3.333,5),(1008,35115,35110,'098',3.333,5),(1008,35116,35110,'980',3.333,5),(1008,35117,35110,'804',3.333,5),(1008,35118,35110,'044',3.333,5),(1008,35119,35110,'443',3.333,5),(1008,35120,35110,'430',3.333,5),(1008,35121,35110,'307',3.333,5),(1008,35122,35110,'075',3.333,5),(1008,35123,35110,'753',3.333,5),(1008,35124,35110,'535',3.333,5),(1008,35125,35110,'357',3.333,5),(1008,35126,35110,'573',3.333,5),(1008,35127,35110,'732',3.333,5),(1008,35128,35110,'32b',3.333,5),(1008,35129,35110,'2b3',3.333,5),(1008,35130,35110,'b33',3.333,5),(1008,35131,35110,'334',3.333,5),(1008,35132,35110,'345',3.333,5),(1008,35133,35110,'457',3.333,5),(1008,35134,35110,'571',3.333,5),(1008,35135,35110,'715',3.333,5),(1008,35136,35110,'153',3.333,5),(1008,35137,35110,'533',3.333,5),(1008,35138,35110,'336',3.333,5),(1008,35139,35110,'364',3.333,5),(1008,35140,35110,'647',3.333,5),(1009,35142,35141,'naa',100,5),(1009,35143,35142,'600',3.333,5),(1009,35144,35142,'000',3.333,5),(1009,35145,35142,'00c',3.333,5),(1009,35146,35142,'0c2',3.333,5),(1009,35147,35142,'c29',3.333,5),(1009,35148,35142,'291',3.333,5),(1009,35149,35142,'916',3.333,5),(1009,35150,35142,'164',3.333,5),(1009,35151,35142,'64c',3.333,5),(1009,35152,35142,'4cf',3.333,5),(1009,35153,35142,'cf1',3.333,5),(1009,35154,35142,'f10',3.333,5),(1009,35155,35142,'10d',3.333,5),(1009,35156,35142,'0dc',3.333,5),(1009,35157,35142,'dc0',3.333,5),(1009,35158,35142,'c07',3.333,5),(1009,35159,35142,'072',3.333,5),(1009,35160,35142,'729',3.333,5),(1009,35161,35142,'298',3.333,5),(1009,35162,35142,'980',3.333,5),(1009,35163,35142,'806',3.333,5),(1009,35164,35142,'06c',3.333,5),(1009,35165,35142,'6c2',3.333,5),(1009,35166,35142,'c23',3.333,5),(1009,35167,35142,'234',3.333,5),(1009,35168,35142,'349',3.333,5),(1009,35169,35142,'498',3.333,5),(1009,35170,35142,'98f',3.333,5),(1009,35171,35142,'8f6',3.333,5),(1009,35172,35142,'f64',3.333,5),(1010,35174,35173,'naa',100,5),(1010,35175,35174,'600',3.333,5),(1010,35176,35174,'000',3.333,5),(1010,35177,35174,'00c',3.333,5),(1010,35178,35174,'0c2',3.333,5),(1010,35179,35174,'c29',3.333,5),(1010,35180,35174,'291',3.333,5),(1010,35181,35174,'91f',3.333,5),(1010,35182,35174,'1f9',3.333,5),(1010,35183,35174,'f95',3.333,5),(1010,35184,35174,'95d',3.333,5),(1010,35185,35174,'5d7',3.333,5),(1010,35186,35174,'d70',3.333,5),(1010,35187,35174,'70b',3.333,5),(1010,35188,35174,'0bc',3.333,5),(1010,35189,35174,'bc1',3.333,5),(1010,35190,35174,'c14',3.333,5),(1010,35191,35174,'14a',3.333,5),(1010,35192,35174,'4a6',3.333,5),(1010,35193,35174,'a6c',3.333,5),(1010,35194,35174,'6c8',3.333,5),(1010,35195,35174,'c88',3.333,5),(1010,35196,35174,'889',3.333,5),(1010,35197,35174,'892',3.333,5),(1010,35198,35174,'928',3.333,5),(1010,35199,35174,'284',3.333,5),(1010,35200,35174,'848',3.333,5),(1010,35201,35174,'485',3.333,5),(1010,35202,35174,'85a',3.333,5),(1010,35203,35174,'5aa',3.333,5),(1010,35204,35174,'aa5',3.333,5),(1011,35206,35205,'naa',100,5),(1011,35207,35206,'600',3.333,5),(1011,35208,35206,'000',3.333,5),(1011,35209,35206,'00c',3.333,5),(1011,35210,35206,'0c2',3.333,5),(1011,35211,35206,'c29',3.333,5),(1011,35212,35206,'292',3.333,5),(1011,35213,35206,'92f',3.333,5),(1011,35214,35206,'2f2',3.333,5),(1011,35215,35206,'f2e',3.333,5),(1011,35216,35206,'2e8',3.333,5),(1011,35217,35206,'e89',3.333,5),(1011,35218,35206,'89f',3.333,5),(1011,35219,35206,'9f8',3.333,5),(1011,35220,35206,'f8e',3.333,5),(1011,35221,35206,'8ed',3.333,5),(1011,35222,35206,'edf',3.333,5),(1011,35223,35206,'dfc',3.333,5),(1011,35224,35206,'fc9',3.333,5),(1011,35225,35206,'c97',3.333,5),(1011,35226,35206,'97c',3.333,5),(1011,35227,35206,'7ce',3.333,5),(1011,35228,35206,'ce6',3.333,5),(1011,35229,35206,'e68',3.333,5),(1011,35230,35206,'68e',3.333,5),(1011,35231,35206,'8ea',3.333,5),(1011,35232,35206,'ea3',3.333,5),(1011,35233,35206,'a37',3.333,5),(1011,35234,35206,'378',3.333,5),(1011,35235,35206,'785',3.333,5),(1011,35236,35206,'85a',3.333,5),(1012,35238,35237,'naa',100,5),(1012,35239,35238,'600',3.333,5),(1012,35240,35238,'000',3.333,5),(1012,35241,35238,'00c',3.333,5),(1012,35242,35238,'0c2',3.333,5),(1012,35243,35238,'c29',3.333,5),(1012,35244,35238,'290',3.333,5),(1012,35245,35238,'90e',3.333,5),(1012,35246,35238,'0ee',3.333,5),(1012,35247,35238,'ee7',3.333,5),(1012,35248,35238,'e73',3.333,5),(1012,35249,35238,'734',3.333,5),(1012,35250,35238,'343',3.333,5),(1012,35251,35238,'436',3.333,5),(1012,35252,35238,'36b',3.333,5),(1012,35253,35238,'6b8',3.333,5),(1012,35254,35238,'b86',3.333,5),(1012,35255,35238,'860',3.333,5),(1012,35256,35238,'600',3.333,5),(1012,35257,35238,'008',3.333,5),(1012,35258,35238,'086',3.333,5),(1012,35259,35238,'863',3.333,5),(1012,35260,35238,'63d',3.333,5),(1012,35261,35238,'3dd',3.333,5),(1012,35262,35238,'dd8',3.333,5),(1012,35263,35238,'d8d',3.333,5),(1012,35264,35238,'8df',3.333,5),(1012,35265,35238,'df7',3.333,5),(1012,35266,35238,'f73',3.333,5),(1012,35267,35238,'73f',3.333,5),(1012,35268,35238,'3fb',3.333,5),(1013,35270,35269,'naa',100,5),(1013,35271,35270,'600',3.333,5),(1013,35272,35270,'000',3.333,5),(1013,35273,35270,'00c',3.333,5),(1013,35274,35270,'0c2',3.333,5),(1013,35275,35270,'c29',3.333,5),(1013,35276,35270,'295',3.333,5),(1013,35277,35270,'95b',3.333,5),(1013,35278,35270,'5b5',3.333,5),(1013,35279,35270,'b52',3.333,5),(1013,35280,35270,'520',3.333,5),(1013,35281,35270,'20e',3.333,5),(1013,35282,35270,'0e7',3.333,5),(1013,35283,35270,'e72',3.333,5),(1013,35284,35270,'726',3.333,5),(1013,35285,35270,'268',3.333,5),(1013,35286,35270,'686',3.333,5),(1013,35287,35270,'865',3.333,5),(1013,35288,35270,'652',3.333,5),(1013,35289,35270,'52b',3.333,5),(1013,35290,35270,'2b4',3.333,5),(1013,35291,35270,'b40',3.333,5),(1013,35292,35270,'40d',3.333,5),(1013,35293,35270,'0dc',3.333,5),(1013,35294,35270,'dc7',3.333,5),(1013,35295,35270,'c72',3.333,5),(1013,35296,35270,'723',3.333,5),(1013,35297,35270,'239',3.333,5),(1013,35298,35270,'39e',3.333,5),(1013,35299,35270,'9e8',3.333,5),(1013,35300,35270,'e8e',3.333,5),(1014,35302,35301,'naa',100,5),(1014,35303,35302,'600',3.333,5),(1014,35304,35302,'000',3.333,5),(1014,35305,35302,'00c',3.333,5),(1014,35306,35302,'0c2',3.333,5),(1014,35307,35302,'c29',3.333,5),(1014,35308,35302,'299',3.333,5),(1014,35309,35302,'99c',3.333,5),(1014,35310,35302,'9c3',3.333,5),(1014,35311,35302,'c35',3.333,5),(1014,35312,35302,'354',3.333,5),(1014,35313,35302,'543',3.333,5),(1014,35314,35302,'438',3.333,5),(1014,35315,35302,'385',3.333,5),(1014,35316,35302,'85e',3.333,5),(1014,35317,35302,'5ef',3.333,5),(1014,35318,35302,'ef1',3.333,5),(1014,35319,35302,'f17',3.333,5),(1014,35320,35302,'171',3.333,5),(1014,35321,35302,'715',3.333,5),(1014,35322,35302,'15c',3.333,5),(1014,35323,35302,'5cc',3.333,5),(1014,35324,35302,'cca',3.333,5),(1014,35325,35302,'caf',3.333,5),(1014,35326,35302,'af7',3.333,5),(1014,35327,35302,'f77',3.333,5),(1014,35328,35302,'77a',3.333,5),(1014,35329,35302,'7a7',3.333,5),(1014,35330,35302,'a7d',3.333,5),(1014,35331,35302,'7d2',3.333,5),(1014,35332,35302,'d2d',3.333,5),(1015,35334,35333,'naa',100,5),(1015,35335,35334,'600',3.333,5),(1015,35336,35334,'000',3.333,5),(1015,35337,35334,'00c',3.333,5),(1015,35338,35334,'0c2',3.333,5),(1015,35339,35334,'c29',3.333,5),(1015,35340,35334,'290',3.333,5),(1015,35341,35334,'901',3.333,5),(1015,35342,35334,'01e',3.333,5),(1015,35343,35334,'1e7',3.333,5),(1015,35344,35334,'e73',3.333,5),(1015,35345,35334,'734',3.333,5),(1015,35346,35334,'346',3.333,5),(1015,35347,35334,'46f',3.333,5),(1015,35348,35334,'6f5',3.333,5),(1015,35349,35334,'f5c',3.333,5),(1015,35350,35334,'5c1',3.333,5),(1015,35351,35334,'c1f',3.333,5),(1015,35352,35334,'1f8',3.333,5),(1015,35353,35334,'f89',3.333,5),(1015,35354,35334,'898',3.333,5),(1015,35355,35334,'987',3.333,5),(1015,35356,35334,'87c',3.333,5),(1015,35357,35334,'7c0',3.333,5),(1015,35358,35334,'c05',3.333,5),(1015,35359,35334,'05f',3.333,5),(1015,35360,35334,'5f3',3.333,5),(1015,35361,35334,'f3e',3.333,5),(1015,35362,35334,'3e8',3.333,5),(1015,35363,35334,'e84',3.333,5),(1015,35364,35334,'840',3.333,5),(1016,35366,35365,'naa',100,5),(1016,35367,35366,'600',3.333,5),(1016,35368,35366,'000',3.333,5),(1016,35369,35366,'00c',3.333,5),(1016,35370,35366,'0c2',3.333,5),(1016,35371,35366,'c29',3.333,5),(1016,35372,35366,'298',3.333,5),(1016,35373,35366,'987',3.333,5),(1016,35374,35366,'876',3.333,5),(1016,35375,35366,'761',3.333,5),(1016,35376,35366,'61e',3.333,5),(1016,35377,35366,'1e6',3.333,5),(1016,35378,35366,'e6a',3.333,5),(1016,35379,35366,'6a7',3.333,5),(1016,35380,35366,'a7a',3.333,5),(1016,35381,35366,'7a5',3.333,5),(1016,35382,35366,'a52',3.333,5),(1016,35383,35366,'52d',3.333,5),(1016,35384,35366,'2d1',3.333,5),(1016,35385,35366,'d11',3.333,5),(1016,35386,35366,'11a',3.333,5),(1016,35387,35366,'1ae',3.333,5),(1016,35388,35366,'ae5',3.333,5),(1016,35389,35366,'e53',3.333,5),(1016,35390,35366,'53d',3.333,5),(1016,35391,35366,'3de',3.333,5),(1016,35392,35366,'deb',3.333,5),(1016,35393,35366,'eb4',3.333,5),(1016,35394,35366,'b42',3.333,5),(1016,35395,35366,'42a',3.333,5),(1016,35396,35366,'2a8',3.333,5),(1017,35398,35397,'naa',100,5),(1017,35399,35398,'600',3.333,5),(1017,35400,35398,'000',3.333,5),(1017,35401,35398,'00c',3.333,5),(1017,35402,35398,'0c2',3.333,5),(1017,35403,35398,'c29',3.333,5),(1017,35404,35398,'29d',3.333,5),(1017,35405,35398,'9da',3.333,5),(1017,35406,35398,'dad',3.333,5),(1017,35407,35398,'ada',3.333,5),(1017,35408,35398,'dad',3.333,5),(1017,35409,35398,'ada',3.333,5),(1017,35410,35398,'daf',3.333,5),(1017,35411,35398,'afa',3.333,5),(1017,35412,35398,'fa6',3.333,5),(1017,35413,35398,'a68',3.333,5),(1017,35414,35398,'687',3.333,5),(1017,35415,35398,'872',3.333,5),(1017,35416,35398,'727',3.333,5),(1017,35417,35398,'273',3.333,5),(1017,35418,35398,'730',3.333,5),(1017,35419,35398,'308',3.333,5),(1017,35420,35398,'08e',3.333,5),(1017,35421,35398,'8e2',3.333,5),(1017,35422,35398,'e2e',3.333,5),(1017,35423,35398,'2ee',3.333,5),(1017,35424,35398,'ee1',3.333,5),(1017,35425,35398,'e10',3.333,5),(1017,35426,35398,'10b',3.333,5),(1017,35427,35398,'0b4',3.333,5),(1017,35428,35398,'b49',3.333,5),(1018,35430,35429,'naa',100,5),(1018,35431,35430,'600',3.333,5),(1018,35432,35430,'000',3.333,5),(1018,35433,35430,'00c',3.333,5),(1018,35434,35430,'0c2',3.333,5),(1018,35435,35430,'c29',3.333,5),(1018,35436,35430,'298',3.333,5),(1018,35437,35430,'983',3.333,5),(1018,35438,35430,'831',3.333,5),(1018,35439,35430,'314',3.333,5),(1018,35440,35430,'147',3.333,5),(1018,35441,35430,'477',3.333,5),(1018,35442,35430,'774',3.333,5),(1018,35443,35430,'745',3.333,5),(1018,35444,35430,'456',3.333,5),(1018,35445,35430,'567',3.333,5),(1018,35446,35430,'676',3.333,5),(1018,35447,35430,'763',3.333,5),(1018,35448,35430,'630',3.333,5),(1018,35449,35430,'306',3.333,5),(1018,35450,35430,'061',3.333,5),(1018,35451,35430,'61d',3.333,5),(1018,35452,35430,'1d4',3.333,5),(1018,35453,35430,'d44',3.333,5),(1018,35454,35430,'440',3.333,5),(1018,35455,35430,'40a',3.333,5),(1018,35456,35430,'0aa',3.333,5),(1018,35457,35430,'aa4',3.333,5),(1018,35458,35430,'a48',3.333,5),(1018,35459,35430,'480',3.333,5),(1018,35460,35430,'800',3.333,5),(1019,35462,35461,'naa',100,5),(1019,35463,35462,'600',3.333,5),(1019,35464,35462,'000',3.333,5),(1019,35465,35462,'00c',3.333,5),(1019,35466,35462,'0c2',3.333,5),(1019,35467,35462,'c29',3.333,5),(1019,35468,35462,'29a',3.333,5),(1019,35469,35462,'9a6',3.333,5),(1019,35470,35462,'a61',3.333,5),(1019,35471,35462,'611',3.333,5),(1019,35472,35462,'11a',3.333,5),(1019,35473,35462,'1ae',3.333,5),(1019,35474,35462,'ae2',3.333,5),(1019,35475,35462,'e2f',3.333,5),(1019,35476,35462,'2f0',3.333,5),(1019,35477,35462,'f08',3.333,5),(1019,35478,35462,'08a',3.333,5),(1019,35479,35462,'8a2',3.333,5),(1019,35480,35462,'a24',3.333,5),(1019,35481,35462,'242',3.333,5),(1019,35482,35462,'42c',3.333,5),(1019,35483,35462,'2c5',3.333,5),(1019,35484,35462,'c59',3.333,5),(1019,35485,35462,'59d',3.333,5),(1019,35486,35462,'9d3',3.333,5),(1019,35487,35462,'d34',3.333,5),(1019,35488,35462,'344',3.333,5),(1019,35489,35462,'44c',3.333,5),(1019,35490,35462,'4c9',3.333,5),(1019,35491,35462,'c94',3.333,5),(1019,35492,35462,'941',3.333,5),(1020,35494,35493,'naa',100,5),(1020,35495,35494,'600',3.333,5),(1020,35496,35494,'000',3.333,5),(1020,35497,35494,'00c',3.333,5),(1020,35498,35494,'0c2',3.333,5),(1020,35499,35494,'c29',3.333,5),(1020,35500,35494,'297',3.333,5),(1020,35501,35494,'97f',3.333,5),(1020,35502,35494,'7f4',3.333,5),(1020,35503,35494,'f41',3.333,5),(1020,35504,35494,'410',3.333,5),(1020,35505,35494,'100',3.333,5),(1020,35506,35494,'00e',3.333,5),(1020,35507,35494,'0ec',3.333,5),(1020,35508,35494,'ecd',3.333,5),(1020,35509,35494,'cd6',3.333,5),(1020,35510,35494,'d6e',3.333,5),(1020,35511,35494,'6e8',3.333,5),(1020,35512,35494,'e8c',3.333,5),(1020,35513,35494,'8c8',3.333,5),(1020,35514,35494,'c88',3.333,5),(1020,35515,35494,'886',3.333,5),(1020,35516,35494,'861',3.333,5),(1020,35517,35494,'61e',3.333,5),(1020,35518,35494,'1e1',3.333,5),(1020,35519,35494,'e14',3.333,5),(1020,35520,35494,'142',3.333,5),(1020,35521,35494,'42b',3.333,5),(1020,35522,35494,'2b5',3.333,5),(1020,35523,35494,'b54',3.333,5),(1020,35524,35494,'540',3.333,5),(1021,35526,35525,'naa',100,5),(1021,35527,35526,'600',3.333,5),(1021,35528,35526,'000',3.333,5),(1021,35529,35526,'00c',3.333,5),(1021,35530,35526,'0c2',3.333,5),(1021,35531,35526,'c29',3.333,5),(1021,35532,35526,'29a',3.333,5),(1021,35533,35526,'9a9',3.333,5),(1021,35534,35526,'a9c',3.333,5),(1021,35535,35526,'9ca',3.333,5),(1021,35536,35526,'ca7',3.333,5),(1021,35537,35526,'a78',3.333,5),(1021,35538,35526,'783',3.333,5),(1021,35539,35526,'837',3.333,5),(1021,35540,35526,'378',3.333,5),(1021,35541,35526,'788',3.333,5),(1021,35542,35526,'883',3.333,5),(1021,35543,35526,'839',3.333,5),(1021,35544,35526,'39d',3.333,5),(1021,35545,35526,'9d3',3.333,5),(1021,35546,35526,'d38',3.333,5),(1021,35547,35526,'380',3.333,5),(1021,35548,35526,'806',3.333,5),(1021,35549,35526,'067',3.333,5),(1021,35550,35526,'673',3.333,5),(1021,35551,35526,'732',3.333,5),(1021,35552,35526,'32e',3.333,5),(1021,35553,35526,'2e4',3.333,5),(1021,35554,35526,'e42',3.333,5),(1021,35555,35526,'421',3.333,5),(1021,35556,35526,'210',3.333,5),(1022,35558,35557,'naa',100,5),(1022,35559,35558,'600',3.333,5),(1022,35560,35558,'000',3.333,5),(1022,35561,35558,'00c',3.333,5),(1022,35562,35558,'0c2',3.333,5),(1022,35563,35558,'c29',3.333,5),(1022,35564,35558,'292',3.333,5),(1022,35565,35558,'921',3.333,5),(1022,35566,35558,'210',3.333,5),(1022,35567,35558,'106',3.333,5),(1022,35568,35558,'06f',3.333,5),(1022,35569,35558,'6fe',3.333,5),(1022,35570,35558,'fe1',3.333,5),(1022,35571,35558,'e1c',3.333,5),(1022,35572,35558,'1c3',3.333,5),(1022,35573,35558,'c33',3.333,5),(1022,35574,35558,'334',3.333,5),(1022,35575,35558,'34a',3.333,5),(1022,35576,35558,'4a8',3.333,5),(1022,35577,35558,'a87',3.333,5),(1022,35578,35558,'87f',3.333,5),(1022,35579,35558,'7fd',3.333,5),(1022,35580,35558,'fd0',3.333,5),(1022,35581,35558,'d02',3.333,5),(1022,35582,35558,'021',3.333,5),(1022,35583,35558,'212',3.333,5),(1022,35584,35558,'125',3.333,5),(1022,35585,35558,'257',3.333,5),(1022,35586,35558,'57c',3.333,5),(1022,35587,35558,'7cc',3.333,5),(1022,35588,35558,'cc1',3.333,5),(1023,35590,35589,'naa',100,5),(1023,35591,35590,'600',3.333,5),(1023,35592,35590,'000',3.333,5),(1023,35593,35590,'00c',3.333,5),(1023,35594,35590,'0c2',3.333,5),(1023,35595,35590,'c29',3.333,5),(1023,35596,35590,'29a',3.333,5),(1023,35597,35590,'9aa',3.333,5),(1023,35598,35590,'aad',3.333,5),(1023,35599,35590,'adf',3.333,5),(1023,35600,35590,'dfb',3.333,5),(1023,35601,35590,'fb7',3.333,5),(1023,35602,35590,'b7e',3.333,5),(1023,35603,35590,'7e3',3.333,5),(1023,35604,35590,'e3a',3.333,5),(1023,35605,35590,'3a9',3.333,5),(1023,35606,35590,'a99',3.333,5),(1023,35607,35590,'998',3.333,5),(1023,35608,35590,'98a',3.333,5),(1023,35609,35590,'8a3',3.333,5),(1023,35610,35590,'a3b',3.333,5),(1023,35611,35590,'3b3',3.333,5),(1023,35612,35590,'b3c',3.333,5),(1023,35613,35590,'3c5',3.333,5),(1023,35614,35590,'c55',3.333,5),(1023,35615,35590,'554',3.333,5),(1023,35616,35590,'542',3.333,5),(1023,35617,35590,'425',3.333,5),(1023,35618,35590,'253',3.333,5),(1023,35619,35590,'533',3.333,5),(1023,35620,35590,'333',3.333,5),(1024,35622,35621,'naa',100,5),(1024,35623,35622,'600',3.333,5),(1024,35624,35622,'000',3.333,5),(1024,35625,35622,'00c',3.333,5),(1024,35626,35622,'0c2',3.333,5),(1024,35627,35622,'c29',3.333,5),(1024,35628,35622,'290',3.333,5),(1024,35629,35622,'906',3.333,5),(1024,35630,35622,'060',3.333,5),(1024,35631,35622,'609',3.333,5),(1024,35632,35622,'092',3.333,5),(1024,35633,35622,'921',3.333,5),(1024,35634,35622,'211',3.333,5),(1024,35635,35622,'11d',3.333,5),(1024,35636,35622,'1d9',3.333,5),(1024,35637,35622,'d94',3.333,5),(1024,35638,35622,'948',3.333,5),(1024,35639,35622,'480',3.333,5),(1024,35640,35622,'80e',3.333,5),(1024,35641,35622,'0e1',3.333,5),(1024,35642,35622,'e19',3.333,5),(1024,35643,35622,'192',3.333,5),(1024,35644,35622,'920',3.333,5),(1024,35645,35622,'20c',3.333,5),(1024,35646,35622,'0ce',3.333,5),(1024,35647,35622,'ce8',3.333,5),(1024,35648,35622,'e8d',3.333,5),(1024,35649,35622,'8dc',3.333,5),(1024,35650,35622,'dce',3.333,5),(1024,35651,35622,'cea',3.333,5),(1024,35652,35622,'ea3',3.333,5),(1025,35654,35653,'naa',100,5),(1025,35655,35654,'600',3.333,5),(1025,35656,35654,'000',3.333,5),(1025,35657,35654,'00c',3.333,5),(1025,35658,35654,'0c2',3.333,5),(1025,35659,35654,'c29',3.333,5),(1025,35660,35654,'298',3.333,5),(1025,35661,35654,'98e',3.333,5),(1025,35662,35654,'8e6',3.333,5),(1025,35663,35654,'e64',3.333,5),(1025,35664,35654,'643',3.333,5),(1025,35665,35654,'433',3.333,5),(1025,35666,35654,'339',3.333,5),(1025,35667,35654,'394',3.333,5),(1025,35668,35654,'946',3.333,5),(1025,35669,35654,'46c',3.333,5),(1025,35670,35654,'6c5',3.333,5),(1025,35671,35654,'c5a',3.333,5),(1025,35672,35654,'5a2',3.333,5),(1025,35673,35654,'a2c',3.333,5),(1025,35674,35654,'2cb',3.333,5),(1025,35675,35654,'cb1',3.333,5),(1025,35676,35654,'b12',3.333,5),(1025,35677,35654,'125',3.333,5),(1025,35678,35654,'25f',3.333,5),(1025,35679,35654,'5f8',3.333,5),(1025,35680,35654,'f87',3.333,5),(1025,35681,35654,'87b',3.333,5),(1025,35682,35654,'7bf',3.333,5),(1025,35683,35654,'bf0',3.333,5),(1025,35684,35654,'f0b',3.333,5),(1026,35686,35685,'naa',100,5),(1026,35687,35686,'600',3.333,5),(1026,35688,35686,'000',3.333,5),(1026,35689,35686,'00c',3.333,5),(1026,35690,35686,'0c2',3.333,5),(1026,35691,35686,'c29',3.333,5),(1026,35692,35686,'298',3.333,5),(1026,35693,35686,'98f',3.333,5),(1026,35694,35686,'8fa',3.333,5),(1026,35695,35686,'fa1',3.333,5),(1026,35696,35686,'a1b',3.333,5),(1026,35697,35686,'1b1',3.333,5),(1026,35698,35686,'b1b',3.333,5),(1026,35699,35686,'1b9',3.333,5),(1026,35700,35686,'b96',3.333,5),(1026,35701,35686,'969',3.333,5),(1026,35702,35686,'697',3.333,5),(1026,35703,35686,'976',3.333,5),(1026,35704,35686,'763',3.333,5),(1026,35705,35686,'63f',3.333,5),(1026,35706,35686,'3f6',3.333,5),(1026,35707,35686,'f64',3.333,5),(1026,35708,35686,'64c',3.333,5),(1026,35709,35686,'4c1',3.333,5),(1026,35710,35686,'c1a',3.333,5),(1026,35711,35686,'1a4',3.333,5),(1026,35712,35686,'a48',3.333,5),(1026,35713,35686,'488',3.333,5),(1026,35714,35686,'884',3.333,5),(1026,35715,35686,'846',3.333,5),(1026,35716,35686,'466',3.333,5),(1027,35718,35717,'naa',100,5),(1027,35719,35718,'600',3.333,5),(1027,35720,35718,'000',3.333,5),(1027,35721,35718,'00c',3.333,5),(1027,35722,35718,'0c2',3.333,5),(1027,35723,35718,'c29',3.333,5),(1027,35724,35718,'298',3.333,5),(1027,35725,35718,'987',3.333,5),(1027,35726,35718,'878',3.333,5),(1027,35727,35718,'787',3.333,5),(1027,35728,35718,'871',3.333,5),(1027,35729,35718,'715',3.333,5),(1027,35730,35718,'155',3.333,5),(1027,35731,35718,'553',3.333,5),(1027,35732,35718,'531',3.333,5),(1027,35733,35718,'312',3.333,5),(1027,35734,35718,'125',3.333,5),(1027,35735,35718,'256',3.333,5),(1027,35736,35718,'569',3.333,5),(1027,35737,35718,'691',3.333,5),(1027,35738,35718,'914',3.333,5),(1027,35739,35718,'14e',3.333,5),(1027,35740,35718,'4ee',3.333,5),(1027,35741,35718,'ee8',3.333,5),(1027,35742,35718,'e85',3.333,5),(1027,35743,35718,'856',3.333,5),(1027,35744,35718,'567',3.333,5),(1027,35745,35718,'67d',3.333,5),(1027,35746,35718,'7d0',3.333,5),(1027,35747,35718,'d02',3.333,5),(1027,35748,35718,'029',3.333,5),(1028,35750,35749,'naa',100,5),(1028,35751,35750,'600',3.333,5),(1028,35752,35750,'000',3.333,5),(1028,35753,35750,'00c',3.333,5),(1028,35754,35750,'0c2',3.333,5),(1028,35755,35750,'c29',3.333,5),(1028,35756,35750,'294',3.333,5),(1028,35757,35750,'941',3.333,5),(1028,35758,35750,'413',3.333,5),(1028,35759,35750,'13d',3.333,5),(1028,35760,35750,'3d8',3.333,5),(1028,35761,35750,'d80',3.333,5),(1028,35762,35750,'80e',3.333,5),(1028,35763,35750,'0e2',3.333,5),(1028,35764,35750,'e2b',3.333,5),(1028,35765,35750,'2b9',3.333,5),(1028,35766,35750,'b91',3.333,5),(1028,35767,35750,'918',3.333,5),(1028,35768,35750,'18f',3.333,5),(1028,35769,35750,'8f0',3.333,5),(1028,35770,35750,'f00',3.333,5),(1028,35771,35750,'009',3.333,5),(1028,35772,35750,'09e',3.333,5),(1028,35773,35750,'9ef',3.333,5),(1028,35774,35750,'ef2',3.333,5),(1028,35775,35750,'f22',3.333,5),(1028,35776,35750,'225',3.333,5),(1028,35777,35750,'254',3.333,5),(1028,35778,35750,'547',3.333,5),(1028,35779,35750,'479',3.333,5),(1028,35780,35750,'798',3.333,5),(1029,35782,35781,'naa',100,5),(1029,35783,35782,'600',3.333,5),(1029,35784,35782,'000',3.333,5),(1029,35785,35782,'00c',3.333,5),(1029,35786,35782,'0c2',3.333,5),(1029,35787,35782,'c29',3.333,5),(1029,35788,35782,'297',3.333,5),(1029,35789,35782,'972',3.333,5),(1029,35790,35782,'727',3.333,5),(1029,35791,35782,'27f',3.333,5),(1029,35792,35782,'7fa',3.333,5),(1029,35793,35782,'fa8',3.333,5),(1029,35794,35782,'a8a',3.333,5),(1029,35795,35782,'8a7',3.333,5),(1029,35796,35782,'a7a',3.333,5),(1029,35797,35782,'7a5',3.333,5),(1029,35798,35782,'a51',3.333,5),(1029,35799,35782,'518',3.333,5),(1029,35800,35782,'18c',3.333,5),(1029,35801,35782,'8cf',3.333,5),(1029,35802,35782,'cf3',3.333,5),(1029,35803,35782,'f37',3.333,5),(1029,35804,35782,'37d',3.333,5),(1029,35805,35782,'7dd',3.333,5),(1029,35806,35782,'ddd',3.333,5),(1029,35807,35782,'ddd',3.333,5),(1029,35808,35782,'ddf',3.333,5),(1029,35809,35782,'dfe',3.333,5),(1029,35810,35782,'fe0',3.333,5),(1029,35811,35782,'e0d',3.333,5),(1029,35812,35782,'0db',3.333,5),(1030,35814,35813,'naa',100,5),(1030,35815,35814,'600',3.333,5),(1030,35816,35814,'000',3.333,5),(1030,35817,35814,'00c',3.333,5),(1030,35818,35814,'0c2',3.333,5),(1030,35819,35814,'c29',3.333,5),(1030,35820,35814,'29c',3.333,5),(1030,35821,35814,'9c0',3.333,5),(1030,35822,35814,'c0b',3.333,5),(1030,35823,35814,'0b8',3.333,5),(1030,35824,35814,'b8b',3.333,5),(1030,35825,35814,'8bd',3.333,5),(1030,35826,35814,'bdf',3.333,5),(1030,35827,35814,'df9',3.333,5),(1030,35828,35814,'f97',3.333,5),(1030,35829,35814,'974',3.333,5),(1030,35830,35814,'747',3.333,5),(1030,35831,35814,'47f',3.333,5),(1030,35832,35814,'7ff',3.333,5),(1030,35833,35814,'ff9',3.333,5),(1030,35834,35814,'f9e',3.333,5),(1030,35835,35814,'9e0',3.333,5),(1030,35836,35814,'e03',3.333,5),(1030,35837,35814,'035',3.333,5),(1030,35838,35814,'350',3.333,5),(1030,35839,35814,'502',3.333,5),(1030,35840,35814,'02c',3.333,5),(1030,35841,35814,'2c8',3.333,5),(1030,35842,35814,'c89',3.333,5),(1030,35843,35814,'890',3.333,5),(1030,35844,35814,'903',3.333,5),(1031,35846,35845,'naa',100,5),(1031,35847,35846,'600',3.333,5),(1031,35848,35846,'000',3.333,5),(1031,35849,35846,'00c',3.333,5),(1031,35850,35846,'0c2',3.333,5),(1031,35851,35846,'c29',3.333,5),(1031,35852,35846,'296',3.333,5),(1031,35853,35846,'969',3.333,5),(1031,35854,35846,'696',3.333,5),(1031,35855,35846,'967',3.333,5),(1031,35856,35846,'673',3.333,5),(1031,35857,35846,'739',3.333,5),(1031,35858,35846,'39d',3.333,5),(1031,35859,35846,'9d8',3.333,5),(1031,35860,35846,'d86',3.333,5),(1031,35861,35846,'867',3.333,5),(1031,35862,35846,'67b',3.333,5),(1031,35863,35846,'7b9',3.333,5),(1031,35864,35846,'b91',3.333,5),(1031,35865,35846,'910',3.333,5),(1031,35866,35846,'108',3.333,5),(1031,35867,35846,'080',3.333,5),(1031,35868,35846,'806',3.333,5),(1031,35869,35846,'06b',3.333,5),(1031,35870,35846,'6b2',3.333,5),(1031,35871,35846,'b20',3.333,5),(1031,35872,35846,'20b',3.333,5),(1031,35873,35846,'0bf',3.333,5),(1031,35874,35846,'bf9',3.333,5),(1031,35875,35846,'f90',3.333,5),(1031,35876,35846,'90f',3.333,5),(1032,35878,35877,'naa',100,5),(1032,35879,35878,'600',3.333,5),(1032,35880,35878,'000',3.333,5),(1032,35881,35878,'00c',3.333,5),(1032,35882,35878,'0c2',3.333,5),(1032,35883,35878,'c29',3.333,5),(1032,35884,35878,'29b',3.333,5),(1032,35885,35878,'9bf',3.333,5),(1032,35886,35878,'bfc',3.333,5),(1032,35887,35878,'fc0',3.333,5),(1032,35888,35878,'c02',3.333,5),(1032,35889,35878,'02c',3.333,5),(1032,35890,35878,'2c9',3.333,5),(1032,35891,35878,'c91',3.333,5),(1032,35892,35878,'91b',3.333,5),(1032,35893,35878,'1b6',3.333,5),(1032,35894,35878,'b67',3.333,5),(1032,35895,35878,'67d',3.333,5),(1032,35896,35878,'7d3',3.333,5),(1032,35897,35878,'d3e',3.333,5),(1032,35898,35878,'3e0',3.333,5),(1032,35899,35878,'e02',3.333,5),(1032,35900,35878,'023',3.333,5),(1032,35901,35878,'230',3.333,5),(1032,35902,35878,'30b',3.333,5),(1032,35903,35878,'0be',3.333,5),(1032,35904,35878,'be1',3.333,5),(1032,35905,35878,'e11',3.333,5),(1032,35906,35878,'119',3.333,5),(1032,35907,35878,'191',3.333,5),(1032,35908,35878,'91e',3.333,5),(1033,35910,35909,'naa',100,5),(1033,35911,35910,'600',3.333,5),(1033,35912,35910,'000',3.333,5),(1033,35913,35910,'00c',3.333,5),(1033,35914,35910,'0c2',3.333,5),(1033,35915,35910,'c29',3.333,5),(1033,35916,35910,'29a',3.333,5),(1033,35917,35910,'9a2',3.333,5),(1033,35918,35910,'a2d',3.333,5),(1033,35919,35910,'2d5',3.333,5),(1033,35920,35910,'d5b',3.333,5),(1033,35921,35910,'5b9',3.333,5),(1033,35922,35910,'b99',3.333,5),(1033,35923,35910,'997',3.333,5),(1033,35924,35910,'97b',3.333,5),(1033,35925,35910,'7bb',3.333,5),(1033,35926,35910,'bbb',3.333,5),(1033,35927,35910,'bb4',3.333,5),(1033,35928,35910,'b41',3.333,5),(1033,35929,35910,'41b',3.333,5),(1033,35930,35910,'1b0',3.333,5),(1033,35931,35910,'b06',3.333,5),(1033,35932,35910,'06a',3.333,5),(1033,35933,35910,'6aa',3.333,5),(1033,35934,35910,'aaf',3.333,5),(1033,35935,35910,'af1',3.333,5),(1033,35936,35910,'f1f',3.333,5),(1033,35937,35910,'1f7',3.333,5),(1033,35938,35910,'f7f',3.333,5),(1033,35939,35910,'7f6',3.333,5),(1033,35940,35910,'f69',3.333,5),(1034,35942,35941,'naa',100,5),(1034,35943,35942,'600',3.333,5),(1034,35944,35942,'000',3.333,5),(1034,35945,35942,'00c',3.333,5),(1034,35946,35942,'0c2',3.333,5),(1034,35947,35942,'c29',3.333,5),(1034,35948,35942,'290',3.333,5),(1034,35949,35942,'906',3.333,5),(1034,35950,35942,'066',3.333,5),(1034,35951,35942,'665',3.333,5),(1034,35952,35942,'651',3.333,5),(1034,35953,35942,'516',3.333,5),(1034,35954,35942,'161',3.333,5),(1034,35955,35942,'614',3.333,5),(1034,35956,35942,'146',3.333,5),(1034,35957,35942,'461',3.333,5),(1034,35958,35942,'616',3.333,5),(1034,35959,35942,'169',3.333,5),(1034,35960,35942,'691',3.333,5),(1034,35961,35942,'91e',3.333,5),(1034,35962,35942,'1e2',3.333,5),(1034,35963,35942,'e24',3.333,5),(1034,35964,35942,'247',3.333,5),(1034,35965,35942,'47e',3.333,5),(1034,35966,35942,'7ee',3.333,5),(1034,35967,35942,'eea',3.333,5),(1034,35968,35942,'ea5',3.333,5),(1034,35969,35942,'a5c',3.333,5),(1034,35970,35942,'5cf',3.333,5),(1034,35971,35942,'cf1',3.333,5),(1034,35972,35942,'f10',3.333,5),(1035,35974,35973,'naa',100,5),(1035,35975,35974,'600',3.333,5),(1035,35976,35974,'000',3.333,5),(1035,35977,35974,'00c',3.333,5),(1035,35978,35974,'0c2',3.333,5),(1035,35979,35974,'c29',3.333,5),(1035,35980,35974,'290',3.333,5),(1035,35981,35974,'90b',3.333,5),(1035,35982,35974,'0b7',3.333,5),(1035,35983,35974,'b79',3.333,5),(1035,35984,35974,'795',3.333,5),(1035,35985,35974,'958',3.333,5),(1035,35986,35974,'582',3.333,5),(1035,35987,35974,'82d',3.333,5),(1035,35988,35974,'2df',3.333,5),(1035,35989,35974,'df1',3.333,5),(1035,35990,35974,'f1f',3.333,5),(1035,35991,35974,'1f9',3.333,5),(1035,35992,35974,'f9e',3.333,5),(1035,35993,35974,'9ec',3.333,5),(1035,35994,35974,'ecd',3.333,5),(1035,35995,35974,'cd8',3.333,5),(1035,35996,35974,'d8f',3.333,5),(1035,35997,35974,'8fa',3.333,5),(1035,35998,35974,'fa4',3.333,5),(1035,35999,35974,'a45',3.333,5),(1035,36000,35974,'454',3.333,5),(1035,36001,35974,'546',3.333,5),(1035,36002,35974,'462',3.333,5),(1035,36003,35974,'62a',3.333,5),(1035,36004,35974,'2a5',3.333,5),(1036,36006,36005,'naa',100,5),(1036,36007,36006,'600',3.333,5),(1036,36008,36006,'000',3.333,5),(1036,36009,36006,'00c',3.333,5),(1036,36010,36006,'0c2',3.333,5),(1036,36011,36006,'c29',3.333,5),(1036,36012,36006,'298',3.333,5),(1036,36013,36006,'982',3.333,5),(1036,36014,36006,'829',3.333,5),(1036,36015,36006,'29b',3.333,5),(1036,36016,36006,'9b0',3.333,5),(1036,36017,36006,'b09',3.333,5),(1036,36018,36006,'097',3.333,5),(1036,36019,36006,'971',3.333,5),(1036,36020,36006,'717',3.333,5),(1036,36021,36006,'17e',3.333,5),(1036,36022,36006,'7e3',3.333,5),(1036,36023,36006,'e37',3.333,5),(1036,36024,36006,'37a',3.333,5),(1036,36025,36006,'7ac',3.333,5),(1036,36026,36006,'ac7',3.333,5),(1036,36027,36006,'c70',3.333,5),(1036,36028,36006,'705',3.333,5),(1036,36029,36006,'05f',3.333,5),(1036,36030,36006,'5f7',3.333,5),(1036,36031,36006,'f7c',3.333,5),(1036,36032,36006,'7ce',3.333,5),(1036,36033,36006,'ce8',3.333,5),(1036,36034,36006,'e89',3.333,5),(1036,36035,36006,'89a',3.333,5),(1036,36036,36006,'9a3',3.333,5),(1037,36038,36037,'naa',100,5),(1037,36039,36038,'600',3.333,5),(1037,36040,36038,'000',3.333,5),(1037,36041,36038,'00c',3.333,5),(1037,36042,36038,'0c2',3.333,5),(1037,36043,36038,'c29',3.333,5),(1037,36044,36038,'298',3.333,5),(1037,36045,36038,'98c',3.333,5),(1037,36046,36038,'8cf',3.333,5),(1037,36047,36038,'cf2',3.333,5),(1037,36048,36038,'f26',3.333,5),(1037,36049,36038,'260',3.333,5),(1037,36050,36038,'60d',3.333,5),(1037,36051,36038,'0d0',3.333,5),(1037,36052,36038,'d0d',3.333,5),(1037,36053,36038,'0d7',3.333,5),(1037,36054,36038,'d72',3.333,5),(1037,36055,36038,'72f',3.333,5),(1037,36056,36038,'2fe',3.333,5),(1037,36057,36038,'fe7',3.333,5),(1037,36058,36038,'e76',3.333,5),(1037,36059,36038,'768',3.333,5),(1037,36060,36038,'685',3.333,5),(1037,36061,36038,'85b',3.333,5),(1037,36062,36038,'5bc',3.333,5),(1037,36063,36038,'bcd',3.333,5),(1037,36064,36038,'cd2',3.333,5),(1037,36065,36038,'d2d',3.333,5),(1037,36066,36038,'2d6',3.333,5),(1037,36067,36038,'d63',3.333,5),(1037,36068,36038,'633',3.333,5),(1038,36070,36069,'naa',100,5),(1038,36071,36070,'600',3.333,5),(1038,36072,36070,'000',3.333,5),(1038,36073,36070,'00c',3.333,5),(1038,36074,36070,'0c2',3.333,5),(1038,36075,36070,'c29',3.333,5),(1038,36076,36070,'294',3.333,5),(1038,36077,36070,'94b',3.333,5),(1038,36078,36070,'4b9',3.333,5),(1038,36079,36070,'b9d',3.333,5),(1038,36080,36070,'9d8',3.333,5),(1038,36081,36070,'d86',3.333,5),(1038,36082,36070,'865',3.333,5),(1038,36083,36070,'659',3.333,5),(1038,36084,36070,'596',3.333,5),(1038,36085,36070,'969',3.333,5),(1038,36086,36070,'69a',3.333,5),(1038,36087,36070,'9a6',3.333,5),(1038,36088,36070,'a67',3.333,5),(1038,36089,36070,'67d',3.333,5),(1038,36090,36070,'7d1',3.333,5),(1038,36091,36070,'d19',3.333,5),(1038,36092,36070,'19f',3.333,5),(1038,36093,36070,'9f9',3.333,5),(1038,36094,36070,'f9c',3.333,5),(1038,36095,36070,'9c9',3.333,5),(1038,36096,36070,'c97',3.333,5),(1038,36097,36070,'97b',3.333,5),(1038,36098,36070,'7b8',3.333,5),(1038,36099,36070,'b82',3.333,5),(1038,36100,36070,'825',3.333,5),(1039,36102,36101,'naa',100,5),(1039,36103,36102,'600',3.333,5),(1039,36104,36102,'000',3.333,5),(1039,36105,36102,'00c',3.333,5),(1039,36106,36102,'0c2',3.333,5),(1039,36107,36102,'c29',3.333,5),(1039,36108,36102,'291',3.333,5),(1039,36109,36102,'91b',3.333,5),(1039,36110,36102,'1bc',3.333,5),(1039,36111,36102,'bc3',3.333,5),(1039,36112,36102,'c37',3.333,5),(1039,36113,36102,'37a',3.333,5),(1039,36114,36102,'7a7',3.333,5),(1039,36115,36102,'a74',3.333,5),(1039,36116,36102,'74f',3.333,5),(1039,36117,36102,'4fd',3.333,5),(1039,36118,36102,'fd5',3.333,5),(1039,36119,36102,'d5c',3.333,5),(1039,36120,36102,'5c3',3.333,5),(1039,36121,36102,'c39',3.333,5),(1039,36122,36102,'398',3.333,5),(1039,36123,36102,'98a',3.333,5),(1039,36124,36102,'8a8',3.333,5),(1039,36125,36102,'a84',3.333,5),(1039,36126,36102,'84f',3.333,5),(1039,36127,36102,'4f7',3.333,5),(1039,36128,36102,'f76',3.333,5),(1039,36129,36102,'764',3.333,5),(1039,36130,36102,'641',3.333,5),(1039,36131,36102,'41e',3.333,5),(1039,36132,36102,'1e0',3.333,5),(1040,36134,36133,'naa',100,5),(1040,36135,36134,'600',3.333,5),(1040,36136,36134,'000',3.333,5),(1040,36137,36134,'00c',3.333,5),(1040,36138,36134,'0c2',3.333,5),(1040,36139,36134,'c29',3.333,5),(1040,36140,36134,'292',3.333,5),(1040,36141,36134,'925',3.333,5),(1040,36142,36134,'25a',3.333,5),(1040,36143,36134,'5ab',3.333,5),(1040,36144,36134,'abe',3.333,5),(1040,36145,36134,'be3',3.333,5),(1040,36146,36134,'e38',3.333,5),(1040,36147,36134,'385',3.333,5),(1040,36148,36134,'85a',3.333,5),(1040,36149,36134,'5a8',3.333,5),(1040,36150,36134,'a8f',3.333,5),(1040,36151,36134,'8f6',3.333,5),(1040,36152,36134,'f68',3.333,5),(1040,36153,36134,'68a',3.333,5),(1040,36154,36134,'8a4',3.333,5),(1040,36155,36134,'a4d',3.333,5),(1040,36156,36134,'4d0',3.333,5),(1040,36157,36134,'d05',3.333,5),(1040,36158,36134,'054',3.333,5),(1040,36159,36134,'542',3.333,5),(1040,36160,36134,'42e',3.333,5),(1040,36161,36134,'2e3',3.333,5),(1040,36162,36134,'e33',3.333,5),(1040,36163,36134,'33c',3.333,5),(1040,36164,36134,'3c8',3.333,5),(1041,36166,36165,'naa',100,5),(1041,36167,36166,'600',3.333,5),(1041,36168,36166,'000',3.333,5),(1041,36169,36166,'00c',3.333,5),(1041,36170,36166,'0c2',3.333,5),(1041,36171,36166,'c29',3.333,5),(1041,36172,36166,'29c',3.333,5),(1041,36173,36166,'9cb',3.333,5),(1041,36174,36166,'cb2',3.333,5),(1041,36175,36166,'b28',3.333,5),(1041,36176,36166,'284',3.333,5),(1041,36177,36166,'84a',3.333,5),(1041,36178,36166,'4a7',3.333,5),(1041,36179,36166,'a71',3.333,5),(1041,36180,36166,'715',3.333,5),(1041,36181,36166,'150',3.333,5),(1041,36182,36166,'509',3.333,5),(1041,36183,36166,'093',3.333,5),(1041,36184,36166,'93d',3.333,5),(1041,36185,36166,'3da',3.333,5),(1041,36186,36166,'da6',3.333,5),(1041,36187,36166,'a6b',3.333,5),(1041,36188,36166,'6b1',3.333,5),(1041,36189,36166,'b11',3.333,5),(1041,36190,36166,'11e',3.333,5),(1041,36191,36166,'1e0',3.333,5),(1041,36192,36166,'e01',3.333,5),(1041,36193,36166,'012',3.333,5),(1041,36194,36166,'129',3.333,5),(1041,36195,36166,'29f',3.333,5),(1041,36196,36166,'9fc',3.333,5),(1042,36198,36197,'naa',100,5),(1042,36199,36198,'600',3.333,5),(1042,36200,36198,'000',3.333,5),(1042,36201,36198,'00c',3.333,5),(1042,36202,36198,'0c2',3.333,5),(1042,36203,36198,'c29',3.333,5),(1042,36204,36198,'29f',3.333,5),(1042,36205,36198,'9f7',3.333,5),(1042,36206,36198,'f70',3.333,5),(1042,36207,36198,'702',3.333,5),(1042,36208,36198,'02b',3.333,5),(1042,36209,36198,'2b2',3.333,5),(1042,36210,36198,'b28',3.333,5),(1042,36211,36198,'287',3.333,5),(1042,36212,36198,'878',3.333,5),(1042,36213,36198,'78f',3.333,5),(1042,36214,36198,'8fa',3.333,5),(1042,36215,36198,'fae',3.333,5),(1042,36216,36198,'ae8',3.333,5),(1042,36217,36198,'e8f',3.333,5),(1042,36218,36198,'8f0',3.333,5),(1042,36219,36198,'f07',3.333,5),(1042,36220,36198,'07c',3.333,5),(1042,36221,36198,'7c2',3.333,5),(1042,36222,36198,'c2b',3.333,5),(1042,36223,36198,'2b0',3.333,5),(1042,36224,36198,'b0f',3.333,5),(1042,36225,36198,'0f7',3.333,5),(1042,36226,36198,'f70',3.333,5),(1042,36227,36198,'707',3.333,5),(1042,36228,36198,'077',3.333,5),(1043,36230,36229,'naa',100,5),(1043,36231,36230,'600',3.333,5),(1043,36232,36230,'000',3.333,5),(1043,36233,36230,'00c',3.333,5),(1043,36234,36230,'0c2',3.333,5),(1043,36235,36230,'c29',3.333,5),(1043,36236,36230,'295',3.333,5),(1043,36237,36230,'953',3.333,5),(1043,36238,36230,'535',3.333,5),(1043,36239,36230,'351',3.333,5),(1043,36240,36230,'51a',3.333,5),(1043,36241,36230,'1ab',3.333,5),(1043,36242,36230,'ab5',3.333,5),(1043,36243,36230,'b5b',3.333,5),(1043,36244,36230,'5b0',3.333,5),(1043,36245,36230,'b0e',3.333,5),(1043,36246,36230,'0e5',3.333,5),(1043,36247,36230,'e55',3.333,5),(1043,36248,36230,'553',3.333,5),(1043,36249,36230,'53d',3.333,5),(1043,36250,36230,'3d4',3.333,5),(1043,36251,36230,'d42',3.333,5),(1043,36252,36230,'425',3.333,5),(1043,36253,36230,'259',3.333,5),(1043,36254,36230,'590',3.333,5),(1043,36255,36230,'909',3.333,5),(1043,36256,36230,'09d',3.333,5),(1043,36257,36230,'9d4',3.333,5),(1043,36258,36230,'d40',3.333,5),(1043,36259,36230,'40d',3.333,5),(1043,36260,36230,'0d9',3.333,5),(1044,36262,36261,'naa',100,5),(1044,36263,36262,'600',3.333,5),(1044,36264,36262,'000',3.333,5),(1044,36265,36262,'00c',3.333,5),(1044,36266,36262,'0c2',3.333,5),(1044,36267,36262,'c29',3.333,5),(1044,36268,36262,'295',3.333,5),(1044,36269,36262,'95f',3.333,5),(1044,36270,36262,'5ff',3.333,5),(1044,36271,36262,'ff5',3.333,5),(1044,36272,36262,'f58',3.333,5),(1044,36273,36262,'582',3.333,5),(1044,36274,36262,'82a',3.333,5),(1044,36275,36262,'2ab',3.333,5),(1044,36276,36262,'abe',3.333,5),(1044,36277,36262,'be8',3.333,5),(1044,36278,36262,'e88',3.333,5),(1044,36279,36262,'88f',3.333,5),(1044,36280,36262,'8fa',3.333,5),(1044,36281,36262,'fa6',3.333,5),(1044,36282,36262,'a6c',3.333,5),(1044,36283,36262,'6cd',3.333,5),(1044,36284,36262,'cdc',3.333,5),(1044,36285,36262,'dc2',3.333,5),(1044,36286,36262,'c28',3.333,5),(1044,36287,36262,'285',3.333,5),(1044,36288,36262,'858',3.333,5),(1044,36289,36262,'58d',3.333,5),(1044,36290,36262,'8d8',3.333,5),(1044,36291,36262,'d89',3.333,5),(1044,36292,36262,'890',3.333,5),(1045,36294,36293,'naa',100,5),(1045,36295,36294,'600',3.333,5),(1045,36296,36294,'000',3.333,5),(1045,36297,36294,'00c',3.333,5),(1045,36298,36294,'0c2',3.333,5),(1045,36299,36294,'c29',3.333,5),(1045,36300,36294,'29d',3.333,5),(1045,36301,36294,'9d3',3.333,5),(1045,36302,36294,'d35',3.333,5),(1045,36303,36294,'350',3.333,5),(1045,36304,36294,'504',3.333,5),(1045,36305,36294,'045',3.333,5),(1045,36306,36294,'459',3.333,5),(1045,36307,36294,'592',3.333,5),(1045,36308,36294,'92e',3.333,5),(1045,36309,36294,'2ea',3.333,5),(1045,36310,36294,'ea1',3.333,5),(1045,36311,36294,'a11',3.333,5),(1045,36312,36294,'118',3.333,5),(1045,36313,36294,'189',3.333,5),(1045,36314,36294,'898',3.333,5),(1045,36315,36294,'98c',3.333,5),(1045,36316,36294,'8cf',3.333,5),(1045,36317,36294,'cf3',3.333,5),(1045,36318,36294,'f3b',3.333,5),(1045,36319,36294,'3b3',3.333,5),(1045,36320,36294,'b3b',3.333,5),(1045,36321,36294,'3b9',3.333,5),(1045,36322,36294,'b9a',3.333,5),(1045,36323,36294,'9af',3.333,5),(1045,36324,36294,'af0',3.333,5),(1046,36326,36325,'naa',100,5),(1046,36327,36326,'600',3.333,5),(1046,36328,36326,'000',3.333,5),(1046,36329,36326,'00c',3.333,5),(1046,36330,36326,'0c2',3.333,5),(1046,36331,36326,'c29',3.333,5),(1046,36332,36326,'299',3.333,5),(1046,36333,36326,'99a',3.333,5),(1046,36334,36326,'9a5',3.333,5),(1046,36335,36326,'a59',3.333,5),(1046,36336,36326,'597',3.333,5),(1046,36337,36326,'977',3.333,5),(1046,36338,36326,'77c',3.333,5),(1046,36339,36326,'7cc',3.333,5),(1046,36340,36326,'ccb',3.333,5),(1046,36341,36326,'cbf',3.333,5),(1046,36342,36326,'bf4',3.333,5),(1046,36343,36326,'f40',3.333,5),(1046,36344,36326,'403',3.333,5),(1046,36345,36326,'030',3.333,5),(1046,36346,36326,'302',3.333,5),(1046,36347,36326,'024',3.333,5),(1046,36348,36326,'244',3.333,5),(1046,36349,36326,'448',3.333,5),(1046,36350,36326,'488',3.333,5),(1046,36351,36326,'88a',3.333,5),(1046,36352,36326,'8a9',3.333,5),(1046,36353,36326,'a9d',3.333,5),(1046,36354,36326,'9d4',3.333,5),(1046,36355,36326,'d4d',3.333,5),(1046,36356,36326,'4d3',3.333,5),(1047,36358,36357,'naa',100,5),(1047,36359,36358,'600',3.333,5),(1047,36360,36358,'000',3.333,5),(1047,36361,36358,'00c',3.333,5),(1047,36362,36358,'0c2',3.333,5),(1047,36363,36358,'c29',3.333,5),(1047,36364,36358,'291',3.333,5),(1047,36365,36358,'919',3.333,5),(1047,36366,36358,'195',3.333,5),(1047,36367,36358,'956',3.333,5),(1047,36368,36358,'567',3.333,5),(1047,36369,36358,'673',3.333,5),(1047,36370,36358,'73b',3.333,5),(1047,36371,36358,'3b0',3.333,5),(1047,36372,36358,'b07',3.333,5),(1047,36373,36358,'07a',3.333,5),(1047,36374,36358,'7a8',3.333,5),(1047,36375,36358,'a82',3.333,5),(1047,36376,36358,'82d',3.333,5),(1047,36377,36358,'2d3',3.333,5),(1047,36378,36358,'d32',3.333,5),(1047,36379,36358,'32e',3.333,5),(1047,36380,36358,'2ed',3.333,5),(1047,36381,36358,'ed5',3.333,5),(1047,36382,36358,'d55',3.333,5),(1047,36383,36358,'550',3.333,5),(1047,36384,36358,'50e',3.333,5),(1047,36385,36358,'0ed',3.333,5),(1047,36386,36358,'ed7',3.333,5),(1047,36387,36358,'d73',3.333,5),(1047,36388,36358,'733',3.333,5),(1048,36390,36389,'naa',100,5),(1048,36391,36390,'600',3.333,5),(1048,36392,36390,'000',3.333,5),(1048,36393,36390,'00c',3.333,5),(1048,36394,36390,'0c2',3.333,5),(1048,36395,36390,'c29',3.333,5),(1048,36396,36390,'29e',3.333,5),(1048,36397,36390,'9e6',3.333,5),(1048,36398,36390,'e6a',3.333,5),(1048,36399,36390,'6a0',3.333,5),(1048,36400,36390,'a04',3.333,5),(1048,36401,36390,'04a',3.333,5),(1048,36402,36390,'4a7',3.333,5),(1048,36403,36390,'a78',3.333,5),(1048,36404,36390,'78d',3.333,5),(1048,36405,36390,'8d3',3.333,5),(1048,36406,36390,'d3d',3.333,5),(1048,36407,36390,'3d0',3.333,5),(1048,36408,36390,'d05',3.333,5),(1048,36409,36390,'058',3.333,5),(1048,36410,36390,'58a',3.333,5),(1048,36411,36390,'8a6',3.333,5),(1048,36412,36390,'a6a',3.333,5),(1048,36413,36390,'6ae',3.333,5),(1048,36414,36390,'aeb',3.333,5),(1048,36415,36390,'ebf',3.333,5),(1048,36416,36390,'bf2',3.333,5),(1048,36417,36390,'f2b',3.333,5),(1048,36418,36390,'2bc',3.333,5),(1048,36419,36390,'bc2',3.333,5),(1048,36420,36390,'c2d',3.333,5),(1049,36422,36421,'naa',100,5),(1049,36423,36422,'600',3.333,5),(1049,36424,36422,'000',3.333,5),(1049,36425,36422,'00c',3.333,5),(1049,36426,36422,'0c2',3.333,5),(1049,36427,36422,'c29',3.333,5),(1049,36428,36422,'29f',3.333,5),(1049,36429,36422,'9f8',3.333,5),(1049,36430,36422,'f86',3.333,5),(1049,36431,36422,'867',3.333,5),(1049,36432,36422,'67e',3.333,5),(1049,36433,36422,'7ed',3.333,5),(1049,36434,36422,'ed9',3.333,5),(1049,36435,36422,'d9d',3.333,5),(1049,36436,36422,'9d3',3.333,5),(1049,36437,36422,'d3c',3.333,5),(1049,36438,36422,'3cb',3.333,5),(1049,36439,36422,'cbb',3.333,5),(1049,36440,36422,'bbe',3.333,5),(1049,36441,36422,'bee',3.333,5),(1049,36442,36422,'eef',3.333,5),(1049,36443,36422,'efc',3.333,5),(1049,36444,36422,'fc3',3.333,5),(1049,36445,36422,'c30',3.333,5),(1049,36446,36422,'30e',3.333,5),(1049,36447,36422,'0e7',3.333,5),(1049,36448,36422,'e7b',3.333,5),(1049,36449,36422,'7ba',3.333,5),(1049,36450,36422,'ba1',3.333,5),(1049,36451,36422,'a1b',3.333,5),(1049,36452,36422,'1b7',3.333,5),(1050,36454,36453,'naa',100,5),(1050,36455,36454,'600',3.333,5),(1050,36456,36454,'000',3.333,5),(1050,36457,36454,'00c',3.333,5),(1050,36458,36454,'0c2',3.333,5),(1050,36459,36454,'c29',3.333,5),(1050,36460,36454,'299',3.333,5),(1050,36461,36454,'99b',3.333,5),(1050,36462,36454,'9bc',3.333,5),(1050,36463,36454,'bc3',3.333,5),(1050,36464,36454,'c34',3.333,5),(1050,36465,36454,'347',3.333,5),(1050,36466,36454,'479',3.333,5),(1050,36467,36454,'79b',3.333,5),(1050,36468,36454,'9bc',3.333,5),(1050,36469,36454,'bc3',3.333,5),(1050,36470,36454,'c38',3.333,5),(1050,36471,36454,'380',3.333,5),(1050,36472,36454,'80b',3.333,5),(1050,36473,36454,'0b0',3.333,5),(1050,36474,36454,'b07',3.333,5),(1050,36475,36454,'072',3.333,5),(1050,36476,36454,'725',3.333,5),(1050,36477,36454,'25d',3.333,5),(1050,36478,36454,'5de',3.333,5),(1050,36479,36454,'deb',3.333,5),(1050,36480,36454,'ebb',3.333,5),(1050,36481,36454,'bba',3.333,5),(1050,36482,36454,'ba0',3.333,5),(1050,36483,36454,'a0e',3.333,5),(1050,36484,36454,'0e0',3.333,5),(1051,36486,36485,'naa',100,5),(1051,36487,36486,'600',3.333,5),(1051,36488,36486,'000',3.333,5),(1051,36489,36486,'00c',3.333,5),(1051,36490,36486,'0c2',3.333,5),(1051,36491,36486,'c29',3.333,5),(1051,36492,36486,'29e',3.333,5),(1051,36493,36486,'9ef',3.333,5),(1051,36494,36486,'efb',3.333,5),(1051,36495,36486,'fb7',3.333,5),(1051,36496,36486,'b74',3.333,5),(1051,36497,36486,'740',3.333,5),(1051,36498,36486,'400',3.333,5),(1051,36499,36486,'00c',3.333,5),(1051,36500,36486,'0c1',3.333,5),(1051,36501,36486,'c14',3.333,5),(1051,36502,36486,'140',3.333,5),(1051,36503,36486,'405',3.333,5),(1051,36504,36486,'058',3.333,5),(1051,36505,36486,'582',3.333,5),(1051,36506,36486,'829',3.333,5),(1051,36507,36486,'295',3.333,5),(1051,36508,36486,'956',3.333,5),(1051,36509,36486,'56b',3.333,5),(1051,36510,36486,'6bd',3.333,5),(1051,36511,36486,'bde',3.333,5),(1051,36512,36486,'de3',3.333,5),(1051,36513,36486,'e37',3.333,5),(1051,36514,36486,'37e',3.333,5),(1051,36515,36486,'7e0',3.333,5),(1051,36516,36486,'e04',3.333,5),(1052,36518,36517,'naa',100,5),(1052,36519,36518,'600',3.333,5),(1052,36520,36518,'000',3.333,5),(1052,36521,36518,'00c',3.333,5),(1052,36522,36518,'0c2',3.333,5),(1052,36523,36518,'c29',3.333,5),(1052,36524,36518,'29e',3.333,5),(1052,36525,36518,'9e5',3.333,5),(1052,36526,36518,'e58',3.333,5),(1052,36527,36518,'58a',3.333,5),(1052,36528,36518,'8a8',3.333,5),(1052,36529,36518,'a86',3.333,5),(1052,36530,36518,'86d',3.333,5),(1052,36531,36518,'6d3',3.333,5),(1052,36532,36518,'d36',3.333,5),(1052,36533,36518,'369',3.333,5),(1052,36534,36518,'69a',3.333,5),(1052,36535,36518,'9a7',3.333,5),(1052,36536,36518,'a7c',3.333,5),(1052,36537,36518,'7c6',3.333,5),(1052,36538,36518,'c63',3.333,5),(1052,36539,36518,'63c',3.333,5),(1052,36540,36518,'3cc',3.333,5),(1052,36541,36518,'cc5',3.333,5),(1052,36542,36518,'c5f',3.333,5),(1052,36543,36518,'5fd',3.333,5),(1052,36544,36518,'fdf',3.333,5),(1052,36545,36518,'dfe',3.333,5),(1052,36546,36518,'fe1',3.333,5),(1052,36547,36518,'e12',3.333,5),(1052,36548,36518,'120',3.333,5),(1053,36550,36549,'naa',100,5),(1053,36551,36550,'600',3.333,5),(1053,36552,36550,'000',3.333,5),(1053,36553,36550,'00c',3.333,5),(1053,36554,36550,'0c2',3.333,5),(1053,36555,36550,'c29',3.333,5),(1053,36556,36550,'29b',3.333,5),(1053,36557,36550,'9be',3.333,5),(1053,36558,36550,'be4',3.333,5),(1053,36559,36550,'e43',3.333,5),(1053,36560,36550,'43e',3.333,5),(1053,36561,36550,'3e0',3.333,5),(1053,36562,36550,'e09',3.333,5),(1053,36563,36550,'090',3.333,5),(1053,36564,36550,'906',3.333,5),(1053,36565,36550,'063',3.333,5),(1053,36566,36550,'639',3.333,5),(1053,36567,36550,'396',3.333,5),(1053,36568,36550,'966',3.333,5),(1053,36569,36550,'660',3.333,5),(1053,36570,36550,'608',3.333,5),(1053,36571,36550,'083',3.333,5),(1053,36572,36550,'83a',3.333,5),(1053,36573,36550,'3a4',3.333,5),(1053,36574,36550,'a4f',3.333,5),(1053,36575,36550,'4fb',3.333,5),(1053,36576,36550,'fb5',3.333,5),(1053,36577,36550,'b54',3.333,5),(1053,36578,36550,'540',3.333,5),(1053,36579,36550,'40b',3.333,5),(1053,36580,36550,'0b2',3.333,5),(1054,36582,36581,'naa',100,5),(1054,36583,36582,'600',3.333,5),(1054,36584,36582,'000',3.333,5),(1054,36585,36582,'00c',3.333,5),(1054,36586,36582,'0c2',3.333,5),(1054,36587,36582,'c29',3.333,5),(1054,36588,36582,'291',3.333,5),(1054,36589,36582,'919',3.333,5),(1054,36590,36582,'199',3.333,5),(1054,36591,36582,'99f',3.333,5),(1054,36592,36582,'9f4',3.333,5),(1054,36593,36582,'f4b',3.333,5),(1054,36594,36582,'4bd',3.333,5),(1054,36595,36582,'bd2',3.333,5),(1054,36596,36582,'d2a',3.333,5),(1054,36597,36582,'2af',3.333,5),(1054,36598,36582,'af7',3.333,5),(1054,36599,36582,'f7d',3.333,5),(1054,36600,36582,'7dc',3.333,5),(1054,36601,36582,'dc6',3.333,5),(1054,36602,36582,'c67',3.333,5),(1054,36603,36582,'678',3.333,5),(1054,36604,36582,'786',3.333,5),(1054,36605,36582,'866',3.333,5),(1054,36606,36582,'66d',3.333,5),(1054,36607,36582,'6df',3.333,5),(1054,36608,36582,'dfc',3.333,5),(1054,36609,36582,'fc3',3.333,5),(1054,36610,36582,'c3e',3.333,5),(1054,36611,36582,'3ef',3.333,5),(1054,36612,36582,'efb',3.333,5),(1055,36614,36613,'naa',100,5),(1055,36615,36614,'600',3.333,5),(1055,36616,36614,'000',3.333,5),(1055,36617,36614,'00c',3.333,5),(1055,36618,36614,'0c2',3.333,5),(1055,36619,36614,'c29',3.333,5),(1055,36620,36614,'296',3.333,5),(1055,36621,36614,'960',3.333,5),(1055,36622,36614,'601',3.333,5),(1055,36623,36614,'01f',3.333,5),(1055,36624,36614,'1f4',3.333,5),(1055,36625,36614,'f47',3.333,5),(1055,36626,36614,'47c',3.333,5),(1055,36627,36614,'7c3',3.333,5),(1055,36628,36614,'c3c',3.333,5),(1055,36629,36614,'3ce',3.333,5),(1055,36630,36614,'ce5',3.333,5),(1055,36631,36614,'e5f',3.333,5),(1055,36632,36614,'5fc',3.333,5),(1055,36633,36614,'fcc',3.333,5),(1055,36634,36614,'cc2',3.333,5),(1055,36635,36614,'c29',3.333,5),(1055,36636,36614,'295',3.333,5),(1055,36637,36614,'951',3.333,5),(1055,36638,36614,'51b',3.333,5),(1055,36639,36614,'1b5',3.333,5),(1055,36640,36614,'b5e',3.333,5),(1055,36641,36614,'5e7',3.333,5),(1055,36642,36614,'e72',3.333,5),(1055,36643,36614,'72c',3.333,5),(1055,36644,36614,'2c6',3.333,5),(1056,36646,36645,'naa',100,5),(1056,36647,36646,'600',3.333,5),(1056,36648,36646,'000',3.333,5),(1056,36649,36646,'00c',3.333,5),(1056,36650,36646,'0c2',3.333,5),(1056,36651,36646,'c29',3.333,5),(1056,36652,36646,'299',3.333,5),(1056,36653,36646,'995',3.333,5),(1056,36654,36646,'95c',3.333,5),(1056,36655,36646,'5cd',3.333,5),(1056,36656,36646,'cdb',3.333,5),(1056,36657,36646,'db5',3.333,5),(1056,36658,36646,'b55',3.333,5),(1056,36659,36646,'553',3.333,5),(1056,36660,36646,'534',3.333,5),(1056,36661,36646,'343',3.333,5),(1056,36662,36646,'435',3.333,5),(1056,36663,36646,'350',3.333,5),(1056,36664,36646,'506',3.333,5),(1056,36665,36646,'063',3.333,5),(1056,36666,36646,'63d',3.333,5),(1056,36667,36646,'3dc',3.333,5),(1056,36668,36646,'dc1',3.333,5),(1056,36669,36646,'c1a',3.333,5),(1056,36670,36646,'1a4',3.333,5),(1056,36671,36646,'a45',3.333,5),(1056,36672,36646,'45e',3.333,5),(1056,36673,36646,'5e0',3.333,5),(1056,36674,36646,'e0b',3.333,5),(1056,36675,36646,'0be',3.333,5),(1056,36676,36646,'be7',3.333,5),(1057,36678,36677,'naa',100,5),(1057,36679,36678,'600',3.333,5),(1057,36680,36678,'000',3.333,5),(1057,36681,36678,'00c',3.333,5),(1057,36682,36678,'0c2',3.333,5),(1057,36683,36678,'c29',3.333,5),(1057,36684,36678,'292',3.333,5),(1057,36685,36678,'928',3.333,5),(1057,36686,36678,'284',3.333,5),(1057,36687,36678,'84b',3.333,5),(1057,36688,36678,'4b5',3.333,5),(1057,36689,36678,'b53',3.333,5),(1057,36690,36678,'53b',3.333,5),(1057,36691,36678,'3b7',3.333,5),(1057,36692,36678,'b73',3.333,5),(1057,36693,36678,'730',3.333,5),(1057,36694,36678,'30c',3.333,5),(1057,36695,36678,'0cc',3.333,5),(1057,36696,36678,'cc7',3.333,5),(1057,36697,36678,'c72',3.333,5),(1057,36698,36678,'726',3.333,5),(1057,36699,36678,'26c',3.333,5),(1057,36700,36678,'6cf',3.333,5),(1057,36701,36678,'cfc',3.333,5),(1057,36702,36678,'fc4',3.333,5),(1057,36703,36678,'c43',3.333,5),(1057,36704,36678,'43f',3.333,5),(1057,36705,36678,'3f0',3.333,5),(1057,36706,36678,'f09',3.333,5),(1057,36707,36678,'09c',3.333,5),(1057,36708,36678,'9c6',3.333,5),(1058,36710,36709,'naa',100,5),(1058,36711,36710,'600',3.333,5),(1058,36712,36710,'000',3.333,5),(1058,36713,36710,'00c',3.333,5),(1058,36714,36710,'0c2',3.333,5),(1058,36715,36710,'c29',3.333,5),(1058,36716,36710,'297',3.333,5),(1058,36717,36710,'976',3.333,5),(1058,36718,36710,'76d',3.333,5),(1058,36719,36710,'6de',3.333,5),(1058,36720,36710,'deb',3.333,5),(1058,36721,36710,'ebf',3.333,5),(1058,36722,36710,'bf2',3.333,5),(1058,36723,36710,'f20',3.333,5),(1058,36724,36710,'206',3.333,5),(1058,36725,36710,'06c',3.333,5),(1058,36726,36710,'6cf',3.333,5),(1058,36727,36710,'cf6',3.333,5),(1058,36728,36710,'f68',3.333,5),(1058,36729,36710,'689',3.333,5),(1058,36730,36710,'892',3.333,5),(1058,36731,36710,'924',3.333,5),(1058,36732,36710,'247',3.333,5),(1058,36733,36710,'474',3.333,5),(1058,36734,36710,'749',3.333,5),(1058,36735,36710,'49f',3.333,5),(1058,36736,36710,'9f3',3.333,5),(1058,36737,36710,'f31',3.333,5),(1058,36738,36710,'310',3.333,5),(1058,36739,36710,'104',3.333,5),(1058,36740,36710,'041',3.333,5),(1059,36742,36741,'naa',100,5),(1059,36743,36742,'600',3.333,5),(1059,36744,36742,'000',3.333,5),(1059,36745,36742,'00c',3.333,5),(1059,36746,36742,'0c2',3.333,5),(1059,36747,36742,'c29',3.333,5),(1059,36748,36742,'29a',3.333,5),(1059,36749,36742,'9a3',3.333,5),(1059,36750,36742,'a3a',3.333,5),(1059,36751,36742,'3af',3.333,5),(1059,36752,36742,'aff',3.333,5),(1059,36753,36742,'ff7',3.333,5),(1059,36754,36742,'f76',3.333,5),(1059,36755,36742,'765',3.333,5),(1059,36756,36742,'652',3.333,5),(1059,36757,36742,'52c',3.333,5),(1059,36758,36742,'2ca',3.333,5),(1059,36759,36742,'cab',3.333,5),(1059,36760,36742,'ab0',3.333,5),(1059,36761,36742,'b07',3.333,5),(1059,36762,36742,'079',3.333,5),(1059,36763,36742,'79c',3.333,5),(1059,36764,36742,'9cb',3.333,5),(1059,36765,36742,'cb4',3.333,5),(1059,36766,36742,'b49',3.333,5),(1059,36767,36742,'49b',3.333,5),(1059,36768,36742,'9b9',3.333,5),(1059,36769,36742,'b93',3.333,5),(1059,36770,36742,'930',3.333,5),(1059,36771,36742,'300',3.333,5),(1059,36772,36742,'001',3.333,5),(1060,36774,36773,'naa',100,5),(1060,36775,36774,'600',3.333,5),(1060,36776,36774,'000',3.333,5),(1060,36777,36774,'00c',3.333,5),(1060,36778,36774,'0c2',3.333,5),(1060,36779,36774,'c29',3.333,5),(1060,36780,36774,'29e',3.333,5),(1060,36781,36774,'9ed',3.333,5),(1060,36782,36774,'edc',3.333,5),(1060,36783,36774,'dcd',3.333,5),(1060,36784,36774,'cde',3.333,5),(1060,36785,36774,'def',3.333,5),(1060,36786,36774,'ef2',3.333,5),(1060,36787,36774,'f23',3.333,5),(1060,36788,36774,'23c',3.333,5),(1060,36789,36774,'3c8',3.333,5),(1060,36790,36774,'c8c',3.333,5),(1060,36791,36774,'8ce',3.333,5),(1060,36792,36774,'ceb',3.333,5),(1060,36793,36774,'eb1',3.333,5),(1060,36794,36774,'b1d',3.333,5),(1060,36795,36774,'1d6',3.333,5),(1060,36796,36774,'d6f',3.333,5),(1060,36797,36774,'6f3',3.333,5),(1060,36798,36774,'f32',3.333,5),(1060,36799,36774,'322',3.333,5),(1060,36800,36774,'22f',3.333,5),(1060,36801,36774,'2fd',3.333,5),(1060,36802,36774,'fdb',3.333,5),(1060,36803,36774,'db5',3.333,5),(1060,36804,36774,'b50',3.333,5),(1061,36806,36805,'naa',100,5),(1061,36807,36806,'600',3.333,5),(1061,36808,36806,'000',3.333,5),(1061,36809,36806,'00c',3.333,5),(1061,36810,36806,'0c2',3.333,5),(1061,36811,36806,'c29',3.333,5),(1061,36812,36806,'29c',3.333,5),(1061,36813,36806,'9c3',3.333,5),(1061,36814,36806,'c3b',3.333,5),(1061,36815,36806,'3bc',3.333,5),(1061,36816,36806,'bcd',3.333,5),(1061,36817,36806,'cd7',3.333,5),(1061,36818,36806,'d72',3.333,5),(1061,36819,36806,'720',3.333,5),(1061,36820,36806,'209',3.333,5),(1061,36821,36806,'09b',3.333,5),(1061,36822,36806,'9b7',3.333,5),(1061,36823,36806,'b70',3.333,5),(1061,36824,36806,'708',3.333,5),(1061,36825,36806,'088',3.333,5),(1061,36826,36806,'887',3.333,5),(1061,36827,36806,'87a',3.333,5),(1061,36828,36806,'7a7',3.333,5),(1061,36829,36806,'a77',3.333,5),(1061,36830,36806,'77e',3.333,5),(1061,36831,36806,'7e2',3.333,5),(1061,36832,36806,'e27',3.333,5),(1061,36833,36806,'277',3.333,5),(1061,36834,36806,'775',3.333,5),(1061,36835,36806,'75d',3.333,5),(1061,36836,36806,'5da',3.333,5),(1062,36838,36837,'naa',100,5),(1062,36839,36838,'600',3.333,5),(1062,36840,36838,'000',3.333,5),(1062,36841,36838,'00c',3.333,5),(1062,36842,36838,'0c2',3.333,5),(1062,36843,36838,'c29',3.333,5),(1062,36844,36838,'29a',3.333,5),(1062,36845,36838,'9ad',3.333,5),(1062,36846,36838,'ad0',3.333,5),(1062,36847,36838,'d04',3.333,5),(1062,36848,36838,'047',3.333,5),(1062,36849,36838,'47c',3.333,5),(1062,36850,36838,'7cd',3.333,5),(1062,36851,36838,'cdc',3.333,5),(1062,36852,36838,'dc1',3.333,5),(1062,36853,36838,'c1a',3.333,5),(1062,36854,36838,'1a9',3.333,5),(1062,36855,36838,'a99',3.333,5),(1062,36856,36838,'996',3.333,5),(1062,36857,36838,'96b',3.333,5),(1062,36858,36838,'6bb',3.333,5),(1062,36859,36838,'bb7',3.333,5),(1062,36860,36838,'b74',3.333,5),(1062,36861,36838,'744',3.333,5),(1062,36862,36838,'44b',3.333,5),(1062,36863,36838,'4bb',3.333,5),(1062,36864,36838,'bb9',3.333,5),(1062,36865,36838,'b91',3.333,5),(1062,36866,36838,'911',3.333,5),(1062,36867,36838,'11e',3.333,5),(1062,36868,36838,'1ed',3.333,5),(1063,36870,36869,'hgw',8.333,5),(1063,36871,36869,'gw2',8.333,5),(1063,36872,36869,'w2k',8.333,5),(1063,36873,36869,'2k8',8.333,5),(1063,36874,36869,'k8r',8.333,5),(1063,36875,36869,'8r2',8.333,5),(1063,36876,36869,'r23',8.333,5),(1063,36877,36869,'232',8.333,5),(1063,36878,36869,'32v',8.333,5),(1063,36879,36869,'2vm',8.333,5),(1063,36880,36869,'vm1',8.333,5),(1063,36881,36869,'m15',8.333,5),(1064,36883,36882,'naa',100,5),(1064,36884,36883,'600',3.333,5),(1064,36885,36883,'000',3.333,5),(1064,36886,36883,'00c',3.333,5),(1064,36887,36883,'0c2',3.333,5),(1064,36888,36883,'c29',3.333,5),(1064,36889,36883,'29c',3.333,5),(1064,36890,36883,'9c8',3.333,5),(1064,36891,36883,'c80',3.333,5),(1064,36892,36883,'80e',3.333,5),(1064,36893,36883,'0ee',3.333,5),(1064,36894,36883,'ee2',3.333,5),(1064,36895,36883,'e21',3.333,5),(1064,36896,36883,'215',3.333,5),(1064,36897,36883,'152',3.333,5),(1064,36898,36883,'524',3.333,5),(1064,36899,36883,'240',3.333,5),(1064,36900,36883,'402',3.333,5),(1064,36901,36883,'020',3.333,5),(1064,36902,36883,'209',3.333,5),(1064,36903,36883,'095',3.333,5),(1064,36904,36883,'95a',3.333,5),(1064,36905,36883,'5ab',3.333,5),(1064,36906,36883,'ab6',3.333,5),(1064,36907,36883,'b67',3.333,5),(1064,36908,36883,'67c',3.333,5),(1064,36909,36883,'7cf',3.333,5),(1064,36910,36883,'cf5',3.333,5),(1064,36911,36883,'f5f',3.333,5),(1064,36912,36883,'5f2',3.333,5),(1064,36913,36883,'f2f',3.333,5),(1065,36915,36914,'naa',100,5),(1065,36916,36915,'600',3.333,5),(1065,36917,36915,'00a',3.333,5),(1065,36918,36915,'0a0',3.333,5),(1065,36919,36915,'a09',3.333,5),(1065,36920,36915,'098',3.333,5),(1065,36921,36915,'980',3.333,5),(1065,36922,36915,'804',3.333,5),(1065,36923,36915,'044',3.333,5),(1065,36924,36915,'443',3.333,5),(1065,36925,36915,'430',3.333,5),(1065,36926,36915,'307',3.333,5),(1065,36927,36915,'072',3.333,5),(1065,36928,36915,'725',3.333,5),(1065,36929,36915,'259',3.333,5),(1065,36930,36915,'593',3.333,5),(1065,36931,36915,'931',3.333,5),(1065,36932,36915,'313',3.333,5),(1065,36933,36915,'13f',3.333,5),(1065,36934,36915,'3f3',3.333,5),(1065,36935,36915,'f33',3.333,5),(1065,36936,36915,'334',3.333,5),(1065,36937,36915,'345',3.333,5),(1065,36938,36915,'455',3.333,5),(1065,36939,36915,'556',3.333,5),(1065,36940,36915,'563',3.333,5),(1065,36941,36915,'639',3.333,5),(1065,36942,36915,'393',3.333,5),(1065,36943,36915,'934',3.333,5),(1065,36944,36915,'345',3.333,5),(1065,36945,36915,'457',3.333,5),(1066,36947,36946,'naa',100,5),(1066,36948,36947,'600',3.333,5),(1066,36949,36947,'00a',3.333,5),(1066,36950,36947,'0a0',3.333,5),(1066,36951,36947,'a09',3.333,5),(1066,36952,36947,'098',3.333,5),(1066,36953,36947,'980',3.333,5),(1066,36954,36947,'804',3.333,5),(1066,36955,36947,'044',3.333,5),(1066,36956,36947,'443',3.333,5),(1066,36957,36947,'430',3.333,5),(1066,36958,36947,'307',3.333,5),(1066,36959,36947,'072',3.333,5),(1066,36960,36947,'725',3.333,5),(1066,36961,36947,'259',3.333,5),(1066,36962,36947,'593',3.333,5),(1066,36963,36947,'931',3.333,5),(1066,36964,36947,'313',3.333,5),(1066,36965,36947,'13f',3.333,5),(1066,36966,36947,'3f3',3.333,5),(1066,36967,36947,'f33',3.333,5),(1066,36968,36947,'334',3.333,5),(1066,36969,36947,'345',3.333,5),(1066,36970,36947,'455',3.333,5),(1066,36971,36947,'556',3.333,5),(1066,36972,36947,'563',3.333,5),(1066,36973,36947,'639',3.333,5),(1066,36974,36947,'393',3.333,5),(1066,36975,36947,'934',3.333,5),(1066,36976,36947,'345',3.333,5),(1066,36977,36947,'458',3.333,5),(1067,36979,36978,'naa',100,5),(1067,36980,36979,'600',3.333,5),(1067,36981,36979,'00a',3.333,5),(1067,36982,36979,'0a0',3.333,5),(1067,36983,36979,'a09',3.333,5),(1067,36984,36979,'098',3.333,5),(1067,36985,36979,'980',3.333,5),(1067,36986,36979,'804',3.333,5),(1067,36987,36979,'044',3.333,5),(1067,36988,36979,'443',3.333,5),(1067,36989,36979,'430',3.333,5),(1067,36990,36979,'307',3.333,5),(1067,36991,36979,'075',3.333,5),(1067,36992,36979,'753',3.333,5),(1067,36993,36979,'535',3.333,5),(1067,36994,36979,'357',3.333,5),(1067,36995,36979,'573',3.333,5),(1067,36996,36979,'732',3.333,5),(1067,36997,36979,'32b',3.333,5),(1067,36998,36979,'2b3',3.333,5),(1067,36999,36979,'b33',3.333,5),(1067,37000,36979,'334',3.333,5),(1067,37001,36979,'345',3.333,5),(1067,37002,36979,'457',3.333,5),(1067,37003,36979,'571',3.333,5),(1067,37004,36979,'715',3.333,5),(1067,37005,36979,'153',3.333,5),(1067,37006,36979,'533',3.333,5),(1067,37007,36979,'336',3.333,5),(1067,37008,36979,'364',3.333,5),(1067,37009,36979,'648',3.333,5),(1068,37011,37010,'naa',100,5),(1068,37012,37011,'600',3.333,5),(1068,37013,37011,'00a',3.333,5),(1068,37014,37011,'0a0',3.333,5),(1068,37015,37011,'a09',3.333,5),(1068,37016,37011,'098',3.333,5),(1068,37017,37011,'980',3.333,5),(1068,37018,37011,'804',3.333,5),(1068,37019,37011,'044',3.333,5),(1068,37020,37011,'443',3.333,5),(1068,37021,37011,'430',3.333,5),(1068,37022,37011,'307',3.333,5),(1068,37023,37011,'075',3.333,5),(1068,37024,37011,'753',3.333,5),(1068,37025,37011,'535',3.333,5),(1068,37026,37011,'357',3.333,5),(1068,37027,37011,'573',3.333,5),(1068,37028,37011,'732',3.333,5),(1068,37029,37011,'32b',3.333,5),(1068,37030,37011,'2b3',3.333,5),(1068,37031,37011,'b33',3.333,5),(1068,37032,37011,'334',3.333,5),(1068,37033,37011,'345',3.333,5),(1068,37034,37011,'457',3.333,5),(1068,37035,37011,'571',3.333,5),(1068,37036,37011,'715',3.333,5),(1068,37037,37011,'153',3.333,5),(1068,37038,37011,'533',3.333,5),(1068,37039,37011,'336',3.333,5),(1068,37040,37011,'364',3.333,5),(1068,37041,37011,'649',3.333,5),(1069,37043,37042,'naa',100,5),(1069,37044,37043,'600',3.333,5),(1069,37045,37043,'000',3.333,5),(1069,37046,37043,'00c',3.333,5),(1069,37047,37043,'0c2',3.333,5),(1069,37048,37043,'c29',3.333,5),(1069,37049,37043,'290',3.333,5),(1069,37050,37043,'908',3.333,5),(1069,37051,37043,'081',3.333,5),(1069,37052,37043,'81d',3.333,5),(1069,37053,37043,'1d3',3.333,5),(1069,37054,37043,'d3b',3.333,5),(1069,37055,37043,'3b1',3.333,5),(1069,37056,37043,'b17',3.333,5),(1069,37057,37043,'171',3.333,5),(1069,37058,37043,'71a',3.333,5),(1069,37059,37043,'1aa',3.333,5),(1069,37060,37043,'aa3',3.333,5),(1069,37061,37043,'a3e',3.333,5),(1069,37062,37043,'3e2',3.333,5),(1069,37063,37043,'e2a',3.333,5),(1069,37064,37043,'2a9',3.333,5),(1069,37065,37043,'a97',3.333,5),(1069,37066,37043,'97e',3.333,5),(1069,37067,37043,'7e4',3.333,5),(1069,37068,37043,'e42',3.333,5),(1069,37069,37043,'42d',3.333,5),(1069,37070,37043,'2df',3.333,5),(1069,37071,37043,'df8',3.333,5),(1069,37072,37043,'f80',3.333,5),(1069,37073,37043,'807',3.333,5),(1070,37075,37074,'naa',100,5),(1070,37076,37075,'600',3.333,5),(1070,37077,37075,'000',3.333,5),(1070,37078,37075,'00c',3.333,5),(1070,37079,37075,'0c2',3.333,5),(1070,37080,37075,'c29',3.333,5),(1070,37081,37075,'298',3.333,5),(1070,37082,37075,'981',3.333,5),(1070,37083,37075,'81b',3.333,5),(1070,37084,37075,'1b9',3.333,5),(1070,37085,37075,'b94',3.333,5),(1070,37086,37075,'94f',3.333,5),(1070,37087,37075,'4f1',3.333,5),(1070,37088,37075,'f1b',3.333,5),(1070,37089,37075,'1b3',3.333,5),(1070,37090,37075,'b3a',3.333,5),(1070,37091,37075,'3a3',3.333,5),(1070,37092,37075,'a39',3.333,5),(1070,37093,37075,'39d',3.333,5),(1070,37094,37075,'9de',3.333,5),(1070,37095,37075,'dec',3.333,5),(1070,37096,37075,'ec3',3.333,5),(1070,37097,37075,'c30',3.333,5),(1070,37098,37075,'306',3.333,5),(1070,37099,37075,'06a',3.333,5),(1070,37100,37075,'6ad',3.333,5),(1070,37101,37075,'adf',3.333,5),(1070,37102,37075,'dfa',3.333,5),(1070,37103,37075,'fab',3.333,5),(1070,37104,37075,'ab8',3.333,5),(1070,37105,37075,'b89',3.333,5),(1071,37107,37106,'naa',100,5),(1071,37108,37107,'600',3.333,5),(1071,37109,37107,'000',3.333,5),(1071,37110,37107,'00c',3.333,5),(1071,37111,37107,'0c2',3.333,5),(1071,37112,37107,'c29',3.333,5),(1071,37113,37107,'29e',3.333,5),(1071,37114,37107,'9e7',3.333,5),(1071,37115,37107,'e7c',3.333,5),(1071,37116,37107,'7c2',3.333,5),(1071,37117,37107,'c22',3.333,5),(1071,37118,37107,'22d',3.333,5),(1071,37119,37107,'2d9',3.333,5),(1071,37120,37107,'d9f',3.333,5),(1071,37121,37107,'9fa',3.333,5),(1071,37122,37107,'fa3',3.333,5),(1071,37123,37107,'a39',3.333,5),(1071,37124,37107,'39d',3.333,5),(1071,37125,37107,'9d7',3.333,5),(1071,37126,37107,'d7b',3.333,5),(1071,37127,37107,'7b8',3.333,5),(1071,37128,37107,'b87',3.333,5),(1071,37129,37107,'87e',3.333,5),(1071,37130,37107,'7ee',3.333,5),(1071,37131,37107,'ee2',3.333,5),(1071,37132,37107,'e22',3.333,5),(1071,37133,37107,'229',3.333,5),(1071,37134,37107,'29a',3.333,5),(1071,37135,37107,'9ad',3.333,5),(1071,37136,37107,'ad1',3.333,5),(1071,37137,37107,'d1e',3.333,5),(1072,37139,37138,'naa',100,5),(1072,37140,37139,'600',3.333,5),(1072,37141,37139,'000',3.333,5),(1072,37142,37139,'00c',3.333,5),(1072,37143,37139,'0c2',3.333,5),(1072,37144,37139,'c29',3.333,5),(1072,37145,37139,'29d',3.333,5),(1072,37146,37139,'9d1',3.333,5),(1072,37147,37139,'d15',3.333,5),(1072,37148,37139,'155',3.333,5),(1072,37149,37139,'551',3.333,5),(1072,37150,37139,'513',3.333,5),(1072,37151,37139,'137',3.333,5),(1072,37152,37139,'376',3.333,5),(1072,37153,37139,'769',3.333,5),(1072,37154,37139,'69e',3.333,5),(1072,37155,37139,'9e7',3.333,5),(1072,37156,37139,'e71',3.333,5),(1072,37157,37139,'71c',3.333,5),(1072,37158,37139,'1c3',3.333,5),(1072,37159,37139,'c39',3.333,5),(1072,37160,37139,'39b',3.333,5),(1072,37161,37139,'9b8',3.333,5),(1072,37162,37139,'b85',3.333,5),(1072,37163,37139,'852',3.333,5),(1072,37164,37139,'52f',3.333,5),(1072,37165,37139,'2f7',3.333,5),(1072,37166,37139,'f74',3.333,5),(1072,37167,37139,'743',3.333,5),(1072,37168,37139,'433',3.333,5),(1072,37169,37139,'337',3.333,5),(1073,37171,37170,'naa',100,5),(1073,37172,37171,'600',3.333,5),(1073,37173,37171,'000',3.333,5),(1073,37174,37171,'00c',3.333,5),(1073,37175,37171,'0c2',3.333,5),(1073,37176,37171,'c29',3.333,5),(1073,37177,37171,'298',3.333,5),(1073,37178,37171,'989',3.333,5),(1073,37179,37171,'89f',3.333,5),(1073,37180,37171,'9f3',3.333,5),(1073,37181,37171,'f39',3.333,5),(1073,37182,37171,'395',3.333,5),(1073,37183,37171,'950',3.333,5),(1073,37184,37171,'500',3.333,5),(1073,37185,37171,'004',3.333,5),(1073,37186,37171,'048',3.333,5),(1073,37187,37171,'487',3.333,5),(1073,37188,37171,'876',3.333,5),(1073,37189,37171,'76c',3.333,5),(1073,37190,37171,'6c9',3.333,5),(1073,37191,37171,'c95',3.333,5),(1073,37192,37171,'959',3.333,5),(1073,37193,37171,'590',3.333,5),(1073,37194,37171,'905',3.333,5),(1073,37195,37171,'054',3.333,5),(1073,37196,37171,'544',3.333,5),(1073,37197,37171,'44b',3.333,5),(1073,37198,37171,'4b8',3.333,5),(1073,37199,37171,'b83',3.333,5),(1073,37200,37171,'835',3.333,5),(1073,37201,37171,'357',3.333,5),(1074,37203,37202,'naa',100,5),(1074,37204,37203,'600',3.333,5),(1074,37205,37203,'000',3.333,5),(1074,37206,37203,'00c',3.333,5),(1074,37207,37203,'0c2',3.333,5),(1074,37208,37203,'c29',3.333,5),(1074,37209,37203,'299',3.333,5),(1074,37210,37203,'99f',3.333,5),(1074,37211,37203,'9f4',3.333,5),(1074,37212,37203,'f48',3.333,5),(1074,37213,37203,'483',3.333,5),(1074,37214,37203,'832',3.333,5),(1074,37215,37203,'328',3.333,5),(1074,37216,37203,'283',3.333,5),(1074,37217,37203,'83b',3.333,5),(1074,37218,37203,'3be',3.333,5),(1074,37219,37203,'be4',3.333,5),(1074,37220,37203,'e47',3.333,5),(1074,37221,37203,'479',3.333,5),(1074,37222,37203,'79d',3.333,5),(1074,37223,37203,'9d3',3.333,5),(1074,37224,37203,'d3d',3.333,5),(1074,37225,37203,'3d3',3.333,5),(1074,37226,37203,'d37',3.333,5),(1074,37227,37203,'37b',3.333,5),(1074,37228,37203,'7b5',3.333,5),(1074,37229,37203,'b56',3.333,5),(1074,37230,37203,'562',3.333,5),(1074,37231,37203,'62e',3.333,5),(1074,37232,37203,'2e8',3.333,5),(1074,37233,37203,'e86',3.333,5),(1075,37235,37234,'naa',100,5),(1075,37236,37235,'600',3.333,5),(1075,37237,37235,'000',3.333,5),(1075,37238,37235,'00c',3.333,5),(1075,37239,37235,'0c2',3.333,5),(1075,37240,37235,'c29',3.333,5),(1075,37241,37235,'292',3.333,5),(1075,37242,37235,'92f',3.333,5),(1075,37243,37235,'2f8',3.333,5),(1075,37244,37235,'f89',3.333,5),(1075,37245,37235,'890',3.333,5),(1075,37246,37235,'90c',3.333,5),(1075,37247,37235,'0ce',3.333,5),(1075,37248,37235,'ce9',3.333,5),(1075,37249,37235,'e99',3.333,5),(1075,37250,37235,'991',3.333,5),(1075,37251,37235,'91a',3.333,5),(1075,37252,37235,'1af',3.333,5),(1075,37253,37235,'af3',3.333,5),(1075,37254,37235,'f32',3.333,5),(1075,37255,37235,'322',3.333,5),(1075,37256,37235,'22a',3.333,5),(1075,37257,37235,'2af',3.333,5),(1075,37258,37235,'af9',3.333,5),(1075,37259,37235,'f9f',3.333,5),(1075,37260,37235,'9f2',3.333,5),(1075,37261,37235,'f27',3.333,5),(1075,37262,37235,'271',3.333,5),(1075,37263,37235,'71a',3.333,5),(1075,37264,37235,'1a0',3.333,5),(1075,37265,37235,'a0e',3.333,5),(1076,37267,37266,'naa',100,5),(1076,37268,37267,'600',3.333,5),(1076,37269,37267,'000',3.333,5),(1076,37270,37267,'00c',3.333,5),(1076,37271,37267,'0c2',3.333,5),(1076,37272,37267,'c29',3.333,5),(1076,37273,37267,'299',3.333,5),(1076,37274,37267,'994',3.333,5),(1076,37275,37267,'94d',3.333,5),(1076,37276,37267,'4d7',3.333,5),(1076,37277,37267,'d73',3.333,5),(1076,37278,37267,'730',3.333,5),(1076,37279,37267,'30e',3.333,5),(1076,37280,37267,'0e8',3.333,5),(1076,37281,37267,'e86',3.333,5),(1076,37282,37267,'860',3.333,5),(1076,37283,37267,'606',3.333,5),(1076,37284,37267,'068',3.333,5),(1076,37285,37267,'68f',3.333,5),(1076,37286,37267,'8fa',3.333,5),(1076,37287,37267,'faa',3.333,5),(1076,37288,37267,'aa3',3.333,5),(1076,37289,37267,'a39',3.333,5),(1076,37290,37267,'39c',3.333,5),(1076,37291,37267,'9c7',3.333,5),(1076,37292,37267,'c7f',3.333,5),(1076,37293,37267,'7fc',3.333,5),(1076,37294,37267,'fc1',3.333,5),(1076,37295,37267,'c1c',3.333,5),(1076,37296,37267,'1cf',3.333,5),(1076,37297,37267,'cfa',3.333,5),(1077,37299,37298,'naa',100,5),(1077,37300,37299,'600',3.333,5),(1077,37301,37299,'000',3.333,5),(1077,37302,37299,'00c',3.333,5),(1077,37303,37299,'0c2',3.333,5),(1077,37304,37299,'c29',3.333,5),(1077,37305,37299,'299',3.333,5),(1077,37306,37299,'99b',3.333,5),(1077,37307,37299,'9b9',3.333,5),(1077,37308,37299,'b93',3.333,5),(1077,37309,37299,'935',3.333,5),(1077,37310,37299,'350',3.333,5),(1077,37311,37299,'501',3.333,5),(1077,37312,37299,'01d',3.333,5),(1077,37313,37299,'1d1',3.333,5),(1077,37314,37299,'d1f',3.333,5),(1077,37315,37299,'1fd',3.333,5),(1077,37316,37299,'fd2',3.333,5),(1077,37317,37299,'d28',3.333,5),(1077,37318,37299,'281',3.333,5),(1077,37319,37299,'813',3.333,5),(1077,37320,37299,'130',3.333,5),(1077,37321,37299,'30f',3.333,5),(1077,37322,37299,'0fe',3.333,5),(1077,37323,37299,'fe3',3.333,5),(1077,37324,37299,'e3a',3.333,5),(1077,37325,37299,'3a1',3.333,5),(1077,37326,37299,'a12',3.333,5),(1077,37327,37299,'12c',3.333,5),(1077,37328,37299,'2c7',3.333,5),(1077,37329,37299,'c7d',3.333,5),(1078,37331,37330,'naa',100,5),(1078,37332,37331,'600',3.333,5),(1078,37333,37331,'000',3.333,5),(1078,37334,37331,'00c',3.333,5),(1078,37335,37331,'0c2',3.333,5),(1078,37336,37331,'c29',3.333,5),(1078,37337,37331,'29e',3.333,5),(1078,37338,37331,'9ee',3.333,5),(1078,37339,37331,'eee',3.333,5),(1078,37340,37331,'ee0',3.333,5),(1078,37341,37331,'e0f',3.333,5),(1078,37342,37331,'0f3',3.333,5),(1078,37343,37331,'f3e',3.333,5),(1078,37344,37331,'3ef',3.333,5),(1078,37345,37331,'efd',3.333,5),(1078,37346,37331,'fd2',3.333,5),(1078,37347,37331,'d24',3.333,5),(1078,37348,37331,'24f',3.333,5),(1078,37349,37331,'4fd',3.333,5),(1078,37350,37331,'fde',3.333,5),(1078,37351,37331,'def',3.333,5),(1078,37352,37331,'efe',3.333,5),(1078,37353,37331,'fed',3.333,5),(1078,37354,37331,'ed6',3.333,5),(1078,37355,37331,'d6b',3.333,5),(1078,37356,37331,'6b5',3.333,5),(1078,37357,37331,'b51',3.333,5),(1078,37358,37331,'512',3.333,5),(1078,37359,37331,'12c',3.333,5),(1078,37360,37331,'2c7',3.333,5),(1078,37361,37331,'c7f',3.333,5),(1079,37363,37362,'naa',100,5),(1079,37364,37363,'600',3.333,5),(1079,37365,37363,'000',3.333,5),(1079,37366,37363,'00c',3.333,5),(1079,37367,37363,'0c2',3.333,5),(1079,37368,37363,'c29',3.333,5),(1079,37369,37363,'299',3.333,5),(1079,37370,37363,'99f',3.333,5),(1079,37371,37363,'9f5',3.333,5),(1079,37372,37363,'f52',3.333,5),(1079,37373,37363,'528',3.333,5),(1079,37374,37363,'283',3.333,5),(1079,37375,37363,'838',3.333,5),(1079,37376,37363,'388',3.333,5),(1079,37377,37363,'885',3.333,5),(1079,37378,37363,'856',3.333,5),(1079,37379,37363,'566',3.333,5),(1079,37380,37363,'66e',3.333,5),(1079,37381,37363,'6ee',3.333,5),(1079,37382,37363,'ee8',3.333,5),(1079,37383,37363,'e86',3.333,5),(1079,37384,37363,'868',3.333,5),(1079,37385,37363,'686',3.333,5),(1079,37386,37363,'868',3.333,5),(1079,37387,37363,'68e',3.333,5),(1079,37388,37363,'8ed',3.333,5),(1079,37389,37363,'ed0',3.333,5),(1079,37390,37363,'d0e',3.333,5),(1079,37391,37363,'0e4',3.333,5),(1079,37392,37363,'e48',3.333,5),(1079,37393,37363,'488',3.333,5),(1080,37395,37394,'naa',100,5),(1080,37396,37395,'600',3.333,5),(1080,37397,37395,'000',3.333,5),(1080,37398,37395,'00c',3.333,5),(1080,37399,37395,'0c2',3.333,5),(1080,37400,37395,'c29',3.333,5),(1080,37401,37395,'292',3.333,5),(1080,37402,37395,'926',3.333,5),(1080,37403,37395,'26e',3.333,5),(1080,37404,37395,'6e5',3.333,5),(1080,37405,37395,'e5b',3.333,5),(1080,37406,37395,'5b1',3.333,5),(1080,37407,37395,'b17',3.333,5),(1080,37408,37395,'176',3.333,5),(1080,37409,37395,'768',3.333,5),(1080,37410,37395,'68c',3.333,5),(1080,37411,37395,'8ce',3.333,5),(1080,37412,37395,'ce4',3.333,5),(1080,37413,37395,'e41',3.333,5),(1080,37414,37395,'410',3.333,5),(1080,37415,37395,'106',3.333,5),(1080,37416,37395,'06b',3.333,5),(1080,37417,37395,'6b6',3.333,5),(1080,37418,37395,'b68',3.333,5),(1080,37419,37395,'68f',3.333,5),(1080,37420,37395,'8fa',3.333,5),(1080,37421,37395,'fa7',3.333,5),(1080,37422,37395,'a70',3.333,5),(1080,37423,37395,'703',3.333,5),(1080,37424,37395,'030',3.333,5),(1080,37425,37395,'300',3.333,5),(1081,37427,37426,'naa',100,5),(1081,37428,37427,'600',3.333,5),(1081,37429,37427,'000',3.333,5),(1081,37430,37427,'00c',3.333,5),(1081,37431,37427,'0c2',3.333,5),(1081,37432,37427,'c29',3.333,5),(1081,37433,37427,'293',3.333,5),(1081,37434,37427,'93d',3.333,5),(1081,37435,37427,'3d1',3.333,5),(1081,37436,37427,'d14',3.333,5),(1081,37437,37427,'148',3.333,5),(1081,37438,37427,'488',3.333,5),(1081,37439,37427,'88e',3.333,5),(1081,37440,37427,'8eb',3.333,5),(1081,37441,37427,'ebc',3.333,5),(1081,37442,37427,'bc4',3.333,5),(1081,37443,37427,'c48',3.333,5),(1081,37444,37427,'484',3.333,5),(1081,37445,37427,'845',3.333,5),(1081,37446,37427,'453',3.333,5),(1081,37447,37427,'538',3.333,5),(1081,37448,37427,'386',3.333,5),(1081,37449,37427,'860',3.333,5),(1081,37450,37427,'603',3.333,5),(1081,37451,37427,'031',3.333,5),(1081,37452,37427,'311',3.333,5),(1081,37453,37427,'11c',3.333,5),(1081,37454,37427,'1c1',3.333,5),(1081,37455,37427,'c18',3.333,5),(1081,37456,37427,'18f',3.333,5),(1081,37457,37427,'8f9',3.333,5),(1082,37459,37458,'naa',100,5),(1082,37460,37459,'600',3.333,5),(1082,37461,37459,'000',3.333,5),(1082,37462,37459,'00c',3.333,5),(1082,37463,37459,'0c2',3.333,5),(1082,37464,37459,'c29',3.333,5),(1082,37465,37459,'29f',3.333,5),(1082,37466,37459,'9fb',3.333,5),(1082,37467,37459,'fb4',3.333,5),(1082,37468,37459,'b41',3.333,5),(1082,37469,37459,'413',3.333,5),(1082,37470,37459,'13b',3.333,5),(1082,37471,37459,'3b1',3.333,5),(1082,37472,37459,'b1a',3.333,5),(1082,37473,37459,'1ab',3.333,5),(1082,37474,37459,'ab0',3.333,5),(1082,37475,37459,'b0b',3.333,5),(1082,37476,37459,'0b4',3.333,5),(1082,37477,37459,'b45',3.333,5),(1082,37478,37459,'453',3.333,5),(1082,37479,37459,'532',3.333,5),(1082,37480,37459,'32e',3.333,5),(1082,37481,37459,'2eb',3.333,5),(1082,37482,37459,'ebc',3.333,5),(1082,37483,37459,'bca',3.333,5),(1082,37484,37459,'cae',3.333,5),(1082,37485,37459,'ae8',3.333,5),(1082,37486,37459,'e82',3.333,5),(1082,37487,37459,'829',3.333,5),(1082,37488,37459,'295',3.333,5),(1082,37489,37459,'95c',3.333,5),(1083,37491,37490,'naa',100,5),(1083,37492,37491,'600',3.333,5),(1083,37493,37491,'000',3.333,5),(1083,37494,37491,'00c',3.333,5),(1083,37495,37491,'0c2',3.333,5),(1083,37496,37491,'c29',3.333,5),(1083,37497,37491,'294',3.333,5),(1083,37498,37491,'94d',3.333,5),(1083,37499,37491,'4d6',3.333,5),(1083,37500,37491,'d69',3.333,5),(1083,37501,37491,'69d',3.333,5),(1083,37502,37491,'9d7',3.333,5),(1083,37503,37491,'d72',3.333,5),(1083,37504,37491,'72b',3.333,5),(1083,37505,37491,'2bd',3.333,5),(1083,37506,37491,'bd7',3.333,5),(1083,37507,37491,'d76',3.333,5),(1083,37508,37491,'76d',3.333,5),(1083,37509,37491,'6d5',3.333,5),(1083,37510,37491,'d5e',3.333,5),(1083,37511,37491,'5e7',3.333,5),(1083,37512,37491,'e7a',3.333,5),(1083,37513,37491,'7a9',3.333,5),(1083,37514,37491,'a9f',3.333,5),(1083,37515,37491,'9f2',3.333,5),(1083,37516,37491,'f2a',3.333,5),(1083,37517,37491,'2a3',3.333,5),(1083,37518,37491,'a3f',3.333,5),(1083,37519,37491,'3f8',3.333,5),(1083,37520,37491,'f84',3.333,5),(1083,37521,37491,'843',3.333,5),(1084,37523,37522,'naa',100,5),(1084,37524,37523,'600',3.333,5),(1084,37525,37523,'000',3.333,5),(1084,37526,37523,'00c',3.333,5),(1084,37527,37523,'0c2',3.333,5),(1084,37528,37523,'c29',3.333,5),(1084,37529,37523,'29c',3.333,5),(1084,37530,37523,'9cd',3.333,5),(1084,37531,37523,'cd2',3.333,5),(1084,37532,37523,'d23',3.333,5),(1084,37533,37523,'23d',3.333,5),(1084,37534,37523,'3d4',3.333,5),(1084,37535,37523,'d4c',3.333,5),(1084,37536,37523,'4c7',3.333,5),(1084,37537,37523,'c7b',3.333,5),(1084,37538,37523,'7bb',3.333,5),(1084,37539,37523,'bb4',3.333,5),(1084,37540,37523,'b47',3.333,5),(1084,37541,37523,'47d',3.333,5),(1084,37542,37523,'7d9',3.333,5),(1084,37543,37523,'d93',3.333,5),(1084,37544,37523,'93e',3.333,5),(1084,37545,37523,'3e3',3.333,5),(1084,37546,37523,'e37',3.333,5),(1084,37547,37523,'379',3.333,5),(1084,37548,37523,'790',3.333,5),(1084,37549,37523,'905',3.333,5),(1084,37550,37523,'050',3.333,5),(1084,37551,37523,'50b',3.333,5),(1084,37552,37523,'0bd',3.333,5),(1084,37553,37523,'bd8',3.333,5),(1085,37555,37554,'naa',100,5),(1085,37556,37555,'600',3.333,5),(1085,37557,37555,'000',3.333,5),(1085,37558,37555,'00c',3.333,5),(1085,37559,37555,'0c2',3.333,5),(1085,37560,37555,'c29',3.333,5),(1085,37561,37555,'298',3.333,5),(1085,37562,37555,'98c',3.333,5),(1085,37563,37555,'8c5',3.333,5),(1085,37564,37555,'c5e',3.333,5),(1085,37565,37555,'5ee',3.333,5),(1085,37566,37555,'ee9',3.333,5),(1085,37567,37555,'e9e',3.333,5),(1085,37568,37555,'9e9',3.333,5),(1085,37569,37555,'e97',3.333,5),(1085,37570,37555,'974',3.333,5),(1085,37571,37555,'74a',3.333,5),(1085,37572,37555,'4a1',3.333,5),(1085,37573,37555,'a12',3.333,5),(1085,37574,37555,'12e',3.333,5),(1085,37575,37555,'2e5',3.333,5),(1085,37576,37555,'e50',3.333,5),(1085,37577,37555,'50a',3.333,5),(1085,37578,37555,'0a0',3.333,5),(1085,37579,37555,'a09',3.333,5),(1085,37580,37555,'09b',3.333,5),(1085,37581,37555,'9b3',3.333,5),(1085,37582,37555,'b38',3.333,5),(1085,37583,37555,'388',3.333,5),(1085,37584,37555,'882',3.333,5),(1085,37585,37555,'823',3.333,5),(1086,37587,37586,'naa',100,5),(1086,37588,37587,'600',3.333,5),(1086,37589,37587,'000',3.333,5),(1086,37590,37587,'00c',3.333,5),(1086,37591,37587,'0c2',3.333,5),(1086,37592,37587,'c29',3.333,5),(1086,37593,37587,'29d',3.333,5),(1086,37594,37587,'9d7',3.333,5),(1086,37595,37587,'d72',3.333,5),(1086,37596,37587,'728',3.333,5),(1086,37597,37587,'28c',3.333,5),(1086,37598,37587,'8c9',3.333,5),(1086,37599,37587,'c9b',3.333,5),(1086,37600,37587,'9b5',3.333,5),(1086,37601,37587,'b5d',3.333,5),(1086,37602,37587,'5d4',3.333,5),(1086,37603,37587,'d4d',3.333,5),(1086,37604,37587,'4d4',3.333,5),(1086,37605,37587,'d41',3.333,5),(1086,37606,37587,'414',3.333,5),(1086,37607,37587,'147',3.333,5),(1086,37608,37587,'470',3.333,5),(1086,37609,37587,'705',3.333,5),(1086,37610,37587,'05b',3.333,5),(1086,37611,37587,'5b2',3.333,5),(1086,37612,37587,'b28',3.333,5),(1086,37613,37587,'28d',3.333,5),(1086,37614,37587,'8d2',3.333,5),(1086,37615,37587,'d2a',3.333,5),(1086,37616,37587,'2a7',3.333,5),(1086,37617,37587,'a78',3.333,5),(1087,37619,37618,'naa',100,5),(1087,37620,37619,'600',3.333,5),(1087,37621,37619,'000',3.333,5),(1087,37622,37619,'00c',3.333,5),(1087,37623,37619,'0c2',3.333,5),(1087,37624,37619,'c29',3.333,5),(1087,37625,37619,'29e',3.333,5),(1087,37626,37619,'9e1',3.333,5),(1087,37627,37619,'e12',3.333,5),(1087,37628,37619,'124',3.333,5),(1087,37629,37619,'249',3.333,5),(1087,37630,37619,'499',3.333,5),(1087,37631,37619,'992',3.333,5),(1087,37632,37619,'92a',3.333,5),(1087,37633,37619,'2a1',3.333,5),(1087,37634,37619,'a11',3.333,5),(1087,37635,37619,'118',3.333,5),(1087,37636,37619,'181',3.333,5),(1087,37637,37619,'814',3.333,5),(1087,37638,37619,'14b',3.333,5),(1087,37639,37619,'4bf',3.333,5),(1087,37640,37619,'bfc',3.333,5),(1087,37641,37619,'fcc',3.333,5),(1087,37642,37619,'cc0',3.333,5),(1087,37643,37619,'c0a',3.333,5),(1087,37644,37619,'0aa',3.333,5),(1087,37645,37619,'aae',3.333,5),(1087,37646,37619,'aee',3.333,5),(1087,37647,37619,'eed',3.333,5),(1087,37648,37619,'ed3',3.333,5),(1087,37649,37619,'d32',3.333,5),(1088,37651,37650,'naa',100,5),(1088,37652,37651,'600',3.333,5),(1088,37653,37651,'000',3.333,5),(1088,37654,37651,'00c',3.333,5),(1088,37655,37651,'0c2',3.333,5),(1088,37656,37651,'c29',3.333,5),(1088,37657,37651,'29a',3.333,5),(1088,37658,37651,'9a9',3.333,5),(1088,37659,37651,'a90',3.333,5),(1088,37660,37651,'900',3.333,5),(1088,37661,37651,'000',3.333,5),(1088,37662,37651,'006',3.333,5),(1088,37663,37651,'06a',3.333,5),(1088,37664,37651,'6a8',3.333,5),(1088,37665,37651,'a8a',3.333,5),(1088,37666,37651,'8a4',3.333,5),(1088,37667,37651,'a40',3.333,5),(1088,37668,37651,'40f',3.333,5),(1088,37669,37651,'0f9',3.333,5),(1088,37670,37651,'f93',3.333,5),(1088,37671,37651,'939',3.333,5),(1088,37672,37651,'391',3.333,5),(1088,37673,37651,'919',3.333,5),(1088,37674,37651,'19f',3.333,5),(1088,37675,37651,'9f4',3.333,5),(1088,37676,37651,'f46',3.333,5),(1088,37677,37651,'46c',3.333,5),(1088,37678,37651,'6cb',3.333,5),(1088,37679,37651,'cbb',3.333,5),(1088,37680,37651,'bb9',3.333,5),(1088,37681,37651,'b9c',3.333,5),(1089,37683,37682,'naa',100,5),(1089,37684,37683,'600',3.333,5),(1089,37685,37683,'000',3.333,5),(1089,37686,37683,'00c',3.333,5),(1089,37687,37683,'0c2',3.333,5),(1089,37688,37683,'c29',3.333,5),(1089,37689,37683,'298',3.333,5),(1089,37690,37683,'98f',3.333,5),(1089,37691,37683,'8f3',3.333,5),(1089,37692,37683,'f36',3.333,5),(1089,37693,37683,'367',3.333,5),(1089,37694,37683,'677',3.333,5),(1089,37695,37683,'775',3.333,5),(1089,37696,37683,'754',3.333,5),(1089,37697,37683,'54e',3.333,5),(1089,37698,37683,'4e6',3.333,5),(1089,37699,37683,'e66',3.333,5),(1089,37700,37683,'66b',3.333,5),(1089,37701,37683,'6b3',3.333,5),(1089,37702,37683,'b3f',3.333,5),(1089,37703,37683,'3fd',3.333,5),(1089,37704,37683,'fd6',3.333,5),(1089,37705,37683,'d6f',3.333,5),(1089,37706,37683,'6f5',3.333,5),(1089,37707,37683,'f5a',3.333,5),(1089,37708,37683,'5a0',3.333,5),(1089,37709,37683,'a08',3.333,5),(1089,37710,37683,'08f',3.333,5),(1089,37711,37683,'8f0',3.333,5),(1089,37712,37683,'f06',3.333,5),(1089,37713,37683,'06c',3.333,5),(1090,37715,37714,'naa',100,5),(1090,37716,37715,'600',3.333,5),(1090,37717,37715,'000',3.333,5),(1090,37718,37715,'00c',3.333,5),(1090,37719,37715,'0c2',3.333,5),(1090,37720,37715,'c29',3.333,5),(1090,37721,37715,'299',3.333,5),(1090,37722,37715,'999',3.333,5),(1090,37723,37715,'992',3.333,5),(1090,37724,37715,'92e',3.333,5),(1090,37725,37715,'2ec',3.333,5),(1090,37726,37715,'ecc',3.333,5),(1090,37727,37715,'cce',3.333,5),(1090,37728,37715,'cec',3.333,5),(1090,37729,37715,'ecd',3.333,5),(1090,37730,37715,'cdc',3.333,5),(1090,37731,37715,'dc5',3.333,5),(1090,37732,37715,'c54',3.333,5),(1090,37733,37715,'54a',3.333,5),(1090,37734,37715,'4ad',3.333,5),(1090,37735,37715,'ad8',3.333,5),(1090,37736,37715,'d8a',3.333,5),(1090,37737,37715,'8a4',3.333,5),(1090,37738,37715,'a48',3.333,5),(1090,37739,37715,'48e',3.333,5),(1090,37740,37715,'8e1',3.333,5),(1090,37741,37715,'e11',3.333,5),(1090,37742,37715,'111',3.333,5),(1090,37743,37715,'11d',3.333,5),(1090,37744,37715,'1d0',3.333,5),(1090,37745,37715,'d0b',3.333,5),(1091,37747,37746,'naa',100,5),(1091,37748,37747,'600',3.333,5),(1091,37749,37747,'000',3.333,5),(1091,37750,37747,'00c',3.333,5),(1091,37751,37747,'0c2',3.333,5),(1091,37752,37747,'c29',3.333,5),(1091,37753,37747,'29c',3.333,5),(1091,37754,37747,'9ce',3.333,5),(1091,37755,37747,'ce4',3.333,5),(1091,37756,37747,'e4b',3.333,5),(1091,37757,37747,'4b7',3.333,5),(1091,37758,37747,'b79',3.333,5),(1091,37759,37747,'793',3.333,5),(1091,37760,37747,'931',3.333,5),(1091,37761,37747,'31e',3.333,5),(1091,37762,37747,'1ea',3.333,5),(1091,37763,37747,'ead',3.333,5),(1091,37764,37747,'adc',3.333,5),(1091,37765,37747,'dcd',3.333,5),(1091,37766,37747,'cdf',3.333,5),(1091,37767,37747,'dfb',3.333,5),(1091,37768,37747,'fb3',3.333,5),(1091,37769,37747,'b3e',3.333,5),(1091,37770,37747,'3ef',3.333,5),(1091,37771,37747,'ef3',3.333,5),(1091,37772,37747,'f30',3.333,5),(1091,37773,37747,'301',3.333,5),(1091,37774,37747,'01b',3.333,5),(1091,37775,37747,'1be',3.333,5),(1091,37776,37747,'be7',3.333,5),(1091,37777,37747,'e70',3.333,5),(1092,37779,37778,'naa',100,5),(1092,37780,37779,'600',3.333,5),(1092,37781,37779,'000',3.333,5),(1092,37782,37779,'00c',3.333,5),(1092,37783,37779,'0c2',3.333,5),(1092,37784,37779,'c29',3.333,5),(1092,37785,37779,'298',3.333,5),(1092,37786,37779,'989',3.333,5),(1092,37787,37779,'898',3.333,5),(1092,37788,37779,'98d',3.333,5),(1092,37789,37779,'8d9',3.333,5),(1092,37790,37779,'d95',3.333,5),(1092,37791,37779,'953',3.333,5),(1092,37792,37779,'53a',3.333,5),(1092,37793,37779,'3aa',3.333,5),(1092,37794,37779,'aab',3.333,5),(1092,37795,37779,'abd',3.333,5),(1092,37796,37779,'bd7',3.333,5),(1092,37797,37779,'d7f',3.333,5),(1092,37798,37779,'7fa',3.333,5),(1092,37799,37779,'fa7',3.333,5),(1092,37800,37779,'a78',3.333,5),(1092,37801,37779,'78e',3.333,5),(1092,37802,37779,'8e0',3.333,5),(1092,37803,37779,'e08',3.333,5),(1092,37804,37779,'08a',3.333,5),(1092,37805,37779,'8a8',3.333,5),(1092,37806,37779,'a87',3.333,5),(1092,37807,37779,'871',3.333,5),(1092,37808,37779,'71d',3.333,5),(1092,37809,37779,'1d2',3.333,5),(1093,37811,37810,'naa',100,5),(1093,37812,37811,'600',3.333,5),(1093,37813,37811,'000',3.333,5),(1093,37814,37811,'00c',3.333,5),(1093,37815,37811,'0c2',3.333,5),(1093,37816,37811,'c29',3.333,5),(1093,37817,37811,'298',3.333,5),(1093,37818,37811,'984',3.333,5),(1093,37819,37811,'848',3.333,5),(1093,37820,37811,'484',3.333,5),(1093,37821,37811,'84c',3.333,5),(1093,37822,37811,'4c4',3.333,5),(1093,37823,37811,'c4a',3.333,5),(1093,37824,37811,'4a9',3.333,5),(1093,37825,37811,'a9c',3.333,5),(1093,37826,37811,'9c4',3.333,5),(1093,37827,37811,'c44',3.333,5),(1093,37828,37811,'44b',3.333,5),(1093,37829,37811,'4b5',3.333,5),(1093,37830,37811,'b5f',3.333,5),(1093,37831,37811,'5fc',3.333,5),(1093,37832,37811,'fc5',3.333,5),(1093,37833,37811,'c57',3.333,5),(1093,37834,37811,'573',3.333,5),(1093,37835,37811,'734',3.333,5),(1093,37836,37811,'345',3.333,5),(1093,37837,37811,'45b',3.333,5),(1093,37838,37811,'5b0',3.333,5),(1093,37839,37811,'b09',3.333,5),(1093,37840,37811,'09e',3.333,5),(1093,37841,37811,'9e8',3.333,5),(1094,37843,37842,'naa',100,5),(1094,37844,37843,'600',3.333,5),(1094,37845,37843,'000',3.333,5),(1094,37846,37843,'00c',3.333,5),(1094,37847,37843,'0c2',3.333,5),(1094,37848,37843,'c29',3.333,5),(1094,37849,37843,'297',3.333,5),(1094,37850,37843,'976',3.333,5),(1094,37851,37843,'763',3.333,5),(1094,37852,37843,'632',3.333,5),(1094,37853,37843,'32f',3.333,5),(1094,37854,37843,'2f5',3.333,5),(1094,37855,37843,'f52',3.333,5),(1094,37856,37843,'52a',3.333,5),(1094,37857,37843,'2a6',3.333,5),(1094,37858,37843,'a6d',3.333,5),(1094,37859,37843,'6d0',3.333,5),(1094,37860,37843,'d08',3.333,5),(1094,37861,37843,'087',3.333,5),(1094,37862,37843,'87e',3.333,5),(1094,37863,37843,'7e9',3.333,5),(1094,37864,37843,'e94',3.333,5),(1094,37865,37843,'94f',3.333,5),(1094,37866,37843,'4f5',3.333,5),(1094,37867,37843,'f5b',3.333,5),(1094,37868,37843,'5b6',3.333,5),(1094,37869,37843,'b63',3.333,5),(1094,37870,37843,'637',3.333,5),(1094,37871,37843,'376',3.333,5),(1094,37872,37843,'761',3.333,5),(1094,37873,37843,'615',3.333,5),(1095,37875,37874,'naa',100,5),(1095,37876,37875,'600',3.333,5),(1095,37877,37875,'000',3.333,5),(1095,37878,37875,'00c',3.333,5),(1095,37879,37875,'0c2',3.333,5),(1095,37880,37875,'c29',3.333,5),(1095,37881,37875,'299',3.333,5),(1095,37882,37875,'99f',3.333,5),(1095,37883,37875,'9f6',3.333,5),(1095,37884,37875,'f63',3.333,5),(1095,37885,37875,'630',3.333,5),(1095,37886,37875,'30f',3.333,5),(1095,37887,37875,'0f7',3.333,5),(1095,37888,37875,'f74',3.333,5),(1095,37889,37875,'74b',3.333,5),(1095,37890,37875,'4b6',3.333,5),(1095,37891,37875,'b61',3.333,5),(1095,37892,37875,'610',3.333,5),(1095,37893,37875,'105',3.333,5),(1095,37894,37875,'059',3.333,5),(1095,37895,37875,'59e',3.333,5),(1095,37896,37875,'9ee',3.333,5),(1095,37897,37875,'ee7',3.333,5),(1095,37898,37875,'e71',3.333,5),(1095,37899,37875,'716',3.333,5),(1095,37900,37875,'165',3.333,5),(1095,37901,37875,'65d',3.333,5),(1095,37902,37875,'5da',3.333,5),(1095,37903,37875,'da7',3.333,5),(1095,37904,37875,'a78',3.333,5),(1095,37905,37875,'78c',3.333,5),(1096,37907,37906,'naa',100,5),(1096,37908,37907,'600',3.333,5),(1096,37909,37907,'000',3.333,5),(1096,37910,37907,'00c',3.333,5),(1096,37911,37907,'0c2',3.333,5),(1096,37912,37907,'c29',3.333,5),(1096,37913,37907,'293',3.333,5),(1096,37914,37907,'93a',3.333,5),(1096,37915,37907,'3a8',3.333,5),(1096,37916,37907,'a81',3.333,5),(1096,37917,37907,'810',3.333,5),(1096,37918,37907,'10d',3.333,5),(1096,37919,37907,'0dc',3.333,5),(1096,37920,37907,'dc0',3.333,5),(1096,37921,37907,'c00',3.333,5),(1096,37922,37907,'007',3.333,5),(1096,37923,37907,'075',3.333,5),(1096,37924,37907,'750',3.333,5),(1096,37925,37907,'509',3.333,5),(1096,37926,37907,'096',3.333,5),(1096,37927,37907,'960',3.333,5),(1096,37928,37907,'60a',3.333,5),(1096,37929,37907,'0a0',3.333,5),(1096,37930,37907,'a09',3.333,5),(1096,37931,37907,'09c',3.333,5),(1096,37932,37907,'9c2',3.333,5),(1096,37933,37907,'c21',3.333,5),(1096,37934,37907,'218',3.333,5),(1096,37935,37907,'18d',3.333,5),(1096,37936,37907,'8d2',3.333,5),(1096,37937,37907,'d28',3.333,5),(1097,37939,37938,'naa',100,5),(1097,37940,37939,'600',3.333,5),(1097,37941,37939,'000',3.333,5),(1097,37942,37939,'00c',3.333,5),(1097,37943,37939,'0c2',3.333,5),(1097,37944,37939,'c29',3.333,5),(1097,37945,37939,'293',3.333,5),(1097,37946,37939,'936',3.333,5),(1097,37947,37939,'36b',3.333,5),(1097,37948,37939,'6b4',3.333,5),(1097,37949,37939,'b41',3.333,5),(1097,37950,37939,'41b',3.333,5),(1097,37951,37939,'1b0',3.333,5),(1097,37952,37939,'b02',3.333,5),(1097,37953,37939,'02e',3.333,5),(1097,37954,37939,'2e5',3.333,5),(1097,37955,37939,'e50',3.333,5),(1097,37956,37939,'50b',3.333,5),(1097,37957,37939,'0bd',3.333,5),(1097,37958,37939,'bdc',3.333,5),(1097,37959,37939,'dc5',3.333,5),(1097,37960,37939,'c53',3.333,5),(1097,37961,37939,'534',3.333,5),(1097,37962,37939,'344',3.333,5),(1097,37963,37939,'44d',3.333,5),(1097,37964,37939,'4d7',3.333,5),(1097,37965,37939,'d72',3.333,5),(1097,37966,37939,'724',3.333,5),(1097,37967,37939,'244',3.333,5),(1097,37968,37939,'443',3.333,5),(1097,37969,37939,'43b',3.333,5),(1098,37971,37970,'naa',100,5),(1098,37972,37971,'600',3.333,5),(1098,37973,37971,'000',3.333,5),(1098,37974,37971,'00c',3.333,5),(1098,37975,37971,'0c2',3.333,5),(1098,37976,37971,'c29',3.333,5),(1098,37977,37971,'294',3.333,5),(1098,37978,37971,'94f',3.333,5),(1098,37979,37971,'4fb',3.333,5),(1098,37980,37971,'fb3',3.333,5),(1098,37981,37971,'b39',3.333,5),(1098,37982,37971,'39a',3.333,5),(1098,37983,37971,'9aa',3.333,5),(1098,37984,37971,'aa2',3.333,5),(1098,37985,37971,'a21',3.333,5),(1098,37986,37971,'21b',3.333,5),(1098,37987,37971,'1bd',3.333,5),(1098,37988,37971,'bdd',3.333,5),(1098,37989,37971,'dd8',3.333,5),(1098,37990,37971,'d8b',3.333,5),(1098,37991,37971,'8ba',3.333,5),(1098,37992,37971,'ba1',3.333,5),(1098,37993,37971,'a12',3.333,5),(1098,37994,37971,'12b',3.333,5),(1098,37995,37971,'2b3',3.333,5),(1098,37996,37971,'b37',3.333,5),(1098,37997,37971,'377',3.333,5),(1098,37998,37971,'77b',3.333,5),(1098,37999,37971,'7bb',3.333,5),(1098,38000,37971,'bb5',3.333,5),(1098,38001,37971,'b58',3.333,5),(1099,38003,38002,'naa',100,5),(1099,38004,38003,'600',3.333,5),(1099,38005,38003,'000',3.333,5),(1099,38006,38003,'00c',3.333,5),(1099,38007,38003,'0c2',3.333,5),(1099,38008,38003,'c29',3.333,5),(1099,38009,38003,'297',3.333,5),(1099,38010,38003,'97c',3.333,5),(1099,38011,38003,'7c6',3.333,5),(1099,38012,38003,'c61',3.333,5),(1099,38013,38003,'61b',3.333,5),(1099,38014,38003,'1b3',3.333,5),(1099,38015,38003,'b34',3.333,5),(1099,38016,38003,'345',3.333,5),(1099,38017,38003,'456',3.333,5),(1099,38018,38003,'561',3.333,5),(1099,38019,38003,'61e',3.333,5),(1099,38020,38003,'1e9',3.333,5),(1099,38021,38003,'e95',3.333,5),(1099,38022,38003,'951',3.333,5),(1099,38023,38003,'511',3.333,5),(1099,38024,38003,'11f',3.333,5),(1099,38025,38003,'1f2',3.333,5),(1099,38026,38003,'f28',3.333,5),(1099,38027,38003,'288',3.333,5),(1099,38028,38003,'887',3.333,5),(1099,38029,38003,'87e',3.333,5),(1099,38030,38003,'7e2',3.333,5),(1099,38031,38003,'e27',3.333,5),(1099,38032,38003,'27c',3.333,5),(1099,38033,38003,'7c2',3.333,5),(1100,38035,38034,'naa',100,5),(1100,38036,38035,'600',3.333,5),(1100,38037,38035,'000',3.333,5),(1100,38038,38035,'00c',3.333,5),(1100,38039,38035,'0c2',3.333,5),(1100,38040,38035,'c29',3.333,5),(1100,38041,38035,'298',3.333,5),(1100,38042,38035,'980',3.333,5),(1100,38043,38035,'808',3.333,5),(1100,38044,38035,'081',3.333,5),(1100,38045,38035,'811',3.333,5),(1100,38046,38035,'114',3.333,5),(1100,38047,38035,'146',3.333,5),(1100,38048,38035,'46e',3.333,5),(1100,38049,38035,'6e1',3.333,5),(1100,38050,38035,'e19',3.333,5),(1100,38051,38035,'194',3.333,5),(1100,38052,38035,'94a',3.333,5),(1100,38053,38035,'4ad',3.333,5),(1100,38054,38035,'adb',3.333,5),(1100,38055,38035,'db6',3.333,5),(1100,38056,38035,'b6f',3.333,5),(1100,38057,38035,'6f3',3.333,5),(1100,38058,38035,'f39',3.333,5),(1100,38059,38035,'395',3.333,5),(1100,38060,38035,'95f',3.333,5),(1100,38061,38035,'5f7',3.333,5),(1100,38062,38035,'f7e',3.333,5),(1100,38063,38035,'7e2',3.333,5),(1100,38064,38035,'e2d',3.333,5),(1100,38065,38035,'2da',3.333,5),(1101,38067,38066,'naa',100,5),(1101,38068,38067,'600',3.333,5),(1101,38069,38067,'000',3.333,5),(1101,38070,38067,'00c',3.333,5),(1101,38071,38067,'0c2',3.333,5),(1101,38072,38067,'c29',3.333,5),(1101,38073,38067,'298',3.333,5),(1101,38074,38067,'98a',3.333,5),(1101,38075,38067,'8a7',3.333,5),(1101,38076,38067,'a7f',3.333,5),(1101,38077,38067,'7fb',3.333,5),(1101,38078,38067,'fb6',3.333,5),(1101,38079,38067,'b61',3.333,5),(1101,38080,38067,'617',3.333,5),(1101,38081,38067,'17e',3.333,5),(1101,38082,38067,'7e0',3.333,5),(1101,38083,38067,'e01',3.333,5),(1101,38084,38067,'01e',3.333,5),(1101,38085,38067,'1e5',3.333,5),(1101,38086,38067,'e5f',3.333,5),(1101,38087,38067,'5fa',3.333,5),(1101,38088,38067,'faf',3.333,5),(1101,38089,38067,'af1',3.333,5),(1101,38090,38067,'f1b',3.333,5),(1101,38091,38067,'1b5',3.333,5),(1101,38092,38067,'b50',3.333,5),(1101,38093,38067,'502',3.333,5),(1101,38094,38067,'02a',3.333,5),(1101,38095,38067,'2ab',3.333,5),(1101,38096,38067,'ab6',3.333,5),(1101,38097,38067,'b6d',3.333,5),(1102,38099,38098,'naa',100,5),(1102,38100,38099,'600',3.333,5),(1102,38101,38099,'000',3.333,5),(1102,38102,38099,'00c',3.333,5),(1102,38103,38099,'0c2',3.333,5),(1102,38104,38099,'c29',3.333,5),(1102,38105,38099,'296',3.333,5),(1102,38106,38099,'968',3.333,5),(1102,38107,38099,'682',3.333,5),(1102,38108,38099,'821',3.333,5),(1102,38109,38099,'21e',3.333,5),(1102,38110,38099,'1e5',3.333,5),(1102,38111,38099,'e5f',3.333,5),(1102,38112,38099,'5fb',3.333,5),(1102,38113,38099,'fb0',3.333,5),(1102,38114,38099,'b0a',3.333,5),(1102,38115,38099,'0a4',3.333,5),(1102,38116,38099,'a4f',3.333,5),(1102,38117,38099,'4f1',3.333,5),(1102,38118,38099,'f17',3.333,5),(1102,38119,38099,'17b',3.333,5),(1102,38120,38099,'7bb',3.333,5),(1102,38121,38099,'bb5',3.333,5),(1102,38122,38099,'b56',3.333,5),(1102,38123,38099,'560',3.333,5),(1102,38124,38099,'609',3.333,5),(1102,38125,38099,'090',3.333,5),(1102,38126,38099,'90b',3.333,5),(1102,38127,38099,'0b7',3.333,5),(1102,38128,38099,'b77',3.333,5),(1102,38129,38099,'773',3.333,5),(1103,38131,38130,'naa',100,5),(1103,38132,38131,'600',3.333,5),(1103,38133,38131,'000',3.333,5),(1103,38134,38131,'00c',3.333,5),(1103,38135,38131,'0c2',3.333,5),(1103,38136,38131,'c29',3.333,5),(1103,38137,38131,'290',3.333,5),(1103,38138,38131,'909',3.333,5),(1103,38139,38131,'098',3.333,5),(1103,38140,38131,'987',3.333,5),(1103,38141,38131,'879',3.333,5),(1103,38142,38131,'795',3.333,5),(1103,38143,38131,'95d',3.333,5),(1103,38144,38131,'5d4',3.333,5),(1103,38145,38131,'d4a',3.333,5),(1103,38146,38131,'4a5',3.333,5),(1103,38147,38131,'a5d',3.333,5),(1103,38148,38131,'5d4',3.333,5),(1103,38149,38131,'d4b',3.333,5),(1103,38150,38131,'4bc',3.333,5),(1103,38151,38131,'bc4',3.333,5),(1103,38152,38131,'c49',3.333,5),(1103,38153,38131,'495',3.333,5),(1103,38154,38131,'956',3.333,5),(1103,38155,38131,'561',3.333,5),(1103,38156,38131,'615',3.333,5),(1103,38157,38131,'157',3.333,5),(1103,38158,38131,'577',3.333,5),(1103,38159,38131,'77a',3.333,5),(1103,38160,38131,'7ab',3.333,5),(1103,38161,38131,'ab2',3.333,5),(1104,38163,38162,'naa',100,5),(1104,38164,38163,'600',3.333,5),(1104,38165,38163,'000',3.333,5),(1104,38166,38163,'00c',3.333,5),(1104,38167,38163,'0c2',3.333,5),(1104,38168,38163,'c29',3.333,5),(1104,38169,38163,'294',3.333,5),(1104,38170,38163,'945',3.333,5),(1104,38171,38163,'45c',3.333,5),(1104,38172,38163,'5c6',3.333,5),(1104,38173,38163,'c6d',3.333,5),(1104,38174,38163,'6dc',3.333,5),(1104,38175,38163,'dc3',3.333,5),(1104,38176,38163,'c32',3.333,5),(1104,38177,38163,'32f',3.333,5),(1104,38178,38163,'2f2',3.333,5),(1104,38179,38163,'f24',3.333,5),(1104,38180,38163,'24c',3.333,5),(1104,38181,38163,'4c3',3.333,5),(1104,38182,38163,'c36',3.333,5),(1104,38183,38163,'369',3.333,5),(1104,38184,38163,'690',3.333,5),(1104,38185,38163,'90d',3.333,5),(1104,38186,38163,'0d7',3.333,5),(1104,38187,38163,'d7a',3.333,5),(1104,38188,38163,'7aa',3.333,5),(1104,38189,38163,'aae',3.333,5),(1104,38190,38163,'ae5',3.333,5),(1104,38191,38163,'e55',3.333,5),(1104,38192,38163,'552',3.333,5),(1104,38193,38163,'52b',3.333,5),(1105,38195,38194,'naa',100,5),(1105,38196,38195,'600',3.333,5),(1105,38197,38195,'000',3.333,5),(1105,38198,38195,'00c',3.333,5),(1105,38199,38195,'0c2',3.333,5),(1105,38200,38195,'c29',3.333,5),(1105,38201,38195,'29c',3.333,5),(1105,38202,38195,'9c9',3.333,5),(1105,38203,38195,'c9b',3.333,5),(1105,38204,38195,'9b6',3.333,5),(1105,38205,38195,'b66',3.333,5),(1105,38206,38195,'665',3.333,5),(1105,38207,38195,'65f',3.333,5),(1105,38208,38195,'5f0',3.333,5),(1105,38209,38195,'f01',3.333,5),(1105,38210,38195,'014',3.333,5),(1105,38211,38195,'14e',3.333,5),(1105,38212,38195,'4e7',3.333,5),(1105,38213,38195,'e71',3.333,5),(1105,38214,38195,'71d',3.333,5),(1105,38215,38195,'1dd',3.333,5),(1105,38216,38195,'dda',3.333,5),(1105,38217,38195,'dab',3.333,5),(1105,38218,38195,'ab4',3.333,5),(1105,38219,38195,'b43',3.333,5),(1105,38220,38195,'43f',3.333,5),(1105,38221,38195,'3fc',3.333,5),(1105,38222,38195,'fcc',3.333,5),(1105,38223,38195,'ccb',3.333,5),(1105,38224,38195,'cbb',3.333,5),(1105,38225,38195,'bb5',3.333,5),(1106,38227,38226,'naa',100,5),(1106,38228,38227,'600',3.333,5),(1106,38229,38227,'000',3.333,5),(1106,38230,38227,'00c',3.333,5),(1106,38231,38227,'0c2',3.333,5),(1106,38232,38227,'c29',3.333,5),(1106,38233,38227,'294',3.333,5),(1106,38234,38227,'949',3.333,5),(1106,38235,38227,'497',3.333,5),(1106,38236,38227,'979',3.333,5),(1106,38237,38227,'791',3.333,5),(1106,38238,38227,'91c',3.333,5),(1106,38239,38227,'1c1',3.333,5),(1106,38240,38227,'c12',3.333,5),(1106,38241,38227,'12d',3.333,5),(1106,38242,38227,'2db',3.333,5),(1106,38243,38227,'db0',3.333,5),(1106,38244,38227,'b0e',3.333,5),(1106,38245,38227,'0ed',3.333,5),(1106,38246,38227,'ed4',3.333,5),(1106,38247,38227,'d4e',3.333,5),(1106,38248,38227,'4eb',3.333,5),(1106,38249,38227,'ebf',3.333,5),(1106,38250,38227,'bf4',3.333,5),(1106,38251,38227,'f4f',3.333,5),(1106,38252,38227,'4f0',3.333,5),(1106,38253,38227,'f09',3.333,5),(1106,38254,38227,'09e',3.333,5),(1106,38255,38227,'9e4',3.333,5),(1106,38256,38227,'e4e',3.333,5),(1106,38257,38227,'4e2',3.333,5),(1107,38259,38258,'naa',100,5),(1107,38260,38259,'600',3.333,5),(1107,38261,38259,'000',3.333,5),(1107,38262,38259,'00c',3.333,5),(1107,38263,38259,'0c2',3.333,5),(1107,38264,38259,'c29',3.333,5),(1107,38265,38259,'294',3.333,5),(1107,38266,38259,'94e',3.333,5),(1107,38267,38259,'4e8',3.333,5),(1107,38268,38259,'e87',3.333,5),(1107,38269,38259,'87b',3.333,5),(1107,38270,38259,'7b1',3.333,5),(1107,38271,38259,'b18',3.333,5),(1107,38272,38259,'184',3.333,5),(1107,38273,38259,'84d',3.333,5),(1107,38274,38259,'4d3',3.333,5),(1107,38275,38259,'d39',3.333,5),(1107,38276,38259,'39c',3.333,5),(1107,38277,38259,'9c6',3.333,5),(1107,38278,38259,'c68',3.333,5),(1107,38279,38259,'682',3.333,5),(1107,38280,38259,'82d',3.333,5),(1107,38281,38259,'2d1',3.333,5),(1107,38282,38259,'d18',3.333,5),(1107,38283,38259,'184',3.333,5),(1107,38284,38259,'84e',3.333,5),(1107,38285,38259,'4e8',3.333,5),(1107,38286,38259,'e89',3.333,5),(1107,38287,38259,'896',3.333,5),(1107,38288,38259,'96b',3.333,5),(1107,38289,38259,'6b0',3.333,5),(1108,38291,38290,'naa',100,5),(1108,38292,38291,'600',3.333,5),(1108,38293,38291,'000',3.333,5),(1108,38294,38291,'00c',3.333,5),(1108,38295,38291,'0c2',3.333,5),(1108,38296,38291,'c29',3.333,5),(1108,38297,38291,'290',3.333,5),(1108,38298,38291,'902',3.333,5),(1108,38299,38291,'02a',3.333,5),(1108,38300,38291,'2a2',3.333,5),(1108,38301,38291,'a2d',3.333,5),(1108,38302,38291,'2d7',3.333,5),(1108,38303,38291,'d72',3.333,5),(1108,38304,38291,'72e',3.333,5),(1108,38305,38291,'2ef',3.333,5),(1108,38306,38291,'efe',3.333,5),(1108,38307,38291,'fe7',3.333,5),(1108,38308,38291,'e74',3.333,5),(1108,38309,38291,'744',3.333,5),(1108,38310,38291,'44e',3.333,5),(1108,38311,38291,'4e3',3.333,5),(1108,38312,38291,'e32',3.333,5),(1108,38313,38291,'321',3.333,5),(1108,38314,38291,'213',3.333,5),(1108,38315,38291,'137',3.333,5),(1108,38316,38291,'374',3.333,5),(1108,38317,38291,'743',3.333,5),(1108,38318,38291,'43a',3.333,5),(1108,38319,38291,'3a5',3.333,5),(1108,38320,38291,'a5c',3.333,5),(1108,38321,38291,'5cf',3.333,5),(1109,38323,38322,'naa',100,5),(1109,38324,38323,'600',3.333,5),(1109,38325,38323,'000',3.333,5),(1109,38326,38323,'00c',3.333,5),(1109,38327,38323,'0c2',3.333,5),(1109,38328,38323,'c29',3.333,5),(1109,38329,38323,'29e',3.333,5),(1109,38330,38323,'9eb',3.333,5),(1109,38331,38323,'eba',3.333,5),(1109,38332,38323,'ba1',3.333,5),(1109,38333,38323,'a18',3.333,5),(1109,38334,38323,'18d',3.333,5),(1109,38335,38323,'8d7',3.333,5),(1109,38336,38323,'d72',3.333,5),(1109,38337,38323,'72a',3.333,5),(1109,38338,38323,'2af',3.333,5),(1109,38339,38323,'af5',3.333,5),(1109,38340,38323,'f5f',3.333,5),(1109,38341,38323,'5f0',3.333,5),(1109,38342,38323,'f05',3.333,5),(1109,38343,38323,'05b',3.333,5),(1109,38344,38323,'5be',3.333,5),(1109,38345,38323,'be4',3.333,5),(1109,38346,38323,'e4f',3.333,5),(1109,38347,38323,'4f0',3.333,5),(1109,38348,38323,'f01',3.333,5),(1109,38349,38323,'019',3.333,5),(1109,38350,38323,'194',3.333,5),(1109,38351,38323,'94b',3.333,5),(1109,38352,38323,'4b1',3.333,5),(1109,38353,38323,'b16',3.333,5),(1110,38355,38354,'naa',100,5),(1110,38356,38355,'600',3.333,5),(1110,38357,38355,'000',3.333,5),(1110,38358,38355,'00c',3.333,5),(1110,38359,38355,'0c2',3.333,5),(1110,38360,38355,'c29',3.333,5),(1110,38361,38355,'292',3.333,5),(1110,38362,38355,'92f',3.333,5),(1110,38363,38355,'2f4',3.333,5),(1110,38364,38355,'f43',3.333,5),(1110,38365,38355,'437',3.333,5),(1110,38366,38355,'370',3.333,5),(1110,38367,38355,'708',3.333,5),(1110,38368,38355,'087',3.333,5),(1110,38369,38355,'87f',3.333,5),(1110,38370,38355,'7f0',3.333,5),(1110,38371,38355,'f03',3.333,5),(1110,38372,38355,'03e',3.333,5),(1110,38373,38355,'3e0',3.333,5),(1110,38374,38355,'e0a',3.333,5),(1110,38375,38355,'0ac',3.333,5),(1110,38376,38355,'ace',3.333,5),(1110,38377,38355,'ce6',3.333,5),(1110,38378,38355,'e68',3.333,5),(1110,38379,38355,'680',3.333,5),(1110,38380,38355,'80e',3.333,5),(1110,38381,38355,'0e2',3.333,5),(1110,38382,38355,'e2d',3.333,5),(1110,38383,38355,'2dc',3.333,5),(1110,38384,38355,'dcd',3.333,5),(1110,38385,38355,'cd8',3.333,5),(1111,38387,38386,'naa',100,5),(1111,38388,38387,'600',3.333,5),(1111,38389,38387,'000',3.333,5),(1111,38390,38387,'00c',3.333,5),(1111,38391,38387,'0c2',3.333,5),(1111,38392,38387,'c29',3.333,5),(1111,38393,38387,'29d',3.333,5),(1111,38394,38387,'9de',3.333,5),(1111,38395,38387,'de6',3.333,5),(1111,38396,38387,'e60',3.333,5),(1111,38397,38387,'601',3.333,5),(1111,38398,38387,'013',3.333,5),(1111,38399,38387,'139',3.333,5),(1111,38400,38387,'396',3.333,5),(1111,38401,38387,'96b',3.333,5),(1111,38402,38387,'6b5',3.333,5),(1111,38403,38387,'b50',3.333,5),(1111,38404,38387,'50b',3.333,5),(1111,38405,38387,'0b8',3.333,5),(1111,38406,38387,'b8b',3.333,5),(1111,38407,38387,'8be',3.333,5),(1111,38408,38387,'be4',3.333,5),(1111,38409,38387,'e4d',3.333,5),(1111,38410,38387,'4d9',3.333,5),(1111,38411,38387,'d9a',3.333,5),(1111,38412,38387,'9ad',3.333,5),(1111,38413,38387,'ad0',3.333,5),(1111,38414,38387,'d0d',3.333,5),(1111,38415,38387,'0d3',3.333,5),(1111,38416,38387,'d34',3.333,5),(1111,38417,38387,'34e',3.333,5),(1112,38419,38418,'naa',100,5),(1112,38420,38419,'600',3.333,5),(1112,38421,38419,'000',3.333,5),(1112,38422,38419,'00c',3.333,5),(1112,38423,38419,'0c2',3.333,5),(1112,38424,38419,'c29',3.333,5),(1112,38425,38419,'291',3.333,5),(1112,38426,38419,'91e',3.333,5),(1112,38427,38419,'1ed',3.333,5),(1112,38428,38419,'ed1',3.333,5),(1112,38429,38419,'d18',3.333,5),(1112,38430,38419,'180',3.333,5),(1112,38431,38419,'806',3.333,5),(1112,38432,38419,'067',3.333,5),(1112,38433,38419,'674',3.333,5),(1112,38434,38419,'746',3.333,5),(1112,38435,38419,'466',3.333,5),(1112,38436,38419,'663',3.333,5),(1112,38437,38419,'635',3.333,5),(1112,38438,38419,'35f',3.333,5),(1112,38439,38419,'5f9',3.333,5),(1112,38440,38419,'f96',3.333,5),(1112,38441,38419,'964',3.333,5),(1112,38442,38419,'64d',3.333,5),(1112,38443,38419,'4d2',3.333,5),(1112,38444,38419,'d28',3.333,5),(1112,38445,38419,'28f',3.333,5),(1112,38446,38419,'8fd',3.333,5),(1112,38447,38419,'fd6',3.333,5),(1112,38448,38419,'d68',3.333,5),(1112,38449,38419,'68f',3.333,5),(1113,38451,38450,'naa',100,5),(1113,38452,38451,'600',3.333,5),(1113,38453,38451,'000',3.333,5),(1113,38454,38451,'00c',3.333,5),(1113,38455,38451,'0c2',3.333,5),(1113,38456,38451,'c29',3.333,5),(1113,38457,38451,'291',3.333,5),(1113,38458,38451,'91c',3.333,5),(1113,38459,38451,'1cb',3.333,5),(1113,38460,38451,'cbb',3.333,5),(1113,38461,38451,'bb2',3.333,5),(1113,38462,38451,'b23',3.333,5),(1113,38463,38451,'234',3.333,5),(1113,38464,38451,'34a',3.333,5),(1113,38465,38451,'4a6',3.333,5),(1113,38466,38451,'a6a',3.333,5),(1113,38467,38451,'6a8',3.333,5),(1113,38468,38451,'a8f',3.333,5),(1113,38469,38451,'8fb',3.333,5),(1113,38470,38451,'fbe',3.333,5),(1113,38471,38451,'beb',3.333,5),(1113,38472,38451,'eb3',3.333,5),(1113,38473,38451,'b3d',3.333,5),(1113,38474,38451,'3d4',3.333,5),(1113,38475,38451,'d4b',3.333,5),(1113,38476,38451,'4b3',3.333,5),(1113,38477,38451,'b34',3.333,5),(1113,38478,38451,'342',3.333,5),(1113,38479,38451,'420',3.333,5),(1113,38480,38451,'20b',3.333,5),(1113,38481,38451,'0b1',3.333,5),(1114,38483,38482,'naa',100,5),(1114,38484,38483,'600',3.333,5),(1114,38485,38483,'000',3.333,5),(1114,38486,38483,'00c',3.333,5),(1114,38487,38483,'0c2',3.333,5),(1114,38488,38483,'c29',3.333,5),(1114,38489,38483,'290',3.333,5),(1114,38490,38483,'908',3.333,5),(1114,38491,38483,'088',3.333,5),(1114,38492,38483,'880',3.333,5),(1114,38493,38483,'80f',3.333,5),(1114,38494,38483,'0f0',3.333,5),(1114,38495,38483,'f02',3.333,5),(1114,38496,38483,'029',3.333,5),(1114,38497,38483,'291',3.333,5),(1114,38498,38483,'911',3.333,5),(1114,38499,38483,'115',3.333,5),(1114,38500,38483,'150',3.333,5),(1114,38501,38483,'500',3.333,5),(1114,38502,38483,'003',3.333,5),(1114,38503,38483,'03a',3.333,5),(1114,38504,38483,'3aa',3.333,5),(1114,38505,38483,'aa8',3.333,5),(1114,38506,38483,'a8e',3.333,5),(1114,38507,38483,'8ea',3.333,5),(1114,38508,38483,'ea6',3.333,5),(1114,38509,38483,'a62',3.333,5),(1114,38510,38483,'626',3.333,5),(1114,38511,38483,'262',3.333,5),(1114,38512,38483,'625',3.333,5),(1114,38513,38483,'258',3.333,5),(1115,38515,38514,'naa',100,5),(1115,38516,38515,'600',3.333,5),(1115,38517,38515,'000',3.333,5),(1115,38518,38515,'00c',3.333,5),(1115,38519,38515,'0c2',3.333,5),(1115,38520,38515,'c29',3.333,5),(1115,38521,38515,'29a',3.333,5),(1115,38522,38515,'9a9',3.333,5),(1115,38523,38515,'a97',3.333,5),(1115,38524,38515,'973',3.333,5),(1115,38525,38515,'73a',3.333,5),(1115,38526,38515,'3a9',3.333,5),(1115,38527,38515,'a90',3.333,5),(1115,38528,38515,'903',3.333,5),(1115,38529,38515,'03c',3.333,5),(1115,38530,38515,'3c8',3.333,5),(1115,38531,38515,'c82',3.333,5),(1115,38532,38515,'828',3.333,5),(1115,38533,38515,'289',3.333,5),(1115,38534,38515,'89b',3.333,5),(1115,38535,38515,'9b8',3.333,5),(1115,38536,38515,'b8f',3.333,5),(1115,38537,38515,'8f0',3.333,5),(1115,38538,38515,'f07',3.333,5),(1115,38539,38515,'07c',3.333,5),(1115,38540,38515,'7c9',3.333,5),(1115,38541,38515,'c97',3.333,5),(1115,38542,38515,'97a',3.333,5),(1115,38543,38515,'7a4',3.333,5),(1115,38544,38515,'a44',3.333,5),(1115,38545,38515,'447',3.333,5),(1116,38547,38546,'naa',100,5),(1116,38548,38547,'600',3.333,5),(1116,38549,38547,'000',3.333,5),(1116,38550,38547,'00c',3.333,5),(1116,38551,38547,'0c2',3.333,5),(1116,38552,38547,'c29',3.333,5),(1116,38553,38547,'290',3.333,5),(1116,38554,38547,'90a',3.333,5),(1116,38555,38547,'0ad',3.333,5),(1116,38556,38547,'ad2',3.333,5),(1116,38557,38547,'d2b',3.333,5),(1116,38558,38547,'2ba',3.333,5),(1116,38559,38547,'ba5',3.333,5),(1116,38560,38547,'a58',3.333,5),(1116,38561,38547,'585',3.333,5),(1116,38562,38547,'853',3.333,5),(1116,38563,38547,'531',3.333,5),(1116,38564,38547,'315',3.333,5),(1116,38565,38547,'151',3.333,5),(1116,38566,38547,'511',3.333,5),(1116,38567,38547,'11a',3.333,5),(1116,38568,38547,'1aa',3.333,5),(1116,38569,38547,'aa3',3.333,5),(1116,38570,38547,'a39',3.333,5),(1116,38571,38547,'392',3.333,5),(1116,38572,38547,'92c',3.333,5),(1116,38573,38547,'2c1',3.333,5),(1116,38574,38547,'c14',3.333,5),(1116,38575,38547,'145',3.333,5),(1116,38576,38547,'45a',3.333,5),(1116,38577,38547,'5a3',3.333,5),(1117,38579,38578,'naa',100,5),(1117,38580,38579,'600',3.333,5),(1117,38581,38579,'000',3.333,5),(1117,38582,38579,'00c',3.333,5),(1117,38583,38579,'0c2',3.333,5),(1117,38584,38579,'c29',3.333,5),(1117,38585,38579,'296',3.333,5),(1117,38586,38579,'962',3.333,5),(1117,38587,38579,'626',3.333,5),(1117,38588,38579,'264',3.333,5),(1117,38589,38579,'649',3.333,5),(1117,38590,38579,'49e',3.333,5),(1117,38591,38579,'9ec',3.333,5),(1117,38592,38579,'ec6',3.333,5),(1117,38593,38579,'c65',3.333,5),(1117,38594,38579,'655',3.333,5),(1117,38595,38579,'558',3.333,5),(1117,38596,38579,'580',3.333,5),(1117,38597,38579,'80a',3.333,5),(1117,38598,38579,'0ab',3.333,5),(1117,38599,38579,'ab8',3.333,5),(1117,38600,38579,'b80',3.333,5),(1117,38601,38579,'803',3.333,5),(1117,38602,38579,'036',3.333,5),(1117,38603,38579,'36b',3.333,5),(1117,38604,38579,'6bb',3.333,5),(1117,38605,38579,'bb1',3.333,5),(1117,38606,38579,'b1a',3.333,5),(1117,38607,38579,'1a0',3.333,5),(1117,38608,38579,'a05',3.333,5),(1117,38609,38579,'054',3.333,5),(1118,38611,38610,'naa',100,5),(1118,38612,38611,'600',3.333,5),(1118,38613,38611,'000',3.333,5),(1118,38614,38611,'00c',3.333,5),(1118,38615,38611,'0c2',3.333,5),(1118,38616,38611,'c29',3.333,5),(1118,38617,38611,'29d',3.333,5),(1118,38618,38611,'9da',3.333,5),(1118,38619,38611,'da0',3.333,5),(1118,38620,38611,'a0c',3.333,5),(1118,38621,38611,'0c6',3.333,5),(1118,38622,38611,'c67',3.333,5),(1118,38623,38611,'678',3.333,5),(1118,38624,38611,'786',3.333,5),(1118,38625,38611,'863',3.333,5),(1118,38626,38611,'63e',3.333,5),(1118,38627,38611,'3ed',3.333,5),(1118,38628,38611,'ed3',3.333,5),(1118,38629,38611,'d3f',3.333,5),(1118,38630,38611,'3f0',3.333,5),(1118,38631,38611,'f00',3.333,5),(1118,38632,38611,'00c',3.333,5),(1118,38633,38611,'0cc',3.333,5),(1118,38634,38611,'cc7',3.333,5),(1118,38635,38611,'c73',3.333,5),(1118,38636,38611,'73d',3.333,5),(1118,38637,38611,'3d2',3.333,5),(1118,38638,38611,'d28',3.333,5),(1118,38639,38611,'282',3.333,5),(1118,38640,38611,'821',3.333,5),(1118,38641,38611,'219',3.333,5),(1119,38643,38642,'naa',100,5),(1119,38644,38643,'600',3.333,5),(1119,38645,38643,'000',3.333,5),(1119,38646,38643,'00c',3.333,5),(1119,38647,38643,'0c2',3.333,5),(1119,38648,38643,'c29',3.333,5),(1119,38649,38643,'29d',3.333,5),(1119,38650,38643,'9de',3.333,5),(1119,38651,38643,'de7',3.333,5),(1119,38652,38643,'e76',3.333,5),(1119,38653,38643,'769',3.333,5),(1119,38654,38643,'690',3.333,5),(1119,38655,38643,'909',3.333,5),(1119,38656,38643,'09d',3.333,5),(1119,38657,38643,'9d1',3.333,5),(1119,38658,38643,'d14',3.333,5),(1119,38659,38643,'14d',3.333,5),(1119,38660,38643,'4d5',3.333,5),(1119,38661,38643,'d55',3.333,5),(1119,38662,38643,'55e',3.333,5),(1119,38663,38643,'5e3',3.333,5),(1119,38664,38643,'e36',3.333,5),(1119,38665,38643,'369',3.333,5),(1119,38666,38643,'69d',3.333,5),(1119,38667,38643,'9dc',3.333,5),(1119,38668,38643,'dc0',3.333,5),(1119,38669,38643,'c06',3.333,5),(1119,38670,38643,'064',3.333,5),(1119,38671,38643,'647',3.333,5),(1119,38672,38643,'47d',3.333,5),(1119,38673,38643,'7d2',3.333,5),(1120,38675,38674,'naa',100,5),(1120,38676,38675,'600',3.333,5),(1120,38677,38675,'000',3.333,5),(1120,38678,38675,'00c',3.333,5),(1120,38679,38675,'0c2',3.333,5),(1120,38680,38675,'c29',3.333,5),(1120,38681,38675,'295',3.333,5),(1120,38682,38675,'958',3.333,5),(1120,38683,38675,'58b',3.333,5),(1120,38684,38675,'8b8',3.333,5),(1120,38685,38675,'b8c',3.333,5),(1120,38686,38675,'8ca',3.333,5),(1120,38687,38675,'ca3',3.333,5),(1120,38688,38675,'a35',3.333,5),(1120,38689,38675,'35c',3.333,5),(1120,38690,38675,'5cf',3.333,5),(1120,38691,38675,'cfe',3.333,5),(1120,38692,38675,'fe8',3.333,5),(1120,38693,38675,'e84',3.333,5),(1120,38694,38675,'840',3.333,5),(1120,38695,38675,'404',3.333,5),(1120,38696,38675,'043',3.333,5),(1120,38697,38675,'435',3.333,5),(1120,38698,38675,'350',3.333,5),(1120,38699,38675,'501',3.333,5),(1120,38700,38675,'016',3.333,5),(1120,38701,38675,'166',3.333,5),(1120,38702,38675,'668',3.333,5),(1120,38703,38675,'68d',3.333,5),(1120,38704,38675,'8d3',3.333,5),(1120,38705,38675,'d36',3.333,5),(1121,38707,38706,'naa',100,5),(1121,38708,38707,'600',3.333,5),(1121,38709,38707,'000',3.333,5),(1121,38710,38707,'00c',3.333,5),(1121,38711,38707,'0c2',3.333,5),(1121,38712,38707,'c29',3.333,5),(1121,38713,38707,'295',3.333,5),(1121,38714,38707,'953',3.333,5),(1121,38715,38707,'53c',3.333,5),(1121,38716,38707,'3c1',3.333,5),(1121,38717,38707,'c14',3.333,5),(1121,38718,38707,'147',3.333,5),(1121,38719,38707,'471',3.333,5),(1121,38720,38707,'71b',3.333,5),(1121,38721,38707,'1b1',3.333,5),(1121,38722,38707,'b1b',3.333,5),(1121,38723,38707,'1b6',3.333,5),(1121,38724,38707,'b67',3.333,5),(1121,38725,38707,'67b',3.333,5),(1121,38726,38707,'7b9',3.333,5),(1121,38727,38707,'b9d',3.333,5),(1121,38728,38707,'9df',3.333,5),(1121,38729,38707,'df1',3.333,5),(1121,38730,38707,'f17',3.333,5),(1121,38731,38707,'17a',3.333,5),(1121,38732,38707,'7a3',3.333,5),(1121,38733,38707,'a3a',3.333,5),(1121,38734,38707,'3a9',3.333,5),(1121,38735,38707,'a95',3.333,5),(1121,38736,38707,'957',3.333,5),(1121,38737,38707,'57a',3.333,5),(1122,38739,38738,'naa',100,5),(1122,38740,38739,'600',3.333,5),(1122,38741,38739,'000',3.333,5),(1122,38742,38739,'00c',3.333,5),(1122,38743,38739,'0c2',3.333,5),(1122,38744,38739,'c29',3.333,5),(1122,38745,38739,'296',3.333,5),(1122,38746,38739,'96a',3.333,5),(1122,38747,38739,'6ad',3.333,5),(1122,38748,38739,'adf',3.333,5),(1122,38749,38739,'df5',3.333,5),(1122,38750,38739,'f5f',3.333,5),(1122,38751,38739,'5f0',3.333,5),(1122,38752,38739,'f07',3.333,5),(1122,38753,38739,'07c',3.333,5),(1122,38754,38739,'7c1',3.333,5),(1122,38755,38739,'c1c',3.333,5),(1122,38756,38739,'1cf',3.333,5),(1122,38757,38739,'cf4',3.333,5),(1122,38758,38739,'f49',3.333,5),(1122,38759,38739,'498',3.333,5),(1122,38760,38739,'988',3.333,5),(1122,38761,38739,'883',3.333,5),(1122,38762,38739,'83e',3.333,5),(1122,38763,38739,'3e0',3.333,5),(1122,38764,38739,'e0d',3.333,5),(1122,38765,38739,'0d8',3.333,5),(1122,38766,38739,'d86',3.333,5),(1122,38767,38739,'868',3.333,5),(1122,38768,38739,'689',3.333,5),(1122,38769,38739,'890',3.333,5),(2,38771,38770,'mer',14.286,5),(2,38772,38770,'erc',14.286,5),(2,38773,38770,'rcu',14.286,5),(2,38774,38770,'cur',14.286,5),(2,38775,38770,'ury',14.286,5),(2,38776,38770,'ryv',14.286,5),(2,38777,38770,'yvc',14.286,5),(2,38778,38771,'nan',50,5),(2,38779,38771,'ane',50,5),(2,38780,38778,'net',25,5),(2,38781,38778,'eta',25,5),(2,38782,38778,'tap',25,5),(2,38783,38778,'app',25,5),(2,38784,38780,'com',100,5),(3,38786,38785,'hgx',20,5),(3,38787,38785,'gx3',20,5),(3,38788,38785,'x36',20,5),(3,38789,38785,'369',20,5),(3,38790,38785,'690',20,5),(4,38792,38791,'reg',12.5,5),(4,38793,38791,'egr',12.5,5),(4,38794,38791,'gre',12.5,5),(4,38795,38791,'res',12.5,5),(4,38796,38791,'ess',12.5,5),(4,38797,38791,'ssi',12.5,5),(4,38798,38791,'sio',12.5,5),(4,38799,38791,'ion',12.5,5),(4,38800,38792,'lab',100,5),(5,38802,38801,'hgr',20,5),(5,38803,38801,'grx',20,5),(5,38804,38801,'rx3',20,5),(5,38805,38801,'x30',20,5),(5,38806,38801,'300',20,5),(6,38808,38807,'hgu',14.286,5),(6,38809,38807,'guc',14.286,5),(6,38810,38807,'ucs',14.286,5),(6,38811,38807,'csb',14.286,5),(6,38812,38807,'sb2',14.286,5),(6,38813,38807,'b20',14.286,5),(6,38814,38807,'200',14.286,5),(703,39944,39943,'hgw',9.091,5),(703,39945,39943,'gw2',9.091,5),(703,39946,39943,'w2k',9.091,5),(703,39947,39943,'2k8',9.091,5),(703,39948,39943,'k8r',9.091,5),(703,39949,39943,'8r2',9.091,5),(703,39950,39943,'r23',9.091,5),(703,39951,39943,'232',9.091,5),(703,39952,39943,'32v',9.091,5),(703,39953,39943,'2vm',9.091,5),(703,39954,39943,'vm9',9.091,5),(1,40202,40201,'rtp',100,5);
/*!40000 ALTER TABLE `fuzzysearch_default_fuzzysearch_index_title` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `history`
--

DROP TABLE IF EXISTS `history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `history` (
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that read the node nid.',
  `nid` int(11) NOT NULL DEFAULT '0' COMMENT 'The node.nid that was read.',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp at which the read occurred.',
  PRIMARY KEY (`uid`,`nid`),
  KEY `nid` (`nid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='A record of which users have read which nodes.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `history`
--

LOCK TABLES `history` WRITE;
/*!40000 ALTER TABLE `history` DISABLE KEYS */;
INSERT INTO `history` VALUES (1,1,1369947414);
/*!40000 ALTER TABLE `history` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `image_effects`
--

DROP TABLE IF EXISTS `image_effects`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `image_effects` (
  `ieid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for an image effect.',
  `isid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The image_styles.isid for an image style.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The weight of the effect in the style.',
  `name` varchar(255) NOT NULL COMMENT 'The unique name of the effect to be executed.',
  `data` longblob NOT NULL COMMENT 'The configuration data for the effect.',
  PRIMARY KEY (`ieid`),
  KEY `isid` (`isid`),
  KEY `weight` (`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores configuration options for image effects.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `image_effects`
--

LOCK TABLES `image_effects` WRITE;
/*!40000 ALTER TABLE `image_effects` DISABLE KEYS */;
/*!40000 ALTER TABLE `image_effects` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `image_styles`
--

DROP TABLE IF EXISTS `image_styles`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `image_styles` (
  `isid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for an image style.',
  `name` varchar(255) NOT NULL COMMENT 'The style name.',
  PRIMARY KEY (`isid`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores configuration options for image styles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `image_styles`
--

LOCK TABLES `image_styles` WRITE;
/*!40000 ALTER TABLE `image_styles` DISABLE KEYS */;
/*!40000 ALTER TABLE `image_styles` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `login_destination`
--

DROP TABLE IF EXISTS `login_destination`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `login_destination` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique ID.',
  `triggers` text NOT NULL COMMENT 'Triggers on which to perform redirect',
  `roles` text NOT NULL COMMENT 'Roles to perform redirect for',
  `pages_type` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Flag to indicate from which pages to redirect. (0 = all pages except listed pages, 1 = only listed pages, 2 = Use custom PHP code)',
  `pages` text NOT NULL COMMENT 'Pages from which to redirect',
  `destination_type` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Flag to indicate the destination type. (0 = static URL, 1 = PHP code)',
  `destination` text NOT NULL COMMENT 'Redirect destination',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The rule’s weight.',
  PRIMARY KEY (`id`),
  KEY `list` (`weight`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COMMENT='Login Destination rules.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `login_destination`
--

LOCK TABLES `login_destination` WRITE;
/*!40000 ALTER TABLE `login_destination` DISABLE KEYS */;
INSERT INTO `login_destination` VALUES (1,'a:1:{s:5:\"login\";s:5:\"login\";}','a:0:{}',0,'',0,'<front>',0);
/*!40000 ALTER TABLE `login_destination` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `menu_custom`
--

DROP TABLE IF EXISTS `menu_custom`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menu_custom` (
  `menu_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique key for menu. This is used as a block delta so length is 32.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Menu title; displayed at top of block.',
  `description` text COMMENT 'Menu description.',
  PRIMARY KEY (`menu_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Holds definitions for top-level custom menus (for example...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menu_custom`
--

LOCK TABLES `menu_custom` WRITE;
/*!40000 ALTER TABLE `menu_custom` DISABLE KEYS */;
INSERT INTO `menu_custom` VALUES ('main-menu','Main menu','The <em>Main</em> menu is used on many sites to show the major sections of the site, often in a top navigation bar.'),('management','Management','The <em>Management</em> menu contains links for administrative tasks.'),('menu-bulk-action-tool','Bulk Action Tool','This block is for bulk operations.'),('menu-mercury-navigation','Navigation','This block is to be used as the main navigation for the site.'),('menu-refine','Refine',''),('menu-selector-tool','Selector Tool','This block is used to list host, virtual machine and virtual disk with a flash accel installed refine capability'),('navigation','Navigation','The <em>Navigation</em> menu contains links intended for site visitors. Links are added to the <em>Navigation</em> menu automatically by some modules.'),('user-menu','User menu','The <em>User</em> menu contains links related to the user\'s account, as well as the \'Log out\' link.');
/*!40000 ALTER TABLE `menu_custom` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `menu_links`
--

DROP TABLE IF EXISTS `menu_links`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menu_links` (
  `menu_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The menu name. All links with the same menu name (such as ’navigation’) are part of the same menu.',
  `mlid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The menu link ID (mlid) is the integer primary key.',
  `plid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The parent link ID (plid) is the mlid of the link above in the hierarchy, or zero if the link is at the top level in its menu.',
  `link_path` varchar(255) NOT NULL DEFAULT '' COMMENT 'The Drupal path or external path this link points to.',
  `router_path` varchar(255) NOT NULL DEFAULT '' COMMENT 'For links corresponding to a Drupal path (external = 0), this connects the link to a menu_router.path for joins.',
  `link_title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The text displayed for the link, which may be modified by a title callback stored in menu_router.',
  `options` blob COMMENT 'A serialized array of options to be passed to the url() or l() function, such as a query string or HTML attributes.',
  `module` varchar(255) NOT NULL DEFAULT 'system' COMMENT 'The name of the module that generated this link.',
  `hidden` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag for whether the link should be rendered in menus. (1 = a disabled menu item that may be shown on admin screens, -1 = a menu callback, 0 = a normal, visible link)',
  `external` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate if the link points to a full URL starting with a protocol, like http:// (1 = external, 0 = internal).',
  `has_children` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Flag indicating whether any links have this link as a parent (1 = children exist, 0 = no children).',
  `expanded` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Flag for whether this link should be rendered as expanded in menus - expanded links always have their child links displayed, instead of only when the link is in the active trail (1 = expanded, 0 = not expanded)',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Link weight among links in the same menu at the same depth.',
  `depth` smallint(6) NOT NULL DEFAULT '0' COMMENT 'The depth relative to the top level. A link with plid == 0 will have depth == 1.',
  `customized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate that the user has manually created or edited the link (1 = customized, 0 = not customized).',
  `p1` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The first mlid in the materialized path. If N = depth, then pN must equal the mlid. If depth > 1 then p(N-1) must equal the plid. All pX where X > depth must equal zero. The columns p1 .. p9 are also called the parents.',
  `p2` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The second mlid in the materialized path. See p1.',
  `p3` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The third mlid in the materialized path. See p1.',
  `p4` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The fourth mlid in the materialized path. See p1.',
  `p5` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The fifth mlid in the materialized path. See p1.',
  `p6` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The sixth mlid in the materialized path. See p1.',
  `p7` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The seventh mlid in the materialized path. See p1.',
  `p8` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The eighth mlid in the materialized path. See p1.',
  `p9` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The ninth mlid in the materialized path. See p1.',
  `updated` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Flag that indicates that this link was generated during the update from Drupal 5.',
  PRIMARY KEY (`mlid`),
  KEY `path_menu` (`link_path`(128),`menu_name`),
  KEY `menu_plid_expand_child` (`menu_name`,`plid`,`expanded`,`has_children`),
  KEY `menu_parents` (`menu_name`,`p1`,`p2`,`p3`,`p4`,`p5`,`p6`,`p7`,`p8`,`p9`),
  KEY `router_path` (`router_path`(128))
) ENGINE=MyISAM AUTO_INCREMENT=881 DEFAULT CHARSET=utf8 COMMENT='Contains the individual links within a menu.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menu_links`
--

LOCK TABLES `menu_links` WRITE;
/*!40000 ALTER TABLE `menu_links` DISABLE KEYS */;
INSERT INTO `menu_links` VALUES ('management',1,0,'admin','admin','Administration','a:0:{}','system',0,0,1,0,9,1,0,1,0,0,0,0,0,0,0,0,0),('user-menu',2,0,'user','user','User account','a:1:{s:5:\"alter\";b:1;}','system',0,0,0,0,-10,1,0,2,0,0,0,0,0,0,0,0,0),('navigation',3,0,'comment/%','comment/%','Comment permalink','a:0:{}','system',0,0,1,0,0,1,0,3,0,0,0,0,0,0,0,0,0),('navigation',4,0,'filter/tips','filter/tips','Compose tips','a:0:{}','system',1,0,0,0,0,1,0,4,0,0,0,0,0,0,0,0,0),('navigation',5,0,'node/%','node/%','','a:0:{}','system',0,0,0,0,0,1,0,5,0,0,0,0,0,0,0,0,0),('navigation',6,0,'node/add','node/add','Add content','a:0:{}','system',0,0,1,0,0,1,0,6,0,0,0,0,0,0,0,0,0),('management',7,1,'admin/appearance','admin/appearance','Appearance','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Select and configure your themes.\";}}','system',0,0,0,0,-6,2,0,1,7,0,0,0,0,0,0,0,0),('management',8,1,'admin/config','admin/config','Configuration','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"Administer settings.\";}}','system',0,0,1,0,0,2,0,1,8,0,0,0,0,0,0,0,0),('management',9,1,'admin/content','admin/content','Content','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:32:\"Administer content and comments.\";}}','system',0,0,1,0,-10,2,0,1,9,0,0,0,0,0,0,0,0),('user-menu',10,2,'user/register','user/register','Create new account','a:0:{}','system',-1,0,0,0,0,2,0,2,10,0,0,0,0,0,0,0,0),('management',11,1,'admin/dashboard','admin/dashboard','Dashboard','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"View and customize your dashboard.\";}}','system',0,0,0,0,-15,2,0,1,11,0,0,0,0,0,0,0,0),('management',12,1,'admin/help','admin/help','Help','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:48:\"Reference for usage, configuration, and modules.\";}}','system',0,0,0,0,9,2,0,1,12,0,0,0,0,0,0,0,0),('management',13,1,'admin/index','admin/index','Index','a:0:{}','system',-1,0,0,0,-18,2,0,1,13,0,0,0,0,0,0,0,0),('user-menu',14,2,'user/login','user/login','Log in','a:0:{}','system',-1,0,0,0,0,2,0,2,14,0,0,0,0,0,0,0,0),('user-menu',15,0,'user/logout','user/logout','Log out','a:1:{s:5:\"alter\";b:1;}','system',0,0,0,0,10,1,0,15,0,0,0,0,0,0,0,0,0),('management',16,1,'admin/modules','admin/modules','Modules','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:26:\"Extend site functionality.\";}}','system',0,0,0,0,-2,2,0,1,16,0,0,0,0,0,0,0,0),('navigation',17,0,'user/%','user/%','My account','a:0:{}','system',0,0,1,0,0,1,0,17,0,0,0,0,0,0,0,0,0),('management',18,1,'admin/people','admin/people','People','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Manage user accounts, roles, and permissions.\";}}','system',0,0,0,0,-4,2,0,1,18,0,0,0,0,0,0,0,0),('management',19,1,'admin/reports','admin/reports','Reports','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"View reports, updates, and errors.\";}}','system',0,0,1,0,5,2,0,1,19,0,0,0,0,0,0,0,0),('user-menu',20,2,'user/password','user/password','Request new password','a:0:{}','system',-1,0,0,0,0,2,0,2,20,0,0,0,0,0,0,0,0),('management',21,1,'admin/structure','admin/structure','Structure','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Administer blocks, content types, menus, etc.\";}}','system',0,0,1,0,-8,2,0,1,21,0,0,0,0,0,0,0,0),('management',22,1,'admin/tasks','admin/tasks','Tasks','a:0:{}','system',-1,0,0,0,-20,2,0,1,22,0,0,0,0,0,0,0,0),('navigation',23,0,'comment/reply/%','comment/reply/%','Add new comment','a:0:{}','system',0,0,0,0,0,1,0,23,0,0,0,0,0,0,0,0,0),('navigation',24,3,'comment/%/approve','comment/%/approve','Approve','a:0:{}','system',0,0,0,0,1,2,0,3,24,0,0,0,0,0,0,0,0),('navigation',25,3,'comment/%/delete','comment/%/delete','Delete','a:0:{}','system',-1,0,0,0,2,2,0,3,25,0,0,0,0,0,0,0,0),('navigation',26,3,'comment/%/edit','comment/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,2,0,3,26,0,0,0,0,0,0,0,0),('navigation',27,0,'taxonomy/term/%','taxonomy/term/%','Taxonomy term','a:0:{}','system',0,0,0,0,0,1,0,27,0,0,0,0,0,0,0,0,0),('navigation',28,3,'comment/%/view','comment/%/view','View comment','a:0:{}','system',-1,0,0,0,-10,2,0,3,28,0,0,0,0,0,0,0,0),('management',29,18,'admin/people/create','admin/people/create','Add user','a:0:{}','system',-1,0,0,0,0,3,0,1,18,29,0,0,0,0,0,0,0),('management',30,21,'admin/structure/block','admin/structure/block','Blocks','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:79:\"Configure what block content appears in your site\'s sidebars and other regions.\";}}','system',0,0,1,0,0,3,0,1,21,30,0,0,0,0,0,0,0),('navigation',31,17,'user/%/cancel','user/%/cancel','Cancel account','a:0:{}','system',0,0,1,0,0,2,0,17,31,0,0,0,0,0,0,0,0),('management',32,9,'admin/content/comment','admin/content/comment','Comments','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:59:\"List and edit site comments and the comment approval queue.\";}}','system',0,0,0,0,0,3,0,1,9,32,0,0,0,0,0,0,0),('management',33,11,'admin/dashboard/configure','admin/dashboard/configure','Configure available dashboard blocks','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:53:\"Configure which blocks can be shown on the dashboard.\";}}','system',-1,0,0,0,0,3,0,1,11,33,0,0,0,0,0,0,0),('management',34,9,'admin/content/node','admin/content/node','Content','a:0:{}','system',-1,0,0,0,-10,3,0,1,9,34,0,0,0,0,0,0,0),('management',35,8,'admin/config/content','admin/config/content','Content authoring','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:53:\"Settings related to formatting and authoring content.\";}}','system',0,0,1,0,-15,3,0,1,8,35,0,0,0,0,0,0,0),('management',36,21,'admin/structure/types','admin/structure/types','Content types','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:92:\"Manage content types, including default status, front page promotion, comment settings, etc.\";}}','system',0,0,1,0,0,3,0,1,21,36,0,0,0,0,0,0,0),('management',37,11,'admin/dashboard/customize','admin/dashboard/customize','Customize dashboard','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:25:\"Customize your dashboard.\";}}','system',-1,0,0,0,0,3,0,1,11,37,0,0,0,0,0,0,0),('navigation',38,5,'node/%/delete','node/%/delete','Delete','a:0:{}','system',-1,0,0,0,1,2,0,5,38,0,0,0,0,0,0,0,0),('management',39,8,'admin/config/development','admin/config/development','Development','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:18:\"Development tools.\";}}','system',0,0,1,0,-10,3,0,1,8,39,0,0,0,0,0,0,0),('navigation',40,17,'user/%/edit','user/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,2,0,17,40,0,0,0,0,0,0,0,0),('navigation',41,5,'node/%/edit','node/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,2,0,5,41,0,0,0,0,0,0,0,0),('management',42,19,'admin/reports/fields','admin/reports/fields','Field list','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:39:\"Overview of fields on all entity types.\";}}','system',0,0,0,0,0,3,0,1,19,42,0,0,0,0,0,0,0),('management',43,7,'admin/appearance/list','admin/appearance/list','List','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"Select and configure your theme\";}}','system',-1,0,0,0,-1,3,0,1,7,43,0,0,0,0,0,0,0),('management',44,16,'admin/modules/list','admin/modules/list','List','a:0:{}','system',-1,0,0,0,0,3,0,1,16,44,0,0,0,0,0,0,0),('management',45,18,'admin/people/people','admin/people/people','List','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:50:\"Find and manage people interacting with your site.\";}}','system',-1,0,0,0,-10,3,0,1,18,45,0,0,0,0,0,0,0),('management',46,8,'admin/config/media','admin/config/media','Media','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:12:\"Media tools.\";}}','system',0,0,1,0,-10,3,0,1,8,46,0,0,0,0,0,0,0),('management',47,21,'admin/structure/menu','admin/structure/menu','Menus','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:86:\"Add new menus to your site, edit existing menus, and rename and reorganize menu links.\";}}','system',0,0,1,0,0,3,0,1,21,47,0,0,0,0,0,0,0),('management',48,8,'admin/config/people','admin/config/people','People','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:24:\"Configure user accounts.\";}}','system',0,0,1,0,-20,3,0,1,8,48,0,0,0,0,0,0,0),('management',49,18,'admin/people/permissions','admin/people/permissions','Permissions','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:64:\"Determine access to features by selecting permissions for roles.\";}}','system',-1,0,0,0,0,3,0,1,18,49,0,0,0,0,0,0,0),('management',50,19,'admin/reports/dblog','admin/reports/dblog','Recent log messages','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"View events that have recently been logged.\";}}','system',0,0,0,0,-1,3,0,1,19,50,0,0,0,0,0,0,0),('management',51,8,'admin/config/regional','admin/config/regional','Regional and language','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:48:\"Regional settings, localization and translation.\";}}','system',0,0,1,0,-5,3,0,1,8,51,0,0,0,0,0,0,0),('navigation',52,5,'node/%/revisions','node/%/revisions','Revisions','a:0:{}','system',-1,0,1,0,2,2,0,5,52,0,0,0,0,0,0,0,0),('management',53,8,'admin/config/search','admin/config/search','Search and metadata','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:36:\"Local site search, metadata and SEO.\";}}','system',0,0,1,0,-10,3,0,1,8,53,0,0,0,0,0,0,0),('management',54,7,'admin/appearance/settings','admin/appearance/settings','Settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:46:\"Configure default and theme specific settings.\";}}','system',-1,0,0,0,20,3,0,1,7,54,0,0,0,0,0,0,0),('management',55,19,'admin/reports/status','admin/reports/status','Status report','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:74:\"Get a status report about your site\'s operation and any detected problems.\";}}','system',0,0,0,0,-60,3,0,1,19,55,0,0,0,0,0,0,0),('management',56,8,'admin/config/system','admin/config/system','System','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"General system related configuration.\";}}','system',0,0,1,0,-20,3,0,1,8,56,0,0,0,0,0,0,0),('management',57,21,'admin/structure/taxonomy','admin/structure/taxonomy','Taxonomy','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:67:\"Manage tagging, categorization, and classification of your content.\";}}','system',0,0,1,0,0,3,0,1,21,57,0,0,0,0,0,0,0),('management',58,19,'admin/reports/access-denied','admin/reports/access-denied','Top \'access denied\' errors','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:35:\"View \'access denied\' errors (403s).\";}}','system',0,0,0,0,0,3,0,1,19,58,0,0,0,0,0,0,0),('management',59,19,'admin/reports/page-not-found','admin/reports/page-not-found','Top \'page not found\' errors','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:36:\"View \'page not found\' errors (404s).\";}}','system',0,0,0,0,0,3,0,1,19,59,0,0,0,0,0,0,0),('management',60,16,'admin/modules/uninstall','admin/modules/uninstall','Uninstall','a:0:{}','system',-1,0,0,0,20,3,0,1,16,60,0,0,0,0,0,0,0),('management',61,8,'admin/config/user-interface','admin/config/user-interface','User interface','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Tools that enhance the user interface.\";}}','system',0,0,1,0,-15,3,0,1,8,61,0,0,0,0,0,0,0),('navigation',62,5,'node/%/view','node/%/view','View','a:0:{}','system',-1,0,0,0,-10,2,0,5,62,0,0,0,0,0,0,0,0),('navigation',63,17,'user/%/view','user/%/view','View','a:0:{}','system',-1,0,0,0,-10,2,0,17,63,0,0,0,0,0,0,0,0),('management',64,8,'admin/config/services','admin/config/services','Web services','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:30:\"Tools related to web services.\";}}','system',0,0,1,0,0,3,0,1,8,64,0,0,0,0,0,0,0),('management',65,8,'admin/config/workflow','admin/config/workflow','Workflow','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Content workflow, editorial workflow tools.\";}}','system',0,0,0,0,5,3,0,1,8,65,0,0,0,0,0,0,0),('management',66,12,'admin/help/block','admin/help/block','block','a:0:{}','system',-1,0,0,0,0,3,0,1,12,66,0,0,0,0,0,0,0),('management',67,12,'admin/help/color','admin/help/color','color','a:0:{}','system',-1,0,0,0,0,3,0,1,12,67,0,0,0,0,0,0,0),('management',68,12,'admin/help/comment','admin/help/comment','comment','a:0:{}','system',-1,0,0,0,0,3,0,1,12,68,0,0,0,0,0,0,0),('management',70,12,'admin/help/dashboard','admin/help/dashboard','dashboard','a:0:{}','system',-1,0,0,0,0,3,0,1,12,70,0,0,0,0,0,0,0),('management',71,12,'admin/help/dblog','admin/help/dblog','dblog','a:0:{}','system',-1,0,0,0,0,3,0,1,12,71,0,0,0,0,0,0,0),('management',72,12,'admin/help/field','admin/help/field','field','a:0:{}','system',-1,0,0,0,0,3,0,1,12,72,0,0,0,0,0,0,0),('management',73,12,'admin/help/field_sql_storage','admin/help/field_sql_storage','field_sql_storage','a:0:{}','system',-1,0,0,0,0,3,0,1,12,73,0,0,0,0,0,0,0),('management',74,12,'admin/help/field_ui','admin/help/field_ui','field_ui','a:0:{}','system',-1,0,0,0,0,3,0,1,12,74,0,0,0,0,0,0,0),('management',76,12,'admin/help/filter','admin/help/filter','filter','a:0:{}','system',-1,0,0,0,0,3,0,1,12,76,0,0,0,0,0,0,0),('management',77,12,'admin/help/help','admin/help/help','help','a:0:{}','system',-1,0,0,0,0,3,0,1,12,77,0,0,0,0,0,0,0),('management',79,12,'admin/help/list','admin/help/list','list','a:0:{}','system',-1,0,0,0,0,3,0,1,12,79,0,0,0,0,0,0,0),('management',80,12,'admin/help/menu','admin/help/menu','menu','a:0:{}','system',-1,0,0,0,0,3,0,1,12,80,0,0,0,0,0,0,0),('management',81,12,'admin/help/node','admin/help/node','node','a:0:{}','system',-1,0,0,0,0,3,0,1,12,81,0,0,0,0,0,0,0),('management',82,12,'admin/help/options','admin/help/options','options','a:0:{}','system',-1,0,0,0,0,3,0,1,12,82,0,0,0,0,0,0,0),('management',83,12,'admin/help/system','admin/help/system','system','a:0:{}','system',-1,0,0,0,0,3,0,1,12,83,0,0,0,0,0,0,0),('management',84,12,'admin/help/taxonomy','admin/help/taxonomy','taxonomy','a:0:{}','system',-1,0,0,0,0,3,0,1,12,84,0,0,0,0,0,0,0),('management',85,12,'admin/help/text','admin/help/text','text','a:0:{}','system',-1,0,0,0,0,3,0,1,12,85,0,0,0,0,0,0,0),('management',86,12,'admin/help/user','admin/help/user','user','a:0:{}','system',-1,0,0,0,0,3,0,1,12,86,0,0,0,0,0,0,0),('navigation',87,27,'taxonomy/term/%/edit','taxonomy/term/%/edit','Edit','a:0:{}','system',-1,0,0,0,10,2,0,27,87,0,0,0,0,0,0,0,0),('navigation',88,27,'taxonomy/term/%/view','taxonomy/term/%/view','View','a:0:{}','system',-1,0,0,0,0,2,0,27,88,0,0,0,0,0,0,0,0),('management',89,48,'admin/config/people/accounts','admin/config/people/accounts','Account settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:109:\"Configure default behavior of users, including registration requirements, e-mails, fields, and user pictures.\";}}','system',0,0,0,0,-10,4,0,1,8,48,89,0,0,0,0,0,0),('management',90,56,'admin/config/system/actions','admin/config/system/actions','Actions','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:41:\"Manage the actions defined for your site.\";}}','system',0,0,1,0,0,4,0,1,8,56,90,0,0,0,0,0,0),('management',91,30,'admin/structure/block/add','admin/structure/block/add','Add block','a:0:{}','system',-1,0,0,0,0,4,0,1,21,30,91,0,0,0,0,0,0),('management',92,36,'admin/structure/types/add','admin/structure/types/add','Add content type','a:0:{}','system',-1,0,0,0,0,4,0,1,21,36,92,0,0,0,0,0,0),('management',93,47,'admin/structure/menu/add','admin/structure/menu/add','Add menu','a:0:{}','system',-1,0,0,0,0,4,0,1,21,47,93,0,0,0,0,0,0),('management',94,57,'admin/structure/taxonomy/add','admin/structure/taxonomy/add','Add vocabulary','a:0:{}','system',-1,0,0,0,0,4,0,1,21,57,94,0,0,0,0,0,0),('management',95,54,'admin/appearance/settings/bartik','admin/appearance/settings/bartik','Bartik','a:0:{}','system',-1,0,0,0,0,4,0,1,7,54,95,0,0,0,0,0,0),('management',96,53,'admin/config/search/clean-urls','admin/config/search/clean-urls','Clean URLs','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Enable or disable clean URLs for your site.\";}}','system',0,0,0,0,5,4,0,1,8,53,96,0,0,0,0,0,0),('management',97,56,'admin/config/system/cron','admin/config/system/cron','Cron','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:40:\"Manage automatic site maintenance tasks.\";}}','system',0,0,0,0,20,4,0,1,8,56,97,0,0,0,0,0,0),('management',98,51,'admin/config/regional/date-time','admin/config/regional/date-time','Date and time','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:44:\"Configure display formats for date and time.\";}}','system',0,0,0,0,-15,4,0,1,8,51,98,0,0,0,0,0,0),('management',99,19,'admin/reports/event/%','admin/reports/event/%','Details','a:0:{}','system',0,0,0,0,0,3,0,1,19,99,0,0,0,0,0,0,0),('management',100,46,'admin/config/media/file-system','admin/config/media/file-system','File system','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:68:\"Tell Drupal where to store uploaded files and how they are accessed.\";}}','system',0,0,0,0,-10,4,0,1,8,46,100,0,0,0,0,0,0),('management',101,54,'admin/appearance/settings/garland','admin/appearance/settings/garland','Garland','a:0:{}','system',-1,0,0,0,0,4,0,1,7,54,101,0,0,0,0,0,0),('management',102,54,'admin/appearance/settings/global','admin/appearance/settings/global','Global settings','a:0:{}','system',-1,0,0,0,-1,4,0,1,7,54,102,0,0,0,0,0,0),('management',103,48,'admin/config/people/ip-blocking','admin/config/people/ip-blocking','IP address blocking','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:28:\"Manage blocked IP addresses.\";}}','system',0,0,1,0,10,4,0,1,8,48,103,0,0,0,0,0,0),('management',105,46,'admin/config/media/image-toolkit','admin/config/media/image-toolkit','Image toolkit','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:74:\"Choose which image toolkit to use if you have installed optional toolkits.\";}}','system',0,0,0,0,20,4,0,1,8,46,105,0,0,0,0,0,0),('management',106,36,'admin/structure/types/list','admin/structure/types/list','List','a:0:{}','system',-1,0,0,0,-10,4,0,1,21,36,106,0,0,0,0,0,0),('management',107,44,'admin/modules/list/confirm','admin/modules/list/confirm','List','a:0:{}','system',-1,0,0,0,0,4,0,1,16,44,107,0,0,0,0,0,0),('management',108,57,'admin/structure/taxonomy/list','admin/structure/taxonomy/list','List','a:0:{}','system',-1,0,0,0,-10,4,0,1,21,57,108,0,0,0,0,0,0),('management',109,47,'admin/structure/menu/list','admin/structure/menu/list','List menus','a:0:{}','system',-1,0,0,0,-10,4,0,1,21,47,109,0,0,0,0,0,0),('management',110,39,'admin/config/development/logging','admin/config/development/logging','Logging and errors','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:154:\"Settings for logging and alerts modules. Various modules can route Drupal\'s system events to different destinations, such as syslog, database, email, etc.\";}}','system',0,0,0,0,-15,4,0,1,8,39,110,0,0,0,0,0,0),('management',111,39,'admin/config/development/maintenance','admin/config/development/maintenance','Maintenance mode','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:62:\"Take the site offline for maintenance or bring it back online.\";}}','system',0,0,0,0,-10,4,0,1,8,39,111,0,0,0,0,0,0),('management',112,39,'admin/config/development/performance','admin/config/development/performance','Performance','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:101:\"Enable or disable page caching for anonymous users and set CSS and JS bandwidth optimization options.\";}}','system',0,0,0,0,-20,4,0,1,8,39,112,0,0,0,0,0,0),('management',113,49,'admin/people/permissions/list','admin/people/permissions/list','Permissions','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:64:\"Determine access to features by selecting permissions for roles.\";}}','system',-1,0,0,0,-8,4,0,1,18,49,113,0,0,0,0,0,0),('management',114,32,'admin/content/comment/new','admin/content/comment/new','Published comments','a:0:{}','system',-1,0,0,0,-10,4,0,1,9,32,114,0,0,0,0,0,0),('management',115,64,'admin/config/services/rss-publishing','admin/config/services/rss-publishing','RSS publishing','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:114:\"Configure the site description, the number of items per feed and whether feeds should be titles/teasers/full-text.\";}}','system',0,0,0,0,0,4,0,1,8,64,115,0,0,0,0,0,0),('management',116,51,'admin/config/regional/settings','admin/config/regional/settings','Regional settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:54:\"Settings for the site\'s default time zone and country.\";}}','system',0,0,0,0,-20,4,0,1,8,51,116,0,0,0,0,0,0),('management',117,49,'admin/people/permissions/roles','admin/people/permissions/roles','Roles','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:30:\"List, edit, or add user roles.\";}}','system',-1,0,1,0,-5,4,0,1,18,49,117,0,0,0,0,0,0),('management',118,47,'admin/structure/menu/settings','admin/structure/menu/settings','Settings','a:0:{}','system',-1,0,0,0,5,4,0,1,21,47,118,0,0,0,0,0,0),('management',119,54,'admin/appearance/settings/seven','admin/appearance/settings/seven','Seven','a:0:{}','system',-1,0,0,0,0,4,0,1,7,54,119,0,0,0,0,0,0),('management',120,56,'admin/config/system/site-information','admin/config/system/site-information','Site information','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:104:\"Change site name, e-mail address, slogan, default front page, and number of posts per page, error pages.\";}}','system',0,0,0,0,-20,4,0,1,8,56,120,0,0,0,0,0,0),('management',121,54,'admin/appearance/settings/stark','admin/appearance/settings/stark','Stark','a:0:{}','system',-1,0,0,0,0,4,0,1,7,54,121,0,0,0,0,0,0),('management',122,35,'admin/config/content/formats','admin/config/content/formats','Text formats','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:127:\"Configure how content input by users is filtered, including allowed HTML tags. Also allows enabling of module-provided filters.\";}}','system',0,0,1,0,0,4,0,1,8,35,122,0,0,0,0,0,0),('management',123,60,'admin/modules/uninstall/confirm','admin/modules/uninstall/confirm','Uninstall','a:0:{}','system',-1,0,0,0,0,4,0,1,16,60,123,0,0,0,0,0,0),('management',124,57,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','','a:0:{}','system',0,0,0,0,0,4,0,1,21,57,124,0,0,0,0,0,0),('management',125,32,'admin/content/comment/approval','admin/content/comment/approval','Unapproved comments','a:0:{}','system',-1,0,0,0,0,4,0,1,9,32,125,0,0,0,0,0,0),('navigation',126,40,'user/%/edit/account','user/%/edit/account','Account','a:0:{}','system',-1,0,0,0,0,3,0,17,40,126,0,0,0,0,0,0,0),('management',127,122,'admin/config/content/formats/%','admin/config/content/formats/%','','a:0:{}','system',0,0,1,0,0,5,0,1,8,35,122,127,0,0,0,0,0),('management',129,124,'admin/structure/taxonomy/%/add','admin/structure/taxonomy/%/add','Add term','a:0:{}','system',-1,0,0,0,0,5,0,1,21,57,124,129,0,0,0,0,0),('management',130,122,'admin/config/content/formats/add','admin/config/content/formats/add','Add text format','a:0:{}','system',-1,0,0,0,1,5,0,1,8,35,122,130,0,0,0,0,0),('management',131,30,'admin/structure/block/list/bartik','admin/structure/block/list/bartik','Bartik','a:0:{}','system',-1,0,0,0,0,4,0,1,21,30,131,0,0,0,0,0,0),('management',132,90,'admin/config/system/actions/configure','admin/config/system/actions/configure','Configure an advanced action','a:0:{}','system',-1,0,0,0,0,5,0,1,8,56,90,132,0,0,0,0,0),('management',133,47,'admin/structure/menu/manage/%','admin/structure/menu/manage/%','Customize menu','a:0:{}','system',0,0,1,0,0,4,0,1,21,47,133,0,0,0,0,0,0),('management',134,124,'admin/structure/taxonomy/%/edit','admin/structure/taxonomy/%/edit','Edit','a:0:{}','system',-1,0,0,0,-10,5,0,1,21,57,124,134,0,0,0,0,0),('management',135,36,'admin/structure/types/manage/%','admin/structure/types/manage/%','Edit content type','a:0:{}','system',0,0,1,0,0,4,0,1,21,36,135,0,0,0,0,0,0),('management',136,98,'admin/config/regional/date-time/formats','admin/config/regional/date-time/formats','Formats','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:51:\"Configure display format strings for date and time.\";}}','system',-1,0,1,0,-9,5,0,1,8,51,98,136,0,0,0,0,0),('management',137,30,'admin/structure/block/list/garland','admin/structure/block/list/garland','Garland','a:0:{}','system',-1,0,0,0,0,4,0,1,21,30,137,0,0,0,0,0,0),('management',138,124,'admin/structure/taxonomy/%/list','admin/structure/taxonomy/%/list','List','a:0:{}','system',-1,0,0,0,-20,5,0,1,21,57,124,138,0,0,0,0,0),('management',139,122,'admin/config/content/formats/list','admin/config/content/formats/list','List','a:0:{}','system',-1,0,0,0,0,5,0,1,8,35,122,139,0,0,0,0,0),('management',141,90,'admin/config/system/actions/manage','admin/config/system/actions/manage','Manage actions','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:41:\"Manage the actions defined for your site.\";}}','system',-1,0,0,0,-2,5,0,1,8,56,90,141,0,0,0,0,0),('management',142,89,'admin/config/people/accounts/settings','admin/config/people/accounts/settings','Settings','a:0:{}','system',-1,0,0,0,-10,5,0,1,8,48,89,142,0,0,0,0,0),('management',143,30,'admin/structure/block/list/seven','admin/structure/block/list/seven','Seven','a:0:{}','system',-1,0,0,0,0,4,0,1,21,30,143,0,0,0,0,0,0),('management',144,30,'admin/structure/block/list/stark','admin/structure/block/list/stark','Stark','a:0:{}','system',-1,0,0,0,0,4,0,1,21,30,144,0,0,0,0,0,0),('management',145,98,'admin/config/regional/date-time/types','admin/config/regional/date-time/types','Types','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:44:\"Configure display formats for date and time.\";}}','system',-1,0,1,0,-10,5,0,1,8,51,98,145,0,0,0,0,0),('navigation',146,52,'node/%/revisions/%/delete','node/%/revisions/%/delete','Delete earlier revision','a:0:{}','system',0,0,0,0,0,3,0,5,52,146,0,0,0,0,0,0,0),('navigation',147,52,'node/%/revisions/%/revert','node/%/revisions/%/revert','Revert to earlier revision','a:0:{}','system',0,0,0,0,0,3,0,5,52,147,0,0,0,0,0,0,0),('navigation',148,52,'node/%/revisions/%/view','node/%/revisions/%/view','Revisions','a:0:{}','system',0,0,0,0,0,3,0,5,52,148,0,0,0,0,0,0,0),('management',149,137,'admin/structure/block/list/garland/add','admin/structure/block/list/garland/add','Add block','a:0:{}','system',-1,0,0,0,0,5,0,1,21,30,137,149,0,0,0,0,0),('management',150,143,'admin/structure/block/list/seven/add','admin/structure/block/list/seven/add','Add block','a:0:{}','system',-1,0,0,0,0,5,0,1,21,30,143,150,0,0,0,0,0),('management',151,144,'admin/structure/block/list/stark/add','admin/structure/block/list/stark/add','Add block','a:0:{}','system',-1,0,0,0,0,5,0,1,21,30,144,151,0,0,0,0,0),('management',152,145,'admin/config/regional/date-time/types/add','admin/config/regional/date-time/types/add','Add date type','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:18:\"Add new date type.\";}}','system',-1,0,0,0,-10,6,0,1,8,51,98,145,152,0,0,0,0),('management',153,136,'admin/config/regional/date-time/formats/add','admin/config/regional/date-time/formats/add','Add format','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Allow users to add additional date formats.\";}}','system',-1,0,0,0,-10,6,0,1,8,51,98,136,153,0,0,0,0),('management',154,133,'admin/structure/menu/manage/%/add','admin/structure/menu/manage/%/add','Add link','a:0:{}','system',-1,0,0,0,0,5,0,1,21,47,133,154,0,0,0,0,0),('management',155,30,'admin/structure/block/manage/%/%','admin/structure/block/manage/%/%','Configure block','a:0:{}','system',0,0,0,0,0,4,0,1,21,30,155,0,0,0,0,0,0),('navigation',156,31,'user/%/cancel/confirm/%/%','user/%/cancel/confirm/%/%','Confirm account cancellation','a:0:{}','system',0,0,0,0,0,3,0,17,31,156,0,0,0,0,0,0,0),('management',157,135,'admin/structure/types/manage/%/delete','admin/structure/types/manage/%/delete','Delete','a:0:{}','system',0,0,0,0,0,5,0,1,21,36,135,157,0,0,0,0,0),('management',158,103,'admin/config/people/ip-blocking/delete/%','admin/config/people/ip-blocking/delete/%','Delete IP address','a:0:{}','system',0,0,0,0,0,5,0,1,8,48,103,158,0,0,0,0,0),('management',159,90,'admin/config/system/actions/delete/%','admin/config/system/actions/delete/%','Delete action','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:17:\"Delete an action.\";}}','system',0,0,0,0,0,5,0,1,8,56,90,159,0,0,0,0,0),('management',160,133,'admin/structure/menu/manage/%/delete','admin/structure/menu/manage/%/delete','Delete menu','a:0:{}','system',0,0,0,0,0,5,0,1,21,47,133,160,0,0,0,0,0),('management',161,47,'admin/structure/menu/item/%/delete','admin/structure/menu/item/%/delete','Delete menu link','a:0:{}','system',0,0,0,0,0,4,0,1,21,47,161,0,0,0,0,0,0),('management',162,117,'admin/people/permissions/roles/delete/%','admin/people/permissions/roles/delete/%','Delete role','a:0:{}','system',0,0,0,0,0,5,0,1,18,49,117,162,0,0,0,0,0),('management',163,127,'admin/config/content/formats/%/disable','admin/config/content/formats/%/disable','Disable text format','a:0:{}','system',0,0,0,0,0,6,0,1,8,35,122,127,163,0,0,0,0),('management',164,135,'admin/structure/types/manage/%/edit','admin/structure/types/manage/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,5,0,1,21,36,135,164,0,0,0,0,0),('management',165,133,'admin/structure/menu/manage/%/edit','admin/structure/menu/manage/%/edit','Edit menu','a:0:{}','system',-1,0,0,0,0,5,0,1,21,47,133,165,0,0,0,0,0),('management',166,47,'admin/structure/menu/item/%/edit','admin/structure/menu/item/%/edit','Edit menu link','a:0:{}','system',0,0,0,0,0,4,0,1,21,47,166,0,0,0,0,0,0),('management',167,117,'admin/people/permissions/roles/edit/%','admin/people/permissions/roles/edit/%','Edit role','a:0:{}','system',0,0,0,0,0,5,0,1,18,49,117,167,0,0,0,0,0),('management',169,133,'admin/structure/menu/manage/%/list','admin/structure/menu/manage/%/list','List links','a:0:{}','system',-1,0,0,0,-10,5,0,1,21,47,133,169,0,0,0,0,0),('management',170,47,'admin/structure/menu/item/%/reset','admin/structure/menu/item/%/reset','Reset menu link','a:0:{}','system',0,0,0,0,0,4,0,1,21,47,170,0,0,0,0,0,0),('management',173,135,'admin/structure/types/manage/%/comment/display','admin/structure/types/manage/%/comment/display','Comment display','a:0:{}','system',-1,0,0,0,4,5,0,1,21,36,135,173,0,0,0,0,0),('management',174,135,'admin/structure/types/manage/%/comment/fields','admin/structure/types/manage/%/comment/fields','Comment fields','a:0:{}','system',-1,0,1,0,3,5,0,1,21,36,135,174,0,0,0,0,0),('management',175,155,'admin/structure/block/manage/%/%/configure','admin/structure/block/manage/%/%/configure','Configure block','a:0:{}','system',-1,0,0,0,0,5,0,1,21,30,155,175,0,0,0,0,0),('management',176,155,'admin/structure/block/manage/%/%/delete','admin/structure/block/manage/%/%/delete','Delete block','a:0:{}','system',-1,0,0,0,0,5,0,1,21,30,155,176,0,0,0,0,0),('management',177,136,'admin/config/regional/date-time/formats/%/delete','admin/config/regional/date-time/formats/%/delete','Delete date format','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:47:\"Allow users to delete a configured date format.\";}}','system',0,0,0,0,0,6,0,1,8,51,98,136,177,0,0,0,0),('management',178,145,'admin/config/regional/date-time/types/%/delete','admin/config/regional/date-time/types/%/delete','Delete date type','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Allow users to delete a configured date type.\";}}','system',0,0,0,0,0,6,0,1,8,51,98,145,178,0,0,0,0),('management',179,136,'admin/config/regional/date-time/formats/%/edit','admin/config/regional/date-time/formats/%/edit','Edit date format','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Allow users to edit a configured date format.\";}}','system',0,0,0,0,0,6,0,1,8,51,98,136,179,0,0,0,0),('management',183,47,'admin/structure/menu/manage/main-menu','admin/structure/menu/manage/%','Main menu','a:0:{}','menu',0,0,0,0,0,4,0,1,21,47,183,0,0,0,0,0,0),('management',184,47,'admin/structure/menu/manage/management','admin/structure/menu/manage/%','Management','a:0:{}','menu',0,0,0,0,0,4,0,1,21,47,184,0,0,0,0,0,0),('management',185,47,'admin/structure/menu/manage/navigation','admin/structure/menu/manage/%','Navigation','a:0:{}','menu',0,0,0,0,0,4,0,1,21,47,185,0,0,0,0,0,0),('management',186,47,'admin/structure/menu/manage/user-menu','admin/structure/menu/manage/%','User menu','a:0:{}','menu',0,0,0,0,0,4,0,1,21,47,186,0,0,0,0,0,0),('navigation',187,0,'search','search','Search','a:0:{}','system',1,0,0,0,0,1,0,187,0,0,0,0,0,0,0,0,0),('navigation',188,187,'search/node','search/node','Content','a:0:{}','system',-1,0,0,0,-10,2,0,187,188,0,0,0,0,0,0,0,0),('navigation',190,188,'search/node/%','search/node/%','Content','a:0:{}','system',-1,0,0,0,0,3,0,187,188,190,0,0,0,0,0,0,0),('navigation',191,17,'user/%/shortcuts','user/%/shortcuts','Shortcuts','a:0:{}','system',-1,0,0,0,0,2,0,17,191,0,0,0,0,0,0,0,0),('management',192,19,'admin/reports/search','admin/reports/search','Top search phrases','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"View most popular search phrases.\";}}','system',0,0,0,0,0,3,0,1,19,192,0,0,0,0,0,0,0),('management',194,12,'admin/help/number','admin/help/number','number','a:0:{}','system',-1,0,0,0,0,3,0,1,12,194,0,0,0,0,0,0,0),('management',196,12,'admin/help/path','admin/help/path','path','a:0:{}','system',-1,0,0,0,0,3,0,1,12,196,0,0,0,0,0,0,0),('management',197,12,'admin/help/rdf','admin/help/rdf','rdf','a:0:{}','system',-1,0,0,0,0,3,0,1,12,197,0,0,0,0,0,0,0),('management',198,12,'admin/help/search','admin/help/search','search','a:0:{}','system',-1,0,0,0,0,3,0,1,12,198,0,0,0,0,0,0,0),('management',199,12,'admin/help/shortcut','admin/help/shortcut','shortcut','a:0:{}','system',-1,0,0,0,0,3,0,1,12,199,0,0,0,0,0,0,0),('management',200,53,'admin/config/search/settings','admin/config/search/settings','Search settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:67:\"Configure relevance settings for search and other indexing options.\";}}','system',0,0,0,0,-10,4,0,1,8,53,200,0,0,0,0,0,0),('management',201,61,'admin/config/user-interface/shortcut','admin/config/user-interface/shortcut','Shortcuts','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:29:\"Add and modify shortcut sets.\";}}','system',0,0,1,0,0,4,0,1,8,61,201,0,0,0,0,0,0),('management',202,53,'admin/config/search/path','admin/config/search/path','URL aliases','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:46:\"Change your site\'s URL paths by aliasing them.\";}}','system',0,0,1,0,-5,4,0,1,8,53,202,0,0,0,0,0,0),('management',203,202,'admin/config/search/path/add','admin/config/search/path/add','Add alias','a:0:{}','system',-1,0,0,0,0,5,0,1,8,53,202,203,0,0,0,0,0),('management',204,201,'admin/config/user-interface/shortcut/add-set','admin/config/user-interface/shortcut/add-set','Add shortcut set','a:0:{}','system',-1,0,0,0,0,5,0,1,8,61,201,204,0,0,0,0,0),('management',205,200,'admin/config/search/settings/reindex','admin/config/search/settings/reindex','Clear index','a:0:{}','system',-1,0,0,0,0,5,0,1,8,53,200,205,0,0,0,0,0),('management',206,201,'admin/config/user-interface/shortcut/%','admin/config/user-interface/shortcut/%','Edit shortcuts','a:0:{}','system',0,0,1,0,0,5,0,1,8,61,201,206,0,0,0,0,0),('management',207,202,'admin/config/search/path/list','admin/config/search/path/list','List','a:0:{}','system',-1,0,0,0,-10,5,0,1,8,53,202,207,0,0,0,0,0),('management',208,206,'admin/config/user-interface/shortcut/%/add-link','admin/config/user-interface/shortcut/%/add-link','Add shortcut','a:0:{}','system',-1,0,0,0,0,6,0,1,8,61,201,206,208,0,0,0,0),('management',209,202,'admin/config/search/path/delete/%','admin/config/search/path/delete/%','Delete alias','a:0:{}','system',0,0,0,0,0,5,0,1,8,53,202,209,0,0,0,0,0),('management',210,206,'admin/config/user-interface/shortcut/%/delete','admin/config/user-interface/shortcut/%/delete','Delete shortcut set','a:0:{}','system',0,0,0,0,0,6,0,1,8,61,201,206,210,0,0,0,0),('management',211,202,'admin/config/search/path/edit/%','admin/config/search/path/edit/%','Edit alias','a:0:{}','system',0,0,0,0,0,5,0,1,8,53,202,211,0,0,0,0,0),('management',212,206,'admin/config/user-interface/shortcut/%/edit','admin/config/user-interface/shortcut/%/edit','Edit set name','a:0:{}','system',-1,0,0,0,10,6,0,1,8,61,201,206,212,0,0,0,0),('management',213,201,'admin/config/user-interface/shortcut/link/%','admin/config/user-interface/shortcut/link/%','Edit shortcut','a:0:{}','system',0,0,1,0,0,5,0,1,8,61,201,213,0,0,0,0,0),('management',214,206,'admin/config/user-interface/shortcut/%/links','admin/config/user-interface/shortcut/%/links','List links','a:0:{}','system',-1,0,0,0,0,6,0,1,8,61,201,206,214,0,0,0,0),('management',215,213,'admin/config/user-interface/shortcut/link/%/delete','admin/config/user-interface/shortcut/link/%/delete','Delete shortcut','a:0:{}','system',0,0,0,0,0,6,0,1,8,61,201,213,215,0,0,0,0),('shortcut-set-1',216,0,'node/add','node/add','Add content','a:0:{}','menu',0,0,0,0,-50,1,0,216,0,0,0,0,0,0,0,0,0),('shortcut-set-1',217,0,'admin/content','admin/content','Find content','a:0:{}','menu',0,0,0,0,-49,1,0,217,0,0,0,0,0,0,0,0,0),('main-menu',218,0,'<front>','','Home','a:0:{}','menu',0,1,0,0,0,1,0,218,0,0,0,0,0,0,0,0,0),('navigation',219,6,'node/add/article','node/add/article','Article','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:89:\"Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.\";}}','system',0,0,0,0,0,2,0,6,219,0,0,0,0,0,0,0,0),('navigation',220,6,'node/add/page','node/add/page','Basic page','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:77:\"Use <em>basic pages</em> for your static content, such as an \'About us\' page.\";}}','system',0,0,0,0,0,2,0,6,220,0,0,0,0,0,0,0,0),('management',308,8,'admin/config/administration','admin/config/administration','Administration','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:21:\"Administration tools.\";}}','system',0,0,1,0,0,3,0,1,8,308,0,0,0,0,0,0,0),('management',309,12,'admin/help/admin_menu','admin/help/admin_menu','admin_menu','a:0:{}','system',-1,0,0,0,0,3,0,1,12,309,0,0,0,0,0,0,0),('management',310,12,'admin/help/syslog','admin/help/syslog','syslog','a:0:{}','system',-1,0,0,0,0,3,0,1,12,310,0,0,0,0,0,0,0),('management',311,308,'admin/config/administration/admin_menu','admin/config/administration/admin_menu','Administration menu','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:36:\"Adjust administration menu settings.\";}}','system',0,0,0,0,0,4,0,1,8,308,311,0,0,0,0,0,0),('navigation',312,0,'ctools_ajax_sample','ctools_ajax_sample','Chaos Tools AJAX Demo','a:0:{}','system',0,0,1,0,0,1,0,312,0,0,0,0,0,0,0,0,0),('navigation',313,312,'ctools_ajax_sample/jumped','ctools_ajax_sample/jumped','Successful Jumping','a:0:{}','system',0,0,0,0,0,2,0,312,313,0,0,0,0,0,0,0,0),('management',314,61,'admin/config/user-interface/modulefilter','admin/config/user-interface/modulefilter','Module filter','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"Configure settings for Module Filter.\";}}','system',0,0,0,0,0,4,0,1,8,61,314,0,0,0,0,0,0),('management',336,21,'admin/structure/views','admin/structure/views','Views','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:35:\"Manage customized lists of content.\";}}','system',0,0,1,0,0,3,0,1,21,336,0,0,0,0,0,0,0),('management',337,19,'admin/reports/views-plugins','admin/reports/views-plugins','Views plugins','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Overview of plugins used in all views.\";}}','system',0,0,0,0,0,3,0,1,19,337,0,0,0,0,0,0,0),('management',338,336,'admin/structure/views/import','admin/structure/views/import','Import','a:0:{}','system',-1,0,0,0,0,4,0,1,21,336,338,0,0,0,0,0,0),('management',339,336,'admin/structure/views/list','admin/structure/views/list','List','a:0:{}','system',-1,0,0,0,-10,4,0,1,21,336,339,0,0,0,0,0,0),('management',340,336,'admin/structure/views/settings','admin/structure/views/settings','Settings','a:0:{}','system',-1,0,0,0,0,4,0,1,21,336,340,0,0,0,0,0,0),('management',341,336,'admin/structure/views/add','admin/structure/views/add','Add new view','a:0:{}','system',-1,0,0,0,0,4,0,1,21,336,341,0,0,0,0,0,0),('management',342,336,'admin/structure/views/add-template','admin/structure/views/add-template','Add view from template','a:0:{}','system',-1,0,0,0,0,4,0,1,21,336,342,0,0,0,0,0,0),('management',343,42,'admin/reports/fields/list','admin/reports/fields/list','List','a:0:{}','system',-1,0,0,0,-10,4,0,1,19,42,343,0,0,0,0,0,0),('management',344,42,'admin/reports/fields/views-fields','admin/reports/fields/views-fields','Used in views','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"Overview of fields used in all views.\";}}','system',-1,0,0,0,0,4,0,1,19,42,344,0,0,0,0,0,0),('management',345,340,'admin/structure/views/settings/advanced','admin/structure/views/settings/advanced','Advanced','a:0:{}','system',-1,0,0,0,1,5,0,1,21,336,340,345,0,0,0,0,0),('management',346,340,'admin/structure/views/settings/basic','admin/structure/views/settings/basic','Basic','a:0:{}','system',-1,0,0,0,0,5,0,1,21,336,340,346,0,0,0,0,0),('management',347,336,'admin/structure/views/view/%','admin/structure/views/view/%','','a:0:{}','system',0,0,0,0,0,4,0,1,21,336,347,0,0,0,0,0,0),('management',348,347,'admin/structure/views/view/%/break-lock','admin/structure/views/view/%/break-lock','Break lock','a:0:{}','system',-1,0,0,0,0,5,0,1,21,336,347,348,0,0,0,0,0),('management',349,347,'admin/structure/views/view/%/edit','admin/structure/views/view/%/edit','Edit view','a:0:{}','system',-1,0,0,0,-10,5,0,1,21,336,347,349,0,0,0,0,0),('management',350,347,'admin/structure/views/view/%/clone','admin/structure/views/view/%/clone','Clone','a:0:{}','system',-1,0,0,0,0,5,0,1,21,336,347,350,0,0,0,0,0),('management',351,347,'admin/structure/views/view/%/delete','admin/structure/views/view/%/delete','Delete','a:0:{}','system',-1,0,0,0,0,5,0,1,21,336,347,351,0,0,0,0,0),('management',352,347,'admin/structure/views/view/%/export','admin/structure/views/view/%/export','Export','a:0:{}','system',-1,0,0,0,0,5,0,1,21,336,347,352,0,0,0,0,0),('management',353,347,'admin/structure/views/view/%/revert','admin/structure/views/view/%/revert','Revert','a:0:{}','system',-1,0,0,0,0,5,0,1,21,336,347,353,0,0,0,0,0),('management',354,336,'admin/structure/views/nojs/preview/%/%','admin/structure/views/nojs/preview/%/%','','a:0:{}','system',0,0,0,0,0,4,0,1,21,336,354,0,0,0,0,0,0),('management',355,347,'admin/structure/views/view/%/preview/%','admin/structure/views/view/%/preview/%','','a:0:{}','system',-1,0,0,0,0,5,0,1,21,336,347,355,0,0,0,0,0),('management',356,336,'admin/structure/views/ajax/preview/%/%','admin/structure/views/ajax/preview/%/%','','a:0:{}','system',0,0,0,0,0,4,0,1,21,336,356,0,0,0,0,0,0),('navigation',358,6,'node/add/vcenter','node/add/vcenter','vCenter','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:15:\"Add new vCenter\";}}','system',0,0,0,0,0,2,0,6,358,0,0,0,0,0,0,0,0),('navigation',359,6,'node/add/data-center','node/add/data-center','Data Center','a:0:{}','system',0,0,0,0,0,2,0,6,359,0,0,0,0,0,0,0,0),('navigation',360,6,'node/add/virtual-machine','node/add/virtual-machine','Virtual Machine','a:0:{}','system',0,0,0,0,0,2,0,6,360,0,0,0,0,0,0,0,0),('management',361,12,'admin/help/unique_field','admin/help/unique_field','unique_field','a:0:{}','system',-1,0,0,0,0,3,0,1,12,361,0,0,0,0,0,0,0),('management',362,54,'admin/appearance/settings/mercury','admin/appearance/settings/mercury','Mercury','a:0:{}','system',-1,0,0,0,0,4,0,1,7,54,362,0,0,0,0,0,0),('management',363,30,'admin/structure/block/list/mercury','admin/structure/block/list/mercury','Mercury','a:0:{}','system',-1,0,0,0,-10,4,0,1,21,30,363,0,0,0,0,0,0),('management',365,131,'admin/structure/block/list/bartik/add','admin/structure/block/list/bartik/add','Add block','a:0:{}','system',-1,0,0,0,0,5,0,1,21,30,131,365,0,0,0,0,0),('management',366,12,'admin/help/php','admin/help/php','php','a:0:{}','system',-1,0,0,0,0,3,0,1,12,366,0,0,0,0,0,0,0),('navigation',367,6,'node/add/host','node/add/host','Host','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:29:\"An ESXi 5.0 host on a vCenter\";}}','system',0,0,0,0,0,2,0,6,367,0,0,0,0,0,0,0,0),('navigation',368,6,'node/add/device','node/add/device','Device','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:42:\"A physical hard drive available to a host.\";}}','system',0,0,0,0,0,2,0,6,368,0,0,0,0,0,0,0,0),('navigation',369,6,'node/add/vdisk','node/add/vdisk','vDisk','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"A virtual disk that is located on a VM\";}}','system',0,0,0,0,0,2,0,6,369,0,0,0,0,0,0,0,0),('management',372,21,'admin/structure/ctools-content','admin/structure/ctools-content','Custom content panes','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:41:\"Add, edit or delete custom content panes.\";}}','system',0,0,0,0,0,3,0,1,21,372,0,0,0,0,0,0,0),('management',373,21,'admin/structure/mini-panels','admin/structure/mini-panels','Mini panels','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:94:\"Add, edit or delete mini panels, which can be used as blocks or content panes in other panels.\";}}','system',0,0,0,0,0,3,0,1,21,373,0,0,0,0,0,0,0),('navigation',374,6,'node/add/panel','node/add/panel','Panel','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:47:\"A panel layout broken up into rows and columns.\";}}','system',0,0,0,0,0,2,0,6,374,0,0,0,0,0,0,0,0),('navigation',375,5,'node/%/panel_content','node/%/panel_content','Panel content','a:0:{}','system',-1,0,0,0,3,2,0,5,375,0,0,0,0,0,0,0,0),('navigation',376,5,'node/%/panel_layout','node/%/panel_layout','Panel layout','a:0:{}','system',-1,0,0,0,2,2,0,5,376,0,0,0,0,0,0,0,0),('management',377,21,'admin/structure/panels','admin/structure/panels','Panels','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:49:\"Get a bird\'s eye view of items related to Panels.\";}}','system',0,0,0,0,0,3,0,1,21,377,0,0,0,0,0,0,0),('management',378,372,'admin/structure/ctools-content/add','admin/structure/ctools-content/add','Add','a:0:{}','system',-1,0,0,0,0,4,0,1,21,372,378,0,0,0,0,0,0),('management',379,373,'admin/structure/mini-panels/add','admin/structure/mini-panels/add','Add','a:0:{}','system',-1,0,0,0,0,4,0,1,21,373,379,0,0,0,0,0,0),('management',380,377,'admin/structure/panels/dashboard','admin/structure/panels/dashboard','Dashboard','a:0:{}','system',-1,0,0,0,-10,4,0,1,21,377,380,0,0,0,0,0,0),('management',381,372,'admin/structure/ctools-content/import','admin/structure/ctools-content/import','Import','a:0:{}','system',-1,0,0,0,0,4,0,1,21,372,381,0,0,0,0,0,0),('management',382,373,'admin/structure/mini-panels/import','admin/structure/mini-panels/import','Import','a:0:{}','system',-1,0,0,0,0,4,0,1,21,373,382,0,0,0,0,0,0),('management',384,372,'admin/structure/ctools-content/list','admin/structure/ctools-content/list','List','a:0:{}','system',-1,0,0,0,-10,4,0,1,21,372,384,0,0,0,0,0,0),('management',385,373,'admin/structure/mini-panels/list','admin/structure/mini-panels/list','List','a:0:{}','system',-1,0,0,0,-10,4,0,1,21,373,385,0,0,0,0,0,0),('management',386,377,'admin/structure/panels/settings','admin/structure/panels/settings','Settings','a:0:{}','system',-1,0,0,0,0,4,0,1,21,377,386,0,0,0,0,0,0),('management',387,373,'admin/structure/mini-panels/settings','admin/structure/mini-panels/settings','Settings','a:0:{}','system',-1,0,0,0,0,4,0,1,21,373,387,0,0,0,0,0,0),('management',389,386,'admin/structure/panels/settings/general','admin/structure/panels/settings/general','General','a:0:{}','system',-1,0,0,0,-10,5,0,1,21,377,386,389,0,0,0,0,0),('management',392,386,'admin/structure/panels/settings/panels-mini','admin/structure/panels/settings/panels-mini','Mini panels','a:0:{}','system',-1,0,0,0,0,5,0,1,21,377,386,392,0,0,0,0,0),('management',393,386,'admin/structure/panels/settings/panel-node','admin/structure/panels/settings/panel-node','Panel nodes','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:67:\"Configure which content is available to add to panel node displays.\";}}','system',-1,0,0,0,0,5,0,1,21,377,386,393,0,0,0,0,0),('management',394,384,'admin/structure/ctools-content/list/%/edit','admin/structure/ctools-content/list/%/edit','Edit','a:0:{}','system',-1,0,0,0,-10,5,0,1,21,372,384,394,0,0,0,0,0),('management',395,385,'admin/structure/mini-panels/list/%/edit','admin/structure/mini-panels/list/%/edit','Edit','a:0:{}','system',-1,0,0,0,-10,5,0,1,21,373,385,395,0,0,0,0,0),('management',396,384,'admin/structure/ctools-content/list/%/export','admin/structure/ctools-content/list/%/export','Export','a:0:{}','system',-1,0,0,0,0,5,0,1,21,372,384,396,0,0,0,0,0),('management',397,385,'admin/structure/mini-panels/list/%/export','admin/structure/mini-panels/list/%/export','Export','a:0:{}','system',-1,0,0,0,0,5,0,1,21,373,385,397,0,0,0,0,0),('management',400,21,'admin/structure/pages','admin/structure/pages','Pages','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:84:\"Add, edit and remove overridden system pages and user defined pages from the system.\";}}','system',0,0,1,0,0,3,0,1,21,400,0,0,0,0,0,0,0),('management',401,400,'admin/structure/pages/add','admin/structure/pages/add','Add custom page','a:0:{}','system',-1,0,0,0,0,4,0,1,21,400,401,0,0,0,0,0,0),('management',402,400,'admin/structure/pages/import','admin/structure/pages/import','Import page','a:0:{}','system',-1,0,0,0,0,4,0,1,21,400,402,0,0,0,0,0,0),('management',403,400,'admin/structure/pages/list','admin/structure/pages/list','List','a:0:{}','system',-1,0,0,0,-10,4,0,1,21,400,403,0,0,0,0,0,0),('management',404,400,'admin/structure/pages/wizard','admin/structure/pages/wizard','Wizards','a:0:{}','system',-1,0,0,0,-5,4,0,1,21,400,404,0,0,0,0,0,0),('management',405,400,'admin/structure/pages/edit/%','admin/structure/pages/edit/%','Edit','a:0:{}','system',0,0,0,0,0,4,0,1,21,400,405,0,0,0,0,0,0),('management',406,386,'admin/structure/panels/settings/panel-page','admin/structure/panels/settings/panel-page','Panel pages','a:0:{}','system',-1,0,0,0,-10,5,0,1,21,377,386,406,0,0,0,0,0),('management',407,400,'admin/structure/pages/%/operation/%','admin/structure/pages/%/operation/%','','a:0:{}','system',0,0,0,0,0,4,0,1,21,400,407,0,0,0,0,0,0),('management',408,47,'admin/structure/menu/manage/menu-mercury-navigation','admin/structure/menu/manage/%','Navigation','a:0:{}','menu',0,0,0,0,0,4,0,1,21,47,408,0,0,0,0,0,0),('menu-mercury-navigation',409,0,'<front>','','Home Page','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:39:\"This links to the home page of the site\";}}','menu',0,1,0,0,-50,1,1,409,0,0,0,0,0,0,0,0,0),('menu-mercury-navigation',410,0,'vm-inventory','vm-inventory','VM Inventory','a:1:{s:10:\"attributes\";a:0:{}}','menu',0,0,0,0,-48,1,1,410,0,0,0,0,0,0,0,0,0),('menu-mercury-navigation',411,0,'config/mercury/settings','config/mercury/settings','Console Settings','a:1:{s:10:\"attributes\";a:0:{}}','menu',0,0,0,0,-44,1,1,411,0,0,0,0,0,0,0,0,0),('menu-mercury-navigation',412,0,'host-directory','host-directory','Host Inventory','a:1:{s:10:\"attributes\";a:0:{}}','menu',0,0,0,0,-49,1,1,412,0,0,0,0,0,0,0,0,0),('menu-mercury-navigation',413,0,'analytics','analytics','Analytics','a:1:{s:10:\"attributes\";a:0:{}}','menu',0,0,0,0,-47,1,1,413,0,0,0,0,0,0,0,0,0),('management',414,47,'admin/structure/menu/manage/menu-selector-tool','admin/structure/menu/manage/%','Selector Tool','a:0:{}','menu',0,0,0,0,0,4,0,1,21,47,414,0,0,0,0,0,0),('menu-selector-tool',415,0,'<front>','','Virtual Disk','a:1:{s:10:\"attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:18:\"selector-tool-item\";i:1;s:24:\"selector-tool-item-vdisk\";}}}','menu',0,1,0,0,-48,1,1,415,0,0,0,0,0,0,0,0,0),('management',418,47,'admin/structure/menu/manage/menu-bulk-action-tool','admin/structure/menu/manage/%','Bulk Action Tool','a:0:{}','menu',0,0,0,0,0,4,0,1,21,47,418,0,0,0,0,0,0),('menu-bulk-action-tool',419,0,'<front>','','Action','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,1,0,0,0,1,1,419,0,0,0,0,0,0,0,0,0),('menu-bulk-action-tool',420,0,'<front>','','Action','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,1,0,0,0,1,1,420,0,0,0,0,0,0,0,0,0),('menu-bulk-action-tool',421,0,'<front>','','Action','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,1,0,0,0,1,1,421,0,0,0,0,0,0,0,0,0),('navigation',423,0,'ctools-popups/%/webservice/cacheinfo/%','ctools-popups/%/webservice/cacheinfo/%','','a:0:{}','system',0,0,0,0,0,1,0,423,0,0,0,0,0,0,0,0,0),('management',842,12,'admin/help/coder_review','admin/help/coder_review','coder_review','a:0:{}','system',-1,0,0,0,0,3,0,1,12,842,0,0,0,0,0,0,0),('management',425,39,'admin/config/development/coder','admin/config/development/coder','Coder','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:58:\"Select code review plugins and modules, and upgrade files.\";}}','system',0,0,0,0,0,4,0,1,8,39,425,0,0,0,0,0,0),('management',843,425,'admin/config/development/coder/review','admin/config/development/coder/review','Review','a:0:{}','system',-1,0,0,0,-2,5,0,1,8,39,425,843,0,0,0,0,0),('management',844,843,'admin/config/development/coder/review/active','admin/config/development/coder/review/active','Active','a:0:{}','system',-1,0,0,0,0,6,0,1,8,39,425,843,844,0,0,0,0),('management',845,843,'admin/config/development/coder/review/all','admin/config/development/coder/review/all','All','a:0:{}','system',-1,0,0,0,1,6,0,1,8,39,425,843,845,0,0,0,0),('management',846,843,'admin/config/development/coder/review/core','admin/config/development/coder/review/core','Core','a:0:{}','system',-1,0,0,0,0,6,0,1,8,39,425,843,846,0,0,0,0),('management',847,843,'admin/config/development/coder/review/default','admin/config/development/coder/review/default','Default','a:0:{}','system',-1,0,0,0,-1,6,0,1,8,39,425,843,847,0,0,0,0),('management',848,843,'admin/config/development/coder/review/files','admin/config/development/coder/review/files','Files','a:0:{}','system',-1,0,0,0,2,6,0,1,8,39,425,843,848,0,0,0,0),('management',849,843,'admin/config/development/coder/review/patches','admin/config/development/coder/review/patches','Patches','a:0:{}','system',-1,0,0,0,3,6,0,1,8,39,425,843,849,0,0,0,0),('management',850,843,'admin/config/development/coder/review/select','admin/config/development/coder/review/select','Select','a:0:{}','system',-1,0,0,0,-2,6,0,1,8,39,425,843,850,0,0,0,0),('management',851,843,'admin/config/development/coder/review/settings','admin/config/development/coder/review/settings','Settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Select code review plugins and modules\";}}','system',-1,0,0,0,3,6,0,1,8,39,425,843,851,0,0,0,0),('management',473,12,'admin/help/logintoboggan','admin/help/logintoboggan','logintoboggan','a:0:{}','system',-1,0,0,0,0,3,0,1,12,473,0,0,0,0,0,0,0),('management',474,56,'admin/config/system/logintoboggan','admin/config/system/logintoboggan','LoginToboggan','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:102:\"Set up custom login options like instant login, login redirects, pre-authorized validation roles, etc.\";}}','system',0,0,0,0,0,4,0,1,8,56,474,0,0,0,0,0,0),('navigation',476,0,'ctools-popups/%/node/hostinfo/%','ctools-popups/%/node/hostinfo/%','','a:0:{}','system',0,0,0,0,0,1,0,476,0,0,0,0,0,0,0,0,0),('management',477,12,'admin/help/pathauto','admin/help/pathauto','pathauto','a:0:{}','system',-1,0,0,0,0,3,0,1,12,477,0,0,0,0,0,0,0),('management',478,12,'admin/help/token','admin/help/token','token','a:0:{}','system',-1,0,0,0,0,3,0,1,12,478,0,0,0,0,0,0,0),('management',479,202,'admin/config/search/path/update_bulk','admin/config/search/path/update_bulk','Bulk update','a:0:{}','system',-1,0,0,0,30,5,0,1,8,53,202,479,0,0,0,0,0),('management',480,202,'admin/config/search/path/delete_bulk','admin/config/search/path/delete_bulk','Delete aliases','a:0:{}','system',-1,0,0,0,40,5,0,1,8,53,202,480,0,0,0,0,0),('management',481,202,'admin/config/search/path/patterns','admin/config/search/path/patterns','Patterns','a:0:{}','system',-1,0,0,0,10,5,0,1,8,53,202,481,0,0,0,0,0),('management',482,202,'admin/config/search/path/settings','admin/config/search/path/settings','Settings','a:0:{}','system',-1,0,0,0,20,5,0,1,8,53,202,482,0,0,0,0,0),('menu-selector-tool',487,0,'host','host','Host','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','system',0,0,0,0,-50,1,1,487,0,0,0,0,0,0,0,0,0),('menu-selector-tool',488,0,'host-directory','host-directory','Host','a:1:{s:10:\"attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:18:\"selector-tool-item\";i:1;s:23:\"selector-tool-item-host\";}}}','system',0,0,0,0,-50,1,1,488,0,0,0,0,0,0,0,0,0),('menu-selector-tool',489,0,'vm-directory','vm-directory','VM','a:1:{s:10:\"attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:18:\"selector-tool-item\";i:1;s:21:\"selector-tool-item-vm\";}}}','system',0,0,0,0,-49,1,1,489,0,0,0,0,0,0,0,0,0),('management',491,12,'admin/help/login_destination','admin/help/login_destination','login_destination','a:0:{}','system',-1,0,0,0,0,3,0,1,12,491,0,0,0,0,0,0,0),('management',492,48,'admin/config/people/login-destination','admin/config/people/login-destination','Login destinations','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:69:\"Customize the destination that the user is redirected to after login.\";}}','system',0,0,1,0,10,4,0,1,8,48,492,0,0,0,0,0,0),('management',493,492,'admin/config/people/login-destination/add','admin/config/people/login-destination/add','Add login destination rule','a:0:{}','system',-1,0,0,0,1,5,0,1,8,48,492,493,0,0,0,0,0),('management',494,492,'admin/config/people/login-destination/list','admin/config/people/login-destination/list','List','a:0:{}','system',-1,0,0,0,-10,5,0,1,8,48,492,494,0,0,0,0,0),('management',495,492,'admin/config/people/login-destination/settings','admin/config/people/login-destination/settings','Settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"Change Login Destination settings.\";}}','system',-1,0,0,0,10,5,0,1,8,48,492,495,0,0,0,0,0),('management',496,492,'admin/config/people/login-destination/delete/%','admin/config/people/login-destination/delete/%','Delete login destination rule','a:0:{}','system',0,0,0,0,0,5,0,1,8,48,492,496,0,0,0,0,0),('management',497,492,'admin/config/people/login-destination/edit/%','admin/config/people/login-destination/edit/%','Edit login destination rule','a:0:{}','system',0,0,0,0,0,5,0,1,8,48,492,497,0,0,0,0,0),('navigation',498,6,'node/add/vm-metrics','node/add/vm-metrics','VM metrics','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"Stores the metrics data of VMs.\";}}','system',0,0,0,0,0,2,0,6,498,0,0,0,0,0,0,0,0),('management',499,47,'admin/structure/menu/manage/menu-refine','admin/structure/menu/manage/%','Refine','a:0:{}','menu',0,0,0,0,0,4,0,1,21,47,499,0,0,0,0,0,0),('menu-refine',500,0,'<front>','','Flash Accel Installed','a:1:{s:10:\"attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:33:\"refine-item-flash-accel-installed\";i:1;s:23:\"refine-item-flash-accel\";}}}','menu',0,1,0,0,-50,1,1,500,0,0,0,0,0,0,0,0,0),('menu-refine',501,0,'<front>','','Flash Accel Not Installed','a:1:{s:10:\"attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:20:\"refine-item-no-flash\";i:1;s:23:\"refine-item-flash-accel\";}}}','menu',0,1,0,0,-49,1,1,501,0,0,0,0,0,0,0,0,0),('navigation',503,0,'ctools-popups/%/device/settings/%','ctools-popups/%/device/settings/%','','a:0:{}','system',0,0,0,0,0,1,0,503,0,0,0,0,0,0,0,0,0),('navigation',505,0,'ctools-popups/%/node/vdiskinfo/%','ctools-popups/%/node/vdiskinfo/%','','a:0:{}','system',0,0,0,0,0,1,0,505,0,0,0,0,0,0,0,0,0),('navigation',511,0,'ctools-popups/%/host/settings/install/%','ctools-popups/%/host/settings/install/%','','a:0:{}','system',0,0,0,0,0,1,0,511,0,0,0,0,0,0,0,0,0),('navigation',512,0,'ctools-popups/%/host/settings/uninstall/%','ctools-popups/%/host/settings/uninstall/%','','a:0:{}','system',0,0,0,0,0,1,0,512,0,0,0,0,0,0,0,0,0),('menu-selector-tool',513,0,'<front>','','Unselect All','a:1:{s:10:\"attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:18:\"selector-tool-item\";i:1;s:31:\"selector-tool-item-unselect-all\";}}}','menu',0,1,0,0,0,1,1,513,0,0,0,0,0,0,0,0,0),('navigation',514,6,'node/add/vdisk-metrics','node/add/vdisk-metrics','vDisk metrics','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:28:\"The metrics from the vDisks.\";}}','system',0,0,0,0,0,2,0,6,514,0,0,0,0,0,0,0,0),('menu-mercury-navigation',515,0,'ongoing-processes','ongoing-processes','Ongoing Processes','a:1:{s:10:\"attributes\";a:0:{}}','menu',1,0,0,0,-46,1,1,515,0,0,0,0,0,0,0,0,0),('management',519,8,'admin/config/date','admin/config/date','Date API','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:42:\"Settings for modules the use the Date API.\";}}','system',0,0,1,0,-10,3,0,1,8,519,0,0,0,0,0,0,0),('management',520,12,'admin/help/date','admin/help/date','date','a:0:{}','system',-1,0,0,0,0,3,0,1,12,520,0,0,0,0,0,0,0),('management',521,519,'admin/config/date/date_popup','admin/config/date/date_popup','Date Popup','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"Configure the Date Popup settings.\";}}','system',0,0,0,0,0,4,0,1,8,519,521,0,0,0,0,0,0),('menu-refine',522,0,'<front>','','Caching Enabled','a:1:{s:10:\"attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:27:\"refine-item-caching-enabled\";i:1;s:19:\"refine-item-caching\";}}}','menu',0,1,0,0,-48,1,1,522,0,0,0,0,0,0,0,0,0),('menu-refine',523,0,'<front>','','Caching  Disabled','a:1:{s:10:\"attributes\";a:1:{s:5:\"class\";a:2:{i:0;s:29:\"refine-item-caching-disaabled\";i:1;s:19:\"refine-item-caching\";}}}','menu',0,1,0,0,-47,1,1,523,0,0,0,0,0,0,0,0,0),('navigation',525,0,'ctools-popups/%/host/settings/upgrade/%','ctools-popups/%/host/settings/upgrade/%','','a:0:{}','system',0,0,0,0,0,1,0,525,0,0,0,0,0,0,0,0,0),('navigation',527,0,'ctools-popups/%/vm/settings/%/%','ctools-popups/%/vm/settings/%/%','','a:0:{}','system',0,0,1,0,0,1,0,527,0,0,0,0,0,0,0,0,0),('navigation',529,0,'ctools-popups/%/node/deviceinfo/%','ctools-popups/%/node/deviceinfo/%','','a:0:{}','system',0,0,0,0,0,1,0,529,0,0,0,0,0,0,0,0,0),('navigation',530,527,'ctools-popups/%/vm/settings/%/%/%','ctools-popups/%/vm/settings/%/%/%','','a:0:{}','system',0,0,0,0,0,2,0,527,530,0,0,0,0,0,0,0,0),('navigation',533,0,'ctools-popups/%/host/settings/assign/%','ctools-popups/%/host/settings/assign/%','','a:0:{}','system',0,0,0,0,0,1,0,533,0,0,0,0,0,0,0,0,0),('navigation',535,0,'ctools-popups/%/vm/refresh/%','ctools-popups/%/vm/refresh/%','','a:0:{}','system',0,0,0,0,0,1,0,535,0,0,0,0,0,0,0,0,0),('navigation',536,0,'ctools-popups/%/host/refresh/%','ctools-popups/%/host/refresh/%','','a:0:{}','system',0,0,0,0,0,1,0,536,0,0,0,0,0,0,0,0,0),('shortcut-set-1',629,0,'node/2984/edit?destination=admin/content','node/%','hg-fmc-test-1','a:0:{}','menu',0,0,0,0,-48,1,0,629,0,0,0,0,0,0,0,0,0),('shortcut-set-1',630,0,'admin/structure/block/manage/block/2/configure?destination=home','admin/structure/block/manage/%/%','Configure block','a:0:{}','menu',0,0,0,0,-47,1,0,630,0,0,0,0,0,0,0,0,0),('navigation',675,0,'ctools-popups/%/host/settings/initialize/%','ctools-popups/%/host/settings/initialize/%','','a:0:{}','system',0,0,0,0,0,1,0,675,0,0,0,0,0,0,0,0,0),('navigation',676,0,'ctools-popups/%/host/settings/unassign/%','ctools-popups/%/host/settings/unassign/%','','a:0:{}','system',0,0,0,0,0,1,0,676,0,0,0,0,0,0,0,0,0),('navigation',677,0,'ctools-popups/%/vdisk/settings/%/%/%','ctools-popups/%/vdisk/settings/%/%/%','','a:0:{}','system',0,0,0,0,0,1,0,677,0,0,0,0,0,0,0,0,0),('navigation',678,0,'ctools-popups/%/host/settings/edit/%','ctools-popups/%/host/settings/edit/%','','a:0:{}','system',0,0,0,0,0,1,0,678,0,0,0,0,0,0,0,0,0),('navigation',682,0,'virtual_machine/%/historical_performance','virtual_machine/%/historical_performance','Historical performance','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"The historical performance page for VM nodes.\";}}','system',0,0,0,0,0,1,0,682,0,0,0,0,0,0,0,0,0),('navigation',683,0,'ctools-popups/%/vm/settings/allocate/%','ctools-popups/%/vm/settings/allocate/%','','a:0:{}','system',0,0,0,0,0,1,0,683,0,0,0,0,0,0,0,0,0),('menu-mercury-navigation',861,0,'config/fmc/settings','config/fmc/settings','Console Settings','a:1:{s:10:\"attributes\";a:0:{}}','menu',0,0,0,0,-45,1,1,861,0,0,0,0,0,0,0,0,0),('navigation',879,0,'discovery/get_discovery_status','discovery/get_discovery_status','','a:0:{}','system',0,0,0,0,0,1,0,879,0,0,0,0,0,0,0,0,0),('navigation',696,0,'ctools-popups/%/vm/settings/advance/%','ctools-popups/%/vm/settings/advance/%','','a:0:{}','system',0,0,0,0,0,1,0,696,0,0,0,0,0,0,0,0,0),('navigation',697,0,'analytics','analytics','Analytics','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:56:\"Form for viewing performance analytics of VMs and Hosts.\";}}','system',0,0,1,0,0,1,0,697,0,0,0,0,0,0,0,0,0),('navigation',698,0,'ctools-popups/%/bulk/host/%','ctools-popups/%/bulk/host/%','','a:0:{}','system',0,0,0,0,0,1,0,698,0,0,0,0,0,0,0,0,0),('navigation',699,0,'ctools-popups/%/bulk/vm/%','ctools-popups/%/bulk/vm/%','','a:0:{}','system',0,0,0,0,0,1,0,699,0,0,0,0,0,0,0,0,0),('management',706,12,'admin/help/views_watchdog','admin/help/views_watchdog','views_watchdog','a:0:{}','system',-1,0,0,0,0,3,0,1,12,706,0,0,0,0,0,0,0),('menu-mercury-navigation',708,0,'console-logs-report','console-logs-report','Console Logs','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:19:\"Console Logs Report\";}}','system',0,0,0,0,-44,1,1,708,0,0,0,0,0,0,0,0,0),('navigation',711,6,'node/add/vm-cache-space','node/add/vm-cache-space','VM Cache Space','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:56:\"Stores all the details related to Cache Space for any VM\";}}','system',0,0,0,0,0,2,0,6,711,0,0,0,0,0,0,0,0),('navigation',712,697,'analytics/view','analytics/view','Analytics','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:44:\"View performance analytics of VMs and Hosts.\";}}','system',0,0,0,0,0,2,0,697,712,0,0,0,0,0,0,0,0),('management',714,8,'admin/config/famc_analytics/clear_metrics','admin/config/famc_analytics/clear_metrics','Clear Flash Accel metrics','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:23:\"Clears all metric data.\";}}','system',0,0,0,0,0,3,0,1,8,714,0,0,0,0,0,0,0),('navigation',757,0,'webservices/HgGetCacheInfo','webservices/HgGetCacheInfo','Get Cache Info','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:14:\"Get Cache Info\";}}','system',0,0,0,0,0,1,0,757,0,0,0,0,0,0,0,0,0),('navigation',758,0,'view/virtual-machines','view/virtual-machines','View Virtual Machines','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:21:\"View Virtual Machines\";}}','system',0,0,0,0,0,1,0,758,0,0,0,0,0,0,0,0,0),('navigation',759,0,'webservices/list','webservices/list','Web Services','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:12:\"Web Services\";}}','system',0,0,0,0,0,1,0,759,0,0,0,0,0,0,0,0,0),('navigation',760,0,'host/devices/%','host/devices/%','All Devices','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:11:\"All Devices\";}}','system',0,0,0,0,0,1,0,760,0,0,0,0,0,0,0,0,0),('management',761,53,'admin/config/search/search_api','admin/config/search/search_api','Search API','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:36:\"Create and configure search engines.\";}}','system',0,0,1,0,0,4,0,1,8,53,761,0,0,0,0,0,0),('management',762,761,'admin/config/search/search_api/add_index','admin/config/search/search_api/add_index','Add index','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:26:\"Create a new search index.\";}}','system',-1,0,0,0,0,5,0,1,8,53,761,762,0,0,0,0,0),('management',763,761,'admin/config/search/search_api/add_server','admin/config/search/search_api/add_server','Add server','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:27:\"Create a new search server.\";}}','system',-1,0,0,0,-1,5,0,1,8,53,761,763,0,0,0,0,0),('management',764,761,'admin/config/search/search_api/overview','admin/config/search/search_api/overview','Overview','a:0:{}','system',-1,0,0,0,-10,5,0,1,8,53,761,764,0,0,0,0,0),('management',765,761,'admin/config/search/search_api/index/%','admin/config/search/search_api/index/%','View index','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:19:\"View index details.\";}}','system',0,0,0,0,0,5,0,1,8,53,761,765,0,0,0,0,0),('management',766,761,'admin/config/search/search_api/server/%','admin/config/search/search_api/server/%','View server','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"View server details.\";}}','system',0,0,0,0,0,5,0,1,8,53,761,766,0,0,0,0,0),('management',767,765,'admin/config/search/search_api/index/%/delete','admin/config/search/search_api/index/%/delete','Delete','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:13:\"Delete index.\";}}','system',-1,0,0,0,0,6,0,1,8,53,761,765,767,0,0,0,0),('management',768,766,'admin/config/search/search_api/server/%/delete','admin/config/search/search_api/server/%/delete','Delete','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:14:\"Delete server.\";}}','system',-1,0,0,0,0,6,0,1,8,53,761,766,768,0,0,0,0),('management',769,766,'admin/config/search/search_api/server/%/edit','admin/config/search/search_api/server/%/edit','Edit','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"Edit server details.\";}}','system',-1,0,0,0,-1,6,0,1,8,53,761,766,769,0,0,0,0),('management',770,765,'admin/config/search/search_api/index/%/fields','admin/config/search/search_api/index/%/fields','Fields','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:22:\"Select indexed fields.\";}}','system',-1,0,0,0,-4,6,0,1,8,53,761,765,770,0,0,0,0),('management',771,765,'admin/config/search/search_api/index/%/edit','admin/config/search/search_api/index/%/edit','Settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"Edit index settings.\";}}','system',-1,0,0,0,-6,6,0,1,8,53,761,765,771,0,0,0,0),('management',772,765,'admin/config/search/search_api/index/%/status','admin/config/search/search_api/index/%/status','Status','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Display and work on index status.\";}}','system',-1,0,0,0,-8,6,0,1,8,53,761,765,772,0,0,0,0),('management',773,765,'admin/config/search/search_api/index/%/view','admin/config/search/search_api/index/%/view','View','a:0:{}','system',-1,0,0,0,-10,6,0,1,8,53,761,765,773,0,0,0,0),('management',774,766,'admin/config/search/search_api/server/%/view','admin/config/search/search_api/server/%/view','View','a:0:{}','system',-1,0,0,0,-10,6,0,1,8,53,761,766,774,0,0,0,0),('management',775,765,'admin/config/search/search_api/index/%/workflow','admin/config/search/search_api/index/%/workflow','Workflow','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"Edit index workflow.\";}}','system',-1,0,0,0,-2,6,0,1,8,53,761,765,775,0,0,0,0),('management',776,761,'admin/config/search/search_api/page','admin/config/search/search_api/page','Search pages','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"Create and configure search pages.\";}}','system',-1,0,1,0,0,5,0,1,8,53,761,776,0,0,0,0,0),('management',777,776,'admin/config/search/search_api/page/add','admin/config/search/search_api/page/add','Add search page','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:22:\"Add a new search page.\";}}','system',-1,0,0,0,0,6,0,1,8,53,761,776,777,0,0,0,0),('management',778,776,'admin/config/search/search_api/page/%','admin/config/search/search_api/page/%','Edit search page','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"Configure or delete a search page.\";}}','system',0,0,0,0,0,6,0,1,8,53,761,776,778,0,0,0,0),('navigation',779,0,'fmc-search','fmc-search','Search','a:0:{}','system',1,0,0,0,0,1,0,779,0,0,0,0,0,0,0,0,0),('management',780,8,'admin/config/clear_variables','admin/config/clear_variables','Clear Console Variables','a:0:{}','system',0,0,0,0,0,3,0,1,8,780,0,0,0,0,0,0,0),('management',782,124,'admin/structure/taxonomy/%/display','admin/structure/taxonomy/%/display','Manage display','a:0:{}','system',-1,0,0,0,2,5,0,1,21,57,124,782,0,0,0,0,0),('management',783,89,'admin/config/people/accounts/display','admin/config/people/accounts/display','Manage display','a:0:{}','system',-1,0,0,0,2,5,0,1,8,48,89,783,0,0,0,0,0),('management',784,124,'admin/structure/taxonomy/%/fields','admin/structure/taxonomy/%/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,5,0,1,21,57,124,784,0,0,0,0,0),('management',785,89,'admin/config/people/accounts/fields','admin/config/people/accounts/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,5,0,1,8,48,89,785,0,0,0,0,0),('management',786,782,'admin/structure/taxonomy/%/display/default','admin/structure/taxonomy/%/display/default','Default','a:0:{}','system',-1,0,0,0,-10,6,0,1,21,57,124,782,786,0,0,0,0),('management',787,783,'admin/config/people/accounts/display/default','admin/config/people/accounts/display/default','Default','a:0:{}','system',-1,0,0,0,-10,6,0,1,8,48,89,783,787,0,0,0,0),('management',788,135,'admin/structure/types/manage/%/display','admin/structure/types/manage/%/display','Manage display','a:0:{}','system',-1,0,0,0,2,5,0,1,21,36,135,788,0,0,0,0,0),('management',789,135,'admin/structure/types/manage/%/fields','admin/structure/types/manage/%/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,5,0,1,21,36,135,789,0,0,0,0,0),('management',790,782,'admin/structure/taxonomy/%/display/full','admin/structure/taxonomy/%/display/full','Taxonomy term page','a:0:{}','system',-1,0,0,0,0,6,0,1,21,57,124,782,790,0,0,0,0),('management',791,782,'admin/structure/taxonomy/%/display/token','admin/structure/taxonomy/%/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,6,0,1,21,57,124,782,791,0,0,0,0),('management',792,783,'admin/config/people/accounts/display/token','admin/config/people/accounts/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,6,0,1,8,48,89,783,792,0,0,0,0),('management',793,783,'admin/config/people/accounts/display/full','admin/config/people/accounts/display/full','User account','a:0:{}','system',-1,0,0,0,0,6,0,1,8,48,89,783,793,0,0,0,0),('management',794,784,'admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','','a:0:{}','system',0,0,0,0,0,6,0,1,21,57,124,784,794,0,0,0,0),('management',795,785,'admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','','a:0:{}','system',0,0,0,0,0,6,0,1,8,48,89,785,795,0,0,0,0),('management',796,788,'admin/structure/types/manage/%/display/default','admin/structure/types/manage/%/display/default','Default','a:0:{}','system',-1,0,0,0,-10,6,0,1,21,36,135,788,796,0,0,0,0),('management',797,788,'admin/structure/types/manage/%/display/rss','admin/structure/types/manage/%/display/rss','RSS','a:0:{}','system',-1,0,0,0,2,6,0,1,21,36,135,788,797,0,0,0,0),('management',798,788,'admin/structure/types/manage/%/display/search_index','admin/structure/types/manage/%/display/search_index','Search index','a:0:{}','system',-1,0,0,0,3,6,0,1,21,36,135,788,798,0,0,0,0),('management',799,788,'admin/structure/types/manage/%/display/search_result','admin/structure/types/manage/%/display/search_result','Search result','a:0:{}','system',-1,0,0,0,4,6,0,1,21,36,135,788,799,0,0,0,0),('management',800,788,'admin/structure/types/manage/%/display/teaser','admin/structure/types/manage/%/display/teaser','Teaser','a:0:{}','system',-1,0,0,0,1,6,0,1,21,36,135,788,800,0,0,0,0),('management',801,788,'admin/structure/types/manage/%/display/full','admin/structure/types/manage/%/display/full','Full content','a:0:{}','system',-1,0,0,0,0,6,0,1,21,36,135,788,801,0,0,0,0),('management',802,788,'admin/structure/types/manage/%/display/token','admin/structure/types/manage/%/display/token','Tokens','a:0:{}','system',-1,0,0,0,5,6,0,1,21,36,135,788,802,0,0,0,0),('management',803,789,'admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','','a:0:{}','system',0,0,0,0,0,6,0,1,21,36,135,789,803,0,0,0,0),('management',804,794,'admin/structure/taxonomy/%/fields/%/delete','admin/structure/taxonomy/%/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,7,0,1,21,57,124,784,794,804,0,0,0),('management',805,794,'admin/structure/taxonomy/%/fields/%/edit','admin/structure/taxonomy/%/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,7,0,1,21,57,124,784,794,805,0,0,0),('management',806,794,'admin/structure/taxonomy/%/fields/%/field-settings','admin/structure/taxonomy/%/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,7,0,1,21,57,124,784,794,806,0,0,0),('management',807,794,'admin/structure/taxonomy/%/fields/%/widget-type','admin/structure/taxonomy/%/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,7,0,1,21,57,124,784,794,807,0,0,0),('management',808,795,'admin/config/people/accounts/fields/%/delete','admin/config/people/accounts/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,7,0,1,8,48,89,785,795,808,0,0,0),('management',809,795,'admin/config/people/accounts/fields/%/edit','admin/config/people/accounts/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,7,0,1,8,48,89,785,795,809,0,0,0),('management',810,795,'admin/config/people/accounts/fields/%/field-settings','admin/config/people/accounts/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,7,0,1,8,48,89,785,795,810,0,0,0),('management',811,795,'admin/config/people/accounts/fields/%/widget-type','admin/config/people/accounts/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,7,0,1,8,48,89,785,795,811,0,0,0),('management',812,173,'admin/structure/types/manage/%/comment/display/default','admin/structure/types/manage/%/comment/display/default','Default','a:0:{}','system',-1,0,0,0,-10,6,0,1,21,36,135,173,812,0,0,0,0),('management',813,173,'admin/structure/types/manage/%/comment/display/full','admin/structure/types/manage/%/comment/display/full','Full comment','a:0:{}','system',-1,0,0,0,0,6,0,1,21,36,135,173,813,0,0,0,0),('management',814,173,'admin/structure/types/manage/%/comment/display/token','admin/structure/types/manage/%/comment/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,6,0,1,21,36,135,173,814,0,0,0,0),('management',815,174,'admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','','a:0:{}','system',0,0,0,0,0,6,0,1,21,36,135,174,815,0,0,0,0),('management',816,803,'admin/structure/types/manage/%/fields/%/delete','admin/structure/types/manage/%/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,7,0,1,21,36,135,789,803,816,0,0,0),('management',817,803,'admin/structure/types/manage/%/fields/%/edit','admin/structure/types/manage/%/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,7,0,1,21,36,135,789,803,817,0,0,0),('management',818,803,'admin/structure/types/manage/%/fields/%/field-settings','admin/structure/types/manage/%/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,7,0,1,21,36,135,789,803,818,0,0,0),('management',819,803,'admin/structure/types/manage/%/fields/%/widget-type','admin/structure/types/manage/%/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,7,0,1,21,36,135,789,803,819,0,0,0),('management',820,815,'admin/structure/types/manage/%/comment/fields/%/delete','admin/structure/types/manage/%/comment/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,7,0,1,21,36,135,174,815,820,0,0,0),('management',821,815,'admin/structure/types/manage/%/comment/fields/%/edit','admin/structure/types/manage/%/comment/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,7,0,1,21,36,135,174,815,821,0,0,0),('management',822,815,'admin/structure/types/manage/%/comment/fields/%/field-settings','admin/structure/types/manage/%/comment/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,7,0,1,21,36,135,174,815,822,0,0,0),('management',823,815,'admin/structure/types/manage/%/comment/fields/%/widget-type','admin/structure/types/manage/%/comment/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,7,0,1,21,36,135,174,815,823,0,0,0),('menu-mercury-navigation',824,0,'http:/fa_help','','Flash Accel Help','a:1:{s:10:\"attributes\";a:1:{s:6:\"target\";s:6:\"_blank\";}}','menu',1,1,0,0,-43,1,1,824,0,0,0,0,0,0,0,0,0),('navigation',826,0,'rediscover/cancel','rediscover/cancel','Cancel Rediscover Operation','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:27:\"Cancel Rediscover Operation\";}}','system',0,0,0,0,0,1,0,826,0,0,0,0,0,0,0,0,0),('navigation',827,0,'ctools-popups/%/mmc/rediscover','ctools-popups/%/mmc/rediscover','','a:0:{}','system',0,0,0,0,0,1,0,827,0,0,0,0,0,0,0,0,0),('management',862,377,'admin/structure/panels/layouts','admin/structure/panels/layouts','Layouts','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Add, edit or delete custom content layouts.\";}}','system',-1,0,0,0,0,4,0,1,21,377,862,0,0,0,0,0,0),('management',863,862,'admin/structure/panels/layouts/add-flexible','admin/structure/panels/layouts/add-flexible','Add flexible layout','a:0:{}','system',-1,0,0,0,0,5,0,1,21,377,862,863,0,0,0,0,0),('management',864,862,'admin/structure/panels/layouts/import','admin/structure/panels/layouts/import','Import','a:0:{}','system',-1,0,0,0,0,5,0,1,21,377,862,864,0,0,0,0,0),('management',865,862,'admin/structure/panels/layouts/list','admin/structure/panels/layouts/list','List','a:0:{}','system',-1,0,0,0,-10,5,0,1,21,377,862,865,0,0,0,0,0),('management',866,865,'admin/structure/panels/layouts/list/%/edit','admin/structure/panels/layouts/list/%/edit','Edit','a:0:{}','system',-1,0,0,0,-10,6,0,1,21,377,862,865,866,0,0,0,0),('management',867,865,'admin/structure/panels/layouts/list/%/export','admin/structure/panels/layouts/list/%/export','Export','a:0:{}','system',-1,0,0,0,0,6,0,1,21,377,862,865,867,0,0,0,0),('menu-selector-tool',834,0,'host-inventory','host-inventory','Host','a:0:{}','system',0,0,0,0,0,1,0,834,0,0,0,0,0,0,0,0,0),('menu-selector-tool',835,0,'vm-inventory','vm-inventory','VM','a:0:{}','system',0,0,0,0,0,1,0,835,0,0,0,0,0,0,0,0,0),('menu-mercury-navigation',836,0,'host-inventory','host-inventory','Host Inventory','a:1:{s:10:\"attributes\";a:0:{}}','menu',0,0,0,0,-49,1,1,836,0,0,0,0,0,0,0,0,0),('navigation',837,0,'ctools-popups/%/bulk/vdisk/%','ctools-popups/%/bulk/vdisk/%','','a:0:{}','system',0,0,0,0,0,1,0,837,0,0,0,0,0,0,0,0,0),('navigation',869,0,'discovery/get_percent_status','discovery/get_percent_status','','a:0:{}','system',0,0,0,0,0,1,0,869,0,0,0,0,0,0,0,0,0),('navigation',870,0,'config/fmc/user/%','config/fmc/user/%','User Settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:13:\"User Settings\";}}','system',1,0,0,0,0,1,0,870,0,0,0,0,0,0,0,0,0),('navigation',871,853,'config/fmc/settings/agents','config/fmc/settings/agents','Agents','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:14:\"Agent Settings\";}}','system',-1,0,0,0,12,2,0,853,871,0,0,0,0,0,0,0,0),('navigation',853,0,'config/fmc/settings','config/fmc/settings','Console Settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:16:\"Console Settings\";}}','system',0,0,0,0,0,1,1,853,0,0,0,0,0,0,0,0,0),('navigation',878,853,'config/fmc/settings/vcenter','config/fmc/settings/vcenter','vCenter','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:16:\"vCenter Settings\";}}','system',-1,0,0,0,8,2,0,853,878,0,0,0,0,0,0,0,0),('navigation',877,853,'config/fmc/settings/vm','config/fmc/settings/vm','VM','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:11:\"VM Settings\";}}','system',-1,0,0,0,10,2,0,853,877,0,0,0,0,0,0,0,0),('navigation',876,853,'config/fmc/settings/migration','config/fmc/settings/migration','Migration','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:18:\"Migration Settings\";}}','system',-1,0,0,0,13,2,0,853,876,0,0,0,0,0,0,0,0),('navigation',875,853,'config/fmc/settings/log','config/fmc/settings/log','Logs','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:12:\"Log Settings\";}}','system',-1,0,0,0,14,2,0,853,875,0,0,0,0,0,0,0,0),('navigation',874,853,'config/fmc/settings/host','config/fmc/settings/host','Host','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:13:\"Host Settings\";}}','system',-1,0,0,0,9,2,0,853,874,0,0,0,0,0,0,0,0),('navigation',873,853,'config/fmc/settings/export_import','config/fmc/settings/export_import','Export / Import','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:15:\"Export / Import\";}}','system',-1,0,0,0,15,2,0,853,873,0,0,0,0,0,0,0,0),('navigation',872,853,'config/fmc/settings/cron_job','config/fmc/settings/cron_job','Discovery','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:18:\"Discovery Settings\";}}','system',-1,0,0,0,11,2,0,853,872,0,0,0,0,0,0,0,0),('management',880,12,'admin/help/famc_asup','admin/help/famc_asup','famc_asup','a:0:{}','system',-1,0,0,0,0,3,0,1,12,880,0,0,0,0,0,0,0);
/*!40000 ALTER TABLE `menu_links` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `menu_router`
--

DROP TABLE IF EXISTS `menu_router`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menu_router` (
  `path` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: the Drupal path this entry describes',
  `load_functions` blob NOT NULL COMMENT 'A serialized array of function names (like node_load) to be called to load an object corresponding to a part of the current path.',
  `to_arg_functions` blob NOT NULL COMMENT 'A serialized array of function names (like user_uid_optional_to_arg) to be called to replace a part of the router path with another string.',
  `access_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'The callback which determines the access to this router path. Defaults to user_access.',
  `access_arguments` blob COMMENT 'A serialized array of arguments for the access callback.',
  `page_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the function that renders the page.',
  `page_arguments` blob COMMENT 'A serialized array of arguments for the page callback.',
  `delivery_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the function that sends the result of the page_callback function to the browser.',
  `fit` int(11) NOT NULL DEFAULT '0' COMMENT 'A numeric representation of how specific the path is.',
  `number_parts` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Number of parts in this router path.',
  `context` int(11) NOT NULL DEFAULT '0' COMMENT 'Only for local tasks (tabs) - the context of a local task to control its placement.',
  `tab_parent` varchar(255) NOT NULL DEFAULT '' COMMENT 'Only for local tasks (tabs) - the router path of the parent page (which may also be a local task).',
  `tab_root` varchar(255) NOT NULL DEFAULT '' COMMENT 'Router path of the closest non-tab parent page. For pages that are not local tasks, this will be the same as the path.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title for the current page, or the title for the tab if this is a local task.',
  `title_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'A function which will alter the title. Defaults to t()',
  `title_arguments` varchar(255) NOT NULL DEFAULT '' COMMENT 'A serialized array of arguments for the title callback. If empty, the title will be used as the sole argument for the title callback.',
  `theme_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'A function which returns the name of the theme that will be used to render this page. If left empty, the default theme will be used.',
  `theme_arguments` varchar(255) NOT NULL DEFAULT '' COMMENT 'A serialized array of arguments for the theme callback.',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT 'Numeric representation of the type of the menu item, like MENU_LOCAL_TASK.',
  `description` text NOT NULL COMMENT 'A description of this item.',
  `position` varchar(255) NOT NULL DEFAULT '' COMMENT 'The position of the block (left or right) on the system administration page for this item.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Weight of the element. Lighter weights are higher up, heavier weights go down.',
  `include_file` mediumtext COMMENT 'The file to include for this element, usually the page callback function lives in this file.',
  PRIMARY KEY (`path`),
  KEY `fit` (`fit`),
  KEY `tab_parent` (`tab_parent`(64),`weight`,`title`),
  KEY `tab_root_weight_title` (`tab_root`(64),`weight`,`title`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Maps paths to various callbacks (access, page and title)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menu_router`
--

LOCK TABLES `menu_router` WRITE;
/*!40000 ALTER TABLE `menu_router` DISABLE KEYS */;
INSERT INTO `menu_router` VALUES ('ctools_ajax_sample','','','1','a:0:{}','ctools_ajax_sample_page','a:0:{}','',1,1,0,'','ctools_ajax_sample','Chaos Tools AJAX Demo','t','','','a:0:{}',6,'','',0,''),('rss.xml','','','user_access','a:1:{i:0;s:14:\"access content\";}','node_feed','a:0:{}','',1,1,0,'','rss.xml','RSS feed','t','','','a:0:{}',0,'','',0,''),('node','','','user_access','a:1:{i:0;s:14:\"access content\";}','node_page_default','a:0:{}','',1,1,0,'','node','','t','','','a:0:{}',0,'','',0,''),('r4032login','','','r4032login_access_callback','a:0:{}','r4032login_redirect','a:0:{}','',1,1,0,'','r4032login','Access denied','t','','','a:0:{}',0,'You are not authorized to access this page.','',0,''),('search','','','search_is_active','a:0:{}','search_view','a:0:{}','',1,1,0,'','search','Search','t','','','a:0:{}',20,'','',0,'modules/search/search.pages.inc'),('batch','','','1','a:0:{}','system_batch_page','a:0:{}','',1,1,0,'','batch','','t','','_system_batch_theme','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',1,1,0,'','admin','Administration','t','','','a:0:{}',6,'','',9,'modules/system/system.admin.inc'),('analytics','','','user_access','a:1:{i:0;s:14:\"access content\";}','drupal_get_form','a:1:{i:0;s:29:\"famc_analytics_analytics_form\";}','',1,1,0,'','analytics','Analytics','t','','','a:0:{}',6,'Form for viewing performance analytics of VMs and Hosts.','',0,''),('fmc-search','','','user_access','a:1:{i:0;s:22:\"access search_api_page\";}','search_api_page_view','a:1:{i:0;s:6:\"search\";}','',1,1,0,'','fmc-search','Search','t','','','a:0:{}',20,'','',0,'sites/all/modules/contrib/search_api_page/search_api_page.pages.inc'),('user','','','mercury_utilities_user_access_check','a:0:{}','user_page','a:0:{}','',1,1,0,'','user','User account','user_menu_title','','','a:0:{}',6,'','',-10,'modules/user/user.pages.inc'),('export-console-log','','','views_access','a:1:{i:0;a:2:{i:0;s:17:\"views_check_roles\";i:1;a:1:{i:0;a:2:{i:3;s:1:\"3\";i:2;s:1:\"2\";}}}}','views_page','a:2:{i:0;s:19:\"console_log_reports\";i:1;s:19:\"views_data_export_1\";}','',1,1,0,'','export-console-log','','t','','','a:0:{}',0,'','',0,''),('ongoing-process','','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}','views_page','a:2:{i:0;s:17:\"ongoing_processes\";i:1;s:4:\"page\";}','',1,1,0,'','ongoing-process','','t','','','a:0:{}',0,'','',0,''),('ongoing-processes','','','ctools_access_menu','a:1:{i:0;a:3:{s:5:\"logic\";s:3:\"and\";s:4:\"type\";s:4:\"none\";s:8:\"settings\";N;}}','page_manager_page_execute','a:1:{i:0;s:17:\"ongoing_processes\";}','',1,1,0,'','ongoing-processes','','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.inc'),('home','','','ctools_access_menu','a:1:{i:0;a:4:{s:7:\"plugins\";a:1:{i:0;a:4:{s:4:\"name\";s:4:\"role\";s:8:\"settings\";a:1:{s:4:\"rids\";a:1:{i:0;i:2;}}s:7:\"context\";s:14:\"logged-in-user\";s:3:\"not\";b:0;}}s:5:\"logic\";s:3:\"and\";s:4:\"type\";s:4:\"none\";s:8:\"settings\";N;}}','page_manager_page_execute','a:1:{i:0;s:9:\"home_page\";}','',1,1,0,'','home','','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.inc'),('vm-inventory','','','ctools_access_menu','a:1:{i:0;a:4:{s:5:\"logic\";s:3:\"and\";s:7:\"plugins\";a:1:{i:0;a:4:{s:4:\"name\";s:4:\"role\";s:8:\"settings\";a:1:{s:4:\"rids\";a:2:{i:0;i:2;i:1;i:3;}}s:7:\"context\";s:14:\"logged-in-user\";s:3:\"not\";b:0;}}s:4:\"type\";s:4:\"none\";s:8:\"settings\";N;}}','page_manager_page_execute','a:1:{i:0;s:3:\"all\";}','',1,1,0,'','vm-inventory','VM','t','','','a:0:{}',6,'','',0,'sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.inc'),('host-inventory','','','ctools_access_menu','a:1:{i:0;a:4:{s:5:\"logic\";s:3:\"and\";s:7:\"plugins\";a:1:{i:0;a:4:{s:4:\"name\";s:4:\"role\";s:8:\"settings\";a:1:{s:4:\"rids\";a:2:{i:0;i:2;i:1;i:3;}}s:7:\"context\";s:14:\"logged-in-user\";s:3:\"not\";b:0;}}s:4:\"type\";s:4:\"none\";s:8:\"settings\";N;}}','page_manager_page_execute','a:1:{i:0;s:12:\"mercury_host\";}','',1,1,0,'','host-inventory','Host','t','','','a:0:{}',6,'','',0,'sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.inc'),('console-logs-report','','','views_access','a:1:{i:0;a:2:{i:0;s:17:\"views_check_roles\";i:1;a:1:{i:0;a:2:{i:3;s:1:\"3\";i:2;s:1:\"2\";}}}}','views_page','a:2:{i:0;s:19:\"console_log_reports\";i:1;s:4:\"page\";}','',1,1,0,'','console-logs-report','Console Logs','t','','','a:0:{}',6,'Console Logs Report','',10,''),('admin/tasks','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',3,2,1,'admin','admin','Tasks','t','','','a:0:{}',140,'','',-20,'modules/system/system.admin.inc'),('user/login','','','user_is_anonymous','a:0:{}','user_page','a:0:{}','',3,2,1,'user','user','Log in','t','','','a:0:{}',140,'','',0,'modules/user/user.pages.inc'),('discovery/get_percent_status','','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','mercury_utilities_get_discovery_percentage','a:0:{}','',3,2,0,'','discovery/get_percent_status','','t','','','a:0:{}',6,'','',0,''),('discovery/get_discovery_status','','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','mercury_utilities_get_discovery_status','a:0:{}','',3,2,0,'','discovery/get_discovery_status','','t','','','a:0:{}',6,'','',0,''),('toboggan/denied','','','1','a:0:{}','logintoboggan_denied','a:0:{}','',3,2,0,'','toboggan/denied','Access denied','t','','','a:0:{}',0,'','',0,''),('ctools_ajax_sample/simple_form','','','1','a:0:{}','ctools_ajax_simple_form','a:0:{}','',3,2,0,'','ctools_ajax_sample/simple_form','Simple Form','t','','','a:0:{}',0,'','',0,''),('ctools_ajax_sample/jumped','','','1','a:0:{}','ctools_ajax_sample_jump_menu_page','a:0:{}','',3,2,0,'','ctools_ajax_sample/jumped','Successful Jumping','t','','','a:0:{}',6,'','',0,''),('admin_menu/flush-cache','','','user_access','a:1:{i:0;s:12:\"flush caches\";}','admin_menu_flush_cache','a:0:{}','',3,2,0,'','admin_menu/flush-cache','','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/admin_menu/admin_menu.inc'),('admin_menu/toggle-modules','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','admin_menu_toggle_modules','a:0:{}','',3,2,0,'','admin_menu/toggle-modules','','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/admin_menu/admin_menu.inc'),('node/add','','','_node_add_access','a:0:{}','node_add_page','a:0:{}','',3,2,0,'','node/add','Add content','t','','','a:0:{}',6,'','',0,'modules/node/node.pages.inc'),('taxonomy/autocomplete','','','user_access','a:1:{i:0;s:14:\"access content\";}','taxonomy_autocomplete','a:0:{}','',3,2,0,'','taxonomy/autocomplete','Autocomplete taxonomy','t','','','a:0:{}',0,'','',0,'modules/taxonomy/taxonomy.pages.inc'),('rediscover/cancel','','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','mercury_management_rediscover_cancel','a:0:{}','',3,2,0,'','rediscover/cancel','Cancel Rediscover Operation','t','','','a:0:{}',6,'Cancel Rediscover Operation','',0,''),('comment/%','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:15:\"access comments\";}','comment_permalink','a:1:{i:0;i:1;}','',2,2,0,'','comment/%','Comment permalink','t','','','a:0:{}',6,'','',0,''),('admin/compact','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_compact_page','a:0:{}','',3,2,0,'','admin/compact','Compact mode','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('filter/tips','','','1','a:0:{}','filter_tips_long','a:0:{}','',3,2,0,'','filter/tips','Compose tips','t','','','a:0:{}',20,'','',0,'modules/filter/filter.pages.inc'),('user/register','','','user_register_access','a:0:{}','drupal_get_form','a:1:{i:0;s:18:\"user_register_form\";}','',3,2,1,'user','user','Create new account','t','','','a:0:{}',132,'','',0,''),('admin/dashboard','','','user_access','a:1:{i:0;s:16:\"access dashboard\";}','dashboard_admin','a:0:{}','',3,2,0,'','admin/dashboard','Dashboard','t','','','a:0:{}',6,'View and customize your dashboard.','',-15,''),('system/files','','','1','a:0:{}','file_download','a:1:{i:0;s:7:\"private\";}','',3,2,0,'','system/files','File download','t','','','a:0:{}',0,'','',0,''),('webservices/HgGetCacheInfo','','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','mercury_management_cache_operation','a:0:{}','',3,2,0,'','webservices/HgGetCacheInfo','Get Cache Info','t','','','a:0:{}',6,'Get Cache Info','',0,''),('admin/index','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_index','a:0:{}','',3,2,1,'admin','admin','Index','t','','','a:0:{}',132,'','',-18,'modules/system/system.admin.inc'),('confirm/rediscover','','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','drupal_get_form','a:1:{i:0;s:37:\"mercury_management_rediscover_confirm\";}','',3,2,0,'','confirm/rediscover','Rediscover','t','','','a:0:{}',0,'','',0,''),('system/temporary','','','1','a:0:{}','file_download','a:1:{i:0;s:9:\"temporary\";}','',3,2,0,'','system/temporary','Temporary files','t','','','a:0:{}',0,'','',0,''),('system/timezone','','','1','a:0:{}','system_timezone','a:0:{}','',3,2,0,'','system/timezone','Time zone','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('view/virtual-machines','','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','mercury_management_display_mercury_vms','a:0:{}','',3,2,0,'','view/virtual-machines','View Virtual Machines','t','','','a:0:{}',6,'View Virtual Machines','',0,''),('token/flush-cache','','','user_access','a:1:{i:0;s:12:\"flush caches\";}','token_flush_cache_callback','a:0:{}','',3,2,0,'','token/flush-cache','','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/token/token.pages.inc'),('webservices/list','','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','mercury_management_webservices','a:0:{}','',3,2,0,'','webservices/list','Web Services','t','','','a:0:{}',6,'Web Services','',0,''),('token/tree','','','1','a:0:{}','token_page_output_tree','a:0:{}','',3,2,0,'','token/tree','','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/token/token.pages.inc'),('admin/config','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_config_page','a:0:{}','',3,2,0,'','admin/config','Configuration','t','','','a:0:{}',6,'Administer settings.','',0,'modules/system/system.admin.inc'),('admin/help','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_main','a:0:{}','',3,2,0,'','admin/help','Help','t','','','a:0:{}',6,'Reference for usage, configuration, and modules.','',9,'modules/help/help.admin.inc'),('user/logout','','','user_is_logged_in','a:0:{}','user_logout','a:0:{}','',3,2,0,'','user/logout','Log out','t','','','a:0:{}',6,'','',10,'modules/user/user.pages.inc'),('panels/ajax','','','user_access','a:1:{i:0;s:14:\"access content\";}','panels_ajax_router','a:0:{}','ajax_deliver',3,2,0,'','panels/ajax','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,''),('user/password','','','1','a:0:{}','drupal_get_form','a:1:{i:0;s:9:\"user_pass\";}','',3,2,1,'user','user','Request new password','t','','','a:0:{}',132,'','',0,'modules/user/user.pages.inc'),('user/autocomplete','','','user_access','a:1:{i:0;s:20:\"access user profiles\";}','user_autocomplete','a:0:{}','',3,2,0,'','user/autocomplete','User autocomplete','t','','','a:0:{}',0,'','',0,'modules/user/user.pages.inc'),('analytics/view','','','user_access','a:1:{i:0;s:14:\"access content\";}','drupal_get_form','a:1:{i:0;s:34:\"famc_analytics_analytics_view_form\";}','',3,2,0,'','analytics/view','Analytics','t','','','a:0:{}',6,'View performance analytics of VMs and Hosts.','',0,''),('admin/appearance','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','system_themes_page','a:0:{}','',3,2,0,'','admin/appearance','Appearance','t','','','a:0:{}',6,'Select and configure your themes.','left',-6,'modules/system/system.admin.inc'),('admin/content','','','user_access','a:1:{i:0;s:23:\"access content overview\";}','drupal_get_form','a:1:{i:0;s:18:\"node_admin_content\";}','',3,2,0,'','admin/content','Content','t','','','a:0:{}',6,'Administer content and comments.','',-10,'modules/node/node.admin.inc'),('search/node','','','_search_menu_access','a:1:{i:0;s:4:\"node\";}','search_view','a:2:{i:0;s:4:\"node\";i:1;s:0:\"\";}','',3,2,1,'search','search','Content','t','','','a:0:{}',132,'','',-10,'modules/search/search.pages.inc'),('admin/modules','','','user_access','a:1:{i:0;s:18:\"administer modules\";}','drupal_get_form','a:1:{i:0;s:14:\"system_modules\";}','',3,2,0,'','admin/modules','Modules','t','','','a:0:{}',6,'Extend site functionality.','',-2,'modules/system/system.admin.inc'),('admin/reports','','','user_access','a:1:{i:0;s:19:\"access site reports\";}','system_admin_menu_block_page','a:0:{}','',3,2,0,'','admin/reports','Reports','t','','','a:0:{}',6,'View reports, updates, and errors.','left',5,'modules/system/system.admin.inc'),('admin/structure','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',3,2,0,'','admin/structure','Structure','t','','','a:0:{}',6,'Administer blocks, content types, menus, etc.','right',-8,'modules/system/system.admin.inc'),('system/ajax','','','1','a:0:{}','ajax_form_callback','a:0:{}','ajax_deliver',3,2,0,'','system/ajax','AHAH callback','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'includes/form.inc'),('admin/people','','','user_access','a:1:{i:0;s:16:\"administer users\";}','user_admin','a:1:{i:0;s:4:\"list\";}','',3,2,0,'','admin/people','People','t','','','a:0:{}',6,'Manage user accounts, roles, and permissions.','left',-4,'modules/user/user.admin.inc'),('views/ajax','','','1','a:0:{}','views_ajax','a:0:{}','ajax_deliver',3,2,0,'','views/ajax','Views','t','','ajax_base_page_theme','a:0:{}',0,'Ajax callback for view loading.','',0,'sites/all/modules/contrib/views/includes/ajax.inc'),('node/%','a:1:{i:1;s:9:\"node_load\";}','','node_access','a:2:{i:0;s:4:\"view\";i:1;i:1;}','node_page_view','a:1:{i:0;i:1;}','',2,2,0,'','node/%','','node_page_title','a:1:{i:0;i:1;}','','a:0:{}',6,'','',0,''),('user/%','a:1:{i:1;s:9:\"user_load\";}','','user_view_access','a:1:{i:0;i:1;}','user_view_page','a:1:{i:0;i:1;}','',2,2,0,'','user/%','My account','user_page_title','a:1:{i:0;i:1;}','','a:0:{}',6,'','',0,''),('admin/content/node','','','user_access','a:1:{i:0;s:23:\"access content overview\";}','drupal_get_form','a:1:{i:0;s:18:\"node_admin_content\";}','',7,3,1,'admin/content','admin/content','Content','t','','','a:0:{}',140,'','',-10,'modules/node/node.admin.inc'),('admin/modules/list','','','user_access','a:1:{i:0;s:18:\"administer modules\";}','drupal_get_form','a:1:{i:0;s:14:\"system_modules\";}','',7,3,1,'admin/modules','admin/modules','List','t','','','a:0:{}',140,'','',0,'modules/system/system.admin.inc'),('node/%/view','a:1:{i:1;s:9:\"node_load\";}','','node_access','a:2:{i:0;s:4:\"view\";i:1;i:1;}','node_page_view','a:1:{i:0;i:1;}','',5,3,1,'node/%','node/%','View','t','','','a:0:{}',140,'','',-10,''),('user/%/view','a:1:{i:1;s:9:\"user_load\";}','','user_view_access','a:1:{i:0;i:1;}','user_view_page','a:1:{i:0;i:1;}','',5,3,1,'user/%','user/%','View','t','','','a:0:{}',140,'','',-10,''),('comment/%/view','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:15:\"access comments\";}','comment_permalink','a:1:{i:0;i:1;}','',5,3,1,'comment/%','comment/%','View comment','t','','','a:0:{}',140,'','',-10,''),('admin/people/create','','','user_access','a:1:{i:0;s:16:\"administer users\";}','user_admin','a:1:{i:0;s:6:\"create\";}','',7,3,1,'admin/people','admin/people','Add user','t','','','a:0:{}',388,'','',0,'modules/user/user.admin.inc'),('admin/dashboard/drawer','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','dashboard_show_disabled','a:0:{}','',7,3,0,'','admin/dashboard/drawer','','t','','','a:0:{}',0,'','',0,''),('admin/dashboard/update','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','dashboard_update','a:0:{}','',7,3,0,'','admin/dashboard/update','','t','','','a:0:{}',0,'','',0,''),('admin/config/clear_variables','','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','mercury_management_clear_drupal_variables','a:0:{}','',7,3,0,'','admin/config/clear_variables','Clear Console Variables','t','','','a:0:{}',6,'','',0,''),('admin/appearance/list','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','system_themes_page','a:0:{}','',7,3,1,'admin/appearance','admin/appearance','List','t','','','a:0:{}',140,'Select and configure your theme','',-1,'modules/system/system.admin.inc'),('fmc/clear/dblogs','','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','mercury_management_clear_database_logs','a:0:{}','',7,3,0,'','fmc/clear/dblogs','','t','','','a:0:{}',0,'','',0,''),('js/admin_menu/cache','','','user_access','a:1:{i:0;s:26:\"access administration menu\";}','admin_menu_js_cache','a:0:{}','admin_menu_deliver',7,3,0,'','js/admin_menu/cache','','t','','','a:0:{}',0,'','',0,''),('refresh/host/%','a:1:{i:2;N;}','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','mercury_utilities_host_refresh_action','a:1:{i:0;i:2;}','',6,3,0,'','refresh/host/%','','t','','','a:0:{}',0,'','',0,''),('refresh/vdisk/%','a:1:{i:2;N;}','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','mercury_utilities_vdisk_refresh_action','a:1:{i:0;i:2;}','',6,3,0,'','refresh/vdisk/%','','t','','','a:0:{}',0,'','',0,''),('virtual_machine/%/vm_disks','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','mercury_utilities_vm_disks_display','a:1:{i:0;i:1;}','',5,3,0,'','virtual_machine/%/vm_disks','','t','','','a:0:{}',0,'','',0,''),('refresh/vm/%','a:1:{i:2;N;}','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','mercury_utilities_vm_refresh_action','a:1:{i:0;i:2;}','',6,3,0,'','refresh/vm/%','','t','','','a:0:{}',0,'','',0,''),('ctools_ajax_sample/%/animal','a:1:{i:1;s:14:\"ctools_js_load\";}','','1','a:0:{}','ctools_ajax_sample_animal','a:1:{i:0;i:1;}','',5,3,0,'','ctools_ajax_sample/%/animal','Animal','t','','','a:0:{}',0,'','',0,''),('admin/dashboard/configure','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','dashboard_admin_blocks','a:0:{}','',7,3,0,'','admin/dashboard/configure','Configure available dashboard blocks','t','','','a:0:{}',4,'Configure which blocks can be shown on the dashboard.','',0,''),('admin/appearance/disable','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','system_theme_disable','a:0:{}','',7,3,0,'','admin/appearance/disable','Disable theme','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/appearance/enable','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','system_theme_enable','a:0:{}','',7,3,0,'','admin/appearance/enable','Enable theme','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('ctools_ajax_sample/%/hello','a:1:{i:1;s:14:\"ctools_js_load\";}','','1','a:0:{}','ctools_ajax_sample_hello','a:1:{i:0;i:1;}','',5,3,0,'','ctools_ajax_sample/%/hello','Hello World','t','','','a:0:{}',0,'','',0,''),('admin/people/people','','','user_access','a:1:{i:0;s:16:\"administer users\";}','user_admin','a:1:{i:0;s:4:\"list\";}','',7,3,1,'admin/people','admin/people','List','t','','','a:0:{}',140,'Find and manage people interacting with your site.','',-10,'modules/user/user.admin.inc'),('ctools_ajax_sample/%/login','a:1:{i:1;s:14:\"ctools_js_load\";}','','1','a:0:{}','ctools_ajax_sample_login','a:1:{i:0;i:1;}','',5,3,0,'','ctools_ajax_sample/%/login','Login','t','','','a:0:{}',0,'','',0,''),('admin/appearance/default','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','system_theme_default','a:0:{}','',7,3,0,'','admin/appearance/default','Set default theme','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/modules/uninstall','','','user_access','a:1:{i:0;s:18:\"administer modules\";}','drupal_get_form','a:1:{i:0;s:24:\"system_modules_uninstall\";}','',7,3,1,'admin/modules','admin/modules','Uninstall','t','','','a:0:{}',132,'','',20,'modules/system/system.admin.inc'),('ctools/autocomplete/%','a:1:{i:2;N;}','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_content_autocomplete_entity','a:1:{i:0;i:2;}','',6,3,0,'','ctools/autocomplete/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/content.menu.inc'),('host/devices/%','a:1:{i:2;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','mercury_management_show_devices','a:1:{i:0;i:2;}','',6,3,0,'','host/devices/%','All Devices','t','','','a:0:{}',6,'All Devices','',0,''),('comment/%/approve','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:19:\"administer comments\";}','comment_approve','a:1:{i:0;i:1;}','',5,3,0,'','comment/%/approve','Approve','t','','','a:0:{}',6,'','',1,'modules/comment/comment.pages.inc'),('token/autocomplete/%','a:1:{i:2;s:15:\"token_type_load\";}','','1','a:0:{}','token_autocomplete_token','a:1:{i:0;i:2;}','',6,3,0,'','token/autocomplete/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/token/token.pages.inc'),('admin/content/comment','','','user_access','a:1:{i:0;s:19:\"administer comments\";}','comment_admin','a:0:{}','',7,3,1,'admin/content','admin/content','Comments','t','','','a:0:{}',134,'List and edit site comments and the comment approval queue.','',0,'modules/comment/comment.admin.inc'),('config/fmc/settings','','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','drupal_get_form','a:1:{i:0;s:39:\"mercury_utilities_vcenter_settings_form\";}','',7,3,0,'','config/fmc/settings','Console Settings','t','','','a:0:{}',6,'Console Settings','',0,''),('admin/structure/types','','','user_access','a:1:{i:0;s:24:\"administer content types\";}','node_overview_types','a:0:{}','',7,3,0,'','admin/structure/types','Content types','t','','','a:0:{}',6,'Manage content types, including default status, front page promotion, comment settings, etc.','',0,'modules/node/content_types.inc'),('admin/dashboard/customize','','','user_access','a:1:{i:0;s:16:\"access dashboard\";}','dashboard_admin','a:1:{i:0;b:1;}','',7,3,0,'','admin/dashboard/customize','Customize dashboard','t','','','a:0:{}',4,'Customize your dashboard.','',0,''),('comment/%/delete','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:19:\"administer comments\";}','comment_confirm_delete_page','a:1:{i:0;i:1;}','',5,3,1,'comment/%','comment/%','Delete','t','','','a:0:{}',132,'','',2,'modules/comment/comment.admin.inc'),('comment/%/edit','a:1:{i:1;s:12:\"comment_load\";}','','comment_access','a:2:{i:0;s:4:\"edit\";i:1;i:1;}','comment_edit_page','a:1:{i:0;i:1;}','',5,3,1,'comment/%','comment/%','Edit','t','','','a:0:{}',132,'','',0,''),('admin/reports/fields','','','user_access','a:1:{i:0;s:24:\"administer content types\";}','field_ui_fields_list','a:0:{}','',7,3,0,'','admin/reports/fields','Field list','t','','','a:0:{}',6,'Overview of fields on all entity types.','',0,'modules/field_ui/field_ui.admin.inc'),('node/%/panel_content','a:1:{i:1;s:9:\"node_load\";}','','panels_node_edit_node','a:1:{i:0;i:1;}','panels_node_edit_content','a:1:{i:0;i:1;}','',5,3,1,'node/%','node/%','Panel content','t','','','a:0:{}',132,'','',3,''),('node/%/panel_layout','a:1:{i:1;s:9:\"node_load\";}','','panels_node_edit_node','a:1:{i:0;i:1;}','panels_node_edit_layout','a:1:{i:0;i:1;}','',5,3,1,'node/%','node/%','Panel layout','t','','','a:0:{}',132,'','',2,''),('admin/structure/panels','','','user_access','a:1:{i:0;s:20:\"use panels dashboard\";}','panels_admin_page','a:0:{}','',7,3,0,'','admin/structure/panels','Panels','t','','','a:0:{}',6,'Get a bird\'s eye view of items related to Panels.','',0,'sites/all/modules/contrib/panels/includes/callbacks.inc'),('admin/reports/dblog','','','user_access','a:1:{i:0;s:19:\"access site reports\";}','dblog_overview','a:0:{}','',7,3,0,'','admin/reports/dblog','Recent log messages','t','','','a:0:{}',6,'View events that have recently been logged.','',-1,'modules/dblog/dblog.admin.inc'),('admin/reports/status','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','system_status','a:0:{}','',7,3,0,'','admin/reports/status','Status report','t','','','a:0:{}',6,'Get a status report about your site\'s operation and any detected problems.','',-60,'modules/system/system.admin.inc'),('admin/help/admin_menu','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/admin_menu','admin_menu','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/block','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/block','block','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/coder_review','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/coder_review','coder_review','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/color','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/color','color','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/comment','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/comment','comment','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/dashboard','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/dashboard','dashboard','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/date','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/date','date','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/dblog','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/dblog','dblog','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/famc_asup','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/famc_asup','famc_asup','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/field','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/field','field','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/field_sql_storage','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/field_sql_storage','field_sql_storage','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/field_ui','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/field_ui','field_ui','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/filter','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/filter','filter','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/help','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/help','help','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/list','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/list','list','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/login_destination','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/login_destination','login_destination','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/logintoboggan','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/logintoboggan','logintoboggan','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/menu','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/menu','menu','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/node','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/node','node','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/number','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/number','number','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/options','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/options','options','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/path','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/path','path','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/pathauto','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/pathauto','pathauto','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/php','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/php','php','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/rdf','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/rdf','rdf','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/search','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/search','search','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/shortcut','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/shortcut','shortcut','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/syslog','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/syslog','syslog','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/system','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/system','system','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/taxonomy','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/taxonomy','taxonomy','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/text','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/text','text','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/token','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/token','token','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/unique_field','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/unique_field','unique_field','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/user','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/user','user','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/views_watchdog','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/views_watchdog','views_watchdog','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('comment/reply/%','a:1:{i:2;s:9:\"node_load\";}','','node_access','a:2:{i:0;s:4:\"view\";i:1;i:2;}','comment_reply','a:1:{i:0;i:2;}','',6,3,0,'','comment/reply/%','Add new comment','t','','','a:0:{}',6,'','',0,'modules/comment/comment.pages.inc'),('admin/config/administration','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/administration','Administration','t','','','a:0:{}',6,'Administration tools.','',0,'modules/system/system.admin.inc'),('admin/structure/block','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','block_admin_display','a:1:{i:0;s:7:\"mercury\";}','',7,3,0,'','admin/structure/block','Blocks','t','','','a:0:{}',6,'Configure what block content appears in your site\'s sidebars and other regions.','',0,'modules/block/block.admin.inc'),('user/%/cancel','a:1:{i:1;s:9:\"user_load\";}','','user_cancel_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:24:\"user_cancel_confirm_form\";i:1;i:1;}','',5,3,0,'','user/%/cancel','Cancel account','t','','','a:0:{}',6,'','',0,'modules/user/user.pages.inc'),('admin/config/content','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/content','Content authoring','t','','','a:0:{}',6,'Settings related to formatting and authoring content.','left',-15,'modules/system/system.admin.inc'),('admin/config/development','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/development','Development','t','','','a:0:{}',6,'Development tools.','right',-10,'modules/system/system.admin.inc'),('user/%/edit','a:1:{i:1;s:9:\"user_load\";}','','user_edit_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:17:\"user_profile_form\";i:1;i:1;}','',5,3,1,'user/%','user/%','Edit','t','','','a:0:{}',132,'','',0,'modules/user/user.pages.inc'),('virtual_machine/%/historical_performance','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:14:\"access content\";}','drupal_get_form','a:2:{i:0;s:38:\"famc_analytics_vm_historical_perf_form\";i:1;i:1;}','',5,3,0,'','virtual_machine/%/historical_performance','Historical performance','t','','','a:0:{}',6,'The historical performance page for VM nodes.','',0,''),('admin/config/media','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/media','Media','t','','','a:0:{}',6,'Media tools.','left',-10,'modules/system/system.admin.inc'),('admin/structure/menu','','','user_access','a:1:{i:0;s:15:\"administer menu\";}','menu_overview_page','a:0:{}','',7,3,0,'','admin/structure/menu','Menus','t','','','a:0:{}',6,'Add new menus to your site, edit existing menus, and rename and reorganize menu links.','',0,'modules/menu/menu.admin.inc'),('admin/structure/pages','','','user_access','a:1:{i:0;s:16:\"use page manager\";}','page_manager_list_page','a:0:{}','',7,3,0,'','admin/structure/pages','Pages','t','','ajax_base_page_theme','a:0:{}',6,'Add, edit and remove overridden system pages and user defined pages from the system.','',0,'sites/all/modules/contrib/ctools/page_manager/page_manager.admin.inc'),('admin/people/permissions','','','user_access','a:1:{i:0;s:22:\"administer permissions\";}','drupal_get_form','a:1:{i:0;s:22:\"user_admin_permissions\";}','',7,3,1,'admin/people','admin/people','Permissions','t','','','a:0:{}',132,'Determine access to features by selecting permissions for roles.','',0,'modules/user/user.admin.inc'),('toboggan/revalidate/%','a:1:{i:2;s:9:\"user_load\";}','','logintoboggan_revalidate_access','a:1:{i:0;i:2;}','logintoboggan_resend_validation','a:1:{i:0;i:2;}','',6,3,0,'','toboggan/revalidate/%','Re-send validation e-mail','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/logintoboggan/logintoboggan.validation.inc'),('admin/config/regional','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/regional','Regional and language','t','','','a:0:{}',6,'Regional settings, localization and translation.','left',-5,'modules/system/system.admin.inc'),('node/%/revisions','a:1:{i:1;s:9:\"node_load\";}','','_node_revision_access','a:1:{i:0;i:1;}','node_revision_overview','a:1:{i:0;i:1;}','',5,3,1,'node/%','node/%','Revisions','t','','','a:0:{}',132,'','',2,'modules/node/node.pages.inc'),('admin/config/search','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/search','Search and metadata','t','','','a:0:{}',6,'Local site search, metadata and SEO.','left',-10,'modules/system/system.admin.inc'),('admin/appearance/settings','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','drupal_get_form','a:1:{i:0;s:21:\"system_theme_settings\";}','',7,3,1,'admin/appearance','admin/appearance','Settings','t','','','a:0:{}',132,'Configure default and theme specific settings.','',20,'modules/system/system.admin.inc'),('user/%/shortcuts','a:1:{i:1;s:9:\"user_load\";}','','shortcut_set_switch_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:19:\"shortcut_set_switch\";i:1;i:1;}','',5,3,1,'user/%','user/%','Shortcuts','t','','','a:0:{}',132,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/system','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/system','System','t','','','a:0:{}',6,'General system related configuration.','right',-20,'modules/system/system.admin.inc'),('admin/structure/taxonomy','','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:1:{i:0;s:30:\"taxonomy_overview_vocabularies\";}','',7,3,0,'','admin/structure/taxonomy','Taxonomy','t','','','a:0:{}',6,'Manage tagging, categorization, and classification of your content.','',0,'modules/taxonomy/taxonomy.admin.inc'),('admin/reports/access-denied','','','user_access','a:1:{i:0;s:19:\"access site reports\";}','dblog_top','a:1:{i:0;s:13:\"access denied\";}','',7,3,0,'','admin/reports/access-denied','Top \'access denied\' errors','t','','','a:0:{}',6,'View \'access denied\' errors (403s).','',0,'modules/dblog/dblog.admin.inc'),('admin/reports/page-not-found','','','user_access','a:1:{i:0;s:19:\"access site reports\";}','dblog_top','a:1:{i:0;s:14:\"page not found\";}','',7,3,0,'','admin/reports/page-not-found','Top \'page not found\' errors','t','','','a:0:{}',6,'View \'page not found\' errors (404s).','',0,'modules/dblog/dblog.admin.inc'),('admin/reports/search','','','user_access','a:1:{i:0;s:19:\"access site reports\";}','dblog_top','a:1:{i:0;s:6:\"search\";}','',7,3,0,'','admin/reports/search','Top search phrases','t','','','a:0:{}',6,'View most popular search phrases.','',0,'modules/dblog/dblog.admin.inc'),('admin/config/user-interface','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/user-interface','User interface','t','','','a:0:{}',6,'Tools that enhance the user interface.','right',-15,'modules/system/system.admin.inc'),('admin/reports/views-plugins','','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_plugin_list','a:0:{}','',7,3,0,'','admin/reports/views-plugins','Views plugins','t','','','a:0:{}',6,'Overview of plugins used in all views.','',0,'sites/all/modules/contrib/views/includes/admin.inc'),('admin/config/services','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/services','Web services','t','','','a:0:{}',6,'Tools related to web services.','right',0,'modules/system/system.admin.inc'),('admin/config/workflow','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/workflow','Workflow','t','','','a:0:{}',6,'Content workflow, editorial workflow tools.','right',5,'modules/system/system.admin.inc'),('admin/config/date','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/date','Date API','t','','','a:0:{}',6,'Settings for modules the use the Date API.','left',-10,'modules/system/system.admin.inc'),('node/%/delete','a:1:{i:1;s:9:\"node_load\";}','','node_access','a:2:{i:0;s:6:\"delete\";i:1;i:1;}','drupal_get_form','a:2:{i:0;s:19:\"node_delete_confirm\";i:1;i:1;}','',5,3,2,'node/%','node/%','Delete','t','','','a:0:{}',132,'','',1,'modules/node/node.pages.inc'),('node/%/edit','a:1:{i:1;s:9:\"node_load\";}','','node_access','a:2:{i:0;s:6:\"update\";i:1;i:1;}','node_page_edit','a:1:{i:0;i:1;}','',5,3,3,'node/%','node/%','Edit','t','','','a:0:{}',132,'','',0,'modules/node/node.pages.inc'),('admin/config/people','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/people','People','t','','','a:0:{}',6,'Configure user accounts.','left',-20,'modules/system/system.admin.inc'),('taxonomy/term/%','a:1:{i:2;s:18:\"taxonomy_term_load\";}','','user_access','a:1:{i:0;s:14:\"access content\";}','taxonomy_term_page','a:1:{i:0;i:2;}','',6,3,0,'','taxonomy/term/%','Taxonomy term','taxonomy_term_title','a:1:{i:0;i:2;}','','a:0:{}',6,'','',0,'modules/taxonomy/taxonomy.pages.inc'),('node/add/article','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:7:\"article\";}','node_add','a:1:{i:0;s:7:\"article\";}','',7,3,0,'','node/add/article','Article','check_plain','','','a:0:{}',6,'Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.','',0,'modules/node/node.pages.inc'),('node/add/page','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:4:\"page\";}','node_add','a:1:{i:0;s:4:\"page\";}','',7,3,0,'','node/add/page','Basic page','check_plain','','','a:0:{}',6,'Use <em>basic pages</em> for your static content, such as an \'About us\' page.','',0,'modules/node/node.pages.inc'),('admin/structure/ctools-content','','','ctools_export_ui_task_access','a:2:{i:0;s:21:\"ctools_custom_content\";i:1;s:4:\"list\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:21:\"ctools_custom_content\";i:1;s:4:\"list\";}','',7,3,0,'','admin/structure/ctools-content','Custom content panes','t','','','a:0:{}',6,'Add, edit or delete custom content panes.','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('node/add/data-center','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:11:\"data_center\";}','node_add','a:1:{i:0;s:11:\"data_center\";}','',7,3,0,'','node/add/data-center','Data Center','check_plain','','','a:0:{}',6,'','',0,'modules/node/node.pages.inc'),('node/add/device','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:6:\"device\";}','node_add','a:1:{i:0;s:6:\"device\";}','',7,3,0,'','node/add/device','Device','check_plain','','','a:0:{}',6,'A physical hard drive available to a host.','',0,'modules/node/node.pages.inc'),('node/add/host','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:4:\"host\";}','node_add','a:1:{i:0;s:4:\"host\";}','',7,3,0,'','node/add/host','Host','check_plain','','','a:0:{}',6,'An ESXi 5.0 host on a vCenter','',0,'modules/node/node.pages.inc'),('admin/structure/mini-panels','','','ctools_export_ui_task_access','a:2:{i:0;s:11:\"panels_mini\";i:1;s:4:\"list\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:11:\"panels_mini\";i:1;s:4:\"list\";}','',7,3,0,'','admin/structure/mini-panels','Mini panels','t','','','a:0:{}',6,'Add, edit or delete mini panels, which can be used as blocks or content panes in other panels.','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('node/add/panel','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:5:\"panel\";}','node_add','a:1:{i:0;s:5:\"panel\";}','',7,3,0,'','node/add/panel','Panel','check_plain','','','a:0:{}',6,'A panel layout broken up into rows and columns.','',0,'modules/node/node.pages.inc'),('node/add/vm-cache-space','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:14:\"vm_cache_space\";}','node_add','a:1:{i:0;s:14:\"vm_cache_space\";}','',7,3,0,'','node/add/vm-cache-space','VM Cache Space','check_plain','','','a:0:{}',6,'Stores all the details related to Cache Space for any VM','',0,'modules/node/node.pages.inc'),('node/add/vm-metrics','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:10:\"vm_metrics\";}','node_add','a:1:{i:0;s:10:\"vm_metrics\";}','',7,3,0,'','node/add/vm-metrics','VM metrics','check_plain','','','a:0:{}',6,'Stores the metrics data of VMs.','',0,'modules/node/node.pages.inc'),('admin/structure/views','','','ctools_export_ui_task_access','a:2:{i:0;s:8:\"views_ui\";i:1;s:4:\"list\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:8:\"views_ui\";i:1;s:4:\"list\";}','',7,3,0,'','admin/structure/views','Views','t','','','a:0:{}',6,'Manage customized lists of content.','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('node/add/virtual-machine','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:15:\"virtual_machine\";}','node_add','a:1:{i:0;s:15:\"virtual_machine\";}','',7,3,0,'','node/add/virtual-machine','Virtual Machine','check_plain','','','a:0:{}',6,'','',0,'modules/node/node.pages.inc'),('node/add/vcenter','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:7:\"vcenter\";}','node_add','a:1:{i:0;s:7:\"vcenter\";}','',7,3,0,'','node/add/vcenter','vCenter','check_plain','','','a:0:{}',6,'Add new vCenter','',0,'modules/node/node.pages.inc'),('node/add/vdisk','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:5:\"vdisk\";}','node_add','a:1:{i:0;s:5:\"vdisk\";}','',7,3,0,'','node/add/vdisk','vDisk','check_plain','','','a:0:{}',6,'A virtual disk that is located on a VM','',0,'modules/node/node.pages.inc'),('node/add/vdisk-metrics','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:13:\"vdisk_metrics\";}','node_add','a:1:{i:0;s:13:\"vdisk_metrics\";}','',7,3,0,'','node/add/vdisk-metrics','vDisk metrics','check_plain','','','a:0:{}',6,'The metrics from the vDisks.','',0,'modules/node/node.pages.inc'),('search/node/%','a:1:{i:2;a:1:{s:14:\"menu_tail_load\";a:2:{i:0;s:4:\"%map\";i:1;s:6:\"%index\";}}}','a:1:{i:2;s:16:\"menu_tail_to_arg\";}','_search_menu_access','a:1:{i:0;s:4:\"node\";}','search_view','a:2:{i:0;s:4:\"node\";i:1;i:2;}','',6,3,1,'search/node','search/node/%','Content','t','','','a:0:{}',132,'','',0,'modules/search/search.pages.inc'),('admin/appearance/settings/global','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','drupal_get_form','a:1:{i:0;s:21:\"system_theme_settings\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Global settings','t','','','a:0:{}',140,'','',-1,'modules/system/system.admin.inc'),('admin/structure/types/list','','','user_access','a:1:{i:0;s:24:\"administer content types\";}','node_overview_types','a:0:{}','',15,4,1,'admin/structure/types','admin/structure/types','List','t','','','a:0:{}',140,'','',-10,'modules/node/content_types.inc'),('admin/structure/taxonomy/list','','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:1:{i:0;s:30:\"taxonomy_overview_vocabularies\";}','',15,4,1,'admin/structure/taxonomy','admin/structure/taxonomy','List','t','','','a:0:{}',140,'','',-10,'modules/taxonomy/taxonomy.admin.inc'),('admin/reports/fields/list','','','user_access','a:1:{i:0;s:24:\"administer content types\";}','field_ui_fields_list','a:0:{}','',15,4,1,'admin/reports/fields','admin/reports/fields','List','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/menu/list','','','user_access','a:1:{i:0;s:15:\"administer menu\";}','menu_overview_page','a:0:{}','',15,4,1,'admin/structure/menu','admin/structure/menu','List menus','t','','','a:0:{}',140,'','',-10,'modules/menu/menu.admin.inc'),('admin/content/comment/new','','','user_access','a:1:{i:0;s:19:\"administer comments\";}','comment_admin','a:0:{}','',15,4,1,'admin/content/comment','admin/content','Published comments','t','','','a:0:{}',140,'','',-10,'modules/comment/comment.admin.inc'),('taxonomy/term/%/view','a:1:{i:2;s:18:\"taxonomy_term_load\";}','','user_access','a:1:{i:0;s:14:\"access content\";}','taxonomy_term_page','a:1:{i:0;i:2;}','',13,4,1,'taxonomy/term/%','taxonomy/term/%','View','t','','','a:0:{}',140,'','',0,'modules/taxonomy/taxonomy.pages.inc'),('user/%/edit/account','a:1:{i:1;a:1:{s:18:\"user_category_load\";a:2:{i:0;s:4:\"%map\";i:1;s:6:\"%index\";}}}','','user_edit_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:17:\"user_profile_form\";i:1;i:1;}','',11,4,1,'user/%/edit','user/%','Account','t','','','a:0:{}',140,'','',0,'modules/user/user.pages.inc'),('admin/modules/list/confirm','','','user_access','a:1:{i:0;s:18:\"administer modules\";}','drupal_get_form','a:1:{i:0;s:14:\"system_modules\";}','',15,4,0,'','admin/modules/list/confirm','List','t','','','a:0:{}',4,'','',0,'modules/system/system.admin.inc'),('admin/people/permissions/list','','','user_access','a:1:{i:0;s:22:\"administer permissions\";}','drupal_get_form','a:1:{i:0;s:22:\"user_admin_permissions\";}','',15,4,1,'admin/people/permissions','admin/people','Permissions','t','','','a:0:{}',140,'Determine access to features by selecting permissions for roles.','',-8,'modules/user/user.admin.inc'),('node/add/panel/choose-layout','','','user_access','a:1:{i:0;s:18:\"create panel-nodes\";}','panels_node_add','a:0:{}','',15,4,0,'','node/add/panel/choose-layout','Choose layout','t','','','a:0:{}',0,'','',0,''),('admin/structure/menu/parents','','','user_access','a:1:{i:0;b:1;}','menu_parent_options_js','a:0:{}','',15,4,0,'','admin/structure/menu/parents','Parent menu items','t','','','a:0:{}',0,'','',0,''),('admin/structure/mini-panels/settings','','','user_access','a:1:{i:0;s:18:\"create mini panels\";}','panels_mini_settings','a:0:{}','',15,4,1,'admin/structure/mini-panels','admin/structure/mini-panels','Settings','t','','','a:0:{}',132,'','',0,''),('admin/modules/uninstall/confirm','','','user_access','a:1:{i:0;s:18:\"administer modules\";}','drupal_get_form','a:1:{i:0;s:24:\"system_modules_uninstall\";}','',15,4,0,'','admin/modules/uninstall/confirm','Uninstall','t','','','a:0:{}',4,'','',0,'modules/system/system.admin.inc'),('admin/config/development/coder','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','coder_review_page','a:0:{}','',15,4,0,'','admin/config/development/coder','Coder','t','','','a:0:{}',6,'Select code review plugins and modules, and upgrade files.','',0,''),('host/ssd/initialize/%','a:1:{i:3;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','mercury_management_initialize_host_ssd','a:1:{i:0;i:3;}','',14,4,0,'','host/ssd/initialize/%','','t','','','a:0:{}',0,'','',0,''),('host/hypervisor-bundle/install/%','a:1:{i:3;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','mercury_management_installhypervisorbundleonhost','a:1:{i:0;i:3;}','',14,4,0,'','host/hypervisor-bundle/install/%','','t','','','a:0:{}',0,'','',0,''),('vm/fmc/install/%','a:1:{i:3;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','mercury_management_installmercurydriveronvm','a:1:{i:0;i:3;}','',14,4,0,'','vm/fmc/install/%','','t','','','a:0:{}',0,'','',0,''),('fmc/operation/%/%','a:2:{i:2;N;i:3;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','mercury_management_no_operation_redirect','a:2:{i:0;i:2;i:1;i:3;}','',12,4,0,'','fmc/operation/%/%','','t','','','a:0:{}',0,'','',0,''),('host/hypervisor-bundle/uninstall/%','a:1:{i:3;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','mercury_management_uninstallhypervisorbundlefromhost','a:1:{i:0;i:3;}','',14,4,0,'','host/hypervisor-bundle/uninstall/%','','t','','','a:0:{}',0,'','',0,''),('vm/fmc/uninstall/%','a:1:{i:3;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','mercury_management_uninstallmercurydriveronvm','a:1:{i:0;i:3;}','',14,4,0,'','vm/fmc/uninstall/%','','t','','','a:0:{}',0,'','',0,''),('host/hypervisor-bundle/upgrade/%','a:1:{i:3;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','mercury_management_upgradehypervisorbundlefromhost','a:1:{i:0;i:3;}','',14,4,0,'','host/hypervisor-bundle/upgrade/%','','t','','','a:0:{}',0,'','',0,''),('vm/fmc/upgrade/%','a:1:{i:3;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','mercury_management_upgrademercurydriveronvm','a:1:{i:0;i:3;}','',14,4,0,'','vm/fmc/upgrade/%','','t','','','a:0:{}',0,'','',0,''),('host/refresh/bulk/%','a:1:{i:3;N;}','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','mercury_utilities_host_bulk_refresh_action','a:1:{i:0;i:3;}','',14,4,0,'','host/refresh/bulk/%','','t','','','a:0:{}',0,'','',0,''),('vm/refresh/bulk/%','a:1:{i:3;N;}','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','mercury_utilities_vm_bulk_refresh_action','a:1:{i:0;i:3;}','',14,4,0,'','vm/refresh/bulk/%','','t','','','a:0:{}',0,'','',0,''),('vm/unallocate/bulk/%','a:1:{i:3;N;}','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','mercury_utilities_vm_bulk_unallocate_action','a:1:{i:0;i:3;}','',14,4,0,'','vm/unallocate/bulk/%','','t','','','a:0:{}',0,'','',0,''),('vm/refresh/%/%','a:2:{i:2;N;i:3;N;}','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','mercury_utilities_vm_part_refresh_action','a:2:{i:0;i:2;i:1;i:3;}','',12,4,0,'','vm/refresh/%/%','','t','','','a:0:{}',0,'','',0,''),('bulk/cachemetrics/%/%','a:2:{i:2;N;i:3;N;}','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','mercury_utilities_vm_settings_bulkaction_cachemetrics','a:2:{i:0;i:2;i:1;i:3;}','',12,4,0,'','bulk/cachemetrics/%/%','','t','','','a:0:{}',0,'','',0,''),('bulk/cachemode/%/%','a:2:{i:2;N;i:3;N;}','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','mercury_utilities_vm_settings_bulkaction_cachemode','a:2:{i:0;i:2;i:1;i:3;}','',12,4,0,'','bulk/cachemode/%/%','','t','','','a:0:{}',0,'','',0,''),('bulk/cachestate/%/%','a:2:{i:2;N;i:3;N;}','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','mercury_utilities_vm_settings_bulkaction_cachestate','a:2:{i:0;i:2;i:1;i:3;}','',12,4,0,'','bulk/cachestate/%/%','','t','','','a:0:{}',0,'','',0,''),('vm/settings/%/%','a:2:{i:2;N;i:3;N;}','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','mercury_utilities_vm_settings_cachespace','a:2:{i:0;i:2;i:1;i:3;}','',12,4,0,'','vm/settings/%/%','','t','','','a:0:{}',0,'','',0,''),('admin/structure/panels/dashboard','','','user_access','a:1:{i:0;s:20:\"use panels dashboard\";}','panels_admin_page','a:0:{}','',15,4,1,'admin/structure/panels','admin/structure/panels','Dashboard','t','','','a:0:{}',140,'','',-10,'sites/all/modules/contrib/panels/includes/callbacks.inc'),('ctools_ajax_sample/%/tablenix/%','a:2:{i:1;s:14:\"ctools_js_load\";i:3;N;}','','1','a:0:{}','ctools_ajax_sample_tablenix','a:2:{i:0;i:1;i:1;i:3;}','',10,4,0,'','ctools_ajax_sample/%/tablenix/%','Hello World','t','','','a:0:{}',0,'','',0,''),('admin/reports/status/php','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','system_php','a:0:{}','',15,4,0,'','admin/reports/status/php','PHP','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('ctools_ajax_sample/%/login/%','a:2:{i:1;s:14:\"ctools_js_load\";i:3;N;}','','1','a:0:{}','ctools_ajax_sample_login_success','a:2:{i:0;i:1;i:1;i:3;}','',10,4,0,'','ctools_ajax_sample/%/login/%','Post-Login Action','t','','','a:0:{}',0,'','',0,''),('admin/reports/status/run-cron','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','system_run_cron','a:0:{}','',15,4,0,'','admin/reports/status/run-cron','Run cron','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/content/comment/approval','','','user_access','a:1:{i:0;s:19:\"administer comments\";}','comment_admin','a:1:{i:0;s:8:\"approval\";}','',15,4,1,'admin/content/comment','admin/content','Unapproved comments','comment_count_unpublished','','','a:0:{}',132,'','',0,'modules/comment/comment.admin.inc'),('ctools/context/ajax/add','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_context_ajax_item_add','a:0:{}','',15,4,0,'','ctools/context/ajax/add','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/context-admin.inc'),('ctools/context/ajax/delete','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_context_ajax_item_delete','a:0:{}','',15,4,0,'','ctools/context/ajax/delete','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/context-admin.inc'),('ctools/context/ajax/configure','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_context_ajax_item_edit','a:0:{}','',15,4,0,'','ctools/context/ajax/configure','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/context-admin.inc'),('ctools-popups/%/mmc/rediscover','a:1:{i:1;s:14:\"ctools_js_load\";}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','ctools_popups_mmc_rediscover','a:1:{i:0;i:1;}','',11,4,0,'','ctools-popups/%/mmc/rediscover','','t','','','a:0:{}',6,'','',0,''),('analytics/%/entity/%','a:2:{i:1;s:14:\"ctools_js_load\";i:3;N;}','','user_access','a:1:{i:0;s:14:\"access content\";}','famc_analytics_ctools_popup','a:2:{i:0;i:1;i:1;i:3;}','',10,4,0,'','analytics/%/entity/%','','t','','','a:0:{}',0,'','',0,''),('admin/config/system/actions','','','user_access','a:1:{i:0;s:18:\"administer actions\";}','system_actions_manage','a:0:{}','',15,4,0,'','admin/config/system/actions','Actions','t','','','a:0:{}',6,'Manage the actions defined for your site.','',0,'modules/system/system.admin.inc'),('admin/structure/block/add','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:1:{i:0;s:20:\"block_add_block_form\";}','',15,4,1,'admin/structure/block','admin/structure/block','Add block','t','','','a:0:{}',388,'','',0,'modules/block/block.admin.inc'),('admin/structure/types/add','','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:1:{i:0;s:14:\"node_type_form\";}','',15,4,1,'admin/structure/types','admin/structure/types','Add content type','t','','','a:0:{}',388,'','',0,'modules/node/content_types.inc'),('admin/structure/menu/add','','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:2:{i:0;s:14:\"menu_edit_menu\";i:1;s:3:\"add\";}','',15,4,1,'admin/structure/menu','admin/structure/menu','Add menu','t','','','a:0:{}',388,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/views/add','','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_add_page','a:0:{}','',15,4,1,'admin/structure/views','admin/structure/views','Add new view','t','','','a:0:{}',388,'','',0,'sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/views/add-template','','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_add_template_page','a:0:{}','',15,4,1,'admin/structure/views','admin/structure/views','Add view from template','t','','','a:0:{}',388,'','',0,'sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/taxonomy/add','','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:1:{i:0;s:24:\"taxonomy_form_vocabulary\";}','',15,4,1,'admin/structure/taxonomy','admin/structure/taxonomy','Add vocabulary','t','','','a:0:{}',388,'','',0,'modules/taxonomy/taxonomy.admin.inc'),('config/fmc/settings/agents','','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','drupal_get_form','a:1:{i:0;s:38:\"mercury_utilities_agents_settings_form\";}','',15,4,1,'config/fmc/settings','config/fmc/settings','Agents','t','','','a:0:{}',132,'Agent Settings','',12,''),('admin/structure/pages/argument','','','user_access','a:1:{i:0;s:23:\"administer page manager\";}','page_manager_page_subtask_argument_ajax','a:0:{}','',15,4,0,'','admin/structure/pages/argument','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.admin.inc'),('admin/config/famc_analytics/clear_metrics','','','user_access','a:1:{i:0;s:14:\"access content\";}','famc_analytics_clear_metrics','a:0:{}','',15,4,0,'','admin/config/famc_analytics/clear_metrics','Clear Flash Accel metrics','t','','','a:0:{}',6,'Clears all metric data.','',0,''),('admin/appearance/settings/bartik','','','_system_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:25:\"themes/bartik/bartik.info\";s:4:\"name\";s:6:\"bartik\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:6:\"Bartik\";s:11:\"description\";s:48:\"A flexible, recolorable theme with many regions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:7:\"regions\";a:20:{s:6:\"header\";s:6:\"Header\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"triptych_first\";s:14:\"Triptych first\";s:15:\"triptych_middle\";s:15:\"Triptych middle\";s:13:\"triptych_last\";s:13:\"Triptych last\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"0\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:28:\"themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','drupal_get_form','a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:6:\"bartik\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Bartik','t','','','a:0:{}',132,'','',0,'modules/system/system.admin.inc'),('admin/reports/event/%','a:1:{i:3;N;}','','user_access','a:1:{i:0;s:19:\"access site reports\";}','dblog_event','a:1:{i:0;i:3;}','',14,4,0,'','admin/reports/event/%','Details','t','','','a:0:{}',6,'','',0,'modules/dblog/dblog.admin.inc'),('config/fmc/settings/cron_job','','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','drupal_get_form','a:1:{i:0;s:36:\"mercury_utilities_cron_settings_form\";}','',15,4,1,'config/fmc/settings','config/fmc/settings','Discovery','t','','','a:0:{}',132,'Discovery Settings','',11,''),('admin/appearance/settings/garland','','','_system_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:27:\"themes/garland/garland.info\";s:4:\"name\";s:7:\"garland\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:7:\"Garland\";s:11:\"description\";s:111:\"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:8:\"settings\";a:1:{s:13:\"garland_width\";s:5:\"fluid\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:29:\"themes/garland/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','drupal_get_form','a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:7:\"garland\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Garland','t','','','a:0:{}',132,'','',0,'modules/system/system.admin.inc'),('config/fmc/settings/host','','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','drupal_get_form','a:1:{i:0;s:36:\"mercury_utilities_host_settings_form\";}','',15,4,1,'config/fmc/settings','config/fmc/settings','Host','t','','','a:0:{}',132,'Host Settings','',9,''),('admin/config/people/ip-blocking','','','user_access','a:1:{i:0;s:18:\"block IP addresses\";}','system_ip_blocking','a:0:{}','',15,4,0,'','admin/config/people/ip-blocking','IP address blocking','t','','','a:0:{}',6,'Manage blocked IP addresses.','',10,'modules/system/system.admin.inc'),('admin/structure/pages/list','','','user_access','a:1:{i:0;s:16:\"use page manager\";}','page_manager_list_page','a:0:{}','',15,4,1,'admin/structure/pages','admin/structure/pages','List','t','','ajax_base_page_theme','a:0:{}',140,'','',-10,'sites/all/modules/contrib/ctools/page_manager/page_manager.admin.inc'),('admin/config/people/login-destination','','','user_access','a:1:{i:0;s:16:\"administer users\";}','login_destination_overview','a:0:{}','',15,4,0,'','admin/config/people/login-destination','Login destinations','t','','','a:0:{}',6,'Customize the destination that the user is redirected to after login.','',10,'sites/all/modules/contrib/login_destination/login_destination.admin.inc'),('config/fmc/settings/log','','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','drupal_get_form','a:1:{i:0;s:35:\"mercury_utilities_log_settings_form\";}','',15,4,1,'config/fmc/settings','config/fmc/settings','Logs','t','','','a:0:{}',132,'Log Settings','',14,''),('admin/appearance/settings/mercury','','','_system_themes_access','a:1:{i:0;O:8:\"stdClass\":13:{s:8:\"filename\";s:37:\"sites/all/themes/mercury/mercury.info\";s:4:\"name\";s:7:\"mercury\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:7:\"Mercury\";s:11:\"description\";s:26:\"Mercury theme for Drupal 7\";s:10:\"screenshot\";s:46:\"sites/all/themes/mercury/images/screenshot.gif\";s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:7:\"mercury\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:14:{s:8:\"page_top\";s:8:\"Page top\";s:16:\"header_top_right\";s:16:\"Header top right\";s:6:\"header\";s:6:\"Header\";s:9:\"highlight\";s:9:\"Highlight\";s:4:\"help\";s:4:\"Help\";s:11:\"title_right\";s:11:\"Title Right\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"sidebar_second\";s:14:\"Second sidebar\";s:6:\"footer\";s:6:\"Footer\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:6:\"search\";i:6;s:7:\"favicon\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:11:\"stylesheets\";a:2:{s:3:\"all\";a:5:{s:15:\"css/default.css\";s:40:\"sites/all/themes/mercury/css/default.css\";s:14:\"css/layout.css\";s:39:\"sites/all/themes/mercury/css/layout.css\";s:13:\"css/style.css\";s:38:\"sites/all/themes/mercury/css/style.css\";s:17:\"css/node-view.css\";s:42:\"sites/all/themes/mercury/css/node-view.css\";s:17:\"css/analytics.css\";s:42:\"sites/all/themes/mercury/css/analytics.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:38:\"sites/all/themes/mercury/css/print.css\";}}s:7:\"scripts\";a:6:{s:19:\"js/jquery-ui.min.js\";s:44:\"sites/all/themes/mercury/js/jquery-ui.min.js\";s:29:\"js/jquery.mCustomScrollbar.js\";s:54:\"sites/all/themes/mercury/js/jquery.mCustomScrollbar.js\";s:27:\"js/jquery.mousewheel.min.js\";s:52:\"sites/all/themes/mercury/js/jquery.mousewheel.min.js\";s:24:\"js/jquery.tablesorter.js\";s:49:\"sites/all/themes/mercury/js/jquery.tablesorter.js\";s:32:\"js/jquery.tablesorter.widgets.js\";s:57:\"sites/all/themes/mercury/js/jquery.tablesorter.widgets.js\";s:14:\"js/function.js\";s:39:\"sites/all/themes/mercury/js/function.js\";}s:7:\"compass\";a:3:{s:6:\"status\";s:1:\"1\";s:8:\"sass_dir\";s:4:\"sass\";s:7:\"css_dir\";s:3:\"css\";}s:8:\"settings\";a:4:{s:12:\"mercury_tabs\";s:1:\"1\";s:28:\"mercury_breadcrumb_separator\";s:2:\"»\";s:14:\"wireframe_mode\";s:1:\"0\";s:14:\"clear_registry\";s:1:\"0\";}s:7:\"version\";s:7:\"7.x-2.1\";s:9:\"datestamp\";s:10:\"1334122542\";s:3:\"php\";s:5:\"5.2.4\";s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:5:{s:15:\"css/default.css\";s:40:\"sites/all/themes/mercury/css/default.css\";s:14:\"css/layout.css\";s:39:\"sites/all/themes/mercury/css/layout.css\";s:13:\"css/style.css\";s:38:\"sites/all/themes/mercury/css/style.css\";s:17:\"css/node-view.css\";s:42:\"sites/all/themes/mercury/css/node-view.css\";s:17:\"css/analytics.css\";s:42:\"sites/all/themes/mercury/css/analytics.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:38:\"sites/all/themes/mercury/css/print.css\";}}s:7:\"scripts\";a:6:{s:19:\"js/jquery-ui.min.js\";s:44:\"sites/all/themes/mercury/js/jquery-ui.min.js\";s:29:\"js/jquery.mCustomScrollbar.js\";s:54:\"sites/all/themes/mercury/js/jquery.mCustomScrollbar.js\";s:27:\"js/jquery.mousewheel.min.js\";s:52:\"sites/all/themes/mercury/js/jquery.mousewheel.min.js\";s:24:\"js/jquery.tablesorter.js\";s:49:\"sites/all/themes/mercury/js/jquery.tablesorter.js\";s:32:\"js/jquery.tablesorter.widgets.js\";s:57:\"sites/all/themes/mercury/js/jquery.tablesorter.widgets.js\";s:14:\"js/function.js\";s:39:\"sites/all/themes/mercury/js/function.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}','drupal_get_form','a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:7:\"mercury\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Mercury','t','','','a:0:{}',132,'','',0,'modules/system/system.admin.inc'),('config/fmc/settings/migration','','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','drupal_get_form','a:1:{i:0;s:41:\"mercury_utilities_migration_settings_form\";}','',15,4,1,'config/fmc/settings','config/fmc/settings','Migration','t','','','a:0:{}',132,'Migration Settings','',13,''),('admin/reports/status/rebuild','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','drupal_get_form','a:1:{i:0;s:30:\"node_configure_rebuild_confirm\";}','',15,4,0,'','admin/reports/status/rebuild','Rebuild permissions','t','','','a:0:{}',0,'','',0,'modules/node/node.admin.inc'),('admin/config/search/search_api','','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','search_api_admin_overview','a:0:{}','',15,4,0,'','admin/config/search/search_api','Search API','t','','','a:0:{}',6,'Create and configure search engines.','',0,'sites/all/modules/contrib/search_api/search_api.admin.inc'),('admin/structure/menu/settings','','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:1:{i:0;s:14:\"menu_configure\";}','',15,4,1,'admin/structure/menu','admin/structure/menu','Settings','t','','','a:0:{}',132,'','',5,'modules/menu/menu.admin.inc'),('admin/structure/panels/settings','','','user_access','a:1:{i:0;s:20:\"use panels dashboard\";}','drupal_get_form','a:1:{i:0;s:26:\"panels_admin_settings_page\";}','',15,4,1,'admin/structure/panels','admin/structure/panels','Settings','t','','','a:0:{}',132,'','',0,'sites/all/modules/contrib/panels/includes/callbacks.inc'),('admin/appearance/settings/seven','','','_system_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/seven/seven.info\";s:4:\"name\";s:5:\"seven\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:5:\"Seven\";s:11:\"description\";s:65:\"A simple one-column, tableless, fluid width administration theme.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"1\";}s:7:\"regions\";a:8:{s:7:\"content\";s:7:\"Content\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','drupal_get_form','a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:5:\"seven\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Seven','t','','','a:0:{}',132,'','',0,'modules/system/system.admin.inc'),('admin/config/user-interface/shortcut','','','user_access','a:1:{i:0;s:20:\"administer shortcuts\";}','shortcut_set_admin','a:0:{}','',15,4,0,'','admin/config/user-interface/shortcut','Shortcuts','t','','','a:0:{}',6,'Add and modify shortcut sets.','',0,'modules/shortcut/shortcut.admin.inc'),('admin/appearance/settings/stark','','','_system_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/stark/stark.info\";s:4:\"name\";s:5:\"stark\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:17:{s:4:\"name\";s:5:\"Stark\";s:11:\"description\";s:208:\"This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/stark/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','drupal_get_form','a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:5:\"stark\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Stark','t','','','a:0:{}',132,'','',0,'modules/system/system.admin.inc'),('admin/config/search/path','','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','path_admin_overview','a:0:{}','',15,4,0,'','admin/config/search/path','URL aliases','t','','','a:0:{}',6,'Change your site\'s URL paths by aliasing them.','',-5,'modules/path/path.admin.inc'),('config/fmc/user/%','a:1:{i:3;s:9:\"user_load\";}','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','drupal_get_form','a:2:{i:0;s:36:\"mercury_utilities_user_settings_form\";i:1;i:3;}','',14,4,0,'','config/fmc/user/%','User Settings','t','','','a:0:{}',20,'User Settings','',0,''),('config/fmc/settings/vm','','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','drupal_get_form','a:1:{i:0;s:34:\"mercury_utilities_vm_settings_form\";}','',15,4,1,'config/fmc/settings','config/fmc/settings','VM','t','','','a:0:{}',132,'VM Settings','',10,''),('admin/structure/pages/wizard','','','user_access','a:1:{i:0;s:16:\"use page manager\";}','page_manager_page_wizard_list','a:1:{i:0;i:4;}','',15,4,1,'admin/structure/pages','admin/structure/pages','Wizards','t','','ajax_base_page_theme','a:0:{}',132,'','',-5,'sites/all/modules/contrib/ctools/includes/page-wizard.inc'),('config/fmc/settings/vcenter','','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','drupal_get_form','a:1:{i:0;s:39:\"mercury_utilities_vcenter_settings_form\";}','',15,4,1,'config/fmc/settings','config/fmc/settings','vCenter','t','','','a:0:{}',140,'vCenter Settings','',8,''),('admin/config/people/accounts','','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:1:{i:0;s:19:\"user_admin_settings\";}','',15,4,0,'','admin/config/people/accounts','Account settings','t','','','a:0:{}',6,'Configure default behavior of users, including registration requirements, e-mails, fields, and user pictures.','',-10,'modules/user/user.admin.inc'),('admin/structure/pages/add','','','user_access','a:1:{i:0;s:23:\"administer page manager\";}','page_manager_page_add_subtask','a:0:{}','',15,4,1,'admin/structure/pages','admin/structure/pages','Add custom page','t','','ajax_base_page_theme','a:0:{}',388,'','',0,'sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.admin.inc'),('admin/config/administration/admin_menu','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:25:\"admin_menu_theme_settings\";}','',15,4,0,'','admin/config/administration/admin_menu','Administration menu','t','','','a:0:{}',6,'Adjust administration menu settings.','',0,'sites/all/modules/contrib/admin_menu/admin_menu.inc'),('admin/config/search/clean-urls','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:25:\"system_clean_url_settings\";}','',15,4,0,'','admin/config/search/clean-urls','Clean URLs','t','','','a:0:{}',6,'Enable or disable clean URLs for your site.','',5,'modules/system/system.admin.inc'),('admin/config/system/cron','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:20:\"system_cron_settings\";}','',15,4,0,'','admin/config/system/cron','Cron','t','','','a:0:{}',6,'Manage automatic site maintenance tasks.','',20,'modules/system/system.admin.inc'),('admin/config/date/date_popup','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:19:\"date_popup_settings\";}','',15,4,0,'','admin/config/date/date_popup','Date Popup','t','','','a:0:{}',6,'Configure the Date Popup settings.','',0,''),('admin/config/regional/date-time','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:25:\"system_date_time_settings\";}','',15,4,0,'','admin/config/regional/date-time','Date and time','t','','','a:0:{}',6,'Configure display formats for date and time.','',-15,'modules/system/system.admin.inc'),('taxonomy/term/%/edit','a:1:{i:2;s:18:\"taxonomy_term_load\";}','','taxonomy_term_edit_access','a:1:{i:0;i:2;}','drupal_get_form','a:3:{i:0;s:18:\"taxonomy_form_term\";i:1;i:2;i:2;N;}','',13,4,1,'taxonomy/term/%','taxonomy/term/%','Edit','t','','','a:0:{}',132,'','',10,'modules/taxonomy/taxonomy.admin.inc'),('config/fmc/settings/export_import','','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','drupal_get_form','a:1:{i:0;s:36:\"mercury_utilities_export_import_form\";}','',15,4,1,'config/fmc/settings','config/fmc/settings','Export / Import','t','','','a:0:{}',132,'Export / Import','',15,'sites/all/modules/custom/mercury_utilities/includes/export_import.inc'),('admin/config/media/file-system','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:27:\"system_file_system_settings\";}','',15,4,0,'','admin/config/media/file-system','File system','t','','','a:0:{}',6,'Tell Drupal where to store uploaded files and how they are accessed.','',-10,'modules/system/system.admin.inc'),('admin/config/media/image-toolkit','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:29:\"system_image_toolkit_settings\";}','',15,4,0,'','admin/config/media/image-toolkit','Image toolkit','t','','','a:0:{}',6,'Choose which image toolkit to use if you have installed optional toolkits.','',20,'modules/system/system.admin.inc'),('admin/structure/views/import','','','views_import_access','a:1:{i:0;s:16:\"administer views\";}','drupal_get_form','a:1:{i:0;s:20:\"views_ui_import_page\";}','',15,4,1,'admin/structure/views','admin/structure/views','Import','t','','','a:0:{}',388,'','',0,'sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/pages/import','','','ctools_access_multiperm','a:2:{i:0;s:23:\"administer page manager\";i:1;s:20:\"use PHP for settings\";}','drupal_get_form','a:2:{i:0;s:32:\"page_manager_page_import_subtask\";i:1;s:4:\"page\";}','',15,4,1,'admin/structure/pages','admin/structure/pages','Import page','t','','ajax_base_page_theme','a:0:{}',388,'','',0,'sites/all/modules/contrib/ctools/page_manager/plugins/tasks/page.admin.inc'),('admin/config/development/logging','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:23:\"system_logging_settings\";}','',15,4,0,'','admin/config/development/logging','Logging and errors','t','','','a:0:{}',6,'Settings for logging and alerts modules. Various modules can route Drupal\'s system events to different destinations, such as syslog, database, email, etc.','',-15,'modules/system/system.admin.inc'),('famc_analytics/get_view_content/%/%','a:2:{i:2;N;i:3;N;}','','user_access','a:1:{i:0;s:14:\"access content\";}','famc_analytics_get_view_content','a:2:{i:0;i:2;i:1;i:3;}','',12,4,0,'','famc_analytics/get_view_content/%/%','View content','t','','','a:0:{}',0,'Returns the content of a view.','',0,''),('admin/config/development/maintenance','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:28:\"system_site_maintenance_mode\";}','',15,4,0,'','admin/config/development/maintenance','Maintenance mode','t','','','a:0:{}',6,'Take the site offline for maintenance or bring it back online.','',-10,'modules/system/system.admin.inc'),('admin/config/user-interface/modulefilter','','','user_access','a:1:{i:0;s:24:\"administer module filter\";}','drupal_get_form','a:1:{i:0;s:22:\"module_filter_settings\";}','',15,4,0,'','admin/config/user-interface/modulefilter','Module filter','t','','','a:0:{}',6,'Configure settings for Module Filter.','',0,'sites/all/modules/contrib/module_filter/module_filter.admin.inc'),('famc_analytics/get_metrics_content/%/%','a:2:{i:2;N;i:3;N;}','','user_access','a:1:{i:0;s:14:\"access content\";}','famc_analytics_get_metrics_content','a:2:{i:0;i:2;i:1;i:3;}','',12,4,0,'','famc_analytics/get_metrics_content/%/%','VM metrics','t','','','a:0:{}',0,'Returns the VM and vDisk metrics content to ajax calls.','',0,''),('admin/config/development/performance','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:27:\"system_performance_settings\";}','',15,4,0,'','admin/config/development/performance','Performance','t','','','a:0:{}',6,'Enable or disable page caching for anonymous users and set CSS and JS bandwidth optimization options.','',-20,'modules/system/system.admin.inc'),('admin/config/services/rss-publishing','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:25:\"system_rss_feeds_settings\";}','',15,4,0,'','admin/config/services/rss-publishing','RSS publishing','t','','','a:0:{}',6,'Configure the site description, the number of items per feed and whether feeds should be titles/teasers/full-text.','',0,'modules/system/system.admin.inc'),('admin/config/regional/settings','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:24:\"system_regional_settings\";}','',15,4,0,'','admin/config/regional/settings','Regional settings','t','','','a:0:{}',6,'Settings for the site\'s default time zone and country.','',-20,'modules/system/system.admin.inc'),('admin/people/permissions/roles','','','user_access','a:1:{i:0;s:22:\"administer permissions\";}','drupal_get_form','a:1:{i:0;s:16:\"user_admin_roles\";}','',15,4,1,'admin/people/permissions','admin/people','Roles','t','','','a:0:{}',132,'List, edit, or add user roles.','',-5,'modules/user/user.admin.inc'),('admin/config/search/settings','','','user_access','a:1:{i:0;s:17:\"administer search\";}','drupal_get_form','a:1:{i:0;s:21:\"search_admin_settings\";}','',15,4,0,'','admin/config/search/settings','Search settings','t','','','a:0:{}',6,'Configure relevance settings for search and other indexing options.','',-10,'modules/search/search.admin.inc'),('admin/structure/views/settings','','','user_access','a:1:{i:0;s:16:\"administer views\";}','drupal_get_form','a:1:{i:0;s:29:\"views_ui_admin_settings_basic\";}','',15,4,1,'admin/structure/views','admin/structure/views','Settings','t','','','a:0:{}',132,'','',0,'sites/all/modules/contrib/views/includes/admin.inc'),('admin/config/system/site-information','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:32:\"system_site_information_settings\";}','',15,4,0,'','admin/config/system/site-information','Site information','t','','','a:0:{}',6,'Change site name, e-mail address, slogan, default front page, and number of posts per page, error pages.','',-20,'modules/system/system.admin.inc'),('admin/config/content/formats','','','user_access','a:1:{i:0;s:18:\"administer filters\";}','drupal_get_form','a:1:{i:0;s:21:\"filter_admin_overview\";}','',15,4,0,'','admin/config/content/formats','Text formats','t','','','a:0:{}',6,'Configure how content input by users is filtered, including allowed HTML tags. Also allows enabling of module-provided filters.','',0,'modules/filter/filter.admin.inc'),('admin/reports/fields/views-fields','','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_field_list','a:0:{}','',15,4,1,'admin/reports/fields','admin/reports/fields','Used in views','t','','','a:0:{}',132,'Overview of fields used in all views.','',0,'sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/ctools-content/add','','','ctools_export_ui_task_access','a:2:{i:0;s:21:\"ctools_custom_content\";i:1;s:3:\"add\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:21:\"ctools_custom_content\";i:1;s:3:\"add\";}','',15,4,1,'admin/structure/ctools-content','admin/structure/ctools-content','Add','t','','','a:0:{}',388,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/mini-panels/add','','','ctools_export_ui_task_access','a:2:{i:0;s:11:\"panels_mini\";i:1;s:3:\"add\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:11:\"panels_mini\";i:1;s:3:\"add\";}','',15,4,1,'admin/structure/mini-panels','admin/structure/mini-panels','Add','t','','','a:0:{}',388,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/ctools-content/import','','','ctools_export_ui_task_access','a:2:{i:0;s:21:\"ctools_custom_content\";i:1;s:6:\"import\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:21:\"ctools_custom_content\";i:1;s:6:\"import\";}','',15,4,1,'admin/structure/ctools-content','admin/structure/ctools-content','Import','t','','','a:0:{}',388,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/mini-panels/import','','','ctools_export_ui_task_access','a:2:{i:0;s:11:\"panels_mini\";i:1;s:6:\"import\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:11:\"panels_mini\";i:1;s:6:\"import\";}','',15,4,1,'admin/structure/mini-panels','admin/structure/mini-panels','Import','t','','','a:0:{}',388,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/ctools-content/list','','','ctools_export_ui_task_access','a:2:{i:0;s:21:\"ctools_custom_content\";i:1;s:4:\"list\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:21:\"ctools_custom_content\";i:1;s:4:\"list\";}','',15,4,1,'admin/structure/ctools-content','admin/structure/ctools-content','List','t','','','a:0:{}',140,'','',-10,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/mini-panels/list','','','ctools_export_ui_task_access','a:2:{i:0;s:11:\"panels_mini\";i:1;s:4:\"list\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:11:\"panels_mini\";i:1;s:4:\"list\";}','',15,4,1,'admin/structure/mini-panels','admin/structure/mini-panels','List','t','','','a:0:{}',140,'','',-10,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/views/list','','','ctools_export_ui_task_access','a:2:{i:0;s:8:\"views_ui\";i:1;s:4:\"list\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:8:\"views_ui\";i:1;s:4:\"list\";}','',15,4,1,'admin/structure/views','admin/structure/views','List','t','','','a:0:{}',140,'','',-10,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/config/system/logintoboggan','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:27:\"logintoboggan_main_settings\";}','',15,4,0,'','admin/config/system/logintoboggan','LoginToboggan','t','','','a:0:{}',6,'Set up custom login options like instant login, login redirects, pre-authorized validation roles, etc.','',0,'sites/all/modules/contrib/logintoboggan/logintoboggan.admin.inc'),('admin/structure/taxonomy/%','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:23:\"taxonomy_overview_terms\";i:1;i:3;}','',14,4,0,'','admin/structure/taxonomy/%','','taxonomy_admin_vocabulary_title_callback','a:1:{i:0;i:3;}','','a:0:{}',6,'','',0,'modules/taxonomy/taxonomy.admin.inc'),('taxonomy/term/%/feed','a:1:{i:2;s:18:\"taxonomy_term_load\";}','','user_access','a:1:{i:0;s:14:\"access content\";}','taxonomy_term_feed','a:1:{i:0;i:2;}','',13,4,0,'','taxonomy/term/%/feed','Taxonomy term','taxonomy_term_title','a:1:{i:0;i:2;}','','a:0:{}',0,'','',0,'modules/taxonomy/taxonomy.pages.inc'),('admin/structure/panels/layouts','','','ctools_export_ui_task_access','a:2:{i:0;s:14:\"panels_layouts\";i:1;s:4:\"list\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:14:\"panels_layouts\";i:1;s:4:\"list\";}','',15,4,1,'admin/structure/panels','admin/structure/panels','Layouts','t','','','a:0:{}',132,'Add, edit or delete custom content layouts.','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/config/people/login-destination/list','','','user_access','a:1:{i:0;s:16:\"administer users\";}','login_destination_overview','a:0:{}','',31,5,1,'admin/config/people/login-destination','admin/config/people/login-destination','List','t','','','a:0:{}',140,'','',-10,'sites/all/modules/contrib/login_destination/login_destination.admin.inc'),('admin/config/search/path/list','','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','path_admin_overview','a:0:{}','',31,5,1,'admin/config/search/path','admin/config/search/path','List','t','','','a:0:{}',140,'','',-10,'modules/path/path.admin.inc'),('admin/config/content/formats/list','','','user_access','a:1:{i:0;s:18:\"administer filters\";}','drupal_get_form','a:1:{i:0;s:21:\"filter_admin_overview\";}','',31,5,1,'admin/config/content/formats','admin/config/content/formats','List','t','','','a:0:{}',140,'','',0,'modules/filter/filter.admin.inc'),('admin/structure/taxonomy/%/list','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:23:\"taxonomy_overview_terms\";i:1;i:3;}','',29,5,1,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','List','t','','','a:0:{}',140,'','',-20,'modules/taxonomy/taxonomy.admin.inc'),('admin/config/search/search_api/overview','','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','search_api_admin_overview','a:0:{}','',31,5,1,'admin/config/search/search_api','admin/config/search/search_api','Overview','t','','','a:0:{}',140,'','',-10,'sites/all/modules/contrib/search_api/search_api.admin.inc'),('admin/config/people/accounts/settings','','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:1:{i:0;s:19:\"user_admin_settings\";}','',31,5,1,'admin/config/people/accounts','admin/config/people/accounts','Settings','t','','','a:0:{}',140,'','',-10,'modules/user/user.admin.inc'),('admin/structure/panels/settings/panels-mini','','','user_access','a:1:{i:0;s:18:\"create mini panels\";}','panels_mini_settings','a:0:{}','',31,5,1,'admin/structure/panels/settings','admin/structure/panels','Mini panels','t','','','a:0:{}',132,'','',0,''),('admin/config/development/coder/review','','','user_access','a:1:{i:0;s:16:\"view code review\";}','coder_review_page','a:0:{}','',31,5,1,'admin/config/development/coder','admin/config/development/coder','Review','t','','','a:0:{}',140,'','',-2,''),('admin/dashboard/block-content/%/%','a:2:{i:3;N;i:4;N;}','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','dashboard_show_block_content','a:2:{i:0;i:3;i:1;i:4;}','',28,5,0,'','admin/dashboard/block-content/%/%','','t','','','a:0:{}',0,'','',0,''),('bulk/disk/advance/%/%','a:2:{i:3;N;i:4;N;}','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','mercury_utilities_vdisk_settings_bulkaction_advance','a:2:{i:0;i:3;i:1;i:4;}','',28,5,0,'','bulk/disk/advance/%/%','','t','','','a:0:{}',0,'','',0,''),('bulk/disk/cachemetrics/%/%','a:2:{i:3;N;i:4;N;}','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','mercury_utilities_vdisk_settings_bulkaction_cachemetrics','a:2:{i:0;i:3;i:1;i:4;}','',28,5,0,'','bulk/disk/cachemetrics/%/%','','t','','','a:0:{}',0,'','',0,''),('admin/config/content/formats/add','','','user_access','a:1:{i:0;s:18:\"administer filters\";}','filter_admin_format_page','a:0:{}','',31,5,1,'admin/config/content/formats','admin/config/content/formats','Add text format','t','','','a:0:{}',388,'','',1,'modules/filter/filter.admin.inc'),('bulk/disk/cachemode/%/%','a:2:{i:3;N;i:4;N;}','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','mercury_utilities_vdisk_settings_bulkaction_cachemode','a:2:{i:0;i:3;i:1;i:4;}','',28,5,0,'','bulk/disk/cachemode/%/%','','t','','','a:0:{}',0,'','',0,''),('bulk/disk/cachestate/%/%','a:2:{i:3;N;i:4;N;}','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','mercury_utilities_vdisk_settings_bulkaction_cachestate','a:2:{i:0;i:3;i:1;i:4;}','',28,5,0,'','bulk/disk/cachestate/%/%','','t','','','a:0:{}',0,'','',0,''),('bulk/vm/advance/%/%','a:2:{i:3;N;i:4;N;}','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','mercury_utilities_vm_settings_bulkaction_advance','a:2:{i:0;i:3;i:1;i:4;}','',28,5,0,'','bulk/vm/advance/%/%','','t','','','a:0:{}',0,'','',0,''),('vm/allocate/bulk/%/%','a:2:{i:3;N;i:4;N;}','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','mercury_utilities_vm_settings_bulkaction_allocate_cache_action','a:2:{i:0;i:3;i:1;i:4;}','',28,5,0,'','vm/allocate/bulk/%/%','','t','','','a:0:{}',0,'','',0,''),('admin/config/search/path/add','','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','path_admin_edit','a:0:{}','',31,5,1,'admin/config/search/path','admin/config/search/path','Add alias','t','','','a:0:{}',388,'','',0,'modules/path/path.admin.inc'),('admin/config/system/actions/manage','','','user_access','a:1:{i:0;s:18:\"administer actions\";}','system_actions_manage','a:0:{}','',31,5,1,'admin/config/system/actions','admin/config/system/actions','Manage actions','t','','','a:0:{}',140,'Manage the actions defined for your site.','',-2,'modules/system/system.admin.inc'),('admin/structure/panels/settings/panel-node','','','user_access','a:1:{i:0;s:22:\"administer panel-nodes\";}','panels_node_settings','a:0:{}','',31,5,1,'admin/structure/panels/settings','admin/structure/panels','Panel nodes','t','','','a:0:{}',132,'Configure which content is available to add to panel node displays.','',0,''),('admin/structure/panels/settings/panel-page','','','user_access','a:1:{i:0;s:20:\"use panels dashboard\";}','panels_admin_panel_context_page','a:0:{}','',31,5,1,'admin/structure/panels/settings','admin/structure/panels','Panel pages','t','','','a:0:{}',132,'','',-10,'sites/all/modules/contrib/panels/includes/callbacks.inc'),('admin/config/system/actions/orphan','','','user_access','a:1:{i:0;s:18:\"administer actions\";}','system_actions_remove_orphans','a:0:{}','',31,5,0,'','admin/config/system/actions/orphan','Remove orphans','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('ctools/context/ajax/access/add','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_access_ajax_add','a:0:{}','',31,5,0,'','ctools/context/ajax/access/add','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/context-access-admin.inc'),('ctools/context/ajax/access/delete','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_access_ajax_delete','a:0:{}','',31,5,0,'','ctools/context/ajax/access/delete','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/context-access-admin.inc'),('ctools/context/ajax/access/configure','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_access_ajax_edit','a:0:{}','',31,5,0,'','ctools/context/ajax/access/configure','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/context-access-admin.inc'),('ctools-popups/%/device/settings/%','a:2:{i:1;s:14:\"ctools_js_load\";i:4;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','ctools_popups_device_setting','a:2:{i:0;i:1;i:1;i:4;}','',22,5,0,'','ctools-popups/%/device/settings/%','','t','','','a:0:{}',6,'','',0,''),('ctools-popups/%/bulk/host/%','a:2:{i:1;s:14:\"ctools_js_load\";i:4;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','ctools_popups_host_bulk_settings','a:2:{i:0;i:1;i:1;i:4;}','',22,5,0,'','ctools-popups/%/bulk/host/%','','t','','','a:0:{}',6,'','',0,''),('ctools-popups/%/host/refresh/%','a:2:{i:1;s:14:\"ctools_js_load\";i:4;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','ctools_popups_host_refresh','a:2:{i:0;i:1;i:1;i:4;}','',22,5,0,'','ctools-popups/%/host/refresh/%','','t','','','a:0:{}',6,'','',0,''),('ctools-popups/%/node/deviceinfo/%','a:2:{i:1;s:14:\"ctools_js_load\";i:4;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','ctools_popups_node_deviceinfo','a:2:{i:0;i:1;i:1;i:4;}','',22,5,0,'','ctools-popups/%/node/deviceinfo/%','','t','','','a:0:{}',6,'','',0,''),('ctools-popups/%/node/hostinfo/%','a:2:{i:1;s:14:\"ctools_js_load\";i:4;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','ctools_popups_node_hostinfo','a:2:{i:0;i:1;i:1;i:4;}','',22,5,0,'','ctools-popups/%/node/hostinfo/%','','t','','','a:0:{}',6,'','',0,''),('ctools-popups/%/node/vdiskinfo/%','a:2:{i:1;s:14:\"ctools_js_load\";i:4;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','ctools_popups_node_vdiskinfo','a:2:{i:0;i:1;i:1;i:4;}','',22,5,0,'','ctools-popups/%/node/vdiskinfo/%','','t','','','a:0:{}',6,'','',0,''),('ctools-popups/%/bulk/vdisk/%','a:2:{i:1;s:14:\"ctools_js_load\";i:4;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','ctools_popups_vdisk_bulk_settings','a:2:{i:0;i:1;i:1;i:4;}','',22,5,0,'','ctools-popups/%/bulk/vdisk/%','','t','','','a:0:{}',6,'','',0,''),('ctools-popups/%/bulk/vm/%','a:2:{i:1;s:14:\"ctools_js_load\";i:4;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','ctools_popups_vm_bulk_settings','a:2:{i:0;i:1;i:1;i:4;}','',22,5,0,'','ctools-popups/%/bulk/vm/%','','t','','','a:0:{}',6,'','',0,''),('ctools-popups/%/vm/refresh/%','a:2:{i:1;s:14:\"ctools_js_load\";i:4;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','ctools_popups_vm_refresh','a:2:{i:0;i:1;i:1;i:4;}','',22,5,0,'','ctools-popups/%/vm/refresh/%','','t','','','a:0:{}',6,'','',0,''),('ctools-popups/%/webservice/cacheinfo/%','a:2:{i:1;s:14:\"ctools_js_load\";i:4;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','ctools_popups_ws_cacheinfo','a:2:{i:0;i:1;i:1;i:4;}','',22,5,0,'','ctools-popups/%/webservice/cacheinfo/%','','t','','','a:0:{}',6,'','',0,''),('node_reference/autocomplete/%/%/%','a:3:{i:2;N;i:3;N;i:4;N;}','','reference_autocomplete_access','a:3:{i:0;i:2;i:1;i:3;i:2;i:4;}','node_reference_autocomplete','a:3:{i:0;i:2;i:1;i:3;i:2;i:4;}','',24,5,0,'','node_reference/autocomplete/%/%/%','','t','','','a:0:{}',0,'','',0,''),('user_reference/autocomplete/%/%/%','a:3:{i:2;N;i:3;N;i:4;N;}','','reference_autocomplete_access','a:3:{i:0;i:2;i:1;i:3;i:2;i:4;}','user_reference_autocomplete','a:3:{i:0;i:2;i:1;i:3;i:2;i:4;}','',24,5,0,'','user_reference/autocomplete/%/%/%','','t','','','a:0:{}',0,'','',0,''),('admin/views/ajax/autocomplete/tag','','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_autocomplete_tag','a:0:{}','',31,5,0,'','admin/views/ajax/autocomplete/tag','','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/views/includes/admin.inc'),('admin/config/people/login-destination/add','','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:1:{i:0;s:27:\"login_destination_edit_form\";}','',31,5,1,'admin/config/people/login-destination','admin/config/people/login-destination','Add login destination rule','t','','','a:0:{}',388,'','',1,'sites/all/modules/contrib/login_destination/login_destination.admin.inc'),('admin/config/user-interface/shortcut/add-set','','','user_access','a:1:{i:0;s:20:\"administer shortcuts\";}','drupal_get_form','a:1:{i:0;s:21:\"shortcut_set_add_form\";}','',31,5,1,'admin/config/user-interface/shortcut','admin/config/user-interface/shortcut','Add shortcut set','t','','','a:0:{}',388,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/structure/taxonomy/%/add','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:3:{i:0;s:18:\"taxonomy_form_term\";i:1;a:0:{}i:2;i:3;}','',29,5,1,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','Add term','t','','','a:0:{}',388,'','',0,'modules/taxonomy/taxonomy.admin.inc'),('admin/structure/views/settings/advanced','','','user_access','a:1:{i:0;s:16:\"administer views\";}','drupal_get_form','a:1:{i:0;s:32:\"views_ui_admin_settings_advanced\";}','',31,5,1,'admin/structure/views/settings','admin/structure/views','Advanced','t','','','a:0:{}',132,'','',1,'sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/block/list/bartik','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:25:\"themes/bartik/bartik.info\";s:4:\"name\";s:6:\"bartik\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:6:\"Bartik\";s:11:\"description\";s:48:\"A flexible, recolorable theme with many regions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:7:\"regions\";a:20:{s:6:\"header\";s:6:\"Header\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"triptych_first\";s:14:\"Triptych first\";s:15:\"triptych_middle\";s:15:\"Triptych middle\";s:13:\"triptych_last\";s:13:\"Triptych last\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"0\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:28:\"themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_display','a:1:{i:0;s:6:\"bartik\";}','',31,5,1,'admin/structure/block','admin/structure/block','Bartik','t','','','a:0:{}',132,'','',0,'modules/block/block.admin.inc'),('admin/structure/views/settings/basic','','','user_access','a:1:{i:0;s:16:\"administer views\";}','drupal_get_form','a:1:{i:0;s:29:\"views_ui_admin_settings_basic\";}','',31,5,1,'admin/structure/views/settings','admin/structure/views','Basic','t','','','a:0:{}',140,'','',0,'sites/all/modules/contrib/views/includes/admin.inc'),('admin/config/search/path/update_bulk','','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','drupal_get_form','a:1:{i:0;s:25:\"pathauto_bulk_update_form\";}','',31,5,1,'admin/config/search/path','admin/config/search/path','Bulk update','t','','','a:0:{}',132,'','',30,'sites/all/modules/contrib/pathauto/pathauto.admin.inc'),('admin/config/search/clean-urls/check','','','1','a:0:{}','drupal_json_output','a:1:{i:0;a:1:{s:6:\"status\";b:1;}}','',31,5,0,'','admin/config/search/clean-urls/check','Clean URL check','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/config/search/settings/reindex','','','user_access','a:1:{i:0;s:17:\"administer search\";}','drupal_get_form','a:1:{i:0;s:22:\"search_reindex_confirm\";}','',31,5,0,'','admin/config/search/settings/reindex','Clear index','t','','','a:0:{}',4,'','',0,'modules/search/search.admin.inc'),('admin/config/system/actions/configure','','','user_access','a:1:{i:0;s:18:\"administer actions\";}','drupal_get_form','a:1:{i:0;s:24:\"system_actions_configure\";}','',31,5,0,'','admin/config/system/actions/configure','Configure an advanced action','t','','','a:0:{}',4,'','',0,'modules/system/system.admin.inc'),('admin/config/search/path/delete_bulk','','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','drupal_get_form','a:1:{i:0;s:21:\"pathauto_admin_delete\";}','',31,5,1,'admin/config/search/path','admin/config/search/path','Delete aliases','t','','','a:0:{}',132,'','',40,'sites/all/modules/contrib/pathauto/pathauto.admin.inc'),('admin/structure/taxonomy/%/edit','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:24:\"taxonomy_form_vocabulary\";i:1;i:3;}','',29,5,1,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','Edit','t','','','a:0:{}',132,'','',-10,'modules/taxonomy/taxonomy.admin.inc'),('admin/config/regional/date-time/formats','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','system_date_time_formats','a:0:{}','',31,5,1,'admin/config/regional/date-time','admin/config/regional/date-time','Formats','t','','','a:0:{}',132,'Configure display format strings for date and time.','',-9,'modules/system/system.admin.inc'),('admin/structure/block/list/garland','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:27:\"themes/garland/garland.info\";s:4:\"name\";s:7:\"garland\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:7:\"Garland\";s:11:\"description\";s:111:\"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:8:\"settings\";a:1:{s:13:\"garland_width\";s:5:\"fluid\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:29:\"themes/garland/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_display','a:1:{i:0;s:7:\"garland\";}','',31,5,1,'admin/structure/block','admin/structure/block','Garland','t','','','a:0:{}',132,'','',0,'modules/block/block.admin.inc'),('admin/structure/panels/settings/general','','','user_access','a:1:{i:0;s:23:\"administer page manager\";}','drupal_get_form','a:1:{i:0;s:26:\"panels_admin_settings_page\";}','',31,5,1,'admin/structure/panels/settings','admin/structure/panels','General','t','','','a:0:{}',140,'','',-10,'sites/all/modules/contrib/panels/includes/callbacks.inc'),('admin/structure/block/list/mercury','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":13:{s:8:\"filename\";s:37:\"sites/all/themes/mercury/mercury.info\";s:4:\"name\";s:7:\"mercury\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:7:\"Mercury\";s:11:\"description\";s:26:\"Mercury theme for Drupal 7\";s:10:\"screenshot\";s:46:\"sites/all/themes/mercury/images/screenshot.gif\";s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:7:\"mercury\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:14:{s:8:\"page_top\";s:8:\"Page top\";s:16:\"header_top_right\";s:16:\"Header top right\";s:6:\"header\";s:6:\"Header\";s:9:\"highlight\";s:9:\"Highlight\";s:4:\"help\";s:4:\"Help\";s:11:\"title_right\";s:11:\"Title Right\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"sidebar_second\";s:14:\"Second sidebar\";s:6:\"footer\";s:6:\"Footer\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:6:\"search\";i:6;s:7:\"favicon\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:11:\"stylesheets\";a:2:{s:3:\"all\";a:5:{s:15:\"css/default.css\";s:40:\"sites/all/themes/mercury/css/default.css\";s:14:\"css/layout.css\";s:39:\"sites/all/themes/mercury/css/layout.css\";s:13:\"css/style.css\";s:38:\"sites/all/themes/mercury/css/style.css\";s:17:\"css/node-view.css\";s:42:\"sites/all/themes/mercury/css/node-view.css\";s:17:\"css/analytics.css\";s:42:\"sites/all/themes/mercury/css/analytics.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:38:\"sites/all/themes/mercury/css/print.css\";}}s:7:\"scripts\";a:6:{s:19:\"js/jquery-ui.min.js\";s:44:\"sites/all/themes/mercury/js/jquery-ui.min.js\";s:29:\"js/jquery.mCustomScrollbar.js\";s:54:\"sites/all/themes/mercury/js/jquery.mCustomScrollbar.js\";s:27:\"js/jquery.mousewheel.min.js\";s:52:\"sites/all/themes/mercury/js/jquery.mousewheel.min.js\";s:24:\"js/jquery.tablesorter.js\";s:49:\"sites/all/themes/mercury/js/jquery.tablesorter.js\";s:32:\"js/jquery.tablesorter.widgets.js\";s:57:\"sites/all/themes/mercury/js/jquery.tablesorter.widgets.js\";s:14:\"js/function.js\";s:39:\"sites/all/themes/mercury/js/function.js\";}s:7:\"compass\";a:3:{s:6:\"status\";s:1:\"1\";s:8:\"sass_dir\";s:4:\"sass\";s:7:\"css_dir\";s:3:\"css\";}s:8:\"settings\";a:4:{s:12:\"mercury_tabs\";s:1:\"1\";s:28:\"mercury_breadcrumb_separator\";s:2:\"»\";s:14:\"wireframe_mode\";s:1:\"0\";s:14:\"clear_registry\";s:1:\"0\";}s:7:\"version\";s:7:\"7.x-2.1\";s:9:\"datestamp\";s:10:\"1334122542\";s:3:\"php\";s:5:\"5.2.4\";s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:5:{s:15:\"css/default.css\";s:40:\"sites/all/themes/mercury/css/default.css\";s:14:\"css/layout.css\";s:39:\"sites/all/themes/mercury/css/layout.css\";s:13:\"css/style.css\";s:38:\"sites/all/themes/mercury/css/style.css\";s:17:\"css/node-view.css\";s:42:\"sites/all/themes/mercury/css/node-view.css\";s:17:\"css/analytics.css\";s:42:\"sites/all/themes/mercury/css/analytics.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:38:\"sites/all/themes/mercury/css/print.css\";}}s:7:\"scripts\";a:6:{s:19:\"js/jquery-ui.min.js\";s:44:\"sites/all/themes/mercury/js/jquery-ui.min.js\";s:29:\"js/jquery.mCustomScrollbar.js\";s:54:\"sites/all/themes/mercury/js/jquery.mCustomScrollbar.js\";s:27:\"js/jquery.mousewheel.min.js\";s:52:\"sites/all/themes/mercury/js/jquery.mousewheel.min.js\";s:24:\"js/jquery.tablesorter.js\";s:49:\"sites/all/themes/mercury/js/jquery.tablesorter.js\";s:32:\"js/jquery.tablesorter.widgets.js\";s:57:\"sites/all/themes/mercury/js/jquery.tablesorter.widgets.js\";s:14:\"js/function.js\";s:39:\"sites/all/themes/mercury/js/function.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_display','a:1:{i:0;s:7:\"mercury\";}','',31,5,1,'admin/structure/block','admin/structure/block','Mercury','t','','','a:0:{}',140,'','',-10,'modules/block/block.admin.inc'),('admin/config/search/path/patterns','','','user_access','a:1:{i:0;s:19:\"administer pathauto\";}','drupal_get_form','a:1:{i:0;s:22:\"pathauto_patterns_form\";}','',31,5,1,'admin/config/search/path','admin/config/search/path','Patterns','t','','','a:0:{}',132,'','',10,'sites/all/modules/contrib/pathauto/pathauto.admin.inc'),('user/reset/%/%/%','a:3:{i:2;N;i:3;N;i:4;N;}','','1','a:0:{}','drupal_get_form','a:4:{i:0;s:15:\"user_pass_reset\";i:1;i:2;i:2;i:3;i:3;i:4;}','',24,5,0,'','user/reset/%/%/%','Reset password','t','','','a:0:{}',0,'','',0,'modules/user/user.pages.inc'),('admin/config/search/search_api/page','','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','search_api_page_admin_overview','a:0:{}','',31,5,1,'admin/config/search/search_api','admin/config/search/search_api','Search pages','t','','','a:0:{}',132,'Create and configure search pages.','',0,'sites/all/modules/contrib/search_api_page/search_api_page.admin.inc'),('admin/config/search/path/settings','','','user_access','a:1:{i:0;s:19:\"administer pathauto\";}','drupal_get_form','a:1:{i:0;s:22:\"pathauto_settings_form\";}','',31,5,1,'admin/config/search/path','admin/config/search/path','Settings','t','','','a:0:{}',132,'','',20,'sites/all/modules/contrib/pathauto/pathauto.admin.inc'),('admin/structure/block/list/seven','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/seven/seven.info\";s:4:\"name\";s:5:\"seven\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:5:\"Seven\";s:11:\"description\";s:65:\"A simple one-column, tableless, fluid width administration theme.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"1\";}s:7:\"regions\";a:8:{s:7:\"content\";s:7:\"Content\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_display','a:1:{i:0;s:5:\"seven\";}','',31,5,1,'admin/structure/block','admin/structure/block','Seven','t','','','a:0:{}',132,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/stark','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/stark/stark.info\";s:4:\"name\";s:5:\"stark\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:17:{s:4:\"name\";s:5:\"Stark\";s:11:\"description\";s:208:\"This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/stark/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_display','a:1:{i:0;s:5:\"stark\";}','',31,5,1,'admin/structure/block','admin/structure/block','Stark','t','','','a:0:{}',132,'','',0,'modules/block/block.admin.inc'),('admin/structure/pages/wizard/%','a:1:{i:4;N;}','','user_access','a:1:{i:0;s:16:\"use page manager\";}','page_manager_page_wizard','a:1:{i:0;i:4;}','',30,5,0,'','admin/structure/pages/wizard/%','Wizard','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/page-wizard.inc'),('admin/config/search/search_api/add_index','','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','drupal_get_form','a:1:{i:0;s:26:\"search_api_admin_add_index\";}','',31,5,1,'admin/config/search/search_api','admin/config/search/search_api','Add index','t','','','a:0:{}',388,'Create a new search index.','',0,'sites/all/modules/contrib/search_api/search_api.admin.inc'),('admin/config/search/search_api/add_server','','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','drupal_get_form','a:1:{i:0;s:27:\"search_api_admin_add_server\";}','',31,5,1,'admin/config/search/search_api','admin/config/search/search_api','Add server','t','','','a:0:{}',388,'Create a new search server.','',-1,'sites/all/modules/contrib/search_api/search_api.admin.inc'),('admin/structure/pages/edit/%','a:1:{i:4;s:23:\"page_manager_cache_load\";}','','user_access','a:1:{i:0;s:16:\"use page manager\";}','page_manager_edit_page','a:1:{i:0;i:4;}','',30,5,0,'','admin/structure/pages/edit/%','Edit','t','','ajax_base_page_theme','a:0:{}',6,'','',0,'sites/all/modules/contrib/ctools/page_manager/page_manager.admin.inc'),('admin/config/people/accounts/display','','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:7:\"default\";}','',31,5,1,'admin/config/people/accounts','admin/config/people/accounts','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/views/ajax/autocomplete/taxonomy','','','user_access','a:1:{i:0;s:14:\"access content\";}','views_ajax_autocomplete_taxonomy','a:0:{}','',31,5,0,'','admin/views/ajax/autocomplete/taxonomy','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/contrib/views/includes/ajax.inc'),('admin/structure/taxonomy/%/fields','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;}','',29,5,1,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/views/ajax/autocomplete/user','','','user_access','a:1:{i:0;s:14:\"access content\";}','views_ajax_autocomplete_user','a:0:{}','',31,5,0,'','admin/views/ajax/autocomplete/user','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/contrib/views/includes/ajax.inc'),('admin/structure/taxonomy/%/display','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:7:\"default\";}','',29,5,1,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields','','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";}','',31,5,1,'admin/config/people/accounts','admin/config/people/accounts','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('node/%/revisions/%/view','a:2:{i:1;a:1:{s:9:\"node_load\";a:1:{i:0;i:3;}}i:3;N;}','','_node_revision_access','a:1:{i:0;i:1;}','node_show','a:2:{i:0;i:1;i:1;b:1;}','',21,5,0,'','node/%/revisions/%/view','Revisions','t','','','a:0:{}',6,'','',0,''),('admin/config/people/login-destination/settings','','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:1:{i:0;s:26:\"login_destination_settings\";}','',31,5,1,'admin/config/people/login-destination','admin/config/people/login-destination','Settings','t','','','a:0:{}',132,'Change Login Destination settings.','',10,'sites/all/modules/contrib/login_destination/login_destination.admin.inc'),('admin/config/regional/date-time/types','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:25:\"system_date_time_settings\";}','',31,5,1,'admin/config/regional/date-time','admin/config/regional/date-time','Types','t','','','a:0:{}',140,'Configure display formats for date and time.','',-10,'modules/system/system.admin.inc'),('user/validate/%/%/%','a:3:{i:2;s:9:\"user_load\";i:3;N;i:4;N;}','','logintoboggan_validate_email_access','a:2:{i:0;i:2;i:1;i:3;}','logintoboggan_validate_email','a:3:{i:0;i:2;i:1;i:3;i:2;i:4;}','',24,5,0,'','user/validate/%/%/%','Validate e-mail address','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/logintoboggan/logintoboggan.validation.inc'),('admin/structure/panels/layouts/add-flexible','','','ctools_export_ui_task_access','a:2:{i:0;s:14:\"panels_layouts\";i:1;s:3:\"add\";}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:3:\"add\";i:2;s:8:\"flexible\";}','',31,5,1,'admin/structure/panels/layouts','admin/structure/panels','Add flexible layout','t','','','a:0:{}',388,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('node/%/revisions/%/delete','a:2:{i:1;a:1:{s:9:\"node_load\";a:1:{i:0;i:3;}}i:3;N;}','','_node_revision_access','a:2:{i:0;i:1;i:1;s:6:\"delete\";}','drupal_get_form','a:2:{i:0;s:28:\"node_revision_delete_confirm\";i:1;i:1;}','',21,5,0,'','node/%/revisions/%/delete','Delete earlier revision','t','','','a:0:{}',6,'','',0,'modules/node/node.pages.inc'),('admin/structure/panels/layouts/import','','','ctools_export_ui_task_access','a:2:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"import\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"import\";}','',31,5,1,'admin/structure/panels/layouts','admin/structure/panels','Import','t','','','a:0:{}',388,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/list','','','ctools_export_ui_task_access','a:2:{i:0;s:14:\"panels_layouts\";i:1;s:4:\"list\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:14:\"panels_layouts\";i:1;s:4:\"list\";}','',31,5,1,'admin/structure/panels/layouts','admin/structure/panels','List','t','','','a:0:{}',140,'','',-10,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('node/%/revisions/%/revert','a:2:{i:1;a:1:{s:9:\"node_load\";a:1:{i:0;i:3;}}i:3;N;}','','_node_revision_access','a:2:{i:0;i:1;i:1;s:6:\"update\";}','drupal_get_form','a:2:{i:0;s:28:\"node_revision_revert_confirm\";i:1;i:1;}','',21,5,0,'','node/%/revisions/%/revert','Revert to earlier revision','t','','','a:0:{}',6,'','',0,'modules/node/node.pages.inc'),('admin/config/content/formats/%','a:1:{i:4;s:18:\"filter_format_load\";}','','user_access','a:1:{i:0;s:18:\"administer filters\";}','filter_admin_format_page','a:1:{i:0;i:4;}','',30,5,0,'','admin/config/content/formats/%','','filter_admin_format_title','a:1:{i:0;i:4;}','','a:0:{}',6,'','',0,'modules/filter/filter.admin.inc'),('admin/structure/menu/manage/%','a:1:{i:4;s:9:\"menu_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}','',30,5,0,'','admin/structure/menu/manage/%','Customize menu','menu_overview_title','a:1:{i:0;i:4;}','','a:0:{}',6,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/types/manage/%','a:1:{i:4;s:14:\"node_type_load\";}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:14:\"node_type_form\";i:1;i:4;}','',30,5,0,'','admin/structure/types/manage/%','Edit content type','node_type_page_title','a:1:{i:0;i:4;}','','a:0:{}',6,'','',0,'modules/node/content_types.inc'),('admin/structure/ctools-content/list/%','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:21:\"ctools_custom_content\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:21:\"ctools_custom_content\";i:1;s:4:\"edit\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:21:\"ctools_custom_content\";i:1;s:4:\"edit\";i:2;i:4;}','',30,5,0,'','admin/structure/ctools-content/list/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/mini-panels/list/%','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:11:\"panels_mini\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:11:\"panels_mini\";i:1;s:4:\"edit\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:11:\"panels_mini\";i:1;s:4:\"edit\";i:2;i:4;}','',30,5,0,'','admin/structure/mini-panels/list/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/views/view/%','a:1:{i:4;s:19:\"views_ui_cache_load\";}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_edit_page','a:1:{i:0;i:4;}','',30,5,0,'','admin/structure/views/view/%','','views_ui_edit_page_title','a:1:{i:0;i:4;}','','a:0:{}',6,'','',0,'sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/block/demo/bartik','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:25:\"themes/bartik/bartik.info\";s:4:\"name\";s:6:\"bartik\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:6:\"Bartik\";s:11:\"description\";s:48:\"A flexible, recolorable theme with many regions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:7:\"regions\";a:20:{s:6:\"header\";s:6:\"Header\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"triptych_first\";s:14:\"Triptych first\";s:15:\"triptych_middle\";s:15:\"Triptych middle\";s:13:\"triptych_last\";s:13:\"Triptych last\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"0\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:28:\"themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_demo','a:1:{i:0;s:6:\"bartik\";}','',31,5,0,'','admin/structure/block/demo/bartik','Bartik','t','','_block_custom_theme','a:1:{i:0;s:6:\"bartik\";}',0,'','',0,'modules/block/block.admin.inc'),('admin/config/user-interface/shortcut/%','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:22:\"shortcut_set_customize\";i:1;i:4;}','',30,5,0,'','admin/config/user-interface/shortcut/%','Edit shortcuts','shortcut_set_title','a:1:{i:0;i:4;}','','a:0:{}',6,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/structure/block/demo/garland','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:27:\"themes/garland/garland.info\";s:4:\"name\";s:7:\"garland\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:7:\"Garland\";s:11:\"description\";s:111:\"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:8:\"settings\";a:1:{s:13:\"garland_width\";s:5:\"fluid\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:29:\"themes/garland/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_demo','a:1:{i:0;s:7:\"garland\";}','',31,5,0,'','admin/structure/block/demo/garland','Garland','t','','_block_custom_theme','a:1:{i:0;s:7:\"garland\";}',0,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/demo/mercury','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":13:{s:8:\"filename\";s:37:\"sites/all/themes/mercury/mercury.info\";s:4:\"name\";s:7:\"mercury\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:7:\"Mercury\";s:11:\"description\";s:26:\"Mercury theme for Drupal 7\";s:10:\"screenshot\";s:46:\"sites/all/themes/mercury/images/screenshot.gif\";s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:7:\"mercury\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:14:{s:8:\"page_top\";s:8:\"Page top\";s:16:\"header_top_right\";s:16:\"Header top right\";s:6:\"header\";s:6:\"Header\";s:9:\"highlight\";s:9:\"Highlight\";s:4:\"help\";s:4:\"Help\";s:11:\"title_right\";s:11:\"Title Right\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"sidebar_second\";s:14:\"Second sidebar\";s:6:\"footer\";s:6:\"Footer\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:6:\"search\";i:6;s:7:\"favicon\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:11:\"stylesheets\";a:2:{s:3:\"all\";a:5:{s:15:\"css/default.css\";s:40:\"sites/all/themes/mercury/css/default.css\";s:14:\"css/layout.css\";s:39:\"sites/all/themes/mercury/css/layout.css\";s:13:\"css/style.css\";s:38:\"sites/all/themes/mercury/css/style.css\";s:17:\"css/node-view.css\";s:42:\"sites/all/themes/mercury/css/node-view.css\";s:17:\"css/analytics.css\";s:42:\"sites/all/themes/mercury/css/analytics.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:38:\"sites/all/themes/mercury/css/print.css\";}}s:7:\"scripts\";a:6:{s:19:\"js/jquery-ui.min.js\";s:44:\"sites/all/themes/mercury/js/jquery-ui.min.js\";s:29:\"js/jquery.mCustomScrollbar.js\";s:54:\"sites/all/themes/mercury/js/jquery.mCustomScrollbar.js\";s:27:\"js/jquery.mousewheel.min.js\";s:52:\"sites/all/themes/mercury/js/jquery.mousewheel.min.js\";s:24:\"js/jquery.tablesorter.js\";s:49:\"sites/all/themes/mercury/js/jquery.tablesorter.js\";s:32:\"js/jquery.tablesorter.widgets.js\";s:57:\"sites/all/themes/mercury/js/jquery.tablesorter.widgets.js\";s:14:\"js/function.js\";s:39:\"sites/all/themes/mercury/js/function.js\";}s:7:\"compass\";a:3:{s:6:\"status\";s:1:\"1\";s:8:\"sass_dir\";s:4:\"sass\";s:7:\"css_dir\";s:3:\"css\";}s:8:\"settings\";a:4:{s:12:\"mercury_tabs\";s:1:\"1\";s:28:\"mercury_breadcrumb_separator\";s:2:\"»\";s:14:\"wireframe_mode\";s:1:\"0\";s:14:\"clear_registry\";s:1:\"0\";}s:7:\"version\";s:7:\"7.x-2.1\";s:9:\"datestamp\";s:10:\"1334122542\";s:3:\"php\";s:5:\"5.2.4\";s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:5:{s:15:\"css/default.css\";s:40:\"sites/all/themes/mercury/css/default.css\";s:14:\"css/layout.css\";s:39:\"sites/all/themes/mercury/css/layout.css\";s:13:\"css/style.css\";s:38:\"sites/all/themes/mercury/css/style.css\";s:17:\"css/node-view.css\";s:42:\"sites/all/themes/mercury/css/node-view.css\";s:17:\"css/analytics.css\";s:42:\"sites/all/themes/mercury/css/analytics.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:38:\"sites/all/themes/mercury/css/print.css\";}}s:7:\"scripts\";a:6:{s:19:\"js/jquery-ui.min.js\";s:44:\"sites/all/themes/mercury/js/jquery-ui.min.js\";s:29:\"js/jquery.mCustomScrollbar.js\";s:54:\"sites/all/themes/mercury/js/jquery.mCustomScrollbar.js\";s:27:\"js/jquery.mousewheel.min.js\";s:52:\"sites/all/themes/mercury/js/jquery.mousewheel.min.js\";s:24:\"js/jquery.tablesorter.js\";s:49:\"sites/all/themes/mercury/js/jquery.tablesorter.js\";s:32:\"js/jquery.tablesorter.widgets.js\";s:57:\"sites/all/themes/mercury/js/jquery.tablesorter.widgets.js\";s:14:\"js/function.js\";s:39:\"sites/all/themes/mercury/js/function.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_demo','a:1:{i:0;s:7:\"mercury\";}','',31,5,0,'','admin/structure/block/demo/mercury','Mercury','t','','_block_custom_theme','a:1:{i:0;s:7:\"mercury\";}',0,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/demo/seven','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/seven/seven.info\";s:4:\"name\";s:5:\"seven\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:5:\"Seven\";s:11:\"description\";s:65:\"A simple one-column, tableless, fluid width administration theme.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"1\";}s:7:\"regions\";a:8:{s:7:\"content\";s:7:\"Content\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_demo','a:1:{i:0;s:5:\"seven\";}','',31,5,0,'','admin/structure/block/demo/seven','Seven','t','','_block_custom_theme','a:1:{i:0;s:5:\"seven\";}',0,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/demo/stark','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/stark/stark.info\";s:4:\"name\";s:5:\"stark\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:17:{s:4:\"name\";s:5:\"Stark\";s:11:\"description\";s:208:\"This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/stark/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_demo','a:1:{i:0;s:5:\"stark\";}','',31,5,0,'','admin/structure/block/demo/stark','Stark','t','','_block_custom_theme','a:1:{i:0;s:5:\"stark\";}',0,'','',0,'modules/block/block.admin.inc'),('admin/structure/types/manage/%/edit','a:1:{i:4;s:14:\"node_type_load\";}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:14:\"node_type_form\";i:1;i:4;}','',61,6,1,'admin/structure/types/manage/%','admin/structure/types/manage/%','Edit','t','','','a:0:{}',140,'','',0,'modules/node/content_types.inc'),('admin/config/user-interface/shortcut/%/links','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:22:\"shortcut_set_customize\";i:1;i:4;}','',61,6,1,'admin/config/user-interface/shortcut/%','admin/config/user-interface/shortcut/%','List links','t','','','a:0:{}',140,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/structure/menu/manage/%/list','a:1:{i:4;s:9:\"menu_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}','',61,6,3,'admin/structure/menu/manage/%','admin/structure/menu/manage/%','List links','t','','','a:0:{}',140,'','',-10,'modules/menu/menu.admin.inc'),('admin/config/development/coder/review/select','','','user_access','a:1:{i:0;s:16:\"view code review\";}','coder_review_page','a:0:{}','',63,6,1,'admin/config/development/coder/review','admin/config/development/coder','Select','t','','','a:0:{}',140,'','',-2,''),('admin/config/development/coder/review/active','','','user_access','a:1:{i:0;s:16:\"view code review\";}','coder_review_page','a:1:{i:0;s:6:\"active\";}','',63,6,1,'admin/config/development/coder/review','admin/config/development/coder','Active','t','','','a:0:{}',132,'','',0,''),('vm/settings/%/%/%/%','a:4:{i:2;N;i:3;N;i:4;N;i:5;N;}','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','mercury_utilities_vm_settings_action','a:4:{i:0;i:2;i:1;i:3;i:2;i:4;i:3;i:5;}','',48,6,0,'','vm/settings/%/%/%/%','','t','','','a:0:{}',0,'','',0,''),('admin/config/development/coder/review/all','','','user_access','a:1:{i:0;s:20:\"view code review all\";}','coder_review_page','a:1:{i:0;s:3:\"all\";}','',63,6,1,'admin/config/development/coder/review','admin/config/development/coder','All','t','','','a:0:{}',132,'','',1,''),('admin/config/development/coder/review/core','','','user_access','a:1:{i:0;s:16:\"view code review\";}','coder_review_page','a:1:{i:0;s:4:\"core\";}','',63,6,1,'admin/config/development/coder/review','admin/config/development/coder','Core','t','','','a:0:{}',132,'','',0,''),('admin/config/development/coder/review/default','','','user_access','a:1:{i:0;s:16:\"view code review\";}','coder_review_page','a:1:{i:0;s:7:\"default\";}','',63,6,1,'admin/config/development/coder/review','admin/config/development/coder','Default','t','','','a:0:{}',132,'','',-1,''),('vdisk/settings/%/%/%/%','a:4:{i:2;N;i:3;N;i:4;N;i:5;N;}','','user_access','a:1:{i:0;s:24:\"access mercury_utilities\";}','mercury_utilities_vdisk_settings_action','a:4:{i:0;i:2;i:1;i:3;i:2;i:4;i:3;i:5;}','',48,6,0,'','vdisk/settings/%/%/%/%','','t','','','a:0:{}',0,'','',0,''),('admin/config/regional/date-time/formats/lookup','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','system_date_time_lookup','a:0:{}','',63,6,0,'','admin/config/regional/date-time/formats/lookup','Date and time lookup','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/structure/types/manage/%/delete','a:1:{i:4;s:14:\"node_type_load\";}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:24:\"node_type_delete_confirm\";i:1;i:4;}','',61,6,0,'','admin/structure/types/manage/%/delete','Delete','t','','','a:0:{}',6,'','',0,'modules/node/content_types.inc'),('admin/people/permissions/roles/edit/%','a:1:{i:5;s:14:\"user_role_load\";}','','user_role_edit_access','a:1:{i:0;i:5;}','drupal_get_form','a:2:{i:0;s:15:\"user_admin_role\";i:1;i:5;}','',62,6,0,'','admin/people/permissions/roles/edit/%','Edit role','t','','','a:0:{}',6,'','',0,'modules/user/user.admin.inc'),('admin/config/development/coder/review/files','','','user_access','a:1:{i:0;s:16:\"view code review\";}','coder_review_page','a:1:{i:0;s:5:\"files\";}','',63,6,1,'admin/config/development/coder/review','admin/config/development/coder','Files','t','','','a:0:{}',132,'','',2,''),('admin/config/development/coder/review/patches','','','user_access','a:1:{i:0;s:16:\"view code review\";}','coder_review_page','a:1:{i:0;s:7:\"patches\";}','',63,6,1,'admin/config/development/coder/review','admin/config/development/coder','Patches','t','','','a:0:{}',132,'','',3,''),('ctools-popups/%/host/settings/assign/%','a:2:{i:1;s:14:\"ctools_js_load\";i:5;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','ctools_popups_host_setting_assign','a:2:{i:0;i:1;i:1;i:5;}','',46,6,0,'','ctools-popups/%/host/settings/assign/%','','t','','','a:0:{}',6,'','',0,''),('ctools-popups/%/host/settings/edit/%','a:2:{i:1;s:14:\"ctools_js_load\";i:5;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','ctools_popups_host_setting_edit','a:2:{i:0;i:1;i:1;i:5;}','',46,6,0,'','ctools-popups/%/host/settings/edit/%','','t','','','a:0:{}',6,'','',0,''),('ctools-popups/%/host/settings/initialize/%','a:2:{i:1;s:14:\"ctools_js_load\";i:5;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','ctools_popups_host_setting_initialize','a:2:{i:0;i:1;i:1;i:5;}','',46,6,0,'','ctools-popups/%/host/settings/initialize/%','','t','','','a:0:{}',6,'','',0,''),('ctools-popups/%/host/settings/install/%','a:2:{i:1;s:14:\"ctools_js_load\";i:5;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','ctools_popups_host_setting_install','a:2:{i:0;i:1;i:1;i:5;}','',46,6,0,'','ctools-popups/%/host/settings/install/%','','t','','','a:0:{}',6,'','',0,''),('ctools-popups/%/host/settings/unassign/%','a:2:{i:1;s:14:\"ctools_js_load\";i:5;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','ctools_popups_host_setting_unassign','a:2:{i:0;i:1;i:1;i:5;}','',46,6,0,'','ctools-popups/%/host/settings/unassign/%','','t','','','a:0:{}',6,'','',0,''),('ctools-popups/%/host/settings/uninstall/%','a:2:{i:1;s:14:\"ctools_js_load\";i:5;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','ctools_popups_host_setting_uninstall','a:2:{i:0;i:1;i:1;i:5;}','',46,6,0,'','ctools-popups/%/host/settings/uninstall/%','','t','','','a:0:{}',6,'','',0,''),('ctools-popups/%/host/settings/upgrade/%','a:2:{i:1;s:14:\"ctools_js_load\";i:5;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','ctools_popups_host_setting_upgrade','a:2:{i:0;i:1;i:1;i:5;}','',46,6,0,'','ctools-popups/%/host/settings/upgrade/%','','t','','','a:0:{}',6,'','',0,''),('ctools-popups/%/vm/settings/%/%','a:3:{i:1;s:14:\"ctools_js_load\";i:4;N;i:5;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','ctools_popups_vm_setting','a:3:{i:0;i:1;i:1;i:4;i:2;i:5;}','',44,6,0,'','ctools-popups/%/vm/settings/%/%','','t','','','a:0:{}',6,'','',0,''),('ctools-popups/%/vm/settings/advance/%','a:2:{i:1;s:14:\"ctools_js_load\";i:5;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','ctools_popups_vm_setting_advance','a:2:{i:0;i:1;i:1;i:5;}','',46,6,0,'','ctools-popups/%/vm/settings/advance/%','','t','','','a:0:{}',6,'','',0,''),('ctools-popups/%/vm/settings/allocate/%','a:2:{i:1;s:14:\"ctools_js_load\";i:5;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','ctools_popups_vm_setting_allocate','a:2:{i:0;i:1;i:1;i:5;}','',46,6,0,'','ctools-popups/%/vm/settings/allocate/%','','t','','','a:0:{}',6,'','',0,''),('admin/structure/block/list/bartik/add','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:1:{i:0;s:20:\"block_add_block_form\";}','',63,6,1,'admin/structure/block/list/bartik','admin/structure/block','Add block','t','','','a:0:{}',388,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/garland/add','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:1:{i:0;s:20:\"block_add_block_form\";}','',63,6,1,'admin/structure/block/list/garland','admin/structure/block','Add block','t','','','a:0:{}',388,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/seven/add','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:1:{i:0;s:20:\"block_add_block_form\";}','',63,6,1,'admin/structure/block/list/seven','admin/structure/block','Add block','t','','','a:0:{}',388,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/stark/add','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:1:{i:0;s:20:\"block_add_block_form\";}','',63,6,1,'admin/structure/block/list/stark','admin/structure/block','Add block','t','','','a:0:{}',388,'','',0,'modules/block/block.admin.inc'),('admin/structure/menu/manage/%/add','a:1:{i:4;s:9:\"menu_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:4:{i:0;s:14:\"menu_edit_item\";i:1;s:3:\"add\";i:2;N;i:3;i:4;}','',61,6,1,'admin/structure/menu/manage/%','admin/structure/menu/manage/%','Add link','t','','','a:0:{}',388,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/block/manage/%/%','a:2:{i:4;N;i:5;N;}','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:3:{i:0;s:21:\"block_admin_configure\";i:1;i:4;i:2;i:5;}','',60,6,0,'','admin/structure/block/manage/%/%','Configure block','t','','','a:0:{}',6,'','',0,'modules/block/block.admin.inc'),('admin/structure/taxonomy/%/display/default','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:7:\"default\";i:3;s:11:\"user_access\";i:4;s:19:\"administer taxonomy\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:7:\"default\";}','',59,6,1,'admin/structure/taxonomy/%/display','admin/structure/taxonomy/%','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/display/default','','','_field_ui_view_mode_menu_access','a:5:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:7:\"default\";i:3;s:11:\"user_access\";i:4;s:16:\"administer users\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:7:\"default\";}','',63,6,1,'admin/config/people/accounts/display','admin/config/people/accounts','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/ip-blocking/delete/%','a:1:{i:5;s:15:\"blocked_ip_load\";}','','user_access','a:1:{i:0;s:18:\"block IP addresses\";}','drupal_get_form','a:2:{i:0;s:25:\"system_ip_blocking_delete\";i:1;i:5;}','',62,6,0,'','admin/config/people/ip-blocking/delete/%','Delete IP address','t','','','a:0:{}',6,'','',0,'modules/system/system.admin.inc'),('admin/config/search/path/delete/%','a:1:{i:5;s:9:\"path_load\";}','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','drupal_get_form','a:2:{i:0;s:25:\"path_admin_delete_confirm\";i:1;i:5;}','',62,6,0,'','admin/config/search/path/delete/%','Delete alias','t','','','a:0:{}',6,'','',0,'modules/path/path.admin.inc'),('admin/config/people/login-destination/delete/%','a:1:{i:5;s:22:\"login_destination_load\";}','','user_access','a:1:{i:0;s:18:\"administer userson\";}','drupal_get_form','a:2:{i:0;s:29:\"login_destination_delete_form\";i:1;i:5;}','',62,6,0,'','admin/config/people/login-destination/delete/%','Delete login destination rule','t','','','a:0:{}',6,'','',0,'sites/all/modules/contrib/login_destination/login_destination.admin.inc'),('admin/structure/menu/manage/%/delete','a:1:{i:4;s:9:\"menu_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','menu_delete_menu_page','a:1:{i:0;i:4;}','',61,6,0,'','admin/structure/menu/manage/%/delete','Delete menu','t','','','a:0:{}',6,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/item/%/delete','a:1:{i:4;s:14:\"menu_link_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','menu_item_delete_page','a:1:{i:0;i:4;}','',61,6,0,'','admin/structure/menu/item/%/delete','Delete menu link','t','','','a:0:{}',6,'','',0,'modules/menu/menu.admin.inc'),('admin/config/search/path/edit/%','a:1:{i:5;s:9:\"path_load\";}','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','path_admin_edit','a:1:{i:0;i:5;}','',62,6,0,'','admin/config/search/path/edit/%','Edit alias','t','','','a:0:{}',6,'','',0,'modules/path/path.admin.inc'),('admin/config/people/login-destination/edit/%','a:1:{i:5;s:22:\"login_destination_load\";}','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:2:{i:0;s:27:\"login_destination_edit_form\";i:1;i:5;}','',62,6,0,'','admin/config/people/login-destination/edit/%','Edit login destination rule','t','','','a:0:{}',6,'','',0,'sites/all/modules/contrib/login_destination/login_destination.admin.inc'),('admin/structure/menu/item/%/edit','a:1:{i:4;s:14:\"menu_link_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:4:{i:0;s:14:\"menu_edit_item\";i:1;s:4:\"edit\";i:2;i:4;i:3;N;}','',61,6,0,'','admin/structure/menu/item/%/edit','Edit menu link','t','','','a:0:{}',6,'','',0,'modules/menu/menu.admin.inc'),('entityreference/autocomplete/single/%/%/%','a:3:{i:3;N;i:4;N;i:5;N;}','','entityreference_autocomplete_access_callback','a:4:{i:0;i:2;i:1;i:3;i:2;i:4;i:3;i:5;}','entityreference_autocomplete_callback','a:4:{i:0;i:2;i:1;i:3;i:2;i:4;i:3;i:5;}','',56,6,0,'','entityreference/autocomplete/single/%/%/%','Entity Reference Autocomplete','t','','','a:0:{}',0,'','',0,''),('entityreference/autocomplete/tags/%/%/%','a:3:{i:3;N;i:4;N;i:5;N;}','','entityreference_autocomplete_access_callback','a:4:{i:0;i:2;i:1;i:3;i:2;i:4;i:3;i:5;}','entityreference_autocomplete_callback','a:4:{i:0;i:2;i:1;i:3;i:2;i:4;i:3;i:5;}','',56,6,0,'','entityreference/autocomplete/tags/%/%/%','Entity Reference Autocomplete','t','','','a:0:{}',0,'','',0,''),('admin/structure/menu/item/%/reset','a:1:{i:4;s:14:\"menu_link_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:2:{i:0;s:23:\"menu_reset_item_confirm\";i:1;i:4;}','',61,6,0,'','admin/structure/menu/item/%/reset','Reset menu link','t','','','a:0:{}',6,'','',0,'modules/menu/menu.admin.inc'),('admin/config/development/coder/review/settings','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:27:\"coder_review_admin_settings\";}','',63,6,1,'admin/config/development/coder/review','admin/config/development/coder','Settings','t','','','a:0:{}',132,'Select code review plugins and modules','',3,''),('admin/structure/taxonomy/%/display/full','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:4:\"full\";i:3;s:11:\"user_access\";i:4;s:19:\"administer taxonomy\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:4:\"full\";}','',59,6,1,'admin/structure/taxonomy/%/display','admin/structure/taxonomy/%','Taxonomy term page','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/display/token','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:5:\"token\";i:3;s:11:\"user_access\";i:4;s:19:\"administer taxonomy\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:5:\"token\";}','',59,6,1,'admin/structure/taxonomy/%/display','admin/structure/taxonomy/%','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/display/token','','','_field_ui_view_mode_menu_access','a:5:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:5:\"token\";i:3;s:11:\"user_access\";i:4;s:16:\"administer users\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:5:\"token\";}','',63,6,1,'admin/config/people/accounts/display','admin/config/people/accounts','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/display/full','','','_field_ui_view_mode_menu_access','a:5:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:4:\"full\";i:3;s:11:\"user_access\";i:4;s:16:\"administer users\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:4:\"full\";}','',63,6,1,'admin/config/people/accounts/display','admin/config/people/accounts','User account','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/regional/date-time/types/add','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:32:\"system_add_date_format_type_form\";}','',63,6,1,'admin/config/regional/date-time/types','admin/config/regional/date-time','Add date type','t','','','a:0:{}',388,'Add new date type.','',-10,'modules/system/system.admin.inc'),('admin/config/regional/date-time/formats/add','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:34:\"system_configure_date_formats_form\";}','',63,6,1,'admin/config/regional/date-time/formats','admin/config/regional/date-time','Add format','t','','','a:0:{}',388,'Allow users to add additional date formats.','',-10,'modules/system/system.admin.inc'),('admin/config/search/search_api/page/add','','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','drupal_get_form','a:1:{i:0;s:25:\"search_api_page_admin_add\";}','',63,6,1,'admin/config/search/search_api/page','admin/config/search/search_api','Add search page','t','','','a:0:{}',388,'Add a new search page.','',0,'sites/all/modules/contrib/search_api_page/search_api_page.admin.inc'),('admin/config/user-interface/shortcut/%/add-link','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:17:\"shortcut_link_add\";i:1;i:4;}','',61,6,1,'admin/config/user-interface/shortcut/%','admin/config/user-interface/shortcut/%','Add shortcut','t','','','a:0:{}',388,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%/add-link-inline','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','shortcut_link_add_inline','a:1:{i:0;i:4;}','',61,6,0,'','admin/config/user-interface/shortcut/%/add-link-inline','Add shortcut','t','','','a:0:{}',0,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/structure/views/view/%/break-lock','a:1:{i:4;s:19:\"views_ui_cache_load\";}','','user_access','a:1:{i:0;s:16:\"administer views\";}','drupal_get_form','a:2:{i:0;s:27:\"views_ui_break_lock_confirm\";i:1;i:4;}','',61,6,0,'','admin/structure/views/view/%/break-lock','Break lock','t','','','a:0:{}',4,'','',0,'sites/all/modules/contrib/views/includes/admin.inc'),('user/%/cancel/confirm/%/%','a:3:{i:1;s:9:\"user_load\";i:4;N;i:5;N;}','','user_cancel_access','a:1:{i:0;i:1;}','user_cancel_confirm','a:3:{i:0;i:1;i:1;i:4;i:2;i:5;}','',44,6,0,'','user/%/cancel/confirm/%/%','Confirm account cancellation','t','','','a:0:{}',6,'','',0,'modules/user/user.pages.inc'),('admin/config/system/actions/delete/%','a:1:{i:5;s:12:\"actions_load\";}','','user_access','a:1:{i:0;s:18:\"administer actions\";}','drupal_get_form','a:2:{i:0;s:26:\"system_actions_delete_form\";i:1;i:5;}','',62,6,0,'','admin/config/system/actions/delete/%','Delete action','t','','','a:0:{}',6,'Delete an action.','',0,'modules/system/system.admin.inc'),('admin/people/permissions/roles/delete/%','a:1:{i:5;s:14:\"user_role_load\";}','','user_role_edit_access','a:1:{i:0;i:5;}','drupal_get_form','a:2:{i:0;s:30:\"user_admin_role_delete_confirm\";i:1;i:5;}','',62,6,0,'','admin/people/permissions/roles/delete/%','Delete role','t','','','a:0:{}',6,'','',0,'modules/user/user.admin.inc'),('admin/config/user-interface/shortcut/%/delete','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_delete_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:24:\"shortcut_set_delete_form\";i:1;i:4;}','',61,6,0,'','admin/config/user-interface/shortcut/%/delete','Delete shortcut set','t','','','a:0:{}',6,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/content/formats/%/disable','a:1:{i:4;s:18:\"filter_format_load\";}','','_filter_disable_format_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:20:\"filter_admin_disable\";i:1;i:4;}','',61,6,0,'','admin/config/content/formats/%/disable','Disable text format','t','','','a:0:{}',6,'','',0,'modules/filter/filter.admin.inc'),('admin/structure/menu/manage/%/edit','a:1:{i:4;s:9:\"menu_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:3:{i:0;s:14:\"menu_edit_menu\";i:1;s:4:\"edit\";i:2;i:4;}','',61,6,3,'admin/structure/menu/manage/%','admin/structure/menu/manage/%','Edit menu','t','','','a:0:{}',132,'','',0,'modules/menu/menu.admin.inc'),('admin/config/search/search_api/page/%','a:1:{i:5;s:20:\"search_api_page_load\";}','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','drupal_get_form','a:2:{i:0;s:26:\"search_api_page_admin_edit\";i:1;i:5;}','',62,6,0,'','admin/config/search/search_api/page/%','Edit search page','t','','','a:0:{}',6,'Configure or delete a search page.','',0,'sites/all/modules/contrib/search_api_page/search_api_page.admin.inc'),('admin/config/user-interface/shortcut/%/edit','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:22:\"shortcut_set_edit_form\";i:1;i:4;}','',61,6,1,'admin/config/user-interface/shortcut/%','admin/config/user-interface/shortcut/%','Edit set name','t','','','a:0:{}',132,'','',10,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/link/%','a:1:{i:5;s:14:\"menu_link_load\";}','','shortcut_link_access','a:1:{i:0;i:5;}','drupal_get_form','a:2:{i:0;s:18:\"shortcut_link_edit\";i:1;i:5;}','',62,6,0,'','admin/config/user-interface/shortcut/link/%','Edit shortcut','t','','','a:0:{}',6,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/structure/views/view/%/edit','a:1:{i:4;s:19:\"views_ui_cache_load\";}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_edit_page','a:1:{i:0;i:4;}','',61,6,3,'admin/structure/views/view/%','admin/structure/views/view/%','Edit view','t','','ajax_base_page_theme','a:0:{}',140,'','',-10,'sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/types/manage/%/display','a:1:{i:4;s:14:\"node_type_load\";}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:7:\"default\";}','',61,6,1,'admin/structure/types/manage/%','admin/structure/types/manage/%','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/structure/pages/%/operation/%','a:2:{i:3;s:14:\"ctools_js_load\";i:5;s:23:\"page_manager_cache_load\";}','','user_access','a:1:{i:0;s:16:\"use page manager\";}','page_manager_edit_page_operation','a:2:{i:0;i:3;i:1;i:5;}','',58,6,0,'','admin/structure/pages/%/operation/%','','t','','ajax_base_page_theme','a:0:{}',6,'','',0,'sites/all/modules/contrib/ctools/page_manager/page_manager.admin.inc'),('admin/structure/pages/%/enable/%','a:2:{i:3;s:14:\"ctools_js_load\";i:5;s:23:\"page_manager_cache_load\";}','','user_access','a:1:{i:0;s:16:\"use page manager\";}','page_manager_enable_page','a:3:{i:0;b:0;i:1;i:3;i:2;i:5;}','',58,6,0,'','admin/structure/pages/%/enable/%','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/page_manager/page_manager.admin.inc'),('admin/structure/types/manage/%/fields','a:1:{i:4;s:14:\"node_type_load\";}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:4:\"node\";i:2;i:4;}','',61,6,1,'admin/structure/types/manage/%','admin/structure/types/manage/%','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/pages/%/disable/%','a:2:{i:3;s:14:\"ctools_js_load\";i:5;s:23:\"page_manager_cache_load\";}','','user_access','a:1:{i:0;s:16:\"use page manager\";}','page_manager_enable_page','a:3:{i:0;b:1;i:1;i:3;i:2;i:5;}','',58,6,0,'','admin/structure/pages/%/disable/%','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/page_manager/page_manager.admin.inc'),('admin/structure/views/nojs/%/%','a:2:{i:4;N;i:5;s:19:\"views_ui_cache_load\";}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_ajax_form','a:3:{i:0;b:0;i:1;i:4;i:2;i:5;}','',60,6,0,'','admin/structure/views/nojs/%/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/views/ajax/%/%','a:2:{i:4;N;i:5;s:19:\"views_ui_cache_load\";}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_ajax_form','a:3:{i:0;b:1;i:1;i:4;i:2;i:5;}','ajax_deliver',60,6,0,'','admin/structure/views/ajax/%/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/panels/layouts/list/%','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:14:\"panels_layouts\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:4:\"edit\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:4:\"edit\";i:2;i:5;}','',62,6,0,'','admin/structure/panels/layouts/list/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/views/template/%/add','a:1:{i:4;N;}','','ctools_export_ui_task_access','a:3:{i:0;s:8:\"views_ui\";i:1;s:12:\"add_template\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:\"views_ui\";i:1;s:12:\"add_template\";i:2;i:4;}','',61,6,0,'','admin/structure/views/template/%/add','Add from template','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/ctools-content/list/%/clone','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:21:\"ctools_custom_content\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:21:\"ctools_custom_content\";i:1;s:5:\"clone\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:21:\"ctools_custom_content\";i:1;s:5:\"clone\";i:2;i:4;}','',61,6,0,'','admin/structure/ctools-content/list/%/clone','Clone','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/mini-panels/list/%/clone','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:11:\"panels_mini\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:11:\"panels_mini\";i:1;s:5:\"clone\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:11:\"panels_mini\";i:1;s:5:\"clone\";i:2;i:4;}','',61,6,0,'','admin/structure/mini-panels/list/%/clone','Clone','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/views/view/%/clone','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:\"views_ui\";i:1;s:5:\"clone\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:\"views_ui\";i:1;s:5:\"clone\";i:2;i:4;}','',61,6,0,'','admin/structure/views/view/%/clone','Clone','t','','','a:0:{}',4,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/ctools-content/list/%/delete','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:21:\"ctools_custom_content\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:21:\"ctools_custom_content\";i:1;s:6:\"delete\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:21:\"ctools_custom_content\";i:1;s:6:\"delete\";i:2;i:4;}','',61,6,0,'','admin/structure/ctools-content/list/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/mini-panels/list/%/delete','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:11:\"panels_mini\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:11:\"panels_mini\";i:1;s:6:\"delete\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:11:\"panels_mini\";i:1;s:6:\"delete\";i:2;i:4;}','',61,6,0,'','admin/structure/mini-panels/list/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/views/view/%/delete','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"delete\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"delete\";i:2;i:4;}','',61,6,0,'','admin/structure/views/view/%/delete','Delete','t','','','a:0:{}',4,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/ctools-content/list/%/disable','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:21:\"ctools_custom_content\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:21:\"ctools_custom_content\";i:1;s:7:\"disable\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:21:\"ctools_custom_content\";i:1;s:7:\"disable\";i:2;i:4;}','',61,6,0,'','admin/structure/ctools-content/list/%/disable','Disable','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/mini-panels/list/%/disable','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:11:\"panels_mini\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:11:\"panels_mini\";i:1;s:7:\"disable\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:11:\"panels_mini\";i:1;s:7:\"disable\";i:2;i:4;}','',61,6,0,'','admin/structure/mini-panels/list/%/disable','Disable','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/views/view/%/disable','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:\"views_ui\";i:1;s:7:\"disable\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:\"views_ui\";i:1;s:7:\"disable\";i:2;i:4;}','',61,6,0,'','admin/structure/views/view/%/disable','Disable','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/ctools-content/list/%/edit','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:21:\"ctools_custom_content\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:21:\"ctools_custom_content\";i:1;s:4:\"edit\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:21:\"ctools_custom_content\";i:1;s:4:\"edit\";i:2;i:4;}','',61,6,1,'admin/structure/ctools-content/list/%','admin/structure/ctools-content/list/%','Edit','t','','','a:0:{}',140,'','',-10,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/mini-panels/list/%/edit','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:11:\"panels_mini\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:11:\"panels_mini\";i:1;s:4:\"edit\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:11:\"panels_mini\";i:1;s:4:\"edit\";i:2;i:4;}','',61,6,1,'admin/structure/mini-panels/list/%','admin/structure/mini-panels/list/%','Edit','t','','','a:0:{}',140,'','',-10,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/ctools-content/list/%/enable','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:21:\"ctools_custom_content\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:21:\"ctools_custom_content\";i:1;s:6:\"enable\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:21:\"ctools_custom_content\";i:1;s:6:\"enable\";i:2;i:4;}','',61,6,0,'','admin/structure/ctools-content/list/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/mini-panels/list/%/enable','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:11:\"panels_mini\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:11:\"panels_mini\";i:1;s:6:\"enable\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:11:\"panels_mini\";i:1;s:6:\"enable\";i:2;i:4;}','',61,6,0,'','admin/structure/mini-panels/list/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/views/view/%/enable','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"enable\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"enable\";i:2;i:4;}','',61,6,0,'','admin/structure/views/view/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/ctools-content/list/%/export','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:21:\"ctools_custom_content\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:21:\"ctools_custom_content\";i:1;s:6:\"export\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:21:\"ctools_custom_content\";i:1;s:6:\"export\";i:2;i:4;}','',61,6,1,'admin/structure/ctools-content/list/%','admin/structure/ctools-content/list/%','Export','t','','','a:0:{}',132,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/mini-panels/list/%/export','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:11:\"panels_mini\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:11:\"panels_mini\";i:1;s:6:\"export\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:11:\"panels_mini\";i:1;s:6:\"export\";i:2;i:4;}','',61,6,1,'admin/structure/mini-panels/list/%','admin/structure/mini-panels/list/%','Export','t','','','a:0:{}',132,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/views/view/%/export','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"export\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"export\";i:2;i:4;}','',61,6,0,'','admin/structure/views/view/%/export','Export','t','','','a:0:{}',4,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/ctools-content/list/%/revert','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:21:\"ctools_custom_content\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:21:\"ctools_custom_content\";i:1;s:6:\"revert\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:21:\"ctools_custom_content\";i:1;s:6:\"delete\";i:2;i:4;}','',61,6,0,'','admin/structure/ctools-content/list/%/revert','Revert','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/mini-panels/list/%/revert','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:11:\"panels_mini\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:11:\"panels_mini\";i:1;s:6:\"revert\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:11:\"panels_mini\";i:1;s:6:\"delete\";i:2;i:4;}','',61,6,0,'','admin/structure/mini-panels/list/%/revert','Revert','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/views/view/%/revert','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"revert\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"delete\";i:2;i:4;}','',61,6,0,'','admin/structure/views/view/%/revert','Revert','t','','','a:0:{}',4,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/config/search/search_api/index/%','a:1:{i:5;s:21:\"search_api_index_load\";}','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','search_api_admin_index_view','a:1:{i:0;i:5;}','',62,6,0,'','admin/config/search/search_api/index/%','View index','search_api_admin_item_title','a:1:{i:0;i:5;}','','a:0:{}',6,'View index details.','',0,'sites/all/modules/contrib/search_api/search_api.admin.inc'),('admin/config/search/search_api/server/%','a:1:{i:5;s:22:\"search_api_server_load\";}','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','search_api_admin_server_view','a:1:{i:0;i:5;}','',62,6,0,'','admin/config/search/search_api/server/%','View server','search_api_admin_item_title','a:1:{i:0;i:5;}','','a:0:{}',6,'View server details.','',0,'sites/all/modules/contrib/search_api/search_api.admin.inc'),('admin/structure/taxonomy/%/fields/%','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',58,6,0,'','admin/structure/taxonomy/%/fields/%','','field_ui_menu_title','a:1:{i:0;i:5;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields/%','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',62,6,0,'','admin/config/people/accounts/fields/%','','field_ui_menu_title','a:1:{i:0;i:5;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/search/search_api/index/%/view','a:1:{i:5;s:21:\"search_api_index_load\";}','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','search_api_admin_index_view','a:1:{i:0;i:5;}','',125,7,1,'admin/config/search/search_api/index/%','admin/config/search/search_api/index/%','View','t','','','a:0:{}',140,'','',-10,'sites/all/modules/contrib/search_api/search_api.admin.inc'),('admin/config/search/search_api/server/%/view','a:1:{i:5;s:22:\"search_api_server_load\";}','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','search_api_admin_server_view','a:1:{i:0;i:5;}','',125,7,1,'admin/config/search/search_api/server/%','admin/config/search/search_api/server/%','View','t','','','a:0:{}',140,'','',-10,'sites/all/modules/contrib/search_api/search_api.admin.inc'),('admin/structure/block/manage/%/%/configure','a:2:{i:4;N;i:5;N;}','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:3:{i:0;s:21:\"block_admin_configure\";i:1;i:4;i:2;i:5;}','',121,7,2,'admin/structure/block/manage/%/%','admin/structure/block/manage/%/%','Configure block','t','','','a:0:{}',140,'','',0,'modules/block/block.admin.inc'),('admin/structure/types/manage/%/display/default','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:4:\"node\";i:1;i:4;i:2;s:7:\"default\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:7:\"default\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/full','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:4:\"node\";i:1;i:4;i:2;s:4:\"full\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:4:\"full\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Full content','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('ctools-popups/%/vm/settings/%/%/%','a:4:{i:1;s:14:\"ctools_js_load\";i:4;N;i:5;N;i:6;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','ctools_popups_vm_setting_others','a:4:{i:0;i:1;i:1;i:4;i:2;i:5;i:3;i:6;}','',88,7,0,'','ctools-popups/%/vm/settings/%/%/%','','t','','','a:0:{}',6,'','',0,''),('admin/structure/types/manage/%/display/rss','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:4:\"node\";i:1;i:4;i:2;s:3:\"rss\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:3:\"rss\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','RSS','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('ctools-popups/%/vdisk/settings/%/%/%','a:4:{i:1;s:14:\"ctools_js_load\";i:4;N;i:5;N;i:6;N;}','','user_access','a:1:{i:0;s:25:\"access mercury_management\";}','ctools_popups_vdisk_setting','a:4:{i:0;i:1;i:1;i:4;i:2;i:5;i:3;i:6;}','',88,7,0,'','ctools-popups/%/vdisk/settings/%/%/%','','t','','','a:0:{}',6,'','',0,''),('admin/structure/types/manage/%/display/search_index','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:4:\"node\";i:1;i:4;i:2;s:12:\"search_index\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:12:\"search_index\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Search index','t','','','a:0:{}',132,'','',3,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/search_result','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:4:\"node\";i:1;i:4;i:2;s:13:\"search_result\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:13:\"search_result\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Search result','t','','','a:0:{}',132,'','',4,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/teaser','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:4:\"node\";i:1;i:4;i:2;s:6:\"teaser\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:6:\"teaser\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Teaser','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/token','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:4:\"node\";i:1;i:4;i:2;s:5:\"token\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:5:\"token\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Tokens','t','','','a:0:{}',132,'','',5,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/display','a:1:{i:4;s:22:\"comment_node_type_load\";}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:7:\"default\";}','',123,7,1,'admin/structure/types/manage/%','admin/structure/types/manage/%','Comment display','t','','','a:0:{}',132,'','',4,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields','a:1:{i:4;s:22:\"comment_node_type_load\";}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:7:\"comment\";i:2;i:4;}','',123,7,1,'admin/structure/types/manage/%','admin/structure/types/manage/%','Comment fields','t','','','a:0:{}',132,'','',3,'modules/field_ui/field_ui.admin.inc'),('admin/structure/block/manage/%/%/delete','a:2:{i:4;N;i:5;N;}','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:3:{i:0;s:25:\"block_custom_block_delete\";i:1;i:4;i:2;i:5;}','',121,7,0,'admin/structure/block/manage/%/%','admin/structure/block/manage/%/%','Delete block','t','','','a:0:{}',132,'','',0,'modules/block/block.admin.inc'),('admin/config/regional/date-time/formats/%/delete','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:2:{i:0;s:30:\"system_date_delete_format_form\";i:1;i:5;}','',125,7,0,'','admin/config/regional/date-time/formats/%/delete','Delete date format','t','','','a:0:{}',6,'Allow users to delete a configured date format.','',0,'modules/system/system.admin.inc'),('admin/config/regional/date-time/types/%/delete','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:2:{i:0;s:35:\"system_delete_date_format_type_form\";i:1;i:5;}','',125,7,0,'','admin/config/regional/date-time/types/%/delete','Delete date type','t','','','a:0:{}',6,'Allow users to delete a configured date type.','',0,'modules/system/system.admin.inc'),('admin/config/user-interface/shortcut/link/%/delete','a:1:{i:5;s:14:\"menu_link_load\";}','','shortcut_link_access','a:1:{i:0;i:5;}','drupal_get_form','a:2:{i:0;s:20:\"shortcut_link_delete\";i:1;i:5;}','',125,7,0,'','admin/config/user-interface/shortcut/link/%/delete','Delete shortcut','t','','','a:0:{}',6,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/regional/date-time/formats/%/edit','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:2:{i:0;s:34:\"system_configure_date_formats_form\";i:1;i:5;}','',125,7,0,'','admin/config/regional/date-time/formats/%/edit','Edit date format','t','','','a:0:{}',6,'Allow users to edit a configured date format.','',0,'modules/system/system.admin.inc'),('admin/structure/views/nojs/preview/%/%','a:2:{i:5;s:19:\"views_ui_cache_load\";i:6;N;}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_preview','a:2:{i:0;i:5;i:1;i:6;}','',124,7,0,'','admin/structure/views/nojs/preview/%/%','','t','','','a:0:{}',6,'','',0,'sites/all/modules/contrib/views/includes/admin.inc'),('admin/config/search/search_api/server/%/edit','a:1:{i:5;s:22:\"search_api_server_load\";}','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','drupal_get_form','a:2:{i:0;s:28:\"search_api_admin_server_edit\";i:1;i:5;}','',125,7,1,'admin/config/search/search_api/server/%','admin/config/search/search_api/server/%','Edit','t','','','a:0:{}',132,'Edit server details.','',-1,'sites/all/modules/contrib/search_api/search_api.admin.inc'),('admin/structure/views/view/%/preview/%','a:2:{i:4;s:19:\"views_ui_cache_load\";i:6;N;}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_build_preview','a:2:{i:0;i:4;i:1;i:6;}','',122,7,3,'','admin/structure/views/view/%/preview/%','','t','','','a:0:{}',4,'','',0,'sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/taxonomy/%/groups/%/delete','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:5;}','',117,7,0,'','admin/structure/taxonomy/%/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/views/ajax/preview/%/%','a:2:{i:5;s:19:\"views_ui_cache_load\";i:6;N;}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_preview','a:2:{i:0;i:5;i:1;i:6;}','ajax_deliver',124,7,0,'','admin/structure/views/ajax/preview/%/%','','t','','','a:0:{}',6,'','',0,'sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/taxonomy/%/fields/%/delete','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:5;}','',117,7,1,'admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/fields/%/edit','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',117,7,1,'admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/search/search_api/index/%/fields','a:1:{i:5;s:21:\"search_api_index_load\";}','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','drupal_get_form','a:2:{i:0;s:29:\"search_api_admin_index_fields\";i:1;i:5;}','',125,7,3,'admin/config/search/search_api/index/%','admin/config/search/search_api/index/%','Fields','t','','','a:0:{}',132,'Select indexed fields.','',-4,'sites/all/modules/contrib/search_api/search_api.admin.inc'),('admin/config/search/search_api/index/%/edit','a:1:{i:5;s:21:\"search_api_index_load\";}','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','drupal_get_form','a:2:{i:0;s:27:\"search_api_admin_index_edit\";i:1;i:5;}','',125,7,3,'admin/config/search/search_api/index/%','admin/config/search/search_api/index/%','Settings','t','','','a:0:{}',132,'Edit index settings.','',-6,'sites/all/modules/contrib/search_api/search_api.admin.inc'),('admin/config/search/search_api/index/%/status','a:1:{i:5;s:21:\"search_api_index_load\";}','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','drupal_get_form','a:2:{i:0;s:34:\"search_api_admin_index_status_form\";i:1;i:5;}','',125,7,3,'admin/config/search/search_api/index/%','admin/config/search/search_api/index/%','Status','t','','','a:0:{}',132,'Display and work on index status.','',-8,'sites/all/modules/contrib/search_api/search_api.admin.inc'),('admin/structure/taxonomy/%/fields/%/widget-type','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:5;}','',117,7,1,'admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/groups/%/delete','a:1:{i:5;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:5;}','',125,7,0,'','admin/config/people/accounts/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/config/people/accounts/fields/%/delete','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:5;}','',125,7,1,'admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields/%/widget-type','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:5;}','',125,7,1,'admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/search/search_api/index/%/workflow','a:1:{i:5;s:21:\"search_api_index_load\";}','','user_access','a:1:{i:0;s:21:\"administer search_api\";}','drupal_get_form','a:2:{i:0;s:31:\"search_api_admin_index_workflow\";i:1;i:5;}','',125,7,3,'admin/config/search/search_api/index/%','admin/config/search/search_api/index/%','Workflow','t','','','a:0:{}',132,'Edit index workflow.','',-2,'sites/all/modules/contrib/search_api/search_api.admin.inc'),('admin/structure/taxonomy/%/fields/%/field-settings','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:5;}','',117,7,1,'admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields/%/edit','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',125,7,1,'admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields/%/field-settings','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:5;}','',125,7,1,'admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/panels/layouts/list/%/clone','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:14:\"panels_layouts\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:5:\"clone\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:5:\"clone\";i:2;i:5;}','',125,7,0,'','admin/structure/panels/layouts/list/%/clone','Clone','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/list/%/delete','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:14:\"panels_layouts\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"delete\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"delete\";i:2;i:5;}','',125,7,0,'','admin/structure/panels/layouts/list/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/list/%/disable','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:14:\"panels_layouts\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:7:\"disable\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:7:\"disable\";i:2;i:5;}','',125,7,0,'','admin/structure/panels/layouts/list/%/disable','Disable','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/list/%/edit','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:14:\"panels_layouts\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:4:\"edit\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:4:\"edit\";i:2;i:5;}','',125,7,1,'admin/structure/panels/layouts/list/%','admin/structure/panels/layouts/list/%','Edit','t','','','a:0:{}',140,'','',-10,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/list/%/enable','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:14:\"panels_layouts\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"enable\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"enable\";i:2;i:5;}','',125,7,0,'','admin/structure/panels/layouts/list/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/list/%/export','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:14:\"panels_layouts\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"export\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"export\";i:2;i:5;}','',125,7,1,'admin/structure/panels/layouts/list/%','admin/structure/panels/layouts/list/%','Export','t','','','a:0:{}',132,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/list/%/revert','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:14:\"panels_layouts\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"revert\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"delete\";i:2;i:5;}','',125,7,0,'','admin/structure/panels/layouts/list/%/revert','Revert','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/ctools/includes/export-ui.inc'),('admin/config/search/search_api/index/%/delete','a:1:{i:5;s:21:\"search_api_index_load\";}','','search_api_access_delete_page','a:1:{i:0;i:5;}','drupal_get_form','a:4:{i:0;s:24:\"search_api_admin_confirm\";i:1;s:5:\"index\";i:2;s:6:\"delete\";i:3;i:5;}','',125,7,1,'admin/config/search/search_api/index/%','admin/config/search/search_api/index/%','Delete','search_api_title_delete_page','a:1:{i:0;i:5;}','','a:0:{}',132,'Delete index.','',0,'sites/all/modules/contrib/search_api/search_api.admin.inc'),('admin/config/search/search_api/server/%/delete','a:1:{i:5;s:22:\"search_api_server_load\";}','','search_api_access_delete_page','a:1:{i:0;i:5;}','drupal_get_form','a:4:{i:0;s:24:\"search_api_admin_confirm\";i:1;s:6:\"server\";i:2;s:6:\"delete\";i:3;i:5;}','',125,7,1,'admin/config/search/search_api/server/%','admin/config/search/search_api/server/%','Delete','search_api_title_delete_page','a:1:{i:0;i:5;}','','a:0:{}',132,'Delete server.','',0,'sites/all/modules/contrib/search_api/search_api.admin.inc'),('admin/structure/types/manage/%/fields/%','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',122,7,0,'','admin/structure/types/manage/%/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/display/default','a:1:{i:4;s:22:\"comment_node_type_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:7:\"default\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:7:\"default\";}','',247,8,1,'admin/structure/types/manage/%/comment/display','admin/structure/types/manage/%','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/display/full','a:1:{i:4;s:22:\"comment_node_type_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:4:\"full\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:4:\"full\";}','',247,8,1,'admin/structure/types/manage/%/comment/display','admin/structure/types/manage/%','Full comment','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/display/token','a:1:{i:4;s:22:\"comment_node_type_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:5:\"token\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:5:\"token\";}','',247,8,1,'admin/structure/types/manage/%/comment/display','admin/structure/types/manage/%','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/groups/%/delete','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:6;}','',245,8,0,'','admin/structure/types/manage/%/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/types/manage/%/fields/%/delete','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:6;}','',245,8,1,'admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/fields/%/edit','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',245,8,1,'admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/fields/%/field-settings','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:6;}','',245,8,1,'admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/fields/%/widget-type','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:6;}','',245,8,1,'admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/views/view/%/edit/%/ajax','a:2:{i:4;s:19:\"views_ui_cache_load\";i:6;N;}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_ajax_get_form','a:3:{i:0;s:18:\"views_ui_edit_form\";i:1;i:4;i:2;i:6;}','ajax_deliver',245,8,0,'','admin/structure/views/view/%/edit/%/ajax','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/views/view/%/preview/%/ajax','a:2:{i:4;s:19:\"views_ui_cache_load\";i:6;N;}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_build_preview','a:2:{i:0;i:4;i:1;i:6;}','ajax_deliver',245,8,0,'','admin/structure/views/view/%/preview/%/ajax','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/contrib/views/includes/admin.inc'),('admin/structure/types/manage/%/comment/fields/%','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}','',246,8,0,'','admin/structure/types/manage/%/comment/fields/%','','field_ui_menu_title','a:1:{i:0;i:7;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/groups/%/delete','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:7;}','',493,9,0,'','admin/structure/types/manage/%/comment/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/contrib/field_group/field_group.field_ui.inc'),('admin/structure/types/manage/%/comment/fields/%/delete','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:7;}','',493,9,1,'admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields/%/edit','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}','',493,9,1,'admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields/%/field-settings','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:7;}','',493,9,1,'admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields/%/widget-type','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:7;}','',493,9,1,'admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc');
/*!40000 ALTER TABLE `menu_router` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mercury_utilities_import_saved_credentials`
--

DROP TABLE IF EXISTS `mercury_utilities_import_saved_credentials`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mercury_utilities_import_saved_credentials` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` varchar(32) NOT NULL,
  `title` varchar(255) NOT NULL,
  `username` varchar(255) DEFAULT NULL,
  `password` varchar(255) DEFAULT NULL,
  `install_port` varchar(10) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `title_type` (`title`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Credential storage for undiscovered nodes.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mercury_utilities_import_saved_credentials`
--

LOCK TABLES `mercury_utilities_import_saved_credentials` WRITE;
/*!40000 ALTER TABLE `mercury_utilities_import_saved_credentials` DISABLE KEYS */;
/*!40000 ALTER TABLE `mercury_utilities_import_saved_credentials` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `node`
--

DROP TABLE IF EXISTS `node`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node` (
  `nid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a node.',
  `vid` int(10) unsigned DEFAULT NULL COMMENT 'The current node_revision.vid version identifier.',
  `type` varchar(32) NOT NULL DEFAULT '' COMMENT 'The node_type.type of this node.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The languages.language of this node.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title of this node, always treated as non-markup plain text.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that owns this node; initially, this is the user that created it.',
  `status` int(11) NOT NULL DEFAULT '1' COMMENT 'Boolean indicating whether the node is published (visible to non-administrators).',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the node was created.',
  `changed` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the node was most recently saved.',
  `comment` int(11) NOT NULL DEFAULT '0' COMMENT 'Whether comments are allowed on this node: 0 = no, 1 = closed (read only), 2 = open (read/write).',
  `promote` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the node should be displayed on the front page.',
  `sticky` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the node should be displayed at the top of lists in which it appears.',
  `tnid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The translation set id for this node, which equals the node id of the source post in each set.',
  `translate` int(11) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this translation page needs to be updated.',
  PRIMARY KEY (`nid`),
  UNIQUE KEY `vid` (`vid`),
  KEY `node_changed` (`changed`),
  KEY `node_created` (`created`),
  KEY `node_frontpage` (`promote`,`status`,`sticky`,`created`),
  KEY `node_status_type` (`status`,`type`,`nid`),
  KEY `node_title_type` (`title`,`type`(4)),
  KEY `node_type` (`type`(4)),
  KEY `uid` (`uid`),
  KEY `tnid` (`tnid`),
  KEY `translate` (`translate`)
) ENGINE=MyISAM AUTO_INCREMENT=201413 DEFAULT CHARSET=utf8 COMMENT='The base table for nodes.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node`
--

LOCK TABLES `node` WRITE;
/*!40000 ALTER TABLE `node` DISABLE KEYS */;
INSERT INTO `node` VALUES (1,1,'vcenter','und','',1,1,1355706197,1371656328,1,0,0,0,0);
/*!40000 ALTER TABLE `node` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `node_access`
--

DROP TABLE IF EXISTS `node_access`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_access` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid this record affects.',
  `gid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The grant ID a user must possess in the specified realm to gain this row’s privileges on the node.',
  `realm` varchar(255) NOT NULL DEFAULT '' COMMENT 'The realm in which the user must possess the grant ID. Each node access node can define one or more realms.',
  `grant_view` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether a user with the realm/grant pair can view this node.',
  `grant_update` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether a user with the realm/grant pair can edit this node.',
  `grant_delete` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether a user with the realm/grant pair can delete this node.',
  PRIMARY KEY (`nid`,`gid`,`realm`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Identifies which realm/grant pairs a user must possess in...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_access`
--

LOCK TABLES `node_access` WRITE;
/*!40000 ALTER TABLE `node_access` DISABLE KEYS */;
INSERT INTO `node_access` VALUES (0,0,'all',1,0,0);
/*!40000 ALTER TABLE `node_access` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `node_comment_statistics`
--

DROP TABLE IF EXISTS `node_comment_statistics`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_comment_statistics` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid for which the statistics are compiled.',
  `cid` int(11) NOT NULL DEFAULT '0' COMMENT 'The comment.cid of the last comment.',
  `last_comment_timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp of the last comment that was posted within this node, from comment.changed.',
  `last_comment_name` varchar(60) DEFAULT NULL COMMENT 'The name of the latest author to post a comment on this node, from comment.name.',
  `last_comment_uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The user ID of the latest author to post a comment on this node, from comment.uid.',
  `comment_count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The total number of comments on this node.',
  PRIMARY KEY (`nid`),
  KEY `node_comment_timestamp` (`last_comment_timestamp`),
  KEY `comment_count` (`comment_count`),
  KEY `last_comment_uid` (`last_comment_uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Maintains statistics of node and comments posts to show ...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_comment_statistics`
--

LOCK TABLES `node_comment_statistics` WRITE;
/*!40000 ALTER TABLE `node_comment_statistics` DISABLE KEYS */;
INSERT INTO `node_comment_statistics` VALUES (1,0,1355706197,NULL,1,0);
/*!40000 ALTER TABLE `node_comment_statistics` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `node_revision`
--

DROP TABLE IF EXISTS `node_revision`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_revision` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node this version belongs to.',
  `vid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for this version.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that created this version.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title of this version.',
  `log` longtext NOT NULL COMMENT 'The log entry explaining the changes in this version.',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when this version was created.',
  `status` int(11) NOT NULL DEFAULT '1' COMMENT 'Boolean indicating whether the node (at the time of this revision) is published (visible to non-administrators).',
  `comment` int(11) NOT NULL DEFAULT '0' COMMENT 'Whether comments are allowed on this node (at the time of this revision): 0 = no, 1 = closed (read only), 2 = open (read/write).',
  `promote` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the node (at the time of this revision) should be displayed on the front page.',
  `sticky` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the node (at the time of this revision) should be displayed at the top of lists in which it appears.',
  PRIMARY KEY (`vid`),
  KEY `nid` (`nid`),
  KEY `uid` (`uid`)
) ENGINE=MyISAM AUTO_INCREMENT=201413 DEFAULT CHARSET=utf8 COMMENT='Stores information about each saved version of a node.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_revision`
--

LOCK TABLES `node_revision` WRITE;
/*!40000 ALTER TABLE `node_revision` DISABLE KEYS */;
INSERT INTO `node_revision` VALUES (1,1,1,'','',1371656328,1,1,0,0);
/*!40000 ALTER TABLE `node_revision` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `node_type`
--

DROP TABLE IF EXISTS `node_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_type` (
  `type` varchar(32) NOT NULL COMMENT 'The machine-readable name of this type.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The human-readable name of this type.',
  `base` varchar(255) NOT NULL COMMENT 'The base string used to construct callbacks corresponding to this node type.',
  `module` varchar(255) NOT NULL COMMENT 'The module defining this node type.',
  `description` mediumtext NOT NULL COMMENT 'A brief description of this type.',
  `help` mediumtext NOT NULL COMMENT 'Help information shown to the user when creating a node of this type.',
  `has_title` tinyint(3) unsigned NOT NULL COMMENT 'Boolean indicating whether this type uses the node.title field.',
  `title_label` varchar(255) NOT NULL DEFAULT '' COMMENT 'The label displayed for the title field on the edit form.',
  `custom` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this type is defined by a module (FALSE) or by a user via Add content type (TRUE).',
  `modified` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this type has been modified by an administrator; currently not used in any way.',
  `locked` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether the administrator can change the machine name of this type.',
  `disabled` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether the node type is disabled.',
  `orig_type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The original machine-readable name of this node type. This may be different from the current type name if the locked field is 0.',
  PRIMARY KEY (`type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores information about all defined node types.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_type`
--

LOCK TABLES `node_type` WRITE;
/*!40000 ALTER TABLE `node_type` DISABLE KEYS */;
INSERT INTO `node_type` VALUES ('article','Article','node_content','node','Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.','',1,'Title',1,1,0,0,'article'),('data_center','Data Center','node_content','node','','',1,'Data Center Name',1,1,0,0,'data_center'),('device','Device','node_content','node','A physical hard drive available to a host.','',1,'Device Name',1,1,0,0,'device'),('host','Host','node_content','node','An ESXi 5.0 host on a vCenter','',1,'Title',1,1,0,0,'host'),('page','Basic page','node_content','node','Use <em>basic pages</em> for your static content, such as an \'About us\' page.','',1,'Title',1,1,0,0,'page'),('panel','Panel','panels_node_hook','panels_node','A panel layout broken up into rows and columns.','',1,'Title',0,0,1,0,'panel'),('vcenter','vCenter','node_content','node','Add new vCenter','',1,'Host Name',1,1,0,0,'vcenter'),('vdisk','vDisk','node_content','node','A virtual disk that is located on a VM','',1,'Title',1,1,0,0,'vdisk'),('vdisk_metrics','vDisk metrics','node_content','node','The metrics from the vDisks.','',1,'Metric Id',1,1,0,0,'vdisk_metrics'),('virtual_machine','Virtual Machine','node_content','node','','',1,'VM Name',1,1,0,0,'virtual_machine'),('vm_cache_space','VM Cache Space','node_content','node','Stores all the details related to Cache Space for any VM','',1,'Cache Space ID',1,1,0,0,'vm_cache_space'),('vm_metrics','VM metrics','node_content','node','Stores the metrics data of VMs.','',1,'Metric Id',1,1,0,0,'vm_metrics');
/*!40000 ALTER TABLE `node_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `page_manager_handlers`
--

DROP TABLE IF EXISTS `page_manager_handlers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `page_manager_handlers` (
  `did` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary ID field for the table. Not used for anything except internal lookups.',
  `name` varchar(255) DEFAULT NULL COMMENT 'Unique ID for this task handler. Used to identify it programmatically.',
  `task` varchar(64) DEFAULT NULL COMMENT 'ID of the task this handler is for.',
  `subtask` varchar(64) NOT NULL DEFAULT '' COMMENT 'ID of the subtask this handler is for.',
  `handler` varchar(64) DEFAULT NULL COMMENT 'ID of the task handler being used.',
  `weight` int(11) DEFAULT NULL COMMENT 'The order in which this handler appears. Lower numbers go first.',
  `conf` longtext NOT NULL COMMENT 'Serialized configuration of the handler, if needed.',
  PRIMARY KEY (`did`),
  UNIQUE KEY `name` (`name`),
  KEY `fulltask` (`task`,`subtask`,`weight`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `page_manager_handlers`
--

LOCK TABLES `page_manager_handlers` WRITE;
/*!40000 ALTER TABLE `page_manager_handlers` DISABLE KEYS */;
INSERT INTO `page_manager_handlers` VALUES (1,'page_home_page_panel_context','page','home_page','panel_context',0,'a:10:{s:5:\"title\";s:5:\"Panel\";s:9:\"no_blocks\";i:0;s:8:\"pipeline\";s:8:\"standard\";s:22:\"body_classes_to_remove\";s:0:\"\";s:19:\"body_classes_to_add\";s:0:\"\";s:6:\"css_id\";s:0:\"\";s:3:\"css\";s:0:\"\";s:8:\"contexts\";a:0:{}s:13:\"relationships\";a:0:{}s:3:\"did\";s:1:\"2\";}'),(2,'page_mercury_host_panel_context','page','mercury_host','panel_context',0,'a:10:{s:5:\"title\";s:10:\"Host Panel\";s:9:\"no_blocks\";i:0;s:8:\"pipeline\";s:8:\"standard\";s:22:\"body_classes_to_remove\";s:0:\"\";s:19:\"body_classes_to_add\";s:0:\"\";s:6:\"css_id\";s:0:\"\";s:3:\"css\";s:0:\"\";s:8:\"contexts\";a:0:{}s:13:\"relationships\";a:0:{}s:3:\"did\";s:1:\"3\";}'),(3,'page_all_panel_context','page','all','panel_context',0,'a:10:{s:5:\"title\";s:12:\"VM Directory\";s:9:\"no_blocks\";i:0;s:8:\"pipeline\";s:8:\"standard\";s:22:\"body_classes_to_remove\";s:0:\"\";s:19:\"body_classes_to_add\";s:0:\"\";s:6:\"css_id\";s:0:\"\";s:3:\"css\";s:0:\"\";s:8:\"contexts\";a:0:{}s:13:\"relationships\";a:0:{}s:3:\"did\";s:1:\"4\";}'),(4,'page_ongoing_processes_panel_context','page','ongoing_processes','panel_context',0,'a:10:{s:5:\"title\";s:17:\"Ongoing Processes\";s:9:\"no_blocks\";i:0;s:8:\"pipeline\";s:8:\"standard\";s:22:\"body_classes_to_remove\";s:0:\"\";s:19:\"body_classes_to_add\";s:0:\"\";s:6:\"css_id\";s:0:\"\";s:3:\"css\";s:0:\"\";s:8:\"contexts\";a:0:{}s:13:\"relationships\";a:0:{}s:3:\"did\";s:1:\"5\";}');
/*!40000 ALTER TABLE `page_manager_handlers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `page_manager_pages`
--

DROP TABLE IF EXISTS `page_manager_pages`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `page_manager_pages` (
  `pid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary ID field for the table. Not used for anything except internal lookups.',
  `name` varchar(255) DEFAULT NULL COMMENT 'Unique ID for this subtask. Used to identify it programmatically.',
  `task` varchar(64) DEFAULT 'page' COMMENT 'What type of page this is, so that we can use the same mechanism for creating tighter UIs for targeted pages.',
  `admin_title` varchar(255) DEFAULT NULL COMMENT 'Human readable title for this page subtask.',
  `admin_description` longtext COMMENT 'Administrative description of this item.',
  `path` varchar(255) DEFAULT NULL COMMENT 'The menu path that will invoke this task.',
  `access` longtext NOT NULL COMMENT 'Access configuration for this path.',
  `menu` longtext NOT NULL COMMENT 'Serialized configuration of Drupal menu visibility settings for this item.',
  `arguments` longtext NOT NULL COMMENT 'Configuration of arguments for this menu item.',
  `conf` longtext NOT NULL COMMENT 'Serialized configuration of the page, if needed.',
  PRIMARY KEY (`pid`),
  UNIQUE KEY `name` (`name`),
  KEY `task` (`task`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8 COMMENT='Contains page subtasks for implementing pages with...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `page_manager_pages`
--

LOCK TABLES `page_manager_pages` WRITE;
/*!40000 ALTER TABLE `page_manager_pages` DISABLE KEYS */;
INSERT INTO `page_manager_pages` VALUES (1,'home_page','page','Home page','','home','a:2:{s:7:\"plugins\";a:1:{i:0;a:4:{s:4:\"name\";s:4:\"role\";s:8:\"settings\";a:1:{s:4:\"rids\";a:1:{i:0;i:2;}}s:7:\"context\";s:14:\"logged-in-user\";s:3:\"not\";b:0;}}s:5:\"logic\";s:3:\"and\";}','a:0:{}','a:0:{}','a:1:{s:11:\"admin_paths\";b:0;}'),(2,'mercury_host','page','Mercury Host','','host-inventory','a:2:{s:5:\"logic\";s:3:\"and\";s:7:\"plugins\";a:1:{i:0;a:4:{s:4:\"name\";s:4:\"role\";s:8:\"settings\";a:1:{s:4:\"rids\";a:2:{i:0;i:2;i:1;i:3;}}s:7:\"context\";s:14:\"logged-in-user\";s:3:\"not\";b:0;}}}','a:5:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:4:\"Host\";s:4:\"name\";s:18:\"menu-selector-tool\";s:6:\"weight\";s:1:\"0\";s:6:\"parent\";a:4:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:4:\"name\";s:10:\"navigation\";s:6:\"weight\";s:1:\"0\";}}','a:0:{}','a:1:{s:11:\"admin_paths\";b:0;}'),(3,'all','page','Mercury VM','','vm-inventory','a:2:{s:5:\"logic\";s:3:\"and\";s:7:\"plugins\";a:1:{i:0;a:4:{s:4:\"name\";s:4:\"role\";s:8:\"settings\";a:1:{s:4:\"rids\";a:2:{i:0;i:2;i:1;i:3;}}s:7:\"context\";s:14:\"logged-in-user\";s:3:\"not\";b:0;}}}','a:5:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:2:\"VM\";s:4:\"name\";s:18:\"menu-selector-tool\";s:6:\"weight\";s:1:\"0\";s:6:\"parent\";a:4:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:4:\"name\";s:10:\"navigation\";s:6:\"weight\";s:1:\"0\";}}','a:0:{}','a:1:{s:11:\"admin_paths\";b:0;}'),(4,'ongoing_processes','page','Ongoing Processes','','ongoing-processes','a:1:{s:5:\"logic\";s:3:\"and\";}','a:0:{}','a:0:{}','a:1:{s:11:\"admin_paths\";b:0;}');
/*!40000 ALTER TABLE `page_manager_pages` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `page_manager_weights`
--

DROP TABLE IF EXISTS `page_manager_weights`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `page_manager_weights` (
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'Unique ID for this task handler. Used to identify it programmatically.',
  `weight` int(11) DEFAULT NULL COMMENT 'The order in which this handler appears. Lower numbers go first.',
  PRIMARY KEY (`name`),
  KEY `weights` (`name`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Contains override weights for page_manager handlers that...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `page_manager_weights`
--

LOCK TABLES `page_manager_weights` WRITE;
/*!40000 ALTER TABLE `page_manager_weights` DISABLE KEYS */;
/*!40000 ALTER TABLE `page_manager_weights` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `panels_display`
--

DROP TABLE IF EXISTS `panels_display`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `panels_display` (
  `did` int(11) NOT NULL AUTO_INCREMENT,
  `layout` varchar(255) DEFAULT '',
  `layout_settings` longtext,
  `panel_settings` longtext,
  `cache` text,
  `title` varchar(255) DEFAULT '',
  `hide_title` tinyint(4) DEFAULT '0',
  `title_pane` int(11) DEFAULT '0',
  PRIMARY KEY (`did`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `panels_display`
--

LOCK TABLES `panels_display` WRITE;
/*!40000 ALTER TABLE `panels_display` DISABLE KEYS */;
INSERT INTO `panels_display` VALUES (2,'onecol','a:0:{}','a:1:{s:14:\"style_settings\";a:2:{s:7:\"default\";N;s:6:\"middle\";N;}}','a:0:{}','',1,1),(3,'onecol','a:0:{}','a:1:{s:14:\"style_settings\";a:2:{s:7:\"default\";N;s:6:\"middle\";N;}}','a:0:{}','Host Inventory',0,0),(4,'flexible','a:0:{}','a:1:{s:14:\"style_settings\";a:2:{s:7:\"default\";N;s:6:\"center\";N;}}','a:0:{}','VM Inventory',0,6),(5,'flexible','a:0:{}','a:1:{s:14:\"style_settings\";a:2:{s:7:\"default\";N;s:6:\"center\";N;}}','a:0:{}','Ongoing Processes',0,8);
/*!40000 ALTER TABLE `panels_display` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `panels_layout`
--

DROP TABLE IF EXISTS `panels_layout`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `panels_layout` (
  `lid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'A database primary key to ensure uniqueness.',
  `name` varchar(255) DEFAULT NULL COMMENT 'Unique ID for this content. Used to identify it programmatically.',
  `admin_title` varchar(255) DEFAULT NULL COMMENT 'Administrative title for this layout.',
  `admin_description` longtext COMMENT 'Administrative description for this layout.',
  `category` varchar(255) DEFAULT NULL COMMENT 'Administrative category for this layout.',
  `plugin` varchar(255) DEFAULT NULL COMMENT 'The layout plugin that owns this layout.',
  `settings` longtext COMMENT 'Serialized settings for the actual layout. The contents of this field are up to the plugin that uses it.',
  PRIMARY KEY (`lid`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COMMENT='Contains exportable customized layouts for this site.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `panels_layout`
--

LOCK TABLES `panels_layout` WRITE;
/*!40000 ALTER TABLE `panels_layout` DISABLE KEYS */;
INSERT INTO `panels_layout` VALUES (1,'ongoing_processes','Ongoing Processes','','','flexible','a:0:{}');
/*!40000 ALTER TABLE `panels_layout` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `panels_mini`
--

DROP TABLE IF EXISTS `panels_mini`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `panels_mini` (
  `pid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary key for uniqueness.',
  `name` varchar(255) DEFAULT NULL COMMENT 'The unique name of the mini panel.',
  `category` varchar(64) DEFAULT NULL COMMENT 'The category this mini panel appears in on the add content pane.',
  `did` int(11) DEFAULT NULL COMMENT 'The display ID of the panel.',
  `admin_title` varchar(128) DEFAULT NULL COMMENT 'The administrative title of the mini panel.',
  `admin_description` longtext COMMENT 'Administrative title of this mini panel.',
  `requiredcontexts` longtext COMMENT 'An array of required contexts.',
  `contexts` longtext COMMENT 'An array of contexts embedded into the panel.',
  `relationships` longtext COMMENT 'An array of relationships embedded into the panel.',
  PRIMARY KEY (`pid`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `panels_mini`
--

LOCK TABLES `panels_mini` WRITE;
/*!40000 ALTER TABLE `panels_mini` DISABLE KEYS */;
/*!40000 ALTER TABLE `panels_mini` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `panels_node`
--

DROP TABLE IF EXISTS `panels_node`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `panels_node` (
  `nid` int(11) NOT NULL DEFAULT '0',
  `css_id` varchar(255) DEFAULT NULL,
  `did` int(11) NOT NULL,
  `pipeline` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`did`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `panels_node`
--

LOCK TABLES `panels_node` WRITE;
/*!40000 ALTER TABLE `panels_node` DISABLE KEYS */;
/*!40000 ALTER TABLE `panels_node` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `panels_pane`
--

DROP TABLE IF EXISTS `panels_pane`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `panels_pane` (
  `pid` int(11) NOT NULL AUTO_INCREMENT,
  `did` int(11) NOT NULL DEFAULT '0',
  `panel` varchar(32) DEFAULT '',
  `type` varchar(32) DEFAULT '',
  `subtype` varchar(64) DEFAULT '',
  `shown` tinyint(4) DEFAULT '1',
  `access` longtext,
  `configuration` longtext,
  `cache` longtext,
  `style` longtext,
  `css` longtext,
  `extras` longtext,
  `position` smallint(6) DEFAULT '0',
  `locks` longtext,
  PRIMARY KEY (`pid`),
  KEY `did_idx` (`did`)
) ENGINE=MyISAM AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `panels_pane`
--

LOCK TABLES `panels_pane` WRITE;
/*!40000 ALTER TABLE `panels_pane` DISABLE KEYS */;
INSERT INTO `panels_pane` VALUES (5,3,'middle','views','all_host',1,'a:0:{}','a:14:{s:23:\"override_pager_settings\";i:0;s:9:\"use_pager\";i:1;s:14:\"nodes_per_page\";s:2:\"20\";s:8:\"pager_id\";s:1:\"0\";s:6:\"offset\";s:1:\"0\";s:9:\"more_link\";i:0;s:10:\"feed_icons\";i:0;s:10:\"panel_args\";i:0;s:12:\"link_to_view\";i:0;s:4:\"args\";s:0:\"\";s:3:\"url\";s:0:\"\";s:7:\"display\";s:7:\"default\";s:14:\"override_title\";i:0;s:19:\"override_title_text\";s:0:\"\";}','a:0:{}','a:1:{s:8:\"settings\";N;}','a:0:{}','a:0:{}',0,'a:0:{}'),(6,4,'center','views','all_vm',1,'a:0:{}','a:14:{s:23:\"override_pager_settings\";i:0;s:9:\"use_pager\";i:1;s:14:\"nodes_per_page\";s:2:\"20\";s:8:\"pager_id\";s:1:\"0\";s:6:\"offset\";s:1:\"0\";s:9:\"more_link\";i:0;s:10:\"feed_icons\";i:0;s:10:\"panel_args\";i:0;s:12:\"link_to_view\";i:0;s:4:\"args\";s:0:\"\";s:3:\"url\";s:0:\"\";s:7:\"display\";s:7:\"default\";s:14:\"override_title\";i:0;s:19:\"override_title_text\";s:0:\"\";}','a:0:{}','a:1:{s:8:\"settings\";N;}','a:0:{}','a:0:{}',0,'a:0:{}'),(7,2,'middle','block','mercury_utilities-home_page_block',1,'a:0:{}','a:2:{s:14:\"override_title\";i:1;s:19:\"override_title_text\";s:7:\"<block>\";}','a:0:{}','a:1:{s:8:\"settings\";N;}','a:0:{}','a:0:{}',0,'a:0:{}'),(9,5,'center','block','mercury_utilities-ongoing_processes_block',1,'a:1:{s:5:\"logic\";s:3:\"and\";}','a:2:{s:14:\"override_title\";i:1;s:19:\"override_title_text\";s:6:\"<none>\";}','a:0:{}','a:1:{s:8:\"settings\";N;}','a:0:{}','a:0:{}',0,'a:0:{}');
/*!40000 ALTER TABLE `panels_pane` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `panels_renderer_pipeline`
--

DROP TABLE IF EXISTS `panels_renderer_pipeline`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `panels_renderer_pipeline` (
  `rpid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'A database primary key to ensure uniqueness.',
  `name` varchar(255) DEFAULT NULL COMMENT 'Unique ID for this content. Used to identify it programmatically.',
  `admin_title` varchar(255) DEFAULT NULL COMMENT 'Administrative title for this pipeline.',
  `admin_description` longtext COMMENT 'Administrative description for this pipeline.',
  `weight` smallint(6) DEFAULT '0',
  `settings` longtext COMMENT 'Serialized settings for the actual pipeline. The contents of this field are up to the plugin that uses it.',
  PRIMARY KEY (`rpid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Contains renderer pipelines for Panels. Each pipeline...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `panels_renderer_pipeline`
--

LOCK TABLES `panels_renderer_pipeline` WRITE;
/*!40000 ALTER TABLE `panels_renderer_pipeline` DISABLE KEYS */;
/*!40000 ALTER TABLE `panels_renderer_pipeline` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `queue`
--

DROP TABLE IF EXISTS `queue`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `queue` (
  `item_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique item ID.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The queue name.',
  `data` longblob COMMENT 'The arbitrary data for the item.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp when the claim lease expires on the item.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp when the item was created.',
  PRIMARY KEY (`item_id`),
  KEY `name_created` (`name`,`created`),
  KEY `expire` (`expire`)
) ENGINE=MyISAM AUTO_INCREMENT=5223 DEFAULT CHARSET=utf8 COMMENT='Stores items in queues.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `queue`
--

LOCK TABLES `queue` WRITE;
/*!40000 ALTER TABLE `queue` DISABLE KEYS */;
INSERT INTO `queue` VALUES (5222,'update_fetch_tasks','a:8:{s:4:\"name\";s:7:\"mercury\";s:4:\"info\";a:5:{s:4:\"name\";s:7:\"Mercury\";s:7:\"project\";s:7:\"mercury\";s:7:\"version\";s:7:\"7.x-2.1\";s:9:\"datestamp\";s:10:\"1334122542\";s:16:\"_info_file_ctime\";i:1355610157;}s:9:\"datestamp\";s:10:\"1334122542\";s:8:\"includes\";a:1:{s:7:\"mercury\";s:7:\"Mercury\";}s:12:\"project_type\";s:5:\"theme\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}',0,1355685380);
/*!40000 ALTER TABLE `queue` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rdf_mapping`
--

DROP TABLE IF EXISTS `rdf_mapping`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rdf_mapping` (
  `type` varchar(128) NOT NULL COMMENT 'The name of the entity type a mapping applies to (node, user, comment, etc.).',
  `bundle` varchar(128) NOT NULL COMMENT 'The name of the bundle a mapping applies to.',
  `mapping` longblob COMMENT 'The serialized mapping of the bundle type and fields to RDF terms.',
  PRIMARY KEY (`type`,`bundle`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores custom RDF mappings for user defined content types...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rdf_mapping`
--

LOCK TABLES `rdf_mapping` WRITE;
/*!40000 ALTER TABLE `rdf_mapping` DISABLE KEYS */;
INSERT INTO `rdf_mapping` VALUES ('node','article','a:11:{s:11:\"field_image\";a:2:{s:10:\"predicates\";a:2:{i:0;s:8:\"og:image\";i:1;s:12:\"rdfs:seeAlso\";}s:4:\"type\";s:3:\"rel\";}s:10:\"field_tags\";a:2:{s:10:\"predicates\";a:1:{i:0;s:10:\"dc:subject\";}s:4:\"type\";s:3:\"rel\";}s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Item\";i:1;s:13:\"foaf:Document\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:4:\"body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}s:13:\"comment_count\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:num_replies\";}s:8:\"datatype\";s:11:\"xsd:integer\";}s:13:\"last_activity\";a:3:{s:10:\"predicates\";a:1:{i:0;s:23:\"sioc:last_activity_date\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}}'),('node','page','a:9:{s:7:\"rdftype\";a:1:{i:0;s:13:\"foaf:Document\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:4:\"body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}s:13:\"comment_count\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:num_replies\";}s:8:\"datatype\";s:11:\"xsd:integer\";}s:13:\"last_activity\";a:3:{s:10:\"predicates\";a:1:{i:0;s:23:\"sioc:last_activity_date\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}}');
/*!40000 ALTER TABLE `rdf_mapping` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `registry`
--

DROP TABLE IF EXISTS `registry`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `registry` (
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the function, class, or interface.',
  `type` varchar(9) NOT NULL DEFAULT '' COMMENT 'Either function or class or interface.',
  `filename` varchar(255) NOT NULL COMMENT 'Name of the file.',
  `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'Name of the module the file belongs to.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The order in which this module’s hooks should be invoked relative to other modules. Equal-weighted modules are ordered by name.',
  PRIMARY KEY (`name`,`type`),
  KEY `hook` (`type`,`weight`,`module`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Each record is a function, class, or interface name and...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `registry`
--

LOCK TABLES `registry` WRITE;
/*!40000 ALTER TABLE `registry` DISABLE KEYS */;
INSERT INTO `registry` VALUES ('AccessDeniedTestCase','class','modules/system/system.test','system',0),('AdminMenuCustomizedTestCase','class','sites/all/modules/contrib/admin_menu/tests/admin_menu.test','admin_menu',0),('AdminMenuDynamicLinksTestCase','class','sites/all/modules/contrib/admin_menu/tests/admin_menu.test','admin_menu',0),('AdminMenuLinkTypesTestCase','class','sites/all/modules/contrib/admin_menu/tests/admin_menu.test','admin_menu',0),('AdminMenuPermissionsTestCase','class','sites/all/modules/contrib/admin_menu/tests/admin_menu.test','admin_menu',0),('AdminMenuWebTestCase','class','sites/all/modules/contrib/admin_menu/tests/admin_menu.test','admin_menu',0),('AdminMetaTagTestCase','class','modules/system/system.test','system',0),('ArchiverInterface','interface','includes/archiver.inc','',0),('ArchiverTar','class','modules/system/system.archiver.inc','system',0),('ArchiverZip','class','modules/system/system.archiver.inc','system',0),('Archive_Tar','class','modules/system/system.tar.inc','system',0),('BatchMemoryQueue','class','includes/batch.queue.inc','',0),('BatchQueue','class','includes/batch.queue.inc','',0),('BlockAdminThemeTestCase','class','modules/block/block.test','block',-5),('BlockCacheTestCase','class','modules/block/block.test','block',-5),('BlockHiddenRegionTestCase','class','modules/block/block.test','block',-5),('BlockHTMLIdTestCase','class','modules/block/block.test','block',-5),('BlockInvalidRegionTestCase','class','modules/block/block.test','block',-5),('BlockTemplateSuggestionsUnitTest','class','modules/block/block.test','block',-5),('BlockTestCase','class','modules/block/block.test','block',-5),('CoderReviewCommentTest','class','sites/all/modules/contrib/coder/coder_review/tests/coder_review_comment.test','coder_review',0),('CoderReviewUpgrade7xTest','class','sites/all/modules/contrib/coder/coder_review/tests/coder_review_7x.test','coder_review',0),('CoderReviewUpgrade6xTest','class','sites/all/modules/contrib/coder/coder_review/tests/coder_review_6x.test','coder_review',0),('CoderReviewTestCase','class','sites/all/modules/contrib/coder/coder_review/tests/coder_review_test_case.tinc','coder_review',0),('MenuAttributesTestHelper','class','sites/all/modules/contrib/menu_attributes/menu_attributes.test','menu_attributes',10),('MenuAttributesTestCase','class','sites/all/modules/contrib/menu_attributes/menu_attributes.test','menu_attributes',10),('MenuAttributesNodeTestCase','class','sites/all/modules/contrib/menu_attributes/menu_attributes.test','menu_attributes',10),('ColorTestCase','class','modules/color/color.test','color',0),('CommentActionsTestCase','class','modules/comment/comment.test','comment',0),('CommentAnonymous','class','modules/comment/comment.test','comment',0),('CommentApprovalTest','class','modules/comment/comment.test','comment',0),('CommentBlockFunctionalTest','class','modules/comment/comment.test','comment',0),('CommentContentRebuild','class','modules/comment/comment.test','comment',0),('CommentController','class','modules/comment/comment.module','comment',0),('CommentFieldsTest','class','modules/comment/comment.test','comment',0),('CommentHelperCase','class','modules/comment/comment.test','comment',0),('CommentInterfaceTest','class','modules/comment/comment.test','comment',0),('CommentNodeAccessTest','class','modules/comment/comment.test','comment',0),('CommentNodeChangesTestCase','class','modules/comment/comment.test','comment',0),('CommentPagerTest','class','modules/comment/comment.test','comment',0),('CommentPreviewTest','class','modules/comment/comment.test','comment',0),('CommentRSSUnitTest','class','modules/comment/comment.test','comment',0),('CommentThreadingTestCase','class','modules/comment/comment.test','comment',0),('CommentTokenReplaceTestCase','class','modules/comment/comment.test','comment',0),('CronRunTestCase','class','modules/system/system.test','system',0),('ctools_context','class','sites/all/modules/contrib/ctools/includes/context.inc','ctools',0),('ctools_context_optional','class','sites/all/modules/contrib/ctools/includes/context.inc','ctools',0),('ctools_context_required','class','sites/all/modules/contrib/ctools/includes/context.inc','ctools',0),('ctools_custom_content_ui','class','sites/all/modules/contrib/ctools/ctools_custom_content/plugins/export_ui/ctools_custom_content_ui.class.php','ctools_custom_content',0),('ctools_export_ui','class','sites/all/modules/contrib/ctools/plugins/export_ui/ctools_export_ui.class.php','ctools',0),('ctools_math_expr','class','sites/all/modules/contrib/ctools/includes/math-expr.inc','ctools',0),('ctools_math_expr_stack','class','sites/all/modules/contrib/ctools/includes/math-expr.inc','ctools',0),('ctools_stylizer_image_processor','class','sites/all/modules/contrib/ctools/includes/stylizer.inc','ctools',0),('DashboardBlocksTestCase','class','modules/dashboard/dashboard.test','dashboard',0),('Database','class','includes/database/database.inc','',0),('DatabaseCondition','class','includes/database/query.inc','',0),('DatabaseConnection','class','includes/database/database.inc','',0),('DatabaseConnectionNotDefinedException','class','includes/database/database.inc','',0),('DatabaseConnection_mysql','class','includes/database/mysql/database.inc','',0),('DatabaseConnection_pgsql','class','includes/database/pgsql/database.inc','',0),('DatabaseConnection_sqlite','class','includes/database/sqlite/database.inc','',0),('DatabaseDriverNotSpecifiedException','class','includes/database/database.inc','',0),('DatabaseLog','class','includes/database/log.inc','',0),('DatabaseSchema','class','includes/database/schema.inc','',0),('DatabaseSchemaObjectDoesNotExistException','class','includes/database/schema.inc','',0),('DatabaseSchemaObjectExistsException','class','includes/database/schema.inc','',0),('DatabaseSchema_mysql','class','includes/database/mysql/schema.inc','',0),('DatabaseSchema_pgsql','class','includes/database/pgsql/schema.inc','',0),('DatabaseSchema_sqlite','class','includes/database/sqlite/schema.inc','',0),('DatabaseStatementBase','class','includes/database/database.inc','',0),('DatabaseStatementEmpty','class','includes/database/database.inc','',0),('DatabaseStatementInterface','interface','includes/database/database.inc','',0),('DatabaseStatementPrefetch','class','includes/database/prefetch.inc','',0),('DatabaseStatement_sqlite','class','includes/database/sqlite/database.inc','',0),('DatabaseTaskException','class','includes/install.inc','',0),('DatabaseTasks','class','includes/install.inc','',0),('DatabaseTasks_mysql','class','includes/database/mysql/install.inc','',0),('DatabaseTasks_pgsql','class','includes/database/pgsql/install.inc','',0),('DatabaseTasks_sqlite','class','includes/database/sqlite/install.inc','',0),('DatabaseTransaction','class','includes/database/database.inc','',0),('DatabaseTransactionCommitFailedException','class','includes/database/database.inc','',0),('DatabaseTransactionExplicitCommitNotAllowedException','class','includes/database/database.inc','',0),('DatabaseTransactionNameNonUniqueException','class','includes/database/database.inc','',0),('DatabaseTransactionNoActiveException','class','includes/database/database.inc','',0),('DatabaseTransactionOutOfOrderException','class','includes/database/database.inc','',0),('DateAPITestCase','class','sites/all/modules/contrib/date/tests/date_api.test','date',0),('DateFieldBasic','class','sites/all/modules/contrib/date/tests/date_field.test','date',0),('DateFieldTestCase','class','sites/all/modules/contrib/date/tests/date_field.test','date',0),('DateObject','class','sites/all/modules/contrib/date/date_api/date_api.module','date_api',0),('DateTimeFunctionalTest','class','modules/system/system.test','system',0),('DateTimezoneTestCase','class','sites/all/modules/contrib/date/tests/date_timezone.test','date',0),('DateUITestCase','class','sites/all/modules/contrib/date/tests/date.test','date',0),('DateValidationTestCase','class','sites/all/modules/contrib/date/tests/date_validation.test','date',0),('date_sql_handler','class','sites/all/modules/contrib/date/date_api/date_api_sql.inc','date_api',0),('date_views_argument_handler','class','sites/all/modules/contrib/date/date_views/includes/date_views_argument_handler.inc','date_views',0),('date_views_argument_handler_simple','class','sites/all/modules/contrib/date/date_views/includes/date_views_argument_handler_simple.inc','date_views',0),('date_views_filter_handler','class','sites/all/modules/contrib/date/date_views/includes/date_views_filter_handler.inc','date_views',0),('date_views_filter_handler_simple','class','sites/all/modules/contrib/date/date_views/includes/date_views_filter_handler_simple.inc','date_views',0),('date_views_plugin_pager','class','sites/all/modules/contrib/date/date_views/includes/date_views_plugin_pager.inc','date_views',0),('DBLogTestCase','class','modules/dblog/dblog.test','dblog',0),('DefaultMailSystem','class','modules/system/system.mail.inc','system',0),('DeleteQuery','class','includes/database/query.inc','',0),('DeleteQuery_sqlite','class','includes/database/sqlite/query.inc','',0),('DrupalCacheArray','class','includes/bootstrap.inc','',0),('DrupalCacheInterface','interface','includes/cache.inc','',0),('DrupalDatabaseCache','class','includes/cache.inc','',0),('DrupalDefaultEntityController','class','includes/entity.inc','',0),('DrupalEntityControllerInterface','interface','includes/entity.inc','',0),('DrupalFakeCache','class','includes/cache-install.inc','',0),('DrupalLocalStreamWrapper','class','includes/stream_wrappers.inc','',0),('DrupalPrivateStreamWrapper','class','includes/stream_wrappers.inc','',0),('DrupalPublicStreamWrapper','class','includes/stream_wrappers.inc','',0),('DrupalQueue','class','modules/system/system.queue.inc','system',0),('DrupalQueueInterface','interface','modules/system/system.queue.inc','system',0),('DrupalReliableQueueInterface','interface','modules/system/system.queue.inc','system',0),('DrupalStreamWrapperInterface','interface','includes/stream_wrappers.inc','',0),('DrupalTemporaryStreamWrapper','class','includes/stream_wrappers.inc','',0),('DrupalUpdateException','class','includes/update.inc','',0),('DrupalUpdaterInterface','interface','includes/updater.inc','',0),('EnableDisableTestCase','class','modules/system/system.test','system',0),('Entity','class','sites/all/modules/contrib/entity/includes/entity.inc','entity',0),('EntityAPIController','class','sites/all/modules/contrib/entity/includes/entity.controller.inc','entity',0),('EntityAPIControllerExportable','class','sites/all/modules/contrib/entity/includes/entity.controller.inc','entity',0),('EntityAPIControllerInterface','interface','sites/all/modules/contrib/entity/includes/entity.controller.inc','entity',0),('EntityAPIi18nItegrationTestCase','class','sites/all/modules/contrib/entity/entity.test','entity',0),('EntityAPIRulesIntegrationTestCase','class','sites/all/modules/contrib/entity/entity.test','entity',0),('EntityAPITestCase','class','sites/all/modules/contrib/entity/entity.test','entity',0),('EntityDB','class','sites/all/modules/contrib/entity/includes/entity.inc','entity',0),('EntityDBExtendable','class','sites/all/modules/contrib/entity/includes/entity.inc','entity',0),('EntityDefaultFeaturesController','class','sites/all/modules/contrib/entity/entity.features.inc','entity',0),('EntityDefaultI18nStringController','class','sites/all/modules/contrib/entity/entity.i18n.inc','entity',0),('EntityDefaultMetadataController','class','sites/all/modules/contrib/entity/entity.info.inc','entity',0),('EntityDefaultRulesController','class','sites/all/modules/contrib/entity/entity.rules.inc','entity',0),('EntityDefaultUIController','class','sites/all/modules/contrib/entity/includes/entity.ui.inc','entity',0),('EntityDefaultViewsController','class','sites/all/modules/contrib/entity/views/entity.views.inc','entity',0),('EntityDrupalWrapper','class','sites/all/modules/contrib/entity/includes/entity.wrapper.inc','entity',0),('EntityExtendable','class','sites/all/modules/contrib/entity/includes/entity.inc','entity',0),('EntityFieldHandlerHelper','class','sites/all/modules/contrib/entity/views/handlers/entity_views_field_handler_helper.inc','entity',0),('EntityFieldQuery','class','includes/entity.inc','',0),('EntityFieldQueryException','class','includes/entity.inc','',0),('EntityListWrapper','class','sites/all/modules/contrib/entity/includes/entity.wrapper.inc','entity',0),('EntityMalformedException','class','includes/entity.inc','',0),('EntityMetadataArrayObject','class','sites/all/modules/contrib/entity/includes/entity.wrapper.inc','entity',0),('EntityMetadataIntegrationTestCase','class','sites/all/modules/contrib/entity/entity.test','entity',0),('EntityMetadataTestCase','class','sites/all/modules/contrib/entity/entity.test','entity',0),('EntityMetadataWrapper','class','sites/all/modules/contrib/entity/includes/entity.wrapper.inc','entity',0),('EntityMetadataWrapperException','class','sites/all/modules/contrib/entity/includes/entity.wrapper.inc','entity',0),('EntityMetadataWrapperIterator','class','sites/all/modules/contrib/entity/includes/entity.wrapper.inc','entity',0),('EntityPropertiesTestCase','class','modules/field/tests/field.test','field',0),('EntityReferenceAdminTestCase','class','sites/all/modules/contrib/entityreference/tests/entityreference.admin.test','entityreference',0),('EntityReferenceBehavior_TaxonomyIndex','class','sites/all/modules/contrib/entityreference/plugins/behavior/EntityReferenceBehavior_TaxonomyIndex.class.php','entityreference',0),('EntityReferenceBehavior_ViewsFilterSelect','class','sites/all/modules/contrib/entityreference/plugins/behavior/EntityReferenceBehavior_ViewsFilterSelect.class.php','entityreference',0),('EntityReferenceHandlersTestCase','class','sites/all/modules/contrib/entityreference/tests/entityreference.handlers.test','entityreference',0),('CoderReviewStyleTest','class','sites/all/modules/contrib/coder/coder_review/tests/coder_review_style.test','coder_review',0),('EntityReference_BehaviorHandler','interface','sites/all/modules/contrib/entityreference/plugins/behavior/abstract.inc','entityreference',0),('EntityReference_BehaviorHandler_Abstract','class','sites/all/modules/contrib/entityreference/plugins/behavior/abstract.inc','entityreference',0),('EntityReference_BehaviorHandler_Broken','class','sites/all/modules/contrib/entityreference/plugins/behavior/abstract.inc','entityreference',0),('entityreference_plugin_display','class','sites/all/modules/contrib/entityreference/views/entityreference_plugin_display.inc','entityreference',0),('entityreference_plugin_row_fields','class','sites/all/modules/contrib/entityreference/views/entityreference_plugin_row_fields.inc','entityreference',0),('entityreference_plugin_style','class','sites/all/modules/contrib/entityreference/views/entityreference_plugin_style.inc','entityreference',0),('EntityReference_SelectionHandler','interface','sites/all/modules/contrib/entityreference/plugins/selection/abstract.inc','entityreference',0),('EntityReference_SelectionHandler_Broken','class','sites/all/modules/contrib/entityreference/plugins/selection/abstract.inc','entityreference',0),('EntityReference_SelectionHandler_Generic','class','sites/all/modules/contrib/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference',0),('EntityReference_SelectionHandler_Generic_comment','class','sites/all/modules/contrib/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference',0),('EntityReference_SelectionHandler_Generic_file','class','sites/all/modules/contrib/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference',0),('EntityReference_SelectionHandler_Generic_node','class','sites/all/modules/contrib/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference',0),('EntityReference_SelectionHandler_Generic_taxonomy_term','class','sites/all/modules/contrib/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference',0),('EntityReference_SelectionHandler_Generic_user','class','sites/all/modules/contrib/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference',0),('EntityReference_SelectionHandler_Views','class','sites/all/modules/contrib/entityreference/plugins/selection/EntityReference_SelectionHandler_Views.class.php','entityreference',0),('EntityStructureWrapper','class','sites/all/modules/contrib/entity/includes/entity.wrapper.inc','entity',0),('EntityTokenTestCase','class','sites/all/modules/contrib/entity/entity.test','entity',0),('EntityValueWrapper','class','sites/all/modules/contrib/entity/includes/entity.wrapper.inc','entity',0),('EntityWebTestCase','class','sites/all/modules/contrib/entity/entity.test','entity',0),('entity_views_handler_area_entity','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_area_entity.inc','entity',0),('entity_views_handler_field_boolean','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_boolean.inc','entity',0),('entity_views_handler_field_date','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_date.inc','entity',0),('entity_views_handler_field_duration','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_duration.inc','entity',0),('entity_views_handler_field_entity','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_entity.inc','entity',0),('entity_views_handler_field_field','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_field.inc','entity',0),('entity_views_handler_field_numeric','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_numeric.inc','entity',0),('entity_views_handler_field_options','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_options.inc','entity',0),('entity_views_handler_field_text','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_text.inc','entity',0),('entity_views_handler_field_uri','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_uri.inc','entity',0),('entity_views_handler_relationship','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_relationship.inc','entity',0),('entity_views_handler_relationship_by_bundle','class','sites/all/modules/contrib/entity/views/handlers/entity_views_handler_relationship_by_bundle.inc','entity',0),('entity_views_plugin_row_entity_view','class','sites/all/modules/contrib/entity/views/plugins/entity_views_plugin_row_entity_view.inc','entity',0),('eva_plugin_display_entity','class','sites/all/modules/contrib/eva/eva_plugin_display_entity.inc','eva',0),('FieldAttachOtherTestCase','class','modules/field/tests/field.test','field',0),('FieldAttachStorageTestCase','class','modules/field/tests/field.test','field',0),('FieldAttachTestCase','class','modules/field/tests/field.test','field',0),('FieldBulkDeleteTestCase','class','modules/field/tests/field.test','field',0),('FieldCrudTestCase','class','modules/field/tests/field.test','field',0),('FieldDisplayAPITestCase','class','modules/field/tests/field.test','field',0),('FieldException','class','modules/field/field.module','field',0),('FieldFormTestCase','class','modules/field/tests/field.test','field',0),('FieldInfoTestCase','class','modules/field/tests/field.test','field',0),('FieldInstanceCrudTestCase','class','modules/field/tests/field.test','field',0),('FieldsOverlapException','class','includes/database/database.inc','',0),('FieldSqlStorageTestCase','class','modules/field/modules/field_sql_storage/field_sql_storage.test','field_sql_storage',0),('FieldTestCase','class','modules/field/tests/field.test','field',0),('FieldTranslationsTestCase','class','modules/field/tests/field.test','field',0),('FieldUIAlterTestCase','class','modules/field_ui/field_ui.test','field_ui',0),('FieldUIManageDisplayTestCase','class','modules/field_ui/field_ui.test','field_ui',0),('FieldUIManageFieldsTestCase','class','modules/field_ui/field_ui.test','field_ui',0),('FieldUITestCase','class','modules/field_ui/field_ui.test','field_ui',0),('FieldUpdateForbiddenException','class','modules/field/field.module','field',0),('FieldValidationException','class','modules/field/field.attach.inc','field',0),('FileTransfer','class','includes/filetransfer/filetransfer.inc','',0),('FileTransferChmodInterface','interface','includes/filetransfer/filetransfer.inc','',0),('FileTransferException','class','includes/filetransfer/filetransfer.inc','',0),('FileTransferFTP','class','includes/filetransfer/ftp.inc','',0),('FileTransferFTPExtension','class','includes/filetransfer/ftp.inc','',0),('FileTransferLocal','class','includes/filetransfer/local.inc','',0),('FileTransferSSH','class','includes/filetransfer/ssh.inc','',0),('FilterAdminTestCase','class','modules/filter/filter.test','filter',0),('FilterCRUDTestCase','class','modules/filter/filter.test','filter',0),('FilterDefaultFormatTestCase','class','modules/filter/filter.test','filter',0),('FilterFormatAccessTestCase','class','modules/filter/filter.test','filter',0),('FilterHooksTestCase','class','modules/filter/filter.test','filter',0),('FilterNoFormatTestCase','class','modules/filter/filter.test','filter',0),('FilterSecurityTestCase','class','modules/filter/filter.test','filter',0),('FilterSettingsTestCase','class','modules/filter/filter.test','filter',0),('FilterUnitTestCase','class','modules/filter/filter.test','filter',0),('FloodFunctionalTest','class','modules/system/system.test','system',0),('FrontPageTestCase','class','modules/system/system.test','system',0),('GroupUITestCase','class','sites/all/modules/contrib/field_group/field_group.test','field_group',1),('HelpTestCase','class','modules/help/help.test','help',0),('HookRequirementsTestCase','class','modules/system/system.test','system',0),('InfoFileParserTestCase','class','modules/system/system.test','system',0),('InsertQuery','class','includes/database/query.inc','',0),('InsertQuery_mysql','class','includes/database/mysql/query.inc','',0),('InsertQuery_pgsql','class','includes/database/pgsql/query.inc','',0),('InsertQuery_sqlite','class','includes/database/sqlite/query.inc','',0),('InvalidMergeQueryException','class','includes/database/database.inc','',0),('IPAddressBlockingTestCase','class','modules/system/system.test','system',0),('ListDynamicValuesTestCase','class','modules/field/modules/list/tests/list.test','list',0),('ListDynamicValuesValidationTestCase','class','modules/field/modules/list/tests/list.test','list',0),('ListFieldTestCase','class','modules/field/modules/list/tests/list.test','list',0),('ListFieldUITestCase','class','modules/field/modules/list/tests/list.test','list',0),('MailSystemInterface','interface','includes/mail.inc','',0),('MemoryQueue','class','modules/system/system.queue.inc','system',0),('CoderReviewSQLTest','class','sites/all/modules/contrib/coder/coder_review/tests/coder_review_sql.test','coder_review',0),('CoderReviewSecurityTest','class','sites/all/modules/contrib/coder/coder_review/tests/coder_review_security.test','coder_review',0),('CoderReviewI18NTest','class','sites/all/modules/contrib/coder/coder_review/tests/coder_review_i18n.test','coder_review',0),('MenuNodeTestCase','class','modules/menu/menu.test','menu',0),('MenuTestCase','class','modules/menu/menu.test','menu',0),('MergeQuery','class','includes/database/query.inc','',0),('MigrateEntityReferenceFieldHandler','class','sites/all/modules/contrib/entityreference/entityreference.migrate.inc','entityreference',0),('ModuleDependencyTestCase','class','modules/system/system.test','system',0),('ModuleRequiredTestCase','class','modules/system/system.test','system',0),('ModuleTestCase','class','modules/system/system.test','system',0),('ModuleUpdater','class','modules/system/system.updater.inc','system',0),('ModuleVersionTestCase','class','modules/system/system.test','system',0),('MultiStepNodeFormBasicOptionsTest','class','modules/node/node.test','node',0),('NewDefaultThemeBlocks','class','modules/block/block.test','block',-5),('NodeAccessBaseTableTestCase','class','modules/node/node.test','node',0),('NodeAccessFieldTestCase','class','modules/node/node.test','node',0),('NodeAccessPagerTestCase','class','modules/node/node.test','node',0),('NodeAccessRebuildTestCase','class','modules/node/node.test','node',0),('NodeAccessRecordsTestCase','class','modules/node/node.test','node',0),('NodeAccessTestCase','class','modules/node/node.test','node',0),('NodeAdminTestCase','class','modules/node/node.test','node',0),('NodeBlockFunctionalTest','class','modules/node/node.test','node',0),('NodeBlockTestCase','class','modules/node/node.test','node',0),('NodeBuildContent','class','modules/node/node.test','node',0),('NodeController','class','modules/node/node.module','node',0),('NodeCreationTestCase','class','modules/node/node.test','node',0),('NodeEntityFieldQueryAlter','class','modules/node/node.test','node',0),('NodeFeedTestCase','class','modules/node/node.test','node',0),('NodeLoadHooksTestCase','class','modules/node/node.test','node',0),('NodeLoadMultipleTestCase','class','modules/node/node.test','node',0),('NodePostSettingsTestCase','class','modules/node/node.test','node',0),('NodeQueryAlter','class','modules/node/node.test','node',0),('NodeReferenceFormTest','class','sites/all/modules/contrib/references/node_reference/node_reference.test','node_reference',0),('NodeRevisionPermissionsTestCase','class','modules/node/node.test','node',0),('NodeRevisionsTestCase','class','modules/node/node.test','node',0),('NodeRSSContentTestCase','class','modules/node/node.test','node',0),('NodeSaveTestCase','class','modules/node/node.test','node',0),('NodeTitleTestCase','class','modules/node/node.test','node',0),('NodeTitleXSSTestCase','class','modules/node/node.test','node',0),('NodeTokenReplaceTestCase','class','modules/node/node.test','node',0),('NodeTypePersistenceTestCase','class','modules/node/node.test','node',0),('NodeTypeTestCase','class','modules/node/node.test','node',0),('NodeWebTestCase','class','modules/node/node.test','node',0),('NoFieldsException','class','includes/database/database.inc','',0),('NoHelpTestCase','class','modules/help/help.test','help',0),('NonDefaultBlockAdmin','class','modules/block/block.test','block',-5),('NumberFieldTestCase','class','modules/field/modules/number/number.test','number',0),('OptionsSelectDynamicValuesTestCase','class','modules/field/modules/options/options.test','options',0),('OptionsWidgetsTestCase','class','modules/field/modules/options/options.test','options',0),('PageEditTestCase','class','modules/node/node.test','node',0),('PageNotFoundTestCase','class','modules/system/system.test','system',0),('PagePreviewTestCase','class','modules/node/node.test','node',0),('PagerDefault','class','includes/pager.inc','',0),('PageTitleFiltering','class','modules/system/system.test','system',0),('PageViewTestCase','class','modules/node/node.test','node',0),('PanelsLegacyState','class','sites/all/modules/contrib/panels/includes/legacy.inc','panels',0),('panels_allowed_layouts','class','sites/all/modules/contrib/panels/includes/common.inc','panels',0),('panels_cache_object','class','sites/all/modules/contrib/panels/includes/plugins.inc','panels',0),('panels_display','class','sites/all/modules/contrib/panels/panels.module','panels',0),('panels_layouts_ui','class','sites/all/modules/contrib/panels/plugins/export_ui/panels_layouts_ui.class.php','panels',0),('panels_mini_ui','class','sites/all/modules/contrib/panels/panels_mini/plugins/export_ui/panels_mini_ui.class.php','panels_mini',0),('panels_renderer_editor','class','sites/all/modules/contrib/panels/plugins/display_renderers/panels_renderer_editor.class.php','panels',0),('panels_renderer_ipe','class','sites/all/modules/contrib/panels/panels_ipe/plugins/display_renderers/panels_renderer_ipe.class.php','panels_ipe',0),('panels_renderer_simple','class','sites/all/modules/contrib/panels/plugins/display_renderers/panels_renderer_simple.class.php','panels',0),('panels_renderer_standard','class','sites/all/modules/contrib/panels/plugins/display_renderers/panels_renderer_standard.class.php','panels',0),('panels_views_plugin_row_fields','class','sites/all/modules/contrib/panels/plugins/views/panels_views_plugin_row_fields.inc','panels',0),('PathautoBulkUpdateTestCase','class','sites/all/modules/contrib/pathauto/pathauto.test','pathauto',0),('PathautoFunctionalTestCase','class','sites/all/modules/contrib/pathauto/pathauto.test','pathauto',0),('PathautoFunctionalTestHelper','class','sites/all/modules/contrib/pathauto/pathauto.test','pathauto',0),('PathautoLocaleTestCase','class','sites/all/modules/contrib/pathauto/pathauto.test','pathauto',0),('PathautoTestHelper','class','sites/all/modules/contrib/pathauto/pathauto.test','pathauto',0),('PathautoTokenTestCase','class','sites/all/modules/contrib/pathauto/pathauto.test','pathauto',0),('PathautoUnitTestCase','class','sites/all/modules/contrib/pathauto/pathauto.test','pathauto',0),('PathLanguageTestCase','class','modules/path/path.test','path',0),('PathLanguageUITestCase','class','modules/path/path.test','path',0),('PathMonolingualTestCase','class','modules/path/path.test','path',0),('PathTaxonomyTermTestCase','class','modules/path/path.test','path',0),('PathTestCase','class','modules/path/path.test','path',0),('PHPAccessTestCase','class','modules/php/php.test','php',0),('PHPFilterTestCase','class','modules/php/php.test','php',0),('PHPTestCase','class','modules/php/php.test','php',0),('Query','class','includes/database/query.inc','',0),('QueryAlterableInterface','interface','includes/database/query.inc','',0),('QueryConditionInterface','interface','includes/database/query.inc','',0),('QueryExtendableInterface','interface','includes/database/select.inc','',0),('QueryPlaceholderInterface','interface','includes/database/query.inc','',0),('QueueTestCase','class','modules/system/system.test','system',0),('RdfCommentAttributesTestCase','class','modules/rdf/rdf.test','rdf',0),('RdfCrudTestCase','class','modules/rdf/rdf.test','rdf',0),('RdfGetRdfNamespacesTestCase','class','modules/rdf/rdf.test','rdf',0),('RdfMappingDefinitionTestCase','class','modules/rdf/rdf.test','rdf',0),('RdfMappingHookTestCase','class','modules/rdf/rdf.test','rdf',0),('RdfRdfaMarkupTestCase','class','modules/rdf/rdf.test','rdf',0),('RdfTrackerAttributesTestCase','class','modules/rdf/rdf.test','rdf',0),('references_handler_argument','class','sites/all/modules/contrib/references/views/references_handler_argument.inc','references',0),('references_handler_relationship','class','sites/all/modules/contrib/references/views/references_handler_relationship.inc','references',0),('references_plugin_display','class','sites/all/modules/contrib/references/views/references_plugin_display.inc','references',0),('references_plugin_row_fields','class','sites/all/modules/contrib/references/views/references_plugin_row_fields.inc','references',0),('references_plugin_style','class','sites/all/modules/contrib/references/views/references_plugin_style.inc','references',0),('RetrieveFileTestCase','class','modules/system/system.test','system',0),('SchemaCache','class','includes/bootstrap.inc','',0),('SearchAdvancedSearchForm','class','modules/search/search.test','search',0),('SearchApiAbstractAlterCallback','class','sites/all/modules/contrib/search_api/includes/callback.inc','search_api',0),('SearchApiAbstractDataSourceController','class','sites/all/modules/contrib/search_api/includes/datasource.inc','search_api',0),('SearchApiAbstractProcessor','class','sites/all/modules/contrib/search_api/includes/processor.inc','search_api',0),('SearchApiAbstractService','class','sites/all/modules/contrib/search_api/includes/service.inc','search_api',0),('SearchApiAlterAddAggregation','class','sites/all/modules/contrib/search_api/includes/callback_add_aggregation.inc','search_api',0),('SearchApiAlterAddHierarchy','class','sites/all/modules/contrib/search_api/includes/callback_add_hierarchy.inc','search_api',0),('SearchApiAlterAddUrl','class','sites/all/modules/contrib/search_api/includes/callback_add_url.inc','search_api',0),('SearchApiAlterAddViewedEntity','class','sites/all/modules/contrib/search_api/includes/callback_add_viewed_entity.inc','search_api',0),('SearchApiAlterBundleFilter','class','sites/all/modules/contrib/search_api/includes/callback_bundle_filter.inc','search_api',0),('SearchApiAlterCallbackInterface','interface','sites/all/modules/contrib/search_api/includes/callback.inc','search_api',0),('SearchApiAlterLanguageControl','class','sites/all/modules/contrib/search_api/includes/callback_language_control.inc','search_api',0),('SearchApiAlterNodeAccess','class','sites/all/modules/contrib/search_api/includes/callback_node_access.inc','search_api',0),('SearchApiAlterNodeStatus','class','sites/all/modules/contrib/search_api/includes/callback_node_status.inc','search_api',0),('SearchApiDataSourceControllerInterface','interface','sites/all/modules/contrib/search_api/includes/datasource.inc','search_api',0),('SearchApiDataSourceException','class','sites/all/modules/contrib/search_api/includes/exception.inc','search_api',0),('SearchApiEntityDataSourceController','class','sites/all/modules/contrib/search_api/includes/datasource_entity.inc','search_api',0),('SearchApiException','class','sites/all/modules/contrib/search_api/includes/exception.inc','search_api',0),('SearchApiExternalDataSourceController','class','sites/all/modules/contrib/search_api/includes/datasource_external.inc','search_api',0),('SearchApiHtmlFilter','class','sites/all/modules/contrib/search_api/includes/processor_html_filter.inc','search_api',0),('SearchApiIgnoreCase','class','sites/all/modules/contrib/search_api/includes/processor_ignore_case.inc','search_api',0),('SearchApiIndex','class','sites/all/modules/contrib/search_api/includes/index_entity.inc','search_api',0),('SearchApiProcessorInterface','interface','sites/all/modules/contrib/search_api/includes/processor.inc','search_api',0),('SearchApiQuery','class','sites/all/modules/contrib/search_api/includes/query.inc','search_api',0),('SearchApiQueryFilter','class','sites/all/modules/contrib/search_api/includes/query.inc','search_api',0),('SearchApiQueryFilterInterface','interface','sites/all/modules/contrib/search_api/includes/query.inc','search_api',0),('SearchApiQueryInterface','interface','sites/all/modules/contrib/search_api/includes/query.inc','search_api',0),('SearchApiServer','class','sites/all/modules/contrib/search_api/includes/server_entity.inc','search_api',0),('SearchApiServiceInterface','interface','sites/all/modules/contrib/search_api/includes/service.inc','search_api',0),('SearchApiStopWords','class','sites/all/modules/contrib/search_api/includes/processor_stopwords.inc','search_api',0),('SearchApiTokenizer','class','sites/all/modules/contrib/search_api/includes/processor_tokenizer.inc','search_api',0),('SearchApiUnitTest','class','sites/all/modules/contrib/search_api/search_api.test','search_api',0),('SearchApiWebTest','class','sites/all/modules/contrib/search_api/search_api.test','search_api',0),('SearchBlockTestCase','class','modules/search/search.test','search',0),('SearchCommentCountToggleTestCase','class','modules/search/search.test','search',0),('SearchCommentTestCase','class','modules/search/search.test','search',0),('SearchConfigSettingsForm','class','modules/search/search.test','search',0),('SearchEmbedForm','class','modules/search/search.test','search',0),('SearchExactTestCase','class','modules/search/search.test','search',0),('SearchExcerptTestCase','class','modules/search/search.test','search',0),('SearchExpressionInsertExtractTestCase','class','modules/search/search.test','search',0),('SearchKeywordsConditions','class','modules/search/search.test','search',0),('SearchLanguageTestCase','class','modules/search/search.test','search',0),('SearchMatchTestCase','class','modules/search/search.test','search',0),('SearchNodeAccessTest','class','modules/search/search.test','search',0),('SearchNumberMatchingTestCase','class','modules/search/search.test','search',0),('SearchNumbersTestCase','class','modules/search/search.test','search',0),('SearchPageOverride','class','modules/search/search.test','search',0),('SearchPageText','class','modules/search/search.test','search',0),('SearchQuery','class','modules/search/search.extender.inc','search',0),('SearchRankingTestCase','class','modules/search/search.test','search',0),('SearchSimplifyTestCase','class','modules/search/search.test','search',0),('SearchTokenizerTestCase','class','modules/search/search.test','search',0),('SelectQuery','class','includes/database/select.inc','',0),('SelectQueryExtender','class','includes/database/select.inc','',0),('SelectQueryInterface','interface','includes/database/select.inc','',0),('SelectQuery_pgsql','class','includes/database/pgsql/select.inc','',0),('SelectQuery_sqlite','class','includes/database/sqlite/select.inc','',0),('ShortcutLinksTestCase','class','modules/shortcut/shortcut.test','shortcut',0),('ShortcutSetsTestCase','class','modules/shortcut/shortcut.test','shortcut',0),('ShortcutTestCase','class','modules/shortcut/shortcut.test','shortcut',0),('ShutdownFunctionsTest','class','modules/system/system.test','system',0),('SiteMaintenanceTestCase','class','modules/system/system.test','system',0),('SkipDotsRecursiveDirectoryIterator','class','includes/filetransfer/filetransfer.inc','',0),('StreamWrapperInterface','interface','includes/stream_wrappers.inc','',0),('SummaryLengthTestCase','class','modules/node/node.test','node',0),('SyslogTestCase','class','modules/syslog/syslog.test','syslog',0),('SystemAdminTestCase','class','modules/system/system.test','system',0),('SystemAuthorizeCase','class','modules/system/system.test','system',0),('SystemBlockTestCase','class','modules/system/system.test','system',0),('SystemIndexPhpTest','class','modules/system/system.test','system',0),('SystemInfoAlterTestCase','class','modules/system/system.test','system',0),('SystemMainContentFallback','class','modules/system/system.test','system',0),('SystemQueue','class','modules/system/system.queue.inc','system',0),('SystemThemeFunctionalTest','class','modules/system/system.test','system',0),('TableSort','class','includes/tablesort.inc','',0),('TaxonomyEFQTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyHooksTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyLegacyTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyLoadMultipleTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyRSSTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTermController','class','modules/taxonomy/taxonomy.module','taxonomy',0),('TaxonomyTermFieldMultipleVocabularyTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTermFieldTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTermFunctionTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTermIndexTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTermTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyThemeTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTokenReplaceTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyVocabularyController','class','modules/taxonomy/taxonomy.module','taxonomy',0),('TaxonomyVocabularyFunctionalTest','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyVocabularyTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyWebTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TestingMailSystem','class','modules/system/system.mail.inc','system',0),('TextFieldTestCase','class','modules/field/modules/text/text.test','text',0),('TextSummaryTestCase','class','modules/field/modules/text/text.test','text',0),('TextTranslationTestCase','class','modules/field/modules/text/text.test','text',0),('ThemeRegistry','class','includes/theme.inc','',0),('ThemeUpdater','class','modules/system/system.updater.inc','system',0),('TokenArrayTestCase','class','sites/all/modules/contrib/token/token.test','token',0),('TokenBlockTestCase','class','sites/all/modules/contrib/token/token.test','token',0),('TokenCommentTestCase','class','sites/all/modules/contrib/token/token.test','token',0),('TokenCurrentPageTestCase','class','sites/all/modules/contrib/token/token.test','token',0),('TokenDateTestCase','class','sites/all/modules/contrib/token/token.test','token',0),('TokenEntityTestCase','class','sites/all/modules/contrib/token/token.test','token',0),('TokenFileTestCase','class','sites/all/modules/contrib/token/token.test','token',0),('TokenMenuTestCase','class','sites/all/modules/contrib/token/token.test','token',0),('TokenNodeTestCase','class','sites/all/modules/contrib/token/token.test','token',0),('TokenProfileTestCase','class','sites/all/modules/contrib/token/token.test','token',0),('TokenRandomTestCase','class','sites/all/modules/contrib/token/token.test','token',0),('TokenReplaceTestCase','class','modules/system/system.test','system',0),('TokenTaxonomyTestCase','class','sites/all/modules/contrib/token/token.test','token',0),('TokenTestHelper','class','sites/all/modules/contrib/token/token.test','token',0),('TokenUnitTestCase','class','sites/all/modules/contrib/token/token.test','token',0),('TokenURLTestCase','class','sites/all/modules/contrib/token/token.test','token',0),('TokenUserTestCase','class','sites/all/modules/contrib/token/token.test','token',0),('TruncateQuery','class','includes/database/query.inc','',0),('TruncateQuery_mysql','class','includes/database/mysql/query.inc','',0),('TruncateQuery_sqlite','class','includes/database/sqlite/query.inc','',0),('UniqueFieldCoreTestCase','class','sites/all/modules/contrib/unique_field/tests/core.test','unique_field',0),('UniqueFieldDateTestCase','class','sites/all/modules/contrib/unique_field/tests/date.test','unique_field',0),('UniqueFieldReferencesTestCase','class','sites/all/modules/contrib/unique_field/tests/references.test','unique_field',0),('UpdateQuery','class','includes/database/query.inc','',0),('UpdateQuery_pgsql','class','includes/database/pgsql/query.inc','',0),('UpdateQuery_sqlite','class','includes/database/sqlite/query.inc','',0),('Updater','class','includes/updater.inc','',0),('UpdaterException','class','includes/updater.inc','',0),('UpdaterFileTransferException','class','includes/updater.inc','',0),('UpdateScriptFunctionalTest','class','modules/system/system.test','system',0),('UserAccountLinksUnitTests','class','modules/user/user.test','user',0),('UserAdminTestCase','class','modules/user/user.test','user',0),('UserAuthmapAssignmentTestCase','class','modules/user/user.test','user',0),('UserAutocompleteTestCase','class','modules/user/user.test','user',0),('UserBlocksUnitTests','class','modules/user/user.test','user',0),('UserCancelTestCase','class','modules/user/user.test','user',0),('UserController','class','modules/user/user.module','user',0),('UserCreateTestCase','class','modules/user/user.test','user',0),('UserEditedOwnAccountTestCase','class','modules/user/user.test','user',0),('UserEditTestCase','class','modules/user/user.test','user',0),('UserLoginTestCase','class','modules/user/user.test','user',0),('UserPasswordResetTestCase','class','modules/user/user.test','user',0),('UserPermissionsTestCase','class','modules/user/user.test','user',0),('UserPictureTestCase','class','modules/user/user.test','user',0),('UserRegistrationTestCase','class','modules/user/user.test','user',0),('UserRoleAdminTestCase','class','modules/user/user.test','user',0),('UserRolesAssignmentTestCase','class','modules/user/user.test','user',0),('UserSaveTestCase','class','modules/user/user.test','user',0),('UserSignatureTestCase','class','modules/user/user.test','user',0),('UserTimeZoneFunctionalTest','class','modules/user/user.test','user',0),('UserTokenReplaceTestCase','class','modules/user/user.test','user',0),('UserUserSearchTestCase','class','modules/user/user.test','user',0),('UserValidateCurrentPassCustomForm','class','modules/user/user.test','user',0),('UserValidationTestCase','class','modules/user/user.test','user',0),('view','class','sites/all/modules/contrib/views/includes/view.inc','views',10),('ViewsAccessTest','class','sites/all/modules/contrib/views/tests/views_access.test','views',10),('ViewsAnalyzeTest','class','sites/all/modules/contrib/views/tests/views_analyze.test','views',10),('ViewsArgumentDefaultTest','class','sites/all/modules/contrib/views/tests/views_argument_default.test','views',10),('ViewsArgumentValidatorTest','class','sites/all/modules/contrib/views/tests/views_argument_validator.test','views',10),('ViewsBasicTest','class','sites/all/modules/contrib/views/tests/views_basic.test','views',10),('ViewsCacheTest','class','sites/all/modules/contrib/views/tests/views_cache.test','views',10),('ViewsExposedFormTest','class','sites/all/modules/contrib/views/tests/views_exposed_form.test','views',10),('viewsFieldApiDataTest','class','sites/all/modules/contrib/views/tests/field/views_fieldapi.test','views',10),('ViewsFieldApiTestHelper','class','sites/all/modules/contrib/views/tests/field/views_fieldapi.test','views',10),('ViewsGlossaryTestCase','class','sites/all/modules/contrib/views/tests/views_glossary.test','views',10),('ViewsHandlerAreaTextTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_area_text.test','views',10),('viewsHandlerArgumentCommentUserUidTest','class','sites/all/modules/contrib/views/tests/comment/views_handler_argument_comment_user_uid.test','views',10),('ViewsHandlerArgumentNullTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_argument_null.test','views',10),('ViewsHandlerArgumentStringTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_argument_string.test','views',10),('ViewsHandlerFieldBooleanTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_field_boolean.test','views',10),('ViewsHandlerFieldCustomTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_field_custom.test','views',10),('ViewsHandlerFieldDateTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_field_date.test','views',10),('viewsHandlerFieldFieldTest','class','sites/all/modules/contrib/views/tests/field/views_fieldapi.test','views',10),('ViewsHandlerFieldMath','class','sites/all/modules/contrib/views/tests/handlers/views_handler_field_math.test','views',10),('ViewsHandlerFieldTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_field.test','views',10),('ViewsHandlerFieldUrlTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_field_url.test','views',10),('viewsHandlerFieldUserNameTest','class','sites/all/modules/contrib/views/tests/user/views_handler_field_user_name.test','views',10),('ViewsHandlerFilterCombineTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_filter_combine.test','views',10),('viewsHandlerFilterCommentUserUidTest','class','sites/all/modules/contrib/views/tests/comment/views_handler_filter_comment_user_uid.test','views',10),('ViewsHandlerFilterCounterTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_field_counter.test','views',10),('ViewsHandlerFilterDateTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_filter_date.test','views',10),('ViewsHandlerFilterEqualityTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_filter_equality.test','views',10),('ViewsHandlerFilterInOperator','class','sites/all/modules/contrib/views/tests/handlers/views_handler_filter_in_operator.test','views',10),('ViewsHandlerFilterNumericTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_filter_numeric.test','views',10),('ViewsHandlerFilterStringTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_filter_string.test','views',10),('ViewsHandlerRelationshipNodeTermDataTest','class','sites/all/modules/contrib/views/tests/taxonomy/views_handler_relationship_node_term_data.test','views',10),('ViewsHandlerSortDateTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_sort_date.test','views',10),('ViewsHandlerSortRandomTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_sort_random.test','views',10),('ViewsHandlerSortTest','class','sites/all/modules/contrib/views/tests/handlers/views_handler_sort.test','views',10),('ViewsHandlersTest','class','sites/all/modules/contrib/views/tests/views_handlers.test','views',10),('ViewsHandlerTestFileSize','class','sites/all/modules/contrib/views/tests/handlers/views_handler_field_file_size.test','views',10),('ViewsHandlerTestXss','class','sites/all/modules/contrib/views/tests/handlers/views_handler_field_xss.test','views',10),('ViewsModuleTest','class','sites/all/modules/contrib/views/tests/views_module.test','views',10),('ViewsPagerTest','class','sites/all/modules/contrib/views/tests/views_pager.test','views',10),('ViewsPluginDisplayTestCase','class','sites/all/modules/contrib/views/tests/plugins/views_plugin_display.test','views',10),('viewsPluginStyleJumpMenuTest','class','sites/all/modules/contrib/views/tests/styles/views_plugin_style_jump_menu.test','views',10),('ViewsPluginStyleTestCase','class','sites/all/modules/contrib/views/tests/styles/views_plugin_style.test','views',10),('ViewsPluginStyleUnformattedTestCase','class','sites/all/modules/contrib/views/tests/styles/views_plugin_style_unformatted.test','views',10),('ViewsQueryGroupByTest','class','sites/all/modules/contrib/views/tests/views_groupby.test','views',10),('viewsSearchQuery','class','sites/all/modules/contrib/views/modules/search/views_handler_filter_search.inc','views',10),('ViewsSqlTest','class','sites/all/modules/contrib/views/tests/views_query.test','views',10),('ViewsTestCase','class','sites/all/modules/contrib/views/tests/views_query.test','views',10),('ViewsTranslatableTest','class','sites/all/modules/contrib/views/tests/views_translatable.test','views',10),('ViewsUiBaseViewsWizard','class','sites/all/modules/contrib/views/plugins/views_wizard/views_ui_base_views_wizard.class.php','views_ui',0),('ViewsUiCommentViewsWizard','class','sites/all/modules/contrib/views/plugins/views_wizard/views_ui_comment_views_wizard.class.php','views_ui',0),('ViewsUiFileManagedViewsWizard','class','sites/all/modules/contrib/views/plugins/views_wizard/views_ui_file_managed_views_wizard.class.php','views_ui',0),('viewsUiGroupbyTestCase','class','sites/all/modules/contrib/views/tests/views_groupby.test','views',10),('ViewsUiNodeRevisionViewsWizard','class','sites/all/modules/contrib/views/plugins/views_wizard/views_ui_node_revision_views_wizard.class.php','views_ui',0),('ViewsUiNodeViewsWizard','class','sites/all/modules/contrib/views/plugins/views_wizard/views_ui_node_views_wizard.class.php','views_ui',0),('ViewsUiTaxonomyTermViewsWizard','class','sites/all/modules/contrib/views/plugins/views_wizard/views_ui_taxonomy_term_views_wizard.class.php','views_ui',0),('ViewsUiUsersViewsWizard','class','sites/all/modules/contrib/views/plugins/views_wizard/views_ui_users_views_wizard.class.php','views_ui',0),('ViewsUIWizardBasicTestCase','class','sites/all/modules/contrib/views/tests/views_ui.test','views',10),('ViewsUIWizardDefaultViewsTestCase','class','sites/all/modules/contrib/views/tests/views_ui.test','views',10),('ViewsUIWizardHelper','class','sites/all/modules/contrib/views/tests/views_ui.test','views',10),('ViewsUIWizardItemsPerPageTestCase','class','sites/all/modules/contrib/views/tests/views_ui.test','views',10),('ViewsUIWizardJumpMenuTestCase','class','sites/all/modules/contrib/views/tests/views_ui.test','views',10),('ViewsUIWizardMenuTestCase','class','sites/all/modules/contrib/views/tests/views_ui.test','views',10),('ViewsUIWizardOverrideDisplaysTestCase','class','sites/all/modules/contrib/views/tests/views_ui.test','views',10),('ViewsUIWizardSortingTestCase','class','sites/all/modules/contrib/views/tests/views_ui.test','views',10),('ViewsUIWizardTaggedWithTestCase','class','sites/all/modules/contrib/views/tests/views_ui.test','views',10),('ViewsUpgradeTestCase','class','sites/all/modules/contrib/views/tests/views_upgrade.test','views',10),('ViewsUserArgumentDefault','class','sites/all/modules/contrib/views/tests/user/views_user_argument_default.test','views',10),('ViewsUserArgumentValidate','class','sites/all/modules/contrib/views/tests/user/views_user_argument_validate.test','views',10),('ViewsUserTestCase','class','sites/all/modules/contrib/views/tests/user/views_user.test','views',10),('ViewsViewTest','class','sites/all/modules/contrib/views/tests/views_view.test','views',10),('ViewsWizardException','class','sites/all/modules/contrib/views/plugins/views_wizard/views_ui_base_views_wizard.class.php','views_ui',0),('ViewsWizardInterface','interface','sites/all/modules/contrib/views/plugins/views_wizard/views_ui_base_views_wizard.class.php','views_ui',0),('views_content_plugin_display_ctools_context','class','sites/all/modules/contrib/ctools/views_content/plugins/views/views_content_plugin_display_ctools_context.inc','views_content',0),('views_content_plugin_display_panel_pane','class','sites/all/modules/contrib/ctools/views_content/plugins/views/views_content_plugin_display_panel_pane.inc','views_content',0),('views_content_plugin_style_ctools_context','class','sites/all/modules/contrib/ctools/views_content/plugins/views/views_content_plugin_style_ctools_context.inc','views_content',0),('views_db_object','class','sites/all/modules/contrib/views/includes/view.inc','views',10),('views_display','class','sites/all/modules/contrib/views/includes/view.inc','views',10),('views_handler','class','sites/all/modules/contrib/views/includes/handlers.inc','views',10),('views_handler_area','class','sites/all/modules/contrib/views/handlers/views_handler_area.inc','views',10),('views_handler_area_broken','class','sites/all/modules/contrib/views/handlers/views_handler_area.inc','views',10),('views_handler_area_result','class','sites/all/modules/contrib/views/handlers/views_handler_area_result.inc','views',10),('views_handler_area_text','class','sites/all/modules/contrib/views/handlers/views_handler_area_text.inc','views',10),('views_handler_area_text_custom','class','sites/all/modules/contrib/views/handlers/views_handler_area_text_custom.inc','views',10),('views_handler_area_view','class','sites/all/modules/contrib/views/handlers/views_handler_area_view.inc','views',10),('views_handler_argument','class','sites/all/modules/contrib/views/handlers/views_handler_argument.inc','views',10),('views_handler_argument_aggregator_category_cid','class','sites/all/modules/contrib/views/modules/aggregator/views_handler_argument_aggregator_category_cid.inc','views',10),('views_handler_argument_aggregator_fid','class','sites/all/modules/contrib/views/modules/aggregator/views_handler_argument_aggregator_fid.inc','views',10),('views_handler_argument_aggregator_iid','class','sites/all/modules/contrib/views/modules/aggregator/views_handler_argument_aggregator_iid.inc','views',10),('views_handler_argument_broken','class','sites/all/modules/contrib/views/handlers/views_handler_argument.inc','views',10),('views_handler_argument_comment_user_uid','class','sites/all/modules/contrib/views/modules/comment/views_handler_argument_comment_user_uid.inc','views',10),('views_handler_argument_date','class','sites/all/modules/contrib/views/handlers/views_handler_argument_date.inc','views',10),('views_handler_argument_field_list','class','sites/all/modules/contrib/views/modules/field/views_handler_argument_field_list.inc','views',10),('views_handler_argument_field_list_string','class','sites/all/modules/contrib/views/modules/field/views_handler_argument_field_list_string.inc','views',10),('views_handler_argument_file_fid','class','sites/all/modules/contrib/views/modules/system/views_handler_argument_file_fid.inc','views',10),('views_handler_argument_formula','class','sites/all/modules/contrib/views/handlers/views_handler_argument_formula.inc','views',10),('views_handler_argument_group_by_numeric','class','sites/all/modules/contrib/views/handlers/views_handler_argument_group_by_numeric.inc','views',10),('views_handler_argument_locale_group','class','sites/all/modules/contrib/views/modules/locale/views_handler_argument_locale_group.inc','views',10),('views_handler_argument_locale_language','class','sites/all/modules/contrib/views/modules/locale/views_handler_argument_locale_language.inc','views',10),('views_handler_argument_many_to_one','class','sites/all/modules/contrib/views/handlers/views_handler_argument_many_to_one.inc','views',10),('views_handler_argument_node_created_day','class','sites/all/modules/contrib/views/modules/node/views_handler_argument_dates_various.inc','views',10),('views_handler_argument_node_created_fulldate','class','sites/all/modules/contrib/views/modules/node/views_handler_argument_dates_various.inc','views',10),('views_handler_argument_node_created_month','class','sites/all/modules/contrib/views/modules/node/views_handler_argument_dates_various.inc','views',10),('views_handler_argument_node_created_week','class','sites/all/modules/contrib/views/modules/node/views_handler_argument_dates_various.inc','views',10),('views_handler_argument_node_created_year','class','sites/all/modules/contrib/views/modules/node/views_handler_argument_dates_various.inc','views',10),('views_handler_argument_node_created_year_month','class','sites/all/modules/contrib/views/modules/node/views_handler_argument_dates_various.inc','views',10),('views_handler_argument_node_language','class','sites/all/modules/contrib/views/modules/node/views_handler_argument_node_language.inc','views',10),('views_handler_argument_node_nid','class','sites/all/modules/contrib/views/modules/node/views_handler_argument_node_nid.inc','views',10),('views_handler_argument_node_tnid','class','sites/all/modules/contrib/views/modules/translation/views_handler_argument_node_tnid.inc','views',10),('views_handler_argument_node_type','class','sites/all/modules/contrib/views/modules/node/views_handler_argument_node_type.inc','views',10),('views_handler_argument_node_uid_revision','class','sites/all/modules/contrib/views/modules/node/views_handler_argument_node_uid_revision.inc','views',10),('views_handler_argument_node_vid','class','sites/all/modules/contrib/views/modules/node/views_handler_argument_node_vid.inc','views',10),('views_handler_argument_null','class','sites/all/modules/contrib/views/handlers/views_handler_argument_null.inc','views',10),('views_handler_argument_numeric','class','sites/all/modules/contrib/views/handlers/views_handler_argument_numeric.inc','views',10),('views_handler_argument_search','class','sites/all/modules/contrib/views/modules/search/views_handler_argument_search.inc','views',10),('views_handler_argument_string','class','sites/all/modules/contrib/views/handlers/views_handler_argument_string.inc','views',10),('views_handler_argument_taxonomy','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_taxonomy.inc','views',10),('views_handler_argument_term_node_tid','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_term_node_tid.inc','views',10),('views_handler_argument_term_node_tid_depth','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_term_node_tid_depth.inc','views',10),('views_handler_argument_term_node_tid_depth_modifier','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_term_node_tid_depth_modifier.inc','views',10),('views_handler_argument_users_roles_rid','class','sites/all/modules/contrib/views/modules/user/views_handler_argument_users_roles_rid.inc','views',10),('views_handler_argument_user_uid','class','sites/all/modules/contrib/views/modules/user/views_handler_argument_user_uid.inc','views',10),('views_handler_argument_vocabulary_machine_name','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_vocabulary_machine_name.inc','views',10),('views_handler_argument_vocabulary_vid','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_vocabulary_vid.inc','views',10),('views_handler_field','class','sites/all/modules/contrib/views/handlers/views_handler_field.inc','views',10),('views_handler_field_accesslog_path','class','sites/all/modules/contrib/views/modules/statistics/views_handler_field_accesslog_path.inc','views',10),('views_handler_field_aggregator_category','class','sites/all/modules/contrib/views/modules/aggregator/views_handler_field_aggregator_category.inc','views',10),('views_handler_field_aggregator_title_link','class','sites/all/modules/contrib/views/modules/aggregator/views_handler_field_aggregator_title_link.inc','views',10),('views_handler_field_aggregator_xss','class','sites/all/modules/contrib/views/modules/aggregator/views_handler_field_aggregator_xss.inc','views',10),('views_handler_field_boolean','class','sites/all/modules/contrib/views/handlers/views_handler_field_boolean.inc','views',10),('views_handler_field_broken','class','sites/all/modules/contrib/views/handlers/views_handler_field.inc','views',10),('views_handler_field_comment','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_comment.inc','views',10),('views_handler_field_comment_depth','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_depth.inc','views',10),('views_handler_field_comment_link','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_link.inc','views',10),('views_handler_field_comment_link_approve','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_link_approve.inc','views',10),('views_handler_field_comment_link_delete','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_link_delete.inc','views',10),('views_handler_field_comment_link_edit','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_link_edit.inc','views',10),('views_handler_field_comment_link_reply','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_link_reply.inc','views',10),('views_handler_field_comment_node_link','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_node_link.inc','views',10),('views_handler_field_comment_username','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_username.inc','views',10),('views_handler_field_contact_link','class','sites/all/modules/contrib/views/modules/contact/views_handler_field_contact_link.inc','views',10),('views_handler_field_contextual_links','class','sites/all/modules/contrib/views/handlers/views_handler_field_contextual_links.inc','views',10),('views_handler_field_counter','class','sites/all/modules/contrib/views/handlers/views_handler_field_counter.inc','views',10),('views_handler_field_custom','class','sites/all/modules/contrib/views/handlers/views_handler_field_custom.inc','views',10),('views_handler_field_date','class','sites/all/modules/contrib/views/handlers/views_handler_field_date.inc','views',10),('views_handler_field_entity','class','sites/all/modules/contrib/views/handlers/views_handler_field_entity.inc','views',10),('views_handler_field_field','class','sites/all/modules/contrib/views/modules/field/views_handler_field_field.inc','views',10),('views_handler_field_file','class','sites/all/modules/contrib/views/modules/system/views_handler_field_file.inc','views',10),('views_handler_field_file_extension','class','sites/all/modules/contrib/views/modules/system/views_handler_field_file_extension.inc','views',10),('views_handler_field_file_filemime','class','sites/all/modules/contrib/views/modules/system/views_handler_field_file_filemime.inc','views',10),('views_handler_field_file_size','class','sites/all/modules/contrib/views/handlers/views_handler_field.inc','views',10),('views_handler_field_file_status','class','sites/all/modules/contrib/views/modules/system/views_handler_field_file_status.inc','views',10),('views_handler_field_file_uri','class','sites/all/modules/contrib/views/modules/system/views_handler_field_file_uri.inc','views',10),('views_handler_field_filter_format_name','class','sites/all/modules/contrib/views/modules/filter/views_handler_field_filter_format_name.inc','views',10),('views_handler_field_history_user_timestamp','class','sites/all/modules/contrib/views/modules/node/views_handler_field_history_user_timestamp.inc','views',10),('views_handler_field_last_comment_timestamp','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_last_comment_timestamp.inc','views',10),('views_handler_field_locale_group','class','sites/all/modules/contrib/views/modules/locale/views_handler_field_locale_group.inc','views',10),('views_handler_field_locale_language','class','sites/all/modules/contrib/views/modules/locale/views_handler_field_locale_language.inc','views',10),('views_handler_field_locale_link_edit','class','sites/all/modules/contrib/views/modules/locale/views_handler_field_locale_link_edit.inc','views',10),('views_handler_field_machine_name','class','sites/all/modules/contrib/views/handlers/views_handler_field_machine_name.inc','views',10),('views_handler_field_markup','class','sites/all/modules/contrib/views/handlers/views_handler_field_markup.inc','views',10),('views_handler_field_math','class','sites/all/modules/contrib/views/handlers/views_handler_field_math.inc','views',10),('views_handler_field_ncs_last_comment_name','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_ncs_last_comment_name.inc','views',10),('views_handler_field_ncs_last_updated','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_ncs_last_updated.inc','views',10),('views_handler_field_node','class','sites/all/modules/contrib/views/modules/node/views_handler_field_node.inc','views',10),('views_handler_field_node_comment','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_node_comment.inc','views',10),('views_handler_field_node_language','class','sites/all/modules/contrib/views/modules/locale/views_handler_field_node_language.inc','views',10),('views_handler_field_node_link','class','sites/all/modules/contrib/views/modules/node/views_handler_field_node_link.inc','views',10),('views_handler_field_node_link_delete','class','sites/all/modules/contrib/views/modules/node/views_handler_field_node_link_delete.inc','views',10),('views_handler_field_node_link_edit','class','sites/all/modules/contrib/views/modules/node/views_handler_field_node_link_edit.inc','views',10),('views_handler_field_node_link_translate','class','sites/all/modules/contrib/views/modules/translation/views_handler_field_node_link_translate.inc','views',10),('views_handler_field_node_new_comments','class','sites/all/modules/contrib/views/modules/comment/views_handler_field_node_new_comments.inc','views',10),('views_handler_field_node_path','class','sites/all/modules/contrib/views/modules/node/views_handler_field_node_path.inc','views',10),('views_handler_field_node_revision','class','sites/all/modules/contrib/views/modules/node/views_handler_field_node_revision.inc','views',10),('views_handler_field_node_revision_link','class','sites/all/modules/contrib/views/modules/node/views_handler_field_node_revision_link.inc','views',10),('views_handler_field_node_revision_link_delete','class','sites/all/modules/contrib/views/modules/node/views_handler_field_node_revision_link_delete.inc','views',10),('views_handler_field_node_revision_link_revert','class','sites/all/modules/contrib/views/modules/node/views_handler_field_node_revision_link_revert.inc','views',10),('views_handler_field_node_translation_link','class','sites/all/modules/contrib/views/modules/translation/views_handler_field_node_translation_link.inc','views',10),('views_handler_field_node_type','class','sites/all/modules/contrib/views/modules/node/views_handler_field_node_type.inc','views',10),('views_handler_field_numeric','class','sites/all/modules/contrib/views/handlers/views_handler_field_numeric.inc','views',10),('views_handler_field_prerender_list','class','sites/all/modules/contrib/views/handlers/views_handler_field_prerender_list.inc','views',10),('views_handler_field_profile_date','class','sites/all/modules/contrib/views/modules/profile/views_handler_field_profile_date.inc','views',10),('views_handler_field_profile_list','class','sites/all/modules/contrib/views/modules/profile/views_handler_field_profile_list.inc','views',10),('views_handler_field_search_score','class','sites/all/modules/contrib/views/modules/search/views_handler_field_search_score.inc','views',10),('views_handler_field_serialized','class','sites/all/modules/contrib/views/handlers/views_handler_field_serialized.inc','views',10),('views_handler_field_taxonomy','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_field_taxonomy.inc','views',10),('views_handler_field_term_link_edit','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_field_term_link_edit.inc','views',10),('views_handler_field_term_node_tid','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_field_term_node_tid.inc','views',10),('views_handler_field_time_interval','class','sites/all/modules/contrib/views/handlers/views_handler_field_time_interval.inc','views',10),('views_handler_field_url','class','sites/all/modules/contrib/views/handlers/views_handler_field_url.inc','views',10),('views_handler_field_user','class','sites/all/modules/contrib/views/modules/user/views_handler_field_user.inc','views',10),('views_handler_field_user_language','class','sites/all/modules/contrib/views/modules/user/views_handler_field_user_language.inc','views',10),('views_handler_field_user_link','class','sites/all/modules/contrib/views/modules/user/views_handler_field_user_link.inc','views',10),('views_handler_field_user_link_cancel','class','sites/all/modules/contrib/views/modules/user/views_handler_field_user_link_cancel.inc','views',10),('views_handler_field_user_link_edit','class','sites/all/modules/contrib/views/modules/user/views_handler_field_user_link_edit.inc','views',10),('views_handler_field_user_mail','class','sites/all/modules/contrib/views/modules/user/views_handler_field_user_mail.inc','views',10),('views_handler_field_user_name','class','sites/all/modules/contrib/views/modules/user/views_handler_field_user_name.inc','views',10),('views_handler_field_user_permissions','class','sites/all/modules/contrib/views/modules/user/views_handler_field_user_permissions.inc','views',10),('views_handler_field_user_picture','class','sites/all/modules/contrib/views/modules/user/views_handler_field_user_picture.inc','views',10),('views_handler_field_user_roles','class','sites/all/modules/contrib/views/modules/user/views_handler_field_user_roles.inc','views',10),('views_handler_field_watchdog_message','class','sites/all/modules/contrib/views_watchdog/views/handlers/views_handler_field_watchdog_message.inc','views_watchdog',0),('views_handler_field_watchdog_severity','class','sites/all/modules/contrib/views_watchdog/views/handlers/views_handler_field_watchdog_severity.inc','views_watchdog',0),('views_handler_field_xss','class','sites/all/modules/contrib/views/handlers/views_handler_field.inc','views',10),('views_handler_filter','class','sites/all/modules/contrib/views/handlers/views_handler_filter.inc','views',10),('views_handler_filter_aggregator_category_cid','class','sites/all/modules/contrib/views/modules/aggregator/views_handler_filter_aggregator_category_cid.inc','views',10),('views_handler_filter_boolean_operator','class','sites/all/modules/contrib/views/handlers/views_handler_filter_boolean_operator.inc','views',10),('views_handler_filter_boolean_operator_string','class','sites/all/modules/contrib/views/handlers/views_handler_filter_boolean_operator_string.inc','views',10),('views_handler_filter_broken','class','sites/all/modules/contrib/views/handlers/views_handler_filter.inc','views',10),('views_handler_filter_combine','class','sites/all/modules/contrib/views/handlers/views_handler_filter_combine.inc','views',10),('views_handler_filter_comment_user_uid','class','sites/all/modules/contrib/views/modules/comment/views_handler_filter_comment_user_uid.inc','views',10),('views_handler_filter_date','class','sites/all/modules/contrib/views/handlers/views_handler_filter_date.inc','views',10),('views_handler_filter_entity_bundle','class','sites/all/modules/contrib/views/handlers/views_handler_filter_entity_bundle.inc','views',10),('views_handler_filter_equality','class','sites/all/modules/contrib/views/handlers/views_handler_filter_equality.inc','views',10),('views_handler_filter_field_list','class','sites/all/modules/contrib/views/modules/field/views_handler_filter_field_list.inc','views',10),('views_handler_filter_file_status','class','sites/all/modules/contrib/views/modules/system/views_handler_filter_file_status.inc','views',10),('views_handler_filter_group_by_numeric','class','sites/all/modules/contrib/views/handlers/views_handler_filter_group_by_numeric.inc','views',10),('views_handler_filter_history_user_timestamp','class','sites/all/modules/contrib/views/modules/node/views_handler_filter_history_user_timestamp.inc','views',10),('views_handler_filter_in_operator','class','sites/all/modules/contrib/views/handlers/views_handler_filter_in_operator.inc','views',10),('views_handler_filter_locale_group','class','sites/all/modules/contrib/views/modules/locale/views_handler_filter_locale_group.inc','views',10),('views_handler_filter_locale_language','class','sites/all/modules/contrib/views/modules/locale/views_handler_filter_locale_language.inc','views',10),('views_handler_filter_locale_version','class','sites/all/modules/contrib/views/modules/locale/views_handler_filter_locale_version.inc','views',10),('views_handler_filter_many_to_one','class','sites/all/modules/contrib/views/handlers/views_handler_filter_many_to_one.inc','views',10),('views_handler_filter_ncs_last_updated','class','sites/all/modules/contrib/views/modules/comment/views_handler_filter_ncs_last_updated.inc','views',10),('views_handler_filter_node_access','class','sites/all/modules/contrib/views/modules/node/views_handler_filter_node_access.inc','views',10),('views_handler_filter_node_comment','class','sites/all/modules/contrib/views/modules/comment/views_handler_filter_node_comment.inc','views',10),('views_handler_filter_node_language','class','sites/all/modules/contrib/views/modules/locale/views_handler_filter_node_language.inc','views',10),('views_handler_filter_node_status','class','sites/all/modules/contrib/views/modules/node/views_handler_filter_node_status.inc','views',10),('views_handler_filter_node_tnid','class','sites/all/modules/contrib/views/modules/translation/views_handler_filter_node_tnid.inc','views',10),('views_handler_filter_node_tnid_child','class','sites/all/modules/contrib/views/modules/translation/views_handler_filter_node_tnid_child.inc','views',10),('views_handler_filter_node_type','class','sites/all/modules/contrib/views/modules/node/views_handler_filter_node_type.inc','views',10),('views_handler_filter_node_uid_revision','class','sites/all/modules/contrib/views/modules/node/views_handler_filter_node_uid_revision.inc','views',10),('views_handler_filter_numeric','class','sites/all/modules/contrib/views/handlers/views_handler_filter_numeric.inc','views',10),('views_handler_filter_profile_selection','class','sites/all/modules/contrib/views/modules/profile/views_handler_filter_profile_selection.inc','views',10),('views_handler_filter_search','class','sites/all/modules/contrib/views/modules/search/views_handler_filter_search.inc','views',10),('views_handler_filter_string','class','sites/all/modules/contrib/views/handlers/views_handler_filter_string.inc','views',10),('views_handler_filter_system_type','class','sites/all/modules/contrib/views/modules/system/views_handler_filter_system_type.inc','views',10),('views_handler_filter_term_node_tid','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_filter_term_node_tid.inc','views',10),('views_handler_filter_term_node_tid_depth','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_filter_term_node_tid_depth.inc','views',10),('views_handler_filter_user_current','class','sites/all/modules/contrib/views/modules/user/views_handler_filter_user_current.inc','views',10),('views_handler_filter_user_name','class','sites/all/modules/contrib/views/modules/user/views_handler_filter_user_name.inc','views',10),('views_handler_filter_user_permissions','class','sites/all/modules/contrib/views/modules/user/views_handler_filter_user_permissions.inc','views',10),('views_handler_filter_user_roles','class','sites/all/modules/contrib/views/modules/user/views_handler_filter_user_roles.inc','views',10),('views_handler_filter_vocabulary_machine_name','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_filter_vocabulary_machine_name.inc','views',10),('views_handler_filter_vocabulary_vid','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_filter_vocabulary_vid.inc','views',10),('views_handler_filter_watchdog_message','class','sites/all/modules/contrib/views_watchdog/views/handlers/views_handler_filter_watchdog_message.inc','views_watchdog',0),('views_handler_filter_watchdog_severity','class','sites/all/modules/contrib/views_watchdog/views/handlers/views_handler_filter_watchdog_severity.inc','views_watchdog',0),('views_handler_filter_watchdog_type','class','sites/all/modules/contrib/views_watchdog/views/handlers/views_handler_filter_watchdog_type.inc','views_watchdog',0),('views_handler_relationship','class','sites/all/modules/contrib/views/handlers/views_handler_relationship.inc','views',10),('views_handler_relationship_broken','class','sites/all/modules/contrib/views/handlers/views_handler_relationship.inc','views',10),('views_handler_relationship_entity_reverse','class','sites/all/modules/contrib/views/modules/field/views_handler_relationship_entity_reverse.inc','views',10),('views_handler_relationship_groupwise_max','class','sites/all/modules/contrib/views/handlers/views_handler_relationship_groupwise_max.inc','views',10),('views_handler_relationship_node_term_data','class','sites/all/modules/contrib/views/modules/taxonomy/views_handler_relationship_node_term_data.inc','views',10),('views_handler_relationship_translation','class','sites/all/modules/contrib/views/modules/translation/views_handler_relationship_translation.inc','views',10),('views_handler_sort','class','sites/all/modules/contrib/views/handlers/views_handler_sort.inc','views',10),('views_handler_sort_broken','class','sites/all/modules/contrib/views/handlers/views_handler_sort.inc','views',10),('views_handler_sort_comment_thread','class','sites/all/modules/contrib/views/modules/comment/views_handler_sort_comment_thread.inc','views',10),('views_handler_sort_date','class','sites/all/modules/contrib/views/handlers/views_handler_sort_date.inc','views',10),('views_handler_sort_group_by_numeric','class','sites/all/modules/contrib/views/handlers/views_handler_sort_group_by_numeric.inc','views',10),('views_handler_sort_menu_hierarchy','class','sites/all/modules/contrib/views/handlers/views_handler_sort_menu_hierarchy.inc','views',10),('views_handler_sort_ncs_last_comment_name','class','sites/all/modules/contrib/views/modules/comment/views_handler_sort_ncs_last_comment_name.inc','views',10),('views_handler_sort_ncs_last_updated','class','sites/all/modules/contrib/views/modules/comment/views_handler_sort_ncs_last_updated.inc','views',10),('views_handler_sort_random','class','sites/all/modules/contrib/views/handlers/views_handler_sort_random.inc','views',10),('views_handler_sort_search_score','class','sites/all/modules/contrib/views/modules/search/views_handler_sort_search_score.inc','views',10),('views_join','class','sites/all/modules/contrib/views/includes/handlers.inc','views',10),('views_join_subquery','class','sites/all/modules/contrib/views/includes/handlers.inc','views',10),('views_many_to_one_helper','class','sites/all/modules/contrib/views/includes/handlers.inc','views',10),('views_object','class','sites/all/modules/contrib/views/includes/base.inc','views',10),('views_php_handler_area','class','sites/all/modules/contrib/views_php/plugins/views/views_php_handler_area.inc','views_php',0),('views_php_handler_field','class','sites/all/modules/contrib/views_php/plugins/views/views_php_handler_field.inc','views_php',0),('views_php_handler_filter','class','sites/all/modules/contrib/views_php/plugins/views/views_php_handler_filter.inc','views_php',0),('views_php_handler_sort','class','sites/all/modules/contrib/views_php/plugins/views/views_php_handler_sort.inc','views_php',0),('views_php_plugin_access','class','sites/all/modules/contrib/views_php/plugins/views/views_php_plugin_access.inc','views_php',0),('views_php_plugin_cache','class','sites/all/modules/contrib/views_php/plugins/views/views_php_plugin_cache.inc','views_php',0),('views_php_plugin_pager','class','sites/all/modules/contrib/views_php/plugins/views/views_php_plugin_pager.inc','views_php',0),('views_php_plugin_query','class','sites/all/modules/contrib/views_php/plugins/views/views_php_plugin_query.inc','views_php',0),('views_php_plugin_wrapper','class','sites/all/modules/contrib/views_php/plugins/views/views_php_plugin_wrapper.inc','views_php',0),('views_plugin','class','sites/all/modules/contrib/views/includes/plugins.inc','views',10),('views_plugin_access','class','sites/all/modules/contrib/views/plugins/views_plugin_access.inc','views',10),('views_plugin_access_none','class','sites/all/modules/contrib/views/plugins/views_plugin_access_none.inc','views',10),('views_plugin_access_perm','class','sites/all/modules/contrib/views/plugins/views_plugin_access_perm.inc','views',10),('views_plugin_access_role','class','sites/all/modules/contrib/views/plugins/views_plugin_access_role.inc','views',10),('views_plugin_argument_default','class','sites/all/modules/contrib/views/plugins/views_plugin_argument_default.inc','views',10),('views_plugin_argument_default_book_root','class','sites/all/modules/contrib/views/modules/book/views_plugin_argument_default_book_root.inc','views',10),('views_plugin_argument_default_current_user','class','sites/all/modules/contrib/views/modules/user/views_plugin_argument_default_current_user.inc','views',10),('views_plugin_argument_default_fixed','class','sites/all/modules/contrib/views/plugins/views_plugin_argument_default_fixed.inc','views',10),('views_plugin_argument_default_node','class','sites/all/modules/contrib/views/modules/node/views_plugin_argument_default_node.inc','views',10),('views_plugin_argument_default_php','class','sites/all/modules/contrib/views/plugins/views_plugin_argument_default_php.inc','views',10),('views_plugin_argument_default_raw','class','sites/all/modules/contrib/views/plugins/views_plugin_argument_default_raw.inc','views',10),('views_plugin_argument_default_taxonomy_tid','class','sites/all/modules/contrib/views/modules/taxonomy/views_plugin_argument_default_taxonomy_tid.inc','views',10),('views_plugin_argument_default_user','class','sites/all/modules/contrib/views/modules/user/views_plugin_argument_default_user.inc','views',10),('views_plugin_argument_validate','class','sites/all/modules/contrib/views/plugins/views_plugin_argument_validate.inc','views',10),('views_plugin_argument_validate_node','class','sites/all/modules/contrib/views/modules/node/views_plugin_argument_validate_node.inc','views',10),('views_plugin_argument_validate_numeric','class','sites/all/modules/contrib/views/plugins/views_plugin_argument_validate_numeric.inc','views',10),('views_plugin_argument_validate_php','class','sites/all/modules/contrib/views/plugins/views_plugin_argument_validate_php.inc','views',10),('views_plugin_argument_validate_taxonomy_term','class','sites/all/modules/contrib/views/modules/taxonomy/views_plugin_argument_validate_taxonomy_term.inc','views',10),('views_plugin_argument_validate_user','class','sites/all/modules/contrib/views/modules/user/views_plugin_argument_validate_user.inc','views',10),('views_plugin_cache','class','sites/all/modules/contrib/views/plugins/views_plugin_cache.inc','views',10),('views_plugin_cache_none','class','sites/all/modules/contrib/views/plugins/views_plugin_cache_none.inc','views',10),('views_plugin_cache_time','class','sites/all/modules/contrib/views/plugins/views_plugin_cache_time.inc','views',10),('views_plugin_display','class','sites/all/modules/contrib/views/plugins/views_plugin_display.inc','views',10),('views_plugin_display_attachment','class','sites/all/modules/contrib/views/plugins/views_plugin_display_attachment.inc','views',10),('views_plugin_display_block','class','sites/all/modules/contrib/views/plugins/views_plugin_display_block.inc','views',10),('views_plugin_display_default','class','sites/all/modules/contrib/views/plugins/views_plugin_display_default.inc','views',10),('views_plugin_display_embed','class','sites/all/modules/contrib/views/plugins/views_plugin_display_embed.inc','views',10),('views_plugin_display_extender','class','sites/all/modules/contrib/views/plugins/views_plugin_display_extender.inc','views',10),('views_plugin_display_feed','class','sites/all/modules/contrib/views/plugins/views_plugin_display_feed.inc','views',10),('views_plugin_display_page','class','sites/all/modules/contrib/views/plugins/views_plugin_display_page.inc','views',10),('views_plugin_exposed_form','class','sites/all/modules/contrib/views/plugins/views_plugin_exposed_form.inc','views',10),('views_plugin_exposed_form_basic','class','sites/all/modules/contrib/views/plugins/views_plugin_exposed_form_basic.inc','views',10),('views_plugin_exposed_form_input_required','class','sites/all/modules/contrib/views/plugins/views_plugin_exposed_form_input_required.inc','views',10),('views_plugin_localization','class','sites/all/modules/contrib/views/plugins/views_plugin_localization.inc','views',10),('views_plugin_localization_core','class','sites/all/modules/contrib/views/plugins/views_plugin_localization_core.inc','views',10),('views_plugin_localization_none','class','sites/all/modules/contrib/views/plugins/views_plugin_localization_none.inc','views',10),('views_plugin_localization_test','class','sites/all/modules/contrib/views/tests/views_plugin_localization_test.inc','views',10),('views_plugin_pager','class','sites/all/modules/contrib/views/plugins/views_plugin_pager.inc','views',10),('views_plugin_pager_full','class','sites/all/modules/contrib/views/plugins/views_plugin_pager_full.inc','views',10),('views_plugin_pager_mini','class','sites/all/modules/contrib/views/plugins/views_plugin_pager_mini.inc','views',10),('views_plugin_pager_none','class','sites/all/modules/contrib/views/plugins/views_plugin_pager_none.inc','views',10),('views_plugin_pager_some','class','sites/all/modules/contrib/views/plugins/views_plugin_pager_some.inc','views',10),('views_plugin_query','class','sites/all/modules/contrib/views/plugins/views_plugin_query.inc','views',10),('views_plugin_query_default','class','sites/all/modules/contrib/views/plugins/views_plugin_query_default.inc','views',10),('views_plugin_row','class','sites/all/modules/contrib/views/plugins/views_plugin_row.inc','views',10),('views_plugin_row_aggregator_rss','class','sites/all/modules/contrib/views/modules/aggregator/views_plugin_row_aggregator_rss.inc','views',10),('views_plugin_row_comment_rss','class','sites/all/modules/contrib/views/modules/comment/views_plugin_row_comment_rss.inc','views',10),('views_plugin_row_comment_view','class','sites/all/modules/contrib/views/modules/comment/views_plugin_row_comment_view.inc','views',10),('views_plugin_row_fields','class','sites/all/modules/contrib/views/plugins/views_plugin_row_fields.inc','views',10),('views_plugin_row_node_rss','class','sites/all/modules/contrib/views/modules/node/views_plugin_row_node_rss.inc','views',10),('views_plugin_row_node_view','class','sites/all/modules/contrib/views/modules/node/views_plugin_row_node_view.inc','views',10),('views_plugin_row_rss_fields','class','sites/all/modules/contrib/views/plugins/views_plugin_row_rss_fields.inc','views',10),('views_plugin_row_search_view','class','sites/all/modules/contrib/views/modules/search/views_plugin_row_search_view.inc','views',10),('views_plugin_row_user_view','class','sites/all/modules/contrib/views/modules/user/views_plugin_row_user_view.inc','views',10),('views_plugin_row_watchdog_rss','class','sites/all/modules/contrib/views_watchdog/views/plugins/views_plugin_row_watchdog_rss.inc','views_watchdog',0),('views_plugin_style','class','sites/all/modules/contrib/views/plugins/views_plugin_style.inc','views',10),('views_plugin_style_default','class','sites/all/modules/contrib/views/plugins/views_plugin_style_default.inc','views',10),('views_plugin_style_grid','class','sites/all/modules/contrib/views/plugins/views_plugin_style_grid.inc','views',10),('views_plugin_style_jump_menu','class','sites/all/modules/contrib/views/plugins/views_plugin_style_jump_menu.inc','views',10),('views_plugin_style_list','class','sites/all/modules/contrib/views/plugins/views_plugin_style_list.inc','views',10),('views_plugin_style_rss','class','sites/all/modules/contrib/views/plugins/views_plugin_style_rss.inc','views',10),('views_plugin_style_summary','class','sites/all/modules/contrib/views/plugins/views_plugin_style_summary.inc','views',10),('views_plugin_style_summary_jump_menu','class','sites/all/modules/contrib/views/plugins/views_plugin_style_summary_jump_menu.inc','views',10),('views_plugin_style_summary_unformatted','class','sites/all/modules/contrib/views/plugins/views_plugin_style_summary_unformatted.inc','views',10),('views_plugin_style_table','class','sites/all/modules/contrib/views/plugins/views_plugin_style_table.inc','views',10),('views_plugin_style_watchdog_table','class','sites/all/modules/contrib/views_watchdog/views/plugins/views_plugin_style_watchdog_table.inc','views_watchdog',0),('views_test_plugin_access_test_dynamic','class','sites/all/modules/contrib/views/tests/test_plugins/views_test_plugin_access_test_dynamic.inc','views',10),('views_test_plugin_access_test_static','class','sites/all/modules/contrib/views/tests/test_plugins/views_test_plugin_access_test_static.inc','views',10),('views_ui','class','sites/all/modules/contrib/views/plugins/export_ui/views_ui.class.php','views_ui',0),('views_data_export_plugin_display_export','class','sites/all/modules/contrib/views_data_export/plugins/views_data_export_plugin_display_export.inc','views_data_export',0),('views_data_export_plugin_query_default_batched','class','sites/all/modules/contrib/views_data_export/plugins/views_data_export_plugin_display_export.inc','views_data_export',0),('views_data_export_plugin_style_export','class','sites/all/modules/contrib/views_data_export/plugins/views_data_export_plugin_style_export.inc','views_data_export',0),('views_data_export_plugin_style_export_csv','class','sites/all/modules/contrib/views_data_export/plugins/views_data_export_plugin_style_export_csv.inc','views_data_export',0),('views_data_export_plugin_style_export_xml','class','sites/all/modules/contrib/views_data_export/plugins/views_data_export_plugin_style_export_xml.inc','views_data_export',0),('EntityReferenceTaxonomyTestCase','class','sites/all/modules/contrib/entityreference/tests/entityreference.taxonomy.test','entityreference',0);
/*!40000 ALTER TABLE `registry` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `registry_file`
--

DROP TABLE IF EXISTS `registry_file`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `registry_file` (
  `filename` varchar(255) NOT NULL COMMENT 'Path to the file.',
  `hash` varchar(64) NOT NULL COMMENT 'sha-256 hash of the file’s contents when last parsed.',
  PRIMARY KEY (`filename`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Files parsed to build the registry.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `registry_file`
--

LOCK TABLES `registry_file` WRITE;
/*!40000 ALTER TABLE `registry_file` DISABLE KEYS */;
INSERT INTO `registry_file` VALUES ('includes/actions.inc','f36b066681463c7dfe189e0430cb1a89bf66f7e228cbb53cdfcd93987193f759'),('includes/ajax.inc','e9c0653a0df32a81577d64980d74ef4f2423573b15fc86e9d7aa65227b52f470'),('includes/archiver.inc','bdbb21b712a62f6b913590b609fd17cd9f3c3b77c0d21f68e71a78427ed2e3e9'),('includes/authorize.inc','a8f26e722ddba490cdc0fcf80238af45f0f88e977b2e0c90c0c21d9df3380748'),('includes/batch.inc','059da9e36e1f3717f27840aae73f10dea7d6c8daf16f6520401cc1ca3b4c0388'),('includes/batch.queue.inc','554b2e92e1dad0f7fd5a19cb8dff7e109f10fbe2441a5692d076338ec908de0f'),('includes/bootstrap.inc','9e0e1eeff97e3a14974eecf34ba9f98ce01c8683a5e91ade4b3851dba2af355f'),('includes/cache-install.inc','e7ed123c5805703c84ad2cce9c1ca46b3ce8caeeea0d8ef39a3024a4ab95fa0e'),('includes/cache.inc','0a70a291f7ce423d1aab4816ef06a6eaf58b454a03a1f419ff309c1147c4765b'),('includes/common.inc','5b2c5e7c61db64e89526811dd4d06ee040419c6cbc02dd26667ecc7d4b4621b5'),('includes/database/database.inc','a42754a5b98efe3092d0c9e1c3d965daeb8436c033b2baa3d41f564fc606a70c'),('includes/database/log.inc','4ecbdf9022d8c612310b41af575f10b0d4c041c0fbc41c6dc7e1f2ab6eacce6b'),('includes/database/mysql/database.inc','d4648a3212519b038654457b83466aabc1b928affdd56076c655ba3d8b79a54b'),('includes/database/mysql/install.inc','6ae316941f771732fbbabed7e1d6b4cbb41b1f429dd097d04b3345aa15e461a0'),('includes/database/mysql/query.inc','7d9ea18a7ff04b7aab6210abbd0313cb53325c19a47ff8ed6c0e591c6e7149c2'),('includes/database/mysql/schema.inc','d8d3904ea9c23a526c2f2a7acc8ba870b31c378aac2eb53e2e41a73c6209c5bd'),('includes/database/pgsql/database.inc','3c981696486d3ec21f508b47516fa078ffc885703179e5ef1ca5b894c89b2fe4'),('includes/database/pgsql/install.inc','585b80c5bbd6f134bff60d06397f15154657a577d4da8d1b181858905f09dea5'),('includes/database/pgsql/query.inc','cb4c84f8f1ffc73098ed71137248dcd078a505a7530e60d979d74b3a3cdaa658'),('includes/database/pgsql/schema.inc','8fd647e4557522283caef63e528c6e403fc0751a46e94aac867a281af85eac27'),('includes/database/pgsql/select.inc','fd4bba7887c1dc6abc8f080fc3a76c01d92ea085434e355dc1ecb50d8743c22d'),('includes/database/prefetch.inc','b5b207a66a69ecb52ee4f4459af16a7b5eabedc87254245f37cc33bebb61c0fb'),('includes/database/query.inc','128b5fdb90562d7f7a9e2662ff6f35251b1370ac215298e2c3297c87ebafd961'),('includes/database/schema.inc','7eb7251f331109757173353263d1031493c1198ae17a165a6f5a03d3f14f93e7'),('includes/database/select.inc','1c74fa55c7721a704f5ef3389032604bf7a60fced15c40d844aee3e1cead7dc6'),('includes/database/sqlite/database.inc','ed2b9981794239cdad2cd04cf4bcdc896ad4d6b66179a4fa487b0d1ec2150a10'),('includes/database/sqlite/install.inc','381f3db8c59837d961978ba3097bb6443534ed1659fd713aa563963fa0c42cc5'),('includes/database/sqlite/query.inc','523ff7c05aa2b2aca08cad3743b321868ec772856f2b1c7af908bb236c6919ad'),('includes/database/sqlite/schema.inc','238414785aa96dd27f10f48c961783f4d1091392beee8d0e7ca8ae774e917da2'),('includes/database/sqlite/select.inc','8d1c426dbd337733c206cce9f59a172546c6ed856d8ef3f1c7bef05a16f7bf68'),('includes/date.inc','18c047be64f201e16d189f1cc47ed9dcf0a145151b1ee187e90511b24e5d2b36'),('includes/entity.inc','0e11791647d4d216714ca11f3eb9702b09f8a617d70841c7efa8ff3a58342e0a'),('includes/errors.inc','395db372adfcfb0676d5a68b6843b6f141a7bb8f86cd36f2cfbd1e75de94e591'),('includes/file.inc','042fed00746880123a3e4d95f138a3d8bc169a77b9cbae98cd05c1840375297d'),('includes/file.mimetypes.inc','f88c967550576694b7a1ce2afd0f2f1bbc1a91d21cc2c20f86c44d39ff353867'),('includes/filetransfer/filetransfer.inc','4391b7228bd952fb351c9431a7c226b4e8a23d9a7307b9ffa63e097c17b25467'),('includes/filetransfer/ftp.inc','589ebf4b8bd4a2973aa56a156ac1fa83b6c73e703391361fb573167670e0d832'),('includes/filetransfer/local.inc','7cbfdb46abbdf539640db27e66fb30e5265128f31002bd0dfc3af16ae01a9492'),('includes/filetransfer/ssh.inc','002e24a24cac133d12728bd3843868ce378681237d7fad420761af84e6efe5ad'),('includes/form.inc','eb51334b963d875471481dc433266a80a3e0f467f35b931734407c5ca16e8393'),('includes/graph.inc','8e0e313a8bb33488f371df11fc1b58d7cf80099b886cd1003871e2c896d1b536'),('includes/image.inc','22c8ff48d46276b9bea1ad2cf4af9b65abcf69fb5ebca441259e774190fa5863'),('includes/install.core.inc','d0609ff9380160955e8ca91c262eea233ce218ce0a33f455bc60485f5a7659ba'),('includes/install.inc','23455f095ebd75c49ef8bf2a18145f77b6633670a5eb9eab860d907b0ba25f35'),('includes/iso.inc','f53653843c75e12aa0b05e7197c5aebdf794e2517b9902fc07994fb7cb8f3ed6'),('includes/json-encode.inc','02a822a652d00151f79db9aa9e171c310b69b93a12f549bc2ce00533a8efa14e'),('includes/language.inc','2660a308eefd99f1aec300d1f8e51365a4331ca8af2b9056e5df528cd5b03a89'),('includes/locale.inc','8cc571c114587f2b30e4e24db17e97e51e81f9cc395fa01f348aba12cee8523e'),('includes/lock.inc','daa62e95528f6b986b85680b600a896452bf2ce6f38921242857dcc5a3460a1b'),('includes/mail.inc','bb50727f20717ffa17cbe11ddb27bd004bd814fc26115c3fca4b06f4cec179fa'),('includes/menu.inc','1fa6f6b0ffc711e352b48ef7f78e399536ed91ba56ad7ed333e34ed7a93228c1'),('includes/module.inc','0033c3a573aa14076002ac5d8659ad00fd60daf3a74ea550dc16058e9ad7f7b2'),('includes/pager.inc','6f9494b85c07a2cc3be4e54aff2d2757485238c476a7da084d25bde1d88be6d8'),('includes/password.inc','aba5df25a237c14cc69335c4cf72d57da130144410ab04d10917d9da21cd606c'),('includes/path.inc','1d939d6b59b07ef41e71c9d616c2e9a34712dd81f6110e1a1f280613b3228738'),('includes/registry.inc','4ffb8c9c8c179c1417ff01790f339edf50b5f7cc0c8bb976eef6858cc71e9bc8'),('includes/session.inc','8293e6cc9f081ecdc4e8cfcdec885a79df01b9007030fe6b467a85c87ebb5d82'),('includes/stream_wrappers.inc','323e418fda2fdd29a44d8618f8855a92172c377eb745412d58ca55fdcaa8f2d1'),('includes/tablesort.inc','3f3cb2820920f7edc0c3d046ffba4fc4e3b73a699a2492780371141cf501aa50'),('includes/theme.inc','1ba1bf14159e30803ed6298f693b8a9a969f7f5afc3e714d7c74ac37a36626d9'),('includes/theme.maintenance.inc','d110314b4d943c3e965fcefe452f6873b53cd6a8844154467dfcbb2b6142dc82'),('includes/token.inc','a975300558711bb49406a5c7f78294648baa2e5c912cb66f0c78bb2991c0f3c3'),('includes/unicode.entities.inc','2b858138596d961fbaa4c6e3986e409921df7f76b6ee1b109c4af5970f1e0f54'),('includes/unicode.inc','3d5a4756f7af1f9de84f7614b6cd87449af43f4bb1e2a77bb2c73589f5826f61'),('includes/update.inc','132a2e54d9a7008ce3d71fdbcdcf3653a143b011508004b977f3493328488090'),('includes/updater.inc','d2da0e74ed86e93c209f16069f3d32e1a134ceb6c06a0044f78e841a1b54e380'),('includes/utility.inc','9b834814fd3f5ef10ce1946be30ef1ddf3f283c749f1ef1a4ebf845ecd524d59'),('includes/xmlrpc.inc','c5b6ea78adeb135373d11aeaaea057d9fa8995faa4e8c0fec9b7c647f15cc4e0'),('includes/xmlrpcs.inc','79dc6e9882f4c506123d7dd8e228a61e22c46979c3aab21a5b1afa315ef6639c'),('modules/block/block.test','b8fc64b16b03fc49d44f2fe4b3711736323effc5e0addbc3e74be91ec2bb3872'),('modules/color/color.test','013806279bd47ceb2f82ca854b57f880ba21058f7a2592c422afae881a7f5d15'),('modules/comment/comment.module','5fcc7c33a0d50bd2ac1bba73e061fa49f40c2ac994e05aa92ea95cae4c30f5d9'),('modules/comment/comment.test','1f41eca8bc1f0dbcd262e87305f8a415ad9c2325ff71e971de99f5d7bb12018c'),('modules/dashboard/dashboard.test','270378b5c8ed0e7d0e00fbc62e617813c6dec1d79396229786942bf9fb738e16'),('modules/dblog/dblog.test','e5b792ca4d34845b083e7d9faccc04e48e0c047e6c8bc8c726c1e33f82c82ed6'),('modules/field/field.attach.inc','d1d0d7e63ccbe1e184bd137adfd0b17434f7a85ff97c579155bb88130fc1f3c5'),('modules/field/field.module','6b495222b9370a3ef9e395473a7a576737d8375c7657987d0713bf73dbd96a82'),('modules/field/modules/field_sql_storage/field_sql_storage.test','8ede9843d771e307dfd3d7e7562976b07e0e0a9310a5cf409413581f199c897f'),('modules/field/modules/list/tests/list.test','9f366469763beb3fe0571d66318bac6df293fd15f4eb5cfe4850b9fb9a509f38'),('modules/field/modules/number/number.test','cb55fbc3a1ceed154af673af727b4c5ee6ac2e7dc9d4e1cbc33f3f8e2269146c'),('modules/field/modules/options/options.test','8c6dd464fdb5cca90b0260bcfa5f56941b4b28edd879b23a795f0442f5368d4c'),('modules/field/modules/text/text.test','9d74c6d039f55dd7d6447a59186da8d48bf20617bfe58424612798f649797586'),('modules/field/tests/field.test','7a152e80654bd0a35ba216405cbbe867f547f1e157586072275eaa349578df6b'),('modules/field_ui/field_ui.test','ca549daa46206221863098c6ee5da53a4c647a3016ee5903687804224a44dc9d'),('modules/filter/filter.test','f439e0d529cae5089990c7f0c5059ece953ae14c56e8a753d6375acf0f873560'),('modules/help/help.test','c6f03ece30548a6a345afcfac920d85afc418596a19dc4cf43f994391c5050d9'),('modules/menu/menu.test','b8ee602184584fab464900a946090dc1f3d81c15b8176004ee62022814632430'),('modules/node/node.module','c1324a338fd025592b879622e2c19c78e134e39666bfa1088b4dd4d1e51ba89b'),('modules/node/node.test','02479c7b9ec66baa6a9e12b049fb95e6adea0a07f530d92a7fa7665b23e443a0'),('modules/path/path.test','c05b26db575e93a73f2e4c8eaa6091b4fe8fc805f59620c2f7e1276cc206ba9d'),('modules/php/php.test','009f628f14137eb137d46c97e0ddef7a0c426707a7b4616c00c6d9446638f243'),('modules/rdf/rdf.test','358e2ae2069a15c6ba828f3428ab979632ece7aa0ba33a6a5bdbc1d065961373'),('modules/search/search.extender.inc','fea036745113dca3fea52ba956af605c4789f4acfa2ab1650a5843c6e173d7fe'),('modules/search/search.test','1fe9dfc982953f42f67d7eee9a855e7248373067ba55cfff001d8a750b83e695'),('modules/shortcut/shortcut.test','b506a253353066e1f995e7f0e3541dadb8ef3c3ff9cf795db96e26599a0b6b7a'),('modules/syslog/syslog.test','7503cfffcdff502e1b80632a3e56b7ffa8c0ea3e24bc3ba7f5f5f5ad5cd0750e'),('modules/system/system.archiver.inc','faa849f3e646a910ab82fd6c8bbf0a4e6b8c60725d7ba81ec0556bd716616cd1'),('modules/system/system.mail.inc','3c2c06b55bded609e72add89db41af3bb405d42b9553793acba5fe51be8861d8'),('modules/system/system.queue.inc','caf4feda51bdf7ad62cf782bc23274d367154e51897f2732f07bd06982d85ab1'),('modules/system/system.tar.inc','8a31d91f7b3cd7eac25b3fa46e1ed9a8527c39718ba76c3f8c0bbbeaa3aa4086'),('modules/system/system.test','ca539539bea3d2c070552f79dbae279e2872ba9d48af386c89ab6c1fc95488da'),('modules/system/system.updater.inc','e2eeed65b833a6215f807b113f6fb4cc3cc487e93efcb1402ed87c536d2c9ea6'),('modules/taxonomy/taxonomy.module','114919b1fc991d9914edd8a617bc4cd30eea5cd0b46c6e5d6c6fd7a0dff3d14a'),('modules/taxonomy/taxonomy.test','6b1d6fd0d683e252e7353e254cf1d42cdb220109f1357c45c6ce2391268df63c'),('modules/user/user.module','841c483c69dbe244f204fb139e0580151300dfad806ccb14b45ff72be89fd566'),('modules/user/user.test','3cc1cf5e5ea1b642ea1d306a330f8b054bac88b4af757048f3b1e816268c8cf5'),('sites/all/modules/contrib/admin_menu/tests/admin_menu.test','185f8244f7a086cda1bd9435ec529e8632598e9b09d1e0d7363b75cf87c04afb'),('sites/all/modules/contrib/block_class/block_class.install','b7c06c2f0ef1628db3e4096df5387356bc21cda297d7315be262b6c94a1f5a2f'),('sites/all/modules/contrib/block_class/block_class.module','317137ff3d573ce6f720a25d74c0f15dd0ca8bfca0ebf7fad891cf07d1d308a4'),('sites/all/modules/contrib/coder/coder.module','8bfa234c1cebfb7e51f3d00d1beddf5f8ad8cd2bf1c4e8e2c902b13d0b110083'),('sites/all/modules/contrib/coder/coder_review/tests/coder_review_security.test','250dcd38c0b43744c70b1fe4ffe70bb2820e43fed3dbb99e9d6b8b4bfef2d9ec'),('sites/all/modules/contrib/coder/coder_review/tests/coder_review_i18n.test','120e78914aed3f7c11ecc5389684c22c077862098bee1a46eac4b83a8d144740'),('sites/all/modules/contrib/coder/coder_review/tests/coder_review_comment.test','9b1edbb39e7fee4869a2e6924111a66bab6659e645c86d87ce41d1473a53a540'),('sites/all/modules/contrib/coder/coder_review/tests/coder_review_7x.test','c1b493d07d451740646dbf1d33d53d5ef4a091aafff9f06886b495edf8119064'),('sites/all/modules/contrib/coder/coder_review/tests/coder_review_6x.test','d2b66b13625c98cdb8ede951e7fd8a9d47de13eb74fb0965f82ec6c4a94ee1e7'),('sites/all/modules/contrib/coder/coder_review/tests/coder_review_test_case.tinc','abb1cdc7d62f2389718ed61abc2c9f189e4d3e1231d7fcb66305ad9bdcc6f44d'),('sites/all/modules/contrib/menu_attributes/menu_attributes.test','2ad598153e1ae5d47d734e15b1bffb30c96222386b51bb134e58c353957c12de'),('sites/all/modules/contrib/computed_field/computed_field.install','d2d3ee39d2593cf2c648e93dc86e1630f3e2496a948fe0203b6401ae39683ed5'),('sites/all/modules/contrib/computed_field/computed_field.module','43881db9bd7a986eac7c714fd7ec9341c06208b1b24d63585c4607478a7f919e'),('sites/all/modules/contrib/ctools/ctools_custom_content/plugins/export_ui/ctools_custom_content_ui.class.php','1b15f1595c6d1ca3abbd1439182d5613d5af7c3155d5f3e52ade4111833bc51b'),('sites/all/modules/contrib/ctools/includes/context.inc','9564cbebde8daa634b4c074c7fe197613d8c23caf60ad7a31e2c3a73c441204f'),('sites/all/modules/contrib/ctools/includes/math-expr.inc','3386323b01da62e02c9f3607cd7f0a0d46f1af90a107a07aed726b1fa8c28235'),('sites/all/modules/contrib/ctools/includes/stylizer.inc','e18f5a1b8af526751d7175354162c06c2013c96f62d9baa399564d8c45a1c90e'),('sites/all/modules/contrib/ctools/plugins/export_ui/ctools_export_ui.class.php','3d6d5df2fd5657b59023c8cb7f2d8f96a3f282f28307e5803cc9159297d6a2ab'),('sites/all/modules/contrib/ctools/views_content/plugins/views/views_content_plugin_display_ctools_context.inc','451bc0ca2cbfdba11159e339de3890480e009de853412034b81d4afe7c102809'),('sites/all/modules/contrib/ctools/views_content/plugins/views/views_content_plugin_display_panel_pane.inc','42725257f1ecd6093be2be28875ecf42ae8ec28e2d5a3f6c9f4aebf51a797e6b'),('sites/all/modules/contrib/ctools/views_content/plugins/views/views_content_plugin_style_ctools_context.inc','71a211a7602d33bd3a4adfdbbcd5f121bdfac8a2c47ec9f8cbaf74be6c83b05a'),('sites/all/modules/contrib/date/date_api/date_api.module','2b28cfc898ce41ca98406ce3271f4a0073cf8d07e91b9610c2c3319286ba5c09'),('sites/all/modules/contrib/date/date_api/date_api_sql.inc','fbf3de8c37ce4b59bfc3ef67ebd6cdc021985e9e6f1b22e0be521d33ccb9da3b'),('sites/all/modules/contrib/date/date_views/includes/date_views.views.inc','c5ee7311c718cf5ce049324215d0f4f75cb6284dc8078a7a5c0f91698c89524a'),('sites/all/modules/contrib/date/date_views/includes/date_views_argument_handler.inc','acc9d39134d2131fc8a1c3b4206f3db2edc574cf17b3b36a4b696bffed31af01'),('sites/all/modules/contrib/date/date_views/includes/date_views_argument_handler_simple.inc','e5dacce0e4b0848b647501da639b6aef6f361626f100221182417dc5fab797d9'),('sites/all/modules/contrib/date/date_views/includes/date_views_filter_handler.inc','73c4ff2d08493330b9e44851596e0c550c7901d8e98708ca2a1cf29cee4a251a'),('sites/all/modules/contrib/date/date_views/includes/date_views_filter_handler_simple.inc','9ee9806d74efcfafee45fba8e1f91f1956a595e1893fb60577a143820ebe93fe'),('sites/all/modules/contrib/date/date_views/includes/date_views_plugin_pager.inc','25baab739094a43b64ad8b3fde0946edaf43ad72de25594ffcd2d9893f459f0f'),('sites/all/modules/contrib/date/tests/date.test','2d46e3cb15f23762289621603ab82a2dba61e7d280a9cf2e4987b5b153b4568e'),('sites/all/modules/contrib/date/tests/date_api.test','ebaf0427701be69bd3dc8a766528d7347a87ee15c2f69b240188aa5ab1182cbd'),('sites/all/modules/contrib/date/tests/date_field.test','785a6cf0afcd4619a58263487e27e130ae0724f532018a5a127f24be1dbb4871'),('sites/all/modules/contrib/date/tests/date_timezone.test','760c3e761d122bafd2fab2056362f33424416a1407e7a1423df42acd03f84495'),('sites/all/modules/contrib/date/tests/date_validation.test','2e4d27c29192c9d55eb27b985d7e9838702c4324d36ed6e3a85999e9f25ada99'),('sites/all/modules/contrib/entity/entity.features.inc','b77e91ea988218fd939a4e5f283b2c745d53e39159af5ab770eda6b66fcb33cb'),('sites/all/modules/contrib/entity/entity.i18n.inc','41e0e62af7e2774f62b162d597bb3244551c280296b692b29d039a2c243d7059'),('sites/all/modules/contrib/entity/entity.info.inc','962cf92c630a2954c4e430164e1d04b8125eb1103dbefb7b954182b4382d072d'),('sites/all/modules/contrib/entity/entity.rules.inc','774199059d1b3ebe6d3fe7a49dbb1550df489055a3d066b5de54edda8dd7ba84'),('sites/all/modules/contrib/entity/entity.test','80139f908ab540b4a30300c027d33b87ab250bfcf4fb44ec18adae7844b1d635'),('sites/all/modules/contrib/entity/entity_token.module','0c1ad6fb6f8c430e47a81be6d08180883c5a1ee728ce8b5dd0775713b34fb862'),('sites/all/modules/contrib/entity/entity_token.tokens.inc','d9246ed9a7d4cfdf16370d3c68f991fb103838b6e2c9682c385d2144629504ee'),('sites/all/modules/contrib/entity/includes/entity.controller.inc','26df053bd4866bf94f57d6ae57bf2d7e3230e74723956ad03fd606a05b41ecf5'),('sites/all/modules/contrib/entity/includes/entity.inc','71161b01ef9e007fd3d8e40b5ae8652194da7cb208c9f9538b63f90d8f0e6ac7'),('sites/all/modules/contrib/entity/includes/entity.ui.inc','b2bdd28eb3af34cb7c2ff1e58e0cf679d26cfd68cd9414dc3abfbd297443874d'),('sites/all/modules/contrib/entity/includes/entity.wrapper.inc','fb771c3dc1ea5d0444bc97246b4cf0d8a4609fc66d24ed2b0de507dcc8fb776c'),('sites/all/modules/contrib/entity/views/entity.views.inc','c2949770db351bc894ab5d715a3e9c9c97c4477e0c42cd90347160ddd228bbfa'),('sites/all/modules/contrib/entity/views/handlers/entity_views_field_handler_helper.inc','69d5ac25d8686ee43be607d682795b2cae0278500392f5f7970ac9f45913ee84'),('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_area_entity.inc','e86aceccf21cbbca4bef7d2c049dc93a8f5a01c6bc73e7b2f92f5659a9eedd03'),('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_boolean.inc','b28b8eee8761ba7a6af35d97ab7aaee28406e6c227271f9769818560626c5791'),('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_date.inc','b0f5be5b399de94934b24e84c8cf6053a043f6b00c60dcffa752daeafdd38778'),('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_duration.inc','6a7f83e4ce141428d3d782db0c71f3cf4b141eff4f551b826fef7e52ac728e01'),('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_entity.inc','f0ea06a0d67b0f4f498414def4d0989aad56d97780107b2fbabdaafc807adbf2'),('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_field.inc','893121efbce2a7181e31147bade260c9cc657cbd33b0d254cb28b2650e57566d'),('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_numeric.inc','f14e2b063930e8820af381b4f5e83c7278440e7804ab88cfde865b6c94e7c0f6'),('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_options.inc','16317359cf59afb290d78eb61228f93dda408081e8c2f88db2f90a60d68d31d6'),('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_text.inc','ae26b8a9a86c36a166644a1f5a9bae0676f535345c092d882df0177ded305bdd'),('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_field_uri.inc','79ecaa3eb17dfdd0ca077351b75a2c0adf411ebc04720e7cc0e2397674225f24'),('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_relationship.inc','b69bc538d1e1e0f91f8485ca54c3b6e2be025caa47619734c467377cf89041b9'),('sites/all/modules/contrib/entity/views/handlers/entity_views_handler_relationship_by_bundle.inc','25aebf66cd2437bd5867fef8f0e0e25d4308b9ce491cc79801e9d3cbed68bcba'),('sites/all/modules/contrib/entity/views/plugins/entity_views_plugin_row_entity_view.inc','ba557790215f2658146424d933e0d17787a0b15180c5815f23428448ccf056a0'),('sites/all/modules/contrib/entityreference/entityreference.migrate.inc','465cd039e590498a18f80d737d2c2a341c06a131d791814745923759fda21e5f'),('sites/all/modules/contrib/entityreference/plugins/behavior/abstract.inc','a7959ddece2ce3490f92d916162e07aed313e28ca299ca0375bad633b42d93e3'),('sites/all/modules/contrib/entityreference/plugins/behavior/EntityReferenceBehavior_TaxonomyIndex.class.php','92fa0cf46ecdf6200659646e6666c562ea506c40efa41a8edd4758dc0c551b92'),('sites/all/modules/contrib/entityreference/plugins/behavior/EntityReferenceBehavior_ViewsFilterSelect.class.php','f6805f62bbd376d98676706602aeb1c4d16e645acb429d31032bc3fb37d850d3'),('sites/all/modules/contrib/entityreference/plugins/selection/abstract.inc','7ecf94f5dc3456e4a5c87117d19deb98c368617fb07d610505b1dfa351f14a0b'),('sites/all/modules/contrib/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','66a3452cd5aede15e1098a1cf7799e9761d71200bbc1fd0fe818aa7f728684a2'),('sites/all/modules/contrib/entityreference/plugins/selection/EntityReference_SelectionHandler_Views.class.php','b1878655779d07b8210ab81c3dd9aae931250f328b044114045a4780a84a0ed7'),('sites/all/modules/contrib/entityreference/plugins/selection/views.inc','7bbe8900b6b71c2d41e370deaccca869884d0fe9ca81772d7d5bca5f58ec1cd8'),('sites/all/modules/contrib/entityreference/tests/entityreference.admin.test','bcd6516be3099ae87a4c3d41add08edd17eafb4244db8442c5dc15f19ebde7ae'),('sites/all/modules/contrib/entityreference/tests/entityreference.handlers.test','d7109c70c59d3fd4aee6e073ad79a125e78e337f097f89363c1a9e15f973492d'),('sites/all/modules/contrib/coder/coder_review/tests/coder_review_style.test','0bc3767c43b8e0e41818382805e5424eb91f48aa4e38e829184828489cacce1e'),('sites/all/modules/contrib/entityreference/views/entityreference_plugin_display.inc','5182b7bc5def89d3d56be33d514bca85d20f92590ed0d1f8cce2710174077564'),('sites/all/modules/contrib/entityreference/views/entityreference_plugin_row_fields.inc','7f5a58c099c2df6fd1c3ae285197a4648841d44fa107bcb2064bc1edf435ea8b'),('sites/all/modules/contrib/entityreference/views/entityreference_plugin_style.inc','a8d57a77bad20ed2c365a9e4edfac1ce5928dd519dc4d5b023f8604b89b52f7c'),('sites/all/modules/contrib/eva/eva_plugin_display_entity.inc','6684d9b38becc0f1f642dd6421d73f756771dfad66ffee2be1191276e62ab4b4'),('sites/all/modules/contrib/field_group/field_group.features.inc','c8fb1d29fddfd9c1b82806b55979b3b5ec34d4a94f8f2307ae2838cb3b21c966'),('sites/all/modules/contrib/field_group/field_group.field_ui.inc','72dccb0bd7668b403134b9ff0aa77bff107eea07cb9d96d1f2c660058712496b'),('sites/all/modules/contrib/field_group/field_group.install','156bd483f3a88d8931b7f439cd1e38141ab567cfbb7dcb9bc93823f07002cd36'),('sites/all/modules/contrib/field_group/field_group.module','67a27fb444148872dfbb2627370dd22de67893567b08f7e76c3ea30de15a1cf8'),('sites/all/modules/contrib/field_group/field_group.test','3d26d8d1408bcf661c07db962ce287bdd5cc513329a8af4d357e7a66fa068244'),('sites/all/modules/contrib/login_destination/login_destination.admin.inc','f5fedd26173ba14b5e2ce38ef38af17c3f3abd232a5f793b345d46025593ea19'),('sites/all/modules/contrib/login_destination/login_destination.module','b99b24c4c32a11f6e25d504bbd1e53e3faff8254ac82a7d3bd999b9bd6febb42'),('sites/all/modules/contrib/coder/coder_review/tests/coder_review_sql.test','acc29d6b1b217954a56620b1ba4fa755dcfdd93919c2ae221286ebb4fee38ffa'),('sites/all/modules/contrib/module_filter/css/module_filter.css','69609136efe52982305062cdf17756ad168aaf35920b7840ea1323e22b0ea0d0'),('sites/all/modules/contrib/module_filter/css/module_filter_tab.css','1789901bbb6bed007fff82895bf6d3ecfed7e237b408930c6c51a1c08e648487'),('sites/all/modules/contrib/module_filter/js/module_filter.js','c8fc76388a4763c9821e9cf6ff31865dd89cbc410a067848798118d14f372c40'),('sites/all/modules/contrib/module_filter/js/module_filter_tab.js','14967d461c738e66bfb2f800c7dcab9a641c1f015cd17ea6867c5f593c4fb9d5'),('sites/all/modules/contrib/module_filter/module_filter.admin.inc','30b1be9c743e4a4d468c2382cbe74666b45e50cfd9251deb0b1a149357c9d03a'),('sites/all/modules/contrib/module_filter/module_filter.install','b05b0010641a06ed8f5d67403cae6c3a3a27aa687835b8f012136d3f68a3cbb3'),('sites/all/modules/contrib/module_filter/module_filter.module','b84535147bd21ed59818d94c2f7aede7c75d8ea0b334c37d0b9f25912217a4aa'),('sites/all/modules/contrib/module_filter/module_filter.theme.inc','1eb90ba4ed6ae900a035fe81bcfaaf16c2ecc84ee91bb1f240dbdf6300e8a69b'),('sites/all/modules/contrib/panels/includes/common.inc','fcc6c2923d7f567514109f1a333f518c9044df463d7bfef7b7d2f3f1515060c8'),('sites/all/modules/contrib/panels/includes/legacy.inc','dc65c1a82f4a063f9cbebbd8a0ceb512a3b41a1ee2603ec8045034412a791aab'),('sites/all/modules/contrib/panels/includes/plugins.inc','d08bc486c44016463a4af61c5c399e7f7b52a04a65a17a5e8e810e1a3c2d1158'),('sites/all/modules/contrib/panels/panels.module','0312b8d317e75f19196d8d8aaba3e9f895ca59c1da79f391d7181d1d5ef5ea34'),('sites/all/modules/contrib/panels/panels_ipe/panels_ipe.module','7e2b39b7936059831fde07d8e105d7871fe7084f4d4809db25cbb534f219976b'),('sites/all/modules/contrib/panels/panels_ipe/plugins/display_renderers/panels_renderer_ipe.class.php','db86a41558641a0ec6af5f4b806feba41babc1c5ec3264abff68a5101bbf7e0c'),('sites/all/modules/contrib/panels/panels_mini/plugins/export_ui/panels_mini_ui.class.php','c0d527cb81f4a01bf680223a818a4c48724bbc62732834d540c03084f720d6f3'),('sites/all/modules/contrib/panels/panels_node/panels_node.module','8018f05a4b9dfe8bbbcdb4efe1af233cda92e4e29cfb182e955e90783174d085'),('sites/all/modules/contrib/panels/plugins/display_renderers/panels_renderer_editor.class.php','962f6a761b008182f18cf90063e2b9eb289a9e9a7de69591a75735ccc449a64a'),('sites/all/modules/contrib/panels/plugins/display_renderers/panels_renderer_simple.class.php','420aeca22872635ebd5ab3ce719dd8e1d7fef339271db5f20a0834b812084a6e'),('sites/all/modules/contrib/panels/plugins/display_renderers/panels_renderer_standard.class.php','7497764e0b1afa55cab7126035b5957869550ab747db48299a9a336e97b48770'),('sites/all/modules/contrib/panels/plugins/export_ui/panels_layouts_ui.class.php','c68da9f716ede2dab44e9b3d410374ab82d50f52657f6f363f1df6cb21c6fa9f'),('sites/all/modules/contrib/panels/plugins/views/panels_views_plugin_row_fields.inc','a30d798fcbc5e0d44894166e31bc2ab9f9c12b1b34629bf5a7b745374e85408b'),('sites/all/modules/contrib/pathauto/pathauto.test','9204240a755119e02eae68c77e7b9ab816747423ccaaf51742231fbaef1f604f'),('sites/all/modules/contrib/r4032login/r4032login.install','d14f2d902ca263adb44af751c02126f8df79a82514c594cbf068234363eb53dc'),('sites/all/modules/contrib/r4032login/r4032login.module','6357969ea72594238184dcb5a7f28c43a6ee7b47271eb22e8a9bd0d8d95d40e8'),('sites/all/modules/contrib/references/node_reference/node_reference.test','8037775d70f7e45db33799c501deedc59fe5a5f6431b94ac0d2feee1fff3459d'),('sites/all/modules/contrib/references/views/references_handler_argument.inc','231031508b499e882e2b80e66c000c38577ed9a64975ea43d0b7441bff1a98d3'),('sites/all/modules/contrib/references/views/references_handler_relationship.inc','e67c5293c59c179005999d67465946793b99f92b5c9421bc5346eaf9dfea14db'),('sites/all/modules/contrib/references/views/references_plugin_display.inc','c0abab2ec372f0c5382ec2fc48593d635806be65e0e806874f095315b8a87896'),('sites/all/modules/contrib/references/views/references_plugin_row_fields.inc','2bff7a5f9a7357f8618b514a437807156d940ba76fceb34720d2a1de10a6b679'),('sites/all/modules/contrib/references/views/references_plugin_style.inc','b0dad018a03974bde55d6b20d50a33187a856d59b42cb57287cf3b5644428f4d'),('sites/all/modules/contrib/search_api/includes/callback.inc','20319d6323235d4d0c632e1fb17ee3c2c856a910b13c9cf0cdfcfc702236f6e9'),('sites/all/modules/contrib/search_api/includes/callback_add_aggregation.inc','e507fb87377812b50caa235a218218d00cb0bcf778e01a305a11eeddc82504af'),('sites/all/modules/contrib/search_api/includes/callback_add_hierarchy.inc','6509d9507fe6d7241192d07042d603fc0371571a63aed5e2488b67cfbc7b1fa4'),('sites/all/modules/contrib/search_api/includes/callback_add_url.inc','20c294f95dd52d7c4660269f13842f1ee6c5e3178ebcc9dd5c6d573f81b775d1'),('sites/all/modules/contrib/search_api/includes/callback_add_viewed_entity.inc','2e6da2dbff2f2e6aab3e405f99ae06cb4a9551916ffb6aae83713eaad0e6e073'),('sites/all/modules/contrib/search_api/includes/callback_bundle_filter.inc','45ca38a742423ce4d0e5c5359e6b3cae110b746880cc2e4088ae5af08bbd6152'),('sites/all/modules/contrib/search_api/includes/callback_language_control.inc','95f6c4c3e688529a6793c7f1ee37357a4dc78f8d588df9df77ddbfe6551507fe'),('sites/all/modules/contrib/search_api/includes/callback_node_access.inc','2df20b21e626e4915ea8e506a094885c4cff17fcc0c51e4a3788665d9a2bff33'),('sites/all/modules/contrib/search_api/includes/callback_node_status.inc','4f72573d05f2daac27257ecf2eedd3b16e646533d450330557a61888add80595'),('sites/all/modules/contrib/search_api/includes/datasource.inc','01ef6929c53dbf02c8b3b9e510e1c7150ed37f5037c3c530702811f123533eb4'),('sites/all/modules/contrib/search_api/includes/datasource_entity.inc','60a7c92a593c91be41bdb1a0758c6584ce438806864f7e4e2849873d02197438'),('sites/all/modules/contrib/search_api/includes/datasource_external.inc','3448c7e313723bd84f929250189e6b8391e8878e9e45689d45c6df4457b91b09'),('sites/all/modules/contrib/search_api/includes/exception.inc','69fe655d0a2870098f3578a51109af3ad48f8decf3a7825b58b262911d636a10'),('sites/all/modules/contrib/search_api/includes/index_entity.inc','0466eb776e14dc6916bc2a9e7f754fea84deadbce72709f7f2e8b3e2036cf6fb'),('sites/all/modules/contrib/search_api/includes/processor.inc','fc1bc1a283fc0f49804d4afbcd409280e0815a3ec67a53c8c329bac53a2606f6'),('sites/all/modules/contrib/search_api/includes/processor_html_filter.inc','4c0986a00ecd146a40ee6679d68e28d63840406578d128a8ebf5efd6b8d7c8aa'),('sites/all/modules/contrib/search_api/includes/processor_ignore_case.inc','bbe21476015952a29481c14ced10d2417dae5255537941c2e7a2a7f9c0205cda'),('sites/all/modules/contrib/search_api/includes/processor_stopwords.inc','c930e4c3e3d752e96bebec1e2da70f91ee3425f3f32ea8b8ca8ec07daf376112'),('sites/all/modules/contrib/search_api/includes/processor_tokenizer.inc','d59eefd80fde7588f90d4855e8ff395a0770e2a9c958a734aedbcfbd0236aa1b'),('sites/all/modules/contrib/search_api/includes/query.inc','3e6b1b591dacde71b12c8c273fb16b6f88bd511604e8b3006fd7c9181ab0ffb1'),('sites/all/modules/contrib/search_api/includes/server_entity.inc','653866d1cea6b9ec4ba77984320ae23f0fdd2b56553509f42b78015c98659f39'),('sites/all/modules/contrib/search_api/includes/service.inc','7947672bec15b77987507d4d950c8e02b6a63beb049f97eae1dc1091ab572272'),('sites/all/modules/contrib/search_api/search_api.test','7b98cc63ab47cfed0914090b9e50a51490711f689f214c5912d8d1d7950bd0f6'),('sites/all/modules/contrib/token/token.install','4dda5878d48025dfc72faeda487f5f28c19318517b37a3da16aacd6e2c08fc2c'),('sites/all/modules/contrib/token/token.module','eafa90a09b9e0eb8a19af1d56badec676744bf7a598333ef6a82e173789b382c'),('sites/all/modules/contrib/token/token.pages.inc','4aefd97cec04c5483635697449a7616a9616e17a5826e82ddffa42825d358637'),('sites/all/modules/contrib/token/token.test','a4d7c5d27809497c2535a66223de49a0ad677d7e7e00b1537b6fd112fba8d60a'),('sites/all/modules/contrib/token/token.tokens.inc','203fae107b8947b3e8a5762f127d09985fa968feb437f129ca677cd40cf3ff1d'),('sites/all/modules/contrib/unique_field/tests/core.test','bea405653528248562e988e5d7d5f9d809cb9fa4fef2c72d6c3ff4f05695744c'),('sites/all/modules/contrib/unique_field/tests/date.test','76b4ac71f1e120cad0efb10fa109f9baa908904d09fd63d8235c96de7dc2d418'),('sites/all/modules/contrib/unique_field/tests/references.test','7bbfc8ff919bfffd9990d111e9daa5f7f742ddff42681442d62dca4889ad64f4'),('sites/all/modules/contrib/unique_field/unique_field.install','d7a1a72ca472942bf3b6a31463c22644e7561462432b760b5db690d68158585c'),('sites/all/modules/contrib/unique_field/unique_field.module','1844523eab69543837246b3ed9afa98bde48de97e60f620674d2ae3e06939224'),('sites/all/modules/contrib/views/handlers/views_handler_area.inc','95d4374c805c057c9855304ded14ce316cdee8aca0744120a74400e2a8173fae'),('sites/all/modules/contrib/views/handlers/views_handler_area_result.inc','836747c024cc153ec4516737da0c42a864eb708e0b77d2f8ba606411c57356a2'),('sites/all/modules/contrib/views/handlers/views_handler_area_text.inc','32ffb78483d4c993e7f6582f218991a3a342784b797f9c5f06f1771880ccfc36'),('sites/all/modules/contrib/views/handlers/views_handler_area_text_custom.inc','35b702060c192b0adf6601ed437d0a02effd3accb71c07d6156013c8be9d5a15'),('sites/all/modules/contrib/views/handlers/views_handler_area_view.inc','a6a4a618c96a5657eaa881aa0836663600629529ebfd943c91303a11171974d5'),('sites/all/modules/contrib/views/handlers/views_handler_argument.inc','5858d2d1ad3ea0321532da0f66c4d2ef2b2a208e941789b37341b76c783c2d42'),('sites/all/modules/contrib/views/handlers/views_handler_argument_date.inc','1b423d5a437bbd8ed97d0bfb69c635d36f15114699a7bc0056568cc87937477d'),('sites/all/modules/contrib/views/handlers/views_handler_argument_formula.inc','5a29748494a7e1c37606224de0c3cac45566efe057e4748b6676a898ac224a61'),('sites/all/modules/contrib/views/handlers/views_handler_argument_group_by_numeric.inc','b8d29f27592448b63f15138510128203d726590daef56cf153a09407c90ec481'),('sites/all/modules/contrib/views/handlers/views_handler_argument_many_to_one.inc','b2de259c2d00fe7ed04eb5d45eb5107ce60535dd0275823883cc29b04d1a3974'),('sites/all/modules/contrib/views/handlers/views_handler_argument_null.inc','26699660fd0915ec078d7eb35a93ef39fd53e3a2a4841c0ac5dbf0bb02207bee'),('sites/all/modules/contrib/views/handlers/views_handler_argument_numeric.inc','ae23d847fa0f1e92baec32665a8894e26660999e338bebffb49ee42daac5a063'),('sites/all/modules/contrib/views/handlers/views_handler_argument_string.inc','f8fe4daf0a636cc93d520a0d5ff212840d8bdaa704ddc3c59a24667f341ed3a1'),('sites/all/modules/contrib/views/handlers/views_handler_field.inc','cfb79dda88a256829d4dfdb6cb3c550f4df6b81b63c2c68bcdea8960e8636cc6'),('sites/all/modules/contrib/views/handlers/views_handler_field_boolean.inc','5ed94bd3d3f885a9f7a7952ff64b099e586f0617ed0198af87dc78aaa4dc4c76'),('sites/all/modules/contrib/views/handlers/views_handler_field_contextual_links.inc','9752231bd248bcbc5c7282361098350f080706e3886d20753c5b2059adb10c00'),('sites/all/modules/contrib/views/handlers/views_handler_field_counter.inc','fcfd07c8a20b91819af375c5e1edc33ec7e5b6ee48f419f6183f3401abf9af42'),('sites/all/modules/contrib/views/handlers/views_handler_field_custom.inc','a3d25fc20401ae0a1af4b7d6e83376a5b7dc18ab0aed17a3c6d81e2314cf19f8'),('sites/all/modules/contrib/views/handlers/views_handler_field_date.inc','ea37efb7819df9a4c2b6f688ec101964474dc7df13e92824913f783314d80740'),('sites/all/modules/contrib/views/handlers/views_handler_field_entity.inc','909ab36aff896ad8fa4306d95a052172ec27e471ab385a035fcadef8d019e0f9'),('sites/all/modules/contrib/views/handlers/views_handler_field_machine_name.inc','df2fe47cf9c6d2e7de8627c08da809fb60883c38697340966f303c223e22aee4'),('sites/all/modules/contrib/views/handlers/views_handler_field_markup.inc','a0c652fdf47f7efe35bbf2371f00e230409fe90ea0038eb101bf0c93ae0718e9'),('sites/all/modules/contrib/views/handlers/views_handler_field_math.inc','c0f1cd82305ecc2378a7346ed0e4e5503c031b155d53cbfee2c46f82e7996ce4'),('sites/all/modules/contrib/views/handlers/views_handler_field_numeric.inc','51311e98172a3f2b9f8d406e4c64f2bc9d1243ab8003e1d421bf6ffa5f0100df'),('sites/all/modules/contrib/views/handlers/views_handler_field_prerender_list.inc','0fe605bf457886fbca5f041a422fc51c6a1927654dcd06cbfc619496fe57de0e'),('sites/all/modules/contrib/views/handlers/views_handler_field_serialized.inc','ad3d82a9f37ae4c71a875526c353839da2ff529351efc7861f8b7c9d4b5a47db'),('sites/all/modules/contrib/views/handlers/views_handler_field_time_interval.inc','280d569784312d19dabfb7aeb94639442ae37e16cba02659a8251de08a4f1de2'),('sites/all/modules/contrib/views/handlers/views_handler_field_url.inc','7ca57a8dcc42a3d1e7e7ec5defa64a689cb678073e15153ff6a7cafe54c90249'),('sites/all/modules/contrib/views/handlers/views_handler_filter.inc','70c93c35ffd8829e9e1bb0d8be80ff1641a868abecb41924c3cb2fc513f521ab'),('sites/all/modules/contrib/views/handlers/views_handler_filter_boolean_operator.inc','f4ca59e4e1f91f219a1b33690a4ad412269946804fe7cacf24f2574b2c6d8599'),('sites/all/modules/contrib/views/handlers/views_handler_filter_boolean_operator_string.inc','306ce393a7a4f565fa3eaa4ede1bc7fb4b7f91c65c65f759cab864532bc9d182'),('sites/all/modules/contrib/views/handlers/views_handler_filter_combine.inc','da924ce0b5095b16f1ccd58f58cd34a73da9a9cf19033fbb66ed41ce10c62c51'),('sites/all/modules/contrib/views/handlers/views_handler_filter_date.inc','e8f6b4181f3661155fd3b94355b2707441e87b2a151af669610a26eb0fba6674'),('sites/all/modules/contrib/views/handlers/views_handler_filter_entity_bundle.inc','02db977a67a09f70bdc8e2bbc46a05fff8a6d8bd6423308c95418476e84714a3'),('sites/all/modules/contrib/views/handlers/views_handler_filter_equality.inc','2100cdd7f5232348adae494c5122ba41ff051eee0a8cc14aeaf6a66202cb7ed1'),('sites/all/modules/contrib/views/handlers/views_handler_filter_group_by_numeric.inc','9401c4c0fe0d678898e5288ef8152784a12e0743df21dec15457353eb2cdb01d'),('sites/all/modules/contrib/views/handlers/views_handler_filter_in_operator.inc','8fd7f075468bddde5c4208b1c3a6105f8fea0ac0c214452a37c00fc2f3453a7d'),('sites/all/modules/contrib/views/handlers/views_handler_filter_many_to_one.inc','b4a415c2824195d3d7d0e37ada9d69ebec0b9cd833ebcac2439efc20aac15595'),('sites/all/modules/contrib/views/handlers/views_handler_filter_numeric.inc','b2fbaf1e4e4c3f9444f384239cd23213e23b7980802791b8a71e231d2a2a8c8d'),('sites/all/modules/contrib/views/handlers/views_handler_filter_string.inc','140006335ac5b19b6253b431afde624db70385b9d22390b8c275296ae469cc7b'),('sites/all/modules/contrib/views/handlers/views_handler_relationship.inc','4fefdb6c9c48b72dcfe86484123b97eb5f5b90b6a440d8026d71f74dccbd1cd6'),('sites/all/modules/contrib/views/handlers/views_handler_relationship_groupwise_max.inc','47dcfe351159b10153697c17b3a92607edb34a258ba3b44087c947b9cc88e86f'),('sites/all/modules/contrib/views/handlers/views_handler_sort.inc','06aab8d75f3dce81eb032128b8f755bfff752dcefc2e5d494b137bca161fdefa'),('sites/all/modules/contrib/views/handlers/views_handler_sort_date.inc','d7e771abf74585bd09cc8e666747a093f40848b451de8ba67c8158317946f1b2'),('sites/all/modules/contrib/views/handlers/views_handler_sort_group_by_numeric.inc','4ba1c38c9af32789a951b8f9377e13631ae26bf1dac3371b31a37ead25b32eb8'),('sites/all/modules/contrib/views/handlers/views_handler_sort_menu_hierarchy.inc','ccd65ea3b3270366b7175e2cd7cc9167a09c27e1486949e4a05495ff5c7be5c1'),('sites/all/modules/contrib/views/handlers/views_handler_sort_random.inc','05a00c3bf76c3278ae0ce39a206a6224089faf5ac4a00dd5b8a558f06fab8e46'),('sites/all/modules/contrib/views/includes/base.inc','edb2afb73e9a7bb1c1ed29eca475f3101b360e3b212ee28d5eb3de1c8c13c0cf'),('sites/all/modules/contrib/views/includes/handlers.inc','544a811db6cb757137fb342e3b500df01e5506a6ef4eec85c04f8e410a6af75a'),('sites/all/modules/contrib/views/includes/plugins.inc','bb12703a4a4e8bbc42ecc8ce27bf98546d9ea024324f4d03ba77348ec18b328c'),('sites/all/modules/contrib/views/includes/view.inc','b4cfd71194b31cc7f69e78e5a08eadb36d4c14ff4f95c9cfe0187db35c487bd8'),('sites/all/modules/contrib/views/modules/aggregator/views_handler_argument_aggregator_category_cid.inc','97acf41d6694fd4451909c18b118f482db9f39aa4b8c5cfa75d044d410c46012'),('sites/all/modules/contrib/views/modules/aggregator/views_handler_argument_aggregator_fid.inc','c37def91d635b01db36809141d147d263cc910895e11c05e73d703e86b39fd43'),('sites/all/modules/contrib/views/modules/aggregator/views_handler_argument_aggregator_iid.inc','6bcf0f512b6561384c06ebe77675454bb4901a8c9320cdd28d88e41461446437'),('sites/all/modules/contrib/views/modules/aggregator/views_handler_field_aggregator_category.inc','252b30b832d8c0097d6878f5d56beecfc8cc1fc7cc8b5a4670d8d95a80b4f17d'),('sites/all/modules/contrib/views/modules/aggregator/views_handler_field_aggregator_title_link.inc','1bb18967b11f2f4de62075d27e483f175b5e3431622c2e5e8292afcd000beadf'),('sites/all/modules/contrib/views/modules/aggregator/views_handler_field_aggregator_xss.inc','2db2e1f0500e0a252c7367e6a92906870b3247f9d424f999c381368ee2c76597'),('sites/all/modules/contrib/views/modules/aggregator/views_handler_filter_aggregator_category_cid.inc','7c7c0690c836ac1b75bca3433aca587b79aec3e7d072ce97dc9b33a35780ad4f'),('sites/all/modules/contrib/views/modules/aggregator/views_plugin_row_aggregator_rss.inc','591e5bb7272e389fe5fc2b563f8887dbc3674811ffbb41333d36a7a9a1859e56'),('sites/all/modules/contrib/views/modules/book/views_plugin_argument_default_book_root.inc','bd3bd9496bf519b1688cf39396f3afa495a29c8190a3e173c0740f4d20606a53'),('sites/all/modules/contrib/views/modules/comment/views_handler_argument_comment_user_uid.inc','5e29f7523010a074bda7c619b24c5d31e0c060cdbe47136b8b16b2f198ed4b4a'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_comment.inc','a126d690cc5bf8491cb4bee4cc8237b90e86768bebbbecb8a9409a3c1e00fa9e'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_depth.inc','1dc353a31d3c71c67d0b3e6854d9e767e421010fbbf6a8b04a14035e5f7c097f'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_link.inc','1f7382f7cb05c65a7cba44e4cd58022bbc6ce5597b96228d1891d7720510bf0e'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_link_approve.inc','f6db8a0b4dd9fffba9d8ecb7b7363ba99d3b2dc7176436a0a6dd7a93195a5789'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_link_delete.inc','905a4cb1f91a4b40ee1ca1d1ded9958ae18e82286589fec100adb676769b1fe9'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_link_edit.inc','8139c932cde20f366a3019111c054b1ed00dbc0c40634b91239b400243b7723a'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_link_reply.inc','8807884efb840407696c909b9d5d07f60bde9d7f385a59eca214178ce5369558'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_node_link.inc','64746ff2b80a5f8e83b996a325c3d5c8393934c331510b93d5815ea11c1db162'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_comment_username.inc','1ce3fa61b3933a3e15466760e4c5d4a85407ba4c8753422b766fc04395fa4d02'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_last_comment_timestamp.inc','30c55ec6d55bf4928b757f2a236aab56d34a8e6955944a1471e9d7b7aed057c0'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_ncs_last_comment_name.inc','82025f3ad22b63abc57172d358b3f975006109802f4a5ecac93ce3785c505cae'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_ncs_last_updated.inc','facfbc5defd843f4dfb60e645f09a784234d87876628c8de98d2dfa6bb98a895'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_node_comment.inc','0cf9e8fb416dca35c3b9df3125eb3a8585f798c6a8f8d0e1034b1fccb5cec38b'),('sites/all/modules/contrib/views/modules/comment/views_handler_field_node_new_comments.inc','e0830d1f70dea473e46ab2b86e380ef741b2907f033777889f812f46989f2ff7'),('sites/all/modules/contrib/views/modules/comment/views_handler_filter_comment_user_uid.inc','f526c2c4153b28d7b144054828261ba7b26566169350477cd4fb3f5b5f280719'),('sites/all/modules/contrib/views/modules/comment/views_handler_filter_ncs_last_updated.inc','9369675dfee24891fe19bddf85a847c275b8127949c55112ae5cb4d422977d24'),('sites/all/modules/contrib/views/modules/comment/views_handler_filter_node_comment.inc','70706c47bad9180c2426005da6c178ed8d27b75b28cb797ca2a1925a96dcef09'),('sites/all/modules/contrib/views/modules/comment/views_handler_sort_comment_thread.inc','a64bc780cba372bd408f08a5ea9289cdf3d40562bdf2f7320657be9a9f6c7882'),('sites/all/modules/contrib/views/modules/comment/views_handler_sort_ncs_last_comment_name.inc','9f039e8b8a046c058fda620804e3503be7b3e7e3e4119f0b015ccbae0922635b'),('sites/all/modules/contrib/views/modules/comment/views_handler_sort_ncs_last_updated.inc','fa8b9c3614ad5838aa40194940d9dc6935175a16e141ac919f40e74a7428c4e3'),('sites/all/modules/contrib/views/modules/comment/views_plugin_row_comment_rss.inc','ab97ac0ed4e6d7f2d44dc4ae9c5a84fe5658b739e1b609e5a877df528c3aa970'),('sites/all/modules/contrib/views/modules/comment/views_plugin_row_comment_view.inc','82d7296fa3109ca170f66f6f3b5e1209af98a9519bb5e4a2c42d9fc0e95d7078'),('sites/all/modules/contrib/views/modules/contact/views_handler_field_contact_link.inc','ec783b215a06c89c0933107a580c144051118305dd0129ac28a7fea5f95a8fd5'),('sites/all/modules/contrib/views/modules/field/views_handler_argument_field_list.inc','eff5152a2c120425a2a75fe7dbcb49ed86e5d48392b0f45b49c2e7abee9fa72b'),('sites/all/modules/contrib/views/modules/field/views_handler_argument_field_list_string.inc','534af91d92da7a622580ab8b262f9ef76241671a5185f30ba81898806c7b7f15'),('sites/all/modules/contrib/views/modules/field/views_handler_field_field.inc','da78d77eff6f6292ebcacc61aef1d92dcae59ccedb6ab111a44fb28253d9d116'),('sites/all/modules/contrib/views/modules/field/views_handler_filter_field_list.inc','3b55cd0a14453c95ebd534507ab842a8505496d0b7e4c7fcd61c186034c7322d'),('sites/all/modules/contrib/views/modules/field/views_handler_relationship_entity_reverse.inc','060035c5430c81671e4541bcf7de833c8a1eb3fa3f3a9db94dd3cebfa4299ef1'),('sites/all/modules/contrib/views/modules/filter/views_handler_field_filter_format_name.inc','fc3f074ffb39822182783a8d5cf2b89ffcc097ccbb2ed15818a72a99e3a18468'),('sites/all/modules/contrib/views/modules/locale/views_handler_argument_locale_group.inc','c8545411096da40f48eef8ec59391f4729c884079482e3e5b3cdd5578a1f9ad7'),('sites/all/modules/contrib/views/modules/locale/views_handler_argument_locale_language.inc','a1b6505bb26e4b3abce543b9097cd0a7b8cddf00bf1e49fbba86febebb0f4486'),('sites/all/modules/contrib/views/modules/locale/views_handler_field_locale_group.inc','5b62afe18f92ee4a5fb49eb0995e65b4744bbe3b9c24ffe8f6c21f3191c04afc'),('sites/all/modules/contrib/views/modules/locale/views_handler_field_locale_language.inc','0cc08bd2d42e07f26e7acc92642b36f0ac62bf23ee9ba3fd21e6cab9a80e9f72'),('sites/all/modules/contrib/views/modules/locale/views_handler_field_locale_link_edit.inc','836ceb1883047011ac1b3dca2254861b8caa1ea67405b3cdbe0fa6f3fbbd5a96'),('sites/all/modules/contrib/views/modules/locale/views_handler_field_node_language.inc','a6ccdb6c1c4df3b4fd31b714f5aa4ac99771ffce63439d6c5de6c0ae2f09a2c1'),('sites/all/modules/contrib/views/modules/locale/views_handler_filter_locale_group.inc','40fbc041bab64f336f59d1e0593f184b879b2a0c9e2a6050709bdc54cceb2716'),('sites/all/modules/contrib/views/modules/locale/views_handler_filter_locale_language.inc','3433893d988aad36b918dd6214f5258b701506bc9c0c6a72fd854a036b635e20'),('sites/all/modules/contrib/views/modules/locale/views_handler_filter_locale_version.inc','9337ea5216784ffc67a0aa45c946e65ad11fc40849189cc70911a81366b78620'),('sites/all/modules/contrib/views/modules/locale/views_handler_filter_node_language.inc','d7edea3f35891cc76aa3bb185b9c1404378623ea7fd214c2a1f0d824df12779a'),('sites/all/modules/contrib/views/modules/node/views_handler_argument_dates_various.inc','d2c17e6ec3d221bdd0d1c060da4b0c85274c8ac5a0b624b1469b162694a8d0f5'),('sites/all/modules/contrib/views/modules/node/views_handler_argument_node_language.inc','7ee3ba02bddaa6aeef9961cdf6af7bb386fc2b12529f095b28520bb98af51775'),('sites/all/modules/contrib/views/modules/node/views_handler_argument_node_nid.inc','11c5b62413ffd1b2c66d4b60a2fe21cf6eb839ae40d4ef81c7a938c5be3e30de'),('sites/all/modules/contrib/views/modules/node/views_handler_argument_node_type.inc','9e21b4cc4ae861f58c804ea7e2c17fbc5dd2a7938b9abfeb54437b531fc95e6e'),('sites/all/modules/contrib/views/modules/node/views_handler_argument_node_uid_revision.inc','675c99f8da9748ac507e202f546914bee3ed4065f6ce83a23a2aaafdaefd084e'),('sites/all/modules/contrib/views/modules/node/views_handler_argument_node_vid.inc','7e5da5594a336c1d0f4cf080ab3fcd690e0de1ee6b5e1830b5fb76a46bced19c'),('sites/all/modules/contrib/views/modules/node/views_handler_field_history_user_timestamp.inc','7d6d9c8273d317ab908d4873a32086dbd5f78a2b2d07b7ed79975841a2cadea6'),('sites/all/modules/contrib/views/modules/node/views_handler_field_node.inc','99a0ef52b68e8913eb3563d5c47097c09e46c6493fcb006f383c6f6798edb7fc'),('sites/all/modules/contrib/views/modules/node/views_handler_field_node_link.inc','26d8309a3a9140682d7d90e4d16ff664a3d7ce662af6ccbf75dc4c493515d7d9'),('sites/all/modules/contrib/views/modules/node/views_handler_field_node_link_delete.inc','3eeed8c9ffc088ee28b8ffaa5e2b084db24284acc4d1b2e69f90c96cc889016d'),('sites/all/modules/contrib/views/modules/node/views_handler_field_node_link_edit.inc','28f8c3b7d3d60c31fec3cdf81c84cfbb20f492220457694a0e150c3ddee030c0'),('sites/all/modules/contrib/views/modules/node/views_handler_field_node_path.inc','f392fde21e434fd40fc672546ef684780179d91827350ba9c348bb1cc5924727'),('sites/all/modules/contrib/views/modules/node/views_handler_field_node_revision.inc','5d861a377571786bf0ef9686d400383429583c3523f801e9cdfb464e748fa8fe'),('sites/all/modules/contrib/views/modules/node/views_handler_field_node_revision_link.inc','ace72f296cf4a4da4b7dd7b303532aebf93b6b1c18a5d30b51b65738475e3889'),('sites/all/modules/contrib/views/modules/node/views_handler_field_node_revision_link_delete.inc','0a36602f080c4ef2bb5cb7dbddc5533deab7743c2fbf3bd88b9e478432cac7fb'),('sites/all/modules/contrib/views/modules/node/views_handler_field_node_revision_link_revert.inc','80ddc7f0c001fde9af491bb22d6044b85324fe90bea611fc3822408fd60008fa'),('sites/all/modules/contrib/views/modules/node/views_handler_field_node_type.inc','f8f39c6f238f837270d1b2e42e67bf9ab400a37fe24246c8b86dfcfacc1c4fd9'),('sites/all/modules/contrib/views/modules/node/views_handler_filter_history_user_timestamp.inc','2970f270e071cad079880e9598d9f7b71d4dd2a2a42a31cd4489029a3cafe158'),('sites/all/modules/contrib/views/modules/node/views_handler_filter_node_access.inc','35fdbb74eb45e10c0faa783d4fbab7068f26ac3a6e0063cf0873358f861cd20d'),('sites/all/modules/contrib/views/modules/node/views_handler_filter_node_status.inc','f7099a59d3f237f2870ecb6b0b5e49dd9d785b1085e94baf55687251e7f3231b'),('sites/all/modules/contrib/views/modules/node/views_handler_filter_node_type.inc','6842082e7b6e131d6e002e627e6b4490b93ca6ffe7fc0b158d31843217c8c929'),('sites/all/modules/contrib/views/modules/node/views_handler_filter_node_uid_revision.inc','b221785bc9a736ef67e4f03e6b26235333115b5b9ce571095de5c5286dd8d744'),('sites/all/modules/contrib/views/modules/node/views_plugin_argument_default_node.inc','7fb79c8f4adb9bcef7c7da4bf4046fe3490e16c244f6ab96fdca97a8567315ff'),('sites/all/modules/contrib/views/modules/node/views_plugin_argument_validate_node.inc','f10d3f4081eed5ca32c41b67e9a0e6f35b2f8ba2cd7897230cb5a680b410a6de'),('sites/all/modules/contrib/views/modules/node/views_plugin_row_node_rss.inc','d170c2aab84b73c862bfa79b7aa3f83f2a6d4668235970a1a797ce6d57501308'),('sites/all/modules/contrib/views/modules/node/views_plugin_row_node_view.inc','713e1c83702ac2d0d7fe76374110cdfd657598a8f3b086ec2352f2de38101504'),('sites/all/modules/contrib/views/modules/profile/views_handler_field_profile_date.inc','4f357b26c60afe2b812c995be69ebce6c6f4ea13075613baad7ec0aef1960d18'),('sites/all/modules/contrib/views/modules/profile/views_handler_field_profile_list.inc','da5fa527ab4bb6a1ff44cc2f9cec91cf3b094670f9e6e3884e1fedce714afe6f'),('sites/all/modules/contrib/views/modules/profile/views_handler_filter_profile_selection.inc','758dea53760a1b655986c33d21345ac396ad41d10ddf39dd16bc7d8c68e72da7'),('sites/all/modules/contrib/views/modules/search/views_handler_argument_search.inc','3c20f1234af341ea2229419980d8405b7eca5005c1e0ee387c8d5cd7a58c5c60'),('sites/all/modules/contrib/views/modules/search/views_handler_field_search_score.inc','711af637c864b775672d9f6203fc2da0902ed17404181d1117b400012aac366f'),('sites/all/modules/contrib/views/modules/search/views_handler_filter_search.inc','8ebd43d8f2a76348f974cd20bad4fa6b1cb078fcb786e9b48558d4f7daa0e0bd'),('sites/all/modules/contrib/views/modules/search/views_handler_sort_search_score.inc','9d23dd6c464d486266749106caec1d10cec2da1cc3ae5f907f39056c46badbdf'),('sites/all/modules/contrib/views/modules/search/views_plugin_row_search_view.inc','bc25864154d4df0a58bc1ac1148581c76df36267a1d18f8caee2e3e1233c8286'),('sites/all/modules/contrib/views/modules/statistics/views_handler_field_accesslog_path.inc','7843e5f4b35f4322d673b5646e840c274f7d747f2c60c4d4e9c47e282e6db37d'),('sites/all/modules/contrib/views/modules/system/views_handler_argument_file_fid.inc','e9bf1fdf12f210f0a77774381b670c77ee88e7789971ce732b254f6be5a0e451'),('sites/all/modules/contrib/views/modules/system/views_handler_field_file.inc','0fff4adb471c0c164a78f507b035a68d41f404ab10535f06f6c11206f39a7681'),('sites/all/modules/contrib/views/modules/system/views_handler_field_file_extension.inc','f833f6ccd098994d91032d40c0eaf5817559917d860f8f2dd8b82768ca616c91'),('sites/all/modules/contrib/views/modules/system/views_handler_field_file_filemime.inc','bdd7f1255f3000f7f2900341d4c4ca378244b96390ef52a30db2962d017b61a4'),('sites/all/modules/contrib/views/modules/system/views_handler_field_file_status.inc','bfb0b9d796a4dbf95c4bb7a3deef7724bcda9e0d9067939b74ec787da934f2b0'),('sites/all/modules/contrib/views/modules/system/views_handler_field_file_uri.inc','350d7dde27ee97cb4279360374eb8633ce7fee115a109346bea85c2c4e3a68c2'),('sites/all/modules/contrib/views/modules/system/views_handler_filter_file_status.inc','9210a34795f9db36974525e718c91c03c28554da1199932791925d7c4a2f3b11'),('sites/all/modules/contrib/views/modules/system/views_handler_filter_system_type.inc','d27513703a75c4d8af79b489266cf4102a36e350c3d90404dab24403ab637205'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_taxonomy.inc','8962fa76f1e03316932468b0fd805817af94726beb82bf9f4786e0c709264662'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_term_node_tid.inc','79a80284231b3bc5aab36833e8200853686784f880dc6b104552d61fc602f27c'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_term_node_tid_depth.inc','5b2806fbad4a6cc104e733a3a0faf6eb1c19975930c67c4149fb3267976e0b7d'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_term_node_tid_depth_modifier.inc','d85ebe68290239b25fc240451655b825325854e9707cf742fbd75de81e0f1aa7'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_vocabulary_machine_name.inc','888647527bec3444b2d0a571a77900396d7c5e884bca04a2a3667a61f6377b5e'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_argument_vocabulary_vid.inc','bf4be783ef6899f004f4dbd06c1bf2cd6dbc322678c825eec36bee81d667e81f'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_field_taxonomy.inc','b0dd5cfa87c44b95aefd819444e4985c1773350bcf9fe073a2ef5c82b680b833'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_field_term_link_edit.inc','d22742a168852702a8d41dceae86dcdb8ed53b1464f6b88601bf7267f2f95f12'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_field_term_node_tid.inc','29c5132ac98a2959405e44f9a83096b0dcfa30ed7fb4688453ca7e1fc779684b'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_filter_term_node_tid.inc','0fd0384ec873d6db244da736e6f5f811ece9a8a5673aeca609a2a3f17f61fc45'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_filter_term_node_tid_depth.inc','0b05ec052dcc03081e20338808dda17beb0bdf869b0cfc1375ca96cfb758c22a'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_filter_vocabulary_machine_name.inc','f1787b436b914cfe5ca6f2575d4c0595f4f496795711d6e8a116a39986728b0a'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_filter_vocabulary_vid.inc','2a4d7dfbb6b795d217e2617595238f552bbea04b80217c933f1ee9978ceb7a0e'),('sites/all/modules/contrib/views/modules/taxonomy/views_handler_relationship_node_term_data.inc','995345469938c7796ed77cb010984cb01c0d712386ae4a5f447e843620248570'),('sites/all/modules/contrib/views/modules/taxonomy/views_plugin_argument_default_taxonomy_tid.inc','fc4c3ace525162fc922de581af0710c7d92dc355e9630040a29a5c3a6ab7f9af'),('sites/all/modules/contrib/views/modules/taxonomy/views_plugin_argument_validate_taxonomy_term.inc','642e8b099da01a5421f03a9a2e08f9cfcdc679674279ab848a5ead6b39ceabb2'),('sites/all/modules/contrib/views/modules/translation/views_handler_argument_node_tnid.inc','b0e3c87d3790cfa2e265f3d9700f2b3c2857932aa4b6e003e5d0114fc1b4d499'),('sites/all/modules/contrib/views/modules/translation/views_handler_field_node_link_translate.inc','27a1ac81b50d4807d9a1eff4c5dc8929e4472f9d363f70f5391a794db73424a2'),('sites/all/modules/contrib/views/modules/translation/views_handler_field_node_translation_link.inc','641ff25cd317bb803de2ace4bd23e8c5f5af5ba4ac38aab7be2fdc58fbb9e86a'),('sites/all/modules/contrib/views/modules/translation/views_handler_filter_node_tnid.inc','0942fd793740e3aec032a1abb7132f53788a9cdeaeb3d931cac908ac30b73950'),('sites/all/modules/contrib/views/modules/translation/views_handler_filter_node_tnid_child.inc','2a7a96d6caa4a99996549be0457bf40fa619731543a636d4573e55c190c64c7a'),('sites/all/modules/contrib/views/modules/translation/views_handler_relationship_translation.inc','9137c85f5ca309d4ee0d3243c470563a5853f5926b8cbd3e843438d4308c9516'),('sites/all/modules/contrib/views/modules/user/views_handler_argument_users_roles_rid.inc','72da80e7f3c6980da024d86f37ba3721021cc1ead2cfcc1ab9b27897b7b5077a'),('sites/all/modules/contrib/views/modules/user/views_handler_argument_user_uid.inc','a4af1bdc1ec5e40587c22c14e839980050baaa346c9d5934ef3f01794932cdc5'),('sites/all/modules/contrib/views/modules/user/views_handler_field_user.inc','1a2141524e43d86b52c7828fe6df61dd603ad433743c1139cfc5cc28ccb5ce74'),('sites/all/modules/contrib/views/modules/user/views_handler_field_user_language.inc','5a3da9e08ebeebbcb5abc6a9b16e0d380c5bb5c57b608afb540a3ca6dc1b2959'),('sites/all/modules/contrib/views/modules/user/views_handler_field_user_link.inc','5a0f35d5305a29816658385ecbd804bf43c92d4b3629fbe4bd9b8d0e9574b6ff'),('sites/all/modules/contrib/views/modules/user/views_handler_field_user_link_cancel.inc','bcc690f03eca154ad02d1de3ebca7d99129455e8c8602c0642382ae66a6d2872'),('sites/all/modules/contrib/views/modules/user/views_handler_field_user_link_edit.inc','5d7c1155d9eccbd6b07c7446fe2b6a8848d6a500f508ac3779f16df56816f92b'),('sites/all/modules/contrib/views/modules/user/views_handler_field_user_mail.inc','b7355b704f19322afb4876cea27744367e20098d4ed973e480bf2baf1ddd111c'),('sites/all/modules/contrib/views/modules/user/views_handler_field_user_name.inc','5fd9a4d7843fee83cf529384a52d7ae69e40a9c8846e7f285e94f4bbbf8c7e29'),('sites/all/modules/contrib/views/modules/user/views_handler_field_user_permissions.inc','ec37373524bf23ae107adda6b825570c550e6654c0f0956409fc58df2c860903'),('sites/all/modules/contrib/views/modules/user/views_handler_field_user_picture.inc','0103d136a91fb219fd981801301b7df00adf90617900ded08efbf6d7df04959b'),('sites/all/modules/contrib/views/modules/user/views_handler_field_user_roles.inc','ab5068c4f01a05c6511f7d4b973a77650d5b5c481d4a73f63b7a9b1ef9c0d138'),('sites/all/modules/contrib/views/modules/user/views_handler_filter_user_current.inc','7f70b7e3b3c10e75d95f54afc9c2fe2f1af9b7a9eab2308d2961b2588dc05845'),('sites/all/modules/contrib/views/modules/user/views_handler_filter_user_name.inc','5225e5d89051313e0e49ea833709bb4dc44369afeee970b0cfaf1818ababa22c'),('sites/all/modules/contrib/views/modules/user/views_handler_filter_user_permissions.inc','a72e8d02c1075cebfee33e5b046460eef9193b2a7c1d47ff130457e4485b6fe5'),('sites/all/modules/contrib/views/modules/user/views_handler_filter_user_roles.inc','3bb69fbc4e352ce8e4840ec78bdd0f1f29e8709097ce6b29cc2fedd2c74c023e'),('sites/all/modules/contrib/views/modules/user/views_plugin_argument_default_current_user.inc','11e729115350deffe46ebfe3a55281fa169a90e38a76c3a9d98f26c87900a22b'),('sites/all/modules/contrib/views/modules/user/views_plugin_argument_default_user.inc','fe567f009a8e20f402f104b157fd44c04d6bd886a39b2f3355104f644f905419'),('sites/all/modules/contrib/views/modules/user/views_plugin_argument_validate_user.inc','40d623b0a678fa7c292da92582f06449d0396341ab161069f0fe8d1086ab95da'),('sites/all/modules/contrib/views/modules/user/views_plugin_row_user_view.inc','52548cca3f18d25b06cfce15ee00acea530b85bd22a10944d984b5a798c5969f'),('sites/all/modules/contrib/views/plugins/export_ui/views_ui.class.php','6e90fbc82e631c61dbf2c3ac807ae0f2df4c12ab636b8a30d320b44c75bd0b7e'),('sites/all/modules/contrib/views/plugins/views_plugin_access.inc','cc16bf7dc4c10eab382e948cfd91902ac1055514b627e3c50932376d3e3f1b91'),('sites/all/modules/contrib/views/plugins/views_plugin_access_none.inc','8e0a6b706c60abf63ab84d8624567ca12a5b80ad293e4334790065fbe6fa14d4'),('sites/all/modules/contrib/views/plugins/views_plugin_access_perm.inc','1807a9c91485a5abd3fb2f6590ed4bc185fdabe308db37b169be8abdfc30cab2'),('sites/all/modules/contrib/views/plugins/views_plugin_access_role.inc','8784836ea87ec6b0974125ed95ed6bbf6fdf91624f496f22c28e9229c695068d'),('sites/all/modules/contrib/views/plugins/views_plugin_argument_default.inc','43e593760f0e8f031f2e7b861385caa5e39f37de400fe4595925288c78f52f23'),('sites/all/modules/contrib/views/plugins/views_plugin_argument_default_fixed.inc','daaa3b59b54cbb11e411e010303f67a51348bb97a4e06997b475f4c41e91c4e0'),('sites/all/modules/contrib/views/plugins/views_plugin_argument_default_php.inc','7a133b603294bfe498bfdeb50fade0b6e3cf8862270376067d86f69e7dc50eb8'),('sites/all/modules/contrib/views/plugins/views_plugin_argument_default_raw.inc','4318e0dfa56f167183453cf8cd913f3b7ee539b77a096507905e36db12ded97e'),('sites/all/modules/contrib/views/plugins/views_plugin_argument_validate.inc','c71e2b54623cc62530ebb717dec1406c76200a59270d9c60b3be290694c9fdd8'),('sites/all/modules/contrib/views/plugins/views_plugin_argument_validate_numeric.inc','c050d3b5723dbfdca9ad312c7fa198e509c626057b95eed326820ce733dd9730'),('sites/all/modules/contrib/views/plugins/views_plugin_argument_validate_php.inc','56a09922081a5e368d5796907727e35cbf43b0d634e53f947990c8a42d5b5f3e'),('sites/all/modules/contrib/views/plugins/views_plugin_cache.inc','5a8d4d584ab973b512ca674b45a1e2a4d43d18d420b333cf8179f1ce79d23d85'),('sites/all/modules/contrib/views/plugins/views_plugin_cache_none.inc','a0d0ba252e1e2b65350c7ce648b97364726fa8ded5a366bfcce30c62daee4450'),('sites/all/modules/contrib/views/plugins/views_plugin_cache_time.inc','10db3dd52b06478b7be9b858f3a053ae2c2f6377abe488ad912f8ca786200a1d'),('sites/all/modules/contrib/views/plugins/views_plugin_display.inc','a61c01757115713c4af7684f11ac4a80f7658f5dea3362610c4a62d3e64a9a6d'),('sites/all/modules/contrib/views/plugins/views_plugin_display_attachment.inc','712f4b78334d8b9abe275ef309541f69ae920117c82930cba1ddbb163cb078f5'),('sites/all/modules/contrib/views/plugins/views_plugin_display_block.inc','be9e3c4a9e28270147bb21de8056712d58e47eeddf6e002fdb9425996d5d5ead'),('sites/all/modules/contrib/views/plugins/views_plugin_display_default.inc','91c6554d8f41f848bf30093d44d076051c54e998f6b50bdc2a922bfeeef9c54d'),('sites/all/modules/contrib/views/plugins/views_plugin_display_embed.inc','5424f2ea9e031faade7a562b8013aea193db5b0bc1be92b97bd7967de0d7bfff'),('sites/all/modules/contrib/views/plugins/views_plugin_display_extender.inc','75fb9f80e7f153715b911690c7140f251df588e6a541fab5881fbfafc0bbf778'),('sites/all/modules/contrib/views/plugins/views_plugin_display_feed.inc','503177e0f2630a8b18a496df1fad909d995abe815c27abb3ac018adfdddb239a'),('sites/all/modules/contrib/views/plugins/views_plugin_display_page.inc','5ff8c9851e5bdb6f6f09b02b1e575742703be4de5754cccb10b6966428df588d'),('sites/all/modules/contrib/views/plugins/views_plugin_exposed_form.inc','170554669c2219a2522a9b074a23090f5b7757a076db09e21803e9590adc3c9e'),('sites/all/modules/contrib/views/plugins/views_plugin_exposed_form_basic.inc','c736e1862b393e15ecc80deb58663405a1d68c2db07eb620d8e640406876cd17'),('sites/all/modules/contrib/views/plugins/views_plugin_exposed_form_input_required.inc','46566e6bf33f1b3d4640526372af94c03334318fe4267e9f5e2e8cb74f4ddc81'),('sites/all/modules/contrib/views/plugins/views_plugin_localization.inc','d7239cc693994dcd069c1f1e7847a7902c5bd29b8d64a93cdf37c602576661fb'),('sites/all/modules/contrib/views/plugins/views_plugin_localization_core.inc','f0900c0640e7c779e9b876223ea395f613c8fe8449f6c8eb5d060e2d54a6afcc'),('sites/all/modules/contrib/views/plugins/views_plugin_localization_none.inc','4930c3a13ddc0df3065f4920a836ffdc933b037e1337764e6687d7311f49dd8a'),('sites/all/modules/contrib/views/plugins/views_plugin_pager.inc','1cbe6ca33f3a177726e4435b82d05e465deb38f9d32d45a20738f47e7c2b0877'),('sites/all/modules/contrib/views/plugins/views_plugin_pager_full.inc','1b6e5e1fd8837d6a5f458079a2dc87161a7814c6d8c181c1dee6958a37096c9a'),('sites/all/modules/contrib/views/plugins/views_plugin_pager_mini.inc','7e69cb56aeb5728fb8d47465d2a42fbd514667a703386ab4b98ac0714cb20b8e'),('sites/all/modules/contrib/views/plugins/views_plugin_pager_none.inc','822cab1ada25f4902a0505f13db86886061d2ced655438b33b197d031ccceddd'),('sites/all/modules/contrib/views/plugins/views_plugin_pager_some.inc','bc6aa7cbf1bc09374eced33334195c8897e4078336b8306d02d71c7aaaa22c99'),('sites/all/modules/contrib/views/plugins/views_plugin_query.inc','0594d1fd0c34b86c6b81741e134da2d385d6be47b667af6660dd1d268fb7fa95'),('sites/all/modules/contrib/views/plugins/views_plugin_query_default.inc','76f57cf8fb9e0d9505a1acc8636c4a34187bc2be5fb574934d3d9c4ba65c5077'),('sites/all/modules/contrib/views/plugins/views_plugin_row.inc','3ca81529526b930cfb0dda202757f203649236b90441e3c035bb79cd419ee2a6'),('sites/all/modules/contrib/views/plugins/views_plugin_row_fields.inc','875fb2868cdbcc5f7af03098cbe55b9bb91ef512e5e52ccde89f7a02a0c5fbe2'),('sites/all/modules/contrib/views/plugins/views_plugin_row_rss_fields.inc','62f4a0ceef14aec9958ee8b98d352303f10818ddc66031814cc8b9d21752ade9'),('sites/all/modules/contrib/views/plugins/views_plugin_style.inc','60243c95aa09e6b09de8418a6dc2b67eabf1e83289cfbf4658c519d6206227be'),('sites/all/modules/contrib/views/plugins/views_plugin_style_default.inc','bf411e635d2fd9e09eb245b43581a0a7b670359180ccb042d42a5e579bbe9c30'),('sites/all/modules/contrib/views/plugins/views_plugin_style_grid.inc','55cdc57509e66f134492850808e19c8688a0dcad2f6fa0f606fba739273f3d5d'),('sites/all/modules/contrib/views/plugins/views_plugin_style_jump_menu.inc','64c0bac7f4732e179105274417286ad7afc7154129d9d87f56e967a2e3ea0775'),('sites/all/modules/contrib/views/plugins/views_plugin_style_list.inc','407b928d2c74a91903b681088bccce926d2268d0a9a6a34c185a4849dc0d7e31'),('sites/all/modules/contrib/views/plugins/views_plugin_style_rss.inc','77fcd2a962022159e89a773c49823306ef69a0dd1b54e6b344d1e2e45590d3d1'),('sites/all/modules/contrib/views/plugins/views_plugin_style_summary.inc','872df59f8f389eaf9b019e82d859dd198d31166e26a9102132e3932c7f1f2916'),('sites/all/modules/contrib/views/plugins/views_plugin_style_summary_jump_menu.inc','1d874546ee84d9ccb132fc01137ae80d807983aa1f589a42d1ac98cc943e9409'),('sites/all/modules/contrib/views/plugins/views_plugin_style_summary_unformatted.inc','c1e6f9dd1d75e29fee271171440d2182e633a1dbbc996cb186f637ff7ad93ed9'),('sites/all/modules/contrib/views/plugins/views_plugin_style_table.inc','036e03018236c2d292fd4b4a623e729b0095cc724555a01b26b37167c28b6b3b'),('sites/all/modules/contrib/views/plugins/views_wizard/views_ui_base_views_wizard.class.php','d8325414c8ddde5c955a5cfb053b77478bb4d73cb2f7d75b857b082bc5a1e12d'),('sites/all/modules/contrib/views/plugins/views_wizard/views_ui_comment_views_wizard.class.php','208d02d7185ccc89c6767d31be2f5417c7877a6846457194eb103bd648aa7577'),('sites/all/modules/contrib/views/plugins/views_wizard/views_ui_file_managed_views_wizard.class.php','5734fb564ba9e2485cfa5d4a49f0c76f65a9be357b78e769ee4af92c4ef9e22a'),('sites/all/modules/contrib/views/plugins/views_wizard/views_ui_node_revision_views_wizard.class.php','6faf9ef92501a4f1aeaf86bcff9edaeb47bd7526ba50d06b841c9366149e7725'),('sites/all/modules/contrib/views/plugins/views_wizard/views_ui_node_views_wizard.class.php','2862cfdcef52cdd42f3b0e0113148bd0da8a93b6cd200f94d51df34e5428fcd2'),('sites/all/modules/contrib/views/plugins/views_wizard/views_ui_taxonomy_term_views_wizard.class.php','a8713b5a925ce8619f4f7b2ce74fbf9f7bb570f8ed084c8a7a5865fb40032eab'),('sites/all/modules/contrib/views/plugins/views_wizard/views_ui_users_views_wizard.class.php','f9fe2fb1ee87a1871e6ad32bad61b2457313f24da1bd5423977ced12de542919'),('sites/all/modules/contrib/views/tests/comment/views_handler_argument_comment_user_uid.test','b8b417ef0e05806a88bd7d5e2f7dcb41339fbf5b66f39311defc9fb65476d561'),('sites/all/modules/contrib/views/tests/comment/views_handler_filter_comment_user_uid.test','347c6ffd4383706dbde844235aaf31cff44a22e95d2e6d8ef4da34a41b70edd1'),('sites/all/modules/contrib/views/tests/field/views_fieldapi.test','13ab94f09aef46cccd1b7819dd40544a6a466c815701e7459e8c38ff14d3d870'),('sites/all/modules/contrib/views/tests/handlers/views_handler_area_text.test','af74a74a3357567b844606add76d7ca1271317778dd7bd245a216cf963c738b4'),('sites/all/modules/contrib/views/tests/handlers/views_handler_argument_null.test','1d174e1f467b905d67217bd755100d78ffeca4aa4ada5c4be40270cd6d30b721'),('sites/all/modules/contrib/views/tests/handlers/views_handler_argument_string.test','3d0213af0041146abb61dcdc750869ed773d0ac80cfa74ffbadfdd03b1f11c52'),('sites/all/modules/contrib/views/tests/handlers/views_handler_field.test','af552bf825ab77486b3d0d156779b7c4806ce5a983c6116ad68b633daf9bb927'),('sites/all/modules/contrib/views/tests/handlers/views_handler_field_boolean.test','45b24a19b3a4ca90dc1591e6a8dbea895c06d7c22ade4c8f74548d1e0185f7d5'),('sites/all/modules/contrib/views/tests/handlers/views_handler_field_counter.test','75b31942adf06b107f5ffd3c97545fde8cd1040b1d00f682e3c7c1320026e26c'),('sites/all/modules/contrib/views/tests/handlers/views_handler_field_custom.test','1446bc3d5a6b1180a79edfa46a5268dbf7f089836aa3bc45df00ddaff9dd0ce1'),('sites/all/modules/contrib/views/tests/handlers/views_handler_field_date.test','6f45326d7f74127956d9d8e4d7ad96a4beb0f66175fa40daf1d618d1a5fa996d'),('sites/all/modules/contrib/views/tests/handlers/views_handler_field_file_size.test','49184db68af398a54e81c8a76261acd861da8fd7846b9d51dcf476d61396bfb9'),('sites/all/modules/contrib/views/tests/handlers/views_handler_field_math.test','6e39e4f782e6b36151ceafb41a5509f7c661be79b393b24f6f5496d724535887'),('sites/all/modules/contrib/views/tests/handlers/views_handler_field_url.test','b41f762a71594b438a2e60a79c8260ba54e6305635725b0747e29f0d3ffe08c9'),('sites/all/modules/contrib/views/tests/handlers/views_handler_field_xss.test','f129ee16c03f84673e33990cbb2da5aa88c362f46e9ba1620b2a842ffd1c9cd2'),('sites/all/modules/contrib/views/tests/handlers/views_handler_filter_combine.test','05842d83a11822afe7d566835f5db9f0f94fdb27ddfc388d38138767bdf36f8b'),('sites/all/modules/contrib/views/tests/handlers/views_handler_filter_date.test','045cc449b68bbd5526071bf38c505b6d44f6c91868273c3120705c3bad250aee'),('sites/all/modules/contrib/views/tests/handlers/views_handler_filter_equality.test','c88f21c9cbf1aae83393b26616908f8020c18fe378d76256c7ba192df2ec17af'),('sites/all/modules/contrib/views/tests/handlers/views_handler_filter_in_operator.test','89420a4071677232e0eb82b184b37b818a82bdb2ff90a8b21293f9ecb21808bf'),('sites/all/modules/contrib/views/tests/handlers/views_handler_filter_numeric.test','35ac7a34e696b979e86ef7209b6697098d9abe218e30a02cc4fe39fb11f2a852'),('sites/all/modules/contrib/views/tests/handlers/views_handler_filter_string.test','b7d090780748faad478e619fd55673d746d4a0cf343d9e40ea96881324c34cbd'),('sites/all/modules/contrib/views/tests/handlers/views_handler_sort.test','f4ff79e6bc54e83c4eb2777811f33702b7e9fe7416ef70ae00d100fa54d44fec'),('sites/all/modules/contrib/views/tests/handlers/views_handler_sort_date.test','f548584d7c6a71cabd3ce07e04053a38df3f3e1685210ce8114238fd05344c10'),('sites/all/modules/contrib/views/tests/handlers/views_handler_sort_random.test','4fdba9bf05a26720ffa97e7a37da65ddc9044bd2832f8c89007b82feb062f182'),('sites/all/modules/contrib/views/tests/plugins/views_plugin_display.test','4a6b136543a60999604c54125fa9d4f5aa61a5dcc71e2133d89325d81bc0fc2d'),('sites/all/modules/contrib/views/tests/styles/views_plugin_style.test','10c19d58cb1e54b02da797bab0c3bb48fa26e36584ebf0cb787adb8c469b630f'),('sites/all/modules/contrib/views/tests/styles/views_plugin_style_jump_menu.test','b711f148f82b076c0bdfbeb3fb66b9ccacb1a99907dd258e9cf113bca06e88b2'),('sites/all/modules/contrib/views/tests/styles/views_plugin_style_unformatted.test','8f376b7956a1f93535f98e591e6ab9ea9914d5cbf994475a870231f6df968080'),('sites/all/modules/contrib/views/tests/taxonomy/views_handler_relationship_node_term_data.test','6074f5c7ae63225ea0cd26626ace6c017740e226f4d3c234e39869c31308223d'),('sites/all/modules/contrib/views/tests/test_plugins/views_test_plugin_access_test_dynamic.inc','6a3ce8c256b84734b6b67a893ab24465a5f62d7bdf9ab5d22082a31849346b7d'),('sites/all/modules/contrib/views/tests/test_plugins/views_test_plugin_access_test_static.inc','e345e42d443cfa73db0ed2be61291117ebd57b86196cdb77c6f440e93443def3'),('sites/all/modules/contrib/views/tests/user/views_handler_field_user_name.test','69641b6da26d8daee9a2ceb2d0df56668bf09b86db1d4071c275b6e8d0885f9e'),('sites/all/modules/contrib/views/tests/user/views_user.test','fbb63b42a0b7051bd4d33cf36841f39d7cc13a63b0554eca431b2a08c19facae'),('sites/all/modules/contrib/views/tests/user/views_user_argument_default.test','6423f2db7673763991b1fd0c452a7d84413c7dd888ca6c95545fadc531cfaaf4'),('sites/all/modules/contrib/views/tests/user/views_user_argument_validate.test','c88c9e5d162958f8924849758486a0d83822ada06088f5cf71bfbe76932d8d84'),('sites/all/modules/contrib/views/tests/views_access.test','f8b9d04b43c09a67ec722290a30408c1df8c163cf6e5863b41468bb4e381ee6f'),('sites/all/modules/contrib/views/tests/views_analyze.test','5548e36c99bb626209d63e5cddbc31f49ad83865c983d2662c6826b328d24ffb'),('sites/all/modules/contrib/views/tests/views_argument_default.test','5950937aae4608bba5b86f366ef3a56cc6518bbccfeaeacda79fa13246d220e4'),('sites/all/modules/contrib/views/tests/views_argument_validator.test','31f8f49946c8aa3b03d6d9a2281bdfb11c54071b28e83fb3e827ca6ff5e38c88'),('sites/all/modules/contrib/views/tests/views_basic.test','655bd33983f84bbea68a3f24bfab545d2c02f36a478566edf35a98a58ff0c6cf'),('sites/all/modules/contrib/views/tests/views_cache.test','76316e1f026c2ab81ef91450b9d6d5985cbfab087f839ea0edd112209bf84fd9'),('sites/all/modules/contrib/views/tests/views_exposed_form.test','2b2b16373af8ecade91d7c77bd8c2da8286a33bde554874f5d81399d201c3228'),('sites/all/modules/contrib/views/tests/views_glossary.test','118d50177a68a6f88e3727e10f8bcc6f95176282cc42fbd604458eeb932a36e8'),('sites/all/modules/contrib/views/tests/views_groupby.test','ac6ca55f084f4884c06437815ccfa5c4d10bfef808c3f6f17a4f69537794a992'),('sites/all/modules/contrib/views/tests/views_handlers.test','a696e3d6b1748da03a04ac532f403700d07c920b9c405c628a6c94ea6764f501'),('sites/all/modules/contrib/views/tests/views_module.test','3939798f2f679308903d4845f5625dd60df6110aec2615e33ab81e854d0b7e73'),('sites/all/modules/contrib/views/tests/views_pager.test','6f448c8c13c5177afb35103119d6281958a2d6dbdfb96ae5f4ee77cb3b44adc5'),('sites/all/modules/contrib/views/tests/views_plugin_localization_test.inc','baedcf6c7381f9c5d3a5062f7d256f96808d06e04b6e73eff8e791e5f5293f45'),('sites/all/modules/contrib/views/tests/views_query.test','1ab587994dc43b1315e9a534d005798aecaa14182ba23a2b445e56516b9528cb'),('sites/all/modules/contrib/views/tests/views_test.views_default.inc','9664b95577fe2664410921bb751e1d99109e79b734f2c8c142d4083449282bd0'),('sites/all/modules/contrib/views/tests/views_translatable.test','4e780fc1bfce03896fea588875cd91311960e77e3deeaf1af5a40c7855640cc1'),('sites/all/modules/contrib/views/tests/views_ui.test','f9687a363d7cc2828739583e3eedeb68c99acd505ff4e3036c806a42b93a2688'),('sites/all/modules/contrib/views/tests/views_upgrade.test','c48bd74b85809dd78d963e525e38f3b6dd7e12aa249f73bd6a20247a40d6713a'),('sites/all/modules/contrib/views/tests/views_view.test','a52e010d27cc2eb29804a3acd30f574adf11fad1f5860e431178b61cddbdbb69'),('sites/all/modules/contrib/views/views_ui.module','903fc52d5943df19733aab4d6824ce5f44641dd22723ca391b97a7bff0f72e84'),('sites/all/modules/contrib/views_php/plugins/views/views_php_handler_area.inc','daae8b1003fe82ae10b4b122393f1cbd5af0030081f2fef3c2299099962f38fb'),('sites/all/modules/contrib/views_php/plugins/views/views_php_handler_field.inc','b590e67240c06221dd355e2a410c2632c0ca2754d0160ca04ad958382a919a4e'),('sites/all/modules/contrib/views_php/plugins/views/views_php_handler_filter.inc','ea8db48b7f1fc4b8a8560cb79ae0c96cfce2946fdef6dc5688e25431f8c08c6e'),('sites/all/modules/contrib/views_php/plugins/views/views_php_handler_sort.inc','cb8a468be62e3e1d6fc549ba2eb802e6bf3be7934c11a3860b01fae6905e1306'),('sites/all/modules/contrib/views_php/plugins/views/views_php_plugin_access.inc','a6b05c6ce87df5af659c89fd9f063055fb33a6e435bd0935a5eaf062637637bc'),('sites/all/modules/contrib/views_php/plugins/views/views_php_plugin_cache.inc','3605b853dadd16c9112aed99afad6f96f3297f6bfaceb45085249a2e273dc29d'),('sites/all/modules/contrib/views_php/plugins/views/views_php_plugin_pager.inc','264b6428ec86fa68b5e70637bc581fc23798fff21eb25e964a1a137a987eeccf'),('sites/all/modules/contrib/views_php/plugins/views/views_php_plugin_query.inc','5c7d86140a537a9f83ccdf13aa2d33d54280371e599d6b9aa19a32e52f698e23'),('sites/all/modules/contrib/views_php/plugins/views/views_php_plugin_wrapper.inc','703e76a50ceb8437e3adca47400fdb1376eb6dfae9ada6a536be534a5da45177'),('sites/all/modules/contrib/views_watchdog/views/handlers/views_handler_field_watchdog_message.inc','645b45fa2316767e87880966f9a5715dcb306127006f35ca564fcc1528ea3c33'),('sites/all/modules/contrib/views_watchdog/views/handlers/views_handler_field_watchdog_severity.inc','03f9a759c91dc22ceb6e4da2fb3836e0e29f344f44f33da84b880f02cce51027'),('sites/all/modules/contrib/views_watchdog/views/handlers/views_handler_filter_watchdog_message.inc','996da97d97a4c73f225a297671f05e39d27a9d718e5a57e855387e149701d3cc'),('sites/all/modules/contrib/views_watchdog/views/handlers/views_handler_filter_watchdog_severity.inc','85385e1b22e5e6db0821c71241d2c6546eaa190bf1b50177029ea92b4ae4d179'),('sites/all/modules/contrib/views_watchdog/views/handlers/views_handler_filter_watchdog_type.inc','b9a72a2bed47f44284c2260e5ce3d77075c6e1a4c1b4f9101b0623d96a397e69'),('sites/all/modules/contrib/views_watchdog/views/plugins/views_plugin_row_watchdog_rss.inc','2960e836d91648d6c14246e919eebe9c029b98ad3c215172169009eceaf02af0'),('sites/all/modules/contrib/views_watchdog/views/plugins/views_plugin_style_watchdog_table.inc','578c10ec4f662dc82cf273378c6ff78417fb27d147836ea6baf8354b0b6bc214'),('sites/all/modules/contrib/views_watchdog/views/theme/theme.inc','61d201243f1c1b5683702d97110783bae8a2303136efd6285eddf48e6daa6719'),('sites/all/modules/contrib/views_watchdog/views/theme/views-view-watchdog-table.tpl.php','efde45b33b3a7b311adc9ce2321bd9e731c54e9802907019aba66a12a886177c'),('sites/all/modules/contrib/views_data_export/views_data_export.module','95de3acc921b7d8a5d29dcac43f373979d354ca3ca13ff007fefe181f4ee35fd'),('sites/all/modules/contrib/views_data_export/plugins/views_data_export_plugin_display_export.inc','b8480c56584c2aeb341a859e16972a9023c3e6f19e602e342f21cb01ead29af7'),('sites/all/modules/contrib/views_data_export/plugins/views_data_export_plugin_style_export.inc','4026eecf120761f9e05618faeb8399c5b382c638377971cf8f7137ae2f6d19ce'),('sites/all/modules/contrib/views_data_export/plugins/views_data_export_plugin_style_export_csv.inc','942f066477c4443079b0a41dfafb137d39d6bcc9277fef165b64b2eda47a2a54'),('sites/all/modules/contrib/views_data_export/plugins/views_data_export_plugin_style_export_xml.inc','f48c40bd65e579810a5d95c1f4bdd930f2dccb21229c75fbb7ba719d18797c93'),('sites/all/modules/contrib/views_data_export/theme/views_data_export.theme.inc','1b139d7fed88f33108921b132dac1cddadf61fdaf4bb424e4e355b3dc3730b83'),('sites/all/modules/contrib/views_data_export/theme/views-data-export-csv-body.tpl.php','46fae8dc619e353fd365f7d427ba8c97f12afa13db33de70fc6bed7bb36f4e4f'),('sites/all/modules/contrib/views_data_export/theme/views-data-export-csv-footer.tpl.php','809b54e63b8b6bf6018fe312f4c2a04f2c4df851a1d3bd53a177aafc0447cb19'),('sites/all/modules/contrib/views_data_export/theme/views-data-export-csv-header.tpl.php','c11c01af5c558b68c60b3ede26819a46123708dbaa48ebef353aa18d8ce3accb'),('sites/all/modules/contrib/views_data_export/theme/views-data-export-doc-body.tpl.php','2e360ff56ad7072a285296b1f494456b4fefb6f9f3204f80ddd29014ac14f594'),('sites/all/modules/contrib/views_data_export/theme/views-data-export-doc-footer.tpl.php','fd7606995eba7a40c803216cf7e36c71b7c25c2b738a8c01b0d8a0a7cb4cf640'),('sites/all/modules/contrib/views_data_export/theme/views-data-export-doc-header.tpl.php','fbb1304d8da61daa2afb311680c2057e4f26a37b18bf3a25f482e8e304e07529'),('sites/all/modules/contrib/views_data_export/theme/views-data-export-txt-body.tpl.php','49537ded9312de55c0103830a22fa95421cf725aa32ff18ebd63065289c3526b'),('sites/all/modules/contrib/views_data_export/theme/views-data-export-txt-footer.tpl.php','9d8ac7e0c84821496347fcb20072ee565dea25e7edc1bc45babeb05d8f3f47c3'),('sites/all/modules/contrib/views_data_export/theme/views-data-export-txt-header.tpl.php','6a934d7c12a93b6fd01d6cd2bdc2db90f42a2f56bac889effae85be2d7bd45fa'),('sites/all/modules/contrib/views_data_export/theme/views-data-export-xls-body.tpl.php','2e360ff56ad7072a285296b1f494456b4fefb6f9f3204f80ddd29014ac14f594'),('sites/all/modules/contrib/views_data_export/theme/views-data-export-xls-footer.tpl.php','fd7606995eba7a40c803216cf7e36c71b7c25c2b738a8c01b0d8a0a7cb4cf640'),('sites/all/modules/contrib/views_data_export/theme/views-data-export-xls-header.tpl.php','fbb1304d8da61daa2afb311680c2057e4f26a37b18bf3a25f482e8e304e07529'),('sites/all/modules/contrib/views_data_export/theme/views-data-export-xml-body.tpl.php','6e585b164dd0f40fd6953425ff7951053db70a4cd82c6aff3e4a98dc2a44be58'),('sites/all/modules/contrib/views_data_export/theme/views-data-export-xml-footer.tpl.php','158d575fc64a7c2d0e78e23f550f992f6b29053d04486401c9abdb56a52e34a2'),('sites/all/modules/contrib/views_data_export/theme/views-data-export-xml-header.tpl.php','b7d1f67007161f5be4082e66e443ec6b170ae30259f4a91a882d28a120da0e41'),('sites/all/modules/contrib/views_data_export/theme/views-data-export.tpl.php','b5607370e0524a326ba3ff6bbc07210ca51ff4d1450626ab89006966e870f69c'),('sites/all/modules/contrib/entityreference/tests/entityreference.taxonomy.test','8e4f7d9ae621df0f587b6fcbf139adea2a35c69305ef018ced88447a41164c5f');
/*!40000 ALTER TABLE `registry_file` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `role`
--

DROP TABLE IF EXISTS `role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role` (
  `rid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique role ID.',
  `name` varchar(64) NOT NULL DEFAULT '' COMMENT 'Unique role name.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The weight of this role in listings and the user interface.',
  PRIMARY KEY (`rid`),
  UNIQUE KEY `name` (`name`),
  KEY `name_weight` (`name`,`weight`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COMMENT='Stores user roles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role`
--

LOCK TABLES `role` WRITE;
/*!40000 ALTER TABLE `role` DISABLE KEYS */;
INSERT INTO `role` VALUES (3,'administrator',2),(1,'anonymous user',0),(2,'authenticated user',1);
/*!40000 ALTER TABLE `role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `role_permission`
--

DROP TABLE IF EXISTS `role_permission`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role_permission` (
  `rid` int(10) unsigned NOT NULL COMMENT 'Foreign Key: role.rid.',
  `permission` varchar(128) NOT NULL DEFAULT '' COMMENT 'A single permission granted to the role identified by rid.',
  `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'The module declaring the permission.',
  PRIMARY KEY (`rid`,`permission`),
  KEY `permission` (`permission`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores the permissions assigned to user roles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role_permission`
--

LOCK TABLES `role_permission` WRITE;
/*!40000 ALTER TABLE `role_permission` DISABLE KEYS */;
INSERT INTO `role_permission` VALUES (2,'access comments','comment'),(2,'access content','node'),(2,'access mercury_management','mercury_management'),(2,'access mercury_utilities','mercury_utilities'),(2,'access search_api_page','search_api_page'),(2,'administer mercury_management settings','mercury_management'),(2,'administer mercury_utilities settings','mercury_utilities'),(2,'create field_host_password','field_permissions'),(2,'create field_host_username','field_permissions'),(2,'create field_password','field_permissions'),(2,'create field_username','field_permissions'),(2,'create field_vm_ip_address','field_permissions'),(2,'create field_vm_password','field_permissions'),(2,'create field_vm_username','field_permissions'),(2,'edit field_host_password','field_permissions'),(2,'edit field_host_username','field_permissions'),(2,'edit field_password','field_permissions'),(2,'edit field_username','field_permissions'),(2,'edit field_vm_ip_address','field_permissions'),(2,'edit field_vm_password','field_permissions'),(2,'edit field_vm_username','field_permissions'),(2,'edit own field_host_password','field_permissions'),(2,'edit own field_host_username','field_permissions'),(2,'edit own field_password','field_permissions'),(2,'edit own field_username','field_permissions'),(2,'edit own field_vm_ip_address','field_permissions'),(2,'edit own field_vm_password','field_permissions'),(2,'edit own field_vm_username','field_permissions'),(2,'post comments','comment'),(2,'search content','search'),(2,'skip comment approval','comment'),(2,'use text format filtered_html','filter'),(2,'view body','field_permissions'),(2,'view comment_body','field_permissions'),(2,'view field_allocated_segments','field_permissions'),(2,'view field_allocated_size','field_permissions'),(2,'view field_allocated_virtual_machines','field_permissions'),(2,'view field_attached_filters','field_permissions'),(2,'view field_boottime','field_permissions'),(2,'view field_bundle_status','field_permissions'),(2,'view field_cachespace','field_permissions'),(2,'view field_cache_state','field_permissions'),(2,'view field_capacity','field_permissions'),(2,'view field_claimed_physical_devices','field_permissions'),(2,'view field_cpu_model','field_permissions'),(2,'view field_cpu_usage','field_permissions'),(2,'view field_datacenter','field_permissions'),(2,'view field_devfs_path','field_permissions'),(2,'view field_device_state','field_permissions'),(2,'view field_device_type','field_permissions'),(2,'view field_disk_index','field_permissions'),(2,'view field_display_name','field_permissions'),(2,'view field_driver_status','field_permissions'),(2,'view field_fa_administration_state','field_permissions'),(2,'view field_fa_build_version','field_permissions'),(2,'view field_fa_cache_mode','field_permissions'),(2,'view field_fa_cache_size','field_permissions'),(2,'view field_fa_generation_id','field_permissions'),(2,'view field_fa_operational_message','field_permissions'),(2,'view field_fa_operational_state','field_permissions'),(2,'view field_fa_performance_state','field_permissions'),(2,'view field_freespace','field_permissions'),(2,'view field_guest_id','field_permissions'),(2,'view field_guest_memory_usage','field_permissions'),(2,'view field_guest_os','field_permissions'),(2,'view field_host','field_permissions'),(2,'view field_host_memory_usage','field_permissions'),(2,'view field_host_name','field_permissions'),(2,'view field_host_password','field_permissions'),(2,'view field_host_status','field_permissions'),(2,'view field_host_username','field_permissions'),(2,'view field_image','field_permissions'),(2,'view field_ip_address','field_permissions'),(2,'view field_is_local','field_permissions'),(2,'view field_is_offline','field_permissions'),(2,'view field_is_perennially_reserved','field_permissions'),(2,'view field_is_pseudo','field_permissions'),(2,'view field_is_rdm_capable','field_permissions'),(2,'view field_is_removable','field_permissions'),(2,'view field_is_ssd','field_permissions'),(2,'view field_maintenance_mode','field_permissions'),(2,'view field_max_physical_devices','field_permissions'),(2,'view field_max_virtual_machines','field_permissions'),(2,'view field_model','field_permissions'),(2,'view field_multipath_plugin','field_permissions'),(2,'view field_naa_identifier','field_permissions'),(2,'view field_no_of_cpu','field_permissions'),(2,'view field_other_uids','field_permissions'),(2,'view field_password','field_permissions'),(2,'view field_path','field_permissions'),(2,'view field_physical_memory','field_permissions'),(2,'view field_reboot_required','field_permissions'),(2,'view field_related_host','field_permissions'),(2,'view field_related_vcenter','field_permissions'),(2,'view field_revision','field_permissions'),(2,'view field_scsi_level','field_permissions'),(2,'view field_segment_size','field_permissions'),(2,'view field_serial_no','field_permissions'),(2,'view field_size','field_permissions'),(2,'view field_software_on_host','field_permissions'),(2,'view field_status','field_permissions'),(2,'view field_tags','field_permissions'),(2,'view field_template','field_permissions'),(2,'view field_thin_provisioning_status','field_permissions'),(2,'view field_timestamp','field_permissions'),(2,'view field_total_segments','field_permissions'),(2,'view field_total_size','field_permissions'),(2,'view field_username','field_permissions'),(2,'view field_vaai_status','field_permissions'),(2,'view field_vdisk','field_permissions'),(2,'view field_vdisk_cache_latency','field_permissions'),(2,'view field_vdisk_hits','field_permissions'),(2,'view field_vdisk_hit_rate_pc','field_permissions'),(2,'view field_vdisk_insertions','field_permissions'),(2,'view field_vdisk_insertion_rate_pc','field_permissions'),(2,'view field_vdisk_population','field_permissions'),(2,'view field_vdisk_population_pc','field_permissions'),(2,'view field_vdisk_read_blocks','field_permissions'),(2,'view field_vdisk_read_latency','field_permissions'),(2,'view field_vdisk_read_ops','field_permissions'),(2,'view field_vdisk_usable_blocks','field_permissions'),(2,'view field_vdisk_write_blocks','field_permissions'),(2,'view field_vdisk_write_latency','field_permissions'),(2,'view field_vdisk_write_ops','field_permissions'),(2,'view field_vendor','field_permissions'),(2,'view field_vib_version','field_permissions'),(2,'view field_virtual_disks','field_permissions'),(2,'view field_virtual_machine','field_permissions'),(2,'view field_vm','field_permissions'),(2,'view field_vmotion','field_permissions'),(2,'view field_vmware_tools','field_permissions'),(2,'view field_vm_cache_latency','field_permissions'),(2,'view field_vm_hits','field_permissions'),(2,'view field_vm_hit_rate_pc','field_permissions'),(2,'view field_vm_insertions','field_permissions'),(2,'view field_vm_insertion_rate_pc','field_permissions'),(2,'view field_vm_password','field_permissions'),(2,'view field_vm_path_name','field_permissions'),(2,'view field_vm_population','field_permissions'),(2,'view field_vm_population_pc','field_permissions'),(2,'view field_vm_read_blocks','field_permissions'),(2,'view field_vm_read_latency','field_permissions'),(2,'view field_vm_read_ops','field_permissions'),(2,'view field_vm_usable_blocks','field_permissions'),(2,'view field_vm_username','field_permissions'),(2,'view field_vm_write_blocks','field_permissions'),(2,'view field_vm_write_latency','field_permissions'),(2,'view field_vm_write_ops','field_permissions'),(2,'view own body','field_permissions'),(2,'view own comment_body','field_permissions'),(2,'view own field_allocated_segments','field_permissions'),(2,'view own field_allocated_size','field_permissions'),(2,'view own field_allocated_virtual_machines','field_permissions'),(2,'view own field_attached_filters','field_permissions'),(2,'view own field_boottime','field_permissions'),(2,'view own field_bundle_status','field_permissions'),(2,'view own field_cachespace','field_permissions'),(2,'view own field_cache_state','field_permissions'),(2,'view own field_capacity','field_permissions'),(2,'view own field_claimed_physical_devices','field_permissions'),(2,'view own field_cpu_model','field_permissions'),(2,'view own field_cpu_usage','field_permissions'),(2,'view own field_datacenter','field_permissions'),(2,'view own field_devfs_path','field_permissions'),(2,'view own field_device_state','field_permissions'),(2,'view own field_device_type','field_permissions'),(2,'view own field_disk_index','field_permissions'),(2,'view own field_display_name','field_permissions'),(2,'view own field_driver_status','field_permissions'),(2,'view own field_fa_administration_state','field_permissions'),(2,'view own field_fa_build_version','field_permissions'),(2,'view own field_fa_cache_mode','field_permissions'),(2,'view own field_fa_cache_size','field_permissions'),(2,'view own field_fa_generation_id','field_permissions'),(2,'view own field_fa_operational_message','field_permissions'),(2,'view own field_fa_operational_state','field_permissions'),(2,'view own field_fa_performance_state','field_permissions'),(2,'view own field_freespace','field_permissions'),(2,'view own field_guest_id','field_permissions'),(2,'view own field_guest_memory_usage','field_permissions'),(2,'view own field_guest_os','field_permissions'),(2,'view own field_host','field_permissions'),(2,'view own field_host_memory_usage','field_permissions'),(2,'view own field_host_name','field_permissions'),(2,'view own field_host_password','field_permissions'),(2,'view own field_host_status','field_permissions'),(2,'view own field_host_username','field_permissions'),(2,'view own field_image','field_permissions'),(2,'view own field_ip_address','field_permissions'),(2,'view own field_is_local','field_permissions'),(2,'view own field_is_offline','field_permissions'),(2,'view own field_is_perennially_reserved','field_permissions'),(2,'view own field_is_pseudo','field_permissions'),(2,'view own field_is_rdm_capable','field_permissions'),(2,'view own field_is_removable','field_permissions'),(2,'view own field_is_ssd','field_permissions'),(2,'view own field_maintenance_mode','field_permissions'),(2,'view own field_max_physical_devices','field_permissions'),(2,'view own field_max_virtual_machines','field_permissions'),(2,'view own field_memory_size','field_permissions'),(2,'view own field_model','field_permissions'),(2,'view own field_multipath_plugin','field_permissions'),(2,'view own field_naa_identifier','field_permissions'),(2,'view own field_no_of_cpu','field_permissions'),(2,'view own field_other_uids','field_permissions'),(2,'view own field_password','field_permissions'),(2,'view own field_path','field_permissions'),(2,'view own field_physical_memory','field_permissions'),(2,'view own field_reboot_required','field_permissions'),(2,'view own field_related_host','field_permissions'),(2,'view own field_related_vcenter','field_permissions'),(2,'view own field_revision','field_permissions'),(2,'view own field_scsi_level','field_permissions'),(2,'view own field_segment_size','field_permissions'),(2,'view own field_serial_no','field_permissions'),(2,'view own field_size','field_permissions'),(2,'view own field_software_on_host','field_permissions'),(2,'view own field_status','field_permissions'),(2,'view own field_tags','field_permissions'),(2,'view own field_template','field_permissions'),(2,'view own field_thin_provisioning_status','field_permissions'),(2,'view own field_timestamp','field_permissions'),(2,'view own field_total_segments','field_permissions'),(2,'view own field_total_size','field_permissions'),(2,'view own field_username','field_permissions'),(2,'view own field_vaai_status','field_permissions'),(2,'view own field_vdisk','field_permissions'),(2,'view own field_vdisk_cache_latency','field_permissions'),(2,'view own field_vdisk_hits','field_permissions'),(2,'view own field_vdisk_hit_rate_pc','field_permissions'),(2,'view own field_vdisk_insertions','field_permissions'),(2,'view own field_vdisk_insertion_rate_pc','field_permissions'),(2,'view own field_vdisk_population','field_permissions'),(2,'view own field_vdisk_population_pc','field_permissions'),(2,'view own field_vdisk_read_blocks','field_permissions'),(2,'view own field_vdisk_read_latency','field_permissions'),(2,'view own field_vdisk_read_ops','field_permissions'),(2,'view own field_vdisk_usable_blocks','field_permissions'),(2,'view own field_vdisk_write_blocks','field_permissions'),(2,'view own field_vdisk_write_latency','field_permissions'),(2,'view own field_vdisk_write_ops','field_permissions'),(2,'view own field_vendor','field_permissions'),(2,'view own field_vib_version','field_permissions'),(2,'view own field_virtual_disks','field_permissions'),(2,'view own field_virtual_machine','field_permissions'),(2,'view own field_vm','field_permissions'),(2,'view own field_vmotion','field_permissions'),(2,'view own field_vmware_tools','field_permissions'),(2,'view own field_vm_cache_latency','field_permissions'),(2,'view own field_vm_hits','field_permissions'),(2,'view own field_vm_hit_rate_pc','field_permissions'),(2,'view own field_vm_insertions','field_permissions'),(2,'view own field_vm_insertion_rate_pc','field_permissions'),(2,'view own field_vm_ip_address','field_permissions'),(2,'view own field_vm_password','field_permissions'),(2,'view own field_vm_path_name','field_permissions'),(2,'view own field_vm_population','field_permissions'),(2,'view own field_vm_population_pc','field_permissions'),(2,'view own field_vm_read_blocks','field_permissions'),(2,'view own field_vm_read_latency','field_permissions'),(2,'view own field_vm_read_ops','field_permissions'),(2,'view own field_vm_usable_blocks','field_permissions'),(2,'view own field_vm_username','field_permissions'),(2,'view own field_vm_write_blocks','field_permissions'),(2,'view own field_vm_write_latency','field_permissions'),(2,'view own field_vm_write_ops','field_permissions'),(3,'access administration menu','admin_menu'),(3,'access administration pages','system'),(3,'access all views','views'),(3,'access comments','comment'),(3,'access content','node'),(3,'access content overview','node'),(3,'access contextual links','contextual'),(3,'access dashboard','dashboard'),(3,'Access Firebug Debug','drupalforfirebug'),(3,'access mercury_management','mercury_management'),(3,'access mercury_utilities','mercury_utilities'),(3,'access overlay','overlay'),(3,'access private fields','field_permissions'),(3,'access search_api_page','search_api_page'),(3,'access site in maintenance mode','system'),(3,'access site reports','system'),(3,'access toolbar','toolbar'),(3,'access user profiles','user'),(3,'administer actions','system'),(3,'administer advanced pane settings','panels'),(3,'administer blocks','block'),(3,'administer comments','comment'),(3,'administer content types','node'),(3,'administer custom content','ctools_custom_content'),(3,'administer field permissions','field_permissions'),(3,'administer fieldgroups','field_group'),(3,'administer filters','filter'),(3,'administer image styles','image'),(3,'administer menu','menu'),(3,'administer menu attributes','menu_attributes'),(3,'administer mercury_management settings','mercury_management'),(3,'administer mercury_utilities settings','mercury_utilities'),(3,'administer mini panels','panels_mini'),(3,'administer module filter','module_filter'),(3,'administer modules','system'),(3,'administer nodes','node'),(3,'administer page manager','page_manager'),(3,'administer pane access','panels'),(3,'administer panel-nodes','panels_node'),(3,'administer panels layouts','panels'),(3,'administer panels styles','panels'),(3,'administer pathauto','pathauto'),(3,'administer permissions','user'),(3,'administer search','search'),(3,'administer search_api','search_api'),(3,'administer shortcuts','shortcut'),(3,'administer site configuration','system'),(3,'administer software updates','system'),(3,'administer taxonomy','taxonomy'),(3,'administer themes','system'),(3,'administer url aliases','path'),(3,'administer users','user'),(3,'administer views','views'),(3,'block IP addresses','system'),(3,'bypass node access','node'),(3,'cancel account','user'),(3,'change layouts in place editing','panels'),(3,'change own username','user'),(3,'create article content','node'),(3,'create body','field_permissions'),(3,'create comment_body','field_permissions'),(3,'create field_allocated_segments','field_permissions'),(3,'create field_allocated_size','field_permissions'),(3,'create field_allocated_virtual_machines','field_permissions'),(3,'create field_attached_filters','field_permissions'),(3,'create field_boottime','field_permissions'),(3,'create field_bundle_status','field_permissions'),(3,'create field_cachespace','field_permissions'),(3,'create field_cache_state','field_permissions'),(3,'create field_capacity','field_permissions'),(3,'create field_claimed_physical_devices','field_permissions'),(3,'create field_cpu_model','field_permissions'),(3,'create field_cpu_usage','field_permissions'),(3,'create field_datacenter','field_permissions'),(3,'create field_devfs_path','field_permissions'),(3,'create field_device_state','field_permissions'),(3,'create field_device_type','field_permissions'),(3,'create field_disk_index','field_permissions'),(3,'create field_display_name','field_permissions'),(3,'create field_driver_status','field_permissions'),(3,'create field_fa_administration_state','field_permissions'),(3,'create field_fa_build_version','field_permissions'),(3,'create field_fa_cache_mode','field_permissions'),(3,'create field_fa_cache_size','field_permissions'),(3,'create field_fa_generation_id','field_permissions'),(3,'create field_fa_operational_message','field_permissions'),(3,'create field_fa_operational_state','field_permissions'),(3,'create field_fa_performance_state','field_permissions'),(3,'create field_freespace','field_permissions'),(3,'create field_guest_id','field_permissions'),(3,'create field_guest_memory_usage','field_permissions'),(3,'create field_guest_os','field_permissions'),(3,'create field_host','field_permissions'),(3,'create field_host_memory_usage','field_permissions'),(3,'create field_host_name','field_permissions'),(3,'create field_host_password','field_permissions'),(3,'create field_host_status','field_permissions'),(3,'create field_host_username','field_permissions'),(3,'create field_image','field_permissions'),(3,'create field_ip_address','field_permissions'),(3,'create field_is_local','field_permissions'),(3,'create field_is_offline','field_permissions'),(3,'create field_is_perennially_reserved','field_permissions'),(3,'create field_is_pseudo','field_permissions'),(3,'create field_is_rdm_capable','field_permissions'),(3,'create field_is_removable','field_permissions'),(3,'create field_is_ssd','field_permissions'),(3,'create field_maintenance_mode','field_permissions'),(3,'create field_max_physical_devices','field_permissions'),(3,'create field_max_virtual_machines','field_permissions'),(3,'create field_memory_size','field_permissions'),(3,'create field_model','field_permissions'),(3,'create field_multipath_plugin','field_permissions'),(3,'create field_naa_identifier','field_permissions'),(3,'create field_no_of_cpu','field_permissions'),(3,'create field_other_uids','field_permissions'),(3,'create field_password','field_permissions'),(3,'create field_path','field_permissions'),(3,'create field_physical_memory','field_permissions'),(3,'create field_reboot_required','field_permissions'),(3,'create field_related_host','field_permissions'),(3,'create field_related_vcenter','field_permissions'),(3,'create field_revision','field_permissions'),(3,'create field_scsi_level','field_permissions'),(3,'create field_segment_size','field_permissions'),(3,'create field_serial_no','field_permissions'),(3,'create field_size','field_permissions'),(3,'create field_software_on_host','field_permissions'),(3,'create field_status','field_permissions'),(3,'create field_tags','field_permissions'),(3,'create field_template','field_permissions'),(3,'create field_thin_provisioning_status','field_permissions'),(3,'create field_timestamp','field_permissions'),(3,'create field_total_segments','field_permissions'),(3,'create field_total_size','field_permissions'),(3,'create field_username','field_permissions'),(3,'create field_vaai_status','field_permissions'),(3,'create field_vdisk','field_permissions'),(3,'create field_vdisk_cache_latency','field_permissions'),(3,'create field_vdisk_hits','field_permissions'),(3,'create field_vdisk_hit_rate_pc','field_permissions'),(3,'create field_vdisk_insertions','field_permissions'),(3,'create field_vdisk_insertion_rate_pc','field_permissions'),(3,'create field_vdisk_population','field_permissions'),(3,'create field_vdisk_population_pc','field_permissions'),(3,'create field_vdisk_read_blocks','field_permissions'),(3,'create field_vdisk_read_latency','field_permissions'),(3,'create field_vdisk_read_ops','field_permissions'),(3,'create field_vdisk_usable_blocks','field_permissions'),(3,'create field_vdisk_write_blocks','field_permissions'),(3,'create field_vdisk_write_latency','field_permissions'),(3,'create field_vdisk_write_ops','field_permissions'),(3,'create field_vendor','field_permissions'),(3,'create field_vib_version','field_permissions'),(3,'create field_virtual_disks','field_permissions'),(3,'create field_virtual_machine','field_permissions'),(3,'create field_vm','field_permissions'),(3,'create field_vmotion','field_permissions'),(3,'create field_vmware_tools','field_permissions'),(3,'create field_vm_cache_latency','field_permissions'),(3,'create field_vm_hits','field_permissions'),(3,'create field_vm_hit_rate_pc','field_permissions'),(3,'create field_vm_insertions','field_permissions'),(3,'create field_vm_insertion_rate_pc','field_permissions'),(3,'create field_vm_ip_address','field_permissions'),(3,'create field_vm_password','field_permissions'),(3,'create field_vm_path_name','field_permissions'),(3,'create field_vm_population','field_permissions'),(3,'create field_vm_population_pc','field_permissions'),(3,'create field_vm_read_blocks','field_permissions'),(3,'create field_vm_read_latency','field_permissions'),(3,'create field_vm_read_ops','field_permissions'),(3,'create field_vm_usable_blocks','field_permissions'),(3,'create field_vm_username','field_permissions'),(3,'create field_vm_write_blocks','field_permissions'),(3,'create field_vm_write_latency','field_permissions'),(3,'create field_vm_write_ops','field_permissions'),(3,'create mini panels','panels_mini'),(3,'create page content','node'),(3,'create panel-nodes','panels_node'),(3,'create url aliases','path'),(3,'customize shortcut links','shortcut'),(3,'delete any article content','node'),(3,'delete any page content','node'),(3,'delete any panel-nodes','panels_node'),(3,'delete own article content','node'),(3,'delete own page content','node'),(3,'delete own panel-nodes','panels_node'),(3,'delete revisions','node'),(3,'delete terms in 1','taxonomy'),(3,'display drupal links','admin_menu'),(3,'edit any article content','node'),(3,'edit any page content','node'),(3,'edit any panel-nodes','panels_node'),(3,'edit body','field_permissions'),(3,'edit comment_body','field_permissions'),(3,'edit field_allocated_segments','field_permissions'),(3,'edit field_allocated_size','field_permissions'),(3,'edit field_allocated_virtual_machines','field_permissions'),(3,'edit field_attached_filters','field_permissions'),(3,'edit field_boottime','field_permissions'),(3,'edit field_bundle_status','field_permissions'),(3,'edit field_cachespace','field_permissions'),(3,'edit field_cache_state','field_permissions'),(3,'edit field_capacity','field_permissions'),(3,'edit field_claimed_physical_devices','field_permissions'),(3,'edit field_cpu_model','field_permissions'),(3,'edit field_cpu_usage','field_permissions'),(3,'edit field_datacenter','field_permissions'),(3,'edit field_devfs_path','field_permissions'),(3,'edit field_device_state','field_permissions'),(3,'edit field_device_type','field_permissions'),(3,'edit field_disk_index','field_permissions'),(3,'edit field_display_name','field_permissions'),(3,'edit field_driver_status','field_permissions'),(3,'edit field_fa_administration_state','field_permissions'),(3,'edit field_fa_build_version','field_permissions'),(3,'edit field_fa_cache_mode','field_permissions'),(3,'edit field_fa_cache_size','field_permissions'),(3,'edit field_fa_generation_id','field_permissions'),(3,'edit field_fa_operational_message','field_permissions'),(3,'edit field_fa_operational_state','field_permissions'),(3,'edit field_fa_performance_state','field_permissions'),(3,'edit field_freespace','field_permissions'),(3,'edit field_guest_id','field_permissions'),(3,'edit field_guest_memory_usage','field_permissions'),(3,'edit field_guest_os','field_permissions'),(3,'edit field_host','field_permissions'),(3,'edit field_host_memory_usage','field_permissions'),(3,'edit field_host_name','field_permissions'),(3,'edit field_host_password','field_permissions'),(3,'edit field_host_status','field_permissions'),(3,'edit field_host_username','field_permissions'),(3,'edit field_image','field_permissions'),(3,'edit field_ip_address','field_permissions'),(3,'edit field_is_local','field_permissions'),(3,'edit field_is_offline','field_permissions'),(3,'edit field_is_perennially_reserved','field_permissions'),(3,'edit field_is_pseudo','field_permissions'),(3,'edit field_is_rdm_capable','field_permissions'),(3,'edit field_is_removable','field_permissions'),(3,'edit field_is_ssd','field_permissions'),(3,'edit field_maintenance_mode','field_permissions'),(3,'edit field_max_physical_devices','field_permissions'),(3,'edit field_max_virtual_machines','field_permissions'),(3,'edit field_memory_size','field_permissions'),(3,'edit field_model','field_permissions'),(3,'edit field_multipath_plugin','field_permissions'),(3,'edit field_naa_identifier','field_permissions'),(3,'edit field_no_of_cpu','field_permissions'),(3,'edit field_other_uids','field_permissions'),(3,'edit field_password','field_permissions'),(3,'edit field_path','field_permissions'),(3,'edit field_physical_memory','field_permissions'),(3,'edit field_reboot_required','field_permissions'),(3,'edit field_related_host','field_permissions'),(3,'edit field_related_vcenter','field_permissions'),(3,'edit field_revision','field_permissions'),(3,'edit field_scsi_level','field_permissions'),(3,'edit field_segment_size','field_permissions'),(3,'edit field_serial_no','field_permissions'),(3,'edit field_size','field_permissions'),(3,'edit field_software_on_host','field_permissions'),(3,'edit field_status','field_permissions'),(3,'edit field_tags','field_permissions'),(3,'edit field_template','field_permissions'),(3,'edit field_thin_provisioning_status','field_permissions'),(3,'edit field_timestamp','field_permissions'),(3,'edit field_total_segments','field_permissions'),(3,'edit field_total_size','field_permissions'),(3,'edit field_username','field_permissions'),(3,'edit field_vaai_status','field_permissions'),(3,'edit field_vdisk','field_permissions'),(3,'edit field_vdisk_cache_latency','field_permissions'),(3,'edit field_vdisk_hits','field_permissions'),(3,'edit field_vdisk_hit_rate_pc','field_permissions'),(3,'edit field_vdisk_insertions','field_permissions'),(3,'edit field_vdisk_insertion_rate_pc','field_permissions'),(3,'edit field_vdisk_population','field_permissions'),(3,'edit field_vdisk_population_pc','field_permissions'),(3,'edit field_vdisk_read_blocks','field_permissions'),(3,'edit field_vdisk_read_latency','field_permissions'),(3,'edit field_vdisk_read_ops','field_permissions'),(3,'edit field_vdisk_usable_blocks','field_permissions'),(3,'edit field_vdisk_write_blocks','field_permissions'),(3,'edit field_vdisk_write_latency','field_permissions'),(3,'edit field_vdisk_write_ops','field_permissions'),(3,'edit field_vendor','field_permissions'),(3,'edit field_vib_version','field_permissions'),(3,'edit field_virtual_disks','field_permissions'),(3,'edit field_virtual_machine','field_permissions'),(3,'edit field_vm','field_permissions'),(3,'edit field_vmotion','field_permissions'),(3,'edit field_vmware_tools','field_permissions'),(3,'edit field_vm_cache_latency','field_permissions'),(3,'edit field_vm_hits','field_permissions'),(3,'edit field_vm_hit_rate_pc','field_permissions'),(3,'edit field_vm_insertions','field_permissions'),(3,'edit field_vm_insertion_rate_pc','field_permissions'),(3,'edit field_vm_ip_address','field_permissions'),(3,'edit field_vm_password','field_permissions'),(3,'edit field_vm_path_name','field_permissions'),(3,'edit field_vm_population','field_permissions'),(3,'edit field_vm_population_pc','field_permissions'),(3,'edit field_vm_read_blocks','field_permissions'),(3,'edit field_vm_read_latency','field_permissions'),(3,'edit field_vm_read_ops','field_permissions'),(3,'edit field_vm_usable_blocks','field_permissions'),(3,'edit field_vm_username','field_permissions'),(3,'edit field_vm_write_blocks','field_permissions'),(3,'edit field_vm_write_latency','field_permissions'),(3,'edit field_vm_write_ops','field_permissions'),(3,'edit own article content','node'),(3,'edit own body','field_permissions'),(3,'edit own comments','comment'),(3,'edit own comment_body','field_permissions'),(3,'edit own field_allocated_segments','field_permissions'),(3,'edit own field_allocated_size','field_permissions'),(3,'edit own field_allocated_virtual_machines','field_permissions'),(3,'edit own field_attached_filters','field_permissions'),(3,'edit own field_boottime','field_permissions'),(3,'edit own field_bundle_status','field_permissions'),(3,'edit own field_cachespace','field_permissions'),(3,'edit own field_cache_state','field_permissions'),(3,'edit own field_capacity','field_permissions'),(3,'edit own field_claimed_physical_devices','field_permissions'),(3,'edit own field_cpu_model','field_permissions'),(3,'edit own field_cpu_usage','field_permissions'),(3,'edit own field_datacenter','field_permissions'),(3,'edit own field_devfs_path','field_permissions'),(3,'edit own field_device_state','field_permissions'),(3,'edit own field_device_type','field_permissions'),(3,'edit own field_disk_index','field_permissions'),(3,'edit own field_display_name','field_permissions'),(3,'edit own field_driver_status','field_permissions'),(3,'edit own field_fa_administration_state','field_permissions'),(3,'edit own field_fa_build_version','field_permissions'),(3,'edit own field_fa_cache_mode','field_permissions'),(3,'edit own field_fa_cache_size','field_permissions'),(3,'edit own field_fa_generation_id','field_permissions'),(3,'edit own field_fa_operational_message','field_permissions'),(3,'edit own field_fa_operational_state','field_permissions'),(3,'edit own field_fa_performance_state','field_permissions'),(3,'edit own field_freespace','field_permissions'),(3,'edit own field_guest_id','field_permissions'),(3,'edit own field_guest_memory_usage','field_permissions'),(3,'edit own field_guest_os','field_permissions'),(3,'edit own field_host','field_permissions'),(3,'edit own field_host_memory_usage','field_permissions'),(3,'edit own field_host_name','field_permissions'),(3,'edit own field_host_password','field_permissions'),(3,'edit own field_host_status','field_permissions'),(3,'edit own field_host_username','field_permissions'),(3,'edit own field_image','field_permissions'),(3,'edit own field_ip_address','field_permissions'),(3,'edit own field_is_local','field_permissions'),(3,'edit own field_is_offline','field_permissions'),(3,'edit own field_is_perennially_reserved','field_permissions'),(3,'edit own field_is_pseudo','field_permissions'),(3,'edit own field_is_rdm_capable','field_permissions'),(3,'edit own field_is_removable','field_permissions'),(3,'edit own field_is_ssd','field_permissions'),(3,'edit own field_maintenance_mode','field_permissions'),(3,'edit own field_max_physical_devices','field_permissions'),(3,'edit own field_max_virtual_machines','field_permissions'),(3,'edit own field_memory_size','field_permissions'),(3,'edit own field_model','field_permissions'),(3,'edit own field_multipath_plugin','field_permissions'),(3,'edit own field_naa_identifier','field_permissions'),(3,'edit own field_no_of_cpu','field_permissions'),(3,'edit own field_other_uids','field_permissions'),(3,'edit own field_password','field_permissions'),(3,'edit own field_path','field_permissions'),(3,'edit own field_physical_memory','field_permissions'),(3,'edit own field_reboot_required','field_permissions'),(3,'edit own field_related_host','field_permissions'),(3,'edit own field_related_vcenter','field_permissions'),(3,'edit own field_revision','field_permissions'),(3,'edit own field_scsi_level','field_permissions'),(3,'edit own field_segment_size','field_permissions'),(3,'edit own field_serial_no','field_permissions'),(3,'edit own field_size','field_permissions'),(3,'edit own field_software_on_host','field_permissions'),(3,'edit own field_status','field_permissions'),(3,'edit own field_tags','field_permissions'),(3,'edit own field_template','field_permissions'),(3,'edit own field_thin_provisioning_status','field_permissions'),(3,'edit own field_timestamp','field_permissions'),(3,'edit own field_total_segments','field_permissions'),(3,'edit own field_total_size','field_permissions'),(3,'edit own field_username','field_permissions'),(3,'edit own field_vaai_status','field_permissions'),(3,'edit own field_vdisk','field_permissions'),(3,'edit own field_vdisk_cache_latency','field_permissions'),(3,'edit own field_vdisk_hits','field_permissions'),(3,'edit own field_vdisk_hit_rate_pc','field_permissions'),(3,'edit own field_vdisk_insertions','field_permissions'),(3,'edit own field_vdisk_insertion_rate_pc','field_permissions'),(3,'edit own field_vdisk_population','field_permissions'),(3,'edit own field_vdisk_population_pc','field_permissions'),(3,'edit own field_vdisk_read_blocks','field_permissions'),(3,'edit own field_vdisk_read_latency','field_permissions'),(3,'edit own field_vdisk_read_ops','field_permissions'),(3,'edit own field_vdisk_usable_blocks','field_permissions'),(3,'edit own field_vdisk_write_blocks','field_permissions'),(3,'edit own field_vdisk_write_latency','field_permissions'),(3,'edit own field_vdisk_write_ops','field_permissions'),(3,'edit own field_vendor','field_permissions'),(3,'edit own field_vib_version','field_permissions'),(3,'edit own field_virtual_disks','field_permissions'),(3,'edit own field_virtual_machine','field_permissions'),(3,'edit own field_vm','field_permissions'),(3,'edit own field_vmotion','field_permissions'),(3,'edit own field_vmware_tools','field_permissions'),(3,'edit own field_vm_cache_latency','field_permissions'),(3,'edit own field_vm_hits','field_permissions'),(3,'edit own field_vm_hit_rate_pc','field_permissions'),(3,'edit own field_vm_insertions','field_permissions'),(3,'edit own field_vm_insertion_rate_pc','field_permissions'),(3,'edit own field_vm_ip_address','field_permissions'),(3,'edit own field_vm_password','field_permissions'),(3,'edit own field_vm_path_name','field_permissions'),(3,'edit own field_vm_population','field_permissions'),(3,'edit own field_vm_population_pc','field_permissions'),(3,'edit own field_vm_read_blocks','field_permissions'),(3,'edit own field_vm_read_latency','field_permissions'),(3,'edit own field_vm_read_ops','field_permissions'),(3,'edit own field_vm_usable_blocks','field_permissions'),(3,'edit own field_vm_username','field_permissions'),(3,'edit own field_vm_write_blocks','field_permissions'),(3,'edit own field_vm_write_latency','field_permissions'),(3,'edit own field_vm_write_ops','field_permissions'),(3,'edit own page content','node'),(3,'edit own panel-nodes','panels_node'),(3,'edit terms in 1','taxonomy'),(3,'Execute Firebug PHP','drupalforfirebug'),(3,'field hidden administer','field_hidden'),(3,'flush caches','admin_menu'),(3,'notify of path changes','pathauto'),(3,'post comments','comment'),(3,'revert revisions','node'),(3,'search content','search'),(3,'select account cancellation method','user'),(3,'skip comment approval','comment'),(3,'switch shortcut sets','shortcut'),(3,'unique_field_perm_admin','unique_field'),(3,'unique_field_perm_bypass','unique_field'),(3,'use advanced search','search'),(3,'use page manager','page_manager'),(3,'use panels caching features','panels'),(3,'use panels dashboard','panels'),(3,'use panels in place editing','panels'),(3,'use panels locks','panels'),(3,'use PHP for settings','php'),(3,'use text format filtered_html','filter'),(3,'use text format full_html','filter'),(3,'view body','field_permissions'),(3,'view code review','coder_review'),(3,'view code review all','coder_review'),(3,'view comment_body','field_permissions'),(3,'view field_allocated_segments','field_permissions'),(3,'view field_allocated_size','field_permissions'),(3,'view field_allocated_virtual_machines','field_permissions'),(3,'view field_attached_filters','field_permissions'),(3,'view field_boottime','field_permissions'),(3,'view field_bundle_status','field_permissions'),(3,'view field_cachespace','field_permissions'),(3,'view field_cache_state','field_permissions'),(3,'view field_capacity','field_permissions'),(3,'view field_claimed_physical_devices','field_permissions'),(3,'view field_cpu_model','field_permissions'),(3,'view field_cpu_usage','field_permissions'),(3,'view field_datacenter','field_permissions'),(3,'view field_devfs_path','field_permissions'),(3,'view field_device_state','field_permissions'),(3,'view field_device_type','field_permissions'),(3,'view field_disk_index','field_permissions'),(3,'view field_display_name','field_permissions'),(3,'view field_driver_status','field_permissions'),(3,'view field_fa_administration_state','field_permissions'),(3,'view field_fa_build_version','field_permissions'),(3,'view field_fa_cache_mode','field_permissions'),(3,'view field_fa_cache_size','field_permissions'),(3,'view field_fa_generation_id','field_permissions'),(3,'view field_fa_operational_message','field_permissions'),(3,'view field_fa_operational_state','field_permissions'),(3,'view field_fa_performance_state','field_permissions'),(3,'view field_freespace','field_permissions'),(3,'view field_guest_id','field_permissions'),(3,'view field_guest_memory_usage','field_permissions'),(3,'view field_guest_os','field_permissions'),(3,'view field_host','field_permissions'),(3,'view field_host_memory_usage','field_permissions'),(3,'view field_host_name','field_permissions'),(3,'view field_host_password','field_permissions'),(3,'view field_host_status','field_permissions'),(3,'view field_host_username','field_permissions'),(3,'view field_image','field_permissions'),(3,'view field_ip_address','field_permissions'),(3,'view field_is_local','field_permissions'),(3,'view field_is_offline','field_permissions'),(3,'view field_is_perennially_reserved','field_permissions'),(3,'view field_is_pseudo','field_permissions'),(3,'view field_is_rdm_capable','field_permissions'),(3,'view field_is_removable','field_permissions'),(3,'view field_is_ssd','field_permissions'),(3,'view field_maintenance_mode','field_permissions'),(3,'view field_max_physical_devices','field_permissions'),(3,'view field_max_virtual_machines','field_permissions'),(3,'view field_memory_size','field_permissions'),(3,'view field_model','field_permissions'),(3,'view field_multipath_plugin','field_permissions'),(3,'view field_naa_identifier','field_permissions'),(3,'view field_no_of_cpu','field_permissions'),(3,'view field_other_uids','field_permissions'),(3,'view field_password','field_permissions'),(3,'view field_path','field_permissions'),(3,'view field_physical_memory','field_permissions'),(3,'view field_reboot_required','field_permissions'),(3,'view field_related_host','field_permissions'),(3,'view field_related_vcenter','field_permissions'),(3,'view field_revision','field_permissions'),(3,'view field_scsi_level','field_permissions'),(3,'view field_segment_size','field_permissions'),(3,'view field_serial_no','field_permissions'),(3,'view field_size','field_permissions'),(3,'view field_software_on_host','field_permissions'),(3,'view field_status','field_permissions'),(3,'view field_tags','field_permissions'),(3,'view field_template','field_permissions'),(3,'view field_thin_provisioning_status','field_permissions'),(3,'view field_timestamp','field_permissions'),(3,'view field_total_segments','field_permissions'),(3,'view field_total_size','field_permissions'),(3,'view field_username','field_permissions'),(3,'view field_vaai_status','field_permissions'),(3,'view field_vdisk','field_permissions'),(3,'view field_vdisk_cache_latency','field_permissions'),(3,'view field_vdisk_hits','field_permissions'),(3,'view field_vdisk_hit_rate_pc','field_permissions'),(3,'view field_vdisk_insertions','field_permissions'),(3,'view field_vdisk_insertion_rate_pc','field_permissions'),(3,'view field_vdisk_population','field_permissions'),(3,'view field_vdisk_population_pc','field_permissions'),(3,'view field_vdisk_read_blocks','field_permissions'),(3,'view field_vdisk_read_latency','field_permissions'),(3,'view field_vdisk_read_ops','field_permissions'),(3,'view field_vdisk_usable_blocks','field_permissions'),(3,'view field_vdisk_write_blocks','field_permissions'),(3,'view field_vdisk_write_latency','field_permissions'),(3,'view field_vdisk_write_ops','field_permissions'),(3,'view field_vendor','field_permissions'),(3,'view field_vib_version','field_permissions'),(3,'view field_virtual_disks','field_permissions'),(3,'view field_virtual_machine','field_permissions'),(3,'view field_vm','field_permissions'),(3,'view field_vmotion','field_permissions'),(3,'view field_vmware_tools','field_permissions'),(3,'view field_vm_cache_latency','field_permissions'),(3,'view field_vm_hits','field_permissions'),(3,'view field_vm_hit_rate_pc','field_permissions'),(3,'view field_vm_insertions','field_permissions'),(3,'view field_vm_insertion_rate_pc','field_permissions'),(3,'view field_vm_ip_address','field_permissions'),(3,'view field_vm_password','field_permissions'),(3,'view field_vm_path_name','field_permissions'),(3,'view field_vm_population','field_permissions'),(3,'view field_vm_population_pc','field_permissions'),(3,'view field_vm_read_blocks','field_permissions'),(3,'view field_vm_read_latency','field_permissions'),(3,'view field_vm_read_ops','field_permissions'),(3,'view field_vm_usable_blocks','field_permissions'),(3,'view field_vm_username','field_permissions'),(3,'view field_vm_write_blocks','field_permissions'),(3,'view field_vm_write_latency','field_permissions'),(3,'view field_vm_write_ops','field_permissions'),(3,'view own body','field_permissions'),(3,'view own comment_body','field_permissions'),(3,'view own field_allocated_segments','field_permissions'),(3,'view own field_allocated_size','field_permissions'),(3,'view own field_allocated_virtual_machines','field_permissions'),(3,'view own field_attached_filters','field_permissions'),(3,'view own field_boottime','field_permissions'),(3,'view own field_bundle_status','field_permissions'),(3,'view own field_cachespace','field_permissions'),(3,'view own field_cache_state','field_permissions'),(3,'view own field_capacity','field_permissions'),(3,'view own field_claimed_physical_devices','field_permissions'),(3,'view own field_cpu_model','field_permissions'),(3,'view own field_cpu_usage','field_permissions'),(3,'view own field_datacenter','field_permissions'),(3,'view own field_devfs_path','field_permissions'),(3,'view own field_device_state','field_permissions'),(3,'view own field_device_type','field_permissions'),(3,'view own field_disk_index','field_permissions'),(3,'view own field_display_name','field_permissions'),(3,'view own field_driver_status','field_permissions'),(3,'view own field_fa_administration_state','field_permissions'),(3,'view own field_fa_build_version','field_permissions'),(3,'view own field_fa_cache_mode','field_permissions'),(3,'view own field_fa_cache_size','field_permissions'),(3,'view own field_fa_generation_id','field_permissions'),(3,'view own field_fa_operational_message','field_permissions'),(3,'view own field_fa_operational_state','field_permissions'),(3,'view own field_fa_performance_state','field_permissions'),(3,'view own field_freespace','field_permissions'),(3,'view own field_guest_id','field_permissions'),(3,'view own field_guest_memory_usage','field_permissions'),(3,'view own field_guest_os','field_permissions'),(3,'view own field_host','field_permissions'),(3,'view own field_host_memory_usage','field_permissions'),(3,'view own field_host_name','field_permissions'),(3,'view own field_host_password','field_permissions'),(3,'view own field_host_status','field_permissions'),(3,'view own field_host_username','field_permissions'),(3,'view own field_image','field_permissions'),(3,'view own field_ip_address','field_permissions'),(3,'view own field_is_local','field_permissions'),(3,'view own field_is_offline','field_permissions'),(3,'view own field_is_perennially_reserved','field_permissions'),(3,'view own field_is_pseudo','field_permissions'),(3,'view own field_is_rdm_capable','field_permissions'),(3,'view own field_is_removable','field_permissions'),(3,'view own field_is_ssd','field_permissions'),(3,'view own field_maintenance_mode','field_permissions'),(3,'view own field_max_physical_devices','field_permissions'),(3,'view own field_max_virtual_machines','field_permissions'),(3,'view own field_memory_size','field_permissions'),(3,'view own field_model','field_permissions'),(3,'view own field_multipath_plugin','field_permissions'),(3,'view own field_naa_identifier','field_permissions'),(3,'view own field_no_of_cpu','field_permissions'),(3,'view own field_other_uids','field_permissions'),(3,'view own field_password','field_permissions'),(3,'view own field_path','field_permissions'),(3,'view own field_physical_memory','field_permissions'),(3,'view own field_reboot_required','field_permissions'),(3,'view own field_related_host','field_permissions'),(3,'view own field_related_vcenter','field_permissions'),(3,'view own field_revision','field_permissions'),(3,'view own field_scsi_level','field_permissions'),(3,'view own field_segment_size','field_permissions'),(3,'view own field_serial_no','field_permissions'),(3,'view own field_size','field_permissions'),(3,'view own field_software_on_host','field_permissions'),(3,'view own field_status','field_permissions'),(3,'view own field_tags','field_permissions'),(3,'view own field_template','field_permissions'),(3,'view own field_thin_provisioning_status','field_permissions'),(3,'view own field_timestamp','field_permissions'),(3,'view own field_total_segments','field_permissions'),(3,'view own field_total_size','field_permissions'),(3,'view own field_username','field_permissions'),(3,'view own field_vaai_status','field_permissions'),(3,'view own field_vdisk','field_permissions'),(3,'view own field_vdisk_cache_latency','field_permissions'),(3,'view own field_vdisk_hits','field_permissions'),(3,'view own field_vdisk_hit_rate_pc','field_permissions'),(3,'view own field_vdisk_insertions','field_permissions'),(3,'view own field_vdisk_insertion_rate_pc','field_permissions'),(3,'view own field_vdisk_population','field_permissions'),(3,'view own field_vdisk_population_pc','field_permissions'),(3,'view own field_vdisk_read_blocks','field_permissions'),(3,'view own field_vdisk_read_latency','field_permissions'),(3,'view own field_vdisk_read_ops','field_permissions'),(3,'view own field_vdisk_usable_blocks','field_permissions'),(3,'view own field_vdisk_write_blocks','field_permissions'),(3,'view own field_vdisk_write_latency','field_permissions'),(3,'view own field_vdisk_write_ops','field_permissions'),(3,'view own field_vendor','field_permissions'),(3,'view own field_vib_version','field_permissions'),(3,'view own field_virtual_disks','field_permissions'),(3,'view own field_virtual_machine','field_permissions'),(3,'view own field_vm','field_permissions'),(3,'view own field_vmotion','field_permissions'),(3,'view own field_vmware_tools','field_permissions'),(3,'view own field_vm_cache_latency','field_permissions'),(3,'view own field_vm_hits','field_permissions'),(3,'view own field_vm_hit_rate_pc','field_permissions'),(3,'view own field_vm_insertions','field_permissions'),(3,'view own field_vm_insertion_rate_pc','field_permissions'),(3,'view own field_vm_ip_address','field_permissions'),(3,'view own field_vm_password','field_permissions'),(3,'view own field_vm_path_name','field_permissions'),(3,'view own field_vm_population','field_permissions'),(3,'view own field_vm_population_pc','field_permissions'),(3,'view own field_vm_read_blocks','field_permissions'),(3,'view own field_vm_read_latency','field_permissions'),(3,'view own field_vm_read_ops','field_permissions'),(3,'view own field_vm_usable_blocks','field_permissions'),(3,'view own field_vm_username','field_permissions'),(3,'view own field_vm_write_blocks','field_permissions'),(3,'view own field_vm_write_latency','field_permissions'),(3,'view own field_vm_write_ops','field_permissions'),(3,'view own unpublished content','node'),(3,'view pane admin links','panels'),(3,'view revisions','node'),(3,'view the administration theme','system');
/*!40000 ALTER TABLE `role_permission` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `search_api_index`
--

DROP TABLE IF EXISTS `search_api_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_api_index` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'An integer identifying the index.',
  `name` varchar(50) NOT NULL COMMENT 'A name to be displayed for the index.',
  `machine_name` varchar(50) NOT NULL COMMENT 'The machine name of the index.',
  `description` text COMMENT 'A string describing the index’ use to users.',
  `server` varchar(50) DEFAULT NULL COMMENT 'The search_api_server.machine_name with which data should be indexed.',
  `item_type` varchar(50) NOT NULL COMMENT 'The type of items stored in this index.',
  `options` mediumtext NOT NULL COMMENT 'An array of additional arguments configuring this index.',
  `enabled` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'A flag indicating whether this index is enabled.',
  `read_only` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A flag indicating whether to write to this index.',
  `status` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'The exportable status of the entity.',
  `module` varchar(255) DEFAULT NULL COMMENT 'The name of the providing module if the entity has been defined in code.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `machine_name` (`machine_name`),
  KEY `item_type` (`item_type`),
  KEY `server` (`server`),
  KEY `enabled` (`enabled`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COMMENT='Stores all search indexes on a search_api_server.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_api_index`
--

LOCK TABLES `search_api_index` WRITE;
/*!40000 ALTER TABLE `search_api_index` DISABLE KEYS */;
INSERT INTO `search_api_index` VALUES (1,'Default node index','default_node_index','An automatically created search index for indexing node data. Might be configured to specific needs.',NULL,'node','a:4:{s:10:\"cron_limit\";s:2:\"50\";s:20:\"data_alter_callbacks\";a:2:{s:29:\"search_api_alter_add_fulltext\";a:3:{s:6:\"status\";i:0;s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:1:{s:6:\"fields\";a:0:{}}}s:24:\"search_api_alter_add_url\";a:2:{s:6:\"status\";i:0;s:6:\"weight\";s:1:\"0\";}}s:10:\"processors\";a:3:{s:22:\"search_api_case_ignore\";a:3:{s:6:\"status\";i:1;s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:1:{s:7:\"strings\";i:0;}}s:22:\"search_api_html_filter\";a:3:{s:6:\"status\";i:1;s:6:\"weight\";s:2:\"10\";s:8:\"settings\";a:3:{s:5:\"title\";i:0;s:3:\"alt\";i:1;s:4:\"tags\";s:54:\"h1 = 5\nh2 = 3\nh3 = 2\nstrong = 2\nb = 2\nem = 1.5\nu = 1.5\";}}s:20:\"search_api_tokenizer\";a:3:{s:6:\"status\";i:1;s:6:\"weight\";s:2:\"20\";s:8:\"settings\";a:2:{s:6:\"spaces\";s:13:\"[^\\p{L}\\p{N}]\";s:9:\"ignorable\";s:3:\"[-]\";}}}s:6:\"fields\";a:11:{s:4:\"type\";a:1:{s:4:\"type\";s:6:\"string\";}s:5:\"title\";a:2:{s:4:\"type\";s:4:\"text\";s:5:\"boost\";s:3:\"5.0\";}s:7:\"promote\";a:1:{s:4:\"type\";s:7:\"boolean\";}s:6:\"sticky\";a:1:{s:4:\"type\";s:7:\"boolean\";}s:7:\"created\";a:1:{s:4:\"type\";s:4:\"date\";}s:7:\"changed\";a:1:{s:4:\"type\";s:4:\"date\";}s:6:\"author\";a:2:{s:4:\"type\";s:7:\"integer\";s:11:\"entity_type\";s:4:\"user\";}s:13:\"comment_count\";a:1:{s:4:\"type\";s:7:\"integer\";}s:19:\"search_api_language\";a:1:{s:4:\"type\";s:6:\"string\";}s:19:\"search_api_fulltext\";a:1:{s:4:\"type\";s:4:\"text\";}s:10:\"body:value\";a:1:{s:4:\"type\";s:4:\"text\";}}}',0,0,1,NULL);
/*!40000 ALTER TABLE `search_api_index` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `search_api_item`
--

DROP TABLE IF EXISTS `search_api_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_api_item` (
  `item_id` int(10) unsigned NOT NULL COMMENT 'The item’s entity id (e.g. node.nid for nodes).',
  `index_id` int(10) unsigned NOT NULL COMMENT 'The search_api_index.id this item belongs to.',
  `changed` bigint(20) NOT NULL DEFAULT '1' COMMENT 'Either a flag or a timestamp to indicate if or when the item was changed since it was last indexed.',
  PRIMARY KEY (`item_id`,`index_id`),
  KEY `indexing` (`index_id`,`changed`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores the items which should be indexed for each index,...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_api_item`
--

LOCK TABLES `search_api_item` WRITE;
/*!40000 ALTER TABLE `search_api_item` DISABLE KEYS */;
INSERT INTO `search_api_item` VALUES (2,2,0),(3,2,0),(4,2,0),(5,2,0),(6,2,0),(7,2,0),(8,2,0),(9,2,0),(10,2,0),(11,2,0),(12,2,0),(13,2,0),(14,2,0),(15,2,0),(16,2,0),(17,2,0),(18,2,0),(19,2,0),(20,2,0),(21,2,0),(22,2,0),(23,2,0),(24,2,0),(25,2,0),(26,2,0),(27,2,0),(28,2,0),(29,2,0),(30,2,0),(31,2,0),(32,2,0),(33,2,0),(34,2,0),(35,2,0),(36,2,0),(37,2,0),(38,2,0),(39,2,0),(40,2,0),(41,2,0),(42,2,0),(43,2,0),(44,2,0),(45,2,0),(46,2,0),(47,2,0),(48,2,0),(49,2,0),(50,2,0),(51,2,0),(52,2,0),(53,2,0),(54,2,0),(55,2,0),(56,2,0),(57,2,0),(58,2,0),(59,2,0),(60,2,0),(61,2,0),(62,2,0),(63,2,0),(64,2,0),(65,2,0),(66,2,0),(67,2,0),(68,2,0),(69,2,0),(70,2,0),(71,2,0),(72,2,0),(73,2,0),(74,2,0),(75,2,0),(76,2,0),(77,2,0),(78,2,0),(79,2,0),(80,2,0),(81,2,0),(82,2,0),(83,2,0),(84,2,0),(85,2,0),(86,2,0),(87,2,0),(88,2,0),(89,2,0),(90,2,0),(91,2,0),(92,2,0),(93,2,0),(94,2,0),(95,2,0),(96,2,0),(97,2,0),(98,2,0),(99,2,0),(100,2,0),(101,2,0),(102,2,0),(103,2,0),(104,2,0),(105,2,0),(106,2,0),(107,2,0),(108,2,0),(109,2,0),(110,2,0),(111,2,0),(112,2,0),(113,2,0),(114,2,0),(115,2,0),(116,2,0),(117,2,0),(118,2,0),(119,2,0),(120,2,0),(121,2,0),(122,2,0),(123,2,0),(124,2,0),(125,2,0),(126,2,0),(127,2,0),(128,2,0),(129,2,0),(130,2,0),(131,2,0),(132,2,0),(133,2,0),(134,2,0),(135,2,0),(136,2,0),(137,2,0),(138,2,0),(139,2,0),(140,2,0),(141,2,0),(142,2,0),(143,2,0),(144,2,0),(145,2,0),(146,2,0),(147,2,0),(148,2,0),(149,2,0),(150,2,0),(151,2,0),(152,2,0),(153,2,0),(154,2,0),(155,2,0),(156,2,0),(157,2,0),(158,2,0),(159,2,0),(160,2,0),(161,2,0),(162,2,0),(163,2,0),(164,2,0),(165,2,0),(166,2,0),(167,2,0),(168,2,0),(169,2,0),(170,2,0),(171,2,0),(172,2,0),(173,2,0),(174,2,0),(175,2,0),(176,2,0),(177,2,0),(178,2,0),(179,2,0),(180,2,0),(181,2,0),(182,2,0),(183,2,0),(184,2,0),(185,2,0),(186,2,0),(187,2,0),(188,2,0),(189,2,0),(190,2,0),(191,2,0),(192,2,0),(193,2,0),(194,2,0),(195,2,0),(196,2,0),(197,2,0),(198,2,0),(199,2,0),(200,2,0),(201,2,0),(202,2,0),(203,2,0),(204,2,0),(205,2,0),(206,2,0),(207,2,0),(208,2,0),(209,2,0),(210,2,0),(211,2,0),(212,2,0),(213,2,0),(214,2,0),(215,2,0),(216,2,0),(217,2,0),(218,2,0),(219,2,0),(220,2,0),(221,2,0),(222,2,0),(223,2,0),(224,2,0),(225,2,0),(226,2,0),(227,2,0),(228,2,0),(229,2,0),(230,2,0),(231,2,0),(232,2,0),(233,2,0),(234,2,0),(235,2,0),(236,2,0),(237,2,0),(238,2,0),(239,2,0),(240,2,0),(241,2,0),(242,2,0),(243,2,0),(244,2,0),(245,2,0),(246,2,0),(247,2,0),(248,2,0),(249,2,0),(250,2,0),(251,2,0),(252,2,0),(253,2,0),(254,2,0),(255,2,0),(256,2,0),(257,2,0),(258,2,0),(259,2,0),(260,2,0),(261,2,0),(262,2,0),(263,2,0),(264,2,0),(265,2,0),(266,2,0),(267,2,0),(268,2,0),(269,2,0),(270,2,0),(271,2,0),(272,2,0),(273,2,0),(274,2,0),(275,2,0),(276,2,0),(277,2,0),(278,2,0),(279,2,0),(280,2,0),(281,2,0),(282,2,0),(283,2,0),(284,2,0),(285,2,0),(286,2,0),(287,2,0),(288,2,0),(289,2,0),(290,2,0),(291,2,0),(292,2,0),(293,2,0),(294,2,0),(295,2,0),(296,2,0),(297,2,0),(298,2,0),(299,2,0),(300,2,0),(301,2,0),(302,2,0),(303,2,0),(304,2,0),(305,2,0),(306,2,0),(307,2,0),(308,2,0),(309,2,0),(310,2,0),(311,2,0),(312,2,0),(313,2,0),(314,2,0),(315,2,0),(316,2,0),(317,2,0),(318,2,0),(319,2,0),(320,2,0),(321,2,0),(322,2,0),(323,2,0),(324,2,0),(325,2,0),(326,2,0),(327,2,0),(328,2,0),(329,2,0),(330,2,0),(331,2,0),(332,2,0),(333,2,0),(334,2,0),(335,2,0),(336,2,0),(337,2,0),(338,2,0),(339,2,0),(340,2,0),(341,2,0),(342,2,0),(343,2,0),(344,2,0),(345,2,0),(346,2,0),(347,2,0),(348,2,0),(349,2,0),(350,2,0),(351,2,0),(352,2,0),(353,2,0),(354,2,0),(355,2,0),(356,2,0),(357,2,0),(358,2,0),(359,2,0),(360,2,0),(361,2,0),(362,2,0),(363,2,0),(364,2,0),(365,2,0),(366,2,0),(367,2,0),(368,2,0),(369,2,0),(370,2,0),(371,2,0),(372,2,0),(373,2,0),(374,2,0),(375,2,0),(376,2,0),(377,2,0),(378,2,0),(379,2,0),(380,2,0),(381,2,0),(382,2,0),(383,2,0),(384,2,0),(385,2,0),(386,2,0),(387,2,0),(388,2,0),(389,2,0),(390,2,0),(391,2,0),(392,2,0),(393,2,0),(394,2,0),(395,2,0),(396,2,0),(397,2,0),(398,2,0),(399,2,0),(400,2,0),(401,2,0),(402,2,0),(403,2,0),(404,2,0),(405,2,0),(406,2,0),(407,2,0),(408,2,0),(409,2,0),(410,2,0),(411,2,0),(412,2,0),(413,2,0),(414,2,0),(415,2,0),(416,2,0),(417,2,0),(418,2,0),(419,2,0),(420,2,0),(421,2,0),(422,2,0),(423,2,0),(424,2,0),(425,2,0),(426,2,0),(427,2,0),(428,2,0),(429,2,0),(430,2,0),(431,2,0),(432,2,0),(433,2,0),(434,2,0),(435,2,0),(436,2,0),(437,2,0),(438,2,0),(439,2,0),(440,2,0),(441,2,0),(442,2,0),(443,2,0),(444,2,0),(445,2,0),(446,2,0),(447,2,0),(448,2,0),(449,2,0),(450,2,0),(451,2,0),(452,2,0),(453,2,0),(454,2,0),(455,2,0),(456,2,0),(457,2,0),(458,2,0),(459,2,0),(460,2,0),(461,2,0),(462,2,0),(463,2,0),(464,2,0),(465,2,0),(466,2,0),(467,2,0),(468,2,0),(469,2,0),(470,2,0),(471,2,0),(472,2,0),(473,2,0),(474,2,0),(475,2,0),(476,2,0),(477,2,0),(478,2,0),(479,2,0),(480,2,0),(481,2,0),(482,2,0),(483,2,0),(484,2,0),(485,2,0),(486,2,0),(487,2,0),(488,2,0),(489,2,0),(490,2,0),(491,2,0),(492,2,0),(493,2,0),(494,2,0),(495,2,0),(496,2,0),(497,2,0),(498,2,0),(499,2,0),(500,2,0),(501,2,0),(502,2,0),(503,2,0),(504,2,0),(505,2,0),(506,2,0),(507,2,0),(508,2,0),(509,2,0),(510,2,0),(511,2,0),(512,2,0),(513,2,0),(514,2,0),(515,2,0),(516,2,0),(517,2,0),(518,2,0),(519,2,0),(520,2,0),(521,2,0),(522,2,0),(523,2,0),(524,2,0),(525,2,0),(526,2,0),(527,2,0),(528,2,0),(529,2,0),(530,2,0),(531,2,0),(532,2,0),(533,2,0),(534,2,0),(535,2,0),(536,2,0),(537,2,0),(538,2,0),(539,2,0),(540,2,0),(541,2,0),(542,2,0),(543,2,0),(544,2,0),(545,2,0),(546,2,0),(547,2,0),(548,2,0),(549,2,0),(550,2,0),(551,2,0),(552,2,0),(553,2,0),(554,2,0),(555,2,0),(556,2,0),(557,2,0),(558,2,0),(559,2,0),(560,2,0),(561,2,0),(562,2,0),(563,2,0),(564,2,0),(565,2,0),(566,2,0),(567,2,0),(568,2,0),(569,2,0),(570,2,0),(571,2,0),(572,2,0),(573,2,0),(574,2,0),(575,2,0),(576,2,0),(577,2,0),(578,2,0),(579,2,0),(580,2,0),(581,2,0),(582,2,0),(583,2,0),(584,2,0),(585,2,0),(586,2,0),(587,2,0),(588,2,0),(589,2,0),(590,2,0),(591,2,0),(592,2,0),(593,2,0),(594,2,0),(595,2,0),(596,2,0),(597,2,0),(598,2,0),(599,2,0),(600,2,0),(601,2,0),(602,2,0),(603,2,0),(604,2,0),(605,2,0),(606,2,0),(607,2,0),(608,2,0),(609,2,0),(610,2,0),(611,2,0),(612,2,0),(613,2,0),(614,2,0),(615,2,0),(616,2,0),(617,2,0),(618,2,0),(619,2,0),(620,2,0),(621,2,0),(622,2,0),(623,2,0),(624,2,0),(625,2,0),(626,2,0),(627,2,0),(628,2,0),(629,2,0),(630,2,0),(631,2,0),(632,2,0),(633,2,0),(634,2,0),(635,2,0),(636,2,0),(637,2,0),(638,2,0),(639,2,0),(640,2,0),(641,2,0),(642,2,0),(643,2,0),(644,2,0),(645,2,0),(646,2,0),(647,2,0),(648,2,0),(649,2,0),(650,2,0),(651,2,0),(652,2,0),(653,2,0),(654,2,0),(655,2,0),(656,2,0),(657,2,0),(658,2,0),(659,2,0),(660,2,0),(661,2,0),(662,2,0),(663,2,0),(664,2,0),(665,2,0),(666,2,0),(667,2,0),(668,2,0),(669,2,0),(670,2,0),(671,2,0),(672,2,0),(673,2,0),(674,2,0),(675,2,0),(676,2,0),(677,2,0),(678,2,0),(679,2,0),(680,2,0),(681,2,0),(682,2,0),(683,2,0),(684,2,0),(685,2,0),(686,2,0),(687,2,0),(688,2,0),(689,2,0),(690,2,0),(691,2,0),(692,2,0),(693,2,0),(694,2,0),(695,2,0),(696,2,0),(697,2,0),(698,2,0),(699,2,0),(700,2,0),(701,2,0),(702,2,0),(703,2,0),(704,2,0),(705,2,0),(706,2,0),(707,2,0),(708,2,0),(709,2,0),(710,2,0),(711,2,0),(712,2,0),(713,2,0),(714,2,0),(715,2,0),(716,2,0),(717,2,0),(718,2,0),(719,2,0),(720,2,0),(721,2,0),(722,2,0),(723,2,0),(724,2,0),(725,2,0),(726,2,0),(727,2,0),(728,2,0),(729,2,0),(730,2,0),(731,2,0),(732,2,0),(733,2,0),(734,2,0),(735,2,0),(736,2,0),(737,2,0),(738,2,0),(739,2,0),(740,2,0),(741,2,0),(742,2,0),(743,2,0),(744,2,0),(745,2,0),(746,2,0),(747,2,0),(748,2,0),(749,2,0),(750,2,0),(751,2,0),(752,2,0),(753,2,0),(754,2,0),(755,2,0),(756,2,0),(757,2,0),(758,2,0),(759,2,0),(760,2,0),(761,2,0),(762,2,0),(763,2,0),(764,2,0),(765,2,0),(766,2,0),(767,2,0),(768,2,0),(769,2,0),(770,2,0),(771,2,0),(772,2,0),(773,2,0),(774,2,0),(775,2,0),(776,2,0),(777,2,0),(778,2,0),(779,2,0),(780,2,0),(781,2,0),(782,2,0),(783,2,0),(784,2,0),(785,2,0),(786,2,0),(787,2,0),(788,2,0),(789,2,0),(790,2,0),(791,2,0),(792,2,0),(793,2,0),(794,2,0),(795,2,0),(796,2,0),(797,2,0),(798,2,0),(799,2,0),(800,2,0),(801,2,0),(802,2,0),(803,2,0),(804,2,0),(805,2,0),(806,2,0),(807,2,0),(808,2,0),(809,2,0),(810,2,0),(811,2,0),(812,2,0),(813,2,0),(814,2,0),(815,2,0),(816,2,0),(817,2,0),(818,2,0),(819,2,0),(820,2,0),(821,2,0),(822,2,0),(823,2,0),(824,2,0),(825,2,0),(826,2,0),(827,2,0),(828,2,0),(829,2,0),(830,2,0),(831,2,0),(832,2,0),(833,2,0),(834,2,0),(835,2,0),(836,2,0),(837,2,0),(838,2,0),(839,2,0),(840,2,0),(841,2,0),(842,2,0),(843,2,0),(844,2,0),(845,2,0),(846,2,0),(847,2,0),(848,2,0),(849,2,0),(850,2,0),(851,2,0),(852,2,0),(853,2,0),(854,2,0),(855,2,0),(856,2,0),(857,2,0),(858,2,0),(859,2,0),(860,2,0),(861,2,0),(862,2,0),(863,2,0),(864,2,0),(865,2,0),(866,2,0),(867,2,0),(868,2,0),(869,2,0),(870,2,0),(871,2,0),(872,2,0),(873,2,0),(874,2,0),(875,2,0),(876,2,0),(877,2,0),(878,2,0),(879,2,0),(880,2,0),(881,2,0),(882,2,0),(883,2,0),(884,2,0),(885,2,0),(886,2,0),(887,2,0),(888,2,0),(889,2,0),(890,2,0),(891,2,0),(892,2,0),(893,2,0),(894,2,0),(895,2,0),(896,2,0),(897,2,0),(898,2,0),(899,2,0),(900,2,0),(901,2,0),(902,2,0),(903,2,0),(904,2,0),(905,2,0),(906,2,0),(907,2,0),(908,2,0),(909,2,0),(910,2,0),(911,2,0),(912,2,0),(913,2,0),(914,2,0),(915,2,0),(916,2,0),(917,2,0),(918,2,0),(919,2,0),(920,2,0),(921,2,0),(922,2,0),(923,2,0),(924,2,0),(925,2,0),(926,2,0),(927,2,0),(928,2,0),(929,2,0),(930,2,0),(931,2,0),(932,2,0),(933,2,0),(934,2,0),(935,2,0),(936,2,0),(937,2,0),(938,2,0),(939,2,0),(940,2,0),(941,2,0),(942,2,0),(943,2,0),(944,2,0),(945,2,0),(946,2,0),(947,2,0),(948,2,0),(949,2,0),(950,2,0),(951,2,0),(952,2,0),(953,2,0),(954,2,0),(955,2,0),(956,2,0),(957,2,0),(958,2,0),(959,2,0),(960,2,0),(961,2,0),(962,2,0),(963,2,0),(964,2,0),(965,2,0),(966,2,0),(967,2,0),(968,2,0),(969,2,0),(970,2,0),(971,2,0),(972,2,0),(973,2,0),(974,2,0),(975,2,0),(976,2,0),(977,2,0),(978,2,0),(979,2,0),(980,2,0),(981,2,0),(982,2,0),(983,2,0),(984,2,0),(985,2,0),(986,2,0),(987,2,0),(988,2,0),(989,2,0),(990,2,0),(991,2,0),(992,2,0),(993,2,0),(994,2,0),(995,2,0),(996,2,0),(997,2,0),(998,2,0),(999,2,0),(1000,2,0),(1001,2,0),(1002,2,0),(1003,2,0),(1004,2,0),(1005,2,0),(1006,2,0),(1007,2,0),(1008,2,0),(1009,2,0),(1010,2,0),(1011,2,0),(1012,2,0),(1013,2,0),(1014,2,0),(1015,2,0),(1016,2,0),(1017,2,0),(1018,2,0),(1019,2,0),(1020,2,0),(1021,2,0),(1022,2,0),(1023,2,0),(1024,2,0),(1025,2,0),(1026,2,0),(1027,2,0),(1028,2,0),(1029,2,0),(1030,2,0),(1031,2,0),(1032,2,0),(1033,2,0),(1034,2,0),(1035,2,0),(1036,2,0),(1037,2,0),(1038,2,0),(1039,2,0),(1040,2,0),(1041,2,0),(1042,2,0),(1043,2,0),(1044,2,0),(1045,2,0),(1046,2,0),(1047,2,0),(1048,2,0),(1049,2,0),(1050,2,0),(1051,2,0),(1052,2,0),(1053,2,0),(1054,2,0),(1055,2,0),(1056,2,0),(1057,2,0),(1058,2,0),(1059,2,0),(1060,2,0),(1061,2,0),(1062,2,0),(1063,2,0),(1064,2,0),(1065,2,0),(1066,2,0),(1067,2,0),(1068,2,0),(1069,2,0),(1070,2,0),(1071,2,0),(1072,2,0),(1073,2,0),(1074,2,0),(1075,2,0),(1076,2,0),(1077,2,0),(1078,2,0),(1079,2,0),(1080,2,0),(1081,2,0),(1082,2,0),(1083,2,0),(1084,2,0),(1085,2,0),(1086,2,0),(1087,2,0),(1088,2,0),(1089,2,0),(1090,2,0),(1091,2,0),(1092,2,0),(1093,2,0),(1094,2,0),(1095,2,0),(1096,2,0),(1097,2,0),(1098,2,0),(1099,2,0),(1100,2,0),(1101,2,0),(1102,2,0),(1103,2,0),(1104,2,0),(1105,2,0),(1106,2,0),(1107,2,0),(1108,2,0),(1109,2,0),(1110,2,0),(1111,2,0),(1112,2,0),(1113,2,0),(1114,2,0),(1115,2,0),(1116,2,0),(1117,2,0),(1118,2,0),(1119,2,0),(1120,2,0),(1121,2,0),(1122,2,0),(1,2,1364308922);
/*!40000 ALTER TABLE `search_api_item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `search_api_page`
--

DROP TABLE IF EXISTS `search_api_page`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_api_page` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a search page.',
  `index_id` varchar(50) NOT NULL COMMENT 'The search_api_index.machine_name this page will search on.',
  `path` varchar(50) NOT NULL COMMENT 'The path at which this search page can be viewed.',
  `name` varchar(50) NOT NULL COMMENT 'The displayed name for a search page.',
  `machine_name` varchar(50) NOT NULL COMMENT 'The machine name for a search page.',
  `description` text COMMENT 'The displayed description for a search page.',
  `options` text NOT NULL COMMENT 'The options used to configure the search page.',
  `enabled` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'A flag indicating whether the search page is enabled.',
  `status` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'The exportable status of the entity.',
  `module` varchar(255) DEFAULT NULL COMMENT 'The name of the providing module if the entity has been defined in code.',
  PRIMARY KEY (`id`),
  KEY `enabled` (`enabled`),
  KEY `index_id` (`index_id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_api_page`
--

LOCK TABLES `search_api_page` WRITE;
/*!40000 ALTER TABLE `search_api_page` DISABLE KEYS */;
INSERT INTO `search_api_page` VALUES (1,'default_fuzzysearch_index','fmc-search','Search','search',NULL,'a:5:{s:4:\"mode\";s:5:\"terms\";s:6:\"fields\";a:0:{}s:8:\"per_page\";s:2:\"50\";s:12:\"get_per_page\";i:1;s:9:\"view_mode\";s:22:\"search_api_page_result\";}',1,1,NULL);
/*!40000 ALTER TABLE `search_api_page` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `search_api_server`
--

DROP TABLE IF EXISTS `search_api_server`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_api_server` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a server.',
  `name` varchar(50) NOT NULL COMMENT 'The displayed name for a server.',
  `machine_name` varchar(50) NOT NULL COMMENT 'The machine name for a server.',
  `description` text COMMENT 'The displayed description for a server.',
  `class` varchar(50) NOT NULL COMMENT 'The id of the service class to use for this server.',
  `options` mediumtext NOT NULL COMMENT 'The options used to configure the service object.',
  `enabled` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'A flag indicating whether the server is enabled.',
  `status` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'The exportable status of the entity.',
  `module` varchar(255) DEFAULT NULL COMMENT 'The name of the providing module if the entity has been defined in code.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `machine_name` (`machine_name`),
  KEY `enabled` (`enabled`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COMMENT='Stores all search servers created through the Search API.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_api_server`
--

LOCK TABLES `search_api_server` WRITE;
/*!40000 ALTER TABLE `search_api_server` DISABLE KEYS */;
/*!40000 ALTER TABLE `search_api_server` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `search_dataset`
--

DROP TABLE IF EXISTS `search_dataset`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_dataset` (
  `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Search item ID, e.g. node ID for nodes.',
  `type` varchar(16) NOT NULL COMMENT 'Type of item, e.g. node.',
  `data` longtext NOT NULL COMMENT 'List of space-separated words from the item.',
  `reindex` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Set to force node reindexing.',
  PRIMARY KEY (`sid`,`type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores items that will be searched.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_dataset`
--

LOCK TABLES `search_dataset` WRITE;
/*!40000 ALTER TABLE `search_dataset` DISABLE KEYS */;
INSERT INTO `search_dataset` VALUES (96281,'node',' ibmesxs serial attached scsi disk naa5000c50041938b37  ',0),(96282,'node',' ata serial attached scsi disk naa5002538050003d09  ',0),(96284,'node',' naa6000c29a784d07bfd536222612ee057f ',0),(96285,'node',' naa6000c29eeb2b6dbd2d24552781be174b ',0),(96077,'node',' netapp fibre channel disk naa60a9800037543261553f41783945462f  ',0),(96115,'node',' naa6000c290b1821e62cf431ca26bf1f765 ',0),(96122,'node',' naa6000c2973380870eb4d88784ea671eca ',0),(96123,'node',' naa6000c29102ce37a07ac01e2ced3959b8 ',0),(96124,'node',' naa60a9800037543261505d424f31325645 ',0),(96126,'node',' naa6000c291fd64f90bd3d371b644cee3c5 ',0),(96071,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325559  ',0),(96072,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325637  ',0),(96073,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325751  ',0),(96074,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325755  ',0),(96064,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325653  ',0),(96065,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325731  ',0),(96066,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325737  ',0),(96067,'node',' netapp fibre channel disk naa60a9800037543261505d424f3132574f  ',0),(96058,'node',' ata serial attached scsi disk naa5002538050003d38  ',0),(96059,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325764  ',0),(96060,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325768  ',0),(96061,'node',' netapp fibre channel disk naa60a9800037543261553f417839454153  ',0),(96062,'node',' netapp fibre channel disk naa60a9800037543261553f417839454155  ',0),(96063,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325651  ',0),(96068,'node',' netapp fibre channel disk naa60a9800037543261553f417839454855  ',0),(96069,'node',' netapp fibre channel disk naa60a9800037543261553f417839454857  ',0),(96070,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325274  ',0),(96075,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325757  ',0),(96076,'node',' netapp fibre channel disk naa60a9800037543261505d424f3132567a  ',0),(96133,'node',' naa6000c2908e605dca09ff6427d4bd914a ',0),(96279,'node',' ibmesxs serial attached scsi disk naa5000c50040cc7d03  ',0),(96280,'node',' netapp serial attached scsi disk naa600a09803c1b589db5363869fc0027d0  ',0),(96431,'node',' naa6000c294aba0be1db4257742f4ab2149 ',0),(1,'node',' fmcbariumtest w3j 4jd6iwnjnv2hwccrmg nrfgbzniq67sfr4arsbb w hgvcenter01gdlenglabnetappcom  ',1371656328),(98841,'node',' local vmware disk mpxvmhba1 c0 t0 l0  ',0),(98840,'node',' local vmware disk mpxvmhba1 c0 t2 l0  ',0),(98847,'node',' x36903vm1 ',0),(192214,'node',' 1371628866   ',0),(192211,'node',' 1371628866   ',0),(192213,'node',' 1371628866   ',0),(192210,'node',' 1371628866   ',0),(192191,'node',' 1371628749   ',0),(192207,'node',' 1371628865   ',0),(192208,'node',' 1371628865   ',0),(192209,'node',' 1371628865   ',0),(127598,'node',' 1371220622   ',0),(127599,'node',' 1371220622   ',0),(127602,'node',' 1371220682   ',0),(127603,'node',' 1371220682   ',0),(127606,'node',' 1371220742   ',0),(127607,'node',' 1371220742   ',0),(127610,'node',' 1371220802   ',0),(127611,'node',' 1371220802   ',0),(127614,'node',' 1371220862   ',0),(127615,'node',' 1371220862   ',0),(127618,'node',' 1371220922   ',0),(127619,'node',' 1371220922   ',0),(127622,'node',' 1371220982   ',0),(127623,'node',' 1371220982   ',0),(127626,'node',' 1371221042   ',0),(127627,'node',' 1371221042   ',0),(127630,'node',' 1371221102 10000  ',0),(127638,'node',' 1371221222   ',0),(127639,'node',' 1371221222   ',0),(127631,'node',' 1371221102   ',0),(127634,'node',' 1371221162   ',0),(127635,'node',' 1371221162   ',0),(127642,'node',' 1371221282   ',0),(127643,'node',' 1371221282   ',0),(127646,'node',' 1371221342   ',0),(127647,'node',' 1371221342   ',0),(127650,'node',' 1371221401   ',0),(127651,'node',' 1371221401   ',0),(127654,'node',' 1371221462   ',0),(127655,'node',' 1371221462   ',0),(127658,'node',' 1371221524   ',0),(127659,'node',' 1371221524   ',0),(127662,'node',' 1371221582   ',0),(127663,'node',' 1371221582   ',0),(127666,'node',' 1371221643   ',0),(127667,'node',' 1371221643   ',0),(127670,'node',' 1371221703   ',0),(127671,'node',' 1371221703   ',0),(127674,'node',' 1371221762   ',0),(127675,'node',' 1371221762   ',0),(127678,'node',' 1371221822   ',0),(127679,'node',' 1371221822   ',0),(127682,'node',' 1371221882   ',0),(127683,'node',' 1371221882   ',0),(127686,'node',' 1371221942   ',0),(127687,'node',' 1371221942   ',0),(127690,'node',' 1371222002   ',0),(127691,'node',' 1371222002   ',0),(127694,'node',' 1371222063   ',0),(127695,'node',' 1371222063   ',0),(127698,'node',' 1371222122   ',0),(127699,'node',' 1371222122   ',0),(127702,'node',' 1371222182   ',0),(127703,'node',' 1371222182   ',0),(127706,'node',' 1371222242   ',0),(127707,'node',' 1371222242   ',0),(127715,'node',' 1371222362   ',0),(127718,'node',' 1371222422   ',0),(127710,'node',' 1371222302   ',0),(127711,'node',' 1371222302   ',0),(127714,'node',' 1371222362   ',0),(127719,'node',' 1371222422   ',0),(127722,'node',' 1371222482   ',0),(127723,'node',' 1371222482   ',0),(127726,'node',' 1371222542   ',0),(127727,'node',' 1371222542   ',0),(127730,'node',' 1371222602   ',0),(127731,'node',' 1371222602   ',0),(127734,'node',' 1371222662   ',0),(127735,'node',' 1371222662   ',0),(127738,'node',' 1371222722   ',0),(127739,'node',' 1371222722 5000  ',0),(127742,'node',' 1371222782   ',0),(127743,'node',' 1371222782   ',0),(127746,'node',' 1371222842   ',0),(127747,'node',' 1371222842   ',0),(127750,'node',' 1371222902   ',0),(127751,'node',' 1371222902   ',0),(127754,'node',' 1371222962   ',0),(127755,'node',' 1371222962   ',0),(127758,'node',' 1371223022   ',0),(127759,'node',' 1371223022   ',0),(127762,'node',' 1371223082   ',0),(127763,'node',' 1371223082   ',0),(127766,'node',' 1371223142   ',0),(127767,'node',' 1371223142   ',0),(127770,'node',' 1371223202   ',0),(127771,'node',' 1371223202   ',0),(127774,'node',' 1371223262   ',0),(127775,'node',' 1371223262   ',0),(127779,'node',' 1371223332   ',0),(127780,'node',' 1371223332   ',0),(127782,'node',' 1371223382   ',0),(127783,'node',' 1371223382   ',0),(127786,'node',' 1371223442   ',0),(127787,'node',' 1371223442   ',0),(127790,'node',' 1371223502   ',0),(127791,'node',' 1371223502   ',0),(127795,'node',' 1371223562   ',0),(127796,'node',' 1371223562   ',0),(192364,'node',' 1371629469   ',0),(192363,'node',' 1371629469   ',0),(192359,'node',' 1371629412   ',0),(192355,'node',' 1371629412   ',0),(192357,'node',' 1371629412   ',0),(192362,'node',' 1371629469   ',0),(192327,'node',' 1371629287   ',0),(192352,'node',' 1371629412   ',0),(192329,'node',' 1371629287   ',0),(192324,'node',' 1371629287   ',0),(192325,'node',' 1371629287   ',0),(192321,'node',' 1371629287   ',0),(192323,'node',' 1371629287   ',0),(192319,'node',' 1371629286   ',0),(192295,'node',' 1371629226   ',0),(192317,'node',' 1371629286   ',0),(192318,'node',' 1371629286   ',0),(192296,'node',' 1371629226   ',0),(192285,'node',' 1371629167   ',0),(192287,'node',' 1371629167   ',0),(192290,'node',' 1371629226   ',0),(192268,'node',' 1371629165   ',0),(192293,'node',' 1371629226   ',0),(192236,'node',' 1371628946   ',0),(192225,'node',' 1371628945   ',0),(192228,'node',' 1371628945   ',0),(192231,'node',' 1371628945   ',0),(192204,'node',' 1371628865   ',0),(192224,'node',' 1371628945   ',0),(192263,'node',' 1371629116   ',0),(192243,'node',' 1371628946   ',0),(192246,'node',' 1371629114   ',0),(192239,'node',' 1371628946   ',0),(192241,'node',' 1371628946   ',0),(192247,'node',' 1371629114   ',0),(192248,'node',' 1371629114   ',0),(192249,'node',' 1371629114   ',0),(192257,'node',' 1371629115   ',0),(192250,'node',' 1371629114   ',0),(192251,'node',' 1371629114   ',0),(192252,'node',' 1371629114   ',0),(192336,'node',' 1371629350   ',0),(192337,'node',' 1371629350   ',0),(192316,'node',' 1371629286   ',0),(192315,'node',' 1371629286   ',0),(192301,'node',' 1371629227   ',0),(192297,'node',' 1371629226   ',0),(192299,'node',' 1371629226   ',0),(192303,'node',' 1371629227   ',0),(192302,'node',' 1371629227   ',0),(192307,'node',' 1371629227   ',0),(192305,'node',' 1371629227   ',0),(192309,'node',' 1371629227   ',0),(192312,'node',' 1371629286   ',0),(192313,'node',' 1371629286   ',0),(192314,'node',' 1371629286   ',0),(192334,'node',' 1371629350   ',0),(192338,'node',' 1371629350   ',0),(192340,'node',' 1371629350   ',0),(192342,'node',' 1371629350   ',0),(192344,'node',' 1371629351   ',0),(99397,'node',' naa600a098044307259313f334556393444 ',0),(99398,'node',' naa600a098044307535732b334571533579 ',0),(99394,'node',' hgw2k8r232vm32 ',0),(99395,'node',' naa6000c2937aedbf22b1bf4f872c4765df ',0),(99396,'node',' naa600a098044307259313f334556393443 ',0),(99392,'node',' flash accel management console 11 ',0),(99393,'node',' hgw2k8r232vm33 ',0),(99391,'node',' flash accel management console 12 ',0),(99389,'node',' hgw2k8r232vm30 ',0),(99390,'node',' hgw2k8r232vm31 ',0),(99387,'node',' hgw2k8r232vm28 ',0),(99388,'node',' hgw2k8r232vm29 ',0),(99386,'node',' hgw2k8r232vm27 ',0),(99384,'node',' hgw2k8r232vm25 ',0),(99385,'node',' hgw2k8r232vm26 ',0),(99382,'node',' hgw2k8r232vm23 ',0),(99383,'node',' hgw2k8r232vm24 ',0),(99378,'node',' naa6000c29b4b82c4cc1945e2db12671829 ',0),(99379,'node',' naa6000c29e08ce8c49f3881f5e5458acda ',0),(99380,'node',' naa6000c29beb328cfb51bf06835ac5ed52 ',0),(99381,'node',' naa6000c2921dd7be48256aa02064b5d01d ',0),(99375,'node',' naa6000c295eaa5dccf467bbae8044414ce ',0),(99376,'node',' naa6000c29b205838c4c55aaafda23eed79 ',0),(99377,'node',' naa6000c29a03b63f95b8f592f18d630b86 ',0),(99371,'node',' naa6000c29c8124bd2298ececba4c3782b1 ',0),(99372,'node',' naa6000c29b3fec74f237a67afa746f5d55 ',0),(99373,'node',' naa6000c2935c4a6942cc0cd05e188cf9ba ',0),(99374,'node',' naa6000c29c58d9db25ed3a37b024d23841 ',0),(99363,'node',' naa6000c29aab2e04f2571c7c6050ee8353 ',0),(99364,'node',' naa6000c294064b8b30c8452cef95062d75 ',0),(99365,'node',' naa6000c29a1b45eeace0049699f7123c20 ',0),(99370,'node',' naa6000c297b449a234fac7c88a0cbeb75e ',0),(99359,'node',' naa6000c29a09f274bcd4bbf3ae484e5e7a ',0),(99369,'node',' naa6000c299e65677701b273f929adbcc1f ',0),(99360,'node',' naa6000c29ac85e6f88af7b4f6868fbe87a ',0),(99361,'node',' naa6000c2940cc5bf41316a55e0c94957c8 ',0),(99368,'node',' naa6000c29af0bf917f423b0f7b4d54e792 ',0),(99362,'node',' naa6000c29d4e2ce7b705f66fdbdb461313 ',0),(99366,'node',' naa6000c296b486ba69a3f71bbafc3e5f15 ',0),(99367,'node',' naa6000c298693d22a716644668f808bc18 ',0),(99354,'node',' naa6000c291fd2395fe3c1997950b8a8c0c ',0),(99355,'node',' naa6000c2967439883ffd8ad92ee6de2a3c ',0),(99356,'node',' naa6000c29a8d23467dedb9b0a508ab6f92 ',0),(99357,'node',' naa6000c290abfaf53c3b2c643b607038bf ',0),(99358,'node',' naa6000c2953e4b58e3268b2275f65c00b3 ',0),(99347,'node',' naa6000c292f6633bcff2180b75206f0661 ',0),(99348,'node',' naa6000c2961e793febff84f5ced5c58b21 ',0),(99349,'node',' naa6000c29bc48a17080060b2a7a04002fc ',0),(99350,'node',' naa6000c29121e66c0d79b623de3052d405 ',0),(99351,'node',' naa6000c297064a18dfa88eced6be50e057 ',0),(99352,'node',' naa6000c2950cabe6ece937dc69d952ae4e ',0),(99353,'node',' naa6000c29eecc6e9adbb0132e3b3ff7d22 ',0),(99343,'node',' naa6000c29df644dce63fd960a3bf12b1d5 ',0),(99344,'node',' naa6000c294f5dd6c075c769db0311d7918 ',0),(99345,'node',' naa6000c29e9e802ff92aa3e9751bb1ccf8 ',0),(99346,'node',' naa6000c290d6a786993a27840bc7e74219 ',0),(99340,'node',' naa6000c29675dd7a7e994beefc89fb5588 ',0),(99341,'node',' naa6000c29bf5e027a66f21c82dcb90d5f2 ',0),(99342,'node',' naa6000c290953dbf42f2b92e416d97f3d6 ',0),(99336,'node',' naa6000c2997b6962f32a26b73da8e61119 ',0),(99337,'node',' naa6000c298ceb3a9e5a4bd63b85488b9e6 ',0),(99338,'node',' naa6000c2956b7de21f10dd9f2621408e5a ',0),(99339,'node',' naa6000c2950d47cdaa94a633480603dd7e ',0),(99332,'node',' naa6000c29c778256eb8f4b6c1a1dce5fcb ',0),(99333,'node',' naa6000c296839ce8de1e698a38b6fc7173 ',0),(99334,'node',' naa6000c29b18316ab182310d09e03d2b2a ',0),(99335,'node',' naa6000c29ff0e809d5b2af05c5768c5cff ',0),(99329,'node',' naa6000c29efaa27da235fda642d90b098e ',0),(99330,'node',' naa6000c2984c0245d266169b9686a2e0c5 ',0),(99331,'node',' naa6000c29682c740d63afb534636704664 ',0),(99325,'node',' naa600a098044307259313f334556393436 ',0),(99326,'node',' naa600a098044307535732b334571533571 ',0),(99327,'node',' naa600a098044307259313f334556393435 ',0),(99328,'node',' naa6000c2908408da158a5c3bfb61c07879 ',0),(99318,'node',' hgw2k8r232vm18 ',0),(99317,'node',' hgw2k8r232vm17 ',0),(99313,'node',' naa6000c2938bb49a8d2e5d49b476c92cf9 ',0),(99314,'node',' naa6000c29b23567272d0e586205dcc32cf ',0),(99311,'node',' naa6000c29a5e879be9aeff82ec4073485e ',0),(99307,'node',' naa6000c29277c4580946c7adda249783a0 ',0),(99304,'node',' naa6000c29de233a6cbb6e5b79519ee353a ',0),(99300,'node',' naa6000c295475d09ab8ae1de90a71dec6f ',0),(99322,'node',' hgw2k8r232vm22 ',0),(99323,'node',' naa6000c293a337fcf57f8ea9762309fd54 ',0),(99324,'node',' naa600a098044307535732b334571533572 ',0),(99321,'node',' hgw2k8r232vm21 ',0),(99319,'node',' hgw2k8r232vm19 ',0),(99320,'node',' hgw2k8r232vm20 ',0),(99315,'node',' naa6000c295e8b49c56dd6827fe418ea715 ',0),(99316,'node',' naa6000c2981d553aa25cfefeeb7b4bc25e ',0),(99312,'node',' naa6000c2950a1a5ab366bf05b6692f2079 ',0),(99308,'node',' naa6000c29980b86140cc05e5ce0e9e43b1 ',0),(99309,'node',' naa6000c2918b7a0a89bc9c6ffe16eb9871 ',0),(99310,'node',' naa6000c299d3ae339df867c0de47a27d80 ',0),(99305,'node',' naa6000c29b26a3835e07a5d36f5837bba5 ',0),(99306,'node',' naa6000c29a1f5f7d26f2a75fb16217d54e ',0),(99301,'node',' naa6000c2948cee8e308227c11728d12994 ',0),(99302,'node',' naa6000c291e7664b34dc236a785a15a710 ',0),(99303,'node',' naa6000c29783fc4f972a0e2aa7af5c9ebc ',0),(192499,'node',' 1371629947   ',0),(192395,'node',' 1371629527   ',0),(192397,'node',' 1371629527   ',0),(192393,'node',' 1371629527   ',0),(192405,'node',' 1371629648   ',0),(192406,'node',' 1371629648   ',0),(192402,'node',' 1371629648   ',0),(192403,'node',' 1371629648   ',0),(192404,'node',' 1371629648   ',0),(192399,'node',' 1371629527   ',0),(192430,'node',' 1371629719   ',0),(192432,'node',' 1371629719   ',0),(192428,'node',' 1371629719   ',0),(192439,'node',' 1371629784   ',0),(192437,'node',' 1371629784 1397  ',0),(192434,'node',' 1371629719   ',0),(192467,'node',' 1371629885   ',0),(192464,'node',' 1371629878 6667  ',0),(192471,'node',' 1371629885   ',0),(192469,'node',' 1371629885   ',0),(192470,'node',' 1371629885   ',0),(192468,'node',' 1371629885   ',0),(192494,'node',' 1371629946   ',0),(192493,'node',' 1371629946   ',0),(192500,'node',' 1371629947   ',0),(192498,'node',' 1371629946   ',0),(192495,'node',' 1371629946   ',0),(192496,'node',' 1371629946   ',0),(192520,'node',' 1371630006   ',0),(98853,'node',' hgrx3001gdlenglabnetappcom ',0),(98854,'node',' hgx36902gdlenglabnetappcom ',0),(98855,'node',' hgx36904gdlenglabnetappcom ',0),(98856,'node',' hgrx6001gdlenglabnetappcom ',0),(98857,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325764  ',0),(98858,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325768  ',0),(98859,'node',' netapp fibre channel disk naa60a9800037543261553f417839454153  ',0),(98860,'node',' netapp fibre channel disk naa60a9800037543261553f417839454155  ',0),(98861,'node',' netapp fibre channel disk naa60a9800037543261505d424f3132564f  ',0),(98862,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325651  ',0),(98863,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325653  ',0),(98865,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325737  ',0),(98864,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325731  ',0),(98866,'node',' netapp fibre channel disk naa60a9800037543261505d424f3132574f  ',0),(98868,'node',' netapp fibre channel disk naa60a9800037543261553f417839454857  ',0),(98867,'node',' netapp fibre channel disk naa60a9800037543261553f417839454855  ',0),(98869,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325274  ',0),(98871,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325637  ',0),(98870,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325559  ',0),(98873,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325755  ',0),(98872,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325751  ',0),(98874,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325757  ',0),(98875,'node',' netapp fibre channel disk naa60a9800037543261505d424f3132567a  ',0),(98876,'node',' netapp fibre channel disk naa60a9800037543261553f41783945462f  ',0),(98877,'node',' netapp fibre channel disk naa60a9800037543261553f41783945482f  ',0),(98878,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325564  ',0),(98879,'node',' netapp iscsi disk naa60a9800037543261553f41783944524b  ',0),(98880,'node',' netapp iscsi disk naa60a9800037543261553f41783944524d  ',0),(98881,'node',' netapp iscsi disk naa60a9800037543261553f41783944524f  ',0),(98882,'node',' netapp iscsi disk naa60a9800037543261553f417839454159  ',0),(98883,'node',' netapp iscsi disk naa60a9800037543261553f417839445251  ',0),(98884,'node',' netapp iscsi disk naa60a9800037543261553f417839445176  ',0),(98892,'node',' ibmesxs serial attached scsi disk naa5000c50041938b37  ',0),(98885,'node',' netapp iscsi disk naa60a9800037543261553f417839445253  ',0),(98886,'node',' netapp iscsi disk naa60a9800037543261553f417839445178  ',0),(98887,'node',' netapp iscsi disk naa60a9800037543261553f417839445255  ',0),(98889,'node',' netapp iscsi disk naa60a9800037543261553f417839454162  ',0),(98888,'node',' netapp iscsi disk naa60a9800037543261553f41783944517a  ',0),(98890,'node',' netapp serial attached scsi disk naa600a09803c1b589db5363869fc0027d0  ',0),(98891,'node',' netapp iscsi disk naa60a9800037543261553f417839445235  ',0),(98893,'node',' ata serial attached scsi disk naa5002538050003d09  ',0),(98894,'node',' netapp iscsi disk naa60a9800037543261553f417839445245  ',0),(98895,'node',' netapp iscsi disk naa60a9800037543261553f417839445247  ',0),(98898,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325568  ',0),(98896,'node',' netapp iscsi disk naa60a9800037543261553f417839445249  ',0),(98897,'node',' netapp iscsi disk naa60a9800037543261505d424f31325645  ',0),(98899,'node',' netapp iscsi disk naa60a9800037543261505d424f31325647  ',0),(98905,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325578  ',0),(98900,'node',' netapp iscsi disk naa60a9800037543261505d424f31325649  ',0),(98902,'node',' local ibm disk naa600605b0042a0dd01895642016bf17dc  ',0),(98901,'node',' netapp fibre channel disk naa60a9800037543261505d424f3132556a  ',0),(98903,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325570  ',0),(98904,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325572  ',0),(98906,'node',' netapp fibre channel disk naa60a9800037543261505d424f3132557a  ',0),(98907,'node',' netapp fibre channel disk naa60a9800037543261505d424f3132554f  ',0),(98908,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325551  ',0),(98909,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325553  ',0),(98910,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325631  ',0),(98911,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325555  ',0),(98912,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325633  ',0),(98913,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325557  ',0),(98914,'node',' netapp iscsi disk naa60a9800037543261505d424f31325639  ',0),(98915,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325670  ',0),(98916,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325672  ',0),(98917,'node',' local ibm disk naa600605b0042a0dd01916818716e4e397  ',0),(98918,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325674  ',0),(98919,'node',' netapp serial attached scsi disk naa600a09809324a93ace0e8370fc013750  ',0),(98920,'node',' netapp iscsi disk naa60a9800037543261505d424f31325641  ',0),(98921,'node',' netapp iscsi disk naa60a9800037543261505d424f31325643  ',0),(98922,'node',' netapp fibre channel disk naa60a9800037543261505d424f31325566  ',0),(98923,'node',' netapp fibre channel disk naa600a098044307259313f334556393464  ',0),(98924,'node',' netapp fibre channel disk naa600a098044307259313f334556393465  ',0),(98925,'node',' netapp fibre channel disk naa600a098044307259313f334556393466  ',0),(98927,'node',' netapp fibre channel disk naa600a098044307259313f334556393468  ',0),(98926,'node',' netapp fibre channel disk naa600a098044307259313f334556393467  ',0),(98928,'node',' netapp fibre channel disk naa600a098044307259313f334556393469  ',0),(98929,'node',' netapp serial attached scsi disk naa600a0980939a29efb56946117b03aba2  ',0),(98930,'node',' netapp fibre channel disk naa600a098044307259313f33455639342d  ',0),(98931,'node',' netapp fibre channel disk naa600a098044307259313f33455639342f  ',0),(98932,'node',' netapp fibre channel disk naa600a098044307259313f33455639346a  ',0),(98933,'node',' netapp fibre channel disk naa600a098044307259313f33455639346b  ',0),(98934,'node',' netapp fibre channel disk naa600a098044307259313f33455639346c  ',0),(98935,'node',' netapp fibre channel disk naa600a098044307259313f33455639346d  ',0),(98936,'node',' netapp fibre channel disk naa600a098044307259313f33455639346e  ',0),(98937,'node',' netapp fibre channel disk naa600a098044307259313f33455639346f  ',0),(98938,'node',' netapp fibre channel disk naa600a098044307535732b334571533630  ',0),(98939,'node',' netapp fibre channel disk naa600a098044307535732b334571533631  ',0),(98940,'node',' netapp fibre channel disk naa600a098044307535732b334571533632  ',0),(98941,'node',' netapp fibre channel disk naa600a098044307535732b334571533633  ',0),(98942,'node',' netapp fibre channel disk naa600a098044307535732b334571533634  ',0),(98943,'node',' netapp fibre channel disk naa600a098044307535732b334571533635  ',0),(98944,'node',' netapp fibre channel disk naa600a098044307535732b334571533636  ',0),(98945,'node',' netapp fibre channel disk naa600a098044307535732b334571533637  ',0),(98946,'node',' netapp fibre channel disk naa600a098044307535732b334571533638  ',0),(98947,'node',' netapp fibre channel disk naa600a098044307535732b334571533639  ',0),(98948,'node',' netapp fibre channel disk naa600a098044307535732b334571533670  ',0),(98949,'node',' netapp fibre channel disk naa600a098044307535732b334571533671  ',0),(98950,'node',' netapp serial attached scsi disk naa600a0980219f29ef2f974c117b04aba2  ',0),(98951,'node',' lsi serial attached scsi disk naa600508e07e7261775c39bd2ebac3410f  ',0),(98952,'node',' netapp fibre channel disk naa600a098044307259313f334556393430  ',0),(192645,'node',' 1371630366   ',0),(192646,'node',' 1371630366   ',0),(192648,'node',' 1371630367 291  ',0),(192643,'node',' 1371630366   ',0),(192644,'node',' 1371630366   ',0),(192566,'node',' 1371630127   ',0),(192568,'node',' 1371630128   ',0),(192570,'node',' 1371630128   ',0),(192573,'node',' 1371630186   ',0),(192574,'node',' 1371630186   ',0),(192575,'node',' 1371630186   ',0),(192576,'node',' 1371630186   ',0),(192577,'node',' 1371630186   ',0),(192578,'node',' 1371630186   ',0),(192579,'node',' 1371630186   ',0),(192580,'node',' 1371630186   ',0),(192582,'node',' 1371630187 1304  ',0),(192584,'node',' 1371630187   ',0),(192590,'node',' 1371630187   ',0),(192585,'node',' 1371630187   ',0),(192586,'node',' 1371630187   ',0),(192588,'node',' 1371630187   ',0),(192592,'node',' 1371630188   ',0),(192595,'node',' 1371630245   ',0),(192596,'node',' 1371630245   ',0),(192597,'node',' 1371630245   ',0),(192598,'node',' 1371630245   ',0),(192599,'node',' 1371630245   ',0),(192600,'node',' 1371630245   ',0),(192601,'node',' 1371630245   ',0),(192602,'node',' 1371630245   ',0),(192604,'node',' 1371630246 971  ',0),(192606,'node',' 1371630246   ',0),(192607,'node',' 1371630246   ',0),(192608,'node',' 1371630246   ',0),(192610,'node',' 1371630247   ',0),(192612,'node',' 1371630247   ',0),(192614,'node',' 1371630247   ',0),(192617,'node',' 1371630306   ',0),(192618,'node',' 1371630306   ',0),(192619,'node',' 1371630306   ',0),(192620,'node',' 1371630306   ',0),(192621,'node',' 1371630306   ',0),(192622,'node',' 1371630306   ',0),(192623,'node',' 1371630306   ',0),(192624,'node',' 1371630306   ',0),(192626,'node',' 1371630306 1337  ',0),(192628,'node',' 1371630307   ',0),(192629,'node',' 1371630307   ',0),(192630,'node',' 1371630307   ',0),(192632,'node',' 1371630307   ',0),(192634,'node',' 1371630307   ',0),(192636,'node',' 1371630307   ',0),(192639,'node',' 1371630366   ',0),(192640,'node',' 1371630366   ',0),(192641,'node',' 1371630366   ',0),(192642,'node',' 1371630366   ',0),(192666,'node',' 1371630428   ',0),(141773,'node',' 1371559276   ',0),(141774,'node',' 1371559276   ',0),(141775,'node',' 1371559276   ',0),(141776,'node',' 1371559276   ',0),(141777,'node',' 1371559276   ',0),(141778,'node',' 1371559276   ',0),(141779,'node',' 1371559276   ',0),(141780,'node',' 1371559276   ',0),(141781,'node',' 1371559276   ',0),(141782,'node',' 1371559276   ',0),(141783,'node',' 1371559276   ',0),(141784,'node',' 1371559276   ',0),(141785,'node',' 1371559276   ',0),(141786,'node',' 1371559276   ',0),(141787,'node',' 1371559276   ',0),(141788,'node',' 1371559276   ',0),(141789,'node',' 1371559276   ',0),(141790,'node',' 1371559276   ',0),(141791,'node',' 1371559276   ',0),(141792,'node',' 1371559276   ',0),(141793,'node',' 1371559276   ',0),(141794,'node',' 1371559276   ',0),(141795,'node',' 1371559276   ',0),(141796,'node',' 1371559276   ',0),(141797,'node',' 1371559276   ',0),(141798,'node',' 1371559276   ',0),(141800,'node',' 1371559285 1693  ',0),(141801,'node',' 1371559285 1708  ',0),(141802,'node',' 1371559285 1832  ',0),(141803,'node',' 1371559285 1718  ',0),(141804,'node',' 1371559285 1571  ',0),(141805,'node',' 1371559285 1793  ',0),(141806,'node',' 1371559285 1694  ',0),(141807,'node',' 1371559285 1630  ',0),(141809,'node',' 1371559286 1747  ',0),(141810,'node',' 1371559286 1643  ',0),(141811,'node',' 1371559286 1753  ',0),(141812,'node',' 1371559286 1740  ',0),(141813,'node',' 1371559286 1626  ',0),(141814,'node',' 1371559286 1687  ',0),(141815,'node',' 1371559286 1568  ',0),(141816,'node',' 1371559286 1681  ',0),(141818,'node',' 1371559293   ',0),(141819,'node',' 1371559293   ',0),(141820,'node',' 1371559293   ',0),(141822,'node',' 1371559300   ',0),(141824,'node',' 1371559307   ',0),(141826,'node',' 1371559314   ',0),(141829,'node',' 1371559323   ',0),(141830,'node',' 1371559323   ',0),(141831,'node',' 1371559323   ',0),(141832,'node',' 1371559323   ',0),(141833,'node',' 1371559323   ',0),(141834,'node',' 1371559323   ',0),(141835,'node',' 1371559323   ',0),(141836,'node',' 1371559323   ',0),(141837,'node',' 1371559323   ',0),(141838,'node',' 1371559323   ',0),(141839,'node',' 1371559323   ',0),(141840,'node',' 1371559323   ',0),(141841,'node',' 1371559323   ',0),(141842,'node',' 1371559323   ',0),(141843,'node',' 1371559323   ',0),(141770,'node',' 1371559276   ',0),(141771,'node',' 1371559276   ',0),(141772,'node',' 1371559276   ',0),(141751,'node',' 1371559276   ',0),(141752,'node',' 1371559276   ',0),(141753,'node',' 1371559276   ',0),(141754,'node',' 1371559276   ',0),(141755,'node',' 1371559276   ',0),(141756,'node',' 1371559276   ',0),(141757,'node',' 1371559276   ',0),(141758,'node',' 1371559276   ',0),(141759,'node',' 1371559276   ',0),(141760,'node',' 1371559276   ',0),(141761,'node',' 1371559276   ',0),(141762,'node',' 1371559276   ',0),(141763,'node',' 1371559276   ',0),(141764,'node',' 1371559276   ',0),(141765,'node',' 1371559276   ',0),(141766,'node',' 1371559276   ',0),(141767,'node',' 1371559276   ',0),(141768,'node',' 1371559276   ',0),(141769,'node',' 1371559276   ',0),(141740,'node',' 1371559276   ',0),(141741,'node',' 1371559276   ',0),(141742,'node',' 1371559276   ',0),(141743,'node',' 1371559276   ',0),(141744,'node',' 1371559276   ',0),(141745,'node',' 1371559276   ',0),(141746,'node',' 1371559276   ',0),(141747,'node',' 1371559276   ',0),(141748,'node',' 1371559276   ',0),(141749,'node',' 1371559276   ',0),(141750,'node',' 1371559276   ',0),(99043,'node',' netapp fibre channel disk naa600a098044307535732b334571533576  ',0),(99037,'node',' netapp fibre channel disk naa600a098044307535732b334571533573  ',0),(98956,'node',' netapp fibre channel disk naa600a098044307259313f334556393434  ',0),(98953,'node',' netapp fibre channel disk naa600a098044307259313f334556393431  ',0),(98954,'node',' netapp fibre channel disk naa600a098044307259313f334556393432  ',0),(98955,'node',' netapp fibre channel disk naa600a098044307259313f334556393433  ',0),(98980,'node',' netapp fibre channel disk naa600a098044307535732b334571533642  ',0),(98957,'node',' netapp fibre channel disk naa600a098044307259313f334556393435  ',0),(98958,'node',' netapp fibre channel disk naa600a098044307259313f334556393436  ',0),(98959,'node',' netapp fibre channel disk naa600a098044307259313f334556393437  ',0),(98960,'node',' netapp fibre channel disk naa600a098044307259313f334556393438  ',0),(98979,'node',' netapp fibre channel disk naa600a098044307535732b334571533565  ',0),(98961,'node',' netapp fibre channel disk naa600a098044307259313f334556393439  ',0),(98962,'node',' netapp fibre channel disk naa600a098044307259313f334556393470  ',0),(98963,'node',' netapp fibre channel disk naa600a098044307259313f334556393471  ',0),(98964,'node',' netapp fibre channel disk naa600a098044307259313f334556393472  ',0),(98978,'node',' netapp fibre channel disk naa600a098044307535732b334571533641  ',0),(98965,'node',' netapp fibre channel disk naa600a098044307259313f334556393473  ',0),(98966,'node',' netapp fibre channel disk naa600a098044307259313f334556393474  ',0),(98967,'node',' netapp fibre channel disk naa600a098044307259313f334556393475  ',0),(98968,'node',' netapp fibre channel disk naa600a098044307259313f334556393476  ',0),(98969,'node',' netapp fibre channel disk naa600a098044307259313f334556393477  ',0),(98970,'node',' netapp fibre channel disk naa600a098044307259313f334556393478  ',0),(98977,'node',' netapp fibre channel disk naa600a098044307535732b334571533564  ',0),(98971,'node',' netapp fibre channel disk naa600a098044307259313f334556393479  ',0),(98972,'node',' netapp serial attached scsi disk naa600a0980b87a29ef1afd4b117b00aba2  ',0),(98973,'node',' netapp fibre channel disk naa600a098044307259313f33455639347a  ',0),(98974,'node',' netapp fibre channel disk naa600a098044307535732b334571533561  ',0),(98975,'node',' netapp fibre channel disk naa600a098044307535732b334571533562  ',0),(98976,'node',' netapp fibre channel disk naa600a098044307535732b334571533563  ',0),(98981,'node',' netapp fibre channel disk naa600a098044307535732b334571533566  ',0),(99036,'node',' netapp fibre channel disk naa600a098044307535732b334571533650  ',0),(98982,'node',' netapp fibre channel disk naa600a098044307535732b334571533643  ',0),(98983,'node',' netapp fibre channel disk naa600a098044307535732b334571533644  ',0),(98984,'node',' netapp fibre channel disk naa600a098044307535732b334571533567  ',0),(98985,'node',' netapp fibre channel disk naa600a098044307535732b334571533645  ',0),(98986,'node',' netapp fibre channel disk naa600a098044307535732b334571533568  ',0),(99035,'node',' netapp fibre channel disk naa600a098044307535732b334571533572  ',0),(98987,'node',' netapp fibre channel disk naa600a098044307535732b334571533646  ',0),(98988,'node',' netapp fibre channel disk naa600a098044307535732b334571533569  ',0),(99034,'node',' netapp fibre channel disk naa600a098044307535732b334571533571  ',0),(98989,'node',' netapp fibre channel disk naa600a098044307535732b334571533647  ',0),(98990,'node',' netapp fibre channel disk naa600a098044307535732b334571533648  ',0),(98991,'node',' netapp fibre channel disk naa600a098044307535732b334571533649  ',0),(99032,'node',' netapp fibre channel disk naa600a098044307259313f33455638724f  ',0),(98992,'node',' netapp fibre channel disk naa600a098044307535732b33457153356a  ',0),(99031,'node',' netapp fibre channel disk naa600a098044307259313f33455638724e  ',0),(98993,'node',' netapp fibre channel disk naa600a098044307535732b33457153356b  ',0),(98994,'node',' netapp fibre channel disk naa600a098044307535732b33457153356c  ',0),(98995,'node',' netapp fibre channel disk naa600a098044307535732b33457153356d  ',0),(98996,'node',' netapp fibre channel disk naa600a098044307535732b33457153364a  ',0),(98997,'node',' netapp fibre channel disk naa600a098044307535732b33457153356e  ',0),(98998,'node',' netapp fibre channel disk naa600a098044307535732b33457153364b  ',0),(98999,'node',' netapp fibre channel disk naa600a098044307535732b33457153356f  ',0),(99000,'node',' netapp fibre channel disk naa600a098044307535732b33457153364c  ',0),(99001,'node',' netapp fibre channel disk naa600a098044307535732b33457153364d  ',0),(99030,'node',' netapp fibre channel disk naa600a098044307259313f33455638724d  ',0),(99002,'node',' netapp fibre channel disk naa600a098044307535732b33457153364e  ',0),(99003,'node',' netapp fibre channel disk naa600a098044307535732b33457153364f  ',0),(99004,'node',' netapp fibre channel disk naa600a098044307259313f334556393441  ',0),(99029,'node',' netapp fibre channel disk naa600a098044307259313f33455638724c  ',0),(99005,'node',' netapp fibre channel disk naa600a098044307259313f334556393442  ',0),(99006,'node',' netapp fibre channel disk naa600a098044307259313f334556393443  ',0),(99007,'node',' netapp fibre channel disk naa600a098044307535732b33457152752d  ',0),(99011,'node',' netapp fibre channel disk naa600a098044307259313f334556393447  ',0),(99008,'node',' netapp fibre channel disk naa600a098044307259313f334556393444  ',0),(99009,'node',' naa600a098044307259313f334556393445 ',0),(99010,'node',' naa600a098044307259313f334556393446 ',0),(99012,'node',' netapp fibre channel disk naa600a098044307259313f334556393448  ',0),(99013,'node',' netapp fibre channel disk naa600a098044307259313f334556393449  ',0),(99014,'node',' netapp fibre channel disk naa600a098044307259313f334556387243  ',0),(99015,'node',' netapp fibre channel disk naa600a098044307259313f334556387244  ',0),(99016,'node',' netapp fibre channel disk naa600a098044307259313f334556387245  ',0),(99017,'node',' netapp fibre channel disk naa600a098044307259313f334556387246  ',0),(99028,'node',' netapp fibre channel disk naa600a098044307259313f33455638724b  ',0),(99018,'node',' netapp fibre channel disk naa600a098044307259313f334556387247  ',0),(99019,'node',' netapp fibre channel disk naa600a098044307259313f334556387248  ',0),(99020,'node',' netapp fibre channel disk naa600a098044307259313f334556387249  ',0),(99021,'node',' netapp fibre channel disk naa600a098044307259313f33455639344a  ',0),(99022,'node',' netapp fibre channel disk naa600a098044307259313f33455639344b  ',0),(99027,'node',' netapp fibre channel disk naa600a098044307259313f33455638724a  ',0),(99023,'node',' netapp fibre channel disk naa600a098044307259313f33455639344c  ',0),(99024,'node',' netapp fibre channel disk naa600a098044307259313f33455639344d  ',0),(99025,'node',' netapp fibre channel disk naa600a098044307259313f33455639344e  ',0),(99026,'node',' netapp fibre channel disk naa600a098044307259313f33455639344f  ',0),(99033,'node',' netapp fibre channel disk naa600a098044307535732b334571533570  ',0),(99038,'node',' netapp fibre channel disk naa600a098044307535732b334571533651  ',0),(99039,'node',' netapp fibre channel disk naa600a098044307535732b334571533574  ',0),(99040,'node',' netapp fibre channel disk naa600a098044307535732b334571533652  ',0),(99041,'node',' netapp fibre channel disk naa600a098044307535732b334571533575  ',0),(99042,'node',' netapp fibre channel disk naa600a098044307535732b334571533653  ',0),(99044,'node',' netapp fibre channel disk naa600a098044307535732b334571533577  ',0),(99045,'node',' netapp fibre channel disk naa600a098044307535732b334571533654  ',0),(99046,'node',' netapp fibre channel disk naa600a098044307535732b334571533578  ',0),(99047,'node',' netapp fibre channel disk naa600a098044307535732b334571533655  ',0),(99048,'node',' netapp fibre channel disk naa600a098044307535732b334571533579  ',0),(99049,'node',' netapp fibre channel disk naa600a098044307535732b334571533656  ',0),(99050,'node',' netapp fibre channel disk naa600a098044307535732b334571533657  ',0),(99051,'node',' netapp fibre channel disk naa600a098044307535732b334571533658  ',0),(99052,'node',' netapp fibre channel disk naa600a098044307535732b334571533659  ',0),(99145,'node',' naa6000c2902d5ba8be5966051779f73945 ',0),(99144,'node',' naa6000c29532d9e75758061ca5a90c3743 ',0),(99142,'node',' naa6000c292e0633db9e8f9555d658ad2ca ',0),(99141,'node',' naa6000c29b3222956854879461dd964e80 ',0),(99140,'node',' naa6000c29a765bf9dd27349f08fccc80c9 ',0),(99138,'node',' naa600a098044307535732b334571533574 ',0),(99137,'node',' naa600a098044307259313f334556393438 ',0),(99135,'node',' naa600a098044307259313f334556393437 ',0),(99126,'node',' hgw2k8r232vm4 custom a 1 i  s 598856  ',0),(99123,'node',' netapp fibre channel disk naa600a098044307259313f334556393463  ',0),(99120,'node',' netapp fibre channel disk naa600a098044307259313f334556393461  ',0),(99118,'node',' netapp fibre channel disk naa600a098044307535732b33457153366f  ',0),(99116,'node',' netapp fibre channel disk naa600a098044307535732b33457153366d  ',0),(99114,'node',' netapp fibre channel disk naa600a098044307535732b33457153366b  ',0),(99111,'node',' netapp fibre channel disk naa600a098044307535732b33457153362d  ',0),(99109,'node',' netapp fibre channel disk naa600a098044307535732b334571527548  ',0),(99107,'node',' netapp fibre channel disk naa600a098044307535732b334571527546  ',0),(99105,'node',' netapp fibre channel disk naa600a098044307535732b334571527544  ',0),(99103,'node',' netapp fibre channel disk naa600a098044307535732b334571527542  ',0),(99100,'node',' netapp fibre channel disk naa600a098044307535732b334571533668  ',0),(99098,'node',' netapp fibre channel disk naa600a098044307535732b334571533666  ',0),(99096,'node',' netapp fibre channel disk naa600a098044307535732b334571533664  ',0),(99094,'node',' netapp fibre channel disk naa600a098044307535732b334571533662  ',0),(99090,'node',' netapp serial attached scsi disk naa600a0980659529efd63544117b01aba2  ',0),(99088,'node',' netapp fibre channel disk naa600a098044307259313f334556387251  ',0),(99086,'node',' netapp fibre channel disk naa600a098044307259313f334556393459  ',0),(99084,'node',' netapp fibre channel disk naa600a098044307259313f334556393457  ',0),(99082,'node',' netapp fibre channel disk naa600a098044307259313f334556393456  ',0),(99080,'node',' netapp fibre channel disk naa600a098044307259313f334556393379  ',0),(99077,'node',' netapp fibre channel disk naa600a098044307259313f334556393378  ',0),(99075,'node',' netapp fibre channel disk naa600a098044307259313f334556393531  ',0),(99073,'node',' netapp fibre channel disk naa600a098044307259313f334556393453  ',0),(99071,'node',' netapp fibre channel disk naa600a098044307259313f334556393376  ',0),(99069,'node',' netapp fibre channel disk naa600a098044307259313f334556393375  ',0),(99067,'node',' netapp fibre channel disk naa600a098044307259313f334556393374  ',0),(99065,'node',' netapp fibre channel disk naa600a098044307259313f334556393373  ',0),(99063,'node',' netapp fibre channel disk naa600a098044307259313f334556393371  ',0),(99061,'node',' netapp fibre channel disk naa600a098044307535732b33457153365a  ',0),(99059,'node',' netapp fibre channel disk naa600a098044307535732b334571527539  ',0),(98845,'node',' fasanity01w2k8r2 ',0),(98842,'node',' fasanity03w2k8r2 ',0),(98846,'node',' x36903vm0 ',0),(99056,'node',' netapp serial attached scsi disk naa600a0980629929ef780f45117b02aba2  ',0),(99054,'node',' netapp fibre channel disk naa600a098044307535732b334571527535  ',0),(98852,'node',' hgrx3009gdlenglabnetappcom ',0),(99053,'node',' netapp fibre channel disk naa600a098044307535732b334571527534  ',0),(99055,'node',' netapp fibre channel disk naa600a098044307535732b334571527536  ',0),(99057,'node',' netapp fibre channel disk naa600a098044307535732b334571527537  ',0),(99058,'node',' netapp fibre channel disk naa600a098044307535732b334571527538  ',0),(99060,'node',' netapp fibre channel disk naa600a098044307535732b33457153357a  ',0),(99062,'node',' netapp fibre channel disk naa600a098044307259313f334556393370  ',0),(99064,'node',' netapp fibre channel disk naa600a098044307259313f334556393372  ',0),(99066,'node',' netapp fibre channel disk naa600a098044307259313f334556393450  ',0),(99068,'node',' netapp fibre channel disk naa600a098044307259313f334556393451  ',0),(99070,'node',' netapp fibre channel disk naa600a098044307259313f334556393452  ',0),(99072,'node',' netapp fibre channel disk naa600a098044307259313f334556393530  ',0),(99074,'node',' netapp fibre channel disk naa600a098044307259313f334556393377  ',0),(99076,'node',' netapp fibre channel disk naa600a098044307259313f334556393454  ',0),(99078,'node',' netapp fibre channel disk naa600a098044307259313f334556393532  ',0),(99079,'node',' netapp fibre channel disk naa600a098044307259313f334556393455  ',0),(99081,'node',' netapp fibre channel disk naa600a098044307259313f334556393533  ',0),(99083,'node',' netapp fibre channel disk naa600a098044307259313f334556393534  ',0),(99085,'node',' netapp fibre channel disk naa600a098044307259313f334556393458  ',0),(99087,'node',' netapp fibre channel disk naa600a098044307259313f334556387250  ',0),(99089,'node',' netapp fibre channel disk naa600a098044307259313f334556387252  ',0),(99091,'node',' netapp fibre channel disk naa600a098044307259313f33455639337a  ',0),(99092,'node',' netapp fibre channel disk naa600a098044307259313f33455639345a  ',0),(99093,'node',' netapp fibre channel disk naa600a098044307535732b334571533661  ',0),(99095,'node',' netapp fibre channel disk naa600a098044307535732b334571533663  ',0),(99097,'node',' netapp fibre channel disk naa600a098044307535732b334571533665  ',0),(99099,'node',' netapp fibre channel disk naa600a098044307535732b334571533667  ',0),(99101,'node',' netapp fibre channel disk naa600a098044307535732b334571533669  ',0),(99102,'node',' netapp fibre channel disk naa600a098044307535732b334571527541  ',0),(99104,'node',' netapp fibre channel disk naa600a098044307535732b334571527543  ',0),(99106,'node',' netapp fibre channel disk naa600a098044307535732b334571527545  ',0),(99108,'node',' netapp fibre channel disk naa600a098044307535732b334571527547  ',0),(99110,'node',' netapp fibre channel disk naa600a098044307535732b334571527549  ',0),(99112,'node',' netapp fibre channel disk naa600a098044307535732b33457153362f  ',0),(99113,'node',' netapp fibre channel disk naa600a098044307535732b33457153366a  ',0),(99115,'node',' netapp fibre channel disk naa600a098044307535732b33457153366c  ',0),(99117,'node',' netapp fibre channel disk naa600a098044307535732b33457153366e  ',0),(99119,'node',' netapp fibre channel disk naa600a098044307535732b33457152754a  ',0),(99121,'node',' netapp fibre channel disk naa600a098044307535732b33457152754b  ',0),(99122,'node',' netapp fibre channel disk naa600a098044307259313f334556393462  ',0),(99124,'node',' hgw2k8r232vm2 custom a 1 i  s 598856  ',0),(99125,'node',' hgw2k8r232vm3 custom a 1 i  s 598856  ',0),(99127,'node',' hgw2k8r232vm5 custom a 1 i  s 598856  ',0),(99128,'node',' hgw2k8r232vm6 ',0),(99129,'node',' hgw2k8r232vm1 custom a 1 i  s 598856  ',0),(99130,'node',' hgw2k8r232vm7 ',0),(99131,'node',' hgw2k8r232vm8 ',0),(99132,'node',' hgw2k8r232vm9 ',0),(99133,'node',' hgw2k8r232vm10 ',0),(99134,'node',' naa6000c299242f2fcb24b70a806cfd6483 ',0),(99136,'node',' naa600a098044307535732b334571533573 ',0),(99139,'node',' naa6000c296b36c887ceec41b5e40543c63 ',0),(99143,'node',' naa6000c29362e532d0433c7b0f3f444807 ',0),(141360,'node',' hgw2k8r232vm14 ',0),(141361,'node',' hgw2k8r232vm15 ',0),(141362,'node',' hgw2k8r232vm13 ',0),(141363,'node',' hgw2k8r232vm17 ',0),(141365,'node',' hgw2k8r232vm19 ',0),(141366,'node',' hgw2k8r232vm20 ',0),(99244,'node',' naa6000c29a54a9df10c14901abe20b4848 ',0),(99243,'node',' naa6000c2950d69f69a7e0086277a1537b6 ',0),(99242,'node',' naa6000c29aa56348f8c52aa982d67a435c ',0),(99240,'node',' naa6000c29d4104df0cf1b6ebc4fb7e62ea ',0),(99239,'node',' naa6000c29ae3e105bef458100c41d96e5e ',0),(99237,'node',' naa6000c29733b0365706a54a9a5c2471db ',0),(99236,'node',' naa6000c299cd2c79e031925c1358c473e6 ',0),(99234,'node',' naa6000c29bd75f23cc168d13228cfd1188 ',0),(99233,'node',' naa6000c294cc74c7000608f59a1e6e6cc5 ',0),(99231,'node',' naa6000c293f222457d87adc267eccabf11 ',0),(99230,'node',' naa6000c29a98d1500a789935c211afcfa4 ',0),(99228,'node',' naa6000c29210632526769e22c7c31ff326 ',0),(99227,'node',' naa6000c29f3ebb0d585f0ed9422d664057 ',0),(99226,'node',' naa6000c29a85ce165a8d96caf467e2b8c2 ',0),(99224,'node',' naa6000c29ef7c743ec1f1ae77fc08b4c8a ',0),(99223,'node',' naa6000c296efb831d18740de67a8212ba3 ',0),(99221,'node',' naa6000c298d5ef350777b9f2be8ba3ef94 ',0),(99220,'node',' naa6000c29ba4507964dff0ad72b70afbbe ',0),(99218,'node',' naa6000c2929533fd5be20eb5cc847a13ed ',0),(99217,'node',' naa6000c2964274185ba96cd4dbf8ef50eb ',0),(99215,'node',' naa6000c29b6e7404ddd6b61e58e787d9d9 ',0),(99214,'node',' naa6000c291dd7f6a5d9401fc71d54adbb6 ',0),(99212,'node',' naa6000c29a137ba86b53498f0230152ba2 ',0),(99211,'node',' naa6000c29fe3390e795d8c591136084897 ',0),(99209,'node',' naa6000c29aac086487546a2ca8dd2ebd5a ',0),(99208,'node',' naa6000c294223f07cf9331c3fa76649fc0 ',0),(99207,'node',' naa6000c293b01b8a3782aed28fa505d311 ',0),(99205,'node',' naa6000c291737bb4cb6f8e9f8eb55ff3fe ',0),(99204,'node',' naa6000c29891c7bfbf1d5b509415e5e8e9 ',0),(99202,'node',' naa6000c29e353d1df472e29083d0de0077 ',0),(99201,'node',' naa6000c29e3371e54aa56bb0971032e089 ',0),(99199,'node',' naa600a098044307259313f334556393439 ',0),(99192,'node',' naa6000c2962f4f2ea11e8380e978daf567 ',0),(99190,'node',' naa6000c29d7c364b06ded47c1f570bc2e3 ',0),(99189,'node',' naa6000c29c50c16277f5b82ee57335fc8a ',0),(99187,'node',' naa6000c29efdea6383c636eb6f5293bb18 ',0),(99186,'node',' naa6000c29be9c8af40d3e0d5938c1f980e ',0),(99184,'node',' naa6000c29859fd519d867292b2a206e338 ',0),(99183,'node',' naa6000c29ca95433a3c26ac5006f2c6bbf ',0),(99181,'node',' naa6000c296c4b84cf9c023f5bd4f7ed00f ',0),(99180,'node',' naa6000c29f57cc968bfbb545dbf20a1886 ',0),(99179,'node',' naa6000c2930690849f0f027e2bdea15971 ',0),(99177,'node',' naa6000c29e2682f4db15114dd9441e9c15 ',0),(99176,'node',' naa6000c29f674e59273634ef0b579e36b7 ',0),(99174,'node',' naa6000c29581ab8a2d1e213ab7a5097f25 ',0),(99173,'node',' naa6000c29929cb6278386c2319ec3c3b6e ',0),(99171,'node',' naa6000c294c5800706fe07fe7bdec0b542 ',0),(99170,'node',' naa6000c29a50c74f6a4499cc613e475ef4 ',0),(99168,'node',' naa6000c29b9d27250346d3e0286ee28a49 ',0),(99167,'node',' naa6000c291ad1e480ea3b8d793ff8001cd ',0),(99165,'node',' naa6000c292dc5b74eeed4bd44591340e16 ',0),(99164,'node',' naa6000c2973fc357862a1d1f9aad0ee35d ',0),(99163,'node',' naa6000c29625d808ede952e2c058cf1a34 ',0),(99161,'node',' naa6000c295e3f8a5d4112eea72713dafc7 ',0),(99160,'node',' naa6000c290b447224a367ae88729a10481 ',0),(99158,'node',' naa6000c297f078b46cc95f683d3fad2304 ',0),(99157,'node',' naa6000c29659d5ed1d994feb862b35f563 ',0),(99156,'node',' naa6000c29509fa9ac43eb732b1b2d9a0f4 ',0),(99155,'node',' naa6000c2925e6758884ac57c7ae894ee86 ',0),(99154,'node',' naa6000c29909baac34d177a4a3840328b8 ',0),(99152,'node',' naa6000c29475b97b7e2d72ab1a29ba04a0 ',0),(99153,'node',' naa6000c291630bfde3725bb05887739ba8 ',0),(99151,'node',' naa6000c290a1e6f7dcd64bad2f0508e1ea ',0),(99150,'node',' naa6000c294e3b594ec724e3a4db1a4516c ',0),(99149,'node',' naa6000c2983a5286249c37e5d021904aaa ',0),(99148,'node',' naa6000c29dc66f186790f6c654494feb0f ',0),(99147,'node',' naa6000c29a2edac2d4e7c2f015ced57b68 ',0),(99146,'node',' naa6000c293d27251a8a3f12accfb90bfc3 ',0),(99159,'node',' naa6000c292da51f1aa36aa0f8f36ab63a1 ',0),(99162,'node',' naa6000c2928d3847de8b714947ebe88135 ',0),(99166,'node',' naa6000c29c21bb973e92f998bea193dd18 ',0),(99169,'node',' naa6000c29b45fb593085a2c48782b02044 ',0),(99172,'node',' naa6000c2965ca4cd7c53811704f77b5d65 ',0),(99175,'node',' naa6000c2979d4a269d6872562552952c80 ',0),(99178,'node',' naa6000c29047896a98adc870dfbebaeac2 ',0),(99182,'node',' naa6000c29548b21a50f8567f2f98d65703 ',0),(99185,'node',' naa6000c294b2c528ee471899a0c8328b4b ',0),(99188,'node',' naa6000c299fb242f20bd0dcbf875123360 ',0),(99191,'node',' naa6000c294d1df893cff4138d2e478e299 ',0),(99198,'node',' naa600a098044307535732b334571533576 ',0),(99196,'node',' naa600a098044307535732b334571533575 ',0),(99193,'node',' hgw2k8r232vm11 ',0),(99194,'node',' hgw2k8r232vm12 ',0),(99195,'node',' naa6000c29a9b11305673146d99b450723c ',0),(99197,'node',' naa600a098044307259313f33455639342d ',0),(99200,'node',' naa6000c29dd17f56e30f12a86aa07ef6da ',0),(99203,'node',' naa6000c2960b02c3a9e54eda5f394a838a ',0),(99206,'node',' naa6000c2917d55d870400ecc0701aece3c ',0),(99210,'node',' naa6000c29e200b558b2cc9c39ced49529c ',0),(99213,'node',' naa6000c29b4543f3d3e3ecbea6126ce7a5 ',0),(99216,'node',' naa6000c29dd4369787c560bd4beacce114 ',0),(99219,'node',' naa6000c298a30b94717e0a7b89a2473c29 ',0),(99222,'node',' naa6000c2941f98a8f551379b37f7715f14 ',0),(99225,'node',' naa6000c299cded2c9adf690ae5be386c24 ',0),(99229,'node',' naa6000c2935081e51a2200a7f51268b899 ',0),(99232,'node',' naa6000c297ce254a93f01e4bda7755f8b1 ',0),(99235,'node',' naa6000c29449c9f7c6ccee27d61d6b548a ',0),(99238,'node',' naa6000c291c6a3669ea9c11a428428f0c0 ',0),(99241,'node',' naa6000c298015b74673771ea38b8763c63 ',0),(99245,'node',' naa6000c293d46dcdef17137ae44b3e63b3 ',0),(192515,'node',' 1371630006   ',0),(192516,'node',' 1371630006   ',0),(192517,'node',' 1371630006   ',0),(192518,'node',' 1371630006   ',0),(192489,'node',' 1371629946   ',0),(192490,'node',' 1371629946   ',0),(192491,'node',' 1371629946   ',0),(192492,'node',' 1371629946   ',0),(192456,'node',' 1371629836   ',0),(192458,'node',' 1371629836   ',0),(192460,'node',' 1371629836   ',0),(192462,'node',' 1371629838 317  ',0),(192421,'node',' 1371629650   ',0),(192424,'node',' 1371629718 984  ',0),(192426,'node',' 1371629719   ',0),(192427,'node',' 1371629719   ',0),(192388,'node',' 1371629526   ',0),(192389,'node',' 1371629526   ',0),(192391,'node',' 1371629527   ',0),(192392,'node',' 1371629527   ',0),(192475,'node',' 1371629886 6667  ',0),(192446,'node',' 1371629786   ',0),(192422,'node',' 1371629702   ',0),(192380,'node',' 1371629522   ',0),(192381,'node',' 1371629526   ',0),(192348,'node',' 1371629411   ',0),(192350,'node',' 1371629412   ',0),(192320,'node',' 1371629287   ',0),(192322,'node',' 1371629287   ',0),(192288,'node',' 1371629222   ',0),(192244,'node',' 1371628982   ',0),(192365,'node',' 1371629469   ',0),(192366,'node',' 1371629469   ',0),(192351,'node',' 1371629412   ',0),(192353,'node',' 1371629412   ',0),(192349,'node',' 1371629411   ',0),(192331,'node',' 1371629288   ',0),(192346,'node',' 1371629396   ',0),(192294,'node',' 1371629226   ',0),(192271,'node',' 1371629165   ',0),(192274,'node',' 1371629165   ',0),(192272,'node',' 1371629165   ',0),(192273,'node',' 1371629165   ',0),(192275,'node',' 1371629165   ',0),(192277,'node',' 1371629166   ',0),(192280,'node',' 1371629166   ',0),(192279,'node',' 1371629166   ',0),(192283,'node',' 1371629166   ',0),(192281,'node',' 1371629166   ',0),(192253,'node',' 1371629114   ',0),(192255,'node',' 1371629115   ',0),(192258,'node',' 1371629115   ',0),(192261,'node',' 1371629115   ',0),(192259,'node',' 1371629115   ',0),(192237,'node',' 1371628946   ',0),(192233,'node',' 1371628945   ',0),(192235,'node',' 1371628946   ',0),(192229,'node',' 1371628945   ',0),(192230,'node',' 1371628945   ',0),(192226,'node',' 1371628945   ',0),(192227,'node',' 1371628945   ',0),(192205,'node',' 1371628865   ',0),(192206,'node',' 1371628865   ',0),(192265,'node',' 1371629116   ',0),(192202,'node',' 1371628865   ',0),(192203,'node',' 1371628865   ',0),(192270,'node',' 1371629165   ',0),(192269,'node',' 1371629165   ',0),(192292,'node',' 1371629226   ',0),(192291,'node',' 1371629226   ',0),(192221,'node',' 1371628867   ',0),(192219,'node',' 1371628867   ',0),(192220,'node',' 1371628867   ',0),(192217,'node',' 1371628866   ',0),(192218,'node',' 1371628867   ',0),(192215,'node',' 1371628866   ',0),(192216,'node',' 1371628866   ',0),(192212,'node',' 1371628866   ',0),(99443,'node',' naa6000c2972f5eb0f1acad26055f514f6d ',0),(99442,'node',' naa6000c292b38715a4bf5db11a06a63e31 ',0),(99440,'node',' naa6000c29a55144da0ca59bf68548743f1 ',0),(99439,'node',' naa6000c298badd992c7dfa3d313aaf4308 ',0),(99437,'node',' naa6000c29bf6e0f4fedbe7daf1e1752859 ',0),(99436,'node',' naa6000c29487a81812d7fcd470b1f05b92 ',0),(99434,'node',' naa6000c296d616c278083d43923197613d ',0),(99433,'node',' naa6000c29bf7087777c6b1a06aa36aa01b ',0),(99432,'node',' naa6000c29e90267af74612bf02c867a8a9 ',0),(99430,'node',' naa6000c296ccdeb9458e68e338f3cd6a82 ',0),(99429,'node',' naa6000c29f155edba699afe8c5ae930141 ',0),(99427,'node',' naa6000c29b8296536ec7810e73af9e6c3a ',0),(99424,'node',' naa6000c299273ff09587c8a7d753e6cbad ',0),(99426,'node',' naa6000c2989e012f7d70034f59682da73f ',0),(99423,'node',' naa6000c29acdcfc3731068d112b925c117 ',0),(99421,'node',' naa6000c29f0e122c0c693e1a11e56d3b50 ',0),(99420,'node',' naa6000c295a0eeb2a325ce87cb26a569cc ',0),(99419,'node',' naa6000c29f518a6ba4ce7d35ae9a59df2f ',0),(99417,'node',' naa6000c29a8feb68507998c1e5005c8d6a ',0),(99416,'node',' naa6000c29630b208ccee2b19c7051c2179 ',0),(99414,'node',' naa6000c294dd93e79791523ad9469f1531 ',0),(99413,'node',' naa6000c29a4374a6fc984cc3df423d7826 ',0),(99411,'node',' naa6000c294c7019963f07607c89dc4666a ',0),(99410,'node',' naa6000c29dd01ef3192bf1ffa13e5c71a2 ',0),(99408,'node',' naa6000c291d75a3708a841e1ee07a014f1 ',0),(99407,'node',' naa6000c29083952def68e3e9ffd16517b9 ',0),(99405,'node',' naa6000c292c148a7d33c2540a9767aa824 ',0),(99404,'node',' naa6000c294dbda2a3d6a7892f1734c71fe ',0),(99402,'node',' naa6000c294f1ceeefa4a2beff5f55584fc ',0),(99401,'node',' naa6000c2959aa2b054351c424d30964b08 ',0),(99400,'node',' naa6000c29d1b17437c7a0141d38fca7c0e ',0),(99299,'node',' naa6000c2938d61e772e92d242e8f616bc8 ',0),(99298,'node',' naa6000c293a79653f23adacab302a35b4c ',0),(99297,'node',' naa6000c29fe6b177596c1c4b553ca45a3f ',0),(99295,'node',' naa6000c29c258d048db92532600399cc4f ',0),(99294,'node',' naa6000c2916a269a0abd1525c1524ce67c ',0),(99292,'node',' naa6000c29293df626e239bea90f331fbff ',0),(99291,'node',' naa6000c293253c456ea75b96f934730b77 ',0),(99290,'node',' naa6000c299a4eb2d1abcfd916114b897a2 ',0),(99288,'node',' naa6000c296145978d116a1dadb39cae949 ',0),(99287,'node',' naa6000c29459e8c5d431d18870e9eba06f ',0),(99285,'node',' naa6000c29e335014bb174151c6fef61968 ',0),(99284,'node',' naa6000c29d46de48951fc586e98226d5ec ',0),(99281,'node',' naa6000c29e279da2c2ed11b70ea5d8c56a ',0),(99275,'node',' naa6000c29cb55e1f2d29a6efd5f2d46898 ',0),(99273,'node',' naa6000c29d497984f4722f3ac9dd476b19 ',0),(99253,'node',' naa6000c29db0b2f97bc7852ba854bc5a0f ',0),(99251,'node',' naa6000c2932722fba5532a5b3cde7c0c63 ',0),(99249,'node',' naa6000c2901a38e7528335db9a8d1b55a9 ',0),(99248,'node',' naa6000c2942d742dac850584b052554ee1 ',0),(99246,'node',' naa6000c29879c542625d4b6088cdc6db0d ',0),(99247,'node',' naa6000c2997ed7efd8c63e88f76714c242 ',0),(99250,'node',' naa6000c293a34e4ff971e1b11d447e4a42 ',0),(99252,'node',' naa6000c29c2a035dec0cb7cf218419267b ',0),(99271,'node',' naa6000c2960acd1e4028a94d476ecdc668 ',0),(99269,'node',' naa6000c2935ddc92f10433d19f2bb80a9b ',0),(99267,'node',' naa6000c29b66d5ffd22d0dd7c09b517e52 ',0),(99265,'node',' naa6000c29932d18cc52aa4303fbb5eb3c8 ',0),(99262,'node',' naa600a098044307535732b334571533578 ',0),(99254,'node',' hgw2k8r232vm13 ',0),(99255,'node',' hgw2k8r232vm14 ',0),(99260,'node',' naa600a098044307259313f334556393442 ',0),(99256,'node',' hgw2k8r232vm15 ',0),(99257,'node',' hgw2k8r232vm16 ',0),(99258,'node',' naa6000c29f6fd3eb9866c057835e2bc58a ',0),(99259,'node',' naa600a098044307259313f334556393441 ',0),(99261,'node',' naa600a098044307535732b334571533577 ',0),(99263,'node',' naa6000c292e02e62a7ea5fcc7e2ac6dac2 ',0),(99264,'node',' naa6000c2933e34e6114d05cd550d6203a2 ',0),(99266,'node',' naa6000c29ffdbb148155d03e2476161cb4 ',0),(99268,'node',' naa6000c298ccbcb8562196baab2010f8ff ',0),(99270,'node',' naa6000c293d496c4a7d9a1f8af3d22ef12 ',0),(99272,'node',' naa6000c29957b3d5f525e35e73b0141a8e ',0),(99274,'node',' naa6000c298c48515e76cb4276acf0d25ab ',0),(99276,'node',' naa6000c29d3d23a134327ee8536278c134 ',0),(99277,'node',' naa6000c294b160ff10b82c3b3164532f5c ',0),(99278,'node',' naa6000c297cdc780e3c13ee563f29dc515 ',0),(99280,'node',' naa6000c2961aac254c504c6d67ecb5f8ac ',0),(99279,'node',' naa6000c29fe77494a31a50f7fb700fd794 ',0),(99282,'node',' naa6000c296600c8dae9d742ee0c1bdc4e9 ',0),(99283,'node',' naa6000c2931b0ffc674dcc8e3598171dad ',0),(99286,'node',' naa6000c29e54336b52aa766cc061802e54 ',0),(99289,'node',' naa6000c2979079a872bc7b010e0990382e ',0),(99293,'node',' naa6000c29e0464e562dccd37ac96b0e1dd ',0),(99296,'node',' naa6000c297b719579011fa5a723f8e0066 ',0),(99399,'node',' naa600a098044307535732b33457153357a ',0),(99403,'node',' naa6000c29768334a860ab2d408c832c177 ',0),(99406,'node',' naa6000c2900ba30f9c04761e67e7ba6cce ',0),(99409,'node',' naa6000c29d47d77c0cd2025e1971109dd6 ',0),(99412,'node',' naa6000c29bf50a0ed8408706208f3ae812 ',0),(99415,'node',' naa6000c296784e9dc1250b3216789698b6 ',0),(99418,'node',' naa6000c29428a929259bdf1e335a6a0cf3 ',0),(99422,'node',' naa6000c2968e87a4052eaebe934cd108c9 ',0),(99425,'node',' naa6000c299fd4914145c44d7f0cb9bbb61 ',0),(99428,'node',' naa6000c294bb43532c863aee47b5f5049f ',0),(99431,'node',' naa6000c29fb5474c246b501f6412606177 ',0),(99435,'node',' naa6000c292e5269fcf7b9ac98f5a58d98d ',0),(99438,'node',' naa6000c29e72b201aedfc8a958975f29c5 ',0),(99441,'node',' naa6000c292d1e0ba34fcd69f4a7ddb7966 ',0),(99444,'node',' naa6000c29ce39995d215bdbe84b1a58c17 ',0),(178704,'node',' 1371597064 1651  ',0),(178705,'node',' 1371597064 1476  ',0),(178702,'node',' 1371597064 1643  ',0),(178703,'node',' 1371597064 1621  ',0),(178700,'node',' 1371597063 1581  ',0),(178699,'node',' 1371597063 1664  ',0),(178695,'node',' 1371597063 1539  ',0),(178697,'node',' 1371597063 1344  ',0),(178696,'node',' 1371597063 1624  ',0),(178698,'node',' 1371597063 1571  ',0),(178693,'node',' 1371597063 1574  ',0),(178694,'node',' 1371597063 1585  ',0),(178688,'node',' 1371597004   ',0),(178690,'node',' 1371597005   ',0),(178684,'node',' 1371597004   ',0),(178686,'node',' 1371597004   ',0),(178683,'node',' 1371597004   ',0),(178676,'node',' 1371597003 1605  ',0),(178677,'node',' 1371597003 1580  ',0),(178680,'node',' 1371597004 942  ',0),(178678,'node',' 1371597003 1498  ',0),(178682,'node',' 1371597004   ',0),(178675,'node',' 1371597003 1431  ',0),(178644,'node',' 1371596944 1585  ',0),(178651,'node',' 1371596945   ',0),(178652,'node',' 1371596945   ',0),(178653,'node',' 1371596945   ',0),(178655,'node',' 1371596945   ',0),(178657,'node',' 1371596946   ',0),(178659,'node',' 1371596946   ',0),(178662,'node',' 1371597002 1548  ',0),(178663,'node',' 1371597002 1587  ',0),(178664,'node',' 1371597002 1573  ',0),(178597,'node',' 1371596826   ',0),(178602,'node',' 1371596882 1646  ',0),(178603,'node',' 1371596882 1432  ',0),(178604,'node',' 1371596882 1673  ',0),(178605,'node',' 1371596882 1649  ',0),(178606,'node',' 1371596882 1465  ',0),(178607,'node',' 1371596882 1649  ',0),(178609,'node',' 1371596883 1650  ',0),(178610,'node',' 1371596883 1479  ',0),(99474,'node',' fmcdebianbld1 ',0),(99472,'node',' hgmh1w2k8r2 ',0),(99473,'node',' hgmh2w2k8r2 ',0),(99470,'node',' hgwin2k814760 ',0),(99471,'node',' fmcbp ',0),(99468,'node',' hgvcenter511 ',0),(99469,'node',' hgvcenter512 ',0),(99467,'node',' flash accel management console ',0),(99465,'node',' hgvma01 ',0),(99466,'node',' fmcdns32 ',0),(99463,'node',' hgw2k8r2dvmtn ',0),(99464,'node',' hgrhel5dns ',0),(99462,'node',' hemanthamainn1305290334 ',0),(99460,'node',' hgw2k8r2template ',0),(99461,'node',' linux1 ',0),(99458,'node',' hgmh3w2k8r2 ',0),(99459,'node',' hgsf1w2k8r2 ',0),(99457,'node',' hgtemplate ',0),(99455,'node',' favesxi5001sanity ',0),(99456,'node',' fasanity02w2k8r2 ',0),(99454,'node',' hgvmhemanth84gdlenglabnetappcom custom a 1 i  s 598854  ',0),(99453,'node',' naa6000c2939eabe43ec0406da8cf74e5fd ',0),(99452,'node',' naa6000c297ed59dbc39a6bbb805c2fb800 ',0),(99451,'node',' naa6000c2978055874f2dceb272e9b89104 ',0),(99450,'node',' naa6000c29e6c8266f8ff0e9ddc2367c593 ',0),(99449,'node',' naa6000c29fc92dc78e108403dfc0dc5004 ',0),(99448,'node',' naa6000c29b807b80b72131045915c52ffc ',0),(99447,'node',' naa6000c29843495e04fb98bb2a0dc2332c ',0),(99446,'node',' naa6000c29be91afe402ae96fef3affb26e ',0),(99445,'node',' naa6000c29a87723ee338351beefff3a76a ',0),(99475,'node',' chrismgmtvm ',0),(99476,'node',' bpmgmtvm ',0),(99477,'node',' hgw2k8r2mgmt ',0),(99478,'node',' hgvcenter01 ',0),(99479,'node',' hgfmcvcenter01 ',0),(99480,'node',' fmcangela ',0),(99481,'node',' hqqandisp ',0),(99482,'node',' fmczaloni ',0),(99483,'node',' hgvcenterperf ',0),(99484,'node',' hemantha ',0),(99485,'node',' hgnatk1w2k8r2 ',0),(99486,'node',' nataliemysqlvm ',0),(99487,'node',' fmczalonibarium ',0),(99488,'node',' fmcpreston1 ',0),(99489,'node',' fmcpreston ',0),(99490,'node',' fmcchris ',0),(99491,'node',' fmcmauricio ',0),(99492,'node',' fmcqa ',0),(99493,'node',' hgw2k8r2bp3 ',0),(99494,'node',' hgw2k8r2bp5 ',0),(99495,'node',' hgw2k8r2nfs4 ',0),(99496,'node',' hgw2k8r2e2e1 ',0),(99497,'node',' hgw2k8r2e2e4 ',0),(99498,'node',' hgw2k8r2e2e6 ',0),(99499,'node',' hgw2k8r2e2e7 ',0),(99500,'node',' hgw2k8r2e2e8 ',0),(99501,'node',' hgw2k8r2e2e9nrn ',0),(99502,'node',' hgw2k8r2e2e10 custom a 1 i  s 598855  ',0),(99503,'node',' hgw2k8r2e2e11 ',0),(99504,'node',' hgw2k8r2e2e12 ',0),(99505,'node',' hgw2k8r2cs11 ',0),(99506,'node',' hgw2k8r2cs1 ',0),(99507,'node',' hgw2k8r2cs3 ',0),(99508,'node',' naa6000c290b1821e62cf431ca26bf1f765 ',0),(99509,'node',' hgw2k8r2cs5 ',0),(99510,'node',' hgw2k8r2cs6 ',0),(99511,'node',' hgw2k8r2cs4 ',0),(99512,'node',' hgw2k8r2cs7 ',0),(99514,'node',' naa6000c29a784d07bfd536222612ee057f ',0),(99513,'node',' naa6000c294aba0be1db4257742f4ab2149 ',0),(99515,'node',' naa6000c291fd64f90bd3d371b644cee3c5 ',0),(99516,'node',' hgw2k8r2cs9 ',0),(99517,'node',' hgw2k8r2cs10 ',0),(99518,'node',' hgw2k8r2cs8 ',0),(99519,'node',' hgw2k8r2ms1 ',0),(99520,'node',' hgw2k8r2cs12 ',0),(104872,'node',' 1371042183 ',0),(99521,'node',' hgw2k8r2cs13 ',0),(104869,'node',' 1371042183 ',0),(104861,'node',' 1371042182   ',0),(104864,'node',' 1371042183 ',0),(99522,'node',' hgw2k8r2e2e62 ',0),(104860,'node',' 1371042126   ',0),(99523,'node',' hgw2k8r2e2e63 ',0),(99529,'node',' hgw2k8r25 ',0),(99528,'node',' hgw2k8r2e2e2 ',0),(99524,'node',' hgw2k8r22 ',0),(99525,'node',' naa6000c2973380870eb4d88784ea671eca ',0),(99526,'node',' naa6000c29102ce37a07ac01e2ced3959b8 ',0),(99527,'node',' naa60a9800037543261505d424f31325645 ',0),(99530,'node',' naa6000c29eeb2b6dbd2d24552781be174b ',0),(99531,'node',' naa6000c2967523a755b6fc0df302814030 ',0),(104862,'node',' 1371042182 ',0),(104863,'node',' 1371042183   ',0),(104865,'node',' 1371042183 ',0),(104866,'node',' 1371042183 ',0),(104867,'node',' 1371042183 ',0),(104868,'node',' 1371042183 ',0),(104870,'node',' 1371042183 ',0),(104871,'node',' 1371042183 ',0),(178549,'node',' 1371596763 1556  ',0),(178550,'node',' 1371596763 1764  ',0),(178552,'node',' 1371596763 1607  ',0),(178553,'node',' 1371596763 1543  ',0),(178554,'node',' 1371596763 1678  ',0),(178556,'node',' 1371596764   ',0),(178564,'node',' 1371596764   ',0),(178566,'node',' 1371596765   ',0),(178558,'node',' 1371596764   ',0),(178559,'node',' 1371596764   ',0),(178560,'node',' 1371596764   ',0),(178569,'node',' 1371596823 1665  ',0),(178570,'node',' 1371596823 1636  ',0),(178562,'node',' 1371596764   ',0),(178571,'node',' 1371596823 1442  ',0),(178572,'node',' 1371596823 1549  ',0),(178510,'node',' 1371596703 1492  ',0),(178512,'node',' 1371596703 1542  ',0),(178513,'node',' 1371596703 1579  ',0),(178514,'node',' 1371596703 1570  ',0),(178516,'node',' 1371596704 1592  ',0),(178517,'node',' 1371596704 1592  ',0),(178518,'node',' 1371596704 1497  ',0),(178519,'node',' 1371596704 1439  ',0),(178520,'node',' 1371596704 1455  ',0),(178456,'node',' 1371596583 1526  ',0),(178459,'node',' 1371596583 1655  ',0),(178460,'node',' 1371596583 1666  ',0),(178461,'node',' 1371596583 1503  ',0),(178463,'node',' 1371596584   ',0),(178465,'node',' 1371596584   ',0),(178466,'node',' 1371596584   ',0),(178467,'node',' 1371596584   ',0),(178469,'node',' 1371596585   ',0),(178471,'node',' 1371596585   ',0),(178428,'node',' 1371596524 1657  ',0),(178432,'node',' 1371596525   ',0),(178434,'node',' 1371596525   ',0),(178435,'node',' 1371596525   ',0),(178429,'node',' 1371596524 1561  ',0),(178353,'node',' 1371596403 1491  ',0),(178357,'node',' 1371596403 1461  ',0),(178358,'node',' 1371596403 1717  ',0),(178359,'node',' 1371596403 1543  ',0),(178354,'node',' 1371596403 1629  ',0),(178355,'node',' 1371596403 1561  ',0),(178363,'node',' 1371596404 1531  ',0),(178361,'node',' 1371596404 1534  ',0),(178362,'node',' 1371596404 1309  ',0),(178367,'node',' 1371596404 1714  ',0),(178364,'node',' 1371596404 1663  ',0),(178365,'node',' 1371596404 1564  ',0),(178372,'node',' 1371596405   ',0),(178368,'node',' 1371596404 1616  ',0),(178370,'node',' 1371596405   ',0),(178378,'node',' 1371596405   ',0),(178380,'node',' 1371596406   ',0),(178373,'node',' 1371596405   ',0),(178374,'node',' 1371596405   ',0),(178385,'node',' 1371596462 1563  ',0),(178386,'node',' 1371596462 1561  ',0),(178383,'node',' 1371596462 1657  ',0),(178384,'node',' 1371596462 1702  ',0),(178387,'node',' 1371596462 1534  ',0),(178395,'node',' 1371596463 1553  ',0),(178404,'node',' 1371596464   ',0),(178411,'node',' 1371596465   ',0),(178526,'node',' 1371596705   ',0),(178515,'node',' 1371596704 1553  ',0),(178524,'node',' 1371596705   ',0),(178484,'node',' 1371596644 1596  ',0),(178475,'node',' 1371596643 1596  ',0),(178472,'node',' 1371596585   ',0),(178474,'node',' 1371596642   ',0),(178441,'node',' 1371596526   ',0),(178443,'node',' 1371596581   ',0),(178437,'node',' 1371596525   ',0),(178439,'node',' 1371596525   ',0),(178406,'node',' 1371596464   ',0),(178391,'node',' 1371596463 1567  ',0),(178400,'node',' 1371596464   ',0),(178402,'node',' 1371596464   ',0),(178371,'node',' 1371596405   ',0),(178375,'node',' 1371596405   ',0),(178360,'node',' 1371596404 1569  ',0),(178369,'node',' 1371596405   ',0),(178351,'node',' 1371596403 1562  ',0),(178348,'node',' 1371596345   ',0),(178350,'node',' 1371596402   ',0),(178346,'node',' 1371596345   ',0),(178298,'node',' 1371596283 1580  ',0),(178307,'node',' 1371596284   ',0),(178309,'node',' 1371596284   ',0),(178313,'node',' 1371596284   ',0),(178315,'node',' 1371596284 107  ',0),(178317,'node',' 1371596285   ',0),(178319,'node',' 1371596342   ',0),(178320,'node',' 1371596342 1592  ',0),(178329,'node',' 1371596344 1595  ',0),(178338,'node',' 1371596344   ',0),(178340,'node',' 1371596344   ',0),(178344,'node',' 1371596345   ',0),(104971,'node',' 1371042243 ',0),(104972,'node',' 1371042243 ',0),(104969,'node',' 1371042243 ',0),(104970,'node',' 1371042243 ',0),(104965,'node',' 1371042243 ',0),(104968,'node',' 1371042243 ',0),(104961,'node',' 1371042243 ',0),(104964,'node',' 1371042243 ',0),(104955,'node',' 1371042243 ',0),(104958,'node',' 1371042243 ',0),(104951,'node',' 1371042243 ',0),(104952,'node',' 1371042243 ',0),(104945,'node',' 1371042243 ',0),(104948,'node',' 1371042243 ',0),(104941,'node',' 1371042243 ',0),(104942,'node',' 1371042243 ',0),(104935,'node',' 1371042243 ',0),(104938,'node',' 1371042243 ',0),(104929,'node',' 1371042243 ',0),(104932,'node',' 1371042243 ',0),(104925,'node',' 1371042242 ',0),(104928,'node',' 1371042243 ',0),(104919,'node',' 1371042183 ',0),(104922,'node',' 1371042183 ',0),(104913,'node',' 1371042183 ',0),(104916,'node',' 1371042183 ',0),(104909,'node',' 1371042183 ',0),(104910,'node',' 1371042183 ',0),(104903,'node',' 1371042183 ',0),(104906,'node',' 1371042183 ',0),(104899,'node',' 1371042183 ',0),(104902,'node',' 1371042183 ',0),(104895,'node',' 1371042183 ',0),(104896,'node',' 1371042183 ',0),(104887,'node',' 1371042183 ',0),(104892,'node',' 1371042183 ',0),(104883,'node',' 1371042183 ',0),(104886,'node',' 1371042183 ',0),(104877,'node',' 1371042183 ',0),(104880,'node',' 1371042183 ',0),(104873,'node',' 1371042183 ',0),(104874,'node',' 1371042183 ',0),(104875,'node',' 1371042183 ',0),(104876,'node',' 1371042183 ',0),(104878,'node',' 1371042183 ',0),(104879,'node',' 1371042183 ',0),(104881,'node',' 1371042183 ',0),(104882,'node',' 1371042183 ',0),(104884,'node',' 1371042183 ',0),(104885,'node',' 1371042183 ',0),(104888,'node',' 1371042183 ',0),(104889,'node',' 1371042183 ',0),(104890,'node',' 1371042183 ',0),(104891,'node',' 1371042183 ',0),(104893,'node',' 1371042183 ',0),(104894,'node',' 1371042183 ',0),(104897,'node',' 1371042183 ',0),(104898,'node',' 1371042183 ',0),(104900,'node',' 1371042183 ',0),(104901,'node',' 1371042183 ',0),(104904,'node',' 1371042183 ',0),(104905,'node',' 1371042183 ',0),(104907,'node',' 1371042183 ',0),(104908,'node',' 1371042183 ',0),(104911,'node',' 1371042183 ',0),(104912,'node',' 1371042183 ',0),(104914,'node',' 1371042183 ',0),(104915,'node',' 1371042183 ',0),(104917,'node',' 1371042183 ',0),(104918,'node',' 1371042183 ',0),(104920,'node',' 1371042183 ',0),(104921,'node',' 1371042183 ',0),(104923,'node',' 1371042186   ',0),(104924,'node',' 1371042242   ',0),(104926,'node',' 1371042243   ',0),(104927,'node',' 1371042243 ',0),(104930,'node',' 1371042243 ',0),(104931,'node',' 1371042243 ',0),(104933,'node',' 1371042243 ',0),(104934,'node',' 1371042243 ',0),(104936,'node',' 1371042243 ',0),(104937,'node',' 1371042243 ',0),(104939,'node',' 1371042243 ',0),(104940,'node',' 1371042243 ',0),(104943,'node',' 1371042243 ',0),(104944,'node',' 1371042243 ',0),(104946,'node',' 1371042243 ',0),(104947,'node',' 1371042243 ',0),(104949,'node',' 1371042243 ',0),(104950,'node',' 1371042243 ',0),(104953,'node',' 1371042243 ',0),(104954,'node',' 1371042243 ',0),(104956,'node',' 1371042243 ',0),(104957,'node',' 1371042243 ',0),(104959,'node',' 1371042243 ',0),(104960,'node',' 1371042243 ',0),(104962,'node',' 1371042243 ',0),(104963,'node',' 1371042243 ',0),(104966,'node',' 1371042243 ',0),(104967,'node',' 1371042243 ',0),(178382,'node',' 1371596462 1561  ',0),(178381,'node',' 1371596462   ',0),(178377,'node',' 1371596405   ',0),(178379,'node',' 1371596406   ',0),(178412,'node',' 1371596522   ',0),(178408,'node',' 1371596465   ',0),(178410,'node',' 1371596465   ',0),(178413,'node',' 1371596523 1570  ',0),(178431,'node',' 1371596525   ',0),(178433,'node',' 1371596525   ',0),(178422,'node',' 1371596524 1582  ',0),(178462,'node',' 1371596584   ',0),(178453,'node',' 1371596583 1564  ',0),(178444,'node',' 1371596582 1573  ',0),(178464,'node',' 1371596584   ',0),(178468,'node',' 1371596585   ',0),(178470,'node',' 1371596585   ',0),(178493,'node',' 1371596645   ',0),(178501,'node',' 1371596646   ',0),(178495,'node',' 1371596645   ',0),(178499,'node',' 1371596646   ',0),(178503,'node',' 1371596646   ',0),(178505,'node',' 1371596702   ',0),(178506,'node',' 1371596703 1588  ',0),(178530,'node',' 1371596705   ',0),(178532,'node',' 1371596705   ',0),(178534,'node',' 1371596706   ',0),(178536,'node',' 1371596761   ',0),(178537,'node',' 1371596762 1585  ',0),(178352,'node',' 1371596403 1554  ',0),(178366,'node',' 1371596404 1590  ',0),(178376,'node',' 1371596405   ',0),(178342,'node',' 1371596344   ',0),(178343,'node',' 1371596344   ',0),(178349,'node',' 1371596345   ',0),(178333,'node',' 1371596344 1578  ',0),(178334,'node',' 1371596344 1548  ',0),(178337,'node',' 1371596344 1638  ',0),(178325,'node',' 1371596342 1541  ',0),(178326,'node',' 1371596342 1699  ',0),(178330,'node',' 1371596344 1590  ',0),(178310,'node',' 1371596284   ',0),(178321,'node',' 1371596342 1579  ',0),(178322,'node',' 1371596342 1510  ',0),(178302,'node',' 1371596283 1677  ',0),(178306,'node',' 1371596283 1644  ',0),(178308,'node',' 1371596284   ',0),(178303,'node',' 1371596283 1511  ',0),(178304,'node',' 1371596283 1620  ',0),(178305,'node',' 1371596283 1515  ',0),(178311,'node',' 1371596284   ',0),(178312,'node',' 1371596284   ',0),(178314,'node',' 1371596284   ',0),(178316,'node',' 1371596284 107  ',0),(178318,'node',' 1371596285   ',0),(178323,'node',' 1371596342 1663  ',0),(178324,'node',' 1371596342 1553  ',0),(178327,'node',' 1371596342 1522  ',0),(178328,'node',' 1371596342 1660  ',0),(178331,'node',' 1371596344 1658  ',0),(178332,'node',' 1371596344 1698  ',0),(178335,'node',' 1371596344 1551  ',0),(178336,'node',' 1371596344 1491  ',0),(178339,'node',' 1371596344   ',0),(178341,'node',' 1371596344   ',0),(178345,'node',' 1371596345   ',0),(178347,'node',' 1371596345   ',0),(178356,'node',' 1371596403 1525  ',0),(178388,'node',' 1371596462 1400  ',0),(178389,'node',' 1371596462 1514  ',0),(178390,'node',' 1371596462 1539  ',0),(178392,'node',' 1371596463 1567  ',0),(178393,'node',' 1371596463 1583  ',0),(178394,'node',' 1371596463 1468  ',0),(178396,'node',' 1371596463 1644  ',0),(178397,'node',' 1371596463 1570  ',0),(178398,'node',' 1371596463 1564  ',0),(178399,'node',' 1371596463 1582  ',0),(178401,'node',' 1371596464   ',0),(178403,'node',' 1371596464   ',0),(178405,'node',' 1371596464   ',0),(178407,'node',' 1371596464   ',0),(178409,'node',' 1371596465   ',0),(178414,'node',' 1371596523 1626  ',0),(178415,'node',' 1371596523 1527  ',0),(178416,'node',' 1371596523 1703  ',0),(178417,'node',' 1371596523 1427  ',0),(178418,'node',' 1371596523 1548  ',0),(178419,'node',' 1371596523 1563  ',0),(178420,'node',' 1371596523 1417  ',0),(178421,'node',' 1371596523 1724  ',0),(178423,'node',' 1371596524 1685  ',0),(178424,'node',' 1371596524 1661  ',0),(178425,'node',' 1371596524 1550  ',0),(178426,'node',' 1371596524 1400  ',0),(178427,'node',' 1371596524 1627  ',0),(178430,'node',' 1371596524 1496  ',0),(178267,'node',' 1371596224 1571  ',0),(178257,'node',' 1371596222   ',0),(178258,'node',' 1371596223 1609  ',0),(178227,'node',' 1371596162 1605  ',0),(178222,'node',' 1371596105   ',0),(178224,'node',' 1371596106   ',0),(178226,'node',' 1371596161   ',0),(178195,'node',' 1371596102   ',0),(178191,'node',' 1371596045   ',0),(178193,'node',' 1371596045   ',0),(178160,'node',' 1371595984   ',0),(178162,'node',' 1371595985   ',0),(178264,'node',' 1371596223 1634  ',0),(178263,'node',' 1371596223 1521  ',0),(178268,'node',' 1371596224 1656  ',0),(178265,'node',' 1371596223 1585  ',0),(178266,'node',' 1371596223 1806  ',0),(178269,'node',' 1371596224 1463  ',0),(178270,'node',' 1371596224 1575  ',0),(178272,'node',' 1371596224 1599  ',0),(178271,'node',' 1371596224 1596  ',0),(178274,'node',' 1371596224 1678  ',0),(178273,'node',' 1371596224 1535  ',0),(178235,'node',' 1371596162 1497  ',0),(178213,'node',' 1371596104 1524  ',0),(178215,'node',' 1371596105   ',0),(178217,'node',' 1371596105   ',0),(178212,'node',' 1371596104 1396  ',0),(178218,'node',' 1371596105   ',0),(178219,'node',' 1371596105   ',0),(178221,'node',' 1371596105   ',0),(178228,'node',' 1371596162 1605  ',0),(178223,'node',' 1371596105   ',0),(178225,'node',' 1371596106   ',0),(178229,'node',' 1371596162 1675  ',0),(178230,'node',' 1371596162 1681  ',0),(178237,'node',' 1371596163 1510  ',0),(178171,'node',' 1371596042 1521  ',0),(178172,'node',' 1371596042 1641  ',0),(178173,'node',' 1371596042 1643  ',0),(178175,'node',' 1371596044 1599  ',0),(178177,'node',' 1371596044 1645  ',0),(178176,'node',' 1371596044 1564  ',0),(178178,'node',' 1371596044 1649  ',0),(178179,'node',' 1371596044 1599  ',0),(178181,'node',' 1371596044 1609  ',0),(178180,'node',' 1371596044 1574  ',0),(178182,'node',' 1371596044 1579  ',0),(178134,'node',' 1371595982 1571  ',0),(178100,'node',' 1371595865   ',0),(178067,'node',' 1371595805   ',0),(178030,'node',' 1371595744   ',0),(177873,'node',' 1371595445   ',0),(177824,'node',' 1371595383 1553  ',0),(177792,'node',' 1371595322   ',0),(177786,'node',' 1371595265   ',0),(105069,'node',' 1371042363 ',0),(105072,'node',' 1371042363 ',0),(105065,'node',' 1371042363 ',0),(105068,'node',' 1371042363 ',0),(105059,'node',' 1371042363 ',0),(105062,'node',' 1371042363 ',0),(105055,'node',' 1371042363 ',0),(105058,'node',' 1371042363 ',0),(105049,'node',' 1371042306   ',0),(105052,'node',' 1371042363 588  ',0),(105043,'node',' 1371042303 ',0),(105046,'node',' 1371042303 ',0),(105039,'node',' 1371042303 ',0),(105042,'node',' 1371042303 ',0),(105033,'node',' 1371042303 ',0),(105036,'node',' 1371042303 ',0),(105029,'node',' 1371042303 ',0),(105030,'node',' 1371042303 ',0),(105023,'node',' 1371042303 ',0),(105026,'node',' 1371042303 ',0),(105013,'node',' 1371042303 ',0),(105017,'node',' 1371042303 ',0),(105009,'node',' 1371042303 ',0),(105010,'node',' 1371042303 ',0),(104999,'node',' 1371042303 ',0),(105006,'node',' 1371042303 ',0),(104993,'node',' 1371042303 ',0),(104996,'node',' 1371042303 ',0),(104989,'node',' 1371042303   ',0),(104992,'node',' 1371042303 ',0),(104983,'node',' 1371042243 ',0),(104986,'node',' 1371042246   ',0),(104979,'node',' 1371042243 ',0),(104980,'node',' 1371042243 ',0),(104973,'node',' 1371042243 ',0),(104976,'node',' 1371042243 ',0),(104974,'node',' 1371042243 ',0),(104975,'node',' 1371042243 ',0),(104977,'node',' 1371042243 ',0),(104978,'node',' 1371042243 ',0),(104981,'node',' 1371042243 ',0),(104982,'node',' 1371042243 ',0),(104984,'node',' 1371042243 ',0),(104985,'node',' 1371042243 ',0),(104987,'node',' 1371042302   ',0),(104988,'node',' 1371042302 ',0),(104990,'node',' 1371042303 ',0),(104991,'node',' 1371042303 ',0),(104994,'node',' 1371042303 ',0),(104995,'node',' 1371042303 ',0),(104997,'node',' 1371042303 ',0),(104998,'node',' 1371042303 ',0),(105000,'node',' 1371042303 ',0),(105001,'node',' 1371042303 ',0),(105002,'node',' 1371042303 ',0),(105003,'node',' 1371042303 ',0),(105004,'node',' 1371042303 ',0),(105005,'node',' 1371042303 ',0),(105007,'node',' 1371042303 ',0),(105008,'node',' 1371042303 ',0),(105011,'node',' 1371042303 ',0),(105012,'node',' 1371042303 ',0),(105014,'node',' 1371042303 ',0),(105015,'node',' 1371042303 ',0),(105016,'node',' 1371042303 ',0),(105018,'node',' 1371042303 ',0),(105019,'node',' 1371042303 ',0),(105020,'node',' 1371042303 ',0),(105021,'node',' 1371042303 ',0),(105022,'node',' 1371042303 ',0),(105024,'node',' 1371042303 ',0),(105025,'node',' 1371042303 ',0),(105027,'node',' 1371042303 ',0),(105028,'node',' 1371042303 ',0),(105031,'node',' 1371042303 ',0),(105032,'node',' 1371042303 ',0),(105034,'node',' 1371042303 ',0),(105035,'node',' 1371042303 ',0),(105037,'node',' 1371042303 ',0),(105038,'node',' 1371042303 ',0),(105040,'node',' 1371042303 ',0),(105041,'node',' 1371042303 ',0),(105044,'node',' 1371042303 ',0),(105045,'node',' 1371042303 ',0),(105047,'node',' 1371042303 ',0),(105048,'node',' 1371042303 ',0),(105050,'node',' 1371042362   ',0),(105051,'node',' 1371042362 ',0),(105053,'node',' 1371042363 ',0),(105054,'node',' 1371042363 ',0),(105056,'node',' 1371042363 ',0),(105057,'node',' 1371042363 ',0),(105060,'node',' 1371042363 ',0),(105061,'node',' 1371042363 ',0),(105063,'node',' 1371042363 ',0),(105064,'node',' 1371042363 ',0),(105066,'node',' 1371042363 ',0),(105067,'node',' 1371042363 ',0),(105070,'node',' 1371042363 ',0),(105071,'node',' 1371042363 ',0),(177863,'node',' 1371595443 1630  ',0),(177861,'node',' 1371595443 1558  ',0),(177859,'node',' 1371595443 1563  ',0),(177860,'node',' 1371595443 1628  ',0),(165843,'node',' 1371575170   ',0),(165841,'node',' 1371575170   ',0),(165750,'node',' 1371575110   ',0),(165746,'node',' 1371575110   ',0),(165655,'node',' 1371575049   ',0),(165653,'node',' 1371575049   ',0),(165562,'node',' 1371574989   ',0),(165564,'node',' 1371574989   ',0),(165553,'node',' 1371574988 1434  ',0),(165392,'node',' 1371574921   ',0),(165393,'node',' 1371574923   ',0),(165390,'node',' 1371574870   ',0),(165299,'node',' 1371574809   ',0),(165297,'node',' 1371574809   ',0),(165206,'node',' 1371574749   ',0),(165204,'node',' 1371574749   ',0),(165113,'node',' 1371574689   ',0),(165109,'node',' 1371574689   ',0),(165018,'node',' 1371574628   ',0),(165016,'node',' 1371574628   ',0),(165257,'node',' 1371574803   ',0),(165258,'node',' 1371574803   ',0),(165259,'node',' 1371574803   ',0),(165224,'node',' 1371574803   ',0),(165225,'node',' 1371574803   ',0),(165226,'node',' 1371574803   ',0),(165014,'node',' 1371574628 1456  ',0),(165015,'node',' 1371574628 1277  ',0),(165034,'node',' 1371574683   ',0),(165035,'node',' 1371574683   ',0),(165032,'node',' 1371574683   ',0),(165033,'node',' 1371574683   ',0),(165037,'node',' 1371574683   ',0),(165038,'node',' 1371574683   ',0),(165040,'node',' 1371574683   ',0),(165041,'node',' 1371574683   ',0),(165039,'node',' 1371574683   ',0),(164848,'node',' 1371574564   ',0),(164849,'node',' 1371574564   ',0),(164926,'node',' 1371574569   ',0),(164928,'node',' 1371574569   ',0),(164929,'node',' 1371574569   ',0),(164939,'node',' 1371574623   ',0),(164940,'node',' 1371574623   ',0),(164941,'node',' 1371574623   ',0),(164942,'node',' 1371574623   ',0),(164943,'node',' 1371574623   ',0),(164851,'node',' 1371574564   ',0),(154637,'node',' 1371567787 1688  ',0),(154602,'node',' 1371567783   ',0),(154603,'node',' 1371567783   ',0),(154597,'node',' 1371567783   ',0),(154601,'node',' 1371567783   ',0),(154595,'node',' 1371567783   ',0),(154596,'node',' 1371567783   ',0),(154589,'node',' 1371567783   ',0),(154594,'node',' 1371567783   ',0),(154592,'node',' 1371567783   ',0),(154593,'node',' 1371567783   ',0),(154590,'node',' 1371567783   ',0),(154591,'node',' 1371567783   ',0),(154598,'node',' 1371567783   ',0),(154599,'node',' 1371567783   ',0),(154600,'node',' 1371567783   ',0),(154567,'node',' 1371567783   ',0),(154568,'node',' 1371567783   ',0),(154569,'node',' 1371567783   ',0),(154570,'node',' 1371567783   ',0),(154571,'node',' 1371567783   ',0),(154572,'node',' 1371567783   ',0),(154573,'node',' 1371567783   ',0),(154574,'node',' 1371567783   ',0),(154463,'node',' 1371567669   ',0),(154464,'node',' 1371567669   ',0),(154413,'node',' 1371567664   ',0),(154414,'node',' 1371567664   ',0),(154415,'node',' 1371567664   ',0),(154416,'node',' 1371567664   ',0),(154417,'node',' 1371567664   ',0),(154418,'node',' 1371567664   ',0),(154419,'node',' 1371567664   ',0),(154420,'node',' 1371567664   ',0),(154319,'node',' 1371567604   ',0),(154320,'node',' 1371567604   ',0),(154321,'node',' 1371567604   ',0),(154322,'node',' 1371567604   ',0),(154323,'node',' 1371567604   ',0),(154324,'node',' 1371567604   ',0),(154325,'node',' 1371567604   ',0),(154326,'node',' 1371567604   ',0),(154327,'node',' 1371567604   ',0),(154328,'node',' 1371567604   ',0),(154206,'node',' 1371567543   ',0),(154207,'node',' 1371567543   ',0),(154208,'node',' 1371567543   ',0),(154209,'node',' 1371567543   ',0),(154210,'node',' 1371567543   ',0),(154211,'node',' 1371567543   ',0),(154212,'node',' 1371567543   ',0),(154213,'node',' 1371567543   ',0),(154214,'node',' 1371567543   ',0),(154215,'node',' 1371567543   ',0),(105169,'node',' 1371042424 ',0),(105170,'node',' 1371042424 ',0),(105163,'node',' 1371042424 ',0),(105166,'node',' 1371042424 ',0),(105159,'node',' 1371042424 ',0),(105160,'node',' 1371042424 ',0),(105153,'node',' 1371042424 ',0),(105156,'node',' 1371042424 ',0),(105149,'node',' 1371042424 ',0),(105150,'node',' 1371042424 ',0),(105143,'node',' 1371042424 ',0),(105146,'node',' 1371042424 ',0),(105139,'node',' 1371042424 ',0),(105142,'node',' 1371042424 ',0),(105133,'node',' 1371042424 ',0),(105136,'node',' 1371042424 ',0),(105129,'node',' 1371042424 ',0),(105130,'node',' 1371042424 ',0),(105123,'node',' 1371042424 ',0),(105126,'node',' 1371042424 ',0),(105117,'node',' 1371042424 ',0),(105120,'node',' 1371042424 ',0),(105113,'node',' 1371042422   ',0),(105116,'node',' 1371042424 ',0),(105107,'node',' 1371042363 ',0),(105110,'node',' 1371042363 ',0),(105103,'node',' 1371042363 ',0),(105106,'node',' 1371042363 ',0),(105099,'node',' 1371042363 ',0),(105102,'node',' 1371042363 ',0),(105095,'node',' 1371042363 ',0),(105098,'node',' 1371042363 ',0),(105093,'node',' 1371042363 ',0),(105094,'node',' 1371042363 ',0),(105089,'node',' 1371042363 ',0),(105090,'node',' 1371042363 ',0),(105083,'node',' 1371042363 ',0),(105086,'node',' 1371042363 ',0),(105073,'node',' 1371042363 ',0),(105076,'node',' 1371042363 ',0),(105074,'node',' 1371042363 ',0),(105075,'node',' 1371042363 ',0),(105077,'node',' 1371042363 ',0),(105078,'node',' 1371042363 ',0),(105079,'node',' 1371042363 ',0),(105080,'node',' 1371042363 ',0),(105081,'node',' 1371042363 ',0),(105082,'node',' 1371042363 ',0),(105084,'node',' 1371042363 ',0),(105085,'node',' 1371042363 ',0),(105087,'node',' 1371042363 ',0),(105088,'node',' 1371042363 ',0),(105091,'node',' 1371042363 ',0),(105092,'node',' 1371042363 ',0),(105096,'node',' 1371042363 ',0),(105097,'node',' 1371042363 ',0),(105100,'node',' 1371042363 ',0),(105101,'node',' 1371042363 ',0),(105104,'node',' 1371042363 ',0),(105105,'node',' 1371042363 ',0),(105108,'node',' 1371042363 ',0),(105109,'node',' 1371042363 ',0),(105111,'node',' 1371042363 ',0),(105112,'node',' 1371042366   ',0),(105114,'node',' 1371042422 ',0),(105115,'node',' 1371042424   ',0),(105118,'node',' 1371042424 ',0),(105119,'node',' 1371042424 ',0),(105121,'node',' 1371042424 ',0),(105122,'node',' 1371042424 ',0),(105124,'node',' 1371042424 ',0),(105125,'node',' 1371042424 ',0),(105127,'node',' 1371042424 ',0),(105128,'node',' 1371042424 ',0),(105131,'node',' 1371042424 ',0),(105132,'node',' 1371042424 ',0),(105134,'node',' 1371042424 ',0),(105135,'node',' 1371042424 ',0),(105137,'node',' 1371042424 ',0),(105138,'node',' 1371042424 ',0),(105140,'node',' 1371042424 ',0),(105141,'node',' 1371042424 ',0),(105144,'node',' 1371042424 ',0),(105145,'node',' 1371042424 ',0),(105147,'node',' 1371042424 ',0),(105148,'node',' 1371042424 ',0),(105151,'node',' 1371042424 ',0),(105152,'node',' 1371042424 ',0),(105154,'node',' 1371042424 ',0),(105155,'node',' 1371042424 ',0),(105157,'node',' 1371042424 ',0),(105158,'node',' 1371042424 ',0),(105161,'node',' 1371042424 ',0),(105162,'node',' 1371042424 ',0),(105164,'node',' 1371042424 ',0),(105165,'node',' 1371042424 ',0),(105167,'node',' 1371042424 ',0),(105168,'node',' 1371042424 ',0),(105171,'node',' 1371042424 ',0),(105172,'node',' 1371042424 ',0),(154129,'node',' 1371567483   ',0),(154132,'node',' 1371567483   ',0),(154130,'node',' 1371567483   ',0),(154131,'node',' 1371567483   ',0),(154133,'node',' 1371567483   ',0),(154134,'node',' 1371567483   ',0),(154135,'node',' 1371567483   ',0),(154136,'node',' 1371567483   ',0),(154137,'node',' 1371567483   ',0),(154138,'node',' 1371567483   ',0),(154139,'node',' 1371567483   ',0),(153933,'node',' 1371567364   ',0),(153934,'node',' 1371567364   ',0),(153940,'node',' 1371567364   ',0),(153935,'node',' 1371567364   ',0),(153939,'node',' 1371567364   ',0),(153936,'node',' 1371567364   ',0),(153937,'node',' 1371567364   ',0),(153942,'node',' 1371567364   ',0),(153941,'node',' 1371567364   ',0),(153938,'node',' 1371567364   ',0),(153943,'node',' 1371567364   ',0),(153944,'node',' 1371567364   ',0),(153945,'node',' 1371567364   ',0),(192805,'node',' 1371630786   ',0),(192806,'node',' 1371630786   ',0),(192798,'node',' 1371630785   ',0),(192802,'node',' 1371630786   ',0),(192804,'node',' 1371630786   ',0),(192750,'node',' 1371630666   ',0),(192752,'node',' 1371630666   ',0),(192751,'node',' 1371630666   ',0),(192753,'node',' 1371630666   ',0),(192754,'node',' 1371630666   ',0),(192755,'node',' 1371630666   ',0),(192756,'node',' 1371630666   ',0),(192758,'node',' 1371630666   ',0),(192746,'node',' 1371630608   ',0),(192728,'node',' 1371630607   ',0),(192729,'node',' 1371630607   ',0),(192730,'node',' 1371630607   ',0),(192692,'node',' 1371630489   ',0),(192711,'node',' 1371630555   ',0),(192712,'node',' 1371630555   ',0),(192714,'node',' 1371630555 779  ',0),(192716,'node',' 1371630556   ',0),(192717,'node',' 1371630556   ',0),(192718,'node',' 1371630556   ',0),(192720,'node',' 1371630556   ',0),(192722,'node',' 1371630556   ',0),(192724,'node',' 1371630556   ',0),(192664,'node',' 1371630428   ',0),(192665,'node',' 1371630428   ',0),(192663,'node',' 1371630428   ',0),(192654,'node',' 1371630367   ',0),(192656,'node',' 1371630367   ',0),(192658,'node',' 1371630368   ',0),(192651,'node',' 1371630367   ',0),(192652,'node',' 1371630367   ',0),(192650,'node',' 1371630367   ',0),(192662,'node',' 1371630428   ',0),(192661,'node',' 1371630428   ',0),(141844,'node',' 1371559323   ',0),(141845,'node',' 1371559323   ',0),(141847,'node',' 1371559323   ',0),(141846,'node',' 1371559323   ',0),(105269,'node',' 1371042544 ',0),(105272,'node',' 1371042544 ',0),(105263,'node',' 1371042544 ',0),(105266,'node',' 1371042544 ',0),(105257,'node',' 1371042544 ',0),(105260,'node',' 1371042544 ',0),(105251,'node',' 1371042544 ',0),(105254,'node',' 1371042544 ',0),(105247,'node',' 1371042544 ',0),(105248,'node',' 1371042544 ',0),(105241,'node',' 1371042544   ',0),(105244,'node',' 1371042544 ',0),(105233,'node',' 1371042484 ',0),(105236,'node',' 1371042484 ',0),(105227,'node',' 1371042484 ',0),(105230,'node',' 1371042484 ',0),(105223,'node',' 1371042484 ',0),(105226,'node',' 1371042484 ',0),(105219,'node',' 1371042484 ',0),(105222,'node',' 1371042484 ',0),(105213,'node',' 1371042484 ',0),(105216,'node',' 1371042484 ',0),(105209,'node',' 1371042484 ',0),(105210,'node',' 1371042484 ',0),(105203,'node',' 1371042484 ',0),(105206,'node',' 1371042484 ',0),(105199,'node',' 1371042484 ',0),(105202,'node',' 1371042484 ',0),(105195,'node',' 1371042484 ',0),(105198,'node',' 1371042484 ',0),(105189,'node',' 1371042484 ',0),(105192,'node',' 1371042484 ',0),(105185,'node',' 1371042484 ',0),(105188,'node',' 1371042484 ',0),(105181,'node',' 1371042484 ',0),(105184,'node',' 1371042484 ',0),(105175,'node',' 1371042426   ',0),(105176,'node',' 1371042482   ',0),(105173,'node',' 1371042424 ',0),(105174,'node',' 1371042424 ',0),(105177,'node',' 1371042482 ',0),(105178,'node',' 1371042484   ',0),(105179,'node',' 1371042484 ',0),(105180,'node',' 1371042484 ',0),(105182,'node',' 1371042484 ',0),(105183,'node',' 1371042484 ',0),(105186,'node',' 1371042484 ',0),(105187,'node',' 1371042484 ',0),(105190,'node',' 1371042484 ',0),(105191,'node',' 1371042484 ',0),(105193,'node',' 1371042484 ',0),(105194,'node',' 1371042484 ',0),(105196,'node',' 1371042484 ',0),(105197,'node',' 1371042484 ',0),(105200,'node',' 1371042484 ',0),(105201,'node',' 1371042484 ',0),(105204,'node',' 1371042484 ',0),(105205,'node',' 1371042484 ',0),(105207,'node',' 1371042484 ',0),(105208,'node',' 1371042484 ',0),(105211,'node',' 1371042484 ',0),(105212,'node',' 1371042484 ',0),(105214,'node',' 1371042484 ',0),(105215,'node',' 1371042484 ',0),(105217,'node',' 1371042484 ',0),(105218,'node',' 1371042484 ',0),(105220,'node',' 1371042484 ',0),(105221,'node',' 1371042484 ',0),(105224,'node',' 1371042484 ',0),(105225,'node',' 1371042484 ',0),(105228,'node',' 1371042484 ',0),(105229,'node',' 1371042484 ',0),(105231,'node',' 1371042484 ',0),(105232,'node',' 1371042484 ',0),(105234,'node',' 1371042484 ',0),(105235,'node',' 1371042484 ',0),(105237,'node',' 1371042484 ',0),(105238,'node',' 1371042486   ',0),(105239,'node',' 1371042542   ',0),(105240,'node',' 1371042542 ',0),(105242,'node',' 1371042544 ',0),(105243,'node',' 1371042544 ',0),(105245,'node',' 1371042544 ',0),(105246,'node',' 1371042544 ',0),(105249,'node',' 1371042544 ',0),(105250,'node',' 1371042544 ',0),(105252,'node',' 1371042544 ',0),(105253,'node',' 1371042544 ',0),(105255,'node',' 1371042544 ',0),(105256,'node',' 1371042544 ',0),(105258,'node',' 1371042544 ',0),(105259,'node',' 1371042544 ',0),(105261,'node',' 1371042544 ',0),(105262,'node',' 1371042544 ',0),(105264,'node',' 1371042544 ',0),(105265,'node',' 1371042544 ',0),(105267,'node',' 1371042544 ',0),(105268,'node',' 1371042544 ',0),(105270,'node',' 1371042544 ',0),(105271,'node',' 1371042544 ',0),(192238,'node',' 1371628946   ',0),(192240,'node',' 1371628946   ',0),(192242,'node',' 1371628946   ',0),(192282,'node',' 1371629166   ',0),(192284,'node',' 1371629167   ',0),(192286,'node',' 1371629167   ',0),(192326,'node',' 1371629287   ',0),(192328,'node',' 1371629287   ',0),(192343,'node',' 1371629351   ',0),(192345,'node',' 1371629396   ',0),(192347,'node',' 1371629402   ',0),(192376,'node',' 1371629470   ',0),(192378,'node',' 1371629470   ',0),(192412,'node',' 1371629649   ',0),(192416,'node',' 1371629650   ',0),(192420,'node',' 1371629650   ',0),(192438,'node',' 1371629784   ',0),(192442,'node',' 1371629785   ',0),(192444,'node',' 1371629785   ',0),(192463,'node',' 1371629878 6667  ',0),(192465,'node',' 1371629881   ',0),(192466,'node',' 1371629885   ',0),(192667,'node',' 1371630428   ',0),(192668,'node',' 1371630428   ',0),(192670,'node',' 1371630429 6667  ',0),(192672,'node',' 1371630429   ',0),(192673,'node',' 1371630429   ',0),(192727,'node',' 1371630607   ',0),(192676,'node',' 1371630430   ',0),(192694,'node',' 1371630489   ',0),(192695,'node',' 1371630489   ',0),(192696,'node',' 1371630489   ',0),(192698,'node',' 1371630490   ',0),(192700,'node',' 1371630490   ',0),(192702,'node',' 1371630490   ',0),(192705,'node',' 1371630555   ',0),(192706,'node',' 1371630555   ',0),(192707,'node',' 1371630555   ',0),(192708,'node',' 1371630555   ',0),(192709,'node',' 1371630555   ',0),(192710,'node',' 1371630555   ',0),(192689,'node',' 1371630489   ',0),(192690,'node',' 1371630489   ',0),(192688,'node',' 1371630489   ',0),(192686,'node',' 1371630489   ',0),(192687,'node',' 1371630489   ',0),(192685,'node',' 1371630489   ',0),(192683,'node',' 1371630489   ',0),(192684,'node',' 1371630489   ',0),(192680,'node',' 1371630430   ',0),(192674,'node',' 1371630429   ',0),(192678,'node',' 1371630430   ',0),(192749,'node',' 1371630666   ',0),(192766,'node',' 1371630667   ',0),(192768,'node',' 1371630667   ',0),(192762,'node',' 1371630667   ',0),(192764,'node',' 1371630667   ',0),(192761,'node',' 1371630667   ',0),(192760,'node',' 1371630667   ',0),(192774,'node',' 1371630725   ',0),(192771,'node',' 1371630725   ',0),(192772,'node',' 1371630725   ',0),(192773,'node',' 1371630725   ',0),(192744,'node',' 1371630608   ',0),(192740,'node',' 1371630607   ',0),(192742,'node',' 1371630608   ',0),(192739,'node',' 1371630607   ',0),(192736,'node',' 1371630607 6667  ',0),(192738,'node',' 1371630607   ',0),(192734,'node',' 1371630607   ',0),(192733,'node',' 1371630607   ',0),(192731,'node',' 1371630607   ',0),(192732,'node',' 1371630607   ',0),(192793,'node',' 1371630785   ',0),(192812,'node',' 1371630787   ',0),(192815,'node',' 1371630845   ',0),(192810,'node',' 1371630787   ',0),(192808,'node',' 1371630786   ',0),(192794,'node',' 1371630785   ',0),(192795,'node',' 1371630785   ',0),(192796,'node',' 1371630785   ',0),(192797,'node',' 1371630785   ',0),(192799,'node',' 1371630785   ',0),(192800,'node',' 1371630785   ',0),(192786,'node',' 1371630726   ',0),(192783,'node',' 1371630726   ',0),(192784,'node',' 1371630726   ',0),(192782,'node',' 1371630726   ',0),(192778,'node',' 1371630725   ',0),(192780,'node',' 1371630726   ',0),(192777,'node',' 1371630725   ',0),(192775,'node',' 1371630725   ',0),(192776,'node',' 1371630725   ',0),(192788,'node',' 1371630727   ',0),(192790,'node',' 1371630727   ',0),(153932,'node',' 1371567364   ',0),(153931,'node',' 1371567364   ',0),(153929,'node',' 1371567364   ',0),(153930,'node',' 1371567364   ',0),(153928,'node',' 1371567364   ',0),(153923,'node',' 1371567310   ',0),(153925,'node',' 1371567310   ',0),(153955,'node',' 1371567364   ',0),(153956,'node',' 1371567364   ',0),(153954,'node',' 1371567364   ',0),(153953,'node',' 1371567364   ',0),(153951,'node',' 1371567364   ',0),(153952,'node',' 1371567364   ',0),(153950,'node',' 1371567364   ',0),(153949,'node',' 1371567364   ',0),(153947,'node',' 1371567364   ',0),(153948,'node',' 1371567364   ',0),(153946,'node',' 1371567364   ',0),(153966,'node',' 1371567364   ',0),(153998,'node',' 1371567368 1542  ',0),(153999,'node',' 1371567368 1557  ',0),(153965,'node',' 1371567364   ',0),(154000,'node',' 1371567368 1705  ',0),(154001,'node',' 1371567368 1634  ',0),(153963,'node',' 1371567364   ',0),(153964,'node',' 1371567364   ',0),(153962,'node',' 1371567364   ',0),(154004,'node',' 1371567368 1571  ',0),(154006,'node',' 1371567369   ',0),(153961,'node',' 1371567364   ',0),(153959,'node',' 1371567364   ',0),(153960,'node',' 1371567364   ',0),(153958,'node',' 1371567364   ',0),(153957,'node',' 1371567364   ',0),(153974,'node',' 1371567364   ',0),(153994,'node',' 1371567367 1652  ',0),(153972,'node',' 1371567364   ',0),(153973,'node',' 1371567364   ',0),(153971,'node',' 1371567364   ',0),(153995,'node',' 1371567367 1672  ',0),(153970,'node',' 1371567364   ',0),(153997,'node',' 1371567368 1671  ',0),(153969,'node',' 1371567364   ',0),(153967,'node',' 1371567364   ',0),(153968,'node',' 1371567364   ',0),(153975,'node',' 1371567364   ',0),(153993,'node',' 1371567367 1564  ',0),(154034,'node',' 1371567424   ',0),(154033,'node',' 1371567424   ',0),(154031,'node',' 1371567424   ',0),(154032,'node',' 1371567424   ',0),(154030,'node',' 1371567424   ',0),(154029,'node',' 1371567424   ',0),(154027,'node',' 1371567424   ',0),(154028,'node',' 1371567424   ',0),(154026,'node',' 1371567424   ',0),(154025,'node',' 1371567424   ',0),(154024,'node',' 1371567424   ',0),(154022,'node',' 1371567424   ',0),(154023,'node',' 1371567424   ',0),(154021,'node',' 1371567424   ',0),(154020,'node',' 1371567424   ',0),(154016,'node',' 1371567370   ',0),(154019,'node',' 1371567424   ',0),(154014,'node',' 1371567369   ',0),(154012,'node',' 1371567369   ',0),(154010,'node',' 1371567369   ',0),(154008,'node',' 1371567369   ',0),(154009,'node',' 1371567369   ',0),(154002,'node',' 1371567368 1502  ',0),(154003,'node',' 1371567368 1587  ',0),(153986,'node',' 1371567364   ',0),(153988,'node',' 1371567367 1704  ',0),(153984,'node',' 1371567364   ',0),(153985,'node',' 1371567364   ',0),(153983,'node',' 1371567364   ',0),(153989,'node',' 1371567367 1714  ',0),(153982,'node',' 1371567364   ',0),(153990,'node',' 1371567367 1605  ',0),(153980,'node',' 1371567364   ',0),(153981,'node',' 1371567364   ',0),(153979,'node',' 1371567364   ',0),(153991,'node',' 1371567367 1653  ',0),(153978,'node',' 1371567364   ',0),(153992,'node',' 1371567367 1538  ',0),(153976,'node',' 1371567364   ',0),(153977,'node',' 1371567364   ',0),(154604,'node',' 1371567783   ',0),(154605,'node',' 1371567783   ',0),(154606,'node',' 1371567783   ',0),(154607,'node',' 1371567783   ',0),(154035,'node',' 1371567424   ',0),(154036,'node',' 1371567424   ',0),(154045,'node',' 1371567424   ',0),(154046,'node',' 1371567424   ',0),(154044,'node',' 1371567424   ',0),(154043,'node',' 1371567424   ',0),(154041,'node',' 1371567424   ',0),(154042,'node',' 1371567424   ',0),(154040,'node',' 1371567424   ',0),(154038,'node',' 1371567424   ',0),(154039,'node',' 1371567424   ',0),(154037,'node',' 1371567424   ',0),(154128,'node',' 1371567483   ',0),(154126,'node',' 1371567483   ',0),(154127,'node',' 1371567483   ',0),(154125,'node',' 1371567483   ',0),(154123,'node',' 1371567483   ',0),(154124,'node',' 1371567483   ',0),(154122,'node',' 1371567483   ',0),(154121,'node',' 1371567483   ',0),(154119,'node',' 1371567483   ',0),(154120,'node',' 1371567483   ',0),(154118,'node',' 1371567483   ',0),(154117,'node',' 1371567483   ',0),(154115,'node',' 1371567483   ',0),(154116,'node',' 1371567483   ',0),(154114,'node',' 1371567483   ',0),(154113,'node',' 1371567483   ',0),(154111,'node',' 1371567483   ',0),(154112,'node',' 1371567483   ',0),(154110,'node',' 1371567483   ',0),(154100,'node',' 1371567429   ',0),(154101,'node',' 1371567429   ',0),(154097,'node',' 1371567429   ',0),(154099,'node',' 1371567429   ',0),(154095,'node',' 1371567428 1720  ',0),(154103,'node',' 1371567429   ',0),(154094,'node',' 1371567428 1606  ',0),(154105,'node',' 1371567429   ',0),(154092,'node',' 1371567428 1523  ',0),(154093,'node',' 1371567428 1632  ',0),(154091,'node',' 1371567428 1634  ',0),(154090,'node',' 1371567428 1424  ',0),(154107,'node',' 1371567430   ',0),(154089,'node',' 1371567428 1666  ',0),(154086,'node',' 1371567427 1513  ',0),(154088,'node',' 1371567428 1653  ',0),(154085,'node',' 1371567427 1643  ',0),(154084,'node',' 1371567427 1675  ',0),(154083,'node',' 1371567427 1533  ',0),(154081,'node',' 1371567427 1692  ',0),(154082,'node',' 1371567427 1626  ',0),(154080,'node',' 1371567427 1642  ',0),(154079,'node',' 1371567427 1554  ',0),(154076,'node',' 1371567424   ',0),(154077,'node',' 1371567424   ',0),(154075,'node',' 1371567424   ',0),(154074,'node',' 1371567424   ',0),(154072,'node',' 1371567424   ',0),(154073,'node',' 1371567424   ',0),(154071,'node',' 1371567424   ',0),(154069,'node',' 1371567424   ',0),(154070,'node',' 1371567424   ',0),(154068,'node',' 1371567424   ',0),(154067,'node',' 1371567424   ',0),(154065,'node',' 1371567424   ',0),(154066,'node',' 1371567424   ',0),(154064,'node',' 1371567424   ',0),(154063,'node',' 1371567424   ',0),(154061,'node',' 1371567424   ',0),(154062,'node',' 1371567424   ',0),(154060,'node',' 1371567424   ',0),(154059,'node',' 1371567424   ',0),(154057,'node',' 1371567424   ',0),(154058,'node',' 1371567424   ',0),(154056,'node',' 1371567424   ',0),(154055,'node',' 1371567424   ',0),(154053,'node',' 1371567424   ',0),(154054,'node',' 1371567424   ',0),(154052,'node',' 1371567424   ',0),(154050,'node',' 1371567424   ',0),(154051,'node',' 1371567424   ',0),(154048,'node',' 1371567424   ',0),(154049,'node',' 1371567424   ',0),(154047,'node',' 1371567424   ',0),(154143,'node',' 1371567483   ',0),(154142,'node',' 1371567483   ',0),(154140,'node',' 1371567483   ',0),(154141,'node',' 1371567483   ',0),(154205,'node',' 1371567543   ',0),(154203,'node',' 1371567543   ',0),(154204,'node',' 1371567543   ',0),(154202,'node',' 1371567543   ',0),(154201,'node',' 1371567543   ',0),(154198,'node',' 1371567490   ',0),(154194,'node',' 1371567489   ',0),(154196,'node',' 1371567489   ',0),(154192,'node',' 1371567489   ',0),(154191,'node',' 1371567489   ',0),(154188,'node',' 1371567488   ',0),(154190,'node',' 1371567489   ',0),(154186,'node',' 1371567488 1573  ',0),(154185,'node',' 1371567488 1558  ',0),(154184,'node',' 1371567488 1550  ',0),(154182,'node',' 1371567488 1634  ',0),(154183,'node',' 1371567488 1549  ',0),(154181,'node',' 1371567488 1610  ',0),(154180,'node',' 1371567488 1515  ',0),(154179,'node',' 1371567488 1692  ',0),(154176,'node',' 1371567487 1654  ',0),(154177,'node',' 1371567487 1573  ',0),(154175,'node',' 1371567487 1747  ',0),(154174,'node',' 1371567487 1420  ',0),(154172,'node',' 1371567487 1686  ',0),(154173,'node',' 1371567487 1537  ',0),(154171,'node',' 1371567487 1643  ',0),(154170,'node',' 1371567487 1648  ',0),(154168,'node',' 1371567483   ',0),(154166,'node',' 1371567483   ',0),(154167,'node',' 1371567483   ',0),(154165,'node',' 1371567483   ',0),(154164,'node',' 1371567483   ',0),(154152,'node',' 1371567483   ',0),(154153,'node',' 1371567483   ',0),(154150,'node',' 1371567483   ',0),(154151,'node',' 1371567483   ',0),(154149,'node',' 1371567483   ',0),(154154,'node',' 1371567483   ',0),(154147,'node',' 1371567483   ',0),(154148,'node',' 1371567483   ',0),(154146,'node',' 1371567483   ',0),(154155,'node',' 1371567483   ',0),(154144,'node',' 1371567483   ',0),(154145,'node',' 1371567483   ',0),(154156,'node',' 1371567483   ',0),(154157,'node',' 1371567483   ',0),(154158,'node',' 1371567483   ',0),(154159,'node',' 1371567483   ',0),(154160,'node',' 1371567483   ',0),(154161,'node',' 1371567483   ',0),(154162,'node',' 1371567483   ',0),(154163,'node',' 1371567483   ',0),(154229,'node',' 1371567543   ',0),(154228,'node',' 1371567543   ',0),(154227,'node',' 1371567543   ',0),(154225,'node',' 1371567543   ',0),(154226,'node',' 1371567543   ',0),(154224,'node',' 1371567543   ',0),(154219,'node',' 1371567543   ',0),(154220,'node',' 1371567543   ',0),(154221,'node',' 1371567543   ',0),(154217,'node',' 1371567543   ',0),(154218,'node',' 1371567543   ',0),(154222,'node',' 1371567543   ',0),(154216,'node',' 1371567543   ',0),(154223,'node',' 1371567543   ',0),(154245,'node',' 1371567543   ',0),(154246,'node',' 1371567543   ',0),(154244,'node',' 1371567543   ',0),(154243,'node',' 1371567543   ',0),(154241,'node',' 1371567543   ',0),(154242,'node',' 1371567543   ',0),(154240,'node',' 1371567543   ',0),(154239,'node',' 1371567543   ',0),(154237,'node',' 1371567543   ',0),(154238,'node',' 1371567543   ',0),(154236,'node',' 1371567543   ',0),(154235,'node',' 1371567543   ',0),(154233,'node',' 1371567543   ',0),(154234,'node',' 1371567543   ',0),(154232,'node',' 1371567543   ',0),(154230,'node',' 1371567543   ',0),(154231,'node',' 1371567543   ',0),(154249,'node',' 1371567543   ',0),(154250,'node',' 1371567543   ',0),(154248,'node',' 1371567543   ',0),(154247,'node',' 1371567543   ',0),(154252,'node',' 1371567543   ',0),(154251,'node',' 1371567543   ',0),(154317,'node',' 1371567604   ',0),(154318,'node',' 1371567604   ',0),(154316,'node',' 1371567604   ',0),(154314,'node',' 1371567604   ',0),(154315,'node',' 1371567604   ',0),(154313,'node',' 1371567604   ',0),(154312,'node',' 1371567604   ',0),(154310,'node',' 1371567604   ',0),(154311,'node',' 1371567604   ',0),(154309,'node',' 1371567604   ',0),(154308,'node',' 1371567604   ',0),(154306,'node',' 1371567604   ',0),(154307,'node',' 1371567604   ',0),(154305,'node',' 1371567604   ',0),(154304,'node',' 1371567604   ',0),(154302,'node',' 1371567604   ',0),(154303,'node',' 1371567604   ',0),(154301,'node',' 1371567604   ',0),(154299,'node',' 1371567604   ',0),(154300,'node',' 1371567604   ',0),(154298,'node',' 1371567604   ',0),(154296,'node',' 1371567604   ',0),(154297,'node',' 1371567604   ',0),(154295,'node',' 1371567604   ',0),(154294,'node',' 1371567604   ',0),(154292,'node',' 1371567604   ',0),(154293,'node',' 1371567604   ',0),(154289,'node',' 1371567550   ',0),(154283,'node',' 1371567549   ',0),(154285,'node',' 1371567549   ',0),(154282,'node',' 1371567549   ',0),(154287,'node',' 1371567549   ',0),(154281,'node',' 1371567549   ',0),(154277,'node',' 1371567548 1610  ',0),(154279,'node',' 1371567549   ',0),(154276,'node',' 1371567548 1601  ',0),(154275,'node',' 1371567548 1569  ',0),(154273,'node',' 1371567548 1614  ',0),(154274,'node',' 1371567548 1647  ',0),(154272,'node',' 1371567548 1660  ',0),(154270,'node',' 1371567548 1560  ',0),(154271,'node',' 1371567548 1576  ',0),(154268,'node',' 1371567547 1692  ',0),(154266,'node',' 1371567547 1637  ',0),(154267,'node',' 1371567547 1612  ',0),(154265,'node',' 1371567547 1753  ',0),(154263,'node',' 1371567547 1608  ',0),(154264,'node',' 1371567547 1533  ',0),(154262,'node',' 1371567547 1624  ',0),(154261,'node',' 1371567547 1722  ',0),(154258,'node',' 1371567543   ',0),(154259,'node',' 1371567543   ',0),(154257,'node',' 1371567543   ',0),(154255,'node',' 1371567543   ',0),(154256,'node',' 1371567543   ',0),(154253,'node',' 1371567543   ',0),(154254,'node',' 1371567543   ',0),(154342,'node',' 1371567604   ',0),(154343,'node',' 1371567604   ',0),(154341,'node',' 1371567604   ',0),(154336,'node',' 1371567604   ',0),(154337,'node',' 1371567604   ',0),(154338,'node',' 1371567604   ',0),(154334,'node',' 1371567604   ',0),(154335,'node',' 1371567604   ',0),(154339,'node',' 1371567604   ',0),(154333,'node',' 1371567604   ',0),(154340,'node',' 1371567604   ',0),(154331,'node',' 1371567604   ',0),(154332,'node',' 1371567604   ',0),(154330,'node',' 1371567604   ',0),(154329,'node',' 1371567604   ',0),(154354,'node',' 1371567607 1586  ',0),(154355,'node',' 1371567607 1594  ',0),(154353,'node',' 1371567607 1618  ',0),(154352,'node',' 1371567607 1578  ',0),(154349,'node',' 1371567604   ',0),(154350,'node',' 1371567604   ',0),(154348,'node',' 1371567604   ',0),(154346,'node',' 1371567604   ',0),(154347,'node',' 1371567604   ',0),(154345,'node',' 1371567604   ',0),(154344,'node',' 1371567604   ',0),(154362,'node',' 1371567608 1670  ',0),(154361,'node',' 1371567608 1608  ',0),(154358,'node',' 1371567607 1589  ',0),(154359,'node',' 1371567607 1668  ',0),(154357,'node',' 1371567607 1641  ',0),(154356,'node',' 1371567607 1647  ',0),(154363,'node',' 1371567608 1606  ',0),(154364,'node',' 1371567608 1508  ',0),(154365,'node',' 1371567608 1694  ',0),(154366,'node',' 1371567608 1700  ',0),(154367,'node',' 1371567608 1621  ',0),(154368,'node',' 1371567608 1544  ',0),(154370,'node',' 1371567609   ',0),(154372,'node',' 1371567609   ',0),(154373,'node',' 1371567609   ',0),(154374,'node',' 1371567609   ',0),(154376,'node',' 1371567609   ',0),(154378,'node',' 1371567609   ',0),(154380,'node',' 1371567610   ',0),(154383,'node',' 1371567664   ',0),(154384,'node',' 1371567664   ',0),(154385,'node',' 1371567664   ',0),(154386,'node',' 1371567664   ',0),(154387,'node',' 1371567664   ',0),(154388,'node',' 1371567664   ',0),(154389,'node',' 1371567664   ',0),(154390,'node',' 1371567664   ',0),(154391,'node',' 1371567664   ',0),(154392,'node',' 1371567664   ',0),(154393,'node',' 1371567664   ',0),(154394,'node',' 1371567664   ',0),(154395,'node',' 1371567664   ',0),(154396,'node',' 1371567664   ',0),(154397,'node',' 1371567664   ',0),(154398,'node',' 1371567664   ',0),(154399,'node',' 1371567664   ',0),(154400,'node',' 1371567664   ',0),(154401,'node',' 1371567664   ',0),(154402,'node',' 1371567664   ',0),(154403,'node',' 1371567664   ',0),(154404,'node',' 1371567664   ',0),(154405,'node',' 1371567664   ',0),(154406,'node',' 1371567664   ',0),(154407,'node',' 1371567664   ',0),(154408,'node',' 1371567664   ',0),(154409,'node',' 1371567664   ',0),(154410,'node',' 1371567664   ',0),(154411,'node',' 1371567664   ',0),(154412,'node',' 1371567664   ',0),(154421,'node',' 1371567664   ',0),(154422,'node',' 1371567664   ',0),(154423,'node',' 1371567664   ',0),(154424,'node',' 1371567664   ',0),(154425,'node',' 1371567664   ',0),(154426,'node',' 1371567664   ',0),(154427,'node',' 1371567664   ',0),(154428,'node',' 1371567664   ',0),(154429,'node',' 1371567664   ',0),(154430,'node',' 1371567664   ',0),(154431,'node',' 1371567664   ',0),(154432,'node',' 1371567664   ',0),(154433,'node',' 1371567664   ',0),(154434,'node',' 1371567664   ',0),(154435,'node',' 1371567664   ',0),(154436,'node',' 1371567664   ',0),(154437,'node',' 1371567664   ',0),(154461,'node',' 1371567669   ',0),(154438,'node',' 1371567664   ',0),(154439,'node',' 1371567664   ',0),(154459,'node',' 1371567668 1556  ',0),(154440,'node',' 1371567664   ',0),(154457,'node',' 1371567668 1580  ',0),(154458,'node',' 1371567668 1614  ',0),(154441,'node',' 1371567664   ',0),(154454,'node',' 1371567668 1588  ',0),(154443,'node',' 1371567667 1621  ',0),(154444,'node',' 1371567667 1753  ',0),(154445,'node',' 1371567667 1623  ',0),(154446,'node',' 1371567667 1663  ',0),(154453,'node',' 1371567668 1678  ',0),(154447,'node',' 1371567667 1591  ',0),(154448,'node',' 1371567667 1627  ',0),(154449,'node',' 1371567667 1619  ',0),(154450,'node',' 1371567667 1798  ',0),(154452,'node',' 1371567668 1711  ',0),(154455,'node',' 1371567668 1517  ',0),(154456,'node',' 1371567668 1618  ',0),(154465,'node',' 1371567669   ',0),(154467,'node',' 1371567669   ',0),(154469,'node',' 1371567669   ',0),(154471,'node',' 1371567670   ',0),(154474,'node',' 1371567723   ',0),(154475,'node',' 1371567723   ',0),(154476,'node',' 1371567723   ',0),(154477,'node',' 1371567723   ',0),(154478,'node',' 1371567723   ',0),(154479,'node',' 1371567723   ',0),(141364,'node',' hgw2k8r232vm18 ',0),(141367,'node',' hgw2k8r232vm21 ',0),(154480,'node',' 1371567723   ',0),(154481,'node',' 1371567723   ',0),(154482,'node',' 1371567723   ',0),(154483,'node',' 1371567723   ',0),(154484,'node',' 1371567723   ',0),(154485,'node',' 1371567723   ',0),(154486,'node',' 1371567723   ',0),(154487,'node',' 1371567723   ',0),(154488,'node',' 1371567723   ',0),(154489,'node',' 1371567723   ',0),(154490,'node',' 1371567723   ',0),(154491,'node',' 1371567723   ',0),(154492,'node',' 1371567723   ',0),(154493,'node',' 1371567723   ',0),(154494,'node',' 1371567723   ',0),(154495,'node',' 1371567723   ',0),(154496,'node',' 1371567723   ',0),(154497,'node',' 1371567723   ',0),(154498,'node',' 1371567723   ',0),(154499,'node',' 1371567723   ',0),(154500,'node',' 1371567723   ',0),(154501,'node',' 1371567723   ',0),(154502,'node',' 1371567723   ',0),(154503,'node',' 1371567723   ',0),(154504,'node',' 1371567723   ',0),(154505,'node',' 1371567723   ',0),(154506,'node',' 1371567723   ',0),(154507,'node',' 1371567723   ',0),(154508,'node',' 1371567723   ',0),(154509,'node',' 1371567723   ',0),(154510,'node',' 1371567723   ',0),(154511,'node',' 1371567723   ',0),(154552,'node',' 1371567728   ',0),(154512,'node',' 1371567723   ',0),(154513,'node',' 1371567723   ',0),(154514,'node',' 1371567723   ',0),(154550,'node',' 1371567728 1527  ',0),(154515,'node',' 1371567723   ',0),(154516,'node',' 1371567723   ',0),(154517,'node',' 1371567723   ',0),(154518,'node',' 1371567723   ',0),(154519,'node',' 1371567723   ',0),(154520,'node',' 1371567723   ',0),(154521,'node',' 1371567723   ',0),(154522,'node',' 1371567723   ',0),(154523,'node',' 1371567723   ',0),(154524,'node',' 1371567723   ',0),(154525,'node',' 1371567723   ',0),(154526,'node',' 1371567723   ',0),(154527,'node',' 1371567723   ',0),(154528,'node',' 1371567723   ',0),(154529,'node',' 1371567723   ',0),(154530,'node',' 1371567723   ',0),(154531,'node',' 1371567723   ',0),(154549,'node',' 1371567728 1535  ',0),(154532,'node',' 1371567723   ',0),(154534,'node',' 1371567727 1695  ',0),(154548,'node',' 1371567728 1760  ',0),(154535,'node',' 1371567727 1737  ',0),(154546,'node',' 1371567728 1492  ',0),(154547,'node',' 1371567728 1605  ',0),(154536,'node',' 1371567727 1584  ',0),(154537,'node',' 1371567727 1564  ',0),(154545,'node',' 1371567728 1538  ',0),(154544,'node',' 1371567728 1630  ',0),(154538,'node',' 1371567727 1536  ',0),(154543,'node',' 1371567728 1580  ',0),(154539,'node',' 1371567727 1680  ',0),(154540,'node',' 1371567727 1574  ',0),(154541,'node',' 1371567727 1534  ',0),(154554,'node',' 1371567729   ',0),(154555,'node',' 1371567729   ',0),(154556,'node',' 1371567729   ',0),(154558,'node',' 1371567729   ',0),(154560,'node',' 1371567729   ',0),(154562,'node',' 1371567729   ',0),(154565,'node',' 1371567783   ',0),(154566,'node',' 1371567783   ',0),(154575,'node',' 1371567783   ',0),(154576,'node',' 1371567783   ',0),(154577,'node',' 1371567783   ',0),(154578,'node',' 1371567783   ',0),(154579,'node',' 1371567783   ',0),(154580,'node',' 1371567783   ',0),(154581,'node',' 1371567783   ',0),(154582,'node',' 1371567783   ',0),(154583,'node',' 1371567783   ',0),(154584,'node',' 1371567783   ',0),(154585,'node',' 1371567783   ',0),(154586,'node',' 1371567783   ',0),(154587,'node',' 1371567783   ',0),(154588,'node',' 1371567783   ',0),(154608,'node',' 1371567783   ',0),(154609,'node',' 1371567783   ',0),(154610,'node',' 1371567783   ',0),(154611,'node',' 1371567783   ',0),(154612,'node',' 1371567783   ',0),(154613,'node',' 1371567783   ',0),(154614,'node',' 1371567783   ',0),(154615,'node',' 1371567783   ',0),(154616,'node',' 1371567783   ',0),(154617,'node',' 1371567783   ',0),(154618,'node',' 1371567783   ',0),(154619,'node',' 1371567783   ',0),(154620,'node',' 1371567783   ',0),(154621,'node',' 1371567783   ',0),(154622,'node',' 1371567783   ',0),(154623,'node',' 1371567783   ',0),(154625,'node',' 1371567786 1543  ',0),(154626,'node',' 1371567786 1642  ',0),(154627,'node',' 1371567786 1612  ',0),(154628,'node',' 1371567786 1654  ',0),(154629,'node',' 1371567786 1621  ',0),(154630,'node',' 1371567786 1592  ',0),(154631,'node',' 1371567786 1633  ',0),(154632,'node',' 1371567786 1597  ',0),(154634,'node',' 1371567787 1663  ',0),(154635,'node',' 1371567787 1475  ',0),(154636,'node',' 1371567787 1650  ',0),(154638,'node',' 1371567787 1592  ',0),(154639,'node',' 1371567787 1612  ',0),(154640,'node',' 1371567787 1637  ',0),(154641,'node',' 1371567787 1635  ',0),(154643,'node',' 1371567788   ',0),(154660,'node',' 1371567844   ',0),(154645,'node',' 1371567788   ',0),(154659,'node',' 1371567844   ',0),(154646,'node',' 1371567788   ',0),(154647,'node',' 1371567788   ',0),(154649,'node',' 1371567788   ',0),(154656,'node',' 1371567844   ',0),(154651,'node',' 1371567789   ',0),(154653,'node',' 1371567789   ',0),(154657,'node',' 1371567844   ',0),(154658,'node',' 1371567844   ',0),(154661,'node',' 1371567844   ',0),(154662,'node',' 1371567844   ',0),(154663,'node',' 1371567844   ',0),(154664,'node',' 1371567844   ',0),(154665,'node',' 1371567844   ',0),(154666,'node',' 1371567844   ',0),(154667,'node',' 1371567844   ',0),(154668,'node',' 1371567844   ',0),(154669,'node',' 1371567844   ',0),(154670,'node',' 1371567844   ',0),(154671,'node',' 1371567844   ',0),(154672,'node',' 1371567844   ',0),(154673,'node',' 1371567844   ',0),(154674,'node',' 1371567844   ',0),(154675,'node',' 1371567844   ',0),(154676,'node',' 1371567844   ',0),(154677,'node',' 1371567844   ',0),(154678,'node',' 1371567844   ',0),(154679,'node',' 1371567844   ',0),(154680,'node',' 1371567844   ',0),(154681,'node',' 1371567844   ',0),(154682,'node',' 1371567844   ',0),(154683,'node',' 1371567844   ',0),(154684,'node',' 1371567844   ',0),(154685,'node',' 1371567844   ',0),(154686,'node',' 1371567844   ',0),(154687,'node',' 1371567844   ',0),(154688,'node',' 1371567844   ',0),(154689,'node',' 1371567844   ',0),(154690,'node',' 1371567844   ',0),(154691,'node',' 1371567844   ',0),(154692,'node',' 1371567844   ',0),(154693,'node',' 1371567844   ',0),(154694,'node',' 1371567844   ',0),(154695,'node',' 1371567844   ',0),(154696,'node',' 1371567844   ',0),(154697,'node',' 1371567844   ',0),(164850,'node',' 1371574564   ',0),(164852,'node',' 1371574564   ',0),(164853,'node',' 1371574564   ',0),(164854,'node',' 1371574564   ',0),(164855,'node',' 1371574564   ',0),(164856,'node',' 1371574564   ',0),(164857,'node',' 1371574564   ',0),(164858,'node',' 1371574564   ',0),(164859,'node',' 1371574564   ',0),(164860,'node',' 1371574564   ',0),(164861,'node',' 1371574564   ',0),(164862,'node',' 1371574564   ',0),(164863,'node',' 1371574564   ',0),(164864,'node',' 1371574564   ',0),(164865,'node',' 1371574564   ',0),(164866,'node',' 1371574564   ',0),(164867,'node',' 1371574564   ',0),(164868,'node',' 1371574564   ',0),(164869,'node',' 1371574564   ',0),(164870,'node',' 1371574564   ',0),(164871,'node',' 1371574564   ',0),(164872,'node',' 1371574564   ',0),(164873,'node',' 1371574564   ',0),(164874,'node',' 1371574564   ',0),(164875,'node',' 1371574564   ',0),(164876,'node',' 1371574564   ',0),(164877,'node',' 1371574564   ',0),(164878,'node',' 1371574564   ',0),(164879,'node',' 1371574564   ',0),(164880,'node',' 1371574564   ',0),(164881,'node',' 1371574564   ',0),(164882,'node',' 1371574564   ',0),(164883,'node',' 1371574564   ',0),(164884,'node',' 1371574564   ',0),(164885,'node',' 1371574564   ',0),(164886,'node',' 1371574564   ',0),(164887,'node',' 1371574564   ',0),(164888,'node',' 1371574564   ',0),(164889,'node',' 1371574564   ',0),(164890,'node',' 1371574564   ',0),(164899,'node',' 1371574564   ',0),(164891,'node',' 1371574564   ',0),(164898,'node',' 1371574564   ',0),(164892,'node',' 1371574564   ',0),(164897,'node',' 1371574564   ',0),(164893,'node',' 1371574564   ',0),(164894,'node',' 1371574564   ',0),(164895,'node',' 1371574564   ',0),(164896,'node',' 1371574564   ',0),(164900,'node',' 1371574564   ',0),(164901,'node',' 1371574564   ',0),(164902,'node',' 1371574564   ',0),(164903,'node',' 1371574564   ',0),(164904,'node',' 1371574564   ',0),(164905,'node',' 1371574564   ',0),(164906,'node',' 1371574564   ',0),(164908,'node',' 1371574567 1418  ',0),(164909,'node',' 1371574567 1442  ',0),(164910,'node',' 1371574567 1571  ',0),(164911,'node',' 1371574567 1297  ',0),(164912,'node',' 1371574567 1377  ',0),(164913,'node',' 1371574567 1277  ',0),(164914,'node',' 1371574567 1328  ',0),(164915,'node',' 1371574567 1161  ',0),(164917,'node',' 1371574568 1341  ',0),(164918,'node',' 1371574568 1354  ',0),(164919,'node',' 1371574568 1210  ',0),(164920,'node',' 1371574568 1249  ',0),(164921,'node',' 1371574568 1415  ',0),(164922,'node',' 1371574568 1301  ',0),(164923,'node',' 1371574568 1241  ',0),(164924,'node',' 1371574568 1385  ',0),(164944,'node',' 1371574623   ',0),(164945,'node',' 1371574623   ',0),(164946,'node',' 1371574623   ',0),(164947,'node',' 1371574623   ',0),(164948,'node',' 1371574623   ',0),(164949,'node',' 1371574623   ',0),(164950,'node',' 1371574623   ',0),(164951,'node',' 1371574623   ',0),(164958,'node',' 1371574623   ',0),(164952,'node',' 1371574623   ',0),(164953,'node',' 1371574623   ',0),(164954,'node',' 1371574623   ',0),(164955,'node',' 1371574623   ',0),(164956,'node',' 1371574623   ',0),(164957,'node',' 1371574623   ',0),(164959,'node',' 1371574623   ',0),(164960,'node',' 1371574623   ',0),(164965,'node',' 1371574623   ',0),(164966,'node',' 1371574623   ',0),(164963,'node',' 1371574623   ',0),(164964,'node',' 1371574623   ',0),(164961,'node',' 1371574623   ',0),(164962,'node',' 1371574623   ',0),(164967,'node',' 1371574623   ',0),(165036,'node',' 1371574683   ',0),(164968,'node',' 1371574623   ',0),(165031,'node',' 1371574683   ',0),(164969,'node',' 1371574623   ',0),(164970,'node',' 1371574623   ',0),(164971,'node',' 1371574623   ',0),(165030,'node',' 1371574683   ',0),(164972,'node',' 1371574623   ',0),(165027,'node',' 1371574629   ',0),(164973,'node',' 1371574623   ',0),(164974,'node',' 1371574623   ',0),(164975,'node',' 1371574623   ',0),(165025,'node',' 1371574629   ',0),(164976,'node',' 1371574623   ',0),(165023,'node',' 1371574629   ',0),(164977,'node',' 1371574623   ',0),(165021,'node',' 1371574628   ',0),(164978,'node',' 1371574623   ',0),(164979,'node',' 1371574623   ',0),(164980,'node',' 1371574623   ',0),(165020,'node',' 1371574628   ',0),(164981,'node',' 1371574623   ',0),(165019,'node',' 1371574628   ',0),(164982,'node',' 1371574623   ',0),(164983,'node',' 1371574623   ',0),(164984,'node',' 1371574623   ',0),(165017,'node',' 1371574628   ',0),(164985,'node',' 1371574623   ',0),(164986,'node',' 1371574623   ',0),(164987,'node',' 1371574623   ',0),(164988,'node',' 1371574623   ',0),(164989,'node',' 1371574623   ',0),(164990,'node',' 1371574623   ',0),(164991,'node',' 1371574623   ',0),(165011,'node',' 1371574628 1274  ',0),(164992,'node',' 1371574623   ',0),(164993,'node',' 1371574623   ',0),(164994,'node',' 1371574623   ',0),(164995,'node',' 1371574623   ',0),(165005,'node',' 1371574627 1361  ',0),(164996,'node',' 1371574623   ',0),(164997,'node',' 1371574623   ',0),(165000,'node',' 1371574627 1358  ',0),(164999,'node',' 1371574627 1397  ',0),(165001,'node',' 1371574627 1323  ',0),(165002,'node',' 1371574627 1453  ',0),(165003,'node',' 1371574627 1334  ',0),(165004,'node',' 1371574627 1416  ',0),(165006,'node',' 1371574627 1393  ',0),(165008,'node',' 1371574628 1355  ',0),(165009,'node',' 1371574628 1227  ',0),(165010,'node',' 1371574628 1334  ',0),(165012,'node',' 1371574628 1324  ',0),(165013,'node',' 1371574628 1350  ',0),(165042,'node',' 1371574683   ',0),(165043,'node',' 1371574683   ',0),(165044,'node',' 1371574683   ',0),(165045,'node',' 1371574683   ',0),(165046,'node',' 1371574683   ',0),(165047,'node',' 1371574683   ',0),(165048,'node',' 1371574683   ',0),(165049,'node',' 1371574683   ',0),(165050,'node',' 1371574683   ',0),(165051,'node',' 1371574683   ',0),(165052,'node',' 1371574683   ',0),(165053,'node',' 1371574683   ',0),(165054,'node',' 1371574683   ',0),(165055,'node',' 1371574683   ',0),(165056,'node',' 1371574683   ',0),(165057,'node',' 1371574683   ',0),(165058,'node',' 1371574683   ',0),(165059,'node',' 1371574683   ',0),(165060,'node',' 1371574683   ',0),(165061,'node',' 1371574683   ',0),(165062,'node',' 1371574683   ',0),(165063,'node',' 1371574683   ',0),(165064,'node',' 1371574683   ',0),(165065,'node',' 1371574683   ',0),(165066,'node',' 1371574683   ',0),(165067,'node',' 1371574683   ',0),(165068,'node',' 1371574683   ',0),(165069,'node',' 1371574683   ',0),(165070,'node',' 1371574683   ',0),(165071,'node',' 1371574683   ',0),(165072,'node',' 1371574683   ',0),(165073,'node',' 1371574683   ',0),(165074,'node',' 1371574683   ',0),(165075,'node',' 1371574683   ',0),(165076,'node',' 1371574683   ',0),(165077,'node',' 1371574683   ',0),(165078,'node',' 1371574683   ',0),(165079,'node',' 1371574683   ',0),(165080,'node',' 1371574683   ',0),(165081,'node',' 1371574683   ',0),(165082,'node',' 1371574683   ',0),(165083,'node',' 1371574683   ',0),(165084,'node',' 1371574683   ',0),(165085,'node',' 1371574683   ',0),(165086,'node',' 1371574683   ',0),(165087,'node',' 1371574683   ',0),(165088,'node',' 1371574683   ',0),(165091,'node',' 1371574687 1365  ',0),(165090,'node',' 1371574687 1518  ',0),(165092,'node',' 1371574687 1419  ',0),(165093,'node',' 1371574687 1495  ',0),(165094,'node',' 1371574687 1481  ',0),(165095,'node',' 1371574687 1376  ',0),(165096,'node',' 1371574687 1403  ',0),(165097,'node',' 1371574687 1337  ',0),(165099,'node',' 1371574688 1303  ',0),(165100,'node',' 1371574688 1325  ',0),(165101,'node',' 1371574688 1392  ',0),(165102,'node',' 1371574688 1322  ',0),(165103,'node',' 1371574688 1276  ',0),(165104,'node',' 1371574688 1351  ',0),(165105,'node',' 1371574688 1373  ',0),(165106,'node',' 1371574688 1353  ',0),(165108,'node',' 1371574688   ',0),(165110,'node',' 1371574689   ',0),(165111,'node',' 1371574689   ',0),(165112,'node',' 1371574689   ',0),(165114,'node',' 1371574689   ',0),(165116,'node',' 1371574689   ',0),(165118,'node',' 1371574690   ',0),(165121,'node',' 1371574743   ',0),(165122,'node',' 1371574743   ',0),(165123,'node',' 1371574743   ',0),(165124,'node',' 1371574743   ',0),(165125,'node',' 1371574743   ',0),(165126,'node',' 1371574743   ',0),(165127,'node',' 1371574743   ',0),(165128,'node',' 1371574743   ',0),(165129,'node',' 1371574743   ',0),(165130,'node',' 1371574743   ',0),(165131,'node',' 1371574743   ',0),(165132,'node',' 1371574743   ',0),(165133,'node',' 1371574743   ',0),(165134,'node',' 1371574743   ',0),(165135,'node',' 1371574743   ',0),(165136,'node',' 1371574743   ',0),(165137,'node',' 1371574743   ',0),(165138,'node',' 1371574743   ',0),(165139,'node',' 1371574743   ',0),(165140,'node',' 1371574743   ',0),(165141,'node',' 1371574743   ',0),(165142,'node',' 1371574743   ',0),(165143,'node',' 1371574743   ',0),(165144,'node',' 1371574743   ',0),(165145,'node',' 1371574743   ',0),(165146,'node',' 1371574743   ',0),(165147,'node',' 1371574743   ',0),(165148,'node',' 1371574743   ',0),(165149,'node',' 1371574743   ',0),(165150,'node',' 1371574743   ',0),(165151,'node',' 1371574743   ',0),(165152,'node',' 1371574743   ',0),(165153,'node',' 1371574743   ',0),(165154,'node',' 1371574743   ',0),(165155,'node',' 1371574743   ',0),(165161,'node',' 1371574743   ',0),(165156,'node',' 1371574743   ',0),(165159,'node',' 1371574743   ',0),(165160,'node',' 1371574743   ',0),(165157,'node',' 1371574743   ',0),(165158,'node',' 1371574743   ',0),(165162,'node',' 1371574743   ',0),(165163,'node',' 1371574743   ',0),(165164,'node',' 1371574743   ',0),(165165,'node',' 1371574743   ',0),(165166,'node',' 1371574743   ',0),(165167,'node',' 1371574743   ',0),(165168,'node',' 1371574743   ',0),(165169,'node',' 1371574743   ',0),(165170,'node',' 1371574743   ',0),(165171,'node',' 1371574743   ',0),(165172,'node',' 1371574743   ',0),(165173,'node',' 1371574743   ',0),(165174,'node',' 1371574743   ',0),(165175,'node',' 1371574743   ',0),(165176,'node',' 1371574743   ',0),(165177,'node',' 1371574743   ',0),(165178,'node',' 1371574743   ',0),(165179,'node',' 1371574743   ',0),(165181,'node',' 1371574747 1518  ',0),(165182,'node',' 1371574747 1430  ',0),(165183,'node',' 1371574747 1366  ',0),(165184,'node',' 1371574747 1500  ',0),(165185,'node',' 1371574747 1401  ',0),(165186,'node',' 1371574747 1395  ',0),(165187,'node',' 1371574747 1500  ',0),(165188,'node',' 1371574747 1411  ',0),(165190,'node',' 1371574748 1275  ',0),(165191,'node',' 1371574748 1346  ',0),(165192,'node',' 1371574748 1377  ',0),(165193,'node',' 1371574748 1361  ',0),(165194,'node',' 1371574748 1366  ',0),(165199,'node',' 1371574748   ',0),(165195,'node',' 1371574748 1297  ',0),(165196,'node',' 1371574748 1309  ',0),(165197,'node',' 1371574748 1246  ',0),(165201,'node',' 1371574748   ',0),(165202,'node',' 1371574748   ',0),(165203,'node',' 1371574748   ',0),(165205,'node',' 1371574749   ',0),(165207,'node',' 1371574749   ',0),(165209,'node',' 1371574749   ',0),(165212,'node',' 1371574803   ',0),(165213,'node',' 1371574803   ',0),(165214,'node',' 1371574803   ',0),(165223,'node',' 1371574803   ',0),(165221,'node',' 1371574803   ',0),(165222,'node',' 1371574803   ',0),(165220,'node',' 1371574803   ',0),(165218,'node',' 1371574803   ',0),(165219,'node',' 1371574803   ',0),(165215,'node',' 1371574803   ',0),(165216,'node',' 1371574803   ',0),(165217,'node',' 1371574803   ',0),(165227,'node',' 1371574803   ',0),(165228,'node',' 1371574803   ',0),(165229,'node',' 1371574803   ',0),(165230,'node',' 1371574803   ',0),(165231,'node',' 1371574803   ',0),(165232,'node',' 1371574803   ',0),(165233,'node',' 1371574803   ',0),(165234,'node',' 1371574803   ',0),(165235,'node',' 1371574803   ',0),(165236,'node',' 1371574803   ',0),(165237,'node',' 1371574803   ',0),(165238,'node',' 1371574803   ',0),(165239,'node',' 1371574803   ',0),(165240,'node',' 1371574803   ',0),(165241,'node',' 1371574803   ',0),(165242,'node',' 1371574803   ',0),(165243,'node',' 1371574803   ',0),(165244,'node',' 1371574803   ',0),(165245,'node',' 1371574803   ',0),(165246,'node',' 1371574803   ',0),(165247,'node',' 1371574803   ',0),(165256,'node',' 1371574803   ',0),(165253,'node',' 1371574803   ',0),(165254,'node',' 1371574803   ',0),(165255,'node',' 1371574803   ',0),(165252,'node',' 1371574803   ',0),(165250,'node',' 1371574803   ',0),(165251,'node',' 1371574803   ',0),(165248,'node',' 1371574803   ',0),(165249,'node',' 1371574803   ',0),(165260,'node',' 1371574803   ',0),(165261,'node',' 1371574803   ',0),(165262,'node',' 1371574803   ',0),(165263,'node',' 1371574803   ',0),(165264,'node',' 1371574803   ',0),(165265,'node',' 1371574803   ',0),(165266,'node',' 1371574803   ',0),(165267,'node',' 1371574803   ',0),(165268,'node',' 1371574803   ',0),(165269,'node',' 1371574803   ',0),(165270,'node',' 1371574803   ',0),(165272,'node',' 1371574807 1419  ',0),(165273,'node',' 1371574807 1379  ',0),(165274,'node',' 1371574807 1506  ',0),(165275,'node',' 1371574807 1464  ',0),(165276,'node',' 1371574807 1407  ',0),(165277,'node',' 1371574807 1461  ',0),(165278,'node',' 1371574807 1570  ',0),(165279,'node',' 1371574807 1446  ',0),(165281,'node',' 1371574808 1379  ',0),(165282,'node',' 1371574808 1318  ',0),(165290,'node',' 1371574808   ',0),(165287,'node',' 1371574808 1340  ',0),(165288,'node',' 1371574808 1469  ',0),(165286,'node',' 1371574808 1383  ',0),(165283,'node',' 1371574808 1296  ',0),(165284,'node',' 1371574808 1413  ',0),(165285,'node',' 1371574808 1267  ',0),(164846,'node',' 1371574562   ',0),(164847,'node',' 1371574564   ',0),(164907,'node',' 1371574567 1363  ',0),(164916,'node',' 1371574568 1313  ',0),(164925,'node',' 1371574569   ',0),(164927,'node',' 1371574569   ',0),(164937,'node',' 1371574621   ',0),(164938,'node',' 1371574623   ',0),(164998,'node',' 1371574627 1380  ',0),(165007,'node',' 1371574628 1326  ',0),(165022,'node',' 1371574629   ',0),(165024,'node',' 1371574629   ',0),(165026,'node',' 1371574629   ',0),(165028,'node',' 1371574681   ',0),(165029,'node',' 1371574683   ',0),(165089,'node',' 1371574687 1426  ',0),(165098,'node',' 1371574688 1338  ',0),(165107,'node',' 1371574688   ',0),(165115,'node',' 1371574689   ',0),(165117,'node',' 1371574690   ',0),(165119,'node',' 1371574741   ',0),(165120,'node',' 1371574743   ',0),(165180,'node',' 1371574747 1441  ',0),(165189,'node',' 1371574748 1323  ',0),(165198,'node',' 1371574748   ',0),(165200,'node',' 1371574748   ',0),(165208,'node',' 1371574749   ',0),(165210,'node',' 1371574801   ',0),(165211,'node',' 1371574803   ',0),(165271,'node',' 1371574807 1457  ',0),(165280,'node',' 1371574808 1359  ',0),(165289,'node',' 1371574808   ',0),(165291,'node',' 1371574809   ',0),(165295,'node',' 1371574809   ',0),(165301,'node',' 1371574862   ',0),(165302,'node',' 1371574864   ',0),(165362,'node',' 1371574867 1422  ',0),(165371,'node',' 1371574869 1393  ',0),(165380,'node',' 1371574869   ',0),(165382,'node',' 1371574869   ',0),(165386,'node',' 1371574870   ',0),(165388,'node',' 1371574870   ',0),(165453,'node',' 1371574927 1474  ',0),(165462,'node',' 1371574928 1415  ',0),(165471,'node',' 1371574929   ',0),(165473,'node',' 1371574929   ',0),(165477,'node',' 1371574929   ',0),(165479,'node',' 1371574929   ',0),(165481,'node',' 1371574930   ',0),(165483,'node',' 1371574981   ',0),(165484,'node',' 1371574983   ',0),(165544,'node',' 1371574987 1460  ',0),(165568,'node',' 1371574989   ',0),(165570,'node',' 1371574990   ',0),(165572,'node',' 1371574990   ',0),(165574,'node',' 1371575041   ',0),(165575,'node',' 1371575044   ',0),(165635,'node',' 1371575047 1529  ',0),(165644,'node',' 1371575048 1463  ',0),(165659,'node',' 1371575050   ',0),(165661,'node',' 1371575050   ',0),(165663,'node',' 1371575050   ',0),(165665,'node',' 1371575101   ',0),(165666,'node',' 1371575104   ',0),(165726,'node',' 1371575107 1494  ',0),(165735,'node',' 1371575109 1505  ',0),(165744,'node',' 1371575109   ',0),(165752,'node',' 1371575110   ',0),(165754,'node',' 1371575110   ',0),(165756,'node',' 1371575162   ',0),(165757,'node',' 1371575164   ',0),(165817,'node',' 1371575168 1510  ',0),(165826,'node',' 1371575169 1465  ',0),(165835,'node',' 1371575169   ',0),(165837,'node',' 1371575169   ',0),(165845,'node',' 1371575170   ',0),(165847,'node',' 1371575222   ',0),(165848,'node',' 1371575223   ',0),(165908,'node',' 1371575227 1553  ',0),(165917,'node',' 1371575228 1494  ',0),(165292,'node',' 1371574809   ',0),(165293,'node',' 1371574809   ',0),(165294,'node',' 1371574809   ',0),(165296,'node',' 1371574809   ',0),(165298,'node',' 1371574809   ',0),(165300,'node',' 1371574809   ',0),(165303,'node',' 1371574864   ',0),(165304,'node',' 1371574864   ',0),(165305,'node',' 1371574864   ',0),(165306,'node',' 1371574864   ',0),(165307,'node',' 1371574864   ',0),(165308,'node',' 1371574864   ',0),(165309,'node',' 1371574864   ',0),(165310,'node',' 1371574864   ',0),(165311,'node',' 1371574864   ',0),(165312,'node',' 1371574864   ',0),(165313,'node',' 1371574864   ',0),(165314,'node',' 1371574864   ',0),(165315,'node',' 1371574864   ',0),(165316,'node',' 1371574864   ',0),(165317,'node',' 1371574864   ',0),(165318,'node',' 1371574864   ',0),(165319,'node',' 1371574864   ',0),(165320,'node',' 1371574864   ',0),(165321,'node',' 1371574864   ',0),(165322,'node',' 1371574864   ',0),(165323,'node',' 1371574864   ',0),(165324,'node',' 1371574864   ',0),(165331,'node',' 1371574864   ',0),(165325,'node',' 1371574864   ',0),(165326,'node',' 1371574864   ',0),(165327,'node',' 1371574864   ',0),(165330,'node',' 1371574864   ',0),(165328,'node',' 1371574864   ',0),(165329,'node',' 1371574864   ',0),(165332,'node',' 1371574864   ',0),(165333,'node',' 1371574864   ',0),(165334,'node',' 1371574864   ',0),(165335,'node',' 1371574864   ',0),(165336,'node',' 1371574864   ',0),(165337,'node',' 1371574864   ',0),(165338,'node',' 1371574864   ',0),(165339,'node',' 1371574864   ',0),(165340,'node',' 1371574864   ',0),(165341,'node',' 1371574864   ',0),(165342,'node',' 1371574864   ',0),(165343,'node',' 1371574864   ',0),(165344,'node',' 1371574864   ',0),(165345,'node',' 1371574864   ',0),(165346,'node',' 1371574864   ',0),(165347,'node',' 1371574864   ',0),(165348,'node',' 1371574864   ',0),(165349,'node',' 1371574864   ',0),(165350,'node',' 1371574864   ',0),(165351,'node',' 1371574864   ',0),(165352,'node',' 1371574864   ',0),(165353,'node',' 1371574864   ',0),(165354,'node',' 1371574864   ',0),(165355,'node',' 1371574864   ',0),(165356,'node',' 1371574864   ',0),(165357,'node',' 1371574864   ',0),(165358,'node',' 1371574864   ',0),(165359,'node',' 1371574864   ',0),(165360,'node',' 1371574864   ',0),(165361,'node',' 1371574864   ',0),(165363,'node',' 1371574867 1342  ',0),(165364,'node',' 1371574867 1443  ',0),(165365,'node',' 1371574867 1468  ',0),(165366,'node',' 1371574867 1385  ',0),(165367,'node',' 1371574867 1470  ',0),(165368,'node',' 1371574867 1500  ',0),(165369,'node',' 1371574867 1376  ',0),(165370,'node',' 1371574867 1385  ',0),(165372,'node',' 1371574869 1357  ',0),(165373,'node',' 1371574869 1445  ',0),(165374,'node',' 1371574869 1368  ',0),(165375,'node',' 1371574869 1383  ',0),(165376,'node',' 1371574869 1404  ',0),(165377,'node',' 1371574869 1389  ',0),(165378,'node',' 1371574869 1423  ',0),(165379,'node',' 1371574869 1374  ',0),(165381,'node',' 1371574869   ',0),(165383,'node',' 1371574869   ',0),(165384,'node',' 1371574869   ',0),(165385,'node',' 1371574869   ',0),(165387,'node',' 1371574870   ',0),(165389,'node',' 1371574870   ',0),(165391,'node',' 1371574870   ',0),(165394,'node',' 1371574923   ',0),(165395,'node',' 1371574923   ',0),(165396,'node',' 1371574923   ',0),(165397,'node',' 1371574923   ',0),(165398,'node',' 1371574923   ',0),(165399,'node',' 1371574923   ',0),(165400,'node',' 1371574923   ',0),(165401,'node',' 1371574923   ',0),(165402,'node',' 1371574923   ',0),(165403,'node',' 1371574923   ',0),(165404,'node',' 1371574923   ',0),(165405,'node',' 1371574923   ',0),(165406,'node',' 1371574923   ',0),(165407,'node',' 1371574923   ',0),(165408,'node',' 1371574923   ',0),(165409,'node',' 1371574923   ',0),(165410,'node',' 1371574923   ',0),(165411,'node',' 1371574923   ',0),(165412,'node',' 1371574923   ',0),(165413,'node',' 1371574923   ',0),(165414,'node',' 1371574923   ',0),(165415,'node',' 1371574923   ',0),(165416,'node',' 1371574923   ',0),(165417,'node',' 1371574923   ',0),(165418,'node',' 1371574923   ',0),(165419,'node',' 1371574923   ',0),(165420,'node',' 1371574923   ',0),(165421,'node',' 1371574923   ',0),(165422,'node',' 1371574923   ',0),(165423,'node',' 1371574923   ',0),(165424,'node',' 1371574923   ',0),(165425,'node',' 1371574923   ',0),(165426,'node',' 1371574923   ',0),(165427,'node',' 1371574923   ',0),(165428,'node',' 1371574923   ',0),(165429,'node',' 1371574923   ',0),(165430,'node',' 1371574923   ',0),(165431,'node',' 1371574923   ',0),(165432,'node',' 1371574923   ',0),(165433,'node',' 1371574923   ',0),(165434,'node',' 1371574923   ',0),(165435,'node',' 1371574923   ',0),(165436,'node',' 1371574923   ',0),(165437,'node',' 1371574923   ',0),(165438,'node',' 1371574923   ',0),(165439,'node',' 1371574923   ',0),(165440,'node',' 1371574923   ',0),(165441,'node',' 1371574923   ',0),(165442,'node',' 1371574923   ',0),(165443,'node',' 1371574923   ',0),(165444,'node',' 1371574923   ',0),(165445,'node',' 1371574923   ',0),(165446,'node',' 1371574923   ',0),(165447,'node',' 1371574923   ',0),(165448,'node',' 1371574923   ',0),(165449,'node',' 1371574923   ',0),(165450,'node',' 1371574923   ',0),(165451,'node',' 1371574923   ',0),(165452,'node',' 1371574923   ',0),(165454,'node',' 1371574927 1558  ',0),(165455,'node',' 1371574927 1377  ',0),(165456,'node',' 1371574927 1424  ',0),(165457,'node',' 1371574927 1470  ',0),(165458,'node',' 1371574927 1508  ',0),(165459,'node',' 1371574927 1433  ',0),(165460,'node',' 1371574927 1498  ',0),(165461,'node',' 1371574927 1518  ',0),(165463,'node',' 1371574928 1401  ',0),(165464,'node',' 1371574928 1280  ',0),(165465,'node',' 1371574928 1418  ',0),(165466,'node',' 1371574928 1428  ',0),(165467,'node',' 1371574928 1543  ',0),(165468,'node',' 1371574928 1519  ',0),(165469,'node',' 1371574928 1384  ',0),(165470,'node',' 1371574928 1329  ',0),(165472,'node',' 1371574929   ',0),(165474,'node',' 1371574929   ',0),(165475,'node',' 1371574929   ',0),(165476,'node',' 1371574929   ',0),(165478,'node',' 1371574929   ',0),(165480,'node',' 1371574929   ',0),(165482,'node',' 1371574930   ',0),(165485,'node',' 1371574983   ',0),(165486,'node',' 1371574983   ',0),(165487,'node',' 1371574983   ',0),(165488,'node',' 1371574983   ',0),(165489,'node',' 1371574983   ',0),(165496,'node',' 1371574983   ',0),(165490,'node',' 1371574983   ',0),(165491,'node',' 1371574983   ',0),(165495,'node',' 1371574983   ',0),(165492,'node',' 1371574983   ',0),(165493,'node',' 1371574983   ',0),(165494,'node',' 1371574983   ',0),(165497,'node',' 1371574983   ',0),(165498,'node',' 1371574983   ',0),(165499,'node',' 1371574983   ',0),(165500,'node',' 1371574983   ',0),(165501,'node',' 1371574983   ',0),(165502,'node',' 1371574983   ',0),(165503,'node',' 1371574983   ',0),(165504,'node',' 1371574983   ',0),(165505,'node',' 1371574983   ',0),(165506,'node',' 1371574983   ',0),(165507,'node',' 1371574983   ',0),(165508,'node',' 1371574983   ',0),(165509,'node',' 1371574983   ',0),(165510,'node',' 1371574983   ',0),(165511,'node',' 1371574983   ',0),(165512,'node',' 1371574983   ',0),(165513,'node',' 1371574983   ',0),(165514,'node',' 1371574983   ',0),(177787,'node',' 1371595265   ',0),(177779,'node',' 1371595264 1523  ',0),(177784,'node',' 1371595264   ',0),(177785,'node',' 1371595264   ',0),(177773,'node',' 1371595264 1640  ',0),(177776,'node',' 1371595264 1457  ',0),(177778,'node',' 1371595264 1606  ',0),(177763,'node',' 1371595263 1600  ',0),(177764,'node',' 1371595263 1504  ',0),(177768,'node',' 1371595263 1579  ',0),(177765,'node',' 1371595263 1593  ',0),(177766,'node',' 1371595263 1654  ',0),(177767,'node',' 1371595263 1545  ',0),(177769,'node',' 1371595263 1485  ',0),(177770,'node',' 1371595263 1461  ',0),(177772,'node',' 1371595264 1498  ',0),(177774,'node',' 1371595264 1569  ',0),(177775,'node',' 1371595264 1681  ',0),(177777,'node',' 1371595264 1563  ',0),(177781,'node',' 1371595264   ',0),(177783,'node',' 1371595264   ',0),(177794,'node',' 1371595323 1391  ',0),(177795,'node',' 1371595323 1497  ',0),(177796,'node',' 1371595323 1623  ',0),(177797,'node',' 1371595323 1636  ',0),(177798,'node',' 1371595323 1584  ',0),(177799,'node',' 1371595323 1647  ',0),(177800,'node',' 1371595323 1638  ',0),(177801,'node',' 1371595323 1577  ',0),(177803,'node',' 1371595324 1755  ',0),(177804,'node',' 1371595324 1470  ',0),(177808,'node',' 1371595324 1491  ',0),(177805,'node',' 1371595324 1604  ',0),(177806,'node',' 1371595324 1498  ',0),(177807,'node',' 1371595324 1554  ',0),(177809,'node',' 1371595324 1598  ',0),(177810,'node',' 1371595324 1488  ',0),(177812,'node',' 1371595324   ',0),(177814,'node',' 1371595325   ',0),(177815,'node',' 1371595325   ',0),(177816,'node',' 1371595325   ',0),(177818,'node',' 1371595325   ',0),(177820,'node',' 1371595325   ',0),(177822,'node',' 1371595325   ',0),(177825,'node',' 1371595383 1772  ',0),(177826,'node',' 1371595383 1621  ',0),(177827,'node',' 1371595383 1486  ',0),(177828,'node',' 1371595383 1516  ',0),(177829,'node',' 1371595383 1532  ',0),(177834,'node',' 1371595384 1487  ',0),(177835,'node',' 1371595384 1592  ',0),(177830,'node',' 1371595383 1475  ',0),(177831,'node',' 1371595383 1472  ',0),(177832,'node',' 1371595383 1532  ',0),(177836,'node',' 1371595384 1456  ',0),(177837,'node',' 1371595384 1536  ',0),(177838,'node',' 1371595384 1600  ',0),(177839,'node',' 1371595384 1575  ',0),(177840,'node',' 1371595384 1647  ',0),(177841,'node',' 1371595384 1630  ',0),(177843,'node',' 1371595384   ',0),(177845,'node',' 1371595385   ',0),(177846,'node',' 1371595385   ',0),(177847,'node',' 1371595385   ',0),(177849,'node',' 1371595385   ',0),(177851,'node',' 1371595385   ',0),(177853,'node',' 1371595385   ',0),(177856,'node',' 1371595443 1468  ',0),(177857,'node',' 1371595443 1438  ',0),(177858,'node',' 1371595443 1639  ',0),(177862,'node',' 1371595443 1553  ',0),(177865,'node',' 1371595444 1593  ',0),(177866,'node',' 1371595444 1681  ',0),(177867,'node',' 1371595444 1636  ',0),(177868,'node',' 1371595444 1541  ',0),(177869,'node',' 1371595444 1675  ',0),(177870,'node',' 1371595444 1567  ',0),(177871,'node',' 1371595444 1527  ',0),(177872,'node',' 1371595444 1601  ',0),(177874,'node',' 1371595445   ',0),(177876,'node',' 1371595445   ',0),(177877,'node',' 1371595445   ',0),(177878,'node',' 1371595445   ',0),(177880,'node',' 1371595445   ',0),(177882,'node',' 1371595446   ',0),(177884,'node',' 1371595446   ',0),(177887,'node',' 1371595502 1578  ',0),(177888,'node',' 1371595502 1566  ',0),(177889,'node',' 1371595502 1613  ',0),(177890,'node',' 1371595502 1533  ',0),(177891,'node',' 1371595502 1618  ',0),(177892,'node',' 1371595502 1595  ',0),(177897,'node',' 1371595503 1501  ',0),(177893,'node',' 1371595502 1603  ',0),(177894,'node',' 1371595502 1544  ',0),(177896,'node',' 1371595503 1496  ',0),(177761,'node',' 1371595262   ',0),(177762,'node',' 1371595263 1554  ',0),(177771,'node',' 1371595264 1569  ',0),(177780,'node',' 1371595264   ',0),(177782,'node',' 1371595264   ',0),(177793,'node',' 1371595323 1576  ',0),(177802,'node',' 1371595324 1560  ',0),(177811,'node',' 1371595324   ',0),(177813,'node',' 1371595325   ',0),(177817,'node',' 1371595325   ',0),(177819,'node',' 1371595325   ',0),(177821,'node',' 1371595325   ',0),(177823,'node',' 1371595382   ',0),(177833,'node',' 1371595384 1567  ',0),(177842,'node',' 1371595384   ',0),(177844,'node',' 1371595385   ',0),(177848,'node',' 1371595385   ',0),(177850,'node',' 1371595385   ',0),(177852,'node',' 1371595385   ',0),(177854,'node',' 1371595442   ',0),(177855,'node',' 1371595443 1561  ',0),(177864,'node',' 1371595444 1604  ',0),(177875,'node',' 1371595445   ',0),(177879,'node',' 1371595445   ',0),(177881,'node',' 1371595446   ',0),(177883,'node',' 1371595446   ',0),(177885,'node',' 1371595501   ',0),(177886,'node',' 1371595502 1582  ',0),(177895,'node',' 1371595503 1550  ',0),(177904,'node',' 1371595504   ',0),(177906,'node',' 1371595504   ',0),(177910,'node',' 1371595504   ',0),(177912,'node',' 1371595505   ',0),(177914,'node',' 1371595505   ',0),(177916,'node',' 1371595562   ',0),(177917,'node',' 1371595563 1586  ',0),(177926,'node',' 1371595564 1586  ',0),(177935,'node',' 1371595564   ',0),(177937,'node',' 1371595565   ',0),(177941,'node',' 1371595565   ',0),(177943,'node',' 1371595565   ',0),(177945,'node',' 1371595565   ',0),(177947,'node',' 1371595621   ',0),(177948,'node',' 1371595622 1597  ',0),(177957,'node',' 1371595623 1595  ',0),(177966,'node',' 1371595624   ',0),(177968,'node',' 1371595624   ',0),(177972,'node',' 1371595624   ',0),(177974,'node',' 1371595625   ',0),(177976,'node',' 1371595625   ',0),(177978,'node',' 1371595681   ',0),(177979,'node',' 1371595682 1580  ',0),(177988,'node',' 1371595683 1568  ',0),(177997,'node',' 1371595684   ',0),(177999,'node',' 1371595684   ',0),(178003,'node',' 1371595684   ',0),(178005,'node',' 1371595685 57  ',0),(178007,'node',' 1371595685   ',0),(178009,'node',' 1371595742   ',0),(178010,'node',' 1371595742 1622  ',0),(178019,'node',' 1371595743 1578  ',0),(178028,'node',' 1371595744   ',0),(178034,'node',' 1371595745   ',0),(178036,'node',' 1371595745   ',0),(178038,'node',' 1371595745   ',0),(178040,'node',' 1371595802   ',0),(178041,'node',' 1371595803 1565  ',0),(178050,'node',' 1371595804 1571  ',0),(178059,'node',' 1371595804   ',0),(178061,'node',' 1371595805   ',0),(178065,'node',' 1371595805   ',0),(178069,'node',' 1371595805   ',0),(178071,'node',' 1371595861   ',0),(178072,'node',' 1371595862 1630  ',0),(178081,'node',' 1371595863 1551  ',0),(178090,'node',' 1371595864   ',0),(178092,'node',' 1371595864   ',0),(178096,'node',' 1371595864   ',0),(178098,'node',' 1371595864   ',0),(178102,'node',' 1371595922   ',0),(178103,'node',' 1371595922 1578  ',0),(178112,'node',' 1371595923 1574  ',0),(178121,'node',' 1371595924   ',0),(178123,'node',' 1371595925   ',0),(178127,'node',' 1371595925   ',0),(178129,'node',' 1371595925   ',0),(178131,'node',' 1371595925   ',0),(178133,'node',' 1371595981   ',0),(178143,'node',' 1371595983 1588  ',0),(178152,'node',' 1371595984   ',0),(178154,'node',' 1371595984   ',0),(178158,'node',' 1371595984   ',0),(177898,'node',' 1371595503 1642  ',0),(177899,'node',' 1371595503 1677  ',0),(177900,'node',' 1371595503 1509  ',0),(177901,'node',' 1371595503 1454  ',0),(177902,'node',' 1371595503 1593  ',0),(177903,'node',' 1371595503 1511  ',0),(177905,'node',' 1371595504   ',0),(177907,'node',' 1371595504   ',0),(177908,'node',' 1371595504   ',0),(177909,'node',' 1371595504   ',0),(177911,'node',' 1371595504   ',0),(177913,'node',' 1371595505   ',0),(177915,'node',' 1371595505   ',0),(177918,'node',' 1371595563 1514  ',0),(177919,'node',' 1371595563 1601  ',0),(177920,'node',' 1371595563 1549  ',0),(177921,'node',' 1371595563 1670  ',0),(177922,'node',' 1371595563 1436  ',0),(177923,'node',' 1371595563 1633  ',0),(177924,'node',' 1371595563 1634  ',0),(177925,'node',' 1371595563 1640  ',0),(177927,'node',' 1371595564 1571  ',0),(177928,'node',' 1371595564 1650  ',0),(177929,'node',' 1371595564 1573  ',0),(177930,'node',' 1371595564 1670  ',0),(177931,'node',' 1371595564 1682  ',0),(177932,'node',' 1371595564 1625  ',0),(177933,'node',' 1371595564 1353  ',0),(177934,'node',' 1371595564 1540  ',0),(177936,'node',' 1371595564   ',0),(177938,'node',' 1371595565   ',0),(177939,'node',' 1371595565   ',0),(177940,'node',' 1371595565   ',0),(177942,'node',' 1371595565   ',0),(177944,'node',' 1371595565   ',0),(177946,'node',' 1371595565   ',0),(177949,'node',' 1371595622 1652  ',0),(177950,'node',' 1371595622 1642  ',0),(177951,'node',' 1371595622 1562  ',0),(177952,'node',' 1371595622 1660  ',0),(177953,'node',' 1371595622 1533  ',0),(177954,'node',' 1371595622 1585  ',0),(177955,'node',' 1371595622 1579  ',0),(177956,'node',' 1371595622 1564  ',0),(177958,'node',' 1371595623 1572  ',0),(177959,'node',' 1371595623 1590  ',0),(177960,'node',' 1371595623 1514  ',0),(177961,'node',' 1371595623 1601  ',0),(177962,'node',' 1371595623 1756  ',0),(177963,'node',' 1371595623 1562  ',0),(177964,'node',' 1371595623 1633  ',0),(177965,'node',' 1371595623 1517  ',0),(177967,'node',' 1371595624   ',0),(177969,'node',' 1371595624   ',0),(177970,'node',' 1371595624   ',0),(177971,'node',' 1371595624   ',0),(177973,'node',' 1371595624   ',0),(177975,'node',' 1371595625   ',0),(177977,'node',' 1371595625   ',0),(177980,'node',' 1371595682 1630  ',0),(177981,'node',' 1371595682 1410  ',0),(177982,'node',' 1371595682 1608  ',0),(177983,'node',' 1371595682 1568  ',0),(177984,'node',' 1371595682 1515  ',0),(177989,'node',' 1371595683 1358  ',0),(177990,'node',' 1371595683 1498  ',0),(177985,'node',' 1371595682 1609  ',0),(177986,'node',' 1371595682 1752  ',0),(177987,'node',' 1371595682 1527  ',0),(177991,'node',' 1371595683 1613  ',0),(177992,'node',' 1371595683 1692  ',0),(177993,'node',' 1371595683 1638  ',0),(177994,'node',' 1371595683 1569  ',0),(177995,'node',' 1371595683 1545  ',0),(177996,'node',' 1371595683 1609  ',0),(177998,'node',' 1371595684   ',0),(178000,'node',' 1371595684   ',0),(178001,'node',' 1371595684   ',0),(178002,'node',' 1371595684   ',0),(178004,'node',' 1371595684   ',0),(178006,'node',' 1371595685 57  ',0),(178008,'node',' 1371595685   ',0),(178011,'node',' 1371595742 1563  ',0),(178012,'node',' 1371595742 1621  ',0),(178013,'node',' 1371595742 1705  ',0),(178014,'node',' 1371595742 1627  ',0),(178015,'node',' 1371595742 1644  ',0),(178016,'node',' 1371595742 1640  ',0),(178017,'node',' 1371595742 1506  ',0),(178018,'node',' 1371595742 1664  ',0),(178020,'node',' 1371595743 1552  ',0),(178021,'node',' 1371595743 1550  ',0),(178022,'node',' 1371595743 1563  ',0),(178023,'node',' 1371595743 1631  ',0),(178024,'node',' 1371595743 1611  ',0),(178025,'node',' 1371595743 1614  ',0),(178026,'node',' 1371595743 1469  ',0),(178027,'node',' 1371595743 1626  ',0),(178029,'node',' 1371595744   ',0),(178031,'node',' 1371595744   ',0),(178032,'node',' 1371595744   ',0),(178033,'node',' 1371595744   ',0),(178035,'node',' 1371595745   ',0),(178037,'node',' 1371595745   ',0),(178039,'node',' 1371595745   ',0),(178042,'node',' 1371595803 1565  ',0),(178043,'node',' 1371595803 1573  ',0),(178044,'node',' 1371595803 1610  ',0),(178045,'node',' 1371595803 1558  ',0),(178046,'node',' 1371595803 1559  ',0),(178047,'node',' 1371595803 1510  ',0),(178048,'node',' 1371595803 1694  ',0),(178049,'node',' 1371595803 1443  ',0),(178051,'node',' 1371595804 1782  ',0),(178052,'node',' 1371595804 1523  ',0),(178053,'node',' 1371595804 1498  ',0),(178054,'node',' 1371595804 1558  ',0),(178055,'node',' 1371595804 1513  ',0),(178056,'node',' 1371595804 1537  ',0),(178057,'node',' 1371595804 1590  ',0),(178058,'node',' 1371595804 1548  ',0),(178060,'node',' 1371595804   ',0),(178062,'node',' 1371595805   ',0),(178063,'node',' 1371595805   ',0),(178064,'node',' 1371595805   ',0),(178066,'node',' 1371595805   ',0),(178068,'node',' 1371595805   ',0),(178070,'node',' 1371595805   ',0),(178074,'node',' 1371595862 1723  ',0),(178073,'node',' 1371595862 1616  ',0),(178075,'node',' 1371595862 1654  ',0),(178076,'node',' 1371595862 1712  ',0),(178077,'node',' 1371595862 1539  ',0),(178078,'node',' 1371595862 1660  ',0),(178079,'node',' 1371595862 1518  ',0),(178080,'node',' 1371595862 1606  ',0),(178082,'node',' 1371595863 1441  ',0),(178083,'node',' 1371595863 1625  ',0),(178084,'node',' 1371595863 1578  ',0),(178085,'node',' 1371595863 1507  ',0),(178086,'node',' 1371595863 1635  ',0),(178087,'node',' 1371595863 1519  ',0),(178088,'node',' 1371595863 1616  ',0),(178089,'node',' 1371595863 1473  ',0),(178091,'node',' 1371595864   ',0),(178093,'node',' 1371595864   ',0),(178094,'node',' 1371595864   ',0),(178095,'node',' 1371595864   ',0),(178097,'node',' 1371595864   ',0),(178099,'node',' 1371595864   ',0),(178101,'node',' 1371595865   ',0),(178104,'node',' 1371595922 1524  ',0),(178105,'node',' 1371595922 1500  ',0),(178106,'node',' 1371595922 1551  ',0),(178107,'node',' 1371595922 1638  ',0),(178108,'node',' 1371595922 1554  ',0),(178109,'node',' 1371595922 1643  ',0),(178110,'node',' 1371595922 1676  ',0),(178111,'node',' 1371595922 1532  ',0),(178113,'node',' 1371595923 1590  ',0),(178114,'node',' 1371595923 1620  ',0),(178115,'node',' 1371595923 1639  ',0),(178116,'node',' 1371595923 1565  ',0),(178117,'node',' 1371595923 1654  ',0),(178118,'node',' 1371595923 1508  ',0),(178119,'node',' 1371595923 1475  ',0),(178120,'node',' 1371595923 1528  ',0),(178122,'node',' 1371595924   ',0),(178124,'node',' 1371595925   ',0),(178125,'node',' 1371595925   ',0),(178126,'node',' 1371595925   ',0),(178128,'node',' 1371595925   ',0),(178130,'node',' 1371595925   ',0),(178132,'node',' 1371595925   ',0),(178135,'node',' 1371595982 1647  ',0),(178136,'node',' 1371595982 1567  ',0),(178137,'node',' 1371595982 1593  ',0),(178138,'node',' 1371595982 1448  ',0),(178139,'node',' 1371595982 1515  ',0),(178140,'node',' 1371595982 1514  ',0),(178141,'node',' 1371595982 1587  ',0),(178142,'node',' 1371595982 1687  ',0),(178144,'node',' 1371595983 1629  ',0),(178145,'node',' 1371595983 1599  ',0),(178146,'node',' 1371595983 1468  ',0),(178147,'node',' 1371595983 1526  ',0),(178156,'node',' 1371595984   ',0),(178148,'node',' 1371595983 1631  ',0),(178149,'node',' 1371595983 1614  ',0),(178155,'node',' 1371595984   ',0),(178150,'node',' 1371595983 1609  ',0),(178151,'node',' 1371595983 1623  ',0),(178153,'node',' 1371595984   ',0),(178157,'node',' 1371595984   ',0),(178159,'node',' 1371595984   ',0),(178161,'node',' 1371595984   ',0),(178163,'node',' 1371595985   ',0),(178166,'node',' 1371596042 1565  ',0),(178167,'node',' 1371596042 1480  ',0),(178168,'node',' 1371596042 1589  ',0),(178169,'node',' 1371596042 1672  ',0),(178170,'node',' 1371596042 1599  ',0),(178184,'node',' 1371596044   ',0),(178186,'node',' 1371596044   ',0),(178187,'node',' 1371596044   ',0),(178188,'node',' 1371596044   ',0),(178190,'node',' 1371596045   ',0),(178192,'node',' 1371596045   ',0),(178194,'node',' 1371596045   ',0),(178197,'node',' 1371596103 1556  ',0),(178198,'node',' 1371596103 1646  ',0),(178199,'node',' 1371596103 1557  ',0),(178200,'node',' 1371596103 1559  ',0),(178201,'node',' 1371596103 1622  ',0),(178202,'node',' 1371596103 1527  ',0),(178203,'node',' 1371596103 1601  ',0),(178204,'node',' 1371596103 1543  ',0),(178207,'node',' 1371596104 1583  ',0),(178206,'node',' 1371596104 1607  ',0),(178208,'node',' 1371596104 1523  ',0),(178209,'node',' 1371596104 1681  ',0),(178210,'node',' 1371596104 1427  ',0),(178211,'node',' 1371596104 1673  ',0),(178231,'node',' 1371596162 1625  ',0),(178234,'node',' 1371596162 1483  ',0),(178232,'node',' 1371596162 1554  ',0),(178233,'node',' 1371596162 1708  ',0),(178238,'node',' 1371596163 1628  ',0),(178239,'node',' 1371596163 1702  ',0),(178240,'node',' 1371596163 1634  ',0),(178241,'node',' 1371596163 1618  ',0),(178242,'node',' 1371596163 1606  ',0),(178243,'node',' 1371596163 1561  ',0),(178244,'node',' 1371596163 1649  ',0),(178246,'node',' 1371596164   ',0),(178248,'node',' 1371596164   ',0),(178249,'node',' 1371596164   ',0),(178250,'node',' 1371596164   ',0),(178252,'node',' 1371596164   ',0),(178254,'node',' 1371596165   ',0),(178256,'node',' 1371596165   ',0),(178259,'node',' 1371596223 1581  ',0),(178260,'node',' 1371596223 1518  ',0),(178261,'node',' 1371596223 1601  ',0),(178262,'node',' 1371596223 1612  ',0),(178275,'node',' 1371596224 1452  ',0),(178277,'node',' 1371596224   ',0),(178279,'node',' 1371596225   ',0),(178280,'node',' 1371596225   ',0),(178281,'node',' 1371596225   ',0),(178283,'node',' 1371596225   ',0),(178285,'node',' 1371596225   ',0),(178287,'node',' 1371596225   ',0),(178290,'node',' 1371596282 1575  ',0),(178291,'node',' 1371596282 1651  ',0),(178292,'node',' 1371596282 1616  ',0),(178293,'node',' 1371596282 1465  ',0),(178294,'node',' 1371596282 1510  ',0),(178295,'node',' 1371596282 1535  ',0),(178296,'node',' 1371596282 1595  ',0),(178297,'node',' 1371596282 1699  ',0),(178299,'node',' 1371596283 1495  ',0),(178300,'node',' 1371596283 1702  ',0),(178301,'node',' 1371596283 1459  ',0),(178164,'node',' 1371596041   ',0),(178165,'node',' 1371596042 1590  ',0),(178174,'node',' 1371596044 1603  ',0),(178183,'node',' 1371596044   ',0),(178185,'node',' 1371596044   ',0),(178189,'node',' 1371596045   ',0),(178196,'node',' 1371596103 1577  ',0),(178205,'node',' 1371596104 1555  ',0),(178214,'node',' 1371596105   ',0),(178216,'node',' 1371596105   ',0),(178220,'node',' 1371596105   ',0),(178236,'node',' 1371596163 1615  ',0),(178245,'node',' 1371596164   ',0),(178247,'node',' 1371596164   ',0),(178251,'node',' 1371596164   ',0),(178253,'node',' 1371596165   ',0),(178255,'node',' 1371596165   ',0),(178276,'node',' 1371596224   ',0),(178278,'node',' 1371596225   ',0),(178282,'node',' 1371596225   ',0),(178284,'node',' 1371596225   ',0),(178286,'node',' 1371596225   ',0),(178288,'node',' 1371596281   ',0),(178289,'node',' 1371596282 1582  ',0),(178436,'node',' 1371596525   ',0),(178438,'node',' 1371596525   ',0),(178445,'node',' 1371596582 1568  ',0),(178440,'node',' 1371596525   ',0),(178442,'node',' 1371596526   ',0),(178446,'node',' 1371596582 1562  ',0),(178447,'node',' 1371596582 1467  ',0),(178448,'node',' 1371596582 1682  ',0),(178449,'node',' 1371596582 1517  ',0),(178450,'node',' 1371596582 1566  ',0),(178451,'node',' 1371596582 1647  ',0),(178452,'node',' 1371596582 1569  ',0),(178454,'node',' 1371596583 1468  ',0),(178455,'node',' 1371596583 1551  ',0),(178457,'node',' 1371596583 1625  ',0),(178458,'node',' 1371596583 1507  ',0),(178473,'node',' 1371596585   ',0),(178476,'node',' 1371596643 1603  ',0),(178477,'node',' 1371596643 1515  ',0),(178478,'node',' 1371596643 1650  ',0),(178479,'node',' 1371596643 1671  ',0),(178480,'node',' 1371596643 1623  ',0),(178496,'node',' 1371596645   ',0),(178500,'node',' 1371596646   ',0),(178481,'node',' 1371596643 1617  ',0),(178482,'node',' 1371596643 1559  ',0),(178494,'node',' 1371596645   ',0),(178483,'node',' 1371596643 1519  ',0),(178490,'node',' 1371596644 1616  ',0),(178491,'node',' 1371596644 1667  ',0),(178485,'node',' 1371596644 1711  ',0),(178488,'node',' 1371596644 1468  ',0),(178489,'node',' 1371596644 1707  ',0),(178486,'node',' 1371596644 1516  ',0),(178487,'node',' 1371596644 1546  ',0),(178492,'node',' 1371596644 1522  ',0),(178497,'node',' 1371596645   ',0),(178498,'node',' 1371596645   ',0),(178502,'node',' 1371596646   ',0),(178504,'node',' 1371596646   ',0),(178507,'node',' 1371596703 1687  ',0),(178508,'node',' 1371596703 1673  ',0),(178509,'node',' 1371596703 1712  ',0),(178511,'node',' 1371596703 1430  ',0),(178521,'node',' 1371596704 1539  ',0),(178522,'node',' 1371596704 1579  ',0),(178523,'node',' 1371596704 1716  ',0),(178525,'node',' 1371596705   ',0),(178527,'node',' 1371596705   ',0),(178528,'node',' 1371596705   ',0),(178529,'node',' 1371596705   ',0),(178531,'node',' 1371596705   ',0),(178533,'node',' 1371596705   ',0),(178535,'node',' 1371596706   ',0),(178538,'node',' 1371596762 1664  ',0),(178539,'node',' 1371596762 1467  ',0),(178541,'node',' 1371596762 1618  ',0),(178540,'node',' 1371596762 1634  ',0),(178542,'node',' 1371596762 1588  ',0),(178543,'node',' 1371596762 1628  ',0),(178544,'node',' 1371596762 1611  ',0),(178545,'node',' 1371596762 1457  ',0),(178547,'node',' 1371596763 1559  ',0),(178548,'node',' 1371596763 1418  ',0),(178551,'node',' 1371596763 1642  ',0),(178573,'node',' 1371596823 1491  ',0),(178574,'node',' 1371596823 1549  ',0),(178575,'node',' 1371596823 1608  ',0),(178576,'node',' 1371596823 1711  ',0),(178578,'node',' 1371596824 1570  ',0),(178579,'node',' 1371596824 1727  ',0),(178580,'node',' 1371596824 1521  ',0),(178581,'node',' 1371596824 1521  ',0),(178582,'node',' 1371596824 1561  ',0),(178583,'node',' 1371596824 1603  ',0),(178584,'node',' 1371596824 1456  ',0),(178585,'node',' 1371596824 1575  ',0),(178587,'node',' 1371596825   ',0),(178589,'node',' 1371596825   ',0),(178590,'node',' 1371596825   ',0),(178591,'node',' 1371596825   ',0),(178593,'node',' 1371596825   ',0),(178595,'node',' 1371596825   ',0),(178600,'node',' 1371596882 1489  ',0),(178601,'node',' 1371596882 1547  ',0),(178611,'node',' 1371596883 1728  ',0),(178612,'node',' 1371596883 1561  ',0),(178613,'node',' 1371596883 1547  ',0),(178614,'node',' 1371596883 1433  ',0),(178624,'node',' 1371596884   ',0),(178615,'node',' 1371596883 1615  ',0),(178621,'node',' 1371596884   ',0),(178622,'node',' 1371596884   ',0),(178616,'node',' 1371596883 1582  ',0),(178618,'node',' 1371596883   ',0),(178620,'node',' 1371596884   ',0),(178626,'node',' 1371596884   ',0),(178628,'node',' 1371596884   ',0),(178631,'node',' 1371596943 1688  ',0),(178632,'node',' 1371596943 1415  ',0),(178633,'node',' 1371596943 1632  ',0),(178634,'node',' 1371596943 1611  ',0),(178635,'node',' 1371596943 1718  ',0),(178636,'node',' 1371596943 1516  ',0),(178637,'node',' 1371596943 1546  ',0),(178638,'node',' 1371596943 1490  ',0),(178640,'node',' 1371596944 1525  ',0),(178641,'node',' 1371596944 1697  ',0),(178642,'node',' 1371596944 1455  ',0),(178643,'node',' 1371596944 1620  ',0),(178645,'node',' 1371596944 1522  ',0),(178646,'node',' 1371596944 1561  ',0),(178647,'node',' 1371596944 1601  ',0),(178649,'node',' 1371596945   ',0),(178665,'node',' 1371597002 1662  ',0),(178666,'node',' 1371597002 1499  ',0),(178668,'node',' 1371597002 1643  ',0),(178667,'node',' 1371597002 1465  ',0),(178669,'node',' 1371597002 1517  ',0),(178671,'node',' 1371597003 1604  ',0),(178672,'node',' 1371597003 1601  ',0),(178673,'node',' 1371597003 1511  ',0),(178674,'node',' 1371597003 1523  ',0),(192180,'node',' 1371628749   ',0),(192178,'node',' 1371628742   ',0),(192179,'node',' 1371628749   ',0),(192181,'node',' 1371628749   ',0),(192182,'node',' 1371628749   ',0),(192183,'node',' 1371628749   ',0),(192184,'node',' 1371628749   ',0),(192185,'node',' 1371628749   ',0),(192186,'node',' 1371628749   ',0),(192187,'node',' 1371628749   ',0),(192188,'node',' 1371628749   ',0),(192189,'node',' 1371628749   ',0),(192190,'node',' 1371628749   ',0),(192200,'node',' 1371628802   ',0),(192201,'node',' 1371628865   ',0),(192222,'node',' 1371628922   ',0),(192223,'node',' 1371628945   ',0),(192232,'node',' 1371628945   ',0),(192234,'node',' 1371628946   ',0),(192245,'node',' 1371629114   ',0),(192254,'node',' 1371629115   ',0),(192256,'node',' 1371629115   ',0),(192260,'node',' 1371629115   ',0),(192262,'node',' 1371629116   ',0),(192264,'node',' 1371629116   ',0),(192266,'node',' 1371629161   ',0),(192267,'node',' 1371629165   ',0),(192276,'node',' 1371629166   ',0),(192278,'node',' 1371629166   ',0),(192289,'node',' 1371629226   ',0),(192298,'node',' 1371629226   ',0),(192300,'node',' 1371629227   ',0),(192304,'node',' 1371629227   ',0),(192306,'node',' 1371629227   ',0),(192308,'node',' 1371629227   ',0),(192310,'node',' 1371629282   ',0),(192311,'node',' 1371629286   ',0),(192330,'node',' 1371629288   ',0),(192332,'node',' 1371629341   ',0),(192333,'node',' 1371629350   ',0),(192335,'node',' 1371629350   ',0),(192339,'node',' 1371629350   ',0),(192341,'node',' 1371629350   ',0),(192354,'node',' 1371629412   ',0),(192356,'node',' 1371629412   ',0),(192358,'node',' 1371629412   ',0),(192360,'node',' 1371629462   ',0),(192361,'node',' 1371629469   ',0),(192370,'node',' 1371629469   ',0),(192374,'node',' 1371629470   ',0),(192390,'node',' 1371629527   ',0),(192394,'node',' 1371629527   ',0),(192396,'node',' 1371629527   ',0),(192398,'node',' 1371629527   ',0),(192400,'node',' 1371629582   ',0),(192401,'node',' 1371629648   ',0),(192410,'node',' 1371629649 1302  ',0),(192418,'node',' 1371629650   ',0),(192423,'node',' 1371629718 984  ',0),(192425,'node',' 1371629719   ',0),(192429,'node',' 1371629719   ',0),(192431,'node',' 1371629719   ',0),(192433,'node',' 1371629719   ',0),(192435,'node',' 1371629761   ',0),(192436,'node',' 1371629784 1397  ',0),(192448,'node',' 1371629821   ',0),(192449,'node',' 1371629835 317  ',0),(192451,'node',' 1371629835   ',0),(192455,'node',' 1371629836   ',0),(192457,'node',' 1371629836   ',0),(192459,'node',' 1371629836   ',0),(192461,'node',' 1371629838 317  ',0),(192477,'node',' 1371629886   ',0),(192481,'node',' 1371629886   ',0),(192483,'node',' 1371629887   ',0),(192485,'node',' 1371629887   ',0),(192487,'node',' 1371629941   ',0),(192488,'node',' 1371629946   ',0),(192497,'node',' 1371629946   ',0),(192367,'node',' 1371629469   ',0),(192368,'node',' 1371629469   ',0),(192369,'node',' 1371629469   ',0),(192371,'node',' 1371629469   ',0),(192372,'node',' 1371629469   ',0),(192373,'node',' 1371629469   ',0),(192375,'node',' 1371629470   ',0),(192377,'node',' 1371629470   ',0),(192379,'node',' 1371629470   ',0),(192382,'node',' 1371629526   ',0),(192383,'node',' 1371629526   ',0),(192384,'node',' 1371629526   ',0),(192385,'node',' 1371629526   ',0),(192386,'node',' 1371629526   ',0),(192387,'node',' 1371629526   ',0),(192407,'node',' 1371629648   ',0),(192408,'node',' 1371629648   ',0),(192409,'node',' 1371629648   ',0),(192411,'node',' 1371629649 1302  ',0),(192413,'node',' 1371629649   ',0),(192414,'node',' 1371629649   ',0),(192415,'node',' 1371629649   ',0),(192417,'node',' 1371629650   ',0),(192419,'node',' 1371629650   ',0),(192440,'node',' 1371629784   ',0),(192441,'node',' 1371629784   ',0),(192443,'node',' 1371629785   ',0),(192445,'node',' 1371629785   ',0),(192447,'node',' 1371629786   ',0),(192450,'node',' 1371629835 317  ',0),(192452,'node',' 1371629835   ',0),(192453,'node',' 1371629835   ',0),(192454,'node',' 1371629835   ',0),(192472,'node',' 1371629885   ',0),(192473,'node',' 1371629885   ',0),(192474,'node',' 1371629885   ',0),(192476,'node',' 1371629886 6667  ',0),(192478,'node',' 1371629886   ',0),(192479,'node',' 1371629886   ',0),(192480,'node',' 1371629886   ',0),(192482,'node',' 1371629886   ',0),(192484,'node',' 1371629887   ',0),(192486,'node',' 1371629887   ',0),(192501,'node',' 1371629947   ',0),(192502,'node',' 1371629947   ',0),(192504,'node',' 1371629947   ',0),(192506,'node',' 1371629947   ',0),(192508,'node',' 1371629947   ',0),(192511,'node',' 1371630006   ',0),(192512,'node',' 1371630006   ',0),(192513,'node',' 1371630006   ',0),(192514,'node',' 1371630006   ',0),(192521,'node',' 1371630006   ',0),(192522,'node',' 1371630006   ',0),(192524,'node',' 1371630007   ',0),(192526,'node',' 1371630007   ',0),(192528,'node',' 1371630007   ',0),(192531,'node',' 1371630066   ',0),(192532,'node',' 1371630066   ',0),(192533,'node',' 1371630066   ',0),(192534,'node',' 1371630066   ',0),(192535,'node',' 1371630066   ',0),(192536,'node',' 1371630066   ',0),(192537,'node',' 1371630066   ',0),(192538,'node',' 1371630066   ',0),(192540,'node',' 1371630067   ',0),(192541,'node',' 1371630067   ',0),(192542,'node',' 1371630067   ',0),(192544,'node',' 1371630067   ',0),(192546,'node',' 1371630067   ',0),(192548,'node',' 1371630067   ',0),(192551,'node',' 1371630126   ',0),(192552,'node',' 1371630126   ',0),(192553,'node',' 1371630126   ',0),(192554,'node',' 1371630126   ',0),(192555,'node',' 1371630126   ',0),(192556,'node',' 1371630126   ',0),(192557,'node',' 1371630126   ',0),(192558,'node',' 1371630126   ',0),(192560,'node',' 1371630127 890  ',0),(192562,'node',' 1371630127   ',0),(192563,'node',' 1371630127   ',0),(192564,'node',' 1371630127   ',0);
/*!40000 ALTER TABLE `search_dataset` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `search_index`
--

DROP TABLE IF EXISTS `search_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_index` (
  `word` varchar(50) NOT NULL DEFAULT '' COMMENT 'The search_total.word that is associated with the search item.',
  `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The search_dataset.sid of the searchable item to which the word belongs.',
  `type` varchar(16) NOT NULL COMMENT 'The search_dataset.type of the searchable item to which the word belongs.',
  `score` float DEFAULT NULL COMMENT 'The numeric score of the word, higher being more important.',
  PRIMARY KEY (`word`,`sid`,`type`),
  KEY `sid_type` (`sid`,`type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores the search index, associating words, items and...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_index`
--

LOCK TABLES `search_index` WRITE;
/*!40000 ALTER TABLE `search_index` DISABLE KEYS */;
INSERT INTO `search_index` VALUES ('disk',96076,'node',26),('channel',96074,'node',26),('disk',96074,'node',26),('scsi',96279,'node',26),('naa6000c29eeb2b6dbd2d24552781be174b',96285,'node',26),('naa6000c29a784d07bfd536222612ee057f',96284,'node',26),('naa5002538050003d09',96282,'node',26),('disk',96282,'node',26),('scsi',96282,'node',26),('attached',96282,'node',26),('serial',96282,'node',26),('ata',96282,'node',26),('disk',96281,'node',26),('naa5000c50041938b37',96281,'node',26),('scsi',96281,'node',26),('attached',96281,'node',26),('serial',96281,'node',26),('ibmesxs',96281,'node',26),('disk',96279,'node',26),('attached',96279,'node',26),('serial',96279,'node',26),('ibmesxs',96279,'node',26),('naa6000c2908e605dca09ff6427d4bd914a',96133,'node',26),('naa6000c291fd64f90bd3d371b644cee3c5',96126,'node',26),('naa60a9800037543261505d424f31325645',96124,'node',26),('naa6000c29102ce37a07ac01e2ced3959b8',96123,'node',26),('naa6000c2973380870eb4d88784ea671eca',96122,'node',26),('naa6000c290b1821e62cf431ca26bf1f765',96115,'node',26),('naa60a9800037543261553f41783945462f',96077,'node',26),('disk',96077,'node',26),('channel',96077,'node',26),('fibre',96077,'node',26),('netapp',96077,'node',26),('naa60a9800037543261505d424f31325755',96074,'node',26),('fibre',96074,'node',26),('netapp',96074,'node',26),('naa60a9800037543261505d424f31325751',96073,'node',26),('disk',96073,'node',26),('channel',96073,'node',26),('fibre',96073,'node',26),('netapp',96073,'node',26),('naa60a9800037543261505d424f31325637',96072,'node',26),('disk',96072,'node',26),('channel',96072,'node',26),('fibre',96072,'node',26),('netapp',96072,'node',26),('disk',96071,'node',26),('naa60a9800037543261505d424f31325559',96071,'node',26),('channel',96071,'node',26),('fibre',96071,'node',26),('netapp',96071,'node',26),('disk',96067,'node',26),('naa60a9800037543261505d424f3132574f',96067,'node',26),('channel',96067,'node',26),('fibre',96067,'node',26),('netapp',96067,'node',26),('naa60a9800037543261505d424f31325737',96066,'node',26),('disk',96066,'node',26),('channel',96066,'node',26),('fibre',96066,'node',26),('netapp',96066,'node',26),('naa60a9800037543261505d424f31325731',96065,'node',26),('disk',96065,'node',26),('channel',96065,'node',26),('fibre',96065,'node',26),('netapp',96065,'node',26),('naa60a9800037543261505d424f31325653',96064,'node',26),('disk',96064,'node',26),('netapp',96064,'node',26),('fibre',96064,'node',26),('channel',96064,'node',26),('naa60a9800037543261505d424f31325651',96063,'node',26),('disk',96063,'node',26),('channel',96063,'node',26),('fibre',96063,'node',26),('netapp',96063,'node',26),('naa60a9800037543261553f417839454155',96062,'node',26),('disk',96062,'node',26),('channel',96062,'node',26),('fibre',96062,'node',26),('netapp',96062,'node',26),('naa60a9800037543261553f417839454153',96061,'node',26),('disk',96061,'node',26),('channel',96061,'node',26),('fibre',96061,'node',26),('netapp',96061,'node',26),('ata',96058,'node',26),('serial',96058,'node',26),('attached',96058,'node',26),('scsi',96058,'node',26),('disk',96058,'node',26),('naa5002538050003d38',96058,'node',26),('netapp',96059,'node',26),('fibre',96059,'node',26),('channel',96059,'node',26),('disk',96059,'node',26),('naa60a9800037543261505d424f31325764',96059,'node',26),('netapp',96060,'node',26),('fibre',96060,'node',26),('channel',96060,'node',26),('disk',96060,'node',26),('naa60a9800037543261505d424f31325768',96060,'node',26),('disk',96070,'node',26),('channel',96070,'node',26),('fibre',96070,'node',26),('netapp',96070,'node',26),('netapp',96068,'node',26),('fibre',96068,'node',26),('channel',96068,'node',26),('disk',96068,'node',26),('naa60a9800037543261553f417839454855',96068,'node',26),('netapp',96069,'node',26),('fibre',96069,'node',26),('channel',96069,'node',26),('disk',96069,'node',26),('naa60a9800037543261553f417839454857',96069,'node',26),('channel',96076,'node',26),('fibre',96076,'node',26),('netapp',96076,'node',26),('naa60a9800037543261505d424f31325757',96075,'node',26),('channel',96075,'node',26),('disk',96075,'node',26),('fibre',96075,'node',26),('netapp',96075,'node',26),('naa60a9800037543261505d424f31325274',96070,'node',26),('naa6000c294aba0be1db4257742f4ab2149',96431,'node',26),('naa600a09803c1b589db5363869fc0027d0',96280,'node',26),('disk',96280,'node',26),('attached',96280,'node',26),('scsi',96280,'node',26),('serial',96280,'node',26),('netapp',96280,'node',26),('naa5000c50040cc7d03',96279,'node',26),('naa60a9800037543261505d424f3132567a',96076,'node',26),('1371220922',127619,'node',26),('1371220622',127598,'node',26),('1371220622',127599,'node',26),('1371220682',127602,'node',26),('1371220742',127606,'node',26),('1371220682',127603,'node',26),('1371220802',127610,'node',26),('1371220742',127607,'node',26),('1371220802',127611,'node',26),('1371220862',127614,'node',26),('1371220862',127615,'node',26),('1371220922',127618,'node',26),('1371629287',192325,'node',26),('1371629287',192324,'node',26),('1371629226',192295,'node',26),('1371629226',192294,'node',26),('1371629167',192285,'node',26),('1371629114',192248,'node',26),('1371629114',192247,'node',26),('1371629114',192252,'node',26),('1371629114',192251,'node',26),('1371629114',192250,'node',26),('1371629114',192249,'node',26),('1371629115',192258,'node',26),('1371629286',192316,'node',26),('1371629286',192315,'node',26),('1371629226',192299,'node',26),('1371629226',192297,'node',26),('1371629227',192301,'node',26),('1371629227',192302,'node',26),('1371629227',192305,'node',26),('1371629227',192303,'node',26),('1371629227',192307,'node',26),('1371629286',192312,'node',26),('1371629227',192309,'node',26),('1371629286',192314,'node',26),('1371629286',192313,'node',26),('1371629287',192323,'node',26),('1371629350',192338,'node',26),('1371629350',192340,'node',26),('1371629350',192342,'node',26),('1371629412',192357,'node',26),('naa6000c291e7664b34dc236a785a15a710',99302,'node',26),('naa6000c29783fc4f972a0e2aa7af5c9ebc',99303,'node',26),('naa6000c2948cee8e308227c11728d12994',99301,'node',26),('naa6000c29a1f5f7d26f2a75fb16217d54e',99306,'node',26),('naa6000c29b26a3835e07a5d36f5837bba5',99305,'node',26),('naa6000c2918b7a0a89bc9c6ffe16eb9871',99309,'node',26),('naa6000c299d3ae339df867c0de47a27d80',99310,'node',26),('naa6000c29980b86140cc05e5ce0e9e43b1',99308,'node',26),('naa6000c2950a1a5ab366bf05b6692f2079',99312,'node',26),('naa6000c2981d553aa25cfefeeb7b4bc25e',99316,'node',26),('naa6000c295e8b49c56dd6827fe418ea715',99315,'node',26),('hgw2k8r232vm20',99320,'node',26),('hgw2k8r232vm19',99319,'node',26),('hgw2k8r232vm21',99321,'node',26),('naa6000c293a337fcf57f8ea9762309fd54',99323,'node',26),('naa600a098044307535732b334571533572',99324,'node',26),('hgw2k8r232vm22',99322,'node',26),('naa6000c295475d09ab8ae1de90a71dec6f',99300,'node',26),('naa6000c29de233a6cbb6e5b79519ee353a',99304,'node',26),('naa6000c29277c4580946c7adda249783a0',99307,'node',26),('naa6000c29a5e879be9aeff82ec4073485e',99311,'node',26),('naa6000c29b23567272d0e586205dcc32cf',99314,'node',26),('naa6000c2938bb49a8d2e5d49b476c92cf9',99313,'node',26),('hgw2k8r232vm17',99317,'node',26),('hgw2k8r232vm18',99318,'node',26),('naa600a098044307259313f334556393435',99327,'node',26),('naa6000c2908408da158a5c3bfb61c07879',99328,'node',26),('naa600a098044307535732b334571533571',99326,'node',26),('naa600a098044307259313f334556393436',99325,'node',26),('naa6000c2984c0245d266169b9686a2e0c5',99330,'node',26),('naa6000c29682c740d63afb534636704664',99331,'node',26),('naa6000c29efaa27da235fda642d90b098e',99329,'node',26),('naa6000c29b18316ab182310d09e03d2b2a',99334,'node',26),('naa6000c29ff0e809d5b2af05c5768c5cff',99335,'node',26),('naa6000c296839ce8de1e698a38b6fc7173',99333,'node',26),('naa6000c29c778256eb8f4b6c1a1dce5fcb',99332,'node',26),('naa6000c2950d47cdaa94a633480603dd7e',99339,'node',26),('naa6000c2956b7de21f10dd9f2621408e5a',99338,'node',26),('naa6000c2997b6962f32a26b73da8e61119',99336,'node',26),('naa6000c298ceb3a9e5a4bd63b85488b9e6',99337,'node',26),('naa6000c29bf5e027a66f21c82dcb90d5f2',99341,'node',26),('naa6000c290953dbf42f2b92e416d97f3d6',99342,'node',26),('naa6000c29675dd7a7e994beefc89fb5588',99340,'node',26),('naa6000c294f5dd6c075c769db0311d7918',99344,'node',26),('naa6000c29e9e802ff92aa3e9751bb1ccf8',99345,'node',26),('naa6000c290d6a786993a27840bc7e74219',99346,'node',26),('naa6000c29df644dce63fd960a3bf12b1d5',99343,'node',26),('naa6000c2950cabe6ece937dc69d952ae4e',99352,'node',26),('naa6000c29eecc6e9adbb0132e3b3ff7d22',99353,'node',26),('naa6000c297064a18dfa88eced6be50e057',99351,'node',26),('naa6000c2961e793febff84f5ced5c58b21',99348,'node',26),('naa6000c292f6633bcff2180b75206f0661',99347,'node',26),('naa6000c2953e4b58e3268b2275f65c00b3',99358,'node',26),('naa6000c2967439883ffd8ad92ee6de2a3c',99355,'node',26),('naa6000c29a8d23467dedb9b0a508ab6f92',99356,'node',26),('naa6000c290abfaf53c3b2c643b607038bf',99357,'node',26),('naa6000c291fd2395fe3c1997950b8a8c0c',99354,'node',26),('naa6000c29d4e2ce7b705f66fdbdb461313',99362,'node',26),('naa6000c299e65677701b273f929adbcc1f',99369,'node',26),('naa6000c29ac85e6f88af7b4f6868fbe87a',99360,'node',26),('naa6000c2940cc5bf41316a55e0c94957c8',99361,'node',26),('naa6000c29a09f274bcd4bbf3ae484e5e7a',99359,'node',26),('naa6000c297b449a234fac7c88a0cbeb75e',99370,'node',26),('naa6000c29af0bf917f423b0f7b4d54e792',99368,'node',26),('naa6000c298693d22a716644668f808bc18',99367,'node',26),('naa6000c296b486ba69a3f71bbafc3e5f15',99366,'node',26),('naa6000c29a1b45eeace0049699f7123c20',99365,'node',26),('naa6000c29aab2e04f2571c7c6050ee8353',99363,'node',26),('naa6000c294064b8b30c8452cef95062d75',99364,'node',26),('naa6000c29c58d9db25ed3a37b024d23841',99374,'node',26),('naa6000c29b3fec74f237a67afa746f5d55',99372,'node',26),('naa6000c2935c4a6942cc0cd05e188cf9ba',99373,'node',26),('naa6000c29b205838c4c55aaafda23eed79',99376,'node',26),('naa6000c29a03b63f95b8f592f18d630b86',99377,'node',26),('naa6000c295eaa5dccf467bbae8044414ce',99375,'node',26),('naa6000c29beb328cfb51bf06835ac5ed52',99380,'node',26),('naa6000c2921dd7be48256aa02064b5d01d',99381,'node',26),('naa6000c29e08ce8c49f3881f5e5458acda',99379,'node',26),('naa6000c29b4b82c4cc1945e2db12671829',99378,'node',26),('hgw2k8r232vm24',99383,'node',26),('hgw2k8r232vm23',99382,'node',26),('hgw2k8r232vm25',99384,'node',26),('hgw2k8r232vm29',99388,'node',26),('hgw2k8r232vm31',99390,'node',26),('flash',99391,'node',26),('accel',99391,'node',26),('management',99391,'node',26),('console',99391,'node',26),('12',99391,'node',26),('hgw2k8r232vm33',99393,'node',26),('11',99392,'node',26),('console',99392,'node',26),('management',99392,'node',26),('flash',99392,'node',26),('accel',99392,'node',26),('naa600a098044307259313f334556393443',99396,'node',26),('naa6000c2937aedbf22b1bf4f872c4765df',99395,'node',26),('hgw2k8r232vm32',99394,'node',26),('naa600a098044307535732b334571533579',99398,'node',26),('naa600a098044307259313f334556393444',99397,'node',26),('naa6000c29c8124bd2298ececba4c3782b1',99371,'node',26),('hgw2k8r232vm27',99386,'node',26),('hgw2k8r232vm28',99387,'node',26),('hgw2k8r232vm30',99389,'node',26),('naa6000c29121e66c0d79b623de3052d405',99350,'node',26),('naa6000c29bc48a17080060b2a7a04002fc',99349,'node',26),('hgw2k8r232vm26',99385,'node',26),('mpxvmhba1',98841,'node',26),('local',98840,'node',26),('vmware',98840,'node',26),('disk',98841,'node',26),('vmware',98841,'node',26),('local',98841,'node',26),('mpxvmhba1',98840,'node',26),('disk',98840,'node',26),('1371629469',192365,'node',26),('1371629469',192366,'node',26),('1371629412',192355,'node',26),('1371629412',192352,'node',26),('1371629412',192353,'node',26),('1371629412',192351,'node',26),('1371629411',192349,'node',26),('1371629351',192344,'node',26),('1371629396',192346,'node',26),('1371629288',192331,'node',26),('1371629350',192334,'node',26),('1371629350',192337,'node',26),('1371629350',192336,'node',26),('1371629287',192321,'node',26),('1371629286',192319,'node',26),('1371629286',192318,'node',26),('1371629286',192317,'node',26),('1371629226',192292,'node',26),('1371629226',192293,'node',26),('1371629165',192271,'node',26),('1371629165',192273,'node',26),('1371629165',192272,'node',26),('1371629165',192274,'node',26),('1371629165',192275,'node',26),('1371629166',192277,'node',26),('1371629166',192279,'node',26),('1371629166',192281,'node',26),('1371629166',192280,'node',26),('hgw2k8r232vm14',141360,'node',26),('hgw2k8r232vm15',141361,'node',26),('hgw2k8r232vm13',141362,'node',26),('hgw2k8r232vm18',141364,'node',26),('hgw2k8r232vm19',141365,'node',26),('hgw2k8r232vm20',141366,'node',26),('1371629166',192283,'node',26),('1371629167',192287,'node',26),('1371629226',192290,'node',26),('1371629226',192291,'node',26),('1371629115',192259,'node',26),('1371629116',192263,'node',26),('1371629115',192261,'node',26),('1371629116',192265,'node',26),('1371628945',192225,'node',26),('1371628945',192224,'node',26),('1371628865',192206,'node',26),('1371628865',192205,'node',26),('1371628945',192228,'node',26),('1371628945',192227,'node',26),('1371628945',192226,'node',26),('1371628945',192231,'node',26),('1371628945',192230,'node',26),('1371628945',192229,'node',26),('1371628946',192236,'node',26),('1371628946',192235,'node',26),('1371628945',192233,'node',26),('1371628946',192241,'node',26),('1371628946',192239,'node',26),('1371628946',192237,'node',26),('1371629114',192246,'node',26),('1371628946',192243,'node',26),('1371629165',192270,'node',26),('1371629115',192257,'node',26),('1371629115',192255,'node',26),('1371629114',192253,'node',26),('1371630006',192516,'node',26),('1371630006',192515,'node',26),('1371630006',192517,'node',26),('1371630006',192518,'node',26),('1371630006',192520,'node',26),('1371629947',192501,'node',26),('1371629946',192489,'node',26),('1371629946',192490,'node',26),('1371629946',192492,'node',26),('1371629946',192491,'node',26),('1371629946',192493,'node',26),('1371629946',192494,'node',26),('1371629836',192456,'node',26),('1371629836',192458,'node',26),('317',192462,'node',1),('1371629838',192462,'node',26),('1371629836',192460,'node',26),('6667',192464,'node',1),('1371629878',192464,'node',26),('1371629885',192467,'node',26),('1371629650',192421,'node',26),('1371629719',192426,'node',26),('984',192424,'node',1),('1371629718',192424,'node',26),('1371629719',192427,'node',26),('1371629719',192428,'node',26),('1371628865',192204,'node',26),('1371628865',192203,'node',26),('1371628865',192202,'node',26),('1371629719',192432,'node',26),('1371629719',192430,'node',26),('1371629648',192407,'node',26),('1371629526',192388,'node',26),('1371629526',192389,'node',26),('1371629527',192392,'node',26),('1371629527',192391,'node',26),('1371629527',192393,'node',26),('1371629527',192397,'node',26),('1371629527',192395,'node',26),('6667',192475,'node',1),('1371629886',192475,'node',26),('1371629786',192446,'node',26),('1371629702',192422,'node',26),('1371629526',192381,'node',26),('1371629522',192380,'node',26),('1371629411',192348,'node',26),('1371629287',192320,'node',26),('1371629287',192328,'node',26),('1371629287',192326,'node',26),('1371629222',192288,'node',26),('1371628982',192244,'node',26),('1371629165',192269,'node',26),('1371629165',192268,'node',26),('1371629226',192296,'node',26),('1371629469',192364,'node',26),('1371629469',192363,'node',26),('1371629469',192362,'node',26),('1371629412',192359,'node',26),('1371629287',192329,'node',26),('1371629287',192327,'node',26),('hgrx3001gdlenglabnetappcom',98853,'node',26),('hgx36902gdlenglabnetappcom',98854,'node',26),('hgx36904gdlenglabnetappcom',98855,'node',26),('hgrx6001gdlenglabnetappcom',98856,'node',26),('fibre',98857,'node',26),('netapp',98857,'node',26),('netapp',98858,'node',26),('naa60a9800037543261505d424f31325764',98857,'node',26),('disk',98857,'node',26),('channel',98857,'node',26),('naa60a9800037543261505d424f31325768',98858,'node',26),('disk',98858,'node',26),('channel',98858,'node',26),('fibre',98858,'node',26),('naa60a9800037543261553f417839454153',98859,'node',26),('disk',98859,'node',26),('channel',98859,'node',26),('fibre',98859,'node',26),('netapp',98859,'node',26),('naa60a9800037543261553f417839454155',98860,'node',26),('disk',98860,'node',26),('channel',98860,'node',26),('fibre',98860,'node',26),('netapp',98860,'node',26),('naa60a9800037543261505d424f3132564f',98861,'node',26),('disk',98861,'node',26),('channel',98861,'node',26),('fibre',98861,'node',26),('netapp',98861,'node',26),('naa60a9800037543261505d424f31325651',98862,'node',26),('disk',98862,'node',26),('channel',98862,'node',26),('fibre',98862,'node',26),('netapp',98862,'node',26),('channel',98865,'node',26),('fibre',98863,'node',26),('netapp',98863,'node',26),('fibre',98865,'node',26),('netapp',98865,'node',26),('naa60a9800037543261505d424f31325653',98863,'node',26),('disk',98863,'node',26),('channel',98863,'node',26),('naa60a9800037543261505d424f31325731',98864,'node',26),('disk',98864,'node',26),('channel',98864,'node',26),('fibre',98864,'node',26),('netapp',98864,'node',26),('naa60a9800037543261505d424f31325737',98865,'node',26),('disk',98865,'node',26),('naa60a9800037543261553f417839454857',98868,'node',26),('disk',98868,'node',26),('channel',98868,'node',26),('fibre',98868,'node',26),('netapp',98866,'node',26),('netapp',98868,'node',26),('naa60a9800037543261505d424f3132574f',98866,'node',26),('disk',98866,'node',26),('channel',98866,'node',26),('fibre',98866,'node',26),('naa60a9800037543261553f417839454855',98867,'node',26),('disk',98867,'node',26),('channel',98867,'node',26),('fibre',98867,'node',26),('netapp',98867,'node',26),('fibre',98871,'node',26),('netapp',98869,'node',26),('netapp',98871,'node',26),('naa60a9800037543261505d424f31325274',98869,'node',26),('disk',98869,'node',26),('channel',98869,'node',26),('fibre',98869,'node',26),('naa60a9800037543261505d424f31325559',98870,'node',26),('disk',98870,'node',26),('channel',98870,'node',26),('fibre',98870,'node',26),('netapp',98870,'node',26),('fibre',98873,'node',26),('netapp',98873,'node',26),('naa60a9800037543261505d424f31325637',98871,'node',26),('disk',98871,'node',26),('channel',98871,'node',26),('naa60a9800037543261505d424f31325751',98872,'node',26),('disk',98872,'node',26),('channel',98872,'node',26),('fibre',98872,'node',26),('netapp',98872,'node',26),('naa60a9800037543261505d424f31325755',98873,'node',26),('disk',98873,'node',26),('channel',98873,'node',26),('naa60a9800037543261505d424f3132567a',98875,'node',26),('disk',98875,'node',26),('channel',98874,'node',26),('fibre',98874,'node',26),('netapp',98874,'node',26),('channel',98875,'node',26),('fibre',98875,'node',26),('netapp',98875,'node',26),('naa60a9800037543261505d424f31325757',98874,'node',26),('disk',98874,'node',26),('naa60a9800037543261553f41783945462f',98876,'node',26),('disk',98876,'node',26),('channel',98876,'node',26),('fibre',98876,'node',26),('netapp',98876,'node',26),('naa60a9800037543261553f41783945482f',98877,'node',26),('disk',98877,'node',26),('channel',98877,'node',26),('fibre',98877,'node',26),('netapp',98877,'node',26),('disk',98878,'node',26),('channel',98878,'node',26),('fibre',98878,'node',26),('netapp',98878,'node',26),('naa60a9800037543261505d424f31325564',98878,'node',26),('naa60a9800037543261553f41783944524b',98879,'node',26),('disk',98879,'node',26),('iscsi',98879,'node',26),('netapp',98879,'node',26),('naa60a9800037543261553f41783944524d',98880,'node',26),('disk',98880,'node',26),('iscsi',98880,'node',26),('netapp',98880,'node',26),('naa60a9800037543261553f41783944524f',98881,'node',26),('disk',98881,'node',26),('iscsi',98881,'node',26),('netapp',98881,'node',26),('naa60a9800037543261553f417839454159',98882,'node',26),('disk',98882,'node',26),('iscsi',98882,'node',26),('netapp',98882,'node',26),('naa60a9800037543261553f417839445251',98883,'node',26),('disk',98883,'node',26),('iscsi',98883,'node',26),('netapp',98883,'node',26),('naa60a9800037543261553f417839445176',98884,'node',26),('disk',98884,'node',26),('iscsi',98884,'node',26),('netapp',98884,'node',26),('naa60a9800037543261553f417839445253',98885,'node',26),('disk',98885,'node',26),('iscsi',98885,'node',26),('netapp',98885,'node',26),('naa60a9800037543261553f417839445178',98886,'node',26),('disk',98886,'node',26),('iscsi',98886,'node',26),('netapp',98886,'node',26),('naa60a9800037543261553f417839445255',98887,'node',26),('disk',98887,'node',26),('iscsi',98887,'node',26),('netapp',98887,'node',26),('disk',98889,'node',26),('iscsi',98889,'node',26),('netapp',98889,'node',26),('naa60a9800037543261553f41783944517a',98888,'node',26),('disk',98888,'node',26),('iscsi',98888,'node',26),('netapp',98888,'node',26),('naa600a09803c1b589db5363869fc0027d0',98890,'node',26),('disk',98890,'node',26),('scsi',98890,'node',26),('attached',98890,'node',26),('serial',98890,'node',26),('netapp',98890,'node',26),('naa60a9800037543261553f417839454162',98889,'node',26),('scsi',98892,'node',26),('attached',98892,'node',26),('serial',98892,'node',26),('ibmesxs',98892,'node',26),('naa60a9800037543261553f417839445235',98891,'node',26),('disk',98891,'node',26),('iscsi',98891,'node',26),('netapp',98891,'node',26),('naa5000c50041938b37',98892,'node',26),('disk',98892,'node',26),('naa5002538050003d09',98893,'node',26),('disk',98893,'node',26),('scsi',98893,'node',26),('attached',98893,'node',26),('serial',98893,'node',26),('ata',98893,'node',26),('iscsi',98894,'node',26),('netapp',98894,'node',26),('naa60a9800037543261553f417839445245',98894,'node',26),('disk',98894,'node',26),('naa60a9800037543261553f417839445247',98895,'node',26),('disk',98895,'node',26),('iscsi',98895,'node',26),('netapp',98895,'node',26),('naa60a9800037543261505d424f31325568',98898,'node',26),('disk',98898,'node',26),('channel',98898,'node',26),('fibre',98898,'node',26),('naa60a9800037543261553f417839445249',98896,'node',26),('disk',98896,'node',26),('iscsi',98896,'node',26),('netapp',98896,'node',26),('netapp',98898,'node',26),('naa60a9800037543261505d424f31325645',98897,'node',26),('disk',98897,'node',26),('iscsi',98897,'node',26),('netapp',98897,'node',26),('naa60a9800037543261505d424f31325647',98899,'node',26),('disk',98899,'node',26),('iscsi',98899,'node',26),('netapp',98899,'node',26),('channel',98905,'node',26),('fibre',98905,'node',26),('naa60a9800037543261505d424f31325649',98900,'node',26),('disk',98900,'node',26),('iscsi',98900,'node',26),('netapp',98900,'node',26),('netapp',98905,'node',26),('naa60a9800037543261505d424f31325570',98903,'node',26),('disk',98903,'node',26),('ibm',98902,'node',26),('local',98902,'node',26),('naa60a9800037543261505d424f3132556a',98901,'node',26),('disk',98901,'node',26),('channel',98901,'node',26),('fibre',98901,'node',26),('netapp',98901,'node',26),('channel',98903,'node',26),('fibre',98903,'node',26),('netapp',98903,'node',26),('naa600605b0042a0dd01895642016bf17dc',98902,'node',26),('disk',98902,'node',26),('naa60a9800037543261505d424f31325572',98904,'node',26),('disk',98904,'node',26),('channel',98904,'node',26),('fibre',98904,'node',26),('netapp',98904,'node',26),('naa60a9800037543261505d424f31325578',98905,'node',26),('disk',98905,'node',26),('naa60a9800037543261505d424f3132557a',98906,'node',26),('disk',98906,'node',26),('channel',98906,'node',26),('fibre',98906,'node',26),('netapp',98906,'node',26),('naa60a9800037543261505d424f3132554f',98907,'node',26),('disk',98907,'node',26),('channel',98907,'node',26),('fibre',98907,'node',26),('netapp',98907,'node',26),('naa60a9800037543261505d424f31325551',98908,'node',26),('disk',98908,'node',26),('channel',98908,'node',26),('fibre',98908,'node',26),('netapp',98908,'node',26),('naa60a9800037543261505d424f31325553',98909,'node',26),('disk',98909,'node',26),('channel',98909,'node',26),('fibre',98909,'node',26),('netapp',98909,'node',26),('naa60a9800037543261505d424f31325631',98910,'node',26),('disk',98910,'node',26),('channel',98910,'node',26),('fibre',98910,'node',26),('netapp',98910,'node',26),('naa60a9800037543261505d424f31325555',98911,'node',26),('disk',98911,'node',26),('channel',98911,'node',26),('fibre',98911,'node',26),('netapp',98911,'node',26),('naa60a9800037543261505d424f31325633',98912,'node',26),('disk',98912,'node',26),('channel',98912,'node',26),('fibre',98912,'node',26),('netapp',98912,'node',26),('fibre',98913,'node',26),('netapp',98913,'node',26),('naa60a9800037543261505d424f31325557',98913,'node',26),('disk',98913,'node',26),('channel',98913,'node',26),('naa60a9800037543261505d424f31325639',98914,'node',26),('disk',98914,'node',26),('iscsi',98914,'node',26),('netapp',98914,'node',26),('disk',98915,'node',26),('channel',98915,'node',26),('fibre',98915,'node',26),('netapp',98915,'node',26),('naa60a9800037543261505d424f31325670',98915,'node',26),('naa60a9800037543261505d424f31325672',98916,'node',26),('disk',98916,'node',26),('channel',98916,'node',26),('fibre',98916,'node',26),('netapp',98916,'node',26),('naa600605b0042a0dd01916818716e4e397',98917,'node',26),('disk',98917,'node',26),('ibm',98917,'node',26),('local',98917,'node',26),('naa60a9800037543261505d424f31325674',98918,'node',26),('disk',98918,'node',26),('channel',98918,'node',26),('fibre',98918,'node',26),('netapp',98918,'node',26),('netapp',98919,'node',26),('naa600a09809324a93ace0e8370fc013750',98919,'node',26),('disk',98919,'node',26),('scsi',98919,'node',26),('attached',98919,'node',26),('serial',98919,'node',26),('naa60a9800037543261505d424f31325641',98920,'node',26),('disk',98920,'node',26),('iscsi',98920,'node',26),('netapp',98920,'node',26),('naa60a9800037543261505d424f31325643',98921,'node',26),('disk',98921,'node',26),('iscsi',98921,'node',26),('netapp',98921,'node',26),('fibre',98922,'node',26),('netapp',98922,'node',26),('naa60a9800037543261505d424f31325566',98922,'node',26),('disk',98922,'node',26),('channel',98922,'node',26),('naa600a098044307259313f334556393464',98923,'node',26),('disk',98923,'node',26),('channel',98923,'node',26),('fibre',98923,'node',26),('netapp',98923,'node',26),('naa600a098044307259313f334556393465',98924,'node',26),('disk',98924,'node',26),('channel',98924,'node',26),('fibre',98924,'node',26),('netapp',98924,'node',26),('naa600a098044307259313f334556393466',98925,'node',26),('disk',98925,'node',26),('channel',98925,'node',26),('fibre',98925,'node',26),('netapp',98925,'node',26),('naa600a098044307259313f334556393469',98928,'node',26),('disk',98928,'node',26),('channel',98928,'node',26),('fibre',98927,'node',26),('netapp',98927,'node',26),('naa600a098044307259313f334556393467',98926,'node',26),('disk',98926,'node',26),('channel',98926,'node',26),('fibre',98926,'node',26),('netapp',98926,'node',26),('fibre',98928,'node',26),('netapp',98928,'node',26),('naa600a098044307259313f334556393468',98927,'node',26),('disk',98927,'node',26),('channel',98927,'node',26),('naa600a0980939a29efb56946117b03aba2',98929,'node',26),('disk',98929,'node',26),('scsi',98929,'node',26),('attached',98929,'node',26),('serial',98929,'node',26),('netapp',98929,'node',26),('naa600a098044307259313f33455639342d',98930,'node',26),('disk',98930,'node',26),('channel',98930,'node',26),('fibre',98930,'node',26),('netapp',98930,'node',26),('naa600a098044307259313f33455639342f',98931,'node',26),('disk',98931,'node',26),('channel',98931,'node',26),('fibre',98931,'node',26),('netapp',98931,'node',26),('naa600a098044307259313f33455639346a',98932,'node',26),('disk',98932,'node',26),('channel',98932,'node',26),('fibre',98932,'node',26),('netapp',98932,'node',26),('naa600a098044307259313f33455639346b',98933,'node',26),('disk',98933,'node',26),('channel',98933,'node',26),('fibre',98933,'node',26),('netapp',98933,'node',26),('naa600a098044307259313f33455639346c',98934,'node',26),('disk',98934,'node',26),('channel',98934,'node',26),('fibre',98934,'node',26),('netapp',98934,'node',26),('naa600a098044307259313f33455639346d',98935,'node',26),('disk',98935,'node',26),('channel',98935,'node',26),('fibre',98935,'node',26),('netapp',98935,'node',26),('naa600a098044307259313f33455639346e',98936,'node',26),('disk',98936,'node',26),('channel',98936,'node',26),('fibre',98936,'node',26),('netapp',98936,'node',26),('netapp',98937,'node',26),('naa600a098044307259313f33455639346f',98937,'node',26),('disk',98937,'node',26),('channel',98937,'node',26),('fibre',98937,'node',26),('naa600a098044307535732b334571533630',98938,'node',26),('disk',98938,'node',26),('channel',98938,'node',26),('fibre',98938,'node',26),('netapp',98938,'node',26),('naa600a098044307535732b334571533631',98939,'node',26),('disk',98939,'node',26),('channel',98939,'node',26),('fibre',98939,'node',26),('netapp',98939,'node',26),('naa600a098044307535732b334571533632',98940,'node',26),('disk',98940,'node',26),('channel',98940,'node',26),('fibre',98940,'node',26),('netapp',98940,'node',26),('naa600a098044307535732b334571533633',98941,'node',26),('disk',98941,'node',26),('channel',98941,'node',26),('fibre',98941,'node',26),('netapp',98941,'node',26),('naa600a098044307535732b334571533634',98942,'node',26),('disk',98942,'node',26),('channel',98942,'node',26),('fibre',98942,'node',26),('netapp',98942,'node',26),('naa600a098044307535732b334571533635',98943,'node',26),('disk',98943,'node',26),('channel',98943,'node',26),('fibre',98943,'node',26),('netapp',98943,'node',26),('naa600a098044307535732b334571533636',98944,'node',26),('disk',98944,'node',26),('channel',98944,'node',26),('fibre',98944,'node',26),('netapp',98944,'node',26),('naa600a098044307535732b334571533637',98945,'node',26),('disk',98945,'node',26),('channel',98945,'node',26),('fibre',98945,'node',26),('netapp',98945,'node',26),('naa600a098044307535732b334571533638',98946,'node',26),('disk',98946,'node',26),('channel',98946,'node',26),('fibre',98946,'node',26),('netapp',98946,'node',26),('naa600a098044307535732b334571533639',98947,'node',26),('disk',98947,'node',26),('channel',98947,'node',26),('fibre',98947,'node',26),('netapp',98947,'node',26),('naa600a098044307535732b334571533670',98948,'node',26),('disk',98948,'node',26),('channel',98948,'node',26),('fibre',98948,'node',26),('netapp',98948,'node',26),('naa600a098044307535732b334571533671',98949,'node',26),('disk',98949,'node',26),('channel',98949,'node',26),('fibre',98949,'node',26),('netapp',98949,'node',26),('naa600a0980219f29ef2f974c117b04aba2',98950,'node',26),('disk',98950,'node',26),('scsi',98950,'node',26),('attached',98950,'node',26),('serial',98950,'node',26),('netapp',98950,'node',26),('naa600508e07e7261775c39bd2ebac3410f',98951,'node',26),('disk',98951,'node',26),('scsi',98951,'node',26),('attached',98951,'node',26),('serial',98951,'node',26),('lsi',98951,'node',26),('naa600a098044307259313f334556393430',98952,'node',26),('disk',98952,'node',26),('channel',98952,'node',26),('fibre',98952,'node',26),('netapp',98952,'node',26),('hgvcenter01gdlenglabnetappcom',1,'node',1),('nrfgbzniq67sfr4arsbb',1,'node',1),('fmcbariumtest',1,'node',26),('w3j',1,'node',1),('4jd6iwnjnv2hwccrmg',1,'node',1),('1371628867',192221,'node',26),('1371628867',192219,'node',26),('1371628867',192220,'node',26),('1371628867',192218,'node',26),('1371628866',192217,'node',26),('1371628866',192215,'node',26),('1371628866',192216,'node',26),('1371628866',192214,'node',26),('naa600a098044307259313f334556393431',98953,'node',26),('disk',98953,'node',26),('channel',98953,'node',26),('fibre',98953,'node',26),('netapp',98953,'node',26),('netapp',98956,'node',26),('naa600a098044307259313f334556393432',98954,'node',26),('disk',98954,'node',26),('channel',98954,'node',26),('fibre',98954,'node',26),('netapp',98954,'node',26),('naa600a098044307259313f334556393433',98955,'node',26),('disk',98955,'node',26),('channel',98955,'node',26),('fibre',98955,'node',26),('netapp',98955,'node',26),('naa600a098044307259313f334556393434',98956,'node',26),('disk',98956,'node',26),('channel',98956,'node',26),('fibre',98956,'node',26),('naa600a098044307259313f334556393435',98957,'node',26),('disk',98957,'node',26),('channel',98957,'node',26),('fibre',98957,'node',26),('netapp',98957,'node',26),('naa600a098044307259313f334556393436',98958,'node',26),('disk',98958,'node',26),('channel',98958,'node',26),('fibre',98958,'node',26),('netapp',98958,'node',26),('naa600a098044307259313f334556393437',98959,'node',26),('disk',98959,'node',26),('channel',98959,'node',26),('fibre',98959,'node',26),('netapp',98959,'node',26),('channel',98960,'node',26),('fibre',98960,'node',26),('netapp',98960,'node',26),('naa600a098044307259313f334556393438',98960,'node',26),('disk',98960,'node',26),('naa600a098044307259313f334556393439',98961,'node',26),('disk',98961,'node',26),('channel',98961,'node',26),('fibre',98961,'node',26),('netapp',98961,'node',26),('naa600a098044307259313f334556393470',98962,'node',26),('disk',98962,'node',26),('channel',98962,'node',26),('fibre',98962,'node',26),('netapp',98962,'node',26),('naa600a098044307259313f334556393471',98963,'node',26),('disk',98963,'node',26),('channel',98963,'node',26),('fibre',98963,'node',26),('netapp',98963,'node',26),('fibre',98964,'node',26),('netapp',98964,'node',26),('naa600a098044307259313f334556393472',98964,'node',26),('disk',98964,'node',26),('channel',98964,'node',26),('naa600a098044307259313f334556393473',98965,'node',26),('disk',98965,'node',26),('channel',98965,'node',26),('fibre',98965,'node',26),('netapp',98965,'node',26),('naa600a098044307259313f334556393474',98966,'node',26),('disk',98966,'node',26),('channel',98966,'node',26),('fibre',98966,'node',26),('netapp',98966,'node',26),('disk',98967,'node',26),('channel',98967,'node',26),('fibre',98967,'node',26),('netapp',98967,'node',26),('naa600a098044307535732b334571533642',98980,'node',26),('disk',98980,'node',26),('channel',98980,'node',26),('fibre',98968,'node',26),('netapp',98968,'node',26),('naa600a098044307259313f334556393475',98967,'node',26),('fibre',98980,'node',26),('netapp',98980,'node',26),('naa600a098044307535732b334571533565',98979,'node',26),('disk',98979,'node',26),('naa600a098044307259313f334556393476',98968,'node',26),('disk',98968,'node',26),('channel',98968,'node',26),('naa600a098044307259313f334556393478',98970,'node',26),('disk',98970,'node',26),('channel',98970,'node',26),('fibre',98970,'node',26),('netapp',98970,'node',26),('naa600a098044307259313f334556393477',98969,'node',26),('disk',98969,'node',26),('channel',98969,'node',26),('fibre',98969,'node',26),('netapp',98969,'node',26),('channel',98979,'node',26),('fibre',98979,'node',26),('netapp',98979,'node',26),('naa600a098044307535732b334571533641',98978,'node',26),('disk',98978,'node',26),('channel',98978,'node',26),('fibre',98978,'node',26),('netapp',98978,'node',26),('naa600a098044307535732b334571533564',98977,'node',26),('naa600a098044307259313f334556393479',98971,'node',26),('disk',98971,'node',26),('channel',98971,'node',26),('fibre',98971,'node',26),('netapp',98971,'node',26),('naa600a0980b87a29ef1afd4b117b00aba2',98972,'node',26),('disk',98972,'node',26),('scsi',98972,'node',26),('attached',98972,'node',26),('serial',98972,'node',26),('netapp',98972,'node',26),('disk',98977,'node',26),('channel',98977,'node',26),('naa600a098044307259313f33455639347a',98973,'node',26),('disk',98973,'node',26),('channel',98973,'node',26),('fibre',98973,'node',26),('netapp',98973,'node',26),('fibre',98977,'node',26),('netapp',98977,'node',26),('naa600a098044307535732b334571533562',98975,'node',26),('disk',98975,'node',26),('channel',98975,'node',26),('fibre',98975,'node',26),('netapp',98975,'node',26),('naa600a098044307535732b334571533561',98974,'node',26),('disk',98974,'node',26),('channel',98974,'node',26),('fibre',98974,'node',26),('netapp',98974,'node',26),('naa600a098044307535732b334571533563',98976,'node',26),('disk',98976,'node',26),('channel',98976,'node',26),('fibre',98976,'node',26),('netapp',98976,'node',26),('naa600a098044307535732b334571533566',98981,'node',26),('disk',98981,'node',26),('channel',98981,'node',26),('fibre',98981,'node',26),('netapp',98981,'node',26),('naa600a098044307535732b334571533643',98982,'node',26),('disk',98982,'node',26),('channel',98982,'node',26),('fibre',98982,'node',26),('netapp',98982,'node',26),('naa600a098044307535732b334571533644',98983,'node',26),('disk',98983,'node',26),('channel',98983,'node',26),('fibre',98983,'node',26),('netapp',98983,'node',26),('naa600a098044307535732b334571533567',98984,'node',26),('disk',98984,'node',26),('channel',98984,'node',26),('fibre',98984,'node',26),('netapp',98984,'node',26),('naa600a098044307535732b334571533645',98985,'node',26),('disk',98985,'node',26),('channel',98985,'node',26),('fibre',98985,'node',26),('netapp',98985,'node',26),('naa600a098044307535732b334571533568',98986,'node',26),('disk',98986,'node',26),('channel',98986,'node',26),('fibre',98986,'node',26),('netapp',98986,'node',26),('naa600a098044307535732b334571533646',98987,'node',26),('disk',98987,'node',26),('channel',98987,'node',26),('fibre',98987,'node',26),('netapp',98987,'node',26),('naa600a098044307535732b334571533569',98988,'node',26),('disk',98988,'node',26),('channel',98988,'node',26),('fibre',98988,'node',26),('netapp',98988,'node',26),('naa600a098044307535732b334571533573',99037,'node',26),('disk',99037,'node',26),('channel',99037,'node',26),('fibre',99037,'node',26),('netapp',99037,'node',26),('fibre',98989,'node',26),('netapp',98989,'node',26),('fibre',98990,'node',26),('netapp',98990,'node',26),('naa600a098044307535732b334571533647',98989,'node',26),('disk',98989,'node',26),('channel',98989,'node',26),('naa600a098044307535732b334571533650',99036,'node',26),('naa600a098044307535732b334571533648',98990,'node',26),('disk',98990,'node',26),('channel',98990,'node',26),('naa600a098044307535732b334571533649',98991,'node',26),('disk',98991,'node',26),('channel',98991,'node',26),('fibre',98991,'node',26),('netapp',98991,'node',26),('naa600a098044307535732b33457153356a',98992,'node',26),('disk',98992,'node',26),('channel',98992,'node',26),('fibre',98992,'node',26),('netapp',98992,'node',26),('disk',99036,'node',26),('channel',99036,'node',26),('fibre',99036,'node',26),('netapp',99036,'node',26),('naa600a098044307535732b334571533572',99035,'node',26),('naa600a098044307535732b33457153356b',98993,'node',26),('disk',98993,'node',26),('channel',98993,'node',26),('fibre',98993,'node',26),('netapp',98993,'node',26),('naa600a098044307535732b33457153356c',98994,'node',26),('disk',98994,'node',26),('channel',98994,'node',26),('fibre',98994,'node',26),('netapp',98994,'node',26),('naa600a098044307535732b33457153356d',98995,'node',26),('disk',98995,'node',26),('channel',98995,'node',26),('fibre',98995,'node',26),('netapp',98995,'node',26),('naa600a098044307535732b33457153364a',98996,'node',26),('disk',98996,'node',26),('channel',98996,'node',26),('fibre',98996,'node',26),('netapp',98996,'node',26),('naa600a098044307535732b33457153356e',98997,'node',26),('disk',98997,'node',26),('channel',98997,'node',26),('fibre',98997,'node',26),('netapp',98997,'node',26),('naa600a098044307535732b33457153364b',98998,'node',26),('disk',98998,'node',26),('channel',98998,'node',26),('fibre',98998,'node',26),('netapp',98998,'node',26),('naa600a098044307535732b33457153356f',98999,'node',26),('disk',98999,'node',26),('channel',98999,'node',26),('fibre',98999,'node',26),('netapp',98999,'node',26),('disk',99035,'node',26),('channel',99035,'node',26),('fibre',99035,'node',26),('netapp',99035,'node',26),('fibre',99000,'node',26),('netapp',99000,'node',26),('naa600a098044307535732b334571533571',99034,'node',26),('netapp',99001,'node',26),('naa600a098044307535732b33457153364c',99000,'node',26),('disk',99000,'node',26),('channel',99000,'node',26),('disk',99034,'node',26),('naa600a098044307535732b33457153364d',99001,'node',26),('disk',99001,'node',26),('channel',99001,'node',26),('fibre',99001,'node',26),('naa600a098044307535732b33457153364e',99002,'node',26),('disk',99002,'node',26),('channel',99002,'node',26),('fibre',99002,'node',26),('netapp',99002,'node',26),('naa600a098044307535732b33457153364f',99003,'node',26),('disk',99003,'node',26),('channel',99003,'node',26),('fibre',99003,'node',26),('netapp',99003,'node',26),('channel',99034,'node',26),('fibre',99034,'node',26),('fibre',99032,'node',26),('disk',99004,'node',26),('channel',99004,'node',26),('fibre',99004,'node',26),('netapp',99004,'node',26),('netapp',99032,'node',26),('naa600a098044307259313f33455638724e',99031,'node',26),('naa600a098044307259313f334556393441',99004,'node',26),('naa600a098044307259313f334556393442',99005,'node',26),('disk',99005,'node',26),('channel',99005,'node',26),('fibre',99005,'node',26),('netapp',99005,'node',26),('naa600a098044307259313f334556393443',99006,'node',26),('disk',99006,'node',26),('channel',99006,'node',26),('fibre',99006,'node',26),('netapp',99006,'node',26),('disk',99031,'node',26),('channel',99031,'node',26),('fibre',99031,'node',26),('disk',99007,'node',26),('channel',99007,'node',26),('fibre',99007,'node',26),('netapp',99007,'node',26),('netapp',99031,'node',26),('naa600a098044307259313f33455638724d',99030,'node',26),('disk',99030,'node',26),('naa600a098044307535732b33457152752d',99007,'node',26),('naa600a098044307259313f334556393444',99008,'node',26),('disk',99008,'node',26),('channel',99008,'node',26),('fibre',99008,'node',26),('netapp',99008,'node',26),('channel',99030,'node',26),('fibre',99030,'node',26),('naa600a098044307259313f334556393448',99012,'node',26),('naa600a098044307259313f334556393445',99009,'node',26),('disk',99012,'node',26),('channel',99012,'node',26),('fibre',99012,'node',26),('netapp',99012,'node',26),('naa600a098044307259313f334556393446',99010,'node',26),('naa600a098044307259313f334556393447',99011,'node',26),('disk',99011,'node',26),('channel',99011,'node',26),('fibre',99011,'node',26),('netapp',99011,'node',26),('naa600a098044307259313f334556393449',99013,'node',26),('disk',99013,'node',26),('channel',99013,'node',26),('fibre',99013,'node',26),('netapp',99013,'node',26),('naa600a098044307259313f334556387243',99014,'node',26),('disk',99014,'node',26),('channel',99014,'node',26),('fibre',99014,'node',26),('netapp',99014,'node',26),('naa600a098044307259313f334556387244',99015,'node',26),('disk',99015,'node',26),('channel',99015,'node',26),('fibre',99015,'node',26),('netapp',99015,'node',26),('naa600a098044307259313f334556387245',99016,'node',26),('disk',99016,'node',26),('channel',99016,'node',26),('fibre',99016,'node',26),('netapp',99016,'node',26),('netapp',99030,'node',26),('naa600a098044307259313f33455638724c',99029,'node',26),('disk',99029,'node',26),('channel',99029,'node',26),('netapp',99017,'node',26),('fibre',99029,'node',26),('naa600a098044307259313f334556387246',99017,'node',26),('disk',99017,'node',26),('channel',99017,'node',26),('fibre',99017,'node',26),('naa600a098044307259313f334556387247',99018,'node',26),('disk',99018,'node',26),('channel',99018,'node',26),('fibre',99018,'node',26),('netapp',99018,'node',26),('naa600a098044307259313f334556387248',99019,'node',26),('disk',99019,'node',26),('channel',99019,'node',26),('fibre',99019,'node',26),('netapp',99019,'node',26),('naa600a098044307259313f334556387249',99020,'node',26),('disk',99020,'node',26),('channel',99020,'node',26),('fibre',99020,'node',26),('netapp',99020,'node',26),('naa600a098044307259313f33455639344a',99021,'node',26),('disk',99021,'node',26),('channel',99021,'node',26),('fibre',99021,'node',26),('netapp',99021,'node',26),('naa600a098044307259313f33455639344b',99022,'node',26),('disk',99022,'node',26),('channel',99022,'node',26),('fibre',99022,'node',26),('netapp',99022,'node',26),('netapp',99029,'node',26),('naa600a098044307259313f33455638724b',99028,'node',26),('disk',99028,'node',26),('channel',99028,'node',26),('fibre',99028,'node',26),('naa600a098044307259313f33455639344c',99023,'node',26),('disk',99023,'node',26),('channel',99023,'node',26),('fibre',99023,'node',26),('netapp',99023,'node',26),('naa600a098044307259313f33455639344d',99024,'node',26),('disk',99024,'node',26),('channel',99024,'node',26),('fibre',99024,'node',26),('netapp',99024,'node',26),('netapp',99028,'node',26),('naa600a098044307259313f33455638724a',99027,'node',26),('disk',99027,'node',26),('naa600a098044307259313f33455639344e',99025,'node',26),('disk',99025,'node',26),('channel',99025,'node',26),('fibre',99025,'node',26),('netapp',99025,'node',26),('channel',99027,'node',26),('fibre',99027,'node',26),('netapp',99027,'node',26),('naa600a098044307259313f33455639344f',99026,'node',26),('disk',99026,'node',26),('channel',99026,'node',26),('fibre',99026,'node',26),('netapp',99026,'node',26),('netapp',99034,'node',26),('naa600a098044307535732b334571533570',99033,'node',26),('disk',99033,'node',26),('channel',99033,'node',26),('fibre',99033,'node',26),('netapp',99033,'node',26),('naa600a098044307259313f33455638724f',99032,'node',26),('disk',99032,'node',26),('channel',99032,'node',26),('naa600a098044307535732b334571533651',99038,'node',26),('disk',99038,'node',26),('channel',99038,'node',26),('fibre',99038,'node',26),('netapp',99038,'node',26),('naa600a098044307535732b334571533574',99039,'node',26),('disk',99039,'node',26),('channel',99039,'node',26),('fibre',99039,'node',26),('netapp',99039,'node',26),('naa600a098044307535732b334571533652',99040,'node',26),('disk',99040,'node',26),('channel',99040,'node',26),('fibre',99040,'node',26),('netapp',99040,'node',26),('naa600a098044307535732b334571533575',99041,'node',26),('disk',99041,'node',26),('channel',99041,'node',26),('fibre',99041,'node',26),('netapp',99041,'node',26),('naa600a098044307535732b334571533653',99042,'node',26),('disk',99042,'node',26),('channel',99042,'node',26),('fibre',99042,'node',26),('netapp',99042,'node',26),('naa600a098044307535732b334571533576',99043,'node',26),('disk',99043,'node',26),('channel',99043,'node',26),('fibre',99043,'node',26),('netapp',99043,'node',26),('naa600a098044307535732b334571533577',99044,'node',26),('disk',99044,'node',26),('channel',99044,'node',26),('fibre',99044,'node',26),('netapp',99044,'node',26),('naa600a098044307535732b334571533654',99045,'node',26),('disk',99045,'node',26),('channel',99045,'node',26),('fibre',99045,'node',26),('netapp',99045,'node',26),('naa600a098044307535732b334571533578',99046,'node',26),('disk',99046,'node',26),('channel',99046,'node',26),('fibre',99046,'node',26),('netapp',99046,'node',26),('naa600a098044307535732b334571533655',99047,'node',26),('disk',99047,'node',26),('channel',99047,'node',26),('fibre',99047,'node',26),('netapp',99047,'node',26),('naa600a098044307535732b334571533579',99048,'node',26),('disk',99048,'node',26),('channel',99048,'node',26),('fibre',99048,'node',26),('netapp',99048,'node',26),('naa600a098044307535732b334571533656',99049,'node',26),('disk',99049,'node',26),('channel',99049,'node',26),('fibre',99049,'node',26),('netapp',99049,'node',26),('naa600a098044307535732b334571533657',99050,'node',26),('disk',99050,'node',26),('channel',99050,'node',26),('fibre',99050,'node',26),('netapp',99050,'node',26),('naa600a098044307535732b334571533658',99051,'node',26),('disk',99051,'node',26),('channel',99051,'node',26),('fibre',99051,'node',26),('netapp',99051,'node',26),('naa600a098044307535732b334571533659',99052,'node',26),('disk',99052,'node',26),('channel',99052,'node',26),('fibre',99052,'node',26),('netapp',99052,'node',26),('1371221042',127626,'node',26),('10000',127630,'node',1),('1371221042',127627,'node',26),('1371221102',127630,'node',26),('naa600a098044307259313f334556393463',99123,'node',26),('disk',99123,'node',26),('channel',99123,'node',26),('fibre',99123,'node',26),('netapp',99123,'node',26),('naa600a098044307535732b33457152754b',99121,'node',26),('disk',99121,'node',26),('channel',99121,'node',26),('fibre',99121,'node',26),('netapp',99121,'node',26),('naa600a098044307535732b33457152754a',99119,'node',26),('disk',99119,'node',26),('channel',99118,'node',26),('fibre',99118,'node',26),('netapp',99118,'node',26),('naa600a098044307535732b33457153366d',99116,'node',26),('disk',99116,'node',26),('channel',99116,'node',26),('fibre',99116,'node',26),('netapp',99116,'node',26),('naa600a098044307535732b33457153366b',99114,'node',26),('disk',99114,'node',26),('channel',99114,'node',26),('fibre',99114,'node',26),('netapp',99114,'node',26),('naa600a098044307535732b33457153362f',99112,'node',26),('disk',99112,'node',26),('channel',99112,'node',26),('fibre',99112,'node',26),('netapp',99111,'node',26),('naa600a098044307535732b334571527549',99110,'node',26),('disk',99109,'node',26),('channel',99109,'node',26),('fibre',99109,'node',26),('netapp',99109,'node',26),('naa600a098044307535732b334571527546',99107,'node',26),('disk',99107,'node',26),('channel',99107,'node',26),('fibre',99107,'node',26),('netapp',99107,'node',26),('naa600a098044307535732b334571527544',99105,'node',26),('disk',99105,'node',26),('channel',99105,'node',26),('fibre',99105,'node',26),('netapp',99105,'node',26),('naa600a098044307535732b334571527542',99103,'node',26),('disk',99103,'node',26),('channel',99103,'node',26),('naa600a098044307535732b334571533669',99101,'node',26),('disk',99101,'node',26),('channel',99101,'node',26),('naa600a098044307535732b334571533667',99099,'node',26),('disk',99099,'node',26),('fibre',99098,'node',26),('netapp',99098,'node',26),('naa600a098044307259313f33455639345a',99092,'node',26),('disk',99092,'node',26),('channel',99092,'node',26),('fibre',99092,'node',26),('netapp',99092,'node',26),('naa600a0980659529efd63544117b01aba2',99090,'node',26),('disk',99090,'node',26),('scsi',99090,'node',26),('attached',99090,'node',26),('serial',99090,'node',26),('netapp',99090,'node',26),('naa600a098044307259313f334556387251',99088,'node',26),('disk',99088,'node',26),('channel',99088,'node',26),('fibre',99088,'node',26),('netapp',99088,'node',26),('naa600a098044307259313f334556393459',99086,'node',26),('disk',99086,'node',26),('channel',99086,'node',26),('fibre',99086,'node',26),('netapp',99086,'node',26),('naa600a098044307259313f334556393457',99084,'node',26),('disk',99084,'node',26),('channel',99084,'node',26),('fibre',99084,'node',26),('netapp',99084,'node',26),('naa600a098044307259313f334556393456',99082,'node',26),('disk',99082,'node',26),('channel',99082,'node',26),('fibre',99082,'node',26),('netapp',99082,'node',26),('naa600a098044307259313f334556393379',99080,'node',26),('disk',99080,'node',26),('channel',99080,'node',26),('fibre',99080,'node',26),('netapp',99080,'node',26),('naa600a098044307259313f334556393532',99078,'node',26),('disk',99078,'node',26),('channel',99078,'node',26),('fibre',99078,'node',26),('netapp',99078,'node',26),('naa600a098044307259313f334556393454',99076,'node',26),('disk',99076,'node',26),('channel',99076,'node',26),('fibre',99076,'node',26),('netapp',99075,'node',26),('naa600a098044307259313f334556393377',99074,'node',26),('disk',99074,'node',26),('channel',99074,'node',26),('fibre',99073,'node',26),('netapp',99073,'node',26),('naa600a098044307259313f334556393530',99072,'node',26),('disk',99072,'node',26),('channel',99071,'node',26),('fibre',99071,'node',26),('netapp',99071,'node',26),('naa600a098044307259313f334556393375',99069,'node',26),('disk',99069,'node',26),('channel',99069,'node',26),('fibre',99069,'node',26),('netapp',99069,'node',26),('naa600a098044307259313f334556393374',99067,'node',26),('disk',99067,'node',26),('channel',99067,'node',26),('fibre',99067,'node',26),('netapp',99067,'node',26),('naa600a098044307259313f334556393373',99065,'node',26),('disk',99065,'node',26),('channel',99065,'node',26),('fibre',99065,'node',26),('netapp',99065,'node',26),('naa600a098044307259313f334556393371',99063,'node',26),('disk',99063,'node',26),('channel',99063,'node',26),('fibre',99063,'node',26),('netapp',99063,'node',26),('naa600a098044307535732b33457153365a',99061,'node',26),('disk',99061,'node',26),('channel',99061,'node',26),('fibre',99061,'node',26),('fasanity01w2k8r2',98845,'node',26),('fasanity03w2k8r2',98842,'node',26),('netapp',99061,'node',26),('naa600a098044307535732b334571527539',99059,'node',26),('disk',99059,'node',26),('x36903vm0',98846,'node',26),('channel',99059,'node',26),('fibre',99059,'node',26),('netapp',99059,'node',26),('naa600a098044307535732b334571527537',99057,'node',26),('disk',99057,'node',26),('channel',99057,'node',26),('fibre',99057,'node',26),('serial',99056,'node',26),('netapp',99056,'node',26),('naa600a098044307535732b334571527536',99055,'node',26),('disk',99055,'node',26),('channel',99054,'node',26),('fibre',99054,'node',26),('netapp',99054,'node',26),('naa600a098044307535732b334571527534',99053,'node',26),('disk',99053,'node',26),('channel',99053,'node',26),('fibre',99053,'node',26),('netapp',99053,'node',26),('hgrx3009gdlenglabnetappcom',98852,'node',26),('channel',99055,'node',26),('fibre',99055,'node',26),('netapp',99055,'node',26),('naa600a098044307535732b334571527535',99054,'node',26),('disk',99054,'node',26),('netapp',99057,'node',26),('naa600a0980629929ef780f45117b02aba2',99056,'node',26),('disk',99056,'node',26),('scsi',99056,'node',26),('attached',99056,'node',26),('naa600a098044307535732b334571527538',99058,'node',26),('disk',99058,'node',26),('channel',99058,'node',26),('fibre',99058,'node',26),('netapp',99058,'node',26),('naa600a098044307535732b33457153357a',99060,'node',26),('disk',99060,'node',26),('channel',99060,'node',26),('fibre',99060,'node',26),('netapp',99060,'node',26),('naa600a098044307259313f334556393370',99062,'node',26),('disk',99062,'node',26),('channel',99062,'node',26),('fibre',99062,'node',26),('netapp',99062,'node',26),('naa600a098044307259313f334556393372',99064,'node',26),('disk',99064,'node',26),('channel',99064,'node',26),('fibre',99064,'node',26),('netapp',99064,'node',26),('naa600a098044307259313f334556393450',99066,'node',26),('disk',99066,'node',26),('channel',99066,'node',26),('fibre',99066,'node',26),('netapp',99066,'node',26),('naa600a098044307259313f334556393451',99068,'node',26),('disk',99068,'node',26),('channel',99068,'node',26),('fibre',99068,'node',26),('netapp',99068,'node',26),('naa600a098044307259313f334556393452',99070,'node',26),('disk',99070,'node',26),('channel',99070,'node',26),('fibre',99070,'node',26),('netapp',99070,'node',26),('channel',99072,'node',26),('fibre',99072,'node',26),('netapp',99072,'node',26),('naa600a098044307259313f334556393376',99071,'node',26),('disk',99071,'node',26),('fibre',99074,'node',26),('netapp',99074,'node',26),('naa600a098044307259313f334556393453',99073,'node',26),('disk',99073,'node',26),('channel',99073,'node',26),('netapp',99076,'node',26),('naa600a098044307259313f334556393531',99075,'node',26),('disk',99075,'node',26),('channel',99075,'node',26),('fibre',99075,'node',26),('naa600a098044307259313f334556393378',99077,'node',26),('disk',99077,'node',26),('channel',99077,'node',26),('fibre',99077,'node',26),('netapp',99077,'node',26),('naa600a098044307259313f334556393455',99079,'node',26),('disk',99079,'node',26),('channel',99079,'node',26),('fibre',99079,'node',26),('netapp',99079,'node',26),('naa600a098044307259313f334556393533',99081,'node',26),('disk',99081,'node',26),('channel',99081,'node',26),('fibre',99081,'node',26),('netapp',99081,'node',26),('naa600a098044307259313f334556393534',99083,'node',26),('disk',99083,'node',26),('channel',99083,'node',26),('fibre',99083,'node',26),('netapp',99083,'node',26),('naa600a098044307259313f334556393458',99085,'node',26),('disk',99085,'node',26),('channel',99085,'node',26),('fibre',99085,'node',26),('netapp',99085,'node',26),('naa600a098044307259313f334556387250',99087,'node',26),('disk',99087,'node',26),('channel',99087,'node',26),('fibre',99087,'node',26),('netapp',99087,'node',26),('naa600a098044307259313f334556387252',99089,'node',26),('disk',99089,'node',26),('channel',99089,'node',26),('fibre',99089,'node',26),('netapp',99089,'node',26),('naa600a098044307259313f33455639337a',99091,'node',26),('disk',99091,'node',26),('channel',99091,'node',26),('fibre',99091,'node',26),('netapp',99091,'node',26),('naa600a098044307535732b334571533662',99094,'node',26),('disk',99094,'node',26),('channel',99094,'node',26),('fibre',99094,'node',26),('netapp',99094,'node',26),('naa600a098044307535732b334571533661',99093,'node',26),('disk',99093,'node',26),('channel',99093,'node',26),('fibre',99093,'node',26),('netapp',99093,'node',26),('disk',99096,'node',26),('channel',99096,'node',26),('fibre',99096,'node',26),('netapp',99096,'node',26),('naa600a098044307535732b334571533663',99095,'node',26),('disk',99095,'node',26),('channel',99095,'node',26),('fibre',99095,'node',26),('netapp',99095,'node',26),('naa600a098044307535732b334571533665',99097,'node',26),('disk',99097,'node',26),('channel',99097,'node',26),('fibre',99097,'node',26),('netapp',99097,'node',26),('naa600a098044307535732b334571533664',99096,'node',26),('channel',99099,'node',26),('fibre',99099,'node',26),('netapp',99099,'node',26),('naa600a098044307535732b334571533666',99098,'node',26),('disk',99098,'node',26),('channel',99098,'node',26),('fibre',99101,'node',26),('netapp',99101,'node',26),('naa600a098044307535732b334571533668',99100,'node',26),('disk',99100,'node',26),('channel',99100,'node',26),('fibre',99100,'node',26),('netapp',99100,'node',26),('fibre',99103,'node',26),('netapp',99103,'node',26),('naa600a098044307535732b334571527541',99102,'node',26),('disk',99102,'node',26),('channel',99102,'node',26),('fibre',99102,'node',26),('netapp',99102,'node',26),('naa600a098044307535732b334571527543',99104,'node',26),('disk',99104,'node',26),('channel',99104,'node',26),('fibre',99104,'node',26),('netapp',99104,'node',26),('naa600a098044307535732b334571527545',99106,'node',26),('disk',99106,'node',26),('channel',99106,'node',26),('fibre',99106,'node',26),('netapp',99106,'node',26),('naa600a098044307535732b334571527547',99108,'node',26),('disk',99108,'node',26),('channel',99108,'node',26),('fibre',99108,'node',26),('netapp',99108,'node',26),('disk',99110,'node',26),('channel',99110,'node',26),('fibre',99110,'node',26),('netapp',99110,'node',26),('naa600a098044307535732b334571527548',99109,'node',26),('netapp',99112,'node',26),('naa600a098044307535732b33457153362d',99111,'node',26),('disk',99111,'node',26),('channel',99111,'node',26),('fibre',99111,'node',26),('naa600a098044307535732b33457153366a',99113,'node',26),('disk',99113,'node',26),('channel',99113,'node',26),('fibre',99113,'node',26),('netapp',99113,'node',26),('naa600a098044307535732b33457153366c',99115,'node',26),('disk',99115,'node',26),('channel',99115,'node',26),('fibre',99115,'node',26),('netapp',99115,'node',26),('naa600a098044307535732b33457153366e',99117,'node',26),('disk',99117,'node',26),('channel',99117,'node',26),('fibre',99117,'node',26),('netapp',99117,'node',26),('channel',99119,'node',26),('fibre',99119,'node',26),('netapp',99119,'node',26),('naa600a098044307535732b33457153366f',99118,'node',26),('disk',99118,'node',26),('naa600a098044307259313f334556393461',99120,'node',26),('disk',99120,'node',26),('channel',99120,'node',26),('fibre',99120,'node',26),('netapp',99120,'node',26),('naa600a098044307259313f334556393462',99122,'node',26),('disk',99122,'node',26),('channel',99122,'node',26),('fibre',99122,'node',26),('netapp',99122,'node',26),('598856',99127,'node',1),('598856',99124,'node',1),('1',99124,'node',1),('custom',99124,'node',1),('hgw2k8r232vm2',99124,'node',26),('hgw2k8r232vm4',99126,'node',26),('598856',99125,'node',1),('1',99125,'node',1),('custom',99125,'node',1),('hgw2k8r232vm3',99125,'node',26),('1',99127,'node',1),('custom',99127,'node',1),('hgw2k8r232vm5',99127,'node',26),('598856',99126,'node',1),('1',99126,'node',1),('custom',99126,'node',1),('1',99129,'node',1),('custom',99129,'node',1),('hgw2k8r232vm1',99129,'node',26),('hgw2k8r232vm6',99128,'node',26),('hgw2k8r232vm7',99130,'node',26),('598856',99129,'node',1),('naa6000c2902d5ba8be5966051779f73945',99145,'node',26),('hgw2k8r232vm9',99132,'node',26),('hgw2k8r232vm8',99131,'node',26),('naa600a098044307259313f334556393437',99135,'node',26),('naa6000c299242f2fcb24b70a806cfd6483',99134,'node',26),('hgw2k8r232vm10',99133,'node',26),('naa600a098044307535732b334571533574',99138,'node',26),('naa600a098044307259313f334556393438',99137,'node',26),('naa600a098044307535732b334571533573',99136,'node',26),('naa6000c29b3222956854879461dd964e80',99141,'node',26),('naa6000c29a765bf9dd27349f08fccc80c9',99140,'node',26),('naa6000c296b36c887ceec41b5e40543c63',99139,'node',26),('naa6000c29532d9e75758061ca5a90c3743',99144,'node',26),('naa6000c29362e532d0433c7b0f3f444807',99143,'node',26),('naa6000c292e0633db9e8f9555d658ad2ca',99142,'node',26),('1371220982',127622,'node',26),('1371220982',127623,'node',26),('1371628749',192184,'node',26),('1371628749',192187,'node',26),('1371628749',192185,'node',26),('1371628749',192186,'node',26),('1371628749',192188,'node',26),('1371628749',192190,'node',26),('1371628749',192189,'node',26),('x36903vm1',98847,'node',26),('1371597064',178704,'node',26),('1651',178704,'node',1),('1476',178705,'node',1),('1371597064',178705,'node',26),('1621',178703,'node',1),('1371597064',178703,'node',26),('1643',178702,'node',1),('1371597064',178702,'node',26),('1581',178700,'node',1),('1371597063',178700,'node',26),('1664',178699,'node',1),('1371597063',178699,'node',26),('1539',178695,'node',1),('1371597063',178695,'node',26),('1624',178696,'node',1),('1371597063',178696,'node',26),('1571',178698,'node',1),('1371597063',178698,'node',26),('1344',178697,'node',1),('1371597063',178697,'node',26),('1585',178694,'node',1),('1371597063',178694,'node',26),('1574',178693,'node',1),('1371597063',178693,'node',26),('1371597005',178690,'node',26),('1371597004',178688,'node',26),('1371597004',178686,'node',26),('1371597004',178684,'node',26),('1371597004',178683,'node',26),('1580',178677,'node',1),('1371597003',178677,'node',26),('1605',178676,'node',1),('1371597003',178676,'node',26),('1498',178678,'node',1),('1371597003',178678,'node',26),('1371597004',178682,'node',26),('942',178680,'node',1),('1371597004',178680,'node',26),('1431',178675,'node',1),('1371597003',178675,'node',26),('1371596945',178652,'node',26),('1371596945',178651,'node',26),('1371596945',178655,'node',26),('1371596945',178653,'node',26),('1371596946',178657,'node',26),('1548',178662,'node',1),('1371597002',178662,'node',26),('1371596946',178659,'node',26),('1587',178663,'node',1),('1371597002',178663,'node',26),('1573',178664,'node',1),('1371597002',178664,'node',26),('1585',178644,'node',1),('1371596944',178644,'node',26),('1646',178602,'node',1),('1371596882',178602,'node',26),('1432',178603,'node',1),('1371596882',178603,'node',26),('1649',178605,'node',1),('1371596882',178605,'node',26),('1673',178604,'node',1),('1371596882',178604,'node',26),('1465',178606,'node',1),('1371596882',178606,'node',26),('1650',178609,'node',1),('1371596883',178609,'node',26),('1649',178607,'node',1),('1371596882',178607,'node',26),('1479',178610,'node',1),('1371596883',178610,'node',26),('1371596826',178597,'node',26),('naa6000c296c4b84cf9c023f5bd4f7ed00f',99181,'node',26),('naa6000c292dc5b74eeed4bd44591340e16',99165,'node',26),('naa6000c297f078b46cc95f683d3fad2304',99158,'node',26),('naa6000c29659d5ed1d994feb862b35f563',99157,'node',26),('naa6000c29509fa9ac43eb732b1b2d9a0f4',99156,'node',26),('naa6000c2925e6758884ac57c7ae894ee86',99155,'node',26),('naa6000c29909baac34d177a4a3840328b8',99154,'node',26),('naa6000c291630bfde3725bb05887739ba8',99153,'node',26),('naa6000c29475b97b7e2d72ab1a29ba04a0',99152,'node',26),('naa6000c290a1e6f7dcd64bad2f0508e1ea',99151,'node',26),('naa6000c294e3b594ec724e3a4db1a4516c',99150,'node',26),('naa6000c2983a5286249c37e5d021904aaa',99149,'node',26),('naa6000c29dc66f186790f6c654494feb0f',99148,'node',26),('naa6000c29a2edac2d4e7c2f015ced57b68',99147,'node',26),('naa6000c293d27251a8a3f12accfb90bfc3',99146,'node',26),('naa6000c295e3f8a5d4112eea72713dafc7',99161,'node',26),('naa6000c290b447224a367ae88729a10481',99160,'node',26),('naa6000c292da51f1aa36aa0f8f36ab63a1',99159,'node',26),('naa6000c2973fc357862a1d1f9aad0ee35d',99164,'node',26),('naa6000c29625d808ede952e2c058cf1a34',99163,'node',26),('naa6000c2928d3847de8b714947ebe88135',99162,'node',26),('naa6000c29b9d27250346d3e0286ee28a49',99168,'node',26),('naa6000c291ad1e480ea3b8d793ff8001cd',99167,'node',26),('naa6000c29c21bb973e92f998bea193dd18',99166,'node',26),('naa6000c294c5800706fe07fe7bdec0b542',99171,'node',26),('naa6000c29a50c74f6a4499cc613e475ef4',99170,'node',26),('naa6000c29b45fb593085a2c48782b02044',99169,'node',26),('naa6000c29581ab8a2d1e213ab7a5097f25',99174,'node',26),('naa6000c29929cb6278386c2319ec3c3b6e',99173,'node',26),('naa6000c2965ca4cd7c53811704f77b5d65',99172,'node',26),('naa6000c29e2682f4db15114dd9441e9c15',99177,'node',26),('naa6000c29f674e59273634ef0b579e36b7',99176,'node',26),('naa6000c2979d4a269d6872562552952c80',99175,'node',26),('naa6000c29f57cc968bfbb545dbf20a1886',99180,'node',26),('naa6000c2930690849f0f027e2bdea15971',99179,'node',26),('naa6000c29047896a98adc870dfbebaeac2',99178,'node',26),('naa6000c29859fd519d867292b2a206e338',99184,'node',26),('naa6000c29ca95433a3c26ac5006f2c6bbf',99183,'node',26),('naa6000c29548b21a50f8567f2f98d65703',99182,'node',26),('naa6000c29efdea6383c636eb6f5293bb18',99187,'node',26),('naa6000c29be9c8af40d3e0d5938c1f980e',99186,'node',26),('naa6000c294b2c528ee471899a0c8328b4b',99185,'node',26),('naa6000c29d7c364b06ded47c1f570bc2e3',99190,'node',26),('naa6000c29c50c16277f5b82ee57335fc8a',99189,'node',26),('naa6000c299fb242f20bd0dcbf875123360',99188,'node',26),('naa6000c2962f4f2ea11e8380e978daf567',99192,'node',26),('naa6000c294d1df893cff4138d2e478e299',99191,'node',26),('naa6000c29a54a9df10c14901abe20b4848',99244,'node',26),('naa6000c29210632526769e22c7c31ff326',99228,'node',26),('naa6000c29a137ba86b53498f0230152ba2',99212,'node',26),('hgw2k8r232vm11',99193,'node',26),('naa600a098044307535732b334571533575',99196,'node',26),('naa6000c29a9b11305673146d99b450723c',99195,'node',26),('hgw2k8r232vm12',99194,'node',26),('naa600a098044307259313f334556393439',99199,'node',26),('naa600a098044307535732b334571533576',99198,'node',26),('naa600a098044307259313f33455639342d',99197,'node',26),('naa6000c29e353d1df472e29083d0de0077',99202,'node',26),('naa6000c29e3371e54aa56bb0971032e089',99201,'node',26),('naa6000c29dd17f56e30f12a86aa07ef6da',99200,'node',26),('naa6000c291737bb4cb6f8e9f8eb55ff3fe',99205,'node',26),('naa6000c29891c7bfbf1d5b509415e5e8e9',99204,'node',26),('naa6000c2960b02c3a9e54eda5f394a838a',99203,'node',26),('naa6000c294223f07cf9331c3fa76649fc0',99208,'node',26),('naa6000c293b01b8a3782aed28fa505d311',99207,'node',26),('naa6000c2917d55d870400ecc0701aece3c',99206,'node',26),('naa6000c29fe3390e795d8c591136084897',99211,'node',26),('naa6000c29e200b558b2cc9c39ced49529c',99210,'node',26),('naa6000c29aac086487546a2ca8dd2ebd5a',99209,'node',26),('naa6000c29b6e7404ddd6b61e58e787d9d9',99215,'node',26),('naa6000c291dd7f6a5d9401fc71d54adbb6',99214,'node',26),('naa6000c29b4543f3d3e3ecbea6126ce7a5',99213,'node',26),('naa6000c2929533fd5be20eb5cc847a13ed',99218,'node',26),('naa6000c2964274185ba96cd4dbf8ef50eb',99217,'node',26),('naa6000c29dd4369787c560bd4beacce114',99216,'node',26),('naa6000c298d5ef350777b9f2be8ba3ef94',99221,'node',26),('naa6000c29ba4507964dff0ad72b70afbbe',99220,'node',26),('naa6000c298a30b94717e0a7b89a2473c29',99219,'node',26),('naa6000c29ef7c743ec1f1ae77fc08b4c8a',99224,'node',26),('naa6000c296efb831d18740de67a8212ba3',99223,'node',26),('naa6000c2941f98a8f551379b37f7715f14',99222,'node',26),('naa6000c29f3ebb0d585f0ed9422d664057',99227,'node',26),('naa6000c29a85ce165a8d96caf467e2b8c2',99226,'node',26),('naa6000c299cded2c9adf690ae5be386c24',99225,'node',26),('naa6000c293f222457d87adc267eccabf11',99231,'node',26),('naa6000c29a98d1500a789935c211afcfa4',99230,'node',26),('naa6000c2935081e51a2200a7f51268b899',99229,'node',26),('naa6000c29bd75f23cc168d13228cfd1188',99234,'node',26),('naa6000c294cc74c7000608f59a1e6e6cc5',99233,'node',26),('naa6000c297ce254a93f01e4bda7755f8b1',99232,'node',26),('naa6000c29733b0365706a54a9a5c2471db',99237,'node',26),('naa6000c299cd2c79e031925c1358c473e6',99236,'node',26),('naa6000c29449c9f7c6ccee27d61d6b548a',99235,'node',26),('naa6000c29d4104df0cf1b6ebc4fb7e62ea',99240,'node',26),('naa6000c29ae3e105bef458100c41d96e5e',99239,'node',26),('naa6000c291c6a3669ea9c11a428428f0c0',99238,'node',26),('naa6000c2950d69f69a7e0086277a1537b6',99243,'node',26),('naa6000c29aa56348f8c52aa982d67a435c',99242,'node',26),('naa6000c298015b74673771ea38b8763c63',99241,'node',26),('naa6000c293d46dcdef17137ae44b3e63b3',99245,'node',26),('1607',178552,'node',1),('1371596763',178552,'node',26),('1678',178554,'node',1),('1371596763',178554,'node',26),('1543',178553,'node',1),('1371596763',178553,'node',26),('1371596764',178556,'node',26),('1371596765',178566,'node',26),('1371596764',178564,'node',26),('1371596764',178562,'node',26),('1371596764',178560,'node',26),('1371596764',178559,'node',26),('1371596764',178558,'node',26),('1636',178570,'node',1),('1371596823',178570,'node',26),('1665',178569,'node',1),('1371596823',178569,'node',26),('1549',178572,'node',1),('1371596823',178572,'node',26),('1442',178571,'node',1),('1371596823',178571,'node',26),('1764',178550,'node',1),('1371596763',178550,'node',26),('1556',178549,'node',1),('1371596763',178549,'node',26),('1371596703',178513,'node',26),('1542',178512,'node',1),('1371596703',178512,'node',26),('1570',178514,'node',1),('1371596703',178514,'node',26),('1579',178513,'node',1),('1592',178516,'node',1),('1371596704',178516,'node',26),('1592',178517,'node',1),('1371596704',178517,'node',26),('1439',178519,'node',1),('1371596704',178519,'node',26),('1497',178518,'node',1),('1371596704',178518,'node',26),('1455',178520,'node',1),('1371596704',178520,'node',26),('1371596703',178510,'node',26),('1655',178459,'node',1),('1371596583',178459,'node',26),('1503',178461,'node',1),('1371596583',178461,'node',26),('1666',178460,'node',1),('1371596583',178460,'node',26),('1371596584',178463,'node',26),('1371596584',178466,'node',26),('1371596584',178465,'node',26),('1371596584',178467,'node',26),('1371596585',178471,'node',26),('1371596585',178469,'node',26),('1526',178456,'node',1),('1371596583',178456,'node',26),('1371596525',178435,'node',26),('1371596524',178428,'node',26),('1657',178428,'node',1),('1371596524',178429,'node',26),('1561',178429,'node',1),('1309',178362,'node',1),('1371596404',178362,'node',26),('1534',178361,'node',1),('1371596404',178361,'node',26),('1543',178359,'node',1),('1371596403',178359,'node',26),('1564',178365,'node',1),('1371596404',178365,'node',26),('1663',178364,'node',1),('1371596404',178364,'node',26),('1531',178363,'node',1),('1371596404',178363,'node',26),('1371596405',178370,'node',26),('1616',178368,'node',1),('1371596404',178368,'node',26),('1714',178367,'node',1),('1371596404',178367,'node',26),('1590',178366,'node',1),('1371596404',178366,'node',26),('1371596405',178376,'node',26),('1371596405',178374,'node',26),('1371596405',178373,'node',26),('1371596405',178372,'node',26),('1657',178383,'node',1),('1371596462',178383,'node',26),('1371596406',178380,'node',26),('1371596405',178378,'node',26),('1534',178387,'node',1),('1371596462',178387,'node',26),('1561',178386,'node',1),('1371596462',178386,'node',26),('1563',178385,'node',1),('1371596462',178385,'node',26),('1702',178384,'node',1),('1371596462',178384,'node',26),('1371596403',178353,'node',26),('1491',178353,'node',1),('1371596403',178354,'node',26),('1629',178354,'node',1),('1371596403',178355,'node',26),('1561',178355,'node',1),('naa6000c29879c542625d4b6088cdc6db0d',99246,'node',26),('naa6000c2901a38e7528335db9a8d1b55a9',99249,'node',26),('naa6000c2942d742dac850584b052554ee1',99248,'node',26),('naa6000c2997ed7efd8c63e88f76714c242',99247,'node',26),('naa6000c2932722fba5532a5b3cde7c0c63',99251,'node',26),('naa6000c293a34e4ff971e1b11d447e4a42',99250,'node',26),('naa6000c29db0b2f97bc7852ba854bc5a0f',99253,'node',26),('naa6000c29c2a035dec0cb7cf218419267b',99252,'node',26),('hgw2k8r232vm13',99254,'node',26),('hgw2k8r232vm14',99255,'node',26),('hgw2k8r232vm15',99256,'node',26),('naa6000c29f6fd3eb9866c057835e2bc58a',99258,'node',26),('hgw2k8r232vm16',99257,'node',26),('naa600a098044307259313f334556393442',99260,'node',26),('naa600a098044307259313f334556393441',99259,'node',26),('naa600a098044307535732b334571533578',99262,'node',26),('naa600a098044307535732b334571533577',99261,'node',26),('naa6000c292e02e62a7ea5fcc7e2ac6dac2',99263,'node',26),('naa6000c29932d18cc52aa4303fbb5eb3c8',99265,'node',26),('naa6000c2933e34e6114d05cd550d6203a2',99264,'node',26),('naa6000c29b66d5ffd22d0dd7c09b517e52',99267,'node',26),('naa6000c29ffdbb148155d03e2476161cb4',99266,'node',26),('naa6000c2935ddc92f10433d19f2bb80a9b',99269,'node',26),('naa6000c298ccbcb8562196baab2010f8ff',99268,'node',26),('naa6000c293d496c4a7d9a1f8af3d22ef12',99270,'node',26),('naa6000c29d497984f4722f3ac9dd476b19',99273,'node',26),('naa6000c29957b3d5f525e35e73b0141a8e',99272,'node',26),('naa6000c2960acd1e4028a94d476ecdc668',99271,'node',26),('naa6000c29cb55e1f2d29a6efd5f2d46898',99275,'node',26),('naa6000c298c48515e76cb4276acf0d25ab',99274,'node',26),('naa6000c296d616c278083d43923197613d',99434,'node',26),('naa6000c29f0e122c0c693e1a11e56d3b50',99421,'node',26),('naa6000c294b160ff10b82c3b3164532f5c',99277,'node',26),('naa6000c29d3d23a134327ee8536278c134',99276,'node',26),('naa6000c294f1ceeefa4a2beff5f55584fc',99402,'node',26),('naa6000c297cdc780e3c13ee563f29dc515',99278,'node',26),('naa6000c2938d61e772e92d242e8f616bc8',99299,'node',26),('naa6000c2961aac254c504c6d67ecb5f8ac',99280,'node',26),('naa6000c29fe77494a31a50f7fb700fd794',99279,'node',26),('naa6000c29293df626e239bea90f331fbff',99292,'node',26),('naa6000c296600c8dae9d742ee0c1bdc4e9',99282,'node',26),('naa6000c29e279da2c2ed11b70ea5d8c56a',99281,'node',26),('naa6000c29e335014bb174151c6fef61968',99285,'node',26),('naa6000c29d46de48951fc586e98226d5ec',99284,'node',26),('naa6000c2931b0ffc674dcc8e3598171dad',99283,'node',26),('naa6000c296145978d116a1dadb39cae949',99288,'node',26),('naa6000c29459e8c5d431d18870e9eba06f',99287,'node',26),('naa6000c29e54336b52aa766cc061802e54',99286,'node',26),('naa6000c293253c456ea75b96f934730b77',99291,'node',26),('naa6000c299a4eb2d1abcfd916114b897a2',99290,'node',26),('naa6000c2979079a872bc7b010e0990382e',99289,'node',26),('naa6000c29c258d048db92532600399cc4f',99295,'node',26),('naa6000c2916a269a0abd1525c1524ce67c',99294,'node',26),('naa6000c29e0464e562dccd37ac96b0e1dd',99293,'node',26),('naa6000c293a79653f23adacab302a35b4c',99298,'node',26),('naa6000c29fe6b177596c1c4b553ca45a3f',99297,'node',26),('naa6000c297b719579011fa5a723f8e0066',99296,'node',26),('naa6000c2959aa2b054351c424d30964b08',99401,'node',26),('naa6000c29d1b17437c7a0141d38fca7c0e',99400,'node',26),('naa600a098044307535732b33457153357a',99399,'node',26),('naa6000c292c148a7d33c2540a9767aa824',99405,'node',26),('naa6000c294dbda2a3d6a7892f1734c71fe',99404,'node',26),('naa6000c29768334a860ab2d408c832c177',99403,'node',26),('naa6000c291d75a3708a841e1ee07a014f1',99408,'node',26),('naa6000c29083952def68e3e9ffd16517b9',99407,'node',26),('naa6000c2900ba30f9c04761e67e7ba6cce',99406,'node',26),('naa6000c294c7019963f07607c89dc4666a',99411,'node',26),('naa6000c29dd01ef3192bf1ffa13e5c71a2',99410,'node',26),('naa6000c29d47d77c0cd2025e1971109dd6',99409,'node',26),('naa6000c294dd93e79791523ad9469f1531',99414,'node',26),('naa6000c29a4374a6fc984cc3df423d7826',99413,'node',26),('naa6000c29bf50a0ed8408706208f3ae812',99412,'node',26),('naa6000c29a8feb68507998c1e5005c8d6a',99417,'node',26),('naa6000c29630b208ccee2b19c7051c2179',99416,'node',26),('naa6000c296784e9dc1250b3216789698b6',99415,'node',26),('naa6000c295a0eeb2a325ce87cb26a569cc',99420,'node',26),('naa6000c29f518a6ba4ce7d35ae9a59df2f',99419,'node',26),('naa6000c29428a929259bdf1e335a6a0cf3',99418,'node',26),('naa6000c299273ff09587c8a7d753e6cbad',99424,'node',26),('naa6000c29acdcfc3731068d112b925c117',99423,'node',26),('naa6000c2968e87a4052eaebe934cd108c9',99422,'node',26),('naa6000c29b8296536ec7810e73af9e6c3a',99427,'node',26),('naa6000c2989e012f7d70034f59682da73f',99426,'node',26),('naa6000c299fd4914145c44d7f0cb9bbb61',99425,'node',26),('naa6000c296ccdeb9458e68e338f3cd6a82',99430,'node',26),('naa6000c29f155edba699afe8c5ae930141',99429,'node',26),('naa6000c294bb43532c863aee47b5f5049f',99428,'node',26),('naa6000c29bf7087777c6b1a06aa36aa01b',99433,'node',26),('naa6000c29e90267af74612bf02c867a8a9',99432,'node',26),('naa6000c29fb5474c246b501f6412606177',99431,'node',26),('naa6000c29bf6e0f4fedbe7daf1e1752859',99437,'node',26),('naa6000c29487a81812d7fcd470b1f05b92',99436,'node',26),('naa6000c292e5269fcf7b9ac98f5a58d98d',99435,'node',26),('naa6000c29a55144da0ca59bf68548743f1',99440,'node',26),('naa6000c298badd992c7dfa3d313aaf4308',99439,'node',26),('naa6000c29e72b201aedfc8a958975f29c5',99438,'node',26),('naa6000c2972f5eb0f1acad26055f514f6d',99443,'node',26),('naa6000c292b38715a4bf5db11a06a63e31',99442,'node',26),('naa6000c292d1e0ba34fcd69f4a7ddb7966',99441,'node',26),('naa6000c29ce39995d215bdbe84b1a58c17',99444,'node',26),('1371596705',178526,'node',26),('1371596705',178524,'node',26),('1371596704',178515,'node',26),('1553',178515,'node',1),('1371596644',178484,'node',26),('1596',178484,'node',1),('1371596642',178474,'node',26),('1371596585',178472,'node',26),('1371596643',178475,'node',26),('1596',178475,'node',1),('1371596526',178441,'node',26),('1371596581',178443,'node',26),('1371596525',178439,'node',26),('1371596525',178437,'node',26),('1371596464',178402,'node',26),('1371596464',178400,'node',26),('1371596463',178391,'node',26),('1567',178391,'node',1),('1371596464',178406,'node',26),('1569',178360,'node',1),('1371596405',178369,'node',26),('1371596404',178360,'node',26),('1371596405',178375,'node',26),('1371596402',178350,'node',26),('1371596345',178348,'node',26),('1371596345',178346,'node',26),('1371596345',178344,'node',26),('1371596344',178338,'node',26),('1371596344',178340,'node',26),('1371596344',178329,'node',26),('1595',178329,'node',1),('1592',178320,'node',1),('1371596342',178320,'node',26),('1371596342',178319,'node',26),('107',178315,'node',1),('1371596285',178317,'node',26),('1371596284',178313,'node',26),('1371596284',178315,'node',26),('1371596284',178309,'node',26),('1371596284',178307,'node',26),('1580',178298,'node',1),('1582',178289,'node',1),('1371596283',178298,'node',26),('1371596405',178377,'node',26),('1371596406',178379,'node',26),('1371596462',178381,'node',26),('1371596462',178382,'node',26),('1561',178382,'node',1),('1371596405',178371,'node',26),('1562',178351,'node',1),('1371596403',178351,'node',26),('1371596523',178413,'node',26),('1570',178413,'node',1),('1371596465',178410,'node',26),('1371596465',178408,'node',26),('1371596522',178412,'node',26),('1371596584',178464,'node',26),('1371596585',178468,'node',26),('1371596582',178444,'node',26),('1573',178444,'node',1),('1371596583',178453,'node',26),('1564',178453,'node',1),('1371596584',178462,'node',26),('1371596524',178422,'node',26),('1582',178422,'node',1),('1371596525',178431,'node',26),('1371596525',178433,'node',26),('1371596646',178503,'node',26),('1371596645',178495,'node',26),('1371596646',178499,'node',26),('1371596646',178501,'node',26),('1371596645',178493,'node',26),('1371596585',178470,'node',26),('1371596761',178536,'node',26),('1371596762',178537,'node',26),('1585',178537,'node',1),('1371596706',178534,'node',26),('1371596705',178532,'node',26),('1371596705',178530,'node',26),('1371596702',178505,'node',26),('1371596703',178506,'node',26),('1588',178506,'node',1),('1638',178337,'node',1),('1371596344',178337,'node',26),('1491',178336,'node',1),('1371596344',178336,'node',26),('1551',178335,'node',1),('1371596344',178335,'node',26),('1371596344',178334,'node',26),('1578',178333,'node',1),('1371596344',178333,'node',26),('1698',178332,'node',1),('1371596344',178332,'node',26),('1658',178331,'node',1),('1371596344',178331,'node',26),('1548',178334,'node',1),('1590',178330,'node',1),('1371596344',178330,'node',26),('1660',178328,'node',1),('1371596342',178328,'node',26),('1522',178327,'node',1),('1371596342',178327,'node',26),('1541',178325,'node',1),('1371596342',178325,'node',26),('1553',178324,'node',1),('1371596342',178324,'node',26),('1663',178323,'node',1),('1371596342',178323,'node',26),('1699',178326,'node',1),('1371596342',178326,'node',26),('1510',178322,'node',1),('1371596342',178322,'node',26),('1579',178321,'node',1),('1371596342',178321,'node',26),('1371596285',178318,'node',26),('107',178316,'node',1),('1371596284',178316,'node',26),('1371596284',178314,'node',26),('1371596284',178312,'node',26),('1371596284',178311,'node',26),('1371596284',178310,'node',26),('1371596284',178308,'node',26),('1644',178306,'node',1),('1371596283',178306,'node',26),('1515',178305,'node',1),('1371596283',178305,'node',26),('1620',178304,'node',1),('1371596283',178304,'node',26),('1511',178303,'node',1),('1677',178302,'node',1),('1371596283',178303,'node',26),('1371596283',178302,'node',26),('1371596465',178409,'node',26),('1371596464',178407,'node',26),('1371596464',178405,'node',26),('1371596464',178404,'node',26),('1371596463',178399,'node',26),('1582',178399,'node',1),('1371596464',178401,'node',26),('1371596464',178403,'node',26),('1564',178398,'node',1),('1371596463',178398,'node',26),('1570',178397,'node',1),('1371596463',178397,'node',26),('1371596463',178396,'node',26),('1644',178396,'node',1),('1553',178395,'node',1),('1371596463',178395,'node',26),('1468',178394,'node',1),('1371596463',178394,'node',26),('1583',178393,'node',1),('1371596463',178393,'node',26),('1567',178392,'node',1),('1371596463',178392,'node',26),('1539',178390,'node',1),('1371596462',178390,'node',26),('1514',178389,'node',1),('1371596462',178389,'node',26),('1400',178388,'node',1),('1371596462',178388,'node',26),('1717',178358,'node',1),('1371596403',178356,'node',26),('1525',178356,'node',1),('1371596403',178357,'node',26),('1461',178357,'node',1),('1371596403',178358,'node',26),('1554',178352,'node',1),('1371596403',178352,'node',26),('1371596345',178349,'node',26),('1371596345',178347,'node',26),('1371596345',178345,'node',26),('1371596344',178343,'node',26),('1371596344',178342,'node',26),('1371596344',178341,'node',26),('1371596344',178339,'node',26),('1400',178426,'node',1),('1371596524',178426,'node',26),('1550',178425,'node',1),('1371596524',178425,'node',26),('1661',178424,'node',1),('1371596524',178424,'node',26),('1371596524',178423,'node',26),('1685',178423,'node',1),('1724',178421,'node',1),('1371596523',178421,'node',26),('1371596523',178420,'node',26),('1417',178420,'node',1),('1563',178419,'node',1),('1371596523',178419,'node',26),('1548',178418,'node',1),('1371596523',178418,'node',26),('1427',178417,'node',1),('1371596523',178417,'node',26),('1371596523',178416,'node',26),('1703',178416,'node',1),('1527',178415,'node',1),('1371596523',178415,'node',26),('1626',178414,'node',1),('1371596523',178414,'node',26),('1371596465',178411,'node',26),('1371596525',178434,'node',26),('1371596525',178432,'node',26),('1496',178430,'node',1),('1371596524',178430,'node',26),('1627',178427,'node',1),('1371596524',178427,'node',26),('1371596224',178267,'node',26),('1571',178267,'node',1),('1609',178258,'node',1),('1371596223',178258,'node',26),('1371596222',178257,'node',26),('1605',178227,'node',1),('1371596162',178227,'node',26),('1371596106',178224,'node',26),('1371596161',178226,'node',26),('1371596105',178222,'node',26),('1371596102',178195,'node',26),('1371596045',178193,'node',26),('1371596045',178191,'node',26),('1371595985',178162,'node',26),('1371595984',178160,'node',26),('fmcdebianbld1',99474,'node',26),('hgmh2w2k8r2',99473,'node',26),('hgmh1w2k8r2',99472,'node',26),('fmcbp',99471,'node',26),('hgwin2k814760',99470,'node',26),('hgvcenter512',99469,'node',26),('hgvcenter511',99468,'node',26),('console',99467,'node',26),('management',99467,'node',26),('accel',99467,'node',26),('flash',99467,'node',26),('fmcdns32',99466,'node',26),('hgvma01',99465,'node',26),('hgrhel5dns',99464,'node',26),('hgw2k8r2dvmtn',99463,'node',26),('hemanthamainn1305290334',99462,'node',26),('linux1',99461,'node',26),('hgw2k8r2template',99460,'node',26),('hgsf1w2k8r2',99459,'node',26),('hgmh3w2k8r2',99458,'node',26),('hgtemplate',99457,'node',26),('fasanity02w2k8r2',99456,'node',26),('favesxi5001sanity',99455,'node',26),('598854',99454,'node',1),('1',99454,'node',1),('custom',99454,'node',1),('hgvmhemanth84gdlenglabnetappcom',99454,'node',26),('naa6000c2939eabe43ec0406da8cf74e5fd',99453,'node',26),('naa6000c297ed59dbc39a6bbb805c2fb800',99452,'node',26),('naa6000c2978055874f2dceb272e9b89104',99451,'node',26),('naa6000c29e6c8266f8ff0e9ddc2367c593',99450,'node',26),('naa6000c29fc92dc78e108403dfc0dc5004',99449,'node',26),('naa6000c29b807b80b72131045915c52ffc',99448,'node',26),('naa6000c29843495e04fb98bb2a0dc2332c',99447,'node',26),('naa6000c29be91afe402ae96fef3affb26e',99446,'node',26),('naa6000c29a87723ee338351beefff3a76a',99445,'node',26),('bpmgmtvm',99476,'node',26),('chrismgmtvm',99475,'node',26),('hgvcenter01',99478,'node',26),('hgw2k8r2mgmt',99477,'node',26),('fmcangela',99480,'node',26),('hgfmcvcenter01',99479,'node',26),('fmczaloni',99482,'node',26),('hqqandisp',99481,'node',26),('hemantha',99484,'node',26),('hgvcenterperf',99483,'node',26),('nataliemysqlvm',99486,'node',26),('hgnatk1w2k8r2',99485,'node',26),('fmcpreston1',99488,'node',26),('fmczalonibarium',99487,'node',26),('fmcchris',99490,'node',26),('fmcpreston',99489,'node',26),('fmcqa',99492,'node',26),('fmcmauricio',99491,'node',26),('hgw2k8r2bp5',99494,'node',26),('hgw2k8r2bp3',99493,'node',26),('hgw2k8r2e2e1',99496,'node',26),('hgw2k8r2nfs4',99495,'node',26),('hgw2k8r2e2e4',99497,'node',26),('hgw2k8r2e2e7',99499,'node',26),('hgw2k8r2e2e6',99498,'node',26),('hgw2k8r2e2e9nrn',99501,'node',26),('hgw2k8r2e2e8',99500,'node',26),('598855',99502,'node',1),('1',99502,'node',1),('custom',99502,'node',1),('hgw2k8r2e2e10',99502,'node',26),('hgw2k8r2e2e11',99503,'node',26),('hgw2k8r2e2e12',99504,'node',26),('hgw2k8r2cs11',99505,'node',26),('hgw2k8r2cs1',99506,'node',26),('naa6000c290b1821e62cf431ca26bf1f765',99508,'node',26),('hgw2k8r2cs3',99507,'node',26),('hgw2k8r2cs5',99509,'node',26),('hgw2k8r2cs6',99510,'node',26),('hgw2k8r2cs4',99511,'node',26),('hgw2k8r2cs7',99512,'node',26),('naa6000c29a784d07bfd536222612ee057f',99514,'node',26),('naa6000c294aba0be1db4257742f4ab2149',99513,'node',26),('naa6000c291fd64f90bd3d371b644cee3c5',99515,'node',26),('hgw2k8r2cs9',99516,'node',26),('hgw2k8r2cs10',99517,'node',26),('hgw2k8r2cs8',99518,'node',26),('hgw2k8r2ms1',99519,'node',26),('hgw2k8r2cs12',99520,'node',26),('hgw2k8r2cs13',99521,'node',26),('hgw2k8r2e2e62',99522,'node',26),('hgw2k8r2e2e63',99523,'node',26),('naa6000c2973380870eb4d88784ea671eca',99525,'node',26),('hgw2k8r22',99524,'node',26),('naa6000c29102ce37a07ac01e2ced3959b8',99526,'node',26),('hgw2k8r25',99529,'node',26),('hgw2k8r2e2e2',99528,'node',26),('naa60a9800037543261505d424f31325645',99527,'node',26),('naa6000c29eeb2b6dbd2d24552781be174b',99530,'node',26),('1371042182',104861,'node',26),('1371042126',104860,'node',26),('naa6000c2967523a755b6fc0df302814030',99531,'node',26),('1371042183',104863,'node',26),('1371042182',104862,'node',26),('1371042183',104866,'node',26),('1371042183',104865,'node',26),('1371042183',104864,'node',26),('1371042183',104869,'node',26),('1371042183',104868,'node',26),('1371042183',104867,'node',26),('1371042183',104872,'node',26),('1371042183',104871,'node',26),('1371042183',104870,'node',26),('1371596223',178264,'node',26),('1634',178264,'node',1),('1521',178263,'node',1),('1371596223',178263,'node',26),('1806',178266,'node',1),('1371596223',178266,'node',26),('1585',178265,'node',1),('1371596223',178265,'node',26),('1656',178268,'node',1),('1371596224',178268,'node',26),('1575',178270,'node',1),('1371596224',178270,'node',26),('1463',178269,'node',1),('1371596224',178269,'node',26),('1371596224',178271,'node',26),('1596',178271,'node',1),('1535',178273,'node',1),('1371596224',178273,'node',26),('1371596224',178272,'node',26),('1599',178272,'node',1),('1678',178274,'node',1),('1371596224',178274,'node',26),('1452',178275,'node',1),('1371596104',178213,'node',26),('1524',178213,'node',1),('1371596105',178215,'node',26),('1396',178212,'node',1),('1371596104',178212,'node',26),('1371596105',178217,'node',26),('1371596105',178219,'node',26),('1371596105',178218,'node',26),('1371596105',178221,'node',26),('1371596106',178225,'node',26),('1371596105',178223,'node',26),('1605',178228,'node',1),('1371596162',178228,'node',26),('1681',178230,'node',1),('1371596162',178230,'node',26),('1675',178229,'node',1),('1371596162',178229,'node',26),('1510',178237,'node',1),('1371596162',178231,'node',26),('1625',178231,'node',1),('1643',178173,'node',1),('1371596042',178173,'node',26),('1371596042',178172,'node',26),('1641',178172,'node',1),('1521',178171,'node',1),('1371596042',178171,'node',26),('1564',178176,'node',1),('1371596044',178176,'node',26),('1371596044',178175,'node',26),('1599',178175,'node',1),('1645',178177,'node',1),('1371596044',178177,'node',26),('1599',178179,'node',1),('1371596044',178179,'node',26),('1649',178178,'node',1),('1371596044',178178,'node',26),('1574',178180,'node',1),('1371596044',178180,'node',26),('1609',178181,'node',1),('1371596044',178181,'node',26),('1579',178182,'node',1),('1371596044',178182,'node',26),('1371596044',178184,'node',26),('1371596044',178186,'node',26),('1371595982',178134,'node',26),('1571',178134,'node',1),('1371595865',178100,'node',26),('1371595805',178067,'node',26),('1371595744',178030,'node',26),('1371595445',177873,'node',26),('1371595383',177824,'node',26),('1553',177824,'node',1),('1371595322',177792,'node',26),('1371595265',177786,'node',26),('1628',177860,'node',1),('1371595443',177860,'node',26),('1563',177859,'node',1),('1371595443',177859,'node',26),('1371575170',165843,'node',26),('1371575170',165841,'node',26),('1371575110',165750,'node',26),('1371575110',165746,'node',26),('1371575049',165655,'node',26),('1371575049',165653,'node',26),('1371574989',165562,'node',26),('1371574989',165564,'node',26),('1371574988',165553,'node',26),('1434',165553,'node',1),('1371574921',165392,'node',26),('1371574870',165390,'node',26),('1371574809',165299,'node',26),('1371574809',165297,'node',26),('1371574749',165206,'node',26),('1371574748',165200,'node',26),('1371574749',165204,'node',26),('1371574689',165113,'node',26),('1371574689',165109,'node',26),('1371574628',165018,'node',26),('1371574628',165016,'node',26),('1371574628',165020,'node',26),('1371574628',165019,'node',26),('1277',165015,'node',1),('1371574628',165017,'node',26),('1371574628',165015,'node',26),('1456',165014,'node',1),('1371574628',165014,'node',26),('1371574683',165033,'node',26),('1371574683',165032,'node',26),('1371574683',165036,'node',26),('1371574683',165035,'node',26),('1371574683',165034,'node',26),('1371574683',165038,'node',26),('1371574683',165037,'node',26),('1371574683',165039,'node',26),('1371574683',165041,'node',26),('1371574683',165040,'node',26),('1371042183',104874,'node',26),('1371042183',104873,'node',26),('1371042183',104877,'node',26),('1371042183',104876,'node',26),('1371042183',104875,'node',26),('1371042183',104880,'node',26),('1371042183',104879,'node',26),('1371042183',104878,'node',26),('1371042183',104883,'node',26),('1371042183',104882,'node',26),('1371042183',104881,'node',26),('1371042183',104887,'node',26),('1371042183',104886,'node',26),('1371042183',104885,'node',26),('1371042183',104884,'node',26),('1371042183',104889,'node',26),('1371042183',104888,'node',26),('1371042183',104892,'node',26),('1371042183',104891,'node',26),('1371042183',104890,'node',26),('1371574569',164929,'node',26),('1371042183',104896,'node',26),('1371042183',104895,'node',26),('1371042183',104894,'node',26),('1371042183',104893,'node',26),('1371574569',164928,'node',26),('1371042183',104899,'node',26),('1371042183',104898,'node',26),('1371042183',104897,'node',26),('1371042183',104903,'node',26),('1371042183',104902,'node',26),('1371042183',104901,'node',26),('1371042183',104900,'node',26),('1371042183',104906,'node',26),('1371042183',104905,'node',26),('1371042183',104904,'node',26),('1371042183',104910,'node',26),('1371042183',104909,'node',26),('1371042183',104908,'node',26),('1371042183',104907,'node',26),('1371574623',164939,'node',26),('1371042183',104913,'node',26),('1371042183',104912,'node',26),('1371042183',104911,'node',26),('1371042183',104916,'node',26),('1371042183',104915,'node',26),('1371042183',104914,'node',26),('1371042183',104919,'node',26),('1371042183',104918,'node',26),('1371042183',104917,'node',26),('1371042183',104922,'node',26),('1371042183',104921,'node',26),('1371042183',104920,'node',26),('1371574623',164940,'node',26),('1371042242',104925,'node',26),('1371042242',104924,'node',26),('1371042186',104923,'node',26),('1371042243',104928,'node',26),('1371042243',104927,'node',26),('1371042243',104926,'node',26),('1371042243',104932,'node',26),('1371042243',104931,'node',26),('1371042243',104930,'node',26),('1371042243',104929,'node',26),('1371042243',104935,'node',26),('1371042243',104934,'node',26),('1371042243',104933,'node',26),('1371574623',164942,'node',26),('1371042243',104938,'node',26),('1371042243',104937,'node',26),('1371042243',104936,'node',26),('1371574623',164941,'node',26),('1371042243',104942,'node',26),('1371042243',104941,'node',26),('1371042243',104940,'node',26),('1371042243',104939,'node',26),('1371042243',104945,'node',26),('1371042243',104944,'node',26),('1371042243',104943,'node',26),('1371042243',104948,'node',26),('1371042243',104947,'node',26),('1371042243',104946,'node',26),('1371042243',104952,'node',26),('1371042243',104951,'node',26),('1371042243',104950,'node',26),('1371042243',104949,'node',26),('1371042243',104955,'node',26),('1371042243',104954,'node',26),('1371042243',104953,'node',26),('1371042243',104958,'node',26),('1371042243',104957,'node',26),('1371042243',104956,'node',26),('1371574623',164943,'node',26),('1371042243',104972,'node',26),('1371042243',104961,'node',26),('1371042243',104960,'node',26),('1371042243',104959,'node',26),('1371042243',104971,'node',26),('1371042243',104965,'node',26),('1371042243',104964,'node',26),('1371042243',104963,'node',26),('1371042243',104962,'node',26),('1371042243',104970,'node',26),('1371042243',104969,'node',26),('1371042243',104968,'node',26),('1371042243',104967,'node',26),('1371042243',104966,'node',26),('1371574569',164926,'node',26),('1371567783',154597,'node',26),('1371567783',154596,'node',26),('1371567783',154595,'node',26),('1371567783',154594,'node',26),('1371567783',154593,'node',26),('1371567783',154592,'node',26),('1371567783',154591,'node',26),('1371567783',154590,'node',26),('1371567783',154589,'node',26),('1371567783',154607,'node',26),('1371567783',154606,'node',26),('1371567783',154605,'node',26),('1371567783',154604,'node',26),('1371567783',154603,'node',26),('1371567783',154602,'node',26),('1371567783',154601,'node',26),('1371567783',154600,'node',26),('1371567783',154599,'node',26),('1371567783',154598,'node',26),('1371567783',154569,'node',26),('1371567783',154568,'node',26),('1371567783',154570,'node',26),('1371567783',154571,'node',26),('1371567783',154573,'node',26),('1371567783',154572,'node',26),('1371567783',154574,'node',26),('1371567783',154567,'node',26),('1371567664',154415,'node',26),('1371567664',154414,'node',26),('1371567664',154416,'node',26),('1371567664',154418,'node',26),('1371567664',154417,'node',26),('1371567664',154419,'node',26),('1371567664',154420,'node',26),('1371567604',154322,'node',26),('1371567604',154323,'node',26),('1371567604',154325,'node',26),('1371567604',154324,'node',26),('1371567604',154326,'node',26),('1371567604',154328,'node',26),('1371567604',154327,'node',26),('1371567604',154320,'node',26),('1371567604',154321,'node',26),('1371567543',154209,'node',26),('1371567543',154211,'node',26),('1371567543',154210,'node',26),('1371567543',154212,'node',26),('1371567543',154214,'node',26),('1371567543',154213,'node',26),('1371567543',154215,'node',26),('1371567483',154134,'node',26),('1371567483',154133,'node',26),('1371567483',154135,'node',26),('1371567483',154136,'node',26),('1371567483',154138,'node',26),('1371567483',154137,'node',26),('1371567483',154139,'node',26),('1371567364',153935,'node',26),('1371567364',153940,'node',26),('1371567364',153939,'node',26),('1371567364',153938,'node',26),('1371567364',153937,'node',26),('1371567364',153936,'node',26),('1371567364',153942,'node',26),('1371567364',153941,'node',26),('1371567364',153943,'node',26),('1371567364',153945,'node',26),('1371567364',153944,'node',26),('1371567364',153934,'node',26),('1371630666',192755,'node',26),('1371630666',192758,'node',26),('1371630666',192756,'node',26),('1371630607',192729,'node',26),('1371630607',192728,'node',26),('1371042243',104973,'node',26),('1371042243',104976,'node',26),('1371042243',104975,'node',26),('1371042243',104974,'node',26),('1371042243',104980,'node',26),('1371042243',104979,'node',26),('1371042243',104978,'node',26),('1371042243',104977,'node',26),('1371042243',104983,'node',26),('1371042243',104982,'node',26),('1371042243',104981,'node',26),('1371042246',104986,'node',26),('1371042243',104985,'node',26),('1371042243',104984,'node',26),('1371042303',104989,'node',26),('1371042302',104988,'node',26),('1371042302',104987,'node',26),('1371042303',104992,'node',26),('1371042303',104991,'node',26),('1371042303',104990,'node',26),('1371042303',104996,'node',26),('1371042303',104995,'node',26),('1371042303',104994,'node',26),('1371042303',104993,'node',26),('1371042303',104999,'node',26),('1371042303',104998,'node',26),('1371042303',104997,'node',26),('1371042303',105001,'node',26),('1371042303',105000,'node',26),('1371042303',105003,'node',26),('1371042303',105002,'node',26),('1371042303',105006,'node',26),('1371042303',105005,'node',26),('1371042303',105004,'node',26),('1371042303',105010,'node',26),('1371042303',105009,'node',26),('1371042303',105008,'node',26),('1371042303',105007,'node',26),('1371042303',105013,'node',26),('1371042303',105012,'node',26),('1371042303',105011,'node',26),('1371042303',105017,'node',26),('1371042303',105016,'node',26),('1371042303',105015,'node',26),('1371042303',105014,'node',26),('1371042303',105020,'node',26),('1371042303',105019,'node',26),('1371042303',105018,'node',26),('1371042303',105023,'node',26),('1371042303',105022,'node',26),('1371042303',105021,'node',26),('1371042303',105026,'node',26),('1371042303',105025,'node',26),('1371042303',105024,'node',26),('1371042303',105030,'node',26),('1371042303',105029,'node',26),('1371042303',105028,'node',26),('1371042303',105027,'node',26),('1371042303',105033,'node',26),('1371042303',105032,'node',26),('1371042303',105031,'node',26),('1371042303',105036,'node',26),('1371042303',105035,'node',26),('1371042303',105034,'node',26),('1371042303',105039,'node',26),('1371042303',105038,'node',26),('1371042303',105037,'node',26),('1371042303',105043,'node',26),('1371042303',105042,'node',26),('1371042303',105041,'node',26),('1371042303',105040,'node',26),('1371042303',105046,'node',26),('1371042303',105045,'node',26),('1371042303',105044,'node',26),('1371042306',105049,'node',26),('1371042303',105048,'node',26),('1371042303',105047,'node',26),('588',105052,'node',1),('1371042363',105052,'node',26),('1371042362',105051,'node',26),('1371042362',105050,'node',26),('1371042363',105055,'node',26),('1371042363',105054,'node',26),('1371042363',105053,'node',26),('1371042363',105059,'node',26),('1371042363',105058,'node',26),('1371042363',105057,'node',26),('1371042363',105056,'node',26),('1371042363',105062,'node',26),('1371042363',105061,'node',26),('1371042363',105060,'node',26),('1371042363',105065,'node',26),('1371042363',105064,'node',26),('1371042363',105063,'node',26),('1371042363',105069,'node',26),('1371042363',105068,'node',26),('1371042363',105067,'node',26),('1371042363',105066,'node',26),('1371042363',105072,'node',26),('1371042363',105071,'node',26),('1371042363',105070,'node',26),('1371630306',192620,'node',26),('1371630306',192618,'node',26),('1371630306',192619,'node',26),('1371630306',192617,'node',26),('1371559323',141846,'node',26),('1371559323',141847,'node',26),('1371559323',141845,'node',26),('1371042363',105073,'node',26),('1371042363',105076,'node',26),('1371042363',105075,'node',26),('1371042363',105074,'node',26),('1371042363',105078,'node',26),('1371042363',105077,'node',26),('1371042363',105080,'node',26),('1371042363',105079,'node',26),('1371042363',105083,'node',26),('1371042363',105082,'node',26),('1371042363',105081,'node',26),('1371042363',105086,'node',26),('1371042363',105085,'node',26),('1371042363',105084,'node',26),('1371042363',105090,'node',26),('1371042363',105089,'node',26),('1371042363',105088,'node',26),('1371042363',105087,'node',26),('1371042363',105095,'node',26),('1371042363',105094,'node',26),('1371042363',105093,'node',26),('1371042363',105092,'node',26),('1371042363',105091,'node',26),('1371042363',105099,'node',26),('1371042363',105098,'node',26),('1371042363',105097,'node',26),('1371042363',105096,'node',26),('1371042363',105103,'node',26),('1371042363',105102,'node',26),('1371042363',105101,'node',26),('1371042363',105100,'node',26),('1371042363',105107,'node',26),('1371042363',105106,'node',26),('1371042363',105105,'node',26),('1371042363',105104,'node',26),('1371042363',105110,'node',26),('1371042363',105109,'node',26),('1371042363',105108,'node',26),('1371042422',105113,'node',26),('1371042366',105112,'node',26),('1371042363',105111,'node',26),('1371042424',105116,'node',26),('1371042424',105115,'node',26),('1371042422',105114,'node',26),('1371042424',105120,'node',26),('1371042424',105119,'node',26),('1371042424',105118,'node',26),('1371042424',105117,'node',26),('1371042424',105123,'node',26),('1371042424',105122,'node',26),('1371042424',105121,'node',26),('1371042424',105126,'node',26),('1371042424',105125,'node',26),('1371042424',105124,'node',26),('1371042424',105129,'node',26),('1371042424',105128,'node',26),('1371042424',105127,'node',26),('1371042424',105133,'node',26),('1371042424',105132,'node',26),('1371042424',105131,'node',26),('1371042424',105130,'node',26),('1371042424',105136,'node',26),('1371042424',105135,'node',26),('1371042424',105134,'node',26),('1371042424',105139,'node',26),('1371042424',105138,'node',26),('1371042424',105137,'node',26),('1371042424',105143,'node',26),('1371042424',105142,'node',26),('1371042424',105141,'node',26),('1371042424',105140,'node',26),('1371042424',105146,'node',26),('1371042424',105145,'node',26),('1371042424',105144,'node',26),('1371042424',105150,'node',26),('1371042424',105149,'node',26),('1371042424',105148,'node',26),('1371042424',105147,'node',26),('1371042424',105153,'node',26),('1371042424',105152,'node',26),('1371042424',105151,'node',26),('1371042424',105156,'node',26),('1371042424',105155,'node',26),('1371042424',105154,'node',26),('1371042424',105160,'node',26),('1371042424',105159,'node',26),('1371042424',105158,'node',26),('1371042424',105157,'node',26),('1371042424',105163,'node',26),('1371042424',105162,'node',26),('1371042424',105161,'node',26),('1371042424',105166,'node',26),('1371042424',105165,'node',26),('1371042424',105164,'node',26),('1371042424',105170,'node',26),('1371042424',105169,'node',26),('1371042424',105168,'node',26),('1371042424',105167,'node',26),('1371042424',105172,'node',26),('1371042424',105171,'node',26),('1371629946',192496,'node',26),('1371629946',192495,'node',26),('1371629947',192500,'node',26),('1371629947',192504,'node',26),('1371629947',192502,'node',26),('1371629946',192498,'node',26),('1371629885',192468,'node',26),('1371629885',192471,'node',26),('1371629885',192472,'node',26),('1371629885',192469,'node',26),('1371629885',192470,'node',26),('1371629719',192434,'node',26),('1371629784',192439,'node',26),('1371629784',192440,'node',26),('1371629784',192437,'node',26),('1397',192437,'node',1),('1371629527',192399,'node',26),('1371629648',192406,'node',26),('1371629648',192405,'node',26),('1371629648',192408,'node',26),('1371629648',192404,'node',26),('1371629648',192402,'node',26),('1371629648',192403,'node',26),('1371628865',192207,'node',26),('1371628749',192191,'node',26),('1371628749',192183,'node',26),('1371628749',192181,'node',26),('1371628749',192182,'node',26),('1371628742',192178,'node',26),('1371628749',192179,'node',26),('1371628749',192180,'node',26),('1371629785',192444,'node',26),('1371629784',192438,'node',26),('1371629785',192442,'node',26),('1371629881',192465,'node',26),('1371629885',192466,'node',26),('1371628866',192213,'node',26),('1371628866',192212,'node',26),('1371628866',192211,'node',26),('1371629878',192463,'node',26),('6667',192463,'node',1),('1371629947',192499,'node',26),('1371628946',192242,'node',26),('1371628946',192238,'node',26),('1371628946',192240,'node',26),('1371042426',105175,'node',26),('1371042424',105174,'node',26),('1371042424',105173,'node',26),('1371042484',105178,'node',26),('1371042482',105177,'node',26),('1371042482',105176,'node',26),('1371042484',105181,'node',26),('1371042484',105180,'node',26),('1371042484',105179,'node',26),('1371042484',105185,'node',26),('1371042484',105184,'node',26),('1371042484',105183,'node',26),('1371042484',105182,'node',26),('1371042484',105189,'node',26),('1371042484',105188,'node',26),('1371042484',105187,'node',26),('1371042484',105186,'node',26),('1371042484',105192,'node',26),('1371042484',105191,'node',26),('1371042484',105190,'node',26),('1371042484',105195,'node',26),('1371042484',105194,'node',26),('1371042484',105193,'node',26),('1371042484',105199,'node',26),('1371042484',105198,'node',26),('1371042484',105197,'node',26),('1371042484',105196,'node',26),('1371042484',105203,'node',26),('1371042484',105202,'node',26),('1371042484',105201,'node',26),('1371042484',105200,'node',26),('1371042484',105206,'node',26),('1371042484',105205,'node',26),('1371042484',105204,'node',26),('1371042484',105210,'node',26),('1371042484',105209,'node',26),('1371042484',105208,'node',26),('1371042484',105207,'node',26),('1371042484',105213,'node',26),('1371042484',105212,'node',26),('1371042484',105211,'node',26),('1371042484',105216,'node',26),('1371042484',105215,'node',26),('1371042484',105214,'node',26),('1371042484',105219,'node',26),('1371042484',105218,'node',26),('1371042484',105217,'node',26),('1371042484',105222,'node',26),('1371042484',105221,'node',26),('1371042484',105220,'node',26),('1371042484',105226,'node',26),('1371042484',105225,'node',26),('1371042484',105224,'node',26),('1371042484',105223,'node',26),('1371042484',105230,'node',26),('1371042484',105229,'node',26),('1371042484',105228,'node',26),('1371042484',105227,'node',26),('1371042484',105233,'node',26),('1371042484',105232,'node',26),('1371042484',105231,'node',26),('1371042484',105236,'node',26),('1371042484',105235,'node',26),('1371042484',105234,'node',26),('1371042486',105238,'node',26),('1371042484',105237,'node',26),('1371042544',105241,'node',26),('1371042542',105240,'node',26),('1371042542',105239,'node',26),('1371042544',105244,'node',26),('1371042544',105243,'node',26),('1371042544',105242,'node',26),('1371042544',105248,'node',26),('1371042544',105247,'node',26),('1371042544',105246,'node',26),('1371042544',105245,'node',26),('1371042544',105251,'node',26),('1371042544',105250,'node',26),('1371042544',105249,'node',26),('1371042544',105254,'node',26),('1371042544',105253,'node',26),('1371042544',105252,'node',26),('1371042544',105257,'node',26),('1371042544',105256,'node',26),('1371042544',105255,'node',26),('1371042544',105260,'node',26),('1371042544',105259,'node',26),('1371042544',105258,'node',26),('1371042544',105263,'node',26),('1371042544',105262,'node',26),('1371042544',105261,'node',26),('1371042544',105266,'node',26),('1371042544',105265,'node',26),('1371042544',105264,'node',26),('1371042544',105269,'node',26),('1371042544',105268,'node',26),('1371042544',105267,'node',26),('1371042544',105272,'node',26),('1371042544',105271,'node',26),('1371042544',105270,'node',26),('1371628866',192210,'node',26),('1371628865',192209,'node',26),('1371628865',192208,'node',26),('1371629167',192286,'node',26),('1371629166',192282,'node',26),('1371629167',192284,'node',26),('1371223562',127796,'node',26),('1371223562',127795,'node',26),('1371629287',192322,'node',26),('1371223502',127790,'node',26),('1371223502',127791,'node',26),('1371223442',127787,'node',26),('1371223442',127786,'node',26),('1371223382',127783,'node',26),('1371223382',127782,'node',26),('1371223332',127780,'node',26),('1371223262',127775,'node',26),('1371223332',127779,'node',26),('1371223202',127771,'node',26),('1371223262',127774,'node',26),('1371223202',127770,'node',26),('1371223142',127767,'node',26),('1371223082',127763,'node',26),('1371223142',127766,'node',26),('1371629650',192418,'node',26),('1371629650',192420,'node',26),('1371223082',127762,'node',26),('1371223022',127759,'node',26),('1371222962',127755,'node',26),('1371223022',127758,'node',26),('1371629649',192412,'node',26),('1371629650',192416,'node',26),('1371222962',127754,'node',26),('1371222902',127751,'node',26),('1371222902',127750,'node',26),('1371222842',127747,'node',26),('1371222842',127746,'node',26),('1371222782',127743,'node',26),('1371222782',127742,'node',26),('1371222722',127739,'node',26),('5000',127739,'node',1),('1371222722',127738,'node',26),('1371222662',127735,'node',26),('1371222662',127734,'node',26),('1371222602',127731,'node',26),('1371222602',127730,'node',26),('1371222542',127727,'node',26),('1371222542',127726,'node',26),('1371222482',127723,'node',26),('1371222482',127722,'node',26),('1371222422',127719,'node',26),('1371222362',127714,'node',26),('1371222302',127711,'node',26),('1371222302',127710,'node',26),('1371222422',127718,'node',26),('1371629470',192378,'node',26),('1371222362',127715,'node',26),('1371629470',192376,'node',26),('1371222242',127707,'node',26),('1371222242',127706,'node',26),('1371222182',127703,'node',26),('1371222182',127702,'node',26),('1371222122',127699,'node',26),('1371222122',127698,'node',26),('1371222063',127695,'node',26),('1371222063',127694,'node',26),('1371222002',127691,'node',26),('1371221942',127687,'node',26),('1371222002',127690,'node',26),('1371221942',127686,'node',26),('1371221882',127683,'node',26),('1371221882',127682,'node',26),('1371221822',127679,'node',26),('1371221822',127678,'node',26),('1371221762',127675,'node',26),('1371221762',127674,'node',26),('1371221703',127671,'node',26),('1371221703',127670,'node',26),('1371221643',127667,'node',26),('1371221643',127666,'node',26),('1371221582',127662,'node',26),('1371221582',127663,'node',26),('1371629402',192347,'node',26),('1371221524',127659,'node',26),('1371629396',192345,'node',26),('1371221462',127655,'node',26),('1371629351',192343,'node',26),('1371221524',127658,'node',26),('1371221462',127654,'node',26),('1371221401',127650,'node',26),('1371221401',127651,'node',26),('1371221342',127647,'node',26),('1371221342',127646,'node',26),('1371221282',127643,'node',26),('1371221282',127642,'node',26),('1371221162',127635,'node',26),('1371221162',127634,'node',26),('1371221102',127631,'node',26),('1371221222',127639,'node',26),('1371221222',127638,'node',26),('1371559276',141750,'node',26),('1371559276',141749,'node',26),('1371559276',141748,'node',26),('1371559276',141747,'node',26),('1371559276',141746,'node',26),('1371559276',141745,'node',26),('1371559276',141744,'node',26),('1371559276',141743,'node',26),('1371559276',141742,'node',26),('1371559276',141741,'node',26),('1371559276',141740,'node',26),('1371559276',141769,'node',26),('1371559276',141768,'node',26),('1371559276',141767,'node',26),('1371559276',141766,'node',26),('1371559276',141765,'node',26),('1371559276',141764,'node',26),('1371559276',141763,'node',26),('1371559276',141762,'node',26),('1371559276',141761,'node',26),('1371559276',141760,'node',26),('1371559276',141759,'node',26),('1371559276',141758,'node',26),('1371559276',141757,'node',26),('1371559276',141756,'node',26),('1371559276',141755,'node',26),('1371559276',141754,'node',26),('1371559276',141753,'node',26),('1371559276',141752,'node',26),('1371559276',141751,'node',26),('1371559276',141772,'node',26),('1371559276',141771,'node',26),('1371559276',141770,'node',26),('1371559323',141844,'node',26),('1371559323',141843,'node',26),('1371559323',141842,'node',26),('1371559323',141841,'node',26),('1371559323',141840,'node',26),('1371559323',141839,'node',26),('1371559323',141838,'node',26),('1371559323',141837,'node',26),('1371559323',141836,'node',26),('1371559323',141835,'node',26),('1371559323',141834,'node',26),('1371559323',141833,'node',26),('1371559323',141832,'node',26),('1371559323',141831,'node',26),('1371559323',141830,'node',26),('1371559323',141829,'node',26),('1371559314',141826,'node',26),('1371559307',141824,'node',26),('1371559300',141822,'node',26),('1371559293',141820,'node',26),('1371559293',141819,'node',26),('1371559293',141818,'node',26),('1681',141816,'node',1),('1371559286',141816,'node',26),('1568',141815,'node',1),('1371559286',141815,'node',26),('1687',141814,'node',1),('1371559286',141814,'node',26),('1626',141813,'node',1),('1371559286',141813,'node',26),('1740',141812,'node',1),('1371559286',141812,'node',26),('1753',141811,'node',1),('1371559286',141811,'node',26),('1643',141810,'node',1),('1371559286',141810,'node',26),('1747',141809,'node',1),('1371559286',141809,'node',26),('1630',141807,'node',1),('1371559285',141807,'node',26),('1694',141806,'node',1),('1371559285',141806,'node',26),('1793',141805,'node',1),('1371559285',141805,'node',26),('1571',141804,'node',1),('1371559285',141804,'node',26),('1718',141803,'node',1),('1371559285',141803,'node',26),('1832',141802,'node',1),('1371559285',141802,'node',26),('1708',141801,'node',1),('1371559285',141801,'node',26),('1693',141800,'node',1),('1371559285',141800,'node',26),('1371559276',141798,'node',26),('1371559276',141797,'node',26),('1371559276',141796,'node',26),('1371559276',141795,'node',26),('1371559276',141794,'node',26),('1371559276',141793,'node',26),('1371559276',141792,'node',26),('1371559276',141791,'node',26),('1371559276',141790,'node',26),('1371559276',141789,'node',26),('1371559276',141788,'node',26),('1371559276',141787,'node',26),('1371559276',141786,'node',26),('1371559276',141785,'node',26),('1371559276',141784,'node',26),('1371559276',141783,'node',26),('1371559276',141782,'node',26),('1371559276',141781,'node',26),('1371559276',141780,'node',26),('1371559276',141779,'node',26),('1371559276',141778,'node',26),('1371559276',141777,'node',26),('1371559276',141776,'node',26),('1371559276',141775,'node',26),('1371559276',141774,'node',26),('1371559276',141773,'node',26),('1371630428',192666,'node',26),('1371630306',192622,'node',26),('1371630306',192621,'node',26),('1371630306',192623,'node',26),('1337',192626,'node',1),('1371630306',192626,'node',26),('1371630306',192624,'node',26),('1371630307',192628,'node',26),('1371630307',192630,'node',26),('1371630307',192629,'node',26),('1371630307',192632,'node',26),('1371630307',192636,'node',26),('1371630307',192634,'node',26),('1371630366',192639,'node',26),('1371630366',192641,'node',26),('1371630366',192640,'node',26),('1371630366',192642,'node',26),('1371630366',192644,'node',26),('1371630366',192643,'node',26),('1371630366',192645,'node',26),('291',192648,'node',1),('1371630367',192648,'node',26),('1371630366',192646,'node',26),('1371630367',192650,'node',26),('1371630367',192652,'node',26),('1371630367',192651,'node',26),('1371630428',192662,'node',26),('1371630428',192661,'node',26),('1371630368',192658,'node',26),('1371630367',192656,'node',26),('1371630367',192654,'node',26),('1371630428',192663,'node',26),('1371630428',192664,'node',26),('1371630428',192665,'node',26),('1371630245',192597,'node',26),('1371630245',192601,'node',26),('1371630245',192600,'node',26),('1371630245',192599,'node',26),('1371630245',192598,'node',26),('1371630245',192602,'node',26),('1371630246',192606,'node',26),('971',192604,'node',1),('1371630246',192604,'node',26),('1371630246',192607,'node',26),('1371630247',192614,'node',26),('1371630247',192612,'node',26),('1371630246',192608,'node',26),('1371630247',192610,'node',26),('1371630186',192573,'node',26),('1371630186',192574,'node',26),('1371630186',192575,'node',26),('1371630186',192577,'node',26),('1371630186',192576,'node',26),('1371630186',192578,'node',26),('1304',192582,'node',1),('1371630187',192582,'node',26),('1371630186',192580,'node',26),('1371630186',192579,'node',26),('1371630187',192590,'node',26),('1371630187',192588,'node',26),('1371630187',192586,'node',26),('1371630245',192596,'node',26),('1371630245',192595,'node',26),('1371630188',192592,'node',26),('1371630187',192584,'node',26),('1371630187',192585,'node',26),('1371630127',192566,'node',26),('1371630128',192568,'node',26),('1371630128',192570,'node',26),('1371630428',192668,'node',26),('1371630428',192667,'node',26),('6667',192670,'node',1),('1371630429',192670,'node',26),('1371630429',192672,'node',26),('1371630429',192673,'node',26),('1371630607',192727,'node',26),('1371630489',192696,'node',26),('1371630490',192698,'node',26),('1371630490',192700,'node',26),('1371630555',192705,'node',26),('1371630490',192702,'node',26),('1371630555',192709,'node',26),('1371630555',192708,'node',26),('1371630555',192706,'node',26),('1371630555',192707,'node',26),('1371630555',192710,'node',26),('1371630556',192724,'node',26),('1371630556',192722,'node',26),('1371630556',192720,'node',26),('1371630556',192718,'node',26),('1371630556',192717,'node',26),('1371630556',192716,'node',26),('1371630555',192714,'node',26),('779',192714,'node',1),('1371630555',192712,'node',26),('1371630555',192711,'node',26),('1371630607',192730,'node',26),('1371630489',192690,'node',26),('1371630489',192692,'node',26),('1371630489',192689,'node',26),('1371630489',192688,'node',26),('1371630489',192686,'node',26),('1371630489',192687,'node',26),('1371630489',192685,'node',26),('1371630430',192680,'node',26),('1371630489',192683,'node',26),('1371630489',192684,'node',26),('1371630429',192674,'node',26),('1371630430',192678,'node',26),('1371630430',192676,'node',26),('1371630489',192695,'node',26),('1371630489',192694,'node',26),('1371630666',192753,'node',26),('1371630666',192754,'node',26),('1371630666',192752,'node',26),('1371630666',192751,'node',26),('1371630666',192750,'node',26),('1371630666',192749,'node',26),('1371630667',192766,'node',26),('1371630667',192768,'node',26),('1371630667',192762,'node',26),('1371630667',192764,'node',26),('1371630667',192761,'node',26),('1371630667',192760,'node',26),('1371630725',192774,'node',26),('1371630725',192772,'node',26),('1371630725',192771,'node',26),('1371630725',192773,'node',26),('1371630607',192740,'node',26),('1371630608',192742,'node',26),('1371630608',192744,'node',26),('1371630607',192739,'node',26),('1371630607',192736,'node',26),('6667',192736,'node',1),('1371630607',192738,'node',26),('1371630607',192733,'node',26),('1371630607',192734,'node',26),('1371630607',192732,'node',26),('1371630607',192731,'node',26),('1371630608',192746,'node',26),('1371630787',192812,'node',26),('1371630845',192815,'node',26),('1371630787',192810,'node',26),('1371630785',192795,'node',26),('1371630785',192794,'node',26),('1371630786',192808,'node',26),('1371630785',192800,'node',26),('1371630785',192799,'node',26),('1371630785',192798,'node',26),('1371630785',192796,'node',26),('1371630785',192797,'node',26),('1371630786',192802,'node',26),('1371630786',192805,'node',26),('1371630786',192806,'node',26),('1371630786',192804,'node',26),('1371630726',192786,'node',26),('1371630726',192783,'node',26),('1371630726',192784,'node',26),('1371630726',192782,'node',26),('1371630726',192780,'node',26),('1371630725',192778,'node',26),('1371630725',192776,'node',26),('1371630725',192775,'node',26),('1371630725',192777,'node',26),('1371630727',192790,'node',26),('1371630727',192788,'node',26),('1371630785',192793,'node',26),('1371567364',153933,'node',26),('1371567364',153932,'node',26),('1371567364',153931,'node',26),('1371567364',153930,'node',26),('1371567364',153929,'node',26),('1371567364',153928,'node',26),('1371567310',153925,'node',26),('1371567310',153923,'node',26),('1371567364',153956,'node',26),('1371567364',153955,'node',26),('1371567364',153954,'node',26),('1371567364',153953,'node',26),('1371567364',153952,'node',26),('1371567364',153951,'node',26),('1371567364',153950,'node',26),('1371567364',153949,'node',26),('1371567364',153948,'node',26),('1371567364',153947,'node',26),('1371567364',153946,'node',26),('1371567364',153966,'node',26),('1371567364',153965,'node',26),('1371567364',153964,'node',26),('1371567364',153963,'node',26),('1371567364',153962,'node',26),('1371567364',153961,'node',26),('1371567364',153960,'node',26),('1371567364',153959,'node',26),('1371567364',153958,'node',26),('1371567364',153957,'node',26),('1371567364',153974,'node',26),('1371567364',153973,'node',26),('1371567364',153972,'node',26),('1371567364',153971,'node',26),('1371567364',153970,'node',26),('1371567364',153969,'node',26),('1371567364',153968,'node',26),('1371567364',153967,'node',26),('1371567364',153975,'node',26),('1371567424',154034,'node',26),('1371567424',154033,'node',26),('1371567424',154032,'node',26),('1371567424',154031,'node',26),('1371567424',154030,'node',26),('1371567424',154029,'node',26),('1371567424',154028,'node',26),('1371567424',154027,'node',26),('1371567424',154026,'node',26),('1371567424',154025,'node',26),('1371567424',154024,'node',26),('1371567424',154023,'node',26),('1371567424',154022,'node',26),('1371567424',154021,'node',26),('1371567424',154020,'node',26),('1371567424',154019,'node',26),('1371567370',154016,'node',26),('1371567369',154014,'node',26),('1371567369',154012,'node',26),('1371567369',154010,'node',26),('1371567369',154009,'node',26),('1371567369',154008,'node',26),('1371567369',154006,'node',26),('1571',154004,'node',1),('1371567368',154004,'node',26),('1587',154003,'node',1),('1371567368',154003,'node',26),('1502',154002,'node',1),('1371567368',154002,'node',26),('1605',153990,'node',1),('1371567367',153990,'node',26),('1714',153989,'node',1),('1371567367',153989,'node',26),('1704',153988,'node',1),('1371567367',153988,'node',26),('1371567364',153986,'node',26),('1538',153992,'node',1),('1371567367',153992,'node',26),('1653',153991,'node',1),('1371567367',153991,'node',26),('1371567364',153985,'node',26),('1371567364',153984,'node',26),('1371567367',153995,'node',26),('1652',153994,'node',1),('1371567367',153994,'node',26),('1564',153993,'node',1),('1371567367',153993,'node',26),('1371567364',153983,'node',26),('1542',153998,'node',1),('1371567368',153998,'node',26),('1671',153997,'node',1),('1371567368',153997,'node',26),('1672',153995,'node',1),('1371567364',153982,'node',26),('1705',154000,'node',1),('1371567368',154000,'node',26),('1557',153999,'node',1),('1371567368',153999,'node',26),('1371567364',153981,'node',26),('1371567364',153980,'node',26),('1634',154001,'node',1),('1371567368',154001,'node',26),('1371567364',153979,'node',26),('1371567364',153978,'node',26),('1371567364',153977,'node',26),('1371567364',153976,'node',26),('1371567424',154036,'node',26),('1371567424',154035,'node',26),('1371567424',154046,'node',26),('1371567424',154045,'node',26),('1371567424',154044,'node',26),('1371567424',154043,'node',26),('1371567424',154042,'node',26),('1371567424',154041,'node',26),('1371567424',154040,'node',26),('1371567424',154039,'node',26),('1371567424',154038,'node',26),('1371567424',154037,'node',26),('1371567483',154132,'node',26),('1371567483',154131,'node',26),('1371567483',154130,'node',26),('1371567483',154129,'node',26),('1371567483',154128,'node',26),('1371567483',154127,'node',26),('1371567483',154126,'node',26),('1371567483',154125,'node',26),('1371567483',154124,'node',26),('1371567483',154123,'node',26),('1371567483',154122,'node',26),('1371567483',154121,'node',26),('1371567483',154120,'node',26),('1371567483',154119,'node',26),('1371567483',154118,'node',26),('1371567483',154117,'node',26),('1371567483',154116,'node',26),('1371567483',154115,'node',26),('1371567483',154114,'node',26),('1371567483',154113,'node',26),('1371567483',154112,'node',26),('1371567483',154111,'node',26),('1371567483',154110,'node',26),('1371567430',154107,'node',26),('1371567429',154105,'node',26),('1371567429',154103,'node',26),('1371567429',154101,'node',26),('1371567429',154100,'node',26),('1371567429',154099,'node',26),('1371567429',154097,'node',26),('1720',154095,'node',1),('1371567428',154095,'node',26),('1606',154094,'node',1),('1371567428',154094,'node',26),('1632',154093,'node',1),('1371567428',154093,'node',26),('1523',154092,'node',1),('1371567428',154092,'node',26),('1634',154091,'node',1),('1371567428',154091,'node',26),('1424',154090,'node',1),('1371567428',154090,'node',26),('1666',154089,'node',1),('1371567428',154089,'node',26),('1653',154088,'node',1),('1371567428',154088,'node',26),('1513',154086,'node',1),('1371567427',154086,'node',26),('1643',154085,'node',1),('1371567427',154085,'node',26),('1675',154084,'node',1),('1371567427',154084,'node',26),('1533',154083,'node',1),('1371567427',154083,'node',26),('1626',154082,'node',1),('1371567427',154082,'node',26),('1692',154081,'node',1),('1371567427',154081,'node',26),('1642',154080,'node',1),('1371567427',154080,'node',26),('1554',154079,'node',1),('1371567427',154079,'node',26),('1371567424',154077,'node',26),('1371567424',154076,'node',26),('1371567424',154075,'node',26),('1371567424',154074,'node',26),('1371567424',154073,'node',26),('1371567424',154072,'node',26),('1371567424',154071,'node',26),('1371567424',154070,'node',26),('1371567424',154069,'node',26),('1371567424',154068,'node',26),('1371567424',154067,'node',26),('1371567424',154066,'node',26),('1371567424',154065,'node',26),('1371567424',154064,'node',26),('1371567424',154063,'node',26),('1371567424',154062,'node',26),('1371567424',154061,'node',26),('1371567424',154060,'node',26),('1371567424',154059,'node',26),('1371567424',154058,'node',26),('1371567424',154057,'node',26),('1371567424',154056,'node',26),('1371567424',154055,'node',26),('1371567424',154054,'node',26),('1371567424',154053,'node',26),('1371567424',154052,'node',26),('1371567424',154051,'node',26),('1371567424',154050,'node',26),('1371567424',154049,'node',26),('1371567424',154048,'node',26),('1371567424',154047,'node',26),('1371567483',154143,'node',26),('1371567483',154142,'node',26),('1371567483',154141,'node',26),('1371567483',154140,'node',26),('1371567543',154208,'node',26),('1371567543',154207,'node',26),('1371567543',154206,'node',26),('1371567543',154205,'node',26),('1371567543',154204,'node',26),('1371567543',154203,'node',26),('1371567543',154202,'node',26),('1371567543',154201,'node',26),('1371567490',154198,'node',26),('1371567489',154196,'node',26),('1371567489',154194,'node',26),('1371567489',154192,'node',26),('1371567489',154191,'node',26),('1371567489',154190,'node',26),('1371567488',154188,'node',26),('1573',154186,'node',1),('1371567488',154186,'node',26),('1558',154185,'node',1),('1371567488',154185,'node',26),('1550',154184,'node',1),('1371567488',154184,'node',26),('1549',154183,'node',1),('1371567488',154183,'node',26),('1634',154182,'node',1),('1371567488',154182,'node',26),('1610',154181,'node',1),('1371567488',154181,'node',26),('1515',154180,'node',1),('1371567488',154180,'node',26),('1692',154179,'node',1),('1371567488',154179,'node',26),('1573',154177,'node',1),('1371567487',154177,'node',26),('1654',154176,'node',1),('1371567487',154176,'node',26),('1747',154175,'node',1),('1371567487',154175,'node',26),('1420',154174,'node',1),('1371567487',154174,'node',26),('1537',154173,'node',1),('1371567487',154173,'node',26),('1686',154172,'node',1),('1371567487',154172,'node',26),('1643',154171,'node',1),('1371567487',154171,'node',26),('1648',154170,'node',1),('1371567487',154170,'node',26),('1371567483',154168,'node',26),('1371567483',154167,'node',26),('1371567483',154166,'node',26),('1371567483',154165,'node',26),('1371567483',154164,'node',26),('1371567483',154157,'node',26),('1371567483',154156,'node',26),('1371567483',154155,'node',26),('1371567483',154154,'node',26),('1371567483',154153,'node',26),('1371567483',154152,'node',26),('1371567483',154160,'node',26),('1371567483',154159,'node',26),('1371567483',154158,'node',26),('1371567483',154151,'node',26),('1371567483',154150,'node',26),('1371567483',154163,'node',26),('1371567483',154162,'node',26),('1371567483',154161,'node',26),('1371567483',154149,'node',26),('1371567483',154148,'node',26),('1371567483',154147,'node',26),('1371567483',154146,'node',26),('1371567483',154145,'node',26),('1371567483',154144,'node',26),('1371567543',154229,'node',26),('1371567543',154228,'node',26),('1371567543',154227,'node',26),('1371567543',154226,'node',26),('1371567543',154225,'node',26),('1371567543',154224,'node',26),('1371567543',154223,'node',26),('1371567543',154222,'node',26),('1371567543',154221,'node',26),('1371567543',154220,'node',26),('1371567543',154219,'node',26),('1371567543',154218,'node',26),('1371567543',154217,'node',26),('1371567543',154216,'node',26),('1371567543',154246,'node',26),('1371567543',154245,'node',26),('1371567543',154244,'node',26),('1371567543',154243,'node',26),('1371567543',154242,'node',26),('1371567543',154241,'node',26),('1371567543',154240,'node',26),('1371567543',154239,'node',26),('1371567543',154238,'node',26),('1371567543',154237,'node',26),('1371567543',154236,'node',26),('1371567543',154235,'node',26),('1371567543',154234,'node',26),('1371567543',154233,'node',26),('1371567543',154232,'node',26),('1371567543',154231,'node',26),('1371567543',154230,'node',26),('1371567543',154250,'node',26),('1371567543',154249,'node',26),('1371567543',154248,'node',26),('1371567543',154247,'node',26),('1371567543',154252,'node',26),('1371567543',154251,'node',26),('1371567604',154319,'node',26),('1371567604',154318,'node',26),('1371567604',154317,'node',26),('1371567604',154316,'node',26),('1371567604',154315,'node',26),('1371567604',154314,'node',26),('1371567604',154313,'node',26),('1371567604',154312,'node',26),('1371567604',154311,'node',26),('1371567604',154310,'node',26),('1371567604',154309,'node',26),('1371567604',154308,'node',26),('1371567604',154307,'node',26),('1371567604',154306,'node',26),('1371567604',154305,'node',26),('1371567604',154304,'node',26),('1371567604',154303,'node',26),('1371567604',154302,'node',26),('1371567604',154301,'node',26),('1371567604',154300,'node',26),('1371567604',154299,'node',26),('1371567604',154298,'node',26),('1371567604',154297,'node',26),('1371567604',154296,'node',26),('1371567604',154295,'node',26),('1371567604',154294,'node',26),('1371567604',154293,'node',26),('1371567604',154292,'node',26),('1371567550',154289,'node',26),('1371567549',154287,'node',26),('1371567549',154285,'node',26),('1371567549',154283,'node',26),('1371567549',154282,'node',26),('1371567549',154281,'node',26),('1371567549',154279,'node',26),('1610',154277,'node',1),('1371567548',154277,'node',26),('1601',154276,'node',1),('1371567548',154276,'node',26),('1569',154275,'node',1),('1371567548',154275,'node',26),('1647',154274,'node',1),('1371567548',154274,'node',26),('1614',154273,'node',1),('1371567548',154273,'node',26),('1660',154272,'node',1),('1371567548',154272,'node',26),('1576',154271,'node',1),('1371567548',154271,'node',26),('1560',154270,'node',1),('1371567548',154270,'node',26),('1692',154268,'node',1),('1371567547',154268,'node',26),('1612',154267,'node',1),('1371567547',154267,'node',26),('1637',154266,'node',1),('1371567547',154266,'node',26),('1753',154265,'node',1),('1371567547',154265,'node',26),('1533',154264,'node',1),('1371567547',154264,'node',26),('1608',154263,'node',1),('1371567547',154263,'node',26),('1624',154262,'node',1),('1371567547',154262,'node',26),('1722',154261,'node',1),('1371567547',154261,'node',26),('1371567543',154259,'node',26),('1371567543',154258,'node',26),('1371567543',154257,'node',26),('1371567543',154256,'node',26),('1371567543',154255,'node',26),('1371567543',154254,'node',26),('1371567543',154253,'node',26),('1371567604',154343,'node',26),('1371567604',154342,'node',26),('1371567604',154341,'node',26),('1371567604',154340,'node',26),('1371567604',154339,'node',26),('1371567604',154338,'node',26),('1371567604',154337,'node',26),('1371567604',154336,'node',26),('1371567604',154335,'node',26),('1371567604',154334,'node',26),('1371567604',154333,'node',26),('1371567604',154332,'node',26),('1371567604',154331,'node',26),('1371567604',154330,'node',26),('1371567604',154329,'node',26),('1371567607',154355,'node',26),('1586',154354,'node',1),('1371567607',154354,'node',26),('1618',154353,'node',1),('1371567607',154353,'node',26),('1578',154352,'node',1),('1371567607',154352,'node',26),('1371567604',154350,'node',26),('1371567604',154349,'node',26),('1371567604',154348,'node',26),('1371567604',154347,'node',26),('1371567604',154346,'node',26),('1371567604',154345,'node',26),('1371567604',154344,'node',26),('1670',154362,'node',1),('1371567608',154362,'node',26),('1608',154361,'node',1),('1371567608',154361,'node',26),('1668',154359,'node',1),('1371567607',154359,'node',26),('1589',154358,'node',1),('1371567607',154358,'node',26),('1641',154357,'node',1),('1371567607',154357,'node',26),('1647',154356,'node',1),('1371567607',154356,'node',26),('1594',154355,'node',1),('1606',154363,'node',1),('1371567608',154363,'node',26),('1371567664',154413,'node',26),('1508',154364,'node',1),('1371567608',154364,'node',26),('1694',154365,'node',1),('1371567608',154365,'node',26),('1700',154366,'node',1),('1371567608',154366,'node',26),('1544',154368,'node',1),('1371567608',154368,'node',26),('1621',154367,'node',1),('1371567608',154367,'node',26),('1371567609',154370,'node',26),('1371567609',154373,'node',26),('1371567609',154372,'node',26),('1371567609',154374,'node',26),('1371567609',154378,'node',26),('1371567609',154376,'node',26),('1371567610',154380,'node',26),('1371567664',154383,'node',26),('1371567664',154385,'node',26),('1371567664',154384,'node',26),('1371567664',154386,'node',26),('1371567664',154387,'node',26),('1371567664',154388,'node',26),('1371567664',154390,'node',26),('1371567664',154389,'node',26),('1371567664',154391,'node',26),('1371567664',154393,'node',26),('1371567664',154392,'node',26),('1371567664',154394,'node',26),('1371567664',154395,'node',26),('1371567664',154397,'node',26),('1371567664',154396,'node',26),('1371567664',154398,'node',26),('1371567664',154399,'node',26),('1371567664',154401,'node',26),('1371567664',154400,'node',26),('1371567664',154402,'node',26),('1371567664',154404,'node',26),('1371567664',154403,'node',26),('1371567664',154405,'node',26),('1371567664',154406,'node',26),('1371567664',154407,'node',26),('1371567664',154409,'node',26),('1371567664',154408,'node',26),('1371567664',154410,'node',26),('1371567664',154411,'node',26),('1371567664',154412,'node',26),('1371567664',154422,'node',26),('1371567664',154421,'node',26),('1371567664',154423,'node',26),('1371567664',154424,'node',26),('1371567664',154426,'node',26),('1371567664',154425,'node',26),('1371567664',154427,'node',26),('1371567664',154428,'node',26),('1371567664',154429,'node',26),('1371567664',154431,'node',26),('1371567664',154430,'node',26),('1371567664',154432,'node',26),('1371567664',154433,'node',26),('1371567664',154435,'node',26),('1371567664',154434,'node',26),('1371567664',154436,'node',26),('1371567664',154437,'node',26),('1371567664',154439,'node',26),('1371567664',154438,'node',26),('1371567664',154440,'node',26),('1371567664',154441,'node',26),('1753',154444,'node',1),('1371567667',154444,'node',26),('1621',154443,'node',1),('1371567667',154443,'node',26),('1623',154445,'node',1),('1371567667',154445,'node',26),('1663',154446,'node',1),('1371567667',154446,'node',26),('1591',154447,'node',1),('1371567667',154447,'node',26),('1619',154449,'node',1),('1371567667',154449,'node',26),('1627',154448,'node',1),('1371567667',154448,'node',26),('1588',154454,'node',1),('1371567668',154454,'node',26),('1678',154453,'node',1),('1371567668',154453,'node',26),('1711',154452,'node',1),('1371567668',154452,'node',26),('1798',154450,'node',1),('1371567667',154450,'node',26),('1371567669',154461,'node',26),('1556',154459,'node',1),('1371567668',154459,'node',26),('1614',154458,'node',1),('1371567668',154458,'node',26),('1580',154457,'node',1),('1371567668',154457,'node',26),('1618',154456,'node',1),('1371567668',154456,'node',26),('1517',154455,'node',1),('1371567668',154455,'node',26),('1371567669',154464,'node',26),('1371567669',154463,'node',26),('1371567669',154465,'node',26),('1371567669',154467,'node',26),('1371567670',154471,'node',26),('1371567669',154469,'node',26),('1371567723',154474,'node',26),('1371567723',154475,'node',26),('1371567723',154477,'node',26),('1371567723',154476,'node',26),('1371567723',154478,'node',26),('1371567723',154479,'node',26),('hgw2k8r232vm17',141363,'node',26),('hgw2k8r232vm21',141367,'node',26),('1371567723',154481,'node',26),('1371567723',154480,'node',26),('1371567723',154482,'node',26),('1371567723',154484,'node',26),('1371567723',154483,'node',26),('1371567723',154485,'node',26),('1371567723',154487,'node',26),('1371567723',154486,'node',26),('1371567723',154488,'node',26),('1371567723',154489,'node',26),('1371567723',154491,'node',26),('1371567723',154490,'node',26),('1371567723',154492,'node',26),('1371567723',154494,'node',26),('1371567723',154493,'node',26),('1371567723',154495,'node',26),('1371567723',154496,'node',26),('1371567723',154498,'node',26),('1371567723',154497,'node',26),('1371567723',154500,'node',26),('1371567723',154499,'node',26),('1371567723',154501,'node',26),('1371567723',154502,'node',26),('1371567723',154503,'node',26),('1371567723',154505,'node',26),('1371567723',154504,'node',26),('1371567723',154506,'node',26),('1371567723',154507,'node',26),('1371567723',154509,'node',26),('1371567723',154508,'node',26),('1371567723',154510,'node',26),('1371567723',154511,'node',26),('1371567723',154513,'node',26),('1371567723',154512,'node',26),('1371567723',154514,'node',26),('1371567723',154516,'node',26),('1371567723',154515,'node',26),('1371567723',154518,'node',26),('1371567723',154517,'node',26),('1371567723',154520,'node',26),('1371567723',154519,'node',26),('1371567723',154522,'node',26),('1371567723',154521,'node',26),('1371567723',154524,'node',26),('1371567723',154523,'node',26),('1371567723',154526,'node',26),('1371567723',154525,'node',26),('1371567723',154528,'node',26),('1371567723',154527,'node',26),('1371567723',154530,'node',26),('1371567723',154529,'node',26),('1371567723',154531,'node',26),('1371567723',154532,'node',26),('1695',154534,'node',1),('1371567727',154534,'node',26),('1371567727',154535,'node',26),('1737',154535,'node',1),('1584',154536,'node',1),('1371567727',154536,'node',26),('1564',154537,'node',1),('1371567727',154537,'node',26),('1371567728',154552,'node',26),('1527',154550,'node',1),('1371567728',154550,'node',26),('1535',154549,'node',1),('1371567728',154549,'node',26),('1760',154548,'node',1),('1371567728',154548,'node',26),('1605',154547,'node',1),('1371567728',154547,'node',26),('1536',154538,'node',1),('1371567727',154538,'node',26),('1492',154546,'node',1),('1371567728',154546,'node',26),('1538',154545,'node',1),('1371567728',154545,'node',26),('1630',154544,'node',1),('1680',154539,'node',1),('1371567727',154539,'node',26),('1371567728',154544,'node',26),('1580',154543,'node',1),('1371567728',154543,'node',26),('1534',154541,'node',1),('1371567727',154541,'node',26),('1574',154540,'node',1),('1371567727',154540,'node',26),('1371567729',154554,'node',26),('1371567729',154555,'node',26),('1371567729',154556,'node',26),('1371567729',154558,'node',26),('1371567729',154562,'node',26),('1371567729',154560,'node',26),('1371567783',154565,'node',26),('1371567783',154566,'node',26),('1371567783',154575,'node',26),('1371567783',154576,'node',26),('1371567783',154577,'node',26),('1371567783',154579,'node',26),('1371567783',154578,'node',26),('1371567783',154580,'node',26),('1371567783',154581,'node',26),('1371567783',154583,'node',26),('1371567783',154582,'node',26),('1371567783',154584,'node',26),('1371567783',154585,'node',26),('1371567783',154586,'node',26),('1371567783',154588,'node',26),('1371567783',154587,'node',26),('1371567783',154610,'node',26),('1371567783',154609,'node',26),('1371567783',154608,'node',26),('1371567783',154611,'node',26),('1371567783',154612,'node',26),('1371567783',154613,'node',26),('1371567783',154614,'node',26),('1371567783',154615,'node',26),('1371567783',154616,'node',26),('1371567783',154619,'node',26),('1371567783',154618,'node',26),('1371567783',154617,'node',26),('1371567783',154620,'node',26),('1371567783',154621,'node',26),('1371567783',154622,'node',26),('1543',154625,'node',1),('1371567786',154625,'node',26),('1371567783',154623,'node',26),('1642',154626,'node',1),('1371567786',154626,'node',26),('1612',154627,'node',1),('1371567786',154627,'node',26),('1654',154628,'node',1),('1371567786',154628,'node',26),('1592',154630,'node',1),('1371567786',154630,'node',26),('1621',154629,'node',1),('1371567786',154629,'node',26),('1633',154631,'node',1),('1371567786',154631,'node',26),('1597',154632,'node',1),('1371567786',154632,'node',26),('1663',154634,'node',1),('1371567787',154634,'node',26),('1650',154636,'node',1),('1371567787',154636,'node',26),('1475',154635,'node',1),('1371567787',154635,'node',26),('1688',154637,'node',1),('1371567787',154637,'node',26),('1592',154638,'node',1),('1371567787',154638,'node',26),('1612',154639,'node',1),('1371567787',154639,'node',26),('1635',154641,'node',1),('1371567787',154641,'node',26),('1637',154640,'node',1),('1371567787',154640,'node',26),('1371567788',154643,'node',26),('1371567788',154645,'node',26),('1371567788',154647,'node',26),('1371567788',154646,'node',26),('1371567788',154649,'node',26),('1371567844',154656,'node',26),('1371567789',154653,'node',26),('1371567789',154651,'node',26),('1371567844',154660,'node',26),('1371567844',154659,'node',26),('1371567844',154658,'node',26),('1371567844',154657,'node',26),('1371567844',154661,'node',26),('1371567844',154663,'node',26),('1371567844',154662,'node',26),('1371567844',154665,'node',26),('1371567844',154664,'node',26),('1371567844',154666,'node',26),('1371567844',154667,'node',26),('1371567844',154669,'node',26),('1371567844',154668,'node',26),('1371567844',154670,'node',26),('1371567844',154671,'node',26),('1371567844',154673,'node',26),('1371567844',154672,'node',26),('1371567844',154674,'node',26),('1371567844',154675,'node',26),('1371567844',154677,'node',26),('1371567844',154676,'node',26),('1371567844',154678,'node',26),('1371567844',154679,'node',26),('1371567844',154680,'node',26),('1371567844',154682,'node',26),('1371567844',154681,'node',26),('1371567844',154683,'node',26),('1371567844',154684,'node',26),('1371567844',154685,'node',26),('1371567844',154686,'node',26),('1371567844',154688,'node',26),('1371567844',154687,'node',26),('1371567844',154689,'node',26),('1371567844',154690,'node',26),('1371567844',154691,'node',26),('1371567844',154693,'node',26),('1371567844',154692,'node',26),('1371567844',154694,'node',26),('1371567844',154695,'node',26),('1371567844',154696,'node',26),('1371567844',154697,'node',26),('1371574564',164849,'node',26),('1371574564',164848,'node',26),('1371574564',164851,'node',26),('1371574564',164850,'node',26),('1371574564',164852,'node',26),('1371574564',164854,'node',26),('1371574564',164853,'node',26),('1371574564',164855,'node',26),('1371574564',164857,'node',26),('1371574564',164856,'node',26),('1371574564',164858,'node',26),('1371574564',164859,'node',26),('1371574564',164861,'node',26),('1371574564',164860,'node',26),('1371574564',164863,'node',26),('1371574564',164862,'node',26),('1371574564',164864,'node',26),('1371574564',164865,'node',26),('1371574564',164866,'node',26),('1371574564',164868,'node',26),('1371574564',164867,'node',26),('1371574564',164869,'node',26),('1371574564',164870,'node',26),('1371574564',164871,'node',26),('1371574564',164872,'node',26),('1371574564',164874,'node',26),('1371574564',164873,'node',26),('1371574564',164875,'node',26),('1371574564',164876,'node',26),('1371574564',164877,'node',26),('1371574564',164879,'node',26),('1371574564',164878,'node',26),('1371574564',164880,'node',26),('1371574564',164882,'node',26),('1371574564',164881,'node',26),('1371574564',164883,'node',26),('1371574564',164884,'node',26),('1371574564',164886,'node',26),('1371574564',164885,'node',26),('1371574564',164887,'node',26),('1371574564',164888,'node',26),('1371574564',164890,'node',26),('1371574564',164889,'node',26),('1371574564',164891,'node',26),('1371574564',164892,'node',26),('1371574564',164894,'node',26),('1371574564',164893,'node',26),('1371574564',164899,'node',26),('1371574564',164898,'node',26),('1371574564',164897,'node',26),('1371574564',164896,'node',26),('1371574564',164895,'node',26),('1371574564',164900,'node',26),('1371574564',164902,'node',26),('1371574564',164901,'node',26),('1371574564',164903,'node',26),('1371574564',164905,'node',26),('1371574564',164904,'node',26),('1371574564',164906,'node',26),('1371574567',164909,'node',26),('1418',164908,'node',1),('1371574567',164908,'node',26),('1571',164910,'node',1),('1371574567',164910,'node',26),('1442',164909,'node',1),('1297',164911,'node',1),('1371574567',164911,'node',26),('1377',164912,'node',1),('1371574567',164912,'node',26),('1328',164914,'node',1),('1371574567',164914,'node',26),('1277',164913,'node',1),('1371574567',164913,'node',26),('1161',164915,'node',1),('1371574567',164915,'node',26),('1341',164917,'node',1),('1371574568',164917,'node',26),('1354',164918,'node',1),('1371574568',164918,'node',26),('1249',164920,'node',1),('1371574568',164920,'node',26),('1210',164919,'node',1),('1371574568',164919,'node',26),('1415',164921,'node',1),('1371574568',164921,'node',26),('1301',164922,'node',1),('1371574568',164922,'node',26),('1385',164924,'node',1),('1371574568',164924,'node',26),('1241',164923,'node',1),('1371574568',164923,'node',26),('1371574623',164945,'node',26),('1371574623',164944,'node',26),('1371574623',164946,'node',26),('1371574623',164947,'node',26),('1371574623',164948,'node',26),('1371574623',164949,'node',26),('1371574623',164951,'node',26),('1371574623',164950,'node',26),('1371574623',164954,'node',26),('1371574623',164953,'node',26),('1371574623',164952,'node',26),('1371574623',164958,'node',26),('1371574623',164957,'node',26),('1371574623',164956,'node',26),('1371574623',164955,'node',26),('1371574623',164960,'node',26),('1371574623',164959,'node',26),('1371574623',164966,'node',26),('1371574623',164965,'node',26),('1371574623',164964,'node',26),('1371574623',164963,'node',26),('1371574623',164962,'node',26),('1371574623',164961,'node',26),('1371574623',164967,'node',26),('1371574623',164968,'node',26),('1371574623',164970,'node',26),('1371574623',164969,'node',26),('1371574623',164971,'node',26),('1371574623',164972,'node',26),('1371574623',164974,'node',26),('1371574623',164973,'node',26),('1371574623',164975,'node',26),('1371574623',164976,'node',26),('1371574623',164977,'node',26),('1371574623',164979,'node',26),('1371574623',164978,'node',26),('1371574623',164980,'node',26),('1371574623',164981,'node',26),('1371574623',164983,'node',26),('1371574623',164982,'node',26),('1371574623',164984,'node',26),('1371574623',164986,'node',26),('1371574623',164985,'node',26),('1371574623',164987,'node',26),('1371574623',164988,'node',26),('1371574623',164990,'node',26),('1371574623',164989,'node',26),('1371574623',164991,'node',26),('1371574623',164992,'node',26),('1371574623',164993,'node',26),('1371574623',164995,'node',26),('1371574623',164994,'node',26),('1371574623',164996,'node',26),('1371574623',164997,'node',26),('1371574627',165000,'node',26),('1397',164999,'node',1),('1371574627',164999,'node',26),('1323',165001,'node',1),('1371574627',165001,'node',26),('1358',165000,'node',1),('1453',165002,'node',1),('1371574627',165002,'node',26),('1334',165003,'node',1),('1371574627',165003,'node',26),('1416',165004,'node',1),('1371574627',165004,'node',26),('1393',165006,'node',1),('1371574627',165006,'node',26),('1361',165005,'node',1),('1371574627',165005,'node',26),('1355',165008,'node',1),('1371574628',165008,'node',26),('1227',165009,'node',1),('1371574628',165009,'node',26),('1371574683',165031,'node',26),('1334',165010,'node',1),('1371574628',165010,'node',26),('1371574683',165030,'node',26),('1371574629',165027,'node',26),('1324',165012,'node',1),('1371574628',165012,'node',26),('1274',165011,'node',1),('1371574628',165011,'node',26),('1371574629',165025,'node',26),('1371574629',165023,'node',26),('1371574628',165021,'node',26),('1350',165013,'node',1),('1371574628',165013,'node',26),('1371574683',165042,'node',26),('1371574683',165043,'node',26),('1371574683',165045,'node',26),('1371574683',165044,'node',26),('1371574683',165046,'node',26),('1371574683',165047,'node',26),('1371574683',165049,'node',26),('1371574683',165048,'node',26),('1371574683',165050,'node',26),('1371574683',165052,'node',26),('1371574683',165051,'node',26),('1371574683',165053,'node',26),('1371574683',165054,'node',26),('1371574683',165056,'node',26),('1371574683',165055,'node',26),('1371574683',165057,'node',26),('1371574683',165058,'node',26),('1371574683',165060,'node',26),('1371574683',165059,'node',26),('1371574683',165061,'node',26),('1371574683',165062,'node',26),('1371574683',165064,'node',26),('1371574683',165063,'node',26),('1371574683',165065,'node',26),('1371574683',165066,'node',26),('1371574683',165068,'node',26),('1371574683',165067,'node',26),('1371574683',165069,'node',26),('1371574683',165070,'node',26),('1371574683',165071,'node',26),('1371574683',165072,'node',26),('1371574683',165074,'node',26),('1371574683',165073,'node',26),('1371574683',165075,'node',26),('1371574683',165076,'node',26),('1371574683',165078,'node',26),('1371574683',165077,'node',26),('1371574683',165079,'node',26),('1371574683',165080,'node',26),('1371574683',165082,'node',26),('1371574683',165081,'node',26),('1371574683',165083,'node',26),('1371574683',165084,'node',26),('1371574683',165086,'node',26),('1371574683',165085,'node',26),('1371574683',165087,'node',26),('1371574683',165088,'node',26),('1365',165091,'node',1),('1371574687',165091,'node',26),('1518',165090,'node',1),('1371574687',165090,'node',26),('1419',165092,'node',1),('1371574687',165092,'node',26),('1495',165093,'node',1),('1371574687',165093,'node',26),('1481',165094,'node',1),('1371574687',165094,'node',26),('1376',165095,'node',1),('1371574687',165095,'node',26),('1337',165097,'node',1),('1371574687',165097,'node',26),('1403',165096,'node',1),('1371574687',165096,'node',26),('1303',165099,'node',1),('1371574688',165099,'node',26),('1325',165100,'node',1),('1371574688',165100,'node',26),('1392',165101,'node',1),('1371574688',165101,'node',26),('1322',165102,'node',1),('1371574688',165102,'node',26),('1276',165103,'node',1),('1371574688',165103,'node',26),('1351',165104,'node',1),('1371574688',165104,'node',26),('1353',165106,'node',1),('1371574688',165106,'node',26),('1373',165105,'node',1),('1371574688',165105,'node',26),('1371574688',165108,'node',26),('1371574689',165111,'node',26),('1371574689',165110,'node',26),('1371574689',165112,'node',26),('1371574689',165114,'node',26),('1371574689',165116,'node',26),('1371574743',165121,'node',26),('1371574690',165118,'node',26),('1371574743',165122,'node',26),('1371574743',165124,'node',26),('1371574743',165123,'node',26),('1371574743',165125,'node',26),('1371574743',165126,'node',26),('1371574743',165127,'node',26),('1371574743',165129,'node',26),('1371574743',165128,'node',26),('1371574743',165130,'node',26),('1371574743',165132,'node',26),('1371574743',165131,'node',26),('1371574743',165133,'node',26),('1371574743',165134,'node',26),('1371574743',165136,'node',26),('1371574743',165135,'node',26),('1371574743',165137,'node',26),('1371574743',165138,'node',26),('1371574743',165140,'node',26),('1371574743',165139,'node',26),('1371574743',165141,'node',26),('1371574743',165143,'node',26),('1371574743',165142,'node',26),('1371574743',165144,'node',26),('1371574743',165145,'node',26),('1371574743',165147,'node',26),('1371574743',165146,'node',26),('1371574743',165148,'node',26),('1371574743',165149,'node',26),('1371574743',165151,'node',26),('1371574743',165150,'node',26),('1371574743',165152,'node',26),('1371574743',165153,'node',26),('1371574743',165155,'node',26),('1371574743',165154,'node',26),('1371574743',165156,'node',26),('1371574743',165161,'node',26),('1371574743',165160,'node',26),('1371574743',165159,'node',26),('1371574743',165158,'node',26),('1371574743',165157,'node',26),('1371574743',165162,'node',26),('1371574743',165164,'node',26),('1371574743',165163,'node',26),('1371574743',165165,'node',26),('1371574743',165166,'node',26),('1371574743',165168,'node',26),('1371574743',165167,'node',26),('1371574743',165170,'node',26),('1371574743',165169,'node',26),('1371574743',165171,'node',26),('1371574743',165172,'node',26),('1371574743',165174,'node',26),('1371574743',165173,'node',26),('1371574743',165175,'node',26),('1371574743',165176,'node',26),('1371574743',165178,'node',26),('1371574743',165177,'node',26),('1518',165181,'node',1),('1371574747',165181,'node',26),('1371574743',165179,'node',26),('1366',165183,'node',1),('1371574747',165183,'node',26),('1430',165182,'node',1),('1371574747',165182,'node',26),('1500',165184,'node',1),('1371574747',165184,'node',26),('1395',165186,'node',1),('1371574747',165186,'node',26),('1401',165185,'node',1),('1371574747',165185,'node',26),('1500',165187,'node',1),('1371574747',165187,'node',26),('1275',165190,'node',1),('1371574748',165190,'node',26),('1411',165188,'node',1),('1371574747',165188,'node',26),('1346',165191,'node',1),('1371574748',165191,'node',26),('1361',165193,'node',1),('1371574748',165193,'node',26),('1377',165192,'node',1),('1371574748',165192,'node',26),('1366',165194,'node',1),('1371574748',165194,'node',26),('1309',165196,'node',1),('1371574748',165196,'node',26),('1297',165195,'node',1),('1371574748',165195,'node',26),('1371574748',165199,'node',26),('1246',165197,'node',1),('1371574748',165197,'node',26),('1371574748',165202,'node',26),('1371574748',165201,'node',26),('1371574748',165203,'node',26),('1371574749',165207,'node',26),('1371574749',165205,'node',26),('1371574803',165212,'node',26),('1371574749',165209,'node',26),('1371574803',165214,'node',26),('1371574803',165213,'node',26),('1371574803',165226,'node',26),('1371574803',165225,'node',26),('1371574803',165224,'node',26),('1371574803',165223,'node',26),('1371574803',165222,'node',26),('1371574803',165221,'node',26),('1371574803',165220,'node',26),('1371574803',165219,'node',26),('1371574803',165218,'node',26),('1371574803',165215,'node',26),('1371574803',165217,'node',26),('1371574803',165216,'node',26),('1371574803',165227,'node',26),('1371574803',165229,'node',26),('1371574803',165228,'node',26),('1371574803',165230,'node',26),('1371574803',165231,'node',26),('1371574803',165233,'node',26),('1371574803',165232,'node',26),('1371574803',165234,'node',26),('1371574803',165236,'node',26),('1371574803',165235,'node',26),('1371574803',165237,'node',26),('1371574803',165238,'node',26),('1371574803',165240,'node',26),('1371574803',165239,'node',26),('1371574803',165242,'node',26),('1371574803',165241,'node',26),('1371574803',165243,'node',26),('1371574803',165244,'node',26),('1371574803',165246,'node',26),('1371574803',165245,'node',26),('1371574803',165247,'node',26),('1371574803',165259,'node',26),('1371574803',165258,'node',26),('1371574803',165257,'node',26),('1371574803',165256,'node',26),('1371574803',165255,'node',26),('1371574803',165254,'node',26),('1371574803',165253,'node',26),('1371574803',165252,'node',26),('1371574803',165251,'node',26),('1371574803',165250,'node',26),('1371574803',165248,'node',26),('1371574803',165249,'node',26),('1371574803',165260,'node',26),('1371574803',165261,'node',26),('1371574803',165263,'node',26),('1371574803',165262,'node',26),('1371574803',165264,'node',26),('1371574803',165266,'node',26),('1371574803',165265,'node',26),('1371574803',165267,'node',26),('1371574803',165269,'node',26),('1371574803',165268,'node',26),('1419',165272,'node',1),('1371574807',165272,'node',26),('1371574803',165270,'node',26),('1379',165273,'node',1),('1371574807',165273,'node',26),('1506',165274,'node',1),('1371574807',165274,'node',26),('1407',165276,'node',1),('1371574807',165276,'node',26),('1464',165275,'node',1),('1371574807',165275,'node',26),('1461',165277,'node',1),('1371574807',165277,'node',26),('1446',165279,'node',1),('1371574807',165279,'node',26),('1570',165278,'node',1),('1371574807',165278,'node',26),('1379',165281,'node',1),('1371574808',165281,'node',26),('1318',165282,'node',1),('1371574808',165282,'node',26),('1371574808',165290,'node',26),('1469',165288,'node',1),('1371574808',165288,'node',26),('1340',165287,'node',1),('1371574808',165287,'node',26),('1383',165286,'node',1),('1371574808',165286,'node',26),('1413',165284,'node',1),('1371574808',165284,'node',26),('1296',165283,'node',1),('1371574808',165283,'node',26),('1267',165285,'node',1),('1371574808',165285,'node',26),('1326',165007,'node',1),('1371574628',165007,'node',26),('1380',164998,'node',1),('1371574627',164998,'node',26),('1371574623',164938,'node',26),('1371574621',164937,'node',26),('1371574569',164927,'node',26),('1371574569',164925,'node',26),('1313',164916,'node',1),('1371574568',164916,'node',26),('1363',164907,'node',1),('1371574567',164907,'node',26),('1371574564',164847,'node',26),('1371574562',164846,'node',26),('1371574629',165024,'node',26),('1371574629',165022,'node',26),('1371574629',165026,'node',26),('1371574681',165028,'node',26),('1371574683',165029,'node',26),('1371574688',165098,'node',26),('1426',165089,'node',1),('1371574687',165089,'node',26),('1371574688',165107,'node',26),('1338',165098,'node',1),('1371574689',165115,'node',26),('1371574741',165119,'node',26),('1371574690',165117,'node',26),('1371574743',165120,'node',26),('1441',165180,'node',1),('1371574747',165180,'node',26),('1323',165189,'node',1),('1371574748',165189,'node',26),('1371574748',165198,'node',26),('1371574749',165208,'node',26),('1371574801',165210,'node',26),('1457',165271,'node',1),('1371574807',165271,'node',26),('1371574803',165211,'node',26),('1359',165280,'node',1),('1371574808',165280,'node',26),('1371574808',165289,'node',26),('1371574809',165295,'node',26),('1371574809',165291,'node',26),('1371574864',165302,'node',26),('1371574862',165301,'node',26),('1422',165362,'node',1),('1371574867',165362,'node',26),('1393',165371,'node',1),('1371574869',165371,'node',26),('1371574869',165380,'node',26),('1371574870',165386,'node',26),('1371574869',165382,'node',26),('1371574870',165388,'node',26),('1474',165453,'node',1),('1371574927',165453,'node',26),('1371574923',165393,'node',26),('1415',165462,'node',1),('1371574928',165462,'node',26),('1371574929',165471,'node',26),('1371574929',165473,'node',26),('1371574929',165479,'node',26),('1371574929',165477,'node',26),('1460',165544,'node',1),('1371574987',165544,'node',26),('1371574983',165484,'node',26),('1371574981',165483,'node',26),('1371574930',165481,'node',26),('1371574989',165568,'node',26),('1371574990',165570,'node',26),('1371574990',165572,'node',26),('1371575044',165575,'node',26),('1371575041',165574,'node',26),('1529',165635,'node',1),('1371575047',165635,'node',26),('1463',165644,'node',1),('1371575048',165644,'node',26),('1371575050',165661,'node',26),('1371575050',165659,'node',26),('1371575050',165663,'node',26),('1371575101',165665,'node',26),('1371575104',165666,'node',26),('1494',165726,'node',1),('1371575107',165726,'node',26),('1371575109',165744,'node',26),('1505',165735,'node',1),('1371575109',165735,'node',26),('1371575110',165752,'node',26),('1371575110',165754,'node',26),('1371575164',165757,'node',26),('1371575162',165756,'node',26),('1510',165817,'node',1),('1371575168',165817,'node',26),('1465',165826,'node',1),('1371575169',165826,'node',26),('1371575169',165837,'node',26),('1371575169',165835,'node',26),('1371575170',165845,'node',26),('1371575223',165848,'node',26),('1371575222',165847,'node',26),('1553',165908,'node',1),('1371575227',165908,'node',26),('1494',165917,'node',1),('1371575228',165917,'node',26),('1371574809',165293,'node',26),('1371574809',165292,'node',26),('1371574809',165294,'node',26),('1371574809',165298,'node',26),('1371574809',165296,'node',26),('1371574809',165300,'node',26),('1371574864',165303,'node',26),('1371574864',165305,'node',26),('1371574864',165304,'node',26),('1371574864',165306,'node',26),('1371574864',165307,'node',26),('1371574864',165308,'node',26),('1371574864',165310,'node',26),('1371574864',165309,'node',26),('1371574864',165311,'node',26),('1371574864',165313,'node',26),('1371574864',165312,'node',26),('1371574864',165314,'node',26),('1371574864',165315,'node',26),('1371574864',165316,'node',26),('1371574864',165318,'node',26),('1371574864',165317,'node',26),('1371574864',165319,'node',26),('1371574864',165320,'node',26),('1371574864',165322,'node',26),('1371574864',165321,'node',26),('1371574864',165323,'node',26),('1371574864',165324,'node',26),('1371574864',165326,'node',26),('1371574864',165325,'node',26),('1371574864',165327,'node',26),('1371574864',165331,'node',26),('1371574864',165330,'node',26),('1371574864',165329,'node',26),('1371574864',165328,'node',26),('1371574864',165333,'node',26),('1371574864',165332,'node',26),('1371574864',165334,'node',26),('1371574864',165335,'node',26),('1371574864',165337,'node',26),('1371574864',165336,'node',26),('1371574864',165338,'node',26),('1371574864',165340,'node',26),('1371574864',165339,'node',26),('1371574864',165341,'node',26),('1371574864',165342,'node',26),('1371574864',165344,'node',26),('1371574864',165343,'node',26),('1371574864',165346,'node',26),('1371574864',165345,'node',26),('1371574864',165348,'node',26),('1371574864',165347,'node',26),('1371574864',165349,'node',26),('1371574864',165351,'node',26),('1371574864',165350,'node',26),('1371574864',165352,'node',26),('1371574864',165353,'node',26),('1371574864',165355,'node',26),('1371574864',165354,'node',26),('1371574864',165357,'node',26),('1371574864',165356,'node',26),('1371574864',165358,'node',26),('1371574864',165360,'node',26),('1371574864',165359,'node',26),('1371574864',165361,'node',26),('1342',165363,'node',1),('1371574867',165363,'node',26),('1468',165365,'node',1),('1371574867',165365,'node',26),('1443',165364,'node',1),('1371574867',165364,'node',26),('1385',165366,'node',1),('1371574867',165366,'node',26),('1470',165367,'node',1),('1371574867',165367,'node',26),('1376',165369,'node',1),('1371574867',165369,'node',26),('1500',165368,'node',1),('1371574867',165368,'node',26),('1385',165370,'node',1),('1371574867',165370,'node',26),('1368',165374,'node',1),('1371574869',165374,'node',26),('1445',165373,'node',1),('1371574869',165373,'node',26),('1357',165372,'node',1),('1371574869',165372,'node',26),('1389',165377,'node',1),('1371574869',165377,'node',26),('1404',165376,'node',1),('1371574869',165376,'node',26),('1383',165375,'node',1),('1371574869',165375,'node',26),('1423',165378,'node',1),('1371574869',165378,'node',26),('1374',165379,'node',1),('1371574869',165379,'node',26),('1371574869',165383,'node',26),('1371574869',165381,'node',26),('1371574869',165384,'node',26),('1371574869',165385,'node',26),('1371574870',165389,'node',26),('1371574870',165387,'node',26),('1371574870',165391,'node',26),('1371574923',165395,'node',26),('1371574923',165394,'node',26),('1371574923',165396,'node',26),('1371574923',165398,'node',26),('1371574923',165397,'node',26),('1371574923',165399,'node',26),('1371574923',165400,'node',26),('1371574923',165401,'node',26),('1371574923',165402,'node',26),('1371574923',165403,'node',26),('1371574923',165405,'node',26),('1371574923',165404,'node',26),('1371574923',165406,'node',26),('1371574923',165408,'node',26),('1371574923',165407,'node',26),('1371574923',165410,'node',26),('1371574923',165409,'node',26),('1371574923',165411,'node',26),('1371574923',165413,'node',26),('1371574923',165412,'node',26),('1371574923',165414,'node',26),('1371574923',165416,'node',26),('1371574923',165415,'node',26),('1371574923',165417,'node',26),('1371574923',165419,'node',26),('1371574923',165418,'node',26),('1371574923',165420,'node',26),('1371574923',165422,'node',26),('1371574923',165421,'node',26),('1371574923',165423,'node',26),('1371574923',165424,'node',26),('1371574923',165426,'node',26),('1371574923',165425,'node',26),('1371574923',165427,'node',26),('1371574923',165429,'node',26),('1371574923',165428,'node',26),('1371574923',165431,'node',26),('1371574923',165430,'node',26),('1371574923',165432,'node',26),('1371574923',165435,'node',26),('1371574923',165434,'node',26),('1371574923',165433,'node',26),('1371574923',165437,'node',26),('1371574923',165436,'node',26),('1371574923',165438,'node',26),('1371574923',165439,'node',26),('1371574923',165441,'node',26),('1371574923',165440,'node',26),('1371574923',165442,'node',26),('1371574923',165444,'node',26),('1371574923',165443,'node',26),('1371574923',165445,'node',26),('1371574923',165446,'node',26),('1371574923',165448,'node',26),('1371574923',165447,'node',26),('1371574923',165450,'node',26),('1371574923',165449,'node',26),('1371574923',165451,'node',26),('1558',165454,'node',1),('1371574927',165454,'node',26),('1371574923',165452,'node',26),('1377',165455,'node',1),('1371574927',165455,'node',26),('1424',165456,'node',1),('1371574927',165456,'node',26),('1508',165458,'node',1),('1371574927',165458,'node',26),('1470',165457,'node',1),('1371574927',165457,'node',26),('1433',165459,'node',1),('1371574927',165459,'node',26),('1498',165460,'node',1),('1371574927',165460,'node',26),('1371574928',165463,'node',26),('1518',165461,'node',1),('1371574927',165461,'node',26),('1280',165464,'node',1),('1371574928',165464,'node',26),('1401',165463,'node',1),('1418',165465,'node',1),('1371574928',165465,'node',26),('1428',165466,'node',1),('1371574928',165466,'node',26),('1519',165468,'node',1),('1371574928',165468,'node',26),('1543',165467,'node',1),('1371574928',165467,'node',26),('1384',165469,'node',1),('1371574928',165469,'node',26),('1329',165470,'node',1),('1371574928',165470,'node',26),('1371574929',165474,'node',26),('1371574929',165472,'node',26),('1371574929',165475,'node',26),('1371574929',165476,'node',26),('1371574929',165480,'node',26),('1371574929',165478,'node',26),('1371574930',165482,'node',26),('1371574983',165485,'node',26),('1371574983',165487,'node',26),('1371574983',165486,'node',26),('1371574983',165488,'node',26),('1371574983',165489,'node',26),('1371574983',165491,'node',26),('1371574983',165490,'node',26),('1371574983',165496,'node',26),('1371574983',165495,'node',26),('1371574983',165494,'node',26),('1371574983',165493,'node',26),('1371574983',165492,'node',26),('1371574983',165497,'node',26),('1371574983',165499,'node',26),('1371574983',165498,'node',26),('1371574983',165500,'node',26),('1371574983',165502,'node',26),('1371574983',165501,'node',26),('1371574983',165503,'node',26),('1371574983',165504,'node',26),('1371574983',165506,'node',26),('1371574983',165505,'node',26),('1371574983',165507,'node',26),('1371574983',165509,'node',26),('1371574983',165508,'node',26),('1371574983',165510,'node',26),('1371574983',165512,'node',26),('1371574983',165511,'node',26),('1371574983',165513,'node',26),('1371574983',165514,'node',26),('1504',177764,'node',1),('1371595263',177764,'node',26),('1600',177763,'node',1),('1371595263',177763,'node',26),('1579',177768,'node',1),('1371595263',177768,'node',26),('1545',177767,'node',1),('1371595263',177767,'node',26),('1654',177766,'node',1),('1371595263',177766,'node',26),('1593',177765,'node',1),('1371595263',177765,'node',26),('1640',177773,'node',1),('1371595264',177773,'node',26),('1498',177772,'node',1),('1371595264',177772,'node',26),('1461',177770,'node',1),('1371595263',177770,'node',26),('1485',177769,'node',1),('1371595263',177769,'node',26),('1457',177776,'node',1),('1371595264',177776,'node',26),('1681',177775,'node',1),('1371595264',177775,'node',26),('1569',177774,'node',1),('1371595264',177774,'node',26),('1523',177779,'node',1),('1371595264',177779,'node',26),('1606',177778,'node',1),('1371595264',177778,'node',26),('1563',177777,'node',1),('1371595264',177777,'node',26),('1371595265',177787,'node',26),('1371595264',177785,'node',26),('1371595264',177784,'node',26),('1371595264',177783,'node',26),('1371595264',177781,'node',26),('1391',177794,'node',1),('1371595323',177794,'node',26),('1497',177795,'node',1),('1371595323',177795,'node',26),('1636',177797,'node',1),('1371595323',177797,'node',26),('1623',177796,'node',1),('1371595323',177796,'node',26),('1584',177798,'node',1),('1371595323',177798,'node',26),('1638',177800,'node',1),('1371595323',177800,'node',26),('1647',177799,'node',1),('1371595323',177799,'node',26),('1470',177804,'node',1),('1371595324',177804,'node',26),('1755',177803,'node',1),('1371595324',177803,'node',26),('1577',177801,'node',1),('1371595323',177801,'node',26),('1371595324',177808,'node',26),('1554',177807,'node',1),('1371595324',177807,'node',26),('1498',177806,'node',1),('1371595324',177806,'node',26),('1604',177805,'node',1),('1371595324',177805,'node',26),('1371595324',177812,'node',26),('1488',177810,'node',1),('1371595324',177810,'node',26),('1598',177809,'node',1),('1371595324',177809,'node',26),('1491',177808,'node',1),('1371595325',177816,'node',26),('1371595325',177815,'node',26),('1371595325',177814,'node',26),('1371595325',177822,'node',26),('1371595325',177820,'node',26),('1371595325',177818,'node',26),('1772',177825,'node',1),('1371595383',177825,'node',26),('1486',177827,'node',1),('1371595383',177827,'node',26),('1621',177826,'node',1),('1371595383',177826,'node',26),('1516',177828,'node',1),('1371595383',177828,'node',26),('1532',177829,'node',1),('1371595383',177829,'node',26),('1592',177835,'node',1),('1371595384',177835,'node',26),('1487',177834,'node',1),('1371595384',177834,'node',26),('1532',177832,'node',1),('1371595383',177832,'node',26),('1472',177831,'node',1),('1371595383',177831,'node',26),('1475',177830,'node',1),('1371595383',177830,'node',26),('1456',177836,'node',1),('1371595384',177836,'node',26),('1600',177838,'node',1),('1371595384',177838,'node',26),('1536',177837,'node',1),('1371595384',177837,'node',26),('1575',177839,'node',1),('1371595384',177839,'node',26),('1647',177840,'node',1),('1371595384',177840,'node',26),('1371595384',177843,'node',26),('1630',177841,'node',1),('1371595384',177841,'node',26),('1371595385',177845,'node',26),('1371595385',177847,'node',26),('1371595385',177846,'node',26),('1371595385',177849,'node',26),('1371595385',177851,'node',26),('1468',177856,'node',1),('1371595443',177856,'node',26),('1371595385',177853,'node',26),('1438',177857,'node',1),('1371595443',177857,'node',26),('1639',177858,'node',1),('1371595443',177858,'node',26),('1558',177861,'node',1),('1371595443',177861,'node',26),('1371595443',177863,'node',26),('1553',177862,'node',1),('1371595443',177862,'node',26),('1593',177865,'node',1),('1371595444',177865,'node',26),('1630',177863,'node',1),('1681',177866,'node',1),('1371595444',177866,'node',26),('1371595444',177868,'node',26),('1636',177867,'node',1),('1371595444',177867,'node',26),('1675',177869,'node',1),('1371595444',177869,'node',26),('1541',177868,'node',1),('1567',177870,'node',1),('1371595444',177870,'node',26),('1601',177872,'node',1),('1371595444',177872,'node',26),('1527',177871,'node',1),('1371595444',177871,'node',26),('1371595445',177874,'node',26),('1371595445',177876,'node',26),('1371595445',177878,'node',26),('1371595445',177877,'node',26),('1371595445',177880,'node',26),('1371595446',177884,'node',26),('1371595446',177882,'node',26),('1578',177887,'node',1),('1371595502',177887,'node',26),('1566',177888,'node',1),('1371595502',177888,'node',26),('1533',177890,'node',1),('1371595502',177890,'node',26),('1613',177889,'node',1),('1371595502',177889,'node',26),('1618',177891,'node',1),('1371595502',177891,'node',26),('1595',177892,'node',1),('1371595502',177892,'node',26),('1603',177893,'node',1),('1371595502',177893,'node',26),('1501',177897,'node',1),('1371595503',177897,'node',26),('1496',177896,'node',1),('1371595503',177896,'node',26),('1544',177894,'node',1),('1371595502',177894,'node',26),('1554',177762,'node',1),('1371595263',177762,'node',26),('1371595262',177761,'node',26),('1569',177771,'node',1),('1371595264',177771,'node',26),('1371595264',177782,'node',26),('1371595264',177780,'node',26),('1560',177802,'node',1),('1371595324',177802,'node',26),('1576',177793,'node',1),('1371595323',177793,'node',26),('1371595324',177811,'node',26),('1371595325',177813,'node',26),('1371595325',177817,'node',26),('1371595325',177821,'node',26),('1371595325',177819,'node',26),('1371595382',177823,'node',26),('1567',177833,'node',1),('1371595384',177833,'node',26),('1371595385',177844,'node',26),('1371595384',177842,'node',26),('1371595385',177848,'node',26),('1371595385',177850,'node',26),('1371595385',177852,'node',26),('1561',177855,'node',1),('1371595443',177855,'node',26),('1371595442',177854,'node',26),('1604',177864,'node',1),('1371595444',177864,'node',26),('1371595445',177875,'node',26),('1371595446',177881,'node',26),('1371595445',177879,'node',26),('1371595446',177883,'node',26),('1371595501',177885,'node',26),('1582',177886,'node',1),('1371595502',177886,'node',26),('1371595504',177904,'node',26),('1550',177895,'node',1),('1371595503',177895,'node',26),('1371595504',177906,'node',26),('1371595504',177910,'node',26),('1371595505',177914,'node',26),('1371595505',177912,'node',26),('1371595562',177916,'node',26),('1586',177917,'node',1),('1371595563',177917,'node',26),('1586',177926,'node',1),('1371595564',177926,'node',26),('1371595564',177935,'node',26),('1371595565',177941,'node',26),('1371595565',177937,'node',26),('1371595621',177947,'node',26),('1371595565',177945,'node',26),('1371595565',177943,'node',26),('1597',177948,'node',1),('1371595622',177948,'node',26),('1371595624',177966,'node',26),('1595',177957,'node',1),('1371595623',177957,'node',26),('1371595624',177968,'node',26),('1371595624',177972,'node',26),('1371595625',177976,'node',26),('1371595625',177974,'node',26),('1371595681',177978,'node',26),('1580',177979,'node',1),('1371595682',177979,'node',26),('1568',177988,'node',1),('1371595683',177988,'node',26),('1371595684',177997,'node',26),('1371595684',178003,'node',26),('1371595684',177999,'node',26),('57',178005,'node',1),('1371595685',178005,'node',26),('1371595685',178007,'node',26),('1622',178010,'node',1),('1371595742',178010,'node',26),('1371595742',178009,'node',26),('1578',178019,'node',1),('1371595743',178019,'node',26),('1371595744',178028,'node',26),('1371595745',178034,'node',26),('1371595745',178036,'node',26),('1371595802',178040,'node',26),('1371595745',178038,'node',26),('1565',178041,'node',1),('1371595803',178041,'node',26),('1571',178050,'node',1),('1371595804',178050,'node',26),('1371595804',178059,'node',26),('1371595805',178065,'node',26),('1371595805',178061,'node',26),('1371595805',178069,'node',26),('1371595862',178072,'node',26),('1371595861',178071,'node',26),('1551',178081,'node',1),('1371595863',178081,'node',26),('1630',178072,'node',1),('1371595864',178090,'node',26),('1371595864',178092,'node',26),('1371595864',178096,'node',26),('1371595864',178098,'node',26),('1578',178103,'node',1),('1371595922',178103,'node',26),('1371595922',178102,'node',26),('1574',178112,'node',1),('1371595923',178112,'node',26),('1371595924',178121,'node',26),('1371595925',178123,'node',26),('1371595925',178127,'node',26),('1371595925',178131,'node',26),('1371595925',178129,'node',26),('1371595981',178133,'node',26),('1371595984',178158,'node',26),('1371595984',178154,'node',26),('1371595984',178152,'node',26),('1588',178143,'node',1),('1371595983',178143,'node',26),('1642',177898,'node',1),('1371595503',177898,'node',26),('1677',177899,'node',1),('1371595503',177899,'node',26),('1509',177900,'node',1),('1371595503',177900,'node',26),('1593',177902,'node',1),('1371595503',177902,'node',26),('1454',177901,'node',1),('1371595503',177901,'node',26),('1511',177903,'node',1),('1371595503',177903,'node',26),('1371595504',177907,'node',26),('1371595504',177905,'node',26),('1371595504',177908,'node',26),('1371595504',177911,'node',26),('1371595504',177909,'node',26),('1371595505',177913,'node',26),('1371595505',177915,'node',26),('1601',177919,'node',1),('1371595563',177919,'node',26),('1514',177918,'node',1),('1371595563',177918,'node',26),('1549',177920,'node',1),('1371595563',177920,'node',26),('1670',177921,'node',1),('1371595563',177921,'node',26),('1633',177923,'node',1),('1371595563',177923,'node',26),('1436',177922,'node',1),('1371595563',177922,'node',26),('1640',177925,'node',1),('1371595563',177925,'node',26),('1634',177924,'node',1),('1371595563',177924,'node',26),('1571',177927,'node',1),('1371595564',177927,'node',26),('1650',177928,'node',1),('1371595564',177928,'node',26),('1573',177929,'node',1),('1371595564',177929,'node',26),('1682',177931,'node',1),('1371595564',177931,'node',26),('1670',177930,'node',1),('1371595564',177930,'node',26),('1625',177932,'node',1),('1371595564',177932,'node',26),('1353',177933,'node',1),('1371595564',177933,'node',26),('1540',177934,'node',1),('1371595564',177934,'node',26),('1371595565',177938,'node',26),('1371595564',177936,'node',26),('1371595565',177939,'node',26),('1371595565',177940,'node',26),('1371595565',177944,'node',26),('1371595565',177942,'node',26),('1371595565',177946,'node',26),('1652',177949,'node',1),('1371595622',177949,'node',26),('1562',177951,'node',1),('1371595622',177951,'node',26),('1642',177950,'node',1),('1371595622',177950,'node',26),('1660',177952,'node',1),('1371595622',177952,'node',26),('1533',177953,'node',1),('1371595622',177953,'node',26),('1579',177955,'node',1),('1371595622',177955,'node',26),('1585',177954,'node',1),('1371595622',177954,'node',26),('1564',177956,'node',1),('1371595622',177956,'node',26),('1371595623',177959,'node',26),('1572',177958,'node',1),('1371595623',177958,'node',26),('1514',177960,'node',1),('1371595623',177960,'node',26),('1590',177959,'node',1),('1601',177961,'node',1),('1371595623',177961,'node',26),('1371595623',177963,'node',26),('1756',177962,'node',1),('1371595623',177962,'node',26),('1633',177964,'node',1),('1371595623',177964,'node',26),('1562',177963,'node',1),('1517',177965,'node',1),('1371595623',177965,'node',26),('1371595624',177969,'node',26),('1371595624',177967,'node',26),('1371595624',177970,'node',26),('1371595624',177973,'node',26),('1371595624',177971,'node',26),('1371595625',177975,'node',26),('1371595625',177977,'node',26),('1410',177981,'node',1),('1371595682',177981,'node',26),('1630',177980,'node',1),('1371595682',177980,'node',26),('1608',177982,'node',1),('1371595682',177982,'node',26),('1515',177984,'node',1),('1371595682',177984,'node',26),('1568',177983,'node',1),('1371595682',177983,'node',26),('1371595683',177990,'node',26),('1358',177989,'node',1),('1371595683',177989,'node',26),('1527',177987,'node',1),('1371595682',177987,'node',26),('1752',177986,'node',1),('1371595682',177986,'node',26),('1609',177985,'node',1),('1371595682',177985,'node',26),('1498',177990,'node',1),('1692',177992,'node',1),('1371595683',177992,'node',26),('1613',177991,'node',1),('1371595683',177991,'node',26),('1638',177993,'node',1),('1371595683',177993,'node',26),('1569',177994,'node',1),('1371595683',177994,'node',26),('1609',177996,'node',1),('1371595683',177996,'node',26),('1545',177995,'node',1),('1371595683',177995,'node',26),('1371595684',177998,'node',26),('1371595684',178000,'node',26),('1371595684',178002,'node',26),('1371595684',178001,'node',26),('1371595684',178004,'node',26),('1371595685',178008,'node',26),('57',178006,'node',1),('1371595685',178006,'node',26),('1563',178011,'node',1),('1371595742',178011,'node',26),('1621',178012,'node',1),('1371595742',178012,'node',26),('1627',178014,'node',1),('1371595742',178014,'node',26),('1705',178013,'node',1),('1371595742',178013,'node',26),('1644',178015,'node',1),('1371595742',178015,'node',26),('1640',178016,'node',1),('1371595742',178016,'node',26),('1664',178018,'node',1),('1371595742',178018,'node',26),('1506',178017,'node',1),('1371595742',178017,'node',26),('1552',178020,'node',1),('1371595743',178020,'node',26),('1550',178021,'node',1),('1371595743',178021,'node',26),('1631',178023,'node',1),('1371595743',178023,'node',26),('1563',178022,'node',1),('1371595743',178022,'node',26),('1611',178024,'node',1),('1371595743',178024,'node',26),('1469',178026,'node',1),('1371595743',178026,'node',26),('1614',178025,'node',1),('1371595743',178025,'node',26),('1626',178027,'node',1),('1371595743',178027,'node',26),('1371595744',178029,'node',26),('1371595744',178031,'node',26),('1371595744',178033,'node',26),('1371595744',178032,'node',26),('1371595745',178035,'node',26),('1371595745',178037,'node',26),('1565',178042,'node',1),('1371595803',178042,'node',26),('1371595745',178039,'node',26),('1573',178043,'node',1),('1371595803',178043,'node',26),('1610',178044,'node',1),('1371595803',178044,'node',26),('1559',178046,'node',1),('1371595803',178046,'node',26),('1558',178045,'node',1),('1371595803',178045,'node',26),('1510',178047,'node',1),('1371595803',178047,'node',26),('1694',178048,'node',1),('1371595803',178048,'node',26),('1782',178051,'node',1),('1371595804',178051,'node',26),('1443',178049,'node',1),('1371595803',178049,'node',26),('1523',178052,'node',1),('1371595804',178052,'node',26),('1498',178053,'node',1),('1371595804',178053,'node',26),('1558',178054,'node',1),('1371595804',178054,'node',26),('1537',178056,'node',1),('1371595804',178056,'node',26),('1513',178055,'node',1),('1371595804',178055,'node',26),('1590',178057,'node',1),('1371595804',178057,'node',26),('1548',178058,'node',1),('1371595804',178058,'node',26),('1371595805',178062,'node',26),('1371595804',178060,'node',26),('1371595805',178063,'node',26),('1371595805',178064,'node',26),('1371595805',178068,'node',26),('1371595805',178066,'node',26),('1371595805',178070,'node',26),('1723',178074,'node',1),('1371595862',178074,'node',26),('1616',178073,'node',1),('1371595862',178073,'node',26),('1654',178075,'node',1),('1371595862',178075,'node',26),('1712',178076,'node',1),('1371595862',178076,'node',26),('1539',178077,'node',1),('1371595862',178077,'node',26),('1518',178079,'node',1),('1371595862',178079,'node',26),('1660',178078,'node',1),('1371595862',178078,'node',26),('1606',178080,'node',1),('1371595862',178080,'node',26),('1441',178082,'node',1),('1371595863',178082,'node',26),('1578',178084,'node',1),('1371595863',178084,'node',26),('1625',178083,'node',1),('1371595863',178083,'node',26),('1507',178085,'node',1),('1371595863',178085,'node',26),('1635',178086,'node',1),('1371595863',178086,'node',26),('1473',178089,'node',1),('1371595863',178089,'node',26),('1616',178088,'node',1),('1371595863',178088,'node',26),('1519',178087,'node',1),('1371595863',178087,'node',26),('1371595864',178091,'node',26),('1371595864',178094,'node',26),('1371595864',178093,'node',26),('1371595864',178095,'node',26),('1371595864',178097,'node',26),('1371595864',178099,'node',26),('1371595865',178101,'node',26),('1524',178104,'node',1),('1371595922',178104,'node',26),('1551',178106,'node',1),('1371595922',178106,'node',26),('1500',178105,'node',1),('1371595922',178105,'node',26),('1638',178107,'node',1),('1371595922',178107,'node',26),('1554',178108,'node',1),('1371595922',178108,'node',26),('1676',178110,'node',1),('1371595922',178110,'node',26),('1643',178109,'node',1),('1371595922',178109,'node',26),('1532',178111,'node',1),('1371595922',178111,'node',26),('1590',178113,'node',1),('1371595923',178113,'node',26),('1639',178115,'node',1),('1371595923',178115,'node',26),('1620',178114,'node',1),('1371595923',178114,'node',26),('1565',178116,'node',1),('1371595923',178116,'node',26),('1508',178118,'node',1),('1371595923',178118,'node',26),('1654',178117,'node',1),('1371595923',178117,'node',26),('1475',178119,'node',1),('1371595923',178119,'node',26),('1528',178120,'node',1),('1371595923',178120,'node',26),('1371595925',178124,'node',26),('1371595924',178122,'node',26),('1371595925',178125,'node',26),('1371595925',178126,'node',26),('1371595925',178130,'node',26),('1371595925',178128,'node',26),('1371595925',178132,'node',26),('1371595982',178136,'node',26),('1647',178135,'node',1),('1371595982',178135,'node',26),('1593',178137,'node',1),('1371595982',178137,'node',26),('1567',178136,'node',1),('1448',178138,'node',1),('1371595982',178138,'node',26),('1371595982',178140,'node',26),('1515',178139,'node',1),('1371595982',178139,'node',26),('1587',178141,'node',1),('1371595982',178141,'node',26),('1514',178140,'node',1),('1687',178142,'node',1),('1371595982',178142,'node',26),('1629',178144,'node',1),('1371595983',178144,'node',26),('1468',178146,'node',1),('1371595983',178146,'node',26),('1599',178145,'node',1),('1371595983',178145,'node',26),('1526',178147,'node',1),('1371595983',178147,'node',26),('1614',178149,'node',1),('1371595983',178149,'node',26),('1631',178148,'node',1),('1371595983',178148,'node',26),('1371595984',178156,'node',26),('1371595984',178155,'node',26),('1371595984',178153,'node',26),('1623',178151,'node',1),('1371595983',178151,'node',26),('1609',178150,'node',1),('1371595983',178150,'node',26),('1371595984',178159,'node',26),('1371595984',178157,'node',26),('1371595984',178161,'node',26),('1371595985',178163,'node',26),('1565',178166,'node',1),('1371596042',178166,'node',26),('1589',178168,'node',1),('1371596042',178168,'node',26),('1480',178167,'node',1),('1371596042',178167,'node',26),('1599',178170,'node',1),('1371596042',178170,'node',26),('1672',178169,'node',1),('1371596042',178169,'node',26),('1371596044',178187,'node',26),('1371596045',178190,'node',26),('1371596044',178188,'node',26),('1371596045',178192,'node',26),('1371596045',178194,'node',26),('1646',178198,'node',1),('1371596103',178198,'node',26),('1556',178197,'node',1),('1371596103',178197,'node',26),('1557',178199,'node',1),('1371596103',178199,'node',26),('1559',178200,'node',1),('1371596103',178200,'node',26),('1527',178202,'node',1),('1371596103',178202,'node',26),('1622',178201,'node',1),('1371596103',178201,'node',26),('1601',178203,'node',1),('1371596103',178203,'node',26),('1543',178204,'node',1),('1371596103',178204,'node',26),('1583',178207,'node',1),('1371596104',178207,'node',26),('1607',178206,'node',1),('1371596104',178206,'node',26),('1523',178208,'node',1),('1371596104',178208,'node',26),('1681',178209,'node',1),('1371596104',178209,'node',26),('1673',178211,'node',1),('1371596104',178211,'node',26),('1427',178210,'node',1),('1371596104',178210,'node',26),('1371596163',178237,'node',26),('1497',178235,'node',1),('1371596162',178235,'node',26),('1483',178234,'node',1),('1371596162',178234,'node',26),('1708',178233,'node',1),('1371596162',178233,'node',26),('1554',178232,'node',1),('1371596162',178232,'node',26),('1702',178239,'node',1),('1371596163',178239,'node',26),('1628',178238,'node',1),('1371596163',178238,'node',26),('1634',178240,'node',1),('1371596163',178240,'node',26),('1371596163',178242,'node',26),('1618',178241,'node',1),('1371596163',178241,'node',26),('1561',178243,'node',1),('1371596163',178243,'node',26),('1606',178242,'node',1),('1649',178244,'node',1),('1371596163',178244,'node',26),('1371596164',178248,'node',26),('1371596164',178246,'node',26),('1371596164',178249,'node',26),('1371596164',178252,'node',26),('1371596164',178250,'node',26),('1371596165',178254,'node',26),('1581',178259,'node',1),('1371596223',178259,'node',26),('1371596165',178256,'node',26),('1518',178260,'node',1),('1371596223',178260,'node',26),('1601',178261,'node',1),('1371596223',178261,'node',26),('1612',178262,'node',1),('1371596223',178262,'node',26),('1371596224',178275,'node',26),('1371596225',178279,'node',26),('1371596224',178277,'node',26),('1371596225',178280,'node',26),('1371596225',178281,'node',26),('1371596225',178285,'node',26),('1371596225',178283,'node',26),('1371596225',178287,'node',26),('1651',178291,'node',1),('1371596282',178291,'node',26),('1575',178290,'node',1),('1371596282',178290,'node',26),('1616',178292,'node',1),('1371596282',178292,'node',26),('1465',178293,'node',1),('1371596282',178293,'node',26),('1510',178294,'node',1),('1371596282',178294,'node',26),('1595',178296,'node',1),('1371596282',178296,'node',26),('1535',178295,'node',1),('1371596282',178295,'node',26),('1699',178297,'node',1),('1371596282',178297,'node',26),('1702',178300,'node',1),('1371596283',178300,'node',26),('1495',178299,'node',1),('1371596283',178299,'node',26),('1459',178301,'node',1),('1371596283',178301,'node',26),('1371596041',178164,'node',26),('1590',178165,'node',1),('1371596042',178165,'node',26),('1603',178174,'node',1),('1371596044',178174,'node',26),('1371596044',178183,'node',26),('1371596045',178189,'node',26),('1371596044',178185,'node',26),('1577',178196,'node',1),('1371596103',178196,'node',26),('1555',178205,'node',1),('1371596104',178205,'node',26),('1371596105',178214,'node',26),('1371596105',178216,'node',26),('1371596105',178220,'node',26),('1615',178236,'node',1),('1371596163',178236,'node',26),('1371596164',178245,'node',26),('1371596164',178247,'node',26),('1371596164',178251,'node',26),('1371596165',178255,'node',26),('1371596165',178253,'node',26),('1371596224',178276,'node',26),('1371596225',178282,'node',26),('1371596225',178278,'node',26),('1371596225',178284,'node',26),('1371596225',178286,'node',26),('1371596282',178289,'node',26),('1371596281',178288,'node',26),('1371596525',178438,'node',26),('1371596525',178436,'node',26),('1568',178445,'node',1),('1371596582',178445,'node',26),('1371596526',178442,'node',26),('1371596525',178440,'node',26),('1562',178446,'node',1),('1371596582',178446,'node',26),('1682',178448,'node',1),('1371596582',178448,'node',26),('1467',178447,'node',1),('1371596582',178447,'node',26),('1517',178449,'node',1),('1371596582',178449,'node',26),('1647',178451,'node',1),('1371596582',178451,'node',26),('1566',178450,'node',1),('1371596582',178450,'node',26),('1569',178452,'node',1),('1371596582',178452,'node',26),('1551',178455,'node',1),('1371596583',178455,'node',26),('1468',178454,'node',1),('1371596583',178454,'node',26),('1507',178458,'node',1),('1371596583',178458,'node',26),('1625',178457,'node',1),('1371596583',178457,'node',26),('1371596585',178473,'node',26),('1603',178476,'node',1),('1371596643',178476,'node',26),('1650',178478,'node',1),('1371596643',178478,'node',26),('1515',178477,'node',1),('1371596643',178477,'node',26),('1671',178479,'node',1),('1371596643',178479,'node',26),('1623',178480,'node',1),('1371596643',178480,'node',26),('1559',178482,'node',1),('1371596643',178482,'node',26),('1617',178481,'node',1),('1371596643',178481,'node',26),('1519',178483,'node',1),('1371596643',178483,'node',26),('1667',178491,'node',1),('1711',178485,'node',1),('1371596644',178485,'node',26),('1371596644',178491,'node',26),('1616',178490,'node',1),('1371596644',178490,'node',26),('1707',178489,'node',1),('1371596644',178489,'node',26),('1468',178488,'node',1),('1371596644',178488,'node',26),('1546',178487,'node',1),('1371596644',178487,'node',26),('1516',178486,'node',1),('1371596644',178486,'node',26),('1371596645',178496,'node',26),('1371596645',178494,'node',26),('1522',178492,'node',1),('1371596644',178492,'node',26),('1371596646',178500,'node',26),('1371596645',178498,'node',26),('1371596645',178497,'node',26),('1371596646',178504,'node',26),('1371596646',178502,'node',26),('1687',178507,'node',1),('1371596703',178507,'node',26),('1371596703',178508,'node',26),('1712',178509,'node',1),('1371596703',178509,'node',26),('1673',178508,'node',1),('1430',178511,'node',1),('1371596703',178511,'node',26),('1492',178510,'node',1),('1539',178521,'node',1),('1371596704',178521,'node',26),('1716',178523,'node',1),('1371596704',178523,'node',26),('1579',178522,'node',1),('1371596704',178522,'node',26),('1371596705',178525,'node',26),('1371596705',178527,'node',26),('1371596705',178529,'node',26),('1371596705',178528,'node',26),('1371596705',178531,'node',26),('1371596706',178535,'node',26),('1371596705',178533,'node',26),('1664',178538,'node',1),('1371596762',178538,'node',26),('1467',178539,'node',1),('1371596762',178539,'node',26),('1618',178541,'node',1),('1371596762',178541,'node',26),('1634',178540,'node',1),('1371596762',178540,'node',26),('1588',178542,'node',1),('1371596762',178542,'node',26),('1628',178543,'node',1),('1371596762',178543,'node',26),('1457',178545,'node',1),('1371596762',178545,'node',26),('1611',178544,'node',1),('1371596762',178544,'node',26),('1559',178547,'node',1),('1371596763',178547,'node',26),('1418',178548,'node',1),('1371596763',178548,'node',26),('1642',178551,'node',1),('1371596763',178551,'node',26),('1371596823',178573,'node',26),('1549',178574,'node',1),('1371596823',178574,'node',26),('1491',178573,'node',1),('1608',178575,'node',1),('1371596823',178575,'node',26),('1711',178576,'node',1),('1371596823',178576,'node',26),('1727',178579,'node',1),('1371596824',178579,'node',26),('1570',178578,'node',1),('1371596824',178578,'node',26),('1521',178580,'node',1),('1371596824',178580,'node',26),('1521',178581,'node',1),('1371596824',178581,'node',26),('1603',178583,'node',1),('1371596824',178583,'node',26),('1561',178582,'node',1),('1371596824',178582,'node',26),('1456',178584,'node',1),('1371596824',178584,'node',26),('1575',178585,'node',1),('1371596824',178585,'node',26),('1371596825',178587,'node',26),('1371596825',178590,'node',26),('1371596825',178589,'node',26),('1371596825',178591,'node',26),('1371596825',178595,'node',26),('1371596825',178593,'node',26),('1547',178601,'node',1),('1371596882',178601,'node',26),('1489',178600,'node',1),('1371596882',178600,'node',26),('1561',178612,'node',1),('1371596883',178612,'node',26),('1728',178611,'node',1),('1371596883',178611,'node',26),('1547',178613,'node',1),('1371596883',178613,'node',26),('1433',178614,'node',1),('1371596883',178614,'node',26),('1615',178615,'node',1),('1371596883',178615,'node',26),('1371596884',178624,'node',26),('1371596884',178622,'node',26),('1371596884',178621,'node',26),('1371596884',178620,'node',26),('1371596883',178618,'node',26),('1582',178616,'node',1),('1371596883',178616,'node',26),('1371596884',178628,'node',26),('1371596884',178626,'node',26),('1688',178631,'node',1),('1371596943',178631,'node',26),('1371596943',178633,'node',26),('1415',178632,'node',1),('1371596943',178632,'node',26),('1611',178634,'node',1),('1371596943',178634,'node',26),('1632',178633,'node',1),('1718',178635,'node',1),('1371596943',178635,'node',26),('1546',178637,'node',1),('1371596943',178637,'node',26),('1516',178636,'node',1),('1371596943',178636,'node',26),('1490',178638,'node',1),('1371596943',178638,'node',26),('1525',178640,'node',1),('1371596944',178640,'node',26),('1455',178642,'node',1),('1371596944',178642,'node',26),('1697',178641,'node',1),('1371596944',178641,'node',26),('1620',178643,'node',1),('1371596944',178643,'node',26),('1561',178646,'node',1),('1371596944',178646,'node',26),('1522',178645,'node',1),('1371596944',178645,'node',26),('1371596945',178649,'node',26),('1601',178647,'node',1),('1371596944',178647,'node',26),('1662',178665,'node',1),('1371597002',178665,'node',26),('1499',178666,'node',1),('1371597002',178666,'node',26),('1643',178668,'node',1),('1371597002',178668,'node',26),('1465',178667,'node',1),('1371597002',178667,'node',26),('1604',178671,'node',1),('1371597003',178671,'node',26),('1517',178669,'node',1),('1371597002',178669,'node',26),('1511',178673,'node',1),('1371597003',178673,'node',26),('1601',178672,'node',1),('1371597003',178672,'node',26),('1523',178674,'node',1),('1371597003',178674,'node',26),('1371628802',192200,'node',26),('1371628865',192201,'node',26),('1371628945',192223,'node',26),('1371628922',192222,'node',26),('1371628945',192232,'node',26),('1371628946',192234,'node',26),('1371629115',192254,'node',26),('1371629114',192245,'node',26),('1371629116',192262,'node',26),('1371629115',192260,'node',26),('1371629115',192256,'node',26),('1371629161',192266,'node',26),('1371629116',192264,'node',26),('1371629166',192276,'node',26),('1371629165',192267,'node',26),('1371629166',192278,'node',26),('1371629226',192298,'node',26),('1371629226',192289,'node',26),('1371629227',192300,'node',26),('1371629227',192306,'node',26),('1371629227',192304,'node',26),('1371629227',192308,'node',26),('1371629286',192311,'node',26),('1371629282',192310,'node',26),('1371629288',192330,'node',26),('1371629350',192333,'node',26),('1371629341',192332,'node',26),('1371629350',192335,'node',26),('1371629350',192339,'node',26),('1371629350',192341,'node',26),('1371629412',192354,'node',26),('1371629412',192350,'node',26),('1371629412',192356,'node',26),('1371629462',192360,'node',26),('1371629412',192358,'node',26),('1371629469',192361,'node',26),('1371629470',192374,'node',26),('1371629469',192370,'node',26),('1371629527',192394,'node',26),('1371629527',192390,'node',26),('1371629527',192396,'node',26),('1371629527',192398,'node',26),('1371629582',192400,'node',26),('1302',192410,'node',1),('1371629649',192410,'node',26),('1371629648',192401,'node',26),('1371629719',192425,'node',26),('984',192423,'node',1),('1371629718',192423,'node',26),('1371629719',192429,'node',26),('1371629719',192431,'node',26),('1371629761',192435,'node',26),('1371629719',192433,'node',26),('1397',192436,'node',1),('1371629784',192436,'node',26),('317',192449,'node',1),('1371629835',192449,'node',26),('1371629821',192448,'node',26),('1371629835',192451,'node',26),('1371629836',192455,'node',26),('1371629836',192459,'node',26),('1371629836',192457,'node',26),('317',192461,'node',1),('1371629838',192461,'node',26),('1371629886',192477,'node',26),('1371629887',192483,'node',26),('1371629886',192481,'node',26),('1371629887',192485,'node',26),('1371629946',192488,'node',26),('1371629941',192487,'node',26),('1371629946',192497,'node',26),('1371629469',192368,'node',26),('1371629469',192367,'node',26),('1371629469',192369,'node',26),('1371629469',192371,'node',26),('1371629469',192373,'node',26),('1371629469',192372,'node',26),('1371629470',192375,'node',26),('1371629470',192377,'node',26),('1371629470',192379,'node',26),('1371629526',192383,'node',26),('1371629526',192382,'node',26),('1371629526',192384,'node',26),('1371629526',192385,'node',26),('1371629526',192387,'node',26),('1371629526',192386,'node',26),('1302',192411,'node',1),('1371629649',192411,'node',26),('1371629648',192409,'node',26),('1371629649',192413,'node',26),('1371629649',192414,'node',26),('1371629650',192417,'node',26),('1371629649',192415,'node',26),('1371629650',192419,'node',26),('1371629785',192443,'node',26),('1371629784',192441,'node',26),('1371629785',192445,'node',26),('1371629786',192447,'node',26),('317',192450,'node',1),('1371629835',192450,'node',26),('1371629835',192452,'node',26),('1371629835',192454,'node',26),('1371629835',192453,'node',26),('1371629885',192474,'node',26),('1371629885',192473,'node',26),('6667',192476,'node',1),('1371629886',192476,'node',26),('1371629886',192478,'node',26),('1371629886',192479,'node',26),('1371629886',192482,'node',26),('1371629886',192480,'node',26),('1371629887',192486,'node',26),('1371629887',192484,'node',26),('1371629947',192506,'node',26),('1371629947',192508,'node',26),('1371630006',192512,'node',26),('1371630006',192511,'node',26),('1371630006',192513,'node',26),('1371630006',192514,'node',26),('1371630006',192521,'node',26),('1371630006',192522,'node',26),('1371630007',192526,'node',26),('1371630007',192524,'node',26),('1371630007',192528,'node',26),('1371630066',192531,'node',26),('1371630066',192533,'node',26),('1371630066',192532,'node',26),('1371630066',192535,'node',26),('1371630066',192534,'node',26),('1371630066',192536,'node',26),('1371630066',192537,'node',26),('1371630067',192540,'node',26),('1371630066',192538,'node',26),('1371630067',192541,'node',26),('1371630067',192544,'node',26),('1371630067',192542,'node',26),('1371630067',192548,'node',26),('1371630067',192546,'node',26),('1371630126',192551,'node',26),('1371630126',192553,'node',26),('1371630126',192552,'node',26),('1371630126',192554,'node',26),('1371630126',192556,'node',26),('1371630126',192555,'node',26),('1371630126',192557,'node',26),('890',192560,'node',1),('1371630127',192560,'node',26),('1371630126',192558,'node',26),('1371630127',192563,'node',26),('1371630127',192562,'node',26),('1371630127',192564,'node',26);
/*!40000 ALTER TABLE `search_index` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `search_node_links`
--

DROP TABLE IF EXISTS `search_node_links`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_node_links` (
  `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The search_dataset.sid of the searchable item containing the link to the node.',
  `type` varchar(16) NOT NULL DEFAULT '' COMMENT 'The search_dataset.type of the searchable item containing the link to the node.',
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid that this item links to.',
  `caption` longtext COMMENT 'The text used to link to the node.nid.',
  PRIMARY KEY (`sid`,`type`,`nid`),
  KEY `nid` (`nid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores items (like nodes) that link to other nodes, used...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_node_links`
--

LOCK TABLES `search_node_links` WRITE;
/*!40000 ALTER TABLE `search_node_links` DISABLE KEYS */;
/*!40000 ALTER TABLE `search_node_links` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `search_total`
--

DROP TABLE IF EXISTS `search_total`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_total` (
  `word` varchar(50) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique word in the search index.',
  `count` float DEFAULT NULL COMMENT 'The count of the word in the index using Zipf’s law to equalize the probability distribution.',
  PRIMARY KEY (`word`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores search totals for words.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_total`
--

LOCK TABLES `search_total` WRITE;
/*!40000 ALTER TABLE `search_total` DISABLE KEYS */;
INSERT INTO `search_total` VALUES ('naa6000c29eeb2b6dbd2d24552781be174b',0.0054629),('naa6000c29a784d07bfd536222612ee057f',0.0054629),('naa5002538050003d09',0.00827253),('naa5000c50041938b37',0.00827253),('naa5000c50040cc7d03',0.00782534),('naa600a09803c1b589db5363869fc0027d0',0.00811789),('naa6000c294aba0be1db4257742f4ab2149',0.0054629),('naa6000c2908e605dca09ff6427d4bd914a',0.00230395),('naa6000c297064a18dfa88eced6be50e057',0.00811789),('naa6000c291fd64f90bd3d371b644cee3c5',0.0054629),('naa6000c29102ce37a07ac01e2ced3959b8',0.0054629),('naa6000c2973380870eb4d88784ea671eca',0.0054629),('naa6000c290b1821e62cf431ca26bf1f765',0.0054629),('naa60a9800037543261553f41783945462f',0.00827253),('naa60a9800037543261505d424f3132567a',0.00827253),('naa60a9800037543261505d424f31325757',0.00827253),('naa60a9800037543261505d424f31325755',0.00827253),('naa60a9800037543261505d424f31325637',0.00827253),('naa60a9800037543261505d424f31325751',0.00827253),('naa60a9800037543261505d424f31325274',0.00827253),('naa60a9800037543261505d424f31325559',0.00827253),('naa60a9800037543261553f417839454857',0.00827253),('naa60a9800037543261505d424f31325737',0.00827253),('naa60a9800037543261505d424f3132574f',0.00827253),('naa60a9800037543261553f417839454855',0.00827253),('naa60a9800037543261505d424f31325731',0.00827253),('naa60a9800037543261505d424f31325653',0.00827253),('naa60a9800037543261505d424f31325651',0.00827253),('naa60a9800037543261553f417839454155',0.00827253),('naa60a9800037543261553f417839454153',0.00827253),('naa60a9800037543261505d424f31325768',0.00827253),('naa60a9800037543261505d424f31325764',0.00827253),('ata',0.00407791),('naa5002538050003d38',0.0163904),('ibmesxs',0.00407791),('disk',5.69903e-05),('serial',0.000977041),('attached',0.000977041),('scsi',0.000977041),('netapp',5.3167e-05),('fibre',5.87957e-05),('channel',5.87957e-05),('naa60a9800037543261505d424f31325645',0.00411657),('naa6000c29121e66c0d79b623de3052d405',0.00811789),('naa6000c29bc48a17080060b2a7a04002fc',0.00811789),('naa6000c29d47d77c0cd2025e1971109dd6',0.0163904),('naa6000c2961e793febff84f5ced5c58b21',0.00811789),('naa6000c292f6633bcff2180b75206f0661',0.00811789),('naa6000c290d6a786993a27840bc7e74219',0.00811789),('naa6000c29e9e802ff92aa3e9751bb1ccf8',0.00811789),('naa6000c294f5dd6c075c769db0311d7918',0.00811789),('naa6000c29df644dce63fd960a3bf12b1d5',0.00811789),('naa6000c290953dbf42f2b92e416d97f3d6',0.00811789),('naa6000c29bf5e027a66f21c82dcb90d5f2',0.00811789),('naa6000c29675dd7a7e994beefc89fb5588',0.00811789),('naa6000c2950d47cdaa94a633480603dd7e',0.00811789),('naa6000c2956b7de21f10dd9f2621408e5a',0.00811789),('naa6000c298ceb3a9e5a4bd63b85488b9e6',0.00811789),('naa6000c2997b6962f32a26b73da8e61119',0.00811789),('1687',0.09691),('naa6000c29ff0e809d5b2af05c5768c5cff',0.00811789),('779',0.0669468),('naa600a09809324a93ace0e8370fc013750',0.0163904),('317',0.0457575),('naa6000c29b18316ab182310d09e03d2b2a',0.00811789),('naa6000c29682c740d63afb534636704664',0.00811789),('1580',0.0263289),('naa60a9800037543261505d424f31325674',0.0163904),('naa6000c296839ce8de1e698a38b6fc7173',0.00811789),('1654',0.0321847),('naa6000c29c778256eb8f4b6c1a1dce5fcb',0.00811789),('1622',0.124939),('1395',0.0511525),('naa6000c2984c0245d266169b9686a2e0c5',0.00811789),('naa6000c29efaa27da235fda642d90b098e',0.00811789),('naa6000c2908408da158a5c3bfb61c07879',0.00811789),('naa600605b0042a0dd01916818716e4e397',0.0163904),('naa600a098044307535732b334571527534',0.0163904),('naa6000c290b447224a367ae88729a10481',0.0163904),('naa6000c29659d5ed1d994feb862b35f563',0.0163904),('naa6000c297f078b46cc95f683d3fad2304',0.0163904),('naa6000c293a337fcf57f8ea9762309fd54',0.00811789),('hgw2k8r232vm22',0.00811789),('hgw2k8r232vm21',0.00827253),('hgw2k8r232vm20',0.00827253),('1634',0.0347621),('1371629718',0.00827253),('hgw2k8r232vm19',0.00827253),('1675',0.0413927),('1694',0.0791812),('hgw2k8r232vm18',0.00827253),('hgw2k8r232vm17',0.00827253),('naa6000c2981d553aa25cfefeeb7b4bc25e',0.0163904),('naa6000c295e8b49c56dd6827fe418ea715',0.0163904),('naa6000c29b23567272d0e586205dcc32cf',0.0163904),('1407',0.0211893),('naa6000c2938bb49a8d2e5d49b476c92cf9',0.0163904),('naa6000c2950a1a5ab366bf05b6692f2079',0.0163904),('naa6000c29a5e879be9aeff82ec4073485e',0.0163904),('naa6000c299d3ae339df867c0de47a27d80',0.0163904),('naa60a9800037543261505d424f31325672',0.0163904),('naa60a9800037543261505d424f31325670',0.0163904),('1631',0.0280287),('naa6000c2918b7a0a89bc9c6ffe16eb9871',0.0163904),('naa6000c29980b86140cc05e5ce0e9e43b1',0.0163904),('naa6000c29277c4580946c7adda249783a0',0.0163904),('naa6000c29a1f5f7d26f2a75fb16217d54e',0.0163904),('naa6000c29b26a3835e07a5d36f5837bba5',0.0163904),('naa6000c29de233a6cbb6e5b79519ee353a',0.0163904),('1656',0.0457575),('naa6000c29783fc4f972a0e2aa7af5c9ebc',0.0163904),('naa6000c293d27251a8a3f12accfb90bfc3',0.0163904),('naa6000c29a2edac2d4e7c2f015ced57b68',0.0163904),('naa6000c291e7664b34dc236a785a15a710',0.0163904),('naa6000c2948cee8e308227c11728d12994',0.0163904),('naa6000c295475d09ab8ae1de90a71dec6f',0.0163904),('1662',0.176091),('1638',0.0511525),('1716',0.124939),('1655',0.0791812),('1658',0.0511525),('1673',0.0791812),('1465',0.0579919),('1650',0.0413927),('naa60a9800037543261505d424f31325639',0.0163904),('1685',0.0669468),('1563',0.0211893),('1711',0.09691),('1568',0.0280287),('1571',0.0263289),('1508',0.0202034),('1579',0.0163904),('naa6000c29dc66f186790f6c654494feb0f',0.0163904),('1697',0.30103),('1717',0.30103),('890',0.0321847),('12',0.00157069),('11',0.000881816),('1561',0.0299632),('107',0.00729924),('naa6000c2983a5286249c37e5d021904aaa',0.0163904),('naa6000c294e3b594ec724e3a4db1a4516c',0.0163904),('naa6000c290a1e6f7dcd64bad2f0508e1ea',0.0163904),('naa6000c29475b97b7e2d72ab1a29ba04a0',0.0163904),('custom',0.0511525),('naa60a9800037543261505d424f31325557',0.0163904),('naa600a098044307535732b334571527535',0.0163904),('1707',0.176091),('naa60a9800037543261505d424f31325633',0.0163904),('1598',0.0142404),('1517',0.0669468),('1586',0.0347621),('1590',0.0248236),('1488',0.0202034),('1431',0.124939),('naa60a9800037543261505d424f31325555',0.0163904),('1617',0.0413927),('1573',0.0347621),('1427',0.124939),('1698',0.09691),('1678',0.0791812),('1516',0.0377886),('1666',0.09691),('1519',0.0263289),('1576',0.0377886),('naa6000c291630bfde3725bb05887739ba8',0.0163904),('naa6000c29909baac34d177a4a3840328b8',0.0163904),('1371223562',0.00553249),('1371223502',0.00415596),('1371223442',0.00553249),('5000',0.00239281),('1371223262',0.00553249),('1371223202',0.00553249),('1371223142',0.00553249),('1371223082',0.00553249),('1371223022',0.00553249),('1371222962',0.00553249),('1371222902',0.00553249),('naa60a9800037543261505d424f31325631',0.0163904),('1712',0.124939),('1371222842',0.00553249),('1371222782',0.00553249),('1371222722',0.00415596),('1371222662',0.00553249),('1371222482',0.00415596),('1371222542',0.00415596),('naa60a9800037543261505d424f31325553',0.0163904),('1616',0.0347621),('1359',0.0511525),('1705',0.124939),('1596',0.0669468),('1574',0.0669468),('1591',0.00634018),('1392',0.0299632),('1606',0.0457575),('1722',0.0102192),('1489',0.0669468),('1660',0.0280287),('1515',0.0377886),('1371222302',0.00553249),('1524',0.0280287),('1371222362',0.00553249),('1371221942',0.00553249),('1583',0.0347621),('984',0.0457575),('naa600a098044307535732b334571533656',0.0163904),('naa600a098044307535732b334571533579',0.00827253),('naa600a098044307535732b334571533657',0.0163904),('naa600a098044307535732b334571533658',0.0163904),('naa600a098044307535732b334571533659',0.0163904),('naa600a098044307535732b33457153366e',0.0163904),('naa600a098044307535732b33457153366f',0.0163904),('naa600a098044307535732b33457152754a',0.0163904),('naa600a098044307259313f334556393461',0.0163904),('naa600a098044307535732b33457152754b',0.0163904),('naa600a098044307259313f334556393462',0.0163904),('naa600a098044307259313f334556393463',0.0163904),('hgw2k8r232vm2',0.0163904),('598856',0.0791812),('hgw2k8r232vm3',0.00811789),('naa60a9800037543261505d424f31325551',0.0163904),('1494',0.0211893),('1699',0.0791812),('1597',0.0579919),('1522',0.0791812),('1438',0.0413927),('1595',0.0511525),('1585',0.0377886),('naa600a098044307535732b334571533650',0.0163904),('naa600a098044307535732b334571533572',0.0054629),('naa600a098044307535732b334571533573',0.00827253),('naa600a098044307535732b334571533651',0.0163904),('naa600a098044307535732b334571533571',0.0054629),('naa600a098044307535732b334571533574',0.00827253),('naa600a098044307535732b334571533652',0.0163904),('naa600a098044307535732b334571533575',0.00827253),('naa600a098044307535732b334571533653',0.0163904),('naa600a098044307535732b334571533576',0.00827253),('naa600a098044307535732b334571533577',0.00827253),('naa600a098044307535732b334571533654',0.0163904),('naa600a098044307535732b334571533578',0.00827253),('naa600a098044307535732b334571533655',0.0163904),('hgw2k8r232vm4',0.00811789),('hgw2k8r232vm5',0.00811789),('hgw2k8r232vm6',0.00811789),('hgw2k8r232vm1',0.00811789),('hgw2k8r232vm7',0.00811789),('hgw2k8r232vm8',0.00811789),('hgw2k8r232vm9',0.00811789),('hgw2k8r232vm10',0.00811789),('naa6000c299242f2fcb24b70a806cfd6483',0.0163904),('naa6000c296b36c887ceec41b5e40543c63',0.0163904),('naa6000c29a765bf9dd27349f08fccc80c9',0.0163904),('naa6000c29b3222956854879461dd964e80',0.0163904),('naa6000c292e0633db9e8f9555d658ad2ca',0.0163904),('naa6000c29362e532d0433c7b0f3f444807',0.0163904),('naa6000c29532d9e75758061ca5a90c3743',0.0163904),('naa6000c2902d5ba8be5966051779f73945',0.0163904),('naa6000c29210632526769e22c7c31ff326',0.0163904),('naa6000c2935081e51a2200a7f51268b899',0.0163904),('naa6000c29a98d1500a789935c211afcfa4',0.0163904),('naa6000c293f222457d87adc267eccabf11',0.0163904),('naa6000c297ce254a93f01e4bda7755f8b1',0.0163904),('naa6000c294cc74c7000608f59a1e6e6cc5',0.0163904),('naa6000c29bd75f23cc168d13228cfd1188',0.0163904),('naa6000c29449c9f7c6ccee27d61d6b548a',0.0163904),('naa6000c299cd2c79e031925c1358c473e6',0.0163904),('naa6000c29733b0365706a54a9a5c2471db',0.0163904),('naa6000c291c6a3669ea9c11a428428f0c0',0.0163904),('naa6000c29ae3e105bef458100c41d96e5e',0.0163904),('naa6000c29d4104df0cf1b6ebc4fb7e62ea',0.0163904),('naa6000c298015b74673771ea38b8763c63',0.0163904),('naa6000c29aa56348f8c52aa982d67a435c',0.0163904),('naa6000c2950d69f69a7e0086277a1537b6',0.0163904),('naa6000c29a54a9df10c14901abe20b4848',0.0163904),('naa6000c293d46dcdef17137ae44b3e63b3',0.0163904),('naa6000c294c7019963f07607c89dc4666a',0.0163904),('naa6000c29bf50a0ed8408706208f3ae812',0.0163904),('naa6000c29a4374a6fc984cc3df423d7826',0.0163904),('naa6000c294dd93e79791523ad9469f1531',0.0163904),('naa6000c296784e9dc1250b3216789698b6',0.0163904),('naa6000c29630b208ccee2b19c7051c2179',0.0163904),('naa6000c29a8feb68507998c1e5005c8d6a',0.0163904),('naa6000c29428a929259bdf1e335a6a0cf3',0.0163904),('naa6000c29f518a6ba4ce7d35ae9a59df2f',0.0163904),('naa6000c295a0eeb2a325ce87cb26a569cc',0.0163904),('naa6000c29f0e122c0c693e1a11e56d3b50',0.0163904),('naa6000c2968e87a4052eaebe934cd108c9',0.0163904),('naa6000c29acdcfc3731068d112b925c117',0.0163904),('naa6000c299273ff09587c8a7d753e6cbad',0.0163904),('naa600a098044307259313f334556393444',0.00827253),('1498',0.0321847),('1640',0.0193052),('naa600a098044307259313f334556393443',0.00827253),('1521',0.0511525),('1514',0.0321847),('1618',0.0413927),('1461',0.0347621),('naa60a9800037543261505d424f3132554f',0.0163904),('1569',0.0413927),('1434',0.0377886),('1371222422',0.00553249),('1578',0.0234811),('1371222182',0.00553249),('1371222602',0.00553249),('1371221582',0.00553249),('1371221222',0.00553249),('1371221282',0.00553249),('1371221342',0.00553249),('1371221401',0.00553249),('1430',0.0184834),('1371221462',0.00553249),('1400',0.0347621),('1371221524',0.00553249),('1510',0.0202034),('naa600a098044307259313f334556393430',0.0163904),('1503',0.0321847),('1379',0.0321847),('1401',0.0234811),('1507',0.0377886),('1518',0.0299632),('1511',0.0377886),('1467',0.0511525),('1526',0.0321847),('1475',0.0347621),('1680',0.00694886),('1572',0.0184834),('1772',0.0457575),('1570',0.0193052),('1439',0.09691),('1747',0.00895484),('1492',0.0347621),('1455',0.0791812),('1509',0.0280287),('1446',0.01524),('1755',0.176091),('naa600a098044307259313f334556393437',0.00827253),('naa600a098044307259313f334556393436',0.0054629),('naa600a098044307259313f334556393438',0.00827253),('naa600a098044307259313f334556393439',0.00827253),('naa600a098044307259313f334556393435',0.0054629),('naa600a098044307259313f334556393470',0.0163904),('naa600a098044307259313f334556393471',0.0163904),('naa600a098044307259313f334556393472',0.0163904),('naa600a098044307259313f334556393473',0.0163904),('naa600a098044307259313f334556393474',0.0163904),('naa600a098044307259313f334556393475',0.0163904),('naa600a098044307259313f334556393476',0.0163904),('naa60a9800037543261505d424f3132557a',0.0163904),('1470',0.01524),('naa600508e07e7261775c39bd2ebac3410f',0.0163904),('1403',0.0193052),('naa600a0980219f29ef2f974c117b04aba2',0.0163904),('naa600a098044307535732b334571533671',0.0163904),('naa600a098044307535732b334571533670',0.0163904),('naa600a098044307535732b334571533639',0.0163904),('1491',0.0347621),('naa600a098044307535732b334571533638',0.0163904),('naa600a098044307535732b334571533637',0.0163904),('1502',0.00582954),('naa600a098044307535732b334571533636',0.0163904),('1423',0.0157943),('1442',0.0791812),('naa600a098044307535732b334571533635',0.0163904),('1481',0.012965),('naa600a098044307535732b334571533634',0.0163904),('naa600a098044307535732b334571533633',0.0163904),('naa600a098044307535732b334571533632',0.0163904),('naa600a098044307535732b334571533631',0.0163904),('1453',0.00843317),('naa600a098044307535732b334571533630',0.0163904),('1764',0.09691),('naa600a098044307259313f33455639346f',0.0163904),('1485',0.0147233),('naa600a098044307259313f33455639346e',0.0163904),('naa600a098044307259313f33455639346d',0.0163904),('naa600a098044307259313f33455639346c',0.0163904),('1422',0.0579919),('naa600a098044307259313f33455639346b',0.0163904),('1443',0.0457575),('naa600a098044307259313f33455639346a',0.0163904),('1472',0.0321847),('naa600a098044307259313f33455639342f',0.0163904),('1456',0.0347621),('naa6000c29dd17f56e30f12a86aa07ef6da',0.0163904),('naa600a098044307259313f33455639342d',0.00827253),('naa6000c29e3371e54aa56bb0971032e089',0.0163904),('naa600a0980939a29efb56946117b03aba2',0.0163904),('naa600a098044307259313f334556393469',0.0163904),('naa600a098044307259313f334556393468',0.0163904),('naa600a098044307259313f334556393467',0.0163904),('1452',0.0579919),('naa600a098044307259313f334556393466',0.0163904),('1575',0.0321847),('naa600a098044307259313f334556393465',0.0163904),('naa600a098044307259313f334556393464',0.0163904),('1476',0.09691),('1700',0.00213413),('naa60a9800037543261505d424f31325566',0.0163904),('1445',0.0163904),('naa60a9800037543261505d424f31325643',0.0163904),('naa600a098044307259313f33455638724c',0.0163904),('naa600a098044307259313f33455638724d',0.0163904),('naa60a9800037543261505d424f31325578',0.0163904),('naa60a9800037543261505d424f31325572',0.0163904),('1464',0.0163904),('lsi',0.00539503),('local',0.00415596),('1480',0.0137883),('1371222242',0.00553249),('1500',0.00975984),('1371222063',0.00553249),('naa60a9800037543261505d424f31325570',0.0163904),('1433',0.124939),('ibm',0.00768683),('1371222122',0.00553249),('naa600605b0042a0dd01895642016bf17dc',0.0163904),('1581',0.0511525),('mpxvmhba1',0.00811789),('1371221703',0.00553249),('1371221762',0.00553249),('1',2.68075e-05),('1371221162',0.00553249),('10000',0.000755952),('1371221102',0.00415596),('vmware',0.00260838),('1371221643',0.00553249),('1371221822',0.00553249),('1371221042',0.00553249),('naa60a9800037543261505d424f3132556a',0.0163904),('1353',0.0791812),('naa60a9800037543261505d424f31325649',0.0163904),('naa60a9800037543261505d424f31325647',0.0163904),('naa60a9800037543261505d424f31325568',0.0163904),('1473',0.0457575),('naa60a9800037543261553f417839445249',0.0163904),('naa60a9800037543261553f417839445247',0.0163904),('naa60a9800037543261553f417839445245',0.0163904),('1490',0.0263289),('1426',0.0347621),('naa60a9800037543261553f417839445235',0.0163904),('accel',0.00267259),('flash',0.00267259),('1420',0.00742402),('naa60a9800037543261553f417839454162',0.0163904),('naa60a9800037543261553f41783944517a',0.0163904),('1562',0.0579919),('naa60a9800037543261553f417839445255',0.0163904),('1670',0.0299632),('naa60a9800037543261553f417839445178',0.0163904),('1384',0.0511525),('naa60a9800037543261553f417839445253',0.0163904),('naa60a9800037543261553f417839445176',0.0163904),('naa60a9800037543261553f417839445251',0.0163904),('naa60a9800037543261553f417839454159',0.00811789),('naa60a9800037543261553f41783944524f',0.0163904),('naa60a9800037543261553f41783944524d',0.0163904),('naa60a9800037543261553f41783944524b',0.0163904),('iscsi',0.000794684),('1720',0.000907617),('naa60a9800037543261505d424f31325564',0.0163904),('naa60a9800037543261553f41783945482f',0.0163904),('1479',0.0669468),('1584',0.0137883),('naa6000c29ce39995d215bdbe84b1a58c17',0.0163904),('naa6000c2972f5eb0f1acad26055f514f6d',0.0163904),('naa6000c292b38715a4bf5db11a06a63e31',0.0163904),('naa60a9800037543261505d424f3132564f',0.0163904),('naa6000c29a55144da0ca59bf68548743f1',0.0163904),('naa6000c292d1e0ba34fcd69f4a7ddb7966',0.0163904),('naa6000c298badd992c7dfa3d313aaf4308',0.0163904),('naa6000c29bf6e0f4fedbe7daf1e1752859',0.0163904),('naa6000c29e72b201aedfc8a958975f29c5',0.0163904),('naa6000c292e5269fcf7b9ac98f5a58d98d',0.0163904),('naa6000c29487a81812d7fcd470b1f05b92',0.0163904),('naa6000c296d616c278083d43923197613d',0.0163904),('naa6000c29bf7087777c6b1a06aa36aa01b',0.0163904),('1371220982',0.00553249),('naa6000c29e90267af74612bf02c867a8a9',0.0163904),('naa6000c29fb5474c246b501f6412606177',0.0163904),('naa6000c296ccdeb9458e68e338f3cd6a82',0.0163904),('naa6000c29f155edba699afe8c5ae930141',0.0163904),('hgrx6001gdlenglabnetappcom',0.00827253),('naa6000c294bb43532c863aee47b5f5049f',0.0163904),('hgx36904gdlenglabnetappcom',0.00827253),('naa6000c29b8296536ec7810e73af9e6c3a',0.0163904),('hgx36902gdlenglabnetappcom',0.00827253),('naa6000c2989e012f7d70034f59682da73f',0.0163904),('naa6000c299fd4914145c44d7f0cb9bbb61',0.0163904),('hgrx3001gdlenglabnetappcom',0.00827253),('naa6000c2928d3847de8b714947ebe88135',0.0163904),('naa6000c292da51f1aa36aa0f8f36ab63a1',0.0163904),('hgrx3009gdlenglabnetappcom',0.00827253),('naa600a098044307535732b334571533570',0.0163904),('naa600a098044307259313f334556393373',0.0163904),('naa6000c2961aac254c504c6d67ecb5f8ac',0.0163904),('1371220922',0.00553249),('1371221882',0.00553249),('x36903vm1',0.00796893),('1371220862',0.00553249),('x36903vm0',0.00796893),('1371222002',0.00553249),('fasanity01w2k8r2',0.00811789),('naa600a098044307259313f33455638724f',0.0163904),('naa600a098044307259313f33455638724e',0.0163904),('1371220802',0.00415596),('1371220742',0.00553249),('fasanity03w2k8r2',0.00811789),('naa60a9800037543261505d424f31325641',0.0163904),('fmcqa',0.00796893),('naa6000c2950cabe6ece937dc69d952ae4e',0.00811789),('naa6000c29eecc6e9adbb0132e3b3ff7d22',0.00811789),('naa6000c291fd2395fe3c1997950b8a8c0c',0.00811789),('1603',0.0791812),('naa6000c2967439883ffd8ad92ee6de2a3c',0.00811789),('naa6000c29a8d23467dedb9b0a508ab6f92',0.00811789),('naa6000c290abfaf53c3b2c643b607038bf',0.00811789),('naa6000c2953e4b58e3268b2275f65c00b3',0.00811789),('naa6000c29a09f274bcd4bbf3ae484e5e7a',0.00811789),('naa6000c29ac85e6f88af7b4f6868fbe87a',0.00811789),('naa6000c2940cc5bf41316a55e0c94957c8',0.00811789),('naa6000c29d4e2ce7b705f66fdbdb461313',0.00811789),('naa6000c29aab2e04f2571c7c6050ee8353',0.00811789),('naa6000c294064b8b30c8452cef95062d75',0.00811789),('naa6000c29a1b45eeace0049699f7123c20',0.00811789),('naa6000c296b486ba69a3f71bbafc3e5f15',0.00811789),('naa6000c298693d22a716644668f808bc18',0.00811789),('naa6000c29af0bf917f423b0f7b4d54e792',0.00811789),('naa6000c299e65677701b273f929adbcc1f',0.00811789),('naa6000c297b449a234fac7c88a0cbeb75e',0.00811789),('naa6000c29c8124bd2298ececba4c3782b1',0.00811789),('naa6000c29b3fec74f237a67afa746f5d55',0.00811789),('naa6000c2935c4a6942cc0cd05e188cf9ba',0.00811789),('naa6000c29c58d9db25ed3a37b024d23841',0.00811789),('naa6000c295eaa5dccf467bbae8044414ce',0.00811789),('naa6000c29b205838c4c55aaafda23eed79',0.00811789),('1623',0.0347621),('naa6000c29a03b63f95b8f592f18d630b86',0.00811789),('naa6000c29b4b82c4cc1945e2db12671829',0.00811789),('naa6000c29e08ce8c49f3881f5e5458acda',0.00811789),('naa6000c29beb328cfb51bf06835ac5ed52',0.00811789),('naa6000c2921dd7be48256aa02064b5d01d',0.00811789),('hgw2k8r232vm23',0.00811789),('hgw2k8r232vm24',0.00811789),('hgw2k8r232vm25',0.00811789),('1677',0.0791812),('hgw2k8r232vm26',0.00811789),('hgw2k8r232vm27',0.00811789),('1639',0.0511525),('hgw2k8r232vm28',0.00811789),('hgw2k8r232vm29',0.00811789),('hgw2k8r232vm30',0.00811789),('1607',0.0321847),('hgw2k8r232vm31',0.00811789),('management',0.00267259),('console',0.00270589),('hgw2k8r232vm33',0.00827253),('hgw2k8r232vm32',0.00811789),('naa6000c2937aedbf22b1bf4f872c4765df',0.0163904),('1626',0.0413927),('1652',0.0457575),('1682',0.0669468),('1645',0.0791812),('1664',0.0511525),('1566',0.0234811),('1594',0.00553249),('1593',0.0222764),('1604',0.0511525),('1635',0.0321847),('1588',0.0457575),('1641',0.0791812),('1371220622',0.00553249),('1615',0.0669468),('1621',0.0413927),('1619',0.00553249),('1630',0.0347621),('1643',0.0457575),('1608',0.0511525),('1671',0.0669468),('1610',0.012965),('1649',0.0791812),('1661',0.176091),('1676',0.0791812),('hgw2k8r232vm15',0.00827253),('1560',0.0263289),('1636',0.0511525),('1599',0.0280287),('1611',0.0669468),('1693',0.0234811),('1371042362',0.00827253),('1448',0.0347621),('naa6000c297ed59dbc39a6bbb805c2fb800',0.0163904),('1613',0.0413927),('1704',0.0104654),('1620',0.0413927),('1582',0.0511525),('1667',0.0791812),('1577',0.0457575),('1644',0.0791812),('1695',0.0377886),('1688',0.124939),('1605',0.0413927),('naa600a098044307259313f33455638724b',0.0163904),('naa600a098044307259313f33455638724a',0.0163904),('naa600a098044307259313f33455639344f',0.0163904),('1703',0.176091),('1614',0.0222764),('1609',0.0791812),('1651',0.124939),('1668',0.0147233),('1627',0.0347621),('1625',0.0321847),('1587',0.0184834),('1648',0.00607415),('1629',0.0511525),('naa6000c29b45fb593085a2c48782b02044',0.0163904),('1460',0.00998422),('naa600a098044307259313f33455639344e',0.0163904),('naa6000c29be91afe402ae96fef3affb26e',0.0163904),('naa600a098044307259313f33455639344d',0.0163904),('1334',0.00998422),('naa6000c2979079a872bc7b010e0990382e',0.0163904),('naa600a098044307259313f33455639344c',0.0163904),('1344',0.30103),('naa6000c29581ab8a2d1e213ab7a5097f25',0.0163904),('naa600a098044307259313f33455639344b',0.0163904),('naa600a098044307259313f33455639344a',0.0163904),('naa600a098044307259313f334556387249',0.0163904),('naa600a098044307259313f334556387248',0.0163904),('naa600a098044307259313f334556387247',0.0163904),('hgw2k8r2cs9',0.00811789),('naa6000c291737bb4cb6f8e9f8eb55ff3fe',0.0163904),('naa600a098044307259313f334556387246',0.0163904),('naa600a098044307259313f334556387245',0.0163904),('naa600a098044307259313f334556387244',0.0163904),('1373',0.0669468),('hgvmhemanth84gdlenglabnetappcom',0.00811789),('naa600a098044307259313f334556387243',0.0163904),('1646',0.09691),('naa600a098044307259313f334556393459',0.0163904),('1424',0.0234811),('naa6000c29aac086487546a2ca8dd2ebd5a',0.0163904),('1487',0.0222764),('1653',0.00643411),('1365',0.0511525),('naa600a098044307259313f334556393449',0.0163904),('naa600a098044307259313f334556393448',0.0163904),('1393',0.0669468),('naa600a098044307259313f334556393447',0.0163904),('1371042544',0.000521675),('1371042303',0.000278305),('1354',0.00998422),('naa600a098044307259313f334556393446',0.0163904),('1416',0.0118992),('1410',0.0107239),('598855',0.30103),('naa600a098044307259313f334556393445',0.0163904),('naa600a098044307259313f334556393372',0.0163904),('naa600a098044307535732b33457152752d',0.0163904),('naa600a098044307259313f334556393442',0.00827253),('naa6000c2979d4a269d6872562552952c80',0.0163904),('naa600a098044307259313f334556393441',0.00827253),('hgw2k8r2e2e10',0.00796893),('1454',0.0413927),('naa600a098044307535732b33457153364f',0.0163904),('naa600a098044307259313f334556393378',0.0163904),('hgwin2k814760',0.00811789),('naa6000c29db0b2f97bc7852ba854bc5a0f',0.0163904),('1567',0.0413927),('naa600a098044307535732b33457153364e',0.0163904),('naa600a098044307535732b33457153364d',0.0163904),('naa6000c296c4b84cf9c023f5bd4f7ed00f',0.0163904),('linux1',0.00827253),('naa600a098044307535732b33457153364c',0.0163904),('naa6000c29a87723ee338351beefff3a76a',0.0163904),('1686',0.0211893),('naa600a098044307535732b33457153356f',0.0163904),('hgw2k8r2ms1',0.00796893),('naa6000c29be9c8af40d3e0d5938c1f980e',0.0163904),('naa600a098044307535732b33457153364b',0.0163904),('hgw2k8r2cs3',0.0163904),('naa600a098044307535732b33457153356e',0.0163904),('naa600a098044307535732b33457153364a',0.0163904),('naa600a098044307535732b33457153356d',0.0163904),('naa600a098044307535732b33457153356c',0.0163904),('naa600a098044307535732b33457153356b',0.0163904),('naa6000c29f674e59273634ef0b579e36b7',0.0163904),('naa600a098044307535732b33457153356a',0.0163904),('naa600a098044307535732b334571533649',0.0163904),('naa6000c29e2682f4db15114dd9441e9c15',0.0163904),('naa6000c29b807b80b72131045915c52ffc',0.0163904),('hgw2k8r2cs12',0.0163904),('naa600a098044307535732b334571533648',0.0163904),('971',0.0321847),('naa600a098044307535732b334571533647',0.0163904),('naa600a098044307535732b334571533569',0.0163904),('naa600a098044307535732b334571533646',0.0163904),('1513',0.0263289),('naa600a098044307535732b334571533568',0.0163904),('naa600a098044307535732b334571533645',0.0163904),('hgtemplate',0.00811789),('naa600a098044307535732b334571533567',0.0163904),('naa6000c2933e34e6114d05cd550d6203a2',0.0163904),('naa600a098044307535732b334571533644',0.0163904),('naa600a098044307259313f334556387252',0.0163904),('hgw2k8r232vm16',0.00811789),('naa600a098044307535732b334571533643',0.0163904),('naa6000c2997ed7efd8c63e88f76714c242',0.0163904),('naa600a098044307535732b334571533566',0.0163904),('naa600a098044307535732b334571533642',0.0163904),('naa600a098044307535732b334571533565',0.0163904),('1428',0.0170333),('naa6000c2960acd1e4028a94d476ecdc668',0.0163904),('naa600a098044307535732b334571533641',0.0163904),('naa600a098044307535732b334571533564',0.0163904),('naa600a098044307535732b334571533563',0.0163904),('naa600a098044307259313f334556393453',0.0163904),('naa6000c2965ca4cd7c53811704f77b5d65',0.0163904),('hgw2k8r232vm14',0.00827253),('naa600a098044307259313f334556393530',0.0163904),('naa600a098044307259313f334556393371',0.0163904),('naa600a098044307535732b334571527539',0.0163904),('1357',0.0321847),('naa6000c291ad1e480ea3b8d793ff8001cd',0.0163904),('naa600a098044307535732b334571533562',0.0163904),('naa600a098044307535732b334571533667',0.0163904),('naa600a098044307535732b334571533561',0.0163904),('naa600a098044307259313f33455639347a',0.0163904),('naa600a0980b87a29ef1afd4b117b00aba2',0.0163904),('naa600a098044307259313f334556393479',0.0163904),('naa600a098044307259313f334556393478',0.0163904),('1376',0.0299632),('naa600a098044307259313f334556393477',0.0163904),('naa600a098044307259313f334556393434',0.0163904),('1341',0.0109954),('naa600a098044307259313f334556393433',0.0163904),('naa600a098044307259313f334556393432',0.0163904),('naa6000c293253c456ea75b96f934730b77',0.0163904),('naa600a098044307259313f334556393431',0.0163904),('naa600a098044307535732b33457153366d',0.0163904),('naa600a098044307535732b334571533661',0.0163904),('naa600a098044307259313f334556393379',0.0163904),('naa600a098044307259313f334556393375',0.0163904),('naa600a098044307535732b33457153366c',0.0163904),('naa600a098044307259313f334556393451',0.0163904),('naa600a098044307259313f334556393456',0.0163904),('naa600a098044307259313f334556393454',0.0163904),('naa600a098044307535732b33457153366b',0.0163904),('naa600a098044307259313f33455639345a',0.0163904),('naa600a098044307535732b33457153366a',0.0163904),('naa600a098044307259313f334556393532',0.0163904),('naa6000c29b9d27250346d3e0286ee28a49',0.0163904),('naa600a098044307259313f334556393374',0.0163904),('naa600a098044307535732b33457153362f',0.0163904),('naa600a098044307535732b33457153357a',0.00827253),('naa600a098044307259313f334556393370',0.0163904),('1371042306',0.0163904),('naa600a098044307535732b334571533664',0.0163904),('naa600a098044307535732b33457153362d',0.0163904),('naa600a098044307535732b334571527536',0.0163904),('naa600a098044307259313f334556387250',0.0163904),('1371042246',0.0163904),('naa600a098044307259313f334556393458',0.0163904),('naa600a098044307535732b334571527549',0.0163904),('naa600a098044307259313f334556393534',0.0163904),('naa600a098044307535732b334571533663',0.0163904),('naa600a098044307259313f334556393377',0.0163904),('naa600a098044307259313f334556393376',0.0163904),('naa600a098044307535732b334571527548',0.0163904),('naa600a098044307259313f334556393455',0.0163904),('naa6000c295e3f8a5d4112eea72713dafc7',0.0163904),('naa600a098044307259313f33455639337a',0.0163904),('naa600a098044307259313f334556393533',0.0163904),('1468',0.0347621),('naa600a098044307535732b334571527547',0.0163904),('naa600a098044307259313f334556393531',0.0163904),('naa600a098044307259313f334556393452',0.0163904),('naa600a098044307535732b33457153365a',0.0163904),('naa600a098044307535732b334571527546',0.0163904),('naa6000c29859fd519d867292b2a206e338',0.0163904),('naa600a098044307535732b334571533665',0.0163904),('naa600a098044307535732b334571527545',0.0163904),('naa600a0980629929ef780f45117b02aba2',0.0163904),('naa600a098044307259313f334556387251',0.0163904),('naa600a0980659529efd63544117b01aba2',0.0163904),('naa600a098044307259313f334556393457',0.0163904),('naa600a098044307535732b334571527544',0.0163904),('naa6000c29a85ce165a8d96caf467e2b8c2',0.0163904),('naa6000c29843495e04fb98bb2a0dc2332c',0.0163904),('naa600a098044307535732b334571533666',0.0163904),('naa600a098044307535732b334571533662',0.0163904),('naa600a098044307535732b334571527543',0.0163904),('1371042486',0.0163904),('naa600a098044307535732b334571527538',0.0163904),('naa600a098044307535732b334571527537',0.0163904),('naa600a098044307535732b334571533668',0.0163904),('hemanthamainn1305290334',0.00827253),('naa600a098044307535732b334571527542',0.0163904),('hgvma01',0.00796893),('1419',0.0177288),('naa600a098044307535732b334571527541',0.0163904),('hgw2k8r2e2e11',0.00811789),('naa600a098044307259313f334556393450',0.0163904),('naa600a098044307535732b334571533669',0.0163904),('naa6000c299cded2c9adf690ae5be386c24',0.0163904),('naa6000c29ef7c743ec1f1ae77fc08b4c8a',0.0163904),('naa6000c29891c7bfbf1d5b509415e5e8e9',0.0163904),('naa6000c296efb831d18740de67a8212ba3',0.0163904),('1760',0.00050353),('naa6000c29a9b11305673146d99b450723c',0.0163904),('naa6000c2930690849f0f027e2bdea15971',0.0163904),('naa6000c29929cb6278386c2319ec3c3b6e',0.0163904),('naa6000c2941f98a8f551379b37f7715f14',0.0163904),('naa6000c29932d18cc52aa4303fbb5eb3c8',0.0163904),('1371042424',0.000278305),('naa6000c298d5ef350777b9f2be8ba3ef94',0.0163904),('naa6000c29ba4507964dff0ad72b70afbbe',0.0163904),('588',0.00231624),('1436',0.0457575),('naa6000c294d1df893cff4138d2e478e299',0.0163904),('hgw2k8r232vm12',0.00811789),('naa6000c298a30b94717e0a7b89a2473c29',0.0163904),('1506',0.0202034),('naa6000c29f57cc968bfbb545dbf20a1886',0.0163904),('naa6000c29047896a98adc870dfbebaeac2',0.0163904),('naa6000c2929533fd5be20eb5cc847a13ed',0.0163904),('naa6000c2932722fba5532a5b3cde7c0c63',0.0163904),('naa6000c2964274185ba96cd4dbf8ef50eb',0.0163904),('naa6000c2960b02c3a9e54eda5f394a838a',0.0163904),('naa6000c29a50c74f6a4499cc613e475ef4',0.0163904),('naa6000c29dd4369787c560bd4beacce114',0.0163904),('hgw2k8r232vm11',0.00811789),('naa6000c29c21bb973e92f998bea193dd18',0.0163904),('hgw2k8r2cs10',0.00811789),('fmcbp',0.00827253),('naa6000c2925e6758884ac57c7ae894ee86',0.0163904),('naa6000c29509fa9ac43eb732b1b2d9a0f4',0.0163904),('1592',0.0347621),('naa6000c29b6e7404ddd6b61e58e787d9d9',0.0163904),('naa6000c292dc5b74eeed4bd44591340e16',0.0163904),('1274',0.09691),('naa6000c291dd7f6a5d9401fc71d54adbb6',0.0163904),('hgw2k8r2cs7',0.0163904),('naa6000c2973fc357862a1d1f9aad0ee35d',0.0163904),('1371042363',0.000278305),('naa6000c29b4543f3d3e3ecbea6126ce7a5',0.0163904),('naa6000c29a137ba86b53498f0230152ba2',0.0163904),('naa6000c2962f4f2ea11e8380e978daf567',0.0163904),('naa6000c29e353d1df472e29083d0de0077',0.0163904),('naa6000c29ca95433a3c26ac5006f2c6bbf',0.0163904),('naa6000c29083952def68e3e9ffd16517b9',0.0163904),('naa6000c29c50c16277f5b82ee57335fc8a',0.0163904),('naa6000c29e54336b52aa766cc061802e54',0.0163904),('naa6000c29d7c364b06ded47c1f570bc2e3',0.0163904),('naa6000c29f3ebb0d585f0ed9422d664057',0.0163904),('naa6000c294223f07cf9331c3fa76649fc0',0.0163904),('naa6000c299fb242f20bd0dcbf875123360',0.0163904),('hgw2k8r2cs11',0.0163904),('naa6000c29fe3390e795d8c591136084897',0.0163904),('naa6000c293b01b8a3782aed28fa505d311',0.0163904),('naa6000c29625d808ede952e2c058cf1a34',0.0163904),('naa6000c29548b21a50f8567f2f98d65703',0.0163904),('naa6000c29e200b558b2cc9c39ced49529c',0.0163904),('naa6000c294c5800706fe07fe7bdec0b542',0.0163904),('naa6000c294b2c528ee471899a0c8328b4b',0.0163904),('naa6000c2917d55d870400ecc0701aece3c',0.0163904),('naa6000c29efdea6383c636eb6f5293bb18',0.0163904),('hgw2k8r2e2e8',0.00796893),('hgw2k8r2e2e12',0.00811789),('naa6000c2900ba30f9c04761e67e7ba6cce',0.0163904),('naa6000c29fe77494a31a50f7fb700fd794',0.0163904),('naa6000c29d46de48951fc586e98226d5ec',0.0163904),('naa6000c29459e8c5d431d18870e9eba06f',0.0163904),('naa6000c296600c8dae9d742ee0c1bdc4e9',0.0163904),('naa6000c29e279da2c2ed11b70ea5d8c56a',0.0163904),('naa6000c296145978d116a1dadb39cae949',0.0163904),('hgw2k8r232vm13',0.00827253),('naa6000c293d496c4a7d9a1f8af3d22ef12',0.0163904),('naa6000c297cdc780e3c13ee563f29dc515',0.0163904),('naa6000c292c148a7d33c2540a9767aa824',0.0163904),('1396',0.124939),('naa6000c2942d742dac850584b052554ee1',0.0163904),('naa6000c29957b3d5f525e35e73b0141a8e',0.0163904),('naa6000c294dbda2a3d6a7892f1734c71fe',0.0163904),('naa6000c29768334a860ab2d408c832c177',0.0163904),('naa6000c29c2a035dec0cb7cf218419267b',0.0163904),('naa6000c294b160ff10b82c3b3164532f5c',0.0163904),('naa6000c294f1ceeefa4a2beff5f55584fc',0.0163904),('naa6000c29e335014bb174151c6fef61968',0.0163904),('naa6000c29dd01ef3192bf1ffa13e5c71a2',0.0163904),('naa6000c2959aa2b054351c424d30964b08',0.0163904),('naa6000c29d1b17437c7a0141d38fca7c0e',0.0163904),('naa6000c2901a38e7528335db9a8d1b55a9',0.0163904),('1371042484',0.000278305),('naa6000c2935ddc92f10433d19f2bb80a9b',0.0163904),('naa6000c29d3d23a134327ee8536278c134',0.0163904),('naa6000c292e02e62a7ea5fcc7e2ac6dac2',0.0163904),('naa6000c2938d61e772e92d242e8f616bc8',0.0163904),('naa6000c29879c542625d4b6088cdc6db0d',0.0163904),('naa6000c29ffdbb148155d03e2476161cb4',0.0163904),('naa6000c29cb55e1f2d29a6efd5f2d46898',0.0163904),('naa6000c293a79653f23adacab302a35b4c',0.0163904),('naa6000c298ccbcb8562196baab2010f8ff',0.0163904),('naa6000c298c48515e76cb4276acf0d25ab',0.0163904),('naa6000c29fe6b177596c1c4b553ca45a3f',0.0163904),('naa6000c299a4eb2d1abcfd916114b897a2',0.0163904),('naa6000c293a34e4ff971e1b11d447e4a42',0.0163904),('naa6000c297b719579011fa5a723f8e0066',0.0163904),('naa6000c29c258d048db92532600399cc4f',0.0163904),('naa6000c29b66d5ffd22d0dd7c09b517e52',0.0163904),('naa6000c2916a269a0abd1525c1524ce67c',0.0163904),('naa6000c29d497984f4722f3ac9dd476b19',0.0163904),('naa6000c291d75a3708a841e1ee07a014f1',0.0163904),('naa6000c29e0464e562dccd37ac96b0e1dd',0.0163904),('naa6000c29f6fd3eb9866c057835e2bc58a',0.0163904),('naa6000c29293df626e239bea90f331fbff',0.0163904),('1351',0.0248236),('hgw2k8r2e2e9nrn',0.00827253),('naa6000c2931b0ffc674dcc8e3598171dad',0.0163904),('fmcpreston1',0.00811789),('hgw2k8r2dvmtn',0.00811789),('fasanity02w2k8r2',0.00811789),('1474',0.0377886),('hgw2k8r2e2e62',0.0163904),('fmczalonibarium',0.00796893),('1469',0.0321847),('hgw2k8r2e2e7',0.00796893),('nataliemysqlvm',0.00811789),('hgnatk1w2k8r2',0.00811789),('hgw2k8r2cs6',0.0163904),('hgw2k8r2e2e6',0.00796893),('1483',0.0299632),('hemantha',0.00811789),('hgw2k8r2cs4',0.0163904),('1342',0.0280287),('naa6000c29e6c8266f8ff0e9ddc2367c593',0.0163904),('hgvcenterperf',0.00827253),('hgvcenter511',0.00811789),('hgw2k8r2cs8',0.0163904),('fmczaloni',0.00796893),('hgmh3w2k8r2',0.00796893),('hqqandisp',0.00811789),('1366',0.0457575),('hgw2k8r2e2e4',0.00796893),('fmcdebianbld1',0.00796893),('hgmh1w2k8r2',0.00796893),('fmcangela',0.00796893),('naa6000c2939eabe43ec0406da8cf74e5fd',0.0163904),('hgw2k8r2e2e1',0.00796893),('hgfmcvcenter01',0.00811789),('hgw2k8r2bp5',0.00811789),('hgw2k8r2nfs4',0.0163904),('hgw2k8r2cs1',0.0163904),('hgrhel5dns',0.00782534),('hgw2k8r2cs13',0.0163904),('hgvcenter512',0.00811789),('hgvcenter01',0.00811789),('fmcdns32',0.00811789),('598854',0.30103),('naa6000c2978055874f2dceb272e9b89104',0.0163904),('1432',0.09691),('hgw2k8r2bp3',0.00811789),('hgw2k8r22',0.00811789),('hgw2k8r2e2e63',0.0163904),('hgw2k8r2mgmt',0.00811789),('fmcmauricio',0.00811789),('1371042183',0.000278305),('1371042182',0.00827253),('1371042126',0.0163904),('bpmgmtvm',0.00811789),('hgmh2w2k8r2',0.00796893),('fmcchris',0.00811789),('hgw2k8r2template',0.00827253),('favesxi5001sanity',0.00811789),('naa6000c2967523a755b6fc0df302814030',0.00811789),('fmcpreston',0.0163904),('hgsf1w2k8r2',0.00811789),('hgw2k8r25',0.00811789),('chrismgmtvm',0.00811789),('naa6000c29fc92dc78e108403dfc0dc5004',0.0163904),('hgw2k8r2cs5',0.0163904),('hgw2k8r2e2e2',0.00827253),('1371042243',0.000278305),('1371042242',0.00827253),('1371042186',0.0163904),('1404',0.0193052),('1371042302',0.00827253),('1740',0.000478561),('1647',0.0413927),('57',0.000540503),('1371596462',0.00166716),('1371596342',0.00166716),('1371595981',0.0163904),('1371595922',0.00166716),('1371595861',0.0163904),('1371595802',0.0163904),('1371595742',0.00166716),('1371595681',0.0163904),('1371595621',0.0163904),('1371595622',0.001852),('1601',0.0413927),('1600',0.0125891),('1559',0.0280287),('1558',0.0163904),('1557',0.0263289),('1556',0.0248236),('1555',0.0669468),('1554',0.0280287),('1545',0.0163904),('1546',0.0347621),('1547',0.0579919),('1548',0.0299632),('1549',0.0234811),('1550',0.0177288),('1551',0.0263289),('1552',0.0170333),('1553',0.0377886),('1542',0.0299632),('1543',0.0248236),('1544',0.0142404),('1541',0.0511525),('1539',0.0248236),('1540',0.0177288),('1411',0.0263289),('1499',0.0791812),('1536',0.0170333),('1537',0.0193052),('1538',0.00653087),('1535',0.0263289),('1531',0.0347621),('1532',0.0222764),('1533',0.0211893),('1534',0.0321847),('1529',0.0177288),('1528',0.0202034),('1527',0.0321847),('1329',0.0280287),('1328',0.00445434),('1326',0.0457575),('1325',0.0234811),('1324',0.0234811),('1323',0.09691),('1322',0.0248236),('1371042366',0.0163904),('1371042422',0.00827253),('1361',0.0579919),('1346',0.0222764),('1457',0.0511525),('1318',0.0211893),('1371042482',0.00827253),('1371042426',0.0163904),('1495',0.0299632),('1358',0.0511525),('1368',0.0457575),('1313',0.0511525),('1309',0.0669468),('1371575222',0.0163904),('1371575162',0.0163904),('1304',0.176091),('1371575101',0.0163904),('1303',0.0248236),('1371575041',0.0163904),('1302',0.176091),('1371574981',0.0163904),('1301',0.0263289),('1371574921',0.0163904),('1371574862',0.0163904),('1371574801',0.0163904),('1371574681',0.0163904),('1371574741',0.0163904),('1371574621',0.0163904),('1276',0.0457575),('1371574562',0.0163904),('1249',0.124939),('1501',0.0299632),('1371042542',0.00827253),('1355',0.0107239),('1350',0.00673338),('1337',0.124939),('1338',0.0579919),('1246',0.0669468),('1374',0.0457575),('291',0.0102192),('1241',0.0791812),('1227',0.176091),('1210',0.00729924),('1371630666',0.00151586),('942',0.00914338),('1371559285',0.00208295),('fmcbariumtest',0.0163904),('w3j',0.30103),('4jd6iwnjnv2hwccrmg',0.30103),('nrfgbzniq67sfr4arsbb',0.30103),('hgvcenter01gdlenglabnetappcom',0.30103),('1371223332',0.00553249),('1371223382',0.00553249),('1371629946',0.00151586),('1371629941',0.0163904),('1371629836',0.00277505),('1371629785',0.00415596),('1371629885',0.001852),('1371629411',0.00827253),('1371629412',0.00166716),('1371629166',0.00208295),('1371220682',0.00553249),('1663',0.09691),('1637',0.00590886),('1642',0.0299632),('6667',0.0579919),('1657',0.0791812),('1612',0.0299632),('1702',0.0791812),('1589',0.0248236),('1523',0.0347621),('1624',0.124939),('1672',0.09691),('1632',0.176091),('1441',0.0377886),('1496',0.0377886),('1723',0.0669468),('1628',0.0299632),('1681',0.0669468),('1728',0.176091),('1665',0.0579919),('1714',0.0791812),('1565',0.0299632),('1486',0.0211893),('1633',0.0280287),('1737',0.00954532),('1718',0.176091),('1692',0.0791812),('1752',0.0377886),('1832',0.012965),('1708',0.124939),('1756',0.0579919),('1782',0.0669468),('1371628742',0.0163904),('1371629351',0.00827253),('1798',0.0193052),('1371628945',0.00151586),('1727',0.30103),('1724',0.124939),('1371628749',0.001283),('1267',0.09691),('1380',0.0122345),('1377',0.0413927),('1564',0.0263289),('1385',0.0413927),('1753',0.00860017),('1415',0.124939),('1418',0.0669468),('1391',0.0579919),('1497',0.0413927),('1504',0.0193052),('1505',0.01524),('1413',0.0211893),('1525',0.0457575),('1463',0.0377886),('1371629341',0.0163904),('1371596581',0.0163904),('1793',0.0299632),('1371629878',0.00827253),('1371628865',0.001852),('1371628802',0.0163904),('1371628922',0.0163904),('1371629114',0.001852),('1371628982',0.0163904),('1371629165',0.001852),('1371629161',0.0163904),('1371629226',0.00151586),('1371629222',0.0163904),('1371629286',0.001852),('1371629282',0.0163904),('1371629350',0.00166716),('1371629402',0.0163904),('1371629396',0.00827253),('1371629462',0.0163904),('1371629469',0.001283),('1371629526',0.001852),('1371629648',0.001852),('1371629582',0.0163904),('1371629719',0.00166716),('1371629702',0.0163904),('1371629786',0.00827253),('1371629784',0.00277505),('1371629761',0.0163904),('1371629835',0.00277505),('1371629821',0.0163904),('1371629881',0.0163904),('1371629838',0.00827253),('1371630006',0.001283),('1371630066',0.001852),('1371630126',0.001852),('1371630186',0.001852),('1371630245',0.001852),('1371630306',0.00151586),('1371630366',0.001852),('1371630428',0.001852),('1371630489',0.00111215),('1371630555',0.00151586),('1371630607',0.00111215),('1371630725',0.001852),('1371630785',0.001852),('1371630845',0.00827253),('1806',0.0791812),('1340',0.00782534),('1297',0.0457575),('1161',0.0791812),('1417',0.09691),('1389',0.0347621),('1459',0.0413927),('1371559276',0.00028302),('1371559286',0.00208295),('1371559293',0.00553249),('1371559300',0.0163904),('1371559307',0.0163904),('1371559314',0.0163904),('1371559323',0.00087825),('1397',0.124939),('1275',0.0413927),('1296',0.0299632),('1363',0.0791812),('1383',0.0457575),('1371629522',0.0163904),('1371567310',0.00827253),('1371567364',0.00028302),('1371567367',0.00208295),('1371567368',0.001852),('1371567369',0.00166716),('1371567370',0.00827253),('1371567424',0.00028302),('1371567427',0.00208295),('1371567428',0.00208295),('1371567429',0.00277505),('1371567430',0.0163904),('1371567483',0.00028302),('1371567487',0.00208295),('1371567488',0.001852),('1371567489',0.00332794),('1371567490',0.0163904),('1371567543',0.00028302),('1371567547',0.00208295),('1371567548',0.00208295),('1371567549',0.00277505),('1371567550',0.0163904),('1371567604',0.000278305),('1371567607',0.001852),('1371567608',0.001852),('1371567609',0.00166716),('1371567610',0.00827253),('1371567664',0.000278305),('1371567667',0.001852),('1371567668',0.001852),('1371567669',0.00166716),('1371567670',0.00827253),('1371567723',0.00028302),('1371567727',0.001852),('1371567728',0.00151586),('1371567729',0.00166716),('1371567783',0.00028302),('1371567786',0.00208295),('1371567787',0.00208295),('1371567788',0.00208295),('1371567789',0.00415596),('1371567844',0.000388283),('1280',0.00782534),('1277',0.0511525),('1371574564',0.000278305),('1371574567',0.001852),('1371574568',0.001852),('1371574569',0.00332794),('1371574623',0.000278305),('1371574627',0.001852),('1371574628',0.00111215),('1371574629',0.00277505),('1371574683',0.000278305),('1371574687',0.001852),('1371574688',0.00151586),('1371574689',0.00208295),('1371574690',0.00827253),('1371574743',0.000278305),('1371574747',0.001852),('1371574748',0.00111215),('1371574749',0.00277505),('1371574803',0.000278305),('1371574807',0.001852),('1371574808',0.00151586),('1371574809',0.00166716),('1371574864',0.000278305),('1371574867',0.001852),('1371574869',0.00111215),('1371574870',0.00277505),('1371574923',0.000278305),('1371574927',0.001852),('1371574928',0.001852),('1371574929',0.00166716),('1371574930',0.00827253),('1371574983',0.000538493),('1371574987',0.0163904),('1371574988',0.0163904),('1371574989',0.00553249),('1371574990',0.00827253),('1371575044',0.0163904),('1371575047',0.0163904),('1371575048',0.0163904),('1371575049',0.00827253),('1371575050',0.00553249),('1371575104',0.0163904),('1371575107',0.0163904),('1371575109',0.00827253),('1371575110',0.00415596),('1371575164',0.0163904),('1371575168',0.0163904),('1371575169',0.00553249),('1371575170',0.00553249),('1371575223',0.0163904),('1371575227',0.0163904),('1371575228',0.0163904),('1371595262',0.0163904),('1371595263',0.001852),('1371595264',0.00111215),('1371595265',0.00827253),('1371595322',0.0163904),('1371595323',0.001852),('1371595324',0.00151586),('1371595325',0.00166716),('1371595382',0.0163904),('1371595383',0.001852),('1371595384',0.00151586),('1371595385',0.00166716),('1371595442',0.0163904),('1371595443',0.001852),('1371595444',0.001852),('1371595445',0.00208295),('1371595446',0.00415596),('1371595501',0.0163904),('1371595502',0.001852),('1371595503',0.001852),('1371595504',0.00208295),('1371595505',0.00415596),('1371595562',0.0163904),('1371595563',0.001852),('1371595564',0.00151586),('1371595565',0.00166716),('1371595623',0.001852),('1371595624',0.00208295),('1371595625',0.00415596),('1371595682',0.001852),('1371595683',0.001852),('1371595684',0.00208295),('1371595685',0.00415596),('1371595743',0.001852),('1371595744',0.00277505),('1371595745',0.00277505),('1371595803',0.001852),('1371595804',0.00151586),('1371595805',0.00166716),('1371595862',0.001852),('1371595863',0.001852),('1371595864',0.00166716),('1371595865',0.00827253),('1371595923',0.001852),('1371595924',0.00827253),('1371595925',0.00166716),('1371595982',0.001852),('1371595983',0.001852),('1371595984',0.00166716),('1371596522',0.0163904),('1371595985',0.00827253),('1371596042',0.001852),('1371596044',0.00111215),('1371596045',0.00277505),('1371596103',0.001852),('1371596104',0.001852),('1371596105',0.00166716),('1371596106',0.00827253),('1371596162',0.001852),('1371596163',0.001852),('1371596164',0.00208295),('1371596165',0.00415596),('1371596223',0.001852),('1371596224',0.00151586),('1371596225',0.00166716),('1371596282',0.001852),('1371596283',0.001852),('1371596284',0.00166716),('1371596285',0.00827253),('1371596344',0.00111215),('1371596345',0.00277505),('1371596403',0.001852),('1371596404',0.001852),('1371596405',0.00166716),('1371596406',0.00827253),('1371596463',0.001852),('1371596464',0.00208295),('1371596465',0.00415596),('1371596523',0.001852),('1371596524',0.001852),('1371596525',0.00166716),('1371596526',0.00827253),('1371596582',0.001852),('1371596583',0.001852),('1371596584',0.00277505),('1371596585',0.00277505),('1371596643',0.001852),('1371596644',0.001852),('1371596645',0.00277505),('1371596646',0.00277505),('1371596703',0.001852),('1371596704',0.001852),('1371596705',0.00166716),('1371596706',0.00827253),('1371596762',0.001852),('1371596763',0.001852),('1371596764',0.00166716),('1371596765',0.00827253),('1371596823',0.001852),('1371596824',0.001852),('1371596825',0.00166716),('1371596826',0.00827253),('1371596882',0.001852),('1371596883',0.00151586),('1371596884',0.00166716),('1371596943',0.001852),('1371596944',0.001852),('1371596945',0.00208295),('1371596946',0.00415596),('1371597002',0.001852),('1371597003',0.001852),('1371597004',0.00166716),('1371596761',0.0163904),('1371597005',0.00827253),('1371597063',0.001852),('1371597064',0.0023797),('1371596041',0.0163904),('1371596161',0.0163904),('1371596222',0.0163904),('1371596402',0.0163904),('1371596281',0.0163904),('1371596702',0.0163904),('1371596642',0.0163904),('1371596102',0.0163904),('1371628866',0.00208295),('1371628867',0.00415596),('1371628946',0.00166716),('1371629115',0.00208295),('1371629116',0.00415596),('1371629167',0.00415596),('1371629227',0.00166716),('1371629287',0.00166716),('1371629288',0.00827253),('1371629470',0.00277505),('1371629527',0.00166716),('1371629649',0.00277505),('1371629650',0.00277505),('1371629886',0.00208295),('1371629887',0.00415596),('1371629947',0.0023797),('1371630007',0.00277505),('1371630067',0.00166716),('1371630127',0.00208295),('1371630128',0.00415596),('1371630187',0.00166716),('1371630188',0.00827253),('1371630246',0.00277505),('1371630247',0.00277505),('1371630307',0.00166716),('1371630367',0.00166716),('1371630368',0.00827253),('1371630429',0.00277505),('1371630430',0.00277505),('1371630490',0.00277505),('1371630556',0.00166716),('1371630608',0.00277505),('1371630667',0.00166716),('1371630726',0.00208295),('1371630727',0.00415596),('1371630786',0.00208295),('1371630787',0.00415596);
/*!40000 ALTER TABLE `search_total` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `semaphore`
--

DROP TABLE IF EXISTS `semaphore`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `semaphore` (
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique name.',
  `value` varchar(255) NOT NULL DEFAULT '' COMMENT 'A value for the semaphore.',
  `expire` double NOT NULL COMMENT 'A Unix timestamp with microseconds indicating when the semaphore should expire.',
  PRIMARY KEY (`name`),
  KEY `value` (`value`),
  KEY `expire` (`expire`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Table for holding semaphores, locks, flags, etc. that...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `semaphore`
--

LOCK TABLES `semaphore` WRITE;
/*!40000 ALTER TABLE `semaphore` DISABLE KEYS */;
/*!40000 ALTER TABLE `semaphore` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequences`
--

DROP TABLE IF EXISTS `sequences`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sequences` (
  `value` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The value of the sequence.',
  PRIMARY KEY (`value`)
) ENGINE=MyISAM AUTO_INCREMENT=34 DEFAULT CHARSET=utf8 COMMENT='Stores IDs.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequences`
--

LOCK TABLES `sequences` WRITE;
/*!40000 ALTER TABLE `sequences` DISABLE KEYS */;
INSERT INTO `sequences` VALUES (33);
/*!40000 ALTER TABLE `sequences` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sessions`
--

DROP TABLE IF EXISTS `sessions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sessions` (
  `uid` int(10) unsigned NOT NULL COMMENT 'The users.uid corresponding to a session, or 0 for anonymous user.',
  `sid` varchar(128) NOT NULL COMMENT 'A session ID. The value is generated by Drupal’s session handlers.',
  `ssid` varchar(128) NOT NULL DEFAULT '' COMMENT 'Secure session ID. The value is generated by Drupal’s session handlers.',
  `hostname` varchar(128) NOT NULL DEFAULT '' COMMENT 'The IP address that last used this session ID (sid).',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when this session last requested a page. Old records are purged by PHP automatically.',
  `cache` int(11) NOT NULL DEFAULT '0' COMMENT 'The time of this user’s last post. This is used when the site has specified a minimum_cache_lifetime. See cache_get().',
  `session` longblob COMMENT 'The serialized contents of $_SESSION, an array of name/value pairs that persists across page requests by this session ID. Drupal loads $_SESSION from here at the start of each request and saves it at the end.',
  PRIMARY KEY (`sid`,`ssid`),
  KEY `timestamp` (`timestamp`),
  KEY `uid` (`uid`),
  KEY `ssid` (`ssid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Drupal’s session handlers read and write into the...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sessions`
--

LOCK TABLES `sessions` WRITE;
/*!40000 ALTER TABLE `sessions` DISABLE KEYS */;
INSERT INTO `sessions` VALUES (1,'nOfmJkIRccU5QVbutmA5RTX8GJMkLJuaPHrO9PRH-1Q','','10.63.230.90',1371647110,0,'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'),(1,'5pYLL8mkRNiIqNkxJfrKEPQA6Jel5pYSgS7v4iTebQs','','10.63.230.117',1371656328,0,'y9zISql8euhD_2WP_5efzLK4E_q23zVdW_Q6QsFsGoBottkPTyaf0s4OK5ofUMQlikJZh1AbSAVW9R-TIGow7g-DDyHaxaptxDUJct4qMzM.'),(1,'CyIbwNcCsxppgds1yrCrgzyDqZYAtnuHmBds-V9Nt3A','','10.63.230.203',1371647818,0,'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..'),(1,'0_qz1TLd3CNzpz7B_nrGgHGgm145MGFhxzRvkT-E8O0','','10.63.224.170',1371645380,0,''),(1,'XESgLFhwkQxraK9XHrHZf5LIQe2GvQ0DXmRodv1gkNY','','10.63.228.168',1371560228,0,''),(1,'xSdtTmHq0B88ueEyHKoFIxltEQ3gnzqRzRL9ZJ3wJgM','','10.63.228.56',1371645785,0,''),(9,'AXYUdJDfPrNuCUJrCXF9W1zWGJoddISL2g5BOWN0vlk','','10.62.18.214',1371586202,0,'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');
/*!40000 ALTER TABLE `sessions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shortcut_set`
--

DROP TABLE IF EXISTS `shortcut_set`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shortcut_set` (
  `set_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'Primary Key: The menu_links.menu_name under which the set’s links are stored.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title of the set.',
  PRIMARY KEY (`set_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores information about sets of shortcuts links.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shortcut_set`
--

LOCK TABLES `shortcut_set` WRITE;
/*!40000 ALTER TABLE `shortcut_set` DISABLE KEYS */;
INSERT INTO `shortcut_set` VALUES ('shortcut-set-1','Default');
/*!40000 ALTER TABLE `shortcut_set` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shortcut_set_users`
--

DROP TABLE IF EXISTS `shortcut_set_users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shortcut_set_users` (
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The users.uid for this set.',
  `set_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The shortcut_set.set_name that will be displayed for this user.',
  PRIMARY KEY (`uid`),
  KEY `set_name` (`set_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Maps users to shortcut sets.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shortcut_set_users`
--

LOCK TABLES `shortcut_set_users` WRITE;
/*!40000 ALTER TABLE `shortcut_set_users` DISABLE KEYS */;
/*!40000 ALTER TABLE `shortcut_set_users` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `system`
--

DROP TABLE IF EXISTS `system`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `system` (
  `filename` varchar(255) NOT NULL DEFAULT '' COMMENT 'The path of the primary file for this item, relative to the Drupal root; e.g. modules/node/node.module.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the item; e.g. node.',
  `type` varchar(12) NOT NULL DEFAULT '' COMMENT 'The type of the item, either module, theme, or theme_engine.',
  `owner` varchar(255) NOT NULL DEFAULT '' COMMENT 'A theme’s ’parent’ . Can be either a theme or an engine.',
  `status` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether or not this item is enabled.',
  `bootstrap` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether this module is loaded during Drupal’s early bootstrapping phase (e.g. even before the page cache is consulted).',
  `schema_version` smallint(6) NOT NULL DEFAULT '-1' COMMENT 'The module’s database schema version number. -1 if the module is not installed (its tables do not exist); 0 or the largest N of the module’s hook_update_N() function that has either been run or existed when the module was first installed.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The order in which this module’s hooks should be invoked relative to other modules. Equal-weighted modules are ordered by name.',
  `info` blob COMMENT 'A serialized array containing information from the module’s .info file; keys can include name, description, package, version, core, dependencies, and php.',
  PRIMARY KEY (`filename`),
  KEY `system_list` (`status`,`bootstrap`,`type`,`weight`,`name`),
  KEY `type_name` (`type`,`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='A list of all modules, themes, and theme engines that are...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `system`
--

LOCK TABLES `system` WRITE;
/*!40000 ALTER TABLE `system` DISABLE KEYS */;
INSERT INTO `system` VALUES ('modules/aggregator/aggregator.module','aggregator','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Aggregator\";s:11:\"description\";s:57:\"Aggregates syndicated content (RSS, RDF, and Atom feeds).\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:15:\"aggregator.test\";}s:9:\"configure\";s:41:\"admin/config/services/aggregator/settings\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:14:\"aggregator.css\";s:33:\"modules/aggregator/aggregator.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/aggregator/tests/aggregator_test.module','aggregator_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:23:\"Aggregator module tests\";s:11:\"description\";s:46:\"Support module for aggregator related testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/block/block.module','block','module','',1,0,7008,-5,'a:12:{s:4:\"name\";s:5:\"Block\";s:11:\"description\";s:140:\"Controls the visual building blocks a page is constructed with. Blocks are boxes of content rendered into an area, or region, of a web page.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"block.test\";}s:9:\"configure\";s:21:\"admin/structure/block\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/block/tests/block_test.module','block_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:10:\"Block test\";s:11:\"description\";s:21:\"Provides test blocks.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/blog/blog.module','blog','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:4:\"Blog\";s:11:\"description\";s:25:\"Enables multi-user blogs.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"blog.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/book/book.module','book','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:4:\"Book\";s:11:\"description\";s:66:\"Allows users to create and organize related content in an outline.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"book.test\";}s:9:\"configure\";s:27:\"admin/content/book/settings\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"book.css\";s:21:\"modules/book/book.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/color/color.module','color','module','',1,0,7001,0,'a:11:{s:4:\"name\";s:5:\"Color\";s:11:\"description\";s:70:\"Allows administrators to change the color scheme of compatible themes.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"color.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/comment/comment.module','comment','module','',1,0,7009,0,'a:13:{s:4:\"name\";s:7:\"Comment\";s:11:\"description\";s:57:\"Allows users to comment on and discuss published content.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:4:\"text\";}s:5:\"files\";a:2:{i:0;s:14:\"comment.module\";i:1;s:12:\"comment.test\";}s:9:\"configure\";s:21:\"admin/content/comment\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:11:\"comment.css\";s:27:\"modules/comment/comment.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/contact/contact.module','contact','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:7:\"Contact\";s:11:\"description\";s:61:\"Enables the use of both personal and site-wide contact forms.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:12:\"contact.test\";}s:9:\"configure\";s:23:\"admin/structure/contact\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/contextual/contextual.module','contextual','module','',0,0,0,0,'a:11:{s:4:\"name\";s:16:\"Contextual links\";s:11:\"description\";s:75:\"Provides contextual links to perform actions related to elements on a page.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:15:\"contextual.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/dashboard/dashboard.module','dashboard','module','',1,0,0,0,'a:12:{s:4:\"name\";s:9:\"Dashboard\";s:11:\"description\";s:136:\"Provides a dashboard page in the administrative interface for organizing administrative tasks and tracking information within your site.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:5:\"files\";a:1:{i:0;s:14:\"dashboard.test\";}s:12:\"dependencies\";a:1:{i:0;s:5:\"block\";}s:9:\"configure\";s:25:\"admin/dashboard/customize\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/dblog/dblog.module','dblog','module','',1,1,7001,0,'a:11:{s:4:\"name\";s:16:\"Database logging\";s:11:\"description\";s:47:\"Logs and records system events to the database.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"dblog.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/field/field.module','field','module','',1,0,7002,0,'a:13:{s:4:\"name\";s:5:\"Field\";s:11:\"description\";s:57:\"Field API to add fields to entities like nodes and users.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:12:\"field.module\";i:1;s:16:\"field.attach.inc\";i:2;s:16:\"tests/field.test\";}s:12:\"dependencies\";a:1:{i:0;s:17:\"field_sql_storage\";}s:8:\"required\";b:1;s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:15:\"theme/field.css\";s:29:\"modules/field/theme/field.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/field/modules/field_sql_storage/field_sql_storage.module','field_sql_storage','module','',1,0,7002,0,'a:12:{s:4:\"name\";s:17:\"Field SQL storage\";s:11:\"description\";s:37:\"Stores field data in an SQL database.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:22:\"field_sql_storage.test\";}s:8:\"required\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/field/modules/list/list.module','list','module','',1,0,7002,0,'a:13:{s:4:\"name\";s:4:\"List\";s:11:\"description\";s:69:\"Defines list field types. Use with Options to create selection lists.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:5:\"field\";i:1;s:7:\"options\";}s:5:\"files\";a:1:{i:0;s:15:\"tests/list.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:73:\"Field type(s) in use - see <a href=\"/admin/reports/fields\">Field list</a>\";}'),('modules/field/modules/list/tests/list_test.module','list_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:9:\"List test\";s:11:\"description\";s:41:\"Support module for the List module tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/field/modules/number/number.module','number','module','',1,0,0,0,'a:13:{s:4:\"name\";s:6:\"Number\";s:11:\"description\";s:28:\"Defines numeric field types.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:11:\"number.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:73:\"Field type(s) in use - see <a href=\"/admin/reports/fields\">Field list</a>\";}'),('modules/field/modules/options/options.module','options','module','',1,0,0,0,'a:11:{s:4:\"name\";s:7:\"Options\";s:11:\"description\";s:82:\"Defines selection, check box and radio button widgets for text and numeric fields.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:12:\"options.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/field/modules/text/text.module','text','module','',1,0,7000,0,'a:13:{s:4:\"name\";s:4:\"Text\";s:11:\"description\";s:32:\"Defines simple text field types.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:9:\"text.test\";}s:8:\"required\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:11:\"explanation\";s:73:\"Field type(s) in use - see <a href=\"/admin/reports/fields\">Field list</a>\";}'),('modules/field/tests/field_test.module','field_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:14:\"Field API Test\";s:11:\"description\";s:39:\"Support module for the Field API tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:5:\"files\";a:1:{i:0;s:21:\"field_test.entity.inc\";}s:7:\"version\";s:4:\"7.16\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/field_ui/field_ui.module','field_ui','module','',1,0,0,0,'a:11:{s:4:\"name\";s:8:\"Field UI\";s:11:\"description\";s:33:\"User interface for the Field API.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:13:\"field_ui.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/file/file.module','file','module','',0,0,0,0,'a:11:{s:4:\"name\";s:4:\"File\";s:11:\"description\";s:26:\"Defines a file field type.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:15:\"tests/file.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/file/tests/file_module_test.module','file_module_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:9:\"File test\";s:11:\"description\";s:53:\"Provides hooks for testing File module functionality.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/filter/filter.module','filter','module','',1,0,7010,0,'a:13:{s:4:\"name\";s:6:\"Filter\";s:11:\"description\";s:43:\"Filters content in preparation for display.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"filter.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:28:\"admin/config/content/formats\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/forum/forum.module','forum','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:5:\"Forum\";s:11:\"description\";s:27:\"Provides discussion forums.\";s:12:\"dependencies\";a:2:{i:0;s:8:\"taxonomy\";i:1;s:7:\"comment\";}s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"forum.test\";}s:9:\"configure\";s:21:\"admin/structure/forum\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:9:\"forum.css\";s:23:\"modules/forum/forum.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/help/help.module','help','module','',1,0,0,0,'a:11:{s:4:\"name\";s:4:\"Help\";s:11:\"description\";s:35:\"Manages the display of online help.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"help.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/image/image.module','image','module','',0,0,7004,0,'a:12:{s:4:\"name\";s:5:\"Image\";s:11:\"description\";s:34:\"Provides image manipulation tools.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:4:\"file\";}s:5:\"files\";a:1:{i:0;s:10:\"image.test\";}s:9:\"configure\";s:31:\"admin/config/media/image-styles\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/image/tests/image_module_test.module','image_module_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:10:\"Image test\";s:11:\"description\";s:69:\"Provides hook implementations for testing Image module functionality.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:24:\"image_module_test.module\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/locale/locale.module','locale','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:6:\"Locale\";s:11:\"description\";s:119:\"Adds language handling functionality and enables the translation of the user interface to languages other than English.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"locale.test\";}s:9:\"configure\";s:30:\"admin/config/regional/language\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/locale/tests/locale_test.module','locale_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:11:\"Locale Test\";s:11:\"description\";s:42:\"Support module for the locale layer tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/menu/menu.module','menu','module','',1,0,7003,0,'a:12:{s:4:\"name\";s:4:\"Menu\";s:11:\"description\";s:60:\"Allows administrators to customize the site navigation menu.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"menu.test\";}s:9:\"configure\";s:20:\"admin/structure/menu\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/node/node.module','node','module','',1,0,7013,0,'a:14:{s:4:\"name\";s:4:\"Node\";s:11:\"description\";s:66:\"Allows content to be submitted to the site and displayed on pages.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:11:\"node.module\";i:1;s:9:\"node.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:21:\"admin/structure/types\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"node.css\";s:21:\"modules/node/node.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/node/tests/node_access_test.module','node_access_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:24:\"Node module access tests\";s:11:\"description\";s:43:\"Support module for node permission testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/node/tests/node_test.module','node_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:17:\"Node module tests\";s:11:\"description\";s:40:\"Support module for node related testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/node/tests/node_test_exception.module','node_test_exception','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:27:\"Node module exception tests\";s:11:\"description\";s:50:\"Support module for node related exception testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/openid/openid.module','openid','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:6:\"OpenID\";s:11:\"description\";s:48:\"Allows users to log into your site using OpenID.\";s:7:\"version\";s:4:\"7.16\";s:7:\"package\";s:4:\"Core\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"openid.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/openid/tests/openid_test.module','openid_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:21:\"OpenID dummy provider\";s:11:\"description\";s:33:\"OpenID provider used for testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"openid\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/overlay/overlay.module','overlay','module','',0,0,0,0,'a:11:{s:4:\"name\";s:7:\"Overlay\";s:11:\"description\";s:59:\"Displays the Drupal administration interface in an overlay.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/path/path.module','path','module','',1,0,0,0,'a:12:{s:4:\"name\";s:4:\"Path\";s:11:\"description\";s:28:\"Allows users to rename URLs.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"path.test\";}s:9:\"configure\";s:24:\"admin/config/search/path\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/php/php.module','php','module','',1,0,0,0,'a:11:{s:4:\"name\";s:10:\"PHP filter\";s:11:\"description\";s:50:\"Allows embedded PHP code/snippets to be evaluated.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:8:\"php.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/poll/poll.module','poll','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:4:\"Poll\";s:11:\"description\";s:95:\"Allows your site to capture votes on different topics in the form of multiple choice questions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"poll.test\";}s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"poll.css\";s:21:\"modules/poll/poll.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/profile/profile.module','profile','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:7:\"Profile\";s:11:\"description\";s:36:\"Supports configurable user profiles.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:12:\"profile.test\";}s:9:\"configure\";s:27:\"admin/config/people/profile\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/rdf/rdf.module','rdf','module','',1,0,0,0,'a:11:{s:4:\"name\";s:3:\"RDF\";s:11:\"description\";s:148:\"Enriches your content with metadata to let other applications (e.g. search engines, aggregators) better understand its relationships and attributes.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:8:\"rdf.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/rdf/tests/rdf_test.module','rdf_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:16:\"RDF module tests\";s:11:\"description\";s:38:\"Support module for RDF module testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/search/search.module','search','module','',1,0,7000,0,'a:13:{s:4:\"name\";s:6:\"Search\";s:11:\"description\";s:36:\"Enables site-wide keyword searching.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:19:\"search.extender.inc\";i:1;s:11:\"search.test\";}s:9:\"configure\";s:28:\"admin/config/search/settings\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"search.css\";s:25:\"modules/search/search.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/search/tests/search_embedded_form.module','search_embedded_form','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:20:\"Search embedded form\";s:11:\"description\";s:59:\"Support module for search module testing of embedded forms.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/search/tests/search_extra_type.module','search_extra_type','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:16:\"Test search type\";s:11:\"description\";s:41:\"Support module for search module testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/shortcut/shortcut.module','shortcut','module','',1,0,0,0,'a:12:{s:4:\"name\";s:8:\"Shortcut\";s:11:\"description\";s:60:\"Allows users to manage customizable lists of shortcut links.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:13:\"shortcut.test\";}s:9:\"configure\";s:36:\"admin/config/user-interface/shortcut\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/simpletest/simpletest.module','simpletest','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:7:\"Testing\";s:11:\"description\";s:53:\"Provides a framework for unit and functional testing.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:47:{i:0;s:15:\"simpletest.test\";i:1;s:24:\"drupal_web_test_case.php\";i:2;s:18:\"tests/actions.test\";i:3;s:15:\"tests/ajax.test\";i:4;s:16:\"tests/batch.test\";i:5;s:20:\"tests/bootstrap.test\";i:6;s:16:\"tests/cache.test\";i:7;s:17:\"tests/common.test\";i:8;s:24:\"tests/database_test.test\";i:9;s:32:\"tests/entity_crud_hook_test.test\";i:10;s:23:\"tests/entity_query.test\";i:11;s:16:\"tests/error.test\";i:12;s:15:\"tests/file.test\";i:13;s:23:\"tests/filetransfer.test\";i:14;s:15:\"tests/form.test\";i:15;s:16:\"tests/graph.test\";i:16;s:16:\"tests/image.test\";i:17;s:15:\"tests/lock.test\";i:18;s:15:\"tests/mail.test\";i:19;s:15:\"tests/menu.test\";i:20;s:17:\"tests/module.test\";i:21;s:16:\"tests/pager.test\";i:22;s:19:\"tests/password.test\";i:23;s:15:\"tests/path.test\";i:24;s:19:\"tests/registry.test\";i:25;s:17:\"tests/schema.test\";i:26;s:18:\"tests/session.test\";i:27;s:20:\"tests/tablesort.test\";i:28;s:16:\"tests/theme.test\";i:29;s:18:\"tests/unicode.test\";i:30;s:17:\"tests/update.test\";i:31;s:17:\"tests/xmlrpc.test\";i:32;s:26:\"tests/upgrade/upgrade.test\";i:33;s:34:\"tests/upgrade/upgrade.comment.test\";i:34;s:31:\"tests/upgrade/update.field.test\";i:35;s:33:\"tests/upgrade/upgrade.filter.test\";i:36;s:32:\"tests/upgrade/upgrade.forum.test\";i:37;s:33:\"tests/upgrade/upgrade.locale.test\";i:38;s:31:\"tests/upgrade/upgrade.menu.test\";i:39;s:31:\"tests/upgrade/upgrade.node.test\";i:40;s:35:\"tests/upgrade/upgrade.taxonomy.test\";i:41;s:34:\"tests/upgrade/upgrade.trigger.test\";i:42;s:39:\"tests/upgrade/upgrade.translatable.test\";i:43;s:33:\"tests/upgrade/update.trigger.test\";i:44;s:33:\"tests/upgrade/upgrade.upload.test\";i:45;s:30:\"tests/upgrade/update.user.test\";i:46;s:31:\"tests/upgrade/upgrade.user.test\";}s:9:\"configure\";s:41:\"admin/config/development/testing/settings\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/actions_loop_test.module','actions_loop_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:17:\"Actions loop test\";s:11:\"description\";s:39:\"Support module for action loop testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/ajax_forms_test.module','ajax_forms_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:26:\"AJAX form test mock module\";s:11:\"description\";s:25:\"Test for AJAX form calls.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/ajax_test.module','ajax_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:9:\"AJAX Test\";s:11:\"description\";s:40:\"Support module for AJAX framework tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/batch_test.module','batch_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:14:\"Batch API test\";s:11:\"description\";s:35:\"Support module for Batch API tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/common_test.module','common_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:11:\"Common Test\";s:11:\"description\";s:32:\"Support module for Common tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:15:\"common_test.css\";s:40:\"modules/simpletest/tests/common_test.css\";}s:5:\"print\";a:1:{s:21:\"common_test.print.css\";s:46:\"modules/simpletest/tests/common_test.print.css\";}}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/common_test_cron_helper.module','common_test_cron_helper','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:23:\"Common Test Cron Helper\";s:11:\"description\";s:56:\"Helper module for CronRunTestCase::testCronExceptions().\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/database_test.module','database_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:13:\"Database Test\";s:11:\"description\";s:40:\"Support module for Database layer tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/drupal_system_listing_compatible_test/drupal_system_listing_compatible_test.module','drupal_system_listing_compatible_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:37:\"Drupal system listing compatible test\";s:11:\"description\";s:62:\"Support module for testing the drupal_system_listing function.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/drupal_system_listing_incompatible_test/drupal_system_listing_incompatible_test.module','drupal_system_listing_incompatible_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:39:\"Drupal system listing incompatible test\";s:11:\"description\";s:62:\"Support module for testing the drupal_system_listing function.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/entity_cache_test.module','entity_cache_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:17:\"Entity cache test\";s:11:\"description\";s:40:\"Support module for testing entity cache.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:28:\"entity_cache_test_dependency\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/entity_cache_test_dependency.module','entity_cache_test_dependency','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:28:\"Entity cache test dependency\";s:11:\"description\";s:51:\"Support dependency module for testing entity cache.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/entity_crud_hook_test.module','entity_crud_hook_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:22:\"Entity CRUD Hooks Test\";s:11:\"description\";s:35:\"Support module for CRUD hook tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/entity_query_access_test.module','entity_query_access_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:24:\"Entity query access test\";s:11:\"description\";s:49:\"Support module for checking entity query results.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/error_test.module','error_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:10:\"Error test\";s:11:\"description\";s:47:\"Support module for error and exception testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/file_test.module','file_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:9:\"File test\";s:11:\"description\";s:39:\"Support module for file handling tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:16:\"file_test.module\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/filter_test.module','filter_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:18:\"Filter test module\";s:11:\"description\";s:33:\"Tests filter hooks and functions.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/form_test.module','form_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:12:\"FormAPI Test\";s:11:\"description\";s:34:\"Support module for Form API tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/image_test.module','image_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:10:\"Image test\";s:11:\"description\";s:39:\"Support module for image toolkit tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/menu_test.module','menu_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:15:\"Hook menu tests\";s:11:\"description\";s:37:\"Support module for menu hook testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/module_test.module','module_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:11:\"Module test\";s:11:\"description\";s:41:\"Support module for module system testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/path_test.module','path_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:15:\"Hook path tests\";s:11:\"description\";s:37:\"Support module for path hook testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/requirements1_test.module','requirements1_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:19:\"Requirements 1 Test\";s:11:\"description\";s:80:\"Tests that a module is not installed when it fails hook_requirements(\'install\').\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/requirements2_test.module','requirements2_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:19:\"Requirements 2 Test\";s:11:\"description\";s:98:\"Tests that a module is not installed when the one it depends on fails hook_requirements(\'install).\";s:12:\"dependencies\";a:2:{i:0;s:18:\"requirements1_test\";i:1;s:7:\"comment\";}s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/session_test.module','session_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:12:\"Session test\";s:11:\"description\";s:40:\"Support module for session data testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_dependencies_test.module','system_dependencies_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:22:\"System dependency test\";s:11:\"description\";s:47:\"Support module for testing system dependencies.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:1:{i:0;s:19:\"_missing_dependency\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_incompatible_core_version_dependencies_test.module','system_incompatible_core_version_dependencies_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:50:\"System incompatible core version dependencies test\";s:11:\"description\";s:47:\"Support module for testing system dependencies.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:1:{i:0;s:37:\"system_incompatible_core_version_test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_incompatible_core_version_test.module','system_incompatible_core_version_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:37:\"System incompatible core version test\";s:11:\"description\";s:47:\"Support module for testing system dependencies.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"5.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_incompatible_module_version_dependencies_test.module','system_incompatible_module_version_dependencies_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:52:\"System incompatible module version dependencies test\";s:11:\"description\";s:47:\"Support module for testing system dependencies.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:1:{i:0;s:46:\"system_incompatible_module_version_test (>2.0)\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_incompatible_module_version_test.module','system_incompatible_module_version_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:39:\"System incompatible module version test\";s:11:\"description\";s:47:\"Support module for testing system dependencies.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_test.module','system_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:11:\"System test\";s:11:\"description\";s:34:\"Support module for system testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:18:\"system_test.module\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/taxonomy_test.module','taxonomy_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:20:\"Taxonomy test module\";s:11:\"description\";s:45:\"\"Tests functions and hooks not used in core\".\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:1:{i:0;s:8:\"taxonomy\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/theme_test.module','theme_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:10:\"Theme test\";s:11:\"description\";s:40:\"Support module for theme system testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/update_script_test.module','update_script_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:18:\"Update script test\";s:11:\"description\";s:41:\"Support module for update script testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/update_test_1.module','update_test_1','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:11:\"Update test\";s:11:\"description\";s:34:\"Support module for update testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/update_test_2.module','update_test_2','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:11:\"Update test\";s:11:\"description\";s:34:\"Support module for update testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/update_test_3.module','update_test_3','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:11:\"Update test\";s:11:\"description\";s:34:\"Support module for update testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/url_alter_test.module','url_alter_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:15:\"Url_alter tests\";s:11:\"description\";s:45:\"A support modules for url_alter hook testing.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/xmlrpc_test.module','xmlrpc_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:12:\"XML-RPC Test\";s:11:\"description\";s:75:\"Support module for XML-RPC tests according to the validator1 specification.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/statistics/statistics.module','statistics','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:10:\"Statistics\";s:11:\"description\";s:37:\"Logs access statistics for your site.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:15:\"statistics.test\";}s:9:\"configure\";s:30:\"admin/config/system/statistics\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/syslog/syslog.module','syslog','module','',1,1,0,0,'a:11:{s:4:\"name\";s:6:\"Syslog\";s:11:\"description\";s:41:\"Logs and records system events to syslog.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"syslog.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/system/system.module','system','module','',1,0,7077,0,'a:13:{s:4:\"name\";s:6:\"System\";s:11:\"description\";s:54:\"Handles general site configuration for administrators.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:6:{i:0;s:19:\"system.archiver.inc\";i:1;s:15:\"system.mail.inc\";i:2;s:16:\"system.queue.inc\";i:3;s:14:\"system.tar.inc\";i:4;s:18:\"system.updater.inc\";i:5;s:11:\"system.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:19:\"admin/config/system\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/taxonomy/taxonomy.module','taxonomy','module','',1,0,7010,0,'a:14:{s:4:\"name\";s:8:\"Taxonomy\";s:11:\"description\";s:38:\"Enables the categorization of content.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:7:\"options\";}s:5:\"files\";a:2:{i:0;s:15:\"taxonomy.module\";i:1;s:13:\"taxonomy.test\";}s:9:\"configure\";s:24:\"admin/structure/taxonomy\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:73:\"Field type(s) in use - see <a href=\"/admin/reports/fields\">Field list</a>\";}'),('modules/toolbar/toolbar.module','toolbar','module','',0,0,0,0,'a:11:{s:4:\"name\";s:7:\"Toolbar\";s:11:\"description\";s:99:\"Provides a toolbar that shows the top-level administration menu items and links from other modules.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/tracker/tracker.module','tracker','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:7:\"Tracker\";s:11:\"description\";s:45:\"Enables tracking of recent content for users.\";s:12:\"dependencies\";a:1:{i:0;s:7:\"comment\";}s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:12:\"tracker.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/translation/tests/translation_test.module','translation_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:24:\"Content Translation Test\";s:11:\"description\";s:49:\"Support module for the content translation tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/translation/translation.module','translation','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:19:\"Content translation\";s:11:\"description\";s:57:\"Allows content to be translated into different languages.\";s:12:\"dependencies\";a:1:{i:0;s:6:\"locale\";}s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:16:\"translation.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/trigger/tests/trigger_test.module','trigger_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:12:\"Trigger Test\";s:11:\"description\";s:33:\"Support module for Trigger tests.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:4:\"7.16\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/trigger/trigger.module','trigger','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:7:\"Trigger\";s:11:\"description\";s:90:\"Enables actions to be fired on certain system events, such as when new content is created.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:12:\"trigger.test\";}s:9:\"configure\";s:23:\"admin/structure/trigger\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/update/tests/aaa_update_test.module','aaa_update_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:15:\"AAA Update test\";s:11:\"description\";s:41:\"Support module for update module testing.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:4:\"7.16\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/update/tests/bbb_update_test.module','bbb_update_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:15:\"BBB Update test\";s:11:\"description\";s:41:\"Support module for update module testing.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:4:\"7.16\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/update/tests/ccc_update_test.module','ccc_update_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:15:\"CCC Update test\";s:11:\"description\";s:41:\"Support module for update module testing.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:4:\"7.16\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/update/tests/update_test.module','update_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:11:\"Update test\";s:11:\"description\";s:41:\"Support module for update module testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/update/update.module','update','module','',0,0,7001,0,'a:12:{s:4:\"name\";s:14:\"Update manager\";s:11:\"description\";s:104:\"Checks for available updates, and can securely install or update modules and themes via a web interface.\";s:7:\"version\";s:4:\"7.16\";s:7:\"package\";s:4:\"Core\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"update.test\";}s:9:\"configure\";s:30:\"admin/reports/updates/settings\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/user/tests/user_form_test.module','user_form_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:22:\"User module form tests\";s:11:\"description\";s:37:\"Support module for user form testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/user/user.module','user','module','',1,0,7018,0,'a:14:{s:4:\"name\";s:4:\"User\";s:11:\"description\";s:47:\"Manages the user registration and login system.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:11:\"user.module\";i:1;s:9:\"user.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:19:\"admin/config/people\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"user.css\";s:21:\"modules/user/user.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('profiles/standard/standard.profile','standard','module','',1,0,0,1000,'a:14:{s:4:\"name\";s:8:\"Standard\";s:11:\"description\";s:51:\"Install with commonly used features pre-configured.\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:21:{i:0;s:5:\"block\";i:1;s:5:\"color\";i:2;s:7:\"comment\";i:3;s:10:\"contextual\";i:4;s:9:\"dashboard\";i:5;s:4:\"help\";i:6;s:5:\"image\";i:7;s:4:\"list\";i:8;s:4:\"menu\";i:9;s:6:\"number\";i:10;s:7:\"options\";i:11;s:4:\"path\";i:12;s:8:\"taxonomy\";i:13;s:5:\"dblog\";i:14;s:6:\"search\";i:15;s:8:\"shortcut\";i:16;s:7:\"toolbar\";i:17;s:7:\"overlay\";i:18;s:8:\"field_ui\";i:19;s:4:\"file\";i:20;s:3:\"rdf\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;s:6:\"hidden\";b:1;s:8:\"required\";b:1;s:17:\"distribution_name\";s:6:\"Drupal\";}'),('sites/all/modules/contrib/admin_menu/admin_devel/admin_devel.module','admin_devel','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:32:\"Administration Development tools\";s:11:\"description\";s:76:\"Administration and debugging functionality for developers and site builders.\";s:7:\"package\";s:14:\"Administration\";s:4:\"core\";s:3:\"7.x\";s:7:\"scripts\";a:1:{s:14:\"admin_devel.js\";s:63:\"sites/all/modules/contrib/admin_menu/admin_devel/admin_devel.js\";}s:7:\"version\";s:11:\"7.x-3.0-rc3\";s:7:\"project\";s:10:\"admin_menu\";s:9:\"datestamp\";s:10:\"1337292349\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/admin_menu/admin_menu.module','admin_menu','module','',1,0,7304,100,'a:12:{s:4:\"name\";s:19:\"Administration menu\";s:11:\"description\";s:123:\"Provides a dropdown menu to most administrative tasks and other common destinations (to users with the proper permissions).\";s:7:\"package\";s:14:\"Administration\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:38:\"admin/config/administration/admin_menu\";s:12:\"dependencies\";a:1:{i:0;s:14:\"system (>7.10)\";}s:5:\"files\";a:1:{i:0;s:21:\"tests/admin_menu.test\";}s:7:\"version\";s:11:\"7.x-3.0-rc3\";s:7:\"project\";s:10:\"admin_menu\";s:9:\"datestamp\";s:10:\"1337292349\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/admin_menu/admin_menu_toolbar/admin_menu_toolbar.module','admin_menu_toolbar','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:33:\"Administration menu Toolbar style\";s:11:\"description\";s:17:\"A better Toolbar.\";s:7:\"package\";s:14:\"Administration\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:10:\"admin_menu\";}s:7:\"version\";s:11:\"7.x-3.0-rc3\";s:7:\"project\";s:10:\"admin_menu\";s:9:\"datestamp\";s:10:\"1337292349\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/block_class/block_class.module','block_class','module','',1,0,7101,0,'a:11:{s:4:\"name\";s:11:\"Block Class\";s:11:\"description\";s:39:\"Allows assigning CSS classes to blocks.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:19:\"block_class.install\";i:1;s:18:\"block_class.module\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:11:\"block_class\";s:9:\"datestamp\";s:10:\"1349301967\";s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/coder/coder.module','coder','module','',1,0,0,0,'a:11:{s:4:\"name\";s:5:\"Coder\";s:11:\"description\";s:66:\"Developer Module that assists with code review and version upgrade\";s:7:\"package\";s:11:\"Development\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:12:\"coder.module\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:5:\"coder\";s:9:\"datestamp\";s:10:\"1352602857\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/coder/coder_review/coder_review.module','coder_review','module','',1,0,3,0,'a:11:{s:4:\"name\";s:12:\"Coder Review\";s:11:\"description\";s:117:\"Developer module which reviews your code identifying coding style problems and where updates to the API are required.\";s:7:\"package\";s:11:\"Development\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"coder\";}s:5:\"files\";a:8:{i:0;s:33:\"tests/coder_review_test_case.tinc\";i:1;s:26:\"tests/coder_review_6x.test\";i:2;s:26:\"tests/coder_review_7x.test\";i:3;s:31:\"tests/coder_review_comment.test\";i:4;s:28:\"tests/coder_review_i18n.test\";i:5;s:32:\"tests/coder_review_security.test\";i:6;s:27:\"tests/coder_review_sql.test\";i:7;s:29:\"tests/coder_review_style.test\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:5:\"coder\";s:9:\"datestamp\";s:10:\"1352602857\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/coder/coder_review/tests/coder_review_test/coder_review_test.module','coder_review_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:17:\"Coder Review Test\";s:7:\"package\";s:5:\"Coder\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:5:\"files\";a:1:{i:0;s:24:\"coder_review_test.module\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:5:\"coder\";s:9:\"datestamp\";s:10:\"1352602857\";s:12:\"dependencies\";a:0:{}s:11:\"description\";s:0:\"\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/coder/coder_upgrade/coder_upgrade.module','coder_upgrade','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:13:\"Coder Upgrade\";s:11:\"description\";s:93:\"Modifies source code to assist with the upgrade of a module for changes to a relied upon API.\";s:7:\"package\";s:11:\"Development\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:12:\"gplib (<2.0)\";}s:5:\"files\";a:1:{i:0;s:18:\"coder_upgrade.test\";}s:9:\"configure\";s:47:\"admin/config/development/coder/upgrade/settings\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:5:\"coder\";s:9:\"datestamp\";s:10:\"1352602857\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/computed_field/computed_field.module','computed_field','module','',1,0,0,0,'a:13:{s:4:\"name\";s:14:\"Computed Field\";s:11:\"description\";s:70:\"Defines a field type that allows values to be \"computed\" via PHP code.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:7:\"package\";s:6:\"Fields\";s:5:\"files\";a:2:{i:0;s:22:\"computed_field.install\";i:1;s:21:\"computed_field.module\";}s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:7:\"project\";s:14:\"computed_field\";s:9:\"datestamp\";s:10:\"1328217338\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:73:\"Field type(s) in use - see <a href=\"/admin/reports/fields\">Field list</a>\";}'),('sites/all/modules/contrib/ctools/bulk_export/bulk_export.module','bulk_export','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:11:\"Bulk Export\";s:11:\"description\";s:67:\"Performs bulk exporting of data objects known about by Chaos tools.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/ctools/ctools.module','ctools','module','',1,0,6007,0,'a:11:{s:4:\"name\";s:11:\"Chaos tools\";s:11:\"description\";s:46:\"A library of helpful tools by Merlin of Chaos.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:5:\"files\";a:3:{i:0;s:20:\"includes/context.inc\";i:1;s:22:\"includes/math-expr.inc\";i:2;s:21:\"includes/stylizer.inc\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/ctools/ctools_access_ruleset/ctools_access_ruleset.module','ctools_access_ruleset','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:15:\"Custom rulesets\";s:11:\"description\";s:81:\"Create custom, exportable, reusable access rulesets for applications like Panels.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/ctools/ctools_ajax_sample/ctools_ajax_sample.module','ctools_ajax_sample','module','',1,0,0,0,'a:11:{s:4:\"name\";s:33:\"Chaos Tools (CTools) AJAX Example\";s:11:\"description\";s:41:\"Shows how to use the power of Chaos AJAX.\";s:7:\"package\";s:16:\"Chaos tool suite\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/ctools/ctools_custom_content/ctools_custom_content.module','ctools_custom_content','module','',1,0,0,0,'a:11:{s:4:\"name\";s:20:\"Custom content panes\";s:11:\"description\";s:79:\"Create custom, exportable, reusable content panes for applications like Panels.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/ctools/ctools_plugin_example/ctools_plugin_example.module','ctools_plugin_example','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:35:\"Chaos Tools (CTools) Plugin Example\";s:11:\"description\";s:75:\"Shows how an external module can provide ctools plugins (for Panels, etc.).\";s:7:\"package\";s:16:\"Chaos tool suite\";s:12:\"dependencies\";a:4:{i:0;s:6:\"ctools\";i:1;s:6:\"panels\";i:2;s:12:\"page_manager\";i:3;s:13:\"advanced_help\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/ctools/page_manager/page_manager.module','page_manager','module','',1,0,0,99,'a:11:{s:4:\"name\";s:12:\"Page manager\";s:11:\"description\";s:54:\"Provides a UI and API to manage pages within the site.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/ctools/stylizer/stylizer.module','stylizer','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:8:\"Stylizer\";s:11:\"description\";s:53:\"Create custom styles for applications such as Panels.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:12:\"dependencies\";a:2:{i:0;s:6:\"ctools\";i:1;s:5:\"color\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/ctools/tests/ctools_export_test/ctools_export_test.module','ctools_export_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:18:\"CTools export test\";s:11:\"description\";s:25:\"CTools export test module\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:6:\"hidden\";b:1;s:5:\"files\";a:1:{i:0;s:18:\"ctools_export.test\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/ctools/tests/ctools_plugin_test.module','ctools_plugin_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:24:\"Chaos tools plugins test\";s:11:\"description\";s:42:\"Provides hooks for testing ctools plugins.\";s:7:\"package\";s:16:\"Chaos tool suite\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:5:\"files\";a:4:{i:0;s:19:\"ctools.plugins.test\";i:1;s:17:\"object_cache.test\";i:2;s:8:\"css.test\";i:3;s:12:\"context.test\";}s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/ctools/views_content/views_content.module','views_content','module','',1,0,0,0,'a:11:{s:4:\"name\";s:19:\"Views content panes\";s:11:\"description\";s:104:\"Allows Views content to be used in Panels, Dashboard and other modules which use the CTools Content API.\";s:7:\"package\";s:16:\"Chaos tool suite\";s:12:\"dependencies\";a:2:{i:0;s:6:\"ctools\";i:1;s:5:\"views\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:61:\"plugins/views/views_content_plugin_display_ctools_context.inc\";i:1;s:57:\"plugins/views/views_content_plugin_display_panel_pane.inc\";i:2;s:59:\"plugins/views/views_content_plugin_style_ctools_context.inc\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/date/date.module','date','module','',1,0,7004,0,'a:13:{s:4:\"name\";s:4:\"Date\";s:11:\"description\";s:33:\"Makes date/time fields available.\";s:12:\"dependencies\";a:1:{i:0;s:8:\"date_api\";}s:7:\"package\";s:9:\"Date/Time\";s:4:\"core\";s:3:\"7.x\";s:3:\"php\";s:3:\"5.2\";s:5:\"files\";a:5:{i:0;s:19:\"tests/date_api.test\";i:1;s:15:\"tests/date.test\";i:2;s:21:\"tests/date_field.test\";i:3;s:26:\"tests/date_validation.test\";i:4;s:24:\"tests/date_timezone.test\";}s:7:\"version\";s:7:\"7.x-2.6\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1344850024\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:73:\"Field type(s) in use - see <a href=\"/admin/reports/fields\">Field list</a>\";}'),('sites/all/modules/contrib/date/date_all_day/date_all_day.module','date_all_day','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:12:\"Date All Day\";s:11:\"description\";s:142:\"Adds \'All Day\' functionality to date fields, including an \'All Day\' theme and \'All Day\' checkboxes for the Date select and Date popup widgets.\";s:12:\"dependencies\";a:2:{i:0;s:8:\"date_api\";i:1;s:4:\"date\";}s:7:\"package\";s:9:\"Date/Time\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-2.6\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1344850024\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/date/date_api/date_api.module','date_api','module','',1,0,7001,0,'a:12:{s:4:\"name\";s:8:\"Date API\";s:11:\"description\";s:45:\"A Date API that can be used by other modules.\";s:7:\"package\";s:9:\"Date/Time\";s:4:\"core\";s:3:\"7.x\";s:3:\"php\";s:3:\"5.2\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"date.css\";s:48:\"sites/all/modules/contrib/date/date_api/date.css\";}}s:5:\"files\";a:2:{i:0;s:15:\"date_api.module\";i:1;s:16:\"date_api_sql.inc\";}s:7:\"version\";s:7:\"7.x-2.6\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1344850024\";s:12:\"dependencies\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/date/date_context/date_context.module','date_context','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:12:\"Date Context\";s:11:\"description\";s:99:\"Adds an option to the Context module to set a context condition based on the value of a date field.\";s:7:\"package\";s:9:\"Date/Time\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:4:\"date\";i:1;s:7:\"context\";}s:5:\"files\";a:2:{i:0;s:19:\"date_context.module\";i:1;s:39:\"plugins/date_context_date_condition.inc\";}s:7:\"version\";s:7:\"7.x-2.6\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1344850024\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/date/date_migrate/date_migrate.module','date_migrate','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:14:\"Date Migration\";s:11:\"description\";s:72:\"Provides support for importing into date fields with the Migrate module.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:9:\"Date/Time\";s:12:\"dependencies\";a:2:{i:0;s:7:\"migrate\";i:1;s:4:\"date\";}s:5:\"files\";a:2:{i:0;s:16:\"date.migrate.inc\";i:1;s:17:\"date_migrate.test\";}s:7:\"version\";s:7:\"7.x-2.6\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1344850024\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/date/date_migrate/date_migrate_example/date_migrate_example.module','date_migrate_example','module','',0,0,-1,0,'a:12:{s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:6:{i:0;s:4:\"date\";i:1;s:11:\"date_repeat\";i:2;s:17:\"date_repeat_field\";i:3;s:12:\"date_migrate\";i:4;s:8:\"features\";i:5;s:7:\"migrate\";}s:11:\"description\";s:42:\"Examples of migrating with the Date module\";s:8:\"features\";a:2:{s:5:\"field\";a:8:{i:0;s:30:\"node-date_migrate_example-body\";i:1;s:36:\"node-date_migrate_example-field_date\";i:2;s:42:\"node-date_migrate_example-field_date_range\";i:3;s:43:\"node-date_migrate_example-field_date_repeat\";i:4;s:41:\"node-date_migrate_example-field_datestamp\";i:5;s:47:\"node-date_migrate_example-field_datestamp_range\";i:6;s:40:\"node-date_migrate_example-field_datetime\";i:7;s:46:\"node-date_migrate_example-field_datetime_range\";}s:4:\"node\";a:1:{i:0;s:20:\"date_migrate_example\";}}s:5:\"files\";a:1:{i:0;s:32:\"date_migrate_example.migrate.inc\";}s:4:\"name\";s:22:\"Date Migration Example\";s:7:\"package\";s:8:\"Features\";s:7:\"project\";s:4:\"date\";s:7:\"version\";s:7:\"7.x-2.6\";s:9:\"datestamp\";s:10:\"1344850024\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/date/date_popup/date_popup.module','date_popup','module','',1,0,0,0,'a:13:{s:4:\"name\";s:10:\"Date Popup\";s:11:\"description\";s:84:\"Enables jquery popup calendars and time entry widgets for selecting dates and times.\";s:12:\"dependencies\";a:1:{i:0;s:8:\"date_api\";}s:7:\"package\";s:9:\"Date/Time\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:28:\"admin/config/date/date_popup\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:25:\"themes/datepicker.1.7.css\";s:67:\"sites/all/modules/contrib/date/date_popup/themes/datepicker.1.7.css\";}}s:7:\"version\";s:7:\"7.x-2.6\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1344850024\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/date/date_repeat/date_repeat.module','date_repeat','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:15:\"Date Repeat API\";s:11:\"description\";s:73:\"A Date Repeat API to calculate repeating dates and times from iCal rules.\";s:12:\"dependencies\";a:1:{i:0;s:8:\"date_api\";}s:7:\"package\";s:9:\"Date/Time\";s:4:\"core\";s:3:\"7.x\";s:3:\"php\";s:3:\"5.2\";s:5:\"files\";a:2:{i:0;s:22:\"tests/date_repeat.test\";i:1;s:27:\"tests/date_repeat_form.test\";}s:7:\"version\";s:7:\"7.x-2.6\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1344850024\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/date/date_repeat_field/date_repeat_field.module','date_repeat_field','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:17:\"Date Repeat Field\";s:11:\"description\";s:97:\"Creates the option of Repeating date fields and manages Date fields that use the Date Repeat API.\";s:12:\"dependencies\";a:3:{i:0;s:8:\"date_api\";i:1;s:4:\"date\";i:2;s:11:\"date_repeat\";}s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:21:\"date_repeat_field.css\";s:70:\"sites/all/modules/contrib/date/date_repeat_field/date_repeat_field.css\";}}s:7:\"package\";s:9:\"Date/Time\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-2.6\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1344850024\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/date/date_tools/date_tools.module','date_tools','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:10:\"Date Tools\";s:11:\"description\";s:52:\"Tools to import and auto-create dates and calendars.\";s:12:\"dependencies\";a:1:{i:0;s:4:\"date\";}s:7:\"package\";s:9:\"Date/Time\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:23:\"admin/config/date/tools\";s:5:\"files\";a:1:{i:0;s:21:\"tests/date_tools.test\";}s:7:\"version\";s:7:\"7.x-2.6\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1344850024\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/date/date_views/date_views.module','date_views','module','',1,0,0,0,'a:11:{s:4:\"name\";s:10:\"Date Views\";s:11:\"description\";s:57:\"Views integration for date fields and date functionality.\";s:7:\"package\";s:9:\"Date/Time\";s:12:\"dependencies\";a:2:{i:0;s:8:\"date_api\";i:1;s:5:\"views\";}s:4:\"core\";s:3:\"7.x\";s:3:\"php\";s:3:\"5.2\";s:5:\"files\";a:7:{i:0;s:40:\"includes/date_views_argument_handler.inc\";i:1;s:47:\"includes/date_views_argument_handler_simple.inc\";i:2;s:38:\"includes/date_views_filter_handler.inc\";i:3;s:45:\"includes/date_views_filter_handler_simple.inc\";i:4;s:37:\"includes/date_views.views_default.inc\";i:5;s:29:\"includes/date_views.views.inc\";i:6;s:36:\"includes/date_views_plugin_pager.inc\";}s:7:\"version\";s:7:\"7.x-2.6\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1344850024\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/drupalforfirebug/drupalforfirebug.module','drupalforfirebug','module','',0,0,7000,100000,'a:11:{s:4:\"name\";s:18:\"Drupal for Firebug\";s:11:\"description\";s:69:\"A helper extension for the Drupal for Firebug Firefox extension addon\";s:7:\"package\";s:11:\"Development\";s:12:\"dependencies\";a:1:{i:0;s:27:\"drupalforfirebug_preprocess\";}s:5:\"files\";a:1:{i:0;s:23:\"drupalforfirebug.module\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-1.4\";s:7:\"project\";s:16:\"drupalforfirebug\";s:9:\"datestamp\";s:10:\"1351752371\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/drupalforfirebug/drupalforfirebug_preprocess.module','drupalforfirebug_preprocess','module','',0,0,7000,-100000,'a:11:{s:4:\"name\";s:31:\"Drupal for Firebug Preprocessor\";s:11:\"description\";s:92:\"A helper extension for the Drupal for Firebug Firefox extension to do preprocessing of forms\";s:7:\"package\";s:11:\"Development\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:32:\"drupalforfirebug_preprocess.info\";}s:7:\"version\";s:7:\"7.x-1.4\";s:7:\"project\";s:16:\"drupalforfirebug\";s:9:\"datestamp\";s:10:\"1351752371\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/entity/entity.module','entity','module','',1,0,7002,0,'a:11:{s:4:\"name\";s:10:\"Entity API\";s:11:\"description\";s:69:\"Enables modules to work with any entity type and to provide entities.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:24:{i:0;s:19:\"entity.features.inc\";i:1;s:15:\"entity.i18n.inc\";i:2;s:15:\"entity.info.inc\";i:3;s:16:\"entity.rules.inc\";i:4;s:11:\"entity.test\";i:5;s:19:\"includes/entity.inc\";i:6;s:30:\"includes/entity.controller.inc\";i:7;s:22:\"includes/entity.ui.inc\";i:8;s:27:\"includes/entity.wrapper.inc\";i:9;s:22:\"views/entity.views.inc\";i:10;s:52:\"views/handlers/entity_views_field_handler_helper.inc\";i:11;s:51:\"views/handlers/entity_views_handler_area_entity.inc\";i:12;s:53:\"views/handlers/entity_views_handler_field_boolean.inc\";i:13;s:50:\"views/handlers/entity_views_handler_field_date.inc\";i:14;s:54:\"views/handlers/entity_views_handler_field_duration.inc\";i:15;s:52:\"views/handlers/entity_views_handler_field_entity.inc\";i:16;s:51:\"views/handlers/entity_views_handler_field_field.inc\";i:17;s:53:\"views/handlers/entity_views_handler_field_numeric.inc\";i:18;s:53:\"views/handlers/entity_views_handler_field_options.inc\";i:19;s:50:\"views/handlers/entity_views_handler_field_text.inc\";i:20;s:49:\"views/handlers/entity_views_handler_field_uri.inc\";i:21;s:62:\"views/handlers/entity_views_handler_relationship_by_bundle.inc\";i:22;s:52:\"views/handlers/entity_views_handler_relationship.inc\";i:23;s:53:\"views/plugins/entity_views_plugin_row_entity_view.inc\";}s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";s:10:\"1337981155\";s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/entity/entity_token.module','entity_token','module','',1,0,0,0,'a:11:{s:4:\"name\";s:13:\"Entity tokens\";s:11:\"description\";s:99:\"Provides token replacements for all properties that have no tokens and are known to the entity API.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:23:\"entity_token.tokens.inc\";i:1;s:19:\"entity_token.module\";}s:12:\"dependencies\";a:1:{i:0;s:6:\"entity\";}s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";s:10:\"1337981155\";s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/entity/tests/entity_feature.module','entity_feature','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:21:\"Entity feature module\";s:11:\"description\";s:31:\"Provides some entities in code.\";s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:21:\"entity_feature.module\";}s:12:\"dependencies\";a:1:{i:0;s:11:\"entity_test\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";s:10:\"1337981155\";s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/entity/tests/entity_test.module','entity_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:23:\"Entity CRUD test module\";s:11:\"description\";s:46:\"Provides entity types based upon the CRUD API.\";s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:18:\"entity_test.module\";i:1;s:19:\"entity_test.install\";}s:12:\"dependencies\";a:1:{i:0;s:6:\"entity\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";s:10:\"1337981155\";s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/entity/tests/entity_test_i18n.module','entity_test_i18n','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:28:\"Entity-test type translation\";s:11:\"description\";s:37:\"Allows translating entity-test types.\";s:12:\"dependencies\";a:2:{i:0;s:11:\"entity_test\";i:1;s:11:\"i18n_string\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";s:10:\"1337981155\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/entityreference/entityreference.module','entityreference','module','',1,0,7002,0,'a:13:{s:4:\"name\";s:16:\"Entity Reference\";s:11:\"description\";s:51:\"Provides a field that can reference other entities.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Fields\";s:12:\"dependencies\";a:2:{i:0;s:6:\"entity\";i:1;s:6:\"ctools\";}s:5:\"files\";a:10:{i:0;s:27:\"entityreference.migrate.inc\";i:1;s:30:\"plugins/selection/abstract.inc\";i:2;s:27:\"plugins/selection/views.inc\";i:3;s:29:\"plugins/behavior/abstract.inc\";i:4;s:40:\"views/entityreference_plugin_display.inc\";i:5;s:38:\"views/entityreference_plugin_style.inc\";i:6;s:43:\"views/entityreference_plugin_row_fields.inc\";i:7;s:35:\"tests/entityreference.handlers.test\";i:8;s:35:\"tests/entityreference.taxonomy.test\";i:9;s:32:\"tests/entityreference.admin.test\";}s:7:\"version\";s:7:\"7.x-1.0\";s:7:\"project\";s:15:\"entityreference\";s:9:\"datestamp\";s:10:\"1353230808\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:73:\"Field type(s) in use - see <a href=\"/admin/reports/fields\">Field list</a>\";}'),('sites/all/modules/contrib/entityreference/examples/entityreference_behavior_example/entityreference_behavior_example.module','entityreference_behavior_example','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:33:\"Entity Reference Behavior Example\";s:11:\"description\";s:71:\"Provides some example code for implementing Entity Reference behaviors.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Fields\";s:12:\"dependencies\";a:1:{i:0;s:15:\"entityreference\";}s:7:\"version\";s:7:\"7.x-1.0\";s:7:\"project\";s:15:\"entityreference\";s:9:\"datestamp\";s:10:\"1353230808\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/eva/eva.module','eva','module','',1,0,0,0,'a:11:{s:4:\"name\";s:3:\"Eva\";s:11:\"description\";s:63:\"Provides a Views display type that can be attached to entities.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:7:\"package\";s:5:\"Views\";s:5:\"files\";a:1:{i:0;s:29:\"eva_plugin_display_entity.inc\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:3:\"eva\";s:9:\"datestamp\";s:10:\"1343701935\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/field_group/field_group.module','field_group','module','',1,0,7003,1,'a:11:{s:4:\"name\";s:10:\"Fieldgroup\";s:11:\"description\";s:10:\"Fieldgroup\";s:7:\"package\";s:6:\"Fields\";s:12:\"dependencies\";a:2:{i:0;s:5:\"field\";i:1;s:6:\"ctools\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:6:{i:0;s:19:\"field_group.install\";i:1;s:18:\"field_group.module\";i:2;s:24:\"field_group.field_ui.inc\";i:3;s:20:\"field_group.form.inc\";i:4;s:24:\"field_group.features.inc\";i:5;s:16:\"field_group.test\";}s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:11:\"field_group\";s:9:\"datestamp\";s:10:\"1319051133\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/field_hidden/field_hidden.module','field_hidden','module','',0,0,0,0,'a:12:{s:4:\"name\";s:12:\"Field Hidden\";s:11:\"description\";s:27:\"Defines hidden field types.\";s:7:\"package\";s:6:\"Fields\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:22:\"field_hidden.admin.inc\";}s:9:\"configure\";s:32:\"admin/config/fields/field_hidden\";s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:12:\"field_hidden\";s:9:\"datestamp\";s:10:\"1347471224\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/field_permissions/field_permissions.module','field_permissions','module','',0,0,7001,50,'a:12:{s:4:\"name\";s:17:\"Field Permissions\";s:11:\"description\";s:61:\"Set field-level permissions to create, update or view fields.\";s:7:\"package\";s:6:\"Fields\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:24:\"field_permissions.module\";i:1;s:27:\"field_permissions.admin.inc\";i:2;s:22:\"field_permissions.test\";}s:9:\"configure\";s:32:\"admin/reports/fields/permissions\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:7:\"project\";s:17:\"field_permissions\";s:9:\"datestamp\";s:10:\"1326241466\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/fuzzysearch/fuzzysearch.module','fuzzysearch','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:12:\"Fuzzy Search\";s:11:\"description\";s:34:\"Fuzzy search engine for Search API\";s:12:\"dependencies\";a:1:{i:0;s:10:\"search_api\";}s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Search\";s:5:\"files\";a:4:{i:0;s:20:\"includes/service.inc\";i:1;s:32:\"includes/fuzzysearch.default.inc\";i:2;s:29:\"includes/processor_search.inc\";i:3;s:30:\"includes/processor_excerpt.inc\";}s:7:\"version\";s:11:\"7.x-1.x-dev\";s:7:\"project\";s:11:\"fuzzysearch\";s:9:\"datestamp\";s:10:\"1352812349\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/jslider_form_api/jslider_form_api.module','jslider_form_api','module','',1,0,0,0,'a:11:{s:4:\"name\";s:22:\"jQuery Slider Form API\";s:11:\"description\";s:123:\"Integrates form element with two numeric textfields and slider to transfer numeric amounts from left to right and backwards\";s:7:\"package\";s:14:\"User interface\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:16:\"jslider_form_api\";s:9:\"datestamp\";s:10:\"1326099649\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/ldap/ldap_authentication/ldap_authentication.module','ldap_authentication','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:19:\"LDAP Authentication\";s:11:\"description\";s:30:\"Implements LDAP authentication\";s:7:\"package\";s:37:\"Lightweight Directory Access Protocol\";s:12:\"dependencies\";a:1:{i:0;s:12:\"ldap_servers\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:39:\"admin/config/people/ldap/authentication\";s:5:\"files\";a:8:{i:0;s:32:\"LdapAuthenticationConf.class.php\";i:1;s:37:\"LdapAuthenticationConfAdmin.class.php\";i:2;s:26:\"ldap_authentication.module\";i:3;s:27:\"ldap_authentication.install\";i:4;s:23:\"ldap_authentication.inc\";i:5;s:29:\"ldap_authentication.theme.inc\";i:6;s:29:\"ldap_authentication.admin.inc\";i:7;s:30:\"tests/ldap_authentication.test\";}s:7:\"version\";s:14:\"7.x-1.0-beta12\";s:7:\"project\";s:4:\"ldap\";s:9:\"datestamp\";s:10:\"1345503423\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/ldap/ldap_authorization/ldap_authorization.module','ldap_authorization','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:18:\"LDAP Authorization\";s:11:\"description\";s:54:\"Implements LDAP authorization (previously LDAP Groups)\";s:7:\"package\";s:37:\"Lightweight Directory Access Protocol\";s:12:\"dependencies\";a:1:{i:0;s:12:\"ldap_servers\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:16:{i:0;s:43:\"LdapAuthorizationConsumerAbstract.class.php\";i:1;s:35:\"LdapAuthorizationConsumer.class.php\";i:2;s:40:\"LdapAuthorizationConsumerAdmin.class.php\";i:3;s:26:\"ldap_authorization.install\";i:4;s:25:\"ldap_authorization.module\";i:5;s:28:\"ldap_authorization.admin.inc\";i:6;s:33:\"ldap_authorization.admin.test.inc\";i:7;s:28:\"ldap_authorization.theme.inc\";i:8;s:32:\"tests/BasicTests/BasicTests.test\";i:9;s:36:\"tests/DeriveFromDN/DeriveFromDN.test\";i:10;s:40:\"tests/DeriveFromAttr/DeriveFromAttr.test\";i:11;s:42:\"tests/DeriveFromEntry/DeriveFromEntry.test\";i:12;s:26:\"tests/1197636/1197636.test\";i:13;s:22:\"tests/Other/Other.test\";i:14;s:16:\"tests/Og/Og.test\";i:15;s:17:\"tests/Og/Og2.test\";}s:9:\"configure\";s:38:\"admin/config/people/ldap/authorization\";s:7:\"version\";s:14:\"7.x-1.0-beta12\";s:7:\"project\";s:4:\"ldap\";s:9:\"datestamp\";s:10:\"1345503423\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/ldap/ldap_authorization/ldap_authorization_drupal_role/ldap_authorization_drupal_role.module','ldap_authorization_drupal_role','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:33:\"LDAP Authorization - Drupal Roles\";s:11:\"description\";s:46:\"Implements LDAP authorization for Drupal roles\";s:7:\"package\";s:37:\"Lightweight Directory Access Protocol\";s:12:\"dependencies\";a:1:{i:0;s:18:\"ldap_authorization\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:38:\"admin/config/people/ldap/authorization\";s:5:\"files\";a:3:{i:0;s:39:\"LdapAuthorizationConsumerRole.class.php\";i:1;s:37:\"ldap_authorization_drupal_role.module\";i:2;s:34:\"ldap_authorization_drupal_role.inc\";}s:7:\"version\";s:14:\"7.x-1.0-beta12\";s:7:\"project\";s:4:\"ldap\";s:9:\"datestamp\";s:10:\"1345503423\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/ldap/ldap_authorization/ldap_authorization_og/ldap_authorization_og.module','ldap_authorization_og','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:40:\"LDAP Authorization - OG (Organic Groups)\";s:11:\"description\";s:48:\"Implements LDAP authorization for Organic Groups\";s:7:\"package\";s:37:\"Lightweight Directory Access Protocol\";s:12:\"dependencies\";a:2:{i:0;s:18:\"ldap_authorization\";i:1;s:2:\"og\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:41:\"admin/config/people/ldap_authorization_og\";s:5:\"files\";a:3:{i:0;s:37:\"LdapAuthorizationConsumerOG.class.php\";i:1;s:28:\"ldap_authorization_og.module\";i:2;s:25:\"ldap_authorization_og.inc\";}s:7:\"version\";s:14:\"7.x-1.0-beta12\";s:7:\"project\";s:4:\"ldap\";s:9:\"datestamp\";s:10:\"1345503423\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/ldap/ldap_feeds/ldap_feeds.module','ldap_feeds','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:10:\"LDAP Feeds\";s:11:\"description\";s:210:\"VERY MUCH IN ALPHA STATE. Included feeds fetcher for a generic ldap query and ldap entry parser to turn fetcher data into feeds compatible parser result. Used to automate content creation based on ldap queries.\";s:7:\"package\";s:37:\"Lightweight Directory Access Protocol\";s:12:\"dependencies\";a:3:{i:0;s:5:\"feeds\";i:1;s:12:\"ldap_servers\";i:2;s:10:\"ldap_query\";}s:9:\"configure\";s:21:\"admin/structure/feeds\";s:4:\"core\";s:3:\"7.x\";s:3:\"php\";s:3:\"5.2\";s:7:\"version\";s:14:\"7.x-1.0-beta12\";s:7:\"project\";s:4:\"ldap\";s:9:\"datestamp\";s:10:\"1345503423\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/ldap/ldap_help/ldap_help.module','ldap_help','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:9:\"LDAP Help\";s:11:\"description\";s:49:\"LDAP Help for configuration and reporting issues.\";s:7:\"package\";s:37:\"Lightweight Directory Access Protocol\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:12:\"ldap_servers\";}s:7:\"version\";s:14:\"7.x-1.0-beta12\";s:7:\"project\";s:4:\"ldap\";s:9:\"datestamp\";s:10:\"1345503423\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/ldap/ldap_profile/ldap_profile.module','ldap_profile','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:12:\"LDAP Profile\";s:11:\"description\";s:87:\"Implements LDAP Profile. Allows you to map Drupal profile fields to LDAP profile fields\";s:7:\"package\";s:37:\"Lightweight Directory Access Protocol\";s:12:\"dependencies\";a:1:{i:0;s:12:\"ldap_servers\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:32:\"admin/config/people/ldap/profile\";s:5:\"files\";a:5:{i:0;s:19:\"ldap_profile.module\";i:1;s:20:\"ldap_profile.install\";i:2;s:22:\"ldap_profile.admin.inc\";i:3;s:25:\"LdapProfileConf.class.php\";i:4;s:30:\"LdapProfileConfAdmin.class.php\";}s:7:\"version\";s:14:\"7.x-1.0-beta12\";s:7:\"project\";s:4:\"ldap\";s:9:\"datestamp\";s:10:\"1345503423\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/ldap/ldap_query/ldap_query.module','ldap_query','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:10:\"LDAP Query\";s:11:\"description\";s:109:\"LDAP Query Builder and Storage for queries used by other ldap modules such as ldap feeds, ldap provision, etc\";s:7:\"package\";s:37:\"Lightweight Directory Access Protocol\";s:12:\"dependencies\";a:1:{i:0;s:12:\"ldap_servers\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:9:{i:0;s:19:\"LdapQuery.class.php\";i:1;s:24:\"LdapQueryAdmin.class.php\";i:2;s:20:\"ldap_query.admin.inc\";i:3;s:14:\"ldap_query.inc\";i:4;s:18:\"ldap_query.install\";i:5;s:17:\"ldap_query.module\";i:6;s:23:\"ldap_query.settings.inc\";i:7;s:22:\"ldap_servers.theme.inc\";i:8;s:21:\"tests/ldap_query.test\";}s:9:\"configure\";s:30:\"admin/config/people/ldap/query\";s:7:\"version\";s:14:\"7.x-1.0-beta12\";s:7:\"project\";s:4:\"ldap\";s:9:\"datestamp\";s:10:\"1345503423\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/ldap/ldap_servers/ldap_servers.module','ldap_servers','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:12:\"LDAP Servers\";s:11:\"description\";s:36:\"Implements LDAP Server Configuration\";s:7:\"package\";s:37:\"Lightweight Directory Access Protocol\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:12:{i:0;s:20:\"LdapServer.class.php\";i:1;s:25:\"LdapServerAdmin.class.php\";i:2;s:22:\"ldap_servers.admin.inc\";i:3;s:27:\"ldap_servers.encryption.inc\";i:4;s:26:\"ldap_servers.functions.inc\";i:5;s:16:\"ldap_servers.inc\";i:6;s:20:\"ldap_servers.install\";i:7;s:19:\"ldap_servers.module\";i:8;s:25:\"ldap_servers.settings.inc\";i:9;s:26:\"ldap_servers.test_form.inc\";i:10;s:22:\"ldap_servers.theme.inc\";i:11;s:23:\"tests/ldap_servers.test\";}s:9:\"configure\";s:32:\"admin/config/people/ldap/servers\";s:7:\"version\";s:14:\"7.x-1.0-beta12\";s:7:\"project\";s:4:\"ldap\";s:9:\"datestamp\";s:10:\"1345503423\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/ldap/ldap_sso/ldap_sso.module','ldap_sso','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:8:\"LDAP SSO\";s:11:\"description\";s:51:\"Implements Single Sign On (SSO) LDAP Authentication\";s:7:\"package\";s:37:\"Lightweight Directory Access Protocol\";s:12:\"dependencies\";a:2:{i:0;s:12:\"ldap_servers\";i:1;s:19:\"ldap_authentication\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:39:\"admin/config/people/ldap/authentication\";s:7:\"version\";s:14:\"7.x-1.0-beta12\";s:7:\"project\";s:4:\"ldap\";s:9:\"datestamp\";s:10:\"1345503423\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/ldap/ldap_views/ldap_views.module','ldap_views','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:10:\"LDAP Views\";s:11:\"description\";s:38:\"Implements LDAP integration with Views\";s:7:\"package\";s:37:\"Lightweight Directory Access Protocol\";s:12:\"dependencies\";a:2:{i:0;s:10:\"ldap_query\";i:1;s:5:\"views\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:11:{i:0;s:17:\"ldap_views.module\";i:1;s:18:\"ldap_views.install\";i:2;s:40:\"plugins/ldap_views_plugin_query_ldap.inc\";i:3;s:40:\"handlers/ldap_views_handler_argument.inc\";i:4;s:50:\"handlers/ldap_views_handler_argument_attribute.inc\";i:5;s:37:\"handlers/ldap_views_handler_field.inc\";i:6;s:47:\"handlers/ldap_views_handler_field_attribute.inc\";i:7;s:38:\"handlers/ldap_views_handler_filter.inc\";i:8;s:48:\"handlers/ldap_views_handler_filter_attribute.inc\";i:9;s:36:\"handlers/ldap_views_handler_sort.inc\";i:10;s:46:\"handlers/ldap_views_handler_sort_attribute.inc\";}s:7:\"version\";s:14:\"7.x-1.0-beta12\";s:7:\"project\";s:4:\"ldap\";s:9:\"datestamp\";s:10:\"1345503423\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/logintoboggan/contrib/logintoboggan_content_access_integration/logintoboggan_content_access_integration.module','logintoboggan_content_access_integration','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:40:\"LoginToboggan Content Access Integration\";s:11:\"description\";s:102:\"Integrates LoginToboggan with Content Access module, so that Non-validated users are handled correctly\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:13:\"logintoboggan\";i:1;s:14:\"content_access\";}s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:13:\"logintoboggan\";s:9:\"datestamp\";s:10:\"1320873335\";s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/logintoboggan/contrib/logintoboggan_rules/logintoboggan_rules.module','logintoboggan_rules','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:31:\"LoginToboggan Rules Integration\";s:11:\"description\";s:42:\"Integrates LoginToboggan with Rules module\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:13:\"logintoboggan\";i:1;s:5:\"rules\";}s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:13:\"logintoboggan\";s:9:\"datestamp\";s:10:\"1320873335\";s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/logintoboggan/contrib/logintoboggan_variable/logintoboggan_variable.module','logintoboggan_variable','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:34:\"LoginToboggan Variable Integration\";s:11:\"description\";s:45:\"Integrates LoginToboggan with Variable module\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:13:\"logintoboggan\";i:1;s:8:\"variable\";}s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:13:\"logintoboggan\";s:9:\"datestamp\";s:10:\"1320873335\";s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/logintoboggan/logintoboggan.module','logintoboggan','module','',1,0,7000,0,'a:13:{s:4:\"name\";s:13:\"LoginToboggan\";s:11:\"description\";s:31:\"Improves Drupal\'s login system.\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:33:\"admin/config/system/logintoboggan\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:17:\"logintoboggan.css\";s:57:\"sites/all/modules/contrib/logintoboggan/logintoboggan.css\";}}s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:13:\"logintoboggan\";s:9:\"datestamp\";s:10:\"1320873335\";s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/login_destination/login_destination.module','login_destination','module','',1,0,7000,0,'a:12:{s:4:\"name\";s:17:\"Login Destination\";s:11:\"description\";s:69:\"Customize the destination that the user is redirected to after login.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:24:\"login_destination.module\";i:1;s:27:\"login_destination.admin.inc\";}s:9:\"configure\";s:37:\"admin/config/people/login-destination\";s:7:\"version\";s:7:\"7.x-1.0\";s:7:\"project\";s:17:\"login_destination\";s:9:\"datestamp\";s:10:\"1313172120\";s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/menu_attributes/menu_attributes.module','menu_attributes','module','',1,0,7001,10,'a:12:{s:4:\"name\";s:15:\"Menu attributes\";s:11:\"description\";s:66:\"Allows administrators to specify custom attributes for menu items.\";s:12:\"dependencies\";a:1:{i:0;s:4:\"menu\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:29:\"admin/structure/menu/settings\";s:5:\"files\";a:1:{i:0;s:20:\"menu_attributes.test\";}s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:7:\"project\";s:15:\"menu_attributes\";s:9:\"datestamp\";s:10:\"1338541556\";s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/module_filter/module_filter.module','module_filter','module','',1,0,7100,0,'a:12:{s:4:\"name\";s:13:\"Module filter\";s:11:\"description\";s:24:\"Filter the modules list.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:9:{i:0;s:21:\"module_filter.install\";i:1;s:16:\"module_filter.js\";i:2;s:20:\"module_filter.module\";i:3;s:23:\"module_filter.admin.inc\";i:4;s:23:\"module_filter.theme.inc\";i:5;s:21:\"css/module_filter.css\";i:6;s:25:\"css/module_filter_tab.css\";i:7;s:19:\"js/module_filter.js\";i:8;s:23:\"js/module_filter_tab.js\";}s:9:\"configure\";s:40:\"admin/config/user-interface/modulefilter\";s:7:\"version\";s:7:\"7.x-1.7\";s:7:\"project\";s:13:\"module_filter\";s:9:\"datestamp\";s:10:\"1341518501\";s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/panels/panels.module','panels','module','',1,0,7301,0,'a:12:{s:4:\"name\";s:6:\"Panels\";s:11:\"description\";s:107:\"Core Panels display functions; provides no external UI, at least one other Panels module should be enabled.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Panels\";s:9:\"configure\";s:22:\"admin/structure/panels\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:5:\"files\";a:5:{i:0;s:13:\"panels.module\";i:1;s:19:\"includes/common.inc\";i:2;s:19:\"includes/legacy.inc\";i:3;s:20:\"includes/plugins.inc\";i:4;s:48:\"plugins/views/panels_views_plugin_row_fields.inc\";}s:7:\"version\";s:7:\"7.x-3.3\";s:7:\"project\";s:6:\"panels\";s:9:\"datestamp\";s:10:\"1345319572\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/panels/panels_ipe/panels_ipe.module','panels_ipe','module','',1,0,0,0,'a:12:{s:4:\"name\";s:22:\"Panels In-Place Editor\";s:11:\"description\";s:101:\"Provide a UI for managing some Panels directly on the frontend, instead of having to use the backend.\";s:7:\"package\";s:6:\"Panels\";s:12:\"dependencies\";a:1:{i:0;s:6:\"panels\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:22:\"admin/structure/panels\";s:5:\"files\";a:1:{i:0;s:17:\"panels_ipe.module\";}s:7:\"version\";s:7:\"7.x-3.3\";s:7:\"project\";s:6:\"panels\";s:9:\"datestamp\";s:10:\"1345319572\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/panels/panels_mini/panels_mini.module','panels_mini','module','',1,0,0,0,'a:11:{s:4:\"name\";s:11:\"Mini panels\";s:11:\"description\";s:89:\"Create mini panels that can be used as blocks by Drupal and panes by other panel modules.\";s:7:\"package\";s:6:\"Panels\";s:12:\"dependencies\";a:1:{i:0;s:6:\"panels\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:42:\"plugins/export_ui/panels_mini_ui.class.php\";}s:7:\"version\";s:7:\"7.x-3.3\";s:7:\"project\";s:6:\"panels\";s:9:\"datestamp\";s:10:\"1345319572\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/panels/panels_node/panels_node.module','panels_node','module','',1,0,6001,11,'a:12:{s:4:\"name\";s:11:\"Panel nodes\";s:11:\"description\";s:65:\"Create nodes that are divided into areas with selectable content.\";s:7:\"package\";s:6:\"Panels\";s:12:\"dependencies\";a:1:{i:0;s:6:\"panels\";}s:9:\"configure\";s:22:\"admin/structure/panels\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:18:\"panels_node.module\";}s:7:\"version\";s:7:\"7.x-3.3\";s:7:\"project\";s:6:\"panels\";s:9:\"datestamp\";s:10:\"1345319572\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/password_field/password_field.module','password_field','module','',1,0,0,0,'a:11:{s:4:\"name\";s:14:\"Password Field\";s:11:\"description\";s:35:\"A basic password field for Drupal 7\";s:7:\"package\";s:6:\"Fields\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:5:\"field\";i:1;s:17:\"field_sql_storage\";}s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:7:\"project\";s:14:\"password_field\";s:9:\"datestamp\";s:10:\"1347577689\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/pathauto/pathauto.module','pathauto','module','',1,0,7005,1,'a:13:{s:4:\"name\";s:8:\"Pathauto\";s:11:\"description\";s:95:\"Provides a mechanism for modules to automatically generate aliases for the content they manage.\";s:12:\"dependencies\";a:2:{i:0;s:4:\"path\";i:1;s:5:\"token\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:13:\"pathauto.test\";}s:9:\"configure\";s:33:\"admin/config/search/path/patterns\";s:10:\"recommends\";a:1:{i:0;s:8:\"redirect\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:8:\"pathauto\";s:9:\"datestamp\";s:10:\"1344525185\";s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/r4032login/r4032login.module','r4032login','module','',1,0,7000,0,'a:12:{s:4:\"name\";s:26:\"Redirect 403 to User Login\";s:11:\"description\";s:78:\"Redirect anonymous users from 403 Access Denied pages to the /user/login page.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:18:\"r4032login.install\";i:1;s:17:\"r4032login.module\";}s:9:\"configure\";s:36:\"admin/config/system/site-information\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:10:\"r4032login\";s:9:\"datestamp\";s:10:\"1326460543\";s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/references/node_reference/node_reference.module','node_reference','module','',1,0,0,0,'a:13:{s:4:\"name\";s:14:\"Node Reference\";s:11:\"description\";s:59:\"Defines a field type for referencing one node from another.\";s:7:\"package\";s:6:\"Fields\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:3:{i:0;s:5:\"field\";i:1;s:10:\"references\";i:2;s:7:\"options\";}s:5:\"files\";a:1:{i:0;s:19:\"node_reference.test\";}s:7:\"version\";s:7:\"7.x-2.0\";s:7:\"project\";s:10:\"references\";s:9:\"datestamp\";s:10:\"1324596643\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:73:\"Field type(s) in use - see <a href=\"/admin/reports/fields\">Field list</a>\";}'),('sites/all/modules/contrib/references/references.module','references','module','',1,0,0,0,'a:11:{s:4:\"name\";s:10:\"References\";s:11:\"description\";s:67:\"Defines common base features for the various reference field types.\";s:7:\"package\";s:6:\"Fields\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:5:\"field\";i:1;s:7:\"options\";}s:5:\"files\";a:5:{i:0;s:41:\"views/references_handler_relationship.inc\";i:1;s:37:\"views/references_handler_argument.inc\";i:2;s:35:\"views/references_plugin_display.inc\";i:3;s:33:\"views/references_plugin_style.inc\";i:4;s:38:\"views/references_plugin_row_fields.inc\";}s:7:\"version\";s:7:\"7.x-2.0\";s:7:\"project\";s:10:\"references\";s:9:\"datestamp\";s:10:\"1324596643\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/references/user_reference/user_reference.module','user_reference','module','',1,0,0,0,'a:11:{s:4:\"name\";s:14:\"User Reference\";s:11:\"description\";s:56:\"Defines a field type for referencing a user from a node.\";s:7:\"package\";s:6:\"Fields\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:3:{i:0;s:5:\"field\";i:1;s:10:\"references\";i:2;s:7:\"options\";}s:7:\"version\";s:7:\"7.x-2.0\";s:7:\"project\";s:10:\"references\";s:9:\"datestamp\";s:10:\"1324596643\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/search_api/contrib/search_api_facetapi/search_api_facetapi.module','search_api_facetapi','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:13:\"Search facets\";s:11:\"description\";s:73:\"Integrate the Search API with the Facet API to provide facetted searches.\";s:12:\"dependencies\";a:2:{i:0;s:10:\"search_api\";i:1;s:8:\"facetapi\";}s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Search\";s:5:\"files\";a:3:{i:0;s:28:\"plugins/facetapi/adapter.inc\";i:1;s:36:\"plugins/facetapi/query_type_term.inc\";i:2;s:36:\"plugins/facetapi/query_type_date.inc\";}s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:10:\"search_api\";s:9:\"datestamp\";s:10:\"1350461221\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/search_api/contrib/search_api_views/search_api_views.module','search_api_views','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:12:\"Search views\";s:11:\"description\";s:107:\"Integrates the Search API with Views, enabling users to create views with searches as filters or arguments.\";s:12:\"dependencies\";a:2:{i:0;s:10:\"search_api\";i:1;s:5:\"views\";}s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Search\";s:5:\"files\";a:14:{i:0;s:32:\"includes/display_facet_block.inc\";i:1;s:29:\"includes/handler_argument.inc\";i:2;s:38:\"includes/handler_argument_fulltext.inc\";i:3;s:44:\"includes/handler_argument_more_like_this.inc\";i:4;s:34:\"includes/handler_argument_text.inc\";i:5;s:27:\"includes/handler_filter.inc\";i:6;s:35:\"includes/handler_filter_boolean.inc\";i:7;s:32:\"includes/handler_filter_date.inc\";i:8;s:36:\"includes/handler_filter_fulltext.inc\";i:9;s:36:\"includes/handler_filter_language.inc\";i:10;s:35:\"includes/handler_filter_options.inc\";i:11;s:32:\"includes/handler_filter_text.inc\";i:12;s:25:\"includes/handler_sort.inc\";i:13;s:18:\"includes/query.inc\";}s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:10:\"search_api\";s:9:\"datestamp\";s:10:\"1350461221\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/search_api/search_api.module','search_api','module','',1,0,7114,0,'a:12:{s:4:\"name\";s:10:\"Search API\";s:11:\"description\";s:63:\"Provides a generic API for modules offering search capabilites.\";s:12:\"dependencies\";a:1:{i:0;s:6:\"entity\";}s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Search\";s:5:\"files\";a:23:{i:0;s:15:\"search_api.test\";i:1;s:21:\"includes/callback.inc\";i:2;s:37:\"includes/callback_add_aggregation.inc\";i:3;s:35:\"includes/callback_add_hierarchy.inc\";i:4;s:29:\"includes/callback_add_url.inc\";i:5;s:39:\"includes/callback_add_viewed_entity.inc\";i:6;s:35:\"includes/callback_bundle_filter.inc\";i:7;s:38:\"includes/callback_language_control.inc\";i:8;s:33:\"includes/callback_node_access.inc\";i:9;s:33:\"includes/callback_node_status.inc\";i:10;s:23:\"includes/datasource.inc\";i:11;s:30:\"includes/datasource_entity.inc\";i:12;s:32:\"includes/datasource_external.inc\";i:13;s:22:\"includes/exception.inc\";i:14;s:25:\"includes/index_entity.inc\";i:15;s:22:\"includes/processor.inc\";i:16;s:34:\"includes/processor_html_filter.inc\";i:17;s:34:\"includes/processor_ignore_case.inc\";i:18;s:32:\"includes/processor_stopwords.inc\";i:19;s:32:\"includes/processor_tokenizer.inc\";i:20;s:18:\"includes/query.inc\";i:21;s:26:\"includes/server_entity.inc\";i:22;s:20:\"includes/service.inc\";}s:9:\"configure\";s:30:\"admin/config/search/search_api\";s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:10:\"search_api\";s:9:\"datestamp\";s:10:\"1350461221\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/search_api/tests/search_api_test.module','search_api_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:15:\"Search API test\";s:11:\"description\";s:54:\"Some dummy implementations for testing the Search API.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Search\";s:12:\"dependencies\";a:1:{i:0;s:10:\"search_api\";}s:5:\"files\";a:1:{i:0;s:22:\"search_api_test.module\";}s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:10:\"search_api\";s:9:\"datestamp\";s:10:\"1350461221\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/search_api_page/search_api_page.module','search_api_page','module','',1,0,7102,0,'a:12:{s:4:\"name\";s:12:\"Search pages\";s:11:\"description\";s:45:\"Create search pages using Search API indexes.\";s:12:\"dependencies\";a:1:{i:0;s:10:\"search_api\";}s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Search\";s:9:\"configure\";s:35:\"admin/config/search/search_api/page\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:7:\"project\";s:15:\"search_api_page\";s:9:\"datestamp\";s:10:\"1320944736\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/services/auth/services_oauth/services_oauth.module','services_oauth','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:20:\"OAuth Authentication\";s:11:\"description\";s:53:\"Provides OAuth authentication for the services module\";s:7:\"package\";s:25:\"Services - authentication\";s:12:\"dependencies\";a:2:{i:0;s:8:\"services\";i:1;s:12:\"oauth_common\";}s:4:\"core\";s:3:\"7.x\";s:3:\"php\";s:3:\"5.2\";s:7:\"version\";s:7:\"7.x-3.1\";s:7:\"project\";s:8:\"services\";s:9:\"datestamp\";s:10:\"1321482643\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/services/servers/rest_server/formats/xcal_format.module','xcal_format','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:21:\"xCal and iCal formats\";s:11:\"description\";s:54:\"Provides xCal and iCal formatters for the REST server.\";s:7:\"package\";s:8:\"Services\";s:4:\"core\";s:3:\"7.x\";s:3:\"php\";s:3:\"5.x\";s:7:\"version\";s:7:\"7.x-3.1\";s:7:\"project\";s:8:\"services\";s:9:\"datestamp\";s:10:\"1321482643\";s:12:\"dependencies\";a:0:{}s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/services/servers/rest_server/rest_server.module','rest_server','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:11:\"REST Server\";s:11:\"description\";s:24:\"Provides an REST server.\";s:7:\"package\";s:18:\"Services - servers\";s:5:\"files\";a:7:{i:0;s:18:\"rest_server.module\";i:1;s:19:\"includes/models.inc\";i:2;s:30:\"includes/rest_server.views.inc\";i:3;s:23:\"includes/RESTServer.inc\";i:4;s:15:\"lib/bencode.php\";i:5;s:17:\"lib/mimeparse.php\";i:6;s:12:\"lib/spyc.php\";}s:12:\"dependencies\";a:1:{i:0;s:8:\"services\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-3.1\";s:7:\"project\";s:8:\"services\";s:9:\"datestamp\";s:10:\"1321482643\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/services/servers/xmlrpc_server/xmlrpc_server.module','xmlrpc_server','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:13:\"XMLRPC Server\";s:11:\"description\";s:25:\"Provides a XMLRPC server.\";s:7:\"package\";s:18:\"Services - servers\";s:5:\"files\";a:1:{i:0;s:20:\"xmlrpc_server.module\";}s:12:\"dependencies\";a:1:{i:0;s:8:\"services\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-3.1\";s:7:\"project\";s:8:\"services\";s:9:\"datestamp\";s:10:\"1321482643\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/services/services.module','services','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:8:\"Services\";s:11:\"description\";s:41:\"Provide an API for creating web services.\";s:7:\"package\";s:8:\"Services\";s:4:\"core\";s:3:\"7.x\";s:3:\"php\";s:3:\"5.x\";s:5:\"files\";a:13:{i:0;s:20:\"services.runtime.inc\";i:1;s:46:\"tests/functional/NoAuthEndpointTestRunner.test\";i:2;s:47:\"tests/functional/ServicesResourceNodeTests.test\";i:3;s:47:\"tests/functional/ServicesResourceUserTests.test\";i:4;s:49:\"tests/functional/ServicesResourceSystemTests.test\";i:5;s:50:\"tests/functional/ServicesResourceCommentTests.test\";i:6;s:51:\"tests/functional/ServicesResourceTaxonomyTests.test\";i:7;s:47:\"tests/functional/ServicesResourceFileTests.test\";i:8;s:43:\"tests/functional/ServicesEndpointTests.test\";i:9;s:41:\"tests/functional/ServicesParserTests.test\";i:10;s:41:\"tests/functional/ServicesXMLRPCTests.test\";i:11;s:34:\"tests/unit/TestServicesModule.test\";i:12;s:19:\"tests/services.test\";}s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"version\";s:7:\"7.x-3.1\";s:7:\"project\";s:8:\"services\";s:9:\"datestamp\";s:10:\"1321482643\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/services/tests/services_test_resource/services_test_resource.module','services_test_resource','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:22:\"Services Test Resource\";s:11:\"description\";s:51:\"Provide test methods to check different situations.\";s:7:\"package\";s:8:\"Services\";s:4:\"core\";s:3:\"7.x\";s:3:\"php\";s:3:\"5.x\";s:5:\"files\";a:1:{i:0;s:29:\"services_test_resource.module\";}s:12:\"dependencies\";a:1:{i:0;s:8:\"services\";}s:7:\"version\";s:7:\"7.x-3.1\";s:7:\"project\";s:8:\"services\";s:9:\"datestamp\";s:10:\"1321482643\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/token/tests/token_test.module','token_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:10:\"Token Test\";s:11:\"description\";s:39:\"Testing module for token functionality.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:17:\"token_test.module\";}s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-1.4\";s:7:\"project\";s:5:\"token\";s:9:\"datestamp\";s:10:\"1348497279\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/token/token.module','token','module','',1,0,7001,0,'a:11:{s:4:\"name\";s:5:\"Token\";s:11:\"description\";s:73:\"Provides a user interface for the Token API and some missing core tokens.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:5:{i:0;s:12:\"token.module\";i:1;s:13:\"token.install\";i:2;s:16:\"token.tokens.inc\";i:3;s:15:\"token.pages.inc\";i:4;s:10:\"token.test\";}s:7:\"version\";s:7:\"7.x-1.4\";s:7:\"project\";s:5:\"token\";s:9:\"datestamp\";s:10:\"1348497279\";s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/unique_field/unique_field.module','unique_field','module','',1,0,0,0,'a:11:{s:4:\"name\";s:12:\"Unique Field\";s:11:\"description\";s:115:\"Provides content validation requirement that a node\'s author, language, taxonomy terms, or other fields are unique.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:5:{i:0;s:19:\"unique_field.module\";i:1;s:20:\"unique_field.install\";i:2;s:15:\"tests/core.test\";i:3;s:15:\"tests/date.test\";i:4;s:21:\"tests/references.test\";}s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:7:\"project\";s:12:\"unique_field\";s:9:\"datestamp\";s:10:\"1311648120\";s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/views/tests/views_test.module','views_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:10:\"Views Test\";s:11:\"description\";s:22:\"Test module for Views.\";s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-3.5\";s:7:\"project\";s:5:\"views\";s:9:\"datestamp\";s:10:\"1345829394\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/views/views.module','views','module','',1,0,7301,10,'a:12:{s:4:\"name\";s:5:\"Views\";s:11:\"description\";s:55:\"Create customized lists and queries from your database.\";s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:3:\"php\";s:3:\"5.2\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:13:\"css/views.css\";s:45:\"sites/all/modules/contrib/views/css/views.css\";}}s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:5:\"files\";a:289:{i:0;s:31:\"handlers/views_handler_area.inc\";i:1;s:38:\"handlers/views_handler_area_result.inc\";i:2;s:36:\"handlers/views_handler_area_text.inc\";i:3;s:43:\"handlers/views_handler_area_text_custom.inc\";i:4;s:36:\"handlers/views_handler_area_view.inc\";i:5;s:35:\"handlers/views_handler_argument.inc\";i:6;s:40:\"handlers/views_handler_argument_date.inc\";i:7;s:43:\"handlers/views_handler_argument_formula.inc\";i:8;s:47:\"handlers/views_handler_argument_many_to_one.inc\";i:9;s:40:\"handlers/views_handler_argument_null.inc\";i:10;s:43:\"handlers/views_handler_argument_numeric.inc\";i:11;s:42:\"handlers/views_handler_argument_string.inc\";i:12;s:52:\"handlers/views_handler_argument_group_by_numeric.inc\";i:13;s:32:\"handlers/views_handler_field.inc\";i:14;s:40:\"handlers/views_handler_field_counter.inc\";i:15;s:40:\"handlers/views_handler_field_boolean.inc\";i:16;s:49:\"handlers/views_handler_field_contextual_links.inc\";i:17;s:39:\"handlers/views_handler_field_custom.inc\";i:18;s:37:\"handlers/views_handler_field_date.inc\";i:19;s:39:\"handlers/views_handler_field_entity.inc\";i:20;s:39:\"handlers/views_handler_field_markup.inc\";i:21;s:37:\"handlers/views_handler_field_math.inc\";i:22;s:40:\"handlers/views_handler_field_numeric.inc\";i:23;s:47:\"handlers/views_handler_field_prerender_list.inc\";i:24;s:46:\"handlers/views_handler_field_time_interval.inc\";i:25;s:43:\"handlers/views_handler_field_serialized.inc\";i:26;s:45:\"handlers/views_handler_field_machine_name.inc\";i:27;s:36:\"handlers/views_handler_field_url.inc\";i:28;s:33:\"handlers/views_handler_filter.inc\";i:29;s:50:\"handlers/views_handler_filter_boolean_operator.inc\";i:30;s:57:\"handlers/views_handler_filter_boolean_operator_string.inc\";i:31;s:41:\"handlers/views_handler_filter_combine.inc\";i:32;s:38:\"handlers/views_handler_filter_date.inc\";i:33;s:42:\"handlers/views_handler_filter_equality.inc\";i:34;s:47:\"handlers/views_handler_filter_entity_bundle.inc\";i:35;s:50:\"handlers/views_handler_filter_group_by_numeric.inc\";i:36;s:45:\"handlers/views_handler_filter_in_operator.inc\";i:37;s:45:\"handlers/views_handler_filter_many_to_one.inc\";i:38;s:41:\"handlers/views_handler_filter_numeric.inc\";i:39;s:40:\"handlers/views_handler_filter_string.inc\";i:40;s:39:\"handlers/views_handler_relationship.inc\";i:41;s:53:\"handlers/views_handler_relationship_groupwise_max.inc\";i:42;s:31:\"handlers/views_handler_sort.inc\";i:43;s:36:\"handlers/views_handler_sort_date.inc\";i:44;s:39:\"handlers/views_handler_sort_formula.inc\";i:45;s:48:\"handlers/views_handler_sort_group_by_numeric.inc\";i:46;s:46:\"handlers/views_handler_sort_menu_hierarchy.inc\";i:47;s:38:\"handlers/views_handler_sort_random.inc\";i:48;s:17:\"includes/base.inc\";i:49;s:21:\"includes/handlers.inc\";i:50;s:20:\"includes/plugins.inc\";i:51;s:17:\"includes/view.inc\";i:52;s:60:\"modules/aggregator/views_handler_argument_aggregator_fid.inc\";i:53;s:60:\"modules/aggregator/views_handler_argument_aggregator_iid.inc\";i:54;s:69:\"modules/aggregator/views_handler_argument_aggregator_category_cid.inc\";i:55;s:64:\"modules/aggregator/views_handler_field_aggregator_title_link.inc\";i:56;s:62:\"modules/aggregator/views_handler_field_aggregator_category.inc\";i:57;s:70:\"modules/aggregator/views_handler_field_aggregator_item_description.inc\";i:58;s:57:\"modules/aggregator/views_handler_field_aggregator_xss.inc\";i:59;s:67:\"modules/aggregator/views_handler_filter_aggregator_category_cid.inc\";i:60;s:54:\"modules/aggregator/views_plugin_row_aggregator_rss.inc\";i:61;s:56:\"modules/book/views_plugin_argument_default_book_root.inc\";i:62;s:59:\"modules/comment/views_handler_argument_comment_user_uid.inc\";i:63;s:47:\"modules/comment/views_handler_field_comment.inc\";i:64;s:53:\"modules/comment/views_handler_field_comment_depth.inc\";i:65;s:52:\"modules/comment/views_handler_field_comment_link.inc\";i:66;s:60:\"modules/comment/views_handler_field_comment_link_approve.inc\";i:67;s:59:\"modules/comment/views_handler_field_comment_link_delete.inc\";i:68;s:57:\"modules/comment/views_handler_field_comment_link_edit.inc\";i:69;s:58:\"modules/comment/views_handler_field_comment_link_reply.inc\";i:70;s:57:\"modules/comment/views_handler_field_comment_node_link.inc\";i:71;s:56:\"modules/comment/views_handler_field_comment_username.inc\";i:72;s:61:\"modules/comment/views_handler_field_ncs_last_comment_name.inc\";i:73;s:56:\"modules/comment/views_handler_field_ncs_last_updated.inc\";i:74;s:52:\"modules/comment/views_handler_field_node_comment.inc\";i:75;s:57:\"modules/comment/views_handler_field_node_new_comments.inc\";i:76;s:62:\"modules/comment/views_handler_field_last_comment_timestamp.inc\";i:77;s:57:\"modules/comment/views_handler_filter_comment_user_uid.inc\";i:78;s:57:\"modules/comment/views_handler_filter_ncs_last_updated.inc\";i:79;s:53:\"modules/comment/views_handler_filter_node_comment.inc\";i:80;s:53:\"modules/comment/views_handler_sort_comment_thread.inc\";i:81;s:60:\"modules/comment/views_handler_sort_ncs_last_comment_name.inc\";i:82;s:55:\"modules/comment/views_handler_sort_ncs_last_updated.inc\";i:83;s:48:\"modules/comment/views_plugin_row_comment_rss.inc\";i:84;s:49:\"modules/comment/views_plugin_row_comment_view.inc\";i:85;s:52:\"modules/contact/views_handler_field_contact_link.inc\";i:86;s:43:\"modules/field/views_handler_field_field.inc\";i:87;s:59:\"modules/field/views_handler_relationship_entity_reverse.inc\";i:88;s:51:\"modules/field/views_handler_argument_field_list.inc\";i:89;s:58:\"modules/field/views_handler_argument_field_list_string.inc\";i:90;s:49:\"modules/field/views_handler_filter_field_list.inc\";i:91;s:57:\"modules/filter/views_handler_field_filter_format_name.inc\";i:92;s:52:\"modules/locale/views_handler_field_node_language.inc\";i:93;s:53:\"modules/locale/views_handler_filter_node_language.inc\";i:94;s:54:\"modules/locale/views_handler_argument_locale_group.inc\";i:95;s:57:\"modules/locale/views_handler_argument_locale_language.inc\";i:96;s:51:\"modules/locale/views_handler_field_locale_group.inc\";i:97;s:54:\"modules/locale/views_handler_field_locale_language.inc\";i:98;s:55:\"modules/locale/views_handler_field_locale_link_edit.inc\";i:99;s:52:\"modules/locale/views_handler_filter_locale_group.inc\";i:100;s:55:\"modules/locale/views_handler_filter_locale_language.inc\";i:101;s:54:\"modules/locale/views_handler_filter_locale_version.inc\";i:102;s:53:\"modules/node/views_handler_argument_dates_various.inc\";i:103;s:53:\"modules/node/views_handler_argument_node_language.inc\";i:104;s:48:\"modules/node/views_handler_argument_node_nid.inc\";i:105;s:49:\"modules/node/views_handler_argument_node_type.inc\";i:106;s:48:\"modules/node/views_handler_argument_node_vid.inc\";i:107;s:57:\"modules/node/views_handler_argument_node_uid_revision.inc\";i:108;s:59:\"modules/node/views_handler_field_history_user_timestamp.inc\";i:109;s:41:\"modules/node/views_handler_field_node.inc\";i:110;s:46:\"modules/node/views_handler_field_node_link.inc\";i:111;s:53:\"modules/node/views_handler_field_node_link_delete.inc\";i:112;s:51:\"modules/node/views_handler_field_node_link_edit.inc\";i:113;s:50:\"modules/node/views_handler_field_node_revision.inc\";i:114;s:55:\"modules/node/views_handler_field_node_revision_link.inc\";i:115;s:62:\"modules/node/views_handler_field_node_revision_link_delete.inc\";i:116;s:62:\"modules/node/views_handler_field_node_revision_link_revert.inc\";i:117;s:46:\"modules/node/views_handler_field_node_path.inc\";i:118;s:46:\"modules/node/views_handler_field_node_type.inc\";i:119;s:60:\"modules/node/views_handler_filter_history_user_timestamp.inc\";i:120;s:49:\"modules/node/views_handler_filter_node_access.inc\";i:121;s:49:\"modules/node/views_handler_filter_node_status.inc\";i:122;s:47:\"modules/node/views_handler_filter_node_type.inc\";i:123;s:55:\"modules/node/views_handler_filter_node_uid_revision.inc\";i:124;s:51:\"modules/node/views_plugin_argument_default_node.inc\";i:125;s:52:\"modules/node/views_plugin_argument_validate_node.inc\";i:126;s:42:\"modules/node/views_plugin_row_node_rss.inc\";i:127;s:43:\"modules/node/views_plugin_row_node_view.inc\";i:128;s:52:\"modules/profile/views_handler_field_profile_date.inc\";i:129;s:52:\"modules/profile/views_handler_field_profile_list.inc\";i:130;s:58:\"modules/profile/views_handler_filter_profile_selection.inc\";i:131;s:48:\"modules/search/views_handler_argument_search.inc\";i:132;s:51:\"modules/search/views_handler_field_search_score.inc\";i:133;s:46:\"modules/search/views_handler_filter_search.inc\";i:134;s:50:\"modules/search/views_handler_sort_search_score.inc\";i:135;s:47:\"modules/search/views_plugin_row_search_view.inc\";i:136;s:57:\"modules/statistics/views_handler_field_accesslog_path.inc\";i:137;s:50:\"modules/system/views_handler_argument_file_fid.inc\";i:138;s:43:\"modules/system/views_handler_field_file.inc\";i:139;s:53:\"modules/system/views_handler_field_file_extension.inc\";i:140;s:52:\"modules/system/views_handler_field_file_filemime.inc\";i:141;s:47:\"modules/system/views_handler_field_file_uri.inc\";i:142;s:50:\"modules/system/views_handler_field_file_status.inc\";i:143;s:51:\"modules/system/views_handler_filter_file_status.inc\";i:144;s:52:\"modules/taxonomy/views_handler_argument_taxonomy.inc\";i:145;s:57:\"modules/taxonomy/views_handler_argument_term_node_tid.inc\";i:146;s:63:\"modules/taxonomy/views_handler_argument_term_node_tid_depth.inc\";i:147;s:72:\"modules/taxonomy/views_handler_argument_term_node_tid_depth_modifier.inc\";i:148;s:58:\"modules/taxonomy/views_handler_argument_vocabulary_vid.inc\";i:149;s:67:\"modules/taxonomy/views_handler_argument_vocabulary_machine_name.inc\";i:150;s:49:\"modules/taxonomy/views_handler_field_taxonomy.inc\";i:151;s:54:\"modules/taxonomy/views_handler_field_term_node_tid.inc\";i:152;s:55:\"modules/taxonomy/views_handler_field_term_link_edit.inc\";i:153;s:55:\"modules/taxonomy/views_handler_filter_term_node_tid.inc\";i:154;s:61:\"modules/taxonomy/views_handler_filter_term_node_tid_depth.inc\";i:155;s:56:\"modules/taxonomy/views_handler_filter_vocabulary_vid.inc\";i:156;s:65:\"modules/taxonomy/views_handler_filter_vocabulary_machine_name.inc\";i:157;s:62:\"modules/taxonomy/views_handler_relationship_node_term_data.inc\";i:158;s:65:\"modules/taxonomy/views_plugin_argument_validate_taxonomy_term.inc\";i:159;s:63:\"modules/taxonomy/views_plugin_argument_default_taxonomy_tid.inc\";i:160;s:51:\"modules/system/views_handler_filter_system_type.inc\";i:161;s:56:\"modules/translation/views_handler_argument_node_tnid.inc\";i:162;s:63:\"modules/translation/views_handler_field_node_link_translate.inc\";i:163;s:65:\"modules/translation/views_handler_field_node_translation_link.inc\";i:164;s:54:\"modules/translation/views_handler_filter_node_tnid.inc\";i:165;s:60:\"modules/translation/views_handler_filter_node_tnid_child.inc\";i:166;s:62:\"modules/translation/views_handler_relationship_translation.inc\";i:167;s:48:\"modules/user/views_handler_argument_user_uid.inc\";i:168;s:55:\"modules/user/views_handler_argument_users_roles_rid.inc\";i:169;s:41:\"modules/user/views_handler_field_user.inc\";i:170;s:50:\"modules/user/views_handler_field_user_language.inc\";i:171;s:46:\"modules/user/views_handler_field_user_link.inc\";i:172;s:53:\"modules/user/views_handler_field_user_link_cancel.inc\";i:173;s:51:\"modules/user/views_handler_field_user_link_edit.inc\";i:174;s:46:\"modules/user/views_handler_field_user_mail.inc\";i:175;s:46:\"modules/user/views_handler_field_user_name.inc\";i:176;s:53:\"modules/user/views_handler_field_user_permissions.inc\";i:177;s:49:\"modules/user/views_handler_field_user_picture.inc\";i:178;s:47:\"modules/user/views_handler_field_user_roles.inc\";i:179;s:50:\"modules/user/views_handler_filter_user_current.inc\";i:180;s:47:\"modules/user/views_handler_filter_user_name.inc\";i:181;s:54:\"modules/user/views_handler_filter_user_permissions.inc\";i:182;s:48:\"modules/user/views_handler_filter_user_roles.inc\";i:183;s:59:\"modules/user/views_plugin_argument_default_current_user.inc\";i:184;s:51:\"modules/user/views_plugin_argument_default_user.inc\";i:185;s:52:\"modules/user/views_plugin_argument_validate_user.inc\";i:186;s:43:\"modules/user/views_plugin_row_user_view.inc\";i:187;s:31:\"plugins/views_plugin_access.inc\";i:188;s:36:\"plugins/views_plugin_access_none.inc\";i:189;s:36:\"plugins/views_plugin_access_perm.inc\";i:190;s:36:\"plugins/views_plugin_access_role.inc\";i:191;s:41:\"plugins/views_plugin_argument_default.inc\";i:192;s:45:\"plugins/views_plugin_argument_default_php.inc\";i:193;s:47:\"plugins/views_plugin_argument_default_fixed.inc\";i:194;s:45:\"plugins/views_plugin_argument_default_raw.inc\";i:195;s:42:\"plugins/views_plugin_argument_validate.inc\";i:196;s:50:\"plugins/views_plugin_argument_validate_numeric.inc\";i:197;s:46:\"plugins/views_plugin_argument_validate_php.inc\";i:198;s:30:\"plugins/views_plugin_cache.inc\";i:199;s:35:\"plugins/views_plugin_cache_none.inc\";i:200;s:35:\"plugins/views_plugin_cache_time.inc\";i:201;s:32:\"plugins/views_plugin_display.inc\";i:202;s:43:\"plugins/views_plugin_display_attachment.inc\";i:203;s:38:\"plugins/views_plugin_display_block.inc\";i:204;s:40:\"plugins/views_plugin_display_default.inc\";i:205;s:38:\"plugins/views_plugin_display_embed.inc\";i:206;s:41:\"plugins/views_plugin_display_extender.inc\";i:207;s:37:\"plugins/views_plugin_display_feed.inc\";i:208;s:37:\"plugins/views_plugin_display_page.inc\";i:209;s:43:\"plugins/views_plugin_exposed_form_basic.inc\";i:210;s:37:\"plugins/views_plugin_exposed_form.inc\";i:211;s:52:\"plugins/views_plugin_exposed_form_input_required.inc\";i:212;s:42:\"plugins/views_plugin_localization_core.inc\";i:213;s:37:\"plugins/views_plugin_localization.inc\";i:214;s:42:\"plugins/views_plugin_localization_none.inc\";i:215;s:30:\"plugins/views_plugin_pager.inc\";i:216;s:35:\"plugins/views_plugin_pager_full.inc\";i:217;s:35:\"plugins/views_plugin_pager_mini.inc\";i:218;s:35:\"plugins/views_plugin_pager_none.inc\";i:219;s:35:\"plugins/views_plugin_pager_some.inc\";i:220;s:30:\"plugins/views_plugin_query.inc\";i:221;s:38:\"plugins/views_plugin_query_default.inc\";i:222;s:28:\"plugins/views_plugin_row.inc\";i:223;s:35:\"plugins/views_plugin_row_fields.inc\";i:224;s:39:\"plugins/views_plugin_row_rss_fields.inc\";i:225;s:30:\"plugins/views_plugin_style.inc\";i:226;s:38:\"plugins/views_plugin_style_default.inc\";i:227;s:35:\"plugins/views_plugin_style_grid.inc\";i:228;s:35:\"plugins/views_plugin_style_list.inc\";i:229;s:40:\"plugins/views_plugin_style_jump_menu.inc\";i:230;s:34:\"plugins/views_plugin_style_rss.inc\";i:231;s:38:\"plugins/views_plugin_style_summary.inc\";i:232;s:48:\"plugins/views_plugin_style_summary_jump_menu.inc\";i:233;s:50:\"plugins/views_plugin_style_summary_unformatted.inc\";i:234;s:36:\"plugins/views_plugin_style_table.inc\";i:235;s:43:\"tests/handlers/views_handler_area_text.test\";i:236;s:47:\"tests/handlers/views_handler_argument_null.test\";i:237;s:49:\"tests/handlers/views_handler_argument_string.test\";i:238;s:39:\"tests/handlers/views_handler_field.test\";i:239;s:47:\"tests/handlers/views_handler_field_boolean.test\";i:240;s:46:\"tests/handlers/views_handler_field_custom.test\";i:241;s:47:\"tests/handlers/views_handler_field_counter.test\";i:242;s:44:\"tests/handlers/views_handler_field_date.test\";i:243;s:49:\"tests/handlers/views_handler_field_file_size.test\";i:244;s:44:\"tests/handlers/views_handler_field_math.test\";i:245;s:43:\"tests/handlers/views_handler_field_url.test\";i:246;s:43:\"tests/handlers/views_handler_field_xss.test\";i:247;s:48:\"tests/handlers/views_handler_filter_combine.test\";i:248;s:45:\"tests/handlers/views_handler_filter_date.test\";i:249;s:49:\"tests/handlers/views_handler_filter_equality.test\";i:250;s:52:\"tests/handlers/views_handler_filter_in_operator.test\";i:251;s:48:\"tests/handlers/views_handler_filter_numeric.test\";i:252;s:47:\"tests/handlers/views_handler_filter_string.test\";i:253;s:45:\"tests/handlers/views_handler_sort_random.test\";i:254;s:43:\"tests/handlers/views_handler_sort_date.test\";i:255;s:38:\"tests/handlers/views_handler_sort.test\";i:256;s:60:\"tests/test_plugins/views_test_plugin_access_test_dynamic.inc\";i:257;s:59:\"tests/test_plugins/views_test_plugin_access_test_static.inc\";i:258;s:39:\"tests/plugins/views_plugin_display.test\";i:259;s:46:\"tests/styles/views_plugin_style_jump_menu.test\";i:260;s:36:\"tests/styles/views_plugin_style.test\";i:261;s:48:\"tests/styles/views_plugin_style_unformatted.test\";i:262;s:23:\"tests/views_access.test\";i:263;s:24:\"tests/views_analyze.test\";i:264;s:22:\"tests/views_basic.test\";i:265;s:33:\"tests/views_argument_default.test\";i:266;s:35:\"tests/views_argument_validator.test\";i:267;s:29:\"tests/views_exposed_form.test\";i:268;s:31:\"tests/field/views_fieldapi.test\";i:269;s:25:\"tests/views_glossary.test\";i:270;s:24:\"tests/views_groupby.test\";i:271;s:25:\"tests/views_handlers.test\";i:272;s:23:\"tests/views_module.test\";i:273;s:22:\"tests/views_pager.test\";i:274;s:40:\"tests/views_plugin_localization_test.inc\";i:275;s:29:\"tests/views_translatable.test\";i:276;s:22:\"tests/views_query.test\";i:277;s:24:\"tests/views_upgrade.test\";i:278;s:34:\"tests/views_test.views_default.inc\";i:279;s:58:\"tests/comment/views_handler_argument_comment_user_uid.test\";i:280;s:56:\"tests/comment/views_handler_filter_comment_user_uid.test\";i:281;s:61:\"tests/taxonomy/views_handler_relationship_node_term_data.test\";i:282;s:45:\"tests/user/views_handler_field_user_name.test\";i:283;s:43:\"tests/user/views_user_argument_default.test\";i:284;s:44:\"tests/user/views_user_argument_validate.test\";i:285;s:26:\"tests/user/views_user.test\";i:286;s:22:\"tests/views_cache.test\";i:287;s:21:\"tests/views_view.test\";i:288;s:19:\"tests/views_ui.test\";}s:7:\"version\";s:7:\"7.x-3.5\";s:7:\"project\";s:5:\"views\";s:9:\"datestamp\";s:10:\"1345829394\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/views/views_ui.module','views_ui','module','',1,0,0,0,'a:12:{s:4:\"name\";s:8:\"Views UI\";s:11:\"description\";s:93:\"Administrative interface to views. Without this module, you cannot create or edit your views.\";s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:21:\"admin/structure/views\";s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:5:\"files\";a:2:{i:0;s:15:\"views_ui.module\";i:1;s:57:\"plugins/views_wizard/views_ui_base_views_wizard.class.php\";}s:7:\"version\";s:7:\"7.x-3.5\";s:7:\"project\";s:5:\"views\";s:9:\"datestamp\";s:10:\"1345829394\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/views_php/views_php.module','views_php','module','',1,0,0,0,'a:11:{s:4:\"name\";s:9:\"Views PHP\";s:11:\"description\";s:44:\"Allows the usage of PHP to construct a view.\";s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:5:\"files\";a:9:{i:0;s:40:\"plugins/views/views_php_handler_area.inc\";i:1;s:41:\"plugins/views/views_php_handler_field.inc\";i:2;s:42:\"plugins/views/views_php_handler_filter.inc\";i:3;s:40:\"plugins/views/views_php_handler_sort.inc\";i:4;s:41:\"plugins/views/views_php_plugin_access.inc\";i:5;s:40:\"plugins/views/views_php_plugin_cache.inc\";i:6;s:40:\"plugins/views/views_php_plugin_pager.inc\";i:7;s:40:\"plugins/views/views_php_plugin_query.inc\";i:8;s:42:\"plugins/views/views_php_plugin_wrapper.inc\";}s:7:\"version\";s:11:\"7.x-1.x-dev\";s:7:\"project\";s:9:\"views_php\";s:9:\"datestamp\";s:10:\"1329828512\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contrib/views_watchdog/views_watchdog.module','views_watchdog','module','',1,0,0,0,'a:12:{s:4:\"name\";s:14:\"Views Watchdog\";s:11:\"description\";s:77:\"Allows to create customized lists (pages, blocks, feeds) of watchdog entries.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Views\";s:9:\"configure\";s:21:\"admin/structure/views\";s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:5:\"files\";a:9:{i:0;s:55:\"views/handlers/views_handler_field_watchdog_message.inc\";i:1;s:56:\"views/handlers/views_handler_field_watchdog_severity.inc\";i:2;s:56:\"views/handlers/views_handler_filter_watchdog_message.inc\";i:3;s:57:\"views/handlers/views_handler_filter_watchdog_severity.inc\";i:4;s:53:\"views/handlers/views_handler_filter_watchdog_type.inc\";i:5;s:47:\"views/plugins/views_plugin_row_watchdog_rss.inc\";i:6;s:51:\"views/plugins/views_plugin_style_watchdog_table.inc\";i:7;s:21:\"views/theme/theme.inc\";i:8;s:45:\"views/theme/views-view-watchdog-table.tpl.php\";}s:7:\"version\";s:7:\"7.x-3.3\";s:7:\"project\";s:14:\"views_watchdog\";s:9:\"datestamp\";s:10:\"1322311852\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/custom/ctools_popups/ctools_popups.module','ctools_popups','module','',1,0,0,0,'a:9:{s:4:\"name\";s:13:\"CTools Popups\";s:11:\"description\";s:32:\"Show content using ctools popups\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:11:\"7.x-1.0-dev\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/custom/famc_analytics/famc_analytics.module','famc_analytics','module','',1,0,0,0,'a:10:{s:4:\"name\";s:42:\"Flash accel management console - analytics\";s:11:\"description\";s:81:\"Provides monitoring and analytics features to the Flash Accel Management Console.\";s:12:\"dependencies\";a:2:{i:0;s:18:\"mercury_management\";i:1;s:6:\"ctools\";}s:7:\"version\";s:3:\"7.1\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:30:\"Flash accel management console\";s:3:\"php\";s:91:\"5.3 #Drupal 7 does not have an explicit PHP 5.3 requirement, but we use stuff like closures\";s:7:\"scripts\";a:1:{s:20:\"js/famc_analytics.js\";s:60:\"sites/all/modules/custom/famc_analytics/js/famc_analytics.js\";}s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/custom/famc_drush/famc_drush.module','famc_drush','module','',1,0,0,0,'a:9:{s:4:\"name\";s:47:\"Flash accel management console - Drush commands\";s:11:\"description\";s:71:\"Provides drush commands for running FAMC tasks from the command prompt.\";s:7:\"version\";s:3:\"7.1\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:30:\"Flash accel management console\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/custom/mercury_fmcdb/mercury_fmcdb.module','mercury_fmcdb','module','',1,0,0,0,'a:10:{s:4:\"name\";s:20:\"Flash Accel DB Calls\";s:11:\"description\";s:65:\"Contains functions called in blocks and views in the fmc database\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:11:\"7.x-1.0-dev\";s:14:\"//dependencies\";a:1:{i:0;s:6:\"ctools\";}s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/custom/mercury_management/mercury_management.module','mercury_management','module','',1,0,0,0,'a:9:{s:4:\"name\";s:25:\"Mercury Management Module\";s:11:\"description\";s:28:\"Mercury management utilities\";s:7:\"package\";s:25:\"NetApp Mercury Management\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:0:{}s:7:\"version\";N;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/custom/mercury_utilities/mercury_utilities.module','mercury_utilities','module','',1,0,0,0,'a:11:{s:4:\"name\";s:17:\"Mercury utilities\";s:11:\"description\";s:18:\"Mercury  utilities\";s:7:\"package\";s:25:\"NetApp Mercury Management\";s:12:\"dependencies\";a:1:{i:0;s:18:\"mercury_management\";}s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:20:\"css/progress-bar.css\";s:63:\"sites/all/modules/custom/mercury_utilities/css/progress-bar.css\";}}s:7:\"scripts\";a:3:{s:23:\"js/mercury_utilities.js\";s:66:\"sites/all/modules/custom/mercury_utilities/js/mercury_utilities.js\";s:36:\"js/mercury_utilities_ajax_handler.js\";s:79:\"sites/all/modules/custom/mercury_utilities/js/mercury_utilities_ajax_handler.js\";s:33:\"js/mercury_utilities_discovery.js\";s:76:\"sites/all/modules/custom/mercury_utilities/js/mercury_utilities_discovery.js\";}s:7:\"version\";N;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/custom/zaloni_utilities/zaloni_utilities.module','zaloni_utilities','module','',0,0,0,0,'a:9:{s:4:\"name\";s:16:\"Zaloni Utilities\";s:11:\"description\";s:16:\"Zaloni utilities\";s:7:\"package\";s:25:\"NetApp Mercury Management\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:0:{}s:7:\"version\";N;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/themes/mercury/mercury.info','mercury','theme','themes/engines/phptemplate/phptemplate.engine',1,0,-1,0,'a:18:{s:4:\"name\";s:7:\"Mercury\";s:11:\"description\";s:26:\"Mercury theme for Drupal 7\";s:10:\"screenshot\";s:46:\"sites/all/themes/mercury/images/screenshot.gif\";s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:7:\"mercury\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:14:{s:8:\"page_top\";s:8:\"Page top\";s:16:\"header_top_right\";s:16:\"Header top right\";s:6:\"header\";s:6:\"Header\";s:9:\"highlight\";s:9:\"Highlight\";s:4:\"help\";s:4:\"Help\";s:11:\"title_right\";s:11:\"Title Right\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"sidebar_second\";s:14:\"Second sidebar\";s:6:\"footer\";s:6:\"Footer\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:6:\"search\";i:6;s:7:\"favicon\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:11:\"stylesheets\";a:2:{s:3:\"all\";a:5:{s:15:\"css/default.css\";s:40:\"sites/all/themes/mercury/css/default.css\";s:14:\"css/layout.css\";s:39:\"sites/all/themes/mercury/css/layout.css\";s:13:\"css/style.css\";s:38:\"sites/all/themes/mercury/css/style.css\";s:17:\"css/node-view.css\";s:42:\"sites/all/themes/mercury/css/node-view.css\";s:17:\"css/analytics.css\";s:42:\"sites/all/themes/mercury/css/analytics.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:38:\"sites/all/themes/mercury/css/print.css\";}}s:7:\"scripts\";a:6:{s:19:\"js/jquery-ui.min.js\";s:44:\"sites/all/themes/mercury/js/jquery-ui.min.js\";s:29:\"js/jquery.mCustomScrollbar.js\";s:54:\"sites/all/themes/mercury/js/jquery.mCustomScrollbar.js\";s:27:\"js/jquery.mousewheel.min.js\";s:52:\"sites/all/themes/mercury/js/jquery.mousewheel.min.js\";s:24:\"js/jquery.tablesorter.js\";s:49:\"sites/all/themes/mercury/js/jquery.tablesorter.js\";s:32:\"js/jquery.tablesorter.widgets.js\";s:57:\"sites/all/themes/mercury/js/jquery.tablesorter.widgets.js\";s:14:\"js/function.js\";s:39:\"sites/all/themes/mercury/js/function.js\";}s:7:\"compass\";a:3:{s:6:\"status\";s:1:\"1\";s:8:\"sass_dir\";s:4:\"sass\";s:7:\"css_dir\";s:3:\"css\";}s:8:\"settings\";a:4:{s:12:\"mercury_tabs\";s:1:\"1\";s:28:\"mercury_breadcrumb_separator\";s:2:\"»\";s:14:\"wireframe_mode\";s:1:\"0\";s:14:\"clear_registry\";s:1:\"0\";}s:7:\"version\";s:7:\"7.x-2.1\";s:9:\"datestamp\";s:10:\"1334122542\";s:3:\"php\";s:5:\"5.2.4\";s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}'),('themes/bartik/bartik.info','bartik','theme','themes/engines/phptemplate/phptemplate.engine',1,0,-1,0,'a:18:{s:4:\"name\";s:6:\"Bartik\";s:11:\"description\";s:48:\"A flexible, recolorable theme with many regions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:7:\"regions\";a:20:{s:6:\"header\";s:6:\"Header\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"triptych_first\";s:14:\"Triptych first\";s:15:\"triptych_middle\";s:15:\"Triptych middle\";s:13:\"triptych_last\";s:13:\"Triptych last\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"0\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:28:\"themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}'),('themes/garland/garland.info','garland','theme','themes/engines/phptemplate/phptemplate.engine',0,0,-1,0,'a:18:{s:4:\"name\";s:7:\"Garland\";s:11:\"description\";s:111:\"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:8:\"settings\";a:1:{s:13:\"garland_width\";s:5:\"fluid\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:29:\"themes/garland/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}'),('themes/seven/seven.info','seven','theme','themes/engines/phptemplate/phptemplate.engine',1,0,-1,0,'a:18:{s:4:\"name\";s:5:\"Seven\";s:11:\"description\";s:65:\"A simple one-column, tableless, fluid width administration theme.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"1\";}s:7:\"regions\";a:8:{s:7:\"content\";s:7:\"Content\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}'),('themes/stark/stark.info','stark','theme','themes/engines/phptemplate/phptemplate.engine',0,0,-1,0,'a:17:{s:4:\"name\";s:5:\"Stark\";s:11:\"description\";s:208:\"This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.16\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1350508567\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/stark/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:3:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}'),('sites/all/modules/contrib/views_data_export/views_data_export.module','views_data_export','module','',1,0,7100,0,'a:11:{s:4:\"name\";s:17:\"Views Data Export\";s:11:\"description\";s:53:\"Plugin to export views data into various file formats\";s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:25:{i:0;s:24:\"views_data_export.module\";i:1;s:51:\"plugins/views_data_export_plugin_display_export.inc\";i:2;s:49:\"plugins/views_data_export_plugin_style_export.inc\";i:3;s:53:\"plugins/views_data_export_plugin_style_export_csv.inc\";i:4;s:53:\"plugins/views_data_export_plugin_style_export_doc.inc\";i:5;s:53:\"plugins/views_data_export_plugin_style_export_txt.inc\";i:6;s:53:\"plugins/views_data_export_plugin_style_export_xls.inc\";i:7;s:53:\"plugins/views_data_export_plugin_style_export_xml.inc\";i:8;s:33:\"theme/views_data_export.theme.inc\";i:9;s:40:\"theme/views-data-export-csv-body.tpl.php\";i:10;s:42:\"theme/views-data-export-csv-footer.tpl.php\";i:11;s:42:\"theme/views-data-export-csv-header.tpl.php\";i:12;s:40:\"theme/views-data-export-doc-body.tpl.php\";i:13;s:42:\"theme/views-data-export-doc-footer.tpl.php\";i:14;s:42:\"theme/views-data-export-doc-header.tpl.php\";i:15;s:40:\"theme/views-data-export-txt-body.tpl.php\";i:16;s:42:\"theme/views-data-export-txt-footer.tpl.php\";i:17;s:42:\"theme/views-data-export-txt-header.tpl.php\";i:18;s:40:\"theme/views-data-export-xls-body.tpl.php\";i:19;s:42:\"theme/views-data-export-xls-footer.tpl.php\";i:20;s:42:\"theme/views-data-export-xls-header.tpl.php\";i:21;s:40:\"theme/views-data-export-xml-body.tpl.php\";i:22;s:42:\"theme/views-data-export-xml-footer.tpl.php\";i:23;s:42:\"theme/views-data-export-xml-header.tpl.php\";i:24;s:31:\"theme/views-data-export.tpl.php\";}s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:7:\"version\";s:13:\"7.x-3.0-beta6\";s:7:\"project\";s:17:\"views_data_export\";s:9:\"datestamp\";s:10:\"1336632688\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/custom/famc_asup/famc_asup.module','famc_asup','module','',1,0,0,0,'a:9:{s:4:\"name\";s:25:\"Flash accel - AutoSupport\";s:11:\"description\";s:32:\"Adds AutoSupport to Flash Accel.\";s:12:\"dependencies\";a:2:{i:0;s:18:\"mercury_management\";i:1;s:6:\"ctools\";}s:7:\"version\";s:3:\"7.1\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:30:\"Flash accel management console\";s:3:\"php\";s:91:\"5.3 #Drupal 7 does not have an explicit PHP 5.3 requirement, but we use stuff like closures\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}');
/*!40000 ALTER TABLE `system` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `taxonomy_index`
--

DROP TABLE IF EXISTS `taxonomy_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxonomy_index` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid this record tracks.',
  `tid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The term ID.',
  `sticky` tinyint(4) DEFAULT '0' COMMENT 'Boolean indicating whether the node is sticky.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the node was created.',
  KEY `term_node` (`tid`,`sticky`,`created`),
  KEY `nid` (`nid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Maintains denormalized information about node/term...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxonomy_index`
--

LOCK TABLES `taxonomy_index` WRITE;
/*!40000 ALTER TABLE `taxonomy_index` DISABLE KEYS */;
/*!40000 ALTER TABLE `taxonomy_index` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `taxonomy_term_data`
--

DROP TABLE IF EXISTS `taxonomy_term_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxonomy_term_data` (
  `tid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique term ID.',
  `vid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The taxonomy_vocabulary.vid of the vocabulary to which the term is assigned.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The term name.',
  `description` longtext COMMENT 'A description of the term.',
  `format` varchar(255) DEFAULT NULL COMMENT 'The filter_format.format of the description.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The weight of this term in relation to other terms.',
  PRIMARY KEY (`tid`),
  KEY `taxonomy_tree` (`vid`,`weight`,`name`),
  KEY `vid_name` (`vid`,`name`),
  KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores term information.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxonomy_term_data`
--

LOCK TABLES `taxonomy_term_data` WRITE;
/*!40000 ALTER TABLE `taxonomy_term_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `taxonomy_term_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `taxonomy_term_hierarchy`
--

DROP TABLE IF EXISTS `taxonomy_term_hierarchy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxonomy_term_hierarchy` (
  `tid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: The taxonomy_term_data.tid of the term.',
  `parent` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: The taxonomy_term_data.tid of the term’s parent. 0 indicates no parent.',
  PRIMARY KEY (`tid`,`parent`),
  KEY `parent` (`parent`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores the hierarchical relationship between terms.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxonomy_term_hierarchy`
--

LOCK TABLES `taxonomy_term_hierarchy` WRITE;
/*!40000 ALTER TABLE `taxonomy_term_hierarchy` DISABLE KEYS */;
/*!40000 ALTER TABLE `taxonomy_term_hierarchy` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `taxonomy_vocabulary`
--

DROP TABLE IF EXISTS `taxonomy_vocabulary`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxonomy_vocabulary` (
  `vid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique vocabulary ID.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'Name of the vocabulary.',
  `machine_name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The vocabulary machine name.',
  `description` longtext COMMENT 'Description of the vocabulary.',
  `hierarchy` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'The type of hierarchy allowed within the vocabulary. (0 = disabled, 1 = single, 2 = multiple)',
  `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'The module which created the vocabulary.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The weight of this vocabulary in relation to other vocabularies.',
  PRIMARY KEY (`vid`),
  UNIQUE KEY `machine_name` (`machine_name`),
  KEY `list` (`weight`,`name`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COMMENT='Stores vocabulary information.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxonomy_vocabulary`
--

LOCK TABLES `taxonomy_vocabulary` WRITE;
/*!40000 ALTER TABLE `taxonomy_vocabulary` DISABLE KEYS */;
INSERT INTO `taxonomy_vocabulary` VALUES (1,'Tags','tags','Use tags to group articles on similar topics into categories.',0,'taxonomy',0);
/*!40000 ALTER TABLE `taxonomy_vocabulary` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `url_alias`
--

DROP TABLE IF EXISTS `url_alias`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `url_alias` (
  `pid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'A unique path alias identifier.',
  `source` varchar(255) NOT NULL DEFAULT '' COMMENT 'The Drupal path this alias is for; e.g. node/12.',
  `alias` varchar(255) NOT NULL DEFAULT '' COMMENT 'The alias for this path; e.g. title-of-the-story.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The language this alias is for; if ’und’, the alias will be used for unknown languages. Each Drupal path can have an alias for each supported language.',
  PRIMARY KEY (`pid`),
  KEY `alias_language_pid` (`alias`,`language`,`pid`),
  KEY `source_language_pid` (`source`,`language`,`pid`)
) ENGINE=MyISAM AUTO_INCREMENT=221862 DEFAULT CHARSET=utf8 COMMENT='A list of URL aliases for Drupal paths; a user may visit...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `url_alias`
--

LOCK TABLES `url_alias` WRITE;
/*!40000 ALTER TABLE `url_alias` DISABLE KEYS */;
INSERT INTO `url_alias` VALUES (2785,'user/1','users/fmcadmin','und'),(2796,'user/9','users/admin','und'),(20636,'node/1','vcenter/fmc-barium-test','und');
/*!40000 ALTER TABLE `url_alias` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `users`
--

DROP TABLE IF EXISTS `users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `users` (
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: Unique user ID.',
  `name` varchar(60) NOT NULL DEFAULT '' COMMENT 'Unique user name.',
  `pass` varchar(128) NOT NULL DEFAULT '' COMMENT 'User’s password (hashed).',
  `mail` varchar(254) DEFAULT '' COMMENT 'User’s e-mail address.',
  `theme` varchar(255) NOT NULL DEFAULT '' COMMENT 'User’s default theme.',
  `signature` varchar(255) NOT NULL DEFAULT '' COMMENT 'User’s signature.',
  `signature_format` varchar(255) DEFAULT NULL COMMENT 'The filter_format.format of the signature.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp for when user was created.',
  `access` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp for previous time user accessed the site.',
  `login` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp for user’s last login.',
  `status` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Whether the user is active(1) or blocked(0).',
  `timezone` varchar(32) DEFAULT NULL COMMENT 'User’s time zone.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'User’s default language.',
  `picture` int(11) NOT NULL DEFAULT '0' COMMENT 'Foreign key: file_managed.fid of user’s picture.',
  `init` varchar(254) DEFAULT '' COMMENT 'E-mail address used for initial account creation.',
  `data` longblob COMMENT 'A serialized array of name value pairs that are related to the user. Any form values posted during user edit are stored and are loaded into the $user object during user_load(). Use of this field is discouraged and it will likely disappear in a future...',
  PRIMARY KEY (`uid`),
  UNIQUE KEY `name` (`name`),
  KEY `access` (`access`),
  KEY `created` (`created`),
  KEY `mail` (`mail`),
  KEY `picture` (`picture`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores user data.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `users`
--

LOCK TABLES `users` WRITE;
/*!40000 ALTER TABLE `users` DISABLE KEYS */;
INSERT INTO `users` VALUES (0,'','','','','',NULL,0,0,0,0,NULL,'',0,'',NULL),(1,'fmcadmin','$S$D73Is1cdQKOvxU0LwIeFJtwb/Ti02an4ti5kgPic1oQb8Qf/pOAo','ppbordoloi@zaloni.com','','','filtered_html',1348575358,1371656251,1371645175,1,'America/New_York','',0,'support@zaloni.com','b:0;'),(9,'admin','$S$DGIkLwNSymMcsppnIsYlj8quy4MzVhAQRangEHX0zTIKUtM825cZ','support@netapp.com','','','filtered_html',1352934896,1371586083,1371586083,1,'America/New_York','',0,'manager@test.com','b:0;');
/*!40000 ALTER TABLE `users` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `users_roles`
--

DROP TABLE IF EXISTS `users_roles`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `users_roles` (
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: users.uid for user.',
  `rid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: role.rid for role.',
  PRIMARY KEY (`uid`,`rid`),
  KEY `rid` (`rid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Maps users to roles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `users_roles`
--

LOCK TABLES `users_roles` WRITE;
/*!40000 ALTER TABLE `users_roles` DISABLE KEYS */;
INSERT INTO `users_roles` VALUES (1,3);
/*!40000 ALTER TABLE `users_roles` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `variable`
--

DROP TABLE IF EXISTS `variable`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `variable` (
  `name` varchar(128) NOT NULL DEFAULT '' COMMENT 'The name of the variable.',
  `value` longblob NOT NULL COMMENT 'The value of the variable.',
  PRIMARY KEY (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Named variable/value pairs created by Drupal core or any...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `variable`
--

LOCK TABLES `variable` WRITE;
/*!40000 ALTER TABLE `variable` DISABLE KEYS */;
INSERT INTO `variable` VALUES ('additional_settings__active_tab_data_center','s:13:\"edit-workflow\";'),('additional_settings__active_tab_device','s:12:\"edit-comment\";'),('additional_settings__active_tab_host','s:15:\"edit-submission\";'),('additional_settings__active_tab_vcenter','s:12:\"edit-comment\";'),('additional_settings__active_tab_vdisk','s:15:\"edit-submission\";'),('additional_settings__active_tab_vdisk_metrics','s:17:\"edit-unique-field\";'),('additional_settings__active_tab_virtual_machine','s:12:\"edit-comment\";'),('additional_settings__active_tab_vm_cache_space','s:12:\"edit-comment\";'),('additional_settings__active_tab_vm_metrics','s:17:\"edit-unique-field\";'),('admin_menu_cache_client','i:0;'),('admin_menu_devel_modules_skip','a:4:{s:11:\"admin_devel\";i:0;s:5:\"coder\";i:0;s:8:\"field_ui\";i:0;s:8:\"views_ui\";i:0;}'),('admin_menu_margin_top','i:1;'),('admin_menu_position_fixed','i:0;'),('admin_menu_tweak_modules','i:0;'),('admin_menu_tweak_permissions','i:0;'),('admin_menu_tweak_tabs','i:0;'),('admin_theme','s:5:\"seven\";'),('anonymous','s:9:\"Anonymous\";'),('block_cache','i:0;'),('cache','i:0;'),('cache_lifetime','s:1:\"0\";'),('clean_url','i:1;'),('comment_anonymous_data_center','i:0;'),('comment_anonymous_device','i:0;'),('comment_anonymous_host','i:0;'),('comment_anonymous_vcenter','i:0;'),('comment_anonymous_vdisk','i:0;'),('comment_anonymous_vdisk_metrics','i:0;'),('comment_anonymous_virtual_machine','i:0;'),('comment_anonymous_vm_cache_space','i:0;'),('comment_anonymous_vm_metrics','i:0;'),('comment_data_center','s:1:\"1\";'),('comment_default_mode_data_center','i:1;'),('comment_default_mode_device','i:1;'),('comment_default_mode_host','i:1;'),('comment_default_mode_vcenter','i:1;'),('comment_default_mode_vdisk','i:1;'),('comment_default_mode_vdisk_metrics','i:1;'),('comment_default_mode_virtual_machine','i:1;'),('comment_default_mode_vm_cache_space','i:1;'),('comment_default_mode_vm_metrics','i:0;'),('comment_default_per_page_data_center','s:2:\"50\";'),('comment_default_per_page_device','s:2:\"50\";'),('comment_default_per_page_host','s:2:\"50\";'),('comment_default_per_page_vcenter','s:2:\"50\";'),('comment_default_per_page_vdisk','s:2:\"50\";'),('comment_default_per_page_vdisk_metrics','s:2:\"50\";'),('comment_default_per_page_virtual_machine','s:2:\"50\";'),('comment_default_per_page_vm_cache_space','s:2:\"50\";'),('comment_default_per_page_vm_metrics','s:2:\"50\";'),('comment_device','s:1:\"1\";'),('comment_form_location_data_center','i:1;'),('comment_form_location_device','i:1;'),('comment_form_location_host','i:1;'),('comment_form_location_vcenter','i:1;'),('comment_form_location_vdisk','i:1;'),('comment_form_location_vdisk_metrics','i:1;'),('comment_form_location_virtual_machine','i:1;'),('comment_form_location_vm_cache_space','i:1;'),('comment_form_location_vm_metrics','i:1;'),('comment_host','s:1:\"2\";'),('comment_page','i:0;'),('comment_preview_data_center','s:1:\"1\";'),('comment_preview_device','s:1:\"0\";'),('comment_preview_host','s:1:\"1\";'),('comment_preview_vcenter','s:1:\"1\";'),('comment_preview_vdisk','s:1:\"1\";'),('comment_preview_vdisk_metrics','s:1:\"0\";'),('comment_preview_virtual_machine','s:1:\"1\";'),('comment_preview_vm_cache_space','s:1:\"0\";'),('comment_preview_vm_metrics','s:1:\"0\";'),('comment_subject_field_data_center','i:1;'),('comment_subject_field_device','i:1;'),('comment_subject_field_host','i:1;'),('comment_subject_field_vcenter','i:1;'),('comment_subject_field_vdisk','i:1;'),('comment_subject_field_vdisk_metrics','i:1;'),('comment_subject_field_virtual_machine','i:1;'),('comment_subject_field_vm_cache_space','i:1;'),('comment_subject_field_vm_metrics','i:1;'),('comment_vcenter','s:1:\"1\";'),('comment_vdisk','s:1:\"2\";'),('comment_vdisk_metrics','s:1:\"2\";'),('comment_virtual_machine','s:1:\"1\";'),('comment_vm_cache_space','s:1:\"1\";'),('comment_vm_metrics','s:1:\"1\";'),('configurable_timezones','i:1;'),('cron_key','s:43:\"JxNjJOu4fHMbSYddHvzVdVKO8oHeOQIjxIF4OQBeWvM\";'),('cron_last','i:1371656281;'),('cron_safe_threshold','s:4:\"3600\";'),('css_js_query_string','s:6:\"moncs7\";'),('ctools_last_cron','i:1423220281;'),('date_api_version','s:3:\"7.2\";'),('date_default_timezone','s:16:\"America/New_York\";'),('date_first_day','s:1:\"1\";'),('dblog_row_limit','s:4:\"1000\";'),('default_field_group','a:7:{s:34:\"group_metrics|node|vm_metrics|form\";b:0;s:27:\"group_device|node|host|form\";b:0;s:54:\"group_flash_accel_attributes|node|virtual_machine|form\";b:0;s:37:\"group_metrics|node|vdisk_metrics|form\";b:0;s:33:\"group_flash_accel|node|vdisk|form\";b:0;s:42:\"group_vm_vmotion|node|virtual_machine|form\";b:0;s:41:\"group_vm_reboot|node|virtual_machine|form\";b:0;}'),('default_nodes_main','s:2:\"10\";'),('drupal_http_request_fails','b:0;'),('drupal_private_key','s:43:\"fYPoSrj4dClirpvSy8wNfcG4Gj3V8qb8BBa94ipjN-c\";'),('email__active_tab','s:24:\"edit-email-admin-created\";'),('empty_timezone_message','i:0;'),('entityreference:base-tables','a:9:{s:7:\"comment\";a:2:{i:0;s:7:\"comment\";i:1;s:3:\"cid\";}s:4:\"node\";a:2:{i:0;s:4:\"node\";i:1;s:3:\"nid\";}s:17:\"search_api_server\";a:2:{i:0;s:17:\"search_api_server\";i:1;s:2:\"id\";}s:16:\"search_api_index\";a:2:{i:0;s:16:\"search_api_index\";i:1;s:2:\"id\";}s:15:\"search_api_page\";a:2:{i:0;s:15:\"search_api_page\";i:1;s:2:\"id\";}s:4:\"file\";a:2:{i:0;s:12:\"file_managed\";i:1;s:3:\"fid\";}s:13:\"taxonomy_term\";a:2:{i:0;s:18:\"taxonomy_term_data\";i:1;s:3:\"tid\";}s:19:\"taxonomy_vocabulary\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:3:\"vid\";}s:4:\"user\";a:2:{i:0;s:5:\"users\";i:1;s:3:\"uid\";}}'),('error_level','s:1:\"0\";'),('famc_cron_last_reset','i:6;'),('field_bundle_settings_node__data_center','a:2:{s:10:\"view_modes\";a:0:{}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:1:{s:5:\"title\";a:1:{s:6:\"weight\";s:2:\"-5\";}}s:7:\"display\";a:0:{}}}'),('field_bundle_settings_node__device','a:2:{s:10:\"view_modes\";a:0:{}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:2:{s:5:\"title\";a:1:{s:6:\"weight\";s:1:\"0\";}s:4:\"path\";a:1:{s:6:\"weight\";s:2:\"30\";}}s:7:\"display\";a:0:{}}}'),('field_bundle_settings_node__host','a:2:{s:10:\"view_modes\";a:0:{}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:2:{s:5:\"title\";a:1:{s:6:\"weight\";s:1:\"0\";}s:4:\"path\";a:1:{s:6:\"weight\";s:2:\"30\";}}s:7:\"display\";a:0:{}}}'),('field_bundle_settings_node__vcenter','a:2:{s:10:\"view_modes\";a:0:{}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:2:{s:5:\"title\";a:1:{s:6:\"weight\";s:1:\"0\";}s:4:\"path\";a:1:{s:6:\"weight\";s:1:\"6\";}}s:7:\"display\";a:0:{}}}'),('field_bundle_settings_node__vdisk','a:2:{s:10:\"view_modes\";a:0:{}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:2:{s:5:\"title\";a:1:{s:6:\"weight\";s:1:\"0\";}s:4:\"path\";a:1:{s:6:\"weight\";s:1:\"8\";}}s:7:\"display\";a:0:{}}}'),('field_bundle_settings_node__vdisk_metrics','a:2:{s:10:\"view_modes\";a:6:{s:6:\"teaser\";a:1:{s:15:\"custom_settings\";b:1;}s:4:\"full\";a:1:{s:15:\"custom_settings\";b:0;}s:3:\"rss\";a:1:{s:15:\"custom_settings\";b:0;}s:12:\"search_index\";a:1:{s:15:\"custom_settings\";b:0;}s:13:\"search_result\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:2:{s:5:\"title\";a:1:{s:6:\"weight\";s:1:\"0\";}s:4:\"path\";a:1:{s:6:\"weight\";s:1:\"1\";}}s:7:\"display\";a:0:{}}}'),('field_bundle_settings_node__virtual_machine','a:2:{s:10:\"view_modes\";a:6:{s:6:\"teaser\";a:1:{s:15:\"custom_settings\";b:1;}s:4:\"full\";a:1:{s:15:\"custom_settings\";b:0;}s:3:\"rss\";a:1:{s:15:\"custom_settings\";b:0;}s:12:\"search_index\";a:1:{s:15:\"custom_settings\";b:0;}s:13:\"search_result\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:2:{s:5:\"title\";a:1:{s:6:\"weight\";s:1:\"0\";}s:4:\"path\";a:1:{s:6:\"weight\";s:2:\"16\";}}s:7:\"display\";a:2:{s:24:\"vm_metrics_entity_view_1\";a:1:{s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"9\";s:7:\"visible\";b:1;}}s:33:\"vdisk_metric_per_vm_entity_view_1\";a:1:{s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"8\";s:7:\"visible\";b:1;}}}}}'),('field_bundle_settings_node__vm_cache_space','a:2:{s:10:\"view_modes\";a:0:{}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:2:{s:5:\"title\";a:1:{s:6:\"weight\";s:1:\"0\";}s:4:\"path\";a:1:{s:6:\"weight\";s:1:\"1\";}}s:7:\"display\";a:0:{}}}'),('field_bundle_settings_node__vm_metrics','a:2:{s:10:\"view_modes\";a:0:{}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:2:{s:5:\"title\";a:1:{s:6:\"weight\";s:1:\"0\";}s:4:\"path\";a:1:{s:6:\"weight\";s:1:\"1\";}}s:7:\"display\";a:0:{}}}'),('file_default_scheme','s:6:\"public\";'),('file_private_path','s:4:\"/tmp\";'),('file_public_path','s:19:\"sites/default/files\";'),('file_temporary_path','s:4:\"/tmp\";'),('filter_fallback_format','s:10:\"plain_text\";'),('host_0','i:0;'),('host_1','i:0;'),('host_10','i:0;'),('host_10.231.1.141','i:0;'),('host_10.231.1.142','i:0;'),('host_11','i:0;'),('host_12','i:0;'),('host_13','i:0;'),('host_2','s:32:\"hg-x3690-4.gdl.englab.netapp.com\";'),('host_3','s:32:\"hg-x3690-1.gdl.englab.netapp.com\";'),('host_4','i:0;'),('host_5','i:0;'),('host_6','i:0;'),('host_7','i:0;'),('host_8','i:0;'),('host_9','i:0;'),('host_esxi-vm1.gdl.englab.netapp.com','i:0;'),('host_esxi-vm2.gdl.englab.netapp.com','i:0;'),('host_esxi-vm3.gdl.englab.netapp.com','i:0;'),('host_hg-c220-1.gdl.englab.netapp.com','i:0;'),('host_hg-d620-1.gdl.englab.netapp.com','i:0;'),('host_hg-rx300-1.gdl.englab.netapp.com','i:0;'),('host_hg-rx300-2.gdl.englab.netapp.com','i:0;'),('host_hg-rx300-5.gdl.englab.netapp.com','i:0;'),('host_hg-rx300-7.gdl.englab.netapp.com','i:0;'),('host_hg-rx300-8.gdl.englab.netapp.com','i:0;'),('host_hg-x3690-1.gdl.englab.netapp.com','i:0;'),('host_hg-x3690-4.gdl.englab.netapp.com','i:0;'),('install_profile','s:8:\"standard\";'),('install_task','s:4:\"done\";'),('install_time','i:1348575533;'),('logintoboggan_confirm_email_at_registration','s:1:\"0\";'),('logintoboggan_immediate_login_on_register','i:1;'),('logintoboggan_login_successful_message','s:1:\"0\";'),('logintoboggan_login_with_email','s:1:\"0\";'),('logintoboggan_minimum_password_length','s:1:\"0\";'),('logintoboggan_override_destination_parameter','i:1;'),('logintoboggan_pre_auth_role','s:1:\"2\";'),('logintoboggan_purge_unvalidated_user_interval','s:1:\"0\";'),('logintoboggan_redirect_on_confirm','s:0:\"\";'),('logintoboggan_redirect_on_register','s:0:\"\";'),('logintoboggan_unified_login','i:0;'),('maintenance_mode','i:0;'),('maintenance_mode_message','s:118:\"Flash Accel Management Console is currently under maintenance. We should be back shortly. Thank you for your patience.\";'),('menu_expanded','a:0:{}'),('menu_masks','a:40:{i:0;i:493;i:1;i:247;i:2;i:246;i:3;i:245;i:4;i:125;i:5;i:124;i:6;i:123;i:7;i:122;i:8;i:121;i:9;i:117;i:10;i:88;i:11;i:63;i:12;i:62;i:13;i:61;i:14;i:60;i:15;i:59;i:16;i:58;i:17;i:56;i:18;i:48;i:19;i:46;i:20;i:44;i:21;i:31;i:22;i:30;i:23;i:29;i:24;i:28;i:25;i:24;i:26;i:22;i:27;i:21;i:28;i:15;i:29;i:14;i:30;i:13;i:31;i:12;i:32;i:11;i:33;i:10;i:34;i:7;i:35;i:6;i:36;i:5;i:37;i:3;i:38;i:2;i:39;i:1;}'),('menu_options_data_center','a:1:{i:0;s:9:\"main-menu\";}'),('menu_options_device','a:1:{i:0;s:9:\"main-menu\";}'),('menu_options_host','a:1:{i:0;s:9:\"main-menu\";}'),('menu_options_vcenter','a:1:{i:0;s:9:\"main-menu\";}'),('menu_options_vdisk','a:1:{i:0;s:9:\"main-menu\";}'),('menu_options_vdisk_metrics','a:1:{i:0;s:9:\"main-menu\";}'),('menu_options_virtual_machine','a:1:{i:0;s:9:\"main-menu\";}'),('menu_options_vm_cache_space','a:1:{i:0;s:9:\"main-menu\";}'),('menu_options_vm_metrics','a:0:{}'),('menu_parent_data_center','s:11:\"main-menu:0\";'),('menu_parent_device','s:11:\"main-menu:0\";'),('menu_parent_host','s:11:\"main-menu:0\";'),('menu_parent_vcenter','s:11:\"main-menu:0\";'),('menu_parent_vdisk','s:11:\"main-menu:0\";'),('menu_parent_vdisk_metrics','s:11:\"main-menu:0\";'),('menu_parent_virtual_machine','s:11:\"main-menu:0\";'),('menu_parent_vm_cache_space','s:11:\"main-menu:0\";'),('menu_parent_vm_metrics','s:11:\"main-menu:0\";'),('minimum_cache_space_vm','s:1:\"1\";'),('minimum_word_size','s:1:\"3\";'),('node_admin_theme','i:1;'),('node_cron_last','s:10:\"1371656281\";'),('node_options_data_center','a:1:{i:0;s:6:\"status\";}'),('node_options_device','a:1:{i:0;s:6:\"status\";}'),('node_options_host','a:2:{i:0;s:6:\"status\";i:1;s:7:\"promote\";}'),('node_options_page','a:1:{i:0;s:6:\"status\";}'),('node_options_vcenter','a:1:{i:0;s:6:\"status\";}'),('node_options_vdisk','a:2:{i:0;s:6:\"status\";i:1;s:7:\"promote\";}'),('node_options_vdisk_metrics','a:1:{i:0;s:6:\"status\";}'),('node_options_virtual_machine','a:1:{i:0;s:6:\"status\";}'),('node_options_vm_cache_space','a:1:{i:0;s:6:\"status\";}'),('node_options_vm_metrics','a:1:{i:0;s:6:\"status\";}'),('node_preview_data_center','s:1:\"0\";'),('node_preview_device','s:1:\"0\";'),('node_preview_host','s:1:\"1\";'),('node_preview_vcenter','s:1:\"0\";'),('node_preview_vdisk','s:1:\"1\";'),('node_preview_vdisk_metrics','s:1:\"0\";'),('node_preview_virtual_machine','s:1:\"0\";'),('node_preview_vm_cache_space','s:1:\"1\";'),('node_preview_vm_metrics','s:1:\"0\";'),('node_rank_comments','s:1:\"0\";'),('node_rank_promote','s:1:\"0\";'),('node_rank_recent','s:1:\"0\";'),('node_rank_relevance','s:1:\"0\";'),('node_rank_sticky','s:1:\"0\";'),('node_submitted_data_center','i:0;'),('node_submitted_device','i:0;'),('node_submitted_host','i:1;'),('node_submitted_page','b:0;'),('node_submitted_vcenter','i:0;'),('node_submitted_vdisk','i:1;'),('node_submitted_vdisk_metrics','i:0;'),('node_submitted_virtual_machine','i:0;'),('node_submitted_vm_cache_space','i:1;'),('node_submitted_vm_metrics','i:0;'),('overlap_cjk','i:1;'),('page_cache_maximum_age','s:1:\"0\";'),('page_compression','i:1;'),('password','s:6:\"netapp\";'),('pathauto_blog_pattern','s:17:\"blogs/[user:name]\";'),('pathauto_forum_pattern','s:29:\"[term:vocabulary]/[term:name]\";'),('pathauto_node_article_pattern','s:0:\"\";'),('pathauto_node_data_center_pattern','s:24:\"data-center/[node:title]\";'),('pathauto_node_device_pattern','s:19:\"device/[node:title]\";'),('pathauto_node_host_pattern','s:17:\"host/[node:title]\";'),('pathauto_node_page_pattern','s:12:\"[node:title]\";'),('pathauto_node_panel_pattern','s:0:\"\";'),('pathauto_node_pattern','s:20:\"content/[node:title]\";'),('pathauto_node_vcenter_pattern','s:20:\"vcenter/[node:title]\";'),('pathauto_node_vdisk_pattern','s:18:\"vdisk/[node:title]\";'),('pathauto_node_virtual_machine_pattern','s:28:\"virtual-machine/[node:title]\";'),('pathauto_punctuation_hyphen','i:1;'),('pathauto_taxonomy_term_pattern','s:29:\"[term:vocabulary]/[term:name]\";'),('pathauto_taxonomy_term_tags_pattern','s:0:\"\";'),('pathauto_user_pattern','s:17:\"users/[user:name]\";'),('path_alias_whitelist','a:2:{s:4:\"node\";b:1;s:4:\"user\";b:1;}'),('preprocess_css','i:1;'),('preprocess_js','i:0;'),('r4032login_access_denied_message','s:48:\"Access denied. You must login to view this page.\";'),('r4032login_display_denied_message','i:1;'),('r4032login_redirect_authenticated_users_to','s:0:\"\";'),('redesc_cron_hour','s:1:\"0\";'),('rediscover_start','s:0:\"\";'),('save_continue_data_center','s:19:\"Save and add fields\";'),('save_continue_device','s:19:\"Save and add fields\";'),('save_continue_host','s:19:\"Save and add fields\";'),('save_continue_vcenter','s:19:\"Save and add fields\";'),('save_continue_vdisk','s:19:\"Save and add fields\";'),('save_continue_vdisk_metrics','s:19:\"Save and add fields\";'),('save_continue_virtual_machine','s:19:\"Save and add fields\";'),('save_continue_vm_cache_space','s:19:\"Save and add fields\";'),('save_continue_vm_metrics','s:19:\"Save and add fields\";'),('search_active_modules','a:2:{s:4:\"node\";s:4:\"node\";s:4:\"user\";i:0;}');
INSERT INTO `variable` VALUES ('search_api_tasks','a:1:{s:26:\"default_fuzzysearch_server\";a:1:{s:25:\"default_fuzzysearch_index\";a:95885:{i:0;s:8:\"delete-2\";i:1;s:8:\"delete-3\";i:2;s:8:\"delete-4\";i:3;s:8:\"delete-5\";i:4;s:8:\"delete-6\";i:5;s:8:\"delete-7\";i:6;s:8:\"delete-8\";i:7;s:8:\"delete-9\";i:8;s:9:\"delete-10\";i:9;s:9:\"delete-11\";i:10;s:9:\"delete-12\";i:11;s:9:\"delete-13\";i:12;s:9:\"delete-14\";i:13;s:9:\"delete-15\";i:14;s:9:\"delete-16\";i:15;s:9:\"delete-17\";i:16;s:9:\"delete-18\";i:17;s:9:\"delete-19\";i:18;s:9:\"delete-20\";i:19;s:9:\"delete-21\";i:20;s:9:\"delete-22\";i:21;s:9:\"delete-23\";i:22;s:9:\"delete-24\";i:23;s:9:\"delete-25\";i:24;s:9:\"delete-26\";i:25;s:9:\"delete-27\";i:26;s:9:\"delete-28\";i:27;s:9:\"delete-29\";i:28;s:9:\"delete-30\";i:29;s:9:\"delete-31\";i:30;s:9:\"delete-32\";i:31;s:9:\"delete-33\";i:32;s:9:\"delete-34\";i:33;s:9:\"delete-35\";i:34;s:9:\"delete-36\";i:35;s:9:\"delete-37\";i:36;s:9:\"delete-38\";i:37;s:9:\"delete-39\";i:38;s:9:\"delete-40\";i:39;s:9:\"delete-41\";i:40;s:9:\"delete-42\";i:41;s:9:\"delete-43\";i:42;s:9:\"delete-44\";i:43;s:9:\"delete-45\";i:44;s:9:\"delete-46\";i:45;s:9:\"delete-47\";i:46;s:9:\"delete-48\";i:47;s:9:\"delete-49\";i:48;s:9:\"delete-50\";i:49;s:9:\"delete-51\";i:50;s:9:\"delete-52\";i:51;s:9:\"delete-53\";i:52;s:9:\"delete-54\";i:53;s:9:\"delete-55\";i:54;s:9:\"delete-56\";i:55;s:9:\"delete-57\";i:56;s:9:\"delete-58\";i:57;s:9:\"delete-59\";i:58;s:9:\"delete-60\";i:59;s:9:\"delete-61\";i:60;s:9:\"delete-62\";i:61;s:9:\"delete-63\";i:62;s:9:\"delete-64\";i:63;s:9:\"delete-65\";i:64;s:9:\"delete-66\";i:65;s:9:\"delete-67\";i:66;s:9:\"delete-68\";i:67;s:9:\"delete-69\";i:68;s:9:\"delete-70\";i:69;s:9:\"delete-71\";i:70;s:9:\"delete-72\";i:71;s:9:\"delete-73\";i:72;s:9:\"delete-74\";i:73;s:9:\"delete-75\";i:74;s:9:\"delete-76\";i:75;s:9:\"delete-77\";i:76;s:9:\"delete-78\";i:77;s:9:\"delete-79\";i:78;s:9:\"delete-80\";i:79;s:9:\"delete-81\";i:80;s:9:\"delete-82\";i:81;s:9:\"delete-83\";i:82;s:9:\"delete-84\";i:83;s:9:\"delete-85\";i:84;s:9:\"delete-86\";i:85;s:9:\"delete-87\";i:86;s:9:\"delete-88\";i:87;s:9:\"delete-89\";i:88;s:9:\"delete-90\";i:89;s:9:\"delete-91\";i:90;s:9:\"delete-92\";i:91;s:9:\"delete-93\";i:92;s:9:\"delete-94\";i:93;s:9:\"delete-95\";i:94;s:9:\"delete-96\";i:95;s:9:\"delete-97\";i:96;s:9:\"delete-98\";i:97;s:9:\"delete-99\";i:98;s:10:\"delete-100\";i:99;s:10:\"delete-101\";i:100;s:10:\"delete-102\";i:101;s:10:\"delete-103\";i:102;s:10:\"delete-104\";i:103;s:10:\"delete-105\";i:104;s:10:\"delete-106\";i:105;s:10:\"delete-107\";i:106;s:10:\"delete-108\";i:107;s:10:\"delete-109\";i:108;s:10:\"delete-110\";i:109;s:10:\"delete-111\";i:110;s:10:\"delete-112\";i:111;s:10:\"delete-113\";i:112;s:10:\"delete-114\";i:113;s:10:\"delete-115\";i:114;s:10:\"delete-116\";i:115;s:10:\"delete-117\";i:116;s:10:\"delete-118\";i:117;s:10:\"delete-119\";i:118;s:10:\"delete-120\";i:119;s:10:\"delete-121\";i:120;s:10:\"delete-122\";i:121;s:10:\"delete-123\";i:122;s:10:\"delete-124\";i:123;s:10:\"delete-125\";i:124;s:10:\"delete-126\";i:125;s:10:\"delete-127\";i:126;s:10:\"delete-128\";i:127;s:10:\"delete-129\";i:128;s:10:\"delete-130\";i:129;s:10:\"delete-131\";i:130;s:10:\"delete-132\";i:131;s:10:\"delete-133\";i:132;s:10:\"delete-134\";i:133;s:10:\"delete-135\";i:134;s:10:\"delete-136\";i:135;s:10:\"delete-137\";i:136;s:10:\"delete-138\";i:137;s:10:\"delete-139\";i:138;s:10:\"delete-140\";i:139;s:10:\"delete-141\";i:140;s:10:\"delete-142\";i:141;s:10:\"delete-143\";i:142;s:10:\"delete-144\";i:143;s:10:\"delete-145\";i:144;s:10:\"delete-146\";i:145;s:10:\"delete-147\";i:146;s:10:\"delete-148\";i:147;s:10:\"delete-149\";i:148;s:10:\"delete-150\";i:149;s:10:\"delete-151\";i:150;s:10:\"delete-152\";i:151;s:10:\"delete-153\";i:152;s:10:\"delete-154\";i:153;s:10:\"delete-155\";i:154;s:10:\"delete-156\";i:155;s:10:\"delete-157\";i:156;s:10:\"delete-158\";i:157;s:10:\"delete-159\";i:158;s:10:\"delete-160\";i:159;s:10:\"delete-161\";i:160;s:10:\"delete-162\";i:161;s:10:\"delete-163\";i:162;s:10:\"delete-164\";i:163;s:10:\"delete-165\";i:164;s:10:\"delete-166\";i:165;s:10:\"delete-167\";i:166;s:10:\"delete-168\";i:167;s:10:\"delete-169\";i:168;s:10:\"delete-170\";i:169;s:10:\"delete-171\";i:170;s:10:\"delete-172\";i:171;s:10:\"delete-173\";i:172;s:10:\"delete-174\";i:173;s:10:\"delete-175\";i:174;s:10:\"delete-176\";i:175;s:10:\"delete-177\";i:176;s:10:\"delete-178\";i:177;s:10:\"delete-179\";i:178;s:10:\"delete-180\";i:179;s:10:\"delete-181\";i:180;s:10:\"delete-182\";i:181;s:10:\"delete-183\";i:182;s:10:\"delete-184\";i:183;s:10:\"delete-185\";i:184;s:10:\"delete-186\";i:185;s:10:\"delete-187\";i:186;s:10:\"delete-188\";i:187;s:10:\"delete-189\";i:188;s:10:\"delete-190\";i:189;s:10:\"delete-191\";i:190;s:10:\"delete-192\";i:191;s:10:\"delete-193\";i:192;s:10:\"delete-194\";i:193;s:10:\"delete-195\";i:194;s:10:\"delete-196\";i:195;s:10:\"delete-197\";i:196;s:10:\"delete-198\";i:197;s:10:\"delete-199\";i:198;s:10:\"delete-200\";i:199;s:10:\"delete-201\";i:200;s:10:\"delete-202\";i:201;s:10:\"delete-203\";i:202;s:10:\"delete-204\";i:203;s:10:\"delete-205\";i:204;s:10:\"delete-206\";i:205;s:10:\"delete-207\";i:206;s:10:\"delete-208\";i:207;s:10:\"delete-209\";i:208;s:10:\"delete-210\";i:209;s:10:\"delete-211\";i:210;s:10:\"delete-212\";i:211;s:10:\"delete-213\";i:212;s:10:\"delete-214\";i:213;s:10:\"delete-215\";i:214;s:10:\"delete-216\";i:215;s:10:\"delete-217\";i:216;s:10:\"delete-218\";i:217;s:10:\"delete-219\";i:218;s:10:\"delete-220\";i:219;s:10:\"delete-221\";i:220;s:10:\"delete-222\";i:221;s:10:\"delete-223\";i:222;s:10:\"delete-224\";i:223;s:10:\"delete-225\";i:224;s:10:\"delete-226\";i:225;s:10:\"delete-227\";i:226;s:10:\"delete-228\";i:227;s:10:\"delete-229\";i:228;s:10:\"delete-230\";i:229;s:10:\"delete-231\";i:230;s:10:\"delete-232\";i:231;s:10:\"delete-233\";i:232;s:10:\"delete-234\";i:233;s:10:\"delete-235\";i:234;s:10:\"delete-236\";i:235;s:10:\"delete-237\";i:236;s:10:\"delete-238\";i:237;s:10:\"delete-239\";i:238;s:10:\"delete-240\";i:239;s:10:\"delete-241\";i:240;s:10:\"delete-242\";i:241;s:10:\"delete-243\";i:242;s:10:\"delete-244\";i:243;s:10:\"delete-245\";i:244;s:10:\"delete-246\";i:245;s:10:\"delete-247\";i:246;s:10:\"delete-248\";i:247;s:10:\"delete-249\";i:248;s:10:\"delete-250\";i:249;s:10:\"delete-251\";i:250;s:10:\"delete-252\";i:251;s:10:\"delete-253\";i:252;s:10:\"delete-254\";i:253;s:10:\"delete-255\";i:254;s:10:\"delete-256\";i:255;s:10:\"delete-257\";i:256;s:10:\"delete-258\";i:257;s:10:\"delete-259\";i:258;s:10:\"delete-260\";i:259;s:10:\"delete-261\";i:260;s:10:\"delete-262\";i:261;s:10:\"delete-263\";i:262;s:10:\"delete-264\";i:263;s:10:\"delete-265\";i:264;s:10:\"delete-266\";i:265;s:10:\"delete-267\";i:266;s:10:\"delete-268\";i:267;s:10:\"delete-269\";i:268;s:10:\"delete-270\";i:269;s:10:\"delete-271\";i:270;s:10:\"delete-272\";i:271;s:10:\"delete-273\";i:272;s:10:\"delete-274\";i:273;s:10:\"delete-275\";i:274;s:10:\"delete-276\";i:275;s:10:\"delete-277\";i:276;s:10:\"delete-278\";i:277;s:10:\"delete-279\";i:278;s:10:\"delete-280\";i:279;s:10:\"delete-281\";i:280;s:10:\"delete-282\";i:281;s:10:\"delete-283\";i:282;s:10:\"delete-284\";i:283;s:10:\"delete-285\";i:284;s:10:\"delete-286\";i:285;s:10:\"delete-287\";i:286;s:10:\"delete-288\";i:287;s:10:\"delete-289\";i:288;s:10:\"delete-290\";i:289;s:10:\"delete-291\";i:290;s:10:\"delete-292\";i:291;s:10:\"delete-293\";i:292;s:10:\"delete-294\";i:293;s:10:\"delete-295\";i:294;s:10:\"delete-296\";i:295;s:10:\"delete-297\";i:296;s:10:\"delete-298\";i:297;s:10:\"delete-299\";i:298;s:10:\"delete-300\";i:299;s:10:\"delete-301\";i:300;s:10:\"delete-302\";i:301;s:10:\"delete-303\";i:302;s:10:\"delete-304\";i:303;s:10:\"delete-305\";i:304;s:10:\"delete-306\";i:305;s:10:\"delete-307\";i:306;s:10:\"delete-308\";i:307;s:10:\"delete-309\";i:308;s:10:\"delete-310\";i:309;s:10:\"delete-311\";i:310;s:10:\"delete-312\";i:311;s:10:\"delete-313\";i:312;s:10:\"delete-314\";i:313;s:10:\"delete-315\";i:314;s:10:\"delete-316\";i:315;s:10:\"delete-317\";i:316;s:10:\"delete-318\";i:317;s:10:\"delete-319\";i:318;s:10:\"delete-320\";i:319;s:10:\"delete-321\";i:320;s:10:\"delete-322\";i:321;s:10:\"delete-323\";i:322;s:10:\"delete-324\";i:323;s:10:\"delete-325\";i:324;s:10:\"delete-326\";i:325;s:10:\"delete-327\";i:326;s:10:\"delete-328\";i:327;s:10:\"delete-329\";i:328;s:10:\"delete-330\";i:329;s:10:\"delete-331\";i:330;s:10:\"delete-332\";i:331;s:10:\"delete-333\";i:332;s:10:\"delete-334\";i:333;s:10:\"delete-335\";i:334;s:10:\"delete-336\";i:335;s:10:\"delete-337\";i:336;s:10:\"delete-338\";i:337;s:10:\"delete-339\";i:338;s:10:\"delete-340\";i:339;s:10:\"delete-341\";i:340;s:10:\"delete-342\";i:341;s:10:\"delete-343\";i:342;s:10:\"delete-344\";i:343;s:10:\"delete-345\";i:344;s:10:\"delete-346\";i:345;s:10:\"delete-347\";i:346;s:10:\"delete-348\";i:347;s:10:\"delete-349\";i:348;s:10:\"delete-350\";i:349;s:10:\"delete-351\";i:350;s:10:\"delete-352\";i:351;s:10:\"delete-353\";i:352;s:10:\"delete-354\";i:353;s:10:\"delete-355\";i:354;s:10:\"delete-356\";i:355;s:10:\"delete-357\";i:356;s:10:\"delete-358\";i:357;s:10:\"delete-359\";i:358;s:10:\"delete-360\";i:359;s:10:\"delete-361\";i:360;s:10:\"delete-362\";i:361;s:10:\"delete-363\";i:362;s:10:\"delete-364\";i:363;s:10:\"delete-365\";i:364;s:10:\"delete-366\";i:365;s:10:\"delete-367\";i:366;s:10:\"delete-368\";i:367;s:10:\"delete-369\";i:368;s:10:\"delete-370\";i:369;s:10:\"delete-371\";i:370;s:10:\"delete-372\";i:371;s:10:\"delete-373\";i:372;s:10:\"delete-374\";i:373;s:10:\"delete-375\";i:374;s:10:\"delete-376\";i:375;s:10:\"delete-377\";i:376;s:10:\"delete-378\";i:377;s:10:\"delete-379\";i:378;s:10:\"delete-380\";i:379;s:10:\"delete-381\";i:380;s:10:\"delete-382\";i:381;s:10:\"delete-383\";i:382;s:10:\"delete-384\";i:383;s:10:\"delete-385\";i:384;s:10:\"delete-386\";i:385;s:10:\"delete-387\";i:386;s:10:\"delete-388\";i:387;s:10:\"delete-389\";i:388;s:10:\"delete-390\";i:389;s:10:\"delete-391\";i:390;s:10:\"delete-392\";i:391;s:10:\"delete-393\";i:392;s:10:\"delete-394\";i:393;s:10:\"delete-395\";i:394;s:10:\"delete-396\";i:395;s:10:\"delete-397\";i:396;s:10:\"delete-398\";i:397;s:10:\"delete-399\";i:398;s:10:\"delete-400\";i:399;s:10:\"delete-401\";i:400;s:10:\"delete-402\";i:401;s:10:\"delete-403\";i:402;s:10:\"delete-404\";i:403;s:10:\"delete-405\";i:404;s:10:\"delete-406\";i:405;s:10:\"delete-407\";i:406;s:10:\"delete-408\";i:407;s:10:\"delete-409\";i:408;s:10:\"delete-410\";i:409;s:10:\"delete-411\";i:410;s:10:\"delete-412\";i:411;s:10:\"delete-413\";i:412;s:10:\"delete-414\";i:413;s:10:\"delete-415\";i:414;s:10:\"delete-416\";i:415;s:10:\"delete-417\";i:416;s:10:\"delete-418\";i:417;s:10:\"delete-419\";i:418;s:10:\"delete-420\";i:419;s:10:\"delete-421\";i:420;s:10:\"delete-422\";i:421;s:10:\"delete-423\";i:422;s:10:\"delete-424\";i:423;s:10:\"delete-425\";i:424;s:10:\"delete-426\";i:425;s:10:\"delete-427\";i:426;s:10:\"delete-428\";i:427;s:10:\"delete-429\";i:428;s:10:\"delete-430\";i:429;s:10:\"delete-431\";i:430;s:10:\"delete-432\";i:431;s:10:\"delete-433\";i:432;s:10:\"delete-434\";i:433;s:10:\"delete-435\";i:434;s:10:\"delete-436\";i:435;s:10:\"delete-437\";i:436;s:10:\"delete-438\";i:437;s:10:\"delete-439\";i:438;s:10:\"delete-440\";i:439;s:10:\"delete-441\";i:440;s:10:\"delete-442\";i:441;s:10:\"delete-443\";i:442;s:10:\"delete-444\";i:443;s:10:\"delete-445\";i:444;s:10:\"delete-446\";i:445;s:10:\"delete-447\";i:446;s:10:\"delete-448\";i:447;s:10:\"delete-449\";i:448;s:10:\"delete-450\";i:449;s:10:\"delete-451\";i:450;s:10:\"delete-452\";i:451;s:10:\"delete-453\";i:452;s:10:\"delete-454\";i:453;s:10:\"delete-455\";i:454;s:10:\"delete-456\";i:455;s:10:\"delete-457\";i:456;s:10:\"delete-458\";i:457;s:10:\"delete-459\";i:458;s:10:\"delete-460\";i:459;s:10:\"delete-461\";i:460;s:10:\"delete-462\";i:461;s:10:\"delete-463\";i:462;s:10:\"delete-464\";i:463;s:10:\"delete-465\";i:464;s:10:\"delete-466\";i:465;s:10:\"delete-467\";i:466;s:10:\"delete-468\";i:467;s:10:\"delete-469\";i:468;s:10:\"delete-470\";i:469;s:10:\"delete-471\";i:470;s:10:\"delete-472\";i:471;s:10:\"delete-473\";i:472;s:10:\"delete-474\";i:473;s:10:\"delete-475\";i:474;s:10:\"delete-476\";i:475;s:10:\"delete-477\";i:476;s:10:\"delete-478\";i:477;s:10:\"delete-479\";i:478;s:10:\"delete-480\";i:479;s:10:\"delete-481\";i:480;s:10:\"delete-482\";i:481;s:10:\"delete-483\";i:482;s:10:\"delete-484\";i:483;s:10:\"delete-485\";i:484;s:10:\"delete-486\";i:485;s:10:\"delete-487\";i:486;s:10:\"delete-488\";i:487;s:10:\"delete-489\";i:488;s:10:\"delete-490\";i:489;s:10:\"delete-491\";i:490;s:10:\"delete-492\";i:491;s:10:\"delete-493\";i:492;s:10:\"delete-494\";i:493;s:10:\"delete-495\";i:494;s:10:\"delete-496\";i:495;s:10:\"delete-497\";i:496;s:10:\"delete-498\";i:497;s:10:\"delete-499\";i:498;s:10:\"delete-500\";i:499;s:10:\"delete-501\";i:500;s:10:\"delete-502\";i:501;s:10:\"delete-503\";i:502;s:10:\"delete-504\";i:503;s:10:\"delete-505\";i:504;s:10:\"delete-506\";i:505;s:10:\"delete-507\";i:506;s:10:\"delete-508\";i:507;s:10:\"delete-509\";i:508;s:10:\"delete-510\";i:509;s:10:\"delete-511\";i:510;s:10:\"delete-512\";i:511;s:10:\"delete-513\";i:512;s:10:\"delete-514\";i:513;s:10:\"delete-515\";i:514;s:10:\"delete-516\";i:515;s:10:\"delete-517\";i:516;s:10:\"delete-518\";i:517;s:10:\"delete-519\";i:518;s:10:\"delete-520\";i:519;s:10:\"delete-521\";i:520;s:10:\"delete-522\";i:521;s:10:\"delete-523\";i:522;s:10:\"delete-524\";i:523;s:10:\"delete-525\";i:524;s:10:\"delete-526\";i:525;s:10:\"delete-527\";i:526;s:10:\"delete-528\";i:527;s:10:\"delete-529\";i:528;s:10:\"delete-530\";i:529;s:10:\"delete-531\";i:530;s:10:\"delete-532\";i:531;s:10:\"delete-533\";i:532;s:10:\"delete-534\";i:533;s:10:\"delete-535\";i:534;s:10:\"delete-536\";i:535;s:10:\"delete-537\";i:536;s:10:\"delete-538\";i:537;s:10:\"delete-539\";i:538;s:10:\"delete-540\";i:539;s:10:\"delete-541\";i:540;s:10:\"delete-542\";i:541;s:10:\"delete-543\";i:542;s:10:\"delete-544\";i:543;s:10:\"delete-545\";i:544;s:10:\"delete-546\";i:545;s:10:\"delete-547\";i:546;s:10:\"delete-548\";i:547;s:10:\"delete-549\";i:548;s:10:\"delete-550\";i:549;s:10:\"delete-551\";i:550;s:10:\"delete-552\";i:551;s:10:\"delete-553\";i:552;s:10:\"delete-554\";i:553;s:10:\"delete-555\";i:554;s:10:\"delete-556\";i:555;s:10:\"delete-557\";i:556;s:10:\"delete-558\";i:557;s:10:\"delete-559\";i:558;s:10:\"delete-560\";i:559;s:10:\"delete-561\";i:560;s:10:\"delete-562\";i:561;s:10:\"delete-563\";i:562;s:10:\"delete-564\";i:563;s:10:\"delete-565\";i:564;s:10:\"delete-566\";i:565;s:10:\"delete-567\";i:566;s:10:\"delete-568\";i:567;s:10:\"delete-569\";i:568;s:10:\"delete-570\";i:569;s:10:\"delete-571\";i:570;s:10:\"delete-572\";i:571;s:10:\"delete-573\";i:572;s:10:\"delete-574\";i:573;s:10:\"delete-575\";i:574;s:10:\"delete-576\";i:575;s:10:\"delete-577\";i:576;s:10:\"delete-578\";i:577;s:10:\"delete-579\";i:578;s:10:\"delete-580\";i:579;s:10:\"delete-581\";i:580;s:10:\"delete-582\";i:581;s:10:\"delete-583\";i:582;s:10:\"delete-584\";i:583;s:10:\"delete-585\";i:584;s:10:\"delete-586\";i:585;s:10:\"delete-587\";i:586;s:10:\"delete-588\";i:587;s:10:\"delete-589\";i:588;s:10:\"delete-590\";i:589;s:10:\"delete-591\";i:590;s:10:\"delete-592\";i:591;s:10:\"delete-593\";i:592;s:10:\"delete-594\";i:593;s:10:\"delete-595\";i:594;s:10:\"delete-596\";i:595;s:10:\"delete-597\";i:596;s:10:\"delete-598\";i:597;s:10:\"delete-599\";i:598;s:10:\"delete-600\";i:599;s:10:\"delete-601\";i:600;s:10:\"delete-602\";i:601;s:10:\"delete-603\";i:602;s:10:\"delete-604\";i:603;s:10:\"delete-605\";i:604;s:10:\"delete-606\";i:605;s:10:\"delete-607\";i:606;s:10:\"delete-608\";i:607;s:10:\"delete-609\";i:608;s:10:\"delete-610\";i:609;s:10:\"delete-611\";i:610;s:10:\"delete-612\";i:611;s:10:\"delete-613\";i:612;s:10:\"delete-614\";i:613;s:10:\"delete-615\";i:614;s:10:\"delete-616\";i:615;s:10:\"delete-617\";i:616;s:10:\"delete-618\";i:617;s:10:\"delete-619\";i:618;s:10:\"delete-620\";i:619;s:10:\"delete-621\";i:620;s:10:\"delete-622\";i:621;s:10:\"delete-623\";i:622;s:10:\"delete-624\";i:623;s:10:\"delete-625\";i:624;s:10:\"delete-626\";i:625;s:10:\"delete-627\";i:626;s:10:\"delete-628\";i:627;s:10:\"delete-629\";i:628;s:10:\"delete-630\";i:629;s:10:\"delete-631\";i:630;s:10:\"delete-632\";i:631;s:10:\"delete-633\";i:632;s:10:\"delete-634\";i:633;s:10:\"delete-635\";i:634;s:10:\"delete-636\";i:635;s:10:\"delete-637\";i:636;s:10:\"delete-638\";i:637;s:10:\"delete-639\";i:638;s:10:\"delete-640\";i:639;s:10:\"delete-641\";i:640;s:10:\"delete-642\";i:641;s:10:\"delete-643\";i:642;s:10:\"delete-644\";i:643;s:10:\"delete-645\";i:644;s:10:\"delete-646\";i:645;s:10:\"delete-647\";i:646;s:10:\"delete-648\";i:647;s:10:\"delete-649\";i:648;s:10:\"delete-650\";i:649;s:10:\"delete-651\";i:650;s:10:\"delete-652\";i:651;s:10:\"delete-653\";i:652;s:10:\"delete-654\";i:653;s:10:\"delete-655\";i:654;s:10:\"delete-656\";i:655;s:10:\"delete-657\";i:656;s:10:\"delete-658\";i:657;s:10:\"delete-659\";i:658;s:10:\"delete-660\";i:659;s:10:\"delete-661\";i:660;s:10:\"delete-662\";i:661;s:10:\"delete-663\";i:662;s:10:\"delete-664\";i:663;s:10:\"delete-665\";i:664;s:10:\"delete-666\";i:665;s:10:\"delete-667\";i:666;s:10:\"delete-668\";i:667;s:10:\"delete-669\";i:668;s:10:\"delete-670\";i:669;s:10:\"delete-671\";i:670;s:10:\"delete-672\";i:671;s:10:\"delete-673\";i:672;s:10:\"delete-674\";i:673;s:10:\"delete-675\";i:674;s:10:\"delete-676\";i:675;s:10:\"delete-677\";i:676;s:10:\"delete-678\";i:677;s:10:\"delete-679\";i:678;s:10:\"delete-680\";i:679;s:10:\"delete-681\";i:680;s:10:\"delete-682\";i:681;s:10:\"delete-683\";i:682;s:10:\"delete-684\";i:683;s:10:\"delete-685\";i:684;s:10:\"delete-686\";i:685;s:10:\"delete-687\";i:686;s:10:\"delete-688\";i:687;s:10:\"delete-689\";i:688;s:10:\"delete-690\";i:689;s:10:\"delete-691\";i:690;s:10:\"delete-692\";i:691;s:10:\"delete-693\";i:692;s:10:\"delete-694\";i:693;s:10:\"delete-695\";i:694;s:10:\"delete-696\";i:695;s:10:\"delete-697\";i:696;s:10:\"delete-698\";i:697;s:10:\"delete-699\";i:698;s:10:\"delete-700\";i:699;s:10:\"delete-701\";i:700;s:10:\"delete-702\";i:701;s:10:\"delete-703\";i:702;s:10:\"delete-704\";i:703;s:10:\"delete-705\";i:704;s:10:\"delete-706\";i:705;s:10:\"delete-707\";i:706;s:10:\"delete-708\";i:707;s:10:\"delete-709\";i:708;s:10:\"delete-710\";i:709;s:10:\"delete-711\";i:710;s:10:\"delete-712\";i:711;s:10:\"delete-713\";i:712;s:10:\"delete-714\";i:713;s:10:\"delete-715\";i:714;s:10:\"delete-716\";i:715;s:10:\"delete-717\";i:716;s:10:\"delete-718\";i:717;s:10:\"delete-719\";i:718;s:10:\"delete-720\";i:719;s:10:\"delete-721\";i:720;s:10:\"delete-722\";i:721;s:10:\"delete-723\";i:722;s:10:\"delete-724\";i:723;s:10:\"delete-725\";i:724;s:10:\"delete-726\";i:725;s:10:\"delete-727\";i:726;s:10:\"delete-728\";i:727;s:10:\"delete-729\";i:728;s:10:\"delete-730\";i:729;s:10:\"delete-731\";i:730;s:10:\"delete-732\";i:731;s:10:\"delete-733\";i:732;s:10:\"delete-734\";i:733;s:10:\"delete-735\";i:734;s:10:\"delete-736\";i:735;s:10:\"delete-737\";i:736;s:10:\"delete-738\";i:737;s:10:\"delete-739\";i:738;s:10:\"delete-740\";i:739;s:10:\"delete-741\";i:740;s:10:\"delete-742\";i:741;s:10:\"delete-743\";i:742;s:10:\"delete-744\";i:743;s:10:\"delete-745\";i:744;s:10:\"delete-746\";i:745;s:10:\"delete-747\";i:746;s:10:\"delete-748\";i:747;s:10:\"delete-749\";i:748;s:10:\"delete-750\";i:749;s:10:\"delete-751\";i:750;s:10:\"delete-752\";i:751;s:10:\"delete-753\";i:752;s:10:\"delete-754\";i:753;s:10:\"delete-755\";i:754;s:10:\"delete-756\";i:755;s:10:\"delete-757\";i:756;s:10:\"delete-758\";i:757;s:10:\"delete-759\";i:758;s:10:\"delete-760\";i:759;s:10:\"delete-761\";i:760;s:10:\"delete-762\";i:761;s:10:\"delete-763\";i:762;s:10:\"delete-764\";i:763;s:10:\"delete-765\";i:764;s:10:\"delete-766\";i:765;s:10:\"delete-767\";i:766;s:10:\"delete-768\";i:767;s:10:\"delete-769\";i:768;s:10:\"delete-770\";i:769;s:10:\"delete-771\";i:770;s:10:\"delete-772\";i:771;s:10:\"delete-773\";i:772;s:10:\"delete-774\";i:773;s:10:\"delete-775\";i:774;s:10:\"delete-776\";i:775;s:10:\"delete-777\";i:776;s:10:\"delete-778\";i:777;s:10:\"delete-779\";i:778;s:10:\"delete-780\";i:779;s:10:\"delete-781\";i:780;s:10:\"delete-782\";i:781;s:10:\"delete-783\";i:782;s:10:\"delete-784\";i:783;s:10:\"delete-785\";i:784;s:10:\"delete-786\";i:785;s:10:\"delete-787\";i:786;s:10:\"delete-788\";i:787;s:10:\"delete-789\";i:788;s:10:\"delete-790\";i:789;s:10:\"delete-791\";i:790;s:10:\"delete-792\";i:791;s:10:\"delete-793\";i:792;s:10:\"delete-794\";i:793;s:10:\"delete-795\";i:794;s:10:\"delete-796\";i:795;s:10:\"delete-797\";i:796;s:10:\"delete-798\";i:797;s:10:\"delete-799\";i:798;s:10:\"delete-800\";i:799;s:10:\"delete-801\";i:800;s:10:\"delete-802\";i:801;s:10:\"delete-803\";i:802;s:10:\"delete-804\";i:803;s:10:\"delete-805\";i:804;s:10:\"delete-806\";i:805;s:10:\"delete-807\";i:806;s:10:\"delete-808\";i:807;s:10:\"delete-809\";i:808;s:10:\"delete-810\";i:809;s:10:\"delete-811\";i:810;s:10:\"delete-812\";i:811;s:10:\"delete-813\";i:812;s:10:\"delete-814\";i:813;s:10:\"delete-815\";i:814;s:10:\"delete-816\";i:815;s:10:\"delete-817\";i:816;s:10:\"delete-818\";i:817;s:10:\"delete-819\";i:818;s:10:\"delete-820\";i:819;s:10:\"delete-821\";i:820;s:10:\"delete-822\";i:821;s:10:\"delete-823\";i:822;s:10:\"delete-824\";i:823;s:10:\"delete-825\";i:824;s:10:\"delete-826\";i:825;s:10:\"delete-827\";i:826;s:10:\"delete-828\";i:827;s:10:\"delete-829\";i:828;s:10:\"delete-830\";i:829;s:10:\"delete-831\";i:830;s:10:\"delete-832\";i:831;s:10:\"delete-833\";i:832;s:10:\"delete-834\";i:833;s:10:\"delete-835\";i:834;s:10:\"delete-836\";i:835;s:10:\"delete-837\";i:836;s:10:\"delete-838\";i:837;s:10:\"delete-839\";i:838;s:10:\"delete-840\";i:839;s:10:\"delete-841\";i:840;s:10:\"delete-842\";i:841;s:10:\"delete-843\";i:842;s:10:\"delete-844\";i:843;s:10:\"delete-845\";i:844;s:10:\"delete-846\";i:845;s:10:\"delete-847\";i:846;s:10:\"delete-848\";i:847;s:10:\"delete-849\";i:848;s:10:\"delete-850\";i:849;s:10:\"delete-851\";i:850;s:10:\"delete-852\";i:851;s:10:\"delete-853\";i:852;s:10:\"delete-854\";i:853;s:10:\"delete-855\";i:854;s:10:\"delete-856\";i:855;s:10:\"delete-857\";i:856;s:10:\"delete-858\";i:857;s:10:\"delete-859\";i:858;s:10:\"delete-860\";i:859;s:10:\"delete-861\";i:860;s:10:\"delete-862\";i:861;s:10:\"delete-863\";i:862;s:10:\"delete-864\";i:863;s:10:\"delete-865\";i:864;s:10:\"delete-866\";i:865;s:10:\"delete-867\";i:866;s:10:\"delete-868\";i:867;s:10:\"delete-869\";i:868;s:10:\"delete-870\";i:869;s:10:\"delete-871\";i:870;s:10:\"delete-872\";i:871;s:10:\"delete-873\";i:872;s:10:\"delete-874\";i:873;s:10:\"delete-875\";i:874;s:10:\"delete-876\";i:875;s:10:\"delete-877\";i:876;s:10:\"delete-878\";i:877;s:10:\"delete-879\";i:878;s:10:\"delete-880\";i:879;s:10:\"delete-881\";i:880;s:10:\"delete-882\";i:881;s:10:\"delete-883\";i:882;s:10:\"delete-884\";i:883;s:10:\"delete-885\";i:884;s:10:\"delete-886\";i:885;s:10:\"delete-887\";i:886;s:10:\"delete-888\";i:887;s:10:\"delete-889\";i:888;s:10:\"delete-890\";i:889;s:10:\"delete-891\";i:890;s:10:\"delete-892\";i:891;s:10:\"delete-893\";i:892;s:10:\"delete-894\";i:893;s:10:\"delete-895\";i:894;s:10:\"delete-896\";i:895;s:10:\"delete-897\";i:896;s:10:\"delete-898\";i:897;s:10:\"delete-899\";i:898;s:10:\"delete-900\";i:899;s:10:\"delete-901\";i:900;s:10:\"delete-902\";i:901;s:10:\"delete-903\";i:902;s:10:\"delete-904\";i:903;s:10:\"delete-905\";i:904;s:10:\"delete-906\";i:905;s:10:\"delete-907\";i:906;s:10:\"delete-908\";i:907;s:10:\"delete-909\";i:908;s:10:\"delete-910\";i:909;s:10:\"delete-911\";i:910;s:10:\"delete-912\";i:911;s:10:\"delete-913\";i:912;s:10:\"delete-914\";i:913;s:10:\"delete-915\";i:914;s:10:\"delete-916\";i:915;s:10:\"delete-917\";i:916;s:10:\"delete-918\";i:917;s:10:\"delete-919\";i:918;s:10:\"delete-920\";i:919;s:10:\"delete-921\";i:920;s:10:\"delete-922\";i:921;s:10:\"delete-923\";i:922;s:10:\"delete-924\";i:923;s:10:\"delete-925\";i:924;s:10:\"delete-926\";i:925;s:10:\"delete-927\";i:926;s:10:\"delete-928\";i:927;s:10:\"delete-929\";i:928;s:10:\"delete-930\";i:929;s:10:\"delete-931\";i:930;s:10:\"delete-932\";i:931;s:10:\"delete-933\";i:932;s:10:\"delete-934\";i:933;s:10:\"delete-935\";i:934;s:10:\"delete-936\";i:935;s:10:\"delete-937\";i:936;s:10:\"delete-938\";i:937;s:10:\"delete-939\";i:938;s:10:\"delete-940\";i:939;s:10:\"delete-941\";i:940;s:10:\"delete-942\";i:941;s:10:\"delete-943\";i:942;s:10:\"delete-944\";i:943;s:10:\"delete-945\";i:944;s:10:\"delete-946\";i:945;s:10:\"delete-947\";i:946;s:10:\"delete-948\";i:947;s:10:\"delete-949\";i:948;s:10:\"delete-950\";i:949;s:10:\"delete-951\";i:950;s:10:\"delete-952\";i:951;s:10:\"delete-953\";i:952;s:10:\"delete-954\";i:953;s:10:\"delete-955\";i:954;s:10:\"delete-956\";i:955;s:10:\"delete-957\";i:956;s:10:\"delete-958\";i:957;s:10:\"delete-959\";i:958;s:10:\"delete-960\";i:959;s:10:\"delete-961\";i:960;s:10:\"delete-962\";i:961;s:10:\"delete-963\";i:962;s:10:\"delete-964\";i:963;s:10:\"delete-965\";i:964;s:10:\"delete-966\";i:965;s:10:\"delete-967\";i:966;s:10:\"delete-968\";i:967;s:10:\"delete-969\";i:968;s:10:\"delete-970\";i:969;s:10:\"delete-971\";i:970;s:10:\"delete-972\";i:971;s:10:\"delete-973\";i:972;s:10:\"delete-974\";i:973;s:10:\"delete-975\";i:974;s:10:\"delete-976\";i:975;s:10:\"delete-977\";i:976;s:10:\"delete-978\";i:977;s:10:\"delete-979\";i:978;s:10:\"delete-980\";i:979;s:10:\"delete-981\";i:980;s:10:\"delete-982\";i:981;s:10:\"delete-983\";i:982;s:10:\"delete-984\";i:983;s:10:\"delete-985\";i:984;s:10:\"delete-986\";i:985;s:10:\"delete-987\";i:986;s:10:\"delete-988\";i:987;s:10:\"delete-989\";i:988;s:10:\"delete-990\";i:989;s:10:\"delete-991\";i:990;s:10:\"delete-992\";i:991;s:10:\"delete-993\";i:992;s:10:\"delete-994\";i:993;s:10:\"delete-995\";i:994;s:10:\"delete-996\";i:995;s:10:\"delete-997\";i:996;s:10:\"delete-998\";i:997;s:10:\"delete-999\";i:998;s:11:\"delete-1000\";i:999;s:11:\"delete-1001\";i:1000;s:11:\"delete-1002\";i:1001;s:11:\"delete-1003\";i:1002;s:11:\"delete-1004\";i:1003;s:11:\"delete-1005\";i:1004;s:11:\"delete-1006\";i:1005;s:11:\"delete-1007\";i:1006;s:11:\"delete-1008\";i:1007;s:11:\"delete-1009\";i:1008;s:11:\"delete-1010\";i:1009;s:11:\"delete-1011\";i:1010;s:11:\"delete-1012\";i:1011;s:11:\"delete-1013\";i:1012;s:11:\"delete-1014\";i:1013;s:11:\"delete-1015\";i:1014;s:11:\"delete-1016\";i:1015;s:11:\"delete-1017\";i:1016;s:11:\"delete-1018\";i:1017;s:11:\"delete-1019\";i:1018;s:11:\"delete-1020\";i:1019;s:11:\"delete-1021\";i:1020;s:11:\"delete-1022\";i:1021;s:11:\"delete-1023\";i:1022;s:11:\"delete-1024\";i:1023;s:11:\"delete-1025\";i:1024;s:11:\"delete-1026\";i:1025;s:11:\"delete-1027\";i:1026;s:11:\"delete-1028\";i:1027;s:11:\"delete-1029\";i:1028;s:11:\"delete-1030\";i:1029;s:11:\"delete-1031\";i:1030;s:11:\"delete-1032\";i:1031;s:11:\"delete-1033\";i:1032;s:11:\"delete-1034\";i:1033;s:11:\"delete-1035\";i:1034;s:11:\"delete-1036\";i:1035;s:11:\"delete-1037\";i:1036;s:11:\"delete-1038\";i:1037;s:11:\"delete-1039\";i:1038;s:11:\"delete-1040\";i:1039;s:11:\"delete-1041\";i:1040;s:11:\"delete-1042\";i:1041;s:11:\"delete-1043\";i:1042;s:11:\"delete-1044\";i:1043;s:11:\"delete-1045\";i:1044;s:11:\"delete-1046\";i:1045;s:11:\"delete-1047\";i:1046;s:11:\"delete-1048\";i:1047;s:11:\"delete-1049\";i:1048;s:11:\"delete-1050\";i:1049;s:11:\"delete-1051\";i:1050;s:11:\"delete-1052\";i:1051;s:11:\"delete-1053\";i:1052;s:11:\"delete-1054\";i:1053;s:11:\"delete-1055\";i:1054;s:11:\"delete-1056\";i:1055;s:11:\"delete-1057\";i:1056;s:11:\"delete-1058\";i:1057;s:11:\"delete-1059\";i:1058;s:11:\"delete-1060\";i:1059;s:11:\"delete-1061\";i:1060;s:11:\"delete-1062\";i:1061;s:11:\"delete-1063\";i:1062;s:11:\"delete-1064\";i:1063;s:11:\"delete-1065\";i:1064;s:11:\"delete-1066\";i:1065;s:11:\"delete-1067\";i:1066;s:11:\"delete-1068\";i:1067;s:11:\"delete-1069\";i:1068;s:11:\"delete-1070\";i:1069;s:11:\"delete-1071\";i:1070;s:11:\"delete-1072\";i:1071;s:11:\"delete-1073\";i:1072;s:11:\"delete-1074\";i:1073;s:11:\"delete-1075\";i:1074;s:11:\"delete-1076\";i:1075;s:11:\"delete-1077\";i:1076;s:11:\"delete-1078\";i:1077;s:11:\"delete-1079\";i:1078;s:11:\"delete-1080\";i:1079;s:11:\"delete-1081\";i:1080;s:11:\"delete-1082\";i:1081;s:11:\"delete-1083\";i:1082;s:11:\"delete-1084\";i:1083;s:11:\"delete-1085\";i:1084;s:11:\"delete-1086\";i:1085;s:11:\"delete-1087\";i:1086;s:11:\"delete-1088\";i:1087;s:11:\"delete-1089\";i:1088;s:11:\"delete-1090\";i:1089;s:11:\"delete-1091\";i:1090;s:11:\"delete-1092\";i:1091;s:11:\"delete-1093\";i:1092;s:11:\"delete-1094\";i:1093;s:11:\"delete-1095\";i:1094;s:11:\"delete-1096\";i:1095;s:11:\"delete-1097\";i:1096;s:11:\"delete-1098\";i:1097;s:11:\"delete-1099\";i:1098;s:11:\"delete-1100\";i:1099;s:11:\"delete-1101\";i:1100;s:11:\"delete-1102\";i:1101;s:11:\"delete-1103\";i:1102;s:11:\"delete-1104\";i:1103;s:11:\"delete-1105\";i:1104;s:11:\"delete-1106\";i:1105;s:11:\"delete-1107\";i:1106;s:11:\"delete-1108\";i:1107;s:11:\"delete-1109\";i:1108;s:11:\"delete-1110\";i:1109;s:11:\"delete-1111\";i:1110;s:11:\"delete-1112\";i:1111;s:11:\"delete-1113\";i:1112;s:11:\"delete-1114\";i:1113;s:11:\"delete-1115\";i:1114;s:11:\"delete-1116\";i:1115;s:11:\"delete-1117\";i:1116;s:11:\"delete-1118\";i:1117;s:11:\"delete-1119\";i:1118;s:11:\"delete-1120\";i:1119;s:11:\"delete-1121\";i:1120;s:11:\"delete-1122\";i:1121;s:13:\"delete-109122\";i:1122;s:13:\"delete-109126\";i:1123;s:13:\"delete-109128\";i:1124;s:13:\"delete-109129\";i:1125;s:13:\"delete-109137\";i:1126;s:13:\"delete-109140\";i:1127;s:13:\"delete-109141\";i:1128;s:13:\"delete-109145\";i:1129;s:13:\"delete-109149\";i:1130;s:13:\"delete-109150\";i:1131;s:13:\"delete-109151\";i:1132;s:13:\"delete-109152\";i:1133;s:13:\"delete-109121\";i:1134;s:13:\"delete-109123\";i:1135;s:13:\"delete-109124\";i:1136;s:13:\"delete-109125\";i:1137;s:13:\"delete-109127\";i:1138;s:13:\"delete-109130\";i:1139;s:13:\"delete-109131\";i:1140;s:13:\"delete-109132\";i:1141;s:13:\"delete-109133\";i:1142;s:13:\"delete-109134\";i:1143;s:13:\"delete-109135\";i:1144;s:13:\"delete-109136\";i:1145;s:13:\"delete-109138\";i:1146;s:13:\"delete-109139\";i:1147;s:13:\"delete-109142\";i:1148;s:13:\"delete-109143\";i:1149;s:13:\"delete-109144\";i:1150;s:13:\"delete-109146\";i:1151;s:13:\"delete-109147\";i:1152;s:13:\"delete-109148\";i:1153;s:13:\"delete-109158\";i:1154;s:13:\"delete-109159\";i:1155;s:13:\"delete-109160\";i:1156;s:13:\"delete-109161\";i:1157;s:13:\"delete-109162\";i:1158;s:13:\"delete-109163\";i:1159;s:13:\"delete-109164\";i:1160;s:13:\"delete-109165\";i:1161;s:13:\"delete-109166\";i:1162;s:13:\"delete-109167\";i:1163;s:13:\"delete-109168\";i:1164;s:13:\"delete-109169\";i:1165;s:13:\"delete-109170\";i:1166;s:13:\"delete-109171\";i:1167;s:13:\"delete-109172\";i:1168;s:13:\"delete-109173\";i:1169;s:13:\"delete-109174\";i:1170;s:13:\"delete-109175\";i:1171;s:13:\"delete-109176\";i:1172;s:13:\"delete-109177\";i:1173;s:13:\"delete-109178\";i:1174;s:13:\"delete-109179\";i:1175;s:13:\"delete-109180\";i:1176;s:13:\"delete-109181\";i:1177;s:13:\"delete-109182\";i:1178;s:13:\"delete-109183\";i:1179;s:13:\"delete-109184\";i:1180;s:13:\"delete-109185\";i:1181;s:13:\"delete-109186\";i:1182;s:13:\"delete-109187\";i:1183;s:13:\"delete-109188\";i:1184;s:13:\"delete-109189\";i:1185;s:13:\"delete-109190\";i:1186;s:13:\"delete-109191\";i:1187;s:13:\"delete-109192\";i:1188;s:13:\"delete-109193\";i:1189;s:13:\"delete-109194\";i:1190;s:13:\"delete-109195\";i:1191;s:13:\"delete-109196\";i:1192;s:13:\"delete-109197\";i:1193;s:13:\"delete-109198\";i:1194;s:13:\"delete-109199\";i:1195;s:13:\"delete-109200\";i:1196;s:13:\"delete-109201\";i:1197;s:13:\"delete-109202\";i:1198;s:13:\"delete-109203\";i:1199;s:13:\"delete-109204\";i:1200;s:13:\"delete-109205\";i:1201;s:13:\"delete-109206\";i:1202;s:13:\"delete-109207\";i:1203;s:13:\"delete-109208\";i:1204;s:13:\"delete-109209\";i:1205;s:13:\"delete-109210\";i:1206;s:13:\"delete-109211\";i:1207;s:13:\"delete-109212\";i:1208;s:13:\"delete-109213\";i:1209;s:13:\"delete-109214\";i:1210;s:13:\"delete-109215\";i:1211;s:13:\"delete-109216\";i:1212;s:13:\"delete-109217\";i:1213;s:13:\"delete-109218\";i:1214;s:13:\"delete-109219\";i:1215;s:13:\"delete-109220\";i:1216;s:13:\"delete-109221\";i:1217;s:13:\"delete-109222\";i:1218;s:13:\"delete-109223\";i:1219;s:13:\"delete-109224\";i:1220;s:13:\"delete-109225\";i:1221;s:13:\"delete-109226\";i:1222;s:13:\"delete-109227\";i:1223;s:13:\"delete-109228\";i:1224;s:13:\"delete-109229\";i:1225;s:13:\"delete-109230\";i:1226;s:13:\"delete-109231\";i:1227;s:13:\"delete-109232\";i:1228;s:13:\"delete-109233\";i:1229;s:13:\"delete-109234\";i:1230;s:13:\"delete-109235\";i:1231;s:13:\"delete-109236\";i:1232;s:13:\"delete-109237\";i:1233;s:13:\"delete-109238\";i:1234;s:13:\"delete-109239\";i:1235;s:13:\"delete-109240\";i:1236;s:13:\"delete-109241\";i:1237;s:13:\"delete-109242\";i:1238;s:13:\"delete-109243\";i:1239;s:13:\"delete-109244\";i:1240;s:13:\"delete-109245\";i:1241;s:13:\"delete-109246\";i:1242;s:13:\"delete-109247\";i:1243;s:13:\"delete-109248\";i:1244;s:13:\"delete-109249\";i:1245;s:13:\"delete-109250\";i:1246;s:13:\"delete-109251\";i:1247;s:13:\"delete-109252\";i:1248;s:13:\"delete-109253\";i:1249;s:13:\"delete-109254\";i:1250;s:13:\"delete-109255\";i:1251;s:13:\"delete-109256\";i:1252;s:13:\"delete-109257\";i:1253;s:13:\"delete-109258\";i:1254;s:13:\"delete-109259\";i:1255;s:13:\"delete-109260\";i:1256;s:13:\"delete-109261\";i:1257;s:13:\"delete-109262\";i:1258;s:13:\"delete-109263\";i:1259;s:13:\"delete-109264\";i:1260;s:13:\"delete-109265\";i:1261;s:13:\"delete-109266\";i:1262;s:13:\"delete-109275\";i:1263;s:13:\"delete-109276\";i:1264;s:13:\"delete-109278\";i:1265;s:13:\"delete-109279\";i:1266;s:13:\"delete-109280\";i:1267;s:13:\"delete-109295\";i:1268;s:13:\"delete-109296\";i:1269;s:13:\"delete-109298\";i:1270;s:13:\"delete-109299\";i:1271;s:13:\"delete-109300\";i:1272;s:13:\"delete-109301\";i:1273;s:13:\"delete-109302\";i:1274;s:13:\"delete-109303\";i:1275;s:13:\"delete-109153\";i:1276;s:13:\"delete-109154\";i:1277;s:13:\"delete-109155\";i:1278;s:13:\"delete-109156\";i:1279;s:13:\"delete-109157\";i:1280;s:13:\"delete-109281\";i:1281;s:13:\"delete-109285\";i:1282;s:13:\"delete-109287\";i:1283;s:13:\"delete-109288\";i:1284;s:13:\"delete-109289\";i:1285;s:13:\"delete-109290\";i:1286;s:13:\"delete-109291\";i:1287;s:13:\"delete-109292\";i:1288;s:13:\"delete-109293\";i:1289;s:13:\"delete-109294\";i:1290;s:13:\"delete-109297\";i:1291;s:13:\"delete-109304\";i:1292;s:13:\"delete-109305\";i:1293;s:13:\"delete-109306\";i:1294;s:13:\"delete-109307\";i:1295;s:13:\"delete-109308\";i:1296;s:13:\"delete-109309\";i:1297;s:13:\"delete-109312\";i:1298;s:13:\"delete-109313\";i:1299;s:13:\"delete-109314\";i:1300;s:13:\"delete-109315\";i:1301;s:13:\"delete-109503\";i:1302;s:13:\"delete-109508\";i:1303;s:13:\"delete-109318\";i:1304;s:13:\"delete-109320\";i:1305;s:13:\"delete-109321\";i:1306;s:13:\"delete-109322\";i:1307;s:13:\"delete-109323\";i:1308;s:13:\"delete-109324\";i:1309;s:13:\"delete-109325\";i:1310;s:13:\"delete-109326\";i:1311;s:13:\"delete-109327\";i:1312;s:13:\"delete-109328\";i:1313;s:13:\"delete-109329\";i:1314;s:13:\"delete-109330\";i:1315;s:13:\"delete-109331\";i:1316;s:13:\"delete-109332\";i:1317;s:13:\"delete-109333\";i:1318;s:13:\"delete-109334\";i:1319;s:13:\"delete-109335\";i:1320;s:13:\"delete-109336\";i:1321;s:13:\"delete-109337\";i:1322;s:13:\"delete-109338\";i:1323;s:13:\"delete-109339\";i:1324;s:13:\"delete-109340\";i:1325;s:13:\"delete-109341\";i:1326;s:13:\"delete-109342\";i:1327;s:13:\"delete-109343\";i:1328;s:13:\"delete-109344\";i:1329;s:13:\"delete-109345\";i:1330;s:13:\"delete-109346\";i:1331;s:13:\"delete-109347\";i:1332;s:13:\"delete-109348\";i:1333;s:13:\"delete-109349\";i:1334;s:13:\"delete-109350\";i:1335;s:13:\"delete-109351\";i:1336;s:13:\"delete-109352\";i:1337;s:13:\"delete-109353\";i:1338;s:13:\"delete-109354\";i:1339;s:13:\"delete-109355\";i:1340;s:13:\"delete-109356\";i:1341;s:13:\"delete-109357\";i:1342;s:13:\"delete-109358\";i:1343;s:13:\"delete-109359\";i:1344;s:13:\"delete-109360\";i:1345;s:13:\"delete-109361\";i:1346;s:13:\"delete-109362\";i:1347;s:13:\"delete-109363\";i:1348;s:13:\"delete-109364\";i:1349;s:13:\"delete-109365\";i:1350;s:13:\"delete-109366\";i:1351;s:13:\"delete-109367\";i:1352;s:13:\"delete-109368\";i:1353;s:13:\"delete-109369\";i:1354;s:13:\"delete-109370\";i:1355;s:13:\"delete-109371\";i:1356;s:13:\"delete-109372\";i:1357;s:13:\"delete-109373\";i:1358;s:13:\"delete-109374\";i:1359;s:13:\"delete-109375\";i:1360;s:13:\"delete-109376\";i:1361;s:13:\"delete-109377\";i:1362;s:13:\"delete-109378\";i:1363;s:13:\"delete-109379\";i:1364;s:13:\"delete-109380\";i:1365;s:13:\"delete-109381\";i:1366;s:13:\"delete-109382\";i:1367;s:13:\"delete-109383\";i:1368;s:13:\"delete-109384\";i:1369;s:13:\"delete-109385\";i:1370;s:13:\"delete-109386\";i:1371;s:13:\"delete-109387\";i:1372;s:13:\"delete-109388\";i:1373;s:13:\"delete-109389\";i:1374;s:13:\"delete-109390\";i:1375;s:13:\"delete-109391\";i:1376;s:13:\"delete-109392\";i:1377;s:13:\"delete-109393\";i:1378;s:13:\"delete-109394\";i:1379;s:13:\"delete-109395\";i:1380;s:13:\"delete-109396\";i:1381;s:13:\"delete-109397\";i:1382;s:13:\"delete-109398\";i:1383;s:13:\"delete-109399\";i:1384;s:13:\"delete-109400\";i:1385;s:13:\"delete-109401\";i:1386;s:13:\"delete-109402\";i:1387;s:13:\"delete-109403\";i:1388;s:13:\"delete-109404\";i:1389;s:13:\"delete-109405\";i:1390;s:13:\"delete-109406\";i:1391;s:13:\"delete-109407\";i:1392;s:13:\"delete-109408\";i:1393;s:13:\"delete-109409\";i:1394;s:13:\"delete-109410\";i:1395;s:13:\"delete-109411\";i:1396;s:13:\"delete-109412\";i:1397;s:13:\"delete-109413\";i:1398;s:13:\"delete-109414\";i:1399;s:13:\"delete-109415\";i:1400;s:13:\"delete-109416\";i:1401;s:13:\"delete-109417\";i:1402;s:13:\"delete-109418\";i:1403;s:13:\"delete-109419\";i:1404;s:13:\"delete-109420\";i:1405;s:13:\"delete-109421\";i:1406;s:13:\"delete-109422\";i:1407;s:13:\"delete-109423\";i:1408;s:13:\"delete-109424\";i:1409;s:13:\"delete-109425\";i:1410;s:13:\"delete-109426\";i:1411;s:13:\"delete-109427\";i:1412;s:13:\"delete-109428\";i:1413;s:13:\"delete-109429\";i:1414;s:13:\"delete-109430\";i:1415;s:13:\"delete-109431\";i:1416;s:13:\"delete-109432\";i:1417;s:13:\"delete-109433\";i:1418;s:13:\"delete-109434\";i:1419;s:13:\"delete-109435\";i:1420;s:13:\"delete-109436\";i:1421;s:13:\"delete-109437\";i:1422;s:13:\"delete-109438\";i:1423;s:13:\"delete-109439\";i:1424;s:13:\"delete-109440\";i:1425;s:13:\"delete-109441\";i:1426;s:13:\"delete-109442\";i:1427;s:13:\"delete-109443\";i:1428;s:13:\"delete-109444\";i:1429;s:13:\"delete-109445\";i:1430;s:13:\"delete-109446\";i:1431;s:13:\"delete-109447\";i:1432;s:13:\"delete-109448\";i:1433;s:13:\"delete-109449\";i:1434;s:13:\"delete-109450\";i:1435;s:13:\"delete-109451\";i:1436;s:13:\"delete-109452\";i:1437;s:13:\"delete-109453\";i:1438;s:13:\"delete-109454\";i:1439;s:13:\"delete-109455\";i:1440;s:13:\"delete-109456\";i:1441;s:13:\"delete-109457\";i:1442;s:13:\"delete-109458\";i:1443;s:13:\"delete-109459\";i:1444;s:13:\"delete-109460\";i:1445;s:13:\"delete-109461\";i:1446;s:13:\"delete-109462\";i:1447;s:13:\"delete-109463\";i:1448;s:13:\"delete-109464\";i:1449;s:13:\"delete-109465\";i:1450;s:13:\"delete-109466\";i:1451;s:13:\"delete-109467\";i:1452;s:13:\"delete-109468\";i:1453;s:13:\"delete-109469\";i:1454;s:13:\"delete-109470\";i:1455;s:13:\"delete-109471\";i:1456;s:13:\"delete-109472\";i:1457;s:13:\"delete-109473\";i:1458;s:13:\"delete-109474\";i:1459;s:13:\"delete-109475\";i:1460;s:13:\"delete-109476\";i:1461;s:13:\"delete-109477\";i:1462;s:13:\"delete-109478\";i:1463;s:13:\"delete-109479\";i:1464;s:13:\"delete-109480\";i:1465;s:13:\"delete-109481\";i:1466;s:13:\"delete-109482\";i:1467;s:13:\"delete-109483\";i:1468;s:13:\"delete-109484\";i:1469;s:13:\"delete-109485\";i:1470;s:13:\"delete-109486\";i:1471;s:13:\"delete-109487\";i:1472;s:13:\"delete-109488\";i:1473;s:13:\"delete-109489\";i:1474;s:13:\"delete-109490\";i:1475;s:13:\"delete-109491\";i:1476;s:13:\"delete-109492\";i:1477;s:13:\"delete-109493\";i:1478;s:13:\"delete-109494\";i:1479;s:13:\"delete-109495\";i:1480;s:13:\"delete-109496\";i:1481;s:13:\"delete-109497\";i:1482;s:13:\"delete-109507\";i:1483;s:13:\"delete-109505\";i:1484;s:13:\"delete-109269\";i:1485;s:13:\"delete-109286\";i:1486;s:13:\"delete-109316\";i:1487;s:13:\"delete-109317\";i:1488;s:13:\"delete-109319\";i:1489;s:13:\"delete-109498\";i:1490;s:13:\"delete-109499\";i:1491;s:13:\"delete-109500\";i:1492;s:13:\"delete-109501\";i:1493;s:13:\"delete-109502\";i:1494;s:13:\"delete-109504\";i:1495;s:13:\"delete-109506\";i:1496;s:13:\"delete-109509\";i:1497;s:13:\"delete-109510\";i:1498;s:13:\"delete-109511\";i:1499;s:13:\"delete-109267\";i:1500;s:13:\"delete-109268\";i:1501;s:13:\"delete-109270\";i:1502;s:13:\"delete-109271\";i:1503;s:13:\"delete-109272\";i:1504;s:13:\"delete-109273\";i:1505;s:13:\"delete-109274\";i:1506;s:13:\"delete-109277\";i:1507;s:13:\"delete-109282\";i:1508;s:13:\"delete-109283\";i:1509;s:13:\"delete-109284\";i:1510;s:13:\"delete-109310\";i:1511;s:13:\"delete-109311\";i:1512;s:13:\"delete-109512\";i:1513;s:13:\"delete-109514\";i:1514;s:13:\"delete-109515\";i:1515;s:13:\"delete-109513\";i:1516;s:10:\"delete-116\";i:1517;s:10:\"delete-210\";i:1518;s:10:\"delete-222\";i:1519;s:10:\"delete-223\";i:1520;s:10:\"delete-224\";i:1521;s:10:\"delete-225\";i:1522;s:10:\"delete-226\";i:1523;s:10:\"delete-227\";i:1524;s:10:\"delete-228\";i:1525;s:10:\"delete-229\";i:1526;s:10:\"delete-289\";i:1527;s:10:\"delete-291\";i:1528;s:10:\"delete-290\";i:1529;s:10:\"delete-292\";i:1530;s:10:\"delete-293\";i:1531;s:10:\"delete-295\";i:1532;s:10:\"delete-294\";i:1533;s:10:\"delete-296\";i:1534;s:10:\"delete-297\";i:1535;s:10:\"delete-299\";i:1536;s:10:\"delete-298\";i:1537;s:10:\"delete-300\";i:1538;s:10:\"delete-301\";i:1539;s:10:\"delete-303\";i:1540;s:10:\"delete-302\";i:1541;s:10:\"delete-304\";i:1542;s:10:\"delete-305\";i:1543;s:10:\"delete-307\";i:1544;s:10:\"delete-306\";i:1545;s:10:\"delete-308\";i:1546;s:10:\"delete-309\";i:1547;s:10:\"delete-311\";i:1548;s:10:\"delete-310\";i:1549;s:10:\"delete-312\";i:1550;s:10:\"delete-313\";i:1551;s:10:\"delete-315\";i:1552;s:10:\"delete-314\";i:1553;s:10:\"delete-316\";i:1554;s:10:\"delete-317\";i:1555;s:10:\"delete-319\";i:1556;s:10:\"delete-318\";i:1557;s:10:\"delete-320\";i:1558;s:10:\"delete-321\";i:1559;s:10:\"delete-323\";i:1560;s:10:\"delete-322\";i:1561;s:10:\"delete-324\";i:1562;s:10:\"delete-325\";i:1563;s:10:\"delete-327\";i:1564;s:10:\"delete-326\";i:1565;s:10:\"delete-328\";i:1566;s:10:\"delete-329\";i:1567;s:10:\"delete-331\";i:1568;s:10:\"delete-330\";i:1569;s:10:\"delete-332\";i:1570;s:10:\"delete-333\";i:1571;s:10:\"delete-335\";i:1572;s:10:\"delete-334\";i:1573;s:10:\"delete-336\";i:1574;s:10:\"delete-337\";i:1575;s:10:\"delete-339\";i:1576;s:10:\"delete-338\";i:1577;s:10:\"delete-340\";i:1578;s:10:\"delete-341\";i:1579;s:10:\"delete-343\";i:1580;s:10:\"delete-342\";i:1581;s:10:\"delete-344\";i:1582;s:10:\"delete-345\";i:1583;s:10:\"delete-347\";i:1584;s:10:\"delete-346\";i:1585;s:10:\"delete-348\";i:1586;s:10:\"delete-349\";i:1587;s:10:\"delete-351\";i:1588;s:10:\"delete-350\";i:1589;s:10:\"delete-352\";i:1590;s:10:\"delete-353\";i:1591;s:10:\"delete-355\";i:1592;s:10:\"delete-354\";i:1593;s:10:\"delete-356\";i:1594;s:10:\"delete-357\";i:1595;s:10:\"delete-359\";i:1596;s:10:\"delete-358\";i:1597;s:10:\"delete-360\";i:1598;s:10:\"delete-361\";i:1599;s:10:\"delete-363\";i:1600;s:10:\"delete-362\";i:1601;s:10:\"delete-364\";i:1602;s:10:\"delete-365\";i:1603;s:10:\"delete-367\";i:1604;s:10:\"delete-366\";i:1605;s:10:\"delete-368\";i:1606;s:10:\"delete-369\";i:1607;s:10:\"delete-371\";i:1608;s:10:\"delete-370\";i:1609;s:10:\"delete-372\";i:1610;s:10:\"delete-373\";i:1611;s:10:\"delete-375\";i:1612;s:10:\"delete-374\";i:1613;s:10:\"delete-376\";i:1614;s:10:\"delete-377\";i:1615;s:10:\"delete-379\";i:1616;s:10:\"delete-378\";i:1617;s:10:\"delete-380\";i:1618;s:10:\"delete-381\";i:1619;s:10:\"delete-383\";i:1620;s:10:\"delete-382\";i:1621;s:10:\"delete-384\";i:1622;s:10:\"delete-385\";i:1623;s:10:\"delete-387\";i:1624;s:10:\"delete-386\";i:1625;s:10:\"delete-388\";i:1626;s:10:\"delete-389\";i:1627;s:10:\"delete-391\";i:1628;s:10:\"delete-390\";i:1629;s:10:\"delete-392\";i:1630;s:10:\"delete-393\";i:1631;s:10:\"delete-395\";i:1632;s:10:\"delete-394\";i:1633;s:10:\"delete-396\";i:1634;s:10:\"delete-397\";i:1635;s:10:\"delete-399\";i:1636;s:10:\"delete-398\";i:1637;s:10:\"delete-400\";i:1638;s:10:\"delete-401\";i:1639;s:10:\"delete-403\";i:1640;s:10:\"delete-402\";i:1641;s:10:\"delete-404\";i:1642;s:10:\"delete-405\";i:1643;s:10:\"delete-407\";i:1644;s:10:\"delete-406\";i:1645;s:10:\"delete-408\";i:1646;s:10:\"delete-409\";i:1647;s:10:\"delete-411\";i:1648;s:10:\"delete-410\";i:1649;s:10:\"delete-412\";i:1650;s:10:\"delete-413\";i:1651;s:10:\"delete-415\";i:1652;s:10:\"delete-414\";i:1653;s:10:\"delete-416\";i:1654;s:10:\"delete-417\";i:1655;s:10:\"delete-419\";i:1656;s:10:\"delete-418\";i:1657;s:10:\"delete-420\";i:1658;s:10:\"delete-421\";i:1659;s:10:\"delete-423\";i:1660;s:10:\"delete-422\";i:1661;s:10:\"delete-424\";i:1662;s:10:\"delete-425\";i:1663;s:10:\"delete-427\";i:1664;s:10:\"delete-426\";i:1665;s:10:\"delete-428\";i:1666;s:10:\"delete-429\";i:1667;s:10:\"delete-431\";i:1668;s:10:\"delete-430\";i:1669;s:10:\"delete-432\";i:1670;s:10:\"delete-433\";i:1671;s:10:\"delete-435\";i:1672;s:10:\"delete-434\";i:1673;s:10:\"delete-436\";i:1674;s:10:\"delete-437\";i:1675;s:10:\"delete-439\";i:1676;s:10:\"delete-438\";i:1677;s:10:\"delete-440\";i:1678;s:10:\"delete-441\";i:1679;s:10:\"delete-443\";i:1680;s:10:\"delete-442\";i:1681;s:10:\"delete-444\";i:1682;s:10:\"delete-445\";i:1683;s:10:\"delete-447\";i:1684;s:10:\"delete-446\";i:1685;s:10:\"delete-448\";i:1686;s:10:\"delete-449\";i:1687;s:10:\"delete-451\";i:1688;s:10:\"delete-450\";i:1689;s:10:\"delete-452\";i:1690;s:10:\"delete-453\";i:1691;s:10:\"delete-455\";i:1692;s:10:\"delete-454\";i:1693;s:10:\"delete-456\";i:1694;s:10:\"delete-457\";i:1695;s:10:\"delete-459\";i:1696;s:10:\"delete-458\";i:1697;s:10:\"delete-460\";i:1698;s:10:\"delete-461\";i:1699;s:10:\"delete-463\";i:1700;s:10:\"delete-462\";i:1701;s:10:\"delete-464\";i:1702;s:10:\"delete-465\";i:1703;s:10:\"delete-467\";i:1704;s:10:\"delete-466\";i:1705;s:10:\"delete-468\";i:1706;s:10:\"delete-469\";i:1707;s:10:\"delete-471\";i:1708;s:10:\"delete-470\";i:1709;s:10:\"delete-472\";i:1710;s:10:\"delete-473\";i:1711;s:10:\"delete-475\";i:1712;s:10:\"delete-474\";i:1713;s:10:\"delete-476\";i:1714;s:10:\"delete-477\";i:1715;s:10:\"delete-479\";i:1716;s:10:\"delete-478\";i:1717;s:10:\"delete-480\";i:1718;s:10:\"delete-481\";i:1719;s:10:\"delete-483\";i:1720;s:10:\"delete-482\";i:1721;s:10:\"delete-484\";i:1722;s:10:\"delete-485\";i:1723;s:10:\"delete-487\";i:1724;s:10:\"delete-486\";i:1725;s:10:\"delete-488\";i:1726;s:10:\"delete-489\";i:1727;s:10:\"delete-491\";i:1728;s:10:\"delete-490\";i:1729;s:10:\"delete-492\";i:1730;s:10:\"delete-493\";i:1731;s:10:\"delete-495\";i:1732;s:10:\"delete-494\";i:1733;s:10:\"delete-496\";i:1734;s:10:\"delete-497\";i:1735;s:10:\"delete-499\";i:1736;s:10:\"delete-498\";i:1737;s:10:\"delete-500\";i:1738;s:10:\"delete-501\";i:1739;s:10:\"delete-503\";i:1740;s:10:\"delete-502\";i:1741;s:10:\"delete-504\";i:1742;s:10:\"delete-505\";i:1743;s:10:\"delete-507\";i:1744;s:10:\"delete-506\";i:1745;s:10:\"delete-508\";i:1746;s:10:\"delete-509\";i:1747;s:10:\"delete-511\";i:1748;s:10:\"delete-510\";i:1749;s:10:\"delete-512\";i:1750;s:10:\"delete-513\";i:1751;s:10:\"delete-515\";i:1752;s:10:\"delete-514\";i:1753;s:10:\"delete-516\";i:1754;s:10:\"delete-517\";i:1755;s:10:\"delete-519\";i:1756;s:10:\"delete-518\";i:1757;s:10:\"delete-520\";i:1758;s:10:\"delete-521\";i:1759;s:10:\"delete-523\";i:1760;s:10:\"delete-522\";i:1761;s:10:\"delete-524\";i:1762;s:10:\"delete-525\";i:1763;s:10:\"delete-527\";i:1764;s:10:\"delete-526\";i:1765;s:10:\"delete-528\";i:1766;s:10:\"delete-529\";i:1767;s:10:\"delete-531\";i:1768;s:10:\"delete-530\";i:1769;s:10:\"delete-532\";i:1770;s:10:\"delete-533\";i:1771;s:10:\"delete-535\";i:1772;s:10:\"delete-534\";i:1773;s:10:\"delete-536\";i:1774;s:10:\"delete-537\";i:1775;s:10:\"delete-539\";i:1776;s:10:\"delete-538\";i:1777;s:10:\"delete-540\";i:1778;s:10:\"delete-541\";i:1779;s:10:\"delete-543\";i:1780;s:10:\"delete-542\";i:1781;s:10:\"delete-544\";i:1782;s:10:\"delete-545\";i:1783;s:10:\"delete-547\";i:1784;s:10:\"delete-546\";i:1785;s:10:\"delete-548\";i:1786;s:10:\"delete-549\";i:1787;s:10:\"delete-551\";i:1788;s:10:\"delete-550\";i:1789;s:10:\"delete-552\";i:1790;s:10:\"delete-553\";i:1791;s:10:\"delete-555\";i:1792;s:10:\"delete-554\";i:1793;s:10:\"delete-556\";i:1794;s:10:\"delete-557\";i:1795;s:10:\"delete-559\";i:1796;s:10:\"delete-558\";i:1797;s:10:\"delete-560\";i:1798;s:10:\"delete-561\";i:1799;s:10:\"delete-563\";i:1800;s:10:\"delete-562\";i:1801;s:10:\"delete-564\";i:1802;s:10:\"delete-565\";i:1803;s:10:\"delete-567\";i:1804;s:10:\"delete-566\";i:1805;s:10:\"delete-568\";i:1806;s:10:\"delete-569\";i:1807;s:10:\"delete-571\";i:1808;s:10:\"delete-570\";i:1809;s:10:\"delete-572\";i:1810;s:10:\"delete-573\";i:1811;s:10:\"delete-575\";i:1812;s:10:\"delete-574\";i:1813;s:10:\"delete-576\";i:1814;s:10:\"delete-577\";i:1815;s:10:\"delete-579\";i:1816;s:10:\"delete-578\";i:1817;s:10:\"delete-580\";i:1818;s:10:\"delete-581\";i:1819;s:10:\"delete-583\";i:1820;s:10:\"delete-582\";i:1821;s:10:\"delete-584\";i:1822;s:10:\"delete-585\";i:1823;s:10:\"delete-587\";i:1824;s:10:\"delete-586\";i:1825;s:10:\"delete-588\";i:1826;s:10:\"delete-589\";i:1827;s:10:\"delete-591\";i:1828;s:10:\"delete-590\";i:1829;s:10:\"delete-592\";i:1830;s:10:\"delete-593\";i:1831;s:10:\"delete-595\";i:1832;s:10:\"delete-594\";i:1833;s:10:\"delete-596\";i:1834;s:10:\"delete-597\";i:1835;s:10:\"delete-599\";i:1836;s:10:\"delete-598\";i:1837;s:10:\"delete-600\";i:1838;s:10:\"delete-601\";i:1839;s:10:\"delete-603\";i:1840;s:10:\"delete-602\";i:1841;s:10:\"delete-604\";i:1842;s:10:\"delete-605\";i:1843;s:10:\"delete-607\";i:1844;s:10:\"delete-606\";i:1845;s:10:\"delete-608\";i:1846;s:10:\"delete-609\";i:1847;s:10:\"delete-611\";i:1848;s:10:\"delete-610\";i:1849;s:10:\"delete-612\";i:1850;s:10:\"delete-613\";i:1851;s:10:\"delete-615\";i:1852;s:10:\"delete-614\";i:1853;s:10:\"delete-616\";i:1854;s:10:\"delete-617\";i:1855;s:10:\"delete-619\";i:1856;s:10:\"delete-618\";i:1857;s:10:\"delete-620\";i:1858;s:10:\"delete-621\";i:1859;s:10:\"delete-623\";i:1860;s:10:\"delete-622\";i:1861;s:10:\"delete-624\";i:1862;s:10:\"delete-625\";i:1863;s:10:\"delete-627\";i:1864;s:10:\"delete-626\";i:1865;s:10:\"delete-628\";i:1866;s:10:\"delete-629\";i:1867;s:10:\"delete-631\";i:1868;s:10:\"delete-630\";i:1869;s:10:\"delete-632\";i:1870;s:10:\"delete-633\";i:1871;s:10:\"delete-635\";i:1872;s:10:\"delete-634\";i:1873;s:10:\"delete-636\";i:1874;s:10:\"delete-637\";i:1875;s:10:\"delete-639\";i:1876;s:10:\"delete-638\";i:1877;s:10:\"delete-640\";i:1878;s:10:\"delete-641\";i:1879;s:10:\"delete-643\";i:1880;s:10:\"delete-642\";i:1881;s:10:\"delete-644\";i:1882;s:10:\"delete-645\";i:1883;s:10:\"delete-647\";i:1884;s:10:\"delete-646\";i:1885;s:10:\"delete-648\";i:1886;s:10:\"delete-649\";i:1887;s:10:\"delete-651\";i:1888;s:10:\"delete-650\";i:1889;s:10:\"delete-652\";i:1890;s:10:\"delete-653\";i:1891;s:10:\"delete-655\";i:1892;s:10:\"delete-654\";i:1893;s:10:\"delete-656\";i:1894;s:10:\"delete-657\";i:1895;s:10:\"delete-659\";i:1896;s:10:\"delete-658\";i:1897;s:10:\"delete-660\";i:1898;s:10:\"delete-661\";i:1899;s:10:\"delete-663\";i:1900;s:10:\"delete-662\";i:1901;s:10:\"delete-664\";i:1902;s:10:\"delete-665\";i:1903;s:10:\"delete-667\";i:1904;s:10:\"delete-666\";i:1905;s:10:\"delete-668\";i:1906;s:10:\"delete-669\";i:1907;s:10:\"delete-671\";i:1908;s:10:\"delete-670\";i:1909;s:10:\"delete-672\";i:1910;s:10:\"delete-673\";i:1911;s:10:\"delete-675\";i:1912;s:10:\"delete-674\";i:1913;s:10:\"delete-676\";i:1914;s:10:\"delete-677\";i:1915;s:10:\"delete-679\";i:1916;s:10:\"delete-678\";i:1917;s:10:\"delete-680\";i:1918;s:10:\"delete-681\";i:1919;s:10:\"delete-683\";i:1920;s:10:\"delete-682\";i:1921;s:10:\"delete-684\";i:1922;s:10:\"delete-685\";i:1923;s:10:\"delete-687\";i:1924;s:10:\"delete-686\";i:1925;s:10:\"delete-688\";i:1926;s:10:\"delete-689\";i:1927;s:10:\"delete-691\";i:1928;s:10:\"delete-690\";i:1929;s:10:\"delete-692\";i:1930;s:10:\"delete-693\";i:1931;s:10:\"delete-695\";i:1932;s:10:\"delete-694\";i:1933;s:10:\"delete-696\";i:1934;s:10:\"delete-697\";i:1935;s:10:\"delete-699\";i:1936;s:10:\"delete-698\";i:1937;s:10:\"delete-700\";i:1938;s:10:\"delete-701\";i:1939;s:10:\"delete-703\";i:1940;s:10:\"delete-702\";i:1941;s:10:\"delete-704\";i:1942;s:10:\"delete-705\";i:1943;s:10:\"delete-707\";i:1944;s:10:\"delete-706\";i:1945;s:10:\"delete-708\";i:1946;s:10:\"delete-709\";i:1947;s:10:\"delete-711\";i:1948;s:10:\"delete-710\";i:1949;s:10:\"delete-712\";i:1950;s:10:\"delete-713\";i:1951;s:10:\"delete-715\";i:1952;s:10:\"delete-714\";i:1953;s:10:\"delete-716\";i:1954;s:10:\"delete-717\";i:1955;s:10:\"delete-719\";i:1956;s:10:\"delete-718\";i:1957;s:10:\"delete-720\";i:1958;s:10:\"delete-721\";i:1959;s:10:\"delete-723\";i:1960;s:10:\"delete-722\";i:1961;s:10:\"delete-724\";i:1962;s:10:\"delete-725\";i:1963;s:10:\"delete-727\";i:1964;s:10:\"delete-726\";i:1965;s:10:\"delete-728\";i:1966;s:10:\"delete-729\";i:1967;s:10:\"delete-731\";i:1968;s:10:\"delete-730\";i:1969;s:10:\"delete-732\";i:1970;s:10:\"delete-733\";i:1971;s:10:\"delete-735\";i:1972;s:10:\"delete-734\";i:1973;s:10:\"delete-736\";i:1974;s:10:\"delete-737\";i:1975;s:10:\"delete-739\";i:1976;s:10:\"delete-738\";i:1977;s:10:\"delete-740\";i:1978;s:10:\"delete-741\";i:1979;s:10:\"delete-743\";i:1980;s:10:\"delete-742\";i:1981;s:10:\"delete-744\";i:1982;s:10:\"delete-745\";i:1983;s:10:\"delete-747\";i:1984;s:10:\"delete-746\";i:1985;s:10:\"delete-748\";i:1986;s:10:\"delete-749\";i:1987;s:10:\"delete-751\";i:1988;s:10:\"delete-750\";i:1989;s:10:\"delete-752\";i:1990;s:10:\"delete-753\";i:1991;s:10:\"delete-755\";i:1992;s:10:\"delete-754\";i:1993;s:10:\"delete-756\";i:1994;s:10:\"delete-757\";i:1995;s:10:\"delete-759\";i:1996;s:10:\"delete-758\";i:1997;s:10:\"delete-760\";i:1998;s:10:\"delete-761\";i:1999;s:10:\"delete-763\";i:2000;s:10:\"delete-762\";i:2001;s:10:\"delete-764\";i:2002;s:10:\"delete-765\";i:2003;s:10:\"delete-767\";i:2004;s:10:\"delete-766\";i:2005;s:10:\"delete-768\";i:2006;s:10:\"delete-769\";i:2007;s:10:\"delete-771\";i:2008;s:10:\"delete-770\";i:2009;s:10:\"delete-772\";i:2010;s:10:\"delete-773\";i:2011;s:10:\"delete-775\";i:2012;s:10:\"delete-774\";i:2013;s:10:\"delete-776\";i:2014;s:10:\"delete-777\";i:2015;s:10:\"delete-779\";i:2016;s:10:\"delete-778\";i:2017;s:10:\"delete-780\";i:2018;s:10:\"delete-781\";i:2019;s:10:\"delete-783\";i:2020;s:10:\"delete-782\";i:2021;s:10:\"delete-784\";i:2022;s:10:\"delete-785\";i:2023;s:10:\"delete-787\";i:2024;s:10:\"delete-786\";i:2025;s:10:\"delete-788\";i:2026;s:10:\"delete-789\";i:2027;s:10:\"delete-791\";i:2028;s:10:\"delete-790\";i:2029;s:10:\"delete-792\";i:2030;s:10:\"delete-793\";i:2031;s:10:\"delete-795\";i:2032;s:10:\"delete-794\";i:2033;s:10:\"delete-796\";i:2034;s:10:\"delete-797\";i:2035;s:10:\"delete-799\";i:2036;s:10:\"delete-798\";i:2037;s:10:\"delete-800\";i:2038;s:10:\"delete-801\";i:2039;s:10:\"delete-803\";i:2040;s:10:\"delete-802\";i:2041;s:10:\"delete-804\";i:2042;s:10:\"delete-805\";i:2043;s:10:\"delete-807\";i:2044;s:10:\"delete-806\";i:2045;s:10:\"delete-808\";i:2046;s:10:\"delete-809\";i:2047;s:10:\"delete-811\";i:2048;s:10:\"delete-810\";i:2049;s:10:\"delete-812\";i:2050;s:10:\"delete-813\";i:2051;s:10:\"delete-815\";i:2052;s:10:\"delete-814\";i:2053;s:10:\"delete-816\";i:2054;s:10:\"delete-817\";i:2055;s:10:\"delete-819\";i:2056;s:10:\"delete-818\";i:2057;s:10:\"delete-820\";i:2058;s:10:\"delete-821\";i:2059;s:10:\"delete-823\";i:2060;s:10:\"delete-822\";i:2061;s:10:\"delete-824\";i:2062;s:10:\"delete-825\";i:2063;s:10:\"delete-827\";i:2064;s:10:\"delete-826\";i:2065;s:10:\"delete-828\";i:2066;s:10:\"delete-829\";i:2067;s:10:\"delete-831\";i:2068;s:10:\"delete-830\";i:2069;s:10:\"delete-832\";i:2070;s:10:\"delete-833\";i:2071;s:10:\"delete-835\";i:2072;s:10:\"delete-834\";i:2073;s:10:\"delete-836\";i:2074;s:10:\"delete-837\";i:2075;s:10:\"delete-839\";i:2076;s:10:\"delete-838\";i:2077;s:10:\"delete-840\";i:2078;s:10:\"delete-841\";i:2079;s:10:\"delete-843\";i:2080;s:10:\"delete-842\";i:2081;s:10:\"delete-844\";i:2082;s:10:\"delete-845\";i:2083;s:10:\"delete-847\";i:2084;s:10:\"delete-846\";i:2085;s:10:\"delete-848\";i:2086;s:10:\"delete-849\";i:2087;s:10:\"delete-851\";i:2088;s:10:\"delete-850\";i:2089;s:10:\"delete-852\";i:2090;s:10:\"delete-853\";i:2091;s:10:\"delete-855\";i:2092;s:10:\"delete-854\";i:2093;s:10:\"delete-856\";i:2094;s:10:\"delete-857\";i:2095;s:10:\"delete-859\";i:2096;s:10:\"delete-858\";i:2097;s:10:\"delete-860\";i:2098;s:10:\"delete-861\";i:2099;s:10:\"delete-863\";i:2100;s:10:\"delete-862\";i:2101;s:10:\"delete-864\";i:2102;s:10:\"delete-865\";i:2103;s:10:\"delete-867\";i:2104;s:10:\"delete-866\";i:2105;s:10:\"delete-868\";i:2106;s:10:\"delete-869\";i:2107;s:10:\"delete-871\";i:2108;s:10:\"delete-870\";i:2109;s:10:\"delete-872\";i:2110;s:10:\"delete-873\";i:2111;s:10:\"delete-875\";i:2112;s:10:\"delete-874\";i:2113;s:10:\"delete-876\";i:2114;s:10:\"delete-877\";i:2115;s:10:\"delete-879\";i:2116;s:10:\"delete-878\";i:2117;s:10:\"delete-880\";i:2118;s:10:\"delete-881\";i:2119;s:10:\"delete-883\";i:2120;s:10:\"delete-882\";i:2121;s:10:\"delete-884\";i:2122;s:10:\"delete-885\";i:2123;s:10:\"delete-887\";i:2124;s:10:\"delete-886\";i:2125;s:10:\"delete-888\";i:2126;s:10:\"delete-889\";i:2127;s:10:\"delete-891\";i:2128;s:10:\"delete-890\";i:2129;s:10:\"delete-892\";i:2130;s:10:\"delete-893\";i:2131;s:10:\"delete-895\";i:2132;s:10:\"delete-894\";i:2133;s:10:\"delete-896\";i:2134;s:10:\"delete-897\";i:2135;s:10:\"delete-899\";i:2136;s:10:\"delete-898\";i:2137;s:10:\"delete-900\";i:2138;s:10:\"delete-901\";i:2139;s:10:\"delete-903\";i:2140;s:10:\"delete-902\";i:2141;s:10:\"delete-904\";i:2142;s:10:\"delete-905\";i:2143;s:10:\"delete-907\";i:2144;s:10:\"delete-906\";i:2145;s:10:\"delete-908\";i:2146;s:10:\"delete-909\";i:2147;s:10:\"delete-911\";i:2148;s:10:\"delete-910\";i:2149;s:10:\"delete-912\";i:2150;s:10:\"delete-913\";i:2151;s:10:\"delete-915\";i:2152;s:10:\"delete-914\";i:2153;s:10:\"delete-916\";i:2154;s:10:\"delete-917\";i:2155;s:10:\"delete-919\";i:2156;s:10:\"delete-918\";i:2157;s:10:\"delete-920\";i:2158;s:10:\"delete-921\";i:2159;s:10:\"delete-923\";i:2160;s:10:\"delete-922\";i:2161;s:10:\"delete-924\";i:2162;s:10:\"delete-925\";i:2163;s:10:\"delete-927\";i:2164;s:10:\"delete-926\";i:2165;s:10:\"delete-928\";i:2166;s:10:\"delete-929\";i:2167;s:10:\"delete-931\";i:2168;s:10:\"delete-930\";i:2169;s:10:\"delete-932\";i:2170;s:10:\"delete-933\";i:2171;s:10:\"delete-935\";i:2172;s:10:\"delete-934\";i:2173;s:10:\"delete-936\";i:2174;s:10:\"delete-937\";i:2175;s:10:\"delete-939\";i:2176;s:10:\"delete-938\";i:2177;s:10:\"delete-940\";i:2178;s:10:\"delete-941\";i:2179;s:10:\"delete-943\";i:2180;s:10:\"delete-942\";i:2181;s:10:\"delete-944\";i:2182;s:10:\"delete-945\";i:2183;s:10:\"delete-947\";i:2184;s:10:\"delete-946\";i:2185;s:10:\"delete-948\";i:2186;s:10:\"delete-949\";i:2187;s:10:\"delete-951\";i:2188;s:10:\"delete-950\";i:2189;s:10:\"delete-952\";i:2190;s:10:\"delete-953\";i:2191;s:10:\"delete-955\";i:2192;s:10:\"delete-954\";i:2193;s:10:\"delete-956\";i:2194;s:10:\"delete-957\";i:2195;s:10:\"delete-959\";i:2196;s:10:\"delete-958\";i:2197;s:10:\"delete-960\";i:2198;s:10:\"delete-961\";i:2199;s:10:\"delete-963\";i:2200;s:10:\"delete-962\";i:2201;s:10:\"delete-964\";i:2202;s:10:\"delete-965\";i:2203;s:10:\"delete-967\";i:2204;s:10:\"delete-966\";i:2205;s:10:\"delete-968\";i:2206;s:10:\"delete-969\";i:2207;s:10:\"delete-971\";i:2208;s:10:\"delete-970\";i:2209;s:10:\"delete-972\";i:2210;s:10:\"delete-973\";i:2211;s:10:\"delete-975\";i:2212;s:10:\"delete-974\";i:2213;s:10:\"delete-976\";i:2214;s:10:\"delete-977\";i:2215;s:10:\"delete-979\";i:2216;s:10:\"delete-978\";i:2217;s:10:\"delete-980\";i:2218;s:10:\"delete-981\";i:2219;s:10:\"delete-983\";i:2220;s:10:\"delete-982\";i:2221;s:10:\"delete-984\";i:2222;s:10:\"delete-985\";i:2223;s:10:\"delete-987\";i:2224;s:10:\"delete-986\";i:2225;s:10:\"delete-988\";i:2226;s:10:\"delete-989\";i:2227;s:10:\"delete-991\";i:2228;s:10:\"delete-990\";i:2229;s:10:\"delete-992\";i:2230;s:10:\"delete-993\";i:2231;s:10:\"delete-995\";i:2232;s:10:\"delete-994\";i:2233;s:10:\"delete-996\";i:2234;s:10:\"delete-997\";i:2235;s:10:\"delete-999\";i:2236;s:10:\"delete-998\";i:2237;s:11:\"delete-1000\";i:2238;s:11:\"delete-1001\";i:2239;s:11:\"delete-1003\";i:2240;s:11:\"delete-1002\";i:2241;s:11:\"delete-1004\";i:2242;s:11:\"delete-1005\";i:2243;s:11:\"delete-1007\";i:2244;s:11:\"delete-1006\";i:2245;s:11:\"delete-1008\";i:2246;s:11:\"delete-1009\";i:2247;s:11:\"delete-1011\";i:2248;s:11:\"delete-1010\";i:2249;s:11:\"delete-1012\";i:2250;s:11:\"delete-1013\";i:2251;s:11:\"delete-1015\";i:2252;s:11:\"delete-1014\";i:2253;s:11:\"delete-1016\";i:2254;s:11:\"delete-1017\";i:2255;s:11:\"delete-1019\";i:2256;s:11:\"delete-1018\";i:2257;s:11:\"delete-1020\";i:2258;s:11:\"delete-1021\";i:2259;s:11:\"delete-1023\";i:2260;s:11:\"delete-1022\";i:2261;s:11:\"delete-1024\";i:2262;s:11:\"delete-1025\";i:2263;s:11:\"delete-1027\";i:2264;s:11:\"delete-1026\";i:2265;s:11:\"delete-1028\";i:2266;s:11:\"delete-1029\";i:2267;s:11:\"delete-1031\";i:2268;s:11:\"delete-1030\";i:2269;s:11:\"delete-1032\";i:2270;s:11:\"delete-1033\";i:2271;s:11:\"delete-1035\";i:2272;s:11:\"delete-1034\";i:2273;s:11:\"delete-1036\";i:2274;s:11:\"delete-1037\";i:2275;s:11:\"delete-1039\";i:2276;s:11:\"delete-1038\";i:2277;s:11:\"delete-1040\";i:2278;s:11:\"delete-1041\";i:2279;s:11:\"delete-1043\";i:2280;s:11:\"delete-1042\";i:2281;s:11:\"delete-1044\";i:2282;s:11:\"delete-1045\";i:2283;s:11:\"delete-1047\";i:2284;s:11:\"delete-1046\";i:2285;s:11:\"delete-1048\";i:2286;s:11:\"delete-1049\";i:2287;s:11:\"delete-1051\";i:2288;s:11:\"delete-1050\";i:2289;s:11:\"delete-1052\";i:2290;s:11:\"delete-1053\";i:2291;s:11:\"delete-1055\";i:2292;s:11:\"delete-1054\";i:2293;s:11:\"delete-1056\";i:2294;s:11:\"delete-1057\";i:2295;s:11:\"delete-1059\";i:2296;s:11:\"delete-1058\";i:2297;s:11:\"delete-1060\";i:2298;s:11:\"delete-1061\";i:2299;s:11:\"delete-1063\";i:2300;s:11:\"delete-1062\";i:2301;s:11:\"delete-1064\";i:2302;s:11:\"delete-1065\";i:2303;s:11:\"delete-1067\";i:2304;s:11:\"delete-1066\";i:2305;s:11:\"delete-1068\";i:2306;s:11:\"delete-1069\";i:2307;s:11:\"delete-1071\";i:2308;s:11:\"delete-1070\";i:2309;s:11:\"delete-1072\";i:2310;s:11:\"delete-1073\";i:2311;s:11:\"delete-1075\";i:2312;s:11:\"delete-1074\";i:2313;s:11:\"delete-1076\";i:2314;s:11:\"delete-1077\";i:2315;s:11:\"delete-1079\";i:2316;s:11:\"delete-1078\";i:2317;s:11:\"delete-1080\";i:2318;s:11:\"delete-1081\";i:2319;s:11:\"delete-1083\";i:2320;s:11:\"delete-1082\";i:2321;s:11:\"delete-1084\";i:2322;s:11:\"delete-1085\";i:2323;s:11:\"delete-1087\";i:2324;s:11:\"delete-1086\";i:2325;s:11:\"delete-1088\";i:2326;s:11:\"delete-1089\";i:2327;s:11:\"delete-1091\";i:2328;s:11:\"delete-1090\";i:2329;s:11:\"delete-1092\";i:2330;s:11:\"delete-1093\";i:2331;s:11:\"delete-1095\";i:2332;s:11:\"delete-1094\";i:2333;s:11:\"delete-1096\";i:2334;s:11:\"delete-1097\";i:2335;s:11:\"delete-1099\";i:2336;s:11:\"delete-1098\";i:2337;s:11:\"delete-1100\";i:2338;s:11:\"delete-1101\";i:2339;s:11:\"delete-1103\";i:2340;s:11:\"delete-1102\";i:2341;s:11:\"delete-1104\";i:2342;s:11:\"delete-1105\";i:2343;s:11:\"delete-1107\";i:2344;s:11:\"delete-1106\";i:2345;s:11:\"delete-1108\";i:2346;s:11:\"delete-1109\";i:2347;s:11:\"delete-1111\";i:2348;s:11:\"delete-1110\";i:2349;s:11:\"delete-1112\";i:2350;s:11:\"delete-1113\";i:2351;s:11:\"delete-1115\";i:2352;s:11:\"delete-1114\";i:2353;s:11:\"delete-1116\";i:2354;s:11:\"delete-1117\";i:2355;s:11:\"delete-1119\";i:2356;s:11:\"delete-1118\";i:2357;s:11:\"delete-1120\";i:2358;s:11:\"delete-1121\";i:2359;s:11:\"delete-1123\";i:2360;s:11:\"delete-1122\";i:2361;s:11:\"delete-1124\";i:2362;s:11:\"delete-1125\";i:2363;s:11:\"delete-1127\";i:2364;s:11:\"delete-1126\";i:2365;s:11:\"delete-1128\";i:2366;s:11:\"delete-1129\";i:2367;s:11:\"delete-1131\";i:2368;s:11:\"delete-1130\";i:2369;s:11:\"delete-1132\";i:2370;s:11:\"delete-1133\";i:2371;s:11:\"delete-1135\";i:2372;s:11:\"delete-1134\";i:2373;s:11:\"delete-1136\";i:2374;s:11:\"delete-1137\";i:2375;s:11:\"delete-1139\";i:2376;s:11:\"delete-1138\";i:2377;s:11:\"delete-1140\";i:2378;s:11:\"delete-1141\";i:2379;s:11:\"delete-1143\";i:2380;s:11:\"delete-1142\";i:2381;s:11:\"delete-1144\";i:2382;s:11:\"delete-1145\";i:2383;s:11:\"delete-1147\";i:2384;s:11:\"delete-1146\";i:2385;s:11:\"delete-1148\";i:2386;s:11:\"delete-1149\";i:2387;s:11:\"delete-1151\";i:2388;s:11:\"delete-1150\";i:2389;s:11:\"delete-1152\";i:2390;s:11:\"delete-1153\";i:2391;s:11:\"delete-1155\";i:2392;s:11:\"delete-1154\";i:2393;s:11:\"delete-1156\";i:2394;s:11:\"delete-1157\";i:2395;s:11:\"delete-1159\";i:2396;s:11:\"delete-1158\";i:2397;s:11:\"delete-1160\";i:2398;s:11:\"delete-1161\";i:2399;s:11:\"delete-1163\";i:2400;s:11:\"delete-1162\";i:2401;s:11:\"delete-1164\";i:2402;s:11:\"delete-1165\";i:2403;s:11:\"delete-1167\";i:2404;s:11:\"delete-1166\";i:2405;s:11:\"delete-1168\";i:2406;s:11:\"delete-1169\";i:2407;s:11:\"delete-1171\";i:2408;s:11:\"delete-1170\";i:2409;s:11:\"delete-1172\";i:2410;s:11:\"delete-1173\";i:2411;s:11:\"delete-1175\";i:2412;s:11:\"delete-1174\";i:2413;s:11:\"delete-1176\";i:2414;s:11:\"delete-1177\";i:2415;s:11:\"delete-1179\";i:2416;s:11:\"delete-1178\";i:2417;s:11:\"delete-1180\";i:2418;s:11:\"delete-1181\";i:2419;s:11:\"delete-1183\";i:2420;s:11:\"delete-1182\";i:2421;s:11:\"delete-1184\";i:2422;s:11:\"delete-1185\";i:2423;s:11:\"delete-1187\";i:2424;s:11:\"delete-1186\";i:2425;s:11:\"delete-1188\";i:2426;s:11:\"delete-1189\";i:2427;s:11:\"delete-1191\";i:2428;s:11:\"delete-1190\";i:2429;s:11:\"delete-1192\";i:2430;s:11:\"delete-1193\";i:2431;s:11:\"delete-1195\";i:2432;s:11:\"delete-1194\";i:2433;s:11:\"delete-1196\";i:2434;s:11:\"delete-1197\";i:2435;s:11:\"delete-1199\";i:2436;s:11:\"delete-1198\";i:2437;s:11:\"delete-1200\";i:2438;s:11:\"delete-1201\";i:2439;s:11:\"delete-1203\";i:2440;s:11:\"delete-1202\";i:2441;s:11:\"delete-1204\";i:2442;s:11:\"delete-1205\";i:2443;s:11:\"delete-1207\";i:2444;s:11:\"delete-1206\";i:2445;s:11:\"delete-1208\";i:2446;s:11:\"delete-1209\";i:2447;s:11:\"delete-1211\";i:2448;s:11:\"delete-1210\";i:2449;s:11:\"delete-1212\";i:2450;s:11:\"delete-1213\";i:2451;s:11:\"delete-1215\";i:2452;s:11:\"delete-1214\";i:2453;s:11:\"delete-1216\";i:2454;s:11:\"delete-1217\";i:2455;s:11:\"delete-1219\";i:2456;s:11:\"delete-1218\";i:2457;s:11:\"delete-1220\";i:2458;s:11:\"delete-1221\";i:2459;s:11:\"delete-1223\";i:2460;s:11:\"delete-1222\";i:2461;s:11:\"delete-1224\";i:2462;s:11:\"delete-1225\";i:2463;s:11:\"delete-1227\";i:2464;s:11:\"delete-1226\";i:2465;s:11:\"delete-1228\";i:2466;s:11:\"delete-1229\";i:2467;s:11:\"delete-1231\";i:2468;s:11:\"delete-1230\";i:2469;s:11:\"delete-1232\";i:2470;s:11:\"delete-1233\";i:2471;s:11:\"delete-1235\";i:2472;s:11:\"delete-1234\";i:2473;s:11:\"delete-1236\";i:2474;s:11:\"delete-1237\";i:2475;s:11:\"delete-1239\";i:2476;s:11:\"delete-1238\";i:2477;s:11:\"delete-1240\";i:2478;s:11:\"delete-1241\";i:2479;s:11:\"delete-1243\";i:2480;s:11:\"delete-1242\";i:2481;s:11:\"delete-1244\";i:2482;s:11:\"delete-1245\";i:2483;s:11:\"delete-1247\";i:2484;s:11:\"delete-1246\";i:2485;s:11:\"delete-1248\";i:2486;s:11:\"delete-1249\";i:2487;s:11:\"delete-1251\";i:2488;s:11:\"delete-1250\";i:2489;s:11:\"delete-1252\";i:2490;s:11:\"delete-1253\";i:2491;s:11:\"delete-1255\";i:2492;s:11:\"delete-1254\";i:2493;s:11:\"delete-1256\";i:2494;s:11:\"delete-1257\";i:2495;s:11:\"delete-1259\";i:2496;s:11:\"delete-1258\";i:2497;s:11:\"delete-1260\";i:2498;s:11:\"delete-1261\";i:2499;s:11:\"delete-1263\";i:2500;s:11:\"delete-1262\";i:2501;s:11:\"delete-1264\";i:2502;s:11:\"delete-1265\";i:2503;s:11:\"delete-1267\";i:2504;s:11:\"delete-1266\";i:2505;s:11:\"delete-1268\";i:2506;s:11:\"delete-1269\";i:2507;s:11:\"delete-1271\";i:2508;s:11:\"delete-1270\";i:2509;s:11:\"delete-1272\";i:2510;s:11:\"delete-1273\";i:2511;s:11:\"delete-1275\";i:2512;s:11:\"delete-1274\";i:2513;s:11:\"delete-1276\";i:2514;s:11:\"delete-1277\";i:2515;s:11:\"delete-1279\";i:2516;s:11:\"delete-1278\";i:2517;s:11:\"delete-1280\";i:2518;s:11:\"delete-1281\";i:2519;s:11:\"delete-1283\";i:2520;s:11:\"delete-1282\";i:2521;s:11:\"delete-1284\";i:2522;s:11:\"delete-1285\";i:2523;s:11:\"delete-1287\";i:2524;s:11:\"delete-1286\";i:2525;s:11:\"delete-1288\";i:2526;s:11:\"delete-1289\";i:2527;s:11:\"delete-1291\";i:2528;s:11:\"delete-1290\";i:2529;s:11:\"delete-1292\";i:2530;s:11:\"delete-1293\";i:2531;s:11:\"delete-1295\";i:2532;s:11:\"delete-1294\";i:2533;s:11:\"delete-1296\";i:2534;s:11:\"delete-1297\";i:2535;s:11:\"delete-1299\";i:2536;s:11:\"delete-1298\";i:2537;s:11:\"delete-1300\";i:2538;s:11:\"delete-1301\";i:2539;s:11:\"delete-1303\";i:2540;s:11:\"delete-1302\";i:2541;s:11:\"delete-1304\";i:2542;s:11:\"delete-1305\";i:2543;s:11:\"delete-1307\";i:2544;s:11:\"delete-1306\";i:2545;s:11:\"delete-1308\";i:2546;s:11:\"delete-1309\";i:2547;s:11:\"delete-1311\";i:2548;s:11:\"delete-1310\";i:2549;s:11:\"delete-1312\";i:2550;s:11:\"delete-1313\";i:2551;s:11:\"delete-1315\";i:2552;s:11:\"delete-1314\";i:2553;s:11:\"delete-1316\";i:2554;s:11:\"delete-1317\";i:2555;s:11:\"delete-1319\";i:2556;s:11:\"delete-1318\";i:2557;s:11:\"delete-1320\";i:2558;s:11:\"delete-1321\";i:2559;s:11:\"delete-1323\";i:2560;s:11:\"delete-1322\";i:2561;s:11:\"delete-1324\";i:2562;s:11:\"delete-1325\";i:2563;s:11:\"delete-1327\";i:2564;s:11:\"delete-1326\";i:2565;s:11:\"delete-1328\";i:2566;s:11:\"delete-1329\";i:2567;s:11:\"delete-1331\";i:2568;s:11:\"delete-1330\";i:2569;s:11:\"delete-1332\";i:2570;s:11:\"delete-1333\";i:2571;s:11:\"delete-1335\";i:2572;s:11:\"delete-1334\";i:2573;s:11:\"delete-1336\";i:2574;s:11:\"delete-1337\";i:2575;s:11:\"delete-1339\";i:2576;s:11:\"delete-1338\";i:2577;s:11:\"delete-1340\";i:2578;s:11:\"delete-1341\";i:2579;s:11:\"delete-1343\";i:2580;s:11:\"delete-1342\";i:2581;s:11:\"delete-1344\";i:2582;s:11:\"delete-1345\";i:2583;s:11:\"delete-1347\";i:2584;s:11:\"delete-1346\";i:2585;s:11:\"delete-1348\";i:2586;s:11:\"delete-1349\";i:2587;s:11:\"delete-1351\";i:2588;s:11:\"delete-1350\";i:2589;s:11:\"delete-1352\";i:2590;s:11:\"delete-1353\";i:2591;s:11:\"delete-1355\";i:2592;s:11:\"delete-1354\";i:2593;s:11:\"delete-1356\";i:2594;s:11:\"delete-1357\";i:2595;s:11:\"delete-1359\";i:2596;s:11:\"delete-1358\";i:2597;s:11:\"delete-1360\";i:2598;s:11:\"delete-1361\";i:2599;s:11:\"delete-1363\";i:2600;s:11:\"delete-1362\";i:2601;s:11:\"delete-1364\";i:2602;s:11:\"delete-1365\";i:2603;s:11:\"delete-1367\";i:2604;s:11:\"delete-1366\";i:2605;s:11:\"delete-1368\";i:2606;s:11:\"delete-1369\";i:2607;s:11:\"delete-1371\";i:2608;s:11:\"delete-1370\";i:2609;s:11:\"delete-1372\";i:2610;s:11:\"delete-1373\";i:2611;s:11:\"delete-1375\";i:2612;s:11:\"delete-1374\";i:2613;s:11:\"delete-1376\";i:2614;s:11:\"delete-1377\";i:2615;s:11:\"delete-1379\";i:2616;s:11:\"delete-1378\";i:2617;s:11:\"delete-1380\";i:2618;s:11:\"delete-1381\";i:2619;s:11:\"delete-1383\";i:2620;s:11:\"delete-1382\";i:2621;s:11:\"delete-1384\";i:2622;s:11:\"delete-1385\";i:2623;s:11:\"delete-1387\";i:2624;s:11:\"delete-1386\";i:2625;s:11:\"delete-1388\";i:2626;s:11:\"delete-1389\";i:2627;s:11:\"delete-1391\";i:2628;s:11:\"delete-1390\";i:2629;s:11:\"delete-1392\";i:2630;s:11:\"delete-1393\";i:2631;s:11:\"delete-1395\";i:2632;s:11:\"delete-1394\";i:2633;s:11:\"delete-1396\";i:2634;s:11:\"delete-1397\";i:2635;s:11:\"delete-1399\";i:2636;s:11:\"delete-1398\";i:2637;s:11:\"delete-1400\";i:2638;s:11:\"delete-1401\";i:2639;s:11:\"delete-1403\";i:2640;s:11:\"delete-1402\";i:2641;s:11:\"delete-1404\";i:2642;s:11:\"delete-1405\";i:2643;s:11:\"delete-1407\";i:2644;s:11:\"delete-1406\";i:2645;s:11:\"delete-1408\";i:2646;s:11:\"delete-1409\";i:2647;s:11:\"delete-1411\";i:2648;s:11:\"delete-1410\";i:2649;s:11:\"delete-1412\";i:2650;s:11:\"delete-1413\";i:2651;s:11:\"delete-1415\";i:2652;s:11:\"delete-1414\";i:2653;s:11:\"delete-1416\";i:2654;s:11:\"delete-1417\";i:2655;s:11:\"delete-1419\";i:2656;s:11:\"delete-1418\";i:2657;s:11:\"delete-1420\";i:2658;s:11:\"delete-1421\";i:2659;s:11:\"delete-1423\";i:2660;s:11:\"delete-1422\";i:2661;s:11:\"delete-1424\";i:2662;s:11:\"delete-1425\";i:2663;s:11:\"delete-1427\";i:2664;s:11:\"delete-1426\";i:2665;s:11:\"delete-1428\";i:2666;s:11:\"delete-1429\";i:2667;s:11:\"delete-1431\";i:2668;s:11:\"delete-1430\";i:2669;s:11:\"delete-1432\";i:2670;s:11:\"delete-1433\";i:2671;s:11:\"delete-1435\";i:2672;s:11:\"delete-1434\";i:2673;s:11:\"delete-1436\";i:2674;s:11:\"delete-1437\";i:2675;s:11:\"delete-1439\";i:2676;s:11:\"delete-1438\";i:2677;s:11:\"delete-1440\";i:2678;s:11:\"delete-1441\";i:2679;s:11:\"delete-1443\";i:2680;s:11:\"delete-1442\";i:2681;s:11:\"delete-1444\";i:2682;s:11:\"delete-1445\";i:2683;s:11:\"delete-1447\";i:2684;s:11:\"delete-1446\";i:2685;s:11:\"delete-1448\";i:2686;s:11:\"delete-1449\";i:2687;s:11:\"delete-1451\";i:2688;s:11:\"delete-1450\";i:2689;s:11:\"delete-1452\";i:2690;s:11:\"delete-1453\";i:2691;s:11:\"delete-1455\";i:2692;s:11:\"delete-1454\";i:2693;s:11:\"delete-1456\";i:2694;s:11:\"delete-1457\";i:2695;s:11:\"delete-1459\";i:2696;s:11:\"delete-1458\";i:2697;s:11:\"delete-1460\";i:2698;s:11:\"delete-1461\";i:2699;s:11:\"delete-1463\";i:2700;s:11:\"delete-1462\";i:2701;s:11:\"delete-1464\";i:2702;s:11:\"delete-1465\";i:2703;s:11:\"delete-1467\";i:2704;s:11:\"delete-1466\";i:2705;s:11:\"delete-1468\";i:2706;s:11:\"delete-1469\";i:2707;s:11:\"delete-1471\";i:2708;s:11:\"delete-1470\";i:2709;s:11:\"delete-1472\";i:2710;s:11:\"delete-1473\";i:2711;s:11:\"delete-1475\";i:2712;s:11:\"delete-1474\";i:2713;s:11:\"delete-1476\";i:2714;s:11:\"delete-1477\";i:2715;s:11:\"delete-1479\";i:2716;s:11:\"delete-1478\";i:2717;s:11:\"delete-1480\";i:2718;s:11:\"delete-1481\";i:2719;s:11:\"delete-1483\";i:2720;s:11:\"delete-1482\";i:2721;s:11:\"delete-1484\";i:2722;s:11:\"delete-1485\";i:2723;s:11:\"delete-1487\";i:2724;s:11:\"delete-1486\";i:2725;s:11:\"delete-1488\";i:2726;s:11:\"delete-1489\";i:2727;s:11:\"delete-1491\";i:2728;s:11:\"delete-1490\";i:2729;s:11:\"delete-1492\";i:2730;s:11:\"delete-1493\";i:2731;s:11:\"delete-1495\";i:2732;s:11:\"delete-1494\";i:2733;s:11:\"delete-1496\";i:2734;s:11:\"delete-1497\";i:2735;s:11:\"delete-1499\";i:2736;s:11:\"delete-1498\";i:2737;s:11:\"delete-1500\";i:2738;s:11:\"delete-1501\";i:2739;s:11:\"delete-1503\";i:2740;s:11:\"delete-1502\";i:2741;s:11:\"delete-1504\";i:2742;s:11:\"delete-1505\";i:2743;s:11:\"delete-1507\";i:2744;s:11:\"delete-1506\";i:2745;s:11:\"delete-1508\";i:2746;s:11:\"delete-1509\";i:2747;s:11:\"delete-1511\";i:2748;s:11:\"delete-1510\";i:2749;s:11:\"delete-1512\";i:2750;s:11:\"delete-1513\";i:2751;s:11:\"delete-1515\";i:2752;s:11:\"delete-1514\";i:2753;s:11:\"delete-1516\";i:2754;s:11:\"delete-1517\";i:2755;s:11:\"delete-1519\";i:2756;s:11:\"delete-1518\";i:2757;s:11:\"delete-1520\";i:2758;s:11:\"delete-1521\";i:2759;s:11:\"delete-1523\";i:2760;s:11:\"delete-1522\";i:2761;s:11:\"delete-1524\";i:2762;s:11:\"delete-1525\";i:2763;s:11:\"delete-1527\";i:2764;s:11:\"delete-1526\";i:2765;s:11:\"delete-1528\";i:2766;s:11:\"delete-1529\";i:2767;s:11:\"delete-1531\";i:2768;s:11:\"delete-1530\";i:2769;s:11:\"delete-1532\";i:2770;s:11:\"delete-1533\";i:2771;s:11:\"delete-1535\";i:2772;s:11:\"delete-1534\";i:2773;s:11:\"delete-1536\";i:2774;s:11:\"delete-1537\";i:2775;s:11:\"delete-1539\";i:2776;s:11:\"delete-1538\";i:2777;s:11:\"delete-1540\";i:2778;s:11:\"delete-1541\";i:2779;s:11:\"delete-1543\";i:2780;s:11:\"delete-1542\";i:2781;s:11:\"delete-1544\";i:2782;s:11:\"delete-1545\";i:2783;s:11:\"delete-1547\";i:2784;s:11:\"delete-1546\";i:2785;s:11:\"delete-1548\";i:2786;s:11:\"delete-1549\";i:2787;s:11:\"delete-1551\";i:2788;s:11:\"delete-1550\";i:2789;s:11:\"delete-1552\";i:2790;s:11:\"delete-1553\";i:2791;s:11:\"delete-1555\";i:2792;s:11:\"delete-1554\";i:2793;s:11:\"delete-1556\";i:2794;s:11:\"delete-1557\";i:2795;s:11:\"delete-1559\";i:2796;s:11:\"delete-1558\";i:2797;s:11:\"delete-1560\";i:2798;s:11:\"delete-1561\";i:2799;s:11:\"delete-1563\";i:2800;s:11:\"delete-1562\";i:2801;s:11:\"delete-1564\";i:2802;s:11:\"delete-1565\";i:2803;s:11:\"delete-1567\";i:2804;s:11:\"delete-1566\";i:2805;s:11:\"delete-1568\";i:2806;s:11:\"delete-1569\";i:2807;s:11:\"delete-1571\";i:2808;s:11:\"delete-1570\";i:2809;s:11:\"delete-1572\";i:2810;s:11:\"delete-1573\";i:2811;s:11:\"delete-1575\";i:2812;s:11:\"delete-1574\";i:2813;s:11:\"delete-1576\";i:2814;s:11:\"delete-1577\";i:2815;s:11:\"delete-1579\";i:2816;s:11:\"delete-1578\";i:2817;s:11:\"delete-1580\";i:2818;s:11:\"delete-1581\";i:2819;s:11:\"delete-1583\";i:2820;s:11:\"delete-1582\";i:2821;s:11:\"delete-1584\";i:2822;s:11:\"delete-1585\";i:2823;s:11:\"delete-1587\";i:2824;s:11:\"delete-1586\";i:2825;s:11:\"delete-1588\";i:2826;s:11:\"delete-1589\";i:2827;s:11:\"delete-1591\";i:2828;s:11:\"delete-1590\";i:2829;s:11:\"delete-1592\";i:2830;s:11:\"delete-1593\";i:2831;s:11:\"delete-1595\";i:2832;s:11:\"delete-1594\";i:2833;s:11:\"delete-1596\";i:2834;s:11:\"delete-1597\";i:2835;s:11:\"delete-1599\";i:2836;s:11:\"delete-1598\";i:2837;s:11:\"delete-1600\";i:2838;s:11:\"delete-1601\";i:2839;s:11:\"delete-1603\";i:2840;s:11:\"delete-1602\";i:2841;s:11:\"delete-1604\";i:2842;s:11:\"delete-1605\";i:2843;s:11:\"delete-1607\";i:2844;s:11:\"delete-1606\";i:2845;s:11:\"delete-1608\";i:2846;s:11:\"delete-1609\";i:2847;s:11:\"delete-1611\";i:2848;s:11:\"delete-1610\";i:2849;s:11:\"delete-1612\";i:2850;s:11:\"delete-1613\";i:2851;s:11:\"delete-1615\";i:2852;s:11:\"delete-1614\";i:2853;s:11:\"delete-1616\";i:2854;s:11:\"delete-1617\";i:2855;s:11:\"delete-1619\";i:2856;s:11:\"delete-1618\";i:2857;s:11:\"delete-1620\";i:2858;s:11:\"delete-1621\";i:2859;s:11:\"delete-1623\";i:2860;s:11:\"delete-1622\";i:2861;s:11:\"delete-1624\";i:2862;s:11:\"delete-1625\";i:2863;s:11:\"delete-1627\";i:2864;s:11:\"delete-1626\";i:2865;s:11:\"delete-1628\";i:2866;s:11:\"delete-1629\";i:2867;s:11:\"delete-1631\";i:2868;s:11:\"delete-1630\";i:2869;s:11:\"delete-1632\";i:2870;s:11:\"delete-1633\";i:2871;s:11:\"delete-1635\";i:2872;s:11:\"delete-1634\";i:2873;s:11:\"delete-1636\";i:2874;s:11:\"delete-1637\";i:2875;s:11:\"delete-1639\";i:2876;s:11:\"delete-1638\";i:2877;s:11:\"delete-1640\";i:2878;s:11:\"delete-1641\";i:2879;s:11:\"delete-1643\";i:2880;s:11:\"delete-1642\";i:2881;s:11:\"delete-1644\";i:2882;s:11:\"delete-1645\";i:2883;s:11:\"delete-1647\";i:2884;s:11:\"delete-1646\";i:2885;s:11:\"delete-1648\";i:2886;s:11:\"delete-1649\";i:2887;s:11:\"delete-1651\";i:2888;s:11:\"delete-1650\";i:2889;s:11:\"delete-1652\";i:2890;s:11:\"delete-1653\";i:2891;s:11:\"delete-1655\";i:2892;s:11:\"delete-1654\";i:2893;s:11:\"delete-1656\";i:2894;s:11:\"delete-1657\";i:2895;s:11:\"delete-1659\";i:2896;s:11:\"delete-1658\";i:2897;s:11:\"delete-1660\";i:2898;s:11:\"delete-1661\";i:2899;s:11:\"delete-1663\";i:2900;s:11:\"delete-1662\";i:2901;s:11:\"delete-1664\";i:2902;s:11:\"delete-1665\";i:2903;s:11:\"delete-1667\";i:2904;s:11:\"delete-1666\";i:2905;s:11:\"delete-1668\";i:2906;s:11:\"delete-1669\";i:2907;s:11:\"delete-1671\";i:2908;s:11:\"delete-1670\";i:2909;s:11:\"delete-1672\";i:2910;s:11:\"delete-1673\";i:2911;s:11:\"delete-1675\";i:2912;s:11:\"delete-1674\";i:2913;s:11:\"delete-1676\";i:2914;s:11:\"delete-1677\";i:2915;s:11:\"delete-1679\";i:2916;s:11:\"delete-1678\";i:2917;s:11:\"delete-1680\";i:2918;s:11:\"delete-1681\";i:2919;s:11:\"delete-1683\";i:2920;s:11:\"delete-1682\";i:2921;s:11:\"delete-1684\";i:2922;s:11:\"delete-1685\";i:2923;s:11:\"delete-1687\";i:2924;s:11:\"delete-1686\";i:2925;s:11:\"delete-1688\";i:2926;s:11:\"delete-1689\";i:2927;s:11:\"delete-1691\";i:2928;s:11:\"delete-1690\";i:2929;s:11:\"delete-1692\";i:2930;s:11:\"delete-1693\";i:2931;s:11:\"delete-1695\";i:2932;s:11:\"delete-1694\";i:2933;s:11:\"delete-1696\";i:2934;s:11:\"delete-1697\";i:2935;s:11:\"delete-1699\";i:2936;s:11:\"delete-1698\";i:2937;s:11:\"delete-1700\";i:2938;s:11:\"delete-1701\";i:2939;s:11:\"delete-1703\";i:2940;s:11:\"delete-1702\";i:2941;s:11:\"delete-1704\";i:2942;s:11:\"delete-1705\";i:2943;s:11:\"delete-1707\";i:2944;s:11:\"delete-1706\";i:2945;s:11:\"delete-1708\";i:2946;s:11:\"delete-1709\";i:2947;s:11:\"delete-1711\";i:2948;s:11:\"delete-1710\";i:2949;s:11:\"delete-1712\";i:2950;s:11:\"delete-1713\";i:2951;s:11:\"delete-1715\";i:2952;s:11:\"delete-1714\";i:2953;s:11:\"delete-1716\";i:2954;s:11:\"delete-1717\";i:2955;s:11:\"delete-1719\";i:2956;s:11:\"delete-1718\";i:2957;s:11:\"delete-1720\";i:2958;s:11:\"delete-1721\";i:2959;s:11:\"delete-1723\";i:2960;s:11:\"delete-1722\";i:2961;s:11:\"delete-1724\";i:2962;s:11:\"delete-1725\";i:2963;s:11:\"delete-1727\";i:2964;s:11:\"delete-1726\";i:2965;s:11:\"delete-1728\";i:2966;s:11:\"delete-1729\";i:2967;s:11:\"delete-1731\";i:2968;s:11:\"delete-1730\";i:2969;s:11:\"delete-1732\";i:2970;s:11:\"delete-1733\";i:2971;s:11:\"delete-1735\";i:2972;s:11:\"delete-1734\";i:2973;s:11:\"delete-1736\";i:2974;s:11:\"delete-1737\";i:2975;s:11:\"delete-1739\";i:2976;s:11:\"delete-1738\";i:2977;s:11:\"delete-1740\";i:2978;s:11:\"delete-1741\";i:2979;s:11:\"delete-1743\";i:2980;s:11:\"delete-1742\";i:2981;s:11:\"delete-1744\";i:2982;s:11:\"delete-1745\";i:2983;s:11:\"delete-1747\";i:2984;s:11:\"delete-1746\";i:2985;s:11:\"delete-1748\";i:2986;s:11:\"delete-1749\";i:2987;s:11:\"delete-1751\";i:2988;s:11:\"delete-1750\";i:2989;s:11:\"delete-1752\";i:2990;s:11:\"delete-1753\";i:2991;s:11:\"delete-1755\";i:2992;s:11:\"delete-1754\";i:2993;s:11:\"delete-1756\";i:2994;s:11:\"delete-1757\";i:2995;s:11:\"delete-1759\";i:2996;s:11:\"delete-1758\";i:2997;s:11:\"delete-1760\";i:2998;s:11:\"delete-1761\";i:2999;s:11:\"delete-1763\";i:3000;s:11:\"delete-1762\";i:3001;s:11:\"delete-1764\";i:3002;s:11:\"delete-1765\";i:3003;s:11:\"delete-1767\";i:3004;s:11:\"delete-1766\";i:3005;s:11:\"delete-1768\";i:3006;s:11:\"delete-1769\";i:3007;s:11:\"delete-1771\";i:3008;s:11:\"delete-1770\";i:3009;s:11:\"delete-1772\";i:3010;s:11:\"delete-1773\";i:3011;s:11:\"delete-1775\";i:3012;s:11:\"delete-1774\";i:3013;s:11:\"delete-1776\";i:3014;s:11:\"delete-1777\";i:3015;s:11:\"delete-1779\";i:3016;s:11:\"delete-1778\";i:3017;s:11:\"delete-1780\";i:3018;s:11:\"delete-1781\";i:3019;s:11:\"delete-1783\";i:3020;s:11:\"delete-1782\";i:3021;s:11:\"delete-1784\";i:3022;s:11:\"delete-1785\";i:3023;s:11:\"delete-1787\";i:3024;s:11:\"delete-1786\";i:3025;s:11:\"delete-1788\";i:3026;s:11:\"delete-1789\";i:3027;s:11:\"delete-1791\";i:3028;s:11:\"delete-1790\";i:3029;s:11:\"delete-1792\";i:3030;s:11:\"delete-1793\";i:3031;s:11:\"delete-1795\";i:3032;s:11:\"delete-1794\";i:3033;s:11:\"delete-1796\";i:3034;s:11:\"delete-1797\";i:3035;s:11:\"delete-1799\";i:3036;s:11:\"delete-1798\";i:3037;s:11:\"delete-1800\";i:3038;s:11:\"delete-1801\";i:3039;s:11:\"delete-1803\";i:3040;s:11:\"delete-1802\";i:3041;s:11:\"delete-1804\";i:3042;s:11:\"delete-1805\";i:3043;s:11:\"delete-1807\";i:3044;s:11:\"delete-1806\";i:3045;s:11:\"delete-1808\";i:3046;s:11:\"delete-1809\";i:3047;s:11:\"delete-1811\";i:3048;s:11:\"delete-1810\";i:3049;s:11:\"delete-1812\";i:3050;s:11:\"delete-1813\";i:3051;s:11:\"delete-1815\";i:3052;s:11:\"delete-1814\";i:3053;s:11:\"delete-1816\";i:3054;s:11:\"delete-1817\";i:3055;s:11:\"delete-1819\";i:3056;s:11:\"delete-1818\";i:3057;s:11:\"delete-1820\";i:3058;s:11:\"delete-1821\";i:3059;s:11:\"delete-1823\";i:3060;s:11:\"delete-1822\";i:3061;s:11:\"delete-1824\";i:3062;s:11:\"delete-1825\";i:3063;s:11:\"delete-1827\";i:3064;s:11:\"delete-1826\";i:3065;s:11:\"delete-1828\";i:3066;s:11:\"delete-1829\";i:3067;s:11:\"delete-1831\";i:3068;s:11:\"delete-1830\";i:3069;s:11:\"delete-1832\";i:3070;s:11:\"delete-1833\";i:3071;s:11:\"delete-1835\";i:3072;s:11:\"delete-1834\";i:3073;s:11:\"delete-1836\";i:3074;s:11:\"delete-1837\";i:3075;s:11:\"delete-1839\";i:3076;s:11:\"delete-1838\";i:3077;s:11:\"delete-1840\";i:3078;s:11:\"delete-1841\";i:3079;s:11:\"delete-1843\";i:3080;s:11:\"delete-1842\";i:3081;s:11:\"delete-1844\";i:3082;s:11:\"delete-1845\";i:3083;s:11:\"delete-1847\";i:3084;s:11:\"delete-1846\";i:3085;s:11:\"delete-1848\";i:3086;s:11:\"delete-1849\";i:3087;s:11:\"delete-1851\";i:3088;s:11:\"delete-1850\";i:3089;s:11:\"delete-1852\";i:3090;s:11:\"delete-1853\";i:3091;s:11:\"delete-1855\";i:3092;s:11:\"delete-1854\";i:3093;s:11:\"delete-1856\";i:3094;s:11:\"delete-1857\";i:3095;s:11:\"delete-1859\";i:3096;s:11:\"delete-1858\";i:3097;s:11:\"delete-1860\";i:3098;s:11:\"delete-1861\";i:3099;s:11:\"delete-1863\";i:3100;s:11:\"delete-1862\";i:3101;s:11:\"delete-1864\";i:3102;s:11:\"delete-1865\";i:3103;s:11:\"delete-1867\";i:3104;s:11:\"delete-1866\";i:3105;s:11:\"delete-1868\";i:3106;s:11:\"delete-1869\";i:3107;s:11:\"delete-1871\";i:3108;s:11:\"delete-1870\";i:3109;s:11:\"delete-1872\";i:3110;s:11:\"delete-1873\";i:3111;s:11:\"delete-1875\";i:3112;s:11:\"delete-1874\";i:3113;s:11:\"delete-1876\";i:3114;s:11:\"delete-1877\";i:3115;s:11:\"delete-1879\";i:3116;s:11:\"delete-1878\";i:3117;s:11:\"delete-1880\";i:3118;s:11:\"delete-1881\";i:3119;s:11:\"delete-1883\";i:3120;s:11:\"delete-1882\";i:3121;s:11:\"delete-1884\";i:3122;s:11:\"delete-1885\";i:3123;s:11:\"delete-1887\";i:3124;s:11:\"delete-1886\";i:3125;s:11:\"delete-1888\";i:3126;s:11:\"delete-1889\";i:3127;s:11:\"delete-1891\";i:3128;s:11:\"delete-1890\";i:3129;s:11:\"delete-1892\";i:3130;s:11:\"delete-1893\";i:3131;s:11:\"delete-1895\";i:3132;s:11:\"delete-1894\";i:3133;s:11:\"delete-1896\";i:3134;s:11:\"delete-1897\";i:3135;s:11:\"delete-1899\";i:3136;s:11:\"delete-1898\";i:3137;s:11:\"delete-1900\";i:3138;s:11:\"delete-1901\";i:3139;s:11:\"delete-1903\";i:3140;s:11:\"delete-1902\";i:3141;s:11:\"delete-1904\";i:3142;s:11:\"delete-1905\";i:3143;s:11:\"delete-1907\";i:3144;s:11:\"delete-1906\";i:3145;s:11:\"delete-1908\";i:3146;s:11:\"delete-1909\";i:3147;s:11:\"delete-1911\";i:3148;s:11:\"delete-1910\";i:3149;s:11:\"delete-1912\";i:3150;s:11:\"delete-1913\";i:3151;s:11:\"delete-1915\";i:3152;s:11:\"delete-1914\";i:3153;s:11:\"delete-1916\";i:3154;s:11:\"delete-1917\";i:3155;s:11:\"delete-1919\";i:3156;s:11:\"delete-1918\";i:3157;s:11:\"delete-1920\";i:3158;s:11:\"delete-1921\";i:3159;s:11:\"delete-1923\";i:3160;s:11:\"delete-1922\";i:3161;s:11:\"delete-1924\";i:3162;s:11:\"delete-1925\";i:3163;s:11:\"delete-1927\";i:3164;s:11:\"delete-1926\";i:3165;s:11:\"delete-1928\";i:3166;s:11:\"delete-1929\";i:3167;s:11:\"delete-1931\";i:3168;s:11:\"delete-1930\";i:3169;s:11:\"delete-1932\";i:3170;s:11:\"delete-1933\";i:3171;s:11:\"delete-1935\";i:3172;s:11:\"delete-1934\";i:3173;s:11:\"delete-1936\";i:3174;s:11:\"delete-1937\";i:3175;s:11:\"delete-1939\";i:3176;s:11:\"delete-1938\";i:3177;s:11:\"delete-1940\";i:3178;s:11:\"delete-1941\";i:3179;s:11:\"delete-1943\";i:3180;s:11:\"delete-1942\";i:3181;s:11:\"delete-1944\";i:3182;s:11:\"delete-1945\";i:3183;s:11:\"delete-1947\";i:3184;s:11:\"delete-1946\";i:3185;s:11:\"delete-1948\";i:3186;s:11:\"delete-1949\";i:3187;s:11:\"delete-1951\";i:3188;s:11:\"delete-1950\";i:3189;s:11:\"delete-1952\";i:3190;s:11:\"delete-1953\";i:3191;s:11:\"delete-1955\";i:3192;s:11:\"delete-1954\";i:3193;s:11:\"delete-1956\";i:3194;s:11:\"delete-1957\";i:3195;s:11:\"delete-1959\";i:3196;s:11:\"delete-1958\";i:3197;s:11:\"delete-1960\";i:3198;s:11:\"delete-1961\";i:3199;s:11:\"delete-1963\";i:3200;s:11:\"delete-1962\";i:3201;s:11:\"delete-1964\";i:3202;s:11:\"delete-1965\";i:3203;s:11:\"delete-1967\";i:3204;s:11:\"delete-1966\";i:3205;s:11:\"delete-1968\";i:3206;s:11:\"delete-1969\";i:3207;s:11:\"delete-1971\";i:3208;s:11:\"delete-1970\";i:3209;s:11:\"delete-1972\";i:3210;s:11:\"delete-1973\";i:3211;s:11:\"delete-1975\";i:3212;s:11:\"delete-1974\";i:3213;s:11:\"delete-1976\";i:3214;s:11:\"delete-1977\";i:3215;s:11:\"delete-1979\";i:3216;s:11:\"delete-1978\";i:3217;s:11:\"delete-1980\";i:3218;s:11:\"delete-1981\";i:3219;s:11:\"delete-1983\";i:3220;s:11:\"delete-1982\";i:3221;s:11:\"delete-1984\";i:3222;s:11:\"delete-1985\";i:3223;s:11:\"delete-1987\";i:3224;s:11:\"delete-1986\";i:3225;s:11:\"delete-1988\";i:3226;s:11:\"delete-1989\";i:3227;s:11:\"delete-1991\";i:3228;s:11:\"delete-1990\";i:3229;s:11:\"delete-1992\";i:3230;s:11:\"delete-1993\";i:3231;s:11:\"delete-1995\";i:3232;s:11:\"delete-1994\";i:3233;s:11:\"delete-1996\";i:3234;s:11:\"delete-1997\";i:3235;s:11:\"delete-1999\";i:3236;s:11:\"delete-1998\";i:3237;s:11:\"delete-2000\";i:3238;s:11:\"delete-2001\";i:3239;s:11:\"delete-2003\";i:3240;s:11:\"delete-2002\";i:3241;s:11:\"delete-2004\";i:3242;s:11:\"delete-2005\";i:3243;s:11:\"delete-2007\";i:3244;s:11:\"delete-2006\";i:3245;s:11:\"delete-2008\";i:3246;s:11:\"delete-2009\";i:3247;s:11:\"delete-2011\";i:3248;s:11:\"delete-2010\";i:3249;s:11:\"delete-2012\";i:3250;s:11:\"delete-2013\";i:3251;s:11:\"delete-2015\";i:3252;s:11:\"delete-2014\";i:3253;s:11:\"delete-2016\";i:3254;s:11:\"delete-2017\";i:3255;s:11:\"delete-2019\";i:3256;s:11:\"delete-2018\";i:3257;s:11:\"delete-2020\";i:3258;s:11:\"delete-2021\";i:3259;s:11:\"delete-2023\";i:3260;s:11:\"delete-2022\";i:3261;s:11:\"delete-2024\";i:3262;s:11:\"delete-2025\";i:3263;s:11:\"delete-2027\";i:3264;s:11:\"delete-2026\";i:3265;s:11:\"delete-2028\";i:3266;s:11:\"delete-2029\";i:3267;s:11:\"delete-2031\";i:3268;s:11:\"delete-2030\";i:3269;s:11:\"delete-2032\";i:3270;s:11:\"delete-2033\";i:3271;s:11:\"delete-2035\";i:3272;s:11:\"delete-2034\";i:3273;s:11:\"delete-2036\";i:3274;s:11:\"delete-2037\";i:3275;s:11:\"delete-2039\";i:3276;s:11:\"delete-2038\";i:3277;s:11:\"delete-2040\";i:3278;s:11:\"delete-2041\";i:3279;s:11:\"delete-2043\";i:3280;s:11:\"delete-2042\";i:3281;s:11:\"delete-2044\";i:3282;s:11:\"delete-2045\";i:3283;s:11:\"delete-2047\";i:3284;s:11:\"delete-2046\";i:3285;s:11:\"delete-2048\";i:3286;s:11:\"delete-2049\";i:3287;s:11:\"delete-2051\";i:3288;s:11:\"delete-2050\";i:3289;s:11:\"delete-2052\";i:3290;s:11:\"delete-2053\";i:3291;s:11:\"delete-2055\";i:3292;s:11:\"delete-2054\";i:3293;s:11:\"delete-2056\";i:3294;s:11:\"delete-2057\";i:3295;s:11:\"delete-2059\";i:3296;s:11:\"delete-2058\";i:3297;s:11:\"delete-2060\";i:3298;s:11:\"delete-2061\";i:3299;s:11:\"delete-2063\";i:3300;s:11:\"delete-2062\";i:3301;s:11:\"delete-2064\";i:3302;s:11:\"delete-2065\";i:3303;s:11:\"delete-2067\";i:3304;s:11:\"delete-2066\";i:3305;s:11:\"delete-2068\";i:3306;s:11:\"delete-2069\";i:3307;s:11:\"delete-2071\";i:3308;s:11:\"delete-2070\";i:3309;s:11:\"delete-2072\";i:3310;s:11:\"delete-2073\";i:3311;s:11:\"delete-2075\";i:3312;s:11:\"delete-2074\";i:3313;s:11:\"delete-2076\";i:3314;s:11:\"delete-2077\";i:3315;s:11:\"delete-2079\";i:3316;s:11:\"delete-2078\";i:3317;s:11:\"delete-2080\";i:3318;s:11:\"delete-2081\";i:3319;s:11:\"delete-2083\";i:3320;s:11:\"delete-2082\";i:3321;s:11:\"delete-2084\";i:3322;s:11:\"delete-2085\";i:3323;s:11:\"delete-2087\";i:3324;s:11:\"delete-2086\";i:3325;s:11:\"delete-2088\";i:3326;s:11:\"delete-2089\";i:3327;s:11:\"delete-2091\";i:3328;s:11:\"delete-2090\";i:3329;s:11:\"delete-2092\";i:3330;s:11:\"delete-2093\";i:3331;s:11:\"delete-2095\";i:3332;s:11:\"delete-2094\";i:3333;s:11:\"delete-2096\";i:3334;s:11:\"delete-2097\";i:3335;s:11:\"delete-2099\";i:3336;s:11:\"delete-2098\";i:3337;s:11:\"delete-2100\";i:3338;s:11:\"delete-2101\";i:3339;s:11:\"delete-2103\";i:3340;s:11:\"delete-2102\";i:3341;s:11:\"delete-2104\";i:3342;s:11:\"delete-2105\";i:3343;s:11:\"delete-2107\";i:3344;s:11:\"delete-2106\";i:3345;s:11:\"delete-2108\";i:3346;s:11:\"delete-2109\";i:3347;s:11:\"delete-2111\";i:3348;s:11:\"delete-2110\";i:3349;s:11:\"delete-2112\";i:3350;s:11:\"delete-2113\";i:3351;s:11:\"delete-2115\";i:3352;s:11:\"delete-2114\";i:3353;s:11:\"delete-2116\";i:3354;s:11:\"delete-2117\";i:3355;s:11:\"delete-2119\";i:3356;s:11:\"delete-2118\";i:3357;s:11:\"delete-2120\";i:3358;s:11:\"delete-2121\";i:3359;s:11:\"delete-2123\";i:3360;s:11:\"delete-2122\";i:3361;s:11:\"delete-2124\";i:3362;s:11:\"delete-2125\";i:3363;s:11:\"delete-2127\";i:3364;s:11:\"delete-2126\";i:3365;s:11:\"delete-2128\";i:3366;s:11:\"delete-2129\";i:3367;s:11:\"delete-2131\";i:3368;s:11:\"delete-2130\";i:3369;s:11:\"delete-2132\";i:3370;s:11:\"delete-2133\";i:3371;s:11:\"delete-2135\";i:3372;s:11:\"delete-2134\";i:3373;s:11:\"delete-2136\";i:3374;s:11:\"delete-2137\";i:3375;s:11:\"delete-2139\";i:3376;s:11:\"delete-2138\";i:3377;s:11:\"delete-2140\";i:3378;s:11:\"delete-2141\";i:3379;s:11:\"delete-2143\";i:3380;s:11:\"delete-2142\";i:3381;s:11:\"delete-2144\";i:3382;s:11:\"delete-2145\";i:3383;s:11:\"delete-2147\";i:3384;s:11:\"delete-2146\";i:3385;s:11:\"delete-2148\";i:3386;s:11:\"delete-2149\";i:3387;s:11:\"delete-2151\";i:3388;s:11:\"delete-2150\";i:3389;s:11:\"delete-2152\";i:3390;s:11:\"delete-2153\";i:3391;s:11:\"delete-2155\";i:3392;s:11:\"delete-2154\";i:3393;s:11:\"delete-2156\";i:3394;s:11:\"delete-2157\";i:3395;s:11:\"delete-2159\";i:3396;s:11:\"delete-2158\";i:3397;s:11:\"delete-2160\";i:3398;s:11:\"delete-2161\";i:3399;s:11:\"delete-2163\";i:3400;s:11:\"delete-2162\";i:3401;s:11:\"delete-2164\";i:3402;s:11:\"delete-2165\";i:3403;s:11:\"delete-2167\";i:3404;s:11:\"delete-2166\";i:3405;s:11:\"delete-2168\";i:3406;s:11:\"delete-2169\";i:3407;s:11:\"delete-2171\";i:3408;s:11:\"delete-2170\";i:3409;s:11:\"delete-2172\";i:3410;s:11:\"delete-2173\";i:3411;s:11:\"delete-2175\";i:3412;s:11:\"delete-2174\";i:3413;s:11:\"delete-2176\";i:3414;s:11:\"delete-2177\";i:3415;s:11:\"delete-2179\";i:3416;s:11:\"delete-2178\";i:3417;s:11:\"delete-2180\";i:3418;s:11:\"delete-2181\";i:3419;s:11:\"delete-2183\";i:3420;s:11:\"delete-2182\";i:3421;s:11:\"delete-2184\";i:3422;s:11:\"delete-2185\";i:3423;s:11:\"delete-2187\";i:3424;s:11:\"delete-2186\";i:3425;s:11:\"delete-2188\";i:3426;s:11:\"delete-2189\";i:3427;s:11:\"delete-2191\";i:3428;s:11:\"delete-2190\";i:3429;s:11:\"delete-2192\";i:3430;s:11:\"delete-2193\";i:3431;s:11:\"delete-2195\";i:3432;s:11:\"delete-2194\";i:3433;s:11:\"delete-2196\";i:3434;s:11:\"delete-2197\";i:3435;s:11:\"delete-2199\";i:3436;s:11:\"delete-2198\";i:3437;s:11:\"delete-2200\";i:3438;s:11:\"delete-2201\";i:3439;s:11:\"delete-2203\";i:3440;s:11:\"delete-2202\";i:3441;s:11:\"delete-2204\";i:3442;s:11:\"delete-2205\";i:3443;s:11:\"delete-2207\";i:3444;s:11:\"delete-2206\";i:3445;s:11:\"delete-2208\";i:3446;s:11:\"delete-2209\";i:3447;s:11:\"delete-2211\";i:3448;s:11:\"delete-2210\";i:3449;s:11:\"delete-2212\";i:3450;s:11:\"delete-2213\";i:3451;s:11:\"delete-2215\";i:3452;s:11:\"delete-2214\";i:3453;s:11:\"delete-2216\";i:3454;s:11:\"delete-2217\";i:3455;s:11:\"delete-2219\";i:3456;s:11:\"delete-2218\";i:3457;s:11:\"delete-2220\";i:3458;s:11:\"delete-2221\";i:3459;s:11:\"delete-2223\";i:3460;s:11:\"delete-2222\";i:3461;s:11:\"delete-2224\";i:3462;s:11:\"delete-2225\";i:3463;s:11:\"delete-2227\";i:3464;s:11:\"delete-2226\";i:3465;s:11:\"delete-2228\";i:3466;s:11:\"delete-2229\";i:3467;s:11:\"delete-2231\";i:3468;s:11:\"delete-2230\";i:3469;s:11:\"delete-2232\";i:3470;s:11:\"delete-2233\";i:3471;s:11:\"delete-2235\";i:3472;s:11:\"delete-2234\";i:3473;s:11:\"delete-2236\";i:3474;s:11:\"delete-2237\";i:3475;s:11:\"delete-2239\";i:3476;s:11:\"delete-2238\";i:3477;s:11:\"delete-2240\";i:3478;s:11:\"delete-2241\";i:3479;s:11:\"delete-2243\";i:3480;s:11:\"delete-2242\";i:3481;s:11:\"delete-2244\";i:3482;s:11:\"delete-2245\";i:3483;s:11:\"delete-2247\";i:3484;s:11:\"delete-2246\";i:3485;s:11:\"delete-2248\";i:3486;s:11:\"delete-2249\";i:3487;s:11:\"delete-2251\";i:3488;s:11:\"delete-2250\";i:3489;s:11:\"delete-2252\";i:3490;s:11:\"delete-2253\";i:3491;s:11:\"delete-2255\";i:3492;s:11:\"delete-2254\";i:3493;s:11:\"delete-2256\";i:3494;s:11:\"delete-2257\";i:3495;s:11:\"delete-2259\";i:3496;s:11:\"delete-2258\";i:3497;s:11:\"delete-2260\";i:3498;s:11:\"delete-2261\";i:3499;s:11:\"delete-2263\";i:3500;s:11:\"delete-2262\";i:3501;s:11:\"delete-2264\";i:3502;s:11:\"delete-2265\";i:3503;s:11:\"delete-2267\";i:3504;s:11:\"delete-2266\";i:3505;s:11:\"delete-2268\";i:3506;s:11:\"delete-2269\";i:3507;s:11:\"delete-2271\";i:3508;s:11:\"delete-2270\";i:3509;s:11:\"delete-2272\";i:3510;s:11:\"delete-2273\";i:3511;s:11:\"delete-2275\";i:3512;s:11:\"delete-2274\";i:3513;s:11:\"delete-2276\";i:3514;s:11:\"delete-2277\";i:3515;s:11:\"delete-2279\";i:3516;s:11:\"delete-2278\";i:3517;s:11:\"delete-2280\";i:3518;s:11:\"delete-2281\";i:3519;s:11:\"delete-2283\";i:3520;s:11:\"delete-2282\";i:3521;s:11:\"delete-2284\";i:3522;s:11:\"delete-2285\";i:3523;s:11:\"delete-2287\";i:3524;s:11:\"delete-2286\";i:3525;s:11:\"delete-2288\";i:3526;s:11:\"delete-2289\";i:3527;s:11:\"delete-2291\";i:3528;s:11:\"delete-2290\";i:3529;s:11:\"delete-2292\";i:3530;s:11:\"delete-2293\";i:3531;s:11:\"delete-2295\";i:3532;s:11:\"delete-2294\";i:3533;s:11:\"delete-2296\";i:3534;s:11:\"delete-2297\";i:3535;s:11:\"delete-2299\";i:3536;s:11:\"delete-2298\";i:3537;s:11:\"delete-2300\";i:3538;s:11:\"delete-2301\";i:3539;s:11:\"delete-2303\";i:3540;s:11:\"delete-2302\";i:3541;s:11:\"delete-2304\";i:3542;s:11:\"delete-2305\";i:3543;s:11:\"delete-2307\";i:3544;s:11:\"delete-2306\";i:3545;s:11:\"delete-2308\";i:3546;s:11:\"delete-2309\";i:3547;s:11:\"delete-2311\";i:3548;s:11:\"delete-2310\";i:3549;s:11:\"delete-2312\";i:3550;s:11:\"delete-2313\";i:3551;s:11:\"delete-2315\";i:3552;s:11:\"delete-2314\";i:3553;s:11:\"delete-2316\";i:3554;s:11:\"delete-2317\";i:3555;s:11:\"delete-2319\";i:3556;s:11:\"delete-2318\";i:3557;s:11:\"delete-2320\";i:3558;s:11:\"delete-2321\";i:3559;s:11:\"delete-2323\";i:3560;s:11:\"delete-2322\";i:3561;s:11:\"delete-2324\";i:3562;s:11:\"delete-2325\";i:3563;s:11:\"delete-2327\";i:3564;s:11:\"delete-2326\";i:3565;s:11:\"delete-2328\";i:3566;s:11:\"delete-2329\";i:3567;s:11:\"delete-2331\";i:3568;s:11:\"delete-2330\";i:3569;s:11:\"delete-2332\";i:3570;s:11:\"delete-2333\";i:3571;s:11:\"delete-2335\";i:3572;s:11:\"delete-2334\";i:3573;s:11:\"delete-2336\";i:3574;s:11:\"delete-2337\";i:3575;s:11:\"delete-2339\";i:3576;s:11:\"delete-2338\";i:3577;s:11:\"delete-2340\";i:3578;s:11:\"delete-2341\";i:3579;s:11:\"delete-2343\";i:3580;s:11:\"delete-2342\";i:3581;s:11:\"delete-2344\";i:3582;s:11:\"delete-2345\";i:3583;s:11:\"delete-2347\";i:3584;s:11:\"delete-2346\";i:3585;s:11:\"delete-2348\";i:3586;s:11:\"delete-2349\";i:3587;s:11:\"delete-2351\";i:3588;s:11:\"delete-2350\";i:3589;s:11:\"delete-2352\";i:3590;s:11:\"delete-2353\";i:3591;s:11:\"delete-2355\";i:3592;s:11:\"delete-2354\";i:3593;s:11:\"delete-2356\";i:3594;s:11:\"delete-2357\";i:3595;s:11:\"delete-2359\";i:3596;s:11:\"delete-2358\";i:3597;s:11:\"delete-2360\";i:3598;s:11:\"delete-2361\";i:3599;s:11:\"delete-2363\";i:3600;s:11:\"delete-2362\";i:3601;s:11:\"delete-2364\";i:3602;s:11:\"delete-2365\";i:3603;s:11:\"delete-2367\";i:3604;s:11:\"delete-2366\";i:3605;s:11:\"delete-2368\";i:3606;s:11:\"delete-2369\";i:3607;s:11:\"delete-2371\";i:3608;s:11:\"delete-2370\";i:3609;s:11:\"delete-2372\";i:3610;s:11:\"delete-2373\";i:3611;s:11:\"delete-2375\";i:3612;s:11:\"delete-2374\";i:3613;s:11:\"delete-2376\";i:3614;s:11:\"delete-2377\";i:3615;s:11:\"delete-2379\";i:3616;s:11:\"delete-2378\";i:3617;s:11:\"delete-2380\";i:3618;s:11:\"delete-2381\";i:3619;s:11:\"delete-2383\";i:3620;s:11:\"delete-2382\";i:3621;s:11:\"delete-2384\";i:3622;s:11:\"delete-2385\";i:3623;s:11:\"delete-2387\";i:3624;s:11:\"delete-2386\";i:3625;s:11:\"delete-2388\";i:3626;s:11:\"delete-2389\";i:3627;s:11:\"delete-2391\";i:3628;s:11:\"delete-2390\";i:3629;s:11:\"delete-2392\";i:3630;s:11:\"delete-2393\";i:3631;s:11:\"delete-2395\";i:3632;s:11:\"delete-2394\";i:3633;s:11:\"delete-2396\";i:3634;s:11:\"delete-2397\";i:3635;s:11:\"delete-2399\";i:3636;s:11:\"delete-2398\";i:3637;s:11:\"delete-2400\";i:3638;s:11:\"delete-2401\";i:3639;s:11:\"delete-2403\";i:3640;s:11:\"delete-2402\";i:3641;s:11:\"delete-2404\";i:3642;s:11:\"delete-2405\";i:3643;s:11:\"delete-2407\";i:3644;s:11:\"delete-2406\";i:3645;s:11:\"delete-2408\";i:3646;s:11:\"delete-2409\";i:3647;s:11:\"delete-2411\";i:3648;s:11:\"delete-2410\";i:3649;s:11:\"delete-2412\";i:3650;s:11:\"delete-2413\";i:3651;s:11:\"delete-2415\";i:3652;s:11:\"delete-2414\";i:3653;s:11:\"delete-2416\";i:3654;s:11:\"delete-2417\";i:3655;s:11:\"delete-2419\";i:3656;s:11:\"delete-2418\";i:3657;s:11:\"delete-2420\";i:3658;s:11:\"delete-2421\";i:3659;s:11:\"delete-2423\";i:3660;s:11:\"delete-2422\";i:3661;s:11:\"delete-2424\";i:3662;s:11:\"delete-2425\";i:3663;s:11:\"delete-2427\";i:3664;s:11:\"delete-2426\";i:3665;s:11:\"delete-2428\";i:3666;s:11:\"delete-2429\";i:3667;s:11:\"delete-2431\";i:3668;s:11:\"delete-2430\";i:3669;s:11:\"delete-2432\";i:3670;s:11:\"delete-2433\";i:3671;s:11:\"delete-2435\";i:3672;s:11:\"delete-2434\";i:3673;s:11:\"delete-2436\";i:3674;s:11:\"delete-2437\";i:3675;s:11:\"delete-2439\";i:3676;s:11:\"delete-2438\";i:3677;s:11:\"delete-2440\";i:3678;s:11:\"delete-2441\";i:3679;s:11:\"delete-2443\";i:3680;s:11:\"delete-2442\";i:3681;s:11:\"delete-2444\";i:3682;s:11:\"delete-2445\";i:3683;s:11:\"delete-2447\";i:3684;s:11:\"delete-2446\";i:3685;s:11:\"delete-2448\";i:3686;s:11:\"delete-2449\";i:3687;s:11:\"delete-2451\";i:3688;s:11:\"delete-2450\";i:3689;s:11:\"delete-2452\";i:3690;s:11:\"delete-2453\";i:3691;s:11:\"delete-2455\";i:3692;s:11:\"delete-2454\";i:3693;s:11:\"delete-2456\";i:3694;s:11:\"delete-2457\";i:3695;s:11:\"delete-2459\";i:3696;s:11:\"delete-2458\";i:3697;s:11:\"delete-2460\";i:3698;s:11:\"delete-2461\";i:3699;s:11:\"delete-2463\";i:3700;s:11:\"delete-2462\";i:3701;s:11:\"delete-2464\";i:3702;s:11:\"delete-2465\";i:3703;s:11:\"delete-2467\";i:3704;s:11:\"delete-2466\";i:3705;s:11:\"delete-2468\";i:3706;s:11:\"delete-2469\";i:3707;s:11:\"delete-2471\";i:3708;s:11:\"delete-2470\";i:3709;s:11:\"delete-2472\";i:3710;s:11:\"delete-2473\";i:3711;s:11:\"delete-2475\";i:3712;s:11:\"delete-2474\";i:3713;s:11:\"delete-2476\";i:3714;s:11:\"delete-2477\";i:3715;s:11:\"delete-2479\";i:3716;s:11:\"delete-2478\";i:3717;s:11:\"delete-2480\";i:3718;s:11:\"delete-2481\";i:3719;s:11:\"delete-2483\";i:3720;s:11:\"delete-2482\";i:3721;s:11:\"delete-2484\";i:3722;s:11:\"delete-2485\";i:3723;s:11:\"delete-2487\";i:3724;s:11:\"delete-2486\";i:3725;s:11:\"delete-2488\";i:3726;s:11:\"delete-2489\";i:3727;s:11:\"delete-2491\";i:3728;s:11:\"delete-2490\";i:3729;s:11:\"delete-2492\";i:3730;s:11:\"delete-2493\";i:3731;s:11:\"delete-2495\";i:3732;s:11:\"delete-2494\";i:3733;s:11:\"delete-2496\";i:3734;s:11:\"delete-2497\";i:3735;s:11:\"delete-2499\";i:3736;s:11:\"delete-2498\";i:3737;s:11:\"delete-2500\";i:3738;s:11:\"delete-2501\";i:3739;s:11:\"delete-2503\";i:3740;s:11:\"delete-2502\";i:3741;s:11:\"delete-2504\";i:3742;s:11:\"delete-2505\";i:3743;s:11:\"delete-2507\";i:3744;s:11:\"delete-2506\";i:3745;s:11:\"delete-2508\";i:3746;s:11:\"delete-2509\";i:3747;s:11:\"delete-2511\";i:3748;s:11:\"delete-2510\";i:3749;s:11:\"delete-2512\";i:3750;s:11:\"delete-2513\";i:3751;s:11:\"delete-2515\";i:3752;s:11:\"delete-2514\";i:3753;s:11:\"delete-2516\";i:3754;s:11:\"delete-2517\";i:3755;s:11:\"delete-2519\";i:3756;s:11:\"delete-2518\";i:3757;s:11:\"delete-2520\";i:3758;s:11:\"delete-2521\";i:3759;s:11:\"delete-2523\";i:3760;s:11:\"delete-2522\";i:3761;s:11:\"delete-2524\";i:3762;s:11:\"delete-2525\";i:3763;s:11:\"delete-2527\";i:3764;s:11:\"delete-2526\";i:3765;s:11:\"delete-2528\";i:3766;s:11:\"delete-2529\";i:3767;s:11:\"delete-2531\";i:3768;s:11:\"delete-2530\";i:3769;s:11:\"delete-2532\";i:3770;s:11:\"delete-2533\";i:3771;s:11:\"delete-2535\";i:3772;s:11:\"delete-2534\";i:3773;s:11:\"delete-2536\";i:3774;s:11:\"delete-2537\";i:3775;s:11:\"delete-2539\";i:3776;s:11:\"delete-2538\";i:3777;s:11:\"delete-2540\";i:3778;s:11:\"delete-2541\";i:3779;s:11:\"delete-2543\";i:3780;s:11:\"delete-2542\";i:3781;s:11:\"delete-2544\";i:3782;s:11:\"delete-2545\";i:3783;s:11:\"delete-2547\";i:3784;s:11:\"delete-2546\";i:3785;s:11:\"delete-2548\";i:3786;s:11:\"delete-2549\";i:3787;s:11:\"delete-2551\";i:3788;s:11:\"delete-2550\";i:3789;s:11:\"delete-2552\";i:3790;s:11:\"delete-2553\";i:3791;s:11:\"delete-2555\";i:3792;s:11:\"delete-2554\";i:3793;s:11:\"delete-2556\";i:3794;s:11:\"delete-2557\";i:3795;s:11:\"delete-2559\";i:3796;s:11:\"delete-2558\";i:3797;s:11:\"delete-2560\";i:3798;s:11:\"delete-2561\";i:3799;s:11:\"delete-2563\";i:3800;s:11:\"delete-2562\";i:3801;s:11:\"delete-2564\";i:3802;s:11:\"delete-2565\";i:3803;s:11:\"delete-2567\";i:3804;s:11:\"delete-2566\";i:3805;s:11:\"delete-2568\";i:3806;s:11:\"delete-2569\";i:3807;s:11:\"delete-2571\";i:3808;s:11:\"delete-2570\";i:3809;s:11:\"delete-2572\";i:3810;s:11:\"delete-2573\";i:3811;s:11:\"delete-2575\";i:3812;s:11:\"delete-2574\";i:3813;s:11:\"delete-2576\";i:3814;s:11:\"delete-2577\";i:3815;s:11:\"delete-2579\";i:3816;s:11:\"delete-2578\";i:3817;s:11:\"delete-2580\";i:3818;s:11:\"delete-2581\";i:3819;s:11:\"delete-2583\";i:3820;s:11:\"delete-2582\";i:3821;s:11:\"delete-2584\";i:3822;s:11:\"delete-2585\";i:3823;s:11:\"delete-2587\";i:3824;s:11:\"delete-2586\";i:3825;s:11:\"delete-2588\";i:3826;s:11:\"delete-2589\";i:3827;s:11:\"delete-2591\";i:3828;s:11:\"delete-2590\";i:3829;s:11:\"delete-2592\";i:3830;s:11:\"delete-2593\";i:3831;s:11:\"delete-2595\";i:3832;s:11:\"delete-2594\";i:3833;s:11:\"delete-2596\";i:3834;s:11:\"delete-2597\";i:3835;s:11:\"delete-2599\";i:3836;s:11:\"delete-2598\";i:3837;s:11:\"delete-2600\";i:3838;s:11:\"delete-2601\";i:3839;s:11:\"delete-2603\";i:3840;s:11:\"delete-2602\";i:3841;s:11:\"delete-2604\";i:3842;s:11:\"delete-2605\";i:3843;s:11:\"delete-2607\";i:3844;s:11:\"delete-2606\";i:3845;s:11:\"delete-2608\";i:3846;s:11:\"delete-2609\";i:3847;s:11:\"delete-2611\";i:3848;s:11:\"delete-2610\";i:3849;s:11:\"delete-2612\";i:3850;s:11:\"delete-2613\";i:3851;s:11:\"delete-2615\";i:3852;s:11:\"delete-2614\";i:3853;s:11:\"delete-2616\";i:3854;s:11:\"delete-2617\";i:3855;s:11:\"delete-2619\";i:3856;s:11:\"delete-2618\";i:3857;s:11:\"delete-2620\";i:3858;s:11:\"delete-2621\";i:3859;s:11:\"delete-2623\";i:3860;s:11:\"delete-2622\";i:3861;s:11:\"delete-2624\";i:3862;s:11:\"delete-2625\";i:3863;s:11:\"delete-2627\";i:3864;s:11:\"delete-2626\";i:3865;s:11:\"delete-2628\";i:3866;s:11:\"delete-2629\";i:3867;s:11:\"delete-2631\";i:3868;s:11:\"delete-2630\";i:3869;s:11:\"delete-2632\";i:3870;s:11:\"delete-2633\";i:3871;s:11:\"delete-2635\";i:3872;s:11:\"delete-2634\";i:3873;s:11:\"delete-2636\";i:3874;s:11:\"delete-2637\";i:3875;s:11:\"delete-2639\";i:3876;s:11:\"delete-2638\";i:3877;s:11:\"delete-2640\";i:3878;s:11:\"delete-2641\";i:3879;s:11:\"delete-2643\";i:3880;s:11:\"delete-2642\";i:3881;s:11:\"delete-2644\";i:3882;s:11:\"delete-2645\";i:3883;s:11:\"delete-2647\";i:3884;s:11:\"delete-2646\";i:3885;s:11:\"delete-2648\";i:3886;s:11:\"delete-2649\";i:3887;s:11:\"delete-2651\";i:3888;s:11:\"delete-2650\";i:3889;s:11:\"delete-2652\";i:3890;s:11:\"delete-2653\";i:3891;s:11:\"delete-2655\";i:3892;s:11:\"delete-2654\";i:3893;s:11:\"delete-2656\";i:3894;s:11:\"delete-2657\";i:3895;s:11:\"delete-2659\";i:3896;s:11:\"delete-2658\";i:3897;s:11:\"delete-2660\";i:3898;s:11:\"delete-2661\";i:3899;s:11:\"delete-2663\";i:3900;s:11:\"delete-2662\";i:3901;s:11:\"delete-2664\";i:3902;s:11:\"delete-2665\";i:3903;s:11:\"delete-2667\";i:3904;s:11:\"delete-2666\";i:3905;s:11:\"delete-2668\";i:3906;s:11:\"delete-2669\";i:3907;s:11:\"delete-2671\";i:3908;s:11:\"delete-2670\";i:3909;s:11:\"delete-2672\";i:3910;s:11:\"delete-2673\";i:3911;s:11:\"delete-2675\";i:3912;s:11:\"delete-2674\";i:3913;s:11:\"delete-2676\";i:3914;s:11:\"delete-2677\";i:3915;s:11:\"delete-2679\";i:3916;s:11:\"delete-2678\";i:3917;s:11:\"delete-2680\";i:3918;s:11:\"delete-2681\";i:3919;s:11:\"delete-2683\";i:3920;s:11:\"delete-2682\";i:3921;s:11:\"delete-2684\";i:3922;s:11:\"delete-2685\";i:3923;s:11:\"delete-2687\";i:3924;s:11:\"delete-2686\";i:3925;s:11:\"delete-2688\";i:3926;s:11:\"delete-2689\";i:3927;s:11:\"delete-2691\";i:3928;s:11:\"delete-2690\";i:3929;s:11:\"delete-2692\";i:3930;s:11:\"delete-2693\";i:3931;s:11:\"delete-2695\";i:3932;s:11:\"delete-2694\";i:3933;s:11:\"delete-2696\";i:3934;s:11:\"delete-2697\";i:3935;s:11:\"delete-2699\";i:3936;s:11:\"delete-2698\";i:3937;s:11:\"delete-2700\";i:3938;s:11:\"delete-2701\";i:3939;s:11:\"delete-2703\";i:3940;s:11:\"delete-2702\";i:3941;s:11:\"delete-2704\";i:3942;s:11:\"delete-2705\";i:3943;s:11:\"delete-2707\";i:3944;s:11:\"delete-2706\";i:3945;s:11:\"delete-2708\";i:3946;s:11:\"delete-2709\";i:3947;s:11:\"delete-2711\";i:3948;s:11:\"delete-2710\";i:3949;s:11:\"delete-2712\";i:3950;s:11:\"delete-2713\";i:3951;s:11:\"delete-2715\";i:3952;s:11:\"delete-2714\";i:3953;s:11:\"delete-2716\";i:3954;s:11:\"delete-2717\";i:3955;s:11:\"delete-2719\";i:3956;s:11:\"delete-2718\";i:3957;s:11:\"delete-2720\";i:3958;s:11:\"delete-2721\";i:3959;s:11:\"delete-2723\";i:3960;s:11:\"delete-2722\";i:3961;s:11:\"delete-2724\";i:3962;s:11:\"delete-2725\";i:3963;s:11:\"delete-2727\";i:3964;s:11:\"delete-2726\";i:3965;s:11:\"delete-2728\";i:3966;s:11:\"delete-2729\";i:3967;s:11:\"delete-2731\";i:3968;s:11:\"delete-2730\";i:3969;s:11:\"delete-2732\";i:3970;s:11:\"delete-2733\";i:3971;s:11:\"delete-2735\";i:3972;s:11:\"delete-2734\";i:3973;s:11:\"delete-2736\";i:3974;s:11:\"delete-2737\";i:3975;s:11:\"delete-2739\";i:3976;s:11:\"delete-2738\";i:3977;s:11:\"delete-2740\";i:3978;s:11:\"delete-2741\";i:3979;s:11:\"delete-2743\";i:3980;s:11:\"delete-2742\";i:3981;s:11:\"delete-2744\";i:3982;s:11:\"delete-2745\";i:3983;s:11:\"delete-2747\";i:3984;s:11:\"delete-2746\";i:3985;s:11:\"delete-2748\";i:3986;s:11:\"delete-2749\";i:3987;s:11:\"delete-2751\";i:3988;s:11:\"delete-2750\";i:3989;s:11:\"delete-2752\";i:3990;s:11:\"delete-2753\";i:3991;s:11:\"delete-2755\";i:3992;s:11:\"delete-2754\";i:3993;s:11:\"delete-2756\";i:3994;s:11:\"delete-2757\";i:3995;s:11:\"delete-2759\";i:3996;s:11:\"delete-2758\";i:3997;s:11:\"delete-2760\";i:3998;s:11:\"delete-2761\";i:3999;s:11:\"delete-2763\";i:4000;s:11:\"delete-2762\";i:4001;s:11:\"delete-2764\";i:4002;s:11:\"delete-2765\";i:4003;s:11:\"delete-2767\";i:4004;s:11:\"delete-2766\";i:4005;s:11:\"delete-2768\";i:4006;s:11:\"delete-2769\";i:4007;s:11:\"delete-2771\";i:4008;s:11:\"delete-2770\";i:4009;s:11:\"delete-2772\";i:4010;s:11:\"delete-2773\";i:4011;s:11:\"delete-2775\";i:4012;s:11:\"delete-2774\";i:4013;s:11:\"delete-2776\";i:4014;s:11:\"delete-2777\";i:4015;s:11:\"delete-2779\";i:4016;s:11:\"delete-2778\";i:4017;s:11:\"delete-2780\";i:4018;s:11:\"delete-2781\";i:4019;s:11:\"delete-2783\";i:4020;s:11:\"delete-2782\";i:4021;s:11:\"delete-2784\";i:4022;s:11:\"delete-2785\";i:4023;s:11:\"delete-2787\";i:4024;s:11:\"delete-2786\";i:4025;s:11:\"delete-2788\";i:4026;s:11:\"delete-2789\";i:4027;s:11:\"delete-2791\";i:4028;s:11:\"delete-2790\";i:4029;s:11:\"delete-2792\";i:4030;s:11:\"delete-2793\";i:4031;s:11:\"delete-2795\";i:4032;s:11:\"delete-2794\";i:4033;s:11:\"delete-2796\";i:4034;s:11:\"delete-2797\";i:4035;s:11:\"delete-2799\";i:4036;s:11:\"delete-2798\";i:4037;s:11:\"delete-2800\";i:4038;s:11:\"delete-2801\";i:4039;s:11:\"delete-2803\";i:4040;s:11:\"delete-2802\";i:4041;s:11:\"delete-2804\";i:4042;s:11:\"delete-2805\";i:4043;s:11:\"delete-2807\";i:4044;s:11:\"delete-2806\";i:4045;s:11:\"delete-2808\";i:4046;s:11:\"delete-2809\";i:4047;s:11:\"delete-2811\";i:4048;s:11:\"delete-2810\";i:4049;s:11:\"delete-2812\";i:4050;s:11:\"delete-2813\";i:4051;s:11:\"delete-2815\";i:4052;s:11:\"delete-2814\";i:4053;s:11:\"delete-2816\";i:4054;s:11:\"delete-2817\";i:4055;s:11:\"delete-2819\";i:4056;s:11:\"delete-2818\";i:4057;s:11:\"delete-2820\";i:4058;s:11:\"delete-2821\";i:4059;s:11:\"delete-2823\";i:4060;s:11:\"delete-2822\";i:4061;s:11:\"delete-2824\";i:4062;s:11:\"delete-2825\";i:4063;s:11:\"delete-2827\";i:4064;s:11:\"delete-2826\";i:4065;s:11:\"delete-2828\";i:4066;s:11:\"delete-2829\";i:4067;s:11:\"delete-2831\";i:4068;s:11:\"delete-2830\";i:4069;s:11:\"delete-2832\";i:4070;s:11:\"delete-2833\";i:4071;s:11:\"delete-2835\";i:4072;s:11:\"delete-2834\";i:4073;s:11:\"delete-2836\";i:4074;s:11:\"delete-2837\";i:4075;s:11:\"delete-2839\";i:4076;s:11:\"delete-2838\";i:4077;s:11:\"delete-2840\";i:4078;s:11:\"delete-2841\";i:4079;s:11:\"delete-2843\";i:4080;s:11:\"delete-2842\";i:4081;s:11:\"delete-2844\";i:4082;s:11:\"delete-2845\";i:4083;s:11:\"delete-2847\";i:4084;s:11:\"delete-2846\";i:4085;s:11:\"delete-2848\";i:4086;s:11:\"delete-2849\";i:4087;s:11:\"delete-2851\";i:4088;s:11:\"delete-2850\";i:4089;s:11:\"delete-2852\";i:4090;s:11:\"delete-2853\";i:4091;s:11:\"delete-2855\";i:4092;s:11:\"delete-2854\";i:4093;s:11:\"delete-2856\";i:4094;s:11:\"delete-2857\";i:4095;s:11:\"delete-2859\";i:4096;s:11:\"delete-2858\";i:4097;s:11:\"delete-2860\";i:4098;s:11:\"delete-2861\";i:4099;s:11:\"delete-2863\";i:4100;s:11:\"delete-2862\";i:4101;s:11:\"delete-2864\";i:4102;s:11:\"delete-2865\";i:4103;s:11:\"delete-2867\";i:4104;s:11:\"delete-2866\";i:4105;s:11:\"delete-2868\";i:4106;s:11:\"delete-2869\";i:4107;s:11:\"delete-2871\";i:4108;s:11:\"delete-2870\";i:4109;s:11:\"delete-2872\";i:4110;s:11:\"delete-2873\";i:4111;s:11:\"delete-2875\";i:4112;s:11:\"delete-2874\";i:4113;s:11:\"delete-2876\";i:4114;s:11:\"delete-2877\";i:4115;s:11:\"delete-2879\";i:4116;s:11:\"delete-2878\";i:4117;s:11:\"delete-2880\";i:4118;s:11:\"delete-2881\";i:4119;s:11:\"delete-2883\";i:4120;s:11:\"delete-2882\";i:4121;s:11:\"delete-2884\";i:4122;s:11:\"delete-2885\";i:4123;s:11:\"delete-2887\";i:4124;s:11:\"delete-2886\";i:4125;s:11:\"delete-2888\";i:4126;s:11:\"delete-2889\";i:4127;s:11:\"delete-2891\";i:4128;s:11:\"delete-2890\";i:4129;s:11:\"delete-2892\";i:4130;s:11:\"delete-2893\";i:4131;s:11:\"delete-2895\";i:4132;s:11:\"delete-2894\";i:4133;s:11:\"delete-2896\";i:4134;s:11:\"delete-2897\";i:4135;s:11:\"delete-2899\";i:4136;s:11:\"delete-2898\";i:4137;s:11:\"delete-2900\";i:4138;s:11:\"delete-2901\";i:4139;s:11:\"delete-2903\";i:4140;s:11:\"delete-2902\";i:4141;s:11:\"delete-2904\";i:4142;s:11:\"delete-2905\";i:4143;s:11:\"delete-2907\";i:4144;s:11:\"delete-2906\";i:4145;s:11:\"delete-2908\";i:4146;s:11:\"delete-2909\";i:4147;s:11:\"delete-2911\";i:4148;s:11:\"delete-2910\";i:4149;s:11:\"delete-2912\";i:4150;s:11:\"delete-2913\";i:4151;s:11:\"delete-2915\";i:4152;s:11:\"delete-2914\";i:4153;s:11:\"delete-2916\";i:4154;s:11:\"delete-2917\";i:4155;s:11:\"delete-2919\";i:4156;s:11:\"delete-2918\";i:4157;s:11:\"delete-2920\";i:4158;s:11:\"delete-2921\";i:4159;s:11:\"delete-2923\";i:4160;s:11:\"delete-2922\";i:4161;s:11:\"delete-2924\";i:4162;s:11:\"delete-2925\";i:4163;s:11:\"delete-2927\";i:4164;s:11:\"delete-2926\";i:4165;s:11:\"delete-2928\";i:4166;s:11:\"delete-2929\";i:4167;s:11:\"delete-2931\";i:4168;s:11:\"delete-2930\";i:4169;s:11:\"delete-2932\";i:4170;s:11:\"delete-2933\";i:4171;s:11:\"delete-2935\";i:4172;s:11:\"delete-2934\";i:4173;s:11:\"delete-2936\";i:4174;s:11:\"delete-2937\";i:4175;s:11:\"delete-2939\";i:4176;s:11:\"delete-2938\";i:4177;s:11:\"delete-2940\";i:4178;s:11:\"delete-2941\";i:4179;s:11:\"delete-2943\";i:4180;s:11:\"delete-2942\";i:4181;s:11:\"delete-2944\";i:4182;s:11:\"delete-2945\";i:4183;s:11:\"delete-2947\";i:4184;s:11:\"delete-2946\";i:4185;s:11:\"delete-2948\";i:4186;s:11:\"delete-2949\";i:4187;s:11:\"delete-2951\";i:4188;s:11:\"delete-2950\";i:4189;s:11:\"delete-2952\";i:4190;s:11:\"delete-2953\";i:4191;s:11:\"delete-2955\";i:4192;s:11:\"delete-2954\";i:4193;s:11:\"delete-2956\";i:4194;s:11:\"delete-2957\";i:4195;s:11:\"delete-2959\";i:4196;s:11:\"delete-2958\";i:4197;s:11:\"delete-2960\";i:4198;s:11:\"delete-2961\";i:4199;s:11:\"delete-2963\";i:4200;s:11:\"delete-2962\";i:4201;s:11:\"delete-2964\";i:4202;s:11:\"delete-2965\";i:4203;s:11:\"delete-2967\";i:4204;s:11:\"delete-2966\";i:4205;s:11:\"delete-2968\";i:4206;s:11:\"delete-2969\";i:4207;s:11:\"delete-2971\";i:4208;s:11:\"delete-2970\";i:4209;s:11:\"delete-2972\";i:4210;s:11:\"delete-2973\";i:4211;s:11:\"delete-2975\";i:4212;s:11:\"delete-2974\";i:4213;s:11:\"delete-2976\";i:4214;s:11:\"delete-2977\";i:4215;s:11:\"delete-2979\";i:4216;s:11:\"delete-2978\";i:4217;s:11:\"delete-2980\";i:4218;s:11:\"delete-2981\";i:4219;s:11:\"delete-2983\";i:4220;s:11:\"delete-2982\";i:4221;s:11:\"delete-2984\";i:4222;s:11:\"delete-2985\";i:4223;s:11:\"delete-2987\";i:4224;s:11:\"delete-2986\";i:4225;s:11:\"delete-2988\";i:4226;s:11:\"delete-2989\";i:4227;s:11:\"delete-2991\";i:4228;s:11:\"delete-2990\";i:4229;s:11:\"delete-2992\";i:4230;s:11:\"delete-2993\";i:4231;s:11:\"delete-2995\";i:4232;s:11:\"delete-2994\";i:4233;s:11:\"delete-2996\";i:4234;s:11:\"delete-2997\";i:4235;s:11:\"delete-2999\";i:4236;s:11:\"delete-2998\";i:4237;s:11:\"delete-3000\";i:4238;s:11:\"delete-3001\";i:4239;s:11:\"delete-3003\";i:4240;s:11:\"delete-3002\";i:4241;s:11:\"delete-3004\";i:4242;s:11:\"delete-3005\";i:4243;s:11:\"delete-3007\";i:4244;s:11:\"delete-3006\";i:4245;s:11:\"delete-3008\";i:4246;s:11:\"delete-3009\";i:4247;s:11:\"delete-3011\";i:4248;s:11:\"delete-3010\";i:4249;s:11:\"delete-3012\";i:4250;s:11:\"delete-3013\";i:4251;s:11:\"delete-3015\";i:4252;s:11:\"delete-3014\";i:4253;s:11:\"delete-3016\";i:4254;s:11:\"delete-3017\";i:4255;s:11:\"delete-3019\";i:4256;s:11:\"delete-3018\";i:4257;s:11:\"delete-3020\";i:4258;s:11:\"delete-3021\";i:4259;s:11:\"delete-3023\";i:4260;s:11:\"delete-3022\";i:4261;s:11:\"delete-3024\";i:4262;s:11:\"delete-3025\";i:4263;s:11:\"delete-3027\";i:4264;s:11:\"delete-3026\";i:4265;s:11:\"delete-3028\";i:4266;s:11:\"delete-3029\";i:4267;s:11:\"delete-3031\";i:4268;s:11:\"delete-3030\";i:4269;s:11:\"delete-3032\";i:4270;s:11:\"delete-3033\";i:4271;s:11:\"delete-3035\";i:4272;s:11:\"delete-3034\";i:4273;s:11:\"delete-3036\";i:4274;s:11:\"delete-3037\";i:4275;s:11:\"delete-3039\";i:4276;s:11:\"delete-3038\";i:4277;s:11:\"delete-3040\";i:4278;s:11:\"delete-3041\";i:4279;s:11:\"delete-3043\";i:4280;s:11:\"delete-3042\";i:4281;s:11:\"delete-3044\";i:4282;s:11:\"delete-3045\";i:4283;s:11:\"delete-3047\";i:4284;s:11:\"delete-3046\";i:4285;s:11:\"delete-3048\";i:4286;s:11:\"delete-3049\";i:4287;s:11:\"delete-3051\";i:4288;s:11:\"delete-3050\";i:4289;s:11:\"delete-3052\";i:4290;s:11:\"delete-3053\";i:4291;s:11:\"delete-3055\";i:4292;s:11:\"delete-3054\";i:4293;s:11:\"delete-3056\";i:4294;s:11:\"delete-3057\";i:4295;s:11:\"delete-3059\";i:4296;s:11:\"delete-3058\";i:4297;s:11:\"delete-3060\";i:4298;s:11:\"delete-3061\";i:4299;s:11:\"delete-3063\";i:4300;s:11:\"delete-3062\";i:4301;s:11:\"delete-3064\";i:4302;s:11:\"delete-3065\";i:4303;s:11:\"delete-3067\";i:4304;s:11:\"delete-3066\";i:4305;s:11:\"delete-3068\";i:4306;s:11:\"delete-3069\";i:4307;s:11:\"delete-3071\";i:4308;s:11:\"delete-3070\";i:4309;s:11:\"delete-3072\";i:4310;s:11:\"delete-3073\";i:4311;s:11:\"delete-3075\";i:4312;s:11:\"delete-3074\";i:4313;s:11:\"delete-3076\";i:4314;s:11:\"delete-3077\";i:4315;s:11:\"delete-3079\";i:4316;s:11:\"delete-3078\";i:4317;s:11:\"delete-3080\";i:4318;s:11:\"delete-3081\";i:4319;s:11:\"delete-3083\";i:4320;s:11:\"delete-3082\";i:4321;s:11:\"delete-3084\";i:4322;s:11:\"delete-3085\";i:4323;s:11:\"delete-3087\";i:4324;s:11:\"delete-3086\";i:4325;s:11:\"delete-3088\";i:4326;s:11:\"delete-3089\";i:4327;s:11:\"delete-3091\";i:4328;s:11:\"delete-3090\";i:4329;s:11:\"delete-3092\";i:4330;s:11:\"delete-3093\";i:4331;s:11:\"delete-3095\";i:4332;s:11:\"delete-3094\";i:4333;s:11:\"delete-3096\";i:4334;s:11:\"delete-3097\";i:4335;s:11:\"delete-3099\";i:4336;s:11:\"delete-3098\";i:4337;s:11:\"delete-3100\";i:4338;s:11:\"delete-3101\";i:4339;s:11:\"delete-3103\";i:4340;s:11:\"delete-3102\";i:4341;s:11:\"delete-3104\";i:4342;s:11:\"delete-3105\";i:4343;s:11:\"delete-3107\";i:4344;s:11:\"delete-3106\";i:4345;s:11:\"delete-3108\";i:4346;s:11:\"delete-3109\";i:4347;s:11:\"delete-3111\";i:4348;s:11:\"delete-3110\";i:4349;s:11:\"delete-3112\";i:4350;s:11:\"delete-3113\";i:4351;s:11:\"delete-3115\";i:4352;s:11:\"delete-3114\";i:4353;s:11:\"delete-3116\";i:4354;s:11:\"delete-3117\";i:4355;s:11:\"delete-3119\";i:4356;s:11:\"delete-3118\";i:4357;s:11:\"delete-3120\";i:4358;s:11:\"delete-3121\";i:4359;s:11:\"delete-3123\";i:4360;s:11:\"delete-3122\";i:4361;s:11:\"delete-3124\";i:4362;s:11:\"delete-3125\";i:4363;s:11:\"delete-3127\";i:4364;s:11:\"delete-3126\";i:4365;s:11:\"delete-3128\";i:4366;s:11:\"delete-3129\";i:4367;s:11:\"delete-3131\";i:4368;s:11:\"delete-3130\";i:4369;s:11:\"delete-3132\";i:4370;s:11:\"delete-3133\";i:4371;s:11:\"delete-3135\";i:4372;s:11:\"delete-3134\";i:4373;s:11:\"delete-3136\";i:4374;s:11:\"delete-3137\";i:4375;s:11:\"delete-3139\";i:4376;s:11:\"delete-3138\";i:4377;s:11:\"delete-3140\";i:4378;s:11:\"delete-3141\";i:4379;s:11:\"delete-3143\";i:4380;s:11:\"delete-3142\";i:4381;s:11:\"delete-3144\";i:4382;s:11:\"delete-3145\";i:4383;s:11:\"delete-3147\";i:4384;s:11:\"delete-3146\";i:4385;s:11:\"delete-3148\";i:4386;s:11:\"delete-3149\";i:4387;s:11:\"delete-3151\";i:4388;s:11:\"delete-3150\";i:4389;s:11:\"delete-3152\";i:4390;s:11:\"delete-3153\";i:4391;s:11:\"delete-3155\";i:4392;s:11:\"delete-3154\";i:4393;s:11:\"delete-3156\";i:4394;s:11:\"delete-3157\";i:4395;s:11:\"delete-3159\";i:4396;s:11:\"delete-3158\";i:4397;s:11:\"delete-3160\";i:4398;s:11:\"delete-3161\";i:4399;s:11:\"delete-3163\";i:4400;s:11:\"delete-3162\";i:4401;s:11:\"delete-3164\";i:4402;s:11:\"delete-3165\";i:4403;s:11:\"delete-3167\";i:4404;s:11:\"delete-3166\";i:4405;s:11:\"delete-3168\";i:4406;s:11:\"delete-3169\";i:4407;s:11:\"delete-3171\";i:4408;s:11:\"delete-3170\";i:4409;s:11:\"delete-3172\";i:4410;s:11:\"delete-3173\";i:4411;s:11:\"delete-3175\";i:4412;s:11:\"delete-3174\";i:4413;s:11:\"delete-3176\";i:4414;s:11:\"delete-3177\";i:4415;s:11:\"delete-3179\";i:4416;s:11:\"delete-3178\";i:4417;s:11:\"delete-3180\";i:4418;s:11:\"delete-3181\";i:4419;s:11:\"delete-3183\";i:4420;s:11:\"delete-3182\";i:4421;s:11:\"delete-3184\";i:4422;s:11:\"delete-3185\";i:4423;s:11:\"delete-3187\";i:4424;s:11:\"delete-3186\";i:4425;s:11:\"delete-3188\";i:4426;s:11:\"delete-3189\";i:4427;s:11:\"delete-3191\";i:4428;s:11:\"delete-3190\";i:4429;s:11:\"delete-3192\";i:4430;s:11:\"delete-3193\";i:4431;s:11:\"delete-3195\";i:4432;s:11:\"delete-3194\";i:4433;s:11:\"delete-3196\";i:4434;s:11:\"delete-3197\";i:4435;s:11:\"delete-3199\";i:4436;s:11:\"delete-3198\";i:4437;s:11:\"delete-3200\";i:4438;s:11:\"delete-3201\";i:4439;s:11:\"delete-3203\";i:4440;s:11:\"delete-3202\";i:4441;s:11:\"delete-3204\";i:4442;s:11:\"delete-3205\";i:4443;s:11:\"delete-3207\";i:4444;s:11:\"delete-3206\";i:4445;s:11:\"delete-3208\";i:4446;s:11:\"delete-3209\";i:4447;s:11:\"delete-3211\";i:4448;s:11:\"delete-3210\";i:4449;s:11:\"delete-3212\";i:4450;s:11:\"delete-3213\";i:4451;s:11:\"delete-3215\";i:4452;s:11:\"delete-3214\";i:4453;s:11:\"delete-3216\";i:4454;s:11:\"delete-3217\";i:4455;s:11:\"delete-3219\";i:4456;s:11:\"delete-3218\";i:4457;s:11:\"delete-3220\";i:4458;s:11:\"delete-3221\";i:4459;s:11:\"delete-3223\";i:4460;s:11:\"delete-3222\";i:4461;s:11:\"delete-3224\";i:4462;s:11:\"delete-3225\";i:4463;s:11:\"delete-3227\";i:4464;s:11:\"delete-3226\";i:4465;s:11:\"delete-3228\";i:4466;s:11:\"delete-3229\";i:4467;s:11:\"delete-3231\";i:4468;s:11:\"delete-3230\";i:4469;s:11:\"delete-3232\";i:4470;s:11:\"delete-3233\";i:4471;s:11:\"delete-3235\";i:4472;s:11:\"delete-3234\";i:4473;s:11:\"delete-3236\";i:4474;s:11:\"delete-3237\";i:4475;s:11:\"delete-3239\";i:4476;s:11:\"delete-3238\";i:4477;s:11:\"delete-3240\";i:4478;s:11:\"delete-3241\";i:4479;s:11:\"delete-3243\";i:4480;s:11:\"delete-3242\";i:4481;s:11:\"delete-3244\";i:4482;s:11:\"delete-3245\";i:4483;s:11:\"delete-3247\";i:4484;s:11:\"delete-3246\";i:4485;s:11:\"delete-3248\";i:4486;s:11:\"delete-3249\";i:4487;s:11:\"delete-3251\";i:4488;s:11:\"delete-3250\";i:4489;s:11:\"delete-3252\";i:4490;s:11:\"delete-3253\";i:4491;s:11:\"delete-3255\";i:4492;s:11:\"delete-3254\";i:4493;s:11:\"delete-3256\";i:4494;s:11:\"delete-3257\";i:4495;s:11:\"delete-3259\";i:4496;s:11:\"delete-3258\";i:4497;s:11:\"delete-3260\";i:4498;s:11:\"delete-3261\";i:4499;s:11:\"delete-3263\";i:4500;s:11:\"delete-3262\";i:4501;s:11:\"delete-3264\";i:4502;s:11:\"delete-3265\";i:4503;s:11:\"delete-3267\";i:4504;s:11:\"delete-3266\";i:4505;s:11:\"delete-3268\";i:4506;s:11:\"delete-3269\";i:4507;s:11:\"delete-3271\";i:4508;s:11:\"delete-3270\";i:4509;s:11:\"delete-3272\";i:4510;s:11:\"delete-3273\";i:4511;s:11:\"delete-3275\";i:4512;s:11:\"delete-3274\";i:4513;s:11:\"delete-3276\";i:4514;s:11:\"delete-3277\";i:4515;s:11:\"delete-3279\";i:4516;s:11:\"delete-3278\";i:4517;s:11:\"delete-3280\";i:4518;s:11:\"delete-3281\";i:4519;s:11:\"delete-3283\";i:4520;s:11:\"delete-3282\";i:4521;s:11:\"delete-3284\";i:4522;s:11:\"delete-3285\";i:4523;s:11:\"delete-3287\";i:4524;s:11:\"delete-3286\";i:4525;s:11:\"delete-3288\";i:4526;s:11:\"delete-3289\";i:4527;s:11:\"delete-3291\";i:4528;s:11:\"delete-3290\";i:4529;s:11:\"delete-3292\";i:4530;s:11:\"delete-3293\";i:4531;s:11:\"delete-3295\";i:4532;s:11:\"delete-3294\";i:4533;s:11:\"delete-3296\";i:4534;s:11:\"delete-3297\";i:4535;s:11:\"delete-3299\";i:4536;s:11:\"delete-3298\";i:4537;s:11:\"delete-3300\";i:4538;s:11:\"delete-3301\";i:4539;s:11:\"delete-3303\";i:4540;s:11:\"delete-3302\";i:4541;s:11:\"delete-3304\";i:4542;s:11:\"delete-3305\";i:4543;s:11:\"delete-3307\";i:4544;s:11:\"delete-3306\";i:4545;s:11:\"delete-3308\";i:4546;s:11:\"delete-3309\";i:4547;s:11:\"delete-3311\";i:4548;s:11:\"delete-3310\";i:4549;s:11:\"delete-3312\";i:4550;s:11:\"delete-3313\";i:4551;s:11:\"delete-3315\";i:4552;s:11:\"delete-3314\";i:4553;s:11:\"delete-3316\";i:4554;s:11:\"delete-3317\";i:4555;s:11:\"delete-3319\";i:4556;s:11:\"delete-3318\";i:4557;s:11:\"delete-3320\";i:4558;s:11:\"delete-3321\";i:4559;s:11:\"delete-3323\";i:4560;s:11:\"delete-3322\";i:4561;s:11:\"delete-3324\";i:4562;s:11:\"delete-3325\";i:4563;s:11:\"delete-3327\";i:4564;s:11:\"delete-3326\";i:4565;s:11:\"delete-3328\";i:4566;s:11:\"delete-3329\";i:4567;s:11:\"delete-3331\";i:4568;s:11:\"delete-3330\";i:4569;s:11:\"delete-3332\";i:4570;s:11:\"delete-3333\";i:4571;s:11:\"delete-3335\";i:4572;s:11:\"delete-3334\";i:4573;s:11:\"delete-3336\";i:4574;s:11:\"delete-3337\";i:4575;s:11:\"delete-3339\";i:4576;s:11:\"delete-3338\";i:4577;s:11:\"delete-3340\";i:4578;s:11:\"delete-3341\";i:4579;s:11:\"delete-3343\";i:4580;s:11:\"delete-3342\";i:4581;s:11:\"delete-3344\";i:4582;s:11:\"delete-3345\";i:4583;s:11:\"delete-3347\";i:4584;s:11:\"delete-3346\";i:4585;s:11:\"delete-3348\";i:4586;s:11:\"delete-3349\";i:4587;s:11:\"delete-3351\";i:4588;s:11:\"delete-3350\";i:4589;s:11:\"delete-3352\";i:4590;s:11:\"delete-3353\";i:4591;s:11:\"delete-3355\";i:4592;s:11:\"delete-3354\";i:4593;s:11:\"delete-3356\";i:4594;s:11:\"delete-3357\";i:4595;s:11:\"delete-3359\";i:4596;s:11:\"delete-3358\";i:4597;s:11:\"delete-3360\";i:4598;s:11:\"delete-3361\";i:4599;s:11:\"delete-3363\";i:4600;s:11:\"delete-3362\";i:4601;s:11:\"delete-3364\";i:4602;s:11:\"delete-3365\";i:4603;s:11:\"delete-3367\";i:4604;s:11:\"delete-3366\";i:4605;s:11:\"delete-3368\";i:4606;s:11:\"delete-3369\";i:4607;s:11:\"delete-3371\";i:4608;s:11:\"delete-3370\";i:4609;s:11:\"delete-3372\";i:4610;s:11:\"delete-3373\";i:4611;s:11:\"delete-3375\";i:4612;s:11:\"delete-3374\";i:4613;s:11:\"delete-3376\";i:4614;s:11:\"delete-3377\";i:4615;s:11:\"delete-3379\";i:4616;s:11:\"delete-3378\";i:4617;s:11:\"delete-3380\";i:4618;s:11:\"delete-3381\";i:4619;s:11:\"delete-3383\";i:4620;s:11:\"delete-3382\";i:4621;s:11:\"delete-3384\";i:4622;s:11:\"delete-3385\";i:4623;s:11:\"delete-3387\";i:4624;s:11:\"delete-3386\";i:4625;s:11:\"delete-3388\";i:4626;s:11:\"delete-3389\";i:4627;s:11:\"delete-3391\";i:4628;s:11:\"delete-3390\";i:4629;s:11:\"delete-3392\";i:4630;s:11:\"delete-3393\";i:4631;s:11:\"delete-3395\";i:4632;s:11:\"delete-3394\";i:4633;s:11:\"delete-3396\";i:4634;s:11:\"delete-3397\";i:4635;s:11:\"delete-3399\";i:4636;s:11:\"delete-3398\";i:4637;s:11:\"delete-3400\";i:4638;s:11:\"delete-3401\";i:4639;s:11:\"delete-3403\";i:4640;s:11:\"delete-3402\";i:4641;s:11:\"delete-3404\";i:4642;s:11:\"delete-3405\";i:4643;s:11:\"delete-3407\";i:4644;s:11:\"delete-3406\";i:4645;s:11:\"delete-3408\";i:4646;s:11:\"delete-3409\";i:4647;s:11:\"delete-3411\";i:4648;s:11:\"delete-3410\";i:4649;s:11:\"delete-3412\";i:4650;s:11:\"delete-3413\";i:4651;s:11:\"delete-3415\";i:4652;s:11:\"delete-3414\";i:4653;s:11:\"delete-3416\";i:4654;s:11:\"delete-3417\";i:4655;s:11:\"delete-3419\";i:4656;s:11:\"delete-3418\";i:4657;s:11:\"delete-3420\";i:4658;s:11:\"delete-3421\";i:4659;s:11:\"delete-3423\";i:4660;s:11:\"delete-3422\";i:4661;s:11:\"delete-3424\";i:4662;s:11:\"delete-3425\";i:4663;s:11:\"delete-3427\";i:4664;s:11:\"delete-3426\";i:4665;s:11:\"delete-3428\";i:4666;s:11:\"delete-3429\";i:4667;s:11:\"delete-3431\";i:4668;s:11:\"delete-3430\";i:4669;s:11:\"delete-3432\";i:4670;s:11:\"delete-3433\";i:4671;s:11:\"delete-3435\";i:4672;s:11:\"delete-3434\";i:4673;s:11:\"delete-3436\";i:4674;s:11:\"delete-3437\";i:4675;s:11:\"delete-3439\";i:4676;s:11:\"delete-3438\";i:4677;s:11:\"delete-3440\";i:4678;s:11:\"delete-3441\";i:4679;s:11:\"delete-3443\";i:4680;s:11:\"delete-3442\";i:4681;s:11:\"delete-3444\";i:4682;s:11:\"delete-3445\";i:4683;s:11:\"delete-3447\";i:4684;s:11:\"delete-3446\";i:4685;s:11:\"delete-3448\";i:4686;s:11:\"delete-3449\";i:4687;s:11:\"delete-3451\";i:4688;s:11:\"delete-3450\";i:4689;s:11:\"delete-3452\";i:4690;s:11:\"delete-3453\";i:4691;s:11:\"delete-3455\";i:4692;s:11:\"delete-3454\";i:4693;s:11:\"delete-3456\";i:4694;s:11:\"delete-3457\";i:4695;s:11:\"delete-3459\";i:4696;s:11:\"delete-3458\";i:4697;s:11:\"delete-3460\";i:4698;s:11:\"delete-3461\";i:4699;s:11:\"delete-3463\";i:4700;s:11:\"delete-3462\";i:4701;s:11:\"delete-3464\";i:4702;s:11:\"delete-3465\";i:4703;s:11:\"delete-3467\";i:4704;s:11:\"delete-3466\";i:4705;s:11:\"delete-3468\";i:4706;s:11:\"delete-3469\";i:4707;s:11:\"delete-3471\";i:4708;s:11:\"delete-3470\";i:4709;s:11:\"delete-3472\";i:4710;s:11:\"delete-3473\";i:4711;s:11:\"delete-3475\";i:4712;s:11:\"delete-3474\";i:4713;s:11:\"delete-3476\";i:4714;s:11:\"delete-3477\";i:4715;s:11:\"delete-3479\";i:4716;s:11:\"delete-3478\";i:4717;s:11:\"delete-3480\";i:4718;s:11:\"delete-3481\";i:4719;s:11:\"delete-3483\";i:4720;s:11:\"delete-3482\";i:4721;s:11:\"delete-3484\";i:4722;s:11:\"delete-3485\";i:4723;s:11:\"delete-3487\";i:4724;s:11:\"delete-3486\";i:4725;s:11:\"delete-3488\";i:4726;s:11:\"delete-3489\";i:4727;s:11:\"delete-3491\";i:4728;s:11:\"delete-3490\";i:4729;s:11:\"delete-3492\";i:4730;s:11:\"delete-3493\";i:4731;s:11:\"delete-3495\";i:4732;s:11:\"delete-3494\";i:4733;s:11:\"delete-3496\";i:4734;s:11:\"delete-3497\";i:4735;s:11:\"delete-3499\";i:4736;s:11:\"delete-3498\";i:4737;s:11:\"delete-3500\";i:4738;s:11:\"delete-3501\";i:4739;s:11:\"delete-3503\";i:4740;s:11:\"delete-3502\";i:4741;s:11:\"delete-3504\";i:4742;s:11:\"delete-3505\";i:4743;s:11:\"delete-3507\";i:4744;s:11:\"delete-3506\";i:4745;s:11:\"delete-3508\";i:4746;s:11:\"delete-3509\";i:4747;s:11:\"delete-3511\";i:4748;s:11:\"delete-3510\";i:4749;s:11:\"delete-3512\";i:4750;s:11:\"delete-3513\";i:4751;s:11:\"delete-3515\";i:4752;s:11:\"delete-3514\";i:4753;s:11:\"delete-3516\";i:4754;s:11:\"delete-3517\";i:4755;s:11:\"delete-3519\";i:4756;s:11:\"delete-3518\";i:4757;s:11:\"delete-3520\";i:4758;s:11:\"delete-3521\";i:4759;s:11:\"delete-3523\";i:4760;s:11:\"delete-3522\";i:4761;s:11:\"delete-3524\";i:4762;s:11:\"delete-3525\";i:4763;s:11:\"delete-3527\";i:4764;s:11:\"delete-3526\";i:4765;s:11:\"delete-3528\";i:4766;s:11:\"delete-3529\";i:4767;s:11:\"delete-3531\";i:4768;s:11:\"delete-3530\";i:4769;s:11:\"delete-3532\";i:4770;s:11:\"delete-3533\";i:4771;s:11:\"delete-3535\";i:4772;s:11:\"delete-3534\";i:4773;s:11:\"delete-3536\";i:4774;s:11:\"delete-3537\";i:4775;s:11:\"delete-3539\";i:4776;s:11:\"delete-3538\";i:4777;s:11:\"delete-3540\";i:4778;s:11:\"delete-3541\";i:4779;s:11:\"delete-3543\";i:4780;s:11:\"delete-3542\";i:4781;s:11:\"delete-3544\";i:4782;s:11:\"delete-3545\";i:4783;s:11:\"delete-3547\";i:4784;s:11:\"delete-3546\";i:4785;s:11:\"delete-3548\";i:4786;s:11:\"delete-3549\";i:4787;s:11:\"delete-3551\";i:4788;s:11:\"delete-3550\";i:4789;s:11:\"delete-3552\";i:4790;s:11:\"delete-3553\";i:4791;s:11:\"delete-3555\";i:4792;s:11:\"delete-3554\";i:4793;s:11:\"delete-3556\";i:4794;s:11:\"delete-3557\";i:4795;s:11:\"delete-3559\";i:4796;s:11:\"delete-3558\";i:4797;s:11:\"delete-3560\";i:4798;s:11:\"delete-3561\";i:4799;s:11:\"delete-3563\";i:4800;s:11:\"delete-3562\";i:4801;s:11:\"delete-3564\";i:4802;s:11:\"delete-3565\";i:4803;s:11:\"delete-3567\";i:4804;s:11:\"delete-3566\";i:4805;s:11:\"delete-3568\";i:4806;s:11:\"delete-3569\";i:4807;s:11:\"delete-3571\";i:4808;s:11:\"delete-3570\";i:4809;s:11:\"delete-3572\";i:4810;s:11:\"delete-3573\";i:4811;s:11:\"delete-3575\";i:4812;s:11:\"delete-3574\";i:4813;s:11:\"delete-3576\";i:4814;s:11:\"delete-3577\";i:4815;s:11:\"delete-3579\";i:4816;s:11:\"delete-3578\";i:4817;s:11:\"delete-3580\";i:4818;s:11:\"delete-3581\";i:4819;s:11:\"delete-3583\";i:4820;s:11:\"delete-3582\";i:4821;s:11:\"delete-3584\";i:4822;s:11:\"delete-3585\";i:4823;s:11:\"delete-3587\";i:4824;s:11:\"delete-3586\";i:4825;s:11:\"delete-3588\";i:4826;s:11:\"delete-3589\";i:4827;s:11:\"delete-3591\";i:4828;s:11:\"delete-3590\";i:4829;s:11:\"delete-3592\";i:4830;s:11:\"delete-3593\";i:4831;s:11:\"delete-3595\";i:4832;s:11:\"delete-3594\";i:4833;s:11:\"delete-3596\";i:4834;s:11:\"delete-3597\";i:4835;s:11:\"delete-3599\";i:4836;s:11:\"delete-3598\";i:4837;s:11:\"delete-3600\";i:4838;s:11:\"delete-3601\";i:4839;s:11:\"delete-3603\";i:4840;s:11:\"delete-3602\";i:4841;s:11:\"delete-3604\";i:4842;s:11:\"delete-3605\";i:4843;s:11:\"delete-3607\";i:4844;s:11:\"delete-3606\";i:4845;s:11:\"delete-3608\";i:4846;s:11:\"delete-3609\";i:4847;s:11:\"delete-3611\";i:4848;s:11:\"delete-3610\";i:4849;s:11:\"delete-3612\";i:4850;s:11:\"delete-3613\";i:4851;s:11:\"delete-3615\";i:4852;s:11:\"delete-3614\";i:4853;s:11:\"delete-3616\";i:4854;s:11:\"delete-3617\";i:4855;s:11:\"delete-3619\";i:4856;s:11:\"delete-3618\";i:4857;s:11:\"delete-3620\";i:4858;s:11:\"delete-3621\";i:4859;s:11:\"delete-3623\";i:4860;s:11:\"delete-3622\";i:4861;s:11:\"delete-3624\";i:4862;s:11:\"delete-3625\";i:4863;s:11:\"delete-3627\";i:4864;s:11:\"delete-3626\";i:4865;s:11:\"delete-3628\";i:4866;s:11:\"delete-3629\";i:4867;s:11:\"delete-3631\";i:4868;s:11:\"delete-3630\";i:4869;s:11:\"delete-3632\";i:4870;s:11:\"delete-3633\";i:4871;s:11:\"delete-3635\";i:4872;s:11:\"delete-3634\";i:4873;s:11:\"delete-3636\";i:4874;s:11:\"delete-3637\";i:4875;s:11:\"delete-3639\";i:4876;s:11:\"delete-3638\";i:4877;s:11:\"delete-3640\";i:4878;s:11:\"delete-3641\";i:4879;s:11:\"delete-3643\";i:4880;s:11:\"delete-3642\";i:4881;s:11:\"delete-3644\";i:4882;s:11:\"delete-3645\";i:4883;s:11:\"delete-3647\";i:4884;s:11:\"delete-3646\";i:4885;s:11:\"delete-3648\";i:4886;s:11:\"delete-3649\";i:4887;s:11:\"delete-3651\";i:4888;s:11:\"delete-3650\";i:4889;s:11:\"delete-3652\";i:4890;s:11:\"delete-3653\";i:4891;s:11:\"delete-3655\";i:4892;s:11:\"delete-3654\";i:4893;s:11:\"delete-3656\";i:4894;s:11:\"delete-3657\";i:4895;s:11:\"delete-3659\";i:4896;s:11:\"delete-3658\";i:4897;s:11:\"delete-3660\";i:4898;s:11:\"delete-3661\";i:4899;s:11:\"delete-3663\";i:4900;s:11:\"delete-3662\";i:4901;s:11:\"delete-3664\";i:4902;s:11:\"delete-3665\";i:4903;s:11:\"delete-3667\";i:4904;s:11:\"delete-3666\";i:4905;s:11:\"delete-3668\";i:4906;s:11:\"delete-3669\";i:4907;s:11:\"delete-3671\";i:4908;s:11:\"delete-3670\";i:4909;s:11:\"delete-3672\";i:4910;s:11:\"delete-3673\";i:4911;s:11:\"delete-3675\";i:4912;s:11:\"delete-3674\";i:4913;s:11:\"delete-3676\";i:4914;s:11:\"delete-3677\";i:4915;s:11:\"delete-3679\";i:4916;s:11:\"delete-3678\";i:4917;s:11:\"delete-3680\";i:4918;s:11:\"delete-3681\";i:4919;s:11:\"delete-3683\";i:4920;s:11:\"delete-3682\";i:4921;s:11:\"delete-3684\";i:4922;s:11:\"delete-3685\";i:4923;s:11:\"delete-3687\";i:4924;s:11:\"delete-3686\";i:4925;s:11:\"delete-3688\";i:4926;s:11:\"delete-3689\";i:4927;s:11:\"delete-3691\";i:4928;s:11:\"delete-3690\";i:4929;s:11:\"delete-3692\";i:4930;s:11:\"delete-3693\";i:4931;s:11:\"delete-3695\";i:4932;s:11:\"delete-3694\";i:4933;s:11:\"delete-3696\";i:4934;s:11:\"delete-3697\";i:4935;s:11:\"delete-3699\";i:4936;s:11:\"delete-3698\";i:4937;s:11:\"delete-3700\";i:4938;s:11:\"delete-3701\";i:4939;s:11:\"delete-3703\";i:4940;s:11:\"delete-3702\";i:4941;s:11:\"delete-3704\";i:4942;s:11:\"delete-3705\";i:4943;s:11:\"delete-3707\";i:4944;s:11:\"delete-3706\";i:4945;s:11:\"delete-3708\";i:4946;s:11:\"delete-3709\";i:4947;s:11:\"delete-3711\";i:4948;s:11:\"delete-3710\";i:4949;s:11:\"delete-3712\";i:4950;s:11:\"delete-3713\";i:4951;s:11:\"delete-3715\";i:4952;s:11:\"delete-3714\";i:4953;s:11:\"delete-3716\";i:4954;s:11:\"delete-3717\";i:4955;s:11:\"delete-3719\";i:4956;s:11:\"delete-3718\";i:4957;s:11:\"delete-3720\";i:4958;s:11:\"delete-3721\";i:4959;s:11:\"delete-3723\";i:4960;s:11:\"delete-3722\";i:4961;s:11:\"delete-3724\";i:4962;s:11:\"delete-3725\";i:4963;s:11:\"delete-3727\";i:4964;s:11:\"delete-3726\";i:4965;s:11:\"delete-3728\";i:4966;s:11:\"delete-3729\";i:4967;s:11:\"delete-3731\";i:4968;s:11:\"delete-3730\";i:4969;s:11:\"delete-3732\";i:4970;s:11:\"delete-3733\";i:4971;s:11:\"delete-3735\";i:4972;s:11:\"delete-3734\";i:4973;s:11:\"delete-3736\";i:4974;s:11:\"delete-3737\";i:4975;s:11:\"delete-3739\";i:4976;s:11:\"delete-3738\";i:4977;s:11:\"delete-3740\";i:4978;s:11:\"delete-3741\";i:4979;s:11:\"delete-3743\";i:4980;s:11:\"delete-3742\";i:4981;s:11:\"delete-3744\";i:4982;s:11:\"delete-3745\";i:4983;s:11:\"delete-3747\";i:4984;s:11:\"delete-3746\";i:4985;s:11:\"delete-3748\";i:4986;s:11:\"delete-3749\";i:4987;s:11:\"delete-3751\";i:4988;s:11:\"delete-3750\";i:4989;s:11:\"delete-3752\";i:4990;s:11:\"delete-3753\";i:4991;s:11:\"delete-3755\";i:4992;s:11:\"delete-3754\";i:4993;s:11:\"delete-3756\";i:4994;s:11:\"delete-3757\";i:4995;s:11:\"delete-3759\";i:4996;s:11:\"delete-3758\";i:4997;s:11:\"delete-3760\";i:4998;s:11:\"delete-3761\";i:4999;s:11:\"delete-3763\";i:5000;s:11:\"delete-3762\";i:5001;s:11:\"delete-3764\";i:5002;s:11:\"delete-3765\";i:5003;s:11:\"delete-3767\";i:5004;s:11:\"delete-3766\";i:5005;s:11:\"delete-3768\";i:5006;s:11:\"delete-3769\";i:5007;s:11:\"delete-3771\";i:5008;s:11:\"delete-3770\";i:5009;s:11:\"delete-3772\";i:5010;s:11:\"delete-3773\";i:5011;s:11:\"delete-3775\";i:5012;s:11:\"delete-3774\";i:5013;s:11:\"delete-3776\";i:5014;s:11:\"delete-3777\";i:5015;s:11:\"delete-3779\";i:5016;s:11:\"delete-3778\";i:5017;s:11:\"delete-3780\";i:5018;s:11:\"delete-3781\";i:5019;s:11:\"delete-3783\";i:5020;s:11:\"delete-3782\";i:5021;s:11:\"delete-3784\";i:5022;s:11:\"delete-3785\";i:5023;s:11:\"delete-3787\";i:5024;s:11:\"delete-3786\";i:5025;s:11:\"delete-3788\";i:5026;s:11:\"delete-3789\";i:5027;s:11:\"delete-3791\";i:5028;s:11:\"delete-3790\";i:5029;s:11:\"delete-3792\";i:5030;s:11:\"delete-3793\";i:5031;s:11:\"delete-3795\";i:5032;s:11:\"delete-3794\";i:5033;s:11:\"delete-3796\";i:5034;s:11:\"delete-3797\";i:5035;s:11:\"delete-3799\";i:5036;s:11:\"delete-3798\";i:5037;s:11:\"delete-3800\";i:5038;s:11:\"delete-3801\";i:5039;s:11:\"delete-3803\";i:5040;s:11:\"delete-3802\";i:5041;s:11:\"delete-3804\";i:5042;s:11:\"delete-3805\";i:5043;s:11:\"delete-3807\";i:5044;s:11:\"delete-3806\";i:5045;s:11:\"delete-3808\";i:5046;s:11:\"delete-3809\";i:5047;s:11:\"delete-3811\";i:5048;s:11:\"delete-3810\";i:5049;s:11:\"delete-3812\";i:5050;s:11:\"delete-3813\";i:5051;s:11:\"delete-3815\";i:5052;s:11:\"delete-3814\";i:5053;s:11:\"delete-3816\";i:5054;s:11:\"delete-3817\";i:5055;s:11:\"delete-3819\";i:5056;s:11:\"delete-3818\";i:5057;s:11:\"delete-3820\";i:5058;s:11:\"delete-3821\";i:5059;s:11:\"delete-3823\";i:5060;s:11:\"delete-3822\";i:5061;s:11:\"delete-3824\";i:5062;s:11:\"delete-3825\";i:5063;s:11:\"delete-3827\";i:5064;s:11:\"delete-3826\";i:5065;s:11:\"delete-3828\";i:5066;s:11:\"delete-3829\";i:5067;s:11:\"delete-3831\";i:5068;s:11:\"delete-3830\";i:5069;s:11:\"delete-3832\";i:5070;s:11:\"delete-3833\";i:5071;s:11:\"delete-3835\";i:5072;s:11:\"delete-3834\";i:5073;s:11:\"delete-3836\";i:5074;s:11:\"delete-3837\";i:5075;s:11:\"delete-3839\";i:5076;s:11:\"delete-3838\";i:5077;s:11:\"delete-3840\";i:5078;s:11:\"delete-3841\";i:5079;s:11:\"delete-3843\";i:5080;s:11:\"delete-3842\";i:5081;s:11:\"delete-3844\";i:5082;s:11:\"delete-3845\";i:5083;s:11:\"delete-3847\";i:5084;s:11:\"delete-3846\";i:5085;s:11:\"delete-3848\";i:5086;s:11:\"delete-3849\";i:5087;s:11:\"delete-3851\";i:5088;s:11:\"delete-3850\";i:5089;s:11:\"delete-3852\";i:5090;s:11:\"delete-3853\";i:5091;s:11:\"delete-3855\";i:5092;s:11:\"delete-3854\";i:5093;s:11:\"delete-3856\";i:5094;s:11:\"delete-3857\";i:5095;s:11:\"delete-3859\";i:5096;s:11:\"delete-3858\";i:5097;s:11:\"delete-3860\";i:5098;s:11:\"delete-3861\";i:5099;s:11:\"delete-3863\";i:5100;s:11:\"delete-3862\";i:5101;s:11:\"delete-3864\";i:5102;s:11:\"delete-3865\";i:5103;s:11:\"delete-3867\";i:5104;s:11:\"delete-3866\";i:5105;s:11:\"delete-3868\";i:5106;s:11:\"delete-3869\";i:5107;s:11:\"delete-3871\";i:5108;s:11:\"delete-3870\";i:5109;s:11:\"delete-3872\";i:5110;s:11:\"delete-3873\";i:5111;s:11:\"delete-3875\";i:5112;s:11:\"delete-3874\";i:5113;s:11:\"delete-3876\";i:5114;s:11:\"delete-3877\";i:5115;s:11:\"delete-3879\";i:5116;s:11:\"delete-3878\";i:5117;s:11:\"delete-3880\";i:5118;s:11:\"delete-3881\";i:5119;s:11:\"delete-3883\";i:5120;s:11:\"delete-3882\";i:5121;s:11:\"delete-3884\";i:5122;s:11:\"delete-3885\";i:5123;s:11:\"delete-3887\";i:5124;s:11:\"delete-3886\";i:5125;s:11:\"delete-3888\";i:5126;s:11:\"delete-3889\";i:5127;s:11:\"delete-3891\";i:5128;s:11:\"delete-3890\";i:5129;s:11:\"delete-3892\";i:5130;s:11:\"delete-3893\";i:5131;s:11:\"delete-3895\";i:5132;s:11:\"delete-3894\";i:5133;s:11:\"delete-3896\";i:5134;s:11:\"delete-3897\";i:5135;s:11:\"delete-3899\";i:5136;s:11:\"delete-3898\";i:5137;s:11:\"delete-3900\";i:5138;s:11:\"delete-3901\";i:5139;s:11:\"delete-3903\";i:5140;s:11:\"delete-3902\";i:5141;s:11:\"delete-3904\";i:5142;s:11:\"delete-3905\";i:5143;s:11:\"delete-3907\";i:5144;s:11:\"delete-3906\";i:5145;s:11:\"delete-3908\";i:5146;s:11:\"delete-3909\";i:5147;s:11:\"delete-3911\";i:5148;s:11:\"delete-3910\";i:5149;s:11:\"delete-3912\";i:5150;s:11:\"delete-3913\";i:5151;s:11:\"delete-3915\";i:5152;s:11:\"delete-3914\";i:5153;s:11:\"delete-3916\";i:5154;s:11:\"delete-3917\";i:5155;s:11:\"delete-3919\";i:5156;s:11:\"delete-3918\";i:5157;s:11:\"delete-3920\";i:5158;s:11:\"delete-3921\";i:5159;s:11:\"delete-3923\";i:5160;s:11:\"delete-3922\";i:5161;s:11:\"delete-3924\";i:5162;s:11:\"delete-3925\";i:5163;s:11:\"delete-3927\";i:5164;s:11:\"delete-3926\";i:5165;s:11:\"delete-3928\";i:5166;s:11:\"delete-3929\";i:5167;s:11:\"delete-3931\";i:5168;s:11:\"delete-3930\";i:5169;s:11:\"delete-3932\";i:5170;s:11:\"delete-3933\";i:5171;s:11:\"delete-3935\";i:5172;s:11:\"delete-3934\";i:5173;s:11:\"delete-3936\";i:5174;s:11:\"delete-3937\";i:5175;s:11:\"delete-3939\";i:5176;s:11:\"delete-3938\";i:5177;s:11:\"delete-3940\";i:5178;s:11:\"delete-3941\";i:5179;s:11:\"delete-3943\";i:5180;s:11:\"delete-3942\";i:5181;s:11:\"delete-3944\";i:5182;s:11:\"delete-3945\";i:5183;s:11:\"delete-3947\";i:5184;s:11:\"delete-3946\";i:5185;s:11:\"delete-3948\";i:5186;s:11:\"delete-3949\";i:5187;s:11:\"delete-3951\";i:5188;s:11:\"delete-3950\";i:5189;s:11:\"delete-3952\";i:5190;s:11:\"delete-3953\";i:5191;s:11:\"delete-3955\";i:5192;s:11:\"delete-3954\";i:5193;s:11:\"delete-3956\";i:5194;s:11:\"delete-3957\";i:5195;s:11:\"delete-3959\";i:5196;s:11:\"delete-3958\";i:5197;s:11:\"delete-3960\";i:5198;s:11:\"delete-3961\";i:5199;s:11:\"delete-3963\";i:5200;s:11:\"delete-3962\";i:5201;s:11:\"delete-3964\";i:5202;s:11:\"delete-3965\";i:5203;s:11:\"delete-3967\";i:5204;s:11:\"delete-3966\";i:5205;s:11:\"delete-3968\";i:5206;s:11:\"delete-3969\";i:5207;s:11:\"delete-3971\";i:5208;s:11:\"delete-3970\";i:5209;s:11:\"delete-3972\";i:5210;s:11:\"delete-3973\";i:5211;s:11:\"delete-3975\";i:5212;s:11:\"delete-3974\";i:5213;s:11:\"delete-3976\";i:5214;s:11:\"delete-3977\";i:5215;s:11:\"delete-3979\";i:5216;s:11:\"delete-3978\";i:5217;s:11:\"delete-3980\";i:5218;s:11:\"delete-3981\";i:5219;s:11:\"delete-3983\";i:5220;s:11:\"delete-3982\";i:5221;s:11:\"delete-3984\";i:5222;s:11:\"delete-3985\";i:5223;s:11:\"delete-3987\";i:5224;s:11:\"delete-3986\";i:5225;s:11:\"delete-3988\";i:5226;s:11:\"delete-3989\";i:5227;s:11:\"delete-3991\";i:5228;s:11:\"delete-3990\";i:5229;s:11:\"delete-3992\";i:5230;s:11:\"delete-3993\";i:5231;s:11:\"delete-3995\";i:5232;s:11:\"delete-3994\";i:5233;s:11:\"delete-3996\";i:5234;s:11:\"delete-3997\";i:5235;s:11:\"delete-3999\";i:5236;s:11:\"delete-3998\";i:5237;s:11:\"delete-4000\";i:5238;s:11:\"delete-4001\";i:5239;s:11:\"delete-4003\";i:5240;s:11:\"delete-4002\";i:5241;s:11:\"delete-4004\";i:5242;s:11:\"delete-4005\";i:5243;s:11:\"delete-4007\";i:5244;s:11:\"delete-4006\";i:5245;s:11:\"delete-4008\";i:5246;s:11:\"delete-4009\";i:5247;s:11:\"delete-4011\";i:5248;s:11:\"delete-4010\";i:5249;s:11:\"delete-4012\";i:5250;s:11:\"delete-4013\";i:5251;s:11:\"delete-4015\";i:5252;s:11:\"delete-4014\";i:5253;s:11:\"delete-4016\";i:5254;s:11:\"delete-4017\";i:5255;s:11:\"delete-4019\";i:5256;s:11:\"delete-4018\";i:5257;s:11:\"delete-4020\";i:5258;s:11:\"delete-4021\";i:5259;s:11:\"delete-4023\";i:5260;s:11:\"delete-4022\";i:5261;s:11:\"delete-4024\";i:5262;s:11:\"delete-4025\";i:5263;s:11:\"delete-4027\";i:5264;s:11:\"delete-4026\";i:5265;s:11:\"delete-4028\";i:5266;s:11:\"delete-4029\";i:5267;s:11:\"delete-4031\";i:5268;s:11:\"delete-4030\";i:5269;s:11:\"delete-4032\";i:5270;s:11:\"delete-4033\";i:5271;s:11:\"delete-4035\";i:5272;s:11:\"delete-4034\";i:5273;s:11:\"delete-4036\";i:5274;s:11:\"delete-4037\";i:5275;s:11:\"delete-4039\";i:5276;s:11:\"delete-4038\";i:5277;s:11:\"delete-4040\";i:5278;s:11:\"delete-4041\";i:5279;s:11:\"delete-4043\";i:5280;s:11:\"delete-4042\";i:5281;s:11:\"delete-4044\";i:5282;s:11:\"delete-4045\";i:5283;s:11:\"delete-4047\";i:5284;s:11:\"delete-4046\";i:5285;s:11:\"delete-4048\";i:5286;s:11:\"delete-4049\";i:5287;s:11:\"delete-4051\";i:5288;s:11:\"delete-4050\";i:5289;s:11:\"delete-4052\";i:5290;s:11:\"delete-4053\";i:5291;s:11:\"delete-4055\";i:5292;s:11:\"delete-4054\";i:5293;s:11:\"delete-4056\";i:5294;s:11:\"delete-4057\";i:5295;s:11:\"delete-4059\";i:5296;s:11:\"delete-4058\";i:5297;s:11:\"delete-4060\";i:5298;s:11:\"delete-4061\";i:5299;s:11:\"delete-4063\";i:5300;s:11:\"delete-4062\";i:5301;s:11:\"delete-4064\";i:5302;s:11:\"delete-4065\";i:5303;s:11:\"delete-4067\";i:5304;s:11:\"delete-4066\";i:5305;s:11:\"delete-4068\";i:5306;s:11:\"delete-4069\";i:5307;s:11:\"delete-4071\";i:5308;s:11:\"delete-4070\";i:5309;s:11:\"delete-4072\";i:5310;s:11:\"delete-4073\";i:5311;s:11:\"delete-4075\";i:5312;s:11:\"delete-4074\";i:5313;s:11:\"delete-4076\";i:5314;s:11:\"delete-4077\";i:5315;s:11:\"delete-4079\";i:5316;s:11:\"delete-4078\";i:5317;s:11:\"delete-4080\";i:5318;s:11:\"delete-4081\";i:5319;s:11:\"delete-4083\";i:5320;s:11:\"delete-4082\";i:5321;s:11:\"delete-4084\";i:5322;s:11:\"delete-4085\";i:5323;s:11:\"delete-4087\";i:5324;s:11:\"delete-4086\";i:5325;s:11:\"delete-4088\";i:5326;s:11:\"delete-4089\";i:5327;s:11:\"delete-4091\";i:5328;s:11:\"delete-4090\";i:5329;s:11:\"delete-4092\";i:5330;s:11:\"delete-4093\";i:5331;s:11:\"delete-4095\";i:5332;s:11:\"delete-4094\";i:5333;s:11:\"delete-4096\";i:5334;s:11:\"delete-4097\";i:5335;s:11:\"delete-4099\";i:5336;s:11:\"delete-4098\";i:5337;s:11:\"delete-4100\";i:5338;s:11:\"delete-4101\";i:5339;s:11:\"delete-4103\";i:5340;s:11:\"delete-4102\";i:5341;s:11:\"delete-4104\";i:5342;s:11:\"delete-4105\";i:5343;s:11:\"delete-4107\";i:5344;s:11:\"delete-4106\";i:5345;s:11:\"delete-4108\";i:5346;s:11:\"delete-4109\";i:5347;s:11:\"delete-4111\";i:5348;s:11:\"delete-4110\";i:5349;s:11:\"delete-4112\";i:5350;s:11:\"delete-4113\";i:5351;s:11:\"delete-4115\";i:5352;s:11:\"delete-4114\";i:5353;s:11:\"delete-4116\";i:5354;s:11:\"delete-4117\";i:5355;s:11:\"delete-4119\";i:5356;s:11:\"delete-4118\";i:5357;s:11:\"delete-4120\";i:5358;s:11:\"delete-4121\";i:5359;s:11:\"delete-4123\";i:5360;s:11:\"delete-4122\";i:5361;s:11:\"delete-4124\";i:5362;s:11:\"delete-4125\";i:5363;s:11:\"delete-4127\";i:5364;s:11:\"delete-4126\";i:5365;s:11:\"delete-4128\";i:5366;s:11:\"delete-4129\";i:5367;s:11:\"delete-4131\";i:5368;s:11:\"delete-4130\";i:5369;s:11:\"delete-4132\";i:5370;s:11:\"delete-4133\";i:5371;s:11:\"delete-4135\";i:5372;s:11:\"delete-4134\";i:5373;s:11:\"delete-4136\";i:5374;s:11:\"delete-4137\";i:5375;s:11:\"delete-4139\";i:5376;s:11:\"delete-4138\";i:5377;s:11:\"delete-4140\";i:5378;s:11:\"delete-4141\";i:5379;s:11:\"delete-4143\";i:5380;s:11:\"delete-4142\";i:5381;s:11:\"delete-4144\";i:5382;s:11:\"delete-4145\";i:5383;s:11:\"delete-4147\";i:5384;s:11:\"delete-4146\";i:5385;s:11:\"delete-4148\";i:5386;s:11:\"delete-4149\";i:5387;s:11:\"delete-4151\";i:5388;s:11:\"delete-4150\";i:5389;s:11:\"delete-4152\";i:5390;s:11:\"delete-4153\";i:5391;s:11:\"delete-4155\";i:5392;s:11:\"delete-4154\";i:5393;s:11:\"delete-4156\";i:5394;s:11:\"delete-4157\";i:5395;s:11:\"delete-4159\";i:5396;s:11:\"delete-4158\";i:5397;s:11:\"delete-4160\";i:5398;s:11:\"delete-4161\";i:5399;s:11:\"delete-4163\";i:5400;s:11:\"delete-4162\";i:5401;s:11:\"delete-4164\";i:5402;s:11:\"delete-4165\";i:5403;s:11:\"delete-4167\";i:5404;s:11:\"delete-4166\";i:5405;s:11:\"delete-4168\";i:5406;s:11:\"delete-4169\";i:5407;s:11:\"delete-4171\";i:5408;s:11:\"delete-4170\";i:5409;s:11:\"delete-4172\";i:5410;s:11:\"delete-4173\";i:5411;s:11:\"delete-4175\";i:5412;s:11:\"delete-4174\";i:5413;s:11:\"delete-4176\";i:5414;s:11:\"delete-4177\";i:5415;s:11:\"delete-4179\";i:5416;s:11:\"delete-4178\";i:5417;s:11:\"delete-4180\";i:5418;s:11:\"delete-4181\";i:5419;s:11:\"delete-4183\";i:5420;s:11:\"delete-4182\";i:5421;s:11:\"delete-4184\";i:5422;s:11:\"delete-4185\";i:5423;s:11:\"delete-4187\";i:5424;s:11:\"delete-4186\";i:5425;s:11:\"delete-4188\";i:5426;s:11:\"delete-4189\";i:5427;s:11:\"delete-4191\";i:5428;s:11:\"delete-4190\";i:5429;s:11:\"delete-4192\";i:5430;s:11:\"delete-4193\";i:5431;s:11:\"delete-4195\";i:5432;s:11:\"delete-4194\";i:5433;s:11:\"delete-4196\";i:5434;s:11:\"delete-4197\";i:5435;s:11:\"delete-4199\";i:5436;s:11:\"delete-4198\";i:5437;s:11:\"delete-4200\";i:5438;s:11:\"delete-4201\";i:5439;s:11:\"delete-4203\";i:5440;s:11:\"delete-4202\";i:5441;s:11:\"delete-4204\";i:5442;s:11:\"delete-4205\";i:5443;s:11:\"delete-4207\";i:5444;s:11:\"delete-4206\";i:5445;s:11:\"delete-4208\";i:5446;s:11:\"delete-4209\";i:5447;s:11:\"delete-4211\";i:5448;s:11:\"delete-4210\";i:5449;s:11:\"delete-4212\";i:5450;s:11:\"delete-4213\";i:5451;s:11:\"delete-4215\";i:5452;s:11:\"delete-4214\";i:5453;s:11:\"delete-4216\";i:5454;s:11:\"delete-4217\";i:5455;s:11:\"delete-4219\";i:5456;s:11:\"delete-4218\";i:5457;s:11:\"delete-4220\";i:5458;s:11:\"delete-4221\";i:5459;s:11:\"delete-4223\";i:5460;s:11:\"delete-4222\";i:5461;s:11:\"delete-4224\";i:5462;s:11:\"delete-4225\";i:5463;s:11:\"delete-4227\";i:5464;s:11:\"delete-4226\";i:5465;s:11:\"delete-4228\";i:5466;s:11:\"delete-4229\";i:5467;s:11:\"delete-4231\";i:5468;s:11:\"delete-4230\";i:5469;s:11:\"delete-4232\";i:5470;s:11:\"delete-4233\";i:5471;s:11:\"delete-4235\";i:5472;s:11:\"delete-4234\";i:5473;s:11:\"delete-4236\";i:5474;s:11:\"delete-4237\";i:5475;s:11:\"delete-4239\";i:5476;s:11:\"delete-4238\";i:5477;s:11:\"delete-4240\";i:5478;s:11:\"delete-4241\";i:5479;s:11:\"delete-4243\";i:5480;s:11:\"delete-4242\";i:5481;s:11:\"delete-4244\";i:5482;s:11:\"delete-4245\";i:5483;s:11:\"delete-4247\";i:5484;s:11:\"delete-4246\";i:5485;s:11:\"delete-4248\";i:5486;s:11:\"delete-4249\";i:5487;s:11:\"delete-4251\";i:5488;s:11:\"delete-4250\";i:5489;s:11:\"delete-4252\";i:5490;s:11:\"delete-4253\";i:5491;s:11:\"delete-4255\";i:5492;s:11:\"delete-4254\";i:5493;s:11:\"delete-4256\";i:5494;s:11:\"delete-4257\";i:5495;s:11:\"delete-4259\";i:5496;s:11:\"delete-4258\";i:5497;s:11:\"delete-4260\";i:5498;s:11:\"delete-4261\";i:5499;s:11:\"delete-4263\";i:5500;s:11:\"delete-4262\";i:5501;s:11:\"delete-4264\";i:5502;s:11:\"delete-4265\";i:5503;s:11:\"delete-4267\";i:5504;s:11:\"delete-4266\";i:5505;s:11:\"delete-4268\";i:5506;s:11:\"delete-4269\";i:5507;s:11:\"delete-4271\";i:5508;s:11:\"delete-4270\";i:5509;s:11:\"delete-4272\";i:5510;s:11:\"delete-4273\";i:5511;s:11:\"delete-4275\";i:5512;s:11:\"delete-4274\";i:5513;s:11:\"delete-4276\";i:5514;s:11:\"delete-4277\";i:5515;s:11:\"delete-4279\";i:5516;s:11:\"delete-4278\";i:5517;s:11:\"delete-4280\";i:5518;s:11:\"delete-4281\";i:5519;s:11:\"delete-4283\";i:5520;s:11:\"delete-4282\";i:5521;s:11:\"delete-4284\";i:5522;s:11:\"delete-4285\";i:5523;s:11:\"delete-4287\";i:5524;s:11:\"delete-4286\";i:5525;s:11:\"delete-4288\";i:5526;s:11:\"delete-4289\";i:5527;s:11:\"delete-4291\";i:5528;s:11:\"delete-4290\";i:5529;s:11:\"delete-4292\";i:5530;s:11:\"delete-4293\";i:5531;s:11:\"delete-4295\";i:5532;s:11:\"delete-4294\";i:5533;s:11:\"delete-4296\";i:5534;s:11:\"delete-4297\";i:5535;s:11:\"delete-4299\";i:5536;s:11:\"delete-4298\";i:5537;s:11:\"delete-4300\";i:5538;s:11:\"delete-4301\";i:5539;s:11:\"delete-4303\";i:5540;s:11:\"delete-4302\";i:5541;s:11:\"delete-4304\";i:5542;s:11:\"delete-4305\";i:5543;s:11:\"delete-4307\";i:5544;s:11:\"delete-4306\";i:5545;s:11:\"delete-4308\";i:5546;s:11:\"delete-4309\";i:5547;s:11:\"delete-4311\";i:5548;s:11:\"delete-4310\";i:5549;s:11:\"delete-4312\";i:5550;s:11:\"delete-4313\";i:5551;s:11:\"delete-4315\";i:5552;s:11:\"delete-4314\";i:5553;s:11:\"delete-4316\";i:5554;s:11:\"delete-4317\";i:5555;s:11:\"delete-4319\";i:5556;s:11:\"delete-4318\";i:5557;s:11:\"delete-4320\";i:5558;s:11:\"delete-4321\";i:5559;s:11:\"delete-4323\";i:5560;s:11:\"delete-4322\";i:5561;s:11:\"delete-4324\";i:5562;s:11:\"delete-4325\";i:5563;s:11:\"delete-4327\";i:5564;s:11:\"delete-4326\";i:5565;s:11:\"delete-4328\";i:5566;s:11:\"delete-4329\";i:5567;s:11:\"delete-4331\";i:5568;s:11:\"delete-4330\";i:5569;s:11:\"delete-4332\";i:5570;s:11:\"delete-4333\";i:5571;s:11:\"delete-4335\";i:5572;s:11:\"delete-4334\";i:5573;s:11:\"delete-4336\";i:5574;s:11:\"delete-4337\";i:5575;s:11:\"delete-4339\";i:5576;s:11:\"delete-4338\";i:5577;s:11:\"delete-4340\";i:5578;s:11:\"delete-4341\";i:5579;s:11:\"delete-4343\";i:5580;s:11:\"delete-4342\";i:5581;s:11:\"delete-4344\";i:5582;s:11:\"delete-4345\";i:5583;s:11:\"delete-4347\";i:5584;s:11:\"delete-4346\";i:5585;s:11:\"delete-4348\";i:5586;s:11:\"delete-4349\";i:5587;s:11:\"delete-4351\";i:5588;s:11:\"delete-4350\";i:5589;s:11:\"delete-4352\";i:5590;s:11:\"delete-4353\";i:5591;s:11:\"delete-4355\";i:5592;s:11:\"delete-4354\";i:5593;s:11:\"delete-4356\";i:5594;s:11:\"delete-4357\";i:5595;s:11:\"delete-4359\";i:5596;s:11:\"delete-4358\";i:5597;s:11:\"delete-4360\";i:5598;s:11:\"delete-4361\";i:5599;s:11:\"delete-4363\";i:5600;s:11:\"delete-4362\";i:5601;s:11:\"delete-4364\";i:5602;s:11:\"delete-4365\";i:5603;s:11:\"delete-4367\";i:5604;s:11:\"delete-4366\";i:5605;s:11:\"delete-4368\";i:5606;s:11:\"delete-4369\";i:5607;s:11:\"delete-4371\";i:5608;s:11:\"delete-4370\";i:5609;s:11:\"delete-4372\";i:5610;s:11:\"delete-4373\";i:5611;s:11:\"delete-4375\";i:5612;s:11:\"delete-4374\";i:5613;s:11:\"delete-4376\";i:5614;s:11:\"delete-4377\";i:5615;s:11:\"delete-4379\";i:5616;s:11:\"delete-4378\";i:5617;s:11:\"delete-4380\";i:5618;s:11:\"delete-4381\";i:5619;s:11:\"delete-4383\";i:5620;s:11:\"delete-4382\";i:5621;s:11:\"delete-4384\";i:5622;s:11:\"delete-4385\";i:5623;s:11:\"delete-4387\";i:5624;s:11:\"delete-4386\";i:5625;s:11:\"delete-4388\";i:5626;s:11:\"delete-4389\";i:5627;s:11:\"delete-4391\";i:5628;s:11:\"delete-4390\";i:5629;s:11:\"delete-4392\";i:5630;s:11:\"delete-4393\";i:5631;s:11:\"delete-4395\";i:5632;s:11:\"delete-4394\";i:5633;s:11:\"delete-4396\";i:5634;s:11:\"delete-4397\";i:5635;s:11:\"delete-4399\";i:5636;s:11:\"delete-4398\";i:5637;s:11:\"delete-4400\";i:5638;s:11:\"delete-4401\";i:5639;s:11:\"delete-4403\";i:5640;s:11:\"delete-4402\";i:5641;s:11:\"delete-4404\";i:5642;s:11:\"delete-4405\";i:5643;s:11:\"delete-4407\";i:5644;s:11:\"delete-4406\";i:5645;s:11:\"delete-4408\";i:5646;s:11:\"delete-4409\";i:5647;s:11:\"delete-4411\";i:5648;s:11:\"delete-4410\";i:5649;s:11:\"delete-4412\";i:5650;s:11:\"delete-4413\";i:5651;s:11:\"delete-4415\";i:5652;s:11:\"delete-4414\";i:5653;s:11:\"delete-4416\";i:5654;s:11:\"delete-4417\";i:5655;s:11:\"delete-4419\";i:5656;s:11:\"delete-4418\";i:5657;s:11:\"delete-4420\";i:5658;s:11:\"delete-4421\";i:5659;s:11:\"delete-4423\";i:5660;s:11:\"delete-4422\";i:5661;s:11:\"delete-4424\";i:5662;s:11:\"delete-4425\";i:5663;s:11:\"delete-4427\";i:5664;s:11:\"delete-4426\";i:5665;s:11:\"delete-4428\";i:5666;s:11:\"delete-4429\";i:5667;s:11:\"delete-4431\";i:5668;s:11:\"delete-4430\";i:5669;s:11:\"delete-4432\";i:5670;s:11:\"delete-4433\";i:5671;s:11:\"delete-4435\";i:5672;s:11:\"delete-4434\";i:5673;s:11:\"delete-4436\";i:5674;s:11:\"delete-4437\";i:5675;s:11:\"delete-4439\";i:5676;s:11:\"delete-4438\";i:5677;s:11:\"delete-4440\";i:5678;s:11:\"delete-4441\";i:5679;s:11:\"delete-4443\";i:5680;s:11:\"delete-4442\";i:5681;s:11:\"delete-4444\";i:5682;s:11:\"delete-4445\";i:5683;s:11:\"delete-4447\";i:5684;s:11:\"delete-4446\";i:5685;s:11:\"delete-4448\";i:5686;s:11:\"delete-4449\";i:5687;s:11:\"delete-4451\";i:5688;s:11:\"delete-4450\";i:5689;s:11:\"delete-4452\";i:5690;s:11:\"delete-4453\";i:5691;s:11:\"delete-4455\";i:5692;s:11:\"delete-4454\";i:5693;s:11:\"delete-4456\";i:5694;s:11:\"delete-4457\";i:5695;s:11:\"delete-4459\";i:5696;s:11:\"delete-4458\";i:5697;s:11:\"delete-4460\";i:5698;s:11:\"delete-4461\";i:5699;s:11:\"delete-4463\";i:5700;s:11:\"delete-4462\";i:5701;s:11:\"delete-4464\";i:5702;s:11:\"delete-4465\";i:5703;s:11:\"delete-4467\";i:5704;s:11:\"delete-4466\";i:5705;s:11:\"delete-4468\";i:5706;s:11:\"delete-4469\";i:5707;s:11:\"delete-4471\";i:5708;s:11:\"delete-4470\";i:5709;s:11:\"delete-4472\";i:5710;s:11:\"delete-4473\";i:5711;s:11:\"delete-4475\";i:5712;s:11:\"delete-4474\";i:5713;s:11:\"delete-4476\";i:5714;s:11:\"delete-4477\";i:5715;s:11:\"delete-4479\";i:5716;s:11:\"delete-4478\";i:5717;s:11:\"delete-4480\";i:5718;s:11:\"delete-4481\";i:5719;s:11:\"delete-4483\";i:5720;s:11:\"delete-4482\";i:5721;s:11:\"delete-4484\";i:5722;s:11:\"delete-4485\";i:5723;s:11:\"delete-4487\";i:5724;s:11:\"delete-4486\";i:5725;s:11:\"delete-4488\";i:5726;s:11:\"delete-4489\";i:5727;s:11:\"delete-4491\";i:5728;s:11:\"delete-4490\";i:5729;s:11:\"delete-4492\";i:5730;s:11:\"delete-4493\";i:5731;s:11:\"delete-4495\";i:5732;s:11:\"delete-4494\";i:5733;s:11:\"delete-4496\";i:5734;s:11:\"delete-4497\";i:5735;s:11:\"delete-4499\";i:5736;s:11:\"delete-4498\";i:5737;s:11:\"delete-4500\";i:5738;s:11:\"delete-4501\";i:5739;s:11:\"delete-4503\";i:5740;s:11:\"delete-4502\";i:5741;s:11:\"delete-4504\";i:5742;s:11:\"delete-4505\";i:5743;s:11:\"delete-4507\";i:5744;s:11:\"delete-4506\";i:5745;s:11:\"delete-4508\";i:5746;s:11:\"delete-4509\";i:5747;s:11:\"delete-4511\";i:5748;s:11:\"delete-4510\";i:5749;s:11:\"delete-4512\";i:5750;s:11:\"delete-4513\";i:5751;s:11:\"delete-4515\";i:5752;s:11:\"delete-4514\";i:5753;s:11:\"delete-4516\";i:5754;s:11:\"delete-4517\";i:5755;s:11:\"delete-4519\";i:5756;s:11:\"delete-4518\";i:5757;s:11:\"delete-4520\";i:5758;s:11:\"delete-4521\";i:5759;s:11:\"delete-4523\";i:5760;s:11:\"delete-4522\";i:5761;s:11:\"delete-4524\";i:5762;s:11:\"delete-4525\";i:5763;s:11:\"delete-4527\";i:5764;s:11:\"delete-4526\";i:5765;s:11:\"delete-4528\";i:5766;s:11:\"delete-4529\";i:5767;s:11:\"delete-4531\";i:5768;s:11:\"delete-4530\";i:5769;s:11:\"delete-4532\";i:5770;s:11:\"delete-4533\";i:5771;s:11:\"delete-4535\";i:5772;s:11:\"delete-4534\";i:5773;s:11:\"delete-4536\";i:5774;s:11:\"delete-4537\";i:5775;s:11:\"delete-4539\";i:5776;s:11:\"delete-4538\";i:5777;s:11:\"delete-4540\";i:5778;s:11:\"delete-4541\";i:5779;s:11:\"delete-4543\";i:5780;s:11:\"delete-4542\";i:5781;s:11:\"delete-4544\";i:5782;s:11:\"delete-4545\";i:5783;s:11:\"delete-4547\";i:5784;s:11:\"delete-4546\";i:5785;s:11:\"delete-4548\";i:5786;s:11:\"delete-4549\";i:5787;s:11:\"delete-4551\";i:5788;s:11:\"delete-4550\";i:5789;s:11:\"delete-4552\";i:5790;s:11:\"delete-4553\";i:5791;s:11:\"delete-4555\";i:5792;s:11:\"delete-4554\";i:5793;s:11:\"delete-4556\";i:5794;s:11:\"delete-4557\";i:5795;s:11:\"delete-4559\";i:5796;s:11:\"delete-4558\";i:5797;s:11:\"delete-4560\";i:5798;s:11:\"delete-4561\";i:5799;s:11:\"delete-4563\";i:5800;s:11:\"delete-4562\";i:5801;s:11:\"delete-4564\";i:5802;s:11:\"delete-4565\";i:5803;s:11:\"delete-4567\";i:5804;s:11:\"delete-4566\";i:5805;s:11:\"delete-4568\";i:5806;s:11:\"delete-4569\";i:5807;s:11:\"delete-4571\";i:5808;s:11:\"delete-4570\";i:5809;s:11:\"delete-4572\";i:5810;s:11:\"delete-4573\";i:5811;s:11:\"delete-4575\";i:5812;s:11:\"delete-4574\";i:5813;s:11:\"delete-4576\";i:5814;s:11:\"delete-4577\";i:5815;s:11:\"delete-4579\";i:5816;s:11:\"delete-4578\";i:5817;s:11:\"delete-4580\";i:5818;s:11:\"delete-4581\";i:5819;s:11:\"delete-4583\";i:5820;s:11:\"delete-4582\";i:5821;s:11:\"delete-4584\";i:5822;s:11:\"delete-4585\";i:5823;s:11:\"delete-4587\";i:5824;s:11:\"delete-4586\";i:5825;s:11:\"delete-4588\";i:5826;s:11:\"delete-4589\";i:5827;s:11:\"delete-4591\";i:5828;s:11:\"delete-4590\";i:5829;s:11:\"delete-4592\";i:5830;s:11:\"delete-4593\";i:5831;s:11:\"delete-4595\";i:5832;s:11:\"delete-4594\";i:5833;s:11:\"delete-4596\";i:5834;s:11:\"delete-4597\";i:5835;s:11:\"delete-4599\";i:5836;s:11:\"delete-4598\";i:5837;s:11:\"delete-4600\";i:5838;s:11:\"delete-4601\";i:5839;s:11:\"delete-4603\";i:5840;s:11:\"delete-4602\";i:5841;s:11:\"delete-4604\";i:5842;s:11:\"delete-4605\";i:5843;s:11:\"delete-4607\";i:5844;s:11:\"delete-4606\";i:5845;s:11:\"delete-4608\";i:5846;s:11:\"delete-4609\";i:5847;s:11:\"delete-4611\";i:5848;s:11:\"delete-4610\";i:5849;s:11:\"delete-4612\";i:5850;s:11:\"delete-4613\";i:5851;s:11:\"delete-4615\";i:5852;s:11:\"delete-4614\";i:5853;s:11:\"delete-4616\";i:5854;s:11:\"delete-4617\";i:5855;s:11:\"delete-4619\";i:5856;s:11:\"delete-4618\";i:5857;s:11:\"delete-4620\";i:5858;s:11:\"delete-4621\";i:5859;s:11:\"delete-4623\";i:5860;s:11:\"delete-4622\";i:5861;s:11:\"delete-4624\";i:5862;s:11:\"delete-4625\";i:5863;s:11:\"delete-4627\";i:5864;s:11:\"delete-4626\";i:5865;s:11:\"delete-4628\";i:5866;s:11:\"delete-4629\";i:5867;s:11:\"delete-4631\";i:5868;s:11:\"delete-4630\";i:5869;s:11:\"delete-4632\";i:5870;s:11:\"delete-4633\";i:5871;s:11:\"delete-4635\";i:5872;s:11:\"delete-4634\";i:5873;s:11:\"delete-4636\";i:5874;s:11:\"delete-4637\";i:5875;s:11:\"delete-4639\";i:5876;s:11:\"delete-4638\";i:5877;s:11:\"delete-4640\";i:5878;s:11:\"delete-4641\";i:5879;s:11:\"delete-4643\";i:5880;s:11:\"delete-4642\";i:5881;s:11:\"delete-4644\";i:5882;s:11:\"delete-4645\";i:5883;s:11:\"delete-4647\";i:5884;s:11:\"delete-4646\";i:5885;s:11:\"delete-4648\";i:5886;s:11:\"delete-4649\";i:5887;s:11:\"delete-4651\";i:5888;s:11:\"delete-4650\";i:5889;s:11:\"delete-4652\";i:5890;s:11:\"delete-4653\";i:5891;s:11:\"delete-4655\";i:5892;s:11:\"delete-4654\";i:5893;s:11:\"delete-4656\";i:5894;s:11:\"delete-4657\";i:5895;s:11:\"delete-4659\";i:5896;s:11:\"delete-4658\";i:5897;s:11:\"delete-4660\";i:5898;s:11:\"delete-4661\";i:5899;s:11:\"delete-4663\";i:5900;s:11:\"delete-4662\";i:5901;s:11:\"delete-4664\";i:5902;s:11:\"delete-4665\";i:5903;s:11:\"delete-4667\";i:5904;s:11:\"delete-4666\";i:5905;s:11:\"delete-4668\";i:5906;s:11:\"delete-4669\";i:5907;s:11:\"delete-4671\";i:5908;s:11:\"delete-4670\";i:5909;s:11:\"delete-4672\";i:5910;s:11:\"delete-4673\";i:5911;s:11:\"delete-4675\";i:5912;s:11:\"delete-4674\";i:5913;s:11:\"delete-4676\";i:5914;s:11:\"delete-4677\";i:5915;s:11:\"delete-4679\";i:5916;s:11:\"delete-4678\";i:5917;s:11:\"delete-4680\";i:5918;s:11:\"delete-4681\";i:5919;s:11:\"delete-4683\";i:5920;s:11:\"delete-4682\";i:5921;s:11:\"delete-4684\";i:5922;s:11:\"delete-4685\";i:5923;s:11:\"delete-4687\";i:5924;s:11:\"delete-4686\";i:5925;s:11:\"delete-4688\";i:5926;s:11:\"delete-4689\";i:5927;s:11:\"delete-4691\";i:5928;s:11:\"delete-4690\";i:5929;s:11:\"delete-4692\";i:5930;s:11:\"delete-4693\";i:5931;s:11:\"delete-4695\";i:5932;s:11:\"delete-4694\";i:5933;s:11:\"delete-4696\";i:5934;s:11:\"delete-4697\";i:5935;s:11:\"delete-4699\";i:5936;s:11:\"delete-4698\";i:5937;s:11:\"delete-4700\";i:5938;s:11:\"delete-4701\";i:5939;s:11:\"delete-4703\";i:5940;s:11:\"delete-4702\";i:5941;s:11:\"delete-4704\";i:5942;s:11:\"delete-4705\";i:5943;s:11:\"delete-4707\";i:5944;s:11:\"delete-4706\";i:5945;s:11:\"delete-4708\";i:5946;s:11:\"delete-4709\";i:5947;s:11:\"delete-4711\";i:5948;s:11:\"delete-4710\";i:5949;s:11:\"delete-4712\";i:5950;s:11:\"delete-4713\";i:5951;s:11:\"delete-4715\";i:5952;s:11:\"delete-4714\";i:5953;s:11:\"delete-4716\";i:5954;s:11:\"delete-4717\";i:5955;s:11:\"delete-4719\";i:5956;s:11:\"delete-4718\";i:5957;s:11:\"delete-4720\";i:5958;s:11:\"delete-4721\";i:5959;s:11:\"delete-4723\";i:5960;s:11:\"delete-4722\";i:5961;s:11:\"delete-4724\";i:5962;s:11:\"delete-4725\";i:5963;s:11:\"delete-4727\";i:5964;s:11:\"delete-4726\";i:5965;s:11:\"delete-4728\";i:5966;s:11:\"delete-4729\";i:5967;s:11:\"delete-4731\";i:5968;s:11:\"delete-4730\";i:5969;s:11:\"delete-4732\";i:5970;s:11:\"delete-4733\";i:5971;s:11:\"delete-4735\";i:5972;s:11:\"delete-4734\";i:5973;s:11:\"delete-4736\";i:5974;s:11:\"delete-4737\";i:5975;s:11:\"delete-4739\";i:5976;s:11:\"delete-4738\";i:5977;s:11:\"delete-4740\";i:5978;s:11:\"delete-4741\";i:5979;s:11:\"delete-4743\";i:5980;s:11:\"delete-4742\";i:5981;s:11:\"delete-4744\";i:5982;s:11:\"delete-4745\";i:5983;s:11:\"delete-4747\";i:5984;s:11:\"delete-4746\";i:5985;s:11:\"delete-4748\";i:5986;s:11:\"delete-4749\";i:5987;s:11:\"delete-4751\";i:5988;s:11:\"delete-4750\";i:5989;s:11:\"delete-4752\";i:5990;s:11:\"delete-4753\";i:5991;s:11:\"delete-4755\";i:5992;s:11:\"delete-4754\";i:5993;s:11:\"delete-4756\";i:5994;s:11:\"delete-4757\";i:5995;s:11:\"delete-4759\";i:5996;s:11:\"delete-4758\";i:5997;s:11:\"delete-4760\";i:5998;s:11:\"delete-4761\";i:5999;s:11:\"delete-4763\";i:6000;s:11:\"delete-4762\";i:6001;s:11:\"delete-4764\";i:6002;s:11:\"delete-4765\";i:6003;s:11:\"delete-4767\";i:6004;s:11:\"delete-4766\";i:6005;s:11:\"delete-4768\";i:6006;s:11:\"delete-4769\";i:6007;s:11:\"delete-4771\";i:6008;s:11:\"delete-4770\";i:6009;s:11:\"delete-4772\";i:6010;s:11:\"delete-4773\";i:6011;s:11:\"delete-4775\";i:6012;s:11:\"delete-4774\";i:6013;s:11:\"delete-4776\";i:6014;s:11:\"delete-4777\";i:6015;s:11:\"delete-4779\";i:6016;s:11:\"delete-4778\";i:6017;s:11:\"delete-4780\";i:6018;s:11:\"delete-4781\";i:6019;s:11:\"delete-4783\";i:6020;s:11:\"delete-4782\";i:6021;s:11:\"delete-4784\";i:6022;s:11:\"delete-4785\";i:6023;s:11:\"delete-4787\";i:6024;s:11:\"delete-4786\";i:6025;s:11:\"delete-4788\";i:6026;s:11:\"delete-4789\";i:6027;s:11:\"delete-4791\";i:6028;s:11:\"delete-4790\";i:6029;s:11:\"delete-4792\";i:6030;s:11:\"delete-4793\";i:6031;s:11:\"delete-4795\";i:6032;s:11:\"delete-4794\";i:6033;s:11:\"delete-4796\";i:6034;s:11:\"delete-4797\";i:6035;s:11:\"delete-4799\";i:6036;s:11:\"delete-4798\";i:6037;s:11:\"delete-4800\";i:6038;s:11:\"delete-4801\";i:6039;s:11:\"delete-4803\";i:6040;s:11:\"delete-4802\";i:6041;s:11:\"delete-4804\";i:6042;s:11:\"delete-4805\";i:6043;s:11:\"delete-4807\";i:6044;s:11:\"delete-4806\";i:6045;s:11:\"delete-4808\";i:6046;s:11:\"delete-4809\";i:6047;s:11:\"delete-4811\";i:6048;s:11:\"delete-4810\";i:6049;s:11:\"delete-4812\";i:6050;s:11:\"delete-4813\";i:6051;s:11:\"delete-4815\";i:6052;s:11:\"delete-4814\";i:6053;s:11:\"delete-4816\";i:6054;s:11:\"delete-4817\";i:6055;s:11:\"delete-4819\";i:6056;s:11:\"delete-4818\";i:6057;s:11:\"delete-4820\";i:6058;s:11:\"delete-4821\";i:6059;s:11:\"delete-4823\";i:6060;s:11:\"delete-4822\";i:6061;s:11:\"delete-4824\";i:6062;s:11:\"delete-4825\";i:6063;s:11:\"delete-4827\";i:6064;s:11:\"delete-4826\";i:6065;s:11:\"delete-4828\";i:6066;s:11:\"delete-4829\";i:6067;s:11:\"delete-4831\";i:6068;s:11:\"delete-4830\";i:6069;s:11:\"delete-4832\";i:6070;s:11:\"delete-4833\";i:6071;s:11:\"delete-4835\";i:6072;s:11:\"delete-4834\";i:6073;s:11:\"delete-4836\";i:6074;s:11:\"delete-4837\";i:6075;s:11:\"delete-4839\";i:6076;s:11:\"delete-4838\";i:6077;s:11:\"delete-4840\";i:6078;s:11:\"delete-4841\";i:6079;s:11:\"delete-4843\";i:6080;s:11:\"delete-4842\";i:6081;s:11:\"delete-4844\";i:6082;s:11:\"delete-4845\";i:6083;s:11:\"delete-4847\";i:6084;s:11:\"delete-4846\";i:6085;s:11:\"delete-4848\";i:6086;s:11:\"delete-4849\";i:6087;s:11:\"delete-4851\";i:6088;s:11:\"delete-4850\";i:6089;s:11:\"delete-4852\";i:6090;s:11:\"delete-4853\";i:6091;s:11:\"delete-4855\";i:6092;s:11:\"delete-4854\";i:6093;s:11:\"delete-4856\";i:6094;s:11:\"delete-4857\";i:6095;s:11:\"delete-4859\";i:6096;s:11:\"delete-4858\";i:6097;s:11:\"delete-4860\";i:6098;s:11:\"delete-4861\";i:6099;s:11:\"delete-4863\";i:6100;s:11:\"delete-4862\";i:6101;s:11:\"delete-4864\";i:6102;s:11:\"delete-4865\";i:6103;s:11:\"delete-4867\";i:6104;s:11:\"delete-4866\";i:6105;s:11:\"delete-4868\";i:6106;s:11:\"delete-4869\";i:6107;s:11:\"delete-4871\";i:6108;s:11:\"delete-4870\";i:6109;s:11:\"delete-4872\";i:6110;s:11:\"delete-4873\";i:6111;s:11:\"delete-4875\";i:6112;s:11:\"delete-4874\";i:6113;s:11:\"delete-4876\";i:6114;s:11:\"delete-4877\";i:6115;s:11:\"delete-4879\";i:6116;s:11:\"delete-4878\";i:6117;s:11:\"delete-4880\";i:6118;s:11:\"delete-4881\";i:6119;s:11:\"delete-4883\";i:6120;s:11:\"delete-4882\";i:6121;s:11:\"delete-4884\";i:6122;s:11:\"delete-4885\";i:6123;s:11:\"delete-4887\";i:6124;s:11:\"delete-4886\";i:6125;s:11:\"delete-4888\";i:6126;s:11:\"delete-4889\";i:6127;s:11:\"delete-4891\";i:6128;s:11:\"delete-4890\";i:6129;s:11:\"delete-4892\";i:6130;s:11:\"delete-4893\";i:6131;s:11:\"delete-4895\";i:6132;s:11:\"delete-4894\";i:6133;s:11:\"delete-4896\";i:6134;s:11:\"delete-4897\";i:6135;s:11:\"delete-4899\";i:6136;s:11:\"delete-4898\";i:6137;s:11:\"delete-4900\";i:6138;s:11:\"delete-4901\";i:6139;s:11:\"delete-4903\";i:6140;s:11:\"delete-4902\";i:6141;s:11:\"delete-4904\";i:6142;s:11:\"delete-4905\";i:6143;s:11:\"delete-4907\";i:6144;s:11:\"delete-4906\";i:6145;s:11:\"delete-4908\";i:6146;s:11:\"delete-4909\";i:6147;s:11:\"delete-4911\";i:6148;s:11:\"delete-4910\";i:6149;s:11:\"delete-4912\";i:6150;s:11:\"delete-4913\";i:6151;s:11:\"delete-4915\";i:6152;s:11:\"delete-4914\";i:6153;s:11:\"delete-4916\";i:6154;s:11:\"delete-4917\";i:6155;s:11:\"delete-4919\";i:6156;s:11:\"delete-4918\";i:6157;s:11:\"delete-4920\";i:6158;s:11:\"delete-4921\";i:6159;s:11:\"delete-4923\";i:6160;s:11:\"delete-4922\";i:6161;s:11:\"delete-4924\";i:6162;s:11:\"delete-4925\";i:6163;s:11:\"delete-4927\";i:6164;s:11:\"delete-4926\";i:6165;s:11:\"delete-4928\";i:6166;s:11:\"delete-4929\";i:6167;s:11:\"delete-4931\";i:6168;s:11:\"delete-4930\";i:6169;s:11:\"delete-4932\";i:6170;s:11:\"delete-4933\";i:6171;s:11:\"delete-4935\";i:6172;s:11:\"delete-4934\";i:6173;s:11:\"delete-4936\";i:6174;s:11:\"delete-4937\";i:6175;s:11:\"delete-4939\";i:6176;s:11:\"delete-4938\";i:6177;s:11:\"delete-4940\";i:6178;s:11:\"delete-4941\";i:6179;s:11:\"delete-4943\";i:6180;s:11:\"delete-4942\";i:6181;s:11:\"delete-4944\";i:6182;s:11:\"delete-4945\";i:6183;s:11:\"delete-4947\";i:6184;s:11:\"delete-4946\";i:6185;s:11:\"delete-4948\";i:6186;s:11:\"delete-4949\";i:6187;s:11:\"delete-4951\";i:6188;s:11:\"delete-4950\";i:6189;s:11:\"delete-4952\";i:6190;s:11:\"delete-4953\";i:6191;s:11:\"delete-4955\";i:6192;s:11:\"delete-4954\";i:6193;s:11:\"delete-4956\";i:6194;s:11:\"delete-4957\";i:6195;s:11:\"delete-4959\";i:6196;s:11:\"delete-4958\";i:6197;s:11:\"delete-4960\";i:6198;s:11:\"delete-4961\";i:6199;s:11:\"delete-4963\";i:6200;s:11:\"delete-4962\";i:6201;s:11:\"delete-4964\";i:6202;s:11:\"delete-4965\";i:6203;s:11:\"delete-4967\";i:6204;s:11:\"delete-4966\";i:6205;s:11:\"delete-4968\";i:6206;s:11:\"delete-4969\";i:6207;s:11:\"delete-4971\";i:6208;s:11:\"delete-4970\";i:6209;s:11:\"delete-4972\";i:6210;s:11:\"delete-4973\";i:6211;s:11:\"delete-4975\";i:6212;s:11:\"delete-4974\";i:6213;s:11:\"delete-4976\";i:6214;s:11:\"delete-4977\";i:6215;s:11:\"delete-4979\";i:6216;s:11:\"delete-4978\";i:6217;s:11:\"delete-4980\";i:6218;s:11:\"delete-4981\";i:6219;s:11:\"delete-4983\";i:6220;s:11:\"delete-4982\";i:6221;s:11:\"delete-4984\";i:6222;s:11:\"delete-4985\";i:6223;s:11:\"delete-4987\";i:6224;s:11:\"delete-4986\";i:6225;s:11:\"delete-4988\";i:6226;s:11:\"delete-4989\";i:6227;s:11:\"delete-4991\";i:6228;s:11:\"delete-4990\";i:6229;s:11:\"delete-4992\";i:6230;s:11:\"delete-4993\";i:6231;s:11:\"delete-4995\";i:6232;s:11:\"delete-4994\";i:6233;s:11:\"delete-4996\";i:6234;s:11:\"delete-4997\";i:6235;s:11:\"delete-4999\";i:6236;s:11:\"delete-4998\";i:6237;s:11:\"delete-5000\";i:6238;s:11:\"delete-5001\";i:6239;s:11:\"delete-5003\";i:6240;s:11:\"delete-5002\";i:6241;s:11:\"delete-5004\";i:6242;s:11:\"delete-5005\";i:6243;s:11:\"delete-5007\";i:6244;s:11:\"delete-5006\";i:6245;s:11:\"delete-5008\";i:6246;s:11:\"delete-5009\";i:6247;s:11:\"delete-5011\";i:6248;s:11:\"delete-5010\";i:6249;s:11:\"delete-5012\";i:6250;s:11:\"delete-5013\";i:6251;s:11:\"delete-5015\";i:6252;s:11:\"delete-5014\";i:6253;s:11:\"delete-5016\";i:6254;s:11:\"delete-5017\";i:6255;s:11:\"delete-5019\";i:6256;s:11:\"delete-5018\";i:6257;s:11:\"delete-5020\";i:6258;s:11:\"delete-5021\";i:6259;s:11:\"delete-5023\";i:6260;s:11:\"delete-5022\";i:6261;s:11:\"delete-5024\";i:6262;s:11:\"delete-5025\";i:6263;s:11:\"delete-5027\";i:6264;s:11:\"delete-5026\";i:6265;s:11:\"delete-5028\";i:6266;s:11:\"delete-5029\";i:6267;s:11:\"delete-5031\";i:6268;s:11:\"delete-5030\";i:6269;s:11:\"delete-5032\";i:6270;s:11:\"delete-5033\";i:6271;s:11:\"delete-5035\";i:6272;s:11:\"delete-5034\";i:6273;s:11:\"delete-5036\";i:6274;s:11:\"delete-5037\";i:6275;s:11:\"delete-5039\";i:6276;s:11:\"delete-5038\";i:6277;s:11:\"delete-5040\";i:6278;s:11:\"delete-5041\";i:6279;s:11:\"delete-5043\";i:6280;s:11:\"delete-5042\";i:6281;s:11:\"delete-5044\";i:6282;s:11:\"delete-5045\";i:6283;s:11:\"delete-5047\";i:6284;s:11:\"delete-5046\";i:6285;s:11:\"delete-5048\";i:6286;s:11:\"delete-5049\";i:6287;s:11:\"delete-5051\";i:6288;s:11:\"delete-5050\";i:6289;s:11:\"delete-5052\";i:6290;s:11:\"delete-5053\";i:6291;s:11:\"delete-5055\";i:6292;s:11:\"delete-5054\";i:6293;s:11:\"delete-5056\";i:6294;s:11:\"delete-5057\";i:6295;s:11:\"delete-5059\";i:6296;s:11:\"delete-5058\";i:6297;s:11:\"delete-5060\";i:6298;s:11:\"delete-5061\";i:6299;s:11:\"delete-5063\";i:6300;s:11:\"delete-5062\";i:6301;s:11:\"delete-5064\";i:6302;s:11:\"delete-5065\";i:6303;s:11:\"delete-5067\";i:6304;s:11:\"delete-5066\";i:6305;s:11:\"delete-5068\";i:6306;s:11:\"delete-5069\";i:6307;s:11:\"delete-5071\";i:6308;s:11:\"delete-5070\";i:6309;s:11:\"delete-5072\";i:6310;s:11:\"delete-5073\";i:6311;s:11:\"delete-5075\";i:6312;s:11:\"delete-5074\";i:6313;s:11:\"delete-5076\";i:6314;s:11:\"delete-5077\";i:6315;s:11:\"delete-5079\";i:6316;s:11:\"delete-5078\";i:6317;s:11:\"delete-5080\";i:6318;s:11:\"delete-5081\";i:6319;s:11:\"delete-5083\";i:6320;s:11:\"delete-5082\";i:6321;s:11:\"delete-5084\";i:6322;s:11:\"delete-5085\";i:6323;s:11:\"delete-5087\";i:6324;s:11:\"delete-5086\";i:6325;s:11:\"delete-5088\";i:6326;s:11:\"delete-5089\";i:6327;s:11:\"delete-5091\";i:6328;s:11:\"delete-5090\";i:6329;s:11:\"delete-5092\";i:6330;s:11:\"delete-5093\";i:6331;s:11:\"delete-5095\";i:6332;s:11:\"delete-5094\";i:6333;s:11:\"delete-5096\";i:6334;s:11:\"delete-5097\";i:6335;s:11:\"delete-5099\";i:6336;s:11:\"delete-5098\";i:6337;s:11:\"delete-5100\";i:6338;s:11:\"delete-5101\";i:6339;s:11:\"delete-5103\";i:6340;s:11:\"delete-5102\";i:6341;s:11:\"delete-5104\";i:6342;s:11:\"delete-5105\";i:6343;s:11:\"delete-5107\";i:6344;s:11:\"delete-5106\";i:6345;s:11:\"delete-5108\";i:6346;s:11:\"delete-5109\";i:6347;s:11:\"delete-5111\";i:6348;s:11:\"delete-5110\";i:6349;s:11:\"delete-5112\";i:6350;s:11:\"delete-5113\";i:6351;s:11:\"delete-5115\";i:6352;s:11:\"delete-5114\";i:6353;s:11:\"delete-5116\";i:6354;s:11:\"delete-5117\";i:6355;s:11:\"delete-5119\";i:6356;s:11:\"delete-5118\";i:6357;s:11:\"delete-5120\";i:6358;s:11:\"delete-5121\";i:6359;s:11:\"delete-5123\";i:6360;s:11:\"delete-5122\";i:6361;s:11:\"delete-5124\";i:6362;s:11:\"delete-5125\";i:6363;s:11:\"delete-5127\";i:6364;s:11:\"delete-5126\";i:6365;s:11:\"delete-5128\";i:6366;s:11:\"delete-5129\";i:6367;s:11:\"delete-5131\";i:6368;s:11:\"delete-5130\";i:6369;s:11:\"delete-5132\";i:6370;s:11:\"delete-5133\";i:6371;s:11:\"delete-5135\";i:6372;s:11:\"delete-5134\";i:6373;s:11:\"delete-5136\";i:6374;s:11:\"delete-5137\";i:6375;s:11:\"delete-5139\";i:6376;s:11:\"delete-5138\";i:6377;s:11:\"delete-5140\";i:6378;s:11:\"delete-5141\";i:6379;s:11:\"delete-5143\";i:6380;s:11:\"delete-5142\";i:6381;s:11:\"delete-5144\";i:6382;s:11:\"delete-5145\";i:6383;s:11:\"delete-5147\";i:6384;s:11:\"delete-5146\";i:6385;s:11:\"delete-5148\";i:6386;s:11:\"delete-5149\";i:6387;s:11:\"delete-5151\";i:6388;s:11:\"delete-5150\";i:6389;s:11:\"delete-5152\";i:6390;s:11:\"delete-5153\";i:6391;s:11:\"delete-5155\";i:6392;s:11:\"delete-5154\";i:6393;s:11:\"delete-5156\";i:6394;s:11:\"delete-5157\";i:6395;s:11:\"delete-5159\";i:6396;s:11:\"delete-5158\";i:6397;s:11:\"delete-5160\";i:6398;s:11:\"delete-5161\";i:6399;s:11:\"delete-5163\";i:6400;s:11:\"delete-5162\";i:6401;s:11:\"delete-5164\";i:6402;s:11:\"delete-5165\";i:6403;s:11:\"delete-5167\";i:6404;s:11:\"delete-5166\";i:6405;s:11:\"delete-5168\";i:6406;s:11:\"delete-5169\";i:6407;s:11:\"delete-5171\";i:6408;s:11:\"delete-5170\";i:6409;s:11:\"delete-5172\";i:6410;s:11:\"delete-5173\";i:6411;s:11:\"delete-5175\";i:6412;s:11:\"delete-5174\";i:6413;s:11:\"delete-5176\";i:6414;s:11:\"delete-5177\";i:6415;s:11:\"delete-5179\";i:6416;s:11:\"delete-5178\";i:6417;s:11:\"delete-5180\";i:6418;s:11:\"delete-5181\";i:6419;s:11:\"delete-5183\";i:6420;s:11:\"delete-5182\";i:6421;s:11:\"delete-5184\";i:6422;s:11:\"delete-5185\";i:6423;s:11:\"delete-5187\";i:6424;s:11:\"delete-5186\";i:6425;s:11:\"delete-5188\";i:6426;s:11:\"delete-5189\";i:6427;s:11:\"delete-5191\";i:6428;s:11:\"delete-5190\";i:6429;s:11:\"delete-5192\";i:6430;s:11:\"delete-5193\";i:6431;s:11:\"delete-5195\";i:6432;s:11:\"delete-5194\";i:6433;s:11:\"delete-5196\";i:6434;s:11:\"delete-5197\";i:6435;s:11:\"delete-5199\";i:6436;s:11:\"delete-5198\";i:6437;s:11:\"delete-5200\";i:6438;s:11:\"delete-5201\";i:6439;s:11:\"delete-5203\";i:6440;s:11:\"delete-5202\";i:6441;s:11:\"delete-5204\";i:6442;s:11:\"delete-5205\";i:6443;s:11:\"delete-5207\";i:6444;s:11:\"delete-5206\";i:6445;s:11:\"delete-5208\";i:6446;s:11:\"delete-5209\";i:6447;s:11:\"delete-5211\";i:6448;s:11:\"delete-5210\";i:6449;s:11:\"delete-5212\";i:6450;s:11:\"delete-5213\";i:6451;s:11:\"delete-5215\";i:6452;s:11:\"delete-5214\";i:6453;s:11:\"delete-5216\";i:6454;s:11:\"delete-5217\";i:6455;s:11:\"delete-5219\";i:6456;s:11:\"delete-5218\";i:6457;s:11:\"delete-5220\";i:6458;s:11:\"delete-5221\";i:6459;s:11:\"delete-5223\";i:6460;s:11:\"delete-5222\";i:6461;s:11:\"delete-5224\";i:6462;s:11:\"delete-5225\";i:6463;s:11:\"delete-5227\";i:6464;s:11:\"delete-5226\";i:6465;s:11:\"delete-5228\";i:6466;s:11:\"delete-5229\";i:6467;s:11:\"delete-5231\";i:6468;s:11:\"delete-5230\";i:6469;s:11:\"delete-5232\";i:6470;s:11:\"delete-5233\";i:6471;s:11:\"delete-5235\";i:6472;s:11:\"delete-5234\";i:6473;s:11:\"delete-5236\";i:6474;s:11:\"delete-5237\";i:6475;s:11:\"delete-5239\";i:6476;s:11:\"delete-5238\";i:6477;s:11:\"delete-5240\";i:6478;s:11:\"delete-5241\";i:6479;s:11:\"delete-5243\";i:6480;s:11:\"delete-5242\";i:6481;s:11:\"delete-5244\";i:6482;s:11:\"delete-5245\";i:6483;s:11:\"delete-5247\";i:6484;s:11:\"delete-5246\";i:6485;s:11:\"delete-5248\";i:6486;s:11:\"delete-5249\";i:6487;s:11:\"delete-5251\";i:6488;s:11:\"delete-5250\";i:6489;s:11:\"delete-5252\";i:6490;s:11:\"delete-5253\";i:6491;s:11:\"delete-5255\";i:6492;s:11:\"delete-5254\";i:6493;s:11:\"delete-5256\";i:6494;s:11:\"delete-5257\";i:6495;s:11:\"delete-5259\";i:6496;s:11:\"delete-5258\";i:6497;s:11:\"delete-5260\";i:6498;s:11:\"delete-5261\";i:6499;s:11:\"delete-5263\";i:6500;s:11:\"delete-5262\";i:6501;s:11:\"delete-5264\";i:6502;s:11:\"delete-5265\";i:6503;s:11:\"delete-5267\";i:6504;s:11:\"delete-5266\";i:6505;s:11:\"delete-5268\";i:6506;s:11:\"delete-5269\";i:6507;s:11:\"delete-5271\";i:6508;s:11:\"delete-5270\";i:6509;s:11:\"delete-5272\";i:6510;s:11:\"delete-5273\";i:6511;s:11:\"delete-5275\";i:6512;s:11:\"delete-5274\";i:6513;s:11:\"delete-5276\";i:6514;s:11:\"delete-5277\";i:6515;s:11:\"delete-5278\";i:6516;s:11:\"delete-5279\";i:6517;s:11:\"delete-5280\";i:6518;s:11:\"delete-5281\";i:6519;s:11:\"delete-5282\";i:6520;s:11:\"delete-5283\";i:6521;s:11:\"delete-5284\";i:6522;s:11:\"delete-5285\";i:6523;s:11:\"delete-5286\";i:6524;s:11:\"delete-5287\";i:6525;s:11:\"delete-5288\";i:6526;s:11:\"delete-5289\";i:6527;s:11:\"delete-5290\";i:6528;s:11:\"delete-5291\";i:6529;s:11:\"delete-5292\";i:6530;s:11:\"delete-5293\";i:6531;s:11:\"delete-5294\";i:6532;s:11:\"delete-5295\";i:6533;s:11:\"delete-5296\";i:6534;s:11:\"delete-5297\";i:6535;s:11:\"delete-5298\";i:6536;s:11:\"delete-5299\";i:6537;s:11:\"delete-5300\";i:6538;s:11:\"delete-5301\";i:6539;s:11:\"delete-5302\";i:6540;s:11:\"delete-5303\";i:6541;s:11:\"delete-5304\";i:6542;s:11:\"delete-5305\";i:6543;s:11:\"delete-5306\";i:6544;s:11:\"delete-5307\";i:6545;s:11:\"delete-5308\";i:6546;s:11:\"delete-5309\";i:6547;s:11:\"delete-5310\";i:6548;s:11:\"delete-5311\";i:6549;s:11:\"delete-5312\";i:6550;s:11:\"delete-5313\";i:6551;s:11:\"delete-5314\";i:6552;s:11:\"delete-5315\";i:6553;s:11:\"delete-5316\";i:6554;s:11:\"delete-5317\";i:6555;s:11:\"delete-5318\";i:6556;s:11:\"delete-5319\";i:6557;s:11:\"delete-5320\";i:6558;s:11:\"delete-5321\";i:6559;s:11:\"delete-5322\";i:6560;s:11:\"delete-5323\";i:6561;s:11:\"delete-5324\";i:6562;s:11:\"delete-5325\";i:6563;s:11:\"delete-5326\";i:6564;s:11:\"delete-5327\";i:6565;s:11:\"delete-5328\";i:6566;s:11:\"delete-5329\";i:6567;s:11:\"delete-5330\";i:6568;s:11:\"delete-5331\";i:6569;s:11:\"delete-5332\";i:6570;s:11:\"delete-5333\";i:6571;s:11:\"delete-5334\";i:6572;s:11:\"delete-5335\";i:6573;s:11:\"delete-5336\";i:6574;s:11:\"delete-5337\";i:6575;s:11:\"delete-5338\";i:6576;s:11:\"delete-5339\";i:6577;s:11:\"delete-5340\";i:6578;s:11:\"delete-5341\";i:6579;s:11:\"delete-5342\";i:6580;s:11:\"delete-5343\";i:6581;s:11:\"delete-5344\";i:6582;s:11:\"delete-5345\";i:6583;s:11:\"delete-5346\";i:6584;s:11:\"delete-5347\";i:6585;s:11:\"delete-5348\";i:6586;s:11:\"delete-5349\";i:6587;s:11:\"delete-5350\";i:6588;s:11:\"delete-5351\";i:6589;s:11:\"delete-5352\";i:6590;s:11:\"delete-5353\";i:6591;s:11:\"delete-5354\";i:6592;s:11:\"delete-5355\";i:6593;s:11:\"delete-5356\";i:6594;s:11:\"delete-5357\";i:6595;s:11:\"delete-5358\";i:6596;s:11:\"delete-5359\";i:6597;s:11:\"delete-5360\";i:6598;s:11:\"delete-5361\";i:6599;s:11:\"delete-5362\";i:6600;s:11:\"delete-5363\";i:6601;s:11:\"delete-5364\";i:6602;s:11:\"delete-5365\";i:6603;s:11:\"delete-5366\";i:6604;s:11:\"delete-5367\";i:6605;s:11:\"delete-5368\";i:6606;s:11:\"delete-5369\";i:6607;s:11:\"delete-5370\";i:6608;s:11:\"delete-5371\";i:6609;s:11:\"delete-5372\";i:6610;s:11:\"delete-5373\";i:6611;s:11:\"delete-5374\";i:6612;s:11:\"delete-5375\";i:6613;s:11:\"delete-5376\";i:6614;s:11:\"delete-5377\";i:6615;s:11:\"delete-5378\";i:6616;s:11:\"delete-5379\";i:6617;s:11:\"delete-5380\";i:6618;s:11:\"delete-5381\";i:6619;s:11:\"delete-5382\";i:6620;s:11:\"delete-5383\";i:6621;s:11:\"delete-5384\";i:6622;s:11:\"delete-5385\";i:6623;s:11:\"delete-5386\";i:6624;s:11:\"delete-5387\";i:6625;s:11:\"delete-5388\";i:6626;s:11:\"delete-5389\";i:6627;s:11:\"delete-5390\";i:6628;s:11:\"delete-5391\";i:6629;s:11:\"delete-5392\";i:6630;s:11:\"delete-5393\";i:6631;s:11:\"delete-5394\";i:6632;s:11:\"delete-5395\";i:6633;s:11:\"delete-5396\";i:6634;s:11:\"delete-5397\";i:6635;s:11:\"delete-5398\";i:6636;s:11:\"delete-5399\";i:6637;s:11:\"delete-5400\";i:6638;s:11:\"delete-5401\";i:6639;s:11:\"delete-5402\";i:6640;s:11:\"delete-5403\";i:6641;s:11:\"delete-5404\";i:6642;s:11:\"delete-5405\";i:6643;s:11:\"delete-5406\";i:6644;s:11:\"delete-5407\";i:6645;s:11:\"delete-5408\";i:6646;s:11:\"delete-5409\";i:6647;s:11:\"delete-5410\";i:6648;s:11:\"delete-5411\";i:6649;s:11:\"delete-5412\";i:6650;s:11:\"delete-5413\";i:6651;s:11:\"delete-5414\";i:6652;s:11:\"delete-5415\";i:6653;s:11:\"delete-5416\";i:6654;s:11:\"delete-5417\";i:6655;s:11:\"delete-5418\";i:6656;s:11:\"delete-5419\";i:6657;s:11:\"delete-5420\";i:6658;s:11:\"delete-5421\";i:6659;s:11:\"delete-5422\";i:6660;s:11:\"delete-5423\";i:6661;s:11:\"delete-5424\";i:6662;s:11:\"delete-5425\";i:6663;s:11:\"delete-5426\";i:6664;s:11:\"delete-5427\";i:6665;s:11:\"delete-5428\";i:6666;s:11:\"delete-5429\";i:6667;s:11:\"delete-5430\";i:6668;s:11:\"delete-5431\";i:6669;s:11:\"delete-5432\";i:6670;s:11:\"delete-5433\";i:6671;s:11:\"delete-5434\";i:6672;s:11:\"delete-5435\";i:6673;s:11:\"delete-5436\";i:6674;s:11:\"delete-5437\";i:6675;s:11:\"delete-5438\";i:6676;s:11:\"delete-5439\";i:6677;s:11:\"delete-5440\";i:6678;s:11:\"delete-5441\";i:6679;s:11:\"delete-5442\";i:6680;s:11:\"delete-5443\";i:6681;s:11:\"delete-5444\";i:6682;s:11:\"delete-5445\";i:6683;s:11:\"delete-5446\";i:6684;s:11:\"delete-5447\";i:6685;s:11:\"delete-5448\";i:6686;s:11:\"delete-5449\";i:6687;s:11:\"delete-5450\";i:6688;s:11:\"delete-5451\";i:6689;s:11:\"delete-5452\";i:6690;s:11:\"delete-5453\";i:6691;s:11:\"delete-5454\";i:6692;s:11:\"delete-5455\";i:6693;s:11:\"delete-5456\";i:6694;s:11:\"delete-5457\";i:6695;s:11:\"delete-5458\";i:6696;s:11:\"delete-5459\";i:6697;s:11:\"delete-5460\";i:6698;s:11:\"delete-5461\";i:6699;s:11:\"delete-5462\";i:6700;s:11:\"delete-5463\";i:6701;s:11:\"delete-5464\";i:6702;s:11:\"delete-5465\";i:6703;s:11:\"delete-5466\";i:6704;s:11:\"delete-5467\";i:6705;s:11:\"delete-5468\";i:6706;s:11:\"delete-5469\";i:6707;s:11:\"delete-5470\";i:6708;s:11:\"delete-5471\";i:6709;s:11:\"delete-5472\";i:6710;s:11:\"delete-5473\";i:6711;s:11:\"delete-5474\";i:6712;s:11:\"delete-5475\";i:6713;s:11:\"delete-5476\";i:6714;s:11:\"delete-5477\";i:6715;s:11:\"delete-5478\";i:6716;s:11:\"delete-5479\";i:6717;s:11:\"delete-5480\";i:6718;s:11:\"delete-5481\";i:6719;s:11:\"delete-5482\";i:6720;s:11:\"delete-5483\";i:6721;s:11:\"delete-5484\";i:6722;s:11:\"delete-5485\";i:6723;s:11:\"delete-5486\";i:6724;s:11:\"delete-5487\";i:6725;s:11:\"delete-5488\";i:6726;s:11:\"delete-5489\";i:6727;s:11:\"delete-5490\";i:6728;s:11:\"delete-5491\";i:6729;s:11:\"delete-5492\";i:6730;s:11:\"delete-5493\";i:6731;s:11:\"delete-5494\";i:6732;s:11:\"delete-5495\";i:6733;s:11:\"delete-5496\";i:6734;s:11:\"delete-5497\";i:6735;s:11:\"delete-5498\";i:6736;s:11:\"delete-5499\";i:6737;s:11:\"delete-5500\";i:6738;s:11:\"delete-5501\";i:6739;s:11:\"delete-5502\";i:6740;s:11:\"delete-5503\";i:6741;s:11:\"delete-5504\";i:6742;s:11:\"delete-5505\";i:6743;s:11:\"delete-5506\";i:6744;s:11:\"delete-5507\";i:6745;s:11:\"delete-5508\";i:6746;s:11:\"delete-5509\";i:6747;s:11:\"delete-5510\";i:6748;s:11:\"delete-5511\";i:6749;s:11:\"delete-5512\";i:6750;s:11:\"delete-5513\";i:6751;s:11:\"delete-5514\";i:6752;s:11:\"delete-5515\";i:6753;s:11:\"delete-5516\";i:6754;s:11:\"delete-5517\";i:6755;s:11:\"delete-5518\";i:6756;s:11:\"delete-5519\";i:6757;s:11:\"delete-5520\";i:6758;s:11:\"delete-5521\";i:6759;s:11:\"delete-5522\";i:6760;s:11:\"delete-5523\";i:6761;s:11:\"delete-5524\";i:6762;s:11:\"delete-5525\";i:6763;s:11:\"delete-5526\";i:6764;s:11:\"delete-5527\";i:6765;s:11:\"delete-5528\";i:6766;s:11:\"delete-5529\";i:6767;s:11:\"delete-5530\";i:6768;s:11:\"delete-5531\";i:6769;s:11:\"delete-5532\";i:6770;s:11:\"delete-5533\";i:6771;s:11:\"delete-5534\";i:6772;s:11:\"delete-5535\";i:6773;s:11:\"delete-5536\";i:6774;s:11:\"delete-5537\";i:6775;s:11:\"delete-5538\";i:6776;s:11:\"delete-5539\";i:6777;s:11:\"delete-5540\";i:6778;s:11:\"delete-5541\";i:6779;s:11:\"delete-5542\";i:6780;s:11:\"delete-5543\";i:6781;s:11:\"delete-5544\";i:6782;s:11:\"delete-5545\";i:6783;s:11:\"delete-5546\";i:6784;s:11:\"delete-5547\";i:6785;s:11:\"delete-5548\";i:6786;s:11:\"delete-5549\";i:6787;s:11:\"delete-5550\";i:6788;s:11:\"delete-5551\";i:6789;s:11:\"delete-5552\";i:6790;s:11:\"delete-5553\";i:6791;s:11:\"delete-5554\";i:6792;s:11:\"delete-5555\";i:6793;s:11:\"delete-5556\";i:6794;s:11:\"delete-5557\";i:6795;s:11:\"delete-5558\";i:6796;s:11:\"delete-5559\";i:6797;s:11:\"delete-5560\";i:6798;s:11:\"delete-5561\";i:6799;s:11:\"delete-5562\";i:6800;s:11:\"delete-5563\";i:6801;s:11:\"delete-5564\";i:6802;s:11:\"delete-5565\";i:6803;s:11:\"delete-5566\";i:6804;s:11:\"delete-5567\";i:6805;s:11:\"delete-5568\";i:6806;s:11:\"delete-5569\";i:6807;s:11:\"delete-5570\";i:6808;s:11:\"delete-5571\";i:6809;s:11:\"delete-5572\";i:6810;s:11:\"delete-5573\";i:6811;s:11:\"delete-5574\";i:6812;s:11:\"delete-5575\";i:6813;s:11:\"delete-5576\";i:6814;s:11:\"delete-5577\";i:6815;s:11:\"delete-5578\";i:6816;s:11:\"delete-5579\";i:6817;s:11:\"delete-5580\";i:6818;s:11:\"delete-5581\";i:6819;s:11:\"delete-5582\";i:6820;s:11:\"delete-5583\";i:6821;s:11:\"delete-5584\";i:6822;s:11:\"delete-5585\";i:6823;s:11:\"delete-5586\";i:6824;s:11:\"delete-5587\";i:6825;s:11:\"delete-5588\";i:6826;s:11:\"delete-5589\";i:6827;s:11:\"delete-5590\";i:6828;s:11:\"delete-5591\";i:6829;s:11:\"delete-5592\";i:6830;s:11:\"delete-5593\";i:6831;s:11:\"delete-5594\";i:6832;s:11:\"delete-5595\";i:6833;s:11:\"delete-5596\";i:6834;s:11:\"delete-5597\";i:6835;s:11:\"delete-5598\";i:6836;s:11:\"delete-5599\";i:6837;s:11:\"delete-5600\";i:6838;s:11:\"delete-5601\";i:6839;s:11:\"delete-5602\";i:6840;s:11:\"delete-5603\";i:6841;s:11:\"delete-5604\";i:6842;s:11:\"delete-5605\";i:6843;s:11:\"delete-5606\";i:6844;s:11:\"delete-5607\";i:6845;s:11:\"delete-5608\";i:6846;s:11:\"delete-5609\";i:6847;s:11:\"delete-5610\";i:6848;s:11:\"delete-5611\";i:6849;s:11:\"delete-5612\";i:6850;s:11:\"delete-5613\";i:6851;s:11:\"delete-5614\";i:6852;s:11:\"delete-5615\";i:6853;s:11:\"delete-5616\";i:6854;s:11:\"delete-5617\";i:6855;s:11:\"delete-5618\";i:6856;s:11:\"delete-5619\";i:6857;s:11:\"delete-5620\";i:6858;s:11:\"delete-5621\";i:6859;s:11:\"delete-5622\";i:6860;s:11:\"delete-5623\";i:6861;s:11:\"delete-5624\";i:6862;s:11:\"delete-5625\";i:6863;s:11:\"delete-5626\";i:6864;s:11:\"delete-5627\";i:6865;s:11:\"delete-5628\";i:6866;s:11:\"delete-5629\";i:6867;s:11:\"delete-5630\";i:6868;s:11:\"delete-5631\";i:6869;s:11:\"delete-5632\";i:6870;s:11:\"delete-5633\";i:6871;s:11:\"delete-5634\";i:6872;s:11:\"delete-5635\";i:6873;s:11:\"delete-5636\";i:6874;s:11:\"delete-5637\";i:6875;s:11:\"delete-5638\";i:6876;s:11:\"delete-5639\";i:6877;s:11:\"delete-5640\";i:6878;s:11:\"delete-5641\";i:6879;s:11:\"delete-5642\";i:6880;s:11:\"delete-5643\";i:6881;s:11:\"delete-5644\";i:6882;s:11:\"delete-5645\";i:6883;s:11:\"delete-5646\";i:6884;s:11:\"delete-5647\";i:6885;s:11:\"delete-5648\";i:6886;s:11:\"delete-5649\";i:6887;s:11:\"delete-5650\";i:6888;s:11:\"delete-5651\";i:6889;s:11:\"delete-5652\";i:6890;s:11:\"delete-5653\";i:6891;s:11:\"delete-5654\";i:6892;s:11:\"delete-5655\";i:6893;s:11:\"delete-5656\";i:6894;s:11:\"delete-5657\";i:6895;s:11:\"delete-5658\";i:6896;s:11:\"delete-5659\";i:6897;s:11:\"delete-5660\";i:6898;s:11:\"delete-5661\";i:6899;s:11:\"delete-5662\";i:6900;s:11:\"delete-5663\";i:6901;s:11:\"delete-5664\";i:6902;s:11:\"delete-5665\";i:6903;s:11:\"delete-5666\";i:6904;s:11:\"delete-5667\";i:6905;s:11:\"delete-5668\";i:6906;s:11:\"delete-5669\";i:6907;s:11:\"delete-5670\";i:6908;s:11:\"delete-5671\";i:6909;s:11:\"delete-5672\";i:6910;s:11:\"delete-5673\";i:6911;s:11:\"delete-5674\";i:6912;s:11:\"delete-5675\";i:6913;s:11:\"delete-5676\";i:6914;s:11:\"delete-5677\";i:6915;s:11:\"delete-5678\";i:6916;s:11:\"delete-5679\";i:6917;s:11:\"delete-5680\";i:6918;s:11:\"delete-5681\";i:6919;s:11:\"delete-5682\";i:6920;s:11:\"delete-5683\";i:6921;s:11:\"delete-5684\";i:6922;s:11:\"delete-5685\";i:6923;s:11:\"delete-5686\";i:6924;s:11:\"delete-5687\";i:6925;s:11:\"delete-5688\";i:6926;s:11:\"delete-5689\";i:6927;s:11:\"delete-5690\";i:6928;s:11:\"delete-5691\";i:6929;s:11:\"delete-5692\";i:6930;s:11:\"delete-5693\";i:6931;s:11:\"delete-5694\";i:6932;s:11:\"delete-5695\";i:6933;s:11:\"delete-5696\";i:6934;s:11:\"delete-5697\";i:6935;s:11:\"delete-5698\";i:6936;s:11:\"delete-5699\";i:6937;s:11:\"delete-5700\";i:6938;s:11:\"delete-5701\";i:6939;s:11:\"delete-5702\";i:6940;s:11:\"delete-5703\";i:6941;s:11:\"delete-5704\";i:6942;s:11:\"delete-5705\";i:6943;s:11:\"delete-5706\";i:6944;s:11:\"delete-5707\";i:6945;s:11:\"delete-5708\";i:6946;s:11:\"delete-5709\";i:6947;s:11:\"delete-5710\";i:6948;s:11:\"delete-5711\";i:6949;s:11:\"delete-5712\";i:6950;s:11:\"delete-5713\";i:6951;s:11:\"delete-5714\";i:6952;s:11:\"delete-5715\";i:6953;s:11:\"delete-5716\";i:6954;s:11:\"delete-5717\";i:6955;s:11:\"delete-5718\";i:6956;s:11:\"delete-5719\";i:6957;s:11:\"delete-5720\";i:6958;s:11:\"delete-5721\";i:6959;s:11:\"delete-5722\";i:6960;s:11:\"delete-5723\";i:6961;s:11:\"delete-5724\";i:6962;s:11:\"delete-5725\";i:6963;s:11:\"delete-5726\";i:6964;s:11:\"delete-5727\";i:6965;s:11:\"delete-5728\";i:6966;s:11:\"delete-5729\";i:6967;s:11:\"delete-5730\";i:6968;s:11:\"delete-5731\";i:6969;s:11:\"delete-5732\";i:6970;s:11:\"delete-5733\";i:6971;s:11:\"delete-5734\";i:6972;s:11:\"delete-5735\";i:6973;s:11:\"delete-5736\";i:6974;s:11:\"delete-5737\";i:6975;s:11:\"delete-5738\";i:6976;s:11:\"delete-5739\";i:6977;s:11:\"delete-5740\";i:6978;s:11:\"delete-5741\";i:6979;s:11:\"delete-5742\";i:6980;s:11:\"delete-5743\";i:6981;s:11:\"delete-5744\";i:6982;s:11:\"delete-5745\";i:6983;s:11:\"delete-5746\";i:6984;s:11:\"delete-5747\";i:6985;s:11:\"delete-5748\";i:6986;s:11:\"delete-5749\";i:6987;s:11:\"delete-5750\";i:6988;s:11:\"delete-5751\";i:6989;s:11:\"delete-5752\";i:6990;s:11:\"delete-5753\";i:6991;s:11:\"delete-5754\";i:6992;s:11:\"delete-5755\";i:6993;s:11:\"delete-5756\";i:6994;s:11:\"delete-5757\";i:6995;s:11:\"delete-5758\";i:6996;s:11:\"delete-5759\";i:6997;s:11:\"delete-5760\";i:6998;s:11:\"delete-5761\";i:6999;s:11:\"delete-5762\";i:7000;s:11:\"delete-5763\";i:7001;s:11:\"delete-5764\";i:7002;s:11:\"delete-5765\";i:7003;s:11:\"delete-5766\";i:7004;s:11:\"delete-5767\";i:7005;s:11:\"delete-5768\";i:7006;s:11:\"delete-5769\";i:7007;s:11:\"delete-5770\";i:7008;s:11:\"delete-5771\";i:7009;s:11:\"delete-5772\";i:7010;s:11:\"delete-5773\";i:7011;s:11:\"delete-5774\";i:7012;s:11:\"delete-5775\";i:7013;s:11:\"delete-5776\";i:7014;s:11:\"delete-5777\";i:7015;s:11:\"delete-5778\";i:7016;s:11:\"delete-5779\";i:7017;s:11:\"delete-5780\";i:7018;s:11:\"delete-5781\";i:7019;s:11:\"delete-5782\";i:7020;s:11:\"delete-5783\";i:7021;s:11:\"delete-5784\";i:7022;s:11:\"delete-5785\";i:7023;s:11:\"delete-5786\";i:7024;s:11:\"delete-5787\";i:7025;s:11:\"delete-5788\";i:7026;s:11:\"delete-5789\";i:7027;s:11:\"delete-5790\";i:7028;s:11:\"delete-5791\";i:7029;s:11:\"delete-5792\";i:7030;s:11:\"delete-5793\";i:7031;s:11:\"delete-5794\";i:7032;s:11:\"delete-5795\";i:7033;s:11:\"delete-5796\";i:7034;s:11:\"delete-5797\";i:7035;s:11:\"delete-5798\";i:7036;s:11:\"delete-5799\";i:7037;s:11:\"delete-5800\";i:7038;s:11:\"delete-5801\";i:7039;s:11:\"delete-5802\";i:7040;s:11:\"delete-5803\";i:7041;s:11:\"delete-5804\";i:7042;s:11:\"delete-5805\";i:7043;s:11:\"delete-5806\";i:7044;s:11:\"delete-5807\";i:7045;s:11:\"delete-5808\";i:7046;s:11:\"delete-5809\";i:7047;s:11:\"delete-5810\";i:7048;s:11:\"delete-5811\";i:7049;s:11:\"delete-5812\";i:7050;s:11:\"delete-5813\";i:7051;s:11:\"delete-5814\";i:7052;s:11:\"delete-5815\";i:7053;s:11:\"delete-5816\";i:7054;s:11:\"delete-5817\";i:7055;s:11:\"delete-5818\";i:7056;s:11:\"delete-5819\";i:7057;s:11:\"delete-5820\";i:7058;s:11:\"delete-5821\";i:7059;s:11:\"delete-5822\";i:7060;s:11:\"delete-5823\";i:7061;s:11:\"delete-5824\";i:7062;s:11:\"delete-5825\";i:7063;s:11:\"delete-5826\";i:7064;s:11:\"delete-5827\";i:7065;s:11:\"delete-5828\";i:7066;s:11:\"delete-5829\";i:7067;s:11:\"delete-5830\";i:7068;s:11:\"delete-5831\";i:7069;s:11:\"delete-5832\";i:7070;s:11:\"delete-5833\";i:7071;s:11:\"delete-5834\";i:7072;s:11:\"delete-5835\";i:7073;s:11:\"delete-5836\";i:7074;s:11:\"delete-5837\";i:7075;s:11:\"delete-5838\";i:7076;s:11:\"delete-5839\";i:7077;s:11:\"delete-5840\";i:7078;s:11:\"delete-5841\";i:7079;s:11:\"delete-5842\";i:7080;s:11:\"delete-5843\";i:7081;s:11:\"delete-5844\";i:7082;s:11:\"delete-5845\";i:7083;s:11:\"delete-5846\";i:7084;s:11:\"delete-5847\";i:7085;s:11:\"delete-5848\";i:7086;s:11:\"delete-5849\";i:7087;s:11:\"delete-5850\";i:7088;s:11:\"delete-5851\";i:7089;s:11:\"delete-5852\";i:7090;s:11:\"delete-5853\";i:7091;s:11:\"delete-5854\";i:7092;s:11:\"delete-5855\";i:7093;s:11:\"delete-5856\";i:7094;s:11:\"delete-5857\";i:7095;s:11:\"delete-5858\";i:7096;s:11:\"delete-5859\";i:7097;s:11:\"delete-5860\";i:7098;s:11:\"delete-5861\";i:7099;s:11:\"delete-5862\";i:7100;s:11:\"delete-5863\";i:7101;s:11:\"delete-5864\";i:7102;s:11:\"delete-5865\";i:7103;s:11:\"delete-5866\";i:7104;s:11:\"delete-5867\";i:7105;s:11:\"delete-5868\";i:7106;s:11:\"delete-5869\";i:7107;s:11:\"delete-5870\";i:7108;s:11:\"delete-5871\";i:7109;s:11:\"delete-5872\";i:7110;s:11:\"delete-5873\";i:7111;s:11:\"delete-5874\";i:7112;s:11:\"delete-5875\";i:7113;s:11:\"delete-5876\";i:7114;s:11:\"delete-5877\";i:7115;s:11:\"delete-5878\";i:7116;s:11:\"delete-5879\";i:7117;s:11:\"delete-5880\";i:7118;s:11:\"delete-5881\";i:7119;s:11:\"delete-5882\";i:7120;s:11:\"delete-5883\";i:7121;s:11:\"delete-5884\";i:7122;s:11:\"delete-5885\";i:7123;s:11:\"delete-5886\";i:7124;s:11:\"delete-5887\";i:7125;s:11:\"delete-5888\";i:7126;s:11:\"delete-5889\";i:7127;s:11:\"delete-5890\";i:7128;s:11:\"delete-5891\";i:7129;s:11:\"delete-5892\";i:7130;s:11:\"delete-5893\";i:7131;s:11:\"delete-5894\";i:7132;s:11:\"delete-5895\";i:7133;s:11:\"delete-5896\";i:7134;s:11:\"delete-5897\";i:7135;s:11:\"delete-5898\";i:7136;s:11:\"delete-5899\";i:7137;s:11:\"delete-5900\";i:7138;s:11:\"delete-5901\";i:7139;s:11:\"delete-5902\";i:7140;s:11:\"delete-5903\";i:7141;s:11:\"delete-5904\";i:7142;s:11:\"delete-5905\";i:7143;s:11:\"delete-5906\";i:7144;s:11:\"delete-5907\";i:7145;s:11:\"delete-5908\";i:7146;s:11:\"delete-5909\";i:7147;s:11:\"delete-5910\";i:7148;s:11:\"delete-5911\";i:7149;s:11:\"delete-5912\";i:7150;s:11:\"delete-5913\";i:7151;s:11:\"delete-5914\";i:7152;s:11:\"delete-5915\";i:7153;s:11:\"delete-5916\";i:7154;s:11:\"delete-5917\";i:7155;s:11:\"delete-5918\";i:7156;s:11:\"delete-5919\";i:7157;s:11:\"delete-5920\";i:7158;s:11:\"delete-5921\";i:7159;s:11:\"delete-5922\";i:7160;s:11:\"delete-5923\";i:7161;s:11:\"delete-5924\";i:7162;s:11:\"delete-5925\";i:7163;s:11:\"delete-5926\";i:7164;s:11:\"delete-5927\";i:7165;s:11:\"delete-5928\";i:7166;s:11:\"delete-5929\";i:7167;s:11:\"delete-5930\";i:7168;s:11:\"delete-5931\";i:7169;s:11:\"delete-5932\";i:7170;s:11:\"delete-5933\";i:7171;s:11:\"delete-5934\";i:7172;s:11:\"delete-5935\";i:7173;s:11:\"delete-5936\";i:7174;s:11:\"delete-5937\";i:7175;s:11:\"delete-5938\";i:7176;s:11:\"delete-5939\";i:7177;s:11:\"delete-5940\";i:7178;s:11:\"delete-5941\";i:7179;s:11:\"delete-5942\";i:7180;s:11:\"delete-5943\";i:7181;s:11:\"delete-5944\";i:7182;s:11:\"delete-5945\";i:7183;s:11:\"delete-5946\";i:7184;s:11:\"delete-5947\";i:7185;s:11:\"delete-5948\";i:7186;s:11:\"delete-5949\";i:7187;s:11:\"delete-5950\";i:7188;s:11:\"delete-5951\";i:7189;s:11:\"delete-5952\";i:7190;s:11:\"delete-5953\";i:7191;s:11:\"delete-5954\";i:7192;s:11:\"delete-5955\";i:7193;s:11:\"delete-5956\";i:7194;s:11:\"delete-5957\";i:7195;s:11:\"delete-5958\";i:7196;s:11:\"delete-5959\";i:7197;s:11:\"delete-5960\";i:7198;s:11:\"delete-5961\";i:7199;s:11:\"delete-5962\";i:7200;s:11:\"delete-5963\";i:7201;s:11:\"delete-5964\";i:7202;s:11:\"delete-5965\";i:7203;s:11:\"delete-5966\";i:7204;s:11:\"delete-5967\";i:7205;s:11:\"delete-5968\";i:7206;s:11:\"delete-5969\";i:7207;s:11:\"delete-5970\";i:7208;s:11:\"delete-5971\";i:7209;s:11:\"delete-5972\";i:7210;s:11:\"delete-5973\";i:7211;s:11:\"delete-5974\";i:7212;s:11:\"delete-5975\";i:7213;s:11:\"delete-5976\";i:7214;s:11:\"delete-5977\";i:7215;s:11:\"delete-5978\";i:7216;s:11:\"delete-5979\";i:7217;s:11:\"delete-5980\";i:7218;s:11:\"delete-5981\";i:7219;s:11:\"delete-5982\";i:7220;s:11:\"delete-5983\";i:7221;s:11:\"delete-5984\";i:7222;s:11:\"delete-5985\";i:7223;s:11:\"delete-5986\";i:7224;s:11:\"delete-5987\";i:7225;s:11:\"delete-5988\";i:7226;s:11:\"delete-5989\";i:7227;s:11:\"delete-5990\";i:7228;s:11:\"delete-5991\";i:7229;s:11:\"delete-5992\";i:7230;s:11:\"delete-5993\";i:7231;s:11:\"delete-5994\";i:7232;s:11:\"delete-5995\";i:7233;s:11:\"delete-5996\";i:7234;s:11:\"delete-5997\";i:7235;s:11:\"delete-5998\";i:7236;s:11:\"delete-5999\";i:7237;s:11:\"delete-6000\";i:7238;s:11:\"delete-6001\";i:7239;s:11:\"delete-6002\";i:7240;s:11:\"delete-6003\";i:7241;s:11:\"delete-6004\";i:7242;s:11:\"delete-6005\";i:7243;s:11:\"delete-6006\";i:7244;s:11:\"delete-6007\";i:7245;s:11:\"delete-6008\";i:7246;s:11:\"delete-6009\";i:7247;s:11:\"delete-6010\";i:7248;s:11:\"delete-6011\";i:7249;s:11:\"delete-6012\";i:7250;s:11:\"delete-6013\";i:7251;s:11:\"delete-6014\";i:7252;s:11:\"delete-6015\";i:7253;s:11:\"delete-6016\";i:7254;s:11:\"delete-6017\";i:7255;s:11:\"delete-6018\";i:7256;s:11:\"delete-6019\";i:7257;s:11:\"delete-6020\";i:7258;s:11:\"delete-6021\";i:7259;s:11:\"delete-6022\";i:7260;s:11:\"delete-6023\";i:7261;s:11:\"delete-6024\";i:7262;s:11:\"delete-6025\";i:7263;s:11:\"delete-6026\";i:7264;s:11:\"delete-6027\";i:7265;s:11:\"delete-6028\";i:7266;s:11:\"delete-6029\";i:7267;s:11:\"delete-6030\";i:7268;s:11:\"delete-6031\";i:7269;s:11:\"delete-6032\";i:7270;s:11:\"delete-6033\";i:7271;s:11:\"delete-6034\";i:7272;s:11:\"delete-6035\";i:7273;s:11:\"delete-6036\";i:7274;s:11:\"delete-6037\";i:7275;s:11:\"delete-6038\";i:7276;s:11:\"delete-6039\";i:7277;s:11:\"delete-6040\";i:7278;s:11:\"delete-6041\";i:7279;s:11:\"delete-6042\";i:7280;s:11:\"delete-6043\";i:7281;s:11:\"delete-6044\";i:7282;s:11:\"delete-6045\";i:7283;s:11:\"delete-6046\";i:7284;s:11:\"delete-6047\";i:7285;s:11:\"delete-6048\";i:7286;s:11:\"delete-6049\";i:7287;s:11:\"delete-6050\";i:7288;s:11:\"delete-6051\";i:7289;s:11:\"delete-6052\";i:7290;s:11:\"delete-6053\";i:7291;s:11:\"delete-6054\";i:7292;s:11:\"delete-6055\";i:7293;s:11:\"delete-6056\";i:7294;s:11:\"delete-6057\";i:7295;s:11:\"delete-6058\";i:7296;s:11:\"delete-6059\";i:7297;s:11:\"delete-6060\";i:7298;s:11:\"delete-6061\";i:7299;s:11:\"delete-6062\";i:7300;s:11:\"delete-6063\";i:7301;s:11:\"delete-6064\";i:7302;s:11:\"delete-6065\";i:7303;s:11:\"delete-6066\";i:7304;s:11:\"delete-6067\";i:7305;s:11:\"delete-6068\";i:7306;s:11:\"delete-6069\";i:7307;s:11:\"delete-6070\";i:7308;s:11:\"delete-6071\";i:7309;s:11:\"delete-6072\";i:7310;s:11:\"delete-6073\";i:7311;s:11:\"delete-6074\";i:7312;s:11:\"delete-6075\";i:7313;s:11:\"delete-6076\";i:7314;s:11:\"delete-6077\";i:7315;s:11:\"delete-6078\";i:7316;s:11:\"delete-6079\";i:7317;s:11:\"delete-6080\";i:7318;s:11:\"delete-6081\";i:7319;s:11:\"delete-6082\";i:7320;s:11:\"delete-6083\";i:7321;s:11:\"delete-6084\";i:7322;s:11:\"delete-6085\";i:7323;s:11:\"delete-6086\";i:7324;s:11:\"delete-6087\";i:7325;s:11:\"delete-6088\";i:7326;s:11:\"delete-6089\";i:7327;s:11:\"delete-6090\";i:7328;s:11:\"delete-6091\";i:7329;s:11:\"delete-6092\";i:7330;s:11:\"delete-6093\";i:7331;s:11:\"delete-6094\";i:7332;s:11:\"delete-6095\";i:7333;s:11:\"delete-6096\";i:7334;s:11:\"delete-6097\";i:7335;s:11:\"delete-6098\";i:7336;s:11:\"delete-6099\";i:7337;s:11:\"delete-6100\";i:7338;s:11:\"delete-6101\";i:7339;s:11:\"delete-6102\";i:7340;s:11:\"delete-6103\";i:7341;s:11:\"delete-6104\";i:7342;s:11:\"delete-6105\";i:7343;s:11:\"delete-6106\";i:7344;s:11:\"delete-6107\";i:7345;s:11:\"delete-6108\";i:7346;s:11:\"delete-6109\";i:7347;s:11:\"delete-6110\";i:7348;s:11:\"delete-6111\";i:7349;s:11:\"delete-6112\";i:7350;s:11:\"delete-6113\";i:7351;s:11:\"delete-6114\";i:7352;s:11:\"delete-6115\";i:7353;s:11:\"delete-6116\";i:7354;s:11:\"delete-6117\";i:7355;s:11:\"delete-6118\";i:7356;s:11:\"delete-6119\";i:7357;s:11:\"delete-6120\";i:7358;s:11:\"delete-6121\";i:7359;s:11:\"delete-6122\";i:7360;s:11:\"delete-6123\";i:7361;s:11:\"delete-6124\";i:7362;s:11:\"delete-6125\";i:7363;s:11:\"delete-6126\";i:7364;s:11:\"delete-6127\";i:7365;s:11:\"delete-6128\";i:7366;s:11:\"delete-6129\";i:7367;s:11:\"delete-6130\";i:7368;s:11:\"delete-6131\";i:7369;s:11:\"delete-6132\";i:7370;s:11:\"delete-6133\";i:7371;s:11:\"delete-6134\";i:7372;s:11:\"delete-6135\";i:7373;s:11:\"delete-6136\";i:7374;s:11:\"delete-6137\";i:7375;s:11:\"delete-6138\";i:7376;s:11:\"delete-6139\";i:7377;s:11:\"delete-6140\";i:7378;s:11:\"delete-6141\";i:7379;s:11:\"delete-6142\";i:7380;s:11:\"delete-6143\";i:7381;s:11:\"delete-6144\";i:7382;s:11:\"delete-6145\";i:7383;s:11:\"delete-6146\";i:7384;s:11:\"delete-6147\";i:7385;s:11:\"delete-6148\";i:7386;s:11:\"delete-6149\";i:7387;s:11:\"delete-6150\";i:7388;s:11:\"delete-6151\";i:7389;s:11:\"delete-6152\";i:7390;s:11:\"delete-6153\";i:7391;s:11:\"delete-6154\";i:7392;s:11:\"delete-6155\";i:7393;s:11:\"delete-6156\";i:7394;s:11:\"delete-6157\";i:7395;s:11:\"delete-6158\";i:7396;s:11:\"delete-6159\";i:7397;s:11:\"delete-6160\";i:7398;s:11:\"delete-6161\";i:7399;s:11:\"delete-6162\";i:7400;s:11:\"delete-6163\";i:7401;s:11:\"delete-6164\";i:7402;s:11:\"delete-6165\";i:7403;s:11:\"delete-6166\";i:7404;s:11:\"delete-6167\";i:7405;s:11:\"delete-6168\";i:7406;s:11:\"delete-6169\";i:7407;s:11:\"delete-6170\";i:7408;s:11:\"delete-6171\";i:7409;s:11:\"delete-6172\";i:7410;s:11:\"delete-6173\";i:7411;s:11:\"delete-6174\";i:7412;s:11:\"delete-6175\";i:7413;s:11:\"delete-6176\";i:7414;s:11:\"delete-6177\";i:7415;s:11:\"delete-6178\";i:7416;s:11:\"delete-6179\";i:7417;s:11:\"delete-6180\";i:7418;s:11:\"delete-6181\";i:7419;s:11:\"delete-6182\";i:7420;s:11:\"delete-6183\";i:7421;s:11:\"delete-6184\";i:7422;s:11:\"delete-6185\";i:7423;s:11:\"delete-6186\";i:7424;s:11:\"delete-6187\";i:7425;s:11:\"delete-6188\";i:7426;s:11:\"delete-6189\";i:7427;s:11:\"delete-6190\";i:7428;s:11:\"delete-6191\";i:7429;s:11:\"delete-6192\";i:7430;s:11:\"delete-6193\";i:7431;s:11:\"delete-6194\";i:7432;s:11:\"delete-6195\";i:7433;s:11:\"delete-6196\";i:7434;s:11:\"delete-6197\";i:7435;s:11:\"delete-6198\";i:7436;s:11:\"delete-6199\";i:7437;s:11:\"delete-6200\";i:7438;s:11:\"delete-6201\";i:7439;s:11:\"delete-6202\";i:7440;s:11:\"delete-6203\";i:7441;s:11:\"delete-6204\";i:7442;s:11:\"delete-6205\";i:7443;s:11:\"delete-6206\";i:7444;s:11:\"delete-6207\";i:7445;s:11:\"delete-6208\";i:7446;s:11:\"delete-6209\";i:7447;s:11:\"delete-6210\";i:7448;s:11:\"delete-6211\";i:7449;s:11:\"delete-6212\";i:7450;s:11:\"delete-6213\";i:7451;s:11:\"delete-6214\";i:7452;s:11:\"delete-6215\";i:7453;s:11:\"delete-6216\";i:7454;s:11:\"delete-6217\";i:7455;s:11:\"delete-6218\";i:7456;s:11:\"delete-6219\";i:7457;s:11:\"delete-6220\";i:7458;s:11:\"delete-6221\";i:7459;s:11:\"delete-6222\";i:7460;s:11:\"delete-6223\";i:7461;s:11:\"delete-6224\";i:7462;s:11:\"delete-6225\";i:7463;s:11:\"delete-6226\";i:7464;s:11:\"delete-6227\";i:7465;s:11:\"delete-6228\";i:7466;s:11:\"delete-6229\";i:7467;s:11:\"delete-6230\";i:7468;s:11:\"delete-6231\";i:7469;s:11:\"delete-6232\";i:7470;s:11:\"delete-6233\";i:7471;s:11:\"delete-6234\";i:7472;s:11:\"delete-6235\";i:7473;s:11:\"delete-6236\";i:7474;s:11:\"delete-6237\";i:7475;s:11:\"delete-6238\";i:7476;s:11:\"delete-6239\";i:7477;s:11:\"delete-6240\";i:7478;s:11:\"delete-6241\";i:7479;s:11:\"delete-6242\";i:7480;s:11:\"delete-6243\";i:7481;s:11:\"delete-6244\";i:7482;s:11:\"delete-6245\";i:7483;s:11:\"delete-6246\";i:7484;s:11:\"delete-6247\";i:7485;s:11:\"delete-6248\";i:7486;s:11:\"delete-6249\";i:7487;s:11:\"delete-6250\";i:7488;s:11:\"delete-6251\";i:7489;s:11:\"delete-6252\";i:7490;s:11:\"delete-6253\";i:7491;s:11:\"delete-6254\";i:7492;s:11:\"delete-6255\";i:7493;s:11:\"delete-6256\";i:7494;s:11:\"delete-6257\";i:7495;s:11:\"delete-6258\";i:7496;s:11:\"delete-6259\";i:7497;s:11:\"delete-6260\";i:7498;s:11:\"delete-6261\";i:7499;s:11:\"delete-6262\";i:7500;s:11:\"delete-6263\";i:7501;s:11:\"delete-6264\";i:7502;s:11:\"delete-6265\";i:7503;s:11:\"delete-6266\";i:7504;s:11:\"delete-6267\";i:7505;s:11:\"delete-6268\";i:7506;s:11:\"delete-6269\";i:7507;s:11:\"delete-6270\";i:7508;s:11:\"delete-6271\";i:7509;s:11:\"delete-6272\";i:7510;s:11:\"delete-6273\";i:7511;s:11:\"delete-6274\";i:7512;s:11:\"delete-6275\";i:7513;s:11:\"delete-6276\";i:7514;s:11:\"delete-6277\";i:7515;s:11:\"delete-6278\";i:7516;s:11:\"delete-6279\";i:7517;s:11:\"delete-6280\";i:7518;s:11:\"delete-6281\";i:7519;s:11:\"delete-6282\";i:7520;s:11:\"delete-6283\";i:7521;s:11:\"delete-6284\";i:7522;s:11:\"delete-6285\";i:7523;s:11:\"delete-6286\";i:7524;s:11:\"delete-6287\";i:7525;s:11:\"delete-6288\";i:7526;s:11:\"delete-6289\";i:7527;s:11:\"delete-6290\";i:7528;s:11:\"delete-6291\";i:7529;s:11:\"delete-6292\";i:7530;s:11:\"delete-6293\";i:7531;s:11:\"delete-6294\";i:7532;s:11:\"delete-6295\";i:7533;s:11:\"delete-6296\";i:7534;s:11:\"delete-6297\";i:7535;s:11:\"delete-6298\";i:7536;s:11:\"delete-6299\";i:7537;s:11:\"delete-6300\";i:7538;s:11:\"delete-6301\";i:7539;s:11:\"delete-6302\";i:7540;s:11:\"delete-6303\";i:7541;s:11:\"delete-6304\";i:7542;s:11:\"delete-6305\";i:7543;s:11:\"delete-6306\";i:7544;s:11:\"delete-6307\";i:7545;s:11:\"delete-6308\";i:7546;s:11:\"delete-6309\";i:7547;s:11:\"delete-6310\";i:7548;s:11:\"delete-6311\";i:7549;s:11:\"delete-6312\";i:7550;s:11:\"delete-6313\";i:7551;s:11:\"delete-6314\";i:7552;s:11:\"delete-6315\";i:7553;s:11:\"delete-6316\";i:7554;s:11:\"delete-6317\";i:7555;s:11:\"delete-6318\";i:7556;s:11:\"delete-6319\";i:7557;s:11:\"delete-6320\";i:7558;s:11:\"delete-6321\";i:7559;s:11:\"delete-6322\";i:7560;s:11:\"delete-6323\";i:7561;s:11:\"delete-6324\";i:7562;s:11:\"delete-6325\";i:7563;s:11:\"delete-6326\";i:7564;s:11:\"delete-6327\";i:7565;s:11:\"delete-6328\";i:7566;s:11:\"delete-6329\";i:7567;s:11:\"delete-6330\";i:7568;s:11:\"delete-6331\";i:7569;s:11:\"delete-6332\";i:7570;s:11:\"delete-6333\";i:7571;s:11:\"delete-6334\";i:7572;s:11:\"delete-6335\";i:7573;s:11:\"delete-6336\";i:7574;s:11:\"delete-6337\";i:7575;s:11:\"delete-6338\";i:7576;s:11:\"delete-6339\";i:7577;s:11:\"delete-6340\";i:7578;s:11:\"delete-6341\";i:7579;s:11:\"delete-6342\";i:7580;s:11:\"delete-6343\";i:7581;s:11:\"delete-6344\";i:7582;s:11:\"delete-6345\";i:7583;s:11:\"delete-6346\";i:7584;s:11:\"delete-6347\";i:7585;s:11:\"delete-6348\";i:7586;s:11:\"delete-6349\";i:7587;s:11:\"delete-6350\";i:7588;s:11:\"delete-6351\";i:7589;s:11:\"delete-6352\";i:7590;s:11:\"delete-6353\";i:7591;s:11:\"delete-6354\";i:7592;s:11:\"delete-6355\";i:7593;s:11:\"delete-6356\";i:7594;s:11:\"delete-6357\";i:7595;s:11:\"delete-6358\";i:7596;s:11:\"delete-6359\";i:7597;s:11:\"delete-6360\";i:7598;s:11:\"delete-6361\";i:7599;s:11:\"delete-6362\";i:7600;s:11:\"delete-6363\";i:7601;s:11:\"delete-6364\";i:7602;s:11:\"delete-6365\";i:7603;s:11:\"delete-6366\";i:7604;s:11:\"delete-6367\";i:7605;s:11:\"delete-6368\";i:7606;s:11:\"delete-6369\";i:7607;s:11:\"delete-6370\";i:7608;s:11:\"delete-6371\";i:7609;s:11:\"delete-6372\";i:7610;s:11:\"delete-6373\";i:7611;s:11:\"delete-6374\";i:7612;s:11:\"delete-6375\";i:7613;s:11:\"delete-6376\";i:7614;s:11:\"delete-6377\";i:7615;s:11:\"delete-6378\";i:7616;s:11:\"delete-6379\";i:7617;s:11:\"delete-6380\";i:7618;s:11:\"delete-6381\";i:7619;s:11:\"delete-6382\";i:7620;s:11:\"delete-6383\";i:7621;s:11:\"delete-6384\";i:7622;s:11:\"delete-6385\";i:7623;s:11:\"delete-6386\";i:7624;s:11:\"delete-6387\";i:7625;s:11:\"delete-6388\";i:7626;s:11:\"delete-6389\";i:7627;s:11:\"delete-6390\";i:7628;s:11:\"delete-6391\";i:7629;s:11:\"delete-6392\";i:7630;s:11:\"delete-6393\";i:7631;s:11:\"delete-6394\";i:7632;s:11:\"delete-6395\";i:7633;s:11:\"delete-6396\";i:7634;s:11:\"delete-6397\";i:7635;s:11:\"delete-6398\";i:7636;s:11:\"delete-6399\";i:7637;s:11:\"delete-6400\";i:7638;s:11:\"delete-6401\";i:7639;s:11:\"delete-6402\";i:7640;s:11:\"delete-6403\";i:7641;s:11:\"delete-6404\";i:7642;s:11:\"delete-6405\";i:7643;s:11:\"delete-6406\";i:7644;s:11:\"delete-6407\";i:7645;s:11:\"delete-6408\";i:7646;s:11:\"delete-6409\";i:7647;s:11:\"delete-6410\";i:7648;s:11:\"delete-6411\";i:7649;s:11:\"delete-6412\";i:7650;s:11:\"delete-6413\";i:7651;s:11:\"delete-6414\";i:7652;s:11:\"delete-6415\";i:7653;s:11:\"delete-6416\";i:7654;s:11:\"delete-6417\";i:7655;s:11:\"delete-6418\";i:7656;s:11:\"delete-6419\";i:7657;s:11:\"delete-6420\";i:7658;s:11:\"delete-6421\";i:7659;s:11:\"delete-6422\";i:7660;s:11:\"delete-6423\";i:7661;s:11:\"delete-6424\";i:7662;s:11:\"delete-6425\";i:7663;s:11:\"delete-6426\";i:7664;s:11:\"delete-6427\";i:7665;s:11:\"delete-6428\";i:7666;s:11:\"delete-6429\";i:7667;s:11:\"delete-6430\";i:7668;s:11:\"delete-6431\";i:7669;s:11:\"delete-6432\";i:7670;s:11:\"delete-6433\";i:7671;s:11:\"delete-6434\";i:7672;s:11:\"delete-6435\";i:7673;s:11:\"delete-6436\";i:7674;s:11:\"delete-6437\";i:7675;s:11:\"delete-6438\";i:7676;s:11:\"delete-6439\";i:7677;s:11:\"delete-6440\";i:7678;s:11:\"delete-6441\";i:7679;s:11:\"delete-6442\";i:7680;s:11:\"delete-6443\";i:7681;s:11:\"delete-6444\";i:7682;s:11:\"delete-6445\";i:7683;s:11:\"delete-6446\";i:7684;s:11:\"delete-6447\";i:7685;s:11:\"delete-6448\";i:7686;s:11:\"delete-6449\";i:7687;s:11:\"delete-6450\";i:7688;s:11:\"delete-6451\";i:7689;s:11:\"delete-6452\";i:7690;s:11:\"delete-6453\";i:7691;s:11:\"delete-6454\";i:7692;s:11:\"delete-6455\";i:7693;s:11:\"delete-6456\";i:7694;s:11:\"delete-6457\";i:7695;s:11:\"delete-6458\";i:7696;s:11:\"delete-6459\";i:7697;s:11:\"delete-6460\";i:7698;s:11:\"delete-6461\";i:7699;s:11:\"delete-6462\";i:7700;s:11:\"delete-6463\";i:7701;s:11:\"delete-6464\";i:7702;s:11:\"delete-6465\";i:7703;s:11:\"delete-6466\";i:7704;s:11:\"delete-6467\";i:7705;s:11:\"delete-6468\";i:7706;s:11:\"delete-6469\";i:7707;s:11:\"delete-6470\";i:7708;s:11:\"delete-6471\";i:7709;s:11:\"delete-6472\";i:7710;s:11:\"delete-6473\";i:7711;s:11:\"delete-6474\";i:7712;s:11:\"delete-6475\";i:7713;s:11:\"delete-6476\";i:7714;s:11:\"delete-6477\";i:7715;s:11:\"delete-6478\";i:7716;s:11:\"delete-6479\";i:7717;s:11:\"delete-6480\";i:7718;s:11:\"delete-6481\";i:7719;s:11:\"delete-6482\";i:7720;s:11:\"delete-6483\";i:7721;s:11:\"delete-6484\";i:7722;s:11:\"delete-6485\";i:7723;s:11:\"delete-6486\";i:7724;s:11:\"delete-6487\";i:7725;s:11:\"delete-6488\";i:7726;s:11:\"delete-6489\";i:7727;s:11:\"delete-6490\";i:7728;s:11:\"delete-6491\";i:7729;s:11:\"delete-6492\";i:7730;s:11:\"delete-6493\";i:7731;s:11:\"delete-6494\";i:7732;s:11:\"delete-6495\";i:7733;s:11:\"delete-6496\";i:7734;s:11:\"delete-6497\";i:7735;s:11:\"delete-6498\";i:7736;s:11:\"delete-6499\";i:7737;s:11:\"delete-6500\";i:7738;s:11:\"delete-6501\";i:7739;s:11:\"delete-6502\";i:7740;s:11:\"delete-6503\";i:7741;s:11:\"delete-6504\";i:7742;s:11:\"delete-6505\";i:7743;s:11:\"delete-6506\";i:7744;s:11:\"delete-6507\";i:7745;s:11:\"delete-6508\";i:7746;s:11:\"delete-6509\";i:7747;s:11:\"delete-6510\";i:7748;s:11:\"delete-6511\";i:7749;s:11:\"delete-6512\";i:7750;s:11:\"delete-6513\";i:7751;s:11:\"delete-6514\";i:7752;s:11:\"delete-6515\";i:7753;s:11:\"delete-6516\";i:7754;s:11:\"delete-6517\";i:7755;s:11:\"delete-6518\";i:7756;s:11:\"delete-6519\";i:7757;s:11:\"delete-6520\";i:7758;s:11:\"delete-6521\";i:7759;s:11:\"delete-6522\";i:7760;s:11:\"delete-6523\";i:7761;s:11:\"delete-6524\";i:7762;s:11:\"delete-6525\";i:7763;s:11:\"delete-6526\";i:7764;s:11:\"delete-6527\";i:7765;s:11:\"delete-6528\";i:7766;s:11:\"delete-6529\";i:7767;s:11:\"delete-6530\";i:7768;s:11:\"delete-6531\";i:7769;s:11:\"delete-6532\";i:7770;s:11:\"delete-6533\";i:7771;s:11:\"delete-6534\";i:7772;s:11:\"delete-6535\";i:7773;s:11:\"delete-6536\";i:7774;s:11:\"delete-6537\";i:7775;s:11:\"delete-6538\";i:7776;s:11:\"delete-6539\";i:7777;s:11:\"delete-6540\";i:7778;s:11:\"delete-6541\";i:7779;s:11:\"delete-6542\";i:7780;s:11:\"delete-6543\";i:7781;s:11:\"delete-6544\";i:7782;s:11:\"delete-6545\";i:7783;s:11:\"delete-6546\";i:7784;s:11:\"delete-6547\";i:7785;s:11:\"delete-6548\";i:7786;s:11:\"delete-6549\";i:7787;s:11:\"delete-6550\";i:7788;s:11:\"delete-6551\";i:7789;s:11:\"delete-6552\";i:7790;s:11:\"delete-6553\";i:7791;s:11:\"delete-6554\";i:7792;s:11:\"delete-6555\";i:7793;s:11:\"delete-6556\";i:7794;s:11:\"delete-6557\";i:7795;s:11:\"delete-6558\";i:7796;s:11:\"delete-6559\";i:7797;s:11:\"delete-6560\";i:7798;s:11:\"delete-6561\";i:7799;s:11:\"delete-6562\";i:7800;s:11:\"delete-6563\";i:7801;s:11:\"delete-6564\";i:7802;s:11:\"delete-6565\";i:7803;s:11:\"delete-6566\";i:7804;s:11:\"delete-6567\";i:7805;s:11:\"delete-6568\";i:7806;s:11:\"delete-6569\";i:7807;s:11:\"delete-6570\";i:7808;s:11:\"delete-6571\";i:7809;s:11:\"delete-6572\";i:7810;s:11:\"delete-6573\";i:7811;s:11:\"delete-6574\";i:7812;s:11:\"delete-6575\";i:7813;s:11:\"delete-6576\";i:7814;s:11:\"delete-6577\";i:7815;s:11:\"delete-6578\";i:7816;s:11:\"delete-6579\";i:7817;s:11:\"delete-6580\";i:7818;s:11:\"delete-6581\";i:7819;s:11:\"delete-6582\";i:7820;s:11:\"delete-6583\";i:7821;s:11:\"delete-6584\";i:7822;s:11:\"delete-6585\";i:7823;s:11:\"delete-6586\";i:7824;s:11:\"delete-6587\";i:7825;s:11:\"delete-6588\";i:7826;s:11:\"delete-6589\";i:7827;s:11:\"delete-6590\";i:7828;s:11:\"delete-6591\";i:7829;s:11:\"delete-6592\";i:7830;s:11:\"delete-6593\";i:7831;s:11:\"delete-6594\";i:7832;s:11:\"delete-6595\";i:7833;s:11:\"delete-6596\";i:7834;s:11:\"delete-6597\";i:7835;s:11:\"delete-6598\";i:7836;s:11:\"delete-6599\";i:7837;s:11:\"delete-6600\";i:7838;s:11:\"delete-6601\";i:7839;s:11:\"delete-6602\";i:7840;s:11:\"delete-6603\";i:7841;s:11:\"delete-6604\";i:7842;s:11:\"delete-6605\";i:7843;s:11:\"delete-6606\";i:7844;s:11:\"delete-6607\";i:7845;s:11:\"delete-6608\";i:7846;s:11:\"delete-6609\";i:7847;s:11:\"delete-6610\";i:7848;s:11:\"delete-6611\";i:7849;s:11:\"delete-6612\";i:7850;s:11:\"delete-6613\";i:7851;s:11:\"delete-6614\";i:7852;s:11:\"delete-6615\";i:7853;s:11:\"delete-6616\";i:7854;s:11:\"delete-6617\";i:7855;s:11:\"delete-6618\";i:7856;s:11:\"delete-6619\";i:7857;s:11:\"delete-6620\";i:7858;s:11:\"delete-6621\";i:7859;s:11:\"delete-6622\";i:7860;s:11:\"delete-6623\";i:7861;s:11:\"delete-6624\";i:7862;s:11:\"delete-6625\";i:7863;s:11:\"delete-6626\";i:7864;s:11:\"delete-6627\";i:7865;s:11:\"delete-6628\";i:7866;s:11:\"delete-6629\";i:7867;s:11:\"delete-6630\";i:7868;s:11:\"delete-6631\";i:7869;s:11:\"delete-6632\";i:7870;s:11:\"delete-6633\";i:7871;s:11:\"delete-6634\";i:7872;s:11:\"delete-6635\";i:7873;s:11:\"delete-6636\";i:7874;s:11:\"delete-6637\";i:7875;s:11:\"delete-6638\";i:7876;s:11:\"delete-6639\";i:7877;s:11:\"delete-6640\";i:7878;s:11:\"delete-6641\";i:7879;s:11:\"delete-6642\";i:7880;s:11:\"delete-6643\";i:7881;s:11:\"delete-6644\";i:7882;s:11:\"delete-6645\";i:7883;s:11:\"delete-6646\";i:7884;s:11:\"delete-6647\";i:7885;s:11:\"delete-6648\";i:7886;s:11:\"delete-6649\";i:7887;s:11:\"delete-6650\";i:7888;s:11:\"delete-6651\";i:7889;s:11:\"delete-6652\";i:7890;s:11:\"delete-6653\";i:7891;s:11:\"delete-6654\";i:7892;s:11:\"delete-6655\";i:7893;s:11:\"delete-6656\";i:7894;s:11:\"delete-6657\";i:7895;s:11:\"delete-6658\";i:7896;s:11:\"delete-6659\";i:7897;s:11:\"delete-6660\";i:7898;s:11:\"delete-6661\";i:7899;s:11:\"delete-6662\";i:7900;s:11:\"delete-6663\";i:7901;s:11:\"delete-6664\";i:7902;s:11:\"delete-6665\";i:7903;s:11:\"delete-6666\";i:7904;s:11:\"delete-6667\";i:7905;s:11:\"delete-6668\";i:7906;s:11:\"delete-6669\";i:7907;s:11:\"delete-6670\";i:7908;s:11:\"delete-6671\";i:7909;s:11:\"delete-6672\";i:7910;s:11:\"delete-6673\";i:7911;s:11:\"delete-6674\";i:7912;s:11:\"delete-6675\";i:7913;s:11:\"delete-6676\";i:7914;s:11:\"delete-6677\";i:7915;s:11:\"delete-6678\";i:7916;s:11:\"delete-6679\";i:7917;s:11:\"delete-6680\";i:7918;s:11:\"delete-6681\";i:7919;s:11:\"delete-6682\";i:7920;s:11:\"delete-6683\";i:7921;s:11:\"delete-6684\";i:7922;s:11:\"delete-6685\";i:7923;s:11:\"delete-6686\";i:7924;s:11:\"delete-6687\";i:7925;s:11:\"delete-6688\";i:7926;s:11:\"delete-6689\";i:7927;s:11:\"delete-6690\";i:7928;s:11:\"delete-6691\";i:7929;s:11:\"delete-6692\";i:7930;s:11:\"delete-6693\";i:7931;s:11:\"delete-6694\";i:7932;s:11:\"delete-6695\";i:7933;s:11:\"delete-6696\";i:7934;s:11:\"delete-6697\";i:7935;s:11:\"delete-6698\";i:7936;s:11:\"delete-6699\";i:7937;s:11:\"delete-6700\";i:7938;s:11:\"delete-6701\";i:7939;s:11:\"delete-6702\";i:7940;s:11:\"delete-6703\";i:7941;s:11:\"delete-6704\";i:7942;s:11:\"delete-6705\";i:7943;s:11:\"delete-6706\";i:7944;s:11:\"delete-6707\";i:7945;s:11:\"delete-6708\";i:7946;s:11:\"delete-6709\";i:7947;s:11:\"delete-6710\";i:7948;s:11:\"delete-6711\";i:7949;s:11:\"delete-6712\";i:7950;s:11:\"delete-6713\";i:7951;s:11:\"delete-6714\";i:7952;s:11:\"delete-6715\";i:7953;s:11:\"delete-6716\";i:7954;s:11:\"delete-6717\";i:7955;s:11:\"delete-6718\";i:7956;s:11:\"delete-6719\";i:7957;s:11:\"delete-6720\";i:7958;s:11:\"delete-6721\";i:7959;s:11:\"delete-6722\";i:7960;s:11:\"delete-6723\";i:7961;s:11:\"delete-6724\";i:7962;s:11:\"delete-6725\";i:7963;s:11:\"delete-6726\";i:7964;s:11:\"delete-6727\";i:7965;s:11:\"delete-6728\";i:7966;s:11:\"delete-6729\";i:7967;s:11:\"delete-6730\";i:7968;s:11:\"delete-6731\";i:7969;s:11:\"delete-6732\";i:7970;s:11:\"delete-6733\";i:7971;s:11:\"delete-6734\";i:7972;s:11:\"delete-6735\";i:7973;s:11:\"delete-6736\";i:7974;s:11:\"delete-6737\";i:7975;s:11:\"delete-6738\";i:7976;s:11:\"delete-6739\";i:7977;s:11:\"delete-6740\";i:7978;s:11:\"delete-6741\";i:7979;s:11:\"delete-6742\";i:7980;s:11:\"delete-6743\";i:7981;s:11:\"delete-6744\";i:7982;s:11:\"delete-6745\";i:7983;s:11:\"delete-6746\";i:7984;s:11:\"delete-6747\";i:7985;s:11:\"delete-6748\";i:7986;s:11:\"delete-6749\";i:7987;s:11:\"delete-6750\";i:7988;s:11:\"delete-6751\";i:7989;s:11:\"delete-6752\";i:7990;s:11:\"delete-6753\";i:7991;s:11:\"delete-6754\";i:7992;s:11:\"delete-6755\";i:7993;s:11:\"delete-6756\";i:7994;s:11:\"delete-6757\";i:7995;s:11:\"delete-6758\";i:7996;s:11:\"delete-6759\";i:7997;s:11:\"delete-6760\";i:7998;s:11:\"delete-6761\";i:7999;s:11:\"delete-6762\";i:8000;s:11:\"delete-6763\";i:8001;s:11:\"delete-6764\";i:8002;s:11:\"delete-6765\";i:8003;s:11:\"delete-6766\";i:8004;s:11:\"delete-6767\";i:8005;s:11:\"delete-6768\";i:8006;s:11:\"delete-6769\";i:8007;s:11:\"delete-6770\";i:8008;s:11:\"delete-6771\";i:8009;s:11:\"delete-6772\";i:8010;s:11:\"delete-6773\";i:8011;s:11:\"delete-6774\";i:8012;s:11:\"delete-6775\";i:8013;s:11:\"delete-6776\";i:8014;s:11:\"delete-6777\";i:8015;s:11:\"delete-6778\";i:8016;s:11:\"delete-6779\";i:8017;s:11:\"delete-6780\";i:8018;s:11:\"delete-6781\";i:8019;s:11:\"delete-6782\";i:8020;s:11:\"delete-6783\";i:8021;s:11:\"delete-6784\";i:8022;s:11:\"delete-6785\";i:8023;s:11:\"delete-6786\";i:8024;s:11:\"delete-6787\";i:8025;s:11:\"delete-6788\";i:8026;s:11:\"delete-6789\";i:8027;s:11:\"delete-6790\";i:8028;s:11:\"delete-6791\";i:8029;s:11:\"delete-6792\";i:8030;s:11:\"delete-6793\";i:8031;s:11:\"delete-6794\";i:8032;s:11:\"delete-6795\";i:8033;s:11:\"delete-6796\";i:8034;s:11:\"delete-6797\";i:8035;s:11:\"delete-6798\";i:8036;s:11:\"delete-6799\";i:8037;s:11:\"delete-6800\";i:8038;s:11:\"delete-6801\";i:8039;s:11:\"delete-6802\";i:8040;s:11:\"delete-6803\";i:8041;s:11:\"delete-6804\";i:8042;s:11:\"delete-6805\";i:8043;s:11:\"delete-6806\";i:8044;s:11:\"delete-6807\";i:8045;s:11:\"delete-6808\";i:8046;s:11:\"delete-6809\";i:8047;s:11:\"delete-6810\";i:8048;s:11:\"delete-6811\";i:8049;s:11:\"delete-6812\";i:8050;s:11:\"delete-6813\";i:8051;s:11:\"delete-6814\";i:8052;s:11:\"delete-6815\";i:8053;s:11:\"delete-6816\";i:8054;s:11:\"delete-6817\";i:8055;s:11:\"delete-6818\";i:8056;s:11:\"delete-6819\";i:8057;s:11:\"delete-6820\";i:8058;s:11:\"delete-6821\";i:8059;s:11:\"delete-6822\";i:8060;s:11:\"delete-6823\";i:8061;s:11:\"delete-6824\";i:8062;s:11:\"delete-6825\";i:8063;s:11:\"delete-6826\";i:8064;s:11:\"delete-6827\";i:8065;s:11:\"delete-6828\";i:8066;s:11:\"delete-6829\";i:8067;s:11:\"delete-6830\";i:8068;s:11:\"delete-6831\";i:8069;s:11:\"delete-6832\";i:8070;s:11:\"delete-6833\";i:8071;s:11:\"delete-6834\";i:8072;s:11:\"delete-6835\";i:8073;s:11:\"delete-6836\";i:8074;s:11:\"delete-6837\";i:8075;s:11:\"delete-6838\";i:8076;s:11:\"delete-6839\";i:8077;s:11:\"delete-6840\";i:8078;s:11:\"delete-6841\";i:8079;s:11:\"delete-6842\";i:8080;s:11:\"delete-6843\";i:8081;s:11:\"delete-6844\";i:8082;s:11:\"delete-6845\";i:8083;s:11:\"delete-6846\";i:8084;s:11:\"delete-6847\";i:8085;s:11:\"delete-6848\";i:8086;s:11:\"delete-6849\";i:8087;s:11:\"delete-6850\";i:8088;s:11:\"delete-6851\";i:8089;s:11:\"delete-6852\";i:8090;s:11:\"delete-6853\";i:8091;s:11:\"delete-6854\";i:8092;s:11:\"delete-6855\";i:8093;s:11:\"delete-6856\";i:8094;s:11:\"delete-6857\";i:8095;s:11:\"delete-6858\";i:8096;s:11:\"delete-6859\";i:8097;s:11:\"delete-6860\";i:8098;s:11:\"delete-6861\";i:8099;s:11:\"delete-6862\";i:8100;s:11:\"delete-6863\";i:8101;s:11:\"delete-6864\";i:8102;s:11:\"delete-6865\";i:8103;s:11:\"delete-6866\";i:8104;s:11:\"delete-6867\";i:8105;s:11:\"delete-6868\";i:8106;s:11:\"delete-6869\";i:8107;s:11:\"delete-6870\";i:8108;s:11:\"delete-6871\";i:8109;s:11:\"delete-6872\";i:8110;s:11:\"delete-6873\";i:8111;s:11:\"delete-6874\";i:8112;s:11:\"delete-6875\";i:8113;s:11:\"delete-6876\";i:8114;s:11:\"delete-6877\";i:8115;s:11:\"delete-6878\";i:8116;s:11:\"delete-6879\";i:8117;s:11:\"delete-6880\";i:8118;s:11:\"delete-6881\";i:8119;s:11:\"delete-6882\";i:8120;s:11:\"delete-6883\";i:8121;s:11:\"delete-6884\";i:8122;s:11:\"delete-6885\";i:8123;s:11:\"delete-6886\";i:8124;s:11:\"delete-6887\";i:8125;s:11:\"delete-6888\";i:8126;s:11:\"delete-6889\";i:8127;s:11:\"delete-6890\";i:8128;s:11:\"delete-6891\";i:8129;s:11:\"delete-6892\";i:8130;s:11:\"delete-6893\";i:8131;s:11:\"delete-6894\";i:8132;s:11:\"delete-6895\";i:8133;s:11:\"delete-6896\";i:8134;s:11:\"delete-6897\";i:8135;s:11:\"delete-6898\";i:8136;s:11:\"delete-6899\";i:8137;s:11:\"delete-6900\";i:8138;s:11:\"delete-6901\";i:8139;s:11:\"delete-6902\";i:8140;s:11:\"delete-6903\";i:8141;s:11:\"delete-6904\";i:8142;s:11:\"delete-6905\";i:8143;s:11:\"delete-6906\";i:8144;s:11:\"delete-6907\";i:8145;s:11:\"delete-6908\";i:8146;s:11:\"delete-6909\";i:8147;s:11:\"delete-6910\";i:8148;s:11:\"delete-6911\";i:8149;s:11:\"delete-6912\";i:8150;s:11:\"delete-6913\";i:8151;s:11:\"delete-6914\";i:8152;s:11:\"delete-6915\";i:8153;s:11:\"delete-6916\";i:8154;s:11:\"delete-6917\";i:8155;s:11:\"delete-6918\";i:8156;s:11:\"delete-6919\";i:8157;s:11:\"delete-6920\";i:8158;s:11:\"delete-6921\";i:8159;s:11:\"delete-6922\";i:8160;s:11:\"delete-6923\";i:8161;s:11:\"delete-6924\";i:8162;s:11:\"delete-6925\";i:8163;s:11:\"delete-6926\";i:8164;s:11:\"delete-6927\";i:8165;s:11:\"delete-6928\";i:8166;s:11:\"delete-6929\";i:8167;s:11:\"delete-6930\";i:8168;s:11:\"delete-6931\";i:8169;s:11:\"delete-6932\";i:8170;s:11:\"delete-6933\";i:8171;s:11:\"delete-6934\";i:8172;s:11:\"delete-6935\";i:8173;s:11:\"delete-6936\";i:8174;s:11:\"delete-6937\";i:8175;s:11:\"delete-6938\";i:8176;s:11:\"delete-6939\";i:8177;s:11:\"delete-6940\";i:8178;s:11:\"delete-6941\";i:8179;s:11:\"delete-6942\";i:8180;s:11:\"delete-6943\";i:8181;s:11:\"delete-6944\";i:8182;s:11:\"delete-6945\";i:8183;s:11:\"delete-6946\";i:8184;s:11:\"delete-6947\";i:8185;s:11:\"delete-6948\";i:8186;s:11:\"delete-6949\";i:8187;s:11:\"delete-6950\";i:8188;s:11:\"delete-6951\";i:8189;s:11:\"delete-6952\";i:8190;s:11:\"delete-6953\";i:8191;s:11:\"delete-6954\";i:8192;s:11:\"delete-6955\";i:8193;s:11:\"delete-6956\";i:8194;s:11:\"delete-6957\";i:8195;s:11:\"delete-6958\";i:8196;s:11:\"delete-6959\";i:8197;s:11:\"delete-6960\";i:8198;s:11:\"delete-6961\";i:8199;s:11:\"delete-6962\";i:8200;s:11:\"delete-6963\";i:8201;s:11:\"delete-6964\";i:8202;s:11:\"delete-6965\";i:8203;s:11:\"delete-6966\";i:8204;s:11:\"delete-6967\";i:8205;s:11:\"delete-6968\";i:8206;s:11:\"delete-6969\";i:8207;s:11:\"delete-6970\";i:8208;s:11:\"delete-6971\";i:8209;s:11:\"delete-6972\";i:8210;s:11:\"delete-6973\";i:8211;s:11:\"delete-6974\";i:8212;s:11:\"delete-6975\";i:8213;s:11:\"delete-6976\";i:8214;s:11:\"delete-6977\";i:8215;s:11:\"delete-6978\";i:8216;s:11:\"delete-6979\";i:8217;s:11:\"delete-6980\";i:8218;s:11:\"delete-6981\";i:8219;s:11:\"delete-6982\";i:8220;s:11:\"delete-6983\";i:8221;s:11:\"delete-6984\";i:8222;s:11:\"delete-6985\";i:8223;s:11:\"delete-6986\";i:8224;s:11:\"delete-6987\";i:8225;s:11:\"delete-6988\";i:8226;s:11:\"delete-6989\";i:8227;s:11:\"delete-6990\";i:8228;s:11:\"delete-6991\";i:8229;s:11:\"delete-6992\";i:8230;s:11:\"delete-6993\";i:8231;s:11:\"delete-6994\";i:8232;s:11:\"delete-6995\";i:8233;s:11:\"delete-6996\";i:8234;s:11:\"delete-6997\";i:8235;s:11:\"delete-6998\";i:8236;s:11:\"delete-6999\";i:8237;s:11:\"delete-7000\";i:8238;s:11:\"delete-7001\";i:8239;s:11:\"delete-7002\";i:8240;s:11:\"delete-7003\";i:8241;s:11:\"delete-7004\";i:8242;s:11:\"delete-7005\";i:8243;s:11:\"delete-7006\";i:8244;s:11:\"delete-7007\";i:8245;s:11:\"delete-7008\";i:8246;s:11:\"delete-7009\";i:8247;s:11:\"delete-7010\";i:8248;s:11:\"delete-7011\";i:8249;s:11:\"delete-7012\";i:8250;s:11:\"delete-7013\";i:8251;s:11:\"delete-7014\";i:8252;s:11:\"delete-7015\";i:8253;s:11:\"delete-7016\";i:8254;s:11:\"delete-7017\";i:8255;s:11:\"delete-7018\";i:8256;s:11:\"delete-7019\";i:8257;s:11:\"delete-7020\";i:8258;s:11:\"delete-7021\";i:8259;s:11:\"delete-7022\";i:8260;s:11:\"delete-7023\";i:8261;s:11:\"delete-7024\";i:8262;s:11:\"delete-7025\";i:8263;s:11:\"delete-7026\";i:8264;s:11:\"delete-7027\";i:8265;s:11:\"delete-7028\";i:8266;s:11:\"delete-7029\";i:8267;s:11:\"delete-7030\";i:8268;s:11:\"delete-7031\";i:8269;s:11:\"delete-7032\";i:8270;s:11:\"delete-7033\";i:8271;s:11:\"delete-7034\";i:8272;s:11:\"delete-7035\";i:8273;s:11:\"delete-7036\";i:8274;s:11:\"delete-7037\";i:8275;s:11:\"delete-7038\";i:8276;s:11:\"delete-7039\";i:8277;s:11:\"delete-7040\";i:8278;s:11:\"delete-7041\";i:8279;s:11:\"delete-7042\";i:8280;s:11:\"delete-7043\";i:8281;s:11:\"delete-7044\";i:8282;s:11:\"delete-7045\";i:8283;s:11:\"delete-7046\";i:8284;s:11:\"delete-7047\";i:8285;s:11:\"delete-7048\";i:8286;s:11:\"delete-7049\";i:8287;s:11:\"delete-7050\";i:8288;s:11:\"delete-7051\";i:8289;s:11:\"delete-7052\";i:8290;s:11:\"delete-7053\";i:8291;s:11:\"delete-7054\";i:8292;s:11:\"delete-7055\";i:8293;s:11:\"delete-7056\";i:8294;s:11:\"delete-7057\";i:8295;s:11:\"delete-7058\";i:8296;s:11:\"delete-7059\";i:8297;s:11:\"delete-7060\";i:8298;s:11:\"delete-7061\";i:8299;s:11:\"delete-7062\";i:8300;s:11:\"delete-7063\";i:8301;s:11:\"delete-7064\";i:8302;s:11:\"delete-7065\";i:8303;s:11:\"delete-7066\";i:8304;s:11:\"delete-7067\";i:8305;s:11:\"delete-7068\";i:8306;s:11:\"delete-7069\";i:8307;s:11:\"delete-7070\";i:8308;s:11:\"delete-7071\";i:8309;s:11:\"delete-7072\";i:8310;s:11:\"delete-7073\";i:8311;s:11:\"delete-7074\";i:8312;s:11:\"delete-7075\";i:8313;s:11:\"delete-7076\";i:8314;s:11:\"delete-7077\";i:8315;s:11:\"delete-7078\";i:8316;s:11:\"delete-7079\";i:8317;s:11:\"delete-7080\";i:8318;s:11:\"delete-7081\";i:8319;s:11:\"delete-7082\";i:8320;s:11:\"delete-7083\";i:8321;s:11:\"delete-7084\";i:8322;s:11:\"delete-7085\";i:8323;s:11:\"delete-7086\";i:8324;s:11:\"delete-7087\";i:8325;s:11:\"delete-7088\";i:8326;s:11:\"delete-7089\";i:8327;s:11:\"delete-7090\";i:8328;s:11:\"delete-7091\";i:8329;s:11:\"delete-7092\";i:8330;s:11:\"delete-7093\";i:8331;s:11:\"delete-7094\";i:8332;s:11:\"delete-7095\";i:8333;s:11:\"delete-7096\";i:8334;s:11:\"delete-7097\";i:8335;s:11:\"delete-7098\";i:8336;s:11:\"delete-7099\";i:8337;s:11:\"delete-7100\";i:8338;s:11:\"delete-7101\";i:8339;s:11:\"delete-7102\";i:8340;s:11:\"delete-7103\";i:8341;s:11:\"delete-7104\";i:8342;s:11:\"delete-7105\";i:8343;s:11:\"delete-7106\";i:8344;s:11:\"delete-7107\";i:8345;s:11:\"delete-7108\";i:8346;s:11:\"delete-7109\";i:8347;s:11:\"delete-7110\";i:8348;s:11:\"delete-7111\";i:8349;s:11:\"delete-7112\";i:8350;s:11:\"delete-7113\";i:8351;s:11:\"delete-7114\";i:8352;s:11:\"delete-7115\";i:8353;s:11:\"delete-7116\";i:8354;s:11:\"delete-7117\";i:8355;s:11:\"delete-7118\";i:8356;s:11:\"delete-7119\";i:8357;s:11:\"delete-7120\";i:8358;s:11:\"delete-7121\";i:8359;s:11:\"delete-7122\";i:8360;s:11:\"delete-7123\";i:8361;s:11:\"delete-7124\";i:8362;s:11:\"delete-7125\";i:8363;s:11:\"delete-7126\";i:8364;s:11:\"delete-7127\";i:8365;s:11:\"delete-7128\";i:8366;s:11:\"delete-7129\";i:8367;s:11:\"delete-7130\";i:8368;s:11:\"delete-7131\";i:8369;s:11:\"delete-7132\";i:8370;s:11:\"delete-7133\";i:8371;s:11:\"delete-7134\";i:8372;s:11:\"delete-7135\";i:8373;s:11:\"delete-7136\";i:8374;s:11:\"delete-7137\";i:8375;s:11:\"delete-7138\";i:8376;s:11:\"delete-7139\";i:8377;s:11:\"delete-7140\";i:8378;s:11:\"delete-7141\";i:8379;s:11:\"delete-7142\";i:8380;s:11:\"delete-7143\";i:8381;s:11:\"delete-7144\";i:8382;s:11:\"delete-7145\";i:8383;s:11:\"delete-7146\";i:8384;s:11:\"delete-7147\";i:8385;s:11:\"delete-7148\";i:8386;s:11:\"delete-7149\";i:8387;s:11:\"delete-7150\";i:8388;s:11:\"delete-7151\";i:8389;s:11:\"delete-7152\";i:8390;s:11:\"delete-7153\";i:8391;s:11:\"delete-7154\";i:8392;s:11:\"delete-7155\";i:8393;s:11:\"delete-7156\";i:8394;s:11:\"delete-7157\";i:8395;s:11:\"delete-7158\";i:8396;s:11:\"delete-7159\";i:8397;s:11:\"delete-7160\";i:8398;s:11:\"delete-7161\";i:8399;s:11:\"delete-7162\";i:8400;s:11:\"delete-7163\";i:8401;s:11:\"delete-7164\";i:8402;s:11:\"delete-7165\";i:8403;s:11:\"delete-7166\";i:8404;s:11:\"delete-7167\";i:8405;s:11:\"delete-7168\";i:8406;s:11:\"delete-7169\";i:8407;s:11:\"delete-7170\";i:8408;s:11:\"delete-7171\";i:8409;s:11:\"delete-7172\";i:8410;s:11:\"delete-7173\";i:8411;s:11:\"delete-7174\";i:8412;s:11:\"delete-7175\";i:8413;s:11:\"delete-7176\";i:8414;s:11:\"delete-7177\";i:8415;s:11:\"delete-7178\";i:8416;s:11:\"delete-7179\";i:8417;s:11:\"delete-7180\";i:8418;s:11:\"delete-7181\";i:8419;s:11:\"delete-7182\";i:8420;s:11:\"delete-7183\";i:8421;s:11:\"delete-7184\";i:8422;s:11:\"delete-7185\";i:8423;s:11:\"delete-7186\";i:8424;s:11:\"delete-7187\";i:8425;s:11:\"delete-7188\";i:8426;s:11:\"delete-7189\";i:8427;s:11:\"delete-7190\";i:8428;s:11:\"delete-7191\";i:8429;s:11:\"delete-7192\";i:8430;s:11:\"delete-7193\";i:8431;s:11:\"delete-7194\";i:8432;s:11:\"delete-7195\";i:8433;s:11:\"delete-7196\";i:8434;s:11:\"delete-7197\";i:8435;s:11:\"delete-7198\";i:8436;s:11:\"delete-7199\";i:8437;s:11:\"delete-7200\";i:8438;s:11:\"delete-7201\";i:8439;s:11:\"delete-7202\";i:8440;s:11:\"delete-7203\";i:8441;s:11:\"delete-7204\";i:8442;s:11:\"delete-7205\";i:8443;s:11:\"delete-7206\";i:8444;s:11:\"delete-7207\";i:8445;s:11:\"delete-7208\";i:8446;s:11:\"delete-7209\";i:8447;s:11:\"delete-7210\";i:8448;s:11:\"delete-7211\";i:8449;s:11:\"delete-7212\";i:8450;s:11:\"delete-7213\";i:8451;s:11:\"delete-7214\";i:8452;s:11:\"delete-7215\";i:8453;s:11:\"delete-7216\";i:8454;s:11:\"delete-7217\";i:8455;s:11:\"delete-7218\";i:8456;s:11:\"delete-7219\";i:8457;s:11:\"delete-7220\";i:8458;s:11:\"delete-7221\";i:8459;s:11:\"delete-7222\";i:8460;s:11:\"delete-7223\";i:8461;s:11:\"delete-7224\";i:8462;s:11:\"delete-7225\";i:8463;s:11:\"delete-7226\";i:8464;s:11:\"delete-7227\";i:8465;s:11:\"delete-7228\";i:8466;s:11:\"delete-7229\";i:8467;s:11:\"delete-7230\";i:8468;s:11:\"delete-7231\";i:8469;s:11:\"delete-7232\";i:8470;s:11:\"delete-7233\";i:8471;s:11:\"delete-7234\";i:8472;s:11:\"delete-7235\";i:8473;s:11:\"delete-7236\";i:8474;s:11:\"delete-7237\";i:8475;s:11:\"delete-7238\";i:8476;s:11:\"delete-7239\";i:8477;s:11:\"delete-7240\";i:8478;s:11:\"delete-7241\";i:8479;s:11:\"delete-7242\";i:8480;s:11:\"delete-7243\";i:8481;s:11:\"delete-7244\";i:8482;s:11:\"delete-7245\";i:8483;s:11:\"delete-7246\";i:8484;s:11:\"delete-7247\";i:8485;s:11:\"delete-7248\";i:8486;s:11:\"delete-7249\";i:8487;s:11:\"delete-7250\";i:8488;s:11:\"delete-7251\";i:8489;s:11:\"delete-7252\";i:8490;s:11:\"delete-7253\";i:8491;s:11:\"delete-7254\";i:8492;s:11:\"delete-7255\";i:8493;s:11:\"delete-7256\";i:8494;s:11:\"delete-7257\";i:8495;s:11:\"delete-7258\";i:8496;s:11:\"delete-7259\";i:8497;s:11:\"delete-7260\";i:8498;s:11:\"delete-7261\";i:8499;s:11:\"delete-7262\";i:8500;s:11:\"delete-7263\";i:8501;s:11:\"delete-7264\";i:8502;s:11:\"delete-7265\";i:8503;s:11:\"delete-7266\";i:8504;s:11:\"delete-7267\";i:8505;s:11:\"delete-7268\";i:8506;s:11:\"delete-7269\";i:8507;s:11:\"delete-7270\";i:8508;s:11:\"delete-7271\";i:8509;s:11:\"delete-7272\";i:8510;s:11:\"delete-7273\";i:8511;s:11:\"delete-7274\";i:8512;s:11:\"delete-7275\";i:8513;s:11:\"delete-7276\";i:8514;s:11:\"delete-7277\";i:8515;s:11:\"delete-7278\";i:8516;s:11:\"delete-7279\";i:8517;s:11:\"delete-7280\";i:8518;s:11:\"delete-7281\";i:8519;s:11:\"delete-7282\";i:8520;s:11:\"delete-7283\";i:8521;s:11:\"delete-7284\";i:8522;s:11:\"delete-7285\";i:8523;s:11:\"delete-7286\";i:8524;s:11:\"delete-7287\";i:8525;s:11:\"delete-7288\";i:8526;s:11:\"delete-7289\";i:8527;s:11:\"delete-7290\";i:8528;s:11:\"delete-7291\";i:8529;s:11:\"delete-7292\";i:8530;s:11:\"delete-7293\";i:8531;s:11:\"delete-7294\";i:8532;s:11:\"delete-7295\";i:8533;s:11:\"delete-7296\";i:8534;s:11:\"delete-7297\";i:8535;s:11:\"delete-7298\";i:8536;s:11:\"delete-7299\";i:8537;s:11:\"delete-7300\";i:8538;s:11:\"delete-7301\";i:8539;s:11:\"delete-7302\";i:8540;s:11:\"delete-7303\";i:8541;s:11:\"delete-7304\";i:8542;s:11:\"delete-7305\";i:8543;s:11:\"delete-7306\";i:8544;s:11:\"delete-7307\";i:8545;s:11:\"delete-7308\";i:8546;s:11:\"delete-7309\";i:8547;s:11:\"delete-7310\";i:8548;s:11:\"delete-7311\";i:8549;s:11:\"delete-7312\";i:8550;s:11:\"delete-7313\";i:8551;s:11:\"delete-7314\";i:8552;s:11:\"delete-7315\";i:8553;s:11:\"delete-7316\";i:8554;s:11:\"delete-7317\";i:8555;s:11:\"delete-7318\";i:8556;s:11:\"delete-7319\";i:8557;s:11:\"delete-7320\";i:8558;s:11:\"delete-7321\";i:8559;s:11:\"delete-7322\";i:8560;s:11:\"delete-7323\";i:8561;s:11:\"delete-7324\";i:8562;s:11:\"delete-7325\";i:8563;s:11:\"delete-7326\";i:8564;s:11:\"delete-7327\";i:8565;s:11:\"delete-7328\";i:8566;s:11:\"delete-7329\";i:8567;s:11:\"delete-7330\";i:8568;s:11:\"delete-7331\";i:8569;s:11:\"delete-7332\";i:8570;s:11:\"delete-7333\";i:8571;s:11:\"delete-7334\";i:8572;s:11:\"delete-7335\";i:8573;s:11:\"delete-7336\";i:8574;s:11:\"delete-7337\";i:8575;s:11:\"delete-7338\";i:8576;s:11:\"delete-7339\";i:8577;s:11:\"delete-7340\";i:8578;s:11:\"delete-7341\";i:8579;s:11:\"delete-7342\";i:8580;s:11:\"delete-7343\";i:8581;s:11:\"delete-7344\";i:8582;s:11:\"delete-7345\";i:8583;s:11:\"delete-7346\";i:8584;s:11:\"delete-7347\";i:8585;s:11:\"delete-7348\";i:8586;s:11:\"delete-7349\";i:8587;s:11:\"delete-7350\";i:8588;s:11:\"delete-7351\";i:8589;s:11:\"delete-7352\";i:8590;s:11:\"delete-7353\";i:8591;s:11:\"delete-7354\";i:8592;s:11:\"delete-7355\";i:8593;s:11:\"delete-7356\";i:8594;s:11:\"delete-7357\";i:8595;s:11:\"delete-7358\";i:8596;s:11:\"delete-7359\";i:8597;s:11:\"delete-7360\";i:8598;s:11:\"delete-7361\";i:8599;s:11:\"delete-7362\";i:8600;s:11:\"delete-7363\";i:8601;s:11:\"delete-7364\";i:8602;s:11:\"delete-7365\";i:8603;s:11:\"delete-7366\";i:8604;s:11:\"delete-7367\";i:8605;s:11:\"delete-7368\";i:8606;s:11:\"delete-7369\";i:8607;s:11:\"delete-7370\";i:8608;s:11:\"delete-7371\";i:8609;s:11:\"delete-7372\";i:8610;s:11:\"delete-7373\";i:8611;s:11:\"delete-7374\";i:8612;s:11:\"delete-7375\";i:8613;s:11:\"delete-7376\";i:8614;s:11:\"delete-7377\";i:8615;s:11:\"delete-7378\";i:8616;s:11:\"delete-7379\";i:8617;s:11:\"delete-7380\";i:8618;s:11:\"delete-7381\";i:8619;s:11:\"delete-7382\";i:8620;s:11:\"delete-7383\";i:8621;s:11:\"delete-7384\";i:8622;s:11:\"delete-7385\";i:8623;s:11:\"delete-7386\";i:8624;s:11:\"delete-7387\";i:8625;s:11:\"delete-7388\";i:8626;s:11:\"delete-7389\";i:8627;s:11:\"delete-7390\";i:8628;s:11:\"delete-7391\";i:8629;s:11:\"delete-7392\";i:8630;s:11:\"delete-7393\";i:8631;s:11:\"delete-7394\";i:8632;s:11:\"delete-7395\";i:8633;s:11:\"delete-7396\";i:8634;s:11:\"delete-7397\";i:8635;s:11:\"delete-7398\";i:8636;s:11:\"delete-7399\";i:8637;s:11:\"delete-7400\";i:8638;s:11:\"delete-7401\";i:8639;s:11:\"delete-7402\";i:8640;s:11:\"delete-7403\";i:8641;s:11:\"delete-7404\";i:8642;s:11:\"delete-7405\";i:8643;s:11:\"delete-7406\";i:8644;s:11:\"delete-7407\";i:8645;s:11:\"delete-7408\";i:8646;s:11:\"delete-7409\";i:8647;s:11:\"delete-7410\";i:8648;s:11:\"delete-7411\";i:8649;s:11:\"delete-7412\";i:8650;s:11:\"delete-7413\";i:8651;s:11:\"delete-7414\";i:8652;s:11:\"delete-7415\";i:8653;s:11:\"delete-7416\";i:8654;s:11:\"delete-7417\";i:8655;s:11:\"delete-7418\";i:8656;s:11:\"delete-7419\";i:8657;s:11:\"delete-7420\";i:8658;s:11:\"delete-7421\";i:8659;s:11:\"delete-7422\";i:8660;s:11:\"delete-7423\";i:8661;s:11:\"delete-7424\";i:8662;s:11:\"delete-7425\";i:8663;s:11:\"delete-7426\";i:8664;s:11:\"delete-7427\";i:8665;s:11:\"delete-7428\";i:8666;s:11:\"delete-7429\";i:8667;s:11:\"delete-7430\";i:8668;s:11:\"delete-7431\";i:8669;s:11:\"delete-7432\";i:8670;s:11:\"delete-7433\";i:8671;s:11:\"delete-7434\";i:8672;s:11:\"delete-7435\";i:8673;s:11:\"delete-7436\";i:8674;s:11:\"delete-7437\";i:8675;s:11:\"delete-7438\";i:8676;s:11:\"delete-7439\";i:8677;s:11:\"delete-7440\";i:8678;s:11:\"delete-7441\";i:8679;s:11:\"delete-7442\";i:8680;s:11:\"delete-7443\";i:8681;s:11:\"delete-7444\";i:8682;s:11:\"delete-7445\";i:8683;s:11:\"delete-7446\";i:8684;s:11:\"delete-7447\";i:8685;s:11:\"delete-7448\";i:8686;s:11:\"delete-7449\";i:8687;s:11:\"delete-7450\";i:8688;s:11:\"delete-7451\";i:8689;s:11:\"delete-7452\";i:8690;s:11:\"delete-7453\";i:8691;s:11:\"delete-7454\";i:8692;s:11:\"delete-7455\";i:8693;s:11:\"delete-7456\";i:8694;s:11:\"delete-7457\";i:8695;s:11:\"delete-7458\";i:8696;s:11:\"delete-7459\";i:8697;s:11:\"delete-7460\";i:8698;s:11:\"delete-7461\";i:8699;s:11:\"delete-7462\";i:8700;s:11:\"delete-7463\";i:8701;s:11:\"delete-7464\";i:8702;s:11:\"delete-7465\";i:8703;s:11:\"delete-7466\";i:8704;s:11:\"delete-7467\";i:8705;s:11:\"delete-7468\";i:8706;s:11:\"delete-7469\";i:8707;s:11:\"delete-7470\";i:8708;s:11:\"delete-7471\";i:8709;s:11:\"delete-7472\";i:8710;s:11:\"delete-7473\";i:8711;s:11:\"delete-7474\";i:8712;s:11:\"delete-7475\";i:8713;s:11:\"delete-7476\";i:8714;s:11:\"delete-7477\";i:8715;s:11:\"delete-7478\";i:8716;s:11:\"delete-7479\";i:8717;s:11:\"delete-7480\";i:8718;s:11:\"delete-7481\";i:8719;s:11:\"delete-7482\";i:8720;s:11:\"delete-7483\";i:8721;s:11:\"delete-7484\";i:8722;s:11:\"delete-7485\";i:8723;s:11:\"delete-7486\";i:8724;s:11:\"delete-7487\";i:8725;s:11:\"delete-7488\";i:8726;s:11:\"delete-7489\";i:8727;s:11:\"delete-7490\";i:8728;s:11:\"delete-7491\";i:8729;s:11:\"delete-7492\";i:8730;s:11:\"delete-7493\";i:8731;s:11:\"delete-7494\";i:8732;s:11:\"delete-7495\";i:8733;s:11:\"delete-7496\";i:8734;s:11:\"delete-7497\";i:8735;s:11:\"delete-7498\";i:8736;s:11:\"delete-7499\";i:8737;s:11:\"delete-7500\";i:8738;s:11:\"delete-7501\";i:8739;s:11:\"delete-7502\";i:8740;s:11:\"delete-7503\";i:8741;s:11:\"delete-7504\";i:8742;s:11:\"delete-7505\";i:8743;s:11:\"delete-7506\";i:8744;s:11:\"delete-7507\";i:8745;s:11:\"delete-7508\";i:8746;s:11:\"delete-7509\";i:8747;s:11:\"delete-7510\";i:8748;s:11:\"delete-7511\";i:8749;s:11:\"delete-7512\";i:8750;s:11:\"delete-7513\";i:8751;s:11:\"delete-7514\";i:8752;s:11:\"delete-7515\";i:8753;s:11:\"delete-7516\";i:8754;s:11:\"delete-7517\";i:8755;s:11:\"delete-7518\";i:8756;s:11:\"delete-7519\";i:8757;s:11:\"delete-7520\";i:8758;s:11:\"delete-7521\";i:8759;s:11:\"delete-7522\";i:8760;s:11:\"delete-7523\";i:8761;s:11:\"delete-7524\";i:8762;s:11:\"delete-7525\";i:8763;s:11:\"delete-7526\";i:8764;s:11:\"delete-7527\";i:8765;s:11:\"delete-7528\";i:8766;s:11:\"delete-7529\";i:8767;s:11:\"delete-7530\";i:8768;s:11:\"delete-7531\";i:8769;s:11:\"delete-7532\";i:8770;s:11:\"delete-7533\";i:8771;s:11:\"delete-7534\";i:8772;s:11:\"delete-7535\";i:8773;s:11:\"delete-7536\";i:8774;s:11:\"delete-7537\";i:8775;s:11:\"delete-7538\";i:8776;s:11:\"delete-7539\";i:8777;s:11:\"delete-7540\";i:8778;s:11:\"delete-7541\";i:8779;s:11:\"delete-7542\";i:8780;s:11:\"delete-7543\";i:8781;s:11:\"delete-7544\";i:8782;s:11:\"delete-7545\";i:8783;s:11:\"delete-7546\";i:8784;s:11:\"delete-7547\";i:8785;s:11:\"delete-7548\";i:8786;s:11:\"delete-7549\";i:8787;s:11:\"delete-7550\";i:8788;s:11:\"delete-7551\";i:8789;s:11:\"delete-7552\";i:8790;s:11:\"delete-7553\";i:8791;s:11:\"delete-7554\";i:8792;s:11:\"delete-7555\";i:8793;s:11:\"delete-7556\";i:8794;s:11:\"delete-7557\";i:8795;s:11:\"delete-7558\";i:8796;s:11:\"delete-7559\";i:8797;s:11:\"delete-7560\";i:8798;s:11:\"delete-7561\";i:8799;s:11:\"delete-7562\";i:8800;s:11:\"delete-7563\";i:8801;s:11:\"delete-7564\";i:8802;s:11:\"delete-7565\";i:8803;s:11:\"delete-7566\";i:8804;s:11:\"delete-7567\";i:8805;s:11:\"delete-7568\";i:8806;s:11:\"delete-7569\";i:8807;s:11:\"delete-7570\";i:8808;s:11:\"delete-7571\";i:8809;s:11:\"delete-7572\";i:8810;s:11:\"delete-7573\";i:8811;s:11:\"delete-7574\";i:8812;s:11:\"delete-7575\";i:8813;s:11:\"delete-7576\";i:8814;s:11:\"delete-7577\";i:8815;s:11:\"delete-7578\";i:8816;s:11:\"delete-7579\";i:8817;s:11:\"delete-7580\";i:8818;s:11:\"delete-7581\";i:8819;s:11:\"delete-7582\";i:8820;s:11:\"delete-7583\";i:8821;s:11:\"delete-7584\";i:8822;s:11:\"delete-7585\";i:8823;s:11:\"delete-7586\";i:8824;s:11:\"delete-7587\";i:8825;s:11:\"delete-7588\";i:8826;s:11:\"delete-7589\";i:8827;s:11:\"delete-7590\";i:8828;s:11:\"delete-7591\";i:8829;s:11:\"delete-7592\";i:8830;s:11:\"delete-7593\";i:8831;s:11:\"delete-7594\";i:8832;s:11:\"delete-7595\";i:8833;s:11:\"delete-7596\";i:8834;s:11:\"delete-7597\";i:8835;s:11:\"delete-7598\";i:8836;s:11:\"delete-7599\";i:8837;s:11:\"delete-7600\";i:8838;s:11:\"delete-7601\";i:8839;s:11:\"delete-7602\";i:8840;s:11:\"delete-7603\";i:8841;s:11:\"delete-7604\";i:8842;s:11:\"delete-7605\";i:8843;s:11:\"delete-7606\";i:8844;s:11:\"delete-7607\";i:8845;s:11:\"delete-7608\";i:8846;s:11:\"delete-7609\";i:8847;s:11:\"delete-7610\";i:8848;s:11:\"delete-7611\";i:8849;s:11:\"delete-7612\";i:8850;s:11:\"delete-7613\";i:8851;s:11:\"delete-7614\";i:8852;s:11:\"delete-7615\";i:8853;s:11:\"delete-7616\";i:8854;s:11:\"delete-7617\";i:8855;s:11:\"delete-7618\";i:8856;s:11:\"delete-7619\";i:8857;s:11:\"delete-7620\";i:8858;s:11:\"delete-7621\";i:8859;s:11:\"delete-7622\";i:8860;s:11:\"delete-7623\";i:8861;s:11:\"delete-7624\";i:8862;s:11:\"delete-7625\";i:8863;s:11:\"delete-7626\";i:8864;s:11:\"delete-7627\";i:8865;s:11:\"delete-7628\";i:8866;s:11:\"delete-7629\";i:8867;s:11:\"delete-7630\";i:8868;s:11:\"delete-7631\";i:8869;s:11:\"delete-7632\";i:8870;s:11:\"delete-7633\";i:8871;s:11:\"delete-7634\";i:8872;s:11:\"delete-7635\";i:8873;s:11:\"delete-7636\";i:8874;s:11:\"delete-7637\";i:8875;s:11:\"delete-7638\";i:8876;s:11:\"delete-7639\";i:8877;s:11:\"delete-7640\";i:8878;s:11:\"delete-7641\";i:8879;s:11:\"delete-7642\";i:8880;s:11:\"delete-7643\";i:8881;s:11:\"delete-7644\";i:8882;s:11:\"delete-7645\";i:8883;s:11:\"delete-7646\";i:8884;s:11:\"delete-7647\";i:8885;s:11:\"delete-7648\";i:8886;s:11:\"delete-7649\";i:8887;s:11:\"delete-7650\";i:8888;s:11:\"delete-7651\";i:8889;s:11:\"delete-7652\";i:8890;s:11:\"delete-7653\";i:8891;s:11:\"delete-7654\";i:8892;s:11:\"delete-7655\";i:8893;s:11:\"delete-7656\";i:8894;s:11:\"delete-7657\";i:8895;s:11:\"delete-7658\";i:8896;s:11:\"delete-7659\";i:8897;s:11:\"delete-7660\";i:8898;s:11:\"delete-7661\";i:8899;s:11:\"delete-7662\";i:8900;s:11:\"delete-7663\";i:8901;s:11:\"delete-7664\";i:8902;s:11:\"delete-7665\";i:8903;s:11:\"delete-7666\";i:8904;s:11:\"delete-7667\";i:8905;s:11:\"delete-7668\";i:8906;s:11:\"delete-7669\";i:8907;s:11:\"delete-7670\";i:8908;s:11:\"delete-7671\";i:8909;s:11:\"delete-7672\";i:8910;s:11:\"delete-7673\";i:8911;s:11:\"delete-7674\";i:8912;s:11:\"delete-7675\";i:8913;s:11:\"delete-7676\";i:8914;s:11:\"delete-7677\";i:8915;s:11:\"delete-7678\";i:8916;s:11:\"delete-7679\";i:8917;s:11:\"delete-7680\";i:8918;s:11:\"delete-7681\";i:8919;s:11:\"delete-7682\";i:8920;s:11:\"delete-7683\";i:8921;s:11:\"delete-7684\";i:8922;s:11:\"delete-7685\";i:8923;s:11:\"delete-7686\";i:8924;s:11:\"delete-7687\";i:8925;s:11:\"delete-7688\";i:8926;s:11:\"delete-7689\";i:8927;s:11:\"delete-7690\";i:8928;s:11:\"delete-7691\";i:8929;s:11:\"delete-7692\";i:8930;s:11:\"delete-7693\";i:8931;s:11:\"delete-7694\";i:8932;s:11:\"delete-7695\";i:8933;s:11:\"delete-7696\";i:8934;s:11:\"delete-7697\";i:8935;s:11:\"delete-7698\";i:8936;s:11:\"delete-7699\";i:8937;s:11:\"delete-7700\";i:8938;s:11:\"delete-7701\";i:8939;s:11:\"delete-7702\";i:8940;s:11:\"delete-7703\";i:8941;s:11:\"delete-7704\";i:8942;s:11:\"delete-7705\";i:8943;s:11:\"delete-7706\";i:8944;s:11:\"delete-7707\";i:8945;s:11:\"delete-7708\";i:8946;s:11:\"delete-7709\";i:8947;s:11:\"delete-7710\";i:8948;s:11:\"delete-7711\";i:8949;s:11:\"delete-7712\";i:8950;s:11:\"delete-7713\";i:8951;s:11:\"delete-7714\";i:8952;s:11:\"delete-7715\";i:8953;s:11:\"delete-7716\";i:8954;s:11:\"delete-7717\";i:8955;s:11:\"delete-7718\";i:8956;s:11:\"delete-7719\";i:8957;s:11:\"delete-7720\";i:8958;s:11:\"delete-7721\";i:8959;s:11:\"delete-7722\";i:8960;s:11:\"delete-7723\";i:8961;s:11:\"delete-7724\";i:8962;s:11:\"delete-7725\";i:8963;s:11:\"delete-7726\";i:8964;s:11:\"delete-7727\";i:8965;s:11:\"delete-7728\";i:8966;s:11:\"delete-7729\";i:8967;s:11:\"delete-7730\";i:8968;s:11:\"delete-7731\";i:8969;s:11:\"delete-7732\";i:8970;s:11:\"delete-7733\";i:8971;s:11:\"delete-7734\";i:8972;s:11:\"delete-7735\";i:8973;s:11:\"delete-7736\";i:8974;s:11:\"delete-7737\";i:8975;s:11:\"delete-7738\";i:8976;s:11:\"delete-7739\";i:8977;s:11:\"delete-7740\";i:8978;s:11:\"delete-7741\";i:8979;s:11:\"delete-7742\";i:8980;s:11:\"delete-7743\";i:8981;s:11:\"delete-7744\";i:8982;s:11:\"delete-7745\";i:8983;s:11:\"delete-7746\";i:8984;s:11:\"delete-7747\";i:8985;s:11:\"delete-7748\";i:8986;s:11:\"delete-7749\";i:8987;s:11:\"delete-7750\";i:8988;s:11:\"delete-7751\";i:8989;s:11:\"delete-7752\";i:8990;s:11:\"delete-7753\";i:8991;s:11:\"delete-7754\";i:8992;s:11:\"delete-7755\";i:8993;s:11:\"delete-7756\";i:8994;s:11:\"delete-7757\";i:8995;s:11:\"delete-7758\";i:8996;s:11:\"delete-7759\";i:8997;s:11:\"delete-7760\";i:8998;s:11:\"delete-7761\";i:8999;s:11:\"delete-7762\";i:9000;s:11:\"delete-7763\";i:9001;s:11:\"delete-7764\";i:9002;s:11:\"delete-7765\";i:9003;s:11:\"delete-7766\";i:9004;s:11:\"delete-7767\";i:9005;s:11:\"delete-7768\";i:9006;s:11:\"delete-7769\";i:9007;s:11:\"delete-7770\";i:9008;s:11:\"delete-7771\";i:9009;s:11:\"delete-7772\";i:9010;s:11:\"delete-7773\";i:9011;s:11:\"delete-7774\";i:9012;s:11:\"delete-7775\";i:9013;s:11:\"delete-7776\";i:9014;s:11:\"delete-7777\";i:9015;s:11:\"delete-7778\";i:9016;s:11:\"delete-7779\";i:9017;s:11:\"delete-7780\";i:9018;s:11:\"delete-7781\";i:9019;s:11:\"delete-7782\";i:9020;s:11:\"delete-7783\";i:9021;s:11:\"delete-7784\";i:9022;s:11:\"delete-7785\";i:9023;s:11:\"delete-7786\";i:9024;s:11:\"delete-7787\";i:9025;s:11:\"delete-7788\";i:9026;s:11:\"delete-7789\";i:9027;s:11:\"delete-7790\";i:9028;s:11:\"delete-7791\";i:9029;s:11:\"delete-7792\";i:9030;s:11:\"delete-7793\";i:9031;s:11:\"delete-7794\";i:9032;s:11:\"delete-7795\";i:9033;s:11:\"delete-7796\";i:9034;s:11:\"delete-7797\";i:9035;s:11:\"delete-7798\";i:9036;s:11:\"delete-7799\";i:9037;s:11:\"delete-7800\";i:9038;s:11:\"delete-7801\";i:9039;s:11:\"delete-7802\";i:9040;s:11:\"delete-7803\";i:9041;s:11:\"delete-7804\";i:9042;s:11:\"delete-7805\";i:9043;s:11:\"delete-7806\";i:9044;s:11:\"delete-7807\";i:9045;s:11:\"delete-7808\";i:9046;s:11:\"delete-7809\";i:9047;s:11:\"delete-7810\";i:9048;s:11:\"delete-7811\";i:9049;s:11:\"delete-7812\";i:9050;s:11:\"delete-7813\";i:9051;s:11:\"delete-7814\";i:9052;s:11:\"delete-7815\";i:9053;s:11:\"delete-7816\";i:9054;s:11:\"delete-7817\";i:9055;s:11:\"delete-7818\";i:9056;s:11:\"delete-7819\";i:9057;s:11:\"delete-7820\";i:9058;s:11:\"delete-7821\";i:9059;s:11:\"delete-7822\";i:9060;s:11:\"delete-7823\";i:9061;s:11:\"delete-7824\";i:9062;s:11:\"delete-7825\";i:9063;s:11:\"delete-7826\";i:9064;s:11:\"delete-7827\";i:9065;s:11:\"delete-7828\";i:9066;s:11:\"delete-7829\";i:9067;s:11:\"delete-7830\";i:9068;s:11:\"delete-7831\";i:9069;s:11:\"delete-7832\";i:9070;s:11:\"delete-7833\";i:9071;s:11:\"delete-7834\";i:9072;s:11:\"delete-7835\";i:9073;s:11:\"delete-7836\";i:9074;s:11:\"delete-7837\";i:9075;s:11:\"delete-7838\";i:9076;s:11:\"delete-7839\";i:9077;s:11:\"delete-7840\";i:9078;s:11:\"delete-7841\";i:9079;s:11:\"delete-7842\";i:9080;s:11:\"delete-7843\";i:9081;s:11:\"delete-7844\";i:9082;s:11:\"delete-7845\";i:9083;s:11:\"delete-7846\";i:9084;s:11:\"delete-7847\";i:9085;s:11:\"delete-7848\";i:9086;s:11:\"delete-7849\";i:9087;s:11:\"delete-7850\";i:9088;s:11:\"delete-7851\";i:9089;s:11:\"delete-7852\";i:9090;s:11:\"delete-7853\";i:9091;s:11:\"delete-7854\";i:9092;s:11:\"delete-7855\";i:9093;s:11:\"delete-7856\";i:9094;s:11:\"delete-7857\";i:9095;s:11:\"delete-7858\";i:9096;s:11:\"delete-7859\";i:9097;s:11:\"delete-7860\";i:9098;s:11:\"delete-7861\";i:9099;s:11:\"delete-7862\";i:9100;s:11:\"delete-7863\";i:9101;s:11:\"delete-7864\";i:9102;s:11:\"delete-7865\";i:9103;s:11:\"delete-7866\";i:9104;s:11:\"delete-7867\";i:9105;s:11:\"delete-7868\";i:9106;s:11:\"delete-7869\";i:9107;s:11:\"delete-7870\";i:9108;s:11:\"delete-7871\";i:9109;s:11:\"delete-7872\";i:9110;s:11:\"delete-7873\";i:9111;s:11:\"delete-7874\";i:9112;s:11:\"delete-7875\";i:9113;s:11:\"delete-7876\";i:9114;s:11:\"delete-7877\";i:9115;s:11:\"delete-7878\";i:9116;s:11:\"delete-7879\";i:9117;s:11:\"delete-7880\";i:9118;s:11:\"delete-7881\";i:9119;s:11:\"delete-7882\";i:9120;s:11:\"delete-7883\";i:9121;s:11:\"delete-7884\";i:9122;s:11:\"delete-7885\";i:9123;s:11:\"delete-7886\";i:9124;s:11:\"delete-7887\";i:9125;s:11:\"delete-7888\";i:9126;s:11:\"delete-7889\";i:9127;s:11:\"delete-7890\";i:9128;s:11:\"delete-7891\";i:9129;s:11:\"delete-7892\";i:9130;s:11:\"delete-7893\";i:9131;s:11:\"delete-7894\";i:9132;s:11:\"delete-7895\";i:9133;s:11:\"delete-7896\";i:9134;s:11:\"delete-7897\";i:9135;s:11:\"delete-7898\";i:9136;s:11:\"delete-7899\";i:9137;s:11:\"delete-7900\";i:9138;s:11:\"delete-7901\";i:9139;s:11:\"delete-7902\";i:9140;s:11:\"delete-7903\";i:9141;s:11:\"delete-7904\";i:9142;s:11:\"delete-7905\";i:9143;s:11:\"delete-7906\";i:9144;s:11:\"delete-7907\";i:9145;s:11:\"delete-7908\";i:9146;s:11:\"delete-7909\";i:9147;s:11:\"delete-7910\";i:9148;s:11:\"delete-7911\";i:9149;s:11:\"delete-7912\";i:9150;s:11:\"delete-7913\";i:9151;s:11:\"delete-7914\";i:9152;s:11:\"delete-7915\";i:9153;s:11:\"delete-7916\";i:9154;s:11:\"delete-7917\";i:9155;s:11:\"delete-7918\";i:9156;s:11:\"delete-7919\";i:9157;s:11:\"delete-7920\";i:9158;s:11:\"delete-7921\";i:9159;s:11:\"delete-7922\";i:9160;s:11:\"delete-7923\";i:9161;s:11:\"delete-7924\";i:9162;s:11:\"delete-7925\";i:9163;s:11:\"delete-7926\";i:9164;s:11:\"delete-7927\";i:9165;s:11:\"delete-7928\";i:9166;s:11:\"delete-7929\";i:9167;s:11:\"delete-7930\";i:9168;s:11:\"delete-7931\";i:9169;s:11:\"delete-7932\";i:9170;s:11:\"delete-7933\";i:9171;s:11:\"delete-7934\";i:9172;s:11:\"delete-7935\";i:9173;s:11:\"delete-7936\";i:9174;s:11:\"delete-7937\";i:9175;s:11:\"delete-7938\";i:9176;s:11:\"delete-7939\";i:9177;s:11:\"delete-7940\";i:9178;s:11:\"delete-7941\";i:9179;s:11:\"delete-7942\";i:9180;s:11:\"delete-7943\";i:9181;s:11:\"delete-7944\";i:9182;s:11:\"delete-7945\";i:9183;s:11:\"delete-7946\";i:9184;s:11:\"delete-7947\";i:9185;s:11:\"delete-7948\";i:9186;s:11:\"delete-7949\";i:9187;s:11:\"delete-7950\";i:9188;s:11:\"delete-7951\";i:9189;s:11:\"delete-7952\";i:9190;s:11:\"delete-7953\";i:9191;s:11:\"delete-7954\";i:9192;s:11:\"delete-7955\";i:9193;s:11:\"delete-7956\";i:9194;s:11:\"delete-7957\";i:9195;s:11:\"delete-7958\";i:9196;s:11:\"delete-7959\";i:9197;s:11:\"delete-7960\";i:9198;s:11:\"delete-7961\";i:9199;s:11:\"delete-7962\";i:9200;s:11:\"delete-7963\";i:9201;s:11:\"delete-7964\";i:9202;s:11:\"delete-7965\";i:9203;s:11:\"delete-7966\";i:9204;s:11:\"delete-7967\";i:9205;s:11:\"delete-7968\";i:9206;s:11:\"delete-7969\";i:9207;s:11:\"delete-7970\";i:9208;s:11:\"delete-7971\";i:9209;s:11:\"delete-7972\";i:9210;s:11:\"delete-7973\";i:9211;s:11:\"delete-7974\";i:9212;s:11:\"delete-7975\";i:9213;s:11:\"delete-7976\";i:9214;s:11:\"delete-7977\";i:9215;s:11:\"delete-7978\";i:9216;s:11:\"delete-7979\";i:9217;s:11:\"delete-7980\";i:9218;s:11:\"delete-7981\";i:9219;s:11:\"delete-7982\";i:9220;s:11:\"delete-7983\";i:9221;s:11:\"delete-7984\";i:9222;s:11:\"delete-7985\";i:9223;s:11:\"delete-7986\";i:9224;s:11:\"delete-7987\";i:9225;s:11:\"delete-7988\";i:9226;s:11:\"delete-7989\";i:9227;s:11:\"delete-7990\";i:9228;s:11:\"delete-7991\";i:9229;s:11:\"delete-7992\";i:9230;s:11:\"delete-7993\";i:9231;s:11:\"delete-7994\";i:9232;s:11:\"delete-7995\";i:9233;s:11:\"delete-7996\";i:9234;s:11:\"delete-7997\";i:9235;s:11:\"delete-7998\";i:9236;s:11:\"delete-7999\";i:9237;s:11:\"delete-8000\";i:9238;s:11:\"delete-8001\";i:9239;s:11:\"delete-8002\";i:9240;s:11:\"delete-8003\";i:9241;s:11:\"delete-8004\";i:9242;s:11:\"delete-8005\";i:9243;s:11:\"delete-8006\";i:9244;s:11:\"delete-8007\";i:9245;s:11:\"delete-8008\";i:9246;s:11:\"delete-8009\";i:9247;s:11:\"delete-8010\";i:9248;s:11:\"delete-8011\";i:9249;s:11:\"delete-8012\";i:9250;s:11:\"delete-8013\";i:9251;s:11:\"delete-8014\";i:9252;s:11:\"delete-8015\";i:9253;s:11:\"delete-8016\";i:9254;s:11:\"delete-8017\";i:9255;s:11:\"delete-8018\";i:9256;s:11:\"delete-8019\";i:9257;s:11:\"delete-8020\";i:9258;s:11:\"delete-8021\";i:9259;s:11:\"delete-8022\";i:9260;s:11:\"delete-8023\";i:9261;s:11:\"delete-8024\";i:9262;s:11:\"delete-8025\";i:9263;s:11:\"delete-8026\";i:9264;s:11:\"delete-8027\";i:9265;s:11:\"delete-8028\";i:9266;s:11:\"delete-8029\";i:9267;s:11:\"delete-8030\";i:9268;s:11:\"delete-8031\";i:9269;s:11:\"delete-8032\";i:9270;s:11:\"delete-8033\";i:9271;s:11:\"delete-8034\";i:9272;s:11:\"delete-8035\";i:9273;s:11:\"delete-8036\";i:9274;s:11:\"delete-8037\";i:9275;s:11:\"delete-8038\";i:9276;s:11:\"delete-8039\";i:9277;s:11:\"delete-8040\";i:9278;s:11:\"delete-8041\";i:9279;s:11:\"delete-8042\";i:9280;s:11:\"delete-8043\";i:9281;s:11:\"delete-8044\";i:9282;s:11:\"delete-8045\";i:9283;s:11:\"delete-8046\";i:9284;s:11:\"delete-8047\";i:9285;s:11:\"delete-8048\";i:9286;s:11:\"delete-8049\";i:9287;s:11:\"delete-8050\";i:9288;s:11:\"delete-8051\";i:9289;s:11:\"delete-8052\";i:9290;s:11:\"delete-8053\";i:9291;s:11:\"delete-8054\";i:9292;s:11:\"delete-8055\";i:9293;s:11:\"delete-8056\";i:9294;s:11:\"delete-8057\";i:9295;s:11:\"delete-8058\";i:9296;s:11:\"delete-8059\";i:9297;s:11:\"delete-8060\";i:9298;s:11:\"delete-8061\";i:9299;s:11:\"delete-8062\";i:9300;s:11:\"delete-8063\";i:9301;s:11:\"delete-8064\";i:9302;s:11:\"delete-8065\";i:9303;s:11:\"delete-8066\";i:9304;s:11:\"delete-8067\";i:9305;s:11:\"delete-8068\";i:9306;s:11:\"delete-8069\";i:9307;s:11:\"delete-8070\";i:9308;s:11:\"delete-8071\";i:9309;s:11:\"delete-8072\";i:9310;s:11:\"delete-8073\";i:9311;s:11:\"delete-8074\";i:9312;s:11:\"delete-8075\";i:9313;s:11:\"delete-8076\";i:9314;s:11:\"delete-8077\";i:9315;s:11:\"delete-8078\";i:9316;s:11:\"delete-8079\";i:9317;s:11:\"delete-8080\";i:9318;s:11:\"delete-8081\";i:9319;s:11:\"delete-8082\";i:9320;s:11:\"delete-8083\";i:9321;s:11:\"delete-8084\";i:9322;s:11:\"delete-8085\";i:9323;s:11:\"delete-8086\";i:9324;s:11:\"delete-8087\";i:9325;s:11:\"delete-8088\";i:9326;s:11:\"delete-8089\";i:9327;s:11:\"delete-8090\";i:9328;s:11:\"delete-8091\";i:9329;s:11:\"delete-8092\";i:9330;s:11:\"delete-8093\";i:9331;s:11:\"delete-8094\";i:9332;s:11:\"delete-8095\";i:9333;s:11:\"delete-8096\";i:9334;s:11:\"delete-8097\";i:9335;s:11:\"delete-8098\";i:9336;s:11:\"delete-8099\";i:9337;s:11:\"delete-8100\";i:9338;s:11:\"delete-8101\";i:9339;s:11:\"delete-8102\";i:9340;s:11:\"delete-8103\";i:9341;s:11:\"delete-8104\";i:9342;s:11:\"delete-8105\";i:9343;s:11:\"delete-8106\";i:9344;s:11:\"delete-8107\";i:9345;s:11:\"delete-8108\";i:9346;s:11:\"delete-8109\";i:9347;s:11:\"delete-8110\";i:9348;s:11:\"delete-8111\";i:9349;s:11:\"delete-8112\";i:9350;s:11:\"delete-8113\";i:9351;s:11:\"delete-8114\";i:9352;s:11:\"delete-8115\";i:9353;s:11:\"delete-8116\";i:9354;s:11:\"delete-8117\";i:9355;s:11:\"delete-8118\";i:9356;s:11:\"delete-8119\";i:9357;s:11:\"delete-8120\";i:9358;s:11:\"delete-8121\";i:9359;s:11:\"delete-8122\";i:9360;s:11:\"delete-8123\";i:9361;s:11:\"delete-8124\";i:9362;s:11:\"delete-8125\";i:9363;s:11:\"delete-8126\";i:9364;s:11:\"delete-8127\";i:9365;s:11:\"delete-8128\";i:9366;s:11:\"delete-8129\";i:9367;s:11:\"delete-8130\";i:9368;s:11:\"delete-8131\";i:9369;s:11:\"delete-8132\";i:9370;s:11:\"delete-8133\";i:9371;s:11:\"delete-8134\";i:9372;s:11:\"delete-8135\";i:9373;s:11:\"delete-8136\";i:9374;s:11:\"delete-8137\";i:9375;s:11:\"delete-8138\";i:9376;s:11:\"delete-8139\";i:9377;s:11:\"delete-8140\";i:9378;s:11:\"delete-8141\";i:9379;s:11:\"delete-8142\";i:9380;s:11:\"delete-8143\";i:9381;s:11:\"delete-8144\";i:9382;s:11:\"delete-8145\";i:9383;s:11:\"delete-8146\";i:9384;s:11:\"delete-8147\";i:9385;s:11:\"delete-8148\";i:9386;s:11:\"delete-8149\";i:9387;s:11:\"delete-8150\";i:9388;s:11:\"delete-8151\";i:9389;s:11:\"delete-8152\";i:9390;s:11:\"delete-8153\";i:9391;s:11:\"delete-8154\";i:9392;s:11:\"delete-8155\";i:9393;s:11:\"delete-8156\";i:9394;s:11:\"delete-8157\";i:9395;s:11:\"delete-8158\";i:9396;s:11:\"delete-8159\";i:9397;s:11:\"delete-8160\";i:9398;s:11:\"delete-8161\";i:9399;s:11:\"delete-8162\";i:9400;s:11:\"delete-8163\";i:9401;s:11:\"delete-8164\";i:9402;s:11:\"delete-8165\";i:9403;s:11:\"delete-8166\";i:9404;s:11:\"delete-8167\";i:9405;s:11:\"delete-8168\";i:9406;s:11:\"delete-8169\";i:9407;s:11:\"delete-8170\";i:9408;s:11:\"delete-8171\";i:9409;s:11:\"delete-8172\";i:9410;s:11:\"delete-8173\";i:9411;s:11:\"delete-8174\";i:9412;s:11:\"delete-8175\";i:9413;s:11:\"delete-8176\";i:9414;s:11:\"delete-8177\";i:9415;s:11:\"delete-8178\";i:9416;s:11:\"delete-8179\";i:9417;s:11:\"delete-8180\";i:9418;s:11:\"delete-8181\";i:9419;s:11:\"delete-8182\";i:9420;s:11:\"delete-8183\";i:9421;s:11:\"delete-8184\";i:9422;s:11:\"delete-8185\";i:9423;s:11:\"delete-8186\";i:9424;s:11:\"delete-8187\";i:9425;s:11:\"delete-8188\";i:9426;s:11:\"delete-8189\";i:9427;s:11:\"delete-8190\";i:9428;s:11:\"delete-8191\";i:9429;s:11:\"delete-8192\";i:9430;s:11:\"delete-8193\";i:9431;s:11:\"delete-8194\";i:9432;s:11:\"delete-8195\";i:9433;s:11:\"delete-8196\";i:9434;s:11:\"delete-8197\";i:9435;s:11:\"delete-8198\";i:9436;s:11:\"delete-8199\";i:9437;s:11:\"delete-8200\";i:9438;s:11:\"delete-8201\";i:9439;s:11:\"delete-8202\";i:9440;s:11:\"delete-8203\";i:9441;s:11:\"delete-8204\";i:9442;s:11:\"delete-8205\";i:9443;s:11:\"delete-8206\";i:9444;s:11:\"delete-8207\";i:9445;s:11:\"delete-8208\";i:9446;s:11:\"delete-8209\";i:9447;s:11:\"delete-8210\";i:9448;s:11:\"delete-8211\";i:9449;s:11:\"delete-8212\";i:9450;s:11:\"delete-8213\";i:9451;s:11:\"delete-8214\";i:9452;s:11:\"delete-8215\";i:9453;s:11:\"delete-8216\";i:9454;s:11:\"delete-8217\";i:9455;s:11:\"delete-8218\";i:9456;s:11:\"delete-8219\";i:9457;s:11:\"delete-8220\";i:9458;s:11:\"delete-8221\";i:9459;s:11:\"delete-8222\";i:9460;s:11:\"delete-8223\";i:9461;s:11:\"delete-8224\";i:9462;s:11:\"delete-8225\";i:9463;s:11:\"delete-8226\";i:9464;s:11:\"delete-8227\";i:9465;s:11:\"delete-8228\";i:9466;s:11:\"delete-8229\";i:9467;s:11:\"delete-8230\";i:9468;s:11:\"delete-8231\";i:9469;s:11:\"delete-8232\";i:9470;s:11:\"delete-8233\";i:9471;s:11:\"delete-8234\";i:9472;s:11:\"delete-8235\";i:9473;s:11:\"delete-8236\";i:9474;s:11:\"delete-8237\";i:9475;s:11:\"delete-8238\";i:9476;s:11:\"delete-8239\";i:9477;s:11:\"delete-8240\";i:9478;s:11:\"delete-8241\";i:9479;s:11:\"delete-8242\";i:9480;s:11:\"delete-8243\";i:9481;s:11:\"delete-8244\";i:9482;s:11:\"delete-8245\";i:9483;s:11:\"delete-8246\";i:9484;s:11:\"delete-8247\";i:9485;s:11:\"delete-8248\";i:9486;s:11:\"delete-8249\";i:9487;s:11:\"delete-8250\";i:9488;s:11:\"delete-8251\";i:9489;s:11:\"delete-8252\";i:9490;s:11:\"delete-8253\";i:9491;s:11:\"delete-8254\";i:9492;s:11:\"delete-8255\";i:9493;s:11:\"delete-8256\";i:9494;s:11:\"delete-8257\";i:9495;s:11:\"delete-8258\";i:9496;s:11:\"delete-8259\";i:9497;s:11:\"delete-8260\";i:9498;s:11:\"delete-8261\";i:9499;s:11:\"delete-8262\";i:9500;s:11:\"delete-8263\";i:9501;s:11:\"delete-8264\";i:9502;s:11:\"delete-8265\";i:9503;s:11:\"delete-8266\";i:9504;s:11:\"delete-8267\";i:9505;s:11:\"delete-8268\";i:9506;s:11:\"delete-8269\";i:9507;s:11:\"delete-8270\";i:9508;s:11:\"delete-8271\";i:9509;s:11:\"delete-8272\";i:9510;s:11:\"delete-8273\";i:9511;s:11:\"delete-8274\";i:9512;s:11:\"delete-8275\";i:9513;s:11:\"delete-8276\";i:9514;s:11:\"delete-8277\";i:9515;s:11:\"delete-8278\";i:9516;s:11:\"delete-8279\";i:9517;s:11:\"delete-8280\";i:9518;s:11:\"delete-8281\";i:9519;s:11:\"delete-8282\";i:9520;s:11:\"delete-8283\";i:9521;s:11:\"delete-8284\";i:9522;s:11:\"delete-8285\";i:9523;s:11:\"delete-8286\";i:9524;s:11:\"delete-8287\";i:9525;s:11:\"delete-8288\";i:9526;s:11:\"delete-8289\";i:9527;s:11:\"delete-8290\";i:9528;s:11:\"delete-8291\";i:9529;s:11:\"delete-8292\";i:9530;s:11:\"delete-8293\";i:9531;s:11:\"delete-8294\";i:9532;s:11:\"delete-8295\";i:9533;s:11:\"delete-8296\";i:9534;s:11:\"delete-8297\";i:9535;s:11:\"delete-8298\";i:9536;s:11:\"delete-8299\";i:9537;s:11:\"delete-8300\";i:9538;s:11:\"delete-8301\";i:9539;s:11:\"delete-8302\";i:9540;s:11:\"delete-8303\";i:9541;s:11:\"delete-8304\";i:9542;s:11:\"delete-8305\";i:9543;s:11:\"delete-8306\";i:9544;s:11:\"delete-8307\";i:9545;s:11:\"delete-8308\";i:9546;s:11:\"delete-8309\";i:9547;s:11:\"delete-8310\";i:9548;s:11:\"delete-8311\";i:9549;s:11:\"delete-8312\";i:9550;s:11:\"delete-8313\";i:9551;s:11:\"delete-8314\";i:9552;s:11:\"delete-8315\";i:9553;s:11:\"delete-8316\";i:9554;s:11:\"delete-8317\";i:9555;s:11:\"delete-8318\";i:9556;s:11:\"delete-8319\";i:9557;s:11:\"delete-8320\";i:9558;s:11:\"delete-8321\";i:9559;s:11:\"delete-8322\";i:9560;s:11:\"delete-8323\";i:9561;s:11:\"delete-8324\";i:9562;s:11:\"delete-8325\";i:9563;s:11:\"delete-8326\";i:9564;s:11:\"delete-8327\";i:9565;s:11:\"delete-8328\";i:9566;s:11:\"delete-8329\";i:9567;s:11:\"delete-8330\";i:9568;s:11:\"delete-8331\";i:9569;s:11:\"delete-8332\";i:9570;s:11:\"delete-8333\";i:9571;s:11:\"delete-8334\";i:9572;s:11:\"delete-8335\";i:9573;s:11:\"delete-8336\";i:9574;s:11:\"delete-8337\";i:9575;s:11:\"delete-8338\";i:9576;s:11:\"delete-8339\";i:9577;s:11:\"delete-8340\";i:9578;s:11:\"delete-8341\";i:9579;s:11:\"delete-8342\";i:9580;s:11:\"delete-8343\";i:9581;s:11:\"delete-8344\";i:9582;s:11:\"delete-8345\";i:9583;s:11:\"delete-8346\";i:9584;s:11:\"delete-8347\";i:9585;s:11:\"delete-8348\";i:9586;s:11:\"delete-8349\";i:9587;s:11:\"delete-8350\";i:9588;s:11:\"delete-8351\";i:9589;s:11:\"delete-8352\";i:9590;s:11:\"delete-8353\";i:9591;s:11:\"delete-8354\";i:9592;s:11:\"delete-8355\";i:9593;s:11:\"delete-8356\";i:9594;s:11:\"delete-8357\";i:9595;s:11:\"delete-8358\";i:9596;s:11:\"delete-8359\";i:9597;s:11:\"delete-8360\";i:9598;s:11:\"delete-8361\";i:9599;s:11:\"delete-8362\";i:9600;s:11:\"delete-8363\";i:9601;s:11:\"delete-8364\";i:9602;s:11:\"delete-8365\";i:9603;s:11:\"delete-8366\";i:9604;s:11:\"delete-8367\";i:9605;s:11:\"delete-8368\";i:9606;s:11:\"delete-8369\";i:9607;s:11:\"delete-8370\";i:9608;s:11:\"delete-8371\";i:9609;s:11:\"delete-8372\";i:9610;s:11:\"delete-8373\";i:9611;s:11:\"delete-8374\";i:9612;s:11:\"delete-8375\";i:9613;s:11:\"delete-8376\";i:9614;s:11:\"delete-8377\";i:9615;s:11:\"delete-8378\";i:9616;s:11:\"delete-8379\";i:9617;s:11:\"delete-8380\";i:9618;s:11:\"delete-8381\";i:9619;s:11:\"delete-8382\";i:9620;s:11:\"delete-8383\";i:9621;s:11:\"delete-8384\";i:9622;s:11:\"delete-8385\";i:9623;s:11:\"delete-8386\";i:9624;s:11:\"delete-8387\";i:9625;s:11:\"delete-8388\";i:9626;s:11:\"delete-8389\";i:9627;s:11:\"delete-8390\";i:9628;s:11:\"delete-8391\";i:9629;s:11:\"delete-8392\";i:9630;s:11:\"delete-8393\";i:9631;s:11:\"delete-8394\";i:9632;s:11:\"delete-8395\";i:9633;s:11:\"delete-8396\";i:9634;s:11:\"delete-8397\";i:9635;s:11:\"delete-8398\";i:9636;s:11:\"delete-8399\";i:9637;s:11:\"delete-8400\";i:9638;s:11:\"delete-8401\";i:9639;s:11:\"delete-8402\";i:9640;s:11:\"delete-8403\";i:9641;s:11:\"delete-8404\";i:9642;s:11:\"delete-8405\";i:9643;s:11:\"delete-8406\";i:9644;s:11:\"delete-8407\";i:9645;s:11:\"delete-8408\";i:9646;s:11:\"delete-8409\";i:9647;s:11:\"delete-8410\";i:9648;s:11:\"delete-8411\";i:9649;s:11:\"delete-8412\";i:9650;s:11:\"delete-8413\";i:9651;s:11:\"delete-8414\";i:9652;s:11:\"delete-8415\";i:9653;s:11:\"delete-8416\";i:9654;s:11:\"delete-8417\";i:9655;s:11:\"delete-8418\";i:9656;s:11:\"delete-8419\";i:9657;s:11:\"delete-8420\";i:9658;s:11:\"delete-8421\";i:9659;s:11:\"delete-8422\";i:9660;s:11:\"delete-8423\";i:9661;s:11:\"delete-8424\";i:9662;s:11:\"delete-8425\";i:9663;s:11:\"delete-8426\";i:9664;s:11:\"delete-8427\";i:9665;s:11:\"delete-8428\";i:9666;s:11:\"delete-8429\";i:9667;s:11:\"delete-8430\";i:9668;s:11:\"delete-8431\";i:9669;s:11:\"delete-8432\";i:9670;s:11:\"delete-8433\";i:9671;s:11:\"delete-8434\";i:9672;s:11:\"delete-8435\";i:9673;s:11:\"delete-8436\";i:9674;s:11:\"delete-8437\";i:9675;s:11:\"delete-8438\";i:9676;s:11:\"delete-8439\";i:9677;s:11:\"delete-8440\";i:9678;s:11:\"delete-8441\";i:9679;s:11:\"delete-8442\";i:9680;s:11:\"delete-8443\";i:9681;s:11:\"delete-8444\";i:9682;s:11:\"delete-8445\";i:9683;s:11:\"delete-8446\";i:9684;s:11:\"delete-8447\";i:9685;s:11:\"delete-8448\";i:9686;s:11:\"delete-8449\";i:9687;s:11:\"delete-8450\";i:9688;s:11:\"delete-8451\";i:9689;s:11:\"delete-8452\";i:9690;s:11:\"delete-8453\";i:9691;s:11:\"delete-8454\";i:9692;s:11:\"delete-8455\";i:9693;s:11:\"delete-8456\";i:9694;s:11:\"delete-8457\";i:9695;s:11:\"delete-8458\";i:9696;s:11:\"delete-8459\";i:9697;s:11:\"delete-8460\";i:9698;s:11:\"delete-8461\";i:9699;s:11:\"delete-8462\";i:9700;s:11:\"delete-8463\";i:9701;s:11:\"delete-8464\";i:9702;s:11:\"delete-8465\";i:9703;s:11:\"delete-8466\";i:9704;s:11:\"delete-8467\";i:9705;s:11:\"delete-8468\";i:9706;s:11:\"delete-8469\";i:9707;s:11:\"delete-8470\";i:9708;s:11:\"delete-8471\";i:9709;s:11:\"delete-8472\";i:9710;s:11:\"delete-8473\";i:9711;s:11:\"delete-8474\";i:9712;s:11:\"delete-8475\";i:9713;s:11:\"delete-8476\";i:9714;s:11:\"delete-8477\";i:9715;s:11:\"delete-8478\";i:9716;s:11:\"delete-8479\";i:9717;s:11:\"delete-8480\";i:9718;s:11:\"delete-8481\";i:9719;s:11:\"delete-8482\";i:9720;s:11:\"delete-8483\";i:9721;s:11:\"delete-8484\";i:9722;s:11:\"delete-8485\";i:9723;s:11:\"delete-8486\";i:9724;s:11:\"delete-8487\";i:9725;s:11:\"delete-8488\";i:9726;s:11:\"delete-8489\";i:9727;s:11:\"delete-8490\";i:9728;s:11:\"delete-8491\";i:9729;s:11:\"delete-8492\";i:9730;s:11:\"delete-8493\";i:9731;s:11:\"delete-8494\";i:9732;s:11:\"delete-8495\";i:9733;s:11:\"delete-8496\";i:9734;s:11:\"delete-8497\";i:9735;s:11:\"delete-8498\";i:9736;s:11:\"delete-8499\";i:9737;s:11:\"delete-8500\";i:9738;s:11:\"delete-8501\";i:9739;s:11:\"delete-8502\";i:9740;s:11:\"delete-8503\";i:9741;s:11:\"delete-8504\";i:9742;s:11:\"delete-8505\";i:9743;s:11:\"delete-8506\";i:9744;s:11:\"delete-8507\";i:9745;s:11:\"delete-8508\";i:9746;s:11:\"delete-8509\";i:9747;s:11:\"delete-8510\";i:9748;s:11:\"delete-8511\";i:9749;s:11:\"delete-8512\";i:9750;s:11:\"delete-8513\";i:9751;s:11:\"delete-8514\";i:9752;s:11:\"delete-8515\";i:9753;s:11:\"delete-8516\";i:9754;s:11:\"delete-8517\";i:9755;s:11:\"delete-8518\";i:9756;s:11:\"delete-8519\";i:9757;s:11:\"delete-8520\";i:9758;s:11:\"delete-8521\";i:9759;s:11:\"delete-8522\";i:9760;s:11:\"delete-8523\";i:9761;s:11:\"delete-8524\";i:9762;s:11:\"delete-8525\";i:9763;s:11:\"delete-8526\";i:9764;s:11:\"delete-8527\";i:9765;s:11:\"delete-8528\";i:9766;s:11:\"delete-8529\";i:9767;s:11:\"delete-8530\";i:9768;s:11:\"delete-8531\";i:9769;s:11:\"delete-8532\";i:9770;s:11:\"delete-8533\";i:9771;s:11:\"delete-8534\";i:9772;s:11:\"delete-8535\";i:9773;s:11:\"delete-8536\";i:9774;s:11:\"delete-8537\";i:9775;s:11:\"delete-8538\";i:9776;s:11:\"delete-8539\";i:9777;s:11:\"delete-8540\";i:9778;s:11:\"delete-8541\";i:9779;s:11:\"delete-8542\";i:9780;s:11:\"delete-8543\";i:9781;s:11:\"delete-8544\";i:9782;s:11:\"delete-8545\";i:9783;s:11:\"delete-8546\";i:9784;s:11:\"delete-8547\";i:9785;s:11:\"delete-8548\";i:9786;s:11:\"delete-8549\";i:9787;s:11:\"delete-8550\";i:9788;s:11:\"delete-8551\";i:9789;s:11:\"delete-8552\";i:9790;s:11:\"delete-8553\";i:9791;s:11:\"delete-8554\";i:9792;s:11:\"delete-8555\";i:9793;s:11:\"delete-8556\";i:9794;s:11:\"delete-8557\";i:9795;s:11:\"delete-8558\";i:9796;s:11:\"delete-8559\";i:9797;s:11:\"delete-8560\";i:9798;s:11:\"delete-8561\";i:9799;s:11:\"delete-8562\";i:9800;s:11:\"delete-8563\";i:9801;s:11:\"delete-8564\";i:9802;s:11:\"delete-8565\";i:9803;s:11:\"delete-8566\";i:9804;s:11:\"delete-8567\";i:9805;s:11:\"delete-8568\";i:9806;s:11:\"delete-8569\";i:9807;s:11:\"delete-8570\";i:9808;s:11:\"delete-8571\";i:9809;s:11:\"delete-8572\";i:9810;s:11:\"delete-8573\";i:9811;s:11:\"delete-8574\";i:9812;s:11:\"delete-8575\";i:9813;s:11:\"delete-8576\";i:9814;s:11:\"delete-8577\";i:9815;s:11:\"delete-8578\";i:9816;s:11:\"delete-8579\";i:9817;s:11:\"delete-8580\";i:9818;s:11:\"delete-8581\";i:9819;s:11:\"delete-8582\";i:9820;s:11:\"delete-8583\";i:9821;s:11:\"delete-8584\";i:9822;s:11:\"delete-8585\";i:9823;s:11:\"delete-8586\";i:9824;s:11:\"delete-8587\";i:9825;s:11:\"delete-8588\";i:9826;s:11:\"delete-8589\";i:9827;s:11:\"delete-8590\";i:9828;s:11:\"delete-8591\";i:9829;s:11:\"delete-8592\";i:9830;s:11:\"delete-8593\";i:9831;s:11:\"delete-8594\";i:9832;s:11:\"delete-8595\";i:9833;s:11:\"delete-8596\";i:9834;s:11:\"delete-8597\";i:9835;s:11:\"delete-8598\";i:9836;s:11:\"delete-8599\";i:9837;s:11:\"delete-8600\";i:9838;s:11:\"delete-8601\";i:9839;s:11:\"delete-8602\";i:9840;s:11:\"delete-8603\";i:9841;s:11:\"delete-8604\";i:9842;s:11:\"delete-8605\";i:9843;s:11:\"delete-8606\";i:9844;s:11:\"delete-8607\";i:9845;s:11:\"delete-8608\";i:9846;s:11:\"delete-8609\";i:9847;s:11:\"delete-8610\";i:9848;s:11:\"delete-8611\";i:9849;s:11:\"delete-8612\";i:9850;s:11:\"delete-8613\";i:9851;s:11:\"delete-8614\";i:9852;s:11:\"delete-8615\";i:9853;s:11:\"delete-8616\";i:9854;s:11:\"delete-8617\";i:9855;s:11:\"delete-8618\";i:9856;s:11:\"delete-8619\";i:9857;s:11:\"delete-8620\";i:9858;s:11:\"delete-8621\";i:9859;s:11:\"delete-8622\";i:9860;s:11:\"delete-8623\";i:9861;s:11:\"delete-8624\";i:9862;s:11:\"delete-8625\";i:9863;s:11:\"delete-8626\";i:9864;s:11:\"delete-8627\";i:9865;s:11:\"delete-8628\";i:9866;s:11:\"delete-8629\";i:9867;s:11:\"delete-8630\";i:9868;s:11:\"delete-8631\";i:9869;s:11:\"delete-8632\";i:9870;s:11:\"delete-8633\";i:9871;s:11:\"delete-8634\";i:9872;s:11:\"delete-8635\";i:9873;s:11:\"delete-8636\";i:9874;s:11:\"delete-8637\";i:9875;s:11:\"delete-8638\";i:9876;s:11:\"delete-8639\";i:9877;s:11:\"delete-8640\";i:9878;s:11:\"delete-8641\";i:9879;s:11:\"delete-8642\";i:9880;s:11:\"delete-8643\";i:9881;s:11:\"delete-8644\";i:9882;s:11:\"delete-8645\";i:9883;s:11:\"delete-8646\";i:9884;s:11:\"delete-8647\";i:9885;s:11:\"delete-8648\";i:9886;s:11:\"delete-8649\";i:9887;s:11:\"delete-8650\";i:9888;s:11:\"delete-8651\";i:9889;s:11:\"delete-8652\";i:9890;s:11:\"delete-8653\";i:9891;s:11:\"delete-8654\";i:9892;s:11:\"delete-8655\";i:9893;s:11:\"delete-8656\";i:9894;s:11:\"delete-8657\";i:9895;s:11:\"delete-8658\";i:9896;s:11:\"delete-8659\";i:9897;s:11:\"delete-8660\";i:9898;s:11:\"delete-8661\";i:9899;s:11:\"delete-8662\";i:9900;s:11:\"delete-8663\";i:9901;s:11:\"delete-8664\";i:9902;s:11:\"delete-8665\";i:9903;s:11:\"delete-8666\";i:9904;s:11:\"delete-8667\";i:9905;s:11:\"delete-8668\";i:9906;s:11:\"delete-8669\";i:9907;s:11:\"delete-8670\";i:9908;s:11:\"delete-8671\";i:9909;s:11:\"delete-8672\";i:9910;s:11:\"delete-8673\";i:9911;s:11:\"delete-8674\";i:9912;s:11:\"delete-8675\";i:9913;s:11:\"delete-8676\";i:9914;s:11:\"delete-8677\";i:9915;s:11:\"delete-8678\";i:9916;s:11:\"delete-8679\";i:9917;s:11:\"delete-8680\";i:9918;s:11:\"delete-8681\";i:9919;s:11:\"delete-8682\";i:9920;s:11:\"delete-8683\";i:9921;s:11:\"delete-8684\";i:9922;s:11:\"delete-8685\";i:9923;s:11:\"delete-8686\";i:9924;s:11:\"delete-8687\";i:9925;s:11:\"delete-8688\";i:9926;s:11:\"delete-8689\";i:9927;s:11:\"delete-8690\";i:9928;s:11:\"delete-8691\";i:9929;s:11:\"delete-8692\";i:9930;s:11:\"delete-8693\";i:9931;s:11:\"delete-8694\";i:9932;s:11:\"delete-8695\";i:9933;s:11:\"delete-8696\";i:9934;s:11:\"delete-8697\";i:9935;s:11:\"delete-8698\";i:9936;s:11:\"delete-8699\";i:9937;s:11:\"delete-8700\";i:9938;s:11:\"delete-8701\";i:9939;s:11:\"delete-8702\";i:9940;s:11:\"delete-8703\";i:9941;s:11:\"delete-8704\";i:9942;s:11:\"delete-8705\";i:9943;s:11:\"delete-8706\";i:9944;s:11:\"delete-8707\";i:9945;s:11:\"delete-8708\";i:9946;s:11:\"delete-8709\";i:9947;s:11:\"delete-8710\";i:9948;s:11:\"delete-8711\";i:9949;s:11:\"delete-8712\";i:9950;s:11:\"delete-8713\";i:9951;s:11:\"delete-8714\";i:9952;s:11:\"delete-8715\";i:9953;s:11:\"delete-8716\";i:9954;s:11:\"delete-8717\";i:9955;s:11:\"delete-8718\";i:9956;s:11:\"delete-8719\";i:9957;s:11:\"delete-8720\";i:9958;s:11:\"delete-8721\";i:9959;s:11:\"delete-8722\";i:9960;s:11:\"delete-8723\";i:9961;s:11:\"delete-8724\";i:9962;s:11:\"delete-8725\";i:9963;s:11:\"delete-8726\";i:9964;s:11:\"delete-8727\";i:9965;s:11:\"delete-8728\";i:9966;s:11:\"delete-8729\";i:9967;s:11:\"delete-8730\";i:9968;s:11:\"delete-8731\";i:9969;s:11:\"delete-8732\";i:9970;s:11:\"delete-8733\";i:9971;s:11:\"delete-8734\";i:9972;s:11:\"delete-8735\";i:9973;s:11:\"delete-8736\";i:9974;s:11:\"delete-8737\";i:9975;s:11:\"delete-8738\";i:9976;s:11:\"delete-8739\";i:9977;s:11:\"delete-8740\";i:9978;s:11:\"delete-8741\";i:9979;s:11:\"delete-8742\";i:9980;s:11:\"delete-8743\";i:9981;s:11:\"delete-8744\";i:9982;s:11:\"delete-8745\";i:9983;s:11:\"delete-8746\";i:9984;s:11:\"delete-8747\";i:9985;s:11:\"delete-8748\";i:9986;s:11:\"delete-8749\";i:9987;s:11:\"delete-8750\";i:9988;s:11:\"delete-8751\";i:9989;s:11:\"delete-8752\";i:9990;s:11:\"delete-8753\";i:9991;s:11:\"delete-8754\";i:9992;s:11:\"delete-8755\";i:9993;s:11:\"delete-8756\";i:9994;s:11:\"delete-8757\";i:9995;s:11:\"delete-8758\";i:9996;s:11:\"delete-8759\";i:9997;s:11:\"delete-8760\";i:9998;s:11:\"delete-8761\";i:9999;s:11:\"delete-8762\";i:10000;s:11:\"delete-8763\";i:10001;s:11:\"delete-8764\";i:10002;s:11:\"delete-8765\";i:10003;s:11:\"delete-8766\";i:10004;s:11:\"delete-8767\";i:10005;s:11:\"delete-8768\";i:10006;s:11:\"delete-8769\";i:10007;s:11:\"delete-8770\";i:10008;s:11:\"delete-8771\";i:10009;s:11:\"delete-8772\";i:10010;s:11:\"delete-8773\";i:10011;s:11:\"delete-8774\";i:10012;s:11:\"delete-8775\";i:10013;s:11:\"delete-8776\";i:10014;s:11:\"delete-8777\";i:10015;s:11:\"delete-8778\";i:10016;s:11:\"delete-8779\";i:10017;s:11:\"delete-8780\";i:10018;s:11:\"delete-8781\";i:10019;s:11:\"delete-8782\";i:10020;s:11:\"delete-8783\";i:10021;s:11:\"delete-8784\";i:10022;s:11:\"delete-8785\";i:10023;s:11:\"delete-8786\";i:10024;s:11:\"delete-8787\";i:10025;s:11:\"delete-8788\";i:10026;s:11:\"delete-8789\";i:10027;s:11:\"delete-8790\";i:10028;s:11:\"delete-8791\";i:10029;s:11:\"delete-8792\";i:10030;s:11:\"delete-8793\";i:10031;s:11:\"delete-8794\";i:10032;s:11:\"delete-8795\";i:10033;s:11:\"delete-8796\";i:10034;s:11:\"delete-8797\";i:10035;s:11:\"delete-8798\";i:10036;s:11:\"delete-8799\";i:10037;s:11:\"delete-8800\";i:10038;s:11:\"delete-8801\";i:10039;s:11:\"delete-8802\";i:10040;s:11:\"delete-8803\";i:10041;s:11:\"delete-8804\";i:10042;s:11:\"delete-8805\";i:10043;s:11:\"delete-8806\";i:10044;s:11:\"delete-8807\";i:10045;s:11:\"delete-8808\";i:10046;s:11:\"delete-8809\";i:10047;s:11:\"delete-8810\";i:10048;s:11:\"delete-8811\";i:10049;s:11:\"delete-8812\";i:10050;s:11:\"delete-8813\";i:10051;s:11:\"delete-8814\";i:10052;s:11:\"delete-8815\";i:10053;s:11:\"delete-8816\";i:10054;s:11:\"delete-8817\";i:10055;s:11:\"delete-8818\";i:10056;s:11:\"delete-8819\";i:10057;s:11:\"delete-8820\";i:10058;s:11:\"delete-8821\";i:10059;s:11:\"delete-8822\";i:10060;s:11:\"delete-8823\";i:10061;s:11:\"delete-8824\";i:10062;s:11:\"delete-8825\";i:10063;s:11:\"delete-8826\";i:10064;s:11:\"delete-8827\";i:10065;s:11:\"delete-8828\";i:10066;s:11:\"delete-8829\";i:10067;s:11:\"delete-8830\";i:10068;s:11:\"delete-8831\";i:10069;s:11:\"delete-8832\";i:10070;s:11:\"delete-8833\";i:10071;s:11:\"delete-8834\";i:10072;s:11:\"delete-8835\";i:10073;s:11:\"delete-8836\";i:10074;s:11:\"delete-8837\";i:10075;s:11:\"delete-8838\";i:10076;s:11:\"delete-8839\";i:10077;s:11:\"delete-8840\";i:10078;s:11:\"delete-8841\";i:10079;s:11:\"delete-8842\";i:10080;s:11:\"delete-8843\";i:10081;s:11:\"delete-8844\";i:10082;s:11:\"delete-8845\";i:10083;s:11:\"delete-8846\";i:10084;s:11:\"delete-8847\";i:10085;s:11:\"delete-8848\";i:10086;s:11:\"delete-8849\";i:10087;s:11:\"delete-8850\";i:10088;s:11:\"delete-8851\";i:10089;s:11:\"delete-8852\";i:10090;s:11:\"delete-8853\";i:10091;s:11:\"delete-8854\";i:10092;s:11:\"delete-8855\";i:10093;s:11:\"delete-8856\";i:10094;s:11:\"delete-8857\";i:10095;s:11:\"delete-8858\";i:10096;s:11:\"delete-8859\";i:10097;s:11:\"delete-8860\";i:10098;s:11:\"delete-8861\";i:10099;s:11:\"delete-8862\";i:10100;s:11:\"delete-8863\";i:10101;s:11:\"delete-8864\";i:10102;s:11:\"delete-8865\";i:10103;s:11:\"delete-8866\";i:10104;s:11:\"delete-8867\";i:10105;s:11:\"delete-8868\";i:10106;s:11:\"delete-8869\";i:10107;s:11:\"delete-8870\";i:10108;s:11:\"delete-8871\";i:10109;s:11:\"delete-8872\";i:10110;s:11:\"delete-8873\";i:10111;s:11:\"delete-8874\";i:10112;s:11:\"delete-8875\";i:10113;s:11:\"delete-8876\";i:10114;s:11:\"delete-8877\";i:10115;s:11:\"delete-8878\";i:10116;s:11:\"delete-8879\";i:10117;s:11:\"delete-8880\";i:10118;s:11:\"delete-8881\";i:10119;s:11:\"delete-8882\";i:10120;s:11:\"delete-8883\";i:10121;s:11:\"delete-8884\";i:10122;s:11:\"delete-8885\";i:10123;s:11:\"delete-8886\";i:10124;s:11:\"delete-8887\";i:10125;s:11:\"delete-8888\";i:10126;s:11:\"delete-8889\";i:10127;s:11:\"delete-8890\";i:10128;s:11:\"delete-8891\";i:10129;s:11:\"delete-8892\";i:10130;s:11:\"delete-8893\";i:10131;s:11:\"delete-8894\";i:10132;s:11:\"delete-8895\";i:10133;s:11:\"delete-8896\";i:10134;s:11:\"delete-8897\";i:10135;s:11:\"delete-8898\";i:10136;s:11:\"delete-8899\";i:10137;s:11:\"delete-8900\";i:10138;s:11:\"delete-8901\";i:10139;s:11:\"delete-8902\";i:10140;s:11:\"delete-8903\";i:10141;s:11:\"delete-8904\";i:10142;s:11:\"delete-8905\";i:10143;s:11:\"delete-8906\";i:10144;s:11:\"delete-8907\";i:10145;s:11:\"delete-8908\";i:10146;s:11:\"delete-8909\";i:10147;s:11:\"delete-8910\";i:10148;s:11:\"delete-8911\";i:10149;s:11:\"delete-8912\";i:10150;s:11:\"delete-8913\";i:10151;s:11:\"delete-8914\";i:10152;s:11:\"delete-8915\";i:10153;s:11:\"delete-8916\";i:10154;s:11:\"delete-8917\";i:10155;s:11:\"delete-8918\";i:10156;s:11:\"delete-8919\";i:10157;s:11:\"delete-8920\";i:10158;s:11:\"delete-8921\";i:10159;s:11:\"delete-8922\";i:10160;s:11:\"delete-8923\";i:10161;s:11:\"delete-8924\";i:10162;s:11:\"delete-8925\";i:10163;s:11:\"delete-8926\";i:10164;s:11:\"delete-8927\";i:10165;s:11:\"delete-8928\";i:10166;s:11:\"delete-8929\";i:10167;s:11:\"delete-8930\";i:10168;s:11:\"delete-8931\";i:10169;s:11:\"delete-8932\";i:10170;s:11:\"delete-8933\";i:10171;s:11:\"delete-8934\";i:10172;s:11:\"delete-8935\";i:10173;s:11:\"delete-8936\";i:10174;s:11:\"delete-8937\";i:10175;s:11:\"delete-8938\";i:10176;s:11:\"delete-8939\";i:10177;s:11:\"delete-8940\";i:10178;s:11:\"delete-8941\";i:10179;s:11:\"delete-8942\";i:10180;s:11:\"delete-8943\";i:10181;s:11:\"delete-8944\";i:10182;s:11:\"delete-8945\";i:10183;s:11:\"delete-8946\";i:10184;s:11:\"delete-8947\";i:10185;s:11:\"delete-8948\";i:10186;s:11:\"delete-8949\";i:10187;s:11:\"delete-8950\";i:10188;s:11:\"delete-8951\";i:10189;s:11:\"delete-8952\";i:10190;s:11:\"delete-8953\";i:10191;s:11:\"delete-8954\";i:10192;s:11:\"delete-8955\";i:10193;s:11:\"delete-8956\";i:10194;s:11:\"delete-8957\";i:10195;s:11:\"delete-8958\";i:10196;s:11:\"delete-8959\";i:10197;s:11:\"delete-8960\";i:10198;s:11:\"delete-8961\";i:10199;s:11:\"delete-8962\";i:10200;s:11:\"delete-8963\";i:10201;s:11:\"delete-8964\";i:10202;s:11:\"delete-8965\";i:10203;s:11:\"delete-8966\";i:10204;s:11:\"delete-8967\";i:10205;s:11:\"delete-8968\";i:10206;s:11:\"delete-8969\";i:10207;s:11:\"delete-8970\";i:10208;s:11:\"delete-8971\";i:10209;s:11:\"delete-8972\";i:10210;s:11:\"delete-8973\";i:10211;s:11:\"delete-8974\";i:10212;s:11:\"delete-8975\";i:10213;s:11:\"delete-8976\";i:10214;s:11:\"delete-8977\";i:10215;s:11:\"delete-8978\";i:10216;s:11:\"delete-8979\";i:10217;s:11:\"delete-8980\";i:10218;s:11:\"delete-8981\";i:10219;s:11:\"delete-8982\";i:10220;s:11:\"delete-8983\";i:10221;s:11:\"delete-8984\";i:10222;s:11:\"delete-8985\";i:10223;s:11:\"delete-8986\";i:10224;s:11:\"delete-8987\";i:10225;s:11:\"delete-8988\";i:10226;s:11:\"delete-8989\";i:10227;s:11:\"delete-8990\";i:10228;s:11:\"delete-8991\";i:10229;s:11:\"delete-8992\";i:10230;s:11:\"delete-8993\";i:10231;s:11:\"delete-8994\";i:10232;s:11:\"delete-8995\";i:10233;s:11:\"delete-8996\";i:10234;s:11:\"delete-8997\";i:10235;s:11:\"delete-8998\";i:10236;s:11:\"delete-8999\";i:10237;s:11:\"delete-9000\";i:10238;s:11:\"delete-9001\";i:10239;s:11:\"delete-9002\";i:10240;s:11:\"delete-9003\";i:10241;s:11:\"delete-9004\";i:10242;s:11:\"delete-9005\";i:10243;s:11:\"delete-9006\";i:10244;s:11:\"delete-9007\";i:10245;s:11:\"delete-9008\";i:10246;s:11:\"delete-9009\";i:10247;s:11:\"delete-9010\";i:10248;s:11:\"delete-9011\";i:10249;s:11:\"delete-9012\";i:10250;s:11:\"delete-9013\";i:10251;s:11:\"delete-9014\";i:10252;s:11:\"delete-9015\";i:10253;s:11:\"delete-9016\";i:10254;s:11:\"delete-9017\";i:10255;s:11:\"delete-9018\";i:10256;s:11:\"delete-9019\";i:10257;s:11:\"delete-9020\";i:10258;s:11:\"delete-9021\";i:10259;s:11:\"delete-9022\";i:10260;s:11:\"delete-9023\";i:10261;s:11:\"delete-9024\";i:10262;s:11:\"delete-9025\";i:10263;s:11:\"delete-9026\";i:10264;s:11:\"delete-9027\";i:10265;s:11:\"delete-9028\";i:10266;s:11:\"delete-9029\";i:10267;s:11:\"delete-9030\";i:10268;s:11:\"delete-9031\";i:10269;s:11:\"delete-9032\";i:10270;s:11:\"delete-9033\";i:10271;s:11:\"delete-9034\";i:10272;s:11:\"delete-9035\";i:10273;s:11:\"delete-9036\";i:10274;s:11:\"delete-9037\";i:10275;s:11:\"delete-9038\";i:10276;s:11:\"delete-9039\";i:10277;s:11:\"delete-9040\";i:10278;s:11:\"delete-9041\";i:10279;s:11:\"delete-9042\";i:10280;s:11:\"delete-9043\";i:10281;s:11:\"delete-9044\";i:10282;s:11:\"delete-9045\";i:10283;s:11:\"delete-9046\";i:10284;s:11:\"delete-9047\";i:10285;s:11:\"delete-9048\";i:10286;s:11:\"delete-9049\";i:10287;s:11:\"delete-9050\";i:10288;s:11:\"delete-9051\";i:10289;s:11:\"delete-9052\";i:10290;s:11:\"delete-9053\";i:10291;s:11:\"delete-9054\";i:10292;s:11:\"delete-9055\";i:10293;s:11:\"delete-9056\";i:10294;s:11:\"delete-9057\";i:10295;s:11:\"delete-9058\";i:10296;s:11:\"delete-9059\";i:10297;s:11:\"delete-9060\";i:10298;s:11:\"delete-9061\";i:10299;s:11:\"delete-9062\";i:10300;s:11:\"delete-9063\";i:10301;s:11:\"delete-9064\";i:10302;s:11:\"delete-9065\";i:10303;s:11:\"delete-9066\";i:10304;s:11:\"delete-9067\";i:10305;s:11:\"delete-9068\";i:10306;s:11:\"delete-9069\";i:10307;s:11:\"delete-9070\";i:10308;s:11:\"delete-9071\";i:10309;s:11:\"delete-9072\";i:10310;s:11:\"delete-9073\";i:10311;s:11:\"delete-9074\";i:10312;s:11:\"delete-9075\";i:10313;s:11:\"delete-9076\";i:10314;s:11:\"delete-9077\";i:10315;s:11:\"delete-9078\";i:10316;s:11:\"delete-9079\";i:10317;s:11:\"delete-9080\";i:10318;s:11:\"delete-9081\";i:10319;s:11:\"delete-9082\";i:10320;s:11:\"delete-9083\";i:10321;s:11:\"delete-9084\";i:10322;s:11:\"delete-9085\";i:10323;s:11:\"delete-9086\";i:10324;s:11:\"delete-9087\";i:10325;s:11:\"delete-9088\";i:10326;s:11:\"delete-9089\";i:10327;s:11:\"delete-9090\";i:10328;s:11:\"delete-9091\";i:10329;s:11:\"delete-9092\";i:10330;s:11:\"delete-9093\";i:10331;s:11:\"delete-9094\";i:10332;s:11:\"delete-9095\";i:10333;s:11:\"delete-9096\";i:10334;s:11:\"delete-9097\";i:10335;s:11:\"delete-9098\";i:10336;s:11:\"delete-9099\";i:10337;s:11:\"delete-9100\";i:10338;s:11:\"delete-9101\";i:10339;s:11:\"delete-9102\";i:10340;s:11:\"delete-9103\";i:10341;s:11:\"delete-9104\";i:10342;s:11:\"delete-9105\";i:10343;s:11:\"delete-9106\";i:10344;s:11:\"delete-9107\";i:10345;s:11:\"delete-9108\";i:10346;s:11:\"delete-9109\";i:10347;s:11:\"delete-9110\";i:10348;s:11:\"delete-9111\";i:10349;s:11:\"delete-9112\";i:10350;s:11:\"delete-9113\";i:10351;s:11:\"delete-9114\";i:10352;s:11:\"delete-9115\";i:10353;s:11:\"delete-9116\";i:10354;s:11:\"delete-9117\";i:10355;s:11:\"delete-9118\";i:10356;s:11:\"delete-9119\";i:10357;s:11:\"delete-9120\";i:10358;s:11:\"delete-9121\";i:10359;s:11:\"delete-9122\";i:10360;s:11:\"delete-9123\";i:10361;s:11:\"delete-9124\";i:10362;s:11:\"delete-9125\";i:10363;s:11:\"delete-9126\";i:10364;s:11:\"delete-9127\";i:10365;s:11:\"delete-9128\";i:10366;s:11:\"delete-9129\";i:10367;s:11:\"delete-9130\";i:10368;s:11:\"delete-9131\";i:10369;s:11:\"delete-9132\";i:10370;s:11:\"delete-9133\";i:10371;s:11:\"delete-9134\";i:10372;s:11:\"delete-9135\";i:10373;s:11:\"delete-9136\";i:10374;s:11:\"delete-9137\";i:10375;s:11:\"delete-9138\";i:10376;s:11:\"delete-9139\";i:10377;s:11:\"delete-9140\";i:10378;s:11:\"delete-9141\";i:10379;s:11:\"delete-9142\";i:10380;s:11:\"delete-9143\";i:10381;s:11:\"delete-9144\";i:10382;s:11:\"delete-9145\";i:10383;s:11:\"delete-9146\";i:10384;s:11:\"delete-9147\";i:10385;s:11:\"delete-9148\";i:10386;s:11:\"delete-9149\";i:10387;s:11:\"delete-9150\";i:10388;s:11:\"delete-9151\";i:10389;s:11:\"delete-9152\";i:10390;s:11:\"delete-9153\";i:10391;s:11:\"delete-9154\";i:10392;s:11:\"delete-9155\";i:10393;s:11:\"delete-9156\";i:10394;s:11:\"delete-9157\";i:10395;s:11:\"delete-9158\";i:10396;s:11:\"delete-9159\";i:10397;s:11:\"delete-9160\";i:10398;s:11:\"delete-9161\";i:10399;s:11:\"delete-9162\";i:10400;s:11:\"delete-9163\";i:10401;s:11:\"delete-9164\";i:10402;s:11:\"delete-9165\";i:10403;s:11:\"delete-9166\";i:10404;s:11:\"delete-9167\";i:10405;s:11:\"delete-9168\";i:10406;s:11:\"delete-9169\";i:10407;s:11:\"delete-9170\";i:10408;s:11:\"delete-9171\";i:10409;s:11:\"delete-9172\";i:10410;s:11:\"delete-9173\";i:10411;s:11:\"delete-9174\";i:10412;s:11:\"delete-9175\";i:10413;s:11:\"delete-9176\";i:10414;s:11:\"delete-9177\";i:10415;s:11:\"delete-9178\";i:10416;s:11:\"delete-9179\";i:10417;s:11:\"delete-9180\";i:10418;s:11:\"delete-9181\";i:10419;s:11:\"delete-9182\";i:10420;s:11:\"delete-9183\";i:10421;s:11:\"delete-9184\";i:10422;s:11:\"delete-9185\";i:10423;s:11:\"delete-9186\";i:10424;s:11:\"delete-9187\";i:10425;s:11:\"delete-9188\";i:10426;s:11:\"delete-9189\";i:10427;s:11:\"delete-9190\";i:10428;s:11:\"delete-9191\";i:10429;s:11:\"delete-9192\";i:10430;s:11:\"delete-9193\";i:10431;s:11:\"delete-9194\";i:10432;s:11:\"delete-9195\";i:10433;s:11:\"delete-9196\";i:10434;s:11:\"delete-9197\";i:10435;s:11:\"delete-9198\";i:10436;s:11:\"delete-9199\";i:10437;s:11:\"delete-9200\";i:10438;s:11:\"delete-9201\";i:10439;s:11:\"delete-9202\";i:10440;s:11:\"delete-9203\";i:10441;s:11:\"delete-9204\";i:10442;s:11:\"delete-9205\";i:10443;s:11:\"delete-9206\";i:10444;s:11:\"delete-9207\";i:10445;s:11:\"delete-9208\";i:10446;s:11:\"delete-9209\";i:10447;s:11:\"delete-9210\";i:10448;s:11:\"delete-9211\";i:10449;s:11:\"delete-9212\";i:10450;s:11:\"delete-9213\";i:10451;s:11:\"delete-9214\";i:10452;s:11:\"delete-9215\";i:10453;s:11:\"delete-9216\";i:10454;s:11:\"delete-9217\";i:10455;s:11:\"delete-9218\";i:10456;s:11:\"delete-9219\";i:10457;s:11:\"delete-9220\";i:10458;s:11:\"delete-9221\";i:10459;s:11:\"delete-9222\";i:10460;s:11:\"delete-9223\";i:10461;s:11:\"delete-9224\";i:10462;s:11:\"delete-9225\";i:10463;s:11:\"delete-9226\";i:10464;s:11:\"delete-9227\";i:10465;s:11:\"delete-9228\";i:10466;s:11:\"delete-9229\";i:10467;s:11:\"delete-9230\";i:10468;s:11:\"delete-9231\";i:10469;s:11:\"delete-9232\";i:10470;s:11:\"delete-9233\";i:10471;s:11:\"delete-9234\";i:10472;s:11:\"delete-9235\";i:10473;s:11:\"delete-9236\";i:10474;s:11:\"delete-9237\";i:10475;s:11:\"delete-9238\";i:10476;s:11:\"delete-9239\";i:10477;s:11:\"delete-9240\";i:10478;s:11:\"delete-9241\";i:10479;s:11:\"delete-9242\";i:10480;s:11:\"delete-9243\";i:10481;s:11:\"delete-9244\";i:10482;s:11:\"delete-9245\";i:10483;s:11:\"delete-9246\";i:10484;s:11:\"delete-9247\";i:10485;s:11:\"delete-9248\";i:10486;s:11:\"delete-9249\";i:10487;s:11:\"delete-9250\";i:10488;s:11:\"delete-9251\";i:10489;s:11:\"delete-9252\";i:10490;s:11:\"delete-9253\";i:10491;s:11:\"delete-9254\";i:10492;s:11:\"delete-9255\";i:10493;s:11:\"delete-9256\";i:10494;s:11:\"delete-9257\";i:10495;s:11:\"delete-9258\";i:10496;s:11:\"delete-9259\";i:10497;s:11:\"delete-9260\";i:10498;s:11:\"delete-9261\";i:10499;s:11:\"delete-9262\";i:10500;s:11:\"delete-9263\";i:10501;s:11:\"delete-9264\";i:10502;s:11:\"delete-9265\";i:10503;s:11:\"delete-9266\";i:10504;s:11:\"delete-9267\";i:10505;s:11:\"delete-9268\";i:10506;s:11:\"delete-9269\";i:10507;s:11:\"delete-9270\";i:10508;s:11:\"delete-9271\";i:10509;s:11:\"delete-9272\";i:10510;s:11:\"delete-9273\";i:10511;s:11:\"delete-9274\";i:10512;s:11:\"delete-9275\";i:10513;s:11:\"delete-9276\";i:10514;s:11:\"delete-9277\";i:10515;s:11:\"delete-9278\";i:10516;s:11:\"delete-9279\";i:10517;s:11:\"delete-9280\";i:10518;s:11:\"delete-9281\";i:10519;s:11:\"delete-9282\";i:10520;s:11:\"delete-9283\";i:10521;s:11:\"delete-9284\";i:10522;s:11:\"delete-9285\";i:10523;s:11:\"delete-9286\";i:10524;s:11:\"delete-9287\";i:10525;s:11:\"delete-9288\";i:10526;s:11:\"delete-9289\";i:10527;s:11:\"delete-9290\";i:10528;s:11:\"delete-9291\";i:10529;s:11:\"delete-9292\";i:10530;s:11:\"delete-9293\";i:10531;s:11:\"delete-9294\";i:10532;s:11:\"delete-9295\";i:10533;s:11:\"delete-9296\";i:10534;s:11:\"delete-9297\";i:10535;s:11:\"delete-9298\";i:10536;s:11:\"delete-9299\";i:10537;s:11:\"delete-9300\";i:10538;s:11:\"delete-9301\";i:10539;s:11:\"delete-9302\";i:10540;s:11:\"delete-9303\";i:10541;s:11:\"delete-9304\";i:10542;s:11:\"delete-9305\";i:10543;s:11:\"delete-9306\";i:10544;s:11:\"delete-9307\";i:10545;s:11:\"delete-9308\";i:10546;s:11:\"delete-9309\";i:10547;s:11:\"delete-9310\";i:10548;s:11:\"delete-9311\";i:10549;s:11:\"delete-9312\";i:10550;s:11:\"delete-9313\";i:10551;s:11:\"delete-9314\";i:10552;s:11:\"delete-9315\";i:10553;s:11:\"delete-9316\";i:10554;s:11:\"delete-9317\";i:10555;s:11:\"delete-9318\";i:10556;s:11:\"delete-9319\";i:10557;s:11:\"delete-9320\";i:10558;s:11:\"delete-9321\";i:10559;s:11:\"delete-9322\";i:10560;s:11:\"delete-9323\";i:10561;s:11:\"delete-9324\";i:10562;s:11:\"delete-9325\";i:10563;s:11:\"delete-9326\";i:10564;s:11:\"delete-9327\";i:10565;s:11:\"delete-9328\";i:10566;s:11:\"delete-9329\";i:10567;s:11:\"delete-9330\";i:10568;s:11:\"delete-9331\";i:10569;s:11:\"delete-9332\";i:10570;s:11:\"delete-9333\";i:10571;s:11:\"delete-9334\";i:10572;s:11:\"delete-9335\";i:10573;s:11:\"delete-9336\";i:10574;s:11:\"delete-9337\";i:10575;s:11:\"delete-9338\";i:10576;s:11:\"delete-9339\";i:10577;s:11:\"delete-9340\";i:10578;s:11:\"delete-9341\";i:10579;s:11:\"delete-9342\";i:10580;s:11:\"delete-9343\";i:10581;s:11:\"delete-9344\";i:10582;s:11:\"delete-9345\";i:10583;s:11:\"delete-9346\";i:10584;s:11:\"delete-9347\";i:10585;s:11:\"delete-9348\";i:10586;s:11:\"delete-9349\";i:10587;s:11:\"delete-9350\";i:10588;s:11:\"delete-9351\";i:10589;s:11:\"delete-9352\";i:10590;s:11:\"delete-9353\";i:10591;s:11:\"delete-9354\";i:10592;s:11:\"delete-9355\";i:10593;s:11:\"delete-9356\";i:10594;s:11:\"delete-9357\";i:10595;s:11:\"delete-9358\";i:10596;s:11:\"delete-9359\";i:10597;s:11:\"delete-9360\";i:10598;s:11:\"delete-9361\";i:10599;s:11:\"delete-9362\";i:10600;s:11:\"delete-9363\";i:10601;s:11:\"delete-9364\";i:10602;s:11:\"delete-9365\";i:10603;s:11:\"delete-9366\";i:10604;s:11:\"delete-9367\";i:10605;s:11:\"delete-9368\";i:10606;s:11:\"delete-9369\";i:10607;s:11:\"delete-9370\";i:10608;s:11:\"delete-9371\";i:10609;s:11:\"delete-9372\";i:10610;s:11:\"delete-9373\";i:10611;s:11:\"delete-9374\";i:10612;s:11:\"delete-9375\";i:10613;s:11:\"delete-9376\";i:10614;s:11:\"delete-9377\";i:10615;s:11:\"delete-9378\";i:10616;s:11:\"delete-9379\";i:10617;s:11:\"delete-9380\";i:10618;s:11:\"delete-9381\";i:10619;s:11:\"delete-9382\";i:10620;s:11:\"delete-9383\";i:10621;s:11:\"delete-9384\";i:10622;s:11:\"delete-9385\";i:10623;s:11:\"delete-9386\";i:10624;s:11:\"delete-9387\";i:10625;s:11:\"delete-9388\";i:10626;s:11:\"delete-9389\";i:10627;s:11:\"delete-9390\";i:10628;s:11:\"delete-9391\";i:10629;s:11:\"delete-9392\";i:10630;s:11:\"delete-9393\";i:10631;s:11:\"delete-9394\";i:10632;s:11:\"delete-9395\";i:10633;s:11:\"delete-9396\";i:10634;s:11:\"delete-9397\";i:10635;s:11:\"delete-9398\";i:10636;s:11:\"delete-9399\";i:10637;s:11:\"delete-9400\";i:10638;s:11:\"delete-9401\";i:10639;s:11:\"delete-9402\";i:10640;s:11:\"delete-9403\";i:10641;s:11:\"delete-9404\";i:10642;s:11:\"delete-9405\";i:10643;s:11:\"delete-9406\";i:10644;s:11:\"delete-9407\";i:10645;s:11:\"delete-9408\";i:10646;s:11:\"delete-9409\";i:10647;s:11:\"delete-9410\";i:10648;s:11:\"delete-9411\";i:10649;s:11:\"delete-9412\";i:10650;s:11:\"delete-9413\";i:10651;s:11:\"delete-9414\";i:10652;s:11:\"delete-9415\";i:10653;s:11:\"delete-9416\";i:10654;s:11:\"delete-9417\";i:10655;s:11:\"delete-9418\";i:10656;s:11:\"delete-9419\";i:10657;s:11:\"delete-9420\";i:10658;s:11:\"delete-9421\";i:10659;s:11:\"delete-9422\";i:10660;s:11:\"delete-9423\";i:10661;s:11:\"delete-9424\";i:10662;s:11:\"delete-9425\";i:10663;s:11:\"delete-9426\";i:10664;s:11:\"delete-9427\";i:10665;s:11:\"delete-9428\";i:10666;s:11:\"delete-9429\";i:10667;s:11:\"delete-9430\";i:10668;s:11:\"delete-9431\";i:10669;s:11:\"delete-9432\";i:10670;s:11:\"delete-9433\";i:10671;s:11:\"delete-9434\";i:10672;s:11:\"delete-9435\";i:10673;s:11:\"delete-9436\";i:10674;s:11:\"delete-9437\";i:10675;s:11:\"delete-9438\";i:10676;s:11:\"delete-9439\";i:10677;s:11:\"delete-9440\";i:10678;s:11:\"delete-9441\";i:10679;s:11:\"delete-9442\";i:10680;s:11:\"delete-9443\";i:10681;s:11:\"delete-9444\";i:10682;s:11:\"delete-9445\";i:10683;s:11:\"delete-9446\";i:10684;s:11:\"delete-9447\";i:10685;s:11:\"delete-9448\";i:10686;s:11:\"delete-9449\";i:10687;s:11:\"delete-9450\";i:10688;s:11:\"delete-9451\";i:10689;s:11:\"delete-9452\";i:10690;s:11:\"delete-9453\";i:10691;s:11:\"delete-9454\";i:10692;s:11:\"delete-9455\";i:10693;s:11:\"delete-9456\";i:10694;s:11:\"delete-9457\";i:10695;s:11:\"delete-9458\";i:10696;s:11:\"delete-9459\";i:10697;s:11:\"delete-9460\";i:10698;s:11:\"delete-9461\";i:10699;s:11:\"delete-9462\";i:10700;s:11:\"delete-9463\";i:10701;s:11:\"delete-9464\";i:10702;s:11:\"delete-9465\";i:10703;s:11:\"delete-9466\";i:10704;s:11:\"delete-9467\";i:10705;s:11:\"delete-9468\";i:10706;s:11:\"delete-9469\";i:10707;s:11:\"delete-9470\";i:10708;s:11:\"delete-9471\";i:10709;s:11:\"delete-9472\";i:10710;s:11:\"delete-9473\";i:10711;s:11:\"delete-9474\";i:10712;s:11:\"delete-9475\";i:10713;s:11:\"delete-9476\";i:10714;s:11:\"delete-9477\";i:10715;s:11:\"delete-9478\";i:10716;s:11:\"delete-9479\";i:10717;s:11:\"delete-9480\";i:10718;s:11:\"delete-9481\";i:10719;s:11:\"delete-9482\";i:10720;s:11:\"delete-9483\";i:10721;s:11:\"delete-9484\";i:10722;s:11:\"delete-9485\";i:10723;s:11:\"delete-9486\";i:10724;s:11:\"delete-9487\";i:10725;s:11:\"delete-9488\";i:10726;s:11:\"delete-9489\";i:10727;s:11:\"delete-9490\";i:10728;s:11:\"delete-9491\";i:10729;s:11:\"delete-9492\";i:10730;s:11:\"delete-9493\";i:10731;s:11:\"delete-9494\";i:10732;s:11:\"delete-9495\";i:10733;s:11:\"delete-9496\";i:10734;s:11:\"delete-9497\";i:10735;s:11:\"delete-9498\";i:10736;s:11:\"delete-9499\";i:10737;s:11:\"delete-9500\";i:10738;s:11:\"delete-9501\";i:10739;s:11:\"delete-9502\";i:10740;s:11:\"delete-9503\";i:10741;s:11:\"delete-9504\";i:10742;s:11:\"delete-9505\";i:10743;s:11:\"delete-9506\";i:10744;s:11:\"delete-9507\";i:10745;s:11:\"delete-9508\";i:10746;s:11:\"delete-9509\";i:10747;s:11:\"delete-9510\";i:10748;s:11:\"delete-9511\";i:10749;s:11:\"delete-9512\";i:10750;s:11:\"delete-9513\";i:10751;s:11:\"delete-9514\";i:10752;s:11:\"delete-9515\";i:10753;s:11:\"delete-9516\";i:10754;s:11:\"delete-9517\";i:10755;s:11:\"delete-9518\";i:10756;s:11:\"delete-9519\";i:10757;s:11:\"delete-9520\";i:10758;s:11:\"delete-9521\";i:10759;s:11:\"delete-9522\";i:10760;s:11:\"delete-9523\";i:10761;s:11:\"delete-9524\";i:10762;s:11:\"delete-9525\";i:10763;s:11:\"delete-9526\";i:10764;s:11:\"delete-9527\";i:10765;s:11:\"delete-9528\";i:10766;s:11:\"delete-9529\";i:10767;s:11:\"delete-9530\";i:10768;s:11:\"delete-9531\";i:10769;s:11:\"delete-9532\";i:10770;s:11:\"delete-9533\";i:10771;s:11:\"delete-9534\";i:10772;s:11:\"delete-9535\";i:10773;s:11:\"delete-9536\";i:10774;s:11:\"delete-9537\";i:10775;s:11:\"delete-9538\";i:10776;s:11:\"delete-9539\";i:10777;s:11:\"delete-9540\";i:10778;s:11:\"delete-9541\";i:10779;s:11:\"delete-9542\";i:10780;s:11:\"delete-9543\";i:10781;s:11:\"delete-9544\";i:10782;s:11:\"delete-9545\";i:10783;s:11:\"delete-9546\";i:10784;s:11:\"delete-9547\";i:10785;s:11:\"delete-9548\";i:10786;s:11:\"delete-9549\";i:10787;s:11:\"delete-9550\";i:10788;s:11:\"delete-9551\";i:10789;s:11:\"delete-9552\";i:10790;s:11:\"delete-9553\";i:10791;s:11:\"delete-9554\";i:10792;s:11:\"delete-9555\";i:10793;s:11:\"delete-9556\";i:10794;s:11:\"delete-9557\";i:10795;s:11:\"delete-9558\";i:10796;s:11:\"delete-9559\";i:10797;s:11:\"delete-9560\";i:10798;s:11:\"delete-9561\";i:10799;s:11:\"delete-9562\";i:10800;s:11:\"delete-9563\";i:10801;s:11:\"delete-9564\";i:10802;s:11:\"delete-9565\";i:10803;s:11:\"delete-9566\";i:10804;s:11:\"delete-9567\";i:10805;s:11:\"delete-9568\";i:10806;s:11:\"delete-9569\";i:10807;s:11:\"delete-9570\";i:10808;s:11:\"delete-9571\";i:10809;s:11:\"delete-9572\";i:10810;s:11:\"delete-9573\";i:10811;s:11:\"delete-9574\";i:10812;s:11:\"delete-9575\";i:10813;s:11:\"delete-9576\";i:10814;s:11:\"delete-9577\";i:10815;s:11:\"delete-9578\";i:10816;s:11:\"delete-9579\";i:10817;s:11:\"delete-9580\";i:10818;s:11:\"delete-9581\";i:10819;s:11:\"delete-9582\";i:10820;s:11:\"delete-9583\";i:10821;s:11:\"delete-9584\";i:10822;s:11:\"delete-9585\";i:10823;s:11:\"delete-9586\";i:10824;s:11:\"delete-9587\";i:10825;s:11:\"delete-9588\";i:10826;s:11:\"delete-9589\";i:10827;s:11:\"delete-9590\";i:10828;s:11:\"delete-9591\";i:10829;s:11:\"delete-9592\";i:10830;s:11:\"delete-9593\";i:10831;s:11:\"delete-9594\";i:10832;s:11:\"delete-9595\";i:10833;s:11:\"delete-9596\";i:10834;s:11:\"delete-9597\";i:10835;s:11:\"delete-9598\";i:10836;s:11:\"delete-9599\";i:10837;s:11:\"delete-9600\";i:10838;s:11:\"delete-9601\";i:10839;s:11:\"delete-9602\";i:10840;s:11:\"delete-9603\";i:10841;s:11:\"delete-9604\";i:10842;s:11:\"delete-9605\";i:10843;s:11:\"delete-9606\";i:10844;s:11:\"delete-9607\";i:10845;s:11:\"delete-9608\";i:10846;s:11:\"delete-9609\";i:10847;s:11:\"delete-9610\";i:10848;s:11:\"delete-9611\";i:10849;s:11:\"delete-9612\";i:10850;s:11:\"delete-9613\";i:10851;s:11:\"delete-9614\";i:10852;s:11:\"delete-9615\";i:10853;s:11:\"delete-9616\";i:10854;s:11:\"delete-9617\";i:10855;s:11:\"delete-9618\";i:10856;s:11:\"delete-9619\";i:10857;s:11:\"delete-9620\";i:10858;s:11:\"delete-9621\";i:10859;s:11:\"delete-9622\";i:10860;s:11:\"delete-9623\";i:10861;s:11:\"delete-9624\";i:10862;s:11:\"delete-9625\";i:10863;s:11:\"delete-9626\";i:10864;s:11:\"delete-9627\";i:10865;s:11:\"delete-9628\";i:10866;s:11:\"delete-9629\";i:10867;s:11:\"delete-9630\";i:10868;s:11:\"delete-9631\";i:10869;s:11:\"delete-9632\";i:10870;s:11:\"delete-9633\";i:10871;s:11:\"delete-9634\";i:10872;s:11:\"delete-9635\";i:10873;s:11:\"delete-9636\";i:10874;s:11:\"delete-9637\";i:10875;s:11:\"delete-9638\";i:10876;s:11:\"delete-9639\";i:10877;s:11:\"delete-9640\";i:10878;s:11:\"delete-9641\";i:10879;s:11:\"delete-9642\";i:10880;s:11:\"delete-9643\";i:10881;s:11:\"delete-9644\";i:10882;s:11:\"delete-9645\";i:10883;s:11:\"delete-9646\";i:10884;s:11:\"delete-9647\";i:10885;s:11:\"delete-9648\";i:10886;s:11:\"delete-9649\";i:10887;s:11:\"delete-9650\";i:10888;s:11:\"delete-9651\";i:10889;s:11:\"delete-9652\";i:10890;s:11:\"delete-9653\";i:10891;s:11:\"delete-9654\";i:10892;s:11:\"delete-9655\";i:10893;s:11:\"delete-9656\";i:10894;s:11:\"delete-9657\";i:10895;s:11:\"delete-9658\";i:10896;s:11:\"delete-9659\";i:10897;s:11:\"delete-9660\";i:10898;s:11:\"delete-9661\";i:10899;s:11:\"delete-9662\";i:10900;s:11:\"delete-9663\";i:10901;s:11:\"delete-9664\";i:10902;s:11:\"delete-9665\";i:10903;s:11:\"delete-9666\";i:10904;s:11:\"delete-9667\";i:10905;s:11:\"delete-9668\";i:10906;s:11:\"delete-9669\";i:10907;s:11:\"delete-9670\";i:10908;s:11:\"delete-9671\";i:10909;s:11:\"delete-9672\";i:10910;s:11:\"delete-9673\";i:10911;s:11:\"delete-9674\";i:10912;s:11:\"delete-9675\";i:10913;s:11:\"delete-9676\";i:10914;s:11:\"delete-9677\";i:10915;s:11:\"delete-9678\";i:10916;s:11:\"delete-9679\";i:10917;s:11:\"delete-9680\";i:10918;s:11:\"delete-9681\";i:10919;s:11:\"delete-9682\";i:10920;s:11:\"delete-9683\";i:10921;s:11:\"delete-9684\";i:10922;s:11:\"delete-9685\";i:10923;s:11:\"delete-9686\";i:10924;s:11:\"delete-9687\";i:10925;s:11:\"delete-9688\";i:10926;s:11:\"delete-9689\";i:10927;s:11:\"delete-9690\";i:10928;s:11:\"delete-9691\";i:10929;s:11:\"delete-9692\";i:10930;s:11:\"delete-9693\";i:10931;s:11:\"delete-9694\";i:10932;s:11:\"delete-9695\";i:10933;s:11:\"delete-9696\";i:10934;s:11:\"delete-9697\";i:10935;s:11:\"delete-9698\";i:10936;s:11:\"delete-9699\";i:10937;s:11:\"delete-9700\";i:10938;s:11:\"delete-9701\";i:10939;s:11:\"delete-9702\";i:10940;s:11:\"delete-9703\";i:10941;s:11:\"delete-9704\";i:10942;s:11:\"delete-9705\";i:10943;s:11:\"delete-9706\";i:10944;s:11:\"delete-9707\";i:10945;s:11:\"delete-9708\";i:10946;s:11:\"delete-9709\";i:10947;s:11:\"delete-9710\";i:10948;s:11:\"delete-9711\";i:10949;s:11:\"delete-9712\";i:10950;s:11:\"delete-9713\";i:10951;s:11:\"delete-9714\";i:10952;s:11:\"delete-9715\";i:10953;s:11:\"delete-9716\";i:10954;s:11:\"delete-9717\";i:10955;s:11:\"delete-9718\";i:10956;s:11:\"delete-9719\";i:10957;s:11:\"delete-9720\";i:10958;s:11:\"delete-9721\";i:10959;s:11:\"delete-9722\";i:10960;s:11:\"delete-9723\";i:10961;s:11:\"delete-9724\";i:10962;s:11:\"delete-9725\";i:10963;s:11:\"delete-9726\";i:10964;s:11:\"delete-9727\";i:10965;s:11:\"delete-9728\";i:10966;s:11:\"delete-9729\";i:10967;s:11:\"delete-9730\";i:10968;s:11:\"delete-9731\";i:10969;s:11:\"delete-9732\";i:10970;s:11:\"delete-9733\";i:10971;s:11:\"delete-9734\";i:10972;s:11:\"delete-9735\";i:10973;s:11:\"delete-9736\";i:10974;s:11:\"delete-9737\";i:10975;s:11:\"delete-9738\";i:10976;s:11:\"delete-9739\";i:10977;s:11:\"delete-9740\";i:10978;s:11:\"delete-9741\";i:10979;s:11:\"delete-9742\";i:10980;s:11:\"delete-9743\";i:10981;s:11:\"delete-9744\";i:10982;s:11:\"delete-9745\";i:10983;s:11:\"delete-9746\";i:10984;s:11:\"delete-9747\";i:10985;s:11:\"delete-9748\";i:10986;s:11:\"delete-9749\";i:10987;s:11:\"delete-9750\";i:10988;s:11:\"delete-9751\";i:10989;s:11:\"delete-9752\";i:10990;s:11:\"delete-9753\";i:10991;s:11:\"delete-9754\";i:10992;s:11:\"delete-9755\";i:10993;s:11:\"delete-9756\";i:10994;s:11:\"delete-9757\";i:10995;s:11:\"delete-9758\";i:10996;s:11:\"delete-9759\";i:10997;s:11:\"delete-9760\";i:10998;s:11:\"delete-9761\";i:10999;s:11:\"delete-9762\";i:11000;s:11:\"delete-9763\";i:11001;s:11:\"delete-9764\";i:11002;s:11:\"delete-9765\";i:11003;s:11:\"delete-9766\";i:11004;s:11:\"delete-9767\";i:11005;s:11:\"delete-9768\";i:11006;s:11:\"delete-9769\";i:11007;s:11:\"delete-9770\";i:11008;s:11:\"delete-9771\";i:11009;s:11:\"delete-9772\";i:11010;s:11:\"delete-9773\";i:11011;s:11:\"delete-9774\";i:11012;s:11:\"delete-9775\";i:11013;s:11:\"delete-9776\";i:11014;s:11:\"delete-9777\";i:11015;s:11:\"delete-9778\";i:11016;s:11:\"delete-9779\";i:11017;s:11:\"delete-9780\";i:11018;s:11:\"delete-9781\";i:11019;s:11:\"delete-9782\";i:11020;s:11:\"delete-9783\";i:11021;s:11:\"delete-9784\";i:11022;s:11:\"delete-9785\";i:11023;s:11:\"delete-9786\";i:11024;s:11:\"delete-9787\";i:11025;s:11:\"delete-9788\";i:11026;s:11:\"delete-9789\";i:11027;s:11:\"delete-9790\";i:11028;s:11:\"delete-9791\";i:11029;s:11:\"delete-9792\";i:11030;s:11:\"delete-9793\";i:11031;s:11:\"delete-9794\";i:11032;s:11:\"delete-9795\";i:11033;s:11:\"delete-9796\";i:11034;s:11:\"delete-9797\";i:11035;s:11:\"delete-9798\";i:11036;s:11:\"delete-9799\";i:11037;s:11:\"delete-9800\";i:11038;s:11:\"delete-9801\";i:11039;s:11:\"delete-9802\";i:11040;s:11:\"delete-9803\";i:11041;s:11:\"delete-9804\";i:11042;s:11:\"delete-9805\";i:11043;s:11:\"delete-9806\";i:11044;s:11:\"delete-9807\";i:11045;s:11:\"delete-9808\";i:11046;s:11:\"delete-9809\";i:11047;s:11:\"delete-9810\";i:11048;s:11:\"delete-9811\";i:11049;s:11:\"delete-9812\";i:11050;s:11:\"delete-9813\";i:11051;s:11:\"delete-9814\";i:11052;s:11:\"delete-9815\";i:11053;s:11:\"delete-9816\";i:11054;s:11:\"delete-9817\";i:11055;s:11:\"delete-9818\";i:11056;s:11:\"delete-9819\";i:11057;s:11:\"delete-9820\";i:11058;s:11:\"delete-9821\";i:11059;s:11:\"delete-9822\";i:11060;s:11:\"delete-9823\";i:11061;s:11:\"delete-9824\";i:11062;s:11:\"delete-9825\";i:11063;s:11:\"delete-9826\";i:11064;s:11:\"delete-9827\";i:11065;s:11:\"delete-9828\";i:11066;s:11:\"delete-9829\";i:11067;s:11:\"delete-9830\";i:11068;s:11:\"delete-9831\";i:11069;s:11:\"delete-9832\";i:11070;s:11:\"delete-9833\";i:11071;s:11:\"delete-9834\";i:11072;s:11:\"delete-9835\";i:11073;s:11:\"delete-9836\";i:11074;s:11:\"delete-9837\";i:11075;s:11:\"delete-9838\";i:11076;s:11:\"delete-9839\";i:11077;s:11:\"delete-9840\";i:11078;s:11:\"delete-9841\";i:11079;s:11:\"delete-9842\";i:11080;s:11:\"delete-9843\";i:11081;s:11:\"delete-9844\";i:11082;s:11:\"delete-9845\";i:11083;s:11:\"delete-9846\";i:11084;s:11:\"delete-9847\";i:11085;s:11:\"delete-9848\";i:11086;s:11:\"delete-9849\";i:11087;s:11:\"delete-9850\";i:11088;s:11:\"delete-9851\";i:11089;s:11:\"delete-9852\";i:11090;s:11:\"delete-9853\";i:11091;s:11:\"delete-9854\";i:11092;s:11:\"delete-9855\";i:11093;s:11:\"delete-9856\";i:11094;s:11:\"delete-9857\";i:11095;s:11:\"delete-9858\";i:11096;s:11:\"delete-9859\";i:11097;s:11:\"delete-9860\";i:11098;s:11:\"delete-9861\";i:11099;s:11:\"delete-9862\";i:11100;s:11:\"delete-9863\";i:11101;s:11:\"delete-9864\";i:11102;s:11:\"delete-9865\";i:11103;s:11:\"delete-9866\";i:11104;s:11:\"delete-9867\";i:11105;s:11:\"delete-9868\";i:11106;s:11:\"delete-9869\";i:11107;s:11:\"delete-9870\";i:11108;s:11:\"delete-9871\";i:11109;s:11:\"delete-9872\";i:11110;s:11:\"delete-9873\";i:11111;s:11:\"delete-9874\";i:11112;s:11:\"delete-9875\";i:11113;s:11:\"delete-9876\";i:11114;s:11:\"delete-9877\";i:11115;s:11:\"delete-9878\";i:11116;s:11:\"delete-9879\";i:11117;s:11:\"delete-9880\";i:11118;s:11:\"delete-9881\";i:11119;s:11:\"delete-9882\";i:11120;s:11:\"delete-9883\";i:11121;s:11:\"delete-9884\";i:11122;s:11:\"delete-9885\";i:11123;s:11:\"delete-9886\";i:11124;s:11:\"delete-9887\";i:11125;s:11:\"delete-9888\";i:11126;s:11:\"delete-9889\";i:11127;s:11:\"delete-9890\";i:11128;s:11:\"delete-9891\";i:11129;s:11:\"delete-9892\";i:11130;s:11:\"delete-9893\";i:11131;s:11:\"delete-9894\";i:11132;s:11:\"delete-9895\";i:11133;s:11:\"delete-9896\";i:11134;s:11:\"delete-9897\";i:11135;s:11:\"delete-9898\";i:11136;s:11:\"delete-9899\";i:11137;s:11:\"delete-9900\";i:11138;s:11:\"delete-9901\";i:11139;s:11:\"delete-9902\";i:11140;s:11:\"delete-9903\";i:11141;s:11:\"delete-9904\";i:11142;s:11:\"delete-9905\";i:11143;s:11:\"delete-9906\";i:11144;s:11:\"delete-9907\";i:11145;s:11:\"delete-9908\";i:11146;s:11:\"delete-9909\";i:11147;s:11:\"delete-9910\";i:11148;s:11:\"delete-9911\";i:11149;s:11:\"delete-9912\";i:11150;s:11:\"delete-9913\";i:11151;s:11:\"delete-9914\";i:11152;s:11:\"delete-9915\";i:11153;s:11:\"delete-9916\";i:11154;s:11:\"delete-9917\";i:11155;s:11:\"delete-9918\";i:11156;s:11:\"delete-9919\";i:11157;s:11:\"delete-9920\";i:11158;s:11:\"delete-9921\";i:11159;s:11:\"delete-9922\";i:11160;s:11:\"delete-9923\";i:11161;s:11:\"delete-9924\";i:11162;s:11:\"delete-9925\";i:11163;s:11:\"delete-9926\";i:11164;s:11:\"delete-9927\";i:11165;s:11:\"delete-9928\";i:11166;s:11:\"delete-9929\";i:11167;s:11:\"delete-9930\";i:11168;s:11:\"delete-9931\";i:11169;s:11:\"delete-9932\";i:11170;s:11:\"delete-9933\";i:11171;s:11:\"delete-9934\";i:11172;s:11:\"delete-9935\";i:11173;s:11:\"delete-9936\";i:11174;s:11:\"delete-9937\";i:11175;s:11:\"delete-9938\";i:11176;s:11:\"delete-9939\";i:11177;s:11:\"delete-9940\";i:11178;s:11:\"delete-9941\";i:11179;s:11:\"delete-9942\";i:11180;s:11:\"delete-9943\";i:11181;s:11:\"delete-9944\";i:11182;s:11:\"delete-9945\";i:11183;s:11:\"delete-9946\";i:11184;s:11:\"delete-9947\";i:11185;s:11:\"delete-9948\";i:11186;s:11:\"delete-9949\";i:11187;s:11:\"delete-9950\";i:11188;s:11:\"delete-9951\";i:11189;s:11:\"delete-9952\";i:11190;s:11:\"delete-9953\";i:11191;s:11:\"delete-9954\";i:11192;s:11:\"delete-9955\";i:11193;s:11:\"delete-9956\";i:11194;s:11:\"delete-9957\";i:11195;s:11:\"delete-9958\";i:11196;s:11:\"delete-9959\";i:11197;s:11:\"delete-9960\";i:11198;s:11:\"delete-9961\";i:11199;s:11:\"delete-9962\";i:11200;s:11:\"delete-9963\";i:11201;s:11:\"delete-9964\";i:11202;s:11:\"delete-9965\";i:11203;s:11:\"delete-9966\";i:11204;s:11:\"delete-9967\";i:11205;s:11:\"delete-9968\";i:11206;s:11:\"delete-9969\";i:11207;s:11:\"delete-9970\";i:11208;s:11:\"delete-9971\";i:11209;s:11:\"delete-9972\";i:11210;s:11:\"delete-9973\";i:11211;s:11:\"delete-9974\";i:11212;s:11:\"delete-9975\";i:11213;s:11:\"delete-9976\";i:11214;s:11:\"delete-9977\";i:11215;s:11:\"delete-9978\";i:11216;s:11:\"delete-9979\";i:11217;s:11:\"delete-9980\";i:11218;s:11:\"delete-9981\";i:11219;s:11:\"delete-9982\";i:11220;s:11:\"delete-9983\";i:11221;s:11:\"delete-9984\";i:11222;s:11:\"delete-9985\";i:11223;s:11:\"delete-9986\";i:11224;s:11:\"delete-9987\";i:11225;s:11:\"delete-9988\";i:11226;s:11:\"delete-9989\";i:11227;s:11:\"delete-9990\";i:11228;s:11:\"delete-9991\";i:11229;s:11:\"delete-9992\";i:11230;s:11:\"delete-9993\";i:11231;s:11:\"delete-9994\";i:11232;s:11:\"delete-9995\";i:11233;s:11:\"delete-9996\";i:11234;s:11:\"delete-9997\";i:11235;s:11:\"delete-9998\";i:11236;s:11:\"delete-9999\";i:11237;s:12:\"delete-10000\";i:11238;s:12:\"delete-10001\";i:11239;s:12:\"delete-10002\";i:11240;s:12:\"delete-10003\";i:11241;s:12:\"delete-10004\";i:11242;s:12:\"delete-10005\";i:11243;s:12:\"delete-10006\";i:11244;s:12:\"delete-10007\";i:11245;s:12:\"delete-10008\";i:11246;s:12:\"delete-10009\";i:11247;s:12:\"delete-10010\";i:11248;s:12:\"delete-10011\";i:11249;s:12:\"delete-10012\";i:11250;s:12:\"delete-10013\";i:11251;s:12:\"delete-10014\";i:11252;s:12:\"delete-10015\";i:11253;s:12:\"delete-10016\";i:11254;s:12:\"delete-10017\";i:11255;s:12:\"delete-10018\";i:11256;s:12:\"delete-10019\";i:11257;s:12:\"delete-10020\";i:11258;s:12:\"delete-10021\";i:11259;s:12:\"delete-10022\";i:11260;s:12:\"delete-10023\";i:11261;s:12:\"delete-10024\";i:11262;s:12:\"delete-10025\";i:11263;s:12:\"delete-10026\";i:11264;s:12:\"delete-10027\";i:11265;s:12:\"delete-10028\";i:11266;s:12:\"delete-10029\";i:11267;s:12:\"delete-10030\";i:11268;s:12:\"delete-10031\";i:11269;s:12:\"delete-10032\";i:11270;s:12:\"delete-10033\";i:11271;s:12:\"delete-10034\";i:11272;s:12:\"delete-10035\";i:11273;s:12:\"delete-10036\";i:11274;s:12:\"delete-10037\";i:11275;s:12:\"delete-10038\";i:11276;s:12:\"delete-10039\";i:11277;s:12:\"delete-10040\";i:11278;s:12:\"delete-10041\";i:11279;s:12:\"delete-10042\";i:11280;s:12:\"delete-10043\";i:11281;s:12:\"delete-10044\";i:11282;s:12:\"delete-10045\";i:11283;s:12:\"delete-10046\";i:11284;s:12:\"delete-10047\";i:11285;s:12:\"delete-10048\";i:11286;s:12:\"delete-10049\";i:11287;s:12:\"delete-10050\";i:11288;s:12:\"delete-10051\";i:11289;s:12:\"delete-10052\";i:11290;s:12:\"delete-10053\";i:11291;s:12:\"delete-10054\";i:11292;s:12:\"delete-10055\";i:11293;s:12:\"delete-10056\";i:11294;s:12:\"delete-10057\";i:11295;s:12:\"delete-10058\";i:11296;s:12:\"delete-10059\";i:11297;s:12:\"delete-10060\";i:11298;s:12:\"delete-10061\";i:11299;s:12:\"delete-10062\";i:11300;s:12:\"delete-10063\";i:11301;s:12:\"delete-10064\";i:11302;s:12:\"delete-10065\";i:11303;s:12:\"delete-10066\";i:11304;s:12:\"delete-10067\";i:11305;s:12:\"delete-10068\";i:11306;s:12:\"delete-10069\";i:11307;s:12:\"delete-10070\";i:11308;s:12:\"delete-10071\";i:11309;s:12:\"delete-10072\";i:11310;s:12:\"delete-10073\";i:11311;s:12:\"delete-10074\";i:11312;s:12:\"delete-10075\";i:11313;s:12:\"delete-10076\";i:11314;s:12:\"delete-10077\";i:11315;s:12:\"delete-10078\";i:11316;s:12:\"delete-10079\";i:11317;s:12:\"delete-10080\";i:11318;s:12:\"delete-10081\";i:11319;s:12:\"delete-10082\";i:11320;s:12:\"delete-10083\";i:11321;s:12:\"delete-10084\";i:11322;s:12:\"delete-10085\";i:11323;s:12:\"delete-10086\";i:11324;s:12:\"delete-10087\";i:11325;s:12:\"delete-10088\";i:11326;s:12:\"delete-10089\";i:11327;s:12:\"delete-10090\";i:11328;s:12:\"delete-10091\";i:11329;s:12:\"delete-10092\";i:11330;s:12:\"delete-10093\";i:11331;s:12:\"delete-10094\";i:11332;s:12:\"delete-10095\";i:11333;s:12:\"delete-10096\";i:11334;s:12:\"delete-10097\";i:11335;s:12:\"delete-10098\";i:11336;s:12:\"delete-10099\";i:11337;s:12:\"delete-10100\";i:11338;s:12:\"delete-10101\";i:11339;s:12:\"delete-10102\";i:11340;s:12:\"delete-10103\";i:11341;s:12:\"delete-10104\";i:11342;s:12:\"delete-10105\";i:11343;s:12:\"delete-10106\";i:11344;s:12:\"delete-10107\";i:11345;s:12:\"delete-10108\";i:11346;s:12:\"delete-10109\";i:11347;s:12:\"delete-10110\";i:11348;s:12:\"delete-10111\";i:11349;s:12:\"delete-10112\";i:11350;s:12:\"delete-10113\";i:11351;s:12:\"delete-10114\";i:11352;s:12:\"delete-10115\";i:11353;s:12:\"delete-10116\";i:11354;s:12:\"delete-10117\";i:11355;s:12:\"delete-10118\";i:11356;s:12:\"delete-10119\";i:11357;s:12:\"delete-10120\";i:11358;s:12:\"delete-10121\";i:11359;s:12:\"delete-10122\";i:11360;s:12:\"delete-10123\";i:11361;s:12:\"delete-10124\";i:11362;s:12:\"delete-10125\";i:11363;s:12:\"delete-10126\";i:11364;s:12:\"delete-10127\";i:11365;s:12:\"delete-10128\";i:11366;s:12:\"delete-10129\";i:11367;s:12:\"delete-10130\";i:11368;s:12:\"delete-10131\";i:11369;s:12:\"delete-10132\";i:11370;s:12:\"delete-10133\";i:11371;s:12:\"delete-10134\";i:11372;s:12:\"delete-10135\";i:11373;s:12:\"delete-10136\";i:11374;s:12:\"delete-10137\";i:11375;s:12:\"delete-10138\";i:11376;s:12:\"delete-10139\";i:11377;s:12:\"delete-10140\";i:11378;s:12:\"delete-10141\";i:11379;s:12:\"delete-10142\";i:11380;s:12:\"delete-10143\";i:11381;s:12:\"delete-10144\";i:11382;s:12:\"delete-10145\";i:11383;s:12:\"delete-10146\";i:11384;s:12:\"delete-10147\";i:11385;s:12:\"delete-10148\";i:11386;s:12:\"delete-10149\";i:11387;s:12:\"delete-10150\";i:11388;s:12:\"delete-10151\";i:11389;s:12:\"delete-10152\";i:11390;s:12:\"delete-10153\";i:11391;s:12:\"delete-10154\";i:11392;s:12:\"delete-10155\";i:11393;s:12:\"delete-10156\";i:11394;s:12:\"delete-10157\";i:11395;s:12:\"delete-10158\";i:11396;s:12:\"delete-10159\";i:11397;s:12:\"delete-10160\";i:11398;s:12:\"delete-10161\";i:11399;s:12:\"delete-10162\";i:11400;s:12:\"delete-10163\";i:11401;s:12:\"delete-10164\";i:11402;s:12:\"delete-10165\";i:11403;s:12:\"delete-10166\";i:11404;s:12:\"delete-10167\";i:11405;s:12:\"delete-10168\";i:11406;s:12:\"delete-10169\";i:11407;s:12:\"delete-10170\";i:11408;s:12:\"delete-10171\";i:11409;s:12:\"delete-10172\";i:11410;s:12:\"delete-10173\";i:11411;s:12:\"delete-10174\";i:11412;s:12:\"delete-10175\";i:11413;s:12:\"delete-10176\";i:11414;s:12:\"delete-10177\";i:11415;s:12:\"delete-10178\";i:11416;s:12:\"delete-10179\";i:11417;s:12:\"delete-10180\";i:11418;s:12:\"delete-10181\";i:11419;s:12:\"delete-10182\";i:11420;s:12:\"delete-10183\";i:11421;s:12:\"delete-10184\";i:11422;s:12:\"delete-10185\";i:11423;s:12:\"delete-10186\";i:11424;s:12:\"delete-10187\";i:11425;s:12:\"delete-10188\";i:11426;s:12:\"delete-10189\";i:11427;s:12:\"delete-10190\";i:11428;s:12:\"delete-10191\";i:11429;s:12:\"delete-10192\";i:11430;s:12:\"delete-10193\";i:11431;s:12:\"delete-10194\";i:11432;s:12:\"delete-10195\";i:11433;s:12:\"delete-10196\";i:11434;s:12:\"delete-10197\";i:11435;s:12:\"delete-10198\";i:11436;s:12:\"delete-10199\";i:11437;s:12:\"delete-10200\";i:11438;s:12:\"delete-10201\";i:11439;s:12:\"delete-10202\";i:11440;s:12:\"delete-10203\";i:11441;s:12:\"delete-10204\";i:11442;s:12:\"delete-10205\";i:11443;s:12:\"delete-10206\";i:11444;s:12:\"delete-10207\";i:11445;s:12:\"delete-10208\";i:11446;s:12:\"delete-10209\";i:11447;s:12:\"delete-10210\";i:11448;s:12:\"delete-10211\";i:11449;s:12:\"delete-10212\";i:11450;s:12:\"delete-10213\";i:11451;s:12:\"delete-10214\";i:11452;s:12:\"delete-10215\";i:11453;s:12:\"delete-10216\";i:11454;s:12:\"delete-10217\";i:11455;s:12:\"delete-10218\";i:11456;s:12:\"delete-10219\";i:11457;s:12:\"delete-10220\";i:11458;s:12:\"delete-10221\";i:11459;s:12:\"delete-10222\";i:11460;s:12:\"delete-10223\";i:11461;s:12:\"delete-10224\";i:11462;s:12:\"delete-10225\";i:11463;s:12:\"delete-10226\";i:11464;s:12:\"delete-10227\";i:11465;s:12:\"delete-10228\";i:11466;s:12:\"delete-10229\";i:11467;s:12:\"delete-10230\";i:11468;s:12:\"delete-10231\";i:11469;s:12:\"delete-10232\";i:11470;s:12:\"delete-10233\";i:11471;s:12:\"delete-10234\";i:11472;s:12:\"delete-10235\";i:11473;s:12:\"delete-10236\";i:11474;s:12:\"delete-10237\";i:11475;s:12:\"delete-10238\";i:11476;s:12:\"delete-10239\";i:11477;s:12:\"delete-10240\";i:11478;s:12:\"delete-10241\";i:11479;s:12:\"delete-10242\";i:11480;s:12:\"delete-10243\";i:11481;s:12:\"delete-10244\";i:11482;s:12:\"delete-10245\";i:11483;s:12:\"delete-10246\";i:11484;s:12:\"delete-10247\";i:11485;s:12:\"delete-10248\";i:11486;s:12:\"delete-10249\";i:11487;s:12:\"delete-10250\";i:11488;s:12:\"delete-10251\";i:11489;s:12:\"delete-10252\";i:11490;s:12:\"delete-10253\";i:11491;s:12:\"delete-10254\";i:11492;s:12:\"delete-10255\";i:11493;s:12:\"delete-10256\";i:11494;s:12:\"delete-10257\";i:11495;s:12:\"delete-10258\";i:11496;s:12:\"delete-10259\";i:11497;s:12:\"delete-10260\";i:11498;s:12:\"delete-10261\";i:11499;s:12:\"delete-10262\";i:11500;s:12:\"delete-10263\";i:11501;s:12:\"delete-10264\";i:11502;s:12:\"delete-10265\";i:11503;s:12:\"delete-10266\";i:11504;s:12:\"delete-10267\";i:11505;s:12:\"delete-10268\";i:11506;s:12:\"delete-10269\";i:11507;s:12:\"delete-10270\";i:11508;s:12:\"delete-10271\";i:11509;s:12:\"delete-10272\";i:11510;s:12:\"delete-10273\";i:11511;s:12:\"delete-10274\";i:11512;s:12:\"delete-10275\";i:11513;s:12:\"delete-10276\";i:11514;s:12:\"delete-10277\";i:11515;s:12:\"delete-10278\";i:11516;s:12:\"delete-10279\";i:11517;s:12:\"delete-10280\";i:11518;s:12:\"delete-10281\";i:11519;s:12:\"delete-10282\";i:11520;s:12:\"delete-10283\";i:11521;s:12:\"delete-10284\";i:11522;s:12:\"delete-10285\";i:11523;s:12:\"delete-10286\";i:11524;s:12:\"delete-10287\";i:11525;s:12:\"delete-10288\";i:11526;s:12:\"delete-10289\";i:11527;s:12:\"delete-10290\";i:11528;s:12:\"delete-10291\";i:11529;s:12:\"delete-10292\";i:11530;s:12:\"delete-10293\";i:11531;s:12:\"delete-10294\";i:11532;s:12:\"delete-10295\";i:11533;s:12:\"delete-10296\";i:11534;s:12:\"delete-10297\";i:11535;s:12:\"delete-10298\";i:11536;s:12:\"delete-10299\";i:11537;s:12:\"delete-10300\";i:11538;s:12:\"delete-10301\";i:11539;s:12:\"delete-10302\";i:11540;s:12:\"delete-10303\";i:11541;s:12:\"delete-10304\";i:11542;s:12:\"delete-10305\";i:11543;s:12:\"delete-10306\";i:11544;s:12:\"delete-10307\";i:11545;s:12:\"delete-10308\";i:11546;s:12:\"delete-10309\";i:11547;s:12:\"delete-10310\";i:11548;s:12:\"delete-10311\";i:11549;s:12:\"delete-10312\";i:11550;s:12:\"delete-10313\";i:11551;s:12:\"delete-10314\";i:11552;s:12:\"delete-10315\";i:11553;s:12:\"delete-10316\";i:11554;s:12:\"delete-10317\";i:11555;s:12:\"delete-10318\";i:11556;s:12:\"delete-10319\";i:11557;s:12:\"delete-10320\";i:11558;s:12:\"delete-10321\";i:11559;s:12:\"delete-10322\";i:11560;s:12:\"delete-10323\";i:11561;s:12:\"delete-10324\";i:11562;s:12:\"delete-10325\";i:11563;s:12:\"delete-10326\";i:11564;s:12:\"delete-10327\";i:11565;s:12:\"delete-10328\";i:11566;s:12:\"delete-10329\";i:11567;s:12:\"delete-10330\";i:11568;s:12:\"delete-10331\";i:11569;s:12:\"delete-10332\";i:11570;s:12:\"delete-10333\";i:11571;s:12:\"delete-10334\";i:11572;s:12:\"delete-10335\";i:11573;s:12:\"delete-10336\";i:11574;s:12:\"delete-10337\";i:11575;s:12:\"delete-10338\";i:11576;s:12:\"delete-10339\";i:11577;s:12:\"delete-10340\";i:11578;s:12:\"delete-10341\";i:11579;s:12:\"delete-10342\";i:11580;s:12:\"delete-10343\";i:11581;s:12:\"delete-10344\";i:11582;s:12:\"delete-10345\";i:11583;s:12:\"delete-10346\";i:11584;s:12:\"delete-10347\";i:11585;s:12:\"delete-10348\";i:11586;s:12:\"delete-10349\";i:11587;s:12:\"delete-10350\";i:11588;s:12:\"delete-10351\";i:11589;s:12:\"delete-10352\";i:11590;s:12:\"delete-10353\";i:11591;s:12:\"delete-10354\";i:11592;s:12:\"delete-10355\";i:11593;s:12:\"delete-10356\";i:11594;s:12:\"delete-10357\";i:11595;s:12:\"delete-10358\";i:11596;s:12:\"delete-10359\";i:11597;s:12:\"delete-10360\";i:11598;s:12:\"delete-10361\";i:11599;s:12:\"delete-10362\";i:11600;s:12:\"delete-10363\";i:11601;s:12:\"delete-10364\";i:11602;s:12:\"delete-10365\";i:11603;s:12:\"delete-10366\";i:11604;s:12:\"delete-10367\";i:11605;s:12:\"delete-10368\";i:11606;s:12:\"delete-10369\";i:11607;s:12:\"delete-10370\";i:11608;s:12:\"delete-10371\";i:11609;s:12:\"delete-10372\";i:11610;s:12:\"delete-10373\";i:11611;s:12:\"delete-10374\";i:11612;s:12:\"delete-10375\";i:11613;s:12:\"delete-10376\";i:11614;s:12:\"delete-10377\";i:11615;s:12:\"delete-10378\";i:11616;s:12:\"delete-10379\";i:11617;s:12:\"delete-10380\";i:11618;s:12:\"delete-10381\";i:11619;s:12:\"delete-10382\";i:11620;s:12:\"delete-10383\";i:11621;s:12:\"delete-10384\";i:11622;s:12:\"delete-10385\";i:11623;s:12:\"delete-10386\";i:11624;s:12:\"delete-10387\";i:11625;s:12:\"delete-10388\";i:11626;s:12:\"delete-10389\";i:11627;s:12:\"delete-10390\";i:11628;s:12:\"delete-10391\";i:11629;s:12:\"delete-10392\";i:11630;s:12:\"delete-10393\";i:11631;s:12:\"delete-10394\";i:11632;s:12:\"delete-10395\";i:11633;s:12:\"delete-10396\";i:11634;s:12:\"delete-10397\";i:11635;s:12:\"delete-10398\";i:11636;s:12:\"delete-10399\";i:11637;s:12:\"delete-10400\";i:11638;s:12:\"delete-10401\";i:11639;s:12:\"delete-10402\";i:11640;s:12:\"delete-10403\";i:11641;s:12:\"delete-10404\";i:11642;s:12:\"delete-10405\";i:11643;s:12:\"delete-10406\";i:11644;s:12:\"delete-10407\";i:11645;s:12:\"delete-10408\";i:11646;s:12:\"delete-10409\";i:11647;s:12:\"delete-10410\";i:11648;s:12:\"delete-10411\";i:11649;s:12:\"delete-10412\";i:11650;s:12:\"delete-10413\";i:11651;s:12:\"delete-10414\";i:11652;s:12:\"delete-10415\";i:11653;s:12:\"delete-10416\";i:11654;s:12:\"delete-10417\";i:11655;s:12:\"delete-10418\";i:11656;s:12:\"delete-10419\";i:11657;s:12:\"delete-10420\";i:11658;s:12:\"delete-10421\";i:11659;s:12:\"delete-10422\";i:11660;s:12:\"delete-10423\";i:11661;s:12:\"delete-10424\";i:11662;s:12:\"delete-10425\";i:11663;s:12:\"delete-10426\";i:11664;s:12:\"delete-10427\";i:11665;s:12:\"delete-10428\";i:11666;s:12:\"delete-10429\";i:11667;s:12:\"delete-10430\";i:11668;s:12:\"delete-10431\";i:11669;s:12:\"delete-10432\";i:11670;s:12:\"delete-10433\";i:11671;s:12:\"delete-10434\";i:11672;s:12:\"delete-10435\";i:11673;s:12:\"delete-10436\";i:11674;s:12:\"delete-10437\";i:11675;s:12:\"delete-10438\";i:11676;s:12:\"delete-10439\";i:11677;s:12:\"delete-10440\";i:11678;s:12:\"delete-10441\";i:11679;s:12:\"delete-10442\";i:11680;s:12:\"delete-10443\";i:11681;s:12:\"delete-10444\";i:11682;s:12:\"delete-10445\";i:11683;s:12:\"delete-10446\";i:11684;s:12:\"delete-10447\";i:11685;s:12:\"delete-10448\";i:11686;s:12:\"delete-10449\";i:11687;s:12:\"delete-10450\";i:11688;s:12:\"delete-10451\";i:11689;s:12:\"delete-10452\";i:11690;s:12:\"delete-10453\";i:11691;s:12:\"delete-10454\";i:11692;s:12:\"delete-10455\";i:11693;s:12:\"delete-10456\";i:11694;s:12:\"delete-10457\";i:11695;s:12:\"delete-10458\";i:11696;s:12:\"delete-10459\";i:11697;s:12:\"delete-10460\";i:11698;s:12:\"delete-10461\";i:11699;s:12:\"delete-10462\";i:11700;s:12:\"delete-10463\";i:11701;s:12:\"delete-10464\";i:11702;s:12:\"delete-10465\";i:11703;s:12:\"delete-10466\";i:11704;s:12:\"delete-10467\";i:11705;s:12:\"delete-10468\";i:11706;s:12:\"delete-10469\";i:11707;s:12:\"delete-10470\";i:11708;s:12:\"delete-10471\";i:11709;s:12:\"delete-10472\";i:11710;s:12:\"delete-10473\";i:11711;s:12:\"delete-10474\";i:11712;s:12:\"delete-10475\";i:11713;s:12:\"delete-10476\";i:11714;s:12:\"delete-10477\";i:11715;s:12:\"delete-10478\";i:11716;s:12:\"delete-10479\";i:11717;s:12:\"delete-10480\";i:11718;s:12:\"delete-10481\";i:11719;s:12:\"delete-10482\";i:11720;s:12:\"delete-10483\";i:11721;s:12:\"delete-10484\";i:11722;s:12:\"delete-10485\";i:11723;s:12:\"delete-10486\";i:11724;s:12:\"delete-10487\";i:11725;s:12:\"delete-10488\";i:11726;s:12:\"delete-10489\";i:11727;s:12:\"delete-10490\";i:11728;s:12:\"delete-10491\";i:11729;s:12:\"delete-10492\";i:11730;s:12:\"delete-10493\";i:11731;s:12:\"delete-10494\";i:11732;s:12:\"delete-10495\";i:11733;s:12:\"delete-10496\";i:11734;s:12:\"delete-10497\";i:11735;s:12:\"delete-10498\";i:11736;s:12:\"delete-10499\";i:11737;s:12:\"delete-10500\";i:11738;s:12:\"delete-10501\";i:11739;s:12:\"delete-10502\";i:11740;s:12:\"delete-10503\";i:11741;s:12:\"delete-10504\";i:11742;s:12:\"delete-10505\";i:11743;s:12:\"delete-10506\";i:11744;s:12:\"delete-10507\";i:11745;s:12:\"delete-10508\";i:11746;s:12:\"delete-10509\";i:11747;s:12:\"delete-10510\";i:11748;s:12:\"delete-10511\";i:11749;s:12:\"delete-10512\";i:11750;s:12:\"delete-10513\";i:11751;s:12:\"delete-10514\";i:11752;s:12:\"delete-10515\";i:11753;s:12:\"delete-10516\";i:11754;s:12:\"delete-10517\";i:11755;s:12:\"delete-10518\";i:11756;s:12:\"delete-10519\";i:11757;s:12:\"delete-10520\";i:11758;s:12:\"delete-10521\";i:11759;s:12:\"delete-10522\";i:11760;s:12:\"delete-10523\";i:11761;s:12:\"delete-10524\";i:11762;s:12:\"delete-10525\";i:11763;s:12:\"delete-10526\";i:11764;s:12:\"delete-10527\";i:11765;s:12:\"delete-10528\";i:11766;s:12:\"delete-10529\";i:11767;s:12:\"delete-10530\";i:11768;s:12:\"delete-10531\";i:11769;s:12:\"delete-10532\";i:11770;s:12:\"delete-10533\";i:11771;s:12:\"delete-10534\";i:11772;s:12:\"delete-10535\";i:11773;s:12:\"delete-10536\";i:11774;s:12:\"delete-10537\";i:11775;s:12:\"delete-10538\";i:11776;s:12:\"delete-10539\";i:11777;s:12:\"delete-10540\";i:11778;s:12:\"delete-10541\";i:11779;s:12:\"delete-10542\";i:11780;s:12:\"delete-10543\";i:11781;s:12:\"delete-10544\";i:11782;s:12:\"delete-10545\";i:11783;s:12:\"delete-10546\";i:11784;s:12:\"delete-10547\";i:11785;s:12:\"delete-10548\";i:11786;s:12:\"delete-10549\";i:11787;s:12:\"delete-10550\";i:11788;s:12:\"delete-10551\";i:11789;s:12:\"delete-10552\";i:11790;s:12:\"delete-10553\";i:11791;s:12:\"delete-10554\";i:11792;s:12:\"delete-10555\";i:11793;s:12:\"delete-10556\";i:11794;s:12:\"delete-10557\";i:11795;s:12:\"delete-10558\";i:11796;s:12:\"delete-10559\";i:11797;s:12:\"delete-10560\";i:11798;s:12:\"delete-10561\";i:11799;s:12:\"delete-10562\";i:11800;s:12:\"delete-10563\";i:11801;s:12:\"delete-10564\";i:11802;s:12:\"delete-10565\";i:11803;s:12:\"delete-10566\";i:11804;s:12:\"delete-10567\";i:11805;s:12:\"delete-10568\";i:11806;s:12:\"delete-10569\";i:11807;s:12:\"delete-10570\";i:11808;s:12:\"delete-10571\";i:11809;s:12:\"delete-10572\";i:11810;s:12:\"delete-10573\";i:11811;s:12:\"delete-10574\";i:11812;s:12:\"delete-10575\";i:11813;s:12:\"delete-10576\";i:11814;s:12:\"delete-10577\";i:11815;s:12:\"delete-10578\";i:11816;s:12:\"delete-10579\";i:11817;s:12:\"delete-10580\";i:11818;s:12:\"delete-10581\";i:11819;s:12:\"delete-10582\";i:11820;s:12:\"delete-10583\";i:11821;s:12:\"delete-10584\";i:11822;s:12:\"delete-10585\";i:11823;s:12:\"delete-10586\";i:11824;s:12:\"delete-10587\";i:11825;s:12:\"delete-10588\";i:11826;s:12:\"delete-10589\";i:11827;s:12:\"delete-10590\";i:11828;s:12:\"delete-10591\";i:11829;s:12:\"delete-10592\";i:11830;s:12:\"delete-10593\";i:11831;s:12:\"delete-10594\";i:11832;s:12:\"delete-10595\";i:11833;s:12:\"delete-10596\";i:11834;s:12:\"delete-10597\";i:11835;s:12:\"delete-10598\";i:11836;s:12:\"delete-10599\";i:11837;s:12:\"delete-10600\";i:11838;s:12:\"delete-10601\";i:11839;s:12:\"delete-10602\";i:11840;s:12:\"delete-10603\";i:11841;s:12:\"delete-10604\";i:11842;s:12:\"delete-10605\";i:11843;s:12:\"delete-10606\";i:11844;s:12:\"delete-10607\";i:11845;s:12:\"delete-10608\";i:11846;s:12:\"delete-10609\";i:11847;s:12:\"delete-10610\";i:11848;s:12:\"delete-10611\";i:11849;s:12:\"delete-10612\";i:11850;s:12:\"delete-10613\";i:11851;s:12:\"delete-10614\";i:11852;s:12:\"delete-10615\";i:11853;s:12:\"delete-10616\";i:11854;s:12:\"delete-10617\";i:11855;s:12:\"delete-10618\";i:11856;s:12:\"delete-10619\";i:11857;s:12:\"delete-10620\";i:11858;s:12:\"delete-10621\";i:11859;s:12:\"delete-10622\";i:11860;s:12:\"delete-10623\";i:11861;s:12:\"delete-10624\";i:11862;s:12:\"delete-10625\";i:11863;s:12:\"delete-10626\";i:11864;s:12:\"delete-10627\";i:11865;s:12:\"delete-10628\";i:11866;s:12:\"delete-10629\";i:11867;s:12:\"delete-10630\";i:11868;s:12:\"delete-10631\";i:11869;s:12:\"delete-10632\";i:11870;s:12:\"delete-10633\";i:11871;s:12:\"delete-10634\";i:11872;s:12:\"delete-10635\";i:11873;s:12:\"delete-10636\";i:11874;s:12:\"delete-10637\";i:11875;s:12:\"delete-10638\";i:11876;s:12:\"delete-10639\";i:11877;s:12:\"delete-10640\";i:11878;s:12:\"delete-10641\";i:11879;s:12:\"delete-10642\";i:11880;s:12:\"delete-10643\";i:11881;s:12:\"delete-10644\";i:11882;s:12:\"delete-10645\";i:11883;s:12:\"delete-10646\";i:11884;s:12:\"delete-10647\";i:11885;s:12:\"delete-10648\";i:11886;s:12:\"delete-10649\";i:11887;s:12:\"delete-10650\";i:11888;s:12:\"delete-10651\";i:11889;s:12:\"delete-10652\";i:11890;s:12:\"delete-10653\";i:11891;s:12:\"delete-10654\";i:11892;s:12:\"delete-10655\";i:11893;s:12:\"delete-10656\";i:11894;s:12:\"delete-10657\";i:11895;s:12:\"delete-10658\";i:11896;s:12:\"delete-10659\";i:11897;s:12:\"delete-10660\";i:11898;s:12:\"delete-10661\";i:11899;s:12:\"delete-10662\";i:11900;s:12:\"delete-10663\";i:11901;s:12:\"delete-10664\";i:11902;s:12:\"delete-10665\";i:11903;s:12:\"delete-10666\";i:11904;s:12:\"delete-10667\";i:11905;s:12:\"delete-10668\";i:11906;s:12:\"delete-10669\";i:11907;s:12:\"delete-10670\";i:11908;s:12:\"delete-10671\";i:11909;s:12:\"delete-10672\";i:11910;s:12:\"delete-10673\";i:11911;s:12:\"delete-10674\";i:11912;s:12:\"delete-10675\";i:11913;s:12:\"delete-10676\";i:11914;s:12:\"delete-10677\";i:11915;s:12:\"delete-10678\";i:11916;s:12:\"delete-10679\";i:11917;s:12:\"delete-10680\";i:11918;s:12:\"delete-10681\";i:11919;s:12:\"delete-10682\";i:11920;s:12:\"delete-10683\";i:11921;s:12:\"delete-10684\";i:11922;s:12:\"delete-10685\";i:11923;s:12:\"delete-10686\";i:11924;s:12:\"delete-10687\";i:11925;s:12:\"delete-10688\";i:11926;s:12:\"delete-10689\";i:11927;s:12:\"delete-10690\";i:11928;s:12:\"delete-10691\";i:11929;s:12:\"delete-10692\";i:11930;s:12:\"delete-10693\";i:11931;s:12:\"delete-10694\";i:11932;s:12:\"delete-10695\";i:11933;s:12:\"delete-10696\";i:11934;s:12:\"delete-10697\";i:11935;s:12:\"delete-10698\";i:11936;s:12:\"delete-10699\";i:11937;s:12:\"delete-10700\";i:11938;s:12:\"delete-10701\";i:11939;s:12:\"delete-10702\";i:11940;s:12:\"delete-10703\";i:11941;s:12:\"delete-10704\";i:11942;s:12:\"delete-10705\";i:11943;s:12:\"delete-10706\";i:11944;s:12:\"delete-10707\";i:11945;s:12:\"delete-10708\";i:11946;s:12:\"delete-10709\";i:11947;s:12:\"delete-10710\";i:11948;s:12:\"delete-10711\";i:11949;s:12:\"delete-10712\";i:11950;s:12:\"delete-10713\";i:11951;s:12:\"delete-10714\";i:11952;s:12:\"delete-10715\";i:11953;s:12:\"delete-10716\";i:11954;s:12:\"delete-10717\";i:11955;s:12:\"delete-10718\";i:11956;s:12:\"delete-10719\";i:11957;s:12:\"delete-10720\";i:11958;s:12:\"delete-10721\";i:11959;s:12:\"delete-10722\";i:11960;s:12:\"delete-10723\";i:11961;s:12:\"delete-10724\";i:11962;s:12:\"delete-10725\";i:11963;s:12:\"delete-10726\";i:11964;s:12:\"delete-10727\";i:11965;s:12:\"delete-10728\";i:11966;s:12:\"delete-10729\";i:11967;s:12:\"delete-10730\";i:11968;s:12:\"delete-10731\";i:11969;s:12:\"delete-10732\";i:11970;s:12:\"delete-10733\";i:11971;s:12:\"delete-10734\";i:11972;s:12:\"delete-10735\";i:11973;s:12:\"delete-10736\";i:11974;s:12:\"delete-10737\";i:11975;s:12:\"delete-10738\";i:11976;s:12:\"delete-10739\";i:11977;s:12:\"delete-10740\";i:11978;s:12:\"delete-10741\";i:11979;s:12:\"delete-10742\";i:11980;s:12:\"delete-10743\";i:11981;s:12:\"delete-10744\";i:11982;s:12:\"delete-10745\";i:11983;s:12:\"delete-10746\";i:11984;s:12:\"delete-10747\";i:11985;s:12:\"delete-10748\";i:11986;s:12:\"delete-10749\";i:11987;s:12:\"delete-10750\";i:11988;s:12:\"delete-10751\";i:11989;s:12:\"delete-10752\";i:11990;s:12:\"delete-10753\";i:11991;s:12:\"delete-10754\";i:11992;s:12:\"delete-10755\";i:11993;s:12:\"delete-10756\";i:11994;s:12:\"delete-10757\";i:11995;s:12:\"delete-10758\";i:11996;s:12:\"delete-10759\";i:11997;s:12:\"delete-10760\";i:11998;s:12:\"delete-10761\";i:11999;s:12:\"delete-10762\";i:12000;s:12:\"delete-10763\";i:12001;s:12:\"delete-10764\";i:12002;s:12:\"delete-10765\";i:12003;s:12:\"delete-10766\";i:12004;s:12:\"delete-10767\";i:12005;s:12:\"delete-10768\";i:12006;s:12:\"delete-10769\";i:12007;s:12:\"delete-10770\";i:12008;s:12:\"delete-10771\";i:12009;s:12:\"delete-10772\";i:12010;s:12:\"delete-10773\";i:12011;s:12:\"delete-10774\";i:12012;s:12:\"delete-10775\";i:12013;s:12:\"delete-10776\";i:12014;s:12:\"delete-10777\";i:12015;s:12:\"delete-10778\";i:12016;s:12:\"delete-10779\";i:12017;s:12:\"delete-10780\";i:12018;s:12:\"delete-10781\";i:12019;s:12:\"delete-10782\";i:12020;s:12:\"delete-10783\";i:12021;s:12:\"delete-10784\";i:12022;s:12:\"delete-10785\";i:12023;s:12:\"delete-10786\";i:12024;s:12:\"delete-10787\";i:12025;s:12:\"delete-10788\";i:12026;s:12:\"delete-10789\";i:12027;s:12:\"delete-10790\";i:12028;s:12:\"delete-10791\";i:12029;s:12:\"delete-10792\";i:12030;s:12:\"delete-10793\";i:12031;s:12:\"delete-10794\";i:12032;s:12:\"delete-10795\";i:12033;s:12:\"delete-10796\";i:12034;s:12:\"delete-10797\";i:12035;s:12:\"delete-10798\";i:12036;s:12:\"delete-10799\";i:12037;s:12:\"delete-10800\";i:12038;s:12:\"delete-10801\";i:12039;s:12:\"delete-10802\";i:12040;s:12:\"delete-10803\";i:12041;s:12:\"delete-10804\";i:12042;s:12:\"delete-10805\";i:12043;s:12:\"delete-10806\";i:12044;s:12:\"delete-10807\";i:12045;s:12:\"delete-10808\";i:12046;s:12:\"delete-10809\";i:12047;s:12:\"delete-10810\";i:12048;s:12:\"delete-10811\";i:12049;s:12:\"delete-10812\";i:12050;s:12:\"delete-10813\";i:12051;s:12:\"delete-10814\";i:12052;s:12:\"delete-10815\";i:12053;s:12:\"delete-10816\";i:12054;s:12:\"delete-10817\";i:12055;s:12:\"delete-10818\";i:12056;s:12:\"delete-10819\";i:12057;s:12:\"delete-10820\";i:12058;s:12:\"delete-10821\";i:12059;s:12:\"delete-10822\";i:12060;s:12:\"delete-10823\";i:12061;s:12:\"delete-10824\";i:12062;s:12:\"delete-10825\";i:12063;s:12:\"delete-10826\";i:12064;s:12:\"delete-10827\";i:12065;s:12:\"delete-10828\";i:12066;s:12:\"delete-10829\";i:12067;s:12:\"delete-10830\";i:12068;s:12:\"delete-10831\";i:12069;s:12:\"delete-10832\";i:12070;s:12:\"delete-10833\";i:12071;s:12:\"delete-10834\";i:12072;s:12:\"delete-10835\";i:12073;s:12:\"delete-10836\";i:12074;s:12:\"delete-10837\";i:12075;s:12:\"delete-10838\";i:12076;s:12:\"delete-10839\";i:12077;s:12:\"delete-10840\";i:12078;s:12:\"delete-10841\";i:12079;s:12:\"delete-10842\";i:12080;s:12:\"delete-10843\";i:12081;s:12:\"delete-10844\";i:12082;s:12:\"delete-10845\";i:12083;s:12:\"delete-10846\";i:12084;s:12:\"delete-10847\";i:12085;s:12:\"delete-10848\";i:12086;s:12:\"delete-10849\";i:12087;s:12:\"delete-10850\";i:12088;s:12:\"delete-10851\";i:12089;s:12:\"delete-10852\";i:12090;s:12:\"delete-10853\";i:12091;s:12:\"delete-10854\";i:12092;s:12:\"delete-10855\";i:12093;s:12:\"delete-10856\";i:12094;s:12:\"delete-10857\";i:12095;s:12:\"delete-10858\";i:12096;s:12:\"delete-10859\";i:12097;s:12:\"delete-10860\";i:12098;s:12:\"delete-10861\";i:12099;s:12:\"delete-10862\";i:12100;s:12:\"delete-10863\";i:12101;s:12:\"delete-10864\";i:12102;s:12:\"delete-10865\";i:12103;s:12:\"delete-10866\";i:12104;s:12:\"delete-10867\";i:12105;s:12:\"delete-10868\";i:12106;s:12:\"delete-10869\";i:12107;s:12:\"delete-10870\";i:12108;s:12:\"delete-10871\";i:12109;s:12:\"delete-10872\";i:12110;s:12:\"delete-10873\";i:12111;s:12:\"delete-10874\";i:12112;s:12:\"delete-10875\";i:12113;s:12:\"delete-10876\";i:12114;s:12:\"delete-10877\";i:12115;s:12:\"delete-10878\";i:12116;s:12:\"delete-10879\";i:12117;s:12:\"delete-10880\";i:12118;s:12:\"delete-10881\";i:12119;s:12:\"delete-10882\";i:12120;s:12:\"delete-10883\";i:12121;s:12:\"delete-10884\";i:12122;s:12:\"delete-10885\";i:12123;s:12:\"delete-10886\";i:12124;s:12:\"delete-10887\";i:12125;s:12:\"delete-10888\";i:12126;s:12:\"delete-10889\";i:12127;s:12:\"delete-10890\";i:12128;s:12:\"delete-10891\";i:12129;s:12:\"delete-10892\";i:12130;s:12:\"delete-10893\";i:12131;s:12:\"delete-10894\";i:12132;s:12:\"delete-10895\";i:12133;s:12:\"delete-10896\";i:12134;s:12:\"delete-10897\";i:12135;s:12:\"delete-10898\";i:12136;s:12:\"delete-10899\";i:12137;s:12:\"delete-10900\";i:12138;s:12:\"delete-10901\";i:12139;s:12:\"delete-10902\";i:12140;s:12:\"delete-10903\";i:12141;s:12:\"delete-10904\";i:12142;s:12:\"delete-10905\";i:12143;s:12:\"delete-10906\";i:12144;s:12:\"delete-10907\";i:12145;s:12:\"delete-10908\";i:12146;s:12:\"delete-10909\";i:12147;s:12:\"delete-10910\";i:12148;s:12:\"delete-10911\";i:12149;s:12:\"delete-10912\";i:12150;s:12:\"delete-10913\";i:12151;s:12:\"delete-10914\";i:12152;s:12:\"delete-10915\";i:12153;s:12:\"delete-10916\";i:12154;s:12:\"delete-10917\";i:12155;s:12:\"delete-10918\";i:12156;s:12:\"delete-10919\";i:12157;s:12:\"delete-10920\";i:12158;s:12:\"delete-10921\";i:12159;s:12:\"delete-10922\";i:12160;s:12:\"delete-10923\";i:12161;s:12:\"delete-10924\";i:12162;s:12:\"delete-10925\";i:12163;s:12:\"delete-10926\";i:12164;s:12:\"delete-10927\";i:12165;s:12:\"delete-10928\";i:12166;s:12:\"delete-10929\";i:12167;s:12:\"delete-10930\";i:12168;s:12:\"delete-10931\";i:12169;s:12:\"delete-10932\";i:12170;s:12:\"delete-10933\";i:12171;s:12:\"delete-10934\";i:12172;s:12:\"delete-10935\";i:12173;s:12:\"delete-10936\";i:12174;s:12:\"delete-10937\";i:12175;s:12:\"delete-10938\";i:12176;s:12:\"delete-10939\";i:12177;s:12:\"delete-10940\";i:12178;s:12:\"delete-10941\";i:12179;s:12:\"delete-10942\";i:12180;s:12:\"delete-10943\";i:12181;s:12:\"delete-10944\";i:12182;s:12:\"delete-10945\";i:12183;s:12:\"delete-10946\";i:12184;s:12:\"delete-10947\";i:12185;s:12:\"delete-10948\";i:12186;s:12:\"delete-10949\";i:12187;s:12:\"delete-10950\";i:12188;s:12:\"delete-10951\";i:12189;s:12:\"delete-10952\";i:12190;s:12:\"delete-10953\";i:12191;s:12:\"delete-10954\";i:12192;s:12:\"delete-10955\";i:12193;s:12:\"delete-10956\";i:12194;s:12:\"delete-10957\";i:12195;s:12:\"delete-10958\";i:12196;s:12:\"delete-10959\";i:12197;s:12:\"delete-10960\";i:12198;s:12:\"delete-10961\";i:12199;s:12:\"delete-10962\";i:12200;s:12:\"delete-10963\";i:12201;s:12:\"delete-10964\";i:12202;s:12:\"delete-10965\";i:12203;s:12:\"delete-10966\";i:12204;s:12:\"delete-10967\";i:12205;s:12:\"delete-10968\";i:12206;s:12:\"delete-10969\";i:12207;s:12:\"delete-10970\";i:12208;s:12:\"delete-10971\";i:12209;s:12:\"delete-10972\";i:12210;s:12:\"delete-10973\";i:12211;s:12:\"delete-10974\";i:12212;s:12:\"delete-10975\";i:12213;s:12:\"delete-10976\";i:12214;s:12:\"delete-10977\";i:12215;s:12:\"delete-10978\";i:12216;s:12:\"delete-10979\";i:12217;s:12:\"delete-10980\";i:12218;s:12:\"delete-10981\";i:12219;s:12:\"delete-10982\";i:12220;s:12:\"delete-10983\";i:12221;s:12:\"delete-10984\";i:12222;s:12:\"delete-10985\";i:12223;s:12:\"delete-10986\";i:12224;s:12:\"delete-10987\";i:12225;s:12:\"delete-10988\";i:12226;s:12:\"delete-10989\";i:12227;s:12:\"delete-10990\";i:12228;s:12:\"delete-10991\";i:12229;s:12:\"delete-10992\";i:12230;s:12:\"delete-10993\";i:12231;s:12:\"delete-10994\";i:12232;s:12:\"delete-10995\";i:12233;s:12:\"delete-10996\";i:12234;s:12:\"delete-10997\";i:12235;s:12:\"delete-10998\";i:12236;s:12:\"delete-10999\";i:12237;s:12:\"delete-11000\";i:12238;s:12:\"delete-11001\";i:12239;s:12:\"delete-11002\";i:12240;s:12:\"delete-11003\";i:12241;s:12:\"delete-11004\";i:12242;s:12:\"delete-11005\";i:12243;s:12:\"delete-11006\";i:12244;s:12:\"delete-11007\";i:12245;s:12:\"delete-11008\";i:12246;s:12:\"delete-11009\";i:12247;s:12:\"delete-11010\";i:12248;s:12:\"delete-11011\";i:12249;s:12:\"delete-11012\";i:12250;s:12:\"delete-11013\";i:12251;s:12:\"delete-11014\";i:12252;s:12:\"delete-11015\";i:12253;s:12:\"delete-11016\";i:12254;s:12:\"delete-11017\";i:12255;s:12:\"delete-11018\";i:12256;s:12:\"delete-11019\";i:12257;s:12:\"delete-11020\";i:12258;s:12:\"delete-11021\";i:12259;s:12:\"delete-11022\";i:12260;s:12:\"delete-11023\";i:12261;s:12:\"delete-11024\";i:12262;s:12:\"delete-11025\";i:12263;s:12:\"delete-11026\";i:12264;s:12:\"delete-11027\";i:12265;s:12:\"delete-11028\";i:12266;s:12:\"delete-11029\";i:12267;s:12:\"delete-11030\";i:12268;s:12:\"delete-11031\";i:12269;s:12:\"delete-11032\";i:12270;s:12:\"delete-11033\";i:12271;s:12:\"delete-11034\";i:12272;s:12:\"delete-11035\";i:12273;s:12:\"delete-11036\";i:12274;s:12:\"delete-11037\";i:12275;s:12:\"delete-11038\";i:12276;s:12:\"delete-11039\";i:12277;s:12:\"delete-11040\";i:12278;s:12:\"delete-11041\";i:12279;s:12:\"delete-11042\";i:12280;s:12:\"delete-11043\";i:12281;s:12:\"delete-11044\";i:12282;s:12:\"delete-11045\";i:12283;s:12:\"delete-11046\";i:12284;s:12:\"delete-11047\";i:12285;s:12:\"delete-11048\";i:12286;s:12:\"delete-11049\";i:12287;s:12:\"delete-11050\";i:12288;s:12:\"delete-11051\";i:12289;s:12:\"delete-11052\";i:12290;s:12:\"delete-11053\";i:12291;s:12:\"delete-11054\";i:12292;s:12:\"delete-11055\";i:12293;s:12:\"delete-11056\";i:12294;s:12:\"delete-11057\";i:12295;s:12:\"delete-11058\";i:12296;s:12:\"delete-11059\";i:12297;s:12:\"delete-11060\";i:12298;s:12:\"delete-11061\";i:12299;s:12:\"delete-11062\";i:12300;s:12:\"delete-11063\";i:12301;s:12:\"delete-11064\";i:12302;s:12:\"delete-11065\";i:12303;s:12:\"delete-11066\";i:12304;s:12:\"delete-11067\";i:12305;s:12:\"delete-11068\";i:12306;s:12:\"delete-11069\";i:12307;s:12:\"delete-11070\";i:12308;s:12:\"delete-11071\";i:12309;s:12:\"delete-11072\";i:12310;s:12:\"delete-11073\";i:12311;s:12:\"delete-11074\";i:12312;s:12:\"delete-11075\";i:12313;s:12:\"delete-11076\";i:12314;s:12:\"delete-11077\";i:12315;s:12:\"delete-11078\";i:12316;s:12:\"delete-11079\";i:12317;s:12:\"delete-11080\";i:12318;s:12:\"delete-11081\";i:12319;s:12:\"delete-11082\";i:12320;s:12:\"delete-11083\";i:12321;s:12:\"delete-11084\";i:12322;s:12:\"delete-11085\";i:12323;s:12:\"delete-11086\";i:12324;s:12:\"delete-11087\";i:12325;s:12:\"delete-11088\";i:12326;s:12:\"delete-11089\";i:12327;s:12:\"delete-11090\";i:12328;s:12:\"delete-11091\";i:12329;s:12:\"delete-11092\";i:12330;s:12:\"delete-11093\";i:12331;s:12:\"delete-11094\";i:12332;s:12:\"delete-11095\";i:12333;s:12:\"delete-11096\";i:12334;s:12:\"delete-11097\";i:12335;s:12:\"delete-11098\";i:12336;s:12:\"delete-11099\";i:12337;s:12:\"delete-11100\";i:12338;s:12:\"delete-11101\";i:12339;s:12:\"delete-11102\";i:12340;s:12:\"delete-11103\";i:12341;s:12:\"delete-11104\";i:12342;s:12:\"delete-11105\";i:12343;s:12:\"delete-11106\";i:12344;s:12:\"delete-11107\";i:12345;s:12:\"delete-11108\";i:12346;s:12:\"delete-11109\";i:12347;s:12:\"delete-11110\";i:12348;s:12:\"delete-11111\";i:12349;s:12:\"delete-11112\";i:12350;s:12:\"delete-11113\";i:12351;s:12:\"delete-11114\";i:12352;s:12:\"delete-11115\";i:12353;s:12:\"delete-11116\";i:12354;s:12:\"delete-11117\";i:12355;s:12:\"delete-11118\";i:12356;s:12:\"delete-11119\";i:12357;s:12:\"delete-11120\";i:12358;s:12:\"delete-11121\";i:12359;s:12:\"delete-11122\";i:12360;s:12:\"delete-11123\";i:12361;s:12:\"delete-11124\";i:12362;s:12:\"delete-11125\";i:12363;s:12:\"delete-11126\";i:12364;s:12:\"delete-11127\";i:12365;s:12:\"delete-11128\";i:12366;s:12:\"delete-11129\";i:12367;s:12:\"delete-11130\";i:12368;s:12:\"delete-11131\";i:12369;s:12:\"delete-11132\";i:12370;s:12:\"delete-11133\";i:12371;s:12:\"delete-11134\";i:12372;s:12:\"delete-11135\";i:12373;s:12:\"delete-11136\";i:12374;s:12:\"delete-11137\";i:12375;s:12:\"delete-11138\";i:12376;s:12:\"delete-11139\";i:12377;s:12:\"delete-11140\";i:12378;s:12:\"delete-11141\";i:12379;s:12:\"delete-11142\";i:12380;s:12:\"delete-11143\";i:12381;s:12:\"delete-11144\";i:12382;s:12:\"delete-11145\";i:12383;s:12:\"delete-11146\";i:12384;s:12:\"delete-11147\";i:12385;s:12:\"delete-11148\";i:12386;s:12:\"delete-11149\";i:12387;s:12:\"delete-11150\";i:12388;s:12:\"delete-11151\";i:12389;s:12:\"delete-11152\";i:12390;s:12:\"delete-11153\";i:12391;s:12:\"delete-11154\";i:12392;s:12:\"delete-11155\";i:12393;s:12:\"delete-11156\";i:12394;s:12:\"delete-11157\";i:12395;s:12:\"delete-11158\";i:12396;s:12:\"delete-11159\";i:12397;s:12:\"delete-11160\";i:12398;s:12:\"delete-11161\";i:12399;s:12:\"delete-11162\";i:12400;s:12:\"delete-11163\";i:12401;s:12:\"delete-11164\";i:12402;s:12:\"delete-11165\";i:12403;s:12:\"delete-11166\";i:12404;s:12:\"delete-11167\";i:12405;s:12:\"delete-11168\";i:12406;s:12:\"delete-11169\";i:12407;s:12:\"delete-11170\";i:12408;s:12:\"delete-11171\";i:12409;s:12:\"delete-11172\";i:12410;s:12:\"delete-11173\";i:12411;s:12:\"delete-11174\";i:12412;s:12:\"delete-11175\";i:12413;s:12:\"delete-11176\";i:12414;s:12:\"delete-11177\";i:12415;s:12:\"delete-11178\";i:12416;s:12:\"delete-11179\";i:12417;s:12:\"delete-11180\";i:12418;s:12:\"delete-11181\";i:12419;s:12:\"delete-11182\";i:12420;s:12:\"delete-11183\";i:12421;s:12:\"delete-11184\";i:12422;s:12:\"delete-11185\";i:12423;s:12:\"delete-11186\";i:12424;s:12:\"delete-11187\";i:12425;s:12:\"delete-11188\";i:12426;s:12:\"delete-11189\";i:12427;s:12:\"delete-11190\";i:12428;s:12:\"delete-11191\";i:12429;s:12:\"delete-11192\";i:12430;s:12:\"delete-11193\";i:12431;s:12:\"delete-11194\";i:12432;s:12:\"delete-11195\";i:12433;s:12:\"delete-11196\";i:12434;s:12:\"delete-11197\";i:12435;s:12:\"delete-11198\";i:12436;s:12:\"delete-11199\";i:12437;s:12:\"delete-11200\";i:12438;s:12:\"delete-11201\";i:12439;s:12:\"delete-11202\";i:12440;s:12:\"delete-11203\";i:12441;s:12:\"delete-11204\";i:12442;s:12:\"delete-11205\";i:12443;s:12:\"delete-11206\";i:12444;s:12:\"delete-11207\";i:12445;s:12:\"delete-11208\";i:12446;s:12:\"delete-11209\";i:12447;s:12:\"delete-11210\";i:12448;s:12:\"delete-11211\";i:12449;s:12:\"delete-11212\";i:12450;s:12:\"delete-11213\";i:12451;s:12:\"delete-11214\";i:12452;s:12:\"delete-11215\";i:12453;s:12:\"delete-11216\";i:12454;s:12:\"delete-11217\";i:12455;s:12:\"delete-11218\";i:12456;s:12:\"delete-11219\";i:12457;s:12:\"delete-11220\";i:12458;s:12:\"delete-11221\";i:12459;s:12:\"delete-11222\";i:12460;s:12:\"delete-11223\";i:12461;s:12:\"delete-11224\";i:12462;s:12:\"delete-11225\";i:12463;s:12:\"delete-11226\";i:12464;s:12:\"delete-11227\";i:12465;s:12:\"delete-11228\";i:12466;s:12:\"delete-11229\";i:12467;s:12:\"delete-11230\";i:12468;s:12:\"delete-11231\";i:12469;s:12:\"delete-11232\";i:12470;s:12:\"delete-11233\";i:12471;s:12:\"delete-11234\";i:12472;s:12:\"delete-11235\";i:12473;s:12:\"delete-11236\";i:12474;s:12:\"delete-11237\";i:12475;s:12:\"delete-11238\";i:12476;s:12:\"delete-11239\";i:12477;s:12:\"delete-11240\";i:12478;s:12:\"delete-11241\";i:12479;s:12:\"delete-11242\";i:12480;s:12:\"delete-11243\";i:12481;s:12:\"delete-11244\";i:12482;s:12:\"delete-11245\";i:12483;s:12:\"delete-11246\";i:12484;s:12:\"delete-11247\";i:12485;s:12:\"delete-11248\";i:12486;s:12:\"delete-11249\";i:12487;s:12:\"delete-11250\";i:12488;s:12:\"delete-11251\";i:12489;s:12:\"delete-11252\";i:12490;s:12:\"delete-11253\";i:12491;s:12:\"delete-11254\";i:12492;s:12:\"delete-11255\";i:12493;s:12:\"delete-11256\";i:12494;s:12:\"delete-11257\";i:12495;s:12:\"delete-11258\";i:12496;s:12:\"delete-11259\";i:12497;s:12:\"delete-11260\";i:12498;s:12:\"delete-11261\";i:12499;s:12:\"delete-11262\";i:12500;s:12:\"delete-11263\";i:12501;s:12:\"delete-11264\";i:12502;s:12:\"delete-11265\";i:12503;s:12:\"delete-11266\";i:12504;s:12:\"delete-11267\";i:12505;s:12:\"delete-11268\";i:12506;s:12:\"delete-11269\";i:12507;s:12:\"delete-11270\";i:12508;s:12:\"delete-11271\";i:12509;s:12:\"delete-11272\";i:12510;s:12:\"delete-11273\";i:12511;s:12:\"delete-11274\";i:12512;s:12:\"delete-11275\";i:12513;s:12:\"delete-11276\";i:12514;s:12:\"delete-11277\";i:12515;s:12:\"delete-11278\";i:12516;s:12:\"delete-11279\";i:12517;s:12:\"delete-11280\";i:12518;s:12:\"delete-11281\";i:12519;s:12:\"delete-11282\";i:12520;s:12:\"delete-11283\";i:12521;s:12:\"delete-11284\";i:12522;s:12:\"delete-11285\";i:12523;s:12:\"delete-11286\";i:12524;s:12:\"delete-11287\";i:12525;s:12:\"delete-11288\";i:12526;s:12:\"delete-11289\";i:12527;s:12:\"delete-11290\";i:12528;s:12:\"delete-11291\";i:12529;s:12:\"delete-11292\";i:12530;s:12:\"delete-11293\";i:12531;s:12:\"delete-11294\";i:12532;s:12:\"delete-11295\";i:12533;s:12:\"delete-11296\";i:12534;s:12:\"delete-11297\";i:12535;s:12:\"delete-11298\";i:12536;s:12:\"delete-11299\";i:12537;s:12:\"delete-11300\";i:12538;s:12:\"delete-11301\";i:12539;s:12:\"delete-11302\";i:12540;s:12:\"delete-11303\";i:12541;s:12:\"delete-11304\";i:12542;s:12:\"delete-11305\";i:12543;s:12:\"delete-11306\";i:12544;s:12:\"delete-11307\";i:12545;s:12:\"delete-11308\";i:12546;s:12:\"delete-11309\";i:12547;s:12:\"delete-11310\";i:12548;s:12:\"delete-11311\";i:12549;s:12:\"delete-11312\";i:12550;s:12:\"delete-11313\";i:12551;s:12:\"delete-11314\";i:12552;s:12:\"delete-11315\";i:12553;s:12:\"delete-11316\";i:12554;s:12:\"delete-11317\";i:12555;s:12:\"delete-11318\";i:12556;s:12:\"delete-11319\";i:12557;s:12:\"delete-11320\";i:12558;s:12:\"delete-11321\";i:12559;s:12:\"delete-11322\";i:12560;s:12:\"delete-11323\";i:12561;s:12:\"delete-11324\";i:12562;s:12:\"delete-11325\";i:12563;s:12:\"delete-11326\";i:12564;s:12:\"delete-11327\";i:12565;s:12:\"delete-11328\";i:12566;s:12:\"delete-11329\";i:12567;s:12:\"delete-11330\";i:12568;s:12:\"delete-11331\";i:12569;s:12:\"delete-11332\";i:12570;s:12:\"delete-11333\";i:12571;s:12:\"delete-11334\";i:12572;s:12:\"delete-11335\";i:12573;s:12:\"delete-11336\";i:12574;s:12:\"delete-11337\";i:12575;s:12:\"delete-11338\";i:12576;s:12:\"delete-11339\";i:12577;s:12:\"delete-11340\";i:12578;s:12:\"delete-11341\";i:12579;s:12:\"delete-11342\";i:12580;s:12:\"delete-11343\";i:12581;s:12:\"delete-11344\";i:12582;s:12:\"delete-11345\";i:12583;s:12:\"delete-11346\";i:12584;s:12:\"delete-11347\";i:12585;s:12:\"delete-11348\";i:12586;s:12:\"delete-11349\";i:12587;s:12:\"delete-11350\";i:12588;s:12:\"delete-11351\";i:12589;s:12:\"delete-11352\";i:12590;s:12:\"delete-11353\";i:12591;s:12:\"delete-11354\";i:12592;s:12:\"delete-11355\";i:12593;s:12:\"delete-11356\";i:12594;s:12:\"delete-11357\";i:12595;s:12:\"delete-11358\";i:12596;s:12:\"delete-11359\";i:12597;s:12:\"delete-11360\";i:12598;s:12:\"delete-11361\";i:12599;s:12:\"delete-11362\";i:12600;s:12:\"delete-11363\";i:12601;s:12:\"delete-11364\";i:12602;s:12:\"delete-11365\";i:12603;s:12:\"delete-11366\";i:12604;s:12:\"delete-11367\";i:12605;s:12:\"delete-11368\";i:12606;s:12:\"delete-11369\";i:12607;s:12:\"delete-11370\";i:12608;s:12:\"delete-11371\";i:12609;s:12:\"delete-11372\";i:12610;s:12:\"delete-11373\";i:12611;s:12:\"delete-11374\";i:12612;s:12:\"delete-11375\";i:12613;s:12:\"delete-11376\";i:12614;s:12:\"delete-11377\";i:12615;s:12:\"delete-11378\";i:12616;s:12:\"delete-11379\";i:12617;s:12:\"delete-11380\";i:12618;s:12:\"delete-11381\";i:12619;s:12:\"delete-11382\";i:12620;s:12:\"delete-11383\";i:12621;s:12:\"delete-11384\";i:12622;s:12:\"delete-11385\";i:12623;s:12:\"delete-11386\";i:12624;s:12:\"delete-11387\";i:12625;s:12:\"delete-11388\";i:12626;s:12:\"delete-11389\";i:12627;s:12:\"delete-11390\";i:12628;s:12:\"delete-11391\";i:12629;s:12:\"delete-11392\";i:12630;s:12:\"delete-11393\";i:12631;s:12:\"delete-11394\";i:12632;s:12:\"delete-11395\";i:12633;s:12:\"delete-11396\";i:12634;s:12:\"delete-11397\";i:12635;s:12:\"delete-11398\";i:12636;s:12:\"delete-11399\";i:12637;s:12:\"delete-11400\";i:12638;s:12:\"delete-11401\";i:12639;s:12:\"delete-11402\";i:12640;s:12:\"delete-11403\";i:12641;s:12:\"delete-11404\";i:12642;s:12:\"delete-11405\";i:12643;s:12:\"delete-11406\";i:12644;s:12:\"delete-11407\";i:12645;s:12:\"delete-11408\";i:12646;s:12:\"delete-11409\";i:12647;s:12:\"delete-11410\";i:12648;s:12:\"delete-11411\";i:12649;s:12:\"delete-11412\";i:12650;s:12:\"delete-11413\";i:12651;s:12:\"delete-11414\";i:12652;s:12:\"delete-11415\";i:12653;s:12:\"delete-11416\";i:12654;s:12:\"delete-11417\";i:12655;s:12:\"delete-11418\";i:12656;s:12:\"delete-11419\";i:12657;s:12:\"delete-11420\";i:12658;s:12:\"delete-11421\";i:12659;s:12:\"delete-11422\";i:12660;s:12:\"delete-11423\";i:12661;s:12:\"delete-11424\";i:12662;s:12:\"delete-11425\";i:12663;s:12:\"delete-11426\";i:12664;s:12:\"delete-11427\";i:12665;s:12:\"delete-11428\";i:12666;s:12:\"delete-11429\";i:12667;s:12:\"delete-11430\";i:12668;s:12:\"delete-11431\";i:12669;s:12:\"delete-11432\";i:12670;s:12:\"delete-11433\";i:12671;s:12:\"delete-11434\";i:12672;s:12:\"delete-11435\";i:12673;s:12:\"delete-11436\";i:12674;s:12:\"delete-11437\";i:12675;s:12:\"delete-11438\";i:12676;s:12:\"delete-11439\";i:12677;s:12:\"delete-11440\";i:12678;s:12:\"delete-11441\";i:12679;s:12:\"delete-11442\";i:12680;s:12:\"delete-11443\";i:12681;s:12:\"delete-11444\";i:12682;s:12:\"delete-11445\";i:12683;s:12:\"delete-11446\";i:12684;s:12:\"delete-11447\";i:12685;s:12:\"delete-11448\";i:12686;s:12:\"delete-11449\";i:12687;s:12:\"delete-11450\";i:12688;s:12:\"delete-11451\";i:12689;s:12:\"delete-11452\";i:12690;s:12:\"delete-11453\";i:12691;s:12:\"delete-11454\";i:12692;s:12:\"delete-11455\";i:12693;s:12:\"delete-11456\";i:12694;s:12:\"delete-11457\";i:12695;s:12:\"delete-11458\";i:12696;s:12:\"delete-11459\";i:12697;s:12:\"delete-11460\";i:12698;s:12:\"delete-11461\";i:12699;s:12:\"delete-11462\";i:12700;s:12:\"delete-11463\";i:12701;s:12:\"delete-11464\";i:12702;s:12:\"delete-11465\";i:12703;s:12:\"delete-11466\";i:12704;s:12:\"delete-11467\";i:12705;s:12:\"delete-11468\";i:12706;s:12:\"delete-11469\";i:12707;s:12:\"delete-11470\";i:12708;s:12:\"delete-11471\";i:12709;s:12:\"delete-11472\";i:12710;s:12:\"delete-11473\";i:12711;s:12:\"delete-11474\";i:12712;s:12:\"delete-11475\";i:12713;s:12:\"delete-11476\";i:12714;s:12:\"delete-11477\";i:12715;s:12:\"delete-11478\";i:12716;s:12:\"delete-11479\";i:12717;s:12:\"delete-11480\";i:12718;s:12:\"delete-11481\";i:12719;s:12:\"delete-11482\";i:12720;s:12:\"delete-11483\";i:12721;s:12:\"delete-11484\";i:12722;s:12:\"delete-11485\";i:12723;s:12:\"delete-11486\";i:12724;s:12:\"delete-11487\";i:12725;s:12:\"delete-11488\";i:12726;s:12:\"delete-11489\";i:12727;s:12:\"delete-11490\";i:12728;s:12:\"delete-11491\";i:12729;s:12:\"delete-11492\";i:12730;s:12:\"delete-11493\";i:12731;s:12:\"delete-11494\";i:12732;s:12:\"delete-11495\";i:12733;s:12:\"delete-11496\";i:12734;s:12:\"delete-11497\";i:12735;s:12:\"delete-11498\";i:12736;s:12:\"delete-11499\";i:12737;s:12:\"delete-11500\";i:12738;s:12:\"delete-11501\";i:12739;s:12:\"delete-11502\";i:12740;s:12:\"delete-11503\";i:12741;s:12:\"delete-11504\";i:12742;s:12:\"delete-11505\";i:12743;s:12:\"delete-11506\";i:12744;s:12:\"delete-11507\";i:12745;s:12:\"delete-11508\";i:12746;s:12:\"delete-11509\";i:12747;s:12:\"delete-11510\";i:12748;s:12:\"delete-11511\";i:12749;s:12:\"delete-11512\";i:12750;s:12:\"delete-11513\";i:12751;s:12:\"delete-11514\";i:12752;s:12:\"delete-11515\";i:12753;s:12:\"delete-11516\";i:12754;s:12:\"delete-11517\";i:12755;s:12:\"delete-11518\";i:12756;s:12:\"delete-11519\";i:12757;s:12:\"delete-11520\";i:12758;s:12:\"delete-11521\";i:12759;s:12:\"delete-11522\";i:12760;s:12:\"delete-11523\";i:12761;s:12:\"delete-11524\";i:12762;s:12:\"delete-11525\";i:12763;s:12:\"delete-11526\";i:12764;s:12:\"delete-11527\";i:12765;s:12:\"delete-11528\";i:12766;s:12:\"delete-11529\";i:12767;s:12:\"delete-11530\";i:12768;s:12:\"delete-11531\";i:12769;s:12:\"delete-11532\";i:12770;s:12:\"delete-11533\";i:12771;s:12:\"delete-11534\";i:12772;s:12:\"delete-11535\";i:12773;s:12:\"delete-11536\";i:12774;s:12:\"delete-11537\";i:12775;s:12:\"delete-11538\";i:12776;s:12:\"delete-11539\";i:12777;s:12:\"delete-11540\";i:12778;s:12:\"delete-11541\";i:12779;s:12:\"delete-11542\";i:12780;s:12:\"delete-11543\";i:12781;s:12:\"delete-11544\";i:12782;s:12:\"delete-11545\";i:12783;s:12:\"delete-11546\";i:12784;s:12:\"delete-11547\";i:12785;s:12:\"delete-11548\";i:12786;s:12:\"delete-11549\";i:12787;s:12:\"delete-11550\";i:12788;s:12:\"delete-11551\";i:12789;s:12:\"delete-11552\";i:12790;s:12:\"delete-11553\";i:12791;s:12:\"delete-11554\";i:12792;s:12:\"delete-11555\";i:12793;s:12:\"delete-11556\";i:12794;s:12:\"delete-11557\";i:12795;s:12:\"delete-11558\";i:12796;s:12:\"delete-11559\";i:12797;s:12:\"delete-11560\";i:12798;s:12:\"delete-11561\";i:12799;s:12:\"delete-11562\";i:12800;s:12:\"delete-11563\";i:12801;s:12:\"delete-11564\";i:12802;s:12:\"delete-11565\";i:12803;s:12:\"delete-11566\";i:12804;s:12:\"delete-11567\";i:12805;s:12:\"delete-11568\";i:12806;s:12:\"delete-11569\";i:12807;s:12:\"delete-11570\";i:12808;s:12:\"delete-11571\";i:12809;s:12:\"delete-11572\";i:12810;s:12:\"delete-11573\";i:12811;s:12:\"delete-11574\";i:12812;s:12:\"delete-11575\";i:12813;s:12:\"delete-11576\";i:12814;s:12:\"delete-11577\";i:12815;s:12:\"delete-11578\";i:12816;s:12:\"delete-11579\";i:12817;s:12:\"delete-11580\";i:12818;s:12:\"delete-11581\";i:12819;s:12:\"delete-11582\";i:12820;s:12:\"delete-11583\";i:12821;s:12:\"delete-11584\";i:12822;s:12:\"delete-11585\";i:12823;s:12:\"delete-11586\";i:12824;s:12:\"delete-11587\";i:12825;s:12:\"delete-11588\";i:12826;s:12:\"delete-11589\";i:12827;s:12:\"delete-11590\";i:12828;s:12:\"delete-11591\";i:12829;s:12:\"delete-11592\";i:12830;s:12:\"delete-11593\";i:12831;s:12:\"delete-11594\";i:12832;s:12:\"delete-11595\";i:12833;s:12:\"delete-11596\";i:12834;s:12:\"delete-11597\";i:12835;s:12:\"delete-11598\";i:12836;s:12:\"delete-11599\";i:12837;s:12:\"delete-11600\";i:12838;s:12:\"delete-11601\";i:12839;s:12:\"delete-11602\";i:12840;s:12:\"delete-11603\";i:12841;s:12:\"delete-11604\";i:12842;s:12:\"delete-11605\";i:12843;s:12:\"delete-11606\";i:12844;s:12:\"delete-11607\";i:12845;s:12:\"delete-11608\";i:12846;s:12:\"delete-11609\";i:12847;s:12:\"delete-11610\";i:12848;s:12:\"delete-11611\";i:12849;s:12:\"delete-11612\";i:12850;s:12:\"delete-11613\";i:12851;s:12:\"delete-11614\";i:12852;s:12:\"delete-11615\";i:12853;s:12:\"delete-11616\";i:12854;s:12:\"delete-11617\";i:12855;s:12:\"delete-11618\";i:12856;s:12:\"delete-11619\";i:12857;s:12:\"delete-11620\";i:12858;s:12:\"delete-11621\";i:12859;s:12:\"delete-11622\";i:12860;s:12:\"delete-11623\";i:12861;s:12:\"delete-11624\";i:12862;s:12:\"delete-11625\";i:12863;s:12:\"delete-11626\";i:12864;s:12:\"delete-11627\";i:12865;s:12:\"delete-11628\";i:12866;s:12:\"delete-11629\";i:12867;s:12:\"delete-11630\";i:12868;s:12:\"delete-11631\";i:12869;s:12:\"delete-11632\";i:12870;s:12:\"delete-11633\";i:12871;s:12:\"delete-11634\";i:12872;s:12:\"delete-11635\";i:12873;s:12:\"delete-11636\";i:12874;s:12:\"delete-11637\";i:12875;s:12:\"delete-11638\";i:12876;s:12:\"delete-11639\";i:12877;s:12:\"delete-11640\";i:12878;s:12:\"delete-11641\";i:12879;s:12:\"delete-11642\";i:12880;s:12:\"delete-11643\";i:12881;s:12:\"delete-11644\";i:12882;s:12:\"delete-11645\";i:12883;s:12:\"delete-11646\";i:12884;s:12:\"delete-11647\";i:12885;s:12:\"delete-11648\";i:12886;s:12:\"delete-11649\";i:12887;s:12:\"delete-11650\";i:12888;s:12:\"delete-11651\";i:12889;s:12:\"delete-11652\";i:12890;s:12:\"delete-11653\";i:12891;s:12:\"delete-11654\";i:12892;s:12:\"delete-11655\";i:12893;s:12:\"delete-11656\";i:12894;s:12:\"delete-11657\";i:12895;s:12:\"delete-11658\";i:12896;s:12:\"delete-11659\";i:12897;s:12:\"delete-11660\";i:12898;s:12:\"delete-11661\";i:12899;s:12:\"delete-11662\";i:12900;s:12:\"delete-11663\";i:12901;s:12:\"delete-11664\";i:12902;s:12:\"delete-11665\";i:12903;s:12:\"delete-11666\";i:12904;s:12:\"delete-11667\";i:12905;s:12:\"delete-11668\";i:12906;s:12:\"delete-11669\";i:12907;s:12:\"delete-11670\";i:12908;s:12:\"delete-11671\";i:12909;s:12:\"delete-11672\";i:12910;s:12:\"delete-11673\";i:12911;s:12:\"delete-11674\";i:12912;s:12:\"delete-11675\";i:12913;s:12:\"delete-11676\";i:12914;s:12:\"delete-11677\";i:12915;s:12:\"delete-11678\";i:12916;s:12:\"delete-11679\";i:12917;s:12:\"delete-11680\";i:12918;s:12:\"delete-11681\";i:12919;s:12:\"delete-11682\";i:12920;s:12:\"delete-11683\";i:12921;s:12:\"delete-11684\";i:12922;s:12:\"delete-11685\";i:12923;s:12:\"delete-11686\";i:12924;s:12:\"delete-11687\";i:12925;s:12:\"delete-11688\";i:12926;s:12:\"delete-11689\";i:12927;s:12:\"delete-11690\";i:12928;s:12:\"delete-11691\";i:12929;s:12:\"delete-11692\";i:12930;s:12:\"delete-11693\";i:12931;s:12:\"delete-11694\";i:12932;s:12:\"delete-11695\";i:12933;s:12:\"delete-11696\";i:12934;s:12:\"delete-11697\";i:12935;s:12:\"delete-11698\";i:12936;s:12:\"delete-11699\";i:12937;s:12:\"delete-11700\";i:12938;s:12:\"delete-11701\";i:12939;s:12:\"delete-11702\";i:12940;s:12:\"delete-11703\";i:12941;s:12:\"delete-11704\";i:12942;s:12:\"delete-11705\";i:12943;s:12:\"delete-11706\";i:12944;s:12:\"delete-11707\";i:12945;s:12:\"delete-11708\";i:12946;s:12:\"delete-11709\";i:12947;s:12:\"delete-11710\";i:12948;s:12:\"delete-11711\";i:12949;s:12:\"delete-11712\";i:12950;s:12:\"delete-11713\";i:12951;s:12:\"delete-11714\";i:12952;s:12:\"delete-11715\";i:12953;s:12:\"delete-11716\";i:12954;s:12:\"delete-11717\";i:12955;s:12:\"delete-11718\";i:12956;s:12:\"delete-11719\";i:12957;s:12:\"delete-11720\";i:12958;s:12:\"delete-11721\";i:12959;s:12:\"delete-11722\";i:12960;s:12:\"delete-11723\";i:12961;s:12:\"delete-11724\";i:12962;s:12:\"delete-11725\";i:12963;s:12:\"delete-11726\";i:12964;s:12:\"delete-11727\";i:12965;s:12:\"delete-11728\";i:12966;s:12:\"delete-11729\";i:12967;s:12:\"delete-11730\";i:12968;s:12:\"delete-11731\";i:12969;s:12:\"delete-11732\";i:12970;s:12:\"delete-11733\";i:12971;s:12:\"delete-11734\";i:12972;s:12:\"delete-11735\";i:12973;s:12:\"delete-11736\";i:12974;s:12:\"delete-11737\";i:12975;s:12:\"delete-11738\";i:12976;s:12:\"delete-11739\";i:12977;s:12:\"delete-11740\";i:12978;s:12:\"delete-11741\";i:12979;s:12:\"delete-11742\";i:12980;s:12:\"delete-11743\";i:12981;s:12:\"delete-11744\";i:12982;s:12:\"delete-11745\";i:12983;s:12:\"delete-11746\";i:12984;s:12:\"delete-11747\";i:12985;s:12:\"delete-11748\";i:12986;s:12:\"delete-11749\";i:12987;s:12:\"delete-11750\";i:12988;s:12:\"delete-11751\";i:12989;s:12:\"delete-11752\";i:12990;s:12:\"delete-11753\";i:12991;s:12:\"delete-11754\";i:12992;s:12:\"delete-11755\";i:12993;s:12:\"delete-11756\";i:12994;s:12:\"delete-11757\";i:12995;s:12:\"delete-11758\";i:12996;s:12:\"delete-11759\";i:12997;s:12:\"delete-11760\";i:12998;s:12:\"delete-11761\";i:12999;s:12:\"delete-11762\";i:13000;s:12:\"delete-11763\";i:13001;s:12:\"delete-11764\";i:13002;s:12:\"delete-11765\";i:13003;s:12:\"delete-11766\";i:13004;s:12:\"delete-11767\";i:13005;s:12:\"delete-11768\";i:13006;s:12:\"delete-11769\";i:13007;s:12:\"delete-11770\";i:13008;s:12:\"delete-11771\";i:13009;s:12:\"delete-11772\";i:13010;s:12:\"delete-11773\";i:13011;s:12:\"delete-11774\";i:13012;s:12:\"delete-11775\";i:13013;s:12:\"delete-11776\";i:13014;s:12:\"delete-11777\";i:13015;s:12:\"delete-11778\";i:13016;s:12:\"delete-11779\";i:13017;s:12:\"delete-11780\";i:13018;s:12:\"delete-11781\";i:13019;s:12:\"delete-11782\";i:13020;s:12:\"delete-11783\";i:13021;s:12:\"delete-11784\";i:13022;s:12:\"delete-11785\";i:13023;s:12:\"delete-11786\";i:13024;s:12:\"delete-11787\";i:13025;s:12:\"delete-11788\";i:13026;s:12:\"delete-11789\";i:13027;s:12:\"delete-11790\";i:13028;s:12:\"delete-11791\";i:13029;s:12:\"delete-11792\";i:13030;s:12:\"delete-11793\";i:13031;s:12:\"delete-11794\";i:13032;s:12:\"delete-11795\";i:13033;s:12:\"delete-11796\";i:13034;s:12:\"delete-11797\";i:13035;s:12:\"delete-11798\";i:13036;s:12:\"delete-11799\";i:13037;s:12:\"delete-11800\";i:13038;s:12:\"delete-11801\";i:13039;s:12:\"delete-11802\";i:13040;s:12:\"delete-11803\";i:13041;s:12:\"delete-11804\";i:13042;s:12:\"delete-11805\";i:13043;s:12:\"delete-11806\";i:13044;s:12:\"delete-11807\";i:13045;s:12:\"delete-11808\";i:13046;s:12:\"delete-11809\";i:13047;s:12:\"delete-11810\";i:13048;s:12:\"delete-11811\";i:13049;s:12:\"delete-11812\";i:13050;s:12:\"delete-11813\";i:13051;s:12:\"delete-11814\";i:13052;s:12:\"delete-11815\";i:13053;s:12:\"delete-11816\";i:13054;s:12:\"delete-11817\";i:13055;s:12:\"delete-11818\";i:13056;s:12:\"delete-11819\";i:13057;s:12:\"delete-11820\";i:13058;s:12:\"delete-11821\";i:13059;s:12:\"delete-11822\";i:13060;s:12:\"delete-11823\";i:13061;s:12:\"delete-11824\";i:13062;s:12:\"delete-11825\";i:13063;s:12:\"delete-11826\";i:13064;s:12:\"delete-11827\";i:13065;s:12:\"delete-11828\";i:13066;s:12:\"delete-11829\";i:13067;s:12:\"delete-11830\";i:13068;s:12:\"delete-11831\";i:13069;s:12:\"delete-11832\";i:13070;s:12:\"delete-11833\";i:13071;s:12:\"delete-11834\";i:13072;s:12:\"delete-11835\";i:13073;s:12:\"delete-11836\";i:13074;s:12:\"delete-11837\";i:13075;s:12:\"delete-11838\";i:13076;s:12:\"delete-11839\";i:13077;s:12:\"delete-11840\";i:13078;s:12:\"delete-11841\";i:13079;s:12:\"delete-11842\";i:13080;s:12:\"delete-11843\";i:13081;s:12:\"delete-11844\";i:13082;s:12:\"delete-11845\";i:13083;s:12:\"delete-11846\";i:13084;s:12:\"delete-11847\";i:13085;s:12:\"delete-11848\";i:13086;s:12:\"delete-11849\";i:13087;s:12:\"delete-11850\";i:13088;s:12:\"delete-11851\";i:13089;s:12:\"delete-11852\";i:13090;s:12:\"delete-11853\";i:13091;s:12:\"delete-11854\";i:13092;s:12:\"delete-11855\";i:13093;s:12:\"delete-11856\";i:13094;s:12:\"delete-11857\";i:13095;s:12:\"delete-11858\";i:13096;s:12:\"delete-11859\";i:13097;s:12:\"delete-11860\";i:13098;s:12:\"delete-11861\";i:13099;s:12:\"delete-11862\";i:13100;s:12:\"delete-11863\";i:13101;s:12:\"delete-11864\";i:13102;s:12:\"delete-11865\";i:13103;s:12:\"delete-11866\";i:13104;s:12:\"delete-11867\";i:13105;s:12:\"delete-11868\";i:13106;s:12:\"delete-11869\";i:13107;s:12:\"delete-11870\";i:13108;s:12:\"delete-11871\";i:13109;s:12:\"delete-11872\";i:13110;s:12:\"delete-11873\";i:13111;s:12:\"delete-11874\";i:13112;s:12:\"delete-11875\";i:13113;s:12:\"delete-11876\";i:13114;s:12:\"delete-11877\";i:13115;s:12:\"delete-11878\";i:13116;s:12:\"delete-11879\";i:13117;s:12:\"delete-11880\";i:13118;s:12:\"delete-11881\";i:13119;s:12:\"delete-11882\";i:13120;s:12:\"delete-11883\";i:13121;s:12:\"delete-11884\";i:13122;s:12:\"delete-11885\";i:13123;s:12:\"delete-11886\";i:13124;s:12:\"delete-11887\";i:13125;s:12:\"delete-11888\";i:13126;s:12:\"delete-11889\";i:13127;s:12:\"delete-11890\";i:13128;s:12:\"delete-11891\";i:13129;s:12:\"delete-11892\";i:13130;s:12:\"delete-11893\";i:13131;s:12:\"delete-11894\";i:13132;s:12:\"delete-11895\";i:13133;s:12:\"delete-11896\";i:13134;s:12:\"delete-11897\";i:13135;s:12:\"delete-11898\";i:13136;s:12:\"delete-11899\";i:13137;s:12:\"delete-11900\";i:13138;s:12:\"delete-11901\";i:13139;s:12:\"delete-11902\";i:13140;s:12:\"delete-11903\";i:13141;s:12:\"delete-11904\";i:13142;s:12:\"delete-11905\";i:13143;s:12:\"delete-11906\";i:13144;s:12:\"delete-11907\";i:13145;s:12:\"delete-11908\";i:13146;s:12:\"delete-11909\";i:13147;s:12:\"delete-11910\";i:13148;s:12:\"delete-11911\";i:13149;s:12:\"delete-11912\";i:13150;s:12:\"delete-11913\";i:13151;s:12:\"delete-11914\";i:13152;s:12:\"delete-11915\";i:13153;s:12:\"delete-11916\";i:13154;s:12:\"delete-11917\";i:13155;s:12:\"delete-11918\";i:13156;s:12:\"delete-11919\";i:13157;s:12:\"delete-11920\";i:13158;s:12:\"delete-11921\";i:13159;s:12:\"delete-11922\";i:13160;s:12:\"delete-11923\";i:13161;s:12:\"delete-11924\";i:13162;s:12:\"delete-11925\";i:13163;s:12:\"delete-11926\";i:13164;s:12:\"delete-11927\";i:13165;s:12:\"delete-11928\";i:13166;s:12:\"delete-11929\";i:13167;s:12:\"delete-11930\";i:13168;s:12:\"delete-11931\";i:13169;s:12:\"delete-11932\";i:13170;s:12:\"delete-11933\";i:13171;s:12:\"delete-11934\";i:13172;s:12:\"delete-11935\";i:13173;s:12:\"delete-11936\";i:13174;s:12:\"delete-11937\";i:13175;s:12:\"delete-11938\";i:13176;s:12:\"delete-11939\";i:13177;s:12:\"delete-11940\";i:13178;s:12:\"delete-11941\";i:13179;s:12:\"delete-11942\";i:13180;s:12:\"delete-11943\";i:13181;s:12:\"delete-11944\";i:13182;s:12:\"delete-11945\";i:13183;s:12:\"delete-11946\";i:13184;s:12:\"delete-11947\";i:13185;s:12:\"delete-11948\";i:13186;s:12:\"delete-11949\";i:13187;s:12:\"delete-11950\";i:13188;s:12:\"delete-11951\";i:13189;s:12:\"delete-11952\";i:13190;s:12:\"delete-11953\";i:13191;s:12:\"delete-11954\";i:13192;s:12:\"delete-11955\";i:13193;s:12:\"delete-11956\";i:13194;s:12:\"delete-11957\";i:13195;s:12:\"delete-11958\";i:13196;s:12:\"delete-11959\";i:13197;s:12:\"delete-11960\";i:13198;s:12:\"delete-11961\";i:13199;s:12:\"delete-11962\";i:13200;s:12:\"delete-11963\";i:13201;s:12:\"delete-11964\";i:13202;s:12:\"delete-11965\";i:13203;s:12:\"delete-11966\";i:13204;s:12:\"delete-11967\";i:13205;s:12:\"delete-11968\";i:13206;s:12:\"delete-11969\";i:13207;s:12:\"delete-11970\";i:13208;s:12:\"delete-11971\";i:13209;s:12:\"delete-11972\";i:13210;s:12:\"delete-11973\";i:13211;s:12:\"delete-11974\";i:13212;s:12:\"delete-11975\";i:13213;s:12:\"delete-11976\";i:13214;s:12:\"delete-11977\";i:13215;s:12:\"delete-11978\";i:13216;s:12:\"delete-11979\";i:13217;s:12:\"delete-11980\";i:13218;s:12:\"delete-11981\";i:13219;s:12:\"delete-11982\";i:13220;s:12:\"delete-11983\";i:13221;s:12:\"delete-11984\";i:13222;s:12:\"delete-11985\";i:13223;s:12:\"delete-11986\";i:13224;s:12:\"delete-11987\";i:13225;s:12:\"delete-11988\";i:13226;s:12:\"delete-11989\";i:13227;s:12:\"delete-11990\";i:13228;s:12:\"delete-11991\";i:13229;s:12:\"delete-11992\";i:13230;s:12:\"delete-11993\";i:13231;s:12:\"delete-11994\";i:13232;s:12:\"delete-11995\";i:13233;s:12:\"delete-11996\";i:13234;s:12:\"delete-11997\";i:13235;s:12:\"delete-11998\";i:13236;s:12:\"delete-11999\";i:13237;s:12:\"delete-12000\";i:13238;s:12:\"delete-12001\";i:13239;s:12:\"delete-12002\";i:13240;s:12:\"delete-12003\";i:13241;s:12:\"delete-12004\";i:13242;s:12:\"delete-12005\";i:13243;s:12:\"delete-12006\";i:13244;s:12:\"delete-12007\";i:13245;s:12:\"delete-12008\";i:13246;s:12:\"delete-12009\";i:13247;s:12:\"delete-12010\";i:13248;s:12:\"delete-12011\";i:13249;s:12:\"delete-12012\";i:13250;s:12:\"delete-12013\";i:13251;s:12:\"delete-12014\";i:13252;s:12:\"delete-12015\";i:13253;s:12:\"delete-12016\";i:13254;s:12:\"delete-12017\";i:13255;s:12:\"delete-12018\";i:13256;s:12:\"delete-12019\";i:13257;s:12:\"delete-12020\";i:13258;s:12:\"delete-12021\";i:13259;s:12:\"delete-12022\";i:13260;s:12:\"delete-12023\";i:13261;s:12:\"delete-12024\";i:13262;s:12:\"delete-12025\";i:13263;s:12:\"delete-12026\";i:13264;s:12:\"delete-12027\";i:13265;s:12:\"delete-12028\";i:13266;s:12:\"delete-12029\";i:13267;s:12:\"delete-12030\";i:13268;s:12:\"delete-12031\";i:13269;s:12:\"delete-12032\";i:13270;s:12:\"delete-12033\";i:13271;s:12:\"delete-12034\";i:13272;s:12:\"delete-12035\";i:13273;s:12:\"delete-12036\";i:13274;s:12:\"delete-12037\";i:13275;s:12:\"delete-12038\";i:13276;s:12:\"delete-12039\";i:13277;s:12:\"delete-12040\";i:13278;s:12:\"delete-12041\";i:13279;s:12:\"delete-12042\";i:13280;s:12:\"delete-12043\";i:13281;s:12:\"delete-12044\";i:13282;s:12:\"delete-12045\";i:13283;s:12:\"delete-12046\";i:13284;s:12:\"delete-12047\";i:13285;s:12:\"delete-12048\";i:13286;s:12:\"delete-12049\";i:13287;s:12:\"delete-12050\";i:13288;s:12:\"delete-12051\";i:13289;s:12:\"delete-12052\";i:13290;s:12:\"delete-12053\";i:13291;s:12:\"delete-12054\";i:13292;s:12:\"delete-12055\";i:13293;s:12:\"delete-12056\";i:13294;s:12:\"delete-12057\";i:13295;s:12:\"delete-12058\";i:13296;s:12:\"delete-12059\";i:13297;s:12:\"delete-12060\";i:13298;s:12:\"delete-12061\";i:13299;s:12:\"delete-12062\";i:13300;s:12:\"delete-12063\";i:13301;s:12:\"delete-12064\";i:13302;s:12:\"delete-12065\";i:13303;s:12:\"delete-12066\";i:13304;s:12:\"delete-12067\";i:13305;s:12:\"delete-12068\";i:13306;s:12:\"delete-12069\";i:13307;s:12:\"delete-12070\";i:13308;s:12:\"delete-12071\";i:13309;s:12:\"delete-12072\";i:13310;s:12:\"delete-12073\";i:13311;s:12:\"delete-12074\";i:13312;s:12:\"delete-12075\";i:13313;s:12:\"delete-12076\";i:13314;s:12:\"delete-12077\";i:13315;s:12:\"delete-12078\";i:13316;s:12:\"delete-12079\";i:13317;s:12:\"delete-12080\";i:13318;s:12:\"delete-12081\";i:13319;s:12:\"delete-12082\";i:13320;s:12:\"delete-12083\";i:13321;s:12:\"delete-12084\";i:13322;s:12:\"delete-12085\";i:13323;s:12:\"delete-12086\";i:13324;s:12:\"delete-12087\";i:13325;s:12:\"delete-12088\";i:13326;s:12:\"delete-12089\";i:13327;s:12:\"delete-12090\";i:13328;s:12:\"delete-12091\";i:13329;s:12:\"delete-12092\";i:13330;s:12:\"delete-12093\";i:13331;s:12:\"delete-12094\";i:13332;s:12:\"delete-12095\";i:13333;s:12:\"delete-12096\";i:13334;s:12:\"delete-12097\";i:13335;s:12:\"delete-12098\";i:13336;s:12:\"delete-12099\";i:13337;s:12:\"delete-12100\";i:13338;s:12:\"delete-12101\";i:13339;s:12:\"delete-12102\";i:13340;s:12:\"delete-12103\";i:13341;s:12:\"delete-12104\";i:13342;s:12:\"delete-12105\";i:13343;s:12:\"delete-12106\";i:13344;s:12:\"delete-12107\";i:13345;s:12:\"delete-12108\";i:13346;s:12:\"delete-12109\";i:13347;s:12:\"delete-12110\";i:13348;s:12:\"delete-12111\";i:13349;s:12:\"delete-12112\";i:13350;s:12:\"delete-12113\";i:13351;s:12:\"delete-12114\";i:13352;s:12:\"delete-12115\";i:13353;s:12:\"delete-12116\";i:13354;s:12:\"delete-12117\";i:13355;s:12:\"delete-12118\";i:13356;s:12:\"delete-12119\";i:13357;s:12:\"delete-12120\";i:13358;s:12:\"delete-12121\";i:13359;s:12:\"delete-12122\";i:13360;s:12:\"delete-12123\";i:13361;s:12:\"delete-12124\";i:13362;s:12:\"delete-12125\";i:13363;s:12:\"delete-12126\";i:13364;s:12:\"delete-12127\";i:13365;s:12:\"delete-12128\";i:13366;s:12:\"delete-12129\";i:13367;s:12:\"delete-12130\";i:13368;s:12:\"delete-12131\";i:13369;s:12:\"delete-12132\";i:13370;s:12:\"delete-12133\";i:13371;s:12:\"delete-12134\";i:13372;s:12:\"delete-12135\";i:13373;s:12:\"delete-12136\";i:13374;s:12:\"delete-12137\";i:13375;s:12:\"delete-12138\";i:13376;s:12:\"delete-12139\";i:13377;s:12:\"delete-12140\";i:13378;s:12:\"delete-12141\";i:13379;s:12:\"delete-12142\";i:13380;s:12:\"delete-12143\";i:13381;s:12:\"delete-12144\";i:13382;s:12:\"delete-12145\";i:13383;s:12:\"delete-12146\";i:13384;s:12:\"delete-12147\";i:13385;s:12:\"delete-12148\";i:13386;s:12:\"delete-12149\";i:13387;s:12:\"delete-12150\";i:13388;s:12:\"delete-12151\";i:13389;s:12:\"delete-12152\";i:13390;s:12:\"delete-12153\";i:13391;s:12:\"delete-12154\";i:13392;s:12:\"delete-12155\";i:13393;s:12:\"delete-12156\";i:13394;s:12:\"delete-12157\";i:13395;s:12:\"delete-12158\";i:13396;s:12:\"delete-12159\";i:13397;s:12:\"delete-12160\";i:13398;s:12:\"delete-12161\";i:13399;s:12:\"delete-12162\";i:13400;s:12:\"delete-12163\";i:13401;s:12:\"delete-12164\";i:13402;s:12:\"delete-12165\";i:13403;s:12:\"delete-12166\";i:13404;s:12:\"delete-12167\";i:13405;s:12:\"delete-12168\";i:13406;s:12:\"delete-12169\";i:13407;s:12:\"delete-12170\";i:13408;s:12:\"delete-12171\";i:13409;s:12:\"delete-12172\";i:13410;s:12:\"delete-12173\";i:13411;s:12:\"delete-12174\";i:13412;s:12:\"delete-12175\";i:13413;s:12:\"delete-12176\";i:13414;s:12:\"delete-12177\";i:13415;s:12:\"delete-12178\";i:13416;s:12:\"delete-12179\";i:13417;s:12:\"delete-12180\";i:13418;s:12:\"delete-12181\";i:13419;s:12:\"delete-12182\";i:13420;s:12:\"delete-12183\";i:13421;s:12:\"delete-12184\";i:13422;s:12:\"delete-12185\";i:13423;s:12:\"delete-12186\";i:13424;s:12:\"delete-12187\";i:13425;s:12:\"delete-12188\";i:13426;s:12:\"delete-12189\";i:13427;s:12:\"delete-12190\";i:13428;s:12:\"delete-12191\";i:13429;s:12:\"delete-12192\";i:13430;s:12:\"delete-12193\";i:13431;s:12:\"delete-12194\";i:13432;s:12:\"delete-12195\";i:13433;s:12:\"delete-12196\";i:13434;s:12:\"delete-12197\";i:13435;s:12:\"delete-12198\";i:13436;s:12:\"delete-12199\";i:13437;s:12:\"delete-12200\";i:13438;s:12:\"delete-12201\";i:13439;s:12:\"delete-12202\";i:13440;s:12:\"delete-12203\";i:13441;s:12:\"delete-12204\";i:13442;s:12:\"delete-12205\";i:13443;s:12:\"delete-12206\";i:13444;s:12:\"delete-12207\";i:13445;s:12:\"delete-12208\";i:13446;s:12:\"delete-12209\";i:13447;s:12:\"delete-12210\";i:13448;s:12:\"delete-12211\";i:13449;s:12:\"delete-12212\";i:13450;s:12:\"delete-12213\";i:13451;s:12:\"delete-12214\";i:13452;s:12:\"delete-12215\";i:13453;s:12:\"delete-12216\";i:13454;s:12:\"delete-12217\";i:13455;s:12:\"delete-12218\";i:13456;s:12:\"delete-12219\";i:13457;s:12:\"delete-12220\";i:13458;s:12:\"delete-12221\";i:13459;s:12:\"delete-12222\";i:13460;s:12:\"delete-12223\";i:13461;s:12:\"delete-12224\";i:13462;s:12:\"delete-12225\";i:13463;s:12:\"delete-12226\";i:13464;s:12:\"delete-12227\";i:13465;s:12:\"delete-12228\";i:13466;s:12:\"delete-12229\";i:13467;s:12:\"delete-12230\";i:13468;s:12:\"delete-12231\";i:13469;s:12:\"delete-12232\";i:13470;s:12:\"delete-12233\";i:13471;s:12:\"delete-12234\";i:13472;s:12:\"delete-12235\";i:13473;s:12:\"delete-12236\";i:13474;s:12:\"delete-12237\";i:13475;s:12:\"delete-12238\";i:13476;s:12:\"delete-12239\";i:13477;s:12:\"delete-12240\";i:13478;s:12:\"delete-12241\";i:13479;s:12:\"delete-12242\";i:13480;s:12:\"delete-12243\";i:13481;s:12:\"delete-12244\";i:13482;s:12:\"delete-12245\";i:13483;s:12:\"delete-12246\";i:13484;s:12:\"delete-12247\";i:13485;s:12:\"delete-12248\";i:13486;s:12:\"delete-12249\";i:13487;s:12:\"delete-12250\";i:13488;s:12:\"delete-12251\";i:13489;s:12:\"delete-12252\";i:13490;s:12:\"delete-12253\";i:13491;s:12:\"delete-12254\";i:13492;s:12:\"delete-12255\";i:13493;s:12:\"delete-12256\";i:13494;s:12:\"delete-12257\";i:13495;s:12:\"delete-12258\";i:13496;s:12:\"delete-12259\";i:13497;s:12:\"delete-12260\";i:13498;s:12:\"delete-12261\";i:13499;s:12:\"delete-12262\";i:13500;s:12:\"delete-12263\";i:13501;s:12:\"delete-12264\";i:13502;s:12:\"delete-12265\";i:13503;s:12:\"delete-12266\";i:13504;s:12:\"delete-12267\";i:13505;s:12:\"delete-12268\";i:13506;s:12:\"delete-12269\";i:13507;s:12:\"delete-12270\";i:13508;s:12:\"delete-12271\";i:13509;s:12:\"delete-12272\";i:13510;s:12:\"delete-12273\";i:13511;s:12:\"delete-12274\";i:13512;s:12:\"delete-12275\";i:13513;s:12:\"delete-12276\";i:13514;s:12:\"delete-12277\";i:13515;s:12:\"delete-12278\";i:13516;s:12:\"delete-12279\";i:13517;s:12:\"delete-12280\";i:13518;s:12:\"delete-12281\";i:13519;s:12:\"delete-12282\";i:13520;s:12:\"delete-12283\";i:13521;s:12:\"delete-12284\";i:13522;s:12:\"delete-12285\";i:13523;s:12:\"delete-12286\";i:13524;s:12:\"delete-12287\";i:13525;s:12:\"delete-12288\";i:13526;s:12:\"delete-12289\";i:13527;s:12:\"delete-12290\";i:13528;s:12:\"delete-12291\";i:13529;s:12:\"delete-12292\";i:13530;s:12:\"delete-12293\";i:13531;s:12:\"delete-12294\";i:13532;s:12:\"delete-12295\";i:13533;s:12:\"delete-12296\";i:13534;s:12:\"delete-12297\";i:13535;s:12:\"delete-12298\";i:13536;s:12:\"delete-12299\";i:13537;s:12:\"delete-12300\";i:13538;s:12:\"delete-12301\";i:13539;s:12:\"delete-12302\";i:13540;s:12:\"delete-12303\";i:13541;s:12:\"delete-12304\";i:13542;s:12:\"delete-12305\";i:13543;s:12:\"delete-12306\";i:13544;s:12:\"delete-12307\";i:13545;s:12:\"delete-12308\";i:13546;s:12:\"delete-12309\";i:13547;s:12:\"delete-12310\";i:13548;s:12:\"delete-12311\";i:13549;s:12:\"delete-12312\";i:13550;s:12:\"delete-12313\";i:13551;s:12:\"delete-12314\";i:13552;s:12:\"delete-12315\";i:13553;s:12:\"delete-12316\";i:13554;s:12:\"delete-12317\";i:13555;s:12:\"delete-12318\";i:13556;s:12:\"delete-12319\";i:13557;s:12:\"delete-12320\";i:13558;s:12:\"delete-12321\";i:13559;s:12:\"delete-12322\";i:13560;s:12:\"delete-12323\";i:13561;s:12:\"delete-12324\";i:13562;s:12:\"delete-12325\";i:13563;s:12:\"delete-12326\";i:13564;s:12:\"delete-12327\";i:13565;s:12:\"delete-12328\";i:13566;s:12:\"delete-12329\";i:13567;s:12:\"delete-12330\";i:13568;s:12:\"delete-12331\";i:13569;s:12:\"delete-12332\";i:13570;s:12:\"delete-12333\";i:13571;s:12:\"delete-12334\";i:13572;s:12:\"delete-12335\";i:13573;s:12:\"delete-12336\";i:13574;s:12:\"delete-12337\";i:13575;s:12:\"delete-12338\";i:13576;s:12:\"delete-12339\";i:13577;s:12:\"delete-12340\";i:13578;s:12:\"delete-12341\";i:13579;s:12:\"delete-12342\";i:13580;s:12:\"delete-12343\";i:13581;s:12:\"delete-12344\";i:13582;s:12:\"delete-12345\";i:13583;s:12:\"delete-12346\";i:13584;s:12:\"delete-12347\";i:13585;s:12:\"delete-12348\";i:13586;s:12:\"delete-12349\";i:13587;s:12:\"delete-12350\";i:13588;s:12:\"delete-12351\";i:13589;s:12:\"delete-12352\";i:13590;s:12:\"delete-12353\";i:13591;s:12:\"delete-12354\";i:13592;s:12:\"delete-12355\";i:13593;s:12:\"delete-12356\";i:13594;s:12:\"delete-12357\";i:13595;s:12:\"delete-12358\";i:13596;s:12:\"delete-12359\";i:13597;s:12:\"delete-12360\";i:13598;s:12:\"delete-12361\";i:13599;s:12:\"delete-12362\";i:13600;s:12:\"delete-12363\";i:13601;s:12:\"delete-12364\";i:13602;s:12:\"delete-12365\";i:13603;s:12:\"delete-12366\";i:13604;s:12:\"delete-12367\";i:13605;s:12:\"delete-12368\";i:13606;s:12:\"delete-12369\";i:13607;s:12:\"delete-12370\";i:13608;s:12:\"delete-12371\";i:13609;s:12:\"delete-12372\";i:13610;s:12:\"delete-12373\";i:13611;s:12:\"delete-12374\";i:13612;s:12:\"delete-12375\";i:13613;s:12:\"delete-12376\";i:13614;s:12:\"delete-12377\";i:13615;s:12:\"delete-12378\";i:13616;s:12:\"delete-12379\";i:13617;s:12:\"delete-12380\";i:13618;s:12:\"delete-12381\";i:13619;s:12:\"delete-12382\";i:13620;s:12:\"delete-12383\";i:13621;s:12:\"delete-12384\";i:13622;s:12:\"delete-12385\";i:13623;s:12:\"delete-12386\";i:13624;s:12:\"delete-12387\";i:13625;s:12:\"delete-12388\";i:13626;s:12:\"delete-12389\";i:13627;s:12:\"delete-12390\";i:13628;s:12:\"delete-12391\";i:13629;s:12:\"delete-12392\";i:13630;s:12:\"delete-12393\";i:13631;s:12:\"delete-12394\";i:13632;s:12:\"delete-12395\";i:13633;s:12:\"delete-12396\";i:13634;s:12:\"delete-12397\";i:13635;s:12:\"delete-12398\";i:13636;s:12:\"delete-12399\";i:13637;s:12:\"delete-12400\";i:13638;s:12:\"delete-12401\";i:13639;s:12:\"delete-12402\";i:13640;s:12:\"delete-12403\";i:13641;s:12:\"delete-12404\";i:13642;s:12:\"delete-12405\";i:13643;s:12:\"delete-12406\";i:13644;s:12:\"delete-12407\";i:13645;s:12:\"delete-12408\";i:13646;s:12:\"delete-12409\";i:13647;s:12:\"delete-12410\";i:13648;s:12:\"delete-12411\";i:13649;s:12:\"delete-12412\";i:13650;s:12:\"delete-12413\";i:13651;s:12:\"delete-12414\";i:13652;s:12:\"delete-12415\";i:13653;s:12:\"delete-12416\";i:13654;s:12:\"delete-12417\";i:13655;s:12:\"delete-12418\";i:13656;s:12:\"delete-12419\";i:13657;s:12:\"delete-12420\";i:13658;s:12:\"delete-12421\";i:13659;s:12:\"delete-12422\";i:13660;s:12:\"delete-12423\";i:13661;s:12:\"delete-12424\";i:13662;s:12:\"delete-12425\";i:13663;s:12:\"delete-12426\";i:13664;s:12:\"delete-12427\";i:13665;s:12:\"delete-12428\";i:13666;s:12:\"delete-12429\";i:13667;s:12:\"delete-12430\";i:13668;s:12:\"delete-12431\";i:13669;s:12:\"delete-12432\";i:13670;s:12:\"delete-12433\";i:13671;s:12:\"delete-12434\";i:13672;s:12:\"delete-12435\";i:13673;s:12:\"delete-12436\";i:13674;s:12:\"delete-12437\";i:13675;s:12:\"delete-12438\";i:13676;s:12:\"delete-12439\";i:13677;s:12:\"delete-12440\";i:13678;s:12:\"delete-12441\";i:13679;s:12:\"delete-12442\";i:13680;s:12:\"delete-12443\";i:13681;s:12:\"delete-12444\";i:13682;s:12:\"delete-12445\";i:13683;s:12:\"delete-12446\";i:13684;s:12:\"delete-12447\";i:13685;s:12:\"delete-12448\";i:13686;s:12:\"delete-12449\";i:13687;s:12:\"delete-12450\";i:13688;s:12:\"delete-12451\";i:13689;s:12:\"delete-12452\";i:13690;s:12:\"delete-12453\";i:13691;s:12:\"delete-12454\";i:13692;s:12:\"delete-12455\";i:13693;s:12:\"delete-12456\";i:13694;s:12:\"delete-12457\";i:13695;s:12:\"delete-12458\";i:13696;s:12:\"delete-12459\";i:13697;s:12:\"delete-12460\";i:13698;s:12:\"delete-12461\";i:13699;s:12:\"delete-12462\";i:13700;s:12:\"delete-12463\";i:13701;s:12:\"delete-12464\";i:13702;s:12:\"delete-12465\";i:13703;s:12:\"delete-12466\";i:13704;s:12:\"delete-12467\";i:13705;s:12:\"delete-12468\";i:13706;s:12:\"delete-12469\";i:13707;s:12:\"delete-12470\";i:13708;s:12:\"delete-12471\";i:13709;s:12:\"delete-12472\";i:13710;s:12:\"delete-12473\";i:13711;s:12:\"delete-12474\";i:13712;s:12:\"delete-12475\";i:13713;s:12:\"delete-12476\";i:13714;s:12:\"delete-12477\";i:13715;s:12:\"delete-12478\";i:13716;s:12:\"delete-12479\";i:13717;s:12:\"delete-12480\";i:13718;s:12:\"delete-12481\";i:13719;s:12:\"delete-12482\";i:13720;s:12:\"delete-12483\";i:13721;s:12:\"delete-12484\";i:13722;s:12:\"delete-12485\";i:13723;s:12:\"delete-12486\";i:13724;s:12:\"delete-12487\";i:13725;s:12:\"delete-12488\";i:13726;s:12:\"delete-12489\";i:13727;s:12:\"delete-12490\";i:13728;s:12:\"delete-12491\";i:13729;s:12:\"delete-12492\";i:13730;s:12:\"delete-12493\";i:13731;s:12:\"delete-12494\";i:13732;s:12:\"delete-12495\";i:13733;s:12:\"delete-12496\";i:13734;s:12:\"delete-12497\";i:13735;s:12:\"delete-12498\";i:13736;s:12:\"delete-12499\";i:13737;s:12:\"delete-12500\";i:13738;s:12:\"delete-12501\";i:13739;s:12:\"delete-12502\";i:13740;s:12:\"delete-12503\";i:13741;s:12:\"delete-12504\";i:13742;s:12:\"delete-12505\";i:13743;s:12:\"delete-12506\";i:13744;s:12:\"delete-12507\";i:13745;s:12:\"delete-12508\";i:13746;s:12:\"delete-12509\";i:13747;s:12:\"delete-12510\";i:13748;s:12:\"delete-12511\";i:13749;s:12:\"delete-12512\";i:13750;s:12:\"delete-12513\";i:13751;s:12:\"delete-12514\";i:13752;s:12:\"delete-12515\";i:13753;s:12:\"delete-12516\";i:13754;s:12:\"delete-12517\";i:13755;s:12:\"delete-12518\";i:13756;s:12:\"delete-12519\";i:13757;s:12:\"delete-12520\";i:13758;s:12:\"delete-12521\";i:13759;s:12:\"delete-12522\";i:13760;s:12:\"delete-12523\";i:13761;s:12:\"delete-12524\";i:13762;s:12:\"delete-12525\";i:13763;s:12:\"delete-12526\";i:13764;s:12:\"delete-12527\";i:13765;s:12:\"delete-12528\";i:13766;s:12:\"delete-12529\";i:13767;s:12:\"delete-12530\";i:13768;s:12:\"delete-12531\";i:13769;s:12:\"delete-12532\";i:13770;s:12:\"delete-12533\";i:13771;s:12:\"delete-12534\";i:13772;s:12:\"delete-12535\";i:13773;s:12:\"delete-12536\";i:13774;s:12:\"delete-12537\";i:13775;s:12:\"delete-12538\";i:13776;s:12:\"delete-12539\";i:13777;s:12:\"delete-12540\";i:13778;s:12:\"delete-12541\";i:13779;s:12:\"delete-12542\";i:13780;s:12:\"delete-12543\";i:13781;s:12:\"delete-12544\";i:13782;s:12:\"delete-12545\";i:13783;s:12:\"delete-12546\";i:13784;s:12:\"delete-12547\";i:13785;s:12:\"delete-12548\";i:13786;s:12:\"delete-12549\";i:13787;s:12:\"delete-12550\";i:13788;s:12:\"delete-12551\";i:13789;s:12:\"delete-12552\";i:13790;s:12:\"delete-12553\";i:13791;s:12:\"delete-12554\";i:13792;s:12:\"delete-12555\";i:13793;s:12:\"delete-12556\";i:13794;s:12:\"delete-12557\";i:13795;s:12:\"delete-12558\";i:13796;s:12:\"delete-12559\";i:13797;s:12:\"delete-12560\";i:13798;s:12:\"delete-12561\";i:13799;s:12:\"delete-12562\";i:13800;s:12:\"delete-12563\";i:13801;s:12:\"delete-12564\";i:13802;s:12:\"delete-12565\";i:13803;s:12:\"delete-12566\";i:13804;s:12:\"delete-12567\";i:13805;s:12:\"delete-12568\";i:13806;s:12:\"delete-12569\";i:13807;s:12:\"delete-12570\";i:13808;s:12:\"delete-12571\";i:13809;s:12:\"delete-12572\";i:13810;s:12:\"delete-12573\";i:13811;s:12:\"delete-12574\";i:13812;s:12:\"delete-12575\";i:13813;s:12:\"delete-12576\";i:13814;s:12:\"delete-12577\";i:13815;s:12:\"delete-12578\";i:13816;s:12:\"delete-12579\";i:13817;s:12:\"delete-12580\";i:13818;s:12:\"delete-12581\";i:13819;s:12:\"delete-12582\";i:13820;s:12:\"delete-12583\";i:13821;s:12:\"delete-12584\";i:13822;s:12:\"delete-12585\";i:13823;s:12:\"delete-12586\";i:13824;s:12:\"delete-12587\";i:13825;s:12:\"delete-12588\";i:13826;s:12:\"delete-12589\";i:13827;s:12:\"delete-12590\";i:13828;s:12:\"delete-12591\";i:13829;s:12:\"delete-12592\";i:13830;s:12:\"delete-12593\";i:13831;s:12:\"delete-12594\";i:13832;s:12:\"delete-12595\";i:13833;s:12:\"delete-12596\";i:13834;s:12:\"delete-12597\";i:13835;s:12:\"delete-12598\";i:13836;s:12:\"delete-12599\";i:13837;s:12:\"delete-12600\";i:13838;s:12:\"delete-12601\";i:13839;s:12:\"delete-12602\";i:13840;s:12:\"delete-12603\";i:13841;s:12:\"delete-12604\";i:13842;s:12:\"delete-12605\";i:13843;s:12:\"delete-12606\";i:13844;s:12:\"delete-12607\";i:13845;s:12:\"delete-12608\";i:13846;s:12:\"delete-12609\";i:13847;s:12:\"delete-12610\";i:13848;s:12:\"delete-12611\";i:13849;s:12:\"delete-12612\";i:13850;s:12:\"delete-12613\";i:13851;s:12:\"delete-12614\";i:13852;s:12:\"delete-12615\";i:13853;s:12:\"delete-12616\";i:13854;s:12:\"delete-12617\";i:13855;s:12:\"delete-12618\";i:13856;s:12:\"delete-12619\";i:13857;s:12:\"delete-12620\";i:13858;s:12:\"delete-12621\";i:13859;s:12:\"delete-12622\";i:13860;s:12:\"delete-12623\";i:13861;s:12:\"delete-12624\";i:13862;s:12:\"delete-12625\";i:13863;s:12:\"delete-12626\";i:13864;s:12:\"delete-12627\";i:13865;s:12:\"delete-12628\";i:13866;s:12:\"delete-12629\";i:13867;s:12:\"delete-12630\";i:13868;s:12:\"delete-12631\";i:13869;s:12:\"delete-12632\";i:13870;s:12:\"delete-12633\";i:13871;s:12:\"delete-12634\";i:13872;s:12:\"delete-12635\";i:13873;s:12:\"delete-12636\";i:13874;s:12:\"delete-12637\";i:13875;s:12:\"delete-12638\";i:13876;s:12:\"delete-12639\";i:13877;s:12:\"delete-12640\";i:13878;s:12:\"delete-12641\";i:13879;s:12:\"delete-12642\";i:13880;s:12:\"delete-12643\";i:13881;s:12:\"delete-12644\";i:13882;s:12:\"delete-12645\";i:13883;s:12:\"delete-12646\";i:13884;s:12:\"delete-12647\";i:13885;s:12:\"delete-12648\";i:13886;s:12:\"delete-12649\";i:13887;s:12:\"delete-12650\";i:13888;s:12:\"delete-12651\";i:13889;s:12:\"delete-12652\";i:13890;s:12:\"delete-12653\";i:13891;s:12:\"delete-12654\";i:13892;s:12:\"delete-12655\";i:13893;s:12:\"delete-12656\";i:13894;s:12:\"delete-12657\";i:13895;s:12:\"delete-12658\";i:13896;s:12:\"delete-12659\";i:13897;s:12:\"delete-12660\";i:13898;s:12:\"delete-12661\";i:13899;s:12:\"delete-12662\";i:13900;s:12:\"delete-12663\";i:13901;s:12:\"delete-12664\";i:13902;s:12:\"delete-12665\";i:13903;s:12:\"delete-12666\";i:13904;s:12:\"delete-12667\";i:13905;s:12:\"delete-12668\";i:13906;s:12:\"delete-12669\";i:13907;s:12:\"delete-12670\";i:13908;s:12:\"delete-12671\";i:13909;s:12:\"delete-12672\";i:13910;s:12:\"delete-12673\";i:13911;s:12:\"delete-12674\";i:13912;s:12:\"delete-12675\";i:13913;s:12:\"delete-12676\";i:13914;s:12:\"delete-12677\";i:13915;s:12:\"delete-12678\";i:13916;s:12:\"delete-12679\";i:13917;s:12:\"delete-12680\";i:13918;s:12:\"delete-12681\";i:13919;s:12:\"delete-12682\";i:13920;s:12:\"delete-12683\";i:13921;s:12:\"delete-12684\";i:13922;s:12:\"delete-12685\";i:13923;s:12:\"delete-12686\";i:13924;s:12:\"delete-12687\";i:13925;s:12:\"delete-12688\";i:13926;s:12:\"delete-12689\";i:13927;s:12:\"delete-12690\";i:13928;s:12:\"delete-12691\";i:13929;s:12:\"delete-12692\";i:13930;s:12:\"delete-12693\";i:13931;s:12:\"delete-12694\";i:13932;s:12:\"delete-12695\";i:13933;s:12:\"delete-12696\";i:13934;s:12:\"delete-12697\";i:13935;s:12:\"delete-12698\";i:13936;s:12:\"delete-12699\";i:13937;s:12:\"delete-12700\";i:13938;s:12:\"delete-12701\";i:13939;s:12:\"delete-12702\";i:13940;s:12:\"delete-12703\";i:13941;s:12:\"delete-12704\";i:13942;s:12:\"delete-12705\";i:13943;s:12:\"delete-12706\";i:13944;s:12:\"delete-12707\";i:13945;s:12:\"delete-12708\";i:13946;s:12:\"delete-12709\";i:13947;s:12:\"delete-12710\";i:13948;s:12:\"delete-12711\";i:13949;s:12:\"delete-12712\";i:13950;s:12:\"delete-12713\";i:13951;s:12:\"delete-12714\";i:13952;s:12:\"delete-12715\";i:13953;s:12:\"delete-12716\";i:13954;s:12:\"delete-12717\";i:13955;s:12:\"delete-12718\";i:13956;s:12:\"delete-12719\";i:13957;s:12:\"delete-12720\";i:13958;s:12:\"delete-12721\";i:13959;s:12:\"delete-12722\";i:13960;s:12:\"delete-12723\";i:13961;s:12:\"delete-12724\";i:13962;s:12:\"delete-12725\";i:13963;s:12:\"delete-12726\";i:13964;s:12:\"delete-12727\";i:13965;s:12:\"delete-12728\";i:13966;s:12:\"delete-12729\";i:13967;s:12:\"delete-12730\";i:13968;s:12:\"delete-12731\";i:13969;s:12:\"delete-12732\";i:13970;s:12:\"delete-12733\";i:13971;s:12:\"delete-12734\";i:13972;s:12:\"delete-12735\";i:13973;s:12:\"delete-12736\";i:13974;s:12:\"delete-12737\";i:13975;s:12:\"delete-12738\";i:13976;s:12:\"delete-12739\";i:13977;s:12:\"delete-12740\";i:13978;s:12:\"delete-12741\";i:13979;s:12:\"delete-12742\";i:13980;s:12:\"delete-12743\";i:13981;s:12:\"delete-12744\";i:13982;s:12:\"delete-12745\";i:13983;s:12:\"delete-12746\";i:13984;s:12:\"delete-12747\";i:13985;s:12:\"delete-12748\";i:13986;s:12:\"delete-12749\";i:13987;s:12:\"delete-12750\";i:13988;s:12:\"delete-12751\";i:13989;s:12:\"delete-12752\";i:13990;s:12:\"delete-12753\";i:13991;s:12:\"delete-12754\";i:13992;s:12:\"delete-12755\";i:13993;s:12:\"delete-12756\";i:13994;s:12:\"delete-12757\";i:13995;s:12:\"delete-12758\";i:13996;s:12:\"delete-12759\";i:13997;s:12:\"delete-12760\";i:13998;s:12:\"delete-12761\";i:13999;s:12:\"delete-12762\";i:14000;s:12:\"delete-12763\";i:14001;s:12:\"delete-12764\";i:14002;s:12:\"delete-12765\";i:14003;s:12:\"delete-12766\";i:14004;s:12:\"delete-12767\";i:14005;s:12:\"delete-12768\";i:14006;s:12:\"delete-12769\";i:14007;s:12:\"delete-12770\";i:14008;s:12:\"delete-12771\";i:14009;s:12:\"delete-12772\";i:14010;s:12:\"delete-12773\";i:14011;s:12:\"delete-12774\";i:14012;s:12:\"delete-12775\";i:14013;s:12:\"delete-12776\";i:14014;s:12:\"delete-12777\";i:14015;s:12:\"delete-12778\";i:14016;s:12:\"delete-12779\";i:14017;s:12:\"delete-12780\";i:14018;s:12:\"delete-12781\";i:14019;s:12:\"delete-12782\";i:14020;s:12:\"delete-12783\";i:14021;s:12:\"delete-12784\";i:14022;s:12:\"delete-12785\";i:14023;s:12:\"delete-12786\";i:14024;s:12:\"delete-12787\";i:14025;s:12:\"delete-12788\";i:14026;s:12:\"delete-12789\";i:14027;s:12:\"delete-12790\";i:14028;s:12:\"delete-12791\";i:14029;s:12:\"delete-12792\";i:14030;s:12:\"delete-12793\";i:14031;s:12:\"delete-12794\";i:14032;s:12:\"delete-12795\";i:14033;s:12:\"delete-12796\";i:14034;s:12:\"delete-12797\";i:14035;s:12:\"delete-12798\";i:14036;s:12:\"delete-12799\";i:14037;s:12:\"delete-12800\";i:14038;s:12:\"delete-12801\";i:14039;s:12:\"delete-12802\";i:14040;s:12:\"delete-12803\";i:14041;s:12:\"delete-12804\";i:14042;s:12:\"delete-12805\";i:14043;s:12:\"delete-12806\";i:14044;s:12:\"delete-12807\";i:14045;s:12:\"delete-12808\";i:14046;s:12:\"delete-12809\";i:14047;s:12:\"delete-12810\";i:14048;s:12:\"delete-12811\";i:14049;s:12:\"delete-12812\";i:14050;s:12:\"delete-12813\";i:14051;s:12:\"delete-12814\";i:14052;s:12:\"delete-12815\";i:14053;s:12:\"delete-12816\";i:14054;s:12:\"delete-12817\";i:14055;s:12:\"delete-12818\";i:14056;s:12:\"delete-12819\";i:14057;s:12:\"delete-12820\";i:14058;s:12:\"delete-12821\";i:14059;s:12:\"delete-12822\";i:14060;s:12:\"delete-12823\";i:14061;s:12:\"delete-12824\";i:14062;s:12:\"delete-12825\";i:14063;s:12:\"delete-12826\";i:14064;s:12:\"delete-12827\";i:14065;s:12:\"delete-12828\";i:14066;s:12:\"delete-12829\";i:14067;s:12:\"delete-12830\";i:14068;s:12:\"delete-12831\";i:14069;s:12:\"delete-12832\";i:14070;s:12:\"delete-12833\";i:14071;s:12:\"delete-12834\";i:14072;s:12:\"delete-12835\";i:14073;s:12:\"delete-12836\";i:14074;s:12:\"delete-12837\";i:14075;s:12:\"delete-12838\";i:14076;s:12:\"delete-12839\";i:14077;s:12:\"delete-12840\";i:14078;s:12:\"delete-12841\";i:14079;s:12:\"delete-12842\";i:14080;s:12:\"delete-12843\";i:14081;s:12:\"delete-12844\";i:14082;s:12:\"delete-12845\";i:14083;s:12:\"delete-12846\";i:14084;s:12:\"delete-12847\";i:14085;s:12:\"delete-12848\";i:14086;s:12:\"delete-12849\";i:14087;s:12:\"delete-12850\";i:14088;s:12:\"delete-12851\";i:14089;s:12:\"delete-12852\";i:14090;s:12:\"delete-12853\";i:14091;s:12:\"delete-12854\";i:14092;s:12:\"delete-12855\";i:14093;s:12:\"delete-12856\";i:14094;s:12:\"delete-12857\";i:14095;s:12:\"delete-12858\";i:14096;s:12:\"delete-12859\";i:14097;s:12:\"delete-12860\";i:14098;s:12:\"delete-12861\";i:14099;s:12:\"delete-12862\";i:14100;s:12:\"delete-12863\";i:14101;s:12:\"delete-12864\";i:14102;s:12:\"delete-12865\";i:14103;s:12:\"delete-12866\";i:14104;s:12:\"delete-12867\";i:14105;s:12:\"delete-12868\";i:14106;s:12:\"delete-12869\";i:14107;s:12:\"delete-12870\";i:14108;s:12:\"delete-12871\";i:14109;s:12:\"delete-12872\";i:14110;s:12:\"delete-12873\";i:14111;s:12:\"delete-12874\";i:14112;s:12:\"delete-12875\";i:14113;s:12:\"delete-12876\";i:14114;s:12:\"delete-12877\";i:14115;s:12:\"delete-12878\";i:14116;s:12:\"delete-12879\";i:14117;s:12:\"delete-12880\";i:14118;s:12:\"delete-12881\";i:14119;s:12:\"delete-12882\";i:14120;s:12:\"delete-12883\";i:14121;s:12:\"delete-12884\";i:14122;s:12:\"delete-12885\";i:14123;s:12:\"delete-12886\";i:14124;s:12:\"delete-12887\";i:14125;s:12:\"delete-12888\";i:14126;s:12:\"delete-12889\";i:14127;s:12:\"delete-12890\";i:14128;s:12:\"delete-12891\";i:14129;s:12:\"delete-12892\";i:14130;s:12:\"delete-12893\";i:14131;s:12:\"delete-12894\";i:14132;s:12:\"delete-12895\";i:14133;s:12:\"delete-12896\";i:14134;s:12:\"delete-12897\";i:14135;s:12:\"delete-12898\";i:14136;s:12:\"delete-12899\";i:14137;s:12:\"delete-12900\";i:14138;s:12:\"delete-12901\";i:14139;s:12:\"delete-12902\";i:14140;s:12:\"delete-12903\";i:14141;s:12:\"delete-12904\";i:14142;s:12:\"delete-12905\";i:14143;s:12:\"delete-12906\";i:14144;s:12:\"delete-12907\";i:14145;s:12:\"delete-12908\";i:14146;s:12:\"delete-12909\";i:14147;s:12:\"delete-12910\";i:14148;s:12:\"delete-12911\";i:14149;s:12:\"delete-12912\";i:14150;s:12:\"delete-12913\";i:14151;s:12:\"delete-12914\";i:14152;s:12:\"delete-12915\";i:14153;s:12:\"delete-12916\";i:14154;s:12:\"delete-12917\";i:14155;s:12:\"delete-12918\";i:14156;s:12:\"delete-12919\";i:14157;s:12:\"delete-12920\";i:14158;s:12:\"delete-12921\";i:14159;s:12:\"delete-12922\";i:14160;s:12:\"delete-12923\";i:14161;s:12:\"delete-12924\";i:14162;s:12:\"delete-12925\";i:14163;s:12:\"delete-12926\";i:14164;s:12:\"delete-12927\";i:14165;s:12:\"delete-12928\";i:14166;s:12:\"delete-12929\";i:14167;s:12:\"delete-12930\";i:14168;s:12:\"delete-12931\";i:14169;s:12:\"delete-12932\";i:14170;s:12:\"delete-12933\";i:14171;s:12:\"delete-12934\";i:14172;s:12:\"delete-12935\";i:14173;s:12:\"delete-12936\";i:14174;s:12:\"delete-12937\";i:14175;s:12:\"delete-12938\";i:14176;s:12:\"delete-12939\";i:14177;s:12:\"delete-12940\";i:14178;s:12:\"delete-12941\";i:14179;s:12:\"delete-12942\";i:14180;s:12:\"delete-12943\";i:14181;s:12:\"delete-12944\";i:14182;s:12:\"delete-12945\";i:14183;s:12:\"delete-12946\";i:14184;s:12:\"delete-12947\";i:14185;s:12:\"delete-12948\";i:14186;s:12:\"delete-12949\";i:14187;s:12:\"delete-12950\";i:14188;s:12:\"delete-12951\";i:14189;s:12:\"delete-12952\";i:14190;s:12:\"delete-12953\";i:14191;s:12:\"delete-12954\";i:14192;s:12:\"delete-12955\";i:14193;s:12:\"delete-12956\";i:14194;s:12:\"delete-12957\";i:14195;s:12:\"delete-12958\";i:14196;s:12:\"delete-12959\";i:14197;s:12:\"delete-12960\";i:14198;s:12:\"delete-12961\";i:14199;s:12:\"delete-12962\";i:14200;s:12:\"delete-12963\";i:14201;s:12:\"delete-12964\";i:14202;s:12:\"delete-12965\";i:14203;s:12:\"delete-12966\";i:14204;s:12:\"delete-12967\";i:14205;s:12:\"delete-12968\";i:14206;s:12:\"delete-12969\";i:14207;s:12:\"delete-12970\";i:14208;s:12:\"delete-12971\";i:14209;s:12:\"delete-12972\";i:14210;s:12:\"delete-12973\";i:14211;s:12:\"delete-12974\";i:14212;s:12:\"delete-12975\";i:14213;s:12:\"delete-12976\";i:14214;s:12:\"delete-12977\";i:14215;s:12:\"delete-12978\";i:14216;s:12:\"delete-12979\";i:14217;s:12:\"delete-12980\";i:14218;s:12:\"delete-12981\";i:14219;s:12:\"delete-12982\";i:14220;s:12:\"delete-12983\";i:14221;s:12:\"delete-12984\";i:14222;s:12:\"delete-12985\";i:14223;s:12:\"delete-12986\";i:14224;s:12:\"delete-12987\";i:14225;s:12:\"delete-12988\";i:14226;s:12:\"delete-12989\";i:14227;s:12:\"delete-12990\";i:14228;s:12:\"delete-12991\";i:14229;s:12:\"delete-12992\";i:14230;s:12:\"delete-12993\";i:14231;s:12:\"delete-12994\";i:14232;s:12:\"delete-12995\";i:14233;s:12:\"delete-12996\";i:14234;s:12:\"delete-12997\";i:14235;s:12:\"delete-12998\";i:14236;s:12:\"delete-12999\";i:14237;s:12:\"delete-13000\";i:14238;s:12:\"delete-13001\";i:14239;s:12:\"delete-13002\";i:14240;s:12:\"delete-13003\";i:14241;s:12:\"delete-13004\";i:14242;s:12:\"delete-13005\";i:14243;s:12:\"delete-13006\";i:14244;s:12:\"delete-13007\";i:14245;s:12:\"delete-13008\";i:14246;s:12:\"delete-13009\";i:14247;s:12:\"delete-13010\";i:14248;s:12:\"delete-13011\";i:14249;s:12:\"delete-13012\";i:14250;s:12:\"delete-13013\";i:14251;s:12:\"delete-13014\";i:14252;s:12:\"delete-13015\";i:14253;s:12:\"delete-13016\";i:14254;s:12:\"delete-13017\";i:14255;s:12:\"delete-13018\";i:14256;s:12:\"delete-13019\";i:14257;s:12:\"delete-13020\";i:14258;s:12:\"delete-13021\";i:14259;s:12:\"delete-13022\";i:14260;s:12:\"delete-13023\";i:14261;s:12:\"delete-13024\";i:14262;s:12:\"delete-13025\";i:14263;s:12:\"delete-13026\";i:14264;s:12:\"delete-13027\";i:14265;s:12:\"delete-13028\";i:14266;s:12:\"delete-13029\";i:14267;s:12:\"delete-13030\";i:14268;s:12:\"delete-13031\";i:14269;s:12:\"delete-13032\";i:14270;s:12:\"delete-13033\";i:14271;s:12:\"delete-13034\";i:14272;s:12:\"delete-13035\";i:14273;s:12:\"delete-13036\";i:14274;s:12:\"delete-13037\";i:14275;s:12:\"delete-13038\";i:14276;s:12:\"delete-13039\";i:14277;s:12:\"delete-13040\";i:14278;s:12:\"delete-13041\";i:14279;s:12:\"delete-13042\";i:14280;s:12:\"delete-13043\";i:14281;s:12:\"delete-13044\";i:14282;s:12:\"delete-13045\";i:14283;s:12:\"delete-13046\";i:14284;s:12:\"delete-13047\";i:14285;s:12:\"delete-13048\";i:14286;s:12:\"delete-13049\";i:14287;s:12:\"delete-13050\";i:14288;s:12:\"delete-13051\";i:14289;s:12:\"delete-13052\";i:14290;s:12:\"delete-13053\";i:14291;s:12:\"delete-13054\";i:14292;s:12:\"delete-13055\";i:14293;s:12:\"delete-13056\";i:14294;s:12:\"delete-13057\";i:14295;s:12:\"delete-13058\";i:14296;s:12:\"delete-13059\";i:14297;s:12:\"delete-13060\";i:14298;s:12:\"delete-13061\";i:14299;s:12:\"delete-13062\";i:14300;s:12:\"delete-13063\";i:14301;s:12:\"delete-13064\";i:14302;s:12:\"delete-13065\";i:14303;s:12:\"delete-13066\";i:14304;s:12:\"delete-13067\";i:14305;s:12:\"delete-13068\";i:14306;s:12:\"delete-13069\";i:14307;s:12:\"delete-13070\";i:14308;s:12:\"delete-13071\";i:14309;s:12:\"delete-13072\";i:14310;s:12:\"delete-13073\";i:14311;s:12:\"delete-13074\";i:14312;s:12:\"delete-13075\";i:14313;s:12:\"delete-13076\";i:14314;s:12:\"delete-13077\";i:14315;s:12:\"delete-13078\";i:14316;s:12:\"delete-13079\";i:14317;s:12:\"delete-13080\";i:14318;s:12:\"delete-13081\";i:14319;s:12:\"delete-13082\";i:14320;s:12:\"delete-13083\";i:14321;s:12:\"delete-13084\";i:14322;s:12:\"delete-13085\";i:14323;s:12:\"delete-13086\";i:14324;s:12:\"delete-13087\";i:14325;s:12:\"delete-13088\";i:14326;s:12:\"delete-13089\";i:14327;s:12:\"delete-13090\";i:14328;s:12:\"delete-13091\";i:14329;s:12:\"delete-13092\";i:14330;s:12:\"delete-13093\";i:14331;s:12:\"delete-13094\";i:14332;s:12:\"delete-13095\";i:14333;s:12:\"delete-13096\";i:14334;s:12:\"delete-13097\";i:14335;s:12:\"delete-13098\";i:14336;s:12:\"delete-13099\";i:14337;s:12:\"delete-13100\";i:14338;s:12:\"delete-13101\";i:14339;s:12:\"delete-13102\";i:14340;s:12:\"delete-13103\";i:14341;s:12:\"delete-13104\";i:14342;s:12:\"delete-13105\";i:14343;s:12:\"delete-13106\";i:14344;s:12:\"delete-13107\";i:14345;s:12:\"delete-13108\";i:14346;s:12:\"delete-13109\";i:14347;s:12:\"delete-13110\";i:14348;s:12:\"delete-13111\";i:14349;s:12:\"delete-13112\";i:14350;s:12:\"delete-13113\";i:14351;s:12:\"delete-13114\";i:14352;s:12:\"delete-13115\";i:14353;s:12:\"delete-13116\";i:14354;s:12:\"delete-13117\";i:14355;s:12:\"delete-13118\";i:14356;s:12:\"delete-13119\";i:14357;s:12:\"delete-13120\";i:14358;s:12:\"delete-13121\";i:14359;s:12:\"delete-13122\";i:14360;s:12:\"delete-13123\";i:14361;s:12:\"delete-13124\";i:14362;s:12:\"delete-13125\";i:14363;s:12:\"delete-13126\";i:14364;s:12:\"delete-13127\";i:14365;s:12:\"delete-13128\";i:14366;s:12:\"delete-13129\";i:14367;s:12:\"delete-13130\";i:14368;s:12:\"delete-13131\";i:14369;s:12:\"delete-13132\";i:14370;s:12:\"delete-13133\";i:14371;s:12:\"delete-13134\";i:14372;s:12:\"delete-13135\";i:14373;s:12:\"delete-13136\";i:14374;s:12:\"delete-13137\";i:14375;s:12:\"delete-13138\";i:14376;s:12:\"delete-13139\";i:14377;s:12:\"delete-13140\";i:14378;s:12:\"delete-13141\";i:14379;s:12:\"delete-13142\";i:14380;s:12:\"delete-13143\";i:14381;s:12:\"delete-13144\";i:14382;s:12:\"delete-13145\";i:14383;s:12:\"delete-13146\";i:14384;s:12:\"delete-13147\";i:14385;s:12:\"delete-13148\";i:14386;s:12:\"delete-13149\";i:14387;s:12:\"delete-13150\";i:14388;s:12:\"delete-13151\";i:14389;s:12:\"delete-13152\";i:14390;s:12:\"delete-13153\";i:14391;s:12:\"delete-13154\";i:14392;s:12:\"delete-13155\";i:14393;s:12:\"delete-13156\";i:14394;s:12:\"delete-13157\";i:14395;s:12:\"delete-13158\";i:14396;s:12:\"delete-13159\";i:14397;s:12:\"delete-13160\";i:14398;s:12:\"delete-13161\";i:14399;s:12:\"delete-13162\";i:14400;s:12:\"delete-13163\";i:14401;s:12:\"delete-13164\";i:14402;s:12:\"delete-13165\";i:14403;s:12:\"delete-13166\";i:14404;s:12:\"delete-13167\";i:14405;s:12:\"delete-13168\";i:14406;s:12:\"delete-13169\";i:14407;s:12:\"delete-13170\";i:14408;s:12:\"delete-13171\";i:14409;s:12:\"delete-13172\";i:14410;s:12:\"delete-13173\";i:14411;s:12:\"delete-13174\";i:14412;s:12:\"delete-13175\";i:14413;s:12:\"delete-13176\";i:14414;s:12:\"delete-13177\";i:14415;s:12:\"delete-13178\";i:14416;s:12:\"delete-13179\";i:14417;s:12:\"delete-13180\";i:14418;s:12:\"delete-13181\";i:14419;s:12:\"delete-13182\";i:14420;s:12:\"delete-13183\";i:14421;s:12:\"delete-13184\";i:14422;s:12:\"delete-13185\";i:14423;s:12:\"delete-13186\";i:14424;s:12:\"delete-13187\";i:14425;s:12:\"delete-13188\";i:14426;s:12:\"delete-13189\";i:14427;s:12:\"delete-13190\";i:14428;s:12:\"delete-13191\";i:14429;s:12:\"delete-13192\";i:14430;s:12:\"delete-13193\";i:14431;s:12:\"delete-13194\";i:14432;s:12:\"delete-13195\";i:14433;s:12:\"delete-13196\";i:14434;s:12:\"delete-13197\";i:14435;s:12:\"delete-13198\";i:14436;s:12:\"delete-13199\";i:14437;s:12:\"delete-13200\";i:14438;s:12:\"delete-13201\";i:14439;s:12:\"delete-13202\";i:14440;s:12:\"delete-13203\";i:14441;s:12:\"delete-13204\";i:14442;s:12:\"delete-13205\";i:14443;s:12:\"delete-13206\";i:14444;s:12:\"delete-13207\";i:14445;s:12:\"delete-13208\";i:14446;s:12:\"delete-13209\";i:14447;s:12:\"delete-13210\";i:14448;s:12:\"delete-13211\";i:14449;s:12:\"delete-13212\";i:14450;s:12:\"delete-13213\";i:14451;s:12:\"delete-13214\";i:14452;s:12:\"delete-13215\";i:14453;s:12:\"delete-13216\";i:14454;s:12:\"delete-13217\";i:14455;s:12:\"delete-13218\";i:14456;s:12:\"delete-13219\";i:14457;s:12:\"delete-13220\";i:14458;s:12:\"delete-13221\";i:14459;s:12:\"delete-13222\";i:14460;s:12:\"delete-13223\";i:14461;s:12:\"delete-13224\";i:14462;s:12:\"delete-13225\";i:14463;s:12:\"delete-13226\";i:14464;s:12:\"delete-13227\";i:14465;s:12:\"delete-13228\";i:14466;s:12:\"delete-13229\";i:14467;s:12:\"delete-13230\";i:14468;s:12:\"delete-13231\";i:14469;s:12:\"delete-13232\";i:14470;s:12:\"delete-13233\";i:14471;s:12:\"delete-13234\";i:14472;s:12:\"delete-13235\";i:14473;s:12:\"delete-13236\";i:14474;s:12:\"delete-13237\";i:14475;s:12:\"delete-13238\";i:14476;s:12:\"delete-13239\";i:14477;s:12:\"delete-13240\";i:14478;s:12:\"delete-13241\";i:14479;s:12:\"delete-13242\";i:14480;s:12:\"delete-13243\";i:14481;s:12:\"delete-13244\";i:14482;s:12:\"delete-13245\";i:14483;s:12:\"delete-13246\";i:14484;s:12:\"delete-13247\";i:14485;s:12:\"delete-13248\";i:14486;s:12:\"delete-13249\";i:14487;s:12:\"delete-13250\";i:14488;s:12:\"delete-13251\";i:14489;s:12:\"delete-13252\";i:14490;s:12:\"delete-13253\";i:14491;s:12:\"delete-13254\";i:14492;s:12:\"delete-13255\";i:14493;s:12:\"delete-13256\";i:14494;s:12:\"delete-13257\";i:14495;s:12:\"delete-13258\";i:14496;s:12:\"delete-13259\";i:14497;s:12:\"delete-13260\";i:14498;s:12:\"delete-13261\";i:14499;s:12:\"delete-13262\";i:14500;s:12:\"delete-13263\";i:14501;s:12:\"delete-13264\";i:14502;s:12:\"delete-13265\";i:14503;s:12:\"delete-13266\";i:14504;s:12:\"delete-13267\";i:14505;s:12:\"delete-13268\";i:14506;s:12:\"delete-13269\";i:14507;s:12:\"delete-13270\";i:14508;s:12:\"delete-13271\";i:14509;s:12:\"delete-13272\";i:14510;s:12:\"delete-13273\";i:14511;s:12:\"delete-13274\";i:14512;s:12:\"delete-13275\";i:14513;s:12:\"delete-13276\";i:14514;s:12:\"delete-13277\";i:14515;s:12:\"delete-13278\";i:14516;s:12:\"delete-13279\";i:14517;s:12:\"delete-13280\";i:14518;s:12:\"delete-13281\";i:14519;s:12:\"delete-13282\";i:14520;s:12:\"delete-13283\";i:14521;s:12:\"delete-13284\";i:14522;s:12:\"delete-13285\";i:14523;s:12:\"delete-13286\";i:14524;s:12:\"delete-13287\";i:14525;s:12:\"delete-13288\";i:14526;s:12:\"delete-13289\";i:14527;s:12:\"delete-13290\";i:14528;s:12:\"delete-13291\";i:14529;s:12:\"delete-13292\";i:14530;s:12:\"delete-13293\";i:14531;s:12:\"delete-13294\";i:14532;s:12:\"delete-13295\";i:14533;s:12:\"delete-13296\";i:14534;s:12:\"delete-13297\";i:14535;s:12:\"delete-13298\";i:14536;s:12:\"delete-13299\";i:14537;s:12:\"delete-13300\";i:14538;s:12:\"delete-13301\";i:14539;s:12:\"delete-13302\";i:14540;s:12:\"delete-13303\";i:14541;s:12:\"delete-13304\";i:14542;s:12:\"delete-13305\";i:14543;s:12:\"delete-13306\";i:14544;s:12:\"delete-13307\";i:14545;s:12:\"delete-13308\";i:14546;s:12:\"delete-13309\";i:14547;s:12:\"delete-13310\";i:14548;s:12:\"delete-13311\";i:14549;s:12:\"delete-13312\";i:14550;s:12:\"delete-13313\";i:14551;s:12:\"delete-13314\";i:14552;s:12:\"delete-13315\";i:14553;s:12:\"delete-13316\";i:14554;s:12:\"delete-13317\";i:14555;s:12:\"delete-13318\";i:14556;s:12:\"delete-13319\";i:14557;s:12:\"delete-13320\";i:14558;s:12:\"delete-13321\";i:14559;s:12:\"delete-13322\";i:14560;s:12:\"delete-13323\";i:14561;s:12:\"delete-13324\";i:14562;s:12:\"delete-13325\";i:14563;s:12:\"delete-13326\";i:14564;s:12:\"delete-13327\";i:14565;s:12:\"delete-13328\";i:14566;s:12:\"delete-13329\";i:14567;s:12:\"delete-13330\";i:14568;s:12:\"delete-13331\";i:14569;s:12:\"delete-13332\";i:14570;s:12:\"delete-13333\";i:14571;s:12:\"delete-13334\";i:14572;s:12:\"delete-13335\";i:14573;s:12:\"delete-13336\";i:14574;s:12:\"delete-13337\";i:14575;s:12:\"delete-13338\";i:14576;s:12:\"delete-13339\";i:14577;s:12:\"delete-13340\";i:14578;s:12:\"delete-13341\";i:14579;s:12:\"delete-13342\";i:14580;s:12:\"delete-13343\";i:14581;s:12:\"delete-13344\";i:14582;s:12:\"delete-13345\";i:14583;s:12:\"delete-13346\";i:14584;s:12:\"delete-13347\";i:14585;s:12:\"delete-13348\";i:14586;s:12:\"delete-13349\";i:14587;s:12:\"delete-13350\";i:14588;s:12:\"delete-13351\";i:14589;s:12:\"delete-13352\";i:14590;s:12:\"delete-13353\";i:14591;s:12:\"delete-13354\";i:14592;s:12:\"delete-13355\";i:14593;s:12:\"delete-13356\";i:14594;s:12:\"delete-13357\";i:14595;s:12:\"delete-13358\";i:14596;s:12:\"delete-13359\";i:14597;s:12:\"delete-13360\";i:14598;s:12:\"delete-13361\";i:14599;s:12:\"delete-13362\";i:14600;s:12:\"delete-13363\";i:14601;s:12:\"delete-13364\";i:14602;s:12:\"delete-13365\";i:14603;s:12:\"delete-13366\";i:14604;s:12:\"delete-13367\";i:14605;s:12:\"delete-13368\";i:14606;s:12:\"delete-13369\";i:14607;s:12:\"delete-13370\";i:14608;s:12:\"delete-13371\";i:14609;s:12:\"delete-13372\";i:14610;s:12:\"delete-13373\";i:14611;s:12:\"delete-13374\";i:14612;s:12:\"delete-13375\";i:14613;s:12:\"delete-13376\";i:14614;s:12:\"delete-13377\";i:14615;s:12:\"delete-13378\";i:14616;s:12:\"delete-13379\";i:14617;s:12:\"delete-13380\";i:14618;s:12:\"delete-13381\";i:14619;s:12:\"delete-13382\";i:14620;s:12:\"delete-13383\";i:14621;s:12:\"delete-13384\";i:14622;s:12:\"delete-13385\";i:14623;s:12:\"delete-13386\";i:14624;s:12:\"delete-13387\";i:14625;s:12:\"delete-13388\";i:14626;s:12:\"delete-13389\";i:14627;s:12:\"delete-13390\";i:14628;s:12:\"delete-13391\";i:14629;s:12:\"delete-13392\";i:14630;s:12:\"delete-13393\";i:14631;s:12:\"delete-13394\";i:14632;s:12:\"delete-13395\";i:14633;s:12:\"delete-13396\";i:14634;s:12:\"delete-13397\";i:14635;s:12:\"delete-13398\";i:14636;s:12:\"delete-13399\";i:14637;s:12:\"delete-13400\";i:14638;s:12:\"delete-13401\";i:14639;s:12:\"delete-13402\";i:14640;s:12:\"delete-13403\";i:14641;s:12:\"delete-13404\";i:14642;s:12:\"delete-13405\";i:14643;s:12:\"delete-13406\";i:14644;s:12:\"delete-13407\";i:14645;s:12:\"delete-13408\";i:14646;s:12:\"delete-13409\";i:14647;s:12:\"delete-13410\";i:14648;s:12:\"delete-13411\";i:14649;s:12:\"delete-13412\";i:14650;s:12:\"delete-13413\";i:14651;s:12:\"delete-13414\";i:14652;s:12:\"delete-13415\";i:14653;s:12:\"delete-13416\";i:14654;s:12:\"delete-13417\";i:14655;s:12:\"delete-13418\";i:14656;s:12:\"delete-13419\";i:14657;s:12:\"delete-13420\";i:14658;s:12:\"delete-13421\";i:14659;s:12:\"delete-13422\";i:14660;s:12:\"delete-13423\";i:14661;s:12:\"delete-13424\";i:14662;s:12:\"delete-13425\";i:14663;s:12:\"delete-13426\";i:14664;s:12:\"delete-13427\";i:14665;s:12:\"delete-13428\";i:14666;s:12:\"delete-13429\";i:14667;s:12:\"delete-13430\";i:14668;s:12:\"delete-13431\";i:14669;s:12:\"delete-13432\";i:14670;s:12:\"delete-13433\";i:14671;s:12:\"delete-13434\";i:14672;s:12:\"delete-13435\";i:14673;s:12:\"delete-13436\";i:14674;s:12:\"delete-13437\";i:14675;s:12:\"delete-13438\";i:14676;s:12:\"delete-13439\";i:14677;s:12:\"delete-13440\";i:14678;s:12:\"delete-13441\";i:14679;s:12:\"delete-13442\";i:14680;s:12:\"delete-13443\";i:14681;s:12:\"delete-13444\";i:14682;s:12:\"delete-13445\";i:14683;s:12:\"delete-13446\";i:14684;s:12:\"delete-13447\";i:14685;s:12:\"delete-13448\";i:14686;s:12:\"delete-13449\";i:14687;s:12:\"delete-13450\";i:14688;s:12:\"delete-13451\";i:14689;s:12:\"delete-13452\";i:14690;s:12:\"delete-13453\";i:14691;s:12:\"delete-13454\";i:14692;s:12:\"delete-13455\";i:14693;s:12:\"delete-13456\";i:14694;s:12:\"delete-13457\";i:14695;s:12:\"delete-13458\";i:14696;s:12:\"delete-13459\";i:14697;s:12:\"delete-13460\";i:14698;s:12:\"delete-13461\";i:14699;s:12:\"delete-13462\";i:14700;s:12:\"delete-13463\";i:14701;s:12:\"delete-13464\";i:14702;s:12:\"delete-13465\";i:14703;s:12:\"delete-13466\";i:14704;s:12:\"delete-13467\";i:14705;s:12:\"delete-13468\";i:14706;s:12:\"delete-13469\";i:14707;s:12:\"delete-13470\";i:14708;s:12:\"delete-13471\";i:14709;s:12:\"delete-13472\";i:14710;s:12:\"delete-13473\";i:14711;s:12:\"delete-13474\";i:14712;s:12:\"delete-13475\";i:14713;s:12:\"delete-13476\";i:14714;s:12:\"delete-13477\";i:14715;s:12:\"delete-13478\";i:14716;s:12:\"delete-13479\";i:14717;s:12:\"delete-13480\";i:14718;s:12:\"delete-13481\";i:14719;s:12:\"delete-13482\";i:14720;s:12:\"delete-13483\";i:14721;s:12:\"delete-13484\";i:14722;s:12:\"delete-13485\";i:14723;s:12:\"delete-13486\";i:14724;s:12:\"delete-13487\";i:14725;s:12:\"delete-13488\";i:14726;s:12:\"delete-13489\";i:14727;s:12:\"delete-13490\";i:14728;s:12:\"delete-13491\";i:14729;s:12:\"delete-13492\";i:14730;s:12:\"delete-13493\";i:14731;s:12:\"delete-13494\";i:14732;s:12:\"delete-13495\";i:14733;s:12:\"delete-13496\";i:14734;s:12:\"delete-13497\";i:14735;s:12:\"delete-13498\";i:14736;s:12:\"delete-13499\";i:14737;s:12:\"delete-13500\";i:14738;s:12:\"delete-13501\";i:14739;s:12:\"delete-13502\";i:14740;s:12:\"delete-13503\";i:14741;s:12:\"delete-13504\";i:14742;s:12:\"delete-13505\";i:14743;s:12:\"delete-13506\";i:14744;s:12:\"delete-13507\";i:14745;s:12:\"delete-13508\";i:14746;s:12:\"delete-13509\";i:14747;s:12:\"delete-13510\";i:14748;s:12:\"delete-13511\";i:14749;s:12:\"delete-13512\";i:14750;s:12:\"delete-13513\";i:14751;s:12:\"delete-13514\";i:14752;s:12:\"delete-13515\";i:14753;s:12:\"delete-13516\";i:14754;s:12:\"delete-13517\";i:14755;s:12:\"delete-13518\";i:14756;s:12:\"delete-13519\";i:14757;s:12:\"delete-13520\";i:14758;s:12:\"delete-13521\";i:14759;s:12:\"delete-13522\";i:14760;s:12:\"delete-13523\";i:14761;s:12:\"delete-13524\";i:14762;s:12:\"delete-13525\";i:14763;s:12:\"delete-13526\";i:14764;s:12:\"delete-13527\";i:14765;s:12:\"delete-13528\";i:14766;s:12:\"delete-13529\";i:14767;s:12:\"delete-13530\";i:14768;s:12:\"delete-13531\";i:14769;s:12:\"delete-13532\";i:14770;s:12:\"delete-13533\";i:14771;s:12:\"delete-13534\";i:14772;s:12:\"delete-13535\";i:14773;s:12:\"delete-13536\";i:14774;s:12:\"delete-13537\";i:14775;s:12:\"delete-13538\";i:14776;s:12:\"delete-13539\";i:14777;s:12:\"delete-13540\";i:14778;s:12:\"delete-13541\";i:14779;s:12:\"delete-13542\";i:14780;s:12:\"delete-13543\";i:14781;s:12:\"delete-13544\";i:14782;s:12:\"delete-13545\";i:14783;s:12:\"delete-13546\";i:14784;s:12:\"delete-13547\";i:14785;s:12:\"delete-13548\";i:14786;s:12:\"delete-13549\";i:14787;s:12:\"delete-13550\";i:14788;s:12:\"delete-13551\";i:14789;s:12:\"delete-13552\";i:14790;s:12:\"delete-13553\";i:14791;s:12:\"delete-13554\";i:14792;s:12:\"delete-13555\";i:14793;s:12:\"delete-13556\";i:14794;s:12:\"delete-13557\";i:14795;s:12:\"delete-13558\";i:14796;s:12:\"delete-13559\";i:14797;s:12:\"delete-13560\";i:14798;s:12:\"delete-13561\";i:14799;s:12:\"delete-13562\";i:14800;s:12:\"delete-13563\";i:14801;s:12:\"delete-13564\";i:14802;s:12:\"delete-13565\";i:14803;s:12:\"delete-13566\";i:14804;s:12:\"delete-13567\";i:14805;s:12:\"delete-13568\";i:14806;s:12:\"delete-13569\";i:14807;s:12:\"delete-13570\";i:14808;s:12:\"delete-13571\";i:14809;s:12:\"delete-13572\";i:14810;s:12:\"delete-13573\";i:14811;s:12:\"delete-13574\";i:14812;s:12:\"delete-13575\";i:14813;s:12:\"delete-13576\";i:14814;s:12:\"delete-13577\";i:14815;s:12:\"delete-13578\";i:14816;s:12:\"delete-13579\";i:14817;s:12:\"delete-13580\";i:14818;s:12:\"delete-13581\";i:14819;s:12:\"delete-13582\";i:14820;s:12:\"delete-13583\";i:14821;s:12:\"delete-13584\";i:14822;s:12:\"delete-13585\";i:14823;s:12:\"delete-13586\";i:14824;s:12:\"delete-13587\";i:14825;s:12:\"delete-13588\";i:14826;s:12:\"delete-13589\";i:14827;s:12:\"delete-13590\";i:14828;s:12:\"delete-13591\";i:14829;s:12:\"delete-13592\";i:14830;s:12:\"delete-13593\";i:14831;s:12:\"delete-13594\";i:14832;s:12:\"delete-13595\";i:14833;s:12:\"delete-13596\";i:14834;s:12:\"delete-13597\";i:14835;s:12:\"delete-13598\";i:14836;s:12:\"delete-13599\";i:14837;s:12:\"delete-13600\";i:14838;s:12:\"delete-13601\";i:14839;s:12:\"delete-13602\";i:14840;s:12:\"delete-13603\";i:14841;s:12:\"delete-13604\";i:14842;s:12:\"delete-13605\";i:14843;s:12:\"delete-13606\";i:14844;s:12:\"delete-13607\";i:14845;s:12:\"delete-13608\";i:14846;s:12:\"delete-13609\";i:14847;s:12:\"delete-13610\";i:14848;s:12:\"delete-13611\";i:14849;s:12:\"delete-13612\";i:14850;s:12:\"delete-13613\";i:14851;s:12:\"delete-13614\";i:14852;s:12:\"delete-13615\";i:14853;s:12:\"delete-13616\";i:14854;s:12:\"delete-13617\";i:14855;s:12:\"delete-13618\";i:14856;s:12:\"delete-13619\";i:14857;s:12:\"delete-13620\";i:14858;s:12:\"delete-13621\";i:14859;s:12:\"delete-13622\";i:14860;s:12:\"delete-13623\";i:14861;s:12:\"delete-13624\";i:14862;s:12:\"delete-13625\";i:14863;s:12:\"delete-13626\";i:14864;s:12:\"delete-13627\";i:14865;s:12:\"delete-13628\";i:14866;s:12:\"delete-13629\";i:14867;s:12:\"delete-13630\";i:14868;s:12:\"delete-13631\";i:14869;s:12:\"delete-13632\";i:14870;s:12:\"delete-13633\";i:14871;s:12:\"delete-13634\";i:14872;s:12:\"delete-13635\";i:14873;s:12:\"delete-13636\";i:14874;s:12:\"delete-13637\";i:14875;s:12:\"delete-13638\";i:14876;s:12:\"delete-13639\";i:14877;s:12:\"delete-13640\";i:14878;s:12:\"delete-13641\";i:14879;s:12:\"delete-13642\";i:14880;s:12:\"delete-13643\";i:14881;s:12:\"delete-13644\";i:14882;s:12:\"delete-13645\";i:14883;s:12:\"delete-13646\";i:14884;s:12:\"delete-13647\";i:14885;s:12:\"delete-13648\";i:14886;s:12:\"delete-13649\";i:14887;s:12:\"delete-13650\";i:14888;s:12:\"delete-13651\";i:14889;s:12:\"delete-13652\";i:14890;s:12:\"delete-13653\";i:14891;s:12:\"delete-13654\";i:14892;s:12:\"delete-13655\";i:14893;s:12:\"delete-13656\";i:14894;s:12:\"delete-13657\";i:14895;s:12:\"delete-13658\";i:14896;s:12:\"delete-13659\";i:14897;s:12:\"delete-13660\";i:14898;s:12:\"delete-13661\";i:14899;s:12:\"delete-13662\";i:14900;s:12:\"delete-13663\";i:14901;s:12:\"delete-13664\";i:14902;s:12:\"delete-13665\";i:14903;s:12:\"delete-13666\";i:14904;s:12:\"delete-13667\";i:14905;s:12:\"delete-13668\";i:14906;s:12:\"delete-13669\";i:14907;s:12:\"delete-13670\";i:14908;s:12:\"delete-13671\";i:14909;s:12:\"delete-13672\";i:14910;s:12:\"delete-13673\";i:14911;s:12:\"delete-13674\";i:14912;s:12:\"delete-13675\";i:14913;s:12:\"delete-13676\";i:14914;s:12:\"delete-13677\";i:14915;s:12:\"delete-13678\";i:14916;s:12:\"delete-13679\";i:14917;s:12:\"delete-13680\";i:14918;s:12:\"delete-13681\";i:14919;s:12:\"delete-13682\";i:14920;s:12:\"delete-13683\";i:14921;s:12:\"delete-13684\";i:14922;s:12:\"delete-13685\";i:14923;s:12:\"delete-13686\";i:14924;s:12:\"delete-13687\";i:14925;s:12:\"delete-13688\";i:14926;s:12:\"delete-13689\";i:14927;s:12:\"delete-13690\";i:14928;s:12:\"delete-13691\";i:14929;s:12:\"delete-13692\";i:14930;s:12:\"delete-13693\";i:14931;s:12:\"delete-13694\";i:14932;s:12:\"delete-13695\";i:14933;s:12:\"delete-13696\";i:14934;s:12:\"delete-13697\";i:14935;s:12:\"delete-13698\";i:14936;s:12:\"delete-13699\";i:14937;s:12:\"delete-13700\";i:14938;s:12:\"delete-13701\";i:14939;s:12:\"delete-13702\";i:14940;s:12:\"delete-13703\";i:14941;s:12:\"delete-13704\";i:14942;s:12:\"delete-13705\";i:14943;s:12:\"delete-13706\";i:14944;s:12:\"delete-13707\";i:14945;s:12:\"delete-13708\";i:14946;s:12:\"delete-13709\";i:14947;s:12:\"delete-13710\";i:14948;s:12:\"delete-13711\";i:14949;s:12:\"delete-13712\";i:14950;s:12:\"delete-13713\";i:14951;s:12:\"delete-13714\";i:14952;s:12:\"delete-13715\";i:14953;s:12:\"delete-13716\";i:14954;s:12:\"delete-13717\";i:14955;s:12:\"delete-13718\";i:14956;s:12:\"delete-13719\";i:14957;s:12:\"delete-13720\";i:14958;s:12:\"delete-13721\";i:14959;s:12:\"delete-13722\";i:14960;s:12:\"delete-13723\";i:14961;s:12:\"delete-13724\";i:14962;s:12:\"delete-13725\";i:14963;s:12:\"delete-13726\";i:14964;s:12:\"delete-13727\";i:14965;s:12:\"delete-13728\";i:14966;s:12:\"delete-13729\";i:14967;s:12:\"delete-13730\";i:14968;s:12:\"delete-13731\";i:14969;s:12:\"delete-13732\";i:14970;s:12:\"delete-13733\";i:14971;s:12:\"delete-13734\";i:14972;s:12:\"delete-13735\";i:14973;s:12:\"delete-13736\";i:14974;s:12:\"delete-13737\";i:14975;s:12:\"delete-13738\";i:14976;s:12:\"delete-13739\";i:14977;s:12:\"delete-13740\";i:14978;s:12:\"delete-13741\";i:14979;s:12:\"delete-13742\";i:14980;s:12:\"delete-13743\";i:14981;s:12:\"delete-13744\";i:14982;s:12:\"delete-13745\";i:14983;s:12:\"delete-13746\";i:14984;s:12:\"delete-13747\";i:14985;s:12:\"delete-13748\";i:14986;s:12:\"delete-13749\";i:14987;s:12:\"delete-13750\";i:14988;s:12:\"delete-13751\";i:14989;s:12:\"delete-13752\";i:14990;s:12:\"delete-13753\";i:14991;s:12:\"delete-13754\";i:14992;s:12:\"delete-13755\";i:14993;s:12:\"delete-13756\";i:14994;s:12:\"delete-13757\";i:14995;s:12:\"delete-13758\";i:14996;s:12:\"delete-13759\";i:14997;s:12:\"delete-13760\";i:14998;s:12:\"delete-13761\";i:14999;s:12:\"delete-13762\";i:15000;s:12:\"delete-13763\";i:15001;s:12:\"delete-13764\";i:15002;s:12:\"delete-13765\";i:15003;s:12:\"delete-13766\";i:15004;s:12:\"delete-13767\";i:15005;s:12:\"delete-13768\";i:15006;s:12:\"delete-13769\";i:15007;s:12:\"delete-13770\";i:15008;s:12:\"delete-13771\";i:15009;s:12:\"delete-13772\";i:15010;s:12:\"delete-13773\";i:15011;s:12:\"delete-13774\";i:15012;s:12:\"delete-13775\";i:15013;s:12:\"delete-13776\";i:15014;s:12:\"delete-13777\";i:15015;s:12:\"delete-13778\";i:15016;s:12:\"delete-13779\";i:15017;s:12:\"delete-13780\";i:15018;s:12:\"delete-13781\";i:15019;s:12:\"delete-13782\";i:15020;s:12:\"delete-13783\";i:15021;s:12:\"delete-13784\";i:15022;s:12:\"delete-13785\";i:15023;s:12:\"delete-13786\";i:15024;s:12:\"delete-13787\";i:15025;s:12:\"delete-13788\";i:15026;s:12:\"delete-13789\";i:15027;s:12:\"delete-13790\";i:15028;s:12:\"delete-13791\";i:15029;s:12:\"delete-13792\";i:15030;s:12:\"delete-13793\";i:15031;s:12:\"delete-13794\";i:15032;s:12:\"delete-13795\";i:15033;s:12:\"delete-13796\";i:15034;s:12:\"delete-13797\";i:15035;s:12:\"delete-13798\";i:15036;s:12:\"delete-13799\";i:15037;s:12:\"delete-13800\";i:15038;s:12:\"delete-13801\";i:15039;s:12:\"delete-13802\";i:15040;s:12:\"delete-13803\";i:15041;s:12:\"delete-13804\";i:15042;s:12:\"delete-13805\";i:15043;s:12:\"delete-13806\";i:15044;s:12:\"delete-13807\";i:15045;s:12:\"delete-13808\";i:15046;s:12:\"delete-13809\";i:15047;s:12:\"delete-13810\";i:15048;s:12:\"delete-13811\";i:15049;s:12:\"delete-13812\";i:15050;s:12:\"delete-13813\";i:15051;s:12:\"delete-13814\";i:15052;s:12:\"delete-13815\";i:15053;s:12:\"delete-13816\";i:15054;s:12:\"delete-13817\";i:15055;s:12:\"delete-13818\";i:15056;s:12:\"delete-13819\";i:15057;s:12:\"delete-13820\";i:15058;s:12:\"delete-13821\";i:15059;s:12:\"delete-13822\";i:15060;s:12:\"delete-13823\";i:15061;s:12:\"delete-13824\";i:15062;s:12:\"delete-13825\";i:15063;s:12:\"delete-13826\";i:15064;s:12:\"delete-13827\";i:15065;s:12:\"delete-13828\";i:15066;s:12:\"delete-13829\";i:15067;s:12:\"delete-13830\";i:15068;s:12:\"delete-13831\";i:15069;s:12:\"delete-13832\";i:15070;s:12:\"delete-13833\";i:15071;s:12:\"delete-13834\";i:15072;s:12:\"delete-13835\";i:15073;s:12:\"delete-13836\";i:15074;s:12:\"delete-13837\";i:15075;s:12:\"delete-13838\";i:15076;s:12:\"delete-13839\";i:15077;s:12:\"delete-13840\";i:15078;s:12:\"delete-13841\";i:15079;s:12:\"delete-13842\";i:15080;s:12:\"delete-13843\";i:15081;s:12:\"delete-13844\";i:15082;s:12:\"delete-13845\";i:15083;s:12:\"delete-13846\";i:15084;s:12:\"delete-13847\";i:15085;s:12:\"delete-13848\";i:15086;s:12:\"delete-13849\";i:15087;s:12:\"delete-13850\";i:15088;s:12:\"delete-13851\";i:15089;s:12:\"delete-13852\";i:15090;s:12:\"delete-13853\";i:15091;s:12:\"delete-13854\";i:15092;s:12:\"delete-13855\";i:15093;s:12:\"delete-13856\";i:15094;s:12:\"delete-13857\";i:15095;s:12:\"delete-13858\";i:15096;s:12:\"delete-13859\";i:15097;s:12:\"delete-13860\";i:15098;s:12:\"delete-13861\";i:15099;s:12:\"delete-13862\";i:15100;s:12:\"delete-13863\";i:15101;s:12:\"delete-13864\";i:15102;s:12:\"delete-13865\";i:15103;s:12:\"delete-13866\";i:15104;s:12:\"delete-13867\";i:15105;s:12:\"delete-13868\";i:15106;s:12:\"delete-13869\";i:15107;s:12:\"delete-13870\";i:15108;s:12:\"delete-13871\";i:15109;s:12:\"delete-13872\";i:15110;s:12:\"delete-13873\";i:15111;s:12:\"delete-13874\";i:15112;s:12:\"delete-13875\";i:15113;s:12:\"delete-13876\";i:15114;s:12:\"delete-13877\";i:15115;s:12:\"delete-13878\";i:15116;s:12:\"delete-13879\";i:15117;s:12:\"delete-13880\";i:15118;s:12:\"delete-13881\";i:15119;s:12:\"delete-13882\";i:15120;s:12:\"delete-13883\";i:15121;s:12:\"delete-13884\";i:15122;s:12:\"delete-13885\";i:15123;s:12:\"delete-13886\";i:15124;s:12:\"delete-13887\";i:15125;s:12:\"delete-13888\";i:15126;s:12:\"delete-13889\";i:15127;s:12:\"delete-13890\";i:15128;s:12:\"delete-13891\";i:15129;s:12:\"delete-13892\";i:15130;s:12:\"delete-13893\";i:15131;s:12:\"delete-13894\";i:15132;s:12:\"delete-13895\";i:15133;s:12:\"delete-13896\";i:15134;s:12:\"delete-13897\";i:15135;s:12:\"delete-13898\";i:15136;s:12:\"delete-13899\";i:15137;s:12:\"delete-13900\";i:15138;s:12:\"delete-13901\";i:15139;s:12:\"delete-13902\";i:15140;s:12:\"delete-13903\";i:15141;s:12:\"delete-13904\";i:15142;s:12:\"delete-13905\";i:15143;s:12:\"delete-13906\";i:15144;s:12:\"delete-13907\";i:15145;s:12:\"delete-13908\";i:15146;s:12:\"delete-13909\";i:15147;s:12:\"delete-13910\";i:15148;s:12:\"delete-13911\";i:15149;s:12:\"delete-13912\";i:15150;s:12:\"delete-13913\";i:15151;s:12:\"delete-13914\";i:15152;s:12:\"delete-13915\";i:15153;s:12:\"delete-13916\";i:15154;s:12:\"delete-13917\";i:15155;s:12:\"delete-13918\";i:15156;s:12:\"delete-13919\";i:15157;s:12:\"delete-13920\";i:15158;s:12:\"delete-13921\";i:15159;s:12:\"delete-13922\";i:15160;s:12:\"delete-13923\";i:15161;s:12:\"delete-13924\";i:15162;s:12:\"delete-13925\";i:15163;s:12:\"delete-13926\";i:15164;s:12:\"delete-13927\";i:15165;s:12:\"delete-13928\";i:15166;s:12:\"delete-13929\";i:15167;s:12:\"delete-13930\";i:15168;s:12:\"delete-13931\";i:15169;s:12:\"delete-13932\";i:15170;s:12:\"delete-13933\";i:15171;s:12:\"delete-13934\";i:15172;s:12:\"delete-13935\";i:15173;s:12:\"delete-13936\";i:15174;s:12:\"delete-13937\";i:15175;s:12:\"delete-13938\";i:15176;s:12:\"delete-13939\";i:15177;s:12:\"delete-13940\";i:15178;s:12:\"delete-13941\";i:15179;s:12:\"delete-13942\";i:15180;s:12:\"delete-13943\";i:15181;s:12:\"delete-13944\";i:15182;s:12:\"delete-13945\";i:15183;s:12:\"delete-13946\";i:15184;s:12:\"delete-13947\";i:15185;s:12:\"delete-13948\";i:15186;s:12:\"delete-13949\";i:15187;s:12:\"delete-13950\";i:15188;s:12:\"delete-13951\";i:15189;s:12:\"delete-13952\";i:15190;s:12:\"delete-13953\";i:15191;s:12:\"delete-13954\";i:15192;s:12:\"delete-13955\";i:15193;s:12:\"delete-13956\";i:15194;s:12:\"delete-13957\";i:15195;s:12:\"delete-13958\";i:15196;s:12:\"delete-13959\";i:15197;s:12:\"delete-13960\";i:15198;s:12:\"delete-13961\";i:15199;s:12:\"delete-13962\";i:15200;s:12:\"delete-13963\";i:15201;s:12:\"delete-13964\";i:15202;s:12:\"delete-13965\";i:15203;s:12:\"delete-13966\";i:15204;s:12:\"delete-13967\";i:15205;s:12:\"delete-13968\";i:15206;s:12:\"delete-13969\";i:15207;s:12:\"delete-13970\";i:15208;s:12:\"delete-13971\";i:15209;s:12:\"delete-13972\";i:15210;s:12:\"delete-13973\";i:15211;s:12:\"delete-13974\";i:15212;s:12:\"delete-13975\";i:15213;s:12:\"delete-13976\";i:15214;s:12:\"delete-13977\";i:15215;s:12:\"delete-13978\";i:15216;s:12:\"delete-13979\";i:15217;s:12:\"delete-13980\";i:15218;s:12:\"delete-13981\";i:15219;s:12:\"delete-13982\";i:15220;s:12:\"delete-13983\";i:15221;s:12:\"delete-13984\";i:15222;s:12:\"delete-13985\";i:15223;s:12:\"delete-13986\";i:15224;s:12:\"delete-13987\";i:15225;s:12:\"delete-13988\";i:15226;s:12:\"delete-13989\";i:15227;s:12:\"delete-13990\";i:15228;s:12:\"delete-13991\";i:15229;s:12:\"delete-13992\";i:15230;s:12:\"delete-13993\";i:15231;s:12:\"delete-13994\";i:15232;s:12:\"delete-13995\";i:15233;s:12:\"delete-13996\";i:15234;s:12:\"delete-13997\";i:15235;s:12:\"delete-13998\";i:15236;s:12:\"delete-13999\";i:15237;s:12:\"delete-14000\";i:15238;s:12:\"delete-14001\";i:15239;s:12:\"delete-14002\";i:15240;s:12:\"delete-14003\";i:15241;s:12:\"delete-14004\";i:15242;s:12:\"delete-14005\";i:15243;s:12:\"delete-14006\";i:15244;s:12:\"delete-14007\";i:15245;s:12:\"delete-14008\";i:15246;s:12:\"delete-14009\";i:15247;s:12:\"delete-14010\";i:15248;s:12:\"delete-14011\";i:15249;s:12:\"delete-14012\";i:15250;s:12:\"delete-14013\";i:15251;s:12:\"delete-14014\";i:15252;s:12:\"delete-14015\";i:15253;s:12:\"delete-14016\";i:15254;s:12:\"delete-14017\";i:15255;s:12:\"delete-14018\";i:15256;s:12:\"delete-14019\";i:15257;s:12:\"delete-14020\";i:15258;s:12:\"delete-14021\";i:15259;s:12:\"delete-14022\";i:15260;s:12:\"delete-14023\";i:15261;s:12:\"delete-14024\";i:15262;s:12:\"delete-14025\";i:15263;s:12:\"delete-14026\";i:15264;s:12:\"delete-14027\";i:15265;s:12:\"delete-14028\";i:15266;s:12:\"delete-14029\";i:15267;s:12:\"delete-14030\";i:15268;s:12:\"delete-14031\";i:15269;s:12:\"delete-14032\";i:15270;s:12:\"delete-14033\";i:15271;s:12:\"delete-14034\";i:15272;s:12:\"delete-14035\";i:15273;s:12:\"delete-14036\";i:15274;s:12:\"delete-14037\";i:15275;s:12:\"delete-14038\";i:15276;s:12:\"delete-14039\";i:15277;s:12:\"delete-14040\";i:15278;s:12:\"delete-14041\";i:15279;s:12:\"delete-14042\";i:15280;s:12:\"delete-14043\";i:15281;s:12:\"delete-14044\";i:15282;s:12:\"delete-14045\";i:15283;s:12:\"delete-14046\";i:15284;s:12:\"delete-14047\";i:15285;s:12:\"delete-14048\";i:15286;s:12:\"delete-14049\";i:15287;s:12:\"delete-14050\";i:15288;s:12:\"delete-14051\";i:15289;s:12:\"delete-14052\";i:15290;s:12:\"delete-14053\";i:15291;s:12:\"delete-14054\";i:15292;s:12:\"delete-14055\";i:15293;s:12:\"delete-14056\";i:15294;s:12:\"delete-14057\";i:15295;s:12:\"delete-14058\";i:15296;s:12:\"delete-14059\";i:15297;s:12:\"delete-14060\";i:15298;s:12:\"delete-14061\";i:15299;s:12:\"delete-14062\";i:15300;s:12:\"delete-14063\";i:15301;s:12:\"delete-14064\";i:15302;s:12:\"delete-14065\";i:15303;s:12:\"delete-14066\";i:15304;s:12:\"delete-14067\";i:15305;s:12:\"delete-14068\";i:15306;s:12:\"delete-14069\";i:15307;s:12:\"delete-14070\";i:15308;s:12:\"delete-14071\";i:15309;s:12:\"delete-14072\";i:15310;s:12:\"delete-14073\";i:15311;s:12:\"delete-14074\";i:15312;s:12:\"delete-14075\";i:15313;s:12:\"delete-14076\";i:15314;s:12:\"delete-14077\";i:15315;s:12:\"delete-14078\";i:15316;s:12:\"delete-14079\";i:15317;s:12:\"delete-14080\";i:15318;s:12:\"delete-14081\";i:15319;s:12:\"delete-14082\";i:15320;s:12:\"delete-14083\";i:15321;s:12:\"delete-14084\";i:15322;s:12:\"delete-14085\";i:15323;s:12:\"delete-14086\";i:15324;s:12:\"delete-14087\";i:15325;s:12:\"delete-14088\";i:15326;s:12:\"delete-14089\";i:15327;s:12:\"delete-14090\";i:15328;s:12:\"delete-14091\";i:15329;s:12:\"delete-14092\";i:15330;s:12:\"delete-14093\";i:15331;s:12:\"delete-14094\";i:15332;s:12:\"delete-14095\";i:15333;s:12:\"delete-14096\";i:15334;s:12:\"delete-14097\";i:15335;s:12:\"delete-14098\";i:15336;s:12:\"delete-14099\";i:15337;s:12:\"delete-14100\";i:15338;s:12:\"delete-14101\";i:15339;s:12:\"delete-14102\";i:15340;s:12:\"delete-14103\";i:15341;s:12:\"delete-14104\";i:15342;s:12:\"delete-14105\";i:15343;s:12:\"delete-14106\";i:15344;s:12:\"delete-14107\";i:15345;s:12:\"delete-14108\";i:15346;s:12:\"delete-14109\";i:15347;s:12:\"delete-14110\";i:15348;s:12:\"delete-14111\";i:15349;s:12:\"delete-14112\";i:15350;s:12:\"delete-14113\";i:15351;s:12:\"delete-14114\";i:15352;s:12:\"delete-14115\";i:15353;s:12:\"delete-14116\";i:15354;s:12:\"delete-14117\";i:15355;s:12:\"delete-14118\";i:15356;s:12:\"delete-14119\";i:15357;s:12:\"delete-14120\";i:15358;s:12:\"delete-14121\";i:15359;s:12:\"delete-14122\";i:15360;s:12:\"delete-14123\";i:15361;s:12:\"delete-14124\";i:15362;s:12:\"delete-14125\";i:15363;s:12:\"delete-14126\";i:15364;s:12:\"delete-14127\";i:15365;s:12:\"delete-14128\";i:15366;s:12:\"delete-14129\";i:15367;s:12:\"delete-14130\";i:15368;s:12:\"delete-14131\";i:15369;s:12:\"delete-14132\";i:15370;s:12:\"delete-14133\";i:15371;s:12:\"delete-14134\";i:15372;s:12:\"delete-14135\";i:15373;s:12:\"delete-14136\";i:15374;s:12:\"delete-14137\";i:15375;s:12:\"delete-14138\";i:15376;s:12:\"delete-14139\";i:15377;s:12:\"delete-14140\";i:15378;s:12:\"delete-14141\";i:15379;s:12:\"delete-14142\";i:15380;s:12:\"delete-14143\";i:15381;s:12:\"delete-14144\";i:15382;s:12:\"delete-14145\";i:15383;s:12:\"delete-14146\";i:15384;s:12:\"delete-14147\";i:15385;s:12:\"delete-14148\";i:15386;s:12:\"delete-14149\";i:15387;s:12:\"delete-14150\";i:15388;s:12:\"delete-14151\";i:15389;s:12:\"delete-14152\";i:15390;s:12:\"delete-14153\";i:15391;s:12:\"delete-14154\";i:15392;s:12:\"delete-14155\";i:15393;s:12:\"delete-14156\";i:15394;s:12:\"delete-14157\";i:15395;s:12:\"delete-14158\";i:15396;s:12:\"delete-14159\";i:15397;s:12:\"delete-14160\";i:15398;s:12:\"delete-14161\";i:15399;s:12:\"delete-14162\";i:15400;s:12:\"delete-14163\";i:15401;s:12:\"delete-14164\";i:15402;s:12:\"delete-14165\";i:15403;s:12:\"delete-14166\";i:15404;s:12:\"delete-14167\";i:15405;s:12:\"delete-14168\";i:15406;s:12:\"delete-14169\";i:15407;s:12:\"delete-14170\";i:15408;s:12:\"delete-14171\";i:15409;s:12:\"delete-14172\";i:15410;s:12:\"delete-14173\";i:15411;s:12:\"delete-14174\";i:15412;s:12:\"delete-14175\";i:15413;s:12:\"delete-14176\";i:15414;s:12:\"delete-14177\";i:15415;s:12:\"delete-14178\";i:15416;s:12:\"delete-14179\";i:15417;s:12:\"delete-14180\";i:15418;s:12:\"delete-14181\";i:15419;s:12:\"delete-14182\";i:15420;s:12:\"delete-14183\";i:15421;s:12:\"delete-14184\";i:15422;s:12:\"delete-14185\";i:15423;s:12:\"delete-14186\";i:15424;s:12:\"delete-14187\";i:15425;s:12:\"delete-14188\";i:15426;s:12:\"delete-14189\";i:15427;s:12:\"delete-14190\";i:15428;s:12:\"delete-14191\";i:15429;s:12:\"delete-14192\";i:15430;s:12:\"delete-14193\";i:15431;s:12:\"delete-14194\";i:15432;s:12:\"delete-14195\";i:15433;s:12:\"delete-14196\";i:15434;s:12:\"delete-14197\";i:15435;s:12:\"delete-14198\";i:15436;s:12:\"delete-14199\";i:15437;s:12:\"delete-14200\";i:15438;s:12:\"delete-14201\";i:15439;s:12:\"delete-14202\";i:15440;s:12:\"delete-14203\";i:15441;s:12:\"delete-14204\";i:15442;s:12:\"delete-14205\";i:15443;s:12:\"delete-14206\";i:15444;s:12:\"delete-14207\";i:15445;s:12:\"delete-14208\";i:15446;s:12:\"delete-14209\";i:15447;s:12:\"delete-14210\";i:15448;s:12:\"delete-14211\";i:15449;s:12:\"delete-14212\";i:15450;s:12:\"delete-14213\";i:15451;s:12:\"delete-14214\";i:15452;s:12:\"delete-14215\";i:15453;s:12:\"delete-14216\";i:15454;s:12:\"delete-14217\";i:15455;s:12:\"delete-14218\";i:15456;s:12:\"delete-14219\";i:15457;s:12:\"delete-14220\";i:15458;s:12:\"delete-14221\";i:15459;s:12:\"delete-14222\";i:15460;s:12:\"delete-14223\";i:15461;s:12:\"delete-14224\";i:15462;s:12:\"delete-14225\";i:15463;s:12:\"delete-14226\";i:15464;s:12:\"delete-14227\";i:15465;s:12:\"delete-14228\";i:15466;s:12:\"delete-14229\";i:15467;s:12:\"delete-14230\";i:15468;s:12:\"delete-14231\";i:15469;s:12:\"delete-14232\";i:15470;s:12:\"delete-14233\";i:15471;s:12:\"delete-14234\";i:15472;s:12:\"delete-14235\";i:15473;s:12:\"delete-14236\";i:15474;s:12:\"delete-14237\";i:15475;s:12:\"delete-14238\";i:15476;s:12:\"delete-14239\";i:15477;s:12:\"delete-14240\";i:15478;s:12:\"delete-14241\";i:15479;s:12:\"delete-14242\";i:15480;s:12:\"delete-14243\";i:15481;s:12:\"delete-14244\";i:15482;s:12:\"delete-14245\";i:15483;s:12:\"delete-14246\";i:15484;s:12:\"delete-14247\";i:15485;s:12:\"delete-14248\";i:15486;s:12:\"delete-14249\";i:15487;s:12:\"delete-14250\";i:15488;s:12:\"delete-14251\";i:15489;s:12:\"delete-14252\";i:15490;s:12:\"delete-14253\";i:15491;s:12:\"delete-14254\";i:15492;s:12:\"delete-14255\";i:15493;s:12:\"delete-14256\";i:15494;s:12:\"delete-14257\";i:15495;s:12:\"delete-14258\";i:15496;s:12:\"delete-14259\";i:15497;s:12:\"delete-14260\";i:15498;s:12:\"delete-14261\";i:15499;s:12:\"delete-14262\";i:15500;s:12:\"delete-14263\";i:15501;s:12:\"delete-14264\";i:15502;s:12:\"delete-14265\";i:15503;s:12:\"delete-14266\";i:15504;s:12:\"delete-14267\";i:15505;s:12:\"delete-14268\";i:15506;s:12:\"delete-14269\";i:15507;s:12:\"delete-14270\";i:15508;s:12:\"delete-14271\";i:15509;s:12:\"delete-14272\";i:15510;s:12:\"delete-14273\";i:15511;s:12:\"delete-14274\";i:15512;s:12:\"delete-14275\";i:15513;s:12:\"delete-14276\";i:15514;s:12:\"delete-14277\";i:15515;s:12:\"delete-14278\";i:15516;s:12:\"delete-14279\";i:15517;s:12:\"delete-14280\";i:15518;s:12:\"delete-14281\";i:15519;s:12:\"delete-14282\";i:15520;s:12:\"delete-14283\";i:15521;s:12:\"delete-14284\";i:15522;s:12:\"delete-14285\";i:15523;s:12:\"delete-14286\";i:15524;s:12:\"delete-14287\";i:15525;s:12:\"delete-14288\";i:15526;s:12:\"delete-14289\";i:15527;s:12:\"delete-14290\";i:15528;s:12:\"delete-14291\";i:15529;s:12:\"delete-14292\";i:15530;s:12:\"delete-14293\";i:15531;s:12:\"delete-14294\";i:15532;s:12:\"delete-14295\";i:15533;s:12:\"delete-14296\";i:15534;s:12:\"delete-14297\";i:15535;s:12:\"delete-14298\";i:15536;s:12:\"delete-14299\";i:15537;s:12:\"delete-14300\";i:15538;s:12:\"delete-14301\";i:15539;s:12:\"delete-14302\";i:15540;s:12:\"delete-14303\";i:15541;s:12:\"delete-14304\";i:15542;s:12:\"delete-14305\";i:15543;s:12:\"delete-14306\";i:15544;s:12:\"delete-14307\";i:15545;s:12:\"delete-14308\";i:15546;s:12:\"delete-14309\";i:15547;s:12:\"delete-14310\";i:15548;s:12:\"delete-14311\";i:15549;s:12:\"delete-14312\";i:15550;s:12:\"delete-14313\";i:15551;s:12:\"delete-14314\";i:15552;s:12:\"delete-14315\";i:15553;s:12:\"delete-14316\";i:15554;s:12:\"delete-14317\";i:15555;s:12:\"delete-14318\";i:15556;s:12:\"delete-14319\";i:15557;s:12:\"delete-14320\";i:15558;s:12:\"delete-14321\";i:15559;s:12:\"delete-14322\";i:15560;s:12:\"delete-14323\";i:15561;s:12:\"delete-14324\";i:15562;s:12:\"delete-14325\";i:15563;s:12:\"delete-14326\";i:15564;s:12:\"delete-14327\";i:15565;s:12:\"delete-14328\";i:15566;s:12:\"delete-14329\";i:15567;s:12:\"delete-14330\";i:15568;s:12:\"delete-14331\";i:15569;s:12:\"delete-14332\";i:15570;s:12:\"delete-14333\";i:15571;s:12:\"delete-14334\";i:15572;s:12:\"delete-14335\";i:15573;s:12:\"delete-14336\";i:15574;s:12:\"delete-14337\";i:15575;s:12:\"delete-14338\";i:15576;s:12:\"delete-14339\";i:15577;s:12:\"delete-14340\";i:15578;s:12:\"delete-14341\";i:15579;s:12:\"delete-14342\";i:15580;s:12:\"delete-14343\";i:15581;s:12:\"delete-14344\";i:15582;s:12:\"delete-14345\";i:15583;s:12:\"delete-14346\";i:15584;s:12:\"delete-14347\";i:15585;s:12:\"delete-14348\";i:15586;s:12:\"delete-14349\";i:15587;s:12:\"delete-14350\";i:15588;s:12:\"delete-14351\";i:15589;s:12:\"delete-14352\";i:15590;s:12:\"delete-14353\";i:15591;s:12:\"delete-14354\";i:15592;s:12:\"delete-14355\";i:15593;s:12:\"delete-14356\";i:15594;s:12:\"delete-14357\";i:15595;s:12:\"delete-14358\";i:15596;s:12:\"delete-14359\";i:15597;s:12:\"delete-14360\";i:15598;s:12:\"delete-14361\";i:15599;s:12:\"delete-14362\";i:15600;s:12:\"delete-14363\";i:15601;s:12:\"delete-14364\";i:15602;s:12:\"delete-14365\";i:15603;s:12:\"delete-14366\";i:15604;s:12:\"delete-14367\";i:15605;s:12:\"delete-14368\";i:15606;s:12:\"delete-14369\";i:15607;s:12:\"delete-14370\";i:15608;s:12:\"delete-14371\";i:15609;s:12:\"delete-14372\";i:15610;s:12:\"delete-14373\";i:15611;s:12:\"delete-14374\";i:15612;s:12:\"delete-14375\";i:15613;s:12:\"delete-14376\";i:15614;s:12:\"delete-14377\";i:15615;s:12:\"delete-14378\";i:15616;s:12:\"delete-14379\";i:15617;s:12:\"delete-14380\";i:15618;s:12:\"delete-14381\";i:15619;s:12:\"delete-14382\";i:15620;s:12:\"delete-14383\";i:15621;s:12:\"delete-14384\";i:15622;s:12:\"delete-14385\";i:15623;s:12:\"delete-14386\";i:15624;s:12:\"delete-14387\";i:15625;s:12:\"delete-14388\";i:15626;s:12:\"delete-14389\";i:15627;s:12:\"delete-14390\";i:15628;s:12:\"delete-14391\";i:15629;s:12:\"delete-14392\";i:15630;s:12:\"delete-14393\";i:15631;s:12:\"delete-14394\";i:15632;s:12:\"delete-14395\";i:15633;s:12:\"delete-14396\";i:15634;s:12:\"delete-14397\";i:15635;s:12:\"delete-14398\";i:15636;s:12:\"delete-14399\";i:15637;s:12:\"delete-14400\";i:15638;s:12:\"delete-14401\";i:15639;s:12:\"delete-14402\";i:15640;s:12:\"delete-14403\";i:15641;s:12:\"delete-14404\";i:15642;s:12:\"delete-14405\";i:15643;s:12:\"delete-14406\";i:15644;s:12:\"delete-14407\";i:15645;s:12:\"delete-14408\";i:15646;s:12:\"delete-14409\";i:15647;s:12:\"delete-14410\";i:15648;s:12:\"delete-14411\";i:15649;s:12:\"delete-14412\";i:15650;s:12:\"delete-14413\";i:15651;s:12:\"delete-14414\";i:15652;s:12:\"delete-14415\";i:15653;s:12:\"delete-14416\";i:15654;s:12:\"delete-14417\";i:15655;s:12:\"delete-14418\";i:15656;s:12:\"delete-14419\";i:15657;s:12:\"delete-14420\";i:15658;s:12:\"delete-14421\";i:15659;s:12:\"delete-14422\";i:15660;s:12:\"delete-14423\";i:15661;s:12:\"delete-14424\";i:15662;s:12:\"delete-14425\";i:15663;s:12:\"delete-14426\";i:15664;s:12:\"delete-14427\";i:15665;s:12:\"delete-14428\";i:15666;s:12:\"delete-14429\";i:15667;s:12:\"delete-14430\";i:15668;s:12:\"delete-14431\";i:15669;s:12:\"delete-14432\";i:15670;s:12:\"delete-14433\";i:15671;s:12:\"delete-14434\";i:15672;s:12:\"delete-14435\";i:15673;s:12:\"delete-14436\";i:15674;s:12:\"delete-14437\";i:15675;s:12:\"delete-14438\";i:15676;s:12:\"delete-14439\";i:15677;s:12:\"delete-14440\";i:15678;s:12:\"delete-14441\";i:15679;s:12:\"delete-14442\";i:15680;s:12:\"delete-14443\";i:15681;s:12:\"delete-14444\";i:15682;s:12:\"delete-14445\";i:15683;s:12:\"delete-14446\";i:15684;s:12:\"delete-14447\";i:15685;s:12:\"delete-14448\";i:15686;s:12:\"delete-14449\";i:15687;s:12:\"delete-14450\";i:15688;s:12:\"delete-14451\";i:15689;s:12:\"delete-14452\";i:15690;s:12:\"delete-14453\";i:15691;s:12:\"delete-14454\";i:15692;s:12:\"delete-14455\";i:15693;s:12:\"delete-14456\";i:15694;s:12:\"delete-14457\";i:15695;s:12:\"delete-14458\";i:15696;s:12:\"delete-14459\";i:15697;s:12:\"delete-14460\";i:15698;s:12:\"delete-14461\";i:15699;s:12:\"delete-14462\";i:15700;s:12:\"delete-14463\";i:15701;s:12:\"delete-14464\";i:15702;s:12:\"delete-14465\";i:15703;s:12:\"delete-14466\";i:15704;s:12:\"delete-14467\";i:15705;s:12:\"delete-14468\";i:15706;s:12:\"delete-14469\";i:15707;s:12:\"delete-14470\";i:15708;s:12:\"delete-14471\";i:15709;s:12:\"delete-14472\";i:15710;s:12:\"delete-14473\";i:15711;s:12:\"delete-14474\";i:15712;s:12:\"delete-14475\";i:15713;s:12:\"delete-14476\";i:15714;s:12:\"delete-14477\";i:15715;s:12:\"delete-14478\";i:15716;s:12:\"delete-14479\";i:15717;s:12:\"delete-14480\";i:15718;s:12:\"delete-14481\";i:15719;s:12:\"delete-14482\";i:15720;s:12:\"delete-14483\";i:15721;s:12:\"delete-14484\";i:15722;s:12:\"delete-14485\";i:15723;s:12:\"delete-14486\";i:15724;s:12:\"delete-14487\";i:15725;s:12:\"delete-14488\";i:15726;s:12:\"delete-14489\";i:15727;s:12:\"delete-14490\";i:15728;s:12:\"delete-14491\";i:15729;s:12:\"delete-14492\";i:15730;s:12:\"delete-14493\";i:15731;s:12:\"delete-14494\";i:15732;s:12:\"delete-14495\";i:15733;s:12:\"delete-14496\";i:15734;s:12:\"delete-14497\";i:15735;s:12:\"delete-14498\";i:15736;s:12:\"delete-14499\";i:15737;s:12:\"delete-14500\";i:15738;s:12:\"delete-14501\";i:15739;s:12:\"delete-14502\";i:15740;s:12:\"delete-14503\";i:15741;s:12:\"delete-14504\";i:15742;s:12:\"delete-14505\";i:15743;s:12:\"delete-14506\";i:15744;s:12:\"delete-14507\";i:15745;s:12:\"delete-14508\";i:15746;s:12:\"delete-14509\";i:15747;s:12:\"delete-14510\";i:15748;s:12:\"delete-14511\";i:15749;s:12:\"delete-14512\";i:15750;s:12:\"delete-14513\";i:15751;s:12:\"delete-14514\";i:15752;s:12:\"delete-14515\";i:15753;s:12:\"delete-14516\";i:15754;s:12:\"delete-14517\";i:15755;s:12:\"delete-14518\";i:15756;s:12:\"delete-14519\";i:15757;s:12:\"delete-14520\";i:15758;s:12:\"delete-14521\";i:15759;s:12:\"delete-14522\";i:15760;s:12:\"delete-14523\";i:15761;s:12:\"delete-14524\";i:15762;s:12:\"delete-14525\";i:15763;s:12:\"delete-14526\";i:15764;s:12:\"delete-14527\";i:15765;s:12:\"delete-14528\";i:15766;s:12:\"delete-14529\";i:15767;s:12:\"delete-14530\";i:15768;s:12:\"delete-14531\";i:15769;s:12:\"delete-14532\";i:15770;s:12:\"delete-14533\";i:15771;s:12:\"delete-14534\";i:15772;s:12:\"delete-14535\";i:15773;s:12:\"delete-14536\";i:15774;s:12:\"delete-14537\";i:15775;s:12:\"delete-14538\";i:15776;s:12:\"delete-14539\";i:15777;s:12:\"delete-14540\";i:15778;s:12:\"delete-14541\";i:15779;s:12:\"delete-14542\";i:15780;s:12:\"delete-14543\";i:15781;s:12:\"delete-14544\";i:15782;s:12:\"delete-14545\";i:15783;s:12:\"delete-14546\";i:15784;s:12:\"delete-14547\";i:15785;s:12:\"delete-14548\";i:15786;s:12:\"delete-14549\";i:15787;s:12:\"delete-14550\";i:15788;s:12:\"delete-14551\";i:15789;s:12:\"delete-14552\";i:15790;s:12:\"delete-14553\";i:15791;s:12:\"delete-14554\";i:15792;s:12:\"delete-14555\";i:15793;s:12:\"delete-14556\";i:15794;s:12:\"delete-14557\";i:15795;s:12:\"delete-14558\";i:15796;s:12:\"delete-14559\";i:15797;s:12:\"delete-14560\";i:15798;s:12:\"delete-14561\";i:15799;s:12:\"delete-14562\";i:15800;s:12:\"delete-14563\";i:15801;s:12:\"delete-14564\";i:15802;s:12:\"delete-14565\";i:15803;s:12:\"delete-14566\";i:15804;s:12:\"delete-14567\";i:15805;s:12:\"delete-14568\";i:15806;s:12:\"delete-14569\";i:15807;s:12:\"delete-14570\";i:15808;s:12:\"delete-14571\";i:15809;s:12:\"delete-14572\";i:15810;s:12:\"delete-14573\";i:15811;s:12:\"delete-14574\";i:15812;s:12:\"delete-14575\";i:15813;s:12:\"delete-14576\";i:15814;s:12:\"delete-14577\";i:15815;s:12:\"delete-14578\";i:15816;s:12:\"delete-14579\";i:15817;s:12:\"delete-14580\";i:15818;s:12:\"delete-14581\";i:15819;s:12:\"delete-14582\";i:15820;s:12:\"delete-14583\";i:15821;s:12:\"delete-14584\";i:15822;s:12:\"delete-14585\";i:15823;s:12:\"delete-14586\";i:15824;s:12:\"delete-14587\";i:15825;s:12:\"delete-14588\";i:15826;s:12:\"delete-14589\";i:15827;s:12:\"delete-14590\";i:15828;s:12:\"delete-14591\";i:15829;s:12:\"delete-14592\";i:15830;s:12:\"delete-14593\";i:15831;s:12:\"delete-14594\";i:15832;s:12:\"delete-14595\";i:15833;s:12:\"delete-14596\";i:15834;s:12:\"delete-14597\";i:15835;s:12:\"delete-14598\";i:15836;s:12:\"delete-14599\";i:15837;s:12:\"delete-14600\";i:15838;s:12:\"delete-14601\";i:15839;s:12:\"delete-14602\";i:15840;s:12:\"delete-14603\";i:15841;s:12:\"delete-14604\";i:15842;s:12:\"delete-14605\";i:15843;s:12:\"delete-14606\";i:15844;s:12:\"delete-14607\";i:15845;s:12:\"delete-14608\";i:15846;s:12:\"delete-14609\";i:15847;s:12:\"delete-14610\";i:15848;s:12:\"delete-14611\";i:15849;s:12:\"delete-14612\";i:15850;s:12:\"delete-14613\";i:15851;s:12:\"delete-14614\";i:15852;s:12:\"delete-14615\";i:15853;s:12:\"delete-14616\";i:15854;s:12:\"delete-14617\";i:15855;s:12:\"delete-14618\";i:15856;s:12:\"delete-14619\";i:15857;s:12:\"delete-14620\";i:15858;s:12:\"delete-14621\";i:15859;s:12:\"delete-14622\";i:15860;s:12:\"delete-14623\";i:15861;s:12:\"delete-14624\";i:15862;s:12:\"delete-14625\";i:15863;s:12:\"delete-14626\";i:15864;s:12:\"delete-14627\";i:15865;s:12:\"delete-14628\";i:15866;s:12:\"delete-14629\";i:15867;s:12:\"delete-14630\";i:15868;s:12:\"delete-14631\";i:15869;s:12:\"delete-14632\";i:15870;s:12:\"delete-14633\";i:15871;s:12:\"delete-14634\";i:15872;s:12:\"delete-14635\";i:15873;s:12:\"delete-14637\";i:15874;s:12:\"delete-14636\";i:15875;s:12:\"delete-14638\";i:15876;s:12:\"delete-14639\";i:15877;s:12:\"delete-14640\";i:15878;s:12:\"delete-14641\";i:15879;s:12:\"delete-14642\";i:15880;s:12:\"delete-14643\";i:15881;s:12:\"delete-14644\";i:15882;s:12:\"delete-14645\";i:15883;s:12:\"delete-14646\";i:15884;s:12:\"delete-14647\";i:15885;s:12:\"delete-14648\";i:15886;s:12:\"delete-14649\";i:15887;s:12:\"delete-14650\";i:15888;s:12:\"delete-14651\";i:15889;s:12:\"delete-14652\";i:15890;s:12:\"delete-14653\";i:15891;s:12:\"delete-14654\";i:15892;s:12:\"delete-14655\";i:15893;s:12:\"delete-14656\";i:15894;s:12:\"delete-14657\";i:15895;s:12:\"delete-14658\";i:15896;s:12:\"delete-14659\";i:15897;s:12:\"delete-14660\";i:15898;s:12:\"delete-14661\";i:15899;s:12:\"delete-14663\";i:15900;s:12:\"delete-14662\";i:15901;s:12:\"delete-14664\";i:15902;s:12:\"delete-14665\";i:15903;s:12:\"delete-14667\";i:15904;s:12:\"delete-14666\";i:15905;s:12:\"delete-14668\";i:15906;s:12:\"delete-14669\";i:15907;s:12:\"delete-14670\";i:15908;s:12:\"delete-14671\";i:15909;s:12:\"delete-14672\";i:15910;s:12:\"delete-14673\";i:15911;s:12:\"delete-14675\";i:15912;s:12:\"delete-14674\";i:15913;s:12:\"delete-14676\";i:15914;s:12:\"delete-14677\";i:15915;s:12:\"delete-14678\";i:15916;s:12:\"delete-14679\";i:15917;s:12:\"delete-14680\";i:15918;s:12:\"delete-14681\";i:15919;s:12:\"delete-14682\";i:15920;s:12:\"delete-14683\";i:15921;s:12:\"delete-14684\";i:15922;s:12:\"delete-14685\";i:15923;s:12:\"delete-14686\";i:15924;s:12:\"delete-14687\";i:15925;s:12:\"delete-14688\";i:15926;s:12:\"delete-14690\";i:15927;s:12:\"delete-14689\";i:15928;s:12:\"delete-14691\";i:15929;s:12:\"delete-14692\";i:15930;s:12:\"delete-14693\";i:15931;s:12:\"delete-14694\";i:15932;s:12:\"delete-14695\";i:15933;s:12:\"delete-14696\";i:15934;s:12:\"delete-14697\";i:15935;s:12:\"delete-14698\";i:15936;s:12:\"delete-14699\";i:15937;s:12:\"delete-14700\";i:15938;s:12:\"delete-14701\";i:15939;s:12:\"delete-14702\";i:15940;s:12:\"delete-14703\";i:15941;s:12:\"delete-14704\";i:15942;s:12:\"delete-14705\";i:15943;s:12:\"delete-14706\";i:15944;s:12:\"delete-14707\";i:15945;s:12:\"delete-14708\";i:15946;s:12:\"delete-14709\";i:15947;s:12:\"delete-14710\";i:15948;s:12:\"delete-14711\";i:15949;s:12:\"delete-14712\";i:15950;s:12:\"delete-14713\";i:15951;s:12:\"delete-14714\";i:15952;s:12:\"delete-14715\";i:15953;s:12:\"delete-14716\";i:15954;s:12:\"delete-14717\";i:15955;s:12:\"delete-14718\";i:15956;s:12:\"delete-14719\";i:15957;s:12:\"delete-14720\";i:15958;s:12:\"delete-14721\";i:15959;s:12:\"delete-14722\";i:15960;s:12:\"delete-14723\";i:15961;s:12:\"delete-14724\";i:15962;s:12:\"delete-14725\";i:15963;s:12:\"delete-14726\";i:15964;s:12:\"delete-14727\";i:15965;s:12:\"delete-14728\";i:15966;s:12:\"delete-14729\";i:15967;s:12:\"delete-14730\";i:15968;s:12:\"delete-14731\";i:15969;s:12:\"delete-14732\";i:15970;s:12:\"delete-14733\";i:15971;s:12:\"delete-14734\";i:15972;s:12:\"delete-14735\";i:15973;s:12:\"delete-14736\";i:15974;s:12:\"delete-14737\";i:15975;s:12:\"delete-14738\";i:15976;s:12:\"delete-14739\";i:15977;s:12:\"delete-14740\";i:15978;s:12:\"delete-14741\";i:15979;s:12:\"delete-14742\";i:15980;s:12:\"delete-14743\";i:15981;s:12:\"delete-14744\";i:15982;s:12:\"delete-14745\";i:15983;s:12:\"delete-14746\";i:15984;s:12:\"delete-14747\";i:15985;s:12:\"delete-14748\";i:15986;s:12:\"delete-14749\";i:15987;s:12:\"delete-14750\";i:15988;s:12:\"delete-14751\";i:15989;s:12:\"delete-14752\";i:15990;s:12:\"delete-14753\";i:15991;s:12:\"delete-14754\";i:15992;s:12:\"delete-14755\";i:15993;s:12:\"delete-14756\";i:15994;s:12:\"delete-14757\";i:15995;s:12:\"delete-14758\";i:15996;s:12:\"delete-14759\";i:15997;s:12:\"delete-14760\";i:15998;s:12:\"delete-14761\";i:15999;s:12:\"delete-14762\";i:16000;s:12:\"delete-14763\";i:16001;s:12:\"delete-14764\";i:16002;s:12:\"delete-14765\";i:16003;s:12:\"delete-14766\";i:16004;s:12:\"delete-14767\";i:16005;s:12:\"delete-14768\";i:16006;s:12:\"delete-14769\";i:16007;s:12:\"delete-14770\";i:16008;s:12:\"delete-14771\";i:16009;s:12:\"delete-14772\";i:16010;s:12:\"delete-14773\";i:16011;s:12:\"delete-14774\";i:16012;s:12:\"delete-14775\";i:16013;s:12:\"delete-14776\";i:16014;s:12:\"delete-14777\";i:16015;s:12:\"delete-14778\";i:16016;s:12:\"delete-14779\";i:16017;s:12:\"delete-14780\";i:16018;s:12:\"delete-14781\";i:16019;s:12:\"delete-14782\";i:16020;s:12:\"delete-14783\";i:16021;s:12:\"delete-14784\";i:16022;s:12:\"delete-14785\";i:16023;s:12:\"delete-14786\";i:16024;s:12:\"delete-14787\";i:16025;s:12:\"delete-14788\";i:16026;s:12:\"delete-14789\";i:16027;s:12:\"delete-14790\";i:16028;s:12:\"delete-14791\";i:16029;s:12:\"delete-14792\";i:16030;s:12:\"delete-14793\";i:16031;s:12:\"delete-14794\";i:16032;s:12:\"delete-14795\";i:16033;s:12:\"delete-14796\";i:16034;s:12:\"delete-14797\";i:16035;s:12:\"delete-14798\";i:16036;s:12:\"delete-14799\";i:16037;s:12:\"delete-14800\";i:16038;s:12:\"delete-14801\";i:16039;s:12:\"delete-14802\";i:16040;s:12:\"delete-14803\";i:16041;s:12:\"delete-14804\";i:16042;s:12:\"delete-14805\";i:16043;s:12:\"delete-14806\";i:16044;s:12:\"delete-14807\";i:16045;s:12:\"delete-14808\";i:16046;s:12:\"delete-14809\";i:16047;s:12:\"delete-14810\";i:16048;s:12:\"delete-14811\";i:16049;s:12:\"delete-14812\";i:16050;s:12:\"delete-14813\";i:16051;s:12:\"delete-14814\";i:16052;s:12:\"delete-14815\";i:16053;s:12:\"delete-14816\";i:16054;s:12:\"delete-14817\";i:16055;s:12:\"delete-14818\";i:16056;s:12:\"delete-14819\";i:16057;s:12:\"delete-14820\";i:16058;s:12:\"delete-14821\";i:16059;s:12:\"delete-14822\";i:16060;s:12:\"delete-14823\";i:16061;s:12:\"delete-14824\";i:16062;s:12:\"delete-14825\";i:16063;s:12:\"delete-14826\";i:16064;s:12:\"delete-14827\";i:16065;s:12:\"delete-14828\";i:16066;s:12:\"delete-14829\";i:16067;s:12:\"delete-14830\";i:16068;s:12:\"delete-14831\";i:16069;s:12:\"delete-14832\";i:16070;s:12:\"delete-14833\";i:16071;s:12:\"delete-14834\";i:16072;s:12:\"delete-14835\";i:16073;s:12:\"delete-14836\";i:16074;s:12:\"delete-14837\";i:16075;s:12:\"delete-14839\";i:16076;s:12:\"delete-14838\";i:16077;s:12:\"delete-14840\";i:16078;s:12:\"delete-14841\";i:16079;s:12:\"delete-14842\";i:16080;s:12:\"delete-14843\";i:16081;s:12:\"delete-14844\";i:16082;s:12:\"delete-14845\";i:16083;s:12:\"delete-14846\";i:16084;s:12:\"delete-14847\";i:16085;s:12:\"delete-14848\";i:16086;s:12:\"delete-14849\";i:16087;s:12:\"delete-14850\";i:16088;s:12:\"delete-14851\";i:16089;s:12:\"delete-14852\";i:16090;s:12:\"delete-14853\";i:16091;s:12:\"delete-14854\";i:16092;s:12:\"delete-14855\";i:16093;s:12:\"delete-14856\";i:16094;s:12:\"delete-14857\";i:16095;s:12:\"delete-14858\";i:16096;s:12:\"delete-14859\";i:16097;s:12:\"delete-14860\";i:16098;s:12:\"delete-14861\";i:16099;s:12:\"delete-14862\";i:16100;s:12:\"delete-14863\";i:16101;s:12:\"delete-14864\";i:16102;s:12:\"delete-14865\";i:16103;s:12:\"delete-14866\";i:16104;s:12:\"delete-14867\";i:16105;s:12:\"delete-14868\";i:16106;s:12:\"delete-14869\";i:16107;s:12:\"delete-14870\";i:16108;s:12:\"delete-14871\";i:16109;s:12:\"delete-14872\";i:16110;s:12:\"delete-14873\";i:16111;s:12:\"delete-14874\";i:16112;s:12:\"delete-14875\";i:16113;s:12:\"delete-14876\";i:16114;s:12:\"delete-14877\";i:16115;s:12:\"delete-14878\";i:16116;s:12:\"delete-14879\";i:16117;s:12:\"delete-14880\";i:16118;s:12:\"delete-14881\";i:16119;s:12:\"delete-14882\";i:16120;s:12:\"delete-14883\";i:16121;s:12:\"delete-14884\";i:16122;s:12:\"delete-14885\";i:16123;s:12:\"delete-14886\";i:16124;s:12:\"delete-14887\";i:16125;s:12:\"delete-14888\";i:16126;s:12:\"delete-14889\";i:16127;s:12:\"delete-14891\";i:16128;s:12:\"delete-14890\";i:16129;s:12:\"delete-14892\";i:16130;s:12:\"delete-14893\";i:16131;s:12:\"delete-14894\";i:16132;s:12:\"delete-14895\";i:16133;s:12:\"delete-14897\";i:16134;s:12:\"delete-14896\";i:16135;s:12:\"delete-14898\";i:16136;s:12:\"delete-14899\";i:16137;s:12:\"delete-14900\";i:16138;s:12:\"delete-14901\";i:16139;s:12:\"delete-14902\";i:16140;s:12:\"delete-14903\";i:16141;s:12:\"delete-14904\";i:16142;s:12:\"delete-14905\";i:16143;s:12:\"delete-14906\";i:16144;s:12:\"delete-14907\";i:16145;s:12:\"delete-14908\";i:16146;s:12:\"delete-14909\";i:16147;s:12:\"delete-14910\";i:16148;s:12:\"delete-14911\";i:16149;s:12:\"delete-14912\";i:16150;s:12:\"delete-14913\";i:16151;s:12:\"delete-14914\";i:16152;s:12:\"delete-14915\";i:16153;s:12:\"delete-14916\";i:16154;s:12:\"delete-14917\";i:16155;s:12:\"delete-14918\";i:16156;s:12:\"delete-14919\";i:16157;s:12:\"delete-14920\";i:16158;s:12:\"delete-14921\";i:16159;s:12:\"delete-14922\";i:16160;s:12:\"delete-14923\";i:16161;s:12:\"delete-14924\";i:16162;s:12:\"delete-14925\";i:16163;s:12:\"delete-14926\";i:16164;s:12:\"delete-14927\";i:16165;s:12:\"delete-14928\";i:16166;s:12:\"delete-14929\";i:16167;s:12:\"delete-14930\";i:16168;s:12:\"delete-14931\";i:16169;s:12:\"delete-14932\";i:16170;s:12:\"delete-14933\";i:16171;s:12:\"delete-14934\";i:16172;s:12:\"delete-14935\";i:16173;s:12:\"delete-14936\";i:16174;s:12:\"delete-14937\";i:16175;s:12:\"delete-14938\";i:16176;s:12:\"delete-14939\";i:16177;s:12:\"delete-14940\";i:16178;s:12:\"delete-14941\";i:16179;s:12:\"delete-14942\";i:16180;s:12:\"delete-14943\";i:16181;s:12:\"delete-14944\";i:16182;s:12:\"delete-14945\";i:16183;s:12:\"delete-14946\";i:16184;s:12:\"delete-14948\";i:16185;s:12:\"delete-14947\";i:16186;s:12:\"delete-14949\";i:16187;s:12:\"delete-14950\";i:16188;s:12:\"delete-14951\";i:16189;s:12:\"delete-14953\";i:16190;s:12:\"delete-14952\";i:16191;s:12:\"delete-14954\";i:16192;s:12:\"delete-14955\";i:16193;s:12:\"delete-14956\";i:16194;s:12:\"delete-14957\";i:16195;s:12:\"delete-14958\";i:16196;s:12:\"delete-14959\";i:16197;s:12:\"delete-14960\";i:16198;s:12:\"delete-14961\";i:16199;s:12:\"delete-14963\";i:16200;s:12:\"delete-14962\";i:16201;s:12:\"delete-14964\";i:16202;s:12:\"delete-14965\";i:16203;s:12:\"delete-14967\";i:16204;s:12:\"delete-14966\";i:16205;s:12:\"delete-14968\";i:16206;s:12:\"delete-14969\";i:16207;s:12:\"delete-14970\";i:16208;s:12:\"delete-14971\";i:16209;s:12:\"delete-14972\";i:16210;s:12:\"delete-14973\";i:16211;s:12:\"delete-14974\";i:16212;s:12:\"delete-14975\";i:16213;s:12:\"delete-14976\";i:16214;s:12:\"delete-14977\";i:16215;s:12:\"delete-14978\";i:16216;s:12:\"delete-14979\";i:16217;s:12:\"delete-14980\";i:16218;s:12:\"delete-14982\";i:16219;s:12:\"delete-14981\";i:16220;s:12:\"delete-14983\";i:16221;s:12:\"delete-14984\";i:16222;s:12:\"delete-14985\";i:16223;s:12:\"delete-14986\";i:16224;s:12:\"delete-14987\";i:16225;s:12:\"delete-14988\";i:16226;s:12:\"delete-14989\";i:16227;s:12:\"delete-14990\";i:16228;s:12:\"delete-14991\";i:16229;s:12:\"delete-14992\";i:16230;s:12:\"delete-14993\";i:16231;s:12:\"delete-14994\";i:16232;s:12:\"delete-14995\";i:16233;s:12:\"delete-14996\";i:16234;s:12:\"delete-14997\";i:16235;s:12:\"delete-14999\";i:16236;s:12:\"delete-14998\";i:16237;s:12:\"delete-15000\";i:16238;s:12:\"delete-15001\";i:16239;s:12:\"delete-15002\";i:16240;s:12:\"delete-15003\";i:16241;s:12:\"delete-15004\";i:16242;s:12:\"delete-15005\";i:16243;s:12:\"delete-15006\";i:16244;s:12:\"delete-15007\";i:16245;s:12:\"delete-15008\";i:16246;s:12:\"delete-15009\";i:16247;s:12:\"delete-15010\";i:16248;s:12:\"delete-15011\";i:16249;s:12:\"delete-15012\";i:16250;s:12:\"delete-15013\";i:16251;s:12:\"delete-15014\";i:16252;s:12:\"delete-15015\";i:16253;s:12:\"delete-15016\";i:16254;s:12:\"delete-15017\";i:16255;s:12:\"delete-15018\";i:16256;s:12:\"delete-15019\";i:16257;s:12:\"delete-15020\";i:16258;s:12:\"delete-15021\";i:16259;s:12:\"delete-15023\";i:16260;s:12:\"delete-15022\";i:16261;s:12:\"delete-15024\";i:16262;s:12:\"delete-15025\";i:16263;s:12:\"delete-15026\";i:16264;s:12:\"delete-15027\";i:16265;s:12:\"delete-15028\";i:16266;s:12:\"delete-15029\";i:16267;s:12:\"delete-15030\";i:16268;s:12:\"delete-15031\";i:16269;s:12:\"delete-15032\";i:16270;s:12:\"delete-15033\";i:16271;s:12:\"delete-15034\";i:16272;s:12:\"delete-15035\";i:16273;s:12:\"delete-15037\";i:16274;s:12:\"delete-15036\";i:16275;s:12:\"delete-15038\";i:16276;s:12:\"delete-15039\";i:16277;s:12:\"delete-15040\";i:16278;s:12:\"delete-15041\";i:16279;s:12:\"delete-15042\";i:16280;s:12:\"delete-15043\";i:16281;s:12:\"delete-15044\";i:16282;s:12:\"delete-15045\";i:16283;s:12:\"delete-15046\";i:16284;s:12:\"delete-15047\";i:16285;s:12:\"delete-15048\";i:16286;s:12:\"delete-15049\";i:16287;s:12:\"delete-15050\";i:16288;s:12:\"delete-15051\";i:16289;s:12:\"delete-15052\";i:16290;s:12:\"delete-15053\";i:16291;s:12:\"delete-15054\";i:16292;s:12:\"delete-15055\";i:16293;s:12:\"delete-15056\";i:16294;s:12:\"delete-15057\";i:16295;s:12:\"delete-15058\";i:16296;s:12:\"delete-15059\";i:16297;s:12:\"delete-15060\";i:16298;s:12:\"delete-15061\";i:16299;s:12:\"delete-15062\";i:16300;s:12:\"delete-15063\";i:16301;s:12:\"delete-15064\";i:16302;s:12:\"delete-15065\";i:16303;s:12:\"delete-15066\";i:16304;s:12:\"delete-15067\";i:16305;s:12:\"delete-15068\";i:16306;s:12:\"delete-15069\";i:16307;s:12:\"delete-15070\";i:16308;s:12:\"delete-15071\";i:16309;s:12:\"delete-15072\";i:16310;s:12:\"delete-15073\";i:16311;s:12:\"delete-15075\";i:16312;s:12:\"delete-15074\";i:16313;s:12:\"delete-15076\";i:16314;s:12:\"delete-15077\";i:16315;s:12:\"delete-15078\";i:16316;s:12:\"delete-15079\";i:16317;s:12:\"delete-15080\";i:16318;s:12:\"delete-15081\";i:16319;s:12:\"delete-15082\";i:16320;s:12:\"delete-15083\";i:16321;s:12:\"delete-15084\";i:16322;s:12:\"delete-15085\";i:16323;s:12:\"delete-15086\";i:16324;s:12:\"delete-15087\";i:16325;s:12:\"delete-15088\";i:16326;s:12:\"delete-15089\";i:16327;s:12:\"delete-15090\";i:16328;s:12:\"delete-15091\";i:16329;s:12:\"delete-15092\";i:16330;s:12:\"delete-15093\";i:16331;s:12:\"delete-15094\";i:16332;s:12:\"delete-15095\";i:16333;s:12:\"delete-15096\";i:16334;s:12:\"delete-15097\";i:16335;s:12:\"delete-15098\";i:16336;s:12:\"delete-15099\";i:16337;s:12:\"delete-15100\";i:16338;s:12:\"delete-15101\";i:16339;s:12:\"delete-15102\";i:16340;s:12:\"delete-15103\";i:16341;s:12:\"delete-15104\";i:16342;s:12:\"delete-15105\";i:16343;s:12:\"delete-15106\";i:16344;s:12:\"delete-15107\";i:16345;s:12:\"delete-15108\";i:16346;s:12:\"delete-15109\";i:16347;s:12:\"delete-15110\";i:16348;s:12:\"delete-15111\";i:16349;s:12:\"delete-15112\";i:16350;s:12:\"delete-15113\";i:16351;s:12:\"delete-15114\";i:16352;s:12:\"delete-15115\";i:16353;s:12:\"delete-15116\";i:16354;s:12:\"delete-15117\";i:16355;s:12:\"delete-15118\";i:16356;s:12:\"delete-15119\";i:16357;s:12:\"delete-15120\";i:16358;s:12:\"delete-15121\";i:16359;s:12:\"delete-15122\";i:16360;s:12:\"delete-15123\";i:16361;s:12:\"delete-15124\";i:16362;s:12:\"delete-15125\";i:16363;s:12:\"delete-15126\";i:16364;s:12:\"delete-15127\";i:16365;s:12:\"delete-15128\";i:16366;s:12:\"delete-15129\";i:16367;s:12:\"delete-15130\";i:16368;s:12:\"delete-15131\";i:16369;s:12:\"delete-15132\";i:16370;s:12:\"delete-15133\";i:16371;s:12:\"delete-15134\";i:16372;s:12:\"delete-15135\";i:16373;s:12:\"delete-15137\";i:16374;s:12:\"delete-15136\";i:16375;s:12:\"delete-15138\";i:16376;s:12:\"delete-15139\";i:16377;s:12:\"delete-15140\";i:16378;s:12:\"delete-15141\";i:16379;s:12:\"delete-15142\";i:16380;s:12:\"delete-15143\";i:16381;s:12:\"delete-15144\";i:16382;s:12:\"delete-15145\";i:16383;s:12:\"delete-15146\";i:16384;s:12:\"delete-15147\";i:16385;s:12:\"delete-15148\";i:16386;s:12:\"delete-15149\";i:16387;s:12:\"delete-15150\";i:16388;s:12:\"delete-15151\";i:16389;s:12:\"delete-15152\";i:16390;s:12:\"delete-15153\";i:16391;s:12:\"delete-15154\";i:16392;s:12:\"delete-15155\";i:16393;s:12:\"delete-15156\";i:16394;s:12:\"delete-15157\";i:16395;s:12:\"delete-15158\";i:16396;s:12:\"delete-15159\";i:16397;s:12:\"delete-15160\";i:16398;s:12:\"delete-15161\";i:16399;s:12:\"delete-15162\";i:16400;s:12:\"delete-15163\";i:16401;s:12:\"delete-15164\";i:16402;s:12:\"delete-15165\";i:16403;s:12:\"delete-15166\";i:16404;s:12:\"delete-15167\";i:16405;s:12:\"delete-15168\";i:16406;s:12:\"delete-15169\";i:16407;s:12:\"delete-15170\";i:16408;s:12:\"delete-15171\";i:16409;s:12:\"delete-15172\";i:16410;s:12:\"delete-15173\";i:16411;s:12:\"delete-15174\";i:16412;s:12:\"delete-15175\";i:16413;s:12:\"delete-15176\";i:16414;s:12:\"delete-15177\";i:16415;s:12:\"delete-15178\";i:16416;s:12:\"delete-15179\";i:16417;s:12:\"delete-15180\";i:16418;s:12:\"delete-15181\";i:16419;s:12:\"delete-15182\";i:16420;s:12:\"delete-15183\";i:16421;s:12:\"delete-15184\";i:16422;s:12:\"delete-15185\";i:16423;s:12:\"delete-15186\";i:16424;s:12:\"delete-15187\";i:16425;s:12:\"delete-15188\";i:16426;s:12:\"delete-15189\";i:16427;s:12:\"delete-15190\";i:16428;s:12:\"delete-15191\";i:16429;s:12:\"delete-15192\";i:16430;s:12:\"delete-15193\";i:16431;s:12:\"delete-15194\";i:16432;s:12:\"delete-15195\";i:16433;s:12:\"delete-15196\";i:16434;s:12:\"delete-15197\";i:16435;s:12:\"delete-15198\";i:16436;s:12:\"delete-15199\";i:16437;s:12:\"delete-15201\";i:16438;s:12:\"delete-15200\";i:16439;s:12:\"delete-15202\";i:16440;s:12:\"delete-15203\";i:16441;s:12:\"delete-15204\";i:16442;s:12:\"delete-15205\";i:16443;s:12:\"delete-15207\";i:16444;s:12:\"delete-15206\";i:16445;s:12:\"delete-15208\";i:16446;s:12:\"delete-15209\";i:16447;s:12:\"delete-15210\";i:16448;s:12:\"delete-15211\";i:16449;s:12:\"delete-15212\";i:16450;s:12:\"delete-15213\";i:16451;s:12:\"delete-15214\";i:16452;s:12:\"delete-15215\";i:16453;s:12:\"delete-15216\";i:16454;s:12:\"delete-15217\";i:16455;s:12:\"delete-15218\";i:16456;s:12:\"delete-15219\";i:16457;s:12:\"delete-15220\";i:16458;s:12:\"delete-15221\";i:16459;s:12:\"delete-15222\";i:16460;s:12:\"delete-15223\";i:16461;s:12:\"delete-15224\";i:16462;s:12:\"delete-15225\";i:16463;s:12:\"delete-15226\";i:16464;s:12:\"delete-15227\";i:16465;s:12:\"delete-15228\";i:16466;s:12:\"delete-15229\";i:16467;s:12:\"delete-15230\";i:16468;s:12:\"delete-15231\";i:16469;s:12:\"delete-15232\";i:16470;s:12:\"delete-15233\";i:16471;s:12:\"delete-15234\";i:16472;s:12:\"delete-15235\";i:16473;s:12:\"delete-15236\";i:16474;s:12:\"delete-15237\";i:16475;s:12:\"delete-15239\";i:16476;s:12:\"delete-15238\";i:16477;s:12:\"delete-15240\";i:16478;s:12:\"delete-15241\";i:16479;s:12:\"delete-15242\";i:16480;s:12:\"delete-15243\";i:16481;s:12:\"delete-15244\";i:16482;s:12:\"delete-15245\";i:16483;s:12:\"delete-15246\";i:16484;s:12:\"delete-15247\";i:16485;s:12:\"delete-15248\";i:16486;s:12:\"delete-15249\";i:16487;s:12:\"delete-15250\";i:16488;s:12:\"delete-15251\";i:16489;s:12:\"delete-15252\";i:16490;s:12:\"delete-15253\";i:16491;s:12:\"delete-15254\";i:16492;s:12:\"delete-15255\";i:16493;s:12:\"delete-15256\";i:16494;s:12:\"delete-15257\";i:16495;s:12:\"delete-15258\";i:16496;s:12:\"delete-15259\";i:16497;s:12:\"delete-15260\";i:16498;s:12:\"delete-15261\";i:16499;s:12:\"delete-15262\";i:16500;s:12:\"delete-15263\";i:16501;s:12:\"delete-15264\";i:16502;s:12:\"delete-15265\";i:16503;s:12:\"delete-15266\";i:16504;s:12:\"delete-15267\";i:16505;s:12:\"delete-15268\";i:16506;s:12:\"delete-15269\";i:16507;s:12:\"delete-15270\";i:16508;s:12:\"delete-15271\";i:16509;s:12:\"delete-15272\";i:16510;s:12:\"delete-15273\";i:16511;s:12:\"delete-15274\";i:16512;s:12:\"delete-15275\";i:16513;s:12:\"delete-15276\";i:16514;s:12:\"delete-15277\";i:16515;s:12:\"delete-15278\";i:16516;s:12:\"delete-15279\";i:16517;s:12:\"delete-15280\";i:16518;s:12:\"delete-15281\";i:16519;s:12:\"delete-15282\";i:16520;s:12:\"delete-15283\";i:16521;s:12:\"delete-15284\";i:16522;s:12:\"delete-15285\";i:16523;s:12:\"delete-15286\";i:16524;s:12:\"delete-15287\";i:16525;s:12:\"delete-15288\";i:16526;s:12:\"delete-15289\";i:16527;s:12:\"delete-15290\";i:16528;s:12:\"delete-15291\";i:16529;s:12:\"delete-15292\";i:16530;s:12:\"delete-15293\";i:16531;s:12:\"delete-15294\";i:16532;s:12:\"delete-15295\";i:16533;s:12:\"delete-15296\";i:16534;s:12:\"delete-15297\";i:16535;s:12:\"delete-15298\";i:16536;s:12:\"delete-15299\";i:16537;s:12:\"delete-15300\";i:16538;s:12:\"delete-15301\";i:16539;s:12:\"delete-15302\";i:16540;s:12:\"delete-15303\";i:16541;s:12:\"delete-15304\";i:16542;s:12:\"delete-15305\";i:16543;s:12:\"delete-15306\";i:16544;s:12:\"delete-15307\";i:16545;s:12:\"delete-15308\";i:16546;s:12:\"delete-15309\";i:16547;s:12:\"delete-15310\";i:16548;s:12:\"delete-15311\";i:16549;s:12:\"delete-15312\";i:16550;s:12:\"delete-15313\";i:16551;s:12:\"delete-15314\";i:16552;s:12:\"delete-15315\";i:16553;s:12:\"delete-15316\";i:16554;s:12:\"delete-15317\";i:16555;s:12:\"delete-15318\";i:16556;s:12:\"delete-15319\";i:16557;s:12:\"delete-15320\";i:16558;s:12:\"delete-15321\";i:16559;s:12:\"delete-15322\";i:16560;s:12:\"delete-15323\";i:16561;s:12:\"delete-15324\";i:16562;s:12:\"delete-15325\";i:16563;s:12:\"delete-15326\";i:16564;s:12:\"delete-15327\";i:16565;s:12:\"delete-15328\";i:16566;s:12:\"delete-15329\";i:16567;s:12:\"delete-15330\";i:16568;s:12:\"delete-15331\";i:16569;s:12:\"delete-15332\";i:16570;s:12:\"delete-15333\";i:16571;s:12:\"delete-15334\";i:16572;s:12:\"delete-15335\";i:16573;s:12:\"delete-15336\";i:16574;s:12:\"delete-15337\";i:16575;s:12:\"delete-15338\";i:16576;s:12:\"delete-15339\";i:16577;s:12:\"delete-15340\";i:16578;s:12:\"delete-15341\";i:16579;s:12:\"delete-15342\";i:16580;s:12:\"delete-15343\";i:16581;s:12:\"delete-15344\";i:16582;s:12:\"delete-15345\";i:16583;s:12:\"delete-15346\";i:16584;s:12:\"delete-15347\";i:16585;s:12:\"delete-15348\";i:16586;s:12:\"delete-15349\";i:16587;s:12:\"delete-15350\";i:16588;s:12:\"delete-15351\";i:16589;s:12:\"delete-15352\";i:16590;s:12:\"delete-15353\";i:16591;s:12:\"delete-15354\";i:16592;s:12:\"delete-15355\";i:16593;s:12:\"delete-15356\";i:16594;s:12:\"delete-15357\";i:16595;s:12:\"delete-15358\";i:16596;s:12:\"delete-15359\";i:16597;s:12:\"delete-15360\";i:16598;s:12:\"delete-15361\";i:16599;s:12:\"delete-15362\";i:16600;s:12:\"delete-15363\";i:16601;s:12:\"delete-15364\";i:16602;s:12:\"delete-15365\";i:16603;s:12:\"delete-15366\";i:16604;s:12:\"delete-15367\";i:16605;s:12:\"delete-15368\";i:16606;s:12:\"delete-15369\";i:16607;s:12:\"delete-15370\";i:16608;s:12:\"delete-15371\";i:16609;s:12:\"delete-15372\";i:16610;s:12:\"delete-15373\";i:16611;s:12:\"delete-15374\";i:16612;s:12:\"delete-15375\";i:16613;s:12:\"delete-15376\";i:16614;s:12:\"delete-15377\";i:16615;s:12:\"delete-15378\";i:16616;s:12:\"delete-15379\";i:16617;s:12:\"delete-15380\";i:16618;s:12:\"delete-15381\";i:16619;s:12:\"delete-15382\";i:16620;s:12:\"delete-15383\";i:16621;s:12:\"delete-15384\";i:16622;s:12:\"delete-15385\";i:16623;s:12:\"delete-15386\";i:16624;s:12:\"delete-15387\";i:16625;s:12:\"delete-15388\";i:16626;s:12:\"delete-15389\";i:16627;s:12:\"delete-15390\";i:16628;s:12:\"delete-15391\";i:16629;s:12:\"delete-15392\";i:16630;s:12:\"delete-15393\";i:16631;s:12:\"delete-15394\";i:16632;s:12:\"delete-15395\";i:16633;s:12:\"delete-15396\";i:16634;s:12:\"delete-15397\";i:16635;s:12:\"delete-15398\";i:16636;s:12:\"delete-15399\";i:16637;s:12:\"delete-15400\";i:16638;s:12:\"delete-15401\";i:16639;s:12:\"delete-15402\";i:16640;s:12:\"delete-15403\";i:16641;s:12:\"delete-15404\";i:16642;s:12:\"delete-15405\";i:16643;s:12:\"delete-15406\";i:16644;s:12:\"delete-15407\";i:16645;s:12:\"delete-15408\";i:16646;s:12:\"delete-15409\";i:16647;s:12:\"delete-15410\";i:16648;s:12:\"delete-15411\";i:16649;s:12:\"delete-15412\";i:16650;s:12:\"delete-15413\";i:16651;s:12:\"delete-15414\";i:16652;s:12:\"delete-15415\";i:16653;s:12:\"delete-15416\";i:16654;s:12:\"delete-15417\";i:16655;s:12:\"delete-15418\";i:16656;s:12:\"delete-15419\";i:16657;s:12:\"delete-15420\";i:16658;s:12:\"delete-15421\";i:16659;s:12:\"delete-15422\";i:16660;s:12:\"delete-15423\";i:16661;s:12:\"delete-15424\";i:16662;s:12:\"delete-15425\";i:16663;s:12:\"delete-15426\";i:16664;s:12:\"delete-15427\";i:16665;s:12:\"delete-15428\";i:16666;s:12:\"delete-15429\";i:16667;s:12:\"delete-15430\";i:16668;s:12:\"delete-15431\";i:16669;s:12:\"delete-15432\";i:16670;s:12:\"delete-15433\";i:16671;s:12:\"delete-15434\";i:16672;s:12:\"delete-15435\";i:16673;s:12:\"delete-15436\";i:16674;s:12:\"delete-15437\";i:16675;s:12:\"delete-15438\";i:16676;s:12:\"delete-15439\";i:16677;s:12:\"delete-15440\";i:16678;s:12:\"delete-15441\";i:16679;s:12:\"delete-15442\";i:16680;s:12:\"delete-15443\";i:16681;s:12:\"delete-15444\";i:16682;s:12:\"delete-15445\";i:16683;s:12:\"delete-15446\";i:16684;s:12:\"delete-15447\";i:16685;s:12:\"delete-15448\";i:16686;s:12:\"delete-15449\";i:16687;s:12:\"delete-15450\";i:16688;s:12:\"delete-15451\";i:16689;s:12:\"delete-15452\";i:16690;s:12:\"delete-15453\";i:16691;s:12:\"delete-15454\";i:16692;s:12:\"delete-15455\";i:16693;s:12:\"delete-15456\";i:16694;s:12:\"delete-15457\";i:16695;s:12:\"delete-15458\";i:16696;s:12:\"delete-15459\";i:16697;s:12:\"delete-15460\";i:16698;s:12:\"delete-15461\";i:16699;s:12:\"delete-15462\";i:16700;s:12:\"delete-15463\";i:16701;s:12:\"delete-15464\";i:16702;s:12:\"delete-15465\";i:16703;s:12:\"delete-15466\";i:16704;s:12:\"delete-15467\";i:16705;s:12:\"delete-15468\";i:16706;s:12:\"delete-15469\";i:16707;s:12:\"delete-15470\";i:16708;s:12:\"delete-15471\";i:16709;s:12:\"delete-15472\";i:16710;s:12:\"delete-15473\";i:16711;s:12:\"delete-15474\";i:16712;s:12:\"delete-15475\";i:16713;s:12:\"delete-15476\";i:16714;s:12:\"delete-15477\";i:16715;s:12:\"delete-15478\";i:16716;s:12:\"delete-15479\";i:16717;s:12:\"delete-15480\";i:16718;s:12:\"delete-15481\";i:16719;s:12:\"delete-15482\";i:16720;s:12:\"delete-15483\";i:16721;s:12:\"delete-15484\";i:16722;s:12:\"delete-15485\";i:16723;s:12:\"delete-15486\";i:16724;s:12:\"delete-15487\";i:16725;s:12:\"delete-15488\";i:16726;s:12:\"delete-15489\";i:16727;s:12:\"delete-15490\";i:16728;s:12:\"delete-15491\";i:16729;s:12:\"delete-15492\";i:16730;s:12:\"delete-15493\";i:16731;s:12:\"delete-15494\";i:16732;s:12:\"delete-15495\";i:16733;s:12:\"delete-15496\";i:16734;s:12:\"delete-15497\";i:16735;s:12:\"delete-15498\";i:16736;s:12:\"delete-15499\";i:16737;s:12:\"delete-15500\";i:16738;s:12:\"delete-15501\";i:16739;s:12:\"delete-15502\";i:16740;s:12:\"delete-15503\";i:16741;s:12:\"delete-15504\";i:16742;s:12:\"delete-15505\";i:16743;s:12:\"delete-15506\";i:16744;s:12:\"delete-15507\";i:16745;s:12:\"delete-15508\";i:16746;s:12:\"delete-15509\";i:16747;s:12:\"delete-15510\";i:16748;s:12:\"delete-15511\";i:16749;s:12:\"delete-15512\";i:16750;s:12:\"delete-15513\";i:16751;s:12:\"delete-15514\";i:16752;s:12:\"delete-15515\";i:16753;s:12:\"delete-15516\";i:16754;s:12:\"delete-15517\";i:16755;s:12:\"delete-15518\";i:16756;s:12:\"delete-15519\";i:16757;s:12:\"delete-15520\";i:16758;s:12:\"delete-15521\";i:16759;s:12:\"delete-15522\";i:16760;s:12:\"delete-15523\";i:16761;s:12:\"delete-15524\";i:16762;s:12:\"delete-15525\";i:16763;s:12:\"delete-15526\";i:16764;s:12:\"delete-15527\";i:16765;s:12:\"delete-15528\";i:16766;s:12:\"delete-15529\";i:16767;s:12:\"delete-15530\";i:16768;s:12:\"delete-15531\";i:16769;s:12:\"delete-15532\";i:16770;s:12:\"delete-15533\";i:16771;s:12:\"delete-15534\";i:16772;s:12:\"delete-15535\";i:16773;s:12:\"delete-15536\";i:16774;s:12:\"delete-15537\";i:16775;s:12:\"delete-15538\";i:16776;s:12:\"delete-15539\";i:16777;s:12:\"delete-15540\";i:16778;s:12:\"delete-15541\";i:16779;s:12:\"delete-15542\";i:16780;s:12:\"delete-15543\";i:16781;s:12:\"delete-15544\";i:16782;s:12:\"delete-15545\";i:16783;s:12:\"delete-15546\";i:16784;s:12:\"delete-15547\";i:16785;s:12:\"delete-15548\";i:16786;s:12:\"delete-15549\";i:16787;s:12:\"delete-15550\";i:16788;s:12:\"delete-15551\";i:16789;s:12:\"delete-15552\";i:16790;s:12:\"delete-15553\";i:16791;s:12:\"delete-15554\";i:16792;s:12:\"delete-15555\";i:16793;s:12:\"delete-15556\";i:16794;s:12:\"delete-15557\";i:16795;s:12:\"delete-15558\";i:16796;s:12:\"delete-15559\";i:16797;s:12:\"delete-15560\";i:16798;s:12:\"delete-15561\";i:16799;s:12:\"delete-15562\";i:16800;s:12:\"delete-15563\";i:16801;s:12:\"delete-15564\";i:16802;s:12:\"delete-15565\";i:16803;s:12:\"delete-15566\";i:16804;s:12:\"delete-15567\";i:16805;s:12:\"delete-15568\";i:16806;s:12:\"delete-15569\";i:16807;s:12:\"delete-15570\";i:16808;s:12:\"delete-15571\";i:16809;s:12:\"delete-15572\";i:16810;s:12:\"delete-15573\";i:16811;s:12:\"delete-15574\";i:16812;s:12:\"delete-15575\";i:16813;s:12:\"delete-15576\";i:16814;s:12:\"delete-15577\";i:16815;s:12:\"delete-15578\";i:16816;s:12:\"delete-15579\";i:16817;s:12:\"delete-15580\";i:16818;s:12:\"delete-15581\";i:16819;s:12:\"delete-15582\";i:16820;s:12:\"delete-15583\";i:16821;s:12:\"delete-15584\";i:16822;s:12:\"delete-15585\";i:16823;s:12:\"delete-15586\";i:16824;s:12:\"delete-15587\";i:16825;s:12:\"delete-15588\";i:16826;s:12:\"delete-15589\";i:16827;s:12:\"delete-15590\";i:16828;s:12:\"delete-15591\";i:16829;s:12:\"delete-15592\";i:16830;s:12:\"delete-15593\";i:16831;s:12:\"delete-15594\";i:16832;s:12:\"delete-15595\";i:16833;s:12:\"delete-15596\";i:16834;s:12:\"delete-15597\";i:16835;s:12:\"delete-15598\";i:16836;s:12:\"delete-15599\";i:16837;s:12:\"delete-15600\";i:16838;s:12:\"delete-15601\";i:16839;s:12:\"delete-15602\";i:16840;s:12:\"delete-15603\";i:16841;s:12:\"delete-15604\";i:16842;s:12:\"delete-15605\";i:16843;s:12:\"delete-15606\";i:16844;s:12:\"delete-15607\";i:16845;s:12:\"delete-15608\";i:16846;s:12:\"delete-15609\";i:16847;s:12:\"delete-15610\";i:16848;s:12:\"delete-15611\";i:16849;s:12:\"delete-15612\";i:16850;s:12:\"delete-15613\";i:16851;s:12:\"delete-15614\";i:16852;s:12:\"delete-15615\";i:16853;s:12:\"delete-15616\";i:16854;s:12:\"delete-15617\";i:16855;s:12:\"delete-15618\";i:16856;s:12:\"delete-15619\";i:16857;s:12:\"delete-15620\";i:16858;s:12:\"delete-15621\";i:16859;s:12:\"delete-15622\";i:16860;s:12:\"delete-15623\";i:16861;s:12:\"delete-15624\";i:16862;s:12:\"delete-15625\";i:16863;s:12:\"delete-15626\";i:16864;s:12:\"delete-15627\";i:16865;s:12:\"delete-15628\";i:16866;s:12:\"delete-15629\";i:16867;s:12:\"delete-15630\";i:16868;s:12:\"delete-15631\";i:16869;s:12:\"delete-15632\";i:16870;s:12:\"delete-15633\";i:16871;s:12:\"delete-15634\";i:16872;s:12:\"delete-15635\";i:16873;s:12:\"delete-15636\";i:16874;s:12:\"delete-15637\";i:16875;s:12:\"delete-15638\";i:16876;s:12:\"delete-15639\";i:16877;s:12:\"delete-15640\";i:16878;s:12:\"delete-15641\";i:16879;s:12:\"delete-15642\";i:16880;s:12:\"delete-15643\";i:16881;s:12:\"delete-15644\";i:16882;s:12:\"delete-15645\";i:16883;s:12:\"delete-15646\";i:16884;s:12:\"delete-15647\";i:16885;s:12:\"delete-15648\";i:16886;s:12:\"delete-15649\";i:16887;s:12:\"delete-15650\";i:16888;s:12:\"delete-15651\";i:16889;s:12:\"delete-15652\";i:16890;s:12:\"delete-15653\";i:16891;s:12:\"delete-15654\";i:16892;s:12:\"delete-15655\";i:16893;s:12:\"delete-15656\";i:16894;s:12:\"delete-15657\";i:16895;s:12:\"delete-15658\";i:16896;s:12:\"delete-15659\";i:16897;s:12:\"delete-15660\";i:16898;s:12:\"delete-15661\";i:16899;s:12:\"delete-15662\";i:16900;s:12:\"delete-15663\";i:16901;s:12:\"delete-15664\";i:16902;s:12:\"delete-15665\";i:16903;s:12:\"delete-15666\";i:16904;s:12:\"delete-15667\";i:16905;s:12:\"delete-15668\";i:16906;s:12:\"delete-15669\";i:16907;s:12:\"delete-15670\";i:16908;s:12:\"delete-15671\";i:16909;s:12:\"delete-15672\";i:16910;s:12:\"delete-15673\";i:16911;s:12:\"delete-15674\";i:16912;s:12:\"delete-15675\";i:16913;s:12:\"delete-15676\";i:16914;s:12:\"delete-15677\";i:16915;s:12:\"delete-15678\";i:16916;s:12:\"delete-15679\";i:16917;s:12:\"delete-15680\";i:16918;s:12:\"delete-15681\";i:16919;s:12:\"delete-15682\";i:16920;s:12:\"delete-15683\";i:16921;s:12:\"delete-15684\";i:16922;s:12:\"delete-15685\";i:16923;s:12:\"delete-15686\";i:16924;s:12:\"delete-15687\";i:16925;s:12:\"delete-15688\";i:16926;s:12:\"delete-15689\";i:16927;s:12:\"delete-15690\";i:16928;s:12:\"delete-15691\";i:16929;s:12:\"delete-15692\";i:16930;s:12:\"delete-15693\";i:16931;s:12:\"delete-15694\";i:16932;s:12:\"delete-15695\";i:16933;s:12:\"delete-15696\";i:16934;s:12:\"delete-15697\";i:16935;s:12:\"delete-15698\";i:16936;s:12:\"delete-15699\";i:16937;s:12:\"delete-15700\";i:16938;s:12:\"delete-15701\";i:16939;s:12:\"delete-15702\";i:16940;s:12:\"delete-15703\";i:16941;s:12:\"delete-15704\";i:16942;s:12:\"delete-15705\";i:16943;s:12:\"delete-15706\";i:16944;s:12:\"delete-15707\";i:16945;s:12:\"delete-15708\";i:16946;s:12:\"delete-15709\";i:16947;s:12:\"delete-15710\";i:16948;s:12:\"delete-15711\";i:16949;s:12:\"delete-15712\";i:16950;s:12:\"delete-15713\";i:16951;s:12:\"delete-15714\";i:16952;s:12:\"delete-15715\";i:16953;s:12:\"delete-15716\";i:16954;s:12:\"delete-15717\";i:16955;s:12:\"delete-15718\";i:16956;s:12:\"delete-15719\";i:16957;s:12:\"delete-15720\";i:16958;s:12:\"delete-15721\";i:16959;s:12:\"delete-15722\";i:16960;s:12:\"delete-15723\";i:16961;s:12:\"delete-15724\";i:16962;s:12:\"delete-15725\";i:16963;s:12:\"delete-15726\";i:16964;s:12:\"delete-15727\";i:16965;s:12:\"delete-15728\";i:16966;s:12:\"delete-15729\";i:16967;s:12:\"delete-15730\";i:16968;s:12:\"delete-15731\";i:16969;s:12:\"delete-15732\";i:16970;s:12:\"delete-15733\";i:16971;s:12:\"delete-15734\";i:16972;s:12:\"delete-15735\";i:16973;s:12:\"delete-15736\";i:16974;s:12:\"delete-15737\";i:16975;s:12:\"delete-15738\";i:16976;s:12:\"delete-15739\";i:16977;s:12:\"delete-15740\";i:16978;s:12:\"delete-15741\";i:16979;s:12:\"delete-15742\";i:16980;s:12:\"delete-15743\";i:16981;s:12:\"delete-15744\";i:16982;s:12:\"delete-15745\";i:16983;s:12:\"delete-15746\";i:16984;s:12:\"delete-15747\";i:16985;s:12:\"delete-15748\";i:16986;s:12:\"delete-15749\";i:16987;s:12:\"delete-15750\";i:16988;s:12:\"delete-15751\";i:16989;s:12:\"delete-15752\";i:16990;s:12:\"delete-15753\";i:16991;s:12:\"delete-15754\";i:16992;s:12:\"delete-15755\";i:16993;s:12:\"delete-15756\";i:16994;s:12:\"delete-15757\";i:16995;s:12:\"delete-15758\";i:16996;s:12:\"delete-15759\";i:16997;s:12:\"delete-15760\";i:16998;s:12:\"delete-15761\";i:16999;s:12:\"delete-15762\";i:17000;s:12:\"delete-15763\";i:17001;s:12:\"delete-15764\";i:17002;s:12:\"delete-15765\";i:17003;s:12:\"delete-15766\";i:17004;s:12:\"delete-15767\";i:17005;s:12:\"delete-15768\";i:17006;s:12:\"delete-15769\";i:17007;s:12:\"delete-15770\";i:17008;s:12:\"delete-15771\";i:17009;s:12:\"delete-15772\";i:17010;s:12:\"delete-15773\";i:17011;s:12:\"delete-15774\";i:17012;s:12:\"delete-15775\";i:17013;s:12:\"delete-15776\";i:17014;s:12:\"delete-15777\";i:17015;s:12:\"delete-15778\";i:17016;s:12:\"delete-15779\";i:17017;s:12:\"delete-15780\";i:17018;s:12:\"delete-15781\";i:17019;s:12:\"delete-15782\";i:17020;s:12:\"delete-15783\";i:17021;s:12:\"delete-15784\";i:17022;s:12:\"delete-15785\";i:17023;s:12:\"delete-15786\";i:17024;s:12:\"delete-15787\";i:17025;s:12:\"delete-15788\";i:17026;s:12:\"delete-15789\";i:17027;s:12:\"delete-15790\";i:17028;s:12:\"delete-15791\";i:17029;s:12:\"delete-15792\";i:17030;s:12:\"delete-15793\";i:17031;s:12:\"delete-15794\";i:17032;s:12:\"delete-15795\";i:17033;s:12:\"delete-15796\";i:17034;s:12:\"delete-15797\";i:17035;s:12:\"delete-15798\";i:17036;s:12:\"delete-15799\";i:17037;s:12:\"delete-15800\";i:17038;s:12:\"delete-15801\";i:17039;s:12:\"delete-15802\";i:17040;s:12:\"delete-15803\";i:17041;s:12:\"delete-15804\";i:17042;s:12:\"delete-15805\";i:17043;s:12:\"delete-15806\";i:17044;s:12:\"delete-15807\";i:17045;s:12:\"delete-15808\";i:17046;s:12:\"delete-15809\";i:17047;s:12:\"delete-15810\";i:17048;s:12:\"delete-15811\";i:17049;s:12:\"delete-15812\";i:17050;s:12:\"delete-15813\";i:17051;s:12:\"delete-15814\";i:17052;s:12:\"delete-15815\";i:17053;s:12:\"delete-15816\";i:17054;s:12:\"delete-15817\";i:17055;s:12:\"delete-15818\";i:17056;s:12:\"delete-15819\";i:17057;s:12:\"delete-15820\";i:17058;s:12:\"delete-15821\";i:17059;s:12:\"delete-15822\";i:17060;s:12:\"delete-15823\";i:17061;s:12:\"delete-15824\";i:17062;s:12:\"delete-15825\";i:17063;s:12:\"delete-15826\";i:17064;s:12:\"delete-15827\";i:17065;s:12:\"delete-15828\";i:17066;s:12:\"delete-15829\";i:17067;s:12:\"delete-15830\";i:17068;s:12:\"delete-15831\";i:17069;s:12:\"delete-15832\";i:17070;s:12:\"delete-15833\";i:17071;s:12:\"delete-15834\";i:17072;s:12:\"delete-15835\";i:17073;s:12:\"delete-15836\";i:17074;s:12:\"delete-15837\";i:17075;s:12:\"delete-15838\";i:17076;s:12:\"delete-15839\";i:17077;s:12:\"delete-15840\";i:17078;s:12:\"delete-15841\";i:17079;s:12:\"delete-15842\";i:17080;s:12:\"delete-15843\";i:17081;s:12:\"delete-15844\";i:17082;s:12:\"delete-15845\";i:17083;s:12:\"delete-15846\";i:17084;s:12:\"delete-15847\";i:17085;s:12:\"delete-15848\";i:17086;s:12:\"delete-15849\";i:17087;s:12:\"delete-15850\";i:17088;s:12:\"delete-15851\";i:17089;s:12:\"delete-15852\";i:17090;s:12:\"delete-15853\";i:17091;s:12:\"delete-15854\";i:17092;s:12:\"delete-15855\";i:17093;s:12:\"delete-15856\";i:17094;s:12:\"delete-15857\";i:17095;s:12:\"delete-15858\";i:17096;s:12:\"delete-15859\";i:17097;s:12:\"delete-15860\";i:17098;s:12:\"delete-15861\";i:17099;s:12:\"delete-15862\";i:17100;s:12:\"delete-15863\";i:17101;s:12:\"delete-15864\";i:17102;s:12:\"delete-15865\";i:17103;s:12:\"delete-15866\";i:17104;s:12:\"delete-15867\";i:17105;s:12:\"delete-15868\";i:17106;s:12:\"delete-15869\";i:17107;s:12:\"delete-15870\";i:17108;s:12:\"delete-15871\";i:17109;s:12:\"delete-15872\";i:17110;s:12:\"delete-15873\";i:17111;s:12:\"delete-15874\";i:17112;s:12:\"delete-15875\";i:17113;s:12:\"delete-15876\";i:17114;s:12:\"delete-15877\";i:17115;s:12:\"delete-15878\";i:17116;s:12:\"delete-15879\";i:17117;s:12:\"delete-15880\";i:17118;s:12:\"delete-15881\";i:17119;s:12:\"delete-15882\";i:17120;s:12:\"delete-15883\";i:17121;s:12:\"delete-15884\";i:17122;s:12:\"delete-15885\";i:17123;s:12:\"delete-15886\";i:17124;s:12:\"delete-15887\";i:17125;s:12:\"delete-15888\";i:17126;s:12:\"delete-15889\";i:17127;s:12:\"delete-15890\";i:17128;s:12:\"delete-15891\";i:17129;s:12:\"delete-15892\";i:17130;s:12:\"delete-15893\";i:17131;s:12:\"delete-15894\";i:17132;s:12:\"delete-15895\";i:17133;s:12:\"delete-15896\";i:17134;s:12:\"delete-15897\";i:17135;s:12:\"delete-15898\";i:17136;s:12:\"delete-15899\";i:17137;s:12:\"delete-15900\";i:17138;s:12:\"delete-15901\";i:17139;s:12:\"delete-15902\";i:17140;s:12:\"delete-15903\";i:17141;s:12:\"delete-15904\";i:17142;s:12:\"delete-15905\";i:17143;s:12:\"delete-15906\";i:17144;s:12:\"delete-15907\";i:17145;s:12:\"delete-15908\";i:17146;s:12:\"delete-15909\";i:17147;s:12:\"delete-15910\";i:17148;s:12:\"delete-15911\";i:17149;s:12:\"delete-15912\";i:17150;s:12:\"delete-15913\";i:17151;s:12:\"delete-15914\";i:17152;s:12:\"delete-15915\";i:17153;s:12:\"delete-15916\";i:17154;s:12:\"delete-15917\";i:17155;s:12:\"delete-15918\";i:17156;s:12:\"delete-15919\";i:17157;s:12:\"delete-15920\";i:17158;s:12:\"delete-15921\";i:17159;s:12:\"delete-15922\";i:17160;s:12:\"delete-15923\";i:17161;s:12:\"delete-15924\";i:17162;s:12:\"delete-15925\";i:17163;s:12:\"delete-15926\";i:17164;s:12:\"delete-15927\";i:17165;s:12:\"delete-15928\";i:17166;s:12:\"delete-15929\";i:17167;s:12:\"delete-15930\";i:17168;s:12:\"delete-15931\";i:17169;s:12:\"delete-15932\";i:17170;s:12:\"delete-15933\";i:17171;s:12:\"delete-15934\";i:17172;s:12:\"delete-15935\";i:17173;s:12:\"delete-15936\";i:17174;s:12:\"delete-15937\";i:17175;s:12:\"delete-15938\";i:17176;s:12:\"delete-15939\";i:17177;s:12:\"delete-15940\";i:17178;s:12:\"delete-15941\";i:17179;s:12:\"delete-15942\";i:17180;s:12:\"delete-15943\";i:17181;s:12:\"delete-15944\";i:17182;s:12:\"delete-15945\";i:17183;s:12:\"delete-15946\";i:17184;s:12:\"delete-15947\";i:17185;s:12:\"delete-15948\";i:17186;s:12:\"delete-15949\";i:17187;s:12:\"delete-15950\";i:17188;s:12:\"delete-15951\";i:17189;s:12:\"delete-15952\";i:17190;s:12:\"delete-15953\";i:17191;s:12:\"delete-15954\";i:17192;s:12:\"delete-15955\";i:17193;s:12:\"delete-15956\";i:17194;s:12:\"delete-15957\";i:17195;s:12:\"delete-15958\";i:17196;s:12:\"delete-15959\";i:17197;s:12:\"delete-15960\";i:17198;s:12:\"delete-15961\";i:17199;s:12:\"delete-15962\";i:17200;s:12:\"delete-15963\";i:17201;s:12:\"delete-15964\";i:17202;s:12:\"delete-15965\";i:17203;s:12:\"delete-15966\";i:17204;s:12:\"delete-15967\";i:17205;s:12:\"delete-15968\";i:17206;s:12:\"delete-15969\";i:17207;s:12:\"delete-15970\";i:17208;s:12:\"delete-15971\";i:17209;s:12:\"delete-15972\";i:17210;s:12:\"delete-15973\";i:17211;s:12:\"delete-15974\";i:17212;s:12:\"delete-15975\";i:17213;s:12:\"delete-15976\";i:17214;s:12:\"delete-15977\";i:17215;s:12:\"delete-15978\";i:17216;s:12:\"delete-15979\";i:17217;s:12:\"delete-15980\";i:17218;s:12:\"delete-15981\";i:17219;s:12:\"delete-15982\";i:17220;s:12:\"delete-15983\";i:17221;s:12:\"delete-15984\";i:17222;s:12:\"delete-15985\";i:17223;s:12:\"delete-15986\";i:17224;s:12:\"delete-15987\";i:17225;s:12:\"delete-15988\";i:17226;s:12:\"delete-15989\";i:17227;s:12:\"delete-15990\";i:17228;s:12:\"delete-15991\";i:17229;s:12:\"delete-15992\";i:17230;s:12:\"delete-15993\";i:17231;s:12:\"delete-15994\";i:17232;s:12:\"delete-15995\";i:17233;s:12:\"delete-15996\";i:17234;s:12:\"delete-15997\";i:17235;s:12:\"delete-15998\";i:17236;s:12:\"delete-15999\";i:17237;s:12:\"delete-16000\";i:17238;s:12:\"delete-16001\";i:17239;s:12:\"delete-16002\";i:17240;s:12:\"delete-16003\";i:17241;s:12:\"delete-16004\";i:17242;s:12:\"delete-16005\";i:17243;s:12:\"delete-16006\";i:17244;s:12:\"delete-16007\";i:17245;s:12:\"delete-16008\";i:17246;s:12:\"delete-16009\";i:17247;s:12:\"delete-16010\";i:17248;s:12:\"delete-16011\";i:17249;s:12:\"delete-16012\";i:17250;s:12:\"delete-16013\";i:17251;s:12:\"delete-16014\";i:17252;s:12:\"delete-16015\";i:17253;s:12:\"delete-16016\";i:17254;s:12:\"delete-16017\";i:17255;s:12:\"delete-16018\";i:17256;s:12:\"delete-16019\";i:17257;s:12:\"delete-16020\";i:17258;s:12:\"delete-16021\";i:17259;s:12:\"delete-16022\";i:17260;s:12:\"delete-16023\";i:17261;s:12:\"delete-16024\";i:17262;s:12:\"delete-16025\";i:17263;s:12:\"delete-16026\";i:17264;s:12:\"delete-16027\";i:17265;s:12:\"delete-16028\";i:17266;s:12:\"delete-16029\";i:17267;s:12:\"delete-16030\";i:17268;s:12:\"delete-16031\";i:17269;s:12:\"delete-16032\";i:17270;s:12:\"delete-16033\";i:17271;s:12:\"delete-16034\";i:17272;s:12:\"delete-16035\";i:17273;s:12:\"delete-16036\";i:17274;s:12:\"delete-16037\";i:17275;s:12:\"delete-16038\";i:17276;s:12:\"delete-16039\";i:17277;s:12:\"delete-16040\";i:17278;s:12:\"delete-16041\";i:17279;s:12:\"delete-16042\";i:17280;s:12:\"delete-16043\";i:17281;s:12:\"delete-16044\";i:17282;s:12:\"delete-16045\";i:17283;s:12:\"delete-16046\";i:17284;s:12:\"delete-16047\";i:17285;s:12:\"delete-16048\";i:17286;s:12:\"delete-16049\";i:17287;s:12:\"delete-16050\";i:17288;s:12:\"delete-16051\";i:17289;s:12:\"delete-16052\";i:17290;s:12:\"delete-16053\";i:17291;s:12:\"delete-16054\";i:17292;s:12:\"delete-16055\";i:17293;s:12:\"delete-16056\";i:17294;s:12:\"delete-16057\";i:17295;s:12:\"delete-16058\";i:17296;s:12:\"delete-16059\";i:17297;s:12:\"delete-16060\";i:17298;s:12:\"delete-16061\";i:17299;s:12:\"delete-16062\";i:17300;s:12:\"delete-16063\";i:17301;s:12:\"delete-16064\";i:17302;s:12:\"delete-16065\";i:17303;s:12:\"delete-16066\";i:17304;s:12:\"delete-16067\";i:17305;s:12:\"delete-16068\";i:17306;s:12:\"delete-16069\";i:17307;s:12:\"delete-16070\";i:17308;s:12:\"delete-16071\";i:17309;s:12:\"delete-16072\";i:17310;s:12:\"delete-16073\";i:17311;s:12:\"delete-16074\";i:17312;s:12:\"delete-16075\";i:17313;s:12:\"delete-16076\";i:17314;s:12:\"delete-16077\";i:17315;s:12:\"delete-16078\";i:17316;s:12:\"delete-16079\";i:17317;s:12:\"delete-16080\";i:17318;s:12:\"delete-16081\";i:17319;s:12:\"delete-16082\";i:17320;s:12:\"delete-16083\";i:17321;s:12:\"delete-16084\";i:17322;s:12:\"delete-16085\";i:17323;s:12:\"delete-16086\";i:17324;s:12:\"delete-16087\";i:17325;s:12:\"delete-16088\";i:17326;s:12:\"delete-16089\";i:17327;s:12:\"delete-16090\";i:17328;s:12:\"delete-16091\";i:17329;s:12:\"delete-16092\";i:17330;s:12:\"delete-16093\";i:17331;s:12:\"delete-16094\";i:17332;s:12:\"delete-16095\";i:17333;s:12:\"delete-16096\";i:17334;s:12:\"delete-16097\";i:17335;s:12:\"delete-16098\";i:17336;s:12:\"delete-16099\";i:17337;s:12:\"delete-16100\";i:17338;s:12:\"delete-16101\";i:17339;s:12:\"delete-16102\";i:17340;s:12:\"delete-16103\";i:17341;s:12:\"delete-16104\";i:17342;s:12:\"delete-16105\";i:17343;s:12:\"delete-16106\";i:17344;s:12:\"delete-16107\";i:17345;s:12:\"delete-16108\";i:17346;s:12:\"delete-16109\";i:17347;s:12:\"delete-16110\";i:17348;s:12:\"delete-16111\";i:17349;s:12:\"delete-16112\";i:17350;s:12:\"delete-16113\";i:17351;s:12:\"delete-16114\";i:17352;s:12:\"delete-16115\";i:17353;s:12:\"delete-16116\";i:17354;s:12:\"delete-16117\";i:17355;s:12:\"delete-16118\";i:17356;s:12:\"delete-16119\";i:17357;s:12:\"delete-16120\";i:17358;s:12:\"delete-16121\";i:17359;s:12:\"delete-16122\";i:17360;s:12:\"delete-16123\";i:17361;s:12:\"delete-16124\";i:17362;s:12:\"delete-16125\";i:17363;s:12:\"delete-16126\";i:17364;s:12:\"delete-16127\";i:17365;s:12:\"delete-16128\";i:17366;s:12:\"delete-16129\";i:17367;s:12:\"delete-16130\";i:17368;s:12:\"delete-16131\";i:17369;s:12:\"delete-16132\";i:17370;s:12:\"delete-16133\";i:17371;s:12:\"delete-16134\";i:17372;s:12:\"delete-16135\";i:17373;s:12:\"delete-16136\";i:17374;s:12:\"delete-16137\";i:17375;s:12:\"delete-16138\";i:17376;s:12:\"delete-16139\";i:17377;s:12:\"delete-16140\";i:17378;s:12:\"delete-16141\";i:17379;s:12:\"delete-16142\";i:17380;s:12:\"delete-16143\";i:17381;s:12:\"delete-16144\";i:17382;s:12:\"delete-16145\";i:17383;s:12:\"delete-16146\";i:17384;s:12:\"delete-16147\";i:17385;s:12:\"delete-16148\";i:17386;s:12:\"delete-16149\";i:17387;s:12:\"delete-16150\";i:17388;s:12:\"delete-16151\";i:17389;s:12:\"delete-16152\";i:17390;s:12:\"delete-16153\";i:17391;s:12:\"delete-16154\";i:17392;s:12:\"delete-16155\";i:17393;s:12:\"delete-16156\";i:17394;s:12:\"delete-16157\";i:17395;s:12:\"delete-16158\";i:17396;s:12:\"delete-16159\";i:17397;s:12:\"delete-16160\";i:17398;s:12:\"delete-16161\";i:17399;s:12:\"delete-16162\";i:17400;s:12:\"delete-16163\";i:17401;s:12:\"delete-16164\";i:17402;s:12:\"delete-16165\";i:17403;s:12:\"delete-16166\";i:17404;s:12:\"delete-16167\";i:17405;s:12:\"delete-16168\";i:17406;s:12:\"delete-16169\";i:17407;s:12:\"delete-16170\";i:17408;s:12:\"delete-16171\";i:17409;s:12:\"delete-16172\";i:17410;s:12:\"delete-16173\";i:17411;s:12:\"delete-16174\";i:17412;s:12:\"delete-16175\";i:17413;s:12:\"delete-16176\";i:17414;s:12:\"delete-16177\";i:17415;s:12:\"delete-16178\";i:17416;s:12:\"delete-16179\";i:17417;s:12:\"delete-16180\";i:17418;s:12:\"delete-16181\";i:17419;s:12:\"delete-16182\";i:17420;s:12:\"delete-16183\";i:17421;s:12:\"delete-16184\";i:17422;s:12:\"delete-16185\";i:17423;s:12:\"delete-16186\";i:17424;s:12:\"delete-16187\";i:17425;s:12:\"delete-16188\";i:17426;s:12:\"delete-16189\";i:17427;s:12:\"delete-16190\";i:17428;s:12:\"delete-16191\";i:17429;s:12:\"delete-16192\";i:17430;s:12:\"delete-16193\";i:17431;s:12:\"delete-16194\";i:17432;s:12:\"delete-16195\";i:17433;s:12:\"delete-16196\";i:17434;s:12:\"delete-16197\";i:17435;s:12:\"delete-16198\";i:17436;s:12:\"delete-16199\";i:17437;s:12:\"delete-16200\";i:17438;s:12:\"delete-16201\";i:17439;s:12:\"delete-16202\";i:17440;s:12:\"delete-16203\";i:17441;s:12:\"delete-16204\";i:17442;s:12:\"delete-16205\";i:17443;s:12:\"delete-16206\";i:17444;s:12:\"delete-16207\";i:17445;s:12:\"delete-16208\";i:17446;s:12:\"delete-16209\";i:17447;s:12:\"delete-16210\";i:17448;s:12:\"delete-16211\";i:17449;s:12:\"delete-16212\";i:17450;s:12:\"delete-16213\";i:17451;s:12:\"delete-16214\";i:17452;s:12:\"delete-16215\";i:17453;s:12:\"delete-16216\";i:17454;s:12:\"delete-16217\";i:17455;s:12:\"delete-16218\";i:17456;s:12:\"delete-16219\";i:17457;s:12:\"delete-16220\";i:17458;s:12:\"delete-16221\";i:17459;s:12:\"delete-16222\";i:17460;s:12:\"delete-16223\";i:17461;s:12:\"delete-16224\";i:17462;s:12:\"delete-16225\";i:17463;s:12:\"delete-16226\";i:17464;s:12:\"delete-16227\";i:17465;s:12:\"delete-16228\";i:17466;s:12:\"delete-16229\";i:17467;s:12:\"delete-16230\";i:17468;s:12:\"delete-16231\";i:17469;s:12:\"delete-16232\";i:17470;s:12:\"delete-16233\";i:17471;s:12:\"delete-16234\";i:17472;s:12:\"delete-16235\";i:17473;s:12:\"delete-16236\";i:17474;s:12:\"delete-16237\";i:17475;s:12:\"delete-16238\";i:17476;s:12:\"delete-16239\";i:17477;s:12:\"delete-16240\";i:17478;s:12:\"delete-16241\";i:17479;s:12:\"delete-16242\";i:17480;s:12:\"delete-16243\";i:17481;s:12:\"delete-16244\";i:17482;s:12:\"delete-16245\";i:17483;s:12:\"delete-16246\";i:17484;s:12:\"delete-16247\";i:17485;s:12:\"delete-16248\";i:17486;s:12:\"delete-16249\";i:17487;s:12:\"delete-16250\";i:17488;s:12:\"delete-16251\";i:17489;s:12:\"delete-16252\";i:17490;s:12:\"delete-16253\";i:17491;s:12:\"delete-16254\";i:17492;s:12:\"delete-16255\";i:17493;s:12:\"delete-16256\";i:17494;s:12:\"delete-16257\";i:17495;s:12:\"delete-16258\";i:17496;s:12:\"delete-16259\";i:17497;s:12:\"delete-16260\";i:17498;s:12:\"delete-16261\";i:17499;s:12:\"delete-16262\";i:17500;s:12:\"delete-16263\";i:17501;s:12:\"delete-16264\";i:17502;s:12:\"delete-16265\";i:17503;s:12:\"delete-16266\";i:17504;s:12:\"delete-16267\";i:17505;s:12:\"delete-16268\";i:17506;s:12:\"delete-16269\";i:17507;s:12:\"delete-16270\";i:17508;s:12:\"delete-16271\";i:17509;s:12:\"delete-16272\";i:17510;s:12:\"delete-16273\";i:17511;s:12:\"delete-16274\";i:17512;s:12:\"delete-16275\";i:17513;s:12:\"delete-16276\";i:17514;s:12:\"delete-16277\";i:17515;s:12:\"delete-16278\";i:17516;s:12:\"delete-16279\";i:17517;s:12:\"delete-16280\";i:17518;s:12:\"delete-16281\";i:17519;s:12:\"delete-16282\";i:17520;s:12:\"delete-16283\";i:17521;s:12:\"delete-16284\";i:17522;s:12:\"delete-16285\";i:17523;s:12:\"delete-16286\";i:17524;s:12:\"delete-16287\";i:17525;s:12:\"delete-16288\";i:17526;s:12:\"delete-16289\";i:17527;s:12:\"delete-16290\";i:17528;s:12:\"delete-16291\";i:17529;s:12:\"delete-16292\";i:17530;s:12:\"delete-16293\";i:17531;s:12:\"delete-16294\";i:17532;s:12:\"delete-16295\";i:17533;s:12:\"delete-16296\";i:17534;s:12:\"delete-16297\";i:17535;s:12:\"delete-16298\";i:17536;s:12:\"delete-16299\";i:17537;s:12:\"delete-16300\";i:17538;s:12:\"delete-16301\";i:17539;s:12:\"delete-16302\";i:17540;s:12:\"delete-16303\";i:17541;s:12:\"delete-16304\";i:17542;s:12:\"delete-16305\";i:17543;s:12:\"delete-16306\";i:17544;s:12:\"delete-16307\";i:17545;s:12:\"delete-16308\";i:17546;s:12:\"delete-16309\";i:17547;s:12:\"delete-16310\";i:17548;s:12:\"delete-16311\";i:17549;s:12:\"delete-16312\";i:17550;s:12:\"delete-16313\";i:17551;s:12:\"delete-16314\";i:17552;s:12:\"delete-16315\";i:17553;s:12:\"delete-16316\";i:17554;s:12:\"delete-16317\";i:17555;s:12:\"delete-16318\";i:17556;s:12:\"delete-16319\";i:17557;s:12:\"delete-16320\";i:17558;s:12:\"delete-16321\";i:17559;s:12:\"delete-16322\";i:17560;s:12:\"delete-16323\";i:17561;s:12:\"delete-16324\";i:17562;s:12:\"delete-16325\";i:17563;s:12:\"delete-16326\";i:17564;s:12:\"delete-16327\";i:17565;s:12:\"delete-16328\";i:17566;s:12:\"delete-16329\";i:17567;s:12:\"delete-16330\";i:17568;s:12:\"delete-16331\";i:17569;s:12:\"delete-16332\";i:17570;s:12:\"delete-16333\";i:17571;s:12:\"delete-16334\";i:17572;s:12:\"delete-16335\";i:17573;s:12:\"delete-16336\";i:17574;s:12:\"delete-16337\";i:17575;s:12:\"delete-16338\";i:17576;s:12:\"delete-16339\";i:17577;s:12:\"delete-16340\";i:17578;s:12:\"delete-16341\";i:17579;s:12:\"delete-16342\";i:17580;s:12:\"delete-16343\";i:17581;s:12:\"delete-16344\";i:17582;s:12:\"delete-16345\";i:17583;s:12:\"delete-16346\";i:17584;s:12:\"delete-16347\";i:17585;s:12:\"delete-16348\";i:17586;s:12:\"delete-16349\";i:17587;s:12:\"delete-16350\";i:17588;s:12:\"delete-16351\";i:17589;s:12:\"delete-16352\";i:17590;s:12:\"delete-16353\";i:17591;s:12:\"delete-16354\";i:17592;s:12:\"delete-16355\";i:17593;s:12:\"delete-16356\";i:17594;s:12:\"delete-16357\";i:17595;s:12:\"delete-16358\";i:17596;s:12:\"delete-16359\";i:17597;s:12:\"delete-16360\";i:17598;s:12:\"delete-16361\";i:17599;s:12:\"delete-16362\";i:17600;s:12:\"delete-16363\";i:17601;s:12:\"delete-16364\";i:17602;s:12:\"delete-16365\";i:17603;s:12:\"delete-16366\";i:17604;s:12:\"delete-16367\";i:17605;s:12:\"delete-16368\";i:17606;s:12:\"delete-16369\";i:17607;s:12:\"delete-16370\";i:17608;s:12:\"delete-16371\";i:17609;s:12:\"delete-16372\";i:17610;s:12:\"delete-16373\";i:17611;s:12:\"delete-16374\";i:17612;s:12:\"delete-16375\";i:17613;s:12:\"delete-16376\";i:17614;s:12:\"delete-16377\";i:17615;s:12:\"delete-16378\";i:17616;s:12:\"delete-16379\";i:17617;s:12:\"delete-16380\";i:17618;s:12:\"delete-16381\";i:17619;s:12:\"delete-16382\";i:17620;s:12:\"delete-16383\";i:17621;s:12:\"delete-16384\";i:17622;s:12:\"delete-16385\";i:17623;s:12:\"delete-16386\";i:17624;s:12:\"delete-16387\";i:17625;s:12:\"delete-16388\";i:17626;s:12:\"delete-16389\";i:17627;s:12:\"delete-16390\";i:17628;s:12:\"delete-16391\";i:17629;s:12:\"delete-16392\";i:17630;s:12:\"delete-16393\";i:17631;s:12:\"delete-16394\";i:17632;s:12:\"delete-16395\";i:17633;s:12:\"delete-16396\";i:17634;s:12:\"delete-16397\";i:17635;s:12:\"delete-16398\";i:17636;s:12:\"delete-16399\";i:17637;s:12:\"delete-16400\";i:17638;s:12:\"delete-16401\";i:17639;s:12:\"delete-16402\";i:17640;s:12:\"delete-16403\";i:17641;s:12:\"delete-16404\";i:17642;s:12:\"delete-16405\";i:17643;s:12:\"delete-16406\";i:17644;s:12:\"delete-16407\";i:17645;s:12:\"delete-16408\";i:17646;s:12:\"delete-16409\";i:17647;s:12:\"delete-16410\";i:17648;s:12:\"delete-16411\";i:17649;s:12:\"delete-16412\";i:17650;s:12:\"delete-16413\";i:17651;s:12:\"delete-16414\";i:17652;s:12:\"delete-16415\";i:17653;s:12:\"delete-16416\";i:17654;s:12:\"delete-16417\";i:17655;s:12:\"delete-16418\";i:17656;s:12:\"delete-16419\";i:17657;s:12:\"delete-16420\";i:17658;s:12:\"delete-16421\";i:17659;s:12:\"delete-16422\";i:17660;s:12:\"delete-16423\";i:17661;s:12:\"delete-16424\";i:17662;s:12:\"delete-16425\";i:17663;s:12:\"delete-16426\";i:17664;s:12:\"delete-16427\";i:17665;s:12:\"delete-16428\";i:17666;s:12:\"delete-16429\";i:17667;s:12:\"delete-16430\";i:17668;s:12:\"delete-16431\";i:17669;s:12:\"delete-16432\";i:17670;s:12:\"delete-16433\";i:17671;s:12:\"delete-16434\";i:17672;s:12:\"delete-16435\";i:17673;s:12:\"delete-16436\";i:17674;s:12:\"delete-16437\";i:17675;s:12:\"delete-16438\";i:17676;s:12:\"delete-16439\";i:17677;s:12:\"delete-16440\";i:17678;s:12:\"delete-16441\";i:17679;s:12:\"delete-16442\";i:17680;s:12:\"delete-16443\";i:17681;s:12:\"delete-16444\";i:17682;s:12:\"delete-16445\";i:17683;s:12:\"delete-16446\";i:17684;s:12:\"delete-16447\";i:17685;s:12:\"delete-16448\";i:17686;s:12:\"delete-16449\";i:17687;s:12:\"delete-16450\";i:17688;s:12:\"delete-16451\";i:17689;s:12:\"delete-16452\";i:17690;s:12:\"delete-16453\";i:17691;s:12:\"delete-16454\";i:17692;s:12:\"delete-16455\";i:17693;s:12:\"delete-16456\";i:17694;s:12:\"delete-16457\";i:17695;s:12:\"delete-16458\";i:17696;s:12:\"delete-16459\";i:17697;s:12:\"delete-16460\";i:17698;s:12:\"delete-16461\";i:17699;s:12:\"delete-16462\";i:17700;s:12:\"delete-16463\";i:17701;s:12:\"delete-16464\";i:17702;s:12:\"delete-16465\";i:17703;s:12:\"delete-16466\";i:17704;s:12:\"delete-16467\";i:17705;s:12:\"delete-16468\";i:17706;s:12:\"delete-16469\";i:17707;s:12:\"delete-16470\";i:17708;s:12:\"delete-16471\";i:17709;s:12:\"delete-16472\";i:17710;s:12:\"delete-16473\";i:17711;s:12:\"delete-16474\";i:17712;s:12:\"delete-16475\";i:17713;s:12:\"delete-16476\";i:17714;s:12:\"delete-16477\";i:17715;s:12:\"delete-16478\";i:17716;s:12:\"delete-16479\";i:17717;s:12:\"delete-16480\";i:17718;s:12:\"delete-16481\";i:17719;s:12:\"delete-16482\";i:17720;s:12:\"delete-16483\";i:17721;s:12:\"delete-16484\";i:17722;s:12:\"delete-16485\";i:17723;s:12:\"delete-16486\";i:17724;s:12:\"delete-16487\";i:17725;s:12:\"delete-16488\";i:17726;s:12:\"delete-16489\";i:17727;s:12:\"delete-16490\";i:17728;s:12:\"delete-16491\";i:17729;s:12:\"delete-16492\";i:17730;s:12:\"delete-16493\";i:17731;s:12:\"delete-16494\";i:17732;s:12:\"delete-16495\";i:17733;s:12:\"delete-16496\";i:17734;s:12:\"delete-16497\";i:17735;s:12:\"delete-16498\";i:17736;s:12:\"delete-16499\";i:17737;s:12:\"delete-16500\";i:17738;s:12:\"delete-16501\";i:17739;s:12:\"delete-16502\";i:17740;s:12:\"delete-16503\";i:17741;s:12:\"delete-16504\";i:17742;s:12:\"delete-16505\";i:17743;s:12:\"delete-16506\";i:17744;s:12:\"delete-16507\";i:17745;s:12:\"delete-16508\";i:17746;s:12:\"delete-16509\";i:17747;s:12:\"delete-16510\";i:17748;s:12:\"delete-16511\";i:17749;s:12:\"delete-16512\";i:17750;s:12:\"delete-16513\";i:17751;s:12:\"delete-16514\";i:17752;s:12:\"delete-16515\";i:17753;s:12:\"delete-16516\";i:17754;s:12:\"delete-16517\";i:17755;s:12:\"delete-16518\";i:17756;s:12:\"delete-16519\";i:17757;s:12:\"delete-16520\";i:17758;s:12:\"delete-16521\";i:17759;s:12:\"delete-16522\";i:17760;s:12:\"delete-16523\";i:17761;s:12:\"delete-16524\";i:17762;s:12:\"delete-16525\";i:17763;s:12:\"delete-16526\";i:17764;s:12:\"delete-16527\";i:17765;s:12:\"delete-16528\";i:17766;s:12:\"delete-16529\";i:17767;s:12:\"delete-16530\";i:17768;s:12:\"delete-16531\";i:17769;s:12:\"delete-16532\";i:17770;s:12:\"delete-16533\";i:17771;s:12:\"delete-16534\";i:17772;s:12:\"delete-16535\";i:17773;s:12:\"delete-16536\";i:17774;s:12:\"delete-16537\";i:17775;s:12:\"delete-16538\";i:17776;s:12:\"delete-16539\";i:17777;s:12:\"delete-16540\";i:17778;s:12:\"delete-16541\";i:17779;s:12:\"delete-16542\";i:17780;s:12:\"delete-16543\";i:17781;s:12:\"delete-16544\";i:17782;s:12:\"delete-16545\";i:17783;s:12:\"delete-16546\";i:17784;s:12:\"delete-16547\";i:17785;s:12:\"delete-16548\";i:17786;s:12:\"delete-16549\";i:17787;s:12:\"delete-16550\";i:17788;s:12:\"delete-16551\";i:17789;s:12:\"delete-16552\";i:17790;s:12:\"delete-16553\";i:17791;s:12:\"delete-16554\";i:17792;s:12:\"delete-16555\";i:17793;s:12:\"delete-16556\";i:17794;s:12:\"delete-16557\";i:17795;s:12:\"delete-16558\";i:17796;s:12:\"delete-16559\";i:17797;s:12:\"delete-16560\";i:17798;s:12:\"delete-16561\";i:17799;s:12:\"delete-16562\";i:17800;s:12:\"delete-16563\";i:17801;s:12:\"delete-16564\";i:17802;s:12:\"delete-16565\";i:17803;s:12:\"delete-16566\";i:17804;s:12:\"delete-16567\";i:17805;s:12:\"delete-16568\";i:17806;s:12:\"delete-16569\";i:17807;s:12:\"delete-16570\";i:17808;s:12:\"delete-16571\";i:17809;s:12:\"delete-16572\";i:17810;s:12:\"delete-16573\";i:17811;s:12:\"delete-16574\";i:17812;s:12:\"delete-16575\";i:17813;s:12:\"delete-16576\";i:17814;s:12:\"delete-16577\";i:17815;s:12:\"delete-16578\";i:17816;s:12:\"delete-16579\";i:17817;s:12:\"delete-16580\";i:17818;s:12:\"delete-16581\";i:17819;s:12:\"delete-16582\";i:17820;s:12:\"delete-16583\";i:17821;s:12:\"delete-16584\";i:17822;s:12:\"delete-16585\";i:17823;s:12:\"delete-16586\";i:17824;s:12:\"delete-16587\";i:17825;s:12:\"delete-16588\";i:17826;s:12:\"delete-16589\";i:17827;s:12:\"delete-16590\";i:17828;s:12:\"delete-16591\";i:17829;s:12:\"delete-16592\";i:17830;s:12:\"delete-16593\";i:17831;s:12:\"delete-16594\";i:17832;s:12:\"delete-16595\";i:17833;s:12:\"delete-16596\";i:17834;s:12:\"delete-16597\";i:17835;s:12:\"delete-16598\";i:17836;s:12:\"delete-16599\";i:17837;s:12:\"delete-16600\";i:17838;s:12:\"delete-16601\";i:17839;s:12:\"delete-16602\";i:17840;s:12:\"delete-16603\";i:17841;s:12:\"delete-16604\";i:17842;s:12:\"delete-16605\";i:17843;s:12:\"delete-16606\";i:17844;s:12:\"delete-16607\";i:17845;s:12:\"delete-16608\";i:17846;s:12:\"delete-16609\";i:17847;s:12:\"delete-16610\";i:17848;s:12:\"delete-16611\";i:17849;s:12:\"delete-16612\";i:17850;s:12:\"delete-16613\";i:17851;s:12:\"delete-16614\";i:17852;s:12:\"delete-16615\";i:17853;s:12:\"delete-16616\";i:17854;s:12:\"delete-16617\";i:17855;s:12:\"delete-16618\";i:17856;s:12:\"delete-16619\";i:17857;s:12:\"delete-16620\";i:17858;s:12:\"delete-16621\";i:17859;s:12:\"delete-16622\";i:17860;s:12:\"delete-16623\";i:17861;s:12:\"delete-16624\";i:17862;s:12:\"delete-16625\";i:17863;s:12:\"delete-16626\";i:17864;s:12:\"delete-16627\";i:17865;s:12:\"delete-16628\";i:17866;s:12:\"delete-16629\";i:17867;s:12:\"delete-16630\";i:17868;s:12:\"delete-16631\";i:17869;s:12:\"delete-16632\";i:17870;s:12:\"delete-16633\";i:17871;s:12:\"delete-16634\";i:17872;s:12:\"delete-16635\";i:17873;s:12:\"delete-16636\";i:17874;s:12:\"delete-16637\";i:17875;s:12:\"delete-16638\";i:17876;s:12:\"delete-16639\";i:17877;s:12:\"delete-16640\";i:17878;s:12:\"delete-16641\";i:17879;s:12:\"delete-16642\";i:17880;s:12:\"delete-16643\";i:17881;s:12:\"delete-16644\";i:17882;s:12:\"delete-16645\";i:17883;s:12:\"delete-16646\";i:17884;s:12:\"delete-16647\";i:17885;s:12:\"delete-16648\";i:17886;s:12:\"delete-16649\";i:17887;s:12:\"delete-16650\";i:17888;s:12:\"delete-16651\";i:17889;s:12:\"delete-16652\";i:17890;s:12:\"delete-16653\";i:17891;s:12:\"delete-16654\";i:17892;s:12:\"delete-16655\";i:17893;s:12:\"delete-16656\";i:17894;s:12:\"delete-16657\";i:17895;s:12:\"delete-16658\";i:17896;s:12:\"delete-16659\";i:17897;s:12:\"delete-16660\";i:17898;s:12:\"delete-16661\";i:17899;s:12:\"delete-16662\";i:17900;s:12:\"delete-16663\";i:17901;s:12:\"delete-16664\";i:17902;s:12:\"delete-16665\";i:17903;s:12:\"delete-16666\";i:17904;s:12:\"delete-16667\";i:17905;s:12:\"delete-16668\";i:17906;s:12:\"delete-16669\";i:17907;s:12:\"delete-16670\";i:17908;s:12:\"delete-16671\";i:17909;s:12:\"delete-16672\";i:17910;s:12:\"delete-16673\";i:17911;s:12:\"delete-16674\";i:17912;s:12:\"delete-16675\";i:17913;s:12:\"delete-16676\";i:17914;s:12:\"delete-16677\";i:17915;s:12:\"delete-16678\";i:17916;s:12:\"delete-16679\";i:17917;s:12:\"delete-16680\";i:17918;s:12:\"delete-16681\";i:17919;s:12:\"delete-16682\";i:17920;s:12:\"delete-16683\";i:17921;s:12:\"delete-16684\";i:17922;s:12:\"delete-16685\";i:17923;s:12:\"delete-16686\";i:17924;s:12:\"delete-16687\";i:17925;s:12:\"delete-16688\";i:17926;s:12:\"delete-16689\";i:17927;s:12:\"delete-16690\";i:17928;s:12:\"delete-16691\";i:17929;s:12:\"delete-16692\";i:17930;s:12:\"delete-16693\";i:17931;s:12:\"delete-16694\";i:17932;s:12:\"delete-16695\";i:17933;s:12:\"delete-16696\";i:17934;s:12:\"delete-16697\";i:17935;s:12:\"delete-16698\";i:17936;s:12:\"delete-16699\";i:17937;s:12:\"delete-16700\";i:17938;s:12:\"delete-16701\";i:17939;s:12:\"delete-16702\";i:17940;s:12:\"delete-16703\";i:17941;s:12:\"delete-16704\";i:17942;s:12:\"delete-16705\";i:17943;s:12:\"delete-16706\";i:17944;s:12:\"delete-16707\";i:17945;s:12:\"delete-16708\";i:17946;s:12:\"delete-16709\";i:17947;s:12:\"delete-16710\";i:17948;s:12:\"delete-16711\";i:17949;s:12:\"delete-16712\";i:17950;s:12:\"delete-16713\";i:17951;s:12:\"delete-16714\";i:17952;s:12:\"delete-16715\";i:17953;s:12:\"delete-16716\";i:17954;s:12:\"delete-16717\";i:17955;s:12:\"delete-16718\";i:17956;s:12:\"delete-16719\";i:17957;s:12:\"delete-16720\";i:17958;s:12:\"delete-16721\";i:17959;s:12:\"delete-16722\";i:17960;s:12:\"delete-16723\";i:17961;s:12:\"delete-16724\";i:17962;s:12:\"delete-16725\";i:17963;s:12:\"delete-16726\";i:17964;s:12:\"delete-16727\";i:17965;s:12:\"delete-16728\";i:17966;s:12:\"delete-16729\";i:17967;s:12:\"delete-16730\";i:17968;s:12:\"delete-16731\";i:17969;s:12:\"delete-16732\";i:17970;s:12:\"delete-16733\";i:17971;s:12:\"delete-16734\";i:17972;s:12:\"delete-16735\";i:17973;s:12:\"delete-16736\";i:17974;s:12:\"delete-16737\";i:17975;s:12:\"delete-16738\";i:17976;s:12:\"delete-16739\";i:17977;s:12:\"delete-16740\";i:17978;s:12:\"delete-16741\";i:17979;s:12:\"delete-16742\";i:17980;s:12:\"delete-16743\";i:17981;s:12:\"delete-16744\";i:17982;s:12:\"delete-16745\";i:17983;s:12:\"delete-16746\";i:17984;s:12:\"delete-16747\";i:17985;s:12:\"delete-16748\";i:17986;s:12:\"delete-16749\";i:17987;s:12:\"delete-16750\";i:17988;s:12:\"delete-16751\";i:17989;s:12:\"delete-16752\";i:17990;s:12:\"delete-16753\";i:17991;s:12:\"delete-16754\";i:17992;s:12:\"delete-16755\";i:17993;s:12:\"delete-16756\";i:17994;s:12:\"delete-16757\";i:17995;s:12:\"delete-16758\";i:17996;s:12:\"delete-16759\";i:17997;s:12:\"delete-16760\";i:17998;s:12:\"delete-16761\";i:17999;s:12:\"delete-16762\";i:18000;s:12:\"delete-16763\";i:18001;s:12:\"delete-16764\";i:18002;s:12:\"delete-16765\";i:18003;s:12:\"delete-16766\";i:18004;s:12:\"delete-16767\";i:18005;s:12:\"delete-16768\";i:18006;s:12:\"delete-16769\";i:18007;s:12:\"delete-16770\";i:18008;s:12:\"delete-16771\";i:18009;s:12:\"delete-16772\";i:18010;s:12:\"delete-16773\";i:18011;s:12:\"delete-16774\";i:18012;s:12:\"delete-16775\";i:18013;s:12:\"delete-16776\";i:18014;s:12:\"delete-16777\";i:18015;s:12:\"delete-16778\";i:18016;s:12:\"delete-16779\";i:18017;s:12:\"delete-16780\";i:18018;s:12:\"delete-16781\";i:18019;s:12:\"delete-16782\";i:18020;s:12:\"delete-16783\";i:18021;s:12:\"delete-16784\";i:18022;s:12:\"delete-16785\";i:18023;s:12:\"delete-16786\";i:18024;s:12:\"delete-16787\";i:18025;s:12:\"delete-16788\";i:18026;s:12:\"delete-16789\";i:18027;s:12:\"delete-16790\";i:18028;s:12:\"delete-16791\";i:18029;s:12:\"delete-16792\";i:18030;s:12:\"delete-16793\";i:18031;s:12:\"delete-16794\";i:18032;s:12:\"delete-16795\";i:18033;s:12:\"delete-16796\";i:18034;s:12:\"delete-16797\";i:18035;s:12:\"delete-16798\";i:18036;s:12:\"delete-16799\";i:18037;s:12:\"delete-16800\";i:18038;s:12:\"delete-16801\";i:18039;s:12:\"delete-16802\";i:18040;s:12:\"delete-16803\";i:18041;s:12:\"delete-16804\";i:18042;s:12:\"delete-16805\";i:18043;s:12:\"delete-16806\";i:18044;s:12:\"delete-16807\";i:18045;s:12:\"delete-16808\";i:18046;s:12:\"delete-16809\";i:18047;s:12:\"delete-16810\";i:18048;s:12:\"delete-16811\";i:18049;s:12:\"delete-16812\";i:18050;s:12:\"delete-16813\";i:18051;s:12:\"delete-16814\";i:18052;s:12:\"delete-16815\";i:18053;s:12:\"delete-16816\";i:18054;s:12:\"delete-16817\";i:18055;s:12:\"delete-16818\";i:18056;s:12:\"delete-16819\";i:18057;s:12:\"delete-16820\";i:18058;s:12:\"delete-16821\";i:18059;s:12:\"delete-16822\";i:18060;s:12:\"delete-16823\";i:18061;s:12:\"delete-16824\";i:18062;s:12:\"delete-16825\";i:18063;s:12:\"delete-16826\";i:18064;s:12:\"delete-16827\";i:18065;s:12:\"delete-16828\";i:18066;s:12:\"delete-16829\";i:18067;s:12:\"delete-16830\";i:18068;s:12:\"delete-16831\";i:18069;s:12:\"delete-16832\";i:18070;s:12:\"delete-16833\";i:18071;s:12:\"delete-16834\";i:18072;s:12:\"delete-16835\";i:18073;s:12:\"delete-16836\";i:18074;s:12:\"delete-16837\";i:18075;s:12:\"delete-16838\";i:18076;s:12:\"delete-16839\";i:18077;s:12:\"delete-16840\";i:18078;s:12:\"delete-16841\";i:18079;s:12:\"delete-16842\";i:18080;s:12:\"delete-16843\";i:18081;s:12:\"delete-16844\";i:18082;s:12:\"delete-16845\";i:18083;s:12:\"delete-16846\";i:18084;s:12:\"delete-16847\";i:18085;s:12:\"delete-16848\";i:18086;s:12:\"delete-16849\";i:18087;s:12:\"delete-16850\";i:18088;s:12:\"delete-16851\";i:18089;s:12:\"delete-16852\";i:18090;s:12:\"delete-16853\";i:18091;s:12:\"delete-16854\";i:18092;s:12:\"delete-16855\";i:18093;s:12:\"delete-16856\";i:18094;s:12:\"delete-16857\";i:18095;s:12:\"delete-16858\";i:18096;s:12:\"delete-16859\";i:18097;s:12:\"delete-16860\";i:18098;s:12:\"delete-16861\";i:18099;s:12:\"delete-16862\";i:18100;s:12:\"delete-16863\";i:18101;s:12:\"delete-16864\";i:18102;s:12:\"delete-16865\";i:18103;s:12:\"delete-16866\";i:18104;s:12:\"delete-16867\";i:18105;s:12:\"delete-16868\";i:18106;s:12:\"delete-16869\";i:18107;s:12:\"delete-16870\";i:18108;s:12:\"delete-16871\";i:18109;s:12:\"delete-16872\";i:18110;s:12:\"delete-16873\";i:18111;s:12:\"delete-16874\";i:18112;s:12:\"delete-16875\";i:18113;s:12:\"delete-16876\";i:18114;s:12:\"delete-16877\";i:18115;s:12:\"delete-16878\";i:18116;s:12:\"delete-16879\";i:18117;s:12:\"delete-16880\";i:18118;s:12:\"delete-16881\";i:18119;s:12:\"delete-16882\";i:18120;s:12:\"delete-16883\";i:18121;s:12:\"delete-16884\";i:18122;s:12:\"delete-16885\";i:18123;s:12:\"delete-16886\";i:18124;s:12:\"delete-16887\";i:18125;s:12:\"delete-16888\";i:18126;s:12:\"delete-16889\";i:18127;s:12:\"delete-16890\";i:18128;s:12:\"delete-16891\";i:18129;s:12:\"delete-16892\";i:18130;s:12:\"delete-16893\";i:18131;s:12:\"delete-16894\";i:18132;s:12:\"delete-16895\";i:18133;s:12:\"delete-16896\";i:18134;s:12:\"delete-16897\";i:18135;s:12:\"delete-16898\";i:18136;s:12:\"delete-16899\";i:18137;s:12:\"delete-16900\";i:18138;s:12:\"delete-16901\";i:18139;s:12:\"delete-16902\";i:18140;s:12:\"delete-16903\";i:18141;s:12:\"delete-16904\";i:18142;s:12:\"delete-16905\";i:18143;s:12:\"delete-16906\";i:18144;s:12:\"delete-16907\";i:18145;s:12:\"delete-16908\";i:18146;s:12:\"delete-16909\";i:18147;s:12:\"delete-16910\";i:18148;s:12:\"delete-16911\";i:18149;s:12:\"delete-16912\";i:18150;s:12:\"delete-16913\";i:18151;s:12:\"delete-16914\";i:18152;s:12:\"delete-16915\";i:18153;s:12:\"delete-16916\";i:18154;s:12:\"delete-16917\";i:18155;s:12:\"delete-16918\";i:18156;s:12:\"delete-16919\";i:18157;s:12:\"delete-16920\";i:18158;s:12:\"delete-16921\";i:18159;s:12:\"delete-16922\";i:18160;s:12:\"delete-16923\";i:18161;s:12:\"delete-16924\";i:18162;s:12:\"delete-16925\";i:18163;s:12:\"delete-16926\";i:18164;s:12:\"delete-16927\";i:18165;s:12:\"delete-16928\";i:18166;s:12:\"delete-16929\";i:18167;s:12:\"delete-16930\";i:18168;s:12:\"delete-16931\";i:18169;s:12:\"delete-16932\";i:18170;s:12:\"delete-16933\";i:18171;s:12:\"delete-16934\";i:18172;s:12:\"delete-16935\";i:18173;s:12:\"delete-16936\";i:18174;s:12:\"delete-16937\";i:18175;s:12:\"delete-16938\";i:18176;s:12:\"delete-16939\";i:18177;s:12:\"delete-16940\";i:18178;s:12:\"delete-16941\";i:18179;s:12:\"delete-16942\";i:18180;s:12:\"delete-16943\";i:18181;s:12:\"delete-16944\";i:18182;s:12:\"delete-16945\";i:18183;s:12:\"delete-16946\";i:18184;s:12:\"delete-16947\";i:18185;s:12:\"delete-16948\";i:18186;s:12:\"delete-16949\";i:18187;s:12:\"delete-16950\";i:18188;s:12:\"delete-16951\";i:18189;s:12:\"delete-16952\";i:18190;s:12:\"delete-16953\";i:18191;s:12:\"delete-16954\";i:18192;s:12:\"delete-16955\";i:18193;s:12:\"delete-16956\";i:18194;s:12:\"delete-16957\";i:18195;s:12:\"delete-16958\";i:18196;s:12:\"delete-16959\";i:18197;s:12:\"delete-16960\";i:18198;s:12:\"delete-16961\";i:18199;s:12:\"delete-16962\";i:18200;s:12:\"delete-16963\";i:18201;s:12:\"delete-16964\";i:18202;s:12:\"delete-16965\";i:18203;s:12:\"delete-16966\";i:18204;s:12:\"delete-16967\";i:18205;s:12:\"delete-16968\";i:18206;s:12:\"delete-16969\";i:18207;s:12:\"delete-16970\";i:18208;s:12:\"delete-16971\";i:18209;s:12:\"delete-16972\";i:18210;s:12:\"delete-16973\";i:18211;s:12:\"delete-16974\";i:18212;s:12:\"delete-16975\";i:18213;s:12:\"delete-16976\";i:18214;s:12:\"delete-16977\";i:18215;s:12:\"delete-16978\";i:18216;s:12:\"delete-16979\";i:18217;s:12:\"delete-16980\";i:18218;s:12:\"delete-16981\";i:18219;s:12:\"delete-16982\";i:18220;s:12:\"delete-16983\";i:18221;s:12:\"delete-16984\";i:18222;s:12:\"delete-16985\";i:18223;s:12:\"delete-16986\";i:18224;s:12:\"delete-16987\";i:18225;s:12:\"delete-16988\";i:18226;s:12:\"delete-16989\";i:18227;s:12:\"delete-16990\";i:18228;s:12:\"delete-16991\";i:18229;s:12:\"delete-16992\";i:18230;s:12:\"delete-16993\";i:18231;s:12:\"delete-16994\";i:18232;s:12:\"delete-16995\";i:18233;s:12:\"delete-16996\";i:18234;s:12:\"delete-16997\";i:18235;s:12:\"delete-16998\";i:18236;s:12:\"delete-16999\";i:18237;s:12:\"delete-17000\";i:18238;s:12:\"delete-17001\";i:18239;s:12:\"delete-17002\";i:18240;s:12:\"delete-17003\";i:18241;s:12:\"delete-17004\";i:18242;s:12:\"delete-17005\";i:18243;s:12:\"delete-17006\";i:18244;s:12:\"delete-17007\";i:18245;s:12:\"delete-17008\";i:18246;s:12:\"delete-17009\";i:18247;s:12:\"delete-17010\";i:18248;s:12:\"delete-17011\";i:18249;s:12:\"delete-17012\";i:18250;s:12:\"delete-17013\";i:18251;s:12:\"delete-17014\";i:18252;s:12:\"delete-17015\";i:18253;s:12:\"delete-17016\";i:18254;s:12:\"delete-17017\";i:18255;s:12:\"delete-17018\";i:18256;s:12:\"delete-17019\";i:18257;s:12:\"delete-17020\";i:18258;s:12:\"delete-17021\";i:18259;s:12:\"delete-17022\";i:18260;s:12:\"delete-17023\";i:18261;s:12:\"delete-17024\";i:18262;s:12:\"delete-17025\";i:18263;s:12:\"delete-17026\";i:18264;s:12:\"delete-17027\";i:18265;s:12:\"delete-17028\";i:18266;s:12:\"delete-17029\";i:18267;s:12:\"delete-17030\";i:18268;s:12:\"delete-17031\";i:18269;s:12:\"delete-17032\";i:18270;s:12:\"delete-17033\";i:18271;s:12:\"delete-17034\";i:18272;s:12:\"delete-17035\";i:18273;s:12:\"delete-17036\";i:18274;s:12:\"delete-17037\";i:18275;s:12:\"delete-17038\";i:18276;s:12:\"delete-17039\";i:18277;s:12:\"delete-17040\";i:18278;s:12:\"delete-17041\";i:18279;s:12:\"delete-17042\";i:18280;s:12:\"delete-17043\";i:18281;s:12:\"delete-17044\";i:18282;s:12:\"delete-17045\";i:18283;s:12:\"delete-17046\";i:18284;s:12:\"delete-17047\";i:18285;s:12:\"delete-17048\";i:18286;s:12:\"delete-17049\";i:18287;s:12:\"delete-17050\";i:18288;s:12:\"delete-17051\";i:18289;s:12:\"delete-17052\";i:18290;s:12:\"delete-17053\";i:18291;s:12:\"delete-17054\";i:18292;s:12:\"delete-17055\";i:18293;s:12:\"delete-17056\";i:18294;s:12:\"delete-17057\";i:18295;s:12:\"delete-17058\";i:18296;s:12:\"delete-17059\";i:18297;s:12:\"delete-17060\";i:18298;s:12:\"delete-17061\";i:18299;s:12:\"delete-17062\";i:18300;s:12:\"delete-17063\";i:18301;s:12:\"delete-17064\";i:18302;s:12:\"delete-17065\";i:18303;s:12:\"delete-17066\";i:18304;s:12:\"delete-17067\";i:18305;s:12:\"delete-17068\";i:18306;s:12:\"delete-17069\";i:18307;s:12:\"delete-17070\";i:18308;s:12:\"delete-17071\";i:18309;s:12:\"delete-17072\";i:18310;s:12:\"delete-17073\";i:18311;s:12:\"delete-17074\";i:18312;s:12:\"delete-17075\";i:18313;s:12:\"delete-17076\";i:18314;s:12:\"delete-17077\";i:18315;s:12:\"delete-17078\";i:18316;s:12:\"delete-17079\";i:18317;s:12:\"delete-17080\";i:18318;s:12:\"delete-17081\";i:18319;s:12:\"delete-17082\";i:18320;s:12:\"delete-17083\";i:18321;s:12:\"delete-17084\";i:18322;s:12:\"delete-17085\";i:18323;s:12:\"delete-17086\";i:18324;s:12:\"delete-17087\";i:18325;s:12:\"delete-17088\";i:18326;s:12:\"delete-17089\";i:18327;s:12:\"delete-17090\";i:18328;s:12:\"delete-17091\";i:18329;s:12:\"delete-17092\";i:18330;s:12:\"delete-17093\";i:18331;s:12:\"delete-17094\";i:18332;s:12:\"delete-17095\";i:18333;s:12:\"delete-17096\";i:18334;s:12:\"delete-17097\";i:18335;s:12:\"delete-17098\";i:18336;s:12:\"delete-17099\";i:18337;s:12:\"delete-17100\";i:18338;s:12:\"delete-17101\";i:18339;s:12:\"delete-17102\";i:18340;s:12:\"delete-17103\";i:18341;s:12:\"delete-17104\";i:18342;s:12:\"delete-17105\";i:18343;s:12:\"delete-17106\";i:18344;s:12:\"delete-17107\";i:18345;s:12:\"delete-17108\";i:18346;s:12:\"delete-17109\";i:18347;s:12:\"delete-17110\";i:18348;s:12:\"delete-17111\";i:18349;s:12:\"delete-17112\";i:18350;s:12:\"delete-17113\";i:18351;s:12:\"delete-17114\";i:18352;s:12:\"delete-17115\";i:18353;s:12:\"delete-17116\";i:18354;s:12:\"delete-17117\";i:18355;s:12:\"delete-17118\";i:18356;s:12:\"delete-17119\";i:18357;s:12:\"delete-17120\";i:18358;s:12:\"delete-17121\";i:18359;s:12:\"delete-17122\";i:18360;s:12:\"delete-17123\";i:18361;s:12:\"delete-17124\";i:18362;s:12:\"delete-17125\";i:18363;s:12:\"delete-17126\";i:18364;s:12:\"delete-17127\";i:18365;s:12:\"delete-17128\";i:18366;s:12:\"delete-17129\";i:18367;s:12:\"delete-17130\";i:18368;s:12:\"delete-17131\";i:18369;s:12:\"delete-17132\";i:18370;s:12:\"delete-17133\";i:18371;s:12:\"delete-17134\";i:18372;s:12:\"delete-17135\";i:18373;s:12:\"delete-17136\";i:18374;s:12:\"delete-17137\";i:18375;s:12:\"delete-17138\";i:18376;s:12:\"delete-17139\";i:18377;s:12:\"delete-17140\";i:18378;s:12:\"delete-17141\";i:18379;s:12:\"delete-17142\";i:18380;s:12:\"delete-17143\";i:18381;s:12:\"delete-17144\";i:18382;s:12:\"delete-17145\";i:18383;s:12:\"delete-17146\";i:18384;s:12:\"delete-17147\";i:18385;s:12:\"delete-17148\";i:18386;s:12:\"delete-17149\";i:18387;s:12:\"delete-17150\";i:18388;s:12:\"delete-17151\";i:18389;s:12:\"delete-17152\";i:18390;s:12:\"delete-17153\";i:18391;s:12:\"delete-17154\";i:18392;s:12:\"delete-17155\";i:18393;s:12:\"delete-17156\";i:18394;s:12:\"delete-17157\";i:18395;s:12:\"delete-17158\";i:18396;s:12:\"delete-17159\";i:18397;s:12:\"delete-17160\";i:18398;s:12:\"delete-17161\";i:18399;s:12:\"delete-17162\";i:18400;s:12:\"delete-17163\";i:18401;s:12:\"delete-17164\";i:18402;s:12:\"delete-17165\";i:18403;s:12:\"delete-17166\";i:18404;s:12:\"delete-17167\";i:18405;s:12:\"delete-17168\";i:18406;s:12:\"delete-17169\";i:18407;s:12:\"delete-17170\";i:18408;s:12:\"delete-17171\";i:18409;s:12:\"delete-17172\";i:18410;s:12:\"delete-17173\";i:18411;s:12:\"delete-17174\";i:18412;s:12:\"delete-17175\";i:18413;s:12:\"delete-17176\";i:18414;s:12:\"delete-17177\";i:18415;s:12:\"delete-17178\";i:18416;s:12:\"delete-17179\";i:18417;s:12:\"delete-17180\";i:18418;s:12:\"delete-17181\";i:18419;s:12:\"delete-17182\";i:18420;s:12:\"delete-17183\";i:18421;s:12:\"delete-17184\";i:18422;s:12:\"delete-17185\";i:18423;s:12:\"delete-17186\";i:18424;s:12:\"delete-17187\";i:18425;s:12:\"delete-17188\";i:18426;s:12:\"delete-17189\";i:18427;s:12:\"delete-17190\";i:18428;s:12:\"delete-17191\";i:18429;s:12:\"delete-17192\";i:18430;s:12:\"delete-17193\";i:18431;s:12:\"delete-17194\";i:18432;s:12:\"delete-17195\";i:18433;s:12:\"delete-17196\";i:18434;s:12:\"delete-17197\";i:18435;s:12:\"delete-17198\";i:18436;s:12:\"delete-17199\";i:18437;s:12:\"delete-17200\";i:18438;s:12:\"delete-17201\";i:18439;s:12:\"delete-17202\";i:18440;s:12:\"delete-17203\";i:18441;s:12:\"delete-17204\";i:18442;s:12:\"delete-17205\";i:18443;s:12:\"delete-17206\";i:18444;s:12:\"delete-17207\";i:18445;s:12:\"delete-17208\";i:18446;s:12:\"delete-17209\";i:18447;s:12:\"delete-17210\";i:18448;s:12:\"delete-17211\";i:18449;s:12:\"delete-17212\";i:18450;s:12:\"delete-17213\";i:18451;s:12:\"delete-17214\";i:18452;s:12:\"delete-17215\";i:18453;s:12:\"delete-17216\";i:18454;s:12:\"delete-17217\";i:18455;s:12:\"delete-17218\";i:18456;s:12:\"delete-17219\";i:18457;s:12:\"delete-17220\";i:18458;s:12:\"delete-17221\";i:18459;s:12:\"delete-17222\";i:18460;s:12:\"delete-17223\";i:18461;s:12:\"delete-17224\";i:18462;s:12:\"delete-17225\";i:18463;s:12:\"delete-17226\";i:18464;s:12:\"delete-17227\";i:18465;s:12:\"delete-17228\";i:18466;s:12:\"delete-17229\";i:18467;s:12:\"delete-17230\";i:18468;s:12:\"delete-17231\";i:18469;s:12:\"delete-17232\";i:18470;s:12:\"delete-17233\";i:18471;s:12:\"delete-17234\";i:18472;s:12:\"delete-17235\";i:18473;s:12:\"delete-17236\";i:18474;s:12:\"delete-17237\";i:18475;s:12:\"delete-17238\";i:18476;s:12:\"delete-17239\";i:18477;s:12:\"delete-17240\";i:18478;s:12:\"delete-17241\";i:18479;s:12:\"delete-17242\";i:18480;s:12:\"delete-17243\";i:18481;s:12:\"delete-17244\";i:18482;s:12:\"delete-17245\";i:18483;s:12:\"delete-17246\";i:18484;s:12:\"delete-17247\";i:18485;s:12:\"delete-17248\";i:18486;s:12:\"delete-17249\";i:18487;s:12:\"delete-17250\";i:18488;s:12:\"delete-17251\";i:18489;s:12:\"delete-17252\";i:18490;s:12:\"delete-17253\";i:18491;s:12:\"delete-17254\";i:18492;s:12:\"delete-17255\";i:18493;s:12:\"delete-17256\";i:18494;s:12:\"delete-17257\";i:18495;s:12:\"delete-17258\";i:18496;s:12:\"delete-17259\";i:18497;s:12:\"delete-17260\";i:18498;s:12:\"delete-17261\";i:18499;s:12:\"delete-17262\";i:18500;s:12:\"delete-17263\";i:18501;s:12:\"delete-17264\";i:18502;s:12:\"delete-17265\";i:18503;s:12:\"delete-17266\";i:18504;s:12:\"delete-17267\";i:18505;s:12:\"delete-17268\";i:18506;s:12:\"delete-17269\";i:18507;s:12:\"delete-17270\";i:18508;s:12:\"delete-17271\";i:18509;s:12:\"delete-17272\";i:18510;s:12:\"delete-17273\";i:18511;s:12:\"delete-17274\";i:18512;s:12:\"delete-17275\";i:18513;s:12:\"delete-17276\";i:18514;s:12:\"delete-17277\";i:18515;s:12:\"delete-17278\";i:18516;s:12:\"delete-17279\";i:18517;s:12:\"delete-17280\";i:18518;s:12:\"delete-17281\";i:18519;s:12:\"delete-17282\";i:18520;s:12:\"delete-17283\";i:18521;s:12:\"delete-17284\";i:18522;s:12:\"delete-17285\";i:18523;s:12:\"delete-17286\";i:18524;s:12:\"delete-17287\";i:18525;s:12:\"delete-17288\";i:18526;s:12:\"delete-17289\";i:18527;s:12:\"delete-17290\";i:18528;s:12:\"delete-17291\";i:18529;s:12:\"delete-17292\";i:18530;s:12:\"delete-17293\";i:18531;s:12:\"delete-17294\";i:18532;s:12:\"delete-17295\";i:18533;s:12:\"delete-17296\";i:18534;s:12:\"delete-17297\";i:18535;s:12:\"delete-17298\";i:18536;s:12:\"delete-17299\";i:18537;s:12:\"delete-17300\";i:18538;s:12:\"delete-17301\";i:18539;s:12:\"delete-17302\";i:18540;s:12:\"delete-17303\";i:18541;s:12:\"delete-17304\";i:18542;s:12:\"delete-17305\";i:18543;s:12:\"delete-17306\";i:18544;s:12:\"delete-17307\";i:18545;s:12:\"delete-17308\";i:18546;s:12:\"delete-17309\";i:18547;s:12:\"delete-17310\";i:18548;s:12:\"delete-17311\";i:18549;s:12:\"delete-17312\";i:18550;s:12:\"delete-17313\";i:18551;s:12:\"delete-17314\";i:18552;s:12:\"delete-17315\";i:18553;s:12:\"delete-17316\";i:18554;s:12:\"delete-17317\";i:18555;s:12:\"delete-17318\";i:18556;s:12:\"delete-17319\";i:18557;s:12:\"delete-17320\";i:18558;s:12:\"delete-17321\";i:18559;s:12:\"delete-17322\";i:18560;s:12:\"delete-17323\";i:18561;s:12:\"delete-17324\";i:18562;s:12:\"delete-17325\";i:18563;s:12:\"delete-17326\";i:18564;s:12:\"delete-17327\";i:18565;s:12:\"delete-17328\";i:18566;s:12:\"delete-17329\";i:18567;s:12:\"delete-17330\";i:18568;s:12:\"delete-17331\";i:18569;s:12:\"delete-17332\";i:18570;s:12:\"delete-17333\";i:18571;s:12:\"delete-17334\";i:18572;s:12:\"delete-17335\";i:18573;s:12:\"delete-17336\";i:18574;s:12:\"delete-17337\";i:18575;s:12:\"delete-17338\";i:18576;s:12:\"delete-17339\";i:18577;s:12:\"delete-17340\";i:18578;s:12:\"delete-17341\";i:18579;s:12:\"delete-17342\";i:18580;s:12:\"delete-17343\";i:18581;s:12:\"delete-17344\";i:18582;s:12:\"delete-17345\";i:18583;s:12:\"delete-17346\";i:18584;s:12:\"delete-17347\";i:18585;s:12:\"delete-17348\";i:18586;s:12:\"delete-17349\";i:18587;s:12:\"delete-17350\";i:18588;s:12:\"delete-17351\";i:18589;s:12:\"delete-17352\";i:18590;s:12:\"delete-17353\";i:18591;s:12:\"delete-17354\";i:18592;s:12:\"delete-17355\";i:18593;s:12:\"delete-17356\";i:18594;s:12:\"delete-17357\";i:18595;s:12:\"delete-17358\";i:18596;s:12:\"delete-17359\";i:18597;s:12:\"delete-17360\";i:18598;s:12:\"delete-17361\";i:18599;s:12:\"delete-17362\";i:18600;s:12:\"delete-17363\";i:18601;s:12:\"delete-17364\";i:18602;s:12:\"delete-17365\";i:18603;s:12:\"delete-17366\";i:18604;s:12:\"delete-17367\";i:18605;s:12:\"delete-17368\";i:18606;s:12:\"delete-17369\";i:18607;s:12:\"delete-17370\";i:18608;s:12:\"delete-17371\";i:18609;s:12:\"delete-17372\";i:18610;s:12:\"delete-17373\";i:18611;s:12:\"delete-17374\";i:18612;s:12:\"delete-17375\";i:18613;s:12:\"delete-17376\";i:18614;s:12:\"delete-17377\";i:18615;s:12:\"delete-17378\";i:18616;s:12:\"delete-17379\";i:18617;s:12:\"delete-17380\";i:18618;s:12:\"delete-17381\";i:18619;s:12:\"delete-17382\";i:18620;s:12:\"delete-17383\";i:18621;s:12:\"delete-17384\";i:18622;s:12:\"delete-17385\";i:18623;s:12:\"delete-17386\";i:18624;s:12:\"delete-17387\";i:18625;s:12:\"delete-17388\";i:18626;s:12:\"delete-17389\";i:18627;s:12:\"delete-17390\";i:18628;s:12:\"delete-17391\";i:18629;s:12:\"delete-17392\";i:18630;s:12:\"delete-17393\";i:18631;s:12:\"delete-17394\";i:18632;s:12:\"delete-17395\";i:18633;s:12:\"delete-17396\";i:18634;s:12:\"delete-17397\";i:18635;s:12:\"delete-17398\";i:18636;s:12:\"delete-17399\";i:18637;s:12:\"delete-17400\";i:18638;s:12:\"delete-17401\";i:18639;s:12:\"delete-17402\";i:18640;s:12:\"delete-17403\";i:18641;s:12:\"delete-17404\";i:18642;s:12:\"delete-17405\";i:18643;s:12:\"delete-17406\";i:18644;s:12:\"delete-17407\";i:18645;s:12:\"delete-17408\";i:18646;s:12:\"delete-17409\";i:18647;s:12:\"delete-17410\";i:18648;s:12:\"delete-17411\";i:18649;s:12:\"delete-17412\";i:18650;s:12:\"delete-17413\";i:18651;s:12:\"delete-17414\";i:18652;s:12:\"delete-17415\";i:18653;s:12:\"delete-17416\";i:18654;s:12:\"delete-17417\";i:18655;s:12:\"delete-17418\";i:18656;s:12:\"delete-17419\";i:18657;s:12:\"delete-17420\";i:18658;s:12:\"delete-17421\";i:18659;s:12:\"delete-17422\";i:18660;s:12:\"delete-17423\";i:18661;s:12:\"delete-17424\";i:18662;s:12:\"delete-17425\";i:18663;s:12:\"delete-17426\";i:18664;s:12:\"delete-17427\";i:18665;s:12:\"delete-17428\";i:18666;s:12:\"delete-17429\";i:18667;s:12:\"delete-17430\";i:18668;s:12:\"delete-17431\";i:18669;s:12:\"delete-17432\";i:18670;s:12:\"delete-17433\";i:18671;s:12:\"delete-17434\";i:18672;s:12:\"delete-17435\";i:18673;s:12:\"delete-17436\";i:18674;s:12:\"delete-17437\";i:18675;s:12:\"delete-17438\";i:18676;s:12:\"delete-17439\";i:18677;s:12:\"delete-17440\";i:18678;s:12:\"delete-17441\";i:18679;s:12:\"delete-17442\";i:18680;s:12:\"delete-17443\";i:18681;s:12:\"delete-17444\";i:18682;s:12:\"delete-17445\";i:18683;s:12:\"delete-17446\";i:18684;s:12:\"delete-17447\";i:18685;s:12:\"delete-17448\";i:18686;s:12:\"delete-17449\";i:18687;s:12:\"delete-17450\";i:18688;s:12:\"delete-17451\";i:18689;s:12:\"delete-17452\";i:18690;s:12:\"delete-17453\";i:18691;s:12:\"delete-17454\";i:18692;s:12:\"delete-17455\";i:18693;s:12:\"delete-17456\";i:18694;s:12:\"delete-17457\";i:18695;s:12:\"delete-17458\";i:18696;s:12:\"delete-17459\";i:18697;s:12:\"delete-17460\";i:18698;s:12:\"delete-17461\";i:18699;s:12:\"delete-17462\";i:18700;s:12:\"delete-17463\";i:18701;s:12:\"delete-17464\";i:18702;s:12:\"delete-17465\";i:18703;s:12:\"delete-17466\";i:18704;s:12:\"delete-17467\";i:18705;s:12:\"delete-17468\";i:18706;s:12:\"delete-17469\";i:18707;s:12:\"delete-17470\";i:18708;s:12:\"delete-17471\";i:18709;s:12:\"delete-17472\";i:18710;s:12:\"delete-17473\";i:18711;s:12:\"delete-17474\";i:18712;s:12:\"delete-17475\";i:18713;s:12:\"delete-17476\";i:18714;s:12:\"delete-17477\";i:18715;s:12:\"delete-17478\";i:18716;s:12:\"delete-17479\";i:18717;s:12:\"delete-17480\";i:18718;s:12:\"delete-17481\";i:18719;s:12:\"delete-17482\";i:18720;s:12:\"delete-17483\";i:18721;s:12:\"delete-17484\";i:18722;s:12:\"delete-17485\";i:18723;s:12:\"delete-17486\";i:18724;s:12:\"delete-17487\";i:18725;s:12:\"delete-17488\";i:18726;s:12:\"delete-17489\";i:18727;s:12:\"delete-17490\";i:18728;s:12:\"delete-17491\";i:18729;s:12:\"delete-17492\";i:18730;s:12:\"delete-17493\";i:18731;s:12:\"delete-17494\";i:18732;s:12:\"delete-17495\";i:18733;s:12:\"delete-17496\";i:18734;s:12:\"delete-17497\";i:18735;s:12:\"delete-17498\";i:18736;s:12:\"delete-17499\";i:18737;s:12:\"delete-17500\";i:18738;s:12:\"delete-17501\";i:18739;s:12:\"delete-17503\";i:18740;s:12:\"delete-17502\";i:18741;s:12:\"delete-17504\";i:18742;s:12:\"delete-17505\";i:18743;s:12:\"delete-17507\";i:18744;s:12:\"delete-17506\";i:18745;s:12:\"delete-17508\";i:18746;s:12:\"delete-17509\";i:18747;s:12:\"delete-17511\";i:18748;s:12:\"delete-17510\";i:18749;s:12:\"delete-17512\";i:18750;s:12:\"delete-17513\";i:18751;s:12:\"delete-17515\";i:18752;s:12:\"delete-17514\";i:18753;s:12:\"delete-17516\";i:18754;s:12:\"delete-17517\";i:18755;s:12:\"delete-17519\";i:18756;s:12:\"delete-17518\";i:18757;s:12:\"delete-17520\";i:18758;s:12:\"delete-17521\";i:18759;s:12:\"delete-17523\";i:18760;s:12:\"delete-17522\";i:18761;s:12:\"delete-17524\";i:18762;s:12:\"delete-17525\";i:18763;s:12:\"delete-17527\";i:18764;s:12:\"delete-17526\";i:18765;s:12:\"delete-17528\";i:18766;s:12:\"delete-17529\";i:18767;s:12:\"delete-17531\";i:18768;s:12:\"delete-17530\";i:18769;s:12:\"delete-17532\";i:18770;s:12:\"delete-17533\";i:18771;s:12:\"delete-17535\";i:18772;s:12:\"delete-17534\";i:18773;s:12:\"delete-17536\";i:18774;s:12:\"delete-17537\";i:18775;s:12:\"delete-17539\";i:18776;s:12:\"delete-17538\";i:18777;s:12:\"delete-17540\";i:18778;s:12:\"delete-17541\";i:18779;s:12:\"delete-17543\";i:18780;s:12:\"delete-17542\";i:18781;s:12:\"delete-17544\";i:18782;s:12:\"delete-17545\";i:18783;s:12:\"delete-17547\";i:18784;s:12:\"delete-17546\";i:18785;s:12:\"delete-17548\";i:18786;s:12:\"delete-17549\";i:18787;s:12:\"delete-17551\";i:18788;s:12:\"delete-17550\";i:18789;s:12:\"delete-17552\";i:18790;s:12:\"delete-17553\";i:18791;s:12:\"delete-17555\";i:18792;s:12:\"delete-17554\";i:18793;s:12:\"delete-17556\";i:18794;s:12:\"delete-17557\";i:18795;s:12:\"delete-17559\";i:18796;s:12:\"delete-17558\";i:18797;s:12:\"delete-17560\";i:18798;s:12:\"delete-17561\";i:18799;s:12:\"delete-17563\";i:18800;s:12:\"delete-17562\";i:18801;s:12:\"delete-17564\";i:18802;s:12:\"delete-17565\";i:18803;s:12:\"delete-17567\";i:18804;s:12:\"delete-17566\";i:18805;s:12:\"delete-17568\";i:18806;s:12:\"delete-17569\";i:18807;s:12:\"delete-17571\";i:18808;s:12:\"delete-17570\";i:18809;s:12:\"delete-17572\";i:18810;s:12:\"delete-17573\";i:18811;s:12:\"delete-17575\";i:18812;s:12:\"delete-17574\";i:18813;s:12:\"delete-17576\";i:18814;s:12:\"delete-17577\";i:18815;s:12:\"delete-17579\";i:18816;s:12:\"delete-17578\";i:18817;s:12:\"delete-17580\";i:18818;s:12:\"delete-17581\";i:18819;s:12:\"delete-17583\";i:18820;s:12:\"delete-17582\";i:18821;s:12:\"delete-17584\";i:18822;s:12:\"delete-17585\";i:18823;s:12:\"delete-17587\";i:18824;s:12:\"delete-17586\";i:18825;s:12:\"delete-17588\";i:18826;s:12:\"delete-17589\";i:18827;s:12:\"delete-17591\";i:18828;s:12:\"delete-17590\";i:18829;s:12:\"delete-17592\";i:18830;s:12:\"delete-17593\";i:18831;s:12:\"delete-17595\";i:18832;s:12:\"delete-17594\";i:18833;s:12:\"delete-17596\";i:18834;s:12:\"delete-17597\";i:18835;s:12:\"delete-17599\";i:18836;s:12:\"delete-17598\";i:18837;s:12:\"delete-17600\";i:18838;s:12:\"delete-17601\";i:18839;s:12:\"delete-17603\";i:18840;s:12:\"delete-17602\";i:18841;s:12:\"delete-17604\";i:18842;s:12:\"delete-17605\";i:18843;s:12:\"delete-17607\";i:18844;s:12:\"delete-17606\";i:18845;s:12:\"delete-17608\";i:18846;s:12:\"delete-17609\";i:18847;s:12:\"delete-17611\";i:18848;s:12:\"delete-17610\";i:18849;s:12:\"delete-17612\";i:18850;s:12:\"delete-17613\";i:18851;s:12:\"delete-17615\";i:18852;s:12:\"delete-17614\";i:18853;s:12:\"delete-17616\";i:18854;s:12:\"delete-17617\";i:18855;s:12:\"delete-17619\";i:18856;s:12:\"delete-17618\";i:18857;s:12:\"delete-17620\";i:18858;s:12:\"delete-17621\";i:18859;s:12:\"delete-17623\";i:18860;s:12:\"delete-17622\";i:18861;s:12:\"delete-17624\";i:18862;s:12:\"delete-17625\";i:18863;s:12:\"delete-17627\";i:18864;s:12:\"delete-17626\";i:18865;s:12:\"delete-17628\";i:18866;s:12:\"delete-17629\";i:18867;s:12:\"delete-17631\";i:18868;s:12:\"delete-17630\";i:18869;s:12:\"delete-17632\";i:18870;s:12:\"delete-17633\";i:18871;s:12:\"delete-17635\";i:18872;s:12:\"delete-17634\";i:18873;s:12:\"delete-17636\";i:18874;s:12:\"delete-17637\";i:18875;s:12:\"delete-17639\";i:18876;s:12:\"delete-17638\";i:18877;s:12:\"delete-17640\";i:18878;s:12:\"delete-17641\";i:18879;s:12:\"delete-17643\";i:18880;s:12:\"delete-17642\";i:18881;s:12:\"delete-17644\";i:18882;s:12:\"delete-17645\";i:18883;s:12:\"delete-17647\";i:18884;s:12:\"delete-17646\";i:18885;s:12:\"delete-17648\";i:18886;s:12:\"delete-17649\";i:18887;s:12:\"delete-17651\";i:18888;s:12:\"delete-17650\";i:18889;s:12:\"delete-17652\";i:18890;s:12:\"delete-17653\";i:18891;s:12:\"delete-17655\";i:18892;s:12:\"delete-17654\";i:18893;s:12:\"delete-17656\";i:18894;s:12:\"delete-17657\";i:18895;s:12:\"delete-17659\";i:18896;s:12:\"delete-17658\";i:18897;s:12:\"delete-17660\";i:18898;s:12:\"delete-17661\";i:18899;s:12:\"delete-17663\";i:18900;s:12:\"delete-17662\";i:18901;s:12:\"delete-17664\";i:18902;s:12:\"delete-17665\";i:18903;s:12:\"delete-17667\";i:18904;s:12:\"delete-17666\";i:18905;s:12:\"delete-17668\";i:18906;s:12:\"delete-17669\";i:18907;s:12:\"delete-17671\";i:18908;s:12:\"delete-17670\";i:18909;s:12:\"delete-17672\";i:18910;s:12:\"delete-17673\";i:18911;s:12:\"delete-17675\";i:18912;s:12:\"delete-17674\";i:18913;s:12:\"delete-17676\";i:18914;s:12:\"delete-17677\";i:18915;s:12:\"delete-17679\";i:18916;s:12:\"delete-17678\";i:18917;s:12:\"delete-17680\";i:18918;s:12:\"delete-17681\";i:18919;s:12:\"delete-17683\";i:18920;s:12:\"delete-17682\";i:18921;s:12:\"delete-17684\";i:18922;s:12:\"delete-17685\";i:18923;s:12:\"delete-17687\";i:18924;s:12:\"delete-17686\";i:18925;s:12:\"delete-17688\";i:18926;s:12:\"delete-17689\";i:18927;s:12:\"delete-17691\";i:18928;s:12:\"delete-17690\";i:18929;s:12:\"delete-17692\";i:18930;s:12:\"delete-17693\";i:18931;s:12:\"delete-17695\";i:18932;s:12:\"delete-17694\";i:18933;s:12:\"delete-17696\";i:18934;s:12:\"delete-17697\";i:18935;s:12:\"delete-17699\";i:18936;s:12:\"delete-17698\";i:18937;s:12:\"delete-17700\";i:18938;s:12:\"delete-17701\";i:18939;s:12:\"delete-17703\";i:18940;s:12:\"delete-17702\";i:18941;s:12:\"delete-17704\";i:18942;s:12:\"delete-17705\";i:18943;s:12:\"delete-17707\";i:18944;s:12:\"delete-17706\";i:18945;s:12:\"delete-17708\";i:18946;s:12:\"delete-17709\";i:18947;s:12:\"delete-17711\";i:18948;s:12:\"delete-17710\";i:18949;s:12:\"delete-17712\";i:18950;s:12:\"delete-17713\";i:18951;s:12:\"delete-17715\";i:18952;s:12:\"delete-17714\";i:18953;s:12:\"delete-17716\";i:18954;s:12:\"delete-17717\";i:18955;s:12:\"delete-17719\";i:18956;s:12:\"delete-17718\";i:18957;s:12:\"delete-17720\";i:18958;s:12:\"delete-17721\";i:18959;s:12:\"delete-17723\";i:18960;s:12:\"delete-17722\";i:18961;s:12:\"delete-17724\";i:18962;s:12:\"delete-17725\";i:18963;s:12:\"delete-17727\";i:18964;s:12:\"delete-17726\";i:18965;s:12:\"delete-17728\";i:18966;s:12:\"delete-17729\";i:18967;s:12:\"delete-17731\";i:18968;s:12:\"delete-17730\";i:18969;s:12:\"delete-17732\";i:18970;s:12:\"delete-17733\";i:18971;s:12:\"delete-17735\";i:18972;s:12:\"delete-17734\";i:18973;s:12:\"delete-17736\";i:18974;s:12:\"delete-17737\";i:18975;s:12:\"delete-17739\";i:18976;s:12:\"delete-17738\";i:18977;s:12:\"delete-17740\";i:18978;s:12:\"delete-17741\";i:18979;s:12:\"delete-17743\";i:18980;s:12:\"delete-17742\";i:18981;s:12:\"delete-17744\";i:18982;s:12:\"delete-17745\";i:18983;s:12:\"delete-17747\";i:18984;s:12:\"delete-17746\";i:18985;s:12:\"delete-17748\";i:18986;s:12:\"delete-17749\";i:18987;s:12:\"delete-17751\";i:18988;s:12:\"delete-17750\";i:18989;s:12:\"delete-17752\";i:18990;s:12:\"delete-17753\";i:18991;s:12:\"delete-17755\";i:18992;s:12:\"delete-17754\";i:18993;s:12:\"delete-17756\";i:18994;s:12:\"delete-17757\";i:18995;s:12:\"delete-17759\";i:18996;s:12:\"delete-17758\";i:18997;s:12:\"delete-17760\";i:18998;s:12:\"delete-17761\";i:18999;s:12:\"delete-17763\";i:19000;s:12:\"delete-17762\";i:19001;s:12:\"delete-17764\";i:19002;s:12:\"delete-17765\";i:19003;s:12:\"delete-17767\";i:19004;s:12:\"delete-17766\";i:19005;s:12:\"delete-17768\";i:19006;s:12:\"delete-17769\";i:19007;s:12:\"delete-17771\";i:19008;s:12:\"delete-17770\";i:19009;s:12:\"delete-17772\";i:19010;s:12:\"delete-17773\";i:19011;s:12:\"delete-17775\";i:19012;s:12:\"delete-17774\";i:19013;s:12:\"delete-17776\";i:19014;s:12:\"delete-17777\";i:19015;s:12:\"delete-17779\";i:19016;s:12:\"delete-17778\";i:19017;s:12:\"delete-17780\";i:19018;s:12:\"delete-17781\";i:19019;s:12:\"delete-17783\";i:19020;s:12:\"delete-17782\";i:19021;s:12:\"delete-17784\";i:19022;s:12:\"delete-17785\";i:19023;s:12:\"delete-17787\";i:19024;s:12:\"delete-17786\";i:19025;s:12:\"delete-17788\";i:19026;s:12:\"delete-17789\";i:19027;s:12:\"delete-17791\";i:19028;s:12:\"delete-17790\";i:19029;s:12:\"delete-17792\";i:19030;s:12:\"delete-17793\";i:19031;s:12:\"delete-17795\";i:19032;s:12:\"delete-17794\";i:19033;s:12:\"delete-17796\";i:19034;s:12:\"delete-17797\";i:19035;s:12:\"delete-17799\";i:19036;s:12:\"delete-17798\";i:19037;s:12:\"delete-17800\";i:19038;s:12:\"delete-17801\";i:19039;s:12:\"delete-17803\";i:19040;s:12:\"delete-17802\";i:19041;s:12:\"delete-17804\";i:19042;s:12:\"delete-17805\";i:19043;s:12:\"delete-17807\";i:19044;s:12:\"delete-17806\";i:19045;s:12:\"delete-17808\";i:19046;s:12:\"delete-17809\";i:19047;s:12:\"delete-17811\";i:19048;s:12:\"delete-17810\";i:19049;s:12:\"delete-17812\";i:19050;s:12:\"delete-17813\";i:19051;s:12:\"delete-17815\";i:19052;s:12:\"delete-17814\";i:19053;s:12:\"delete-17816\";i:19054;s:12:\"delete-17817\";i:19055;s:12:\"delete-17819\";i:19056;s:12:\"delete-17818\";i:19057;s:12:\"delete-17820\";i:19058;s:12:\"delete-17821\";i:19059;s:12:\"delete-17823\";i:19060;s:12:\"delete-17822\";i:19061;s:12:\"delete-17824\";i:19062;s:12:\"delete-17825\";i:19063;s:12:\"delete-17827\";i:19064;s:12:\"delete-17826\";i:19065;s:12:\"delete-17828\";i:19066;s:12:\"delete-17829\";i:19067;s:12:\"delete-17831\";i:19068;s:12:\"delete-17830\";i:19069;s:12:\"delete-17832\";i:19070;s:12:\"delete-17833\";i:19071;s:12:\"delete-17835\";i:19072;s:12:\"delete-17834\";i:19073;s:12:\"delete-17836\";i:19074;s:12:\"delete-17837\";i:19075;s:12:\"delete-17839\";i:19076;s:12:\"delete-17838\";i:19077;s:12:\"delete-17840\";i:19078;s:12:\"delete-17841\";i:19079;s:12:\"delete-17843\";i:19080;s:12:\"delete-17842\";i:19081;s:12:\"delete-17844\";i:19082;s:12:\"delete-17845\";i:19083;s:12:\"delete-17847\";i:19084;s:12:\"delete-17846\";i:19085;s:12:\"delete-17848\";i:19086;s:12:\"delete-17849\";i:19087;s:12:\"delete-17851\";i:19088;s:12:\"delete-17850\";i:19089;s:12:\"delete-17852\";i:19090;s:12:\"delete-17853\";i:19091;s:12:\"delete-17855\";i:19092;s:12:\"delete-17854\";i:19093;s:12:\"delete-17856\";i:19094;s:12:\"delete-17857\";i:19095;s:12:\"delete-17859\";i:19096;s:12:\"delete-17858\";i:19097;s:12:\"delete-17860\";i:19098;s:12:\"delete-17861\";i:19099;s:12:\"delete-17863\";i:19100;s:12:\"delete-17862\";i:19101;s:12:\"delete-17864\";i:19102;s:12:\"delete-17865\";i:19103;s:12:\"delete-17867\";i:19104;s:12:\"delete-17866\";i:19105;s:12:\"delete-17868\";i:19106;s:12:\"delete-17869\";i:19107;s:12:\"delete-17871\";i:19108;s:12:\"delete-17870\";i:19109;s:12:\"delete-17872\";i:19110;s:12:\"delete-17873\";i:19111;s:12:\"delete-17875\";i:19112;s:12:\"delete-17874\";i:19113;s:12:\"delete-17876\";i:19114;s:12:\"delete-17877\";i:19115;s:12:\"delete-17879\";i:19116;s:12:\"delete-17878\";i:19117;s:12:\"delete-17880\";i:19118;s:12:\"delete-17881\";i:19119;s:12:\"delete-17883\";i:19120;s:12:\"delete-17882\";i:19121;s:12:\"delete-17884\";i:19122;s:12:\"delete-17885\";i:19123;s:12:\"delete-17887\";i:19124;s:12:\"delete-17886\";i:19125;s:12:\"delete-17888\";i:19126;s:12:\"delete-17889\";i:19127;s:12:\"delete-17891\";i:19128;s:12:\"delete-17890\";i:19129;s:12:\"delete-17892\";i:19130;s:12:\"delete-17893\";i:19131;s:12:\"delete-17895\";i:19132;s:12:\"delete-17894\";i:19133;s:12:\"delete-17896\";i:19134;s:12:\"delete-17897\";i:19135;s:12:\"delete-17899\";i:19136;s:12:\"delete-17898\";i:19137;s:12:\"delete-17900\";i:19138;s:12:\"delete-17901\";i:19139;s:12:\"delete-17903\";i:19140;s:12:\"delete-17902\";i:19141;s:12:\"delete-17904\";i:19142;s:12:\"delete-17905\";i:19143;s:12:\"delete-17907\";i:19144;s:12:\"delete-17906\";i:19145;s:12:\"delete-17908\";i:19146;s:12:\"delete-17909\";i:19147;s:12:\"delete-17911\";i:19148;s:12:\"delete-17910\";i:19149;s:12:\"delete-17912\";i:19150;s:12:\"delete-17913\";i:19151;s:12:\"delete-17915\";i:19152;s:12:\"delete-17914\";i:19153;s:12:\"delete-17916\";i:19154;s:12:\"delete-17917\";i:19155;s:12:\"delete-17919\";i:19156;s:12:\"delete-17918\";i:19157;s:12:\"delete-17920\";i:19158;s:12:\"delete-17921\";i:19159;s:12:\"delete-17923\";i:19160;s:12:\"delete-17922\";i:19161;s:12:\"delete-17924\";i:19162;s:12:\"delete-17925\";i:19163;s:12:\"delete-17927\";i:19164;s:12:\"delete-17926\";i:19165;s:12:\"delete-17928\";i:19166;s:12:\"delete-17929\";i:19167;s:12:\"delete-17931\";i:19168;s:12:\"delete-17930\";i:19169;s:12:\"delete-17932\";i:19170;s:12:\"delete-17933\";i:19171;s:12:\"delete-17935\";i:19172;s:12:\"delete-17934\";i:19173;s:12:\"delete-17936\";i:19174;s:12:\"delete-17937\";i:19175;s:12:\"delete-17939\";i:19176;s:12:\"delete-17938\";i:19177;s:12:\"delete-17940\";i:19178;s:12:\"delete-17941\";i:19179;s:12:\"delete-17943\";i:19180;s:12:\"delete-17942\";i:19181;s:12:\"delete-17944\";i:19182;s:12:\"delete-17945\";i:19183;s:12:\"delete-17947\";i:19184;s:12:\"delete-17946\";i:19185;s:12:\"delete-17948\";i:19186;s:12:\"delete-17949\";i:19187;s:12:\"delete-17951\";i:19188;s:12:\"delete-17950\";i:19189;s:12:\"delete-17952\";i:19190;s:12:\"delete-17953\";i:19191;s:12:\"delete-17955\";i:19192;s:12:\"delete-17954\";i:19193;s:12:\"delete-17956\";i:19194;s:12:\"delete-17957\";i:19195;s:12:\"delete-17959\";i:19196;s:12:\"delete-17958\";i:19197;s:12:\"delete-17960\";i:19198;s:12:\"delete-17961\";i:19199;s:12:\"delete-17963\";i:19200;s:12:\"delete-17962\";i:19201;s:12:\"delete-17964\";i:19202;s:12:\"delete-17965\";i:19203;s:12:\"delete-17967\";i:19204;s:12:\"delete-17966\";i:19205;s:12:\"delete-17968\";i:19206;s:12:\"delete-17969\";i:19207;s:12:\"delete-17971\";i:19208;s:12:\"delete-17970\";i:19209;s:12:\"delete-17972\";i:19210;s:12:\"delete-17973\";i:19211;s:12:\"delete-17975\";i:19212;s:12:\"delete-17974\";i:19213;s:12:\"delete-17976\";i:19214;s:12:\"delete-17977\";i:19215;s:12:\"delete-17979\";i:19216;s:12:\"delete-17978\";i:19217;s:12:\"delete-17980\";i:19218;s:12:\"delete-17981\";i:19219;s:12:\"delete-17983\";i:19220;s:12:\"delete-17982\";i:19221;s:12:\"delete-17984\";i:19222;s:12:\"delete-17985\";i:19223;s:12:\"delete-17987\";i:19224;s:12:\"delete-17986\";i:19225;s:12:\"delete-17988\";i:19226;s:12:\"delete-17989\";i:19227;s:12:\"delete-17991\";i:19228;s:12:\"delete-17990\";i:19229;s:12:\"delete-17992\";i:19230;s:12:\"delete-17993\";i:19231;s:12:\"delete-17995\";i:19232;s:12:\"delete-17994\";i:19233;s:12:\"delete-17996\";i:19234;s:12:\"delete-17997\";i:19235;s:12:\"delete-17999\";i:19236;s:12:\"delete-17998\";i:19237;s:12:\"delete-18000\";i:19238;s:12:\"delete-18001\";i:19239;s:12:\"delete-18003\";i:19240;s:12:\"delete-18002\";i:19241;s:12:\"delete-18004\";i:19242;s:12:\"delete-18005\";i:19243;s:12:\"delete-18007\";i:19244;s:12:\"delete-18006\";i:19245;s:12:\"delete-18008\";i:19246;s:12:\"delete-18009\";i:19247;s:12:\"delete-18011\";i:19248;s:12:\"delete-18010\";i:19249;s:12:\"delete-18012\";i:19250;s:12:\"delete-18013\";i:19251;s:12:\"delete-18015\";i:19252;s:12:\"delete-18014\";i:19253;s:12:\"delete-18016\";i:19254;s:12:\"delete-18017\";i:19255;s:12:\"delete-18019\";i:19256;s:12:\"delete-18018\";i:19257;s:12:\"delete-18020\";i:19258;s:12:\"delete-18021\";i:19259;s:12:\"delete-18023\";i:19260;s:12:\"delete-18022\";i:19261;s:12:\"delete-18024\";i:19262;s:12:\"delete-18025\";i:19263;s:12:\"delete-18027\";i:19264;s:12:\"delete-18026\";i:19265;s:12:\"delete-18028\";i:19266;s:12:\"delete-18029\";i:19267;s:12:\"delete-18031\";i:19268;s:12:\"delete-18030\";i:19269;s:12:\"delete-18032\";i:19270;s:12:\"delete-18033\";i:19271;s:12:\"delete-18035\";i:19272;s:12:\"delete-18034\";i:19273;s:12:\"delete-18036\";i:19274;s:12:\"delete-18037\";i:19275;s:12:\"delete-18039\";i:19276;s:12:\"delete-18038\";i:19277;s:12:\"delete-18040\";i:19278;s:12:\"delete-18041\";i:19279;s:12:\"delete-18043\";i:19280;s:12:\"delete-18042\";i:19281;s:12:\"delete-18044\";i:19282;s:12:\"delete-18045\";i:19283;s:12:\"delete-18047\";i:19284;s:12:\"delete-18046\";i:19285;s:12:\"delete-18048\";i:19286;s:12:\"delete-18049\";i:19287;s:12:\"delete-18051\";i:19288;s:12:\"delete-18050\";i:19289;s:12:\"delete-18052\";i:19290;s:12:\"delete-18053\";i:19291;s:12:\"delete-18055\";i:19292;s:12:\"delete-18054\";i:19293;s:12:\"delete-18056\";i:19294;s:12:\"delete-18057\";i:19295;s:12:\"delete-18059\";i:19296;s:12:\"delete-18058\";i:19297;s:12:\"delete-18060\";i:19298;s:12:\"delete-18061\";i:19299;s:12:\"delete-18063\";i:19300;s:12:\"delete-18062\";i:19301;s:12:\"delete-18064\";i:19302;s:12:\"delete-18065\";i:19303;s:12:\"delete-18067\";i:19304;s:12:\"delete-18066\";i:19305;s:12:\"delete-18068\";i:19306;s:12:\"delete-18069\";i:19307;s:12:\"delete-18071\";i:19308;s:12:\"delete-18070\";i:19309;s:12:\"delete-18072\";i:19310;s:12:\"delete-18073\";i:19311;s:12:\"delete-18075\";i:19312;s:12:\"delete-18074\";i:19313;s:12:\"delete-18076\";i:19314;s:12:\"delete-18077\";i:19315;s:12:\"delete-18079\";i:19316;s:12:\"delete-18078\";i:19317;s:12:\"delete-18080\";i:19318;s:12:\"delete-18081\";i:19319;s:12:\"delete-18083\";i:19320;s:12:\"delete-18082\";i:19321;s:12:\"delete-18084\";i:19322;s:12:\"delete-18085\";i:19323;s:12:\"delete-18087\";i:19324;s:12:\"delete-18086\";i:19325;s:12:\"delete-18088\";i:19326;s:12:\"delete-18089\";i:19327;s:12:\"delete-18091\";i:19328;s:12:\"delete-18090\";i:19329;s:12:\"delete-18092\";i:19330;s:12:\"delete-18093\";i:19331;s:12:\"delete-18095\";i:19332;s:12:\"delete-18094\";i:19333;s:12:\"delete-18096\";i:19334;s:12:\"delete-18097\";i:19335;s:12:\"delete-18099\";i:19336;s:12:\"delete-18098\";i:19337;s:12:\"delete-18100\";i:19338;s:12:\"delete-18101\";i:19339;s:12:\"delete-18103\";i:19340;s:12:\"delete-18102\";i:19341;s:12:\"delete-18104\";i:19342;s:12:\"delete-18105\";i:19343;s:12:\"delete-18107\";i:19344;s:12:\"delete-18106\";i:19345;s:12:\"delete-18108\";i:19346;s:12:\"delete-18109\";i:19347;s:12:\"delete-18111\";i:19348;s:12:\"delete-18110\";i:19349;s:12:\"delete-18112\";i:19350;s:12:\"delete-18113\";i:19351;s:12:\"delete-18115\";i:19352;s:12:\"delete-18114\";i:19353;s:12:\"delete-18116\";i:19354;s:12:\"delete-18117\";i:19355;s:12:\"delete-18119\";i:19356;s:12:\"delete-18118\";i:19357;s:12:\"delete-18120\";i:19358;s:12:\"delete-18121\";i:19359;s:12:\"delete-18123\";i:19360;s:12:\"delete-18122\";i:19361;s:12:\"delete-18124\";i:19362;s:12:\"delete-18125\";i:19363;s:12:\"delete-18127\";i:19364;s:12:\"delete-18126\";i:19365;s:12:\"delete-18128\";i:19366;s:12:\"delete-18129\";i:19367;s:12:\"delete-18131\";i:19368;s:12:\"delete-18130\";i:19369;s:12:\"delete-18132\";i:19370;s:12:\"delete-18133\";i:19371;s:12:\"delete-18135\";i:19372;s:12:\"delete-18134\";i:19373;s:12:\"delete-18136\";i:19374;s:12:\"delete-18137\";i:19375;s:12:\"delete-18139\";i:19376;s:12:\"delete-18138\";i:19377;s:12:\"delete-18140\";i:19378;s:12:\"delete-18141\";i:19379;s:12:\"delete-18143\";i:19380;s:12:\"delete-18142\";i:19381;s:12:\"delete-18144\";i:19382;s:12:\"delete-18145\";i:19383;s:12:\"delete-18147\";i:19384;s:12:\"delete-18146\";i:19385;s:12:\"delete-18148\";i:19386;s:12:\"delete-18149\";i:19387;s:12:\"delete-18151\";i:19388;s:12:\"delete-18150\";i:19389;s:12:\"delete-18152\";i:19390;s:12:\"delete-18153\";i:19391;s:12:\"delete-18155\";i:19392;s:12:\"delete-18154\";i:19393;s:12:\"delete-18156\";i:19394;s:12:\"delete-18157\";i:19395;s:12:\"delete-18159\";i:19396;s:12:\"delete-18158\";i:19397;s:12:\"delete-18160\";i:19398;s:12:\"delete-18161\";i:19399;s:12:\"delete-18163\";i:19400;s:12:\"delete-18162\";i:19401;s:12:\"delete-18164\";i:19402;s:12:\"delete-18165\";i:19403;s:12:\"delete-18167\";i:19404;s:12:\"delete-18166\";i:19405;s:12:\"delete-18168\";i:19406;s:12:\"delete-18169\";i:19407;s:12:\"delete-18171\";i:19408;s:12:\"delete-18170\";i:19409;s:12:\"delete-18172\";i:19410;s:12:\"delete-18173\";i:19411;s:12:\"delete-18175\";i:19412;s:12:\"delete-18174\";i:19413;s:12:\"delete-18176\";i:19414;s:12:\"delete-18177\";i:19415;s:12:\"delete-18179\";i:19416;s:12:\"delete-18178\";i:19417;s:12:\"delete-18180\";i:19418;s:12:\"delete-18181\";i:19419;s:12:\"delete-18183\";i:19420;s:12:\"delete-18182\";i:19421;s:12:\"delete-18184\";i:19422;s:12:\"delete-18185\";i:19423;s:12:\"delete-18187\";i:19424;s:12:\"delete-18186\";i:19425;s:12:\"delete-18188\";i:19426;s:12:\"delete-18189\";i:19427;s:12:\"delete-18191\";i:19428;s:12:\"delete-18190\";i:19429;s:12:\"delete-18192\";i:19430;s:12:\"delete-18193\";i:19431;s:12:\"delete-18195\";i:19432;s:12:\"delete-18194\";i:19433;s:12:\"delete-18196\";i:19434;s:12:\"delete-18197\";i:19435;s:12:\"delete-18199\";i:19436;s:12:\"delete-18198\";i:19437;s:12:\"delete-18200\";i:19438;s:12:\"delete-18201\";i:19439;s:12:\"delete-18203\";i:19440;s:12:\"delete-18202\";i:19441;s:12:\"delete-18204\";i:19442;s:12:\"delete-18205\";i:19443;s:12:\"delete-18207\";i:19444;s:12:\"delete-18206\";i:19445;s:12:\"delete-18208\";i:19446;s:12:\"delete-18209\";i:19447;s:12:\"delete-18211\";i:19448;s:12:\"delete-18210\";i:19449;s:12:\"delete-18212\";i:19450;s:12:\"delete-18213\";i:19451;s:12:\"delete-18215\";i:19452;s:12:\"delete-18214\";i:19453;s:12:\"delete-18216\";i:19454;s:12:\"delete-18217\";i:19455;s:12:\"delete-18219\";i:19456;s:12:\"delete-18218\";i:19457;s:12:\"delete-18220\";i:19458;s:12:\"delete-18221\";i:19459;s:12:\"delete-18223\";i:19460;s:12:\"delete-18222\";i:19461;s:12:\"delete-18224\";i:19462;s:12:\"delete-18225\";i:19463;s:12:\"delete-18227\";i:19464;s:12:\"delete-18226\";i:19465;s:12:\"delete-18228\";i:19466;s:12:\"delete-18229\";i:19467;s:12:\"delete-18231\";i:19468;s:12:\"delete-18230\";i:19469;s:12:\"delete-18232\";i:19470;s:12:\"delete-18233\";i:19471;s:12:\"delete-18235\";i:19472;s:12:\"delete-18234\";i:19473;s:12:\"delete-18236\";i:19474;s:12:\"delete-18237\";i:19475;s:12:\"delete-18239\";i:19476;s:12:\"delete-18238\";i:19477;s:12:\"delete-18240\";i:19478;s:12:\"delete-18241\";i:19479;s:12:\"delete-18243\";i:19480;s:12:\"delete-18242\";i:19481;s:12:\"delete-18244\";i:19482;s:12:\"delete-18245\";i:19483;s:12:\"delete-18247\";i:19484;s:12:\"delete-18246\";i:19485;s:12:\"delete-18248\";i:19486;s:12:\"delete-18249\";i:19487;s:12:\"delete-18251\";i:19488;s:12:\"delete-18250\";i:19489;s:12:\"delete-18252\";i:19490;s:12:\"delete-18253\";i:19491;s:12:\"delete-18255\";i:19492;s:12:\"delete-18254\";i:19493;s:12:\"delete-18256\";i:19494;s:12:\"delete-18257\";i:19495;s:12:\"delete-18259\";i:19496;s:12:\"delete-18258\";i:19497;s:12:\"delete-18260\";i:19498;s:12:\"delete-18261\";i:19499;s:12:\"delete-18263\";i:19500;s:12:\"delete-18262\";i:19501;s:12:\"delete-18264\";i:19502;s:12:\"delete-18265\";i:19503;s:12:\"delete-18267\";i:19504;s:12:\"delete-18266\";i:19505;s:12:\"delete-18268\";i:19506;s:12:\"delete-18269\";i:19507;s:12:\"delete-18271\";i:19508;s:12:\"delete-18270\";i:19509;s:12:\"delete-18272\";i:19510;s:12:\"delete-18273\";i:19511;s:12:\"delete-18275\";i:19512;s:12:\"delete-18274\";i:19513;s:12:\"delete-18276\";i:19514;s:12:\"delete-18277\";i:19515;s:12:\"delete-18279\";i:19516;s:12:\"delete-18278\";i:19517;s:12:\"delete-18280\";i:19518;s:12:\"delete-18281\";i:19519;s:12:\"delete-18283\";i:19520;s:12:\"delete-18282\";i:19521;s:12:\"delete-18284\";i:19522;s:12:\"delete-18285\";i:19523;s:12:\"delete-18287\";i:19524;s:12:\"delete-18286\";i:19525;s:12:\"delete-18288\";i:19526;s:12:\"delete-18289\";i:19527;s:12:\"delete-18291\";i:19528;s:12:\"delete-18290\";i:19529;s:12:\"delete-18292\";i:19530;s:12:\"delete-18293\";i:19531;s:12:\"delete-18295\";i:19532;s:12:\"delete-18294\";i:19533;s:12:\"delete-18296\";i:19534;s:12:\"delete-18297\";i:19535;s:12:\"delete-18299\";i:19536;s:12:\"delete-18298\";i:19537;s:12:\"delete-18300\";i:19538;s:12:\"delete-18301\";i:19539;s:12:\"delete-18303\";i:19540;s:12:\"delete-18302\";i:19541;s:12:\"delete-18304\";i:19542;s:12:\"delete-18305\";i:19543;s:12:\"delete-18307\";i:19544;s:12:\"delete-18306\";i:19545;s:12:\"delete-18308\";i:19546;s:12:\"delete-18309\";i:19547;s:12:\"delete-18311\";i:19548;s:12:\"delete-18310\";i:19549;s:12:\"delete-18312\";i:19550;s:12:\"delete-18313\";i:19551;s:12:\"delete-18315\";i:19552;s:12:\"delete-18314\";i:19553;s:12:\"delete-18316\";i:19554;s:12:\"delete-18317\";i:19555;s:12:\"delete-18319\";i:19556;s:12:\"delete-18318\";i:19557;s:12:\"delete-18320\";i:19558;s:12:\"delete-18321\";i:19559;s:12:\"delete-18323\";i:19560;s:12:\"delete-18322\";i:19561;s:12:\"delete-18324\";i:19562;s:12:\"delete-18325\";i:19563;s:12:\"delete-18327\";i:19564;s:12:\"delete-18326\";i:19565;s:12:\"delete-18328\";i:19566;s:12:\"delete-18329\";i:19567;s:12:\"delete-18331\";i:19568;s:12:\"delete-18330\";i:19569;s:12:\"delete-18332\";i:19570;s:12:\"delete-18333\";i:19571;s:12:\"delete-18335\";i:19572;s:12:\"delete-18334\";i:19573;s:12:\"delete-18336\";i:19574;s:12:\"delete-18337\";i:19575;s:12:\"delete-18339\";i:19576;s:12:\"delete-18338\";i:19577;s:12:\"delete-18340\";i:19578;s:12:\"delete-18341\";i:19579;s:12:\"delete-18343\";i:19580;s:12:\"delete-18342\";i:19581;s:12:\"delete-18344\";i:19582;s:12:\"delete-18345\";i:19583;s:12:\"delete-18347\";i:19584;s:12:\"delete-18346\";i:19585;s:12:\"delete-18348\";i:19586;s:12:\"delete-18349\";i:19587;s:12:\"delete-18351\";i:19588;s:12:\"delete-18350\";i:19589;s:12:\"delete-18352\";i:19590;s:12:\"delete-18353\";i:19591;s:12:\"delete-18355\";i:19592;s:12:\"delete-18354\";i:19593;s:12:\"delete-18356\";i:19594;s:12:\"delete-18357\";i:19595;s:12:\"delete-18359\";i:19596;s:12:\"delete-18358\";i:19597;s:12:\"delete-18360\";i:19598;s:12:\"delete-18361\";i:19599;s:12:\"delete-18363\";i:19600;s:12:\"delete-18362\";i:19601;s:12:\"delete-18364\";i:19602;s:12:\"delete-18365\";i:19603;s:12:\"delete-18367\";i:19604;s:12:\"delete-18366\";i:19605;s:12:\"delete-18368\";i:19606;s:12:\"delete-18369\";i:19607;s:12:\"delete-18371\";i:19608;s:12:\"delete-18370\";i:19609;s:12:\"delete-18372\";i:19610;s:12:\"delete-18373\";i:19611;s:12:\"delete-18375\";i:19612;s:12:\"delete-18374\";i:19613;s:12:\"delete-18376\";i:19614;s:12:\"delete-18377\";i:19615;s:12:\"delete-18379\";i:19616;s:12:\"delete-18378\";i:19617;s:12:\"delete-18380\";i:19618;s:12:\"delete-18381\";i:19619;s:12:\"delete-18383\";i:19620;s:12:\"delete-18382\";i:19621;s:12:\"delete-18384\";i:19622;s:12:\"delete-18385\";i:19623;s:12:\"delete-18387\";i:19624;s:12:\"delete-18386\";i:19625;s:12:\"delete-18388\";i:19626;s:12:\"delete-18389\";i:19627;s:12:\"delete-18391\";i:19628;s:12:\"delete-18390\";i:19629;s:12:\"delete-18392\";i:19630;s:12:\"delete-18393\";i:19631;s:12:\"delete-18395\";i:19632;s:12:\"delete-18394\";i:19633;s:12:\"delete-18396\";i:19634;s:12:\"delete-18397\";i:19635;s:12:\"delete-18399\";i:19636;s:12:\"delete-18398\";i:19637;s:12:\"delete-18400\";i:19638;s:12:\"delete-18401\";i:19639;s:12:\"delete-18403\";i:19640;s:12:\"delete-18402\";i:19641;s:12:\"delete-18404\";i:19642;s:12:\"delete-18405\";i:19643;s:12:\"delete-18407\";i:19644;s:12:\"delete-18406\";i:19645;s:12:\"delete-18408\";i:19646;s:12:\"delete-18409\";i:19647;s:12:\"delete-18411\";i:19648;s:12:\"delete-18410\";i:19649;s:12:\"delete-18412\";i:19650;s:12:\"delete-18413\";i:19651;s:12:\"delete-18415\";i:19652;s:12:\"delete-18414\";i:19653;s:12:\"delete-18416\";i:19654;s:12:\"delete-18417\";i:19655;s:12:\"delete-18419\";i:19656;s:12:\"delete-18418\";i:19657;s:12:\"delete-18420\";i:19658;s:12:\"delete-18421\";i:19659;s:12:\"delete-18423\";i:19660;s:12:\"delete-18422\";i:19661;s:12:\"delete-18424\";i:19662;s:12:\"delete-18425\";i:19663;s:12:\"delete-18427\";i:19664;s:12:\"delete-18426\";i:19665;s:12:\"delete-18428\";i:19666;s:12:\"delete-18429\";i:19667;s:12:\"delete-18431\";i:19668;s:12:\"delete-18430\";i:19669;s:12:\"delete-18432\";i:19670;s:12:\"delete-18433\";i:19671;s:12:\"delete-18435\";i:19672;s:12:\"delete-18434\";i:19673;s:12:\"delete-18436\";i:19674;s:12:\"delete-18437\";i:19675;s:12:\"delete-18439\";i:19676;s:12:\"delete-18438\";i:19677;s:12:\"delete-18440\";i:19678;s:12:\"delete-18441\";i:19679;s:12:\"delete-18443\";i:19680;s:12:\"delete-18442\";i:19681;s:12:\"delete-18444\";i:19682;s:12:\"delete-18445\";i:19683;s:12:\"delete-18447\";i:19684;s:12:\"delete-18446\";i:19685;s:12:\"delete-18448\";i:19686;s:12:\"delete-18449\";i:19687;s:12:\"delete-18451\";i:19688;s:12:\"delete-18450\";i:19689;s:12:\"delete-18452\";i:19690;s:12:\"delete-18453\";i:19691;s:12:\"delete-18455\";i:19692;s:12:\"delete-18456\";i:19693;s:12:\"delete-18454\";i:19694;s:12:\"delete-18457\";i:19695;s:12:\"delete-18459\";i:19696;s:12:\"delete-18458\";i:19697;s:12:\"delete-18460\";i:19698;s:12:\"delete-18461\";i:19699;s:12:\"delete-18463\";i:19700;s:12:\"delete-18462\";i:19701;s:12:\"delete-18464\";i:19702;s:12:\"delete-18465\";i:19703;s:12:\"delete-18467\";i:19704;s:12:\"delete-18466\";i:19705;s:12:\"delete-18468\";i:19706;s:12:\"delete-18469\";i:19707;s:12:\"delete-18471\";i:19708;s:12:\"delete-18470\";i:19709;s:12:\"delete-18472\";i:19710;s:12:\"delete-18473\";i:19711;s:12:\"delete-18475\";i:19712;s:12:\"delete-18474\";i:19713;s:12:\"delete-18476\";i:19714;s:12:\"delete-18477\";i:19715;s:12:\"delete-18479\";i:19716;s:12:\"delete-18478\";i:19717;s:12:\"delete-18480\";i:19718;s:12:\"delete-18481\";i:19719;s:12:\"delete-18483\";i:19720;s:12:\"delete-18482\";i:19721;s:12:\"delete-18484\";i:19722;s:12:\"delete-18485\";i:19723;s:12:\"delete-18487\";i:19724;s:12:\"delete-18486\";i:19725;s:12:\"delete-18488\";i:19726;s:12:\"delete-18489\";i:19727;s:12:\"delete-18491\";i:19728;s:12:\"delete-18490\";i:19729;s:12:\"delete-18492\";i:19730;s:12:\"delete-18493\";i:19731;s:12:\"delete-18495\";i:19732;s:12:\"delete-18494\";i:19733;s:12:\"delete-18496\";i:19734;s:12:\"delete-18497\";i:19735;s:12:\"delete-18499\";i:19736;s:12:\"delete-18498\";i:19737;s:12:\"delete-18500\";i:19738;s:12:\"delete-18501\";i:19739;s:12:\"delete-18503\";i:19740;s:12:\"delete-18502\";i:19741;s:12:\"delete-18504\";i:19742;s:12:\"delete-18505\";i:19743;s:12:\"delete-18507\";i:19744;s:12:\"delete-18506\";i:19745;s:12:\"delete-18508\";i:19746;s:12:\"delete-18509\";i:19747;s:12:\"delete-18511\";i:19748;s:12:\"delete-18510\";i:19749;s:12:\"delete-18512\";i:19750;s:12:\"delete-18513\";i:19751;s:12:\"delete-18515\";i:19752;s:12:\"delete-18514\";i:19753;s:12:\"delete-18516\";i:19754;s:12:\"delete-18517\";i:19755;s:12:\"delete-18519\";i:19756;s:12:\"delete-18518\";i:19757;s:12:\"delete-18520\";i:19758;s:12:\"delete-18521\";i:19759;s:12:\"delete-18523\";i:19760;s:12:\"delete-18522\";i:19761;s:12:\"delete-18524\";i:19762;s:12:\"delete-18525\";i:19763;s:12:\"delete-18527\";i:19764;s:12:\"delete-18526\";i:19765;s:12:\"delete-18528\";i:19766;s:12:\"delete-18529\";i:19767;s:12:\"delete-18531\";i:19768;s:12:\"delete-18530\";i:19769;s:12:\"delete-18532\";i:19770;s:12:\"delete-18533\";i:19771;s:12:\"delete-18535\";i:19772;s:12:\"delete-18534\";i:19773;s:12:\"delete-18536\";i:19774;s:12:\"delete-18537\";i:19775;s:12:\"delete-18539\";i:19776;s:12:\"delete-18538\";i:19777;s:12:\"delete-18540\";i:19778;s:12:\"delete-18541\";i:19779;s:12:\"delete-18543\";i:19780;s:12:\"delete-18542\";i:19781;s:12:\"delete-18544\";i:19782;s:12:\"delete-18545\";i:19783;s:12:\"delete-18547\";i:19784;s:12:\"delete-18546\";i:19785;s:12:\"delete-18548\";i:19786;s:12:\"delete-18549\";i:19787;s:12:\"delete-18551\";i:19788;s:12:\"delete-18550\";i:19789;s:12:\"delete-18552\";i:19790;s:12:\"delete-18553\";i:19791;s:12:\"delete-18555\";i:19792;s:12:\"delete-18554\";i:19793;s:12:\"delete-18556\";i:19794;s:12:\"delete-18557\";i:19795;s:12:\"delete-18559\";i:19796;s:12:\"delete-18558\";i:19797;s:12:\"delete-18560\";i:19798;s:12:\"delete-18561\";i:19799;s:12:\"delete-18563\";i:19800;s:12:\"delete-18562\";i:19801;s:12:\"delete-18564\";i:19802;s:12:\"delete-18565\";i:19803;s:12:\"delete-18567\";i:19804;s:12:\"delete-18566\";i:19805;s:12:\"delete-18568\";i:19806;s:12:\"delete-18569\";i:19807;s:12:\"delete-18571\";i:19808;s:12:\"delete-18570\";i:19809;s:12:\"delete-18572\";i:19810;s:12:\"delete-18573\";i:19811;s:12:\"delete-18575\";i:19812;s:12:\"delete-18574\";i:19813;s:12:\"delete-18576\";i:19814;s:12:\"delete-18577\";i:19815;s:12:\"delete-18579\";i:19816;s:12:\"delete-18578\";i:19817;s:12:\"delete-18580\";i:19818;s:12:\"delete-18581\";i:19819;s:12:\"delete-18583\";i:19820;s:12:\"delete-18582\";i:19821;s:12:\"delete-18584\";i:19822;s:12:\"delete-18585\";i:19823;s:12:\"delete-18587\";i:19824;s:12:\"delete-18586\";i:19825;s:12:\"delete-18588\";i:19826;s:12:\"delete-18589\";i:19827;s:12:\"delete-18591\";i:19828;s:12:\"delete-18590\";i:19829;s:12:\"delete-18592\";i:19830;s:12:\"delete-18593\";i:19831;s:12:\"delete-18595\";i:19832;s:12:\"delete-18594\";i:19833;s:12:\"delete-18596\";i:19834;s:12:\"delete-18597\";i:19835;s:12:\"delete-18599\";i:19836;s:12:\"delete-18598\";i:19837;s:12:\"delete-18600\";i:19838;s:12:\"delete-18601\";i:19839;s:12:\"delete-18603\";i:19840;s:12:\"delete-18602\";i:19841;s:12:\"delete-18604\";i:19842;s:12:\"delete-18605\";i:19843;s:12:\"delete-18607\";i:19844;s:12:\"delete-18606\";i:19845;s:12:\"delete-18608\";i:19846;s:12:\"delete-18609\";i:19847;s:12:\"delete-18611\";i:19848;s:12:\"delete-18610\";i:19849;s:12:\"delete-18612\";i:19850;s:12:\"delete-18613\";i:19851;s:12:\"delete-18615\";i:19852;s:12:\"delete-18614\";i:19853;s:12:\"delete-18616\";i:19854;s:12:\"delete-18617\";i:19855;s:12:\"delete-18619\";i:19856;s:12:\"delete-18618\";i:19857;s:12:\"delete-18620\";i:19858;s:12:\"delete-18621\";i:19859;s:12:\"delete-18623\";i:19860;s:12:\"delete-18622\";i:19861;s:12:\"delete-18624\";i:19862;s:12:\"delete-18625\";i:19863;s:12:\"delete-18627\";i:19864;s:12:\"delete-18626\";i:19865;s:12:\"delete-18628\";i:19866;s:12:\"delete-18629\";i:19867;s:12:\"delete-18631\";i:19868;s:12:\"delete-18630\";i:19869;s:12:\"delete-18632\";i:19870;s:12:\"delete-18633\";i:19871;s:12:\"delete-18635\";i:19872;s:12:\"delete-18634\";i:19873;s:12:\"delete-18636\";i:19874;s:12:\"delete-18637\";i:19875;s:12:\"delete-18639\";i:19876;s:12:\"delete-18638\";i:19877;s:12:\"delete-18640\";i:19878;s:12:\"delete-18641\";i:19879;s:12:\"delete-18643\";i:19880;s:12:\"delete-18642\";i:19881;s:12:\"delete-18644\";i:19882;s:12:\"delete-18645\";i:19883;s:12:\"delete-18647\";i:19884;s:12:\"delete-18646\";i:19885;s:12:\"delete-18648\";i:19886;s:12:\"delete-18649\";i:19887;s:12:\"delete-18651\";i:19888;s:12:\"delete-18650\";i:19889;s:12:\"delete-18652\";i:19890;s:12:\"delete-18653\";i:19891;s:12:\"delete-18655\";i:19892;s:12:\"delete-18654\";i:19893;s:12:\"delete-18656\";i:19894;s:12:\"delete-18657\";i:19895;s:12:\"delete-18659\";i:19896;s:12:\"delete-18658\";i:19897;s:12:\"delete-18660\";i:19898;s:12:\"delete-18661\";i:19899;s:12:\"delete-18663\";i:19900;s:12:\"delete-18662\";i:19901;s:12:\"delete-18664\";i:19902;s:12:\"delete-18665\";i:19903;s:12:\"delete-18667\";i:19904;s:12:\"delete-18666\";i:19905;s:12:\"delete-18668\";i:19906;s:12:\"delete-18669\";i:19907;s:12:\"delete-18671\";i:19908;s:12:\"delete-18670\";i:19909;s:12:\"delete-18672\";i:19910;s:12:\"delete-18673\";i:19911;s:12:\"delete-18675\";i:19912;s:12:\"delete-18674\";i:19913;s:12:\"delete-18676\";i:19914;s:12:\"delete-18677\";i:19915;s:12:\"delete-18679\";i:19916;s:12:\"delete-18678\";i:19917;s:12:\"delete-18680\";i:19918;s:12:\"delete-18681\";i:19919;s:12:\"delete-18683\";i:19920;s:12:\"delete-18682\";i:19921;s:12:\"delete-18684\";i:19922;s:12:\"delete-18685\";i:19923;s:12:\"delete-18687\";i:19924;s:12:\"delete-18686\";i:19925;s:12:\"delete-18688\";i:19926;s:12:\"delete-18689\";i:19927;s:12:\"delete-18691\";i:19928;s:12:\"delete-18690\";i:19929;s:12:\"delete-18692\";i:19930;s:12:\"delete-18693\";i:19931;s:12:\"delete-18695\";i:19932;s:12:\"delete-18694\";i:19933;s:12:\"delete-18696\";i:19934;s:12:\"delete-18697\";i:19935;s:12:\"delete-18699\";i:19936;s:12:\"delete-18698\";i:19937;s:12:\"delete-18700\";i:19938;s:12:\"delete-18701\";i:19939;s:12:\"delete-18703\";i:19940;s:12:\"delete-18702\";i:19941;s:12:\"delete-18704\";i:19942;s:12:\"delete-18705\";i:19943;s:12:\"delete-18707\";i:19944;s:12:\"delete-18706\";i:19945;s:12:\"delete-18708\";i:19946;s:12:\"delete-18709\";i:19947;s:12:\"delete-18711\";i:19948;s:12:\"delete-18710\";i:19949;s:12:\"delete-18712\";i:19950;s:12:\"delete-18713\";i:19951;s:12:\"delete-18715\";i:19952;s:12:\"delete-18714\";i:19953;s:12:\"delete-18716\";i:19954;s:12:\"delete-18717\";i:19955;s:12:\"delete-18719\";i:19956;s:12:\"delete-18718\";i:19957;s:12:\"delete-18720\";i:19958;s:12:\"delete-18721\";i:19959;s:12:\"delete-18723\";i:19960;s:12:\"delete-18722\";i:19961;s:12:\"delete-18724\";i:19962;s:12:\"delete-18725\";i:19963;s:12:\"delete-18727\";i:19964;s:12:\"delete-18726\";i:19965;s:12:\"delete-18728\";i:19966;s:12:\"delete-18729\";i:19967;s:12:\"delete-18731\";i:19968;s:12:\"delete-18730\";i:19969;s:12:\"delete-18732\";i:19970;s:12:\"delete-18733\";i:19971;s:12:\"delete-18735\";i:19972;s:12:\"delete-18734\";i:19973;s:12:\"delete-18736\";i:19974;s:12:\"delete-18737\";i:19975;s:12:\"delete-18739\";i:19976;s:12:\"delete-18738\";i:19977;s:12:\"delete-18740\";i:19978;s:12:\"delete-18741\";i:19979;s:12:\"delete-18743\";i:19980;s:12:\"delete-18742\";i:19981;s:12:\"delete-18744\";i:19982;s:12:\"delete-18745\";i:19983;s:12:\"delete-18747\";i:19984;s:12:\"delete-18746\";i:19985;s:12:\"delete-18748\";i:19986;s:12:\"delete-18750\";i:19987;s:12:\"delete-18752\";i:19988;s:12:\"delete-18754\";i:19989;s:12:\"delete-18756\";i:19990;s:12:\"delete-18758\";i:19991;s:12:\"delete-18760\";i:19992;s:12:\"delete-18762\";i:19993;s:12:\"delete-18764\";i:19994;s:12:\"delete-18766\";i:19995;s:12:\"delete-18768\";i:19996;s:12:\"delete-18770\";i:19997;s:12:\"delete-18772\";i:19998;s:12:\"delete-18774\";i:19999;s:12:\"delete-18776\";i:20000;s:12:\"delete-18778\";i:20001;s:12:\"delete-18780\";i:20002;s:12:\"delete-18782\";i:20003;s:12:\"delete-18784\";i:20004;s:12:\"delete-18786\";i:20005;s:12:\"delete-18788\";i:20006;s:12:\"delete-18790\";i:20007;s:12:\"delete-18792\";i:20008;s:12:\"delete-18794\";i:20009;s:12:\"delete-18796\";i:20010;s:12:\"delete-18798\";i:20011;s:12:\"delete-18800\";i:20012;s:12:\"delete-18802\";i:20013;s:12:\"delete-18804\";i:20014;s:12:\"delete-18806\";i:20015;s:12:\"delete-18808\";i:20016;s:12:\"delete-18810\";i:20017;s:12:\"delete-18812\";i:20018;s:12:\"delete-18814\";i:20019;s:12:\"delete-18816\";i:20020;s:12:\"delete-18818\";i:20021;s:12:\"delete-18820\";i:20022;s:12:\"delete-18822\";i:20023;s:12:\"delete-18824\";i:20024;s:12:\"delete-18826\";i:20025;s:12:\"delete-18828\";i:20026;s:12:\"delete-18830\";i:20027;s:12:\"delete-18832\";i:20028;s:12:\"delete-18834\";i:20029;s:12:\"delete-18836\";i:20030;s:12:\"delete-18838\";i:20031;s:12:\"delete-18840\";i:20032;s:12:\"delete-18842\";i:20033;s:12:\"delete-18844\";i:20034;s:12:\"delete-18846\";i:20035;s:12:\"delete-18848\";i:20036;s:12:\"delete-18850\";i:20037;s:12:\"delete-18852\";i:20038;s:12:\"delete-18854\";i:20039;s:12:\"delete-18856\";i:20040;s:12:\"delete-18858\";i:20041;s:12:\"delete-18860\";i:20042;s:12:\"delete-18862\";i:20043;s:12:\"delete-18864\";i:20044;s:12:\"delete-18866\";i:20045;s:12:\"delete-18868\";i:20046;s:12:\"delete-18870\";i:20047;s:12:\"delete-18872\";i:20048;s:12:\"delete-18874\";i:20049;s:12:\"delete-18876\";i:20050;s:12:\"delete-18878\";i:20051;s:12:\"delete-18880\";i:20052;s:12:\"delete-18882\";i:20053;s:12:\"delete-18884\";i:20054;s:12:\"delete-18886\";i:20055;s:12:\"delete-18888\";i:20056;s:12:\"delete-18890\";i:20057;s:12:\"delete-18892\";i:20058;s:12:\"delete-18894\";i:20059;s:12:\"delete-18896\";i:20060;s:12:\"delete-18898\";i:20061;s:12:\"delete-18900\";i:20062;s:12:\"delete-18902\";i:20063;s:12:\"delete-18904\";i:20064;s:12:\"delete-18906\";i:20065;s:12:\"delete-18908\";i:20066;s:12:\"delete-18910\";i:20067;s:12:\"delete-18912\";i:20068;s:12:\"delete-18914\";i:20069;s:12:\"delete-18916\";i:20070;s:12:\"delete-18918\";i:20071;s:12:\"delete-18920\";i:20072;s:12:\"delete-18922\";i:20073;s:12:\"delete-18924\";i:20074;s:12:\"delete-18926\";i:20075;s:12:\"delete-18928\";i:20076;s:12:\"delete-18930\";i:20077;s:12:\"delete-18932\";i:20078;s:12:\"delete-18934\";i:20079;s:12:\"delete-18936\";i:20080;s:12:\"delete-18938\";i:20081;s:12:\"delete-18940\";i:20082;s:12:\"delete-18942\";i:20083;s:12:\"delete-18944\";i:20084;s:12:\"delete-18946\";i:20085;s:12:\"delete-18948\";i:20086;s:12:\"delete-18950\";i:20087;s:12:\"delete-18952\";i:20088;s:12:\"delete-18954\";i:20089;s:12:\"delete-18956\";i:20090;s:12:\"delete-18958\";i:20091;s:12:\"delete-18960\";i:20092;s:12:\"delete-18962\";i:20093;s:12:\"delete-18964\";i:20094;s:12:\"delete-18966\";i:20095;s:12:\"delete-18968\";i:20096;s:12:\"delete-18970\";i:20097;s:12:\"delete-18972\";i:20098;s:12:\"delete-18974\";i:20099;s:12:\"delete-18976\";i:20100;s:12:\"delete-18978\";i:20101;s:12:\"delete-18980\";i:20102;s:12:\"delete-18982\";i:20103;s:12:\"delete-18984\";i:20104;s:12:\"delete-18986\";i:20105;s:12:\"delete-18988\";i:20106;s:12:\"delete-18990\";i:20107;s:12:\"delete-18992\";i:20108;s:12:\"delete-18994\";i:20109;s:12:\"delete-18996\";i:20110;s:12:\"delete-18998\";i:20111;s:12:\"delete-19000\";i:20112;s:12:\"delete-19002\";i:20113;s:12:\"delete-19004\";i:20114;s:12:\"delete-19006\";i:20115;s:12:\"delete-19008\";i:20116;s:12:\"delete-19010\";i:20117;s:12:\"delete-19012\";i:20118;s:12:\"delete-19014\";i:20119;s:12:\"delete-19016\";i:20120;s:12:\"delete-19018\";i:20121;s:12:\"delete-19020\";i:20122;s:12:\"delete-19022\";i:20123;s:12:\"delete-19024\";i:20124;s:12:\"delete-19026\";i:20125;s:12:\"delete-19028\";i:20126;s:12:\"delete-19030\";i:20127;s:12:\"delete-19032\";i:20128;s:12:\"delete-19034\";i:20129;s:12:\"delete-19036\";i:20130;s:12:\"delete-19038\";i:20131;s:12:\"delete-19040\";i:20132;s:12:\"delete-19042\";i:20133;s:12:\"delete-19044\";i:20134;s:12:\"delete-19046\";i:20135;s:12:\"delete-19048\";i:20136;s:12:\"delete-19050\";i:20137;s:12:\"delete-19052\";i:20138;s:12:\"delete-19054\";i:20139;s:12:\"delete-19056\";i:20140;s:12:\"delete-19058\";i:20141;s:12:\"delete-19060\";i:20142;s:12:\"delete-19062\";i:20143;s:12:\"delete-19064\";i:20144;s:12:\"delete-19066\";i:20145;s:12:\"delete-19068\";i:20146;s:12:\"delete-19070\";i:20147;s:12:\"delete-19072\";i:20148;s:12:\"delete-19074\";i:20149;s:12:\"delete-19076\";i:20150;s:12:\"delete-19078\";i:20151;s:12:\"delete-19080\";i:20152;s:12:\"delete-19082\";i:20153;s:12:\"delete-19084\";i:20154;s:12:\"delete-19086\";i:20155;s:12:\"delete-19088\";i:20156;s:12:\"delete-19090\";i:20157;s:12:\"delete-19092\";i:20158;s:12:\"delete-19094\";i:20159;s:12:\"delete-19096\";i:20160;s:12:\"delete-19098\";i:20161;s:12:\"delete-19100\";i:20162;s:12:\"delete-19102\";i:20163;s:12:\"delete-19104\";i:20164;s:12:\"delete-19106\";i:20165;s:12:\"delete-19108\";i:20166;s:12:\"delete-19110\";i:20167;s:12:\"delete-19112\";i:20168;s:12:\"delete-19114\";i:20169;s:12:\"delete-19116\";i:20170;s:12:\"delete-19118\";i:20171;s:12:\"delete-19120\";i:20172;s:12:\"delete-19122\";i:20173;s:12:\"delete-19124\";i:20174;s:12:\"delete-19126\";i:20175;s:12:\"delete-19128\";i:20176;s:12:\"delete-19130\";i:20177;s:12:\"delete-19132\";i:20178;s:12:\"delete-19134\";i:20179;s:12:\"delete-19136\";i:20180;s:12:\"delete-19138\";i:20181;s:12:\"delete-19140\";i:20182;s:12:\"delete-19142\";i:20183;s:12:\"delete-19144\";i:20184;s:12:\"delete-19146\";i:20185;s:12:\"delete-19148\";i:20186;s:12:\"delete-19150\";i:20187;s:12:\"delete-19152\";i:20188;s:12:\"delete-19154\";i:20189;s:12:\"delete-19156\";i:20190;s:12:\"delete-19158\";i:20191;s:12:\"delete-19160\";i:20192;s:12:\"delete-19162\";i:20193;s:12:\"delete-19164\";i:20194;s:12:\"delete-19166\";i:20195;s:12:\"delete-19168\";i:20196;s:12:\"delete-19170\";i:20197;s:12:\"delete-19172\";i:20198;s:12:\"delete-19174\";i:20199;s:12:\"delete-19176\";i:20200;s:12:\"delete-19178\";i:20201;s:12:\"delete-19180\";i:20202;s:12:\"delete-19182\";i:20203;s:12:\"delete-19184\";i:20204;s:12:\"delete-19186\";i:20205;s:12:\"delete-19188\";i:20206;s:12:\"delete-19190\";i:20207;s:12:\"delete-19192\";i:20208;s:12:\"delete-19194\";i:20209;s:12:\"delete-19196\";i:20210;s:12:\"delete-19198\";i:20211;s:12:\"delete-19200\";i:20212;s:12:\"delete-19202\";i:20213;s:12:\"delete-19204\";i:20214;s:12:\"delete-19206\";i:20215;s:12:\"delete-19208\";i:20216;s:12:\"delete-19210\";i:20217;s:12:\"delete-19212\";i:20218;s:12:\"delete-19214\";i:20219;s:12:\"delete-19216\";i:20220;s:12:\"delete-19218\";i:20221;s:12:\"delete-19220\";i:20222;s:12:\"delete-19222\";i:20223;s:12:\"delete-19224\";i:20224;s:12:\"delete-19226\";i:20225;s:12:\"delete-19228\";i:20226;s:12:\"delete-19230\";i:20227;s:12:\"delete-19232\";i:20228;s:12:\"delete-19234\";i:20229;s:12:\"delete-19236\";i:20230;s:12:\"delete-19238\";i:20231;s:12:\"delete-19240\";i:20232;s:12:\"delete-19242\";i:20233;s:12:\"delete-19244\";i:20234;s:12:\"delete-19246\";i:20235;s:12:\"delete-19248\";i:20236;s:12:\"delete-19250\";i:20237;s:12:\"delete-19252\";i:20238;s:12:\"delete-19254\";i:20239;s:12:\"delete-19256\";i:20240;s:12:\"delete-19258\";i:20241;s:12:\"delete-19260\";i:20242;s:12:\"delete-19262\";i:20243;s:12:\"delete-19264\";i:20244;s:12:\"delete-19266\";i:20245;s:12:\"delete-19268\";i:20246;s:12:\"delete-19270\";i:20247;s:12:\"delete-19272\";i:20248;s:12:\"delete-19274\";i:20249;s:12:\"delete-19276\";i:20250;s:12:\"delete-19278\";i:20251;s:12:\"delete-19280\";i:20252;s:12:\"delete-19282\";i:20253;s:12:\"delete-19284\";i:20254;s:12:\"delete-19286\";i:20255;s:12:\"delete-19288\";i:20256;s:12:\"delete-19290\";i:20257;s:12:\"delete-19292\";i:20258;s:12:\"delete-19294\";i:20259;s:12:\"delete-19296\";i:20260;s:12:\"delete-19298\";i:20261;s:12:\"delete-19300\";i:20262;s:12:\"delete-19302\";i:20263;s:12:\"delete-19304\";i:20264;s:12:\"delete-19306\";i:20265;s:12:\"delete-19308\";i:20266;s:12:\"delete-19310\";i:20267;s:12:\"delete-19312\";i:20268;s:12:\"delete-19314\";i:20269;s:12:\"delete-19316\";i:20270;s:12:\"delete-19318\";i:20271;s:12:\"delete-19320\";i:20272;s:12:\"delete-19322\";i:20273;s:12:\"delete-19324\";i:20274;s:12:\"delete-19326\";i:20275;s:12:\"delete-19328\";i:20276;s:12:\"delete-19330\";i:20277;s:12:\"delete-19332\";i:20278;s:12:\"delete-19334\";i:20279;s:12:\"delete-19336\";i:20280;s:12:\"delete-19338\";i:20281;s:12:\"delete-19340\";i:20282;s:12:\"delete-19342\";i:20283;s:12:\"delete-19344\";i:20284;s:12:\"delete-19346\";i:20285;s:12:\"delete-19348\";i:20286;s:12:\"delete-19350\";i:20287;s:12:\"delete-19352\";i:20288;s:12:\"delete-19354\";i:20289;s:12:\"delete-19356\";i:20290;s:12:\"delete-19358\";i:20291;s:12:\"delete-19360\";i:20292;s:12:\"delete-19362\";i:20293;s:12:\"delete-19364\";i:20294;s:12:\"delete-19366\";i:20295;s:12:\"delete-19368\";i:20296;s:12:\"delete-19370\";i:20297;s:12:\"delete-19372\";i:20298;s:12:\"delete-19374\";i:20299;s:12:\"delete-19376\";i:20300;s:12:\"delete-19378\";i:20301;s:12:\"delete-19380\";i:20302;s:12:\"delete-19382\";i:20303;s:12:\"delete-19384\";i:20304;s:12:\"delete-19386\";i:20305;s:12:\"delete-19388\";i:20306;s:12:\"delete-19390\";i:20307;s:12:\"delete-19392\";i:20308;s:12:\"delete-19394\";i:20309;s:12:\"delete-19396\";i:20310;s:12:\"delete-19398\";i:20311;s:12:\"delete-19400\";i:20312;s:12:\"delete-19402\";i:20313;s:12:\"delete-19404\";i:20314;s:12:\"delete-19406\";i:20315;s:12:\"delete-19408\";i:20316;s:12:\"delete-19410\";i:20317;s:12:\"delete-19412\";i:20318;s:12:\"delete-19414\";i:20319;s:12:\"delete-19416\";i:20320;s:12:\"delete-19418\";i:20321;s:12:\"delete-19420\";i:20322;s:12:\"delete-19422\";i:20323;s:12:\"delete-19424\";i:20324;s:12:\"delete-19426\";i:20325;s:12:\"delete-19428\";i:20326;s:12:\"delete-19430\";i:20327;s:12:\"delete-19432\";i:20328;s:12:\"delete-19434\";i:20329;s:12:\"delete-19436\";i:20330;s:12:\"delete-19438\";i:20331;s:12:\"delete-19440\";i:20332;s:12:\"delete-19442\";i:20333;s:12:\"delete-19444\";i:20334;s:12:\"delete-19446\";i:20335;s:12:\"delete-19448\";i:20336;s:12:\"delete-19450\";i:20337;s:12:\"delete-19452\";i:20338;s:12:\"delete-19454\";i:20339;s:12:\"delete-19456\";i:20340;s:12:\"delete-19458\";i:20341;s:12:\"delete-19460\";i:20342;s:12:\"delete-19462\";i:20343;s:12:\"delete-19464\";i:20344;s:12:\"delete-19466\";i:20345;s:12:\"delete-19468\";i:20346;s:12:\"delete-19470\";i:20347;s:12:\"delete-19472\";i:20348;s:12:\"delete-19474\";i:20349;s:12:\"delete-19476\";i:20350;s:12:\"delete-19478\";i:20351;s:12:\"delete-19480\";i:20352;s:12:\"delete-19482\";i:20353;s:12:\"delete-19484\";i:20354;s:12:\"delete-19486\";i:20355;s:12:\"delete-19488\";i:20356;s:12:\"delete-19490\";i:20357;s:12:\"delete-19492\";i:20358;s:12:\"delete-19494\";i:20359;s:12:\"delete-19496\";i:20360;s:12:\"delete-19498\";i:20361;s:12:\"delete-19500\";i:20362;s:12:\"delete-19502\";i:20363;s:12:\"delete-19504\";i:20364;s:12:\"delete-19506\";i:20365;s:12:\"delete-19508\";i:20366;s:12:\"delete-19510\";i:20367;s:12:\"delete-19512\";i:20368;s:12:\"delete-19514\";i:20369;s:12:\"delete-19516\";i:20370;s:12:\"delete-19518\";i:20371;s:12:\"delete-19520\";i:20372;s:12:\"delete-19522\";i:20373;s:12:\"delete-19524\";i:20374;s:12:\"delete-19526\";i:20375;s:12:\"delete-19528\";i:20376;s:12:\"delete-19530\";i:20377;s:12:\"delete-19532\";i:20378;s:12:\"delete-19534\";i:20379;s:12:\"delete-19536\";i:20380;s:12:\"delete-19538\";i:20381;s:12:\"delete-19540\";i:20382;s:12:\"delete-19542\";i:20383;s:12:\"delete-19544\";i:20384;s:12:\"delete-19546\";i:20385;s:12:\"delete-19548\";i:20386;s:12:\"delete-19550\";i:20387;s:12:\"delete-19552\";i:20388;s:12:\"delete-19554\";i:20389;s:12:\"delete-19556\";i:20390;s:12:\"delete-19558\";i:20391;s:12:\"delete-19560\";i:20392;s:12:\"delete-19562\";i:20393;s:12:\"delete-19564\";i:20394;s:12:\"delete-19566\";i:20395;s:12:\"delete-19568\";i:20396;s:12:\"delete-19570\";i:20397;s:12:\"delete-19572\";i:20398;s:12:\"delete-19574\";i:20399;s:12:\"delete-19576\";i:20400;s:12:\"delete-19578\";i:20401;s:12:\"delete-19580\";i:20402;s:12:\"delete-19582\";i:20403;s:12:\"delete-19584\";i:20404;s:12:\"delete-19586\";i:20405;s:12:\"delete-19588\";i:20406;s:12:\"delete-19590\";i:20407;s:12:\"delete-19592\";i:20408;s:12:\"delete-19594\";i:20409;s:12:\"delete-19596\";i:20410;s:12:\"delete-19598\";i:20411;s:12:\"delete-19600\";i:20412;s:12:\"delete-19602\";i:20413;s:12:\"delete-19604\";i:20414;s:12:\"delete-19606\";i:20415;s:12:\"delete-19608\";i:20416;s:12:\"delete-19610\";i:20417;s:12:\"delete-19612\";i:20418;s:12:\"delete-19614\";i:20419;s:12:\"delete-19616\";i:20420;s:12:\"delete-19618\";i:20421;s:12:\"delete-19620\";i:20422;s:12:\"delete-19622\";i:20423;s:12:\"delete-19624\";i:20424;s:12:\"delete-19626\";i:20425;s:12:\"delete-19628\";i:20426;s:12:\"delete-19630\";i:20427;s:12:\"delete-19632\";i:20428;s:12:\"delete-19634\";i:20429;s:12:\"delete-19636\";i:20430;s:12:\"delete-19638\";i:20431;s:12:\"delete-19640\";i:20432;s:12:\"delete-19642\";i:20433;s:12:\"delete-19644\";i:20434;s:12:\"delete-19646\";i:20435;s:12:\"delete-19648\";i:20436;s:12:\"delete-19650\";i:20437;s:12:\"delete-19652\";i:20438;s:12:\"delete-19654\";i:20439;s:12:\"delete-19656\";i:20440;s:12:\"delete-19658\";i:20441;s:12:\"delete-19660\";i:20442;s:12:\"delete-19662\";i:20443;s:12:\"delete-19664\";i:20444;s:12:\"delete-19666\";i:20445;s:12:\"delete-19668\";i:20446;s:12:\"delete-19670\";i:20447;s:12:\"delete-19672\";i:20448;s:12:\"delete-19674\";i:20449;s:12:\"delete-19676\";i:20450;s:12:\"delete-19678\";i:20451;s:12:\"delete-19680\";i:20452;s:12:\"delete-19682\";i:20453;s:12:\"delete-19684\";i:20454;s:12:\"delete-19686\";i:20455;s:12:\"delete-19688\";i:20456;s:12:\"delete-19690\";i:20457;s:12:\"delete-19692\";i:20458;s:12:\"delete-19694\";i:20459;s:12:\"delete-19696\";i:20460;s:12:\"delete-19698\";i:20461;s:12:\"delete-19700\";i:20462;s:12:\"delete-19702\";i:20463;s:12:\"delete-19704\";i:20464;s:12:\"delete-19706\";i:20465;s:12:\"delete-19708\";i:20466;s:12:\"delete-19710\";i:20467;s:12:\"delete-19712\";i:20468;s:12:\"delete-19714\";i:20469;s:12:\"delete-19716\";i:20470;s:12:\"delete-19718\";i:20471;s:12:\"delete-19720\";i:20472;s:12:\"delete-19722\";i:20473;s:12:\"delete-19724\";i:20474;s:12:\"delete-19726\";i:20475;s:12:\"delete-19728\";i:20476;s:12:\"delete-19730\";i:20477;s:12:\"delete-19732\";i:20478;s:12:\"delete-19734\";i:20479;s:12:\"delete-19736\";i:20480;s:12:\"delete-19738\";i:20481;s:12:\"delete-19740\";i:20482;s:12:\"delete-19742\";i:20483;s:12:\"delete-19744\";i:20484;s:12:\"delete-19746\";i:20485;s:12:\"delete-19748\";i:20486;s:12:\"delete-19750\";i:20487;s:12:\"delete-19752\";i:20488;s:12:\"delete-19754\";i:20489;s:12:\"delete-19756\";i:20490;s:12:\"delete-19758\";i:20491;s:12:\"delete-19760\";i:20492;s:12:\"delete-19762\";i:20493;s:12:\"delete-19764\";i:20494;s:12:\"delete-19766\";i:20495;s:12:\"delete-19768\";i:20496;s:12:\"delete-19770\";i:20497;s:12:\"delete-19772\";i:20498;s:12:\"delete-19774\";i:20499;s:12:\"delete-19776\";i:20500;s:12:\"delete-19778\";i:20501;s:12:\"delete-19780\";i:20502;s:12:\"delete-19782\";i:20503;s:12:\"delete-19784\";i:20504;s:12:\"delete-19786\";i:20505;s:12:\"delete-19788\";i:20506;s:12:\"delete-19790\";i:20507;s:12:\"delete-19792\";i:20508;s:12:\"delete-19794\";i:20509;s:12:\"delete-19796\";i:20510;s:12:\"delete-19798\";i:20511;s:12:\"delete-19800\";i:20512;s:12:\"delete-19802\";i:20513;s:12:\"delete-19804\";i:20514;s:12:\"delete-19806\";i:20515;s:12:\"delete-19808\";i:20516;s:12:\"delete-19810\";i:20517;s:12:\"delete-19812\";i:20518;s:12:\"delete-19814\";i:20519;s:12:\"delete-19816\";i:20520;s:12:\"delete-19818\";i:20521;s:12:\"delete-19820\";i:20522;s:12:\"delete-19822\";i:20523;s:12:\"delete-19824\";i:20524;s:12:\"delete-19826\";i:20525;s:12:\"delete-19828\";i:20526;s:12:\"delete-19830\";i:20527;s:12:\"delete-19832\";i:20528;s:12:\"delete-19834\";i:20529;s:12:\"delete-19836\";i:20530;s:12:\"delete-19838\";i:20531;s:12:\"delete-19840\";i:20532;s:12:\"delete-19842\";i:20533;s:12:\"delete-19844\";i:20534;s:12:\"delete-19846\";i:20535;s:12:\"delete-19848\";i:20536;s:12:\"delete-19850\";i:20537;s:12:\"delete-19852\";i:20538;s:12:\"delete-19854\";i:20539;s:12:\"delete-19856\";i:20540;s:12:\"delete-19858\";i:20541;s:12:\"delete-19860\";i:20542;s:12:\"delete-19862\";i:20543;s:12:\"delete-19864\";i:20544;s:12:\"delete-19866\";i:20545;s:12:\"delete-19868\";i:20546;s:12:\"delete-19870\";i:20547;s:12:\"delete-19872\";i:20548;s:12:\"delete-19874\";i:20549;s:12:\"delete-19876\";i:20550;s:12:\"delete-19878\";i:20551;s:12:\"delete-19880\";i:20552;s:12:\"delete-19882\";i:20553;s:12:\"delete-19884\";i:20554;s:12:\"delete-19886\";i:20555;s:12:\"delete-19888\";i:20556;s:12:\"delete-19890\";i:20557;s:12:\"delete-19892\";i:20558;s:12:\"delete-19894\";i:20559;s:12:\"delete-19896\";i:20560;s:12:\"delete-19898\";i:20561;s:12:\"delete-19900\";i:20562;s:12:\"delete-19902\";i:20563;s:12:\"delete-19904\";i:20564;s:12:\"delete-19906\";i:20565;s:12:\"delete-19908\";i:20566;s:12:\"delete-19910\";i:20567;s:12:\"delete-19912\";i:20568;s:12:\"delete-19914\";i:20569;s:12:\"delete-19916\";i:20570;s:12:\"delete-19918\";i:20571;s:12:\"delete-19920\";i:20572;s:12:\"delete-19922\";i:20573;s:12:\"delete-19924\";i:20574;s:12:\"delete-19926\";i:20575;s:12:\"delete-19928\";i:20576;s:12:\"delete-19930\";i:20577;s:12:\"delete-19932\";i:20578;s:12:\"delete-19934\";i:20579;s:12:\"delete-19936\";i:20580;s:12:\"delete-19938\";i:20581;s:12:\"delete-19940\";i:20582;s:12:\"delete-19942\";i:20583;s:12:\"delete-19944\";i:20584;s:12:\"delete-19946\";i:20585;s:12:\"delete-19948\";i:20586;s:12:\"delete-19950\";i:20587;s:12:\"delete-19952\";i:20588;s:12:\"delete-19954\";i:20589;s:12:\"delete-19956\";i:20590;s:12:\"delete-19958\";i:20591;s:12:\"delete-19960\";i:20592;s:12:\"delete-19962\";i:20593;s:12:\"delete-19964\";i:20594;s:12:\"delete-19966\";i:20595;s:12:\"delete-19968\";i:20596;s:12:\"delete-19970\";i:20597;s:12:\"delete-19972\";i:20598;s:12:\"delete-19974\";i:20599;s:12:\"delete-19976\";i:20600;s:12:\"delete-19978\";i:20601;s:12:\"delete-19980\";i:20602;s:12:\"delete-19982\";i:20603;s:12:\"delete-19984\";i:20604;s:12:\"delete-19986\";i:20605;s:12:\"delete-19988\";i:20606;s:12:\"delete-19990\";i:20607;s:12:\"delete-19992\";i:20608;s:12:\"delete-19994\";i:20609;s:12:\"delete-19996\";i:20610;s:12:\"delete-19998\";i:20611;s:12:\"delete-20000\";i:20612;s:12:\"delete-20002\";i:20613;s:12:\"delete-20004\";i:20614;s:12:\"delete-20006\";i:20615;s:12:\"delete-20008\";i:20616;s:12:\"delete-20010\";i:20617;s:12:\"delete-20012\";i:20618;s:12:\"delete-20014\";i:20619;s:12:\"delete-20016\";i:20620;s:12:\"delete-20018\";i:20621;s:12:\"delete-20020\";i:20622;s:12:\"delete-20022\";i:20623;s:12:\"delete-20024\";i:20624;s:12:\"delete-20026\";i:20625;s:12:\"delete-20028\";i:20626;s:12:\"delete-20030\";i:20627;s:12:\"delete-20032\";i:20628;s:12:\"delete-20034\";i:20629;s:12:\"delete-20036\";i:20630;s:12:\"delete-20038\";i:20631;s:12:\"delete-20040\";i:20632;s:12:\"delete-20042\";i:20633;s:12:\"delete-20044\";i:20634;s:12:\"delete-20046\";i:20635;s:12:\"delete-20048\";i:20636;s:12:\"delete-20050\";i:20637;s:12:\"delete-20052\";i:20638;s:12:\"delete-20054\";i:20639;s:12:\"delete-20056\";i:20640;s:12:\"delete-20058\";i:20641;s:12:\"delete-20060\";i:20642;s:12:\"delete-20062\";i:20643;s:12:\"delete-20064\";i:20644;s:12:\"delete-20066\";i:20645;s:12:\"delete-20068\";i:20646;s:12:\"delete-20070\";i:20647;s:12:\"delete-20072\";i:20648;s:12:\"delete-20074\";i:20649;s:12:\"delete-20076\";i:20650;s:12:\"delete-20078\";i:20651;s:12:\"delete-20080\";i:20652;s:12:\"delete-20082\";i:20653;s:12:\"delete-20084\";i:20654;s:12:\"delete-20086\";i:20655;s:12:\"delete-20088\";i:20656;s:12:\"delete-20090\";i:20657;s:12:\"delete-20092\";i:20658;s:12:\"delete-20094\";i:20659;s:12:\"delete-20096\";i:20660;s:12:\"delete-20098\";i:20661;s:12:\"delete-20100\";i:20662;s:12:\"delete-20102\";i:20663;s:12:\"delete-20104\";i:20664;s:12:\"delete-20106\";i:20665;s:12:\"delete-20108\";i:20666;s:12:\"delete-20110\";i:20667;s:12:\"delete-20112\";i:20668;s:12:\"delete-20114\";i:20669;s:12:\"delete-20116\";i:20670;s:12:\"delete-20118\";i:20671;s:12:\"delete-20120\";i:20672;s:12:\"delete-20122\";i:20673;s:12:\"delete-20124\";i:20674;s:12:\"delete-20126\";i:20675;s:12:\"delete-20128\";i:20676;s:12:\"delete-20130\";i:20677;s:12:\"delete-20132\";i:20678;s:12:\"delete-20134\";i:20679;s:12:\"delete-20136\";i:20680;s:12:\"delete-20138\";i:20681;s:12:\"delete-20140\";i:20682;s:12:\"delete-20142\";i:20683;s:12:\"delete-20144\";i:20684;s:12:\"delete-20146\";i:20685;s:12:\"delete-20148\";i:20686;s:12:\"delete-20150\";i:20687;s:12:\"delete-20152\";i:20688;s:12:\"delete-20154\";i:20689;s:12:\"delete-20156\";i:20690;s:12:\"delete-20158\";i:20691;s:12:\"delete-20160\";i:20692;s:12:\"delete-20162\";i:20693;s:12:\"delete-20164\";i:20694;s:12:\"delete-20166\";i:20695;s:12:\"delete-20168\";i:20696;s:12:\"delete-20170\";i:20697;s:12:\"delete-20172\";i:20698;s:12:\"delete-20174\";i:20699;s:12:\"delete-20176\";i:20700;s:12:\"delete-20178\";i:20701;s:12:\"delete-20180\";i:20702;s:12:\"delete-20182\";i:20703;s:12:\"delete-20184\";i:20704;s:12:\"delete-20186\";i:20705;s:12:\"delete-20188\";i:20706;s:12:\"delete-20190\";i:20707;s:12:\"delete-20192\";i:20708;s:12:\"delete-20194\";i:20709;s:12:\"delete-20196\";i:20710;s:12:\"delete-20198\";i:20711;s:12:\"delete-20200\";i:20712;s:12:\"delete-20202\";i:20713;s:12:\"delete-20204\";i:20714;s:12:\"delete-20206\";i:20715;s:12:\"delete-20208\";i:20716;s:12:\"delete-20210\";i:20717;s:12:\"delete-20212\";i:20718;s:12:\"delete-20214\";i:20719;s:12:\"delete-20216\";i:20720;s:12:\"delete-20218\";i:20721;s:12:\"delete-20220\";i:20722;s:12:\"delete-20222\";i:20723;s:12:\"delete-20224\";i:20724;s:12:\"delete-20226\";i:20725;s:12:\"delete-20228\";i:20726;s:12:\"delete-20230\";i:20727;s:12:\"delete-20232\";i:20728;s:12:\"delete-20234\";i:20729;s:12:\"delete-20236\";i:20730;s:12:\"delete-20238\";i:20731;s:12:\"delete-20240\";i:20732;s:12:\"delete-20242\";i:20733;s:12:\"delete-20244\";i:20734;s:12:\"delete-20246\";i:20735;s:12:\"delete-20248\";i:20736;s:12:\"delete-20250\";i:20737;s:12:\"delete-20252\";i:20738;s:12:\"delete-20254\";i:20739;s:12:\"delete-20256\";i:20740;s:12:\"delete-20258\";i:20741;s:12:\"delete-20260\";i:20742;s:12:\"delete-20262\";i:20743;s:12:\"delete-20264\";i:20744;s:12:\"delete-20266\";i:20745;s:12:\"delete-20268\";i:20746;s:12:\"delete-20270\";i:20747;s:12:\"delete-20272\";i:20748;s:12:\"delete-20274\";i:20749;s:12:\"delete-20276\";i:20750;s:12:\"delete-20278\";i:20751;s:12:\"delete-20280\";i:20752;s:12:\"delete-20282\";i:20753;s:12:\"delete-20284\";i:20754;s:12:\"delete-20286\";i:20755;s:12:\"delete-20288\";i:20756;s:12:\"delete-20290\";i:20757;s:12:\"delete-20292\";i:20758;s:12:\"delete-20294\";i:20759;s:12:\"delete-20296\";i:20760;s:12:\"delete-20298\";i:20761;s:12:\"delete-20300\";i:20762;s:12:\"delete-20302\";i:20763;s:12:\"delete-20304\";i:20764;s:12:\"delete-20306\";i:20765;s:12:\"delete-20308\";i:20766;s:12:\"delete-20310\";i:20767;s:12:\"delete-20312\";i:20768;s:12:\"delete-20314\";i:20769;s:12:\"delete-20316\";i:20770;s:12:\"delete-20318\";i:20771;s:12:\"delete-20320\";i:20772;s:12:\"delete-20322\";i:20773;s:12:\"delete-20324\";i:20774;s:12:\"delete-20326\";i:20775;s:12:\"delete-20328\";i:20776;s:12:\"delete-20330\";i:20777;s:12:\"delete-20332\";i:20778;s:12:\"delete-20334\";i:20779;s:12:\"delete-20336\";i:20780;s:12:\"delete-20338\";i:20781;s:12:\"delete-20340\";i:20782;s:12:\"delete-20342\";i:20783;s:12:\"delete-20344\";i:20784;s:12:\"delete-20346\";i:20785;s:12:\"delete-20348\";i:20786;s:12:\"delete-20350\";i:20787;s:12:\"delete-20352\";i:20788;s:12:\"delete-20354\";i:20789;s:12:\"delete-20356\";i:20790;s:12:\"delete-20358\";i:20791;s:12:\"delete-20360\";i:20792;s:12:\"delete-20362\";i:20793;s:12:\"delete-20364\";i:20794;s:12:\"delete-20366\";i:20795;s:12:\"delete-20368\";i:20796;s:12:\"delete-20370\";i:20797;s:12:\"delete-20372\";i:20798;s:12:\"delete-20374\";i:20799;s:12:\"delete-20376\";i:20800;s:12:\"delete-20378\";i:20801;s:12:\"delete-20380\";i:20802;s:12:\"delete-20382\";i:20803;s:12:\"delete-20384\";i:20804;s:12:\"delete-20386\";i:20805;s:12:\"delete-20388\";i:20806;s:12:\"delete-20390\";i:20807;s:12:\"delete-20392\";i:20808;s:12:\"delete-20394\";i:20809;s:12:\"delete-20396\";i:20810;s:12:\"delete-20398\";i:20811;s:12:\"delete-20400\";i:20812;s:12:\"delete-20402\";i:20813;s:12:\"delete-20404\";i:20814;s:12:\"delete-20406\";i:20815;s:12:\"delete-20408\";i:20816;s:12:\"delete-20410\";i:20817;s:12:\"delete-20412\";i:20818;s:12:\"delete-20414\";i:20819;s:12:\"delete-20416\";i:20820;s:12:\"delete-20418\";i:20821;s:12:\"delete-20420\";i:20822;s:12:\"delete-20422\";i:20823;s:12:\"delete-20424\";i:20824;s:12:\"delete-20426\";i:20825;s:12:\"delete-20428\";i:20826;s:12:\"delete-20430\";i:20827;s:12:\"delete-20432\";i:20828;s:12:\"delete-20434\";i:20829;s:12:\"delete-20436\";i:20830;s:12:\"delete-20438\";i:20831;s:12:\"delete-20440\";i:20832;s:12:\"delete-20442\";i:20833;s:12:\"delete-20444\";i:20834;s:12:\"delete-20446\";i:20835;s:12:\"delete-20448\";i:20836;s:12:\"delete-20450\";i:20837;s:12:\"delete-20452\";i:20838;s:12:\"delete-20454\";i:20839;s:12:\"delete-20456\";i:20840;s:12:\"delete-20458\";i:20841;s:12:\"delete-20460\";i:20842;s:12:\"delete-20462\";i:20843;s:12:\"delete-20464\";i:20844;s:12:\"delete-20466\";i:20845;s:12:\"delete-20468\";i:20846;s:12:\"delete-20470\";i:20847;s:12:\"delete-20472\";i:20848;s:12:\"delete-20474\";i:20849;s:12:\"delete-20476\";i:20850;s:12:\"delete-20478\";i:20851;s:12:\"delete-20480\";i:20852;s:12:\"delete-20482\";i:20853;s:12:\"delete-20484\";i:20854;s:12:\"delete-20486\";i:20855;s:12:\"delete-20488\";i:20856;s:12:\"delete-20490\";i:20857;s:12:\"delete-20492\";i:20858;s:12:\"delete-20494\";i:20859;s:12:\"delete-20496\";i:20860;s:12:\"delete-20498\";i:20861;s:12:\"delete-20500\";i:20862;s:12:\"delete-20502\";i:20863;s:12:\"delete-20504\";i:20864;s:12:\"delete-20506\";i:20865;s:12:\"delete-20508\";i:20866;s:12:\"delete-20510\";i:20867;s:12:\"delete-20512\";i:20868;s:12:\"delete-20514\";i:20869;s:12:\"delete-20516\";i:20870;s:12:\"delete-20518\";i:20871;s:12:\"delete-20520\";i:20872;s:12:\"delete-20522\";i:20873;s:12:\"delete-20524\";i:20874;s:12:\"delete-20526\";i:20875;s:12:\"delete-20528\";i:20876;s:12:\"delete-20530\";i:20877;s:12:\"delete-20532\";i:20878;s:12:\"delete-20534\";i:20879;s:12:\"delete-20536\";i:20880;s:12:\"delete-20538\";i:20881;s:12:\"delete-20540\";i:20882;s:12:\"delete-20542\";i:20883;s:12:\"delete-20544\";i:20884;s:12:\"delete-20546\";i:20885;s:12:\"delete-20548\";i:20886;s:12:\"delete-20550\";i:20887;s:12:\"delete-20552\";i:20888;s:12:\"delete-20554\";i:20889;s:12:\"delete-20556\";i:20890;s:12:\"delete-20558\";i:20891;s:12:\"delete-20560\";i:20892;s:12:\"delete-20562\";i:20893;s:12:\"delete-20564\";i:20894;s:12:\"delete-20566\";i:20895;s:12:\"delete-20568\";i:20896;s:12:\"delete-20570\";i:20897;s:12:\"delete-20572\";i:20898;s:12:\"delete-20574\";i:20899;s:12:\"delete-20576\";i:20900;s:12:\"delete-20578\";i:20901;s:12:\"delete-20580\";i:20902;s:12:\"delete-20582\";i:20903;s:12:\"delete-20584\";i:20904;s:12:\"delete-20586\";i:20905;s:12:\"delete-20588\";i:20906;s:12:\"delete-20590\";i:20907;s:12:\"delete-20592\";i:20908;s:12:\"delete-20594\";i:20909;s:12:\"delete-20596\";i:20910;s:12:\"delete-20598\";i:20911;s:12:\"delete-20600\";i:20912;s:12:\"delete-20602\";i:20913;s:12:\"delete-20604\";i:20914;s:12:\"delete-20606\";i:20915;s:12:\"delete-20608\";i:20916;s:12:\"delete-20610\";i:20917;s:12:\"delete-20612\";i:20918;s:12:\"delete-20614\";i:20919;s:12:\"delete-20616\";i:20920;s:12:\"delete-20618\";i:20921;s:12:\"delete-20620\";i:20922;s:12:\"delete-20622\";i:20923;s:12:\"delete-20624\";i:20924;s:12:\"delete-20626\";i:20925;s:12:\"delete-20628\";i:20926;s:12:\"delete-20630\";i:20927;s:12:\"delete-20632\";i:20928;s:12:\"delete-20634\";i:20929;s:12:\"delete-20636\";i:20930;s:12:\"delete-20638\";i:20931;s:12:\"delete-20640\";i:20932;s:12:\"delete-20642\";i:20933;s:12:\"delete-20644\";i:20934;s:12:\"delete-20646\";i:20935;s:12:\"delete-20648\";i:20936;s:12:\"delete-20650\";i:20937;s:12:\"delete-20652\";i:20938;s:12:\"delete-20654\";i:20939;s:12:\"delete-20656\";i:20940;s:12:\"delete-20658\";i:20941;s:12:\"delete-20660\";i:20942;s:12:\"delete-20662\";i:20943;s:12:\"delete-20664\";i:20944;s:12:\"delete-20666\";i:20945;s:12:\"delete-20668\";i:20946;s:12:\"delete-20670\";i:20947;s:12:\"delete-20672\";i:20948;s:12:\"delete-20674\";i:20949;s:12:\"delete-20676\";i:20950;s:12:\"delete-20678\";i:20951;s:12:\"delete-20680\";i:20952;s:12:\"delete-20682\";i:20953;s:12:\"delete-20684\";i:20954;s:12:\"delete-20686\";i:20955;s:12:\"delete-20688\";i:20956;s:12:\"delete-20690\";i:20957;s:12:\"delete-20692\";i:20958;s:12:\"delete-20694\";i:20959;s:12:\"delete-20696\";i:20960;s:12:\"delete-20698\";i:20961;s:12:\"delete-20700\";i:20962;s:12:\"delete-20702\";i:20963;s:12:\"delete-20704\";i:20964;s:12:\"delete-20706\";i:20965;s:12:\"delete-20708\";i:20966;s:12:\"delete-20710\";i:20967;s:12:\"delete-20712\";i:20968;s:12:\"delete-20714\";i:20969;s:12:\"delete-20716\";i:20970;s:12:\"delete-20718\";i:20971;s:12:\"delete-20720\";i:20972;s:12:\"delete-20722\";i:20973;s:12:\"delete-20724\";i:20974;s:12:\"delete-20726\";i:20975;s:12:\"delete-20728\";i:20976;s:12:\"delete-20730\";i:20977;s:12:\"delete-20732\";i:20978;s:12:\"delete-20734\";i:20979;s:12:\"delete-20736\";i:20980;s:12:\"delete-20738\";i:20981;s:12:\"delete-20740\";i:20982;s:12:\"delete-20742\";i:20983;s:12:\"delete-20744\";i:20984;s:12:\"delete-20746\";i:20985;s:12:\"delete-20748\";i:20986;s:12:\"delete-19749\";i:20987;s:12:\"delete-19751\";i:20988;s:12:\"delete-19753\";i:20989;s:12:\"delete-19755\";i:20990;s:12:\"delete-19757\";i:20991;s:12:\"delete-19759\";i:20992;s:12:\"delete-19761\";i:20993;s:12:\"delete-19763\";i:20994;s:12:\"delete-19765\";i:20995;s:12:\"delete-19767\";i:20996;s:12:\"delete-19769\";i:20997;s:12:\"delete-19771\";i:20998;s:12:\"delete-19773\";i:20999;s:12:\"delete-19775\";i:21000;s:12:\"delete-19777\";i:21001;s:12:\"delete-19779\";i:21002;s:12:\"delete-19781\";i:21003;s:12:\"delete-19783\";i:21004;s:12:\"delete-19785\";i:21005;s:12:\"delete-19787\";i:21006;s:12:\"delete-19789\";i:21007;s:12:\"delete-19791\";i:21008;s:12:\"delete-19793\";i:21009;s:12:\"delete-19795\";i:21010;s:12:\"delete-19797\";i:21011;s:12:\"delete-19799\";i:21012;s:12:\"delete-19801\";i:21013;s:12:\"delete-19803\";i:21014;s:12:\"delete-19805\";i:21015;s:12:\"delete-19807\";i:21016;s:12:\"delete-19809\";i:21017;s:12:\"delete-19811\";i:21018;s:12:\"delete-19813\";i:21019;s:12:\"delete-19815\";i:21020;s:12:\"delete-19817\";i:21021;s:12:\"delete-19819\";i:21022;s:12:\"delete-19821\";i:21023;s:12:\"delete-19823\";i:21024;s:12:\"delete-19825\";i:21025;s:12:\"delete-19827\";i:21026;s:12:\"delete-19829\";i:21027;s:12:\"delete-19831\";i:21028;s:12:\"delete-19833\";i:21029;s:12:\"delete-19835\";i:21030;s:12:\"delete-19837\";i:21031;s:12:\"delete-19839\";i:21032;s:12:\"delete-19841\";i:21033;s:12:\"delete-19843\";i:21034;s:12:\"delete-19845\";i:21035;s:12:\"delete-19847\";i:21036;s:12:\"delete-19849\";i:21037;s:12:\"delete-19851\";i:21038;s:12:\"delete-19853\";i:21039;s:12:\"delete-19855\";i:21040;s:12:\"delete-19857\";i:21041;s:12:\"delete-19859\";i:21042;s:12:\"delete-19861\";i:21043;s:12:\"delete-19863\";i:21044;s:12:\"delete-19865\";i:21045;s:12:\"delete-19867\";i:21046;s:12:\"delete-19869\";i:21047;s:12:\"delete-19871\";i:21048;s:12:\"delete-19873\";i:21049;s:12:\"delete-19875\";i:21050;s:12:\"delete-19877\";i:21051;s:12:\"delete-19879\";i:21052;s:12:\"delete-19881\";i:21053;s:12:\"delete-19883\";i:21054;s:12:\"delete-19885\";i:21055;s:12:\"delete-19887\";i:21056;s:12:\"delete-19889\";i:21057;s:12:\"delete-19891\";i:21058;s:12:\"delete-19893\";i:21059;s:12:\"delete-19895\";i:21060;s:12:\"delete-19897\";i:21061;s:12:\"delete-19899\";i:21062;s:12:\"delete-19901\";i:21063;s:12:\"delete-19903\";i:21064;s:12:\"delete-19905\";i:21065;s:12:\"delete-19907\";i:21066;s:12:\"delete-19909\";i:21067;s:12:\"delete-19911\";i:21068;s:12:\"delete-19913\";i:21069;s:12:\"delete-19915\";i:21070;s:12:\"delete-19917\";i:21071;s:12:\"delete-19919\";i:21072;s:12:\"delete-19921\";i:21073;s:12:\"delete-19923\";i:21074;s:12:\"delete-19925\";i:21075;s:12:\"delete-19927\";i:21076;s:12:\"delete-19929\";i:21077;s:12:\"delete-19931\";i:21078;s:12:\"delete-19933\";i:21079;s:12:\"delete-19935\";i:21080;s:12:\"delete-19937\";i:21081;s:12:\"delete-19939\";i:21082;s:12:\"delete-19941\";i:21083;s:12:\"delete-19943\";i:21084;s:12:\"delete-19945\";i:21085;s:12:\"delete-19947\";i:21086;s:12:\"delete-19949\";i:21087;s:12:\"delete-19951\";i:21088;s:12:\"delete-19953\";i:21089;s:12:\"delete-19955\";i:21090;s:12:\"delete-19957\";i:21091;s:12:\"delete-19959\";i:21092;s:12:\"delete-19961\";i:21093;s:12:\"delete-19963\";i:21094;s:12:\"delete-19965\";i:21095;s:12:\"delete-19967\";i:21096;s:12:\"delete-19969\";i:21097;s:12:\"delete-19971\";i:21098;s:12:\"delete-19973\";i:21099;s:12:\"delete-19975\";i:21100;s:12:\"delete-19977\";i:21101;s:12:\"delete-19979\";i:21102;s:12:\"delete-19981\";i:21103;s:12:\"delete-19983\";i:21104;s:12:\"delete-19985\";i:21105;s:12:\"delete-19987\";i:21106;s:12:\"delete-19989\";i:21107;s:12:\"delete-19991\";i:21108;s:12:\"delete-19993\";i:21109;s:12:\"delete-19995\";i:21110;s:12:\"delete-19997\";i:21111;s:12:\"delete-19999\";i:21112;s:12:\"delete-20001\";i:21113;s:12:\"delete-20003\";i:21114;s:12:\"delete-20005\";i:21115;s:12:\"delete-20007\";i:21116;s:12:\"delete-20009\";i:21117;s:12:\"delete-20011\";i:21118;s:12:\"delete-20013\";i:21119;s:12:\"delete-20015\";i:21120;s:12:\"delete-20017\";i:21121;s:12:\"delete-20019\";i:21122;s:12:\"delete-20021\";i:21123;s:12:\"delete-20023\";i:21124;s:12:\"delete-20025\";i:21125;s:12:\"delete-20027\";i:21126;s:12:\"delete-20029\";i:21127;s:12:\"delete-20031\";i:21128;s:12:\"delete-20033\";i:21129;s:12:\"delete-20035\";i:21130;s:12:\"delete-20037\";i:21131;s:12:\"delete-20039\";i:21132;s:12:\"delete-20041\";i:21133;s:12:\"delete-20043\";i:21134;s:12:\"delete-20045\";i:21135;s:12:\"delete-20047\";i:21136;s:12:\"delete-20049\";i:21137;s:12:\"delete-20051\";i:21138;s:12:\"delete-20053\";i:21139;s:12:\"delete-20055\";i:21140;s:12:\"delete-20057\";i:21141;s:12:\"delete-20059\";i:21142;s:12:\"delete-20061\";i:21143;s:12:\"delete-20063\";i:21144;s:12:\"delete-20065\";i:21145;s:12:\"delete-20067\";i:21146;s:12:\"delete-20069\";i:21147;s:12:\"delete-20071\";i:21148;s:12:\"delete-20073\";i:21149;s:12:\"delete-20075\";i:21150;s:12:\"delete-20077\";i:21151;s:12:\"delete-20079\";i:21152;s:12:\"delete-20081\";i:21153;s:12:\"delete-20083\";i:21154;s:12:\"delete-20085\";i:21155;s:12:\"delete-20087\";i:21156;s:12:\"delete-20089\";i:21157;s:12:\"delete-20091\";i:21158;s:12:\"delete-20093\";i:21159;s:12:\"delete-20095\";i:21160;s:12:\"delete-20097\";i:21161;s:12:\"delete-20099\";i:21162;s:12:\"delete-20101\";i:21163;s:12:\"delete-20103\";i:21164;s:12:\"delete-20105\";i:21165;s:12:\"delete-20107\";i:21166;s:12:\"delete-20109\";i:21167;s:12:\"delete-20111\";i:21168;s:12:\"delete-20113\";i:21169;s:12:\"delete-20115\";i:21170;s:12:\"delete-20117\";i:21171;s:12:\"delete-20119\";i:21172;s:12:\"delete-20121\";i:21173;s:12:\"delete-20123\";i:21174;s:12:\"delete-20125\";i:21175;s:12:\"delete-20127\";i:21176;s:12:\"delete-20129\";i:21177;s:12:\"delete-20131\";i:21178;s:12:\"delete-20133\";i:21179;s:12:\"delete-20135\";i:21180;s:12:\"delete-20137\";i:21181;s:12:\"delete-20139\";i:21182;s:12:\"delete-20141\";i:21183;s:12:\"delete-20143\";i:21184;s:12:\"delete-20145\";i:21185;s:12:\"delete-20147\";i:21186;s:12:\"delete-20149\";i:21187;s:12:\"delete-20151\";i:21188;s:12:\"delete-20153\";i:21189;s:12:\"delete-20155\";i:21190;s:12:\"delete-20157\";i:21191;s:12:\"delete-20159\";i:21192;s:12:\"delete-20161\";i:21193;s:12:\"delete-20163\";i:21194;s:12:\"delete-20165\";i:21195;s:12:\"delete-20167\";i:21196;s:12:\"delete-20169\";i:21197;s:12:\"delete-20171\";i:21198;s:12:\"delete-20173\";i:21199;s:12:\"delete-20175\";i:21200;s:12:\"delete-20177\";i:21201;s:12:\"delete-20179\";i:21202;s:12:\"delete-20181\";i:21203;s:12:\"delete-20183\";i:21204;s:12:\"delete-20185\";i:21205;s:12:\"delete-20187\";i:21206;s:12:\"delete-20189\";i:21207;s:12:\"delete-20191\";i:21208;s:12:\"delete-20193\";i:21209;s:12:\"delete-20195\";i:21210;s:12:\"delete-20197\";i:21211;s:12:\"delete-20199\";i:21212;s:12:\"delete-20201\";i:21213;s:12:\"delete-20203\";i:21214;s:12:\"delete-20205\";i:21215;s:12:\"delete-20207\";i:21216;s:12:\"delete-20209\";i:21217;s:12:\"delete-20211\";i:21218;s:12:\"delete-20213\";i:21219;s:12:\"delete-20215\";i:21220;s:12:\"delete-20217\";i:21221;s:12:\"delete-20219\";i:21222;s:12:\"delete-20221\";i:21223;s:12:\"delete-20223\";i:21224;s:12:\"delete-20225\";i:21225;s:12:\"delete-20227\";i:21226;s:12:\"delete-20229\";i:21227;s:12:\"delete-20231\";i:21228;s:12:\"delete-20233\";i:21229;s:12:\"delete-20235\";i:21230;s:12:\"delete-20237\";i:21231;s:12:\"delete-20239\";i:21232;s:12:\"delete-20241\";i:21233;s:12:\"delete-20243\";i:21234;s:12:\"delete-20245\";i:21235;s:12:\"delete-20247\";i:21236;s:12:\"delete-20249\";i:21237;s:12:\"delete-20251\";i:21238;s:12:\"delete-20253\";i:21239;s:12:\"delete-20255\";i:21240;s:12:\"delete-20257\";i:21241;s:12:\"delete-20259\";i:21242;s:12:\"delete-20261\";i:21243;s:12:\"delete-20263\";i:21244;s:12:\"delete-20265\";i:21245;s:12:\"delete-20267\";i:21246;s:12:\"delete-20269\";i:21247;s:12:\"delete-20271\";i:21248;s:12:\"delete-20273\";i:21249;s:12:\"delete-20275\";i:21250;s:12:\"delete-20277\";i:21251;s:12:\"delete-20279\";i:21252;s:12:\"delete-20281\";i:21253;s:12:\"delete-20283\";i:21254;s:12:\"delete-20285\";i:21255;s:12:\"delete-20287\";i:21256;s:12:\"delete-20289\";i:21257;s:12:\"delete-20291\";i:21258;s:12:\"delete-20293\";i:21259;s:12:\"delete-20295\";i:21260;s:12:\"delete-20297\";i:21261;s:12:\"delete-20299\";i:21262;s:12:\"delete-20301\";i:21263;s:12:\"delete-20303\";i:21264;s:12:\"delete-20305\";i:21265;s:12:\"delete-20307\";i:21266;s:12:\"delete-20309\";i:21267;s:12:\"delete-20311\";i:21268;s:12:\"delete-20313\";i:21269;s:12:\"delete-20315\";i:21270;s:12:\"delete-20317\";i:21271;s:12:\"delete-20319\";i:21272;s:12:\"delete-20321\";i:21273;s:12:\"delete-20323\";i:21274;s:12:\"delete-20325\";i:21275;s:12:\"delete-20327\";i:21276;s:12:\"delete-20329\";i:21277;s:12:\"delete-20331\";i:21278;s:12:\"delete-20333\";i:21279;s:12:\"delete-20335\";i:21280;s:12:\"delete-20337\";i:21281;s:12:\"delete-20339\";i:21282;s:12:\"delete-20341\";i:21283;s:12:\"delete-20343\";i:21284;s:12:\"delete-20345\";i:21285;s:12:\"delete-20347\";i:21286;s:12:\"delete-20349\";i:21287;s:12:\"delete-20351\";i:21288;s:12:\"delete-20353\";i:21289;s:12:\"delete-20355\";i:21290;s:12:\"delete-20357\";i:21291;s:12:\"delete-20359\";i:21292;s:12:\"delete-20361\";i:21293;s:12:\"delete-20363\";i:21294;s:12:\"delete-20365\";i:21295;s:12:\"delete-20367\";i:21296;s:12:\"delete-20369\";i:21297;s:12:\"delete-20371\";i:21298;s:12:\"delete-20373\";i:21299;s:12:\"delete-20375\";i:21300;s:12:\"delete-20377\";i:21301;s:12:\"delete-20379\";i:21302;s:12:\"delete-20381\";i:21303;s:12:\"delete-20383\";i:21304;s:12:\"delete-20385\";i:21305;s:12:\"delete-20387\";i:21306;s:12:\"delete-20389\";i:21307;s:12:\"delete-20391\";i:21308;s:12:\"delete-20393\";i:21309;s:12:\"delete-20395\";i:21310;s:12:\"delete-20397\";i:21311;s:12:\"delete-20399\";i:21312;s:12:\"delete-20401\";i:21313;s:12:\"delete-20403\";i:21314;s:12:\"delete-20405\";i:21315;s:12:\"delete-20407\";i:21316;s:12:\"delete-20409\";i:21317;s:12:\"delete-20411\";i:21318;s:12:\"delete-20413\";i:21319;s:12:\"delete-20415\";i:21320;s:12:\"delete-20417\";i:21321;s:12:\"delete-20419\";i:21322;s:12:\"delete-20421\";i:21323;s:12:\"delete-20423\";i:21324;s:12:\"delete-20425\";i:21325;s:12:\"delete-20427\";i:21326;s:12:\"delete-20429\";i:21327;s:12:\"delete-20431\";i:21328;s:12:\"delete-20433\";i:21329;s:12:\"delete-20435\";i:21330;s:12:\"delete-20437\";i:21331;s:12:\"delete-20439\";i:21332;s:12:\"delete-20441\";i:21333;s:12:\"delete-20443\";i:21334;s:12:\"delete-20445\";i:21335;s:12:\"delete-20447\";i:21336;s:12:\"delete-20449\";i:21337;s:12:\"delete-20451\";i:21338;s:12:\"delete-20453\";i:21339;s:12:\"delete-20455\";i:21340;s:12:\"delete-20457\";i:21341;s:12:\"delete-20459\";i:21342;s:12:\"delete-20461\";i:21343;s:12:\"delete-20463\";i:21344;s:12:\"delete-20465\";i:21345;s:12:\"delete-20467\";i:21346;s:12:\"delete-20469\";i:21347;s:12:\"delete-20471\";i:21348;s:12:\"delete-20473\";i:21349;s:12:\"delete-20475\";i:21350;s:12:\"delete-20477\";i:21351;s:12:\"delete-20479\";i:21352;s:12:\"delete-20481\";i:21353;s:12:\"delete-20483\";i:21354;s:12:\"delete-20485\";i:21355;s:12:\"delete-20487\";i:21356;s:12:\"delete-20489\";i:21357;s:12:\"delete-20491\";i:21358;s:12:\"delete-20493\";i:21359;s:12:\"delete-20495\";i:21360;s:12:\"delete-20497\";i:21361;s:12:\"delete-20499\";i:21362;s:12:\"delete-20501\";i:21363;s:12:\"delete-20503\";i:21364;s:12:\"delete-20505\";i:21365;s:12:\"delete-20507\";i:21366;s:12:\"delete-20509\";i:21367;s:12:\"delete-20511\";i:21368;s:12:\"delete-20513\";i:21369;s:12:\"delete-20515\";i:21370;s:12:\"delete-20517\";i:21371;s:12:\"delete-20519\";i:21372;s:12:\"delete-20521\";i:21373;s:12:\"delete-20523\";i:21374;s:12:\"delete-20525\";i:21375;s:12:\"delete-20527\";i:21376;s:12:\"delete-20529\";i:21377;s:12:\"delete-20531\";i:21378;s:12:\"delete-20533\";i:21379;s:12:\"delete-20535\";i:21380;s:12:\"delete-20537\";i:21381;s:12:\"delete-20539\";i:21382;s:12:\"delete-20541\";i:21383;s:12:\"delete-20543\";i:21384;s:12:\"delete-20545\";i:21385;s:12:\"delete-20547\";i:21386;s:12:\"delete-20549\";i:21387;s:12:\"delete-20551\";i:21388;s:12:\"delete-20553\";i:21389;s:12:\"delete-20555\";i:21390;s:12:\"delete-20557\";i:21391;s:12:\"delete-20559\";i:21392;s:12:\"delete-20561\";i:21393;s:12:\"delete-20563\";i:21394;s:12:\"delete-20565\";i:21395;s:12:\"delete-20567\";i:21396;s:12:\"delete-20569\";i:21397;s:12:\"delete-20571\";i:21398;s:12:\"delete-20573\";i:21399;s:12:\"delete-20575\";i:21400;s:12:\"delete-20577\";i:21401;s:12:\"delete-20579\";i:21402;s:12:\"delete-20581\";i:21403;s:12:\"delete-20583\";i:21404;s:12:\"delete-20585\";i:21405;s:12:\"delete-20587\";i:21406;s:12:\"delete-20589\";i:21407;s:12:\"delete-20591\";i:21408;s:12:\"delete-20593\";i:21409;s:12:\"delete-20595\";i:21410;s:12:\"delete-20597\";i:21411;s:12:\"delete-20599\";i:21412;s:12:\"delete-20601\";i:21413;s:12:\"delete-20603\";i:21414;s:12:\"delete-20605\";i:21415;s:12:\"delete-20607\";i:21416;s:12:\"delete-20609\";i:21417;s:12:\"delete-20611\";i:21418;s:12:\"delete-20613\";i:21419;s:12:\"delete-20615\";i:21420;s:12:\"delete-20617\";i:21421;s:12:\"delete-20619\";i:21422;s:12:\"delete-20621\";i:21423;s:12:\"delete-20623\";i:21424;s:12:\"delete-20625\";i:21425;s:12:\"delete-20627\";i:21426;s:12:\"delete-20629\";i:21427;s:12:\"delete-20631\";i:21428;s:12:\"delete-20633\";i:21429;s:12:\"delete-20635\";i:21430;s:12:\"delete-20637\";i:21431;s:12:\"delete-20639\";i:21432;s:12:\"delete-20641\";i:21433;s:12:\"delete-20643\";i:21434;s:12:\"delete-20645\";i:21435;s:12:\"delete-20647\";i:21436;s:12:\"delete-20649\";i:21437;s:12:\"delete-20651\";i:21438;s:12:\"delete-20653\";i:21439;s:12:\"delete-20655\";i:21440;s:12:\"delete-20657\";i:21441;s:12:\"delete-20659\";i:21442;s:12:\"delete-20661\";i:21443;s:12:\"delete-20663\";i:21444;s:12:\"delete-20665\";i:21445;s:12:\"delete-20667\";i:21446;s:12:\"delete-20669\";i:21447;s:12:\"delete-20671\";i:21448;s:12:\"delete-20673\";i:21449;s:12:\"delete-20675\";i:21450;s:12:\"delete-20677\";i:21451;s:12:\"delete-20679\";i:21452;s:12:\"delete-20681\";i:21453;s:12:\"delete-20683\";i:21454;s:12:\"delete-20685\";i:21455;s:12:\"delete-20687\";i:21456;s:12:\"delete-20689\";i:21457;s:12:\"delete-20691\";i:21458;s:12:\"delete-20693\";i:21459;s:12:\"delete-20695\";i:21460;s:12:\"delete-20697\";i:21461;s:12:\"delete-20699\";i:21462;s:12:\"delete-20701\";i:21463;s:12:\"delete-20703\";i:21464;s:12:\"delete-20705\";i:21465;s:12:\"delete-20707\";i:21466;s:12:\"delete-20709\";i:21467;s:12:\"delete-20711\";i:21468;s:12:\"delete-20713\";i:21469;s:12:\"delete-20715\";i:21470;s:12:\"delete-20717\";i:21471;s:12:\"delete-20719\";i:21472;s:12:\"delete-20721\";i:21473;s:12:\"delete-20723\";i:21474;s:12:\"delete-20725\";i:21475;s:12:\"delete-20727\";i:21476;s:12:\"delete-20729\";i:21477;s:12:\"delete-20731\";i:21478;s:12:\"delete-20733\";i:21479;s:12:\"delete-20735\";i:21480;s:12:\"delete-20737\";i:21481;s:12:\"delete-20739\";i:21482;s:12:\"delete-20741\";i:21483;s:12:\"delete-20743\";i:21484;s:12:\"delete-20745\";i:21485;s:12:\"delete-20747\";i:21486;s:12:\"delete-20749\";i:21487;s:12:\"delete-22750\";i:21488;s:12:\"delete-22752\";i:21489;s:12:\"delete-22754\";i:21490;s:12:\"delete-22756\";i:21491;s:12:\"delete-22758\";i:21492;s:12:\"delete-22760\";i:21493;s:12:\"delete-22762\";i:21494;s:12:\"delete-22764\";i:21495;s:12:\"delete-22766\";i:21496;s:12:\"delete-22768\";i:21497;s:12:\"delete-22770\";i:21498;s:12:\"delete-22774\";i:21499;s:12:\"delete-22772\";i:21500;s:12:\"delete-22776\";i:21501;s:12:\"delete-22778\";i:21502;s:12:\"delete-22780\";i:21503;s:12:\"delete-22782\";i:21504;s:12:\"delete-22784\";i:21505;s:12:\"delete-22786\";i:21506;s:12:\"delete-22788\";i:21507;s:12:\"delete-22790\";i:21508;s:12:\"delete-22794\";i:21509;s:12:\"delete-22792\";i:21510;s:12:\"delete-22796\";i:21511;s:12:\"delete-22798\";i:21512;s:12:\"delete-22800\";i:21513;s:12:\"delete-22802\";i:21514;s:12:\"delete-22806\";i:21515;s:12:\"delete-22804\";i:21516;s:12:\"delete-22808\";i:21517;s:12:\"delete-22810\";i:21518;s:12:\"delete-22812\";i:21519;s:12:\"delete-22814\";i:21520;s:12:\"delete-22816\";i:21521;s:12:\"delete-22818\";i:21522;s:12:\"delete-22820\";i:21523;s:12:\"delete-22822\";i:21524;s:12:\"delete-22824\";i:21525;s:12:\"delete-22826\";i:21526;s:12:\"delete-22828\";i:21527;s:12:\"delete-22830\";i:21528;s:12:\"delete-22832\";i:21529;s:12:\"delete-22834\";i:21530;s:12:\"delete-22838\";i:21531;s:12:\"delete-22836\";i:21532;s:12:\"delete-22840\";i:21533;s:12:\"delete-22842\";i:21534;s:12:\"delete-22844\";i:21535;s:12:\"delete-22846\";i:21536;s:12:\"delete-22848\";i:21537;s:12:\"delete-22850\";i:21538;s:12:\"delete-22852\";i:21539;s:12:\"delete-22854\";i:21540;s:12:\"delete-22856\";i:21541;s:12:\"delete-22858\";i:21542;s:12:\"delete-22862\";i:21543;s:12:\"delete-22860\";i:21544;s:12:\"delete-22864\";i:21545;s:12:\"delete-22866\";i:21546;s:12:\"delete-22868\";i:21547;s:12:\"delete-22870\";i:21548;s:12:\"delete-22874\";i:21549;s:12:\"delete-22872\";i:21550;s:12:\"delete-22876\";i:21551;s:12:\"delete-22878\";i:21552;s:12:\"delete-22882\";i:21553;s:12:\"delete-22880\";i:21554;s:12:\"delete-22884\";i:21555;s:12:\"delete-22886\";i:21556;s:12:\"delete-22888\";i:21557;s:12:\"delete-22890\";i:21558;s:12:\"delete-22894\";i:21559;s:12:\"delete-22892\";i:21560;s:12:\"delete-22896\";i:21561;s:12:\"delete-22898\";i:21562;s:12:\"delete-22902\";i:21563;s:12:\"delete-22900\";i:21564;s:12:\"delete-22904\";i:21565;s:12:\"delete-22906\";i:21566;s:12:\"delete-22908\";i:21567;s:12:\"delete-22910\";i:21568;s:12:\"delete-22914\";i:21569;s:12:\"delete-22912\";i:21570;s:12:\"delete-22916\";i:21571;s:12:\"delete-22918\";i:21572;s:12:\"delete-22922\";i:21573;s:12:\"delete-22920\";i:21574;s:12:\"delete-22924\";i:21575;s:12:\"delete-22926\";i:21576;s:12:\"delete-22928\";i:21577;s:12:\"delete-22930\";i:21578;s:12:\"delete-22932\";i:21579;s:12:\"delete-22934\";i:21580;s:12:\"delete-22936\";i:21581;s:12:\"delete-22938\";i:21582;s:12:\"delete-22940\";i:21583;s:12:\"delete-22942\";i:21584;s:12:\"delete-22946\";i:21585;s:12:\"delete-22944\";i:21586;s:12:\"delete-22948\";i:21587;s:12:\"delete-22950\";i:21588;s:12:\"delete-22952\";i:21589;s:12:\"delete-22954\";i:21590;s:12:\"delete-22956\";i:21591;s:12:\"delete-22958\";i:21592;s:12:\"delete-22960\";i:21593;s:12:\"delete-22962\";i:21594;s:12:\"delete-22964\";i:21595;s:12:\"delete-22966\";i:21596;s:12:\"delete-22968\";i:21597;s:12:\"delete-22970\";i:21598;s:12:\"delete-22972\";i:21599;s:12:\"delete-22974\";i:21600;s:12:\"delete-22978\";i:21601;s:12:\"delete-22976\";i:21602;s:12:\"delete-22980\";i:21603;s:12:\"delete-22982\";i:21604;s:12:\"delete-22984\";i:21605;s:12:\"delete-22986\";i:21606;s:12:\"delete-22988\";i:21607;s:12:\"delete-22990\";i:21608;s:12:\"delete-22992\";i:21609;s:12:\"delete-22994\";i:21610;s:12:\"delete-22996\";i:21611;s:12:\"delete-22998\";i:21612;s:12:\"delete-23000\";i:21613;s:12:\"delete-23002\";i:21614;s:12:\"delete-23004\";i:21615;s:12:\"delete-23006\";i:21616;s:12:\"delete-23010\";i:21617;s:12:\"delete-23008\";i:21618;s:12:\"delete-23012\";i:21619;s:12:\"delete-23014\";i:21620;s:12:\"delete-23016\";i:21621;s:12:\"delete-23018\";i:21622;s:12:\"delete-23022\";i:21623;s:12:\"delete-23020\";i:21624;s:12:\"delete-23024\";i:21625;s:12:\"delete-23026\";i:21626;s:12:\"delete-23028\";i:21627;s:12:\"delete-23030\";i:21628;s:12:\"delete-23034\";i:21629;s:12:\"delete-23032\";i:21630;s:12:\"delete-23036\";i:21631;s:12:\"delete-23038\";i:21632;s:12:\"delete-23040\";i:21633;s:12:\"delete-23042\";i:21634;s:12:\"delete-23046\";i:21635;s:12:\"delete-23044\";i:21636;s:12:\"delete-23048\";i:21637;s:12:\"delete-23050\";i:21638;s:12:\"delete-23054\";i:21639;s:12:\"delete-23052\";i:21640;s:12:\"delete-23056\";i:21641;s:12:\"delete-23058\";i:21642;s:12:\"delete-23060\";i:21643;s:12:\"delete-23062\";i:21644;s:12:\"delete-23066\";i:21645;s:12:\"delete-23064\";i:21646;s:12:\"delete-23068\";i:21647;s:12:\"delete-23070\";i:21648;s:12:\"delete-23072\";i:21649;s:12:\"delete-23074\";i:21650;s:12:\"delete-23076\";i:21651;s:12:\"delete-23078\";i:21652;s:12:\"delete-23080\";i:21653;s:12:\"delete-23082\";i:21654;s:12:\"delete-23084\";i:21655;s:12:\"delete-23086\";i:21656;s:12:\"delete-23088\";i:21657;s:12:\"delete-23090\";i:21658;s:12:\"delete-23092\";i:21659;s:12:\"delete-23094\";i:21660;s:12:\"delete-23096\";i:21661;s:12:\"delete-23098\";i:21662;s:12:\"delete-23100\";i:21663;s:12:\"delete-23102\";i:21664;s:12:\"delete-23104\";i:21665;s:12:\"delete-23106\";i:21666;s:12:\"delete-23110\";i:21667;s:12:\"delete-23108\";i:21668;s:12:\"delete-23112\";i:21669;s:12:\"delete-23114\";i:21670;s:12:\"delete-23116\";i:21671;s:12:\"delete-23118\";i:21672;s:12:\"delete-23122\";i:21673;s:12:\"delete-23120\";i:21674;s:12:\"delete-23124\";i:21675;s:12:\"delete-23126\";i:21676;s:12:\"delete-23128\";i:21677;s:12:\"delete-23130\";i:21678;s:12:\"delete-23134\";i:21679;s:12:\"delete-23132\";i:21680;s:12:\"delete-23136\";i:21681;s:12:\"delete-23138\";i:21682;s:12:\"delete-23142\";i:21683;s:12:\"delete-23140\";i:21684;s:12:\"delete-23144\";i:21685;s:12:\"delete-23146\";i:21686;s:12:\"delete-23148\";i:21687;s:12:\"delete-23150\";i:21688;s:12:\"delete-23154\";i:21689;s:12:\"delete-23152\";i:21690;s:12:\"delete-23156\";i:21691;s:12:\"delete-23158\";i:21692;s:12:\"delete-23160\";i:21693;s:12:\"delete-23162\";i:21694;s:12:\"delete-23164\";i:21695;s:12:\"delete-23166\";i:21696;s:12:\"delete-23168\";i:21697;s:12:\"delete-23170\";i:21698;s:12:\"delete-23172\";i:21699;s:12:\"delete-23174\";i:21700;s:12:\"delete-23176\";i:21701;s:12:\"delete-23178\";i:21702;s:12:\"delete-23180\";i:21703;s:12:\"delete-23182\";i:21704;s:12:\"delete-23186\";i:21705;s:12:\"delete-23184\";i:21706;s:12:\"delete-23188\";i:21707;s:12:\"delete-23190\";i:21708;s:12:\"delete-23192\";i:21709;s:12:\"delete-23194\";i:21710;s:12:\"delete-23198\";i:21711;s:12:\"delete-23196\";i:21712;s:12:\"delete-23200\";i:21713;s:12:\"delete-23202\";i:21714;s:12:\"delete-23204\";i:21715;s:12:\"delete-23206\";i:21716;s:12:\"delete-23210\";i:21717;s:12:\"delete-23208\";i:21718;s:12:\"delete-23212\";i:21719;s:12:\"delete-23214\";i:21720;s:12:\"delete-23216\";i:21721;s:12:\"delete-23218\";i:21722;s:12:\"delete-23222\";i:21723;s:12:\"delete-23220\";i:21724;s:12:\"delete-23224\";i:21725;s:12:\"delete-23226\";i:21726;s:12:\"delete-23230\";i:21727;s:12:\"delete-23228\";i:21728;s:12:\"delete-23232\";i:21729;s:12:\"delete-23234\";i:21730;s:12:\"delete-23236\";i:21731;s:12:\"delete-23238\";i:21732;s:12:\"delete-23240\";i:21733;s:12:\"delete-23242\";i:21734;s:12:\"delete-23244\";i:21735;s:12:\"delete-23246\";i:21736;s:12:\"delete-23250\";i:21737;s:12:\"delete-23248\";i:21738;s:12:\"delete-23252\";i:21739;s:12:\"delete-23254\";i:21740;s:12:\"delete-23256\";i:21741;s:12:\"delete-23258\";i:21742;s:12:\"delete-23262\";i:21743;s:12:\"delete-23260\";i:21744;s:12:\"delete-23264\";i:21745;s:12:\"delete-23266\";i:21746;s:12:\"delete-23268\";i:21747;s:12:\"delete-23270\";i:21748;s:12:\"delete-23272\";i:21749;s:12:\"delete-23274\";i:21750;s:12:\"delete-23276\";i:21751;s:12:\"delete-23278\";i:21752;s:12:\"delete-23280\";i:21753;s:12:\"delete-23282\";i:21754;s:12:\"delete-23284\";i:21755;s:12:\"delete-23286\";i:21756;s:12:\"delete-23288\";i:21757;s:12:\"delete-23290\";i:21758;s:12:\"delete-23294\";i:21759;s:12:\"delete-23292\";i:21760;s:12:\"delete-23296\";i:21761;s:12:\"delete-23298\";i:21762;s:12:\"delete-23300\";i:21763;s:12:\"delete-23302\";i:21764;s:12:\"delete-23304\";i:21765;s:12:\"delete-23306\";i:21766;s:12:\"delete-23308\";i:21767;s:12:\"delete-23310\";i:21768;s:12:\"delete-23314\";i:21769;s:12:\"delete-23312\";i:21770;s:12:\"delete-23316\";i:21771;s:12:\"delete-23318\";i:21772;s:12:\"delete-23320\";i:21773;s:12:\"delete-23322\";i:21774;s:12:\"delete-23326\";i:21775;s:12:\"delete-23324\";i:21776;s:12:\"delete-23328\";i:21777;s:12:\"delete-23330\";i:21778;s:12:\"delete-23332\";i:21779;s:12:\"delete-23334\";i:21780;s:12:\"delete-23338\";i:21781;s:12:\"delete-23336\";i:21782;s:12:\"delete-23340\";i:21783;s:12:\"delete-23342\";i:21784;s:12:\"delete-23344\";i:21785;s:12:\"delete-23346\";i:21786;s:12:\"delete-23350\";i:21787;s:12:\"delete-23348\";i:21788;s:12:\"delete-23352\";i:21789;s:12:\"delete-23354\";i:21790;s:12:\"delete-23358\";i:21791;s:12:\"delete-23356\";i:21792;s:12:\"delete-23360\";i:21793;s:12:\"delete-23362\";i:21794;s:12:\"delete-23364\";i:21795;s:12:\"delete-23366\";i:21796;s:12:\"delete-23370\";i:21797;s:12:\"delete-23368\";i:21798;s:12:\"delete-23372\";i:21799;s:12:\"delete-23374\";i:21800;s:12:\"delete-23378\";i:21801;s:12:\"delete-23376\";i:21802;s:12:\"delete-23380\";i:21803;s:12:\"delete-23382\";i:21804;s:12:\"delete-23384\";i:21805;s:12:\"delete-23386\";i:21806;s:12:\"delete-23390\";i:21807;s:12:\"delete-23388\";i:21808;s:12:\"delete-23392\";i:21809;s:12:\"delete-23394\";i:21810;s:12:\"delete-23396\";i:21811;s:12:\"delete-23398\";i:21812;s:12:\"delete-23400\";i:21813;s:12:\"delete-23402\";i:21814;s:12:\"delete-23404\";i:21815;s:12:\"delete-23406\";i:21816;s:12:\"delete-23408\";i:21817;s:12:\"delete-23410\";i:21818;s:12:\"delete-23414\";i:21819;s:12:\"delete-23412\";i:21820;s:12:\"delete-23416\";i:21821;s:12:\"delete-23418\";i:21822;s:12:\"delete-23422\";i:21823;s:12:\"delete-23420\";i:21824;s:12:\"delete-23424\";i:21825;s:12:\"delete-23426\";i:21826;s:12:\"delete-23428\";i:21827;s:12:\"delete-23430\";i:21828;s:12:\"delete-23432\";i:21829;s:12:\"delete-23434\";i:21830;s:12:\"delete-23436\";i:21831;s:12:\"delete-23438\";i:21832;s:12:\"delete-23442\";i:21833;s:12:\"delete-23440\";i:21834;s:12:\"delete-23444\";i:21835;s:12:\"delete-23446\";i:21836;s:12:\"delete-23448\";i:21837;s:12:\"delete-23450\";i:21838;s:12:\"delete-23452\";i:21839;s:12:\"delete-23454\";i:21840;s:12:\"delete-23456\";i:21841;s:12:\"delete-23458\";i:21842;s:12:\"delete-23460\";i:21843;s:12:\"delete-23462\";i:21844;s:12:\"delete-23466\";i:21845;s:12:\"delete-23464\";i:21846;s:12:\"delete-23468\";i:21847;s:12:\"delete-23470\";i:21848;s:12:\"delete-23472\";i:21849;s:12:\"delete-23474\";i:21850;s:12:\"delete-23476\";i:21851;s:12:\"delete-23478\";i:21852;s:12:\"delete-23480\";i:21853;s:12:\"delete-23482\";i:21854;s:12:\"delete-23484\";i:21855;s:12:\"delete-23486\";i:21856;s:12:\"delete-23488\";i:21857;s:12:\"delete-23490\";i:21858;s:12:\"delete-23492\";i:21859;s:12:\"delete-23494\";i:21860;s:12:\"delete-23498\";i:21861;s:12:\"delete-23496\";i:21862;s:12:\"delete-23500\";i:21863;s:12:\"delete-23502\";i:21864;s:12:\"delete-23504\";i:21865;s:12:\"delete-23506\";i:21866;s:12:\"delete-23510\";i:21867;s:12:\"delete-23508\";i:21868;s:12:\"delete-23512\";i:21869;s:12:\"delete-23514\";i:21870;s:12:\"delete-23516\";i:21871;s:12:\"delete-23518\";i:21872;s:12:\"delete-23522\";i:21873;s:12:\"delete-23520\";i:21874;s:12:\"delete-23524\";i:21875;s:12:\"delete-23526\";i:21876;s:12:\"delete-23530\";i:21877;s:12:\"delete-23528\";i:21878;s:12:\"delete-23532\";i:21879;s:12:\"delete-23534\";i:21880;s:12:\"delete-23536\";i:21881;s:12:\"delete-23538\";i:21882;s:12:\"delete-23542\";i:21883;s:12:\"delete-23540\";i:21884;s:12:\"delete-23544\";i:21885;s:12:\"delete-23546\";i:21886;s:12:\"delete-23548\";i:21887;s:12:\"delete-23550\";i:21888;s:12:\"delete-23554\";i:21889;s:12:\"delete-23552\";i:21890;s:12:\"delete-23556\";i:21891;s:12:\"delete-23558\";i:21892;s:12:\"delete-23560\";i:21893;s:12:\"delete-23562\";i:21894;s:12:\"delete-23564\";i:21895;s:12:\"delete-23566\";i:21896;s:12:\"delete-23568\";i:21897;s:12:\"delete-23570\";i:21898;s:12:\"delete-23574\";i:21899;s:12:\"delete-23572\";i:21900;s:12:\"delete-23576\";i:21901;s:12:\"delete-23578\";i:21902;s:12:\"delete-23580\";i:21903;s:12:\"delete-23582\";i:21904;s:12:\"delete-23586\";i:21905;s:12:\"delete-23584\";i:21906;s:12:\"delete-23588\";i:21907;s:12:\"delete-23590\";i:21908;s:12:\"delete-23594\";i:21909;s:12:\"delete-23592\";i:21910;s:12:\"delete-23596\";i:21911;s:12:\"delete-23598\";i:21912;s:12:\"delete-23600\";i:21913;s:12:\"delete-23602\";i:21914;s:12:\"delete-23606\";i:21915;s:12:\"delete-23604\";i:21916;s:12:\"delete-23608\";i:21917;s:12:\"delete-23610\";i:21918;s:12:\"delete-23612\";i:21919;s:12:\"delete-23614\";i:21920;s:12:\"delete-23616\";i:21921;s:12:\"delete-23618\";i:21922;s:12:\"delete-23620\";i:21923;s:12:\"delete-23622\";i:21924;s:12:\"delete-23624\";i:21925;s:12:\"delete-23626\";i:21926;s:12:\"delete-23628\";i:21927;s:12:\"delete-23630\";i:21928;s:12:\"delete-23632\";i:21929;s:12:\"delete-23634\";i:21930;s:12:\"delete-23636\";i:21931;s:12:\"delete-23638\";i:21932;s:12:\"delete-23640\";i:21933;s:12:\"delete-23642\";i:21934;s:12:\"delete-23644\";i:21935;s:12:\"delete-23646\";i:21936;s:12:\"delete-23648\";i:21937;s:12:\"delete-23650\";i:21938;s:12:\"delete-23654\";i:21939;s:12:\"delete-23652\";i:21940;s:12:\"delete-23656\";i:21941;s:12:\"delete-23658\";i:21942;s:12:\"delete-23662\";i:21943;s:12:\"delete-23660\";i:21944;s:12:\"delete-23664\";i:21945;s:12:\"delete-23666\";i:21946;s:12:\"delete-23668\";i:21947;s:12:\"delete-23670\";i:21948;s:12:\"delete-23674\";i:21949;s:12:\"delete-23672\";i:21950;s:12:\"delete-23676\";i:21951;s:12:\"delete-23678\";i:21952;s:12:\"delete-23680\";i:21953;s:12:\"delete-23682\";i:21954;s:12:\"delete-23684\";i:21955;s:12:\"delete-23686\";i:21956;s:12:\"delete-23688\";i:21957;s:12:\"delete-23690\";i:21958;s:12:\"delete-23692\";i:21959;s:12:\"delete-23694\";i:21960;s:12:\"delete-23698\";i:21961;s:12:\"delete-23696\";i:21962;s:12:\"delete-23700\";i:21963;s:12:\"delete-23702\";i:21964;s:12:\"delete-23706\";i:21965;s:12:\"delete-23704\";i:21966;s:12:\"delete-23708\";i:21967;s:12:\"delete-23710\";i:21968;s:12:\"delete-23712\";i:21969;s:12:\"delete-23714\";i:21970;s:12:\"delete-23716\";i:21971;s:12:\"delete-23718\";i:21972;s:12:\"delete-23720\";i:21973;s:12:\"delete-23722\";i:21974;s:12:\"delete-23724\";i:21975;s:12:\"delete-23726\";i:21976;s:12:\"delete-23728\";i:21977;s:12:\"delete-23730\";i:21978;s:12:\"delete-23732\";i:21979;s:12:\"delete-23734\";i:21980;s:12:\"delete-23736\";i:21981;s:12:\"delete-23738\";i:21982;s:12:\"delete-23740\";i:21983;s:12:\"delete-23742\";i:21984;s:12:\"delete-23744\";i:21985;s:12:\"delete-23746\";i:21986;s:12:\"delete-23750\";i:21987;s:12:\"delete-21751\";i:21988;s:12:\"delete-21753\";i:21989;s:12:\"delete-21755\";i:21990;s:12:\"delete-21757\";i:21991;s:12:\"delete-21759\";i:21992;s:12:\"delete-21761\";i:21993;s:12:\"delete-21763\";i:21994;s:12:\"delete-21765\";i:21995;s:12:\"delete-21767\";i:21996;s:12:\"delete-21769\";i:21997;s:12:\"delete-21771\";i:21998;s:12:\"delete-21773\";i:21999;s:12:\"delete-21775\";i:22000;s:12:\"delete-21777\";i:22001;s:12:\"delete-21779\";i:22002;s:12:\"delete-21781\";i:22003;s:12:\"delete-21783\";i:22004;s:12:\"delete-21785\";i:22005;s:12:\"delete-21787\";i:22006;s:12:\"delete-21789\";i:22007;s:12:\"delete-21791\";i:22008;s:12:\"delete-21793\";i:22009;s:12:\"delete-21795\";i:22010;s:12:\"delete-21797\";i:22011;s:12:\"delete-21799\";i:22012;s:12:\"delete-21801\";i:22013;s:12:\"delete-21803\";i:22014;s:12:\"delete-21805\";i:22015;s:12:\"delete-21807\";i:22016;s:12:\"delete-21809\";i:22017;s:12:\"delete-21811\";i:22018;s:12:\"delete-21813\";i:22019;s:12:\"delete-21815\";i:22020;s:12:\"delete-21817\";i:22021;s:12:\"delete-21819\";i:22022;s:12:\"delete-21821\";i:22023;s:12:\"delete-21823\";i:22024;s:12:\"delete-21825\";i:22025;s:12:\"delete-21827\";i:22026;s:12:\"delete-21829\";i:22027;s:12:\"delete-21831\";i:22028;s:12:\"delete-21833\";i:22029;s:12:\"delete-21835\";i:22030;s:12:\"delete-21837\";i:22031;s:12:\"delete-21839\";i:22032;s:12:\"delete-21841\";i:22033;s:12:\"delete-21843\";i:22034;s:12:\"delete-21845\";i:22035;s:12:\"delete-21847\";i:22036;s:12:\"delete-21849\";i:22037;s:12:\"delete-21851\";i:22038;s:12:\"delete-21853\";i:22039;s:12:\"delete-21855\";i:22040;s:12:\"delete-21857\";i:22041;s:12:\"delete-21859\";i:22042;s:12:\"delete-21861\";i:22043;s:12:\"delete-21863\";i:22044;s:12:\"delete-21865\";i:22045;s:12:\"delete-21867\";i:22046;s:12:\"delete-21869\";i:22047;s:12:\"delete-21871\";i:22048;s:12:\"delete-21873\";i:22049;s:12:\"delete-21875\";i:22050;s:12:\"delete-21877\";i:22051;s:12:\"delete-21879\";i:22052;s:12:\"delete-21881\";i:22053;s:12:\"delete-21883\";i:22054;s:12:\"delete-21885\";i:22055;s:12:\"delete-21887\";i:22056;s:12:\"delete-21889\";i:22057;s:12:\"delete-21891\";i:22058;s:12:\"delete-21893\";i:22059;s:12:\"delete-21895\";i:22060;s:12:\"delete-21897\";i:22061;s:12:\"delete-21899\";i:22062;s:12:\"delete-21901\";i:22063;s:12:\"delete-21903\";i:22064;s:12:\"delete-21905\";i:22065;s:12:\"delete-21907\";i:22066;s:12:\"delete-21909\";i:22067;s:12:\"delete-21911\";i:22068;s:12:\"delete-21913\";i:22069;s:12:\"delete-21915\";i:22070;s:12:\"delete-21917\";i:22071;s:12:\"delete-21919\";i:22072;s:12:\"delete-21921\";i:22073;s:12:\"delete-21923\";i:22074;s:12:\"delete-21925\";i:22075;s:12:\"delete-21927\";i:22076;s:12:\"delete-21929\";i:22077;s:12:\"delete-21931\";i:22078;s:12:\"delete-21933\";i:22079;s:12:\"delete-21935\";i:22080;s:12:\"delete-21937\";i:22081;s:12:\"delete-21939\";i:22082;s:12:\"delete-21941\";i:22083;s:12:\"delete-21943\";i:22084;s:12:\"delete-21945\";i:22085;s:12:\"delete-21947\";i:22086;s:12:\"delete-21949\";i:22087;s:12:\"delete-21951\";i:22088;s:12:\"delete-21953\";i:22089;s:12:\"delete-21955\";i:22090;s:12:\"delete-21957\";i:22091;s:12:\"delete-21959\";i:22092;s:12:\"delete-21961\";i:22093;s:12:\"delete-21963\";i:22094;s:12:\"delete-21965\";i:22095;s:12:\"delete-21967\";i:22096;s:12:\"delete-21969\";i:22097;s:12:\"delete-21971\";i:22098;s:12:\"delete-21973\";i:22099;s:12:\"delete-21975\";i:22100;s:12:\"delete-21977\";i:22101;s:12:\"delete-21979\";i:22102;s:12:\"delete-21981\";i:22103;s:12:\"delete-21983\";i:22104;s:12:\"delete-21985\";i:22105;s:12:\"delete-21987\";i:22106;s:12:\"delete-21989\";i:22107;s:12:\"delete-21991\";i:22108;s:12:\"delete-21993\";i:22109;s:12:\"delete-21995\";i:22110;s:12:\"delete-21997\";i:22111;s:12:\"delete-21999\";i:22112;s:12:\"delete-22001\";i:22113;s:12:\"delete-22003\";i:22114;s:12:\"delete-22005\";i:22115;s:12:\"delete-22007\";i:22116;s:12:\"delete-22009\";i:22117;s:12:\"delete-22011\";i:22118;s:12:\"delete-22013\";i:22119;s:12:\"delete-22015\";i:22120;s:12:\"delete-22017\";i:22121;s:12:\"delete-22019\";i:22122;s:12:\"delete-22021\";i:22123;s:12:\"delete-22023\";i:22124;s:12:\"delete-22025\";i:22125;s:12:\"delete-22027\";i:22126;s:12:\"delete-22029\";i:22127;s:12:\"delete-22031\";i:22128;s:12:\"delete-22033\";i:22129;s:12:\"delete-22035\";i:22130;s:12:\"delete-22037\";i:22131;s:12:\"delete-22039\";i:22132;s:12:\"delete-22041\";i:22133;s:12:\"delete-22043\";i:22134;s:12:\"delete-22045\";i:22135;s:12:\"delete-22047\";i:22136;s:12:\"delete-22049\";i:22137;s:12:\"delete-22051\";i:22138;s:12:\"delete-22053\";i:22139;s:12:\"delete-22055\";i:22140;s:12:\"delete-22057\";i:22141;s:12:\"delete-22059\";i:22142;s:12:\"delete-22061\";i:22143;s:12:\"delete-22063\";i:22144;s:12:\"delete-22065\";i:22145;s:12:\"delete-22067\";i:22146;s:12:\"delete-22069\";i:22147;s:12:\"delete-22071\";i:22148;s:12:\"delete-22073\";i:22149;s:12:\"delete-22075\";i:22150;s:12:\"delete-22077\";i:22151;s:12:\"delete-22079\";i:22152;s:12:\"delete-22081\";i:22153;s:12:\"delete-22083\";i:22154;s:12:\"delete-22085\";i:22155;s:12:\"delete-22087\";i:22156;s:12:\"delete-22089\";i:22157;s:12:\"delete-22091\";i:22158;s:12:\"delete-22093\";i:22159;s:12:\"delete-22095\";i:22160;s:12:\"delete-22097\";i:22161;s:12:\"delete-22099\";i:22162;s:12:\"delete-22101\";i:22163;s:12:\"delete-22103\";i:22164;s:12:\"delete-22105\";i:22165;s:12:\"delete-22107\";i:22166;s:12:\"delete-22109\";i:22167;s:12:\"delete-22111\";i:22168;s:12:\"delete-22113\";i:22169;s:12:\"delete-22115\";i:22170;s:12:\"delete-22117\";i:22171;s:12:\"delete-22119\";i:22172;s:12:\"delete-22121\";i:22173;s:12:\"delete-22123\";i:22174;s:12:\"delete-22125\";i:22175;s:12:\"delete-22127\";i:22176;s:12:\"delete-22129\";i:22177;s:12:\"delete-22131\";i:22178;s:12:\"delete-22133\";i:22179;s:12:\"delete-22135\";i:22180;s:12:\"delete-22137\";i:22181;s:12:\"delete-22139\";i:22182;s:12:\"delete-22141\";i:22183;s:12:\"delete-22143\";i:22184;s:12:\"delete-22145\";i:22185;s:12:\"delete-22147\";i:22186;s:12:\"delete-22149\";i:22187;s:12:\"delete-22151\";i:22188;s:12:\"delete-22153\";i:22189;s:12:\"delete-22155\";i:22190;s:12:\"delete-22157\";i:22191;s:12:\"delete-22159\";i:22192;s:12:\"delete-22161\";i:22193;s:12:\"delete-22163\";i:22194;s:12:\"delete-22165\";i:22195;s:12:\"delete-22167\";i:22196;s:12:\"delete-22169\";i:22197;s:12:\"delete-22171\";i:22198;s:12:\"delete-22173\";i:22199;s:12:\"delete-22175\";i:22200;s:12:\"delete-22177\";i:22201;s:12:\"delete-22179\";i:22202;s:12:\"delete-22181\";i:22203;s:12:\"delete-22183\";i:22204;s:12:\"delete-22185\";i:22205;s:12:\"delete-22187\";i:22206;s:12:\"delete-22189\";i:22207;s:12:\"delete-22191\";i:22208;s:12:\"delete-22193\";i:22209;s:12:\"delete-22195\";i:22210;s:12:\"delete-22197\";i:22211;s:12:\"delete-22199\";i:22212;s:12:\"delete-22201\";i:22213;s:12:\"delete-22203\";i:22214;s:12:\"delete-22205\";i:22215;s:12:\"delete-22207\";i:22216;s:12:\"delete-22209\";i:22217;s:12:\"delete-22211\";i:22218;s:12:\"delete-22213\";i:22219;s:12:\"delete-22215\";i:22220;s:12:\"delete-22217\";i:22221;s:12:\"delete-22219\";i:22222;s:12:\"delete-22221\";i:22223;s:12:\"delete-22223\";i:22224;s:12:\"delete-22225\";i:22225;s:12:\"delete-22227\";i:22226;s:12:\"delete-22229\";i:22227;s:12:\"delete-22231\";i:22228;s:12:\"delete-22233\";i:22229;s:12:\"delete-22235\";i:22230;s:12:\"delete-22237\";i:22231;s:12:\"delete-22239\";i:22232;s:12:\"delete-22241\";i:22233;s:12:\"delete-22243\";i:22234;s:12:\"delete-22245\";i:22235;s:12:\"delete-22247\";i:22236;s:12:\"delete-22249\";i:22237;s:12:\"delete-22251\";i:22238;s:12:\"delete-22253\";i:22239;s:12:\"delete-22255\";i:22240;s:12:\"delete-22257\";i:22241;s:12:\"delete-22259\";i:22242;s:12:\"delete-22261\";i:22243;s:12:\"delete-22263\";i:22244;s:12:\"delete-22265\";i:22245;s:12:\"delete-22267\";i:22246;s:12:\"delete-22269\";i:22247;s:12:\"delete-22271\";i:22248;s:12:\"delete-22273\";i:22249;s:12:\"delete-22275\";i:22250;s:12:\"delete-22277\";i:22251;s:12:\"delete-22279\";i:22252;s:12:\"delete-22281\";i:22253;s:12:\"delete-22283\";i:22254;s:12:\"delete-22285\";i:22255;s:12:\"delete-22287\";i:22256;s:12:\"delete-22289\";i:22257;s:12:\"delete-22291\";i:22258;s:12:\"delete-22293\";i:22259;s:12:\"delete-22295\";i:22260;s:12:\"delete-22297\";i:22261;s:12:\"delete-22299\";i:22262;s:12:\"delete-22301\";i:22263;s:12:\"delete-22303\";i:22264;s:12:\"delete-22305\";i:22265;s:12:\"delete-22307\";i:22266;s:12:\"delete-22309\";i:22267;s:12:\"delete-22311\";i:22268;s:12:\"delete-22313\";i:22269;s:12:\"delete-22315\";i:22270;s:12:\"delete-22317\";i:22271;s:12:\"delete-22319\";i:22272;s:12:\"delete-22321\";i:22273;s:12:\"delete-22323\";i:22274;s:12:\"delete-22325\";i:22275;s:12:\"delete-22327\";i:22276;s:12:\"delete-22329\";i:22277;s:12:\"delete-22331\";i:22278;s:12:\"delete-22333\";i:22279;s:12:\"delete-22335\";i:22280;s:12:\"delete-22337\";i:22281;s:12:\"delete-22339\";i:22282;s:12:\"delete-22341\";i:22283;s:12:\"delete-22343\";i:22284;s:12:\"delete-22345\";i:22285;s:12:\"delete-22347\";i:22286;s:12:\"delete-22349\";i:22287;s:12:\"delete-22351\";i:22288;s:12:\"delete-22353\";i:22289;s:12:\"delete-22355\";i:22290;s:12:\"delete-22357\";i:22291;s:12:\"delete-22359\";i:22292;s:12:\"delete-22361\";i:22293;s:12:\"delete-22363\";i:22294;s:12:\"delete-22365\";i:22295;s:12:\"delete-22367\";i:22296;s:12:\"delete-22369\";i:22297;s:12:\"delete-22371\";i:22298;s:12:\"delete-22373\";i:22299;s:12:\"delete-22375\";i:22300;s:12:\"delete-22377\";i:22301;s:12:\"delete-22379\";i:22302;s:12:\"delete-22381\";i:22303;s:12:\"delete-22383\";i:22304;s:12:\"delete-22385\";i:22305;s:12:\"delete-22387\";i:22306;s:12:\"delete-22389\";i:22307;s:12:\"delete-22391\";i:22308;s:12:\"delete-22393\";i:22309;s:12:\"delete-22395\";i:22310;s:12:\"delete-22397\";i:22311;s:12:\"delete-22399\";i:22312;s:12:\"delete-22401\";i:22313;s:12:\"delete-22403\";i:22314;s:12:\"delete-22405\";i:22315;s:12:\"delete-22407\";i:22316;s:12:\"delete-22409\";i:22317;s:12:\"delete-22411\";i:22318;s:12:\"delete-22413\";i:22319;s:12:\"delete-22415\";i:22320;s:12:\"delete-22417\";i:22321;s:12:\"delete-22419\";i:22322;s:12:\"delete-22421\";i:22323;s:12:\"delete-22423\";i:22324;s:12:\"delete-22425\";i:22325;s:12:\"delete-22427\";i:22326;s:12:\"delete-22429\";i:22327;s:12:\"delete-22431\";i:22328;s:12:\"delete-22433\";i:22329;s:12:\"delete-22435\";i:22330;s:12:\"delete-22437\";i:22331;s:12:\"delete-22439\";i:22332;s:12:\"delete-22441\";i:22333;s:12:\"delete-22443\";i:22334;s:12:\"delete-22445\";i:22335;s:12:\"delete-22447\";i:22336;s:12:\"delete-22449\";i:22337;s:12:\"delete-22451\";i:22338;s:12:\"delete-22453\";i:22339;s:12:\"delete-22455\";i:22340;s:12:\"delete-22457\";i:22341;s:12:\"delete-22459\";i:22342;s:12:\"delete-22461\";i:22343;s:12:\"delete-22463\";i:22344;s:12:\"delete-22465\";i:22345;s:12:\"delete-22467\";i:22346;s:12:\"delete-22469\";i:22347;s:12:\"delete-22471\";i:22348;s:12:\"delete-22473\";i:22349;s:12:\"delete-22475\";i:22350;s:12:\"delete-22477\";i:22351;s:12:\"delete-22479\";i:22352;s:12:\"delete-22481\";i:22353;s:12:\"delete-22483\";i:22354;s:12:\"delete-22485\";i:22355;s:12:\"delete-22487\";i:22356;s:12:\"delete-22489\";i:22357;s:12:\"delete-22491\";i:22358;s:12:\"delete-22493\";i:22359;s:12:\"delete-22495\";i:22360;s:12:\"delete-22497\";i:22361;s:12:\"delete-22499\";i:22362;s:12:\"delete-22501\";i:22363;s:12:\"delete-22503\";i:22364;s:12:\"delete-22505\";i:22365;s:12:\"delete-22507\";i:22366;s:12:\"delete-22509\";i:22367;s:12:\"delete-22511\";i:22368;s:12:\"delete-22513\";i:22369;s:12:\"delete-22515\";i:22370;s:12:\"delete-22517\";i:22371;s:12:\"delete-22519\";i:22372;s:12:\"delete-22521\";i:22373;s:12:\"delete-22523\";i:22374;s:12:\"delete-22525\";i:22375;s:12:\"delete-22527\";i:22376;s:12:\"delete-22529\";i:22377;s:12:\"delete-22531\";i:22378;s:12:\"delete-22533\";i:22379;s:12:\"delete-22535\";i:22380;s:12:\"delete-22537\";i:22381;s:12:\"delete-22539\";i:22382;s:12:\"delete-22541\";i:22383;s:12:\"delete-22543\";i:22384;s:12:\"delete-22545\";i:22385;s:12:\"delete-22547\";i:22386;s:12:\"delete-22549\";i:22387;s:12:\"delete-22551\";i:22388;s:12:\"delete-22553\";i:22389;s:12:\"delete-22555\";i:22390;s:12:\"delete-22557\";i:22391;s:12:\"delete-22559\";i:22392;s:12:\"delete-22561\";i:22393;s:12:\"delete-22563\";i:22394;s:12:\"delete-22565\";i:22395;s:12:\"delete-22567\";i:22396;s:12:\"delete-22569\";i:22397;s:12:\"delete-22571\";i:22398;s:12:\"delete-22573\";i:22399;s:12:\"delete-22575\";i:22400;s:12:\"delete-22577\";i:22401;s:12:\"delete-22579\";i:22402;s:12:\"delete-22581\";i:22403;s:12:\"delete-22583\";i:22404;s:12:\"delete-22585\";i:22405;s:12:\"delete-22587\";i:22406;s:12:\"delete-22589\";i:22407;s:12:\"delete-22591\";i:22408;s:12:\"delete-22593\";i:22409;s:12:\"delete-22595\";i:22410;s:12:\"delete-22597\";i:22411;s:12:\"delete-22599\";i:22412;s:12:\"delete-22601\";i:22413;s:12:\"delete-22603\";i:22414;s:12:\"delete-22605\";i:22415;s:12:\"delete-22607\";i:22416;s:12:\"delete-22609\";i:22417;s:12:\"delete-22611\";i:22418;s:12:\"delete-22613\";i:22419;s:12:\"delete-22615\";i:22420;s:12:\"delete-22617\";i:22421;s:12:\"delete-22619\";i:22422;s:12:\"delete-22621\";i:22423;s:12:\"delete-22623\";i:22424;s:12:\"delete-22625\";i:22425;s:12:\"delete-22627\";i:22426;s:12:\"delete-22629\";i:22427;s:12:\"delete-22631\";i:22428;s:12:\"delete-22633\";i:22429;s:12:\"delete-22635\";i:22430;s:12:\"delete-22637\";i:22431;s:12:\"delete-22639\";i:22432;s:12:\"delete-22641\";i:22433;s:12:\"delete-22643\";i:22434;s:12:\"delete-22645\";i:22435;s:12:\"delete-22647\";i:22436;s:12:\"delete-22649\";i:22437;s:12:\"delete-22651\";i:22438;s:12:\"delete-22653\";i:22439;s:12:\"delete-22655\";i:22440;s:12:\"delete-22657\";i:22441;s:12:\"delete-22659\";i:22442;s:12:\"delete-22661\";i:22443;s:12:\"delete-22663\";i:22444;s:12:\"delete-22665\";i:22445;s:12:\"delete-22667\";i:22446;s:12:\"delete-22669\";i:22447;s:12:\"delete-22671\";i:22448;s:12:\"delete-22673\";i:22449;s:12:\"delete-22675\";i:22450;s:12:\"delete-22677\";i:22451;s:12:\"delete-22679\";i:22452;s:12:\"delete-22681\";i:22453;s:12:\"delete-22683\";i:22454;s:12:\"delete-22685\";i:22455;s:12:\"delete-22687\";i:22456;s:12:\"delete-22689\";i:22457;s:12:\"delete-22691\";i:22458;s:12:\"delete-22693\";i:22459;s:12:\"delete-22695\";i:22460;s:12:\"delete-22697\";i:22461;s:12:\"delete-22699\";i:22462;s:12:\"delete-22701\";i:22463;s:12:\"delete-22703\";i:22464;s:12:\"delete-22705\";i:22465;s:12:\"delete-22707\";i:22466;s:12:\"delete-22709\";i:22467;s:12:\"delete-22711\";i:22468;s:12:\"delete-22713\";i:22469;s:12:\"delete-22715\";i:22470;s:12:\"delete-22717\";i:22471;s:12:\"delete-22719\";i:22472;s:12:\"delete-22721\";i:22473;s:12:\"delete-22723\";i:22474;s:12:\"delete-22725\";i:22475;s:12:\"delete-22727\";i:22476;s:12:\"delete-22729\";i:22477;s:12:\"delete-22731\";i:22478;s:12:\"delete-22733\";i:22479;s:12:\"delete-22735\";i:22480;s:12:\"delete-22737\";i:22481;s:12:\"delete-22739\";i:22482;s:12:\"delete-22741\";i:22483;s:12:\"delete-22743\";i:22484;s:12:\"delete-22745\";i:22485;s:12:\"delete-22747\";i:22486;s:12:\"delete-22749\";i:22487;s:12:\"delete-22751\";i:22488;s:12:\"delete-22753\";i:22489;s:12:\"delete-22755\";i:22490;s:12:\"delete-22757\";i:22491;s:12:\"delete-22759\";i:22492;s:12:\"delete-22761\";i:22493;s:12:\"delete-22763\";i:22494;s:12:\"delete-22765\";i:22495;s:12:\"delete-22767\";i:22496;s:12:\"delete-22769\";i:22497;s:12:\"delete-22771\";i:22498;s:12:\"delete-22773\";i:22499;s:12:\"delete-22775\";i:22500;s:12:\"delete-22777\";i:22501;s:12:\"delete-22779\";i:22502;s:12:\"delete-22781\";i:22503;s:12:\"delete-22783\";i:22504;s:12:\"delete-22785\";i:22505;s:12:\"delete-22787\";i:22506;s:12:\"delete-22789\";i:22507;s:12:\"delete-22791\";i:22508;s:12:\"delete-22793\";i:22509;s:12:\"delete-22795\";i:22510;s:12:\"delete-22797\";i:22511;s:12:\"delete-22799\";i:22512;s:12:\"delete-22801\";i:22513;s:12:\"delete-22803\";i:22514;s:12:\"delete-22805\";i:22515;s:12:\"delete-22807\";i:22516;s:12:\"delete-22809\";i:22517;s:12:\"delete-22811\";i:22518;s:12:\"delete-22813\";i:22519;s:12:\"delete-22815\";i:22520;s:12:\"delete-22817\";i:22521;s:12:\"delete-22819\";i:22522;s:12:\"delete-22821\";i:22523;s:12:\"delete-22823\";i:22524;s:12:\"delete-22825\";i:22525;s:12:\"delete-22827\";i:22526;s:12:\"delete-22829\";i:22527;s:12:\"delete-22831\";i:22528;s:12:\"delete-22833\";i:22529;s:12:\"delete-22835\";i:22530;s:12:\"delete-22837\";i:22531;s:12:\"delete-22839\";i:22532;s:12:\"delete-22841\";i:22533;s:12:\"delete-22843\";i:22534;s:12:\"delete-22845\";i:22535;s:12:\"delete-22847\";i:22536;s:12:\"delete-22849\";i:22537;s:12:\"delete-22851\";i:22538;s:12:\"delete-22853\";i:22539;s:12:\"delete-22855\";i:22540;s:12:\"delete-22857\";i:22541;s:12:\"delete-22859\";i:22542;s:12:\"delete-22861\";i:22543;s:12:\"delete-22863\";i:22544;s:12:\"delete-22865\";i:22545;s:12:\"delete-22867\";i:22546;s:12:\"delete-22869\";i:22547;s:12:\"delete-22871\";i:22548;s:12:\"delete-22873\";i:22549;s:12:\"delete-22875\";i:22550;s:12:\"delete-22877\";i:22551;s:12:\"delete-22879\";i:22552;s:12:\"delete-22881\";i:22553;s:12:\"delete-22883\";i:22554;s:12:\"delete-22885\";i:22555;s:12:\"delete-22887\";i:22556;s:12:\"delete-22889\";i:22557;s:12:\"delete-22891\";i:22558;s:12:\"delete-22893\";i:22559;s:12:\"delete-22895\";i:22560;s:12:\"delete-22897\";i:22561;s:12:\"delete-22899\";i:22562;s:12:\"delete-22901\";i:22563;s:12:\"delete-22903\";i:22564;s:12:\"delete-22905\";i:22565;s:12:\"delete-22907\";i:22566;s:12:\"delete-22909\";i:22567;s:12:\"delete-22911\";i:22568;s:12:\"delete-22913\";i:22569;s:12:\"delete-22915\";i:22570;s:12:\"delete-22917\";i:22571;s:12:\"delete-22919\";i:22572;s:12:\"delete-22921\";i:22573;s:12:\"delete-22923\";i:22574;s:12:\"delete-22925\";i:22575;s:12:\"delete-22927\";i:22576;s:12:\"delete-22929\";i:22577;s:12:\"delete-22931\";i:22578;s:12:\"delete-22933\";i:22579;s:12:\"delete-22935\";i:22580;s:12:\"delete-22937\";i:22581;s:12:\"delete-22939\";i:22582;s:12:\"delete-22941\";i:22583;s:12:\"delete-22943\";i:22584;s:12:\"delete-22945\";i:22585;s:12:\"delete-22947\";i:22586;s:12:\"delete-22949\";i:22587;s:12:\"delete-22951\";i:22588;s:12:\"delete-22953\";i:22589;s:12:\"delete-22955\";i:22590;s:12:\"delete-22957\";i:22591;s:12:\"delete-22959\";i:22592;s:12:\"delete-22961\";i:22593;s:12:\"delete-22963\";i:22594;s:12:\"delete-22965\";i:22595;s:12:\"delete-22967\";i:22596;s:12:\"delete-22969\";i:22597;s:12:\"delete-22971\";i:22598;s:12:\"delete-22973\";i:22599;s:12:\"delete-22975\";i:22600;s:12:\"delete-22977\";i:22601;s:12:\"delete-22979\";i:22602;s:12:\"delete-22981\";i:22603;s:12:\"delete-22983\";i:22604;s:12:\"delete-22985\";i:22605;s:12:\"delete-22987\";i:22606;s:12:\"delete-22989\";i:22607;s:12:\"delete-22991\";i:22608;s:12:\"delete-22993\";i:22609;s:12:\"delete-22995\";i:22610;s:12:\"delete-22997\";i:22611;s:12:\"delete-22999\";i:22612;s:12:\"delete-23001\";i:22613;s:12:\"delete-23003\";i:22614;s:12:\"delete-23005\";i:22615;s:12:\"delete-23007\";i:22616;s:12:\"delete-23009\";i:22617;s:12:\"delete-23011\";i:22618;s:12:\"delete-23013\";i:22619;s:12:\"delete-23015\";i:22620;s:12:\"delete-23017\";i:22621;s:12:\"delete-23019\";i:22622;s:12:\"delete-23021\";i:22623;s:12:\"delete-23023\";i:22624;s:12:\"delete-23025\";i:22625;s:12:\"delete-23027\";i:22626;s:12:\"delete-23029\";i:22627;s:12:\"delete-23031\";i:22628;s:12:\"delete-23033\";i:22629;s:12:\"delete-23035\";i:22630;s:12:\"delete-23037\";i:22631;s:12:\"delete-23039\";i:22632;s:12:\"delete-23041\";i:22633;s:12:\"delete-23043\";i:22634;s:12:\"delete-23045\";i:22635;s:12:\"delete-23047\";i:22636;s:12:\"delete-23049\";i:22637;s:12:\"delete-23051\";i:22638;s:12:\"delete-23053\";i:22639;s:12:\"delete-23055\";i:22640;s:12:\"delete-23057\";i:22641;s:12:\"delete-23059\";i:22642;s:12:\"delete-23061\";i:22643;s:12:\"delete-23063\";i:22644;s:12:\"delete-23065\";i:22645;s:12:\"delete-23067\";i:22646;s:12:\"delete-23069\";i:22647;s:12:\"delete-23071\";i:22648;s:12:\"delete-23073\";i:22649;s:12:\"delete-23075\";i:22650;s:12:\"delete-23077\";i:22651;s:12:\"delete-23079\";i:22652;s:12:\"delete-23081\";i:22653;s:12:\"delete-23083\";i:22654;s:12:\"delete-23085\";i:22655;s:12:\"delete-23087\";i:22656;s:12:\"delete-23089\";i:22657;s:12:\"delete-23091\";i:22658;s:12:\"delete-23093\";i:22659;s:12:\"delete-23095\";i:22660;s:12:\"delete-23097\";i:22661;s:12:\"delete-23099\";i:22662;s:12:\"delete-23101\";i:22663;s:12:\"delete-23103\";i:22664;s:12:\"delete-23105\";i:22665;s:12:\"delete-23107\";i:22666;s:12:\"delete-23109\";i:22667;s:12:\"delete-23111\";i:22668;s:12:\"delete-23113\";i:22669;s:12:\"delete-23115\";i:22670;s:12:\"delete-23117\";i:22671;s:12:\"delete-23119\";i:22672;s:12:\"delete-23121\";i:22673;s:12:\"delete-23123\";i:22674;s:12:\"delete-23125\";i:22675;s:12:\"delete-23127\";i:22676;s:12:\"delete-23129\";i:22677;s:12:\"delete-23131\";i:22678;s:12:\"delete-23133\";i:22679;s:12:\"delete-23135\";i:22680;s:12:\"delete-23137\";i:22681;s:12:\"delete-23139\";i:22682;s:12:\"delete-23141\";i:22683;s:12:\"delete-23143\";i:22684;s:12:\"delete-23145\";i:22685;s:12:\"delete-23147\";i:22686;s:12:\"delete-23149\";i:22687;s:12:\"delete-23151\";i:22688;s:12:\"delete-23153\";i:22689;s:12:\"delete-23155\";i:22690;s:12:\"delete-23157\";i:22691;s:12:\"delete-23159\";i:22692;s:12:\"delete-23161\";i:22693;s:12:\"delete-23163\";i:22694;s:12:\"delete-23165\";i:22695;s:12:\"delete-23167\";i:22696;s:12:\"delete-23169\";i:22697;s:12:\"delete-23171\";i:22698;s:12:\"delete-23173\";i:22699;s:12:\"delete-23175\";i:22700;s:12:\"delete-23177\";i:22701;s:12:\"delete-23179\";i:22702;s:12:\"delete-23181\";i:22703;s:12:\"delete-23183\";i:22704;s:12:\"delete-23185\";i:22705;s:12:\"delete-23187\";i:22706;s:12:\"delete-23189\";i:22707;s:12:\"delete-23191\";i:22708;s:12:\"delete-23193\";i:22709;s:12:\"delete-23195\";i:22710;s:12:\"delete-23197\";i:22711;s:12:\"delete-23199\";i:22712;s:12:\"delete-23201\";i:22713;s:12:\"delete-23203\";i:22714;s:12:\"delete-23205\";i:22715;s:12:\"delete-23207\";i:22716;s:12:\"delete-23209\";i:22717;s:12:\"delete-23211\";i:22718;s:12:\"delete-23213\";i:22719;s:12:\"delete-23215\";i:22720;s:12:\"delete-23217\";i:22721;s:12:\"delete-23219\";i:22722;s:12:\"delete-23221\";i:22723;s:12:\"delete-23223\";i:22724;s:12:\"delete-23225\";i:22725;s:12:\"delete-23227\";i:22726;s:12:\"delete-23229\";i:22727;s:12:\"delete-23231\";i:22728;s:12:\"delete-23233\";i:22729;s:12:\"delete-23235\";i:22730;s:12:\"delete-23237\";i:22731;s:12:\"delete-23239\";i:22732;s:12:\"delete-23241\";i:22733;s:12:\"delete-23243\";i:22734;s:12:\"delete-23245\";i:22735;s:12:\"delete-23247\";i:22736;s:12:\"delete-23249\";i:22737;s:12:\"delete-23251\";i:22738;s:12:\"delete-23253\";i:22739;s:12:\"delete-23255\";i:22740;s:12:\"delete-23257\";i:22741;s:12:\"delete-23259\";i:22742;s:12:\"delete-23261\";i:22743;s:12:\"delete-23263\";i:22744;s:12:\"delete-23265\";i:22745;s:12:\"delete-23267\";i:22746;s:12:\"delete-23269\";i:22747;s:12:\"delete-23271\";i:22748;s:12:\"delete-23273\";i:22749;s:12:\"delete-23275\";i:22750;s:12:\"delete-23277\";i:22751;s:12:\"delete-23279\";i:22752;s:12:\"delete-23281\";i:22753;s:12:\"delete-23283\";i:22754;s:12:\"delete-23285\";i:22755;s:12:\"delete-23287\";i:22756;s:12:\"delete-23289\";i:22757;s:12:\"delete-23291\";i:22758;s:12:\"delete-23293\";i:22759;s:12:\"delete-23295\";i:22760;s:12:\"delete-23297\";i:22761;s:12:\"delete-23299\";i:22762;s:12:\"delete-23301\";i:22763;s:12:\"delete-23303\";i:22764;s:12:\"delete-23305\";i:22765;s:12:\"delete-23307\";i:22766;s:12:\"delete-23309\";i:22767;s:12:\"delete-23311\";i:22768;s:12:\"delete-23313\";i:22769;s:12:\"delete-23315\";i:22770;s:12:\"delete-23317\";i:22771;s:12:\"delete-23319\";i:22772;s:12:\"delete-23321\";i:22773;s:12:\"delete-23323\";i:22774;s:12:\"delete-23325\";i:22775;s:12:\"delete-23327\";i:22776;s:12:\"delete-23329\";i:22777;s:12:\"delete-23331\";i:22778;s:12:\"delete-23333\";i:22779;s:12:\"delete-23335\";i:22780;s:12:\"delete-23337\";i:22781;s:12:\"delete-23339\";i:22782;s:12:\"delete-23341\";i:22783;s:12:\"delete-23343\";i:22784;s:12:\"delete-23345\";i:22785;s:12:\"delete-23347\";i:22786;s:12:\"delete-23349\";i:22787;s:12:\"delete-23351\";i:22788;s:12:\"delete-23353\";i:22789;s:12:\"delete-23355\";i:22790;s:12:\"delete-23357\";i:22791;s:12:\"delete-23359\";i:22792;s:12:\"delete-23361\";i:22793;s:12:\"delete-23363\";i:22794;s:12:\"delete-23365\";i:22795;s:12:\"delete-23367\";i:22796;s:12:\"delete-23369\";i:22797;s:12:\"delete-23371\";i:22798;s:12:\"delete-23373\";i:22799;s:12:\"delete-23375\";i:22800;s:12:\"delete-23377\";i:22801;s:12:\"delete-23379\";i:22802;s:12:\"delete-23381\";i:22803;s:12:\"delete-23383\";i:22804;s:12:\"delete-23385\";i:22805;s:12:\"delete-23387\";i:22806;s:12:\"delete-23389\";i:22807;s:12:\"delete-23391\";i:22808;s:12:\"delete-23393\";i:22809;s:12:\"delete-23395\";i:22810;s:12:\"delete-23397\";i:22811;s:12:\"delete-23399\";i:22812;s:12:\"delete-23401\";i:22813;s:12:\"delete-23403\";i:22814;s:12:\"delete-23405\";i:22815;s:12:\"delete-23407\";i:22816;s:12:\"delete-23409\";i:22817;s:12:\"delete-23411\";i:22818;s:12:\"delete-23413\";i:22819;s:12:\"delete-23415\";i:22820;s:12:\"delete-23417\";i:22821;s:12:\"delete-23419\";i:22822;s:12:\"delete-23421\";i:22823;s:12:\"delete-23423\";i:22824;s:12:\"delete-23425\";i:22825;s:12:\"delete-23427\";i:22826;s:12:\"delete-23429\";i:22827;s:12:\"delete-23431\";i:22828;s:12:\"delete-23433\";i:22829;s:12:\"delete-23435\";i:22830;s:12:\"delete-23437\";i:22831;s:12:\"delete-23439\";i:22832;s:12:\"delete-23441\";i:22833;s:12:\"delete-23443\";i:22834;s:12:\"delete-23445\";i:22835;s:12:\"delete-23447\";i:22836;s:12:\"delete-23449\";i:22837;s:12:\"delete-23451\";i:22838;s:12:\"delete-23453\";i:22839;s:12:\"delete-23455\";i:22840;s:12:\"delete-23457\";i:22841;s:12:\"delete-23459\";i:22842;s:12:\"delete-23461\";i:22843;s:12:\"delete-23463\";i:22844;s:12:\"delete-23465\";i:22845;s:12:\"delete-23467\";i:22846;s:12:\"delete-23469\";i:22847;s:12:\"delete-23471\";i:22848;s:12:\"delete-23473\";i:22849;s:12:\"delete-23475\";i:22850;s:12:\"delete-23477\";i:22851;s:12:\"delete-23479\";i:22852;s:12:\"delete-23481\";i:22853;s:12:\"delete-23483\";i:22854;s:12:\"delete-23485\";i:22855;s:12:\"delete-23487\";i:22856;s:12:\"delete-23489\";i:22857;s:12:\"delete-23491\";i:22858;s:12:\"delete-23493\";i:22859;s:12:\"delete-23495\";i:22860;s:12:\"delete-23497\";i:22861;s:12:\"delete-23499\";i:22862;s:12:\"delete-23501\";i:22863;s:12:\"delete-23503\";i:22864;s:12:\"delete-23505\";i:22865;s:12:\"delete-23507\";i:22866;s:12:\"delete-23509\";i:22867;s:12:\"delete-23511\";i:22868;s:12:\"delete-23513\";i:22869;s:12:\"delete-23515\";i:22870;s:12:\"delete-23517\";i:22871;s:12:\"delete-23519\";i:22872;s:12:\"delete-23521\";i:22873;s:12:\"delete-23523\";i:22874;s:12:\"delete-23525\";i:22875;s:12:\"delete-23527\";i:22876;s:12:\"delete-23529\";i:22877;s:12:\"delete-23531\";i:22878;s:12:\"delete-23533\";i:22879;s:12:\"delete-23535\";i:22880;s:12:\"delete-23537\";i:22881;s:12:\"delete-23539\";i:22882;s:12:\"delete-23541\";i:22883;s:12:\"delete-23543\";i:22884;s:12:\"delete-23545\";i:22885;s:12:\"delete-23547\";i:22886;s:12:\"delete-23549\";i:22887;s:12:\"delete-23551\";i:22888;s:12:\"delete-23553\";i:22889;s:12:\"delete-23555\";i:22890;s:12:\"delete-23557\";i:22891;s:12:\"delete-23559\";i:22892;s:12:\"delete-23561\";i:22893;s:12:\"delete-23563\";i:22894;s:12:\"delete-23565\";i:22895;s:12:\"delete-23567\";i:22896;s:12:\"delete-23569\";i:22897;s:12:\"delete-23571\";i:22898;s:12:\"delete-23573\";i:22899;s:12:\"delete-23575\";i:22900;s:12:\"delete-23577\";i:22901;s:12:\"delete-23579\";i:22902;s:12:\"delete-23581\";i:22903;s:12:\"delete-23583\";i:22904;s:12:\"delete-23585\";i:22905;s:12:\"delete-23587\";i:22906;s:12:\"delete-23589\";i:22907;s:12:\"delete-23591\";i:22908;s:12:\"delete-23593\";i:22909;s:12:\"delete-23595\";i:22910;s:12:\"delete-23597\";i:22911;s:12:\"delete-23599\";i:22912;s:12:\"delete-23601\";i:22913;s:12:\"delete-23603\";i:22914;s:12:\"delete-23605\";i:22915;s:12:\"delete-23607\";i:22916;s:12:\"delete-23609\";i:22917;s:12:\"delete-23611\";i:22918;s:12:\"delete-23613\";i:22919;s:12:\"delete-23615\";i:22920;s:12:\"delete-23617\";i:22921;s:12:\"delete-23619\";i:22922;s:12:\"delete-23621\";i:22923;s:12:\"delete-23623\";i:22924;s:12:\"delete-23625\";i:22925;s:12:\"delete-23627\";i:22926;s:12:\"delete-23629\";i:22927;s:12:\"delete-23631\";i:22928;s:12:\"delete-23633\";i:22929;s:12:\"delete-23635\";i:22930;s:12:\"delete-23637\";i:22931;s:12:\"delete-23639\";i:22932;s:12:\"delete-23641\";i:22933;s:12:\"delete-23643\";i:22934;s:12:\"delete-23645\";i:22935;s:12:\"delete-23647\";i:22936;s:12:\"delete-23649\";i:22937;s:12:\"delete-23651\";i:22938;s:12:\"delete-23653\";i:22939;s:12:\"delete-23655\";i:22940;s:12:\"delete-23657\";i:22941;s:12:\"delete-23659\";i:22942;s:12:\"delete-23661\";i:22943;s:12:\"delete-23663\";i:22944;s:12:\"delete-23665\";i:22945;s:12:\"delete-23667\";i:22946;s:12:\"delete-23669\";i:22947;s:12:\"delete-23671\";i:22948;s:12:\"delete-23673\";i:22949;s:12:\"delete-23675\";i:22950;s:12:\"delete-23677\";i:22951;s:12:\"delete-23679\";i:22952;s:12:\"delete-23681\";i:22953;s:12:\"delete-23683\";i:22954;s:12:\"delete-23685\";i:22955;s:12:\"delete-23687\";i:22956;s:12:\"delete-23689\";i:22957;s:12:\"delete-23691\";i:22958;s:12:\"delete-23693\";i:22959;s:12:\"delete-23695\";i:22960;s:12:\"delete-23697\";i:22961;s:12:\"delete-23699\";i:22962;s:12:\"delete-23701\";i:22963;s:12:\"delete-23703\";i:22964;s:12:\"delete-23705\";i:22965;s:12:\"delete-23707\";i:22966;s:12:\"delete-23709\";i:22967;s:12:\"delete-23711\";i:22968;s:12:\"delete-23713\";i:22969;s:12:\"delete-23715\";i:22970;s:12:\"delete-23717\";i:22971;s:12:\"delete-23719\";i:22972;s:12:\"delete-23721\";i:22973;s:12:\"delete-23723\";i:22974;s:12:\"delete-23725\";i:22975;s:12:\"delete-23727\";i:22976;s:12:\"delete-23729\";i:22977;s:12:\"delete-23731\";i:22978;s:12:\"delete-23733\";i:22979;s:12:\"delete-23735\";i:22980;s:12:\"delete-23737\";i:22981;s:12:\"delete-23739\";i:22982;s:12:\"delete-23741\";i:22983;s:12:\"delete-23743\";i:22984;s:12:\"delete-23745\";i:22985;s:12:\"delete-23747\";i:22986;s:12:\"delete-23749\";i:22987;s:8:\"delete-2\";i:22988;s:8:\"delete-3\";i:22989;s:8:\"delete-4\";i:22990;s:8:\"delete-5\";i:22991;s:8:\"delete-6\";i:22992;s:8:\"delete-8\";i:22993;s:8:\"delete-9\";i:22994;s:9:\"delete-10\";i:22995;s:9:\"delete-11\";i:22996;s:9:\"delete-12\";i:22997;s:9:\"delete-13\";i:22998;s:9:\"delete-14\";i:22999;s:9:\"delete-15\";i:23000;s:9:\"delete-16\";i:23001;s:9:\"delete-17\";i:23002;s:9:\"delete-18\";i:23003;s:9:\"delete-19\";i:23004;s:9:\"delete-20\";i:23005;s:9:\"delete-21\";i:23006;s:9:\"delete-22\";i:23007;s:9:\"delete-23\";i:23008;s:9:\"delete-24\";i:23009;s:9:\"delete-25\";i:23010;s:9:\"delete-26\";i:23011;s:9:\"delete-27\";i:23012;s:9:\"delete-28\";i:23013;s:9:\"delete-29\";i:23014;s:9:\"delete-30\";i:23015;s:9:\"delete-31\";i:23016;s:9:\"delete-32\";i:23017;s:9:\"delete-33\";i:23018;s:9:\"delete-34\";i:23019;s:9:\"delete-35\";i:23020;s:9:\"delete-36\";i:23021;s:9:\"delete-37\";i:23022;s:9:\"delete-38\";i:23023;s:9:\"delete-39\";i:23024;s:9:\"delete-40\";i:23025;s:9:\"delete-41\";i:23026;s:9:\"delete-42\";i:23027;s:9:\"delete-43\";i:23028;s:9:\"delete-44\";i:23029;s:9:\"delete-45\";i:23030;s:9:\"delete-46\";i:23031;s:9:\"delete-47\";i:23032;s:9:\"delete-48\";i:23033;s:9:\"delete-49\";i:23034;s:9:\"delete-50\";i:23035;s:9:\"delete-51\";i:23036;s:9:\"delete-52\";i:23037;s:9:\"delete-53\";i:23038;s:9:\"delete-54\";i:23039;s:9:\"delete-55\";i:23040;s:9:\"delete-56\";i:23041;s:9:\"delete-57\";i:23042;s:9:\"delete-58\";i:23043;s:9:\"delete-59\";i:23044;s:9:\"delete-60\";i:23045;s:9:\"delete-61\";i:23046;s:9:\"delete-62\";i:23047;s:9:\"delete-63\";i:23048;s:9:\"delete-64\";i:23049;s:9:\"delete-65\";i:23050;s:9:\"delete-66\";i:23051;s:9:\"delete-67\";i:23052;s:9:\"delete-68\";i:23053;s:9:\"delete-69\";i:23054;s:9:\"delete-70\";i:23055;s:9:\"delete-71\";i:23056;s:9:\"delete-72\";i:23057;s:9:\"delete-73\";i:23058;s:9:\"delete-74\";i:23059;s:9:\"delete-75\";i:23060;s:9:\"delete-76\";i:23061;s:9:\"delete-77\";i:23062;s:9:\"delete-78\";i:23063;s:9:\"delete-79\";i:23064;s:9:\"delete-80\";i:23065;s:9:\"delete-81\";i:23066;s:9:\"delete-82\";i:23067;s:9:\"delete-83\";i:23068;s:9:\"delete-84\";i:23069;s:9:\"delete-85\";i:23070;s:9:\"delete-86\";i:23071;s:9:\"delete-87\";i:23072;s:9:\"delete-88\";i:23073;s:9:\"delete-89\";i:23074;s:9:\"delete-90\";i:23075;s:9:\"delete-91\";i:23076;s:9:\"delete-92\";i:23077;s:9:\"delete-93\";i:23078;s:9:\"delete-94\";i:23079;s:9:\"delete-95\";i:23080;s:9:\"delete-96\";i:23081;s:9:\"delete-97\";i:23082;s:9:\"delete-98\";i:23083;s:9:\"delete-99\";i:23084;s:10:\"delete-100\";i:23085;s:10:\"delete-101\";i:23086;s:10:\"delete-102\";i:23087;s:10:\"delete-103\";i:23088;s:10:\"delete-104\";i:23089;s:10:\"delete-105\";i:23090;s:10:\"delete-106\";i:23091;s:10:\"delete-107\";i:23092;s:10:\"delete-108\";i:23093;s:10:\"delete-109\";i:23094;s:10:\"delete-110\";i:23095;s:10:\"delete-111\";i:23096;s:10:\"delete-112\";i:23097;s:10:\"delete-113\";i:23098;s:10:\"delete-114\";i:23099;s:10:\"delete-115\";i:23100;s:10:\"delete-117\";i:23101;s:10:\"delete-118\";i:23102;s:10:\"delete-119\";i:23103;s:10:\"delete-120\";i:23104;s:10:\"delete-121\";i:23105;s:10:\"delete-122\";i:23106;s:10:\"delete-123\";i:23107;s:10:\"delete-124\";i:23108;s:10:\"delete-125\";i:23109;s:10:\"delete-126\";i:23110;s:10:\"delete-127\";i:23111;s:10:\"delete-128\";i:23112;s:10:\"delete-129\";i:23113;s:10:\"delete-130\";i:23114;s:10:\"delete-131\";i:23115;s:10:\"delete-132\";i:23116;s:10:\"delete-133\";i:23117;s:10:\"delete-134\";i:23118;s:10:\"delete-135\";i:23119;s:10:\"delete-136\";i:23120;s:10:\"delete-137\";i:23121;s:10:\"delete-138\";i:23122;s:10:\"delete-139\";i:23123;s:10:\"delete-140\";i:23124;s:10:\"delete-141\";i:23125;s:10:\"delete-142\";i:23126;s:10:\"delete-143\";i:23127;s:10:\"delete-144\";i:23128;s:10:\"delete-145\";i:23129;s:10:\"delete-146\";i:23130;s:10:\"delete-147\";i:23131;s:10:\"delete-148\";i:23132;s:10:\"delete-149\";i:23133;s:10:\"delete-150\";i:23134;s:10:\"delete-151\";i:23135;s:10:\"delete-152\";i:23136;s:10:\"delete-153\";i:23137;s:10:\"delete-154\";i:23138;s:10:\"delete-155\";i:23139;s:10:\"delete-156\";i:23140;s:10:\"delete-157\";i:23141;s:10:\"delete-158\";i:23142;s:10:\"delete-159\";i:23143;s:10:\"delete-160\";i:23144;s:10:\"delete-161\";i:23145;s:10:\"delete-162\";i:23146;s:10:\"delete-163\";i:23147;s:10:\"delete-164\";i:23148;s:10:\"delete-165\";i:23149;s:10:\"delete-166\";i:23150;s:10:\"delete-167\";i:23151;s:10:\"delete-168\";i:23152;s:10:\"delete-169\";i:23153;s:10:\"delete-170\";i:23154;s:10:\"delete-171\";i:23155;s:10:\"delete-172\";i:23156;s:10:\"delete-173\";i:23157;s:10:\"delete-174\";i:23158;s:10:\"delete-175\";i:23159;s:10:\"delete-176\";i:23160;s:10:\"delete-177\";i:23161;s:10:\"delete-178\";i:23162;s:10:\"delete-179\";i:23163;s:10:\"delete-180\";i:23164;s:10:\"delete-181\";i:23165;s:10:\"delete-182\";i:23166;s:10:\"delete-183\";i:23167;s:10:\"delete-184\";i:23168;s:10:\"delete-185\";i:23169;s:10:\"delete-186\";i:23170;s:10:\"delete-187\";i:23171;s:10:\"delete-188\";i:23172;s:10:\"delete-189\";i:23173;s:10:\"delete-190\";i:23174;s:10:\"delete-191\";i:23175;s:10:\"delete-192\";i:23176;s:10:\"delete-193\";i:23177;s:10:\"delete-194\";i:23178;s:10:\"delete-195\";i:23179;s:10:\"delete-196\";i:23180;s:10:\"delete-197\";i:23181;s:10:\"delete-198\";i:23182;s:10:\"delete-199\";i:23183;s:10:\"delete-200\";i:23184;s:10:\"delete-201\";i:23185;s:10:\"delete-202\";i:23186;s:10:\"delete-203\";i:23187;s:10:\"delete-204\";i:23188;s:10:\"delete-205\";i:23189;s:10:\"delete-206\";i:23190;s:10:\"delete-207\";i:23191;s:10:\"delete-208\";i:23192;s:10:\"delete-209\";i:23193;s:10:\"delete-211\";i:23194;s:10:\"delete-212\";i:23195;s:10:\"delete-213\";i:23196;s:10:\"delete-214\";i:23197;s:10:\"delete-215\";i:23198;s:10:\"delete-216\";i:23199;s:10:\"delete-217\";i:23200;s:10:\"delete-218\";i:23201;s:10:\"delete-219\";i:23202;s:10:\"delete-220\";i:23203;s:10:\"delete-221\";i:23204;s:10:\"delete-230\";i:23205;s:10:\"delete-231\";i:23206;s:10:\"delete-232\";i:23207;s:10:\"delete-233\";i:23208;s:10:\"delete-234\";i:23209;s:10:\"delete-235\";i:23210;s:10:\"delete-236\";i:23211;s:10:\"delete-237\";i:23212;s:10:\"delete-238\";i:23213;s:10:\"delete-239\";i:23214;s:10:\"delete-240\";i:23215;s:10:\"delete-241\";i:23216;s:10:\"delete-242\";i:23217;s:10:\"delete-243\";i:23218;s:10:\"delete-244\";i:23219;s:10:\"delete-245\";i:23220;s:10:\"delete-246\";i:23221;s:10:\"delete-247\";i:23222;s:10:\"delete-248\";i:23223;s:10:\"delete-249\";i:23224;s:10:\"delete-250\";i:23225;s:10:\"delete-251\";i:23226;s:10:\"delete-252\";i:23227;s:10:\"delete-253\";i:23228;s:10:\"delete-254\";i:23229;s:10:\"delete-255\";i:23230;s:10:\"delete-256\";i:23231;s:10:\"delete-257\";i:23232;s:10:\"delete-258\";i:23233;s:10:\"delete-259\";i:23234;s:10:\"delete-260\";i:23235;s:10:\"delete-261\";i:23236;s:10:\"delete-262\";i:23237;s:10:\"delete-263\";i:23238;s:10:\"delete-264\";i:23239;s:10:\"delete-265\";i:23240;s:10:\"delete-266\";i:23241;s:10:\"delete-267\";i:23242;s:10:\"delete-268\";i:23243;s:10:\"delete-269\";i:23244;s:10:\"delete-270\";i:23245;s:10:\"delete-271\";i:23246;s:10:\"delete-272\";i:23247;s:10:\"delete-273\";i:23248;s:10:\"delete-274\";i:23249;s:10:\"delete-275\";i:23250;s:10:\"delete-276\";i:23251;s:10:\"delete-277\";i:23252;s:10:\"delete-278\";i:23253;s:10:\"delete-279\";i:23254;s:10:\"delete-280\";i:23255;s:10:\"delete-281\";i:23256;s:10:\"delete-282\";i:23257;s:10:\"delete-283\";i:23258;s:10:\"delete-284\";i:23259;s:10:\"delete-285\";i:23260;s:10:\"delete-286\";i:23261;s:10:\"delete-287\";i:23262;s:10:\"delete-288\";i:23263;s:12:\"delete-23751\";i:23264;s:12:\"delete-23753\";i:23265;s:12:\"delete-23755\";i:23266;s:12:\"delete-23757\";i:23267;s:12:\"delete-23759\";i:23268;s:12:\"delete-23761\";i:23269;s:12:\"delete-23763\";i:23270;s:12:\"delete-23765\";i:23271;s:12:\"delete-23767\";i:23272;s:12:\"delete-23769\";i:23273;s:12:\"delete-23771\";i:23274;s:12:\"delete-23773\";i:23275;s:12:\"delete-23775\";i:23276;s:12:\"delete-23777\";i:23277;s:12:\"delete-23779\";i:23278;s:12:\"delete-23781\";i:23279;s:12:\"delete-23783\";i:23280;s:12:\"delete-23785\";i:23281;s:12:\"delete-23787\";i:23282;s:12:\"delete-23789\";i:23283;s:12:\"delete-23791\";i:23284;s:12:\"delete-23793\";i:23285;s:12:\"delete-23795\";i:23286;s:12:\"delete-23797\";i:23287;s:12:\"delete-23799\";i:23288;s:12:\"delete-23801\";i:23289;s:12:\"delete-23803\";i:23290;s:12:\"delete-23805\";i:23291;s:12:\"delete-23807\";i:23292;s:12:\"delete-23809\";i:23293;s:12:\"delete-23811\";i:23294;s:12:\"delete-23813\";i:23295;s:12:\"delete-23815\";i:23296;s:12:\"delete-23817\";i:23297;s:12:\"delete-23819\";i:23298;s:12:\"delete-23821\";i:23299;s:12:\"delete-23823\";i:23300;s:12:\"delete-23825\";i:23301;s:12:\"delete-23827\";i:23302;s:12:\"delete-23829\";i:23303;s:12:\"delete-23831\";i:23304;s:12:\"delete-23833\";i:23305;s:12:\"delete-23835\";i:23306;s:12:\"delete-23837\";i:23307;s:12:\"delete-23839\";i:23308;s:12:\"delete-23841\";i:23309;s:12:\"delete-23843\";i:23310;s:12:\"delete-23845\";i:23311;s:12:\"delete-23847\";i:23312;s:12:\"delete-23849\";i:23313;s:12:\"delete-23851\";i:23314;s:12:\"delete-23853\";i:23315;s:12:\"delete-23855\";i:23316;s:12:\"delete-23857\";i:23317;s:12:\"delete-23859\";i:23318;s:12:\"delete-23861\";i:23319;s:12:\"delete-23863\";i:23320;s:12:\"delete-23865\";i:23321;s:12:\"delete-23867\";i:23322;s:12:\"delete-23869\";i:23323;s:12:\"delete-23871\";i:23324;s:12:\"delete-23873\";i:23325;s:12:\"delete-23875\";i:23326;s:12:\"delete-23877\";i:23327;s:12:\"delete-23879\";i:23328;s:12:\"delete-23881\";i:23329;s:12:\"delete-23883\";i:23330;s:12:\"delete-23885\";i:23331;s:12:\"delete-23887\";i:23332;s:12:\"delete-23889\";i:23333;s:12:\"delete-23891\";i:23334;s:12:\"delete-23893\";i:23335;s:12:\"delete-23895\";i:23336;s:12:\"delete-23897\";i:23337;s:12:\"delete-23899\";i:23338;s:12:\"delete-23901\";i:23339;s:12:\"delete-23903\";i:23340;s:12:\"delete-23905\";i:23341;s:12:\"delete-23907\";i:23342;s:12:\"delete-23909\";i:23343;s:12:\"delete-23911\";i:23344;s:12:\"delete-23913\";i:23345;s:12:\"delete-23915\";i:23346;s:12:\"delete-23917\";i:23347;s:12:\"delete-23919\";i:23348;s:12:\"delete-23921\";i:23349;s:12:\"delete-23923\";i:23350;s:12:\"delete-23925\";i:23351;s:12:\"delete-23927\";i:23352;s:12:\"delete-23929\";i:23353;s:12:\"delete-23931\";i:23354;s:12:\"delete-23933\";i:23355;s:12:\"delete-23935\";i:23356;s:12:\"delete-23937\";i:23357;s:12:\"delete-23939\";i:23358;s:12:\"delete-23941\";i:23359;s:12:\"delete-23943\";i:23360;s:12:\"delete-23945\";i:23361;s:12:\"delete-23947\";i:23362;s:12:\"delete-23949\";i:23363;s:12:\"delete-23951\";i:23364;s:12:\"delete-23953\";i:23365;s:12:\"delete-23955\";i:23366;s:12:\"delete-23957\";i:23367;s:12:\"delete-23959\";i:23368;s:12:\"delete-23961\";i:23369;s:12:\"delete-23963\";i:23370;s:12:\"delete-23965\";i:23371;s:12:\"delete-23967\";i:23372;s:12:\"delete-23969\";i:23373;s:12:\"delete-23971\";i:23374;s:12:\"delete-23973\";i:23375;s:12:\"delete-23975\";i:23376;s:12:\"delete-23977\";i:23377;s:12:\"delete-23979\";i:23378;s:12:\"delete-23981\";i:23379;s:12:\"delete-23983\";i:23380;s:12:\"delete-23985\";i:23381;s:12:\"delete-23987\";i:23382;s:12:\"delete-23989\";i:23383;s:12:\"delete-23991\";i:23384;s:12:\"delete-23993\";i:23385;s:12:\"delete-23995\";i:23386;s:12:\"delete-23997\";i:23387;s:12:\"delete-23999\";i:23388;s:12:\"delete-24001\";i:23389;s:12:\"delete-24003\";i:23390;s:12:\"delete-24005\";i:23391;s:12:\"delete-24007\";i:23392;s:12:\"delete-24009\";i:23393;s:12:\"delete-24011\";i:23394;s:12:\"delete-24013\";i:23395;s:12:\"delete-24015\";i:23396;s:12:\"delete-24017\";i:23397;s:12:\"delete-24019\";i:23398;s:12:\"delete-24021\";i:23399;s:12:\"delete-24023\";i:23400;s:12:\"delete-24025\";i:23401;s:12:\"delete-24027\";i:23402;s:12:\"delete-24029\";i:23403;s:12:\"delete-24031\";i:23404;s:12:\"delete-24033\";i:23405;s:12:\"delete-24035\";i:23406;s:12:\"delete-24037\";i:23407;s:12:\"delete-24039\";i:23408;s:12:\"delete-24041\";i:23409;s:12:\"delete-24043\";i:23410;s:12:\"delete-24045\";i:23411;s:12:\"delete-24047\";i:23412;s:12:\"delete-24049\";i:23413;s:12:\"delete-24051\";i:23414;s:12:\"delete-24053\";i:23415;s:12:\"delete-24055\";i:23416;s:12:\"delete-24057\";i:23417;s:12:\"delete-24059\";i:23418;s:12:\"delete-24061\";i:23419;s:12:\"delete-24063\";i:23420;s:12:\"delete-24065\";i:23421;s:12:\"delete-24067\";i:23422;s:12:\"delete-24069\";i:23423;s:12:\"delete-24071\";i:23424;s:12:\"delete-24073\";i:23425;s:12:\"delete-24075\";i:23426;s:12:\"delete-24077\";i:23427;s:12:\"delete-24079\";i:23428;s:12:\"delete-24081\";i:23429;s:12:\"delete-24083\";i:23430;s:12:\"delete-24085\";i:23431;s:12:\"delete-24087\";i:23432;s:12:\"delete-24089\";i:23433;s:12:\"delete-24091\";i:23434;s:12:\"delete-24093\";i:23435;s:12:\"delete-24095\";i:23436;s:12:\"delete-24097\";i:23437;s:12:\"delete-24099\";i:23438;s:12:\"delete-24101\";i:23439;s:12:\"delete-24103\";i:23440;s:12:\"delete-24105\";i:23441;s:12:\"delete-24107\";i:23442;s:12:\"delete-24109\";i:23443;s:12:\"delete-24111\";i:23444;s:12:\"delete-24113\";i:23445;s:12:\"delete-24115\";i:23446;s:12:\"delete-24117\";i:23447;s:12:\"delete-24119\";i:23448;s:12:\"delete-24121\";i:23449;s:12:\"delete-24123\";i:23450;s:12:\"delete-24125\";i:23451;s:12:\"delete-24127\";i:23452;s:12:\"delete-24129\";i:23453;s:12:\"delete-24131\";i:23454;s:12:\"delete-24133\";i:23455;s:8:\"delete-7\";i:23456;s:12:\"delete-24150\";i:23457;s:12:\"delete-24151\";i:23458;s:12:\"delete-24154\";i:23459;s:12:\"delete-24155\";i:23460;s:12:\"delete-24158\";i:23461;s:12:\"delete-24159\";i:23462;s:12:\"delete-24162\";i:23463;s:12:\"delete-24163\";i:23464;s:12:\"delete-24166\";i:23465;s:12:\"delete-24167\";i:23466;s:12:\"delete-24170\";i:23467;s:12:\"delete-24171\";i:23468;s:12:\"delete-24174\";i:23469;s:12:\"delete-24175\";i:23470;s:12:\"delete-24178\";i:23471;s:12:\"delete-24179\";i:23472;s:12:\"delete-24182\";i:23473;s:12:\"delete-24183\";i:23474;s:12:\"delete-24186\";i:23475;s:12:\"delete-24187\";i:23476;s:12:\"delete-24190\";i:23477;s:12:\"delete-24191\";i:23478;s:12:\"delete-24194\";i:23479;s:12:\"delete-24195\";i:23480;s:12:\"delete-24198\";i:23481;s:12:\"delete-24199\";i:23482;s:12:\"delete-24202\";i:23483;s:12:\"delete-24203\";i:23484;s:12:\"delete-24206\";i:23485;s:12:\"delete-24207\";i:23486;s:12:\"delete-24210\";i:23487;s:12:\"delete-24211\";i:23488;s:12:\"delete-24214\";i:23489;s:12:\"delete-24215\";i:23490;s:12:\"delete-24218\";i:23491;s:12:\"delete-24219\";i:23492;s:12:\"delete-24222\";i:23493;s:12:\"delete-24223\";i:23494;s:12:\"delete-24226\";i:23495;s:12:\"delete-24227\";i:23496;s:12:\"delete-24230\";i:23497;s:12:\"delete-24231\";i:23498;s:12:\"delete-24234\";i:23499;s:12:\"delete-24235\";i:23500;s:12:\"delete-24238\";i:23501;s:12:\"delete-24239\";i:23502;s:12:\"delete-24152\";i:23503;s:12:\"delete-24153\";i:23504;s:12:\"delete-24156\";i:23505;s:12:\"delete-24157\";i:23506;s:12:\"delete-24160\";i:23507;s:12:\"delete-24161\";i:23508;s:12:\"delete-24165\";i:23509;s:12:\"delete-24164\";i:23510;s:12:\"delete-24168\";i:23511;s:12:\"delete-24169\";i:23512;s:12:\"delete-24172\";i:23513;s:12:\"delete-24173\";i:23514;s:12:\"delete-24177\";i:23515;s:12:\"delete-24176\";i:23516;s:12:\"delete-24180\";i:23517;s:12:\"delete-24181\";i:23518;s:12:\"delete-24184\";i:23519;s:12:\"delete-24185\";i:23520;s:12:\"delete-24188\";i:23521;s:12:\"delete-24189\";i:23522;s:12:\"delete-24193\";i:23523;s:12:\"delete-24192\";i:23524;s:12:\"delete-24196\";i:23525;s:12:\"delete-24197\";i:23526;s:12:\"delete-24200\";i:23527;s:12:\"delete-24201\";i:23528;s:12:\"delete-24205\";i:23529;s:12:\"delete-24204\";i:23530;s:12:\"delete-24208\";i:23531;s:12:\"delete-24209\";i:23532;s:12:\"delete-24212\";i:23533;s:12:\"delete-24213\";i:23534;s:12:\"delete-24216\";i:23535;s:12:\"delete-24217\";i:23536;s:12:\"delete-24221\";i:23537;s:12:\"delete-24220\";i:23538;s:12:\"delete-24224\";i:23539;s:12:\"delete-24225\";i:23540;s:12:\"delete-24228\";i:23541;s:12:\"delete-24229\";i:23542;s:12:\"delete-24233\";i:23543;s:12:\"delete-24232\";i:23544;s:12:\"delete-24236\";i:23545;s:12:\"delete-24237\";i:23546;s:12:\"delete-24240\";i:23547;s:12:\"delete-24241\";i:23548;s:12:\"delete-24242\";i:23549;s:12:\"delete-24243\";i:23550;s:12:\"delete-24244\";i:23551;s:12:\"delete-24245\";i:23552;s:12:\"delete-24246\";i:23553;s:12:\"delete-24247\";i:23554;s:12:\"delete-24250\";i:23555;s:12:\"delete-24251\";i:23556;s:12:\"delete-24248\";i:23557;s:12:\"delete-24249\";i:23558;s:12:\"delete-24252\";i:23559;s:12:\"delete-24253\";i:23560;s:12:\"delete-24254\";i:23561;s:12:\"delete-24256\";i:23562;s:12:\"delete-24257\";i:23563;s:12:\"delete-24255\";i:23564;s:12:\"delete-24258\";i:23565;s:12:\"delete-24259\";i:23566;s:12:\"delete-24260\";i:23567;s:12:\"delete-24261\";i:23568;s:12:\"delete-24262\";i:23569;s:12:\"delete-24263\";i:23570;s:12:\"delete-24266\";i:23571;s:12:\"delete-24267\";i:23572;s:12:\"delete-24264\";i:23573;s:12:\"delete-24265\";i:23574;s:12:\"delete-24268\";i:23575;s:12:\"delete-24269\";i:23576;s:12:\"delete-24270\";i:23577;s:12:\"delete-24271\";i:23578;s:12:\"delete-24274\";i:23579;s:12:\"delete-24275\";i:23580;s:12:\"delete-24272\";i:23581;s:12:\"delete-24273\";i:23582;s:12:\"delete-24276\";i:23583;s:12:\"delete-24277\";i:23584;s:12:\"delete-24278\";i:23585;s:12:\"delete-24279\";i:23586;s:12:\"delete-24282\";i:23587;s:12:\"delete-24280\";i:23588;s:12:\"delete-24281\";i:23589;s:12:\"delete-24283\";i:23590;s:12:\"delete-24286\";i:23591;s:12:\"delete-24284\";i:23592;s:12:\"delete-24285\";i:23593;s:12:\"delete-24287\";i:23594;s:12:\"delete-24290\";i:23595;s:12:\"delete-24291\";i:23596;s:12:\"delete-24288\";i:23597;s:12:\"delete-24289\";i:23598;s:12:\"delete-24292\";i:23599;s:12:\"delete-24293\";i:23600;s:12:\"delete-24294\";i:23601;s:12:\"delete-24295\";i:23602;s:12:\"delete-24298\";i:23603;s:12:\"delete-24299\";i:23604;s:12:\"delete-24296\";i:23605;s:12:\"delete-24297\";i:23606;s:12:\"delete-24300\";i:23607;s:12:\"delete-24301\";i:23608;s:12:\"delete-24302\";i:23609;s:12:\"delete-24304\";i:23610;s:12:\"delete-24305\";i:23611;s:12:\"delete-24303\";i:23612;s:12:\"delete-24306\";i:23613;s:12:\"delete-24307\";i:23614;s:12:\"delete-24308\";i:23615;s:12:\"delete-24309\";i:23616;s:12:\"delete-24310\";i:23617;s:12:\"delete-24311\";i:23618;s:12:\"delete-24314\";i:23619;s:12:\"delete-24315\";i:23620;s:12:\"delete-24312\";i:23621;s:12:\"delete-24313\";i:23622;s:12:\"delete-24316\";i:23623;s:12:\"delete-24317\";i:23624;s:12:\"delete-24318\";i:23625;s:12:\"delete-24319\";i:23626;s:12:\"delete-24322\";i:23627;s:12:\"delete-24323\";i:23628;s:12:\"delete-24320\";i:23629;s:12:\"delete-24321\";i:23630;s:12:\"delete-24324\";i:23631;s:12:\"delete-24325\";i:23632;s:12:\"delete-24326\";i:23633;s:12:\"delete-24327\";i:23634;s:12:\"delete-24328\";i:23635;s:12:\"delete-24329\";i:23636;s:12:\"delete-24330\";i:23637;s:12:\"delete-24331\";i:23638;s:12:\"delete-24334\";i:23639;s:12:\"delete-24332\";i:23640;s:12:\"delete-24333\";i:23641;s:12:\"delete-24336\";i:23642;s:12:\"delete-24337\";i:23643;s:12:\"delete-24335\";i:23644;s:12:\"delete-24338\";i:23645;s:12:\"delete-24339\";i:23646;s:12:\"delete-24342\";i:23647;s:12:\"delete-24343\";i:23648;s:12:\"delete-24340\";i:23649;s:12:\"delete-24341\";i:23650;s:12:\"delete-24344\";i:23651;s:12:\"delete-24345\";i:23652;s:12:\"delete-24346\";i:23653;s:12:\"delete-24347\";i:23654;s:12:\"delete-24350\";i:23655;s:12:\"delete-24351\";i:23656;s:12:\"delete-24348\";i:23657;s:12:\"delete-24349\";i:23658;s:12:\"delete-24352\";i:23659;s:12:\"delete-24353\";i:23660;s:12:\"delete-24354\";i:23661;s:12:\"delete-24356\";i:23662;s:12:\"delete-24357\";i:23663;s:12:\"delete-24355\";i:23664;s:12:\"delete-24358\";i:23665;s:12:\"delete-24359\";i:23666;s:12:\"delete-24360\";i:23667;s:12:\"delete-24361\";i:23668;s:12:\"delete-24362\";i:23669;s:12:\"delete-24363\";i:23670;s:12:\"delete-24366\";i:23671;s:12:\"delete-24364\";i:23672;s:12:\"delete-24365\";i:23673;s:12:\"delete-24367\";i:23674;s:12:\"delete-24368\";i:23675;s:12:\"delete-24369\";i:23676;s:12:\"delete-24370\";i:23677;s:12:\"delete-24371\";i:23678;s:12:\"delete-24372\";i:23679;s:12:\"delete-24373\";i:23680;s:12:\"delete-24374\";i:23681;s:12:\"delete-24375\";i:23682;s:12:\"delete-24376\";i:23683;s:12:\"delete-24377\";i:23684;s:12:\"delete-24378\";i:23685;s:12:\"delete-24379\";i:23686;s:12:\"delete-24380\";i:23687;s:12:\"delete-24381\";i:23688;s:12:\"delete-24382\";i:23689;s:12:\"delete-24383\";i:23690;s:12:\"delete-24384\";i:23691;s:12:\"delete-24385\";i:23692;s:12:\"delete-24386\";i:23693;s:12:\"delete-24387\";i:23694;s:12:\"delete-24388\";i:23695;s:12:\"delete-24389\";i:23696;s:12:\"delete-24390\";i:23697;s:12:\"delete-24391\";i:23698;s:12:\"delete-24392\";i:23699;s:12:\"delete-24393\";i:23700;s:12:\"delete-24394\";i:23701;s:12:\"delete-24395\";i:23702;s:12:\"delete-24396\";i:23703;s:12:\"delete-24397\";i:23704;s:12:\"delete-24398\";i:23705;s:12:\"delete-24399\";i:23706;s:12:\"delete-24400\";i:23707;s:12:\"delete-24401\";i:23708;s:12:\"delete-24402\";i:23709;s:12:\"delete-24403\";i:23710;s:12:\"delete-24404\";i:23711;s:12:\"delete-24405\";i:23712;s:12:\"delete-24406\";i:23713;s:12:\"delete-24407\";i:23714;s:12:\"delete-24408\";i:23715;s:12:\"delete-24409\";i:23716;s:12:\"delete-24410\";i:23717;s:12:\"delete-24411\";i:23718;s:12:\"delete-24412\";i:23719;s:12:\"delete-24413\";i:23720;s:12:\"delete-24414\";i:23721;s:12:\"delete-24415\";i:23722;s:12:\"delete-24416\";i:23723;s:12:\"delete-24417\";i:23724;s:12:\"delete-24418\";i:23725;s:12:\"delete-24419\";i:23726;s:12:\"delete-24420\";i:23727;s:12:\"delete-24421\";i:23728;s:12:\"delete-24422\";i:23729;s:12:\"delete-24423\";i:23730;s:12:\"delete-24424\";i:23731;s:12:\"delete-24425\";i:23732;s:12:\"delete-24426\";i:23733;s:12:\"delete-24427\";i:23734;s:12:\"delete-24428\";i:23735;s:12:\"delete-24429\";i:23736;s:12:\"delete-24430\";i:23737;s:12:\"delete-24431\";i:23738;s:12:\"delete-24432\";i:23739;s:12:\"delete-24433\";i:23740;s:12:\"delete-24434\";i:23741;s:12:\"delete-24435\";i:23742;s:12:\"delete-24436\";i:23743;s:12:\"delete-24437\";i:23744;s:12:\"delete-24438\";i:23745;s:12:\"delete-24439\";i:23746;s:12:\"delete-24440\";i:23747;s:12:\"delete-24441\";i:23748;s:12:\"delete-24442\";i:23749;s:12:\"delete-24443\";i:23750;s:12:\"delete-24444\";i:23751;s:12:\"delete-24445\";i:23752;s:12:\"delete-24446\";i:23753;s:12:\"delete-24447\";i:23754;s:12:\"delete-24448\";i:23755;s:12:\"delete-24449\";i:23756;s:12:\"delete-24450\";i:23757;s:12:\"delete-24451\";i:23758;s:12:\"delete-24452\";i:23759;s:12:\"delete-24453\";i:23760;s:12:\"delete-24454\";i:23761;s:12:\"delete-24455\";i:23762;s:12:\"delete-24456\";i:23763;s:12:\"delete-24457\";i:23764;s:12:\"delete-24458\";i:23765;s:12:\"delete-24459\";i:23766;s:12:\"delete-24460\";i:23767;s:12:\"delete-24461\";i:23768;s:12:\"delete-24462\";i:23769;s:12:\"delete-24463\";i:23770;s:12:\"delete-24464\";i:23771;s:12:\"delete-24465\";i:23772;s:12:\"delete-24466\";i:23773;s:12:\"delete-24467\";i:23774;s:12:\"delete-24468\";i:23775;s:12:\"delete-24469\";i:23776;s:12:\"delete-24470\";i:23777;s:12:\"delete-24471\";i:23778;s:12:\"delete-24472\";i:23779;s:12:\"delete-24473\";i:23780;s:12:\"delete-24474\";i:23781;s:12:\"delete-24475\";i:23782;s:12:\"delete-24476\";i:23783;s:12:\"delete-24477\";i:23784;s:12:\"delete-24478\";i:23785;s:12:\"delete-24479\";i:23786;s:12:\"delete-24480\";i:23787;s:12:\"delete-24481\";i:23788;s:12:\"delete-24482\";i:23789;s:12:\"delete-24483\";i:23790;s:12:\"delete-24484\";i:23791;s:12:\"delete-24485\";i:23792;s:12:\"delete-24486\";i:23793;s:12:\"delete-24487\";i:23794;s:12:\"delete-24488\";i:23795;s:12:\"delete-24489\";i:23796;s:12:\"delete-24490\";i:23797;s:12:\"delete-24491\";i:23798;s:12:\"delete-24492\";i:23799;s:12:\"delete-24493\";i:23800;s:12:\"delete-24494\";i:23801;s:12:\"delete-24495\";i:23802;s:12:\"delete-24496\";i:23803;s:12:\"delete-24497\";i:23804;s:12:\"delete-24498\";i:23805;s:12:\"delete-24499\";i:23806;s:12:\"delete-24500\";i:23807;s:12:\"delete-24501\";i:23808;s:12:\"delete-24502\";i:23809;s:12:\"delete-24503\";i:23810;s:12:\"delete-24504\";i:23811;s:12:\"delete-24505\";i:23812;s:12:\"delete-24506\";i:23813;s:12:\"delete-24507\";i:23814;s:12:\"delete-24508\";i:23815;s:12:\"delete-24509\";i:23816;s:12:\"delete-24510\";i:23817;s:12:\"delete-24511\";i:23818;s:12:\"delete-24512\";i:23819;s:12:\"delete-24513\";i:23820;s:12:\"delete-24514\";i:23821;s:12:\"delete-24515\";i:23822;s:12:\"delete-24516\";i:23823;s:12:\"delete-24517\";i:23824;s:12:\"delete-24518\";i:23825;s:12:\"delete-24519\";i:23826;s:12:\"delete-24520\";i:23827;s:12:\"delete-24521\";i:23828;s:12:\"delete-24522\";i:23829;s:12:\"delete-24523\";i:23830;s:12:\"delete-24524\";i:23831;s:12:\"delete-24525\";i:23832;s:12:\"delete-24526\";i:23833;s:12:\"delete-24527\";i:23834;s:12:\"delete-24528\";i:23835;s:12:\"delete-24529\";i:23836;s:12:\"delete-24530\";i:23837;s:12:\"delete-24531\";i:23838;s:12:\"delete-24532\";i:23839;s:12:\"delete-24533\";i:23840;s:12:\"delete-24534\";i:23841;s:12:\"delete-24535\";i:23842;s:12:\"delete-24536\";i:23843;s:12:\"delete-24537\";i:23844;s:12:\"delete-24538\";i:23845;s:12:\"delete-24539\";i:23846;s:12:\"delete-24540\";i:23847;s:12:\"delete-24541\";i:23848;s:12:\"delete-24542\";i:23849;s:12:\"delete-24543\";i:23850;s:12:\"delete-24544\";i:23851;s:12:\"delete-24545\";i:23852;s:12:\"delete-24546\";i:23853;s:12:\"delete-24547\";i:23854;s:12:\"delete-24548\";i:23855;s:12:\"delete-24549\";i:23856;s:12:\"delete-24550\";i:23857;s:12:\"delete-24551\";i:23858;s:12:\"delete-24552\";i:23859;s:12:\"delete-24553\";i:23860;s:12:\"delete-24554\";i:23861;s:12:\"delete-24555\";i:23862;s:12:\"delete-24556\";i:23863;s:12:\"delete-24557\";i:23864;s:12:\"delete-24558\";i:23865;s:12:\"delete-24559\";i:23866;s:12:\"delete-24560\";i:23867;s:12:\"delete-24561\";i:23868;s:12:\"delete-24562\";i:23869;s:12:\"delete-24563\";i:23870;s:12:\"delete-24564\";i:23871;s:12:\"delete-24565\";i:23872;s:12:\"delete-24566\";i:23873;s:12:\"delete-24567\";i:23874;s:12:\"delete-24568\";i:23875;s:12:\"delete-24569\";i:23876;s:12:\"delete-24570\";i:23877;s:12:\"delete-24571\";i:23878;s:12:\"delete-24572\";i:23879;s:12:\"delete-24573\";i:23880;s:12:\"delete-24574\";i:23881;s:12:\"delete-24575\";i:23882;s:12:\"delete-24576\";i:23883;s:12:\"delete-24577\";i:23884;s:12:\"delete-24578\";i:23885;s:12:\"delete-24579\";i:23886;s:12:\"delete-24580\";i:23887;s:12:\"delete-24581\";i:23888;s:12:\"delete-24582\";i:23889;s:12:\"delete-24583\";i:23890;s:12:\"delete-24584\";i:23891;s:12:\"delete-24585\";i:23892;s:12:\"delete-24586\";i:23893;s:12:\"delete-24587\";i:23894;s:12:\"delete-24588\";i:23895;s:12:\"delete-24589\";i:23896;s:12:\"delete-24590\";i:23897;s:12:\"delete-24591\";i:23898;s:12:\"delete-24592\";i:23899;s:12:\"delete-24593\";i:23900;s:12:\"delete-24594\";i:23901;s:12:\"delete-24595\";i:23902;s:12:\"delete-24596\";i:23903;s:12:\"delete-24597\";i:23904;s:12:\"delete-24598\";i:23905;s:12:\"delete-24599\";i:23906;s:12:\"delete-24600\";i:23907;s:12:\"delete-24601\";i:23908;s:12:\"delete-24602\";i:23909;s:12:\"delete-24603\";i:23910;s:12:\"delete-24604\";i:23911;s:12:\"delete-24605\";i:23912;s:12:\"delete-24606\";i:23913;s:12:\"delete-24607\";i:23914;s:12:\"delete-24608\";i:23915;s:12:\"delete-24609\";i:23916;s:12:\"delete-24610\";i:23917;s:12:\"delete-24611\";i:23918;s:12:\"delete-24612\";i:23919;s:12:\"delete-24613\";i:23920;s:12:\"delete-24614\";i:23921;s:12:\"delete-24615\";i:23922;s:12:\"delete-24616\";i:23923;s:12:\"delete-24617\";i:23924;s:12:\"delete-24618\";i:23925;s:12:\"delete-24619\";i:23926;s:12:\"delete-24620\";i:23927;s:12:\"delete-24621\";i:23928;s:12:\"delete-24622\";i:23929;s:12:\"delete-24623\";i:23930;s:12:\"delete-24624\";i:23931;s:12:\"delete-24625\";i:23932;s:12:\"delete-24626\";i:23933;s:12:\"delete-24627\";i:23934;s:12:\"delete-24628\";i:23935;s:12:\"delete-24629\";i:23936;s:12:\"delete-24630\";i:23937;s:12:\"delete-24631\";i:23938;s:12:\"delete-24632\";i:23939;s:12:\"delete-24633\";i:23940;s:12:\"delete-24634\";i:23941;s:12:\"delete-24635\";i:23942;s:12:\"delete-24636\";i:23943;s:12:\"delete-24637\";i:23944;s:12:\"delete-24638\";i:23945;s:12:\"delete-24639\";i:23946;s:12:\"delete-24640\";i:23947;s:12:\"delete-24641\";i:23948;s:12:\"delete-24642\";i:23949;s:12:\"delete-24643\";i:23950;s:12:\"delete-24644\";i:23951;s:12:\"delete-24645\";i:23952;s:12:\"delete-24646\";i:23953;s:12:\"delete-24647\";i:23954;s:12:\"delete-24648\";i:23955;s:12:\"delete-24649\";i:23956;s:12:\"delete-24650\";i:23957;s:12:\"delete-24651\";i:23958;s:12:\"delete-24652\";i:23959;s:12:\"delete-24653\";i:23960;s:12:\"delete-24654\";i:23961;s:12:\"delete-24655\";i:23962;s:12:\"delete-24656\";i:23963;s:12:\"delete-24657\";i:23964;s:12:\"delete-24658\";i:23965;s:12:\"delete-24659\";i:23966;s:12:\"delete-24660\";i:23967;s:12:\"delete-24661\";i:23968;s:12:\"delete-24662\";i:23969;s:12:\"delete-24663\";i:23970;s:12:\"delete-24664\";i:23971;s:12:\"delete-24665\";i:23972;s:12:\"delete-24666\";i:23973;s:12:\"delete-24667\";i:23974;s:12:\"delete-24668\";i:23975;s:12:\"delete-24669\";i:23976;s:12:\"delete-24670\";i:23977;s:12:\"delete-24671\";i:23978;s:12:\"delete-24672\";i:23979;s:12:\"delete-24673\";i:23980;s:12:\"delete-24674\";i:23981;s:12:\"delete-24675\";i:23982;s:12:\"delete-24676\";i:23983;s:12:\"delete-24677\";i:23984;s:12:\"delete-24678\";i:23985;s:12:\"delete-24679\";i:23986;s:12:\"delete-24680\";i:23987;s:12:\"delete-24681\";i:23988;s:12:\"delete-24682\";i:23989;s:12:\"delete-24683\";i:23990;s:12:\"delete-24684\";i:23991;s:12:\"delete-24685\";i:23992;s:12:\"delete-24686\";i:23993;s:12:\"delete-24687\";i:23994;s:12:\"delete-24688\";i:23995;s:12:\"delete-24689\";i:23996;s:12:\"delete-24690\";i:23997;s:12:\"delete-24691\";i:23998;s:12:\"delete-24692\";i:23999;s:12:\"delete-24693\";i:24000;s:12:\"delete-24694\";i:24001;s:12:\"delete-24695\";i:24002;s:12:\"delete-24696\";i:24003;s:12:\"delete-24697\";i:24004;s:12:\"delete-24698\";i:24005;s:12:\"delete-24699\";i:24006;s:12:\"delete-24700\";i:24007;s:12:\"delete-24701\";i:24008;s:12:\"delete-24702\";i:24009;s:12:\"delete-24703\";i:24010;s:12:\"delete-24704\";i:24011;s:12:\"delete-24705\";i:24012;s:12:\"delete-24706\";i:24013;s:12:\"delete-24707\";i:24014;s:12:\"delete-24708\";i:24015;s:12:\"delete-24709\";i:24016;s:12:\"delete-24710\";i:24017;s:12:\"delete-24711\";i:24018;s:12:\"delete-24712\";i:24019;s:12:\"delete-24713\";i:24020;s:12:\"delete-24714\";i:24021;s:12:\"delete-24715\";i:24022;s:12:\"delete-24716\";i:24023;s:12:\"delete-24717\";i:24024;s:12:\"delete-24718\";i:24025;s:12:\"delete-24719\";i:24026;s:12:\"delete-24720\";i:24027;s:12:\"delete-24721\";i:24028;s:12:\"delete-24722\";i:24029;s:12:\"delete-24723\";i:24030;s:12:\"delete-24724\";i:24031;s:12:\"delete-24725\";i:24032;s:12:\"delete-24726\";i:24033;s:12:\"delete-24727\";i:24034;s:12:\"delete-24728\";i:24035;s:12:\"delete-24729\";i:24036;s:12:\"delete-24730\";i:24037;s:12:\"delete-24731\";i:24038;s:12:\"delete-24732\";i:24039;s:12:\"delete-24733\";i:24040;s:12:\"delete-24734\";i:24041;s:12:\"delete-24735\";i:24042;s:12:\"delete-24736\";i:24043;s:12:\"delete-24737\";i:24044;s:12:\"delete-24738\";i:24045;s:12:\"delete-24739\";i:24046;s:12:\"delete-24740\";i:24047;s:12:\"delete-24741\";i:24048;s:12:\"delete-24742\";i:24049;s:12:\"delete-24743\";i:24050;s:12:\"delete-24744\";i:24051;s:12:\"delete-24745\";i:24052;s:12:\"delete-24746\";i:24053;s:12:\"delete-24747\";i:24054;s:12:\"delete-24748\";i:24055;s:12:\"delete-24749\";i:24056;s:12:\"delete-24750\";i:24057;s:12:\"delete-24751\";i:24058;s:12:\"delete-24752\";i:24059;s:12:\"delete-24753\";i:24060;s:12:\"delete-24754\";i:24061;s:12:\"delete-24755\";i:24062;s:12:\"delete-24756\";i:24063;s:12:\"delete-24757\";i:24064;s:12:\"delete-24758\";i:24065;s:12:\"delete-24759\";i:24066;s:12:\"delete-24760\";i:24067;s:12:\"delete-24761\";i:24068;s:12:\"delete-24762\";i:24069;s:12:\"delete-24763\";i:24070;s:12:\"delete-24764\";i:24071;s:12:\"delete-24765\";i:24072;s:12:\"delete-24766\";i:24073;s:12:\"delete-24767\";i:24074;s:12:\"delete-24768\";i:24075;s:12:\"delete-24769\";i:24076;s:12:\"delete-24770\";i:24077;s:12:\"delete-24771\";i:24078;s:12:\"delete-24772\";i:24079;s:12:\"delete-24773\";i:24080;s:12:\"delete-24774\";i:24081;s:12:\"delete-24775\";i:24082;s:12:\"delete-24776\";i:24083;s:12:\"delete-24777\";i:24084;s:12:\"delete-24778\";i:24085;s:12:\"delete-24779\";i:24086;s:12:\"delete-24780\";i:24087;s:12:\"delete-24781\";i:24088;s:12:\"delete-24782\";i:24089;s:12:\"delete-24783\";i:24090;s:12:\"delete-24784\";i:24091;s:12:\"delete-24785\";i:24092;s:12:\"delete-24786\";i:24093;s:12:\"delete-24787\";i:24094;s:12:\"delete-24788\";i:24095;s:12:\"delete-24789\";i:24096;s:12:\"delete-24790\";i:24097;s:12:\"delete-24791\";i:24098;s:12:\"delete-24792\";i:24099;s:12:\"delete-24793\";i:24100;s:12:\"delete-24794\";i:24101;s:12:\"delete-24795\";i:24102;s:12:\"delete-24796\";i:24103;s:12:\"delete-24797\";i:24104;s:12:\"delete-24798\";i:24105;s:12:\"delete-24799\";i:24106;s:12:\"delete-24800\";i:24107;s:12:\"delete-24801\";i:24108;s:12:\"delete-24802\";i:24109;s:12:\"delete-24803\";i:24110;s:12:\"delete-24804\";i:24111;s:12:\"delete-24805\";i:24112;s:12:\"delete-24806\";i:24113;s:12:\"delete-24807\";i:24114;s:12:\"delete-24808\";i:24115;s:12:\"delete-24809\";i:24116;s:12:\"delete-24810\";i:24117;s:12:\"delete-24811\";i:24118;s:12:\"delete-24812\";i:24119;s:12:\"delete-24813\";i:24120;s:12:\"delete-24814\";i:24121;s:12:\"delete-24815\";i:24122;s:12:\"delete-24816\";i:24123;s:12:\"delete-24817\";i:24124;s:12:\"delete-24818\";i:24125;s:12:\"delete-24819\";i:24126;s:12:\"delete-24820\";i:24127;s:12:\"delete-24821\";i:24128;s:12:\"delete-24822\";i:24129;s:12:\"delete-24823\";i:24130;s:12:\"delete-24824\";i:24131;s:12:\"delete-24825\";i:24132;s:12:\"delete-24826\";i:24133;s:12:\"delete-24827\";i:24134;s:12:\"delete-24828\";i:24135;s:12:\"delete-24829\";i:24136;s:12:\"delete-24830\";i:24137;s:12:\"delete-24831\";i:24138;s:12:\"delete-24832\";i:24139;s:12:\"delete-24833\";i:24140;s:12:\"delete-24834\";i:24141;s:12:\"delete-24835\";i:24142;s:12:\"delete-24836\";i:24143;s:12:\"delete-24837\";i:24144;s:12:\"delete-24838\";i:24145;s:12:\"delete-24839\";i:24146;s:12:\"delete-24840\";i:24147;s:12:\"delete-24841\";i:24148;s:12:\"delete-24842\";i:24149;s:12:\"delete-24843\";i:24150;s:12:\"delete-24844\";i:24151;s:12:\"delete-24845\";i:24152;s:12:\"delete-24846\";i:24153;s:12:\"delete-24847\";i:24154;s:12:\"delete-24848\";i:24155;s:12:\"delete-24849\";i:24156;s:12:\"delete-24850\";i:24157;s:12:\"delete-24851\";i:24158;s:12:\"delete-24852\";i:24159;s:12:\"delete-24853\";i:24160;s:12:\"delete-24854\";i:24161;s:12:\"delete-24855\";i:24162;s:12:\"delete-24856\";i:24163;s:12:\"delete-24857\";i:24164;s:12:\"delete-24858\";i:24165;s:12:\"delete-24859\";i:24166;s:12:\"delete-24860\";i:24167;s:12:\"delete-24861\";i:24168;s:12:\"delete-24862\";i:24169;s:12:\"delete-24863\";i:24170;s:12:\"delete-24864\";i:24171;s:12:\"delete-24865\";i:24172;s:12:\"delete-24866\";i:24173;s:12:\"delete-24867\";i:24174;s:12:\"delete-24868\";i:24175;s:12:\"delete-24869\";i:24176;s:12:\"delete-24870\";i:24177;s:12:\"delete-24871\";i:24178;s:12:\"delete-24872\";i:24179;s:12:\"delete-24873\";i:24180;s:12:\"delete-24874\";i:24181;s:12:\"delete-24875\";i:24182;s:12:\"delete-24876\";i:24183;s:12:\"delete-24877\";i:24184;s:12:\"delete-24878\";i:24185;s:12:\"delete-24879\";i:24186;s:12:\"delete-24880\";i:24187;s:12:\"delete-24881\";i:24188;s:12:\"delete-24882\";i:24189;s:12:\"delete-24883\";i:24190;s:12:\"delete-24884\";i:24191;s:12:\"delete-24885\";i:24192;s:12:\"delete-24886\";i:24193;s:12:\"delete-24887\";i:24194;s:12:\"delete-24888\";i:24195;s:12:\"delete-24889\";i:24196;s:12:\"delete-24890\";i:24197;s:12:\"delete-24891\";i:24198;s:12:\"delete-24892\";i:24199;s:12:\"delete-24893\";i:24200;s:12:\"delete-24894\";i:24201;s:12:\"delete-24895\";i:24202;s:12:\"delete-24896\";i:24203;s:12:\"delete-24897\";i:24204;s:12:\"delete-24898\";i:24205;s:12:\"delete-24899\";i:24206;s:12:\"delete-24900\";i:24207;s:12:\"delete-24901\";i:24208;s:12:\"delete-24902\";i:24209;s:12:\"delete-24903\";i:24210;s:12:\"delete-24904\";i:24211;s:12:\"delete-24905\";i:24212;s:12:\"delete-24906\";i:24213;s:12:\"delete-24907\";i:24214;s:12:\"delete-24908\";i:24215;s:12:\"delete-24909\";i:24216;s:12:\"delete-24910\";i:24217;s:12:\"delete-24911\";i:24218;s:12:\"delete-24912\";i:24219;s:12:\"delete-24913\";i:24220;s:12:\"delete-24914\";i:24221;s:12:\"delete-24915\";i:24222;s:12:\"delete-24916\";i:24223;s:12:\"delete-24917\";i:24224;s:12:\"delete-24918\";i:24225;s:12:\"delete-24919\";i:24226;s:12:\"delete-24920\";i:24227;s:12:\"delete-24921\";i:24228;s:12:\"delete-24922\";i:24229;s:12:\"delete-24923\";i:24230;s:12:\"delete-24924\";i:24231;s:12:\"delete-24925\";i:24232;s:12:\"delete-24926\";i:24233;s:12:\"delete-24927\";i:24234;s:12:\"delete-24928\";i:24235;s:12:\"delete-24929\";i:24236;s:12:\"delete-24930\";i:24237;s:12:\"delete-24931\";i:24238;s:12:\"delete-24932\";i:24239;s:12:\"delete-24933\";i:24240;s:12:\"delete-24934\";i:24241;s:12:\"delete-24935\";i:24242;s:12:\"delete-24936\";i:24243;s:12:\"delete-24937\";i:24244;s:12:\"delete-24938\";i:24245;s:12:\"delete-24939\";i:24246;s:12:\"delete-24940\";i:24247;s:12:\"delete-24941\";i:24248;s:12:\"delete-24942\";i:24249;s:12:\"delete-24943\";i:24250;s:12:\"delete-24944\";i:24251;s:12:\"delete-24945\";i:24252;s:12:\"delete-24946\";i:24253;s:12:\"delete-24947\";i:24254;s:12:\"delete-24948\";i:24255;s:12:\"delete-24949\";i:24256;s:12:\"delete-24950\";i:24257;s:12:\"delete-24951\";i:24258;s:12:\"delete-24952\";i:24259;s:12:\"delete-24953\";i:24260;s:12:\"delete-24954\";i:24261;s:12:\"delete-24955\";i:24262;s:12:\"delete-24956\";i:24263;s:12:\"delete-24957\";i:24264;s:12:\"delete-24958\";i:24265;s:12:\"delete-24959\";i:24266;s:12:\"delete-24960\";i:24267;s:12:\"delete-24961\";i:24268;s:12:\"delete-24962\";i:24269;s:12:\"delete-24963\";i:24270;s:12:\"delete-24964\";i:24271;s:12:\"delete-24965\";i:24272;s:12:\"delete-24966\";i:24273;s:12:\"delete-24967\";i:24274;s:12:\"delete-24968\";i:24275;s:12:\"delete-24969\";i:24276;s:12:\"delete-24970\";i:24277;s:12:\"delete-24971\";i:24278;s:12:\"delete-24972\";i:24279;s:12:\"delete-24973\";i:24280;s:12:\"delete-24974\";i:24281;s:12:\"delete-24975\";i:24282;s:12:\"delete-24976\";i:24283;s:12:\"delete-24977\";i:24284;s:12:\"delete-24978\";i:24285;s:12:\"delete-24979\";i:24286;s:12:\"delete-24980\";i:24287;s:12:\"delete-24981\";i:24288;s:12:\"delete-24982\";i:24289;s:12:\"delete-24983\";i:24290;s:12:\"delete-24984\";i:24291;s:12:\"delete-24985\";i:24292;s:12:\"delete-24986\";i:24293;s:12:\"delete-24987\";i:24294;s:12:\"delete-24988\";i:24295;s:12:\"delete-24989\";i:24296;s:12:\"delete-24990\";i:24297;s:12:\"delete-24991\";i:24298;s:12:\"delete-24992\";i:24299;s:12:\"delete-24993\";i:24300;s:12:\"delete-24994\";i:24301;s:12:\"delete-24995\";i:24302;s:12:\"delete-24996\";i:24303;s:12:\"delete-24997\";i:24304;s:12:\"delete-24998\";i:24305;s:12:\"delete-24999\";i:24306;s:12:\"delete-25000\";i:24307;s:12:\"delete-25001\";i:24308;s:12:\"delete-25002\";i:24309;s:12:\"delete-25003\";i:24310;s:12:\"delete-25004\";i:24311;s:12:\"delete-25005\";i:24312;s:12:\"delete-25006\";i:24313;s:12:\"delete-25007\";i:24314;s:12:\"delete-25008\";i:24315;s:12:\"delete-25009\";i:24316;s:12:\"delete-25010\";i:24317;s:12:\"delete-25011\";i:24318;s:12:\"delete-25012\";i:24319;s:12:\"delete-25013\";i:24320;s:12:\"delete-25014\";i:24321;s:12:\"delete-25015\";i:24322;s:12:\"delete-25016\";i:24323;s:12:\"delete-25017\";i:24324;s:12:\"delete-25018\";i:24325;s:12:\"delete-25019\";i:24326;s:12:\"delete-25020\";i:24327;s:12:\"delete-25021\";i:24328;s:12:\"delete-25022\";i:24329;s:12:\"delete-25023\";i:24330;s:12:\"delete-25024\";i:24331;s:12:\"delete-25025\";i:24332;s:12:\"delete-25026\";i:24333;s:12:\"delete-25027\";i:24334;s:12:\"delete-25028\";i:24335;s:12:\"delete-25029\";i:24336;s:12:\"delete-25030\";i:24337;s:12:\"delete-25031\";i:24338;s:12:\"delete-25032\";i:24339;s:12:\"delete-25033\";i:24340;s:12:\"delete-25034\";i:24341;s:12:\"delete-25035\";i:24342;s:12:\"delete-25036\";i:24343;s:12:\"delete-25037\";i:24344;s:12:\"delete-25038\";i:24345;s:12:\"delete-25039\";i:24346;s:12:\"delete-25040\";i:24347;s:12:\"delete-25041\";i:24348;s:12:\"delete-25042\";i:24349;s:12:\"delete-25043\";i:24350;s:12:\"delete-25044\";i:24351;s:12:\"delete-25045\";i:24352;s:12:\"delete-25046\";i:24353;s:12:\"delete-25047\";i:24354;s:12:\"delete-25048\";i:24355;s:12:\"delete-25049\";i:24356;s:12:\"delete-25050\";i:24357;s:12:\"delete-25051\";i:24358;s:12:\"delete-25052\";i:24359;s:12:\"delete-25053\";i:24360;s:12:\"delete-25054\";i:24361;s:12:\"delete-25055\";i:24362;s:12:\"delete-25056\";i:24363;s:12:\"delete-25057\";i:24364;s:12:\"delete-25058\";i:24365;s:12:\"delete-25059\";i:24366;s:12:\"delete-25060\";i:24367;s:12:\"delete-25061\";i:24368;s:12:\"delete-25062\";i:24369;s:12:\"delete-25063\";i:24370;s:12:\"delete-25064\";i:24371;s:12:\"delete-25065\";i:24372;s:12:\"delete-25066\";i:24373;s:12:\"delete-25067\";i:24374;s:12:\"delete-25068\";i:24375;s:12:\"delete-25069\";i:24376;s:12:\"delete-25070\";i:24377;s:12:\"delete-25071\";i:24378;s:12:\"delete-25072\";i:24379;s:12:\"delete-25073\";i:24380;s:12:\"delete-25074\";i:24381;s:12:\"delete-25075\";i:24382;s:12:\"delete-25076\";i:24383;s:12:\"delete-25077\";i:24384;s:12:\"delete-25078\";i:24385;s:12:\"delete-25079\";i:24386;s:12:\"delete-25080\";i:24387;s:12:\"delete-25081\";i:24388;s:12:\"delete-25082\";i:24389;s:12:\"delete-25083\";i:24390;s:12:\"delete-25084\";i:24391;s:12:\"delete-25085\";i:24392;s:12:\"delete-25086\";i:24393;s:12:\"delete-25087\";i:24394;s:12:\"delete-25088\";i:24395;s:12:\"delete-25089\";i:24396;s:12:\"delete-25090\";i:24397;s:12:\"delete-25091\";i:24398;s:12:\"delete-25092\";i:24399;s:12:\"delete-25093\";i:24400;s:12:\"delete-25094\";i:24401;s:12:\"delete-25095\";i:24402;s:12:\"delete-25096\";i:24403;s:12:\"delete-25097\";i:24404;s:12:\"delete-25098\";i:24405;s:12:\"delete-25099\";i:24406;s:12:\"delete-25100\";i:24407;s:12:\"delete-25101\";i:24408;s:12:\"delete-25102\";i:24409;s:12:\"delete-25103\";i:24410;s:12:\"delete-25104\";i:24411;s:12:\"delete-25105\";i:24412;s:12:\"delete-25106\";i:24413;s:12:\"delete-25107\";i:24414;s:12:\"delete-25108\";i:24415;s:12:\"delete-25109\";i:24416;s:12:\"delete-25110\";i:24417;s:12:\"delete-25111\";i:24418;s:12:\"delete-25112\";i:24419;s:12:\"delete-25113\";i:24420;s:12:\"delete-25114\";i:24421;s:12:\"delete-25115\";i:24422;s:12:\"delete-25116\";i:24423;s:12:\"delete-25117\";i:24424;s:12:\"delete-25118\";i:24425;s:12:\"delete-25119\";i:24426;s:12:\"delete-25120\";i:24427;s:12:\"delete-25121\";i:24428;s:12:\"delete-25122\";i:24429;s:12:\"delete-25123\";i:24430;s:12:\"delete-25124\";i:24431;s:12:\"delete-25125\";i:24432;s:12:\"delete-25126\";i:24433;s:12:\"delete-25127\";i:24434;s:12:\"delete-25128\";i:24435;s:12:\"delete-25129\";i:24436;s:12:\"delete-25130\";i:24437;s:12:\"delete-25131\";i:24438;s:12:\"delete-25132\";i:24439;s:12:\"delete-25133\";i:24440;s:12:\"delete-25134\";i:24441;s:12:\"delete-25135\";i:24442;s:12:\"delete-25136\";i:24443;s:12:\"delete-25137\";i:24444;s:12:\"delete-25138\";i:24445;s:12:\"delete-25139\";i:24446;s:12:\"delete-25140\";i:24447;s:12:\"delete-25141\";i:24448;s:12:\"delete-25142\";i:24449;s:12:\"delete-25143\";i:24450;s:12:\"delete-25144\";i:24451;s:12:\"delete-25145\";i:24452;s:12:\"delete-25146\";i:24453;s:12:\"delete-25147\";i:24454;s:12:\"delete-25148\";i:24455;s:12:\"delete-25149\";i:24456;s:12:\"delete-25150\";i:24457;s:12:\"delete-25151\";i:24458;s:12:\"delete-25152\";i:24459;s:12:\"delete-25153\";i:24460;s:12:\"delete-25154\";i:24461;s:12:\"delete-25155\";i:24462;s:12:\"delete-25156\";i:24463;s:12:\"delete-25157\";i:24464;s:12:\"delete-25158\";i:24465;s:12:\"delete-25159\";i:24466;s:12:\"delete-25160\";i:24467;s:12:\"delete-25161\";i:24468;s:12:\"delete-25162\";i:24469;s:12:\"delete-25163\";i:24470;s:12:\"delete-25164\";i:24471;s:12:\"delete-25165\";i:24472;s:12:\"delete-25166\";i:24473;s:12:\"delete-25167\";i:24474;s:12:\"delete-25168\";i:24475;s:12:\"delete-25169\";i:24476;s:12:\"delete-25170\";i:24477;s:12:\"delete-25171\";i:24478;s:12:\"delete-25172\";i:24479;s:12:\"delete-25173\";i:24480;s:12:\"delete-25174\";i:24481;s:12:\"delete-25175\";i:24482;s:12:\"delete-25176\";i:24483;s:12:\"delete-25177\";i:24484;s:12:\"delete-25178\";i:24485;s:12:\"delete-25179\";i:24486;s:12:\"delete-25180\";i:24487;s:12:\"delete-25181\";i:24488;s:12:\"delete-25182\";i:24489;s:12:\"delete-25183\";i:24490;s:12:\"delete-25184\";i:24491;s:12:\"delete-25185\";i:24492;s:12:\"delete-25186\";i:24493;s:12:\"delete-25187\";i:24494;s:12:\"delete-25188\";i:24495;s:12:\"delete-25189\";i:24496;s:12:\"delete-25190\";i:24497;s:12:\"delete-25191\";i:24498;s:12:\"delete-25192\";i:24499;s:12:\"delete-25193\";i:24500;s:12:\"delete-25194\";i:24501;s:12:\"delete-25195\";i:24502;s:12:\"delete-25196\";i:24503;s:12:\"delete-25197\";i:24504;s:12:\"delete-25198\";i:24505;s:12:\"delete-25199\";i:24506;s:12:\"delete-25200\";i:24507;s:12:\"delete-25201\";i:24508;s:12:\"delete-25202\";i:24509;s:12:\"delete-25203\";i:24510;s:12:\"delete-25204\";i:24511;s:12:\"delete-25205\";i:24512;s:12:\"delete-25206\";i:24513;s:12:\"delete-25207\";i:24514;s:12:\"delete-25208\";i:24515;s:12:\"delete-25209\";i:24516;s:12:\"delete-25210\";i:24517;s:12:\"delete-25211\";i:24518;s:12:\"delete-25212\";i:24519;s:12:\"delete-25213\";i:24520;s:12:\"delete-25214\";i:24521;s:12:\"delete-25215\";i:24522;s:12:\"delete-25216\";i:24523;s:12:\"delete-25217\";i:24524;s:12:\"delete-25218\";i:24525;s:12:\"delete-25219\";i:24526;s:12:\"delete-25220\";i:24527;s:12:\"delete-25221\";i:24528;s:12:\"delete-25222\";i:24529;s:12:\"delete-25223\";i:24530;s:12:\"delete-25224\";i:24531;s:12:\"delete-25225\";i:24532;s:12:\"delete-25226\";i:24533;s:12:\"delete-25227\";i:24534;s:12:\"delete-25228\";i:24535;s:12:\"delete-25229\";i:24536;s:12:\"delete-25230\";i:24537;s:12:\"delete-25231\";i:24538;s:12:\"delete-25232\";i:24539;s:12:\"delete-25233\";i:24540;s:12:\"delete-25234\";i:24541;s:12:\"delete-25235\";i:24542;s:12:\"delete-25236\";i:24543;s:12:\"delete-25237\";i:24544;s:12:\"delete-25238\";i:24545;s:12:\"delete-25239\";i:24546;s:12:\"delete-25240\";i:24547;s:12:\"delete-25241\";i:24548;s:12:\"delete-25242\";i:24549;s:12:\"delete-25243\";i:24550;s:12:\"delete-25244\";i:24551;s:12:\"delete-25245\";i:24552;s:12:\"delete-25246\";i:24553;s:12:\"delete-25247\";i:24554;s:12:\"delete-25248\";i:24555;s:12:\"delete-25249\";i:24556;s:12:\"delete-25250\";i:24557;s:12:\"delete-25251\";i:24558;s:12:\"delete-25252\";i:24559;s:12:\"delete-25253\";i:24560;s:12:\"delete-25254\";i:24561;s:12:\"delete-25255\";i:24562;s:12:\"delete-25256\";i:24563;s:12:\"delete-25257\";i:24564;s:12:\"delete-25258\";i:24565;s:12:\"delete-25259\";i:24566;s:12:\"delete-25260\";i:24567;s:12:\"delete-25261\";i:24568;s:12:\"delete-25262\";i:24569;s:12:\"delete-25263\";i:24570;s:12:\"delete-25264\";i:24571;s:12:\"delete-25265\";i:24572;s:12:\"delete-25266\";i:24573;s:12:\"delete-25267\";i:24574;s:12:\"delete-25268\";i:24575;s:12:\"delete-25269\";i:24576;s:12:\"delete-25270\";i:24577;s:12:\"delete-25271\";i:24578;s:12:\"delete-25272\";i:24579;s:12:\"delete-25273\";i:24580;s:12:\"delete-25274\";i:24581;s:12:\"delete-25275\";i:24582;s:12:\"delete-25276\";i:24583;s:12:\"delete-25277\";i:24584;s:12:\"delete-25278\";i:24585;s:12:\"delete-25279\";i:24586;s:12:\"delete-25280\";i:24587;s:12:\"delete-25281\";i:24588;s:12:\"delete-25282\";i:24589;s:12:\"delete-25283\";i:24590;s:12:\"delete-25284\";i:24591;s:12:\"delete-25285\";i:24592;s:12:\"delete-25286\";i:24593;s:12:\"delete-25287\";i:24594;s:12:\"delete-25288\";i:24595;s:12:\"delete-25289\";i:24596;s:12:\"delete-25290\";i:24597;s:12:\"delete-25291\";i:24598;s:12:\"delete-25292\";i:24599;s:12:\"delete-25293\";i:24600;s:12:\"delete-25294\";i:24601;s:12:\"delete-25295\";i:24602;s:12:\"delete-25296\";i:24603;s:12:\"delete-25297\";i:24604;s:12:\"delete-25298\";i:24605;s:12:\"delete-25299\";i:24606;s:12:\"delete-25300\";i:24607;s:12:\"delete-25301\";i:24608;s:12:\"delete-25302\";i:24609;s:12:\"delete-25303\";i:24610;s:12:\"delete-25304\";i:24611;s:12:\"delete-25305\";i:24612;s:12:\"delete-25306\";i:24613;s:12:\"delete-25307\";i:24614;s:12:\"delete-25308\";i:24615;s:12:\"delete-25309\";i:24616;s:12:\"delete-25310\";i:24617;s:12:\"delete-25311\";i:24618;s:12:\"delete-25312\";i:24619;s:12:\"delete-25313\";i:24620;s:12:\"delete-25314\";i:24621;s:12:\"delete-25315\";i:24622;s:12:\"delete-25316\";i:24623;s:12:\"delete-25317\";i:24624;s:12:\"delete-25318\";i:24625;s:12:\"delete-25319\";i:24626;s:12:\"delete-25320\";i:24627;s:12:\"delete-25321\";i:24628;s:12:\"delete-25322\";i:24629;s:12:\"delete-25323\";i:24630;s:12:\"delete-25324\";i:24631;s:12:\"delete-25325\";i:24632;s:12:\"delete-25326\";i:24633;s:12:\"delete-25327\";i:24634;s:12:\"delete-25328\";i:24635;s:12:\"delete-25329\";i:24636;s:12:\"delete-25330\";i:24637;s:12:\"delete-25331\";i:24638;s:12:\"delete-25332\";i:24639;s:12:\"delete-25333\";i:24640;s:12:\"delete-25334\";i:24641;s:12:\"delete-25335\";i:24642;s:12:\"delete-25336\";i:24643;s:12:\"delete-25337\";i:24644;s:12:\"delete-25338\";i:24645;s:12:\"delete-25339\";i:24646;s:12:\"delete-25340\";i:24647;s:12:\"delete-25341\";i:24648;s:12:\"delete-25342\";i:24649;s:12:\"delete-25343\";i:24650;s:12:\"delete-25344\";i:24651;s:12:\"delete-25345\";i:24652;s:12:\"delete-25346\";i:24653;s:12:\"delete-25347\";i:24654;s:12:\"delete-25348\";i:24655;s:12:\"delete-25349\";i:24656;s:12:\"delete-25350\";i:24657;s:12:\"delete-25351\";i:24658;s:12:\"delete-25352\";i:24659;s:12:\"delete-25353\";i:24660;s:12:\"delete-25354\";i:24661;s:12:\"delete-25355\";i:24662;s:12:\"delete-25356\";i:24663;s:12:\"delete-25357\";i:24664;s:12:\"delete-25358\";i:24665;s:12:\"delete-25359\";i:24666;s:12:\"delete-25360\";i:24667;s:12:\"delete-25361\";i:24668;s:12:\"delete-25362\";i:24669;s:12:\"delete-25363\";i:24670;s:12:\"delete-25364\";i:24671;s:12:\"delete-25365\";i:24672;s:12:\"delete-25366\";i:24673;s:12:\"delete-25367\";i:24674;s:12:\"delete-25368\";i:24675;s:12:\"delete-25369\";i:24676;s:12:\"delete-25370\";i:24677;s:12:\"delete-25371\";i:24678;s:12:\"delete-25372\";i:24679;s:12:\"delete-25373\";i:24680;s:12:\"delete-25374\";i:24681;s:12:\"delete-25375\";i:24682;s:12:\"delete-25376\";i:24683;s:12:\"delete-25377\";i:24684;s:12:\"delete-25378\";i:24685;s:12:\"delete-25379\";i:24686;s:12:\"delete-25380\";i:24687;s:12:\"delete-25381\";i:24688;s:12:\"delete-25382\";i:24689;s:12:\"delete-25383\";i:24690;s:12:\"delete-25384\";i:24691;s:12:\"delete-25385\";i:24692;s:12:\"delete-25386\";i:24693;s:12:\"delete-25387\";i:24694;s:12:\"delete-25388\";i:24695;s:12:\"delete-25389\";i:24696;s:12:\"delete-25390\";i:24697;s:12:\"delete-25391\";i:24698;s:12:\"delete-25392\";i:24699;s:12:\"delete-25393\";i:24700;s:12:\"delete-25394\";i:24701;s:12:\"delete-25395\";i:24702;s:12:\"delete-25396\";i:24703;s:12:\"delete-25397\";i:24704;s:12:\"delete-25398\";i:24705;s:12:\"delete-25399\";i:24706;s:12:\"delete-25400\";i:24707;s:12:\"delete-25401\";i:24708;s:12:\"delete-25402\";i:24709;s:12:\"delete-25403\";i:24710;s:12:\"delete-25404\";i:24711;s:12:\"delete-25405\";i:24712;s:12:\"delete-25406\";i:24713;s:12:\"delete-25407\";i:24714;s:12:\"delete-25408\";i:24715;s:12:\"delete-25409\";i:24716;s:12:\"delete-25410\";i:24717;s:12:\"delete-25411\";i:24718;s:12:\"delete-25412\";i:24719;s:12:\"delete-25413\";i:24720;s:12:\"delete-25414\";i:24721;s:12:\"delete-25415\";i:24722;s:12:\"delete-25416\";i:24723;s:12:\"delete-25417\";i:24724;s:12:\"delete-25418\";i:24725;s:12:\"delete-25419\";i:24726;s:12:\"delete-25420\";i:24727;s:12:\"delete-25421\";i:24728;s:12:\"delete-25422\";i:24729;s:12:\"delete-25423\";i:24730;s:12:\"delete-25424\";i:24731;s:12:\"delete-25425\";i:24732;s:12:\"delete-25426\";i:24733;s:12:\"delete-25427\";i:24734;s:12:\"delete-25428\";i:24735;s:12:\"delete-25429\";i:24736;s:12:\"delete-25430\";i:24737;s:12:\"delete-25431\";i:24738;s:12:\"delete-25432\";i:24739;s:12:\"delete-25433\";i:24740;s:12:\"delete-25434\";i:24741;s:12:\"delete-25435\";i:24742;s:12:\"delete-25436\";i:24743;s:12:\"delete-25437\";i:24744;s:12:\"delete-25438\";i:24745;s:12:\"delete-25439\";i:24746;s:12:\"delete-25440\";i:24747;s:12:\"delete-25441\";i:24748;s:12:\"delete-25442\";i:24749;s:12:\"delete-25443\";i:24750;s:12:\"delete-25444\";i:24751;s:12:\"delete-25445\";i:24752;s:12:\"delete-25446\";i:24753;s:12:\"delete-25447\";i:24754;s:12:\"delete-25448\";i:24755;s:12:\"delete-25449\";i:24756;s:12:\"delete-25450\";i:24757;s:12:\"delete-25451\";i:24758;s:12:\"delete-25452\";i:24759;s:12:\"delete-25453\";i:24760;s:12:\"delete-25454\";i:24761;s:12:\"delete-25455\";i:24762;s:12:\"delete-25456\";i:24763;s:12:\"delete-25457\";i:24764;s:12:\"delete-25458\";i:24765;s:12:\"delete-25459\";i:24766;s:12:\"delete-25460\";i:24767;s:12:\"delete-25461\";i:24768;s:12:\"delete-25462\";i:24769;s:12:\"delete-25463\";i:24770;s:12:\"delete-25464\";i:24771;s:12:\"delete-25465\";i:24772;s:12:\"delete-25466\";i:24773;s:12:\"delete-25467\";i:24774;s:12:\"delete-25468\";i:24775;s:12:\"delete-25469\";i:24776;s:12:\"delete-25470\";i:24777;s:12:\"delete-25471\";i:24778;s:12:\"delete-25472\";i:24779;s:12:\"delete-25473\";i:24780;s:12:\"delete-25474\";i:24781;s:12:\"delete-25475\";i:24782;s:12:\"delete-25476\";i:24783;s:12:\"delete-25477\";i:24784;s:12:\"delete-25478\";i:24785;s:12:\"delete-25479\";i:24786;s:12:\"delete-25480\";i:24787;s:12:\"delete-25481\";i:24788;s:12:\"delete-25482\";i:24789;s:12:\"delete-25483\";i:24790;s:12:\"delete-25484\";i:24791;s:12:\"delete-25485\";i:24792;s:12:\"delete-25486\";i:24793;s:12:\"delete-25487\";i:24794;s:12:\"delete-25488\";i:24795;s:12:\"delete-25489\";i:24796;s:12:\"delete-25490\";i:24797;s:12:\"delete-25491\";i:24798;s:12:\"delete-25492\";i:24799;s:12:\"delete-25493\";i:24800;s:12:\"delete-25494\";i:24801;s:12:\"delete-25495\";i:24802;s:12:\"delete-25496\";i:24803;s:12:\"delete-25497\";i:24804;s:12:\"delete-25498\";i:24805;s:12:\"delete-25499\";i:24806;s:12:\"delete-25500\";i:24807;s:12:\"delete-25501\";i:24808;s:12:\"delete-25502\";i:24809;s:12:\"delete-25503\";i:24810;s:12:\"delete-25504\";i:24811;s:12:\"delete-25505\";i:24812;s:12:\"delete-25506\";i:24813;s:12:\"delete-25507\";i:24814;s:12:\"delete-25508\";i:24815;s:12:\"delete-25509\";i:24816;s:12:\"delete-25510\";i:24817;s:12:\"delete-25511\";i:24818;s:12:\"delete-25512\";i:24819;s:12:\"delete-25513\";i:24820;s:12:\"delete-25514\";i:24821;s:12:\"delete-25515\";i:24822;s:12:\"delete-25516\";i:24823;s:12:\"delete-25517\";i:24824;s:12:\"delete-25518\";i:24825;s:12:\"delete-25519\";i:24826;s:12:\"delete-25520\";i:24827;s:12:\"delete-25521\";i:24828;s:12:\"delete-25522\";i:24829;s:12:\"delete-25523\";i:24830;s:12:\"delete-25524\";i:24831;s:12:\"delete-25525\";i:24832;s:12:\"delete-25526\";i:24833;s:12:\"delete-25527\";i:24834;s:12:\"delete-25528\";i:24835;s:12:\"delete-25529\";i:24836;s:12:\"delete-25530\";i:24837;s:12:\"delete-25531\";i:24838;s:12:\"delete-25532\";i:24839;s:12:\"delete-25533\";i:24840;s:12:\"delete-25534\";i:24841;s:12:\"delete-25535\";i:24842;s:12:\"delete-25536\";i:24843;s:12:\"delete-25537\";i:24844;s:12:\"delete-25538\";i:24845;s:12:\"delete-25539\";i:24846;s:12:\"delete-25540\";i:24847;s:12:\"delete-25541\";i:24848;s:12:\"delete-25542\";i:24849;s:12:\"delete-25543\";i:24850;s:12:\"delete-25544\";i:24851;s:12:\"delete-25545\";i:24852;s:12:\"delete-25546\";i:24853;s:12:\"delete-25547\";i:24854;s:12:\"delete-25548\";i:24855;s:12:\"delete-25549\";i:24856;s:12:\"delete-25550\";i:24857;s:12:\"delete-25551\";i:24858;s:12:\"delete-25552\";i:24859;s:12:\"delete-25553\";i:24860;s:12:\"delete-25554\";i:24861;s:12:\"delete-25555\";i:24862;s:12:\"delete-25556\";i:24863;s:12:\"delete-25557\";i:24864;s:12:\"delete-25558\";i:24865;s:12:\"delete-25559\";i:24866;s:12:\"delete-25560\";i:24867;s:12:\"delete-25561\";i:24868;s:12:\"delete-25562\";i:24869;s:12:\"delete-25563\";i:24870;s:12:\"delete-25564\";i:24871;s:12:\"delete-25565\";i:24872;s:12:\"delete-25566\";i:24873;s:12:\"delete-25567\";i:24874;s:12:\"delete-25568\";i:24875;s:12:\"delete-25569\";i:24876;s:12:\"delete-25570\";i:24877;s:12:\"delete-25571\";i:24878;s:12:\"delete-25572\";i:24879;s:12:\"delete-25573\";i:24880;s:12:\"delete-25574\";i:24881;s:12:\"delete-25575\";i:24882;s:12:\"delete-25576\";i:24883;s:12:\"delete-25577\";i:24884;s:12:\"delete-25578\";i:24885;s:12:\"delete-25579\";i:24886;s:12:\"delete-25580\";i:24887;s:12:\"delete-25581\";i:24888;s:12:\"delete-25582\";i:24889;s:12:\"delete-25583\";i:24890;s:12:\"delete-25584\";i:24891;s:12:\"delete-25585\";i:24892;s:12:\"delete-25586\";i:24893;s:12:\"delete-25587\";i:24894;s:12:\"delete-25588\";i:24895;s:12:\"delete-25589\";i:24896;s:12:\"delete-25590\";i:24897;s:12:\"delete-25591\";i:24898;s:12:\"delete-25592\";i:24899;s:12:\"delete-25593\";i:24900;s:12:\"delete-25594\";i:24901;s:12:\"delete-25595\";i:24902;s:12:\"delete-25596\";i:24903;s:12:\"delete-25597\";i:24904;s:12:\"delete-25598\";i:24905;s:12:\"delete-25599\";i:24906;s:12:\"delete-25600\";i:24907;s:12:\"delete-25601\";i:24908;s:12:\"delete-25602\";i:24909;s:12:\"delete-25603\";i:24910;s:12:\"delete-25604\";i:24911;s:12:\"delete-25605\";i:24912;s:12:\"delete-25606\";i:24913;s:12:\"delete-25607\";i:24914;s:12:\"delete-25608\";i:24915;s:12:\"delete-25609\";i:24916;s:12:\"delete-25610\";i:24917;s:12:\"delete-25611\";i:24918;s:12:\"delete-25612\";i:24919;s:12:\"delete-25613\";i:24920;s:12:\"delete-25614\";i:24921;s:12:\"delete-25615\";i:24922;s:12:\"delete-25616\";i:24923;s:12:\"delete-25617\";i:24924;s:12:\"delete-25618\";i:24925;s:12:\"delete-25619\";i:24926;s:12:\"delete-25620\";i:24927;s:12:\"delete-25621\";i:24928;s:12:\"delete-25622\";i:24929;s:12:\"delete-25623\";i:24930;s:12:\"delete-25624\";i:24931;s:12:\"delete-25625\";i:24932;s:12:\"delete-25626\";i:24933;s:12:\"delete-25627\";i:24934;s:12:\"delete-25628\";i:24935;s:12:\"delete-25629\";i:24936;s:12:\"delete-25630\";i:24937;s:12:\"delete-25631\";i:24938;s:12:\"delete-25632\";i:24939;s:12:\"delete-25633\";i:24940;s:12:\"delete-25634\";i:24941;s:12:\"delete-25635\";i:24942;s:12:\"delete-25636\";i:24943;s:12:\"delete-25637\";i:24944;s:12:\"delete-25638\";i:24945;s:12:\"delete-25639\";i:24946;s:12:\"delete-25640\";i:24947;s:12:\"delete-25641\";i:24948;s:12:\"delete-25642\";i:24949;s:12:\"delete-25643\";i:24950;s:12:\"delete-25644\";i:24951;s:12:\"delete-25645\";i:24952;s:12:\"delete-25646\";i:24953;s:12:\"delete-25647\";i:24954;s:12:\"delete-25648\";i:24955;s:12:\"delete-25649\";i:24956;s:12:\"delete-25650\";i:24957;s:12:\"delete-25651\";i:24958;s:12:\"delete-25652\";i:24959;s:12:\"delete-25653\";i:24960;s:12:\"delete-25654\";i:24961;s:12:\"delete-25655\";i:24962;s:12:\"delete-25656\";i:24963;s:12:\"delete-25657\";i:24964;s:12:\"delete-25658\";i:24965;s:12:\"delete-25659\";i:24966;s:12:\"delete-25660\";i:24967;s:12:\"delete-25661\";i:24968;s:12:\"delete-25662\";i:24969;s:12:\"delete-25663\";i:24970;s:12:\"delete-25664\";i:24971;s:12:\"delete-25665\";i:24972;s:12:\"delete-25666\";i:24973;s:12:\"delete-25667\";i:24974;s:12:\"delete-25668\";i:24975;s:12:\"delete-25669\";i:24976;s:12:\"delete-25670\";i:24977;s:12:\"delete-25671\";i:24978;s:12:\"delete-25672\";i:24979;s:12:\"delete-25673\";i:24980;s:12:\"delete-25674\";i:24981;s:12:\"delete-25675\";i:24982;s:12:\"delete-25676\";i:24983;s:12:\"delete-25677\";i:24984;s:12:\"delete-25678\";i:24985;s:12:\"delete-25679\";i:24986;s:12:\"delete-25680\";i:24987;s:12:\"delete-25681\";i:24988;s:12:\"delete-25682\";i:24989;s:12:\"delete-25683\";i:24990;s:12:\"delete-25684\";i:24991;s:12:\"delete-25685\";i:24992;s:12:\"delete-25686\";i:24993;s:12:\"delete-25687\";i:24994;s:12:\"delete-25688\";i:24995;s:12:\"delete-25689\";i:24996;s:12:\"delete-25690\";i:24997;s:12:\"delete-25691\";i:24998;s:12:\"delete-25692\";i:24999;s:12:\"delete-25693\";i:25000;s:12:\"delete-25694\";i:25001;s:12:\"delete-25695\";i:25002;s:12:\"delete-25696\";i:25003;s:12:\"delete-25697\";i:25004;s:12:\"delete-25698\";i:25005;s:12:\"delete-25699\";i:25006;s:12:\"delete-25700\";i:25007;s:12:\"delete-25701\";i:25008;s:12:\"delete-25702\";i:25009;s:12:\"delete-25703\";i:25010;s:12:\"delete-25704\";i:25011;s:12:\"delete-25705\";i:25012;s:12:\"delete-25706\";i:25013;s:12:\"delete-25707\";i:25014;s:12:\"delete-25708\";i:25015;s:12:\"delete-25709\";i:25016;s:12:\"delete-25710\";i:25017;s:12:\"delete-25711\";i:25018;s:12:\"delete-25712\";i:25019;s:12:\"delete-25713\";i:25020;s:12:\"delete-25714\";i:25021;s:12:\"delete-25715\";i:25022;s:12:\"delete-25716\";i:25023;s:12:\"delete-25717\";i:25024;s:12:\"delete-25718\";i:25025;s:12:\"delete-25719\";i:25026;s:12:\"delete-25720\";i:25027;s:12:\"delete-25721\";i:25028;s:12:\"delete-25722\";i:25029;s:12:\"delete-25723\";i:25030;s:12:\"delete-25724\";i:25031;s:12:\"delete-25725\";i:25032;s:12:\"delete-25726\";i:25033;s:12:\"delete-25727\";i:25034;s:12:\"delete-25728\";i:25035;s:12:\"delete-25729\";i:25036;s:12:\"delete-25730\";i:25037;s:12:\"delete-25731\";i:25038;s:12:\"delete-25732\";i:25039;s:12:\"delete-25733\";i:25040;s:12:\"delete-25734\";i:25041;s:12:\"delete-25735\";i:25042;s:12:\"delete-25736\";i:25043;s:12:\"delete-25737\";i:25044;s:12:\"delete-25738\";i:25045;s:12:\"delete-25739\";i:25046;s:12:\"delete-25794\";i:25047;s:12:\"delete-25795\";i:25048;s:12:\"delete-25796\";i:25049;s:12:\"delete-25797\";i:25050;s:12:\"delete-25798\";i:25051;s:12:\"delete-25799\";i:25052;s:12:\"delete-25800\";i:25053;s:12:\"delete-25801\";i:25054;s:12:\"delete-25802\";i:25055;s:12:\"delete-25803\";i:25056;s:12:\"delete-25804\";i:25057;s:12:\"delete-25805\";i:25058;s:12:\"delete-25806\";i:25059;s:12:\"delete-25807\";i:25060;s:12:\"delete-25808\";i:25061;s:12:\"delete-25809\";i:25062;s:12:\"delete-25810\";i:25063;s:12:\"delete-25811\";i:25064;s:12:\"delete-25812\";i:25065;s:12:\"delete-25813\";i:25066;s:12:\"delete-25814\";i:25067;s:12:\"delete-25815\";i:25068;s:12:\"delete-25816\";i:25069;s:12:\"delete-25817\";i:25070;s:12:\"delete-25818\";i:25071;s:12:\"delete-25819\";i:25072;s:12:\"delete-25820\";i:25073;s:12:\"delete-25821\";i:25074;s:12:\"delete-25822\";i:25075;s:12:\"delete-25823\";i:25076;s:12:\"delete-25824\";i:25077;s:12:\"delete-25825\";i:25078;s:12:\"delete-25826\";i:25079;s:12:\"delete-25827\";i:25080;s:12:\"delete-25828\";i:25081;s:12:\"delete-25829\";i:25082;s:12:\"delete-25830\";i:25083;s:12:\"delete-25831\";i:25084;s:12:\"delete-25832\";i:25085;s:12:\"delete-25833\";i:25086;s:12:\"delete-25834\";i:25087;s:12:\"delete-25835\";i:25088;s:12:\"delete-25836\";i:25089;s:12:\"delete-25837\";i:25090;s:12:\"delete-25838\";i:25091;s:12:\"delete-25839\";i:25092;s:12:\"delete-25840\";i:25093;s:12:\"delete-25841\";i:25094;s:12:\"delete-25842\";i:25095;s:12:\"delete-25843\";i:25096;s:12:\"delete-25844\";i:25097;s:12:\"delete-25845\";i:25098;s:12:\"delete-25846\";i:25099;s:12:\"delete-25847\";i:25100;s:12:\"delete-25848\";i:25101;s:12:\"delete-25849\";i:25102;s:12:\"delete-25850\";i:25103;s:12:\"delete-25851\";i:25104;s:12:\"delete-25852\";i:25105;s:12:\"delete-25853\";i:25106;s:12:\"delete-25854\";i:25107;s:12:\"delete-25855\";i:25108;s:12:\"delete-25856\";i:25109;s:12:\"delete-25857\";i:25110;s:12:\"delete-25858\";i:25111;s:12:\"delete-25859\";i:25112;s:12:\"delete-25860\";i:25113;s:12:\"delete-25861\";i:25114;s:12:\"delete-25862\";i:25115;s:12:\"delete-25863\";i:25116;s:12:\"delete-25864\";i:25117;s:12:\"delete-25865\";i:25118;s:12:\"delete-25866\";i:25119;s:12:\"delete-25867\";i:25120;s:12:\"delete-25868\";i:25121;s:12:\"delete-25869\";i:25122;s:12:\"delete-25870\";i:25123;s:12:\"delete-25871\";i:25124;s:12:\"delete-25872\";i:25125;s:12:\"delete-25873\";i:25126;s:12:\"delete-25874\";i:25127;s:12:\"delete-25875\";i:25128;s:12:\"delete-25876\";i:25129;s:12:\"delete-25877\";i:25130;s:12:\"delete-25878\";i:25131;s:12:\"delete-25879\";i:25132;s:12:\"delete-25880\";i:25133;s:12:\"delete-25881\";i:25134;s:12:\"delete-25882\";i:25135;s:12:\"delete-25883\";i:25136;s:12:\"delete-25884\";i:25137;s:12:\"delete-25885\";i:25138;s:12:\"delete-25886\";i:25139;s:12:\"delete-25887\";i:25140;s:12:\"delete-25888\";i:25141;s:12:\"delete-25889\";i:25142;s:12:\"delete-25890\";i:25143;s:12:\"delete-25891\";i:25144;s:12:\"delete-25892\";i:25145;s:12:\"delete-25893\";i:25146;s:12:\"delete-25894\";i:25147;s:12:\"delete-25895\";i:25148;s:12:\"delete-25896\";i:25149;s:12:\"delete-25897\";i:25150;s:12:\"delete-25898\";i:25151;s:12:\"delete-25899\";i:25152;s:12:\"delete-25900\";i:25153;s:12:\"delete-25901\";i:25154;s:12:\"delete-25902\";i:25155;s:12:\"delete-25903\";i:25156;s:12:\"delete-25904\";i:25157;s:12:\"delete-25905\";i:25158;s:12:\"delete-25906\";i:25159;s:12:\"delete-25907\";i:25160;s:12:\"delete-25908\";i:25161;s:12:\"delete-25909\";i:25162;s:12:\"delete-25910\";i:25163;s:12:\"delete-25911\";i:25164;s:12:\"delete-25912\";i:25165;s:12:\"delete-25913\";i:25166;s:12:\"delete-25914\";i:25167;s:12:\"delete-25915\";i:25168;s:12:\"delete-25916\";i:25169;s:12:\"delete-25917\";i:25170;s:12:\"delete-25918\";i:25171;s:12:\"delete-25919\";i:25172;s:12:\"delete-25920\";i:25173;s:12:\"delete-25921\";i:25174;s:12:\"delete-25922\";i:25175;s:12:\"delete-25923\";i:25176;s:12:\"delete-25924\";i:25177;s:12:\"delete-25925\";i:25178;s:12:\"delete-25926\";i:25179;s:12:\"delete-25927\";i:25180;s:12:\"delete-25928\";i:25181;s:12:\"delete-25929\";i:25182;s:12:\"delete-25930\";i:25183;s:12:\"delete-25931\";i:25184;s:12:\"delete-25932\";i:25185;s:12:\"delete-25933\";i:25186;s:12:\"delete-25934\";i:25187;s:12:\"delete-25935\";i:25188;s:12:\"delete-25936\";i:25189;s:12:\"delete-25937\";i:25190;s:12:\"delete-25938\";i:25191;s:12:\"delete-25939\";i:25192;s:12:\"delete-25940\";i:25193;s:12:\"delete-25941\";i:25194;s:12:\"delete-25942\";i:25195;s:12:\"delete-25943\";i:25196;s:12:\"delete-25944\";i:25197;s:12:\"delete-25945\";i:25198;s:12:\"delete-25946\";i:25199;s:12:\"delete-25947\";i:25200;s:12:\"delete-25948\";i:25201;s:12:\"delete-25949\";i:25202;s:12:\"delete-25950\";i:25203;s:12:\"delete-25951\";i:25204;s:12:\"delete-25952\";i:25205;s:12:\"delete-25953\";i:25206;s:12:\"delete-25954\";i:25207;s:12:\"delete-25955\";i:25208;s:12:\"delete-25956\";i:25209;s:12:\"delete-25957\";i:25210;s:12:\"delete-25958\";i:25211;s:12:\"delete-25959\";i:25212;s:12:\"delete-25960\";i:25213;s:12:\"delete-25961\";i:25214;s:12:\"delete-25962\";i:25215;s:12:\"delete-25963\";i:25216;s:12:\"delete-25964\";i:25217;s:12:\"delete-25965\";i:25218;s:12:\"delete-25966\";i:25219;s:12:\"delete-25967\";i:25220;s:12:\"delete-25968\";i:25221;s:12:\"delete-25969\";i:25222;s:12:\"delete-25970\";i:25223;s:12:\"delete-25971\";i:25224;s:12:\"delete-25972\";i:25225;s:12:\"delete-25973\";i:25226;s:12:\"delete-25974\";i:25227;s:12:\"delete-25975\";i:25228;s:12:\"delete-25976\";i:25229;s:12:\"delete-25977\";i:25230;s:12:\"delete-25978\";i:25231;s:12:\"delete-25979\";i:25232;s:12:\"delete-25980\";i:25233;s:12:\"delete-25981\";i:25234;s:12:\"delete-25982\";i:25235;s:12:\"delete-25983\";i:25236;s:12:\"delete-25984\";i:25237;s:12:\"delete-25985\";i:25238;s:12:\"delete-25986\";i:25239;s:12:\"delete-25987\";i:25240;s:12:\"delete-25988\";i:25241;s:12:\"delete-25989\";i:25242;s:12:\"delete-25990\";i:25243;s:12:\"delete-25991\";i:25244;s:12:\"delete-25992\";i:25245;s:12:\"delete-25993\";i:25246;s:12:\"delete-25994\";i:25247;s:12:\"delete-25995\";i:25248;s:12:\"delete-25996\";i:25249;s:12:\"delete-25997\";i:25250;s:12:\"delete-25998\";i:25251;s:12:\"delete-25999\";i:25252;s:12:\"delete-26000\";i:25253;s:12:\"delete-26001\";i:25254;s:12:\"delete-26002\";i:25255;s:12:\"delete-26003\";i:25256;s:12:\"delete-26004\";i:25257;s:12:\"delete-26005\";i:25258;s:12:\"delete-26006\";i:25259;s:12:\"delete-26007\";i:25260;s:12:\"delete-26008\";i:25261;s:12:\"delete-26009\";i:25262;s:12:\"delete-26010\";i:25263;s:12:\"delete-26011\";i:25264;s:12:\"delete-26012\";i:25265;s:12:\"delete-26013\";i:25266;s:12:\"delete-26014\";i:25267;s:12:\"delete-26015\";i:25268;s:12:\"delete-26016\";i:25269;s:12:\"delete-26017\";i:25270;s:12:\"delete-26018\";i:25271;s:12:\"delete-26019\";i:25272;s:12:\"delete-26020\";i:25273;s:12:\"delete-26021\";i:25274;s:12:\"delete-26022\";i:25275;s:12:\"delete-26023\";i:25276;s:12:\"delete-26024\";i:25277;s:12:\"delete-26025\";i:25278;s:12:\"delete-26026\";i:25279;s:12:\"delete-26027\";i:25280;s:12:\"delete-26028\";i:25281;s:12:\"delete-26029\";i:25282;s:12:\"delete-26030\";i:25283;s:12:\"delete-26031\";i:25284;s:12:\"delete-26032\";i:25285;s:12:\"delete-26033\";i:25286;s:12:\"delete-26034\";i:25287;s:12:\"delete-26035\";i:25288;s:12:\"delete-26036\";i:25289;s:12:\"delete-26037\";i:25290;s:12:\"delete-26038\";i:25291;s:12:\"delete-26039\";i:25292;s:12:\"delete-26040\";i:25293;s:12:\"delete-26041\";i:25294;s:12:\"delete-26042\";i:25295;s:12:\"delete-26043\";i:25296;s:12:\"delete-26044\";i:25297;s:12:\"delete-26045\";i:25298;s:12:\"delete-26046\";i:25299;s:12:\"delete-26047\";i:25300;s:12:\"delete-26048\";i:25301;s:12:\"delete-26049\";i:25302;s:12:\"delete-26050\";i:25303;s:12:\"delete-26051\";i:25304;s:12:\"delete-26052\";i:25305;s:12:\"delete-26053\";i:25306;s:12:\"delete-26054\";i:25307;s:12:\"delete-26055\";i:25308;s:12:\"delete-26056\";i:25309;s:12:\"delete-26057\";i:25310;s:12:\"delete-26058\";i:25311;s:12:\"delete-26059\";i:25312;s:12:\"delete-26060\";i:25313;s:12:\"delete-26061\";i:25314;s:12:\"delete-26062\";i:25315;s:12:\"delete-26063\";i:25316;s:12:\"delete-26064\";i:25317;s:12:\"delete-26065\";i:25318;s:12:\"delete-26066\";i:25319;s:12:\"delete-26067\";i:25320;s:12:\"delete-26068\";i:25321;s:12:\"delete-26069\";i:25322;s:12:\"delete-26070\";i:25323;s:12:\"delete-26071\";i:25324;s:12:\"delete-26072\";i:25325;s:12:\"delete-26073\";i:25326;s:12:\"delete-26074\";i:25327;s:12:\"delete-26075\";i:25328;s:12:\"delete-26076\";i:25329;s:12:\"delete-26077\";i:25330;s:12:\"delete-26078\";i:25331;s:12:\"delete-26079\";i:25332;s:12:\"delete-26080\";i:25333;s:12:\"delete-26081\";i:25334;s:12:\"delete-26082\";i:25335;s:12:\"delete-26083\";i:25336;s:12:\"delete-26084\";i:25337;s:12:\"delete-26085\";i:25338;s:12:\"delete-26086\";i:25339;s:12:\"delete-26087\";i:25340;s:12:\"delete-26088\";i:25341;s:12:\"delete-26089\";i:25342;s:12:\"delete-26090\";i:25343;s:12:\"delete-26091\";i:25344;s:12:\"delete-26092\";i:25345;s:12:\"delete-26093\";i:25346;s:12:\"delete-26094\";i:25347;s:12:\"delete-26095\";i:25348;s:12:\"delete-26096\";i:25349;s:12:\"delete-26097\";i:25350;s:12:\"delete-26098\";i:25351;s:12:\"delete-26099\";i:25352;s:12:\"delete-26100\";i:25353;s:12:\"delete-26101\";i:25354;s:12:\"delete-26102\";i:25355;s:12:\"delete-26103\";i:25356;s:12:\"delete-26104\";i:25357;s:12:\"delete-26105\";i:25358;s:12:\"delete-26106\";i:25359;s:12:\"delete-26107\";i:25360;s:12:\"delete-26108\";i:25361;s:12:\"delete-26109\";i:25362;s:12:\"delete-26110\";i:25363;s:12:\"delete-26111\";i:25364;s:12:\"delete-26112\";i:25365;s:12:\"delete-26113\";i:25366;s:12:\"delete-26114\";i:25367;s:12:\"delete-26115\";i:25368;s:12:\"delete-26116\";i:25369;s:12:\"delete-26117\";i:25370;s:12:\"delete-26118\";i:25371;s:12:\"delete-26119\";i:25372;s:12:\"delete-26120\";i:25373;s:12:\"delete-26121\";i:25374;s:12:\"delete-26122\";i:25375;s:12:\"delete-26123\";i:25376;s:12:\"delete-26124\";i:25377;s:12:\"delete-26125\";i:25378;s:12:\"delete-26126\";i:25379;s:12:\"delete-26127\";i:25380;s:12:\"delete-26128\";i:25381;s:12:\"delete-26129\";i:25382;s:12:\"delete-26130\";i:25383;s:12:\"delete-26131\";i:25384;s:12:\"delete-26132\";i:25385;s:12:\"delete-26133\";i:25386;s:12:\"delete-26134\";i:25387;s:12:\"delete-26135\";i:25388;s:12:\"delete-26136\";i:25389;s:12:\"delete-26137\";i:25390;s:12:\"delete-26138\";i:25391;s:12:\"delete-26139\";i:25392;s:12:\"delete-26140\";i:25393;s:12:\"delete-26141\";i:25394;s:12:\"delete-26142\";i:25395;s:12:\"delete-26143\";i:25396;s:12:\"delete-26144\";i:25397;s:12:\"delete-26145\";i:25398;s:12:\"delete-26146\";i:25399;s:12:\"delete-26147\";i:25400;s:12:\"delete-26148\";i:25401;s:12:\"delete-26149\";i:25402;s:12:\"delete-26150\";i:25403;s:12:\"delete-26151\";i:25404;s:12:\"delete-26152\";i:25405;s:12:\"delete-26153\";i:25406;s:12:\"delete-26154\";i:25407;s:12:\"delete-26155\";i:25408;s:12:\"delete-26156\";i:25409;s:12:\"delete-26157\";i:25410;s:12:\"delete-26158\";i:25411;s:12:\"delete-26159\";i:25412;s:12:\"delete-26160\";i:25413;s:12:\"delete-26161\";i:25414;s:12:\"delete-26162\";i:25415;s:12:\"delete-26163\";i:25416;s:12:\"delete-26164\";i:25417;s:12:\"delete-26165\";i:25418;s:12:\"delete-26166\";i:25419;s:12:\"delete-26167\";i:25420;s:12:\"delete-26168\";i:25421;s:12:\"delete-26169\";i:25422;s:12:\"delete-26170\";i:25423;s:12:\"delete-26171\";i:25424;s:12:\"delete-26172\";i:25425;s:12:\"delete-26173\";i:25426;s:12:\"delete-26174\";i:25427;s:12:\"delete-26175\";i:25428;s:12:\"delete-26176\";i:25429;s:12:\"delete-26177\";i:25430;s:12:\"delete-26178\";i:25431;s:12:\"delete-26179\";i:25432;s:12:\"delete-26180\";i:25433;s:12:\"delete-26181\";i:25434;s:12:\"delete-26182\";i:25435;s:12:\"delete-26183\";i:25436;s:12:\"delete-26184\";i:25437;s:12:\"delete-26185\";i:25438;s:12:\"delete-26186\";i:25439;s:12:\"delete-26187\";i:25440;s:12:\"delete-26188\";i:25441;s:12:\"delete-26189\";i:25442;s:12:\"delete-26190\";i:25443;s:12:\"delete-26191\";i:25444;s:12:\"delete-26192\";i:25445;s:12:\"delete-26193\";i:25446;s:12:\"delete-26194\";i:25447;s:12:\"delete-26195\";i:25448;s:12:\"delete-26196\";i:25449;s:12:\"delete-26197\";i:25450;s:12:\"delete-26198\";i:25451;s:12:\"delete-26199\";i:25452;s:12:\"delete-26200\";i:25453;s:12:\"delete-26201\";i:25454;s:12:\"delete-26202\";i:25455;s:12:\"delete-26203\";i:25456;s:12:\"delete-26204\";i:25457;s:12:\"delete-26205\";i:25458;s:12:\"delete-26206\";i:25459;s:12:\"delete-26207\";i:25460;s:12:\"delete-26208\";i:25461;s:12:\"delete-26209\";i:25462;s:12:\"delete-26210\";i:25463;s:12:\"delete-26211\";i:25464;s:12:\"delete-26212\";i:25465;s:12:\"delete-26213\";i:25466;s:12:\"delete-26214\";i:25467;s:12:\"delete-26215\";i:25468;s:12:\"delete-26216\";i:25469;s:12:\"delete-26217\";i:25470;s:12:\"delete-26218\";i:25471;s:12:\"delete-26219\";i:25472;s:12:\"delete-26220\";i:25473;s:12:\"delete-26221\";i:25474;s:12:\"delete-26222\";i:25475;s:12:\"delete-26223\";i:25476;s:12:\"delete-26224\";i:25477;s:12:\"delete-26225\";i:25478;s:12:\"delete-26226\";i:25479;s:12:\"delete-26227\";i:25480;s:12:\"delete-26228\";i:25481;s:12:\"delete-26229\";i:25482;s:12:\"delete-26230\";i:25483;s:12:\"delete-26231\";i:25484;s:12:\"delete-26232\";i:25485;s:12:\"delete-26233\";i:25486;s:12:\"delete-26234\";i:25487;s:12:\"delete-26235\";i:25488;s:12:\"delete-26236\";i:25489;s:12:\"delete-26237\";i:25490;s:12:\"delete-26238\";i:25491;s:12:\"delete-26239\";i:25492;s:12:\"delete-26240\";i:25493;s:12:\"delete-26241\";i:25494;s:12:\"delete-26242\";i:25495;s:12:\"delete-26243\";i:25496;s:12:\"delete-26244\";i:25497;s:12:\"delete-26245\";i:25498;s:12:\"delete-26246\";i:25499;s:12:\"delete-26247\";i:25500;s:12:\"delete-26248\";i:25501;s:12:\"delete-26249\";i:25502;s:12:\"delete-26250\";i:25503;s:12:\"delete-26251\";i:25504;s:12:\"delete-26252\";i:25505;s:12:\"delete-26253\";i:25506;s:12:\"delete-26254\";i:25507;s:12:\"delete-26255\";i:25508;s:12:\"delete-26256\";i:25509;s:12:\"delete-26257\";i:25510;s:12:\"delete-26258\";i:25511;s:12:\"delete-26259\";i:25512;s:12:\"delete-26260\";i:25513;s:12:\"delete-26261\";i:25514;s:12:\"delete-26262\";i:25515;s:12:\"delete-26263\";i:25516;s:12:\"delete-26264\";i:25517;s:12:\"delete-26265\";i:25518;s:12:\"delete-26266\";i:25519;s:12:\"delete-26267\";i:25520;s:12:\"delete-26268\";i:25521;s:12:\"delete-26269\";i:25522;s:12:\"delete-26270\";i:25523;s:12:\"delete-26271\";i:25524;s:12:\"delete-26272\";i:25525;s:12:\"delete-26273\";i:25526;s:12:\"delete-26274\";i:25527;s:12:\"delete-26275\";i:25528;s:12:\"delete-26276\";i:25529;s:12:\"delete-26277\";i:25530;s:12:\"delete-26278\";i:25531;s:12:\"delete-26279\";i:25532;s:12:\"delete-26280\";i:25533;s:12:\"delete-26281\";i:25534;s:12:\"delete-26282\";i:25535;s:12:\"delete-26283\";i:25536;s:12:\"delete-26284\";i:25537;s:12:\"delete-26285\";i:25538;s:12:\"delete-26286\";i:25539;s:12:\"delete-26287\";i:25540;s:12:\"delete-26288\";i:25541;s:12:\"delete-26289\";i:25542;s:12:\"delete-26290\";i:25543;s:12:\"delete-26291\";i:25544;s:12:\"delete-26292\";i:25545;s:12:\"delete-26293\";i:25546;s:12:\"delete-26294\";i:25547;s:12:\"delete-26295\";i:25548;s:12:\"delete-26296\";i:25549;s:12:\"delete-26297\";i:25550;s:12:\"delete-26298\";i:25551;s:12:\"delete-26299\";i:25552;s:12:\"delete-26300\";i:25553;s:12:\"delete-26301\";i:25554;s:12:\"delete-26302\";i:25555;s:12:\"delete-26303\";i:25556;s:12:\"delete-26304\";i:25557;s:12:\"delete-26305\";i:25558;s:12:\"delete-26306\";i:25559;s:12:\"delete-26307\";i:25560;s:12:\"delete-26308\";i:25561;s:12:\"delete-26309\";i:25562;s:12:\"delete-26310\";i:25563;s:12:\"delete-26311\";i:25564;s:12:\"delete-26312\";i:25565;s:12:\"delete-26313\";i:25566;s:12:\"delete-26314\";i:25567;s:12:\"delete-26315\";i:25568;s:12:\"delete-26316\";i:25569;s:12:\"delete-26317\";i:25570;s:12:\"delete-26318\";i:25571;s:12:\"delete-26319\";i:25572;s:12:\"delete-26320\";i:25573;s:12:\"delete-26321\";i:25574;s:12:\"delete-26322\";i:25575;s:12:\"delete-26323\";i:25576;s:12:\"delete-26324\";i:25577;s:12:\"delete-26325\";i:25578;s:12:\"delete-26326\";i:25579;s:12:\"delete-26327\";i:25580;s:12:\"delete-26328\";i:25581;s:12:\"delete-26329\";i:25582;s:12:\"delete-26330\";i:25583;s:12:\"delete-26331\";i:25584;s:12:\"delete-26332\";i:25585;s:12:\"delete-26333\";i:25586;s:12:\"delete-26334\";i:25587;s:12:\"delete-26335\";i:25588;s:12:\"delete-26336\";i:25589;s:12:\"delete-26337\";i:25590;s:12:\"delete-26338\";i:25591;s:12:\"delete-26339\";i:25592;s:12:\"delete-26340\";i:25593;s:12:\"delete-26341\";i:25594;s:12:\"delete-26342\";i:25595;s:12:\"delete-26343\";i:25596;s:12:\"delete-26344\";i:25597;s:12:\"delete-26345\";i:25598;s:12:\"delete-26346\";i:25599;s:12:\"delete-26347\";i:25600;s:12:\"delete-26348\";i:25601;s:12:\"delete-26349\";i:25602;s:12:\"delete-26350\";i:25603;s:12:\"delete-26351\";i:25604;s:12:\"delete-26352\";i:25605;s:12:\"delete-26353\";i:25606;s:12:\"delete-26354\";i:25607;s:12:\"delete-26355\";i:25608;s:12:\"delete-26356\";i:25609;s:12:\"delete-26357\";i:25610;s:12:\"delete-26358\";i:25611;s:12:\"delete-26359\";i:25612;s:12:\"delete-26360\";i:25613;s:12:\"delete-26361\";i:25614;s:12:\"delete-26362\";i:25615;s:12:\"delete-26363\";i:25616;s:12:\"delete-26364\";i:25617;s:12:\"delete-26365\";i:25618;s:12:\"delete-26366\";i:25619;s:12:\"delete-26367\";i:25620;s:12:\"delete-26368\";i:25621;s:12:\"delete-26369\";i:25622;s:12:\"delete-26370\";i:25623;s:12:\"delete-26371\";i:25624;s:12:\"delete-26372\";i:25625;s:12:\"delete-26373\";i:25626;s:12:\"delete-26374\";i:25627;s:12:\"delete-26375\";i:25628;s:12:\"delete-26376\";i:25629;s:12:\"delete-26377\";i:25630;s:12:\"delete-26378\";i:25631;s:12:\"delete-26379\";i:25632;s:12:\"delete-26380\";i:25633;s:12:\"delete-26381\";i:25634;s:12:\"delete-26382\";i:25635;s:12:\"delete-26383\";i:25636;s:12:\"delete-26384\";i:25637;s:12:\"delete-26385\";i:25638;s:12:\"delete-26386\";i:25639;s:12:\"delete-26387\";i:25640;s:12:\"delete-26388\";i:25641;s:12:\"delete-26389\";i:25642;s:12:\"delete-26390\";i:25643;s:12:\"delete-26391\";i:25644;s:12:\"delete-26392\";i:25645;s:12:\"delete-26393\";i:25646;s:12:\"delete-26394\";i:25647;s:12:\"delete-26395\";i:25648;s:12:\"delete-26396\";i:25649;s:12:\"delete-26397\";i:25650;s:12:\"delete-26398\";i:25651;s:12:\"delete-26399\";i:25652;s:12:\"delete-26400\";i:25653;s:12:\"delete-26401\";i:25654;s:12:\"delete-26402\";i:25655;s:12:\"delete-26403\";i:25656;s:12:\"delete-26404\";i:25657;s:12:\"delete-26405\";i:25658;s:12:\"delete-26406\";i:25659;s:12:\"delete-26407\";i:25660;s:12:\"delete-26408\";i:25661;s:12:\"delete-26409\";i:25662;s:12:\"delete-26410\";i:25663;s:12:\"delete-26411\";i:25664;s:12:\"delete-26412\";i:25665;s:12:\"delete-26413\";i:25666;s:12:\"delete-26414\";i:25667;s:12:\"delete-26415\";i:25668;s:12:\"delete-26416\";i:25669;s:12:\"delete-26417\";i:25670;s:12:\"delete-26418\";i:25671;s:12:\"delete-26419\";i:25672;s:12:\"delete-26420\";i:25673;s:12:\"delete-26421\";i:25674;s:12:\"delete-26422\";i:25675;s:12:\"delete-26423\";i:25676;s:12:\"delete-26424\";i:25677;s:12:\"delete-26425\";i:25678;s:12:\"delete-26426\";i:25679;s:12:\"delete-26427\";i:25680;s:12:\"delete-26428\";i:25681;s:12:\"delete-26429\";i:25682;s:12:\"delete-26430\";i:25683;s:12:\"delete-26431\";i:25684;s:12:\"delete-26432\";i:25685;s:12:\"delete-26433\";i:25686;s:12:\"delete-26434\";i:25687;s:12:\"delete-26435\";i:25688;s:12:\"delete-26436\";i:25689;s:12:\"delete-26437\";i:25690;s:12:\"delete-26438\";i:25691;s:12:\"delete-26439\";i:25692;s:12:\"delete-26440\";i:25693;s:12:\"delete-26441\";i:25694;s:12:\"delete-26442\";i:25695;s:12:\"delete-26443\";i:25696;s:12:\"delete-26444\";i:25697;s:12:\"delete-26445\";i:25698;s:12:\"delete-26446\";i:25699;s:12:\"delete-26447\";i:25700;s:12:\"delete-26448\";i:25701;s:12:\"delete-26449\";i:25702;s:12:\"delete-26450\";i:25703;s:12:\"delete-26451\";i:25704;s:12:\"delete-26452\";i:25705;s:12:\"delete-26453\";i:25706;s:12:\"delete-26454\";i:25707;s:12:\"delete-26455\";i:25708;s:12:\"delete-26456\";i:25709;s:12:\"delete-26457\";i:25710;s:12:\"delete-26458\";i:25711;s:12:\"delete-26459\";i:25712;s:12:\"delete-26460\";i:25713;s:12:\"delete-26461\";i:25714;s:12:\"delete-26462\";i:25715;s:12:\"delete-26463\";i:25716;s:12:\"delete-26464\";i:25717;s:12:\"delete-26465\";i:25718;s:12:\"delete-26466\";i:25719;s:12:\"delete-26467\";i:25720;s:12:\"delete-26468\";i:25721;s:12:\"delete-26469\";i:25722;s:12:\"delete-26470\";i:25723;s:12:\"delete-26471\";i:25724;s:12:\"delete-26472\";i:25725;s:12:\"delete-26473\";i:25726;s:12:\"delete-26474\";i:25727;s:12:\"delete-26475\";i:25728;s:12:\"delete-26476\";i:25729;s:12:\"delete-26477\";i:25730;s:12:\"delete-26478\";i:25731;s:12:\"delete-26479\";i:25732;s:12:\"delete-26480\";i:25733;s:12:\"delete-26481\";i:25734;s:12:\"delete-26482\";i:25735;s:12:\"delete-26483\";i:25736;s:12:\"delete-26484\";i:25737;s:12:\"delete-26485\";i:25738;s:12:\"delete-26486\";i:25739;s:12:\"delete-26487\";i:25740;s:12:\"delete-26488\";i:25741;s:12:\"delete-26489\";i:25742;s:12:\"delete-26490\";i:25743;s:12:\"delete-26491\";i:25744;s:12:\"delete-26492\";i:25745;s:12:\"delete-26493\";i:25746;s:12:\"delete-26494\";i:25747;s:12:\"delete-26495\";i:25748;s:12:\"delete-26496\";i:25749;s:12:\"delete-26497\";i:25750;s:12:\"delete-26498\";i:25751;s:12:\"delete-26499\";i:25752;s:12:\"delete-26500\";i:25753;s:12:\"delete-26501\";i:25754;s:12:\"delete-26502\";i:25755;s:12:\"delete-26503\";i:25756;s:12:\"delete-26504\";i:25757;s:12:\"delete-26505\";i:25758;s:12:\"delete-26506\";i:25759;s:12:\"delete-26507\";i:25760;s:12:\"delete-26508\";i:25761;s:12:\"delete-26509\";i:25762;s:12:\"delete-26510\";i:25763;s:12:\"delete-26511\";i:25764;s:12:\"delete-26512\";i:25765;s:12:\"delete-26513\";i:25766;s:12:\"delete-26514\";i:25767;s:12:\"delete-26515\";i:25768;s:12:\"delete-26516\";i:25769;s:12:\"delete-26517\";i:25770;s:12:\"delete-26518\";i:25771;s:12:\"delete-26519\";i:25772;s:12:\"delete-26520\";i:25773;s:12:\"delete-26521\";i:25774;s:12:\"delete-26522\";i:25775;s:12:\"delete-26523\";i:25776;s:12:\"delete-26524\";i:25777;s:12:\"delete-26525\";i:25778;s:12:\"delete-26526\";i:25779;s:12:\"delete-26527\";i:25780;s:12:\"delete-26528\";i:25781;s:12:\"delete-26529\";i:25782;s:12:\"delete-26530\";i:25783;s:12:\"delete-26531\";i:25784;s:12:\"delete-26532\";i:25785;s:12:\"delete-26533\";i:25786;s:12:\"delete-26534\";i:25787;s:12:\"delete-26535\";i:25788;s:12:\"delete-26536\";i:25789;s:12:\"delete-26537\";i:25790;s:12:\"delete-26538\";i:25791;s:12:\"delete-26539\";i:25792;s:12:\"delete-26540\";i:25793;s:12:\"delete-26541\";i:25794;s:12:\"delete-26542\";i:25795;s:12:\"delete-26543\";i:25796;s:12:\"delete-26544\";i:25797;s:12:\"delete-26545\";i:25798;s:12:\"delete-26546\";i:25799;s:12:\"delete-26547\";i:25800;s:12:\"delete-26548\";i:25801;s:12:\"delete-26549\";i:25802;s:12:\"delete-26550\";i:25803;s:12:\"delete-26551\";i:25804;s:12:\"delete-26552\";i:25805;s:12:\"delete-26553\";i:25806;s:12:\"delete-26554\";i:25807;s:12:\"delete-26555\";i:25808;s:12:\"delete-26556\";i:25809;s:12:\"delete-26557\";i:25810;s:12:\"delete-26558\";i:25811;s:12:\"delete-26559\";i:25812;s:12:\"delete-26560\";i:25813;s:12:\"delete-26561\";i:25814;s:12:\"delete-26562\";i:25815;s:12:\"delete-26563\";i:25816;s:12:\"delete-26564\";i:25817;s:12:\"delete-26565\";i:25818;s:12:\"delete-26566\";i:25819;s:12:\"delete-26567\";i:25820;s:12:\"delete-26568\";i:25821;s:12:\"delete-26569\";i:25822;s:12:\"delete-26570\";i:25823;s:12:\"delete-26571\";i:25824;s:12:\"delete-26572\";i:25825;s:12:\"delete-26573\";i:25826;s:12:\"delete-26574\";i:25827;s:12:\"delete-26575\";i:25828;s:12:\"delete-26576\";i:25829;s:12:\"delete-26577\";i:25830;s:12:\"delete-26578\";i:25831;s:12:\"delete-26579\";i:25832;s:12:\"delete-26580\";i:25833;s:12:\"delete-26581\";i:25834;s:12:\"delete-26582\";i:25835;s:12:\"delete-26583\";i:25836;s:12:\"delete-26584\";i:25837;s:12:\"delete-26585\";i:25838;s:12:\"delete-26586\";i:25839;s:12:\"delete-26587\";i:25840;s:12:\"delete-26588\";i:25841;s:12:\"delete-26589\";i:25842;s:12:\"delete-26590\";i:25843;s:12:\"delete-26591\";i:25844;s:12:\"delete-26592\";i:25845;s:12:\"delete-26593\";i:25846;s:12:\"delete-26594\";i:25847;s:12:\"delete-26595\";i:25848;s:12:\"delete-26596\";i:25849;s:12:\"delete-26597\";i:25850;s:12:\"delete-26598\";i:25851;s:12:\"delete-26599\";i:25852;s:12:\"delete-26600\";i:25853;s:12:\"delete-26601\";i:25854;s:12:\"delete-26602\";i:25855;s:12:\"delete-26603\";i:25856;s:12:\"delete-26604\";i:25857;s:12:\"delete-26605\";i:25858;s:12:\"delete-26606\";i:25859;s:12:\"delete-26607\";i:25860;s:12:\"delete-26608\";i:25861;s:12:\"delete-26610\";i:25862;s:12:\"delete-26611\";i:25863;s:12:\"delete-26612\";i:25864;s:12:\"delete-26613\";i:25865;s:12:\"delete-26614\";i:25866;s:12:\"delete-26615\";i:25867;s:12:\"delete-26616\";i:25868;s:12:\"delete-26617\";i:25869;s:12:\"delete-26618\";i:25870;s:12:\"delete-26619\";i:25871;s:12:\"delete-26620\";i:25872;s:12:\"delete-26621\";i:25873;s:12:\"delete-26622\";i:25874;s:12:\"delete-26623\";i:25875;s:12:\"delete-26624\";i:25876;s:12:\"delete-26625\";i:25877;s:12:\"delete-26626\";i:25878;s:12:\"delete-26627\";i:25879;s:12:\"delete-26628\";i:25880;s:12:\"delete-26629\";i:25881;s:12:\"delete-26630\";i:25882;s:12:\"delete-26631\";i:25883;s:12:\"delete-26632\";i:25884;s:12:\"delete-26633\";i:25885;s:12:\"delete-26634\";i:25886;s:12:\"delete-26635\";i:25887;s:12:\"delete-26636\";i:25888;s:12:\"delete-26637\";i:25889;s:12:\"delete-26638\";i:25890;s:12:\"delete-26639\";i:25891;s:12:\"delete-26640\";i:25892;s:12:\"delete-26641\";i:25893;s:12:\"delete-26642\";i:25894;s:12:\"delete-26643\";i:25895;s:12:\"delete-26644\";i:25896;s:12:\"delete-26645\";i:25897;s:12:\"delete-26646\";i:25898;s:12:\"delete-26647\";i:25899;s:12:\"delete-26648\";i:25900;s:12:\"delete-26649\";i:25901;s:12:\"delete-26650\";i:25902;s:12:\"delete-26651\";i:25903;s:12:\"delete-26652\";i:25904;s:12:\"delete-26653\";i:25905;s:12:\"delete-26654\";i:25906;s:12:\"delete-26655\";i:25907;s:12:\"delete-26656\";i:25908;s:12:\"delete-26657\";i:25909;s:12:\"delete-26658\";i:25910;s:12:\"delete-26659\";i:25911;s:12:\"delete-26660\";i:25912;s:12:\"delete-26661\";i:25913;s:12:\"delete-26662\";i:25914;s:12:\"delete-26663\";i:25915;s:12:\"delete-26664\";i:25916;s:12:\"delete-26665\";i:25917;s:12:\"delete-26666\";i:25918;s:12:\"delete-26667\";i:25919;s:12:\"delete-26668\";i:25920;s:12:\"delete-26669\";i:25921;s:12:\"delete-26670\";i:25922;s:12:\"delete-26671\";i:25923;s:12:\"delete-26672\";i:25924;s:12:\"delete-26673\";i:25925;s:12:\"delete-26674\";i:25926;s:12:\"delete-26675\";i:25927;s:12:\"delete-26676\";i:25928;s:12:\"delete-26677\";i:25929;s:12:\"delete-26678\";i:25930;s:12:\"delete-26679\";i:25931;s:12:\"delete-26680\";i:25932;s:12:\"delete-26681\";i:25933;s:12:\"delete-26682\";i:25934;s:12:\"delete-26683\";i:25935;s:12:\"delete-26684\";i:25936;s:12:\"delete-26685\";i:25937;s:12:\"delete-26686\";i:25938;s:12:\"delete-26687\";i:25939;s:12:\"delete-26688\";i:25940;s:12:\"delete-26689\";i:25941;s:12:\"delete-26690\";i:25942;s:12:\"delete-26691\";i:25943;s:12:\"delete-26692\";i:25944;s:12:\"delete-26693\";i:25945;s:12:\"delete-26694\";i:25946;s:12:\"delete-26695\";i:25947;s:12:\"delete-26696\";i:25948;s:12:\"delete-26697\";i:25949;s:12:\"delete-26698\";i:25950;s:12:\"delete-26699\";i:25951;s:12:\"delete-26700\";i:25952;s:12:\"delete-26701\";i:25953;s:12:\"delete-26702\";i:25954;s:12:\"delete-26703\";i:25955;s:12:\"delete-26704\";i:25956;s:12:\"delete-26705\";i:25957;s:12:\"delete-26706\";i:25958;s:12:\"delete-26707\";i:25959;s:12:\"delete-26708\";i:25960;s:12:\"delete-26709\";i:25961;s:12:\"delete-26710\";i:25962;s:12:\"delete-26711\";i:25963;s:12:\"delete-26712\";i:25964;s:12:\"delete-26713\";i:25965;s:12:\"delete-26714\";i:25966;s:12:\"delete-26715\";i:25967;s:12:\"delete-26716\";i:25968;s:12:\"delete-26717\";i:25969;s:12:\"delete-26718\";i:25970;s:12:\"delete-26719\";i:25971;s:12:\"delete-26720\";i:25972;s:12:\"delete-26721\";i:25973;s:12:\"delete-26722\";i:25974;s:12:\"delete-26723\";i:25975;s:12:\"delete-26724\";i:25976;s:12:\"delete-26725\";i:25977;s:12:\"delete-26726\";i:25978;s:12:\"delete-26727\";i:25979;s:12:\"delete-26728\";i:25980;s:12:\"delete-26729\";i:25981;s:12:\"delete-26730\";i:25982;s:12:\"delete-26731\";i:25983;s:12:\"delete-26732\";i:25984;s:12:\"delete-26733\";i:25985;s:12:\"delete-26734\";i:25986;s:12:\"delete-26735\";i:25987;s:12:\"delete-26736\";i:25988;s:12:\"delete-26737\";i:25989;s:12:\"delete-26738\";i:25990;s:12:\"delete-26739\";i:25991;s:12:\"delete-26740\";i:25992;s:12:\"delete-26741\";i:25993;s:12:\"delete-26742\";i:25994;s:12:\"delete-26743\";i:25995;s:12:\"delete-26744\";i:25996;s:12:\"delete-26745\";i:25997;s:12:\"delete-26746\";i:25998;s:12:\"delete-26747\";i:25999;s:12:\"delete-26748\";i:26000;s:12:\"delete-26749\";i:26001;s:12:\"delete-26750\";i:26002;s:12:\"delete-26751\";i:26003;s:12:\"delete-26752\";i:26004;s:12:\"delete-26753\";i:26005;s:12:\"delete-26754\";i:26006;s:12:\"delete-26755\";i:26007;s:12:\"delete-26756\";i:26008;s:12:\"delete-26757\";i:26009;s:12:\"delete-26758\";i:26010;s:12:\"delete-26759\";i:26011;s:12:\"delete-26760\";i:26012;s:12:\"delete-26761\";i:26013;s:12:\"delete-26762\";i:26014;s:12:\"delete-26763\";i:26015;s:12:\"delete-26764\";i:26016;s:12:\"delete-26765\";i:26017;s:12:\"delete-26766\";i:26018;s:12:\"delete-26767\";i:26019;s:12:\"delete-26768\";i:26020;s:12:\"delete-26769\";i:26021;s:12:\"delete-26770\";i:26022;s:12:\"delete-26771\";i:26023;s:12:\"delete-26772\";i:26024;s:12:\"delete-26773\";i:26025;s:12:\"delete-26774\";i:26026;s:12:\"delete-26775\";i:26027;s:12:\"delete-26776\";i:26028;s:12:\"delete-26777\";i:26029;s:12:\"delete-26778\";i:26030;s:12:\"delete-26779\";i:26031;s:12:\"delete-26780\";i:26032;s:12:\"delete-26781\";i:26033;s:12:\"delete-26782\";i:26034;s:12:\"delete-26783\";i:26035;s:12:\"delete-26784\";i:26036;s:12:\"delete-26785\";i:26037;s:12:\"delete-26786\";i:26038;s:12:\"delete-26787\";i:26039;s:12:\"delete-26788\";i:26040;s:12:\"delete-26789\";i:26041;s:12:\"delete-26790\";i:26042;s:12:\"delete-26791\";i:26043;s:12:\"delete-26792\";i:26044;s:12:\"delete-26793\";i:26045;s:12:\"delete-26794\";i:26046;s:12:\"delete-26795\";i:26047;s:12:\"delete-26796\";i:26048;s:12:\"delete-26797\";i:26049;s:12:\"delete-26798\";i:26050;s:12:\"delete-26799\";i:26051;s:12:\"delete-26800\";i:26052;s:12:\"delete-26801\";i:26053;s:12:\"delete-26802\";i:26054;s:12:\"delete-26803\";i:26055;s:12:\"delete-26804\";i:26056;s:12:\"delete-26805\";i:26057;s:12:\"delete-26806\";i:26058;s:12:\"delete-26807\";i:26059;s:12:\"delete-26808\";i:26060;s:12:\"delete-26809\";i:26061;s:12:\"delete-26810\";i:26062;s:12:\"delete-26811\";i:26063;s:12:\"delete-26812\";i:26064;s:12:\"delete-26813\";i:26065;s:12:\"delete-26814\";i:26066;s:12:\"delete-26815\";i:26067;s:12:\"delete-26816\";i:26068;s:12:\"delete-26817\";i:26069;s:12:\"delete-26818\";i:26070;s:12:\"delete-26819\";i:26071;s:12:\"delete-26820\";i:26072;s:12:\"delete-26821\";i:26073;s:12:\"delete-26822\";i:26074;s:12:\"delete-26823\";i:26075;s:12:\"delete-26824\";i:26076;s:12:\"delete-26825\";i:26077;s:12:\"delete-26826\";i:26078;s:12:\"delete-26827\";i:26079;s:12:\"delete-26828\";i:26080;s:12:\"delete-26829\";i:26081;s:12:\"delete-26830\";i:26082;s:12:\"delete-26831\";i:26083;s:12:\"delete-26832\";i:26084;s:12:\"delete-26833\";i:26085;s:12:\"delete-26834\";i:26086;s:12:\"delete-26835\";i:26087;s:12:\"delete-26836\";i:26088;s:12:\"delete-26837\";i:26089;s:12:\"delete-26838\";i:26090;s:12:\"delete-26839\";i:26091;s:12:\"delete-26840\";i:26092;s:12:\"delete-26841\";i:26093;s:12:\"delete-26842\";i:26094;s:12:\"delete-26843\";i:26095;s:12:\"delete-26844\";i:26096;s:12:\"delete-26845\";i:26097;s:12:\"delete-26846\";i:26098;s:12:\"delete-26847\";i:26099;s:12:\"delete-26848\";i:26100;s:12:\"delete-26849\";i:26101;s:12:\"delete-26850\";i:26102;s:12:\"delete-26851\";i:26103;s:12:\"delete-26852\";i:26104;s:12:\"delete-26853\";i:26105;s:12:\"delete-26854\";i:26106;s:12:\"delete-26855\";i:26107;s:12:\"delete-26856\";i:26108;s:12:\"delete-26857\";i:26109;s:12:\"delete-26858\";i:26110;s:12:\"delete-26859\";i:26111;s:12:\"delete-26860\";i:26112;s:12:\"delete-26861\";i:26113;s:12:\"delete-26862\";i:26114;s:12:\"delete-26863\";i:26115;s:12:\"delete-26864\";i:26116;s:12:\"delete-26865\";i:26117;s:12:\"delete-26866\";i:26118;s:12:\"delete-26867\";i:26119;s:12:\"delete-26868\";i:26120;s:12:\"delete-26869\";i:26121;s:12:\"delete-26870\";i:26122;s:12:\"delete-26871\";i:26123;s:12:\"delete-26872\";i:26124;s:12:\"delete-26873\";i:26125;s:12:\"delete-26874\";i:26126;s:12:\"delete-26875\";i:26127;s:12:\"delete-26876\";i:26128;s:12:\"delete-26877\";i:26129;s:12:\"delete-26878\";i:26130;s:12:\"delete-26879\";i:26131;s:12:\"delete-26880\";i:26132;s:12:\"delete-26881\";i:26133;s:12:\"delete-26882\";i:26134;s:12:\"delete-26883\";i:26135;s:12:\"delete-26884\";i:26136;s:12:\"delete-26885\";i:26137;s:12:\"delete-26886\";i:26138;s:12:\"delete-26887\";i:26139;s:12:\"delete-26888\";i:26140;s:12:\"delete-26889\";i:26141;s:12:\"delete-26890\";i:26142;s:12:\"delete-26891\";i:26143;s:12:\"delete-26892\";i:26144;s:12:\"delete-26893\";i:26145;s:12:\"delete-26894\";i:26146;s:12:\"delete-26895\";i:26147;s:12:\"delete-26896\";i:26148;s:12:\"delete-26897\";i:26149;s:12:\"delete-26898\";i:26150;s:12:\"delete-26899\";i:26151;s:12:\"delete-26900\";i:26152;s:12:\"delete-26901\";i:26153;s:12:\"delete-26902\";i:26154;s:12:\"delete-26903\";i:26155;s:12:\"delete-26904\";i:26156;s:12:\"delete-26905\";i:26157;s:12:\"delete-26906\";i:26158;s:12:\"delete-26907\";i:26159;s:12:\"delete-26908\";i:26160;s:12:\"delete-26909\";i:26161;s:12:\"delete-26910\";i:26162;s:12:\"delete-26911\";i:26163;s:12:\"delete-26912\";i:26164;s:12:\"delete-26913\";i:26165;s:12:\"delete-26914\";i:26166;s:12:\"delete-26915\";i:26167;s:12:\"delete-26916\";i:26168;s:12:\"delete-26917\";i:26169;s:12:\"delete-26918\";i:26170;s:12:\"delete-26919\";i:26171;s:12:\"delete-26920\";i:26172;s:12:\"delete-26921\";i:26173;s:12:\"delete-26922\";i:26174;s:12:\"delete-26923\";i:26175;s:12:\"delete-26924\";i:26176;s:12:\"delete-26925\";i:26177;s:12:\"delete-26926\";i:26178;s:12:\"delete-26927\";i:26179;s:12:\"delete-26928\";i:26180;s:12:\"delete-26929\";i:26181;s:12:\"delete-26930\";i:26182;s:12:\"delete-26931\";i:26183;s:12:\"delete-26932\";i:26184;s:12:\"delete-26933\";i:26185;s:12:\"delete-26934\";i:26186;s:12:\"delete-26935\";i:26187;s:12:\"delete-26936\";i:26188;s:12:\"delete-26937\";i:26189;s:12:\"delete-26938\";i:26190;s:12:\"delete-26939\";i:26191;s:12:\"delete-26940\";i:26192;s:12:\"delete-26941\";i:26193;s:12:\"delete-26942\";i:26194;s:12:\"delete-26943\";i:26195;s:12:\"delete-26944\";i:26196;s:12:\"delete-26945\";i:26197;s:12:\"delete-26946\";i:26198;s:12:\"delete-26947\";i:26199;s:12:\"delete-26948\";i:26200;s:12:\"delete-26949\";i:26201;s:12:\"delete-26950\";i:26202;s:12:\"delete-26951\";i:26203;s:12:\"delete-26952\";i:26204;s:12:\"delete-26953\";i:26205;s:12:\"delete-26954\";i:26206;s:12:\"delete-26955\";i:26207;s:12:\"delete-26956\";i:26208;s:12:\"delete-26957\";i:26209;s:12:\"delete-26958\";i:26210;s:12:\"delete-26959\";i:26211;s:12:\"delete-26960\";i:26212;s:12:\"delete-26961\";i:26213;s:12:\"delete-26962\";i:26214;s:12:\"delete-26963\";i:26215;s:12:\"delete-26964\";i:26216;s:12:\"delete-26965\";i:26217;s:12:\"delete-26966\";i:26218;s:12:\"delete-26967\";i:26219;s:12:\"delete-26968\";i:26220;s:12:\"delete-26969\";i:26221;s:12:\"delete-26970\";i:26222;s:12:\"delete-26971\";i:26223;s:12:\"delete-26972\";i:26224;s:12:\"delete-26973\";i:26225;s:12:\"delete-26974\";i:26226;s:12:\"delete-26975\";i:26227;s:12:\"delete-26976\";i:26228;s:12:\"delete-26977\";i:26229;s:12:\"delete-26978\";i:26230;s:12:\"delete-26979\";i:26231;s:12:\"delete-26980\";i:26232;s:12:\"delete-26981\";i:26233;s:12:\"delete-26982\";i:26234;s:12:\"delete-26983\";i:26235;s:12:\"delete-26984\";i:26236;s:12:\"delete-26985\";i:26237;s:12:\"delete-26986\";i:26238;s:12:\"delete-26987\";i:26239;s:12:\"delete-26988\";i:26240;s:12:\"delete-26989\";i:26241;s:12:\"delete-26990\";i:26242;s:12:\"delete-26991\";i:26243;s:12:\"delete-26992\";i:26244;s:12:\"delete-26993\";i:26245;s:12:\"delete-26994\";i:26246;s:12:\"delete-26995\";i:26247;s:12:\"delete-26996\";i:26248;s:12:\"delete-26997\";i:26249;s:12:\"delete-26998\";i:26250;s:12:\"delete-26999\";i:26251;s:12:\"delete-27000\";i:26252;s:12:\"delete-27001\";i:26253;s:12:\"delete-27002\";i:26254;s:12:\"delete-27003\";i:26255;s:12:\"delete-27004\";i:26256;s:12:\"delete-27005\";i:26257;s:12:\"delete-27006\";i:26258;s:12:\"delete-27007\";i:26259;s:12:\"delete-27008\";i:26260;s:12:\"delete-27009\";i:26261;s:12:\"delete-27010\";i:26262;s:12:\"delete-27011\";i:26263;s:12:\"delete-27012\";i:26264;s:12:\"delete-27013\";i:26265;s:12:\"delete-27014\";i:26266;s:12:\"delete-27015\";i:26267;s:12:\"delete-27016\";i:26268;s:12:\"delete-27017\";i:26269;s:12:\"delete-27018\";i:26270;s:12:\"delete-27019\";i:26271;s:12:\"delete-27020\";i:26272;s:12:\"delete-27021\";i:26273;s:12:\"delete-27022\";i:26274;s:12:\"delete-27023\";i:26275;s:12:\"delete-27024\";i:26276;s:12:\"delete-27025\";i:26277;s:12:\"delete-27026\";i:26278;s:12:\"delete-27027\";i:26279;s:12:\"delete-27028\";i:26280;s:12:\"delete-27029\";i:26281;s:12:\"delete-27030\";i:26282;s:12:\"delete-27031\";i:26283;s:12:\"delete-27032\";i:26284;s:12:\"delete-27033\";i:26285;s:12:\"delete-27034\";i:26286;s:12:\"delete-27035\";i:26287;s:12:\"delete-27036\";i:26288;s:12:\"delete-27037\";i:26289;s:12:\"delete-27038\";i:26290;s:12:\"delete-27039\";i:26291;s:12:\"delete-27040\";i:26292;s:12:\"delete-27041\";i:26293;s:12:\"delete-27042\";i:26294;s:12:\"delete-27043\";i:26295;s:12:\"delete-27044\";i:26296;s:12:\"delete-27045\";i:26297;s:12:\"delete-27046\";i:26298;s:12:\"delete-27047\";i:26299;s:12:\"delete-27048\";i:26300;s:12:\"delete-27049\";i:26301;s:12:\"delete-27050\";i:26302;s:12:\"delete-27051\";i:26303;s:12:\"delete-27052\";i:26304;s:12:\"delete-27053\";i:26305;s:12:\"delete-27054\";i:26306;s:12:\"delete-27055\";i:26307;s:12:\"delete-27056\";i:26308;s:12:\"delete-27057\";i:26309;s:12:\"delete-27058\";i:26310;s:12:\"delete-27059\";i:26311;s:12:\"delete-27060\";i:26312;s:12:\"delete-27061\";i:26313;s:12:\"delete-27062\";i:26314;s:12:\"delete-27063\";i:26315;s:12:\"delete-27064\";i:26316;s:12:\"delete-27065\";i:26317;s:12:\"delete-27066\";i:26318;s:12:\"delete-27067\";i:26319;s:12:\"delete-27068\";i:26320;s:12:\"delete-27069\";i:26321;s:12:\"delete-27070\";i:26322;s:12:\"delete-27071\";i:26323;s:12:\"delete-27072\";i:26324;s:12:\"delete-27073\";i:26325;s:12:\"delete-27074\";i:26326;s:12:\"delete-27075\";i:26327;s:12:\"delete-27076\";i:26328;s:12:\"delete-27077\";i:26329;s:12:\"delete-27078\";i:26330;s:12:\"delete-27079\";i:26331;s:12:\"delete-27080\";i:26332;s:12:\"delete-27081\";i:26333;s:12:\"delete-27082\";i:26334;s:12:\"delete-27083\";i:26335;s:12:\"delete-27084\";i:26336;s:12:\"delete-27085\";i:26337;s:12:\"delete-27086\";i:26338;s:12:\"delete-27087\";i:26339;s:12:\"delete-27088\";i:26340;s:12:\"delete-27089\";i:26341;s:12:\"delete-27090\";i:26342;s:12:\"delete-27091\";i:26343;s:12:\"delete-27092\";i:26344;s:12:\"delete-27093\";i:26345;s:12:\"delete-27094\";i:26346;s:12:\"delete-27095\";i:26347;s:12:\"delete-27096\";i:26348;s:12:\"delete-27097\";i:26349;s:12:\"delete-27098\";i:26350;s:12:\"delete-27099\";i:26351;s:12:\"delete-27100\";i:26352;s:12:\"delete-27101\";i:26353;s:12:\"delete-27102\";i:26354;s:12:\"delete-27103\";i:26355;s:12:\"delete-27104\";i:26356;s:12:\"delete-27105\";i:26357;s:12:\"delete-27106\";i:26358;s:12:\"delete-27107\";i:26359;s:12:\"delete-27108\";i:26360;s:12:\"delete-27109\";i:26361;s:12:\"delete-27110\";i:26362;s:12:\"delete-27111\";i:26363;s:12:\"delete-27112\";i:26364;s:12:\"delete-27113\";i:26365;s:12:\"delete-27114\";i:26366;s:12:\"delete-27115\";i:26367;s:12:\"delete-27116\";i:26368;s:12:\"delete-27117\";i:26369;s:12:\"delete-27118\";i:26370;s:12:\"delete-27119\";i:26371;s:12:\"delete-27120\";i:26372;s:12:\"delete-27121\";i:26373;s:12:\"delete-27122\";i:26374;s:12:\"delete-27123\";i:26375;s:12:\"delete-27124\";i:26376;s:12:\"delete-27125\";i:26377;s:12:\"delete-27126\";i:26378;s:12:\"delete-27127\";i:26379;s:12:\"delete-27128\";i:26380;s:12:\"delete-27129\";i:26381;s:12:\"delete-27130\";i:26382;s:12:\"delete-27131\";i:26383;s:12:\"delete-27132\";i:26384;s:12:\"delete-27133\";i:26385;s:12:\"delete-27134\";i:26386;s:12:\"delete-27135\";i:26387;s:12:\"delete-27136\";i:26388;s:12:\"delete-27137\";i:26389;s:12:\"delete-27138\";i:26390;s:12:\"delete-27139\";i:26391;s:12:\"delete-27140\";i:26392;s:12:\"delete-27141\";i:26393;s:12:\"delete-27142\";i:26394;s:12:\"delete-27143\";i:26395;s:12:\"delete-27144\";i:26396;s:12:\"delete-27145\";i:26397;s:12:\"delete-27146\";i:26398;s:12:\"delete-27147\";i:26399;s:12:\"delete-27148\";i:26400;s:12:\"delete-27149\";i:26401;s:12:\"delete-27150\";i:26402;s:12:\"delete-27151\";i:26403;s:12:\"delete-27152\";i:26404;s:12:\"delete-27153\";i:26405;s:12:\"delete-27154\";i:26406;s:12:\"delete-27155\";i:26407;s:12:\"delete-27156\";i:26408;s:12:\"delete-27157\";i:26409;s:12:\"delete-27158\";i:26410;s:12:\"delete-27159\";i:26411;s:12:\"delete-27160\";i:26412;s:12:\"delete-27161\";i:26413;s:12:\"delete-27162\";i:26414;s:12:\"delete-27163\";i:26415;s:12:\"delete-27164\";i:26416;s:12:\"delete-27165\";i:26417;s:12:\"delete-27166\";i:26418;s:12:\"delete-27167\";i:26419;s:12:\"delete-27168\";i:26420;s:12:\"delete-27169\";i:26421;s:12:\"delete-27170\";i:26422;s:12:\"delete-27171\";i:26423;s:12:\"delete-27172\";i:26424;s:12:\"delete-27173\";i:26425;s:12:\"delete-27174\";i:26426;s:12:\"delete-27175\";i:26427;s:12:\"delete-27176\";i:26428;s:12:\"delete-27177\";i:26429;s:12:\"delete-27178\";i:26430;s:12:\"delete-27179\";i:26431;s:12:\"delete-27180\";i:26432;s:12:\"delete-27181\";i:26433;s:12:\"delete-27182\";i:26434;s:12:\"delete-27183\";i:26435;s:12:\"delete-27184\";i:26436;s:12:\"delete-27185\";i:26437;s:12:\"delete-27186\";i:26438;s:12:\"delete-27187\";i:26439;s:12:\"delete-27188\";i:26440;s:12:\"delete-27189\";i:26441;s:12:\"delete-27190\";i:26442;s:12:\"delete-27191\";i:26443;s:12:\"delete-27192\";i:26444;s:12:\"delete-27193\";i:26445;s:12:\"delete-27194\";i:26446;s:12:\"delete-27195\";i:26447;s:12:\"delete-27196\";i:26448;s:12:\"delete-27197\";i:26449;s:12:\"delete-27198\";i:26450;s:12:\"delete-27199\";i:26451;s:12:\"delete-27200\";i:26452;s:12:\"delete-27201\";i:26453;s:12:\"delete-27202\";i:26454;s:12:\"delete-27203\";i:26455;s:12:\"delete-27204\";i:26456;s:12:\"delete-27205\";i:26457;s:12:\"delete-27206\";i:26458;s:12:\"delete-27207\";i:26459;s:12:\"delete-27208\";i:26460;s:12:\"delete-27209\";i:26461;s:12:\"delete-27210\";i:26462;s:12:\"delete-27211\";i:26463;s:12:\"delete-27212\";i:26464;s:12:\"delete-27213\";i:26465;s:12:\"delete-27214\";i:26466;s:12:\"delete-27215\";i:26467;s:12:\"delete-27216\";i:26468;s:12:\"delete-27217\";i:26469;s:12:\"delete-27218\";i:26470;s:12:\"delete-27219\";i:26471;s:12:\"delete-27220\";i:26472;s:12:\"delete-27221\";i:26473;s:12:\"delete-27222\";i:26474;s:12:\"delete-27223\";i:26475;s:12:\"delete-27224\";i:26476;s:12:\"delete-27225\";i:26477;s:12:\"delete-27226\";i:26478;s:12:\"delete-27227\";i:26479;s:12:\"delete-27228\";i:26480;s:12:\"delete-27229\";i:26481;s:12:\"delete-27230\";i:26482;s:12:\"delete-27231\";i:26483;s:12:\"delete-27232\";i:26484;s:12:\"delete-27233\";i:26485;s:12:\"delete-27234\";i:26486;s:12:\"delete-27235\";i:26487;s:12:\"delete-27236\";i:26488;s:12:\"delete-27237\";i:26489;s:12:\"delete-27238\";i:26490;s:12:\"delete-27239\";i:26491;s:12:\"delete-27240\";i:26492;s:12:\"delete-27241\";i:26493;s:12:\"delete-27242\";i:26494;s:12:\"delete-27243\";i:26495;s:12:\"delete-27244\";i:26496;s:12:\"delete-27245\";i:26497;s:12:\"delete-27246\";i:26498;s:12:\"delete-27247\";i:26499;s:12:\"delete-27248\";i:26500;s:12:\"delete-27249\";i:26501;s:12:\"delete-27250\";i:26502;s:12:\"delete-27251\";i:26503;s:12:\"delete-27252\";i:26504;s:12:\"delete-27253\";i:26505;s:12:\"delete-27254\";i:26506;s:12:\"delete-27255\";i:26507;s:12:\"delete-27256\";i:26508;s:12:\"delete-27257\";i:26509;s:12:\"delete-27258\";i:26510;s:12:\"delete-27259\";i:26511;s:12:\"delete-27260\";i:26512;s:12:\"delete-27261\";i:26513;s:12:\"delete-27262\";i:26514;s:12:\"delete-27263\";i:26515;s:12:\"delete-27264\";i:26516;s:12:\"delete-27265\";i:26517;s:12:\"delete-27266\";i:26518;s:12:\"delete-27267\";i:26519;s:12:\"delete-27268\";i:26520;s:12:\"delete-27269\";i:26521;s:12:\"delete-27270\";i:26522;s:12:\"delete-27271\";i:26523;s:12:\"delete-27272\";i:26524;s:12:\"delete-27273\";i:26525;s:12:\"delete-27274\";i:26526;s:12:\"delete-27275\";i:26527;s:12:\"delete-27276\";i:26528;s:12:\"delete-27277\";i:26529;s:12:\"delete-27278\";i:26530;s:12:\"delete-27279\";i:26531;s:12:\"delete-27280\";i:26532;s:12:\"delete-27281\";i:26533;s:12:\"delete-27282\";i:26534;s:12:\"delete-27283\";i:26535;s:12:\"delete-27284\";i:26536;s:12:\"delete-27285\";i:26537;s:12:\"delete-27286\";i:26538;s:12:\"delete-27287\";i:26539;s:12:\"delete-27288\";i:26540;s:12:\"delete-27289\";i:26541;s:12:\"delete-27290\";i:26542;s:12:\"delete-27291\";i:26543;s:12:\"delete-27292\";i:26544;s:12:\"delete-27293\";i:26545;s:12:\"delete-27294\";i:26546;s:12:\"delete-27295\";i:26547;s:12:\"delete-27296\";i:26548;s:12:\"delete-27297\";i:26549;s:12:\"delete-27298\";i:26550;s:12:\"delete-27299\";i:26551;s:12:\"delete-27300\";i:26552;s:12:\"delete-27301\";i:26553;s:12:\"delete-27302\";i:26554;s:12:\"delete-27303\";i:26555;s:12:\"delete-27304\";i:26556;s:12:\"delete-27305\";i:26557;s:12:\"delete-27306\";i:26558;s:12:\"delete-27307\";i:26559;s:12:\"delete-27308\";i:26560;s:12:\"delete-27309\";i:26561;s:12:\"delete-27310\";i:26562;s:12:\"delete-27311\";i:26563;s:12:\"delete-27312\";i:26564;s:12:\"delete-27313\";i:26565;s:12:\"delete-27314\";i:26566;s:12:\"delete-27315\";i:26567;s:12:\"delete-27316\";i:26568;s:12:\"delete-27317\";i:26569;s:12:\"delete-27318\";i:26570;s:12:\"delete-27319\";i:26571;s:12:\"delete-27320\";i:26572;s:12:\"delete-27321\";i:26573;s:12:\"delete-27322\";i:26574;s:12:\"delete-27323\";i:26575;s:12:\"delete-27324\";i:26576;s:12:\"delete-27325\";i:26577;s:12:\"delete-27326\";i:26578;s:12:\"delete-27327\";i:26579;s:12:\"delete-27328\";i:26580;s:12:\"delete-27329\";i:26581;s:12:\"delete-27330\";i:26582;s:12:\"delete-27331\";i:26583;s:12:\"delete-27332\";i:26584;s:12:\"delete-27333\";i:26585;s:12:\"delete-27334\";i:26586;s:12:\"delete-27335\";i:26587;s:12:\"delete-27336\";i:26588;s:12:\"delete-27337\";i:26589;s:12:\"delete-27338\";i:26590;s:12:\"delete-27339\";i:26591;s:12:\"delete-27340\";i:26592;s:12:\"delete-27341\";i:26593;s:12:\"delete-27342\";i:26594;s:12:\"delete-27343\";i:26595;s:12:\"delete-27344\";i:26596;s:12:\"delete-27345\";i:26597;s:12:\"delete-27346\";i:26598;s:12:\"delete-27347\";i:26599;s:12:\"delete-27348\";i:26600;s:12:\"delete-27349\";i:26601;s:12:\"delete-27350\";i:26602;s:12:\"delete-27351\";i:26603;s:12:\"delete-27352\";i:26604;s:12:\"delete-27353\";i:26605;s:12:\"delete-27354\";i:26606;s:12:\"delete-27355\";i:26607;s:12:\"delete-27356\";i:26608;s:12:\"delete-27357\";i:26609;s:12:\"delete-27358\";i:26610;s:12:\"delete-27359\";i:26611;s:12:\"delete-27360\";i:26612;s:12:\"delete-27361\";i:26613;s:12:\"delete-27362\";i:26614;s:12:\"delete-27363\";i:26615;s:12:\"delete-27364\";i:26616;s:12:\"delete-27365\";i:26617;s:12:\"delete-27366\";i:26618;s:12:\"delete-27367\";i:26619;s:12:\"delete-27368\";i:26620;s:12:\"delete-27369\";i:26621;s:12:\"delete-27370\";i:26622;s:12:\"delete-27371\";i:26623;s:12:\"delete-27372\";i:26624;s:12:\"delete-27373\";i:26625;s:12:\"delete-27374\";i:26626;s:12:\"delete-27375\";i:26627;s:12:\"delete-27376\";i:26628;s:12:\"delete-27377\";i:26629;s:12:\"delete-27378\";i:26630;s:12:\"delete-27379\";i:26631;s:12:\"delete-27380\";i:26632;s:12:\"delete-27381\";i:26633;s:12:\"delete-27382\";i:26634;s:12:\"delete-27383\";i:26635;s:12:\"delete-27384\";i:26636;s:12:\"delete-27385\";i:26637;s:12:\"delete-27386\";i:26638;s:12:\"delete-27387\";i:26639;s:12:\"delete-27388\";i:26640;s:12:\"delete-27389\";i:26641;s:12:\"delete-27390\";i:26642;s:12:\"delete-27391\";i:26643;s:12:\"delete-27392\";i:26644;s:12:\"delete-27393\";i:26645;s:12:\"delete-27394\";i:26646;s:12:\"delete-27395\";i:26647;s:12:\"delete-27396\";i:26648;s:12:\"delete-27397\";i:26649;s:12:\"delete-27398\";i:26650;s:12:\"delete-27399\";i:26651;s:12:\"delete-27400\";i:26652;s:12:\"delete-27401\";i:26653;s:12:\"delete-27402\";i:26654;s:12:\"delete-27403\";i:26655;s:12:\"delete-27404\";i:26656;s:12:\"delete-27405\";i:26657;s:12:\"delete-27406\";i:26658;s:12:\"delete-27407\";i:26659;s:12:\"delete-27408\";i:26660;s:12:\"delete-27409\";i:26661;s:12:\"delete-27410\";i:26662;s:12:\"delete-27411\";i:26663;s:12:\"delete-27412\";i:26664;s:12:\"delete-27413\";i:26665;s:12:\"delete-27414\";i:26666;s:12:\"delete-27415\";i:26667;s:12:\"delete-27416\";i:26668;s:12:\"delete-27417\";i:26669;s:12:\"delete-27418\";i:26670;s:12:\"delete-27419\";i:26671;s:12:\"delete-27420\";i:26672;s:12:\"delete-27421\";i:26673;s:12:\"delete-27422\";i:26674;s:12:\"delete-27423\";i:26675;s:12:\"delete-27424\";i:26676;s:12:\"delete-27425\";i:26677;s:12:\"delete-27426\";i:26678;s:12:\"delete-27427\";i:26679;s:12:\"delete-27428\";i:26680;s:12:\"delete-27429\";i:26681;s:12:\"delete-27430\";i:26682;s:12:\"delete-27431\";i:26683;s:12:\"delete-27432\";i:26684;s:12:\"delete-27433\";i:26685;s:12:\"delete-27434\";i:26686;s:12:\"delete-27435\";i:26687;s:12:\"delete-27436\";i:26688;s:12:\"delete-27437\";i:26689;s:12:\"delete-27438\";i:26690;s:12:\"delete-27439\";i:26691;s:12:\"delete-27440\";i:26692;s:12:\"delete-27441\";i:26693;s:12:\"delete-27442\";i:26694;s:12:\"delete-27443\";i:26695;s:12:\"delete-27444\";i:26696;s:12:\"delete-27445\";i:26697;s:12:\"delete-27446\";i:26698;s:12:\"delete-27447\";i:26699;s:12:\"delete-27448\";i:26700;s:12:\"delete-27449\";i:26701;s:12:\"delete-27450\";i:26702;s:12:\"delete-27451\";i:26703;s:12:\"delete-27452\";i:26704;s:12:\"delete-27453\";i:26705;s:12:\"delete-27454\";i:26706;s:12:\"delete-27455\";i:26707;s:12:\"delete-27456\";i:26708;s:12:\"delete-27457\";i:26709;s:12:\"delete-27458\";i:26710;s:12:\"delete-27459\";i:26711;s:12:\"delete-27460\";i:26712;s:12:\"delete-27461\";i:26713;s:12:\"delete-27462\";i:26714;s:12:\"delete-27463\";i:26715;s:12:\"delete-27464\";i:26716;s:12:\"delete-27465\";i:26717;s:12:\"delete-27466\";i:26718;s:12:\"delete-27467\";i:26719;s:12:\"delete-27468\";i:26720;s:12:\"delete-27469\";i:26721;s:12:\"delete-27470\";i:26722;s:12:\"delete-27471\";i:26723;s:12:\"delete-27472\";i:26724;s:12:\"delete-27473\";i:26725;s:12:\"delete-27474\";i:26726;s:12:\"delete-27475\";i:26727;s:12:\"delete-27476\";i:26728;s:12:\"delete-27477\";i:26729;s:12:\"delete-27478\";i:26730;s:12:\"delete-27479\";i:26731;s:12:\"delete-27480\";i:26732;s:12:\"delete-27481\";i:26733;s:12:\"delete-27482\";i:26734;s:12:\"delete-27483\";i:26735;s:12:\"delete-27484\";i:26736;s:12:\"delete-27485\";i:26737;s:12:\"delete-27486\";i:26738;s:12:\"delete-27487\";i:26739;s:12:\"delete-27488\";i:26740;s:12:\"delete-27489\";i:26741;s:12:\"delete-27490\";i:26742;s:12:\"delete-27491\";i:26743;s:12:\"delete-27492\";i:26744;s:12:\"delete-27493\";i:26745;s:12:\"delete-27494\";i:26746;s:12:\"delete-27495\";i:26747;s:12:\"delete-27496\";i:26748;s:12:\"delete-27497\";i:26749;s:12:\"delete-27498\";i:26750;s:12:\"delete-27499\";i:26751;s:12:\"delete-27500\";i:26752;s:12:\"delete-27501\";i:26753;s:12:\"delete-27502\";i:26754;s:12:\"delete-27503\";i:26755;s:12:\"delete-27504\";i:26756;s:12:\"delete-27505\";i:26757;s:12:\"delete-27506\";i:26758;s:12:\"delete-27507\";i:26759;s:12:\"delete-27508\";i:26760;s:12:\"delete-27509\";i:26761;s:12:\"delete-27510\";i:26762;s:12:\"delete-27511\";i:26763;s:12:\"delete-27512\";i:26764;s:12:\"delete-27513\";i:26765;s:12:\"delete-27514\";i:26766;s:12:\"delete-27515\";i:26767;s:12:\"delete-27516\";i:26768;s:12:\"delete-27517\";i:26769;s:12:\"delete-27518\";i:26770;s:12:\"delete-27519\";i:26771;s:12:\"delete-27520\";i:26772;s:12:\"delete-27521\";i:26773;s:12:\"delete-27522\";i:26774;s:12:\"delete-27523\";i:26775;s:12:\"delete-27524\";i:26776;s:12:\"delete-27525\";i:26777;s:12:\"delete-27526\";i:26778;s:12:\"delete-27527\";i:26779;s:12:\"delete-27528\";i:26780;s:12:\"delete-27529\";i:26781;s:12:\"delete-27530\";i:26782;s:12:\"delete-27531\";i:26783;s:12:\"delete-27532\";i:26784;s:12:\"delete-27533\";i:26785;s:12:\"delete-27534\";i:26786;s:12:\"delete-27535\";i:26787;s:12:\"delete-27536\";i:26788;s:12:\"delete-27537\";i:26789;s:12:\"delete-27538\";i:26790;s:12:\"delete-27539\";i:26791;s:12:\"delete-27540\";i:26792;s:12:\"delete-27541\";i:26793;s:12:\"delete-27542\";i:26794;s:12:\"delete-27543\";i:26795;s:12:\"delete-27544\";i:26796;s:12:\"delete-27545\";i:26797;s:12:\"delete-27546\";i:26798;s:12:\"delete-27547\";i:26799;s:12:\"delete-27548\";i:26800;s:12:\"delete-27549\";i:26801;s:12:\"delete-27550\";i:26802;s:12:\"delete-27551\";i:26803;s:12:\"delete-27552\";i:26804;s:12:\"delete-27553\";i:26805;s:12:\"delete-27554\";i:26806;s:12:\"delete-27555\";i:26807;s:12:\"delete-27556\";i:26808;s:12:\"delete-27557\";i:26809;s:12:\"delete-27558\";i:26810;s:12:\"delete-27559\";i:26811;s:12:\"delete-27560\";i:26812;s:12:\"delete-27561\";i:26813;s:12:\"delete-27562\";i:26814;s:12:\"delete-27563\";i:26815;s:12:\"delete-27564\";i:26816;s:12:\"delete-27565\";i:26817;s:12:\"delete-27566\";i:26818;s:12:\"delete-27567\";i:26819;s:12:\"delete-27568\";i:26820;s:12:\"delete-27569\";i:26821;s:12:\"delete-27570\";i:26822;s:12:\"delete-27571\";i:26823;s:12:\"delete-27572\";i:26824;s:12:\"delete-27573\";i:26825;s:12:\"delete-27574\";i:26826;s:12:\"delete-27575\";i:26827;s:12:\"delete-27576\";i:26828;s:12:\"delete-27577\";i:26829;s:12:\"delete-27578\";i:26830;s:12:\"delete-27579\";i:26831;s:12:\"delete-27580\";i:26832;s:12:\"delete-27581\";i:26833;s:12:\"delete-27582\";i:26834;s:12:\"delete-27583\";i:26835;s:12:\"delete-27584\";i:26836;s:12:\"delete-27585\";i:26837;s:12:\"delete-27586\";i:26838;s:12:\"delete-27587\";i:26839;s:12:\"delete-27588\";i:26840;s:12:\"delete-27589\";i:26841;s:12:\"delete-27590\";i:26842;s:12:\"delete-27591\";i:26843;s:12:\"delete-27592\";i:26844;s:12:\"delete-27593\";i:26845;s:12:\"delete-27594\";i:26846;s:12:\"delete-27595\";i:26847;s:12:\"delete-27596\";i:26848;s:12:\"delete-27597\";i:26849;s:12:\"delete-27598\";i:26850;s:12:\"delete-27599\";i:26851;s:12:\"delete-27600\";i:26852;s:12:\"delete-27601\";i:26853;s:12:\"delete-27602\";i:26854;s:12:\"delete-27603\";i:26855;s:12:\"delete-27604\";i:26856;s:12:\"delete-27605\";i:26857;s:12:\"delete-27606\";i:26858;s:12:\"delete-27607\";i:26859;s:12:\"delete-27608\";i:26860;s:12:\"delete-27609\";i:26861;s:12:\"delete-27610\";i:26862;s:12:\"delete-27611\";i:26863;s:12:\"delete-27612\";i:26864;s:12:\"delete-27613\";i:26865;s:12:\"delete-27614\";i:26866;s:12:\"delete-27615\";i:26867;s:12:\"delete-27616\";i:26868;s:12:\"delete-27617\";i:26869;s:12:\"delete-27618\";i:26870;s:12:\"delete-27619\";i:26871;s:12:\"delete-27620\";i:26872;s:12:\"delete-27621\";i:26873;s:12:\"delete-27622\";i:26874;s:12:\"delete-27623\";i:26875;s:12:\"delete-27624\";i:26876;s:12:\"delete-27625\";i:26877;s:12:\"delete-27626\";i:26878;s:12:\"delete-27627\";i:26879;s:12:\"delete-27628\";i:26880;s:12:\"delete-27629\";i:26881;s:12:\"delete-27630\";i:26882;s:12:\"delete-27631\";i:26883;s:12:\"delete-27632\";i:26884;s:12:\"delete-27633\";i:26885;s:12:\"delete-27634\";i:26886;s:12:\"delete-27635\";i:26887;s:12:\"delete-27636\";i:26888;s:12:\"delete-27637\";i:26889;s:12:\"delete-27638\";i:26890;s:12:\"delete-27639\";i:26891;s:12:\"delete-27640\";i:26892;s:12:\"delete-27641\";i:26893;s:12:\"delete-27642\";i:26894;s:12:\"delete-27643\";i:26895;s:12:\"delete-27644\";i:26896;s:12:\"delete-27645\";i:26897;s:12:\"delete-27646\";i:26898;s:12:\"delete-27647\";i:26899;s:12:\"delete-27648\";i:26900;s:12:\"delete-27649\";i:26901;s:12:\"delete-27650\";i:26902;s:12:\"delete-27651\";i:26903;s:12:\"delete-27652\";i:26904;s:12:\"delete-27653\";i:26905;s:12:\"delete-27654\";i:26906;s:12:\"delete-27655\";i:26907;s:12:\"delete-27656\";i:26908;s:12:\"delete-27657\";i:26909;s:12:\"delete-27658\";i:26910;s:12:\"delete-27659\";i:26911;s:12:\"delete-27660\";i:26912;s:12:\"delete-27661\";i:26913;s:12:\"delete-27662\";i:26914;s:12:\"delete-27663\";i:26915;s:12:\"delete-27664\";i:26916;s:12:\"delete-27665\";i:26917;s:12:\"delete-27666\";i:26918;s:12:\"delete-27667\";i:26919;s:12:\"delete-27668\";i:26920;s:12:\"delete-27669\";i:26921;s:12:\"delete-27670\";i:26922;s:12:\"delete-27671\";i:26923;s:12:\"delete-27672\";i:26924;s:12:\"delete-27673\";i:26925;s:12:\"delete-27674\";i:26926;s:12:\"delete-27675\";i:26927;s:12:\"delete-27676\";i:26928;s:12:\"delete-27677\";i:26929;s:12:\"delete-27678\";i:26930;s:12:\"delete-27679\";i:26931;s:12:\"delete-27680\";i:26932;s:12:\"delete-27681\";i:26933;s:12:\"delete-27682\";i:26934;s:12:\"delete-27683\";i:26935;s:12:\"delete-27684\";i:26936;s:12:\"delete-27685\";i:26937;s:12:\"delete-27686\";i:26938;s:12:\"delete-27687\";i:26939;s:12:\"delete-27688\";i:26940;s:12:\"delete-27689\";i:26941;s:12:\"delete-27690\";i:26942;s:12:\"delete-27691\";i:26943;s:12:\"delete-27692\";i:26944;s:12:\"delete-27693\";i:26945;s:12:\"delete-27694\";i:26946;s:12:\"delete-27695\";i:26947;s:12:\"delete-27696\";i:26948;s:12:\"delete-27697\";i:26949;s:12:\"delete-27698\";i:26950;s:12:\"delete-27699\";i:26951;s:12:\"delete-27700\";i:26952;s:12:\"delete-27701\";i:26953;s:12:\"delete-27702\";i:26954;s:12:\"delete-27703\";i:26955;s:12:\"delete-27704\";i:26956;s:12:\"delete-27705\";i:26957;s:12:\"delete-27706\";i:26958;s:12:\"delete-27707\";i:26959;s:12:\"delete-27708\";i:26960;s:12:\"delete-27709\";i:26961;s:12:\"delete-27710\";i:26962;s:12:\"delete-27711\";i:26963;s:12:\"delete-27712\";i:26964;s:12:\"delete-27713\";i:26965;s:12:\"delete-27714\";i:26966;s:12:\"delete-27715\";i:26967;s:12:\"delete-27716\";i:26968;s:12:\"delete-27717\";i:26969;s:12:\"delete-27718\";i:26970;s:12:\"delete-27719\";i:26971;s:12:\"delete-27720\";i:26972;s:12:\"delete-27721\";i:26973;s:12:\"delete-27722\";i:26974;s:12:\"delete-27723\";i:26975;s:12:\"delete-27724\";i:26976;s:12:\"delete-27725\";i:26977;s:12:\"delete-27726\";i:26978;s:12:\"delete-27727\";i:26979;s:12:\"delete-27728\";i:26980;s:12:\"delete-27729\";i:26981;s:12:\"delete-27730\";i:26982;s:12:\"delete-27731\";i:26983;s:12:\"delete-27732\";i:26984;s:12:\"delete-27733\";i:26985;s:12:\"delete-27734\";i:26986;s:12:\"delete-27735\";i:26987;s:12:\"delete-27736\";i:26988;s:12:\"delete-27737\";i:26989;s:12:\"delete-27738\";i:26990;s:12:\"delete-27739\";i:26991;s:12:\"delete-27740\";i:26992;s:12:\"delete-27741\";i:26993;s:12:\"delete-27742\";i:26994;s:12:\"delete-27743\";i:26995;s:12:\"delete-27744\";i:26996;s:12:\"delete-27745\";i:26997;s:12:\"delete-27746\";i:26998;s:12:\"delete-27747\";i:26999;s:12:\"delete-27748\";i:27000;s:12:\"delete-27749\";i:27001;s:12:\"delete-27750\";i:27002;s:12:\"delete-27751\";i:27003;s:12:\"delete-27752\";i:27004;s:12:\"delete-27753\";i:27005;s:12:\"delete-27754\";i:27006;s:12:\"delete-27755\";i:27007;s:12:\"delete-27756\";i:27008;s:12:\"delete-27757\";i:27009;s:12:\"delete-27758\";i:27010;s:12:\"delete-27759\";i:27011;s:12:\"delete-27760\";i:27012;s:12:\"delete-27761\";i:27013;s:12:\"delete-27762\";i:27014;s:12:\"delete-27763\";i:27015;s:12:\"delete-27764\";i:27016;s:12:\"delete-27765\";i:27017;s:12:\"delete-27766\";i:27018;s:12:\"delete-27767\";i:27019;s:12:\"delete-27768\";i:27020;s:12:\"delete-27769\";i:27021;s:12:\"delete-27770\";i:27022;s:12:\"delete-27771\";i:27023;s:12:\"delete-27772\";i:27024;s:12:\"delete-27773\";i:27025;s:12:\"delete-27774\";i:27026;s:12:\"delete-27775\";i:27027;s:12:\"delete-27776\";i:27028;s:12:\"delete-27777\";i:27029;s:12:\"delete-27778\";i:27030;s:12:\"delete-27779\";i:27031;s:12:\"delete-27780\";i:27032;s:12:\"delete-27781\";i:27033;s:12:\"delete-27782\";i:27034;s:12:\"delete-27783\";i:27035;s:12:\"delete-27784\";i:27036;s:12:\"delete-27785\";i:27037;s:12:\"delete-27786\";i:27038;s:12:\"delete-27787\";i:27039;s:12:\"delete-27788\";i:27040;s:12:\"delete-27789\";i:27041;s:12:\"delete-27790\";i:27042;s:12:\"delete-27791\";i:27043;s:12:\"delete-27792\";i:27044;s:12:\"delete-27793\";i:27045;s:12:\"delete-27794\";i:27046;s:12:\"delete-27795\";i:27047;s:12:\"delete-27796\";i:27048;s:12:\"delete-27797\";i:27049;s:12:\"delete-27798\";i:27050;s:12:\"delete-27799\";i:27051;s:12:\"delete-27800\";i:27052;s:12:\"delete-27801\";i:27053;s:12:\"delete-27802\";i:27054;s:12:\"delete-27803\";i:27055;s:12:\"delete-27804\";i:27056;s:12:\"delete-27805\";i:27057;s:12:\"delete-27806\";i:27058;s:12:\"delete-27807\";i:27059;s:12:\"delete-27808\";i:27060;s:12:\"delete-27809\";i:27061;s:12:\"delete-27810\";i:27062;s:12:\"delete-27811\";i:27063;s:12:\"delete-27812\";i:27064;s:12:\"delete-27813\";i:27065;s:12:\"delete-27814\";i:27066;s:12:\"delete-27815\";i:27067;s:12:\"delete-27816\";i:27068;s:12:\"delete-27817\";i:27069;s:12:\"delete-27818\";i:27070;s:12:\"delete-27819\";i:27071;s:12:\"delete-27820\";i:27072;s:12:\"delete-27821\";i:27073;s:12:\"delete-27822\";i:27074;s:12:\"delete-27823\";i:27075;s:12:\"delete-27824\";i:27076;s:12:\"delete-27825\";i:27077;s:12:\"delete-27826\";i:27078;s:12:\"delete-27827\";i:27079;s:12:\"delete-27828\";i:27080;s:12:\"delete-27829\";i:27081;s:12:\"delete-27830\";i:27082;s:12:\"delete-27831\";i:27083;s:12:\"delete-27832\";i:27084;s:12:\"delete-27833\";i:27085;s:12:\"delete-27834\";i:27086;s:12:\"delete-27835\";i:27087;s:12:\"delete-27836\";i:27088;s:12:\"delete-27837\";i:27089;s:12:\"delete-27838\";i:27090;s:12:\"delete-27839\";i:27091;s:12:\"delete-27840\";i:27092;s:12:\"delete-27841\";i:27093;s:12:\"delete-27842\";i:27094;s:12:\"delete-27843\";i:27095;s:12:\"delete-27844\";i:27096;s:12:\"delete-27845\";i:27097;s:12:\"delete-27846\";i:27098;s:12:\"delete-27847\";i:27099;s:12:\"delete-27848\";i:27100;s:12:\"delete-27849\";i:27101;s:12:\"delete-27850\";i:27102;s:12:\"delete-27851\";i:27103;s:12:\"delete-27852\";i:27104;s:12:\"delete-27853\";i:27105;s:12:\"delete-27854\";i:27106;s:12:\"delete-27855\";i:27107;s:12:\"delete-27856\";i:27108;s:12:\"delete-27857\";i:27109;s:12:\"delete-27858\";i:27110;s:12:\"delete-27859\";i:27111;s:12:\"delete-27860\";i:27112;s:12:\"delete-27861\";i:27113;s:12:\"delete-27862\";i:27114;s:12:\"delete-27863\";i:27115;s:12:\"delete-27864\";i:27116;s:12:\"delete-27865\";i:27117;s:12:\"delete-27866\";i:27118;s:12:\"delete-27867\";i:27119;s:12:\"delete-27868\";i:27120;s:12:\"delete-27869\";i:27121;s:12:\"delete-27870\";i:27122;s:12:\"delete-27871\";i:27123;s:12:\"delete-27872\";i:27124;s:12:\"delete-27873\";i:27125;s:12:\"delete-27874\";i:27126;s:12:\"delete-27875\";i:27127;s:12:\"delete-27876\";i:27128;s:12:\"delete-27877\";i:27129;s:12:\"delete-27878\";i:27130;s:12:\"delete-27879\";i:27131;s:12:\"delete-27880\";i:27132;s:12:\"delete-27881\";i:27133;s:12:\"delete-27882\";i:27134;s:12:\"delete-27883\";i:27135;s:12:\"delete-27884\";i:27136;s:12:\"delete-27885\";i:27137;s:12:\"delete-27886\";i:27138;s:12:\"delete-27887\";i:27139;s:12:\"delete-27888\";i:27140;s:12:\"delete-27889\";i:27141;s:12:\"delete-27890\";i:27142;s:12:\"delete-27891\";i:27143;s:12:\"delete-27892\";i:27144;s:12:\"delete-27893\";i:27145;s:12:\"delete-27894\";i:27146;s:12:\"delete-27895\";i:27147;s:12:\"delete-27896\";i:27148;s:12:\"delete-27897\";i:27149;s:12:\"delete-27898\";i:27150;s:12:\"delete-27899\";i:27151;s:12:\"delete-27900\";i:27152;s:12:\"delete-27901\";i:27153;s:12:\"delete-27902\";i:27154;s:12:\"delete-27903\";i:27155;s:12:\"delete-27904\";i:27156;s:12:\"delete-27905\";i:27157;s:12:\"delete-27906\";i:27158;s:12:\"delete-27907\";i:27159;s:12:\"delete-27908\";i:27160;s:12:\"delete-27909\";i:27161;s:12:\"delete-27910\";i:27162;s:12:\"delete-27911\";i:27163;s:12:\"delete-27912\";i:27164;s:12:\"delete-27913\";i:27165;s:12:\"delete-27914\";i:27166;s:12:\"delete-27915\";i:27167;s:12:\"delete-27916\";i:27168;s:12:\"delete-27917\";i:27169;s:12:\"delete-27918\";i:27170;s:12:\"delete-27919\";i:27171;s:12:\"delete-27920\";i:27172;s:12:\"delete-27921\";i:27173;s:12:\"delete-27922\";i:27174;s:12:\"delete-27923\";i:27175;s:12:\"delete-27924\";i:27176;s:12:\"delete-27925\";i:27177;s:12:\"delete-27926\";i:27178;s:12:\"delete-27927\";i:27179;s:12:\"delete-27930\";i:27180;s:12:\"delete-27931\";i:27181;s:12:\"delete-27932\";i:27182;s:12:\"delete-27935\";i:27183;s:12:\"delete-27938\";i:27184;s:12:\"delete-27939\";i:27185;s:12:\"delete-27940\";i:27186;s:12:\"delete-27946\";i:27187;s:12:\"delete-27947\";i:27188;s:12:\"delete-27948\";i:27189;s:12:\"delete-27949\";i:27190;s:12:\"delete-27950\";i:27191;s:12:\"delete-27951\";i:27192;s:12:\"delete-27952\";i:27193;s:12:\"delete-27953\";i:27194;s:12:\"delete-27954\";i:27195;s:12:\"delete-27955\";i:27196;s:12:\"delete-27956\";i:27197;s:12:\"delete-27957\";i:27198;s:12:\"delete-27958\";i:27199;s:12:\"delete-27959\";i:27200;s:12:\"delete-27960\";i:27201;s:12:\"delete-27961\";i:27202;s:12:\"delete-27962\";i:27203;s:12:\"delete-27963\";i:27204;s:12:\"delete-27964\";i:27205;s:12:\"delete-27965\";i:27206;s:12:\"delete-27966\";i:27207;s:12:\"delete-27967\";i:27208;s:12:\"delete-27968\";i:27209;s:12:\"delete-27969\";i:27210;s:12:\"delete-27970\";i:27211;s:12:\"delete-27971\";i:27212;s:12:\"delete-27972\";i:27213;s:12:\"delete-27973\";i:27214;s:12:\"delete-27974\";i:27215;s:12:\"delete-27975\";i:27216;s:12:\"delete-27976\";i:27217;s:12:\"delete-27977\";i:27218;s:12:\"delete-27978\";i:27219;s:12:\"delete-27979\";i:27220;s:12:\"delete-27980\";i:27221;s:12:\"delete-27981\";i:27222;s:12:\"delete-27982\";i:27223;s:12:\"delete-27983\";i:27224;s:12:\"delete-27984\";i:27225;s:12:\"delete-27985\";i:27226;s:12:\"delete-27986\";i:27227;s:12:\"delete-27987\";i:27228;s:12:\"delete-27988\";i:27229;s:12:\"delete-27989\";i:27230;s:12:\"delete-27990\";i:27231;s:12:\"delete-27991\";i:27232;s:12:\"delete-27992\";i:27233;s:12:\"delete-27993\";i:27234;s:12:\"delete-27994\";i:27235;s:12:\"delete-27995\";i:27236;s:12:\"delete-27996\";i:27237;s:12:\"delete-27997\";i:27238;s:12:\"delete-27998\";i:27239;s:12:\"delete-27999\";i:27240;s:12:\"delete-28000\";i:27241;s:12:\"delete-28001\";i:27242;s:12:\"delete-28002\";i:27243;s:12:\"delete-28003\";i:27244;s:12:\"delete-28004\";i:27245;s:12:\"delete-28005\";i:27246;s:12:\"delete-28006\";i:27247;s:12:\"delete-28007\";i:27248;s:12:\"delete-28008\";i:27249;s:12:\"delete-28009\";i:27250;s:12:\"delete-28010\";i:27251;s:12:\"delete-28011\";i:27252;s:12:\"delete-28012\";i:27253;s:12:\"delete-28013\";i:27254;s:12:\"delete-28014\";i:27255;s:12:\"delete-28015\";i:27256;s:12:\"delete-28016\";i:27257;s:12:\"delete-28017\";i:27258;s:12:\"delete-28018\";i:27259;s:12:\"delete-28019\";i:27260;s:12:\"delete-28020\";i:27261;s:12:\"delete-28021\";i:27262;s:12:\"delete-28022\";i:27263;s:12:\"delete-28023\";i:27264;s:12:\"delete-28024\";i:27265;s:12:\"delete-28025\";i:27266;s:12:\"delete-28026\";i:27267;s:12:\"delete-28027\";i:27268;s:12:\"delete-28028\";i:27269;s:12:\"delete-28029\";i:27270;s:12:\"delete-28030\";i:27271;s:12:\"delete-28031\";i:27272;s:12:\"delete-28032\";i:27273;s:12:\"delete-28033\";i:27274;s:12:\"delete-28034\";i:27275;s:12:\"delete-28035\";i:27276;s:12:\"delete-28036\";i:27277;s:12:\"delete-28037\";i:27278;s:12:\"delete-28038\";i:27279;s:12:\"delete-28039\";i:27280;s:12:\"delete-28040\";i:27281;s:12:\"delete-28041\";i:27282;s:12:\"delete-28042\";i:27283;s:12:\"delete-28043\";i:27284;s:12:\"delete-28044\";i:27285;s:12:\"delete-28045\";i:27286;s:12:\"delete-28046\";i:27287;s:12:\"delete-28047\";i:27288;s:12:\"delete-28048\";i:27289;s:12:\"delete-28049\";i:27290;s:12:\"delete-28050\";i:27291;s:12:\"delete-28051\";i:27292;s:12:\"delete-28052\";i:27293;s:12:\"delete-28053\";i:27294;s:12:\"delete-28054\";i:27295;s:12:\"delete-28055\";i:27296;s:12:\"delete-28056\";i:27297;s:12:\"delete-28057\";i:27298;s:12:\"delete-28058\";i:27299;s:12:\"delete-28059\";i:27300;s:12:\"delete-28060\";i:27301;s:12:\"delete-28061\";i:27302;s:12:\"delete-28062\";i:27303;s:12:\"delete-28063\";i:27304;s:12:\"delete-28064\";i:27305;s:12:\"delete-28065\";i:27306;s:12:\"delete-28066\";i:27307;s:12:\"delete-28067\";i:27308;s:12:\"delete-28068\";i:27309;s:12:\"delete-28069\";i:27310;s:12:\"delete-28070\";i:27311;s:12:\"delete-28071\";i:27312;s:12:\"delete-28072\";i:27313;s:12:\"delete-28073\";i:27314;s:12:\"delete-28074\";i:27315;s:12:\"delete-28075\";i:27316;s:12:\"delete-28076\";i:27317;s:12:\"delete-28077\";i:27318;s:12:\"delete-28078\";i:27319;s:12:\"delete-28079\";i:27320;s:12:\"delete-28080\";i:27321;s:12:\"delete-28081\";i:27322;s:12:\"delete-28082\";i:27323;s:12:\"delete-28083\";i:27324;s:12:\"delete-28084\";i:27325;s:12:\"delete-28085\";i:27326;s:12:\"delete-28086\";i:27327;s:12:\"delete-28087\";i:27328;s:12:\"delete-28088\";i:27329;s:12:\"delete-28089\";i:27330;s:12:\"delete-28090\";i:27331;s:12:\"delete-28091\";i:27332;s:12:\"delete-28092\";i:27333;s:12:\"delete-28093\";i:27334;s:12:\"delete-28094\";i:27335;s:12:\"delete-28095\";i:27336;s:12:\"delete-28096\";i:27337;s:12:\"delete-28097\";i:27338;s:12:\"delete-28098\";i:27339;s:12:\"delete-28099\";i:27340;s:12:\"delete-28100\";i:27341;s:12:\"delete-28101\";i:27342;s:12:\"delete-28102\";i:27343;s:12:\"delete-28103\";i:27344;s:12:\"delete-28104\";i:27345;s:12:\"delete-28105\";i:27346;s:12:\"delete-28106\";i:27347;s:12:\"delete-28107\";i:27348;s:12:\"delete-28108\";i:27349;s:12:\"delete-28109\";i:27350;s:12:\"delete-28110\";i:27351;s:12:\"delete-28111\";i:27352;s:12:\"delete-28112\";i:27353;s:12:\"delete-28113\";i:27354;s:12:\"delete-28114\";i:27355;s:12:\"delete-28115\";i:27356;s:12:\"delete-28116\";i:27357;s:12:\"delete-28117\";i:27358;s:12:\"delete-28118\";i:27359;s:12:\"delete-28119\";i:27360;s:12:\"delete-28120\";i:27361;s:12:\"delete-28121\";i:27362;s:12:\"delete-28122\";i:27363;s:12:\"delete-28123\";i:27364;s:12:\"delete-28124\";i:27365;s:12:\"delete-28125\";i:27366;s:12:\"delete-28126\";i:27367;s:12:\"delete-28127\";i:27368;s:12:\"delete-28128\";i:27369;s:12:\"delete-28129\";i:27370;s:12:\"delete-28130\";i:27371;s:12:\"delete-28131\";i:27372;s:12:\"delete-28132\";i:27373;s:12:\"delete-28133\";i:27374;s:12:\"delete-28134\";i:27375;s:12:\"delete-28135\";i:27376;s:12:\"delete-28136\";i:27377;s:12:\"delete-28137\";i:27378;s:12:\"delete-28138\";i:27379;s:12:\"delete-28139\";i:27380;s:12:\"delete-28140\";i:27381;s:12:\"delete-28141\";i:27382;s:12:\"delete-28142\";i:27383;s:12:\"delete-28143\";i:27384;s:12:\"delete-28144\";i:27385;s:12:\"delete-28145\";i:27386;s:12:\"delete-28146\";i:27387;s:12:\"delete-28147\";i:27388;s:12:\"delete-28148\";i:27389;s:12:\"delete-28149\";i:27390;s:12:\"delete-28150\";i:27391;s:12:\"delete-28151\";i:27392;s:12:\"delete-28152\";i:27393;s:12:\"delete-28153\";i:27394;s:12:\"delete-28154\";i:27395;s:12:\"delete-28155\";i:27396;s:12:\"delete-28156\";i:27397;s:12:\"delete-28157\";i:27398;s:12:\"delete-28158\";i:27399;s:12:\"delete-28159\";i:27400;s:12:\"delete-28160\";i:27401;s:12:\"delete-28161\";i:27402;s:12:\"delete-28162\";i:27403;s:12:\"delete-28163\";i:27404;s:12:\"delete-28164\";i:27405;s:12:\"delete-28165\";i:27406;s:12:\"delete-28166\";i:27407;s:12:\"delete-28167\";i:27408;s:12:\"delete-28168\";i:27409;s:12:\"delete-28169\";i:27410;s:12:\"delete-28170\";i:27411;s:12:\"delete-28171\";i:27412;s:12:\"delete-28172\";i:27413;s:12:\"delete-28173\";i:27414;s:12:\"delete-28174\";i:27415;s:12:\"delete-28175\";i:27416;s:12:\"delete-28176\";i:27417;s:12:\"delete-28177\";i:27418;s:12:\"delete-28178\";i:27419;s:12:\"delete-28179\";i:27420;s:12:\"delete-28180\";i:27421;s:12:\"delete-28181\";i:27422;s:12:\"delete-28182\";i:27423;s:12:\"delete-28183\";i:27424;s:12:\"delete-28184\";i:27425;s:12:\"delete-28185\";i:27426;s:12:\"delete-28186\";i:27427;s:12:\"delete-28187\";i:27428;s:12:\"delete-28188\";i:27429;s:12:\"delete-28189\";i:27430;s:12:\"delete-28190\";i:27431;s:12:\"delete-28191\";i:27432;s:12:\"delete-28192\";i:27433;s:12:\"delete-28193\";i:27434;s:12:\"delete-28194\";i:27435;s:12:\"delete-28195\";i:27436;s:12:\"delete-28196\";i:27437;s:12:\"delete-28197\";i:27438;s:12:\"delete-28198\";i:27439;s:12:\"delete-28199\";i:27440;s:12:\"delete-28200\";i:27441;s:12:\"delete-28201\";i:27442;s:12:\"delete-28202\";i:27443;s:12:\"delete-28203\";i:27444;s:12:\"delete-28204\";i:27445;s:12:\"delete-28205\";i:27446;s:12:\"delete-28206\";i:27447;s:12:\"delete-28207\";i:27448;s:12:\"delete-28208\";i:27449;s:12:\"delete-28209\";i:27450;s:12:\"delete-28210\";i:27451;s:12:\"delete-28211\";i:27452;s:12:\"delete-28212\";i:27453;s:12:\"delete-28213\";i:27454;s:12:\"delete-28214\";i:27455;s:12:\"delete-28215\";i:27456;s:12:\"delete-28216\";i:27457;s:12:\"delete-28217\";i:27458;s:12:\"delete-28218\";i:27459;s:12:\"delete-28219\";i:27460;s:12:\"delete-28220\";i:27461;s:12:\"delete-28221\";i:27462;s:12:\"delete-28222\";i:27463;s:12:\"delete-28223\";i:27464;s:12:\"delete-28224\";i:27465;s:12:\"delete-28225\";i:27466;s:12:\"delete-28226\";i:27467;s:12:\"delete-28227\";i:27468;s:12:\"delete-28228\";i:27469;s:12:\"delete-28229\";i:27470;s:12:\"delete-28230\";i:27471;s:12:\"delete-28231\";i:27472;s:12:\"delete-28232\";i:27473;s:12:\"delete-28233\";i:27474;s:12:\"delete-28234\";i:27475;s:12:\"delete-28235\";i:27476;s:12:\"delete-28236\";i:27477;s:12:\"delete-28237\";i:27478;s:12:\"delete-28238\";i:27479;s:12:\"delete-28239\";i:27480;s:12:\"delete-28240\";i:27481;s:12:\"delete-28241\";i:27482;s:12:\"delete-28242\";i:27483;s:12:\"delete-28243\";i:27484;s:12:\"delete-28244\";i:27485;s:12:\"delete-28245\";i:27486;s:12:\"delete-28246\";i:27487;s:12:\"delete-28247\";i:27488;s:12:\"delete-28248\";i:27489;s:12:\"delete-28249\";i:27490;s:12:\"delete-28250\";i:27491;s:12:\"delete-28251\";i:27492;s:12:\"delete-28252\";i:27493;s:12:\"delete-28253\";i:27494;s:12:\"delete-28254\";i:27495;s:12:\"delete-28255\";i:27496;s:12:\"delete-28256\";i:27497;s:12:\"delete-28257\";i:27498;s:12:\"delete-28258\";i:27499;s:12:\"delete-28259\";i:27500;s:12:\"delete-28260\";i:27501;s:12:\"delete-28261\";i:27502;s:12:\"delete-28262\";i:27503;s:12:\"delete-28263\";i:27504;s:12:\"delete-28264\";i:27505;s:12:\"delete-28265\";i:27506;s:12:\"delete-28266\";i:27507;s:12:\"delete-28267\";i:27508;s:12:\"delete-28268\";i:27509;s:12:\"delete-28269\";i:27510;s:12:\"delete-28270\";i:27511;s:12:\"delete-28271\";i:27512;s:12:\"delete-28272\";i:27513;s:12:\"delete-28273\";i:27514;s:12:\"delete-28274\";i:27515;s:12:\"delete-28275\";i:27516;s:12:\"delete-28276\";i:27517;s:12:\"delete-28277\";i:27518;s:12:\"delete-28278\";i:27519;s:12:\"delete-28279\";i:27520;s:12:\"delete-28280\";i:27521;s:12:\"delete-28281\";i:27522;s:12:\"delete-28282\";i:27523;s:12:\"delete-28283\";i:27524;s:12:\"delete-28284\";i:27525;s:12:\"delete-28285\";i:27526;s:12:\"delete-28286\";i:27527;s:12:\"delete-28287\";i:27528;s:12:\"delete-28288\";i:27529;s:12:\"delete-28289\";i:27530;s:12:\"delete-28290\";i:27531;s:12:\"delete-28291\";i:27532;s:12:\"delete-28292\";i:27533;s:12:\"delete-28293\";i:27534;s:12:\"delete-28294\";i:27535;s:12:\"delete-28295\";i:27536;s:12:\"delete-28296\";i:27537;s:12:\"delete-28297\";i:27538;s:12:\"delete-28298\";i:27539;s:12:\"delete-28299\";i:27540;s:12:\"delete-28300\";i:27541;s:12:\"delete-28301\";i:27542;s:12:\"delete-28302\";i:27543;s:12:\"delete-28303\";i:27544;s:12:\"delete-28304\";i:27545;s:12:\"delete-28305\";i:27546;s:12:\"delete-28306\";i:27547;s:12:\"delete-28307\";i:27548;s:12:\"delete-28308\";i:27549;s:12:\"delete-28309\";i:27550;s:12:\"delete-28310\";i:27551;s:12:\"delete-28311\";i:27552;s:12:\"delete-28312\";i:27553;s:12:\"delete-28313\";i:27554;s:12:\"delete-28314\";i:27555;s:12:\"delete-28315\";i:27556;s:12:\"delete-28316\";i:27557;s:12:\"delete-28317\";i:27558;s:12:\"delete-28318\";i:27559;s:12:\"delete-28319\";i:27560;s:12:\"delete-28320\";i:27561;s:12:\"delete-28321\";i:27562;s:12:\"delete-28322\";i:27563;s:12:\"delete-28323\";i:27564;s:12:\"delete-28324\";i:27565;s:12:\"delete-28325\";i:27566;s:12:\"delete-28326\";i:27567;s:12:\"delete-28327\";i:27568;s:12:\"delete-28328\";i:27569;s:12:\"delete-28329\";i:27570;s:12:\"delete-28330\";i:27571;s:12:\"delete-28331\";i:27572;s:12:\"delete-28332\";i:27573;s:12:\"delete-28333\";i:27574;s:12:\"delete-28334\";i:27575;s:12:\"delete-28335\";i:27576;s:12:\"delete-28336\";i:27577;s:12:\"delete-28337\";i:27578;s:12:\"delete-28338\";i:27579;s:12:\"delete-28339\";i:27580;s:12:\"delete-28340\";i:27581;s:12:\"delete-28343\";i:27582;s:12:\"delete-28344\";i:27583;s:12:\"delete-28341\";i:27584;s:12:\"delete-28342\";i:27585;s:12:\"delete-28345\";i:27586;s:12:\"delete-28346\";i:27587;s:12:\"delete-28349\";i:27588;s:12:\"delete-28350\";i:27589;s:12:\"delete-28347\";i:27590;s:12:\"delete-28348\";i:27591;s:12:\"delete-28351\";i:27592;s:12:\"delete-28352\";i:27593;s:12:\"delete-28355\";i:27594;s:12:\"delete-28356\";i:27595;s:12:\"delete-28353\";i:27596;s:12:\"delete-28354\";i:27597;s:12:\"delete-28357\";i:27598;s:12:\"delete-28358\";i:27599;s:12:\"delete-28361\";i:27600;s:12:\"delete-28359\";i:27601;s:12:\"delete-28360\";i:27602;s:12:\"delete-28362\";i:27603;s:12:\"delete-28363\";i:27604;s:12:\"delete-28364\";i:27605;s:12:\"delete-28367\";i:27606;s:12:\"delete-28368\";i:27607;s:12:\"delete-28365\";i:27608;s:12:\"delete-28366\";i:27609;s:12:\"delete-28369\";i:27610;s:12:\"delete-28370\";i:27611;s:12:\"delete-28373\";i:27612;s:12:\"delete-28374\";i:27613;s:12:\"delete-28371\";i:27614;s:12:\"delete-28372\";i:27615;s:12:\"delete-28375\";i:27616;s:12:\"delete-28376\";i:27617;s:12:\"delete-28379\";i:27618;s:12:\"delete-28380\";i:27619;s:12:\"delete-28377\";i:27620;s:12:\"delete-28378\";i:27621;s:12:\"delete-28381\";i:27622;s:12:\"delete-28382\";i:27623;s:12:\"delete-28385\";i:27624;s:12:\"delete-28386\";i:27625;s:12:\"delete-28383\";i:27626;s:12:\"delete-28384\";i:27627;s:12:\"delete-28387\";i:27628;s:12:\"delete-28388\";i:27629;s:12:\"delete-28391\";i:27630;s:12:\"delete-28389\";i:27631;s:12:\"delete-28390\";i:27632;s:12:\"delete-28392\";i:27633;s:12:\"delete-28393\";i:27634;s:12:\"delete-28394\";i:27635;s:12:\"delete-28397\";i:27636;s:12:\"delete-28398\";i:27637;s:12:\"delete-28395\";i:27638;s:12:\"delete-28396\";i:27639;s:12:\"delete-28399\";i:27640;s:12:\"delete-28400\";i:27641;s:12:\"delete-28403\";i:27642;s:12:\"delete-28404\";i:27643;s:12:\"delete-28401\";i:27644;s:12:\"delete-28402\";i:27645;s:12:\"delete-28405\";i:27646;s:12:\"delete-28406\";i:27647;s:12:\"delete-28409\";i:27648;s:12:\"delete-28410\";i:27649;s:12:\"delete-28407\";i:27650;s:12:\"delete-28408\";i:27651;s:12:\"delete-28411\";i:27652;s:12:\"delete-28412\";i:27653;s:12:\"delete-28415\";i:27654;s:12:\"delete-28416\";i:27655;s:12:\"delete-28413\";i:27656;s:12:\"delete-28414\";i:27657;s:12:\"delete-28417\";i:27658;s:12:\"delete-28418\";i:27659;s:12:\"delete-28421\";i:27660;s:12:\"delete-28422\";i:27661;s:12:\"delete-28419\";i:27662;s:12:\"delete-28420\";i:27663;s:12:\"delete-28423\";i:27664;s:12:\"delete-28424\";i:27665;s:12:\"delete-28427\";i:27666;s:12:\"delete-28428\";i:27667;s:12:\"delete-28425\";i:27668;s:12:\"delete-28426\";i:27669;s:12:\"delete-28429\";i:27670;s:12:\"delete-28430\";i:27671;s:12:\"delete-28433\";i:27672;s:12:\"delete-28434\";i:27673;s:12:\"delete-28431\";i:27674;s:12:\"delete-28432\";i:27675;s:12:\"delete-28435\";i:27676;s:12:\"delete-28436\";i:27677;s:12:\"delete-28439\";i:27678;s:12:\"delete-28437\";i:27679;s:12:\"delete-28438\";i:27680;s:12:\"delete-28440\";i:27681;s:12:\"delete-28441\";i:27682;s:12:\"delete-28442\";i:27683;s:12:\"delete-28445\";i:27684;s:12:\"delete-28446\";i:27685;s:12:\"delete-28443\";i:27686;s:12:\"delete-28444\";i:27687;s:12:\"delete-28447\";i:27688;s:12:\"delete-28448\";i:27689;s:12:\"delete-28451\";i:27690;s:12:\"delete-28449\";i:27691;s:12:\"delete-28450\";i:27692;s:12:\"delete-28452\";i:27693;s:12:\"delete-28453\";i:27694;s:12:\"delete-28454\";i:27695;s:12:\"delete-28457\";i:27696;s:12:\"delete-28458\";i:27697;s:12:\"delete-28455\";i:27698;s:12:\"delete-28456\";i:27699;s:12:\"delete-28459\";i:27700;s:12:\"delete-28460\";i:27701;s:12:\"delete-28463\";i:27702;s:12:\"delete-28464\";i:27703;s:12:\"delete-28461\";i:27704;s:12:\"delete-28462\";i:27705;s:12:\"delete-28465\";i:27706;s:12:\"delete-28466\";i:27707;s:12:\"delete-28469\";i:27708;s:12:\"delete-28470\";i:27709;s:12:\"delete-28467\";i:27710;s:12:\"delete-28468\";i:27711;s:12:\"delete-28471\";i:27712;s:12:\"delete-28472\";i:27713;s:12:\"delete-28475\";i:27714;s:12:\"delete-28476\";i:27715;s:12:\"delete-28473\";i:27716;s:12:\"delete-28474\";i:27717;s:12:\"delete-28477\";i:27718;s:12:\"delete-28478\";i:27719;s:12:\"delete-28481\";i:27720;s:12:\"delete-28482\";i:27721;s:12:\"delete-28479\";i:27722;s:12:\"delete-28480\";i:27723;s:12:\"delete-28483\";i:27724;s:12:\"delete-28484\";i:27725;s:12:\"delete-28487\";i:27726;s:12:\"delete-28488\";i:27727;s:12:\"delete-28485\";i:27728;s:12:\"delete-28486\";i:27729;s:12:\"delete-28489\";i:27730;s:12:\"delete-28490\";i:27731;s:12:\"delete-28493\";i:27732;s:12:\"delete-28494\";i:27733;s:12:\"delete-28491\";i:27734;s:12:\"delete-28492\";i:27735;s:12:\"delete-28495\";i:27736;s:12:\"delete-28496\";i:27737;s:12:\"delete-28499\";i:27738;s:12:\"delete-28500\";i:27739;s:12:\"delete-28497\";i:27740;s:12:\"delete-28498\";i:27741;s:12:\"delete-28501\";i:27742;s:12:\"delete-28502\";i:27743;s:12:\"delete-28505\";i:27744;s:12:\"delete-28506\";i:27745;s:12:\"delete-28503\";i:27746;s:12:\"delete-28504\";i:27747;s:12:\"delete-28507\";i:27748;s:12:\"delete-28508\";i:27749;s:12:\"delete-28511\";i:27750;s:12:\"delete-28509\";i:27751;s:12:\"delete-28510\";i:27752;s:12:\"delete-28512\";i:27753;s:12:\"delete-28513\";i:27754;s:12:\"delete-28514\";i:27755;s:12:\"delete-28517\";i:27756;s:12:\"delete-28515\";i:27757;s:12:\"delete-28516\";i:27758;s:12:\"delete-28518\";i:27759;s:12:\"delete-28519\";i:27760;s:12:\"delete-28520\";i:27761;s:12:\"delete-28523\";i:27762;s:12:\"delete-28524\";i:27763;s:12:\"delete-28521\";i:27764;s:12:\"delete-28522\";i:27765;s:12:\"delete-28525\";i:27766;s:12:\"delete-28526\";i:27767;s:12:\"delete-28529\";i:27768;s:12:\"delete-28530\";i:27769;s:12:\"delete-28527\";i:27770;s:12:\"delete-28528\";i:27771;s:12:\"delete-28531\";i:27772;s:12:\"delete-28532\";i:27773;s:12:\"delete-28535\";i:27774;s:12:\"delete-28536\";i:27775;s:12:\"delete-28533\";i:27776;s:12:\"delete-28534\";i:27777;s:12:\"delete-28537\";i:27778;s:12:\"delete-28538\";i:27779;s:12:\"delete-28539\";i:27780;s:12:\"delete-28540\";i:27781;s:12:\"delete-28541\";i:27782;s:12:\"delete-28542\";i:27783;s:12:\"delete-28543\";i:27784;s:12:\"delete-28544\";i:27785;s:12:\"delete-28547\";i:27786;s:12:\"delete-28545\";i:27787;s:12:\"delete-28546\";i:27788;s:12:\"delete-28548\";i:27789;s:12:\"delete-28549\";i:27790;s:12:\"delete-28550\";i:27791;s:12:\"delete-28553\";i:27792;s:12:\"delete-28551\";i:27793;s:12:\"delete-28552\";i:27794;s:12:\"delete-28554\";i:27795;s:12:\"delete-28555\";i:27796;s:12:\"delete-28556\";i:27797;s:12:\"delete-28559\";i:27798;s:12:\"delete-28560\";i:27799;s:12:\"delete-28557\";i:27800;s:12:\"delete-28558\";i:27801;s:12:\"delete-28561\";i:27802;s:12:\"delete-28562\";i:27803;s:12:\"delete-28565\";i:27804;s:12:\"delete-28566\";i:27805;s:12:\"delete-28563\";i:27806;s:12:\"delete-28564\";i:27807;s:12:\"delete-28567\";i:27808;s:12:\"delete-28568\";i:27809;s:12:\"delete-28571\";i:27810;s:12:\"delete-28572\";i:27811;s:12:\"delete-28569\";i:27812;s:12:\"delete-28570\";i:27813;s:12:\"delete-28573\";i:27814;s:12:\"delete-28574\";i:27815;s:12:\"delete-28577\";i:27816;s:12:\"delete-28575\";i:27817;s:12:\"delete-28576\";i:27818;s:12:\"delete-28578\";i:27819;s:12:\"delete-28579\";i:27820;s:12:\"delete-28580\";i:27821;s:12:\"delete-28583\";i:27822;s:12:\"delete-28581\";i:27823;s:12:\"delete-28582\";i:27824;s:12:\"delete-28584\";i:27825;s:12:\"delete-28585\";i:27826;s:12:\"delete-28586\";i:27827;s:12:\"delete-28589\";i:27828;s:12:\"delete-28590\";i:27829;s:12:\"delete-28587\";i:27830;s:12:\"delete-28588\";i:27831;s:12:\"delete-28591\";i:27832;s:12:\"delete-28592\";i:27833;s:12:\"delete-28595\";i:27834;s:12:\"delete-28596\";i:27835;s:12:\"delete-28593\";i:27836;s:12:\"delete-28594\";i:27837;s:12:\"delete-28597\";i:27838;s:12:\"delete-28598\";i:27839;s:12:\"delete-28601\";i:27840;s:12:\"delete-28602\";i:27841;s:12:\"delete-28599\";i:27842;s:12:\"delete-28600\";i:27843;s:12:\"delete-28603\";i:27844;s:12:\"delete-28604\";i:27845;s:12:\"delete-28607\";i:27846;s:12:\"delete-28608\";i:27847;s:12:\"delete-28605\";i:27848;s:12:\"delete-28606\";i:27849;s:12:\"delete-28609\";i:27850;s:12:\"delete-28610\";i:27851;s:12:\"delete-28613\";i:27852;s:12:\"delete-28611\";i:27853;s:12:\"delete-28612\";i:27854;s:12:\"delete-28614\";i:27855;s:12:\"delete-28615\";i:27856;s:12:\"delete-28616\";i:27857;s:12:\"delete-28619\";i:27858;s:12:\"delete-28617\";i:27859;s:12:\"delete-28618\";i:27860;s:12:\"delete-28620\";i:27861;s:12:\"delete-28621\";i:27862;s:12:\"delete-28622\";i:27863;s:12:\"delete-28625\";i:27864;s:12:\"delete-28626\";i:27865;s:12:\"delete-28623\";i:27866;s:12:\"delete-28624\";i:27867;s:12:\"delete-28627\";i:27868;s:12:\"delete-28628\";i:27869;s:12:\"delete-28631\";i:27870;s:12:\"delete-28629\";i:27871;s:12:\"delete-28630\";i:27872;s:12:\"delete-28632\";i:27873;s:12:\"delete-28633\";i:27874;s:12:\"delete-28634\";i:27875;s:12:\"delete-28637\";i:27876;s:12:\"delete-28638\";i:27877;s:12:\"delete-28635\";i:27878;s:12:\"delete-28636\";i:27879;s:12:\"delete-28639\";i:27880;s:12:\"delete-28640\";i:27881;s:12:\"delete-28643\";i:27882;s:12:\"delete-28644\";i:27883;s:12:\"delete-28641\";i:27884;s:12:\"delete-28642\";i:27885;s:12:\"delete-28645\";i:27886;s:12:\"delete-28646\";i:27887;s:12:\"delete-28649\";i:27888;s:12:\"delete-28650\";i:27889;s:12:\"delete-28647\";i:27890;s:12:\"delete-28648\";i:27891;s:12:\"delete-28651\";i:27892;s:12:\"delete-28652\";i:27893;s:12:\"delete-28655\";i:27894;s:12:\"delete-28656\";i:27895;s:12:\"delete-28653\";i:27896;s:12:\"delete-28654\";i:27897;s:12:\"delete-28657\";i:27898;s:12:\"delete-28658\";i:27899;s:12:\"delete-28661\";i:27900;s:12:\"delete-28659\";i:27901;s:12:\"delete-28660\";i:27902;s:12:\"delete-28662\";i:27903;s:12:\"delete-28663\";i:27904;s:12:\"delete-28664\";i:27905;s:12:\"delete-28667\";i:27906;s:12:\"delete-28668\";i:27907;s:12:\"delete-28665\";i:27908;s:12:\"delete-28666\";i:27909;s:12:\"delete-28669\";i:27910;s:12:\"delete-28670\";i:27911;s:12:\"delete-28673\";i:27912;s:12:\"delete-28674\";i:27913;s:12:\"delete-28671\";i:27914;s:12:\"delete-28672\";i:27915;s:12:\"delete-28675\";i:27916;s:12:\"delete-28676\";i:27917;s:12:\"delete-28679\";i:27918;s:12:\"delete-28680\";i:27919;s:12:\"delete-28677\";i:27920;s:12:\"delete-28678\";i:27921;s:12:\"delete-28681\";i:27922;s:12:\"delete-28682\";i:27923;s:12:\"delete-28683\";i:27924;s:12:\"delete-28684\";i:27925;s:12:\"delete-28685\";i:27926;s:12:\"delete-28686\";i:27927;s:12:\"delete-28687\";i:27928;s:12:\"delete-28688\";i:27929;s:12:\"delete-28691\";i:27930;s:12:\"delete-28692\";i:27931;s:12:\"delete-28689\";i:27932;s:12:\"delete-28690\";i:27933;s:12:\"delete-28693\";i:27934;s:12:\"delete-28694\";i:27935;s:12:\"delete-28697\";i:27936;s:12:\"delete-28698\";i:27937;s:12:\"delete-28695\";i:27938;s:12:\"delete-28696\";i:27939;s:12:\"delete-28699\";i:27940;s:12:\"delete-28700\";i:27941;s:12:\"delete-28703\";i:27942;s:12:\"delete-28704\";i:27943;s:12:\"delete-28701\";i:27944;s:12:\"delete-28702\";i:27945;s:12:\"delete-28705\";i:27946;s:12:\"delete-28706\";i:27947;s:12:\"delete-28709\";i:27948;s:12:\"delete-28710\";i:27949;s:12:\"delete-28707\";i:27950;s:12:\"delete-28708\";i:27951;s:12:\"delete-28711\";i:27952;s:12:\"delete-28712\";i:27953;s:12:\"delete-28715\";i:27954;s:12:\"delete-28716\";i:27955;s:12:\"delete-28713\";i:27956;s:12:\"delete-28714\";i:27957;s:12:\"delete-28717\";i:27958;s:12:\"delete-28718\";i:27959;s:12:\"delete-28721\";i:27960;s:12:\"delete-28719\";i:27961;s:12:\"delete-28720\";i:27962;s:12:\"delete-28722\";i:27963;s:12:\"delete-28723\";i:27964;s:12:\"delete-28724\";i:27965;s:12:\"delete-28727\";i:27966;s:12:\"delete-28725\";i:27967;s:12:\"delete-28726\";i:27968;s:12:\"delete-28728\";i:27969;s:12:\"delete-28729\";i:27970;s:12:\"delete-28730\";i:27971;s:12:\"delete-28733\";i:27972;s:12:\"delete-28734\";i:27973;s:12:\"delete-28731\";i:27974;s:12:\"delete-28732\";i:27975;s:12:\"delete-28735\";i:27976;s:12:\"delete-28736\";i:27977;s:12:\"delete-28739\";i:27978;s:12:\"delete-28737\";i:27979;s:12:\"delete-28738\";i:27980;s:12:\"delete-28740\";i:27981;s:12:\"delete-28741\";i:27982;s:12:\"delete-28742\";i:27983;s:12:\"delete-28745\";i:27984;s:12:\"delete-28746\";i:27985;s:12:\"delete-28743\";i:27986;s:12:\"delete-28744\";i:27987;s:12:\"delete-28747\";i:27988;s:12:\"delete-28748\";i:27989;s:12:\"delete-28751\";i:27990;s:12:\"delete-28752\";i:27991;s:12:\"delete-28749\";i:27992;s:12:\"delete-28750\";i:27993;s:12:\"delete-28753\";i:27994;s:12:\"delete-28754\";i:27995;s:12:\"delete-28757\";i:27996;s:12:\"delete-28758\";i:27997;s:12:\"delete-28755\";i:27998;s:12:\"delete-28756\";i:27999;s:12:\"delete-28759\";i:28000;s:12:\"delete-28760\";i:28001;s:12:\"delete-28763\";i:28002;s:12:\"delete-28764\";i:28003;s:12:\"delete-28761\";i:28004;s:12:\"delete-28762\";i:28005;s:12:\"delete-28765\";i:28006;s:12:\"delete-28766\";i:28007;s:12:\"delete-28769\";i:28008;s:12:\"delete-28770\";i:28009;s:12:\"delete-28767\";i:28010;s:12:\"delete-28768\";i:28011;s:12:\"delete-28771\";i:28012;s:12:\"delete-28772\";i:28013;s:12:\"delete-28775\";i:28014;s:12:\"delete-28776\";i:28015;s:12:\"delete-28773\";i:28016;s:12:\"delete-28774\";i:28017;s:12:\"delete-28777\";i:28018;s:12:\"delete-28778\";i:28019;s:12:\"delete-28781\";i:28020;s:12:\"delete-28782\";i:28021;s:12:\"delete-28779\";i:28022;s:12:\"delete-28780\";i:28023;s:12:\"delete-28783\";i:28024;s:12:\"delete-28784\";i:28025;s:12:\"delete-28787\";i:28026;s:12:\"delete-28788\";i:28027;s:12:\"delete-28785\";i:28028;s:12:\"delete-28786\";i:28029;s:12:\"delete-28789\";i:28030;s:12:\"delete-28790\";i:28031;s:12:\"delete-28793\";i:28032;s:12:\"delete-28791\";i:28033;s:12:\"delete-28792\";i:28034;s:12:\"delete-28794\";i:28035;s:12:\"delete-28795\";i:28036;s:12:\"delete-28796\";i:28037;s:12:\"delete-28799\";i:28038;s:12:\"delete-28800\";i:28039;s:12:\"delete-28797\";i:28040;s:12:\"delete-28798\";i:28041;s:12:\"delete-28801\";i:28042;s:12:\"delete-28802\";i:28043;s:12:\"delete-28805\";i:28044;s:12:\"delete-28806\";i:28045;s:12:\"delete-28803\";i:28046;s:12:\"delete-28804\";i:28047;s:12:\"delete-28807\";i:28048;s:12:\"delete-28808\";i:28049;s:12:\"delete-28811\";i:28050;s:12:\"delete-28812\";i:28051;s:12:\"delete-28809\";i:28052;s:12:\"delete-28810\";i:28053;s:12:\"delete-28813\";i:28054;s:12:\"delete-28814\";i:28055;s:12:\"delete-28817\";i:28056;s:12:\"delete-28818\";i:28057;s:12:\"delete-28815\";i:28058;s:12:\"delete-28816\";i:28059;s:12:\"delete-28819\";i:28060;s:12:\"delete-28820\";i:28061;s:12:\"delete-28823\";i:28062;s:12:\"delete-28821\";i:28063;s:12:\"delete-28822\";i:28064;s:12:\"delete-28824\";i:28065;s:12:\"delete-28825\";i:28066;s:12:\"delete-28826\";i:28067;s:12:\"delete-28829\";i:28068;s:12:\"delete-28830\";i:28069;s:12:\"delete-28827\";i:28070;s:12:\"delete-28828\";i:28071;s:12:\"delete-28831\";i:28072;s:12:\"delete-28832\";i:28073;s:12:\"delete-28835\";i:28074;s:12:\"delete-28836\";i:28075;s:12:\"delete-28833\";i:28076;s:12:\"delete-28834\";i:28077;s:12:\"delete-28837\";i:28078;s:12:\"delete-28838\";i:28079;s:12:\"delete-28841\";i:28080;s:12:\"delete-28842\";i:28081;s:12:\"delete-28839\";i:28082;s:12:\"delete-28840\";i:28083;s:12:\"delete-28843\";i:28084;s:12:\"delete-28844\";i:28085;s:12:\"delete-28845\";i:28086;s:12:\"delete-28846\";i:28087;s:12:\"delete-28847\";i:28088;s:12:\"delete-28848\";i:28089;s:12:\"delete-28849\";i:28090;s:12:\"delete-28850\";i:28091;s:12:\"delete-28853\";i:28092;s:12:\"delete-28854\";i:28093;s:12:\"delete-28851\";i:28094;s:12:\"delete-28852\";i:28095;s:12:\"delete-28855\";i:28096;s:12:\"delete-28856\";i:28097;s:12:\"delete-28859\";i:28098;s:12:\"delete-28860\";i:28099;s:12:\"delete-28857\";i:28100;s:12:\"delete-28858\";i:28101;s:12:\"delete-28861\";i:28102;s:12:\"delete-28862\";i:28103;s:12:\"delete-28865\";i:28104;s:12:\"delete-28866\";i:28105;s:12:\"delete-28863\";i:28106;s:12:\"delete-28864\";i:28107;s:12:\"delete-28867\";i:28108;s:12:\"delete-28868\";i:28109;s:12:\"delete-28871\";i:28110;s:12:\"delete-28872\";i:28111;s:12:\"delete-28869\";i:28112;s:12:\"delete-28870\";i:28113;s:12:\"delete-28873\";i:28114;s:12:\"delete-28874\";i:28115;s:12:\"delete-28877\";i:28116;s:12:\"delete-28878\";i:28117;s:12:\"delete-28875\";i:28118;s:12:\"delete-28876\";i:28119;s:12:\"delete-28879\";i:28120;s:12:\"delete-28880\";i:28121;s:12:\"delete-28883\";i:28122;s:12:\"delete-28884\";i:28123;s:12:\"delete-28881\";i:28124;s:12:\"delete-28882\";i:28125;s:12:\"delete-28885\";i:28126;s:12:\"delete-28886\";i:28127;s:12:\"delete-28889\";i:28128;s:12:\"delete-28890\";i:28129;s:12:\"delete-28887\";i:28130;s:12:\"delete-28888\";i:28131;s:12:\"delete-28891\";i:28132;s:12:\"delete-28892\";i:28133;s:12:\"delete-28895\";i:28134;s:12:\"delete-28896\";i:28135;s:12:\"delete-28893\";i:28136;s:12:\"delete-28894\";i:28137;s:12:\"delete-28897\";i:28138;s:12:\"delete-28898\";i:28139;s:12:\"delete-28901\";i:28140;s:12:\"delete-28899\";i:28141;s:12:\"delete-28900\";i:28142;s:12:\"delete-28902\";i:28143;s:12:\"delete-28903\";i:28144;s:12:\"delete-28904\";i:28145;s:12:\"delete-28907\";i:28146;s:12:\"delete-28908\";i:28147;s:12:\"delete-28905\";i:28148;s:12:\"delete-28906\";i:28149;s:12:\"delete-28909\";i:28150;s:12:\"delete-28910\";i:28151;s:12:\"delete-28913\";i:28152;s:12:\"delete-28914\";i:28153;s:12:\"delete-28911\";i:28154;s:12:\"delete-28912\";i:28155;s:12:\"delete-28915\";i:28156;s:12:\"delete-28916\";i:28157;s:12:\"delete-28919\";i:28158;s:12:\"delete-28920\";i:28159;s:12:\"delete-28917\";i:28160;s:12:\"delete-28918\";i:28161;s:12:\"delete-28921\";i:28162;s:12:\"delete-28922\";i:28163;s:12:\"delete-28925\";i:28164;s:12:\"delete-28926\";i:28165;s:12:\"delete-28923\";i:28166;s:12:\"delete-28924\";i:28167;s:12:\"delete-28927\";i:28168;s:12:\"delete-28928\";i:28169;s:12:\"delete-28931\";i:28170;s:12:\"delete-28932\";i:28171;s:12:\"delete-28929\";i:28172;s:12:\"delete-28930\";i:28173;s:12:\"delete-28933\";i:28174;s:12:\"delete-28934\";i:28175;s:12:\"delete-28937\";i:28176;s:12:\"delete-28938\";i:28177;s:12:\"delete-28935\";i:28178;s:12:\"delete-28936\";i:28179;s:12:\"delete-28939\";i:28180;s:12:\"delete-28940\";i:28181;s:12:\"delete-28943\";i:28182;s:12:\"delete-28944\";i:28183;s:12:\"delete-28941\";i:28184;s:12:\"delete-28942\";i:28185;s:12:\"delete-28945\";i:28186;s:12:\"delete-28946\";i:28187;s:12:\"delete-28949\";i:28188;s:12:\"delete-28950\";i:28189;s:12:\"delete-28947\";i:28190;s:12:\"delete-28948\";i:28191;s:12:\"delete-28951\";i:28192;s:12:\"delete-28952\";i:28193;s:12:\"delete-28955\";i:28194;s:12:\"delete-28956\";i:28195;s:12:\"delete-28953\";i:28196;s:12:\"delete-28954\";i:28197;s:12:\"delete-28957\";i:28198;s:12:\"delete-28958\";i:28199;s:12:\"delete-28961\";i:28200;s:12:\"delete-28962\";i:28201;s:12:\"delete-28959\";i:28202;s:12:\"delete-28960\";i:28203;s:12:\"delete-28963\";i:28204;s:12:\"delete-28964\";i:28205;s:12:\"delete-28967\";i:28206;s:12:\"delete-28965\";i:28207;s:12:\"delete-28966\";i:28208;s:12:\"delete-28968\";i:28209;s:12:\"delete-28969\";i:28210;s:12:\"delete-28970\";i:28211;s:12:\"delete-28973\";i:28212;s:12:\"delete-28974\";i:28213;s:12:\"delete-28971\";i:28214;s:12:\"delete-28972\";i:28215;s:12:\"delete-28975\";i:28216;s:12:\"delete-28976\";i:28217;s:12:\"delete-28979\";i:28218;s:12:\"delete-28977\";i:28219;s:12:\"delete-28978\";i:28220;s:12:\"delete-28980\";i:28221;s:12:\"delete-28981\";i:28222;s:12:\"delete-28982\";i:28223;s:12:\"delete-28985\";i:28224;s:12:\"delete-28986\";i:28225;s:12:\"delete-28983\";i:28226;s:12:\"delete-28984\";i:28227;s:12:\"delete-28987\";i:28228;s:12:\"delete-28988\";i:28229;s:12:\"delete-28991\";i:28230;s:12:\"delete-28992\";i:28231;s:12:\"delete-28989\";i:28232;s:12:\"delete-28990\";i:28233;s:12:\"delete-28993\";i:28234;s:12:\"delete-28994\";i:28235;s:12:\"delete-28997\";i:28236;s:12:\"delete-28995\";i:28237;s:12:\"delete-28996\";i:28238;s:12:\"delete-28998\";i:28239;s:12:\"delete-28999\";i:28240;s:12:\"delete-29000\";i:28241;s:12:\"delete-29003\";i:28242;s:12:\"delete-29004\";i:28243;s:12:\"delete-29001\";i:28244;s:12:\"delete-29002\";i:28245;s:12:\"delete-29005\";i:28246;s:12:\"delete-29006\";i:28247;s:12:\"delete-29009\";i:28248;s:12:\"delete-29010\";i:28249;s:12:\"delete-29007\";i:28250;s:12:\"delete-29008\";i:28251;s:12:\"delete-29011\";i:28252;s:12:\"delete-29012\";i:28253;s:12:\"delete-29015\";i:28254;s:12:\"delete-29016\";i:28255;s:12:\"delete-29013\";i:28256;s:12:\"delete-29014\";i:28257;s:12:\"delete-29017\";i:28258;s:12:\"delete-29018\";i:28259;s:12:\"delete-29021\";i:28260;s:12:\"delete-29022\";i:28261;s:12:\"delete-29019\";i:28262;s:12:\"delete-29020\";i:28263;s:12:\"delete-29023\";i:28264;s:12:\"delete-29024\";i:28265;s:12:\"delete-29027\";i:28266;s:12:\"delete-29028\";i:28267;s:12:\"delete-29025\";i:28268;s:12:\"delete-29026\";i:28269;s:12:\"delete-29029\";i:28270;s:12:\"delete-29030\";i:28271;s:12:\"delete-29033\";i:28272;s:12:\"delete-29034\";i:28273;s:12:\"delete-29035\";i:28274;s:12:\"delete-29036\";i:28275;s:12:\"delete-29039\";i:28276;s:12:\"delete-29031\";i:28277;s:12:\"delete-29032\";i:28278;s:12:\"delete-29037\";i:28279;s:12:\"delete-29038\";i:28280;s:12:\"delete-29040\";i:28281;s:12:\"delete-29041\";i:28282;s:12:\"delete-29042\";i:28283;s:12:\"delete-29045\";i:28284;s:12:\"delete-29046\";i:28285;s:12:\"delete-29043\";i:28286;s:12:\"delete-29044\";i:28287;s:12:\"delete-29047\";i:28288;s:12:\"delete-29048\";i:28289;s:12:\"delete-29051\";i:28290;s:12:\"delete-29052\";i:28291;s:12:\"delete-29049\";i:28292;s:12:\"delete-29050\";i:28293;s:12:\"delete-29053\";i:28294;s:12:\"delete-29054\";i:28295;s:12:\"delete-29057\";i:28296;s:12:\"delete-29058\";i:28297;s:12:\"delete-29055\";i:28298;s:12:\"delete-29056\";i:28299;s:12:\"delete-29059\";i:28300;s:12:\"delete-29060\";i:28301;s:12:\"delete-29063\";i:28302;s:12:\"delete-29064\";i:28303;s:12:\"delete-29061\";i:28304;s:12:\"delete-29062\";i:28305;s:12:\"delete-29065\";i:28306;s:12:\"delete-29066\";i:28307;s:12:\"delete-29069\";i:28308;s:12:\"delete-29070\";i:28309;s:12:\"delete-29067\";i:28310;s:12:\"delete-29068\";i:28311;s:12:\"delete-29071\";i:28312;s:12:\"delete-29072\";i:28313;s:12:\"delete-29075\";i:28314;s:12:\"delete-29076\";i:28315;s:12:\"delete-29073\";i:28316;s:12:\"delete-29074\";i:28317;s:12:\"delete-29077\";i:28318;s:12:\"delete-29078\";i:28319;s:12:\"delete-29081\";i:28320;s:12:\"delete-29079\";i:28321;s:12:\"delete-29080\";i:28322;s:12:\"delete-29082\";i:28323;s:12:\"delete-29083\";i:28324;s:12:\"delete-29084\";i:28325;s:12:\"delete-29087\";i:28326;s:12:\"delete-29088\";i:28327;s:12:\"delete-29085\";i:28328;s:12:\"delete-29086\";i:28329;s:12:\"delete-29089\";i:28330;s:12:\"delete-29090\";i:28331;s:12:\"delete-29093\";i:28332;s:12:\"delete-29094\";i:28333;s:12:\"delete-29091\";i:28334;s:12:\"delete-29092\";i:28335;s:12:\"delete-29095\";i:28336;s:12:\"delete-29096\";i:28337;s:12:\"delete-29099\";i:28338;s:12:\"delete-29097\";i:28339;s:12:\"delete-29098\";i:28340;s:12:\"delete-29100\";i:28341;s:12:\"delete-29101\";i:28342;s:12:\"delete-29102\";i:28343;s:12:\"delete-29105\";i:28344;s:12:\"delete-29106\";i:28345;s:12:\"delete-29103\";i:28346;s:12:\"delete-29104\";i:28347;s:12:\"delete-29107\";i:28348;s:12:\"delete-29108\";i:28349;s:12:\"delete-29111\";i:28350;s:12:\"delete-29109\";i:28351;s:12:\"delete-29110\";i:28352;s:12:\"delete-29112\";i:28353;s:12:\"delete-29113\";i:28354;s:12:\"delete-29114\";i:28355;s:12:\"delete-29117\";i:28356;s:12:\"delete-29118\";i:28357;s:12:\"delete-29115\";i:28358;s:12:\"delete-29116\";i:28359;s:12:\"delete-29119\";i:28360;s:12:\"delete-29120\";i:28361;s:12:\"delete-29123\";i:28362;s:12:\"delete-29124\";i:28363;s:12:\"delete-29121\";i:28364;s:12:\"delete-29122\";i:28365;s:12:\"delete-29125\";i:28366;s:12:\"delete-29126\";i:28367;s:12:\"delete-29129\";i:28368;s:12:\"delete-29130\";i:28369;s:12:\"delete-29127\";i:28370;s:12:\"delete-29128\";i:28371;s:12:\"delete-29131\";i:28372;s:12:\"delete-29132\";i:28373;s:12:\"delete-29135\";i:28374;s:12:\"delete-29133\";i:28375;s:12:\"delete-29134\";i:28376;s:12:\"delete-29136\";i:28377;s:12:\"delete-29137\";i:28378;s:12:\"delete-29138\";i:28379;s:12:\"delete-29141\";i:28380;s:12:\"delete-29139\";i:28381;s:12:\"delete-29140\";i:28382;s:12:\"delete-29142\";i:28383;s:12:\"delete-29143\";i:28384;s:12:\"delete-29144\";i:28385;s:12:\"delete-29147\";i:28386;s:12:\"delete-29145\";i:28387;s:12:\"delete-29146\";i:28388;s:12:\"delete-29148\";i:28389;s:12:\"delete-29149\";i:28390;s:12:\"delete-29150\";i:28391;s:12:\"delete-29153\";i:28392;s:12:\"delete-29154\";i:28393;s:12:\"delete-29151\";i:28394;s:12:\"delete-29152\";i:28395;s:12:\"delete-29155\";i:28396;s:12:\"delete-29156\";i:28397;s:12:\"delete-29159\";i:28398;s:12:\"delete-29160\";i:28399;s:12:\"delete-29157\";i:28400;s:12:\"delete-29158\";i:28401;s:12:\"delete-29161\";i:28402;s:12:\"delete-29162\";i:28403;s:12:\"delete-29165\";i:28404;s:12:\"delete-29166\";i:28405;s:12:\"delete-29163\";i:28406;s:12:\"delete-29164\";i:28407;s:12:\"delete-29167\";i:28408;s:12:\"delete-29168\";i:28409;s:12:\"delete-29171\";i:28410;s:12:\"delete-29172\";i:28411;s:12:\"delete-29169\";i:28412;s:12:\"delete-29170\";i:28413;s:12:\"delete-29173\";i:28414;s:12:\"delete-29174\";i:28415;s:12:\"delete-29177\";i:28416;s:12:\"delete-29175\";i:28417;s:12:\"delete-29176\";i:28418;s:12:\"delete-29178\";i:28419;s:12:\"delete-29179\";i:28420;s:12:\"delete-29180\";i:28421;s:12:\"delete-29183\";i:28422;s:12:\"delete-29184\";i:28423;s:12:\"delete-29181\";i:28424;s:12:\"delete-29182\";i:28425;s:12:\"delete-29185\";i:28426;s:12:\"delete-29186\";i:28427;s:12:\"delete-29189\";i:28428;s:12:\"delete-29190\";i:28429;s:12:\"delete-29187\";i:28430;s:12:\"delete-29188\";i:28431;s:12:\"delete-29191\";i:28432;s:12:\"delete-29192\";i:28433;s:12:\"delete-29195\";i:28434;s:12:\"delete-29193\";i:28435;s:12:\"delete-29194\";i:28436;s:12:\"delete-29196\";i:28437;s:12:\"delete-29197\";i:28438;s:12:\"delete-29198\";i:28439;s:12:\"delete-29201\";i:28440;s:12:\"delete-29202\";i:28441;s:12:\"delete-29199\";i:28442;s:12:\"delete-29200\";i:28443;s:12:\"delete-29203\";i:28444;s:12:\"delete-29204\";i:28445;s:12:\"delete-29207\";i:28446;s:12:\"delete-29208\";i:28447;s:12:\"delete-29205\";i:28448;s:12:\"delete-29206\";i:28449;s:12:\"delete-29209\";i:28450;s:12:\"delete-29210\";i:28451;s:12:\"delete-29213\";i:28452;s:12:\"delete-29214\";i:28453;s:12:\"delete-29211\";i:28454;s:12:\"delete-29212\";i:28455;s:12:\"delete-29215\";i:28456;s:12:\"delete-29216\";i:28457;s:12:\"delete-29219\";i:28458;s:12:\"delete-29220\";i:28459;s:12:\"delete-29217\";i:28460;s:12:\"delete-29218\";i:28461;s:12:\"delete-29221\";i:28462;s:12:\"delete-29222\";i:28463;s:12:\"delete-29225\";i:28464;s:12:\"delete-29226\";i:28465;s:12:\"delete-29223\";i:28466;s:12:\"delete-29224\";i:28467;s:12:\"delete-29227\";i:28468;s:12:\"delete-29228\";i:28469;s:12:\"delete-29231\";i:28470;s:12:\"delete-29232\";i:28471;s:12:\"delete-29229\";i:28472;s:12:\"delete-29230\";i:28473;s:12:\"delete-29233\";i:28474;s:12:\"delete-29234\";i:28475;s:12:\"delete-29237\";i:28476;s:12:\"delete-29238\";i:28477;s:12:\"delete-29235\";i:28478;s:12:\"delete-29236\";i:28479;s:12:\"delete-29239\";i:28480;s:12:\"delete-29240\";i:28481;s:12:\"delete-29243\";i:28482;s:12:\"delete-29241\";i:28483;s:12:\"delete-29242\";i:28484;s:12:\"delete-29244\";i:28485;s:12:\"delete-29245\";i:28486;s:12:\"delete-29246\";i:28487;s:12:\"delete-29249\";i:28488;s:12:\"delete-29250\";i:28489;s:12:\"delete-29247\";i:28490;s:12:\"delete-29248\";i:28491;s:12:\"delete-29251\";i:28492;s:12:\"delete-29252\";i:28493;s:12:\"delete-29255\";i:28494;s:12:\"delete-29256\";i:28495;s:12:\"delete-29253\";i:28496;s:12:\"delete-29254\";i:28497;s:12:\"delete-29257\";i:28498;s:12:\"delete-29258\";i:28499;s:12:\"delete-29261\";i:28500;s:12:\"delete-29262\";i:28501;s:12:\"delete-29259\";i:28502;s:12:\"delete-29260\";i:28503;s:12:\"delete-29263\";i:28504;s:12:\"delete-29264\";i:28505;s:12:\"delete-29267\";i:28506;s:12:\"delete-29268\";i:28507;s:12:\"delete-29265\";i:28508;s:12:\"delete-29266\";i:28509;s:12:\"delete-29269\";i:28510;s:12:\"delete-29270\";i:28511;s:12:\"delete-29273\";i:28512;s:12:\"delete-29274\";i:28513;s:12:\"delete-29271\";i:28514;s:12:\"delete-29272\";i:28515;s:12:\"delete-29275\";i:28516;s:12:\"delete-29276\";i:28517;s:12:\"delete-29279\";i:28518;s:12:\"delete-29277\";i:28519;s:12:\"delete-29278\";i:28520;s:12:\"delete-29280\";i:28521;s:12:\"delete-29281\";i:28522;s:12:\"delete-29282\";i:28523;s:12:\"delete-29285\";i:28524;s:12:\"delete-29286\";i:28525;s:12:\"delete-29283\";i:28526;s:12:\"delete-29284\";i:28527;s:12:\"delete-29287\";i:28528;s:12:\"delete-29288\";i:28529;s:12:\"delete-29291\";i:28530;s:12:\"delete-29292\";i:28531;s:12:\"delete-29289\";i:28532;s:12:\"delete-29290\";i:28533;s:12:\"delete-29293\";i:28534;s:12:\"delete-29294\";i:28535;s:12:\"delete-29297\";i:28536;s:12:\"delete-29295\";i:28537;s:12:\"delete-29296\";i:28538;s:12:\"delete-29298\";i:28539;s:12:\"delete-29299\";i:28540;s:12:\"delete-29300\";i:28541;s:12:\"delete-29303\";i:28542;s:12:\"delete-29304\";i:28543;s:12:\"delete-29301\";i:28544;s:12:\"delete-29302\";i:28545;s:12:\"delete-29305\";i:28546;s:12:\"delete-29306\";i:28547;s:12:\"delete-29309\";i:28548;s:12:\"delete-29310\";i:28549;s:12:\"delete-29307\";i:28550;s:12:\"delete-29308\";i:28551;s:12:\"delete-29311\";i:28552;s:12:\"delete-29312\";i:28553;s:12:\"delete-29315\";i:28554;s:12:\"delete-29316\";i:28555;s:12:\"delete-29313\";i:28556;s:12:\"delete-29314\";i:28557;s:12:\"delete-29317\";i:28558;s:12:\"delete-29318\";i:28559;s:12:\"delete-29321\";i:28560;s:12:\"delete-29319\";i:28561;s:12:\"delete-29320\";i:28562;s:12:\"delete-29322\";i:28563;s:12:\"delete-29323\";i:28564;s:12:\"delete-29324\";i:28565;s:12:\"delete-29327\";i:28566;s:12:\"delete-29325\";i:28567;s:12:\"delete-29326\";i:28568;s:12:\"delete-29328\";i:28569;s:12:\"delete-29329\";i:28570;s:12:\"delete-29330\";i:28571;s:12:\"delete-29333\";i:28572;s:12:\"delete-29334\";i:28573;s:12:\"delete-29331\";i:28574;s:12:\"delete-29332\";i:28575;s:12:\"delete-29335\";i:28576;s:12:\"delete-29336\";i:28577;s:12:\"delete-29339\";i:28578;s:12:\"delete-29340\";i:28579;s:12:\"delete-29341\";i:28580;s:12:\"delete-29342\";i:28581;s:12:\"delete-29345\";i:28582;s:12:\"delete-29346\";i:28583;s:12:\"delete-29337\";i:28584;s:12:\"delete-29338\";i:28585;s:12:\"delete-29343\";i:28586;s:12:\"delete-29344\";i:28587;s:12:\"delete-29347\";i:28588;s:12:\"delete-29348\";i:28589;s:12:\"delete-29351\";i:28590;s:12:\"delete-29352\";i:28591;s:12:\"delete-29349\";i:28592;s:12:\"delete-29350\";i:28593;s:12:\"delete-29353\";i:28594;s:12:\"delete-29354\";i:28595;s:12:\"delete-29357\";i:28596;s:12:\"delete-29358\";i:28597;s:12:\"delete-29355\";i:28598;s:12:\"delete-29356\";i:28599;s:12:\"delete-29359\";i:28600;s:12:\"delete-29360\";i:28601;s:12:\"delete-29363\";i:28602;s:12:\"delete-29361\";i:28603;s:12:\"delete-29362\";i:28604;s:12:\"delete-29364\";i:28605;s:12:\"delete-29365\";i:28606;s:12:\"delete-29366\";i:28607;s:12:\"delete-29369\";i:28608;s:12:\"delete-29370\";i:28609;s:12:\"delete-29367\";i:28610;s:12:\"delete-29368\";i:28611;s:12:\"delete-29371\";i:28612;s:12:\"delete-29372\";i:28613;s:12:\"delete-29375\";i:28614;s:12:\"delete-29376\";i:28615;s:12:\"delete-29373\";i:28616;s:12:\"delete-29374\";i:28617;s:12:\"delete-29377\";i:28618;s:12:\"delete-29378\";i:28619;s:12:\"delete-29381\";i:28620;s:12:\"delete-29382\";i:28621;s:12:\"delete-29379\";i:28622;s:12:\"delete-29380\";i:28623;s:12:\"delete-29383\";i:28624;s:12:\"delete-29384\";i:28625;s:12:\"delete-29387\";i:28626;s:12:\"delete-29388\";i:28627;s:12:\"delete-29385\";i:28628;s:12:\"delete-29386\";i:28629;s:12:\"delete-29389\";i:28630;s:12:\"delete-29390\";i:28631;s:12:\"delete-29393\";i:28632;s:12:\"delete-29394\";i:28633;s:12:\"delete-29391\";i:28634;s:12:\"delete-29392\";i:28635;s:12:\"delete-29395\";i:28636;s:12:\"delete-29396\";i:28637;s:12:\"delete-29399\";i:28638;s:12:\"delete-29397\";i:28639;s:12:\"delete-29398\";i:28640;s:12:\"delete-29400\";i:28641;s:12:\"delete-29401\";i:28642;s:12:\"delete-29402\";i:28643;s:12:\"delete-29405\";i:28644;s:12:\"delete-29406\";i:28645;s:12:\"delete-29403\";i:28646;s:12:\"delete-29404\";i:28647;s:12:\"delete-29407\";i:28648;s:12:\"delete-29408\";i:28649;s:12:\"delete-29411\";i:28650;s:12:\"delete-29412\";i:28651;s:12:\"delete-29409\";i:28652;s:12:\"delete-29410\";i:28653;s:12:\"delete-29413\";i:28654;s:12:\"delete-29414\";i:28655;s:12:\"delete-29417\";i:28656;s:12:\"delete-29418\";i:28657;s:12:\"delete-29415\";i:28658;s:12:\"delete-29416\";i:28659;s:12:\"delete-29419\";i:28660;s:12:\"delete-29420\";i:28661;s:12:\"delete-29423\";i:28662;s:12:\"delete-29424\";i:28663;s:12:\"delete-29421\";i:28664;s:12:\"delete-29422\";i:28665;s:12:\"delete-29425\";i:28666;s:12:\"delete-29426\";i:28667;s:12:\"delete-29429\";i:28668;s:12:\"delete-29430\";i:28669;s:12:\"delete-29427\";i:28670;s:12:\"delete-29428\";i:28671;s:12:\"delete-29431\";i:28672;s:12:\"delete-29432\";i:28673;s:12:\"delete-29435\";i:28674;s:12:\"delete-29436\";i:28675;s:12:\"delete-29433\";i:28676;s:12:\"delete-29434\";i:28677;s:12:\"delete-29437\";i:28678;s:12:\"delete-29438\";i:28679;s:12:\"delete-29441\";i:28680;s:12:\"delete-29442\";i:28681;s:12:\"delete-29439\";i:28682;s:12:\"delete-29440\";i:28683;s:12:\"delete-29443\";i:28684;s:12:\"delete-29444\";i:28685;s:12:\"delete-29447\";i:28686;s:12:\"delete-29445\";i:28687;s:12:\"delete-29446\";i:28688;s:12:\"delete-29448\";i:28689;s:12:\"delete-29449\";i:28690;s:12:\"delete-29450\";i:28691;s:12:\"delete-29453\";i:28692;s:12:\"delete-29454\";i:28693;s:12:\"delete-29451\";i:28694;s:12:\"delete-29452\";i:28695;s:12:\"delete-29455\";i:28696;s:12:\"delete-29456\";i:28697;s:12:\"delete-29459\";i:28698;s:12:\"delete-29460\";i:28699;s:12:\"delete-29457\";i:28700;s:12:\"delete-29458\";i:28701;s:12:\"delete-29461\";i:28702;s:12:\"delete-29462\";i:28703;s:12:\"delete-29465\";i:28704;s:12:\"delete-29463\";i:28705;s:12:\"delete-29464\";i:28706;s:12:\"delete-29466\";i:28707;s:12:\"delete-29467\";i:28708;s:12:\"delete-29468\";i:28709;s:12:\"delete-29471\";i:28710;s:12:\"delete-29472\";i:28711;s:12:\"delete-29469\";i:28712;s:12:\"delete-29470\";i:28713;s:12:\"delete-29473\";i:28714;s:12:\"delete-29474\";i:28715;s:12:\"delete-29477\";i:28716;s:12:\"delete-29478\";i:28717;s:12:\"delete-29475\";i:28718;s:12:\"delete-29476\";i:28719;s:12:\"delete-29479\";i:28720;s:12:\"delete-29480\";i:28721;s:12:\"delete-29483\";i:28722;s:12:\"delete-29484\";i:28723;s:12:\"delete-29481\";i:28724;s:12:\"delete-29482\";i:28725;s:12:\"delete-29485\";i:28726;s:12:\"delete-29486\";i:28727;s:12:\"delete-29489\";i:28728;s:12:\"delete-29490\";i:28729;s:12:\"delete-29487\";i:28730;s:12:\"delete-29488\";i:28731;s:12:\"delete-29491\";i:28732;s:12:\"delete-29492\";i:28733;s:12:\"delete-29495\";i:28734;s:12:\"delete-29496\";i:28735;s:12:\"delete-29497\";i:28736;s:12:\"delete-29498\";i:28737;s:12:\"delete-29501\";i:28738;s:12:\"delete-29502\";i:28739;s:12:\"delete-29493\";i:28740;s:12:\"delete-29494\";i:28741;s:12:\"delete-29499\";i:28742;s:12:\"delete-29500\";i:28743;s:12:\"delete-29503\";i:28744;s:12:\"delete-29504\";i:28745;s:12:\"delete-29505\";i:28746;s:12:\"delete-29506\";i:28747;s:12:\"delete-29507\";i:28748;s:12:\"delete-29508\";i:28749;s:12:\"delete-29509\";i:28750;s:12:\"delete-29510\";i:28751;s:12:\"delete-29513\";i:28752;s:12:\"delete-29511\";i:28753;s:12:\"delete-29512\";i:28754;s:12:\"delete-29514\";i:28755;s:12:\"delete-29515\";i:28756;s:12:\"delete-29516\";i:28757;s:12:\"delete-29519\";i:28758;s:12:\"delete-29520\";i:28759;s:12:\"delete-29517\";i:28760;s:12:\"delete-29518\";i:28761;s:12:\"delete-29521\";i:28762;s:12:\"delete-29522\";i:28763;s:12:\"delete-29525\";i:28764;s:12:\"delete-29526\";i:28765;s:12:\"delete-29523\";i:28766;s:12:\"delete-29524\";i:28767;s:12:\"delete-29527\";i:28768;s:12:\"delete-29528\";i:28769;s:12:\"delete-29531\";i:28770;s:12:\"delete-29529\";i:28771;s:12:\"delete-29530\";i:28772;s:12:\"delete-29532\";i:28773;s:12:\"delete-29533\";i:28774;s:12:\"delete-29534\";i:28775;s:12:\"delete-29537\";i:28776;s:12:\"delete-29538\";i:28777;s:12:\"delete-29535\";i:28778;s:12:\"delete-29536\";i:28779;s:12:\"delete-29539\";i:28780;s:12:\"delete-29540\";i:28781;s:12:\"delete-29541\";i:28782;s:12:\"delete-29542\";i:28783;s:12:\"delete-29543\";i:28784;s:12:\"delete-29544\";i:28785;s:12:\"delete-29545\";i:28786;s:12:\"delete-29546\";i:28787;s:12:\"delete-29549\";i:28788;s:12:\"delete-29550\";i:28789;s:12:\"delete-29547\";i:28790;s:12:\"delete-29548\";i:28791;s:12:\"delete-29551\";i:28792;s:12:\"delete-29552\";i:28793;s:12:\"delete-29553\";i:28794;s:12:\"delete-29554\";i:28795;s:12:\"delete-29555\";i:28796;s:12:\"delete-29556\";i:28797;s:12:\"delete-29557\";i:28798;s:12:\"delete-29558\";i:28799;s:12:\"delete-29561\";i:28800;s:12:\"delete-29559\";i:28801;s:12:\"delete-29560\";i:28802;s:12:\"delete-29562\";i:28803;s:12:\"delete-29563\";i:28804;s:12:\"delete-29564\";i:28805;s:12:\"delete-29565\";i:28806;s:12:\"delete-29566\";i:28807;s:12:\"delete-29567\";i:28808;s:12:\"delete-29568\";i:28809;s:12:\"delete-29569\";i:28810;s:12:\"delete-29570\";i:28811;s:12:\"delete-29573\";i:28812;s:12:\"delete-29574\";i:28813;s:12:\"delete-29571\";i:28814;s:12:\"delete-29572\";i:28815;s:12:\"delete-29575\";i:28816;s:12:\"delete-29576\";i:28817;s:12:\"delete-29579\";i:28818;s:12:\"delete-29577\";i:28819;s:12:\"delete-29578\";i:28820;s:12:\"delete-29580\";i:28821;s:12:\"delete-29581\";i:28822;s:12:\"delete-29582\";i:28823;s:12:\"delete-29583\";i:28824;s:12:\"delete-29584\";i:28825;s:12:\"delete-29585\";i:28826;s:12:\"delete-29586\";i:28827;s:12:\"delete-29587\";i:28828;s:12:\"delete-29588\";i:28829;s:12:\"delete-29591\";i:28830;s:12:\"delete-29592\";i:28831;s:12:\"delete-29589\";i:28832;s:12:\"delete-29590\";i:28833;s:12:\"delete-29593\";i:28834;s:12:\"delete-29594\";i:28835;s:12:\"delete-29597\";i:28836;s:12:\"delete-29595\";i:28837;s:12:\"delete-29596\";i:28838;s:12:\"delete-29598\";i:28839;s:12:\"delete-29599\";i:28840;s:12:\"delete-29600\";i:28841;s:12:\"delete-29603\";i:28842;s:12:\"delete-29604\";i:28843;s:12:\"delete-29601\";i:28844;s:12:\"delete-29602\";i:28845;s:12:\"delete-29605\";i:28846;s:12:\"delete-29606\";i:28847;s:12:\"delete-29609\";i:28848;s:12:\"delete-29607\";i:28849;s:12:\"delete-29608\";i:28850;s:12:\"delete-29610\";i:28851;s:12:\"delete-29611\";i:28852;s:12:\"delete-29612\";i:28853;s:12:\"delete-29615\";i:28854;s:12:\"delete-29613\";i:28855;s:12:\"delete-29614\";i:28856;s:12:\"delete-29616\";i:28857;s:12:\"delete-29617\";i:28858;s:12:\"delete-29618\";i:28859;s:12:\"delete-29621\";i:28860;s:12:\"delete-29622\";i:28861;s:12:\"delete-29623\";i:28862;s:12:\"delete-29624\";i:28863;s:12:\"delete-29627\";i:28864;s:12:\"delete-29628\";i:28865;s:12:\"delete-29619\";i:28866;s:12:\"delete-29620\";i:28867;s:12:\"delete-29625\";i:28868;s:12:\"delete-29626\";i:28869;s:12:\"delete-29629\";i:28870;s:12:\"delete-29630\";i:28871;s:12:\"delete-29631\";i:28872;s:12:\"delete-29632\";i:28873;s:12:\"delete-29633\";i:28874;s:12:\"delete-29634\";i:28875;s:12:\"delete-29635\";i:28876;s:12:\"delete-29636\";i:28877;s:12:\"delete-29639\";i:28878;s:12:\"delete-29640\";i:28879;s:12:\"delete-29637\";i:28880;s:12:\"delete-29638\";i:28881;s:12:\"delete-29641\";i:28882;s:12:\"delete-29642\";i:28883;s:12:\"delete-29645\";i:28884;s:12:\"delete-29643\";i:28885;s:12:\"delete-29644\";i:28886;s:12:\"delete-29646\";i:28887;s:12:\"delete-29647\";i:28888;s:12:\"delete-29648\";i:28889;s:12:\"delete-29651\";i:28890;s:12:\"delete-29652\";i:28891;s:12:\"delete-29649\";i:28892;s:12:\"delete-29650\";i:28893;s:12:\"delete-29653\";i:28894;s:12:\"delete-29654\";i:28895;s:12:\"delete-29657\";i:28896;s:12:\"delete-29655\";i:28897;s:12:\"delete-29656\";i:28898;s:12:\"delete-29658\";i:28899;s:12:\"delete-29659\";i:28900;s:12:\"delete-29660\";i:28901;s:12:\"delete-29663\";i:28902;s:12:\"delete-29661\";i:28903;s:12:\"delete-29662\";i:28904;s:12:\"delete-29664\";i:28905;s:12:\"delete-29665\";i:28906;s:12:\"delete-29666\";i:28907;s:12:\"delete-29667\";i:28908;s:12:\"delete-29668\";i:28909;s:12:\"delete-29669\";i:28910;s:12:\"delete-29670\";i:28911;s:12:\"delete-29671\";i:28912;s:12:\"delete-29672\";i:28913;s:12:\"delete-29675\";i:28914;s:12:\"delete-29676\";i:28915;s:12:\"delete-29673\";i:28916;s:12:\"delete-29674\";i:28917;s:12:\"delete-29677\";i:28918;s:12:\"delete-29678\";i:28919;s:12:\"delete-29681\";i:28920;s:12:\"delete-29679\";i:28921;s:12:\"delete-29680\";i:28922;s:12:\"delete-29682\";i:28923;s:12:\"delete-29683\";i:28924;s:12:\"delete-29684\";i:28925;s:12:\"delete-29687\";i:28926;s:12:\"delete-29688\";i:28927;s:12:\"delete-29685\";i:28928;s:12:\"delete-29686\";i:28929;s:12:\"delete-29689\";i:28930;s:12:\"delete-29690\";i:28931;s:12:\"delete-29693\";i:28932;s:12:\"delete-29694\";i:28933;s:12:\"delete-29691\";i:28934;s:12:\"delete-29692\";i:28935;s:12:\"delete-29695\";i:28936;s:12:\"delete-29696\";i:28937;s:12:\"delete-29697\";i:28938;s:12:\"delete-29698\";i:28939;s:12:\"delete-29699\";i:28940;s:12:\"delete-29700\";i:28941;s:12:\"delete-29701\";i:28942;s:12:\"delete-29702\";i:28943;s:12:\"delete-29705\";i:28944;s:12:\"delete-29703\";i:28945;s:12:\"delete-29704\";i:28946;s:12:\"delete-29706\";i:28947;s:12:\"delete-29707\";i:28948;s:12:\"delete-29708\";i:28949;s:12:\"delete-29711\";i:28950;s:12:\"delete-29712\";i:28951;s:12:\"delete-29709\";i:28952;s:12:\"delete-29710\";i:28953;s:12:\"delete-29713\";i:28954;s:12:\"delete-29714\";i:28955;s:12:\"delete-29717\";i:28956;s:12:\"delete-29718\";i:28957;s:12:\"delete-29715\";i:28958;s:12:\"delete-29716\";i:28959;s:12:\"delete-29719\";i:28960;s:12:\"delete-29720\";i:28961;s:12:\"delete-29723\";i:28962;s:12:\"delete-29724\";i:28963;s:12:\"delete-29721\";i:28964;s:12:\"delete-29722\";i:28965;s:12:\"delete-29725\";i:28966;s:12:\"delete-29726\";i:28967;s:12:\"delete-29729\";i:28968;s:12:\"delete-29727\";i:28969;s:12:\"delete-29728\";i:28970;s:12:\"delete-29730\";i:28971;s:12:\"delete-29731\";i:28972;s:12:\"delete-29732\";i:28973;s:12:\"delete-29735\";i:28974;s:12:\"delete-29736\";i:28975;s:12:\"delete-29733\";i:28976;s:12:\"delete-29734\";i:28977;s:12:\"delete-29737\";i:28978;s:12:\"delete-29738\";i:28979;s:12:\"delete-29741\";i:28980;s:12:\"delete-29742\";i:28981;s:12:\"delete-29739\";i:28982;s:12:\"delete-29740\";i:28983;s:12:\"delete-29743\";i:28984;s:12:\"delete-29744\";i:28985;s:12:\"delete-29747\";i:28986;s:12:\"delete-29748\";i:28987;s:12:\"delete-29745\";i:28988;s:12:\"delete-29746\";i:28989;s:12:\"delete-29749\";i:28990;s:12:\"delete-29750\";i:28991;s:12:\"delete-29751\";i:28992;s:12:\"delete-29752\";i:28993;s:12:\"delete-29753\";i:28994;s:12:\"delete-29754\";i:28995;s:12:\"delete-29755\";i:28996;s:12:\"delete-29756\";i:28997;s:12:\"delete-29757\";i:28998;s:12:\"delete-29758\";i:28999;s:12:\"delete-29759\";i:29000;s:12:\"delete-29760\";i:29001;s:12:\"delete-29761\";i:29002;s:12:\"delete-29762\";i:29003;s:12:\"delete-29765\";i:29004;s:12:\"delete-29766\";i:29005;s:12:\"delete-29763\";i:29006;s:12:\"delete-29764\";i:29007;s:12:\"delete-29767\";i:29008;s:12:\"delete-29768\";i:29009;s:12:\"delete-29771\";i:29010;s:12:\"delete-29769\";i:29011;s:12:\"delete-29770\";i:29012;s:12:\"delete-29772\";i:29013;s:12:\"delete-29773\";i:29014;s:12:\"delete-29774\";i:29015;s:12:\"delete-29775\";i:29016;s:12:\"delete-29776\";i:29017;s:12:\"delete-29777\";i:29018;s:12:\"delete-29778\";i:29019;s:12:\"delete-29779\";i:29020;s:12:\"delete-29780\";i:29021;s:12:\"delete-29783\";i:29022;s:12:\"delete-29784\";i:29023;s:12:\"delete-29781\";i:29024;s:12:\"delete-29782\";i:29025;s:12:\"delete-29785\";i:29026;s:12:\"delete-29786\";i:29027;s:12:\"delete-29789\";i:29028;s:12:\"delete-29787\";i:29029;s:12:\"delete-29788\";i:29030;s:12:\"delete-29790\";i:29031;s:12:\"delete-29791\";i:29032;s:12:\"delete-29792\";i:29033;s:12:\"delete-29795\";i:29034;s:12:\"delete-29796\";i:29035;s:12:\"delete-29793\";i:29036;s:12:\"delete-29794\";i:29037;s:12:\"delete-29797\";i:29038;s:12:\"delete-29798\";i:29039;s:12:\"delete-29801\";i:29040;s:12:\"delete-29802\";i:29041;s:12:\"delete-29799\";i:29042;s:12:\"delete-29800\";i:29043;s:12:\"delete-29803\";i:29044;s:12:\"delete-29804\";i:29045;s:12:\"delete-29807\";i:29046;s:12:\"delete-29808\";i:29047;s:12:\"delete-29805\";i:29048;s:12:\"delete-29806\";i:29049;s:12:\"delete-29809\";i:29050;s:12:\"delete-29810\";i:29051;s:12:\"delete-29813\";i:29052;s:12:\"delete-29811\";i:29053;s:12:\"delete-29812\";i:29054;s:12:\"delete-29814\";i:29055;s:12:\"delete-29815\";i:29056;s:12:\"delete-29816\";i:29057;s:12:\"delete-29819\";i:29058;s:12:\"delete-29820\";i:29059;s:12:\"delete-29817\";i:29060;s:12:\"delete-29818\";i:29061;s:12:\"delete-29821\";i:29062;s:12:\"delete-29822\";i:29063;s:12:\"delete-29825\";i:29064;s:12:\"delete-29823\";i:29065;s:12:\"delete-29824\";i:29066;s:12:\"delete-29826\";i:29067;s:12:\"delete-29827\";i:29068;s:12:\"delete-29828\";i:29069;s:12:\"delete-29829\";i:29070;s:12:\"delete-29830\";i:29071;s:12:\"delete-29831\";i:29072;s:12:\"delete-29832\";i:29073;s:12:\"delete-29833\";i:29074;s:12:\"delete-29834\";i:29075;s:12:\"delete-29837\";i:29076;s:12:\"delete-29838\";i:29077;s:12:\"delete-29835\";i:29078;s:12:\"delete-29836\";i:29079;s:12:\"delete-29839\";i:29080;s:12:\"delete-29840\";i:29081;s:12:\"delete-29843\";i:29082;s:12:\"delete-29841\";i:29083;s:12:\"delete-29842\";i:29084;s:12:\"delete-29844\";i:29085;s:12:\"delete-29845\";i:29086;s:12:\"delete-29846\";i:29087;s:12:\"delete-29849\";i:29088;s:12:\"delete-29847\";i:29089;s:12:\"delete-29848\";i:29090;s:12:\"delete-29850\";i:29091;s:12:\"delete-29851\";i:29092;s:12:\"delete-29852\";i:29093;s:12:\"delete-29855\";i:29094;s:12:\"delete-29853\";i:29095;s:12:\"delete-29854\";i:29096;s:12:\"delete-29856\";i:29097;s:12:\"delete-29857\";i:29098;s:12:\"delete-29858\";i:29099;s:12:\"delete-29861\";i:29100;s:12:\"delete-29862\";i:29101;s:12:\"delete-29859\";i:29102;s:12:\"delete-29860\";i:29103;s:12:\"delete-29863\";i:29104;s:12:\"delete-29864\";i:29105;s:12:\"delete-29867\";i:29106;s:12:\"delete-29865\";i:29107;s:12:\"delete-29866\";i:29108;s:12:\"delete-29868\";i:29109;s:12:\"delete-29869\";i:29110;s:12:\"delete-29870\";i:29111;s:12:\"delete-29871\";i:29112;s:12:\"delete-29872\";i:29113;s:12:\"delete-29873\";i:29114;s:12:\"delete-29874\";i:29115;s:12:\"delete-29875\";i:29116;s:12:\"delete-29876\";i:29117;s:12:\"delete-29877\";i:29118;s:12:\"delete-29878\";i:29119;s:12:\"delete-29879\";i:29120;s:12:\"delete-29880\";i:29121;s:12:\"delete-29881\";i:29122;s:12:\"delete-29882\";i:29123;s:12:\"delete-29885\";i:29124;s:12:\"delete-29883\";i:29125;s:12:\"delete-29884\";i:29126;s:12:\"delete-29886\";i:29127;s:12:\"delete-29887\";i:29128;s:12:\"delete-29888\";i:29129;s:12:\"delete-29891\";i:29130;s:12:\"delete-29892\";i:29131;s:12:\"delete-29889\";i:29132;s:12:\"delete-29890\";i:29133;s:12:\"delete-29893\";i:29134;s:12:\"delete-29894\";i:29135;s:12:\"delete-29897\";i:29136;s:12:\"delete-29898\";i:29137;s:12:\"delete-29895\";i:29138;s:12:\"delete-29896\";i:29139;s:12:\"delete-29899\";i:29140;s:12:\"delete-29900\";i:29141;s:12:\"delete-29903\";i:29142;s:12:\"delete-29904\";i:29143;s:12:\"delete-29901\";i:29144;s:12:\"delete-29902\";i:29145;s:12:\"delete-29905\";i:29146;s:12:\"delete-29906\";i:29147;s:12:\"delete-29907\";i:29148;s:12:\"delete-29908\";i:29149;s:12:\"delete-29909\";i:29150;s:12:\"delete-29910\";i:29151;s:12:\"delete-29911\";i:29152;s:12:\"delete-29912\";i:29153;s:12:\"delete-29915\";i:29154;s:12:\"delete-29916\";i:29155;s:12:\"delete-29913\";i:29156;s:12:\"delete-29914\";i:29157;s:12:\"delete-29917\";i:29158;s:12:\"delete-29918\";i:29159;s:12:\"delete-29921\";i:29160;s:12:\"delete-29919\";i:29161;s:12:\"delete-29920\";i:29162;s:12:\"delete-29922\";i:29163;s:12:\"delete-29923\";i:29164;s:12:\"delete-29924\";i:29165;s:12:\"delete-29927\";i:29166;s:12:\"delete-29928\";i:29167;s:12:\"delete-29925\";i:29168;s:12:\"delete-29926\";i:29169;s:12:\"delete-29929\";i:29170;s:12:\"delete-29930\";i:29171;s:12:\"delete-29933\";i:29172;s:12:\"delete-29934\";i:29173;s:12:\"delete-29931\";i:29174;s:12:\"delete-29932\";i:29175;s:12:\"delete-29935\";i:29176;s:12:\"delete-29936\";i:29177;s:12:\"delete-29937\";i:29178;s:12:\"delete-29938\";i:29179;s:12:\"delete-29939\";i:29180;s:12:\"delete-29940\";i:29181;s:12:\"delete-29941\";i:29182;s:12:\"delete-29942\";i:29183;s:12:\"delete-29945\";i:29184;s:12:\"delete-29946\";i:29185;s:12:\"delete-29943\";i:29186;s:12:\"delete-29944\";i:29187;s:12:\"delete-29947\";i:29188;s:12:\"delete-29948\";i:29189;s:12:\"delete-29951\";i:29190;s:12:\"delete-29952\";i:29191;s:12:\"delete-29949\";i:29192;s:12:\"delete-29950\";i:29193;s:12:\"delete-29953\";i:29194;s:12:\"delete-29954\";i:29195;s:12:\"delete-29957\";i:29196;s:12:\"delete-29958\";i:29197;s:12:\"delete-29955\";i:29198;s:12:\"delete-29956\";i:29199;s:12:\"delete-29959\";i:29200;s:12:\"delete-29960\";i:29201;s:12:\"delete-29963\";i:29202;s:12:\"delete-29964\";i:29203;s:12:\"delete-29961\";i:29204;s:12:\"delete-29962\";i:29205;s:12:\"delete-29965\";i:29206;s:12:\"delete-29966\";i:29207;s:12:\"delete-29969\";i:29208;s:12:\"delete-29970\";i:29209;s:12:\"delete-29967\";i:29210;s:12:\"delete-29968\";i:29211;s:12:\"delete-29971\";i:29212;s:12:\"delete-29972\";i:29213;s:12:\"delete-29975\";i:29214;s:12:\"delete-29973\";i:29215;s:12:\"delete-29974\";i:29216;s:12:\"delete-29976\";i:29217;s:12:\"delete-29977\";i:29218;s:12:\"delete-29978\";i:29219;s:12:\"delete-29981\";i:29220;s:12:\"delete-29979\";i:29221;s:12:\"delete-29980\";i:29222;s:12:\"delete-29982\";i:29223;s:12:\"delete-29983\";i:29224;s:12:\"delete-29984\";i:29225;s:12:\"delete-29987\";i:29226;s:12:\"delete-29988\";i:29227;s:12:\"delete-29985\";i:29228;s:12:\"delete-29986\";i:29229;s:12:\"delete-29989\";i:29230;s:12:\"delete-29990\";i:29231;s:12:\"delete-29993\";i:29232;s:12:\"delete-29994\";i:29233;s:12:\"delete-29991\";i:29234;s:12:\"delete-29992\";i:29235;s:12:\"delete-29995\";i:29236;s:12:\"delete-29996\";i:29237;s:12:\"delete-29999\";i:29238;s:12:\"delete-30000\";i:29239;s:12:\"delete-29997\";i:29240;s:12:\"delete-29998\";i:29241;s:12:\"delete-30001\";i:29242;s:12:\"delete-30002\";i:29243;s:12:\"delete-30005\";i:29244;s:12:\"delete-30006\";i:29245;s:12:\"delete-30003\";i:29246;s:12:\"delete-30004\";i:29247;s:12:\"delete-30007\";i:29248;s:12:\"delete-30008\";i:29249;s:12:\"delete-30011\";i:29250;s:12:\"delete-30012\";i:29251;s:12:\"delete-30009\";i:29252;s:12:\"delete-30010\";i:29253;s:12:\"delete-30013\";i:29254;s:12:\"delete-30014\";i:29255;s:12:\"delete-30017\";i:29256;s:12:\"delete-30018\";i:29257;s:12:\"delete-30015\";i:29258;s:12:\"delete-30016\";i:29259;s:12:\"delete-30019\";i:29260;s:12:\"delete-30020\";i:29261;s:12:\"delete-30023\";i:29262;s:12:\"delete-30021\";i:29263;s:12:\"delete-30022\";i:29264;s:12:\"delete-30024\";i:29265;s:12:\"delete-30025\";i:29266;s:12:\"delete-30026\";i:29267;s:12:\"delete-30029\";i:29268;s:12:\"delete-30030\";i:29269;s:12:\"delete-30027\";i:29270;s:12:\"delete-30028\";i:29271;s:12:\"delete-30031\";i:29272;s:12:\"delete-30032\";i:29273;s:12:\"delete-30035\";i:29274;s:12:\"delete-30036\";i:29275;s:12:\"delete-30033\";i:29276;s:12:\"delete-30034\";i:29277;s:12:\"delete-30037\";i:29278;s:12:\"delete-30038\";i:29279;s:12:\"delete-30041\";i:29280;s:12:\"delete-30042\";i:29281;s:12:\"delete-30039\";i:29282;s:12:\"delete-30040\";i:29283;s:12:\"delete-30043\";i:29284;s:12:\"delete-30044\";i:29285;s:12:\"delete-30047\";i:29286;s:12:\"delete-30048\";i:29287;s:12:\"delete-30045\";i:29288;s:12:\"delete-30046\";i:29289;s:12:\"delete-30049\";i:29290;s:12:\"delete-30050\";i:29291;s:12:\"delete-30053\";i:29292;s:12:\"delete-30054\";i:29293;s:12:\"delete-30051\";i:29294;s:12:\"delete-30052\";i:29295;s:12:\"delete-30055\";i:29296;s:12:\"delete-30056\";i:29297;s:12:\"delete-30059\";i:29298;s:12:\"delete-30060\";i:29299;s:12:\"delete-30057\";i:29300;s:12:\"delete-30058\";i:29301;s:12:\"delete-30061\";i:29302;s:12:\"delete-30062\";i:29303;s:12:\"delete-30065\";i:29304;s:12:\"delete-30066\";i:29305;s:12:\"delete-30063\";i:29306;s:12:\"delete-30064\";i:29307;s:12:\"delete-30067\";i:29308;s:12:\"delete-30068\";i:29309;s:12:\"delete-30071\";i:29310;s:12:\"delete-30072\";i:29311;s:12:\"delete-30069\";i:29312;s:12:\"delete-30070\";i:29313;s:12:\"delete-30073\";i:29314;s:12:\"delete-30074\";i:29315;s:12:\"delete-30077\";i:29316;s:12:\"delete-30078\";i:29317;s:12:\"delete-30075\";i:29318;s:12:\"delete-30076\";i:29319;s:12:\"delete-30079\";i:29320;s:12:\"delete-30080\";i:29321;s:12:\"delete-30083\";i:29322;s:12:\"delete-30084\";i:29323;s:12:\"delete-30081\";i:29324;s:12:\"delete-30082\";i:29325;s:12:\"delete-30085\";i:29326;s:12:\"delete-30086\";i:29327;s:12:\"delete-30087\";i:29328;s:12:\"delete-30088\";i:29329;s:12:\"delete-30089\";i:29330;s:12:\"delete-30090\";i:29331;s:12:\"delete-30091\";i:29332;s:12:\"delete-30092\";i:29333;s:12:\"delete-30095\";i:29334;s:12:\"delete-30093\";i:29335;s:12:\"delete-30094\";i:29336;s:12:\"delete-30096\";i:29337;s:12:\"delete-30097\";i:29338;s:12:\"delete-30098\";i:29339;s:12:\"delete-30101\";i:29340;s:12:\"delete-30099\";i:29341;s:12:\"delete-30100\";i:29342;s:12:\"delete-30102\";i:29343;s:12:\"delete-30103\";i:29344;s:12:\"delete-30104\";i:29345;s:12:\"delete-30107\";i:29346;s:12:\"delete-30108\";i:29347;s:12:\"delete-30105\";i:29348;s:12:\"delete-30106\";i:29349;s:12:\"delete-30109\";i:29350;s:12:\"delete-30110\";i:29351;s:12:\"delete-30113\";i:29352;s:12:\"delete-30114\";i:29353;s:12:\"delete-30111\";i:29354;s:12:\"delete-30112\";i:29355;s:12:\"delete-30115\";i:29356;s:12:\"delete-30116\";i:29357;s:12:\"delete-30119\";i:29358;s:12:\"delete-30120\";i:29359;s:12:\"delete-30117\";i:29360;s:12:\"delete-30118\";i:29361;s:12:\"delete-30121\";i:29362;s:12:\"delete-30122\";i:29363;s:12:\"delete-30125\";i:29364;s:12:\"delete-30123\";i:29365;s:12:\"delete-30124\";i:29366;s:12:\"delete-30126\";i:29367;s:12:\"delete-30127\";i:29368;s:12:\"delete-30128\";i:29369;s:12:\"delete-30131\";i:29370;s:12:\"delete-30129\";i:29371;s:12:\"delete-30130\";i:29372;s:12:\"delete-30132\";i:29373;s:12:\"delete-30133\";i:29374;s:12:\"delete-30134\";i:29375;s:12:\"delete-30135\";i:29376;s:12:\"delete-30136\";i:29377;s:12:\"delete-30137\";i:29378;s:12:\"delete-30138\";i:29379;s:12:\"delete-30139\";i:29380;s:12:\"delete-30140\";i:29381;s:12:\"delete-30143\";i:29382;s:12:\"delete-30141\";i:29383;s:12:\"delete-30142\";i:29384;s:12:\"delete-30144\";i:29385;s:12:\"delete-30145\";i:29386;s:12:\"delete-30146\";i:29387;s:12:\"delete-30149\";i:29388;s:12:\"delete-30150\";i:29389;s:12:\"delete-30147\";i:29390;s:12:\"delete-30148\";i:29391;s:12:\"delete-30151\";i:29392;s:12:\"delete-30152\";i:29393;s:12:\"delete-30155\";i:29394;s:12:\"delete-30156\";i:29395;s:12:\"delete-30153\";i:29396;s:12:\"delete-30154\";i:29397;s:12:\"delete-30157\";i:29398;s:12:\"delete-30158\";i:29399;s:12:\"delete-30161\";i:29400;s:12:\"delete-30159\";i:29401;s:12:\"delete-30160\";i:29402;s:12:\"delete-30162\";i:29403;s:12:\"delete-30163\";i:29404;s:12:\"delete-30164\";i:29405;s:12:\"delete-30167\";i:29406;s:12:\"delete-30168\";i:29407;s:12:\"delete-30165\";i:29408;s:12:\"delete-30166\";i:29409;s:12:\"delete-30169\";i:29410;s:12:\"delete-30170\";i:29411;s:12:\"delete-30173\";i:29412;s:12:\"delete-30171\";i:29413;s:12:\"delete-30172\";i:29414;s:12:\"delete-30174\";i:29415;s:12:\"delete-30175\";i:29416;s:12:\"delete-30176\";i:29417;s:12:\"delete-30179\";i:29418;s:12:\"delete-30180\";i:29419;s:12:\"delete-30177\";i:29420;s:12:\"delete-30178\";i:29421;s:12:\"delete-30181\";i:29422;s:12:\"delete-30182\";i:29423;s:12:\"delete-30183\";i:29424;s:12:\"delete-30184\";i:29425;s:12:\"delete-30185\";i:29426;s:12:\"delete-30186\";i:29427;s:12:\"delete-30187\";i:29428;s:12:\"delete-30188\";i:29429;s:12:\"delete-30189\";i:29430;s:12:\"delete-30190\";i:29431;s:12:\"delete-30191\";i:29432;s:12:\"delete-30192\";i:29433;s:12:\"delete-30193\";i:29434;s:12:\"delete-30194\";i:29435;s:12:\"delete-30197\";i:29436;s:12:\"delete-30195\";i:29437;s:12:\"delete-30196\";i:29438;s:12:\"delete-30198\";i:29439;s:12:\"delete-30199\";i:29440;s:12:\"delete-30200\";i:29441;s:12:\"delete-30203\";i:29442;s:12:\"delete-30201\";i:29443;s:12:\"delete-30202\";i:29444;s:12:\"delete-30204\";i:29445;s:12:\"delete-30205\";i:29446;s:12:\"delete-30206\";i:29447;s:12:\"delete-30209\";i:29448;s:12:\"delete-30207\";i:29449;s:12:\"delete-30208\";i:29450;s:12:\"delete-30210\";i:29451;s:12:\"delete-30211\";i:29452;s:12:\"delete-30212\";i:29453;s:12:\"delete-30215\";i:29454;s:12:\"delete-30216\";i:29455;s:12:\"delete-30213\";i:29456;s:12:\"delete-30214\";i:29457;s:12:\"delete-30217\";i:29458;s:12:\"delete-30218\";i:29459;s:12:\"delete-30221\";i:29460;s:12:\"delete-30222\";i:29461;s:12:\"delete-30219\";i:29462;s:12:\"delete-30220\";i:29463;s:12:\"delete-30223\";i:29464;s:12:\"delete-30224\";i:29465;s:12:\"delete-30227\";i:29466;s:12:\"delete-30228\";i:29467;s:12:\"delete-30225\";i:29468;s:12:\"delete-30226\";i:29469;s:12:\"delete-30229\";i:29470;s:12:\"delete-30230\";i:29471;s:12:\"delete-30233\";i:29472;s:12:\"delete-30231\";i:29473;s:12:\"delete-30232\";i:29474;s:12:\"delete-30234\";i:29475;s:12:\"delete-30235\";i:29476;s:12:\"delete-30236\";i:29477;s:12:\"delete-30239\";i:29478;s:12:\"delete-30240\";i:29479;s:12:\"delete-30237\";i:29480;s:12:\"delete-30238\";i:29481;s:12:\"delete-30241\";i:29482;s:12:\"delete-30242\";i:29483;s:12:\"delete-30245\";i:29484;s:12:\"delete-30243\";i:29485;s:12:\"delete-30244\";i:29486;s:12:\"delete-30246\";i:29487;s:12:\"delete-30247\";i:29488;s:12:\"delete-30248\";i:29489;s:12:\"delete-30251\";i:29490;s:12:\"delete-30252\";i:29491;s:12:\"delete-30253\";i:29492;s:12:\"delete-30254\";i:29493;s:12:\"delete-30249\";i:29494;s:12:\"delete-30250\";i:29495;s:12:\"delete-30255\";i:29496;s:12:\"delete-30256\";i:29497;s:12:\"delete-30257\";i:29498;s:12:\"delete-30258\";i:29499;s:12:\"delete-30259\";i:29500;s:12:\"delete-30260\";i:29501;s:12:\"delete-30263\";i:29502;s:12:\"delete-30264\";i:29503;s:12:\"delete-30261\";i:29504;s:12:\"delete-30262\";i:29505;s:12:\"delete-30265\";i:29506;s:12:\"delete-30266\";i:29507;s:12:\"delete-30269\";i:29508;s:12:\"delete-30270\";i:29509;s:12:\"delete-30267\";i:29510;s:12:\"delete-30268\";i:29511;s:12:\"delete-30271\";i:29512;s:12:\"delete-30272\";i:29513;s:12:\"delete-30275\";i:29514;s:12:\"delete-30276\";i:29515;s:12:\"delete-30273\";i:29516;s:12:\"delete-30274\";i:29517;s:12:\"delete-30277\";i:29518;s:12:\"delete-30278\";i:29519;s:12:\"delete-30279\";i:29520;s:12:\"delete-30280\";i:29521;s:12:\"delete-30281\";i:29522;s:12:\"delete-30282\";i:29523;s:12:\"delete-30283\";i:29524;s:12:\"delete-30284\";i:29525;s:12:\"delete-30287\";i:29526;s:12:\"delete-30288\";i:29527;s:12:\"delete-30285\";i:29528;s:12:\"delete-30286\";i:29529;s:12:\"delete-30289\";i:29530;s:12:\"delete-30290\";i:29531;s:12:\"delete-30291\";i:29532;s:12:\"delete-30292\";i:29533;s:12:\"delete-30293\";i:29534;s:12:\"delete-30294\";i:29535;s:12:\"delete-30295\";i:29536;s:12:\"delete-30296\";i:29537;s:12:\"delete-30299\";i:29538;s:12:\"delete-30300\";i:29539;s:12:\"delete-30297\";i:29540;s:12:\"delete-30298\";i:29541;s:12:\"delete-30301\";i:29542;s:12:\"delete-30302\";i:29543;s:12:\"delete-30305\";i:29544;s:12:\"delete-30303\";i:29545;s:12:\"delete-30304\";i:29546;s:12:\"delete-30306\";i:29547;s:12:\"delete-30307\";i:29548;s:12:\"delete-30308\";i:29549;s:12:\"delete-30311\";i:29550;s:12:\"delete-30312\";i:29551;s:12:\"delete-30309\";i:29552;s:12:\"delete-30310\";i:29553;s:12:\"delete-30313\";i:29554;s:12:\"delete-30314\";i:29555;s:12:\"delete-30317\";i:29556;s:12:\"delete-30315\";i:29557;s:12:\"delete-30316\";i:29558;s:12:\"delete-30318\";i:29559;s:12:\"delete-30319\";i:29560;s:12:\"delete-30320\";i:29561;s:12:\"delete-30323\";i:29562;s:12:\"delete-30321\";i:29563;s:12:\"delete-30322\";i:29564;s:12:\"delete-30324\";i:29565;s:12:\"delete-30325\";i:29566;s:12:\"delete-30326\";i:29567;s:12:\"delete-30329\";i:29568;s:12:\"delete-30330\";i:29569;s:12:\"delete-30327\";i:29570;s:12:\"delete-30328\";i:29571;s:12:\"delete-30331\";i:29572;s:12:\"delete-30332\";i:29573;s:12:\"delete-30335\";i:29574;s:12:\"delete-30336\";i:29575;s:12:\"delete-30333\";i:29576;s:12:\"delete-30334\";i:29577;s:12:\"delete-30337\";i:29578;s:12:\"delete-30338\";i:29579;s:12:\"delete-30341\";i:29580;s:12:\"delete-30342\";i:29581;s:12:\"delete-30339\";i:29582;s:12:\"delete-30340\";i:29583;s:12:\"delete-30343\";i:29584;s:12:\"delete-30344\";i:29585;s:12:\"delete-30347\";i:29586;s:12:\"delete-30348\";i:29587;s:12:\"delete-30345\";i:29588;s:12:\"delete-30346\";i:29589;s:12:\"delete-30349\";i:29590;s:12:\"delete-30350\";i:29591;s:12:\"delete-30353\";i:29592;s:12:\"delete-30354\";i:29593;s:12:\"delete-30351\";i:29594;s:12:\"delete-30352\";i:29595;s:12:\"delete-30355\";i:29596;s:12:\"delete-30356\";i:29597;s:12:\"delete-30359\";i:29598;s:12:\"delete-30357\";i:29599;s:12:\"delete-30358\";i:29600;s:12:\"delete-30360\";i:29601;s:12:\"delete-30361\";i:29602;s:12:\"delete-30362\";i:29603;s:12:\"delete-30365\";i:29604;s:12:\"delete-30366\";i:29605;s:12:\"delete-30363\";i:29606;s:12:\"delete-30364\";i:29607;s:12:\"delete-30367\";i:29608;s:12:\"delete-30368\";i:29609;s:12:\"delete-30369\";i:29610;s:12:\"delete-30370\";i:29611;s:12:\"delete-30371\";i:29612;s:12:\"delete-30372\";i:29613;s:12:\"delete-30373\";i:29614;s:12:\"delete-30374\";i:29615;s:12:\"delete-30377\";i:29616;s:12:\"delete-30378\";i:29617;s:12:\"delete-30375\";i:29618;s:12:\"delete-30376\";i:29619;s:12:\"delete-30379\";i:29620;s:12:\"delete-30380\";i:29621;s:12:\"delete-30383\";i:29622;s:12:\"delete-30384\";i:29623;s:12:\"delete-30381\";i:29624;s:12:\"delete-30382\";i:29625;s:12:\"delete-30385\";i:29626;s:12:\"delete-30386\";i:29627;s:12:\"delete-30389\";i:29628;s:12:\"delete-30387\";i:29629;s:12:\"delete-30388\";i:29630;s:12:\"delete-30390\";i:29631;s:12:\"delete-30391\";i:29632;s:12:\"delete-30392\";i:29633;s:12:\"delete-30395\";i:29634;s:12:\"delete-30393\";i:29635;s:12:\"delete-30394\";i:29636;s:12:\"delete-30396\";i:29637;s:12:\"delete-30397\";i:29638;s:12:\"delete-30398\";i:29639;s:12:\"delete-30401\";i:29640;s:12:\"delete-30402\";i:29641;s:12:\"delete-30399\";i:29642;s:12:\"delete-30400\";i:29643;s:12:\"delete-30403\";i:29644;s:12:\"delete-30404\";i:29645;s:12:\"delete-30407\";i:29646;s:12:\"delete-30408\";i:29647;s:12:\"delete-30405\";i:29648;s:12:\"delete-30406\";i:29649;s:12:\"delete-30409\";i:29650;s:12:\"delete-30410\";i:29651;s:12:\"delete-30411\";i:29652;s:12:\"delete-30412\";i:29653;s:12:\"delete-30413\";i:29654;s:12:\"delete-30414\";i:29655;s:12:\"delete-30415\";i:29656;s:12:\"delete-30416\";i:29657;s:12:\"delete-30419\";i:29658;s:12:\"delete-30420\";i:29659;s:12:\"delete-30417\";i:29660;s:12:\"delete-30418\";i:29661;s:12:\"delete-30421\";i:29662;s:12:\"delete-30422\";i:29663;s:12:\"delete-30425\";i:29664;s:12:\"delete-30426\";i:29665;s:12:\"delete-30423\";i:29666;s:12:\"delete-30424\";i:29667;s:12:\"delete-30427\";i:29668;s:12:\"delete-30428\";i:29669;s:12:\"delete-30431\";i:29670;s:12:\"delete-30432\";i:29671;s:12:\"delete-30429\";i:29672;s:12:\"delete-30430\";i:29673;s:12:\"delete-30433\";i:29674;s:12:\"delete-30434\";i:29675;s:12:\"delete-30437\";i:29676;s:12:\"delete-30435\";i:29677;s:12:\"delete-30436\";i:29678;s:12:\"delete-30438\";i:29679;s:12:\"delete-30439\";i:29680;s:12:\"delete-30440\";i:29681;s:12:\"delete-30443\";i:29682;s:12:\"delete-30444\";i:29683;s:12:\"delete-30441\";i:29684;s:12:\"delete-30442\";i:29685;s:12:\"delete-30445\";i:29686;s:12:\"delete-30446\";i:29687;s:12:\"delete-30449\";i:29688;s:12:\"delete-30450\";i:29689;s:12:\"delete-30447\";i:29690;s:12:\"delete-30448\";i:29691;s:12:\"delete-30451\";i:29692;s:12:\"delete-30452\";i:29693;s:12:\"delete-30455\";i:29694;s:12:\"delete-30456\";i:29695;s:12:\"delete-30453\";i:29696;s:12:\"delete-30454\";i:29697;s:12:\"delete-30457\";i:29698;s:12:\"delete-30458\";i:29699;s:12:\"delete-30461\";i:29700;s:12:\"delete-30462\";i:29701;s:12:\"delete-30459\";i:29702;s:12:\"delete-30460\";i:29703;s:12:\"delete-30463\";i:29704;s:12:\"delete-30464\";i:29705;s:12:\"delete-30467\";i:29706;s:12:\"delete-30465\";i:29707;s:12:\"delete-30466\";i:29708;s:12:\"delete-30468\";i:29709;s:12:\"delete-30469\";i:29710;s:12:\"delete-30470\";i:29711;s:12:\"delete-30473\";i:29712;s:12:\"delete-30474\";i:29713;s:12:\"delete-30471\";i:29714;s:12:\"delete-30472\";i:29715;s:12:\"delete-30475\";i:29716;s:12:\"delete-30476\";i:29717;s:12:\"delete-30479\";i:29718;s:12:\"delete-30480\";i:29719;s:12:\"delete-30477\";i:29720;s:12:\"delete-30478\";i:29721;s:12:\"delete-30481\";i:29722;s:12:\"delete-30482\";i:29723;s:12:\"delete-30483\";i:29724;s:12:\"delete-30484\";i:29725;s:12:\"delete-30485\";i:29726;s:12:\"delete-30486\";i:29727;s:12:\"delete-30487\";i:29728;s:12:\"delete-30488\";i:29729;s:12:\"delete-30491\";i:29730;s:12:\"delete-30492\";i:29731;s:12:\"delete-30489\";i:29732;s:12:\"delete-30490\";i:29733;s:12:\"delete-30493\";i:29734;s:12:\"delete-30494\";i:29735;s:12:\"delete-30497\";i:29736;s:12:\"delete-30498\";i:29737;s:12:\"delete-30495\";i:29738;s:12:\"delete-30496\";i:29739;s:12:\"delete-30499\";i:29740;s:12:\"delete-30500\";i:29741;s:12:\"delete-30503\";i:29742;s:12:\"delete-30504\";i:29743;s:12:\"delete-30501\";i:29744;s:12:\"delete-30502\";i:29745;s:12:\"delete-30505\";i:29746;s:12:\"delete-30506\";i:29747;s:12:\"delete-30509\";i:29748;s:12:\"delete-30510\";i:29749;s:12:\"delete-30507\";i:29750;s:12:\"delete-30508\";i:29751;s:12:\"delete-30511\";i:29752;s:12:\"delete-30512\";i:29753;s:12:\"delete-30513\";i:29754;s:12:\"delete-30514\";i:29755;s:12:\"delete-30515\";i:29756;s:12:\"delete-30516\";i:29757;s:12:\"delete-30517\";i:29758;s:12:\"delete-30518\";i:29759;s:12:\"delete-30521\";i:29760;s:12:\"delete-30522\";i:29761;s:12:\"delete-30519\";i:29762;s:12:\"delete-30520\";i:29763;s:12:\"delete-30523\";i:29764;s:12:\"delete-30524\";i:29765;s:12:\"delete-30527\";i:29766;s:12:\"delete-30528\";i:29767;s:12:\"delete-30525\";i:29768;s:12:\"delete-30526\";i:29769;s:12:\"delete-30529\";i:29770;s:12:\"delete-30530\";i:29771;s:12:\"delete-30533\";i:29772;s:12:\"delete-30534\";i:29773;s:12:\"delete-30531\";i:29774;s:12:\"delete-30532\";i:29775;s:12:\"delete-30535\";i:29776;s:12:\"delete-30536\";i:29777;s:12:\"delete-30539\";i:29778;s:12:\"delete-30540\";i:29779;s:12:\"delete-30537\";i:29780;s:12:\"delete-30538\";i:29781;s:12:\"delete-30541\";i:29782;s:12:\"delete-30542\";i:29783;s:12:\"delete-30545\";i:29784;s:12:\"delete-30546\";i:29785;s:12:\"delete-30543\";i:29786;s:12:\"delete-30544\";i:29787;s:12:\"delete-30547\";i:29788;s:12:\"delete-30548\";i:29789;s:12:\"delete-30551\";i:29790;s:12:\"delete-30549\";i:29791;s:12:\"delete-30550\";i:29792;s:12:\"delete-30552\";i:29793;s:12:\"delete-30553\";i:29794;s:12:\"delete-30554\";i:29795;s:12:\"delete-30557\";i:29796;s:12:\"delete-30555\";i:29797;s:12:\"delete-30556\";i:29798;s:12:\"delete-30558\";i:29799;s:12:\"delete-30559\";i:29800;s:12:\"delete-30560\";i:29801;s:12:\"delete-30563\";i:29802;s:12:\"delete-30564\";i:29803;s:12:\"delete-30561\";i:29804;s:12:\"delete-30562\";i:29805;s:12:\"delete-30565\";i:29806;s:12:\"delete-30566\";i:29807;s:12:\"delete-30569\";i:29808;s:12:\"delete-30570\";i:29809;s:12:\"delete-30567\";i:29810;s:12:\"delete-30568\";i:29811;s:12:\"delete-30571\";i:29812;s:12:\"delete-30572\";i:29813;s:12:\"delete-30575\";i:29814;s:12:\"delete-30576\";i:29815;s:12:\"delete-30573\";i:29816;s:12:\"delete-30574\";i:29817;s:12:\"delete-30577\";i:29818;s:12:\"delete-30578\";i:29819;s:12:\"delete-30581\";i:29820;s:12:\"delete-30582\";i:29821;s:12:\"delete-30579\";i:29822;s:12:\"delete-30580\";i:29823;s:12:\"delete-30583\";i:29824;s:12:\"delete-30584\";i:29825;s:12:\"delete-30587\";i:29826;s:12:\"delete-30588\";i:29827;s:12:\"delete-30585\";i:29828;s:12:\"delete-30586\";i:29829;s:12:\"delete-30589\";i:29830;s:12:\"delete-30590\";i:29831;s:12:\"delete-30593\";i:29832;s:12:\"delete-30594\";i:29833;s:12:\"delete-30591\";i:29834;s:12:\"delete-30592\";i:29835;s:12:\"delete-30595\";i:29836;s:12:\"delete-30596\";i:29837;s:12:\"delete-30599\";i:29838;s:12:\"delete-30600\";i:29839;s:12:\"delete-30597\";i:29840;s:12:\"delete-30598\";i:29841;s:12:\"delete-30601\";i:29842;s:12:\"delete-30602\";i:29843;s:12:\"delete-30605\";i:29844;s:12:\"delete-30603\";i:29845;s:12:\"delete-30604\";i:29846;s:12:\"delete-30606\";i:29847;s:12:\"delete-30607\";i:29848;s:12:\"delete-30608\";i:29849;s:12:\"delete-30611\";i:29850;s:12:\"delete-30612\";i:29851;s:12:\"delete-30609\";i:29852;s:12:\"delete-30610\";i:29853;s:12:\"delete-30613\";i:29854;s:12:\"delete-30614\";i:29855;s:12:\"delete-30617\";i:29856;s:12:\"delete-30618\";i:29857;s:12:\"delete-30615\";i:29858;s:12:\"delete-30616\";i:29859;s:12:\"delete-30619\";i:29860;s:12:\"delete-30620\";i:29861;s:12:\"delete-30623\";i:29862;s:12:\"delete-30624\";i:29863;s:12:\"delete-30621\";i:29864;s:12:\"delete-30622\";i:29865;s:12:\"delete-30625\";i:29866;s:12:\"delete-30626\";i:29867;s:12:\"delete-30627\";i:29868;s:12:\"delete-30628\";i:29869;s:12:\"delete-30629\";i:29870;s:12:\"delete-30630\";i:29871;s:12:\"delete-30631\";i:29872;s:12:\"delete-30632\";i:29873;s:12:\"delete-30635\";i:29874;s:12:\"delete-30636\";i:29875;s:12:\"delete-30633\";i:29876;s:12:\"delete-30634\";i:29877;s:12:\"delete-30637\";i:29878;s:12:\"delete-30638\";i:29879;s:12:\"delete-30641\";i:29880;s:12:\"delete-30642\";i:29881;s:12:\"delete-30639\";i:29882;s:12:\"delete-30640\";i:29883;s:12:\"delete-30643\";i:29884;s:12:\"delete-30644\";i:29885;s:12:\"delete-30647\";i:29886;s:12:\"delete-30648\";i:29887;s:12:\"delete-30645\";i:29888;s:12:\"delete-30646\";i:29889;s:12:\"delete-30649\";i:29890;s:12:\"delete-30650\";i:29891;s:12:\"delete-30653\";i:29892;s:12:\"delete-30654\";i:29893;s:12:\"delete-30651\";i:29894;s:12:\"delete-30652\";i:29895;s:12:\"delete-30655\";i:29896;s:12:\"delete-30656\";i:29897;s:12:\"delete-30659\";i:29898;s:12:\"delete-30660\";i:29899;s:12:\"delete-30657\";i:29900;s:12:\"delete-30658\";i:29901;s:12:\"delete-30661\";i:29902;s:12:\"delete-30662\";i:29903;s:12:\"delete-30665\";i:29904;s:12:\"delete-30666\";i:29905;s:12:\"delete-30663\";i:29906;s:12:\"delete-30664\";i:29907;s:12:\"delete-30667\";i:29908;s:12:\"delete-30668\";i:29909;s:12:\"delete-30671\";i:29910;s:12:\"delete-30672\";i:29911;s:12:\"delete-30669\";i:29912;s:12:\"delete-30670\";i:29913;s:12:\"delete-30673\";i:29914;s:12:\"delete-30674\";i:29915;s:12:\"delete-30677\";i:29916;s:12:\"delete-30678\";i:29917;s:12:\"delete-30675\";i:29918;s:12:\"delete-30676\";i:29919;s:12:\"delete-30679\";i:29920;s:12:\"delete-30680\";i:29921;s:12:\"delete-30683\";i:29922;s:12:\"delete-30684\";i:29923;s:12:\"delete-30681\";i:29924;s:12:\"delete-30682\";i:29925;s:12:\"delete-30685\";i:29926;s:12:\"delete-30686\";i:29927;s:12:\"delete-30689\";i:29928;s:12:\"delete-30690\";i:29929;s:12:\"delete-30687\";i:29930;s:12:\"delete-30688\";i:29931;s:12:\"delete-30691\";i:29932;s:12:\"delete-30692\";i:29933;s:12:\"delete-30695\";i:29934;s:12:\"delete-30693\";i:29935;s:12:\"delete-30694\";i:29936;s:12:\"delete-30696\";i:29937;s:12:\"delete-30697\";i:29938;s:12:\"delete-30698\";i:29939;s:12:\"delete-30701\";i:29940;s:12:\"delete-30702\";i:29941;s:12:\"delete-30699\";i:29942;s:12:\"delete-30700\";i:29943;s:12:\"delete-30703\";i:29944;s:12:\"delete-30704\";i:29945;s:12:\"delete-30707\";i:29946;s:12:\"delete-30708\";i:29947;s:12:\"delete-30705\";i:29948;s:12:\"delete-30706\";i:29949;s:12:\"delete-30709\";i:29950;s:12:\"delete-30710\";i:29951;s:12:\"delete-30713\";i:29952;s:12:\"delete-30714\";i:29953;s:12:\"delete-30711\";i:29954;s:12:\"delete-30712\";i:29955;s:12:\"delete-30715\";i:29956;s:12:\"delete-30716\";i:29957;s:12:\"delete-30717\";i:29958;s:12:\"delete-30718\";i:29959;s:12:\"delete-30719\";i:29960;s:12:\"delete-30720\";i:29961;s:12:\"delete-30721\";i:29962;s:12:\"delete-30722\";i:29963;s:12:\"delete-30725\";i:29964;s:12:\"delete-30723\";i:29965;s:12:\"delete-30724\";i:29966;s:12:\"delete-30726\";i:29967;s:12:\"delete-30727\";i:29968;s:12:\"delete-30728\";i:29969;s:12:\"delete-30731\";i:29970;s:12:\"delete-30732\";i:29971;s:12:\"delete-30729\";i:29972;s:12:\"delete-30730\";i:29973;s:12:\"delete-30733\";i:29974;s:12:\"delete-30734\";i:29975;s:12:\"delete-30735\";i:29976;s:12:\"delete-30736\";i:29977;s:12:\"delete-30737\";i:29978;s:12:\"delete-30738\";i:29979;s:12:\"delete-30739\";i:29980;s:12:\"delete-30740\";i:29981;s:12:\"delete-30743\";i:29982;s:12:\"delete-30744\";i:29983;s:12:\"delete-30741\";i:29984;s:12:\"delete-30742\";i:29985;s:12:\"delete-30745\";i:29986;s:12:\"delete-30746\";i:29987;s:12:\"delete-30749\";i:29988;s:12:\"delete-30747\";i:29989;s:12:\"delete-30748\";i:29990;s:12:\"delete-30750\";i:29991;s:12:\"delete-30751\";i:29992;s:12:\"delete-30752\";i:29993;s:12:\"delete-30755\";i:29994;s:12:\"delete-30753\";i:29995;s:12:\"delete-30754\";i:29996;s:12:\"delete-30756\";i:29997;s:12:\"delete-30757\";i:29998;s:12:\"delete-30758\";i:29999;s:12:\"delete-30761\";i:30000;s:12:\"delete-30762\";i:30001;s:12:\"delete-30759\";i:30002;s:12:\"delete-30760\";i:30003;s:12:\"delete-30763\";i:30004;s:12:\"delete-30764\";i:30005;s:12:\"delete-30767\";i:30006;s:12:\"delete-30765\";i:30007;s:12:\"delete-30766\";i:30008;s:12:\"delete-30768\";i:30009;s:12:\"delete-30769\";i:30010;s:12:\"delete-30770\";i:30011;s:12:\"delete-30773\";i:30012;s:12:\"delete-30771\";i:30013;s:12:\"delete-30772\";i:30014;s:12:\"delete-30774\";i:30015;s:12:\"delete-30775\";i:30016;s:12:\"delete-30776\";i:30017;s:12:\"delete-30779\";i:30018;s:12:\"delete-30780\";i:30019;s:12:\"delete-30777\";i:30020;s:12:\"delete-30778\";i:30021;s:12:\"delete-30781\";i:30022;s:12:\"delete-30782\";i:30023;s:12:\"delete-30785\";i:30024;s:12:\"delete-30786\";i:30025;s:12:\"delete-30783\";i:30026;s:12:\"delete-30784\";i:30027;s:12:\"delete-30787\";i:30028;s:12:\"delete-30788\";i:30029;s:12:\"delete-30791\";i:30030;s:12:\"delete-30792\";i:30031;s:12:\"delete-30789\";i:30032;s:12:\"delete-30790\";i:30033;s:12:\"delete-30793\";i:30034;s:12:\"delete-30794\";i:30035;s:12:\"delete-30797\";i:30036;s:12:\"delete-30795\";i:30037;s:12:\"delete-30796\";i:30038;s:12:\"delete-30798\";i:30039;s:12:\"delete-30799\";i:30040;s:12:\"delete-30800\";i:30041;s:12:\"delete-30803\";i:30042;s:12:\"delete-30804\";i:30043;s:12:\"delete-30801\";i:30044;s:12:\"delete-30802\";i:30045;s:12:\"delete-30805\";i:30046;s:12:\"delete-30806\";i:30047;s:12:\"delete-30809\";i:30048;s:12:\"delete-30807\";i:30049;s:12:\"delete-30808\";i:30050;s:12:\"delete-30810\";i:30051;s:12:\"delete-30811\";i:30052;s:12:\"delete-30812\";i:30053;s:12:\"delete-30815\";i:30054;s:12:\"delete-30813\";i:30055;s:12:\"delete-30814\";i:30056;s:12:\"delete-30816\";i:30057;s:12:\"delete-30817\";i:30058;s:12:\"delete-30818\";i:30059;s:12:\"delete-30821\";i:30060;s:12:\"delete-30822\";i:30061;s:12:\"delete-30819\";i:30062;s:12:\"delete-30820\";i:30063;s:12:\"delete-30823\";i:30064;s:12:\"delete-30824\";i:30065;s:12:\"delete-30827\";i:30066;s:12:\"delete-30828\";i:30067;s:12:\"delete-30825\";i:30068;s:12:\"delete-30826\";i:30069;s:12:\"delete-30829\";i:30070;s:12:\"delete-30830\";i:30071;s:12:\"delete-30833\";i:30072;s:12:\"delete-30834\";i:30073;s:12:\"delete-30831\";i:30074;s:12:\"delete-30832\";i:30075;s:12:\"delete-30835\";i:30076;s:12:\"delete-30836\";i:30077;s:12:\"delete-30839\";i:30078;s:12:\"delete-30837\";i:30079;s:12:\"delete-30838\";i:30080;s:12:\"delete-30840\";i:30081;s:12:\"delete-30841\";i:30082;s:12:\"delete-30842\";i:30083;s:12:\"delete-30845\";i:30084;s:12:\"delete-30846\";i:30085;s:12:\"delete-30843\";i:30086;s:12:\"delete-30844\";i:30087;s:12:\"delete-30847\";i:30088;s:12:\"delete-30848\";i:30089;s:12:\"delete-30851\";i:30090;s:12:\"delete-30852\";i:30091;s:12:\"delete-30849\";i:30092;s:12:\"delete-30850\";i:30093;s:12:\"delete-30853\";i:30094;s:12:\"delete-30854\";i:30095;s:12:\"delete-30857\";i:30096;s:12:\"delete-30855\";i:30097;s:12:\"delete-30856\";i:30098;s:12:\"delete-30858\";i:30099;s:12:\"delete-30859\";i:30100;s:12:\"delete-30860\";i:30101;s:12:\"delete-30863\";i:30102;s:12:\"delete-30864\";i:30103;s:12:\"delete-30861\";i:30104;s:12:\"delete-30862\";i:30105;s:12:\"delete-30865\";i:30106;s:12:\"delete-30866\";i:30107;s:12:\"delete-30869\";i:30108;s:12:\"delete-30870\";i:30109;s:12:\"delete-30867\";i:30110;s:12:\"delete-30868\";i:30111;s:12:\"delete-30871\";i:30112;s:12:\"delete-30872\";i:30113;s:12:\"delete-30875\";i:30114;s:12:\"delete-30876\";i:30115;s:12:\"delete-30873\";i:30116;s:12:\"delete-30874\";i:30117;s:12:\"delete-30877\";i:30118;s:12:\"delete-30878\";i:30119;s:12:\"delete-30881\";i:30120;s:12:\"delete-30882\";i:30121;s:12:\"delete-30879\";i:30122;s:12:\"delete-30880\";i:30123;s:12:\"delete-30883\";i:30124;s:12:\"delete-30884\";i:30125;s:12:\"delete-30887\";i:30126;s:12:\"delete-30888\";i:30127;s:12:\"delete-30885\";i:30128;s:12:\"delete-30886\";i:30129;s:12:\"delete-30889\";i:30130;s:12:\"delete-30890\";i:30131;s:12:\"delete-30893\";i:30132;s:12:\"delete-30894\";i:30133;s:12:\"delete-30891\";i:30134;s:12:\"delete-30892\";i:30135;s:12:\"delete-30895\";i:30136;s:12:\"delete-30896\";i:30137;s:12:\"delete-30899\";i:30138;s:12:\"delete-30900\";i:30139;s:12:\"delete-30897\";i:30140;s:12:\"delete-30898\";i:30141;s:12:\"delete-30901\";i:30142;s:12:\"delete-30902\";i:30143;s:12:\"delete-30905\";i:30144;s:12:\"delete-30906\";i:30145;s:12:\"delete-30903\";i:30146;s:12:\"delete-30904\";i:30147;s:12:\"delete-30907\";i:30148;s:12:\"delete-30908\";i:30149;s:12:\"delete-30911\";i:30150;s:12:\"delete-30912\";i:30151;s:12:\"delete-30909\";i:30152;s:12:\"delete-30910\";i:30153;s:12:\"delete-30913\";i:30154;s:12:\"delete-30914\";i:30155;s:12:\"delete-30917\";i:30156;s:12:\"delete-30918\";i:30157;s:12:\"delete-30915\";i:30158;s:12:\"delete-30916\";i:30159;s:12:\"delete-30919\";i:30160;s:12:\"delete-30920\";i:30161;s:12:\"delete-30923\";i:30162;s:12:\"delete-30921\";i:30163;s:12:\"delete-30922\";i:30164;s:12:\"delete-30924\";i:30165;s:12:\"delete-30925\";i:30166;s:12:\"delete-30926\";i:30167;s:12:\"delete-30929\";i:30168;s:12:\"delete-30930\";i:30169;s:12:\"delete-30927\";i:30170;s:12:\"delete-30928\";i:30171;s:12:\"delete-30931\";i:30172;s:12:\"delete-30932\";i:30173;s:12:\"delete-30935\";i:30174;s:12:\"delete-30936\";i:30175;s:12:\"delete-30933\";i:30176;s:12:\"delete-30934\";i:30177;s:12:\"delete-30937\";i:30178;s:12:\"delete-30938\";i:30179;s:12:\"delete-30941\";i:30180;s:12:\"delete-30942\";i:30181;s:12:\"delete-30939\";i:30182;s:12:\"delete-30940\";i:30183;s:12:\"delete-30943\";i:30184;s:12:\"delete-30944\";i:30185;s:12:\"delete-30947\";i:30186;s:12:\"delete-30948\";i:30187;s:12:\"delete-30945\";i:30188;s:12:\"delete-30946\";i:30189;s:12:\"delete-30949\";i:30190;s:12:\"delete-30950\";i:30191;s:12:\"delete-30953\";i:30192;s:12:\"delete-30954\";i:30193;s:12:\"delete-30951\";i:30194;s:12:\"delete-30952\";i:30195;s:12:\"delete-30955\";i:30196;s:12:\"delete-30956\";i:30197;s:12:\"delete-30959\";i:30198;s:12:\"delete-30960\";i:30199;s:12:\"delete-30957\";i:30200;s:12:\"delete-30958\";i:30201;s:12:\"delete-30961\";i:30202;s:12:\"delete-30962\";i:30203;s:12:\"delete-30963\";i:30204;s:12:\"delete-30964\";i:30205;s:12:\"delete-30965\";i:30206;s:12:\"delete-30966\";i:30207;s:12:\"delete-30967\";i:30208;s:12:\"delete-30968\";i:30209;s:12:\"delete-30971\";i:30210;s:12:\"delete-30969\";i:30211;s:12:\"delete-30970\";i:30212;s:12:\"delete-30972\";i:30213;s:12:\"delete-30973\";i:30214;s:12:\"delete-30974\";i:30215;s:12:\"delete-30977\";i:30216;s:12:\"delete-30975\";i:30217;s:12:\"delete-30976\";i:30218;s:12:\"delete-30978\";i:30219;s:12:\"delete-30979\";i:30220;s:12:\"delete-30980\";i:30221;s:12:\"delete-30983\";i:30222;s:12:\"delete-30981\";i:30223;s:12:\"delete-30982\";i:30224;s:12:\"delete-30984\";i:30225;s:12:\"delete-30985\";i:30226;s:12:\"delete-30986\";i:30227;s:12:\"delete-30987\";i:30228;s:12:\"delete-30988\";i:30229;s:12:\"delete-30989\";i:30230;s:12:\"delete-30990\";i:30231;s:12:\"delete-30991\";i:30232;s:12:\"delete-30992\";i:30233;s:12:\"delete-30995\";i:30234;s:12:\"delete-30996\";i:30235;s:12:\"delete-30993\";i:30236;s:12:\"delete-30994\";i:30237;s:12:\"delete-30997\";i:30238;s:12:\"delete-30998\";i:30239;s:12:\"delete-31001\";i:30240;s:12:\"delete-31002\";i:30241;s:12:\"delete-30999\";i:30242;s:12:\"delete-31000\";i:30243;s:12:\"delete-31003\";i:30244;s:12:\"delete-31004\";i:30245;s:12:\"delete-31007\";i:30246;s:12:\"delete-31008\";i:30247;s:12:\"delete-31005\";i:30248;s:12:\"delete-31006\";i:30249;s:12:\"delete-31009\";i:30250;s:12:\"delete-31010\";i:30251;s:12:\"delete-31013\";i:30252;s:12:\"delete-31014\";i:30253;s:12:\"delete-31011\";i:30254;s:12:\"delete-31012\";i:30255;s:12:\"delete-31015\";i:30256;s:12:\"delete-31016\";i:30257;s:12:\"delete-31019\";i:30258;s:12:\"delete-31020\";i:30259;s:12:\"delete-31017\";i:30260;s:12:\"delete-31018\";i:30261;s:12:\"delete-31021\";i:30262;s:12:\"delete-31022\";i:30263;s:12:\"delete-31025\";i:30264;s:12:\"delete-31026\";i:30265;s:12:\"delete-31023\";i:30266;s:12:\"delete-31024\";i:30267;s:12:\"delete-31027\";i:30268;s:12:\"delete-31028\";i:30269;s:12:\"delete-31031\";i:30270;s:12:\"delete-31032\";i:30271;s:12:\"delete-31029\";i:30272;s:12:\"delete-31030\";i:30273;s:12:\"delete-31033\";i:30274;s:12:\"delete-31034\";i:30275;s:12:\"delete-31035\";i:30276;s:12:\"delete-31036\";i:30277;s:12:\"delete-31037\";i:30278;s:12:\"delete-31038\";i:30279;s:12:\"delete-31039\";i:30280;s:12:\"delete-31040\";i:30281;s:12:\"delete-31043\";i:30282;s:12:\"delete-31044\";i:30283;s:12:\"delete-31041\";i:30284;s:12:\"delete-31042\";i:30285;s:12:\"delete-31045\";i:30286;s:12:\"delete-31046\";i:30287;s:12:\"delete-31047\";i:30288;s:12:\"delete-31048\";i:30289;s:12:\"delete-31049\";i:30290;s:12:\"delete-31050\";i:30291;s:12:\"delete-31051\";i:30292;s:12:\"delete-31052\";i:30293;s:12:\"delete-31055\";i:30294;s:12:\"delete-31056\";i:30295;s:12:\"delete-31053\";i:30296;s:12:\"delete-31054\";i:30297;s:12:\"delete-31057\";i:30298;s:12:\"delete-31058\";i:30299;s:12:\"delete-31061\";i:30300;s:12:\"delete-31062\";i:30301;s:12:\"delete-31059\";i:30302;s:12:\"delete-31060\";i:30303;s:12:\"delete-31063\";i:30304;s:12:\"delete-31064\";i:30305;s:12:\"delete-31067\";i:30306;s:12:\"delete-31065\";i:30307;s:12:\"delete-31066\";i:30308;s:12:\"delete-31068\";i:30309;s:12:\"delete-31069\";i:30310;s:12:\"delete-31070\";i:30311;s:12:\"delete-31073\";i:30312;s:12:\"delete-31071\";i:30313;s:12:\"delete-31072\";i:30314;s:12:\"delete-31074\";i:30315;s:12:\"delete-31075\";i:30316;s:12:\"delete-31076\";i:30317;s:12:\"delete-31079\";i:30318;s:12:\"delete-31080\";i:30319;s:12:\"delete-31077\";i:30320;s:12:\"delete-31078\";i:30321;s:12:\"delete-31081\";i:30322;s:12:\"delete-31082\";i:30323;s:12:\"delete-31085\";i:30324;s:12:\"delete-31086\";i:30325;s:12:\"delete-31083\";i:30326;s:12:\"delete-31084\";i:30327;s:12:\"delete-31087\";i:30328;s:12:\"delete-31088\";i:30329;s:12:\"delete-31091\";i:30330;s:12:\"delete-31089\";i:30331;s:12:\"delete-31090\";i:30332;s:12:\"delete-31092\";i:30333;s:12:\"delete-31093\";i:30334;s:12:\"delete-31094\";i:30335;s:12:\"delete-31097\";i:30336;s:12:\"delete-31098\";i:30337;s:12:\"delete-31095\";i:30338;s:12:\"delete-31096\";i:30339;s:12:\"delete-31099\";i:30340;s:12:\"delete-31100\";i:30341;s:12:\"delete-31103\";i:30342;s:12:\"delete-31104\";i:30343;s:12:\"delete-31101\";i:30344;s:12:\"delete-31102\";i:30345;s:12:\"delete-31105\";i:30346;s:12:\"delete-31106\";i:30347;s:12:\"delete-31109\";i:30348;s:12:\"delete-31107\";i:30349;s:12:\"delete-31108\";i:30350;s:12:\"delete-31110\";i:30351;s:12:\"delete-31111\";i:30352;s:12:\"delete-31112\";i:30353;s:12:\"delete-31115\";i:30354;s:12:\"delete-31113\";i:30355;s:12:\"delete-31114\";i:30356;s:12:\"delete-31116\";i:30357;s:12:\"delete-31117\";i:30358;s:12:\"delete-31118\";i:30359;s:12:\"delete-31121\";i:30360;s:12:\"delete-31122\";i:30361;s:12:\"delete-31119\";i:30362;s:12:\"delete-31120\";i:30363;s:12:\"delete-31123\";i:30364;s:12:\"delete-31124\";i:30365;s:12:\"delete-31127\";i:30366;s:12:\"delete-31125\";i:30367;s:12:\"delete-31126\";i:30368;s:12:\"delete-31128\";i:30369;s:12:\"delete-31129\";i:30370;s:12:\"delete-31130\";i:30371;s:12:\"delete-31131\";i:30372;s:12:\"delete-31132\";i:30373;s:12:\"delete-31133\";i:30374;s:12:\"delete-31134\";i:30375;s:12:\"delete-31135\";i:30376;s:12:\"delete-31136\";i:30377;s:12:\"delete-31137\";i:30378;s:12:\"delete-31138\";i:30379;s:12:\"delete-31139\";i:30380;s:12:\"delete-31140\";i:30381;s:12:\"delete-31141\";i:30382;s:12:\"delete-31142\";i:30383;s:12:\"delete-31145\";i:30384;s:12:\"delete-31146\";i:30385;s:12:\"delete-31143\";i:30386;s:12:\"delete-31144\";i:30387;s:12:\"delete-31147\";i:30388;s:12:\"delete-31148\";i:30389;s:12:\"delete-31151\";i:30390;s:12:\"delete-31149\";i:30391;s:12:\"delete-31150\";i:30392;s:12:\"delete-31152\";i:30393;s:12:\"delete-31153\";i:30394;s:12:\"delete-31154\";i:30395;s:12:\"delete-31157\";i:30396;s:12:\"delete-31158\";i:30397;s:12:\"delete-31155\";i:30398;s:12:\"delete-31156\";i:30399;s:12:\"delete-31159\";i:30400;s:12:\"delete-31160\";i:30401;s:12:\"delete-31163\";i:30402;s:12:\"delete-31161\";i:30403;s:12:\"delete-31162\";i:30404;s:12:\"delete-31164\";i:30405;s:12:\"delete-31165\";i:30406;s:12:\"delete-31166\";i:30407;s:12:\"delete-31169\";i:30408;s:12:\"delete-31170\";i:30409;s:12:\"delete-31167\";i:30410;s:12:\"delete-31168\";i:30411;s:12:\"delete-31171\";i:30412;s:12:\"delete-31172\";i:30413;s:12:\"delete-31175\";i:30414;s:12:\"delete-31176\";i:30415;s:12:\"delete-31173\";i:30416;s:12:\"delete-31174\";i:30417;s:12:\"delete-31177\";i:30418;s:12:\"delete-31178\";i:30419;s:12:\"delete-31181\";i:30420;s:12:\"delete-31182\";i:30421;s:12:\"delete-31179\";i:30422;s:12:\"delete-31180\";i:30423;s:12:\"delete-31183\";i:30424;s:12:\"delete-31184\";i:30425;s:12:\"delete-31187\";i:30426;s:12:\"delete-31188\";i:30427;s:12:\"delete-31185\";i:30428;s:12:\"delete-31186\";i:30429;s:12:\"delete-31189\";i:30430;s:12:\"delete-31190\";i:30431;s:12:\"delete-31193\";i:30432;s:12:\"delete-31191\";i:30433;s:12:\"delete-31192\";i:30434;s:12:\"delete-31194\";i:30435;s:12:\"delete-31195\";i:30436;s:12:\"delete-31196\";i:30437;s:12:\"delete-31199\";i:30438;s:12:\"delete-31197\";i:30439;s:12:\"delete-31198\";i:30440;s:12:\"delete-31200\";i:30441;s:12:\"delete-31201\";i:30442;s:12:\"delete-31202\";i:30443;s:12:\"delete-31205\";i:30444;s:12:\"delete-31206\";i:30445;s:12:\"delete-31203\";i:30446;s:12:\"delete-31204\";i:30447;s:12:\"delete-31207\";i:30448;s:12:\"delete-31208\";i:30449;s:12:\"delete-31211\";i:30450;s:12:\"delete-31212\";i:30451;s:12:\"delete-31209\";i:30452;s:12:\"delete-31210\";i:30453;s:12:\"delete-31213\";i:30454;s:12:\"delete-31214\";i:30455;s:12:\"delete-31217\";i:30456;s:12:\"delete-31215\";i:30457;s:12:\"delete-31216\";i:30458;s:12:\"delete-31218\";i:30459;s:12:\"delete-31219\";i:30460;s:12:\"delete-31220\";i:30461;s:12:\"delete-31223\";i:30462;s:12:\"delete-31221\";i:30463;s:12:\"delete-31222\";i:30464;s:12:\"delete-31224\";i:30465;s:12:\"delete-31225\";i:30466;s:12:\"delete-31226\";i:30467;s:12:\"delete-31229\";i:30468;s:12:\"delete-31230\";i:30469;s:12:\"delete-31227\";i:30470;s:12:\"delete-31228\";i:30471;s:12:\"delete-31231\";i:30472;s:12:\"delete-31232\";i:30473;s:12:\"delete-31235\";i:30474;s:12:\"delete-31236\";i:30475;s:12:\"delete-31233\";i:30476;s:12:\"delete-31234\";i:30477;s:12:\"delete-31237\";i:30478;s:12:\"delete-31238\";i:30479;s:12:\"delete-31241\";i:30480;s:12:\"delete-31242\";i:30481;s:12:\"delete-31239\";i:30482;s:12:\"delete-31240\";i:30483;s:12:\"delete-31243\";i:30484;s:12:\"delete-31244\";i:30485;s:12:\"delete-31247\";i:30486;s:12:\"delete-31245\";i:30487;s:12:\"delete-31246\";i:30488;s:12:\"delete-31248\";i:30489;s:12:\"delete-31249\";i:30490;s:12:\"delete-31250\";i:30491;s:12:\"delete-31253\";i:30492;s:12:\"delete-31254\";i:30493;s:12:\"delete-31251\";i:30494;s:12:\"delete-31252\";i:30495;s:12:\"delete-31255\";i:30496;s:12:\"delete-31256\";i:30497;s:12:\"delete-31257\";i:30498;s:12:\"delete-31258\";i:30499;s:12:\"delete-31259\";i:30500;s:12:\"delete-31260\";i:30501;s:12:\"delete-31261\";i:30502;s:12:\"delete-31262\";i:30503;s:12:\"delete-31265\";i:30504;s:12:\"delete-31266\";i:30505;s:12:\"delete-31263\";i:30506;s:12:\"delete-31264\";i:30507;s:12:\"delete-31267\";i:30508;s:12:\"delete-31268\";i:30509;s:12:\"delete-31271\";i:30510;s:12:\"delete-31269\";i:30511;s:12:\"delete-31270\";i:30512;s:12:\"delete-31272\";i:30513;s:12:\"delete-31273\";i:30514;s:12:\"delete-31274\";i:30515;s:12:\"delete-31277\";i:30516;s:12:\"delete-31278\";i:30517;s:12:\"delete-31275\";i:30518;s:12:\"delete-31276\";i:30519;s:12:\"delete-31279\";i:30520;s:12:\"delete-31280\";i:30521;s:12:\"delete-31283\";i:30522;s:12:\"delete-31284\";i:30523;s:12:\"delete-31281\";i:30524;s:12:\"delete-31282\";i:30525;s:12:\"delete-31285\";i:30526;s:12:\"delete-31286\";i:30527;s:12:\"delete-31287\";i:30528;s:12:\"delete-31288\";i:30529;s:12:\"delete-31289\";i:30530;s:12:\"delete-31290\";i:30531;s:12:\"delete-31291\";i:30532;s:12:\"delete-31294\";i:30533;s:12:\"delete-31295\";i:30534;s:12:\"delete-31292\";i:30535;s:12:\"delete-31293\";i:30536;s:12:\"delete-31296\";i:30537;s:12:\"delete-31297\";i:30538;s:12:\"delete-31300\";i:30539;s:12:\"delete-31298\";i:30540;s:12:\"delete-31299\";i:30541;s:12:\"delete-31301\";i:30542;s:12:\"delete-31302\";i:30543;s:12:\"delete-31303\";i:30544;s:12:\"delete-31306\";i:30545;s:12:\"delete-31307\";i:30546;s:12:\"delete-31304\";i:30547;s:12:\"delete-31305\";i:30548;s:12:\"delete-31308\";i:30549;s:12:\"delete-31309\";i:30550;s:12:\"delete-31312\";i:30551;s:12:\"delete-31313\";i:30552;s:12:\"delete-31310\";i:30553;s:12:\"delete-31311\";i:30554;s:12:\"delete-31314\";i:30555;s:12:\"delete-31315\";i:30556;s:12:\"delete-31318\";i:30557;s:12:\"delete-31319\";i:30558;s:12:\"delete-31316\";i:30559;s:12:\"delete-31317\";i:30560;s:12:\"delete-31320\";i:30561;s:12:\"delete-31321\";i:30562;s:12:\"delete-31324\";i:30563;s:12:\"delete-31322\";i:30564;s:12:\"delete-31323\";i:30565;s:12:\"delete-31325\";i:30566;s:12:\"delete-31326\";i:30567;s:12:\"delete-31327\";i:30568;s:12:\"delete-31330\";i:30569;s:12:\"delete-31331\";i:30570;s:12:\"delete-31328\";i:30571;s:12:\"delete-31329\";i:30572;s:12:\"delete-31332\";i:30573;s:12:\"delete-31333\";i:30574;s:12:\"delete-31336\";i:30575;s:12:\"delete-31337\";i:30576;s:12:\"delete-31334\";i:30577;s:12:\"delete-31335\";i:30578;s:12:\"delete-31338\";i:30579;s:12:\"delete-31339\";i:30580;s:12:\"delete-31342\";i:30581;s:12:\"delete-31340\";i:30582;s:12:\"delete-31341\";i:30583;s:12:\"delete-31343\";i:30584;s:12:\"delete-31344\";i:30585;s:12:\"delete-31345\";i:30586;s:12:\"delete-31348\";i:30587;s:12:\"delete-31346\";i:30588;s:12:\"delete-31347\";i:30589;s:12:\"delete-31349\";i:30590;s:12:\"delete-31350\";i:30591;s:12:\"delete-31351\";i:30592;s:12:\"delete-31354\";i:30593;s:12:\"delete-31352\";i:30594;s:12:\"delete-31353\";i:30595;s:12:\"delete-31355\";i:30596;s:12:\"delete-31356\";i:30597;s:12:\"delete-31357\";i:30598;s:12:\"delete-31360\";i:30599;s:12:\"delete-31361\";i:30600;s:12:\"delete-31362\";i:30601;s:12:\"delete-31363\";i:30602;s:12:\"delete-31358\";i:30603;s:12:\"delete-31359\";i:30604;s:12:\"delete-31364\";i:30605;s:12:\"delete-31365\";i:30606;s:12:\"delete-31366\";i:30607;s:12:\"delete-31367\";i:30608;s:12:\"delete-31368\";i:30609;s:12:\"delete-31369\";i:30610;s:12:\"delete-31370\";i:30611;s:12:\"delete-31371\";i:30612;s:12:\"delete-31372\";i:30613;s:12:\"delete-31373\";i:30614;s:12:\"delete-31374\";i:30615;s:12:\"delete-31375\";i:30616;s:12:\"delete-31378\";i:30617;s:12:\"delete-31379\";i:30618;s:12:\"delete-31376\";i:30619;s:12:\"delete-31377\";i:30620;s:12:\"delete-31380\";i:30621;s:12:\"delete-31381\";i:30622;s:12:\"delete-31384\";i:30623;s:12:\"delete-31385\";i:30624;s:12:\"delete-31382\";i:30625;s:12:\"delete-31383\";i:30626;s:12:\"delete-31386\";i:30627;s:12:\"delete-31387\";i:30628;s:12:\"delete-31388\";i:30629;s:12:\"delete-31389\";i:30630;s:12:\"delete-31390\";i:30631;s:12:\"delete-31391\";i:30632;s:12:\"delete-31392\";i:30633;s:12:\"delete-31393\";i:30634;s:12:\"delete-31396\";i:30635;s:12:\"delete-31397\";i:30636;s:12:\"delete-31394\";i:30637;s:12:\"delete-31395\";i:30638;s:12:\"delete-31398\";i:30639;s:12:\"delete-31399\";i:30640;s:12:\"delete-31402\";i:30641;s:12:\"delete-31403\";i:30642;s:12:\"delete-31400\";i:30643;s:12:\"delete-31401\";i:30644;s:12:\"delete-31404\";i:30645;s:12:\"delete-31405\";i:30646;s:12:\"delete-31408\";i:30647;s:12:\"delete-31409\";i:30648;s:12:\"delete-31406\";i:30649;s:12:\"delete-31407\";i:30650;s:12:\"delete-31410\";i:30651;s:12:\"delete-31411\";i:30652;s:12:\"delete-31414\";i:30653;s:12:\"delete-31415\";i:30654;s:12:\"delete-31416\";i:30655;s:12:\"delete-31417\";i:30656;s:12:\"delete-31412\";i:30657;s:12:\"delete-31413\";i:30658;s:12:\"delete-31418\";i:30659;s:12:\"delete-31419\";i:30660;s:12:\"delete-31420\";i:30661;s:12:\"delete-31421\";i:30662;s:12:\"delete-31422\";i:30663;s:12:\"delete-31423\";i:30664;s:12:\"delete-31426\";i:30665;s:12:\"delete-31427\";i:30666;s:12:\"delete-31424\";i:30667;s:12:\"delete-31425\";i:30668;s:12:\"delete-31428\";i:30669;s:12:\"delete-31429\";i:30670;s:12:\"delete-31432\";i:30671;s:12:\"delete-31430\";i:30672;s:12:\"delete-31431\";i:30673;s:12:\"delete-31433\";i:30674;s:12:\"delete-31434\";i:30675;s:12:\"delete-31435\";i:30676;s:12:\"delete-31436\";i:30677;s:12:\"delete-31437\";i:30678;s:12:\"delete-31438\";i:30679;s:12:\"delete-31439\";i:30680;s:12:\"delete-31440\";i:30681;s:12:\"delete-31441\";i:30682;s:12:\"delete-31444\";i:30683;s:12:\"delete-31445\";i:30684;s:12:\"delete-31442\";i:30685;s:12:\"delete-31443\";i:30686;s:12:\"delete-31446\";i:30687;s:12:\"delete-31447\";i:30688;s:12:\"delete-31450\";i:30689;s:12:\"delete-31451\";i:30690;s:12:\"delete-31448\";i:30691;s:12:\"delete-31449\";i:30692;s:12:\"delete-31452\";i:30693;s:12:\"delete-31453\";i:30694;s:12:\"delete-31456\";i:30695;s:12:\"delete-31454\";i:30696;s:12:\"delete-31455\";i:30697;s:12:\"delete-31457\";i:30698;s:12:\"delete-31458\";i:30699;s:12:\"delete-31459\";i:30700;s:12:\"delete-31462\";i:30701;s:12:\"delete-31463\";i:30702;s:12:\"delete-31460\";i:30703;s:12:\"delete-31461\";i:30704;s:12:\"delete-31464\";i:30705;s:12:\"delete-31465\";i:30706;s:12:\"delete-31466\";i:30707;s:12:\"delete-31467\";i:30708;s:12:\"delete-31468\";i:30709;s:12:\"delete-31469\";i:30710;s:12:\"delete-31470\";i:30711;s:12:\"delete-31471\";i:30712;s:12:\"delete-31474\";i:30713;s:12:\"delete-31475\";i:30714;s:12:\"delete-31472\";i:30715;s:12:\"delete-31473\";i:30716;s:12:\"delete-31476\";i:30717;s:12:\"delete-31477\";i:30718;s:12:\"delete-31480\";i:30719;s:12:\"delete-31478\";i:30720;s:12:\"delete-31479\";i:30721;s:12:\"delete-31481\";i:30722;s:12:\"delete-31483\";i:30723;s:12:\"delete-31482\";i:30724;s:12:\"delete-31486\";i:30725;s:12:\"delete-31487\";i:30726;s:12:\"delete-31484\";i:30727;s:12:\"delete-31485\";i:30728;s:12:\"delete-31488\";i:30729;s:12:\"delete-31492\";i:30730;s:12:\"delete-31489\";i:30731;s:12:\"delete-31490\";i:30732;s:12:\"delete-31491\";i:30733;s:12:\"delete-31493\";i:30734;s:12:\"delete-31494\";i:30735;s:12:\"delete-31495\";i:30736;s:12:\"delete-31498\";i:30737;s:12:\"delete-31496\";i:30738;s:12:\"delete-31497\";i:30739;s:12:\"delete-31499\";i:30740;s:12:\"delete-31500\";i:30741;s:12:\"delete-31501\";i:30742;s:12:\"delete-31504\";i:30743;s:12:\"delete-31505\";i:30744;s:12:\"delete-31502\";i:30745;s:12:\"delete-31503\";i:30746;s:12:\"delete-31506\";i:30747;s:12:\"delete-31507\";i:30748;s:12:\"delete-31510\";i:30749;s:12:\"delete-31508\";i:30750;s:12:\"delete-31509\";i:30751;s:12:\"delete-31511\";i:30752;s:12:\"delete-31512\";i:30753;s:12:\"delete-31513\";i:30754;s:12:\"delete-31516\";i:30755;s:12:\"delete-31517\";i:30756;s:12:\"delete-31514\";i:30757;s:12:\"delete-31515\";i:30758;s:12:\"delete-31518\";i:30759;s:12:\"delete-31519\";i:30760;s:12:\"delete-31520\";i:30761;s:12:\"delete-31521\";i:30762;s:12:\"delete-31522\";i:30763;s:12:\"delete-31523\";i:30764;s:12:\"delete-31524\";i:30765;s:12:\"delete-31525\";i:30766;s:12:\"delete-31528\";i:30767;s:12:\"delete-31529\";i:30768;s:12:\"delete-31526\";i:30769;s:12:\"delete-31527\";i:30770;s:12:\"delete-31530\";i:30771;s:12:\"delete-31531\";i:30772;s:12:\"delete-31534\";i:30773;s:12:\"delete-31532\";i:30774;s:12:\"delete-31533\";i:30775;s:12:\"delete-31535\";i:30776;s:12:\"delete-31536\";i:30777;s:12:\"delete-31537\";i:30778;s:12:\"delete-31538\";i:30779;s:12:\"delete-31539\";i:30780;s:12:\"delete-31540\";i:30781;s:12:\"delete-31541\";i:30782;s:12:\"delete-31542\";i:30783;s:12:\"delete-31543\";i:30784;s:12:\"delete-31546\";i:30785;s:12:\"delete-31547\";i:30786;s:12:\"delete-31544\";i:30787;s:12:\"delete-31545\";i:30788;s:12:\"delete-31548\";i:30789;s:12:\"delete-31549\";i:30790;s:12:\"delete-31550\";i:30791;s:12:\"delete-31551\";i:30792;s:12:\"delete-31552\";i:30793;s:12:\"delete-31553\";i:30794;s:12:\"delete-31554\";i:30795;s:12:\"delete-31555\";i:30796;s:12:\"delete-31556\";i:30797;s:12:\"delete-31557\";i:30798;s:12:\"delete-31558\";i:30799;s:12:\"delete-31559\";i:30800;s:12:\"delete-31560\";i:30801;s:12:\"delete-31561\";i:30802;s:12:\"delete-31564\";i:30803;s:12:\"delete-31562\";i:30804;s:12:\"delete-31563\";i:30805;s:12:\"delete-31565\";i:30806;s:12:\"delete-31566\";i:30807;s:12:\"delete-31567\";i:30808;s:12:\"delete-31570\";i:30809;s:12:\"delete-31571\";i:30810;s:12:\"delete-31568\";i:30811;s:12:\"delete-31569\";i:30812;s:12:\"delete-31572\";i:30813;s:12:\"delete-31573\";i:30814;s:12:\"delete-31574\";i:30815;s:12:\"delete-31575\";i:30816;s:12:\"delete-31576\";i:30817;s:12:\"delete-31577\";i:30818;s:12:\"delete-31578\";i:30819;s:12:\"delete-31579\";i:30820;s:12:\"delete-31582\";i:30821;s:12:\"delete-31583\";i:30822;s:12:\"delete-31580\";i:30823;s:12:\"delete-31581\";i:30824;s:12:\"delete-31584\";i:30825;s:12:\"delete-31585\";i:30826;s:12:\"delete-31588\";i:30827;s:12:\"delete-31586\";i:30828;s:12:\"delete-31587\";i:30829;s:12:\"delete-31589\";i:30830;s:12:\"delete-31590\";i:30831;s:12:\"delete-31591\";i:30832;s:12:\"delete-31594\";i:30833;s:12:\"delete-31595\";i:30834;s:12:\"delete-31592\";i:30835;s:12:\"delete-31593\";i:30836;s:12:\"delete-31596\";i:30837;s:12:\"delete-31597\";i:30838;s:12:\"delete-31600\";i:30839;s:12:\"delete-31598\";i:30840;s:12:\"delete-31599\";i:30841;s:12:\"delete-31601\";i:30842;s:12:\"delete-31602\";i:30843;s:12:\"delete-31603\";i:30844;s:12:\"delete-31604\";i:30845;s:12:\"delete-31605\";i:30846;s:12:\"delete-31606\";i:30847;s:12:\"delete-31607\";i:30848;s:12:\"delete-31608\";i:30849;s:12:\"delete-31609\";i:30850;s:12:\"delete-31612\";i:30851;s:12:\"delete-31613\";i:30852;s:12:\"delete-31610\";i:30853;s:12:\"delete-31611\";i:30854;s:12:\"delete-31614\";i:30855;s:12:\"delete-31615\";i:30856;s:12:\"delete-31616\";i:30857;s:12:\"delete-31617\";i:30858;s:12:\"delete-31618\";i:30859;s:12:\"delete-31619\";i:30860;s:12:\"delete-31620\";i:30861;s:12:\"delete-31621\";i:30862;s:12:\"delete-31624\";i:30863;s:12:\"delete-31622\";i:30864;s:12:\"delete-31623\";i:30865;s:12:\"delete-31625\";i:30866;s:12:\"delete-31626\";i:30867;s:12:\"delete-31627\";i:30868;s:12:\"delete-31630\";i:30869;s:12:\"delete-31628\";i:30870;s:12:\"delete-31629\";i:30871;s:12:\"delete-31631\";i:30872;s:12:\"delete-31633\";i:30873;s:12:\"delete-31632\";i:30874;s:12:\"delete-31636\";i:30875;s:12:\"delete-31637\";i:30876;s:12:\"delete-31634\";i:30877;s:12:\"delete-31635\";i:30878;s:12:\"delete-31638\";i:30879;s:12:\"delete-31639\";i:30880;s:12:\"delete-31642\";i:30881;s:12:\"delete-31640\";i:30882;s:12:\"delete-31641\";i:30883;s:12:\"delete-31643\";i:30884;s:12:\"delete-31645\";i:30885;s:12:\"delete-31644\";i:30886;s:12:\"delete-31648\";i:30887;s:12:\"delete-31649\";i:30888;s:12:\"delete-31646\";i:30889;s:12:\"delete-31647\";i:30890;s:12:\"delete-31650\";i:30891;s:12:\"delete-31651\";i:30892;s:12:\"delete-31652\";i:30893;s:12:\"delete-31653\";i:30894;s:12:\"delete-31654\";i:30895;s:12:\"delete-31655\";i:30896;s:12:\"delete-31656\";i:30897;s:12:\"delete-31657\";i:30898;s:12:\"delete-31660\";i:30899;s:12:\"delete-31661\";i:30900;s:12:\"delete-31658\";i:30901;s:12:\"delete-31659\";i:30902;s:12:\"delete-31662\";i:30903;s:12:\"delete-31666\";i:30904;s:12:\"delete-31663\";i:30905;s:12:\"delete-31667\";i:30906;s:12:\"delete-31664\";i:30907;s:12:\"delete-31665\";i:30908;s:12:\"delete-31668\";i:30909;s:12:\"delete-31669\";i:30910;s:12:\"delete-31672\";i:30911;s:12:\"delete-31673\";i:30912;s:12:\"delete-31670\";i:30913;s:12:\"delete-31671\";i:30914;s:12:\"delete-31674\";i:30915;s:12:\"delete-31675\";i:30916;s:12:\"delete-31678\";i:30917;s:12:\"delete-31679\";i:30918;s:12:\"delete-31676\";i:30919;s:12:\"delete-31677\";i:30920;s:12:\"delete-31680\";i:30921;s:12:\"delete-31681\";i:30922;s:12:\"delete-31684\";i:30923;s:12:\"delete-31682\";i:30924;s:12:\"delete-31683\";i:30925;s:12:\"delete-31685\";i:30926;s:12:\"delete-31686\";i:30927;s:12:\"delete-31687\";i:30928;s:12:\"delete-31690\";i:30929;s:12:\"delete-31688\";i:30930;s:12:\"delete-31689\";i:30931;s:12:\"delete-31691\";i:30932;s:12:\"delete-31692\";i:30933;s:12:\"delete-31693\";i:30934;s:12:\"delete-31696\";i:30935;s:12:\"delete-31697\";i:30936;s:12:\"delete-31694\";i:30937;s:12:\"delete-31695\";i:30938;s:12:\"delete-31698\";i:30939;s:12:\"delete-31699\";i:30940;s:12:\"delete-31702\";i:30941;s:12:\"delete-31700\";i:30942;s:12:\"delete-31701\";i:30943;s:12:\"delete-31703\";i:30944;s:12:\"delete-31704\";i:30945;s:12:\"delete-31705\";i:30946;s:12:\"delete-31706\";i:30947;s:12:\"delete-31707\";i:30948;s:12:\"delete-31708\";i:30949;s:12:\"delete-31709\";i:30950;s:12:\"delete-31710\";i:30951;s:12:\"delete-31711\";i:30952;s:12:\"delete-31714\";i:30953;s:12:\"delete-31712\";i:30954;s:12:\"delete-31713\";i:30955;s:12:\"delete-31715\";i:30956;s:12:\"delete-31716\";i:30957;s:12:\"delete-31717\";i:30958;s:12:\"delete-31720\";i:30959;s:12:\"delete-31721\";i:30960;s:12:\"delete-31718\";i:30961;s:12:\"delete-31719\";i:30962;s:12:\"delete-31722\";i:30963;s:12:\"delete-31723\";i:30964;s:12:\"delete-31726\";i:30965;s:12:\"delete-31724\";i:30966;s:12:\"delete-31725\";i:30967;s:12:\"delete-31727\";i:30968;s:12:\"delete-31728\";i:30969;s:12:\"delete-31729\";i:30970;s:12:\"delete-31732\";i:30971;s:12:\"delete-31730\";i:30972;s:12:\"delete-31731\";i:30973;s:12:\"delete-31733\";i:30974;s:12:\"delete-31734\";i:30975;s:12:\"delete-31735\";i:30976;s:12:\"delete-31738\";i:30977;s:12:\"delete-31739\";i:30978;s:12:\"delete-31736\";i:30979;s:12:\"delete-31737\";i:30980;s:12:\"delete-31740\";i:30981;s:12:\"delete-31741\";i:30982;s:12:\"delete-31742\";i:30983;s:12:\"delete-31743\";i:30984;s:12:\"delete-31744\";i:30985;s:12:\"delete-31745\";i:30986;s:12:\"delete-31746\";i:30987;s:12:\"delete-31747\";i:30988;s:12:\"delete-31750\";i:30989;s:12:\"delete-31748\";i:30990;s:12:\"delete-31749\";i:30991;s:12:\"delete-31751\";i:30992;s:12:\"delete-31752\";i:30993;s:12:\"delete-31753\";i:30994;s:12:\"delete-31756\";i:30995;s:12:\"delete-31757\";i:30996;s:12:\"delete-31754\";i:30997;s:12:\"delete-31755\";i:30998;s:12:\"delete-31758\";i:30999;s:12:\"delete-31759\";i:31000;s:12:\"delete-31762\";i:31001;s:12:\"delete-31763\";i:31002;s:12:\"delete-31760\";i:31003;s:12:\"delete-31761\";i:31004;s:12:\"delete-31764\";i:31005;s:12:\"delete-31765\";i:31006;s:12:\"delete-31768\";i:31007;s:12:\"delete-31766\";i:31008;s:12:\"delete-31767\";i:31009;s:12:\"delete-31769\";i:31010;s:12:\"delete-31770\";i:31011;s:12:\"delete-31771\";i:31012;s:12:\"delete-31774\";i:31013;s:12:\"delete-31775\";i:31014;s:12:\"delete-31772\";i:31015;s:12:\"delete-31773\";i:31016;s:12:\"delete-31776\";i:31017;s:12:\"delete-31777\";i:31018;s:12:\"delete-31780\";i:31019;s:12:\"delete-31781\";i:31020;s:12:\"delete-31778\";i:31021;s:12:\"delete-31779\";i:31022;s:12:\"delete-31782\";i:31023;s:12:\"delete-31783\";i:31024;s:12:\"delete-31786\";i:31025;s:12:\"delete-31784\";i:31026;s:12:\"delete-31785\";i:31027;s:12:\"delete-31787\";i:31028;s:12:\"delete-31788\";i:31029;s:12:\"delete-31789\";i:31030;s:12:\"delete-31792\";i:31031;s:12:\"delete-31793\";i:31032;s:12:\"delete-31794\";i:31033;s:12:\"delete-31795\";i:31034;s:12:\"delete-31790\";i:31035;s:12:\"delete-31791\";i:31036;s:12:\"delete-31796\";i:31037;s:12:\"delete-31797\";i:31038;s:12:\"delete-31798\";i:31039;s:12:\"delete-31799\";i:31040;s:12:\"delete-31800\";i:31041;s:12:\"delete-31801\";i:31042;s:12:\"delete-31804\";i:31043;s:12:\"delete-31802\";i:31044;s:12:\"delete-31803\";i:31045;s:12:\"delete-31805\";i:31046;s:12:\"delete-31806\";i:31047;s:12:\"delete-31807\";i:31048;s:12:\"delete-31810\";i:31049;s:12:\"delete-31811\";i:31050;s:12:\"delete-31808\";i:31051;s:12:\"delete-31809\";i:31052;s:12:\"delete-31812\";i:31053;s:12:\"delete-31814\";i:31054;s:12:\"delete-31815\";i:31055;s:12:\"delete-31813\";i:31056;s:12:\"delete-31816\";i:31057;s:12:\"delete-31817\";i:31058;s:12:\"delete-31818\";i:31059;s:12:\"delete-31819\";i:31060;s:12:\"delete-31822\";i:31061;s:12:\"delete-31823\";i:31062;s:12:\"delete-31820\";i:31063;s:12:\"delete-31821\";i:31064;s:12:\"delete-31824\";i:31065;s:12:\"delete-31825\";i:31066;s:12:\"delete-31828\";i:31067;s:12:\"delete-31826\";i:31068;s:12:\"delete-31827\";i:31069;s:12:\"delete-31829\";i:31070;s:12:\"delete-31830\";i:31071;s:12:\"delete-31831\";i:31072;s:12:\"delete-31834\";i:31073;s:12:\"delete-31835\";i:31074;s:12:\"delete-31832\";i:31075;s:12:\"delete-31833\";i:31076;s:12:\"delete-31836\";i:31077;s:12:\"delete-31837\";i:31078;s:12:\"delete-31840\";i:31079;s:12:\"delete-31838\";i:31080;s:12:\"delete-31839\";i:31081;s:12:\"delete-31841\";i:31082;s:12:\"delete-31842\";i:31083;s:12:\"delete-31843\";i:31084;s:12:\"delete-31844\";i:31085;s:12:\"delete-31845\";i:31086;s:12:\"delete-31846\";i:31087;s:12:\"delete-31847\";i:31088;s:12:\"delete-31848\";i:31089;s:12:\"delete-31849\";i:31090;s:12:\"delete-31852\";i:31091;s:12:\"delete-31853\";i:31092;s:12:\"delete-31854\";i:31093;s:12:\"delete-31855\";i:31094;s:12:\"delete-31858\";i:31095;s:12:\"delete-31859\";i:31096;s:12:\"delete-31850\";i:31097;s:12:\"delete-31851\";i:31098;s:12:\"delete-31856\";i:31099;s:12:\"delete-31857\";i:31100;s:12:\"delete-31860\";i:31101;s:12:\"delete-31861\";i:31102;s:12:\"delete-31864\";i:31103;s:12:\"delete-31865\";i:31104;s:12:\"delete-31862\";i:31105;s:12:\"delete-31863\";i:31106;s:12:\"delete-31866\";i:31107;s:12:\"delete-31867\";i:31108;s:12:\"delete-31870\";i:31109;s:12:\"delete-31868\";i:31110;s:12:\"delete-31869\";i:31111;s:12:\"delete-31871\";i:31112;s:12:\"delete-31872\";i:31113;s:12:\"delete-31873\";i:31114;s:12:\"delete-31876\";i:31115;s:12:\"delete-31877\";i:31116;s:12:\"delete-31878\";i:31117;s:12:\"delete-31879\";i:31118;s:12:\"delete-31882\";i:31119;s:12:\"delete-31874\";i:31120;s:12:\"delete-31875\";i:31121;s:12:\"delete-31880\";i:31122;s:12:\"delete-31881\";i:31123;s:12:\"delete-31883\";i:31124;s:12:\"delete-31884\";i:31125;s:12:\"delete-31885\";i:31126;s:12:\"delete-31888\";i:31127;s:12:\"delete-31889\";i:31128;s:12:\"delete-31886\";i:31129;s:12:\"delete-31887\";i:31130;s:12:\"delete-31890\";i:31131;s:12:\"delete-31891\";i:31132;s:12:\"delete-31894\";i:31133;s:12:\"delete-31892\";i:31134;s:12:\"delete-31893\";i:31135;s:12:\"delete-31895\";i:31136;s:12:\"delete-31896\";i:31137;s:12:\"delete-31897\";i:31138;s:12:\"delete-31898\";i:31139;s:12:\"delete-31899\";i:31140;s:12:\"delete-31900\";i:31141;s:12:\"delete-31901\";i:31142;s:12:\"delete-31902\";i:31143;s:12:\"delete-31903\";i:31144;s:12:\"delete-31904\";i:31145;s:12:\"delete-31905\";i:31146;s:12:\"delete-31906\";i:31147;s:12:\"delete-31907\";i:31148;s:12:\"delete-31908\";i:31149;s:12:\"delete-31909\";i:31150;s:12:\"delete-31912\";i:31151;s:12:\"delete-31913\";i:31152;s:12:\"delete-31910\";i:31153;s:12:\"delete-31911\";i:31154;s:12:\"delete-31914\";i:31155;s:12:\"delete-31915\";i:31156;s:12:\"delete-31918\";i:31157;s:12:\"delete-31919\";i:31158;s:12:\"delete-31916\";i:31159;s:12:\"delete-31917\";i:31160;s:12:\"delete-31920\";i:31161;s:12:\"delete-31921\";i:31162;s:12:\"delete-31924\";i:31163;s:12:\"delete-31925\";i:31164;s:12:\"delete-31922\";i:31165;s:12:\"delete-31923\";i:31166;s:12:\"delete-31926\";i:31167;s:12:\"delete-31927\";i:31168;s:12:\"delete-31930\";i:31169;s:12:\"delete-31928\";i:31170;s:12:\"delete-31929\";i:31171;s:12:\"delete-31931\";i:31172;s:12:\"delete-31932\";i:31173;s:12:\"delete-31933\";i:31174;s:12:\"delete-31934\";i:31175;s:12:\"delete-31935\";i:31176;s:12:\"delete-31936\";i:31177;s:12:\"delete-31937\";i:31178;s:12:\"delete-31938\";i:31179;s:12:\"delete-31939\";i:31180;s:12:\"delete-31942\";i:31181;s:12:\"delete-31943\";i:31182;s:12:\"delete-31940\";i:31183;s:12:\"delete-31941\";i:31184;s:12:\"delete-31944\";i:31185;s:12:\"delete-31945\";i:31186;s:12:\"delete-31946\";i:31187;s:12:\"delete-31947\";i:31188;s:12:\"delete-31948\";i:31189;s:12:\"delete-31949\";i:31190;s:12:\"delete-31950\";i:31191;s:12:\"delete-31951\";i:31192;s:12:\"delete-31954\";i:31193;s:12:\"delete-31955\";i:31194;s:12:\"delete-31952\";i:31195;s:12:\"delete-31953\";i:31196;s:12:\"delete-31956\";i:31197;s:12:\"delete-31957\";i:31198;s:12:\"delete-31960\";i:31199;s:12:\"delete-31961\";i:31200;s:12:\"delete-31958\";i:31201;s:12:\"delete-31959\";i:31202;s:12:\"delete-31962\";i:31203;s:12:\"delete-31963\";i:31204;s:12:\"delete-31966\";i:31205;s:12:\"delete-31967\";i:31206;s:12:\"delete-31968\";i:31207;s:12:\"delete-31969\";i:31208;s:12:\"delete-31972\";i:31209;s:12:\"delete-31964\";i:31210;s:12:\"delete-31965\";i:31211;s:12:\"delete-31970\";i:31212;s:12:\"delete-31971\";i:31213;s:12:\"delete-31973\";i:31214;s:12:\"delete-31974\";i:31215;s:12:\"delete-31975\";i:31216;s:12:\"delete-31976\";i:31217;s:12:\"delete-31977\";i:31218;s:12:\"delete-31978\";i:31219;s:12:\"delete-31979\";i:31220;s:12:\"delete-31980\";i:31221;s:12:\"delete-31981\";i:31222;s:12:\"delete-31984\";i:31223;s:12:\"delete-31985\";i:31224;s:12:\"delete-31982\";i:31225;s:12:\"delete-31983\";i:31226;s:12:\"delete-31986\";i:31227;s:12:\"delete-31987\";i:31228;s:12:\"delete-31990\";i:31229;s:12:\"delete-31988\";i:31230;s:12:\"delete-31989\";i:31231;s:12:\"delete-31991\";i:31232;s:12:\"delete-31992\";i:31233;s:12:\"delete-31993\";i:31234;s:12:\"delete-31996\";i:31235;s:12:\"delete-31994\";i:31236;s:12:\"delete-31995\";i:31237;s:12:\"delete-31997\";i:31238;s:12:\"delete-31998\";i:31239;s:12:\"delete-31999\";i:31240;s:12:\"delete-32002\";i:31241;s:12:\"delete-32003\";i:31242;s:12:\"delete-32000\";i:31243;s:12:\"delete-32001\";i:31244;s:12:\"delete-32004\";i:31245;s:12:\"delete-32005\";i:31246;s:12:\"delete-32008\";i:31247;s:12:\"delete-32009\";i:31248;s:12:\"delete-32010\";i:31249;s:12:\"delete-32011\";i:31250;s:12:\"delete-32014\";i:31251;s:12:\"delete-32015\";i:31252;s:12:\"delete-32006\";i:31253;s:12:\"delete-32007\";i:31254;s:12:\"delete-32012\";i:31255;s:12:\"delete-32013\";i:31256;s:12:\"delete-32016\";i:31257;s:12:\"delete-32017\";i:31258;s:12:\"delete-32020\";i:31259;s:12:\"delete-32021\";i:31260;s:12:\"delete-32018\";i:31261;s:12:\"delete-32019\";i:31262;s:12:\"delete-32022\";i:31263;s:12:\"delete-32023\";i:31264;s:12:\"delete-32026\";i:31265;s:12:\"delete-32027\";i:31266;s:12:\"delete-32024\";i:31267;s:12:\"delete-32025\";i:31268;s:12:\"delete-32028\";i:31269;s:12:\"delete-32029\";i:31270;s:12:\"delete-32032\";i:31271;s:12:\"delete-32033\";i:31272;s:12:\"delete-32030\";i:31273;s:12:\"delete-32031\";i:31274;s:12:\"delete-32034\";i:31275;s:12:\"delete-32035\";i:31276;s:12:\"delete-32038\";i:31277;s:12:\"delete-32039\";i:31278;s:12:\"delete-32036\";i:31279;s:12:\"delete-32037\";i:31280;s:12:\"delete-32040\";i:31281;s:12:\"delete-32041\";i:31282;s:12:\"delete-32044\";i:31283;s:12:\"delete-32045\";i:31284;s:12:\"delete-32042\";i:31285;s:12:\"delete-32043\";i:31286;s:12:\"delete-32046\";i:31287;s:12:\"delete-32047\";i:31288;s:12:\"delete-32050\";i:31289;s:12:\"delete-32051\";i:31290;s:12:\"delete-32048\";i:31291;s:12:\"delete-32049\";i:31292;s:12:\"delete-32052\";i:31293;s:12:\"delete-32053\";i:31294;s:12:\"delete-32054\";i:31295;s:12:\"delete-32055\";i:31296;s:12:\"delete-32056\";i:31297;s:12:\"delete-32057\";i:31298;s:12:\"delete-32058\";i:31299;s:12:\"delete-32059\";i:31300;s:12:\"delete-32062\";i:31301;s:12:\"delete-32060\";i:31302;s:12:\"delete-32061\";i:31303;s:12:\"delete-32063\";i:31304;s:12:\"delete-32064\";i:31305;s:12:\"delete-32065\";i:31306;s:12:\"delete-32068\";i:31307;s:12:\"delete-32069\";i:31308;s:12:\"delete-32066\";i:31309;s:12:\"delete-32067\";i:31310;s:12:\"delete-32070\";i:31311;s:12:\"delete-32071\";i:31312;s:12:\"delete-32074\";i:31313;s:12:\"delete-32072\";i:31314;s:12:\"delete-32073\";i:31315;s:12:\"delete-32075\";i:31316;s:12:\"delete-32076\";i:31317;s:12:\"delete-32077\";i:31318;s:12:\"delete-32080\";i:31319;s:12:\"delete-32078\";i:31320;s:12:\"delete-32079\";i:31321;s:12:\"delete-32081\";i:31322;s:12:\"delete-32082\";i:31323;s:12:\"delete-32083\";i:31324;s:12:\"delete-32086\";i:31325;s:12:\"delete-32087\";i:31326;s:12:\"delete-32084\";i:31327;s:12:\"delete-32085\";i:31328;s:12:\"delete-32088\";i:31329;s:12:\"delete-32089\";i:31330;s:12:\"delete-32090\";i:31331;s:12:\"delete-32091\";i:31332;s:12:\"delete-32092\";i:31333;s:12:\"delete-32093\";i:31334;s:12:\"delete-32094\";i:31335;s:12:\"delete-32095\";i:31336;s:12:\"delete-32098\";i:31337;s:12:\"delete-32096\";i:31338;s:12:\"delete-32097\";i:31339;s:12:\"delete-32099\";i:31340;s:12:\"delete-32100\";i:31341;s:12:\"delete-32101\";i:31342;s:12:\"delete-32102\";i:31343;s:12:\"delete-32103\";i:31344;s:12:\"delete-32104\";i:31345;s:12:\"delete-32105\";i:31346;s:12:\"delete-32106\";i:31347;s:12:\"delete-32107\";i:31348;s:12:\"delete-32110\";i:31349;s:12:\"delete-32111\";i:31350;s:12:\"delete-32108\";i:31351;s:12:\"delete-32109\";i:31352;s:12:\"delete-32112\";i:31353;s:12:\"delete-32113\";i:31354;s:12:\"delete-32116\";i:31355;s:12:\"delete-32117\";i:31356;s:12:\"delete-32114\";i:31357;s:12:\"delete-32115\";i:31358;s:12:\"delete-32118\";i:31359;s:12:\"delete-32119\";i:31360;s:12:\"delete-32120\";i:31361;s:12:\"delete-32121\";i:31362;s:12:\"delete-32122\";i:31363;s:12:\"delete-32123\";i:31364;s:12:\"delete-32124\";i:31365;s:12:\"delete-32125\";i:31366;s:12:\"delete-32128\";i:31367;s:12:\"delete-32129\";i:31368;s:12:\"delete-32126\";i:31369;s:12:\"delete-32127\";i:31370;s:12:\"delete-32130\";i:31371;s:12:\"delete-32131\";i:31372;s:12:\"delete-32134\";i:31373;s:12:\"delete-32135\";i:31374;s:12:\"delete-32132\";i:31375;s:12:\"delete-32133\";i:31376;s:12:\"delete-32136\";i:31377;s:12:\"delete-32137\";i:31378;s:12:\"delete-32140\";i:31379;s:12:\"delete-32141\";i:31380;s:12:\"delete-32138\";i:31381;s:12:\"delete-32139\";i:31382;s:12:\"delete-32142\";i:31383;s:12:\"delete-32143\";i:31384;s:12:\"delete-32146\";i:31385;s:12:\"delete-32144\";i:31386;s:12:\"delete-32145\";i:31387;s:12:\"delete-32147\";i:31388;s:12:\"delete-32148\";i:31389;s:12:\"delete-32149\";i:31390;s:12:\"delete-32152\";i:31391;s:12:\"delete-32150\";i:31392;s:12:\"delete-32151\";i:31393;s:12:\"delete-32153\";i:31394;s:12:\"delete-32154\";i:31395;s:12:\"delete-32155\";i:31396;s:12:\"delete-32158\";i:31397;s:12:\"delete-32159\";i:31398;s:12:\"delete-32156\";i:31399;s:12:\"delete-32157\";i:31400;s:12:\"delete-32160\";i:31401;s:12:\"delete-32161\";i:31402;s:12:\"delete-32162\";i:31403;s:12:\"delete-32163\";i:31404;s:12:\"delete-32164\";i:31405;s:12:\"delete-32165\";i:31406;s:12:\"delete-32166\";i:31407;s:12:\"delete-32167\";i:31408;s:12:\"delete-32170\";i:31409;s:12:\"delete-32168\";i:31410;s:12:\"delete-32169\";i:31411;s:12:\"delete-32171\";i:31412;s:12:\"delete-32172\";i:31413;s:12:\"delete-32173\";i:31414;s:12:\"delete-32176\";i:31415;s:12:\"delete-32177\";i:31416;s:12:\"delete-32174\";i:31417;s:12:\"delete-32175\";i:31418;s:12:\"delete-32178\";i:31419;s:12:\"delete-32179\";i:31420;s:12:\"delete-32182\";i:31421;s:12:\"delete-32183\";i:31422;s:12:\"delete-32180\";i:31423;s:12:\"delete-32181\";i:31424;s:12:\"delete-32184\";i:31425;s:12:\"delete-32185\";i:31426;s:12:\"delete-32188\";i:31427;s:12:\"delete-32186\";i:31428;s:12:\"delete-32187\";i:31429;s:12:\"delete-32189\";i:31430;s:12:\"delete-32190\";i:31431;s:12:\"delete-32191\";i:31432;s:12:\"delete-32194\";i:31433;s:12:\"delete-32195\";i:31434;s:12:\"delete-32192\";i:31435;s:12:\"delete-32193\";i:31436;s:12:\"delete-32196\";i:31437;s:12:\"delete-32197\";i:31438;s:12:\"delete-32200\";i:31439;s:12:\"delete-32198\";i:31440;s:12:\"delete-32199\";i:31441;s:12:\"delete-32201\";i:31442;s:12:\"delete-32202\";i:31443;s:12:\"delete-32204\";i:31444;s:12:\"delete-32205\";i:31445;s:12:\"delete-32203\";i:31446;s:12:\"delete-32206\";i:31447;s:12:\"delete-32207\";i:31448;s:12:\"delete-32208\";i:31449;s:12:\"delete-32209\";i:31450;s:12:\"delete-32212\";i:31451;s:12:\"delete-32210\";i:31452;s:12:\"delete-32211\";i:31453;s:12:\"delete-32213\";i:31454;s:12:\"delete-32214\";i:31455;s:12:\"delete-32215\";i:31456;s:12:\"delete-32218\";i:31457;s:12:\"delete-32219\";i:31458;s:12:\"delete-32216\";i:31459;s:12:\"delete-32217\";i:31460;s:12:\"delete-32220\";i:31461;s:12:\"delete-32221\";i:31462;s:12:\"delete-32224\";i:31463;s:12:\"delete-32222\";i:31464;s:12:\"delete-32223\";i:31465;s:12:\"delete-32225\";i:31466;s:12:\"delete-32226\";i:31467;s:12:\"delete-32227\";i:31468;s:12:\"delete-32230\";i:31469;s:12:\"delete-32228\";i:31470;s:12:\"delete-32229\";i:31471;s:12:\"delete-32231\";i:31472;s:12:\"delete-32232\";i:31473;s:12:\"delete-32233\";i:31474;s:12:\"delete-32236\";i:31475;s:12:\"delete-32237\";i:31476;s:12:\"delete-32234\";i:31477;s:12:\"delete-32235\";i:31478;s:12:\"delete-32238\";i:31479;s:12:\"delete-32239\";i:31480;s:12:\"delete-32242\";i:31481;s:12:\"delete-32240\";i:31482;s:12:\"delete-32241\";i:31483;s:12:\"delete-32243\";i:31484;s:12:\"delete-32244\";i:31485;s:12:\"delete-32245\";i:31486;s:12:\"delete-32248\";i:31487;s:12:\"delete-32249\";i:31488;s:12:\"delete-32246\";i:31489;s:12:\"delete-32247\";i:31490;s:12:\"delete-32250\";i:31491;s:12:\"delete-32251\";i:31492;s:12:\"delete-32254\";i:31493;s:12:\"delete-32255\";i:31494;s:12:\"delete-32252\";i:31495;s:12:\"delete-32253\";i:31496;s:12:\"delete-32256\";i:31497;s:12:\"delete-32257\";i:31498;s:12:\"delete-32258\";i:31499;s:12:\"delete-32259\";i:31500;s:12:\"delete-32260\";i:31501;s:12:\"delete-32261\";i:31502;s:12:\"delete-32262\";i:31503;s:12:\"delete-32263\";i:31504;s:12:\"delete-32266\";i:31505;s:12:\"delete-32267\";i:31506;s:12:\"delete-32264\";i:31507;s:12:\"delete-32265\";i:31508;s:12:\"delete-32268\";i:31509;s:12:\"delete-32269\";i:31510;s:12:\"delete-32272\";i:31511;s:12:\"delete-32270\";i:31512;s:12:\"delete-32271\";i:31513;s:12:\"delete-32273\";i:31514;s:12:\"delete-32274\";i:31515;s:12:\"delete-32275\";i:31516;s:12:\"delete-32278\";i:31517;s:12:\"delete-32276\";i:31518;s:12:\"delete-32277\";i:31519;s:12:\"delete-32279\";i:31520;s:12:\"delete-32280\";i:31521;s:12:\"delete-32281\";i:31522;s:12:\"delete-32284\";i:31523;s:12:\"delete-32285\";i:31524;s:12:\"delete-32282\";i:31525;s:12:\"delete-32283\";i:31526;s:12:\"delete-32286\";i:31527;s:12:\"delete-32287\";i:31528;s:12:\"delete-32290\";i:31529;s:12:\"delete-32291\";i:31530;s:12:\"delete-32288\";i:31531;s:12:\"delete-32289\";i:31532;s:12:\"delete-32292\";i:31533;s:12:\"delete-32293\";i:31534;s:12:\"delete-32296\";i:31535;s:12:\"delete-32297\";i:31536;s:12:\"delete-32294\";i:31537;s:12:\"delete-32295\";i:31538;s:12:\"delete-32298\";i:31539;s:12:\"delete-32299\";i:31540;s:12:\"delete-32302\";i:31541;s:12:\"delete-32300\";i:31542;s:12:\"delete-32301\";i:31543;s:12:\"delete-32303\";i:31544;s:12:\"delete-32304\";i:31545;s:12:\"delete-32305\";i:31546;s:12:\"delete-32308\";i:31547;s:12:\"delete-32306\";i:31548;s:12:\"delete-32307\";i:31549;s:12:\"delete-32309\";i:31550;s:12:\"delete-32310\";i:31551;s:12:\"delete-32311\";i:31552;s:12:\"delete-32314\";i:31553;s:12:\"delete-32312\";i:31554;s:12:\"delete-32313\";i:31555;s:12:\"delete-32315\";i:31556;s:12:\"delete-32316\";i:31557;s:12:\"delete-32317\";i:31558;s:12:\"delete-32320\";i:31559;s:12:\"delete-32321\";i:31560;s:12:\"delete-32318\";i:31561;s:12:\"delete-32319\";i:31562;s:12:\"delete-32322\";i:31563;s:12:\"delete-32323\";i:31564;s:12:\"delete-32326\";i:31565;s:12:\"delete-32324\";i:31566;s:12:\"delete-32325\";i:31567;s:12:\"delete-32327\";i:31568;s:12:\"delete-32328\";i:31569;s:12:\"delete-32329\";i:31570;s:12:\"delete-32332\";i:31571;s:12:\"delete-32330\";i:31572;s:12:\"delete-32331\";i:31573;s:12:\"delete-32333\";i:31574;s:12:\"delete-32334\";i:31575;s:12:\"delete-32335\";i:31576;s:12:\"delete-32338\";i:31577;s:12:\"delete-32339\";i:31578;s:12:\"delete-32336\";i:31579;s:12:\"delete-32337\";i:31580;s:12:\"delete-32340\";i:31581;s:12:\"delete-32341\";i:31582;s:12:\"delete-32342\";i:31583;s:12:\"delete-32343\";i:31584;s:12:\"delete-32344\";i:31585;s:12:\"delete-32345\";i:31586;s:12:\"delete-32346\";i:31587;s:12:\"delete-32347\";i:31588;s:12:\"delete-32348\";i:31589;s:12:\"delete-32349\";i:31590;s:12:\"delete-32350\";i:31591;s:12:\"delete-32351\";i:31592;s:12:\"delete-32352\";i:31593;s:12:\"delete-32353\";i:31594;s:12:\"delete-32356\";i:31595;s:12:\"delete-32357\";i:31596;s:12:\"delete-32354\";i:31597;s:12:\"delete-32355\";i:31598;s:12:\"delete-32358\";i:31599;s:12:\"delete-32359\";i:31600;s:12:\"delete-32360\";i:31601;s:12:\"delete-32361\";i:31602;s:12:\"delete-32362\";i:31603;s:12:\"delete-32363\";i:31604;s:12:\"delete-32364\";i:31605;s:12:\"delete-32365\";i:31606;s:12:\"delete-32368\";i:31607;s:12:\"delete-32366\";i:31608;s:12:\"delete-32367\";i:31609;s:12:\"delete-32369\";i:31610;s:12:\"delete-32370\";i:31611;s:12:\"delete-32371\";i:31612;s:12:\"delete-32374\";i:31613;s:12:\"delete-32375\";i:31614;s:12:\"delete-32372\";i:31615;s:12:\"delete-32373\";i:31616;s:12:\"delete-32376\";i:31617;s:12:\"delete-32377\";i:31618;s:12:\"delete-32378\";i:31619;s:12:\"delete-32379\";i:31620;s:12:\"delete-32380\";i:31621;s:12:\"delete-32381\";i:31622;s:12:\"delete-32382\";i:31623;s:12:\"delete-32383\";i:31624;s:12:\"delete-32386\";i:31625;s:12:\"delete-32387\";i:31626;s:12:\"delete-32384\";i:31627;s:12:\"delete-32385\";i:31628;s:12:\"delete-32388\";i:31629;s:12:\"delete-32389\";i:31630;s:12:\"delete-32392\";i:31631;s:12:\"delete-32393\";i:31632;s:12:\"delete-32390\";i:31633;s:12:\"delete-32391\";i:31634;s:12:\"delete-32394\";i:31635;s:12:\"delete-32395\";i:31636;s:12:\"delete-32398\";i:31637;s:12:\"delete-32399\";i:31638;s:12:\"delete-32396\";i:31639;s:12:\"delete-32397\";i:31640;s:12:\"delete-32400\";i:31641;s:12:\"delete-32401\";i:31642;s:12:\"delete-32402\";i:31643;s:12:\"delete-32403\";i:31644;s:12:\"delete-32404\";i:31645;s:12:\"delete-32405\";i:31646;s:12:\"delete-32406\";i:31647;s:12:\"delete-32407\";i:31648;s:12:\"delete-32410\";i:31649;s:12:\"delete-32411\";i:31650;s:12:\"delete-32408\";i:31651;s:12:\"delete-32409\";i:31652;s:12:\"delete-32412\";i:31653;s:12:\"delete-32413\";i:31654;s:12:\"delete-32416\";i:31655;s:12:\"delete-32417\";i:31656;s:12:\"delete-32414\";i:31657;s:12:\"delete-32415\";i:31658;s:12:\"delete-32418\";i:31659;s:12:\"delete-32419\";i:31660;s:12:\"delete-32422\";i:31661;s:12:\"delete-32423\";i:31662;s:12:\"delete-32420\";i:31663;s:12:\"delete-32421\";i:31664;s:12:\"delete-32424\";i:31665;s:12:\"delete-32425\";i:31666;s:12:\"delete-32428\";i:31667;s:12:\"delete-32426\";i:31668;s:12:\"delete-32427\";i:31669;s:12:\"delete-32429\";i:31670;s:12:\"delete-32430\";i:31671;s:12:\"delete-32431\";i:31672;s:12:\"delete-32434\";i:31673;s:12:\"delete-32435\";i:31674;s:12:\"delete-32432\";i:31675;s:12:\"delete-32433\";i:31676;s:12:\"delete-32436\";i:31677;s:12:\"delete-32437\";i:31678;s:12:\"delete-32438\";i:31679;s:12:\"delete-32439\";i:31680;s:12:\"delete-32440\";i:31681;s:12:\"delete-32441\";i:31682;s:12:\"delete-32442\";i:31683;s:12:\"delete-32445\";i:31684;s:12:\"delete-32446\";i:31685;s:12:\"delete-32443\";i:31686;s:12:\"delete-32444\";i:31687;s:12:\"delete-32447\";i:31688;s:12:\"delete-32448\";i:31689;s:12:\"delete-32451\";i:31690;s:12:\"delete-32452\";i:31691;s:12:\"delete-32449\";i:31692;s:12:\"delete-32450\";i:31693;s:12:\"delete-32453\";i:31694;s:12:\"delete-32454\";i:31695;s:12:\"delete-32457\";i:31696;s:12:\"delete-32458\";i:31697;s:12:\"delete-32455\";i:31698;s:12:\"delete-32456\";i:31699;s:12:\"delete-32459\";i:31700;s:12:\"delete-32460\";i:31701;s:12:\"delete-32463\";i:31702;s:12:\"delete-32461\";i:31703;s:12:\"delete-32462\";i:31704;s:12:\"delete-32464\";i:31705;s:12:\"delete-32465\";i:31706;s:12:\"delete-32466\";i:31707;s:12:\"delete-32469\";i:31708;s:12:\"delete-32470\";i:31709;s:12:\"delete-32467\";i:31710;s:12:\"delete-32468\";i:31711;s:12:\"delete-32471\";i:31712;s:12:\"delete-32472\";i:31713;s:12:\"delete-32475\";i:31714;s:12:\"delete-32476\";i:31715;s:12:\"delete-32473\";i:31716;s:12:\"delete-32474\";i:31717;s:12:\"delete-32477\";i:31718;s:12:\"delete-32478\";i:31719;s:12:\"delete-32481\";i:31720;s:12:\"delete-32482\";i:31721;s:12:\"delete-32479\";i:31722;s:12:\"delete-32480\";i:31723;s:12:\"delete-32483\";i:31724;s:12:\"delete-32484\";i:31725;s:12:\"delete-32487\";i:31726;s:12:\"delete-32488\";i:31727;s:12:\"delete-32485\";i:31728;s:12:\"delete-32486\";i:31729;s:12:\"delete-32489\";i:31730;s:12:\"delete-32490\";i:31731;s:12:\"delete-32493\";i:31732;s:12:\"delete-32494\";i:31733;s:12:\"delete-32491\";i:31734;s:12:\"delete-32492\";i:31735;s:12:\"delete-32495\";i:31736;s:12:\"delete-32496\";i:31737;s:12:\"delete-32499\";i:31738;s:12:\"delete-32497\";i:31739;s:12:\"delete-32498\";i:31740;s:12:\"delete-32500\";i:31741;s:12:\"delete-32501\";i:31742;s:12:\"delete-32502\";i:31743;s:12:\"delete-32503\";i:31744;s:12:\"delete-32504\";i:31745;s:12:\"delete-32505\";i:31746;s:12:\"delete-32506\";i:31747;s:12:\"delete-32507\";i:31748;s:12:\"delete-32508\";i:31749;s:12:\"delete-32509\";i:31750;s:12:\"delete-32510\";i:31751;s:12:\"delete-32511\";i:31752;s:12:\"delete-32512\";i:31753;s:12:\"delete-32513\";i:31754;s:12:\"delete-32514\";i:31755;s:12:\"delete-32517\";i:31756;s:12:\"delete-32515\";i:31757;s:12:\"delete-32516\";i:31758;s:12:\"delete-32518\";i:31759;s:12:\"delete-32519\";i:31760;s:12:\"delete-32520\";i:31761;s:12:\"delete-32523\";i:31762;s:12:\"delete-32524\";i:31763;s:12:\"delete-32521\";i:31764;s:12:\"delete-32522\";i:31765;s:12:\"delete-32525\";i:31766;s:12:\"delete-32526\";i:31767;s:12:\"delete-32529\";i:31768;s:12:\"delete-32527\";i:31769;s:12:\"delete-32528\";i:31770;s:12:\"delete-32530\";i:31771;s:12:\"delete-32531\";i:31772;s:12:\"delete-32532\";i:31773;s:12:\"delete-32535\";i:31774;s:12:\"delete-32536\";i:31775;s:12:\"delete-32533\";i:31776;s:12:\"delete-32534\";i:31777;s:12:\"delete-32537\";i:31778;s:12:\"delete-32538\";i:31779;s:12:\"delete-32541\";i:31780;s:12:\"delete-32542\";i:31781;s:12:\"delete-32539\";i:31782;s:12:\"delete-32540\";i:31783;s:12:\"delete-32543\";i:31784;s:12:\"delete-32544\";i:31785;s:12:\"delete-32547\";i:31786;s:12:\"delete-32548\";i:31787;s:12:\"delete-32545\";i:31788;s:12:\"delete-32546\";i:31789;s:12:\"delete-32549\";i:31790;s:12:\"delete-32550\";i:31791;s:12:\"delete-32553\";i:31792;s:12:\"delete-32551\";i:31793;s:12:\"delete-32552\";i:31794;s:12:\"delete-32554\";i:31795;s:12:\"delete-32555\";i:31796;s:12:\"delete-32556\";i:31797;s:12:\"delete-32557\";i:31798;s:12:\"delete-32558\";i:31799;s:12:\"delete-32559\";i:31800;s:12:\"delete-32560\";i:31801;s:12:\"delete-32561\";i:31802;s:12:\"delete-32562\";i:31803;s:12:\"delete-32565\";i:31804;s:12:\"delete-32563\";i:31805;s:12:\"delete-32564\";i:31806;s:12:\"delete-32566\";i:31807;s:12:\"delete-32567\";i:31808;s:12:\"delete-32568\";i:31809;s:12:\"delete-32571\";i:31810;s:12:\"delete-32569\";i:31811;s:12:\"delete-32570\";i:31812;s:12:\"delete-32572\";i:31813;s:12:\"delete-32573\";i:31814;s:12:\"delete-32574\";i:31815;s:12:\"delete-32575\";i:31816;s:12:\"delete-32576\";i:31817;s:12:\"delete-32577\";i:31818;s:12:\"delete-32578\";i:31819;s:12:\"delete-32579\";i:31820;s:12:\"delete-32580\";i:31821;s:12:\"delete-32581\";i:31822;s:12:\"delete-32582\";i:31823;s:12:\"delete-32583\";i:31824;s:12:\"delete-32584\";i:31825;s:12:\"delete-32585\";i:31826;s:12:\"delete-32586\";i:31827;s:12:\"delete-32589\";i:31828;s:12:\"delete-32587\";i:31829;s:12:\"delete-32588\";i:31830;s:12:\"delete-32590\";i:31831;s:12:\"delete-32591\";i:31832;s:12:\"delete-32592\";i:31833;s:12:\"delete-32595\";i:31834;s:12:\"delete-32596\";i:31835;s:12:\"delete-32593\";i:31836;s:12:\"delete-32594\";i:31837;s:12:\"delete-32597\";i:31838;s:12:\"delete-32598\";i:31839;s:12:\"delete-32599\";i:31840;s:12:\"delete-32600\";i:31841;s:12:\"delete-32601\";i:31842;s:12:\"delete-32602\";i:31843;s:12:\"delete-32603\";i:31844;s:12:\"delete-32604\";i:31845;s:12:\"delete-32607\";i:31846;s:12:\"delete-32608\";i:31847;s:12:\"delete-32605\";i:31848;s:12:\"delete-32606\";i:31849;s:12:\"delete-32609\";i:31850;s:12:\"delete-32610\";i:31851;s:12:\"delete-32613\";i:31852;s:12:\"delete-32611\";i:31853;s:12:\"delete-32612\";i:31854;s:12:\"delete-32614\";i:31855;s:12:\"delete-32615\";i:31856;s:12:\"delete-32616\";i:31857;s:12:\"delete-32619\";i:31858;s:12:\"delete-32617\";i:31859;s:12:\"delete-32618\";i:31860;s:12:\"delete-32620\";i:31861;s:12:\"delete-32621\";i:31862;s:12:\"delete-32622\";i:31863;s:12:\"delete-32625\";i:31864;s:12:\"delete-32626\";i:31865;s:12:\"delete-32623\";i:31866;s:12:\"delete-32624\";i:31867;s:12:\"delete-32627\";i:31868;s:12:\"delete-32628\";i:31869;s:12:\"delete-32631\";i:31870;s:12:\"delete-32629\";i:31871;s:12:\"delete-32630\";i:31872;s:12:\"delete-32632\";i:31873;s:12:\"delete-32633\";i:31874;s:12:\"delete-32634\";i:31875;s:12:\"delete-32637\";i:31876;s:12:\"delete-32638\";i:31877;s:12:\"delete-32635\";i:31878;s:12:\"delete-32636\";i:31879;s:12:\"delete-32639\";i:31880;s:12:\"delete-32640\";i:31881;s:12:\"delete-32641\";i:31882;s:12:\"delete-32642\";i:31883;s:12:\"delete-32643\";i:31884;s:12:\"delete-32644\";i:31885;s:12:\"delete-32645\";i:31886;s:12:\"delete-32646\";i:31887;s:12:\"delete-32649\";i:31888;s:12:\"delete-32650\";i:31889;s:12:\"delete-32647\";i:31890;s:12:\"delete-32648\";i:31891;s:12:\"delete-32651\";i:31892;s:12:\"delete-32652\";i:31893;s:12:\"delete-32655\";i:31894;s:12:\"delete-32656\";i:31895;s:12:\"delete-32653\";i:31896;s:12:\"delete-32654\";i:31897;s:12:\"delete-32657\";i:31898;s:12:\"delete-32658\";i:31899;s:12:\"delete-32659\";i:31900;s:12:\"delete-32660\";i:31901;s:12:\"delete-32661\";i:31902;s:12:\"delete-32662\";i:31903;s:12:\"delete-32663\";i:31904;s:12:\"delete-32664\";i:31905;s:12:\"delete-32667\";i:31906;s:12:\"delete-32668\";i:31907;s:12:\"delete-32665\";i:31908;s:12:\"delete-32666\";i:31909;s:12:\"delete-32669\";i:31910;s:12:\"delete-32670\";i:31911;s:12:\"delete-32673\";i:31912;s:12:\"delete-32671\";i:31913;s:12:\"delete-32672\";i:31914;s:12:\"delete-32674\";i:31915;s:12:\"delete-32675\";i:31916;s:12:\"delete-32676\";i:31917;s:12:\"delete-32679\";i:31918;s:12:\"delete-32677\";i:31919;s:12:\"delete-32678\";i:31920;s:12:\"delete-32680\";i:31921;s:12:\"delete-32681\";i:31922;s:12:\"delete-32682\";i:31923;s:12:\"delete-32683\";i:31924;s:12:\"delete-32684\";i:31925;s:12:\"delete-32685\";i:31926;s:12:\"delete-32686\";i:31927;s:12:\"delete-32687\";i:31928;s:12:\"delete-32688\";i:31929;s:12:\"delete-32691\";i:31930;s:12:\"delete-32692\";i:31931;s:12:\"delete-32689\";i:31932;s:12:\"delete-32690\";i:31933;s:12:\"delete-32693\";i:31934;s:12:\"delete-32694\";i:31935;s:12:\"delete-32697\";i:31936;s:12:\"delete-32695\";i:31937;s:12:\"delete-32696\";i:31938;s:12:\"delete-32698\";i:31939;s:12:\"delete-32699\";i:31940;s:12:\"delete-32700\";i:31941;s:12:\"delete-32703\";i:31942;s:12:\"delete-32704\";i:31943;s:12:\"delete-32701\";i:31944;s:12:\"delete-32702\";i:31945;s:12:\"delete-32705\";i:31946;s:12:\"delete-32706\";i:31947;s:12:\"delete-32709\";i:31948;s:12:\"delete-32707\";i:31949;s:12:\"delete-32708\";i:31950;s:12:\"delete-32710\";i:31951;s:12:\"delete-32711\";i:31952;s:12:\"delete-32712\";i:31953;s:12:\"delete-32715\";i:31954;s:12:\"delete-32716\";i:31955;s:12:\"delete-32713\";i:31956;s:12:\"delete-32714\";i:31957;s:12:\"delete-32717\";i:31958;s:12:\"delete-32718\";i:31959;s:12:\"delete-32721\";i:31960;s:12:\"delete-32719\";i:31961;s:12:\"delete-32720\";i:31962;s:12:\"delete-32722\";i:31963;s:12:\"delete-32723\";i:31964;s:12:\"delete-32724\";i:31965;s:12:\"delete-32727\";i:31966;s:12:\"delete-32728\";i:31967;s:12:\"delete-32725\";i:31968;s:12:\"delete-32726\";i:31969;s:12:\"delete-32729\";i:31970;s:12:\"delete-32730\";i:31971;s:12:\"delete-32733\";i:31972;s:12:\"delete-32731\";i:31973;s:12:\"delete-32732\";i:31974;s:12:\"delete-32734\";i:31975;s:12:\"delete-32735\";i:31976;s:12:\"delete-32736\";i:31977;s:12:\"delete-32739\";i:31978;s:12:\"delete-32740\";i:31979;s:12:\"delete-32737\";i:31980;s:12:\"delete-32738\";i:31981;s:12:\"delete-32741\";i:31982;s:12:\"delete-32742\";i:31983;s:12:\"delete-32743\";i:31984;s:12:\"delete-32744\";i:31985;s:12:\"delete-32745\";i:31986;s:12:\"delete-32746\";i:31987;s:12:\"delete-32747\";i:31988;s:12:\"delete-32748\";i:31989;s:12:\"delete-32751\";i:31990;s:12:\"delete-32752\";i:31991;s:12:\"delete-32749\";i:31992;s:12:\"delete-32750\";i:31993;s:12:\"delete-32753\";i:31994;s:12:\"delete-32754\";i:31995;s:12:\"delete-32757\";i:31996;s:12:\"delete-32758\";i:31997;s:12:\"delete-32755\";i:31998;s:12:\"delete-32756\";i:31999;s:12:\"delete-32759\";i:32000;s:12:\"delete-32760\";i:32001;s:12:\"delete-32761\";i:32002;s:12:\"delete-32762\";i:32003;s:12:\"delete-32763\";i:32004;s:12:\"delete-32764\";i:32005;s:12:\"delete-32765\";i:32006;s:12:\"delete-32766\";i:32007;s:12:\"delete-32769\";i:32008;s:12:\"delete-32767\";i:32009;s:12:\"delete-32768\";i:32010;s:12:\"delete-32770\";i:32011;s:12:\"delete-32771\";i:32012;s:12:\"delete-32772\";i:32013;s:12:\"delete-32773\";i:32014;s:12:\"delete-32774\";i:32015;s:12:\"delete-32775\";i:32016;s:12:\"delete-32776\";i:32017;s:12:\"delete-32777\";i:32018;s:12:\"delete-32778\";i:32019;s:12:\"delete-32781\";i:32020;s:12:\"delete-32782\";i:32021;s:12:\"delete-32779\";i:32022;s:12:\"delete-32780\";i:32023;s:12:\"delete-32783\";i:32024;s:12:\"delete-32787\";i:32025;s:12:\"delete-32784\";i:32026;s:12:\"delete-32788\";i:32027;s:12:\"delete-32785\";i:32028;s:12:\"delete-32786\";i:32029;s:12:\"delete-32789\";i:32030;s:12:\"delete-32790\";i:32031;s:12:\"delete-32793\";i:32032;s:12:\"delete-32791\";i:32033;s:12:\"delete-32792\";i:32034;s:12:\"delete-32794\";i:32035;s:12:\"delete-32795\";i:32036;s:12:\"delete-32796\";i:32037;s:12:\"delete-32799\";i:32038;s:12:\"delete-32800\";i:32039;s:12:\"delete-32797\";i:32040;s:12:\"delete-32798\";i:32041;s:12:\"delete-32801\";i:32042;s:12:\"delete-32802\";i:32043;s:12:\"delete-32805\";i:32044;s:12:\"delete-32806\";i:32045;s:12:\"delete-32803\";i:32046;s:12:\"delete-32804\";i:32047;s:12:\"delete-32807\";i:32048;s:12:\"delete-32808\";i:32049;s:12:\"delete-32809\";i:32050;s:12:\"delete-32810\";i:32051;s:12:\"delete-32811\";i:32052;s:12:\"delete-32812\";i:32053;s:12:\"delete-32813\";i:32054;s:12:\"delete-32814\";i:32055;s:12:\"delete-32817\";i:32056;s:12:\"delete-32818\";i:32057;s:12:\"delete-32815\";i:32058;s:12:\"delete-32816\";i:32059;s:12:\"delete-32819\";i:32060;s:12:\"delete-32820\";i:32061;s:12:\"delete-32823\";i:32062;s:12:\"delete-32824\";i:32063;s:12:\"delete-32821\";i:32064;s:12:\"delete-32822\";i:32065;s:12:\"delete-32825\";i:32066;s:12:\"delete-32826\";i:32067;s:12:\"delete-32829\";i:32068;s:12:\"delete-32827\";i:32069;s:12:\"delete-32828\";i:32070;s:12:\"delete-32830\";i:32071;s:12:\"delete-32831\";i:32072;s:12:\"delete-32832\";i:32073;s:12:\"delete-32835\";i:32074;s:12:\"delete-32833\";i:32075;s:12:\"delete-32834\";i:32076;s:12:\"delete-32836\";i:32077;s:12:\"delete-32837\";i:32078;s:12:\"delete-32838\";i:32079;s:12:\"delete-32841\";i:32080;s:12:\"delete-32842\";i:32081;s:12:\"delete-32839\";i:32082;s:12:\"delete-32840\";i:32083;s:12:\"delete-32843\";i:32084;s:12:\"delete-32844\";i:32085;s:12:\"delete-32847\";i:32086;s:12:\"delete-32845\";i:32087;s:12:\"delete-32846\";i:32088;s:12:\"delete-32848\";i:32089;s:12:\"delete-32849\";i:32090;s:12:\"delete-32850\";i:32091;s:12:\"delete-32853\";i:32092;s:12:\"delete-32854\";i:32093;s:12:\"delete-32851\";i:32094;s:12:\"delete-32852\";i:32095;s:12:\"delete-32855\";i:32096;s:12:\"delete-32856\";i:32097;s:12:\"delete-32859\";i:32098;s:12:\"delete-32860\";i:32099;s:12:\"delete-32857\";i:32100;s:12:\"delete-32858\";i:32101;s:12:\"delete-32861\";i:32102;s:12:\"delete-32862\";i:32103;s:12:\"delete-32865\";i:32104;s:12:\"delete-32863\";i:32105;s:12:\"delete-32864\";i:32106;s:12:\"delete-32866\";i:32107;s:12:\"delete-32867\";i:32108;s:12:\"delete-32868\";i:32109;s:12:\"delete-32871\";i:32110;s:12:\"delete-32872\";i:32111;s:12:\"delete-32869\";i:32112;s:12:\"delete-32870\";i:32113;s:12:\"delete-32873\";i:32114;s:12:\"delete-32874\";i:32115;s:12:\"delete-32877\";i:32116;s:12:\"delete-32878\";i:32117;s:12:\"delete-32875\";i:32118;s:12:\"delete-32876\";i:32119;s:12:\"delete-32879\";i:32120;s:12:\"delete-32880\";i:32121;s:12:\"delete-32883\";i:32122;s:12:\"delete-32881\";i:32123;s:12:\"delete-32882\";i:32124;s:12:\"delete-32884\";i:32125;s:12:\"delete-32885\";i:32126;s:12:\"delete-32886\";i:32127;s:12:\"delete-32887\";i:32128;s:12:\"delete-32888\";i:32129;s:12:\"delete-32889\";i:32130;s:12:\"delete-32890\";i:32131;s:12:\"delete-32891\";i:32132;s:12:\"delete-32892\";i:32133;s:12:\"delete-32895\";i:32134;s:12:\"delete-32896\";i:32135;s:12:\"delete-32893\";i:32136;s:12:\"delete-32894\";i:32137;s:12:\"delete-32897\";i:32138;s:12:\"delete-32901\";i:32139;s:12:\"delete-32898\";i:32140;s:12:\"delete-32902\";i:32141;s:12:\"delete-32899\";i:32142;s:12:\"delete-32900\";i:32143;s:12:\"delete-32903\";i:32144;s:12:\"delete-32904\";i:32145;s:12:\"delete-32905\";i:32146;s:12:\"delete-32906\";i:32147;s:12:\"delete-32907\";i:32148;s:12:\"delete-32908\";i:32149;s:12:\"delete-32909\";i:32150;s:12:\"delete-32910\";i:32151;s:12:\"delete-32913\";i:32152;s:12:\"delete-32911\";i:32153;s:12:\"delete-32912\";i:32154;s:12:\"delete-32914\";i:32155;s:12:\"delete-32916\";i:32156;s:12:\"delete-32915\";i:32157;s:12:\"delete-32919\";i:32158;s:12:\"delete-32920\";i:32159;s:12:\"delete-32917\";i:32160;s:12:\"delete-32918\";i:32161;s:12:\"delete-32921\";i:32162;s:12:\"delete-32922\";i:32163;s:12:\"delete-32925\";i:32164;s:12:\"delete-32926\";i:32165;s:12:\"delete-32923\";i:32166;s:12:\"delete-32924\";i:32167;s:12:\"delete-32927\";i:32168;s:12:\"delete-32928\";i:32169;s:12:\"delete-32931\";i:32170;s:12:\"delete-32929\";i:32171;s:12:\"delete-32930\";i:32172;s:12:\"delete-32932\";i:32173;s:12:\"delete-32933\";i:32174;s:12:\"delete-32934\";i:32175;s:12:\"delete-32937\";i:32176;s:12:\"delete-32938\";i:32177;s:12:\"delete-32935\";i:32178;s:12:\"delete-32936\";i:32179;s:12:\"delete-32939\";i:32180;s:12:\"delete-32940\";i:32181;s:12:\"delete-32943\";i:32182;s:12:\"delete-32941\";i:32183;s:12:\"delete-32942\";i:32184;s:12:\"delete-32944\";i:32185;s:12:\"delete-32945\";i:32186;s:12:\"delete-32946\";i:32187;s:12:\"delete-32949\";i:32188;s:12:\"delete-32950\";i:32189;s:12:\"delete-32947\";i:32190;s:12:\"delete-32948\";i:32191;s:12:\"delete-32951\";i:32192;s:12:\"delete-32952\";i:32193;s:12:\"delete-32955\";i:32194;s:12:\"delete-32953\";i:32195;s:12:\"delete-32954\";i:32196;s:12:\"delete-32956\";i:32197;s:12:\"delete-32957\";i:32198;s:12:\"delete-32958\";i:32199;s:12:\"delete-32961\";i:32200;s:12:\"delete-32959\";i:32201;s:12:\"delete-32960\";i:32202;s:12:\"delete-32962\";i:32203;s:12:\"delete-32963\";i:32204;s:12:\"delete-32964\";i:32205;s:12:\"delete-32967\";i:32206;s:12:\"delete-32965\";i:32207;s:12:\"delete-32966\";i:32208;s:12:\"delete-32968\";i:32209;s:12:\"delete-32969\";i:32210;s:12:\"delete-32970\";i:32211;s:12:\"delete-32973\";i:32212;s:12:\"delete-32974\";i:32213;s:12:\"delete-32971\";i:32214;s:12:\"delete-32972\";i:32215;s:12:\"delete-32975\";i:32216;s:12:\"delete-32976\";i:32217;s:12:\"delete-32979\";i:32218;s:12:\"delete-32977\";i:32219;s:12:\"delete-32978\";i:32220;s:12:\"delete-32980\";i:32221;s:12:\"delete-32982\";i:32222;s:12:\"delete-32981\";i:32223;s:12:\"delete-32985\";i:32224;s:12:\"delete-32986\";i:32225;s:12:\"delete-32983\";i:32226;s:12:\"delete-32984\";i:32227;s:12:\"delete-32987\";i:32228;s:12:\"delete-32988\";i:32229;s:12:\"delete-32989\";i:32230;s:12:\"delete-32990\";i:32231;s:12:\"delete-32991\";i:32232;s:12:\"delete-32992\";i:32233;s:12:\"delete-32993\";i:32234;s:12:\"delete-32994\";i:32235;s:12:\"delete-32995\";i:32236;s:12:\"delete-32996\";i:32237;s:12:\"delete-32997\";i:32238;s:12:\"delete-32998\";i:32239;s:12:\"delete-32999\";i:32240;s:12:\"delete-33000\";i:32241;s:12:\"delete-33003\";i:32242;s:12:\"delete-33001\";i:32243;s:12:\"delete-33002\";i:32244;s:12:\"delete-33004\";i:32245;s:12:\"delete-33005\";i:32246;s:12:\"delete-33006\";i:32247;s:12:\"delete-33009\";i:32248;s:12:\"delete-33010\";i:32249;s:12:\"delete-33007\";i:32250;s:12:\"delete-33008\";i:32251;s:12:\"delete-33011\";i:32252;s:12:\"delete-33012\";i:32253;s:12:\"delete-33013\";i:32254;s:12:\"delete-33014\";i:32255;s:12:\"delete-33015\";i:32256;s:12:\"delete-33016\";i:32257;s:12:\"delete-33017\";i:32258;s:12:\"delete-33020\";i:32259;s:12:\"delete-33021\";i:32260;s:12:\"delete-33018\";i:32261;s:12:\"delete-33019\";i:32262;s:12:\"delete-33022\";i:32263;s:12:\"delete-33023\";i:32264;s:12:\"delete-33026\";i:32265;s:12:\"delete-33027\";i:32266;s:12:\"delete-33024\";i:32267;s:12:\"delete-33025\";i:32268;s:12:\"delete-33028\";i:32269;s:12:\"delete-33029\";i:32270;s:12:\"delete-33032\";i:32271;s:12:\"delete-33030\";i:32272;s:12:\"delete-33031\";i:32273;s:12:\"delete-33033\";i:32274;s:12:\"delete-33034\";i:32275;s:12:\"delete-33035\";i:32276;s:12:\"delete-33038\";i:32277;s:12:\"delete-33036\";i:32278;s:12:\"delete-33037\";i:32279;s:12:\"delete-33039\";i:32280;s:12:\"delete-33040\";i:32281;s:12:\"delete-33041\";i:32282;s:12:\"delete-33044\";i:32283;s:12:\"delete-33042\";i:32284;s:12:\"delete-33043\";i:32285;s:12:\"delete-33045\";i:32286;s:12:\"delete-33046\";i:32287;s:12:\"delete-33047\";i:32288;s:12:\"delete-33050\";i:32289;s:12:\"delete-33051\";i:32290;s:12:\"delete-33048\";i:32291;s:12:\"delete-33049\";i:32292;s:12:\"delete-33052\";i:32293;s:12:\"delete-33053\";i:32294;s:12:\"delete-33056\";i:32295;s:12:\"delete-33057\";i:32296;s:12:\"delete-33054\";i:32297;s:12:\"delete-33055\";i:32298;s:12:\"delete-33058\";i:32299;s:12:\"delete-33059\";i:32300;s:12:\"delete-33062\";i:32301;s:12:\"delete-33060\";i:32302;s:12:\"delete-33061\";i:32303;s:12:\"delete-33063\";i:32304;s:12:\"delete-33064\";i:32305;s:12:\"delete-33065\";i:32306;s:12:\"delete-33066\";i:32307;s:12:\"delete-33067\";i:32308;s:12:\"delete-33068\";i:32309;s:12:\"delete-33069\";i:32310;s:12:\"delete-33070\";i:32311;s:12:\"delete-33071\";i:32312;s:12:\"delete-33074\";i:32313;s:12:\"delete-33075\";i:32314;s:12:\"delete-33072\";i:32315;s:12:\"delete-33073\";i:32316;s:12:\"delete-33076\";i:32317;s:12:\"delete-33077\";i:32318;s:12:\"delete-33078\";i:32319;s:12:\"delete-33079\";i:32320;s:12:\"delete-33080\";i:32321;s:12:\"delete-33081\";i:32322;s:12:\"delete-33082\";i:32323;s:12:\"delete-33083\";i:32324;s:12:\"delete-33086\";i:32325;s:12:\"delete-33084\";i:32326;s:12:\"delete-33085\";i:32327;s:12:\"delete-33087\";i:32328;s:12:\"delete-33088\";i:32329;s:12:\"delete-33089\";i:32330;s:12:\"delete-33092\";i:32331;s:12:\"delete-33093\";i:32332;s:12:\"delete-33090\";i:32333;s:12:\"delete-33091\";i:32334;s:12:\"delete-33094\";i:32335;s:12:\"delete-33095\";i:32336;s:12:\"delete-33096\";i:32337;s:12:\"delete-33097\";i:32338;s:12:\"delete-33098\";i:32339;s:12:\"delete-33099\";i:32340;s:12:\"delete-33100\";i:32341;s:12:\"delete-33101\";i:32342;s:12:\"delete-33102\";i:32343;s:12:\"delete-33103\";i:32344;s:12:\"delete-33104\";i:32345;s:12:\"delete-33105\";i:32346;s:12:\"delete-33106\";i:32347;s:12:\"delete-33107\";i:32348;s:12:\"delete-33110\";i:32349;s:12:\"delete-33108\";i:32350;s:12:\"delete-33109\";i:32351;s:12:\"delete-33111\";i:32352;s:12:\"delete-33112\";i:32353;s:12:\"delete-33113\";i:32354;s:12:\"delete-33116\";i:32355;s:12:\"delete-33117\";i:32356;s:12:\"delete-33114\";i:32357;s:12:\"delete-33115\";i:32358;s:12:\"delete-33118\";i:32359;s:12:\"delete-33119\";i:32360;s:12:\"delete-33120\";i:32361;s:12:\"delete-33121\";i:32362;s:12:\"delete-33122\";i:32363;s:12:\"delete-33123\";i:32364;s:12:\"delete-33124\";i:32365;s:12:\"delete-33125\";i:32366;s:12:\"delete-33128\";i:32367;s:12:\"delete-33126\";i:32368;s:12:\"delete-33127\";i:32369;s:12:\"delete-33129\";i:32370;s:12:\"delete-33130\";i:32371;s:12:\"delete-33131\";i:32372;s:12:\"delete-33134\";i:32373;s:12:\"delete-33135\";i:32374;s:12:\"delete-33132\";i:32375;s:12:\"delete-33133\";i:32376;s:12:\"delete-33136\";i:32377;s:12:\"delete-33137\";i:32378;s:12:\"delete-33140\";i:32379;s:12:\"delete-33138\";i:32380;s:12:\"delete-33139\";i:32381;s:12:\"delete-33141\";i:32382;s:12:\"delete-33142\";i:32383;s:12:\"delete-33143\";i:32384;s:12:\"delete-33146\";i:32385;s:12:\"delete-33147\";i:32386;s:12:\"delete-33144\";i:32387;s:12:\"delete-33145\";i:32388;s:12:\"delete-33148\";i:32389;s:12:\"delete-33150\";i:32390;s:12:\"delete-33151\";i:32391;s:12:\"delete-33149\";i:32392;s:12:\"delete-33152\";i:32393;s:12:\"delete-33153\";i:32394;s:12:\"delete-33154\";i:32395;s:12:\"delete-33155\";i:32396;s:12:\"delete-33156\";i:32397;s:12:\"delete-33157\";i:32398;s:12:\"delete-33158\";i:32399;s:12:\"delete-33159\";i:32400;s:12:\"delete-33160\";i:32401;s:12:\"delete-33161\";i:32402;s:12:\"delete-33162\";i:32403;s:12:\"delete-33163\";i:32404;s:12:\"delete-33164\";i:32405;s:12:\"delete-33165\";i:32406;s:12:\"delete-33166\";i:32407;s:12:\"delete-33167\";i:32408;s:12:\"delete-33170\";i:32409;s:12:\"delete-33168\";i:32410;s:12:\"delete-33169\";i:32411;s:12:\"delete-33171\";i:32412;s:12:\"delete-33172\";i:32413;s:12:\"delete-33173\";i:32414;s:12:\"delete-33176\";i:32415;s:12:\"delete-33174\";i:32416;s:12:\"delete-33175\";i:32417;s:12:\"delete-33177\";i:32418;s:12:\"delete-33178\";i:32419;s:12:\"delete-33179\";i:32420;s:12:\"delete-33182\";i:32421;s:12:\"delete-33183\";i:32422;s:12:\"delete-33180\";i:32423;s:12:\"delete-33181\";i:32424;s:12:\"delete-33184\";i:32425;s:12:\"delete-33185\";i:32426;s:12:\"delete-33188\";i:32427;s:12:\"delete-33189\";i:32428;s:12:\"delete-33186\";i:32429;s:12:\"delete-33187\";i:32430;s:12:\"delete-33190\";i:32431;s:12:\"delete-33191\";i:32432;s:12:\"delete-33194\";i:32433;s:12:\"delete-33195\";i:32434;s:12:\"delete-33192\";i:32435;s:12:\"delete-33193\";i:32436;s:12:\"delete-33196\";i:32437;s:12:\"delete-33198\";i:32438;s:12:\"delete-33199\";i:32439;s:12:\"delete-33197\";i:32440;s:12:\"delete-33200\";i:32441;s:12:\"delete-33201\";i:32442;s:12:\"delete-33202\";i:32443;s:12:\"delete-33203\";i:32444;s:12:\"delete-33206\";i:32445;s:12:\"delete-33204\";i:32446;s:12:\"delete-33205\";i:32447;s:12:\"delete-33207\";i:32448;s:12:\"delete-33208\";i:32449;s:12:\"delete-33211\";i:32450;s:12:\"delete-33212\";i:32451;s:12:\"delete-33209\";i:32452;s:12:\"delete-33210\";i:32453;s:12:\"delete-33213\";i:32454;s:12:\"delete-33214\";i:32455;s:12:\"delete-33217\";i:32456;s:12:\"delete-33218\";i:32457;s:12:\"delete-33219\";i:32458;s:12:\"delete-33220\";i:32459;s:12:\"delete-33223\";i:32460;s:12:\"delete-33215\";i:32461;s:12:\"delete-33216\";i:32462;s:12:\"delete-33221\";i:32463;s:12:\"delete-33222\";i:32464;s:12:\"delete-33224\";i:32465;s:12:\"delete-33225\";i:32466;s:12:\"delete-33226\";i:32467;s:12:\"delete-33229\";i:32468;s:12:\"delete-33230\";i:32469;s:12:\"delete-33227\";i:32470;s:12:\"delete-33228\";i:32471;s:12:\"delete-33231\";i:32472;s:12:\"delete-33232\";i:32473;s:12:\"delete-33233\";i:32474;s:12:\"delete-33234\";i:32475;s:12:\"delete-33235\";i:32476;s:12:\"delete-33236\";i:32477;s:12:\"delete-33237\";i:32478;s:12:\"delete-33238\";i:32479;s:12:\"delete-33241\";i:32480;s:12:\"delete-33242\";i:32481;s:12:\"delete-33239\";i:32482;s:12:\"delete-33240\";i:32483;s:12:\"delete-33243\";i:32484;s:12:\"delete-33244\";i:32485;s:12:\"delete-33247\";i:32486;s:12:\"delete-33245\";i:32487;s:12:\"delete-33246\";i:32488;s:12:\"delete-33248\";i:32489;s:12:\"delete-33249\";i:32490;s:12:\"delete-33250\";i:32491;s:12:\"delete-33253\";i:32492;s:12:\"delete-33254\";i:32493;s:12:\"delete-33251\";i:32494;s:12:\"delete-33252\";i:32495;s:12:\"delete-33255\";i:32496;s:12:\"delete-33256\";i:32497;s:12:\"delete-33259\";i:32498;s:12:\"delete-33260\";i:32499;s:12:\"delete-33257\";i:32500;s:12:\"delete-33258\";i:32501;s:12:\"delete-33261\";i:32502;s:12:\"delete-33262\";i:32503;s:12:\"delete-33265\";i:32504;s:12:\"delete-33266\";i:32505;s:12:\"delete-33263\";i:32506;s:12:\"delete-33264\";i:32507;s:12:\"delete-33267\";i:32508;s:12:\"delete-33268\";i:32509;s:12:\"delete-33271\";i:32510;s:12:\"delete-33272\";i:32511;s:12:\"delete-33269\";i:32512;s:12:\"delete-33270\";i:32513;s:12:\"delete-33273\";i:32514;s:12:\"delete-33274\";i:32515;s:12:\"delete-33275\";i:32516;s:12:\"delete-33276\";i:32517;s:12:\"delete-33277\";i:32518;s:12:\"delete-33278\";i:32519;s:12:\"delete-33279\";i:32520;s:12:\"delete-33280\";i:32521;s:12:\"delete-33283\";i:32522;s:12:\"delete-33281\";i:32523;s:12:\"delete-33282\";i:32524;s:12:\"delete-33284\";i:32525;s:12:\"delete-33285\";i:32526;s:12:\"delete-33286\";i:32527;s:12:\"delete-33289\";i:32528;s:12:\"delete-33287\";i:32529;s:12:\"delete-33288\";i:32530;s:12:\"delete-33290\";i:32531;s:12:\"delete-33291\";i:32532;s:12:\"delete-33292\";i:32533;s:12:\"delete-33295\";i:32534;s:12:\"delete-33296\";i:32535;s:12:\"delete-33293\";i:32536;s:12:\"delete-33294\";i:32537;s:12:\"delete-33297\";i:32538;s:12:\"delete-33298\";i:32539;s:12:\"delete-33299\";i:32540;s:12:\"delete-33300\";i:32541;s:12:\"delete-33301\";i:32542;s:12:\"delete-33302\";i:32543;s:12:\"delete-33303\";i:32544;s:12:\"delete-33304\";i:32545;s:12:\"delete-33307\";i:32546;s:12:\"delete-33305\";i:32547;s:12:\"delete-33306\";i:32548;s:12:\"delete-33308\";i:32549;s:12:\"delete-33309\";i:32550;s:12:\"delete-33310\";i:32551;s:12:\"delete-33313\";i:32552;s:12:\"delete-33311\";i:32553;s:12:\"delete-33312\";i:32554;s:12:\"delete-33314\";i:32555;s:12:\"delete-33315\";i:32556;s:12:\"delete-33316\";i:32557;s:12:\"delete-33319\";i:32558;s:12:\"delete-33320\";i:32559;s:12:\"delete-33317\";i:32560;s:12:\"delete-33318\";i:32561;s:12:\"delete-33321\";i:32562;s:12:\"delete-33322\";i:32563;s:12:\"delete-33325\";i:32564;s:12:\"delete-33326\";i:32565;s:12:\"delete-33323\";i:32566;s:12:\"delete-33324\";i:32567;s:12:\"delete-33327\";i:32568;s:12:\"delete-33328\";i:32569;s:12:\"delete-33331\";i:32570;s:12:\"delete-33329\";i:32571;s:12:\"delete-33330\";i:32572;s:12:\"delete-33332\";i:32573;s:12:\"delete-33333\";i:32574;s:12:\"delete-33334\";i:32575;s:12:\"delete-33337\";i:32576;s:12:\"delete-33338\";i:32577;s:12:\"delete-33335\";i:32578;s:12:\"delete-33336\";i:32579;s:12:\"delete-33339\";i:32580;s:12:\"delete-33340\";i:32581;s:12:\"delete-33343\";i:32582;s:12:\"delete-33341\";i:32583;s:12:\"delete-33342\";i:32584;s:12:\"delete-33344\";i:32585;s:12:\"delete-33345\";i:32586;s:12:\"delete-33346\";i:32587;s:12:\"delete-33349\";i:32588;s:12:\"delete-33347\";i:32589;s:12:\"delete-33348\";i:32590;s:12:\"delete-33350\";i:32591;s:12:\"delete-33351\";i:32592;s:12:\"delete-33352\";i:32593;s:12:\"delete-33353\";i:32594;s:12:\"delete-33354\";i:32595;s:12:\"delete-33355\";i:32596;s:12:\"delete-33356\";i:32597;s:12:\"delete-33357\";i:32598;s:12:\"delete-33358\";i:32599;s:12:\"delete-33361\";i:32600;s:12:\"delete-33362\";i:32601;s:12:\"delete-33359\";i:32602;s:12:\"delete-33360\";i:32603;s:12:\"delete-33363\";i:32604;s:12:\"delete-33364\";i:32605;s:12:\"delete-33365\";i:32606;s:12:\"delete-33366\";i:32607;s:12:\"delete-33367\";i:32608;s:12:\"delete-33368\";i:32609;s:12:\"delete-33369\";i:32610;s:12:\"delete-33370\";i:32611;s:12:\"delete-33373\";i:32612;s:12:\"delete-33371\";i:32613;s:12:\"delete-33372\";i:32614;s:12:\"delete-33374\";i:32615;s:12:\"delete-33375\";i:32616;s:12:\"delete-33376\";i:32617;s:12:\"delete-33379\";i:32618;s:12:\"delete-33380\";i:32619;s:12:\"delete-33377\";i:32620;s:12:\"delete-33378\";i:32621;s:12:\"delete-33381\";i:32622;s:12:\"delete-33382\";i:32623;s:12:\"delete-33385\";i:32624;s:12:\"delete-33383\";i:32625;s:12:\"delete-33384\";i:32626;s:12:\"delete-33386\";i:32627;s:12:\"delete-33387\";i:32628;s:12:\"delete-33388\";i:32629;s:12:\"delete-33391\";i:32630;s:12:\"delete-33392\";i:32631;s:12:\"delete-33389\";i:32632;s:12:\"delete-33390\";i:32633;s:12:\"delete-33393\";i:32634;s:12:\"delete-33394\";i:32635;s:12:\"delete-33397\";i:32636;s:12:\"delete-33395\";i:32637;s:12:\"delete-33396\";i:32638;s:12:\"delete-33398\";i:32639;s:12:\"delete-33399\";i:32640;s:12:\"delete-33400\";i:32641;s:12:\"delete-33401\";i:32642;s:12:\"delete-33402\";i:32643;s:12:\"delete-33403\";i:32644;s:12:\"delete-33404\";i:32645;s:12:\"delete-33405\";i:32646;s:12:\"delete-33406\";i:32647;s:12:\"delete-33409\";i:32648;s:12:\"delete-33410\";i:32649;s:12:\"delete-33407\";i:32650;s:12:\"delete-33408\";i:32651;s:12:\"delete-33411\";i:32652;s:12:\"delete-33412\";i:32653;s:12:\"delete-33413\";i:32654;s:12:\"delete-33414\";i:32655;s:12:\"delete-33415\";i:32656;s:12:\"delete-33416\";i:32657;s:12:\"delete-33417\";i:32658;s:12:\"delete-33418\";i:32659;s:12:\"delete-33421\";i:32660;s:12:\"delete-33422\";i:32661;s:12:\"delete-33419\";i:32662;s:12:\"delete-33420\";i:32663;s:12:\"delete-33423\";i:32664;s:12:\"delete-33424\";i:32665;s:12:\"delete-33427\";i:32666;s:12:\"delete-33425\";i:32667;s:12:\"delete-33426\";i:32668;s:12:\"delete-33428\";i:32669;s:12:\"delete-33429\";i:32670;s:12:\"delete-33430\";i:32671;s:12:\"delete-33433\";i:32672;s:12:\"delete-33431\";i:32673;s:12:\"delete-33432\";i:32674;s:12:\"delete-33434\";i:32675;s:12:\"delete-33435\";i:32676;s:12:\"delete-33436\";i:32677;s:12:\"delete-33439\";i:32678;s:12:\"delete-33440\";i:32679;s:12:\"delete-33437\";i:32680;s:12:\"delete-33438\";i:32681;s:12:\"delete-33441\";i:32682;s:12:\"delete-33442\";i:32683;s:12:\"delete-33443\";i:32684;s:12:\"delete-33444\";i:32685;s:12:\"delete-33445\";i:32686;s:12:\"delete-33446\";i:32687;s:12:\"delete-33447\";i:32688;s:12:\"delete-33448\";i:32689;s:12:\"delete-33451\";i:32690;s:12:\"delete-33452\";i:32691;s:12:\"delete-33449\";i:32692;s:12:\"delete-33450\";i:32693;s:12:\"delete-33453\";i:32694;s:12:\"delete-33454\";i:32695;s:12:\"delete-33457\";i:32696;s:12:\"delete-33455\";i:32697;s:12:\"delete-33456\";i:32698;s:12:\"delete-33458\";i:32699;s:12:\"delete-33459\";i:32700;s:12:\"delete-33460\";i:32701;s:12:\"delete-33463\";i:32702;s:12:\"delete-33461\";i:32703;s:12:\"delete-33462\";i:32704;s:12:\"delete-33464\";i:32705;s:12:\"delete-33465\";i:32706;s:12:\"delete-33466\";i:32707;s:12:\"delete-33469\";i:32708;s:12:\"delete-33467\";i:32709;s:12:\"delete-33468\";i:32710;s:12:\"delete-33470\";i:32711;s:12:\"delete-33471\";i:32712;s:12:\"delete-33472\";i:32713;s:12:\"delete-33475\";i:32714;s:12:\"delete-33476\";i:32715;s:12:\"delete-33473\";i:32716;s:12:\"delete-33474\";i:32717;s:12:\"delete-33477\";i:32718;s:12:\"delete-33478\";i:32719;s:12:\"delete-33479\";i:32720;s:12:\"delete-33480\";i:32721;s:12:\"delete-33481\";i:32722;s:12:\"delete-33482\";i:32723;s:12:\"delete-33483\";i:32724;s:12:\"delete-33484\";i:32725;s:12:\"delete-33487\";i:32726;s:12:\"delete-33488\";i:32727;s:12:\"delete-33485\";i:32728;s:12:\"delete-33486\";i:32729;s:12:\"delete-33489\";i:32730;s:12:\"delete-33490\";i:32731;s:12:\"delete-33491\";i:32732;s:12:\"delete-33492\";i:32733;s:12:\"delete-33493\";i:32734;s:12:\"delete-33494\";i:32735;s:12:\"delete-33495\";i:32736;s:12:\"delete-33496\";i:32737;s:12:\"delete-33499\";i:32738;s:12:\"delete-33500\";i:32739;s:12:\"delete-33497\";i:32740;s:12:\"delete-33498\";i:32741;s:12:\"delete-33501\";i:32742;s:12:\"delete-33502\";i:32743;s:12:\"delete-33503\";i:32744;s:12:\"delete-33504\";i:32745;s:12:\"delete-33505\";i:32746;s:12:\"delete-33506\";i:32747;s:12:\"delete-33507\";i:32748;s:12:\"delete-33508\";i:32749;s:12:\"delete-33511\";i:32750;s:12:\"delete-33509\";i:32751;s:12:\"delete-33510\";i:32752;s:12:\"delete-33512\";i:32753;s:12:\"delete-33513\";i:32754;s:12:\"delete-33514\";i:32755;s:12:\"delete-33517\";i:32756;s:12:\"delete-33515\";i:32757;s:12:\"delete-33516\";i:32758;s:12:\"delete-33518\";i:32759;s:12:\"delete-33519\";i:32760;s:12:\"delete-33520\";i:32761;s:12:\"delete-33521\";i:32762;s:12:\"delete-33522\";i:32763;s:12:\"delete-33523\";i:32764;s:12:\"delete-33524\";i:32765;s:12:\"delete-33525\";i:32766;s:12:\"delete-33526\";i:32767;s:12:\"delete-33529\";i:32768;s:12:\"delete-33527\";i:32769;s:12:\"delete-33528\";i:32770;s:12:\"delete-33530\";i:32771;s:12:\"delete-33531\";i:32772;s:12:\"delete-33532\";i:32773;s:12:\"delete-33535\";i:32774;s:12:\"delete-33533\";i:32775;s:12:\"delete-33534\";i:32776;s:12:\"delete-33536\";i:32777;s:12:\"delete-33537\";i:32778;s:12:\"delete-33538\";i:32779;s:12:\"delete-33541\";i:32780;s:12:\"delete-33539\";i:32781;s:12:\"delete-33540\";i:32782;s:12:\"delete-33542\";i:32783;s:12:\"delete-33543\";i:32784;s:12:\"delete-33544\";i:32785;s:12:\"delete-33545\";i:32786;s:12:\"delete-33546\";i:32787;s:12:\"delete-33547\";i:32788;s:12:\"delete-33548\";i:32789;s:12:\"delete-33549\";i:32790;s:12:\"delete-33550\";i:32791;s:12:\"delete-33553\";i:32792;s:12:\"delete-33551\";i:32793;s:12:\"delete-33552\";i:32794;s:12:\"delete-33554\";i:32795;s:12:\"delete-33555\";i:32796;s:12:\"delete-33556\";i:32797;s:12:\"delete-33559\";i:32798;s:12:\"delete-33560\";i:32799;s:12:\"delete-33557\";i:32800;s:12:\"delete-33558\";i:32801;s:12:\"delete-33561\";i:32802;s:12:\"delete-33562\";i:32803;s:12:\"delete-33565\";i:32804;s:12:\"delete-33566\";i:32805;s:12:\"delete-33563\";i:32806;s:12:\"delete-33564\";i:32807;s:12:\"delete-33567\";i:32808;s:12:\"delete-33568\";i:32809;s:12:\"delete-33571\";i:32810;s:12:\"delete-33572\";i:32811;s:12:\"delete-33569\";i:32812;s:12:\"delete-33570\";i:32813;s:12:\"delete-33573\";i:32814;s:12:\"delete-33574\";i:32815;s:12:\"delete-33575\";i:32816;s:12:\"delete-33576\";i:32817;s:12:\"delete-33577\";i:32818;s:12:\"delete-33578\";i:32819;s:12:\"delete-33579\";i:32820;s:12:\"delete-33580\";i:32821;s:12:\"delete-33583\";i:32822;s:12:\"delete-33584\";i:32823;s:12:\"delete-33581\";i:32824;s:12:\"delete-33582\";i:32825;s:12:\"delete-33585\";i:32826;s:12:\"delete-33586\";i:32827;s:12:\"delete-33589\";i:32828;s:12:\"delete-33587\";i:32829;s:12:\"delete-33588\";i:32830;s:12:\"delete-33590\";i:32831;s:12:\"delete-33591\";i:32832;s:12:\"delete-33594\";i:32833;s:12:\"delete-33595\";i:32834;s:12:\"delete-33592\";i:32835;s:12:\"delete-33593\";i:32836;s:12:\"delete-33596\";i:32837;s:12:\"delete-33597\";i:32838;s:12:\"delete-33600\";i:32839;s:12:\"delete-33598\";i:32840;s:12:\"delete-33599\";i:32841;s:12:\"delete-33601\";i:32842;s:12:\"delete-33602\";i:32843;s:12:\"delete-33603\";i:32844;s:12:\"delete-33606\";i:32845;s:12:\"delete-33604\";i:32846;s:12:\"delete-33605\";i:32847;s:12:\"delete-33607\";i:32848;s:12:\"delete-33608\";i:32849;s:12:\"delete-33609\";i:32850;s:12:\"delete-33612\";i:32851;s:12:\"delete-33613\";i:32852;s:12:\"delete-33610\";i:32853;s:12:\"delete-33611\";i:32854;s:12:\"delete-33614\";i:32855;s:12:\"delete-33615\";i:32856;s:12:\"delete-33618\";i:32857;s:12:\"delete-33616\";i:32858;s:12:\"delete-33617\";i:32859;s:12:\"delete-33619\";i:32860;s:12:\"delete-33620\";i:32861;s:12:\"delete-33621\";i:32862;s:12:\"delete-33624\";i:32863;s:12:\"delete-33625\";i:32864;s:12:\"delete-33622\";i:32865;s:12:\"delete-33623\";i:32866;s:12:\"delete-33626\";i:32867;s:12:\"delete-33627\";i:32868;s:12:\"delete-33630\";i:32869;s:12:\"delete-33628\";i:32870;s:12:\"delete-33629\";i:32871;s:12:\"delete-33631\";i:32872;s:12:\"delete-33632\";i:32873;s:12:\"delete-33633\";i:32874;s:12:\"delete-33636\";i:32875;s:12:\"delete-33637\";i:32876;s:12:\"delete-33634\";i:32877;s:12:\"delete-33635\";i:32878;s:12:\"delete-33638\";i:32879;s:12:\"delete-33639\";i:32880;s:12:\"delete-33642\";i:32881;s:12:\"delete-33643\";i:32882;s:12:\"delete-33640\";i:32883;s:12:\"delete-33641\";i:32884;s:12:\"delete-33644\";i:32885;s:12:\"delete-33645\";i:32886;s:12:\"delete-33646\";i:32887;s:12:\"delete-33647\";i:32888;s:12:\"delete-33648\";i:32889;s:12:\"delete-33649\";i:32890;s:12:\"delete-33650\";i:32891;s:12:\"delete-33651\";i:32892;s:12:\"delete-33654\";i:32893;s:12:\"delete-33655\";i:32894;s:12:\"delete-33652\";i:32895;s:12:\"delete-33653\";i:32896;s:12:\"delete-33656\";i:32897;s:12:\"delete-33657\";i:32898;s:12:\"delete-33660\";i:32899;s:12:\"delete-33658\";i:32900;s:12:\"delete-33659\";i:32901;s:12:\"delete-33661\";i:32902;s:12:\"delete-33662\";i:32903;s:12:\"delete-33663\";i:32904;s:12:\"delete-33666\";i:32905;s:12:\"delete-33667\";i:32906;s:12:\"delete-33664\";i:32907;s:12:\"delete-33665\";i:32908;s:12:\"delete-33668\";i:32909;s:12:\"delete-33669\";i:32910;s:12:\"delete-33670\";i:32911;s:12:\"delete-33671\";i:32912;s:12:\"delete-33672\";i:32913;s:12:\"delete-33673\";i:32914;s:12:\"delete-33674\";i:32915;s:12:\"delete-33675\";i:32916;s:12:\"delete-33678\";i:32917;s:12:\"delete-33676\";i:32918;s:12:\"delete-33677\";i:32919;s:12:\"delete-33679\";i:32920;s:12:\"delete-33680\";i:32921;s:12:\"delete-33681\";i:32922;s:12:\"delete-33684\";i:32923;s:12:\"delete-33685\";i:32924;s:12:\"delete-33682\";i:32925;s:12:\"delete-33683\";i:32926;s:12:\"delete-33686\";i:32927;s:12:\"delete-33687\";i:32928;s:12:\"delete-33690\";i:32929;s:12:\"delete-33691\";i:32930;s:12:\"delete-33688\";i:32931;s:12:\"delete-33689\";i:32932;s:12:\"delete-33692\";i:32933;s:12:\"delete-33693\";i:32934;s:12:\"delete-33696\";i:32935;s:12:\"delete-33697\";i:32936;s:12:\"delete-33694\";i:32937;s:12:\"delete-33695\";i:32938;s:12:\"delete-33698\";i:32939;s:12:\"delete-33699\";i:32940;s:12:\"delete-33702\";i:32941;s:12:\"delete-33703\";i:32942;s:12:\"delete-33700\";i:32943;s:12:\"delete-33701\";i:32944;s:12:\"delete-33704\";i:32945;s:12:\"delete-33705\";i:32946;s:12:\"delete-33708\";i:32947;s:12:\"delete-33706\";i:32948;s:12:\"delete-33707\";i:32949;s:12:\"delete-33709\";i:32950;s:12:\"delete-33710\";i:32951;s:12:\"delete-33711\";i:32952;s:12:\"delete-33714\";i:32953;s:12:\"delete-33715\";i:32954;s:12:\"delete-33712\";i:32955;s:12:\"delete-33713\";i:32956;s:12:\"delete-33716\";i:32957;s:12:\"delete-33717\";i:32958;s:12:\"delete-33720\";i:32959;s:12:\"delete-33718\";i:32960;s:12:\"delete-33719\";i:32961;s:12:\"delete-33721\";i:32962;s:12:\"delete-33722\";i:32963;s:12:\"delete-33723\";i:32964;s:12:\"delete-33726\";i:32965;s:12:\"delete-33727\";i:32966;s:12:\"delete-33724\";i:32967;s:12:\"delete-33725\";i:32968;s:12:\"delete-33728\";i:32969;s:12:\"delete-33729\";i:32970;s:12:\"delete-33732\";i:32971;s:12:\"delete-33733\";i:32972;s:12:\"delete-33730\";i:32973;s:12:\"delete-33731\";i:32974;s:12:\"delete-33734\";i:32975;s:12:\"delete-33735\";i:32976;s:12:\"delete-33736\";i:32977;s:12:\"delete-33737\";i:32978;s:12:\"delete-33738\";i:32979;s:12:\"delete-33739\";i:32980;s:12:\"delete-33740\";i:32981;s:12:\"delete-33741\";i:32982;s:12:\"delete-33744\";i:32983;s:12:\"delete-33745\";i:32984;s:12:\"delete-33742\";i:32985;s:12:\"delete-33743\";i:32986;s:12:\"delete-33746\";i:32987;s:12:\"delete-33747\";i:32988;s:12:\"delete-33750\";i:32989;s:12:\"delete-33748\";i:32990;s:12:\"delete-33749\";i:32991;s:12:\"delete-33751\";i:32992;s:12:\"delete-33752\";i:32993;s:12:\"delete-33753\";i:32994;s:12:\"delete-33756\";i:32995;s:12:\"delete-33754\";i:32996;s:12:\"delete-33755\";i:32997;s:12:\"delete-33757\";i:32998;s:12:\"delete-33758\";i:32999;s:12:\"delete-33759\";i:33000;s:12:\"delete-33762\";i:33001;s:12:\"delete-33763\";i:33002;s:12:\"delete-33760\";i:33003;s:12:\"delete-33761\";i:33004;s:12:\"delete-33764\";i:33005;s:12:\"delete-33765\";i:33006;s:12:\"delete-33768\";i:33007;s:12:\"delete-33769\";i:33008;s:12:\"delete-33766\";i:33009;s:12:\"delete-33767\";i:33010;s:12:\"delete-33770\";i:33011;s:12:\"delete-33771\";i:33012;s:12:\"delete-33774\";i:33013;s:12:\"delete-33772\";i:33014;s:12:\"delete-33773\";i:33015;s:12:\"delete-33775\";i:33016;s:12:\"delete-33776\";i:33017;s:12:\"delete-33777\";i:33018;s:12:\"delete-33780\";i:33019;s:12:\"delete-33778\";i:33020;s:12:\"delete-33779\";i:33021;s:12:\"delete-33781\";i:33022;s:12:\"delete-33782\";i:33023;s:12:\"delete-33783\";i:33024;s:12:\"delete-33786\";i:33025;s:12:\"delete-33784\";i:33026;s:12:\"delete-33785\";i:33027;s:12:\"delete-33787\";i:33028;s:12:\"delete-33788\";i:33029;s:12:\"delete-33789\";i:33030;s:12:\"delete-33792\";i:33031;s:12:\"delete-33790\";i:33032;s:12:\"delete-33791\";i:33033;s:12:\"delete-33793\";i:33034;s:12:\"delete-33794\";i:33035;s:12:\"delete-33795\";i:33036;s:12:\"delete-33798\";i:33037;s:12:\"delete-33799\";i:33038;s:12:\"delete-33796\";i:33039;s:12:\"delete-33797\";i:33040;s:12:\"delete-33800\";i:33041;s:12:\"delete-33801\";i:33042;s:12:\"delete-33804\";i:33043;s:12:\"delete-33805\";i:33044;s:12:\"delete-33802\";i:33045;s:12:\"delete-33803\";i:33046;s:12:\"delete-33806\";i:33047;s:12:\"delete-33807\";i:33048;s:12:\"delete-33808\";i:33049;s:12:\"delete-33809\";i:33050;s:12:\"delete-33810\";i:33051;s:12:\"delete-33811\";i:33052;s:12:\"delete-33812\";i:33053;s:12:\"delete-33813\";i:33054;s:12:\"delete-33816\";i:33055;s:12:\"delete-33817\";i:33056;s:12:\"delete-33814\";i:33057;s:12:\"delete-33815\";i:33058;s:12:\"delete-33818\";i:33059;s:12:\"delete-33819\";i:33060;s:12:\"delete-33822\";i:33061;s:12:\"delete-33820\";i:33062;s:12:\"delete-33821\";i:33063;s:12:\"delete-33823\";i:33064;s:12:\"delete-33824\";i:33065;s:12:\"delete-33825\";i:33066;s:12:\"delete-33828\";i:33067;s:12:\"delete-33826\";i:33068;s:12:\"delete-33827\";i:33069;s:12:\"delete-33829\";i:33070;s:12:\"delete-33830\";i:33071;s:12:\"delete-33831\";i:33072;s:12:\"delete-33834\";i:33073;s:12:\"delete-33832\";i:33074;s:12:\"delete-33833\";i:33075;s:12:\"delete-33835\";i:33076;s:12:\"delete-33836\";i:33077;s:12:\"delete-33837\";i:33078;s:12:\"delete-33840\";i:33079;s:12:\"delete-33841\";i:33080;s:12:\"delete-33838\";i:33081;s:12:\"delete-33839\";i:33082;s:12:\"delete-33842\";i:33083;s:12:\"delete-33843\";i:33084;s:12:\"delete-33846\";i:33085;s:12:\"delete-33847\";i:33086;s:12:\"delete-33844\";i:33087;s:12:\"delete-33845\";i:33088;s:12:\"delete-33848\";i:33089;s:12:\"delete-33849\";i:33090;s:12:\"delete-33852\";i:33091;s:12:\"delete-33850\";i:33092;s:12:\"delete-33851\";i:33093;s:12:\"delete-33853\";i:33094;s:12:\"delete-33854\";i:33095;s:12:\"delete-33855\";i:33096;s:12:\"delete-33858\";i:33097;s:12:\"delete-33856\";i:33098;s:12:\"delete-33857\";i:33099;s:12:\"delete-33859\";i:33100;s:12:\"delete-33860\";i:33101;s:12:\"delete-33861\";i:33102;s:12:\"delete-33864\";i:33103;s:12:\"delete-33862\";i:33104;s:12:\"delete-33863\";i:33105;s:12:\"delete-33865\";i:33106;s:12:\"delete-33866\";i:33107;s:12:\"delete-33867\";i:33108;s:12:\"delete-33870\";i:33109;s:12:\"delete-33868\";i:33110;s:12:\"delete-33869\";i:33111;s:12:\"delete-33871\";i:33112;s:12:\"delete-33872\";i:33113;s:12:\"delete-33873\";i:33114;s:12:\"delete-33876\";i:33115;s:12:\"delete-33877\";i:33116;s:12:\"delete-33874\";i:33117;s:12:\"delete-33875\";i:33118;s:12:\"delete-33878\";i:33119;s:12:\"delete-33879\";i:33120;s:12:\"delete-33882\";i:33121;s:12:\"delete-33880\";i:33122;s:12:\"delete-33881\";i:33123;s:12:\"delete-33883\";i:33124;s:12:\"delete-33884\";i:33125;s:12:\"delete-33885\";i:33126;s:12:\"delete-33886\";i:33127;s:12:\"delete-33887\";i:33128;s:12:\"delete-33888\";i:33129;s:12:\"delete-33889\";i:33130;s:12:\"delete-33890\";i:33131;s:12:\"delete-33891\";i:33132;s:12:\"delete-33894\";i:33133;s:12:\"delete-33892\";i:33134;s:12:\"delete-33893\";i:33135;s:12:\"delete-33895\";i:33136;s:12:\"delete-33896\";i:33137;s:12:\"delete-33897\";i:33138;s:12:\"delete-33900\";i:33139;s:12:\"delete-33898\";i:33140;s:12:\"delete-33899\";i:33141;s:12:\"delete-33901\";i:33142;s:12:\"delete-33902\";i:33143;s:12:\"delete-33903\";i:33144;s:12:\"delete-33906\";i:33145;s:12:\"delete-33907\";i:33146;s:12:\"delete-33904\";i:33147;s:12:\"delete-33905\";i:33148;s:12:\"delete-33908\";i:33149;s:12:\"delete-33909\";i:33150;s:12:\"delete-33912\";i:33151;s:12:\"delete-33910\";i:33152;s:12:\"delete-33911\";i:33153;s:12:\"delete-33913\";i:33154;s:12:\"delete-33914\";i:33155;s:12:\"delete-33915\";i:33156;s:12:\"delete-33918\";i:33157;s:12:\"delete-33919\";i:33158;s:12:\"delete-33916\";i:33159;s:12:\"delete-33917\";i:33160;s:12:\"delete-33920\";i:33161;s:12:\"delete-33921\";i:33162;s:12:\"delete-33922\";i:33163;s:12:\"delete-33923\";i:33164;s:12:\"delete-33924\";i:33165;s:12:\"delete-33925\";i:33166;s:12:\"delete-33926\";i:33167;s:12:\"delete-33927\";i:33168;s:12:\"delete-33928\";i:33169;s:12:\"delete-33929\";i:33170;s:12:\"delete-33930\";i:33171;s:12:\"delete-33931\";i:33172;s:12:\"delete-33932\";i:33173;s:12:\"delete-33933\";i:33174;s:12:\"delete-33936\";i:33175;s:12:\"delete-33934\";i:33176;s:12:\"delete-33935\";i:33177;s:12:\"delete-33937\";i:33178;s:12:\"delete-33938\";i:33179;s:12:\"delete-33939\";i:33180;s:12:\"delete-33942\";i:33181;s:12:\"delete-33940\";i:33182;s:12:\"delete-33941\";i:33183;s:12:\"delete-33943\";i:33184;s:12:\"delete-33944\";i:33185;s:12:\"delete-33945\";i:33186;s:12:\"delete-33948\";i:33187;s:12:\"delete-33949\";i:33188;s:12:\"delete-33946\";i:33189;s:12:\"delete-33947\";i:33190;s:12:\"delete-33950\";i:33191;s:12:\"delete-33951\";i:33192;s:12:\"delete-33954\";i:33193;s:12:\"delete-33952\";i:33194;s:12:\"delete-33953\";i:33195;s:12:\"delete-33955\";i:33196;s:12:\"delete-33956\";i:33197;s:12:\"delete-33957\";i:33198;s:12:\"delete-33960\";i:33199;s:12:\"delete-33958\";i:33200;s:12:\"delete-33959\";i:33201;s:12:\"delete-33961\";i:33202;s:12:\"delete-33962\";i:33203;s:12:\"delete-33963\";i:33204;s:12:\"delete-33964\";i:33205;s:12:\"delete-33965\";i:33206;s:12:\"delete-33966\";i:33207;s:12:\"delete-33967\";i:33208;s:12:\"delete-33968\";i:33209;s:12:\"delete-33969\";i:33210;s:12:\"delete-33972\";i:33211;s:12:\"delete-33970\";i:33212;s:12:\"delete-33971\";i:33213;s:12:\"delete-33973\";i:33214;s:12:\"delete-33974\";i:33215;s:12:\"delete-33977\";i:33216;s:12:\"delete-33975\";i:33217;s:12:\"delete-33976\";i:33218;s:12:\"delete-33978\";i:33219;s:12:\"delete-33979\";i:33220;s:12:\"delete-33980\";i:33221;s:12:\"delete-33983\";i:33222;s:12:\"delete-33981\";i:33223;s:12:\"delete-33982\";i:33224;s:12:\"delete-33984\";i:33225;s:12:\"delete-33985\";i:33226;s:12:\"delete-33986\";i:33227;s:12:\"delete-33989\";i:33228;s:12:\"delete-33990\";i:33229;s:12:\"delete-33987\";i:33230;s:12:\"delete-33988\";i:33231;s:12:\"delete-33991\";i:33232;s:12:\"delete-33992\";i:33233;s:12:\"delete-33995\";i:33234;s:12:\"delete-33993\";i:33235;s:12:\"delete-33994\";i:33236;s:12:\"delete-33996\";i:33237;s:12:\"delete-33997\";i:33238;s:12:\"delete-33998\";i:33239;s:12:\"delete-34001\";i:33240;s:12:\"delete-33999\";i:33241;s:12:\"delete-34000\";i:33242;s:12:\"delete-34002\";i:33243;s:12:\"delete-34003\";i:33244;s:12:\"delete-34004\";i:33245;s:12:\"delete-34007\";i:33246;s:12:\"delete-34008\";i:33247;s:12:\"delete-34005\";i:33248;s:12:\"delete-34006\";i:33249;s:12:\"delete-34009\";i:33250;s:12:\"delete-34010\";i:33251;s:12:\"delete-34013\";i:33252;s:12:\"delete-34014\";i:33253;s:12:\"delete-34011\";i:33254;s:12:\"delete-34012\";i:33255;s:12:\"delete-34015\";i:33256;s:12:\"delete-34016\";i:33257;s:12:\"delete-34019\";i:33258;s:12:\"delete-34020\";i:33259;s:12:\"delete-34017\";i:33260;s:12:\"delete-34018\";i:33261;s:12:\"delete-34021\";i:33262;s:12:\"delete-34022\";i:33263;s:12:\"delete-34025\";i:33264;s:12:\"delete-34026\";i:33265;s:12:\"delete-34023\";i:33266;s:12:\"delete-34024\";i:33267;s:12:\"delete-34027\";i:33268;s:12:\"delete-34028\";i:33269;s:12:\"delete-34031\";i:33270;s:12:\"delete-34029\";i:33271;s:12:\"delete-34030\";i:33272;s:12:\"delete-34032\";i:33273;s:12:\"delete-34033\";i:33274;s:12:\"delete-34034\";i:33275;s:12:\"delete-34035\";i:33276;s:12:\"delete-34036\";i:33277;s:12:\"delete-34037\";i:33278;s:12:\"delete-34038\";i:33279;s:12:\"delete-34039\";i:33280;s:12:\"delete-34040\";i:33281;s:12:\"delete-34043\";i:33282;s:12:\"delete-34044\";i:33283;s:12:\"delete-34041\";i:33284;s:12:\"delete-34042\";i:33285;s:12:\"delete-34045\";i:33286;s:12:\"delete-34047\";i:33287;s:12:\"delete-34048\";i:33288;s:12:\"delete-34046\";i:33289;s:12:\"delete-34049\";i:33290;s:12:\"delete-34050\";i:33291;s:12:\"delete-34051\";i:33292;s:12:\"delete-34052\";i:33293;s:12:\"delete-34055\";i:33294;s:12:\"delete-34056\";i:33295;s:12:\"delete-34053\";i:33296;s:12:\"delete-34054\";i:33297;s:12:\"delete-34057\";i:33298;s:12:\"delete-34058\";i:33299;s:12:\"delete-34061\";i:33300;s:12:\"delete-34059\";i:33301;s:12:\"delete-34060\";i:33302;s:12:\"delete-34062\";i:33303;s:12:\"delete-34063\";i:33304;s:12:\"delete-34064\";i:33305;s:12:\"delete-34067\";i:33306;s:12:\"delete-34068\";i:33307;s:12:\"delete-34065\";i:33308;s:12:\"delete-34066\";i:33309;s:12:\"delete-34069\";i:33310;s:12:\"delete-34070\";i:33311;s:12:\"delete-34071\";i:33312;s:12:\"delete-34072\";i:33313;s:12:\"delete-34073\";i:33314;s:12:\"delete-34074\";i:33315;s:12:\"delete-34075\";i:33316;s:12:\"delete-34076\";i:33317;s:12:\"delete-34079\";i:33318;s:12:\"delete-34080\";i:33319;s:12:\"delete-34077\";i:33320;s:12:\"delete-34078\";i:33321;s:12:\"delete-34081\";i:33322;s:12:\"delete-34082\";i:33323;s:12:\"delete-34085\";i:33324;s:12:\"delete-34086\";i:33325;s:12:\"delete-34083\";i:33326;s:12:\"delete-34084\";i:33327;s:12:\"delete-34087\";i:33328;s:12:\"delete-34088\";i:33329;s:12:\"delete-34091\";i:33330;s:12:\"delete-34092\";i:33331;s:12:\"delete-34089\";i:33332;s:12:\"delete-34090\";i:33333;s:12:\"delete-34093\";i:33334;s:12:\"delete-34094\";i:33335;s:12:\"delete-34097\";i:33336;s:12:\"delete-34098\";i:33337;s:12:\"delete-34095\";i:33338;s:12:\"delete-34096\";i:33339;s:12:\"delete-34099\";i:33340;s:12:\"delete-34100\";i:33341;s:12:\"delete-34103\";i:33342;s:12:\"delete-34101\";i:33343;s:12:\"delete-34102\";i:33344;s:12:\"delete-34104\";i:33345;s:12:\"delete-34105\";i:33346;s:12:\"delete-34106\";i:33347;s:12:\"delete-34109\";i:33348;s:12:\"delete-34107\";i:33349;s:12:\"delete-34108\";i:33350;s:12:\"delete-34110\";i:33351;s:12:\"delete-34111\";i:33352;s:12:\"delete-34112\";i:33353;s:12:\"delete-34115\";i:33354;s:12:\"delete-34116\";i:33355;s:12:\"delete-34113\";i:33356;s:12:\"delete-34114\";i:33357;s:12:\"delete-34117\";i:33358;s:12:\"delete-34118\";i:33359;s:12:\"delete-34119\";i:33360;s:12:\"delete-34120\";i:33361;s:12:\"delete-34121\";i:33362;s:12:\"delete-34122\";i:33363;s:12:\"delete-34123\";i:33364;s:12:\"delete-34124\";i:33365;s:12:\"delete-34127\";i:33366;s:12:\"delete-34128\";i:33367;s:12:\"delete-34125\";i:33368;s:12:\"delete-34126\";i:33369;s:12:\"delete-34129\";i:33370;s:12:\"delete-34130\";i:33371;s:12:\"delete-34131\";i:33372;s:12:\"delete-34132\";i:33373;s:12:\"delete-34133\";i:33374;s:12:\"delete-34134\";i:33375;s:12:\"delete-34135\";i:33376;s:12:\"delete-34136\";i:33377;s:12:\"delete-34139\";i:33378;s:12:\"delete-34137\";i:33379;s:12:\"delete-34138\";i:33380;s:12:\"delete-34140\";i:33381;s:12:\"delete-34141\";i:33382;s:12:\"delete-34142\";i:33383;s:12:\"delete-34145\";i:33384;s:12:\"delete-34143\";i:33385;s:12:\"delete-34144\";i:33386;s:12:\"delete-34146\";i:33387;s:12:\"delete-34147\";i:33388;s:12:\"delete-34148\";i:33389;s:12:\"delete-34151\";i:33390;s:12:\"delete-34149\";i:33391;s:12:\"delete-34150\";i:33392;s:12:\"delete-34152\";i:33393;s:12:\"delete-34153\";i:33394;s:12:\"delete-34154\";i:33395;s:12:\"delete-34157\";i:33396;s:12:\"delete-34155\";i:33397;s:12:\"delete-34156\";i:33398;s:12:\"delete-34158\";i:33399;s:12:\"delete-34159\";i:33400;s:12:\"delete-34160\";i:33401;s:12:\"delete-34163\";i:33402;s:12:\"delete-34161\";i:33403;s:12:\"delete-34162\";i:33404;s:12:\"delete-34164\";i:33405;s:12:\"delete-34165\";i:33406;s:12:\"delete-34166\";i:33407;s:12:\"delete-34169\";i:33408;s:12:\"delete-34167\";i:33409;s:12:\"delete-34168\";i:33410;s:12:\"delete-34170\";i:33411;s:12:\"delete-34171\";i:33412;s:12:\"delete-34172\";i:33413;s:12:\"delete-34175\";i:33414;s:12:\"delete-34173\";i:33415;s:12:\"delete-34174\";i:33416;s:12:\"delete-34176\";i:33417;s:12:\"delete-34177\";i:33418;s:12:\"delete-34178\";i:33419;s:12:\"delete-34181\";i:33420;s:12:\"delete-34182\";i:33421;s:12:\"delete-34179\";i:33422;s:12:\"delete-34180\";i:33423;s:12:\"delete-34183\";i:33424;s:12:\"delete-34184\";i:33425;s:12:\"delete-34187\";i:33426;s:12:\"delete-34185\";i:33427;s:12:\"delete-34186\";i:33428;s:12:\"delete-34188\";i:33429;s:12:\"delete-34189\";i:33430;s:12:\"delete-34190\";i:33431;s:12:\"delete-34193\";i:33432;s:12:\"delete-34191\";i:33433;s:12:\"delete-34192\";i:33434;s:12:\"delete-34194\";i:33435;s:12:\"delete-34195\";i:33436;s:12:\"delete-34196\";i:33437;s:12:\"delete-34199\";i:33438;s:12:\"delete-34200\";i:33439;s:12:\"delete-34197\";i:33440;s:12:\"delete-34198\";i:33441;s:12:\"delete-34201\";i:33442;s:12:\"delete-34202\";i:33443;s:12:\"delete-34205\";i:33444;s:12:\"delete-34206\";i:33445;s:12:\"delete-34203\";i:33446;s:12:\"delete-34204\";i:33447;s:12:\"delete-34207\";i:33448;s:12:\"delete-34208\";i:33449;s:12:\"delete-34211\";i:33450;s:12:\"delete-34212\";i:33451;s:12:\"delete-34209\";i:33452;s:12:\"delete-34210\";i:33453;s:12:\"delete-34213\";i:33454;s:12:\"delete-34214\";i:33455;s:12:\"delete-34217\";i:33456;s:12:\"delete-34215\";i:33457;s:12:\"delete-34216\";i:33458;s:12:\"delete-34218\";i:33459;s:12:\"delete-34219\";i:33460;s:12:\"delete-34220\";i:33461;s:12:\"delete-34221\";i:33462;s:12:\"delete-34222\";i:33463;s:12:\"delete-34223\";i:33464;s:12:\"delete-34224\";i:33465;s:12:\"delete-34225\";i:33466;s:12:\"delete-34226\";i:33467;s:12:\"delete-34229\";i:33468;s:12:\"delete-34227\";i:33469;s:12:\"delete-34228\";i:33470;s:12:\"delete-34230\";i:33471;s:12:\"delete-34231\";i:33472;s:12:\"delete-34232\";i:33473;s:12:\"delete-34235\";i:33474;s:12:\"delete-34233\";i:33475;s:12:\"delete-34234\";i:33476;s:12:\"delete-34236\";i:33477;s:12:\"delete-34237\";i:33478;s:12:\"delete-34238\";i:33479;s:12:\"delete-34241\";i:33480;s:12:\"delete-34239\";i:33481;s:12:\"delete-34240\";i:33482;s:12:\"delete-34242\";i:33483;s:12:\"delete-34243\";i:33484;s:12:\"delete-34244\";i:33485;s:12:\"delete-34247\";i:33486;s:12:\"delete-34245\";i:33487;s:12:\"delete-34246\";i:33488;s:12:\"delete-34248\";i:33489;s:12:\"delete-34249\";i:33490;s:12:\"delete-34250\";i:33491;s:12:\"delete-34253\";i:33492;s:12:\"delete-34251\";i:33493;s:12:\"delete-34252\";i:33494;s:12:\"delete-34254\";i:33495;s:12:\"delete-34255\";i:33496;s:12:\"delete-34256\";i:33497;s:12:\"delete-34259\";i:33498;s:12:\"delete-34260\";i:33499;s:12:\"delete-34257\";i:33500;s:12:\"delete-34258\";i:33501;s:12:\"delete-34261\";i:33502;s:12:\"delete-34262\";i:33503;s:12:\"delete-34265\";i:33504;s:12:\"delete-34266\";i:33505;s:12:\"delete-34263\";i:33506;s:12:\"delete-34264\";i:33507;s:12:\"delete-34267\";i:33508;s:12:\"delete-34268\";i:33509;s:12:\"delete-34271\";i:33510;s:12:\"delete-34272\";i:33511;s:12:\"delete-34269\";i:33512;s:12:\"delete-34270\";i:33513;s:12:\"delete-34273\";i:33514;s:12:\"delete-34274\";i:33515;s:12:\"delete-34275\";i:33516;s:12:\"delete-34276\";i:33517;s:12:\"delete-34277\";i:33518;s:12:\"delete-34278\";i:33519;s:12:\"delete-34279\";i:33520;s:12:\"delete-34280\";i:33521;s:12:\"delete-34283\";i:33522;s:12:\"delete-34284\";i:33523;s:12:\"delete-34281\";i:33524;s:12:\"delete-34282\";i:33525;s:12:\"delete-34285\";i:33526;s:12:\"delete-34286\";i:33527;s:12:\"delete-34289\";i:33528;s:12:\"delete-34290\";i:33529;s:12:\"delete-34287\";i:33530;s:12:\"delete-34288\";i:33531;s:12:\"delete-34291\";i:33532;s:12:\"delete-34292\";i:33533;s:12:\"delete-34293\";i:33534;s:12:\"delete-34294\";i:33535;s:12:\"delete-34295\";i:33536;s:12:\"delete-34296\";i:33537;s:12:\"delete-34297\";i:33538;s:12:\"delete-34298\";i:33539;s:12:\"delete-34301\";i:33540;s:12:\"delete-34299\";i:33541;s:12:\"delete-34300\";i:33542;s:12:\"delete-34302\";i:33543;s:12:\"delete-34303\";i:33544;s:12:\"delete-34304\";i:33545;s:12:\"delete-34307\";i:33546;s:12:\"delete-34305\";i:33547;s:12:\"delete-34306\";i:33548;s:12:\"delete-34308\";i:33549;s:12:\"delete-34309\";i:33550;s:12:\"delete-34310\";i:33551;s:12:\"delete-34313\";i:33552;s:12:\"delete-34314\";i:33553;s:12:\"delete-34311\";i:33554;s:12:\"delete-34312\";i:33555;s:12:\"delete-34315\";i:33556;s:12:\"delete-34316\";i:33557;s:12:\"delete-34319\";i:33558;s:12:\"delete-34317\";i:33559;s:12:\"delete-34318\";i:33560;s:12:\"delete-34320\";i:33561;s:12:\"delete-34321\";i:33562;s:12:\"delete-34322\";i:33563;s:12:\"delete-34325\";i:33564;s:12:\"delete-34326\";i:33565;s:12:\"delete-34323\";i:33566;s:12:\"delete-34324\";i:33567;s:12:\"delete-34327\";i:33568;s:12:\"delete-34328\";i:33569;s:12:\"delete-34329\";i:33570;s:12:\"delete-34330\";i:33571;s:12:\"delete-34331\";i:33572;s:12:\"delete-34332\";i:33573;s:12:\"delete-34333\";i:33574;s:12:\"delete-34334\";i:33575;s:12:\"delete-34337\";i:33576;s:12:\"delete-34338\";i:33577;s:12:\"delete-34339\";i:33578;s:12:\"delete-34340\";i:33579;s:12:\"delete-34343\";i:33580;s:12:\"delete-34335\";i:33581;s:12:\"delete-34336\";i:33582;s:12:\"delete-34341\";i:33583;s:12:\"delete-34342\";i:33584;s:12:\"delete-34344\";i:33585;s:12:\"delete-34345\";i:33586;s:12:\"delete-34346\";i:33587;s:12:\"delete-34349\";i:33588;s:12:\"delete-34347\";i:33589;s:12:\"delete-34348\";i:33590;s:12:\"delete-34350\";i:33591;s:12:\"delete-34351\";i:33592;s:12:\"delete-34352\";i:33593;s:12:\"delete-34353\";i:33594;s:12:\"delete-34354\";i:33595;s:12:\"delete-34355\";i:33596;s:12:\"delete-34356\";i:33597;s:12:\"delete-34357\";i:33598;s:12:\"delete-34358\";i:33599;s:12:\"delete-34361\";i:33600;s:12:\"delete-34362\";i:33601;s:12:\"delete-34359\";i:33602;s:12:\"delete-34360\";i:33603;s:12:\"delete-34363\";i:33604;s:12:\"delete-34364\";i:33605;s:12:\"delete-34367\";i:33606;s:12:\"delete-34368\";i:33607;s:12:\"delete-34365\";i:33608;s:12:\"delete-34366\";i:33609;s:12:\"delete-34369\";i:33610;s:12:\"delete-34370\";i:33611;s:12:\"delete-34371\";i:33612;s:12:\"delete-34372\";i:33613;s:12:\"delete-34373\";i:33614;s:12:\"delete-34374\";i:33615;s:12:\"delete-34375\";i:33616;s:12:\"delete-34376\";i:33617;s:12:\"delete-34379\";i:33618;s:12:\"delete-34380\";i:33619;s:12:\"delete-34377\";i:33620;s:12:\"delete-34378\";i:33621;s:12:\"delete-34381\";i:33622;s:12:\"delete-34382\";i:33623;s:12:\"delete-34385\";i:33624;s:12:\"delete-34383\";i:33625;s:12:\"delete-34384\";i:33626;s:12:\"delete-34386\";i:33627;s:12:\"delete-34387\";i:33628;s:12:\"delete-34388\";i:33629;s:12:\"delete-34391\";i:33630;s:12:\"delete-34389\";i:33631;s:12:\"delete-34390\";i:33632;s:12:\"delete-34392\";i:33633;s:12:\"delete-34393\";i:33634;s:12:\"delete-34394\";i:33635;s:12:\"delete-34395\";i:33636;s:12:\"delete-34396\";i:33637;s:12:\"delete-34397\";i:33638;s:12:\"delete-34398\";i:33639;s:12:\"delete-34399\";i:33640;s:12:\"delete-34400\";i:33641;s:12:\"delete-34403\";i:33642;s:12:\"delete-34404\";i:33643;s:12:\"delete-34401\";i:33644;s:12:\"delete-34402\";i:33645;s:12:\"delete-34405\";i:33646;s:12:\"delete-34406\";i:33647;s:12:\"delete-34407\";i:33648;s:12:\"delete-34408\";i:33649;s:12:\"delete-34409\";i:33650;s:12:\"delete-34410\";i:33651;s:12:\"delete-34411\";i:33652;s:12:\"delete-34412\";i:33653;s:12:\"delete-34413\";i:33654;s:12:\"delete-34414\";i:33655;s:12:\"delete-34415\";i:33656;s:12:\"delete-34416\";i:33657;s:12:\"delete-34417\";i:33658;s:12:\"delete-34418\";i:33659;s:12:\"delete-34421\";i:33660;s:12:\"delete-34422\";i:33661;s:12:\"delete-34419\";i:33662;s:12:\"delete-34420\";i:33663;s:12:\"delete-34423\";i:33664;s:12:\"delete-34424\";i:33665;s:12:\"delete-34425\";i:33666;s:12:\"delete-34426\";i:33667;s:12:\"delete-34427\";i:33668;s:12:\"delete-34428\";i:33669;s:12:\"delete-34429\";i:33670;s:12:\"delete-34430\";i:33671;s:12:\"delete-34433\";i:33672;s:12:\"delete-34434\";i:33673;s:12:\"delete-34431\";i:33674;s:12:\"delete-34432\";i:33675;s:12:\"delete-34435\";i:33676;s:12:\"delete-34436\";i:33677;s:12:\"delete-34437\";i:33678;s:12:\"delete-34438\";i:33679;s:12:\"delete-34439\";i:33680;s:12:\"delete-34440\";i:33681;s:12:\"delete-34441\";i:33682;s:12:\"delete-34442\";i:33683;s:12:\"delete-34445\";i:33684;s:12:\"delete-34443\";i:33685;s:12:\"delete-34444\";i:33686;s:12:\"delete-34446\";i:33687;s:12:\"delete-34447\";i:33688;s:12:\"delete-34448\";i:33689;s:12:\"delete-34449\";i:33690;s:12:\"delete-34450\";i:33691;s:12:\"delete-34451\";i:33692;s:12:\"delete-34452\";i:33693;s:12:\"delete-34453\";i:33694;s:12:\"delete-34454\";i:33695;s:12:\"delete-34457\";i:33696;s:12:\"delete-34458\";i:33697;s:12:\"delete-34455\";i:33698;s:12:\"delete-34456\";i:33699;s:12:\"delete-34459\";i:33700;s:12:\"delete-34460\";i:33701;s:12:\"delete-34463\";i:33702;s:12:\"delete-34461\";i:33703;s:12:\"delete-34462\";i:33704;s:12:\"delete-34464\";i:33705;s:12:\"delete-34465\";i:33706;s:12:\"delete-34466\";i:33707;s:12:\"delete-34467\";i:33708;s:12:\"delete-34468\";i:33709;s:12:\"delete-34469\";i:33710;s:12:\"delete-34470\";i:33711;s:12:\"delete-34471\";i:33712;s:12:\"delete-34472\";i:33713;s:12:\"delete-34475\";i:33714;s:12:\"delete-34476\";i:33715;s:12:\"delete-34473\";i:33716;s:12:\"delete-34474\";i:33717;s:12:\"delete-34477\";i:33718;s:12:\"delete-34478\";i:33719;s:12:\"delete-34479\";i:33720;s:12:\"delete-34480\";i:33721;s:12:\"delete-34481\";i:33722;s:12:\"delete-34482\";i:33723;s:12:\"delete-34483\";i:33724;s:12:\"delete-34484\";i:33725;s:12:\"delete-34487\";i:33726;s:12:\"delete-34488\";i:33727;s:12:\"delete-34485\";i:33728;s:12:\"delete-34486\";i:33729;s:12:\"delete-34489\";i:33730;s:12:\"delete-34490\";i:33731;s:12:\"delete-34493\";i:33732;s:12:\"delete-34494\";i:33733;s:12:\"delete-34491\";i:33734;s:12:\"delete-34492\";i:33735;s:12:\"delete-34495\";i:33736;s:12:\"delete-34496\";i:33737;s:12:\"delete-34499\";i:33738;s:12:\"delete-34500\";i:33739;s:12:\"delete-34497\";i:33740;s:12:\"delete-34498\";i:33741;s:12:\"delete-34501\";i:33742;s:12:\"delete-34502\";i:33743;s:12:\"delete-34503\";i:33744;s:12:\"delete-34504\";i:33745;s:12:\"delete-34505\";i:33746;s:12:\"delete-34506\";i:33747;s:12:\"delete-34507\";i:33748;s:12:\"delete-34508\";i:33749;s:12:\"delete-34509\";i:33750;s:12:\"delete-34510\";i:33751;s:12:\"delete-34511\";i:33752;s:12:\"delete-34512\";i:33753;s:12:\"delete-34513\";i:33754;s:12:\"delete-34514\";i:33755;s:12:\"delete-34515\";i:33756;s:12:\"delete-34516\";i:33757;s:12:\"delete-34517\";i:33758;s:12:\"delete-34518\";i:33759;s:12:\"delete-34519\";i:33760;s:12:\"delete-34520\";i:33761;s:12:\"delete-34523\";i:33762;s:12:\"delete-34524\";i:33763;s:12:\"delete-34521\";i:33764;s:12:\"delete-34522\";i:33765;s:12:\"delete-34525\";i:33766;s:12:\"delete-34526\";i:33767;s:12:\"delete-34529\";i:33768;s:12:\"delete-34530\";i:33769;s:12:\"delete-34527\";i:33770;s:12:\"delete-34528\";i:33771;s:12:\"delete-34531\";i:33772;s:12:\"delete-34532\";i:33773;s:12:\"delete-34533\";i:33774;s:12:\"delete-34534\";i:33775;s:12:\"delete-34535\";i:33776;s:12:\"delete-34536\";i:33777;s:12:\"delete-34537\";i:33778;s:12:\"delete-34538\";i:33779;s:12:\"delete-34541\";i:33780;s:12:\"delete-34539\";i:33781;s:12:\"delete-34540\";i:33782;s:12:\"delete-34542\";i:33783;s:12:\"delete-34543\";i:33784;s:12:\"delete-34544\";i:33785;s:12:\"delete-34547\";i:33786;s:12:\"delete-34548\";i:33787;s:12:\"delete-34545\";i:33788;s:12:\"delete-34546\";i:33789;s:12:\"delete-34549\";i:33790;s:12:\"delete-34550\";i:33791;s:12:\"delete-34551\";i:33792;s:12:\"delete-34552\";i:33793;s:12:\"delete-34553\";i:33794;s:12:\"delete-34554\";i:33795;s:12:\"delete-34555\";i:33796;s:12:\"delete-34556\";i:33797;s:12:\"delete-34559\";i:33798;s:12:\"delete-34560\";i:33799;s:12:\"delete-34557\";i:33800;s:12:\"delete-34558\";i:33801;s:12:\"delete-34561\";i:33802;s:12:\"delete-34562\";i:33803;s:12:\"delete-34565\";i:33804;s:12:\"delete-34566\";i:33805;s:12:\"delete-34563\";i:33806;s:12:\"delete-34564\";i:33807;s:12:\"delete-34567\";i:33808;s:12:\"delete-34568\";i:33809;s:12:\"delete-34571\";i:33810;s:12:\"delete-34572\";i:33811;s:12:\"delete-34569\";i:33812;s:12:\"delete-34570\";i:33813;s:12:\"delete-34573\";i:33814;s:12:\"delete-34574\";i:33815;s:12:\"delete-34577\";i:33816;s:12:\"delete-34575\";i:33817;s:12:\"delete-34576\";i:33818;s:12:\"delete-34578\";i:33819;s:12:\"delete-34579\";i:33820;s:12:\"delete-34580\";i:33821;s:12:\"delete-34583\";i:33822;s:12:\"delete-34584\";i:33823;s:12:\"delete-34581\";i:33824;s:12:\"delete-34582\";i:33825;s:12:\"delete-34585\";i:33826;s:12:\"delete-34586\";i:33827;s:12:\"delete-34589\";i:33828;s:12:\"delete-34587\";i:33829;s:12:\"delete-34588\";i:33830;s:12:\"delete-34590\";i:33831;s:12:\"delete-34591\";i:33832;s:12:\"delete-34592\";i:33833;s:12:\"delete-34595\";i:33834;s:12:\"delete-34596\";i:33835;s:12:\"delete-34593\";i:33836;s:12:\"delete-34594\";i:33837;s:12:\"delete-34597\";i:33838;s:12:\"delete-34598\";i:33839;s:12:\"delete-34601\";i:33840;s:12:\"delete-34599\";i:33841;s:12:\"delete-34600\";i:33842;s:12:\"delete-34602\";i:33843;s:12:\"delete-34603\";i:33844;s:12:\"delete-34604\";i:33845;s:12:\"delete-34607\";i:33846;s:12:\"delete-34608\";i:33847;s:12:\"delete-34605\";i:33848;s:12:\"delete-34606\";i:33849;s:12:\"delete-34609\";i:33850;s:12:\"delete-34610\";i:33851;s:12:\"delete-34613\";i:33852;s:12:\"delete-34611\";i:33853;s:12:\"delete-34612\";i:33854;s:12:\"delete-34614\";i:33855;s:12:\"delete-34615\";i:33856;s:12:\"delete-34616\";i:33857;s:12:\"delete-34619\";i:33858;s:12:\"delete-34617\";i:33859;s:12:\"delete-34618\";i:33860;s:12:\"delete-34620\";i:33861;s:12:\"delete-34621\";i:33862;s:12:\"delete-34622\";i:33863;s:12:\"delete-34625\";i:33864;s:12:\"delete-34626\";i:33865;s:12:\"delete-34623\";i:33866;s:12:\"delete-34624\";i:33867;s:12:\"delete-34627\";i:33868;s:12:\"delete-34628\";i:33869;s:12:\"delete-34631\";i:33870;s:12:\"delete-34629\";i:33871;s:12:\"delete-34630\";i:33872;s:12:\"delete-34632\";i:33873;s:12:\"delete-34633\";i:33874;s:12:\"delete-34634\";i:33875;s:12:\"delete-34637\";i:33876;s:12:\"delete-34635\";i:33877;s:12:\"delete-34636\";i:33878;s:12:\"delete-34638\";i:33879;s:12:\"delete-34639\";i:33880;s:12:\"delete-34640\";i:33881;s:12:\"delete-34643\";i:33882;s:12:\"delete-34641\";i:33883;s:12:\"delete-34642\";i:33884;s:12:\"delete-34644\";i:33885;s:12:\"delete-34645\";i:33886;s:12:\"delete-34646\";i:33887;s:12:\"delete-34649\";i:33888;s:12:\"delete-34647\";i:33889;s:12:\"delete-34648\";i:33890;s:12:\"delete-34650\";i:33891;s:12:\"delete-34651\";i:33892;s:12:\"delete-34652\";i:33893;s:12:\"delete-34655\";i:33894;s:12:\"delete-34656\";i:33895;s:12:\"delete-34653\";i:33896;s:12:\"delete-34654\";i:33897;s:12:\"delete-34657\";i:33898;s:12:\"delete-34658\";i:33899;s:12:\"delete-34661\";i:33900;s:12:\"delete-34659\";i:33901;s:12:\"delete-34660\";i:33902;s:12:\"delete-34662\";i:33903;s:12:\"delete-34663\";i:33904;s:12:\"delete-34664\";i:33905;s:12:\"delete-34667\";i:33906;s:12:\"delete-34668\";i:33907;s:12:\"delete-34665\";i:33908;s:12:\"delete-34666\";i:33909;s:12:\"delete-34669\";i:33910;s:12:\"delete-34670\";i:33911;s:12:\"delete-34673\";i:33912;s:12:\"delete-34674\";i:33913;s:12:\"delete-34671\";i:33914;s:12:\"delete-34672\";i:33915;s:12:\"delete-34675\";i:33916;s:12:\"delete-34676\";i:33917;s:12:\"delete-34679\";i:33918;s:12:\"delete-34677\";i:33919;s:12:\"delete-34678\";i:33920;s:12:\"delete-34680\";i:33921;s:12:\"delete-34681\";i:33922;s:12:\"delete-34682\";i:33923;s:12:\"delete-34685\";i:33924;s:12:\"delete-34686\";i:33925;s:12:\"delete-34683\";i:33926;s:12:\"delete-34684\";i:33927;s:12:\"delete-34687\";i:33928;s:12:\"delete-34688\";i:33929;s:12:\"delete-34691\";i:33930;s:12:\"delete-34692\";i:33931;s:12:\"delete-34689\";i:33932;s:12:\"delete-34690\";i:33933;s:12:\"delete-34693\";i:33934;s:12:\"delete-34694\";i:33935;s:12:\"delete-34697\";i:33936;s:12:\"delete-34698\";i:33937;s:12:\"delete-34695\";i:33938;s:12:\"delete-34696\";i:33939;s:12:\"delete-34699\";i:33940;s:12:\"delete-34700\";i:33941;s:12:\"delete-34703\";i:33942;s:12:\"delete-34704\";i:33943;s:12:\"delete-34701\";i:33944;s:12:\"delete-34702\";i:33945;s:12:\"delete-34705\";i:33946;s:12:\"delete-34706\";i:33947;s:12:\"delete-34709\";i:33948;s:12:\"delete-34710\";i:33949;s:12:\"delete-34707\";i:33950;s:12:\"delete-34708\";i:33951;s:12:\"delete-34711\";i:33952;s:12:\"delete-34712\";i:33953;s:12:\"delete-34715\";i:33954;s:12:\"delete-34716\";i:33955;s:12:\"delete-34713\";i:33956;s:12:\"delete-34714\";i:33957;s:12:\"delete-34717\";i:33958;s:12:\"delete-34718\";i:33959;s:12:\"delete-34721\";i:33960;s:12:\"delete-34722\";i:33961;s:12:\"delete-34719\";i:33962;s:12:\"delete-34720\";i:33963;s:12:\"delete-34723\";i:33964;s:12:\"delete-34724\";i:33965;s:12:\"delete-34727\";i:33966;s:12:\"delete-34728\";i:33967;s:12:\"delete-34725\";i:33968;s:12:\"delete-34726\";i:33969;s:12:\"delete-34729\";i:33970;s:12:\"delete-34730\";i:33971;s:12:\"delete-34733\";i:33972;s:12:\"delete-34734\";i:33973;s:12:\"delete-34731\";i:33974;s:12:\"delete-34732\";i:33975;s:12:\"delete-34735\";i:33976;s:12:\"delete-34736\";i:33977;s:12:\"delete-34739\";i:33978;s:12:\"delete-34740\";i:33979;s:12:\"delete-34737\";i:33980;s:12:\"delete-34738\";i:33981;s:12:\"delete-34741\";i:33982;s:12:\"delete-34742\";i:33983;s:12:\"delete-34745\";i:33984;s:12:\"delete-34746\";i:33985;s:12:\"delete-34743\";i:33986;s:12:\"delete-34744\";i:33987;s:12:\"delete-34747\";i:33988;s:12:\"delete-34748\";i:33989;s:12:\"delete-34751\";i:33990;s:12:\"delete-34749\";i:33991;s:12:\"delete-34750\";i:33992;s:12:\"delete-34752\";i:33993;s:12:\"delete-34753\";i:33994;s:12:\"delete-34754\";i:33995;s:12:\"delete-34755\";i:33996;s:12:\"delete-34756\";i:33997;s:12:\"delete-34757\";i:33998;s:12:\"delete-34758\";i:33999;s:12:\"delete-34759\";i:34000;s:12:\"delete-34760\";i:34001;s:12:\"delete-34763\";i:34002;s:12:\"delete-34761\";i:34003;s:12:\"delete-34762\";i:34004;s:12:\"delete-34764\";i:34005;s:12:\"delete-34765\";i:34006;s:12:\"delete-34766\";i:34007;s:12:\"delete-34769\";i:34008;s:12:\"delete-34770\";i:34009;s:12:\"delete-34767\";i:34010;s:12:\"delete-34768\";i:34011;s:12:\"delete-34771\";i:34012;s:12:\"delete-34772\";i:34013;s:12:\"delete-34775\";i:34014;s:12:\"delete-34773\";i:34015;s:12:\"delete-34774\";i:34016;s:12:\"delete-34776\";i:34017;s:12:\"delete-34777\";i:34018;s:12:\"delete-34778\";i:34019;s:12:\"delete-34781\";i:34020;s:12:\"delete-34779\";i:34021;s:12:\"delete-34780\";i:34022;s:12:\"delete-34782\";i:34023;s:12:\"delete-34783\";i:34024;s:12:\"delete-34784\";i:34025;s:12:\"delete-34787\";i:34026;s:12:\"delete-34788\";i:34027;s:12:\"delete-34785\";i:34028;s:12:\"delete-34786\";i:34029;s:12:\"delete-34789\";i:34030;s:12:\"delete-34790\";i:34031;s:12:\"delete-34793\";i:34032;s:12:\"delete-34791\";i:34033;s:12:\"delete-34792\";i:34034;s:12:\"delete-34794\";i:34035;s:12:\"delete-34795\";i:34036;s:12:\"delete-34796\";i:34037;s:12:\"delete-34799\";i:34038;s:12:\"delete-34800\";i:34039;s:12:\"delete-34797\";i:34040;s:12:\"delete-34798\";i:34041;s:12:\"delete-34801\";i:34042;s:12:\"delete-34802\";i:34043;s:12:\"delete-34803\";i:34044;s:12:\"delete-34804\";i:34045;s:12:\"delete-34805\";i:34046;s:12:\"delete-34806\";i:34047;s:12:\"delete-34807\";i:34048;s:12:\"delete-34808\";i:34049;s:12:\"delete-34811\";i:34050;s:12:\"delete-34809\";i:34051;s:12:\"delete-34810\";i:34052;s:12:\"delete-34812\";i:34053;s:12:\"delete-34813\";i:34054;s:12:\"delete-34814\";i:34055;s:12:\"delete-34817\";i:34056;s:12:\"delete-34818\";i:34057;s:12:\"delete-34815\";i:34058;s:12:\"delete-34816\";i:34059;s:12:\"delete-34819\";i:34060;s:12:\"delete-34820\";i:34061;s:12:\"delete-34821\";i:34062;s:12:\"delete-34822\";i:34063;s:12:\"delete-34823\";i:34064;s:12:\"delete-34824\";i:34065;s:12:\"delete-34825\";i:34066;s:12:\"delete-34826\";i:34067;s:12:\"delete-34829\";i:34068;s:12:\"delete-34830\";i:34069;s:12:\"delete-34827\";i:34070;s:12:\"delete-34828\";i:34071;s:12:\"delete-34831\";i:34072;s:12:\"delete-34832\";i:34073;s:12:\"delete-34835\";i:34074;s:12:\"delete-34836\";i:34075;s:12:\"delete-34833\";i:34076;s:12:\"delete-34834\";i:34077;s:12:\"delete-34837\";i:34078;s:12:\"delete-34838\";i:34079;s:12:\"delete-34841\";i:34080;s:12:\"delete-34842\";i:34081;s:12:\"delete-34839\";i:34082;s:12:\"delete-34840\";i:34083;s:12:\"delete-34843\";i:34084;s:12:\"delete-34844\";i:34085;s:12:\"delete-34847\";i:34086;s:12:\"delete-34845\";i:34087;s:12:\"delete-34846\";i:34088;s:12:\"delete-34848\";i:34089;s:12:\"delete-34849\";i:34090;s:12:\"delete-34850\";i:34091;s:12:\"delete-34851\";i:34092;s:12:\"delete-34852\";i:34093;s:12:\"delete-34853\";i:34094;s:12:\"delete-34854\";i:34095;s:12:\"delete-34855\";i:34096;s:12:\"delete-34856\";i:34097;s:12:\"delete-34859\";i:34098;s:12:\"delete-34857\";i:34099;s:12:\"delete-34858\";i:34100;s:12:\"delete-34860\";i:34101;s:12:\"delete-34861\";i:34102;s:12:\"delete-34862\";i:34103;s:12:\"delete-34865\";i:34104;s:12:\"delete-34863\";i:34105;s:12:\"delete-34864\";i:34106;s:12:\"delete-34866\";i:34107;s:12:\"delete-34867\";i:34108;s:12:\"delete-34868\";i:34109;s:12:\"delete-34869\";i:34110;s:12:\"delete-34870\";i:34111;s:12:\"delete-34871\";i:34112;s:12:\"delete-34872\";i:34113;s:12:\"delete-34873\";i:34114;s:12:\"delete-34874\";i:34115;s:12:\"delete-34877\";i:34116;s:12:\"delete-34878\";i:34117;s:12:\"delete-34875\";i:34118;s:12:\"delete-34876\";i:34119;s:12:\"delete-34879\";i:34120;s:12:\"delete-34880\";i:34121;s:12:\"delete-34883\";i:34122;s:12:\"delete-34884\";i:34123;s:12:\"delete-34881\";i:34124;s:12:\"delete-34882\";i:34125;s:12:\"delete-34885\";i:34126;s:12:\"delete-34886\";i:34127;s:12:\"delete-34887\";i:34128;s:12:\"delete-34888\";i:34129;s:12:\"delete-34889\";i:34130;s:12:\"delete-34890\";i:34131;s:12:\"delete-34891\";i:34132;s:12:\"delete-34892\";i:34133;s:12:\"delete-34893\";i:34134;s:12:\"delete-34894\";i:34135;s:12:\"delete-34895\";i:34136;s:12:\"delete-34896\";i:34137;s:12:\"delete-34897\";i:34138;s:12:\"delete-34898\";i:34139;s:12:\"delete-34901\";i:34140;s:12:\"delete-34902\";i:34141;s:12:\"delete-34899\";i:34142;s:12:\"delete-34900\";i:34143;s:12:\"delete-34903\";i:34144;s:12:\"delete-34904\";i:34145;s:12:\"delete-34907\";i:34146;s:12:\"delete-34908\";i:34147;s:12:\"delete-34905\";i:34148;s:12:\"delete-34906\";i:34149;s:12:\"delete-34909\";i:34150;s:12:\"delete-34910\";i:34151;s:12:\"delete-34913\";i:34152;s:12:\"delete-34914\";i:34153;s:12:\"delete-34911\";i:34154;s:12:\"delete-34912\";i:34155;s:12:\"delete-34915\";i:34156;s:12:\"delete-34916\";i:34157;s:12:\"delete-34919\";i:34158;s:12:\"delete-34920\";i:34159;s:12:\"delete-34917\";i:34160;s:12:\"delete-34918\";i:34161;s:12:\"delete-34921\";i:34162;s:12:\"delete-34922\";i:34163;s:12:\"delete-34925\";i:34164;s:12:\"delete-34926\";i:34165;s:12:\"delete-34923\";i:34166;s:12:\"delete-34924\";i:34167;s:12:\"delete-34927\";i:34168;s:12:\"delete-34928\";i:34169;s:12:\"delete-34931\";i:34170;s:12:\"delete-34932\";i:34171;s:12:\"delete-34929\";i:34172;s:12:\"delete-34930\";i:34173;s:12:\"delete-34933\";i:34174;s:12:\"delete-34934\";i:34175;s:12:\"delete-34935\";i:34176;s:12:\"delete-34936\";i:34177;s:12:\"delete-34937\";i:34178;s:12:\"delete-34938\";i:34179;s:12:\"delete-34939\";i:34180;s:12:\"delete-34940\";i:34181;s:12:\"delete-34941\";i:34182;s:12:\"delete-34942\";i:34183;s:12:\"delete-34943\";i:34184;s:12:\"delete-34944\";i:34185;s:12:\"delete-34945\";i:34186;s:12:\"delete-34946\";i:34187;s:12:\"delete-34949\";i:34188;s:12:\"delete-34947\";i:34189;s:12:\"delete-34948\";i:34190;s:12:\"delete-34950\";i:34191;s:12:\"delete-34951\";i:34192;s:12:\"delete-34952\";i:34193;s:12:\"delete-34955\";i:34194;s:12:\"delete-34956\";i:34195;s:12:\"delete-34953\";i:34196;s:12:\"delete-34954\";i:34197;s:12:\"delete-34957\";i:34198;s:12:\"delete-34958\";i:34199;s:12:\"delete-34961\";i:34200;s:12:\"delete-34962\";i:34201;s:12:\"delete-34959\";i:34202;s:12:\"delete-34960\";i:34203;s:12:\"delete-34963\";i:34204;s:12:\"delete-34964\";i:34205;s:12:\"delete-34967\";i:34206;s:12:\"delete-34968\";i:34207;s:12:\"delete-34965\";i:34208;s:12:\"delete-34966\";i:34209;s:12:\"delete-34969\";i:34210;s:12:\"delete-34970\";i:34211;s:12:\"delete-34973\";i:34212;s:12:\"delete-34974\";i:34213;s:12:\"delete-34971\";i:34214;s:12:\"delete-34972\";i:34215;s:12:\"delete-34975\";i:34216;s:12:\"delete-34976\";i:34217;s:12:\"delete-34977\";i:34218;s:12:\"delete-34978\";i:34219;s:12:\"delete-34979\";i:34220;s:12:\"delete-34980\";i:34221;s:12:\"delete-34981\";i:34222;s:12:\"delete-34982\";i:34223;s:12:\"delete-34985\";i:34224;s:12:\"delete-34986\";i:34225;s:12:\"delete-34983\";i:34226;s:12:\"delete-34984\";i:34227;s:12:\"delete-34987\";i:34228;s:12:\"delete-34988\";i:34229;s:12:\"delete-34991\";i:34230;s:12:\"delete-34992\";i:34231;s:12:\"delete-34989\";i:34232;s:12:\"delete-34990\";i:34233;s:12:\"delete-34993\";i:34234;s:12:\"delete-34994\";i:34235;s:12:\"delete-34997\";i:34236;s:12:\"delete-34998\";i:34237;s:12:\"delete-34995\";i:34238;s:12:\"delete-34996\";i:34239;s:12:\"delete-34999\";i:34240;s:12:\"delete-35000\";i:34241;s:12:\"delete-35003\";i:34242;s:12:\"delete-35004\";i:34243;s:12:\"delete-35001\";i:34244;s:12:\"delete-35002\";i:34245;s:12:\"delete-35005\";i:34246;s:12:\"delete-35006\";i:34247;s:12:\"delete-35009\";i:34248;s:12:\"delete-35010\";i:34249;s:12:\"delete-35007\";i:34250;s:12:\"delete-35008\";i:34251;s:12:\"delete-35011\";i:34252;s:12:\"delete-35012\";i:34253;s:12:\"delete-35013\";i:34254;s:12:\"delete-35014\";i:34255;s:12:\"delete-35015\";i:34256;s:12:\"delete-35016\";i:34257;s:12:\"delete-35017\";i:34258;s:12:\"delete-35018\";i:34259;s:12:\"delete-35021\";i:34260;s:12:\"delete-35019\";i:34261;s:12:\"delete-35020\";i:34262;s:12:\"delete-35022\";i:34263;s:12:\"delete-35023\";i:34264;s:12:\"delete-35024\";i:34265;s:12:\"delete-35027\";i:34266;s:12:\"delete-35028\";i:34267;s:12:\"delete-35025\";i:34268;s:12:\"delete-35026\";i:34269;s:12:\"delete-35029\";i:34270;s:12:\"delete-35030\";i:34271;s:12:\"delete-35033\";i:34272;s:12:\"delete-35034\";i:34273;s:12:\"delete-35031\";i:34274;s:12:\"delete-35032\";i:34275;s:12:\"delete-35035\";i:34276;s:12:\"delete-35036\";i:34277;s:12:\"delete-35039\";i:34278;s:12:\"delete-35037\";i:34279;s:12:\"delete-35038\";i:34280;s:12:\"delete-35040\";i:34281;s:12:\"delete-35041\";i:34282;s:12:\"delete-35042\";i:34283;s:12:\"delete-35045\";i:34284;s:12:\"delete-35046\";i:34285;s:12:\"delete-35043\";i:34286;s:12:\"delete-35044\";i:34287;s:12:\"delete-35047\";i:34288;s:12:\"delete-35048\";i:34289;s:12:\"delete-35051\";i:34290;s:12:\"delete-35052\";i:34291;s:12:\"delete-35049\";i:34292;s:12:\"delete-35050\";i:34293;s:12:\"delete-35053\";i:34294;s:12:\"delete-35054\";i:34295;s:12:\"delete-35057\";i:34296;s:12:\"delete-35058\";i:34297;s:12:\"delete-35055\";i:34298;s:12:\"delete-35056\";i:34299;s:12:\"delete-35059\";i:34300;s:12:\"delete-35060\";i:34301;s:12:\"delete-35063\";i:34302;s:12:\"delete-35061\";i:34303;s:12:\"delete-35062\";i:34304;s:12:\"delete-35064\";i:34305;s:12:\"delete-35065\";i:34306;s:12:\"delete-35066\";i:34307;s:12:\"delete-35069\";i:34308;s:12:\"delete-35070\";i:34309;s:12:\"delete-35067\";i:34310;s:12:\"delete-35068\";i:34311;s:12:\"delete-35071\";i:34312;s:12:\"delete-35072\";i:34313;s:12:\"delete-35075\";i:34314;s:12:\"delete-35076\";i:34315;s:12:\"delete-35073\";i:34316;s:12:\"delete-35074\";i:34317;s:12:\"delete-35077\";i:34318;s:12:\"delete-35078\";i:34319;s:12:\"delete-35079\";i:34320;s:12:\"delete-35080\";i:34321;s:12:\"delete-35081\";i:34322;s:12:\"delete-35082\";i:34323;s:12:\"delete-35083\";i:34324;s:12:\"delete-35084\";i:34325;s:12:\"delete-35087\";i:34326;s:12:\"delete-35085\";i:34327;s:12:\"delete-35086\";i:34328;s:12:\"delete-35088\";i:34329;s:12:\"delete-35089\";i:34330;s:12:\"delete-35090\";i:34331;s:12:\"delete-35093\";i:34332;s:12:\"delete-35091\";i:34333;s:12:\"delete-35092\";i:34334;s:12:\"delete-35094\";i:34335;s:12:\"delete-35095\";i:34336;s:12:\"delete-35096\";i:34337;s:12:\"delete-35099\";i:34338;s:12:\"delete-35100\";i:34339;s:12:\"delete-35097\";i:34340;s:12:\"delete-35098\";i:34341;s:12:\"delete-35101\";i:34342;s:12:\"delete-35102\";i:34343;s:12:\"delete-35105\";i:34344;s:12:\"delete-35106\";i:34345;s:12:\"delete-35103\";i:34346;s:12:\"delete-35104\";i:34347;s:12:\"delete-35107\";i:34348;s:12:\"delete-35108\";i:34349;s:12:\"delete-35111\";i:34350;s:12:\"delete-35109\";i:34351;s:12:\"delete-35110\";i:34352;s:12:\"delete-35112\";i:34353;s:12:\"delete-35113\";i:34354;s:12:\"delete-35114\";i:34355;s:12:\"delete-35115\";i:34356;s:12:\"delete-35116\";i:34357;s:12:\"delete-35117\";i:34358;s:12:\"delete-35118\";i:34359;s:12:\"delete-35119\";i:34360;s:12:\"delete-35120\";i:34361;s:12:\"delete-35123\";i:34362;s:12:\"delete-35124\";i:34363;s:12:\"delete-35121\";i:34364;s:12:\"delete-35122\";i:34365;s:12:\"delete-35125\";i:34366;s:12:\"delete-35126\";i:34367;s:12:\"delete-35127\";i:34368;s:12:\"delete-35128\";i:34369;s:12:\"delete-35129\";i:34370;s:12:\"delete-35130\";i:34371;s:12:\"delete-35131\";i:34372;s:12:\"delete-35132\";i:34373;s:12:\"delete-35135\";i:34374;s:12:\"delete-35133\";i:34375;s:12:\"delete-35134\";i:34376;s:12:\"delete-35136\";i:34377;s:12:\"delete-35137\";i:34378;s:12:\"delete-35138\";i:34379;s:12:\"delete-35141\";i:34380;s:12:\"delete-35139\";i:34381;s:12:\"delete-35140\";i:34382;s:12:\"delete-35142\";i:34383;s:12:\"delete-35143\";i:34384;s:12:\"delete-35144\";i:34385;s:12:\"delete-35147\";i:34386;s:12:\"delete-35145\";i:34387;s:12:\"delete-35146\";i:34388;s:12:\"delete-35148\";i:34389;s:12:\"delete-35149\";i:34390;s:12:\"delete-35150\";i:34391;s:12:\"delete-35153\";i:34392;s:12:\"delete-35151\";i:34393;s:12:\"delete-35152\";i:34394;s:12:\"delete-35154\";i:34395;s:12:\"delete-35155\";i:34396;s:12:\"delete-35156\";i:34397;s:12:\"delete-35159\";i:34398;s:12:\"delete-35160\";i:34399;s:12:\"delete-35157\";i:34400;s:12:\"delete-35158\";i:34401;s:12:\"delete-35161\";i:34402;s:12:\"delete-35162\";i:34403;s:12:\"delete-35163\";i:34404;s:12:\"delete-35164\";i:34405;s:12:\"delete-35165\";i:34406;s:12:\"delete-35166\";i:34407;s:12:\"delete-35167\";i:34408;s:12:\"delete-35168\";i:34409;s:12:\"delete-35171\";i:34410;s:12:\"delete-35172\";i:34411;s:12:\"delete-35169\";i:34412;s:12:\"delete-35170\";i:34413;s:12:\"delete-35173\";i:34414;s:12:\"delete-35174\";i:34415;s:12:\"delete-35177\";i:34416;s:12:\"delete-35178\";i:34417;s:12:\"delete-35175\";i:34418;s:12:\"delete-35176\";i:34419;s:12:\"delete-35179\";i:34420;s:12:\"delete-35180\";i:34421;s:12:\"delete-35181\";i:34422;s:12:\"delete-35182\";i:34423;s:12:\"delete-35183\";i:34424;s:12:\"delete-35184\";i:34425;s:12:\"delete-35185\";i:34426;s:12:\"delete-35186\";i:34427;s:12:\"delete-35189\";i:34428;s:12:\"delete-35190\";i:34429;s:12:\"delete-35187\";i:34430;s:12:\"delete-35188\";i:34431;s:12:\"delete-35191\";i:34432;s:12:\"delete-35192\";i:34433;s:12:\"delete-35195\";i:34434;s:12:\"delete-35196\";i:34435;s:12:\"delete-35193\";i:34436;s:12:\"delete-35194\";i:34437;s:12:\"delete-35197\";i:34438;s:12:\"delete-35198\";i:34439;s:12:\"delete-35201\";i:34440;s:12:\"delete-35202\";i:34441;s:12:\"delete-35199\";i:34442;s:12:\"delete-35200\";i:34443;s:12:\"delete-35203\";i:34444;s:12:\"delete-35204\";i:34445;s:12:\"delete-35207\";i:34446;s:12:\"delete-35208\";i:34447;s:12:\"delete-35205\";i:34448;s:12:\"delete-35206\";i:34449;s:12:\"delete-35209\";i:34450;s:12:\"delete-35210\";i:34451;s:12:\"delete-35213\";i:34452;s:12:\"delete-35214\";i:34453;s:12:\"delete-35211\";i:34454;s:12:\"delete-35212\";i:34455;s:12:\"delete-35215\";i:34456;s:12:\"delete-35216\";i:34457;s:12:\"delete-35219\";i:34458;s:12:\"delete-35220\";i:34459;s:12:\"delete-35217\";i:34460;s:12:\"delete-35218\";i:34461;s:12:\"delete-35221\";i:34462;s:12:\"delete-35222\";i:34463;s:12:\"delete-35225\";i:34464;s:12:\"delete-35223\";i:34465;s:12:\"delete-35224\";i:34466;s:12:\"delete-35226\";i:34467;s:12:\"delete-35227\";i:34468;s:12:\"delete-35228\";i:34469;s:12:\"delete-35231\";i:34470;s:12:\"delete-35232\";i:34471;s:12:\"delete-35229\";i:34472;s:12:\"delete-35230\";i:34473;s:12:\"delete-35233\";i:34474;s:12:\"delete-35234\";i:34475;s:12:\"delete-35237\";i:34476;s:12:\"delete-35235\";i:34477;s:12:\"delete-35236\";i:34478;s:12:\"delete-35238\";i:34479;s:12:\"delete-35239\";i:34480;s:12:\"delete-35240\";i:34481;s:12:\"delete-35243\";i:34482;s:12:\"delete-35241\";i:34483;s:12:\"delete-35242\";i:34484;s:12:\"delete-35244\";i:34485;s:12:\"delete-35245\";i:34486;s:12:\"delete-35246\";i:34487;s:12:\"delete-35247\";i:34488;s:12:\"delete-35248\";i:34489;s:12:\"delete-35249\";i:34490;s:12:\"delete-35250\";i:34491;s:12:\"delete-35251\";i:34492;s:12:\"delete-35252\";i:34493;s:12:\"delete-35255\";i:34494;s:12:\"delete-35256\";i:34495;s:12:\"delete-35257\";i:34496;s:12:\"delete-35258\";i:34497;s:12:\"delete-35261\";i:34498;s:12:\"delete-35253\";i:34499;s:12:\"delete-35254\";i:34500;s:12:\"delete-35259\";i:34501;s:12:\"delete-35260\";i:34502;s:12:\"delete-35262\";i:34503;s:12:\"delete-35263\";i:34504;s:12:\"delete-35264\";i:34505;s:12:\"delete-35267\";i:34506;s:12:\"delete-35268\";i:34507;s:12:\"delete-35265\";i:34508;s:12:\"delete-35266\";i:34509;s:12:\"delete-35269\";i:34510;s:12:\"delete-35270\";i:34511;s:12:\"delete-35271\";i:34512;s:12:\"delete-35272\";i:34513;s:12:\"delete-35273\";i:34514;s:12:\"delete-35274\";i:34515;s:12:\"delete-35275\";i:34516;s:12:\"delete-35276\";i:34517;s:12:\"delete-35279\";i:34518;s:12:\"delete-35277\";i:34519;s:12:\"delete-35278\";i:34520;s:12:\"delete-35280\";i:34521;s:12:\"delete-35281\";i:34522;s:12:\"delete-35283\";i:34523;s:12:\"delete-35284\";i:34524;s:12:\"delete-35282\";i:34525;s:12:\"delete-35285\";i:34526;s:12:\"delete-35286\";i:34527;s:12:\"delete-35287\";i:34528;s:12:\"delete-35288\";i:34529;s:12:\"delete-35291\";i:34530;s:12:\"delete-35289\";i:34531;s:12:\"delete-35290\";i:34532;s:12:\"delete-35292\";i:34533;s:12:\"delete-35293\";i:34534;s:12:\"delete-35294\";i:34535;s:12:\"delete-35297\";i:34536;s:12:\"delete-35298\";i:34537;s:12:\"delete-35295\";i:34538;s:12:\"delete-35296\";i:34539;s:12:\"delete-35299\";i:34540;s:12:\"delete-35300\";i:34541;s:12:\"delete-35303\";i:34542;s:12:\"delete-35301\";i:34543;s:12:\"delete-35302\";i:34544;s:12:\"delete-35304\";i:34545;s:12:\"delete-35305\";i:34546;s:12:\"delete-35306\";i:34547;s:12:\"delete-35309\";i:34548;s:12:\"delete-35310\";i:34549;s:12:\"delete-35307\";i:34550;s:12:\"delete-35308\";i:34551;s:12:\"delete-35311\";i:34552;s:12:\"delete-35312\";i:34553;s:12:\"delete-35315\";i:34554;s:12:\"delete-35313\";i:34555;s:12:\"delete-35314\";i:34556;s:12:\"delete-35316\";i:34557;s:12:\"delete-35317\";i:34558;s:12:\"delete-35318\";i:34559;s:12:\"delete-35321\";i:34560;s:12:\"delete-35322\";i:34561;s:12:\"delete-35319\";i:34562;s:12:\"delete-35320\";i:34563;s:12:\"delete-35323\";i:34564;s:12:\"delete-35324\";i:34565;s:12:\"delete-35327\";i:34566;s:12:\"delete-35328\";i:34567;s:12:\"delete-35325\";i:34568;s:12:\"delete-35326\";i:34569;s:12:\"delete-35329\";i:34570;s:12:\"delete-35330\";i:34571;s:12:\"delete-35333\";i:34572;s:12:\"delete-35331\";i:34573;s:12:\"delete-35332\";i:34574;s:12:\"delete-35334\";i:34575;s:12:\"delete-35335\";i:34576;s:12:\"delete-35336\";i:34577;s:12:\"delete-35339\";i:34578;s:12:\"delete-35337\";i:34579;s:12:\"delete-35338\";i:34580;s:12:\"delete-35340\";i:34581;s:12:\"delete-35341\";i:34582;s:12:\"delete-35342\";i:34583;s:12:\"delete-35345\";i:34584;s:12:\"delete-35343\";i:34585;s:12:\"delete-35344\";i:34586;s:12:\"delete-35346\";i:34587;s:12:\"delete-35347\";i:34588;s:12:\"delete-35348\";i:34589;s:12:\"delete-35351\";i:34590;s:12:\"delete-35352\";i:34591;s:12:\"delete-35349\";i:34592;s:12:\"delete-35350\";i:34593;s:12:\"delete-35353\";i:34594;s:12:\"delete-35354\";i:34595;s:12:\"delete-35357\";i:34596;s:12:\"delete-35355\";i:34597;s:12:\"delete-35356\";i:34598;s:12:\"delete-35358\";i:34599;s:12:\"delete-35359\";i:34600;s:12:\"delete-35360\";i:34601;s:12:\"delete-35363\";i:34602;s:12:\"delete-35361\";i:34603;s:12:\"delete-35362\";i:34604;s:12:\"delete-35364\";i:34605;s:12:\"delete-35365\";i:34606;s:12:\"delete-35366\";i:34607;s:12:\"delete-35369\";i:34608;s:12:\"delete-35370\";i:34609;s:12:\"delete-35367\";i:34610;s:12:\"delete-35368\";i:34611;s:12:\"delete-35371\";i:34612;s:12:\"delete-35372\";i:34613;s:12:\"delete-35375\";i:34614;s:12:\"delete-35376\";i:34615;s:12:\"delete-35373\";i:34616;s:12:\"delete-35374\";i:34617;s:12:\"delete-35377\";i:34618;s:12:\"delete-35378\";i:34619;s:12:\"delete-35381\";i:34620;s:12:\"delete-35379\";i:34621;s:12:\"delete-35380\";i:34622;s:12:\"delete-35382\";i:34623;s:12:\"delete-35383\";i:34624;s:12:\"delete-35384\";i:34625;s:12:\"delete-35385\";i:34626;s:12:\"delete-35386\";i:34627;s:12:\"delete-35387\";i:34628;s:12:\"delete-35388\";i:34629;s:12:\"delete-35389\";i:34630;s:12:\"delete-35390\";i:34631;s:12:\"delete-35393\";i:34632;s:12:\"delete-35391\";i:34633;s:12:\"delete-35392\";i:34634;s:12:\"delete-35394\";i:34635;s:12:\"delete-35395\";i:34636;s:12:\"delete-35396\";i:34637;s:12:\"delete-35399\";i:34638;s:12:\"delete-35400\";i:34639;s:12:\"delete-35397\";i:34640;s:12:\"delete-35398\";i:34641;s:12:\"delete-35401\";i:34642;s:12:\"delete-35405\";i:34643;s:12:\"delete-35402\";i:34644;s:12:\"delete-35403\";i:34645;s:12:\"delete-35404\";i:34646;s:12:\"delete-35406\";i:34647;s:12:\"delete-35407\";i:34648;s:12:\"delete-35408\";i:34649;s:12:\"delete-35411\";i:34650;s:12:\"delete-35409\";i:34651;s:12:\"delete-35410\";i:34652;s:12:\"delete-35412\";i:34653;s:12:\"delete-35414\";i:34654;s:12:\"delete-35413\";i:34655;s:12:\"delete-35417\";i:34656;s:12:\"delete-35418\";i:34657;s:12:\"delete-35415\";i:34658;s:12:\"delete-35416\";i:34659;s:12:\"delete-35419\";i:34660;s:12:\"delete-35423\";i:34661;s:12:\"delete-35420\";i:34662;s:12:\"delete-35424\";i:34663;s:12:\"delete-35421\";i:34664;s:12:\"delete-35422\";i:34665;s:12:\"delete-35425\";i:34666;s:12:\"delete-35426\";i:34667;s:12:\"delete-35429\";i:34668;s:12:\"delete-35427\";i:34669;s:12:\"delete-35428\";i:34670;s:12:\"delete-35430\";i:34671;s:12:\"delete-35431\";i:34672;s:12:\"delete-35432\";i:34673;s:12:\"delete-35435\";i:34674;s:12:\"delete-35433\";i:34675;s:12:\"delete-35434\";i:34676;s:12:\"delete-35436\";i:34677;s:12:\"delete-35438\";i:34678;s:12:\"delete-35437\";i:34679;s:12:\"delete-35441\";i:34680;s:12:\"delete-35442\";i:34681;s:12:\"delete-35439\";i:34682;s:12:\"delete-35440\";i:34683;s:12:\"delete-35443\";i:34684;s:12:\"delete-35444\";i:34685;s:12:\"delete-35447\";i:34686;s:12:\"delete-35448\";i:34687;s:12:\"delete-35445\";i:34688;s:12:\"delete-35446\";i:34689;s:12:\"delete-35449\";i:34690;s:12:\"delete-35450\";i:34691;s:12:\"delete-35453\";i:34692;s:12:\"delete-35454\";i:34693;s:12:\"delete-35451\";i:34694;s:12:\"delete-35452\";i:34695;s:12:\"delete-35455\";i:34696;s:12:\"delete-35456\";i:34697;s:12:\"delete-35459\";i:34698;s:12:\"delete-35460\";i:34699;s:12:\"delete-35457\";i:34700;s:12:\"delete-35458\";i:34701;s:12:\"delete-35461\";i:34702;s:12:\"delete-35462\";i:34703;s:12:\"delete-35465\";i:34704;s:12:\"delete-35463\";i:34705;s:12:\"delete-35464\";i:34706;s:12:\"delete-35466\";i:34707;s:12:\"delete-35467\";i:34708;s:12:\"delete-35468\";i:34709;s:12:\"delete-35471\";i:34710;s:12:\"delete-35472\";i:34711;s:12:\"delete-35469\";i:34712;s:12:\"delete-35470\";i:34713;s:12:\"delete-35473\";i:34714;s:12:\"delete-35474\";i:34715;s:12:\"delete-35477\";i:34716;s:12:\"delete-35478\";i:34717;s:12:\"delete-35475\";i:34718;s:12:\"delete-35476\";i:34719;s:12:\"delete-35479\";i:34720;s:12:\"delete-35480\";i:34721;s:12:\"delete-35483\";i:34722;s:12:\"delete-35484\";i:34723;s:12:\"delete-35481\";i:34724;s:12:\"delete-35482\";i:34725;s:12:\"delete-35485\";i:34726;s:12:\"delete-35486\";i:34727;s:12:\"delete-35489\";i:34728;s:12:\"delete-35490\";i:34729;s:12:\"delete-35487\";i:34730;s:12:\"delete-35488\";i:34731;s:12:\"delete-35491\";i:34732;s:12:\"delete-35492\";i:34733;s:12:\"delete-35495\";i:34734;s:12:\"delete-35496\";i:34735;s:12:\"delete-35493\";i:34736;s:12:\"delete-35494\";i:34737;s:12:\"delete-35497\";i:34738;s:12:\"delete-35501\";i:34739;s:12:\"delete-35498\";i:34740;s:12:\"delete-35502\";i:34741;s:12:\"delete-35499\";i:34742;s:12:\"delete-35500\";i:34743;s:12:\"delete-35503\";i:34744;s:12:\"delete-35504\";i:34745;s:12:\"delete-35507\";i:34746;s:12:\"delete-35505\";i:34747;s:12:\"delete-35506\";i:34748;s:12:\"delete-35508\";i:34749;s:12:\"delete-35510\";i:34750;s:12:\"delete-35509\";i:34751;s:12:\"delete-35513\";i:34752;s:12:\"delete-35514\";i:34753;s:12:\"delete-35511\";i:34754;s:12:\"delete-35512\";i:34755;s:12:\"delete-35515\";i:34756;s:12:\"delete-35519\";i:34757;s:12:\"delete-35516\";i:34758;s:12:\"delete-35520\";i:34759;s:12:\"delete-35517\";i:34760;s:12:\"delete-35518\";i:34761;s:12:\"delete-35521\";i:34762;s:12:\"delete-35522\";i:34763;s:12:\"delete-35525\";i:34764;s:12:\"delete-35526\";i:34765;s:12:\"delete-35523\";i:34766;s:12:\"delete-35524\";i:34767;s:12:\"delete-35527\";i:34768;s:12:\"delete-35528\";i:34769;s:12:\"delete-35531\";i:34770;s:12:\"delete-35532\";i:34771;s:12:\"delete-35529\";i:34772;s:12:\"delete-35530\";i:34773;s:12:\"delete-35533\";i:34774;s:12:\"delete-35534\";i:34775;s:12:\"delete-35537\";i:34776;s:12:\"delete-35535\";i:34777;s:12:\"delete-35536\";i:34778;s:12:\"delete-35538\";i:34779;s:12:\"delete-35539\";i:34780;s:12:\"delete-35540\";i:34781;s:12:\"delete-35543\";i:34782;s:12:\"delete-35541\";i:34783;s:12:\"delete-35542\";i:34784;s:12:\"delete-35544\";i:34785;s:12:\"delete-35545\";i:34786;s:12:\"delete-35546\";i:34787;s:12:\"delete-35549\";i:34788;s:12:\"delete-35550\";i:34789;s:12:\"delete-35547\";i:34790;s:12:\"delete-35548\";i:34791;s:12:\"delete-35551\";i:34792;s:12:\"delete-35552\";i:34793;s:12:\"delete-35555\";i:34794;s:12:\"delete-35556\";i:34795;s:12:\"delete-35553\";i:34796;s:12:\"delete-35554\";i:34797;s:12:\"delete-35557\";i:34798;s:12:\"delete-35561\";i:34799;s:12:\"delete-35558\";i:34800;s:12:\"delete-35562\";i:34801;s:12:\"delete-35559\";i:34802;s:12:\"delete-35560\";i:34803;s:12:\"delete-35563\";i:34804;s:12:\"delete-35564\";i:34805;s:12:\"delete-35565\";i:34806;s:12:\"delete-35566\";i:34807;s:12:\"delete-35567\";i:34808;s:12:\"delete-35568\";i:34809;s:12:\"delete-35569\";i:34810;s:12:\"delete-35570\";i:34811;s:12:\"delete-35573\";i:34812;s:12:\"delete-35574\";i:34813;s:12:\"delete-35571\";i:34814;s:12:\"delete-35572\";i:34815;s:12:\"delete-35575\";i:34816;s:12:\"delete-35576\";i:34817;s:12:\"delete-35579\";i:34818;s:12:\"delete-35577\";i:34819;s:12:\"delete-35578\";i:34820;s:12:\"delete-35580\";i:34821;s:12:\"delete-35581\";i:34822;s:12:\"delete-35582\";i:34823;s:12:\"delete-35585\";i:34824;s:12:\"delete-35583\";i:34825;s:12:\"delete-35584\";i:34826;s:12:\"delete-35586\";i:34827;s:12:\"delete-35587\";i:34828;s:12:\"delete-35588\";i:34829;s:12:\"delete-35589\";i:34830;s:12:\"delete-35590\";i:34831;s:12:\"delete-35591\";i:34832;s:12:\"delete-35592\";i:34833;s:12:\"delete-35593\";i:34834;s:12:\"delete-35594\";i:34835;s:12:\"delete-35597\";i:34836;s:12:\"delete-35595\";i:34837;s:12:\"delete-35596\";i:34838;s:12:\"delete-35598\";i:34839;s:12:\"delete-35599\";i:34840;s:12:\"delete-35600\";i:34841;s:12:\"delete-35603\";i:34842;s:12:\"delete-35604\";i:34843;s:12:\"delete-35601\";i:34844;s:12:\"delete-35602\";i:34845;s:12:\"delete-35605\";i:34846;s:12:\"delete-35609\";i:34847;s:12:\"delete-35606\";i:34848;s:12:\"delete-35610\";i:34849;s:12:\"delete-35607\";i:34850;s:12:\"delete-35608\";i:34851;s:12:\"delete-35611\";i:34852;s:12:\"delete-35612\";i:34853;s:12:\"delete-35615\";i:34854;s:12:\"delete-35613\";i:34855;s:12:\"delete-35614\";i:34856;s:12:\"delete-35616\";i:34857;s:12:\"delete-35617\";i:34858;s:12:\"delete-35618\";i:34859;s:12:\"delete-35619\";i:34860;s:12:\"delete-35620\";i:34861;s:12:\"delete-35621\";i:34862;s:12:\"delete-35622\";i:34863;s:12:\"delete-35623\";i:34864;s:12:\"delete-35624\";i:34865;s:12:\"delete-35627\";i:34866;s:12:\"delete-35625\";i:34867;s:12:\"delete-35626\";i:34868;s:12:\"delete-35628\";i:34869;s:12:\"delete-35629\";i:34870;s:12:\"delete-35630\";i:34871;s:12:\"delete-35631\";i:34872;s:12:\"delete-35632\";i:34873;s:12:\"delete-35633\";i:34874;s:12:\"delete-35634\";i:34875;s:12:\"delete-35635\";i:34876;s:12:\"delete-35636\";i:34877;s:12:\"delete-35639\";i:34878;s:12:\"delete-35640\";i:34879;s:12:\"delete-35637\";i:34880;s:12:\"delete-35638\";i:34881;s:12:\"delete-35641\";i:34882;s:12:\"delete-35642\";i:34883;s:12:\"delete-35645\";i:34884;s:12:\"delete-35643\";i:34885;s:12:\"delete-35644\";i:34886;s:12:\"delete-35646\";i:34887;s:12:\"delete-35647\";i:34888;s:12:\"delete-35648\";i:34889;s:12:\"delete-35649\";i:34890;s:12:\"delete-35650\";i:34891;s:12:\"delete-35651\";i:34892;s:12:\"delete-35652\";i:34893;s:12:\"delete-35653\";i:34894;s:12:\"delete-35654\";i:34895;s:12:\"delete-35657\";i:34896;s:12:\"delete-35658\";i:34897;s:12:\"delete-35655\";i:34898;s:12:\"delete-35656\";i:34899;s:12:\"delete-35659\";i:34900;s:12:\"delete-35660\";i:34901;s:12:\"delete-35663\";i:34902;s:12:\"delete-35664\";i:34903;s:12:\"delete-35661\";i:34904;s:12:\"delete-35662\";i:34905;s:12:\"delete-35665\";i:34906;s:12:\"delete-35666\";i:34907;s:12:\"delete-35669\";i:34908;s:12:\"delete-35667\";i:34909;s:12:\"delete-35668\";i:34910;s:12:\"delete-35670\";i:34911;s:12:\"delete-35671\";i:34912;s:12:\"delete-35672\";i:34913;s:12:\"delete-35675\";i:34914;s:12:\"delete-35673\";i:34915;s:12:\"delete-35674\";i:34916;s:12:\"delete-35676\";i:34917;s:12:\"delete-35677\";i:34918;s:12:\"delete-35678\";i:34919;s:12:\"delete-35681\";i:34920;s:12:\"delete-35679\";i:34921;s:12:\"delete-35680\";i:34922;s:12:\"delete-35682\";i:34923;s:12:\"delete-35683\";i:34924;s:12:\"delete-35684\";i:34925;s:12:\"delete-35687\";i:34926;s:12:\"delete-35685\";i:34927;s:12:\"delete-35686\";i:34928;s:12:\"delete-35688\";i:34929;s:12:\"delete-35689\";i:34930;s:12:\"delete-35690\";i:34931;s:12:\"delete-35693\";i:34932;s:12:\"delete-35691\";i:34933;s:12:\"delete-35692\";i:34934;s:12:\"delete-35694\";i:34935;s:12:\"delete-35695\";i:34936;s:12:\"delete-35698\";i:34937;s:12:\"delete-35696\";i:34938;s:12:\"delete-35697\";i:34939;s:12:\"delete-35699\";i:34940;s:12:\"delete-35700\";i:34941;s:12:\"delete-35701\";i:34942;s:12:\"delete-35704\";i:34943;s:12:\"delete-35705\";i:34944;s:12:\"delete-35702\";i:34945;s:12:\"delete-35703\";i:34946;s:12:\"delete-35706\";i:34947;s:12:\"delete-35707\";i:34948;s:12:\"delete-35710\";i:34949;s:12:\"delete-35708\";i:34950;s:12:\"delete-35709\";i:34951;s:12:\"delete-35711\";i:34952;s:12:\"delete-35712\";i:34953;s:12:\"delete-35713\";i:34954;s:12:\"delete-35716\";i:34955;s:12:\"delete-35714\";i:34956;s:12:\"delete-35715\";i:34957;s:12:\"delete-35717\";i:34958;s:12:\"delete-35718\";i:34959;s:12:\"delete-35719\";i:34960;s:12:\"delete-35722\";i:34961;s:12:\"delete-35723\";i:34962;s:12:\"delete-35720\";i:34963;s:12:\"delete-35721\";i:34964;s:12:\"delete-35724\";i:34965;s:12:\"delete-35725\";i:34966;s:12:\"delete-35728\";i:34967;s:12:\"delete-35729\";i:34968;s:12:\"delete-35726\";i:34969;s:12:\"delete-35727\";i:34970;s:12:\"delete-35730\";i:34971;s:12:\"delete-35731\";i:34972;s:12:\"delete-35734\";i:34973;s:12:\"delete-35735\";i:34974;s:12:\"delete-35732\";i:34975;s:12:\"delete-35733\";i:34976;s:12:\"delete-35736\";i:34977;s:12:\"delete-35737\";i:34978;s:12:\"delete-35738\";i:34979;s:12:\"delete-35739\";i:34980;s:12:\"delete-35740\";i:34981;s:12:\"delete-35741\";i:34982;s:12:\"delete-35742\";i:34983;s:12:\"delete-35743\";i:34984;s:12:\"delete-35746\";i:34985;s:12:\"delete-35747\";i:34986;s:12:\"delete-35744\";i:34987;s:12:\"delete-35745\";i:34988;s:12:\"delete-35748\";i:34989;s:12:\"delete-35749\";i:34990;s:12:\"delete-35752\";i:34991;s:12:\"delete-35753\";i:34992;s:12:\"delete-35750\";i:34993;s:12:\"delete-35751\";i:34994;s:12:\"delete-35754\";i:34995;s:12:\"delete-35755\";i:34996;s:12:\"delete-35758\";i:34997;s:12:\"delete-35759\";i:34998;s:12:\"delete-35756\";i:34999;s:12:\"delete-35757\";i:35000;s:12:\"delete-35760\";i:35001;s:12:\"delete-35761\";i:35002;s:12:\"delete-35764\";i:35003;s:12:\"delete-35765\";i:35004;s:12:\"delete-35762\";i:35005;s:12:\"delete-35763\";i:35006;s:12:\"delete-35766\";i:35007;s:12:\"delete-35767\";i:35008;s:12:\"delete-35770\";i:35009;s:12:\"delete-35768\";i:35010;s:12:\"delete-35769\";i:35011;s:12:\"delete-35771\";i:35012;s:12:\"delete-35772\";i:35013;s:12:\"delete-35773\";i:35014;s:12:\"delete-35776\";i:35015;s:12:\"delete-35777\";i:35016;s:12:\"delete-35774\";i:35017;s:12:\"delete-35775\";i:35018;s:12:\"delete-35778\";i:35019;s:12:\"delete-35779\";i:35020;s:12:\"delete-35782\";i:35021;s:12:\"delete-35780\";i:35022;s:12:\"delete-35781\";i:35023;s:12:\"delete-35783\";i:35024;s:12:\"delete-35784\";i:35025;s:12:\"delete-35785\";i:35026;s:12:\"delete-35786\";i:35027;s:12:\"delete-35787\";i:35028;s:12:\"delete-35788\";i:35029;s:12:\"delete-35789\";i:35030;s:12:\"delete-35790\";i:35031;s:12:\"delete-35791\";i:35032;s:12:\"delete-35794\";i:35033;s:12:\"delete-35792\";i:35034;s:12:\"delete-35793\";i:35035;s:12:\"delete-35795\";i:35036;s:12:\"delete-35796\";i:35037;s:12:\"delete-35797\";i:35038;s:12:\"delete-35800\";i:35039;s:12:\"delete-35801\";i:35040;s:12:\"delete-35798\";i:35041;s:12:\"delete-35799\";i:35042;s:12:\"delete-35802\";i:35043;s:12:\"delete-35803\";i:35044;s:12:\"delete-35806\";i:35045;s:12:\"delete-35807\";i:35046;s:12:\"delete-35804\";i:35047;s:12:\"delete-35805\";i:35048;s:12:\"delete-35808\";i:35049;s:12:\"delete-35809\";i:35050;s:12:\"delete-35812\";i:35051;s:12:\"delete-35813\";i:35052;s:12:\"delete-35814\";i:35053;s:12:\"delete-35815\";i:35054;s:12:\"delete-35818\";i:35055;s:12:\"delete-35810\";i:35056;s:12:\"delete-35811\";i:35057;s:12:\"delete-35816\";i:35058;s:12:\"delete-35817\";i:35059;s:12:\"delete-35819\";i:35060;s:12:\"delete-35820\";i:35061;s:12:\"delete-35821\";i:35062;s:12:\"delete-35824\";i:35063;s:12:\"delete-35825\";i:35064;s:12:\"delete-35822\";i:35065;s:12:\"delete-35823\";i:35066;s:12:\"delete-35826\";i:35067;s:12:\"delete-35827\";i:35068;s:12:\"delete-35830\";i:35069;s:12:\"delete-35828\";i:35070;s:12:\"delete-35829\";i:35071;s:12:\"delete-35831\";i:35072;s:12:\"delete-35832\";i:35073;s:12:\"delete-35833\";i:35074;s:12:\"delete-35836\";i:35075;s:12:\"delete-35837\";i:35076;s:12:\"delete-35834\";i:35077;s:12:\"delete-35835\";i:35078;s:12:\"delete-35838\";i:35079;s:12:\"delete-35839\";i:35080;s:12:\"delete-35842\";i:35081;s:12:\"delete-35843\";i:35082;s:12:\"delete-35840\";i:35083;s:12:\"delete-35841\";i:35084;s:12:\"delete-35844\";i:35085;s:12:\"delete-35845\";i:35086;s:12:\"delete-35848\";i:35087;s:12:\"delete-35849\";i:35088;s:12:\"delete-35846\";i:35089;s:12:\"delete-35847\";i:35090;s:12:\"delete-35850\";i:35091;s:12:\"delete-35851\";i:35092;s:12:\"delete-35854\";i:35093;s:12:\"delete-35855\";i:35094;s:12:\"delete-35852\";i:35095;s:12:\"delete-35853\";i:35096;s:12:\"delete-35856\";i:35097;s:12:\"delete-35857\";i:35098;s:12:\"delete-35860\";i:35099;s:12:\"delete-35861\";i:35100;s:12:\"delete-35858\";i:35101;s:12:\"delete-35859\";i:35102;s:12:\"delete-35862\";i:35103;s:12:\"delete-35863\";i:35104;s:12:\"delete-35866\";i:35105;s:12:\"delete-35864\";i:35106;s:12:\"delete-35865\";i:35107;s:12:\"delete-35867\";i:35108;s:12:\"delete-35868\";i:35109;s:12:\"delete-35869\";i:35110;s:12:\"delete-35870\";i:35111;s:12:\"delete-35871\";i:35112;s:12:\"delete-35872\";i:35113;s:12:\"delete-35873\";i:35114;s:12:\"delete-35874\";i:35115;s:12:\"delete-35875\";i:35116;s:12:\"delete-35878\";i:35117;s:12:\"delete-35879\";i:35118;s:12:\"delete-35876\";i:35119;s:12:\"delete-35877\";i:35120;s:12:\"delete-35880\";i:35121;s:12:\"delete-35881\";i:35122;s:12:\"delete-35884\";i:35123;s:12:\"delete-35882\";i:35124;s:12:\"delete-35883\";i:35125;s:12:\"delete-35885\";i:35126;s:12:\"delete-35886\";i:35127;s:12:\"delete-35889\";i:35128;s:12:\"delete-35890\";i:35129;s:12:\"delete-35887\";i:35130;s:12:\"delete-35888\";i:35131;s:12:\"delete-35891\";i:35132;s:12:\"delete-35892\";i:35133;s:12:\"delete-35893\";i:35134;s:12:\"delete-35894\";i:35135;s:12:\"delete-35895\";i:35136;s:12:\"delete-35896\";i:35137;s:12:\"delete-35897\";i:35138;s:12:\"delete-35898\";i:35139;s:12:\"delete-35901\";i:35140;s:12:\"delete-35902\";i:35141;s:12:\"delete-35899\";i:35142;s:12:\"delete-35900\";i:35143;s:12:\"delete-35903\";i:35144;s:12:\"delete-35904\";i:35145;s:12:\"delete-35905\";i:35146;s:12:\"delete-35906\";i:35147;s:12:\"delete-35907\";i:35148;s:12:\"delete-35908\";i:35149;s:12:\"delete-35909\";i:35150;s:12:\"delete-35910\";i:35151;s:12:\"delete-35911\";i:35152;s:12:\"delete-35912\";i:35153;s:12:\"delete-35913\";i:35154;s:12:\"delete-35914\";i:35155;s:12:\"delete-35915\";i:35156;s:12:\"delete-35916\";i:35157;s:12:\"delete-35919\";i:35158;s:12:\"delete-35917\";i:35159;s:12:\"delete-35918\";i:35160;s:12:\"delete-35920\";i:35161;s:12:\"delete-35921\";i:35162;s:12:\"delete-35922\";i:35163;s:12:\"delete-35925\";i:35164;s:12:\"delete-35923\";i:35165;s:12:\"delete-35924\";i:35166;s:12:\"delete-35926\";i:35167;s:12:\"delete-35927\";i:35168;s:12:\"delete-35928\";i:35169;s:12:\"delete-35931\";i:35170;s:12:\"delete-35929\";i:35171;s:12:\"delete-35930\";i:35172;s:12:\"delete-35932\";i:35173;s:12:\"delete-35933\";i:35174;s:12:\"delete-35934\";i:35175;s:12:\"delete-35937\";i:35176;s:12:\"delete-35938\";i:35177;s:12:\"delete-35935\";i:35178;s:12:\"delete-35936\";i:35179;s:12:\"delete-35939\";i:35180;s:12:\"delete-35940\";i:35181;s:12:\"delete-35941\";i:35182;s:12:\"delete-35942\";i:35183;s:12:\"delete-35943\";i:35184;s:12:\"delete-35944\";i:35185;s:12:\"delete-35945\";i:35186;s:12:\"delete-35946\";i:35187;s:12:\"delete-35949\";i:35188;s:12:\"delete-35947\";i:35189;s:12:\"delete-35948\";i:35190;s:12:\"delete-35950\";i:35191;s:12:\"delete-35951\";i:35192;s:12:\"delete-35952\";i:35193;s:12:\"delete-35955\";i:35194;s:12:\"delete-35956\";i:35195;s:12:\"delete-35953\";i:35196;s:12:\"delete-35954\";i:35197;s:12:\"delete-35957\";i:35198;s:12:\"delete-35958\";i:35199;s:12:\"delete-35961\";i:35200;s:12:\"delete-35962\";i:35201;s:12:\"delete-35959\";i:35202;s:12:\"delete-35960\";i:35203;s:12:\"delete-35963\";i:35204;s:12:\"delete-35964\";i:35205;s:12:\"delete-35967\";i:35206;s:12:\"delete-35968\";i:35207;s:12:\"delete-35965\";i:35208;s:12:\"delete-35966\";i:35209;s:12:\"delete-35969\";i:35210;s:12:\"delete-35970\";i:35211;s:12:\"delete-35973\";i:35212;s:12:\"delete-35974\";i:35213;s:12:\"delete-35971\";i:35214;s:12:\"delete-35972\";i:35215;s:12:\"delete-35975\";i:35216;s:12:\"delete-35976\";i:35217;s:12:\"delete-35979\";i:35218;s:12:\"delete-35980\";i:35219;s:12:\"delete-35977\";i:35220;s:12:\"delete-35978\";i:35221;s:12:\"delete-35981\";i:35222;s:12:\"delete-35982\";i:35223;s:12:\"delete-35985\";i:35224;s:12:\"delete-35986\";i:35225;s:12:\"delete-35983\";i:35226;s:12:\"delete-35984\";i:35227;s:12:\"delete-35987\";i:35228;s:12:\"delete-35988\";i:35229;s:12:\"delete-35989\";i:35230;s:12:\"delete-35990\";i:35231;s:12:\"delete-35991\";i:35232;s:12:\"delete-35992\";i:35233;s:12:\"delete-35993\";i:35234;s:12:\"delete-35994\";i:35235;s:12:\"delete-35997\";i:35236;s:12:\"delete-35998\";i:35237;s:12:\"delete-35995\";i:35238;s:12:\"delete-35996\";i:35239;s:12:\"delete-35999\";i:35240;s:12:\"delete-36000\";i:35241;s:12:\"delete-36003\";i:35242;s:12:\"delete-36004\";i:35243;s:12:\"delete-36001\";i:35244;s:12:\"delete-36002\";i:35245;s:12:\"delete-36005\";i:35246;s:12:\"delete-36006\";i:35247;s:12:\"delete-36009\";i:35248;s:12:\"delete-36007\";i:35249;s:12:\"delete-36008\";i:35250;s:12:\"delete-36010\";i:35251;s:12:\"delete-36011\";i:35252;s:12:\"delete-36012\";i:35253;s:12:\"delete-36015\";i:35254;s:12:\"delete-36016\";i:35255;s:12:\"delete-36013\";i:35256;s:12:\"delete-36014\";i:35257;s:12:\"delete-36017\";i:35258;s:12:\"delete-36018\";i:35259;s:12:\"delete-36021\";i:35260;s:12:\"delete-36022\";i:35261;s:12:\"delete-36019\";i:35262;s:12:\"delete-36020\";i:35263;s:12:\"delete-36023\";i:35264;s:12:\"delete-36024\";i:35265;s:12:\"delete-36025\";i:35266;s:12:\"delete-36026\";i:35267;s:12:\"delete-36027\";i:35268;s:12:\"delete-36028\";i:35269;s:12:\"delete-36029\";i:35270;s:12:\"delete-36030\";i:35271;s:12:\"delete-36033\";i:35272;s:12:\"delete-36031\";i:35273;s:12:\"delete-36032\";i:35274;s:12:\"delete-36034\";i:35275;s:12:\"delete-36035\";i:35276;s:12:\"delete-36036\";i:35277;s:12:\"delete-36039\";i:35278;s:12:\"delete-36037\";i:35279;s:12:\"delete-36038\";i:35280;s:12:\"delete-36040\";i:35281;s:12:\"delete-36041\";i:35282;s:12:\"delete-36042\";i:35283;s:12:\"delete-36045\";i:35284;s:12:\"delete-36046\";i:35285;s:12:\"delete-36043\";i:35286;s:12:\"delete-36044\";i:35287;s:12:\"delete-36047\";i:35288;s:12:\"delete-36048\";i:35289;s:12:\"delete-36051\";i:35290;s:12:\"delete-36052\";i:35291;s:12:\"delete-36049\";i:35292;s:12:\"delete-36050\";i:35293;s:12:\"delete-36053\";i:35294;s:12:\"delete-36054\";i:35295;s:12:\"delete-36057\";i:35296;s:12:\"delete-36055\";i:35297;s:12:\"delete-36056\";i:35298;s:12:\"delete-36058\";i:35299;s:12:\"delete-36059\";i:35300;s:12:\"delete-36060\";i:35301;s:12:\"delete-36063\";i:35302;s:12:\"delete-36064\";i:35303;s:12:\"delete-36061\";i:35304;s:12:\"delete-36062\";i:35305;s:12:\"delete-36065\";i:35306;s:12:\"delete-36066\";i:35307;s:12:\"delete-36069\";i:35308;s:12:\"delete-36067\";i:35309;s:12:\"delete-36068\";i:35310;s:12:\"delete-36070\";i:35311;s:12:\"delete-36071\";i:35312;s:12:\"delete-36072\";i:35313;s:12:\"delete-36075\";i:35314;s:12:\"delete-36076\";i:35315;s:12:\"delete-36073\";i:35316;s:12:\"delete-36074\";i:35317;s:12:\"delete-36077\";i:35318;s:12:\"delete-36078\";i:35319;s:12:\"delete-36081\";i:35320;s:12:\"delete-36082\";i:35321;s:12:\"delete-36079\";i:35322;s:12:\"delete-36080\";i:35323;s:12:\"delete-36083\";i:35324;s:12:\"delete-36084\";i:35325;s:12:\"delete-36087\";i:35326;s:12:\"delete-36088\";i:35327;s:12:\"delete-36085\";i:35328;s:12:\"delete-36086\";i:35329;s:12:\"delete-36089\";i:35330;s:12:\"delete-36090\";i:35331;s:12:\"delete-36093\";i:35332;s:12:\"delete-36094\";i:35333;s:12:\"delete-36091\";i:35334;s:12:\"delete-36092\";i:35335;s:12:\"delete-36095\";i:35336;s:12:\"delete-36096\";i:35337;s:12:\"delete-36099\";i:35338;s:12:\"delete-36100\";i:35339;s:12:\"delete-36097\";i:35340;s:12:\"delete-36098\";i:35341;s:12:\"delete-36101\";i:35342;s:12:\"delete-36102\";i:35343;s:12:\"delete-36105\";i:35344;s:12:\"delete-36103\";i:35345;s:12:\"delete-36104\";i:35346;s:12:\"delete-36106\";i:35347;s:12:\"delete-36107\";i:35348;s:12:\"delete-36108\";i:35349;s:12:\"delete-36111\";i:35350;s:12:\"delete-36109\";i:35351;s:12:\"delete-36110\";i:35352;s:12:\"delete-36112\";i:35353;s:12:\"delete-36113\";i:35354;s:12:\"delete-36114\";i:35355;s:12:\"delete-36117\";i:35356;s:12:\"delete-36115\";i:35357;s:12:\"delete-36116\";i:35358;s:12:\"delete-36118\";i:35359;s:12:\"delete-36119\";i:35360;s:12:\"delete-36120\";i:35361;s:12:\"delete-36123\";i:35362;s:12:\"delete-36124\";i:35363;s:12:\"delete-36121\";i:35364;s:12:\"delete-36122\";i:35365;s:12:\"delete-36125\";i:35366;s:12:\"delete-36126\";i:35367;s:12:\"delete-36129\";i:35368;s:12:\"delete-36127\";i:35369;s:12:\"delete-36128\";i:35370;s:12:\"delete-36130\";i:35371;s:12:\"delete-36131\";i:35372;s:12:\"delete-36132\";i:35373;s:12:\"delete-36135\";i:35374;s:12:\"delete-36133\";i:35375;s:12:\"delete-36134\";i:35376;s:12:\"delete-36136\";i:35377;s:12:\"delete-36137\";i:35378;s:12:\"delete-36138\";i:35379;s:12:\"delete-36139\";i:35380;s:12:\"delete-36140\";i:35381;s:12:\"delete-36141\";i:35382;s:12:\"delete-36142\";i:35383;s:12:\"delete-36143\";i:35384;s:12:\"delete-36144\";i:35385;s:12:\"delete-36147\";i:35386;s:12:\"delete-36148\";i:35387;s:12:\"delete-36145\";i:35388;s:12:\"delete-36146\";i:35389;s:12:\"delete-36149\";i:35390;s:12:\"delete-36150\";i:35391;s:12:\"delete-36153\";i:35392;s:12:\"delete-36154\";i:35393;s:12:\"delete-36151\";i:35394;s:12:\"delete-36152\";i:35395;s:12:\"delete-36155\";i:35396;s:12:\"delete-36156\";i:35397;s:12:\"delete-36159\";i:35398;s:12:\"delete-36157\";i:35399;s:12:\"delete-36158\";i:35400;s:12:\"delete-36160\";i:35401;s:12:\"delete-36161\";i:35402;s:12:\"delete-36162\";i:35403;s:12:\"delete-36163\";i:35404;s:12:\"delete-36164\";i:35405;s:12:\"delete-36165\";i:35406;s:12:\"delete-36166\";i:35407;s:12:\"delete-36167\";i:35408;s:12:\"delete-36168\";i:35409;s:12:\"delete-36171\";i:35410;s:12:\"delete-36172\";i:35411;s:12:\"delete-36169\";i:35412;s:12:\"delete-36170\";i:35413;s:12:\"delete-36173\";i:35414;s:12:\"delete-36174\";i:35415;s:12:\"delete-36177\";i:35416;s:12:\"delete-36178\";i:35417;s:12:\"delete-36175\";i:35418;s:12:\"delete-36176\";i:35419;s:12:\"delete-36179\";i:35420;s:12:\"delete-36180\";i:35421;s:12:\"delete-36183\";i:35422;s:12:\"delete-36184\";i:35423;s:12:\"delete-36181\";i:35424;s:12:\"delete-36182\";i:35425;s:12:\"delete-36185\";i:35426;s:12:\"delete-36186\";i:35427;s:12:\"delete-36189\";i:35428;s:12:\"delete-36190\";i:35429;s:12:\"delete-36187\";i:35430;s:12:\"delete-36188\";i:35431;s:12:\"delete-36191\";i:35432;s:12:\"delete-36192\";i:35433;s:12:\"delete-36195\";i:35434;s:12:\"delete-36196\";i:35435;s:12:\"delete-36193\";i:35436;s:12:\"delete-36194\";i:35437;s:12:\"delete-36197\";i:35438;s:12:\"delete-36198\";i:35439;s:12:\"delete-36201\";i:35440;s:12:\"delete-36202\";i:35441;s:12:\"delete-36199\";i:35442;s:12:\"delete-36200\";i:35443;s:12:\"delete-36203\";i:35444;s:12:\"delete-36204\";i:35445;s:12:\"delete-36207\";i:35446;s:12:\"delete-36208\";i:35447;s:12:\"delete-36205\";i:35448;s:12:\"delete-36206\";i:35449;s:12:\"delete-36209\";i:35450;s:12:\"delete-36210\";i:35451;s:12:\"delete-36213\";i:35452;s:12:\"delete-36214\";i:35453;s:12:\"delete-36211\";i:35454;s:12:\"delete-36212\";i:35455;s:12:\"delete-36215\";i:35456;s:12:\"delete-36216\";i:35457;s:12:\"delete-36219\";i:35458;s:12:\"delete-36220\";i:35459;s:12:\"delete-36217\";i:35460;s:12:\"delete-36218\";i:35461;s:12:\"delete-36221\";i:35462;s:12:\"delete-36222\";i:35463;s:12:\"delete-36225\";i:35464;s:12:\"delete-36223\";i:35465;s:12:\"delete-36224\";i:35466;s:12:\"delete-36226\";i:35467;s:12:\"delete-36227\";i:35468;s:12:\"delete-36228\";i:35469;s:12:\"delete-36231\";i:35470;s:12:\"delete-36229\";i:35471;s:12:\"delete-36230\";i:35472;s:12:\"delete-36232\";i:35473;s:12:\"delete-36233\";i:35474;s:12:\"delete-36234\";i:35475;s:12:\"delete-36237\";i:35476;s:12:\"delete-36235\";i:35477;s:12:\"delete-36236\";i:35478;s:12:\"delete-36238\";i:35479;s:12:\"delete-36239\";i:35480;s:12:\"delete-36240\";i:35481;s:12:\"delete-36241\";i:35482;s:12:\"delete-36242\";i:35483;s:12:\"delete-36243\";i:35484;s:12:\"delete-36244\";i:35485;s:12:\"delete-36245\";i:35486;s:12:\"delete-36246\";i:35487;s:12:\"delete-36249\";i:35488;s:12:\"delete-36247\";i:35489;s:12:\"delete-36248\";i:35490;s:12:\"delete-36250\";i:35491;s:12:\"delete-36251\";i:35492;s:12:\"delete-36252\";i:35493;s:12:\"delete-36253\";i:35494;s:12:\"delete-36254\";i:35495;s:12:\"delete-36255\";i:35496;s:12:\"delete-36256\";i:35497;s:12:\"delete-36257\";i:35498;s:12:\"delete-36258\";i:35499;s:12:\"delete-36261\";i:35500;s:12:\"delete-36262\";i:35501;s:12:\"delete-36263\";i:35502;s:12:\"delete-36264\";i:35503;s:12:\"delete-36267\";i:35504;s:12:\"delete-36259\";i:35505;s:12:\"delete-36260\";i:35506;s:12:\"delete-36265\";i:35507;s:12:\"delete-36266\";i:35508;s:12:\"delete-36268\";i:35509;s:12:\"delete-36269\";i:35510;s:12:\"delete-36270\";i:35511;s:12:\"delete-36271\";i:35512;s:12:\"delete-36272\";i:35513;s:12:\"delete-36273\";i:35514;s:12:\"delete-36274\";i:35515;s:12:\"delete-36275\";i:35516;s:12:\"delete-36276\";i:35517;s:12:\"delete-36279\";i:35518;s:12:\"delete-36277\";i:35519;s:12:\"delete-36278\";i:35520;s:12:\"delete-36280\";i:35521;s:12:\"delete-36281\";i:35522;s:12:\"delete-36282\";i:35523;s:12:\"delete-36285\";i:35524;s:12:\"delete-36283\";i:35525;s:12:\"delete-36284\";i:35526;s:12:\"delete-36286\";i:35527;s:12:\"delete-36287\";i:35528;s:12:\"delete-36288\";i:35529;s:12:\"delete-36291\";i:35530;s:12:\"delete-36292\";i:35531;s:12:\"delete-36289\";i:35532;s:12:\"delete-36290\";i:35533;s:12:\"delete-36293\";i:35534;s:12:\"delete-36294\";i:35535;s:12:\"delete-36297\";i:35536;s:12:\"delete-36298\";i:35537;s:12:\"delete-36295\";i:35538;s:12:\"delete-36296\";i:35539;s:12:\"delete-36299\";i:35540;s:12:\"delete-36300\";i:35541;s:12:\"delete-36303\";i:35542;s:12:\"delete-36304\";i:35543;s:12:\"delete-36301\";i:35544;s:12:\"delete-36302\";i:35545;s:12:\"delete-36305\";i:35546;s:12:\"delete-36306\";i:35547;s:12:\"delete-36309\";i:35548;s:12:\"delete-36307\";i:35549;s:12:\"delete-36308\";i:35550;s:12:\"delete-36310\";i:35551;s:12:\"delete-36311\";i:35552;s:12:\"delete-36312\";i:35553;s:12:\"delete-36315\";i:35554;s:12:\"delete-36313\";i:35555;s:12:\"delete-36314\";i:35556;s:12:\"delete-36316\";i:35557;s:12:\"delete-36317\";i:35558;s:12:\"delete-36318\";i:35559;s:12:\"delete-36321\";i:35560;s:12:\"delete-36319\";i:35561;s:12:\"delete-36320\";i:35562;s:12:\"delete-36322\";i:35563;s:12:\"delete-36323\";i:35564;s:12:\"delete-36324\";i:35565;s:12:\"delete-36327\";i:35566;s:12:\"delete-36328\";i:35567;s:12:\"delete-36325\";i:35568;s:12:\"delete-36326\";i:35569;s:12:\"delete-36329\";i:35570;s:12:\"delete-36330\";i:35571;s:12:\"delete-36331\";i:35572;s:12:\"delete-36332\";i:35573;s:12:\"delete-36333\";i:35574;s:12:\"delete-36334\";i:35575;s:12:\"delete-36335\";i:35576;s:12:\"delete-36336\";i:35577;s:12:\"delete-36337\";i:35578;s:12:\"delete-36338\";i:35579;s:12:\"delete-36339\";i:35580;s:12:\"delete-36340\";i:35581;s:12:\"delete-36341\";i:35582;s:12:\"delete-36342\";i:35583;s:12:\"delete-36343\";i:35584;s:12:\"delete-36344\";i:35585;s:12:\"delete-36345\";i:35586;s:12:\"delete-36346\";i:35587;s:12:\"delete-36347\";i:35588;s:12:\"delete-36348\";i:35589;s:12:\"delete-36351\";i:35590;s:12:\"delete-36352\";i:35591;s:12:\"delete-36349\";i:35592;s:12:\"delete-36350\";i:35593;s:12:\"delete-36353\";i:35594;s:12:\"delete-36354\";i:35595;s:12:\"delete-36357\";i:35596;s:12:\"delete-36358\";i:35597;s:12:\"delete-36355\";i:35598;s:12:\"delete-36356\";i:35599;s:12:\"delete-36359\";i:35600;s:12:\"delete-36360\";i:35601;s:12:\"delete-36363\";i:35602;s:12:\"delete-36364\";i:35603;s:12:\"delete-36361\";i:35604;s:12:\"delete-36362\";i:35605;s:12:\"delete-36365\";i:35606;s:12:\"delete-36366\";i:35607;s:12:\"delete-36367\";i:35608;s:12:\"delete-36368\";i:35609;s:12:\"delete-36369\";i:35610;s:12:\"delete-36370\";i:35611;s:12:\"delete-36371\";i:35612;s:12:\"delete-36372\";i:35613;s:12:\"delete-36375\";i:35614;s:12:\"delete-36376\";i:35615;s:12:\"delete-36373\";i:35616;s:12:\"delete-36374\";i:35617;s:12:\"delete-36377\";i:35618;s:12:\"delete-36378\";i:35619;s:12:\"delete-36381\";i:35620;s:12:\"delete-36382\";i:35621;s:12:\"delete-36383\";i:35622;s:12:\"delete-36384\";i:35623;s:12:\"delete-36387\";i:35624;s:12:\"delete-36388\";i:35625;s:12:\"delete-36379\";i:35626;s:12:\"delete-36380\";i:35627;s:12:\"delete-36385\";i:35628;s:12:\"delete-36386\";i:35629;s:12:\"delete-36389\";i:35630;s:12:\"delete-36390\";i:35631;s:12:\"delete-36393\";i:35632;s:12:\"delete-36394\";i:35633;s:12:\"delete-36391\";i:35634;s:12:\"delete-36392\";i:35635;s:12:\"delete-36395\";i:35636;s:12:\"delete-36396\";i:35637;s:12:\"delete-36399\";i:35638;s:12:\"delete-36397\";i:35639;s:12:\"delete-36398\";i:35640;s:12:\"delete-36400\";i:35641;s:12:\"delete-36401\";i:35642;s:12:\"delete-36402\";i:35643;s:12:\"delete-36405\";i:35644;s:12:\"delete-36406\";i:35645;s:12:\"delete-36403\";i:35646;s:12:\"delete-36404\";i:35647;s:12:\"delete-36407\";i:35648;s:12:\"delete-36408\";i:35649;s:12:\"delete-36411\";i:35650;s:12:\"delete-36412\";i:35651;s:12:\"delete-36409\";i:35652;s:12:\"delete-36410\";i:35653;s:12:\"delete-36413\";i:35654;s:12:\"delete-36414\";i:35655;s:12:\"delete-36417\";i:35656;s:12:\"delete-36418\";i:35657;s:12:\"delete-36415\";i:35658;s:12:\"delete-36416\";i:35659;s:12:\"delete-36419\";i:35660;s:12:\"delete-36420\";i:35661;s:12:\"delete-36423\";i:35662;s:12:\"delete-36424\";i:35663;s:12:\"delete-36421\";i:35664;s:12:\"delete-36422\";i:35665;s:12:\"delete-36425\";i:35666;s:12:\"delete-36426\";i:35667;s:12:\"delete-36429\";i:35668;s:12:\"delete-36430\";i:35669;s:12:\"delete-36427\";i:35670;s:12:\"delete-36428\";i:35671;s:12:\"delete-36431\";i:35672;s:12:\"delete-36432\";i:35673;s:12:\"delete-36435\";i:35674;s:12:\"delete-36433\";i:35675;s:12:\"delete-36434\";i:35676;s:12:\"delete-36436\";i:35677;s:12:\"delete-36437\";i:35678;s:12:\"delete-36438\";i:35679;s:12:\"delete-36441\";i:35680;s:12:\"delete-36442\";i:35681;s:12:\"delete-36439\";i:35682;s:12:\"delete-36440\";i:35683;s:12:\"delete-36443\";i:35684;s:12:\"delete-36444\";i:35685;s:12:\"delete-36447\";i:35686;s:12:\"delete-36448\";i:35687;s:12:\"delete-36445\";i:35688;s:12:\"delete-36446\";i:35689;s:12:\"delete-36449\";i:35690;s:12:\"delete-36450\";i:35691;s:12:\"delete-36453\";i:35692;s:12:\"delete-36451\";i:35693;s:12:\"delete-36452\";i:35694;s:12:\"delete-36454\";i:35695;s:12:\"delete-36455\";i:35696;s:12:\"delete-36456\";i:35697;s:12:\"delete-36459\";i:35698;s:12:\"delete-36460\";i:35699;s:12:\"delete-36457\";i:35700;s:12:\"delete-36458\";i:35701;s:12:\"delete-36461\";i:35702;s:12:\"delete-36462\";i:35703;s:12:\"delete-36465\";i:35704;s:12:\"delete-36463\";i:35705;s:12:\"delete-36464\";i:35706;s:12:\"delete-36466\";i:35707;s:12:\"delete-36467\";i:35708;s:12:\"delete-36468\";i:35709;s:12:\"delete-36471\";i:35710;s:12:\"delete-36472\";i:35711;s:12:\"delete-36469\";i:35712;s:12:\"delete-36470\";i:35713;s:12:\"delete-36473\";i:35714;s:12:\"delete-36474\";i:35715;s:12:\"delete-36475\";i:35716;s:12:\"delete-36476\";i:35717;s:12:\"delete-36477\";i:35718;s:12:\"delete-36478\";i:35719;s:12:\"delete-36479\";i:35720;s:12:\"delete-36480\";i:35721;s:12:\"delete-36483\";i:35722;s:12:\"delete-36484\";i:35723;s:12:\"delete-36481\";i:35724;s:12:\"delete-36482\";i:35725;s:12:\"delete-36485\";i:35726;s:12:\"delete-36486\";i:35727;s:12:\"delete-36489\";i:35728;s:12:\"delete-36487\";i:35729;s:12:\"delete-36488\";i:35730;s:12:\"delete-36490\";i:35731;s:12:\"delete-36491\";i:35732;s:12:\"delete-36492\";i:35733;s:12:\"delete-36493\";i:35734;s:12:\"delete-36494\";i:35735;s:12:\"delete-36495\";i:35736;s:12:\"delete-36496\";i:35737;s:12:\"delete-36497\";i:35738;s:12:\"delete-36498\";i:35739;s:12:\"delete-36501\";i:35740;s:12:\"delete-36502\";i:35741;s:12:\"delete-36499\";i:35742;s:12:\"delete-36500\";i:35743;s:12:\"delete-36503\";i:35744;s:12:\"delete-36504\";i:35745;s:12:\"delete-36505\";i:35746;s:12:\"delete-36506\";i:35747;s:12:\"delete-36507\";i:35748;s:12:\"delete-36508\";i:35749;s:12:\"delete-36509\";i:35750;s:12:\"delete-36510\";i:35751;s:12:\"delete-36513\";i:35752;s:12:\"delete-36511\";i:35753;s:12:\"delete-36512\";i:35754;s:12:\"delete-36514\";i:35755;s:12:\"delete-36515\";i:35756;s:12:\"delete-36516\";i:35757;s:12:\"delete-36519\";i:35758;s:12:\"delete-36520\";i:35759;s:12:\"delete-36517\";i:35760;s:12:\"delete-36518\";i:35761;s:12:\"delete-36521\";i:35762;s:12:\"delete-36522\";i:35763;s:12:\"delete-36525\";i:35764;s:12:\"delete-36526\";i:35765;s:12:\"delete-36523\";i:35766;s:12:\"delete-36524\";i:35767;s:12:\"delete-36527\";i:35768;s:12:\"delete-36528\";i:35769;s:12:\"delete-36531\";i:35770;s:12:\"delete-36532\";i:35771;s:12:\"delete-36529\";i:35772;s:12:\"delete-36530\";i:35773;s:12:\"delete-36533\";i:35774;s:12:\"delete-36534\";i:35775;s:12:\"delete-36537\";i:35776;s:12:\"delete-36538\";i:35777;s:12:\"delete-36535\";i:35778;s:12:\"delete-36536\";i:35779;s:12:\"delete-36539\";i:35780;s:12:\"delete-36540\";i:35781;s:12:\"delete-36543\";i:35782;s:12:\"delete-36544\";i:35783;s:12:\"delete-36541\";i:35784;s:12:\"delete-36542\";i:35785;s:12:\"delete-36545\";i:35786;s:12:\"delete-36546\";i:35787;s:12:\"delete-36547\";i:35788;s:12:\"delete-36548\";i:35789;s:12:\"delete-36549\";i:35790;s:12:\"delete-36550\";i:35791;s:12:\"delete-36551\";i:35792;s:12:\"delete-36552\";i:35793;s:12:\"delete-36555\";i:35794;s:12:\"delete-36556\";i:35795;s:12:\"delete-36553\";i:35796;s:12:\"delete-36554\";i:35797;s:12:\"delete-36557\";i:35798;s:12:\"delete-36558\";i:35799;s:12:\"delete-36561\";i:35800;s:12:\"delete-36562\";i:35801;s:12:\"delete-36559\";i:35802;s:12:\"delete-36560\";i:35803;s:12:\"delete-36563\";i:35804;s:12:\"delete-36564\";i:35805;s:12:\"delete-36567\";i:35806;s:12:\"delete-36565\";i:35807;s:12:\"delete-36566\";i:35808;s:12:\"delete-36568\";i:35809;s:12:\"delete-36569\";i:35810;s:12:\"delete-36570\";i:35811;s:12:\"delete-36573\";i:35812;s:12:\"delete-36574\";i:35813;s:12:\"delete-36571\";i:35814;s:12:\"delete-36572\";i:35815;s:12:\"delete-36575\";i:35816;s:12:\"delete-36576\";i:35817;s:12:\"delete-36579\";i:35818;s:12:\"delete-36580\";i:35819;s:12:\"delete-36577\";i:35820;s:12:\"delete-36578\";i:35821;s:12:\"delete-36581\";i:35822;s:12:\"delete-36582\";i:35823;s:12:\"delete-36585\";i:35824;s:12:\"delete-36583\";i:35825;s:12:\"delete-36584\";i:35826;s:12:\"delete-36586\";i:35827;s:12:\"delete-36587\";i:35828;s:12:\"delete-36588\";i:35829;s:12:\"delete-36591\";i:35830;s:12:\"delete-36592\";i:35831;s:12:\"delete-36589\";i:35832;s:12:\"delete-36590\";i:35833;s:12:\"delete-36593\";i:35834;s:12:\"delete-36594\";i:35835;s:12:\"delete-36597\";i:35836;s:12:\"delete-36598\";i:35837;s:12:\"delete-36595\";i:35838;s:12:\"delete-36596\";i:35839;s:12:\"delete-36599\";i:35840;s:12:\"delete-36600\";i:35841;s:12:\"delete-36601\";i:35842;s:12:\"delete-36602\";i:35843;s:12:\"delete-36603\";i:35844;s:12:\"delete-36604\";i:35845;s:12:\"delete-36605\";i:35846;s:12:\"delete-36606\";i:35847;s:12:\"delete-36609\";i:35848;s:12:\"delete-36607\";i:35849;s:12:\"delete-36608\";i:35850;s:12:\"delete-36610\";i:35851;s:12:\"delete-36611\";i:35852;s:12:\"delete-36612\";i:35853;s:12:\"delete-36615\";i:35854;s:12:\"delete-36613\";i:35855;s:12:\"delete-36614\";i:35856;s:12:\"delete-36616\";i:35857;s:12:\"delete-36617\";i:35858;s:12:\"delete-36618\";i:35859;s:12:\"delete-36621\";i:35860;s:12:\"delete-36619\";i:35861;s:12:\"delete-36620\";i:35862;s:12:\"delete-36622\";i:35863;s:12:\"delete-36623\";i:35864;s:12:\"delete-36624\";i:35865;s:12:\"delete-36627\";i:35866;s:12:\"delete-36628\";i:35867;s:12:\"delete-36625\";i:35868;s:12:\"delete-36626\";i:35869;s:12:\"delete-36629\";i:35870;s:12:\"delete-36630\";i:35871;s:12:\"delete-36631\";i:35872;s:12:\"delete-36632\";i:35873;s:12:\"delete-36633\";i:35874;s:12:\"delete-36634\";i:35875;s:12:\"delete-36635\";i:35876;s:12:\"delete-36636\";i:35877;s:12:\"delete-36639\";i:35878;s:12:\"delete-36640\";i:35879;s:12:\"delete-36637\";i:35880;s:12:\"delete-36638\";i:35881;s:12:\"delete-36641\";i:35882;s:12:\"delete-36642\";i:35883;s:12:\"delete-36643\";i:35884;s:12:\"delete-36644\";i:35885;s:12:\"delete-36645\";i:35886;s:12:\"delete-36646\";i:35887;s:12:\"delete-36647\";i:35888;s:12:\"delete-36648\";i:35889;s:12:\"delete-36649\";i:35890;s:12:\"delete-36650\";i:35891;s:12:\"delete-36651\";i:35892;s:12:\"delete-36652\";i:35893;s:12:\"delete-36653\";i:35894;s:12:\"delete-36656\";i:35895;s:12:\"delete-36654\";i:35896;s:12:\"delete-36655\";i:35897;s:12:\"delete-36657\";i:35898;s:12:\"delete-36658\";i:35899;s:12:\"delete-36659\";i:35900;s:12:\"delete-36662\";i:35901;s:12:\"delete-36663\";i:35902;s:12:\"delete-36660\";i:35903;s:12:\"delete-36661\";i:35904;s:12:\"delete-36664\";i:35905;s:12:\"delete-36665\";i:35906;s:12:\"delete-36668\";i:35907;s:12:\"delete-36666\";i:35908;s:12:\"delete-36667\";i:35909;s:12:\"delete-36669\";i:35910;s:12:\"delete-36670\";i:35911;s:12:\"delete-36671\";i:35912;s:12:\"delete-36674\";i:35913;s:12:\"delete-36675\";i:35914;s:12:\"delete-36672\";i:35915;s:12:\"delete-36673\";i:35916;s:12:\"delete-36676\";i:35917;s:12:\"delete-36677\";i:35918;s:12:\"delete-36680\";i:35919;s:12:\"delete-36681\";i:35920;s:12:\"delete-36678\";i:35921;s:12:\"delete-36679\";i:35922;s:12:\"delete-36682\";i:35923;s:12:\"delete-36683\";i:35924;s:12:\"delete-36686\";i:35925;s:12:\"delete-36687\";i:35926;s:12:\"delete-36684\";i:35927;s:12:\"delete-36685\";i:35928;s:12:\"delete-36688\";i:35929;s:12:\"delete-36689\";i:35930;s:12:\"delete-36692\";i:35931;s:12:\"delete-36693\";i:35932;s:12:\"delete-36690\";i:35933;s:12:\"delete-36691\";i:35934;s:12:\"delete-36694\";i:35935;s:12:\"delete-36695\";i:35936;s:12:\"delete-36696\";i:35937;s:12:\"delete-36697\";i:35938;s:12:\"delete-36698\";i:35939;s:12:\"delete-36699\";i:35940;s:12:\"delete-36700\";i:35941;s:12:\"delete-36701\";i:35942;s:12:\"delete-36704\";i:35943;s:12:\"delete-36705\";i:35944;s:12:\"delete-36702\";i:35945;s:12:\"delete-36703\";i:35946;s:12:\"delete-36706\";i:35947;s:12:\"delete-36707\";i:35948;s:12:\"delete-36710\";i:35949;s:12:\"delete-36711\";i:35950;s:12:\"delete-36708\";i:35951;s:12:\"delete-36709\";i:35952;s:12:\"delete-36712\";i:35953;s:12:\"delete-36713\";i:35954;s:12:\"delete-36716\";i:35955;s:12:\"delete-36717\";i:35956;s:12:\"delete-36714\";i:35957;s:12:\"delete-36715\";i:35958;s:12:\"delete-36718\";i:35959;s:12:\"delete-36719\";i:35960;s:12:\"delete-36722\";i:35961;s:12:\"delete-36723\";i:35962;s:12:\"delete-36720\";i:35963;s:12:\"delete-36721\";i:35964;s:12:\"delete-36724\";i:35965;s:12:\"delete-36725\";i:35966;s:12:\"delete-36728\";i:35967;s:12:\"delete-36726\";i:35968;s:12:\"delete-36727\";i:35969;s:12:\"delete-36729\";i:35970;s:12:\"delete-36730\";i:35971;s:12:\"delete-36731\";i:35972;s:12:\"delete-36734\";i:35973;s:12:\"delete-36732\";i:35974;s:12:\"delete-36733\";i:35975;s:12:\"delete-36735\";i:35976;s:12:\"delete-36736\";i:35977;s:12:\"delete-36737\";i:35978;s:12:\"delete-36738\";i:35979;s:12:\"delete-36739\";i:35980;s:12:\"delete-36740\";i:35981;s:12:\"delete-36741\";i:35982;s:12:\"delete-36742\";i:35983;s:12:\"delete-36743\";i:35984;s:12:\"delete-36746\";i:35985;s:12:\"delete-36747\";i:35986;s:12:\"delete-36744\";i:35987;s:12:\"delete-36745\";i:35988;s:12:\"delete-36748\";i:35989;s:12:\"delete-36749\";i:35990;s:12:\"delete-36752\";i:35991;s:12:\"delete-36753\";i:35992;s:12:\"delete-36750\";i:35993;s:12:\"delete-36751\";i:35994;s:12:\"delete-36754\";i:35995;s:12:\"delete-36755\";i:35996;s:12:\"delete-36758\";i:35997;s:12:\"delete-36759\";i:35998;s:12:\"delete-36756\";i:35999;s:12:\"delete-36757\";i:36000;s:12:\"delete-36760\";i:36001;s:12:\"delete-36761\";i:36002;s:12:\"delete-36764\";i:36003;s:12:\"delete-36762\";i:36004;s:12:\"delete-36763\";i:36005;s:12:\"delete-36765\";i:36006;s:12:\"delete-36766\";i:36007;s:12:\"delete-36767\";i:36008;s:12:\"delete-36770\";i:36009;s:12:\"delete-36768\";i:36010;s:12:\"delete-36769\";i:36011;s:12:\"delete-36771\";i:36012;s:12:\"delete-36772\";i:36013;s:12:\"delete-36773\";i:36014;s:12:\"delete-36774\";i:36015;s:12:\"delete-36775\";i:36016;s:12:\"delete-36776\";i:36017;s:12:\"delete-36777\";i:36018;s:12:\"delete-36778\";i:36019;s:12:\"delete-36779\";i:36020;s:12:\"delete-36782\";i:36021;s:12:\"delete-36780\";i:36022;s:12:\"delete-36781\";i:36023;s:12:\"delete-36783\";i:36024;s:12:\"delete-36784\";i:36025;s:12:\"delete-36785\";i:36026;s:12:\"delete-36788\";i:36027;s:12:\"delete-36789\";i:36028;s:12:\"delete-36786\";i:36029;s:12:\"delete-36787\";i:36030;s:12:\"delete-36790\";i:36031;s:12:\"delete-36791\";i:36032;s:12:\"delete-36794\";i:36033;s:12:\"delete-36795\";i:36034;s:12:\"delete-36792\";i:36035;s:12:\"delete-36793\";i:36036;s:12:\"delete-36796\";i:36037;s:12:\"delete-36797\";i:36038;s:12:\"delete-36800\";i:36039;s:12:\"delete-36798\";i:36040;s:12:\"delete-36799\";i:36041;s:12:\"delete-36801\";i:36042;s:12:\"delete-36802\";i:36043;s:12:\"delete-36803\";i:36044;s:12:\"delete-36806\";i:36045;s:12:\"delete-36804\";i:36046;s:12:\"delete-36805\";i:36047;s:12:\"delete-36807\";i:36048;s:12:\"delete-36808\";i:36049;s:12:\"delete-36809\";i:36050;s:12:\"delete-36812\";i:36051;s:12:\"delete-36813\";i:36052;s:12:\"delete-36810\";i:36053;s:12:\"delete-36811\";i:36054;s:12:\"delete-36814\";i:36055;s:12:\"delete-36815\";i:36056;s:12:\"delete-36818\";i:36057;s:12:\"delete-36819\";i:36058;s:12:\"delete-36816\";i:36059;s:12:\"delete-36817\";i:36060;s:12:\"delete-36820\";i:36061;s:12:\"delete-36821\";i:36062;s:12:\"delete-36822\";i:36063;s:12:\"delete-36823\";i:36064;s:12:\"delete-36824\";i:36065;s:12:\"delete-36825\";i:36066;s:12:\"delete-36826\";i:36067;s:12:\"delete-36827\";i:36068;s:12:\"delete-36830\";i:36069;s:12:\"delete-36828\";i:36070;s:12:\"delete-36829\";i:36071;s:12:\"delete-36831\";i:36072;s:12:\"delete-36832\";i:36073;s:12:\"delete-36833\";i:36074;s:12:\"delete-36836\";i:36075;s:12:\"delete-36837\";i:36076;s:12:\"delete-36834\";i:36077;s:12:\"delete-36835\";i:36078;s:12:\"delete-36838\";i:36079;s:12:\"delete-36839\";i:36080;s:12:\"delete-36842\";i:36081;s:12:\"delete-36843\";i:36082;s:12:\"delete-36840\";i:36083;s:12:\"delete-36841\";i:36084;s:12:\"delete-36844\";i:36085;s:12:\"delete-36845\";i:36086;s:12:\"delete-36848\";i:36087;s:12:\"delete-36849\";i:36088;s:12:\"delete-36846\";i:36089;s:12:\"delete-36847\";i:36090;s:12:\"delete-36850\";i:36091;s:12:\"delete-36851\";i:36092;s:12:\"delete-36854\";i:36093;s:12:\"delete-36855\";i:36094;s:12:\"delete-36852\";i:36095;s:12:\"delete-36853\";i:36096;s:12:\"delete-36856\";i:36097;s:12:\"delete-36857\";i:36098;s:12:\"delete-36860\";i:36099;s:12:\"delete-36858\";i:36100;s:12:\"delete-36859\";i:36101;s:12:\"delete-36861\";i:36102;s:12:\"delete-36862\";i:36103;s:12:\"delete-36863\";i:36104;s:12:\"delete-36866\";i:36105;s:12:\"delete-36867\";i:36106;s:12:\"delete-36864\";i:36107;s:12:\"delete-36865\";i:36108;s:12:\"delete-36868\";i:36109;s:12:\"delete-36869\";i:36110;s:12:\"delete-36872\";i:36111;s:12:\"delete-36870\";i:36112;s:12:\"delete-36871\";i:36113;s:12:\"delete-36873\";i:36114;s:12:\"delete-36874\";i:36115;s:12:\"delete-36875\";i:36116;s:12:\"delete-36878\";i:36117;s:12:\"delete-36879\";i:36118;s:12:\"delete-36876\";i:36119;s:12:\"delete-36877\";i:36120;s:12:\"delete-36880\";i:36121;s:12:\"delete-36881\";i:36122;s:12:\"delete-36884\";i:36123;s:12:\"delete-36885\";i:36124;s:12:\"delete-36882\";i:36125;s:12:\"delete-36883\";i:36126;s:12:\"delete-36886\";i:36127;s:12:\"delete-36887\";i:36128;s:12:\"delete-36890\";i:36129;s:12:\"delete-36888\";i:36130;s:12:\"delete-36889\";i:36131;s:12:\"delete-36891\";i:36132;s:12:\"delete-36892\";i:36133;s:12:\"delete-36893\";i:36134;s:12:\"delete-36896\";i:36135;s:12:\"delete-36897\";i:36136;s:12:\"delete-36894\";i:36137;s:12:\"delete-36895\";i:36138;s:12:\"delete-36898\";i:36139;s:12:\"delete-36899\";i:36140;s:12:\"delete-36902\";i:36141;s:12:\"delete-36903\";i:36142;s:12:\"delete-36900\";i:36143;s:12:\"delete-36901\";i:36144;s:12:\"delete-36904\";i:36145;s:12:\"delete-36905\";i:36146;s:12:\"delete-36906\";i:36147;s:12:\"delete-36907\";i:36148;s:12:\"delete-36908\";i:36149;s:12:\"delete-36909\";i:36150;s:12:\"delete-36910\";i:36151;s:12:\"delete-36911\";i:36152;s:12:\"delete-36912\";i:36153;s:12:\"delete-36913\";i:36154;s:12:\"delete-36914\";i:36155;s:12:\"delete-36915\";i:36156;s:12:\"delete-36916\";i:36157;s:12:\"delete-36917\";i:36158;s:12:\"delete-36920\";i:36159;s:12:\"delete-36921\";i:36160;s:12:\"delete-36918\";i:36161;s:12:\"delete-36919\";i:36162;s:12:\"delete-36922\";i:36163;s:12:\"delete-36923\";i:36164;s:12:\"delete-36924\";i:36165;s:12:\"delete-36925\";i:36166;s:12:\"delete-36926\";i:36167;s:12:\"delete-36927\";i:36168;s:12:\"delete-36928\";i:36169;s:12:\"delete-36929\";i:36170;s:12:\"delete-36932\";i:36171;s:12:\"delete-36930\";i:36172;s:12:\"delete-36931\";i:36173;s:12:\"delete-36933\";i:36174;s:12:\"delete-36934\";i:36175;s:12:\"delete-36935\";i:36176;s:12:\"delete-36938\";i:36177;s:12:\"delete-36939\";i:36178;s:12:\"delete-36936\";i:36179;s:12:\"delete-36937\";i:36180;s:12:\"delete-36940\";i:36181;s:12:\"delete-36941\";i:36182;s:12:\"delete-36944\";i:36183;s:12:\"delete-36945\";i:36184;s:12:\"delete-36942\";i:36185;s:12:\"delete-36943\";i:36186;s:12:\"delete-36946\";i:36187;s:12:\"delete-36947\";i:36188;s:12:\"delete-36950\";i:36189;s:12:\"delete-36951\";i:36190;s:12:\"delete-36948\";i:36191;s:12:\"delete-36949\";i:36192;s:12:\"delete-36952\";i:36193;s:12:\"delete-36953\";i:36194;s:12:\"delete-36956\";i:36195;s:12:\"delete-36954\";i:36196;s:12:\"delete-36955\";i:36197;s:12:\"delete-36957\";i:36198;s:12:\"delete-36958\";i:36199;s:12:\"delete-36959\";i:36200;s:12:\"delete-36960\";i:36201;s:12:\"delete-36961\";i:36202;s:12:\"delete-36962\";i:36203;s:12:\"delete-36963\";i:36204;s:12:\"delete-36964\";i:36205;s:12:\"delete-36965\";i:36206;s:12:\"delete-36968\";i:36207;s:12:\"delete-36969\";i:36208;s:12:\"delete-36966\";i:36209;s:12:\"delete-36967\";i:36210;s:12:\"delete-36970\";i:36211;s:12:\"delete-36971\";i:36212;s:12:\"delete-36974\";i:36213;s:12:\"delete-36975\";i:36214;s:12:\"delete-36972\";i:36215;s:12:\"delete-36973\";i:36216;s:12:\"delete-36976\";i:36217;s:12:\"delete-36977\";i:36218;s:12:\"delete-36980\";i:36219;s:12:\"delete-36978\";i:36220;s:12:\"delete-36979\";i:36221;s:12:\"delete-36981\";i:36222;s:12:\"delete-36982\";i:36223;s:12:\"delete-36983\";i:36224;s:12:\"delete-36986\";i:36225;s:12:\"delete-36987\";i:36226;s:12:\"delete-36984\";i:36227;s:12:\"delete-36985\";i:36228;s:12:\"delete-36988\";i:36229;s:12:\"delete-36989\";i:36230;s:12:\"delete-36992\";i:36231;s:12:\"delete-36993\";i:36232;s:12:\"delete-36990\";i:36233;s:12:\"delete-36991\";i:36234;s:12:\"delete-36994\";i:36235;s:12:\"delete-36995\";i:36236;s:12:\"delete-36998\";i:36237;s:12:\"delete-36999\";i:36238;s:12:\"delete-36996\";i:36239;s:12:\"delete-36997\";i:36240;s:12:\"delete-37000\";i:36241;s:12:\"delete-37001\";i:36242;s:12:\"delete-37004\";i:36243;s:12:\"delete-37002\";i:36244;s:12:\"delete-37003\";i:36245;s:12:\"delete-37005\";i:36246;s:12:\"delete-37006\";i:36247;s:12:\"delete-37007\";i:36248;s:12:\"delete-37010\";i:36249;s:12:\"delete-37011\";i:36250;s:12:\"delete-37008\";i:36251;s:12:\"delete-37009\";i:36252;s:12:\"delete-37012\";i:36253;s:12:\"delete-37013\";i:36254;s:12:\"delete-37016\";i:36255;s:12:\"delete-37017\";i:36256;s:12:\"delete-37014\";i:36257;s:12:\"delete-37015\";i:36258;s:12:\"delete-37018\";i:36259;s:12:\"delete-37019\";i:36260;s:12:\"delete-37020\";i:36261;s:12:\"delete-37021\";i:36262;s:12:\"delete-37022\";i:36263;s:12:\"delete-37023\";i:36264;s:12:\"delete-37024\";i:36265;s:12:\"delete-37025\";i:36266;s:12:\"delete-37028\";i:36267;s:12:\"delete-37029\";i:36268;s:12:\"delete-37026\";i:36269;s:12:\"delete-37027\";i:36270;s:12:\"delete-37030\";i:36271;s:12:\"delete-37031\";i:36272;s:12:\"delete-37034\";i:36273;s:12:\"delete-37035\";i:36274;s:12:\"delete-37032\";i:36275;s:12:\"delete-37033\";i:36276;s:12:\"delete-37036\";i:36277;s:12:\"delete-37037\";i:36278;s:12:\"delete-37040\";i:36279;s:12:\"delete-37041\";i:36280;s:12:\"delete-37038\";i:36281;s:12:\"delete-37039\";i:36282;s:12:\"delete-37042\";i:36283;s:12:\"delete-37043\";i:36284;s:12:\"delete-37046\";i:36285;s:12:\"delete-37047\";i:36286;s:12:\"delete-37044\";i:36287;s:12:\"delete-37045\";i:36288;s:12:\"delete-37048\";i:36289;s:12:\"delete-37049\";i:36290;s:12:\"delete-37052\";i:36291;s:12:\"delete-37053\";i:36292;s:12:\"delete-37050\";i:36293;s:12:\"delete-37051\";i:36294;s:12:\"delete-37054\";i:36295;s:12:\"delete-37055\";i:36296;s:12:\"delete-37056\";i:36297;s:12:\"delete-37057\";i:36298;s:12:\"delete-37058\";i:36299;s:12:\"delete-37059\";i:36300;s:12:\"delete-37060\";i:36301;s:12:\"delete-37061\";i:36302;s:12:\"delete-37064\";i:36303;s:12:\"delete-37065\";i:36304;s:12:\"delete-37062\";i:36305;s:12:\"delete-37063\";i:36306;s:12:\"delete-37066\";i:36307;s:12:\"delete-37067\";i:36308;s:12:\"delete-37070\";i:36309;s:12:\"delete-37071\";i:36310;s:12:\"delete-37068\";i:36311;s:12:\"delete-37069\";i:36312;s:12:\"delete-37072\";i:36313;s:12:\"delete-37073\";i:36314;s:12:\"delete-37076\";i:36315;s:12:\"delete-37074\";i:36316;s:12:\"delete-37075\";i:36317;s:12:\"delete-37077\";i:36318;s:12:\"delete-37078\";i:36319;s:12:\"delete-37079\";i:36320;s:12:\"delete-37082\";i:36321;s:12:\"delete-37083\";i:36322;s:12:\"delete-37080\";i:36323;s:12:\"delete-37081\";i:36324;s:12:\"delete-37084\";i:36325;s:12:\"delete-37085\";i:36326;s:12:\"delete-37088\";i:36327;s:12:\"delete-37089\";i:36328;s:12:\"delete-37086\";i:36329;s:12:\"delete-37087\";i:36330;s:12:\"delete-37090\";i:36331;s:12:\"delete-37091\";i:36332;s:12:\"delete-37094\";i:36333;s:12:\"delete-37095\";i:36334;s:12:\"delete-37092\";i:36335;s:12:\"delete-37093\";i:36336;s:12:\"delete-37096\";i:36337;s:12:\"delete-37097\";i:36338;s:12:\"delete-37100\";i:36339;s:12:\"delete-37101\";i:36340;s:12:\"delete-37102\";i:36341;s:12:\"delete-37103\";i:36342;s:12:\"delete-37098\";i:36343;s:12:\"delete-37099\";i:36344;s:12:\"delete-37104\";i:36345;s:12:\"delete-37105\";i:36346;s:12:\"delete-37106\";i:36347;s:12:\"delete-37107\";i:36348;s:12:\"delete-37108\";i:36349;s:12:\"delete-37109\";i:36350;s:12:\"delete-37112\";i:36351;s:12:\"delete-37113\";i:36352;s:12:\"delete-37110\";i:36353;s:12:\"delete-37111\";i:36354;s:12:\"delete-37114\";i:36355;s:12:\"delete-37115\";i:36356;s:12:\"delete-37118\";i:36357;s:12:\"delete-37119\";i:36358;s:12:\"delete-37116\";i:36359;s:12:\"delete-37117\";i:36360;s:12:\"delete-37120\";i:36361;s:12:\"delete-37121\";i:36362;s:12:\"delete-37122\";i:36363;s:12:\"delete-37123\";i:36364;s:12:\"delete-37124\";i:36365;s:12:\"delete-37125\";i:36366;s:12:\"delete-37126\";i:36367;s:12:\"delete-37127\";i:36368;s:12:\"delete-37130\";i:36369;s:12:\"delete-37128\";i:36370;s:12:\"delete-37129\";i:36371;s:12:\"delete-37131\";i:36372;s:12:\"delete-37132\";i:36373;s:12:\"delete-37133\";i:36374;s:12:\"delete-37136\";i:36375;s:12:\"delete-37137\";i:36376;s:12:\"delete-37134\";i:36377;s:12:\"delete-37135\";i:36378;s:12:\"delete-37138\";i:36379;s:12:\"delete-37139\";i:36380;s:12:\"delete-37142\";i:36381;s:12:\"delete-37143\";i:36382;s:12:\"delete-37140\";i:36383;s:12:\"delete-37141\";i:36384;s:12:\"delete-37144\";i:36385;s:12:\"delete-37145\";i:36386;s:12:\"delete-37148\";i:36387;s:12:\"delete-37149\";i:36388;s:12:\"delete-37146\";i:36389;s:12:\"delete-37147\";i:36390;s:12:\"delete-37150\";i:36391;s:12:\"delete-37151\";i:36392;s:12:\"delete-37154\";i:36393;s:12:\"delete-37152\";i:36394;s:12:\"delete-37153\";i:36395;s:12:\"delete-37155\";i:36396;s:12:\"delete-37156\";i:36397;s:12:\"delete-37157\";i:36398;s:12:\"delete-37160\";i:36399;s:12:\"delete-37161\";i:36400;s:12:\"delete-37158\";i:36401;s:12:\"delete-37159\";i:36402;s:12:\"delete-37162\";i:36403;s:12:\"delete-37163\";i:36404;s:12:\"delete-37166\";i:36405;s:12:\"delete-37164\";i:36406;s:12:\"delete-37165\";i:36407;s:12:\"delete-37167\";i:36408;s:12:\"delete-37168\";i:36409;s:12:\"delete-37169\";i:36410;s:12:\"delete-37172\";i:36411;s:12:\"delete-37173\";i:36412;s:12:\"delete-37170\";i:36413;s:12:\"delete-37171\";i:36414;s:12:\"delete-37174\";i:36415;s:12:\"delete-37175\";i:36416;s:12:\"delete-37178\";i:36417;s:12:\"delete-37176\";i:36418;s:12:\"delete-37177\";i:36419;s:12:\"delete-37179\";i:36420;s:12:\"delete-37180\";i:36421;s:12:\"delete-37181\";i:36422;s:12:\"delete-37184\";i:36423;s:12:\"delete-37185\";i:36424;s:12:\"delete-37182\";i:36425;s:12:\"delete-37183\";i:36426;s:12:\"delete-37186\";i:36427;s:12:\"delete-37187\";i:36428;s:12:\"delete-37190\";i:36429;s:12:\"delete-37191\";i:36430;s:12:\"delete-37188\";i:36431;s:12:\"delete-37189\";i:36432;s:12:\"delete-37192\";i:36433;s:12:\"delete-37193\";i:36434;s:12:\"delete-37194\";i:36435;s:12:\"delete-37195\";i:36436;s:12:\"delete-37196\";i:36437;s:12:\"delete-37197\";i:36438;s:12:\"delete-37198\";i:36439;s:12:\"delete-37199\";i:36440;s:12:\"delete-37200\";i:36441;s:12:\"delete-37201\";i:36442;s:12:\"delete-37202\";i:36443;s:12:\"delete-37203\";i:36444;s:12:\"delete-37204\";i:36445;s:12:\"delete-37205\";i:36446;s:12:\"delete-37206\";i:36447;s:12:\"delete-37207\";i:36448;s:12:\"delete-37208\";i:36449;s:12:\"delete-37209\";i:36450;s:12:\"delete-37210\";i:36451;s:12:\"delete-37211\";i:36452;s:12:\"delete-37214\";i:36453;s:12:\"delete-37215\";i:36454;s:12:\"delete-37212\";i:36455;s:12:\"delete-37213\";i:36456;s:12:\"delete-37216\";i:36457;s:12:\"delete-37217\";i:36458;s:12:\"delete-37220\";i:36459;s:12:\"delete-37221\";i:36460;s:12:\"delete-37218\";i:36461;s:12:\"delete-37219\";i:36462;s:12:\"delete-37222\";i:36463;s:12:\"delete-37223\";i:36464;s:12:\"delete-37224\";i:36465;s:12:\"delete-37225\";i:36466;s:12:\"delete-37226\";i:36467;s:12:\"delete-37227\";i:36468;s:12:\"delete-37228\";i:36469;s:12:\"delete-37229\";i:36470;s:12:\"delete-37232\";i:36471;s:12:\"delete-37233\";i:36472;s:12:\"delete-37230\";i:36473;s:12:\"delete-37231\";i:36474;s:12:\"delete-37234\";i:36475;s:12:\"delete-37235\";i:36476;s:12:\"delete-37236\";i:36477;s:12:\"delete-37237\";i:36478;s:12:\"delete-37238\";i:36479;s:12:\"delete-37239\";i:36480;s:12:\"delete-37240\";i:36481;s:12:\"delete-37241\";i:36482;s:12:\"delete-37244\";i:36483;s:12:\"delete-37245\";i:36484;s:12:\"delete-37242\";i:36485;s:12:\"delete-37243\";i:36486;s:12:\"delete-37246\";i:36487;s:12:\"delete-37247\";i:36488;s:12:\"delete-37250\";i:36489;s:12:\"delete-37248\";i:36490;s:12:\"delete-37249\";i:36491;s:12:\"delete-37251\";i:36492;s:12:\"delete-37252\";i:36493;s:12:\"delete-37253\";i:36494;s:12:\"delete-37256\";i:36495;s:12:\"delete-37257\";i:36496;s:12:\"delete-37254\";i:36497;s:12:\"delete-37255\";i:36498;s:12:\"delete-37258\";i:36499;s:12:\"delete-37259\";i:36500;s:12:\"delete-37260\";i:36501;s:12:\"delete-37261\";i:36502;s:12:\"delete-37262\";i:36503;s:12:\"delete-37263\";i:36504;s:12:\"delete-37264\";i:36505;s:12:\"delete-37265\";i:36506;s:12:\"delete-37268\";i:36507;s:12:\"delete-37266\";i:36508;s:12:\"delete-37267\";i:36509;s:12:\"delete-37269\";i:36510;s:12:\"delete-37270\";i:36511;s:12:\"delete-37271\";i:36512;s:12:\"delete-37274\";i:36513;s:12:\"delete-37275\";i:36514;s:12:\"delete-37272\";i:36515;s:12:\"delete-37273\";i:36516;s:12:\"delete-37276\";i:36517;s:12:\"delete-37277\";i:36518;s:12:\"delete-37280\";i:36519;s:12:\"delete-37278\";i:36520;s:12:\"delete-37279\";i:36521;s:12:\"delete-37281\";i:36522;s:12:\"delete-37282\";i:36523;s:12:\"delete-37283\";i:36524;s:12:\"delete-37286\";i:36525;s:12:\"delete-37284\";i:36526;s:12:\"delete-37285\";i:36527;s:12:\"delete-37287\";i:36528;s:12:\"delete-37288\";i:36529;s:12:\"delete-37289\";i:36530;s:12:\"delete-37292\";i:36531;s:12:\"delete-37293\";i:36532;s:12:\"delete-37290\";i:36533;s:12:\"delete-37291\";i:36534;s:12:\"delete-37294\";i:36535;s:12:\"delete-37295\";i:36536;s:12:\"delete-37298\";i:36537;s:12:\"delete-37296\";i:36538;s:12:\"delete-37297\";i:36539;s:12:\"delete-37299\";i:36540;s:12:\"delete-37300\";i:36541;s:12:\"delete-37301\";i:36542;s:12:\"delete-37304\";i:36543;s:12:\"delete-37305\";i:36544;s:12:\"delete-37302\";i:36545;s:12:\"delete-37303\";i:36546;s:12:\"delete-37306\";i:36547;s:12:\"delete-37307\";i:36548;s:12:\"delete-37310\";i:36549;s:12:\"delete-37311\";i:36550;s:12:\"delete-37308\";i:36551;s:12:\"delete-37309\";i:36552;s:12:\"delete-37312\";i:36553;s:12:\"delete-37313\";i:36554;s:12:\"delete-37316\";i:36555;s:12:\"delete-37314\";i:36556;s:12:\"delete-37315\";i:36557;s:12:\"delete-37317\";i:36558;s:12:\"delete-37318\";i:36559;s:12:\"delete-37319\";i:36560;s:12:\"delete-37322\";i:36561;s:12:\"delete-37323\";i:36562;s:12:\"delete-37320\";i:36563;s:12:\"delete-37321\";i:36564;s:12:\"delete-37324\";i:36565;s:12:\"delete-37325\";i:36566;s:12:\"delete-37328\";i:36567;s:12:\"delete-37329\";i:36568;s:12:\"delete-37326\";i:36569;s:12:\"delete-37327\";i:36570;s:12:\"delete-37330\";i:36571;s:12:\"delete-37331\";i:36572;s:12:\"delete-37334\";i:36573;s:12:\"delete-37335\";i:36574;s:12:\"delete-37332\";i:36575;s:12:\"delete-37333\";i:36576;s:12:\"delete-37336\";i:36577;s:12:\"delete-37337\";i:36578;s:12:\"delete-37340\";i:36579;s:12:\"delete-37341\";i:36580;s:12:\"delete-37338\";i:36581;s:12:\"delete-37339\";i:36582;s:12:\"delete-37342\";i:36583;s:12:\"delete-37343\";i:36584;s:12:\"delete-37346\";i:36585;s:12:\"delete-37344\";i:36586;s:12:\"delete-37345\";i:36587;s:12:\"delete-37347\";i:36588;s:12:\"delete-37348\";i:36589;s:12:\"delete-37349\";i:36590;s:12:\"delete-37350\";i:36591;s:12:\"delete-37351\";i:36592;s:12:\"delete-37352\";i:36593;s:12:\"delete-37353\";i:36594;s:12:\"delete-37354\";i:36595;s:12:\"delete-37355\";i:36596;s:12:\"delete-37358\";i:36597;s:12:\"delete-37359\";i:36598;s:12:\"delete-37356\";i:36599;s:12:\"delete-37357\";i:36600;s:12:\"delete-37360\";i:36601;s:12:\"delete-37361\";i:36602;s:12:\"delete-37362\";i:36603;s:12:\"delete-37363\";i:36604;s:12:\"delete-37364\";i:36605;s:12:\"delete-37365\";i:36606;s:12:\"delete-37366\";i:36607;s:12:\"delete-37367\";i:36608;s:12:\"delete-37370\";i:36609;s:12:\"delete-37368\";i:36610;s:12:\"delete-37369\";i:36611;s:12:\"delete-37371\";i:36612;s:12:\"delete-37372\";i:36613;s:12:\"delete-37373\";i:36614;s:12:\"delete-37376\";i:36615;s:12:\"delete-37374\";i:36616;s:12:\"delete-37375\";i:36617;s:12:\"delete-37377\";i:36618;s:12:\"delete-37378\";i:36619;s:12:\"delete-37379\";i:36620;s:12:\"delete-37382\";i:36621;s:12:\"delete-37383\";i:36622;s:12:\"delete-37380\";i:36623;s:12:\"delete-37381\";i:36624;s:12:\"delete-37384\";i:36625;s:12:\"delete-37385\";i:36626;s:12:\"delete-37388\";i:36627;s:12:\"delete-37389\";i:36628;s:12:\"delete-37386\";i:36629;s:12:\"delete-37387\";i:36630;s:12:\"delete-37390\";i:36631;s:12:\"delete-37391\";i:36632;s:12:\"delete-37394\";i:36633;s:12:\"delete-37395\";i:36634;s:12:\"delete-37392\";i:36635;s:12:\"delete-37393\";i:36636;s:12:\"delete-37396\";i:36637;s:12:\"delete-37397\";i:36638;s:12:\"delete-37400\";i:36639;s:12:\"delete-37401\";i:36640;s:12:\"delete-37398\";i:36641;s:12:\"delete-37399\";i:36642;s:12:\"delete-37402\";i:36643;s:12:\"delete-37403\";i:36644;s:12:\"delete-37406\";i:36645;s:12:\"delete-37407\";i:36646;s:12:\"delete-37404\";i:36647;s:12:\"delete-37405\";i:36648;s:12:\"delete-37408\";i:36649;s:12:\"delete-37409\";i:36650;s:12:\"delete-37412\";i:36651;s:12:\"delete-37413\";i:36652;s:12:\"delete-37410\";i:36653;s:12:\"delete-37411\";i:36654;s:12:\"delete-37414\";i:36655;s:12:\"delete-37415\";i:36656;s:12:\"delete-37418\";i:36657;s:12:\"delete-37416\";i:36658;s:12:\"delete-37417\";i:36659;s:12:\"delete-37419\";i:36660;s:12:\"delete-37420\";i:36661;s:12:\"delete-37421\";i:36662;s:12:\"delete-37424\";i:36663;s:12:\"delete-37425\";i:36664;s:12:\"delete-37422\";i:36665;s:12:\"delete-37423\";i:36666;s:12:\"delete-37426\";i:36667;s:12:\"delete-37427\";i:36668;s:12:\"delete-37430\";i:36669;s:12:\"delete-37428\";i:36670;s:12:\"delete-37429\";i:36671;s:12:\"delete-37431\";i:36672;s:12:\"delete-37432\";i:36673;s:12:\"delete-37433\";i:36674;s:12:\"delete-37436\";i:36675;s:12:\"delete-37437\";i:36676;s:12:\"delete-37434\";i:36677;s:12:\"delete-37435\";i:36678;s:12:\"delete-37438\";i:36679;s:12:\"delete-37439\";i:36680;s:12:\"delete-37442\";i:36681;s:12:\"delete-37443\";i:36682;s:12:\"delete-37440\";i:36683;s:12:\"delete-37441\";i:36684;s:12:\"delete-37444\";i:36685;s:12:\"delete-37445\";i:36686;s:12:\"delete-37446\";i:36687;s:12:\"delete-37447\";i:36688;s:12:\"delete-37448\";i:36689;s:12:\"delete-37449\";i:36690;s:12:\"delete-37450\";i:36691;s:12:\"delete-37451\";i:36692;s:12:\"delete-37454\";i:36693;s:12:\"delete-37452\";i:36694;s:12:\"delete-37453\";i:36695;s:12:\"delete-37455\";i:36696;s:12:\"delete-37456\";i:36697;s:12:\"delete-37457\";i:36698;s:12:\"delete-37460\";i:36699;s:12:\"delete-37461\";i:36700;s:12:\"delete-37458\";i:36701;s:12:\"delete-37459\";i:36702;s:12:\"delete-37462\";i:36703;s:12:\"delete-37463\";i:36704;s:12:\"delete-37466\";i:36705;s:12:\"delete-37467\";i:36706;s:12:\"delete-37464\";i:36707;s:12:\"delete-37465\";i:36708;s:12:\"delete-37468\";i:36709;s:12:\"delete-37469\";i:36710;s:12:\"delete-37472\";i:36711;s:12:\"delete-37473\";i:36712;s:12:\"delete-37470\";i:36713;s:12:\"delete-37471\";i:36714;s:12:\"delete-37474\";i:36715;s:12:\"delete-37475\";i:36716;s:12:\"delete-37478\";i:36717;s:12:\"delete-37479\";i:36718;s:12:\"delete-37476\";i:36719;s:12:\"delete-37477\";i:36720;s:12:\"delete-37480\";i:36721;s:12:\"delete-37481\";i:36722;s:12:\"delete-37484\";i:36723;s:12:\"delete-37485\";i:36724;s:12:\"delete-37482\";i:36725;s:12:\"delete-37483\";i:36726;s:12:\"delete-37486\";i:36727;s:12:\"delete-37487\";i:36728;s:12:\"delete-37490\";i:36729;s:12:\"delete-37488\";i:36730;s:12:\"delete-37489\";i:36731;s:12:\"delete-37491\";i:36732;s:12:\"delete-37492\";i:36733;s:12:\"delete-37493\";i:36734;s:12:\"delete-37496\";i:36735;s:12:\"delete-37497\";i:36736;s:12:\"delete-37494\";i:36737;s:12:\"delete-37495\";i:36738;s:12:\"delete-37498\";i:36739;s:12:\"delete-37499\";i:36740;s:12:\"delete-37502\";i:36741;s:12:\"delete-37503\";i:36742;s:12:\"delete-37500\";i:36743;s:12:\"delete-37501\";i:36744;s:12:\"delete-37504\";i:36745;s:12:\"delete-37505\";i:36746;s:12:\"delete-37508\";i:36747;s:12:\"delete-37509\";i:36748;s:12:\"delete-37506\";i:36749;s:12:\"delete-37507\";i:36750;s:12:\"delete-37510\";i:36751;s:12:\"delete-37511\";i:36752;s:12:\"delete-37514\";i:36753;s:12:\"delete-37515\";i:36754;s:12:\"delete-37512\";i:36755;s:12:\"delete-37513\";i:36756;s:12:\"delete-37516\";i:36757;s:12:\"delete-37517\";i:36758;s:12:\"delete-37520\";i:36759;s:12:\"delete-37521\";i:36760;s:12:\"delete-37518\";i:36761;s:12:\"delete-37519\";i:36762;s:12:\"delete-37522\";i:36763;s:12:\"delete-37523\";i:36764;s:12:\"delete-37526\";i:36765;s:12:\"delete-37524\";i:36766;s:12:\"delete-37525\";i:36767;s:12:\"delete-37527\";i:36768;s:12:\"delete-37528\";i:36769;s:12:\"delete-37529\";i:36770;s:12:\"delete-37532\";i:36771;s:12:\"delete-37533\";i:36772;s:12:\"delete-37530\";i:36773;s:12:\"delete-37531\";i:36774;s:12:\"delete-37534\";i:36775;s:12:\"delete-37535\";i:36776;s:12:\"delete-37538\";i:36777;s:12:\"delete-37539\";i:36778;s:12:\"delete-37536\";i:36779;s:12:\"delete-37537\";i:36780;s:12:\"delete-37540\";i:36781;s:12:\"delete-37541\";i:36782;s:12:\"delete-37544\";i:36783;s:12:\"delete-37542\";i:36784;s:12:\"delete-37543\";i:36785;s:12:\"delete-37545\";i:36786;s:12:\"delete-37546\";i:36787;s:12:\"delete-37547\";i:36788;s:12:\"delete-37550\";i:36789;s:12:\"delete-37548\";i:36790;s:12:\"delete-37549\";i:36791;s:12:\"delete-37551\";i:36792;s:12:\"delete-37552\";i:36793;s:12:\"delete-37553\";i:36794;s:12:\"delete-37556\";i:36795;s:12:\"delete-37557\";i:36796;s:12:\"delete-37554\";i:36797;s:12:\"delete-37555\";i:36798;s:12:\"delete-37558\";i:36799;s:12:\"delete-37559\";i:36800;s:12:\"delete-37562\";i:36801;s:12:\"delete-37560\";i:36802;s:12:\"delete-37561\";i:36803;s:12:\"delete-37563\";i:36804;s:12:\"delete-37564\";i:36805;s:12:\"delete-37565\";i:36806;s:12:\"delete-37568\";i:36807;s:12:\"delete-37569\";i:36808;s:12:\"delete-37566\";i:36809;s:12:\"delete-37567\";i:36810;s:12:\"delete-37570\";i:36811;s:12:\"delete-37571\";i:36812;s:12:\"delete-37574\";i:36813;s:12:\"delete-37572\";i:36814;s:12:\"delete-37573\";i:36815;s:12:\"delete-37575\";i:36816;s:12:\"delete-37576\";i:36817;s:12:\"delete-37577\";i:36818;s:12:\"delete-37580\";i:36819;s:12:\"delete-37581\";i:36820;s:12:\"delete-37578\";i:36821;s:12:\"delete-37579\";i:36822;s:12:\"delete-37582\";i:36823;s:12:\"delete-37583\";i:36824;s:12:\"delete-37586\";i:36825;s:12:\"delete-37584\";i:36826;s:12:\"delete-37585\";i:36827;s:12:\"delete-37587\";i:36828;s:12:\"delete-37588\";i:36829;s:12:\"delete-37589\";i:36830;s:12:\"delete-37592\";i:36831;s:12:\"delete-37590\";i:36832;s:12:\"delete-37591\";i:36833;s:12:\"delete-37593\";i:36834;s:12:\"delete-37594\";i:36835;s:12:\"delete-37595\";i:36836;s:12:\"delete-37598\";i:36837;s:12:\"delete-37596\";i:36838;s:12:\"delete-37597\";i:36839;s:12:\"delete-37599\";i:36840;s:12:\"delete-37600\";i:36841;s:12:\"delete-37601\";i:36842;s:12:\"delete-37604\";i:36843;s:12:\"delete-37602\";i:36844;s:12:\"delete-37603\";i:36845;s:12:\"delete-37605\";i:36846;s:12:\"delete-37606\";i:36847;s:12:\"delete-37607\";i:36848;s:12:\"delete-37610\";i:36849;s:12:\"delete-37611\";i:36850;s:12:\"delete-37608\";i:36851;s:12:\"delete-37609\";i:36852;s:12:\"delete-37612\";i:36853;s:12:\"delete-37613\";i:36854;s:12:\"delete-37616\";i:36855;s:12:\"delete-37617\";i:36856;s:12:\"delete-37614\";i:36857;s:12:\"delete-37615\";i:36858;s:12:\"delete-37618\";i:36859;s:12:\"delete-37619\";i:36860;s:12:\"delete-37622\";i:36861;s:12:\"delete-37623\";i:36862;s:12:\"delete-37620\";i:36863;s:12:\"delete-37621\";i:36864;s:12:\"delete-37624\";i:36865;s:12:\"delete-37625\";i:36866;s:12:\"delete-37628\";i:36867;s:12:\"delete-37626\";i:36868;s:12:\"delete-37627\";i:36869;s:12:\"delete-37629\";i:36870;s:12:\"delete-37630\";i:36871;s:12:\"delete-37631\";i:36872;s:12:\"delete-37634\";i:36873;s:12:\"delete-37635\";i:36874;s:12:\"delete-37632\";i:36875;s:12:\"delete-37633\";i:36876;s:12:\"delete-37636\";i:36877;s:12:\"delete-37637\";i:36878;s:12:\"delete-37640\";i:36879;s:12:\"delete-37641\";i:36880;s:12:\"delete-37638\";i:36881;s:12:\"delete-37639\";i:36882;s:12:\"delete-37642\";i:36883;s:12:\"delete-37643\";i:36884;s:12:\"delete-37646\";i:36885;s:12:\"delete-37647\";i:36886;s:12:\"delete-37644\";i:36887;s:12:\"delete-37645\";i:36888;s:12:\"delete-37648\";i:36889;s:12:\"delete-37649\";i:36890;s:12:\"delete-37652\";i:36891;s:12:\"delete-37653\";i:36892;s:12:\"delete-37650\";i:36893;s:12:\"delete-37651\";i:36894;s:12:\"delete-37654\";i:36895;s:12:\"delete-37655\";i:36896;s:12:\"delete-37658\";i:36897;s:12:\"delete-37659\";i:36898;s:12:\"delete-37656\";i:36899;s:12:\"delete-37657\";i:36900;s:12:\"delete-37660\";i:36901;s:12:\"delete-37661\";i:36902;s:12:\"delete-37664\";i:36903;s:12:\"delete-37665\";i:36904;s:12:\"delete-37662\";i:36905;s:12:\"delete-37663\";i:36906;s:12:\"delete-37666\";i:36907;s:12:\"delete-37667\";i:36908;s:12:\"delete-37670\";i:36909;s:12:\"delete-37671\";i:36910;s:12:\"delete-37668\";i:36911;s:12:\"delete-37669\";i:36912;s:12:\"delete-37672\";i:36913;s:12:\"delete-37673\";i:36914;s:12:\"delete-37676\";i:36915;s:12:\"delete-37677\";i:36916;s:12:\"delete-37674\";i:36917;s:12:\"delete-37675\";i:36918;s:12:\"delete-37678\";i:36919;s:12:\"delete-37679\";i:36920;s:12:\"delete-37682\";i:36921;s:12:\"delete-37683\";i:36922;s:12:\"delete-37680\";i:36923;s:12:\"delete-37681\";i:36924;s:12:\"delete-37684\";i:36925;s:12:\"delete-37685\";i:36926;s:12:\"delete-37688\";i:36927;s:12:\"delete-37686\";i:36928;s:12:\"delete-37687\";i:36929;s:12:\"delete-37689\";i:36930;s:12:\"delete-37690\";i:36931;s:12:\"delete-37692\";i:36932;s:12:\"delete-37693\";i:36933;s:12:\"delete-37691\";i:36934;s:12:\"delete-37694\";i:36935;s:12:\"delete-37695\";i:36936;s:12:\"delete-37696\";i:36937;s:12:\"delete-37697\";i:36938;s:12:\"delete-37700\";i:36939;s:12:\"delete-37698\";i:36940;s:12:\"delete-37699\";i:36941;s:12:\"delete-37701\";i:36942;s:12:\"delete-37702\";i:36943;s:12:\"delete-37703\";i:36944;s:12:\"delete-37706\";i:36945;s:12:\"delete-37707\";i:36946;s:12:\"delete-37704\";i:36947;s:12:\"delete-37705\";i:36948;s:12:\"delete-37708\";i:36949;s:12:\"delete-37709\";i:36950;s:12:\"delete-37712\";i:36951;s:12:\"delete-37713\";i:36952;s:12:\"delete-37710\";i:36953;s:12:\"delete-37711\";i:36954;s:12:\"delete-37714\";i:36955;s:12:\"delete-37715\";i:36956;s:12:\"delete-37716\";i:36957;s:12:\"delete-37717\";i:36958;s:12:\"delete-37718\";i:36959;s:12:\"delete-37719\";i:36960;s:12:\"delete-37720\";i:36961;s:12:\"delete-37721\";i:36962;s:12:\"delete-37724\";i:36963;s:12:\"delete-37725\";i:36964;s:12:\"delete-37722\";i:36965;s:12:\"delete-37723\";i:36966;s:12:\"delete-37726\";i:36967;s:12:\"delete-37727\";i:36968;s:12:\"delete-37730\";i:36969;s:12:\"delete-37731\";i:36970;s:12:\"delete-37728\";i:36971;s:12:\"delete-37729\";i:36972;s:12:\"delete-37732\";i:36973;s:12:\"delete-37733\";i:36974;s:12:\"delete-37736\";i:36975;s:12:\"delete-37734\";i:36976;s:12:\"delete-37735\";i:36977;s:12:\"delete-37737\";i:36978;s:12:\"delete-37738\";i:36979;s:12:\"delete-37739\";i:36980;s:12:\"delete-37742\";i:36981;s:12:\"delete-37743\";i:36982;s:12:\"delete-37740\";i:36983;s:12:\"delete-37741\";i:36984;s:12:\"delete-37744\";i:36985;s:12:\"delete-37745\";i:36986;s:12:\"delete-37748\";i:36987;s:12:\"delete-37749\";i:36988;s:12:\"delete-37746\";i:36989;s:12:\"delete-37747\";i:36990;s:12:\"delete-37750\";i:36991;s:12:\"delete-37751\";i:36992;s:12:\"delete-37754\";i:36993;s:12:\"delete-37755\";i:36994;s:12:\"delete-37752\";i:36995;s:12:\"delete-37753\";i:36996;s:12:\"delete-37756\";i:36997;s:12:\"delete-37757\";i:36998;s:12:\"delete-37758\";i:36999;s:12:\"delete-37759\";i:37000;s:12:\"delete-37760\";i:37001;s:12:\"delete-37761\";i:37002;s:12:\"delete-37762\";i:37003;s:12:\"delete-37763\";i:37004;s:12:\"delete-37766\";i:37005;s:12:\"delete-37767\";i:37006;s:12:\"delete-37764\";i:37007;s:12:\"delete-37765\";i:37008;s:12:\"delete-37768\";i:37009;s:12:\"delete-37769\";i:37010;s:12:\"delete-37772\";i:37011;s:12:\"delete-37773\";i:37012;s:12:\"delete-37770\";i:37013;s:12:\"delete-37771\";i:37014;s:12:\"delete-37774\";i:37015;s:12:\"delete-37775\";i:37016;s:12:\"delete-37778\";i:37017;s:12:\"delete-37776\";i:37018;s:12:\"delete-37777\";i:37019;s:12:\"delete-37779\";i:37020;s:12:\"delete-37780\";i:37021;s:12:\"delete-37781\";i:37022;s:12:\"delete-37784\";i:37023;s:12:\"delete-37782\";i:37024;s:12:\"delete-37783\";i:37025;s:12:\"delete-37785\";i:37026;s:12:\"delete-37786\";i:37027;s:12:\"delete-37787\";i:37028;s:12:\"delete-37790\";i:37029;s:12:\"delete-37788\";i:37030;s:12:\"delete-37789\";i:37031;s:12:\"delete-37791\";i:37032;s:12:\"delete-37792\";i:37033;s:12:\"delete-37793\";i:37034;s:12:\"delete-37796\";i:37035;s:12:\"delete-37794\";i:37036;s:12:\"delete-37795\";i:37037;s:12:\"delete-37797\";i:37038;s:12:\"delete-37798\";i:37039;s:12:\"delete-37799\";i:37040;s:12:\"delete-37802\";i:37041;s:12:\"delete-37800\";i:37042;s:12:\"delete-37801\";i:37043;s:12:\"delete-37803\";i:37044;s:12:\"delete-37804\";i:37045;s:12:\"delete-37805\";i:37046;s:12:\"delete-37808\";i:37047;s:12:\"delete-37809\";i:37048;s:12:\"delete-37806\";i:37049;s:12:\"delete-37807\";i:37050;s:12:\"delete-37810\";i:37051;s:12:\"delete-37811\";i:37052;s:12:\"delete-37814\";i:37053;s:12:\"delete-37812\";i:37054;s:12:\"delete-37813\";i:37055;s:12:\"delete-37815\";i:37056;s:12:\"delete-37816\";i:37057;s:12:\"delete-37817\";i:37058;s:12:\"delete-37820\";i:37059;s:12:\"delete-37821\";i:37060;s:12:\"delete-37818\";i:37061;s:12:\"delete-37819\";i:37062;s:12:\"delete-37822\";i:37063;s:12:\"delete-37823\";i:37064;s:12:\"delete-37826\";i:37065;s:12:\"delete-37827\";i:37066;s:12:\"delete-37824\";i:37067;s:12:\"delete-37825\";i:37068;s:12:\"delete-37828\";i:37069;s:12:\"delete-37829\";i:37070;s:12:\"delete-37830\";i:37071;s:12:\"delete-37831\";i:37072;s:12:\"delete-37832\";i:37073;s:12:\"delete-37833\";i:37074;s:12:\"delete-37834\";i:37075;s:12:\"delete-37835\";i:37076;s:12:\"delete-37838\";i:37077;s:12:\"delete-37839\";i:37078;s:12:\"delete-37836\";i:37079;s:12:\"delete-37837\";i:37080;s:12:\"delete-37840\";i:37081;s:12:\"delete-37841\";i:37082;s:12:\"delete-37844\";i:37083;s:12:\"delete-37845\";i:37084;s:12:\"delete-37842\";i:37085;s:12:\"delete-37843\";i:37086;s:12:\"delete-37846\";i:37087;s:12:\"delete-37847\";i:37088;s:12:\"delete-37850\";i:37089;s:12:\"delete-37851\";i:37090;s:12:\"delete-37848\";i:37091;s:12:\"delete-37849\";i:37092;s:12:\"delete-37852\";i:37093;s:12:\"delete-37853\";i:37094;s:12:\"delete-37856\";i:37095;s:12:\"delete-37857\";i:37096;s:12:\"delete-37854\";i:37097;s:12:\"delete-37855\";i:37098;s:12:\"delete-37858\";i:37099;s:12:\"delete-37859\";i:37100;s:12:\"delete-37862\";i:37101;s:12:\"delete-37860\";i:37102;s:12:\"delete-37861\";i:37103;s:12:\"delete-37863\";i:37104;s:12:\"delete-37864\";i:37105;s:12:\"delete-37865\";i:37106;s:12:\"delete-37868\";i:37107;s:12:\"delete-37866\";i:37108;s:12:\"delete-37867\";i:37109;s:12:\"delete-37869\";i:37110;s:12:\"delete-37870\";i:37111;s:12:\"delete-37871\";i:37112;s:12:\"delete-37874\";i:37113;s:12:\"delete-37872\";i:37114;s:12:\"delete-37873\";i:37115;s:12:\"delete-37875\";i:37116;s:12:\"delete-37876\";i:37117;s:12:\"delete-37877\";i:37118;s:12:\"delete-37878\";i:37119;s:12:\"delete-37879\";i:37120;s:12:\"delete-37880\";i:37121;s:12:\"delete-37881\";i:37122;s:12:\"delete-37882\";i:37123;s:12:\"delete-37883\";i:37124;s:12:\"delete-37886\";i:37125;s:12:\"delete-37887\";i:37126;s:12:\"delete-37884\";i:37127;s:12:\"delete-37885\";i:37128;s:12:\"delete-37888\";i:37129;s:12:\"delete-37889\";i:37130;s:12:\"delete-37892\";i:37131;s:12:\"delete-37893\";i:37132;s:12:\"delete-37890\";i:37133;s:12:\"delete-37891\";i:37134;s:12:\"delete-37894\";i:37135;s:12:\"delete-37895\";i:37136;s:12:\"delete-37898\";i:37137;s:12:\"delete-37896\";i:37138;s:12:\"delete-37897\";i:37139;s:12:\"delete-37899\";i:37140;s:12:\"delete-37900\";i:37141;s:12:\"delete-37901\";i:37142;s:12:\"delete-37904\";i:37143;s:12:\"delete-37905\";i:37144;s:12:\"delete-37902\";i:37145;s:12:\"delete-37903\";i:37146;s:12:\"delete-37906\";i:37147;s:12:\"delete-37907\";i:37148;s:12:\"delete-37910\";i:37149;s:12:\"delete-37911\";i:37150;s:12:\"delete-37908\";i:37151;s:12:\"delete-37909\";i:37152;s:12:\"delete-37912\";i:37153;s:12:\"delete-37913\";i:37154;s:12:\"delete-37916\";i:37155;s:12:\"delete-37914\";i:37156;s:12:\"delete-37915\";i:37157;s:12:\"delete-37917\";i:37158;s:12:\"delete-37918\";i:37159;s:12:\"delete-37919\";i:37160;s:12:\"delete-37922\";i:37161;s:12:\"delete-37923\";i:37162;s:12:\"delete-37920\";i:37163;s:12:\"delete-37921\";i:37164;s:12:\"delete-37924\";i:37165;s:12:\"delete-37925\";i:37166;s:12:\"delete-37928\";i:37167;s:12:\"delete-37929\";i:37168;s:12:\"delete-37926\";i:37169;s:12:\"delete-37927\";i:37170;s:12:\"delete-37930\";i:37171;s:12:\"delete-37931\";i:37172;s:12:\"delete-37934\";i:37173;s:12:\"delete-37935\";i:37174;s:12:\"delete-37932\";i:37175;s:12:\"delete-37933\";i:37176;s:12:\"delete-37936\";i:37177;s:12:\"delete-37937\";i:37178;s:12:\"delete-37940\";i:37179;s:12:\"delete-37941\";i:37180;s:12:\"delete-37942\";i:37181;s:12:\"delete-37938\";i:37182;s:12:\"delete-37939\";i:37183;s:12:\"delete-37943\";i:37184;s:12:\"delete-37946\";i:37185;s:12:\"delete-37947\";i:37186;s:12:\"delete-37948\";i:37187;s:12:\"delete-37949\";i:37188;s:12:\"delete-37952\";i:37189;s:12:\"delete-37953\";i:37190;s:12:\"delete-37944\";i:37191;s:12:\"delete-37945\";i:37192;s:12:\"delete-37950\";i:37193;s:12:\"delete-37951\";i:37194;s:12:\"delete-37954\";i:37195;s:12:\"delete-37955\";i:37196;s:12:\"delete-37958\";i:37197;s:12:\"delete-37959\";i:37198;s:12:\"delete-37956\";i:37199;s:12:\"delete-37957\";i:37200;s:12:\"delete-37960\";i:37201;s:12:\"delete-37961\";i:37202;s:12:\"delete-37964\";i:37203;s:12:\"delete-37965\";i:37204;s:12:\"delete-37962\";i:37205;s:12:\"delete-37963\";i:37206;s:12:\"delete-37966\";i:37207;s:12:\"delete-37967\";i:37208;s:12:\"delete-37970\";i:37209;s:12:\"delete-37971\";i:37210;s:12:\"delete-37968\";i:37211;s:12:\"delete-37969\";i:37212;s:12:\"delete-37972\";i:37213;s:12:\"delete-37973\";i:37214;s:12:\"delete-37976\";i:37215;s:12:\"delete-37977\";i:37216;s:12:\"delete-37974\";i:37217;s:12:\"delete-37975\";i:37218;s:12:\"delete-37978\";i:37219;s:12:\"delete-37979\";i:37220;s:12:\"delete-37982\";i:37221;s:12:\"delete-37983\";i:37222;s:12:\"delete-37980\";i:37223;s:12:\"delete-37981\";i:37224;s:12:\"delete-37984\";i:37225;s:12:\"delete-37985\";i:37226;s:12:\"delete-37988\";i:37227;s:12:\"delete-37989\";i:37228;s:12:\"delete-37986\";i:37229;s:12:\"delete-37987\";i:37230;s:12:\"delete-37990\";i:37231;s:12:\"delete-37991\";i:37232;s:12:\"delete-37994\";i:37233;s:12:\"delete-37995\";i:37234;s:12:\"delete-37992\";i:37235;s:12:\"delete-37993\";i:37236;s:12:\"delete-37996\";i:37237;s:12:\"delete-37997\";i:37238;s:12:\"delete-38000\";i:37239;s:12:\"delete-38001\";i:37240;s:12:\"delete-37998\";i:37241;s:12:\"delete-37999\";i:37242;s:12:\"delete-38002\";i:37243;s:12:\"delete-38003\";i:37244;s:12:\"delete-38006\";i:37245;s:12:\"delete-38007\";i:37246;s:12:\"delete-38004\";i:37247;s:12:\"delete-38005\";i:37248;s:12:\"delete-38008\";i:37249;s:12:\"delete-38009\";i:37250;s:12:\"delete-38012\";i:37251;s:12:\"delete-38010\";i:37252;s:12:\"delete-38011\";i:37253;s:12:\"delete-38013\";i:37254;s:12:\"delete-38014\";i:37255;s:12:\"delete-38015\";i:37256;s:12:\"delete-38016\";i:37257;s:12:\"delete-38017\";i:37258;s:12:\"delete-38018\";i:37259;s:12:\"delete-38019\";i:37260;s:12:\"delete-38020\";i:37261;s:12:\"delete-38021\";i:37262;s:12:\"delete-38024\";i:37263;s:12:\"delete-38025\";i:37264;s:12:\"delete-38022\";i:37265;s:12:\"delete-38023\";i:37266;s:12:\"delete-38026\";i:37267;s:12:\"delete-38027\";i:37268;s:12:\"delete-38030\";i:37269;s:12:\"delete-38031\";i:37270;s:12:\"delete-38028\";i:37271;s:12:\"delete-38029\";i:37272;s:12:\"delete-38032\";i:37273;s:12:\"delete-38033\";i:37274;s:12:\"delete-38036\";i:37275;s:12:\"delete-38037\";i:37276;s:12:\"delete-38034\";i:37277;s:12:\"delete-38035\";i:37278;s:12:\"delete-38038\";i:37279;s:12:\"delete-38039\";i:37280;s:12:\"delete-38040\";i:37281;s:12:\"delete-38041\";i:37282;s:12:\"delete-38042\";i:37283;s:12:\"delete-38043\";i:37284;s:12:\"delete-38044\";i:37285;s:12:\"delete-38045\";i:37286;s:12:\"delete-38048\";i:37287;s:12:\"delete-38046\";i:37288;s:12:\"delete-38047\";i:37289;s:12:\"delete-38049\";i:37290;s:12:\"delete-38050\";i:37291;s:12:\"delete-38051\";i:37292;s:12:\"delete-38054\";i:37293;s:12:\"delete-38055\";i:37294;s:12:\"delete-38052\";i:37295;s:12:\"delete-38053\";i:37296;s:12:\"delete-38056\";i:37297;s:12:\"delete-38057\";i:37298;s:12:\"delete-38060\";i:37299;s:12:\"delete-38061\";i:37300;s:12:\"delete-38058\";i:37301;s:12:\"delete-38059\";i:37302;s:12:\"delete-38062\";i:37303;s:12:\"delete-38065\";i:37304;s:12:\"delete-38066\";i:37305;s:12:\"delete-38063\";i:37306;s:12:\"delete-38064\";i:37307;s:12:\"delete-38067\";i:37308;s:12:\"delete-38070\";i:37309;s:12:\"delete-38071\";i:37310;s:12:\"delete-38068\";i:37311;s:12:\"delete-38069\";i:37312;s:12:\"delete-38072\";i:37313;s:12:\"delete-38075\";i:37314;s:12:\"delete-38076\";i:37315;s:12:\"delete-38073\";i:37316;s:12:\"delete-38074\";i:37317;s:12:\"delete-38077\";i:37318;s:12:\"delete-38080\";i:37319;s:12:\"delete-38081\";i:37320;s:12:\"delete-38078\";i:37321;s:12:\"delete-38079\";i:37322;s:12:\"delete-38082\";i:37323;s:12:\"delete-38085\";i:37324;s:12:\"delete-38086\";i:37325;s:12:\"delete-38083\";i:37326;s:12:\"delete-38084\";i:37327;s:12:\"delete-38087\";i:37328;s:12:\"delete-38090\";i:37329;s:12:\"delete-38091\";i:37330;s:12:\"delete-38088\";i:37331;s:12:\"delete-38089\";i:37332;s:12:\"delete-38092\";i:37333;s:12:\"delete-38095\";i:37334;s:12:\"delete-38096\";i:37335;s:12:\"delete-38093\";i:37336;s:12:\"delete-38094\";i:37337;s:12:\"delete-38097\";i:37338;s:12:\"delete-38100\";i:37339;s:12:\"delete-38101\";i:37340;s:12:\"delete-38098\";i:37341;s:12:\"delete-38099\";i:37342;s:12:\"delete-38102\";i:37343;s:12:\"delete-38105\";i:37344;s:12:\"delete-38106\";i:37345;s:12:\"delete-38103\";i:37346;s:12:\"delete-38104\";i:37347;s:12:\"delete-38107\";i:37348;s:12:\"delete-38110\";i:37349;s:12:\"delete-38111\";i:37350;s:12:\"delete-38108\";i:37351;s:12:\"delete-38109\";i:37352;s:12:\"delete-38112\";i:37353;s:12:\"delete-38115\";i:37354;s:12:\"delete-38116\";i:37355;s:12:\"delete-38113\";i:37356;s:12:\"delete-38114\";i:37357;s:12:\"delete-38117\";i:37358;s:12:\"delete-38120\";i:37359;s:12:\"delete-38118\";i:37360;s:12:\"delete-38119\";i:37361;s:12:\"delete-38121\";i:37362;s:12:\"delete-38122\";i:37363;s:12:\"delete-38125\";i:37364;s:12:\"delete-38126\";i:37365;s:12:\"delete-38123\";i:37366;s:12:\"delete-38124\";i:37367;s:12:\"delete-38127\";i:37368;s:12:\"delete-38130\";i:37369;s:12:\"delete-38131\";i:37370;s:12:\"delete-38128\";i:37371;s:12:\"delete-38129\";i:37372;s:12:\"delete-38132\";i:37373;s:12:\"delete-38135\";i:37374;s:12:\"delete-38136\";i:37375;s:12:\"delete-38133\";i:37376;s:12:\"delete-38134\";i:37377;s:12:\"delete-38137\";i:37378;s:12:\"delete-38140\";i:37379;s:12:\"delete-38141\";i:37380;s:12:\"delete-38138\";i:37381;s:12:\"delete-38139\";i:37382;s:12:\"delete-38142\";i:37383;s:12:\"delete-38145\";i:37384;s:12:\"delete-38146\";i:37385;s:12:\"delete-38143\";i:37386;s:12:\"delete-38144\";i:37387;s:12:\"delete-38147\";i:37388;s:12:\"delete-38150\";i:37389;s:12:\"delete-38151\";i:37390;s:12:\"delete-38148\";i:37391;s:12:\"delete-38149\";i:37392;s:12:\"delete-38152\";i:37393;s:12:\"delete-38155\";i:37394;s:12:\"delete-38153\";i:37395;s:12:\"delete-38154\";i:37396;s:12:\"delete-38156\";i:37397;s:12:\"delete-38159\";i:37398;s:12:\"delete-38160\";i:37399;s:12:\"delete-38157\";i:37400;s:12:\"delete-38158\";i:37401;s:12:\"delete-38161\";i:37402;s:12:\"delete-38164\";i:37403;s:12:\"delete-38165\";i:37404;s:12:\"delete-38162\";i:37405;s:12:\"delete-38163\";i:37406;s:12:\"delete-38166\";i:37407;s:12:\"delete-38169\";i:37408;s:12:\"delete-38170\";i:37409;s:12:\"delete-38167\";i:37410;s:12:\"delete-38168\";i:37411;s:12:\"delete-38171\";i:37412;s:12:\"delete-38174\";i:37413;s:12:\"delete-38175\";i:37414;s:12:\"delete-38172\";i:37415;s:12:\"delete-38173\";i:37416;s:12:\"delete-38176\";i:37417;s:12:\"delete-38179\";i:37418;s:12:\"delete-38180\";i:37419;s:12:\"delete-38177\";i:37420;s:12:\"delete-38178\";i:37421;s:12:\"delete-38181\";i:37422;s:12:\"delete-38184\";i:37423;s:12:\"delete-38182\";i:37424;s:12:\"delete-38183\";i:37425;s:12:\"delete-38185\";i:37426;s:12:\"delete-38186\";i:37427;s:12:\"delete-38189\";i:37428;s:12:\"delete-38190\";i:37429;s:12:\"delete-38187\";i:37430;s:12:\"delete-38188\";i:37431;s:12:\"delete-38191\";i:37432;s:12:\"delete-38194\";i:37433;s:12:\"delete-38195\";i:37434;s:12:\"delete-38192\";i:37435;s:12:\"delete-38193\";i:37436;s:12:\"delete-38196\";i:37437;s:12:\"delete-38199\";i:37438;s:12:\"delete-38200\";i:37439;s:12:\"delete-38197\";i:37440;s:12:\"delete-38198\";i:37441;s:12:\"delete-38201\";i:37442;s:12:\"delete-38204\";i:37443;s:12:\"delete-38205\";i:37444;s:12:\"delete-38202\";i:37445;s:12:\"delete-38203\";i:37446;s:12:\"delete-38206\";i:37447;s:12:\"delete-38209\";i:37448;s:12:\"delete-38207\";i:37449;s:12:\"delete-38208\";i:37450;s:12:\"delete-38210\";i:37451;s:12:\"delete-38211\";i:37452;s:12:\"delete-38214\";i:37453;s:12:\"delete-38215\";i:37454;s:12:\"delete-38212\";i:37455;s:12:\"delete-38213\";i:37456;s:12:\"delete-38216\";i:37457;s:12:\"delete-38219\";i:37458;s:12:\"delete-38220\";i:37459;s:12:\"delete-38217\";i:37460;s:12:\"delete-38218\";i:37461;s:12:\"delete-38221\";i:37462;s:12:\"delete-38224\";i:37463;s:12:\"delete-38225\";i:37464;s:12:\"delete-38222\";i:37465;s:12:\"delete-38223\";i:37466;s:12:\"delete-38226\";i:37467;s:12:\"delete-38229\";i:37468;s:12:\"delete-38227\";i:37469;s:12:\"delete-38228\";i:37470;s:12:\"delete-38230\";i:37471;s:12:\"delete-38231\";i:37472;s:12:\"delete-38234\";i:37473;s:12:\"delete-38235\";i:37474;s:12:\"delete-38236\";i:37475;s:12:\"delete-38239\";i:37476;s:12:\"delete-38240\";i:37477;s:12:\"delete-38232\";i:37478;s:12:\"delete-38233\";i:37479;s:12:\"delete-38237\";i:37480;s:12:\"delete-38238\";i:37481;s:12:\"delete-38241\";i:37482;s:12:\"delete-38244\";i:37483;s:12:\"delete-38245\";i:37484;s:12:\"delete-38242\";i:37485;s:12:\"delete-38243\";i:37486;s:12:\"delete-38246\";i:37487;s:12:\"delete-38249\";i:37488;s:12:\"delete-38250\";i:37489;s:12:\"delete-38247\";i:37490;s:12:\"delete-38248\";i:37491;s:12:\"delete-38251\";i:37492;s:12:\"delete-38252\";i:37493;s:12:\"delete-38253\";i:37494;s:12:\"delete-38256\";i:37495;s:12:\"delete-38257\";i:37496;s:12:\"delete-38254\";i:37497;s:12:\"delete-38255\";i:37498;s:12:\"delete-38258\";i:37499;s:12:\"delete-38261\";i:37500;s:12:\"delete-38259\";i:37501;s:12:\"delete-38260\";i:37502;s:12:\"delete-38262\";i:37503;s:12:\"delete-38263\";i:37504;s:12:\"delete-38266\";i:37505;s:12:\"delete-38267\";i:37506;s:12:\"delete-38264\";i:37507;s:12:\"delete-38265\";i:37508;s:12:\"delete-38268\";i:37509;s:12:\"delete-38271\";i:37510;s:12:\"delete-38272\";i:37511;s:12:\"delete-38269\";i:37512;s:12:\"delete-38270\";i:37513;s:12:\"delete-38273\";i:37514;s:12:\"delete-38276\";i:37515;s:12:\"delete-38274\";i:37516;s:12:\"delete-38275\";i:37517;s:12:\"delete-38277\";i:37518;s:12:\"delete-38278\";i:37519;s:12:\"delete-38281\";i:37520;s:12:\"delete-38282\";i:37521;s:12:\"delete-38279\";i:37522;s:12:\"delete-38280\";i:37523;s:12:\"delete-38283\";i:37524;s:12:\"delete-38286\";i:37525;s:12:\"delete-38287\";i:37526;s:12:\"delete-38284\";i:37527;s:12:\"delete-38285\";i:37528;s:12:\"delete-38288\";i:37529;s:12:\"delete-38291\";i:37530;s:12:\"delete-38292\";i:37531;s:12:\"delete-38289\";i:37532;s:12:\"delete-38290\";i:37533;s:12:\"delete-38293\";i:37534;s:12:\"delete-38296\";i:37535;s:12:\"delete-38297\";i:37536;s:12:\"delete-38294\";i:37537;s:12:\"delete-38295\";i:37538;s:12:\"delete-38298\";i:37539;s:12:\"delete-38301\";i:37540;s:12:\"delete-38302\";i:37541;s:12:\"delete-38299\";i:37542;s:12:\"delete-38300\";i:37543;s:12:\"delete-38303\";i:37544;s:12:\"delete-38306\";i:37545;s:12:\"delete-38304\";i:37546;s:12:\"delete-38305\";i:37547;s:12:\"delete-38307\";i:37548;s:12:\"delete-38308\";i:37549;s:12:\"delete-38311\";i:37550;s:12:\"delete-38312\";i:37551;s:12:\"delete-38309\";i:37552;s:12:\"delete-38310\";i:37553;s:12:\"delete-38313\";i:37554;s:12:\"delete-38316\";i:37555;s:12:\"delete-38317\";i:37556;s:12:\"delete-38314\";i:37557;s:12:\"delete-38315\";i:37558;s:12:\"delete-38318\";i:37559;s:12:\"delete-38321\";i:37560;s:12:\"delete-38322\";i:37561;s:12:\"delete-38319\";i:37562;s:12:\"delete-38320\";i:37563;s:12:\"delete-38323\";i:37564;s:12:\"delete-38326\";i:37565;s:12:\"delete-38327\";i:37566;s:12:\"delete-38324\";i:37567;s:12:\"delete-38325\";i:37568;s:12:\"delete-38328\";i:37569;s:12:\"delete-38331\";i:37570;s:12:\"delete-38329\";i:37571;s:12:\"delete-38330\";i:37572;s:12:\"delete-38332\";i:37573;s:12:\"delete-38333\";i:37574;s:12:\"delete-38336\";i:37575;s:12:\"delete-38337\";i:37576;s:12:\"delete-38334\";i:37577;s:12:\"delete-38335\";i:37578;s:12:\"delete-38338\";i:37579;s:12:\"delete-38341\";i:37580;s:12:\"delete-38342\";i:37581;s:12:\"delete-38339\";i:37582;s:12:\"delete-38340\";i:37583;s:12:\"delete-38343\";i:37584;s:12:\"delete-38346\";i:37585;s:12:\"delete-38347\";i:37586;s:12:\"delete-38344\";i:37587;s:12:\"delete-38345\";i:37588;s:12:\"delete-38348\";i:37589;s:12:\"delete-38351\";i:37590;s:12:\"delete-38352\";i:37591;s:12:\"delete-38349\";i:37592;s:12:\"delete-38350\";i:37593;s:12:\"delete-38353\";i:37594;s:12:\"delete-38356\";i:37595;s:12:\"delete-38357\";i:37596;s:12:\"delete-38354\";i:37597;s:12:\"delete-38355\";i:37598;s:12:\"delete-38358\";i:37599;s:12:\"delete-38361\";i:37600;s:12:\"delete-38362\";i:37601;s:12:\"delete-38359\";i:37602;s:12:\"delete-38360\";i:37603;s:12:\"delete-38363\";i:37604;s:12:\"delete-38366\";i:37605;s:12:\"delete-38367\";i:37606;s:12:\"delete-38364\";i:37607;s:12:\"delete-38365\";i:37608;s:12:\"delete-38368\";i:37609;s:12:\"delete-38371\";i:37610;s:12:\"delete-38369\";i:37611;s:12:\"delete-38370\";i:37612;s:12:\"delete-38372\";i:37613;s:12:\"delete-38373\";i:37614;s:12:\"delete-38376\";i:37615;s:12:\"delete-38377\";i:37616;s:12:\"delete-38374\";i:37617;s:12:\"delete-38375\";i:37618;s:12:\"delete-38378\";i:37619;s:12:\"delete-38379\";i:37620;s:12:\"delete-38380\";i:37621;s:12:\"delete-38381\";i:37622;s:12:\"delete-38382\";i:37623;s:12:\"delete-38383\";i:37624;s:12:\"delete-38386\";i:37625;s:12:\"delete-38384\";i:37626;s:12:\"delete-38385\";i:37627;s:12:\"delete-38387\";i:37628;s:12:\"delete-38388\";i:37629;s:12:\"delete-38391\";i:37630;s:12:\"delete-38392\";i:37631;s:12:\"delete-38389\";i:37632;s:12:\"delete-38390\";i:37633;s:12:\"delete-38393\";i:37634;s:12:\"delete-38396\";i:37635;s:12:\"delete-38397\";i:37636;s:12:\"delete-38394\";i:37637;s:12:\"delete-38395\";i:37638;s:12:\"delete-38398\";i:37639;s:12:\"delete-38401\";i:37640;s:12:\"delete-38399\";i:37641;s:12:\"delete-38400\";i:37642;s:12:\"delete-38402\";i:37643;s:12:\"delete-38403\";i:37644;s:12:\"delete-38406\";i:37645;s:12:\"delete-38404\";i:37646;s:12:\"delete-38405\";i:37647;s:12:\"delete-38407\";i:37648;s:12:\"delete-38408\";i:37649;s:12:\"delete-38411\";i:37650;s:12:\"delete-38412\";i:37651;s:12:\"delete-38409\";i:37652;s:12:\"delete-38410\";i:37653;s:12:\"delete-38413\";i:37654;s:12:\"delete-38416\";i:37655;s:12:\"delete-38414\";i:37656;s:12:\"delete-38415\";i:37657;s:12:\"delete-38417\";i:37658;s:12:\"delete-38418\";i:37659;s:12:\"delete-38421\";i:37660;s:12:\"delete-38422\";i:37661;s:12:\"delete-38419\";i:37662;s:12:\"delete-38420\";i:37663;s:12:\"delete-38423\";i:37664;s:12:\"delete-38426\";i:37665;s:12:\"delete-38427\";i:37666;s:12:\"delete-38424\";i:37667;s:12:\"delete-38425\";i:37668;s:12:\"delete-38428\";i:37669;s:12:\"delete-38431\";i:37670;s:12:\"delete-38432\";i:37671;s:12:\"delete-38429\";i:37672;s:12:\"delete-38430\";i:37673;s:12:\"delete-38433\";i:37674;s:12:\"delete-38436\";i:37675;s:12:\"delete-38437\";i:37676;s:12:\"delete-38434\";i:37677;s:12:\"delete-38435\";i:37678;s:12:\"delete-38438\";i:37679;s:12:\"delete-38441\";i:37680;s:12:\"delete-38442\";i:37681;s:12:\"delete-38439\";i:37682;s:12:\"delete-38440\";i:37683;s:12:\"delete-38443\";i:37684;s:12:\"delete-38444\";i:37685;s:12:\"delete-38445\";i:37686;s:12:\"delete-38446\";i:37687;s:12:\"delete-38447\";i:37688;s:12:\"delete-38448\";i:37689;s:12:\"delete-38451\";i:37690;s:12:\"delete-38452\";i:37691;s:12:\"delete-38449\";i:37692;s:12:\"delete-38450\";i:37693;s:12:\"delete-38453\";i:37694;s:12:\"delete-38456\";i:37695;s:12:\"delete-38457\";i:37696;s:12:\"delete-38454\";i:37697;s:12:\"delete-38455\";i:37698;s:12:\"delete-38458\";i:37699;s:12:\"delete-38461\";i:37700;s:12:\"delete-38462\";i:37701;s:12:\"delete-38459\";i:37702;s:12:\"delete-38460\";i:37703;s:12:\"delete-38463\";i:37704;s:12:\"delete-38466\";i:37705;s:12:\"delete-38464\";i:37706;s:12:\"delete-38465\";i:37707;s:12:\"delete-38467\";i:37708;s:12:\"delete-38468\";i:37709;s:12:\"delete-38471\";i:37710;s:12:\"delete-38472\";i:37711;s:12:\"delete-38469\";i:37712;s:12:\"delete-38470\";i:37713;s:12:\"delete-38473\";i:37714;s:12:\"delete-38476\";i:37715;s:12:\"delete-38474\";i:37716;s:12:\"delete-38475\";i:37717;s:12:\"delete-38477\";i:37718;s:12:\"delete-38478\";i:37719;s:12:\"delete-38481\";i:37720;s:12:\"delete-38482\";i:37721;s:12:\"delete-38479\";i:37722;s:12:\"delete-38480\";i:37723;s:12:\"delete-38483\";i:37724;s:12:\"delete-38486\";i:37725;s:12:\"delete-38487\";i:37726;s:12:\"delete-38484\";i:37727;s:12:\"delete-38485\";i:37728;s:12:\"delete-38488\";i:37729;s:12:\"delete-38489\";i:37730;s:12:\"delete-38490\";i:37731;s:12:\"delete-38491\";i:37732;s:12:\"delete-38492\";i:37733;s:12:\"delete-38493\";i:37734;s:12:\"delete-38496\";i:37735;s:12:\"delete-38497\";i:37736;s:12:\"delete-38494\";i:37737;s:12:\"delete-38495\";i:37738;s:12:\"delete-38498\";i:37739;s:12:\"delete-38501\";i:37740;s:12:\"delete-38499\";i:37741;s:12:\"delete-38500\";i:37742;s:12:\"delete-38502\";i:37743;s:12:\"delete-38503\";i:37744;s:12:\"delete-38506\";i:37745;s:12:\"delete-38507\";i:37746;s:12:\"delete-38504\";i:37747;s:12:\"delete-38505\";i:37748;s:12:\"delete-38508\";i:37749;s:12:\"delete-38511\";i:37750;s:12:\"delete-38512\";i:37751;s:12:\"delete-38509\";i:37752;s:12:\"delete-38510\";i:37753;s:12:\"delete-38513\";i:37754;s:12:\"delete-38516\";i:37755;s:12:\"delete-38517\";i:37756;s:12:\"delete-38514\";i:37757;s:12:\"delete-38515\";i:37758;s:12:\"delete-38518\";i:37759;s:12:\"delete-38521\";i:37760;s:12:\"delete-38522\";i:37761;s:12:\"delete-38519\";i:37762;s:12:\"delete-38520\";i:37763;s:12:\"delete-38523\";i:37764;s:12:\"delete-38526\";i:37765;s:12:\"delete-38527\";i:37766;s:12:\"delete-38524\";i:37767;s:12:\"delete-38525\";i:37768;s:12:\"delete-38528\";i:37769;s:12:\"delete-38531\";i:37770;s:12:\"delete-38529\";i:37771;s:12:\"delete-38530\";i:37772;s:12:\"delete-38532\";i:37773;s:12:\"delete-38533\";i:37774;s:12:\"delete-38536\";i:37775;s:12:\"delete-38537\";i:37776;s:12:\"delete-38534\";i:37777;s:12:\"delete-38535\";i:37778;s:12:\"delete-38538\";i:37779;s:12:\"delete-38541\";i:37780;s:12:\"delete-38542\";i:37781;s:12:\"delete-38539\";i:37782;s:12:\"delete-38540\";i:37783;s:12:\"delete-38543\";i:37784;s:12:\"delete-38546\";i:37785;s:12:\"delete-38547\";i:37786;s:12:\"delete-38544\";i:37787;s:12:\"delete-38545\";i:37788;s:12:\"delete-38548\";i:37789;s:12:\"delete-38551\";i:37790;s:12:\"delete-38552\";i:37791;s:12:\"delete-38549\";i:37792;s:12:\"delete-38550\";i:37793;s:12:\"delete-38553\";i:37794;s:12:\"delete-38556\";i:37795;s:12:\"delete-38557\";i:37796;s:12:\"delete-38554\";i:37797;s:12:\"delete-38555\";i:37798;s:12:\"delete-38558\";i:37799;s:12:\"delete-38561\";i:37800;s:12:\"delete-38562\";i:37801;s:12:\"delete-38559\";i:37802;s:12:\"delete-38560\";i:37803;s:12:\"delete-38563\";i:37804;s:12:\"delete-38566\";i:37805;s:12:\"delete-38567\";i:37806;s:12:\"delete-38564\";i:37807;s:12:\"delete-38565\";i:37808;s:12:\"delete-38568\";i:37809;s:12:\"delete-38571\";i:37810;s:12:\"delete-38569\";i:37811;s:12:\"delete-38570\";i:37812;s:12:\"delete-38572\";i:37813;s:12:\"delete-38573\";i:37814;s:12:\"delete-38576\";i:37815;s:12:\"delete-38577\";i:37816;s:12:\"delete-38574\";i:37817;s:12:\"delete-38575\";i:37818;s:12:\"delete-38578\";i:37819;s:12:\"delete-38581\";i:37820;s:12:\"delete-38579\";i:37821;s:12:\"delete-38580\";i:37822;s:12:\"delete-38582\";i:37823;s:12:\"delete-38583\";i:37824;s:12:\"delete-38586\";i:37825;s:12:\"delete-38587\";i:37826;s:12:\"delete-38584\";i:37827;s:12:\"delete-38585\";i:37828;s:12:\"delete-38588\";i:37829;s:12:\"delete-38591\";i:37830;s:12:\"delete-38589\";i:37831;s:12:\"delete-38590\";i:37832;s:12:\"delete-38592\";i:37833;s:12:\"delete-38593\";i:37834;s:12:\"delete-38596\";i:37835;s:12:\"delete-38597\";i:37836;s:12:\"delete-38594\";i:37837;s:12:\"delete-38595\";i:37838;s:12:\"delete-38598\";i:37839;s:12:\"delete-38601\";i:37840;s:12:\"delete-38602\";i:37841;s:12:\"delete-38599\";i:37842;s:12:\"delete-38600\";i:37843;s:12:\"delete-38603\";i:37844;s:12:\"delete-38606\";i:37845;s:12:\"delete-38604\";i:37846;s:12:\"delete-38605\";i:37847;s:12:\"delete-38607\";i:37848;s:12:\"delete-38608\";i:37849;s:12:\"delete-38611\";i:37850;s:12:\"delete-38612\";i:37851;s:12:\"delete-38609\";i:37852;s:12:\"delete-38610\";i:37853;s:12:\"delete-38613\";i:37854;s:12:\"delete-38616\";i:37855;s:12:\"delete-38617\";i:37856;s:12:\"delete-38614\";i:37857;s:12:\"delete-38615\";i:37858;s:12:\"delete-38618\";i:37859;s:12:\"delete-38621\";i:37860;s:12:\"delete-38622\";i:37861;s:12:\"delete-38619\";i:37862;s:12:\"delete-38620\";i:37863;s:12:\"delete-38623\";i:37864;s:12:\"delete-38626\";i:37865;s:12:\"delete-38627\";i:37866;s:12:\"delete-38624\";i:37867;s:12:\"delete-38625\";i:37868;s:12:\"delete-38628\";i:37869;s:12:\"delete-38631\";i:37870;s:12:\"delete-38632\";i:37871;s:12:\"delete-38629\";i:37872;s:12:\"delete-38630\";i:37873;s:12:\"delete-38633\";i:37874;s:12:\"delete-38636\";i:37875;s:12:\"delete-38637\";i:37876;s:12:\"delete-38634\";i:37877;s:12:\"delete-38635\";i:37878;s:12:\"delete-38638\";i:37879;s:12:\"delete-38641\";i:37880;s:12:\"delete-38639\";i:37881;s:12:\"delete-38640\";i:37882;s:12:\"delete-38642\";i:37883;s:12:\"delete-38643\";i:37884;s:12:\"delete-38646\";i:37885;s:12:\"delete-38644\";i:37886;s:12:\"delete-38645\";i:37887;s:12:\"delete-38647\";i:37888;s:12:\"delete-38648\";i:37889;s:12:\"delete-38651\";i:37890;s:12:\"delete-38652\";i:37891;s:12:\"delete-38649\";i:37892;s:12:\"delete-38650\";i:37893;s:12:\"delete-38653\";i:37894;s:12:\"delete-38656\";i:37895;s:12:\"delete-38654\";i:37896;s:12:\"delete-38655\";i:37897;s:12:\"delete-38657\";i:37898;s:12:\"delete-38658\";i:37899;s:12:\"delete-38661\";i:37900;s:12:\"delete-38662\";i:37901;s:12:\"delete-38663\";i:37902;s:12:\"delete-38666\";i:37903;s:12:\"delete-38667\";i:37904;s:12:\"delete-38659\";i:37905;s:12:\"delete-38660\";i:37906;s:12:\"delete-38664\";i:37907;s:12:\"delete-38665\";i:37908;s:12:\"delete-38668\";i:37909;s:12:\"delete-38671\";i:37910;s:12:\"delete-38672\";i:37911;s:12:\"delete-38669\";i:37912;s:12:\"delete-38670\";i:37913;s:12:\"delete-38673\";i:37914;s:12:\"delete-38676\";i:37915;s:12:\"delete-38677\";i:37916;s:12:\"delete-38674\";i:37917;s:12:\"delete-38675\";i:37918;s:12:\"delete-38678\";i:37919;s:12:\"delete-38681\";i:37920;s:12:\"delete-38682\";i:37921;s:12:\"delete-38679\";i:37922;s:12:\"delete-38680\";i:37923;s:12:\"delete-38683\";i:37924;s:12:\"delete-38686\";i:37925;s:12:\"delete-38687\";i:37926;s:12:\"delete-38684\";i:37927;s:12:\"delete-38685\";i:37928;s:12:\"delete-38688\";i:37929;s:12:\"delete-38691\";i:37930;s:12:\"delete-38692\";i:37931;s:12:\"delete-38689\";i:37932;s:12:\"delete-38690\";i:37933;s:12:\"delete-38693\";i:37934;s:12:\"delete-38696\";i:37935;s:12:\"delete-38697\";i:37936;s:12:\"delete-38694\";i:37937;s:12:\"delete-38695\";i:37938;s:12:\"delete-38698\";i:37939;s:12:\"delete-38701\";i:37940;s:12:\"delete-38699\";i:37941;s:12:\"delete-38700\";i:37942;s:12:\"delete-38702\";i:37943;s:12:\"delete-38703\";i:37944;s:12:\"delete-38706\";i:37945;s:12:\"delete-38707\";i:37946;s:12:\"delete-38704\";i:37947;s:12:\"delete-38705\";i:37948;s:12:\"delete-38708\";i:37949;s:12:\"delete-38711\";i:37950;s:12:\"delete-38712\";i:37951;s:12:\"delete-38709\";i:37952;s:12:\"delete-38710\";i:37953;s:12:\"delete-38713\";i:37954;s:12:\"delete-38716\";i:37955;s:12:\"delete-38717\";i:37956;s:12:\"delete-38714\";i:37957;s:12:\"delete-38715\";i:37958;s:12:\"delete-38718\";i:37959;s:12:\"delete-38721\";i:37960;s:12:\"delete-38719\";i:37961;s:12:\"delete-38720\";i:37962;s:12:\"delete-38722\";i:37963;s:12:\"delete-38723\";i:37964;s:12:\"delete-38726\";i:37965;s:12:\"delete-38727\";i:37966;s:12:\"delete-38724\";i:37967;s:12:\"delete-38725\";i:37968;s:12:\"delete-38728\";i:37969;s:12:\"delete-38731\";i:37970;s:12:\"delete-38732\";i:37971;s:12:\"delete-38729\";i:37972;s:12:\"delete-38730\";i:37973;s:12:\"delete-38733\";i:37974;s:12:\"delete-38736\";i:37975;s:12:\"delete-38737\";i:37976;s:12:\"delete-38734\";i:37977;s:12:\"delete-38735\";i:37978;s:12:\"delete-38738\";i:37979;s:12:\"delete-38741\";i:37980;s:12:\"delete-38742\";i:37981;s:12:\"delete-38739\";i:37982;s:12:\"delete-38740\";i:37983;s:12:\"delete-38743\";i:37984;s:12:\"delete-38746\";i:37985;s:12:\"delete-38744\";i:37986;s:12:\"delete-38745\";i:37987;s:12:\"delete-38747\";i:37988;s:12:\"delete-38748\";i:37989;s:12:\"delete-38751\";i:37990;s:12:\"delete-38749\";i:37991;s:12:\"delete-38750\";i:37992;s:12:\"delete-38752\";i:37993;s:12:\"delete-38753\";i:37994;s:12:\"delete-38756\";i:37995;s:12:\"delete-38757\";i:37996;s:12:\"delete-38754\";i:37997;s:12:\"delete-38755\";i:37998;s:12:\"delete-38758\";i:37999;s:12:\"delete-38761\";i:38000;s:12:\"delete-38762\";i:38001;s:12:\"delete-38759\";i:38002;s:12:\"delete-38760\";i:38003;s:12:\"delete-38763\";i:38004;s:12:\"delete-38766\";i:38005;s:12:\"delete-38764\";i:38006;s:12:\"delete-38765\";i:38007;s:12:\"delete-38767\";i:38008;s:12:\"delete-38768\";i:38009;s:12:\"delete-38771\";i:38010;s:12:\"delete-38772\";i:38011;s:12:\"delete-38769\";i:38012;s:12:\"delete-38770\";i:38013;s:12:\"delete-38773\";i:38014;s:12:\"delete-38776\";i:38015;s:12:\"delete-38777\";i:38016;s:12:\"delete-38774\";i:38017;s:12:\"delete-38775\";i:38018;s:12:\"delete-38778\";i:38019;s:12:\"delete-38781\";i:38020;s:12:\"delete-38782\";i:38021;s:12:\"delete-38779\";i:38022;s:12:\"delete-38780\";i:38023;s:12:\"delete-38783\";i:38024;s:12:\"delete-38786\";i:38025;s:12:\"delete-38787\";i:38026;s:12:\"delete-38784\";i:38027;s:12:\"delete-38785\";i:38028;s:12:\"delete-38788\";i:38029;s:12:\"delete-38791\";i:38030;s:12:\"delete-38792\";i:38031;s:12:\"delete-38789\";i:38032;s:12:\"delete-38790\";i:38033;s:12:\"delete-38793\";i:38034;s:12:\"delete-38796\";i:38035;s:12:\"delete-38797\";i:38036;s:12:\"delete-38794\";i:38037;s:12:\"delete-38795\";i:38038;s:12:\"delete-38798\";i:38039;s:12:\"delete-38801\";i:38040;s:12:\"delete-38799\";i:38041;s:12:\"delete-38800\";i:38042;s:12:\"delete-38802\";i:38043;s:12:\"delete-38803\";i:38044;s:12:\"delete-38806\";i:38045;s:12:\"delete-38804\";i:38046;s:12:\"delete-38805\";i:38047;s:12:\"delete-38807\";i:38048;s:12:\"delete-38808\";i:38049;s:12:\"delete-38811\";i:38050;s:12:\"delete-38812\";i:38051;s:12:\"delete-38809\";i:38052;s:12:\"delete-38810\";i:38053;s:12:\"delete-38813\";i:38054;s:12:\"delete-38816\";i:38055;s:12:\"delete-38817\";i:38056;s:12:\"delete-38814\";i:38057;s:12:\"delete-38815\";i:38058;s:12:\"delete-38818\";i:38059;s:12:\"delete-38821\";i:38060;s:12:\"delete-38822\";i:38061;s:12:\"delete-38823\";i:38062;s:12:\"delete-38826\";i:38063;s:12:\"delete-38827\";i:38064;s:12:\"delete-38819\";i:38065;s:12:\"delete-38820\";i:38066;s:12:\"delete-38824\";i:38067;s:12:\"delete-38825\";i:38068;s:12:\"delete-38828\";i:38069;s:12:\"delete-38831\";i:38070;s:12:\"delete-38829\";i:38071;s:12:\"delete-38830\";i:38072;s:12:\"delete-38832\";i:38073;s:12:\"delete-38833\";i:38074;s:12:\"delete-38836\";i:38075;s:12:\"delete-38837\";i:38076;s:12:\"delete-38834\";i:38077;s:12:\"delete-38835\";i:38078;s:12:\"delete-38838\";i:38079;s:12:\"delete-38839\";i:38080;s:12:\"delete-38840\";i:38081;s:12:\"delete-38841\";i:38082;s:12:\"delete-38842\";i:38083;s:12:\"delete-38843\";i:38084;s:12:\"delete-38846\";i:38085;s:12:\"delete-38847\";i:38086;s:12:\"delete-38844\";i:38087;s:12:\"delete-38845\";i:38088;s:12:\"delete-38848\";i:38089;s:12:\"delete-38851\";i:38090;s:12:\"delete-38852\";i:38091;s:12:\"delete-38849\";i:38092;s:12:\"delete-38850\";i:38093;s:12:\"delete-38853\";i:38094;s:12:\"delete-38856\";i:38095;s:12:\"delete-38857\";i:38096;s:12:\"delete-38854\";i:38097;s:12:\"delete-38855\";i:38098;s:12:\"delete-38858\";i:38099;s:12:\"delete-38861\";i:38100;s:12:\"delete-38859\";i:38101;s:12:\"delete-38860\";i:38102;s:12:\"delete-38862\";i:38103;s:12:\"delete-38863\";i:38104;s:12:\"delete-38866\";i:38105;s:12:\"delete-38867\";i:38106;s:12:\"delete-38864\";i:38107;s:12:\"delete-38865\";i:38108;s:12:\"delete-38868\";i:38109;s:12:\"delete-38871\";i:38110;s:12:\"delete-38869\";i:38111;s:12:\"delete-38870\";i:38112;s:12:\"delete-38872\";i:38113;s:12:\"delete-38873\";i:38114;s:12:\"delete-38876\";i:38115;s:12:\"delete-38877\";i:38116;s:12:\"delete-38874\";i:38117;s:12:\"delete-38875\";i:38118;s:12:\"delete-38878\";i:38119;s:12:\"delete-38881\";i:38120;s:12:\"delete-38882\";i:38121;s:12:\"delete-38879\";i:38122;s:12:\"delete-38880\";i:38123;s:12:\"delete-38883\";i:38124;s:12:\"delete-38886\";i:38125;s:12:\"delete-38884\";i:38126;s:12:\"delete-38885\";i:38127;s:12:\"delete-38887\";i:38128;s:12:\"delete-38888\";i:38129;s:12:\"delete-38891\";i:38130;s:12:\"delete-38892\";i:38131;s:12:\"delete-38889\";i:38132;s:12:\"delete-38890\";i:38133;s:12:\"delete-38893\";i:38134;s:12:\"delete-38896\";i:38135;s:12:\"delete-38897\";i:38136;s:12:\"delete-38894\";i:38137;s:12:\"delete-38895\";i:38138;s:12:\"delete-38898\";i:38139;s:12:\"delete-38901\";i:38140;s:12:\"delete-38902\";i:38141;s:12:\"delete-38903\";i:38142;s:12:\"delete-38906\";i:38143;s:12:\"delete-38907\";i:38144;s:12:\"delete-38899\";i:38145;s:12:\"delete-38900\";i:38146;s:12:\"delete-38904\";i:38147;s:12:\"delete-38905\";i:38148;s:12:\"delete-38908\";i:38149;s:12:\"delete-38911\";i:38150;s:12:\"delete-38909\";i:38151;s:12:\"delete-38910\";i:38152;s:12:\"delete-38912\";i:38153;s:12:\"delete-38913\";i:38154;s:12:\"delete-38916\";i:38155;s:12:\"delete-38917\";i:38156;s:12:\"delete-38914\";i:38157;s:12:\"delete-38915\";i:38158;s:12:\"delete-38918\";i:38159;s:12:\"delete-38921\";i:38160;s:12:\"delete-38922\";i:38161;s:12:\"delete-38919\";i:38162;s:12:\"delete-38920\";i:38163;s:12:\"delete-38923\";i:38164;s:12:\"delete-38926\";i:38165;s:12:\"delete-38927\";i:38166;s:12:\"delete-38924\";i:38167;s:12:\"delete-38925\";i:38168;s:12:\"delete-38928\";i:38169;s:12:\"delete-38931\";i:38170;s:12:\"delete-38932\";i:38171;s:12:\"delete-38929\";i:38172;s:12:\"delete-38930\";i:38173;s:12:\"delete-38933\";i:38174;s:12:\"delete-38936\";i:38175;s:12:\"delete-38937\";i:38176;s:12:\"delete-38934\";i:38177;s:12:\"delete-38935\";i:38178;s:12:\"delete-38938\";i:38179;s:12:\"delete-38941\";i:38180;s:12:\"delete-38942\";i:38181;s:12:\"delete-38939\";i:38182;s:12:\"delete-38940\";i:38183;s:12:\"delete-38943\";i:38184;s:12:\"delete-38946\";i:38185;s:12:\"delete-38947\";i:38186;s:12:\"delete-38944\";i:38187;s:12:\"delete-38945\";i:38188;s:12:\"delete-38948\";i:38189;s:12:\"delete-38951\";i:38190;s:12:\"delete-38952\";i:38191;s:12:\"delete-38949\";i:38192;s:12:\"delete-38950\";i:38193;s:12:\"delete-38953\";i:38194;s:12:\"delete-38954\";i:38195;s:12:\"delete-38955\";i:38196;s:12:\"delete-38956\";i:38197;s:12:\"delete-38957\";i:38198;s:12:\"delete-38958\";i:38199;s:12:\"delete-38961\";i:38200;s:12:\"delete-38962\";i:38201;s:12:\"delete-38959\";i:38202;s:12:\"delete-38960\";i:38203;s:12:\"delete-38963\";i:38204;s:12:\"delete-38966\";i:38205;s:12:\"delete-38967\";i:38206;s:12:\"delete-38964\";i:38207;s:12:\"delete-38965\";i:38208;s:12:\"delete-38968\";i:38209;s:12:\"delete-38971\";i:38210;s:12:\"delete-38972\";i:38211;s:12:\"delete-38969\";i:38212;s:12:\"delete-38970\";i:38213;s:12:\"delete-38973\";i:38214;s:12:\"delete-38976\";i:38215;s:12:\"delete-38974\";i:38216;s:12:\"delete-38975\";i:38217;s:12:\"delete-38977\";i:38218;s:12:\"delete-38978\";i:38219;s:12:\"delete-38981\";i:38220;s:12:\"delete-38982\";i:38221;s:12:\"delete-38979\";i:38222;s:12:\"delete-38980\";i:38223;s:12:\"delete-38983\";i:38224;s:12:\"delete-38986\";i:38225;s:12:\"delete-38987\";i:38226;s:12:\"delete-38984\";i:38227;s:12:\"delete-38985\";i:38228;s:12:\"delete-38988\";i:38229;s:12:\"delete-38991\";i:38230;s:12:\"delete-38989\";i:38231;s:12:\"delete-38990\";i:38232;s:12:\"delete-38992\";i:38233;s:12:\"delete-38993\";i:38234;s:12:\"delete-38996\";i:38235;s:12:\"delete-38997\";i:38236;s:12:\"delete-38994\";i:38237;s:12:\"delete-38995\";i:38238;s:12:\"delete-38998\";i:38239;s:12:\"delete-39001\";i:38240;s:12:\"delete-38999\";i:38241;s:12:\"delete-39000\";i:38242;s:12:\"delete-39002\";i:38243;s:12:\"delete-39003\";i:38244;s:12:\"delete-39006\";i:38245;s:12:\"delete-39007\";i:38246;s:12:\"delete-39004\";i:38247;s:12:\"delete-39005\";i:38248;s:12:\"delete-39008\";i:38249;s:12:\"delete-39011\";i:38250;s:12:\"delete-39012\";i:38251;s:12:\"delete-39009\";i:38252;s:12:\"delete-39010\";i:38253;s:12:\"delete-39013\";i:38254;s:12:\"delete-39016\";i:38255;s:12:\"delete-39017\";i:38256;s:12:\"delete-39014\";i:38257;s:12:\"delete-39015\";i:38258;s:12:\"delete-39018\";i:38259;s:12:\"delete-39021\";i:38260;s:12:\"delete-39022\";i:38261;s:12:\"delete-39019\";i:38262;s:12:\"delete-39020\";i:38263;s:12:\"delete-39023\";i:38264;s:12:\"delete-39026\";i:38265;s:12:\"delete-39027\";i:38266;s:12:\"delete-39024\";i:38267;s:12:\"delete-39025\";i:38268;s:12:\"delete-39028\";i:38269;s:12:\"delete-39031\";i:38270;s:12:\"delete-39032\";i:38271;s:12:\"delete-39029\";i:38272;s:12:\"delete-39030\";i:38273;s:12:\"delete-39033\";i:38274;s:12:\"delete-39036\";i:38275;s:12:\"delete-39037\";i:38276;s:12:\"delete-39034\";i:38277;s:12:\"delete-39035\";i:38278;s:12:\"delete-39038\";i:38279;s:12:\"delete-39041\";i:38280;s:12:\"delete-39042\";i:38281;s:12:\"delete-39039\";i:38282;s:12:\"delete-39040\";i:38283;s:12:\"delete-39043\";i:38284;s:12:\"delete-39046\";i:38285;s:12:\"delete-39044\";i:38286;s:12:\"delete-39045\";i:38287;s:12:\"delete-39047\";i:38288;s:12:\"delete-39048\";i:38289;s:12:\"delete-39051\";i:38290;s:12:\"delete-39049\";i:38291;s:12:\"delete-39050\";i:38292;s:12:\"delete-39052\";i:38293;s:12:\"delete-39053\";i:38294;s:12:\"delete-39056\";i:38295;s:12:\"delete-39057\";i:38296;s:12:\"delete-39054\";i:38297;s:12:\"delete-39055\";i:38298;s:12:\"delete-39058\";i:38299;s:12:\"delete-39061\";i:38300;s:12:\"delete-39062\";i:38301;s:12:\"delete-39059\";i:38302;s:12:\"delete-39060\";i:38303;s:12:\"delete-39063\";i:38304;s:12:\"delete-39066\";i:38305;s:12:\"delete-39064\";i:38306;s:12:\"delete-39065\";i:38307;s:12:\"delete-39067\";i:38308;s:12:\"delete-39068\";i:38309;s:12:\"delete-39071\";i:38310;s:12:\"delete-39072\";i:38311;s:12:\"delete-39073\";i:38312;s:12:\"delete-39076\";i:38313;s:12:\"delete-39077\";i:38314;s:12:\"delete-39069\";i:38315;s:12:\"delete-39070\";i:38316;s:12:\"delete-39074\";i:38317;s:12:\"delete-39075\";i:38318;s:12:\"delete-39078\";i:38319;s:12:\"delete-39081\";i:38320;s:12:\"delete-39079\";i:38321;s:12:\"delete-39080\";i:38322;s:12:\"delete-39082\";i:38323;s:12:\"delete-39083\";i:38324;s:12:\"delete-39086\";i:38325;s:12:\"delete-39087\";i:38326;s:12:\"delete-39088\";i:38327;s:12:\"delete-39091\";i:38328;s:12:\"delete-39092\";i:38329;s:12:\"delete-39084\";i:38330;s:12:\"delete-39085\";i:38331;s:12:\"delete-39089\";i:38332;s:12:\"delete-39090\";i:38333;s:12:\"delete-39093\";i:38334;s:12:\"delete-39096\";i:38335;s:12:\"delete-39094\";i:38336;s:12:\"delete-39095\";i:38337;s:12:\"delete-39097\";i:38338;s:12:\"delete-39098\";i:38339;s:12:\"delete-39101\";i:38340;s:12:\"delete-39102\";i:38341;s:12:\"delete-39099\";i:38342;s:12:\"delete-39100\";i:38343;s:12:\"delete-39103\";i:38344;s:12:\"delete-39106\";i:38345;s:12:\"delete-39104\";i:38346;s:12:\"delete-39105\";i:38347;s:12:\"delete-39107\";i:38348;s:12:\"delete-39108\";i:38349;s:12:\"delete-39111\";i:38350;s:12:\"delete-39109\";i:38351;s:12:\"delete-39110\";i:38352;s:12:\"delete-39112\";i:38353;s:12:\"delete-39115\";i:38354;s:12:\"delete-39116\";i:38355;s:12:\"delete-39113\";i:38356;s:12:\"delete-39114\";i:38357;s:12:\"delete-39117\";i:38358;s:12:\"delete-39120\";i:38359;s:12:\"delete-39121\";i:38360;s:12:\"delete-39118\";i:38361;s:12:\"delete-39119\";i:38362;s:12:\"delete-39122\";i:38363;s:12:\"delete-39125\";i:38364;s:12:\"delete-39126\";i:38365;s:12:\"delete-39123\";i:38366;s:12:\"delete-39124\";i:38367;s:12:\"delete-39127\";i:38368;s:12:\"delete-39130\";i:38369;s:12:\"delete-39131\";i:38370;s:12:\"delete-39128\";i:38371;s:12:\"delete-39129\";i:38372;s:12:\"delete-39132\";i:38373;s:12:\"delete-39135\";i:38374;s:12:\"delete-39136\";i:38375;s:12:\"delete-39133\";i:38376;s:12:\"delete-39134\";i:38377;s:12:\"delete-39137\";i:38378;s:12:\"delete-39140\";i:38379;s:12:\"delete-39141\";i:38380;s:12:\"delete-39138\";i:38381;s:12:\"delete-39139\";i:38382;s:12:\"delete-39142\";i:38383;s:12:\"delete-39145\";i:38384;s:12:\"delete-39143\";i:38385;s:12:\"delete-39144\";i:38386;s:12:\"delete-39146\";i:38387;s:12:\"delete-39147\";i:38388;s:12:\"delete-39150\";i:38389;s:12:\"delete-39151\";i:38390;s:12:\"delete-39148\";i:38391;s:12:\"delete-39149\";i:38392;s:12:\"delete-39152\";i:38393;s:12:\"delete-39155\";i:38394;s:12:\"delete-39156\";i:38395;s:12:\"delete-39153\";i:38396;s:12:\"delete-39154\";i:38397;s:12:\"delete-39157\";i:38398;s:12:\"delete-39158\";i:38399;s:12:\"delete-39159\";i:38400;s:12:\"delete-39160\";i:38401;s:12:\"delete-39161\";i:38402;s:12:\"delete-39162\";i:38403;s:12:\"delete-39165\";i:38404;s:12:\"delete-39166\";i:38405;s:12:\"delete-39163\";i:38406;s:12:\"delete-39164\";i:38407;s:12:\"delete-39167\";i:38408;s:12:\"delete-39171\";i:38409;s:12:\"delete-39170\";i:38410;s:12:\"delete-39168\";i:38411;s:12:\"delete-39169\";i:38412;s:12:\"delete-39172\";i:38413;s:12:\"delete-39175\";i:38414;s:12:\"delete-39176\";i:38415;s:12:\"delete-39173\";i:38416;s:12:\"delete-39174\";i:38417;s:12:\"delete-39177\";i:38418;s:12:\"delete-39180\";i:38419;s:12:\"delete-39181\";i:38420;s:12:\"delete-39178\";i:38421;s:12:\"delete-39179\";i:38422;s:12:\"delete-39182\";i:38423;s:12:\"delete-39185\";i:38424;s:12:\"delete-39186\";i:38425;s:12:\"delete-39183\";i:38426;s:12:\"delete-39184\";i:38427;s:12:\"delete-39187\";i:38428;s:12:\"delete-39190\";i:38429;s:12:\"delete-39188\";i:38430;s:12:\"delete-39189\";i:38431;s:12:\"delete-39191\";i:38432;s:12:\"delete-39192\";i:38433;s:12:\"delete-39195\";i:38434;s:12:\"delete-39196\";i:38435;s:12:\"delete-39193\";i:38436;s:12:\"delete-39194\";i:38437;s:12:\"delete-39197\";i:38438;s:12:\"delete-39201\";i:38439;s:12:\"delete-39200\";i:38440;s:12:\"delete-39198\";i:38441;s:12:\"delete-39199\";i:38442;s:12:\"delete-39202\";i:38443;s:12:\"delete-39205\";i:38444;s:12:\"delete-39203\";i:38445;s:12:\"delete-39204\";i:38446;s:12:\"delete-39206\";i:38447;s:12:\"delete-39207\";i:38448;s:12:\"delete-39210\";i:38449;s:12:\"delete-39211\";i:38450;s:12:\"delete-39212\";i:38451;s:12:\"delete-39215\";i:38452;s:12:\"delete-39216\";i:38453;s:12:\"delete-39208\";i:38454;s:12:\"delete-39209\";i:38455;s:12:\"delete-39213\";i:38456;s:12:\"delete-39214\";i:38457;s:12:\"delete-39217\";i:38458;s:12:\"delete-39220\";i:38459;s:12:\"delete-39221\";i:38460;s:12:\"delete-39218\";i:38461;s:12:\"delete-39219\";i:38462;s:12:\"delete-39222\";i:38463;s:12:\"delete-39225\";i:38464;s:12:\"delete-39226\";i:38465;s:12:\"delete-39223\";i:38466;s:12:\"delete-39224\";i:38467;s:12:\"delete-39227\";i:38468;s:12:\"delete-39231\";i:38469;s:12:\"delete-39230\";i:38470;s:12:\"delete-39228\";i:38471;s:12:\"delete-39229\";i:38472;s:12:\"delete-39232\";i:38473;s:12:\"delete-39235\";i:38474;s:12:\"delete-39236\";i:38475;s:12:\"delete-39233\";i:38476;s:12:\"delete-39234\";i:38477;s:12:\"delete-39237\";i:38478;s:12:\"delete-39238\";i:38479;s:12:\"delete-39239\";i:38480;s:12:\"delete-39240\";i:38481;s:12:\"delete-39241\";i:38482;s:12:\"delete-39242\";i:38483;s:12:\"delete-39245\";i:38484;s:12:\"delete-39243\";i:38485;s:12:\"delete-39244\";i:38486;s:12:\"delete-39246\";i:38487;s:12:\"delete-39247\";i:38488;s:12:\"delete-39250\";i:38489;s:12:\"delete-39248\";i:38490;s:12:\"delete-39249\";i:38491;s:12:\"delete-39251\";i:38492;s:12:\"delete-39252\";i:38493;s:12:\"delete-39255\";i:38494;s:12:\"delete-39256\";i:38495;s:12:\"delete-39257\";i:38496;s:12:\"delete-39260\";i:38497;s:12:\"delete-39253\";i:38498;s:12:\"delete-39254\";i:38499;s:12:\"delete-39258\";i:38500;s:12:\"delete-39259\";i:38501;s:12:\"delete-39261\";i:38502;s:12:\"delete-39262\";i:38503;s:12:\"delete-39265\";i:38504;s:12:\"delete-39266\";i:38505;s:12:\"delete-39263\";i:38506;s:12:\"delete-39264\";i:38507;s:12:\"delete-39267\";i:38508;s:12:\"delete-39270\";i:38509;s:12:\"delete-39271\";i:38510;s:12:\"delete-39268\";i:38511;s:12:\"delete-39269\";i:38512;s:12:\"delete-39272\";i:38513;s:12:\"delete-39275\";i:38514;s:12:\"delete-39273\";i:38515;s:12:\"delete-39274\";i:38516;s:12:\"delete-39276\";i:38517;s:12:\"delete-39277\";i:38518;s:12:\"delete-39280\";i:38519;s:12:\"delete-39281\";i:38520;s:12:\"delete-39278\";i:38521;s:12:\"delete-39279\";i:38522;s:12:\"delete-39282\";i:38523;s:12:\"delete-39285\";i:38524;s:12:\"delete-39286\";i:38525;s:12:\"delete-39283\";i:38526;s:12:\"delete-39284\";i:38527;s:12:\"delete-39287\";i:38528;s:12:\"delete-39290\";i:38529;s:12:\"delete-39291\";i:38530;s:12:\"delete-39288\";i:38531;s:12:\"delete-39289\";i:38532;s:12:\"delete-39292\";i:38533;s:12:\"delete-39295\";i:38534;s:12:\"delete-39296\";i:38535;s:12:\"delete-39293\";i:38536;s:12:\"delete-39294\";i:38537;s:12:\"delete-39297\";i:38538;s:12:\"delete-39300\";i:38539;s:12:\"delete-39301\";i:38540;s:12:\"delete-39298\";i:38541;s:12:\"delete-39299\";i:38542;s:12:\"delete-39302\";i:38543;s:12:\"delete-39305\";i:38544;s:12:\"delete-39306\";i:38545;s:12:\"delete-39303\";i:38546;s:12:\"delete-39304\";i:38547;s:12:\"delete-39307\";i:38548;s:12:\"delete-39310\";i:38549;s:12:\"delete-39311\";i:38550;s:12:\"delete-39308\";i:38551;s:12:\"delete-39309\";i:38552;s:12:\"delete-39312\";i:38553;s:12:\"delete-39315\";i:38554;s:12:\"delete-39316\";i:38555;s:12:\"delete-39313\";i:38556;s:12:\"delete-39314\";i:38557;s:12:\"delete-39317\";i:38558;s:12:\"delete-39320\";i:38559;s:12:\"delete-39321\";i:38560;s:12:\"delete-39318\";i:38561;s:12:\"delete-39319\";i:38562;s:12:\"delete-39322\";i:38563;s:12:\"delete-39325\";i:38564;s:12:\"delete-39326\";i:38565;s:12:\"delete-39323\";i:38566;s:12:\"delete-39324\";i:38567;s:12:\"delete-39327\";i:38568;s:12:\"delete-39330\";i:38569;s:12:\"delete-39331\";i:38570;s:12:\"delete-39328\";i:38571;s:12:\"delete-39329\";i:38572;s:12:\"delete-39332\";i:38573;s:12:\"delete-39333\";i:38574;s:12:\"delete-39334\";i:38575;s:12:\"delete-39335\";i:38576;s:12:\"delete-39336\";i:38577;s:12:\"delete-39337\";i:38578;s:12:\"delete-39338\";i:38579;s:12:\"delete-39339\";i:38580;s:12:\"delete-39340\";i:38581;s:12:\"delete-39341\";i:38582;s:12:\"delete-39342\";i:38583;s:12:\"delete-39343\";i:38584;s:12:\"delete-39344\";i:38585;s:12:\"delete-39345\";i:38586;s:12:\"delete-39346\";i:38587;s:12:\"delete-39347\";i:38588;s:12:\"delete-39350\";i:38589;s:12:\"delete-39351\";i:38590;s:12:\"delete-39348\";i:38591;s:12:\"delete-39349\";i:38592;s:12:\"delete-39352\";i:38593;s:12:\"delete-39353\";i:38594;s:12:\"delete-39354\";i:38595;s:12:\"delete-39355\";i:38596;s:12:\"delete-39356\";i:38597;s:12:\"delete-39357\";i:38598;s:12:\"delete-39360\";i:38599;s:12:\"delete-39361\";i:38600;s:12:\"delete-39358\";i:38601;s:12:\"delete-39359\";i:38602;s:12:\"delete-39362\";i:38603;s:12:\"delete-39365\";i:38604;s:12:\"delete-39366\";i:38605;s:12:\"delete-39367\";i:38606;s:12:\"delete-39370\";i:38607;s:12:\"delete-39371\";i:38608;s:12:\"delete-39363\";i:38609;s:12:\"delete-39364\";i:38610;s:12:\"delete-39368\";i:38611;s:12:\"delete-39369\";i:38612;s:12:\"delete-39372\";i:38613;s:12:\"delete-39375\";i:38614;s:12:\"delete-39376\";i:38615;s:12:\"delete-39377\";i:38616;s:12:\"delete-39380\";i:38617;s:12:\"delete-39381\";i:38618;s:12:\"delete-39373\";i:38619;s:12:\"delete-39374\";i:38620;s:12:\"delete-39378\";i:38621;s:12:\"delete-39379\";i:38622;s:12:\"delete-39382\";i:38623;s:12:\"delete-39385\";i:38624;s:12:\"delete-39386\";i:38625;s:12:\"delete-39383\";i:38626;s:12:\"delete-39384\";i:38627;s:12:\"delete-39387\";i:38628;s:12:\"delete-39390\";i:38629;s:12:\"delete-39388\";i:38630;s:12:\"delete-39389\";i:38631;s:12:\"delete-39391\";i:38632;s:12:\"delete-39392\";i:38633;s:12:\"delete-39395\";i:38634;s:12:\"delete-39396\";i:38635;s:12:\"delete-39393\";i:38636;s:12:\"delete-39394\";i:38637;s:12:\"delete-39397\";i:38638;s:12:\"delete-39400\";i:38639;s:12:\"delete-39401\";i:38640;s:12:\"delete-39398\";i:38641;s:12:\"delete-39399\";i:38642;s:12:\"delete-39402\";i:38643;s:12:\"delete-39405\";i:38644;s:12:\"delete-39406\";i:38645;s:12:\"delete-39403\";i:38646;s:12:\"delete-39404\";i:38647;s:12:\"delete-39407\";i:38648;s:12:\"delete-39408\";i:38649;s:12:\"delete-39409\";i:38650;s:12:\"delete-39410\";i:38651;s:12:\"delete-39411\";i:38652;s:12:\"delete-39412\";i:38653;s:12:\"delete-39415\";i:38654;s:12:\"delete-39416\";i:38655;s:12:\"delete-39413\";i:38656;s:12:\"delete-39414\";i:38657;s:12:\"delete-39417\";i:38658;s:12:\"delete-39420\";i:38659;s:12:\"delete-39421\";i:38660;s:12:\"delete-39418\";i:38661;s:12:\"delete-39419\";i:38662;s:12:\"delete-39422\";i:38663;s:12:\"delete-39425\";i:38664;s:12:\"delete-39426\";i:38665;s:12:\"delete-39423\";i:38666;s:12:\"delete-39424\";i:38667;s:12:\"delete-39427\";i:38668;s:12:\"delete-39430\";i:38669;s:12:\"delete-39431\";i:38670;s:12:\"delete-39428\";i:38671;s:12:\"delete-39429\";i:38672;s:12:\"delete-39432\";i:38673;s:12:\"delete-39435\";i:38674;s:12:\"delete-39436\";i:38675;s:12:\"delete-39433\";i:38676;s:12:\"delete-39434\";i:38677;s:12:\"delete-39437\";i:38678;s:12:\"delete-39440\";i:38679;s:12:\"delete-39441\";i:38680;s:12:\"delete-39438\";i:38681;s:12:\"delete-39439\";i:38682;s:12:\"delete-39442\";i:38683;s:12:\"delete-39445\";i:38684;s:12:\"delete-39446\";i:38685;s:12:\"delete-39443\";i:38686;s:12:\"delete-39444\";i:38687;s:12:\"delete-39447\";i:38688;s:12:\"delete-39450\";i:38689;s:12:\"delete-39451\";i:38690;s:12:\"delete-39448\";i:38691;s:12:\"delete-39449\";i:38692;s:12:\"delete-39452\";i:38693;s:12:\"delete-39455\";i:38694;s:12:\"delete-39456\";i:38695;s:12:\"delete-39453\";i:38696;s:12:\"delete-39454\";i:38697;s:12:\"delete-39457\";i:38698;s:12:\"delete-39460\";i:38699;s:12:\"delete-39461\";i:38700;s:12:\"delete-39458\";i:38701;s:12:\"delete-39459\";i:38702;s:12:\"delete-39462\";i:38703;s:12:\"delete-39465\";i:38704;s:12:\"delete-39463\";i:38705;s:12:\"delete-39464\";i:38706;s:12:\"delete-39466\";i:38707;s:12:\"delete-39467\";i:38708;s:12:\"delete-39470\";i:38709;s:12:\"delete-39471\";i:38710;s:12:\"delete-39468\";i:38711;s:12:\"delete-39469\";i:38712;s:12:\"delete-39472\";i:38713;s:12:\"delete-39475\";i:38714;s:12:\"delete-39476\";i:38715;s:12:\"delete-39473\";i:38716;s:12:\"delete-39474\";i:38717;s:12:\"delete-39477\";i:38718;s:12:\"delete-39480\";i:38719;s:12:\"delete-39478\";i:38720;s:12:\"delete-39479\";i:38721;s:12:\"delete-39481\";i:38722;s:12:\"delete-39482\";i:38723;s:12:\"delete-39485\";i:38724;s:12:\"delete-39486\";i:38725;s:12:\"delete-39483\";i:38726;s:12:\"delete-39484\";i:38727;s:12:\"delete-39487\";i:38728;s:12:\"delete-39490\";i:38729;s:12:\"delete-39488\";i:38730;s:12:\"delete-39489\";i:38731;s:12:\"delete-39491\";i:38732;s:12:\"delete-39492\";i:38733;s:12:\"delete-39495\";i:38734;s:12:\"delete-39493\";i:38735;s:12:\"delete-39494\";i:38736;s:12:\"delete-39496\";i:38737;s:12:\"delete-39497\";i:38738;s:12:\"delete-39500\";i:38739;s:12:\"delete-39501\";i:38740;s:12:\"delete-39498\";i:38741;s:12:\"delete-39499\";i:38742;s:12:\"delete-39502\";i:38743;s:12:\"delete-39505\";i:38744;s:12:\"delete-39506\";i:38745;s:12:\"delete-39503\";i:38746;s:12:\"delete-39504\";i:38747;s:12:\"delete-39507\";i:38748;s:12:\"delete-39510\";i:38749;s:12:\"delete-39511\";i:38750;s:12:\"delete-39508\";i:38751;s:12:\"delete-39509\";i:38752;s:12:\"delete-39512\";i:38753;s:12:\"delete-39515\";i:38754;s:12:\"delete-39516\";i:38755;s:12:\"delete-39513\";i:38756;s:12:\"delete-39514\";i:38757;s:12:\"delete-39517\";i:38758;s:12:\"delete-39520\";i:38759;s:12:\"delete-39518\";i:38760;s:12:\"delete-39519\";i:38761;s:12:\"delete-39521\";i:38762;s:12:\"delete-39522\";i:38763;s:12:\"delete-39525\";i:38764;s:12:\"delete-39523\";i:38765;s:12:\"delete-39524\";i:38766;s:12:\"delete-39526\";i:38767;s:12:\"delete-39527\";i:38768;s:12:\"delete-39530\";i:38769;s:12:\"delete-39531\";i:38770;s:12:\"delete-39528\";i:38771;s:12:\"delete-39529\";i:38772;s:12:\"delete-39532\";i:38773;s:12:\"delete-39535\";i:38774;s:12:\"delete-39536\";i:38775;s:12:\"delete-39533\";i:38776;s:12:\"delete-39534\";i:38777;s:12:\"delete-39537\";i:38778;s:12:\"delete-39540\";i:38779;s:12:\"delete-39541\";i:38780;s:12:\"delete-39538\";i:38781;s:12:\"delete-39539\";i:38782;s:12:\"delete-39542\";i:38783;s:12:\"delete-39545\";i:38784;s:12:\"delete-39546\";i:38785;s:12:\"delete-39543\";i:38786;s:12:\"delete-39544\";i:38787;s:12:\"delete-39547\";i:38788;s:12:\"delete-39550\";i:38789;s:12:\"delete-39551\";i:38790;s:12:\"delete-39548\";i:38791;s:12:\"delete-39549\";i:38792;s:12:\"delete-39552\";i:38793;s:12:\"delete-39555\";i:38794;s:12:\"delete-39556\";i:38795;s:12:\"delete-39553\";i:38796;s:12:\"delete-39554\";i:38797;s:12:\"delete-39557\";i:38798;s:12:\"delete-39560\";i:38799;s:12:\"delete-39561\";i:38800;s:12:\"delete-39558\";i:38801;s:12:\"delete-39559\";i:38802;s:12:\"delete-39562\";i:38803;s:12:\"delete-39565\";i:38804;s:12:\"delete-39566\";i:38805;s:12:\"delete-39563\";i:38806;s:12:\"delete-39564\";i:38807;s:12:\"delete-39567\";i:38808;s:12:\"delete-39570\";i:38809;s:12:\"delete-39571\";i:38810;s:12:\"delete-39568\";i:38811;s:12:\"delete-39569\";i:38812;s:12:\"delete-39572\";i:38813;s:12:\"delete-39575\";i:38814;s:12:\"delete-39573\";i:38815;s:12:\"delete-39574\";i:38816;s:12:\"delete-39576\";i:38817;s:12:\"delete-39577\";i:38818;s:12:\"delete-39580\";i:38819;s:12:\"delete-39581\";i:38820;s:12:\"delete-39578\";i:38821;s:12:\"delete-39579\";i:38822;s:12:\"delete-39582\";i:38823;s:12:\"delete-39585\";i:38824;s:12:\"delete-39586\";i:38825;s:12:\"delete-39583\";i:38826;s:12:\"delete-39584\";i:38827;s:12:\"delete-39587\";i:38828;s:12:\"delete-39590\";i:38829;s:12:\"delete-39591\";i:38830;s:12:\"delete-39588\";i:38831;s:12:\"delete-39589\";i:38832;s:12:\"delete-39592\";i:38833;s:12:\"delete-39595\";i:38834;s:12:\"delete-39596\";i:38835;s:12:\"delete-39593\";i:38836;s:12:\"delete-39594\";i:38837;s:12:\"delete-39597\";i:38838;s:12:\"delete-39600\";i:38839;s:12:\"delete-39601\";i:38840;s:12:\"delete-39598\";i:38841;s:12:\"delete-39599\";i:38842;s:12:\"delete-39602\";i:38843;s:12:\"delete-39605\";i:38844;s:12:\"delete-39606\";i:38845;s:12:\"delete-39603\";i:38846;s:12:\"delete-39604\";i:38847;s:12:\"delete-39607\";i:38848;s:12:\"delete-39610\";i:38849;s:12:\"delete-39608\";i:38850;s:12:\"delete-39609\";i:38851;s:12:\"delete-39611\";i:38852;s:12:\"delete-39612\";i:38853;s:12:\"delete-39615\";i:38854;s:12:\"delete-39613\";i:38855;s:12:\"delete-39614\";i:38856;s:12:\"delete-39616\";i:38857;s:12:\"delete-39617\";i:38858;s:12:\"delete-39620\";i:38859;s:12:\"delete-39621\";i:38860;s:12:\"delete-39618\";i:38861;s:12:\"delete-39619\";i:38862;s:12:\"delete-39622\";i:38863;s:12:\"delete-39625\";i:38864;s:12:\"delete-39626\";i:38865;s:12:\"delete-39623\";i:38866;s:12:\"delete-39624\";i:38867;s:12:\"delete-39627\";i:38868;s:12:\"delete-39630\";i:38869;s:12:\"delete-39631\";i:38870;s:12:\"delete-39628\";i:38871;s:12:\"delete-39629\";i:38872;s:12:\"delete-39632\";i:38873;s:12:\"delete-39635\";i:38874;s:12:\"delete-39636\";i:38875;s:12:\"delete-39633\";i:38876;s:12:\"delete-39634\";i:38877;s:12:\"delete-39637\";i:38878;s:12:\"delete-39640\";i:38879;s:12:\"delete-39638\";i:38880;s:12:\"delete-39639\";i:38881;s:12:\"delete-39641\";i:38882;s:12:\"delete-39642\";i:38883;s:12:\"delete-39645\";i:38884;s:12:\"delete-39646\";i:38885;s:12:\"delete-39643\";i:38886;s:12:\"delete-39644\";i:38887;s:12:\"delete-39647\";i:38888;s:12:\"delete-39650\";i:38889;s:12:\"delete-39651\";i:38890;s:12:\"delete-39648\";i:38891;s:12:\"delete-39649\";i:38892;s:12:\"delete-39652\";i:38893;s:12:\"delete-39655\";i:38894;s:12:\"delete-39656\";i:38895;s:12:\"delete-39653\";i:38896;s:12:\"delete-39654\";i:38897;s:12:\"delete-39657\";i:38898;s:12:\"delete-39660\";i:38899;s:12:\"delete-39661\";i:38900;s:12:\"delete-39658\";i:38901;s:12:\"delete-39659\";i:38902;s:12:\"delete-39662\";i:38903;s:12:\"delete-39665\";i:38904;s:12:\"delete-39666\";i:38905;s:12:\"delete-39663\";i:38906;s:12:\"delete-39664\";i:38907;s:12:\"delete-39667\";i:38908;s:12:\"delete-39670\";i:38909;s:12:\"delete-39668\";i:38910;s:12:\"delete-39669\";i:38911;s:12:\"delete-39671\";i:38912;s:12:\"delete-39672\";i:38913;s:12:\"delete-39675\";i:38914;s:12:\"delete-39676\";i:38915;s:12:\"delete-39673\";i:38916;s:12:\"delete-39674\";i:38917;s:12:\"delete-39677\";i:38918;s:12:\"delete-39680\";i:38919;s:12:\"delete-39678\";i:38920;s:12:\"delete-39679\";i:38921;s:12:\"delete-39681\";i:38922;s:12:\"delete-39682\";i:38923;s:12:\"delete-39685\";i:38924;s:12:\"delete-39686\";i:38925;s:12:\"delete-39687\";i:38926;s:12:\"delete-39690\";i:38927;s:12:\"delete-39691\";i:38928;s:12:\"delete-39683\";i:38929;s:12:\"delete-39684\";i:38930;s:12:\"delete-39688\";i:38931;s:12:\"delete-39689\";i:38932;s:12:\"delete-39692\";i:38933;s:12:\"delete-39693\";i:38934;s:12:\"delete-39694\";i:38935;s:12:\"delete-39695\";i:38936;s:12:\"delete-39696\";i:38937;s:12:\"delete-39697\";i:38938;s:12:\"delete-39700\";i:38939;s:12:\"delete-39701\";i:38940;s:12:\"delete-39698\";i:38941;s:12:\"delete-39699\";i:38942;s:12:\"delete-39702\";i:38943;s:12:\"delete-39705\";i:38944;s:12:\"delete-39706\";i:38945;s:12:\"delete-39703\";i:38946;s:12:\"delete-39704\";i:38947;s:12:\"delete-39707\";i:38948;s:12:\"delete-39708\";i:38949;s:12:\"delete-39709\";i:38950;s:12:\"delete-39710\";i:38951;s:12:\"delete-39711\";i:38952;s:12:\"delete-39712\";i:38953;s:12:\"delete-39715\";i:38954;s:12:\"delete-39716\";i:38955;s:12:\"delete-39713\";i:38956;s:12:\"delete-39714\";i:38957;s:12:\"delete-39717\";i:38958;s:12:\"delete-39720\";i:38959;s:12:\"delete-39721\";i:38960;s:12:\"delete-39718\";i:38961;s:12:\"delete-39719\";i:38962;s:12:\"delete-39722\";i:38963;s:12:\"delete-39725\";i:38964;s:12:\"delete-39726\";i:38965;s:12:\"delete-39723\";i:38966;s:12:\"delete-39724\";i:38967;s:12:\"delete-39727\";i:38968;s:12:\"delete-39730\";i:38969;s:12:\"delete-39731\";i:38970;s:12:\"delete-39728\";i:38971;s:12:\"delete-39729\";i:38972;s:12:\"delete-39732\";i:38973;s:12:\"delete-39733\";i:38974;s:12:\"delete-39734\";i:38975;s:12:\"delete-39735\";i:38976;s:12:\"delete-39736\";i:38977;s:12:\"delete-39737\";i:38978;s:12:\"delete-39740\";i:38979;s:12:\"delete-39741\";i:38980;s:12:\"delete-39738\";i:38981;s:12:\"delete-39739\";i:38982;s:12:\"delete-39742\";i:38983;s:12:\"delete-39745\";i:38984;s:12:\"delete-39746\";i:38985;s:12:\"delete-39743\";i:38986;s:12:\"delete-39744\";i:38987;s:12:\"delete-39747\";i:38988;s:12:\"delete-39748\";i:38989;s:12:\"delete-39749\";i:38990;s:12:\"delete-39750\";i:38991;s:12:\"delete-39751\";i:38992;s:12:\"delete-39752\";i:38993;s:12:\"delete-39755\";i:38994;s:12:\"delete-39753\";i:38995;s:12:\"delete-39754\";i:38996;s:12:\"delete-39756\";i:38997;s:12:\"delete-39757\";i:38998;s:12:\"delete-39760\";i:38999;s:12:\"delete-39761\";i:39000;s:12:\"delete-39758\";i:39001;s:12:\"delete-39759\";i:39002;s:12:\"delete-39762\";i:39003;s:12:\"delete-39765\";i:39004;s:12:\"delete-39766\";i:39005;s:12:\"delete-39763\";i:39006;s:12:\"delete-39764\";i:39007;s:12:\"delete-39767\";i:39008;s:12:\"delete-39770\";i:39009;s:12:\"delete-39771\";i:39010;s:12:\"delete-39768\";i:39011;s:12:\"delete-39769\";i:39012;s:12:\"delete-39772\";i:39013;s:12:\"delete-39775\";i:39014;s:12:\"delete-39776\";i:39015;s:12:\"delete-39773\";i:39016;s:12:\"delete-39774\";i:39017;s:12:\"delete-39777\";i:39018;s:12:\"delete-39780\";i:39019;s:12:\"delete-39781\";i:39020;s:12:\"delete-39778\";i:39021;s:12:\"delete-39779\";i:39022;s:12:\"delete-39782\";i:39023;s:12:\"delete-39785\";i:39024;s:12:\"delete-39786\";i:39025;s:12:\"delete-39783\";i:39026;s:12:\"delete-39784\";i:39027;s:12:\"delete-39787\";i:39028;s:12:\"delete-39790\";i:39029;s:12:\"delete-39788\";i:39030;s:12:\"delete-39789\";i:39031;s:12:\"delete-39791\";i:39032;s:12:\"delete-39792\";i:39033;s:12:\"delete-39795\";i:39034;s:12:\"delete-39796\";i:39035;s:12:\"delete-39793\";i:39036;s:12:\"delete-39794\";i:39037;s:12:\"delete-39797\";i:39038;s:12:\"delete-39800\";i:39039;s:12:\"delete-39801\";i:39040;s:12:\"delete-39798\";i:39041;s:12:\"delete-39799\";i:39042;s:12:\"delete-39802\";i:39043;s:12:\"delete-39805\";i:39044;s:12:\"delete-39806\";i:39045;s:12:\"delete-39803\";i:39046;s:12:\"delete-39804\";i:39047;s:12:\"delete-39807\";i:39048;s:12:\"delete-39810\";i:39049;s:12:\"delete-39811\";i:39050;s:12:\"delete-39808\";i:39051;s:12:\"delete-39809\";i:39052;s:12:\"delete-39812\";i:39053;s:12:\"delete-39815\";i:39054;s:12:\"delete-39813\";i:39055;s:12:\"delete-39814\";i:39056;s:12:\"delete-39816\";i:39057;s:12:\"delete-39817\";i:39058;s:12:\"delete-39820\";i:39059;s:12:\"delete-39821\";i:39060;s:12:\"delete-39818\";i:39061;s:12:\"delete-39819\";i:39062;s:12:\"delete-39822\";i:39063;s:12:\"delete-39825\";i:39064;s:12:\"delete-39826\";i:39065;s:12:\"delete-39823\";i:39066;s:12:\"delete-39824\";i:39067;s:12:\"delete-39827\";i:39068;s:12:\"delete-39830\";i:39069;s:12:\"delete-39831\";i:39070;s:12:\"delete-39828\";i:39071;s:12:\"delete-39829\";i:39072;s:12:\"delete-39832\";i:39073;s:12:\"delete-39835\";i:39074;s:12:\"delete-39836\";i:39075;s:12:\"delete-39833\";i:39076;s:12:\"delete-39834\";i:39077;s:12:\"delete-39837\";i:39078;s:12:\"delete-39840\";i:39079;s:12:\"delete-39838\";i:39080;s:12:\"delete-39839\";i:39081;s:12:\"delete-39841\";i:39082;s:12:\"delete-39842\";i:39083;s:12:\"delete-39843\";i:39084;s:12:\"delete-39844\";i:39085;s:12:\"delete-39845\";i:39086;s:12:\"delete-39846\";i:39087;s:12:\"delete-39847\";i:39088;s:12:\"delete-39850\";i:39089;s:12:\"delete-39851\";i:39090;s:12:\"delete-39848\";i:39091;s:12:\"delete-39849\";i:39092;s:12:\"delete-39852\";i:39093;s:12:\"delete-39855\";i:39094;s:12:\"delete-39853\";i:39095;s:12:\"delete-39854\";i:39096;s:12:\"delete-39856\";i:39097;s:12:\"delete-39857\";i:39098;s:12:\"delete-39860\";i:39099;s:12:\"delete-39861\";i:39100;s:12:\"delete-39858\";i:39101;s:12:\"delete-39859\";i:39102;s:12:\"delete-39862\";i:39103;s:12:\"delete-39865\";i:39104;s:12:\"delete-39866\";i:39105;s:12:\"delete-39863\";i:39106;s:12:\"delete-39864\";i:39107;s:12:\"delete-39867\";i:39108;s:12:\"delete-39870\";i:39109;s:12:\"delete-39871\";i:39110;s:12:\"delete-39868\";i:39111;s:12:\"delete-39869\";i:39112;s:12:\"delete-39872\";i:39113;s:12:\"delete-39875\";i:39114;s:12:\"delete-39876\";i:39115;s:12:\"delete-39873\";i:39116;s:12:\"delete-39874\";i:39117;s:12:\"delete-39877\";i:39118;s:12:\"delete-39878\";i:39119;s:12:\"delete-39879\";i:39120;s:12:\"delete-39880\";i:39121;s:12:\"delete-39881\";i:39122;s:12:\"delete-39882\";i:39123;s:12:\"delete-39885\";i:39124;s:12:\"delete-39883\";i:39125;s:12:\"delete-39884\";i:39126;s:12:\"delete-39886\";i:39127;s:12:\"delete-39887\";i:39128;s:12:\"delete-39888\";i:39129;s:12:\"delete-39889\";i:39130;s:12:\"delete-39890\";i:39131;s:12:\"delete-39891\";i:39132;s:12:\"delete-39892\";i:39133;s:12:\"delete-39895\";i:39134;s:12:\"delete-39896\";i:39135;s:12:\"delete-39893\";i:39136;s:12:\"delete-39894\";i:39137;s:12:\"delete-39897\";i:39138;s:12:\"delete-39900\";i:39139;s:12:\"delete-39901\";i:39140;s:12:\"delete-39898\";i:39141;s:12:\"delete-39899\";i:39142;s:12:\"delete-39902\";i:39143;s:12:\"delete-39905\";i:39144;s:12:\"delete-39903\";i:39145;s:12:\"delete-39904\";i:39146;s:12:\"delete-39906\";i:39147;s:12:\"delete-39907\";i:39148;s:12:\"delete-39910\";i:39149;s:12:\"delete-39911\";i:39150;s:12:\"delete-39908\";i:39151;s:12:\"delete-39909\";i:39152;s:12:\"delete-39912\";i:39153;s:12:\"delete-39915\";i:39154;s:12:\"delete-39916\";i:39155;s:12:\"delete-39913\";i:39156;s:12:\"delete-39914\";i:39157;s:12:\"delete-39917\";i:39158;s:12:\"delete-39920\";i:39159;s:12:\"delete-39921\";i:39160;s:12:\"delete-39918\";i:39161;s:12:\"delete-39919\";i:39162;s:12:\"delete-39922\";i:39163;s:12:\"delete-39925\";i:39164;s:12:\"delete-39926\";i:39165;s:12:\"delete-39923\";i:39166;s:12:\"delete-39924\";i:39167;s:12:\"delete-39927\";i:39168;s:12:\"delete-39930\";i:39169;s:12:\"delete-39931\";i:39170;s:12:\"delete-39928\";i:39171;s:12:\"delete-39929\";i:39172;s:12:\"delete-39932\";i:39173;s:12:\"delete-39935\";i:39174;s:12:\"delete-39936\";i:39175;s:12:\"delete-39933\";i:39176;s:12:\"delete-39934\";i:39177;s:12:\"delete-39937\";i:39178;s:12:\"delete-39940\";i:39179;s:12:\"delete-39941\";i:39180;s:12:\"delete-39938\";i:39181;s:12:\"delete-39939\";i:39182;s:12:\"delete-39942\";i:39183;s:12:\"delete-39945\";i:39184;s:12:\"delete-39946\";i:39185;s:12:\"delete-39943\";i:39186;s:12:\"delete-39944\";i:39187;s:12:\"delete-39947\";i:39188;s:12:\"delete-39950\";i:39189;s:12:\"delete-39951\";i:39190;s:12:\"delete-39948\";i:39191;s:12:\"delete-39949\";i:39192;s:12:\"delete-39952\";i:39193;s:12:\"delete-39955\";i:39194;s:12:\"delete-39953\";i:39195;s:12:\"delete-39954\";i:39196;s:12:\"delete-39956\";i:39197;s:12:\"delete-39957\";i:39198;s:12:\"delete-39960\";i:39199;s:12:\"delete-39961\";i:39200;s:12:\"delete-39958\";i:39201;s:12:\"delete-39959\";i:39202;s:12:\"delete-39962\";i:39203;s:12:\"delete-39965\";i:39204;s:12:\"delete-39966\";i:39205;s:12:\"delete-39963\";i:39206;s:12:\"delete-39964\";i:39207;s:12:\"delete-39967\";i:39208;s:12:\"delete-39970\";i:39209;s:12:\"delete-39971\";i:39210;s:12:\"delete-39968\";i:39211;s:12:\"delete-39969\";i:39212;s:12:\"delete-39972\";i:39213;s:12:\"delete-39975\";i:39214;s:12:\"delete-39976\";i:39215;s:12:\"delete-39973\";i:39216;s:12:\"delete-39974\";i:39217;s:12:\"delete-39977\";i:39218;s:12:\"delete-39978\";i:39219;s:12:\"delete-39979\";i:39220;s:12:\"delete-39980\";i:39221;s:12:\"delete-39981\";i:39222;s:12:\"delete-39982\";i:39223;s:12:\"delete-39985\";i:39224;s:12:\"delete-39986\";i:39225;s:12:\"delete-39983\";i:39226;s:12:\"delete-39984\";i:39227;s:12:\"delete-39987\";i:39228;s:12:\"delete-39990\";i:39229;s:12:\"delete-39991\";i:39230;s:12:\"delete-39988\";i:39231;s:12:\"delete-39989\";i:39232;s:12:\"delete-39992\";i:39233;s:12:\"delete-39995\";i:39234;s:12:\"delete-39996\";i:39235;s:12:\"delete-39993\";i:39236;s:12:\"delete-39994\";i:39237;s:12:\"delete-39997\";i:39238;s:12:\"delete-40000\";i:39239;s:12:\"delete-40001\";i:39240;s:12:\"delete-39998\";i:39241;s:12:\"delete-39999\";i:39242;s:12:\"delete-40002\";i:39243;s:12:\"delete-40005\";i:39244;s:12:\"delete-40006\";i:39245;s:12:\"delete-40003\";i:39246;s:12:\"delete-40004\";i:39247;s:12:\"delete-40007\";i:39248;s:12:\"delete-40010\";i:39249;s:12:\"delete-40011\";i:39250;s:12:\"delete-40008\";i:39251;s:12:\"delete-40009\";i:39252;s:12:\"delete-40012\";i:39253;s:12:\"delete-40015\";i:39254;s:12:\"delete-40016\";i:39255;s:12:\"delete-40013\";i:39256;s:12:\"delete-40014\";i:39257;s:12:\"delete-40017\";i:39258;s:12:\"delete-40020\";i:39259;s:12:\"delete-40021\";i:39260;s:12:\"delete-40018\";i:39261;s:12:\"delete-40019\";i:39262;s:12:\"delete-40022\";i:39263;s:12:\"delete-40025\";i:39264;s:12:\"delete-40026\";i:39265;s:12:\"delete-40023\";i:39266;s:12:\"delete-40024\";i:39267;s:12:\"delete-40027\";i:39268;s:12:\"delete-40030\";i:39269;s:12:\"delete-40031\";i:39270;s:12:\"delete-40028\";i:39271;s:12:\"delete-40029\";i:39272;s:12:\"delete-40032\";i:39273;s:12:\"delete-40035\";i:39274;s:12:\"delete-40036\";i:39275;s:12:\"delete-40033\";i:39276;s:12:\"delete-40034\";i:39277;s:12:\"delete-40037\";i:39278;s:12:\"delete-40040\";i:39279;s:12:\"delete-40041\";i:39280;s:12:\"delete-40038\";i:39281;s:12:\"delete-40039\";i:39282;s:12:\"delete-40042\";i:39283;s:12:\"delete-40045\";i:39284;s:12:\"delete-40046\";i:39285;s:12:\"delete-40043\";i:39286;s:12:\"delete-40044\";i:39287;s:12:\"delete-40047\";i:39288;s:12:\"delete-40050\";i:39289;s:12:\"delete-40051\";i:39290;s:12:\"delete-40048\";i:39291;s:12:\"delete-40049\";i:39292;s:12:\"delete-40052\";i:39293;s:12:\"delete-40055\";i:39294;s:12:\"delete-40056\";i:39295;s:12:\"delete-40053\";i:39296;s:12:\"delete-40054\";i:39297;s:12:\"delete-40057\";i:39298;s:12:\"delete-40060\";i:39299;s:12:\"delete-40061\";i:39300;s:12:\"delete-40058\";i:39301;s:12:\"delete-40059\";i:39302;s:12:\"delete-40062\";i:39303;s:12:\"delete-40065\";i:39304;s:12:\"delete-40063\";i:39305;s:12:\"delete-40064\";i:39306;s:12:\"delete-40066\";i:39307;s:12:\"delete-40067\";i:39308;s:12:\"delete-40070\";i:39309;s:12:\"delete-40068\";i:39310;s:12:\"delete-40069\";i:39311;s:12:\"delete-40071\";i:39312;s:12:\"delete-40074\";i:39313;s:12:\"delete-40075\";i:39314;s:12:\"delete-40072\";i:39315;s:12:\"delete-40073\";i:39316;s:12:\"delete-40076\";i:39317;s:12:\"delete-40079\";i:39318;s:12:\"delete-40077\";i:39319;s:12:\"delete-40078\";i:39320;s:12:\"delete-40080\";i:39321;s:12:\"delete-40081\";i:39322;s:12:\"delete-40084\";i:39323;s:12:\"delete-40085\";i:39324;s:12:\"delete-40082\";i:39325;s:12:\"delete-40083\";i:39326;s:12:\"delete-40086\";i:39327;s:12:\"delete-40089\";i:39328;s:12:\"delete-40090\";i:39329;s:12:\"delete-40087\";i:39330;s:12:\"delete-40088\";i:39331;s:12:\"delete-40091\";i:39332;s:12:\"delete-40094\";i:39333;s:12:\"delete-40095\";i:39334;s:12:\"delete-40092\";i:39335;s:12:\"delete-40093\";i:39336;s:12:\"delete-40096\";i:39337;s:12:\"delete-40099\";i:39338;s:12:\"delete-40100\";i:39339;s:12:\"delete-40097\";i:39340;s:12:\"delete-40098\";i:39341;s:12:\"delete-40101\";i:39342;s:12:\"delete-40104\";i:39343;s:12:\"delete-40105\";i:39344;s:12:\"delete-40102\";i:39345;s:12:\"delete-40103\";i:39346;s:12:\"delete-40106\";i:39347;s:12:\"delete-40109\";i:39348;s:12:\"delete-40110\";i:39349;s:12:\"delete-40107\";i:39350;s:12:\"delete-40108\";i:39351;s:12:\"delete-40111\";i:39352;s:12:\"delete-40114\";i:39353;s:12:\"delete-40115\";i:39354;s:12:\"delete-40112\";i:39355;s:12:\"delete-40113\";i:39356;s:12:\"delete-40116\";i:39357;s:12:\"delete-40119\";i:39358;s:12:\"delete-40117\";i:39359;s:12:\"delete-40118\";i:39360;s:12:\"delete-40120\";i:39361;s:12:\"delete-40121\";i:39362;s:12:\"delete-40124\";i:39363;s:12:\"delete-40125\";i:39364;s:12:\"delete-40122\";i:39365;s:12:\"delete-40123\";i:39366;s:12:\"delete-40126\";i:39367;s:12:\"delete-40129\";i:39368;s:12:\"delete-40130\";i:39369;s:12:\"delete-40127\";i:39370;s:12:\"delete-40128\";i:39371;s:12:\"delete-40131\";i:39372;s:12:\"delete-40134\";i:39373;s:12:\"delete-40135\";i:39374;s:12:\"delete-40132\";i:39375;s:12:\"delete-40133\";i:39376;s:12:\"delete-40136\";i:39377;s:12:\"delete-40139\";i:39378;s:12:\"delete-40140\";i:39379;s:12:\"delete-40137\";i:39380;s:12:\"delete-40138\";i:39381;s:12:\"delete-40141\";i:39382;s:12:\"delete-40144\";i:39383;s:12:\"delete-40145\";i:39384;s:12:\"delete-40142\";i:39385;s:12:\"delete-40143\";i:39386;s:12:\"delete-40146\";i:39387;s:12:\"delete-40149\";i:39388;s:12:\"delete-40147\";i:39389;s:12:\"delete-40148\";i:39390;s:12:\"delete-40150\";i:39391;s:12:\"delete-40151\";i:39392;s:12:\"delete-40154\";i:39393;s:12:\"delete-40155\";i:39394;s:12:\"delete-40152\";i:39395;s:12:\"delete-40153\";i:39396;s:12:\"delete-40156\";i:39397;s:12:\"delete-40159\";i:39398;s:12:\"delete-40160\";i:39399;s:12:\"delete-40157\";i:39400;s:12:\"delete-40158\";i:39401;s:12:\"delete-40161\";i:39402;s:12:\"delete-40164\";i:39403;s:12:\"delete-40165\";i:39404;s:12:\"delete-40162\";i:39405;s:12:\"delete-40163\";i:39406;s:12:\"delete-40166\";i:39407;s:12:\"delete-40169\";i:39408;s:12:\"delete-40170\";i:39409;s:12:\"delete-40167\";i:39410;s:12:\"delete-40168\";i:39411;s:12:\"delete-40171\";i:39412;s:12:\"delete-40174\";i:39413;s:12:\"delete-40175\";i:39414;s:12:\"delete-40172\";i:39415;s:12:\"delete-40173\";i:39416;s:12:\"delete-40176\";i:39417;s:12:\"delete-40179\";i:39418;s:12:\"delete-40180\";i:39419;s:12:\"delete-40177\";i:39420;s:12:\"delete-40178\";i:39421;s:12:\"delete-40181\";i:39422;s:12:\"delete-40184\";i:39423;s:12:\"delete-40185\";i:39424;s:12:\"delete-40182\";i:39425;s:12:\"delete-40183\";i:39426;s:12:\"delete-40186\";i:39427;s:12:\"delete-40189\";i:39428;s:12:\"delete-40190\";i:39429;s:12:\"delete-40187\";i:39430;s:12:\"delete-40188\";i:39431;s:12:\"delete-40191\";i:39432;s:12:\"delete-40194\";i:39433;s:12:\"delete-40195\";i:39434;s:12:\"delete-40192\";i:39435;s:12:\"delete-40193\";i:39436;s:12:\"delete-40196\";i:39437;s:12:\"delete-40199\";i:39438;s:12:\"delete-40197\";i:39439;s:12:\"delete-40198\";i:39440;s:12:\"delete-40200\";i:39441;s:12:\"delete-40201\";i:39442;s:12:\"delete-40204\";i:39443;s:12:\"delete-40205\";i:39444;s:12:\"delete-40202\";i:39445;s:12:\"delete-40203\";i:39446;s:12:\"delete-40206\";i:39447;s:12:\"delete-40209\";i:39448;s:12:\"delete-40210\";i:39449;s:12:\"delete-40207\";i:39450;s:12:\"delete-40208\";i:39451;s:12:\"delete-40211\";i:39452;s:12:\"delete-40214\";i:39453;s:12:\"delete-40212\";i:39454;s:12:\"delete-40213\";i:39455;s:12:\"delete-40215\";i:39456;s:12:\"delete-40216\";i:39457;s:12:\"delete-40219\";i:39458;s:12:\"delete-40217\";i:39459;s:12:\"delete-40218\";i:39460;s:12:\"delete-40220\";i:39461;s:12:\"delete-40221\";i:39462;s:12:\"delete-40224\";i:39463;s:12:\"delete-40225\";i:39464;s:12:\"delete-40222\";i:39465;s:12:\"delete-40223\";i:39466;s:12:\"delete-40226\";i:39467;s:12:\"delete-40229\";i:39468;s:12:\"delete-40230\";i:39469;s:12:\"delete-40227\";i:39470;s:12:\"delete-40228\";i:39471;s:12:\"delete-40231\";i:39472;s:12:\"delete-40234\";i:39473;s:12:\"delete-40232\";i:39474;s:12:\"delete-40233\";i:39475;s:12:\"delete-40235\";i:39476;s:12:\"delete-40236\";i:39477;s:12:\"delete-40239\";i:39478;s:12:\"delete-40240\";i:39479;s:12:\"delete-40237\";i:39480;s:12:\"delete-40238\";i:39481;s:12:\"delete-40241\";i:39482;s:12:\"delete-40244\";i:39483;s:12:\"delete-40245\";i:39484;s:12:\"delete-40242\";i:39485;s:12:\"delete-40243\";i:39486;s:12:\"delete-40246\";i:39487;s:12:\"delete-40249\";i:39488;s:12:\"delete-40250\";i:39489;s:12:\"delete-40247\";i:39490;s:12:\"delete-40248\";i:39491;s:12:\"delete-40251\";i:39492;s:12:\"delete-40252\";i:39493;s:12:\"delete-40253\";i:39494;s:12:\"delete-40254\";i:39495;s:12:\"delete-40255\";i:39496;s:12:\"delete-40256\";i:39497;s:12:\"delete-40259\";i:39498;s:12:\"delete-40260\";i:39499;s:12:\"delete-40257\";i:39500;s:12:\"delete-40258\";i:39501;s:12:\"delete-40261\";i:39502;s:12:\"delete-40264\";i:39503;s:12:\"delete-40265\";i:39504;s:12:\"delete-40262\";i:39505;s:12:\"delete-40263\";i:39506;s:12:\"delete-40266\";i:39507;s:12:\"delete-40269\";i:39508;s:12:\"delete-40270\";i:39509;s:12:\"delete-40267\";i:39510;s:12:\"delete-40268\";i:39511;s:12:\"delete-40271\";i:39512;s:12:\"delete-40274\";i:39513;s:12:\"delete-40272\";i:39514;s:12:\"delete-40273\";i:39515;s:12:\"delete-40275\";i:39516;s:12:\"delete-40276\";i:39517;s:12:\"delete-40279\";i:39518;s:12:\"delete-40280\";i:39519;s:12:\"delete-40277\";i:39520;s:12:\"delete-40278\";i:39521;s:12:\"delete-40281\";i:39522;s:12:\"delete-40284\";i:39523;s:12:\"delete-40285\";i:39524;s:12:\"delete-40282\";i:39525;s:12:\"delete-40283\";i:39526;s:12:\"delete-40286\";i:39527;s:12:\"delete-40289\";i:39528;s:12:\"delete-40287\";i:39529;s:12:\"delete-40288\";i:39530;s:12:\"delete-40290\";i:39531;s:12:\"delete-40291\";i:39532;s:12:\"delete-40294\";i:39533;s:12:\"delete-40295\";i:39534;s:12:\"delete-40292\";i:39535;s:12:\"delete-40293\";i:39536;s:12:\"delete-40296\";i:39537;s:12:\"delete-40299\";i:39538;s:12:\"delete-40297\";i:39539;s:12:\"delete-40298\";i:39540;s:12:\"delete-40300\";i:39541;s:12:\"delete-40301\";i:39542;s:12:\"delete-40304\";i:39543;s:12:\"delete-40302\";i:39544;s:12:\"delete-40303\";i:39545;s:12:\"delete-40305\";i:39546;s:12:\"delete-40306\";i:39547;s:12:\"delete-40309\";i:39548;s:12:\"delete-40310\";i:39549;s:12:\"delete-40307\";i:39550;s:12:\"delete-40308\";i:39551;s:12:\"delete-40311\";i:39552;s:12:\"delete-40314\";i:39553;s:12:\"delete-40315\";i:39554;s:12:\"delete-40312\";i:39555;s:12:\"delete-40313\";i:39556;s:12:\"delete-40316\";i:39557;s:12:\"delete-40319\";i:39558;s:12:\"delete-40320\";i:39559;s:12:\"delete-40317\";i:39560;s:12:\"delete-40318\";i:39561;s:12:\"delete-40321\";i:39562;s:12:\"delete-40324\";i:39563;s:12:\"delete-40325\";i:39564;s:12:\"delete-40322\";i:39565;s:12:\"delete-40323\";i:39566;s:12:\"delete-40326\";i:39567;s:12:\"delete-40329\";i:39568;s:12:\"delete-40330\";i:39569;s:12:\"delete-40327\";i:39570;s:12:\"delete-40328\";i:39571;s:12:\"delete-40331\";i:39572;s:12:\"delete-40334\";i:39573;s:12:\"delete-40332\";i:39574;s:12:\"delete-40333\";i:39575;s:12:\"delete-40335\";i:39576;s:12:\"delete-40336\";i:39577;s:12:\"delete-40339\";i:39578;s:12:\"delete-40340\";i:39579;s:12:\"delete-40337\";i:39580;s:12:\"delete-40338\";i:39581;s:12:\"delete-40341\";i:39582;s:12:\"delete-40344\";i:39583;s:12:\"delete-40345\";i:39584;s:12:\"delete-40342\";i:39585;s:12:\"delete-40343\";i:39586;s:12:\"delete-40346\";i:39587;s:12:\"delete-40349\";i:39588;s:12:\"delete-40350\";i:39589;s:12:\"delete-40347\";i:39590;s:12:\"delete-40348\";i:39591;s:12:\"delete-40351\";i:39592;s:12:\"delete-40354\";i:39593;s:12:\"delete-40355\";i:39594;s:12:\"delete-40352\";i:39595;s:12:\"delete-40353\";i:39596;s:12:\"delete-40356\";i:39597;s:12:\"delete-40359\";i:39598;s:12:\"delete-40360\";i:39599;s:12:\"delete-40357\";i:39600;s:12:\"delete-40358\";i:39601;s:12:\"delete-40361\";i:39602;s:12:\"delete-40364\";i:39603;s:12:\"delete-40365\";i:39604;s:12:\"delete-40362\";i:39605;s:12:\"delete-40363\";i:39606;s:12:\"delete-40366\";i:39607;s:12:\"delete-40369\";i:39608;s:12:\"delete-40367\";i:39609;s:12:\"delete-40368\";i:39610;s:12:\"delete-40370\";i:39611;s:12:\"delete-40371\";i:39612;s:12:\"delete-40374\";i:39613;s:12:\"delete-40375\";i:39614;s:12:\"delete-40372\";i:39615;s:12:\"delete-40373\";i:39616;s:12:\"delete-40376\";i:39617;s:12:\"delete-40379\";i:39618;s:12:\"delete-40380\";i:39619;s:12:\"delete-40377\";i:39620;s:12:\"delete-40378\";i:39621;s:12:\"delete-40381\";i:39622;s:12:\"delete-40384\";i:39623;s:12:\"delete-40385\";i:39624;s:12:\"delete-40382\";i:39625;s:12:\"delete-40383\";i:39626;s:12:\"delete-40386\";i:39627;s:12:\"delete-40389\";i:39628;s:12:\"delete-40390\";i:39629;s:12:\"delete-40387\";i:39630;s:12:\"delete-40388\";i:39631;s:12:\"delete-40391\";i:39632;s:12:\"delete-40394\";i:39633;s:12:\"delete-40392\";i:39634;s:12:\"delete-40393\";i:39635;s:12:\"delete-40395\";i:39636;s:12:\"delete-40396\";i:39637;s:12:\"delete-40399\";i:39638;s:12:\"delete-40400\";i:39639;s:12:\"delete-40397\";i:39640;s:12:\"delete-40398\";i:39641;s:12:\"delete-40401\";i:39642;s:12:\"delete-40404\";i:39643;s:12:\"delete-40402\";i:39644;s:12:\"delete-40403\";i:39645;s:12:\"delete-40405\";i:39646;s:12:\"delete-40406\";i:39647;s:12:\"delete-40409\";i:39648;s:12:\"delete-40410\";i:39649;s:12:\"delete-40407\";i:39650;s:12:\"delete-40408\";i:39651;s:12:\"delete-40411\";i:39652;s:12:\"delete-40414\";i:39653;s:12:\"delete-40415\";i:39654;s:12:\"delete-40412\";i:39655;s:12:\"delete-40413\";i:39656;s:12:\"delete-40416\";i:39657;s:12:\"delete-40419\";i:39658;s:12:\"delete-40420\";i:39659;s:12:\"delete-40417\";i:39660;s:12:\"delete-40418\";i:39661;s:12:\"delete-40421\";i:39662;s:12:\"delete-40424\";i:39663;s:12:\"delete-40422\";i:39664;s:12:\"delete-40423\";i:39665;s:12:\"delete-40425\";i:39666;s:12:\"delete-40426\";i:39667;s:12:\"delete-40429\";i:39668;s:12:\"delete-40430\";i:39669;s:12:\"delete-40427\";i:39670;s:12:\"delete-40428\";i:39671;s:12:\"delete-40431\";i:39672;s:12:\"delete-40434\";i:39673;s:12:\"delete-40432\";i:39674;s:12:\"delete-40433\";i:39675;s:12:\"delete-40435\";i:39676;s:12:\"delete-40436\";i:39677;s:12:\"delete-40439\";i:39678;s:12:\"delete-40440\";i:39679;s:12:\"delete-40437\";i:39680;s:12:\"delete-40438\";i:39681;s:12:\"delete-40441\";i:39682;s:12:\"delete-40444\";i:39683;s:12:\"delete-40445\";i:39684;s:12:\"delete-40442\";i:39685;s:12:\"delete-40443\";i:39686;s:12:\"delete-40446\";i:39687;s:12:\"delete-40449\";i:39688;s:12:\"delete-40450\";i:39689;s:12:\"delete-40447\";i:39690;s:12:\"delete-40448\";i:39691;s:12:\"delete-40451\";i:39692;s:12:\"delete-40454\";i:39693;s:12:\"delete-40455\";i:39694;s:12:\"delete-40452\";i:39695;s:12:\"delete-40453\";i:39696;s:12:\"delete-40456\";i:39697;s:12:\"delete-40459\";i:39698;s:12:\"delete-40460\";i:39699;s:12:\"delete-40457\";i:39700;s:12:\"delete-40458\";i:39701;s:12:\"delete-40461\";i:39702;s:12:\"delete-40464\";i:39703;s:12:\"delete-40465\";i:39704;s:12:\"delete-40462\";i:39705;s:12:\"delete-40463\";i:39706;s:12:\"delete-40466\";i:39707;s:12:\"delete-40469\";i:39708;s:12:\"delete-40470\";i:39709;s:12:\"delete-40467\";i:39710;s:12:\"delete-40468\";i:39711;s:12:\"delete-40471\";i:39712;s:12:\"delete-40474\";i:39713;s:12:\"delete-40475\";i:39714;s:12:\"delete-40472\";i:39715;s:12:\"delete-40473\";i:39716;s:12:\"delete-40476\";i:39717;s:12:\"delete-40479\";i:39718;s:12:\"delete-40477\";i:39719;s:12:\"delete-40478\";i:39720;s:12:\"delete-40480\";i:39721;s:12:\"delete-40481\";i:39722;s:12:\"delete-40484\";i:39723;s:12:\"delete-40485\";i:39724;s:12:\"delete-40482\";i:39725;s:12:\"delete-40483\";i:39726;s:12:\"delete-40486\";i:39727;s:12:\"delete-40489\";i:39728;s:12:\"delete-40490\";i:39729;s:12:\"delete-40487\";i:39730;s:12:\"delete-40488\";i:39731;s:12:\"delete-40491\";i:39732;s:12:\"delete-40494\";i:39733;s:12:\"delete-40492\";i:39734;s:12:\"delete-40493\";i:39735;s:12:\"delete-40495\";i:39736;s:12:\"delete-40496\";i:39737;s:12:\"delete-40499\";i:39738;s:12:\"delete-40500\";i:39739;s:12:\"delete-40497\";i:39740;s:12:\"delete-40498\";i:39741;s:12:\"delete-40501\";i:39742;s:12:\"delete-40504\";i:39743;s:12:\"delete-40505\";i:39744;s:12:\"delete-40502\";i:39745;s:12:\"delete-40503\";i:39746;s:12:\"delete-40506\";i:39747;s:12:\"delete-40509\";i:39748;s:12:\"delete-40510\";i:39749;s:12:\"delete-40507\";i:39750;s:12:\"delete-40508\";i:39751;s:12:\"delete-40511\";i:39752;s:12:\"delete-40514\";i:39753;s:12:\"delete-40515\";i:39754;s:12:\"delete-40512\";i:39755;s:12:\"delete-40513\";i:39756;s:12:\"delete-40516\";i:39757;s:12:\"delete-40519\";i:39758;s:12:\"delete-40520\";i:39759;s:12:\"delete-40517\";i:39760;s:12:\"delete-40518\";i:39761;s:12:\"delete-40521\";i:39762;s:12:\"delete-40524\";i:39763;s:12:\"delete-40525\";i:39764;s:12:\"delete-40522\";i:39765;s:12:\"delete-40523\";i:39766;s:12:\"delete-40526\";i:39767;s:12:\"delete-40529\";i:39768;s:12:\"delete-40527\";i:39769;s:12:\"delete-40528\";i:39770;s:12:\"delete-40530\";i:39771;s:12:\"delete-40531\";i:39772;s:12:\"delete-40534\";i:39773;s:12:\"delete-40535\";i:39774;s:12:\"delete-40532\";i:39775;s:12:\"delete-40533\";i:39776;s:12:\"delete-40536\";i:39777;s:12:\"delete-40539\";i:39778;s:12:\"delete-40540\";i:39779;s:12:\"delete-40537\";i:39780;s:12:\"delete-40538\";i:39781;s:12:\"delete-40541\";i:39782;s:12:\"delete-40544\";i:39783;s:12:\"delete-40545\";i:39784;s:12:\"delete-40542\";i:39785;s:12:\"delete-40543\";i:39786;s:12:\"delete-40546\";i:39787;s:12:\"delete-40549\";i:39788;s:12:\"delete-40550\";i:39789;s:12:\"delete-40547\";i:39790;s:12:\"delete-40548\";i:39791;s:12:\"delete-40551\";i:39792;s:12:\"delete-40554\";i:39793;s:12:\"delete-40555\";i:39794;s:12:\"delete-40552\";i:39795;s:12:\"delete-40553\";i:39796;s:12:\"delete-40556\";i:39797;s:12:\"delete-40559\";i:39798;s:12:\"delete-40557\";i:39799;s:12:\"delete-40558\";i:39800;s:12:\"delete-40560\";i:39801;s:12:\"delete-40561\";i:39802;s:12:\"delete-40564\";i:39803;s:12:\"delete-40565\";i:39804;s:12:\"delete-40562\";i:39805;s:12:\"delete-40563\";i:39806;s:12:\"delete-40566\";i:39807;s:12:\"delete-40569\";i:39808;s:12:\"delete-40567\";i:39809;s:12:\"delete-40568\";i:39810;s:12:\"delete-40570\";i:39811;s:12:\"delete-40571\";i:39812;s:12:\"delete-40574\";i:39813;s:12:\"delete-40575\";i:39814;s:12:\"delete-40572\";i:39815;s:12:\"delete-40573\";i:39816;s:12:\"delete-40576\";i:39817;s:12:\"delete-40579\";i:39818;s:12:\"delete-40580\";i:39819;s:12:\"delete-40577\";i:39820;s:12:\"delete-40578\";i:39821;s:12:\"delete-40581\";i:39822;s:12:\"delete-40584\";i:39823;s:12:\"delete-40582\";i:39824;s:12:\"delete-40583\";i:39825;s:12:\"delete-40585\";i:39826;s:12:\"delete-40586\";i:39827;s:12:\"delete-40589\";i:39828;s:12:\"delete-40590\";i:39829;s:12:\"delete-40587\";i:39830;s:12:\"delete-40588\";i:39831;s:12:\"delete-40591\";i:39832;s:12:\"delete-40594\";i:39833;s:12:\"delete-40592\";i:39834;s:12:\"delete-40593\";i:39835;s:12:\"delete-40595\";i:39836;s:12:\"delete-40596\";i:39837;s:12:\"delete-40599\";i:39838;s:12:\"delete-40600\";i:39839;s:12:\"delete-40597\";i:39840;s:12:\"delete-40598\";i:39841;s:12:\"delete-40601\";i:39842;s:12:\"delete-40604\";i:39843;s:12:\"delete-40605\";i:39844;s:12:\"delete-40602\";i:39845;s:12:\"delete-40603\";i:39846;s:12:\"delete-40606\";i:39847;s:12:\"delete-40609\";i:39848;s:12:\"delete-40610\";i:39849;s:12:\"delete-40607\";i:39850;s:12:\"delete-40608\";i:39851;s:12:\"delete-40611\";i:39852;s:12:\"delete-40614\";i:39853;s:12:\"delete-40615\";i:39854;s:12:\"delete-40612\";i:39855;s:12:\"delete-40613\";i:39856;s:12:\"delete-40616\";i:39857;s:12:\"delete-40619\";i:39858;s:12:\"delete-40620\";i:39859;s:12:\"delete-40617\";i:39860;s:12:\"delete-40618\";i:39861;s:12:\"delete-40621\";i:39862;s:12:\"delete-40624\";i:39863;s:12:\"delete-40622\";i:39864;s:12:\"delete-40623\";i:39865;s:12:\"delete-40625\";i:39866;s:12:\"delete-40626\";i:39867;s:12:\"delete-40629\";i:39868;s:12:\"delete-40630\";i:39869;s:12:\"delete-40627\";i:39870;s:12:\"delete-40628\";i:39871;s:12:\"delete-40631\";i:39872;s:12:\"delete-40634\";i:39873;s:12:\"delete-40632\";i:39874;s:12:\"delete-40633\";i:39875;s:12:\"delete-40635\";i:39876;s:12:\"delete-40636\";i:39877;s:12:\"delete-40639\";i:39878;s:12:\"delete-40640\";i:39879;s:12:\"delete-40637\";i:39880;s:12:\"delete-40638\";i:39881;s:12:\"delete-40641\";i:39882;s:12:\"delete-40644\";i:39883;s:12:\"delete-40642\";i:39884;s:12:\"delete-40643\";i:39885;s:12:\"delete-40645\";i:39886;s:12:\"delete-40646\";i:39887;s:12:\"delete-40649\";i:39888;s:12:\"delete-40650\";i:39889;s:12:\"delete-40647\";i:39890;s:12:\"delete-40648\";i:39891;s:12:\"delete-40651\";i:39892;s:12:\"delete-40654\";i:39893;s:12:\"delete-40655\";i:39894;s:12:\"delete-40652\";i:39895;s:12:\"delete-40653\";i:39896;s:12:\"delete-40656\";i:39897;s:12:\"delete-40659\";i:39898;s:12:\"delete-40660\";i:39899;s:12:\"delete-40657\";i:39900;s:12:\"delete-40658\";i:39901;s:12:\"delete-40661\";i:39902;s:12:\"delete-40664\";i:39903;s:12:\"delete-40665\";i:39904;s:12:\"delete-40662\";i:39905;s:12:\"delete-40663\";i:39906;s:12:\"delete-40666\";i:39907;s:12:\"delete-40669\";i:39908;s:12:\"delete-40670\";i:39909;s:12:\"delete-40667\";i:39910;s:12:\"delete-40668\";i:39911;s:12:\"delete-40671\";i:39912;s:12:\"delete-40674\";i:39913;s:12:\"delete-40675\";i:39914;s:12:\"delete-40672\";i:39915;s:12:\"delete-40673\";i:39916;s:12:\"delete-40676\";i:39917;s:12:\"delete-40679\";i:39918;s:12:\"delete-40677\";i:39919;s:12:\"delete-40678\";i:39920;s:12:\"delete-40680\";i:39921;s:12:\"delete-40681\";i:39922;s:12:\"delete-40684\";i:39923;s:12:\"delete-40685\";i:39924;s:12:\"delete-40682\";i:39925;s:12:\"delete-40683\";i:39926;s:12:\"delete-40686\";i:39927;s:12:\"delete-40689\";i:39928;s:12:\"delete-40690\";i:39929;s:12:\"delete-40687\";i:39930;s:12:\"delete-40688\";i:39931;s:12:\"delete-40691\";i:39932;s:12:\"delete-40694\";i:39933;s:12:\"delete-40692\";i:39934;s:12:\"delete-40693\";i:39935;s:12:\"delete-40695\";i:39936;s:12:\"delete-40696\";i:39937;s:12:\"delete-40699\";i:39938;s:12:\"delete-40700\";i:39939;s:12:\"delete-40697\";i:39940;s:12:\"delete-40698\";i:39941;s:12:\"delete-40701\";i:39942;s:12:\"delete-40704\";i:39943;s:12:\"delete-40705\";i:39944;s:12:\"delete-40702\";i:39945;s:12:\"delete-40703\";i:39946;s:12:\"delete-40706\";i:39947;s:12:\"delete-40709\";i:39948;s:12:\"delete-40710\";i:39949;s:12:\"delete-40707\";i:39950;s:12:\"delete-40708\";i:39951;s:12:\"delete-40711\";i:39952;s:12:\"delete-40714\";i:39953;s:12:\"delete-40712\";i:39954;s:12:\"delete-40713\";i:39955;s:12:\"delete-40715\";i:39956;s:12:\"delete-40716\";i:39957;s:12:\"delete-40719\";i:39958;s:12:\"delete-40717\";i:39959;s:12:\"delete-40718\";i:39960;s:12:\"delete-40720\";i:39961;s:12:\"delete-40721\";i:39962;s:12:\"delete-40724\";i:39963;s:12:\"delete-40725\";i:39964;s:12:\"delete-40722\";i:39965;s:12:\"delete-40723\";i:39966;s:12:\"delete-40726\";i:39967;s:12:\"delete-40729\";i:39968;s:12:\"delete-40730\";i:39969;s:12:\"delete-40727\";i:39970;s:12:\"delete-40728\";i:39971;s:12:\"delete-40731\";i:39972;s:12:\"delete-40734\";i:39973;s:12:\"delete-40735\";i:39974;s:12:\"delete-40732\";i:39975;s:12:\"delete-40733\";i:39976;s:12:\"delete-40736\";i:39977;s:12:\"delete-40739\";i:39978;s:12:\"delete-40737\";i:39979;s:12:\"delete-40738\";i:39980;s:12:\"delete-40740\";i:39981;s:12:\"delete-40741\";i:39982;s:12:\"delete-40744\";i:39983;s:12:\"delete-40745\";i:39984;s:12:\"delete-40742\";i:39985;s:12:\"delete-40743\";i:39986;s:12:\"delete-40746\";i:39987;s:12:\"delete-40749\";i:39988;s:12:\"delete-40750\";i:39989;s:12:\"delete-40747\";i:39990;s:12:\"delete-40748\";i:39991;s:12:\"delete-40751\";i:39992;s:12:\"delete-40754\";i:39993;s:12:\"delete-40755\";i:39994;s:12:\"delete-40752\";i:39995;s:12:\"delete-40753\";i:39996;s:12:\"delete-40756\";i:39997;s:12:\"delete-40759\";i:39998;s:12:\"delete-40760\";i:39999;s:12:\"delete-40757\";i:40000;s:12:\"delete-40758\";i:40001;s:12:\"delete-40761\";i:40002;s:12:\"delete-40764\";i:40003;s:12:\"delete-40762\";i:40004;s:12:\"delete-40763\";i:40005;s:12:\"delete-40765\";i:40006;s:12:\"delete-40766\";i:40007;s:12:\"delete-40769\";i:40008;s:12:\"delete-40770\";i:40009;s:12:\"delete-40767\";i:40010;s:12:\"delete-40768\";i:40011;s:12:\"delete-40771\";i:40012;s:12:\"delete-40774\";i:40013;s:12:\"delete-40775\";i:40014;s:12:\"delete-40772\";i:40015;s:12:\"delete-40773\";i:40016;s:12:\"delete-40776\";i:40017;s:12:\"delete-40779\";i:40018;s:12:\"delete-40777\";i:40019;s:12:\"delete-40778\";i:40020;s:12:\"delete-40780\";i:40021;s:12:\"delete-40781\";i:40022;s:12:\"delete-40784\";i:40023;s:12:\"delete-40785\";i:40024;s:12:\"delete-40782\";i:40025;s:12:\"delete-40783\";i:40026;s:12:\"delete-40786\";i:40027;s:12:\"delete-40789\";i:40028;s:12:\"delete-40790\";i:40029;s:12:\"delete-40787\";i:40030;s:12:\"delete-40788\";i:40031;s:12:\"delete-40791\";i:40032;s:12:\"delete-40794\";i:40033;s:12:\"delete-40795\";i:40034;s:12:\"delete-40792\";i:40035;s:12:\"delete-40793\";i:40036;s:12:\"delete-40796\";i:40037;s:12:\"delete-40799\";i:40038;s:12:\"delete-40800\";i:40039;s:12:\"delete-40797\";i:40040;s:12:\"delete-40798\";i:40041;s:12:\"delete-40801\";i:40042;s:12:\"delete-40804\";i:40043;s:12:\"delete-40805\";i:40044;s:12:\"delete-40802\";i:40045;s:12:\"delete-40803\";i:40046;s:12:\"delete-40806\";i:40047;s:12:\"delete-40809\";i:40048;s:12:\"delete-40807\";i:40049;s:12:\"delete-40808\";i:40050;s:12:\"delete-40810\";i:40051;s:12:\"delete-40811\";i:40052;s:12:\"delete-40814\";i:40053;s:12:\"delete-40815\";i:40054;s:12:\"delete-40812\";i:40055;s:12:\"delete-40813\";i:40056;s:12:\"delete-40816\";i:40057;s:12:\"delete-40819\";i:40058;s:12:\"delete-40820\";i:40059;s:12:\"delete-40817\";i:40060;s:12:\"delete-40818\";i:40061;s:12:\"delete-40821\";i:40062;s:12:\"delete-40824\";i:40063;s:12:\"delete-40825\";i:40064;s:12:\"delete-40822\";i:40065;s:12:\"delete-40823\";i:40066;s:12:\"delete-40826\";i:40067;s:12:\"delete-40829\";i:40068;s:12:\"delete-40830\";i:40069;s:12:\"delete-40827\";i:40070;s:12:\"delete-40828\";i:40071;s:12:\"delete-40831\";i:40072;s:12:\"delete-40834\";i:40073;s:12:\"delete-40832\";i:40074;s:12:\"delete-40833\";i:40075;s:12:\"delete-40835\";i:40076;s:12:\"delete-40836\";i:40077;s:12:\"delete-40839\";i:40078;s:12:\"delete-40840\";i:40079;s:12:\"delete-40837\";i:40080;s:12:\"delete-40838\";i:40081;s:12:\"delete-40841\";i:40082;s:12:\"delete-40844\";i:40083;s:12:\"delete-40845\";i:40084;s:12:\"delete-40842\";i:40085;s:12:\"delete-40843\";i:40086;s:12:\"delete-40846\";i:40087;s:12:\"delete-40849\";i:40088;s:12:\"delete-40850\";i:40089;s:12:\"delete-40847\";i:40090;s:12:\"delete-40848\";i:40091;s:12:\"delete-40851\";i:40092;s:12:\"delete-40854\";i:40093;s:12:\"delete-40855\";i:40094;s:12:\"delete-40852\";i:40095;s:12:\"delete-40853\";i:40096;s:12:\"delete-40856\";i:40097;s:12:\"delete-40859\";i:40098;s:12:\"delete-40860\";i:40099;s:12:\"delete-40857\";i:40100;s:12:\"delete-40858\";i:40101;s:12:\"delete-40861\";i:40102;s:12:\"delete-40864\";i:40103;s:12:\"delete-40862\";i:40104;s:12:\"delete-40863\";i:40105;s:12:\"delete-40865\";i:40106;s:12:\"delete-40866\";i:40107;s:12:\"delete-40869\";i:40108;s:12:\"delete-40870\";i:40109;s:12:\"delete-40867\";i:40110;s:12:\"delete-40868\";i:40111;s:12:\"delete-40871\";i:40112;s:12:\"delete-40874\";i:40113;s:12:\"delete-40875\";i:40114;s:12:\"delete-40872\";i:40115;s:12:\"delete-40873\";i:40116;s:12:\"delete-40876\";i:40117;s:12:\"delete-40879\";i:40118;s:12:\"delete-40880\";i:40119;s:12:\"delete-40877\";i:40120;s:12:\"delete-40878\";i:40121;s:12:\"delete-40881\";i:40122;s:12:\"delete-40882\";i:40123;s:12:\"delete-40883\";i:40124;s:12:\"delete-40884\";i:40125;s:12:\"delete-40885\";i:40126;s:12:\"delete-40886\";i:40127;s:12:\"delete-40889\";i:40128;s:12:\"delete-40887\";i:40129;s:12:\"delete-40888\";i:40130;s:12:\"delete-40890\";i:40131;s:12:\"delete-40891\";i:40132;s:12:\"delete-40894\";i:40133;s:12:\"delete-40892\";i:40134;s:12:\"delete-40893\";i:40135;s:12:\"delete-40895\";i:40136;s:12:\"delete-40896\";i:40137;s:12:\"delete-40899\";i:40138;s:12:\"delete-40900\";i:40139;s:12:\"delete-40897\";i:40140;s:12:\"delete-40898\";i:40141;s:12:\"delete-40901\";i:40142;s:12:\"delete-40904\";i:40143;s:12:\"delete-40905\";i:40144;s:12:\"delete-40902\";i:40145;s:12:\"delete-40903\";i:40146;s:12:\"delete-40906\";i:40147;s:12:\"delete-40909\";i:40148;s:12:\"delete-40910\";i:40149;s:12:\"delete-40907\";i:40150;s:12:\"delete-40908\";i:40151;s:12:\"delete-40911\";i:40152;s:12:\"delete-40914\";i:40153;s:12:\"delete-40915\";i:40154;s:12:\"delete-40912\";i:40155;s:12:\"delete-40913\";i:40156;s:12:\"delete-40916\";i:40157;s:12:\"delete-40919\";i:40158;s:12:\"delete-40917\";i:40159;s:12:\"delete-40918\";i:40160;s:12:\"delete-40920\";i:40161;s:12:\"delete-40921\";i:40162;s:12:\"delete-40924\";i:40163;s:12:\"delete-40925\";i:40164;s:12:\"delete-40922\";i:40165;s:12:\"delete-40923\";i:40166;s:12:\"delete-40926\";i:40167;s:12:\"delete-40929\";i:40168;s:12:\"delete-40930\";i:40169;s:12:\"delete-40927\";i:40170;s:12:\"delete-40928\";i:40171;s:12:\"delete-40931\";i:40172;s:12:\"delete-40934\";i:40173;s:12:\"delete-40932\";i:40174;s:12:\"delete-40933\";i:40175;s:12:\"delete-40935\";i:40176;s:12:\"delete-40936\";i:40177;s:12:\"delete-40939\";i:40178;s:12:\"delete-40940\";i:40179;s:12:\"delete-40937\";i:40180;s:12:\"delete-40938\";i:40181;s:12:\"delete-40941\";i:40182;s:12:\"delete-40944\";i:40183;s:12:\"delete-40945\";i:40184;s:12:\"delete-40942\";i:40185;s:12:\"delete-40943\";i:40186;s:12:\"delete-40946\";i:40187;s:12:\"delete-40949\";i:40188;s:12:\"delete-40947\";i:40189;s:12:\"delete-40948\";i:40190;s:12:\"delete-40950\";i:40191;s:12:\"delete-40951\";i:40192;s:12:\"delete-40954\";i:40193;s:12:\"delete-40952\";i:40194;s:12:\"delete-40953\";i:40195;s:12:\"delete-40955\";i:40196;s:12:\"delete-40956\";i:40197;s:12:\"delete-40959\";i:40198;s:12:\"delete-40960\";i:40199;s:12:\"delete-40957\";i:40200;s:12:\"delete-40958\";i:40201;s:12:\"delete-40961\";i:40202;s:12:\"delete-40964\";i:40203;s:12:\"delete-40965\";i:40204;s:12:\"delete-40962\";i:40205;s:12:\"delete-40963\";i:40206;s:12:\"delete-40966\";i:40207;s:12:\"delete-40969\";i:40208;s:12:\"delete-40970\";i:40209;s:12:\"delete-40967\";i:40210;s:12:\"delete-40968\";i:40211;s:12:\"delete-40971\";i:40212;s:12:\"delete-40974\";i:40213;s:12:\"delete-40975\";i:40214;s:12:\"delete-40972\";i:40215;s:12:\"delete-40973\";i:40216;s:12:\"delete-40976\";i:40217;s:12:\"delete-40979\";i:40218;s:12:\"delete-40980\";i:40219;s:12:\"delete-40977\";i:40220;s:12:\"delete-40978\";i:40221;s:12:\"delete-40981\";i:40222;s:12:\"delete-40984\";i:40223;s:12:\"delete-40985\";i:40224;s:12:\"delete-40982\";i:40225;s:12:\"delete-40983\";i:40226;s:12:\"delete-40986\";i:40227;s:12:\"delete-40987\";i:40228;s:12:\"delete-40988\";i:40229;s:12:\"delete-40989\";i:40230;s:12:\"delete-40990\";i:40231;s:12:\"delete-40991\";i:40232;s:12:\"delete-40994\";i:40233;s:12:\"delete-40995\";i:40234;s:12:\"delete-40992\";i:40235;s:12:\"delete-40993\";i:40236;s:12:\"delete-40996\";i:40237;s:12:\"delete-40999\";i:40238;s:12:\"delete-41000\";i:40239;s:12:\"delete-40997\";i:40240;s:12:\"delete-40998\";i:40241;s:12:\"delete-41001\";i:40242;s:12:\"delete-41004\";i:40243;s:12:\"delete-41005\";i:40244;s:12:\"delete-41002\";i:40245;s:12:\"delete-41003\";i:40246;s:12:\"delete-41006\";i:40247;s:12:\"delete-41009\";i:40248;s:12:\"delete-41010\";i:40249;s:12:\"delete-41007\";i:40250;s:12:\"delete-41008\";i:40251;s:12:\"delete-41011\";i:40252;s:12:\"delete-41014\";i:40253;s:12:\"delete-41015\";i:40254;s:12:\"delete-41012\";i:40255;s:12:\"delete-41013\";i:40256;s:12:\"delete-41016\";i:40257;s:12:\"delete-41019\";i:40258;s:12:\"delete-41020\";i:40259;s:12:\"delete-41017\";i:40260;s:12:\"delete-41018\";i:40261;s:12:\"delete-41021\";i:40262;s:12:\"delete-41024\";i:40263;s:12:\"delete-41025\";i:40264;s:12:\"delete-41022\";i:40265;s:12:\"delete-41023\";i:40266;s:12:\"delete-41026\";i:40267;s:12:\"delete-41029\";i:40268;s:12:\"delete-41030\";i:40269;s:12:\"delete-41027\";i:40270;s:12:\"delete-41028\";i:40271;s:12:\"delete-41031\";i:40272;s:12:\"delete-41034\";i:40273;s:12:\"delete-41035\";i:40274;s:12:\"delete-41032\";i:40275;s:12:\"delete-41033\";i:40276;s:12:\"delete-41036\";i:40277;s:12:\"delete-41039\";i:40278;s:12:\"delete-41037\";i:40279;s:12:\"delete-41038\";i:40280;s:12:\"delete-41040\";i:40281;s:12:\"delete-41041\";i:40282;s:12:\"delete-41044\";i:40283;s:12:\"delete-41045\";i:40284;s:12:\"delete-41042\";i:40285;s:12:\"delete-41043\";i:40286;s:12:\"delete-41046\";i:40287;s:12:\"delete-41049\";i:40288;s:12:\"delete-41050\";i:40289;s:12:\"delete-41047\";i:40290;s:12:\"delete-41048\";i:40291;s:12:\"delete-41051\";i:40292;s:12:\"delete-41054\";i:40293;s:12:\"delete-41055\";i:40294;s:12:\"delete-41052\";i:40295;s:12:\"delete-41053\";i:40296;s:12:\"delete-41056\";i:40297;s:12:\"delete-41059\";i:40298;s:12:\"delete-41060\";i:40299;s:12:\"delete-41057\";i:40300;s:12:\"delete-41058\";i:40301;s:12:\"delete-41061\";i:40302;s:12:\"delete-41064\";i:40303;s:12:\"delete-41062\";i:40304;s:12:\"delete-41063\";i:40305;s:12:\"delete-41065\";i:40306;s:12:\"delete-41066\";i:40307;s:12:\"delete-41069\";i:40308;s:12:\"delete-41067\";i:40309;s:12:\"delete-41068\";i:40310;s:12:\"delete-41070\";i:40311;s:12:\"delete-41071\";i:40312;s:12:\"delete-41074\";i:40313;s:12:\"delete-41075\";i:40314;s:12:\"delete-41072\";i:40315;s:12:\"delete-41073\";i:40316;s:12:\"delete-41076\";i:40317;s:12:\"delete-41079\";i:40318;s:12:\"delete-41080\";i:40319;s:12:\"delete-41077\";i:40320;s:12:\"delete-41078\";i:40321;s:12:\"delete-41081\";i:40322;s:12:\"delete-41084\";i:40323;s:12:\"delete-41085\";i:40324;s:12:\"delete-41082\";i:40325;s:12:\"delete-41083\";i:40326;s:12:\"delete-41086\";i:40327;s:12:\"delete-41089\";i:40328;s:12:\"delete-41090\";i:40329;s:12:\"delete-41087\";i:40330;s:12:\"delete-41088\";i:40331;s:12:\"delete-41091\";i:40332;s:12:\"delete-41094\";i:40333;s:12:\"delete-41092\";i:40334;s:12:\"delete-41093\";i:40335;s:12:\"delete-41095\";i:40336;s:12:\"delete-41096\";i:40337;s:12:\"delete-41099\";i:40338;s:12:\"delete-41100\";i:40339;s:12:\"delete-41097\";i:40340;s:12:\"delete-41098\";i:40341;s:12:\"delete-41101\";i:40342;s:12:\"delete-41104\";i:40343;s:12:\"delete-41105\";i:40344;s:12:\"delete-41102\";i:40345;s:12:\"delete-41103\";i:40346;s:12:\"delete-41106\";i:40347;s:12:\"delete-41109\";i:40348;s:12:\"delete-41110\";i:40349;s:12:\"delete-41107\";i:40350;s:12:\"delete-41108\";i:40351;s:12:\"delete-41111\";i:40352;s:12:\"delete-41114\";i:40353;s:12:\"delete-41112\";i:40354;s:12:\"delete-41113\";i:40355;s:12:\"delete-41115\";i:40356;s:12:\"delete-41116\";i:40357;s:12:\"delete-41119\";i:40358;s:12:\"delete-41120\";i:40359;s:12:\"delete-41117\";i:40360;s:12:\"delete-41118\";i:40361;s:12:\"delete-41121\";i:40362;s:12:\"delete-41124\";i:40363;s:12:\"delete-41122\";i:40364;s:12:\"delete-41123\";i:40365;s:12:\"delete-41125\";i:40366;s:12:\"delete-41126\";i:40367;s:12:\"delete-41129\";i:40368;s:12:\"delete-41130\";i:40369;s:12:\"delete-41127\";i:40370;s:12:\"delete-41128\";i:40371;s:12:\"delete-41131\";i:40372;s:12:\"delete-41134\";i:40373;s:12:\"delete-41135\";i:40374;s:12:\"delete-41132\";i:40375;s:12:\"delete-41133\";i:40376;s:12:\"delete-41136\";i:40377;s:12:\"delete-41139\";i:40378;s:12:\"delete-41140\";i:40379;s:12:\"delete-41137\";i:40380;s:12:\"delete-41138\";i:40381;s:12:\"delete-41141\";i:40382;s:12:\"delete-41144\";i:40383;s:12:\"delete-41145\";i:40384;s:12:\"delete-41142\";i:40385;s:12:\"delete-41143\";i:40386;s:12:\"delete-41146\";i:40387;s:12:\"delete-41149\";i:40388;s:12:\"delete-41150\";i:40389;s:12:\"delete-41147\";i:40390;s:12:\"delete-41148\";i:40391;s:12:\"delete-41151\";i:40392;s:12:\"delete-41154\";i:40393;s:12:\"delete-41155\";i:40394;s:12:\"delete-41152\";i:40395;s:12:\"delete-41153\";i:40396;s:12:\"delete-41156\";i:40397;s:12:\"delete-41159\";i:40398;s:12:\"delete-41160\";i:40399;s:12:\"delete-41157\";i:40400;s:12:\"delete-41158\";i:40401;s:12:\"delete-41161\";i:40402;s:12:\"delete-41164\";i:40403;s:12:\"delete-41165\";i:40404;s:12:\"delete-41162\";i:40405;s:12:\"delete-41163\";i:40406;s:12:\"delete-41166\";i:40407;s:12:\"delete-41167\";i:40408;s:12:\"delete-41168\";i:40409;s:12:\"delete-41169\";i:40410;s:12:\"delete-41170\";i:40411;s:12:\"delete-41171\";i:40412;s:12:\"delete-41172\";i:40413;s:12:\"delete-41173\";i:40414;s:12:\"delete-41174\";i:40415;s:12:\"delete-41175\";i:40416;s:12:\"delete-41176\";i:40417;s:12:\"delete-41179\";i:40418;s:12:\"delete-41180\";i:40419;s:12:\"delete-41177\";i:40420;s:12:\"delete-41178\";i:40421;s:12:\"delete-41181\";i:40422;s:12:\"delete-41184\";i:40423;s:12:\"delete-41185\";i:40424;s:12:\"delete-41182\";i:40425;s:12:\"delete-41183\";i:40426;s:12:\"delete-41186\";i:40427;s:12:\"delete-41189\";i:40428;s:12:\"delete-41190\";i:40429;s:12:\"delete-41187\";i:40430;s:12:\"delete-41188\";i:40431;s:12:\"delete-41191\";i:40432;s:12:\"delete-41194\";i:40433;s:12:\"delete-41192\";i:40434;s:12:\"delete-41193\";i:40435;s:12:\"delete-41195\";i:40436;s:12:\"delete-41196\";i:40437;s:12:\"delete-41199\";i:40438;s:12:\"delete-41197\";i:40439;s:12:\"delete-41198\";i:40440;s:12:\"delete-41200\";i:40441;s:12:\"delete-41201\";i:40442;s:12:\"delete-41204\";i:40443;s:12:\"delete-41205\";i:40444;s:12:\"delete-41202\";i:40445;s:12:\"delete-41203\";i:40446;s:12:\"delete-41206\";i:40447;s:12:\"delete-41207\";i:40448;s:12:\"delete-41208\";i:40449;s:12:\"delete-41209\";i:40450;s:12:\"delete-41210\";i:40451;s:12:\"delete-41211\";i:40452;s:12:\"delete-41214\";i:40453;s:12:\"delete-41215\";i:40454;s:12:\"delete-41212\";i:40455;s:12:\"delete-41213\";i:40456;s:12:\"delete-41216\";i:40457;s:12:\"delete-41219\";i:40458;s:12:\"delete-41220\";i:40459;s:12:\"delete-41217\";i:40460;s:12:\"delete-41218\";i:40461;s:12:\"delete-41221\";i:40462;s:12:\"delete-41224\";i:40463;s:12:\"delete-41222\";i:40464;s:12:\"delete-41223\";i:40465;s:12:\"delete-41225\";i:40466;s:12:\"delete-41226\";i:40467;s:12:\"delete-41229\";i:40468;s:12:\"delete-41230\";i:40469;s:12:\"delete-41227\";i:40470;s:12:\"delete-41228\";i:40471;s:12:\"delete-41231\";i:40472;s:12:\"delete-41234\";i:40473;s:12:\"delete-41235\";i:40474;s:12:\"delete-41232\";i:40475;s:12:\"delete-41233\";i:40476;s:12:\"delete-41236\";i:40477;s:12:\"delete-41239\";i:40478;s:12:\"delete-41240\";i:40479;s:12:\"delete-41237\";i:40480;s:12:\"delete-41238\";i:40481;s:12:\"delete-41241\";i:40482;s:12:\"delete-41244\";i:40483;s:12:\"delete-41242\";i:40484;s:12:\"delete-41243\";i:40485;s:12:\"delete-41245\";i:40486;s:12:\"delete-41246\";i:40487;s:12:\"delete-41249\";i:40488;s:12:\"delete-41250\";i:40489;s:12:\"delete-41247\";i:40490;s:12:\"delete-41248\";i:40491;s:12:\"delete-41251\";i:40492;s:12:\"delete-41254\";i:40493;s:12:\"delete-41255\";i:40494;s:12:\"delete-41252\";i:40495;s:12:\"delete-41253\";i:40496;s:12:\"delete-41256\";i:40497;s:12:\"delete-41259\";i:40498;s:12:\"delete-41260\";i:40499;s:12:\"delete-41257\";i:40500;s:12:\"delete-41258\";i:40501;s:12:\"delete-41261\";i:40502;s:12:\"delete-41264\";i:40503;s:12:\"delete-41262\";i:40504;s:12:\"delete-41263\";i:40505;s:12:\"delete-41265\";i:40506;s:12:\"delete-41266\";i:40507;s:12:\"delete-41269\";i:40508;s:12:\"delete-41270\";i:40509;s:12:\"delete-41267\";i:40510;s:12:\"delete-41268\";i:40511;s:12:\"delete-41271\";i:40512;s:12:\"delete-41274\";i:40513;s:12:\"delete-41272\";i:40514;s:12:\"delete-41273\";i:40515;s:12:\"delete-41275\";i:40516;s:12:\"delete-41276\";i:40517;s:12:\"delete-41279\";i:40518;s:12:\"delete-41280\";i:40519;s:12:\"delete-41277\";i:40520;s:12:\"delete-41278\";i:40521;s:12:\"delete-41281\";i:40522;s:12:\"delete-41284\";i:40523;s:12:\"delete-41282\";i:40524;s:12:\"delete-41283\";i:40525;s:12:\"delete-41285\";i:40526;s:12:\"delete-41286\";i:40527;s:12:\"delete-41289\";i:40528;s:12:\"delete-41290\";i:40529;s:12:\"delete-41287\";i:40530;s:12:\"delete-41288\";i:40531;s:12:\"delete-41291\";i:40532;s:12:\"delete-41294\";i:40533;s:12:\"delete-41295\";i:40534;s:12:\"delete-41292\";i:40535;s:12:\"delete-41293\";i:40536;s:12:\"delete-41296\";i:40537;s:12:\"delete-41299\";i:40538;s:12:\"delete-41300\";i:40539;s:12:\"delete-41297\";i:40540;s:12:\"delete-41298\";i:40541;s:12:\"delete-41301\";i:40542;s:12:\"delete-41304\";i:40543;s:12:\"delete-41305\";i:40544;s:12:\"delete-41302\";i:40545;s:12:\"delete-41303\";i:40546;s:12:\"delete-41306\";i:40547;s:12:\"delete-41309\";i:40548;s:12:\"delete-41310\";i:40549;s:12:\"delete-41307\";i:40550;s:12:\"delete-41308\";i:40551;s:12:\"delete-41311\";i:40552;s:12:\"delete-41314\";i:40553;s:12:\"delete-41315\";i:40554;s:12:\"delete-41312\";i:40555;s:12:\"delete-41313\";i:40556;s:12:\"delete-41316\";i:40557;s:12:\"delete-41319\";i:40558;s:12:\"delete-41320\";i:40559;s:12:\"delete-41317\";i:40560;s:12:\"delete-41318\";i:40561;s:12:\"delete-41321\";i:40562;s:12:\"delete-41324\";i:40563;s:12:\"delete-41325\";i:40564;s:12:\"delete-41322\";i:40565;s:12:\"delete-41323\";i:40566;s:12:\"delete-41326\";i:40567;s:12:\"delete-41329\";i:40568;s:12:\"delete-41330\";i:40569;s:12:\"delete-41327\";i:40570;s:12:\"delete-41328\";i:40571;s:12:\"delete-41331\";i:40572;s:12:\"delete-41334\";i:40573;s:12:\"delete-41335\";i:40574;s:12:\"delete-41332\";i:40575;s:12:\"delete-41333\";i:40576;s:12:\"delete-41336\";i:40577;s:12:\"delete-41339\";i:40578;s:12:\"delete-41340\";i:40579;s:12:\"delete-41337\";i:40580;s:12:\"delete-41338\";i:40581;s:12:\"delete-41341\";i:40582;s:12:\"delete-41344\";i:40583;s:12:\"delete-41342\";i:40584;s:12:\"delete-41343\";i:40585;s:12:\"delete-41345\";i:40586;s:12:\"delete-41346\";i:40587;s:12:\"delete-41349\";i:40588;s:12:\"delete-41347\";i:40589;s:12:\"delete-41348\";i:40590;s:12:\"delete-41350\";i:40591;s:12:\"delete-41353\";i:40592;s:12:\"delete-41354\";i:40593;s:12:\"delete-41351\";i:40594;s:12:\"delete-41352\";i:40595;s:12:\"delete-41355\";i:40596;s:12:\"delete-41358\";i:40597;s:12:\"delete-41359\";i:40598;s:12:\"delete-41356\";i:40599;s:12:\"delete-41357\";i:40600;s:12:\"delete-41360\";i:40601;s:12:\"delete-41363\";i:40602;s:12:\"delete-41364\";i:40603;s:12:\"delete-41361\";i:40604;s:12:\"delete-41362\";i:40605;s:12:\"delete-41365\";i:40606;s:12:\"delete-41368\";i:40607;s:12:\"delete-41369\";i:40608;s:12:\"delete-41366\";i:40609;s:12:\"delete-41367\";i:40610;s:12:\"delete-41370\";i:40611;s:12:\"delete-41373\";i:40612;s:12:\"delete-41374\";i:40613;s:12:\"delete-41371\";i:40614;s:12:\"delete-41372\";i:40615;s:12:\"delete-41375\";i:40616;s:12:\"delete-41378\";i:40617;s:12:\"delete-41379\";i:40618;s:12:\"delete-41376\";i:40619;s:12:\"delete-41377\";i:40620;s:12:\"delete-41380\";i:40621;s:12:\"delete-41383\";i:40622;s:12:\"delete-41384\";i:40623;s:12:\"delete-41381\";i:40624;s:12:\"delete-41382\";i:40625;s:12:\"delete-41385\";i:40626;s:12:\"delete-41388\";i:40627;s:12:\"delete-41389\";i:40628;s:12:\"delete-41386\";i:40629;s:12:\"delete-41387\";i:40630;s:12:\"delete-41390\";i:40631;s:12:\"delete-41393\";i:40632;s:12:\"delete-41394\";i:40633;s:12:\"delete-41391\";i:40634;s:12:\"delete-41392\";i:40635;s:12:\"delete-41395\";i:40636;s:12:\"delete-41398\";i:40637;s:12:\"delete-41399\";i:40638;s:12:\"delete-41396\";i:40639;s:12:\"delete-41397\";i:40640;s:12:\"delete-41400\";i:40641;s:12:\"delete-41403\";i:40642;s:12:\"delete-41404\";i:40643;s:12:\"delete-41401\";i:40644;s:12:\"delete-41402\";i:40645;s:12:\"delete-41405\";i:40646;s:12:\"delete-41408\";i:40647;s:12:\"delete-41406\";i:40648;s:12:\"delete-41407\";i:40649;s:12:\"delete-41409\";i:40650;s:12:\"delete-41410\";i:40651;s:12:\"delete-41413\";i:40652;s:12:\"delete-41414\";i:40653;s:12:\"delete-41411\";i:40654;s:12:\"delete-41412\";i:40655;s:12:\"delete-41415\";i:40656;s:12:\"delete-41418\";i:40657;s:12:\"delete-41419\";i:40658;s:12:\"delete-41416\";i:40659;s:12:\"delete-41417\";i:40660;s:12:\"delete-41420\";i:40661;s:12:\"delete-41423\";i:40662;s:12:\"delete-41424\";i:40663;s:12:\"delete-41421\";i:40664;s:12:\"delete-41422\";i:40665;s:12:\"delete-41425\";i:40666;s:12:\"delete-41428\";i:40667;s:12:\"delete-41429\";i:40668;s:12:\"delete-41426\";i:40669;s:12:\"delete-41427\";i:40670;s:12:\"delete-41430\";i:40671;s:12:\"delete-41433\";i:40672;s:12:\"delete-41434\";i:40673;s:12:\"delete-41431\";i:40674;s:12:\"delete-41432\";i:40675;s:12:\"delete-41435\";i:40676;s:12:\"delete-41438\";i:40677;s:12:\"delete-41439\";i:40678;s:12:\"delete-41436\";i:40679;s:12:\"delete-41437\";i:40680;s:12:\"delete-41440\";i:40681;s:12:\"delete-41443\";i:40682;s:12:\"delete-41444\";i:40683;s:12:\"delete-41441\";i:40684;s:12:\"delete-41442\";i:40685;s:12:\"delete-41445\";i:40686;s:12:\"delete-41448\";i:40687;s:12:\"delete-41449\";i:40688;s:12:\"delete-41446\";i:40689;s:12:\"delete-41447\";i:40690;s:12:\"delete-41450\";i:40691;s:12:\"delete-41453\";i:40692;s:12:\"delete-41454\";i:40693;s:12:\"delete-41451\";i:40694;s:12:\"delete-41452\";i:40695;s:12:\"delete-41455\";i:40696;s:12:\"delete-41458\";i:40697;s:12:\"delete-41459\";i:40698;s:12:\"delete-41456\";i:40699;s:12:\"delete-41457\";i:40700;s:12:\"delete-41460\";i:40701;s:12:\"delete-41463\";i:40702;s:12:\"delete-41464\";i:40703;s:12:\"delete-41461\";i:40704;s:12:\"delete-41462\";i:40705;s:12:\"delete-41465\";i:40706;s:12:\"delete-41468\";i:40707;s:12:\"delete-41466\";i:40708;s:12:\"delete-41467\";i:40709;s:12:\"delete-41469\";i:40710;s:12:\"delete-41470\";i:40711;s:12:\"delete-41473\";i:40712;s:12:\"delete-41474\";i:40713;s:12:\"delete-41471\";i:40714;s:12:\"delete-41472\";i:40715;s:12:\"delete-41475\";i:40716;s:12:\"delete-41478\";i:40717;s:12:\"delete-41479\";i:40718;s:12:\"delete-41476\";i:40719;s:12:\"delete-41477\";i:40720;s:12:\"delete-41480\";i:40721;s:12:\"delete-41483\";i:40722;s:12:\"delete-41481\";i:40723;s:12:\"delete-41482\";i:40724;s:12:\"delete-41484\";i:40725;s:12:\"delete-41485\";i:40726;s:12:\"delete-41488\";i:40727;s:12:\"delete-41489\";i:40728;s:12:\"delete-41486\";i:40729;s:12:\"delete-41487\";i:40730;s:12:\"delete-41490\";i:40731;s:12:\"delete-41493\";i:40732;s:12:\"delete-41494\";i:40733;s:12:\"delete-41491\";i:40734;s:12:\"delete-41492\";i:40735;s:12:\"delete-41495\";i:40736;s:12:\"delete-41498\";i:40737;s:12:\"delete-41499\";i:40738;s:12:\"delete-41496\";i:40739;s:12:\"delete-41497\";i:40740;s:12:\"delete-41500\";i:40741;s:12:\"delete-41503\";i:40742;s:12:\"delete-41504\";i:40743;s:12:\"delete-41501\";i:40744;s:12:\"delete-41502\";i:40745;s:12:\"delete-41505\";i:40746;s:12:\"delete-41508\";i:40747;s:12:\"delete-41509\";i:40748;s:12:\"delete-41506\";i:40749;s:12:\"delete-41507\";i:40750;s:12:\"delete-41510\";i:40751;s:12:\"delete-41513\";i:40752;s:12:\"delete-41511\";i:40753;s:12:\"delete-41512\";i:40754;s:12:\"delete-41514\";i:40755;s:12:\"delete-41515\";i:40756;s:12:\"delete-41518\";i:40757;s:12:\"delete-41519\";i:40758;s:12:\"delete-41516\";i:40759;s:12:\"delete-41517\";i:40760;s:12:\"delete-41520\";i:40761;s:12:\"delete-41523\";i:40762;s:12:\"delete-41521\";i:40763;s:12:\"delete-41522\";i:40764;s:12:\"delete-41524\";i:40765;s:12:\"delete-41525\";i:40766;s:12:\"delete-41528\";i:40767;s:12:\"delete-41529\";i:40768;s:12:\"delete-41526\";i:40769;s:12:\"delete-41527\";i:40770;s:12:\"delete-41530\";i:40771;s:12:\"delete-41533\";i:40772;s:12:\"delete-41534\";i:40773;s:12:\"delete-41531\";i:40774;s:12:\"delete-41532\";i:40775;s:12:\"delete-41535\";i:40776;s:12:\"delete-41538\";i:40777;s:12:\"delete-41539\";i:40778;s:12:\"delete-41536\";i:40779;s:12:\"delete-41537\";i:40780;s:12:\"delete-41540\";i:40781;s:12:\"delete-41543\";i:40782;s:12:\"delete-41544\";i:40783;s:12:\"delete-41541\";i:40784;s:12:\"delete-41542\";i:40785;s:12:\"delete-41545\";i:40786;s:12:\"delete-41548\";i:40787;s:12:\"delete-41549\";i:40788;s:12:\"delete-41550\";i:40789;s:12:\"delete-41553\";i:40790;s:12:\"delete-41546\";i:40791;s:12:\"delete-41547\";i:40792;s:12:\"delete-41551\";i:40793;s:12:\"delete-41552\";i:40794;s:12:\"delete-41554\";i:40795;s:12:\"delete-41555\";i:40796;s:12:\"delete-41558\";i:40797;s:12:\"delete-41559\";i:40798;s:12:\"delete-41556\";i:40799;s:12:\"delete-41557\";i:40800;s:12:\"delete-41560\";i:40801;s:12:\"delete-41563\";i:40802;s:12:\"delete-41561\";i:40803;s:12:\"delete-41562\";i:40804;s:12:\"delete-41564\";i:40805;s:12:\"delete-41565\";i:40806;s:12:\"delete-41568\";i:40807;s:12:\"delete-41569\";i:40808;s:12:\"delete-41566\";i:40809;s:12:\"delete-41567\";i:40810;s:12:\"delete-41570\";i:40811;s:12:\"delete-41573\";i:40812;s:12:\"delete-41571\";i:40813;s:12:\"delete-41572\";i:40814;s:12:\"delete-41574\";i:40815;s:12:\"delete-41575\";i:40816;s:12:\"delete-41578\";i:40817;s:12:\"delete-41579\";i:40818;s:12:\"delete-41576\";i:40819;s:12:\"delete-41577\";i:40820;s:12:\"delete-41580\";i:40821;s:12:\"delete-41583\";i:40822;s:12:\"delete-41584\";i:40823;s:12:\"delete-41581\";i:40824;s:12:\"delete-41582\";i:40825;s:12:\"delete-41585\";i:40826;s:12:\"delete-41588\";i:40827;s:12:\"delete-41589\";i:40828;s:12:\"delete-41586\";i:40829;s:12:\"delete-41587\";i:40830;s:12:\"delete-41590\";i:40831;s:12:\"delete-41593\";i:40832;s:12:\"delete-41591\";i:40833;s:12:\"delete-41592\";i:40834;s:12:\"delete-41594\";i:40835;s:12:\"delete-41595\";i:40836;s:12:\"delete-41598\";i:40837;s:12:\"delete-41599\";i:40838;s:12:\"delete-41596\";i:40839;s:12:\"delete-41597\";i:40840;s:12:\"delete-41600\";i:40841;s:12:\"delete-41603\";i:40842;s:12:\"delete-41601\";i:40843;s:12:\"delete-41602\";i:40844;s:12:\"delete-41604\";i:40845;s:12:\"delete-41605\";i:40846;s:12:\"delete-41608\";i:40847;s:12:\"delete-41609\";i:40848;s:12:\"delete-41606\";i:40849;s:12:\"delete-41607\";i:40850;s:12:\"delete-41610\";i:40851;s:12:\"delete-41613\";i:40852;s:12:\"delete-41614\";i:40853;s:12:\"delete-41611\";i:40854;s:12:\"delete-41612\";i:40855;s:12:\"delete-41615\";i:40856;s:12:\"delete-41618\";i:40857;s:12:\"delete-41619\";i:40858;s:12:\"delete-41616\";i:40859;s:12:\"delete-41617\";i:40860;s:12:\"delete-41620\";i:40861;s:12:\"delete-41623\";i:40862;s:12:\"delete-41621\";i:40863;s:12:\"delete-41622\";i:40864;s:12:\"delete-41624\";i:40865;s:12:\"delete-41625\";i:40866;s:12:\"delete-41628\";i:40867;s:12:\"delete-41629\";i:40868;s:12:\"delete-41626\";i:40869;s:12:\"delete-41627\";i:40870;s:12:\"delete-41630\";i:40871;s:12:\"delete-41633\";i:40872;s:12:\"delete-41634\";i:40873;s:12:\"delete-41631\";i:40874;s:12:\"delete-41632\";i:40875;s:12:\"delete-41635\";i:40876;s:12:\"delete-41638\";i:40877;s:12:\"delete-41636\";i:40878;s:12:\"delete-41637\";i:40879;s:12:\"delete-41639\";i:40880;s:12:\"delete-41640\";i:40881;s:12:\"delete-41643\";i:40882;s:12:\"delete-41644\";i:40883;s:12:\"delete-41641\";i:40884;s:12:\"delete-41642\";i:40885;s:12:\"delete-41645\";i:40886;s:12:\"delete-41648\";i:40887;s:12:\"delete-41649\";i:40888;s:12:\"delete-41646\";i:40889;s:12:\"delete-41647\";i:40890;s:12:\"delete-41650\";i:40891;s:12:\"delete-41653\";i:40892;s:12:\"delete-41654\";i:40893;s:12:\"delete-41651\";i:40894;s:12:\"delete-41652\";i:40895;s:12:\"delete-41655\";i:40896;s:12:\"delete-41658\";i:40897;s:12:\"delete-41656\";i:40898;s:12:\"delete-41657\";i:40899;s:12:\"delete-41659\";i:40900;s:12:\"delete-41660\";i:40901;s:12:\"delete-41663\";i:40902;s:12:\"delete-41664\";i:40903;s:12:\"delete-41661\";i:40904;s:12:\"delete-41662\";i:40905;s:12:\"delete-41665\";i:40906;s:12:\"delete-41668\";i:40907;s:12:\"delete-41669\";i:40908;s:12:\"delete-41666\";i:40909;s:12:\"delete-41667\";i:40910;s:12:\"delete-41670\";i:40911;s:12:\"delete-41673\";i:40912;s:12:\"delete-41674\";i:40913;s:12:\"delete-41671\";i:40914;s:12:\"delete-41672\";i:40915;s:12:\"delete-41675\";i:40916;s:12:\"delete-41678\";i:40917;s:12:\"delete-41679\";i:40918;s:12:\"delete-41676\";i:40919;s:12:\"delete-41677\";i:40920;s:12:\"delete-41680\";i:40921;s:12:\"delete-41683\";i:40922;s:12:\"delete-41681\";i:40923;s:12:\"delete-41682\";i:40924;s:12:\"delete-41684\";i:40925;s:12:\"delete-41685\";i:40926;s:12:\"delete-41688\";i:40927;s:12:\"delete-41689\";i:40928;s:12:\"delete-41686\";i:40929;s:12:\"delete-41687\";i:40930;s:12:\"delete-41690\";i:40931;s:12:\"delete-41693\";i:40932;s:12:\"delete-41694\";i:40933;s:12:\"delete-41691\";i:40934;s:12:\"delete-41692\";i:40935;s:12:\"delete-41695\";i:40936;s:12:\"delete-41698\";i:40937;s:12:\"delete-41696\";i:40938;s:12:\"delete-41697\";i:40939;s:12:\"delete-41699\";i:40940;s:12:\"delete-41700\";i:40941;s:12:\"delete-41703\";i:40942;s:12:\"delete-41704\";i:40943;s:12:\"delete-41701\";i:40944;s:12:\"delete-41702\";i:40945;s:12:\"delete-41705\";i:40946;s:12:\"delete-41708\";i:40947;s:12:\"delete-41709\";i:40948;s:12:\"delete-41706\";i:40949;s:12:\"delete-41707\";i:40950;s:12:\"delete-41710\";i:40951;s:12:\"delete-41713\";i:40952;s:12:\"delete-41714\";i:40953;s:12:\"delete-41711\";i:40954;s:12:\"delete-41712\";i:40955;s:12:\"delete-41715\";i:40956;s:12:\"delete-41718\";i:40957;s:12:\"delete-41716\";i:40958;s:12:\"delete-41717\";i:40959;s:12:\"delete-41719\";i:40960;s:12:\"delete-41720\";i:40961;s:12:\"delete-41723\";i:40962;s:12:\"delete-41724\";i:40963;s:12:\"delete-41721\";i:40964;s:12:\"delete-41722\";i:40965;s:12:\"delete-41725\";i:40966;s:12:\"delete-41728\";i:40967;s:12:\"delete-41729\";i:40968;s:12:\"delete-41726\";i:40969;s:12:\"delete-41727\";i:40970;s:12:\"delete-41730\";i:40971;s:12:\"delete-41733\";i:40972;s:12:\"delete-41734\";i:40973;s:12:\"delete-41731\";i:40974;s:12:\"delete-41732\";i:40975;s:12:\"delete-41735\";i:40976;s:12:\"delete-41738\";i:40977;s:12:\"delete-41739\";i:40978;s:12:\"delete-41736\";i:40979;s:12:\"delete-41737\";i:40980;s:12:\"delete-41740\";i:40981;s:12:\"delete-41743\";i:40982;s:12:\"delete-41744\";i:40983;s:12:\"delete-41741\";i:40984;s:12:\"delete-41742\";i:40985;s:12:\"delete-41745\";i:40986;s:12:\"delete-41748\";i:40987;s:12:\"delete-41746\";i:40988;s:12:\"delete-41747\";i:40989;s:12:\"delete-41749\";i:40990;s:12:\"delete-41750\";i:40991;s:12:\"delete-41753\";i:40992;s:12:\"delete-41754\";i:40993;s:12:\"delete-41751\";i:40994;s:12:\"delete-41752\";i:40995;s:12:\"delete-41755\";i:40996;s:12:\"delete-41758\";i:40997;s:12:\"delete-41759\";i:40998;s:12:\"delete-41756\";i:40999;s:12:\"delete-41757\";i:41000;s:12:\"delete-41760\";i:41001;s:12:\"delete-41763\";i:41002;s:12:\"delete-41764\";i:41003;s:12:\"delete-41761\";i:41004;s:12:\"delete-41762\";i:41005;s:12:\"delete-41765\";i:41006;s:12:\"delete-41768\";i:41007;s:12:\"delete-41769\";i:41008;s:12:\"delete-41766\";i:41009;s:12:\"delete-41767\";i:41010;s:12:\"delete-41770\";i:41011;s:12:\"delete-41773\";i:41012;s:12:\"delete-41774\";i:41013;s:12:\"delete-41771\";i:41014;s:12:\"delete-41772\";i:41015;s:12:\"delete-41775\";i:41016;s:12:\"delete-41778\";i:41017;s:12:\"delete-41779\";i:41018;s:12:\"delete-41776\";i:41019;s:12:\"delete-41777\";i:41020;s:12:\"delete-41780\";i:41021;s:12:\"delete-41783\";i:41022;s:12:\"delete-41784\";i:41023;s:12:\"delete-41781\";i:41024;s:12:\"delete-41782\";i:41025;s:12:\"delete-41785\";i:41026;s:12:\"delete-41788\";i:41027;s:12:\"delete-41789\";i:41028;s:12:\"delete-41786\";i:41029;s:12:\"delete-41787\";i:41030;s:12:\"delete-41790\";i:41031;s:12:\"delete-41793\";i:41032;s:12:\"delete-41794\";i:41033;s:12:\"delete-41791\";i:41034;s:12:\"delete-41792\";i:41035;s:12:\"delete-41795\";i:41036;s:12:\"delete-41798\";i:41037;s:12:\"delete-41799\";i:41038;s:12:\"delete-41796\";i:41039;s:12:\"delete-41797\";i:41040;s:12:\"delete-41800\";i:41041;s:12:\"delete-41803\";i:41042;s:12:\"delete-41804\";i:41043;s:12:\"delete-41801\";i:41044;s:12:\"delete-41802\";i:41045;s:12:\"delete-41805\";i:41046;s:12:\"delete-41808\";i:41047;s:12:\"delete-41806\";i:41048;s:12:\"delete-41807\";i:41049;s:12:\"delete-41809\";i:41050;s:12:\"delete-41810\";i:41051;s:12:\"delete-41813\";i:41052;s:12:\"delete-41814\";i:41053;s:12:\"delete-41811\";i:41054;s:12:\"delete-41812\";i:41055;s:12:\"delete-41815\";i:41056;s:12:\"delete-41818\";i:41057;s:12:\"delete-41819\";i:41058;s:12:\"delete-41816\";i:41059;s:12:\"delete-41817\";i:41060;s:12:\"delete-41820\";i:41061;s:12:\"delete-41823\";i:41062;s:12:\"delete-41824\";i:41063;s:12:\"delete-41821\";i:41064;s:12:\"delete-41822\";i:41065;s:12:\"delete-41825\";i:41066;s:12:\"delete-41828\";i:41067;s:12:\"delete-41829\";i:41068;s:12:\"delete-41826\";i:41069;s:12:\"delete-41827\";i:41070;s:12:\"delete-41830\";i:41071;s:12:\"delete-41833\";i:41072;s:12:\"delete-41834\";i:41073;s:12:\"delete-41831\";i:41074;s:12:\"delete-41832\";i:41075;s:12:\"delete-41835\";i:41076;s:12:\"delete-41838\";i:41077;s:12:\"delete-41839\";i:41078;s:12:\"delete-41836\";i:41079;s:12:\"delete-41837\";i:41080;s:12:\"delete-41840\";i:41081;s:12:\"delete-41843\";i:41082;s:12:\"delete-41844\";i:41083;s:12:\"delete-41841\";i:41084;s:12:\"delete-41842\";i:41085;s:12:\"delete-41845\";i:41086;s:12:\"delete-41848\";i:41087;s:12:\"delete-41849\";i:41088;s:12:\"delete-41846\";i:41089;s:12:\"delete-41847\";i:41090;s:12:\"delete-41850\";i:41091;s:12:\"delete-41853\";i:41092;s:12:\"delete-41854\";i:41093;s:12:\"delete-41851\";i:41094;s:12:\"delete-41852\";i:41095;s:12:\"delete-41855\";i:41096;s:12:\"delete-41858\";i:41097;s:12:\"delete-41859\";i:41098;s:12:\"delete-41856\";i:41099;s:12:\"delete-41857\";i:41100;s:12:\"delete-41860\";i:41101;s:12:\"delete-41863\";i:41102;s:12:\"delete-41864\";i:41103;s:12:\"delete-41861\";i:41104;s:12:\"delete-41862\";i:41105;s:12:\"delete-41865\";i:41106;s:12:\"delete-41868\";i:41107;s:12:\"delete-41869\";i:41108;s:12:\"delete-41866\";i:41109;s:12:\"delete-41867\";i:41110;s:12:\"delete-41870\";i:41111;s:12:\"delete-41873\";i:41112;s:12:\"delete-41871\";i:41113;s:12:\"delete-41872\";i:41114;s:12:\"delete-41874\";i:41115;s:12:\"delete-41875\";i:41116;s:12:\"delete-41878\";i:41117;s:12:\"delete-41879\";i:41118;s:12:\"delete-41876\";i:41119;s:12:\"delete-41877\";i:41120;s:12:\"delete-41880\";i:41121;s:12:\"delete-41883\";i:41122;s:12:\"delete-41884\";i:41123;s:12:\"delete-41881\";i:41124;s:12:\"delete-41882\";i:41125;s:12:\"delete-41885\";i:41126;s:12:\"delete-41888\";i:41127;s:12:\"delete-41889\";i:41128;s:12:\"delete-41886\";i:41129;s:12:\"delete-41887\";i:41130;s:12:\"delete-41890\";i:41131;s:12:\"delete-41893\";i:41132;s:12:\"delete-41894\";i:41133;s:12:\"delete-41891\";i:41134;s:12:\"delete-41892\";i:41135;s:12:\"delete-41895\";i:41136;s:12:\"delete-41898\";i:41137;s:12:\"delete-41899\";i:41138;s:12:\"delete-41896\";i:41139;s:12:\"delete-41897\";i:41140;s:12:\"delete-41900\";i:41141;s:12:\"delete-41903\";i:41142;s:12:\"delete-41904\";i:41143;s:12:\"delete-41901\";i:41144;s:12:\"delete-41902\";i:41145;s:12:\"delete-41905\";i:41146;s:12:\"delete-41908\";i:41147;s:12:\"delete-41909\";i:41148;s:12:\"delete-41906\";i:41149;s:12:\"delete-41907\";i:41150;s:12:\"delete-41910\";i:41151;s:12:\"delete-41913\";i:41152;s:12:\"delete-41914\";i:41153;s:12:\"delete-41911\";i:41154;s:12:\"delete-41912\";i:41155;s:12:\"delete-41915\";i:41156;s:12:\"delete-41918\";i:41157;s:12:\"delete-41919\";i:41158;s:12:\"delete-41916\";i:41159;s:12:\"delete-41917\";i:41160;s:12:\"delete-41920\";i:41161;s:12:\"delete-41923\";i:41162;s:12:\"delete-41921\";i:41163;s:12:\"delete-41922\";i:41164;s:12:\"delete-41924\";i:41165;s:12:\"delete-41925\";i:41166;s:12:\"delete-41928\";i:41167;s:12:\"delete-41929\";i:41168;s:12:\"delete-41926\";i:41169;s:12:\"delete-41927\";i:41170;s:12:\"delete-41930\";i:41171;s:12:\"delete-41933\";i:41172;s:12:\"delete-41934\";i:41173;s:12:\"delete-41931\";i:41174;s:12:\"delete-41932\";i:41175;s:12:\"delete-41935\";i:41176;s:12:\"delete-41938\";i:41177;s:12:\"delete-41939\";i:41178;s:12:\"delete-41936\";i:41179;s:12:\"delete-41937\";i:41180;s:12:\"delete-41940\";i:41181;s:12:\"delete-41943\";i:41182;s:12:\"delete-41944\";i:41183;s:12:\"delete-41941\";i:41184;s:12:\"delete-41942\";i:41185;s:12:\"delete-41945\";i:41186;s:12:\"delete-41948\";i:41187;s:12:\"delete-41949\";i:41188;s:12:\"delete-41946\";i:41189;s:12:\"delete-41947\";i:41190;s:12:\"delete-41950\";i:41191;s:12:\"delete-41953\";i:41192;s:12:\"delete-41954\";i:41193;s:12:\"delete-41951\";i:41194;s:12:\"delete-41952\";i:41195;s:12:\"delete-41955\";i:41196;s:12:\"delete-41958\";i:41197;s:12:\"delete-41959\";i:41198;s:12:\"delete-41956\";i:41199;s:12:\"delete-41957\";i:41200;s:12:\"delete-41960\";i:41201;s:12:\"delete-41963\";i:41202;s:12:\"delete-41964\";i:41203;s:12:\"delete-41961\";i:41204;s:12:\"delete-41962\";i:41205;s:12:\"delete-41965\";i:41206;s:12:\"delete-41968\";i:41207;s:12:\"delete-41969\";i:41208;s:12:\"delete-41966\";i:41209;s:12:\"delete-41967\";i:41210;s:12:\"delete-41970\";i:41211;s:12:\"delete-41973\";i:41212;s:12:\"delete-41974\";i:41213;s:12:\"delete-41971\";i:41214;s:12:\"delete-41972\";i:41215;s:12:\"delete-41975\";i:41216;s:12:\"delete-41978\";i:41217;s:12:\"delete-41979\";i:41218;s:12:\"delete-41976\";i:41219;s:12:\"delete-41977\";i:41220;s:12:\"delete-41980\";i:41221;s:12:\"delete-41983\";i:41222;s:12:\"delete-41984\";i:41223;s:12:\"delete-41981\";i:41224;s:12:\"delete-41982\";i:41225;s:12:\"delete-41985\";i:41226;s:12:\"delete-41988\";i:41227;s:12:\"delete-41989\";i:41228;s:12:\"delete-41986\";i:41229;s:12:\"delete-41987\";i:41230;s:12:\"delete-41990\";i:41231;s:12:\"delete-41993\";i:41232;s:12:\"delete-41994\";i:41233;s:12:\"delete-41991\";i:41234;s:12:\"delete-41992\";i:41235;s:12:\"delete-41995\";i:41236;s:12:\"delete-41998\";i:41237;s:12:\"delete-41999\";i:41238;s:12:\"delete-41996\";i:41239;s:12:\"delete-41997\";i:41240;s:12:\"delete-42000\";i:41241;s:12:\"delete-42003\";i:41242;s:12:\"delete-42001\";i:41243;s:12:\"delete-42002\";i:41244;s:12:\"delete-42004\";i:41245;s:12:\"delete-42005\";i:41246;s:12:\"delete-42008\";i:41247;s:12:\"delete-42009\";i:41248;s:12:\"delete-42006\";i:41249;s:12:\"delete-42007\";i:41250;s:12:\"delete-42010\";i:41251;s:12:\"delete-42013\";i:41252;s:12:\"delete-42011\";i:41253;s:12:\"delete-42012\";i:41254;s:12:\"delete-42014\";i:41255;s:12:\"delete-42015\";i:41256;s:12:\"delete-42018\";i:41257;s:12:\"delete-42019\";i:41258;s:12:\"delete-42016\";i:41259;s:12:\"delete-42017\";i:41260;s:12:\"delete-42020\";i:41261;s:12:\"delete-42023\";i:41262;s:12:\"delete-42024\";i:41263;s:12:\"delete-42021\";i:41264;s:12:\"delete-42022\";i:41265;s:12:\"delete-42025\";i:41266;s:12:\"delete-42028\";i:41267;s:12:\"delete-42029\";i:41268;s:12:\"delete-42026\";i:41269;s:12:\"delete-42027\";i:41270;s:12:\"delete-42030\";i:41271;s:12:\"delete-42033\";i:41272;s:12:\"delete-42034\";i:41273;s:12:\"delete-42031\";i:41274;s:12:\"delete-42032\";i:41275;s:12:\"delete-42035\";i:41276;s:12:\"delete-42038\";i:41277;s:12:\"delete-42039\";i:41278;s:12:\"delete-42036\";i:41279;s:12:\"delete-42037\";i:41280;s:12:\"delete-42040\";i:41281;s:12:\"delete-42043\";i:41282;s:12:\"delete-42044\";i:41283;s:12:\"delete-42041\";i:41284;s:12:\"delete-42042\";i:41285;s:12:\"delete-42045\";i:41286;s:12:\"delete-42048\";i:41287;s:12:\"delete-42049\";i:41288;s:12:\"delete-42046\";i:41289;s:12:\"delete-42047\";i:41290;s:12:\"delete-42050\";i:41291;s:12:\"delete-42053\";i:41292;s:12:\"delete-42054\";i:41293;s:12:\"delete-42051\";i:41294;s:12:\"delete-42052\";i:41295;s:12:\"delete-42055\";i:41296;s:12:\"delete-42058\";i:41297;s:12:\"delete-42056\";i:41298;s:12:\"delete-42057\";i:41299;s:12:\"delete-42059\";i:41300;s:12:\"delete-42060\";i:41301;s:12:\"delete-42063\";i:41302;s:12:\"delete-42064\";i:41303;s:12:\"delete-42061\";i:41304;s:12:\"delete-42062\";i:41305;s:12:\"delete-42065\";i:41306;s:12:\"delete-42068\";i:41307;s:12:\"delete-42069\";i:41308;s:12:\"delete-42066\";i:41309;s:12:\"delete-42067\";i:41310;s:12:\"delete-42070\";i:41311;s:12:\"delete-42073\";i:41312;s:12:\"delete-42071\";i:41313;s:12:\"delete-42072\";i:41314;s:12:\"delete-42074\";i:41315;s:12:\"delete-42075\";i:41316;s:12:\"delete-42078\";i:41317;s:12:\"delete-42079\";i:41318;s:12:\"delete-42076\";i:41319;s:12:\"delete-42077\";i:41320;s:12:\"delete-42080\";i:41321;s:12:\"delete-42083\";i:41322;s:12:\"delete-42084\";i:41323;s:12:\"delete-42081\";i:41324;s:12:\"delete-42082\";i:41325;s:12:\"delete-42085\";i:41326;s:12:\"delete-42088\";i:41327;s:12:\"delete-42086\";i:41328;s:12:\"delete-42087\";i:41329;s:12:\"delete-42089\";i:41330;s:12:\"delete-42090\";i:41331;s:12:\"delete-42093\";i:41332;s:12:\"delete-42094\";i:41333;s:12:\"delete-42091\";i:41334;s:12:\"delete-42092\";i:41335;s:12:\"delete-42095\";i:41336;s:12:\"delete-42098\";i:41337;s:12:\"delete-42099\";i:41338;s:12:\"delete-42096\";i:41339;s:12:\"delete-42097\";i:41340;s:12:\"delete-42100\";i:41341;s:12:\"delete-42103\";i:41342;s:12:\"delete-42104\";i:41343;s:12:\"delete-42101\";i:41344;s:12:\"delete-42102\";i:41345;s:12:\"delete-42105\";i:41346;s:12:\"delete-42108\";i:41347;s:12:\"delete-42109\";i:41348;s:12:\"delete-42106\";i:41349;s:12:\"delete-42107\";i:41350;s:12:\"delete-42110\";i:41351;s:12:\"delete-42113\";i:41352;s:12:\"delete-42114\";i:41353;s:12:\"delete-42111\";i:41354;s:12:\"delete-42112\";i:41355;s:12:\"delete-42115\";i:41356;s:12:\"delete-42118\";i:41357;s:12:\"delete-42119\";i:41358;s:12:\"delete-42116\";i:41359;s:12:\"delete-42117\";i:41360;s:12:\"delete-42120\";i:41361;s:12:\"delete-42123\";i:41362;s:12:\"delete-42121\";i:41363;s:12:\"delete-42122\";i:41364;s:12:\"delete-42124\";i:41365;s:12:\"delete-42125\";i:41366;s:12:\"delete-42128\";i:41367;s:12:\"delete-42129\";i:41368;s:12:\"delete-42126\";i:41369;s:12:\"delete-42127\";i:41370;s:12:\"delete-42130\";i:41371;s:12:\"delete-42133\";i:41372;s:12:\"delete-42134\";i:41373;s:12:\"delete-42131\";i:41374;s:12:\"delete-42132\";i:41375;s:12:\"delete-42135\";i:41376;s:12:\"delete-42138\";i:41377;s:12:\"delete-42139\";i:41378;s:12:\"delete-42136\";i:41379;s:12:\"delete-42137\";i:41380;s:12:\"delete-42140\";i:41381;s:12:\"delete-42143\";i:41382;s:12:\"delete-42144\";i:41383;s:12:\"delete-42141\";i:41384;s:12:\"delete-42142\";i:41385;s:12:\"delete-42145\";i:41386;s:12:\"delete-42148\";i:41387;s:12:\"delete-42149\";i:41388;s:12:\"delete-42146\";i:41389;s:12:\"delete-42147\";i:41390;s:12:\"delete-42150\";i:41391;s:12:\"delete-42153\";i:41392;s:12:\"delete-42151\";i:41393;s:12:\"delete-42152\";i:41394;s:12:\"delete-42154\";i:41395;s:12:\"delete-42155\";i:41396;s:12:\"delete-42158\";i:41397;s:12:\"delete-42159\";i:41398;s:12:\"delete-42156\";i:41399;s:12:\"delete-42157\";i:41400;s:12:\"delete-42160\";i:41401;s:12:\"delete-42163\";i:41402;s:12:\"delete-42164\";i:41403;s:12:\"delete-42161\";i:41404;s:12:\"delete-42162\";i:41405;s:12:\"delete-42165\";i:41406;s:12:\"delete-42168\";i:41407;s:12:\"delete-42166\";i:41408;s:12:\"delete-42167\";i:41409;s:12:\"delete-42169\";i:41410;s:12:\"delete-42170\";i:41411;s:12:\"delete-42173\";i:41412;s:12:\"delete-42174\";i:41413;s:12:\"delete-42171\";i:41414;s:12:\"delete-42172\";i:41415;s:12:\"delete-42175\";i:41416;s:12:\"delete-42178\";i:41417;s:12:\"delete-42179\";i:41418;s:12:\"delete-42176\";i:41419;s:12:\"delete-42177\";i:41420;s:12:\"delete-42180\";i:41421;s:12:\"delete-42183\";i:41422;s:12:\"delete-42184\";i:41423;s:12:\"delete-42181\";i:41424;s:12:\"delete-42182\";i:41425;s:12:\"delete-42185\";i:41426;s:12:\"delete-42188\";i:41427;s:12:\"delete-42189\";i:41428;s:12:\"delete-42186\";i:41429;s:12:\"delete-42187\";i:41430;s:12:\"delete-42190\";i:41431;s:12:\"delete-42193\";i:41432;s:12:\"delete-42194\";i:41433;s:12:\"delete-42191\";i:41434;s:12:\"delete-42192\";i:41435;s:12:\"delete-42195\";i:41436;s:12:\"delete-42198\";i:41437;s:12:\"delete-42199\";i:41438;s:12:\"delete-42196\";i:41439;s:12:\"delete-42197\";i:41440;s:12:\"delete-42200\";i:41441;s:12:\"delete-42203\";i:41442;s:12:\"delete-42201\";i:41443;s:12:\"delete-42202\";i:41444;s:12:\"delete-42204\";i:41445;s:12:\"delete-42205\";i:41446;s:12:\"delete-42208\";i:41447;s:12:\"delete-42209\";i:41448;s:12:\"delete-42206\";i:41449;s:12:\"delete-42207\";i:41450;s:12:\"delete-42210\";i:41451;s:12:\"delete-42213\";i:41452;s:12:\"delete-42214\";i:41453;s:12:\"delete-42211\";i:41454;s:12:\"delete-42212\";i:41455;s:12:\"delete-42215\";i:41456;s:12:\"delete-42218\";i:41457;s:12:\"delete-42219\";i:41458;s:12:\"delete-42216\";i:41459;s:12:\"delete-42217\";i:41460;s:12:\"delete-42220\";i:41461;s:12:\"delete-42223\";i:41462;s:12:\"delete-42224\";i:41463;s:12:\"delete-42221\";i:41464;s:12:\"delete-42222\";i:41465;s:12:\"delete-42225\";i:41466;s:12:\"delete-42228\";i:41467;s:12:\"delete-42229\";i:41468;s:12:\"delete-42226\";i:41469;s:12:\"delete-42227\";i:41470;s:12:\"delete-42230\";i:41471;s:12:\"delete-42233\";i:41472;s:12:\"delete-42234\";i:41473;s:12:\"delete-42231\";i:41474;s:12:\"delete-42232\";i:41475;s:12:\"delete-42235\";i:41476;s:12:\"delete-42238\";i:41477;s:12:\"delete-42239\";i:41478;s:12:\"delete-42236\";i:41479;s:12:\"delete-42237\";i:41480;s:12:\"delete-42240\";i:41481;s:12:\"delete-42243\";i:41482;s:12:\"delete-42244\";i:41483;s:12:\"delete-42241\";i:41484;s:12:\"delete-42242\";i:41485;s:12:\"delete-42245\";i:41486;s:12:\"delete-42246\";i:41487;s:12:\"delete-42247\";i:41488;s:12:\"delete-42248\";i:41489;s:12:\"delete-42249\";i:41490;s:12:\"delete-42250\";i:41491;s:12:\"delete-42253\";i:41492;s:12:\"delete-42254\";i:41493;s:12:\"delete-42251\";i:41494;s:12:\"delete-42252\";i:41495;s:12:\"delete-42255\";i:41496;s:12:\"delete-42258\";i:41497;s:12:\"delete-42256\";i:41498;s:12:\"delete-42257\";i:41499;s:12:\"delete-42259\";i:41500;s:12:\"delete-42260\";i:41501;s:12:\"delete-42263\";i:41502;s:12:\"delete-42264\";i:41503;s:12:\"delete-42261\";i:41504;s:12:\"delete-42262\";i:41505;s:12:\"delete-42265\";i:41506;s:12:\"delete-42268\";i:41507;s:12:\"delete-42269\";i:41508;s:12:\"delete-42266\";i:41509;s:12:\"delete-42267\";i:41510;s:12:\"delete-42270\";i:41511;s:12:\"delete-42273\";i:41512;s:12:\"delete-42274\";i:41513;s:12:\"delete-42271\";i:41514;s:12:\"delete-42272\";i:41515;s:12:\"delete-42275\";i:41516;s:12:\"delete-42278\";i:41517;s:12:\"delete-42279\";i:41518;s:12:\"delete-42276\";i:41519;s:12:\"delete-42277\";i:41520;s:12:\"delete-42280\";i:41521;s:12:\"delete-42283\";i:41522;s:12:\"delete-42284\";i:41523;s:12:\"delete-42281\";i:41524;s:12:\"delete-42282\";i:41525;s:12:\"delete-42285\";i:41526;s:12:\"delete-42288\";i:41527;s:12:\"delete-42286\";i:41528;s:12:\"delete-42287\";i:41529;s:12:\"delete-42289\";i:41530;s:12:\"delete-42290\";i:41531;s:12:\"delete-42293\";i:41532;s:12:\"delete-42291\";i:41533;s:12:\"delete-42292\";i:41534;s:12:\"delete-42294\";i:41535;s:12:\"delete-42295\";i:41536;s:12:\"delete-42298\";i:41537;s:12:\"delete-42299\";i:41538;s:12:\"delete-42296\";i:41539;s:12:\"delete-42297\";i:41540;s:12:\"delete-42300\";i:41541;s:12:\"delete-42303\";i:41542;s:12:\"delete-42304\";i:41543;s:12:\"delete-42301\";i:41544;s:12:\"delete-42302\";i:41545;s:12:\"delete-42305\";i:41546;s:12:\"delete-42308\";i:41547;s:12:\"delete-42309\";i:41548;s:12:\"delete-42306\";i:41549;s:12:\"delete-42307\";i:41550;s:12:\"delete-42310\";i:41551;s:12:\"delete-42313\";i:41552;s:12:\"delete-42314\";i:41553;s:12:\"delete-42311\";i:41554;s:12:\"delete-42312\";i:41555;s:12:\"delete-42315\";i:41556;s:12:\"delete-42318\";i:41557;s:12:\"delete-42319\";i:41558;s:12:\"delete-42316\";i:41559;s:12:\"delete-42317\";i:41560;s:12:\"delete-42320\";i:41561;s:12:\"delete-42323\";i:41562;s:12:\"delete-42324\";i:41563;s:12:\"delete-42321\";i:41564;s:12:\"delete-42322\";i:41565;s:12:\"delete-42325\";i:41566;s:12:\"delete-42328\";i:41567;s:12:\"delete-42329\";i:41568;s:12:\"delete-42326\";i:41569;s:12:\"delete-42327\";i:41570;s:12:\"delete-42330\";i:41571;s:12:\"delete-42333\";i:41572;s:12:\"delete-42334\";i:41573;s:12:\"delete-42331\";i:41574;s:12:\"delete-42332\";i:41575;s:12:\"delete-42335\";i:41576;s:12:\"delete-42338\";i:41577;s:12:\"delete-42336\";i:41578;s:12:\"delete-42337\";i:41579;s:12:\"delete-42339\";i:41580;s:12:\"delete-42340\";i:41581;s:12:\"delete-42343\";i:41582;s:12:\"delete-42344\";i:41583;s:12:\"delete-42341\";i:41584;s:12:\"delete-42342\";i:41585;s:12:\"delete-42345\";i:41586;s:12:\"delete-42348\";i:41587;s:12:\"delete-42349\";i:41588;s:12:\"delete-42346\";i:41589;s:12:\"delete-42347\";i:41590;s:12:\"delete-42350\";i:41591;s:12:\"delete-42353\";i:41592;s:12:\"delete-42354\";i:41593;s:12:\"delete-42351\";i:41594;s:12:\"delete-42352\";i:41595;s:12:\"delete-42355\";i:41596;s:12:\"delete-42358\";i:41597;s:12:\"delete-42359\";i:41598;s:12:\"delete-42356\";i:41599;s:12:\"delete-42357\";i:41600;s:12:\"delete-42360\";i:41601;s:12:\"delete-42363\";i:41602;s:12:\"delete-42364\";i:41603;s:12:\"delete-42361\";i:41604;s:12:\"delete-42362\";i:41605;s:12:\"delete-42365\";i:41606;s:12:\"delete-42368\";i:41607;s:12:\"delete-42369\";i:41608;s:12:\"delete-42366\";i:41609;s:12:\"delete-42367\";i:41610;s:12:\"delete-42370\";i:41611;s:12:\"delete-42373\";i:41612;s:12:\"delete-42374\";i:41613;s:12:\"delete-42371\";i:41614;s:12:\"delete-42372\";i:41615;s:12:\"delete-42375\";i:41616;s:12:\"delete-42378\";i:41617;s:12:\"delete-42379\";i:41618;s:12:\"delete-42376\";i:41619;s:12:\"delete-42377\";i:41620;s:12:\"delete-42380\";i:41621;s:12:\"delete-42383\";i:41622;s:12:\"delete-42384\";i:41623;s:12:\"delete-42381\";i:41624;s:12:\"delete-42382\";i:41625;s:12:\"delete-42385\";i:41626;s:12:\"delete-42388\";i:41627;s:12:\"delete-42389\";i:41628;s:12:\"delete-42386\";i:41629;s:12:\"delete-42387\";i:41630;s:12:\"delete-42390\";i:41631;s:12:\"delete-42393\";i:41632;s:12:\"delete-42394\";i:41633;s:12:\"delete-42391\";i:41634;s:12:\"delete-42392\";i:41635;s:12:\"delete-42395\";i:41636;s:12:\"delete-42398\";i:41637;s:12:\"delete-42399\";i:41638;s:12:\"delete-42396\";i:41639;s:12:\"delete-42397\";i:41640;s:12:\"delete-42400\";i:41641;s:12:\"delete-42403\";i:41642;s:12:\"delete-42404\";i:41643;s:12:\"delete-42401\";i:41644;s:12:\"delete-42402\";i:41645;s:12:\"delete-42405\";i:41646;s:12:\"delete-42408\";i:41647;s:12:\"delete-42409\";i:41648;s:12:\"delete-42406\";i:41649;s:12:\"delete-42407\";i:41650;s:12:\"delete-42410\";i:41651;s:12:\"delete-42413\";i:41652;s:12:\"delete-42414\";i:41653;s:12:\"delete-42411\";i:41654;s:12:\"delete-42412\";i:41655;s:12:\"delete-42415\";i:41656;s:12:\"delete-42418\";i:41657;s:12:\"delete-42419\";i:41658;s:12:\"delete-42416\";i:41659;s:12:\"delete-42417\";i:41660;s:12:\"delete-42420\";i:41661;s:12:\"delete-42423\";i:41662;s:12:\"delete-42424\";i:41663;s:12:\"delete-42421\";i:41664;s:12:\"delete-42422\";i:41665;s:12:\"delete-42425\";i:41666;s:12:\"delete-42428\";i:41667;s:12:\"delete-42429\";i:41668;s:12:\"delete-42426\";i:41669;s:12:\"delete-42427\";i:41670;s:12:\"delete-42430\";i:41671;s:12:\"delete-42433\";i:41672;s:12:\"delete-42434\";i:41673;s:12:\"delete-42431\";i:41674;s:12:\"delete-42432\";i:41675;s:12:\"delete-42435\";i:41676;s:12:\"delete-42438\";i:41677;s:12:\"delete-42439\";i:41678;s:12:\"delete-42436\";i:41679;s:12:\"delete-42437\";i:41680;s:12:\"delete-42440\";i:41681;s:12:\"delete-42443\";i:41682;s:12:\"delete-42444\";i:41683;s:12:\"delete-42441\";i:41684;s:12:\"delete-42442\";i:41685;s:12:\"delete-42445\";i:41686;s:12:\"delete-42448\";i:41687;s:12:\"delete-42446\";i:41688;s:12:\"delete-42447\";i:41689;s:12:\"delete-42449\";i:41690;s:12:\"delete-42450\";i:41691;s:12:\"delete-42453\";i:41692;s:12:\"delete-42454\";i:41693;s:12:\"delete-42451\";i:41694;s:12:\"delete-42452\";i:41695;s:12:\"delete-42455\";i:41696;s:12:\"delete-42458\";i:41697;s:12:\"delete-42456\";i:41698;s:12:\"delete-42457\";i:41699;s:12:\"delete-42459\";i:41700;s:12:\"delete-42460\";i:41701;s:12:\"delete-42463\";i:41702;s:12:\"delete-42464\";i:41703;s:12:\"delete-42461\";i:41704;s:12:\"delete-42462\";i:41705;s:12:\"delete-42465\";i:41706;s:12:\"delete-42468\";i:41707;s:12:\"delete-42469\";i:41708;s:12:\"delete-42466\";i:41709;s:12:\"delete-42467\";i:41710;s:12:\"delete-42470\";i:41711;s:12:\"delete-42473\";i:41712;s:12:\"delete-42474\";i:41713;s:12:\"delete-42471\";i:41714;s:12:\"delete-42472\";i:41715;s:12:\"delete-42475\";i:41716;s:12:\"delete-42478\";i:41717;s:12:\"delete-42479\";i:41718;s:12:\"delete-42476\";i:41719;s:12:\"delete-42477\";i:41720;s:12:\"delete-42480\";i:41721;s:12:\"delete-42483\";i:41722;s:12:\"delete-42484\";i:41723;s:12:\"delete-42481\";i:41724;s:12:\"delete-42482\";i:41725;s:12:\"delete-42485\";i:41726;s:12:\"delete-42488\";i:41727;s:12:\"delete-42489\";i:41728;s:12:\"delete-42486\";i:41729;s:12:\"delete-42487\";i:41730;s:12:\"delete-42490\";i:41731;s:12:\"delete-42493\";i:41732;s:12:\"delete-42494\";i:41733;s:12:\"delete-42491\";i:41734;s:12:\"delete-42492\";i:41735;s:12:\"delete-42495\";i:41736;s:12:\"delete-42498\";i:41737;s:12:\"delete-42499\";i:41738;s:12:\"delete-42496\";i:41739;s:12:\"delete-42497\";i:41740;s:12:\"delete-42500\";i:41741;s:12:\"delete-42503\";i:41742;s:12:\"delete-42504\";i:41743;s:12:\"delete-42501\";i:41744;s:12:\"delete-42502\";i:41745;s:12:\"delete-42505\";i:41746;s:12:\"delete-42508\";i:41747;s:12:\"delete-42509\";i:41748;s:12:\"delete-42506\";i:41749;s:12:\"delete-42507\";i:41750;s:12:\"delete-42510\";i:41751;s:12:\"delete-42513\";i:41752;s:12:\"delete-42514\";i:41753;s:12:\"delete-42511\";i:41754;s:12:\"delete-42512\";i:41755;s:12:\"delete-42515\";i:41756;s:12:\"delete-42518\";i:41757;s:12:\"delete-42519\";i:41758;s:12:\"delete-42516\";i:41759;s:12:\"delete-42517\";i:41760;s:12:\"delete-42520\";i:41761;s:12:\"delete-42523\";i:41762;s:12:\"delete-42524\";i:41763;s:12:\"delete-42521\";i:41764;s:12:\"delete-42522\";i:41765;s:12:\"delete-42525\";i:41766;s:12:\"delete-42528\";i:41767;s:12:\"delete-42529\";i:41768;s:12:\"delete-42526\";i:41769;s:12:\"delete-42527\";i:41770;s:12:\"delete-42530\";i:41771;s:12:\"delete-42533\";i:41772;s:12:\"delete-42531\";i:41773;s:12:\"delete-42532\";i:41774;s:12:\"delete-42534\";i:41775;s:12:\"delete-42535\";i:41776;s:12:\"delete-42538\";i:41777;s:12:\"delete-42539\";i:41778;s:12:\"delete-42536\";i:41779;s:12:\"delete-42537\";i:41780;s:12:\"delete-42540\";i:41781;s:12:\"delete-42543\";i:41782;s:12:\"delete-42541\";i:41783;s:12:\"delete-42542\";i:41784;s:12:\"delete-42544\";i:41785;s:12:\"delete-42545\";i:41786;s:12:\"delete-42548\";i:41787;s:12:\"delete-42549\";i:41788;s:12:\"delete-42546\";i:41789;s:12:\"delete-42547\";i:41790;s:12:\"delete-42550\";i:41791;s:12:\"delete-42553\";i:41792;s:12:\"delete-42551\";i:41793;s:12:\"delete-42552\";i:41794;s:12:\"delete-42554\";i:41795;s:12:\"delete-42555\";i:41796;s:12:\"delete-42558\";i:41797;s:12:\"delete-42559\";i:41798;s:12:\"delete-42556\";i:41799;s:12:\"delete-42557\";i:41800;s:12:\"delete-42560\";i:41801;s:12:\"delete-42563\";i:41802;s:12:\"delete-42564\";i:41803;s:12:\"delete-42561\";i:41804;s:12:\"delete-42562\";i:41805;s:12:\"delete-42565\";i:41806;s:12:\"delete-42568\";i:41807;s:12:\"delete-42569\";i:41808;s:12:\"delete-42566\";i:41809;s:12:\"delete-42567\";i:41810;s:12:\"delete-42570\";i:41811;s:12:\"delete-42573\";i:41812;s:12:\"delete-42574\";i:41813;s:12:\"delete-42571\";i:41814;s:12:\"delete-42572\";i:41815;s:12:\"delete-42575\";i:41816;s:12:\"delete-42578\";i:41817;s:12:\"delete-42579\";i:41818;s:12:\"delete-42576\";i:41819;s:12:\"delete-42577\";i:41820;s:12:\"delete-42580\";i:41821;s:12:\"delete-42583\";i:41822;s:12:\"delete-42584\";i:41823;s:12:\"delete-42581\";i:41824;s:12:\"delete-42582\";i:41825;s:12:\"delete-42585\";i:41826;s:12:\"delete-42588\";i:41827;s:12:\"delete-42589\";i:41828;s:12:\"delete-42586\";i:41829;s:12:\"delete-42587\";i:41830;s:12:\"delete-42590\";i:41831;s:12:\"delete-42593\";i:41832;s:12:\"delete-42594\";i:41833;s:12:\"delete-42591\";i:41834;s:12:\"delete-42592\";i:41835;s:12:\"delete-42595\";i:41836;s:12:\"delete-42598\";i:41837;s:12:\"delete-42599\";i:41838;s:12:\"delete-42596\";i:41839;s:12:\"delete-42597\";i:41840;s:12:\"delete-42600\";i:41841;s:12:\"delete-42603\";i:41842;s:12:\"delete-42604\";i:41843;s:12:\"delete-42601\";i:41844;s:12:\"delete-42602\";i:41845;s:12:\"delete-42605\";i:41846;s:12:\"delete-42608\";i:41847;s:12:\"delete-42606\";i:41848;s:12:\"delete-42607\";i:41849;s:12:\"delete-42609\";i:41850;s:12:\"delete-42610\";i:41851;s:12:\"delete-42613\";i:41852;s:12:\"delete-42614\";i:41853;s:12:\"delete-42611\";i:41854;s:12:\"delete-42612\";i:41855;s:12:\"delete-42615\";i:41856;s:12:\"delete-42618\";i:41857;s:12:\"delete-42616\";i:41858;s:12:\"delete-42617\";i:41859;s:12:\"delete-42619\";i:41860;s:12:\"delete-42620\";i:41861;s:12:\"delete-42623\";i:41862;s:12:\"delete-42621\";i:41863;s:12:\"delete-42622\";i:41864;s:12:\"delete-42624\";i:41865;s:12:\"delete-42625\";i:41866;s:12:\"delete-42628\";i:41867;s:12:\"delete-42626\";i:41868;s:12:\"delete-42627\";i:41869;s:12:\"delete-42629\";i:41870;s:12:\"delete-42632\";i:41871;s:12:\"delete-42633\";i:41872;s:12:\"delete-42630\";i:41873;s:12:\"delete-42631\";i:41874;s:12:\"delete-42634\";i:41875;s:12:\"delete-42637\";i:41876;s:12:\"delete-42638\";i:41877;s:12:\"delete-42635\";i:41878;s:12:\"delete-42636\";i:41879;s:12:\"delete-42639\";i:41880;s:12:\"delete-42642\";i:41881;s:12:\"delete-42643\";i:41882;s:12:\"delete-42640\";i:41883;s:12:\"delete-42641\";i:41884;s:12:\"delete-42644\";i:41885;s:12:\"delete-42645\";i:41886;s:12:\"delete-42646\";i:41887;s:12:\"delete-42647\";i:41888;s:12:\"delete-42648\";i:41889;s:12:\"delete-42649\";i:41890;s:12:\"delete-42652\";i:41891;s:12:\"delete-42653\";i:41892;s:12:\"delete-42650\";i:41893;s:12:\"delete-42651\";i:41894;s:12:\"delete-42654\";i:41895;s:12:\"delete-42657\";i:41896;s:12:\"delete-42655\";i:41897;s:12:\"delete-42656\";i:41898;s:12:\"delete-42658\";i:41899;s:12:\"delete-42659\";i:41900;s:12:\"delete-42662\";i:41901;s:12:\"delete-42660\";i:41902;s:12:\"delete-42661\";i:41903;s:12:\"delete-42663\";i:41904;s:12:\"delete-42664\";i:41905;s:12:\"delete-42667\";i:41906;s:12:\"delete-42668\";i:41907;s:12:\"delete-42665\";i:41908;s:12:\"delete-42666\";i:41909;s:12:\"delete-42669\";i:41910;s:12:\"delete-42672\";i:41911;s:12:\"delete-42673\";i:41912;s:12:\"delete-42670\";i:41913;s:12:\"delete-42671\";i:41914;s:12:\"delete-42674\";i:41915;s:12:\"delete-42677\";i:41916;s:12:\"delete-42675\";i:41917;s:12:\"delete-42676\";i:41918;s:12:\"delete-42678\";i:41919;s:12:\"delete-42679\";i:41920;s:12:\"delete-42682\";i:41921;s:12:\"delete-42680\";i:41922;s:12:\"delete-42681\";i:41923;s:12:\"delete-42683\";i:41924;s:12:\"delete-42684\";i:41925;s:12:\"delete-42687\";i:41926;s:12:\"delete-42688\";i:41927;s:12:\"delete-42685\";i:41928;s:12:\"delete-42686\";i:41929;s:12:\"delete-42689\";i:41930;s:12:\"delete-42692\";i:41931;s:12:\"delete-42693\";i:41932;s:12:\"delete-42690\";i:41933;s:12:\"delete-42691\";i:41934;s:12:\"delete-42694\";i:41935;s:12:\"delete-42697\";i:41936;s:12:\"delete-42698\";i:41937;s:12:\"delete-42695\";i:41938;s:12:\"delete-42696\";i:41939;s:12:\"delete-42699\";i:41940;s:12:\"delete-42702\";i:41941;s:12:\"delete-42703\";i:41942;s:12:\"delete-42700\";i:41943;s:12:\"delete-42701\";i:41944;s:12:\"delete-42704\";i:41945;s:12:\"delete-42705\";i:41946;s:12:\"delete-42706\";i:41947;s:12:\"delete-42707\";i:41948;s:12:\"delete-42708\";i:41949;s:12:\"delete-42709\";i:41950;s:12:\"delete-42712\";i:41951;s:12:\"delete-42710\";i:41952;s:12:\"delete-42711\";i:41953;s:12:\"delete-42713\";i:41954;s:12:\"delete-42714\";i:41955;s:12:\"delete-42717\";i:41956;s:12:\"delete-42718\";i:41957;s:12:\"delete-42715\";i:41958;s:12:\"delete-42716\";i:41959;s:12:\"delete-42719\";i:41960;s:12:\"delete-42722\";i:41961;s:12:\"delete-42720\";i:41962;s:12:\"delete-42721\";i:41963;s:12:\"delete-42723\";i:41964;s:12:\"delete-42724\";i:41965;s:12:\"delete-42727\";i:41966;s:12:\"delete-42725\";i:41967;s:12:\"delete-42726\";i:41968;s:12:\"delete-42728\";i:41969;s:12:\"delete-42729\";i:41970;s:12:\"delete-42732\";i:41971;s:12:\"delete-42730\";i:41972;s:12:\"delete-42731\";i:41973;s:12:\"delete-42733\";i:41974;s:12:\"delete-42734\";i:41975;s:12:\"delete-42737\";i:41976;s:12:\"delete-42738\";i:41977;s:12:\"delete-42735\";i:41978;s:12:\"delete-42736\";i:41979;s:12:\"delete-42739\";i:41980;s:12:\"delete-42742\";i:41981;s:12:\"delete-42743\";i:41982;s:12:\"delete-42740\";i:41983;s:12:\"delete-42741\";i:41984;s:12:\"delete-42744\";i:41985;s:12:\"delete-42747\";i:41986;s:12:\"delete-42748\";i:41987;s:12:\"delete-42745\";i:41988;s:12:\"delete-42746\";i:41989;s:12:\"delete-42749\";i:41990;s:12:\"delete-42752\";i:41991;s:12:\"delete-42753\";i:41992;s:12:\"delete-42750\";i:41993;s:12:\"delete-42751\";i:41994;s:12:\"delete-42754\";i:41995;s:12:\"delete-42757\";i:41996;s:12:\"delete-42758\";i:41997;s:12:\"delete-42755\";i:41998;s:12:\"delete-42756\";i:41999;s:12:\"delete-42759\";i:42000;s:12:\"delete-42762\";i:42001;s:12:\"delete-42763\";i:42002;s:12:\"delete-42760\";i:42003;s:12:\"delete-42761\";i:42004;s:12:\"delete-42764\";i:42005;s:12:\"delete-42767\";i:42006;s:12:\"delete-42765\";i:42007;s:12:\"delete-42766\";i:42008;s:12:\"delete-42768\";i:42009;s:12:\"delete-42769\";i:42010;s:12:\"delete-42772\";i:42011;s:12:\"delete-42773\";i:42012;s:12:\"delete-42770\";i:42013;s:12:\"delete-42771\";i:42014;s:12:\"delete-42774\";i:42015;s:12:\"delete-42777\";i:42016;s:12:\"delete-42775\";i:42017;s:12:\"delete-42776\";i:42018;s:12:\"delete-42778\";i:42019;s:12:\"delete-42779\";i:42020;s:12:\"delete-42782\";i:42021;s:12:\"delete-42783\";i:42022;s:12:\"delete-42780\";i:42023;s:12:\"delete-42781\";i:42024;s:12:\"delete-42784\";i:42025;s:12:\"delete-42787\";i:42026;s:12:\"delete-42785\";i:42027;s:12:\"delete-42786\";i:42028;s:12:\"delete-42788\";i:42029;s:12:\"delete-42789\";i:42030;s:12:\"delete-42792\";i:42031;s:12:\"delete-42793\";i:42032;s:12:\"delete-42790\";i:42033;s:12:\"delete-42791\";i:42034;s:12:\"delete-42794\";i:42035;s:12:\"delete-42797\";i:42036;s:12:\"delete-42798\";i:42037;s:12:\"delete-42795\";i:42038;s:12:\"delete-42796\";i:42039;s:12:\"delete-42799\";i:42040;s:12:\"delete-42802\";i:42041;s:12:\"delete-42803\";i:42042;s:12:\"delete-42800\";i:42043;s:12:\"delete-42801\";i:42044;s:12:\"delete-42804\";i:42045;s:12:\"delete-42807\";i:42046;s:12:\"delete-42808\";i:42047;s:12:\"delete-42805\";i:42048;s:12:\"delete-42806\";i:42049;s:12:\"delete-42809\";i:42050;s:12:\"delete-42812\";i:42051;s:12:\"delete-42813\";i:42052;s:12:\"delete-42810\";i:42053;s:12:\"delete-42811\";i:42054;s:12:\"delete-42814\";i:42055;s:12:\"delete-42817\";i:42056;s:12:\"delete-42815\";i:42057;s:12:\"delete-42816\";i:42058;s:12:\"delete-42818\";i:42059;s:12:\"delete-42819\";i:42060;s:12:\"delete-42822\";i:42061;s:12:\"delete-42823\";i:42062;s:12:\"delete-42820\";i:42063;s:12:\"delete-42821\";i:42064;s:12:\"delete-42824\";i:42065;s:12:\"delete-42827\";i:42066;s:12:\"delete-42828\";i:42067;s:12:\"delete-42825\";i:42068;s:12:\"delete-42826\";i:42069;s:12:\"delete-42829\";i:42070;s:12:\"delete-42832\";i:42071;s:12:\"delete-42833\";i:42072;s:12:\"delete-42830\";i:42073;s:12:\"delete-42831\";i:42074;s:12:\"delete-42834\";i:42075;s:12:\"delete-42837\";i:42076;s:12:\"delete-42838\";i:42077;s:12:\"delete-42835\";i:42078;s:12:\"delete-42836\";i:42079;s:12:\"delete-42839\";i:42080;s:12:\"delete-42842\";i:42081;s:12:\"delete-42840\";i:42082;s:12:\"delete-42841\";i:42083;s:12:\"delete-42843\";i:42084;s:12:\"delete-42844\";i:42085;s:12:\"delete-42847\";i:42086;s:12:\"delete-42848\";i:42087;s:12:\"delete-42845\";i:42088;s:12:\"delete-42846\";i:42089;s:12:\"delete-42849\";i:42090;s:12:\"delete-42852\";i:42091;s:12:\"delete-42853\";i:42092;s:12:\"delete-42850\";i:42093;s:12:\"delete-42851\";i:42094;s:12:\"delete-42854\";i:42095;s:12:\"delete-42857\";i:42096;s:12:\"delete-42858\";i:42097;s:12:\"delete-42855\";i:42098;s:12:\"delete-42856\";i:42099;s:12:\"delete-42859\";i:42100;s:12:\"delete-42862\";i:42101;s:12:\"delete-42860\";i:42102;s:12:\"delete-42861\";i:42103;s:12:\"delete-42863\";i:42104;s:12:\"delete-42864\";i:42105;s:12:\"delete-42867\";i:42106;s:12:\"delete-42868\";i:42107;s:12:\"delete-42865\";i:42108;s:12:\"delete-42866\";i:42109;s:12:\"delete-42869\";i:42110;s:12:\"delete-42872\";i:42111;s:12:\"delete-42873\";i:42112;s:12:\"delete-42870\";i:42113;s:12:\"delete-42871\";i:42114;s:12:\"delete-42874\";i:42115;s:12:\"delete-42877\";i:42116;s:12:\"delete-42878\";i:42117;s:12:\"delete-42875\";i:42118;s:12:\"delete-42876\";i:42119;s:12:\"delete-42879\";i:42120;s:12:\"delete-42882\";i:42121;s:12:\"delete-42883\";i:42122;s:12:\"delete-42880\";i:42123;s:12:\"delete-42881\";i:42124;s:12:\"delete-42884\";i:42125;s:12:\"delete-42887\";i:42126;s:12:\"delete-42888\";i:42127;s:12:\"delete-42885\";i:42128;s:12:\"delete-42886\";i:42129;s:12:\"delete-42889\";i:42130;s:12:\"delete-42892\";i:42131;s:12:\"delete-42893\";i:42132;s:12:\"delete-42890\";i:42133;s:12:\"delete-42891\";i:42134;s:12:\"delete-42894\";i:42135;s:12:\"delete-42897\";i:42136;s:12:\"delete-42898\";i:42137;s:12:\"delete-42895\";i:42138;s:12:\"delete-42896\";i:42139;s:12:\"delete-42899\";i:42140;s:12:\"delete-42902\";i:42141;s:12:\"delete-42903\";i:42142;s:12:\"delete-42900\";i:42143;s:12:\"delete-42901\";i:42144;s:12:\"delete-42904\";i:42145;s:12:\"delete-42907\";i:42146;s:12:\"delete-42908\";i:42147;s:12:\"delete-42905\";i:42148;s:12:\"delete-42906\";i:42149;s:12:\"delete-42909\";i:42150;s:12:\"delete-42912\";i:42151;s:12:\"delete-42913\";i:42152;s:12:\"delete-42910\";i:42153;s:12:\"delete-42911\";i:42154;s:12:\"delete-42914\";i:42155;s:12:\"delete-42917\";i:42156;s:12:\"delete-42918\";i:42157;s:12:\"delete-42915\";i:42158;s:12:\"delete-42916\";i:42159;s:12:\"delete-42919\";i:42160;s:12:\"delete-42922\";i:42161;s:12:\"delete-42923\";i:42162;s:12:\"delete-42920\";i:42163;s:12:\"delete-42921\";i:42164;s:12:\"delete-42924\";i:42165;s:12:\"delete-42927\";i:42166;s:12:\"delete-42928\";i:42167;s:12:\"delete-42925\";i:42168;s:12:\"delete-42926\";i:42169;s:12:\"delete-42929\";i:42170;s:12:\"delete-42932\";i:42171;s:12:\"delete-42933\";i:42172;s:12:\"delete-42930\";i:42173;s:12:\"delete-42931\";i:42174;s:12:\"delete-42934\";i:42175;s:12:\"delete-42937\";i:42176;s:12:\"delete-42938\";i:42177;s:12:\"delete-42935\";i:42178;s:12:\"delete-42936\";i:42179;s:12:\"delete-42939\";i:42180;s:12:\"delete-42942\";i:42181;s:12:\"delete-42943\";i:42182;s:12:\"delete-42940\";i:42183;s:12:\"delete-42941\";i:42184;s:12:\"delete-42944\";i:42185;s:12:\"delete-42947\";i:42186;s:12:\"delete-42948\";i:42187;s:12:\"delete-42945\";i:42188;s:12:\"delete-42946\";i:42189;s:12:\"delete-42949\";i:42190;s:12:\"delete-42952\";i:42191;s:12:\"delete-42953\";i:42192;s:12:\"delete-42950\";i:42193;s:12:\"delete-42951\";i:42194;s:12:\"delete-42954\";i:42195;s:12:\"delete-42957\";i:42196;s:12:\"delete-42958\";i:42197;s:12:\"delete-42955\";i:42198;s:12:\"delete-42956\";i:42199;s:12:\"delete-42959\";i:42200;s:12:\"delete-42962\";i:42201;s:12:\"delete-42963\";i:42202;s:12:\"delete-42960\";i:42203;s:12:\"delete-42961\";i:42204;s:12:\"delete-42964\";i:42205;s:12:\"delete-42967\";i:42206;s:12:\"delete-42968\";i:42207;s:12:\"delete-42965\";i:42208;s:12:\"delete-42966\";i:42209;s:12:\"delete-42969\";i:42210;s:12:\"delete-42972\";i:42211;s:12:\"delete-42973\";i:42212;s:12:\"delete-42970\";i:42213;s:12:\"delete-42971\";i:42214;s:12:\"delete-42974\";i:42215;s:12:\"delete-42977\";i:42216;s:12:\"delete-42978\";i:42217;s:12:\"delete-42975\";i:42218;s:12:\"delete-42976\";i:42219;s:12:\"delete-42979\";i:42220;s:12:\"delete-42982\";i:42221;s:12:\"delete-42983\";i:42222;s:12:\"delete-42980\";i:42223;s:12:\"delete-42981\";i:42224;s:12:\"delete-42984\";i:42225;s:12:\"delete-42987\";i:42226;s:12:\"delete-42988\";i:42227;s:12:\"delete-42985\";i:42228;s:12:\"delete-42986\";i:42229;s:12:\"delete-42989\";i:42230;s:12:\"delete-42992\";i:42231;s:12:\"delete-42993\";i:42232;s:12:\"delete-42990\";i:42233;s:12:\"delete-42991\";i:42234;s:12:\"delete-42994\";i:42235;s:12:\"delete-42997\";i:42236;s:12:\"delete-42998\";i:42237;s:12:\"delete-42995\";i:42238;s:12:\"delete-42996\";i:42239;s:12:\"delete-42999\";i:42240;s:12:\"delete-43002\";i:42241;s:12:\"delete-43000\";i:42242;s:12:\"delete-43001\";i:42243;s:12:\"delete-43003\";i:42244;s:12:\"delete-43004\";i:42245;s:12:\"delete-43007\";i:42246;s:12:\"delete-43008\";i:42247;s:12:\"delete-43005\";i:42248;s:12:\"delete-43006\";i:42249;s:12:\"delete-43009\";i:42250;s:12:\"delete-43012\";i:42251;s:12:\"delete-43013\";i:42252;s:12:\"delete-43010\";i:42253;s:12:\"delete-43011\";i:42254;s:12:\"delete-43014\";i:42255;s:12:\"delete-43015\";i:42256;s:12:\"delete-43016\";i:42257;s:12:\"delete-43017\";i:42258;s:12:\"delete-43018\";i:42259;s:12:\"delete-43019\";i:42260;s:12:\"delete-43022\";i:42261;s:12:\"delete-43023\";i:42262;s:12:\"delete-43020\";i:42263;s:12:\"delete-43021\";i:42264;s:12:\"delete-43024\";i:42265;s:12:\"delete-43027\";i:42266;s:12:\"delete-43028\";i:42267;s:12:\"delete-43025\";i:42268;s:12:\"delete-43026\";i:42269;s:12:\"delete-43029\";i:42270;s:12:\"delete-43032\";i:42271;s:12:\"delete-43033\";i:42272;s:12:\"delete-43030\";i:42273;s:12:\"delete-43031\";i:42274;s:12:\"delete-43034\";i:42275;s:12:\"delete-43037\";i:42276;s:12:\"delete-43035\";i:42277;s:12:\"delete-43036\";i:42278;s:12:\"delete-43038\";i:42279;s:12:\"delete-43039\";i:42280;s:12:\"delete-43042\";i:42281;s:12:\"delete-43043\";i:42282;s:12:\"delete-43040\";i:42283;s:12:\"delete-43041\";i:42284;s:12:\"delete-43044\";i:42285;s:12:\"delete-43047\";i:42286;s:12:\"delete-43045\";i:42287;s:12:\"delete-43046\";i:42288;s:12:\"delete-43048\";i:42289;s:12:\"delete-43049\";i:42290;s:12:\"delete-43052\";i:42291;s:12:\"delete-43053\";i:42292;s:12:\"delete-43050\";i:42293;s:12:\"delete-43051\";i:42294;s:12:\"delete-43054\";i:42295;s:12:\"delete-43057\";i:42296;s:12:\"delete-43055\";i:42297;s:12:\"delete-43056\";i:42298;s:12:\"delete-43058\";i:42299;s:12:\"delete-43059\";i:42300;s:12:\"delete-43062\";i:42301;s:12:\"delete-43060\";i:42302;s:12:\"delete-43061\";i:42303;s:12:\"delete-43063\";i:42304;s:12:\"delete-43064\";i:42305;s:12:\"delete-43067\";i:42306;s:12:\"delete-43068\";i:42307;s:12:\"delete-43065\";i:42308;s:12:\"delete-43066\";i:42309;s:12:\"delete-43069\";i:42310;s:12:\"delete-43072\";i:42311;s:12:\"delete-43073\";i:42312;s:12:\"delete-43070\";i:42313;s:12:\"delete-43071\";i:42314;s:12:\"delete-43074\";i:42315;s:12:\"delete-43077\";i:42316;s:12:\"delete-43075\";i:42317;s:12:\"delete-43076\";i:42318;s:12:\"delete-43078\";i:42319;s:12:\"delete-43079\";i:42320;s:12:\"delete-43082\";i:42321;s:12:\"delete-43083\";i:42322;s:12:\"delete-43080\";i:42323;s:12:\"delete-43081\";i:42324;s:12:\"delete-43084\";i:42325;s:12:\"delete-43087\";i:42326;s:12:\"delete-43085\";i:42327;s:12:\"delete-43086\";i:42328;s:12:\"delete-43088\";i:42329;s:12:\"delete-43089\";i:42330;s:12:\"delete-43092\";i:42331;s:12:\"delete-43090\";i:42332;s:12:\"delete-43091\";i:42333;s:12:\"delete-43093\";i:42334;s:12:\"delete-43094\";i:42335;s:12:\"delete-43097\";i:42336;s:12:\"delete-43095\";i:42337;s:12:\"delete-43096\";i:42338;s:12:\"delete-43098\";i:42339;s:12:\"delete-43099\";i:42340;s:12:\"delete-43102\";i:42341;s:12:\"delete-43103\";i:42342;s:12:\"delete-43100\";i:42343;s:12:\"delete-43101\";i:42344;s:12:\"delete-43104\";i:42345;s:12:\"delete-43107\";i:42346;s:12:\"delete-43105\";i:42347;s:12:\"delete-43106\";i:42348;s:12:\"delete-43108\";i:42349;s:12:\"delete-43109\";i:42350;s:12:\"delete-43112\";i:42351;s:12:\"delete-43113\";i:42352;s:12:\"delete-43110\";i:42353;s:12:\"delete-43111\";i:42354;s:12:\"delete-43114\";i:42355;s:12:\"delete-43117\";i:42356;s:12:\"delete-43115\";i:42357;s:12:\"delete-43116\";i:42358;s:12:\"delete-43118\";i:42359;s:12:\"delete-43119\";i:42360;s:12:\"delete-43122\";i:42361;s:12:\"delete-43120\";i:42362;s:12:\"delete-43121\";i:42363;s:12:\"delete-43123\";i:42364;s:12:\"delete-43124\";i:42365;s:12:\"delete-43127\";i:42366;s:12:\"delete-43128\";i:42367;s:12:\"delete-43125\";i:42368;s:12:\"delete-43126\";i:42369;s:12:\"delete-43129\";i:42370;s:12:\"delete-43132\";i:42371;s:12:\"delete-43133\";i:42372;s:12:\"delete-43130\";i:42373;s:12:\"delete-43131\";i:42374;s:12:\"delete-43134\";i:42375;s:12:\"delete-43137\";i:42376;s:12:\"delete-43138\";i:42377;s:12:\"delete-43135\";i:42378;s:12:\"delete-43136\";i:42379;s:12:\"delete-43139\";i:42380;s:12:\"delete-43142\";i:42381;s:12:\"delete-43143\";i:42382;s:12:\"delete-43140\";i:42383;s:12:\"delete-43141\";i:42384;s:12:\"delete-43144\";i:42385;s:12:\"delete-43147\";i:42386;s:12:\"delete-43145\";i:42387;s:12:\"delete-43146\";i:42388;s:12:\"delete-43148\";i:42389;s:12:\"delete-43149\";i:42390;s:12:\"delete-43152\";i:42391;s:12:\"delete-43153\";i:42392;s:12:\"delete-43150\";i:42393;s:12:\"delete-43151\";i:42394;s:12:\"delete-43154\";i:42395;s:12:\"delete-43157\";i:42396;s:12:\"delete-43158\";i:42397;s:12:\"delete-43155\";i:42398;s:12:\"delete-43156\";i:42399;s:12:\"delete-43159\";i:42400;s:12:\"delete-43162\";i:42401;s:12:\"delete-43160\";i:42402;s:12:\"delete-43161\";i:42403;s:12:\"delete-43163\";i:42404;s:12:\"delete-43164\";i:42405;s:12:\"delete-43167\";i:42406;s:12:\"delete-43168\";i:42407;s:12:\"delete-43165\";i:42408;s:12:\"delete-43166\";i:42409;s:12:\"delete-43169\";i:42410;s:12:\"delete-43172\";i:42411;s:12:\"delete-43173\";i:42412;s:12:\"delete-43170\";i:42413;s:12:\"delete-43171\";i:42414;s:12:\"delete-43174\";i:42415;s:12:\"delete-43177\";i:42416;s:12:\"delete-43178\";i:42417;s:12:\"delete-43175\";i:42418;s:12:\"delete-43176\";i:42419;s:12:\"delete-43179\";i:42420;s:12:\"delete-43182\";i:42421;s:12:\"delete-43183\";i:42422;s:12:\"delete-43180\";i:42423;s:12:\"delete-43181\";i:42424;s:12:\"delete-43184\";i:42425;s:12:\"delete-43187\";i:42426;s:12:\"delete-43188\";i:42427;s:12:\"delete-43185\";i:42428;s:12:\"delete-43186\";i:42429;s:12:\"delete-43189\";i:42430;s:12:\"delete-43192\";i:42431;s:12:\"delete-43190\";i:42432;s:12:\"delete-43191\";i:42433;s:12:\"delete-43193\";i:42434;s:12:\"delete-43194\";i:42435;s:12:\"delete-43197\";i:42436;s:12:\"delete-43195\";i:42437;s:12:\"delete-43196\";i:42438;s:12:\"delete-43198\";i:42439;s:12:\"delete-43199\";i:42440;s:12:\"delete-43202\";i:42441;s:12:\"delete-43203\";i:42442;s:12:\"delete-43200\";i:42443;s:12:\"delete-43201\";i:42444;s:12:\"delete-43204\";i:42445;s:12:\"delete-43207\";i:42446;s:12:\"delete-43208\";i:42447;s:12:\"delete-43205\";i:42448;s:12:\"delete-43206\";i:42449;s:12:\"delete-43209\";i:42450;s:12:\"delete-43212\";i:42451;s:12:\"delete-43213\";i:42452;s:12:\"delete-43210\";i:42453;s:12:\"delete-43211\";i:42454;s:12:\"delete-43214\";i:42455;s:12:\"delete-43217\";i:42456;s:12:\"delete-43218\";i:42457;s:12:\"delete-43215\";i:42458;s:12:\"delete-43216\";i:42459;s:12:\"delete-43219\";i:42460;s:12:\"delete-43222\";i:42461;s:12:\"delete-43223\";i:42462;s:12:\"delete-43220\";i:42463;s:12:\"delete-43221\";i:42464;s:12:\"delete-43224\";i:42465;s:12:\"delete-43227\";i:42466;s:12:\"delete-43228\";i:42467;s:12:\"delete-43225\";i:42468;s:12:\"delete-43226\";i:42469;s:12:\"delete-43229\";i:42470;s:12:\"delete-43232\";i:42471;s:12:\"delete-43233\";i:42472;s:12:\"delete-43230\";i:42473;s:12:\"delete-43231\";i:42474;s:12:\"delete-43234\";i:42475;s:12:\"delete-43235\";i:42476;s:12:\"delete-43236\";i:42477;s:12:\"delete-43237\";i:42478;s:12:\"delete-43238\";i:42479;s:12:\"delete-43239\";i:42480;s:12:\"delete-43242\";i:42481;s:12:\"delete-43243\";i:42482;s:12:\"delete-43240\";i:42483;s:12:\"delete-43241\";i:42484;s:12:\"delete-43244\";i:42485;s:12:\"delete-43247\";i:42486;s:12:\"delete-43248\";i:42487;s:12:\"delete-43245\";i:42488;s:12:\"delete-43246\";i:42489;s:12:\"delete-43249\";i:42490;s:12:\"delete-43252\";i:42491;s:12:\"delete-43253\";i:42492;s:12:\"delete-43250\";i:42493;s:12:\"delete-43251\";i:42494;s:12:\"delete-43254\";i:42495;s:12:\"delete-43257\";i:42496;s:12:\"delete-43258\";i:42497;s:12:\"delete-43255\";i:42498;s:12:\"delete-43256\";i:42499;s:12:\"delete-43259\";i:42500;s:12:\"delete-43262\";i:42501;s:12:\"delete-43263\";i:42502;s:12:\"delete-43260\";i:42503;s:12:\"delete-43261\";i:42504;s:12:\"delete-43264\";i:42505;s:12:\"delete-43267\";i:42506;s:12:\"delete-43268\";i:42507;s:12:\"delete-43265\";i:42508;s:12:\"delete-43266\";i:42509;s:12:\"delete-43269\";i:42510;s:12:\"delete-43272\";i:42511;s:12:\"delete-43273\";i:42512;s:12:\"delete-43270\";i:42513;s:12:\"delete-43271\";i:42514;s:12:\"delete-43274\";i:42515;s:12:\"delete-43277\";i:42516;s:12:\"delete-43278\";i:42517;s:12:\"delete-43275\";i:42518;s:12:\"delete-43276\";i:42519;s:12:\"delete-43279\";i:42520;s:12:\"delete-43282\";i:42521;s:12:\"delete-43283\";i:42522;s:12:\"delete-43280\";i:42523;s:12:\"delete-43281\";i:42524;s:12:\"delete-43284\";i:42525;s:12:\"delete-43287\";i:42526;s:12:\"delete-43288\";i:42527;s:12:\"delete-43285\";i:42528;s:12:\"delete-43286\";i:42529;s:12:\"delete-43289\";i:42530;s:12:\"delete-43292\";i:42531;s:12:\"delete-43293\";i:42532;s:12:\"delete-43290\";i:42533;s:12:\"delete-43291\";i:42534;s:12:\"delete-43294\";i:42535;s:12:\"delete-43297\";i:42536;s:12:\"delete-43298\";i:42537;s:12:\"delete-43295\";i:42538;s:12:\"delete-43296\";i:42539;s:12:\"delete-43299\";i:42540;s:12:\"delete-43302\";i:42541;s:12:\"delete-43300\";i:42542;s:12:\"delete-43301\";i:42543;s:12:\"delete-43303\";i:42544;s:12:\"delete-43304\";i:42545;s:12:\"delete-43307\";i:42546;s:12:\"delete-43308\";i:42547;s:12:\"delete-43305\";i:42548;s:12:\"delete-43306\";i:42549;s:12:\"delete-43309\";i:42550;s:12:\"delete-43312\";i:42551;s:12:\"delete-43310\";i:42552;s:12:\"delete-43311\";i:42553;s:12:\"delete-43313\";i:42554;s:12:\"delete-43314\";i:42555;s:12:\"delete-43317\";i:42556;s:12:\"delete-43318\";i:42557;s:12:\"delete-43315\";i:42558;s:12:\"delete-43316\";i:42559;s:12:\"delete-43319\";i:42560;s:12:\"delete-43322\";i:42561;s:12:\"delete-43323\";i:42562;s:12:\"delete-43320\";i:42563;s:12:\"delete-43321\";i:42564;s:12:\"delete-43324\";i:42565;s:12:\"delete-43327\";i:42566;s:12:\"delete-43328\";i:42567;s:12:\"delete-43325\";i:42568;s:12:\"delete-43326\";i:42569;s:12:\"delete-43329\";i:42570;s:12:\"delete-43332\";i:42571;s:12:\"delete-43333\";i:42572;s:12:\"delete-43330\";i:42573;s:12:\"delete-43331\";i:42574;s:12:\"delete-43334\";i:42575;s:12:\"delete-43337\";i:42576;s:12:\"delete-43338\";i:42577;s:12:\"delete-43335\";i:42578;s:12:\"delete-43336\";i:42579;s:12:\"delete-43339\";i:42580;s:12:\"delete-43342\";i:42581;s:12:\"delete-43343\";i:42582;s:12:\"delete-43340\";i:42583;s:12:\"delete-43341\";i:42584;s:12:\"delete-43344\";i:42585;s:12:\"delete-43347\";i:42586;s:12:\"delete-43348\";i:42587;s:12:\"delete-43345\";i:42588;s:12:\"delete-43346\";i:42589;s:12:\"delete-43349\";i:42590;s:12:\"delete-43352\";i:42591;s:12:\"delete-43353\";i:42592;s:12:\"delete-43350\";i:42593;s:12:\"delete-43351\";i:42594;s:12:\"delete-43354\";i:42595;s:12:\"delete-43357\";i:42596;s:12:\"delete-43358\";i:42597;s:12:\"delete-43355\";i:42598;s:12:\"delete-43356\";i:42599;s:12:\"delete-43359\";i:42600;s:12:\"delete-43362\";i:42601;s:12:\"delete-43363\";i:42602;s:12:\"delete-43360\";i:42603;s:12:\"delete-43361\";i:42604;s:12:\"delete-43364\";i:42605;s:12:\"delete-43367\";i:42606;s:12:\"delete-43368\";i:42607;s:12:\"delete-43365\";i:42608;s:12:\"delete-43366\";i:42609;s:12:\"delete-43369\";i:42610;s:12:\"delete-43372\";i:42611;s:12:\"delete-43373\";i:42612;s:12:\"delete-43370\";i:42613;s:12:\"delete-43371\";i:42614;s:12:\"delete-43374\";i:42615;s:12:\"delete-43377\";i:42616;s:12:\"delete-43378\";i:42617;s:12:\"delete-43375\";i:42618;s:12:\"delete-43376\";i:42619;s:12:\"delete-43379\";i:42620;s:12:\"delete-43380\";i:42621;s:12:\"delete-43381\";i:42622;s:12:\"delete-43382\";i:42623;s:12:\"delete-43383\";i:42624;s:12:\"delete-43384\";i:42625;s:12:\"delete-43387\";i:42626;s:12:\"delete-43388\";i:42627;s:12:\"delete-43385\";i:42628;s:12:\"delete-43386\";i:42629;s:12:\"delete-43389\";i:42630;s:12:\"delete-43392\";i:42631;s:12:\"delete-43393\";i:42632;s:12:\"delete-43390\";i:42633;s:12:\"delete-43391\";i:42634;s:12:\"delete-43394\";i:42635;s:12:\"delete-43397\";i:42636;s:12:\"delete-43398\";i:42637;s:12:\"delete-43395\";i:42638;s:12:\"delete-43396\";i:42639;s:12:\"delete-43399\";i:42640;s:12:\"delete-43402\";i:42641;s:12:\"delete-43403\";i:42642;s:12:\"delete-43400\";i:42643;s:12:\"delete-43401\";i:42644;s:12:\"delete-43404\";i:42645;s:12:\"delete-43407\";i:42646;s:12:\"delete-43408\";i:42647;s:12:\"delete-43405\";i:42648;s:12:\"delete-43406\";i:42649;s:12:\"delete-43409\";i:42650;s:12:\"delete-43412\";i:42651;s:12:\"delete-43413\";i:42652;s:12:\"delete-43410\";i:42653;s:12:\"delete-43411\";i:42654;s:12:\"delete-43414\";i:42655;s:12:\"delete-43417\";i:42656;s:12:\"delete-43418\";i:42657;s:12:\"delete-43415\";i:42658;s:12:\"delete-43416\";i:42659;s:12:\"delete-43419\";i:42660;s:12:\"delete-43422\";i:42661;s:12:\"delete-43420\";i:42662;s:12:\"delete-43421\";i:42663;s:12:\"delete-43423\";i:42664;s:12:\"delete-43424\";i:42665;s:12:\"delete-43427\";i:42666;s:12:\"delete-43428\";i:42667;s:12:\"delete-43425\";i:42668;s:12:\"delete-43426\";i:42669;s:12:\"delete-43429\";i:42670;s:12:\"delete-43432\";i:42671;s:12:\"delete-43433\";i:42672;s:12:\"delete-43430\";i:42673;s:12:\"delete-43431\";i:42674;s:12:\"delete-43434\";i:42675;s:12:\"delete-43437\";i:42676;s:12:\"delete-43438\";i:42677;s:12:\"delete-43435\";i:42678;s:12:\"delete-43436\";i:42679;s:12:\"delete-43439\";i:42680;s:12:\"delete-43442\";i:42681;s:12:\"delete-43443\";i:42682;s:12:\"delete-43440\";i:42683;s:12:\"delete-43441\";i:42684;s:12:\"delete-43444\";i:42685;s:12:\"delete-43447\";i:42686;s:12:\"delete-43448\";i:42687;s:12:\"delete-43445\";i:42688;s:12:\"delete-43446\";i:42689;s:12:\"delete-43449\";i:42690;s:12:\"delete-43452\";i:42691;s:12:\"delete-43453\";i:42692;s:12:\"delete-43450\";i:42693;s:12:\"delete-43451\";i:42694;s:12:\"delete-43454\";i:42695;s:12:\"delete-43457\";i:42696;s:12:\"delete-43458\";i:42697;s:12:\"delete-43455\";i:42698;s:12:\"delete-43456\";i:42699;s:12:\"delete-43459\";i:42700;s:12:\"delete-43462\";i:42701;s:12:\"delete-43463\";i:42702;s:12:\"delete-43460\";i:42703;s:12:\"delete-43461\";i:42704;s:12:\"delete-43464\";i:42705;s:12:\"delete-43467\";i:42706;s:12:\"delete-43465\";i:42707;s:12:\"delete-43466\";i:42708;s:12:\"delete-43468\";i:42709;s:12:\"delete-43469\";i:42710;s:12:\"delete-43470\";i:42711;s:12:\"delete-43471\";i:42712;s:12:\"delete-43472\";i:42713;s:12:\"delete-43473\";i:42714;s:12:\"delete-43474\";i:42715;s:12:\"delete-43477\";i:42716;s:12:\"delete-43478\";i:42717;s:12:\"delete-43475\";i:42718;s:12:\"delete-43476\";i:42719;s:12:\"delete-43479\";i:42720;s:12:\"delete-43482\";i:42721;s:12:\"delete-43480\";i:42722;s:12:\"delete-43481\";i:42723;s:12:\"delete-43483\";i:42724;s:12:\"delete-43484\";i:42725;s:12:\"delete-43487\";i:42726;s:12:\"delete-43488\";i:42727;s:12:\"delete-43485\";i:42728;s:12:\"delete-43486\";i:42729;s:12:\"delete-43489\";i:42730;s:12:\"delete-43492\";i:42731;s:12:\"delete-43493\";i:42732;s:12:\"delete-43490\";i:42733;s:12:\"delete-43491\";i:42734;s:12:\"delete-43494\";i:42735;s:12:\"delete-43497\";i:42736;s:12:\"delete-43495\";i:42737;s:12:\"delete-43496\";i:42738;s:12:\"delete-43498\";i:42739;s:12:\"delete-43499\";i:42740;s:12:\"delete-43502\";i:42741;s:12:\"delete-43503\";i:42742;s:12:\"delete-43500\";i:42743;s:12:\"delete-43501\";i:42744;s:12:\"delete-43504\";i:42745;s:12:\"delete-43507\";i:42746;s:12:\"delete-43508\";i:42747;s:12:\"delete-43505\";i:42748;s:12:\"delete-43506\";i:42749;s:12:\"delete-43509\";i:42750;s:12:\"delete-43512\";i:42751;s:12:\"delete-43510\";i:42752;s:12:\"delete-43511\";i:42753;s:12:\"delete-43513\";i:42754;s:12:\"delete-43514\";i:42755;s:12:\"delete-43517\";i:42756;s:12:\"delete-43518\";i:42757;s:12:\"delete-43515\";i:42758;s:12:\"delete-43516\";i:42759;s:12:\"delete-43519\";i:42760;s:12:\"delete-43522\";i:42761;s:12:\"delete-43520\";i:42762;s:12:\"delete-43521\";i:42763;s:12:\"delete-43523\";i:42764;s:12:\"delete-43524\";i:42765;s:12:\"delete-43527\";i:42766;s:12:\"delete-43528\";i:42767;s:12:\"delete-43525\";i:42768;s:12:\"delete-43526\";i:42769;s:12:\"delete-43529\";i:42770;s:12:\"delete-43532\";i:42771;s:12:\"delete-43533\";i:42772;s:12:\"delete-43530\";i:42773;s:12:\"delete-43531\";i:42774;s:12:\"delete-43534\";i:42775;s:12:\"delete-43537\";i:42776;s:12:\"delete-43538\";i:42777;s:12:\"delete-43535\";i:42778;s:12:\"delete-43536\";i:42779;s:12:\"delete-43539\";i:42780;s:12:\"delete-43542\";i:42781;s:12:\"delete-43543\";i:42782;s:12:\"delete-43540\";i:42783;s:12:\"delete-43541\";i:42784;s:12:\"delete-43544\";i:42785;s:12:\"delete-43547\";i:42786;s:12:\"delete-43548\";i:42787;s:12:\"delete-43545\";i:42788;s:12:\"delete-43546\";i:42789;s:12:\"delete-43549\";i:42790;s:12:\"delete-43552\";i:42791;s:12:\"delete-43553\";i:42792;s:12:\"delete-43550\";i:42793;s:12:\"delete-43551\";i:42794;s:12:\"delete-43554\";i:42795;s:12:\"delete-43557\";i:42796;s:12:\"delete-43558\";i:42797;s:12:\"delete-43555\";i:42798;s:12:\"delete-43556\";i:42799;s:12:\"delete-43559\";i:42800;s:12:\"delete-43562\";i:42801;s:12:\"delete-43560\";i:42802;s:12:\"delete-43561\";i:42803;s:12:\"delete-43563\";i:42804;s:12:\"delete-43564\";i:42805;s:12:\"delete-43567\";i:42806;s:12:\"delete-43568\";i:42807;s:12:\"delete-43565\";i:42808;s:12:\"delete-43566\";i:42809;s:12:\"delete-43569\";i:42810;s:12:\"delete-43572\";i:42811;s:12:\"delete-43573\";i:42812;s:12:\"delete-43570\";i:42813;s:12:\"delete-43571\";i:42814;s:12:\"delete-43574\";i:42815;s:12:\"delete-43577\";i:42816;s:12:\"delete-43575\";i:42817;s:12:\"delete-43576\";i:42818;s:12:\"delete-43578\";i:42819;s:12:\"delete-43579\";i:42820;s:12:\"delete-43582\";i:42821;s:12:\"delete-43583\";i:42822;s:12:\"delete-43580\";i:42823;s:12:\"delete-43581\";i:42824;s:12:\"delete-43584\";i:42825;s:12:\"delete-43587\";i:42826;s:12:\"delete-43585\";i:42827;s:12:\"delete-43586\";i:42828;s:12:\"delete-43588\";i:42829;s:12:\"delete-43589\";i:42830;s:12:\"delete-43592\";i:42831;s:12:\"delete-43593\";i:42832;s:12:\"delete-43590\";i:42833;s:12:\"delete-43591\";i:42834;s:12:\"delete-43594\";i:42835;s:12:\"delete-43597\";i:42836;s:12:\"delete-43595\";i:42837;s:12:\"delete-43596\";i:42838;s:12:\"delete-43598\";i:42839;s:12:\"delete-43599\";i:42840;s:12:\"delete-43602\";i:42841;s:12:\"delete-43603\";i:42842;s:12:\"delete-43600\";i:42843;s:12:\"delete-43601\";i:42844;s:12:\"delete-43604\";i:42845;s:12:\"delete-43607\";i:42846;s:12:\"delete-43605\";i:42847;s:12:\"delete-43606\";i:42848;s:12:\"delete-43608\";i:42849;s:12:\"delete-43609\";i:42850;s:12:\"delete-43612\";i:42851;s:12:\"delete-43613\";i:42852;s:12:\"delete-43610\";i:42853;s:12:\"delete-43611\";i:42854;s:12:\"delete-43614\";i:42855;s:12:\"delete-43617\";i:42856;s:12:\"delete-43618\";i:42857;s:12:\"delete-43615\";i:42858;s:12:\"delete-43616\";i:42859;s:12:\"delete-43619\";i:42860;s:12:\"delete-43622\";i:42861;s:12:\"delete-43623\";i:42862;s:12:\"delete-43620\";i:42863;s:12:\"delete-43621\";i:42864;s:12:\"delete-43624\";i:42865;s:12:\"delete-43627\";i:42866;s:12:\"delete-43628\";i:42867;s:12:\"delete-43625\";i:42868;s:12:\"delete-43626\";i:42869;s:12:\"delete-43629\";i:42870;s:12:\"delete-43632\";i:42871;s:12:\"delete-43633\";i:42872;s:12:\"delete-43630\";i:42873;s:12:\"delete-43631\";i:42874;s:12:\"delete-43634\";i:42875;s:12:\"delete-43637\";i:42876;s:12:\"delete-43635\";i:42877;s:12:\"delete-43636\";i:42878;s:12:\"delete-43638\";i:42879;s:12:\"delete-43639\";i:42880;s:12:\"delete-43642\";i:42881;s:12:\"delete-43643\";i:42882;s:12:\"delete-43640\";i:42883;s:12:\"delete-43641\";i:42884;s:12:\"delete-43644\";i:42885;s:12:\"delete-43647\";i:42886;s:12:\"delete-43648\";i:42887;s:12:\"delete-43645\";i:42888;s:12:\"delete-43646\";i:42889;s:12:\"delete-43649\";i:42890;s:12:\"delete-43652\";i:42891;s:12:\"delete-43653\";i:42892;s:12:\"delete-43650\";i:42893;s:12:\"delete-43651\";i:42894;s:12:\"delete-43654\";i:42895;s:12:\"delete-43657\";i:42896;s:12:\"delete-43658\";i:42897;s:12:\"delete-43655\";i:42898;s:12:\"delete-43656\";i:42899;s:12:\"delete-43659\";i:42900;s:12:\"delete-43662\";i:42901;s:12:\"delete-43663\";i:42902;s:12:\"delete-43660\";i:42903;s:12:\"delete-43661\";i:42904;s:12:\"delete-43664\";i:42905;s:12:\"delete-43667\";i:42906;s:12:\"delete-43665\";i:42907;s:12:\"delete-43666\";i:42908;s:12:\"delete-43668\";i:42909;s:12:\"delete-43669\";i:42910;s:12:\"delete-43672\";i:42911;s:12:\"delete-43670\";i:42912;s:12:\"delete-43671\";i:42913;s:12:\"delete-43673\";i:42914;s:12:\"delete-43674\";i:42915;s:12:\"delete-43677\";i:42916;s:12:\"delete-43678\";i:42917;s:12:\"delete-43675\";i:42918;s:12:\"delete-43676\";i:42919;s:12:\"delete-43679\";i:42920;s:12:\"delete-43682\";i:42921;s:12:\"delete-43683\";i:42922;s:12:\"delete-43680\";i:42923;s:12:\"delete-43681\";i:42924;s:12:\"delete-43684\";i:42925;s:12:\"delete-43687\";i:42926;s:12:\"delete-43685\";i:42927;s:12:\"delete-43686\";i:42928;s:12:\"delete-43688\";i:42929;s:12:\"delete-43689\";i:42930;s:12:\"delete-43692\";i:42931;s:12:\"delete-43693\";i:42932;s:12:\"delete-43690\";i:42933;s:12:\"delete-43691\";i:42934;s:12:\"delete-43694\";i:42935;s:12:\"delete-43695\";i:42936;s:12:\"delete-43696\";i:42937;s:12:\"delete-43697\";i:42938;s:12:\"delete-43698\";i:42939;s:12:\"delete-43699\";i:42940;s:12:\"delete-43702\";i:42941;s:12:\"delete-43703\";i:42942;s:12:\"delete-43700\";i:42943;s:12:\"delete-43701\";i:42944;s:12:\"delete-43704\";i:42945;s:12:\"delete-43707\";i:42946;s:12:\"delete-43705\";i:42947;s:12:\"delete-43706\";i:42948;s:12:\"delete-43708\";i:42949;s:12:\"delete-43709\";i:42950;s:12:\"delete-43712\";i:42951;s:12:\"delete-43713\";i:42952;s:12:\"delete-43710\";i:42953;s:12:\"delete-43711\";i:42954;s:12:\"delete-43714\";i:42955;s:12:\"delete-43717\";i:42956;s:12:\"delete-43718\";i:42957;s:12:\"delete-43715\";i:42958;s:12:\"delete-43716\";i:42959;s:12:\"delete-43719\";i:42960;s:12:\"delete-43722\";i:42961;s:12:\"delete-43723\";i:42962;s:12:\"delete-43720\";i:42963;s:12:\"delete-43721\";i:42964;s:12:\"delete-43724\";i:42965;s:12:\"delete-43727\";i:42966;s:12:\"delete-43728\";i:42967;s:12:\"delete-43725\";i:42968;s:12:\"delete-43726\";i:42969;s:12:\"delete-43729\";i:42970;s:12:\"delete-43732\";i:42971;s:12:\"delete-43733\";i:42972;s:12:\"delete-43730\";i:42973;s:12:\"delete-43731\";i:42974;s:12:\"delete-43734\";i:42975;s:12:\"delete-43737\";i:42976;s:12:\"delete-43738\";i:42977;s:12:\"delete-43735\";i:42978;s:12:\"delete-43736\";i:42979;s:12:\"delete-43739\";i:42980;s:12:\"delete-43742\";i:42981;s:12:\"delete-43743\";i:42982;s:12:\"delete-43740\";i:42983;s:12:\"delete-43741\";i:42984;s:12:\"delete-43744\";i:42985;s:12:\"delete-43747\";i:42986;s:12:\"delete-43748\";i:42987;s:12:\"delete-43745\";i:42988;s:12:\"delete-43746\";i:42989;s:12:\"delete-43749\";i:42990;s:12:\"delete-43752\";i:42991;s:12:\"delete-43753\";i:42992;s:12:\"delete-43750\";i:42993;s:12:\"delete-43751\";i:42994;s:12:\"delete-43754\";i:42995;s:12:\"delete-43757\";i:42996;s:12:\"delete-43758\";i:42997;s:12:\"delete-43755\";i:42998;s:12:\"delete-43756\";i:42999;s:12:\"delete-43759\";i:43000;s:12:\"delete-43762\";i:43001;s:12:\"delete-43763\";i:43002;s:12:\"delete-43760\";i:43003;s:12:\"delete-43761\";i:43004;s:12:\"delete-43764\";i:43005;s:12:\"delete-43767\";i:43006;s:12:\"delete-43765\";i:43007;s:12:\"delete-43766\";i:43008;s:12:\"delete-43768\";i:43009;s:12:\"delete-43769\";i:43010;s:12:\"delete-43772\";i:43011;s:12:\"delete-43773\";i:43012;s:12:\"delete-43770\";i:43013;s:12:\"delete-43771\";i:43014;s:12:\"delete-43774\";i:43015;s:12:\"delete-43777\";i:43016;s:12:\"delete-43778\";i:43017;s:12:\"delete-43775\";i:43018;s:12:\"delete-43776\";i:43019;s:12:\"delete-43779\";i:43020;s:12:\"delete-43782\";i:43021;s:12:\"delete-43783\";i:43022;s:12:\"delete-43780\";i:43023;s:12:\"delete-43781\";i:43024;s:12:\"delete-43784\";i:43025;s:12:\"delete-43787\";i:43026;s:12:\"delete-43788\";i:43027;s:12:\"delete-43785\";i:43028;s:12:\"delete-43786\";i:43029;s:12:\"delete-43789\";i:43030;s:12:\"delete-43792\";i:43031;s:12:\"delete-43793\";i:43032;s:12:\"delete-43790\";i:43033;s:12:\"delete-43791\";i:43034;s:12:\"delete-43794\";i:43035;s:12:\"delete-43797\";i:43036;s:12:\"delete-43795\";i:43037;s:12:\"delete-43796\";i:43038;s:12:\"delete-43798\";i:43039;s:12:\"delete-43799\";i:43040;s:12:\"delete-43802\";i:43041;s:12:\"delete-43803\";i:43042;s:12:\"delete-43800\";i:43043;s:12:\"delete-43801\";i:43044;s:12:\"delete-43804\";i:43045;s:12:\"delete-43807\";i:43046;s:12:\"delete-43808\";i:43047;s:12:\"delete-43805\";i:43048;s:12:\"delete-43806\";i:43049;s:12:\"delete-43809\";i:43050;s:12:\"delete-43812\";i:43051;s:12:\"delete-43813\";i:43052;s:12:\"delete-43810\";i:43053;s:12:\"delete-43811\";i:43054;s:12:\"delete-43814\";i:43055;s:12:\"delete-43817\";i:43056;s:12:\"delete-43818\";i:43057;s:12:\"delete-43815\";i:43058;s:12:\"delete-43816\";i:43059;s:12:\"delete-43819\";i:43060;s:12:\"delete-43822\";i:43061;s:12:\"delete-43823\";i:43062;s:12:\"delete-43820\";i:43063;s:12:\"delete-43821\";i:43064;s:12:\"delete-43824\";i:43065;s:12:\"delete-43827\";i:43066;s:12:\"delete-43828\";i:43067;s:12:\"delete-43825\";i:43068;s:12:\"delete-43826\";i:43069;s:12:\"delete-43829\";i:43070;s:12:\"delete-43832\";i:43071;s:12:\"delete-43833\";i:43072;s:12:\"delete-43830\";i:43073;s:12:\"delete-43831\";i:43074;s:12:\"delete-43834\";i:43075;s:12:\"delete-43837\";i:43076;s:12:\"delete-43835\";i:43077;s:12:\"delete-43836\";i:43078;s:12:\"delete-43838\";i:43079;s:12:\"delete-43839\";i:43080;s:12:\"delete-43842\";i:43081;s:12:\"delete-43843\";i:43082;s:12:\"delete-43840\";i:43083;s:12:\"delete-43841\";i:43084;s:12:\"delete-43844\";i:43085;s:12:\"delete-43847\";i:43086;s:12:\"delete-43848\";i:43087;s:12:\"delete-43845\";i:43088;s:12:\"delete-43846\";i:43089;s:12:\"delete-43849\";i:43090;s:12:\"delete-43852\";i:43091;s:12:\"delete-43853\";i:43092;s:12:\"delete-43850\";i:43093;s:12:\"delete-43851\";i:43094;s:12:\"delete-43854\";i:43095;s:12:\"delete-43857\";i:43096;s:12:\"delete-43858\";i:43097;s:12:\"delete-43855\";i:43098;s:12:\"delete-43856\";i:43099;s:12:\"delete-43859\";i:43100;s:12:\"delete-43862\";i:43101;s:12:\"delete-43863\";i:43102;s:12:\"delete-43860\";i:43103;s:12:\"delete-43861\";i:43104;s:12:\"delete-43864\";i:43105;s:12:\"delete-43867\";i:43106;s:12:\"delete-43865\";i:43107;s:12:\"delete-43866\";i:43108;s:12:\"delete-43868\";i:43109;s:12:\"delete-43869\";i:43110;s:12:\"delete-43872\";i:43111;s:12:\"delete-43873\";i:43112;s:12:\"delete-43870\";i:43113;s:12:\"delete-43871\";i:43114;s:12:\"delete-43874\";i:43115;s:12:\"delete-43877\";i:43116;s:12:\"delete-43878\";i:43117;s:12:\"delete-43875\";i:43118;s:12:\"delete-43876\";i:43119;s:12:\"delete-43879\";i:43120;s:12:\"delete-43882\";i:43121;s:12:\"delete-43880\";i:43122;s:12:\"delete-43881\";i:43123;s:12:\"delete-43883\";i:43124;s:12:\"delete-43884\";i:43125;s:12:\"delete-43887\";i:43126;s:12:\"delete-43888\";i:43127;s:12:\"delete-43885\";i:43128;s:12:\"delete-43886\";i:43129;s:12:\"delete-43889\";i:43130;s:12:\"delete-43892\";i:43131;s:12:\"delete-43893\";i:43132;s:12:\"delete-43890\";i:43133;s:12:\"delete-43891\";i:43134;s:12:\"delete-43894\";i:43135;s:12:\"delete-43897\";i:43136;s:12:\"delete-43895\";i:43137;s:12:\"delete-43896\";i:43138;s:12:\"delete-43898\";i:43139;s:12:\"delete-43899\";i:43140;s:12:\"delete-43902\";i:43141;s:12:\"delete-43903\";i:43142;s:12:\"delete-43900\";i:43143;s:12:\"delete-43901\";i:43144;s:12:\"delete-43904\";i:43145;s:12:\"delete-43907\";i:43146;s:12:\"delete-43908\";i:43147;s:12:\"delete-43905\";i:43148;s:12:\"delete-43906\";i:43149;s:12:\"delete-43909\";i:43150;s:12:\"delete-43912\";i:43151;s:12:\"delete-43913\";i:43152;s:12:\"delete-43910\";i:43153;s:12:\"delete-43911\";i:43154;s:12:\"delete-43914\";i:43155;s:12:\"delete-43917\";i:43156;s:12:\"delete-43915\";i:43157;s:12:\"delete-43916\";i:43158;s:12:\"delete-43918\";i:43159;s:12:\"delete-43919\";i:43160;s:12:\"delete-43922\";i:43161;s:12:\"delete-43923\";i:43162;s:12:\"delete-43920\";i:43163;s:12:\"delete-43921\";i:43164;s:12:\"delete-43924\";i:43165;s:12:\"delete-43927\";i:43166;s:12:\"delete-43928\";i:43167;s:12:\"delete-43925\";i:43168;s:12:\"delete-43926\";i:43169;s:12:\"delete-43929\";i:43170;s:12:\"delete-43932\";i:43171;s:12:\"delete-43930\";i:43172;s:12:\"delete-43931\";i:43173;s:12:\"delete-43933\";i:43174;s:12:\"delete-43934\";i:43175;s:12:\"delete-43937\";i:43176;s:12:\"delete-43938\";i:43177;s:12:\"delete-43935\";i:43178;s:12:\"delete-43936\";i:43179;s:12:\"delete-43939\";i:43180;s:12:\"delete-43942\";i:43181;s:12:\"delete-43940\";i:43182;s:12:\"delete-43941\";i:43183;s:12:\"delete-43943\";i:43184;s:12:\"delete-43944\";i:43185;s:12:\"delete-43947\";i:43186;s:12:\"delete-43948\";i:43187;s:12:\"delete-43945\";i:43188;s:12:\"delete-43946\";i:43189;s:12:\"delete-43949\";i:43190;s:12:\"delete-43952\";i:43191;s:12:\"delete-43953\";i:43192;s:12:\"delete-43950\";i:43193;s:12:\"delete-43951\";i:43194;s:12:\"delete-43954\";i:43195;s:12:\"delete-43957\";i:43196;s:12:\"delete-43958\";i:43197;s:12:\"delete-43955\";i:43198;s:12:\"delete-43956\";i:43199;s:12:\"delete-43959\";i:43200;s:12:\"delete-43962\";i:43201;s:12:\"delete-43960\";i:43202;s:12:\"delete-43961\";i:43203;s:12:\"delete-43963\";i:43204;s:12:\"delete-43964\";i:43205;s:12:\"delete-43967\";i:43206;s:12:\"delete-43968\";i:43207;s:12:\"delete-43965\";i:43208;s:12:\"delete-43966\";i:43209;s:12:\"delete-43969\";i:43210;s:12:\"delete-43972\";i:43211;s:12:\"delete-43973\";i:43212;s:12:\"delete-43970\";i:43213;s:12:\"delete-43971\";i:43214;s:12:\"delete-43974\";i:43215;s:12:\"delete-43977\";i:43216;s:12:\"delete-43978\";i:43217;s:12:\"delete-43975\";i:43218;s:12:\"delete-43976\";i:43219;s:12:\"delete-43979\";i:43220;s:12:\"delete-43982\";i:43221;s:12:\"delete-43983\";i:43222;s:12:\"delete-43980\";i:43223;s:12:\"delete-43981\";i:43224;s:12:\"delete-43984\";i:43225;s:12:\"delete-43987\";i:43226;s:12:\"delete-43988\";i:43227;s:12:\"delete-43989\";i:43228;s:12:\"delete-43992\";i:43229;s:12:\"delete-43985\";i:43230;s:12:\"delete-43986\";i:43231;s:12:\"delete-43990\";i:43232;s:12:\"delete-43991\";i:43233;s:12:\"delete-43993\";i:43234;s:12:\"delete-43994\";i:43235;s:12:\"delete-43997\";i:43236;s:12:\"delete-43998\";i:43237;s:12:\"delete-43995\";i:43238;s:12:\"delete-43996\";i:43239;s:12:\"delete-43999\";i:43240;s:12:\"delete-44002\";i:43241;s:12:\"delete-44003\";i:43242;s:12:\"delete-44000\";i:43243;s:12:\"delete-44001\";i:43244;s:12:\"delete-44004\";i:43245;s:12:\"delete-44007\";i:43246;s:12:\"delete-44005\";i:43247;s:12:\"delete-44006\";i:43248;s:12:\"delete-44008\";i:43249;s:12:\"delete-44009\";i:43250;s:12:\"delete-44012\";i:43251;s:12:\"delete-44013\";i:43252;s:12:\"delete-44010\";i:43253;s:12:\"delete-44011\";i:43254;s:12:\"delete-44014\";i:43255;s:12:\"delete-44017\";i:43256;s:12:\"delete-44018\";i:43257;s:12:\"delete-44019\";i:43258;s:12:\"delete-44022\";i:43259;s:12:\"delete-44015\";i:43260;s:12:\"delete-44016\";i:43261;s:12:\"delete-44020\";i:43262;s:12:\"delete-44021\";i:43263;s:12:\"delete-44023\";i:43264;s:12:\"delete-44024\";i:43265;s:12:\"delete-44027\";i:43266;s:12:\"delete-44028\";i:43267;s:12:\"delete-44025\";i:43268;s:12:\"delete-44026\";i:43269;s:12:\"delete-44029\";i:43270;s:12:\"delete-44032\";i:43271;s:12:\"delete-44033\";i:43272;s:12:\"delete-44030\";i:43273;s:12:\"delete-44031\";i:43274;s:12:\"delete-44034\";i:43275;s:12:\"delete-44037\";i:43276;s:12:\"delete-44038\";i:43277;s:12:\"delete-44035\";i:43278;s:12:\"delete-44036\";i:43279;s:12:\"delete-44039\";i:43280;s:12:\"delete-44042\";i:43281;s:12:\"delete-44043\";i:43282;s:12:\"delete-44040\";i:43283;s:12:\"delete-44041\";i:43284;s:12:\"delete-44044\";i:43285;s:12:\"delete-44047\";i:43286;s:12:\"delete-44048\";i:43287;s:12:\"delete-44045\";i:43288;s:12:\"delete-44046\";i:43289;s:12:\"delete-44049\";i:43290;s:12:\"delete-44052\";i:43291;s:12:\"delete-44053\";i:43292;s:12:\"delete-44050\";i:43293;s:12:\"delete-44051\";i:43294;s:12:\"delete-44054\";i:43295;s:12:\"delete-44057\";i:43296;s:12:\"delete-44055\";i:43297;s:12:\"delete-44056\";i:43298;s:12:\"delete-44058\";i:43299;s:12:\"delete-44059\";i:43300;s:12:\"delete-44062\";i:43301;s:12:\"delete-44063\";i:43302;s:12:\"delete-44060\";i:43303;s:12:\"delete-44061\";i:43304;s:12:\"delete-44064\";i:43305;s:12:\"delete-44067\";i:43306;s:12:\"delete-44068\";i:43307;s:12:\"delete-44065\";i:43308;s:12:\"delete-44066\";i:43309;s:12:\"delete-44069\";i:43310;s:12:\"delete-44072\";i:43311;s:12:\"delete-44073\";i:43312;s:12:\"delete-44070\";i:43313;s:12:\"delete-44071\";i:43314;s:12:\"delete-44074\";i:43315;s:12:\"delete-44077\";i:43316;s:12:\"delete-44075\";i:43317;s:12:\"delete-44076\";i:43318;s:12:\"delete-44078\";i:43319;s:12:\"delete-44079\";i:43320;s:12:\"delete-44082\";i:43321;s:12:\"delete-44083\";i:43322;s:12:\"delete-44080\";i:43323;s:12:\"delete-44081\";i:43324;s:12:\"delete-44084\";i:43325;s:12:\"delete-44087\";i:43326;s:12:\"delete-44088\";i:43327;s:12:\"delete-44085\";i:43328;s:12:\"delete-44086\";i:43329;s:12:\"delete-44089\";i:43330;s:12:\"delete-44092\";i:43331;s:12:\"delete-44093\";i:43332;s:12:\"delete-44090\";i:43333;s:12:\"delete-44091\";i:43334;s:12:\"delete-44094\";i:43335;s:12:\"delete-44097\";i:43336;s:12:\"delete-44095\";i:43337;s:12:\"delete-44096\";i:43338;s:12:\"delete-44098\";i:43339;s:12:\"delete-44099\";i:43340;s:12:\"delete-44100\";i:43341;s:12:\"delete-44101\";i:43342;s:12:\"delete-44102\";i:43343;s:12:\"delete-44103\";i:43344;s:12:\"delete-44104\";i:43345;s:12:\"delete-44107\";i:43346;s:12:\"delete-44108\";i:43347;s:12:\"delete-44105\";i:43348;s:12:\"delete-44106\";i:43349;s:12:\"delete-44109\";i:43350;s:12:\"delete-44112\";i:43351;s:12:\"delete-44110\";i:43352;s:12:\"delete-44111\";i:43353;s:12:\"delete-44113\";i:43354;s:12:\"delete-44114\";i:43355;s:12:\"delete-44117\";i:43356;s:12:\"delete-44115\";i:43357;s:12:\"delete-44116\";i:43358;s:12:\"delete-44118\";i:43359;s:12:\"delete-44119\";i:43360;s:12:\"delete-44120\";i:43361;s:12:\"delete-44121\";i:43362;s:12:\"delete-44122\";i:43363;s:12:\"delete-44123\";i:43364;s:12:\"delete-44124\";i:43365;s:12:\"delete-44127\";i:43366;s:12:\"delete-44125\";i:43367;s:12:\"delete-44126\";i:43368;s:12:\"delete-44128\";i:43369;s:12:\"delete-44129\";i:43370;s:12:\"delete-44132\";i:43371;s:12:\"delete-44133\";i:43372;s:12:\"delete-44130\";i:43373;s:12:\"delete-44131\";i:43374;s:12:\"delete-44134\";i:43375;s:12:\"delete-44137\";i:43376;s:12:\"delete-44138\";i:43377;s:12:\"delete-44135\";i:43378;s:12:\"delete-44136\";i:43379;s:12:\"delete-44139\";i:43380;s:12:\"delete-44142\";i:43381;s:12:\"delete-44143\";i:43382;s:12:\"delete-44140\";i:43383;s:12:\"delete-44141\";i:43384;s:12:\"delete-44144\";i:43385;s:12:\"delete-44147\";i:43386;s:12:\"delete-44148\";i:43387;s:12:\"delete-44145\";i:43388;s:12:\"delete-44146\";i:43389;s:12:\"delete-44149\";i:43390;s:12:\"delete-44152\";i:43391;s:12:\"delete-44150\";i:43392;s:12:\"delete-44151\";i:43393;s:12:\"delete-44153\";i:43394;s:12:\"delete-44154\";i:43395;s:12:\"delete-44157\";i:43396;s:12:\"delete-44155\";i:43397;s:12:\"delete-44156\";i:43398;s:12:\"delete-44158\";i:43399;s:12:\"delete-44159\";i:43400;s:12:\"delete-44162\";i:43401;s:12:\"delete-44163\";i:43402;s:12:\"delete-44160\";i:43403;s:12:\"delete-44161\";i:43404;s:12:\"delete-44164\";i:43405;s:12:\"delete-44167\";i:43406;s:12:\"delete-44165\";i:43407;s:12:\"delete-44166\";i:43408;s:12:\"delete-44168\";i:43409;s:12:\"delete-44169\";i:43410;s:12:\"delete-44172\";i:43411;s:12:\"delete-44173\";i:43412;s:12:\"delete-44170\";i:43413;s:12:\"delete-44171\";i:43414;s:12:\"delete-44174\";i:43415;s:12:\"delete-44177\";i:43416;s:12:\"delete-44178\";i:43417;s:12:\"delete-44175\";i:43418;s:12:\"delete-44176\";i:43419;s:12:\"delete-44179\";i:43420;s:12:\"delete-44182\";i:43421;s:12:\"delete-44180\";i:43422;s:12:\"delete-44181\";i:43423;s:12:\"delete-44183\";i:43424;s:12:\"delete-44184\";i:43425;s:12:\"delete-44187\";i:43426;s:12:\"delete-44188\";i:43427;s:12:\"delete-44185\";i:43428;s:12:\"delete-44186\";i:43429;s:12:\"delete-44189\";i:43430;s:12:\"delete-44192\";i:43431;s:12:\"delete-44193\";i:43432;s:12:\"delete-44190\";i:43433;s:12:\"delete-44191\";i:43434;s:12:\"delete-44194\";i:43435;s:12:\"delete-44197\";i:43436;s:12:\"delete-44198\";i:43437;s:12:\"delete-44195\";i:43438;s:12:\"delete-44196\";i:43439;s:12:\"delete-44199\";i:43440;s:12:\"delete-44202\";i:43441;s:12:\"delete-44200\";i:43442;s:12:\"delete-44201\";i:43443;s:12:\"delete-44203\";i:43444;s:12:\"delete-44204\";i:43445;s:12:\"delete-44207\";i:43446;s:12:\"delete-44208\";i:43447;s:12:\"delete-44205\";i:43448;s:12:\"delete-44206\";i:43449;s:12:\"delete-44209\";i:43450;s:12:\"delete-44212\";i:43451;s:12:\"delete-44213\";i:43452;s:12:\"delete-44210\";i:43453;s:12:\"delete-44211\";i:43454;s:12:\"delete-44214\";i:43455;s:12:\"delete-44217\";i:43456;s:12:\"delete-44215\";i:43457;s:12:\"delete-44216\";i:43458;s:12:\"delete-44218\";i:43459;s:12:\"delete-44219\";i:43460;s:12:\"delete-44222\";i:43461;s:12:\"delete-44223\";i:43462;s:12:\"delete-44220\";i:43463;s:12:\"delete-44221\";i:43464;s:12:\"delete-44224\";i:43465;s:12:\"delete-44227\";i:43466;s:12:\"delete-44228\";i:43467;s:12:\"delete-44225\";i:43468;s:12:\"delete-44226\";i:43469;s:12:\"delete-44229\";i:43470;s:12:\"delete-44232\";i:43471;s:12:\"delete-44233\";i:43472;s:12:\"delete-44234\";i:43473;s:12:\"delete-44237\";i:43474;s:12:\"delete-44238\";i:43475;s:12:\"delete-44230\";i:43476;s:12:\"delete-44231\";i:43477;s:12:\"delete-44235\";i:43478;s:12:\"delete-44236\";i:43479;s:12:\"delete-44239\";i:43480;s:12:\"delete-44242\";i:43481;s:12:\"delete-44243\";i:43482;s:12:\"delete-44240\";i:43483;s:12:\"delete-44241\";i:43484;s:12:\"delete-44244\";i:43485;s:12:\"delete-44247\";i:43486;s:12:\"delete-44248\";i:43487;s:12:\"delete-44249\";i:43488;s:12:\"delete-44252\";i:43489;s:12:\"delete-44253\";i:43490;s:12:\"delete-44245\";i:43491;s:12:\"delete-44246\";i:43492;s:12:\"delete-44250\";i:43493;s:12:\"delete-44251\";i:43494;s:12:\"delete-44254\";i:43495;s:12:\"delete-44257\";i:43496;s:12:\"delete-44258\";i:43497;s:12:\"delete-44255\";i:43498;s:12:\"delete-44256\";i:43499;s:12:\"delete-44259\";i:43500;s:12:\"delete-44262\";i:43501;s:12:\"delete-44260\";i:43502;s:12:\"delete-44261\";i:43503;s:12:\"delete-44263\";i:43504;s:12:\"delete-44264\";i:43505;s:12:\"delete-44267\";i:43506;s:12:\"delete-44268\";i:43507;s:12:\"delete-44265\";i:43508;s:12:\"delete-44266\";i:43509;s:12:\"delete-44269\";i:43510;s:12:\"delete-44272\";i:43511;s:12:\"delete-44273\";i:43512;s:12:\"delete-44270\";i:43513;s:12:\"delete-44271\";i:43514;s:12:\"delete-44274\";i:43515;s:12:\"delete-44277\";i:43516;s:12:\"delete-44275\";i:43517;s:12:\"delete-44276\";i:43518;s:12:\"delete-44278\";i:43519;s:12:\"delete-44279\";i:43520;s:12:\"delete-44282\";i:43521;s:12:\"delete-44283\";i:43522;s:12:\"delete-44280\";i:43523;s:12:\"delete-44281\";i:43524;s:12:\"delete-44284\";i:43525;s:12:\"delete-44287\";i:43526;s:12:\"delete-44288\";i:43527;s:12:\"delete-44285\";i:43528;s:12:\"delete-44286\";i:43529;s:12:\"delete-44289\";i:43530;s:12:\"delete-44292\";i:43531;s:12:\"delete-44293\";i:43532;s:12:\"delete-44290\";i:43533;s:12:\"delete-44291\";i:43534;s:12:\"delete-44294\";i:43535;s:12:\"delete-44297\";i:43536;s:12:\"delete-44298\";i:43537;s:12:\"delete-44295\";i:43538;s:12:\"delete-44296\";i:43539;s:12:\"delete-44299\";i:43540;s:12:\"delete-44302\";i:43541;s:12:\"delete-44303\";i:43542;s:12:\"delete-44300\";i:43543;s:12:\"delete-44301\";i:43544;s:12:\"delete-44304\";i:43545;s:12:\"delete-44307\";i:43546;s:12:\"delete-44308\";i:43547;s:12:\"delete-44305\";i:43548;s:12:\"delete-44306\";i:43549;s:12:\"delete-44309\";i:43550;s:12:\"delete-44312\";i:43551;s:12:\"delete-44310\";i:43552;s:12:\"delete-44311\";i:43553;s:12:\"delete-44313\";i:43554;s:12:\"delete-44314\";i:43555;s:12:\"delete-44317\";i:43556;s:12:\"delete-44318\";i:43557;s:12:\"delete-44315\";i:43558;s:12:\"delete-44316\";i:43559;s:12:\"delete-44319\";i:43560;s:12:\"delete-44322\";i:43561;s:12:\"delete-44323\";i:43562;s:12:\"delete-44320\";i:43563;s:12:\"delete-44321\";i:43564;s:12:\"delete-44324\";i:43565;s:12:\"delete-44327\";i:43566;s:12:\"delete-44328\";i:43567;s:12:\"delete-44325\";i:43568;s:12:\"delete-44326\";i:43569;s:12:\"delete-44329\";i:43570;s:12:\"delete-44332\";i:43571;s:12:\"delete-44333\";i:43572;s:12:\"delete-44330\";i:43573;s:12:\"delete-44331\";i:43574;s:12:\"delete-44334\";i:43575;s:12:\"delete-44337\";i:43576;s:12:\"delete-44338\";i:43577;s:12:\"delete-44335\";i:43578;s:12:\"delete-44336\";i:43579;s:12:\"delete-44339\";i:43580;s:12:\"delete-44342\";i:43581;s:12:\"delete-44343\";i:43582;s:12:\"delete-44340\";i:43583;s:12:\"delete-44341\";i:43584;s:12:\"delete-44344\";i:43585;s:12:\"delete-44347\";i:43586;s:12:\"delete-44345\";i:43587;s:12:\"delete-44346\";i:43588;s:12:\"delete-44348\";i:43589;s:12:\"delete-44349\";i:43590;s:12:\"delete-44352\";i:43591;s:12:\"delete-44353\";i:43592;s:12:\"delete-44350\";i:43593;s:12:\"delete-44351\";i:43594;s:12:\"delete-44354\";i:43595;s:12:\"delete-44357\";i:43596;s:12:\"delete-44358\";i:43597;s:12:\"delete-44355\";i:43598;s:12:\"delete-44356\";i:43599;s:12:\"delete-44359\";i:43600;s:12:\"delete-44362\";i:43601;s:12:\"delete-44360\";i:43602;s:12:\"delete-44361\";i:43603;s:12:\"delete-44363\";i:43604;s:12:\"delete-44364\";i:43605;s:12:\"delete-44367\";i:43606;s:12:\"delete-44365\";i:43607;s:12:\"delete-44366\";i:43608;s:12:\"delete-44368\";i:43609;s:12:\"delete-44369\";i:43610;s:12:\"delete-44372\";i:43611;s:12:\"delete-44373\";i:43612;s:12:\"delete-44370\";i:43613;s:12:\"delete-44371\";i:43614;s:12:\"delete-44374\";i:43615;s:12:\"delete-44377\";i:43616;s:12:\"delete-44378\";i:43617;s:12:\"delete-44375\";i:43618;s:12:\"delete-44376\";i:43619;s:12:\"delete-44379\";i:43620;s:12:\"delete-44382\";i:43621;s:12:\"delete-44383\";i:43622;s:12:\"delete-44380\";i:43623;s:12:\"delete-44381\";i:43624;s:12:\"delete-44384\";i:43625;s:12:\"delete-44387\";i:43626;s:12:\"delete-44385\";i:43627;s:12:\"delete-44386\";i:43628;s:12:\"delete-44388\";i:43629;s:12:\"delete-44389\";i:43630;s:12:\"delete-44392\";i:43631;s:12:\"delete-44390\";i:43632;s:12:\"delete-44391\";i:43633;s:12:\"delete-44393\";i:43634;s:12:\"delete-44394\";i:43635;s:12:\"delete-44397\";i:43636;s:12:\"delete-44395\";i:43637;s:12:\"delete-44396\";i:43638;s:12:\"delete-44398\";i:43639;s:12:\"delete-44399\";i:43640;s:12:\"delete-44402\";i:43641;s:12:\"delete-44403\";i:43642;s:12:\"delete-44400\";i:43643;s:12:\"delete-44401\";i:43644;s:12:\"delete-44404\";i:43645;s:12:\"delete-44407\";i:43646;s:12:\"delete-44408\";i:43647;s:12:\"delete-44405\";i:43648;s:12:\"delete-44406\";i:43649;s:12:\"delete-44409\";i:43650;s:12:\"delete-44412\";i:43651;s:12:\"delete-44410\";i:43652;s:12:\"delete-44411\";i:43653;s:12:\"delete-44413\";i:43654;s:12:\"delete-44414\";i:43655;s:12:\"delete-44415\";i:43656;s:12:\"delete-44416\";i:43657;s:12:\"delete-44417\";i:43658;s:12:\"delete-44418\";i:43659;s:12:\"delete-44419\";i:43660;s:12:\"delete-44422\";i:43661;s:12:\"delete-44423\";i:43662;s:12:\"delete-44420\";i:43663;s:12:\"delete-44421\";i:43664;s:12:\"delete-44424\";i:43665;s:12:\"delete-44425\";i:43666;s:12:\"delete-44426\";i:43667;s:12:\"delete-44427\";i:43668;s:12:\"delete-44428\";i:43669;s:12:\"delete-44429\";i:43670;s:12:\"delete-44432\";i:43671;s:12:\"delete-44433\";i:43672;s:12:\"delete-44430\";i:43673;s:12:\"delete-44431\";i:43674;s:12:\"delete-44434\";i:43675;s:12:\"delete-44437\";i:43676;s:12:\"delete-44438\";i:43677;s:12:\"delete-44435\";i:43678;s:12:\"delete-44436\";i:43679;s:12:\"delete-44439\";i:43680;s:12:\"delete-44442\";i:43681;s:12:\"delete-44443\";i:43682;s:12:\"delete-44440\";i:43683;s:12:\"delete-44441\";i:43684;s:12:\"delete-44444\";i:43685;s:12:\"delete-44447\";i:43686;s:12:\"delete-44448\";i:43687;s:12:\"delete-44445\";i:43688;s:12:\"delete-44446\";i:43689;s:12:\"delete-44449\";i:43690;s:12:\"delete-44452\";i:43691;s:12:\"delete-44453\";i:43692;s:12:\"delete-44450\";i:43693;s:12:\"delete-44451\";i:43694;s:12:\"delete-44454\";i:43695;s:12:\"delete-44457\";i:43696;s:12:\"delete-44455\";i:43697;s:12:\"delete-44456\";i:43698;s:12:\"delete-44458\";i:43699;s:12:\"delete-44459\";i:43700;s:12:\"delete-44462\";i:43701;s:12:\"delete-44463\";i:43702;s:12:\"delete-44460\";i:43703;s:12:\"delete-44461\";i:43704;s:12:\"delete-44464\";i:43705;s:12:\"delete-44467\";i:43706;s:12:\"delete-44468\";i:43707;s:12:\"delete-44465\";i:43708;s:12:\"delete-44466\";i:43709;s:12:\"delete-44469\";i:43710;s:12:\"delete-44472\";i:43711;s:12:\"delete-44473\";i:43712;s:12:\"delete-44470\";i:43713;s:12:\"delete-44471\";i:43714;s:12:\"delete-44474\";i:43715;s:12:\"delete-44477\";i:43716;s:12:\"delete-44478\";i:43717;s:12:\"delete-44475\";i:43718;s:12:\"delete-44476\";i:43719;s:12:\"delete-44479\";i:43720;s:12:\"delete-44482\";i:43721;s:12:\"delete-44483\";i:43722;s:12:\"delete-44480\";i:43723;s:12:\"delete-44481\";i:43724;s:12:\"delete-44484\";i:43725;s:12:\"delete-44487\";i:43726;s:12:\"delete-44488\";i:43727;s:12:\"delete-44485\";i:43728;s:12:\"delete-44486\";i:43729;s:12:\"delete-44489\";i:43730;s:12:\"delete-44492\";i:43731;s:12:\"delete-44493\";i:43732;s:12:\"delete-44490\";i:43733;s:12:\"delete-44491\";i:43734;s:12:\"delete-44494\";i:43735;s:12:\"delete-44497\";i:43736;s:12:\"delete-44498\";i:43737;s:12:\"delete-44495\";i:43738;s:12:\"delete-44496\";i:43739;s:12:\"delete-44499\";i:43740;s:12:\"delete-44502\";i:43741;s:12:\"delete-44503\";i:43742;s:12:\"delete-44500\";i:43743;s:12:\"delete-44501\";i:43744;s:12:\"delete-44504\";i:43745;s:12:\"delete-44507\";i:43746;s:12:\"delete-44508\";i:43747;s:12:\"delete-44505\";i:43748;s:12:\"delete-44506\";i:43749;s:12:\"delete-44509\";i:43750;s:12:\"delete-44512\";i:43751;s:12:\"delete-44513\";i:43752;s:12:\"delete-44510\";i:43753;s:12:\"delete-44511\";i:43754;s:12:\"delete-44514\";i:43755;s:12:\"delete-44517\";i:43756;s:12:\"delete-44515\";i:43757;s:12:\"delete-44516\";i:43758;s:12:\"delete-44518\";i:43759;s:12:\"delete-44519\";i:43760;s:12:\"delete-44522\";i:43761;s:12:\"delete-44523\";i:43762;s:12:\"delete-44520\";i:43763;s:12:\"delete-44521\";i:43764;s:12:\"delete-44524\";i:43765;s:12:\"delete-44527\";i:43766;s:12:\"delete-44528\";i:43767;s:12:\"delete-44525\";i:43768;s:12:\"delete-44526\";i:43769;s:12:\"delete-44529\";i:43770;s:12:\"delete-44532\";i:43771;s:12:\"delete-44533\";i:43772;s:12:\"delete-44530\";i:43773;s:12:\"delete-44531\";i:43774;s:12:\"delete-44534\";i:43775;s:12:\"delete-44537\";i:43776;s:12:\"delete-44538\";i:43777;s:12:\"delete-44535\";i:43778;s:12:\"delete-44536\";i:43779;s:12:\"delete-44539\";i:43780;s:12:\"delete-44542\";i:43781;s:12:\"delete-44543\";i:43782;s:12:\"delete-44540\";i:43783;s:12:\"delete-44541\";i:43784;s:12:\"delete-44544\";i:43785;s:12:\"delete-44547\";i:43786;s:12:\"delete-44548\";i:43787;s:12:\"delete-44545\";i:43788;s:12:\"delete-44546\";i:43789;s:12:\"delete-44549\";i:43790;s:12:\"delete-44552\";i:43791;s:12:\"delete-44553\";i:43792;s:12:\"delete-44550\";i:43793;s:12:\"delete-44551\";i:43794;s:12:\"delete-44554\";i:43795;s:12:\"delete-44557\";i:43796;s:12:\"delete-44558\";i:43797;s:12:\"delete-44555\";i:43798;s:12:\"delete-44556\";i:43799;s:12:\"delete-44559\";i:43800;s:12:\"delete-44562\";i:43801;s:12:\"delete-44560\";i:43802;s:12:\"delete-44561\";i:43803;s:12:\"delete-44563\";i:43804;s:12:\"delete-44564\";i:43805;s:12:\"delete-44565\";i:43806;s:12:\"delete-44566\";i:43807;s:12:\"delete-44567\";i:43808;s:12:\"delete-44568\";i:43809;s:12:\"delete-44569\";i:43810;s:12:\"delete-44572\";i:43811;s:12:\"delete-44573\";i:43812;s:12:\"delete-44570\";i:43813;s:12:\"delete-44571\";i:43814;s:12:\"delete-44574\";i:43815;s:12:\"delete-44577\";i:43816;s:12:\"delete-44578\";i:43817;s:12:\"delete-44575\";i:43818;s:12:\"delete-44576\";i:43819;s:12:\"delete-44579\";i:43820;s:12:\"delete-44582\";i:43821;s:12:\"delete-44583\";i:43822;s:12:\"delete-44580\";i:43823;s:12:\"delete-44581\";i:43824;s:12:\"delete-44584\";i:43825;s:12:\"delete-44587\";i:43826;s:12:\"delete-44588\";i:43827;s:12:\"delete-44585\";i:43828;s:12:\"delete-44586\";i:43829;s:12:\"delete-44589\";i:43830;s:12:\"delete-44592\";i:43831;s:12:\"delete-44593\";i:43832;s:12:\"delete-44590\";i:43833;s:12:\"delete-44591\";i:43834;s:12:\"delete-44594\";i:43835;s:12:\"delete-44597\";i:43836;s:12:\"delete-44598\";i:43837;s:12:\"delete-44595\";i:43838;s:12:\"delete-44596\";i:43839;s:12:\"delete-44599\";i:43840;s:12:\"delete-44602\";i:43841;s:12:\"delete-44600\";i:43842;s:12:\"delete-44601\";i:43843;s:12:\"delete-44603\";i:43844;s:12:\"delete-44604\";i:43845;s:12:\"delete-44607\";i:43846;s:12:\"delete-44608\";i:43847;s:12:\"delete-44605\";i:43848;s:12:\"delete-44606\";i:43849;s:12:\"delete-44609\";i:43850;s:12:\"delete-44612\";i:43851;s:12:\"delete-44613\";i:43852;s:12:\"delete-44610\";i:43853;s:12:\"delete-44611\";i:43854;s:12:\"delete-44614\";i:43855;s:12:\"delete-44617\";i:43856;s:12:\"delete-44618\";i:43857;s:12:\"delete-44615\";i:43858;s:12:\"delete-44616\";i:43859;s:12:\"delete-44619\";i:43860;s:12:\"delete-44622\";i:43861;s:12:\"delete-44623\";i:43862;s:12:\"delete-44620\";i:43863;s:12:\"delete-44621\";i:43864;s:12:\"delete-44624\";i:43865;s:12:\"delete-44627\";i:43866;s:12:\"delete-44628\";i:43867;s:12:\"delete-44625\";i:43868;s:12:\"delete-44626\";i:43869;s:12:\"delete-44629\";i:43870;s:12:\"delete-44632\";i:43871;s:12:\"delete-44633\";i:43872;s:12:\"delete-44630\";i:43873;s:12:\"delete-44631\";i:43874;s:12:\"delete-44634\";i:43875;s:12:\"delete-44637\";i:43876;s:12:\"delete-44635\";i:43877;s:12:\"delete-44636\";i:43878;s:12:\"delete-44638\";i:43879;s:12:\"delete-44639\";i:43880;s:12:\"delete-44642\";i:43881;s:12:\"delete-44640\";i:43882;s:12:\"delete-44641\";i:43883;s:12:\"delete-44643\";i:43884;s:12:\"delete-44644\";i:43885;s:12:\"delete-44647\";i:43886;s:12:\"delete-44648\";i:43887;s:12:\"delete-44645\";i:43888;s:12:\"delete-44646\";i:43889;s:12:\"delete-44649\";i:43890;s:12:\"delete-44652\";i:43891;s:12:\"delete-44653\";i:43892;s:12:\"delete-44650\";i:43893;s:12:\"delete-44651\";i:43894;s:12:\"delete-44654\";i:43895;s:12:\"delete-44657\";i:43896;s:12:\"delete-44658\";i:43897;s:12:\"delete-44655\";i:43898;s:12:\"delete-44656\";i:43899;s:12:\"delete-44659\";i:43900;s:12:\"delete-44662\";i:43901;s:12:\"delete-44663\";i:43902;s:12:\"delete-44660\";i:43903;s:12:\"delete-44661\";i:43904;s:12:\"delete-44664\";i:43905;s:12:\"delete-44667\";i:43906;s:12:\"delete-44668\";i:43907;s:12:\"delete-44669\";i:43908;s:12:\"delete-44672\";i:43909;s:12:\"delete-44665\";i:43910;s:12:\"delete-44666\";i:43911;s:12:\"delete-44670\";i:43912;s:12:\"delete-44671\";i:43913;s:12:\"delete-44673\";i:43914;s:12:\"delete-44674\";i:43915;s:12:\"delete-44677\";i:43916;s:12:\"delete-44678\";i:43917;s:12:\"delete-44675\";i:43918;s:12:\"delete-44676\";i:43919;s:12:\"delete-44679\";i:43920;s:12:\"delete-44682\";i:43921;s:12:\"delete-44683\";i:43922;s:12:\"delete-44680\";i:43923;s:12:\"delete-44681\";i:43924;s:12:\"delete-44684\";i:43925;s:12:\"delete-44687\";i:43926;s:12:\"delete-44685\";i:43927;s:12:\"delete-44686\";i:43928;s:12:\"delete-44688\";i:43929;s:12:\"delete-44689\";i:43930;s:12:\"delete-44692\";i:43931;s:12:\"delete-44693\";i:43932;s:12:\"delete-44690\";i:43933;s:12:\"delete-44691\";i:43934;s:12:\"delete-44694\";i:43935;s:12:\"delete-44697\";i:43936;s:12:\"delete-44698\";i:43937;s:12:\"delete-44695\";i:43938;s:12:\"delete-44696\";i:43939;s:12:\"delete-44699\";i:43940;s:12:\"delete-44702\";i:43941;s:12:\"delete-44703\";i:43942;s:12:\"delete-44700\";i:43943;s:12:\"delete-44701\";i:43944;s:12:\"delete-44704\";i:43945;s:12:\"delete-44707\";i:43946;s:12:\"delete-44708\";i:43947;s:12:\"delete-44705\";i:43948;s:12:\"delete-44706\";i:43949;s:12:\"delete-44709\";i:43950;s:12:\"delete-44712\";i:43951;s:12:\"delete-44710\";i:43952;s:12:\"delete-44711\";i:43953;s:12:\"delete-44713\";i:43954;s:12:\"delete-44714\";i:43955;s:12:\"delete-44717\";i:43956;s:12:\"delete-44718\";i:43957;s:12:\"delete-44715\";i:43958;s:12:\"delete-44716\";i:43959;s:12:\"delete-44719\";i:43960;s:12:\"delete-44722\";i:43961;s:12:\"delete-44723\";i:43962;s:12:\"delete-44720\";i:43963;s:12:\"delete-44721\";i:43964;s:12:\"delete-44724\";i:43965;s:12:\"delete-44727\";i:43966;s:12:\"delete-44728\";i:43967;s:12:\"delete-44725\";i:43968;s:12:\"delete-44726\";i:43969;s:12:\"delete-44729\";i:43970;s:12:\"delete-44732\";i:43971;s:12:\"delete-44733\";i:43972;s:12:\"delete-44730\";i:43973;s:12:\"delete-44731\";i:43974;s:12:\"delete-44734\";i:43975;s:12:\"delete-44737\";i:43976;s:12:\"delete-44738\";i:43977;s:12:\"delete-44735\";i:43978;s:12:\"delete-44736\";i:43979;s:12:\"delete-44739\";i:43980;s:12:\"delete-44740\";i:43981;s:12:\"delete-44741\";i:43982;s:12:\"delete-44742\";i:43983;s:12:\"delete-44743\";i:43984;s:12:\"delete-44744\";i:43985;s:12:\"delete-44747\";i:43986;s:12:\"delete-44748\";i:43987;s:12:\"delete-44745\";i:43988;s:12:\"delete-44746\";i:43989;s:12:\"delete-44749\";i:43990;s:12:\"delete-44752\";i:43991;s:12:\"delete-44753\";i:43992;s:12:\"delete-44750\";i:43993;s:12:\"delete-44751\";i:43994;s:12:\"delete-44754\";i:43995;s:12:\"delete-44757\";i:43996;s:12:\"delete-44758\";i:43997;s:12:\"delete-44755\";i:43998;s:12:\"delete-44756\";i:43999;s:12:\"delete-44759\";i:44000;s:12:\"delete-44762\";i:44001;s:12:\"delete-44763\";i:44002;s:12:\"delete-44760\";i:44003;s:12:\"delete-44761\";i:44004;s:12:\"delete-44764\";i:44005;s:12:\"delete-44767\";i:44006;s:12:\"delete-44768\";i:44007;s:12:\"delete-44765\";i:44008;s:12:\"delete-44766\";i:44009;s:12:\"delete-44769\";i:44010;s:12:\"delete-44772\";i:44011;s:12:\"delete-44770\";i:44012;s:12:\"delete-44771\";i:44013;s:12:\"delete-44773\";i:44014;s:12:\"delete-44774\";i:44015;s:12:\"delete-44777\";i:44016;s:12:\"delete-44778\";i:44017;s:12:\"delete-44775\";i:44018;s:12:\"delete-44776\";i:44019;s:12:\"delete-44779\";i:44020;s:12:\"delete-44782\";i:44021;s:12:\"delete-44780\";i:44022;s:12:\"delete-44781\";i:44023;s:12:\"delete-44783\";i:44024;s:12:\"delete-44784\";i:44025;s:12:\"delete-44787\";i:44026;s:12:\"delete-44788\";i:44027;s:12:\"delete-44785\";i:44028;s:12:\"delete-44786\";i:44029;s:12:\"delete-44789\";i:44030;s:12:\"delete-44792\";i:44031;s:12:\"delete-44793\";i:44032;s:12:\"delete-44790\";i:44033;s:12:\"delete-44791\";i:44034;s:12:\"delete-44794\";i:44035;s:12:\"delete-44797\";i:44036;s:12:\"delete-44798\";i:44037;s:12:\"delete-44795\";i:44038;s:12:\"delete-44796\";i:44039;s:12:\"delete-44799\";i:44040;s:12:\"delete-44802\";i:44041;s:12:\"delete-44803\";i:44042;s:12:\"delete-44800\";i:44043;s:12:\"delete-44801\";i:44044;s:12:\"delete-44804\";i:44045;s:12:\"delete-44805\";i:44046;s:12:\"delete-44806\";i:44047;s:12:\"delete-44807\";i:44048;s:12:\"delete-44808\";i:44049;s:12:\"delete-44809\";i:44050;s:12:\"delete-44812\";i:44051;s:12:\"delete-44813\";i:44052;s:12:\"delete-44810\";i:44053;s:12:\"delete-44811\";i:44054;s:12:\"delete-44814\";i:44055;s:12:\"delete-44817\";i:44056;s:12:\"delete-44818\";i:44057;s:12:\"delete-44815\";i:44058;s:12:\"delete-44816\";i:44059;s:12:\"delete-44819\";i:44060;s:12:\"delete-44822\";i:44061;s:12:\"delete-44823\";i:44062;s:12:\"delete-44820\";i:44063;s:12:\"delete-44821\";i:44064;s:12:\"delete-44824\";i:44065;s:12:\"delete-44827\";i:44066;s:12:\"delete-44828\";i:44067;s:12:\"delete-44825\";i:44068;s:12:\"delete-44826\";i:44069;s:12:\"delete-44829\";i:44070;s:12:\"delete-44832\";i:44071;s:12:\"delete-44833\";i:44072;s:12:\"delete-44830\";i:44073;s:12:\"delete-44831\";i:44074;s:12:\"delete-44834\";i:44075;s:12:\"delete-44835\";i:44076;s:12:\"delete-44836\";i:44077;s:12:\"delete-44837\";i:44078;s:12:\"delete-44838\";i:44079;s:12:\"delete-44839\";i:44080;s:12:\"delete-44842\";i:44081;s:12:\"delete-44843\";i:44082;s:12:\"delete-44840\";i:44083;s:12:\"delete-44841\";i:44084;s:12:\"delete-44844\";i:44085;s:12:\"delete-44847\";i:44086;s:12:\"delete-44845\";i:44087;s:12:\"delete-44846\";i:44088;s:12:\"delete-44848\";i:44089;s:12:\"delete-44849\";i:44090;s:12:\"delete-44852\";i:44091;s:12:\"delete-44853\";i:44092;s:12:\"delete-44850\";i:44093;s:12:\"delete-44851\";i:44094;s:12:\"delete-44854\";i:44095;s:12:\"delete-44857\";i:44096;s:12:\"delete-44858\";i:44097;s:12:\"delete-44855\";i:44098;s:12:\"delete-44856\";i:44099;s:12:\"delete-44859\";i:44100;s:12:\"delete-44862\";i:44101;s:12:\"delete-44863\";i:44102;s:12:\"delete-44860\";i:44103;s:12:\"delete-44861\";i:44104;s:12:\"delete-44864\";i:44105;s:12:\"delete-44867\";i:44106;s:12:\"delete-44868\";i:44107;s:12:\"delete-44865\";i:44108;s:12:\"delete-44866\";i:44109;s:12:\"delete-44869\";i:44110;s:12:\"delete-44870\";i:44111;s:12:\"delete-44871\";i:44112;s:12:\"delete-44872\";i:44113;s:12:\"delete-44873\";i:44114;s:12:\"delete-44874\";i:44115;s:12:\"delete-44877\";i:44116;s:12:\"delete-44875\";i:44117;s:12:\"delete-44876\";i:44118;s:12:\"delete-44878\";i:44119;s:12:\"delete-44879\";i:44120;s:12:\"delete-44882\";i:44121;s:12:\"delete-44880\";i:44122;s:12:\"delete-44881\";i:44123;s:12:\"delete-44883\";i:44124;s:12:\"delete-44884\";i:44125;s:12:\"delete-44887\";i:44126;s:12:\"delete-44888\";i:44127;s:12:\"delete-44885\";i:44128;s:12:\"delete-44886\";i:44129;s:12:\"delete-44889\";i:44130;s:12:\"delete-44892\";i:44131;s:12:\"delete-44893\";i:44132;s:12:\"delete-44890\";i:44133;s:12:\"delete-44891\";i:44134;s:12:\"delete-44894\";i:44135;s:12:\"delete-44897\";i:44136;s:12:\"delete-44898\";i:44137;s:12:\"delete-44895\";i:44138;s:12:\"delete-44896\";i:44139;s:12:\"delete-44899\";i:44140;s:12:\"delete-44902\";i:44141;s:12:\"delete-44903\";i:44142;s:12:\"delete-44904\";i:44143;s:12:\"delete-44907\";i:44144;s:12:\"delete-44908\";i:44145;s:12:\"delete-44900\";i:44146;s:12:\"delete-44901\";i:44147;s:12:\"delete-44905\";i:44148;s:12:\"delete-44906\";i:44149;s:12:\"delete-44909\";i:44150;s:12:\"delete-44912\";i:44151;s:12:\"delete-44913\";i:44152;s:12:\"delete-44914\";i:44153;s:12:\"delete-44917\";i:44154;s:12:\"delete-44918\";i:44155;s:12:\"delete-44910\";i:44156;s:12:\"delete-44911\";i:44157;s:12:\"delete-44915\";i:44158;s:12:\"delete-44916\";i:44159;s:12:\"delete-44919\";i:44160;s:12:\"delete-44922\";i:44161;s:12:\"delete-44923\";i:44162;s:12:\"delete-44920\";i:44163;s:12:\"delete-44921\";i:44164;s:12:\"delete-44924\";i:44165;s:12:\"delete-44927\";i:44166;s:12:\"delete-44925\";i:44167;s:12:\"delete-44926\";i:44168;s:12:\"delete-44928\";i:44169;s:12:\"delete-44929\";i:44170;s:12:\"delete-44932\";i:44171;s:12:\"delete-44933\";i:44172;s:12:\"delete-44930\";i:44173;s:12:\"delete-44931\";i:44174;s:12:\"delete-44934\";i:44175;s:12:\"delete-44937\";i:44176;s:12:\"delete-44938\";i:44177;s:12:\"delete-44935\";i:44178;s:12:\"delete-44936\";i:44179;s:12:\"delete-44939\";i:44180;s:12:\"delete-44942\";i:44181;s:12:\"delete-44943\";i:44182;s:12:\"delete-44940\";i:44183;s:12:\"delete-44941\";i:44184;s:12:\"delete-44944\";i:44185;s:12:\"delete-44947\";i:44186;s:12:\"delete-44948\";i:44187;s:12:\"delete-44945\";i:44188;s:12:\"delete-44946\";i:44189;s:12:\"delete-44949\";i:44190;s:12:\"delete-44952\";i:44191;s:12:\"delete-44950\";i:44192;s:12:\"delete-44951\";i:44193;s:12:\"delete-44953\";i:44194;s:12:\"delete-44954\";i:44195;s:12:\"delete-44957\";i:44196;s:12:\"delete-44955\";i:44197;s:12:\"delete-44956\";i:44198;s:12:\"delete-44958\";i:44199;s:12:\"delete-44959\";i:44200;s:12:\"delete-44962\";i:44201;s:12:\"delete-44963\";i:44202;s:12:\"delete-44960\";i:44203;s:12:\"delete-44961\";i:44204;s:12:\"delete-44964\";i:44205;s:12:\"delete-44967\";i:44206;s:12:\"delete-44968\";i:44207;s:12:\"delete-44965\";i:44208;s:12:\"delete-44966\";i:44209;s:12:\"delete-44969\";i:44210;s:12:\"delete-44972\";i:44211;s:12:\"delete-44973\";i:44212;s:12:\"delete-44970\";i:44213;s:12:\"delete-44971\";i:44214;s:12:\"delete-44974\";i:44215;s:12:\"delete-44977\";i:44216;s:12:\"delete-44978\";i:44217;s:12:\"delete-44975\";i:44218;s:12:\"delete-44976\";i:44219;s:12:\"delete-44979\";i:44220;s:12:\"delete-44982\";i:44221;s:12:\"delete-44980\";i:44222;s:12:\"delete-44981\";i:44223;s:12:\"delete-44983\";i:44224;s:12:\"delete-44984\";i:44225;s:12:\"delete-44985\";i:44226;s:12:\"delete-44986\";i:44227;s:12:\"delete-44987\";i:44228;s:12:\"delete-44988\";i:44229;s:12:\"delete-44989\";i:44230;s:12:\"delete-44992\";i:44231;s:12:\"delete-44993\";i:44232;s:12:\"delete-44990\";i:44233;s:12:\"delete-44991\";i:44234;s:12:\"delete-44994\";i:44235;s:12:\"delete-44997\";i:44236;s:12:\"delete-44998\";i:44237;s:12:\"delete-44995\";i:44238;s:12:\"delete-44996\";i:44239;s:12:\"delete-44999\";i:44240;s:12:\"delete-45002\";i:44241;s:12:\"delete-45000\";i:44242;s:12:\"delete-45001\";i:44243;s:12:\"delete-45003\";i:44244;s:12:\"delete-45004\";i:44245;s:12:\"delete-45007\";i:44246;s:12:\"delete-45005\";i:44247;s:12:\"delete-45006\";i:44248;s:12:\"delete-45008\";i:44249;s:12:\"delete-45009\";i:44250;s:12:\"delete-45012\";i:44251;s:12:\"delete-45013\";i:44252;s:12:\"delete-45010\";i:44253;s:12:\"delete-45011\";i:44254;s:12:\"delete-45014\";i:44255;s:12:\"delete-45017\";i:44256;s:12:\"delete-45018\";i:44257;s:12:\"delete-45015\";i:44258;s:12:\"delete-45016\";i:44259;s:12:\"delete-45019\";i:44260;s:12:\"delete-45022\";i:44261;s:12:\"delete-45023\";i:44262;s:12:\"delete-45020\";i:44263;s:12:\"delete-45021\";i:44264;s:12:\"delete-45024\";i:44265;s:12:\"delete-45027\";i:44266;s:12:\"delete-45028\";i:44267;s:12:\"delete-45025\";i:44268;s:12:\"delete-45026\";i:44269;s:12:\"delete-45029\";i:44270;s:12:\"delete-45032\";i:44271;s:12:\"delete-45030\";i:44272;s:12:\"delete-45031\";i:44273;s:12:\"delete-45033\";i:44274;s:12:\"delete-45034\";i:44275;s:12:\"delete-45037\";i:44276;s:12:\"delete-45038\";i:44277;s:12:\"delete-45035\";i:44278;s:12:\"delete-45036\";i:44279;s:12:\"delete-45039\";i:44280;s:12:\"delete-45042\";i:44281;s:12:\"delete-45043\";i:44282;s:12:\"delete-45040\";i:44283;s:12:\"delete-45041\";i:44284;s:12:\"delete-45044\";i:44285;s:12:\"delete-45047\";i:44286;s:12:\"delete-45048\";i:44287;s:12:\"delete-45045\";i:44288;s:12:\"delete-45046\";i:44289;s:12:\"delete-45049\";i:44290;s:12:\"delete-45050\";i:44291;s:12:\"delete-45051\";i:44292;s:12:\"delete-45052\";i:44293;s:12:\"delete-45053\";i:44294;s:12:\"delete-45054\";i:44295;s:12:\"delete-45057\";i:44296;s:12:\"delete-45058\";i:44297;s:12:\"delete-45055\";i:44298;s:12:\"delete-45056\";i:44299;s:12:\"delete-45059\";i:44300;s:12:\"delete-45062\";i:44301;s:12:\"delete-45063\";i:44302;s:12:\"delete-45060\";i:44303;s:12:\"delete-45061\";i:44304;s:12:\"delete-45064\";i:44305;s:12:\"delete-45067\";i:44306;s:12:\"delete-45068\";i:44307;s:12:\"delete-45065\";i:44308;s:12:\"delete-45066\";i:44309;s:12:\"delete-45069\";i:44310;s:12:\"delete-45072\";i:44311;s:12:\"delete-45073\";i:44312;s:12:\"delete-45070\";i:44313;s:12:\"delete-45071\";i:44314;s:12:\"delete-45074\";i:44315;s:12:\"delete-45077\";i:44316;s:12:\"delete-45075\";i:44317;s:12:\"delete-45076\";i:44318;s:12:\"delete-45078\";i:44319;s:12:\"delete-45079\";i:44320;s:12:\"delete-45082\";i:44321;s:12:\"delete-45083\";i:44322;s:12:\"delete-45080\";i:44323;s:12:\"delete-45081\";i:44324;s:12:\"delete-45084\";i:44325;s:12:\"delete-45087\";i:44326;s:12:\"delete-45088\";i:44327;s:12:\"delete-45085\";i:44328;s:12:\"delete-45086\";i:44329;s:12:\"delete-45089\";i:44330;s:12:\"delete-45092\";i:44331;s:12:\"delete-45093\";i:44332;s:12:\"delete-45090\";i:44333;s:12:\"delete-45091\";i:44334;s:12:\"delete-45094\";i:44335;s:12:\"delete-45097\";i:44336;s:12:\"delete-45095\";i:44337;s:12:\"delete-45096\";i:44338;s:12:\"delete-45098\";i:44339;s:12:\"delete-45099\";i:44340;s:12:\"delete-45102\";i:44341;s:12:\"delete-45103\";i:44342;s:12:\"delete-45100\";i:44343;s:12:\"delete-45101\";i:44344;s:12:\"delete-45104\";i:44345;s:12:\"delete-45107\";i:44346;s:12:\"delete-45105\";i:44347;s:12:\"delete-45106\";i:44348;s:12:\"delete-45108\";i:44349;s:12:\"delete-45109\";i:44350;s:12:\"delete-45112\";i:44351;s:12:\"delete-45110\";i:44352;s:12:\"delete-45111\";i:44353;s:12:\"delete-45113\";i:44354;s:12:\"delete-45114\";i:44355;s:12:\"delete-45117\";i:44356;s:12:\"delete-45118\";i:44357;s:12:\"delete-45115\";i:44358;s:12:\"delete-45116\";i:44359;s:12:\"delete-45119\";i:44360;s:12:\"delete-45122\";i:44361;s:12:\"delete-45120\";i:44362;s:12:\"delete-45121\";i:44363;s:12:\"delete-45123\";i:44364;s:12:\"delete-45124\";i:44365;s:12:\"delete-45127\";i:44366;s:12:\"delete-45128\";i:44367;s:12:\"delete-45125\";i:44368;s:12:\"delete-45126\";i:44369;s:12:\"delete-45129\";i:44370;s:12:\"delete-45132\";i:44371;s:12:\"delete-45130\";i:44372;s:12:\"delete-45131\";i:44373;s:12:\"delete-45133\";i:44374;s:12:\"delete-45134\";i:44375;s:12:\"delete-45137\";i:44376;s:12:\"delete-45138\";i:44377;s:12:\"delete-45135\";i:44378;s:12:\"delete-45136\";i:44379;s:12:\"delete-45139\";i:44380;s:12:\"delete-45140\";i:44381;s:12:\"delete-45141\";i:44382;s:12:\"delete-45142\";i:44383;s:12:\"delete-45143\";i:44384;s:12:\"delete-45144\";i:44385;s:12:\"delete-45147\";i:44386;s:12:\"delete-45145\";i:44387;s:12:\"delete-45146\";i:44388;s:12:\"delete-45148\";i:44389;s:12:\"delete-45149\";i:44390;s:12:\"delete-45152\";i:44391;s:12:\"delete-45153\";i:44392;s:12:\"delete-45150\";i:44393;s:12:\"delete-45151\";i:44394;s:12:\"delete-45154\";i:44395;s:12:\"delete-45157\";i:44396;s:12:\"delete-45158\";i:44397;s:12:\"delete-45155\";i:44398;s:12:\"delete-45156\";i:44399;s:12:\"delete-45159\";i:44400;s:12:\"delete-45162\";i:44401;s:12:\"delete-45163\";i:44402;s:12:\"delete-45164\";i:44403;s:12:\"delete-45167\";i:44404;s:12:\"delete-45168\";i:44405;s:12:\"delete-45160\";i:44406;s:12:\"delete-45161\";i:44407;s:12:\"delete-45165\";i:44408;s:12:\"delete-45166\";i:44409;s:12:\"delete-45169\";i:44410;s:12:\"delete-45172\";i:44411;s:12:\"delete-45173\";i:44412;s:12:\"delete-45170\";i:44413;s:12:\"delete-45171\";i:44414;s:12:\"delete-45174\";i:44415;s:12:\"delete-45175\";i:44416;s:12:\"delete-45176\";i:44417;s:12:\"delete-45177\";i:44418;s:12:\"delete-45178\";i:44419;s:12:\"delete-45179\";i:44420;s:12:\"delete-45182\";i:44421;s:12:\"delete-45183\";i:44422;s:12:\"delete-45184\";i:44423;s:12:\"delete-45180\";i:44424;s:12:\"delete-45181\";i:44425;s:12:\"delete-45185\";i:44426;s:12:\"delete-45186\";i:44427;s:12:\"delete-45187\";i:44428;s:12:\"delete-45188\";i:44429;s:12:\"delete-45189\";i:44430;s:12:\"delete-45192\";i:44431;s:12:\"delete-45193\";i:44432;s:12:\"delete-45190\";i:44433;s:12:\"delete-45191\";i:44434;s:12:\"delete-45194\";i:44435;s:12:\"delete-45197\";i:44436;s:12:\"delete-45198\";i:44437;s:12:\"delete-45199\";i:44438;s:12:\"delete-45202\";i:44439;s:12:\"delete-45195\";i:44440;s:12:\"delete-45196\";i:44441;s:12:\"delete-45200\";i:44442;s:12:\"delete-45201\";i:44443;s:12:\"delete-45203\";i:44444;s:12:\"delete-45204\";i:44445;s:12:\"delete-45207\";i:44446;s:12:\"delete-45208\";i:44447;s:12:\"delete-45205\";i:44448;s:12:\"delete-45206\";i:44449;s:12:\"delete-45209\";i:44450;s:12:\"delete-45212\";i:44451;s:12:\"delete-45210\";i:44452;s:12:\"delete-45211\";i:44453;s:12:\"delete-45213\";i:44454;s:12:\"delete-45214\";i:44455;s:12:\"delete-45217\";i:44456;s:12:\"delete-45218\";i:44457;s:12:\"delete-45215\";i:44458;s:12:\"delete-45216\";i:44459;s:12:\"delete-45219\";i:44460;s:12:\"delete-45222\";i:44461;s:12:\"delete-45223\";i:44462;s:12:\"delete-45220\";i:44463;s:12:\"delete-45221\";i:44464;s:12:\"delete-45224\";i:44465;s:12:\"delete-45227\";i:44466;s:12:\"delete-45225\";i:44467;s:12:\"delete-45226\";i:44468;s:12:\"delete-45228\";i:44469;s:12:\"delete-45229\";i:44470;s:12:\"delete-45230\";i:44471;s:12:\"delete-45231\";i:44472;s:12:\"delete-45232\";i:44473;s:12:\"delete-45233\";i:44474;s:12:\"delete-45234\";i:44475;s:12:\"delete-45237\";i:44476;s:12:\"delete-45238\";i:44477;s:12:\"delete-45235\";i:44478;s:12:\"delete-45236\";i:44479;s:12:\"delete-45239\";i:44480;s:12:\"delete-45242\";i:44481;s:12:\"delete-45240\";i:44482;s:12:\"delete-45241\";i:44483;s:12:\"delete-45243\";i:44484;s:12:\"delete-45244\";i:44485;s:12:\"delete-45247\";i:44486;s:12:\"delete-45248\";i:44487;s:12:\"delete-45245\";i:44488;s:12:\"delete-45246\";i:44489;s:12:\"delete-45249\";i:44490;s:12:\"delete-45252\";i:44491;s:12:\"delete-45250\";i:44492;s:12:\"delete-45251\";i:44493;s:12:\"delete-45253\";i:44494;s:12:\"delete-45254\";i:44495;s:12:\"delete-45257\";i:44496;s:12:\"delete-45255\";i:44497;s:12:\"delete-45256\";i:44498;s:12:\"delete-45258\";i:44499;s:12:\"delete-45259\";i:44500;s:12:\"delete-45262\";i:44501;s:12:\"delete-45263\";i:44502;s:12:\"delete-45260\";i:44503;s:12:\"delete-45261\";i:44504;s:12:\"delete-45264\";i:44505;s:12:\"delete-45267\";i:44506;s:12:\"delete-45268\";i:44507;s:12:\"delete-45265\";i:44508;s:12:\"delete-45266\";i:44509;s:12:\"delete-45269\";i:44510;s:12:\"delete-45272\";i:44511;s:12:\"delete-45273\";i:44512;s:12:\"delete-45270\";i:44513;s:12:\"delete-45271\";i:44514;s:12:\"delete-45274\";i:44515;s:12:\"delete-45277\";i:44516;s:12:\"delete-45275\";i:44517;s:12:\"delete-45276\";i:44518;s:12:\"delete-45278\";i:44519;s:12:\"delete-45279\";i:44520;s:12:\"delete-45282\";i:44521;s:12:\"delete-45283\";i:44522;s:12:\"delete-45280\";i:44523;s:12:\"delete-45281\";i:44524;s:12:\"delete-45284\";i:44525;s:12:\"delete-45287\";i:44526;s:12:\"delete-45288\";i:44527;s:12:\"delete-45285\";i:44528;s:12:\"delete-45286\";i:44529;s:12:\"delete-45289\";i:44530;s:12:\"delete-45292\";i:44531;s:12:\"delete-45290\";i:44532;s:12:\"delete-45291\";i:44533;s:12:\"delete-45293\";i:44534;s:12:\"delete-45294\";i:44535;s:12:\"delete-45297\";i:44536;s:12:\"delete-45298\";i:44537;s:12:\"delete-45295\";i:44538;s:12:\"delete-45296\";i:44539;s:12:\"delete-45299\";i:44540;s:12:\"delete-45302\";i:44541;s:12:\"delete-45303\";i:44542;s:12:\"delete-45300\";i:44543;s:12:\"delete-45301\";i:44544;s:12:\"delete-45304\";i:44545;s:12:\"delete-45307\";i:44546;s:12:\"delete-45305\";i:44547;s:12:\"delete-45306\";i:44548;s:12:\"delete-45308\";i:44549;s:12:\"delete-45309\";i:44550;s:12:\"delete-45312\";i:44551;s:12:\"delete-45313\";i:44552;s:12:\"delete-45310\";i:44553;s:12:\"delete-45311\";i:44554;s:12:\"delete-45314\";i:44555;s:12:\"delete-45317\";i:44556;s:12:\"delete-45318\";i:44557;s:12:\"delete-45315\";i:44558;s:12:\"delete-45316\";i:44559;s:12:\"delete-45319\";i:44560;s:12:\"delete-45322\";i:44561;s:12:\"delete-45320\";i:44562;s:12:\"delete-45321\";i:44563;s:12:\"delete-45323\";i:44564;s:12:\"delete-45324\";i:44565;s:12:\"delete-45327\";i:44566;s:12:\"delete-45328\";i:44567;s:12:\"delete-45325\";i:44568;s:12:\"delete-45326\";i:44569;s:12:\"delete-45329\";i:44570;s:12:\"delete-45332\";i:44571;s:12:\"delete-45333\";i:44572;s:12:\"delete-45330\";i:44573;s:12:\"delete-45331\";i:44574;s:12:\"delete-45334\";i:44575;s:12:\"delete-45337\";i:44576;s:12:\"delete-45335\";i:44577;s:12:\"delete-45336\";i:44578;s:12:\"delete-45338\";i:44579;s:12:\"delete-45339\";i:44580;s:12:\"delete-45342\";i:44581;s:12:\"delete-45343\";i:44582;s:12:\"delete-45340\";i:44583;s:12:\"delete-45341\";i:44584;s:12:\"delete-45344\";i:44585;s:12:\"delete-45347\";i:44586;s:12:\"delete-45348\";i:44587;s:12:\"delete-45345\";i:44588;s:12:\"delete-45346\";i:44589;s:12:\"delete-45349\";i:44590;s:12:\"delete-45352\";i:44591;s:12:\"delete-45353\";i:44592;s:12:\"delete-45350\";i:44593;s:12:\"delete-45351\";i:44594;s:12:\"delete-45354\";i:44595;s:12:\"delete-45357\";i:44596;s:12:\"delete-45358\";i:44597;s:12:\"delete-45355\";i:44598;s:12:\"delete-45356\";i:44599;s:12:\"delete-45359\";i:44600;s:12:\"delete-45362\";i:44601;s:12:\"delete-45360\";i:44602;s:12:\"delete-45361\";i:44603;s:12:\"delete-45363\";i:44604;s:12:\"delete-45364\";i:44605;s:12:\"delete-45367\";i:44606;s:12:\"delete-45368\";i:44607;s:12:\"delete-45365\";i:44608;s:12:\"delete-45366\";i:44609;s:12:\"delete-45369\";i:44610;s:12:\"delete-45372\";i:44611;s:12:\"delete-45373\";i:44612;s:12:\"delete-45370\";i:44613;s:12:\"delete-45371\";i:44614;s:12:\"delete-45374\";i:44615;s:12:\"delete-45377\";i:44616;s:12:\"delete-45378\";i:44617;s:12:\"delete-45375\";i:44618;s:12:\"delete-45376\";i:44619;s:12:\"delete-45379\";i:44620;s:12:\"delete-45382\";i:44621;s:12:\"delete-45383\";i:44622;s:12:\"delete-45380\";i:44623;s:12:\"delete-45381\";i:44624;s:12:\"delete-45384\";i:44625;s:12:\"delete-45387\";i:44626;s:12:\"delete-45388\";i:44627;s:12:\"delete-45385\";i:44628;s:12:\"delete-45386\";i:44629;s:12:\"delete-45389\";i:44630;s:12:\"delete-45392\";i:44631;s:12:\"delete-45393\";i:44632;s:12:\"delete-45390\";i:44633;s:12:\"delete-45391\";i:44634;s:12:\"delete-45394\";i:44635;s:12:\"delete-45397\";i:44636;s:12:\"delete-45398\";i:44637;s:12:\"delete-45395\";i:44638;s:12:\"delete-45396\";i:44639;s:12:\"delete-45399\";i:44640;s:12:\"delete-45402\";i:44641;s:12:\"delete-45403\";i:44642;s:12:\"delete-45400\";i:44643;s:12:\"delete-45401\";i:44644;s:12:\"delete-45404\";i:44645;s:12:\"delete-45407\";i:44646;s:12:\"delete-45408\";i:44647;s:12:\"delete-45405\";i:44648;s:12:\"delete-45406\";i:44649;s:12:\"delete-45409\";i:44650;s:12:\"delete-45412\";i:44651;s:12:\"delete-45413\";i:44652;s:12:\"delete-45410\";i:44653;s:12:\"delete-45411\";i:44654;s:12:\"delete-45414\";i:44655;s:12:\"delete-45417\";i:44656;s:12:\"delete-45415\";i:44657;s:12:\"delete-45416\";i:44658;s:12:\"delete-45418\";i:44659;s:12:\"delete-45419\";i:44660;s:12:\"delete-45422\";i:44661;s:12:\"delete-45423\";i:44662;s:12:\"delete-45420\";i:44663;s:12:\"delete-45421\";i:44664;s:12:\"delete-45424\";i:44665;s:12:\"delete-45427\";i:44666;s:12:\"delete-45428\";i:44667;s:12:\"delete-45425\";i:44668;s:12:\"delete-45426\";i:44669;s:12:\"delete-45429\";i:44670;s:12:\"delete-45432\";i:44671;s:12:\"delete-45433\";i:44672;s:12:\"delete-45430\";i:44673;s:12:\"delete-45431\";i:44674;s:12:\"delete-45434\";i:44675;s:12:\"delete-45437\";i:44676;s:12:\"delete-45435\";i:44677;s:12:\"delete-45436\";i:44678;s:12:\"delete-45438\";i:44679;s:12:\"delete-45439\";i:44680;s:12:\"delete-45442\";i:44681;s:12:\"delete-45443\";i:44682;s:12:\"delete-45440\";i:44683;s:12:\"delete-45441\";i:44684;s:12:\"delete-45444\";i:44685;s:12:\"delete-45447\";i:44686;s:12:\"delete-45445\";i:44687;s:12:\"delete-45446\";i:44688;s:12:\"delete-45448\";i:44689;s:12:\"delete-45449\";i:44690;s:12:\"delete-45452\";i:44691;s:12:\"delete-45453\";i:44692;s:12:\"delete-45450\";i:44693;s:12:\"delete-45451\";i:44694;s:12:\"delete-45454\";i:44695;s:12:\"delete-45457\";i:44696;s:12:\"delete-45458\";i:44697;s:12:\"delete-45455\";i:44698;s:12:\"delete-45456\";i:44699;s:12:\"delete-45459\";i:44700;s:12:\"delete-45462\";i:44701;s:12:\"delete-45463\";i:44702;s:12:\"delete-45460\";i:44703;s:12:\"delete-45461\";i:44704;s:12:\"delete-45464\";i:44705;s:12:\"delete-45467\";i:44706;s:12:\"delete-45468\";i:44707;s:12:\"delete-45465\";i:44708;s:12:\"delete-45466\";i:44709;s:12:\"delete-45469\";i:44710;s:12:\"delete-45472\";i:44711;s:12:\"delete-45473\";i:44712;s:12:\"delete-45470\";i:44713;s:12:\"delete-45471\";i:44714;s:12:\"delete-45474\";i:44715;s:12:\"delete-45477\";i:44716;s:12:\"delete-45475\";i:44717;s:12:\"delete-45476\";i:44718;s:12:\"delete-45478\";i:44719;s:12:\"delete-45479\";i:44720;s:12:\"delete-45482\";i:44721;s:12:\"delete-45483\";i:44722;s:12:\"delete-45480\";i:44723;s:12:\"delete-45481\";i:44724;s:12:\"delete-45484\";i:44725;s:12:\"delete-45487\";i:44726;s:12:\"delete-45485\";i:44727;s:12:\"delete-45486\";i:44728;s:12:\"delete-45488\";i:44729;s:12:\"delete-45489\";i:44730;s:12:\"delete-45492\";i:44731;s:12:\"delete-45490\";i:44732;s:12:\"delete-45491\";i:44733;s:12:\"delete-45493\";i:44734;s:12:\"delete-45494\";i:44735;s:12:\"delete-45497\";i:44736;s:12:\"delete-45498\";i:44737;s:12:\"delete-45495\";i:44738;s:12:\"delete-45496\";i:44739;s:12:\"delete-45499\";i:44740;s:12:\"delete-45502\";i:44741;s:12:\"delete-45503\";i:44742;s:12:\"delete-45500\";i:44743;s:12:\"delete-45501\";i:44744;s:12:\"delete-45504\";i:44745;s:12:\"delete-45507\";i:44746;s:12:\"delete-45505\";i:44747;s:12:\"delete-45506\";i:44748;s:12:\"delete-45508\";i:44749;s:12:\"delete-45509\";i:44750;s:12:\"delete-45512\";i:44751;s:12:\"delete-45513\";i:44752;s:12:\"delete-45510\";i:44753;s:12:\"delete-45511\";i:44754;s:12:\"delete-45514\";i:44755;s:12:\"delete-45517\";i:44756;s:12:\"delete-45518\";i:44757;s:12:\"delete-45515\";i:44758;s:12:\"delete-45516\";i:44759;s:12:\"delete-45519\";i:44760;s:12:\"delete-45522\";i:44761;s:12:\"delete-45523\";i:44762;s:12:\"delete-45520\";i:44763;s:12:\"delete-45521\";i:44764;s:12:\"delete-45524\";i:44765;s:12:\"delete-45527\";i:44766;s:12:\"delete-45528\";i:44767;s:12:\"delete-45525\";i:44768;s:12:\"delete-45526\";i:44769;s:12:\"delete-45529\";i:44770;s:12:\"delete-45532\";i:44771;s:12:\"delete-45530\";i:44772;s:12:\"delete-45531\";i:44773;s:12:\"delete-45533\";i:44774;s:12:\"delete-45534\";i:44775;s:12:\"delete-45537\";i:44776;s:12:\"delete-45538\";i:44777;s:12:\"delete-45535\";i:44778;s:12:\"delete-45536\";i:44779;s:12:\"delete-45539\";i:44780;s:12:\"delete-45542\";i:44781;s:12:\"delete-45540\";i:44782;s:12:\"delete-45541\";i:44783;s:12:\"delete-45543\";i:44784;s:12:\"delete-45544\";i:44785;s:12:\"delete-45547\";i:44786;s:12:\"delete-45548\";i:44787;s:12:\"delete-45545\";i:44788;s:12:\"delete-45546\";i:44789;s:12:\"delete-45549\";i:44790;s:12:\"delete-45552\";i:44791;s:12:\"delete-45553\";i:44792;s:12:\"delete-45550\";i:44793;s:12:\"delete-45551\";i:44794;s:12:\"delete-45554\";i:44795;s:12:\"delete-45557\";i:44796;s:12:\"delete-45558\";i:44797;s:12:\"delete-45555\";i:44798;s:12:\"delete-45556\";i:44799;s:12:\"delete-45559\";i:44800;s:12:\"delete-45562\";i:44801;s:12:\"delete-45560\";i:44802;s:12:\"delete-45561\";i:44803;s:12:\"delete-45563\";i:44804;s:12:\"delete-45564\";i:44805;s:12:\"delete-45567\";i:44806;s:12:\"delete-45568\";i:44807;s:12:\"delete-45565\";i:44808;s:12:\"delete-45566\";i:44809;s:12:\"delete-45569\";i:44810;s:12:\"delete-45572\";i:44811;s:12:\"delete-45573\";i:44812;s:12:\"delete-45570\";i:44813;s:12:\"delete-45571\";i:44814;s:12:\"delete-45574\";i:44815;s:12:\"delete-45577\";i:44816;s:12:\"delete-45578\";i:44817;s:12:\"delete-45575\";i:44818;s:12:\"delete-45576\";i:44819;s:12:\"delete-45579\";i:44820;s:12:\"delete-45582\";i:44821;s:12:\"delete-45583\";i:44822;s:12:\"delete-45580\";i:44823;s:12:\"delete-45581\";i:44824;s:12:\"delete-45584\";i:44825;s:12:\"delete-45587\";i:44826;s:12:\"delete-45588\";i:44827;s:12:\"delete-45585\";i:44828;s:12:\"delete-45586\";i:44829;s:12:\"delete-45589\";i:44830;s:12:\"delete-45592\";i:44831;s:12:\"delete-45593\";i:44832;s:12:\"delete-45594\";i:44833;s:12:\"delete-45597\";i:44834;s:12:\"delete-45598\";i:44835;s:12:\"delete-45590\";i:44836;s:12:\"delete-45591\";i:44837;s:12:\"delete-45595\";i:44838;s:12:\"delete-45596\";i:44839;s:12:\"delete-45599\";i:44840;s:12:\"delete-45602\";i:44841;s:12:\"delete-45603\";i:44842;s:12:\"delete-45600\";i:44843;s:12:\"delete-45601\";i:44844;s:12:\"delete-45604\";i:44845;s:12:\"delete-45607\";i:44846;s:12:\"delete-45608\";i:44847;s:12:\"delete-45605\";i:44848;s:12:\"delete-45606\";i:44849;s:12:\"delete-45609\";i:44850;s:12:\"delete-45612\";i:44851;s:12:\"delete-45613\";i:44852;s:12:\"delete-45610\";i:44853;s:12:\"delete-45611\";i:44854;s:12:\"delete-45614\";i:44855;s:12:\"delete-45617\";i:44856;s:12:\"delete-45615\";i:44857;s:12:\"delete-45616\";i:44858;s:12:\"delete-45618\";i:44859;s:12:\"delete-45619\";i:44860;s:12:\"delete-45622\";i:44861;s:12:\"delete-45623\";i:44862;s:12:\"delete-45620\";i:44863;s:12:\"delete-45621\";i:44864;s:12:\"delete-45624\";i:44865;s:12:\"delete-45627\";i:44866;s:12:\"delete-45628\";i:44867;s:12:\"delete-45625\";i:44868;s:12:\"delete-45626\";i:44869;s:12:\"delete-45629\";i:44870;s:12:\"delete-45632\";i:44871;s:12:\"delete-45633\";i:44872;s:12:\"delete-45630\";i:44873;s:12:\"delete-45631\";i:44874;s:12:\"delete-45634\";i:44875;s:12:\"delete-45637\";i:44876;s:12:\"delete-45638\";i:44877;s:12:\"delete-45635\";i:44878;s:12:\"delete-45636\";i:44879;s:12:\"delete-45639\";i:44880;s:12:\"delete-45642\";i:44881;s:12:\"delete-45643\";i:44882;s:12:\"delete-45640\";i:44883;s:12:\"delete-45641\";i:44884;s:12:\"delete-45644\";i:44885;s:12:\"delete-45647\";i:44886;s:12:\"delete-45648\";i:44887;s:12:\"delete-45645\";i:44888;s:12:\"delete-45646\";i:44889;s:12:\"delete-45649\";i:44890;s:12:\"delete-45652\";i:44891;s:12:\"delete-45653\";i:44892;s:12:\"delete-45650\";i:44893;s:12:\"delete-45651\";i:44894;s:12:\"delete-45654\";i:44895;s:12:\"delete-45657\";i:44896;s:12:\"delete-45655\";i:44897;s:12:\"delete-45656\";i:44898;s:12:\"delete-45658\";i:44899;s:12:\"delete-45659\";i:44900;s:12:\"delete-45662\";i:44901;s:12:\"delete-45663\";i:44902;s:12:\"delete-45660\";i:44903;s:12:\"delete-45661\";i:44904;s:12:\"delete-45664\";i:44905;s:12:\"delete-45667\";i:44906;s:12:\"delete-45668\";i:44907;s:12:\"delete-45665\";i:44908;s:12:\"delete-45666\";i:44909;s:12:\"delete-45669\";i:44910;s:12:\"delete-45672\";i:44911;s:12:\"delete-45673\";i:44912;s:12:\"delete-45670\";i:44913;s:12:\"delete-45671\";i:44914;s:12:\"delete-45674\";i:44915;s:12:\"delete-45677\";i:44916;s:12:\"delete-45678\";i:44917;s:12:\"delete-45675\";i:44918;s:12:\"delete-45676\";i:44919;s:12:\"delete-45679\";i:44920;s:12:\"delete-45682\";i:44921;s:12:\"delete-45683\";i:44922;s:12:\"delete-45680\";i:44923;s:12:\"delete-45681\";i:44924;s:12:\"delete-45684\";i:44925;s:12:\"delete-45687\";i:44926;s:12:\"delete-45688\";i:44927;s:12:\"delete-45685\";i:44928;s:12:\"delete-45686\";i:44929;s:12:\"delete-45689\";i:44930;s:12:\"delete-45692\";i:44931;s:12:\"delete-45693\";i:44932;s:12:\"delete-45690\";i:44933;s:12:\"delete-45691\";i:44934;s:12:\"delete-45694\";i:44935;s:12:\"delete-45697\";i:44936;s:12:\"delete-45698\";i:44937;s:12:\"delete-45695\";i:44938;s:12:\"delete-45696\";i:44939;s:12:\"delete-45699\";i:44940;s:12:\"delete-45702\";i:44941;s:12:\"delete-45703\";i:44942;s:12:\"delete-45700\";i:44943;s:12:\"delete-45701\";i:44944;s:12:\"delete-45704\";i:44945;s:12:\"delete-45707\";i:44946;s:12:\"delete-45708\";i:44947;s:12:\"delete-45705\";i:44948;s:12:\"delete-45706\";i:44949;s:12:\"delete-45709\";i:44950;s:12:\"delete-45712\";i:44951;s:12:\"delete-45710\";i:44952;s:12:\"delete-45711\";i:44953;s:12:\"delete-45713\";i:44954;s:12:\"delete-45714\";i:44955;s:12:\"delete-45717\";i:44956;s:12:\"delete-45718\";i:44957;s:12:\"delete-45715\";i:44958;s:12:\"delete-45716\";i:44959;s:12:\"delete-45719\";i:44960;s:12:\"delete-45722\";i:44961;s:12:\"delete-45720\";i:44962;s:12:\"delete-45721\";i:44963;s:12:\"delete-45723\";i:44964;s:12:\"delete-45724\";i:44965;s:12:\"delete-45727\";i:44966;s:12:\"delete-45728\";i:44967;s:12:\"delete-45725\";i:44968;s:12:\"delete-45726\";i:44969;s:12:\"delete-45729\";i:44970;s:12:\"delete-45732\";i:44971;s:12:\"delete-45733\";i:44972;s:12:\"delete-45730\";i:44973;s:12:\"delete-45731\";i:44974;s:12:\"delete-45734\";i:44975;s:12:\"delete-45737\";i:44976;s:12:\"delete-45738\";i:44977;s:12:\"delete-45735\";i:44978;s:12:\"delete-45736\";i:44979;s:12:\"delete-45739\";i:44980;s:12:\"delete-45740\";i:44981;s:12:\"delete-45741\";i:44982;s:12:\"delete-45742\";i:44983;s:12:\"delete-45743\";i:44984;s:12:\"delete-45744\";i:44985;s:12:\"delete-45747\";i:44986;s:12:\"delete-45748\";i:44987;s:12:\"delete-45745\";i:44988;s:12:\"delete-45746\";i:44989;s:12:\"delete-45749\";i:44990;s:12:\"delete-45752\";i:44991;s:12:\"delete-45753\";i:44992;s:12:\"delete-45750\";i:44993;s:12:\"delete-45751\";i:44994;s:12:\"delete-45754\";i:44995;s:12:\"delete-45757\";i:44996;s:12:\"delete-45758\";i:44997;s:12:\"delete-45755\";i:44998;s:12:\"delete-45756\";i:44999;s:12:\"delete-45759\";i:45000;s:12:\"delete-45762\";i:45001;s:12:\"delete-45760\";i:45002;s:12:\"delete-45761\";i:45003;s:12:\"delete-45763\";i:45004;s:12:\"delete-45764\";i:45005;s:12:\"delete-45767\";i:45006;s:12:\"delete-45768\";i:45007;s:12:\"delete-45765\";i:45008;s:12:\"delete-45766\";i:45009;s:12:\"delete-45769\";i:45010;s:12:\"delete-45772\";i:45011;s:12:\"delete-45773\";i:45012;s:12:\"delete-45770\";i:45013;s:12:\"delete-45771\";i:45014;s:12:\"delete-45774\";i:45015;s:12:\"delete-45777\";i:45016;s:12:\"delete-45778\";i:45017;s:12:\"delete-45775\";i:45018;s:12:\"delete-45776\";i:45019;s:12:\"delete-45779\";i:45020;s:12:\"delete-45782\";i:45021;s:12:\"delete-45780\";i:45022;s:12:\"delete-45781\";i:45023;s:12:\"delete-45783\";i:45024;s:12:\"delete-45784\";i:45025;s:12:\"delete-45787\";i:45026;s:12:\"delete-45788\";i:45027;s:12:\"delete-45785\";i:45028;s:12:\"delete-45786\";i:45029;s:12:\"delete-45789\";i:45030;s:12:\"delete-45792\";i:45031;s:12:\"delete-45793\";i:45032;s:12:\"delete-45790\";i:45033;s:12:\"delete-45791\";i:45034;s:12:\"delete-45794\";i:45035;s:12:\"delete-45797\";i:45036;s:12:\"delete-45795\";i:45037;s:12:\"delete-45796\";i:45038;s:12:\"delete-45798\";i:45039;s:12:\"delete-45799\";i:45040;s:12:\"delete-45802\";i:45041;s:12:\"delete-45803\";i:45042;s:12:\"delete-45800\";i:45043;s:12:\"delete-45801\";i:45044;s:12:\"delete-45804\";i:45045;s:12:\"delete-45807\";i:45046;s:12:\"delete-45808\";i:45047;s:12:\"delete-45805\";i:45048;s:12:\"delete-45806\";i:45049;s:12:\"delete-45809\";i:45050;s:12:\"delete-45812\";i:45051;s:12:\"delete-45813\";i:45052;s:12:\"delete-45810\";i:45053;s:12:\"delete-45811\";i:45054;s:12:\"delete-45814\";i:45055;s:12:\"delete-45817\";i:45056;s:12:\"delete-45818\";i:45057;s:12:\"delete-45815\";i:45058;s:12:\"delete-45816\";i:45059;s:12:\"delete-45819\";i:45060;s:12:\"delete-45822\";i:45061;s:12:\"delete-45823\";i:45062;s:12:\"delete-45820\";i:45063;s:12:\"delete-45821\";i:45064;s:12:\"delete-45824\";i:45065;s:12:\"delete-45827\";i:45066;s:12:\"delete-45825\";i:45067;s:12:\"delete-45826\";i:45068;s:12:\"delete-45828\";i:45069;s:12:\"delete-45829\";i:45070;s:12:\"delete-45832\";i:45071;s:12:\"delete-45833\";i:45072;s:12:\"delete-45830\";i:45073;s:12:\"delete-45831\";i:45074;s:12:\"delete-45834\";i:45075;s:12:\"delete-45837\";i:45076;s:12:\"delete-45835\";i:45077;s:12:\"delete-45836\";i:45078;s:12:\"delete-45838\";i:45079;s:12:\"delete-45839\";i:45080;s:12:\"delete-45842\";i:45081;s:12:\"delete-45843\";i:45082;s:12:\"delete-45840\";i:45083;s:12:\"delete-45841\";i:45084;s:12:\"delete-45844\";i:45085;s:12:\"delete-45847\";i:45086;s:12:\"delete-45848\";i:45087;s:12:\"delete-45845\";i:45088;s:12:\"delete-45846\";i:45089;s:12:\"delete-45849\";i:45090;s:12:\"delete-45852\";i:45091;s:12:\"delete-45853\";i:45092;s:12:\"delete-45850\";i:45093;s:12:\"delete-45851\";i:45094;s:12:\"delete-45854\";i:45095;s:12:\"delete-45857\";i:45096;s:12:\"delete-45855\";i:45097;s:12:\"delete-45856\";i:45098;s:12:\"delete-45858\";i:45099;s:12:\"delete-45859\";i:45100;s:12:\"delete-45862\";i:45101;s:12:\"delete-45863\";i:45102;s:12:\"delete-45860\";i:45103;s:12:\"delete-45861\";i:45104;s:12:\"delete-45864\";i:45105;s:12:\"delete-45867\";i:45106;s:12:\"delete-45865\";i:45107;s:12:\"delete-45866\";i:45108;s:12:\"delete-45868\";i:45109;s:12:\"delete-45869\";i:45110;s:12:\"delete-45872\";i:45111;s:12:\"delete-45873\";i:45112;s:12:\"delete-45870\";i:45113;s:12:\"delete-45871\";i:45114;s:12:\"delete-45874\";i:45115;s:12:\"delete-45877\";i:45116;s:12:\"delete-45878\";i:45117;s:12:\"delete-45875\";i:45118;s:12:\"delete-45876\";i:45119;s:12:\"delete-45879\";i:45120;s:12:\"delete-45882\";i:45121;s:12:\"delete-45883\";i:45122;s:12:\"delete-45880\";i:45123;s:12:\"delete-45881\";i:45124;s:12:\"delete-45884\";i:45125;s:12:\"delete-45887\";i:45126;s:12:\"delete-45888\";i:45127;s:12:\"delete-45885\";i:45128;s:12:\"delete-45886\";i:45129;s:12:\"delete-45889\";i:45130;s:12:\"delete-45892\";i:45131;s:12:\"delete-45893\";i:45132;s:12:\"delete-45890\";i:45133;s:12:\"delete-45891\";i:45134;s:12:\"delete-45894\";i:45135;s:12:\"delete-45897\";i:45136;s:12:\"delete-45898\";i:45137;s:12:\"delete-45895\";i:45138;s:12:\"delete-45896\";i:45139;s:12:\"delete-45899\";i:45140;s:12:\"delete-45902\";i:45141;s:12:\"delete-45900\";i:45142;s:12:\"delete-45901\";i:45143;s:12:\"delete-45903\";i:45144;s:12:\"delete-45904\";i:45145;s:12:\"delete-45907\";i:45146;s:12:\"delete-45908\";i:45147;s:12:\"delete-45905\";i:45148;s:12:\"delete-45906\";i:45149;s:12:\"delete-45909\";i:45150;s:12:\"delete-45912\";i:45151;s:12:\"delete-45910\";i:45152;s:12:\"delete-45911\";i:45153;s:12:\"delete-45913\";i:45154;s:12:\"delete-45914\";i:45155;s:12:\"delete-45917\";i:45156;s:12:\"delete-45918\";i:45157;s:12:\"delete-45915\";i:45158;s:12:\"delete-45916\";i:45159;s:12:\"delete-45919\";i:45160;s:12:\"delete-45922\";i:45161;s:12:\"delete-45923\";i:45162;s:12:\"delete-45920\";i:45163;s:12:\"delete-45921\";i:45164;s:12:\"delete-45924\";i:45165;s:12:\"delete-45927\";i:45166;s:12:\"delete-45928\";i:45167;s:12:\"delete-45925\";i:45168;s:12:\"delete-45926\";i:45169;s:12:\"delete-45929\";i:45170;s:12:\"delete-45932\";i:45171;s:12:\"delete-45933\";i:45172;s:12:\"delete-45930\";i:45173;s:12:\"delete-45931\";i:45174;s:12:\"delete-45934\";i:45175;s:12:\"delete-45937\";i:45176;s:12:\"delete-45938\";i:45177;s:12:\"delete-45935\";i:45178;s:12:\"delete-45936\";i:45179;s:12:\"delete-45939\";i:45180;s:12:\"delete-45942\";i:45181;s:12:\"delete-45940\";i:45182;s:12:\"delete-45941\";i:45183;s:12:\"delete-45943\";i:45184;s:12:\"delete-45944\";i:45185;s:12:\"delete-45947\";i:45186;s:12:\"delete-45948\";i:45187;s:12:\"delete-45945\";i:45188;s:12:\"delete-45946\";i:45189;s:12:\"delete-45949\";i:45190;s:12:\"delete-45952\";i:45191;s:12:\"delete-45950\";i:45192;s:12:\"delete-45951\";i:45193;s:12:\"delete-45953\";i:45194;s:12:\"delete-45954\";i:45195;s:12:\"delete-45957\";i:45196;s:12:\"delete-45958\";i:45197;s:12:\"delete-45955\";i:45198;s:12:\"delete-45956\";i:45199;s:12:\"delete-45959\";i:45200;s:12:\"delete-45962\";i:45201;s:12:\"delete-45963\";i:45202;s:12:\"delete-45960\";i:45203;s:12:\"delete-45961\";i:45204;s:12:\"delete-45964\";i:45205;s:12:\"delete-45967\";i:45206;s:12:\"delete-45968\";i:45207;s:12:\"delete-45965\";i:45208;s:12:\"delete-45966\";i:45209;s:12:\"delete-45969\";i:45210;s:12:\"delete-45972\";i:45211;s:12:\"delete-45973\";i:45212;s:12:\"delete-45970\";i:45213;s:12:\"delete-45971\";i:45214;s:12:\"delete-45974\";i:45215;s:12:\"delete-45977\";i:45216;s:12:\"delete-45975\";i:45217;s:12:\"delete-45976\";i:45218;s:12:\"delete-45978\";i:45219;s:12:\"delete-45979\";i:45220;s:12:\"delete-45982\";i:45221;s:12:\"delete-45983\";i:45222;s:12:\"delete-45984\";i:45223;s:12:\"delete-45987\";i:45224;s:12:\"delete-45988\";i:45225;s:12:\"delete-45980\";i:45226;s:12:\"delete-45981\";i:45227;s:12:\"delete-45985\";i:45228;s:12:\"delete-45986\";i:45229;s:12:\"delete-45989\";i:45230;s:12:\"delete-45992\";i:45231;s:12:\"delete-45990\";i:45232;s:12:\"delete-45991\";i:45233;s:12:\"delete-45993\";i:45234;s:12:\"delete-45994\";i:45235;s:12:\"delete-45997\";i:45236;s:12:\"delete-45998\";i:45237;s:12:\"delete-45995\";i:45238;s:12:\"delete-45996\";i:45239;s:12:\"delete-45999\";i:45240;s:12:\"delete-46002\";i:45241;s:12:\"delete-46003\";i:45242;s:12:\"delete-46000\";i:45243;s:12:\"delete-46001\";i:45244;s:12:\"delete-46004\";i:45245;s:12:\"delete-46007\";i:45246;s:12:\"delete-46005\";i:45247;s:12:\"delete-46006\";i:45248;s:12:\"delete-46008\";i:45249;s:12:\"delete-46009\";i:45250;s:12:\"delete-46012\";i:45251;s:12:\"delete-46013\";i:45252;s:12:\"delete-46010\";i:45253;s:12:\"delete-46011\";i:45254;s:12:\"delete-46014\";i:45255;s:12:\"delete-46017\";i:45256;s:12:\"delete-46018\";i:45257;s:12:\"delete-46015\";i:45258;s:12:\"delete-46016\";i:45259;s:12:\"delete-46019\";i:45260;s:12:\"delete-46022\";i:45261;s:12:\"delete-46023\";i:45262;s:12:\"delete-46020\";i:45263;s:12:\"delete-46021\";i:45264;s:12:\"delete-46024\";i:45265;s:12:\"delete-46027\";i:45266;s:12:\"delete-46028\";i:45267;s:12:\"delete-46025\";i:45268;s:12:\"delete-46026\";i:45269;s:12:\"delete-46029\";i:45270;s:12:\"delete-46032\";i:45271;s:12:\"delete-46030\";i:45272;s:12:\"delete-46031\";i:45273;s:12:\"delete-46033\";i:45274;s:12:\"delete-46034\";i:45275;s:12:\"delete-46037\";i:45276;s:12:\"delete-46038\";i:45277;s:12:\"delete-46035\";i:45278;s:12:\"delete-46036\";i:45279;s:12:\"delete-46039\";i:45280;s:12:\"delete-46042\";i:45281;s:12:\"delete-46043\";i:45282;s:12:\"delete-46040\";i:45283;s:12:\"delete-46041\";i:45284;s:12:\"delete-46044\";i:45285;s:12:\"delete-46047\";i:45286;s:12:\"delete-46048\";i:45287;s:12:\"delete-46045\";i:45288;s:12:\"delete-46046\";i:45289;s:12:\"delete-46049\";i:45290;s:12:\"delete-46052\";i:45291;s:12:\"delete-46053\";i:45292;s:12:\"delete-46050\";i:45293;s:12:\"delete-46051\";i:45294;s:12:\"delete-46054\";i:45295;s:12:\"delete-46057\";i:45296;s:12:\"delete-46058\";i:45297;s:12:\"delete-46055\";i:45298;s:12:\"delete-46056\";i:45299;s:12:\"delete-46059\";i:45300;s:12:\"delete-46062\";i:45301;s:12:\"delete-46063\";i:45302;s:12:\"delete-46060\";i:45303;s:12:\"delete-46061\";i:45304;s:12:\"delete-46064\";i:45305;s:12:\"delete-46067\";i:45306;s:12:\"delete-46068\";i:45307;s:12:\"delete-46065\";i:45308;s:12:\"delete-46066\";i:45309;s:12:\"delete-46069\";i:45310;s:12:\"delete-46072\";i:45311;s:12:\"delete-46070\";i:45312;s:12:\"delete-46071\";i:45313;s:12:\"delete-46073\";i:45314;s:12:\"delete-46074\";i:45315;s:12:\"delete-46077\";i:45316;s:12:\"delete-46078\";i:45317;s:12:\"delete-46075\";i:45318;s:12:\"delete-46076\";i:45319;s:12:\"delete-46079\";i:45320;s:12:\"delete-46082\";i:45321;s:12:\"delete-46083\";i:45322;s:12:\"delete-46080\";i:45323;s:12:\"delete-46081\";i:45324;s:12:\"delete-46084\";i:45325;s:12:\"delete-46087\";i:45326;s:12:\"delete-46088\";i:45327;s:12:\"delete-46085\";i:45328;s:12:\"delete-46086\";i:45329;s:12:\"delete-46089\";i:45330;s:12:\"delete-46092\";i:45331;s:12:\"delete-46093\";i:45332;s:12:\"delete-46090\";i:45333;s:12:\"delete-46091\";i:45334;s:12:\"delete-46094\";i:45335;s:12:\"delete-46097\";i:45336;s:12:\"delete-46098\";i:45337;s:12:\"delete-46095\";i:45338;s:12:\"delete-46096\";i:45339;s:12:\"delete-46099\";i:45340;s:12:\"delete-46102\";i:45341;s:12:\"delete-46103\";i:45342;s:12:\"delete-46100\";i:45343;s:12:\"delete-46101\";i:45344;s:12:\"delete-46104\";i:45345;s:12:\"delete-46107\";i:45346;s:12:\"delete-46108\";i:45347;s:12:\"delete-46105\";i:45348;s:12:\"delete-46106\";i:45349;s:12:\"delete-46109\";i:45350;s:12:\"delete-46112\";i:45351;s:12:\"delete-46113\";i:45352;s:12:\"delete-46110\";i:45353;s:12:\"delete-46111\";i:45354;s:12:\"delete-46114\";i:45355;s:12:\"delete-46117\";i:45356;s:12:\"delete-46118\";i:45357;s:12:\"delete-46115\";i:45358;s:12:\"delete-46116\";i:45359;s:12:\"delete-46119\";i:45360;s:12:\"delete-46122\";i:45361;s:12:\"delete-46123\";i:45362;s:12:\"delete-46120\";i:45363;s:12:\"delete-46121\";i:45364;s:12:\"delete-46124\";i:45365;s:12:\"delete-46127\";i:45366;s:12:\"delete-46128\";i:45367;s:12:\"delete-46125\";i:45368;s:12:\"delete-46126\";i:45369;s:12:\"delete-46129\";i:45370;s:12:\"delete-46132\";i:45371;s:12:\"delete-46133\";i:45372;s:12:\"delete-46130\";i:45373;s:12:\"delete-46131\";i:45374;s:12:\"delete-46134\";i:45375;s:12:\"delete-46137\";i:45376;s:12:\"delete-46135\";i:45377;s:12:\"delete-46136\";i:45378;s:12:\"delete-46138\";i:45379;s:12:\"delete-46139\";i:45380;s:12:\"delete-46142\";i:45381;s:12:\"delete-46143\";i:45382;s:12:\"delete-46140\";i:45383;s:12:\"delete-46141\";i:45384;s:12:\"delete-46144\";i:45385;s:12:\"delete-46147\";i:45386;s:12:\"delete-46148\";i:45387;s:12:\"delete-46145\";i:45388;s:12:\"delete-46146\";i:45389;s:12:\"delete-46149\";i:45390;s:12:\"delete-46152\";i:45391;s:12:\"delete-46153\";i:45392;s:12:\"delete-46150\";i:45393;s:12:\"delete-46151\";i:45394;s:12:\"delete-46154\";i:45395;s:12:\"delete-46157\";i:45396;s:12:\"delete-46158\";i:45397;s:12:\"delete-46155\";i:45398;s:12:\"delete-46156\";i:45399;s:12:\"delete-46159\";i:45400;s:12:\"delete-46162\";i:45401;s:12:\"delete-46160\";i:45402;s:12:\"delete-46161\";i:45403;s:12:\"delete-46163\";i:45404;s:12:\"delete-46164\";i:45405;s:12:\"delete-46167\";i:45406;s:12:\"delete-46165\";i:45407;s:12:\"delete-46166\";i:45408;s:12:\"delete-46168\";i:45409;s:12:\"delete-46169\";i:45410;s:12:\"delete-46172\";i:45411;s:12:\"delete-46173\";i:45412;s:12:\"delete-46170\";i:45413;s:12:\"delete-46171\";i:45414;s:12:\"delete-46174\";i:45415;s:12:\"delete-46177\";i:45416;s:12:\"delete-46178\";i:45417;s:12:\"delete-46175\";i:45418;s:12:\"delete-46176\";i:45419;s:12:\"delete-46179\";i:45420;s:12:\"delete-46182\";i:45421;s:12:\"delete-46183\";i:45422;s:12:\"delete-46180\";i:45423;s:12:\"delete-46181\";i:45424;s:12:\"delete-46184\";i:45425;s:12:\"delete-46187\";i:45426;s:12:\"delete-46188\";i:45427;s:12:\"delete-46185\";i:45428;s:12:\"delete-46186\";i:45429;s:12:\"delete-46189\";i:45430;s:12:\"delete-46192\";i:45431;s:12:\"delete-46193\";i:45432;s:12:\"delete-46190\";i:45433;s:12:\"delete-46191\";i:45434;s:12:\"delete-46194\";i:45435;s:12:\"delete-46197\";i:45436;s:12:\"delete-46198\";i:45437;s:12:\"delete-46195\";i:45438;s:12:\"delete-46196\";i:45439;s:12:\"delete-46199\";i:45440;s:12:\"delete-46202\";i:45441;s:12:\"delete-46203\";i:45442;s:12:\"delete-46200\";i:45443;s:12:\"delete-46201\";i:45444;s:12:\"delete-46204\";i:45445;s:12:\"delete-46207\";i:45446;s:12:\"delete-46205\";i:45447;s:12:\"delete-46206\";i:45448;s:12:\"delete-46208\";i:45449;s:12:\"delete-46209\";i:45450;s:12:\"delete-46212\";i:45451;s:12:\"delete-46213\";i:45452;s:12:\"delete-46210\";i:45453;s:12:\"delete-46211\";i:45454;s:12:\"delete-46214\";i:45455;s:12:\"delete-46217\";i:45456;s:12:\"delete-46218\";i:45457;s:12:\"delete-46215\";i:45458;s:12:\"delete-46216\";i:45459;s:12:\"delete-46219\";i:45460;s:12:\"delete-46222\";i:45461;s:12:\"delete-46223\";i:45462;s:12:\"delete-46220\";i:45463;s:12:\"delete-46221\";i:45464;s:12:\"delete-46224\";i:45465;s:12:\"delete-46227\";i:45466;s:12:\"delete-46228\";i:45467;s:12:\"delete-46225\";i:45468;s:12:\"delete-46226\";i:45469;s:12:\"delete-46229\";i:45470;s:12:\"delete-46232\";i:45471;s:12:\"delete-46233\";i:45472;s:12:\"delete-46230\";i:45473;s:12:\"delete-46231\";i:45474;s:12:\"delete-46234\";i:45475;s:12:\"delete-46237\";i:45476;s:12:\"delete-46238\";i:45477;s:12:\"delete-46235\";i:45478;s:12:\"delete-46236\";i:45479;s:12:\"delete-46239\";i:45480;s:12:\"delete-46242\";i:45481;s:12:\"delete-46243\";i:45482;s:12:\"delete-46240\";i:45483;s:12:\"delete-46241\";i:45484;s:12:\"delete-46244\";i:45485;s:12:\"delete-46247\";i:45486;s:12:\"delete-46248\";i:45487;s:12:\"delete-46245\";i:45488;s:12:\"delete-46246\";i:45489;s:12:\"delete-46249\";i:45490;s:12:\"delete-46252\";i:45491;s:12:\"delete-46253\";i:45492;s:12:\"delete-46250\";i:45493;s:12:\"delete-46251\";i:45494;s:12:\"delete-46254\";i:45495;s:12:\"delete-46257\";i:45496;s:12:\"delete-46255\";i:45497;s:12:\"delete-46256\";i:45498;s:12:\"delete-46258\";i:45499;s:12:\"delete-46259\";i:45500;s:12:\"delete-46262\";i:45501;s:12:\"delete-46263\";i:45502;s:12:\"delete-46260\";i:45503;s:12:\"delete-46261\";i:45504;s:12:\"delete-46264\";i:45505;s:12:\"delete-46267\";i:45506;s:12:\"delete-46268\";i:45507;s:12:\"delete-46265\";i:45508;s:12:\"delete-46266\";i:45509;s:12:\"delete-46269\";i:45510;s:12:\"delete-46272\";i:45511;s:12:\"delete-46273\";i:45512;s:12:\"delete-46270\";i:45513;s:12:\"delete-46271\";i:45514;s:12:\"delete-46274\";i:45515;s:12:\"delete-46277\";i:45516;s:12:\"delete-46278\";i:45517;s:12:\"delete-46275\";i:45518;s:12:\"delete-46276\";i:45519;s:12:\"delete-46279\";i:45520;s:12:\"delete-46282\";i:45521;s:12:\"delete-46283\";i:45522;s:12:\"delete-46280\";i:45523;s:12:\"delete-46281\";i:45524;s:12:\"delete-46284\";i:45525;s:12:\"delete-46287\";i:45526;s:12:\"delete-46285\";i:45527;s:12:\"delete-46286\";i:45528;s:12:\"delete-46288\";i:45529;s:12:\"delete-46289\";i:45530;s:12:\"delete-46292\";i:45531;s:12:\"delete-46293\";i:45532;s:12:\"delete-46290\";i:45533;s:12:\"delete-46291\";i:45534;s:12:\"delete-46294\";i:45535;s:12:\"delete-46297\";i:45536;s:12:\"delete-46298\";i:45537;s:12:\"delete-46295\";i:45538;s:12:\"delete-46296\";i:45539;s:12:\"delete-46299\";i:45540;s:12:\"delete-46302\";i:45541;s:12:\"delete-46303\";i:45542;s:12:\"delete-46300\";i:45543;s:12:\"delete-46301\";i:45544;s:12:\"delete-46304\";i:45545;s:12:\"delete-46307\";i:45546;s:12:\"delete-46308\";i:45547;s:12:\"delete-46305\";i:45548;s:12:\"delete-46306\";i:45549;s:12:\"delete-46309\";i:45550;s:12:\"delete-46312\";i:45551;s:12:\"delete-46310\";i:45552;s:12:\"delete-46311\";i:45553;s:12:\"delete-46313\";i:45554;s:12:\"delete-46314\";i:45555;s:12:\"delete-46317\";i:45556;s:12:\"delete-46318\";i:45557;s:12:\"delete-46315\";i:45558;s:12:\"delete-46316\";i:45559;s:12:\"delete-46319\";i:45560;s:12:\"delete-46322\";i:45561;s:12:\"delete-46323\";i:45562;s:12:\"delete-46320\";i:45563;s:12:\"delete-46321\";i:45564;s:12:\"delete-46324\";i:45565;s:12:\"delete-46327\";i:45566;s:12:\"delete-46328\";i:45567;s:12:\"delete-46325\";i:45568;s:12:\"delete-46326\";i:45569;s:12:\"delete-46329\";i:45570;s:12:\"delete-46332\";i:45571;s:12:\"delete-46333\";i:45572;s:12:\"delete-46330\";i:45573;s:12:\"delete-46331\";i:45574;s:12:\"delete-46334\";i:45575;s:12:\"delete-46337\";i:45576;s:12:\"delete-46338\";i:45577;s:12:\"delete-46335\";i:45578;s:12:\"delete-46336\";i:45579;s:12:\"delete-46339\";i:45580;s:12:\"delete-46342\";i:45581;s:12:\"delete-46343\";i:45582;s:12:\"delete-46340\";i:45583;s:12:\"delete-46341\";i:45584;s:12:\"delete-46344\";i:45585;s:12:\"delete-46347\";i:45586;s:12:\"delete-46345\";i:45587;s:12:\"delete-46346\";i:45588;s:12:\"delete-46348\";i:45589;s:12:\"delete-46349\";i:45590;s:12:\"delete-46352\";i:45591;s:12:\"delete-46353\";i:45592;s:12:\"delete-46350\";i:45593;s:12:\"delete-46351\";i:45594;s:12:\"delete-46354\";i:45595;s:12:\"delete-46357\";i:45596;s:12:\"delete-46358\";i:45597;s:12:\"delete-46355\";i:45598;s:12:\"delete-46356\";i:45599;s:12:\"delete-46359\";i:45600;s:12:\"delete-46362\";i:45601;s:12:\"delete-46360\";i:45602;s:12:\"delete-46361\";i:45603;s:12:\"delete-46363\";i:45604;s:12:\"delete-46364\";i:45605;s:12:\"delete-46367\";i:45606;s:12:\"delete-46368\";i:45607;s:12:\"delete-46365\";i:45608;s:12:\"delete-46366\";i:45609;s:12:\"delete-46369\";i:45610;s:12:\"delete-46372\";i:45611;s:12:\"delete-46370\";i:45612;s:12:\"delete-46371\";i:45613;s:12:\"delete-46373\";i:45614;s:12:\"delete-46374\";i:45615;s:12:\"delete-46377\";i:45616;s:12:\"delete-46378\";i:45617;s:12:\"delete-46375\";i:45618;s:12:\"delete-46376\";i:45619;s:12:\"delete-46379\";i:45620;s:12:\"delete-46382\";i:45621;s:12:\"delete-46383\";i:45622;s:12:\"delete-46380\";i:45623;s:12:\"delete-46381\";i:45624;s:12:\"delete-46384\";i:45625;s:12:\"delete-46387\";i:45626;s:12:\"delete-46388\";i:45627;s:12:\"delete-46385\";i:45628;s:12:\"delete-46386\";i:45629;s:12:\"delete-46389\";i:45630;s:12:\"delete-46392\";i:45631;s:12:\"delete-46393\";i:45632;s:12:\"delete-46390\";i:45633;s:12:\"delete-46391\";i:45634;s:12:\"delete-46394\";i:45635;s:12:\"delete-46397\";i:45636;s:12:\"delete-46398\";i:45637;s:12:\"delete-46395\";i:45638;s:12:\"delete-46396\";i:45639;s:12:\"delete-46399\";i:45640;s:12:\"delete-46402\";i:45641;s:12:\"delete-46403\";i:45642;s:12:\"delete-46400\";i:45643;s:12:\"delete-46401\";i:45644;s:12:\"delete-46404\";i:45645;s:12:\"delete-46407\";i:45646;s:12:\"delete-46408\";i:45647;s:12:\"delete-46405\";i:45648;s:12:\"delete-46406\";i:45649;s:12:\"delete-46409\";i:45650;s:12:\"delete-46412\";i:45651;s:12:\"delete-46413\";i:45652;s:12:\"delete-46410\";i:45653;s:12:\"delete-46411\";i:45654;s:12:\"delete-46414\";i:45655;s:12:\"delete-46417\";i:45656;s:12:\"delete-46418\";i:45657;s:12:\"delete-46415\";i:45658;s:12:\"delete-46416\";i:45659;s:12:\"delete-46419\";i:45660;s:12:\"delete-46422\";i:45661;s:12:\"delete-46423\";i:45662;s:12:\"delete-46420\";i:45663;s:12:\"delete-46421\";i:45664;s:12:\"delete-46424\";i:45665;s:12:\"delete-46425\";i:45666;s:12:\"delete-46426\";i:45667;s:12:\"delete-46427\";i:45668;s:12:\"delete-46428\";i:45669;s:12:\"delete-46429\";i:45670;s:12:\"delete-46430\";i:45671;s:12:\"delete-46431\";i:45672;s:12:\"delete-46432\";i:45673;s:12:\"delete-46433\";i:45674;s:12:\"delete-46434\";i:45675;s:12:\"delete-46437\";i:45676;s:12:\"delete-46435\";i:45677;s:12:\"delete-46436\";i:45678;s:12:\"delete-46438\";i:45679;s:12:\"delete-46439\";i:45680;s:12:\"delete-46442\";i:45681;s:12:\"delete-46443\";i:45682;s:12:\"delete-46440\";i:45683;s:12:\"delete-46441\";i:45684;s:12:\"delete-46444\";i:45685;s:12:\"delete-46445\";i:45686;s:12:\"delete-46446\";i:45687;s:12:\"delete-46447\";i:45688;s:12:\"delete-46448\";i:45689;s:12:\"delete-46449\";i:45690;s:12:\"delete-46452\";i:45691;s:12:\"delete-46453\";i:45692;s:12:\"delete-46450\";i:45693;s:12:\"delete-46451\";i:45694;s:12:\"delete-46454\";i:45695;s:12:\"delete-46457\";i:45696;s:12:\"delete-46458\";i:45697;s:12:\"delete-46455\";i:45698;s:12:\"delete-46456\";i:45699;s:12:\"delete-46459\";i:45700;s:12:\"delete-46462\";i:45701;s:12:\"delete-46460\";i:45702;s:12:\"delete-46461\";i:45703;s:12:\"delete-46463\";i:45704;s:12:\"delete-46464\";i:45705;s:12:\"delete-46467\";i:45706;s:12:\"delete-46468\";i:45707;s:12:\"delete-46465\";i:45708;s:12:\"delete-46466\";i:45709;s:12:\"delete-46469\";i:45710;s:12:\"delete-46472\";i:45711;s:12:\"delete-46470\";i:45712;s:12:\"delete-46471\";i:45713;s:12:\"delete-46473\";i:45714;s:12:\"delete-46474\";i:45715;s:12:\"delete-46477\";i:45716;s:12:\"delete-46478\";i:45717;s:12:\"delete-46475\";i:45718;s:12:\"delete-46476\";i:45719;s:12:\"delete-46479\";i:45720;s:12:\"delete-46482\";i:45721;s:12:\"delete-46483\";i:45722;s:12:\"delete-46480\";i:45723;s:12:\"delete-46481\";i:45724;s:12:\"delete-46484\";i:45725;s:12:\"delete-46487\";i:45726;s:12:\"delete-46488\";i:45727;s:12:\"delete-46485\";i:45728;s:12:\"delete-46486\";i:45729;s:12:\"delete-46489\";i:45730;s:12:\"delete-46492\";i:45731;s:12:\"delete-46490\";i:45732;s:12:\"delete-46491\";i:45733;s:12:\"delete-46493\";i:45734;s:12:\"delete-46494\";i:45735;s:12:\"delete-46497\";i:45736;s:12:\"delete-46498\";i:45737;s:12:\"delete-46495\";i:45738;s:12:\"delete-46496\";i:45739;s:12:\"delete-46499\";i:45740;s:12:\"delete-46502\";i:45741;s:12:\"delete-46503\";i:45742;s:12:\"delete-46500\";i:45743;s:12:\"delete-46501\";i:45744;s:12:\"delete-46504\";i:45745;s:12:\"delete-46505\";i:45746;s:12:\"delete-46506\";i:45747;s:12:\"delete-46507\";i:45748;s:12:\"delete-46508\";i:45749;s:12:\"delete-46509\";i:45750;s:12:\"delete-46512\";i:45751;s:12:\"delete-46513\";i:45752;s:12:\"delete-46510\";i:45753;s:12:\"delete-46511\";i:45754;s:12:\"delete-46514\";i:45755;s:12:\"delete-46517\";i:45756;s:12:\"delete-46518\";i:45757;s:12:\"delete-46515\";i:45758;s:12:\"delete-46516\";i:45759;s:12:\"delete-46519\";i:45760;s:12:\"delete-46522\";i:45761;s:12:\"delete-46523\";i:45762;s:12:\"delete-46520\";i:45763;s:12:\"delete-46521\";i:45764;s:12:\"delete-46524\";i:45765;s:12:\"delete-46525\";i:45766;s:12:\"delete-46526\";i:45767;s:12:\"delete-46527\";i:45768;s:12:\"delete-46528\";i:45769;s:12:\"delete-46529\";i:45770;s:12:\"delete-46532\";i:45771;s:12:\"delete-46533\";i:45772;s:12:\"delete-46530\";i:45773;s:12:\"delete-46531\";i:45774;s:12:\"delete-46534\";i:45775;s:12:\"delete-46537\";i:45776;s:12:\"delete-46538\";i:45777;s:12:\"delete-46535\";i:45778;s:12:\"delete-46536\";i:45779;s:12:\"delete-46539\";i:45780;s:12:\"delete-46542\";i:45781;s:12:\"delete-46543\";i:45782;s:12:\"delete-46540\";i:45783;s:12:\"delete-46541\";i:45784;s:12:\"delete-46544\";i:45785;s:12:\"delete-46547\";i:45786;s:12:\"delete-46548\";i:45787;s:12:\"delete-46545\";i:45788;s:12:\"delete-46546\";i:45789;s:12:\"delete-46549\";i:45790;s:12:\"delete-46552\";i:45791;s:12:\"delete-46550\";i:45792;s:12:\"delete-46551\";i:45793;s:12:\"delete-46553\";i:45794;s:12:\"delete-46554\";i:45795;s:12:\"delete-46557\";i:45796;s:12:\"delete-46558\";i:45797;s:12:\"delete-46555\";i:45798;s:12:\"delete-46556\";i:45799;s:12:\"delete-46559\";i:45800;s:12:\"delete-46562\";i:45801;s:12:\"delete-46563\";i:45802;s:12:\"delete-46560\";i:45803;s:12:\"delete-46561\";i:45804;s:12:\"delete-46564\";i:45805;s:12:\"delete-46567\";i:45806;s:12:\"delete-46568\";i:45807;s:12:\"delete-46565\";i:45808;s:12:\"delete-46566\";i:45809;s:12:\"delete-46569\";i:45810;s:12:\"delete-46572\";i:45811;s:12:\"delete-46570\";i:45812;s:12:\"delete-46571\";i:45813;s:12:\"delete-46573\";i:45814;s:12:\"delete-46574\";i:45815;s:12:\"delete-46577\";i:45816;s:12:\"delete-46575\";i:45817;s:12:\"delete-46576\";i:45818;s:12:\"delete-46578\";i:45819;s:12:\"delete-46579\";i:45820;s:12:\"delete-46582\";i:45821;s:12:\"delete-46583\";i:45822;s:12:\"delete-46580\";i:45823;s:12:\"delete-46581\";i:45824;s:12:\"delete-46584\";i:45825;s:12:\"delete-46587\";i:45826;s:12:\"delete-46588\";i:45827;s:12:\"delete-46585\";i:45828;s:12:\"delete-46586\";i:45829;s:12:\"delete-46589\";i:45830;s:12:\"delete-46592\";i:45831;s:12:\"delete-46590\";i:45832;s:12:\"delete-46591\";i:45833;s:12:\"delete-46593\";i:45834;s:12:\"delete-46594\";i:45835;s:12:\"delete-46597\";i:45836;s:12:\"delete-46598\";i:45837;s:12:\"delete-46595\";i:45838;s:12:\"delete-46596\";i:45839;s:12:\"delete-46599\";i:45840;s:12:\"delete-46602\";i:45841;s:12:\"delete-46603\";i:45842;s:12:\"delete-46600\";i:45843;s:12:\"delete-46601\";i:45844;s:12:\"delete-46604\";i:45845;s:12:\"delete-46607\";i:45846;s:12:\"delete-46608\";i:45847;s:12:\"delete-46605\";i:45848;s:12:\"delete-46606\";i:45849;s:12:\"delete-46609\";i:45850;s:12:\"delete-46612\";i:45851;s:12:\"delete-46613\";i:45852;s:12:\"delete-46610\";i:45853;s:12:\"delete-46611\";i:45854;s:12:\"delete-46614\";i:45855;s:12:\"delete-46617\";i:45856;s:12:\"delete-46618\";i:45857;s:12:\"delete-46615\";i:45858;s:12:\"delete-46616\";i:45859;s:12:\"delete-46619\";i:45860;s:12:\"delete-46622\";i:45861;s:12:\"delete-46623\";i:45862;s:12:\"delete-46620\";i:45863;s:12:\"delete-46621\";i:45864;s:12:\"delete-46624\";i:45865;s:12:\"delete-46627\";i:45866;s:12:\"delete-46628\";i:45867;s:12:\"delete-46625\";i:45868;s:12:\"delete-46626\";i:45869;s:12:\"delete-46629\";i:45870;s:12:\"delete-46632\";i:45871;s:12:\"delete-46633\";i:45872;s:12:\"delete-46630\";i:45873;s:12:\"delete-46631\";i:45874;s:12:\"delete-46634\";i:45875;s:12:\"delete-46637\";i:45876;s:12:\"delete-46638\";i:45877;s:12:\"delete-46635\";i:45878;s:12:\"delete-46636\";i:45879;s:12:\"delete-46639\";i:45880;s:12:\"delete-46642\";i:45881;s:12:\"delete-46643\";i:45882;s:12:\"delete-46640\";i:45883;s:12:\"delete-46641\";i:45884;s:12:\"delete-46644\";i:45885;s:12:\"delete-46647\";i:45886;s:12:\"delete-46648\";i:45887;s:12:\"delete-46645\";i:45888;s:12:\"delete-46646\";i:45889;s:12:\"delete-46649\";i:45890;s:12:\"delete-46652\";i:45891;s:12:\"delete-46653\";i:45892;s:12:\"delete-46650\";i:45893;s:12:\"delete-46651\";i:45894;s:12:\"delete-46654\";i:45895;s:12:\"delete-46657\";i:45896;s:12:\"delete-46658\";i:45897;s:12:\"delete-46655\";i:45898;s:12:\"delete-46656\";i:45899;s:12:\"delete-46659\";i:45900;s:12:\"delete-46662\";i:45901;s:12:\"delete-46663\";i:45902;s:12:\"delete-46660\";i:45903;s:12:\"delete-46661\";i:45904;s:12:\"delete-46664\";i:45905;s:12:\"delete-46667\";i:45906;s:12:\"delete-46668\";i:45907;s:12:\"delete-46665\";i:45908;s:12:\"delete-46666\";i:45909;s:12:\"delete-46669\";i:45910;s:12:\"delete-46672\";i:45911;s:12:\"delete-46673\";i:45912;s:12:\"delete-46670\";i:45913;s:12:\"delete-46671\";i:45914;s:12:\"delete-46674\";i:45915;s:12:\"delete-46677\";i:45916;s:12:\"delete-46678\";i:45917;s:12:\"delete-46675\";i:45918;s:12:\"delete-46676\";i:45919;s:12:\"delete-46679\";i:45920;s:12:\"delete-46682\";i:45921;s:12:\"delete-46683\";i:45922;s:12:\"delete-46680\";i:45923;s:12:\"delete-46681\";i:45924;s:12:\"delete-46684\";i:45925;s:12:\"delete-46687\";i:45926;s:12:\"delete-46688\";i:45927;s:12:\"delete-46685\";i:45928;s:12:\"delete-46686\";i:45929;s:12:\"delete-46689\";i:45930;s:12:\"delete-46692\";i:45931;s:12:\"delete-46693\";i:45932;s:12:\"delete-46690\";i:45933;s:12:\"delete-46691\";i:45934;s:12:\"delete-46694\";i:45935;s:12:\"delete-46697\";i:45936;s:12:\"delete-46698\";i:45937;s:12:\"delete-46695\";i:45938;s:12:\"delete-46696\";i:45939;s:12:\"delete-46699\";i:45940;s:12:\"delete-46702\";i:45941;s:12:\"delete-46703\";i:45942;s:12:\"delete-46700\";i:45943;s:12:\"delete-46701\";i:45944;s:12:\"delete-46704\";i:45945;s:12:\"delete-46707\";i:45946;s:12:\"delete-46708\";i:45947;s:12:\"delete-46705\";i:45948;s:12:\"delete-46706\";i:45949;s:12:\"delete-46709\";i:45950;s:12:\"delete-46712\";i:45951;s:12:\"delete-46713\";i:45952;s:12:\"delete-46710\";i:45953;s:12:\"delete-46711\";i:45954;s:12:\"delete-46714\";i:45955;s:12:\"delete-46717\";i:45956;s:12:\"delete-46718\";i:45957;s:12:\"delete-46715\";i:45958;s:12:\"delete-46716\";i:45959;s:12:\"delete-46719\";i:45960;s:12:\"delete-46722\";i:45961;s:12:\"delete-46723\";i:45962;s:12:\"delete-46720\";i:45963;s:12:\"delete-46721\";i:45964;s:12:\"delete-46724\";i:45965;s:12:\"delete-46727\";i:45966;s:12:\"delete-46728\";i:45967;s:12:\"delete-46725\";i:45968;s:12:\"delete-46726\";i:45969;s:12:\"delete-46729\";i:45970;s:12:\"delete-46732\";i:45971;s:12:\"delete-46730\";i:45972;s:12:\"delete-46731\";i:45973;s:12:\"delete-46733\";i:45974;s:12:\"delete-46734\";i:45975;s:12:\"delete-46737\";i:45976;s:12:\"delete-46738\";i:45977;s:12:\"delete-46735\";i:45978;s:12:\"delete-46736\";i:45979;s:12:\"delete-46739\";i:45980;s:12:\"delete-46742\";i:45981;s:12:\"delete-46740\";i:45982;s:12:\"delete-46741\";i:45983;s:12:\"delete-46743\";i:45984;s:12:\"delete-46744\";i:45985;s:12:\"delete-46747\";i:45986;s:12:\"delete-46748\";i:45987;s:12:\"delete-46745\";i:45988;s:12:\"delete-46746\";i:45989;s:12:\"delete-46749\";i:45990;s:12:\"delete-46752\";i:45991;s:12:\"delete-46753\";i:45992;s:12:\"delete-46750\";i:45993;s:12:\"delete-46751\";i:45994;s:12:\"delete-46754\";i:45995;s:12:\"delete-46757\";i:45996;s:12:\"delete-46758\";i:45997;s:12:\"delete-46755\";i:45998;s:12:\"delete-46756\";i:45999;s:12:\"delete-46759\";i:46000;s:12:\"delete-46762\";i:46001;s:12:\"delete-46763\";i:46002;s:12:\"delete-46760\";i:46003;s:12:\"delete-46761\";i:46004;s:12:\"delete-46764\";i:46005;s:12:\"delete-46767\";i:46006;s:12:\"delete-46768\";i:46007;s:12:\"delete-46765\";i:46008;s:12:\"delete-46766\";i:46009;s:12:\"delete-46769\";i:46010;s:12:\"delete-46772\";i:46011;s:12:\"delete-46773\";i:46012;s:12:\"delete-46770\";i:46013;s:12:\"delete-46771\";i:46014;s:12:\"delete-46774\";i:46015;s:12:\"delete-46777\";i:46016;s:12:\"delete-46775\";i:46017;s:12:\"delete-46776\";i:46018;s:12:\"delete-46778\";i:46019;s:12:\"delete-46779\";i:46020;s:12:\"delete-46782\";i:46021;s:12:\"delete-46780\";i:46022;s:12:\"delete-46781\";i:46023;s:12:\"delete-46783\";i:46024;s:12:\"delete-46784\";i:46025;s:12:\"delete-46787\";i:46026;s:12:\"delete-46785\";i:46027;s:12:\"delete-46786\";i:46028;s:12:\"delete-46788\";i:46029;s:12:\"delete-46789\";i:46030;s:12:\"delete-46792\";i:46031;s:12:\"delete-46793\";i:46032;s:12:\"delete-46790\";i:46033;s:12:\"delete-46791\";i:46034;s:12:\"delete-46794\";i:46035;s:12:\"delete-46797\";i:46036;s:12:\"delete-46798\";i:46037;s:12:\"delete-46795\";i:46038;s:12:\"delete-46796\";i:46039;s:12:\"delete-46799\";i:46040;s:12:\"delete-46802\";i:46041;s:12:\"delete-46803\";i:46042;s:12:\"delete-46800\";i:46043;s:12:\"delete-46801\";i:46044;s:12:\"delete-46804\";i:46045;s:12:\"delete-46807\";i:46046;s:12:\"delete-46808\";i:46047;s:12:\"delete-46805\";i:46048;s:12:\"delete-46806\";i:46049;s:12:\"delete-46809\";i:46050;s:12:\"delete-46812\";i:46051;s:12:\"delete-46813\";i:46052;s:12:\"delete-46810\";i:46053;s:12:\"delete-46811\";i:46054;s:12:\"delete-46814\";i:46055;s:12:\"delete-46817\";i:46056;s:12:\"delete-46815\";i:46057;s:12:\"delete-46816\";i:46058;s:12:\"delete-46818\";i:46059;s:12:\"delete-46819\";i:46060;s:12:\"delete-46822\";i:46061;s:12:\"delete-46823\";i:46062;s:12:\"delete-46820\";i:46063;s:12:\"delete-46821\";i:46064;s:12:\"delete-46824\";i:46065;s:12:\"delete-46827\";i:46066;s:12:\"delete-46825\";i:46067;s:12:\"delete-46826\";i:46068;s:12:\"delete-46828\";i:46069;s:12:\"delete-46829\";i:46070;s:12:\"delete-46832\";i:46071;s:12:\"delete-46833\";i:46072;s:12:\"delete-46830\";i:46073;s:12:\"delete-46831\";i:46074;s:12:\"delete-46834\";i:46075;s:12:\"delete-46837\";i:46076;s:12:\"delete-46838\";i:46077;s:12:\"delete-46835\";i:46078;s:12:\"delete-46836\";i:46079;s:12:\"delete-46839\";i:46080;s:12:\"delete-46842\";i:46081;s:12:\"delete-46843\";i:46082;s:12:\"delete-46840\";i:46083;s:12:\"delete-46841\";i:46084;s:12:\"delete-46844\";i:46085;s:12:\"delete-46847\";i:46086;s:12:\"delete-46848\";i:46087;s:12:\"delete-46845\";i:46088;s:12:\"delete-46846\";i:46089;s:12:\"delete-46849\";i:46090;s:12:\"delete-46852\";i:46091;s:12:\"delete-46850\";i:46092;s:12:\"delete-46851\";i:46093;s:12:\"delete-46853\";i:46094;s:12:\"delete-46854\";i:46095;s:12:\"delete-46857\";i:46096;s:12:\"delete-46858\";i:46097;s:12:\"delete-46855\";i:46098;s:12:\"delete-46856\";i:46099;s:12:\"delete-46859\";i:46100;s:12:\"delete-46862\";i:46101;s:12:\"delete-46863\";i:46102;s:12:\"delete-46860\";i:46103;s:12:\"delete-46861\";i:46104;s:12:\"delete-46864\";i:46105;s:12:\"delete-46867\";i:46106;s:12:\"delete-46868\";i:46107;s:12:\"delete-46865\";i:46108;s:12:\"delete-46866\";i:46109;s:12:\"delete-46869\";i:46110;s:12:\"delete-46873\";i:46111;s:12:\"delete-46872\";i:46112;s:12:\"delete-46870\";i:46113;s:12:\"delete-46871\";i:46114;s:12:\"delete-46874\";i:46115;s:12:\"delete-46878\";i:46116;s:12:\"delete-46877\";i:46117;s:12:\"delete-46875\";i:46118;s:12:\"delete-46876\";i:46119;s:12:\"delete-46879\";i:46120;s:12:\"delete-46882\";i:46121;s:12:\"delete-46883\";i:46122;s:12:\"delete-46880\";i:46123;s:12:\"delete-46881\";i:46124;s:12:\"delete-46884\";i:46125;s:12:\"delete-46887\";i:46126;s:12:\"delete-46885\";i:46127;s:12:\"delete-46886\";i:46128;s:12:\"delete-46888\";i:46129;s:12:\"delete-46892\";i:46130;s:12:\"delete-46889\";i:46131;s:12:\"delete-46893\";i:46132;s:12:\"delete-46890\";i:46133;s:12:\"delete-46891\";i:46134;s:12:\"delete-46894\";i:46135;s:12:\"delete-46897\";i:46136;s:12:\"delete-46898\";i:46137;s:12:\"delete-46895\";i:46138;s:12:\"delete-46896\";i:46139;s:12:\"delete-46899\";i:46140;s:12:\"delete-46902\";i:46141;s:12:\"delete-46903\";i:46142;s:12:\"delete-46900\";i:46143;s:12:\"delete-46901\";i:46144;s:12:\"delete-46904\";i:46145;s:12:\"delete-46908\";i:46146;s:12:\"delete-46907\";i:46147;s:12:\"delete-46905\";i:46148;s:12:\"delete-46906\";i:46149;s:12:\"delete-46909\";i:46150;s:12:\"delete-46912\";i:46151;s:12:\"delete-46913\";i:46152;s:12:\"delete-46910\";i:46153;s:12:\"delete-46911\";i:46154;s:12:\"delete-46914\";i:46155;s:12:\"delete-46917\";i:46156;s:12:\"delete-46918\";i:46157;s:12:\"delete-46915\";i:46158;s:12:\"delete-46916\";i:46159;s:12:\"delete-46919\";i:46160;s:12:\"delete-46922\";i:46161;s:12:\"delete-46923\";i:46162;s:12:\"delete-46920\";i:46163;s:12:\"delete-46921\";i:46164;s:12:\"delete-46924\";i:46165;s:12:\"delete-46927\";i:46166;s:12:\"delete-46925\";i:46167;s:12:\"delete-46926\";i:46168;s:12:\"delete-46928\";i:46169;s:12:\"delete-46929\";i:46170;s:12:\"delete-46932\";i:46171;s:12:\"delete-46933\";i:46172;s:12:\"delete-46930\";i:46173;s:12:\"delete-46931\";i:46174;s:12:\"delete-46934\";i:46175;s:12:\"delete-46937\";i:46176;s:12:\"delete-46938\";i:46177;s:12:\"delete-46935\";i:46178;s:12:\"delete-46936\";i:46179;s:12:\"delete-46939\";i:46180;s:12:\"delete-46942\";i:46181;s:12:\"delete-46943\";i:46182;s:12:\"delete-46940\";i:46183;s:12:\"delete-46941\";i:46184;s:12:\"delete-46944\";i:46185;s:12:\"delete-46948\";i:46186;s:12:\"delete-46947\";i:46187;s:12:\"delete-46945\";i:46188;s:12:\"delete-46946\";i:46189;s:12:\"delete-46949\";i:46190;s:12:\"delete-46952\";i:46191;s:12:\"delete-46953\";i:46192;s:12:\"delete-46950\";i:46193;s:12:\"delete-46951\";i:46194;s:12:\"delete-46954\";i:46195;s:12:\"delete-46957\";i:46196;s:12:\"delete-46955\";i:46197;s:12:\"delete-46956\";i:46198;s:12:\"delete-46958\";i:46199;s:12:\"delete-46959\";i:46200;s:12:\"delete-46962\";i:46201;s:12:\"delete-46963\";i:46202;s:12:\"delete-46960\";i:46203;s:12:\"delete-46961\";i:46204;s:12:\"delete-46964\";i:46205;s:12:\"delete-46967\";i:46206;s:12:\"delete-46968\";i:46207;s:12:\"delete-46965\";i:46208;s:12:\"delete-46966\";i:46209;s:12:\"delete-46969\";i:46210;s:12:\"delete-46973\";i:46211;s:12:\"delete-46972\";i:46212;s:12:\"delete-46970\";i:46213;s:12:\"delete-46971\";i:46214;s:12:\"delete-46974\";i:46215;s:12:\"delete-46977\";i:46216;s:12:\"delete-46978\";i:46217;s:12:\"delete-46975\";i:46218;s:12:\"delete-46976\";i:46219;s:12:\"delete-46979\";i:46220;s:12:\"delete-46982\";i:46221;s:12:\"delete-46980\";i:46222;s:12:\"delete-46981\";i:46223;s:12:\"delete-46983\";i:46224;s:12:\"delete-46984\";i:46225;s:12:\"delete-46987\";i:46226;s:12:\"delete-46988\";i:46227;s:12:\"delete-46985\";i:46228;s:12:\"delete-46986\";i:46229;s:12:\"delete-46989\";i:46230;s:12:\"delete-46992\";i:46231;s:12:\"delete-46990\";i:46232;s:12:\"delete-46991\";i:46233;s:12:\"delete-46993\";i:46234;s:12:\"delete-46994\";i:46235;s:12:\"delete-46997\";i:46236;s:12:\"delete-46998\";i:46237;s:12:\"delete-46995\";i:46238;s:12:\"delete-46996\";i:46239;s:12:\"delete-46999\";i:46240;s:12:\"delete-47002\";i:46241;s:12:\"delete-47000\";i:46242;s:12:\"delete-47001\";i:46243;s:12:\"delete-47003\";i:46244;s:12:\"delete-47004\";i:46245;s:12:\"delete-47007\";i:46246;s:12:\"delete-47008\";i:46247;s:12:\"delete-47005\";i:46248;s:12:\"delete-47006\";i:46249;s:12:\"delete-47009\";i:46250;s:12:\"delete-47013\";i:46251;s:12:\"delete-47012\";i:46252;s:12:\"delete-47010\";i:46253;s:12:\"delete-47011\";i:46254;s:12:\"delete-47014\";i:46255;s:12:\"delete-47017\";i:46256;s:12:\"delete-47018\";i:46257;s:12:\"delete-47015\";i:46258;s:12:\"delete-47016\";i:46259;s:12:\"delete-47019\";i:46260;s:12:\"delete-47022\";i:46261;s:12:\"delete-47023\";i:46262;s:12:\"delete-47020\";i:46263;s:12:\"delete-47021\";i:46264;s:12:\"delete-47024\";i:46265;s:12:\"delete-47027\";i:46266;s:12:\"delete-47028\";i:46267;s:12:\"delete-47025\";i:46268;s:12:\"delete-47026\";i:46269;s:12:\"delete-47029\";i:46270;s:12:\"delete-47032\";i:46271;s:12:\"delete-47033\";i:46272;s:12:\"delete-47030\";i:46273;s:12:\"delete-47031\";i:46274;s:12:\"delete-47034\";i:46275;s:12:\"delete-47037\";i:46276;s:12:\"delete-47038\";i:46277;s:12:\"delete-47035\";i:46278;s:12:\"delete-47036\";i:46279;s:12:\"delete-47039\";i:46280;s:12:\"delete-47040\";i:46281;s:12:\"delete-47041\";i:46282;s:12:\"delete-47042\";i:46283;s:12:\"delete-47043\";i:46284;s:12:\"delete-47044\";i:46285;s:12:\"delete-47047\";i:46286;s:12:\"delete-47048\";i:46287;s:12:\"delete-47045\";i:46288;s:12:\"delete-47046\";i:46289;s:12:\"delete-47049\";i:46290;s:12:\"delete-47052\";i:46291;s:12:\"delete-47053\";i:46292;s:12:\"delete-47050\";i:46293;s:12:\"delete-47051\";i:46294;s:12:\"delete-47054\";i:46295;s:12:\"delete-47057\";i:46296;s:12:\"delete-47058\";i:46297;s:12:\"delete-47055\";i:46298;s:12:\"delete-47056\";i:46299;s:12:\"delete-47059\";i:46300;s:12:\"delete-47062\";i:46301;s:12:\"delete-47063\";i:46302;s:12:\"delete-47060\";i:46303;s:12:\"delete-47061\";i:46304;s:12:\"delete-47064\";i:46305;s:12:\"delete-47067\";i:46306;s:12:\"delete-47068\";i:46307;s:12:\"delete-47065\";i:46308;s:12:\"delete-47066\";i:46309;s:12:\"delete-47069\";i:46310;s:12:\"delete-47072\";i:46311;s:12:\"delete-47073\";i:46312;s:12:\"delete-47070\";i:46313;s:12:\"delete-47071\";i:46314;s:12:\"delete-47074\";i:46315;s:12:\"delete-47077\";i:46316;s:12:\"delete-47075\";i:46317;s:12:\"delete-47076\";i:46318;s:12:\"delete-47078\";i:46319;s:12:\"delete-47079\";i:46320;s:12:\"delete-47082\";i:46321;s:12:\"delete-47083\";i:46322;s:12:\"delete-47080\";i:46323;s:12:\"delete-47081\";i:46324;s:12:\"delete-47084\";i:46325;s:12:\"delete-47087\";i:46326;s:12:\"delete-47088\";i:46327;s:12:\"delete-47085\";i:46328;s:12:\"delete-47086\";i:46329;s:12:\"delete-47089\";i:46330;s:12:\"delete-47092\";i:46331;s:12:\"delete-47090\";i:46332;s:12:\"delete-47091\";i:46333;s:12:\"delete-47093\";i:46334;s:12:\"delete-47094\";i:46335;s:12:\"delete-47097\";i:46336;s:12:\"delete-47098\";i:46337;s:12:\"delete-47095\";i:46338;s:12:\"delete-47096\";i:46339;s:12:\"delete-47099\";i:46340;s:12:\"delete-47102\";i:46341;s:12:\"delete-47103\";i:46342;s:12:\"delete-47100\";i:46343;s:12:\"delete-47101\";i:46344;s:12:\"delete-47104\";i:46345;s:12:\"delete-47107\";i:46346;s:12:\"delete-47108\";i:46347;s:12:\"delete-47105\";i:46348;s:12:\"delete-47106\";i:46349;s:12:\"delete-47109\";i:46350;s:12:\"delete-47112\";i:46351;s:12:\"delete-47113\";i:46352;s:12:\"delete-47110\";i:46353;s:12:\"delete-47111\";i:46354;s:12:\"delete-47114\";i:46355;s:12:\"delete-47117\";i:46356;s:12:\"delete-47115\";i:46357;s:12:\"delete-47116\";i:46358;s:12:\"delete-47118\";i:46359;s:12:\"delete-47119\";i:46360;s:12:\"delete-47122\";i:46361;s:12:\"delete-47123\";i:46362;s:12:\"delete-47120\";i:46363;s:12:\"delete-47121\";i:46364;s:12:\"delete-47124\";i:46365;s:12:\"delete-47127\";i:46366;s:12:\"delete-47128\";i:46367;s:12:\"delete-47125\";i:46368;s:12:\"delete-47126\";i:46369;s:12:\"delete-47129\";i:46370;s:12:\"delete-47132\";i:46371;s:12:\"delete-47130\";i:46372;s:12:\"delete-47131\";i:46373;s:12:\"delete-47133\";i:46374;s:12:\"delete-47134\";i:46375;s:12:\"delete-47137\";i:46376;s:12:\"delete-47138\";i:46377;s:12:\"delete-47135\";i:46378;s:12:\"delete-47136\";i:46379;s:12:\"delete-47139\";i:46380;s:12:\"delete-47142\";i:46381;s:12:\"delete-47143\";i:46382;s:12:\"delete-47140\";i:46383;s:12:\"delete-47141\";i:46384;s:12:\"delete-47144\";i:46385;s:12:\"delete-47147\";i:46386;s:12:\"delete-47145\";i:46387;s:12:\"delete-47146\";i:46388;s:12:\"delete-47148\";i:46389;s:12:\"delete-47149\";i:46390;s:12:\"delete-47152\";i:46391;s:12:\"delete-47153\";i:46392;s:12:\"delete-47150\";i:46393;s:12:\"delete-47151\";i:46394;s:12:\"delete-47154\";i:46395;s:12:\"delete-47157\";i:46396;s:12:\"delete-47158\";i:46397;s:12:\"delete-47155\";i:46398;s:12:\"delete-47156\";i:46399;s:12:\"delete-47159\";i:46400;s:12:\"delete-47162\";i:46401;s:12:\"delete-47160\";i:46402;s:12:\"delete-47161\";i:46403;s:12:\"delete-47163\";i:46404;s:12:\"delete-47164\";i:46405;s:12:\"delete-47167\";i:46406;s:12:\"delete-47168\";i:46407;s:12:\"delete-47165\";i:46408;s:12:\"delete-47166\";i:46409;s:12:\"delete-47169\";i:46410;s:12:\"delete-47172\";i:46411;s:12:\"delete-47170\";i:46412;s:12:\"delete-47171\";i:46413;s:12:\"delete-47173\";i:46414;s:12:\"delete-47174\";i:46415;s:12:\"delete-47177\";i:46416;s:12:\"delete-47178\";i:46417;s:12:\"delete-47175\";i:46418;s:12:\"delete-47176\";i:46419;s:12:\"delete-47179\";i:46420;s:12:\"delete-47182\";i:46421;s:12:\"delete-47180\";i:46422;s:12:\"delete-47181\";i:46423;s:12:\"delete-47183\";i:46424;s:12:\"delete-47184\";i:46425;s:12:\"delete-47187\";i:46426;s:12:\"delete-47188\";i:46427;s:12:\"delete-47185\";i:46428;s:12:\"delete-47186\";i:46429;s:12:\"delete-47189\";i:46430;s:12:\"delete-47192\";i:46431;s:12:\"delete-47193\";i:46432;s:12:\"delete-47190\";i:46433;s:12:\"delete-47191\";i:46434;s:12:\"delete-47194\";i:46435;s:12:\"delete-47197\";i:46436;s:12:\"delete-47195\";i:46437;s:12:\"delete-47196\";i:46438;s:12:\"delete-47198\";i:46439;s:12:\"delete-47199\";i:46440;s:12:\"delete-47202\";i:46441;s:12:\"delete-47203\";i:46442;s:12:\"delete-47200\";i:46443;s:12:\"delete-47201\";i:46444;s:12:\"delete-47204\";i:46445;s:12:\"delete-47207\";i:46446;s:12:\"delete-47208\";i:46447;s:12:\"delete-47205\";i:46448;s:12:\"delete-47206\";i:46449;s:12:\"delete-47209\";i:46450;s:12:\"delete-47212\";i:46451;s:12:\"delete-47210\";i:46452;s:12:\"delete-47211\";i:46453;s:12:\"delete-47213\";i:46454;s:12:\"delete-47214\";i:46455;s:12:\"delete-47217\";i:46456;s:12:\"delete-47215\";i:46457;s:12:\"delete-47216\";i:46458;s:12:\"delete-47218\";i:46459;s:12:\"delete-47219\";i:46460;s:12:\"delete-47222\";i:46461;s:12:\"delete-47220\";i:46462;s:12:\"delete-47221\";i:46463;s:12:\"delete-47223\";i:46464;s:12:\"delete-47224\";i:46465;s:12:\"delete-47227\";i:46466;s:12:\"delete-47228\";i:46467;s:12:\"delete-47225\";i:46468;s:12:\"delete-47226\";i:46469;s:12:\"delete-47229\";i:46470;s:12:\"delete-47232\";i:46471;s:12:\"delete-47233\";i:46472;s:12:\"delete-47230\";i:46473;s:12:\"delete-47231\";i:46474;s:12:\"delete-47234\";i:46475;s:12:\"delete-47237\";i:46476;s:12:\"delete-47235\";i:46477;s:12:\"delete-47236\";i:46478;s:12:\"delete-47238\";i:46479;s:12:\"delete-47239\";i:46480;s:12:\"delete-47242\";i:46481;s:12:\"delete-47243\";i:46482;s:12:\"delete-47240\";i:46483;s:12:\"delete-47241\";i:46484;s:12:\"delete-47244\";i:46485;s:12:\"delete-47247\";i:46486;s:12:\"delete-47248\";i:46487;s:12:\"delete-47245\";i:46488;s:12:\"delete-47246\";i:46489;s:12:\"delete-47249\";i:46490;s:12:\"delete-47252\";i:46491;s:12:\"delete-47253\";i:46492;s:12:\"delete-47250\";i:46493;s:12:\"delete-47251\";i:46494;s:12:\"delete-47254\";i:46495;s:12:\"delete-47257\";i:46496;s:12:\"delete-47255\";i:46497;s:12:\"delete-47256\";i:46498;s:12:\"delete-47258\";i:46499;s:12:\"delete-47259\";i:46500;s:12:\"delete-47262\";i:46501;s:12:\"delete-47263\";i:46502;s:12:\"delete-47260\";i:46503;s:12:\"delete-47261\";i:46504;s:12:\"delete-47264\";i:46505;s:12:\"delete-47267\";i:46506;s:12:\"delete-47268\";i:46507;s:12:\"delete-47265\";i:46508;s:12:\"delete-47266\";i:46509;s:12:\"delete-47269\";i:46510;s:12:\"delete-47272\";i:46511;s:12:\"delete-47273\";i:46512;s:12:\"delete-47270\";i:46513;s:12:\"delete-47271\";i:46514;s:12:\"delete-47274\";i:46515;s:12:\"delete-47277\";i:46516;s:12:\"delete-47278\";i:46517;s:12:\"delete-47275\";i:46518;s:12:\"delete-47276\";i:46519;s:12:\"delete-47279\";i:46520;s:12:\"delete-47282\";i:46521;s:12:\"delete-47280\";i:46522;s:12:\"delete-47281\";i:46523;s:12:\"delete-47283\";i:46524;s:12:\"delete-47284\";i:46525;s:12:\"delete-47287\";i:46526;s:12:\"delete-47288\";i:46527;s:12:\"delete-47285\";i:46528;s:12:\"delete-47286\";i:46529;s:12:\"delete-47289\";i:46530;s:12:\"delete-47292\";i:46531;s:12:\"delete-47293\";i:46532;s:12:\"delete-47290\";i:46533;s:12:\"delete-47291\";i:46534;s:12:\"delete-47294\";i:46535;s:12:\"delete-47297\";i:46536;s:12:\"delete-47298\";i:46537;s:12:\"delete-47295\";i:46538;s:12:\"delete-47296\";i:46539;s:12:\"delete-47299\";i:46540;s:12:\"delete-47302\";i:46541;s:12:\"delete-47300\";i:46542;s:12:\"delete-47301\";i:46543;s:12:\"delete-47303\";i:46544;s:12:\"delete-47304\";i:46545;s:12:\"delete-47307\";i:46546;s:12:\"delete-47305\";i:46547;s:12:\"delete-47306\";i:46548;s:12:\"delete-47308\";i:46549;s:12:\"delete-47309\";i:46550;s:12:\"delete-47312\";i:46551;s:12:\"delete-47310\";i:46552;s:12:\"delete-47311\";i:46553;s:12:\"delete-47313\";i:46554;s:12:\"delete-47314\";i:46555;s:12:\"delete-47317\";i:46556;s:12:\"delete-47318\";i:46557;s:12:\"delete-47315\";i:46558;s:12:\"delete-47316\";i:46559;s:12:\"delete-47319\";i:46560;s:12:\"delete-47322\";i:46561;s:12:\"delete-47323\";i:46562;s:12:\"delete-47320\";i:46563;s:12:\"delete-47321\";i:46564;s:12:\"delete-47324\";i:46565;s:12:\"delete-47327\";i:46566;s:12:\"delete-47328\";i:46567;s:12:\"delete-47325\";i:46568;s:12:\"delete-47326\";i:46569;s:12:\"delete-47329\";i:46570;s:12:\"delete-47332\";i:46571;s:12:\"delete-47333\";i:46572;s:12:\"delete-47330\";i:46573;s:12:\"delete-47331\";i:46574;s:12:\"delete-47334\";i:46575;s:12:\"delete-47337\";i:46576;s:12:\"delete-47335\";i:46577;s:12:\"delete-47336\";i:46578;s:12:\"delete-47338\";i:46579;s:12:\"delete-47339\";i:46580;s:12:\"delete-47342\";i:46581;s:12:\"delete-47343\";i:46582;s:12:\"delete-47340\";i:46583;s:12:\"delete-47341\";i:46584;s:12:\"delete-47344\";i:46585;s:12:\"delete-47347\";i:46586;s:12:\"delete-47348\";i:46587;s:12:\"delete-47345\";i:46588;s:12:\"delete-47346\";i:46589;s:12:\"delete-47349\";i:46590;s:12:\"delete-47352\";i:46591;s:12:\"delete-47353\";i:46592;s:12:\"delete-47350\";i:46593;s:12:\"delete-47351\";i:46594;s:12:\"delete-47354\";i:46595;s:12:\"delete-47357\";i:46596;s:12:\"delete-47358\";i:46597;s:12:\"delete-47355\";i:46598;s:12:\"delete-47356\";i:46599;s:12:\"delete-47359\";i:46600;s:12:\"delete-47362\";i:46601;s:12:\"delete-47363\";i:46602;s:12:\"delete-47360\";i:46603;s:12:\"delete-47361\";i:46604;s:12:\"delete-47364\";i:46605;s:12:\"delete-47367\";i:46606;s:12:\"delete-47365\";i:46607;s:12:\"delete-47366\";i:46608;s:12:\"delete-47368\";i:46609;s:12:\"delete-47369\";i:46610;s:12:\"delete-47372\";i:46611;s:12:\"delete-47373\";i:46612;s:12:\"delete-47370\";i:46613;s:12:\"delete-47371\";i:46614;s:12:\"delete-47374\";i:46615;s:12:\"delete-47377\";i:46616;s:12:\"delete-47378\";i:46617;s:12:\"delete-47375\";i:46618;s:12:\"delete-47376\";i:46619;s:12:\"delete-47379\";i:46620;s:12:\"delete-47382\";i:46621;s:12:\"delete-47383\";i:46622;s:12:\"delete-47380\";i:46623;s:12:\"delete-47381\";i:46624;s:12:\"delete-47384\";i:46625;s:12:\"delete-47387\";i:46626;s:12:\"delete-47388\";i:46627;s:12:\"delete-47385\";i:46628;s:12:\"delete-47386\";i:46629;s:12:\"delete-47389\";i:46630;s:12:\"delete-47392\";i:46631;s:12:\"delete-47393\";i:46632;s:12:\"delete-47390\";i:46633;s:12:\"delete-47391\";i:46634;s:12:\"delete-47394\";i:46635;s:12:\"delete-47397\";i:46636;s:12:\"delete-47398\";i:46637;s:12:\"delete-47395\";i:46638;s:12:\"delete-47396\";i:46639;s:12:\"delete-47399\";i:46640;s:12:\"delete-47402\";i:46641;s:12:\"delete-47403\";i:46642;s:12:\"delete-47400\";i:46643;s:12:\"delete-47401\";i:46644;s:12:\"delete-47404\";i:46645;s:12:\"delete-47407\";i:46646;s:12:\"delete-47408\";i:46647;s:12:\"delete-47405\";i:46648;s:12:\"delete-47406\";i:46649;s:12:\"delete-47409\";i:46650;s:12:\"delete-47412\";i:46651;s:12:\"delete-47413\";i:46652;s:12:\"delete-47410\";i:46653;s:12:\"delete-47411\";i:46654;s:12:\"delete-47414\";i:46655;s:12:\"delete-47417\";i:46656;s:12:\"delete-47418\";i:46657;s:12:\"delete-47419\";i:46658;s:12:\"delete-47422\";i:46659;s:12:\"delete-47423\";i:46660;s:12:\"delete-47415\";i:46661;s:12:\"delete-47416\";i:46662;s:12:\"delete-47420\";i:46663;s:12:\"delete-47421\";i:46664;s:12:\"delete-47424\";i:46665;s:12:\"delete-47427\";i:46666;s:12:\"delete-47428\";i:46667;s:12:\"delete-47425\";i:46668;s:12:\"delete-47426\";i:46669;s:12:\"delete-47429\";i:46670;s:12:\"delete-47432\";i:46671;s:12:\"delete-47433\";i:46672;s:12:\"delete-47430\";i:46673;s:12:\"delete-47431\";i:46674;s:12:\"delete-47434\";i:46675;s:12:\"delete-47437\";i:46676;s:12:\"delete-47438\";i:46677;s:12:\"delete-47435\";i:46678;s:12:\"delete-47436\";i:46679;s:12:\"delete-47439\";i:46680;s:12:\"delete-47442\";i:46681;s:12:\"delete-47443\";i:46682;s:12:\"delete-47440\";i:46683;s:12:\"delete-47441\";i:46684;s:12:\"delete-47444\";i:46685;s:12:\"delete-47447\";i:46686;s:12:\"delete-47448\";i:46687;s:12:\"delete-47445\";i:46688;s:12:\"delete-47446\";i:46689;s:12:\"delete-47449\";i:46690;s:12:\"delete-47452\";i:46691;s:12:\"delete-47453\";i:46692;s:12:\"delete-47450\";i:46693;s:12:\"delete-47451\";i:46694;s:12:\"delete-47454\";i:46695;s:12:\"delete-47457\";i:46696;s:12:\"delete-47458\";i:46697;s:12:\"delete-47455\";i:46698;s:12:\"delete-47456\";i:46699;s:12:\"delete-47459\";i:46700;s:12:\"delete-47462\";i:46701;s:12:\"delete-47463\";i:46702;s:12:\"delete-47460\";i:46703;s:12:\"delete-47461\";i:46704;s:12:\"delete-47464\";i:46705;s:12:\"delete-47467\";i:46706;s:12:\"delete-47468\";i:46707;s:12:\"delete-47465\";i:46708;s:12:\"delete-47466\";i:46709;s:12:\"delete-47469\";i:46710;s:12:\"delete-47472\";i:46711;s:12:\"delete-47473\";i:46712;s:12:\"delete-47470\";i:46713;s:12:\"delete-47471\";i:46714;s:12:\"delete-47474\";i:46715;s:12:\"delete-47477\";i:46716;s:12:\"delete-47478\";i:46717;s:12:\"delete-47475\";i:46718;s:12:\"delete-47476\";i:46719;s:12:\"delete-47479\";i:46720;s:12:\"delete-47482\";i:46721;s:12:\"delete-47483\";i:46722;s:12:\"delete-47480\";i:46723;s:12:\"delete-47481\";i:46724;s:12:\"delete-47484\";i:46725;s:12:\"delete-47487\";i:46726;s:12:\"delete-47488\";i:46727;s:12:\"delete-47485\";i:46728;s:12:\"delete-47486\";i:46729;s:12:\"delete-47489\";i:46730;s:12:\"delete-47492\";i:46731;s:12:\"delete-47490\";i:46732;s:12:\"delete-47491\";i:46733;s:12:\"delete-47493\";i:46734;s:12:\"delete-47494\";i:46735;s:12:\"delete-47497\";i:46736;s:12:\"delete-47498\";i:46737;s:12:\"delete-47495\";i:46738;s:12:\"delete-47496\";i:46739;s:12:\"delete-47499\";i:46740;s:12:\"delete-47502\";i:46741;s:12:\"delete-47503\";i:46742;s:12:\"delete-47500\";i:46743;s:12:\"delete-47501\";i:46744;s:12:\"delete-47504\";i:46745;s:12:\"delete-47507\";i:46746;s:12:\"delete-47508\";i:46747;s:12:\"delete-47505\";i:46748;s:12:\"delete-47506\";i:46749;s:12:\"delete-47509\";i:46750;s:12:\"delete-47512\";i:46751;s:12:\"delete-47513\";i:46752;s:12:\"delete-47510\";i:46753;s:12:\"delete-47511\";i:46754;s:12:\"delete-47514\";i:46755;s:12:\"delete-47517\";i:46756;s:12:\"delete-47518\";i:46757;s:12:\"delete-47515\";i:46758;s:12:\"delete-47516\";i:46759;s:12:\"delete-47519\";i:46760;s:12:\"delete-47522\";i:46761;s:12:\"delete-47523\";i:46762;s:12:\"delete-47520\";i:46763;s:12:\"delete-47521\";i:46764;s:12:\"delete-47524\";i:46765;s:12:\"delete-47527\";i:46766;s:12:\"delete-47528\";i:46767;s:12:\"delete-47525\";i:46768;s:12:\"delete-47526\";i:46769;s:12:\"delete-47529\";i:46770;s:12:\"delete-47532\";i:46771;s:12:\"delete-47533\";i:46772;s:12:\"delete-47530\";i:46773;s:12:\"delete-47531\";i:46774;s:12:\"delete-47534\";i:46775;s:12:\"delete-47537\";i:46776;s:12:\"delete-47535\";i:46777;s:12:\"delete-47536\";i:46778;s:12:\"delete-47538\";i:46779;s:12:\"delete-47539\";i:46780;s:12:\"delete-47540\";i:46781;s:12:\"delete-47541\";i:46782;s:12:\"delete-47542\";i:46783;s:12:\"delete-47543\";i:46784;s:12:\"delete-47544\";i:46785;s:12:\"delete-47547\";i:46786;s:12:\"delete-47548\";i:46787;s:12:\"delete-47545\";i:46788;s:12:\"delete-47546\";i:46789;s:12:\"delete-47549\";i:46790;s:12:\"delete-47552\";i:46791;s:12:\"delete-47553\";i:46792;s:12:\"delete-47550\";i:46793;s:12:\"delete-47551\";i:46794;s:12:\"delete-47554\";i:46795;s:12:\"delete-47557\";i:46796;s:12:\"delete-47555\";i:46797;s:12:\"delete-47556\";i:46798;s:12:\"delete-47558\";i:46799;s:12:\"delete-47559\";i:46800;s:12:\"delete-47562\";i:46801;s:12:\"delete-47563\";i:46802;s:12:\"delete-47560\";i:46803;s:12:\"delete-47561\";i:46804;s:12:\"delete-47564\";i:46805;s:12:\"delete-47567\";i:46806;s:12:\"delete-47568\";i:46807;s:12:\"delete-47565\";i:46808;s:12:\"delete-47566\";i:46809;s:12:\"delete-47569\";i:46810;s:12:\"delete-47572\";i:46811;s:12:\"delete-47573\";i:46812;s:12:\"delete-47570\";i:46813;s:12:\"delete-47571\";i:46814;s:12:\"delete-47574\";i:46815;s:12:\"delete-47577\";i:46816;s:12:\"delete-47578\";i:46817;s:12:\"delete-47575\";i:46818;s:12:\"delete-47576\";i:46819;s:12:\"delete-47579\";i:46820;s:12:\"delete-47582\";i:46821;s:12:\"delete-47583\";i:46822;s:12:\"delete-47580\";i:46823;s:12:\"delete-47581\";i:46824;s:12:\"delete-47584\";i:46825;s:12:\"delete-47587\";i:46826;s:12:\"delete-47588\";i:46827;s:12:\"delete-47585\";i:46828;s:12:\"delete-47586\";i:46829;s:12:\"delete-47589\";i:46830;s:12:\"delete-47592\";i:46831;s:12:\"delete-47590\";i:46832;s:12:\"delete-47591\";i:46833;s:12:\"delete-47593\";i:46834;s:12:\"delete-47594\";i:46835;s:12:\"delete-47597\";i:46836;s:12:\"delete-47595\";i:46837;s:12:\"delete-47596\";i:46838;s:12:\"delete-47598\";i:46839;s:12:\"delete-47599\";i:46840;s:12:\"delete-47602\";i:46841;s:12:\"delete-47603\";i:46842;s:12:\"delete-47600\";i:46843;s:12:\"delete-47601\";i:46844;s:12:\"delete-47604\";i:46845;s:12:\"delete-47607\";i:46846;s:12:\"delete-47608\";i:46847;s:12:\"delete-47605\";i:46848;s:12:\"delete-47606\";i:46849;s:12:\"delete-47609\";i:46850;s:12:\"delete-47612\";i:46851;s:12:\"delete-47613\";i:46852;s:12:\"delete-47610\";i:46853;s:12:\"delete-47611\";i:46854;s:12:\"delete-47614\";i:46855;s:12:\"delete-47617\";i:46856;s:12:\"delete-47618\";i:46857;s:12:\"delete-47615\";i:46858;s:12:\"delete-47616\";i:46859;s:12:\"delete-47619\";i:46860;s:12:\"delete-47622\";i:46861;s:12:\"delete-47623\";i:46862;s:12:\"delete-47620\";i:46863;s:12:\"delete-47621\";i:46864;s:12:\"delete-47624\";i:46865;s:12:\"delete-47627\";i:46866;s:12:\"delete-47628\";i:46867;s:12:\"delete-47625\";i:46868;s:12:\"delete-47626\";i:46869;s:12:\"delete-47629\";i:46870;s:12:\"delete-47632\";i:46871;s:12:\"delete-47633\";i:46872;s:12:\"delete-47630\";i:46873;s:12:\"delete-47631\";i:46874;s:12:\"delete-47634\";i:46875;s:12:\"delete-47637\";i:46876;s:12:\"delete-47635\";i:46877;s:12:\"delete-47636\";i:46878;s:12:\"delete-47638\";i:46879;s:12:\"delete-47639\";i:46880;s:12:\"delete-47642\";i:46881;s:12:\"delete-47643\";i:46882;s:12:\"delete-47640\";i:46883;s:12:\"delete-47641\";i:46884;s:12:\"delete-47644\";i:46885;s:12:\"delete-47647\";i:46886;s:12:\"delete-47645\";i:46887;s:12:\"delete-47646\";i:46888;s:12:\"delete-47648\";i:46889;s:12:\"delete-47649\";i:46890;s:12:\"delete-47652\";i:46891;s:12:\"delete-47653\";i:46892;s:12:\"delete-47650\";i:46893;s:12:\"delete-47651\";i:46894;s:12:\"delete-47654\";i:46895;s:12:\"delete-47657\";i:46896;s:12:\"delete-47658\";i:46897;s:12:\"delete-47655\";i:46898;s:12:\"delete-47656\";i:46899;s:12:\"delete-47659\";i:46900;s:12:\"delete-47662\";i:46901;s:12:\"delete-47663\";i:46902;s:12:\"delete-47660\";i:46903;s:12:\"delete-47661\";i:46904;s:12:\"delete-47664\";i:46905;s:12:\"delete-47667\";i:46906;s:12:\"delete-47668\";i:46907;s:12:\"delete-47665\";i:46908;s:12:\"delete-47666\";i:46909;s:12:\"delete-47669\";i:46910;s:12:\"delete-47672\";i:46911;s:12:\"delete-47673\";i:46912;s:12:\"delete-47670\";i:46913;s:12:\"delete-47671\";i:46914;s:12:\"delete-47674\";i:46915;s:12:\"delete-47677\";i:46916;s:12:\"delete-47678\";i:46917;s:12:\"delete-47675\";i:46918;s:12:\"delete-47676\";i:46919;s:12:\"delete-47679\";i:46920;s:12:\"delete-47682\";i:46921;s:12:\"delete-47683\";i:46922;s:12:\"delete-47680\";i:46923;s:12:\"delete-47681\";i:46924;s:12:\"delete-47684\";i:46925;s:12:\"delete-47687\";i:46926;s:12:\"delete-47688\";i:46927;s:12:\"delete-47685\";i:46928;s:12:\"delete-47686\";i:46929;s:12:\"delete-47689\";i:46930;s:12:\"delete-47692\";i:46931;s:12:\"delete-47693\";i:46932;s:12:\"delete-47690\";i:46933;s:12:\"delete-47691\";i:46934;s:12:\"delete-47694\";i:46935;s:12:\"delete-47697\";i:46936;s:12:\"delete-47695\";i:46937;s:12:\"delete-47696\";i:46938;s:12:\"delete-47698\";i:46939;s:12:\"delete-47699\";i:46940;s:12:\"delete-47702\";i:46941;s:12:\"delete-47703\";i:46942;s:12:\"delete-47700\";i:46943;s:12:\"delete-47701\";i:46944;s:12:\"delete-47704\";i:46945;s:12:\"delete-47707\";i:46946;s:12:\"delete-47708\";i:46947;s:12:\"delete-47705\";i:46948;s:12:\"delete-47706\";i:46949;s:12:\"delete-47709\";i:46950;s:12:\"delete-47712\";i:46951;s:12:\"delete-47710\";i:46952;s:12:\"delete-47711\";i:46953;s:12:\"delete-47713\";i:46954;s:12:\"delete-47714\";i:46955;s:12:\"delete-47717\";i:46956;s:12:\"delete-47715\";i:46957;s:12:\"delete-47716\";i:46958;s:12:\"delete-47718\";i:46959;s:12:\"delete-47719\";i:46960;s:12:\"delete-47722\";i:46961;s:12:\"delete-47723\";i:46962;s:12:\"delete-47724\";i:46963;s:12:\"delete-47727\";i:46964;s:12:\"delete-47728\";i:46965;s:12:\"delete-47720\";i:46966;s:12:\"delete-47721\";i:46967;s:12:\"delete-47725\";i:46968;s:12:\"delete-47726\";i:46969;s:12:\"delete-47729\";i:46970;s:12:\"delete-47732\";i:46971;s:12:\"delete-47733\";i:46972;s:12:\"delete-47730\";i:46973;s:12:\"delete-47731\";i:46974;s:12:\"delete-47734\";i:46975;s:12:\"delete-47737\";i:46976;s:12:\"delete-47738\";i:46977;s:12:\"delete-47735\";i:46978;s:12:\"delete-47736\";i:46979;s:12:\"delete-47739\";i:46980;s:12:\"delete-47742\";i:46981;s:12:\"delete-47743\";i:46982;s:12:\"delete-47740\";i:46983;s:12:\"delete-47741\";i:46984;s:12:\"delete-47744\";i:46985;s:12:\"delete-47747\";i:46986;s:12:\"delete-47745\";i:46987;s:12:\"delete-47746\";i:46988;s:12:\"delete-47748\";i:46989;s:12:\"delete-47749\";i:46990;s:12:\"delete-47752\";i:46991;s:12:\"delete-47750\";i:46992;s:12:\"delete-47751\";i:46993;s:12:\"delete-47753\";i:46994;s:12:\"delete-47754\";i:46995;s:12:\"delete-47757\";i:46996;s:12:\"delete-47758\";i:46997;s:12:\"delete-47755\";i:46998;s:12:\"delete-47756\";i:46999;s:12:\"delete-47759\";i:47000;s:12:\"delete-47762\";i:47001;s:12:\"delete-47763\";i:47002;s:12:\"delete-47760\";i:47003;s:12:\"delete-47761\";i:47004;s:12:\"delete-47764\";i:47005;s:12:\"delete-47767\";i:47006;s:12:\"delete-47768\";i:47007;s:12:\"delete-47765\";i:47008;s:12:\"delete-47766\";i:47009;s:12:\"delete-47769\";i:47010;s:12:\"delete-47772\";i:47011;s:12:\"delete-47773\";i:47012;s:12:\"delete-47770\";i:47013;s:12:\"delete-47771\";i:47014;s:12:\"delete-47774\";i:47015;s:12:\"delete-47777\";i:47016;s:12:\"delete-47778\";i:47017;s:12:\"delete-47775\";i:47018;s:12:\"delete-47776\";i:47019;s:12:\"delete-47779\";i:47020;s:12:\"delete-47782\";i:47021;s:12:\"delete-47783\";i:47022;s:12:\"delete-47780\";i:47023;s:12:\"delete-47781\";i:47024;s:12:\"delete-47784\";i:47025;s:12:\"delete-47787\";i:47026;s:12:\"delete-47788\";i:47027;s:12:\"delete-47785\";i:47028;s:12:\"delete-47786\";i:47029;s:12:\"delete-47789\";i:47030;s:12:\"delete-47792\";i:47031;s:12:\"delete-47793\";i:47032;s:12:\"delete-47790\";i:47033;s:12:\"delete-47791\";i:47034;s:12:\"delete-47794\";i:47035;s:12:\"delete-47797\";i:47036;s:12:\"delete-47798\";i:47037;s:12:\"delete-47795\";i:47038;s:12:\"delete-47796\";i:47039;s:12:\"delete-47799\";i:47040;s:12:\"delete-47802\";i:47041;s:12:\"delete-47803\";i:47042;s:12:\"delete-47800\";i:47043;s:12:\"delete-47801\";i:47044;s:12:\"delete-47804\";i:47045;s:12:\"delete-47807\";i:47046;s:12:\"delete-47808\";i:47047;s:12:\"delete-47805\";i:47048;s:12:\"delete-47806\";i:47049;s:12:\"delete-47809\";i:47050;s:12:\"delete-47812\";i:47051;s:12:\"delete-47813\";i:47052;s:12:\"delete-47810\";i:47053;s:12:\"delete-47811\";i:47054;s:12:\"delete-47814\";i:47055;s:12:\"delete-47817\";i:47056;s:12:\"delete-47815\";i:47057;s:12:\"delete-47816\";i:47058;s:12:\"delete-47818\";i:47059;s:12:\"delete-47819\";i:47060;s:12:\"delete-47822\";i:47061;s:12:\"delete-47823\";i:47062;s:12:\"delete-47820\";i:47063;s:12:\"delete-47821\";i:47064;s:12:\"delete-47824\";i:47065;s:12:\"delete-47827\";i:47066;s:12:\"delete-47828\";i:47067;s:12:\"delete-47825\";i:47068;s:12:\"delete-47826\";i:47069;s:12:\"delete-47829\";i:47070;s:12:\"delete-47832\";i:47071;s:12:\"delete-47833\";i:47072;s:12:\"delete-47830\";i:47073;s:12:\"delete-47831\";i:47074;s:12:\"delete-47834\";i:47075;s:12:\"delete-47837\";i:47076;s:12:\"delete-47838\";i:47077;s:12:\"delete-47835\";i:47078;s:12:\"delete-47836\";i:47079;s:12:\"delete-47839\";i:47080;s:12:\"delete-47842\";i:47081;s:12:\"delete-47843\";i:47082;s:12:\"delete-47840\";i:47083;s:12:\"delete-47841\";i:47084;s:12:\"delete-47844\";i:47085;s:12:\"delete-47847\";i:47086;s:12:\"delete-47848\";i:47087;s:12:\"delete-47845\";i:47088;s:12:\"delete-47846\";i:47089;s:12:\"delete-47849\";i:47090;s:12:\"delete-47852\";i:47091;s:12:\"delete-47853\";i:47092;s:12:\"delete-47850\";i:47093;s:12:\"delete-47851\";i:47094;s:12:\"delete-47854\";i:47095;s:12:\"delete-47857\";i:47096;s:12:\"delete-47855\";i:47097;s:12:\"delete-47856\";i:47098;s:12:\"delete-47858\";i:47099;s:12:\"delete-47859\";i:47100;s:12:\"delete-47862\";i:47101;s:12:\"delete-47863\";i:47102;s:12:\"delete-47860\";i:47103;s:12:\"delete-47861\";i:47104;s:12:\"delete-47864\";i:47105;s:12:\"delete-47867\";i:47106;s:12:\"delete-47868\";i:47107;s:12:\"delete-47865\";i:47108;s:12:\"delete-47866\";i:47109;s:12:\"delete-47869\";i:47110;s:12:\"delete-47872\";i:47111;s:12:\"delete-47873\";i:47112;s:12:\"delete-47870\";i:47113;s:12:\"delete-47871\";i:47114;s:12:\"delete-47874\";i:47115;s:12:\"delete-47877\";i:47116;s:12:\"delete-47878\";i:47117;s:12:\"delete-47875\";i:47118;s:12:\"delete-47876\";i:47119;s:12:\"delete-47879\";i:47120;s:12:\"delete-47882\";i:47121;s:12:\"delete-47880\";i:47122;s:12:\"delete-47881\";i:47123;s:12:\"delete-47883\";i:47124;s:12:\"delete-47884\";i:47125;s:12:\"delete-47887\";i:47126;s:12:\"delete-47888\";i:47127;s:12:\"delete-47885\";i:47128;s:12:\"delete-47886\";i:47129;s:12:\"delete-47889\";i:47130;s:12:\"delete-47892\";i:47131;s:12:\"delete-47893\";i:47132;s:12:\"delete-47890\";i:47133;s:12:\"delete-47891\";i:47134;s:12:\"delete-47894\";i:47135;s:12:\"delete-47897\";i:47136;s:12:\"delete-47898\";i:47137;s:12:\"delete-47895\";i:47138;s:12:\"delete-47896\";i:47139;s:12:\"delete-47899\";i:47140;s:12:\"delete-47902\";i:47141;s:12:\"delete-47903\";i:47142;s:12:\"delete-47900\";i:47143;s:12:\"delete-47901\";i:47144;s:12:\"delete-47904\";i:47145;s:12:\"delete-47907\";i:47146;s:12:\"delete-47908\";i:47147;s:12:\"delete-47905\";i:47148;s:12:\"delete-47906\";i:47149;s:12:\"delete-47909\";i:47150;s:12:\"delete-47912\";i:47151;s:12:\"delete-47913\";i:47152;s:12:\"delete-47910\";i:47153;s:12:\"delete-47911\";i:47154;s:12:\"delete-47914\";i:47155;s:12:\"delete-47917\";i:47156;s:12:\"delete-47918\";i:47157;s:12:\"delete-47915\";i:47158;s:12:\"delete-47916\";i:47159;s:12:\"delete-47919\";i:47160;s:12:\"delete-47922\";i:47161;s:12:\"delete-47923\";i:47162;s:12:\"delete-47920\";i:47163;s:12:\"delete-47921\";i:47164;s:12:\"delete-47924\";i:47165;s:12:\"delete-47927\";i:47166;s:12:\"delete-47925\";i:47167;s:12:\"delete-47926\";i:47168;s:12:\"delete-47928\";i:47169;s:12:\"delete-47929\";i:47170;s:12:\"delete-47932\";i:47171;s:12:\"delete-47933\";i:47172;s:12:\"delete-47930\";i:47173;s:12:\"delete-47931\";i:47174;s:12:\"delete-47934\";i:47175;s:12:\"delete-47937\";i:47176;s:12:\"delete-47938\";i:47177;s:12:\"delete-47935\";i:47178;s:12:\"delete-47936\";i:47179;s:12:\"delete-47939\";i:47180;s:12:\"delete-47942\";i:47181;s:12:\"delete-47943\";i:47182;s:12:\"delete-47940\";i:47183;s:12:\"delete-47941\";i:47184;s:12:\"delete-47944\";i:47185;s:12:\"delete-47947\";i:47186;s:12:\"delete-47948\";i:47187;s:12:\"delete-47945\";i:47188;s:12:\"delete-47946\";i:47189;s:12:\"delete-47949\";i:47190;s:12:\"delete-47952\";i:47191;s:12:\"delete-47950\";i:47192;s:12:\"delete-47951\";i:47193;s:12:\"delete-47953\";i:47194;s:12:\"delete-47954\";i:47195;s:12:\"delete-47957\";i:47196;s:12:\"delete-47958\";i:47197;s:12:\"delete-47955\";i:47198;s:12:\"delete-47956\";i:47199;s:12:\"delete-47959\";i:47200;s:12:\"delete-47962\";i:47201;s:12:\"delete-47963\";i:47202;s:12:\"delete-47960\";i:47203;s:12:\"delete-47961\";i:47204;s:12:\"delete-47964\";i:47205;s:12:\"delete-47967\";i:47206;s:12:\"delete-47968\";i:47207;s:12:\"delete-47965\";i:47208;s:12:\"delete-47966\";i:47209;s:12:\"delete-47969\";i:47210;s:12:\"delete-47972\";i:47211;s:12:\"delete-47973\";i:47212;s:12:\"delete-47970\";i:47213;s:12:\"delete-47971\";i:47214;s:12:\"delete-47974\";i:47215;s:12:\"delete-47977\";i:47216;s:12:\"delete-47978\";i:47217;s:12:\"delete-47975\";i:47218;s:12:\"delete-47976\";i:47219;s:12:\"delete-47979\";i:47220;s:12:\"delete-47982\";i:47221;s:12:\"delete-47980\";i:47222;s:12:\"delete-47981\";i:47223;s:12:\"delete-47983\";i:47224;s:12:\"delete-47984\";i:47225;s:12:\"delete-47987\";i:47226;s:12:\"delete-47988\";i:47227;s:12:\"delete-47985\";i:47228;s:12:\"delete-47986\";i:47229;s:12:\"delete-47989\";i:47230;s:12:\"delete-47992\";i:47231;s:12:\"delete-47993\";i:47232;s:12:\"delete-47990\";i:47233;s:12:\"delete-47991\";i:47234;s:12:\"delete-47994\";i:47235;s:12:\"delete-47997\";i:47236;s:12:\"delete-47995\";i:47237;s:12:\"delete-47996\";i:47238;s:12:\"delete-47998\";i:47239;s:12:\"delete-47999\";i:47240;s:12:\"delete-48002\";i:47241;s:12:\"delete-48003\";i:47242;s:12:\"delete-48000\";i:47243;s:12:\"delete-48001\";i:47244;s:12:\"delete-48004\";i:47245;s:12:\"delete-48007\";i:47246;s:12:\"delete-48008\";i:47247;s:12:\"delete-48005\";i:47248;s:12:\"delete-48006\";i:47249;s:12:\"delete-48009\";i:47250;s:12:\"delete-48012\";i:47251;s:12:\"delete-48013\";i:47252;s:12:\"delete-48010\";i:47253;s:12:\"delete-48011\";i:47254;s:12:\"delete-48014\";i:47255;s:12:\"delete-48017\";i:47256;s:12:\"delete-48018\";i:47257;s:12:\"delete-48015\";i:47258;s:12:\"delete-48016\";i:47259;s:12:\"delete-48019\";i:47260;s:12:\"delete-48022\";i:47261;s:12:\"delete-48023\";i:47262;s:12:\"delete-48020\";i:47263;s:12:\"delete-48021\";i:47264;s:12:\"delete-48024\";i:47265;s:12:\"delete-48027\";i:47266;s:12:\"delete-48028\";i:47267;s:12:\"delete-48025\";i:47268;s:12:\"delete-48026\";i:47269;s:12:\"delete-48029\";i:47270;s:12:\"delete-48032\";i:47271;s:12:\"delete-48033\";i:47272;s:12:\"delete-48030\";i:47273;s:12:\"delete-48031\";i:47274;s:12:\"delete-48034\";i:47275;s:12:\"delete-48037\";i:47276;s:12:\"delete-48038\";i:47277;s:12:\"delete-48035\";i:47278;s:12:\"delete-48036\";i:47279;s:12:\"delete-48039\";i:47280;s:12:\"delete-48042\";i:47281;s:12:\"delete-48043\";i:47282;s:12:\"delete-48040\";i:47283;s:12:\"delete-48041\";i:47284;s:12:\"delete-48044\";i:47285;s:12:\"delete-48047\";i:47286;s:12:\"delete-48045\";i:47287;s:12:\"delete-48046\";i:47288;s:12:\"delete-48048\";i:47289;s:12:\"delete-48049\";i:47290;s:12:\"delete-48052\";i:47291;s:12:\"delete-48053\";i:47292;s:12:\"delete-48050\";i:47293;s:12:\"delete-48051\";i:47294;s:12:\"delete-48054\";i:47295;s:12:\"delete-48057\";i:47296;s:12:\"delete-48058\";i:47297;s:12:\"delete-48055\";i:47298;s:12:\"delete-48056\";i:47299;s:12:\"delete-48059\";i:47300;s:12:\"delete-48062\";i:47301;s:12:\"delete-48063\";i:47302;s:12:\"delete-48060\";i:47303;s:12:\"delete-48061\";i:47304;s:12:\"delete-48064\";i:47305;s:12:\"delete-48067\";i:47306;s:12:\"delete-48068\";i:47307;s:12:\"delete-48065\";i:47308;s:12:\"delete-48066\";i:47309;s:12:\"delete-48069\";i:47310;s:12:\"delete-48072\";i:47311;s:12:\"delete-48073\";i:47312;s:12:\"delete-48070\";i:47313;s:12:\"delete-48071\";i:47314;s:12:\"delete-48074\";i:47315;s:12:\"delete-48077\";i:47316;s:12:\"delete-48078\";i:47317;s:12:\"delete-48075\";i:47318;s:12:\"delete-48076\";i:47319;s:12:\"delete-48079\";i:47320;s:12:\"delete-48082\";i:47321;s:12:\"delete-48083\";i:47322;s:12:\"delete-48080\";i:47323;s:12:\"delete-48081\";i:47324;s:12:\"delete-48084\";i:47325;s:12:\"delete-48087\";i:47326;s:12:\"delete-48088\";i:47327;s:12:\"delete-48085\";i:47328;s:12:\"delete-48086\";i:47329;s:12:\"delete-48089\";i:47330;s:12:\"delete-48092\";i:47331;s:12:\"delete-48093\";i:47332;s:12:\"delete-48090\";i:47333;s:12:\"delete-48091\";i:47334;s:12:\"delete-48094\";i:47335;s:12:\"delete-48097\";i:47336;s:12:\"delete-48098\";i:47337;s:12:\"delete-48095\";i:47338;s:12:\"delete-48096\";i:47339;s:12:\"delete-48099\";i:47340;s:12:\"delete-48102\";i:47341;s:12:\"delete-48103\";i:47342;s:12:\"delete-48100\";i:47343;s:12:\"delete-48101\";i:47344;s:12:\"delete-48104\";i:47345;s:12:\"delete-48107\";i:47346;s:12:\"delete-48105\";i:47347;s:12:\"delete-48106\";i:47348;s:12:\"delete-48108\";i:47349;s:12:\"delete-48109\";i:47350;s:12:\"delete-48112\";i:47351;s:12:\"delete-48113\";i:47352;s:12:\"delete-48110\";i:47353;s:12:\"delete-48111\";i:47354;s:12:\"delete-48114\";i:47355;s:12:\"delete-48117\";i:47356;s:12:\"delete-48118\";i:47357;s:12:\"delete-48115\";i:47358;s:12:\"delete-48116\";i:47359;s:12:\"delete-48119\";i:47360;s:12:\"delete-48122\";i:47361;s:12:\"delete-48123\";i:47362;s:12:\"delete-48120\";i:47363;s:12:\"delete-48121\";i:47364;s:12:\"delete-48124\";i:47365;s:12:\"delete-48127\";i:47366;s:12:\"delete-48128\";i:47367;s:12:\"delete-48125\";i:47368;s:12:\"delete-48126\";i:47369;s:12:\"delete-48129\";i:47370;s:12:\"delete-48132\";i:47371;s:12:\"delete-48133\";i:47372;s:12:\"delete-48130\";i:47373;s:12:\"delete-48131\";i:47374;s:12:\"delete-48134\";i:47375;s:12:\"delete-48137\";i:47376;s:12:\"delete-48135\";i:47377;s:12:\"delete-48136\";i:47378;s:12:\"delete-48138\";i:47379;s:12:\"delete-48139\";i:47380;s:12:\"delete-48142\";i:47381;s:12:\"delete-48143\";i:47382;s:12:\"delete-48140\";i:47383;s:12:\"delete-48141\";i:47384;s:12:\"delete-48144\";i:47385;s:12:\"delete-48147\";i:47386;s:12:\"delete-48148\";i:47387;s:12:\"delete-48145\";i:47388;s:12:\"delete-48146\";i:47389;s:12:\"delete-48149\";i:47390;s:12:\"delete-48152\";i:47391;s:12:\"delete-48153\";i:47392;s:12:\"delete-48150\";i:47393;s:12:\"delete-48151\";i:47394;s:12:\"delete-48154\";i:47395;s:12:\"delete-48157\";i:47396;s:12:\"delete-48158\";i:47397;s:12:\"delete-48155\";i:47398;s:12:\"delete-48156\";i:47399;s:12:\"delete-48159\";i:47400;s:12:\"delete-48162\";i:47401;s:12:\"delete-48160\";i:47402;s:12:\"delete-48161\";i:47403;s:12:\"delete-48163\";i:47404;s:12:\"delete-48164\";i:47405;s:12:\"delete-48167\";i:47406;s:12:\"delete-48165\";i:47407;s:12:\"delete-48166\";i:47408;s:12:\"delete-48168\";i:47409;s:12:\"delete-48169\";i:47410;s:12:\"delete-48170\";i:47411;s:12:\"delete-48171\";i:47412;s:12:\"delete-48172\";i:47413;s:12:\"delete-48173\";i:47414;s:12:\"delete-48174\";i:47415;s:12:\"delete-48177\";i:47416;s:12:\"delete-48175\";i:47417;s:12:\"delete-48176\";i:47418;s:12:\"delete-48178\";i:47419;s:12:\"delete-48179\";i:47420;s:12:\"delete-48182\";i:47421;s:12:\"delete-48183\";i:47422;s:12:\"delete-48180\";i:47423;s:12:\"delete-48181\";i:47424;s:12:\"delete-48184\";i:47425;s:12:\"delete-48187\";i:47426;s:12:\"delete-48188\";i:47427;s:12:\"delete-48185\";i:47428;s:12:\"delete-48186\";i:47429;s:12:\"delete-48189\";i:47430;s:12:\"delete-48192\";i:47431;s:12:\"delete-48193\";i:47432;s:12:\"delete-48190\";i:47433;s:12:\"delete-48191\";i:47434;s:12:\"delete-48194\";i:47435;s:12:\"delete-48197\";i:47436;s:12:\"delete-48198\";i:47437;s:12:\"delete-48195\";i:47438;s:12:\"delete-48196\";i:47439;s:12:\"delete-48199\";i:47440;s:12:\"delete-48202\";i:47441;s:12:\"delete-48203\";i:47442;s:12:\"delete-48200\";i:47443;s:12:\"delete-48201\";i:47444;s:12:\"delete-48204\";i:47445;s:12:\"delete-48207\";i:47446;s:12:\"delete-48205\";i:47447;s:12:\"delete-48206\";i:47448;s:12:\"delete-48208\";i:47449;s:12:\"delete-48209\";i:47450;s:12:\"delete-48212\";i:47451;s:12:\"delete-48213\";i:47452;s:12:\"delete-48210\";i:47453;s:12:\"delete-48211\";i:47454;s:12:\"delete-48214\";i:47455;s:12:\"delete-48217\";i:47456;s:12:\"delete-48218\";i:47457;s:12:\"delete-48215\";i:47458;s:12:\"delete-48216\";i:47459;s:12:\"delete-48219\";i:47460;s:12:\"delete-48222\";i:47461;s:12:\"delete-48223\";i:47462;s:12:\"delete-48220\";i:47463;s:12:\"delete-48221\";i:47464;s:12:\"delete-48224\";i:47465;s:12:\"delete-48227\";i:47466;s:12:\"delete-48225\";i:47467;s:12:\"delete-48226\";i:47468;s:12:\"delete-48228\";i:47469;s:12:\"delete-48229\";i:47470;s:12:\"delete-48232\";i:47471;s:12:\"delete-48233\";i:47472;s:12:\"delete-48230\";i:47473;s:12:\"delete-48231\";i:47474;s:12:\"delete-48234\";i:47475;s:12:\"delete-48237\";i:47476;s:12:\"delete-48238\";i:47477;s:12:\"delete-48235\";i:47478;s:12:\"delete-48236\";i:47479;s:12:\"delete-48239\";i:47480;s:12:\"delete-48242\";i:47481;s:12:\"delete-48243\";i:47482;s:12:\"delete-48240\";i:47483;s:12:\"delete-48241\";i:47484;s:12:\"delete-48244\";i:47485;s:12:\"delete-48247\";i:47486;s:12:\"delete-48248\";i:47487;s:12:\"delete-48245\";i:47488;s:12:\"delete-48246\";i:47489;s:12:\"delete-48249\";i:47490;s:12:\"delete-48252\";i:47491;s:12:\"delete-48253\";i:47492;s:12:\"delete-48250\";i:47493;s:12:\"delete-48251\";i:47494;s:12:\"delete-48254\";i:47495;s:12:\"delete-48257\";i:47496;s:12:\"delete-48255\";i:47497;s:12:\"delete-48256\";i:47498;s:12:\"delete-48258\";i:47499;s:12:\"delete-48259\";i:47500;s:12:\"delete-48262\";i:47501;s:12:\"delete-48263\";i:47502;s:12:\"delete-48260\";i:47503;s:12:\"delete-48261\";i:47504;s:12:\"delete-48264\";i:47505;s:12:\"delete-48267\";i:47506;s:12:\"delete-48268\";i:47507;s:12:\"delete-48265\";i:47508;s:12:\"delete-48266\";i:47509;s:12:\"delete-48269\";i:47510;s:12:\"delete-48272\";i:47511;s:12:\"delete-48273\";i:47512;s:12:\"delete-48270\";i:47513;s:12:\"delete-48271\";i:47514;s:12:\"delete-48274\";i:47515;s:12:\"delete-48277\";i:47516;s:12:\"delete-48278\";i:47517;s:12:\"delete-48275\";i:47518;s:12:\"delete-48276\";i:47519;s:12:\"delete-48279\";i:47520;s:12:\"delete-48282\";i:47521;s:12:\"delete-48283\";i:47522;s:12:\"delete-48280\";i:47523;s:12:\"delete-48281\";i:47524;s:12:\"delete-48284\";i:47525;s:12:\"delete-48287\";i:47526;s:12:\"delete-48288\";i:47527;s:12:\"delete-48285\";i:47528;s:12:\"delete-48286\";i:47529;s:12:\"delete-48289\";i:47530;s:12:\"delete-48292\";i:47531;s:12:\"delete-48293\";i:47532;s:12:\"delete-48290\";i:47533;s:12:\"delete-48291\";i:47534;s:12:\"delete-48294\";i:47535;s:12:\"delete-48297\";i:47536;s:12:\"delete-48298\";i:47537;s:12:\"delete-48295\";i:47538;s:12:\"delete-48296\";i:47539;s:12:\"delete-48299\";i:47540;s:12:\"delete-48302\";i:47541;s:12:\"delete-48303\";i:47542;s:12:\"delete-48300\";i:47543;s:12:\"delete-48301\";i:47544;s:12:\"delete-48304\";i:47545;s:12:\"delete-48307\";i:47546;s:12:\"delete-48308\";i:47547;s:12:\"delete-48305\";i:47548;s:12:\"delete-48306\";i:47549;s:12:\"delete-48309\";i:47550;s:12:\"delete-48312\";i:47551;s:12:\"delete-48313\";i:47552;s:12:\"delete-48310\";i:47553;s:12:\"delete-48311\";i:47554;s:12:\"delete-48314\";i:47555;s:12:\"delete-48317\";i:47556;s:12:\"delete-48318\";i:47557;s:12:\"delete-48315\";i:47558;s:12:\"delete-48316\";i:47559;s:12:\"delete-48319\";i:47560;s:12:\"delete-48322\";i:47561;s:12:\"delete-48323\";i:47562;s:12:\"delete-48320\";i:47563;s:12:\"delete-48321\";i:47564;s:12:\"delete-48324\";i:47565;s:12:\"delete-48327\";i:47566;s:12:\"delete-48328\";i:47567;s:12:\"delete-48325\";i:47568;s:12:\"delete-48326\";i:47569;s:12:\"delete-48329\";i:47570;s:12:\"delete-48332\";i:47571;s:12:\"delete-48333\";i:47572;s:12:\"delete-48330\";i:47573;s:12:\"delete-48331\";i:47574;s:12:\"delete-48334\";i:47575;s:12:\"delete-48337\";i:47576;s:12:\"delete-48335\";i:47577;s:12:\"delete-48336\";i:47578;s:12:\"delete-48338\";i:47579;s:12:\"delete-48339\";i:47580;s:12:\"delete-48342\";i:47581;s:12:\"delete-48343\";i:47582;s:12:\"delete-48340\";i:47583;s:12:\"delete-48341\";i:47584;s:12:\"delete-48344\";i:47585;s:12:\"delete-48347\";i:47586;s:12:\"delete-48348\";i:47587;s:12:\"delete-48345\";i:47588;s:12:\"delete-48346\";i:47589;s:12:\"delete-48349\";i:47590;s:12:\"delete-48352\";i:47591;s:12:\"delete-48353\";i:47592;s:12:\"delete-48350\";i:47593;s:12:\"delete-48351\";i:47594;s:12:\"delete-48354\";i:47595;s:12:\"delete-48357\";i:47596;s:12:\"delete-48355\";i:47597;s:12:\"delete-48356\";i:47598;s:12:\"delete-48358\";i:47599;s:12:\"delete-48359\";i:47600;s:12:\"delete-48362\";i:47601;s:12:\"delete-48363\";i:47602;s:12:\"delete-48360\";i:47603;s:12:\"delete-48361\";i:47604;s:12:\"delete-48364\";i:47605;s:12:\"delete-48367\";i:47606;s:12:\"delete-48365\";i:47607;s:12:\"delete-48366\";i:47608;s:12:\"delete-48368\";i:47609;s:12:\"delete-48369\";i:47610;s:12:\"delete-48372\";i:47611;s:12:\"delete-48373\";i:47612;s:12:\"delete-48370\";i:47613;s:12:\"delete-48371\";i:47614;s:12:\"delete-48374\";i:47615;s:12:\"delete-48377\";i:47616;s:12:\"delete-48375\";i:47617;s:12:\"delete-48376\";i:47618;s:12:\"delete-48378\";i:47619;s:12:\"delete-48379\";i:47620;s:12:\"delete-48382\";i:47621;s:12:\"delete-48383\";i:47622;s:12:\"delete-48380\";i:47623;s:12:\"delete-48381\";i:47624;s:12:\"delete-48384\";i:47625;s:12:\"delete-48387\";i:47626;s:12:\"delete-48385\";i:47627;s:12:\"delete-48386\";i:47628;s:12:\"delete-48388\";i:47629;s:12:\"delete-48391\";i:47630;s:12:\"delete-48392\";i:47631;s:12:\"delete-48389\";i:47632;s:12:\"delete-48390\";i:47633;s:12:\"delete-48393\";i:47634;s:12:\"delete-48396\";i:47635;s:12:\"delete-48397\";i:47636;s:12:\"delete-48394\";i:47637;s:12:\"delete-48395\";i:47638;s:12:\"delete-48398\";i:47639;s:12:\"delete-48401\";i:47640;s:12:\"delete-48399\";i:47641;s:12:\"delete-48400\";i:47642;s:12:\"delete-48402\";i:47643;s:12:\"delete-48403\";i:47644;s:12:\"delete-48406\";i:47645;s:12:\"delete-48407\";i:47646;s:12:\"delete-48404\";i:47647;s:12:\"delete-48405\";i:47648;s:12:\"delete-48408\";i:47649;s:12:\"delete-48411\";i:47650;s:12:\"delete-48409\";i:47651;s:12:\"delete-48410\";i:47652;s:12:\"delete-48412\";i:47653;s:12:\"delete-48413\";i:47654;s:12:\"delete-48416\";i:47655;s:12:\"delete-48417\";i:47656;s:12:\"delete-48414\";i:47657;s:12:\"delete-48415\";i:47658;s:12:\"delete-48418\";i:47659;s:12:\"delete-48421\";i:47660;s:12:\"delete-48422\";i:47661;s:12:\"delete-48419\";i:47662;s:12:\"delete-48420\";i:47663;s:12:\"delete-48423\";i:47664;s:12:\"delete-48426\";i:47665;s:12:\"delete-48427\";i:47666;s:12:\"delete-48424\";i:47667;s:12:\"delete-48425\";i:47668;s:12:\"delete-48428\";i:47669;s:12:\"delete-48431\";i:47670;s:12:\"delete-48429\";i:47671;s:12:\"delete-48430\";i:47672;s:12:\"delete-48432\";i:47673;s:12:\"delete-48433\";i:47674;s:12:\"delete-48436\";i:47675;s:12:\"delete-48437\";i:47676;s:12:\"delete-48434\";i:47677;s:12:\"delete-48435\";i:47678;s:12:\"delete-48438\";i:47679;s:12:\"delete-48441\";i:47680;s:12:\"delete-48442\";i:47681;s:12:\"delete-48439\";i:47682;s:12:\"delete-48440\";i:47683;s:12:\"delete-48443\";i:47684;s:12:\"delete-48446\";i:47685;s:12:\"delete-48447\";i:47686;s:12:\"delete-48444\";i:47687;s:12:\"delete-48445\";i:47688;s:12:\"delete-48448\";i:47689;s:12:\"delete-48451\";i:47690;s:12:\"delete-48452\";i:47691;s:12:\"delete-48449\";i:47692;s:12:\"delete-48450\";i:47693;s:12:\"delete-48453\";i:47694;s:12:\"delete-48456\";i:47695;s:12:\"delete-48457\";i:47696;s:12:\"delete-48454\";i:47697;s:12:\"delete-48455\";i:47698;s:12:\"delete-48458\";i:47699;s:12:\"delete-48461\";i:47700;s:12:\"delete-48462\";i:47701;s:12:\"delete-48459\";i:47702;s:12:\"delete-48460\";i:47703;s:12:\"delete-48463\";i:47704;s:12:\"delete-48466\";i:47705;s:12:\"delete-48467\";i:47706;s:12:\"delete-48464\";i:47707;s:12:\"delete-48465\";i:47708;s:12:\"delete-48468\";i:47709;s:12:\"delete-48471\";i:47710;s:12:\"delete-48472\";i:47711;s:12:\"delete-48469\";i:47712;s:12:\"delete-48470\";i:47713;s:12:\"delete-48473\";i:47714;s:12:\"delete-48476\";i:47715;s:12:\"delete-48477\";i:47716;s:12:\"delete-48474\";i:47717;s:12:\"delete-48475\";i:47718;s:12:\"delete-48478\";i:47719;s:12:\"delete-48481\";i:47720;s:12:\"delete-48482\";i:47721;s:12:\"delete-48479\";i:47722;s:12:\"delete-48480\";i:47723;s:12:\"delete-48483\";i:47724;s:12:\"delete-48486\";i:47725;s:12:\"delete-48487\";i:47726;s:12:\"delete-48484\";i:47727;s:12:\"delete-48485\";i:47728;s:12:\"delete-48488\";i:47729;s:12:\"delete-48491\";i:47730;s:12:\"delete-48492\";i:47731;s:12:\"delete-48489\";i:47732;s:12:\"delete-48490\";i:47733;s:12:\"delete-48493\";i:47734;s:12:\"delete-48496\";i:47735;s:12:\"delete-48497\";i:47736;s:12:\"delete-48494\";i:47737;s:12:\"delete-48495\";i:47738;s:12:\"delete-48498\";i:47739;s:12:\"delete-48501\";i:47740;s:12:\"delete-48499\";i:47741;s:12:\"delete-48500\";i:47742;s:12:\"delete-48502\";i:47743;s:12:\"delete-48503\";i:47744;s:12:\"delete-48506\";i:47745;s:12:\"delete-48507\";i:47746;s:12:\"delete-48504\";i:47747;s:12:\"delete-48505\";i:47748;s:12:\"delete-48508\";i:47749;s:12:\"delete-48511\";i:47750;s:12:\"delete-48512\";i:47751;s:12:\"delete-48509\";i:47752;s:12:\"delete-48510\";i:47753;s:12:\"delete-48513\";i:47754;s:12:\"delete-48516\";i:47755;s:12:\"delete-48517\";i:47756;s:12:\"delete-48514\";i:47757;s:12:\"delete-48515\";i:47758;s:12:\"delete-48518\";i:47759;s:12:\"delete-48521\";i:47760;s:12:\"delete-48522\";i:47761;s:12:\"delete-48519\";i:47762;s:12:\"delete-48520\";i:47763;s:12:\"delete-48523\";i:47764;s:12:\"delete-48524\";i:47765;s:12:\"delete-48525\";i:47766;s:12:\"delete-48526\";i:47767;s:12:\"delete-48527\";i:47768;s:12:\"delete-48528\";i:47769;s:12:\"delete-48531\";i:47770;s:12:\"delete-48529\";i:47771;s:12:\"delete-48530\";i:47772;s:12:\"delete-48532\";i:47773;s:12:\"delete-48533\";i:47774;s:12:\"delete-48536\";i:47775;s:12:\"delete-48534\";i:47776;s:12:\"delete-48535\";i:47777;s:12:\"delete-48537\";i:47778;s:12:\"delete-48538\";i:47779;s:12:\"delete-48541\";i:47780;s:12:\"delete-48542\";i:47781;s:12:\"delete-48539\";i:47782;s:12:\"delete-48540\";i:47783;s:12:\"delete-48543\";i:47784;s:12:\"delete-48546\";i:47785;s:12:\"delete-48547\";i:47786;s:12:\"delete-48544\";i:47787;s:12:\"delete-48545\";i:47788;s:12:\"delete-48548\";i:47789;s:12:\"delete-48551\";i:47790;s:12:\"delete-48552\";i:47791;s:12:\"delete-48549\";i:47792;s:12:\"delete-48550\";i:47793;s:12:\"delete-48553\";i:47794;s:12:\"delete-48556\";i:47795;s:12:\"delete-48557\";i:47796;s:12:\"delete-48554\";i:47797;s:12:\"delete-48555\";i:47798;s:12:\"delete-48558\";i:47799;s:12:\"delete-48561\";i:47800;s:12:\"delete-48559\";i:47801;s:12:\"delete-48560\";i:47802;s:12:\"delete-48562\";i:47803;s:12:\"delete-48563\";i:47804;s:12:\"delete-48566\";i:47805;s:12:\"delete-48567\";i:47806;s:12:\"delete-48564\";i:47807;s:12:\"delete-48565\";i:47808;s:12:\"delete-48568\";i:47809;s:12:\"delete-48571\";i:47810;s:12:\"delete-48572\";i:47811;s:12:\"delete-48569\";i:47812;s:12:\"delete-48570\";i:47813;s:12:\"delete-48573\";i:47814;s:12:\"delete-48576\";i:47815;s:12:\"delete-48577\";i:47816;s:12:\"delete-48574\";i:47817;s:12:\"delete-48575\";i:47818;s:12:\"delete-48578\";i:47819;s:12:\"delete-48581\";i:47820;s:12:\"delete-48582\";i:47821;s:12:\"delete-48579\";i:47822;s:12:\"delete-48580\";i:47823;s:12:\"delete-48583\";i:47824;s:12:\"delete-48586\";i:47825;s:12:\"delete-48587\";i:47826;s:12:\"delete-48584\";i:47827;s:12:\"delete-48585\";i:47828;s:12:\"delete-48588\";i:47829;s:12:\"delete-48591\";i:47830;s:12:\"delete-48592\";i:47831;s:12:\"delete-48593\";i:47832;s:12:\"delete-48596\";i:47833;s:12:\"delete-48597\";i:47834;s:12:\"delete-48589\";i:47835;s:12:\"delete-48590\";i:47836;s:12:\"delete-48594\";i:47837;s:12:\"delete-48595\";i:47838;s:12:\"delete-48598\";i:47839;s:12:\"delete-48601\";i:47840;s:12:\"delete-48602\";i:47841;s:12:\"delete-48599\";i:47842;s:12:\"delete-48600\";i:47843;s:12:\"delete-48603\";i:47844;s:12:\"delete-48606\";i:47845;s:12:\"delete-48607\";i:47846;s:12:\"delete-48604\";i:47847;s:12:\"delete-48605\";i:47848;s:12:\"delete-48608\";i:47849;s:12:\"delete-48611\";i:47850;s:12:\"delete-48609\";i:47851;s:12:\"delete-48610\";i:47852;s:12:\"delete-48612\";i:47853;s:12:\"delete-48613\";i:47854;s:12:\"delete-48616\";i:47855;s:12:\"delete-48614\";i:47856;s:12:\"delete-48615\";i:47857;s:12:\"delete-48617\";i:47858;s:12:\"delete-48618\";i:47859;s:12:\"delete-48621\";i:47860;s:12:\"delete-48622\";i:47861;s:12:\"delete-48619\";i:47862;s:12:\"delete-48620\";i:47863;s:12:\"delete-48623\";i:47864;s:12:\"delete-48626\";i:47865;s:12:\"delete-48627\";i:47866;s:12:\"delete-48624\";i:47867;s:12:\"delete-48625\";i:47868;s:12:\"delete-48628\";i:47869;s:12:\"delete-48631\";i:47870;s:12:\"delete-48632\";i:47871;s:12:\"delete-48629\";i:47872;s:12:\"delete-48630\";i:47873;s:12:\"delete-48633\";i:47874;s:12:\"delete-48636\";i:47875;s:12:\"delete-48637\";i:47876;s:12:\"delete-48634\";i:47877;s:12:\"delete-48635\";i:47878;s:12:\"delete-48638\";i:47879;s:12:\"delete-48641\";i:47880;s:12:\"delete-48642\";i:47881;s:12:\"delete-48639\";i:47882;s:12:\"delete-48640\";i:47883;s:12:\"delete-48643\";i:47884;s:12:\"delete-48646\";i:47885;s:12:\"delete-48647\";i:47886;s:12:\"delete-48644\";i:47887;s:12:\"delete-48645\";i:47888;s:12:\"delete-48648\";i:47889;s:12:\"delete-48651\";i:47890;s:12:\"delete-48652\";i:47891;s:12:\"delete-48649\";i:47892;s:12:\"delete-48650\";i:47893;s:12:\"delete-48653\";i:47894;s:12:\"delete-48656\";i:47895;s:12:\"delete-48657\";i:47896;s:12:\"delete-48654\";i:47897;s:12:\"delete-48655\";i:47898;s:12:\"delete-48658\";i:47899;s:12:\"delete-48659\";i:47900;s:12:\"delete-48660\";i:47901;s:12:\"delete-48661\";i:47902;s:12:\"delete-48662\";i:47903;s:12:\"delete-48663\";i:47904;s:12:\"delete-48666\";i:47905;s:12:\"delete-48667\";i:47906;s:12:\"delete-48664\";i:47907;s:12:\"delete-48665\";i:47908;s:12:\"delete-48668\";i:47909;s:12:\"delete-48671\";i:47910;s:12:\"delete-48672\";i:47911;s:12:\"delete-48669\";i:47912;s:12:\"delete-48670\";i:47913;s:12:\"delete-48673\";i:47914;s:12:\"delete-48676\";i:47915;s:12:\"delete-48674\";i:47916;s:12:\"delete-48675\";i:47917;s:12:\"delete-48677\";i:47918;s:12:\"delete-48678\";i:47919;s:12:\"delete-48681\";i:47920;s:12:\"delete-48682\";i:47921;s:12:\"delete-48679\";i:47922;s:12:\"delete-48680\";i:47923;s:12:\"delete-48683\";i:47924;s:12:\"delete-48686\";i:47925;s:12:\"delete-48687\";i:47926;s:12:\"delete-48684\";i:47927;s:12:\"delete-48685\";i:47928;s:12:\"delete-48688\";i:47929;s:12:\"delete-48691\";i:47930;s:12:\"delete-48692\";i:47931;s:12:\"delete-48689\";i:47932;s:12:\"delete-48690\";i:47933;s:12:\"delete-48693\";i:47934;s:12:\"delete-48696\";i:47935;s:12:\"delete-48694\";i:47936;s:12:\"delete-48695\";i:47937;s:12:\"delete-48697\";i:47938;s:12:\"delete-48698\";i:47939;s:12:\"delete-48701\";i:47940;s:12:\"delete-48702\";i:47941;s:12:\"delete-48703\";i:47942;s:12:\"delete-48706\";i:47943;s:12:\"delete-48707\";i:47944;s:12:\"delete-48699\";i:47945;s:12:\"delete-48700\";i:47946;s:12:\"delete-48704\";i:47947;s:12:\"delete-48705\";i:47948;s:12:\"delete-48708\";i:47949;s:12:\"delete-48711\";i:47950;s:12:\"delete-48712\";i:47951;s:12:\"delete-48709\";i:47952;s:12:\"delete-48710\";i:47953;s:12:\"delete-48713\";i:47954;s:12:\"delete-48716\";i:47955;s:12:\"delete-48717\";i:47956;s:12:\"delete-48714\";i:47957;s:12:\"delete-48715\";i:47958;s:12:\"delete-48718\";i:47959;s:12:\"delete-48721\";i:47960;s:12:\"delete-48722\";i:47961;s:12:\"delete-48719\";i:47962;s:12:\"delete-48720\";i:47963;s:12:\"delete-48723\";i:47964;s:12:\"delete-48726\";i:47965;s:12:\"delete-48727\";i:47966;s:12:\"delete-48724\";i:47967;s:12:\"delete-48725\";i:47968;s:12:\"delete-48728\";i:47969;s:12:\"delete-48731\";i:47970;s:12:\"delete-48732\";i:47971;s:12:\"delete-48729\";i:47972;s:12:\"delete-48730\";i:47973;s:12:\"delete-48733\";i:47974;s:12:\"delete-48736\";i:47975;s:12:\"delete-48734\";i:47976;s:12:\"delete-48735\";i:47977;s:12:\"delete-48737\";i:47978;s:12:\"delete-48738\";i:47979;s:12:\"delete-48741\";i:47980;s:12:\"delete-48742\";i:47981;s:12:\"delete-48743\";i:47982;s:12:\"delete-48746\";i:47983;s:12:\"delete-48747\";i:47984;s:12:\"delete-48739\";i:47985;s:12:\"delete-48740\";i:47986;s:12:\"delete-48744\";i:47987;s:12:\"delete-48745\";i:47988;s:12:\"delete-48748\";i:47989;s:12:\"delete-48751\";i:47990;s:12:\"delete-48752\";i:47991;s:12:\"delete-48749\";i:47992;s:12:\"delete-48750\";i:47993;s:12:\"delete-48753\";i:47994;s:12:\"delete-48756\";i:47995;s:12:\"delete-48757\";i:47996;s:12:\"delete-48754\";i:47997;s:12:\"delete-48755\";i:47998;s:12:\"delete-48758\";i:47999;s:12:\"delete-48761\";i:48000;s:12:\"delete-48762\";i:48001;s:12:\"delete-48759\";i:48002;s:12:\"delete-48760\";i:48003;s:12:\"delete-48763\";i:48004;s:12:\"delete-48766\";i:48005;s:12:\"delete-48764\";i:48006;s:12:\"delete-48765\";i:48007;s:12:\"delete-48767\";i:48008;s:12:\"delete-48768\";i:48009;s:12:\"delete-48771\";i:48010;s:12:\"delete-48772\";i:48011;s:12:\"delete-48769\";i:48012;s:12:\"delete-48770\";i:48013;s:12:\"delete-48773\";i:48014;s:12:\"delete-48776\";i:48015;s:12:\"delete-48774\";i:48016;s:12:\"delete-48775\";i:48017;s:12:\"delete-48777\";i:48018;s:12:\"delete-48778\";i:48019;s:12:\"delete-48781\";i:48020;s:12:\"delete-48782\";i:48021;s:12:\"delete-48779\";i:48022;s:12:\"delete-48780\";i:48023;s:12:\"delete-48783\";i:48024;s:12:\"delete-48786\";i:48025;s:12:\"delete-48784\";i:48026;s:12:\"delete-48785\";i:48027;s:12:\"delete-48787\";i:48028;s:12:\"delete-48788\";i:48029;s:12:\"delete-48791\";i:48030;s:12:\"delete-48792\";i:48031;s:12:\"delete-48789\";i:48032;s:12:\"delete-48790\";i:48033;s:12:\"delete-48793\";i:48034;s:12:\"delete-48796\";i:48035;s:12:\"delete-48794\";i:48036;s:12:\"delete-48795\";i:48037;s:12:\"delete-48797\";i:48038;s:12:\"delete-48798\";i:48039;s:12:\"delete-48801\";i:48040;s:12:\"delete-48802\";i:48041;s:12:\"delete-48799\";i:48042;s:12:\"delete-48800\";i:48043;s:12:\"delete-48803\";i:48044;s:12:\"delete-48806\";i:48045;s:12:\"delete-48804\";i:48046;s:12:\"delete-48805\";i:48047;s:12:\"delete-48807\";i:48048;s:12:\"delete-48808\";i:48049;s:12:\"delete-48811\";i:48050;s:12:\"delete-48812\";i:48051;s:12:\"delete-48809\";i:48052;s:12:\"delete-48810\";i:48053;s:12:\"delete-48813\";i:48054;s:12:\"delete-48816\";i:48055;s:12:\"delete-48817\";i:48056;s:12:\"delete-48814\";i:48057;s:12:\"delete-48815\";i:48058;s:12:\"delete-48818\";i:48059;s:12:\"delete-48821\";i:48060;s:12:\"delete-48822\";i:48061;s:12:\"delete-48819\";i:48062;s:12:\"delete-48820\";i:48063;s:12:\"delete-48823\";i:48064;s:12:\"delete-48826\";i:48065;s:12:\"delete-48827\";i:48066;s:12:\"delete-48824\";i:48067;s:12:\"delete-48825\";i:48068;s:12:\"delete-48828\";i:48069;s:12:\"delete-48831\";i:48070;s:12:\"delete-48829\";i:48071;s:12:\"delete-48830\";i:48072;s:12:\"delete-48832\";i:48073;s:12:\"delete-48833\";i:48074;s:12:\"delete-48836\";i:48075;s:12:\"delete-48837\";i:48076;s:12:\"delete-48834\";i:48077;s:12:\"delete-48835\";i:48078;s:12:\"delete-48838\";i:48079;s:12:\"delete-48841\";i:48080;s:12:\"delete-48842\";i:48081;s:12:\"delete-48839\";i:48082;s:12:\"delete-48840\";i:48083;s:12:\"delete-48843\";i:48084;s:12:\"delete-48846\";i:48085;s:12:\"delete-48847\";i:48086;s:12:\"delete-48844\";i:48087;s:12:\"delete-48845\";i:48088;s:12:\"delete-48848\";i:48089;s:12:\"delete-48851\";i:48090;s:12:\"delete-48852\";i:48091;s:12:\"delete-48849\";i:48092;s:12:\"delete-48850\";i:48093;s:12:\"delete-48853\";i:48094;s:12:\"delete-48856\";i:48095;s:12:\"delete-48857\";i:48096;s:12:\"delete-48854\";i:48097;s:12:\"delete-48855\";i:48098;s:12:\"delete-48858\";i:48099;s:12:\"delete-48861\";i:48100;s:12:\"delete-48862\";i:48101;s:12:\"delete-48859\";i:48102;s:12:\"delete-48860\";i:48103;s:12:\"delete-48863\";i:48104;s:12:\"delete-48866\";i:48105;s:12:\"delete-48867\";i:48106;s:12:\"delete-48864\";i:48107;s:12:\"delete-48865\";i:48108;s:12:\"delete-48868\";i:48109;s:12:\"delete-48871\";i:48110;s:12:\"delete-48869\";i:48111;s:12:\"delete-48870\";i:48112;s:12:\"delete-48872\";i:48113;s:12:\"delete-48873\";i:48114;s:12:\"delete-48876\";i:48115;s:12:\"delete-48877\";i:48116;s:12:\"delete-48874\";i:48117;s:12:\"delete-48875\";i:48118;s:12:\"delete-48878\";i:48119;s:12:\"delete-48881\";i:48120;s:12:\"delete-48882\";i:48121;s:12:\"delete-48879\";i:48122;s:12:\"delete-48880\";i:48123;s:12:\"delete-48883\";i:48124;s:12:\"delete-48886\";i:48125;s:12:\"delete-48884\";i:48126;s:12:\"delete-48885\";i:48127;s:12:\"delete-48887\";i:48128;s:12:\"delete-48888\";i:48129;s:12:\"delete-48891\";i:48130;s:12:\"delete-48892\";i:48131;s:12:\"delete-48889\";i:48132;s:12:\"delete-48890\";i:48133;s:12:\"delete-48893\";i:48134;s:12:\"delete-48896\";i:48135;s:12:\"delete-48897\";i:48136;s:12:\"delete-48894\";i:48137;s:12:\"delete-48895\";i:48138;s:12:\"delete-48898\";i:48139;s:12:\"delete-48901\";i:48140;s:12:\"delete-48902\";i:48141;s:12:\"delete-48899\";i:48142;s:12:\"delete-48900\";i:48143;s:12:\"delete-48903\";i:48144;s:12:\"delete-48906\";i:48145;s:12:\"delete-48907\";i:48146;s:12:\"delete-48904\";i:48147;s:12:\"delete-48905\";i:48148;s:12:\"delete-48908\";i:48149;s:12:\"delete-48911\";i:48150;s:12:\"delete-48909\";i:48151;s:12:\"delete-48910\";i:48152;s:12:\"delete-48912\";i:48153;s:12:\"delete-48913\";i:48154;s:12:\"delete-48916\";i:48155;s:12:\"delete-48917\";i:48156;s:12:\"delete-48914\";i:48157;s:12:\"delete-48915\";i:48158;s:12:\"delete-48918\";i:48159;s:12:\"delete-48921\";i:48160;s:12:\"delete-48922\";i:48161;s:12:\"delete-48919\";i:48162;s:12:\"delete-48920\";i:48163;s:12:\"delete-48923\";i:48164;s:12:\"delete-48924\";i:48165;s:12:\"delete-48925\";i:48166;s:12:\"delete-48926\";i:48167;s:12:\"delete-48927\";i:48168;s:12:\"delete-48928\";i:48169;s:12:\"delete-48931\";i:48170;s:12:\"delete-48932\";i:48171;s:12:\"delete-48929\";i:48172;s:12:\"delete-48930\";i:48173;s:12:\"delete-48933\";i:48174;s:12:\"delete-48936\";i:48175;s:12:\"delete-48937\";i:48176;s:12:\"delete-48934\";i:48177;s:12:\"delete-48935\";i:48178;s:12:\"delete-48938\";i:48179;s:12:\"delete-48939\";i:48180;s:12:\"delete-48940\";i:48181;s:12:\"delete-48941\";i:48182;s:12:\"delete-48942\";i:48183;s:12:\"delete-48943\";i:48184;s:12:\"delete-48946\";i:48185;s:12:\"delete-48947\";i:48186;s:12:\"delete-48944\";i:48187;s:12:\"delete-48945\";i:48188;s:12:\"delete-48948\";i:48189;s:12:\"delete-48951\";i:48190;s:12:\"delete-48952\";i:48191;s:12:\"delete-48949\";i:48192;s:12:\"delete-48950\";i:48193;s:12:\"delete-48953\";i:48194;s:12:\"delete-48956\";i:48195;s:12:\"delete-48957\";i:48196;s:12:\"delete-48954\";i:48197;s:12:\"delete-48955\";i:48198;s:12:\"delete-48958\";i:48199;s:12:\"delete-48961\";i:48200;s:12:\"delete-48962\";i:48201;s:12:\"delete-48959\";i:48202;s:12:\"delete-48960\";i:48203;s:12:\"delete-48963\";i:48204;s:12:\"delete-48966\";i:48205;s:12:\"delete-48967\";i:48206;s:12:\"delete-48964\";i:48207;s:12:\"delete-48965\";i:48208;s:12:\"delete-48968\";i:48209;s:12:\"delete-48971\";i:48210;s:12:\"delete-48969\";i:48211;s:12:\"delete-48970\";i:48212;s:12:\"delete-48972\";i:48213;s:12:\"delete-48973\";i:48214;s:12:\"delete-48976\";i:48215;s:12:\"delete-48977\";i:48216;s:12:\"delete-48974\";i:48217;s:12:\"delete-48975\";i:48218;s:12:\"delete-48978\";i:48219;s:12:\"delete-48981\";i:48220;s:12:\"delete-48982\";i:48221;s:12:\"delete-48979\";i:48222;s:12:\"delete-48980\";i:48223;s:12:\"delete-48983\";i:48224;s:12:\"delete-48986\";i:48225;s:12:\"delete-48984\";i:48226;s:12:\"delete-48985\";i:48227;s:12:\"delete-48987\";i:48228;s:12:\"delete-48988\";i:48229;s:12:\"delete-48991\";i:48230;s:12:\"delete-48992\";i:48231;s:12:\"delete-48989\";i:48232;s:12:\"delete-48990\";i:48233;s:12:\"delete-48993\";i:48234;s:12:\"delete-48994\";i:48235;s:12:\"delete-48995\";i:48236;s:12:\"delete-48996\";i:48237;s:12:\"delete-48997\";i:48238;s:12:\"delete-48998\";i:48239;s:12:\"delete-49001\";i:48240;s:12:\"delete-48999\";i:48241;s:12:\"delete-49000\";i:48242;s:12:\"delete-49002\";i:48243;s:12:\"delete-49003\";i:48244;s:12:\"delete-49006\";i:48245;s:12:\"delete-49004\";i:48246;s:12:\"delete-49005\";i:48247;s:12:\"delete-49007\";i:48248;s:12:\"delete-49008\";i:48249;s:12:\"delete-49011\";i:48250;s:12:\"delete-49012\";i:48251;s:12:\"delete-49009\";i:48252;s:12:\"delete-49010\";i:48253;s:12:\"delete-49013\";i:48254;s:12:\"delete-49016\";i:48255;s:12:\"delete-49017\";i:48256;s:12:\"delete-49018\";i:48257;s:12:\"delete-49021\";i:48258;s:12:\"delete-49022\";i:48259;s:12:\"delete-49014\";i:48260;s:12:\"delete-49015\";i:48261;s:12:\"delete-49019\";i:48262;s:12:\"delete-49020\";i:48263;s:12:\"delete-49023\";i:48264;s:12:\"delete-49026\";i:48265;s:12:\"delete-49027\";i:48266;s:12:\"delete-49024\";i:48267;s:12:\"delete-49025\";i:48268;s:12:\"delete-49028\";i:48269;s:12:\"delete-49031\";i:48270;s:12:\"delete-49032\";i:48271;s:12:\"delete-49029\";i:48272;s:12:\"delete-49030\";i:48273;s:12:\"delete-49033\";i:48274;s:12:\"delete-49036\";i:48275;s:12:\"delete-49037\";i:48276;s:12:\"delete-49034\";i:48277;s:12:\"delete-49035\";i:48278;s:12:\"delete-49038\";i:48279;s:12:\"delete-49041\";i:48280;s:12:\"delete-49042\";i:48281;s:12:\"delete-49039\";i:48282;s:12:\"delete-49040\";i:48283;s:12:\"delete-49043\";i:48284;s:12:\"delete-49044\";i:48285;s:12:\"delete-49045\";i:48286;s:12:\"delete-49046\";i:48287;s:12:\"delete-49047\";i:48288;s:12:\"delete-49048\";i:48289;s:12:\"delete-49051\";i:48290;s:12:\"delete-49049\";i:48291;s:12:\"delete-49050\";i:48292;s:12:\"delete-49052\";i:48293;s:12:\"delete-49053\";i:48294;s:12:\"delete-49056\";i:48295;s:12:\"delete-49057\";i:48296;s:12:\"delete-49054\";i:48297;s:12:\"delete-49055\";i:48298;s:12:\"delete-49058\";i:48299;s:12:\"delete-49061\";i:48300;s:12:\"delete-49059\";i:48301;s:12:\"delete-49060\";i:48302;s:12:\"delete-49062\";i:48303;s:12:\"delete-49063\";i:48304;s:12:\"delete-49066\";i:48305;s:12:\"delete-49067\";i:48306;s:12:\"delete-49064\";i:48307;s:12:\"delete-49065\";i:48308;s:12:\"delete-49068\";i:48309;s:12:\"delete-49071\";i:48310;s:12:\"delete-49072\";i:48311;s:12:\"delete-49069\";i:48312;s:12:\"delete-49070\";i:48313;s:12:\"delete-49073\";i:48314;s:12:\"delete-49076\";i:48315;s:12:\"delete-49077\";i:48316;s:12:\"delete-49074\";i:48317;s:12:\"delete-49075\";i:48318;s:12:\"delete-49078\";i:48319;s:12:\"delete-49081\";i:48320;s:12:\"delete-49079\";i:48321;s:12:\"delete-49080\";i:48322;s:12:\"delete-49082\";i:48323;s:12:\"delete-49083\";i:48324;s:12:\"delete-49086\";i:48325;s:12:\"delete-49084\";i:48326;s:12:\"delete-49085\";i:48327;s:12:\"delete-49087\";i:48328;s:12:\"delete-49088\";i:48329;s:12:\"delete-49091\";i:48330;s:12:\"delete-49092\";i:48331;s:12:\"delete-49089\";i:48332;s:12:\"delete-49090\";i:48333;s:12:\"delete-49093\";i:48334;s:12:\"delete-49096\";i:48335;s:12:\"delete-49097\";i:48336;s:12:\"delete-49094\";i:48337;s:12:\"delete-49095\";i:48338;s:12:\"delete-49098\";i:48339;s:12:\"delete-49102\";i:48340;s:12:\"delete-49101\";i:48341;s:12:\"delete-49099\";i:48342;s:12:\"delete-49100\";i:48343;s:12:\"delete-49103\";i:48344;s:12:\"delete-49104\";i:48345;s:12:\"delete-49105\";i:48346;s:12:\"delete-49106\";i:48347;s:12:\"delete-49107\";i:48348;s:12:\"delete-49108\";i:48349;s:12:\"delete-49111\";i:48350;s:12:\"delete-49112\";i:48351;s:12:\"delete-49109\";i:48352;s:12:\"delete-49110\";i:48353;s:12:\"delete-49113\";i:48354;s:12:\"delete-49117\";i:48355;s:12:\"delete-49116\";i:48356;s:12:\"delete-49114\";i:48357;s:12:\"delete-49115\";i:48358;s:12:\"delete-49118\";i:48359;s:12:\"delete-49122\";i:48360;s:12:\"delete-49121\";i:48361;s:12:\"delete-49119\";i:48362;s:12:\"delete-49120\";i:48363;s:12:\"delete-49123\";i:48364;s:12:\"delete-49126\";i:48365;s:12:\"delete-49127\";i:48366;s:12:\"delete-49124\";i:48367;s:12:\"delete-49125\";i:48368;s:12:\"delete-49128\";i:48369;s:12:\"delete-49131\";i:48370;s:12:\"delete-49129\";i:48371;s:12:\"delete-49130\";i:48372;s:12:\"delete-49132\";i:48373;s:12:\"delete-49133\";i:48374;s:12:\"delete-49136\";i:48375;s:12:\"delete-49137\";i:48376;s:12:\"delete-49134\";i:48377;s:12:\"delete-49135\";i:48378;s:12:\"delete-49138\";i:48379;s:12:\"delete-49141\";i:48380;s:12:\"delete-49142\";i:48381;s:12:\"delete-49139\";i:48382;s:12:\"delete-49140\";i:48383;s:12:\"delete-49143\";i:48384;s:12:\"delete-49146\";i:48385;s:12:\"delete-49144\";i:48386;s:12:\"delete-49145\";i:48387;s:12:\"delete-49147\";i:48388;s:12:\"delete-49151\";i:48389;s:12:\"delete-49148\";i:48390;s:12:\"delete-49152\";i:48391;s:12:\"delete-49149\";i:48392;s:12:\"delete-49150\";i:48393;s:12:\"delete-49153\";i:48394;s:12:\"delete-49156\";i:48395;s:12:\"delete-49157\";i:48396;s:12:\"delete-49154\";i:48397;s:12:\"delete-49155\";i:48398;s:12:\"delete-49158\";i:48399;s:12:\"delete-49161\";i:48400;s:12:\"delete-49159\";i:48401;s:12:\"delete-49160\";i:48402;s:12:\"delete-49162\";i:48403;s:12:\"delete-49163\";i:48404;s:12:\"delete-49166\";i:48405;s:12:\"delete-49167\";i:48406;s:12:\"delete-49164\";i:48407;s:12:\"delete-49165\";i:48408;s:12:\"delete-49168\";i:48409;s:12:\"delete-49171\";i:48410;s:12:\"delete-49172\";i:48411;s:12:\"delete-49169\";i:48412;s:12:\"delete-49170\";i:48413;s:12:\"delete-49173\";i:48414;s:12:\"delete-49176\";i:48415;s:12:\"delete-49177\";i:48416;s:12:\"delete-49174\";i:48417;s:12:\"delete-49175\";i:48418;s:12:\"delete-49178\";i:48419;s:12:\"delete-49181\";i:48420;s:12:\"delete-49182\";i:48421;s:12:\"delete-49179\";i:48422;s:12:\"delete-49180\";i:48423;s:12:\"delete-49183\";i:48424;s:12:\"delete-49186\";i:48425;s:12:\"delete-49184\";i:48426;s:12:\"delete-49185\";i:48427;s:12:\"delete-49187\";i:48428;s:12:\"delete-49191\";i:48429;s:12:\"delete-49188\";i:48430;s:12:\"delete-49192\";i:48431;s:12:\"delete-49189\";i:48432;s:12:\"delete-49190\";i:48433;s:12:\"delete-49193\";i:48434;s:12:\"delete-49196\";i:48435;s:12:\"delete-49194\";i:48436;s:12:\"delete-49195\";i:48437;s:12:\"delete-49197\";i:48438;s:12:\"delete-49198\";i:48439;s:12:\"delete-49201\";i:48440;s:12:\"delete-49202\";i:48441;s:12:\"delete-49199\";i:48442;s:12:\"delete-49200\";i:48443;s:12:\"delete-49203\";i:48444;s:12:\"delete-49206\";i:48445;s:12:\"delete-49207\";i:48446;s:12:\"delete-49204\";i:48447;s:12:\"delete-49205\";i:48448;s:12:\"delete-49208\";i:48449;s:12:\"delete-49212\";i:48450;s:12:\"delete-49211\";i:48451;s:12:\"delete-49209\";i:48452;s:12:\"delete-49210\";i:48453;s:12:\"delete-49213\";i:48454;s:12:\"delete-49216\";i:48455;s:12:\"delete-49217\";i:48456;s:12:\"delete-49214\";i:48457;s:12:\"delete-49215\";i:48458;s:12:\"delete-49218\";i:48459;s:12:\"delete-49221\";i:48460;s:12:\"delete-49219\";i:48461;s:12:\"delete-49220\";i:48462;s:12:\"delete-49222\";i:48463;s:12:\"delete-49223\";i:48464;s:12:\"delete-49226\";i:48465;s:12:\"delete-49227\";i:48466;s:12:\"delete-49224\";i:48467;s:12:\"delete-49225\";i:48468;s:12:\"delete-49228\";i:48469;s:12:\"delete-49231\";i:48470;s:12:\"delete-49229\";i:48471;s:12:\"delete-49230\";i:48472;s:12:\"delete-49232\";i:48473;s:12:\"delete-49233\";i:48474;s:12:\"delete-49236\";i:48475;s:12:\"delete-49237\";i:48476;s:12:\"delete-49234\";i:48477;s:12:\"delete-49235\";i:48478;s:12:\"delete-49238\";i:48479;s:12:\"delete-49241\";i:48480;s:12:\"delete-49242\";i:48481;s:12:\"delete-49239\";i:48482;s:12:\"delete-49240\";i:48483;s:12:\"delete-49243\";i:48484;s:12:\"delete-49246\";i:48485;s:12:\"delete-49244\";i:48486;s:12:\"delete-49245\";i:48487;s:12:\"delete-49247\";i:48488;s:12:\"delete-49248\";i:48489;s:12:\"delete-49251\";i:48490;s:12:\"delete-49252\";i:48491;s:12:\"delete-49249\";i:48492;s:12:\"delete-49250\";i:48493;s:12:\"delete-49253\";i:48494;s:12:\"delete-49256\";i:48495;s:12:\"delete-49257\";i:48496;s:12:\"delete-49254\";i:48497;s:12:\"delete-49255\";i:48498;s:12:\"delete-49258\";i:48499;s:12:\"delete-49261\";i:48500;s:12:\"delete-49262\";i:48501;s:12:\"delete-49259\";i:48502;s:12:\"delete-49260\";i:48503;s:12:\"delete-49263\";i:48504;s:12:\"delete-49266\";i:48505;s:12:\"delete-49264\";i:48506;s:12:\"delete-49265\";i:48507;s:12:\"delete-49267\";i:48508;s:12:\"delete-49268\";i:48509;s:12:\"delete-49271\";i:48510;s:12:\"delete-49272\";i:48511;s:12:\"delete-49269\";i:48512;s:12:\"delete-49270\";i:48513;s:12:\"delete-49273\";i:48514;s:12:\"delete-49276\";i:48515;s:12:\"delete-49277\";i:48516;s:12:\"delete-49274\";i:48517;s:12:\"delete-49275\";i:48518;s:12:\"delete-49278\";i:48519;s:12:\"delete-49281\";i:48520;s:12:\"delete-49282\";i:48521;s:12:\"delete-49279\";i:48522;s:12:\"delete-49280\";i:48523;s:12:\"delete-49283\";i:48524;s:12:\"delete-49286\";i:48525;s:12:\"delete-49287\";i:48526;s:12:\"delete-49284\";i:48527;s:12:\"delete-49285\";i:48528;s:12:\"delete-49288\";i:48529;s:12:\"delete-49291\";i:48530;s:12:\"delete-49289\";i:48531;s:12:\"delete-49290\";i:48532;s:12:\"delete-49292\";i:48533;s:12:\"delete-49293\";i:48534;s:12:\"delete-49296\";i:48535;s:12:\"delete-49297\";i:48536;s:12:\"delete-49294\";i:48537;s:12:\"delete-49295\";i:48538;s:12:\"delete-49298\";i:48539;s:12:\"delete-49301\";i:48540;s:12:\"delete-49302\";i:48541;s:12:\"delete-49299\";i:48542;s:12:\"delete-49300\";i:48543;s:12:\"delete-49303\";i:48544;s:12:\"delete-49306\";i:48545;s:12:\"delete-49307\";i:48546;s:12:\"delete-49304\";i:48547;s:12:\"delete-49305\";i:48548;s:12:\"delete-49308\";i:48549;s:12:\"delete-49311\";i:48550;s:12:\"delete-49312\";i:48551;s:12:\"delete-49309\";i:48552;s:12:\"delete-49310\";i:48553;s:12:\"delete-49313\";i:48554;s:12:\"delete-49316\";i:48555;s:12:\"delete-49314\";i:48556;s:12:\"delete-49315\";i:48557;s:12:\"delete-49317\";i:48558;s:12:\"delete-49318\";i:48559;s:12:\"delete-49321\";i:48560;s:12:\"delete-49322\";i:48561;s:12:\"delete-49319\";i:48562;s:12:\"delete-49320\";i:48563;s:12:\"delete-49323\";i:48564;s:12:\"delete-49326\";i:48565;s:12:\"delete-49327\";i:48566;s:12:\"delete-49324\";i:48567;s:12:\"delete-49325\";i:48568;s:12:\"delete-49328\";i:48569;s:12:\"delete-49331\";i:48570;s:12:\"delete-49332\";i:48571;s:12:\"delete-49329\";i:48572;s:12:\"delete-49330\";i:48573;s:12:\"delete-49333\";i:48574;s:12:\"delete-49336\";i:48575;s:12:\"delete-49337\";i:48576;s:12:\"delete-49334\";i:48577;s:12:\"delete-49335\";i:48578;s:12:\"delete-49338\";i:48579;s:12:\"delete-49341\";i:48580;s:12:\"delete-49342\";i:48581;s:12:\"delete-49339\";i:48582;s:12:\"delete-49340\";i:48583;s:12:\"delete-49343\";i:48584;s:12:\"delete-49346\";i:48585;s:12:\"delete-49347\";i:48586;s:12:\"delete-49344\";i:48587;s:12:\"delete-49345\";i:48588;s:12:\"delete-49348\";i:48589;s:12:\"delete-49351\";i:48590;s:12:\"delete-49352\";i:48591;s:12:\"delete-49349\";i:48592;s:12:\"delete-49350\";i:48593;s:12:\"delete-49353\";i:48594;s:12:\"delete-49356\";i:48595;s:12:\"delete-49357\";i:48596;s:12:\"delete-49354\";i:48597;s:12:\"delete-49355\";i:48598;s:12:\"delete-49358\";i:48599;s:12:\"delete-49361\";i:48600;s:12:\"delete-49362\";i:48601;s:12:\"delete-49359\";i:48602;s:12:\"delete-49360\";i:48603;s:12:\"delete-49363\";i:48604;s:12:\"delete-49366\";i:48605;s:12:\"delete-49367\";i:48606;s:12:\"delete-49364\";i:48607;s:12:\"delete-49365\";i:48608;s:12:\"delete-49368\";i:48609;s:12:\"delete-49371\";i:48610;s:12:\"delete-49372\";i:48611;s:12:\"delete-49369\";i:48612;s:12:\"delete-49370\";i:48613;s:12:\"delete-49373\";i:48614;s:12:\"delete-49376\";i:48615;s:12:\"delete-49377\";i:48616;s:12:\"delete-49374\";i:48617;s:12:\"delete-49375\";i:48618;s:12:\"delete-49378\";i:48619;s:12:\"delete-49381\";i:48620;s:12:\"delete-49382\";i:48621;s:12:\"delete-49379\";i:48622;s:12:\"delete-49380\";i:48623;s:12:\"delete-49383\";i:48624;s:12:\"delete-49386\";i:48625;s:12:\"delete-49387\";i:48626;s:12:\"delete-49384\";i:48627;s:12:\"delete-49385\";i:48628;s:12:\"delete-49388\";i:48629;s:12:\"delete-49391\";i:48630;s:12:\"delete-49392\";i:48631;s:12:\"delete-49389\";i:48632;s:12:\"delete-49390\";i:48633;s:12:\"delete-49393\";i:48634;s:12:\"delete-49396\";i:48635;s:12:\"delete-49397\";i:48636;s:12:\"delete-49394\";i:48637;s:12:\"delete-49395\";i:48638;s:12:\"delete-49398\";i:48639;s:12:\"delete-49401\";i:48640;s:12:\"delete-49402\";i:48641;s:12:\"delete-49399\";i:48642;s:12:\"delete-49400\";i:48643;s:12:\"delete-49403\";i:48644;s:12:\"delete-49406\";i:48645;s:12:\"delete-49407\";i:48646;s:12:\"delete-49404\";i:48647;s:12:\"delete-49405\";i:48648;s:12:\"delete-49408\";i:48649;s:12:\"delete-49411\";i:48650;s:12:\"delete-49412\";i:48651;s:12:\"delete-49409\";i:48652;s:12:\"delete-49410\";i:48653;s:12:\"delete-49413\";i:48654;s:12:\"delete-49416\";i:48655;s:12:\"delete-49417\";i:48656;s:12:\"delete-49414\";i:48657;s:12:\"delete-49415\";i:48658;s:12:\"delete-49418\";i:48659;s:12:\"delete-49421\";i:48660;s:12:\"delete-49422\";i:48661;s:12:\"delete-49419\";i:48662;s:12:\"delete-49420\";i:48663;s:12:\"delete-49423\";i:48664;s:12:\"delete-49426\";i:48665;s:12:\"delete-49427\";i:48666;s:12:\"delete-49424\";i:48667;s:12:\"delete-49425\";i:48668;s:12:\"delete-49428\";i:48669;s:12:\"delete-49431\";i:48670;s:12:\"delete-49432\";i:48671;s:12:\"delete-49429\";i:48672;s:12:\"delete-49430\";i:48673;s:12:\"delete-49433\";i:48674;s:12:\"delete-49436\";i:48675;s:12:\"delete-49437\";i:48676;s:12:\"delete-49434\";i:48677;s:12:\"delete-49435\";i:48678;s:12:\"delete-49438\";i:48679;s:12:\"delete-49441\";i:48680;s:12:\"delete-49439\";i:48681;s:12:\"delete-49440\";i:48682;s:12:\"delete-49442\";i:48683;s:12:\"delete-49443\";i:48684;s:12:\"delete-49446\";i:48685;s:12:\"delete-49447\";i:48686;s:12:\"delete-49444\";i:48687;s:12:\"delete-49445\";i:48688;s:12:\"delete-49448\";i:48689;s:12:\"delete-49451\";i:48690;s:12:\"delete-49452\";i:48691;s:12:\"delete-49449\";i:48692;s:12:\"delete-49450\";i:48693;s:12:\"delete-49453\";i:48694;s:12:\"delete-49456\";i:48695;s:12:\"delete-49457\";i:48696;s:12:\"delete-49454\";i:48697;s:12:\"delete-49455\";i:48698;s:12:\"delete-49458\";i:48699;s:12:\"delete-49461\";i:48700;s:12:\"delete-49462\";i:48701;s:12:\"delete-49459\";i:48702;s:12:\"delete-49460\";i:48703;s:12:\"delete-49463\";i:48704;s:12:\"delete-49466\";i:48705;s:12:\"delete-49467\";i:48706;s:12:\"delete-49464\";i:48707;s:12:\"delete-49465\";i:48708;s:12:\"delete-49468\";i:48709;s:12:\"delete-49471\";i:48710;s:12:\"delete-49472\";i:48711;s:12:\"delete-49469\";i:48712;s:12:\"delete-49470\";i:48713;s:12:\"delete-49473\";i:48714;s:12:\"delete-49476\";i:48715;s:12:\"delete-49477\";i:48716;s:12:\"delete-49474\";i:48717;s:12:\"delete-49475\";i:48718;s:12:\"delete-49478\";i:48719;s:12:\"delete-49481\";i:48720;s:12:\"delete-49482\";i:48721;s:12:\"delete-49479\";i:48722;s:12:\"delete-49480\";i:48723;s:12:\"delete-49483\";i:48724;s:12:\"delete-49486\";i:48725;s:12:\"delete-49487\";i:48726;s:12:\"delete-49484\";i:48727;s:12:\"delete-49485\";i:48728;s:12:\"delete-49488\";i:48729;s:12:\"delete-49491\";i:48730;s:12:\"delete-49492\";i:48731;s:12:\"delete-49489\";i:48732;s:12:\"delete-49490\";i:48733;s:12:\"delete-49493\";i:48734;s:12:\"delete-49496\";i:48735;s:12:\"delete-49497\";i:48736;s:12:\"delete-49494\";i:48737;s:12:\"delete-49495\";i:48738;s:12:\"delete-49498\";i:48739;s:12:\"delete-49501\";i:48740;s:12:\"delete-49502\";i:48741;s:12:\"delete-49499\";i:48742;s:12:\"delete-49500\";i:48743;s:12:\"delete-49503\";i:48744;s:12:\"delete-49506\";i:48745;s:12:\"delete-49507\";i:48746;s:12:\"delete-49504\";i:48747;s:12:\"delete-49505\";i:48748;s:12:\"delete-49508\";i:48749;s:12:\"delete-49511\";i:48750;s:12:\"delete-49512\";i:48751;s:12:\"delete-49509\";i:48752;s:12:\"delete-49510\";i:48753;s:12:\"delete-49513\";i:48754;s:12:\"delete-49516\";i:48755;s:12:\"delete-49517\";i:48756;s:12:\"delete-49514\";i:48757;s:12:\"delete-49515\";i:48758;s:12:\"delete-49518\";i:48759;s:12:\"delete-49521\";i:48760;s:12:\"delete-49522\";i:48761;s:12:\"delete-49519\";i:48762;s:12:\"delete-49520\";i:48763;s:12:\"delete-49523\";i:48764;s:12:\"delete-49526\";i:48765;s:12:\"delete-49527\";i:48766;s:12:\"delete-49524\";i:48767;s:12:\"delete-49525\";i:48768;s:12:\"delete-49528\";i:48769;s:12:\"delete-49531\";i:48770;s:12:\"delete-49532\";i:48771;s:12:\"delete-49529\";i:48772;s:12:\"delete-49530\";i:48773;s:12:\"delete-49533\";i:48774;s:12:\"delete-49536\";i:48775;s:12:\"delete-49537\";i:48776;s:12:\"delete-49534\";i:48777;s:12:\"delete-49535\";i:48778;s:12:\"delete-49538\";i:48779;s:12:\"delete-49541\";i:48780;s:12:\"delete-49542\";i:48781;s:12:\"delete-49539\";i:48782;s:12:\"delete-49540\";i:48783;s:12:\"delete-49543\";i:48784;s:12:\"delete-49546\";i:48785;s:12:\"delete-49544\";i:48786;s:12:\"delete-49545\";i:48787;s:12:\"delete-49547\";i:48788;s:12:\"delete-49548\";i:48789;s:12:\"delete-49551\";i:48790;s:12:\"delete-49552\";i:48791;s:12:\"delete-49549\";i:48792;s:12:\"delete-49550\";i:48793;s:12:\"delete-49553\";i:48794;s:12:\"delete-49556\";i:48795;s:12:\"delete-49554\";i:48796;s:12:\"delete-49555\";i:48797;s:12:\"delete-49557\";i:48798;s:12:\"delete-49558\";i:48799;s:12:\"delete-49561\";i:48800;s:12:\"delete-49562\";i:48801;s:12:\"delete-49559\";i:48802;s:12:\"delete-49560\";i:48803;s:12:\"delete-49563\";i:48804;s:12:\"delete-49566\";i:48805;s:12:\"delete-49567\";i:48806;s:12:\"delete-49564\";i:48807;s:12:\"delete-49565\";i:48808;s:12:\"delete-49568\";i:48809;s:12:\"delete-49571\";i:48810;s:12:\"delete-49569\";i:48811;s:12:\"delete-49570\";i:48812;s:12:\"delete-49572\";i:48813;s:12:\"delete-49573\";i:48814;s:12:\"delete-49576\";i:48815;s:12:\"delete-49577\";i:48816;s:12:\"delete-49574\";i:48817;s:12:\"delete-49575\";i:48818;s:12:\"delete-49578\";i:48819;s:12:\"delete-49581\";i:48820;s:12:\"delete-49582\";i:48821;s:12:\"delete-49579\";i:48822;s:12:\"delete-49580\";i:48823;s:12:\"delete-49583\";i:48824;s:12:\"delete-49586\";i:48825;s:12:\"delete-49584\";i:48826;s:12:\"delete-49585\";i:48827;s:12:\"delete-49587\";i:48828;s:12:\"delete-49588\";i:48829;s:12:\"delete-49591\";i:48830;s:12:\"delete-49592\";i:48831;s:12:\"delete-49589\";i:48832;s:12:\"delete-49590\";i:48833;s:12:\"delete-49593\";i:48834;s:12:\"delete-49596\";i:48835;s:12:\"delete-49597\";i:48836;s:12:\"delete-49594\";i:48837;s:12:\"delete-49595\";i:48838;s:12:\"delete-49598\";i:48839;s:12:\"delete-49601\";i:48840;s:12:\"delete-49602\";i:48841;s:12:\"delete-49599\";i:48842;s:12:\"delete-49600\";i:48843;s:12:\"delete-49603\";i:48844;s:12:\"delete-49606\";i:48845;s:12:\"delete-49607\";i:48846;s:12:\"delete-49604\";i:48847;s:12:\"delete-49605\";i:48848;s:12:\"delete-49608\";i:48849;s:12:\"delete-49611\";i:48850;s:12:\"delete-49609\";i:48851;s:12:\"delete-49610\";i:48852;s:12:\"delete-49612\";i:48853;s:12:\"delete-49613\";i:48854;s:12:\"delete-49616\";i:48855;s:12:\"delete-49617\";i:48856;s:12:\"delete-49614\";i:48857;s:12:\"delete-49615\";i:48858;s:12:\"delete-49618\";i:48859;s:12:\"delete-49619\";i:48860;s:12:\"delete-49620\";i:48861;s:12:\"delete-49621\";i:48862;s:12:\"delete-49622\";i:48863;s:12:\"delete-49623\";i:48864;s:12:\"delete-49626\";i:48865;s:12:\"delete-49627\";i:48866;s:12:\"delete-49624\";i:48867;s:12:\"delete-49625\";i:48868;s:12:\"delete-49628\";i:48869;s:12:\"delete-49631\";i:48870;s:12:\"delete-49632\";i:48871;s:12:\"delete-49629\";i:48872;s:12:\"delete-49630\";i:48873;s:12:\"delete-49633\";i:48874;s:12:\"delete-49636\";i:48875;s:12:\"delete-49637\";i:48876;s:12:\"delete-49634\";i:48877;s:12:\"delete-49635\";i:48878;s:12:\"delete-49638\";i:48879;s:12:\"delete-49641\";i:48880;s:12:\"delete-49642\";i:48881;s:12:\"delete-49639\";i:48882;s:12:\"delete-49640\";i:48883;s:12:\"delete-49643\";i:48884;s:12:\"delete-49646\";i:48885;s:12:\"delete-49647\";i:48886;s:12:\"delete-49644\";i:48887;s:12:\"delete-49645\";i:48888;s:12:\"delete-49648\";i:48889;s:12:\"delete-49651\";i:48890;s:12:\"delete-49652\";i:48891;s:12:\"delete-49649\";i:48892;s:12:\"delete-49650\";i:48893;s:12:\"delete-49653\";i:48894;s:12:\"delete-49656\";i:48895;s:12:\"delete-49657\";i:48896;s:12:\"delete-49654\";i:48897;s:12:\"delete-49655\";i:48898;s:12:\"delete-49658\";i:48899;s:12:\"delete-49661\";i:48900;s:12:\"delete-49662\";i:48901;s:12:\"delete-49659\";i:48902;s:12:\"delete-49660\";i:48903;s:12:\"delete-49663\";i:48904;s:12:\"delete-49666\";i:48905;s:12:\"delete-49667\";i:48906;s:12:\"delete-49664\";i:48907;s:12:\"delete-49665\";i:48908;s:12:\"delete-49668\";i:48909;s:12:\"delete-49671\";i:48910;s:12:\"delete-49672\";i:48911;s:12:\"delete-49669\";i:48912;s:12:\"delete-49670\";i:48913;s:12:\"delete-49673\";i:48914;s:12:\"delete-49676\";i:48915;s:12:\"delete-49677\";i:48916;s:12:\"delete-49674\";i:48917;s:12:\"delete-49675\";i:48918;s:12:\"delete-49678\";i:48919;s:12:\"delete-49681\";i:48920;s:12:\"delete-49679\";i:48921;s:12:\"delete-49680\";i:48922;s:12:\"delete-49682\";i:48923;s:12:\"delete-49683\";i:48924;s:12:\"delete-49686\";i:48925;s:12:\"delete-49687\";i:48926;s:12:\"delete-49684\";i:48927;s:12:\"delete-49685\";i:48928;s:12:\"delete-49688\";i:48929;s:12:\"delete-49691\";i:48930;s:12:\"delete-49692\";i:48931;s:12:\"delete-49689\";i:48932;s:12:\"delete-49690\";i:48933;s:12:\"delete-49693\";i:48934;s:12:\"delete-49696\";i:48935;s:12:\"delete-49697\";i:48936;s:12:\"delete-49694\";i:48937;s:12:\"delete-49695\";i:48938;s:12:\"delete-49698\";i:48939;s:12:\"delete-49701\";i:48940;s:12:\"delete-49702\";i:48941;s:12:\"delete-49699\";i:48942;s:12:\"delete-49700\";i:48943;s:12:\"delete-49703\";i:48944;s:12:\"delete-49706\";i:48945;s:12:\"delete-49707\";i:48946;s:12:\"delete-49704\";i:48947;s:12:\"delete-49705\";i:48948;s:12:\"delete-49708\";i:48949;s:12:\"delete-49711\";i:48950;s:12:\"delete-49712\";i:48951;s:12:\"delete-49709\";i:48952;s:12:\"delete-49710\";i:48953;s:12:\"delete-49713\";i:48954;s:12:\"delete-49716\";i:48955;s:12:\"delete-49717\";i:48956;s:12:\"delete-49714\";i:48957;s:12:\"delete-49715\";i:48958;s:12:\"delete-49718\";i:48959;s:12:\"delete-49721\";i:48960;s:12:\"delete-49722\";i:48961;s:12:\"delete-49719\";i:48962;s:12:\"delete-49720\";i:48963;s:12:\"delete-49723\";i:48964;s:12:\"delete-49726\";i:48965;s:12:\"delete-49727\";i:48966;s:12:\"delete-49724\";i:48967;s:12:\"delete-49725\";i:48968;s:12:\"delete-49728\";i:48969;s:12:\"delete-49731\";i:48970;s:12:\"delete-49732\";i:48971;s:12:\"delete-49729\";i:48972;s:12:\"delete-49730\";i:48973;s:12:\"delete-49733\";i:48974;s:12:\"delete-49736\";i:48975;s:12:\"delete-49737\";i:48976;s:12:\"delete-49734\";i:48977;s:12:\"delete-49735\";i:48978;s:12:\"delete-49738\";i:48979;s:12:\"delete-49741\";i:48980;s:12:\"delete-49742\";i:48981;s:12:\"delete-49739\";i:48982;s:12:\"delete-49740\";i:48983;s:12:\"delete-49743\";i:48984;s:12:\"delete-49746\";i:48985;s:12:\"delete-49747\";i:48986;s:12:\"delete-49744\";i:48987;s:12:\"delete-49745\";i:48988;s:12:\"delete-49748\";i:48989;s:12:\"delete-49751\";i:48990;s:12:\"delete-49752\";i:48991;s:12:\"delete-49749\";i:48992;s:12:\"delete-49750\";i:48993;s:12:\"delete-49753\";i:48994;s:12:\"delete-49756\";i:48995;s:12:\"delete-49757\";i:48996;s:12:\"delete-49754\";i:48997;s:12:\"delete-49755\";i:48998;s:12:\"delete-49758\";i:48999;s:12:\"delete-49761\";i:49000;s:12:\"delete-49762\";i:49001;s:12:\"delete-49759\";i:49002;s:12:\"delete-49760\";i:49003;s:12:\"delete-49763\";i:49004;s:12:\"delete-49766\";i:49005;s:12:\"delete-49767\";i:49006;s:12:\"delete-49764\";i:49007;s:12:\"delete-49765\";i:49008;s:12:\"delete-49768\";i:49009;s:12:\"delete-49771\";i:49010;s:12:\"delete-49769\";i:49011;s:12:\"delete-49770\";i:49012;s:12:\"delete-49772\";i:49013;s:12:\"delete-49773\";i:49014;s:12:\"delete-49776\";i:49015;s:12:\"delete-49777\";i:49016;s:12:\"delete-49774\";i:49017;s:12:\"delete-49775\";i:49018;s:12:\"delete-49778\";i:49019;s:12:\"delete-49781\";i:49020;s:12:\"delete-49782\";i:49021;s:12:\"delete-49779\";i:49022;s:12:\"delete-49780\";i:49023;s:12:\"delete-49783\";i:49024;s:12:\"delete-49786\";i:49025;s:12:\"delete-49787\";i:49026;s:12:\"delete-49784\";i:49027;s:12:\"delete-49785\";i:49028;s:12:\"delete-49788\";i:49029;s:12:\"delete-49791\";i:49030;s:12:\"delete-49792\";i:49031;s:12:\"delete-49789\";i:49032;s:12:\"delete-49790\";i:49033;s:12:\"delete-49793\";i:49034;s:12:\"delete-49796\";i:49035;s:12:\"delete-49797\";i:49036;s:12:\"delete-49794\";i:49037;s:12:\"delete-49795\";i:49038;s:12:\"delete-49798\";i:49039;s:12:\"delete-49801\";i:49040;s:12:\"delete-49802\";i:49041;s:12:\"delete-49799\";i:49042;s:12:\"delete-49800\";i:49043;s:12:\"delete-49803\";i:49044;s:12:\"delete-49806\";i:49045;s:12:\"delete-49807\";i:49046;s:12:\"delete-49804\";i:49047;s:12:\"delete-49805\";i:49048;s:12:\"delete-49808\";i:49049;s:12:\"delete-49811\";i:49050;s:12:\"delete-49809\";i:49051;s:12:\"delete-49810\";i:49052;s:12:\"delete-49812\";i:49053;s:12:\"delete-49813\";i:49054;s:12:\"delete-49816\";i:49055;s:12:\"delete-49817\";i:49056;s:12:\"delete-49814\";i:49057;s:12:\"delete-49815\";i:49058;s:12:\"delete-49818\";i:49059;s:12:\"delete-49821\";i:49060;s:12:\"delete-49822\";i:49061;s:12:\"delete-49819\";i:49062;s:12:\"delete-49820\";i:49063;s:12:\"delete-49823\";i:49064;s:12:\"delete-49826\";i:49065;s:12:\"delete-49827\";i:49066;s:12:\"delete-49824\";i:49067;s:12:\"delete-49825\";i:49068;s:12:\"delete-49828\";i:49069;s:12:\"delete-49831\";i:49070;s:12:\"delete-49832\";i:49071;s:12:\"delete-49829\";i:49072;s:12:\"delete-49830\";i:49073;s:12:\"delete-49833\";i:49074;s:12:\"delete-49836\";i:49075;s:12:\"delete-49837\";i:49076;s:12:\"delete-49834\";i:49077;s:12:\"delete-49835\";i:49078;s:12:\"delete-49838\";i:49079;s:12:\"delete-49841\";i:49080;s:12:\"delete-49839\";i:49081;s:12:\"delete-49840\";i:49082;s:12:\"delete-49842\";i:49083;s:12:\"delete-49843\";i:49084;s:12:\"delete-49846\";i:49085;s:12:\"delete-49847\";i:49086;s:12:\"delete-49844\";i:49087;s:12:\"delete-49845\";i:49088;s:12:\"delete-49848\";i:49089;s:12:\"delete-49851\";i:49090;s:12:\"delete-49852\";i:49091;s:12:\"delete-49849\";i:49092;s:12:\"delete-49850\";i:49093;s:12:\"delete-49853\";i:49094;s:12:\"delete-49856\";i:49095;s:12:\"delete-49857\";i:49096;s:12:\"delete-49854\";i:49097;s:12:\"delete-49855\";i:49098;s:12:\"delete-49858\";i:49099;s:12:\"delete-49861\";i:49100;s:12:\"delete-49862\";i:49101;s:12:\"delete-49859\";i:49102;s:12:\"delete-49860\";i:49103;s:12:\"delete-49863\";i:49104;s:12:\"delete-49866\";i:49105;s:12:\"delete-49867\";i:49106;s:12:\"delete-49864\";i:49107;s:12:\"delete-49865\";i:49108;s:12:\"delete-49868\";i:49109;s:12:\"delete-49871\";i:49110;s:12:\"delete-49869\";i:49111;s:12:\"delete-49870\";i:49112;s:12:\"delete-49872\";i:49113;s:12:\"delete-49873\";i:49114;s:12:\"delete-49876\";i:49115;s:12:\"delete-49877\";i:49116;s:12:\"delete-49874\";i:49117;s:12:\"delete-49875\";i:49118;s:12:\"delete-49878\";i:49119;s:12:\"delete-49881\";i:49120;s:12:\"delete-49882\";i:49121;s:12:\"delete-49879\";i:49122;s:12:\"delete-49880\";i:49123;s:12:\"delete-49883\";i:49124;s:12:\"delete-49886\";i:49125;s:12:\"delete-49884\";i:49126;s:12:\"delete-49885\";i:49127;s:12:\"delete-49887\";i:49128;s:12:\"delete-49888\";i:49129;s:12:\"delete-49891\";i:49130;s:12:\"delete-49892\";i:49131;s:12:\"delete-49889\";i:49132;s:12:\"delete-49890\";i:49133;s:12:\"delete-49893\";i:49134;s:12:\"delete-49896\";i:49135;s:12:\"delete-49897\";i:49136;s:12:\"delete-49894\";i:49137;s:12:\"delete-49895\";i:49138;s:12:\"delete-49898\";i:49139;s:12:\"delete-49901\";i:49140;s:12:\"delete-49902\";i:49141;s:12:\"delete-49899\";i:49142;s:12:\"delete-49900\";i:49143;s:12:\"delete-49903\";i:49144;s:12:\"delete-49906\";i:49145;s:12:\"delete-49907\";i:49146;s:12:\"delete-49904\";i:49147;s:12:\"delete-49905\";i:49148;s:12:\"delete-49908\";i:49149;s:12:\"delete-49911\";i:49150;s:12:\"delete-49912\";i:49151;s:12:\"delete-49909\";i:49152;s:12:\"delete-49910\";i:49153;s:12:\"delete-49913\";i:49154;s:12:\"delete-49916\";i:49155;s:12:\"delete-49914\";i:49156;s:12:\"delete-49915\";i:49157;s:12:\"delete-49917\";i:49158;s:12:\"delete-49918\";i:49159;s:12:\"delete-49921\";i:49160;s:12:\"delete-49922\";i:49161;s:12:\"delete-49919\";i:49162;s:12:\"delete-49920\";i:49163;s:12:\"delete-49923\";i:49164;s:12:\"delete-49926\";i:49165;s:12:\"delete-49927\";i:49166;s:12:\"delete-49924\";i:49167;s:12:\"delete-49925\";i:49168;s:12:\"delete-49928\";i:49169;s:12:\"delete-49931\";i:49170;s:12:\"delete-49932\";i:49171;s:12:\"delete-49929\";i:49172;s:12:\"delete-49930\";i:49173;s:12:\"delete-49933\";i:49174;s:12:\"delete-49936\";i:49175;s:12:\"delete-49937\";i:49176;s:12:\"delete-49934\";i:49177;s:12:\"delete-49935\";i:49178;s:12:\"delete-49938\";i:49179;s:12:\"delete-49941\";i:49180;s:12:\"delete-49942\";i:49181;s:12:\"delete-49939\";i:49182;s:12:\"delete-49940\";i:49183;s:12:\"delete-49943\";i:49184;s:12:\"delete-49946\";i:49185;s:12:\"delete-49947\";i:49186;s:12:\"delete-49944\";i:49187;s:12:\"delete-49945\";i:49188;s:12:\"delete-49948\";i:49189;s:12:\"delete-49951\";i:49190;s:12:\"delete-49949\";i:49191;s:12:\"delete-49950\";i:49192;s:12:\"delete-49952\";i:49193;s:12:\"delete-49953\";i:49194;s:12:\"delete-49956\";i:49195;s:12:\"delete-49957\";i:49196;s:12:\"delete-49954\";i:49197;s:12:\"delete-49955\";i:49198;s:12:\"delete-49958\";i:49199;s:12:\"delete-49961\";i:49200;s:12:\"delete-49962\";i:49201;s:12:\"delete-49959\";i:49202;s:12:\"delete-49960\";i:49203;s:12:\"delete-49963\";i:49204;s:12:\"delete-49966\";i:49205;s:12:\"delete-49967\";i:49206;s:12:\"delete-49964\";i:49207;s:12:\"delete-49965\";i:49208;s:12:\"delete-49968\";i:49209;s:12:\"delete-49971\";i:49210;s:12:\"delete-49972\";i:49211;s:12:\"delete-49969\";i:49212;s:12:\"delete-49970\";i:49213;s:12:\"delete-49973\";i:49214;s:12:\"delete-49976\";i:49215;s:12:\"delete-49977\";i:49216;s:12:\"delete-49974\";i:49217;s:12:\"delete-49975\";i:49218;s:12:\"delete-49978\";i:49219;s:12:\"delete-49981\";i:49220;s:12:\"delete-49982\";i:49221;s:12:\"delete-49979\";i:49222;s:12:\"delete-49980\";i:49223;s:12:\"delete-49983\";i:49224;s:12:\"delete-49986\";i:49225;s:12:\"delete-49987\";i:49226;s:12:\"delete-49984\";i:49227;s:12:\"delete-49985\";i:49228;s:12:\"delete-49988\";i:49229;s:12:\"delete-49991\";i:49230;s:12:\"delete-49992\";i:49231;s:12:\"delete-49989\";i:49232;s:12:\"delete-49990\";i:49233;s:12:\"delete-49993\";i:49234;s:12:\"delete-49996\";i:49235;s:12:\"delete-49994\";i:49236;s:12:\"delete-49995\";i:49237;s:12:\"delete-49997\";i:49238;s:12:\"delete-49998\";i:49239;s:12:\"delete-50001\";i:49240;s:12:\"delete-50002\";i:49241;s:12:\"delete-49999\";i:49242;s:12:\"delete-50000\";i:49243;s:12:\"delete-50003\";i:49244;s:12:\"delete-50006\";i:49245;s:12:\"delete-50007\";i:49246;s:12:\"delete-50004\";i:49247;s:12:\"delete-50005\";i:49248;s:12:\"delete-50008\";i:49249;s:12:\"delete-50011\";i:49250;s:12:\"delete-50012\";i:49251;s:12:\"delete-50009\";i:49252;s:12:\"delete-50010\";i:49253;s:12:\"delete-50013\";i:49254;s:12:\"delete-50016\";i:49255;s:12:\"delete-50017\";i:49256;s:12:\"delete-50014\";i:49257;s:12:\"delete-50015\";i:49258;s:12:\"delete-50018\";i:49259;s:12:\"delete-50021\";i:49260;s:12:\"delete-50022\";i:49261;s:12:\"delete-50019\";i:49262;s:12:\"delete-50020\";i:49263;s:12:\"delete-50023\";i:49264;s:12:\"delete-50026\";i:49265;s:12:\"delete-50027\";i:49266;s:12:\"delete-50024\";i:49267;s:12:\"delete-50025\";i:49268;s:12:\"delete-50028\";i:49269;s:12:\"delete-50031\";i:49270;s:12:\"delete-50032\";i:49271;s:12:\"delete-50029\";i:49272;s:12:\"delete-50030\";i:49273;s:12:\"delete-50033\";i:49274;s:12:\"delete-50036\";i:49275;s:12:\"delete-50037\";i:49276;s:12:\"delete-50034\";i:49277;s:12:\"delete-50035\";i:49278;s:12:\"delete-50038\";i:49279;s:12:\"delete-50041\";i:49280;s:12:\"delete-50042\";i:49281;s:12:\"delete-50039\";i:49282;s:12:\"delete-50040\";i:49283;s:12:\"delete-50043\";i:49284;s:12:\"delete-50046\";i:49285;s:12:\"delete-50047\";i:49286;s:12:\"delete-50044\";i:49287;s:12:\"delete-50045\";i:49288;s:12:\"delete-50048\";i:49289;s:12:\"delete-50051\";i:49290;s:12:\"delete-50052\";i:49291;s:12:\"delete-50049\";i:49292;s:12:\"delete-50050\";i:49293;s:12:\"delete-50053\";i:49294;s:12:\"delete-50056\";i:49295;s:12:\"delete-50057\";i:49296;s:12:\"delete-50054\";i:49297;s:12:\"delete-50055\";i:49298;s:12:\"delete-50058\";i:49299;s:12:\"delete-50061\";i:49300;s:12:\"delete-50062\";i:49301;s:12:\"delete-50059\";i:49302;s:12:\"delete-50060\";i:49303;s:12:\"delete-50063\";i:49304;s:12:\"delete-50066\";i:49305;s:12:\"delete-50067\";i:49306;s:12:\"delete-50064\";i:49307;s:12:\"delete-50065\";i:49308;s:12:\"delete-50068\";i:49309;s:12:\"delete-50071\";i:49310;s:12:\"delete-50072\";i:49311;s:12:\"delete-50069\";i:49312;s:12:\"delete-50070\";i:49313;s:12:\"delete-50073\";i:49314;s:12:\"delete-50076\";i:49315;s:12:\"delete-50077\";i:49316;s:12:\"delete-50074\";i:49317;s:12:\"delete-50075\";i:49318;s:12:\"delete-50078\";i:49319;s:12:\"delete-50081\";i:49320;s:12:\"delete-50082\";i:49321;s:12:\"delete-50079\";i:49322;s:12:\"delete-50080\";i:49323;s:12:\"delete-50083\";i:49324;s:12:\"delete-50086\";i:49325;s:12:\"delete-50087\";i:49326;s:12:\"delete-50084\";i:49327;s:12:\"delete-50085\";i:49328;s:12:\"delete-50088\";i:49329;s:12:\"delete-50091\";i:49330;s:12:\"delete-50092\";i:49331;s:12:\"delete-50089\";i:49332;s:12:\"delete-50090\";i:49333;s:12:\"delete-50093\";i:49334;s:12:\"delete-50096\";i:49335;s:12:\"delete-50097\";i:49336;s:12:\"delete-50094\";i:49337;s:12:\"delete-50095\";i:49338;s:12:\"delete-50098\";i:49339;s:12:\"delete-50101\";i:49340;s:12:\"delete-50102\";i:49341;s:12:\"delete-50099\";i:49342;s:12:\"delete-50100\";i:49343;s:12:\"delete-50103\";i:49344;s:12:\"delete-50106\";i:49345;s:12:\"delete-50107\";i:49346;s:12:\"delete-50104\";i:49347;s:12:\"delete-50105\";i:49348;s:12:\"delete-50108\";i:49349;s:12:\"delete-50111\";i:49350;s:12:\"delete-50112\";i:49351;s:12:\"delete-50109\";i:49352;s:12:\"delete-50110\";i:49353;s:12:\"delete-50113\";i:49354;s:12:\"delete-50116\";i:49355;s:12:\"delete-50117\";i:49356;s:12:\"delete-50114\";i:49357;s:12:\"delete-50115\";i:49358;s:12:\"delete-50118\";i:49359;s:12:\"delete-50121\";i:49360;s:12:\"delete-50122\";i:49361;s:12:\"delete-50119\";i:49362;s:12:\"delete-50120\";i:49363;s:12:\"delete-50123\";i:49364;s:12:\"delete-50126\";i:49365;s:12:\"delete-50127\";i:49366;s:12:\"delete-50124\";i:49367;s:12:\"delete-50125\";i:49368;s:12:\"delete-50128\";i:49369;s:12:\"delete-50131\";i:49370;s:12:\"delete-50132\";i:49371;s:12:\"delete-50129\";i:49372;s:12:\"delete-50130\";i:49373;s:12:\"delete-50133\";i:49374;s:12:\"delete-50136\";i:49375;s:12:\"delete-50137\";i:49376;s:12:\"delete-50134\";i:49377;s:12:\"delete-50135\";i:49378;s:12:\"delete-50138\";i:49379;s:12:\"delete-50141\";i:49380;s:12:\"delete-50139\";i:49381;s:12:\"delete-50140\";i:49382;s:12:\"delete-50142\";i:49383;s:12:\"delete-50143\";i:49384;s:12:\"delete-50146\";i:49385;s:12:\"delete-50147\";i:49386;s:12:\"delete-50144\";i:49387;s:12:\"delete-50145\";i:49388;s:12:\"delete-50148\";i:49389;s:12:\"delete-50151\";i:49390;s:12:\"delete-50152\";i:49391;s:12:\"delete-50149\";i:49392;s:12:\"delete-50150\";i:49393;s:12:\"delete-50153\";i:49394;s:12:\"delete-50156\";i:49395;s:12:\"delete-50157\";i:49396;s:12:\"delete-50154\";i:49397;s:12:\"delete-50155\";i:49398;s:12:\"delete-50158\";i:49399;s:12:\"delete-50161\";i:49400;s:12:\"delete-50159\";i:49401;s:12:\"delete-50160\";i:49402;s:12:\"delete-50162\";i:49403;s:12:\"delete-50163\";i:49404;s:12:\"delete-50166\";i:49405;s:12:\"delete-50167\";i:49406;s:12:\"delete-50164\";i:49407;s:12:\"delete-50165\";i:49408;s:12:\"delete-50168\";i:49409;s:12:\"delete-50171\";i:49410;s:12:\"delete-50172\";i:49411;s:12:\"delete-50169\";i:49412;s:12:\"delete-50170\";i:49413;s:12:\"delete-50173\";i:49414;s:12:\"delete-50176\";i:49415;s:12:\"delete-50177\";i:49416;s:12:\"delete-50174\";i:49417;s:12:\"delete-50175\";i:49418;s:12:\"delete-50178\";i:49419;s:12:\"delete-50181\";i:49420;s:12:\"delete-50182\";i:49421;s:12:\"delete-50179\";i:49422;s:12:\"delete-50180\";i:49423;s:12:\"delete-50183\";i:49424;s:12:\"delete-50186\";i:49425;s:12:\"delete-50187\";i:49426;s:12:\"delete-50184\";i:49427;s:12:\"delete-50185\";i:49428;s:12:\"delete-50188\";i:49429;s:12:\"delete-50191\";i:49430;s:12:\"delete-50189\";i:49431;s:12:\"delete-50190\";i:49432;s:12:\"delete-50192\";i:49433;s:12:\"delete-50193\";i:49434;s:12:\"delete-50196\";i:49435;s:12:\"delete-50197\";i:49436;s:12:\"delete-50194\";i:49437;s:12:\"delete-50195\";i:49438;s:12:\"delete-50198\";i:49439;s:12:\"delete-50201\";i:49440;s:12:\"delete-50202\";i:49441;s:12:\"delete-50199\";i:49442;s:12:\"delete-50200\";i:49443;s:12:\"delete-50203\";i:49444;s:12:\"delete-50206\";i:49445;s:12:\"delete-50207\";i:49446;s:12:\"delete-50204\";i:49447;s:12:\"delete-50205\";i:49448;s:12:\"delete-50208\";i:49449;s:12:\"delete-50211\";i:49450;s:12:\"delete-50209\";i:49451;s:12:\"delete-50210\";i:49452;s:12:\"delete-50212\";i:49453;s:12:\"delete-50213\";i:49454;s:12:\"delete-50216\";i:49455;s:12:\"delete-50217\";i:49456;s:12:\"delete-50214\";i:49457;s:12:\"delete-50215\";i:49458;s:12:\"delete-50218\";i:49459;s:12:\"delete-50221\";i:49460;s:12:\"delete-50222\";i:49461;s:12:\"delete-50219\";i:49462;s:12:\"delete-50220\";i:49463;s:12:\"delete-50223\";i:49464;s:12:\"delete-50226\";i:49465;s:12:\"delete-50227\";i:49466;s:12:\"delete-50224\";i:49467;s:12:\"delete-50225\";i:49468;s:12:\"delete-50228\";i:49469;s:12:\"delete-50229\";i:49470;s:12:\"delete-50230\";i:49471;s:12:\"delete-50231\";i:49472;s:12:\"delete-50232\";i:49473;s:12:\"delete-50233\";i:49474;s:12:\"delete-50236\";i:49475;s:12:\"delete-50237\";i:49476;s:12:\"delete-50234\";i:49477;s:12:\"delete-50235\";i:49478;s:12:\"delete-50238\";i:49479;s:12:\"delete-50241\";i:49480;s:12:\"delete-50242\";i:49481;s:12:\"delete-50239\";i:49482;s:12:\"delete-50240\";i:49483;s:12:\"delete-50243\";i:49484;s:12:\"delete-50246\";i:49485;s:12:\"delete-50247\";i:49486;s:12:\"delete-50244\";i:49487;s:12:\"delete-50245\";i:49488;s:12:\"delete-50248\";i:49489;s:12:\"delete-50251\";i:49490;s:12:\"delete-50252\";i:49491;s:12:\"delete-50249\";i:49492;s:12:\"delete-50250\";i:49493;s:12:\"delete-50253\";i:49494;s:12:\"delete-50256\";i:49495;s:12:\"delete-50257\";i:49496;s:12:\"delete-50254\";i:49497;s:12:\"delete-50255\";i:49498;s:12:\"delete-50258\";i:49499;s:12:\"delete-50261\";i:49500;s:12:\"delete-50262\";i:49501;s:12:\"delete-50259\";i:49502;s:12:\"delete-50260\";i:49503;s:12:\"delete-50263\";i:49504;s:12:\"delete-50266\";i:49505;s:12:\"delete-50264\";i:49506;s:12:\"delete-50265\";i:49507;s:12:\"delete-50267\";i:49508;s:12:\"delete-50268\";i:49509;s:12:\"delete-50271\";i:49510;s:12:\"delete-50272\";i:49511;s:12:\"delete-50269\";i:49512;s:12:\"delete-50270\";i:49513;s:12:\"delete-50273\";i:49514;s:12:\"delete-50276\";i:49515;s:12:\"delete-50277\";i:49516;s:12:\"delete-50274\";i:49517;s:12:\"delete-50275\";i:49518;s:12:\"delete-50278\";i:49519;s:12:\"delete-50281\";i:49520;s:12:\"delete-50282\";i:49521;s:12:\"delete-50279\";i:49522;s:12:\"delete-50280\";i:49523;s:12:\"delete-50283\";i:49524;s:12:\"delete-50286\";i:49525;s:12:\"delete-50287\";i:49526;s:12:\"delete-50284\";i:49527;s:12:\"delete-50285\";i:49528;s:12:\"delete-50288\";i:49529;s:12:\"delete-50291\";i:49530;s:12:\"delete-50289\";i:49531;s:12:\"delete-50290\";i:49532;s:12:\"delete-50292\";i:49533;s:12:\"delete-50293\";i:49534;s:12:\"delete-50296\";i:49535;s:12:\"delete-50297\";i:49536;s:12:\"delete-50294\";i:49537;s:12:\"delete-50295\";i:49538;s:12:\"delete-50298\";i:49539;s:12:\"delete-50301\";i:49540;s:12:\"delete-50302\";i:49541;s:12:\"delete-50299\";i:49542;s:12:\"delete-50300\";i:49543;s:12:\"delete-50303\";i:49544;s:12:\"delete-50306\";i:49545;s:12:\"delete-50307\";i:49546;s:12:\"delete-50304\";i:49547;s:12:\"delete-50305\";i:49548;s:12:\"delete-50308\";i:49549;s:12:\"delete-50311\";i:49550;s:12:\"delete-50309\";i:49551;s:12:\"delete-50310\";i:49552;s:12:\"delete-50312\";i:49553;s:12:\"delete-50313\";i:49554;s:12:\"delete-50316\";i:49555;s:12:\"delete-50317\";i:49556;s:12:\"delete-50314\";i:49557;s:12:\"delete-50315\";i:49558;s:12:\"delete-50318\";i:49559;s:12:\"delete-50321\";i:49560;s:12:\"delete-50322\";i:49561;s:12:\"delete-50319\";i:49562;s:12:\"delete-50320\";i:49563;s:12:\"delete-50323\";i:49564;s:12:\"delete-50326\";i:49565;s:12:\"delete-50327\";i:49566;s:12:\"delete-50324\";i:49567;s:12:\"delete-50325\";i:49568;s:12:\"delete-50328\";i:49569;s:12:\"delete-50331\";i:49570;s:12:\"delete-50332\";i:49571;s:12:\"delete-50329\";i:49572;s:12:\"delete-50330\";i:49573;s:12:\"delete-50333\";i:49574;s:12:\"delete-50336\";i:49575;s:12:\"delete-50337\";i:49576;s:12:\"delete-50334\";i:49577;s:12:\"delete-50335\";i:49578;s:12:\"delete-50338\";i:49579;s:12:\"delete-50341\";i:49580;s:12:\"delete-50342\";i:49581;s:12:\"delete-50339\";i:49582;s:12:\"delete-50340\";i:49583;s:12:\"delete-50343\";i:49584;s:12:\"delete-50346\";i:49585;s:12:\"delete-50347\";i:49586;s:12:\"delete-50344\";i:49587;s:12:\"delete-50345\";i:49588;s:12:\"delete-50348\";i:49589;s:12:\"delete-50351\";i:49590;s:12:\"delete-50352\";i:49591;s:12:\"delete-50349\";i:49592;s:12:\"delete-50350\";i:49593;s:12:\"delete-50353\";i:49594;s:12:\"delete-50356\";i:49595;s:12:\"delete-50357\";i:49596;s:12:\"delete-50354\";i:49597;s:12:\"delete-50355\";i:49598;s:12:\"delete-50358\";i:49599;s:12:\"delete-50361\";i:49600;s:12:\"delete-50362\";i:49601;s:12:\"delete-50359\";i:49602;s:12:\"delete-50360\";i:49603;s:12:\"delete-50363\";i:49604;s:12:\"delete-50366\";i:49605;s:12:\"delete-50367\";i:49606;s:12:\"delete-50364\";i:49607;s:12:\"delete-50365\";i:49608;s:12:\"delete-50368\";i:49609;s:12:\"delete-50371\";i:49610;s:12:\"delete-50372\";i:49611;s:12:\"delete-50369\";i:49612;s:12:\"delete-50370\";i:49613;s:12:\"delete-50373\";i:49614;s:12:\"delete-50376\";i:49615;s:12:\"delete-50377\";i:49616;s:12:\"delete-50374\";i:49617;s:12:\"delete-50375\";i:49618;s:12:\"delete-50378\";i:49619;s:12:\"delete-50381\";i:49620;s:12:\"delete-50382\";i:49621;s:12:\"delete-50379\";i:49622;s:12:\"delete-50380\";i:49623;s:12:\"delete-50383\";i:49624;s:12:\"delete-50386\";i:49625;s:12:\"delete-50387\";i:49626;s:12:\"delete-50384\";i:49627;s:12:\"delete-50385\";i:49628;s:12:\"delete-50388\";i:49629;s:12:\"delete-50391\";i:49630;s:12:\"delete-50392\";i:49631;s:12:\"delete-50389\";i:49632;s:12:\"delete-50390\";i:49633;s:12:\"delete-50393\";i:49634;s:12:\"delete-50396\";i:49635;s:12:\"delete-50397\";i:49636;s:12:\"delete-50394\";i:49637;s:12:\"delete-50395\";i:49638;s:12:\"delete-50398\";i:49639;s:12:\"delete-50401\";i:49640;s:12:\"delete-50402\";i:49641;s:12:\"delete-50399\";i:49642;s:12:\"delete-50400\";i:49643;s:12:\"delete-50403\";i:49644;s:12:\"delete-50406\";i:49645;s:12:\"delete-50407\";i:49646;s:12:\"delete-50404\";i:49647;s:12:\"delete-50405\";i:49648;s:12:\"delete-50408\";i:49649;s:12:\"delete-50411\";i:49650;s:12:\"delete-50412\";i:49651;s:12:\"delete-50409\";i:49652;s:12:\"delete-50410\";i:49653;s:12:\"delete-50413\";i:49654;s:12:\"delete-50416\";i:49655;s:12:\"delete-50414\";i:49656;s:12:\"delete-50415\";i:49657;s:12:\"delete-50417\";i:49658;s:12:\"delete-50418\";i:49659;s:12:\"delete-50421\";i:49660;s:12:\"delete-50422\";i:49661;s:12:\"delete-50419\";i:49662;s:12:\"delete-50420\";i:49663;s:12:\"delete-50423\";i:49664;s:12:\"delete-50426\";i:49665;s:12:\"delete-50427\";i:49666;s:12:\"delete-50424\";i:49667;s:12:\"delete-50425\";i:49668;s:12:\"delete-50428\";i:49669;s:12:\"delete-50429\";i:49670;s:12:\"delete-50430\";i:49671;s:12:\"delete-50431\";i:49672;s:12:\"delete-50432\";i:49673;s:12:\"delete-50433\";i:49674;s:12:\"delete-50436\";i:49675;s:12:\"delete-50437\";i:49676;s:12:\"delete-50434\";i:49677;s:12:\"delete-50435\";i:49678;s:12:\"delete-50438\";i:49679;s:12:\"delete-50441\";i:49680;s:12:\"delete-50442\";i:49681;s:12:\"delete-50439\";i:49682;s:12:\"delete-50440\";i:49683;s:12:\"delete-50443\";i:49684;s:12:\"delete-50446\";i:49685;s:12:\"delete-50447\";i:49686;s:12:\"delete-50444\";i:49687;s:12:\"delete-50445\";i:49688;s:12:\"delete-50448\";i:49689;s:12:\"delete-50451\";i:49690;s:12:\"delete-50449\";i:49691;s:12:\"delete-50450\";i:49692;s:12:\"delete-50452\";i:49693;s:12:\"delete-50453\";i:49694;s:12:\"delete-50456\";i:49695;s:12:\"delete-50457\";i:49696;s:12:\"delete-50454\";i:49697;s:12:\"delete-50455\";i:49698;s:12:\"delete-50458\";i:49699;s:12:\"delete-50461\";i:49700;s:12:\"delete-50462\";i:49701;s:12:\"delete-50459\";i:49702;s:12:\"delete-50460\";i:49703;s:12:\"delete-50463\";i:49704;s:12:\"delete-50466\";i:49705;s:12:\"delete-50467\";i:49706;s:12:\"delete-50464\";i:49707;s:12:\"delete-50465\";i:49708;s:12:\"delete-50468\";i:49709;s:12:\"delete-50471\";i:49710;s:12:\"delete-50472\";i:49711;s:12:\"delete-50469\";i:49712;s:12:\"delete-50470\";i:49713;s:12:\"delete-50473\";i:49714;s:12:\"delete-50476\";i:49715;s:12:\"delete-50477\";i:49716;s:12:\"delete-50474\";i:49717;s:12:\"delete-50475\";i:49718;s:12:\"delete-50478\";i:49719;s:12:\"delete-50481\";i:49720;s:12:\"delete-50482\";i:49721;s:12:\"delete-50479\";i:49722;s:12:\"delete-50480\";i:49723;s:12:\"delete-50483\";i:49724;s:12:\"delete-50486\";i:49725;s:12:\"delete-50487\";i:49726;s:12:\"delete-50484\";i:49727;s:12:\"delete-50485\";i:49728;s:12:\"delete-50488\";i:49729;s:12:\"delete-50491\";i:49730;s:12:\"delete-50489\";i:49731;s:12:\"delete-50490\";i:49732;s:12:\"delete-50492\";i:49733;s:12:\"delete-50493\";i:49734;s:12:\"delete-50496\";i:49735;s:12:\"delete-50497\";i:49736;s:12:\"delete-50494\";i:49737;s:12:\"delete-50495\";i:49738;s:12:\"delete-50498\";i:49739;s:12:\"delete-50501\";i:49740;s:12:\"delete-50502\";i:49741;s:12:\"delete-50499\";i:49742;s:12:\"delete-50500\";i:49743;s:12:\"delete-50503\";i:49744;s:12:\"delete-50506\";i:49745;s:12:\"delete-50507\";i:49746;s:12:\"delete-50504\";i:49747;s:12:\"delete-50505\";i:49748;s:12:\"delete-50508\";i:49749;s:12:\"delete-50511\";i:49750;s:12:\"delete-50512\";i:49751;s:12:\"delete-50509\";i:49752;s:12:\"delete-50510\";i:49753;s:12:\"delete-50513\";i:49754;s:12:\"delete-50516\";i:49755;s:12:\"delete-50517\";i:49756;s:12:\"delete-50514\";i:49757;s:12:\"delete-50515\";i:49758;s:12:\"delete-50518\";i:49759;s:12:\"delete-50521\";i:49760;s:12:\"delete-50519\";i:49761;s:12:\"delete-50520\";i:49762;s:12:\"delete-50522\";i:49763;s:12:\"delete-50523\";i:49764;s:12:\"delete-50526\";i:49765;s:12:\"delete-50527\";i:49766;s:12:\"delete-50524\";i:49767;s:12:\"delete-50525\";i:49768;s:12:\"delete-50528\";i:49769;s:12:\"delete-50531\";i:49770;s:12:\"delete-50529\";i:49771;s:12:\"delete-50530\";i:49772;s:12:\"delete-50532\";i:49773;s:12:\"delete-50533\";i:49774;s:12:\"delete-50536\";i:49775;s:12:\"delete-50537\";i:49776;s:12:\"delete-50534\";i:49777;s:12:\"delete-50535\";i:49778;s:12:\"delete-50538\";i:49779;s:12:\"delete-50541\";i:49780;s:12:\"delete-50542\";i:49781;s:12:\"delete-50539\";i:49782;s:12:\"delete-50540\";i:49783;s:12:\"delete-50543\";i:49784;s:12:\"delete-50546\";i:49785;s:12:\"delete-50547\";i:49786;s:12:\"delete-50544\";i:49787;s:12:\"delete-50545\";i:49788;s:12:\"delete-50548\";i:49789;s:12:\"delete-50551\";i:49790;s:12:\"delete-50552\";i:49791;s:12:\"delete-50549\";i:49792;s:12:\"delete-50550\";i:49793;s:12:\"delete-50553\";i:49794;s:12:\"delete-50556\";i:49795;s:12:\"delete-50554\";i:49796;s:12:\"delete-50555\";i:49797;s:12:\"delete-50557\";i:49798;s:12:\"delete-50558\";i:49799;s:12:\"delete-50561\";i:49800;s:12:\"delete-50562\";i:49801;s:12:\"delete-50559\";i:49802;s:12:\"delete-50560\";i:49803;s:12:\"delete-50563\";i:49804;s:12:\"delete-50564\";i:49805;s:12:\"delete-50565\";i:49806;s:12:\"delete-50566\";i:49807;s:12:\"delete-50567\";i:49808;s:12:\"delete-50568\";i:49809;s:12:\"delete-50571\";i:49810;s:12:\"delete-50572\";i:49811;s:12:\"delete-50569\";i:49812;s:12:\"delete-50570\";i:49813;s:12:\"delete-50573\";i:49814;s:12:\"delete-50576\";i:49815;s:12:\"delete-50577\";i:49816;s:12:\"delete-50574\";i:49817;s:12:\"delete-50575\";i:49818;s:12:\"delete-50578\";i:49819;s:12:\"delete-50581\";i:49820;s:12:\"delete-50582\";i:49821;s:12:\"delete-50579\";i:49822;s:12:\"delete-50580\";i:49823;s:12:\"delete-50583\";i:49824;s:12:\"delete-50586\";i:49825;s:12:\"delete-50584\";i:49826;s:12:\"delete-50585\";i:49827;s:12:\"delete-50587\";i:49828;s:12:\"delete-50588\";i:49829;s:12:\"delete-50591\";i:49830;s:12:\"delete-50592\";i:49831;s:12:\"delete-50589\";i:49832;s:12:\"delete-50590\";i:49833;s:12:\"delete-50593\";i:49834;s:12:\"delete-50596\";i:49835;s:12:\"delete-50597\";i:49836;s:12:\"delete-50594\";i:49837;s:12:\"delete-50595\";i:49838;s:12:\"delete-50598\";i:49839;s:12:\"delete-50601\";i:49840;s:12:\"delete-50602\";i:49841;s:12:\"delete-50599\";i:49842;s:12:\"delete-50600\";i:49843;s:12:\"delete-50603\";i:49844;s:12:\"delete-50606\";i:49845;s:12:\"delete-50607\";i:49846;s:12:\"delete-50604\";i:49847;s:12:\"delete-50605\";i:49848;s:12:\"delete-50608\";i:49849;s:12:\"delete-50611\";i:49850;s:12:\"delete-50612\";i:49851;s:12:\"delete-50609\";i:49852;s:12:\"delete-50610\";i:49853;s:12:\"delete-50613\";i:49854;s:12:\"delete-50616\";i:49855;s:12:\"delete-50617\";i:49856;s:12:\"delete-50614\";i:49857;s:12:\"delete-50615\";i:49858;s:12:\"delete-50618\";i:49859;s:12:\"delete-50621\";i:49860;s:12:\"delete-50622\";i:49861;s:12:\"delete-50619\";i:49862;s:12:\"delete-50620\";i:49863;s:12:\"delete-50623\";i:49864;s:12:\"delete-50626\";i:49865;s:12:\"delete-50624\";i:49866;s:12:\"delete-50625\";i:49867;s:12:\"delete-50627\";i:49868;s:12:\"delete-50628\";i:49869;s:12:\"delete-50631\";i:49870;s:12:\"delete-50632\";i:49871;s:12:\"delete-50629\";i:49872;s:12:\"delete-50630\";i:49873;s:12:\"delete-50633\";i:49874;s:12:\"delete-50636\";i:49875;s:12:\"delete-50637\";i:49876;s:12:\"delete-50634\";i:49877;s:12:\"delete-50635\";i:49878;s:12:\"delete-50638\";i:49879;s:12:\"delete-50641\";i:49880;s:12:\"delete-50642\";i:49881;s:12:\"delete-50639\";i:49882;s:12:\"delete-50640\";i:49883;s:12:\"delete-50643\";i:49884;s:12:\"delete-50646\";i:49885;s:12:\"delete-50644\";i:49886;s:12:\"delete-50645\";i:49887;s:12:\"delete-50647\";i:49888;s:12:\"delete-50648\";i:49889;s:12:\"delete-50651\";i:49890;s:12:\"delete-50649\";i:49891;s:12:\"delete-50650\";i:49892;s:12:\"delete-50652\";i:49893;s:12:\"delete-50653\";i:49894;s:12:\"delete-50656\";i:49895;s:12:\"delete-50657\";i:49896;s:12:\"delete-50654\";i:49897;s:12:\"delete-50655\";i:49898;s:12:\"delete-50658\";i:49899;s:12:\"delete-50661\";i:49900;s:12:\"delete-50662\";i:49901;s:12:\"delete-50659\";i:49902;s:12:\"delete-50660\";i:49903;s:12:\"delete-50663\";i:49904;s:12:\"delete-50666\";i:49905;s:12:\"delete-50667\";i:49906;s:12:\"delete-50664\";i:49907;s:12:\"delete-50665\";i:49908;s:12:\"delete-50668\";i:49909;s:12:\"delete-50671\";i:49910;s:12:\"delete-50672\";i:49911;s:12:\"delete-50669\";i:49912;s:12:\"delete-50670\";i:49913;s:12:\"delete-50673\";i:49914;s:12:\"delete-50676\";i:49915;s:12:\"delete-50677\";i:49916;s:12:\"delete-50674\";i:49917;s:12:\"delete-50675\";i:49918;s:12:\"delete-50678\";i:49919;s:12:\"delete-50681\";i:49920;s:12:\"delete-50682\";i:49921;s:12:\"delete-50679\";i:49922;s:12:\"delete-50680\";i:49923;s:12:\"delete-50683\";i:49924;s:12:\"delete-50686\";i:49925;s:12:\"delete-50687\";i:49926;s:12:\"delete-50684\";i:49927;s:12:\"delete-50685\";i:49928;s:12:\"delete-50688\";i:49929;s:12:\"delete-50691\";i:49930;s:12:\"delete-50689\";i:49931;s:12:\"delete-50690\";i:49932;s:12:\"delete-50692\";i:49933;s:12:\"delete-50693\";i:49934;s:12:\"delete-50696\";i:49935;s:12:\"delete-50697\";i:49936;s:12:\"delete-50694\";i:49937;s:12:\"delete-50695\";i:49938;s:12:\"delete-50698\";i:49939;s:12:\"delete-50701\";i:49940;s:12:\"delete-50702\";i:49941;s:12:\"delete-50699\";i:49942;s:12:\"delete-50700\";i:49943;s:12:\"delete-50703\";i:49944;s:12:\"delete-50706\";i:49945;s:12:\"delete-50707\";i:49946;s:12:\"delete-50704\";i:49947;s:12:\"delete-50705\";i:49948;s:12:\"delete-50708\";i:49949;s:12:\"delete-50711\";i:49950;s:12:\"delete-50712\";i:49951;s:12:\"delete-50709\";i:49952;s:12:\"delete-50710\";i:49953;s:12:\"delete-50713\";i:49954;s:12:\"delete-50716\";i:49955;s:12:\"delete-50717\";i:49956;s:12:\"delete-50714\";i:49957;s:12:\"delete-50715\";i:49958;s:12:\"delete-50718\";i:49959;s:12:\"delete-50721\";i:49960;s:12:\"delete-50722\";i:49961;s:12:\"delete-50719\";i:49962;s:12:\"delete-50720\";i:49963;s:12:\"delete-50723\";i:49964;s:12:\"delete-50726\";i:49965;s:12:\"delete-50724\";i:49966;s:12:\"delete-50725\";i:49967;s:12:\"delete-50727\";i:49968;s:12:\"delete-50728\";i:49969;s:12:\"delete-50731\";i:49970;s:12:\"delete-50732\";i:49971;s:12:\"delete-50729\";i:49972;s:12:\"delete-50730\";i:49973;s:12:\"delete-50733\";i:49974;s:12:\"delete-50736\";i:49975;s:12:\"delete-50737\";i:49976;s:12:\"delete-50734\";i:49977;s:12:\"delete-50735\";i:49978;s:12:\"delete-50738\";i:49979;s:12:\"delete-50741\";i:49980;s:12:\"delete-50742\";i:49981;s:12:\"delete-50739\";i:49982;s:12:\"delete-50740\";i:49983;s:12:\"delete-50743\";i:49984;s:12:\"delete-50746\";i:49985;s:12:\"delete-50744\";i:49986;s:12:\"delete-50745\";i:49987;s:12:\"delete-50747\";i:49988;s:12:\"delete-50748\";i:49989;s:12:\"delete-50751\";i:49990;s:12:\"delete-50752\";i:49991;s:12:\"delete-50749\";i:49992;s:12:\"delete-50750\";i:49993;s:12:\"delete-50753\";i:49994;s:12:\"delete-50756\";i:49995;s:12:\"delete-50754\";i:49996;s:12:\"delete-50755\";i:49997;s:12:\"delete-50757\";i:49998;s:12:\"delete-50758\";i:49999;s:12:\"delete-50761\";i:50000;s:12:\"delete-50762\";i:50001;s:12:\"delete-50759\";i:50002;s:12:\"delete-50760\";i:50003;s:12:\"delete-50763\";i:50004;s:12:\"delete-50766\";i:50005;s:12:\"delete-50767\";i:50006;s:12:\"delete-50764\";i:50007;s:12:\"delete-50765\";i:50008;s:12:\"delete-50768\";i:50009;s:12:\"delete-50771\";i:50010;s:12:\"delete-50772\";i:50011;s:12:\"delete-50769\";i:50012;s:12:\"delete-50770\";i:50013;s:12:\"delete-50773\";i:50014;s:12:\"delete-50776\";i:50015;s:12:\"delete-50777\";i:50016;s:12:\"delete-50774\";i:50017;s:12:\"delete-50775\";i:50018;s:12:\"delete-50778\";i:50019;s:12:\"delete-50781\";i:50020;s:12:\"delete-50782\";i:50021;s:12:\"delete-50779\";i:50022;s:12:\"delete-50780\";i:50023;s:12:\"delete-50783\";i:50024;s:12:\"delete-50786\";i:50025;s:12:\"delete-50787\";i:50026;s:12:\"delete-50784\";i:50027;s:12:\"delete-50785\";i:50028;s:12:\"delete-50788\";i:50029;s:12:\"delete-50791\";i:50030;s:12:\"delete-50792\";i:50031;s:12:\"delete-50789\";i:50032;s:12:\"delete-50790\";i:50033;s:12:\"delete-50793\";i:50034;s:12:\"delete-50796\";i:50035;s:12:\"delete-50797\";i:50036;s:12:\"delete-50794\";i:50037;s:12:\"delete-50795\";i:50038;s:12:\"delete-50798\";i:50039;s:12:\"delete-50801\";i:50040;s:12:\"delete-50802\";i:50041;s:12:\"delete-50799\";i:50042;s:12:\"delete-50800\";i:50043;s:12:\"delete-50803\";i:50044;s:12:\"delete-50806\";i:50045;s:12:\"delete-50807\";i:50046;s:12:\"delete-50804\";i:50047;s:12:\"delete-50805\";i:50048;s:12:\"delete-50808\";i:50049;s:12:\"delete-50811\";i:50050;s:12:\"delete-50812\";i:50051;s:12:\"delete-50809\";i:50052;s:12:\"delete-50810\";i:50053;s:12:\"delete-50813\";i:50054;s:12:\"delete-50816\";i:50055;s:12:\"delete-50817\";i:50056;s:12:\"delete-50814\";i:50057;s:12:\"delete-50815\";i:50058;s:12:\"delete-50818\";i:50059;s:12:\"delete-50821\";i:50060;s:12:\"delete-50822\";i:50061;s:12:\"delete-50819\";i:50062;s:12:\"delete-50820\";i:50063;s:12:\"delete-50823\";i:50064;s:12:\"delete-50826\";i:50065;s:12:\"delete-50827\";i:50066;s:12:\"delete-50824\";i:50067;s:12:\"delete-50825\";i:50068;s:12:\"delete-50828\";i:50069;s:12:\"delete-50831\";i:50070;s:12:\"delete-50829\";i:50071;s:12:\"delete-50830\";i:50072;s:12:\"delete-50832\";i:50073;s:12:\"delete-50833\";i:50074;s:12:\"delete-50836\";i:50075;s:12:\"delete-50837\";i:50076;s:12:\"delete-50834\";i:50077;s:12:\"delete-50835\";i:50078;s:12:\"delete-50838\";i:50079;s:12:\"delete-50841\";i:50080;s:12:\"delete-50842\";i:50081;s:12:\"delete-50839\";i:50082;s:12:\"delete-50840\";i:50083;s:12:\"delete-50843\";i:50084;s:12:\"delete-50846\";i:50085;s:12:\"delete-50847\";i:50086;s:12:\"delete-50844\";i:50087;s:12:\"delete-50845\";i:50088;s:12:\"delete-50848\";i:50089;s:12:\"delete-50851\";i:50090;s:12:\"delete-50849\";i:50091;s:12:\"delete-50850\";i:50092;s:12:\"delete-50852\";i:50093;s:12:\"delete-50853\";i:50094;s:12:\"delete-50856\";i:50095;s:12:\"delete-50857\";i:50096;s:12:\"delete-50854\";i:50097;s:12:\"delete-50855\";i:50098;s:12:\"delete-50858\";i:50099;s:12:\"delete-50861\";i:50100;s:12:\"delete-50862\";i:50101;s:12:\"delete-50859\";i:50102;s:12:\"delete-50860\";i:50103;s:12:\"delete-50863\";i:50104;s:12:\"delete-50866\";i:50105;s:12:\"delete-50867\";i:50106;s:12:\"delete-50864\";i:50107;s:12:\"delete-50865\";i:50108;s:12:\"delete-50868\";i:50109;s:12:\"delete-50871\";i:50110;s:12:\"delete-50872\";i:50111;s:12:\"delete-50869\";i:50112;s:12:\"delete-50870\";i:50113;s:12:\"delete-50873\";i:50114;s:12:\"delete-50876\";i:50115;s:12:\"delete-50877\";i:50116;s:12:\"delete-50874\";i:50117;s:12:\"delete-50875\";i:50118;s:12:\"delete-50878\";i:50119;s:12:\"delete-50881\";i:50120;s:12:\"delete-50882\";i:50121;s:12:\"delete-50879\";i:50122;s:12:\"delete-50880\";i:50123;s:12:\"delete-50883\";i:50124;s:12:\"delete-50886\";i:50125;s:12:\"delete-50887\";i:50126;s:12:\"delete-50884\";i:50127;s:12:\"delete-50885\";i:50128;s:12:\"delete-50888\";i:50129;s:12:\"delete-50891\";i:50130;s:12:\"delete-50892\";i:50131;s:12:\"delete-50889\";i:50132;s:12:\"delete-50890\";i:50133;s:12:\"delete-50893\";i:50134;s:12:\"delete-50896\";i:50135;s:12:\"delete-50897\";i:50136;s:12:\"delete-50894\";i:50137;s:12:\"delete-50895\";i:50138;s:12:\"delete-50898\";i:50139;s:12:\"delete-50901\";i:50140;s:12:\"delete-50902\";i:50141;s:12:\"delete-50899\";i:50142;s:12:\"delete-50900\";i:50143;s:12:\"delete-50903\";i:50144;s:12:\"delete-50906\";i:50145;s:12:\"delete-50907\";i:50146;s:12:\"delete-50904\";i:50147;s:12:\"delete-50905\";i:50148;s:12:\"delete-50908\";i:50149;s:12:\"delete-50911\";i:50150;s:12:\"delete-50912\";i:50151;s:12:\"delete-50909\";i:50152;s:12:\"delete-50910\";i:50153;s:12:\"delete-50913\";i:50154;s:12:\"delete-50916\";i:50155;s:12:\"delete-50917\";i:50156;s:12:\"delete-50914\";i:50157;s:12:\"delete-50915\";i:50158;s:12:\"delete-50918\";i:50159;s:12:\"delete-50921\";i:50160;s:12:\"delete-50919\";i:50161;s:12:\"delete-50920\";i:50162;s:12:\"delete-50922\";i:50163;s:12:\"delete-50923\";i:50164;s:12:\"delete-50926\";i:50165;s:12:\"delete-50927\";i:50166;s:12:\"delete-50924\";i:50167;s:12:\"delete-50925\";i:50168;s:12:\"delete-50928\";i:50169;s:12:\"delete-50931\";i:50170;s:12:\"delete-50932\";i:50171;s:12:\"delete-50929\";i:50172;s:12:\"delete-50930\";i:50173;s:12:\"delete-50933\";i:50174;s:12:\"delete-50936\";i:50175;s:12:\"delete-50934\";i:50176;s:12:\"delete-50935\";i:50177;s:12:\"delete-50937\";i:50178;s:12:\"delete-50938\";i:50179;s:12:\"delete-50941\";i:50180;s:12:\"delete-50942\";i:50181;s:12:\"delete-50939\";i:50182;s:12:\"delete-50940\";i:50183;s:12:\"delete-50943\";i:50184;s:12:\"delete-50946\";i:50185;s:12:\"delete-50947\";i:50186;s:12:\"delete-50944\";i:50187;s:12:\"delete-50945\";i:50188;s:12:\"delete-50948\";i:50189;s:12:\"delete-50951\";i:50190;s:12:\"delete-50952\";i:50191;s:12:\"delete-50949\";i:50192;s:12:\"delete-50950\";i:50193;s:12:\"delete-50953\";i:50194;s:12:\"delete-50956\";i:50195;s:12:\"delete-50957\";i:50196;s:12:\"delete-50954\";i:50197;s:12:\"delete-50955\";i:50198;s:12:\"delete-50958\";i:50199;s:12:\"delete-50961\";i:50200;s:12:\"delete-50962\";i:50201;s:12:\"delete-50959\";i:50202;s:12:\"delete-50960\";i:50203;s:12:\"delete-50963\";i:50204;s:12:\"delete-50966\";i:50205;s:12:\"delete-50967\";i:50206;s:12:\"delete-50964\";i:50207;s:12:\"delete-50965\";i:50208;s:12:\"delete-50968\";i:50209;s:12:\"delete-50971\";i:50210;s:12:\"delete-50972\";i:50211;s:12:\"delete-50969\";i:50212;s:12:\"delete-50970\";i:50213;s:12:\"delete-50973\";i:50214;s:12:\"delete-50976\";i:50215;s:12:\"delete-50974\";i:50216;s:12:\"delete-50975\";i:50217;s:12:\"delete-50977\";i:50218;s:12:\"delete-50978\";i:50219;s:12:\"delete-50981\";i:50220;s:12:\"delete-50982\";i:50221;s:12:\"delete-50979\";i:50222;s:12:\"delete-50980\";i:50223;s:12:\"delete-50983\";i:50224;s:12:\"delete-50986\";i:50225;s:12:\"delete-50987\";i:50226;s:12:\"delete-50984\";i:50227;s:12:\"delete-50985\";i:50228;s:12:\"delete-50988\";i:50229;s:12:\"delete-50991\";i:50230;s:12:\"delete-50992\";i:50231;s:12:\"delete-50989\";i:50232;s:12:\"delete-50990\";i:50233;s:12:\"delete-50993\";i:50234;s:12:\"delete-50996\";i:50235;s:12:\"delete-50997\";i:50236;s:12:\"delete-50994\";i:50237;s:12:\"delete-50995\";i:50238;s:12:\"delete-50998\";i:50239;s:12:\"delete-51001\";i:50240;s:12:\"delete-51002\";i:50241;s:12:\"delete-50999\";i:50242;s:12:\"delete-51000\";i:50243;s:12:\"delete-51003\";i:50244;s:12:\"delete-51006\";i:50245;s:12:\"delete-51007\";i:50246;s:12:\"delete-51004\";i:50247;s:12:\"delete-51005\";i:50248;s:12:\"delete-51008\";i:50249;s:12:\"delete-51011\";i:50250;s:12:\"delete-51012\";i:50251;s:12:\"delete-51009\";i:50252;s:12:\"delete-51010\";i:50253;s:12:\"delete-51013\";i:50254;s:12:\"delete-51016\";i:50255;s:12:\"delete-51017\";i:50256;s:12:\"delete-51014\";i:50257;s:12:\"delete-51015\";i:50258;s:12:\"delete-51018\";i:50259;s:12:\"delete-51021\";i:50260;s:12:\"delete-51022\";i:50261;s:12:\"delete-51019\";i:50262;s:12:\"delete-51020\";i:50263;s:12:\"delete-51023\";i:50264;s:12:\"delete-51026\";i:50265;s:12:\"delete-51027\";i:50266;s:12:\"delete-51024\";i:50267;s:12:\"delete-51025\";i:50268;s:12:\"delete-51028\";i:50269;s:12:\"delete-51031\";i:50270;s:12:\"delete-51032\";i:50271;s:12:\"delete-51029\";i:50272;s:12:\"delete-51030\";i:50273;s:12:\"delete-51033\";i:50274;s:12:\"delete-51036\";i:50275;s:12:\"delete-51037\";i:50276;s:12:\"delete-51034\";i:50277;s:12:\"delete-51035\";i:50278;s:12:\"delete-51038\";i:50279;s:12:\"delete-51041\";i:50280;s:12:\"delete-51042\";i:50281;s:12:\"delete-51039\";i:50282;s:12:\"delete-51040\";i:50283;s:12:\"delete-51043\";i:50284;s:12:\"delete-51046\";i:50285;s:12:\"delete-51047\";i:50286;s:12:\"delete-51044\";i:50287;s:12:\"delete-51045\";i:50288;s:12:\"delete-51048\";i:50289;s:12:\"delete-51051\";i:50290;s:12:\"delete-51052\";i:50291;s:12:\"delete-51049\";i:50292;s:12:\"delete-51050\";i:50293;s:12:\"delete-51053\";i:50294;s:12:\"delete-51056\";i:50295;s:12:\"delete-51054\";i:50296;s:12:\"delete-51055\";i:50297;s:12:\"delete-51057\";i:50298;s:12:\"delete-51058\";i:50299;s:12:\"delete-51061\";i:50300;s:12:\"delete-51062\";i:50301;s:12:\"delete-51059\";i:50302;s:12:\"delete-51060\";i:50303;s:12:\"delete-51063\";i:50304;s:12:\"delete-51066\";i:50305;s:12:\"delete-51067\";i:50306;s:12:\"delete-51064\";i:50307;s:12:\"delete-51065\";i:50308;s:12:\"delete-51068\";i:50309;s:12:\"delete-51071\";i:50310;s:12:\"delete-51069\";i:50311;s:12:\"delete-51070\";i:50312;s:12:\"delete-51072\";i:50313;s:12:\"delete-51073\";i:50314;s:12:\"delete-51076\";i:50315;s:12:\"delete-51077\";i:50316;s:12:\"delete-51074\";i:50317;s:12:\"delete-51075\";i:50318;s:12:\"delete-51078\";i:50319;s:12:\"delete-51081\";i:50320;s:12:\"delete-51082\";i:50321;s:12:\"delete-51079\";i:50322;s:12:\"delete-51080\";i:50323;s:12:\"delete-51083\";i:50324;s:12:\"delete-51086\";i:50325;s:12:\"delete-51087\";i:50326;s:12:\"delete-51084\";i:50327;s:12:\"delete-51085\";i:50328;s:12:\"delete-51088\";i:50329;s:12:\"delete-51091\";i:50330;s:12:\"delete-51089\";i:50331;s:12:\"delete-51090\";i:50332;s:12:\"delete-51092\";i:50333;s:12:\"delete-51093\";i:50334;s:12:\"delete-51096\";i:50335;s:12:\"delete-51097\";i:50336;s:12:\"delete-51094\";i:50337;s:12:\"delete-51095\";i:50338;s:12:\"delete-51098\";i:50339;s:12:\"delete-51101\";i:50340;s:12:\"delete-51102\";i:50341;s:12:\"delete-51099\";i:50342;s:12:\"delete-51100\";i:50343;s:12:\"delete-51103\";i:50344;s:12:\"delete-51106\";i:50345;s:12:\"delete-51107\";i:50346;s:12:\"delete-51104\";i:50347;s:12:\"delete-51105\";i:50348;s:12:\"delete-51108\";i:50349;s:12:\"delete-51111\";i:50350;s:12:\"delete-51112\";i:50351;s:12:\"delete-51109\";i:50352;s:12:\"delete-51110\";i:50353;s:12:\"delete-51113\";i:50354;s:12:\"delete-51116\";i:50355;s:12:\"delete-51117\";i:50356;s:12:\"delete-51114\";i:50357;s:12:\"delete-51115\";i:50358;s:12:\"delete-51118\";i:50359;s:12:\"delete-51121\";i:50360;s:12:\"delete-51122\";i:50361;s:12:\"delete-51119\";i:50362;s:12:\"delete-51120\";i:50363;s:12:\"delete-51123\";i:50364;s:12:\"delete-51126\";i:50365;s:12:\"delete-51127\";i:50366;s:12:\"delete-51124\";i:50367;s:12:\"delete-51125\";i:50368;s:12:\"delete-51128\";i:50369;s:12:\"delete-51131\";i:50370;s:12:\"delete-51132\";i:50371;s:12:\"delete-51129\";i:50372;s:12:\"delete-51130\";i:50373;s:12:\"delete-51133\";i:50374;s:12:\"delete-51136\";i:50375;s:12:\"delete-51134\";i:50376;s:12:\"delete-51135\";i:50377;s:12:\"delete-51137\";i:50378;s:12:\"delete-51138\";i:50379;s:12:\"delete-51141\";i:50380;s:12:\"delete-51142\";i:50381;s:12:\"delete-51139\";i:50382;s:12:\"delete-51140\";i:50383;s:12:\"delete-51143\";i:50384;s:12:\"delete-51146\";i:50385;s:12:\"delete-51147\";i:50386;s:12:\"delete-51144\";i:50387;s:12:\"delete-51145\";i:50388;s:12:\"delete-51148\";i:50389;s:12:\"delete-51151\";i:50390;s:12:\"delete-51152\";i:50391;s:12:\"delete-51149\";i:50392;s:12:\"delete-51150\";i:50393;s:12:\"delete-51153\";i:50394;s:12:\"delete-51156\";i:50395;s:12:\"delete-51157\";i:50396;s:12:\"delete-51154\";i:50397;s:12:\"delete-51155\";i:50398;s:12:\"delete-51158\";i:50399;s:12:\"delete-51161\";i:50400;s:12:\"delete-51162\";i:50401;s:12:\"delete-51159\";i:50402;s:12:\"delete-51160\";i:50403;s:12:\"delete-51163\";i:50404;s:12:\"delete-51166\";i:50405;s:12:\"delete-51167\";i:50406;s:12:\"delete-51164\";i:50407;s:12:\"delete-51165\";i:50408;s:12:\"delete-51168\";i:50409;s:12:\"delete-51171\";i:50410;s:12:\"delete-51169\";i:50411;s:12:\"delete-51170\";i:50412;s:12:\"delete-51172\";i:50413;s:12:\"delete-51173\";i:50414;s:12:\"delete-51176\";i:50415;s:12:\"delete-51177\";i:50416;s:12:\"delete-51174\";i:50417;s:12:\"delete-51175\";i:50418;s:12:\"delete-51178\";i:50419;s:12:\"delete-51181\";i:50420;s:12:\"delete-51179\";i:50421;s:12:\"delete-51180\";i:50422;s:12:\"delete-51182\";i:50423;s:12:\"delete-51183\";i:50424;s:12:\"delete-51186\";i:50425;s:12:\"delete-51187\";i:50426;s:12:\"delete-51184\";i:50427;s:12:\"delete-51185\";i:50428;s:12:\"delete-51188\";i:50429;s:12:\"delete-51191\";i:50430;s:12:\"delete-51192\";i:50431;s:12:\"delete-51189\";i:50432;s:12:\"delete-51190\";i:50433;s:12:\"delete-51193\";i:50434;s:12:\"delete-51196\";i:50435;s:12:\"delete-51197\";i:50436;s:12:\"delete-51194\";i:50437;s:12:\"delete-51195\";i:50438;s:12:\"delete-51198\";i:50439;s:12:\"delete-51201\";i:50440;s:12:\"delete-51202\";i:50441;s:12:\"delete-51199\";i:50442;s:12:\"delete-51200\";i:50443;s:12:\"delete-51203\";i:50444;s:12:\"delete-51206\";i:50445;s:12:\"delete-51207\";i:50446;s:12:\"delete-51204\";i:50447;s:12:\"delete-51205\";i:50448;s:12:\"delete-51208\";i:50449;s:12:\"delete-51211\";i:50450;s:12:\"delete-51212\";i:50451;s:12:\"delete-51209\";i:50452;s:12:\"delete-51210\";i:50453;s:12:\"delete-51213\";i:50454;s:12:\"delete-51216\";i:50455;s:12:\"delete-51217\";i:50456;s:12:\"delete-51214\";i:50457;s:12:\"delete-51215\";i:50458;s:12:\"delete-51218\";i:50459;s:12:\"delete-51221\";i:50460;s:12:\"delete-51222\";i:50461;s:12:\"delete-51219\";i:50462;s:12:\"delete-51220\";i:50463;s:12:\"delete-51223\";i:50464;s:12:\"delete-51226\";i:50465;s:12:\"delete-51227\";i:50466;s:12:\"delete-51224\";i:50467;s:12:\"delete-51225\";i:50468;s:12:\"delete-51228\";i:50469;s:12:\"delete-51231\";i:50470;s:12:\"delete-51232\";i:50471;s:12:\"delete-51229\";i:50472;s:12:\"delete-51230\";i:50473;s:12:\"delete-51233\";i:50474;s:12:\"delete-51236\";i:50475;s:12:\"delete-51237\";i:50476;s:12:\"delete-51234\";i:50477;s:12:\"delete-51235\";i:50478;s:12:\"delete-51238\";i:50479;s:12:\"delete-51241\";i:50480;s:12:\"delete-51242\";i:50481;s:12:\"delete-51239\";i:50482;s:12:\"delete-51240\";i:50483;s:12:\"delete-51243\";i:50484;s:12:\"delete-51246\";i:50485;s:12:\"delete-51247\";i:50486;s:12:\"delete-51244\";i:50487;s:12:\"delete-51245\";i:50488;s:12:\"delete-51248\";i:50489;s:12:\"delete-51251\";i:50490;s:12:\"delete-51252\";i:50491;s:12:\"delete-51249\";i:50492;s:12:\"delete-51250\";i:50493;s:12:\"delete-51253\";i:50494;s:12:\"delete-51256\";i:50495;s:12:\"delete-51257\";i:50496;s:12:\"delete-51254\";i:50497;s:12:\"delete-51255\";i:50498;s:12:\"delete-51258\";i:50499;s:12:\"delete-51261\";i:50500;s:12:\"delete-51262\";i:50501;s:12:\"delete-51259\";i:50502;s:12:\"delete-51260\";i:50503;s:12:\"delete-51263\";i:50504;s:12:\"delete-51266\";i:50505;s:12:\"delete-51267\";i:50506;s:12:\"delete-51264\";i:50507;s:12:\"delete-51265\";i:50508;s:12:\"delete-51268\";i:50509;s:12:\"delete-51271\";i:50510;s:12:\"delete-51272\";i:50511;s:12:\"delete-51269\";i:50512;s:12:\"delete-51270\";i:50513;s:12:\"delete-51273\";i:50514;s:12:\"delete-51276\";i:50515;s:12:\"delete-51274\";i:50516;s:12:\"delete-51275\";i:50517;s:12:\"delete-51277\";i:50518;s:12:\"delete-51278\";i:50519;s:12:\"delete-51281\";i:50520;s:12:\"delete-51282\";i:50521;s:12:\"delete-51279\";i:50522;s:12:\"delete-51280\";i:50523;s:12:\"delete-51283\";i:50524;s:12:\"delete-51286\";i:50525;s:12:\"delete-51284\";i:50526;s:12:\"delete-51285\";i:50527;s:12:\"delete-51287\";i:50528;s:12:\"delete-51288\";i:50529;s:12:\"delete-51291\";i:50530;s:12:\"delete-51292\";i:50531;s:12:\"delete-51289\";i:50532;s:12:\"delete-51290\";i:50533;s:12:\"delete-51293\";i:50534;s:12:\"delete-51296\";i:50535;s:12:\"delete-51297\";i:50536;s:12:\"delete-51294\";i:50537;s:12:\"delete-51295\";i:50538;s:12:\"delete-51298\";i:50539;s:12:\"delete-51302\";i:50540;s:12:\"delete-51301\";i:50541;s:12:\"delete-51299\";i:50542;s:12:\"delete-51300\";i:50543;s:12:\"delete-51303\";i:50544;s:12:\"delete-51307\";i:50545;s:12:\"delete-51306\";i:50546;s:12:\"delete-51304\";i:50547;s:12:\"delete-51305\";i:50548;s:12:\"delete-51308\";i:50549;s:12:\"delete-51312\";i:50550;s:12:\"delete-51311\";i:50551;s:12:\"delete-51309\";i:50552;s:12:\"delete-51310\";i:50553;s:12:\"delete-51313\";i:50554;s:12:\"delete-51316\";i:50555;s:12:\"delete-51314\";i:50556;s:12:\"delete-51315\";i:50557;s:12:\"delete-51317\";i:50558;s:12:\"delete-51318\";i:50559;s:12:\"delete-51321\";i:50560;s:12:\"delete-51322\";i:50561;s:12:\"delete-51319\";i:50562;s:12:\"delete-51320\";i:50563;s:12:\"delete-51323\";i:50564;s:12:\"delete-51327\";i:50565;s:12:\"delete-51326\";i:50566;s:12:\"delete-51324\";i:50567;s:12:\"delete-51325\";i:50568;s:12:\"delete-51328\";i:50569;s:12:\"delete-51332\";i:50570;s:12:\"delete-51331\";i:50571;s:12:\"delete-51329\";i:50572;s:12:\"delete-51330\";i:50573;s:12:\"delete-51333\";i:50574;s:12:\"delete-51336\";i:50575;s:12:\"delete-51337\";i:50576;s:12:\"delete-51334\";i:50577;s:12:\"delete-51335\";i:50578;s:12:\"delete-51338\";i:50579;s:12:\"delete-51341\";i:50580;s:12:\"delete-51342\";i:50581;s:12:\"delete-51339\";i:50582;s:12:\"delete-51340\";i:50583;s:12:\"delete-51343\";i:50584;s:12:\"delete-51346\";i:50585;s:12:\"delete-51347\";i:50586;s:12:\"delete-51344\";i:50587;s:12:\"delete-51345\";i:50588;s:12:\"delete-51348\";i:50589;s:12:\"delete-51352\";i:50590;s:12:\"delete-51351\";i:50591;s:12:\"delete-51349\";i:50592;s:12:\"delete-51350\";i:50593;s:12:\"delete-51353\";i:50594;s:12:\"delete-51356\";i:50595;s:12:\"delete-51354\";i:50596;s:12:\"delete-51355\";i:50597;s:12:\"delete-51357\";i:50598;s:12:\"delete-51358\";i:50599;s:12:\"delete-51361\";i:50600;s:12:\"delete-51362\";i:50601;s:12:\"delete-51359\";i:50602;s:12:\"delete-51360\";i:50603;s:12:\"delete-51363\";i:50604;s:12:\"delete-51367\";i:50605;s:12:\"delete-51366\";i:50606;s:12:\"delete-51364\";i:50607;s:12:\"delete-51365\";i:50608;s:12:\"delete-51368\";i:50609;s:12:\"delete-51371\";i:50610;s:12:\"delete-51372\";i:50611;s:12:\"delete-51369\";i:50612;s:12:\"delete-51370\";i:50613;s:12:\"delete-51373\";i:50614;s:12:\"delete-51377\";i:50615;s:12:\"delete-51376\";i:50616;s:12:\"delete-51374\";i:50617;s:12:\"delete-51375\";i:50618;s:12:\"delete-51378\";i:50619;s:12:\"delete-51381\";i:50620;s:12:\"delete-51382\";i:50621;s:12:\"delete-51379\";i:50622;s:12:\"delete-51380\";i:50623;s:12:\"delete-51383\";i:50624;s:12:\"delete-51387\";i:50625;s:12:\"delete-51386\";i:50626;s:12:\"delete-51384\";i:50627;s:12:\"delete-51385\";i:50628;s:12:\"delete-51388\";i:50629;s:12:\"delete-51391\";i:50630;s:12:\"delete-51392\";i:50631;s:12:\"delete-51389\";i:50632;s:12:\"delete-51390\";i:50633;s:12:\"delete-51393\";i:50634;s:12:\"delete-51396\";i:50635;s:12:\"delete-51394\";i:50636;s:12:\"delete-51395\";i:50637;s:12:\"delete-51397\";i:50638;s:12:\"delete-51398\";i:50639;s:12:\"delete-51401\";i:50640;s:12:\"delete-51402\";i:50641;s:12:\"delete-51399\";i:50642;s:12:\"delete-51400\";i:50643;s:12:\"delete-51403\";i:50644;s:12:\"delete-51406\";i:50645;s:12:\"delete-51407\";i:50646;s:12:\"delete-51404\";i:50647;s:12:\"delete-51405\";i:50648;s:12:\"delete-51408\";i:50649;s:12:\"delete-51411\";i:50650;s:12:\"delete-51412\";i:50651;s:12:\"delete-51409\";i:50652;s:12:\"delete-51410\";i:50653;s:12:\"delete-51413\";i:50654;s:12:\"delete-51416\";i:50655;s:12:\"delete-51417\";i:50656;s:12:\"delete-51414\";i:50657;s:12:\"delete-51415\";i:50658;s:12:\"delete-51418\";i:50659;s:12:\"delete-51421\";i:50660;s:12:\"delete-51422\";i:50661;s:12:\"delete-51419\";i:50662;s:12:\"delete-51420\";i:50663;s:12:\"delete-51423\";i:50664;s:12:\"delete-51426\";i:50665;s:12:\"delete-51427\";i:50666;s:12:\"delete-51424\";i:50667;s:12:\"delete-51425\";i:50668;s:12:\"delete-51428\";i:50669;s:12:\"delete-51431\";i:50670;s:12:\"delete-51432\";i:50671;s:12:\"delete-51429\";i:50672;s:12:\"delete-51430\";i:50673;s:12:\"delete-51433\";i:50674;s:12:\"delete-51436\";i:50675;s:12:\"delete-51437\";i:50676;s:12:\"delete-51434\";i:50677;s:12:\"delete-51435\";i:50678;s:12:\"delete-51438\";i:50679;s:12:\"delete-51441\";i:50680;s:12:\"delete-51442\";i:50681;s:12:\"delete-51439\";i:50682;s:12:\"delete-51440\";i:50683;s:12:\"delete-51443\";i:50684;s:12:\"delete-51446\";i:50685;s:12:\"delete-51447\";i:50686;s:12:\"delete-51444\";i:50687;s:12:\"delete-51445\";i:50688;s:12:\"delete-51448\";i:50689;s:12:\"delete-51451\";i:50690;s:12:\"delete-51452\";i:50691;s:12:\"delete-51449\";i:50692;s:12:\"delete-51450\";i:50693;s:12:\"delete-51453\";i:50694;s:12:\"delete-51456\";i:50695;s:12:\"delete-51454\";i:50696;s:12:\"delete-51455\";i:50697;s:12:\"delete-51457\";i:50698;s:12:\"delete-51458\";i:50699;s:12:\"delete-51461\";i:50700;s:12:\"delete-51462\";i:50701;s:12:\"delete-51459\";i:50702;s:12:\"delete-51460\";i:50703;s:12:\"delete-51463\";i:50704;s:12:\"delete-51466\";i:50705;s:12:\"delete-51464\";i:50706;s:12:\"delete-51465\";i:50707;s:12:\"delete-51467\";i:50708;s:12:\"delete-51468\";i:50709;s:12:\"delete-51471\";i:50710;s:12:\"delete-51472\";i:50711;s:12:\"delete-51469\";i:50712;s:12:\"delete-51470\";i:50713;s:12:\"delete-51473\";i:50714;s:12:\"delete-51476\";i:50715;s:12:\"delete-51477\";i:50716;s:12:\"delete-51474\";i:50717;s:12:\"delete-51475\";i:50718;s:12:\"delete-51478\";i:50719;s:12:\"delete-51481\";i:50720;s:12:\"delete-51479\";i:50721;s:12:\"delete-51480\";i:50722;s:12:\"delete-51482\";i:50723;s:12:\"delete-51483\";i:50724;s:12:\"delete-51486\";i:50725;s:12:\"delete-51487\";i:50726;s:12:\"delete-51484\";i:50727;s:12:\"delete-51485\";i:50728;s:12:\"delete-51488\";i:50729;s:12:\"delete-51491\";i:50730;s:12:\"delete-51492\";i:50731;s:12:\"delete-51489\";i:50732;s:12:\"delete-51490\";i:50733;s:12:\"delete-51493\";i:50734;s:12:\"delete-51496\";i:50735;s:12:\"delete-51497\";i:50736;s:12:\"delete-51494\";i:50737;s:12:\"delete-51495\";i:50738;s:12:\"delete-51498\";i:50739;s:12:\"delete-51501\";i:50740;s:12:\"delete-51502\";i:50741;s:12:\"delete-51499\";i:50742;s:12:\"delete-51500\";i:50743;s:12:\"delete-51503\";i:50744;s:12:\"delete-51506\";i:50745;s:12:\"delete-51507\";i:50746;s:12:\"delete-51504\";i:50747;s:12:\"delete-51505\";i:50748;s:12:\"delete-51508\";i:50749;s:12:\"delete-51511\";i:50750;s:12:\"delete-51512\";i:50751;s:12:\"delete-51509\";i:50752;s:12:\"delete-51510\";i:50753;s:12:\"delete-51513\";i:50754;s:12:\"delete-51516\";i:50755;s:12:\"delete-51517\";i:50756;s:12:\"delete-51514\";i:50757;s:12:\"delete-51515\";i:50758;s:12:\"delete-51518\";i:50759;s:12:\"delete-51521\";i:50760;s:12:\"delete-51519\";i:50761;s:12:\"delete-51520\";i:50762;s:12:\"delete-51522\";i:50763;s:12:\"delete-51523\";i:50764;s:12:\"delete-51526\";i:50765;s:12:\"delete-51527\";i:50766;s:12:\"delete-51524\";i:50767;s:12:\"delete-51525\";i:50768;s:12:\"delete-51528\";i:50769;s:12:\"delete-51531\";i:50770;s:12:\"delete-51532\";i:50771;s:12:\"delete-51529\";i:50772;s:12:\"delete-51530\";i:50773;s:12:\"delete-51533\";i:50774;s:12:\"delete-51536\";i:50775;s:12:\"delete-51534\";i:50776;s:12:\"delete-51535\";i:50777;s:12:\"delete-51537\";i:50778;s:12:\"delete-51538\";i:50779;s:12:\"delete-51541\";i:50780;s:12:\"delete-51542\";i:50781;s:12:\"delete-51539\";i:50782;s:12:\"delete-51540\";i:50783;s:12:\"delete-51543\";i:50784;s:12:\"delete-51546\";i:50785;s:12:\"delete-51547\";i:50786;s:12:\"delete-51544\";i:50787;s:12:\"delete-51545\";i:50788;s:12:\"delete-51548\";i:50789;s:12:\"delete-51551\";i:50790;s:12:\"delete-51552\";i:50791;s:12:\"delete-51549\";i:50792;s:12:\"delete-51550\";i:50793;s:12:\"delete-51553\";i:50794;s:12:\"delete-51556\";i:50795;s:12:\"delete-51557\";i:50796;s:12:\"delete-51554\";i:50797;s:12:\"delete-51555\";i:50798;s:12:\"delete-51558\";i:50799;s:12:\"delete-51561\";i:50800;s:12:\"delete-51562\";i:50801;s:12:\"delete-51559\";i:50802;s:12:\"delete-51560\";i:50803;s:12:\"delete-51563\";i:50804;s:12:\"delete-51566\";i:50805;s:12:\"delete-51567\";i:50806;s:12:\"delete-51564\";i:50807;s:12:\"delete-51565\";i:50808;s:12:\"delete-51568\";i:50809;s:12:\"delete-51571\";i:50810;s:12:\"delete-51572\";i:50811;s:12:\"delete-51569\";i:50812;s:12:\"delete-51570\";i:50813;s:12:\"delete-51573\";i:50814;s:12:\"delete-51576\";i:50815;s:12:\"delete-51574\";i:50816;s:12:\"delete-51575\";i:50817;s:12:\"delete-51577\";i:50818;s:12:\"delete-51578\";i:50819;s:12:\"delete-51581\";i:50820;s:12:\"delete-51582\";i:50821;s:12:\"delete-51579\";i:50822;s:12:\"delete-51580\";i:50823;s:12:\"delete-51583\";i:50824;s:12:\"delete-51586\";i:50825;s:12:\"delete-51587\";i:50826;s:12:\"delete-51584\";i:50827;s:12:\"delete-51585\";i:50828;s:12:\"delete-51588\";i:50829;s:12:\"delete-51591\";i:50830;s:12:\"delete-51592\";i:50831;s:12:\"delete-51589\";i:50832;s:12:\"delete-51590\";i:50833;s:12:\"delete-51593\";i:50834;s:12:\"delete-51596\";i:50835;s:12:\"delete-51597\";i:50836;s:12:\"delete-51594\";i:50837;s:12:\"delete-51595\";i:50838;s:12:\"delete-51598\";i:50839;s:12:\"delete-51601\";i:50840;s:12:\"delete-51599\";i:50841;s:12:\"delete-51600\";i:50842;s:12:\"delete-51602\";i:50843;s:12:\"delete-51603\";i:50844;s:12:\"delete-51606\";i:50845;s:12:\"delete-51607\";i:50846;s:12:\"delete-51604\";i:50847;s:12:\"delete-51605\";i:50848;s:12:\"delete-51608\";i:50849;s:12:\"delete-51611\";i:50850;s:12:\"delete-51612\";i:50851;s:12:\"delete-51609\";i:50852;s:12:\"delete-51610\";i:50853;s:12:\"delete-51613\";i:50854;s:12:\"delete-51616\";i:50855;s:12:\"delete-51617\";i:50856;s:12:\"delete-51614\";i:50857;s:12:\"delete-51615\";i:50858;s:12:\"delete-51618\";i:50859;s:12:\"delete-51621\";i:50860;s:12:\"delete-51622\";i:50861;s:12:\"delete-51619\";i:50862;s:12:\"delete-51620\";i:50863;s:12:\"delete-51623\";i:50864;s:12:\"delete-51626\";i:50865;s:12:\"delete-51627\";i:50866;s:12:\"delete-51624\";i:50867;s:12:\"delete-51625\";i:50868;s:12:\"delete-51628\";i:50869;s:12:\"delete-51631\";i:50870;s:12:\"delete-51632\";i:50871;s:12:\"delete-51629\";i:50872;s:12:\"delete-51630\";i:50873;s:12:\"delete-51633\";i:50874;s:12:\"delete-51636\";i:50875;s:12:\"delete-51634\";i:50876;s:12:\"delete-51635\";i:50877;s:12:\"delete-51637\";i:50878;s:12:\"delete-51638\";i:50879;s:12:\"delete-51641\";i:50880;s:12:\"delete-51642\";i:50881;s:12:\"delete-51639\";i:50882;s:12:\"delete-51640\";i:50883;s:12:\"delete-51643\";i:50884;s:12:\"delete-51646\";i:50885;s:12:\"delete-51647\";i:50886;s:12:\"delete-51644\";i:50887;s:12:\"delete-51645\";i:50888;s:12:\"delete-51648\";i:50889;s:12:\"delete-51651\";i:50890;s:12:\"delete-51652\";i:50891;s:12:\"delete-51649\";i:50892;s:12:\"delete-51650\";i:50893;s:12:\"delete-51653\";i:50894;s:12:\"delete-51656\";i:50895;s:12:\"delete-51657\";i:50896;s:12:\"delete-51654\";i:50897;s:12:\"delete-51655\";i:50898;s:12:\"delete-51658\";i:50899;s:12:\"delete-51661\";i:50900;s:12:\"delete-51659\";i:50901;s:12:\"delete-51660\";i:50902;s:12:\"delete-51662\";i:50903;s:12:\"delete-51663\";i:50904;s:12:\"delete-51666\";i:50905;s:12:\"delete-51667\";i:50906;s:12:\"delete-51664\";i:50907;s:12:\"delete-51665\";i:50908;s:12:\"delete-51668\";i:50909;s:12:\"delete-51671\";i:50910;s:12:\"delete-51669\";i:50911;s:12:\"delete-51670\";i:50912;s:12:\"delete-51672\";i:50913;s:12:\"delete-51673\";i:50914;s:12:\"delete-51676\";i:50915;s:12:\"delete-51674\";i:50916;s:12:\"delete-51675\";i:50917;s:12:\"delete-51677\";i:50918;s:12:\"delete-51678\";i:50919;s:12:\"delete-51681\";i:50920;s:12:\"delete-51682\";i:50921;s:12:\"delete-51679\";i:50922;s:12:\"delete-51680\";i:50923;s:12:\"delete-51683\";i:50924;s:12:\"delete-51686\";i:50925;s:12:\"delete-51687\";i:50926;s:12:\"delete-51684\";i:50927;s:12:\"delete-51685\";i:50928;s:12:\"delete-51688\";i:50929;s:12:\"delete-51691\";i:50930;s:12:\"delete-51689\";i:50931;s:12:\"delete-51690\";i:50932;s:12:\"delete-51692\";i:50933;s:12:\"delete-51693\";i:50934;s:12:\"delete-51696\";i:50935;s:12:\"delete-51697\";i:50936;s:12:\"delete-51694\";i:50937;s:12:\"delete-51695\";i:50938;s:12:\"delete-51698\";i:50939;s:12:\"delete-51701\";i:50940;s:12:\"delete-51702\";i:50941;s:12:\"delete-51699\";i:50942;s:12:\"delete-51700\";i:50943;s:12:\"delete-51703\";i:50944;s:12:\"delete-51706\";i:50945;s:12:\"delete-51707\";i:50946;s:12:\"delete-51704\";i:50947;s:12:\"delete-51705\";i:50948;s:12:\"delete-51708\";i:50949;s:12:\"delete-51711\";i:50950;s:12:\"delete-51712\";i:50951;s:12:\"delete-51709\";i:50952;s:12:\"delete-51710\";i:50953;s:12:\"delete-51713\";i:50954;s:12:\"delete-51716\";i:50955;s:12:\"delete-51717\";i:50956;s:12:\"delete-51714\";i:50957;s:12:\"delete-51715\";i:50958;s:12:\"delete-51718\";i:50959;s:12:\"delete-51721\";i:50960;s:12:\"delete-51722\";i:50961;s:12:\"delete-51719\";i:50962;s:12:\"delete-51720\";i:50963;s:12:\"delete-51723\";i:50964;s:12:\"delete-51726\";i:50965;s:12:\"delete-51727\";i:50966;s:12:\"delete-51724\";i:50967;s:12:\"delete-51725\";i:50968;s:12:\"delete-51728\";i:50969;s:12:\"delete-51729\";i:50970;s:12:\"delete-51730\";i:50971;s:12:\"delete-51731\";i:50972;s:12:\"delete-51732\";i:50973;s:12:\"delete-51733\";i:50974;s:12:\"delete-51736\";i:50975;s:12:\"delete-51737\";i:50976;s:12:\"delete-51734\";i:50977;s:12:\"delete-51735\";i:50978;s:12:\"delete-51738\";i:50979;s:12:\"delete-51741\";i:50980;s:12:\"delete-51742\";i:50981;s:12:\"delete-51739\";i:50982;s:12:\"delete-51740\";i:50983;s:12:\"delete-51743\";i:50984;s:12:\"delete-51746\";i:50985;s:12:\"delete-51747\";i:50986;s:12:\"delete-51744\";i:50987;s:12:\"delete-51745\";i:50988;s:12:\"delete-51748\";i:50989;s:12:\"delete-51751\";i:50990;s:12:\"delete-51752\";i:50991;s:12:\"delete-51749\";i:50992;s:12:\"delete-51750\";i:50993;s:12:\"delete-51753\";i:50994;s:12:\"delete-51756\";i:50995;s:12:\"delete-51757\";i:50996;s:12:\"delete-51754\";i:50997;s:12:\"delete-51755\";i:50998;s:12:\"delete-51758\";i:50999;s:12:\"delete-51761\";i:51000;s:12:\"delete-51762\";i:51001;s:12:\"delete-51759\";i:51002;s:12:\"delete-51760\";i:51003;s:12:\"delete-51763\";i:51004;s:12:\"delete-51766\";i:51005;s:12:\"delete-51767\";i:51006;s:12:\"delete-51764\";i:51007;s:12:\"delete-51765\";i:51008;s:12:\"delete-51768\";i:51009;s:12:\"delete-51771\";i:51010;s:12:\"delete-51772\";i:51011;s:12:\"delete-51769\";i:51012;s:12:\"delete-51770\";i:51013;s:12:\"delete-51773\";i:51014;s:12:\"delete-51776\";i:51015;s:12:\"delete-51774\";i:51016;s:12:\"delete-51775\";i:51017;s:12:\"delete-51777\";i:51018;s:12:\"delete-51778\";i:51019;s:12:\"delete-51781\";i:51020;s:12:\"delete-51782\";i:51021;s:12:\"delete-51779\";i:51022;s:12:\"delete-51780\";i:51023;s:12:\"delete-51783\";i:51024;s:12:\"delete-51786\";i:51025;s:12:\"delete-51787\";i:51026;s:12:\"delete-51784\";i:51027;s:12:\"delete-51785\";i:51028;s:12:\"delete-51788\";i:51029;s:12:\"delete-51791\";i:51030;s:12:\"delete-51789\";i:51031;s:12:\"delete-51790\";i:51032;s:12:\"delete-51792\";i:51033;s:12:\"delete-51793\";i:51034;s:12:\"delete-51796\";i:51035;s:12:\"delete-51797\";i:51036;s:12:\"delete-51794\";i:51037;s:12:\"delete-51795\";i:51038;s:12:\"delete-51798\";i:51039;s:12:\"delete-51801\";i:51040;s:12:\"delete-51802\";i:51041;s:12:\"delete-51799\";i:51042;s:12:\"delete-51800\";i:51043;s:12:\"delete-51803\";i:51044;s:12:\"delete-51806\";i:51045;s:12:\"delete-51807\";i:51046;s:12:\"delete-51804\";i:51047;s:12:\"delete-51805\";i:51048;s:12:\"delete-51808\";i:51049;s:12:\"delete-51811\";i:51050;s:12:\"delete-51812\";i:51051;s:12:\"delete-51809\";i:51052;s:12:\"delete-51810\";i:51053;s:12:\"delete-51813\";i:51054;s:12:\"delete-51816\";i:51055;s:12:\"delete-51817\";i:51056;s:12:\"delete-51814\";i:51057;s:12:\"delete-51815\";i:51058;s:12:\"delete-51818\";i:51059;s:12:\"delete-51821\";i:51060;s:12:\"delete-51819\";i:51061;s:12:\"delete-51820\";i:51062;s:12:\"delete-51822\";i:51063;s:12:\"delete-51823\";i:51064;s:12:\"delete-51826\";i:51065;s:12:\"delete-51827\";i:51066;s:12:\"delete-51824\";i:51067;s:12:\"delete-51825\";i:51068;s:12:\"delete-51828\";i:51069;s:12:\"delete-51831\";i:51070;s:12:\"delete-51832\";i:51071;s:12:\"delete-51829\";i:51072;s:12:\"delete-51830\";i:51073;s:12:\"delete-51833\";i:51074;s:12:\"delete-51836\";i:51075;s:12:\"delete-51837\";i:51076;s:12:\"delete-51834\";i:51077;s:12:\"delete-51835\";i:51078;s:12:\"delete-51838\";i:51079;s:12:\"delete-51841\";i:51080;s:12:\"delete-51842\";i:51081;s:12:\"delete-51839\";i:51082;s:12:\"delete-51840\";i:51083;s:12:\"delete-51843\";i:51084;s:12:\"delete-51846\";i:51085;s:12:\"delete-51847\";i:51086;s:12:\"delete-51844\";i:51087;s:12:\"delete-51845\";i:51088;s:12:\"delete-51848\";i:51089;s:12:\"delete-51851\";i:51090;s:12:\"delete-51852\";i:51091;s:12:\"delete-51849\";i:51092;s:12:\"delete-51850\";i:51093;s:12:\"delete-51853\";i:51094;s:12:\"delete-51856\";i:51095;s:12:\"delete-51857\";i:51096;s:12:\"delete-51854\";i:51097;s:12:\"delete-51855\";i:51098;s:12:\"delete-51858\";i:51099;s:12:\"delete-51861\";i:51100;s:12:\"delete-51862\";i:51101;s:12:\"delete-51859\";i:51102;s:12:\"delete-51860\";i:51103;s:12:\"delete-51863\";i:51104;s:12:\"delete-51866\";i:51105;s:12:\"delete-51867\";i:51106;s:12:\"delete-51864\";i:51107;s:12:\"delete-51865\";i:51108;s:12:\"delete-51868\";i:51109;s:12:\"delete-51871\";i:51110;s:12:\"delete-51872\";i:51111;s:12:\"delete-51869\";i:51112;s:12:\"delete-51870\";i:51113;s:12:\"delete-51873\";i:51114;s:12:\"delete-51876\";i:51115;s:12:\"delete-51877\";i:51116;s:12:\"delete-51874\";i:51117;s:12:\"delete-51875\";i:51118;s:12:\"delete-51878\";i:51119;s:12:\"delete-51881\";i:51120;s:12:\"delete-51882\";i:51121;s:12:\"delete-51879\";i:51122;s:12:\"delete-51880\";i:51123;s:12:\"delete-51883\";i:51124;s:12:\"delete-51886\";i:51125;s:12:\"delete-51887\";i:51126;s:12:\"delete-51884\";i:51127;s:12:\"delete-51885\";i:51128;s:12:\"delete-51888\";i:51129;s:12:\"delete-51891\";i:51130;s:12:\"delete-51892\";i:51131;s:12:\"delete-51889\";i:51132;s:12:\"delete-51890\";i:51133;s:12:\"delete-51893\";i:51134;s:12:\"delete-51896\";i:51135;s:12:\"delete-51897\";i:51136;s:12:\"delete-51894\";i:51137;s:12:\"delete-51895\";i:51138;s:12:\"delete-51898\";i:51139;s:12:\"delete-51901\";i:51140;s:12:\"delete-51902\";i:51141;s:12:\"delete-51899\";i:51142;s:12:\"delete-51900\";i:51143;s:12:\"delete-51903\";i:51144;s:12:\"delete-51906\";i:51145;s:12:\"delete-51904\";i:51146;s:12:\"delete-51905\";i:51147;s:12:\"delete-51907\";i:51148;s:12:\"delete-51910\";i:51149;s:12:\"delete-51911\";i:51150;s:12:\"delete-51908\";i:51151;s:12:\"delete-51909\";i:51152;s:12:\"delete-51912\";i:51153;s:12:\"delete-51915\";i:51154;s:12:\"delete-51916\";i:51155;s:12:\"delete-51913\";i:51156;s:12:\"delete-51914\";i:51157;s:12:\"delete-51917\";i:51158;s:12:\"delete-51920\";i:51159;s:12:\"delete-51921\";i:51160;s:12:\"delete-51918\";i:51161;s:12:\"delete-51919\";i:51162;s:12:\"delete-51922\";i:51163;s:12:\"delete-51925\";i:51164;s:12:\"delete-51926\";i:51165;s:12:\"delete-51923\";i:51166;s:12:\"delete-51924\";i:51167;s:12:\"delete-51927\";i:51168;s:12:\"delete-51930\";i:51169;s:12:\"delete-51928\";i:51170;s:12:\"delete-51929\";i:51171;s:12:\"delete-51931\";i:51172;s:12:\"delete-51932\";i:51173;s:12:\"delete-51935\";i:51174;s:12:\"delete-51936\";i:51175;s:12:\"delete-51933\";i:51176;s:12:\"delete-51934\";i:51177;s:12:\"delete-51937\";i:51178;s:12:\"delete-51940\";i:51179;s:12:\"delete-51941\";i:51180;s:12:\"delete-51938\";i:51181;s:12:\"delete-51939\";i:51182;s:12:\"delete-51942\";i:51183;s:12:\"delete-51945\";i:51184;s:12:\"delete-51946\";i:51185;s:12:\"delete-51943\";i:51186;s:12:\"delete-51944\";i:51187;s:12:\"delete-51947\";i:51188;s:12:\"delete-51950\";i:51189;s:12:\"delete-51951\";i:51190;s:12:\"delete-51948\";i:51191;s:12:\"delete-51949\";i:51192;s:12:\"delete-51952\";i:51193;s:12:\"delete-51955\";i:51194;s:12:\"delete-51956\";i:51195;s:12:\"delete-51953\";i:51196;s:12:\"delete-51954\";i:51197;s:12:\"delete-51957\";i:51198;s:12:\"delete-51960\";i:51199;s:12:\"delete-51961\";i:51200;s:12:\"delete-51958\";i:51201;s:12:\"delete-51959\";i:51202;s:12:\"delete-51962\";i:51203;s:12:\"delete-51965\";i:51204;s:12:\"delete-51966\";i:51205;s:12:\"delete-51963\";i:51206;s:12:\"delete-51964\";i:51207;s:12:\"delete-51967\";i:51208;s:12:\"delete-51970\";i:51209;s:12:\"delete-51971\";i:51210;s:12:\"delete-51968\";i:51211;s:12:\"delete-51969\";i:51212;s:12:\"delete-51972\";i:51213;s:12:\"delete-51975\";i:51214;s:12:\"delete-51973\";i:51215;s:12:\"delete-51974\";i:51216;s:12:\"delete-51976\";i:51217;s:12:\"delete-51977\";i:51218;s:12:\"delete-51980\";i:51219;s:12:\"delete-51981\";i:51220;s:12:\"delete-51978\";i:51221;s:12:\"delete-51979\";i:51222;s:12:\"delete-51982\";i:51223;s:12:\"delete-51985\";i:51224;s:12:\"delete-51986\";i:51225;s:12:\"delete-51983\";i:51226;s:12:\"delete-51984\";i:51227;s:12:\"delete-51987\";i:51228;s:12:\"delete-51990\";i:51229;s:12:\"delete-51991\";i:51230;s:12:\"delete-51988\";i:51231;s:12:\"delete-51989\";i:51232;s:12:\"delete-51992\";i:51233;s:12:\"delete-51995\";i:51234;s:12:\"delete-51996\";i:51235;s:12:\"delete-51993\";i:51236;s:12:\"delete-51994\";i:51237;s:12:\"delete-51997\";i:51238;s:12:\"delete-52000\";i:51239;s:12:\"delete-52001\";i:51240;s:12:\"delete-51998\";i:51241;s:12:\"delete-51999\";i:51242;s:12:\"delete-52002\";i:51243;s:12:\"delete-52005\";i:51244;s:12:\"delete-52006\";i:51245;s:12:\"delete-52003\";i:51246;s:12:\"delete-52004\";i:51247;s:12:\"delete-52007\";i:51248;s:12:\"delete-52010\";i:51249;s:12:\"delete-52008\";i:51250;s:12:\"delete-52009\";i:51251;s:12:\"delete-52011\";i:51252;s:12:\"delete-52012\";i:51253;s:12:\"delete-52015\";i:51254;s:12:\"delete-52013\";i:51255;s:12:\"delete-52014\";i:51256;s:12:\"delete-52016\";i:51257;s:12:\"delete-52017\";i:51258;s:12:\"delete-52020\";i:51259;s:12:\"delete-52021\";i:51260;s:12:\"delete-52018\";i:51261;s:12:\"delete-52019\";i:51262;s:12:\"delete-52022\";i:51263;s:12:\"delete-52025\";i:51264;s:12:\"delete-52026\";i:51265;s:12:\"delete-52023\";i:51266;s:12:\"delete-52024\";i:51267;s:12:\"delete-52027\";i:51268;s:12:\"delete-52030\";i:51269;s:12:\"delete-52028\";i:51270;s:12:\"delete-52029\";i:51271;s:12:\"delete-52031\";i:51272;s:12:\"delete-52032\";i:51273;s:12:\"delete-52035\";i:51274;s:12:\"delete-52036\";i:51275;s:12:\"delete-52033\";i:51276;s:12:\"delete-52034\";i:51277;s:12:\"delete-52037\";i:51278;s:12:\"delete-52040\";i:51279;s:12:\"delete-52041\";i:51280;s:12:\"delete-52038\";i:51281;s:12:\"delete-52039\";i:51282;s:12:\"delete-52042\";i:51283;s:12:\"delete-52045\";i:51284;s:12:\"delete-52046\";i:51285;s:12:\"delete-52043\";i:51286;s:12:\"delete-52044\";i:51287;s:12:\"delete-52047\";i:51288;s:12:\"delete-52050\";i:51289;s:12:\"delete-52051\";i:51290;s:12:\"delete-52048\";i:51291;s:12:\"delete-52049\";i:51292;s:12:\"delete-52052\";i:51293;s:12:\"delete-52055\";i:51294;s:12:\"delete-52053\";i:51295;s:12:\"delete-52054\";i:51296;s:12:\"delete-52056\";i:51297;s:12:\"delete-52057\";i:51298;s:12:\"delete-52060\";i:51299;s:12:\"delete-52061\";i:51300;s:12:\"delete-52058\";i:51301;s:12:\"delete-52059\";i:51302;s:12:\"delete-52062\";i:51303;s:12:\"delete-52065\";i:51304;s:12:\"delete-52066\";i:51305;s:12:\"delete-52063\";i:51306;s:12:\"delete-52064\";i:51307;s:12:\"delete-52067\";i:51308;s:12:\"delete-52070\";i:51309;s:12:\"delete-52071\";i:51310;s:12:\"delete-52068\";i:51311;s:12:\"delete-52069\";i:51312;s:12:\"delete-52072\";i:51313;s:12:\"delete-52075\";i:51314;s:12:\"delete-52076\";i:51315;s:12:\"delete-52073\";i:51316;s:12:\"delete-52074\";i:51317;s:12:\"delete-52077\";i:51318;s:12:\"delete-52080\";i:51319;s:12:\"delete-52078\";i:51320;s:12:\"delete-52079\";i:51321;s:12:\"delete-52081\";i:51322;s:12:\"delete-52082\";i:51323;s:12:\"delete-52085\";i:51324;s:12:\"delete-52086\";i:51325;s:12:\"delete-52083\";i:51326;s:12:\"delete-52084\";i:51327;s:12:\"delete-52087\";i:51328;s:12:\"delete-52090\";i:51329;s:12:\"delete-52091\";i:51330;s:12:\"delete-52088\";i:51331;s:12:\"delete-52089\";i:51332;s:12:\"delete-52092\";i:51333;s:12:\"delete-52095\";i:51334;s:12:\"delete-52096\";i:51335;s:12:\"delete-52093\";i:51336;s:12:\"delete-52094\";i:51337;s:12:\"delete-52097\";i:51338;s:12:\"delete-52100\";i:51339;s:12:\"delete-52101\";i:51340;s:12:\"delete-52098\";i:51341;s:12:\"delete-52099\";i:51342;s:12:\"delete-52102\";i:51343;s:12:\"delete-52105\";i:51344;s:12:\"delete-52106\";i:51345;s:12:\"delete-52103\";i:51346;s:12:\"delete-52104\";i:51347;s:12:\"delete-52107\";i:51348;s:12:\"delete-52110\";i:51349;s:12:\"delete-52111\";i:51350;s:12:\"delete-52108\";i:51351;s:12:\"delete-52109\";i:51352;s:12:\"delete-52112\";i:51353;s:12:\"delete-52115\";i:51354;s:12:\"delete-52116\";i:51355;s:12:\"delete-52113\";i:51356;s:12:\"delete-52114\";i:51357;s:12:\"delete-52117\";i:51358;s:12:\"delete-52120\";i:51359;s:12:\"delete-52121\";i:51360;s:12:\"delete-52118\";i:51361;s:12:\"delete-52119\";i:51362;s:12:\"delete-52122\";i:51363;s:12:\"delete-52125\";i:51364;s:12:\"delete-52126\";i:51365;s:12:\"delete-52123\";i:51366;s:12:\"delete-52124\";i:51367;s:12:\"delete-52127\";i:51368;s:12:\"delete-52130\";i:51369;s:12:\"delete-52131\";i:51370;s:12:\"delete-52128\";i:51371;s:12:\"delete-52129\";i:51372;s:12:\"delete-52132\";i:51373;s:12:\"delete-52135\";i:51374;s:12:\"delete-52133\";i:51375;s:12:\"delete-52134\";i:51376;s:12:\"delete-52136\";i:51377;s:12:\"delete-52137\";i:51378;s:12:\"delete-52140\";i:51379;s:12:\"delete-52141\";i:51380;s:12:\"delete-52138\";i:51381;s:12:\"delete-52139\";i:51382;s:12:\"delete-52142\";i:51383;s:12:\"delete-52145\";i:51384;s:12:\"delete-52146\";i:51385;s:12:\"delete-52143\";i:51386;s:12:\"delete-52144\";i:51387;s:12:\"delete-52147\";i:51388;s:12:\"delete-52150\";i:51389;s:12:\"delete-52151\";i:51390;s:12:\"delete-52148\";i:51391;s:12:\"delete-52149\";i:51392;s:12:\"delete-52152\";i:51393;s:12:\"delete-52155\";i:51394;s:12:\"delete-52156\";i:51395;s:12:\"delete-52153\";i:51396;s:12:\"delete-52154\";i:51397;s:12:\"delete-52157\";i:51398;s:12:\"delete-52160\";i:51399;s:12:\"delete-52161\";i:51400;s:12:\"delete-52158\";i:51401;s:12:\"delete-52159\";i:51402;s:12:\"delete-52162\";i:51403;s:12:\"delete-52165\";i:51404;s:12:\"delete-52166\";i:51405;s:12:\"delete-52163\";i:51406;s:12:\"delete-52164\";i:51407;s:12:\"delete-52167\";i:51408;s:12:\"delete-52170\";i:51409;s:12:\"delete-52171\";i:51410;s:12:\"delete-52168\";i:51411;s:12:\"delete-52169\";i:51412;s:12:\"delete-52172\";i:51413;s:12:\"delete-52175\";i:51414;s:12:\"delete-52173\";i:51415;s:12:\"delete-52174\";i:51416;s:12:\"delete-52176\";i:51417;s:12:\"delete-52177\";i:51418;s:12:\"delete-52180\";i:51419;s:12:\"delete-52181\";i:51420;s:12:\"delete-52178\";i:51421;s:12:\"delete-52179\";i:51422;s:12:\"delete-52182\";i:51423;s:12:\"delete-52185\";i:51424;s:12:\"delete-52186\";i:51425;s:12:\"delete-52183\";i:51426;s:12:\"delete-52184\";i:51427;s:12:\"delete-52187\";i:51428;s:12:\"delete-52190\";i:51429;s:12:\"delete-52191\";i:51430;s:12:\"delete-52188\";i:51431;s:12:\"delete-52189\";i:51432;s:12:\"delete-52192\";i:51433;s:12:\"delete-52195\";i:51434;s:12:\"delete-52196\";i:51435;s:12:\"delete-52193\";i:51436;s:12:\"delete-52194\";i:51437;s:12:\"delete-52197\";i:51438;s:12:\"delete-52200\";i:51439;s:12:\"delete-52201\";i:51440;s:12:\"delete-52198\";i:51441;s:12:\"delete-52199\";i:51442;s:12:\"delete-52202\";i:51443;s:12:\"delete-52205\";i:51444;s:12:\"delete-52206\";i:51445;s:12:\"delete-52203\";i:51446;s:12:\"delete-52204\";i:51447;s:12:\"delete-52207\";i:51448;s:12:\"delete-52210\";i:51449;s:12:\"delete-52211\";i:51450;s:12:\"delete-52208\";i:51451;s:12:\"delete-52209\";i:51452;s:12:\"delete-52212\";i:51453;s:12:\"delete-52215\";i:51454;s:12:\"delete-52216\";i:51455;s:12:\"delete-52213\";i:51456;s:12:\"delete-52214\";i:51457;s:12:\"delete-52218\";i:51458;s:12:\"delete-52219\";i:51459;s:12:\"delete-52217\";i:51460;s:12:\"delete-52220\";i:51461;s:12:\"delete-52221\";i:51462;s:12:\"delete-52222\";i:51463;s:12:\"delete-52223\";i:51464;s:12:\"delete-52224\";i:51465;s:12:\"delete-52225\";i:51466;s:12:\"delete-52226\";i:51467;s:12:\"delete-52229\";i:51468;s:12:\"delete-52230\";i:51469;s:12:\"delete-52227\";i:51470;s:12:\"delete-52228\";i:51471;s:12:\"delete-52231\";i:51472;s:12:\"delete-52234\";i:51473;s:12:\"delete-52235\";i:51474;s:12:\"delete-52232\";i:51475;s:12:\"delete-52233\";i:51476;s:12:\"delete-52236\";i:51477;s:12:\"delete-52239\";i:51478;s:12:\"delete-52240\";i:51479;s:12:\"delete-52237\";i:51480;s:12:\"delete-52238\";i:51481;s:12:\"delete-52241\";i:51482;s:12:\"delete-52242\";i:51483;s:12:\"delete-52243\";i:51484;s:12:\"delete-52244\";i:51485;s:12:\"delete-52245\";i:51486;s:12:\"delete-52246\";i:51487;s:12:\"delete-52249\";i:51488;s:12:\"delete-52250\";i:51489;s:12:\"delete-52247\";i:51490;s:12:\"delete-52248\";i:51491;s:12:\"delete-52251\";i:51492;s:12:\"delete-52254\";i:51493;s:12:\"delete-52252\";i:51494;s:12:\"delete-52253\";i:51495;s:12:\"delete-52255\";i:51496;s:12:\"delete-52256\";i:51497;s:12:\"delete-52259\";i:51498;s:12:\"delete-52260\";i:51499;s:12:\"delete-52257\";i:51500;s:12:\"delete-52258\";i:51501;s:12:\"delete-52261\";i:51502;s:12:\"delete-52264\";i:51503;s:12:\"delete-52265\";i:51504;s:12:\"delete-52262\";i:51505;s:12:\"delete-52263\";i:51506;s:12:\"delete-52266\";i:51507;s:12:\"delete-52269\";i:51508;s:12:\"delete-52270\";i:51509;s:12:\"delete-52267\";i:51510;s:12:\"delete-52268\";i:51511;s:12:\"delete-52271\";i:51512;s:12:\"delete-52274\";i:51513;s:12:\"delete-52275\";i:51514;s:12:\"delete-52272\";i:51515;s:12:\"delete-52273\";i:51516;s:12:\"delete-52276\";i:51517;s:12:\"delete-52279\";i:51518;s:12:\"delete-52280\";i:51519;s:12:\"delete-52277\";i:51520;s:12:\"delete-52278\";i:51521;s:12:\"delete-52281\";i:51522;s:12:\"delete-52284\";i:51523;s:12:\"delete-52285\";i:51524;s:12:\"delete-52282\";i:51525;s:12:\"delete-52283\";i:51526;s:12:\"delete-52286\";i:51527;s:12:\"delete-52289\";i:51528;s:12:\"delete-52287\";i:51529;s:12:\"delete-52288\";i:51530;s:12:\"delete-52290\";i:51531;s:12:\"delete-52291\";i:51532;s:12:\"delete-52294\";i:51533;s:12:\"delete-52295\";i:51534;s:12:\"delete-52292\";i:51535;s:12:\"delete-52293\";i:51536;s:12:\"delete-52296\";i:51537;s:12:\"delete-52299\";i:51538;s:12:\"delete-52300\";i:51539;s:12:\"delete-52297\";i:51540;s:12:\"delete-52298\";i:51541;s:12:\"delete-52301\";i:51542;s:12:\"delete-52304\";i:51543;s:12:\"delete-52305\";i:51544;s:12:\"delete-52302\";i:51545;s:12:\"delete-52303\";i:51546;s:12:\"delete-52306\";i:51547;s:12:\"delete-52309\";i:51548;s:12:\"delete-52310\";i:51549;s:12:\"delete-52307\";i:51550;s:12:\"delete-52308\";i:51551;s:12:\"delete-52311\";i:51552;s:12:\"delete-52314\";i:51553;s:12:\"delete-52315\";i:51554;s:12:\"delete-52312\";i:51555;s:12:\"delete-52313\";i:51556;s:12:\"delete-52316\";i:51557;s:12:\"delete-52319\";i:51558;s:12:\"delete-52320\";i:51559;s:12:\"delete-52317\";i:51560;s:12:\"delete-52318\";i:51561;s:12:\"delete-52321\";i:51562;s:12:\"delete-52324\";i:51563;s:12:\"delete-52322\";i:51564;s:12:\"delete-52323\";i:51565;s:12:\"delete-52325\";i:51566;s:12:\"delete-52326\";i:51567;s:12:\"delete-52329\";i:51568;s:12:\"delete-52330\";i:51569;s:12:\"delete-52327\";i:51570;s:12:\"delete-52328\";i:51571;s:12:\"delete-52331\";i:51572;s:12:\"delete-52334\";i:51573;s:12:\"delete-52335\";i:51574;s:12:\"delete-52332\";i:51575;s:12:\"delete-52333\";i:51576;s:12:\"delete-52336\";i:51577;s:12:\"delete-52339\";i:51578;s:12:\"delete-52340\";i:51579;s:12:\"delete-52337\";i:51580;s:12:\"delete-52338\";i:51581;s:12:\"delete-52341\";i:51582;s:12:\"delete-52344\";i:51583;s:12:\"delete-52345\";i:51584;s:12:\"delete-52342\";i:51585;s:12:\"delete-52343\";i:51586;s:12:\"delete-52346\";i:51587;s:12:\"delete-52349\";i:51588;s:12:\"delete-52347\";i:51589;s:12:\"delete-52348\";i:51590;s:12:\"delete-52350\";i:51591;s:12:\"delete-52351\";i:51592;s:12:\"delete-52354\";i:51593;s:12:\"delete-52352\";i:51594;s:12:\"delete-52353\";i:51595;s:12:\"delete-52355\";i:51596;s:12:\"delete-52356\";i:51597;s:12:\"delete-52359\";i:51598;s:12:\"delete-52360\";i:51599;s:12:\"delete-52357\";i:51600;s:12:\"delete-52358\";i:51601;s:12:\"delete-52361\";i:51602;s:12:\"delete-52364\";i:51603;s:12:\"delete-52365\";i:51604;s:12:\"delete-52362\";i:51605;s:12:\"delete-52363\";i:51606;s:12:\"delete-52366\";i:51607;s:12:\"delete-52369\";i:51608;s:12:\"delete-52370\";i:51609;s:12:\"delete-52367\";i:51610;s:12:\"delete-52368\";i:51611;s:12:\"delete-52371\";i:51612;s:12:\"delete-52374\";i:51613;s:12:\"delete-52375\";i:51614;s:12:\"delete-52372\";i:51615;s:12:\"delete-52373\";i:51616;s:12:\"delete-52376\";i:51617;s:12:\"delete-52379\";i:51618;s:12:\"delete-52380\";i:51619;s:12:\"delete-52377\";i:51620;s:12:\"delete-52378\";i:51621;s:12:\"delete-52381\";i:51622;s:12:\"delete-52384\";i:51623;s:12:\"delete-52385\";i:51624;s:12:\"delete-52382\";i:51625;s:12:\"delete-52383\";i:51626;s:12:\"delete-52386\";i:51627;s:12:\"delete-52389\";i:51628;s:12:\"delete-52387\";i:51629;s:12:\"delete-52388\";i:51630;s:12:\"delete-52390\";i:51631;s:12:\"delete-52391\";i:51632;s:12:\"delete-52394\";i:51633;s:12:\"delete-52395\";i:51634;s:12:\"delete-52392\";i:51635;s:12:\"delete-52393\";i:51636;s:12:\"delete-52396\";i:51637;s:12:\"delete-52399\";i:51638;s:12:\"delete-52400\";i:51639;s:12:\"delete-52397\";i:51640;s:12:\"delete-52398\";i:51641;s:12:\"delete-52401\";i:51642;s:12:\"delete-52404\";i:51643;s:12:\"delete-52405\";i:51644;s:12:\"delete-52402\";i:51645;s:12:\"delete-52403\";i:51646;s:12:\"delete-52406\";i:51647;s:12:\"delete-52409\";i:51648;s:12:\"delete-52410\";i:51649;s:12:\"delete-52407\";i:51650;s:12:\"delete-52408\";i:51651;s:12:\"delete-52411\";i:51652;s:12:\"delete-52414\";i:51653;s:12:\"delete-52415\";i:51654;s:12:\"delete-52412\";i:51655;s:12:\"delete-52413\";i:51656;s:12:\"delete-52416\";i:51657;s:12:\"delete-52419\";i:51658;s:12:\"delete-52420\";i:51659;s:12:\"delete-52417\";i:51660;s:12:\"delete-52418\";i:51661;s:12:\"delete-52421\";i:51662;s:12:\"delete-52424\";i:51663;s:12:\"delete-52425\";i:51664;s:12:\"delete-52422\";i:51665;s:12:\"delete-52423\";i:51666;s:12:\"delete-52426\";i:51667;s:12:\"delete-52429\";i:51668;s:12:\"delete-52430\";i:51669;s:12:\"delete-52427\";i:51670;s:12:\"delete-52428\";i:51671;s:12:\"delete-52431\";i:51672;s:12:\"delete-52434\";i:51673;s:12:\"delete-52435\";i:51674;s:12:\"delete-52432\";i:51675;s:12:\"delete-52433\";i:51676;s:12:\"delete-52436\";i:51677;s:12:\"delete-52439\";i:51678;s:12:\"delete-52440\";i:51679;s:12:\"delete-52437\";i:51680;s:12:\"delete-52438\";i:51681;s:12:\"delete-52441\";i:51682;s:12:\"delete-52444\";i:51683;s:12:\"delete-52442\";i:51684;s:12:\"delete-52443\";i:51685;s:12:\"delete-52445\";i:51686;s:12:\"delete-52446\";i:51687;s:12:\"delete-52449\";i:51688;s:12:\"delete-52450\";i:51689;s:12:\"delete-52447\";i:51690;s:12:\"delete-52448\";i:51691;s:12:\"delete-52451\";i:51692;s:12:\"delete-52454\";i:51693;s:12:\"delete-52455\";i:51694;s:12:\"delete-52452\";i:51695;s:12:\"delete-52453\";i:51696;s:12:\"delete-52456\";i:51697;s:12:\"delete-52459\";i:51698;s:12:\"delete-52460\";i:51699;s:12:\"delete-52457\";i:51700;s:12:\"delete-52458\";i:51701;s:12:\"delete-52461\";i:51702;s:12:\"delete-52464\";i:51703;s:12:\"delete-52462\";i:51704;s:12:\"delete-52463\";i:51705;s:12:\"delete-52465\";i:51706;s:12:\"delete-52466\";i:51707;s:12:\"delete-52469\";i:51708;s:12:\"delete-52470\";i:51709;s:12:\"delete-52467\";i:51710;s:12:\"delete-52468\";i:51711;s:12:\"delete-52471\";i:51712;s:12:\"delete-52474\";i:51713;s:12:\"delete-52475\";i:51714;s:12:\"delete-52472\";i:51715;s:12:\"delete-52473\";i:51716;s:12:\"delete-52476\";i:51717;s:12:\"delete-52479\";i:51718;s:12:\"delete-52480\";i:51719;s:12:\"delete-52477\";i:51720;s:12:\"delete-52478\";i:51721;s:12:\"delete-52481\";i:51722;s:12:\"delete-52484\";i:51723;s:12:\"delete-52485\";i:51724;s:12:\"delete-52482\";i:51725;s:12:\"delete-52483\";i:51726;s:12:\"delete-52486\";i:51727;s:12:\"delete-52489\";i:51728;s:12:\"delete-52490\";i:51729;s:12:\"delete-52487\";i:51730;s:12:\"delete-52488\";i:51731;s:12:\"delete-52491\";i:51732;s:12:\"delete-52494\";i:51733;s:12:\"delete-52495\";i:51734;s:12:\"delete-52492\";i:51735;s:12:\"delete-52493\";i:51736;s:12:\"delete-52496\";i:51737;s:12:\"delete-52499\";i:51738;s:12:\"delete-52500\";i:51739;s:12:\"delete-52497\";i:51740;s:12:\"delete-52498\";i:51741;s:12:\"delete-52501\";i:51742;s:12:\"delete-52504\";i:51743;s:12:\"delete-52505\";i:51744;s:12:\"delete-52502\";i:51745;s:12:\"delete-52503\";i:51746;s:12:\"delete-52506\";i:51747;s:12:\"delete-52509\";i:51748;s:12:\"delete-52510\";i:51749;s:12:\"delete-52507\";i:51750;s:12:\"delete-52508\";i:51751;s:12:\"delete-52511\";i:51752;s:12:\"delete-52512\";i:51753;s:12:\"delete-52513\";i:51754;s:12:\"delete-52514\";i:51755;s:12:\"delete-52515\";i:51756;s:12:\"delete-52516\";i:51757;s:12:\"delete-52519\";i:51758;s:12:\"delete-52520\";i:51759;s:12:\"delete-52517\";i:51760;s:12:\"delete-52518\";i:51761;s:12:\"delete-52521\";i:51762;s:12:\"delete-52524\";i:51763;s:12:\"delete-52525\";i:51764;s:12:\"delete-52522\";i:51765;s:12:\"delete-52523\";i:51766;s:12:\"delete-52526\";i:51767;s:12:\"delete-52529\";i:51768;s:12:\"delete-52527\";i:51769;s:12:\"delete-52528\";i:51770;s:12:\"delete-52530\";i:51771;s:12:\"delete-52531\";i:51772;s:12:\"delete-52534\";i:51773;s:12:\"delete-52535\";i:51774;s:12:\"delete-52532\";i:51775;s:12:\"delete-52533\";i:51776;s:12:\"delete-52536\";i:51777;s:12:\"delete-52539\";i:51778;s:12:\"delete-52540\";i:51779;s:12:\"delete-52537\";i:51780;s:12:\"delete-52538\";i:51781;s:12:\"delete-52541\";i:51782;s:12:\"delete-52544\";i:51783;s:12:\"delete-52545\";i:51784;s:12:\"delete-52542\";i:51785;s:12:\"delete-52543\";i:51786;s:12:\"delete-52546\";i:51787;s:12:\"delete-52549\";i:51788;s:12:\"delete-52550\";i:51789;s:12:\"delete-52547\";i:51790;s:12:\"delete-52548\";i:51791;s:12:\"delete-52551\";i:51792;s:12:\"delete-52554\";i:51793;s:12:\"delete-52552\";i:51794;s:12:\"delete-52553\";i:51795;s:12:\"delete-52555\";i:51796;s:12:\"delete-52556\";i:51797;s:12:\"delete-52559\";i:51798;s:12:\"delete-52560\";i:51799;s:12:\"delete-52557\";i:51800;s:12:\"delete-52558\";i:51801;s:12:\"delete-52561\";i:51802;s:12:\"delete-52564\";i:51803;s:12:\"delete-52562\";i:51804;s:12:\"delete-52563\";i:51805;s:12:\"delete-52565\";i:51806;s:12:\"delete-52566\";i:51807;s:12:\"delete-52569\";i:51808;s:12:\"delete-52570\";i:51809;s:12:\"delete-52567\";i:51810;s:12:\"delete-52568\";i:51811;s:12:\"delete-52571\";i:51812;s:12:\"delete-52574\";i:51813;s:12:\"delete-52575\";i:51814;s:12:\"delete-52572\";i:51815;s:12:\"delete-52573\";i:51816;s:12:\"delete-52576\";i:51817;s:12:\"delete-52579\";i:51818;s:12:\"delete-52580\";i:51819;s:12:\"delete-52577\";i:51820;s:12:\"delete-52578\";i:51821;s:12:\"delete-52581\";i:51822;s:12:\"delete-52584\";i:51823;s:12:\"delete-52582\";i:51824;s:12:\"delete-52583\";i:51825;s:12:\"delete-52585\";i:51826;s:12:\"delete-52586\";i:51827;s:12:\"delete-52589\";i:51828;s:12:\"delete-52590\";i:51829;s:12:\"delete-52587\";i:51830;s:12:\"delete-52588\";i:51831;s:12:\"delete-52591\";i:51832;s:12:\"delete-52594\";i:51833;s:12:\"delete-52595\";i:51834;s:12:\"delete-52592\";i:51835;s:12:\"delete-52593\";i:51836;s:12:\"delete-52596\";i:51837;s:12:\"delete-52599\";i:51838;s:12:\"delete-52600\";i:51839;s:12:\"delete-52597\";i:51840;s:12:\"delete-52598\";i:51841;s:12:\"delete-52601\";i:51842;s:12:\"delete-52604\";i:51843;s:12:\"delete-52605\";i:51844;s:12:\"delete-52602\";i:51845;s:12:\"delete-52603\";i:51846;s:12:\"delete-52606\";i:51847;s:12:\"delete-52609\";i:51848;s:12:\"delete-52610\";i:51849;s:12:\"delete-52607\";i:51850;s:12:\"delete-52608\";i:51851;s:12:\"delete-52611\";i:51852;s:12:\"delete-52614\";i:51853;s:12:\"delete-52615\";i:51854;s:12:\"delete-52612\";i:51855;s:12:\"delete-52613\";i:51856;s:12:\"delete-52616\";i:51857;s:12:\"delete-52619\";i:51858;s:12:\"delete-52620\";i:51859;s:12:\"delete-52617\";i:51860;s:12:\"delete-52618\";i:51861;s:12:\"delete-52621\";i:51862;s:12:\"delete-52624\";i:51863;s:12:\"delete-52622\";i:51864;s:12:\"delete-52623\";i:51865;s:12:\"delete-52625\";i:51866;s:12:\"delete-52626\";i:51867;s:12:\"delete-52629\";i:51868;s:12:\"delete-52630\";i:51869;s:12:\"delete-52627\";i:51870;s:12:\"delete-52628\";i:51871;s:12:\"delete-52631\";i:51872;s:12:\"delete-52634\";i:51873;s:12:\"delete-52635\";i:51874;s:12:\"delete-52632\";i:51875;s:12:\"delete-52633\";i:51876;s:12:\"delete-52636\";i:51877;s:12:\"delete-52639\";i:51878;s:12:\"delete-52640\";i:51879;s:12:\"delete-52637\";i:51880;s:12:\"delete-52638\";i:51881;s:12:\"delete-52641\";i:51882;s:12:\"delete-52644\";i:51883;s:12:\"delete-52645\";i:51884;s:12:\"delete-52642\";i:51885;s:12:\"delete-52643\";i:51886;s:12:\"delete-52646\";i:51887;s:12:\"delete-52649\";i:51888;s:12:\"delete-52650\";i:51889;s:12:\"delete-52647\";i:51890;s:12:\"delete-52648\";i:51891;s:12:\"delete-52651\";i:51892;s:12:\"delete-52654\";i:51893;s:12:\"delete-52655\";i:51894;s:12:\"delete-52652\";i:51895;s:12:\"delete-52653\";i:51896;s:12:\"delete-52656\";i:51897;s:12:\"delete-52659\";i:51898;s:12:\"delete-52660\";i:51899;s:12:\"delete-52657\";i:51900;s:12:\"delete-52658\";i:51901;s:12:\"delete-52661\";i:51902;s:12:\"delete-52664\";i:51903;s:12:\"delete-52665\";i:51904;s:12:\"delete-52662\";i:51905;s:12:\"delete-52663\";i:51906;s:12:\"delete-52666\";i:51907;s:12:\"delete-52669\";i:51908;s:12:\"delete-52667\";i:51909;s:12:\"delete-52668\";i:51910;s:12:\"delete-52670\";i:51911;s:12:\"delete-52671\";i:51912;s:12:\"delete-52674\";i:51913;s:12:\"delete-52675\";i:51914;s:12:\"delete-52672\";i:51915;s:12:\"delete-52673\";i:51916;s:12:\"delete-52676\";i:51917;s:12:\"delete-52679\";i:51918;s:12:\"delete-52680\";i:51919;s:12:\"delete-52677\";i:51920;s:12:\"delete-52678\";i:51921;s:12:\"delete-52681\";i:51922;s:12:\"delete-52684\";i:51923;s:12:\"delete-52685\";i:51924;s:12:\"delete-52682\";i:51925;s:12:\"delete-52683\";i:51926;s:12:\"delete-52686\";i:51927;s:12:\"delete-52689\";i:51928;s:12:\"delete-52690\";i:51929;s:12:\"delete-52687\";i:51930;s:12:\"delete-52688\";i:51931;s:12:\"delete-52691\";i:51932;s:12:\"delete-52694\";i:51933;s:12:\"delete-52695\";i:51934;s:12:\"delete-52692\";i:51935;s:12:\"delete-52693\";i:51936;s:12:\"delete-52696\";i:51937;s:12:\"delete-52699\";i:51938;s:12:\"delete-52700\";i:51939;s:12:\"delete-52697\";i:51940;s:12:\"delete-52698\";i:51941;s:12:\"delete-52701\";i:51942;s:12:\"delete-52704\";i:51943;s:12:\"delete-52705\";i:51944;s:12:\"delete-52702\";i:51945;s:12:\"delete-52703\";i:51946;s:12:\"delete-52706\";i:51947;s:12:\"delete-52709\";i:51948;s:12:\"delete-52707\";i:51949;s:12:\"delete-52708\";i:51950;s:12:\"delete-52710\";i:51951;s:12:\"delete-52711\";i:51952;s:12:\"delete-52714\";i:51953;s:12:\"delete-52715\";i:51954;s:12:\"delete-52712\";i:51955;s:12:\"delete-52713\";i:51956;s:12:\"delete-52716\";i:51957;s:12:\"delete-52719\";i:51958;s:12:\"delete-52720\";i:51959;s:12:\"delete-52717\";i:51960;s:12:\"delete-52718\";i:51961;s:12:\"delete-52721\";i:51962;s:12:\"delete-52724\";i:51963;s:12:\"delete-52722\";i:51964;s:12:\"delete-52723\";i:51965;s:12:\"delete-52725\";i:51966;s:12:\"delete-52726\";i:51967;s:12:\"delete-52729\";i:51968;s:12:\"delete-52730\";i:51969;s:12:\"delete-52727\";i:51970;s:12:\"delete-52728\";i:51971;s:12:\"delete-52731\";i:51972;s:12:\"delete-52734\";i:51973;s:12:\"delete-52732\";i:51974;s:12:\"delete-52733\";i:51975;s:12:\"delete-52735\";i:51976;s:12:\"delete-52736\";i:51977;s:12:\"delete-52739\";i:51978;s:12:\"delete-52740\";i:51979;s:12:\"delete-52737\";i:51980;s:12:\"delete-52738\";i:51981;s:12:\"delete-52741\";i:51982;s:12:\"delete-52744\";i:51983;s:12:\"delete-52745\";i:51984;s:12:\"delete-52742\";i:51985;s:12:\"delete-52743\";i:51986;s:12:\"delete-52746\";i:51987;s:12:\"delete-52749\";i:51988;s:12:\"delete-52750\";i:51989;s:12:\"delete-52747\";i:51990;s:12:\"delete-52748\";i:51991;s:12:\"delete-52751\";i:51992;s:12:\"delete-52754\";i:51993;s:12:\"delete-52755\";i:51994;s:12:\"delete-52752\";i:51995;s:12:\"delete-52753\";i:51996;s:12:\"delete-52756\";i:51997;s:12:\"delete-52759\";i:51998;s:12:\"delete-52760\";i:51999;s:12:\"delete-52757\";i:52000;s:12:\"delete-52758\";i:52001;s:12:\"delete-52761\";i:52002;s:12:\"delete-52764\";i:52003;s:12:\"delete-52765\";i:52004;s:12:\"delete-52762\";i:52005;s:12:\"delete-52763\";i:52006;s:12:\"delete-52766\";i:52007;s:12:\"delete-52769\";i:52008;s:12:\"delete-52770\";i:52009;s:12:\"delete-52767\";i:52010;s:12:\"delete-52768\";i:52011;s:12:\"delete-52771\";i:52012;s:12:\"delete-52774\";i:52013;s:12:\"delete-52775\";i:52014;s:12:\"delete-52772\";i:52015;s:12:\"delete-52773\";i:52016;s:12:\"delete-52776\";i:52017;s:12:\"delete-52779\";i:52018;s:12:\"delete-52780\";i:52019;s:12:\"delete-52777\";i:52020;s:12:\"delete-52778\";i:52021;s:12:\"delete-52781\";i:52022;s:12:\"delete-52784\";i:52023;s:12:\"delete-52785\";i:52024;s:12:\"delete-52782\";i:52025;s:12:\"delete-52783\";i:52026;s:12:\"delete-52786\";i:52027;s:12:\"delete-52789\";i:52028;s:12:\"delete-52790\";i:52029;s:12:\"delete-52787\";i:52030;s:12:\"delete-52788\";i:52031;s:12:\"delete-52791\";i:52032;s:12:\"delete-52794\";i:52033;s:12:\"delete-52795\";i:52034;s:12:\"delete-52792\";i:52035;s:12:\"delete-52793\";i:52036;s:12:\"delete-52796\";i:52037;s:12:\"delete-52799\";i:52038;s:12:\"delete-52800\";i:52039;s:12:\"delete-52797\";i:52040;s:12:\"delete-52798\";i:52041;s:12:\"delete-52801\";i:52042;s:12:\"delete-52804\";i:52043;s:12:\"delete-52805\";i:52044;s:12:\"delete-52806\";i:52045;s:12:\"delete-52809\";i:52046;s:12:\"delete-52802\";i:52047;s:12:\"delete-52803\";i:52048;s:12:\"delete-52807\";i:52049;s:12:\"delete-52808\";i:52050;s:12:\"delete-52810\";i:52051;s:12:\"delete-52811\";i:52052;s:12:\"delete-52814\";i:52053;s:12:\"delete-52815\";i:52054;s:12:\"delete-52812\";i:52055;s:12:\"delete-52813\";i:52056;s:12:\"delete-52816\";i:52057;s:12:\"delete-52819\";i:52058;s:12:\"delete-52820\";i:52059;s:12:\"delete-52817\";i:52060;s:12:\"delete-52818\";i:52061;s:12:\"delete-52821\";i:52062;s:12:\"delete-52822\";i:52063;s:12:\"delete-52823\";i:52064;s:12:\"delete-52824\";i:52065;s:12:\"delete-52825\";i:52066;s:12:\"delete-52826\";i:52067;s:12:\"delete-52829\";i:52068;s:12:\"delete-52830\";i:52069;s:12:\"delete-52827\";i:52070;s:12:\"delete-52828\";i:52071;s:12:\"delete-52831\";i:52072;s:12:\"delete-52834\";i:52073;s:12:\"delete-52835\";i:52074;s:12:\"delete-52832\";i:52075;s:12:\"delete-52833\";i:52076;s:12:\"delete-52836\";i:52077;s:12:\"delete-52839\";i:52078;s:12:\"delete-52837\";i:52079;s:12:\"delete-52838\";i:52080;s:12:\"delete-52840\";i:52081;s:12:\"delete-52841\";i:52082;s:12:\"delete-52844\";i:52083;s:12:\"delete-52845\";i:52084;s:12:\"delete-52842\";i:52085;s:12:\"delete-52843\";i:52086;s:12:\"delete-52846\";i:52087;s:12:\"delete-52849\";i:52088;s:12:\"delete-52850\";i:52089;s:12:\"delete-52847\";i:52090;s:12:\"delete-52848\";i:52091;s:12:\"delete-52851\";i:52092;s:12:\"delete-52854\";i:52093;s:12:\"delete-52855\";i:52094;s:12:\"delete-52852\";i:52095;s:12:\"delete-52853\";i:52096;s:12:\"delete-52856\";i:52097;s:12:\"delete-52859\";i:52098;s:12:\"delete-52860\";i:52099;s:12:\"delete-52857\";i:52100;s:12:\"delete-52858\";i:52101;s:12:\"delete-52861\";i:52102;s:12:\"delete-52864\";i:52103;s:12:\"delete-52865\";i:52104;s:12:\"delete-52862\";i:52105;s:12:\"delete-52863\";i:52106;s:12:\"delete-52866\";i:52107;s:12:\"delete-52869\";i:52108;s:12:\"delete-52870\";i:52109;s:12:\"delete-52867\";i:52110;s:12:\"delete-52868\";i:52111;s:12:\"delete-52871\";i:52112;s:12:\"delete-52874\";i:52113;s:12:\"delete-52875\";i:52114;s:12:\"delete-52872\";i:52115;s:12:\"delete-52873\";i:52116;s:12:\"delete-52876\";i:52117;s:12:\"delete-52879\";i:52118;s:12:\"delete-52880\";i:52119;s:12:\"delete-52877\";i:52120;s:12:\"delete-52878\";i:52121;s:12:\"delete-52881\";i:52122;s:12:\"delete-52884\";i:52123;s:12:\"delete-52885\";i:52124;s:12:\"delete-52882\";i:52125;s:12:\"delete-52883\";i:52126;s:12:\"delete-52886\";i:52127;s:12:\"delete-52889\";i:52128;s:12:\"delete-52890\";i:52129;s:12:\"delete-52887\";i:52130;s:12:\"delete-52888\";i:52131;s:12:\"delete-52891\";i:52132;s:12:\"delete-52894\";i:52133;s:12:\"delete-52895\";i:52134;s:12:\"delete-52892\";i:52135;s:12:\"delete-52893\";i:52136;s:12:\"delete-52896\";i:52137;s:12:\"delete-52899\";i:52138;s:12:\"delete-52900\";i:52139;s:12:\"delete-52897\";i:52140;s:12:\"delete-52898\";i:52141;s:12:\"delete-52901\";i:52142;s:12:\"delete-52904\";i:52143;s:12:\"delete-52905\";i:52144;s:12:\"delete-52902\";i:52145;s:12:\"delete-52903\";i:52146;s:12:\"delete-52906\";i:52147;s:12:\"delete-52909\";i:52148;s:12:\"delete-52910\";i:52149;s:12:\"delete-52907\";i:52150;s:12:\"delete-52908\";i:52151;s:12:\"delete-52911\";i:52152;s:12:\"delete-52914\";i:52153;s:12:\"delete-52912\";i:52154;s:12:\"delete-52913\";i:52155;s:12:\"delete-52915\";i:52156;s:12:\"delete-52916\";i:52157;s:12:\"delete-52919\";i:52158;s:12:\"delete-52920\";i:52159;s:12:\"delete-52917\";i:52160;s:12:\"delete-52918\";i:52161;s:12:\"delete-52921\";i:52162;s:12:\"delete-52924\";i:52163;s:12:\"delete-52925\";i:52164;s:12:\"delete-52926\";i:52165;s:12:\"delete-52929\";i:52166;s:12:\"delete-52930\";i:52167;s:12:\"delete-52922\";i:52168;s:12:\"delete-52923\";i:52169;s:12:\"delete-52927\";i:52170;s:12:\"delete-52928\";i:52171;s:12:\"delete-52931\";i:52172;s:12:\"delete-52934\";i:52173;s:12:\"delete-52932\";i:52174;s:12:\"delete-52933\";i:52175;s:12:\"delete-52935\";i:52176;s:12:\"delete-52936\";i:52177;s:12:\"delete-52939\";i:52178;s:12:\"delete-52937\";i:52179;s:12:\"delete-52938\";i:52180;s:12:\"delete-52940\";i:52181;s:12:\"delete-52941\";i:52182;s:12:\"delete-52944\";i:52183;s:12:\"delete-52945\";i:52184;s:12:\"delete-52942\";i:52185;s:12:\"delete-52943\";i:52186;s:12:\"delete-52946\";i:52187;s:12:\"delete-52949\";i:52188;s:12:\"delete-52950\";i:52189;s:12:\"delete-52947\";i:52190;s:12:\"delete-52948\";i:52191;s:12:\"delete-52951\";i:52192;s:12:\"delete-52954\";i:52193;s:12:\"delete-52955\";i:52194;s:12:\"delete-52952\";i:52195;s:12:\"delete-52953\";i:52196;s:12:\"delete-52956\";i:52197;s:12:\"delete-52959\";i:52198;s:12:\"delete-52960\";i:52199;s:12:\"delete-52957\";i:52200;s:12:\"delete-52958\";i:52201;s:12:\"delete-52961\";i:52202;s:12:\"delete-52964\";i:52203;s:12:\"delete-52965\";i:52204;s:12:\"delete-52962\";i:52205;s:12:\"delete-52963\";i:52206;s:12:\"delete-52966\";i:52207;s:12:\"delete-52969\";i:52208;s:12:\"delete-52970\";i:52209;s:12:\"delete-52967\";i:52210;s:12:\"delete-52968\";i:52211;s:12:\"delete-52971\";i:52212;s:12:\"delete-52974\";i:52213;s:12:\"delete-52975\";i:52214;s:12:\"delete-52972\";i:52215;s:12:\"delete-52973\";i:52216;s:12:\"delete-52976\";i:52217;s:12:\"delete-52979\";i:52218;s:12:\"delete-52980\";i:52219;s:12:\"delete-52977\";i:52220;s:12:\"delete-52978\";i:52221;s:12:\"delete-52981\";i:52222;s:12:\"delete-52984\";i:52223;s:12:\"delete-52985\";i:52224;s:12:\"delete-52982\";i:52225;s:12:\"delete-52983\";i:52226;s:12:\"delete-52986\";i:52227;s:12:\"delete-52989\";i:52228;s:12:\"delete-52990\";i:52229;s:12:\"delete-52987\";i:52230;s:12:\"delete-52988\";i:52231;s:12:\"delete-52991\";i:52232;s:12:\"delete-52994\";i:52233;s:12:\"delete-52995\";i:52234;s:12:\"delete-52992\";i:52235;s:12:\"delete-52993\";i:52236;s:12:\"delete-52996\";i:52237;s:12:\"delete-52997\";i:52238;s:12:\"delete-52998\";i:52239;s:12:\"delete-52999\";i:52240;s:12:\"delete-53000\";i:52241;s:12:\"delete-53001\";i:52242;s:12:\"delete-53004\";i:52243;s:12:\"delete-53002\";i:52244;s:12:\"delete-53003\";i:52245;s:12:\"delete-53005\";i:52246;s:12:\"delete-53006\";i:52247;s:12:\"delete-53009\";i:52248;s:12:\"delete-53007\";i:52249;s:12:\"delete-53008\";i:52250;s:12:\"delete-53010\";i:52251;s:12:\"delete-53011\";i:52252;s:12:\"delete-53014\";i:52253;s:12:\"delete-53015\";i:52254;s:12:\"delete-53012\";i:52255;s:12:\"delete-53013\";i:52256;s:12:\"delete-53016\";i:52257;s:12:\"delete-53019\";i:52258;s:12:\"delete-53020\";i:52259;s:12:\"delete-53017\";i:52260;s:12:\"delete-53018\";i:52261;s:12:\"delete-53021\";i:52262;s:12:\"delete-53024\";i:52263;s:12:\"delete-53025\";i:52264;s:12:\"delete-53022\";i:52265;s:12:\"delete-53023\";i:52266;s:12:\"delete-53026\";i:52267;s:12:\"delete-53029\";i:52268;s:12:\"delete-53027\";i:52269;s:12:\"delete-53028\";i:52270;s:12:\"delete-53030\";i:52271;s:12:\"delete-53031\";i:52272;s:12:\"delete-53034\";i:52273;s:12:\"delete-53035\";i:52274;s:12:\"delete-53032\";i:52275;s:12:\"delete-53033\";i:52276;s:12:\"delete-53036\";i:52277;s:12:\"delete-53039\";i:52278;s:12:\"delete-53040\";i:52279;s:12:\"delete-53037\";i:52280;s:12:\"delete-53038\";i:52281;s:12:\"delete-53041\";i:52282;s:12:\"delete-53044\";i:52283;s:12:\"delete-53045\";i:52284;s:12:\"delete-53042\";i:52285;s:12:\"delete-53043\";i:52286;s:12:\"delete-53046\";i:52287;s:12:\"delete-53049\";i:52288;s:12:\"delete-53050\";i:52289;s:12:\"delete-53047\";i:52290;s:12:\"delete-53048\";i:52291;s:12:\"delete-53051\";i:52292;s:12:\"delete-53054\";i:52293;s:12:\"delete-53055\";i:52294;s:12:\"delete-53052\";i:52295;s:12:\"delete-53053\";i:52296;s:12:\"delete-53056\";i:52297;s:12:\"delete-53059\";i:52298;s:12:\"delete-53060\";i:52299;s:12:\"delete-53057\";i:52300;s:12:\"delete-53058\";i:52301;s:12:\"delete-53061\";i:52302;s:12:\"delete-53064\";i:52303;s:12:\"delete-53065\";i:52304;s:12:\"delete-53062\";i:52305;s:12:\"delete-53063\";i:52306;s:12:\"delete-53066\";i:52307;s:12:\"delete-53069\";i:52308;s:12:\"delete-53070\";i:52309;s:12:\"delete-53067\";i:52310;s:12:\"delete-53068\";i:52311;s:12:\"delete-53071\";i:52312;s:12:\"delete-53074\";i:52313;s:12:\"delete-53075\";i:52314;s:12:\"delete-53072\";i:52315;s:12:\"delete-53073\";i:52316;s:12:\"delete-53076\";i:52317;s:12:\"delete-53079\";i:52318;s:12:\"delete-53077\";i:52319;s:12:\"delete-53078\";i:52320;s:12:\"delete-53080\";i:52321;s:12:\"delete-53081\";i:52322;s:12:\"delete-53084\";i:52323;s:12:\"delete-53085\";i:52324;s:12:\"delete-53082\";i:52325;s:12:\"delete-53083\";i:52326;s:12:\"delete-53086\";i:52327;s:12:\"delete-53089\";i:52328;s:12:\"delete-53090\";i:52329;s:12:\"delete-53087\";i:52330;s:12:\"delete-53088\";i:52331;s:12:\"delete-53091\";i:52332;s:12:\"delete-53094\";i:52333;s:12:\"delete-53095\";i:52334;s:12:\"delete-53092\";i:52335;s:12:\"delete-53093\";i:52336;s:12:\"delete-53096\";i:52337;s:12:\"delete-53099\";i:52338;s:12:\"delete-53100\";i:52339;s:12:\"delete-53097\";i:52340;s:12:\"delete-53098\";i:52341;s:12:\"delete-53101\";i:52342;s:12:\"delete-53104\";i:52343;s:12:\"delete-53105\";i:52344;s:12:\"delete-53102\";i:52345;s:12:\"delete-53103\";i:52346;s:12:\"delete-53106\";i:52347;s:12:\"delete-53109\";i:52348;s:12:\"delete-53110\";i:52349;s:12:\"delete-53107\";i:52350;s:12:\"delete-53108\";i:52351;s:12:\"delete-53111\";i:52352;s:12:\"delete-53114\";i:52353;s:12:\"delete-53115\";i:52354;s:12:\"delete-53112\";i:52355;s:12:\"delete-53113\";i:52356;s:12:\"delete-53116\";i:52357;s:12:\"delete-53119\";i:52358;s:12:\"delete-53120\";i:52359;s:12:\"delete-53117\";i:52360;s:12:\"delete-53118\";i:52361;s:12:\"delete-53121\";i:52362;s:12:\"delete-53124\";i:52363;s:12:\"delete-53125\";i:52364;s:12:\"delete-53122\";i:52365;s:12:\"delete-53123\";i:52366;s:12:\"delete-53126\";i:52367;s:12:\"delete-53129\";i:52368;s:12:\"delete-53130\";i:52369;s:12:\"delete-53127\";i:52370;s:12:\"delete-53128\";i:52371;s:12:\"delete-53131\";i:52372;s:12:\"delete-53134\";i:52373;s:12:\"delete-53132\";i:52374;s:12:\"delete-53133\";i:52375;s:12:\"delete-53135\";i:52376;s:12:\"delete-53136\";i:52377;s:12:\"delete-53139\";i:52378;s:12:\"delete-53140\";i:52379;s:12:\"delete-53137\";i:52380;s:12:\"delete-53138\";i:52381;s:12:\"delete-53141\";i:52382;s:12:\"delete-53144\";i:52383;s:12:\"delete-53145\";i:52384;s:12:\"delete-53142\";i:52385;s:12:\"delete-53143\";i:52386;s:12:\"delete-53146\";i:52387;s:12:\"delete-53149\";i:52388;s:12:\"delete-53150\";i:52389;s:12:\"delete-53147\";i:52390;s:12:\"delete-53148\";i:52391;s:12:\"delete-53151\";i:52392;s:12:\"delete-53154\";i:52393;s:12:\"delete-53155\";i:52394;s:12:\"delete-53152\";i:52395;s:12:\"delete-53153\";i:52396;s:12:\"delete-53156\";i:52397;s:12:\"delete-53159\";i:52398;s:12:\"delete-53160\";i:52399;s:12:\"delete-53157\";i:52400;s:12:\"delete-53158\";i:52401;s:12:\"delete-53161\";i:52402;s:12:\"delete-53164\";i:52403;s:12:\"delete-53165\";i:52404;s:12:\"delete-53162\";i:52405;s:12:\"delete-53163\";i:52406;s:12:\"delete-53166\";i:52407;s:12:\"delete-53169\";i:52408;s:12:\"delete-53170\";i:52409;s:12:\"delete-53167\";i:52410;s:12:\"delete-53168\";i:52411;s:12:\"delete-53171\";i:52412;s:12:\"delete-53174\";i:52413;s:12:\"delete-53175\";i:52414;s:12:\"delete-53172\";i:52415;s:12:\"delete-53173\";i:52416;s:12:\"delete-53176\";i:52417;s:12:\"delete-53179\";i:52418;s:12:\"delete-53177\";i:52419;s:12:\"delete-53178\";i:52420;s:12:\"delete-53180\";i:52421;s:12:\"delete-53181\";i:52422;s:12:\"delete-53184\";i:52423;s:12:\"delete-53185\";i:52424;s:12:\"delete-53182\";i:52425;s:12:\"delete-53183\";i:52426;s:12:\"delete-53186\";i:52427;s:12:\"delete-53189\";i:52428;s:12:\"delete-53190\";i:52429;s:12:\"delete-53187\";i:52430;s:12:\"delete-53188\";i:52431;s:12:\"delete-53191\";i:52432;s:12:\"delete-53194\";i:52433;s:12:\"delete-53195\";i:52434;s:12:\"delete-53192\";i:52435;s:12:\"delete-53193\";i:52436;s:12:\"delete-53196\";i:52437;s:12:\"delete-53199\";i:52438;s:12:\"delete-53200\";i:52439;s:12:\"delete-53197\";i:52440;s:12:\"delete-53198\";i:52441;s:12:\"delete-53201\";i:52442;s:12:\"delete-53204\";i:52443;s:12:\"delete-53205\";i:52444;s:12:\"delete-53202\";i:52445;s:12:\"delete-53203\";i:52446;s:12:\"delete-53206\";i:52447;s:12:\"delete-53209\";i:52448;s:12:\"delete-53210\";i:52449;s:12:\"delete-53207\";i:52450;s:12:\"delete-53208\";i:52451;s:12:\"delete-53211\";i:52452;s:12:\"delete-53214\";i:52453;s:12:\"delete-53215\";i:52454;s:12:\"delete-53212\";i:52455;s:12:\"delete-53213\";i:52456;s:12:\"delete-53216\";i:52457;s:12:\"delete-53219\";i:52458;s:12:\"delete-53220\";i:52459;s:12:\"delete-53217\";i:52460;s:12:\"delete-53218\";i:52461;s:12:\"delete-53221\";i:52462;s:12:\"delete-53224\";i:52463;s:12:\"delete-53225\";i:52464;s:12:\"delete-53222\";i:52465;s:12:\"delete-53223\";i:52466;s:12:\"delete-53226\";i:52467;s:12:\"delete-53229\";i:52468;s:12:\"delete-53230\";i:52469;s:12:\"delete-53227\";i:52470;s:12:\"delete-53228\";i:52471;s:12:\"delete-53231\";i:52472;s:12:\"delete-53234\";i:52473;s:12:\"delete-53235\";i:52474;s:12:\"delete-53232\";i:52475;s:12:\"delete-53233\";i:52476;s:12:\"delete-53236\";i:52477;s:12:\"delete-53239\";i:52478;s:12:\"delete-53240\";i:52479;s:12:\"delete-53237\";i:52480;s:12:\"delete-53238\";i:52481;s:12:\"delete-53241\";i:52482;s:12:\"delete-53244\";i:52483;s:12:\"delete-53245\";i:52484;s:12:\"delete-53242\";i:52485;s:12:\"delete-53243\";i:52486;s:12:\"delete-53246\";i:52487;s:12:\"delete-53249\";i:52488;s:12:\"delete-53250\";i:52489;s:12:\"delete-53247\";i:52490;s:12:\"delete-53248\";i:52491;s:12:\"delete-53251\";i:52492;s:12:\"delete-53254\";i:52493;s:12:\"delete-53255\";i:52494;s:12:\"delete-53252\";i:52495;s:12:\"delete-53253\";i:52496;s:12:\"delete-53256\";i:52497;s:12:\"delete-53259\";i:52498;s:12:\"delete-53260\";i:52499;s:12:\"delete-53257\";i:52500;s:12:\"delete-53258\";i:52501;s:12:\"delete-53261\";i:52502;s:12:\"delete-53264\";i:52503;s:12:\"delete-53265\";i:52504;s:12:\"delete-53262\";i:52505;s:12:\"delete-53263\";i:52506;s:12:\"delete-53266\";i:52507;s:12:\"delete-53269\";i:52508;s:12:\"delete-53270\";i:52509;s:12:\"delete-53267\";i:52510;s:12:\"delete-53268\";i:52511;s:12:\"delete-53271\";i:52512;s:12:\"delete-53274\";i:52513;s:12:\"delete-53272\";i:52514;s:12:\"delete-53273\";i:52515;s:12:\"delete-53275\";i:52516;s:12:\"delete-53276\";i:52517;s:12:\"delete-53279\";i:52518;s:12:\"delete-53280\";i:52519;s:12:\"delete-53277\";i:52520;s:12:\"delete-53278\";i:52521;s:12:\"delete-53281\";i:52522;s:12:\"delete-53284\";i:52523;s:12:\"delete-53285\";i:52524;s:12:\"delete-53282\";i:52525;s:12:\"delete-53283\";i:52526;s:12:\"delete-53286\";i:52527;s:12:\"delete-53289\";i:52528;s:12:\"delete-53290\";i:52529;s:12:\"delete-53287\";i:52530;s:12:\"delete-53288\";i:52531;s:12:\"delete-53291\";i:52532;s:12:\"delete-53294\";i:52533;s:12:\"delete-53295\";i:52534;s:12:\"delete-53292\";i:52535;s:12:\"delete-53293\";i:52536;s:12:\"delete-53296\";i:52537;s:12:\"delete-53299\";i:52538;s:12:\"delete-53297\";i:52539;s:12:\"delete-53298\";i:52540;s:12:\"delete-53300\";i:52541;s:12:\"delete-53301\";i:52542;s:12:\"delete-53304\";i:52543;s:12:\"delete-53305\";i:52544;s:12:\"delete-53302\";i:52545;s:12:\"delete-53303\";i:52546;s:12:\"delete-53306\";i:52547;s:12:\"delete-53309\";i:52548;s:12:\"delete-53310\";i:52549;s:12:\"delete-53307\";i:52550;s:12:\"delete-53308\";i:52551;s:12:\"delete-53311\";i:52552;s:12:\"delete-53314\";i:52553;s:12:\"delete-53315\";i:52554;s:12:\"delete-53312\";i:52555;s:12:\"delete-53313\";i:52556;s:12:\"delete-53316\";i:52557;s:12:\"delete-53319\";i:52558;s:12:\"delete-53320\";i:52559;s:12:\"delete-53317\";i:52560;s:12:\"delete-53318\";i:52561;s:12:\"delete-53321\";i:52562;s:12:\"delete-53324\";i:52563;s:12:\"delete-53325\";i:52564;s:12:\"delete-53322\";i:52565;s:12:\"delete-53323\";i:52566;s:12:\"delete-53326\";i:52567;s:12:\"delete-53329\";i:52568;s:12:\"delete-53327\";i:52569;s:12:\"delete-53328\";i:52570;s:12:\"delete-53330\";i:52571;s:12:\"delete-53331\";i:52572;s:12:\"delete-53334\";i:52573;s:12:\"delete-53335\";i:52574;s:12:\"delete-53332\";i:52575;s:12:\"delete-53333\";i:52576;s:12:\"delete-53336\";i:52577;s:12:\"delete-53339\";i:52578;s:12:\"delete-53340\";i:52579;s:12:\"delete-53337\";i:52580;s:12:\"delete-53338\";i:52581;s:12:\"delete-53341\";i:52582;s:12:\"delete-53344\";i:52583;s:12:\"delete-53345\";i:52584;s:12:\"delete-53342\";i:52585;s:12:\"delete-53343\";i:52586;s:12:\"delete-53346\";i:52587;s:12:\"delete-53349\";i:52588;s:12:\"delete-53350\";i:52589;s:12:\"delete-53347\";i:52590;s:12:\"delete-53348\";i:52591;s:12:\"delete-53351\";i:52592;s:12:\"delete-53354\";i:52593;s:12:\"delete-53352\";i:52594;s:12:\"delete-53353\";i:52595;s:12:\"delete-53355\";i:52596;s:12:\"delete-53356\";i:52597;s:12:\"delete-53359\";i:52598;s:12:\"delete-53360\";i:52599;s:12:\"delete-53357\";i:52600;s:12:\"delete-53358\";i:52601;s:12:\"delete-53361\";i:52602;s:12:\"delete-53364\";i:52603;s:12:\"delete-53365\";i:52604;s:12:\"delete-53362\";i:52605;s:12:\"delete-53363\";i:52606;s:12:\"delete-53366\";i:52607;s:12:\"delete-53369\";i:52608;s:12:\"delete-53370\";i:52609;s:12:\"delete-53367\";i:52610;s:12:\"delete-53368\";i:52611;s:12:\"delete-53371\";i:52612;s:12:\"delete-53374\";i:52613;s:12:\"delete-53375\";i:52614;s:12:\"delete-53372\";i:52615;s:12:\"delete-53373\";i:52616;s:12:\"delete-53376\";i:52617;s:12:\"delete-53379\";i:52618;s:12:\"delete-53377\";i:52619;s:12:\"delete-53378\";i:52620;s:12:\"delete-53380\";i:52621;s:12:\"delete-53381\";i:52622;s:12:\"delete-53384\";i:52623;s:12:\"delete-53385\";i:52624;s:12:\"delete-53382\";i:52625;s:12:\"delete-53383\";i:52626;s:12:\"delete-53386\";i:52627;s:12:\"delete-53389\";i:52628;s:12:\"delete-53390\";i:52629;s:12:\"delete-53387\";i:52630;s:12:\"delete-53388\";i:52631;s:12:\"delete-53391\";i:52632;s:12:\"delete-53394\";i:52633;s:12:\"delete-53395\";i:52634;s:12:\"delete-53392\";i:52635;s:12:\"delete-53393\";i:52636;s:12:\"delete-53396\";i:52637;s:12:\"delete-53399\";i:52638;s:12:\"delete-53400\";i:52639;s:12:\"delete-53397\";i:52640;s:12:\"delete-53398\";i:52641;s:12:\"delete-53401\";i:52642;s:12:\"delete-53404\";i:52643;s:12:\"delete-53405\";i:52644;s:12:\"delete-53402\";i:52645;s:12:\"delete-53403\";i:52646;s:12:\"delete-53406\";i:52647;s:12:\"delete-53409\";i:52648;s:12:\"delete-53407\";i:52649;s:12:\"delete-53408\";i:52650;s:12:\"delete-53410\";i:52651;s:12:\"delete-53411\";i:52652;s:12:\"delete-53414\";i:52653;s:12:\"delete-53415\";i:52654;s:12:\"delete-53412\";i:52655;s:12:\"delete-53413\";i:52656;s:12:\"delete-53416\";i:52657;s:12:\"delete-53419\";i:52658;s:12:\"delete-53420\";i:52659;s:12:\"delete-53417\";i:52660;s:12:\"delete-53418\";i:52661;s:12:\"delete-53421\";i:52662;s:12:\"delete-53424\";i:52663;s:12:\"delete-53425\";i:52664;s:12:\"delete-53422\";i:52665;s:12:\"delete-53423\";i:52666;s:12:\"delete-53426\";i:52667;s:12:\"delete-53429\";i:52668;s:12:\"delete-53427\";i:52669;s:12:\"delete-53428\";i:52670;s:12:\"delete-53430\";i:52671;s:12:\"delete-53431\";i:52672;s:12:\"delete-53434\";i:52673;s:12:\"delete-53435\";i:52674;s:12:\"delete-53432\";i:52675;s:12:\"delete-53433\";i:52676;s:12:\"delete-53436\";i:52677;s:12:\"delete-53439\";i:52678;s:12:\"delete-53440\";i:52679;s:12:\"delete-53437\";i:52680;s:12:\"delete-53438\";i:52681;s:12:\"delete-53441\";i:52682;s:12:\"delete-53444\";i:52683;s:12:\"delete-53445\";i:52684;s:12:\"delete-53442\";i:52685;s:12:\"delete-53443\";i:52686;s:12:\"delete-53446\";i:52687;s:12:\"delete-53449\";i:52688;s:12:\"delete-53447\";i:52689;s:12:\"delete-53448\";i:52690;s:12:\"delete-53450\";i:52691;s:12:\"delete-53451\";i:52692;s:12:\"delete-53454\";i:52693;s:12:\"delete-53455\";i:52694;s:12:\"delete-53452\";i:52695;s:12:\"delete-53453\";i:52696;s:12:\"delete-53456\";i:52697;s:12:\"delete-53459\";i:52698;s:12:\"delete-53460\";i:52699;s:12:\"delete-53457\";i:52700;s:12:\"delete-53458\";i:52701;s:12:\"delete-53461\";i:52702;s:12:\"delete-53464\";i:52703;s:12:\"delete-53462\";i:52704;s:12:\"delete-53463\";i:52705;s:12:\"delete-53465\";i:52706;s:12:\"delete-53466\";i:52707;s:12:\"delete-53469\";i:52708;s:12:\"delete-53467\";i:52709;s:12:\"delete-53468\";i:52710;s:12:\"delete-53470\";i:52711;s:12:\"delete-53471\";i:52712;s:12:\"delete-53474\";i:52713;s:12:\"delete-53475\";i:52714;s:12:\"delete-53472\";i:52715;s:12:\"delete-53473\";i:52716;s:12:\"delete-53476\";i:52717;s:12:\"delete-53479\";i:52718;s:12:\"delete-53480\";i:52719;s:12:\"delete-53477\";i:52720;s:12:\"delete-53478\";i:52721;s:12:\"delete-53481\";i:52722;s:12:\"delete-53484\";i:52723;s:12:\"delete-53485\";i:52724;s:12:\"delete-53482\";i:52725;s:12:\"delete-53483\";i:52726;s:12:\"delete-53486\";i:52727;s:12:\"delete-53489\";i:52728;s:12:\"delete-53487\";i:52729;s:12:\"delete-53488\";i:52730;s:12:\"delete-53490\";i:52731;s:12:\"delete-53491\";i:52732;s:12:\"delete-53494\";i:52733;s:12:\"delete-53495\";i:52734;s:12:\"delete-53492\";i:52735;s:12:\"delete-53493\";i:52736;s:12:\"delete-53496\";i:52737;s:12:\"delete-53499\";i:52738;s:12:\"delete-53500\";i:52739;s:12:\"delete-53497\";i:52740;s:12:\"delete-53498\";i:52741;s:12:\"delete-53501\";i:52742;s:12:\"delete-53504\";i:52743;s:12:\"delete-53505\";i:52744;s:12:\"delete-53502\";i:52745;s:12:\"delete-53503\";i:52746;s:12:\"delete-53506\";i:52747;s:12:\"delete-53509\";i:52748;s:12:\"delete-53510\";i:52749;s:12:\"delete-53507\";i:52750;s:12:\"delete-53508\";i:52751;s:12:\"delete-53511\";i:52752;s:12:\"delete-53514\";i:52753;s:12:\"delete-53515\";i:52754;s:12:\"delete-53512\";i:52755;s:12:\"delete-53513\";i:52756;s:12:\"delete-53516\";i:52757;s:12:\"delete-53519\";i:52758;s:12:\"delete-53520\";i:52759;s:12:\"delete-53517\";i:52760;s:12:\"delete-53518\";i:52761;s:12:\"delete-53521\";i:52762;s:12:\"delete-53524\";i:52763;s:12:\"delete-53525\";i:52764;s:12:\"delete-53522\";i:52765;s:12:\"delete-53523\";i:52766;s:12:\"delete-53526\";i:52767;s:12:\"delete-53529\";i:52768;s:12:\"delete-53530\";i:52769;s:12:\"delete-53527\";i:52770;s:12:\"delete-53528\";i:52771;s:12:\"delete-53531\";i:52772;s:12:\"delete-53534\";i:52773;s:12:\"delete-53535\";i:52774;s:12:\"delete-53532\";i:52775;s:12:\"delete-53533\";i:52776;s:12:\"delete-53536\";i:52777;s:12:\"delete-53539\";i:52778;s:12:\"delete-53540\";i:52779;s:12:\"delete-53537\";i:52780;s:12:\"delete-53538\";i:52781;s:12:\"delete-53541\";i:52782;s:12:\"delete-53544\";i:52783;s:12:\"delete-53545\";i:52784;s:12:\"delete-53542\";i:52785;s:12:\"delete-53543\";i:52786;s:12:\"delete-53546\";i:52787;s:12:\"delete-53549\";i:52788;s:12:\"delete-53550\";i:52789;s:12:\"delete-53547\";i:52790;s:12:\"delete-53548\";i:52791;s:12:\"delete-53551\";i:52792;s:12:\"delete-53554\";i:52793;s:12:\"delete-53555\";i:52794;s:12:\"delete-53556\";i:52795;s:12:\"delete-53559\";i:52796;s:12:\"delete-53560\";i:52797;s:12:\"delete-53552\";i:52798;s:12:\"delete-53553\";i:52799;s:12:\"delete-53557\";i:52800;s:12:\"delete-53558\";i:52801;s:12:\"delete-53561\";i:52802;s:12:\"delete-53564\";i:52803;s:12:\"delete-53565\";i:52804;s:12:\"delete-53562\";i:52805;s:12:\"delete-53563\";i:52806;s:12:\"delete-53566\";i:52807;s:12:\"delete-53569\";i:52808;s:12:\"delete-53570\";i:52809;s:12:\"delete-53567\";i:52810;s:12:\"delete-53568\";i:52811;s:12:\"delete-53571\";i:52812;s:12:\"delete-53574\";i:52813;s:12:\"delete-53575\";i:52814;s:12:\"delete-53572\";i:52815;s:12:\"delete-53573\";i:52816;s:12:\"delete-53576\";i:52817;s:12:\"delete-53579\";i:52818;s:12:\"delete-53580\";i:52819;s:12:\"delete-53577\";i:52820;s:12:\"delete-53578\";i:52821;s:12:\"delete-53581\";i:52822;s:12:\"delete-53584\";i:52823;s:12:\"delete-53585\";i:52824;s:12:\"delete-53582\";i:52825;s:12:\"delete-53583\";i:52826;s:12:\"delete-53586\";i:52827;s:12:\"delete-53589\";i:52828;s:12:\"delete-53590\";i:52829;s:12:\"delete-53587\";i:52830;s:12:\"delete-53588\";i:52831;s:12:\"delete-53591\";i:52832;s:12:\"delete-53594\";i:52833;s:12:\"delete-53595\";i:52834;s:12:\"delete-53592\";i:52835;s:12:\"delete-53593\";i:52836;s:12:\"delete-53596\";i:52837;s:12:\"delete-53599\";i:52838;s:12:\"delete-53600\";i:52839;s:12:\"delete-53597\";i:52840;s:12:\"delete-53598\";i:52841;s:12:\"delete-53601\";i:52842;s:12:\"delete-53604\";i:52843;s:12:\"delete-53605\";i:52844;s:12:\"delete-53602\";i:52845;s:12:\"delete-53603\";i:52846;s:12:\"delete-53606\";i:52847;s:12:\"delete-53609\";i:52848;s:12:\"delete-53610\";i:52849;s:12:\"delete-53607\";i:52850;s:12:\"delete-53608\";i:52851;s:12:\"delete-53611\";i:52852;s:12:\"delete-53614\";i:52853;s:12:\"delete-53615\";i:52854;s:12:\"delete-53612\";i:52855;s:12:\"delete-53613\";i:52856;s:12:\"delete-53616\";i:52857;s:12:\"delete-53619\";i:52858;s:12:\"delete-53620\";i:52859;s:12:\"delete-53617\";i:52860;s:12:\"delete-53618\";i:52861;s:12:\"delete-53621\";i:52862;s:12:\"delete-53624\";i:52863;s:12:\"delete-53625\";i:52864;s:12:\"delete-53622\";i:52865;s:12:\"delete-53623\";i:52866;s:12:\"delete-53626\";i:52867;s:12:\"delete-53629\";i:52868;s:12:\"delete-53627\";i:52869;s:12:\"delete-53628\";i:52870;s:12:\"delete-53630\";i:52871;s:12:\"delete-53631\";i:52872;s:12:\"delete-53634\";i:52873;s:12:\"delete-53635\";i:52874;s:12:\"delete-53632\";i:52875;s:12:\"delete-53633\";i:52876;s:12:\"delete-53636\";i:52877;s:12:\"delete-53639\";i:52878;s:12:\"delete-53640\";i:52879;s:12:\"delete-53637\";i:52880;s:12:\"delete-53638\";i:52881;s:12:\"delete-53641\";i:52882;s:12:\"delete-53644\";i:52883;s:12:\"delete-53645\";i:52884;s:12:\"delete-53642\";i:52885;s:12:\"delete-53643\";i:52886;s:12:\"delete-53646\";i:52887;s:12:\"delete-53649\";i:52888;s:12:\"delete-53650\";i:52889;s:12:\"delete-53647\";i:52890;s:12:\"delete-53648\";i:52891;s:12:\"delete-53651\";i:52892;s:12:\"delete-53654\";i:52893;s:12:\"delete-53652\";i:52894;s:12:\"delete-53653\";i:52895;s:12:\"delete-53655\";i:52896;s:12:\"delete-53656\";i:52897;s:12:\"delete-53659\";i:52898;s:12:\"delete-53660\";i:52899;s:12:\"delete-53657\";i:52900;s:12:\"delete-53658\";i:52901;s:12:\"delete-53661\";i:52902;s:12:\"delete-53664\";i:52903;s:12:\"delete-53665\";i:52904;s:12:\"delete-53662\";i:52905;s:12:\"delete-53663\";i:52906;s:12:\"delete-53666\";i:52907;s:12:\"delete-53669\";i:52908;s:12:\"delete-53670\";i:52909;s:12:\"delete-53667\";i:52910;s:12:\"delete-53668\";i:52911;s:12:\"delete-53671\";i:52912;s:12:\"delete-53674\";i:52913;s:12:\"delete-53675\";i:52914;s:12:\"delete-53672\";i:52915;s:12:\"delete-53673\";i:52916;s:12:\"delete-53676\";i:52917;s:12:\"delete-53679\";i:52918;s:12:\"delete-53677\";i:52919;s:12:\"delete-53678\";i:52920;s:12:\"delete-53680\";i:52921;s:12:\"delete-53681\";i:52922;s:12:\"delete-53684\";i:52923;s:12:\"delete-53685\";i:52924;s:12:\"delete-53682\";i:52925;s:12:\"delete-53683\";i:52926;s:12:\"delete-53686\";i:52927;s:12:\"delete-53689\";i:52928;s:12:\"delete-53690\";i:52929;s:12:\"delete-53687\";i:52930;s:12:\"delete-53688\";i:52931;s:12:\"delete-53691\";i:52932;s:12:\"delete-53694\";i:52933;s:12:\"delete-53695\";i:52934;s:12:\"delete-53692\";i:52935;s:12:\"delete-53693\";i:52936;s:12:\"delete-53696\";i:52937;s:12:\"delete-53699\";i:52938;s:12:\"delete-53700\";i:52939;s:12:\"delete-53697\";i:52940;s:12:\"delete-53698\";i:52941;s:12:\"delete-53701\";i:52942;s:12:\"delete-53704\";i:52943;s:12:\"delete-53705\";i:52944;s:12:\"delete-53702\";i:52945;s:12:\"delete-53703\";i:52946;s:12:\"delete-53706\";i:52947;s:12:\"delete-53709\";i:52948;s:12:\"delete-53707\";i:52949;s:12:\"delete-53708\";i:52950;s:12:\"delete-53710\";i:52951;s:12:\"delete-53711\";i:52952;s:12:\"delete-53714\";i:52953;s:12:\"delete-53712\";i:52954;s:12:\"delete-53713\";i:52955;s:12:\"delete-53715\";i:52956;s:12:\"delete-53716\";i:52957;s:12:\"delete-53719\";i:52958;s:12:\"delete-53720\";i:52959;s:12:\"delete-53717\";i:52960;s:12:\"delete-53718\";i:52961;s:12:\"delete-53721\";i:52962;s:12:\"delete-53724\";i:52963;s:12:\"delete-53725\";i:52964;s:12:\"delete-53722\";i:52965;s:12:\"delete-53723\";i:52966;s:12:\"delete-53726\";i:52967;s:12:\"delete-53729\";i:52968;s:12:\"delete-53730\";i:52969;s:12:\"delete-53727\";i:52970;s:12:\"delete-53728\";i:52971;s:12:\"delete-53731\";i:52972;s:12:\"delete-53734\";i:52973;s:12:\"delete-53735\";i:52974;s:12:\"delete-53732\";i:52975;s:12:\"delete-53733\";i:52976;s:12:\"delete-53736\";i:52977;s:12:\"delete-53739\";i:52978;s:12:\"delete-53737\";i:52979;s:12:\"delete-53738\";i:52980;s:12:\"delete-53740\";i:52981;s:12:\"delete-53741\";i:52982;s:12:\"delete-53744\";i:52983;s:12:\"delete-53745\";i:52984;s:12:\"delete-53742\";i:52985;s:12:\"delete-53743\";i:52986;s:12:\"delete-53746\";i:52987;s:12:\"delete-53749\";i:52988;s:12:\"delete-53750\";i:52989;s:12:\"delete-53747\";i:52990;s:12:\"delete-53748\";i:52991;s:12:\"delete-53751\";i:52992;s:12:\"delete-53754\";i:52993;s:12:\"delete-53755\";i:52994;s:12:\"delete-53752\";i:52995;s:12:\"delete-53753\";i:52996;s:12:\"delete-53756\";i:52997;s:12:\"delete-53759\";i:52998;s:12:\"delete-53757\";i:52999;s:12:\"delete-53758\";i:53000;s:12:\"delete-53760\";i:53001;s:12:\"delete-53761\";i:53002;s:12:\"delete-53764\";i:53003;s:12:\"delete-53765\";i:53004;s:12:\"delete-53762\";i:53005;s:12:\"delete-53763\";i:53006;s:12:\"delete-53766\";i:53007;s:12:\"delete-53769\";i:53008;s:12:\"delete-53770\";i:53009;s:12:\"delete-53767\";i:53010;s:12:\"delete-53768\";i:53011;s:12:\"delete-53771\";i:53012;s:12:\"delete-53774\";i:53013;s:12:\"delete-53775\";i:53014;s:12:\"delete-53772\";i:53015;s:12:\"delete-53773\";i:53016;s:12:\"delete-53776\";i:53017;s:12:\"delete-53779\";i:53018;s:12:\"delete-53780\";i:53019;s:12:\"delete-53777\";i:53020;s:12:\"delete-53778\";i:53021;s:12:\"delete-53781\";i:53022;s:12:\"delete-53784\";i:53023;s:12:\"delete-53782\";i:53024;s:12:\"delete-53783\";i:53025;s:12:\"delete-53785\";i:53026;s:12:\"delete-53786\";i:53027;s:12:\"delete-53789\";i:53028;s:12:\"delete-53790\";i:53029;s:12:\"delete-53787\";i:53030;s:12:\"delete-53788\";i:53031;s:12:\"delete-53791\";i:53032;s:12:\"delete-53794\";i:53033;s:12:\"delete-53795\";i:53034;s:12:\"delete-53792\";i:53035;s:12:\"delete-53793\";i:53036;s:12:\"delete-53796\";i:53037;s:12:\"delete-53799\";i:53038;s:12:\"delete-53800\";i:53039;s:12:\"delete-53797\";i:53040;s:12:\"delete-53798\";i:53041;s:12:\"delete-53801\";i:53042;s:12:\"delete-53804\";i:53043;s:12:\"delete-53802\";i:53044;s:12:\"delete-53803\";i:53045;s:12:\"delete-53805\";i:53046;s:12:\"delete-53806\";i:53047;s:12:\"delete-53809\";i:53048;s:12:\"delete-53810\";i:53049;s:12:\"delete-53807\";i:53050;s:12:\"delete-53808\";i:53051;s:12:\"delete-53811\";i:53052;s:12:\"delete-53814\";i:53053;s:12:\"delete-53815\";i:53054;s:12:\"delete-53812\";i:53055;s:12:\"delete-53813\";i:53056;s:12:\"delete-53816\";i:53057;s:12:\"delete-53819\";i:53058;s:12:\"delete-53820\";i:53059;s:12:\"delete-53817\";i:53060;s:12:\"delete-53818\";i:53061;s:12:\"delete-53821\";i:53062;s:12:\"delete-53824\";i:53063;s:12:\"delete-53825\";i:53064;s:12:\"delete-53822\";i:53065;s:12:\"delete-53823\";i:53066;s:12:\"delete-53826\";i:53067;s:12:\"delete-53829\";i:53068;s:12:\"delete-53830\";i:53069;s:12:\"delete-53827\";i:53070;s:12:\"delete-53828\";i:53071;s:12:\"delete-53831\";i:53072;s:12:\"delete-53834\";i:53073;s:12:\"delete-53835\";i:53074;s:12:\"delete-53832\";i:53075;s:12:\"delete-53833\";i:53076;s:12:\"delete-53836\";i:53077;s:12:\"delete-53839\";i:53078;s:12:\"delete-53840\";i:53079;s:12:\"delete-53837\";i:53080;s:12:\"delete-53838\";i:53081;s:12:\"delete-53841\";i:53082;s:12:\"delete-53844\";i:53083;s:12:\"delete-53845\";i:53084;s:12:\"delete-53842\";i:53085;s:12:\"delete-53843\";i:53086;s:12:\"delete-53846\";i:53087;s:12:\"delete-53849\";i:53088;s:12:\"delete-53850\";i:53089;s:12:\"delete-53847\";i:53090;s:12:\"delete-53848\";i:53091;s:12:\"delete-53851\";i:53092;s:12:\"delete-53854\";i:53093;s:12:\"delete-53855\";i:53094;s:12:\"delete-53852\";i:53095;s:12:\"delete-53853\";i:53096;s:12:\"delete-53856\";i:53097;s:12:\"delete-53859\";i:53098;s:12:\"delete-53860\";i:53099;s:12:\"delete-53857\";i:53100;s:12:\"delete-53858\";i:53101;s:12:\"delete-53861\";i:53102;s:12:\"delete-53864\";i:53103;s:12:\"delete-53865\";i:53104;s:12:\"delete-53862\";i:53105;s:12:\"delete-53863\";i:53106;s:12:\"delete-53866\";i:53107;s:12:\"delete-53869\";i:53108;s:12:\"delete-53867\";i:53109;s:12:\"delete-53868\";i:53110;s:12:\"delete-53870\";i:53111;s:12:\"delete-53871\";i:53112;s:12:\"delete-53874\";i:53113;s:12:\"delete-53875\";i:53114;s:12:\"delete-53872\";i:53115;s:12:\"delete-53873\";i:53116;s:12:\"delete-53876\";i:53117;s:12:\"delete-53879\";i:53118;s:12:\"delete-53880\";i:53119;s:12:\"delete-53877\";i:53120;s:12:\"delete-53878\";i:53121;s:12:\"delete-53881\";i:53122;s:12:\"delete-53884\";i:53123;s:12:\"delete-53885\";i:53124;s:12:\"delete-53882\";i:53125;s:12:\"delete-53883\";i:53126;s:12:\"delete-53886\";i:53127;s:12:\"delete-53889\";i:53128;s:12:\"delete-53890\";i:53129;s:12:\"delete-53887\";i:53130;s:12:\"delete-53888\";i:53131;s:12:\"delete-53891\";i:53132;s:12:\"delete-53894\";i:53133;s:12:\"delete-53895\";i:53134;s:12:\"delete-53892\";i:53135;s:12:\"delete-53893\";i:53136;s:12:\"delete-53896\";i:53137;s:12:\"delete-53899\";i:53138;s:12:\"delete-53900\";i:53139;s:12:\"delete-53897\";i:53140;s:12:\"delete-53898\";i:53141;s:12:\"delete-53901\";i:53142;s:12:\"delete-53904\";i:53143;s:12:\"delete-53905\";i:53144;s:12:\"delete-53902\";i:53145;s:12:\"delete-53903\";i:53146;s:12:\"delete-53906\";i:53147;s:12:\"delete-53909\";i:53148;s:12:\"delete-53910\";i:53149;s:12:\"delete-53907\";i:53150;s:12:\"delete-53908\";i:53151;s:12:\"delete-53911\";i:53152;s:12:\"delete-53914\";i:53153;s:12:\"delete-53912\";i:53154;s:12:\"delete-53913\";i:53155;s:12:\"delete-53915\";i:53156;s:12:\"delete-53916\";i:53157;s:12:\"delete-53919\";i:53158;s:12:\"delete-53920\";i:53159;s:12:\"delete-53917\";i:53160;s:12:\"delete-53918\";i:53161;s:12:\"delete-53921\";i:53162;s:12:\"delete-53924\";i:53163;s:12:\"delete-53925\";i:53164;s:12:\"delete-53922\";i:53165;s:12:\"delete-53923\";i:53166;s:12:\"delete-53926\";i:53167;s:12:\"delete-53929\";i:53168;s:12:\"delete-53930\";i:53169;s:12:\"delete-53927\";i:53170;s:12:\"delete-53928\";i:53171;s:12:\"delete-53931\";i:53172;s:12:\"delete-53934\";i:53173;s:12:\"delete-53935\";i:53174;s:12:\"delete-53932\";i:53175;s:12:\"delete-53933\";i:53176;s:12:\"delete-53936\";i:53177;s:12:\"delete-53939\";i:53178;s:12:\"delete-53940\";i:53179;s:12:\"delete-53937\";i:53180;s:12:\"delete-53938\";i:53181;s:12:\"delete-53941\";i:53182;s:12:\"delete-53944\";i:53183;s:12:\"delete-53945\";i:53184;s:12:\"delete-53942\";i:53185;s:12:\"delete-53943\";i:53186;s:12:\"delete-53946\";i:53187;s:12:\"delete-53949\";i:53188;s:12:\"delete-53950\";i:53189;s:12:\"delete-53947\";i:53190;s:12:\"delete-53948\";i:53191;s:12:\"delete-53951\";i:53192;s:12:\"delete-53954\";i:53193;s:12:\"delete-53955\";i:53194;s:12:\"delete-53952\";i:53195;s:12:\"delete-53953\";i:53196;s:12:\"delete-53956\";i:53197;s:12:\"delete-53959\";i:53198;s:12:\"delete-53960\";i:53199;s:12:\"delete-53957\";i:53200;s:12:\"delete-53958\";i:53201;s:12:\"delete-53961\";i:53202;s:12:\"delete-53964\";i:53203;s:12:\"delete-53965\";i:53204;s:12:\"delete-53962\";i:53205;s:12:\"delete-53963\";i:53206;s:12:\"delete-53966\";i:53207;s:12:\"delete-53969\";i:53208;s:12:\"delete-53970\";i:53209;s:12:\"delete-53967\";i:53210;s:12:\"delete-53968\";i:53211;s:12:\"delete-53971\";i:53212;s:12:\"delete-53974\";i:53213;s:12:\"delete-53975\";i:53214;s:12:\"delete-53972\";i:53215;s:12:\"delete-53973\";i:53216;s:12:\"delete-53976\";i:53217;s:12:\"delete-53979\";i:53218;s:12:\"delete-53980\";i:53219;s:12:\"delete-53977\";i:53220;s:12:\"delete-53978\";i:53221;s:12:\"delete-53981\";i:53222;s:12:\"delete-53984\";i:53223;s:12:\"delete-53985\";i:53224;s:12:\"delete-53982\";i:53225;s:12:\"delete-53983\";i:53226;s:12:\"delete-53986\";i:53227;s:12:\"delete-53989\";i:53228;s:12:\"delete-53990\";i:53229;s:12:\"delete-53987\";i:53230;s:12:\"delete-53988\";i:53231;s:12:\"delete-53991\";i:53232;s:12:\"delete-53994\";i:53233;s:12:\"delete-53995\";i:53234;s:12:\"delete-53992\";i:53235;s:12:\"delete-53993\";i:53236;s:12:\"delete-53996\";i:53237;s:12:\"delete-53999\";i:53238;s:12:\"delete-54000\";i:53239;s:12:\"delete-53997\";i:53240;s:12:\"delete-53998\";i:53241;s:12:\"delete-54001\";i:53242;s:12:\"delete-54004\";i:53243;s:12:\"delete-54005\";i:53244;s:12:\"delete-54002\";i:53245;s:12:\"delete-54003\";i:53246;s:12:\"delete-54006\";i:53247;s:12:\"delete-54009\";i:53248;s:12:\"delete-54010\";i:53249;s:12:\"delete-54007\";i:53250;s:12:\"delete-54008\";i:53251;s:12:\"delete-54011\";i:53252;s:12:\"delete-54014\";i:53253;s:12:\"delete-54015\";i:53254;s:12:\"delete-54012\";i:53255;s:12:\"delete-54013\";i:53256;s:12:\"delete-54016\";i:53257;s:12:\"delete-54019\";i:53258;s:12:\"delete-54020\";i:53259;s:12:\"delete-54017\";i:53260;s:12:\"delete-54018\";i:53261;s:12:\"delete-54021\";i:53262;s:12:\"delete-54024\";i:53263;s:12:\"delete-54025\";i:53264;s:12:\"delete-54022\";i:53265;s:12:\"delete-54023\";i:53266;s:12:\"delete-54026\";i:53267;s:12:\"delete-54029\";i:53268;s:12:\"delete-54030\";i:53269;s:12:\"delete-54027\";i:53270;s:12:\"delete-54028\";i:53271;s:12:\"delete-54031\";i:53272;s:12:\"delete-54034\";i:53273;s:12:\"delete-54035\";i:53274;s:12:\"delete-54032\";i:53275;s:12:\"delete-54033\";i:53276;s:12:\"delete-54036\";i:53277;s:12:\"delete-54039\";i:53278;s:12:\"delete-54040\";i:53279;s:12:\"delete-54037\";i:53280;s:12:\"delete-54038\";i:53281;s:12:\"delete-54041\";i:53282;s:12:\"delete-54044\";i:53283;s:12:\"delete-54045\";i:53284;s:12:\"delete-54042\";i:53285;s:12:\"delete-54043\";i:53286;s:12:\"delete-54046\";i:53287;s:12:\"delete-54049\";i:53288;s:12:\"delete-54050\";i:53289;s:12:\"delete-54047\";i:53290;s:12:\"delete-54048\";i:53291;s:12:\"delete-54051\";i:53292;s:12:\"delete-54054\";i:53293;s:12:\"delete-54055\";i:53294;s:12:\"delete-54052\";i:53295;s:12:\"delete-54053\";i:53296;s:12:\"delete-54056\";i:53297;s:12:\"delete-54057\";i:53298;s:12:\"delete-54058\";i:53299;s:12:\"delete-54059\";i:53300;s:12:\"delete-54060\";i:53301;s:12:\"delete-54061\";i:53302;s:12:\"delete-54064\";i:53303;s:12:\"delete-54065\";i:53304;s:12:\"delete-54062\";i:53305;s:12:\"delete-54063\";i:53306;s:12:\"delete-54066\";i:53307;s:12:\"delete-54069\";i:53308;s:12:\"delete-54070\";i:53309;s:12:\"delete-54067\";i:53310;s:12:\"delete-54068\";i:53311;s:12:\"delete-54071\";i:53312;s:12:\"delete-54074\";i:53313;s:12:\"delete-54075\";i:53314;s:12:\"delete-54072\";i:53315;s:12:\"delete-54073\";i:53316;s:12:\"delete-54076\";i:53317;s:12:\"delete-54079\";i:53318;s:12:\"delete-54080\";i:53319;s:12:\"delete-54077\";i:53320;s:12:\"delete-54078\";i:53321;s:12:\"delete-54081\";i:53322;s:12:\"delete-54084\";i:53323;s:12:\"delete-54085\";i:53324;s:12:\"delete-54082\";i:53325;s:12:\"delete-54083\";i:53326;s:12:\"delete-54086\";i:53327;s:12:\"delete-54089\";i:53328;s:12:\"delete-54090\";i:53329;s:12:\"delete-54087\";i:53330;s:12:\"delete-54088\";i:53331;s:12:\"delete-54091\";i:53332;s:12:\"delete-54094\";i:53333;s:12:\"delete-54095\";i:53334;s:12:\"delete-54092\";i:53335;s:12:\"delete-54093\";i:53336;s:12:\"delete-54096\";i:53337;s:12:\"delete-54099\";i:53338;s:12:\"delete-54100\";i:53339;s:12:\"delete-54097\";i:53340;s:12:\"delete-54098\";i:53341;s:12:\"delete-54101\";i:53342;s:12:\"delete-54104\";i:53343;s:12:\"delete-54105\";i:53344;s:12:\"delete-54102\";i:53345;s:12:\"delete-54103\";i:53346;s:12:\"delete-54106\";i:53347;s:12:\"delete-54109\";i:53348;s:12:\"delete-54110\";i:53349;s:12:\"delete-54107\";i:53350;s:12:\"delete-54108\";i:53351;s:12:\"delete-54111\";i:53352;s:12:\"delete-54114\";i:53353;s:12:\"delete-54115\";i:53354;s:12:\"delete-54112\";i:53355;s:12:\"delete-54113\";i:53356;s:12:\"delete-54116\";i:53357;s:12:\"delete-54119\";i:53358;s:12:\"delete-54120\";i:53359;s:12:\"delete-54117\";i:53360;s:12:\"delete-54118\";i:53361;s:12:\"delete-54121\";i:53362;s:12:\"delete-54124\";i:53363;s:12:\"delete-54125\";i:53364;s:12:\"delete-54122\";i:53365;s:12:\"delete-54123\";i:53366;s:12:\"delete-54126\";i:53367;s:12:\"delete-54129\";i:53368;s:12:\"delete-54130\";i:53369;s:12:\"delete-54127\";i:53370;s:12:\"delete-54128\";i:53371;s:12:\"delete-54131\";i:53372;s:12:\"delete-54134\";i:53373;s:12:\"delete-54135\";i:53374;s:12:\"delete-54132\";i:53375;s:12:\"delete-54133\";i:53376;s:12:\"delete-54136\";i:53377;s:12:\"delete-54139\";i:53378;s:12:\"delete-54140\";i:53379;s:12:\"delete-54141\";i:53380;s:12:\"delete-54144\";i:53381;s:12:\"delete-54145\";i:53382;s:12:\"delete-54137\";i:53383;s:12:\"delete-54138\";i:53384;s:12:\"delete-54142\";i:53385;s:12:\"delete-54143\";i:53386;s:12:\"delete-54146\";i:53387;s:12:\"delete-54149\";i:53388;s:12:\"delete-54150\";i:53389;s:12:\"delete-54147\";i:53390;s:12:\"delete-54148\";i:53391;s:12:\"delete-54151\";i:53392;s:12:\"delete-54154\";i:53393;s:12:\"delete-54155\";i:53394;s:12:\"delete-54152\";i:53395;s:12:\"delete-54153\";i:53396;s:12:\"delete-54156\";i:53397;s:12:\"delete-54159\";i:53398;s:12:\"delete-54160\";i:53399;s:12:\"delete-54157\";i:53400;s:12:\"delete-54158\";i:53401;s:12:\"delete-54161\";i:53402;s:12:\"delete-54164\";i:53403;s:12:\"delete-54165\";i:53404;s:12:\"delete-54162\";i:53405;s:12:\"delete-54163\";i:53406;s:12:\"delete-54166\";i:53407;s:12:\"delete-54169\";i:53408;s:12:\"delete-54167\";i:53409;s:12:\"delete-54168\";i:53410;s:12:\"delete-54170\";i:53411;s:12:\"delete-54171\";i:53412;s:12:\"delete-54174\";i:53413;s:12:\"delete-54175\";i:53414;s:12:\"delete-54172\";i:53415;s:12:\"delete-54173\";i:53416;s:12:\"delete-54176\";i:53417;s:12:\"delete-54179\";i:53418;s:12:\"delete-54180\";i:53419;s:12:\"delete-54177\";i:53420;s:12:\"delete-54178\";i:53421;s:12:\"delete-54181\";i:53422;s:12:\"delete-54184\";i:53423;s:12:\"delete-54185\";i:53424;s:12:\"delete-54182\";i:53425;s:12:\"delete-54183\";i:53426;s:12:\"delete-54186\";i:53427;s:12:\"delete-54189\";i:53428;s:12:\"delete-54190\";i:53429;s:12:\"delete-54187\";i:53430;s:12:\"delete-54188\";i:53431;s:12:\"delete-54191\";i:53432;s:12:\"delete-54194\";i:53433;s:12:\"delete-54192\";i:53434;s:12:\"delete-54193\";i:53435;s:12:\"delete-54195\";i:53436;s:12:\"delete-54196\";i:53437;s:12:\"delete-54199\";i:53438;s:12:\"delete-54200\";i:53439;s:12:\"delete-54197\";i:53440;s:12:\"delete-54198\";i:53441;s:12:\"delete-54201\";i:53442;s:12:\"delete-54204\";i:53443;s:12:\"delete-54202\";i:53444;s:12:\"delete-54203\";i:53445;s:12:\"delete-54205\";i:53446;s:12:\"delete-54206\";i:53447;s:12:\"delete-54209\";i:53448;s:12:\"delete-54210\";i:53449;s:12:\"delete-54207\";i:53450;s:12:\"delete-54208\";i:53451;s:12:\"delete-54211\";i:53452;s:12:\"delete-54214\";i:53453;s:12:\"delete-54215\";i:53454;s:12:\"delete-54212\";i:53455;s:12:\"delete-54213\";i:53456;s:12:\"delete-54216\";i:53457;s:12:\"delete-54219\";i:53458;s:12:\"delete-54217\";i:53459;s:12:\"delete-54218\";i:53460;s:12:\"delete-54220\";i:53461;s:12:\"delete-54221\";i:53462;s:12:\"delete-54224\";i:53463;s:12:\"delete-54225\";i:53464;s:12:\"delete-54222\";i:53465;s:12:\"delete-54223\";i:53466;s:12:\"delete-54226\";i:53467;s:12:\"delete-54229\";i:53468;s:12:\"delete-54230\";i:53469;s:12:\"delete-54227\";i:53470;s:12:\"delete-54228\";i:53471;s:12:\"delete-54231\";i:53472;s:12:\"delete-54234\";i:53473;s:12:\"delete-54232\";i:53474;s:12:\"delete-54233\";i:53475;s:12:\"delete-54235\";i:53476;s:12:\"delete-54236\";i:53477;s:12:\"delete-54239\";i:53478;s:12:\"delete-54240\";i:53479;s:12:\"delete-54237\";i:53480;s:12:\"delete-54238\";i:53481;s:12:\"delete-54241\";i:53482;s:12:\"delete-54244\";i:53483;s:12:\"delete-54245\";i:53484;s:12:\"delete-54242\";i:53485;s:12:\"delete-54243\";i:53486;s:12:\"delete-54246\";i:53487;s:12:\"delete-54249\";i:53488;s:12:\"delete-54250\";i:53489;s:12:\"delete-54247\";i:53490;s:12:\"delete-54248\";i:53491;s:12:\"delete-54251\";i:53492;s:12:\"delete-54254\";i:53493;s:12:\"delete-54255\";i:53494;s:12:\"delete-54252\";i:53495;s:12:\"delete-54253\";i:53496;s:12:\"delete-54256\";i:53497;s:12:\"delete-54259\";i:53498;s:12:\"delete-54260\";i:53499;s:12:\"delete-54257\";i:53500;s:12:\"delete-54258\";i:53501;s:12:\"delete-54261\";i:53502;s:12:\"delete-54264\";i:53503;s:12:\"delete-54265\";i:53504;s:12:\"delete-54262\";i:53505;s:12:\"delete-54263\";i:53506;s:12:\"delete-54266\";i:53507;s:12:\"delete-54269\";i:53508;s:12:\"delete-54270\";i:53509;s:12:\"delete-54267\";i:53510;s:12:\"delete-54268\";i:53511;s:12:\"delete-54271\";i:53512;s:12:\"delete-54274\";i:53513;s:12:\"delete-54275\";i:53514;s:12:\"delete-54272\";i:53515;s:12:\"delete-54273\";i:53516;s:12:\"delete-54276\";i:53517;s:12:\"delete-54279\";i:53518;s:12:\"delete-54280\";i:53519;s:12:\"delete-54277\";i:53520;s:12:\"delete-54278\";i:53521;s:12:\"delete-54281\";i:53522;s:12:\"delete-54284\";i:53523;s:12:\"delete-54285\";i:53524;s:12:\"delete-54282\";i:53525;s:12:\"delete-54283\";i:53526;s:12:\"delete-54286\";i:53527;s:12:\"delete-54289\";i:53528;s:12:\"delete-54290\";i:53529;s:12:\"delete-54287\";i:53530;s:12:\"delete-54288\";i:53531;s:12:\"delete-54291\";i:53532;s:12:\"delete-54294\";i:53533;s:12:\"delete-54295\";i:53534;s:12:\"delete-54292\";i:53535;s:12:\"delete-54293\";i:53536;s:12:\"delete-54296\";i:53537;s:12:\"delete-54299\";i:53538;s:12:\"delete-54300\";i:53539;s:12:\"delete-54297\";i:53540;s:12:\"delete-54298\";i:53541;s:12:\"delete-54301\";i:53542;s:12:\"delete-54304\";i:53543;s:12:\"delete-54305\";i:53544;s:12:\"delete-54302\";i:53545;s:12:\"delete-54303\";i:53546;s:12:\"delete-54306\";i:53547;s:12:\"delete-54309\";i:53548;s:12:\"delete-54310\";i:53549;s:12:\"delete-54307\";i:53550;s:12:\"delete-54308\";i:53551;s:12:\"delete-54311\";i:53552;s:12:\"delete-54314\";i:53553;s:12:\"delete-54315\";i:53554;s:12:\"delete-54312\";i:53555;s:12:\"delete-54313\";i:53556;s:12:\"delete-54316\";i:53557;s:12:\"delete-54319\";i:53558;s:12:\"delete-54320\";i:53559;s:12:\"delete-54317\";i:53560;s:12:\"delete-54318\";i:53561;s:12:\"delete-54321\";i:53562;s:12:\"delete-54324\";i:53563;s:12:\"delete-54325\";i:53564;s:12:\"delete-54322\";i:53565;s:12:\"delete-54323\";i:53566;s:12:\"delete-54326\";i:53567;s:12:\"delete-54327\";i:53568;s:12:\"delete-54328\";i:53569;s:12:\"delete-54329\";i:53570;s:12:\"delete-54330\";i:53571;s:12:\"delete-54331\";i:53572;s:12:\"delete-54334\";i:53573;s:12:\"delete-54335\";i:53574;s:12:\"delete-54332\";i:53575;s:12:\"delete-54333\";i:53576;s:12:\"delete-54336\";i:53577;s:12:\"delete-54339\";i:53578;s:12:\"delete-54340\";i:53579;s:12:\"delete-54337\";i:53580;s:12:\"delete-54338\";i:53581;s:12:\"delete-54341\";i:53582;s:12:\"delete-54344\";i:53583;s:12:\"delete-54345\";i:53584;s:12:\"delete-54342\";i:53585;s:12:\"delete-54343\";i:53586;s:12:\"delete-54346\";i:53587;s:12:\"delete-54349\";i:53588;s:12:\"delete-54350\";i:53589;s:12:\"delete-54347\";i:53590;s:12:\"delete-54348\";i:53591;s:12:\"delete-54351\";i:53592;s:12:\"delete-54354\";i:53593;s:12:\"delete-54355\";i:53594;s:12:\"delete-54352\";i:53595;s:12:\"delete-54353\";i:53596;s:12:\"delete-54356\";i:53597;s:12:\"delete-54359\";i:53598;s:12:\"delete-54360\";i:53599;s:12:\"delete-54357\";i:53600;s:12:\"delete-54358\";i:53601;s:12:\"delete-54361\";i:53602;s:12:\"delete-54364\";i:53603;s:12:\"delete-54362\";i:53604;s:12:\"delete-54363\";i:53605;s:12:\"delete-54365\";i:53606;s:12:\"delete-54366\";i:53607;s:12:\"delete-54369\";i:53608;s:12:\"delete-54370\";i:53609;s:12:\"delete-54367\";i:53610;s:12:\"delete-54368\";i:53611;s:12:\"delete-54371\";i:53612;s:12:\"delete-54374\";i:53613;s:12:\"delete-54375\";i:53614;s:12:\"delete-54372\";i:53615;s:12:\"delete-54373\";i:53616;s:12:\"delete-54376\";i:53617;s:12:\"delete-54379\";i:53618;s:12:\"delete-54380\";i:53619;s:12:\"delete-54377\";i:53620;s:12:\"delete-54378\";i:53621;s:12:\"delete-54381\";i:53622;s:12:\"delete-54384\";i:53623;s:12:\"delete-54385\";i:53624;s:12:\"delete-54382\";i:53625;s:12:\"delete-54383\";i:53626;s:12:\"delete-54386\";i:53627;s:12:\"delete-54389\";i:53628;s:12:\"delete-54390\";i:53629;s:12:\"delete-54387\";i:53630;s:12:\"delete-54388\";i:53631;s:12:\"delete-54391\";i:53632;s:12:\"delete-54394\";i:53633;s:12:\"delete-54395\";i:53634;s:12:\"delete-54392\";i:53635;s:12:\"delete-54393\";i:53636;s:12:\"delete-54396\";i:53637;s:12:\"delete-54399\";i:53638;s:12:\"delete-54400\";i:53639;s:12:\"delete-54397\";i:53640;s:12:\"delete-54398\";i:53641;s:12:\"delete-54401\";i:53642;s:12:\"delete-54404\";i:53643;s:12:\"delete-54405\";i:53644;s:12:\"delete-54402\";i:53645;s:12:\"delete-54403\";i:53646;s:12:\"delete-54406\";i:53647;s:12:\"delete-54409\";i:53648;s:12:\"delete-54410\";i:53649;s:12:\"delete-54407\";i:53650;s:12:\"delete-54408\";i:53651;s:12:\"delete-54411\";i:53652;s:12:\"delete-54414\";i:53653;s:12:\"delete-54415\";i:53654;s:12:\"delete-54412\";i:53655;s:12:\"delete-54413\";i:53656;s:12:\"delete-54416\";i:53657;s:12:\"delete-54419\";i:53658;s:12:\"delete-54420\";i:53659;s:12:\"delete-54417\";i:53660;s:12:\"delete-54418\";i:53661;s:12:\"delete-54421\";i:53662;s:12:\"delete-54424\";i:53663;s:12:\"delete-54422\";i:53664;s:12:\"delete-54423\";i:53665;s:12:\"delete-54425\";i:53666;s:12:\"delete-54426\";i:53667;s:12:\"delete-54429\";i:53668;s:12:\"delete-54430\";i:53669;s:12:\"delete-54427\";i:53670;s:12:\"delete-54428\";i:53671;s:12:\"delete-54431\";i:53672;s:12:\"delete-54434\";i:53673;s:12:\"delete-54435\";i:53674;s:12:\"delete-54432\";i:53675;s:12:\"delete-54433\";i:53676;s:12:\"delete-54436\";i:53677;s:12:\"delete-54439\";i:53678;s:12:\"delete-54440\";i:53679;s:12:\"delete-54441\";i:53680;s:12:\"delete-54444\";i:53681;s:12:\"delete-54445\";i:53682;s:12:\"delete-54437\";i:53683;s:12:\"delete-54438\";i:53684;s:12:\"delete-54442\";i:53685;s:12:\"delete-54443\";i:53686;s:12:\"delete-54446\";i:53687;s:12:\"delete-54449\";i:53688;s:12:\"delete-54450\";i:53689;s:12:\"delete-54447\";i:53690;s:12:\"delete-54448\";i:53691;s:12:\"delete-54451\";i:53692;s:12:\"delete-54454\";i:53693;s:12:\"delete-54455\";i:53694;s:12:\"delete-54452\";i:53695;s:12:\"delete-54453\";i:53696;s:12:\"delete-54456\";i:53697;s:12:\"delete-54459\";i:53698;s:12:\"delete-54460\";i:53699;s:12:\"delete-54457\";i:53700;s:12:\"delete-54458\";i:53701;s:12:\"delete-54461\";i:53702;s:12:\"delete-54464\";i:53703;s:12:\"delete-54465\";i:53704;s:12:\"delete-54462\";i:53705;s:12:\"delete-54463\";i:53706;s:12:\"delete-54466\";i:53707;s:12:\"delete-54469\";i:53708;s:12:\"delete-54470\";i:53709;s:12:\"delete-54467\";i:53710;s:12:\"delete-54468\";i:53711;s:12:\"delete-54471\";i:53712;s:12:\"delete-54474\";i:53713;s:12:\"delete-54475\";i:53714;s:12:\"delete-54472\";i:53715;s:12:\"delete-54473\";i:53716;s:12:\"delete-54476\";i:53717;s:12:\"delete-54479\";i:53718;s:12:\"delete-54480\";i:53719;s:12:\"delete-54477\";i:53720;s:12:\"delete-54478\";i:53721;s:12:\"delete-54481\";i:53722;s:12:\"delete-54484\";i:53723;s:12:\"delete-54485\";i:53724;s:12:\"delete-54482\";i:53725;s:12:\"delete-54483\";i:53726;s:12:\"delete-54486\";i:53727;s:12:\"delete-54489\";i:53728;s:12:\"delete-54487\";i:53729;s:12:\"delete-54488\";i:53730;s:12:\"delete-54490\";i:53731;s:12:\"delete-54491\";i:53732;s:12:\"delete-54494\";i:53733;s:12:\"delete-54495\";i:53734;s:12:\"delete-54492\";i:53735;s:12:\"delete-54493\";i:53736;s:12:\"delete-54496\";i:53737;s:12:\"delete-54499\";i:53738;s:12:\"delete-54497\";i:53739;s:12:\"delete-54498\";i:53740;s:12:\"delete-54500\";i:53741;s:12:\"delete-54501\";i:53742;s:12:\"delete-54504\";i:53743;s:12:\"delete-54505\";i:53744;s:12:\"delete-54502\";i:53745;s:12:\"delete-54503\";i:53746;s:12:\"delete-54506\";i:53747;s:12:\"delete-54509\";i:53748;s:12:\"delete-54510\";i:53749;s:12:\"delete-54507\";i:53750;s:12:\"delete-54508\";i:53751;s:12:\"delete-54511\";i:53752;s:12:\"delete-54514\";i:53753;s:12:\"delete-54515\";i:53754;s:12:\"delete-54512\";i:53755;s:12:\"delete-54513\";i:53756;s:12:\"delete-54516\";i:53757;s:12:\"delete-54519\";i:53758;s:12:\"delete-54520\";i:53759;s:12:\"delete-54517\";i:53760;s:12:\"delete-54518\";i:53761;s:12:\"delete-54521\";i:53762;s:12:\"delete-54524\";i:53763;s:12:\"delete-54522\";i:53764;s:12:\"delete-54523\";i:53765;s:12:\"delete-54525\";i:53766;s:12:\"delete-54526\";i:53767;s:12:\"delete-54529\";i:53768;s:12:\"delete-54530\";i:53769;s:12:\"delete-54527\";i:53770;s:12:\"delete-54528\";i:53771;s:12:\"delete-54531\";i:53772;s:12:\"delete-54534\";i:53773;s:12:\"delete-54535\";i:53774;s:12:\"delete-54532\";i:53775;s:12:\"delete-54533\";i:53776;s:12:\"delete-54536\";i:53777;s:12:\"delete-54539\";i:53778;s:12:\"delete-54540\";i:53779;s:12:\"delete-54537\";i:53780;s:12:\"delete-54538\";i:53781;s:12:\"delete-54541\";i:53782;s:12:\"delete-54544\";i:53783;s:12:\"delete-54545\";i:53784;s:12:\"delete-54542\";i:53785;s:12:\"delete-54543\";i:53786;s:12:\"delete-54546\";i:53787;s:12:\"delete-54549\";i:53788;s:12:\"delete-54550\";i:53789;s:12:\"delete-54547\";i:53790;s:12:\"delete-54548\";i:53791;s:12:\"delete-54551\";i:53792;s:12:\"delete-54554\";i:53793;s:12:\"delete-54555\";i:53794;s:12:\"delete-54552\";i:53795;s:12:\"delete-54553\";i:53796;s:12:\"delete-54556\";i:53797;s:12:\"delete-54559\";i:53798;s:12:\"delete-54560\";i:53799;s:12:\"delete-54557\";i:53800;s:12:\"delete-54558\";i:53801;s:12:\"delete-54561\";i:53802;s:12:\"delete-54564\";i:53803;s:12:\"delete-54565\";i:53804;s:12:\"delete-54562\";i:53805;s:12:\"delete-54563\";i:53806;s:12:\"delete-54566\";i:53807;s:12:\"delete-54569\";i:53808;s:12:\"delete-54570\";i:53809;s:12:\"delete-54567\";i:53810;s:12:\"delete-54568\";i:53811;s:12:\"delete-54571\";i:53812;s:12:\"delete-54574\";i:53813;s:12:\"delete-54575\";i:53814;s:12:\"delete-54572\";i:53815;s:12:\"delete-54573\";i:53816;s:12:\"delete-54576\";i:53817;s:12:\"delete-54579\";i:53818;s:12:\"delete-54580\";i:53819;s:12:\"delete-54577\";i:53820;s:12:\"delete-54578\";i:53821;s:12:\"delete-54581\";i:53822;s:12:\"delete-54582\";i:53823;s:12:\"delete-54583\";i:53824;s:12:\"delete-54584\";i:53825;s:12:\"delete-54585\";i:53826;s:12:\"delete-54586\";i:53827;s:12:\"delete-54589\";i:53828;s:12:\"delete-54587\";i:53829;s:12:\"delete-54588\";i:53830;s:12:\"delete-54590\";i:53831;s:12:\"delete-54591\";i:53832;s:12:\"delete-54594\";i:53833;s:12:\"delete-54592\";i:53834;s:12:\"delete-54593\";i:53835;s:12:\"delete-54595\";i:53836;s:12:\"delete-54596\";i:53837;s:12:\"delete-54599\";i:53838;s:12:\"delete-54597\";i:53839;s:12:\"delete-54598\";i:53840;s:12:\"delete-54600\";i:53841;s:12:\"delete-54601\";i:53842;s:12:\"delete-54604\";i:53843;s:12:\"delete-54605\";i:53844;s:12:\"delete-54602\";i:53845;s:12:\"delete-54603\";i:53846;s:12:\"delete-54606\";i:53847;s:12:\"delete-54609\";i:53848;s:12:\"delete-54610\";i:53849;s:12:\"delete-54607\";i:53850;s:12:\"delete-54608\";i:53851;s:12:\"delete-54611\";i:53852;s:12:\"delete-54614\";i:53853;s:12:\"delete-54615\";i:53854;s:12:\"delete-54612\";i:53855;s:12:\"delete-54613\";i:53856;s:12:\"delete-54616\";i:53857;s:12:\"delete-54619\";i:53858;s:12:\"delete-54620\";i:53859;s:12:\"delete-54617\";i:53860;s:12:\"delete-54618\";i:53861;s:12:\"delete-54621\";i:53862;s:12:\"delete-54624\";i:53863;s:12:\"delete-54625\";i:53864;s:12:\"delete-54622\";i:53865;s:12:\"delete-54623\";i:53866;s:12:\"delete-54626\";i:53867;s:12:\"delete-54629\";i:53868;s:12:\"delete-54627\";i:53869;s:12:\"delete-54628\";i:53870;s:12:\"delete-54630\";i:53871;s:12:\"delete-54631\";i:53872;s:12:\"delete-54634\";i:53873;s:12:\"delete-54635\";i:53874;s:12:\"delete-54632\";i:53875;s:12:\"delete-54633\";i:53876;s:12:\"delete-54636\";i:53877;s:12:\"delete-54639\";i:53878;s:12:\"delete-54640\";i:53879;s:12:\"delete-54637\";i:53880;s:12:\"delete-54638\";i:53881;s:12:\"delete-54641\";i:53882;s:12:\"delete-54644\";i:53883;s:12:\"delete-54645\";i:53884;s:12:\"delete-54642\";i:53885;s:12:\"delete-54643\";i:53886;s:12:\"delete-54646\";i:53887;s:12:\"delete-54649\";i:53888;s:12:\"delete-54647\";i:53889;s:12:\"delete-54648\";i:53890;s:12:\"delete-54650\";i:53891;s:12:\"delete-54651\";i:53892;s:12:\"delete-54654\";i:53893;s:12:\"delete-54655\";i:53894;s:12:\"delete-54652\";i:53895;s:12:\"delete-54653\";i:53896;s:12:\"delete-54656\";i:53897;s:12:\"delete-54659\";i:53898;s:12:\"delete-54660\";i:53899;s:12:\"delete-54657\";i:53900;s:12:\"delete-54658\";i:53901;s:12:\"delete-54661\";i:53902;s:12:\"delete-54664\";i:53903;s:12:\"delete-54665\";i:53904;s:12:\"delete-54662\";i:53905;s:12:\"delete-54663\";i:53906;s:12:\"delete-54666\";i:53907;s:12:\"delete-54669\";i:53908;s:12:\"delete-54670\";i:53909;s:12:\"delete-54667\";i:53910;s:12:\"delete-54668\";i:53911;s:12:\"delete-54671\";i:53912;s:12:\"delete-54674\";i:53913;s:12:\"delete-54675\";i:53914;s:12:\"delete-54672\";i:53915;s:12:\"delete-54673\";i:53916;s:12:\"delete-54676\";i:53917;s:12:\"delete-54679\";i:53918;s:12:\"delete-54680\";i:53919;s:12:\"delete-54677\";i:53920;s:12:\"delete-54678\";i:53921;s:12:\"delete-54681\";i:53922;s:12:\"delete-54684\";i:53923;s:12:\"delete-54685\";i:53924;s:12:\"delete-54682\";i:53925;s:12:\"delete-54683\";i:53926;s:12:\"delete-54686\";i:53927;s:12:\"delete-54689\";i:53928;s:12:\"delete-54690\";i:53929;s:12:\"delete-54687\";i:53930;s:12:\"delete-54688\";i:53931;s:12:\"delete-54691\";i:53932;s:12:\"delete-54694\";i:53933;s:12:\"delete-54695\";i:53934;s:12:\"delete-54692\";i:53935;s:12:\"delete-54693\";i:53936;s:12:\"delete-54696\";i:53937;s:12:\"delete-54699\";i:53938;s:12:\"delete-54700\";i:53939;s:12:\"delete-54697\";i:53940;s:12:\"delete-54698\";i:53941;s:12:\"delete-54701\";i:53942;s:12:\"delete-54704\";i:53943;s:12:\"delete-54705\";i:53944;s:12:\"delete-54702\";i:53945;s:12:\"delete-54703\";i:53946;s:12:\"delete-54706\";i:53947;s:12:\"delete-54709\";i:53948;s:12:\"delete-54710\";i:53949;s:12:\"delete-54707\";i:53950;s:12:\"delete-54708\";i:53951;s:12:\"delete-54711\";i:53952;s:12:\"delete-54714\";i:53953;s:12:\"delete-54715\";i:53954;s:12:\"delete-54712\";i:53955;s:12:\"delete-54713\";i:53956;s:12:\"delete-54716\";i:53957;s:12:\"delete-54719\";i:53958;s:12:\"delete-54720\";i:53959;s:12:\"delete-54717\";i:53960;s:12:\"delete-54718\";i:53961;s:12:\"delete-54721\";i:53962;s:12:\"delete-54724\";i:53963;s:12:\"delete-54725\";i:53964;s:12:\"delete-54722\";i:53965;s:12:\"delete-54723\";i:53966;s:12:\"delete-54726\";i:53967;s:12:\"delete-54729\";i:53968;s:12:\"delete-54730\";i:53969;s:12:\"delete-54727\";i:53970;s:12:\"delete-54728\";i:53971;s:12:\"delete-54731\";i:53972;s:12:\"delete-54734\";i:53973;s:12:\"delete-54735\";i:53974;s:12:\"delete-54732\";i:53975;s:12:\"delete-54733\";i:53976;s:12:\"delete-54736\";i:53977;s:12:\"delete-54739\";i:53978;s:12:\"delete-54740\";i:53979;s:12:\"delete-54737\";i:53980;s:12:\"delete-54738\";i:53981;s:12:\"delete-54741\";i:53982;s:12:\"delete-54744\";i:53983;s:12:\"delete-54745\";i:53984;s:12:\"delete-54742\";i:53985;s:12:\"delete-54743\";i:53986;s:12:\"delete-54746\";i:53987;s:12:\"delete-54749\";i:53988;s:12:\"delete-54750\";i:53989;s:12:\"delete-54747\";i:53990;s:12:\"delete-54748\";i:53991;s:12:\"delete-54751\";i:53992;s:12:\"delete-54754\";i:53993;s:12:\"delete-54755\";i:53994;s:12:\"delete-54752\";i:53995;s:12:\"delete-54753\";i:53996;s:12:\"delete-54756\";i:53997;s:12:\"delete-54759\";i:53998;s:12:\"delete-54760\";i:53999;s:12:\"delete-54757\";i:54000;s:12:\"delete-54758\";i:54001;s:12:\"delete-54761\";i:54002;s:12:\"delete-54764\";i:54003;s:12:\"delete-54765\";i:54004;s:12:\"delete-54762\";i:54005;s:12:\"delete-54763\";i:54006;s:12:\"delete-54766\";i:54007;s:12:\"delete-54769\";i:54008;s:12:\"delete-54770\";i:54009;s:12:\"delete-54767\";i:54010;s:12:\"delete-54768\";i:54011;s:12:\"delete-54771\";i:54012;s:12:\"delete-54774\";i:54013;s:12:\"delete-54775\";i:54014;s:12:\"delete-54772\";i:54015;s:12:\"delete-54773\";i:54016;s:12:\"delete-54776\";i:54017;s:12:\"delete-54779\";i:54018;s:12:\"delete-54780\";i:54019;s:12:\"delete-54777\";i:54020;s:12:\"delete-54778\";i:54021;s:12:\"delete-54781\";i:54022;s:12:\"delete-54784\";i:54023;s:12:\"delete-54782\";i:54024;s:12:\"delete-54783\";i:54025;s:12:\"delete-54785\";i:54026;s:12:\"delete-54788\";i:54027;s:12:\"delete-54789\";i:54028;s:12:\"delete-54786\";i:54029;s:12:\"delete-54787\";i:54030;s:12:\"delete-54790\";i:54031;s:12:\"delete-54793\";i:54032;s:12:\"delete-54794\";i:54033;s:12:\"delete-54791\";i:54034;s:12:\"delete-54792\";i:54035;s:12:\"delete-54795\";i:54036;s:12:\"delete-54798\";i:54037;s:12:\"delete-54799\";i:54038;s:12:\"delete-54796\";i:54039;s:12:\"delete-54797\";i:54040;s:12:\"delete-54800\";i:54041;s:12:\"delete-54803\";i:54042;s:12:\"delete-54804\";i:54043;s:12:\"delete-54801\";i:54044;s:12:\"delete-54802\";i:54045;s:12:\"delete-54805\";i:54046;s:12:\"delete-54808\";i:54047;s:12:\"delete-54809\";i:54048;s:12:\"delete-54806\";i:54049;s:12:\"delete-54807\";i:54050;s:12:\"delete-54810\";i:54051;s:12:\"delete-54813\";i:54052;s:12:\"delete-54814\";i:54053;s:12:\"delete-54811\";i:54054;s:12:\"delete-54812\";i:54055;s:12:\"delete-54815\";i:54056;s:12:\"delete-54818\";i:54057;s:12:\"delete-54819\";i:54058;s:12:\"delete-54816\";i:54059;s:12:\"delete-54817\";i:54060;s:12:\"delete-54820\";i:54061;s:12:\"delete-54823\";i:54062;s:12:\"delete-54821\";i:54063;s:12:\"delete-54822\";i:54064;s:12:\"delete-54824\";i:54065;s:12:\"delete-54825\";i:54066;s:12:\"delete-54828\";i:54067;s:12:\"delete-54826\";i:54068;s:12:\"delete-54827\";i:54069;s:12:\"delete-54829\";i:54070;s:12:\"delete-54830\";i:54071;s:12:\"delete-54833\";i:54072;s:12:\"delete-54834\";i:54073;s:12:\"delete-54831\";i:54074;s:12:\"delete-54832\";i:54075;s:12:\"delete-54835\";i:54076;s:12:\"delete-54838\";i:54077;s:12:\"delete-54839\";i:54078;s:12:\"delete-54836\";i:54079;s:12:\"delete-54837\";i:54080;s:12:\"delete-54840\";i:54081;s:12:\"delete-54843\";i:54082;s:12:\"delete-54844\";i:54083;s:12:\"delete-54841\";i:54084;s:12:\"delete-54842\";i:54085;s:12:\"delete-54845\";i:54086;s:12:\"delete-54848\";i:54087;s:12:\"delete-54849\";i:54088;s:12:\"delete-54846\";i:54089;s:12:\"delete-54847\";i:54090;s:12:\"delete-54850\";i:54091;s:12:\"delete-54853\";i:54092;s:12:\"delete-54851\";i:54093;s:12:\"delete-54852\";i:54094;s:12:\"delete-54854\";i:54095;s:12:\"delete-54855\";i:54096;s:12:\"delete-54858\";i:54097;s:12:\"delete-54859\";i:54098;s:12:\"delete-54856\";i:54099;s:12:\"delete-54857\";i:54100;s:12:\"delete-54860\";i:54101;s:12:\"delete-54863\";i:54102;s:12:\"delete-54864\";i:54103;s:12:\"delete-54861\";i:54104;s:12:\"delete-54862\";i:54105;s:12:\"delete-54865\";i:54106;s:12:\"delete-54868\";i:54107;s:12:\"delete-54869\";i:54108;s:12:\"delete-54866\";i:54109;s:12:\"delete-54867\";i:54110;s:12:\"delete-54870\";i:54111;s:12:\"delete-54873\";i:54112;s:12:\"delete-54874\";i:54113;s:12:\"delete-54871\";i:54114;s:12:\"delete-54872\";i:54115;s:12:\"delete-54875\";i:54116;s:12:\"delete-54878\";i:54117;s:12:\"delete-54879\";i:54118;s:12:\"delete-54876\";i:54119;s:12:\"delete-54877\";i:54120;s:12:\"delete-54880\";i:54121;s:12:\"delete-54883\";i:54122;s:12:\"delete-54881\";i:54123;s:12:\"delete-54882\";i:54124;s:12:\"delete-54884\";i:54125;s:12:\"delete-54885\";i:54126;s:12:\"delete-54888\";i:54127;s:12:\"delete-54889\";i:54128;s:12:\"delete-54886\";i:54129;s:12:\"delete-54887\";i:54130;s:12:\"delete-54890\";i:54131;s:12:\"delete-54893\";i:54132;s:12:\"delete-54894\";i:54133;s:12:\"delete-54891\";i:54134;s:12:\"delete-54892\";i:54135;s:12:\"delete-54895\";i:54136;s:12:\"delete-54898\";i:54137;s:12:\"delete-54896\";i:54138;s:12:\"delete-54897\";i:54139;s:12:\"delete-54899\";i:54140;s:12:\"delete-54900\";i:54141;s:12:\"delete-54903\";i:54142;s:12:\"delete-54904\";i:54143;s:12:\"delete-54901\";i:54144;s:12:\"delete-54902\";i:54145;s:12:\"delete-54905\";i:54146;s:12:\"delete-54908\";i:54147;s:12:\"delete-54909\";i:54148;s:12:\"delete-54906\";i:54149;s:12:\"delete-54907\";i:54150;s:12:\"delete-54910\";i:54151;s:12:\"delete-54913\";i:54152;s:12:\"delete-54914\";i:54153;s:12:\"delete-54911\";i:54154;s:12:\"delete-54912\";i:54155;s:12:\"delete-54915\";i:54156;s:12:\"delete-54916\";i:54157;s:12:\"delete-54917\";i:54158;s:12:\"delete-54918\";i:54159;s:12:\"delete-54919\";i:54160;s:12:\"delete-54920\";i:54161;s:12:\"delete-54923\";i:54162;s:12:\"delete-54924\";i:54163;s:12:\"delete-54921\";i:54164;s:12:\"delete-54922\";i:54165;s:12:\"delete-54925\";i:54166;s:12:\"delete-54928\";i:54167;s:12:\"delete-54929\";i:54168;s:12:\"delete-54926\";i:54169;s:12:\"delete-54927\";i:54170;s:12:\"delete-54930\";i:54171;s:12:\"delete-54933\";i:54172;s:12:\"delete-54934\";i:54173;s:12:\"delete-54931\";i:54174;s:12:\"delete-54932\";i:54175;s:12:\"delete-54935\";i:54176;s:12:\"delete-54938\";i:54177;s:12:\"delete-54939\";i:54178;s:12:\"delete-54936\";i:54179;s:12:\"delete-54937\";i:54180;s:12:\"delete-54940\";i:54181;s:12:\"delete-54943\";i:54182;s:12:\"delete-54941\";i:54183;s:12:\"delete-54942\";i:54184;s:12:\"delete-54944\";i:54185;s:12:\"delete-54945\";i:54186;s:12:\"delete-54948\";i:54187;s:12:\"delete-54949\";i:54188;s:12:\"delete-54946\";i:54189;s:12:\"delete-54947\";i:54190;s:12:\"delete-54950\";i:54191;s:12:\"delete-54953\";i:54192;s:12:\"delete-54954\";i:54193;s:12:\"delete-54951\";i:54194;s:12:\"delete-54952\";i:54195;s:12:\"delete-54955\";i:54196;s:12:\"delete-54958\";i:54197;s:12:\"delete-54959\";i:54198;s:12:\"delete-54956\";i:54199;s:12:\"delete-54957\";i:54200;s:12:\"delete-54960\";i:54201;s:12:\"delete-54963\";i:54202;s:12:\"delete-54964\";i:54203;s:12:\"delete-54961\";i:54204;s:12:\"delete-54962\";i:54205;s:12:\"delete-54965\";i:54206;s:12:\"delete-54968\";i:54207;s:12:\"delete-54969\";i:54208;s:12:\"delete-54966\";i:54209;s:12:\"delete-54967\";i:54210;s:12:\"delete-54970\";i:54211;s:12:\"delete-54973\";i:54212;s:12:\"delete-54974\";i:54213;s:12:\"delete-54971\";i:54214;s:12:\"delete-54972\";i:54215;s:12:\"delete-54975\";i:54216;s:12:\"delete-54978\";i:54217;s:12:\"delete-54979\";i:54218;s:12:\"delete-54976\";i:54219;s:12:\"delete-54977\";i:54220;s:12:\"delete-54980\";i:54221;s:12:\"delete-54983\";i:54222;s:12:\"delete-54984\";i:54223;s:12:\"delete-54981\";i:54224;s:12:\"delete-54982\";i:54225;s:12:\"delete-54985\";i:54226;s:12:\"delete-54988\";i:54227;s:12:\"delete-54989\";i:54228;s:12:\"delete-54986\";i:54229;s:12:\"delete-54987\";i:54230;s:12:\"delete-54990\";i:54231;s:12:\"delete-54993\";i:54232;s:12:\"delete-54994\";i:54233;s:12:\"delete-54991\";i:54234;s:12:\"delete-54992\";i:54235;s:12:\"delete-54995\";i:54236;s:12:\"delete-54998\";i:54237;s:12:\"delete-54999\";i:54238;s:12:\"delete-54996\";i:54239;s:12:\"delete-54997\";i:54240;s:12:\"delete-55000\";i:54241;s:12:\"delete-55003\";i:54242;s:12:\"delete-55004\";i:54243;s:12:\"delete-55001\";i:54244;s:12:\"delete-55002\";i:54245;s:12:\"delete-55005\";i:54246;s:12:\"delete-55008\";i:54247;s:12:\"delete-55009\";i:54248;s:12:\"delete-55006\";i:54249;s:12:\"delete-55007\";i:54250;s:12:\"delete-55010\";i:54251;s:12:\"delete-55013\";i:54252;s:12:\"delete-55014\";i:54253;s:12:\"delete-55011\";i:54254;s:12:\"delete-55012\";i:54255;s:12:\"delete-55015\";i:54256;s:12:\"delete-55018\";i:54257;s:12:\"delete-55019\";i:54258;s:12:\"delete-55016\";i:54259;s:12:\"delete-55017\";i:54260;s:12:\"delete-55020\";i:54261;s:12:\"delete-55023\";i:54262;s:12:\"delete-55024\";i:54263;s:12:\"delete-55021\";i:54264;s:12:\"delete-55022\";i:54265;s:12:\"delete-55025\";i:54266;s:12:\"delete-55028\";i:54267;s:12:\"delete-55026\";i:54268;s:12:\"delete-55027\";i:54269;s:12:\"delete-55029\";i:54270;s:12:\"delete-55030\";i:54271;s:12:\"delete-55033\";i:54272;s:12:\"delete-55034\";i:54273;s:12:\"delete-55031\";i:54274;s:12:\"delete-55032\";i:54275;s:12:\"delete-55035\";i:54276;s:12:\"delete-55038\";i:54277;s:12:\"delete-55039\";i:54278;s:12:\"delete-55036\";i:54279;s:12:\"delete-55037\";i:54280;s:12:\"delete-55040\";i:54281;s:12:\"delete-55043\";i:54282;s:12:\"delete-55041\";i:54283;s:12:\"delete-55042\";i:54284;s:12:\"delete-55044\";i:54285;s:12:\"delete-55045\";i:54286;s:12:\"delete-55048\";i:54287;s:12:\"delete-55049\";i:54288;s:12:\"delete-55046\";i:54289;s:12:\"delete-55047\";i:54290;s:12:\"delete-55050\";i:54291;s:12:\"delete-55053\";i:54292;s:12:\"delete-55054\";i:54293;s:12:\"delete-55051\";i:54294;s:12:\"delete-55052\";i:54295;s:12:\"delete-55055\";i:54296;s:12:\"delete-55058\";i:54297;s:12:\"delete-55059\";i:54298;s:12:\"delete-55056\";i:54299;s:12:\"delete-55057\";i:54300;s:12:\"delete-55060\";i:54301;s:12:\"delete-55061\";i:54302;s:12:\"delete-55062\";i:54303;s:12:\"delete-55063\";i:54304;s:12:\"delete-55064\";i:54305;s:12:\"delete-55065\";i:54306;s:12:\"delete-55068\";i:54307;s:12:\"delete-55069\";i:54308;s:12:\"delete-55066\";i:54309;s:12:\"delete-55067\";i:54310;s:12:\"delete-55070\";i:54311;s:12:\"delete-55073\";i:54312;s:12:\"delete-55074\";i:54313;s:12:\"delete-55071\";i:54314;s:12:\"delete-55072\";i:54315;s:12:\"delete-55075\";i:54316;s:12:\"delete-55078\";i:54317;s:12:\"delete-55079\";i:54318;s:12:\"delete-55076\";i:54319;s:12:\"delete-55077\";i:54320;s:12:\"delete-55080\";i:54321;s:12:\"delete-55083\";i:54322;s:12:\"delete-55084\";i:54323;s:12:\"delete-55081\";i:54324;s:12:\"delete-55082\";i:54325;s:12:\"delete-55085\";i:54326;s:12:\"delete-55088\";i:54327;s:12:\"delete-55089\";i:54328;s:12:\"delete-55086\";i:54329;s:12:\"delete-55087\";i:54330;s:12:\"delete-55090\";i:54331;s:12:\"delete-55093\";i:54332;s:12:\"delete-55091\";i:54333;s:12:\"delete-55092\";i:54334;s:12:\"delete-55094\";i:54335;s:12:\"delete-55095\";i:54336;s:12:\"delete-55098\";i:54337;s:12:\"delete-55099\";i:54338;s:12:\"delete-55096\";i:54339;s:12:\"delete-55097\";i:54340;s:12:\"delete-55100\";i:54341;s:12:\"delete-55103\";i:54342;s:12:\"delete-55101\";i:54343;s:12:\"delete-55102\";i:54344;s:12:\"delete-55104\";i:54345;s:12:\"delete-55105\";i:54346;s:12:\"delete-55108\";i:54347;s:12:\"delete-55109\";i:54348;s:12:\"delete-55106\";i:54349;s:12:\"delete-55107\";i:54350;s:12:\"delete-55110\";i:54351;s:12:\"delete-55113\";i:54352;s:12:\"delete-55114\";i:54353;s:12:\"delete-55111\";i:54354;s:12:\"delete-55112\";i:54355;s:12:\"delete-55115\";i:54356;s:12:\"delete-55118\";i:54357;s:12:\"delete-55119\";i:54358;s:12:\"delete-55116\";i:54359;s:12:\"delete-55117\";i:54360;s:12:\"delete-55120\";i:54361;s:12:\"delete-55123\";i:54362;s:12:\"delete-55124\";i:54363;s:12:\"delete-55121\";i:54364;s:12:\"delete-55122\";i:54365;s:12:\"delete-55125\";i:54366;s:12:\"delete-55128\";i:54367;s:12:\"delete-55126\";i:54368;s:12:\"delete-55127\";i:54369;s:12:\"delete-55129\";i:54370;s:12:\"delete-55130\";i:54371;s:12:\"delete-55133\";i:54372;s:12:\"delete-55131\";i:54373;s:12:\"delete-55132\";i:54374;s:12:\"delete-55134\";i:54375;s:12:\"delete-55135\";i:54376;s:12:\"delete-55138\";i:54377;s:12:\"delete-55136\";i:54378;s:12:\"delete-55137\";i:54379;s:12:\"delete-55139\";i:54380;s:12:\"delete-55140\";i:54381;s:12:\"delete-55143\";i:54382;s:12:\"delete-55144\";i:54383;s:12:\"delete-55141\";i:54384;s:12:\"delete-55142\";i:54385;s:12:\"delete-55145\";i:54386;s:12:\"delete-55148\";i:54387;s:12:\"delete-55149\";i:54388;s:12:\"delete-55146\";i:54389;s:12:\"delete-55147\";i:54390;s:12:\"delete-55150\";i:54391;s:12:\"delete-55153\";i:54392;s:12:\"delete-55154\";i:54393;s:12:\"delete-55151\";i:54394;s:12:\"delete-55152\";i:54395;s:12:\"delete-55155\";i:54396;s:12:\"delete-55158\";i:54397;s:12:\"delete-55156\";i:54398;s:12:\"delete-55157\";i:54399;s:12:\"delete-55159\";i:54400;s:12:\"delete-55160\";i:54401;s:12:\"delete-55163\";i:54402;s:12:\"delete-55164\";i:54403;s:12:\"delete-55161\";i:54404;s:12:\"delete-55162\";i:54405;s:12:\"delete-55165\";i:54406;s:12:\"delete-55168\";i:54407;s:12:\"delete-55166\";i:54408;s:12:\"delete-55167\";i:54409;s:12:\"delete-55169\";i:54410;s:12:\"delete-55170\";i:54411;s:12:\"delete-55173\";i:54412;s:12:\"delete-55174\";i:54413;s:12:\"delete-55171\";i:54414;s:12:\"delete-55172\";i:54415;s:12:\"delete-55175\";i:54416;s:12:\"delete-55178\";i:54417;s:12:\"delete-55179\";i:54418;s:12:\"delete-55176\";i:54419;s:12:\"delete-55177\";i:54420;s:12:\"delete-55180\";i:54421;s:12:\"delete-55183\";i:54422;s:12:\"delete-55184\";i:54423;s:12:\"delete-55181\";i:54424;s:12:\"delete-55182\";i:54425;s:12:\"delete-55185\";i:54426;s:12:\"delete-55188\";i:54427;s:12:\"delete-55189\";i:54428;s:12:\"delete-55186\";i:54429;s:12:\"delete-55187\";i:54430;s:12:\"delete-55190\";i:54431;s:12:\"delete-55193\";i:54432;s:12:\"delete-55194\";i:54433;s:12:\"delete-55191\";i:54434;s:12:\"delete-55192\";i:54435;s:12:\"delete-55195\";i:54436;s:12:\"delete-55198\";i:54437;s:12:\"delete-55199\";i:54438;s:12:\"delete-55196\";i:54439;s:12:\"delete-55197\";i:54440;s:12:\"delete-55200\";i:54441;s:12:\"delete-55203\";i:54442;s:12:\"delete-55201\";i:54443;s:12:\"delete-55202\";i:54444;s:12:\"delete-55204\";i:54445;s:12:\"delete-55205\";i:54446;s:12:\"delete-55208\";i:54447;s:12:\"delete-55209\";i:54448;s:12:\"delete-55206\";i:54449;s:12:\"delete-55207\";i:54450;s:12:\"delete-55210\";i:54451;s:12:\"delete-55213\";i:54452;s:12:\"delete-55214\";i:54453;s:12:\"delete-55211\";i:54454;s:12:\"delete-55212\";i:54455;s:12:\"delete-55215\";i:54456;s:12:\"delete-55218\";i:54457;s:12:\"delete-55219\";i:54458;s:12:\"delete-55216\";i:54459;s:12:\"delete-55217\";i:54460;s:12:\"delete-55220\";i:54461;s:12:\"delete-55223\";i:54462;s:12:\"delete-55224\";i:54463;s:12:\"delete-55221\";i:54464;s:12:\"delete-55222\";i:54465;s:12:\"delete-55225\";i:54466;s:12:\"delete-55228\";i:54467;s:12:\"delete-55229\";i:54468;s:12:\"delete-55226\";i:54469;s:12:\"delete-55227\";i:54470;s:12:\"delete-55230\";i:54471;s:12:\"delete-55233\";i:54472;s:12:\"delete-55234\";i:54473;s:12:\"delete-55231\";i:54474;s:12:\"delete-55232\";i:54475;s:12:\"delete-55235\";i:54476;s:12:\"delete-55238\";i:54477;s:12:\"delete-55239\";i:54478;s:12:\"delete-55236\";i:54479;s:12:\"delete-55237\";i:54480;s:12:\"delete-55240\";i:54481;s:12:\"delete-55243\";i:54482;s:12:\"delete-55244\";i:54483;s:12:\"delete-55241\";i:54484;s:12:\"delete-55242\";i:54485;s:12:\"delete-55245\";i:54486;s:12:\"delete-55248\";i:54487;s:12:\"delete-55249\";i:54488;s:12:\"delete-55246\";i:54489;s:12:\"delete-55247\";i:54490;s:12:\"delete-55250\";i:54491;s:12:\"delete-55253\";i:54492;s:12:\"delete-55254\";i:54493;s:12:\"delete-55251\";i:54494;s:12:\"delete-55252\";i:54495;s:12:\"delete-55255\";i:54496;s:12:\"delete-55258\";i:54497;s:12:\"delete-55259\";i:54498;s:12:\"delete-55256\";i:54499;s:12:\"delete-55257\";i:54500;s:12:\"delete-55260\";i:54501;s:12:\"delete-55263\";i:54502;s:12:\"delete-55264\";i:54503;s:12:\"delete-55261\";i:54504;s:12:\"delete-55262\";i:54505;s:12:\"delete-55265\";i:54506;s:12:\"delete-55268\";i:54507;s:12:\"delete-55266\";i:54508;s:12:\"delete-55267\";i:54509;s:12:\"delete-55269\";i:54510;s:12:\"delete-55270\";i:54511;s:12:\"delete-55273\";i:54512;s:12:\"delete-55274\";i:54513;s:12:\"delete-55271\";i:54514;s:12:\"delete-55272\";i:54515;s:12:\"delete-55275\";i:54516;s:12:\"delete-55278\";i:54517;s:12:\"delete-55279\";i:54518;s:12:\"delete-55276\";i:54519;s:12:\"delete-55277\";i:54520;s:12:\"delete-55280\";i:54521;s:12:\"delete-55283\";i:54522;s:12:\"delete-55281\";i:54523;s:12:\"delete-55282\";i:54524;s:12:\"delete-55284\";i:54525;s:12:\"delete-55285\";i:54526;s:12:\"delete-55288\";i:54527;s:12:\"delete-55289\";i:54528;s:12:\"delete-55286\";i:54529;s:12:\"delete-55287\";i:54530;s:12:\"delete-55290\";i:54531;s:12:\"delete-55293\";i:54532;s:12:\"delete-55291\";i:54533;s:12:\"delete-55292\";i:54534;s:12:\"delete-55294\";i:54535;s:12:\"delete-55295\";i:54536;s:12:\"delete-55298\";i:54537;s:12:\"delete-55299\";i:54538;s:12:\"delete-55296\";i:54539;s:12:\"delete-55297\";i:54540;s:12:\"delete-55300\";i:54541;s:12:\"delete-55303\";i:54542;s:12:\"delete-55304\";i:54543;s:12:\"delete-55301\";i:54544;s:12:\"delete-55302\";i:54545;s:12:\"delete-55305\";i:54546;s:12:\"delete-55308\";i:54547;s:12:\"delete-55309\";i:54548;s:12:\"delete-55306\";i:54549;s:12:\"delete-55307\";i:54550;s:12:\"delete-55310\";i:54551;s:12:\"delete-55313\";i:54552;s:12:\"delete-55314\";i:54553;s:12:\"delete-55311\";i:54554;s:12:\"delete-55312\";i:54555;s:12:\"delete-55315\";i:54556;s:12:\"delete-55318\";i:54557;s:12:\"delete-55316\";i:54558;s:12:\"delete-55317\";i:54559;s:12:\"delete-55319\";i:54560;s:12:\"delete-55320\";i:54561;s:12:\"delete-55323\";i:54562;s:12:\"delete-55324\";i:54563;s:12:\"delete-55321\";i:54564;s:12:\"delete-55322\";i:54565;s:12:\"delete-55325\";i:54566;s:12:\"delete-55328\";i:54567;s:12:\"delete-55329\";i:54568;s:12:\"delete-55326\";i:54569;s:12:\"delete-55327\";i:54570;s:12:\"delete-55330\";i:54571;s:12:\"delete-55333\";i:54572;s:12:\"delete-55334\";i:54573;s:12:\"delete-55331\";i:54574;s:12:\"delete-55332\";i:54575;s:12:\"delete-55335\";i:54576;s:12:\"delete-55338\";i:54577;s:12:\"delete-55339\";i:54578;s:12:\"delete-55336\";i:54579;s:12:\"delete-55337\";i:54580;s:12:\"delete-55340\";i:54581;s:12:\"delete-55343\";i:54582;s:12:\"delete-55344\";i:54583;s:12:\"delete-55341\";i:54584;s:12:\"delete-55342\";i:54585;s:12:\"delete-55345\";i:54586;s:12:\"delete-55348\";i:54587;s:12:\"delete-55349\";i:54588;s:12:\"delete-55346\";i:54589;s:12:\"delete-55347\";i:54590;s:12:\"delete-55350\";i:54591;s:12:\"delete-55353\";i:54592;s:12:\"delete-55354\";i:54593;s:12:\"delete-55351\";i:54594;s:12:\"delete-55352\";i:54595;s:12:\"delete-55355\";i:54596;s:12:\"delete-55358\";i:54597;s:12:\"delete-55359\";i:54598;s:12:\"delete-55356\";i:54599;s:12:\"delete-55357\";i:54600;s:12:\"delete-55360\";i:54601;s:12:\"delete-55363\";i:54602;s:12:\"delete-55364\";i:54603;s:12:\"delete-55361\";i:54604;s:12:\"delete-55362\";i:54605;s:12:\"delete-55365\";i:54606;s:12:\"delete-55368\";i:54607;s:12:\"delete-55369\";i:54608;s:12:\"delete-55366\";i:54609;s:12:\"delete-55367\";i:54610;s:12:\"delete-55370\";i:54611;s:12:\"delete-55373\";i:54612;s:12:\"delete-55374\";i:54613;s:12:\"delete-55371\";i:54614;s:12:\"delete-55372\";i:54615;s:12:\"delete-55375\";i:54616;s:12:\"delete-55378\";i:54617;s:12:\"delete-55379\";i:54618;s:12:\"delete-55376\";i:54619;s:12:\"delete-55377\";i:54620;s:12:\"delete-55380\";i:54621;s:12:\"delete-55383\";i:54622;s:12:\"delete-55384\";i:54623;s:12:\"delete-55381\";i:54624;s:12:\"delete-55382\";i:54625;s:12:\"delete-55385\";i:54626;s:12:\"delete-55388\";i:54627;s:12:\"delete-55389\";i:54628;s:12:\"delete-55386\";i:54629;s:12:\"delete-55387\";i:54630;s:12:\"delete-55390\";i:54631;s:12:\"delete-55393\";i:54632;s:12:\"delete-55391\";i:54633;s:12:\"delete-55392\";i:54634;s:12:\"delete-55394\";i:54635;s:12:\"delete-55395\";i:54636;s:12:\"delete-55398\";i:54637;s:12:\"delete-55399\";i:54638;s:12:\"delete-55396\";i:54639;s:12:\"delete-55397\";i:54640;s:12:\"delete-55400\";i:54641;s:12:\"delete-55403\";i:54642;s:12:\"delete-55404\";i:54643;s:12:\"delete-55401\";i:54644;s:12:\"delete-55402\";i:54645;s:12:\"delete-55405\";i:54646;s:12:\"delete-55408\";i:54647;s:12:\"delete-55409\";i:54648;s:12:\"delete-55406\";i:54649;s:12:\"delete-55407\";i:54650;s:12:\"delete-55410\";i:54651;s:12:\"delete-55413\";i:54652;s:12:\"delete-55414\";i:54653;s:12:\"delete-55411\";i:54654;s:12:\"delete-55412\";i:54655;s:12:\"delete-55415\";i:54656;s:12:\"delete-55418\";i:54657;s:12:\"delete-55419\";i:54658;s:12:\"delete-55416\";i:54659;s:12:\"delete-55417\";i:54660;s:12:\"delete-55420\";i:54661;s:12:\"delete-55423\";i:54662;s:12:\"delete-55421\";i:54663;s:12:\"delete-55422\";i:54664;s:12:\"delete-55424\";i:54665;s:12:\"delete-55427\";i:54666;s:12:\"delete-55428\";i:54667;s:12:\"delete-55425\";i:54668;s:12:\"delete-55426\";i:54669;s:12:\"delete-55429\";i:54670;s:12:\"delete-55432\";i:54671;s:12:\"delete-55433\";i:54672;s:12:\"delete-55430\";i:54673;s:12:\"delete-55431\";i:54674;s:12:\"delete-55434\";i:54675;s:12:\"delete-55437\";i:54676;s:12:\"delete-55435\";i:54677;s:12:\"delete-55436\";i:54678;s:12:\"delete-55438\";i:54679;s:12:\"delete-55439\";i:54680;s:12:\"delete-55442\";i:54681;s:12:\"delete-55443\";i:54682;s:12:\"delete-55440\";i:54683;s:12:\"delete-55441\";i:54684;s:12:\"delete-55444\";i:54685;s:12:\"delete-55447\";i:54686;s:12:\"delete-55445\";i:54687;s:12:\"delete-55446\";i:54688;s:12:\"delete-55448\";i:54689;s:12:\"delete-55449\";i:54690;s:12:\"delete-55452\";i:54691;s:12:\"delete-55453\";i:54692;s:12:\"delete-55450\";i:54693;s:12:\"delete-55451\";i:54694;s:12:\"delete-55454\";i:54695;s:12:\"delete-55457\";i:54696;s:12:\"delete-55458\";i:54697;s:12:\"delete-55455\";i:54698;s:12:\"delete-55456\";i:54699;s:12:\"delete-55459\";i:54700;s:12:\"delete-55462\";i:54701;s:12:\"delete-55463\";i:54702;s:12:\"delete-55460\";i:54703;s:12:\"delete-55461\";i:54704;s:12:\"delete-55464\";i:54705;s:12:\"delete-55467\";i:54706;s:12:\"delete-55468\";i:54707;s:12:\"delete-55465\";i:54708;s:12:\"delete-55466\";i:54709;s:12:\"delete-55469\";i:54710;s:12:\"delete-55472\";i:54711;s:12:\"delete-55473\";i:54712;s:12:\"delete-55470\";i:54713;s:12:\"delete-55471\";i:54714;s:12:\"delete-55474\";i:54715;s:12:\"delete-55477\";i:54716;s:12:\"delete-55478\";i:54717;s:12:\"delete-55475\";i:54718;s:12:\"delete-55476\";i:54719;s:12:\"delete-55479\";i:54720;s:12:\"delete-55482\";i:54721;s:12:\"delete-55483\";i:54722;s:12:\"delete-55480\";i:54723;s:12:\"delete-55481\";i:54724;s:12:\"delete-55484\";i:54725;s:12:\"delete-55487\";i:54726;s:12:\"delete-55485\";i:54727;s:12:\"delete-55486\";i:54728;s:12:\"delete-55488\";i:54729;s:12:\"delete-55489\";i:54730;s:12:\"delete-55492\";i:54731;s:12:\"delete-55493\";i:54732;s:12:\"delete-55490\";i:54733;s:12:\"delete-55491\";i:54734;s:12:\"delete-55494\";i:54735;s:12:\"delete-55497\";i:54736;s:12:\"delete-55498\";i:54737;s:12:\"delete-55495\";i:54738;s:12:\"delete-55496\";i:54739;s:12:\"delete-55499\";i:54740;s:12:\"delete-55500\";i:54741;s:12:\"delete-55501\";i:54742;s:12:\"delete-55502\";i:54743;s:12:\"delete-55503\";i:54744;s:12:\"delete-55504\";i:54745;s:12:\"delete-55507\";i:54746;s:12:\"delete-55508\";i:54747;s:12:\"delete-55505\";i:54748;s:12:\"delete-55506\";i:54749;s:12:\"delete-55509\";i:54750;s:12:\"delete-55512\";i:54751;s:12:\"delete-55510\";i:54752;s:12:\"delete-55511\";i:54753;s:12:\"delete-55513\";i:54754;s:12:\"delete-55514\";i:54755;s:12:\"delete-55517\";i:54756;s:12:\"delete-55518\";i:54757;s:12:\"delete-55515\";i:54758;s:12:\"delete-55516\";i:54759;s:12:\"delete-55519\";i:54760;s:12:\"delete-55522\";i:54761;s:12:\"delete-55523\";i:54762;s:12:\"delete-55520\";i:54763;s:12:\"delete-55521\";i:54764;s:12:\"delete-55524\";i:54765;s:12:\"delete-55527\";i:54766;s:12:\"delete-55528\";i:54767;s:12:\"delete-55525\";i:54768;s:12:\"delete-55526\";i:54769;s:12:\"delete-55529\";i:54770;s:12:\"delete-55532\";i:54771;s:12:\"delete-55533\";i:54772;s:12:\"delete-55530\";i:54773;s:12:\"delete-55531\";i:54774;s:12:\"delete-55534\";i:54775;s:12:\"delete-55537\";i:54776;s:12:\"delete-55538\";i:54777;s:12:\"delete-55535\";i:54778;s:12:\"delete-55536\";i:54779;s:12:\"delete-55539\";i:54780;s:12:\"delete-55542\";i:54781;s:12:\"delete-55543\";i:54782;s:12:\"delete-55540\";i:54783;s:12:\"delete-55541\";i:54784;s:12:\"delete-55544\";i:54785;s:12:\"delete-55547\";i:54786;s:12:\"delete-55548\";i:54787;s:12:\"delete-55545\";i:54788;s:12:\"delete-55546\";i:54789;s:12:\"delete-55549\";i:54790;s:12:\"delete-55552\";i:54791;s:12:\"delete-55553\";i:54792;s:12:\"delete-55550\";i:54793;s:12:\"delete-55551\";i:54794;s:12:\"delete-55554\";i:54795;s:12:\"delete-55557\";i:54796;s:12:\"delete-55558\";i:54797;s:12:\"delete-55555\";i:54798;s:12:\"delete-55556\";i:54799;s:12:\"delete-55559\";i:54800;s:12:\"delete-55562\";i:54801;s:12:\"delete-55563\";i:54802;s:12:\"delete-55560\";i:54803;s:12:\"delete-55561\";i:54804;s:12:\"delete-55564\";i:54805;s:12:\"delete-55567\";i:54806;s:12:\"delete-55568\";i:54807;s:12:\"delete-55565\";i:54808;s:12:\"delete-55566\";i:54809;s:12:\"delete-55569\";i:54810;s:12:\"delete-55572\";i:54811;s:12:\"delete-55573\";i:54812;s:12:\"delete-55570\";i:54813;s:12:\"delete-55571\";i:54814;s:12:\"delete-55574\";i:54815;s:12:\"delete-55577\";i:54816;s:12:\"delete-55575\";i:54817;s:12:\"delete-55576\";i:54818;s:12:\"delete-55578\";i:54819;s:12:\"delete-55579\";i:54820;s:12:\"delete-55582\";i:54821;s:12:\"delete-55583\";i:54822;s:12:\"delete-55580\";i:54823;s:12:\"delete-55581\";i:54824;s:12:\"delete-55584\";i:54825;s:12:\"delete-55587\";i:54826;s:12:\"delete-55588\";i:54827;s:12:\"delete-55585\";i:54828;s:12:\"delete-55586\";i:54829;s:12:\"delete-55589\";i:54830;s:12:\"delete-55592\";i:54831;s:12:\"delete-55593\";i:54832;s:12:\"delete-55590\";i:54833;s:12:\"delete-55591\";i:54834;s:12:\"delete-55594\";i:54835;s:12:\"delete-55597\";i:54836;s:12:\"delete-55598\";i:54837;s:12:\"delete-55595\";i:54838;s:12:\"delete-55596\";i:54839;s:12:\"delete-55599\";i:54840;s:12:\"delete-55602\";i:54841;s:12:\"delete-55600\";i:54842;s:12:\"delete-55601\";i:54843;s:12:\"delete-55603\";i:54844;s:12:\"delete-55604\";i:54845;s:12:\"delete-55607\";i:54846;s:12:\"delete-55608\";i:54847;s:12:\"delete-55605\";i:54848;s:12:\"delete-55606\";i:54849;s:12:\"delete-55609\";i:54850;s:12:\"delete-55612\";i:54851;s:12:\"delete-55613\";i:54852;s:12:\"delete-55610\";i:54853;s:12:\"delete-55611\";i:54854;s:12:\"delete-55614\";i:54855;s:12:\"delete-55617\";i:54856;s:12:\"delete-55618\";i:54857;s:12:\"delete-55615\";i:54858;s:12:\"delete-55616\";i:54859;s:12:\"delete-55619\";i:54860;s:12:\"delete-55622\";i:54861;s:12:\"delete-55623\";i:54862;s:12:\"delete-55620\";i:54863;s:12:\"delete-55621\";i:54864;s:12:\"delete-55624\";i:54865;s:12:\"delete-55627\";i:54866;s:12:\"delete-55628\";i:54867;s:12:\"delete-55625\";i:54868;s:12:\"delete-55626\";i:54869;s:12:\"delete-55629\";i:54870;s:12:\"delete-55632\";i:54871;s:12:\"delete-55633\";i:54872;s:12:\"delete-55630\";i:54873;s:12:\"delete-55631\";i:54874;s:12:\"delete-55634\";i:54875;s:12:\"delete-55637\";i:54876;s:12:\"delete-55638\";i:54877;s:12:\"delete-55635\";i:54878;s:12:\"delete-55636\";i:54879;s:12:\"delete-55639\";i:54880;s:12:\"delete-55642\";i:54881;s:12:\"delete-55640\";i:54882;s:12:\"delete-55641\";i:54883;s:12:\"delete-55643\";i:54884;s:12:\"delete-55644\";i:54885;s:12:\"delete-55645\";i:54886;s:12:\"delete-55646\";i:54887;s:12:\"delete-55647\";i:54888;s:12:\"delete-55648\";i:54889;s:12:\"delete-55649\";i:54890;s:12:\"delete-55652\";i:54891;s:12:\"delete-55650\";i:54892;s:12:\"delete-55651\";i:54893;s:12:\"delete-55653\";i:54894;s:12:\"delete-55654\";i:54895;s:12:\"delete-55657\";i:54896;s:12:\"delete-55658\";i:54897;s:12:\"delete-55655\";i:54898;s:12:\"delete-55656\";i:54899;s:12:\"delete-55659\";i:54900;s:12:\"delete-55662\";i:54901;s:12:\"delete-55663\";i:54902;s:12:\"delete-55660\";i:54903;s:12:\"delete-55661\";i:54904;s:12:\"delete-55664\";i:54905;s:12:\"delete-55667\";i:54906;s:12:\"delete-55668\";i:54907;s:12:\"delete-55665\";i:54908;s:12:\"delete-55666\";i:54909;s:12:\"delete-55669\";i:54910;s:12:\"delete-55672\";i:54911;s:12:\"delete-55673\";i:54912;s:12:\"delete-55670\";i:54913;s:12:\"delete-55671\";i:54914;s:12:\"delete-55674\";i:54915;s:12:\"delete-55677\";i:54916;s:12:\"delete-55678\";i:54917;s:12:\"delete-55675\";i:54918;s:12:\"delete-55676\";i:54919;s:12:\"delete-55679\";i:54920;s:12:\"delete-55682\";i:54921;s:12:\"delete-55683\";i:54922;s:12:\"delete-55680\";i:54923;s:12:\"delete-55681\";i:54924;s:12:\"delete-55684\";i:54925;s:12:\"delete-55687\";i:54926;s:12:\"delete-55688\";i:54927;s:12:\"delete-55685\";i:54928;s:12:\"delete-55686\";i:54929;s:12:\"delete-55689\";i:54930;s:12:\"delete-55692\";i:54931;s:12:\"delete-55693\";i:54932;s:12:\"delete-55690\";i:54933;s:12:\"delete-55691\";i:54934;s:12:\"delete-55694\";i:54935;s:12:\"delete-55697\";i:54936;s:12:\"delete-55698\";i:54937;s:12:\"delete-55695\";i:54938;s:12:\"delete-55696\";i:54939;s:12:\"delete-55699\";i:54940;s:12:\"delete-55702\";i:54941;s:12:\"delete-55700\";i:54942;s:12:\"delete-55701\";i:54943;s:12:\"delete-55703\";i:54944;s:12:\"delete-55704\";i:54945;s:12:\"delete-55707\";i:54946;s:12:\"delete-55705\";i:54947;s:12:\"delete-55706\";i:54948;s:12:\"delete-55708\";i:54949;s:12:\"delete-55709\";i:54950;s:12:\"delete-55712\";i:54951;s:12:\"delete-55713\";i:54952;s:12:\"delete-55710\";i:54953;s:12:\"delete-55711\";i:54954;s:12:\"delete-55714\";i:54955;s:12:\"delete-55717\";i:54956;s:12:\"delete-55715\";i:54957;s:12:\"delete-55716\";i:54958;s:12:\"delete-55718\";i:54959;s:12:\"delete-55719\";i:54960;s:12:\"delete-55722\";i:54961;s:12:\"delete-55723\";i:54962;s:12:\"delete-55720\";i:54963;s:12:\"delete-55721\";i:54964;s:12:\"delete-55724\";i:54965;s:12:\"delete-55727\";i:54966;s:12:\"delete-55728\";i:54967;s:12:\"delete-55725\";i:54968;s:12:\"delete-55726\";i:54969;s:12:\"delete-55729\";i:54970;s:12:\"delete-55732\";i:54971;s:12:\"delete-55733\";i:54972;s:12:\"delete-55730\";i:54973;s:12:\"delete-55731\";i:54974;s:12:\"delete-55734\";i:54975;s:12:\"delete-55737\";i:54976;s:12:\"delete-55738\";i:54977;s:12:\"delete-55735\";i:54978;s:12:\"delete-55736\";i:54979;s:12:\"delete-55739\";i:54980;s:12:\"delete-55742\";i:54981;s:12:\"delete-55740\";i:54982;s:12:\"delete-55741\";i:54983;s:12:\"delete-55743\";i:54984;s:12:\"delete-55744\";i:54985;s:12:\"delete-55747\";i:54986;s:12:\"delete-55748\";i:54987;s:12:\"delete-55745\";i:54988;s:12:\"delete-55746\";i:54989;s:12:\"delete-55749\";i:54990;s:12:\"delete-55752\";i:54991;s:12:\"delete-55753\";i:54992;s:12:\"delete-55750\";i:54993;s:12:\"delete-55751\";i:54994;s:12:\"delete-55754\";i:54995;s:12:\"delete-55757\";i:54996;s:12:\"delete-55758\";i:54997;s:12:\"delete-55755\";i:54998;s:12:\"delete-55756\";i:54999;s:12:\"delete-55759\";i:55000;s:12:\"delete-55762\";i:55001;s:12:\"delete-55763\";i:55002;s:12:\"delete-55760\";i:55003;s:12:\"delete-55761\";i:55004;s:12:\"delete-55764\";i:55005;s:12:\"delete-55767\";i:55006;s:12:\"delete-55768\";i:55007;s:12:\"delete-55765\";i:55008;s:12:\"delete-55766\";i:55009;s:12:\"delete-55769\";i:55010;s:12:\"delete-55772\";i:55011;s:12:\"delete-55773\";i:55012;s:12:\"delete-55770\";i:55013;s:12:\"delete-55771\";i:55014;s:12:\"delete-55774\";i:55015;s:12:\"delete-55777\";i:55016;s:12:\"delete-55775\";i:55017;s:12:\"delete-55776\";i:55018;s:12:\"delete-55778\";i:55019;s:12:\"delete-55779\";i:55020;s:12:\"delete-55782\";i:55021;s:12:\"delete-55783\";i:55022;s:12:\"delete-55780\";i:55023;s:12:\"delete-55781\";i:55024;s:12:\"delete-55784\";i:55025;s:12:\"delete-55787\";i:55026;s:12:\"delete-55788\";i:55027;s:12:\"delete-55785\";i:55028;s:12:\"delete-55786\";i:55029;s:12:\"delete-55789\";i:55030;s:12:\"delete-55792\";i:55031;s:12:\"delete-55790\";i:55032;s:12:\"delete-55791\";i:55033;s:12:\"delete-55793\";i:55034;s:12:\"delete-55794\";i:55035;s:12:\"delete-55797\";i:55036;s:12:\"delete-55798\";i:55037;s:12:\"delete-55795\";i:55038;s:12:\"delete-55796\";i:55039;s:12:\"delete-55799\";i:55040;s:12:\"delete-55802\";i:55041;s:12:\"delete-55800\";i:55042;s:12:\"delete-55801\";i:55043;s:12:\"delete-55803\";i:55044;s:12:\"delete-55804\";i:55045;s:12:\"delete-55807\";i:55046;s:12:\"delete-55808\";i:55047;s:12:\"delete-55805\";i:55048;s:12:\"delete-55806\";i:55049;s:12:\"delete-55809\";i:55050;s:12:\"delete-55812\";i:55051;s:12:\"delete-55813\";i:55052;s:12:\"delete-55810\";i:55053;s:12:\"delete-55811\";i:55054;s:12:\"delete-55814\";i:55055;s:12:\"delete-55815\";i:55056;s:12:\"delete-55816\";i:55057;s:12:\"delete-55817\";i:55058;s:12:\"delete-55818\";i:55059;s:12:\"delete-55819\";i:55060;s:12:\"delete-55822\";i:55061;s:12:\"delete-55820\";i:55062;s:12:\"delete-55821\";i:55063;s:12:\"delete-55823\";i:55064;s:12:\"delete-55824\";i:55065;s:12:\"delete-55827\";i:55066;s:12:\"delete-55825\";i:55067;s:12:\"delete-55826\";i:55068;s:12:\"delete-55828\";i:55069;s:12:\"delete-55829\";i:55070;s:12:\"delete-55832\";i:55071;s:12:\"delete-55833\";i:55072;s:12:\"delete-55830\";i:55073;s:12:\"delete-55831\";i:55074;s:12:\"delete-55834\";i:55075;s:12:\"delete-55837\";i:55076;s:12:\"delete-55835\";i:55077;s:12:\"delete-55836\";i:55078;s:12:\"delete-55838\";i:55079;s:12:\"delete-55839\";i:55080;s:12:\"delete-55842\";i:55081;s:12:\"delete-55843\";i:55082;s:12:\"delete-55840\";i:55083;s:12:\"delete-55841\";i:55084;s:12:\"delete-55844\";i:55085;s:12:\"delete-55847\";i:55086;s:12:\"delete-55848\";i:55087;s:12:\"delete-55845\";i:55088;s:12:\"delete-55846\";i:55089;s:12:\"delete-55849\";i:55090;s:12:\"delete-55852\";i:55091;s:12:\"delete-55853\";i:55092;s:12:\"delete-55850\";i:55093;s:12:\"delete-55851\";i:55094;s:12:\"delete-55854\";i:55095;s:12:\"delete-55857\";i:55096;s:12:\"delete-55858\";i:55097;s:12:\"delete-55855\";i:55098;s:12:\"delete-55856\";i:55099;s:12:\"delete-55859\";i:55100;s:12:\"delete-55862\";i:55101;s:12:\"delete-55860\";i:55102;s:12:\"delete-55861\";i:55103;s:12:\"delete-55863\";i:55104;s:12:\"delete-55864\";i:55105;s:12:\"delete-55867\";i:55106;s:12:\"delete-55868\";i:55107;s:12:\"delete-55865\";i:55108;s:12:\"delete-55866\";i:55109;s:12:\"delete-55869\";i:55110;s:12:\"delete-55872\";i:55111;s:12:\"delete-55873\";i:55112;s:12:\"delete-55870\";i:55113;s:12:\"delete-55871\";i:55114;s:12:\"delete-55874\";i:55115;s:12:\"delete-55877\";i:55116;s:12:\"delete-55878\";i:55117;s:12:\"delete-55875\";i:55118;s:12:\"delete-55876\";i:55119;s:12:\"delete-55879\";i:55120;s:12:\"delete-55882\";i:55121;s:12:\"delete-55883\";i:55122;s:12:\"delete-55880\";i:55123;s:12:\"delete-55881\";i:55124;s:12:\"delete-55884\";i:55125;s:12:\"delete-55887\";i:55126;s:12:\"delete-55885\";i:55127;s:12:\"delete-55886\";i:55128;s:12:\"delete-55888\";i:55129;s:12:\"delete-55889\";i:55130;s:12:\"delete-55892\";i:55131;s:12:\"delete-55893\";i:55132;s:12:\"delete-55890\";i:55133;s:12:\"delete-55891\";i:55134;s:12:\"delete-55894\";i:55135;s:12:\"delete-55897\";i:55136;s:12:\"delete-55898\";i:55137;s:12:\"delete-55895\";i:55138;s:12:\"delete-55896\";i:55139;s:12:\"delete-55899\";i:55140;s:12:\"delete-55902\";i:55141;s:12:\"delete-55900\";i:55142;s:12:\"delete-55901\";i:55143;s:12:\"delete-55903\";i:55144;s:12:\"delete-55904\";i:55145;s:12:\"delete-55907\";i:55146;s:12:\"delete-55908\";i:55147;s:12:\"delete-55905\";i:55148;s:12:\"delete-55906\";i:55149;s:12:\"delete-55909\";i:55150;s:12:\"delete-55912\";i:55151;s:12:\"delete-55913\";i:55152;s:12:\"delete-55910\";i:55153;s:12:\"delete-55911\";i:55154;s:12:\"delete-55914\";i:55155;s:12:\"delete-55917\";i:55156;s:12:\"delete-55918\";i:55157;s:12:\"delete-55915\";i:55158;s:12:\"delete-55916\";i:55159;s:12:\"delete-55919\";i:55160;s:12:\"delete-55922\";i:55161;s:12:\"delete-55923\";i:55162;s:12:\"delete-55920\";i:55163;s:12:\"delete-55921\";i:55164;s:12:\"delete-55924\";i:55165;s:12:\"delete-55927\";i:55166;s:12:\"delete-55928\";i:55167;s:12:\"delete-55925\";i:55168;s:12:\"delete-55926\";i:55169;s:12:\"delete-55929\";i:55170;s:12:\"delete-55932\";i:55171;s:12:\"delete-55933\";i:55172;s:12:\"delete-55930\";i:55173;s:12:\"delete-55931\";i:55174;s:12:\"delete-55934\";i:55175;s:12:\"delete-55937\";i:55176;s:12:\"delete-55938\";i:55177;s:12:\"delete-55935\";i:55178;s:12:\"delete-55936\";i:55179;s:12:\"delete-55939\";i:55180;s:12:\"delete-55942\";i:55181;s:12:\"delete-55943\";i:55182;s:12:\"delete-55940\";i:55183;s:12:\"delete-55941\";i:55184;s:12:\"delete-55944\";i:55185;s:12:\"delete-55947\";i:55186;s:12:\"delete-55948\";i:55187;s:12:\"delete-55945\";i:55188;s:12:\"delete-55946\";i:55189;s:12:\"delete-55949\";i:55190;s:12:\"delete-55952\";i:55191;s:12:\"delete-55950\";i:55192;s:12:\"delete-55951\";i:55193;s:12:\"delete-55953\";i:55194;s:12:\"delete-55954\";i:55195;s:12:\"delete-55957\";i:55196;s:12:\"delete-55958\";i:55197;s:12:\"delete-55955\";i:55198;s:12:\"delete-55956\";i:55199;s:12:\"delete-55959\";i:55200;s:12:\"delete-55962\";i:55201;s:12:\"delete-55963\";i:55202;s:12:\"delete-55960\";i:55203;s:12:\"delete-55961\";i:55204;s:12:\"delete-55964\";i:55205;s:12:\"delete-55967\";i:55206;s:12:\"delete-55968\";i:55207;s:12:\"delete-55965\";i:55208;s:12:\"delete-55966\";i:55209;s:12:\"delete-55969\";i:55210;s:12:\"delete-55972\";i:55211;s:12:\"delete-55973\";i:55212;s:12:\"delete-55970\";i:55213;s:12:\"delete-55971\";i:55214;s:12:\"delete-55974\";i:55215;s:12:\"delete-55977\";i:55216;s:12:\"delete-55978\";i:55217;s:12:\"delete-55975\";i:55218;s:12:\"delete-55976\";i:55219;s:12:\"delete-55979\";i:55220;s:12:\"delete-55982\";i:55221;s:12:\"delete-55983\";i:55222;s:12:\"delete-55980\";i:55223;s:12:\"delete-55981\";i:55224;s:12:\"delete-55984\";i:55225;s:12:\"delete-55987\";i:55226;s:12:\"delete-55988\";i:55227;s:12:\"delete-55985\";i:55228;s:12:\"delete-55986\";i:55229;s:12:\"delete-55989\";i:55230;s:12:\"delete-55992\";i:55231;s:12:\"delete-55993\";i:55232;s:12:\"delete-55990\";i:55233;s:12:\"delete-55991\";i:55234;s:12:\"delete-55994\";i:55235;s:12:\"delete-55997\";i:55236;s:12:\"delete-55995\";i:55237;s:12:\"delete-55996\";i:55238;s:12:\"delete-55998\";i:55239;s:12:\"delete-56001\";i:55240;s:12:\"delete-56002\";i:55241;s:12:\"delete-55999\";i:55242;s:12:\"delete-56000\";i:55243;s:12:\"delete-56003\";i:55244;s:12:\"delete-56004\";i:55245;s:12:\"delete-56005\";i:55246;s:12:\"delete-56006\";i:55247;s:12:\"delete-56007\";i:55248;s:12:\"delete-56008\";i:55249;s:12:\"delete-56011\";i:55250;s:12:\"delete-56012\";i:55251;s:12:\"delete-56009\";i:55252;s:12:\"delete-56010\";i:55253;s:12:\"delete-56013\";i:55254;s:12:\"delete-56016\";i:55255;s:12:\"delete-56017\";i:55256;s:12:\"delete-56014\";i:55257;s:12:\"delete-56015\";i:55258;s:12:\"delete-56018\";i:55259;s:12:\"delete-56021\";i:55260;s:12:\"delete-56019\";i:55261;s:12:\"delete-56020\";i:55262;s:12:\"delete-56022\";i:55263;s:12:\"delete-56023\";i:55264;s:12:\"delete-56026\";i:55265;s:12:\"delete-56027\";i:55266;s:12:\"delete-56024\";i:55267;s:12:\"delete-56025\";i:55268;s:12:\"delete-56028\";i:55269;s:12:\"delete-56031\";i:55270;s:12:\"delete-56032\";i:55271;s:12:\"delete-56029\";i:55272;s:12:\"delete-56030\";i:55273;s:12:\"delete-56033\";i:55274;s:12:\"delete-56036\";i:55275;s:12:\"delete-56037\";i:55276;s:12:\"delete-56034\";i:55277;s:12:\"delete-56035\";i:55278;s:12:\"delete-56038\";i:55279;s:12:\"delete-56041\";i:55280;s:12:\"delete-56042\";i:55281;s:12:\"delete-56039\";i:55282;s:12:\"delete-56040\";i:55283;s:12:\"delete-56043\";i:55284;s:12:\"delete-56046\";i:55285;s:12:\"delete-56047\";i:55286;s:12:\"delete-56044\";i:55287;s:12:\"delete-56045\";i:55288;s:12:\"delete-56048\";i:55289;s:12:\"delete-56051\";i:55290;s:12:\"delete-56052\";i:55291;s:12:\"delete-56049\";i:55292;s:12:\"delete-56050\";i:55293;s:12:\"delete-56053\";i:55294;s:12:\"delete-56056\";i:55295;s:12:\"delete-56054\";i:55296;s:12:\"delete-56055\";i:55297;s:12:\"delete-56057\";i:55298;s:12:\"delete-56058\";i:55299;s:12:\"delete-56061\";i:55300;s:12:\"delete-56062\";i:55301;s:12:\"delete-56059\";i:55302;s:12:\"delete-56060\";i:55303;s:12:\"delete-56063\";i:55304;s:12:\"delete-56066\";i:55305;s:12:\"delete-56067\";i:55306;s:12:\"delete-56064\";i:55307;s:12:\"delete-56065\";i:55308;s:12:\"delete-56068\";i:55309;s:12:\"delete-56071\";i:55310;s:12:\"delete-56069\";i:55311;s:12:\"delete-56070\";i:55312;s:12:\"delete-56072\";i:55313;s:12:\"delete-56073\";i:55314;s:12:\"delete-56076\";i:55315;s:12:\"delete-56077\";i:55316;s:12:\"delete-56074\";i:55317;s:12:\"delete-56075\";i:55318;s:12:\"delete-56078\";i:55319;s:12:\"delete-56081\";i:55320;s:12:\"delete-56082\";i:55321;s:12:\"delete-56079\";i:55322;s:12:\"delete-56080\";i:55323;s:12:\"delete-56083\";i:55324;s:12:\"delete-56086\";i:55325;s:12:\"delete-56084\";i:55326;s:12:\"delete-56085\";i:55327;s:12:\"delete-56087\";i:55328;s:12:\"delete-56088\";i:55329;s:12:\"delete-56091\";i:55330;s:12:\"delete-56092\";i:55331;s:12:\"delete-56089\";i:55332;s:12:\"delete-56090\";i:55333;s:12:\"delete-56093\";i:55334;s:12:\"delete-56096\";i:55335;s:12:\"delete-56097\";i:55336;s:12:\"delete-56094\";i:55337;s:12:\"delete-56095\";i:55338;s:12:\"delete-56098\";i:55339;s:12:\"delete-56099\";i:55340;s:12:\"delete-56100\";i:55341;s:12:\"delete-56101\";i:55342;s:12:\"delete-56102\";i:55343;s:12:\"delete-56103\";i:55344;s:12:\"delete-56106\";i:55345;s:12:\"delete-56104\";i:55346;s:12:\"delete-56105\";i:55347;s:12:\"delete-56107\";i:55348;s:12:\"delete-56108\";i:55349;s:12:\"delete-56109\";i:55350;s:12:\"delete-56110\";i:55351;s:12:\"delete-56111\";i:55352;s:12:\"delete-56112\";i:55353;s:12:\"delete-56113\";i:55354;s:12:\"delete-56116\";i:55355;s:12:\"delete-56117\";i:55356;s:12:\"delete-56114\";i:55357;s:12:\"delete-56115\";i:55358;s:12:\"delete-56118\";i:55359;s:12:\"delete-56121\";i:55360;s:12:\"delete-56122\";i:55361;s:12:\"delete-56119\";i:55362;s:12:\"delete-56120\";i:55363;s:12:\"delete-56123\";i:55364;s:12:\"delete-56126\";i:55365;s:12:\"delete-56124\";i:55366;s:12:\"delete-56125\";i:55367;s:12:\"delete-56127\";i:55368;s:12:\"delete-56128\";i:55369;s:12:\"delete-56131\";i:55370;s:12:\"delete-56132\";i:55371;s:12:\"delete-56129\";i:55372;s:12:\"delete-56130\";i:55373;s:12:\"delete-56133\";i:55374;s:12:\"delete-56136\";i:55375;s:12:\"delete-56137\";i:55376;s:12:\"delete-56134\";i:55377;s:12:\"delete-56135\";i:55378;s:12:\"delete-56138\";i:55379;s:12:\"delete-56141\";i:55380;s:12:\"delete-56142\";i:55381;s:12:\"delete-56139\";i:55382;s:12:\"delete-56140\";i:55383;s:12:\"delete-56143\";i:55384;s:12:\"delete-56146\";i:55385;s:12:\"delete-56144\";i:55386;s:12:\"delete-56145\";i:55387;s:12:\"delete-56147\";i:55388;s:12:\"delete-56148\";i:55389;s:12:\"delete-56151\";i:55390;s:12:\"delete-56152\";i:55391;s:12:\"delete-56149\";i:55392;s:12:\"delete-56150\";i:55393;s:12:\"delete-56153\";i:55394;s:12:\"delete-56156\";i:55395;s:12:\"delete-56157\";i:55396;s:12:\"delete-56154\";i:55397;s:12:\"delete-56155\";i:55398;s:12:\"delete-56158\";i:55399;s:12:\"delete-56161\";i:55400;s:12:\"delete-56162\";i:55401;s:12:\"delete-56159\";i:55402;s:12:\"delete-56160\";i:55403;s:12:\"delete-56163\";i:55404;s:12:\"delete-56166\";i:55405;s:12:\"delete-56167\";i:55406;s:12:\"delete-56164\";i:55407;s:12:\"delete-56165\";i:55408;s:12:\"delete-56168\";i:55409;s:12:\"delete-56171\";i:55410;s:12:\"delete-56172\";i:55411;s:12:\"delete-56169\";i:55412;s:12:\"delete-56170\";i:55413;s:12:\"delete-56173\";i:55414;s:12:\"delete-56176\";i:55415;s:12:\"delete-56177\";i:55416;s:12:\"delete-56178\";i:55417;s:12:\"delete-56181\";i:55418;s:12:\"delete-56182\";i:55419;s:12:\"delete-56174\";i:55420;s:12:\"delete-56175\";i:55421;s:12:\"delete-56179\";i:55422;s:12:\"delete-56180\";i:55423;s:12:\"delete-56183\";i:55424;s:12:\"delete-56186\";i:55425;s:12:\"delete-56187\";i:55426;s:12:\"delete-56184\";i:55427;s:12:\"delete-56185\";i:55428;s:12:\"delete-56188\";i:55429;s:12:\"delete-56191\";i:55430;s:12:\"delete-56192\";i:55431;s:12:\"delete-56189\";i:55432;s:12:\"delete-56190\";i:55433;s:12:\"delete-56193\";i:55434;s:12:\"delete-56196\";i:55435;s:12:\"delete-56197\";i:55436;s:12:\"delete-56194\";i:55437;s:12:\"delete-56195\";i:55438;s:12:\"delete-56198\";i:55439;s:12:\"delete-56201\";i:55440;s:12:\"delete-56202\";i:55441;s:12:\"delete-56199\";i:55442;s:12:\"delete-56200\";i:55443;s:12:\"delete-56203\";i:55444;s:12:\"delete-56206\";i:55445;s:12:\"delete-56207\";i:55446;s:12:\"delete-56204\";i:55447;s:12:\"delete-56205\";i:55448;s:12:\"delete-56208\";i:55449;s:12:\"delete-56211\";i:55450;s:12:\"delete-56212\";i:55451;s:12:\"delete-56209\";i:55452;s:12:\"delete-56210\";i:55453;s:12:\"delete-56213\";i:55454;s:12:\"delete-56216\";i:55455;s:12:\"delete-56217\";i:55456;s:12:\"delete-56214\";i:55457;s:12:\"delete-56215\";i:55458;s:12:\"delete-56218\";i:55459;s:12:\"delete-56221\";i:55460;s:12:\"delete-56222\";i:55461;s:12:\"delete-56219\";i:55462;s:12:\"delete-56220\";i:55463;s:12:\"delete-56223\";i:55464;s:12:\"delete-56226\";i:55465;s:12:\"delete-56224\";i:55466;s:12:\"delete-56225\";i:55467;s:12:\"delete-56227\";i:55468;s:12:\"delete-56228\";i:55469;s:12:\"delete-56231\";i:55470;s:12:\"delete-56232\";i:55471;s:12:\"delete-56229\";i:55472;s:12:\"delete-56230\";i:55473;s:12:\"delete-56233\";i:55474;s:12:\"delete-56236\";i:55475;s:12:\"delete-56237\";i:55476;s:12:\"delete-56234\";i:55477;s:12:\"delete-56235\";i:55478;s:12:\"delete-56238\";i:55479;s:12:\"delete-56241\";i:55480;s:12:\"delete-56242\";i:55481;s:12:\"delete-56239\";i:55482;s:12:\"delete-56240\";i:55483;s:12:\"delete-56243\";i:55484;s:12:\"delete-56246\";i:55485;s:12:\"delete-56247\";i:55486;s:12:\"delete-56244\";i:55487;s:12:\"delete-56245\";i:55488;s:12:\"delete-56248\";i:55489;s:12:\"delete-56251\";i:55490;s:12:\"delete-56249\";i:55491;s:12:\"delete-56250\";i:55492;s:12:\"delete-56252\";i:55493;s:12:\"delete-56253\";i:55494;s:12:\"delete-56256\";i:55495;s:12:\"delete-56257\";i:55496;s:12:\"delete-56254\";i:55497;s:12:\"delete-56255\";i:55498;s:12:\"delete-56258\";i:55499;s:12:\"delete-56261\";i:55500;s:12:\"delete-56259\";i:55501;s:12:\"delete-56260\";i:55502;s:12:\"delete-56262\";i:55503;s:12:\"delete-56263\";i:55504;s:12:\"delete-56266\";i:55505;s:12:\"delete-56267\";i:55506;s:12:\"delete-56264\";i:55507;s:12:\"delete-56265\";i:55508;s:12:\"delete-56268\";i:55509;s:12:\"delete-56271\";i:55510;s:12:\"delete-56272\";i:55511;s:12:\"delete-56269\";i:55512;s:12:\"delete-56270\";i:55513;s:12:\"delete-56273\";i:55514;s:12:\"delete-56276\";i:55515;s:12:\"delete-56277\";i:55516;s:12:\"delete-56274\";i:55517;s:12:\"delete-56275\";i:55518;s:12:\"delete-56278\";i:55519;s:12:\"delete-56281\";i:55520;s:12:\"delete-56282\";i:55521;s:12:\"delete-56279\";i:55522;s:12:\"delete-56280\";i:55523;s:12:\"delete-56283\";i:55524;s:12:\"delete-56286\";i:55525;s:12:\"delete-56287\";i:55526;s:12:\"delete-56284\";i:55527;s:12:\"delete-56285\";i:55528;s:12:\"delete-56288\";i:55529;s:12:\"delete-56291\";i:55530;s:12:\"delete-56289\";i:55531;s:12:\"delete-56290\";i:55532;s:12:\"delete-56292\";i:55533;s:12:\"delete-56293\";i:55534;s:12:\"delete-56296\";i:55535;s:12:\"delete-56297\";i:55536;s:12:\"delete-56294\";i:55537;s:12:\"delete-56295\";i:55538;s:12:\"delete-56298\";i:55539;s:12:\"delete-56301\";i:55540;s:12:\"delete-56302\";i:55541;s:12:\"delete-56299\";i:55542;s:12:\"delete-56300\";i:55543;s:12:\"delete-56303\";i:55544;s:12:\"delete-56304\";i:55545;s:12:\"delete-56305\";i:55546;s:12:\"delete-56306\";i:55547;s:12:\"delete-56307\";i:55548;s:12:\"delete-56308\";i:55549;s:12:\"delete-56311\";i:55550;s:12:\"delete-56312\";i:55551;s:12:\"delete-56309\";i:55552;s:12:\"delete-56310\";i:55553;s:12:\"delete-56313\";i:55554;s:12:\"delete-56316\";i:55555;s:12:\"delete-56317\";i:55556;s:12:\"delete-56314\";i:55557;s:12:\"delete-56315\";i:55558;s:12:\"delete-56318\";i:55559;s:12:\"delete-56321\";i:55560;s:12:\"delete-56322\";i:55561;s:12:\"delete-56319\";i:55562;s:12:\"delete-56320\";i:55563;s:12:\"delete-56323\";i:55564;s:12:\"delete-56326\";i:55565;s:12:\"delete-56327\";i:55566;s:12:\"delete-56324\";i:55567;s:12:\"delete-56325\";i:55568;s:12:\"delete-56328\";i:55569;s:12:\"delete-56331\";i:55570;s:12:\"delete-56332\";i:55571;s:12:\"delete-56329\";i:55572;s:12:\"delete-56330\";i:55573;s:12:\"delete-56333\";i:55574;s:12:\"delete-56336\";i:55575;s:12:\"delete-56337\";i:55576;s:12:\"delete-56334\";i:55577;s:12:\"delete-56335\";i:55578;s:12:\"delete-56338\";i:55579;s:12:\"delete-56341\";i:55580;s:12:\"delete-56342\";i:55581;s:12:\"delete-56339\";i:55582;s:12:\"delete-56340\";i:55583;s:12:\"delete-56343\";i:55584;s:12:\"delete-56346\";i:55585;s:12:\"delete-56347\";i:55586;s:12:\"delete-56344\";i:55587;s:12:\"delete-56345\";i:55588;s:12:\"delete-56348\";i:55589;s:12:\"delete-56351\";i:55590;s:12:\"delete-56349\";i:55591;s:12:\"delete-56350\";i:55592;s:12:\"delete-56352\";i:55593;s:12:\"delete-56353\";i:55594;s:12:\"delete-56356\";i:55595;s:12:\"delete-56357\";i:55596;s:12:\"delete-56354\";i:55597;s:12:\"delete-56355\";i:55598;s:12:\"delete-56358\";i:55599;s:12:\"delete-56361\";i:55600;s:12:\"delete-56362\";i:55601;s:12:\"delete-56359\";i:55602;s:12:\"delete-56360\";i:55603;s:12:\"delete-56363\";i:55604;s:12:\"delete-56366\";i:55605;s:12:\"delete-56367\";i:55606;s:12:\"delete-56364\";i:55607;s:12:\"delete-56365\";i:55608;s:12:\"delete-56368\";i:55609;s:12:\"delete-56371\";i:55610;s:12:\"delete-56372\";i:55611;s:12:\"delete-56369\";i:55612;s:12:\"delete-56370\";i:55613;s:12:\"delete-56373\";i:55614;s:12:\"delete-56376\";i:55615;s:12:\"delete-56377\";i:55616;s:12:\"delete-56374\";i:55617;s:12:\"delete-56375\";i:55618;s:12:\"delete-56378\";i:55619;s:12:\"delete-56381\";i:55620;s:12:\"delete-56382\";i:55621;s:12:\"delete-56379\";i:55622;s:12:\"delete-56380\";i:55623;s:12:\"delete-56383\";i:55624;s:12:\"delete-56384\";i:55625;s:12:\"delete-56385\";i:55626;s:12:\"delete-56386\";i:55627;s:12:\"delete-56387\";i:55628;s:12:\"delete-56388\";i:55629;s:12:\"delete-56391\";i:55630;s:12:\"delete-56392\";i:55631;s:12:\"delete-56389\";i:55632;s:12:\"delete-56390\";i:55633;s:12:\"delete-56393\";i:55634;s:12:\"delete-56396\";i:55635;s:12:\"delete-56397\";i:55636;s:12:\"delete-56394\";i:55637;s:12:\"delete-56395\";i:55638;s:12:\"delete-56398\";i:55639;s:12:\"delete-56401\";i:55640;s:12:\"delete-56402\";i:55641;s:12:\"delete-56399\";i:55642;s:12:\"delete-56400\";i:55643;s:12:\"delete-56403\";i:55644;s:12:\"delete-56406\";i:55645;s:12:\"delete-56407\";i:55646;s:12:\"delete-56404\";i:55647;s:12:\"delete-56405\";i:55648;s:12:\"delete-56408\";i:55649;s:12:\"delete-56411\";i:55650;s:12:\"delete-56412\";i:55651;s:12:\"delete-56409\";i:55652;s:12:\"delete-56410\";i:55653;s:12:\"delete-56413\";i:55654;s:12:\"delete-56416\";i:55655;s:12:\"delete-56417\";i:55656;s:12:\"delete-56414\";i:55657;s:12:\"delete-56415\";i:55658;s:12:\"delete-56418\";i:55659;s:12:\"delete-56421\";i:55660;s:12:\"delete-56422\";i:55661;s:12:\"delete-56419\";i:55662;s:12:\"delete-56420\";i:55663;s:12:\"delete-56423\";i:55664;s:12:\"delete-56426\";i:55665;s:12:\"delete-56427\";i:55666;s:12:\"delete-56424\";i:55667;s:12:\"delete-56425\";i:55668;s:12:\"delete-56428\";i:55669;s:12:\"delete-56431\";i:55670;s:12:\"delete-56432\";i:55671;s:12:\"delete-56429\";i:55672;s:12:\"delete-56430\";i:55673;s:12:\"delete-56433\";i:55674;s:12:\"delete-56436\";i:55675;s:12:\"delete-56437\";i:55676;s:12:\"delete-56434\";i:55677;s:12:\"delete-56435\";i:55678;s:12:\"delete-56438\";i:55679;s:12:\"delete-56441\";i:55680;s:12:\"delete-56442\";i:55681;s:12:\"delete-56439\";i:55682;s:12:\"delete-56440\";i:55683;s:12:\"delete-56443\";i:55684;s:12:\"delete-56446\";i:55685;s:12:\"delete-56447\";i:55686;s:12:\"delete-56444\";i:55687;s:12:\"delete-56445\";i:55688;s:12:\"delete-56448\";i:55689;s:12:\"delete-56451\";i:55690;s:12:\"delete-56449\";i:55691;s:12:\"delete-56450\";i:55692;s:12:\"delete-56452\";i:55693;s:12:\"delete-56453\";i:55694;s:12:\"delete-56456\";i:55695;s:12:\"delete-56457\";i:55696;s:12:\"delete-56454\";i:55697;s:12:\"delete-56455\";i:55698;s:12:\"delete-56458\";i:55699;s:12:\"delete-56461\";i:55700;s:12:\"delete-56462\";i:55701;s:12:\"delete-56459\";i:55702;s:12:\"delete-56460\";i:55703;s:12:\"delete-56463\";i:55704;s:12:\"delete-56466\";i:55705;s:12:\"delete-56464\";i:55706;s:12:\"delete-56465\";i:55707;s:12:\"delete-56467\";i:55708;s:12:\"delete-56468\";i:55709;s:12:\"delete-56471\";i:55710;s:12:\"delete-56472\";i:55711;s:12:\"delete-56469\";i:55712;s:12:\"delete-56470\";i:55713;s:12:\"delete-56473\";i:55714;s:12:\"delete-56476\";i:55715;s:12:\"delete-56477\";i:55716;s:12:\"delete-56474\";i:55717;s:12:\"delete-56475\";i:55718;s:12:\"delete-56478\";i:55719;s:12:\"delete-56481\";i:55720;s:12:\"delete-56482\";i:55721;s:12:\"delete-56479\";i:55722;s:12:\"delete-56480\";i:55723;s:12:\"delete-56483\";i:55724;s:12:\"delete-56486\";i:55725;s:12:\"delete-56487\";i:55726;s:12:\"delete-56484\";i:55727;s:12:\"delete-56485\";i:55728;s:12:\"delete-56488\";i:55729;s:12:\"delete-56491\";i:55730;s:12:\"delete-56492\";i:55731;s:12:\"delete-56489\";i:55732;s:12:\"delete-56490\";i:55733;s:12:\"delete-56493\";i:55734;s:12:\"delete-56496\";i:55735;s:12:\"delete-56497\";i:55736;s:12:\"delete-56494\";i:55737;s:12:\"delete-56495\";i:55738;s:12:\"delete-56498\";i:55739;s:12:\"delete-56501\";i:55740;s:12:\"delete-56502\";i:55741;s:12:\"delete-56499\";i:55742;s:12:\"delete-56500\";i:55743;s:12:\"delete-56503\";i:55744;s:12:\"delete-56506\";i:55745;s:12:\"delete-56507\";i:55746;s:12:\"delete-56504\";i:55747;s:12:\"delete-56505\";i:55748;s:12:\"delete-56508\";i:55749;s:12:\"delete-56511\";i:55750;s:12:\"delete-56512\";i:55751;s:12:\"delete-56509\";i:55752;s:12:\"delete-56510\";i:55753;s:12:\"delete-56513\";i:55754;s:12:\"delete-56516\";i:55755;s:12:\"delete-56517\";i:55756;s:12:\"delete-56514\";i:55757;s:12:\"delete-56515\";i:55758;s:12:\"delete-56518\";i:55759;s:12:\"delete-56521\";i:55760;s:12:\"delete-56522\";i:55761;s:12:\"delete-56519\";i:55762;s:12:\"delete-56520\";i:55763;s:12:\"delete-56523\";i:55764;s:12:\"delete-56526\";i:55765;s:12:\"delete-56527\";i:55766;s:12:\"delete-56524\";i:55767;s:12:\"delete-56525\";i:55768;s:12:\"delete-56528\";i:55769;s:12:\"delete-56531\";i:55770;s:12:\"delete-56529\";i:55771;s:12:\"delete-56530\";i:55772;s:12:\"delete-56532\";i:55773;s:12:\"delete-56533\";i:55774;s:12:\"delete-56536\";i:55775;s:12:\"delete-56537\";i:55776;s:12:\"delete-56534\";i:55777;s:12:\"delete-56535\";i:55778;s:12:\"delete-56538\";i:55779;s:12:\"delete-56541\";i:55780;s:12:\"delete-56542\";i:55781;s:12:\"delete-56539\";i:55782;s:12:\"delete-56540\";i:55783;s:12:\"delete-56543\";i:55784;s:12:\"delete-56546\";i:55785;s:12:\"delete-56547\";i:55786;s:12:\"delete-56544\";i:55787;s:12:\"delete-56545\";i:55788;s:12:\"delete-56548\";i:55789;s:12:\"delete-56551\";i:55790;s:12:\"delete-56552\";i:55791;s:12:\"delete-56549\";i:55792;s:12:\"delete-56550\";i:55793;s:12:\"delete-56553\";i:55794;s:12:\"delete-56556\";i:55795;s:12:\"delete-56557\";i:55796;s:12:\"delete-56554\";i:55797;s:12:\"delete-56555\";i:55798;s:12:\"delete-56558\";i:55799;s:12:\"delete-56561\";i:55800;s:12:\"delete-56559\";i:55801;s:12:\"delete-56560\";i:55802;s:12:\"delete-56562\";i:55803;s:12:\"delete-56563\";i:55804;s:12:\"delete-56566\";i:55805;s:12:\"delete-56567\";i:55806;s:12:\"delete-56564\";i:55807;s:12:\"delete-56565\";i:55808;s:12:\"delete-56568\";i:55809;s:12:\"delete-56571\";i:55810;s:12:\"delete-56572\";i:55811;s:12:\"delete-56569\";i:55812;s:12:\"delete-56570\";i:55813;s:12:\"delete-56573\";i:55814;s:12:\"delete-56576\";i:55815;s:12:\"delete-56577\";i:55816;s:12:\"delete-56574\";i:55817;s:12:\"delete-56575\";i:55818;s:12:\"delete-56578\";i:55819;s:12:\"delete-56581\";i:55820;s:12:\"delete-56582\";i:55821;s:12:\"delete-56579\";i:55822;s:12:\"delete-56580\";i:55823;s:12:\"delete-56583\";i:55824;s:12:\"delete-56586\";i:55825;s:12:\"delete-56587\";i:55826;s:12:\"delete-56584\";i:55827;s:12:\"delete-56585\";i:55828;s:12:\"delete-56588\";i:55829;s:12:\"delete-56591\";i:55830;s:12:\"delete-56589\";i:55831;s:12:\"delete-56590\";i:55832;s:12:\"delete-56592\";i:55833;s:12:\"delete-56593\";i:55834;s:12:\"delete-56596\";i:55835;s:12:\"delete-56597\";i:55836;s:12:\"delete-56594\";i:55837;s:12:\"delete-56595\";i:55838;s:12:\"delete-56598\";i:55839;s:12:\"delete-56601\";i:55840;s:12:\"delete-56602\";i:55841;s:12:\"delete-56599\";i:55842;s:12:\"delete-56600\";i:55843;s:12:\"delete-56603\";i:55844;s:12:\"delete-56606\";i:55845;s:12:\"delete-56607\";i:55846;s:12:\"delete-56604\";i:55847;s:12:\"delete-56605\";i:55848;s:12:\"delete-56608\";i:55849;s:12:\"delete-56611\";i:55850;s:12:\"delete-56612\";i:55851;s:12:\"delete-56609\";i:55852;s:12:\"delete-56610\";i:55853;s:12:\"delete-56613\";i:55854;s:12:\"delete-56616\";i:55855;s:12:\"delete-56617\";i:55856;s:12:\"delete-56614\";i:55857;s:12:\"delete-56615\";i:55858;s:12:\"delete-56618\";i:55859;s:12:\"delete-56621\";i:55860;s:12:\"delete-56622\";i:55861;s:12:\"delete-56619\";i:55862;s:12:\"delete-56620\";i:55863;s:12:\"delete-56623\";i:55864;s:12:\"delete-56626\";i:55865;s:12:\"delete-56627\";i:55866;s:12:\"delete-56624\";i:55867;s:12:\"delete-56625\";i:55868;s:12:\"delete-56628\";i:55869;s:12:\"delete-56631\";i:55870;s:12:\"delete-56632\";i:55871;s:12:\"delete-56629\";i:55872;s:12:\"delete-56630\";i:55873;s:12:\"delete-56633\";i:55874;s:12:\"delete-56636\";i:55875;s:12:\"delete-56637\";i:55876;s:12:\"delete-56634\";i:55877;s:12:\"delete-56635\";i:55878;s:12:\"delete-56638\";i:55879;s:12:\"delete-56641\";i:55880;s:12:\"delete-56639\";i:55881;s:12:\"delete-56640\";i:55882;s:12:\"delete-56642\";i:55883;s:12:\"delete-56643\";i:55884;s:12:\"delete-56646\";i:55885;s:12:\"delete-56647\";i:55886;s:12:\"delete-56644\";i:55887;s:12:\"delete-56645\";i:55888;s:12:\"delete-56648\";i:55889;s:12:\"delete-56651\";i:55890;s:12:\"delete-56652\";i:55891;s:12:\"delete-56649\";i:55892;s:12:\"delete-56650\";i:55893;s:12:\"delete-56653\";i:55894;s:12:\"delete-56656\";i:55895;s:12:\"delete-56657\";i:55896;s:12:\"delete-56654\";i:55897;s:12:\"delete-56655\";i:55898;s:12:\"delete-56658\";i:55899;s:12:\"delete-56661\";i:55900;s:12:\"delete-56662\";i:55901;s:12:\"delete-56663\";i:55902;s:12:\"delete-56666\";i:55903;s:12:\"delete-56667\";i:55904;s:12:\"delete-56659\";i:55905;s:12:\"delete-56660\";i:55906;s:12:\"delete-56664\";i:55907;s:12:\"delete-56665\";i:55908;s:12:\"delete-56668\";i:55909;s:12:\"delete-56669\";i:55910;s:12:\"delete-56670\";i:55911;s:12:\"delete-56671\";i:55912;s:12:\"delete-56672\";i:55913;s:12:\"delete-56673\";i:55914;s:12:\"delete-56676\";i:55915;s:12:\"delete-56677\";i:55916;s:12:\"delete-56674\";i:55917;s:12:\"delete-56675\";i:55918;s:12:\"delete-56678\";i:55919;s:12:\"delete-56681\";i:55920;s:12:\"delete-56682\";i:55921;s:12:\"delete-56679\";i:55922;s:12:\"delete-56680\";i:55923;s:12:\"delete-56683\";i:55924;s:12:\"delete-56686\";i:55925;s:12:\"delete-56687\";i:55926;s:12:\"delete-56684\";i:55927;s:12:\"delete-56685\";i:55928;s:12:\"delete-56688\";i:55929;s:12:\"delete-56691\";i:55930;s:12:\"delete-56692\";i:55931;s:12:\"delete-56689\";i:55932;s:12:\"delete-56690\";i:55933;s:12:\"delete-56693\";i:55934;s:12:\"delete-56696\";i:55935;s:12:\"delete-56697\";i:55936;s:12:\"delete-56694\";i:55937;s:12:\"delete-56695\";i:55938;s:12:\"delete-56698\";i:55939;s:12:\"delete-56701\";i:55940;s:12:\"delete-56699\";i:55941;s:12:\"delete-56700\";i:55942;s:12:\"delete-56702\";i:55943;s:12:\"delete-56705\";i:55944;s:12:\"delete-56703\";i:55945;s:12:\"delete-56704\";i:55946;s:12:\"delete-56706\";i:55947;s:12:\"delete-56707\";i:55948;s:12:\"delete-56710\";i:55949;s:12:\"delete-56711\";i:55950;s:12:\"delete-56708\";i:55951;s:12:\"delete-56709\";i:55952;s:12:\"delete-56712\";i:55953;s:12:\"delete-56715\";i:55954;s:12:\"delete-56716\";i:55955;s:12:\"delete-56713\";i:55956;s:12:\"delete-56714\";i:55957;s:12:\"delete-56717\";i:55958;s:12:\"delete-56720\";i:55959;s:12:\"delete-56721\";i:55960;s:12:\"delete-56718\";i:55961;s:12:\"delete-56719\";i:55962;s:12:\"delete-56722\";i:55963;s:12:\"delete-56725\";i:55964;s:12:\"delete-56726\";i:55965;s:12:\"delete-56723\";i:55966;s:12:\"delete-56724\";i:55967;s:12:\"delete-56727\";i:55968;s:12:\"delete-56730\";i:55969;s:12:\"delete-56728\";i:55970;s:12:\"delete-56729\";i:55971;s:12:\"delete-56731\";i:55972;s:12:\"delete-56732\";i:55973;s:12:\"delete-56735\";i:55974;s:12:\"delete-56736\";i:55975;s:12:\"delete-56733\";i:55976;s:12:\"delete-56734\";i:55977;s:12:\"delete-56737\";i:55978;s:12:\"delete-56740\";i:55979;s:12:\"delete-56741\";i:55980;s:12:\"delete-56738\";i:55981;s:12:\"delete-56739\";i:55982;s:12:\"delete-56742\";i:55983;s:12:\"delete-56745\";i:55984;s:12:\"delete-56746\";i:55985;s:12:\"delete-56743\";i:55986;s:12:\"delete-56744\";i:55987;s:12:\"delete-56747\";i:55988;s:12:\"delete-56750\";i:55989;s:12:\"delete-56751\";i:55990;s:12:\"delete-56748\";i:55991;s:12:\"delete-56749\";i:55992;s:12:\"delete-56752\";i:55993;s:12:\"delete-56755\";i:55994;s:12:\"delete-56756\";i:55995;s:12:\"delete-56753\";i:55996;s:12:\"delete-56754\";i:55997;s:12:\"delete-56757\";i:55998;s:12:\"delete-56760\";i:55999;s:12:\"delete-56758\";i:56000;s:12:\"delete-56759\";i:56001;s:12:\"delete-56761\";i:56002;s:12:\"delete-56762\";i:56003;s:12:\"delete-56765\";i:56004;s:12:\"delete-56766\";i:56005;s:12:\"delete-56763\";i:56006;s:12:\"delete-56764\";i:56007;s:12:\"delete-56767\";i:56008;s:12:\"delete-56770\";i:56009;s:12:\"delete-56771\";i:56010;s:12:\"delete-56768\";i:56011;s:12:\"delete-56769\";i:56012;s:12:\"delete-56772\";i:56013;s:12:\"delete-56775\";i:56014;s:12:\"delete-56773\";i:56015;s:12:\"delete-56774\";i:56016;s:12:\"delete-56776\";i:56017;s:12:\"delete-56777\";i:56018;s:12:\"delete-56780\";i:56019;s:12:\"delete-56781\";i:56020;s:12:\"delete-56778\";i:56021;s:12:\"delete-56779\";i:56022;s:12:\"delete-56782\";i:56023;s:12:\"delete-56785\";i:56024;s:12:\"delete-56783\";i:56025;s:12:\"delete-56784\";i:56026;s:12:\"delete-56786\";i:56027;s:12:\"delete-56787\";i:56028;s:12:\"delete-56790\";i:56029;s:12:\"delete-56791\";i:56030;s:12:\"delete-56788\";i:56031;s:12:\"delete-56789\";i:56032;s:12:\"delete-56792\";i:56033;s:12:\"delete-56795\";i:56034;s:12:\"delete-56793\";i:56035;s:12:\"delete-56794\";i:56036;s:12:\"delete-56796\";i:56037;s:12:\"delete-56797\";i:56038;s:12:\"delete-56800\";i:56039;s:12:\"delete-56801\";i:56040;s:12:\"delete-56802\";i:56041;s:12:\"delete-56805\";i:56042;s:12:\"delete-56806\";i:56043;s:12:\"delete-56798\";i:56044;s:12:\"delete-56799\";i:56045;s:12:\"delete-56803\";i:56046;s:12:\"delete-56804\";i:56047;s:12:\"delete-56807\";i:56048;s:12:\"delete-56810\";i:56049;s:12:\"delete-56808\";i:56050;s:12:\"delete-56809\";i:56051;s:12:\"delete-56811\";i:56052;s:12:\"delete-56812\";i:56053;s:12:\"delete-56815\";i:56054;s:12:\"delete-56816\";i:56055;s:12:\"delete-56813\";i:56056;s:12:\"delete-56814\";i:56057;s:12:\"delete-56817\";i:56058;s:12:\"delete-56820\";i:56059;s:12:\"delete-56821\";i:56060;s:12:\"delete-56818\";i:56061;s:12:\"delete-56819\";i:56062;s:12:\"delete-56822\";i:56063;s:12:\"delete-56825\";i:56064;s:12:\"delete-56823\";i:56065;s:12:\"delete-56824\";i:56066;s:12:\"delete-56826\";i:56067;s:12:\"delete-56827\";i:56068;s:12:\"delete-56830\";i:56069;s:12:\"delete-56831\";i:56070;s:12:\"delete-56828\";i:56071;s:12:\"delete-56829\";i:56072;s:12:\"delete-56832\";i:56073;s:12:\"delete-56835\";i:56074;s:12:\"delete-56836\";i:56075;s:12:\"delete-56833\";i:56076;s:12:\"delete-56834\";i:56077;s:12:\"delete-56837\";i:56078;s:12:\"delete-56840\";i:56079;s:12:\"delete-56838\";i:56080;s:12:\"delete-56839\";i:56081;s:12:\"delete-56841\";i:56082;s:12:\"delete-56842\";i:56083;s:12:\"delete-56845\";i:56084;s:12:\"delete-56843\";i:56085;s:12:\"delete-56844\";i:56086;s:12:\"delete-56846\";i:56087;s:12:\"delete-56847\";i:56088;s:12:\"delete-56850\";i:56089;s:12:\"delete-56851\";i:56090;s:12:\"delete-56848\";i:56091;s:12:\"delete-56849\";i:56092;s:12:\"delete-56852\";i:56093;s:12:\"delete-56855\";i:56094;s:12:\"delete-56856\";i:56095;s:12:\"delete-56853\";i:56096;s:12:\"delete-56854\";i:56097;s:12:\"delete-56857\";i:56098;s:12:\"delete-56860\";i:56099;s:12:\"delete-56861\";i:56100;s:12:\"delete-56858\";i:56101;s:12:\"delete-56859\";i:56102;s:12:\"delete-56862\";i:56103;s:12:\"delete-56865\";i:56104;s:12:\"delete-56866\";i:56105;s:12:\"delete-56863\";i:56106;s:12:\"delete-56864\";i:56107;s:12:\"delete-56867\";i:56108;s:12:\"delete-56870\";i:56109;s:12:\"delete-56871\";i:56110;s:12:\"delete-56868\";i:56111;s:12:\"delete-56869\";i:56112;s:12:\"delete-56872\";i:56113;s:12:\"delete-56875\";i:56114;s:12:\"delete-56873\";i:56115;s:12:\"delete-56874\";i:56116;s:12:\"delete-56876\";i:56117;s:12:\"delete-56877\";i:56118;s:12:\"delete-56880\";i:56119;s:12:\"delete-56881\";i:56120;s:12:\"delete-56878\";i:56121;s:12:\"delete-56879\";i:56122;s:12:\"delete-56882\";i:56123;s:12:\"delete-56885\";i:56124;s:12:\"delete-56886\";i:56125;s:12:\"delete-56883\";i:56126;s:12:\"delete-56884\";i:56127;s:12:\"delete-56887\";i:56128;s:12:\"delete-56890\";i:56129;s:12:\"delete-56888\";i:56130;s:12:\"delete-56889\";i:56131;s:12:\"delete-56891\";i:56132;s:12:\"delete-56892\";i:56133;s:12:\"delete-56895\";i:56134;s:12:\"delete-56896\";i:56135;s:12:\"delete-56893\";i:56136;s:12:\"delete-56894\";i:56137;s:12:\"delete-56897\";i:56138;s:12:\"delete-56900\";i:56139;s:12:\"delete-56901\";i:56140;s:12:\"delete-56898\";i:56141;s:12:\"delete-56899\";i:56142;s:12:\"delete-56902\";i:56143;s:12:\"delete-56905\";i:56144;s:12:\"delete-56903\";i:56145;s:12:\"delete-56904\";i:56146;s:12:\"delete-56906\";i:56147;s:12:\"delete-56907\";i:56148;s:12:\"delete-56910\";i:56149;s:12:\"delete-56911\";i:56150;s:12:\"delete-56908\";i:56151;s:12:\"delete-56909\";i:56152;s:12:\"delete-56912\";i:56153;s:12:\"delete-56915\";i:56154;s:12:\"delete-56916\";i:56155;s:12:\"delete-56913\";i:56156;s:12:\"delete-56914\";i:56157;s:12:\"delete-56917\";i:56158;s:12:\"delete-56920\";i:56159;s:12:\"delete-56921\";i:56160;s:12:\"delete-56918\";i:56161;s:12:\"delete-56919\";i:56162;s:12:\"delete-56922\";i:56163;s:12:\"delete-56925\";i:56164;s:12:\"delete-56926\";i:56165;s:12:\"delete-56923\";i:56166;s:12:\"delete-56924\";i:56167;s:12:\"delete-56927\";i:56168;s:12:\"delete-56930\";i:56169;s:12:\"delete-56931\";i:56170;s:12:\"delete-56928\";i:56171;s:12:\"delete-56929\";i:56172;s:12:\"delete-56932\";i:56173;s:12:\"delete-56935\";i:56174;s:12:\"delete-56936\";i:56175;s:12:\"delete-56933\";i:56176;s:12:\"delete-56934\";i:56177;s:12:\"delete-56937\";i:56178;s:12:\"delete-56940\";i:56179;s:12:\"delete-56941\";i:56180;s:12:\"delete-56938\";i:56181;s:12:\"delete-56939\";i:56182;s:12:\"delete-56942\";i:56183;s:12:\"delete-56945\";i:56184;s:12:\"delete-56943\";i:56185;s:12:\"delete-56944\";i:56186;s:12:\"delete-56946\";i:56187;s:12:\"delete-56947\";i:56188;s:12:\"delete-56950\";i:56189;s:12:\"delete-56951\";i:56190;s:12:\"delete-56948\";i:56191;s:12:\"delete-56949\";i:56192;s:12:\"delete-56952\";i:56193;s:12:\"delete-56955\";i:56194;s:12:\"delete-56956\";i:56195;s:12:\"delete-56953\";i:56196;s:12:\"delete-56954\";i:56197;s:12:\"delete-56957\";i:56198;s:12:\"delete-56960\";i:56199;s:12:\"delete-56961\";i:56200;s:12:\"delete-56962\";i:56201;s:12:\"delete-56965\";i:56202;s:12:\"delete-56966\";i:56203;s:12:\"delete-56958\";i:56204;s:12:\"delete-56959\";i:56205;s:12:\"delete-56963\";i:56206;s:12:\"delete-56964\";i:56207;s:12:\"delete-56967\";i:56208;s:12:\"delete-56970\";i:56209;s:12:\"delete-56971\";i:56210;s:12:\"delete-56968\";i:56211;s:12:\"delete-56969\";i:56212;s:12:\"delete-56972\";i:56213;s:12:\"delete-56975\";i:56214;s:12:\"delete-56976\";i:56215;s:12:\"delete-56973\";i:56216;s:12:\"delete-56974\";i:56217;s:12:\"delete-56977\";i:56218;s:12:\"delete-56980\";i:56219;s:12:\"delete-56981\";i:56220;s:12:\"delete-56978\";i:56221;s:12:\"delete-56979\";i:56222;s:12:\"delete-56982\";i:56223;s:12:\"delete-56985\";i:56224;s:12:\"delete-56983\";i:56225;s:12:\"delete-56984\";i:56226;s:12:\"delete-56986\";i:56227;s:12:\"delete-56987\";i:56228;s:12:\"delete-56990\";i:56229;s:12:\"delete-56991\";i:56230;s:12:\"delete-56988\";i:56231;s:12:\"delete-56989\";i:56232;s:12:\"delete-56992\";i:56233;s:12:\"delete-56995\";i:56234;s:12:\"delete-56993\";i:56235;s:12:\"delete-56994\";i:56236;s:12:\"delete-56996\";i:56237;s:12:\"delete-56997\";i:56238;s:12:\"delete-57000\";i:56239;s:12:\"delete-57001\";i:56240;s:12:\"delete-56998\";i:56241;s:12:\"delete-56999\";i:56242;s:12:\"delete-57002\";i:56243;s:12:\"delete-57005\";i:56244;s:12:\"delete-57006\";i:56245;s:12:\"delete-57003\";i:56246;s:12:\"delete-57004\";i:56247;s:12:\"delete-57007\";i:56248;s:12:\"delete-57010\";i:56249;s:12:\"delete-57011\";i:56250;s:12:\"delete-57008\";i:56251;s:12:\"delete-57009\";i:56252;s:12:\"delete-57012\";i:56253;s:12:\"delete-57015\";i:56254;s:12:\"delete-57016\";i:56255;s:12:\"delete-57013\";i:56256;s:12:\"delete-57014\";i:56257;s:12:\"delete-57017\";i:56258;s:12:\"delete-57020\";i:56259;s:12:\"delete-57021\";i:56260;s:12:\"delete-57018\";i:56261;s:12:\"delete-57019\";i:56262;s:12:\"delete-57022\";i:56263;s:12:\"delete-57025\";i:56264;s:12:\"delete-57026\";i:56265;s:12:\"delete-57023\";i:56266;s:12:\"delete-57024\";i:56267;s:12:\"delete-57027\";i:56268;s:12:\"delete-57030\";i:56269;s:12:\"delete-57031\";i:56270;s:12:\"delete-57028\";i:56271;s:12:\"delete-57029\";i:56272;s:12:\"delete-57032\";i:56273;s:12:\"delete-57035\";i:56274;s:12:\"delete-57033\";i:56275;s:12:\"delete-57034\";i:56276;s:12:\"delete-57036\";i:56277;s:12:\"delete-57037\";i:56278;s:12:\"delete-57040\";i:56279;s:12:\"delete-57041\";i:56280;s:12:\"delete-57038\";i:56281;s:12:\"delete-57039\";i:56282;s:12:\"delete-57042\";i:56283;s:12:\"delete-57045\";i:56284;s:12:\"delete-57043\";i:56285;s:12:\"delete-57044\";i:56286;s:12:\"delete-57046\";i:56287;s:12:\"delete-57047\";i:56288;s:12:\"delete-57050\";i:56289;s:12:\"delete-57048\";i:56290;s:12:\"delete-57049\";i:56291;s:12:\"delete-57051\";i:56292;s:12:\"delete-57052\";i:56293;s:12:\"delete-57055\";i:56294;s:12:\"delete-57056\";i:56295;s:12:\"delete-57053\";i:56296;s:12:\"delete-57054\";i:56297;s:12:\"delete-57057\";i:56298;s:12:\"delete-57060\";i:56299;s:12:\"delete-57061\";i:56300;s:12:\"delete-57058\";i:56301;s:12:\"delete-57059\";i:56302;s:12:\"delete-57062\";i:56303;s:12:\"delete-57065\";i:56304;s:12:\"delete-57066\";i:56305;s:12:\"delete-57063\";i:56306;s:12:\"delete-57064\";i:56307;s:12:\"delete-57067\";i:56308;s:12:\"delete-57070\";i:56309;s:12:\"delete-57071\";i:56310;s:12:\"delete-57068\";i:56311;s:12:\"delete-57069\";i:56312;s:12:\"delete-57072\";i:56313;s:12:\"delete-57075\";i:56314;s:12:\"delete-57076\";i:56315;s:12:\"delete-57073\";i:56316;s:12:\"delete-57074\";i:56317;s:12:\"delete-57077\";i:56318;s:12:\"delete-57080\";i:56319;s:12:\"delete-57081\";i:56320;s:12:\"delete-57078\";i:56321;s:12:\"delete-57079\";i:56322;s:12:\"delete-57082\";i:56323;s:12:\"delete-57085\";i:56324;s:12:\"delete-57086\";i:56325;s:12:\"delete-57083\";i:56326;s:12:\"delete-57084\";i:56327;s:12:\"delete-57087\";i:56328;s:12:\"delete-57088\";i:56329;s:12:\"delete-57089\";i:56330;s:12:\"delete-57090\";i:56331;s:12:\"delete-57091\";i:56332;s:12:\"delete-57092\";i:56333;s:12:\"delete-57095\";i:56334;s:12:\"delete-57096\";i:56335;s:12:\"delete-57093\";i:56336;s:12:\"delete-57094\";i:56337;s:12:\"delete-57097\";i:56338;s:12:\"delete-57100\";i:56339;s:12:\"delete-57101\";i:56340;s:12:\"delete-57098\";i:56341;s:12:\"delete-57099\";i:56342;s:12:\"delete-57102\";i:56343;s:12:\"delete-57105\";i:56344;s:12:\"delete-57106\";i:56345;s:12:\"delete-57103\";i:56346;s:12:\"delete-57104\";i:56347;s:12:\"delete-57107\";i:56348;s:12:\"delete-57110\";i:56349;s:12:\"delete-57111\";i:56350;s:12:\"delete-57108\";i:56351;s:12:\"delete-57109\";i:56352;s:12:\"delete-57112\";i:56353;s:12:\"delete-57115\";i:56354;s:12:\"delete-57116\";i:56355;s:12:\"delete-57113\";i:56356;s:12:\"delete-57114\";i:56357;s:12:\"delete-57117\";i:56358;s:12:\"delete-57120\";i:56359;s:12:\"delete-57121\";i:56360;s:12:\"delete-57118\";i:56361;s:12:\"delete-57119\";i:56362;s:12:\"delete-57122\";i:56363;s:12:\"delete-57125\";i:56364;s:12:\"delete-57126\";i:56365;s:12:\"delete-57123\";i:56366;s:12:\"delete-57124\";i:56367;s:12:\"delete-57127\";i:56368;s:12:\"delete-57130\";i:56369;s:12:\"delete-57128\";i:56370;s:12:\"delete-57129\";i:56371;s:12:\"delete-57131\";i:56372;s:12:\"delete-57132\";i:56373;s:12:\"delete-57135\";i:56374;s:12:\"delete-57136\";i:56375;s:12:\"delete-57133\";i:56376;s:12:\"delete-57134\";i:56377;s:12:\"delete-57137\";i:56378;s:12:\"delete-57140\";i:56379;s:12:\"delete-57141\";i:56380;s:12:\"delete-57138\";i:56381;s:12:\"delete-57139\";i:56382;s:12:\"delete-57142\";i:56383;s:12:\"delete-57145\";i:56384;s:12:\"delete-57146\";i:56385;s:12:\"delete-57143\";i:56386;s:12:\"delete-57144\";i:56387;s:12:\"delete-57147\";i:56388;s:12:\"delete-57150\";i:56389;s:12:\"delete-57148\";i:56390;s:12:\"delete-57149\";i:56391;s:12:\"delete-57151\";i:56392;s:12:\"delete-57152\";i:56393;s:12:\"delete-57155\";i:56394;s:12:\"delete-57153\";i:56395;s:12:\"delete-57154\";i:56396;s:12:\"delete-57156\";i:56397;s:12:\"delete-57157\";i:56398;s:12:\"delete-57160\";i:56399;s:12:\"delete-57161\";i:56400;s:12:\"delete-57158\";i:56401;s:12:\"delete-57159\";i:56402;s:12:\"delete-57162\";i:56403;s:12:\"delete-57165\";i:56404;s:12:\"delete-57163\";i:56405;s:12:\"delete-57164\";i:56406;s:12:\"delete-57166\";i:56407;s:12:\"delete-57167\";i:56408;s:12:\"delete-57170\";i:56409;s:12:\"delete-57171\";i:56410;s:12:\"delete-57168\";i:56411;s:12:\"delete-57169\";i:56412;s:12:\"delete-57172\";i:56413;s:12:\"delete-57175\";i:56414;s:12:\"delete-57176\";i:56415;s:12:\"delete-57173\";i:56416;s:12:\"delete-57174\";i:56417;s:12:\"delete-57177\";i:56418;s:12:\"delete-57180\";i:56419;s:12:\"delete-57181\";i:56420;s:12:\"delete-57178\";i:56421;s:12:\"delete-57179\";i:56422;s:12:\"delete-57182\";i:56423;s:12:\"delete-57185\";i:56424;s:12:\"delete-57186\";i:56425;s:12:\"delete-57183\";i:56426;s:12:\"delete-57184\";i:56427;s:12:\"delete-57187\";i:56428;s:12:\"delete-57190\";i:56429;s:12:\"delete-57191\";i:56430;s:12:\"delete-57188\";i:56431;s:12:\"delete-57189\";i:56432;s:12:\"delete-57192\";i:56433;s:12:\"delete-57195\";i:56434;s:12:\"delete-57196\";i:56435;s:12:\"delete-57193\";i:56436;s:12:\"delete-57194\";i:56437;s:12:\"delete-57197\";i:56438;s:12:\"delete-57200\";i:56439;s:12:\"delete-57198\";i:56440;s:12:\"delete-57199\";i:56441;s:12:\"delete-57201\";i:56442;s:12:\"delete-57202\";i:56443;s:12:\"delete-57205\";i:56444;s:12:\"delete-57203\";i:56445;s:12:\"delete-57204\";i:56446;s:12:\"delete-57206\";i:56447;s:12:\"delete-57207\";i:56448;s:12:\"delete-57210\";i:56449;s:12:\"delete-57211\";i:56450;s:12:\"delete-57208\";i:56451;s:12:\"delete-57209\";i:56452;s:12:\"delete-57212\";i:56453;s:12:\"delete-57215\";i:56454;s:12:\"delete-57216\";i:56455;s:12:\"delete-57213\";i:56456;s:12:\"delete-57214\";i:56457;s:12:\"delete-57217\";i:56458;s:12:\"delete-57220\";i:56459;s:12:\"delete-57221\";i:56460;s:12:\"delete-57218\";i:56461;s:12:\"delete-57219\";i:56462;s:12:\"delete-57222\";i:56463;s:12:\"delete-57225\";i:56464;s:12:\"delete-57226\";i:56465;s:12:\"delete-57223\";i:56466;s:12:\"delete-57224\";i:56467;s:12:\"delete-57227\";i:56468;s:12:\"delete-57230\";i:56469;s:12:\"delete-57231\";i:56470;s:12:\"delete-57228\";i:56471;s:12:\"delete-57229\";i:56472;s:12:\"delete-57232\";i:56473;s:12:\"delete-57235\";i:56474;s:12:\"delete-57236\";i:56475;s:12:\"delete-57233\";i:56476;s:12:\"delete-57234\";i:56477;s:12:\"delete-57237\";i:56478;s:12:\"delete-57240\";i:56479;s:12:\"delete-57241\";i:56480;s:12:\"delete-57238\";i:56481;s:12:\"delete-57239\";i:56482;s:12:\"delete-57242\";i:56483;s:12:\"delete-57245\";i:56484;s:12:\"delete-57246\";i:56485;s:12:\"delete-57243\";i:56486;s:12:\"delete-57244\";i:56487;s:12:\"delete-57247\";i:56488;s:12:\"delete-57250\";i:56489;s:12:\"delete-57251\";i:56490;s:12:\"delete-57248\";i:56491;s:12:\"delete-57249\";i:56492;s:12:\"delete-57252\";i:56493;s:12:\"delete-57255\";i:56494;s:12:\"delete-57256\";i:56495;s:12:\"delete-57253\";i:56496;s:12:\"delete-57254\";i:56497;s:12:\"delete-57257\";i:56498;s:12:\"delete-57260\";i:56499;s:12:\"delete-57261\";i:56500;s:12:\"delete-57258\";i:56501;s:12:\"delete-57259\";i:56502;s:12:\"delete-57262\";i:56503;s:12:\"delete-57265\";i:56504;s:12:\"delete-57266\";i:56505;s:12:\"delete-57263\";i:56506;s:12:\"delete-57264\";i:56507;s:12:\"delete-57267\";i:56508;s:12:\"delete-57270\";i:56509;s:12:\"delete-57271\";i:56510;s:12:\"delete-57268\";i:56511;s:12:\"delete-57269\";i:56512;s:12:\"delete-57272\";i:56513;s:12:\"delete-57275\";i:56514;s:12:\"delete-57276\";i:56515;s:12:\"delete-57273\";i:56516;s:12:\"delete-57274\";i:56517;s:12:\"delete-57277\";i:56518;s:12:\"delete-57280\";i:56519;s:12:\"delete-57281\";i:56520;s:12:\"delete-57278\";i:56521;s:12:\"delete-57279\";i:56522;s:12:\"delete-57282\";i:56523;s:12:\"delete-57285\";i:56524;s:12:\"delete-57283\";i:56525;s:12:\"delete-57284\";i:56526;s:12:\"delete-57286\";i:56527;s:12:\"delete-57287\";i:56528;s:12:\"delete-57290\";i:56529;s:12:\"delete-57288\";i:56530;s:12:\"delete-57289\";i:56531;s:12:\"delete-57291\";i:56532;s:12:\"delete-57292\";i:56533;s:12:\"delete-57295\";i:56534;s:12:\"delete-57296\";i:56535;s:12:\"delete-57293\";i:56536;s:12:\"delete-57294\";i:56537;s:12:\"delete-57297\";i:56538;s:12:\"delete-57298\";i:56539;s:12:\"delete-57299\";i:56540;s:12:\"delete-57300\";i:56541;s:12:\"delete-57301\";i:56542;s:12:\"delete-57302\";i:56543;s:12:\"delete-57305\";i:56544;s:12:\"delete-57306\";i:56545;s:12:\"delete-57303\";i:56546;s:12:\"delete-57304\";i:56547;s:12:\"delete-57307\";i:56548;s:12:\"delete-57310\";i:56549;s:12:\"delete-57311\";i:56550;s:12:\"delete-57308\";i:56551;s:12:\"delete-57309\";i:56552;s:12:\"delete-57312\";i:56553;s:12:\"delete-57315\";i:56554;s:12:\"delete-57316\";i:56555;s:12:\"delete-57313\";i:56556;s:12:\"delete-57314\";i:56557;s:12:\"delete-57317\";i:56558;s:12:\"delete-57320\";i:56559;s:12:\"delete-57321\";i:56560;s:12:\"delete-57318\";i:56561;s:12:\"delete-57319\";i:56562;s:12:\"delete-57322\";i:56563;s:12:\"delete-57325\";i:56564;s:12:\"delete-57326\";i:56565;s:12:\"delete-57323\";i:56566;s:12:\"delete-57324\";i:56567;s:12:\"delete-57327\";i:56568;s:12:\"delete-57330\";i:56569;s:12:\"delete-57328\";i:56570;s:12:\"delete-57329\";i:56571;s:12:\"delete-57331\";i:56572;s:12:\"delete-57332\";i:56573;s:12:\"delete-57335\";i:56574;s:12:\"delete-57336\";i:56575;s:12:\"delete-57333\";i:56576;s:12:\"delete-57334\";i:56577;s:12:\"delete-57337\";i:56578;s:12:\"delete-57338\";i:56579;s:12:\"delete-57339\";i:56580;s:12:\"delete-57340\";i:56581;s:12:\"delete-57341\";i:56582;s:12:\"delete-57342\";i:56583;s:12:\"delete-57345\";i:56584;s:12:\"delete-57346\";i:56585;s:12:\"delete-57343\";i:56586;s:12:\"delete-57344\";i:56587;s:12:\"delete-57347\";i:56588;s:12:\"delete-57350\";i:56589;s:12:\"delete-57348\";i:56590;s:12:\"delete-57349\";i:56591;s:12:\"delete-57351\";i:56592;s:12:\"delete-57352\";i:56593;s:12:\"delete-57355\";i:56594;s:12:\"delete-57356\";i:56595;s:12:\"delete-57353\";i:56596;s:12:\"delete-57354\";i:56597;s:12:\"delete-57357\";i:56598;s:12:\"delete-57360\";i:56599;s:12:\"delete-57361\";i:56600;s:12:\"delete-57358\";i:56601;s:12:\"delete-57359\";i:56602;s:12:\"delete-57362\";i:56603;s:12:\"delete-57365\";i:56604;s:12:\"delete-57366\";i:56605;s:12:\"delete-57363\";i:56606;s:12:\"delete-57364\";i:56607;s:12:\"delete-57367\";i:56608;s:12:\"delete-57370\";i:56609;s:12:\"delete-57368\";i:56610;s:12:\"delete-57369\";i:56611;s:12:\"delete-57371\";i:56612;s:12:\"delete-57372\";i:56613;s:12:\"delete-57375\";i:56614;s:12:\"delete-57376\";i:56615;s:12:\"delete-57373\";i:56616;s:12:\"delete-57374\";i:56617;s:12:\"delete-57377\";i:56618;s:12:\"delete-57380\";i:56619;s:12:\"delete-57381\";i:56620;s:12:\"delete-57378\";i:56621;s:12:\"delete-57379\";i:56622;s:12:\"delete-57382\";i:56623;s:12:\"delete-57385\";i:56624;s:12:\"delete-57386\";i:56625;s:12:\"delete-57383\";i:56626;s:12:\"delete-57384\";i:56627;s:12:\"delete-57387\";i:56628;s:12:\"delete-57390\";i:56629;s:12:\"delete-57391\";i:56630;s:12:\"delete-57388\";i:56631;s:12:\"delete-57389\";i:56632;s:12:\"delete-57392\";i:56633;s:12:\"delete-57395\";i:56634;s:12:\"delete-57393\";i:56635;s:12:\"delete-57394\";i:56636;s:12:\"delete-57396\";i:56637;s:12:\"delete-57397\";i:56638;s:12:\"delete-57400\";i:56639;s:12:\"delete-57401\";i:56640;s:12:\"delete-57398\";i:56641;s:12:\"delete-57399\";i:56642;s:12:\"delete-57402\";i:56643;s:12:\"delete-57405\";i:56644;s:12:\"delete-57406\";i:56645;s:12:\"delete-57403\";i:56646;s:12:\"delete-57404\";i:56647;s:12:\"delete-57407\";i:56648;s:12:\"delete-57410\";i:56649;s:12:\"delete-57408\";i:56650;s:12:\"delete-57409\";i:56651;s:12:\"delete-57411\";i:56652;s:12:\"delete-57412\";i:56653;s:12:\"delete-57415\";i:56654;s:12:\"delete-57416\";i:56655;s:12:\"delete-57413\";i:56656;s:12:\"delete-57414\";i:56657;s:12:\"delete-57417\";i:56658;s:12:\"delete-57420\";i:56659;s:12:\"delete-57421\";i:56660;s:12:\"delete-57418\";i:56661;s:12:\"delete-57419\";i:56662;s:12:\"delete-57422\";i:56663;s:12:\"delete-57425\";i:56664;s:12:\"delete-57426\";i:56665;s:12:\"delete-57423\";i:56666;s:12:\"delete-57424\";i:56667;s:12:\"delete-57427\";i:56668;s:12:\"delete-57430\";i:56669;s:12:\"delete-57431\";i:56670;s:12:\"delete-57428\";i:56671;s:12:\"delete-57429\";i:56672;s:12:\"delete-57432\";i:56673;s:12:\"delete-57435\";i:56674;s:12:\"delete-57436\";i:56675;s:12:\"delete-57433\";i:56676;s:12:\"delete-57434\";i:56677;s:12:\"delete-57437\";i:56678;s:12:\"delete-57440\";i:56679;s:12:\"delete-57441\";i:56680;s:12:\"delete-57438\";i:56681;s:12:\"delete-57439\";i:56682;s:12:\"delete-57442\";i:56683;s:12:\"delete-57445\";i:56684;s:12:\"delete-57446\";i:56685;s:12:\"delete-57443\";i:56686;s:12:\"delete-57444\";i:56687;s:12:\"delete-57447\";i:56688;s:12:\"delete-57450\";i:56689;s:12:\"delete-57451\";i:56690;s:12:\"delete-57448\";i:56691;s:12:\"delete-57449\";i:56692;s:12:\"delete-57452\";i:56693;s:12:\"delete-57455\";i:56694;s:12:\"delete-57456\";i:56695;s:12:\"delete-57453\";i:56696;s:12:\"delete-57454\";i:56697;s:12:\"delete-57457\";i:56698;s:12:\"delete-57460\";i:56699;s:12:\"delete-57461\";i:56700;s:12:\"delete-57458\";i:56701;s:12:\"delete-57459\";i:56702;s:12:\"delete-57462\";i:56703;s:12:\"delete-57465\";i:56704;s:12:\"delete-57466\";i:56705;s:12:\"delete-57463\";i:56706;s:12:\"delete-57464\";i:56707;s:12:\"delete-57467\";i:56708;s:12:\"delete-57470\";i:56709;s:12:\"delete-57471\";i:56710;s:12:\"delete-57468\";i:56711;s:12:\"delete-57469\";i:56712;s:12:\"delete-57472\";i:56713;s:12:\"delete-57475\";i:56714;s:12:\"delete-57473\";i:56715;s:12:\"delete-57474\";i:56716;s:12:\"delete-57476\";i:56717;s:12:\"delete-57477\";i:56718;s:12:\"delete-57480\";i:56719;s:12:\"delete-57481\";i:56720;s:12:\"delete-57478\";i:56721;s:12:\"delete-57479\";i:56722;s:12:\"delete-57482\";i:56723;s:12:\"delete-57485\";i:56724;s:12:\"delete-57486\";i:56725;s:12:\"delete-57483\";i:56726;s:12:\"delete-57484\";i:56727;s:12:\"delete-57487\";i:56728;s:12:\"delete-57490\";i:56729;s:12:\"delete-57491\";i:56730;s:12:\"delete-57488\";i:56731;s:12:\"delete-57489\";i:56732;s:12:\"delete-57492\";i:56733;s:12:\"delete-57495\";i:56734;s:12:\"delete-57496\";i:56735;s:12:\"delete-57493\";i:56736;s:12:\"delete-57494\";i:56737;s:12:\"delete-57497\";i:56738;s:12:\"delete-57500\";i:56739;s:12:\"delete-57501\";i:56740;s:12:\"delete-57498\";i:56741;s:12:\"delete-57499\";i:56742;s:12:\"delete-57502\";i:56743;s:12:\"delete-57505\";i:56744;s:12:\"delete-57506\";i:56745;s:12:\"delete-57503\";i:56746;s:12:\"delete-57504\";i:56747;s:12:\"delete-57507\";i:56748;s:12:\"delete-57510\";i:56749;s:12:\"delete-57511\";i:56750;s:12:\"delete-57508\";i:56751;s:12:\"delete-57509\";i:56752;s:12:\"delete-57512\";i:56753;s:12:\"delete-57515\";i:56754;s:12:\"delete-57516\";i:56755;s:12:\"delete-57513\";i:56756;s:12:\"delete-57514\";i:56757;s:12:\"delete-57517\";i:56758;s:12:\"delete-57520\";i:56759;s:12:\"delete-57521\";i:56760;s:12:\"delete-57518\";i:56761;s:12:\"delete-57519\";i:56762;s:12:\"delete-57522\";i:56763;s:12:\"delete-57525\";i:56764;s:12:\"delete-57526\";i:56765;s:12:\"delete-57523\";i:56766;s:12:\"delete-57524\";i:56767;s:12:\"delete-57527\";i:56768;s:12:\"delete-57530\";i:56769;s:12:\"delete-57528\";i:56770;s:12:\"delete-57529\";i:56771;s:12:\"delete-57531\";i:56772;s:12:\"delete-57532\";i:56773;s:12:\"delete-57535\";i:56774;s:12:\"delete-57536\";i:56775;s:12:\"delete-57533\";i:56776;s:12:\"delete-57534\";i:56777;s:12:\"delete-57537\";i:56778;s:12:\"delete-57540\";i:56779;s:12:\"delete-57541\";i:56780;s:12:\"delete-57538\";i:56781;s:12:\"delete-57539\";i:56782;s:12:\"delete-57542\";i:56783;s:12:\"delete-57543\";i:56784;s:12:\"delete-57544\";i:56785;s:12:\"delete-57545\";i:56786;s:12:\"delete-57546\";i:56787;s:12:\"delete-57547\";i:56788;s:12:\"delete-57550\";i:56789;s:12:\"delete-57551\";i:56790;s:12:\"delete-57548\";i:56791;s:12:\"delete-57549\";i:56792;s:12:\"delete-57552\";i:56793;s:12:\"delete-57555\";i:56794;s:12:\"delete-57556\";i:56795;s:12:\"delete-57553\";i:56796;s:12:\"delete-57554\";i:56797;s:12:\"delete-57557\";i:56798;s:12:\"delete-57560\";i:56799;s:12:\"delete-57558\";i:56800;s:12:\"delete-57559\";i:56801;s:12:\"delete-57561\";i:56802;s:12:\"delete-57562\";i:56803;s:12:\"delete-57565\";i:56804;s:12:\"delete-57563\";i:56805;s:12:\"delete-57564\";i:56806;s:12:\"delete-57566\";i:56807;s:12:\"delete-57567\";i:56808;s:12:\"delete-57570\";i:56809;s:12:\"delete-57571\";i:56810;s:12:\"delete-57568\";i:56811;s:12:\"delete-57569\";i:56812;s:12:\"delete-57572\";i:56813;s:12:\"delete-57575\";i:56814;s:12:\"delete-57573\";i:56815;s:12:\"delete-57574\";i:56816;s:12:\"delete-57576\";i:56817;s:12:\"delete-57577\";i:56818;s:12:\"delete-57580\";i:56819;s:12:\"delete-57581\";i:56820;s:12:\"delete-57578\";i:56821;s:12:\"delete-57579\";i:56822;s:12:\"delete-57582\";i:56823;s:12:\"delete-57585\";i:56824;s:12:\"delete-57586\";i:56825;s:12:\"delete-57583\";i:56826;s:12:\"delete-57584\";i:56827;s:12:\"delete-57587\";i:56828;s:12:\"delete-57590\";i:56829;s:12:\"delete-57591\";i:56830;s:12:\"delete-57588\";i:56831;s:12:\"delete-57589\";i:56832;s:12:\"delete-57592\";i:56833;s:12:\"delete-57595\";i:56834;s:12:\"delete-57596\";i:56835;s:12:\"delete-57593\";i:56836;s:12:\"delete-57594\";i:56837;s:12:\"delete-57597\";i:56838;s:12:\"delete-57600\";i:56839;s:12:\"delete-57598\";i:56840;s:12:\"delete-57599\";i:56841;s:12:\"delete-57601\";i:56842;s:12:\"delete-57602\";i:56843;s:12:\"delete-57605\";i:56844;s:12:\"delete-57606\";i:56845;s:12:\"delete-57603\";i:56846;s:12:\"delete-57604\";i:56847;s:12:\"delete-57607\";i:56848;s:12:\"delete-57610\";i:56849;s:12:\"delete-57611\";i:56850;s:12:\"delete-57608\";i:56851;s:12:\"delete-57609\";i:56852;s:12:\"delete-57612\";i:56853;s:12:\"delete-57615\";i:56854;s:12:\"delete-57616\";i:56855;s:12:\"delete-57613\";i:56856;s:12:\"delete-57614\";i:56857;s:12:\"delete-57617\";i:56858;s:12:\"delete-57620\";i:56859;s:12:\"delete-57621\";i:56860;s:12:\"delete-57618\";i:56861;s:12:\"delete-57619\";i:56862;s:12:\"delete-57622\";i:56863;s:12:\"delete-57625\";i:56864;s:12:\"delete-57626\";i:56865;s:12:\"delete-57623\";i:56866;s:12:\"delete-57624\";i:56867;s:12:\"delete-57627\";i:56868;s:12:\"delete-57630\";i:56869;s:12:\"delete-57628\";i:56870;s:12:\"delete-57629\";i:56871;s:12:\"delete-57631\";i:56872;s:12:\"delete-57632\";i:56873;s:12:\"delete-57635\";i:56874;s:12:\"delete-57636\";i:56875;s:12:\"delete-57633\";i:56876;s:12:\"delete-57634\";i:56877;s:12:\"delete-57637\";i:56878;s:12:\"delete-57640\";i:56879;s:12:\"delete-57641\";i:56880;s:12:\"delete-57638\";i:56881;s:12:\"delete-57639\";i:56882;s:12:\"delete-57642\";i:56883;s:12:\"delete-57645\";i:56884;s:12:\"delete-57646\";i:56885;s:12:\"delete-57643\";i:56886;s:12:\"delete-57644\";i:56887;s:12:\"delete-57647\";i:56888;s:12:\"delete-57650\";i:56889;s:12:\"delete-57651\";i:56890;s:12:\"delete-57648\";i:56891;s:12:\"delete-57649\";i:56892;s:12:\"delete-57652\";i:56893;s:12:\"delete-57655\";i:56894;s:12:\"delete-57653\";i:56895;s:12:\"delete-57654\";i:56896;s:12:\"delete-57656\";i:56897;s:12:\"delete-57657\";i:56898;s:12:\"delete-57660\";i:56899;s:12:\"delete-57658\";i:56900;s:12:\"delete-57659\";i:56901;s:12:\"delete-57661\";i:56902;s:12:\"delete-57662\";i:56903;s:12:\"delete-57665\";i:56904;s:12:\"delete-57666\";i:56905;s:12:\"delete-57663\";i:56906;s:12:\"delete-57664\";i:56907;s:12:\"delete-57667\";i:56908;s:12:\"delete-57670\";i:56909;s:12:\"delete-57671\";i:56910;s:12:\"delete-57668\";i:56911;s:12:\"delete-57669\";i:56912;s:12:\"delete-57672\";i:56913;s:12:\"delete-57675\";i:56914;s:12:\"delete-57676\";i:56915;s:12:\"delete-57673\";i:56916;s:12:\"delete-57674\";i:56917;s:12:\"delete-57677\";i:56918;s:12:\"delete-57680\";i:56919;s:12:\"delete-57678\";i:56920;s:12:\"delete-57679\";i:56921;s:12:\"delete-57681\";i:56922;s:12:\"delete-57682\";i:56923;s:12:\"delete-57685\";i:56924;s:12:\"delete-57686\";i:56925;s:12:\"delete-57683\";i:56926;s:12:\"delete-57684\";i:56927;s:12:\"delete-57687\";i:56928;s:12:\"delete-57690\";i:56929;s:12:\"delete-57688\";i:56930;s:12:\"delete-57689\";i:56931;s:12:\"delete-57691\";i:56932;s:12:\"delete-57692\";i:56933;s:12:\"delete-57695\";i:56934;s:12:\"delete-57696\";i:56935;s:12:\"delete-57693\";i:56936;s:12:\"delete-57694\";i:56937;s:12:\"delete-57697\";i:56938;s:12:\"delete-57700\";i:56939;s:12:\"delete-57701\";i:56940;s:12:\"delete-57698\";i:56941;s:12:\"delete-57699\";i:56942;s:12:\"delete-57702\";i:56943;s:12:\"delete-57705\";i:56944;s:12:\"delete-57706\";i:56945;s:12:\"delete-57703\";i:56946;s:12:\"delete-57704\";i:56947;s:12:\"delete-57707\";i:56948;s:12:\"delete-57710\";i:56949;s:12:\"delete-57711\";i:56950;s:12:\"delete-57708\";i:56951;s:12:\"delete-57709\";i:56952;s:12:\"delete-57712\";i:56953;s:12:\"delete-57715\";i:56954;s:12:\"delete-57716\";i:56955;s:12:\"delete-57713\";i:56956;s:12:\"delete-57714\";i:56957;s:12:\"delete-57717\";i:56958;s:12:\"delete-57720\";i:56959;s:12:\"delete-57718\";i:56960;s:12:\"delete-57719\";i:56961;s:12:\"delete-57721\";i:56962;s:12:\"delete-57722\";i:56963;s:12:\"delete-57725\";i:56964;s:12:\"delete-57726\";i:56965;s:12:\"delete-57723\";i:56966;s:12:\"delete-57724\";i:56967;s:12:\"delete-57727\";i:56968;s:12:\"delete-57730\";i:56969;s:12:\"delete-57731\";i:56970;s:12:\"delete-57728\";i:56971;s:12:\"delete-57729\";i:56972;s:12:\"delete-57732\";i:56973;s:12:\"delete-57735\";i:56974;s:12:\"delete-57733\";i:56975;s:12:\"delete-57734\";i:56976;s:12:\"delete-57736\";i:56977;s:12:\"delete-57737\";i:56978;s:12:\"delete-57740\";i:56979;s:12:\"delete-57741\";i:56980;s:12:\"delete-57738\";i:56981;s:12:\"delete-57739\";i:56982;s:12:\"delete-57742\";i:56983;s:12:\"delete-57745\";i:56984;s:12:\"delete-57746\";i:56985;s:12:\"delete-57743\";i:56986;s:12:\"delete-57744\";i:56987;s:12:\"delete-57747\";i:56988;s:12:\"delete-57750\";i:56989;s:12:\"delete-57751\";i:56990;s:12:\"delete-57748\";i:56991;s:12:\"delete-57749\";i:56992;s:12:\"delete-57752\";i:56993;s:12:\"delete-57755\";i:56994;s:12:\"delete-57756\";i:56995;s:12:\"delete-57753\";i:56996;s:12:\"delete-57754\";i:56997;s:12:\"delete-57757\";i:56998;s:12:\"delete-57760\";i:56999;s:12:\"delete-57761\";i:57000;s:12:\"delete-57758\";i:57001;s:12:\"delete-57759\";i:57002;s:12:\"delete-57762\";i:57003;s:12:\"delete-57765\";i:57004;s:12:\"delete-57763\";i:57005;s:12:\"delete-57764\";i:57006;s:12:\"delete-57766\";i:57007;s:12:\"delete-57767\";i:57008;s:12:\"delete-57770\";i:57009;s:12:\"delete-57771\";i:57010;s:12:\"delete-57768\";i:57011;s:12:\"delete-57769\";i:57012;s:12:\"delete-57772\";i:57013;s:12:\"delete-57775\";i:57014;s:12:\"delete-57776\";i:57015;s:12:\"delete-57773\";i:57016;s:12:\"delete-57774\";i:57017;s:12:\"delete-57777\";i:57018;s:12:\"delete-57780\";i:57019;s:12:\"delete-57781\";i:57020;s:12:\"delete-57778\";i:57021;s:12:\"delete-57779\";i:57022;s:12:\"delete-57782\";i:57023;s:12:\"delete-57785\";i:57024;s:12:\"delete-57786\";i:57025;s:12:\"delete-57783\";i:57026;s:12:\"delete-57784\";i:57027;s:12:\"delete-57787\";i:57028;s:12:\"delete-57790\";i:57029;s:12:\"delete-57788\";i:57030;s:12:\"delete-57789\";i:57031;s:12:\"delete-57791\";i:57032;s:12:\"delete-57792\";i:57033;s:12:\"delete-57795\";i:57034;s:12:\"delete-57796\";i:57035;s:12:\"delete-57793\";i:57036;s:12:\"delete-57794\";i:57037;s:12:\"delete-57797\";i:57038;s:12:\"delete-57800\";i:57039;s:12:\"delete-57801\";i:57040;s:12:\"delete-57798\";i:57041;s:12:\"delete-57799\";i:57042;s:12:\"delete-57802\";i:57043;s:12:\"delete-57805\";i:57044;s:12:\"delete-57803\";i:57045;s:12:\"delete-57804\";i:57046;s:12:\"delete-57806\";i:57047;s:12:\"delete-57807\";i:57048;s:12:\"delete-57810\";i:57049;s:12:\"delete-57811\";i:57050;s:12:\"delete-57808\";i:57051;s:12:\"delete-57809\";i:57052;s:12:\"delete-57812\";i:57053;s:12:\"delete-57815\";i:57054;s:12:\"delete-57816\";i:57055;s:12:\"delete-57813\";i:57056;s:12:\"delete-57814\";i:57057;s:12:\"delete-57817\";i:57058;s:12:\"delete-57820\";i:57059;s:12:\"delete-57821\";i:57060;s:12:\"delete-57818\";i:57061;s:12:\"delete-57819\";i:57062;s:12:\"delete-57822\";i:57063;s:12:\"delete-57825\";i:57064;s:12:\"delete-57823\";i:57065;s:12:\"delete-57824\";i:57066;s:12:\"delete-57826\";i:57067;s:12:\"delete-57827\";i:57068;s:12:\"delete-57830\";i:57069;s:12:\"delete-57831\";i:57070;s:12:\"delete-57828\";i:57071;s:12:\"delete-57829\";i:57072;s:12:\"delete-57832\";i:57073;s:12:\"delete-57835\";i:57074;s:12:\"delete-57836\";i:57075;s:12:\"delete-57833\";i:57076;s:12:\"delete-57834\";i:57077;s:12:\"delete-57837\";i:57078;s:12:\"delete-57840\";i:57079;s:12:\"delete-57841\";i:57080;s:12:\"delete-57838\";i:57081;s:12:\"delete-57839\";i:57082;s:12:\"delete-57842\";i:57083;s:12:\"delete-57845\";i:57084;s:12:\"delete-57846\";i:57085;s:12:\"delete-57843\";i:57086;s:12:\"delete-57844\";i:57087;s:12:\"delete-57847\";i:57088;s:12:\"delete-57850\";i:57089;s:12:\"delete-57851\";i:57090;s:12:\"delete-57848\";i:57091;s:12:\"delete-57849\";i:57092;s:12:\"delete-57852\";i:57093;s:12:\"delete-57855\";i:57094;s:12:\"delete-57853\";i:57095;s:12:\"delete-57854\";i:57096;s:12:\"delete-57856\";i:57097;s:12:\"delete-57857\";i:57098;s:12:\"delete-57860\";i:57099;s:12:\"delete-57861\";i:57100;s:12:\"delete-57858\";i:57101;s:12:\"delete-57859\";i:57102;s:12:\"delete-57862\";i:57103;s:12:\"delete-57865\";i:57104;s:12:\"delete-57866\";i:57105;s:12:\"delete-57863\";i:57106;s:12:\"delete-57864\";i:57107;s:12:\"delete-57867\";i:57108;s:12:\"delete-57870\";i:57109;s:12:\"delete-57871\";i:57110;s:12:\"delete-57868\";i:57111;s:12:\"delete-57869\";i:57112;s:12:\"delete-57872\";i:57113;s:12:\"delete-57875\";i:57114;s:12:\"delete-57873\";i:57115;s:12:\"delete-57874\";i:57116;s:12:\"delete-57876\";i:57117;s:12:\"delete-57877\";i:57118;s:12:\"delete-57880\";i:57119;s:12:\"delete-57881\";i:57120;s:12:\"delete-57878\";i:57121;s:12:\"delete-57879\";i:57122;s:12:\"delete-57882\";i:57123;s:12:\"delete-57885\";i:57124;s:12:\"delete-57886\";i:57125;s:12:\"delete-57883\";i:57126;s:12:\"delete-57884\";i:57127;s:12:\"delete-57887\";i:57128;s:12:\"delete-57890\";i:57129;s:12:\"delete-57888\";i:57130;s:12:\"delete-57889\";i:57131;s:12:\"delete-57891\";i:57132;s:12:\"delete-57892\";i:57133;s:12:\"delete-57895\";i:57134;s:12:\"delete-57896\";i:57135;s:12:\"delete-57893\";i:57136;s:12:\"delete-57894\";i:57137;s:12:\"delete-57897\";i:57138;s:12:\"delete-57900\";i:57139;s:12:\"delete-57901\";i:57140;s:12:\"delete-57898\";i:57141;s:12:\"delete-57899\";i:57142;s:12:\"delete-57902\";i:57143;s:12:\"delete-57905\";i:57144;s:12:\"delete-57906\";i:57145;s:12:\"delete-57903\";i:57146;s:12:\"delete-57904\";i:57147;s:12:\"delete-57907\";i:57148;s:12:\"delete-57910\";i:57149;s:12:\"delete-57911\";i:57150;s:12:\"delete-57908\";i:57151;s:12:\"delete-57909\";i:57152;s:12:\"delete-57912\";i:57153;s:12:\"delete-57915\";i:57154;s:12:\"delete-57916\";i:57155;s:12:\"delete-57913\";i:57156;s:12:\"delete-57914\";i:57157;s:12:\"delete-57917\";i:57158;s:12:\"delete-57920\";i:57159;s:12:\"delete-57921\";i:57160;s:12:\"delete-57918\";i:57161;s:12:\"delete-57919\";i:57162;s:12:\"delete-57922\";i:57163;s:12:\"delete-57925\";i:57164;s:12:\"delete-57923\";i:57165;s:12:\"delete-57924\";i:57166;s:12:\"delete-57926\";i:57167;s:12:\"delete-57927\";i:57168;s:12:\"delete-57930\";i:57169;s:12:\"delete-57931\";i:57170;s:12:\"delete-57928\";i:57171;s:12:\"delete-57929\";i:57172;s:12:\"delete-57932\";i:57173;s:12:\"delete-57935\";i:57174;s:12:\"delete-57936\";i:57175;s:12:\"delete-57933\";i:57176;s:12:\"delete-57934\";i:57177;s:12:\"delete-57937\";i:57178;s:12:\"delete-57940\";i:57179;s:12:\"delete-57941\";i:57180;s:12:\"delete-57938\";i:57181;s:12:\"delete-57939\";i:57182;s:12:\"delete-57942\";i:57183;s:12:\"delete-57943\";i:57184;s:12:\"delete-57944\";i:57185;s:12:\"delete-57945\";i:57186;s:12:\"delete-57946\";i:57187;s:12:\"delete-57947\";i:57188;s:12:\"delete-57950\";i:57189;s:12:\"delete-57951\";i:57190;s:12:\"delete-57948\";i:57191;s:12:\"delete-57949\";i:57192;s:12:\"delete-57952\";i:57193;s:12:\"delete-57955\";i:57194;s:12:\"delete-57956\";i:57195;s:12:\"delete-57953\";i:57196;s:12:\"delete-57954\";i:57197;s:12:\"delete-57957\";i:57198;s:12:\"delete-57960\";i:57199;s:12:\"delete-57958\";i:57200;s:12:\"delete-57959\";i:57201;s:12:\"delete-57961\";i:57202;s:12:\"delete-57962\";i:57203;s:12:\"delete-57965\";i:57204;s:12:\"delete-57966\";i:57205;s:12:\"delete-57963\";i:57206;s:12:\"delete-57964\";i:57207;s:12:\"delete-57967\";i:57208;s:12:\"delete-57970\";i:57209;s:12:\"delete-57971\";i:57210;s:12:\"delete-57968\";i:57211;s:12:\"delete-57969\";i:57212;s:12:\"delete-57972\";i:57213;s:12:\"delete-57975\";i:57214;s:12:\"delete-57973\";i:57215;s:12:\"delete-57974\";i:57216;s:12:\"delete-57976\";i:57217;s:12:\"delete-57977\";i:57218;s:12:\"delete-57980\";i:57219;s:12:\"delete-57978\";i:57220;s:12:\"delete-57979\";i:57221;s:12:\"delete-57981\";i:57222;s:12:\"delete-57982\";i:57223;s:12:\"delete-57985\";i:57224;s:12:\"delete-57986\";i:57225;s:12:\"delete-57983\";i:57226;s:12:\"delete-57984\";i:57227;s:12:\"delete-57987\";i:57228;s:12:\"delete-57990\";i:57229;s:12:\"delete-57988\";i:57230;s:12:\"delete-57989\";i:57231;s:12:\"delete-57991\";i:57232;s:12:\"delete-57992\";i:57233;s:12:\"delete-57995\";i:57234;s:12:\"delete-57996\";i:57235;s:12:\"delete-57993\";i:57236;s:12:\"delete-57994\";i:57237;s:12:\"delete-57997\";i:57238;s:12:\"delete-58000\";i:57239;s:12:\"delete-57998\";i:57240;s:12:\"delete-57999\";i:57241;s:12:\"delete-58001\";i:57242;s:12:\"delete-58002\";i:57243;s:12:\"delete-58005\";i:57244;s:12:\"delete-58006\";i:57245;s:12:\"delete-58003\";i:57246;s:12:\"delete-58004\";i:57247;s:12:\"delete-58007\";i:57248;s:12:\"delete-58010\";i:57249;s:12:\"delete-58011\";i:57250;s:12:\"delete-58008\";i:57251;s:12:\"delete-58009\";i:57252;s:12:\"delete-58012\";i:57253;s:12:\"delete-58015\";i:57254;s:12:\"delete-58016\";i:57255;s:12:\"delete-58013\";i:57256;s:12:\"delete-58014\";i:57257;s:12:\"delete-58017\";i:57258;s:12:\"delete-58020\";i:57259;s:12:\"delete-58021\";i:57260;s:12:\"delete-58018\";i:57261;s:12:\"delete-58019\";i:57262;s:12:\"delete-58022\";i:57263;s:12:\"delete-58025\";i:57264;s:12:\"delete-58026\";i:57265;s:12:\"delete-58023\";i:57266;s:12:\"delete-58024\";i:57267;s:12:\"delete-58027\";i:57268;s:12:\"delete-58030\";i:57269;s:12:\"delete-58028\";i:57270;s:12:\"delete-58029\";i:57271;s:12:\"delete-58031\";i:57272;s:12:\"delete-58032\";i:57273;s:12:\"delete-58035\";i:57274;s:12:\"delete-58036\";i:57275;s:12:\"delete-58033\";i:57276;s:12:\"delete-58034\";i:57277;s:12:\"delete-58037\";i:57278;s:12:\"delete-58038\";i:57279;s:12:\"delete-58039\";i:57280;s:12:\"delete-58040\";i:57281;s:12:\"delete-58041\";i:57282;s:12:\"delete-58042\";i:57283;s:12:\"delete-58045\";i:57284;s:12:\"delete-58046\";i:57285;s:12:\"delete-58043\";i:57286;s:12:\"delete-58044\";i:57287;s:12:\"delete-58047\";i:57288;s:12:\"delete-58050\";i:57289;s:12:\"delete-58051\";i:57290;s:12:\"delete-58048\";i:57291;s:12:\"delete-58049\";i:57292;s:12:\"delete-58052\";i:57293;s:12:\"delete-58055\";i:57294;s:12:\"delete-58056\";i:57295;s:12:\"delete-58053\";i:57296;s:12:\"delete-58054\";i:57297;s:12:\"delete-58057\";i:57298;s:12:\"delete-58060\";i:57299;s:12:\"delete-58058\";i:57300;s:12:\"delete-58059\";i:57301;s:12:\"delete-58061\";i:57302;s:12:\"delete-58062\";i:57303;s:12:\"delete-58065\";i:57304;s:12:\"delete-58066\";i:57305;s:12:\"delete-58063\";i:57306;s:12:\"delete-58064\";i:57307;s:12:\"delete-58067\";i:57308;s:12:\"delete-58070\";i:57309;s:12:\"delete-58071\";i:57310;s:12:\"delete-58068\";i:57311;s:12:\"delete-58069\";i:57312;s:12:\"delete-58072\";i:57313;s:12:\"delete-58075\";i:57314;s:12:\"delete-58076\";i:57315;s:12:\"delete-58073\";i:57316;s:12:\"delete-58074\";i:57317;s:12:\"delete-58077\";i:57318;s:12:\"delete-58080\";i:57319;s:12:\"delete-58081\";i:57320;s:12:\"delete-58078\";i:57321;s:12:\"delete-58079\";i:57322;s:12:\"delete-58082\";i:57323;s:12:\"delete-58083\";i:57324;s:12:\"delete-58084\";i:57325;s:12:\"delete-58085\";i:57326;s:12:\"delete-58086\";i:57327;s:12:\"delete-58087\";i:57328;s:12:\"delete-58090\";i:57329;s:12:\"delete-58091\";i:57330;s:12:\"delete-58088\";i:57331;s:12:\"delete-58089\";i:57332;s:12:\"delete-58092\";i:57333;s:12:\"delete-58095\";i:57334;s:12:\"delete-58093\";i:57335;s:12:\"delete-58094\";i:57336;s:12:\"delete-58096\";i:57337;s:12:\"delete-58097\";i:57338;s:12:\"delete-58100\";i:57339;s:12:\"delete-58098\";i:57340;s:12:\"delete-58099\";i:57341;s:12:\"delete-58101\";i:57342;s:12:\"delete-58102\";i:57343;s:12:\"delete-58105\";i:57344;s:12:\"delete-58106\";i:57345;s:12:\"delete-58103\";i:57346;s:12:\"delete-58104\";i:57347;s:12:\"delete-58107\";i:57348;s:12:\"delete-58110\";i:57349;s:12:\"delete-58108\";i:57350;s:12:\"delete-58109\";i:57351;s:12:\"delete-58111\";i:57352;s:12:\"delete-58112\";i:57353;s:12:\"delete-58115\";i:57354;s:12:\"delete-58116\";i:57355;s:12:\"delete-58113\";i:57356;s:12:\"delete-58114\";i:57357;s:12:\"delete-58117\";i:57358;s:12:\"delete-58120\";i:57359;s:12:\"delete-58121\";i:57360;s:12:\"delete-58118\";i:57361;s:12:\"delete-58119\";i:57362;s:12:\"delete-58122\";i:57363;s:12:\"delete-58123\";i:57364;s:12:\"delete-58124\";i:57365;s:12:\"delete-58125\";i:57366;s:12:\"delete-58126\";i:57367;s:12:\"delete-58127\";i:57368;s:12:\"delete-58130\";i:57369;s:12:\"delete-58131\";i:57370;s:12:\"delete-58128\";i:57371;s:12:\"delete-58129\";i:57372;s:12:\"delete-58132\";i:57373;s:12:\"delete-58135\";i:57374;s:12:\"delete-58136\";i:57375;s:12:\"delete-58133\";i:57376;s:12:\"delete-58134\";i:57377;s:12:\"delete-58137\";i:57378;s:12:\"delete-58140\";i:57379;s:12:\"delete-58141\";i:57380;s:12:\"delete-58138\";i:57381;s:12:\"delete-58139\";i:57382;s:12:\"delete-58142\";i:57383;s:12:\"delete-58145\";i:57384;s:12:\"delete-58146\";i:57385;s:12:\"delete-58143\";i:57386;s:12:\"delete-58144\";i:57387;s:12:\"delete-58147\";i:57388;s:12:\"delete-58150\";i:57389;s:12:\"delete-58151\";i:57390;s:12:\"delete-58148\";i:57391;s:12:\"delete-58149\";i:57392;s:12:\"delete-58152\";i:57393;s:12:\"delete-58155\";i:57394;s:12:\"delete-58156\";i:57395;s:12:\"delete-58153\";i:57396;s:12:\"delete-58154\";i:57397;s:12:\"delete-58157\";i:57398;s:12:\"delete-58160\";i:57399;s:12:\"delete-58161\";i:57400;s:12:\"delete-58158\";i:57401;s:12:\"delete-58159\";i:57402;s:12:\"delete-58162\";i:57403;s:12:\"delete-58165\";i:57404;s:12:\"delete-58166\";i:57405;s:12:\"delete-58163\";i:57406;s:12:\"delete-58164\";i:57407;s:12:\"delete-58167\";i:57408;s:12:\"delete-58170\";i:57409;s:12:\"delete-58171\";i:57410;s:12:\"delete-58168\";i:57411;s:12:\"delete-58169\";i:57412;s:12:\"delete-58172\";i:57413;s:12:\"delete-58175\";i:57414;s:12:\"delete-58176\";i:57415;s:12:\"delete-58173\";i:57416;s:12:\"delete-58174\";i:57417;s:12:\"delete-58177\";i:57418;s:12:\"delete-58180\";i:57419;s:12:\"delete-58178\";i:57420;s:12:\"delete-58179\";i:57421;s:12:\"delete-58181\";i:57422;s:12:\"delete-58182\";i:57423;s:12:\"delete-58185\";i:57424;s:12:\"delete-58186\";i:57425;s:12:\"delete-58183\";i:57426;s:12:\"delete-58184\";i:57427;s:12:\"delete-58187\";i:57428;s:12:\"delete-58190\";i:57429;s:12:\"delete-58191\";i:57430;s:12:\"delete-58188\";i:57431;s:12:\"delete-58189\";i:57432;s:12:\"delete-58192\";i:57433;s:12:\"delete-58195\";i:57434;s:12:\"delete-58193\";i:57435;s:12:\"delete-58194\";i:57436;s:12:\"delete-58196\";i:57437;s:12:\"delete-58197\";i:57438;s:12:\"delete-58200\";i:57439;s:12:\"delete-58201\";i:57440;s:12:\"delete-58198\";i:57441;s:12:\"delete-58199\";i:57442;s:12:\"delete-58202\";i:57443;s:12:\"delete-58205\";i:57444;s:12:\"delete-58206\";i:57445;s:12:\"delete-58203\";i:57446;s:12:\"delete-58204\";i:57447;s:12:\"delete-58207\";i:57448;s:12:\"delete-58210\";i:57449;s:12:\"delete-58208\";i:57450;s:12:\"delete-58209\";i:57451;s:12:\"delete-58211\";i:57452;s:12:\"delete-58212\";i:57453;s:12:\"delete-58215\";i:57454;s:12:\"delete-58216\";i:57455;s:12:\"delete-58213\";i:57456;s:12:\"delete-58214\";i:57457;s:12:\"delete-58217\";i:57458;s:12:\"delete-58220\";i:57459;s:12:\"delete-58218\";i:57460;s:12:\"delete-58219\";i:57461;s:12:\"delete-58221\";i:57462;s:12:\"delete-58222\";i:57463;s:12:\"delete-58225\";i:57464;s:12:\"delete-58226\";i:57465;s:12:\"delete-58223\";i:57466;s:12:\"delete-58224\";i:57467;s:12:\"delete-58227\";i:57468;s:12:\"delete-58230\";i:57469;s:12:\"delete-58231\";i:57470;s:12:\"delete-58228\";i:57471;s:12:\"delete-58229\";i:57472;s:12:\"delete-58232\";i:57473;s:12:\"delete-58235\";i:57474;s:12:\"delete-58233\";i:57475;s:12:\"delete-58234\";i:57476;s:12:\"delete-58236\";i:57477;s:12:\"delete-58237\";i:57478;s:12:\"delete-58240\";i:57479;s:12:\"delete-58241\";i:57480;s:12:\"delete-58238\";i:57481;s:12:\"delete-58239\";i:57482;s:12:\"delete-58242\";i:57483;s:12:\"delete-58245\";i:57484;s:12:\"delete-58246\";i:57485;s:12:\"delete-58243\";i:57486;s:12:\"delete-58244\";i:57487;s:12:\"delete-58247\";i:57488;s:12:\"delete-58250\";i:57489;s:12:\"delete-58251\";i:57490;s:12:\"delete-58248\";i:57491;s:12:\"delete-58249\";i:57492;s:12:\"delete-58252\";i:57493;s:12:\"delete-58255\";i:57494;s:12:\"delete-58253\";i:57495;s:12:\"delete-58254\";i:57496;s:12:\"delete-58256\";i:57497;s:12:\"delete-58257\";i:57498;s:12:\"delete-58260\";i:57499;s:12:\"delete-58261\";i:57500;s:12:\"delete-58258\";i:57501;s:12:\"delete-58259\";i:57502;s:12:\"delete-58262\";i:57503;s:12:\"delete-58265\";i:57504;s:12:\"delete-58266\";i:57505;s:12:\"delete-58263\";i:57506;s:12:\"delete-58264\";i:57507;s:12:\"delete-58267\";i:57508;s:12:\"delete-58270\";i:57509;s:12:\"delete-58271\";i:57510;s:12:\"delete-58268\";i:57511;s:12:\"delete-58269\";i:57512;s:12:\"delete-58272\";i:57513;s:12:\"delete-58275\";i:57514;s:12:\"delete-58276\";i:57515;s:12:\"delete-58273\";i:57516;s:12:\"delete-58274\";i:57517;s:12:\"delete-58277\";i:57518;s:12:\"delete-58280\";i:57519;s:12:\"delete-58281\";i:57520;s:12:\"delete-58278\";i:57521;s:12:\"delete-58279\";i:57522;s:12:\"delete-58282\";i:57523;s:12:\"delete-58285\";i:57524;s:12:\"delete-58286\";i:57525;s:12:\"delete-58283\";i:57526;s:12:\"delete-58284\";i:57527;s:12:\"delete-58287\";i:57528;s:12:\"delete-58290\";i:57529;s:12:\"delete-58291\";i:57530;s:12:\"delete-58288\";i:57531;s:12:\"delete-58289\";i:57532;s:12:\"delete-58292\";i:57533;s:12:\"delete-58295\";i:57534;s:12:\"delete-58296\";i:57535;s:12:\"delete-58293\";i:57536;s:12:\"delete-58294\";i:57537;s:12:\"delete-58297\";i:57538;s:12:\"delete-58300\";i:57539;s:12:\"delete-58298\";i:57540;s:12:\"delete-58299\";i:57541;s:12:\"delete-58301\";i:57542;s:12:\"delete-58302\";i:57543;s:12:\"delete-58305\";i:57544;s:12:\"delete-58306\";i:57545;s:12:\"delete-58303\";i:57546;s:12:\"delete-58304\";i:57547;s:12:\"delete-58307\";i:57548;s:12:\"delete-58310\";i:57549;s:12:\"delete-58308\";i:57550;s:12:\"delete-58309\";i:57551;s:12:\"delete-58311\";i:57552;s:12:\"delete-58312\";i:57553;s:12:\"delete-58315\";i:57554;s:12:\"delete-58316\";i:57555;s:12:\"delete-58313\";i:57556;s:12:\"delete-58314\";i:57557;s:12:\"delete-58317\";i:57558;s:12:\"delete-58320\";i:57559;s:12:\"delete-58318\";i:57560;s:12:\"delete-58319\";i:57561;s:12:\"delete-58321\";i:57562;s:12:\"delete-58322\";i:57563;s:12:\"delete-58325\";i:57564;s:12:\"delete-58326\";i:57565;s:12:\"delete-58323\";i:57566;s:12:\"delete-58324\";i:57567;s:12:\"delete-58327\";i:57568;s:12:\"delete-58330\";i:57569;s:12:\"delete-58331\";i:57570;s:12:\"delete-58328\";i:57571;s:12:\"delete-58329\";i:57572;s:12:\"delete-58332\";i:57573;s:12:\"delete-58335\";i:57574;s:12:\"delete-58336\";i:57575;s:12:\"delete-58333\";i:57576;s:12:\"delete-58334\";i:57577;s:12:\"delete-58337\";i:57578;s:12:\"delete-58338\";i:57579;s:12:\"delete-58339\";i:57580;s:12:\"delete-58340\";i:57581;s:12:\"delete-58341\";i:57582;s:12:\"delete-58342\";i:57583;s:12:\"delete-58345\";i:57584;s:12:\"delete-58346\";i:57585;s:12:\"delete-58343\";i:57586;s:12:\"delete-58344\";i:57587;s:12:\"delete-58347\";i:57588;s:12:\"delete-58350\";i:57589;s:12:\"delete-58351\";i:57590;s:12:\"delete-58348\";i:57591;s:12:\"delete-58349\";i:57592;s:12:\"delete-58352\";i:57593;s:12:\"delete-58355\";i:57594;s:12:\"delete-58356\";i:57595;s:12:\"delete-58353\";i:57596;s:12:\"delete-58354\";i:57597;s:12:\"delete-58357\";i:57598;s:12:\"delete-58360\";i:57599;s:12:\"delete-58361\";i:57600;s:12:\"delete-58362\";i:57601;s:12:\"delete-58365\";i:57602;s:12:\"delete-58366\";i:57603;s:12:\"delete-58358\";i:57604;s:12:\"delete-58359\";i:57605;s:12:\"delete-58363\";i:57606;s:12:\"delete-58364\";i:57607;s:12:\"delete-58367\";i:57608;s:12:\"delete-58370\";i:57609;s:12:\"delete-58371\";i:57610;s:12:\"delete-58368\";i:57611;s:12:\"delete-58369\";i:57612;s:12:\"delete-58372\";i:57613;s:12:\"delete-58375\";i:57614;s:12:\"delete-58376\";i:57615;s:12:\"delete-58373\";i:57616;s:12:\"delete-58374\";i:57617;s:12:\"delete-58377\";i:57618;s:12:\"delete-58380\";i:57619;s:12:\"delete-58378\";i:57620;s:12:\"delete-58379\";i:57621;s:12:\"delete-58381\";i:57622;s:12:\"delete-58382\";i:57623;s:12:\"delete-58385\";i:57624;s:12:\"delete-58386\";i:57625;s:12:\"delete-58383\";i:57626;s:12:\"delete-58384\";i:57627;s:12:\"delete-58387\";i:57628;s:12:\"delete-58390\";i:57629;s:12:\"delete-58391\";i:57630;s:12:\"delete-58388\";i:57631;s:12:\"delete-58389\";i:57632;s:12:\"delete-58392\";i:57633;s:12:\"delete-58395\";i:57634;s:12:\"delete-58396\";i:57635;s:12:\"delete-58393\";i:57636;s:12:\"delete-58394\";i:57637;s:12:\"delete-58397\";i:57638;s:12:\"delete-58400\";i:57639;s:12:\"delete-58398\";i:57640;s:12:\"delete-58399\";i:57641;s:12:\"delete-58401\";i:57642;s:12:\"delete-58402\";i:57643;s:12:\"delete-58405\";i:57644;s:12:\"delete-58406\";i:57645;s:12:\"delete-58403\";i:57646;s:12:\"delete-58404\";i:57647;s:12:\"delete-58407\";i:57648;s:12:\"delete-58410\";i:57649;s:12:\"delete-58408\";i:57650;s:12:\"delete-58409\";i:57651;s:12:\"delete-58411\";i:57652;s:12:\"delete-58412\";i:57653;s:12:\"delete-58415\";i:57654;s:12:\"delete-58416\";i:57655;s:12:\"delete-58413\";i:57656;s:12:\"delete-58414\";i:57657;s:12:\"delete-58417\";i:57658;s:12:\"delete-58420\";i:57659;s:12:\"delete-58421\";i:57660;s:12:\"delete-58418\";i:57661;s:12:\"delete-58419\";i:57662;s:12:\"delete-58422\";i:57663;s:12:\"delete-58425\";i:57664;s:12:\"delete-58423\";i:57665;s:12:\"delete-58424\";i:57666;s:12:\"delete-58426\";i:57667;s:12:\"delete-58427\";i:57668;s:12:\"delete-58430\";i:57669;s:12:\"delete-58428\";i:57670;s:12:\"delete-58429\";i:57671;s:12:\"delete-58431\";i:57672;s:12:\"delete-58432\";i:57673;s:12:\"delete-58435\";i:57674;s:12:\"delete-58436\";i:57675;s:12:\"delete-58433\";i:57676;s:12:\"delete-58434\";i:57677;s:12:\"delete-58437\";i:57678;s:12:\"delete-58440\";i:57679;s:12:\"delete-58438\";i:57680;s:12:\"delete-58439\";i:57681;s:12:\"delete-58441\";i:57682;s:12:\"delete-58442\";i:57683;s:12:\"delete-58445\";i:57684;s:12:\"delete-58443\";i:57685;s:12:\"delete-58444\";i:57686;s:12:\"delete-58446\";i:57687;s:12:\"delete-58447\";i:57688;s:12:\"delete-58450\";i:57689;s:12:\"delete-58448\";i:57690;s:12:\"delete-58449\";i:57691;s:12:\"delete-58451\";i:57692;s:12:\"delete-58452\";i:57693;s:12:\"delete-58455\";i:57694;s:12:\"delete-58456\";i:57695;s:12:\"delete-58453\";i:57696;s:12:\"delete-58454\";i:57697;s:12:\"delete-58457\";i:57698;s:12:\"delete-58460\";i:57699;s:12:\"delete-58461\";i:57700;s:12:\"delete-58458\";i:57701;s:12:\"delete-58459\";i:57702;s:12:\"delete-58462\";i:57703;s:12:\"delete-58465\";i:57704;s:12:\"delete-58463\";i:57705;s:12:\"delete-58464\";i:57706;s:12:\"delete-58466\";i:57707;s:12:\"delete-58467\";i:57708;s:12:\"delete-58470\";i:57709;s:12:\"delete-58471\";i:57710;s:12:\"delete-58468\";i:57711;s:12:\"delete-58469\";i:57712;s:12:\"delete-58472\";i:57713;s:12:\"delete-58475\";i:57714;s:12:\"delete-58473\";i:57715;s:12:\"delete-58474\";i:57716;s:12:\"delete-58476\";i:57717;s:12:\"delete-58477\";i:57718;s:12:\"delete-58480\";i:57719;s:12:\"delete-58481\";i:57720;s:12:\"delete-58478\";i:57721;s:12:\"delete-58479\";i:57722;s:12:\"delete-58482\";i:57723;s:12:\"delete-58485\";i:57724;s:12:\"delete-58486\";i:57725;s:12:\"delete-58483\";i:57726;s:12:\"delete-58484\";i:57727;s:12:\"delete-58487\";i:57728;s:12:\"delete-58490\";i:57729;s:12:\"delete-58488\";i:57730;s:12:\"delete-58489\";i:57731;s:12:\"delete-58491\";i:57732;s:12:\"delete-58492\";i:57733;s:12:\"delete-58495\";i:57734;s:12:\"delete-58496\";i:57735;s:12:\"delete-58493\";i:57736;s:12:\"delete-58494\";i:57737;s:12:\"delete-58497\";i:57738;s:12:\"delete-58500\";i:57739;s:12:\"delete-58501\";i:57740;s:12:\"delete-58498\";i:57741;s:12:\"delete-58499\";i:57742;s:12:\"delete-58502\";i:57743;s:12:\"delete-58505\";i:57744;s:12:\"delete-58503\";i:57745;s:12:\"delete-58504\";i:57746;s:12:\"delete-58506\";i:57747;s:12:\"delete-58507\";i:57748;s:12:\"delete-58510\";i:57749;s:12:\"delete-58511\";i:57750;s:12:\"delete-58508\";i:57751;s:12:\"delete-58509\";i:57752;s:12:\"delete-58512\";i:57753;s:12:\"delete-58515\";i:57754;s:12:\"delete-58513\";i:57755;s:12:\"delete-58514\";i:57756;s:12:\"delete-58516\";i:57757;s:12:\"delete-58517\";i:57758;s:12:\"delete-58520\";i:57759;s:12:\"delete-58518\";i:57760;s:12:\"delete-58519\";i:57761;s:12:\"delete-58521\";i:57762;s:12:\"delete-58522\";i:57763;s:12:\"delete-58525\";i:57764;s:12:\"delete-58523\";i:57765;s:12:\"delete-58524\";i:57766;s:12:\"delete-58526\";i:57767;s:12:\"delete-58527\";i:57768;s:12:\"delete-58530\";i:57769;s:12:\"delete-58531\";i:57770;s:12:\"delete-58528\";i:57771;s:12:\"delete-58529\";i:57772;s:12:\"delete-58532\";i:57773;s:12:\"delete-58535\";i:57774;s:12:\"delete-58533\";i:57775;s:12:\"delete-58534\";i:57776;s:12:\"delete-58536\";i:57777;s:12:\"delete-58537\";i:57778;s:12:\"delete-58540\";i:57779;s:12:\"delete-58538\";i:57780;s:12:\"delete-58539\";i:57781;s:12:\"delete-58541\";i:57782;s:12:\"delete-58542\";i:57783;s:12:\"delete-58545\";i:57784;s:12:\"delete-58543\";i:57785;s:12:\"delete-58544\";i:57786;s:12:\"delete-58546\";i:57787;s:12:\"delete-58547\";i:57788;s:12:\"delete-58550\";i:57789;s:12:\"delete-58551\";i:57790;s:12:\"delete-58548\";i:57791;s:12:\"delete-58549\";i:57792;s:12:\"delete-58552\";i:57793;s:12:\"delete-58555\";i:57794;s:12:\"delete-58556\";i:57795;s:12:\"delete-58553\";i:57796;s:12:\"delete-58554\";i:57797;s:12:\"delete-58557\";i:57798;s:12:\"delete-58560\";i:57799;s:12:\"delete-58558\";i:57800;s:12:\"delete-58559\";i:57801;s:12:\"delete-58561\";i:57802;s:12:\"delete-58562\";i:57803;s:12:\"delete-58565\";i:57804;s:12:\"delete-58566\";i:57805;s:12:\"delete-58563\";i:57806;s:12:\"delete-58564\";i:57807;s:12:\"delete-58567\";i:57808;s:12:\"delete-58570\";i:57809;s:12:\"delete-58571\";i:57810;s:12:\"delete-58568\";i:57811;s:12:\"delete-58569\";i:57812;s:12:\"delete-58572\";i:57813;s:12:\"delete-58575\";i:57814;s:12:\"delete-58573\";i:57815;s:12:\"delete-58574\";i:57816;s:12:\"delete-58576\";i:57817;s:12:\"delete-58577\";i:57818;s:12:\"delete-58580\";i:57819;s:12:\"delete-58581\";i:57820;s:12:\"delete-58578\";i:57821;s:12:\"delete-58579\";i:57822;s:12:\"delete-58582\";i:57823;s:12:\"delete-58585\";i:57824;s:12:\"delete-58586\";i:57825;s:12:\"delete-58583\";i:57826;s:12:\"delete-58584\";i:57827;s:12:\"delete-58587\";i:57828;s:12:\"delete-58590\";i:57829;s:12:\"delete-58591\";i:57830;s:12:\"delete-58588\";i:57831;s:12:\"delete-58589\";i:57832;s:12:\"delete-58592\";i:57833;s:12:\"delete-58595\";i:57834;s:12:\"delete-58593\";i:57835;s:12:\"delete-58594\";i:57836;s:12:\"delete-58596\";i:57837;s:12:\"delete-58597\";i:57838;s:12:\"delete-58600\";i:57839;s:12:\"delete-58601\";i:57840;s:12:\"delete-58598\";i:57841;s:12:\"delete-58599\";i:57842;s:12:\"delete-58602\";i:57843;s:12:\"delete-58605\";i:57844;s:12:\"delete-58606\";i:57845;s:12:\"delete-58603\";i:57846;s:12:\"delete-58604\";i:57847;s:12:\"delete-58607\";i:57848;s:12:\"delete-58610\";i:57849;s:12:\"delete-58611\";i:57850;s:12:\"delete-58608\";i:57851;s:12:\"delete-58609\";i:57852;s:12:\"delete-58612\";i:57853;s:12:\"delete-58615\";i:57854;s:12:\"delete-58616\";i:57855;s:12:\"delete-58613\";i:57856;s:12:\"delete-58614\";i:57857;s:12:\"delete-58617\";i:57858;s:12:\"delete-58620\";i:57859;s:12:\"delete-58618\";i:57860;s:12:\"delete-58619\";i:57861;s:12:\"delete-58621\";i:57862;s:12:\"delete-58624\";i:57863;s:12:\"delete-58625\";i:57864;s:12:\"delete-58622\";i:57865;s:12:\"delete-58623\";i:57866;s:12:\"delete-58626\";i:57867;s:12:\"delete-58629\";i:57868;s:12:\"delete-58627\";i:57869;s:12:\"delete-58628\";i:57870;s:12:\"delete-58630\";i:57871;s:12:\"delete-58631\";i:57872;s:12:\"delete-58634\";i:57873;s:12:\"delete-58635\";i:57874;s:12:\"delete-58632\";i:57875;s:12:\"delete-58633\";i:57876;s:12:\"delete-58636\";i:57877;s:12:\"delete-58639\";i:57878;s:12:\"delete-58640\";i:57879;s:12:\"delete-58637\";i:57880;s:12:\"delete-58638\";i:57881;s:12:\"delete-58641\";i:57882;s:12:\"delete-58644\";i:57883;s:12:\"delete-58642\";i:57884;s:12:\"delete-58643\";i:57885;s:12:\"delete-58645\";i:57886;s:12:\"delete-58646\";i:57887;s:12:\"delete-58649\";i:57888;s:12:\"delete-58650\";i:57889;s:12:\"delete-58647\";i:57890;s:12:\"delete-58648\";i:57891;s:12:\"delete-58651\";i:57892;s:12:\"delete-58654\";i:57893;s:12:\"delete-58655\";i:57894;s:12:\"delete-58652\";i:57895;s:12:\"delete-58653\";i:57896;s:12:\"delete-58656\";i:57897;s:12:\"delete-58659\";i:57898;s:12:\"delete-58660\";i:57899;s:12:\"delete-58657\";i:57900;s:12:\"delete-58658\";i:57901;s:12:\"delete-58661\";i:57902;s:12:\"delete-58664\";i:57903;s:12:\"delete-58662\";i:57904;s:12:\"delete-58663\";i:57905;s:12:\"delete-58665\";i:57906;s:12:\"delete-58666\";i:57907;s:12:\"delete-58669\";i:57908;s:12:\"delete-58670\";i:57909;s:12:\"delete-58667\";i:57910;s:12:\"delete-58668\";i:57911;s:12:\"delete-58671\";i:57912;s:12:\"delete-58674\";i:57913;s:12:\"delete-58675\";i:57914;s:12:\"delete-58672\";i:57915;s:12:\"delete-58673\";i:57916;s:12:\"delete-58676\";i:57917;s:12:\"delete-58679\";i:57918;s:12:\"delete-58677\";i:57919;s:12:\"delete-58678\";i:57920;s:12:\"delete-58680\";i:57921;s:12:\"delete-58681\";i:57922;s:12:\"delete-58684\";i:57923;s:12:\"delete-58685\";i:57924;s:12:\"delete-58682\";i:57925;s:12:\"delete-58683\";i:57926;s:12:\"delete-58686\";i:57927;s:12:\"delete-58689\";i:57928;s:12:\"delete-58690\";i:57929;s:12:\"delete-58687\";i:57930;s:12:\"delete-58688\";i:57931;s:12:\"delete-58691\";i:57932;s:12:\"delete-58694\";i:57933;s:12:\"delete-58692\";i:57934;s:12:\"delete-58693\";i:57935;s:12:\"delete-58695\";i:57936;s:12:\"delete-58696\";i:57937;s:12:\"delete-58699\";i:57938;s:12:\"delete-58700\";i:57939;s:12:\"delete-58697\";i:57940;s:12:\"delete-58698\";i:57941;s:12:\"delete-58701\";i:57942;s:12:\"delete-58704\";i:57943;s:12:\"delete-58705\";i:57944;s:12:\"delete-58702\";i:57945;s:12:\"delete-58703\";i:57946;s:12:\"delete-58706\";i:57947;s:12:\"delete-58709\";i:57948;s:12:\"delete-58710\";i:57949;s:12:\"delete-58707\";i:57950;s:12:\"delete-58708\";i:57951;s:12:\"delete-58711\";i:57952;s:12:\"delete-58714\";i:57953;s:12:\"delete-58715\";i:57954;s:12:\"delete-58712\";i:57955;s:12:\"delete-58713\";i:57956;s:12:\"delete-58716\";i:57957;s:12:\"delete-58719\";i:57958;s:12:\"delete-58720\";i:57959;s:12:\"delete-58717\";i:57960;s:12:\"delete-58718\";i:57961;s:12:\"delete-58721\";i:57962;s:12:\"delete-58724\";i:57963;s:12:\"delete-58725\";i:57964;s:12:\"delete-58722\";i:57965;s:12:\"delete-58723\";i:57966;s:12:\"delete-58726\";i:57967;s:12:\"delete-58729\";i:57968;s:12:\"delete-58730\";i:57969;s:12:\"delete-58727\";i:57970;s:12:\"delete-58728\";i:57971;s:12:\"delete-58731\";i:57972;s:12:\"delete-58734\";i:57973;s:12:\"delete-58732\";i:57974;s:12:\"delete-58733\";i:57975;s:12:\"delete-58735\";i:57976;s:12:\"delete-58736\";i:57977;s:12:\"delete-58739\";i:57978;s:12:\"delete-58740\";i:57979;s:12:\"delete-58737\";i:57980;s:12:\"delete-58738\";i:57981;s:12:\"delete-58741\";i:57982;s:12:\"delete-58744\";i:57983;s:12:\"delete-58745\";i:57984;s:12:\"delete-58742\";i:57985;s:12:\"delete-58743\";i:57986;s:12:\"delete-58746\";i:57987;s:12:\"delete-58749\";i:57988;s:12:\"delete-58747\";i:57989;s:12:\"delete-58748\";i:57990;s:12:\"delete-58750\";i:57991;s:12:\"delete-58751\";i:57992;s:12:\"delete-58754\";i:57993;s:12:\"delete-58755\";i:57994;s:12:\"delete-58752\";i:57995;s:12:\"delete-58753\";i:57996;s:12:\"delete-58756\";i:57997;s:12:\"delete-58759\";i:57998;s:12:\"delete-58760\";i:57999;s:12:\"delete-58757\";i:58000;s:12:\"delete-58758\";i:58001;s:12:\"delete-58761\";i:58002;s:12:\"delete-58764\";i:58003;s:12:\"delete-58765\";i:58004;s:12:\"delete-58762\";i:58005;s:12:\"delete-58763\";i:58006;s:12:\"delete-58766\";i:58007;s:12:\"delete-58769\";i:58008;s:12:\"delete-58770\";i:58009;s:12:\"delete-58767\";i:58010;s:12:\"delete-58768\";i:58011;s:12:\"delete-58771\";i:58012;s:12:\"delete-58774\";i:58013;s:12:\"delete-58775\";i:58014;s:12:\"delete-58772\";i:58015;s:12:\"delete-58773\";i:58016;s:12:\"delete-58776\";i:58017;s:12:\"delete-58779\";i:58018;s:12:\"delete-58777\";i:58019;s:12:\"delete-58778\";i:58020;s:12:\"delete-58780\";i:58021;s:12:\"delete-58781\";i:58022;s:12:\"delete-58784\";i:58023;s:12:\"delete-58785\";i:58024;s:12:\"delete-58782\";i:58025;s:12:\"delete-58783\";i:58026;s:12:\"delete-58786\";i:58027;s:12:\"delete-58789\";i:58028;s:12:\"delete-58790\";i:58029;s:12:\"delete-58787\";i:58030;s:12:\"delete-58788\";i:58031;s:12:\"delete-58791\";i:58032;s:12:\"delete-58794\";i:58033;s:12:\"delete-58795\";i:58034;s:12:\"delete-58792\";i:58035;s:12:\"delete-58793\";i:58036;s:12:\"delete-58796\";i:58037;s:12:\"delete-58799\";i:58038;s:12:\"delete-58800\";i:58039;s:12:\"delete-58797\";i:58040;s:12:\"delete-58798\";i:58041;s:12:\"delete-58801\";i:58042;s:12:\"delete-58804\";i:58043;s:12:\"delete-58802\";i:58044;s:12:\"delete-58803\";i:58045;s:12:\"delete-58805\";i:58046;s:12:\"delete-58806\";i:58047;s:12:\"delete-58809\";i:58048;s:12:\"delete-58807\";i:58049;s:12:\"delete-58808\";i:58050;s:12:\"delete-58810\";i:58051;s:12:\"delete-58811\";i:58052;s:12:\"delete-58814\";i:58053;s:12:\"delete-58812\";i:58054;s:12:\"delete-58813\";i:58055;s:12:\"delete-58815\";i:58056;s:12:\"delete-58816\";i:58057;s:12:\"delete-58819\";i:58058;s:12:\"delete-58820\";i:58059;s:12:\"delete-58817\";i:58060;s:12:\"delete-58818\";i:58061;s:12:\"delete-58821\";i:58062;s:12:\"delete-58824\";i:58063;s:12:\"delete-58825\";i:58064;s:12:\"delete-58822\";i:58065;s:12:\"delete-58823\";i:58066;s:12:\"delete-58826\";i:58067;s:12:\"delete-58829\";i:58068;s:12:\"delete-58830\";i:58069;s:12:\"delete-58827\";i:58070;s:12:\"delete-58828\";i:58071;s:12:\"delete-58831\";i:58072;s:12:\"delete-58834\";i:58073;s:12:\"delete-58835\";i:58074;s:12:\"delete-58832\";i:58075;s:12:\"delete-58833\";i:58076;s:12:\"delete-58836\";i:58077;s:12:\"delete-58839\";i:58078;s:12:\"delete-58840\";i:58079;s:12:\"delete-58837\";i:58080;s:12:\"delete-58838\";i:58081;s:12:\"delete-58841\";i:58082;s:12:\"delete-58844\";i:58083;s:12:\"delete-58842\";i:58084;s:12:\"delete-58843\";i:58085;s:12:\"delete-58845\";i:58086;s:12:\"delete-58846\";i:58087;s:12:\"delete-58849\";i:58088;s:12:\"delete-58850\";i:58089;s:12:\"delete-58847\";i:58090;s:12:\"delete-58848\";i:58091;s:12:\"delete-58851\";i:58092;s:12:\"delete-58854\";i:58093;s:12:\"delete-58855\";i:58094;s:12:\"delete-58852\";i:58095;s:12:\"delete-58853\";i:58096;s:12:\"delete-58856\";i:58097;s:12:\"delete-58859\";i:58098;s:12:\"delete-58860\";i:58099;s:12:\"delete-58857\";i:58100;s:12:\"delete-58858\";i:58101;s:12:\"delete-58861\";i:58102;s:12:\"delete-58864\";i:58103;s:12:\"delete-58862\";i:58104;s:12:\"delete-58863\";i:58105;s:12:\"delete-58865\";i:58106;s:12:\"delete-58866\";i:58107;s:12:\"delete-58869\";i:58108;s:12:\"delete-58870\";i:58109;s:12:\"delete-58867\";i:58110;s:12:\"delete-58868\";i:58111;s:12:\"delete-58871\";i:58112;s:12:\"delete-58874\";i:58113;s:12:\"delete-58875\";i:58114;s:12:\"delete-58872\";i:58115;s:12:\"delete-58873\";i:58116;s:12:\"delete-58876\";i:58117;s:12:\"delete-58879\";i:58118;s:12:\"delete-58880\";i:58119;s:12:\"delete-58877\";i:58120;s:12:\"delete-58878\";i:58121;s:12:\"delete-58881\";i:58122;s:12:\"delete-58884\";i:58123;s:12:\"delete-58885\";i:58124;s:12:\"delete-58882\";i:58125;s:12:\"delete-58883\";i:58126;s:12:\"delete-58886\";i:58127;s:12:\"delete-58889\";i:58128;s:12:\"delete-58890\";i:58129;s:12:\"delete-58887\";i:58130;s:12:\"delete-58888\";i:58131;s:12:\"delete-58891\";i:58132;s:12:\"delete-58894\";i:58133;s:12:\"delete-58892\";i:58134;s:12:\"delete-58893\";i:58135;s:12:\"delete-58895\";i:58136;s:12:\"delete-58896\";i:58137;s:12:\"delete-58899\";i:58138;s:12:\"delete-58900\";i:58139;s:12:\"delete-58897\";i:58140;s:12:\"delete-58898\";i:58141;s:12:\"delete-58901\";i:58142;s:12:\"delete-58904\";i:58143;s:12:\"delete-58905\";i:58144;s:12:\"delete-58902\";i:58145;s:12:\"delete-58903\";i:58146;s:12:\"delete-58906\";i:58147;s:12:\"delete-58909\";i:58148;s:12:\"delete-58907\";i:58149;s:12:\"delete-58908\";i:58150;s:12:\"delete-58910\";i:58151;s:12:\"delete-58911\";i:58152;s:12:\"delete-58914\";i:58153;s:12:\"delete-58912\";i:58154;s:12:\"delete-58913\";i:58155;s:12:\"delete-58915\";i:58156;s:12:\"delete-58916\";i:58157;s:12:\"delete-58919\";i:58158;s:12:\"delete-58920\";i:58159;s:12:\"delete-58917\";i:58160;s:12:\"delete-58918\";i:58161;s:12:\"delete-58921\";i:58162;s:12:\"delete-58924\";i:58163;s:12:\"delete-58925\";i:58164;s:12:\"delete-58922\";i:58165;s:12:\"delete-58923\";i:58166;s:12:\"delete-58926\";i:58167;s:12:\"delete-58929\";i:58168;s:12:\"delete-58930\";i:58169;s:12:\"delete-58927\";i:58170;s:12:\"delete-58928\";i:58171;s:12:\"delete-58931\";i:58172;s:12:\"delete-58934\";i:58173;s:12:\"delete-58935\";i:58174;s:12:\"delete-58932\";i:58175;s:12:\"delete-58933\";i:58176;s:12:\"delete-58936\";i:58177;s:12:\"delete-58937\";i:58178;s:12:\"delete-58938\";i:58179;s:12:\"delete-58939\";i:58180;s:12:\"delete-58940\";i:58181;s:12:\"delete-58941\";i:58182;s:12:\"delete-58944\";i:58183;s:12:\"delete-58945\";i:58184;s:12:\"delete-58942\";i:58185;s:12:\"delete-58943\";i:58186;s:12:\"delete-58946\";i:58187;s:12:\"delete-58949\";i:58188;s:12:\"delete-58950\";i:58189;s:12:\"delete-58947\";i:58190;s:12:\"delete-58948\";i:58191;s:12:\"delete-58951\";i:58192;s:12:\"delete-58954\";i:58193;s:12:\"delete-58955\";i:58194;s:12:\"delete-58952\";i:58195;s:12:\"delete-58953\";i:58196;s:12:\"delete-58956\";i:58197;s:12:\"delete-58959\";i:58198;s:12:\"delete-58960\";i:58199;s:12:\"delete-58957\";i:58200;s:12:\"delete-58958\";i:58201;s:12:\"delete-58961\";i:58202;s:12:\"delete-58964\";i:58203;s:12:\"delete-58965\";i:58204;s:12:\"delete-58962\";i:58205;s:12:\"delete-58963\";i:58206;s:12:\"delete-58966\";i:58207;s:12:\"delete-58969\";i:58208;s:12:\"delete-58970\";i:58209;s:12:\"delete-58967\";i:58210;s:12:\"delete-58968\";i:58211;s:12:\"delete-58971\";i:58212;s:12:\"delete-58974\";i:58213;s:12:\"delete-58972\";i:58214;s:12:\"delete-58973\";i:58215;s:12:\"delete-58975\";i:58216;s:12:\"delete-58976\";i:58217;s:12:\"delete-58979\";i:58218;s:12:\"delete-58980\";i:58219;s:12:\"delete-58977\";i:58220;s:12:\"delete-58978\";i:58221;s:12:\"delete-58981\";i:58222;s:12:\"delete-58984\";i:58223;s:12:\"delete-58985\";i:58224;s:12:\"delete-58982\";i:58225;s:12:\"delete-58983\";i:58226;s:12:\"delete-58986\";i:58227;s:12:\"delete-58989\";i:58228;s:12:\"delete-58990\";i:58229;s:12:\"delete-58987\";i:58230;s:12:\"delete-58988\";i:58231;s:12:\"delete-58991\";i:58232;s:12:\"delete-58994\";i:58233;s:12:\"delete-58995\";i:58234;s:12:\"delete-58992\";i:58235;s:12:\"delete-58993\";i:58236;s:12:\"delete-58996\";i:58237;s:12:\"delete-58999\";i:58238;s:12:\"delete-58997\";i:58239;s:12:\"delete-58998\";i:58240;s:12:\"delete-59000\";i:58241;s:12:\"delete-59001\";i:58242;s:12:\"delete-59004\";i:58243;s:12:\"delete-59005\";i:58244;s:12:\"delete-59002\";i:58245;s:12:\"delete-59003\";i:58246;s:12:\"delete-59006\";i:58247;s:12:\"delete-59009\";i:58248;s:12:\"delete-59010\";i:58249;s:12:\"delete-59007\";i:58250;s:12:\"delete-59008\";i:58251;s:12:\"delete-59011\";i:58252;s:12:\"delete-59014\";i:58253;s:12:\"delete-59015\";i:58254;s:12:\"delete-59012\";i:58255;s:12:\"delete-59013\";i:58256;s:12:\"delete-59016\";i:58257;s:12:\"delete-59019\";i:58258;s:12:\"delete-59017\";i:58259;s:12:\"delete-59018\";i:58260;s:12:\"delete-59020\";i:58261;s:12:\"delete-59021\";i:58262;s:12:\"delete-59024\";i:58263;s:12:\"delete-59025\";i:58264;s:12:\"delete-59022\";i:58265;s:12:\"delete-59023\";i:58266;s:12:\"delete-59026\";i:58267;s:12:\"delete-59029\";i:58268;s:12:\"delete-59027\";i:58269;s:12:\"delete-59028\";i:58270;s:12:\"delete-59030\";i:58271;s:12:\"delete-59031\";i:58272;s:12:\"delete-59034\";i:58273;s:12:\"delete-59035\";i:58274;s:12:\"delete-59032\";i:58275;s:12:\"delete-59033\";i:58276;s:12:\"delete-59036\";i:58277;s:12:\"delete-59039\";i:58278;s:12:\"delete-59040\";i:58279;s:12:\"delete-59037\";i:58280;s:12:\"delete-59038\";i:58281;s:12:\"delete-59041\";i:58282;s:12:\"delete-59044\";i:58283;s:12:\"delete-59042\";i:58284;s:12:\"delete-59043\";i:58285;s:12:\"delete-59045\";i:58286;s:12:\"delete-59046\";i:58287;s:12:\"delete-59049\";i:58288;s:12:\"delete-59050\";i:58289;s:12:\"delete-59047\";i:58290;s:12:\"delete-59048\";i:58291;s:12:\"delete-59051\";i:58292;s:12:\"delete-59052\";i:58293;s:12:\"delete-59053\";i:58294;s:12:\"delete-59054\";i:58295;s:12:\"delete-59055\";i:58296;s:12:\"delete-59056\";i:58297;s:12:\"delete-59057\";i:58298;s:12:\"delete-59058\";i:58299;s:12:\"delete-59059\";i:58300;s:12:\"delete-59060\";i:58301;s:12:\"delete-59061\";i:58302;s:12:\"delete-59064\";i:58303;s:12:\"delete-59065\";i:58304;s:12:\"delete-59062\";i:58305;s:12:\"delete-59063\";i:58306;s:12:\"delete-59066\";i:58307;s:12:\"delete-59069\";i:58308;s:12:\"delete-59067\";i:58309;s:12:\"delete-59068\";i:58310;s:12:\"delete-59070\";i:58311;s:12:\"delete-59071\";i:58312;s:12:\"delete-59074\";i:58313;s:12:\"delete-59075\";i:58314;s:12:\"delete-59072\";i:58315;s:12:\"delete-59073\";i:58316;s:12:\"delete-59076\";i:58317;s:12:\"delete-59079\";i:58318;s:12:\"delete-59080\";i:58319;s:12:\"delete-59077\";i:58320;s:12:\"delete-59078\";i:58321;s:12:\"delete-59081\";i:58322;s:12:\"delete-59082\";i:58323;s:12:\"delete-59083\";i:58324;s:12:\"delete-59084\";i:58325;s:12:\"delete-59085\";i:58326;s:12:\"delete-59086\";i:58327;s:12:\"delete-59089\";i:58328;s:12:\"delete-59087\";i:58329;s:12:\"delete-59088\";i:58330;s:12:\"delete-59090\";i:58331;s:12:\"delete-59091\";i:58332;s:12:\"delete-59094\";i:58333;s:12:\"delete-59092\";i:58334;s:12:\"delete-59093\";i:58335;s:12:\"delete-59095\";i:58336;s:12:\"delete-59096\";i:58337;s:12:\"delete-59099\";i:58338;s:12:\"delete-59100\";i:58339;s:12:\"delete-59097\";i:58340;s:12:\"delete-59098\";i:58341;s:12:\"delete-59101\";i:58342;s:12:\"delete-59104\";i:58343;s:12:\"delete-59105\";i:58344;s:12:\"delete-59102\";i:58345;s:12:\"delete-59103\";i:58346;s:12:\"delete-59106\";i:58347;s:12:\"delete-59109\";i:58348;s:12:\"delete-59110\";i:58349;s:12:\"delete-59107\";i:58350;s:12:\"delete-59108\";i:58351;s:12:\"delete-59111\";i:58352;s:12:\"delete-59114\";i:58353;s:12:\"delete-59115\";i:58354;s:12:\"delete-59112\";i:58355;s:12:\"delete-59113\";i:58356;s:12:\"delete-59116\";i:58357;s:12:\"delete-59119\";i:58358;s:12:\"delete-59120\";i:58359;s:12:\"delete-59117\";i:58360;s:12:\"delete-59118\";i:58361;s:12:\"delete-59121\";i:58362;s:12:\"delete-59124\";i:58363;s:12:\"delete-59125\";i:58364;s:12:\"delete-59122\";i:58365;s:12:\"delete-59123\";i:58366;s:12:\"delete-59126\";i:58367;s:12:\"delete-59129\";i:58368;s:12:\"delete-59130\";i:58369;s:12:\"delete-59127\";i:58370;s:12:\"delete-59128\";i:58371;s:12:\"delete-59131\";i:58372;s:12:\"delete-59134\";i:58373;s:12:\"delete-59135\";i:58374;s:12:\"delete-59132\";i:58375;s:12:\"delete-59133\";i:58376;s:12:\"delete-59136\";i:58377;s:12:\"delete-59139\";i:58378;s:12:\"delete-59140\";i:58379;s:12:\"delete-59137\";i:58380;s:12:\"delete-59138\";i:58381;s:12:\"delete-59141\";i:58382;s:12:\"delete-59144\";i:58383;s:12:\"delete-59145\";i:58384;s:12:\"delete-59142\";i:58385;s:12:\"delete-59143\";i:58386;s:12:\"delete-59146\";i:58387;s:12:\"delete-59149\";i:58388;s:12:\"delete-59147\";i:58389;s:12:\"delete-59148\";i:58390;s:12:\"delete-59150\";i:58391;s:12:\"delete-59151\";i:58392;s:12:\"delete-59154\";i:58393;s:12:\"delete-59155\";i:58394;s:12:\"delete-59156\";i:58395;s:12:\"delete-59159\";i:58396;s:12:\"delete-59152\";i:58397;s:12:\"delete-59153\";i:58398;s:12:\"delete-59157\";i:58399;s:12:\"delete-59158\";i:58400;s:12:\"delete-59160\";i:58401;s:12:\"delete-59161\";i:58402;s:12:\"delete-59164\";i:58403;s:12:\"delete-59162\";i:58404;s:12:\"delete-59163\";i:58405;s:12:\"delete-59165\";i:58406;s:12:\"delete-59166\";i:58407;s:12:\"delete-59169\";i:58408;s:12:\"delete-59170\";i:58409;s:12:\"delete-59167\";i:58410;s:12:\"delete-59168\";i:58411;s:12:\"delete-59171\";i:58412;s:12:\"delete-59174\";i:58413;s:12:\"delete-59175\";i:58414;s:12:\"delete-59172\";i:58415;s:12:\"delete-59173\";i:58416;s:12:\"delete-59176\";i:58417;s:12:\"delete-59179\";i:58418;s:12:\"delete-59180\";i:58419;s:12:\"delete-59177\";i:58420;s:12:\"delete-59178\";i:58421;s:12:\"delete-59181\";i:58422;s:12:\"delete-59184\";i:58423;s:12:\"delete-59182\";i:58424;s:12:\"delete-59183\";i:58425;s:12:\"delete-59185\";i:58426;s:12:\"delete-59186\";i:58427;s:12:\"delete-59189\";i:58428;s:12:\"delete-59190\";i:58429;s:12:\"delete-59187\";i:58430;s:12:\"delete-59188\";i:58431;s:12:\"delete-59191\";i:58432;s:12:\"delete-59194\";i:58433;s:12:\"delete-59192\";i:58434;s:12:\"delete-59193\";i:58435;s:12:\"delete-59195\";i:58436;s:12:\"delete-59196\";i:58437;s:12:\"delete-59199\";i:58438;s:12:\"delete-59200\";i:58439;s:12:\"delete-59197\";i:58440;s:12:\"delete-59198\";i:58441;s:12:\"delete-59201\";i:58442;s:12:\"delete-59204\";i:58443;s:12:\"delete-59205\";i:58444;s:12:\"delete-59202\";i:58445;s:12:\"delete-59203\";i:58446;s:12:\"delete-59206\";i:58447;s:12:\"delete-59209\";i:58448;s:12:\"delete-59210\";i:58449;s:12:\"delete-59207\";i:58450;s:12:\"delete-59208\";i:58451;s:12:\"delete-59211\";i:58452;s:12:\"delete-59214\";i:58453;s:12:\"delete-59215\";i:58454;s:12:\"delete-59212\";i:58455;s:12:\"delete-59213\";i:58456;s:12:\"delete-59216\";i:58457;s:12:\"delete-59219\";i:58458;s:12:\"delete-59217\";i:58459;s:12:\"delete-59218\";i:58460;s:12:\"delete-59220\";i:58461;s:12:\"delete-59221\";i:58462;s:12:\"delete-59224\";i:58463;s:12:\"delete-59225\";i:58464;s:12:\"delete-59222\";i:58465;s:12:\"delete-59223\";i:58466;s:12:\"delete-59226\";i:58467;s:12:\"delete-59229\";i:58468;s:12:\"delete-59230\";i:58469;s:12:\"delete-59227\";i:58470;s:12:\"delete-59228\";i:58471;s:12:\"delete-59231\";i:58472;s:12:\"delete-59234\";i:58473;s:12:\"delete-59232\";i:58474;s:12:\"delete-59233\";i:58475;s:12:\"delete-59235\";i:58476;s:12:\"delete-59236\";i:58477;s:12:\"delete-59239\";i:58478;s:12:\"delete-59240\";i:58479;s:12:\"delete-59237\";i:58480;s:12:\"delete-59238\";i:58481;s:12:\"delete-59241\";i:58482;s:12:\"delete-59244\";i:58483;s:12:\"delete-59245\";i:58484;s:12:\"delete-59242\";i:58485;s:12:\"delete-59243\";i:58486;s:12:\"delete-59246\";i:58487;s:12:\"delete-59249\";i:58488;s:12:\"delete-59250\";i:58489;s:12:\"delete-59247\";i:58490;s:12:\"delete-59248\";i:58491;s:12:\"delete-59251\";i:58492;s:12:\"delete-59254\";i:58493;s:12:\"delete-59255\";i:58494;s:12:\"delete-59252\";i:58495;s:12:\"delete-59253\";i:58496;s:12:\"delete-59256\";i:58497;s:12:\"delete-59259\";i:58498;s:12:\"delete-59257\";i:58499;s:12:\"delete-59258\";i:58500;s:12:\"delete-59260\";i:58501;s:12:\"delete-59263\";i:58502;s:12:\"delete-59264\";i:58503;s:12:\"delete-59261\";i:58504;s:12:\"delete-59262\";i:58505;s:12:\"delete-59265\";i:58506;s:12:\"delete-59268\";i:58507;s:12:\"delete-59266\";i:58508;s:12:\"delete-59267\";i:58509;s:12:\"delete-59269\";i:58510;s:12:\"delete-59270\";i:58511;s:12:\"delete-59273\";i:58512;s:12:\"delete-59274\";i:58513;s:12:\"delete-59271\";i:58514;s:12:\"delete-59272\";i:58515;s:12:\"delete-59275\";i:58516;s:12:\"delete-59278\";i:58517;s:12:\"delete-59276\";i:58518;s:12:\"delete-59277\";i:58519;s:12:\"delete-59279\";i:58520;s:12:\"delete-59280\";i:58521;s:12:\"delete-59283\";i:58522;s:12:\"delete-59284\";i:58523;s:12:\"delete-59281\";i:58524;s:12:\"delete-59282\";i:58525;s:12:\"delete-59285\";i:58526;s:12:\"delete-59288\";i:58527;s:12:\"delete-59289\";i:58528;s:12:\"delete-59286\";i:58529;s:12:\"delete-59287\";i:58530;s:12:\"delete-59290\";i:58531;s:12:\"delete-59293\";i:58532;s:12:\"delete-59291\";i:58533;s:12:\"delete-59292\";i:58534;s:12:\"delete-59294\";i:58535;s:12:\"delete-59295\";i:58536;s:12:\"delete-59296\";i:58537;s:12:\"delete-59297\";i:58538;s:12:\"delete-59298\";i:58539;s:12:\"delete-59299\";i:58540;s:12:\"delete-59300\";i:58541;s:12:\"delete-59303\";i:58542;s:12:\"delete-59304\";i:58543;s:12:\"delete-59301\";i:58544;s:12:\"delete-59302\";i:58545;s:12:\"delete-59305\";i:58546;s:12:\"delete-59308\";i:58547;s:12:\"delete-59309\";i:58548;s:12:\"delete-59306\";i:58549;s:12:\"delete-59307\";i:58550;s:12:\"delete-59310\";i:58551;s:12:\"delete-59313\";i:58552;s:12:\"delete-59311\";i:58553;s:12:\"delete-59312\";i:58554;s:12:\"delete-59314\";i:58555;s:12:\"delete-59315\";i:58556;s:12:\"delete-59318\";i:58557;s:12:\"delete-59316\";i:58558;s:12:\"delete-59317\";i:58559;s:12:\"delete-59319\";i:58560;s:12:\"delete-59320\";i:58561;s:12:\"delete-59321\";i:58562;s:12:\"delete-59322\";i:58563;s:12:\"delete-59323\";i:58564;s:12:\"delete-59324\";i:58565;s:12:\"delete-59325\";i:58566;s:12:\"delete-59328\";i:58567;s:12:\"delete-59329\";i:58568;s:12:\"delete-59326\";i:58569;s:12:\"delete-59327\";i:58570;s:12:\"delete-59330\";i:58571;s:12:\"delete-59333\";i:58572;s:12:\"delete-59334\";i:58573;s:12:\"delete-59331\";i:58574;s:12:\"delete-59332\";i:58575;s:12:\"delete-59335\";i:58576;s:12:\"delete-59336\";i:58577;s:12:\"delete-59337\";i:58578;s:12:\"delete-59338\";i:58579;s:12:\"delete-59339\";i:58580;s:12:\"delete-59340\";i:58581;s:12:\"delete-59343\";i:58582;s:12:\"delete-59344\";i:58583;s:12:\"delete-59341\";i:58584;s:12:\"delete-59342\";i:58585;s:12:\"delete-59345\";i:58586;s:12:\"delete-59348\";i:58587;s:12:\"delete-59349\";i:58588;s:12:\"delete-59346\";i:58589;s:12:\"delete-59347\";i:58590;s:12:\"delete-59350\";i:58591;s:12:\"delete-59353\";i:58592;s:12:\"delete-59354\";i:58593;s:12:\"delete-59351\";i:58594;s:12:\"delete-59352\";i:58595;s:12:\"delete-59355\";i:58596;s:12:\"delete-59358\";i:58597;s:12:\"delete-59359\";i:58598;s:12:\"delete-59356\";i:58599;s:12:\"delete-59357\";i:58600;s:12:\"delete-59360\";i:58601;s:12:\"delete-59363\";i:58602;s:12:\"delete-59361\";i:58603;s:12:\"delete-59362\";i:58604;s:12:\"delete-59364\";i:58605;s:12:\"delete-59365\";i:58606;s:12:\"delete-59368\";i:58607;s:12:\"delete-59369\";i:58608;s:12:\"delete-59366\";i:58609;s:12:\"delete-59367\";i:58610;s:12:\"delete-59370\";i:58611;s:12:\"delete-59373\";i:58612;s:12:\"delete-59374\";i:58613;s:12:\"delete-59371\";i:58614;s:12:\"delete-59372\";i:58615;s:12:\"delete-59375\";i:58616;s:12:\"delete-59378\";i:58617;s:12:\"delete-59379\";i:58618;s:12:\"delete-59376\";i:58619;s:12:\"delete-59377\";i:58620;s:12:\"delete-59380\";i:58621;s:12:\"delete-59383\";i:58622;s:12:\"delete-59381\";i:58623;s:12:\"delete-59382\";i:58624;s:12:\"delete-59384\";i:58625;s:12:\"delete-59385\";i:58626;s:12:\"delete-59388\";i:58627;s:12:\"delete-59389\";i:58628;s:12:\"delete-59386\";i:58629;s:12:\"delete-59387\";i:58630;s:12:\"delete-59390\";i:58631;s:12:\"delete-59393\";i:58632;s:12:\"delete-59394\";i:58633;s:12:\"delete-59391\";i:58634;s:12:\"delete-59392\";i:58635;s:12:\"delete-59395\";i:58636;s:12:\"delete-59398\";i:58637;s:12:\"delete-59399\";i:58638;s:12:\"delete-59396\";i:58639;s:12:\"delete-59397\";i:58640;s:12:\"delete-59400\";i:58641;s:12:\"delete-59403\";i:58642;s:12:\"delete-59404\";i:58643;s:12:\"delete-59401\";i:58644;s:12:\"delete-59402\";i:58645;s:12:\"delete-59405\";i:58646;s:12:\"delete-59408\";i:58647;s:12:\"delete-59409\";i:58648;s:12:\"delete-59406\";i:58649;s:12:\"delete-59407\";i:58650;s:12:\"delete-59410\";i:58651;s:12:\"delete-59413\";i:58652;s:12:\"delete-59414\";i:58653;s:12:\"delete-59411\";i:58654;s:12:\"delete-59412\";i:58655;s:12:\"delete-59415\";i:58656;s:12:\"delete-59418\";i:58657;s:12:\"delete-59419\";i:58658;s:12:\"delete-59416\";i:58659;s:12:\"delete-59417\";i:58660;s:12:\"delete-59420\";i:58661;s:12:\"delete-59421\";i:58662;s:12:\"delete-59422\";i:58663;s:12:\"delete-59423\";i:58664;s:12:\"delete-59424\";i:58665;s:12:\"delete-59425\";i:58666;s:12:\"delete-59428\";i:58667;s:12:\"delete-59429\";i:58668;s:12:\"delete-59426\";i:58669;s:12:\"delete-59427\";i:58670;s:12:\"delete-59430\";i:58671;s:12:\"delete-59433\";i:58672;s:12:\"delete-59434\";i:58673;s:12:\"delete-59431\";i:58674;s:12:\"delete-59432\";i:58675;s:12:\"delete-59435\";i:58676;s:12:\"delete-59438\";i:58677;s:12:\"delete-59439\";i:58678;s:12:\"delete-59436\";i:58679;s:12:\"delete-59437\";i:58680;s:12:\"delete-59440\";i:58681;s:12:\"delete-59443\";i:58682;s:12:\"delete-59444\";i:58683;s:12:\"delete-59441\";i:58684;s:12:\"delete-59442\";i:58685;s:12:\"delete-59445\";i:58686;s:12:\"delete-59448\";i:58687;s:12:\"delete-59449\";i:58688;s:12:\"delete-59446\";i:58689;s:12:\"delete-59447\";i:58690;s:12:\"delete-59450\";i:58691;s:12:\"delete-59453\";i:58692;s:12:\"delete-59451\";i:58693;s:12:\"delete-59452\";i:58694;s:12:\"delete-59454\";i:58695;s:12:\"delete-59455\";i:58696;s:12:\"delete-59456\";i:58697;s:12:\"delete-59457\";i:58698;s:12:\"delete-59458\";i:58699;s:12:\"delete-59459\";i:58700;s:12:\"delete-59460\";i:58701;s:12:\"delete-59463\";i:58702;s:12:\"delete-59464\";i:58703;s:12:\"delete-59461\";i:58704;s:12:\"delete-59462\";i:58705;s:12:\"delete-59465\";i:58706;s:12:\"delete-59468\";i:58707;s:12:\"delete-59469\";i:58708;s:12:\"delete-59466\";i:58709;s:12:\"delete-59467\";i:58710;s:12:\"delete-59470\";i:58711;s:12:\"delete-59473\";i:58712;s:12:\"delete-59474\";i:58713;s:12:\"delete-59471\";i:58714;s:12:\"delete-59472\";i:58715;s:12:\"delete-59475\";i:58716;s:12:\"delete-59478\";i:58717;s:12:\"delete-59479\";i:58718;s:12:\"delete-59476\";i:58719;s:12:\"delete-59477\";i:58720;s:12:\"delete-59480\";i:58721;s:12:\"delete-59483\";i:58722;s:12:\"delete-59484\";i:58723;s:12:\"delete-59481\";i:58724;s:12:\"delete-59482\";i:58725;s:12:\"delete-59485\";i:58726;s:12:\"delete-59488\";i:58727;s:12:\"delete-59486\";i:58728;s:12:\"delete-59487\";i:58729;s:12:\"delete-59489\";i:58730;s:12:\"delete-59490\";i:58731;s:12:\"delete-59493\";i:58732;s:12:\"delete-59494\";i:58733;s:12:\"delete-59491\";i:58734;s:12:\"delete-59492\";i:58735;s:12:\"delete-59495\";i:58736;s:12:\"delete-59498\";i:58737;s:12:\"delete-59499\";i:58738;s:12:\"delete-59496\";i:58739;s:12:\"delete-59497\";i:58740;s:12:\"delete-59500\";i:58741;s:12:\"delete-59503\";i:58742;s:12:\"delete-59504\";i:58743;s:12:\"delete-59501\";i:58744;s:12:\"delete-59502\";i:58745;s:12:\"delete-59505\";i:58746;s:12:\"delete-59508\";i:58747;s:12:\"delete-59506\";i:58748;s:12:\"delete-59507\";i:58749;s:12:\"delete-59509\";i:58750;s:12:\"delete-59510\";i:58751;s:12:\"delete-59513\";i:58752;s:12:\"delete-59514\";i:58753;s:12:\"delete-59511\";i:58754;s:12:\"delete-59512\";i:58755;s:12:\"delete-59515\";i:58756;s:12:\"delete-59518\";i:58757;s:12:\"delete-59519\";i:58758;s:12:\"delete-59516\";i:58759;s:12:\"delete-59517\";i:58760;s:12:\"delete-59520\";i:58761;s:12:\"delete-59523\";i:58762;s:12:\"delete-59524\";i:58763;s:12:\"delete-59521\";i:58764;s:12:\"delete-59522\";i:58765;s:12:\"delete-59525\";i:58766;s:12:\"delete-59528\";i:58767;s:12:\"delete-59529\";i:58768;s:12:\"delete-59526\";i:58769;s:12:\"delete-59527\";i:58770;s:12:\"delete-59530\";i:58771;s:12:\"delete-59533\";i:58772;s:12:\"delete-59534\";i:58773;s:12:\"delete-59531\";i:58774;s:12:\"delete-59532\";i:58775;s:12:\"delete-59535\";i:58776;s:12:\"delete-59538\";i:58777;s:12:\"delete-59539\";i:58778;s:12:\"delete-59536\";i:58779;s:12:\"delete-59537\";i:58780;s:12:\"delete-59540\";i:58781;s:12:\"delete-59543\";i:58782;s:12:\"delete-59544\";i:58783;s:12:\"delete-59541\";i:58784;s:12:\"delete-59542\";i:58785;s:12:\"delete-59545\";i:58786;s:12:\"delete-59548\";i:58787;s:12:\"delete-59549\";i:58788;s:12:\"delete-59546\";i:58789;s:12:\"delete-59547\";i:58790;s:12:\"delete-59550\";i:58791;s:12:\"delete-59553\";i:58792;s:12:\"delete-59554\";i:58793;s:12:\"delete-59551\";i:58794;s:12:\"delete-59552\";i:58795;s:12:\"delete-59555\";i:58796;s:12:\"delete-59558\";i:58797;s:12:\"delete-59559\";i:58798;s:12:\"delete-59556\";i:58799;s:12:\"delete-59557\";i:58800;s:12:\"delete-59560\";i:58801;s:12:\"delete-59563\";i:58802;s:12:\"delete-59564\";i:58803;s:12:\"delete-59561\";i:58804;s:12:\"delete-59562\";i:58805;s:12:\"delete-59565\";i:58806;s:12:\"delete-59568\";i:58807;s:12:\"delete-59569\";i:58808;s:12:\"delete-59566\";i:58809;s:12:\"delete-59567\";i:58810;s:12:\"delete-59570\";i:58811;s:12:\"delete-59573\";i:58812;s:12:\"delete-59574\";i:58813;s:12:\"delete-59571\";i:58814;s:12:\"delete-59572\";i:58815;s:12:\"delete-59575\";i:58816;s:12:\"delete-59578\";i:58817;s:12:\"delete-59576\";i:58818;s:12:\"delete-59577\";i:58819;s:12:\"delete-59579\";i:58820;s:12:\"delete-59582\";i:58821;s:12:\"delete-59583\";i:58822;s:12:\"delete-59580\";i:58823;s:12:\"delete-59581\";i:58824;s:12:\"delete-59584\";i:58825;s:12:\"delete-59587\";i:58826;s:12:\"delete-59588\";i:58827;s:12:\"delete-59585\";i:58828;s:12:\"delete-59586\";i:58829;s:12:\"delete-59589\";i:58830;s:12:\"delete-59592\";i:58831;s:12:\"delete-59593\";i:58832;s:12:\"delete-59590\";i:58833;s:12:\"delete-59591\";i:58834;s:12:\"delete-59594\";i:58835;s:12:\"delete-59597\";i:58836;s:12:\"delete-59598\";i:58837;s:12:\"delete-59595\";i:58838;s:12:\"delete-59596\";i:58839;s:12:\"delete-59599\";i:58840;s:12:\"delete-59602\";i:58841;s:12:\"delete-59603\";i:58842;s:12:\"delete-59600\";i:58843;s:12:\"delete-59601\";i:58844;s:12:\"delete-59604\";i:58845;s:12:\"delete-59607\";i:58846;s:12:\"delete-59608\";i:58847;s:12:\"delete-59605\";i:58848;s:12:\"delete-59606\";i:58849;s:12:\"delete-59609\";i:58850;s:12:\"delete-59612\";i:58851;s:12:\"delete-59610\";i:58852;s:12:\"delete-59611\";i:58853;s:12:\"delete-59613\";i:58854;s:12:\"delete-59614\";i:58855;s:12:\"delete-59617\";i:58856;s:12:\"delete-59618\";i:58857;s:12:\"delete-59615\";i:58858;s:12:\"delete-59616\";i:58859;s:12:\"delete-59619\";i:58860;s:12:\"delete-59622\";i:58861;s:12:\"delete-59623\";i:58862;s:12:\"delete-59620\";i:58863;s:12:\"delete-59621\";i:58864;s:12:\"delete-59624\";i:58865;s:12:\"delete-59627\";i:58866;s:12:\"delete-59628\";i:58867;s:12:\"delete-59625\";i:58868;s:12:\"delete-59626\";i:58869;s:12:\"delete-59629\";i:58870;s:12:\"delete-59632\";i:58871;s:12:\"delete-59633\";i:58872;s:12:\"delete-59630\";i:58873;s:12:\"delete-59631\";i:58874;s:12:\"delete-59634\";i:58875;s:12:\"delete-59637\";i:58876;s:12:\"delete-59638\";i:58877;s:12:\"delete-59635\";i:58878;s:12:\"delete-59636\";i:58879;s:12:\"delete-59639\";i:58880;s:12:\"delete-59642\";i:58881;s:12:\"delete-59643\";i:58882;s:12:\"delete-59640\";i:58883;s:12:\"delete-59641\";i:58884;s:12:\"delete-59644\";i:58885;s:12:\"delete-59647\";i:58886;s:12:\"delete-59648\";i:58887;s:12:\"delete-59645\";i:58888;s:12:\"delete-59646\";i:58889;s:12:\"delete-59649\";i:58890;s:12:\"delete-59652\";i:58891;s:12:\"delete-59653\";i:58892;s:12:\"delete-59650\";i:58893;s:12:\"delete-59651\";i:58894;s:12:\"delete-59654\";i:58895;s:12:\"delete-59657\";i:58896;s:12:\"delete-59658\";i:58897;s:12:\"delete-59655\";i:58898;s:12:\"delete-59656\";i:58899;s:12:\"delete-59659\";i:58900;s:12:\"delete-59662\";i:58901;s:12:\"delete-59663\";i:58902;s:12:\"delete-59660\";i:58903;s:12:\"delete-59661\";i:58904;s:12:\"delete-59664\";i:58905;s:12:\"delete-59667\";i:58906;s:12:\"delete-59668\";i:58907;s:12:\"delete-59665\";i:58908;s:12:\"delete-59666\";i:58909;s:12:\"delete-59669\";i:58910;s:12:\"delete-59672\";i:58911;s:12:\"delete-59673\";i:58912;s:12:\"delete-59670\";i:58913;s:12:\"delete-59671\";i:58914;s:12:\"delete-59674\";i:58915;s:12:\"delete-59677\";i:58916;s:12:\"delete-59675\";i:58917;s:12:\"delete-59676\";i:58918;s:12:\"delete-59678\";i:58919;s:12:\"delete-59679\";i:58920;s:12:\"delete-59682\";i:58921;s:12:\"delete-59680\";i:58922;s:12:\"delete-59681\";i:58923;s:12:\"delete-59683\";i:58924;s:12:\"delete-59684\";i:58925;s:12:\"delete-59687\";i:58926;s:12:\"delete-59688\";i:58927;s:12:\"delete-59685\";i:58928;s:12:\"delete-59686\";i:58929;s:12:\"delete-59689\";i:58930;s:12:\"delete-59692\";i:58931;s:12:\"delete-59693\";i:58932;s:12:\"delete-59690\";i:58933;s:12:\"delete-59691\";i:58934;s:12:\"delete-59694\";i:58935;s:12:\"delete-59697\";i:58936;s:12:\"delete-59698\";i:58937;s:12:\"delete-59695\";i:58938;s:12:\"delete-59696\";i:58939;s:12:\"delete-59699\";i:58940;s:12:\"delete-59702\";i:58941;s:12:\"delete-59703\";i:58942;s:12:\"delete-59700\";i:58943;s:12:\"delete-59701\";i:58944;s:12:\"delete-59704\";i:58945;s:12:\"delete-59707\";i:58946;s:12:\"delete-59708\";i:58947;s:12:\"delete-59705\";i:58948;s:12:\"delete-59706\";i:58949;s:12:\"delete-59709\";i:58950;s:12:\"delete-59712\";i:58951;s:12:\"delete-59713\";i:58952;s:12:\"delete-59710\";i:58953;s:12:\"delete-59711\";i:58954;s:12:\"delete-59714\";i:58955;s:12:\"delete-59717\";i:58956;s:12:\"delete-59715\";i:58957;s:12:\"delete-59716\";i:58958;s:12:\"delete-59718\";i:58959;s:12:\"delete-59719\";i:58960;s:12:\"delete-59722\";i:58961;s:12:\"delete-59723\";i:58962;s:12:\"delete-59720\";i:58963;s:12:\"delete-59721\";i:58964;s:12:\"delete-59724\";i:58965;s:12:\"delete-59727\";i:58966;s:12:\"delete-59728\";i:58967;s:12:\"delete-59725\";i:58968;s:12:\"delete-59726\";i:58969;s:12:\"delete-59729\";i:58970;s:12:\"delete-59732\";i:58971;s:12:\"delete-59733\";i:58972;s:12:\"delete-59730\";i:58973;s:12:\"delete-59731\";i:58974;s:12:\"delete-59734\";i:58975;s:12:\"delete-59737\";i:58976;s:12:\"delete-59735\";i:58977;s:12:\"delete-59736\";i:58978;s:12:\"delete-59738\";i:58979;s:12:\"delete-59739\";i:58980;s:12:\"delete-59742\";i:58981;s:12:\"delete-59743\";i:58982;s:12:\"delete-59740\";i:58983;s:12:\"delete-59741\";i:58984;s:12:\"delete-59744\";i:58985;s:12:\"delete-59747\";i:58986;s:12:\"delete-59748\";i:58987;s:12:\"delete-59745\";i:58988;s:12:\"delete-59746\";i:58989;s:12:\"delete-59749\";i:58990;s:12:\"delete-59752\";i:58991;s:12:\"delete-59753\";i:58992;s:12:\"delete-59750\";i:58993;s:12:\"delete-59751\";i:58994;s:12:\"delete-59754\";i:58995;s:12:\"delete-59757\";i:58996;s:12:\"delete-59758\";i:58997;s:12:\"delete-59755\";i:58998;s:12:\"delete-59756\";i:58999;s:12:\"delete-59759\";i:59000;s:12:\"delete-59762\";i:59001;s:12:\"delete-59760\";i:59002;s:12:\"delete-59761\";i:59003;s:12:\"delete-59763\";i:59004;s:12:\"delete-59764\";i:59005;s:12:\"delete-59767\";i:59006;s:12:\"delete-59768\";i:59007;s:12:\"delete-59765\";i:59008;s:12:\"delete-59766\";i:59009;s:12:\"delete-59769\";i:59010;s:12:\"delete-59772\";i:59011;s:12:\"delete-59773\";i:59012;s:12:\"delete-59770\";i:59013;s:12:\"delete-59771\";i:59014;s:12:\"delete-59774\";i:59015;s:12:\"delete-59777\";i:59016;s:12:\"delete-59778\";i:59017;s:12:\"delete-59775\";i:59018;s:12:\"delete-59776\";i:59019;s:12:\"delete-59779\";i:59020;s:12:\"delete-59782\";i:59021;s:12:\"delete-59783\";i:59022;s:12:\"delete-59780\";i:59023;s:12:\"delete-59781\";i:59024;s:12:\"delete-59784\";i:59025;s:12:\"delete-59787\";i:59026;s:12:\"delete-59788\";i:59027;s:12:\"delete-59785\";i:59028;s:12:\"delete-59786\";i:59029;s:12:\"delete-59789\";i:59030;s:12:\"delete-59792\";i:59031;s:12:\"delete-59793\";i:59032;s:12:\"delete-59790\";i:59033;s:12:\"delete-59791\";i:59034;s:12:\"delete-59794\";i:59035;s:12:\"delete-59795\";i:59036;s:12:\"delete-59796\";i:59037;s:12:\"delete-59797\";i:59038;s:12:\"delete-59798\";i:59039;s:12:\"delete-59799\";i:59040;s:12:\"delete-59802\";i:59041;s:12:\"delete-59800\";i:59042;s:12:\"delete-59801\";i:59043;s:12:\"delete-59803\";i:59044;s:12:\"delete-59804\";i:59045;s:12:\"delete-59807\";i:59046;s:12:\"delete-59805\";i:59047;s:12:\"delete-59806\";i:59048;s:12:\"delete-59808\";i:59049;s:12:\"delete-59809\";i:59050;s:12:\"delete-59812\";i:59051;s:12:\"delete-59813\";i:59052;s:12:\"delete-59810\";i:59053;s:12:\"delete-59811\";i:59054;s:12:\"delete-59814\";i:59055;s:12:\"delete-59817\";i:59056;s:12:\"delete-59818\";i:59057;s:12:\"delete-59815\";i:59058;s:12:\"delete-59816\";i:59059;s:12:\"delete-59819\";i:59060;s:12:\"delete-59822\";i:59061;s:12:\"delete-59820\";i:59062;s:12:\"delete-59821\";i:59063;s:12:\"delete-59823\";i:59064;s:12:\"delete-59824\";i:59065;s:12:\"delete-59827\";i:59066;s:12:\"delete-59828\";i:59067;s:12:\"delete-59825\";i:59068;s:12:\"delete-59826\";i:59069;s:12:\"delete-59829\";i:59070;s:12:\"delete-59832\";i:59071;s:12:\"delete-59833\";i:59072;s:12:\"delete-59830\";i:59073;s:12:\"delete-59831\";i:59074;s:12:\"delete-59834\";i:59075;s:12:\"delete-59837\";i:59076;s:12:\"delete-59838\";i:59077;s:12:\"delete-59835\";i:59078;s:12:\"delete-59836\";i:59079;s:12:\"delete-59839\";i:59080;s:12:\"delete-59842\";i:59081;s:12:\"delete-59843\";i:59082;s:12:\"delete-59840\";i:59083;s:12:\"delete-59841\";i:59084;s:12:\"delete-59844\";i:59085;s:12:\"delete-59847\";i:59086;s:12:\"delete-59848\";i:59087;s:12:\"delete-59845\";i:59088;s:12:\"delete-59846\";i:59089;s:12:\"delete-59849\";i:59090;s:12:\"delete-59852\";i:59091;s:12:\"delete-59853\";i:59092;s:12:\"delete-59850\";i:59093;s:12:\"delete-59851\";i:59094;s:12:\"delete-59854\";i:59095;s:12:\"delete-59857\";i:59096;s:12:\"delete-59858\";i:59097;s:12:\"delete-59855\";i:59098;s:12:\"delete-59856\";i:59099;s:12:\"delete-59859\";i:59100;s:12:\"delete-59862\";i:59101;s:12:\"delete-59863\";i:59102;s:12:\"delete-59860\";i:59103;s:12:\"delete-59861\";i:59104;s:12:\"delete-59864\";i:59105;s:12:\"delete-59867\";i:59106;s:12:\"delete-59868\";i:59107;s:12:\"delete-59865\";i:59108;s:12:\"delete-59866\";i:59109;s:12:\"delete-59869\";i:59110;s:12:\"delete-59872\";i:59111;s:12:\"delete-59873\";i:59112;s:12:\"delete-59870\";i:59113;s:12:\"delete-59871\";i:59114;s:12:\"delete-59874\";i:59115;s:12:\"delete-59877\";i:59116;s:12:\"delete-59878\";i:59117;s:12:\"delete-59875\";i:59118;s:12:\"delete-59876\";i:59119;s:12:\"delete-59879\";i:59120;s:12:\"delete-59882\";i:59121;s:12:\"delete-59883\";i:59122;s:12:\"delete-59880\";i:59123;s:12:\"delete-59881\";i:59124;s:12:\"delete-59884\";i:59125;s:12:\"delete-59887\";i:59126;s:12:\"delete-59885\";i:59127;s:12:\"delete-59886\";i:59128;s:12:\"delete-59888\";i:59129;s:12:\"delete-59889\";i:59130;s:12:\"delete-59892\";i:59131;s:12:\"delete-59893\";i:59132;s:12:\"delete-59890\";i:59133;s:12:\"delete-59891\";i:59134;s:12:\"delete-59894\";i:59135;s:12:\"delete-59897\";i:59136;s:12:\"delete-59898\";i:59137;s:12:\"delete-59895\";i:59138;s:12:\"delete-59896\";i:59139;s:12:\"delete-59899\";i:59140;s:12:\"delete-59902\";i:59141;s:12:\"delete-59903\";i:59142;s:12:\"delete-59900\";i:59143;s:12:\"delete-59901\";i:59144;s:12:\"delete-59904\";i:59145;s:12:\"delete-59907\";i:59146;s:12:\"delete-59908\";i:59147;s:12:\"delete-59905\";i:59148;s:12:\"delete-59906\";i:59149;s:12:\"delete-59909\";i:59150;s:12:\"delete-59912\";i:59151;s:12:\"delete-59910\";i:59152;s:12:\"delete-59911\";i:59153;s:12:\"delete-59913\";i:59154;s:12:\"delete-59914\";i:59155;s:12:\"delete-59917\";i:59156;s:12:\"delete-59918\";i:59157;s:12:\"delete-59915\";i:59158;s:12:\"delete-59916\";i:59159;s:12:\"delete-59919\";i:59160;s:12:\"delete-59922\";i:59161;s:12:\"delete-59923\";i:59162;s:12:\"delete-59920\";i:59163;s:12:\"delete-59921\";i:59164;s:12:\"delete-59924\";i:59165;s:12:\"delete-59927\";i:59166;s:12:\"delete-59928\";i:59167;s:12:\"delete-59925\";i:59168;s:12:\"delete-59926\";i:59169;s:12:\"delete-59929\";i:59170;s:12:\"delete-59932\";i:59171;s:12:\"delete-59930\";i:59172;s:12:\"delete-59931\";i:59173;s:12:\"delete-59933\";i:59174;s:12:\"delete-59934\";i:59175;s:12:\"delete-59937\";i:59176;s:12:\"delete-59938\";i:59177;s:12:\"delete-59935\";i:59178;s:12:\"delete-59936\";i:59179;s:12:\"delete-59939\";i:59180;s:12:\"delete-59942\";i:59181;s:12:\"delete-59943\";i:59182;s:12:\"delete-59940\";i:59183;s:12:\"delete-59941\";i:59184;s:12:\"delete-59944\";i:59185;s:12:\"delete-59947\";i:59186;s:12:\"delete-59948\";i:59187;s:12:\"delete-59945\";i:59188;s:12:\"delete-59946\";i:59189;s:12:\"delete-59949\";i:59190;s:12:\"delete-59952\";i:59191;s:12:\"delete-59950\";i:59192;s:12:\"delete-59951\";i:59193;s:12:\"delete-59953\";i:59194;s:12:\"delete-59954\";i:59195;s:12:\"delete-59955\";i:59196;s:12:\"delete-59956\";i:59197;s:12:\"delete-59957\";i:59198;s:12:\"delete-59958\";i:59199;s:12:\"delete-59959\";i:59200;s:12:\"delete-59962\";i:59201;s:12:\"delete-59960\";i:59202;s:12:\"delete-59961\";i:59203;s:12:\"delete-59963\";i:59204;s:12:\"delete-59964\";i:59205;s:12:\"delete-59967\";i:59206;s:12:\"delete-59965\";i:59207;s:12:\"delete-59966\";i:59208;s:12:\"delete-59968\";i:59209;s:12:\"delete-59969\";i:59210;s:12:\"delete-59972\";i:59211;s:12:\"delete-59973\";i:59212;s:12:\"delete-59970\";i:59213;s:12:\"delete-59971\";i:59214;s:12:\"delete-59974\";i:59215;s:12:\"delete-59977\";i:59216;s:12:\"delete-59978\";i:59217;s:12:\"delete-59975\";i:59218;s:12:\"delete-59976\";i:59219;s:12:\"delete-59979\";i:59220;s:12:\"delete-59982\";i:59221;s:12:\"delete-59983\";i:59222;s:12:\"delete-59980\";i:59223;s:12:\"delete-59981\";i:59224;s:12:\"delete-59984\";i:59225;s:12:\"delete-59987\";i:59226;s:12:\"delete-59988\";i:59227;s:12:\"delete-59985\";i:59228;s:12:\"delete-59986\";i:59229;s:12:\"delete-59989\";i:59230;s:12:\"delete-59992\";i:59231;s:12:\"delete-59990\";i:59232;s:12:\"delete-59991\";i:59233;s:12:\"delete-59993\";i:59234;s:12:\"delete-59994\";i:59235;s:12:\"delete-59997\";i:59236;s:12:\"delete-59998\";i:59237;s:12:\"delete-59995\";i:59238;s:12:\"delete-59996\";i:59239;s:12:\"delete-59999\";i:59240;s:12:\"delete-60002\";i:59241;s:12:\"delete-60003\";i:59242;s:12:\"delete-60000\";i:59243;s:12:\"delete-60001\";i:59244;s:12:\"delete-60004\";i:59245;s:12:\"delete-60007\";i:59246;s:12:\"delete-60008\";i:59247;s:12:\"delete-60005\";i:59248;s:12:\"delete-60006\";i:59249;s:12:\"delete-60009\";i:59250;s:12:\"delete-60012\";i:59251;s:12:\"delete-60013\";i:59252;s:12:\"delete-60014\";i:59253;s:12:\"delete-60017\";i:59254;s:12:\"delete-60018\";i:59255;s:12:\"delete-60010\";i:59256;s:12:\"delete-60011\";i:59257;s:12:\"delete-60015\";i:59258;s:12:\"delete-60016\";i:59259;s:12:\"delete-60019\";i:59260;s:12:\"delete-60022\";i:59261;s:12:\"delete-60023\";i:59262;s:12:\"delete-60020\";i:59263;s:12:\"delete-60021\";i:59264;s:12:\"delete-60024\";i:59265;s:12:\"delete-60027\";i:59266;s:12:\"delete-60025\";i:59267;s:12:\"delete-60026\";i:59268;s:12:\"delete-60028\";i:59269;s:12:\"delete-60029\";i:59270;s:12:\"delete-60032\";i:59271;s:12:\"delete-60033\";i:59272;s:12:\"delete-60030\";i:59273;s:12:\"delete-60031\";i:59274;s:12:\"delete-60034\";i:59275;s:12:\"delete-60037\";i:59276;s:12:\"delete-60038\";i:59277;s:12:\"delete-60035\";i:59278;s:12:\"delete-60036\";i:59279;s:12:\"delete-60039\";i:59280;s:12:\"delete-60042\";i:59281;s:12:\"delete-60043\";i:59282;s:12:\"delete-60040\";i:59283;s:12:\"delete-60041\";i:59284;s:12:\"delete-60044\";i:59285;s:12:\"delete-60047\";i:59286;s:12:\"delete-60048\";i:59287;s:12:\"delete-60045\";i:59288;s:12:\"delete-60046\";i:59289;s:12:\"delete-60049\";i:59290;s:12:\"delete-60052\";i:59291;s:12:\"delete-60053\";i:59292;s:12:\"delete-60050\";i:59293;s:12:\"delete-60051\";i:59294;s:12:\"delete-60054\";i:59295;s:12:\"delete-60057\";i:59296;s:12:\"delete-60058\";i:59297;s:12:\"delete-60055\";i:59298;s:12:\"delete-60056\";i:59299;s:12:\"delete-60059\";i:59300;s:12:\"delete-60062\";i:59301;s:12:\"delete-60063\";i:59302;s:12:\"delete-60060\";i:59303;s:12:\"delete-60061\";i:59304;s:12:\"delete-60064\";i:59305;s:12:\"delete-60067\";i:59306;s:12:\"delete-60068\";i:59307;s:12:\"delete-60065\";i:59308;s:12:\"delete-60066\";i:59309;s:12:\"delete-60069\";i:59310;s:12:\"delete-60072\";i:59311;s:12:\"delete-60073\";i:59312;s:12:\"delete-60070\";i:59313;s:12:\"delete-60071\";i:59314;s:12:\"delete-60074\";i:59315;s:12:\"delete-60077\";i:59316;s:12:\"delete-60075\";i:59317;s:12:\"delete-60076\";i:59318;s:12:\"delete-60078\";i:59319;s:12:\"delete-60079\";i:59320;s:12:\"delete-60082\";i:59321;s:12:\"delete-60083\";i:59322;s:12:\"delete-60080\";i:59323;s:12:\"delete-60081\";i:59324;s:12:\"delete-60084\";i:59325;s:12:\"delete-60087\";i:59326;s:12:\"delete-60088\";i:59327;s:12:\"delete-60085\";i:59328;s:12:\"delete-60086\";i:59329;s:12:\"delete-60089\";i:59330;s:12:\"delete-60092\";i:59331;s:12:\"delete-60093\";i:59332;s:12:\"delete-60090\";i:59333;s:12:\"delete-60091\";i:59334;s:12:\"delete-60094\";i:59335;s:12:\"delete-60097\";i:59336;s:12:\"delete-60098\";i:59337;s:12:\"delete-60095\";i:59338;s:12:\"delete-60096\";i:59339;s:12:\"delete-60099\";i:59340;s:12:\"delete-60102\";i:59341;s:12:\"delete-60103\";i:59342;s:12:\"delete-60100\";i:59343;s:12:\"delete-60101\";i:59344;s:12:\"delete-60104\";i:59345;s:12:\"delete-60107\";i:59346;s:12:\"delete-60108\";i:59347;s:12:\"delete-60105\";i:59348;s:12:\"delete-60106\";i:59349;s:12:\"delete-60109\";i:59350;s:12:\"delete-60112\";i:59351;s:12:\"delete-60113\";i:59352;s:12:\"delete-60110\";i:59353;s:12:\"delete-60111\";i:59354;s:12:\"delete-60114\";i:59355;s:12:\"delete-60117\";i:59356;s:12:\"delete-60118\";i:59357;s:12:\"delete-60115\";i:59358;s:12:\"delete-60116\";i:59359;s:12:\"delete-60119\";i:59360;s:12:\"delete-60122\";i:59361;s:12:\"delete-60123\";i:59362;s:12:\"delete-60120\";i:59363;s:12:\"delete-60121\";i:59364;s:12:\"delete-60124\";i:59365;s:12:\"delete-60127\";i:59366;s:12:\"delete-60128\";i:59367;s:12:\"delete-60125\";i:59368;s:12:\"delete-60126\";i:59369;s:12:\"delete-60129\";i:59370;s:12:\"delete-60132\";i:59371;s:12:\"delete-60133\";i:59372;s:12:\"delete-60130\";i:59373;s:12:\"delete-60131\";i:59374;s:12:\"delete-60134\";i:59375;s:12:\"delete-60137\";i:59376;s:12:\"delete-60138\";i:59377;s:12:\"delete-60135\";i:59378;s:12:\"delete-60136\";i:59379;s:12:\"delete-60139\";i:59380;s:12:\"delete-60142\";i:59381;s:12:\"delete-60143\";i:59382;s:12:\"delete-60140\";i:59383;s:12:\"delete-60141\";i:59384;s:12:\"delete-60144\";i:59385;s:12:\"delete-60147\";i:59386;s:12:\"delete-60145\";i:59387;s:12:\"delete-60146\";i:59388;s:12:\"delete-60148\";i:59389;s:12:\"delete-60149\";i:59390;s:12:\"delete-60152\";i:59391;s:12:\"delete-60153\";i:59392;s:12:\"delete-60150\";i:59393;s:12:\"delete-60151\";i:59394;s:12:\"delete-60154\";i:59395;s:12:\"delete-60157\";i:59396;s:12:\"delete-60158\";i:59397;s:12:\"delete-60155\";i:59398;s:12:\"delete-60156\";i:59399;s:12:\"delete-60159\";i:59400;s:12:\"delete-60162\";i:59401;s:12:\"delete-60160\";i:59402;s:12:\"delete-60161\";i:59403;s:12:\"delete-60163\";i:59404;s:12:\"delete-60164\";i:59405;s:12:\"delete-60167\";i:59406;s:12:\"delete-60168\";i:59407;s:12:\"delete-60165\";i:59408;s:12:\"delete-60166\";i:59409;s:12:\"delete-60169\";i:59410;s:12:\"delete-60172\";i:59411;s:12:\"delete-60173\";i:59412;s:12:\"delete-60170\";i:59413;s:12:\"delete-60171\";i:59414;s:12:\"delete-60174\";i:59415;s:12:\"delete-60177\";i:59416;s:12:\"delete-60175\";i:59417;s:12:\"delete-60176\";i:59418;s:12:\"delete-60178\";i:59419;s:12:\"delete-60179\";i:59420;s:12:\"delete-60182\";i:59421;s:12:\"delete-60183\";i:59422;s:12:\"delete-60180\";i:59423;s:12:\"delete-60181\";i:59424;s:12:\"delete-60184\";i:59425;s:12:\"delete-60187\";i:59426;s:12:\"delete-60188\";i:59427;s:12:\"delete-60185\";i:59428;s:12:\"delete-60186\";i:59429;s:12:\"delete-60189\";i:59430;s:12:\"delete-60192\";i:59431;s:12:\"delete-60193\";i:59432;s:12:\"delete-60190\";i:59433;s:12:\"delete-60191\";i:59434;s:12:\"delete-60194\";i:59435;s:12:\"delete-60197\";i:59436;s:12:\"delete-60198\";i:59437;s:12:\"delete-60195\";i:59438;s:12:\"delete-60196\";i:59439;s:12:\"delete-60199\";i:59440;s:12:\"delete-60202\";i:59441;s:12:\"delete-60203\";i:59442;s:12:\"delete-60200\";i:59443;s:12:\"delete-60201\";i:59444;s:12:\"delete-60204\";i:59445;s:12:\"delete-60207\";i:59446;s:12:\"delete-60208\";i:59447;s:12:\"delete-60205\";i:59448;s:12:\"delete-60206\";i:59449;s:12:\"delete-60209\";i:59450;s:12:\"delete-60212\";i:59451;s:12:\"delete-60210\";i:59452;s:12:\"delete-60211\";i:59453;s:12:\"delete-60213\";i:59454;s:12:\"delete-60216\";i:59455;s:12:\"delete-60217\";i:59456;s:12:\"delete-60214\";i:59457;s:12:\"delete-60215\";i:59458;s:12:\"delete-60218\";i:59459;s:12:\"delete-60221\";i:59460;s:12:\"delete-60222\";i:59461;s:12:\"delete-60219\";i:59462;s:12:\"delete-60220\";i:59463;s:12:\"delete-60223\";i:59464;s:12:\"delete-60226\";i:59465;s:12:\"delete-60227\";i:59466;s:12:\"delete-60224\";i:59467;s:12:\"delete-60225\";i:59468;s:12:\"delete-60228\";i:59469;s:12:\"delete-60231\";i:59470;s:12:\"delete-60232\";i:59471;s:12:\"delete-60229\";i:59472;s:12:\"delete-60230\";i:59473;s:12:\"delete-60233\";i:59474;s:12:\"delete-60236\";i:59475;s:12:\"delete-60237\";i:59476;s:12:\"delete-60234\";i:59477;s:12:\"delete-60235\";i:59478;s:12:\"delete-60238\";i:59479;s:12:\"delete-60241\";i:59480;s:12:\"delete-60242\";i:59481;s:12:\"delete-60239\";i:59482;s:12:\"delete-60240\";i:59483;s:12:\"delete-60243\";i:59484;s:12:\"delete-60246\";i:59485;s:12:\"delete-60247\";i:59486;s:12:\"delete-60244\";i:59487;s:12:\"delete-60245\";i:59488;s:12:\"delete-60248\";i:59489;s:12:\"delete-60251\";i:59490;s:12:\"delete-60252\";i:59491;s:12:\"delete-60249\";i:59492;s:12:\"delete-60250\";i:59493;s:12:\"delete-60253\";i:59494;s:12:\"delete-60256\";i:59495;s:12:\"delete-60257\";i:59496;s:12:\"delete-60254\";i:59497;s:12:\"delete-60255\";i:59498;s:12:\"delete-60258\";i:59499;s:12:\"delete-60261\";i:59500;s:12:\"delete-60262\";i:59501;s:12:\"delete-60259\";i:59502;s:12:\"delete-60260\";i:59503;s:12:\"delete-60263\";i:59504;s:12:\"delete-60266\";i:59505;s:12:\"delete-60267\";i:59506;s:12:\"delete-60264\";i:59507;s:12:\"delete-60265\";i:59508;s:12:\"delete-60268\";i:59509;s:12:\"delete-60271\";i:59510;s:12:\"delete-60272\";i:59511;s:12:\"delete-60269\";i:59512;s:12:\"delete-60270\";i:59513;s:12:\"delete-60273\";i:59514;s:12:\"delete-60276\";i:59515;s:12:\"delete-60277\";i:59516;s:12:\"delete-60274\";i:59517;s:12:\"delete-60275\";i:59518;s:12:\"delete-60278\";i:59519;s:12:\"delete-60281\";i:59520;s:12:\"delete-60282\";i:59521;s:12:\"delete-60279\";i:59522;s:12:\"delete-60280\";i:59523;s:12:\"delete-60283\";i:59524;s:12:\"delete-60286\";i:59525;s:12:\"delete-60287\";i:59526;s:12:\"delete-60284\";i:59527;s:12:\"delete-60285\";i:59528;s:12:\"delete-60288\";i:59529;s:12:\"delete-60291\";i:59530;s:12:\"delete-60289\";i:59531;s:12:\"delete-60290\";i:59532;s:12:\"delete-60292\";i:59533;s:12:\"delete-60293\";i:59534;s:12:\"delete-60296\";i:59535;s:12:\"delete-60297\";i:59536;s:12:\"delete-60294\";i:59537;s:12:\"delete-60295\";i:59538;s:12:\"delete-60298\";i:59539;s:12:\"delete-60301\";i:59540;s:12:\"delete-60302\";i:59541;s:12:\"delete-60299\";i:59542;s:12:\"delete-60300\";i:59543;s:12:\"delete-60303\";i:59544;s:12:\"delete-60306\";i:59545;s:12:\"delete-60307\";i:59546;s:12:\"delete-60304\";i:59547;s:12:\"delete-60305\";i:59548;s:12:\"delete-60308\";i:59549;s:12:\"delete-60311\";i:59550;s:12:\"delete-60309\";i:59551;s:12:\"delete-60310\";i:59552;s:12:\"delete-60312\";i:59553;s:12:\"delete-60313\";i:59554;s:12:\"delete-60316\";i:59555;s:12:\"delete-60317\";i:59556;s:12:\"delete-60314\";i:59557;s:12:\"delete-60315\";i:59558;s:12:\"delete-60318\";i:59559;s:12:\"delete-60321\";i:59560;s:12:\"delete-60322\";i:59561;s:12:\"delete-60319\";i:59562;s:12:\"delete-60320\";i:59563;s:12:\"delete-60323\";i:59564;s:12:\"delete-60326\";i:59565;s:12:\"delete-60324\";i:59566;s:12:\"delete-60325\";i:59567;s:12:\"delete-60327\";i:59568;s:12:\"delete-60328\";i:59569;s:12:\"delete-60331\";i:59570;s:12:\"delete-60332\";i:59571;s:12:\"delete-60329\";i:59572;s:12:\"delete-60330\";i:59573;s:12:\"delete-60333\";i:59574;s:12:\"delete-60336\";i:59575;s:12:\"delete-60337\";i:59576;s:12:\"delete-60334\";i:59577;s:12:\"delete-60335\";i:59578;s:12:\"delete-60338\";i:59579;s:12:\"delete-60341\";i:59580;s:12:\"delete-60342\";i:59581;s:12:\"delete-60339\";i:59582;s:12:\"delete-60340\";i:59583;s:12:\"delete-60343\";i:59584;s:12:\"delete-60346\";i:59585;s:12:\"delete-60347\";i:59586;s:12:\"delete-60344\";i:59587;s:12:\"delete-60345\";i:59588;s:12:\"delete-60348\";i:59589;s:12:\"delete-60351\";i:59590;s:12:\"delete-60352\";i:59591;s:12:\"delete-60349\";i:59592;s:12:\"delete-60350\";i:59593;s:12:\"delete-60353\";i:59594;s:12:\"delete-60356\";i:59595;s:12:\"delete-60357\";i:59596;s:12:\"delete-60354\";i:59597;s:12:\"delete-60355\";i:59598;s:12:\"delete-60358\";i:59599;s:12:\"delete-60361\";i:59600;s:12:\"delete-60362\";i:59601;s:12:\"delete-60359\";i:59602;s:12:\"delete-60360\";i:59603;s:12:\"delete-60363\";i:59604;s:12:\"delete-60366\";i:59605;s:12:\"delete-60367\";i:59606;s:12:\"delete-60364\";i:59607;s:12:\"delete-60365\";i:59608;s:12:\"delete-60368\";i:59609;s:12:\"delete-60369\";i:59610;s:12:\"delete-60370\";i:59611;s:12:\"delete-60371\";i:59612;s:12:\"delete-60372\";i:59613;s:12:\"delete-60375\";i:59614;s:12:\"delete-60376\";i:59615;s:12:\"delete-60373\";i:59616;s:12:\"delete-60374\";i:59617;s:12:\"delete-60377\";i:59618;s:12:\"delete-60380\";i:59619;s:12:\"delete-60381\";i:59620;s:12:\"delete-60378\";i:59621;s:12:\"delete-60379\";i:59622;s:12:\"delete-60382\";i:59623;s:12:\"delete-60385\";i:59624;s:12:\"delete-60386\";i:59625;s:12:\"delete-60383\";i:59626;s:12:\"delete-60384\";i:59627;s:12:\"delete-60387\";i:59628;s:12:\"delete-60390\";i:59629;s:12:\"delete-60391\";i:59630;s:12:\"delete-60388\";i:59631;s:12:\"delete-60389\";i:59632;s:12:\"delete-60392\";i:59633;s:12:\"delete-60395\";i:59634;s:12:\"delete-60393\";i:59635;s:12:\"delete-60394\";i:59636;s:12:\"delete-60396\";i:59637;s:12:\"delete-60397\";i:59638;s:12:\"delete-60400\";i:59639;s:12:\"delete-60401\";i:59640;s:12:\"delete-60398\";i:59641;s:12:\"delete-60399\";i:59642;s:12:\"delete-60402\";i:59643;s:12:\"delete-60405\";i:59644;s:12:\"delete-60406\";i:59645;s:12:\"delete-60403\";i:59646;s:12:\"delete-60404\";i:59647;s:12:\"delete-60407\";i:59648;s:12:\"delete-60410\";i:59649;s:12:\"delete-60411\";i:59650;s:12:\"delete-60408\";i:59651;s:12:\"delete-60409\";i:59652;s:12:\"delete-60412\";i:59653;s:12:\"delete-60415\";i:59654;s:12:\"delete-60416\";i:59655;s:12:\"delete-60413\";i:59656;s:12:\"delete-60414\";i:59657;s:12:\"delete-60417\";i:59658;s:12:\"delete-60420\";i:59659;s:12:\"delete-60421\";i:59660;s:12:\"delete-60418\";i:59661;s:12:\"delete-60419\";i:59662;s:12:\"delete-60422\";i:59663;s:12:\"delete-60425\";i:59664;s:12:\"delete-60426\";i:59665;s:12:\"delete-60423\";i:59666;s:12:\"delete-60424\";i:59667;s:12:\"delete-60427\";i:59668;s:12:\"delete-60430\";i:59669;s:12:\"delete-60431\";i:59670;s:12:\"delete-60428\";i:59671;s:12:\"delete-60429\";i:59672;s:12:\"delete-60432\";i:59673;s:12:\"delete-60435\";i:59674;s:12:\"delete-60436\";i:59675;s:12:\"delete-60433\";i:59676;s:12:\"delete-60434\";i:59677;s:12:\"delete-60437\";i:59678;s:12:\"delete-60440\";i:59679;s:12:\"delete-60441\";i:59680;s:12:\"delete-60438\";i:59681;s:12:\"delete-60439\";i:59682;s:12:\"delete-60442\";i:59683;s:12:\"delete-60445\";i:59684;s:12:\"delete-60446\";i:59685;s:12:\"delete-60443\";i:59686;s:12:\"delete-60444\";i:59687;s:12:\"delete-60447\";i:59688;s:12:\"delete-60450\";i:59689;s:12:\"delete-60451\";i:59690;s:12:\"delete-60448\";i:59691;s:12:\"delete-60449\";i:59692;s:12:\"delete-60452\";i:59693;s:12:\"delete-60455\";i:59694;s:12:\"delete-60456\";i:59695;s:12:\"delete-60453\";i:59696;s:12:\"delete-60454\";i:59697;s:12:\"delete-60457\";i:59698;s:12:\"delete-60460\";i:59699;s:12:\"delete-60461\";i:59700;s:12:\"delete-60458\";i:59701;s:12:\"delete-60459\";i:59702;s:12:\"delete-60462\";i:59703;s:12:\"delete-60465\";i:59704;s:12:\"delete-60466\";i:59705;s:12:\"delete-60467\";i:59706;s:12:\"delete-60470\";i:59707;s:12:\"delete-60471\";i:59708;s:12:\"delete-60463\";i:59709;s:12:\"delete-60464\";i:59710;s:12:\"delete-60468\";i:59711;s:12:\"delete-60469\";i:59712;s:12:\"delete-60472\";i:59713;s:12:\"delete-60475\";i:59714;s:12:\"delete-60476\";i:59715;s:12:\"delete-60473\";i:59716;s:12:\"delete-60474\";i:59717;s:12:\"delete-60477\";i:59718;s:12:\"delete-60480\";i:59719;s:12:\"delete-60481\";i:59720;s:12:\"delete-60478\";i:59721;s:12:\"delete-60479\";i:59722;s:12:\"delete-60482\";i:59723;s:12:\"delete-60485\";i:59724;s:12:\"delete-60486\";i:59725;s:12:\"delete-60483\";i:59726;s:12:\"delete-60484\";i:59727;s:12:\"delete-60487\";i:59728;s:12:\"delete-60490\";i:59729;s:12:\"delete-60491\";i:59730;s:12:\"delete-60488\";i:59731;s:12:\"delete-60489\";i:59732;s:12:\"delete-60492\";i:59733;s:12:\"delete-60493\";i:59734;s:12:\"delete-60494\";i:59735;s:12:\"delete-60495\";i:59736;s:12:\"delete-60496\";i:59737;s:12:\"delete-60497\";i:59738;s:12:\"delete-60500\";i:59739;s:12:\"delete-60501\";i:59740;s:12:\"delete-60498\";i:59741;s:12:\"delete-60499\";i:59742;s:12:\"delete-60502\";i:59743;s:12:\"delete-60505\";i:59744;s:12:\"delete-60503\";i:59745;s:12:\"delete-60504\";i:59746;s:12:\"delete-60506\";i:59747;s:12:\"delete-60507\";i:59748;s:12:\"delete-60510\";i:59749;s:12:\"delete-60511\";i:59750;s:12:\"delete-60508\";i:59751;s:12:\"delete-60509\";i:59752;s:12:\"delete-60512\";i:59753;s:12:\"delete-60515\";i:59754;s:12:\"delete-60516\";i:59755;s:12:\"delete-60513\";i:59756;s:12:\"delete-60514\";i:59757;s:12:\"delete-60517\";i:59758;s:12:\"delete-60520\";i:59759;s:12:\"delete-60521\";i:59760;s:12:\"delete-60518\";i:59761;s:12:\"delete-60519\";i:59762;s:12:\"delete-60522\";i:59763;s:12:\"delete-60525\";i:59764;s:12:\"delete-60526\";i:59765;s:12:\"delete-60523\";i:59766;s:12:\"delete-60524\";i:59767;s:12:\"delete-60527\";i:59768;s:12:\"delete-60530\";i:59769;s:12:\"delete-60531\";i:59770;s:12:\"delete-60528\";i:59771;s:12:\"delete-60529\";i:59772;s:12:\"delete-60532\";i:59773;s:12:\"delete-60535\";i:59774;s:12:\"delete-60536\";i:59775;s:12:\"delete-60533\";i:59776;s:12:\"delete-60534\";i:59777;s:12:\"delete-60537\";i:59778;s:12:\"delete-60540\";i:59779;s:12:\"delete-60541\";i:59780;s:12:\"delete-60538\";i:59781;s:12:\"delete-60539\";i:59782;s:12:\"delete-60542\";i:59783;s:12:\"delete-60545\";i:59784;s:12:\"delete-60546\";i:59785;s:12:\"delete-60543\";i:59786;s:12:\"delete-60544\";i:59787;s:12:\"delete-60547\";i:59788;s:12:\"delete-60550\";i:59789;s:12:\"delete-60551\";i:59790;s:12:\"delete-60548\";i:59791;s:12:\"delete-60549\";i:59792;s:12:\"delete-60552\";i:59793;s:12:\"delete-60555\";i:59794;s:12:\"delete-60553\";i:59795;s:12:\"delete-60554\";i:59796;s:12:\"delete-60556\";i:59797;s:12:\"delete-60557\";i:59798;s:12:\"delete-60560\";i:59799;s:12:\"delete-60561\";i:59800;s:12:\"delete-60558\";i:59801;s:12:\"delete-60559\";i:59802;s:12:\"delete-60562\";i:59803;s:12:\"delete-60565\";i:59804;s:12:\"delete-60566\";i:59805;s:12:\"delete-60563\";i:59806;s:12:\"delete-60564\";i:59807;s:12:\"delete-60567\";i:59808;s:12:\"delete-60570\";i:59809;s:12:\"delete-60571\";i:59810;s:12:\"delete-60568\";i:59811;s:12:\"delete-60569\";i:59812;s:12:\"delete-60572\";i:59813;s:12:\"delete-60575\";i:59814;s:12:\"delete-60576\";i:59815;s:12:\"delete-60573\";i:59816;s:12:\"delete-60574\";i:59817;s:12:\"delete-60577\";i:59818;s:12:\"delete-60580\";i:59819;s:12:\"delete-60581\";i:59820;s:12:\"delete-60578\";i:59821;s:12:\"delete-60579\";i:59822;s:12:\"delete-60582\";i:59823;s:12:\"delete-60585\";i:59824;s:12:\"delete-60586\";i:59825;s:12:\"delete-60583\";i:59826;s:12:\"delete-60584\";i:59827;s:12:\"delete-60587\";i:59828;s:12:\"delete-60590\";i:59829;s:12:\"delete-60588\";i:59830;s:12:\"delete-60589\";i:59831;s:12:\"delete-60591\";i:59832;s:12:\"delete-60592\";i:59833;s:12:\"delete-60595\";i:59834;s:12:\"delete-60596\";i:59835;s:12:\"delete-60593\";i:59836;s:12:\"delete-60594\";i:59837;s:12:\"delete-60597\";i:59838;s:12:\"delete-60600\";i:59839;s:12:\"delete-60598\";i:59840;s:12:\"delete-60599\";i:59841;s:12:\"delete-60601\";i:59842;s:12:\"delete-60602\";i:59843;s:12:\"delete-60605\";i:59844;s:12:\"delete-60606\";i:59845;s:12:\"delete-60603\";i:59846;s:12:\"delete-60604\";i:59847;s:12:\"delete-60607\";i:59848;s:12:\"delete-60610\";i:59849;s:12:\"delete-60611\";i:59850;s:12:\"delete-60608\";i:59851;s:12:\"delete-60609\";i:59852;s:12:\"delete-60612\";i:59853;s:12:\"delete-60615\";i:59854;s:12:\"delete-60616\";i:59855;s:12:\"delete-60613\";i:59856;s:12:\"delete-60614\";i:59857;s:12:\"delete-60617\";i:59858;s:12:\"delete-60620\";i:59859;s:12:\"delete-60621\";i:59860;s:12:\"delete-60618\";i:59861;s:12:\"delete-60619\";i:59862;s:12:\"delete-60622\";i:59863;s:12:\"delete-60625\";i:59864;s:12:\"delete-60626\";i:59865;s:12:\"delete-60623\";i:59866;s:12:\"delete-60624\";i:59867;s:12:\"delete-60627\";i:59868;s:12:\"delete-60630\";i:59869;s:12:\"delete-60631\";i:59870;s:12:\"delete-60628\";i:59871;s:12:\"delete-60629\";i:59872;s:12:\"delete-60632\";i:59873;s:12:\"delete-60635\";i:59874;s:12:\"delete-60636\";i:59875;s:12:\"delete-60633\";i:59876;s:12:\"delete-60634\";i:59877;s:12:\"delete-60637\";i:59878;s:12:\"delete-60640\";i:59879;s:12:\"delete-60638\";i:59880;s:12:\"delete-60639\";i:59881;s:12:\"delete-60641\";i:59882;s:12:\"delete-60642\";i:59883;s:12:\"delete-60645\";i:59884;s:12:\"delete-60646\";i:59885;s:12:\"delete-60643\";i:59886;s:12:\"delete-60644\";i:59887;s:12:\"delete-60647\";i:59888;s:12:\"delete-60650\";i:59889;s:12:\"delete-60648\";i:59890;s:12:\"delete-60649\";i:59891;s:12:\"delete-60651\";i:59892;s:12:\"delete-60652\";i:59893;s:12:\"delete-60655\";i:59894;s:12:\"delete-60656\";i:59895;s:12:\"delete-60653\";i:59896;s:12:\"delete-60654\";i:59897;s:12:\"delete-60657\";i:59898;s:12:\"delete-60660\";i:59899;s:12:\"delete-60661\";i:59900;s:12:\"delete-60658\";i:59901;s:12:\"delete-60659\";i:59902;s:12:\"delete-60662\";i:59903;s:12:\"delete-60665\";i:59904;s:12:\"delete-60666\";i:59905;s:12:\"delete-60663\";i:59906;s:12:\"delete-60664\";i:59907;s:12:\"delete-60667\";i:59908;s:12:\"delete-60670\";i:59909;s:12:\"delete-60671\";i:59910;s:12:\"delete-60668\";i:59911;s:12:\"delete-60669\";i:59912;s:12:\"delete-60672\";i:59913;s:12:\"delete-60675\";i:59914;s:12:\"delete-60676\";i:59915;s:12:\"delete-60673\";i:59916;s:12:\"delete-60674\";i:59917;s:12:\"delete-60677\";i:59918;s:12:\"delete-60680\";i:59919;s:12:\"delete-60681\";i:59920;s:12:\"delete-60678\";i:59921;s:12:\"delete-60679\";i:59922;s:12:\"delete-60682\";i:59923;s:12:\"delete-60685\";i:59924;s:12:\"delete-60686\";i:59925;s:12:\"delete-60683\";i:59926;s:12:\"delete-60684\";i:59927;s:12:\"delete-60687\";i:59928;s:12:\"delete-60690\";i:59929;s:12:\"delete-60691\";i:59930;s:12:\"delete-60688\";i:59931;s:12:\"delete-60689\";i:59932;s:12:\"delete-60692\";i:59933;s:12:\"delete-60695\";i:59934;s:12:\"delete-60696\";i:59935;s:12:\"delete-60693\";i:59936;s:12:\"delete-60694\";i:59937;s:12:\"delete-60697\";i:59938;s:12:\"delete-60700\";i:59939;s:12:\"delete-60701\";i:59940;s:12:\"delete-60698\";i:59941;s:12:\"delete-60699\";i:59942;s:12:\"delete-60702\";i:59943;s:12:\"delete-60705\";i:59944;s:12:\"delete-60706\";i:59945;s:12:\"delete-60703\";i:59946;s:12:\"delete-60704\";i:59947;s:12:\"delete-60707\";i:59948;s:12:\"delete-60710\";i:59949;s:12:\"delete-60708\";i:59950;s:12:\"delete-60709\";i:59951;s:12:\"delete-60711\";i:59952;s:12:\"delete-60712\";i:59953;s:12:\"delete-60715\";i:59954;s:12:\"delete-60716\";i:59955;s:12:\"delete-60713\";i:59956;s:12:\"delete-60714\";i:59957;s:12:\"delete-60717\";i:59958;s:12:\"delete-60720\";i:59959;s:12:\"delete-60721\";i:59960;s:12:\"delete-60718\";i:59961;s:12:\"delete-60719\";i:59962;s:12:\"delete-60722\";i:59963;s:12:\"delete-60725\";i:59964;s:12:\"delete-60726\";i:59965;s:12:\"delete-60723\";i:59966;s:12:\"delete-60724\";i:59967;s:12:\"delete-60727\";i:59968;s:12:\"delete-60730\";i:59969;s:12:\"delete-60731\";i:59970;s:12:\"delete-60728\";i:59971;s:12:\"delete-60729\";i:59972;s:12:\"delete-60732\";i:59973;s:12:\"delete-60735\";i:59974;s:12:\"delete-60736\";i:59975;s:12:\"delete-60733\";i:59976;s:12:\"delete-60734\";i:59977;s:12:\"delete-60737\";i:59978;s:12:\"delete-60740\";i:59979;s:12:\"delete-60741\";i:59980;s:12:\"delete-60738\";i:59981;s:12:\"delete-60739\";i:59982;s:12:\"delete-60742\";i:59983;s:12:\"delete-60745\";i:59984;s:12:\"delete-60746\";i:59985;s:12:\"delete-60743\";i:59986;s:12:\"delete-60744\";i:59987;s:12:\"delete-60747\";i:59988;s:12:\"delete-60750\";i:59989;s:12:\"delete-60751\";i:59990;s:12:\"delete-60748\";i:59991;s:12:\"delete-60749\";i:59992;s:12:\"delete-60752\";i:59993;s:12:\"delete-60755\";i:59994;s:12:\"delete-60756\";i:59995;s:12:\"delete-60753\";i:59996;s:12:\"delete-60754\";i:59997;s:12:\"delete-60757\";i:59998;s:12:\"delete-60760\";i:59999;s:12:\"delete-60761\";i:60000;s:12:\"delete-60758\";i:60001;s:12:\"delete-60759\";i:60002;s:12:\"delete-60762\";i:60003;s:12:\"delete-60765\";i:60004;s:12:\"delete-60766\";i:60005;s:12:\"delete-60763\";i:60006;s:12:\"delete-60764\";i:60007;s:12:\"delete-60767\";i:60008;s:12:\"delete-60770\";i:60009;s:12:\"delete-60771\";i:60010;s:12:\"delete-60768\";i:60011;s:12:\"delete-60769\";i:60012;s:12:\"delete-60772\";i:60013;s:12:\"delete-60775\";i:60014;s:12:\"delete-60776\";i:60015;s:12:\"delete-60773\";i:60016;s:12:\"delete-60774\";i:60017;s:12:\"delete-60777\";i:60018;s:12:\"delete-60780\";i:60019;s:12:\"delete-60781\";i:60020;s:12:\"delete-60778\";i:60021;s:12:\"delete-60779\";i:60022;s:12:\"delete-60782\";i:60023;s:12:\"delete-60785\";i:60024;s:12:\"delete-60786\";i:60025;s:12:\"delete-60783\";i:60026;s:12:\"delete-60784\";i:60027;s:12:\"delete-60787\";i:60028;s:12:\"delete-60790\";i:60029;s:12:\"delete-60791\";i:60030;s:12:\"delete-60788\";i:60031;s:12:\"delete-60789\";i:60032;s:12:\"delete-60792\";i:60033;s:12:\"delete-60795\";i:60034;s:12:\"delete-60796\";i:60035;s:12:\"delete-60797\";i:60036;s:12:\"delete-60800\";i:60037;s:12:\"delete-60801\";i:60038;s:12:\"delete-60793\";i:60039;s:12:\"delete-60794\";i:60040;s:12:\"delete-60798\";i:60041;s:12:\"delete-60799\";i:60042;s:12:\"delete-60802\";i:60043;s:12:\"delete-60805\";i:60044;s:12:\"delete-60806\";i:60045;s:12:\"delete-60803\";i:60046;s:12:\"delete-60804\";i:60047;s:12:\"delete-60807\";i:60048;s:12:\"delete-60810\";i:60049;s:12:\"delete-60811\";i:60050;s:12:\"delete-60808\";i:60051;s:12:\"delete-60809\";i:60052;s:12:\"delete-60812\";i:60053;s:12:\"delete-60815\";i:60054;s:12:\"delete-60816\";i:60055;s:12:\"delete-60813\";i:60056;s:12:\"delete-60814\";i:60057;s:12:\"delete-60817\";i:60058;s:12:\"delete-60820\";i:60059;s:12:\"delete-60821\";i:60060;s:12:\"delete-60818\";i:60061;s:12:\"delete-60819\";i:60062;s:12:\"delete-60822\";i:60063;s:12:\"delete-60825\";i:60064;s:12:\"delete-60826\";i:60065;s:12:\"delete-60823\";i:60066;s:12:\"delete-60824\";i:60067;s:12:\"delete-60827\";i:60068;s:12:\"delete-60830\";i:60069;s:12:\"delete-60831\";i:60070;s:12:\"delete-60828\";i:60071;s:12:\"delete-60829\";i:60072;s:12:\"delete-60832\";i:60073;s:12:\"delete-60835\";i:60074;s:12:\"delete-60836\";i:60075;s:12:\"delete-60833\";i:60076;s:12:\"delete-60834\";i:60077;s:12:\"delete-60837\";i:60078;s:12:\"delete-60840\";i:60079;s:12:\"delete-60841\";i:60080;s:12:\"delete-60838\";i:60081;s:12:\"delete-60839\";i:60082;s:12:\"delete-60842\";i:60083;s:12:\"delete-60845\";i:60084;s:12:\"delete-60846\";i:60085;s:12:\"delete-60843\";i:60086;s:12:\"delete-60844\";i:60087;s:12:\"delete-60847\";i:60088;s:12:\"delete-60850\";i:60089;s:12:\"delete-60848\";i:60090;s:12:\"delete-60849\";i:60091;s:12:\"delete-60851\";i:60092;s:12:\"delete-60854\";i:60093;s:12:\"delete-60855\";i:60094;s:12:\"delete-60852\";i:60095;s:12:\"delete-60853\";i:60096;s:12:\"delete-60856\";i:60097;s:12:\"delete-60859\";i:60098;s:12:\"delete-60857\";i:60099;s:12:\"delete-60858\";i:60100;s:12:\"delete-60860\";i:60101;s:12:\"delete-60861\";i:60102;s:12:\"delete-60864\";i:60103;s:12:\"delete-60865\";i:60104;s:12:\"delete-60862\";i:60105;s:12:\"delete-60863\";i:60106;s:12:\"delete-60866\";i:60107;s:12:\"delete-60869\";i:60108;s:12:\"delete-60870\";i:60109;s:12:\"delete-60867\";i:60110;s:12:\"delete-60868\";i:60111;s:12:\"delete-60871\";i:60112;s:12:\"delete-60874\";i:60113;s:12:\"delete-60875\";i:60114;s:12:\"delete-60872\";i:60115;s:12:\"delete-60873\";i:60116;s:12:\"delete-60876\";i:60117;s:12:\"delete-60879\";i:60118;s:12:\"delete-60880\";i:60119;s:12:\"delete-60877\";i:60120;s:12:\"delete-60878\";i:60121;s:12:\"delete-60881\";i:60122;s:12:\"delete-60884\";i:60123;s:12:\"delete-60885\";i:60124;s:12:\"delete-60882\";i:60125;s:12:\"delete-60883\";i:60126;s:12:\"delete-60886\";i:60127;s:12:\"delete-60889\";i:60128;s:12:\"delete-60890\";i:60129;s:12:\"delete-60887\";i:60130;s:12:\"delete-60888\";i:60131;s:12:\"delete-60891\";i:60132;s:12:\"delete-60894\";i:60133;s:12:\"delete-60895\";i:60134;s:12:\"delete-60892\";i:60135;s:12:\"delete-60893\";i:60136;s:12:\"delete-60896\";i:60137;s:12:\"delete-60899\";i:60138;s:12:\"delete-60897\";i:60139;s:12:\"delete-60898\";i:60140;s:12:\"delete-60900\";i:60141;s:12:\"delete-60901\";i:60142;s:12:\"delete-60904\";i:60143;s:12:\"delete-60905\";i:60144;s:12:\"delete-60902\";i:60145;s:12:\"delete-60903\";i:60146;s:12:\"delete-60906\";i:60147;s:12:\"delete-60909\";i:60148;s:12:\"delete-60910\";i:60149;s:12:\"delete-60907\";i:60150;s:12:\"delete-60908\";i:60151;s:12:\"delete-60911\";i:60152;s:12:\"delete-60914\";i:60153;s:12:\"delete-60915\";i:60154;s:12:\"delete-60912\";i:60155;s:12:\"delete-60913\";i:60156;s:12:\"delete-60916\";i:60157;s:12:\"delete-60919\";i:60158;s:12:\"delete-60920\";i:60159;s:12:\"delete-60917\";i:60160;s:12:\"delete-60918\";i:60161;s:12:\"delete-60921\";i:60162;s:12:\"delete-60924\";i:60163;s:12:\"delete-60925\";i:60164;s:12:\"delete-60922\";i:60165;s:12:\"delete-60923\";i:60166;s:12:\"delete-60926\";i:60167;s:12:\"delete-60929\";i:60168;s:12:\"delete-60930\";i:60169;s:12:\"delete-60927\";i:60170;s:12:\"delete-60928\";i:60171;s:12:\"delete-60931\";i:60172;s:12:\"delete-60934\";i:60173;s:12:\"delete-60932\";i:60174;s:12:\"delete-60933\";i:60175;s:12:\"delete-60935\";i:60176;s:12:\"delete-60936\";i:60177;s:12:\"delete-60939\";i:60178;s:12:\"delete-60940\";i:60179;s:12:\"delete-60937\";i:60180;s:12:\"delete-60938\";i:60181;s:12:\"delete-60941\";i:60182;s:12:\"delete-60944\";i:60183;s:12:\"delete-60945\";i:60184;s:12:\"delete-60942\";i:60185;s:12:\"delete-60943\";i:60186;s:12:\"delete-60946\";i:60187;s:12:\"delete-60949\";i:60188;s:12:\"delete-60950\";i:60189;s:12:\"delete-60947\";i:60190;s:12:\"delete-60948\";i:60191;s:12:\"delete-60951\";i:60192;s:12:\"delete-60954\";i:60193;s:12:\"delete-60955\";i:60194;s:12:\"delete-60952\";i:60195;s:12:\"delete-60953\";i:60196;s:12:\"delete-60956\";i:60197;s:12:\"delete-60959\";i:60198;s:12:\"delete-60960\";i:60199;s:12:\"delete-60957\";i:60200;s:12:\"delete-60958\";i:60201;s:12:\"delete-60961\";i:60202;s:12:\"delete-60964\";i:60203;s:12:\"delete-60965\";i:60204;s:12:\"delete-60962\";i:60205;s:12:\"delete-60963\";i:60206;s:12:\"delete-60966\";i:60207;s:12:\"delete-60969\";i:60208;s:12:\"delete-60970\";i:60209;s:12:\"delete-60967\";i:60210;s:12:\"delete-60968\";i:60211;s:12:\"delete-60971\";i:60212;s:12:\"delete-60974\";i:60213;s:12:\"delete-60972\";i:60214;s:12:\"delete-60973\";i:60215;s:12:\"delete-60975\";i:60216;s:12:\"delete-60976\";i:60217;s:12:\"delete-60979\";i:60218;s:12:\"delete-60980\";i:60219;s:12:\"delete-60977\";i:60220;s:12:\"delete-60978\";i:60221;s:12:\"delete-60981\";i:60222;s:12:\"delete-60984\";i:60223;s:12:\"delete-60985\";i:60224;s:12:\"delete-60982\";i:60225;s:12:\"delete-60983\";i:60226;s:12:\"delete-60986\";i:60227;s:12:\"delete-60989\";i:60228;s:12:\"delete-60990\";i:60229;s:12:\"delete-60987\";i:60230;s:12:\"delete-60988\";i:60231;s:12:\"delete-60991\";i:60232;s:12:\"delete-60994\";i:60233;s:12:\"delete-60992\";i:60234;s:12:\"delete-60993\";i:60235;s:12:\"delete-60995\";i:60236;s:12:\"delete-60996\";i:60237;s:12:\"delete-60999\";i:60238;s:12:\"delete-61000\";i:60239;s:12:\"delete-60997\";i:60240;s:12:\"delete-60998\";i:60241;s:12:\"delete-61001\";i:60242;s:12:\"delete-61002\";i:60243;s:12:\"delete-61003\";i:60244;s:12:\"delete-61004\";i:60245;s:12:\"delete-61005\";i:60246;s:12:\"delete-61006\";i:60247;s:12:\"delete-61009\";i:60248;s:12:\"delete-61010\";i:60249;s:12:\"delete-61007\";i:60250;s:12:\"delete-61008\";i:60251;s:12:\"delete-61011\";i:60252;s:12:\"delete-61014\";i:60253;s:12:\"delete-61015\";i:60254;s:12:\"delete-61012\";i:60255;s:12:\"delete-61013\";i:60256;s:12:\"delete-61016\";i:60257;s:12:\"delete-61019\";i:60258;s:12:\"delete-61020\";i:60259;s:12:\"delete-61017\";i:60260;s:12:\"delete-61018\";i:60261;s:12:\"delete-61021\";i:60262;s:12:\"delete-61024\";i:60263;s:12:\"delete-61025\";i:60264;s:12:\"delete-61022\";i:60265;s:12:\"delete-61023\";i:60266;s:12:\"delete-61026\";i:60267;s:12:\"delete-61029\";i:60268;s:12:\"delete-61030\";i:60269;s:12:\"delete-61027\";i:60270;s:12:\"delete-61028\";i:60271;s:12:\"delete-61031\";i:60272;s:12:\"delete-61034\";i:60273;s:12:\"delete-61035\";i:60274;s:12:\"delete-61032\";i:60275;s:12:\"delete-61033\";i:60276;s:12:\"delete-61036\";i:60277;s:12:\"delete-61039\";i:60278;s:12:\"delete-61040\";i:60279;s:12:\"delete-61037\";i:60280;s:12:\"delete-61038\";i:60281;s:12:\"delete-61041\";i:60282;s:12:\"delete-61044\";i:60283;s:12:\"delete-61045\";i:60284;s:12:\"delete-61042\";i:60285;s:12:\"delete-61043\";i:60286;s:12:\"delete-61046\";i:60287;s:12:\"delete-61049\";i:60288;s:12:\"delete-61050\";i:60289;s:12:\"delete-61047\";i:60290;s:12:\"delete-61048\";i:60291;s:12:\"delete-61051\";i:60292;s:12:\"delete-61054\";i:60293;s:12:\"delete-61055\";i:60294;s:12:\"delete-61052\";i:60295;s:12:\"delete-61053\";i:60296;s:12:\"delete-61056\";i:60297;s:12:\"delete-61059\";i:60298;s:12:\"delete-61060\";i:60299;s:12:\"delete-61057\";i:60300;s:12:\"delete-61058\";i:60301;s:12:\"delete-61061\";i:60302;s:12:\"delete-61064\";i:60303;s:12:\"delete-61065\";i:60304;s:12:\"delete-61062\";i:60305;s:12:\"delete-61063\";i:60306;s:12:\"delete-61066\";i:60307;s:12:\"delete-61069\";i:60308;s:12:\"delete-61070\";i:60309;s:12:\"delete-61067\";i:60310;s:12:\"delete-61068\";i:60311;s:12:\"delete-61071\";i:60312;s:12:\"delete-61074\";i:60313;s:12:\"delete-61075\";i:60314;s:12:\"delete-61072\";i:60315;s:12:\"delete-61073\";i:60316;s:12:\"delete-61076\";i:60317;s:12:\"delete-61079\";i:60318;s:12:\"delete-61080\";i:60319;s:12:\"delete-61077\";i:60320;s:12:\"delete-61078\";i:60321;s:12:\"delete-61081\";i:60322;s:12:\"delete-61084\";i:60323;s:12:\"delete-61085\";i:60324;s:12:\"delete-61082\";i:60325;s:12:\"delete-61083\";i:60326;s:12:\"delete-61086\";i:60327;s:12:\"delete-61089\";i:60328;s:12:\"delete-61087\";i:60329;s:12:\"delete-61088\";i:60330;s:12:\"delete-61090\";i:60331;s:12:\"delete-61091\";i:60332;s:12:\"delete-61094\";i:60333;s:12:\"delete-61095\";i:60334;s:12:\"delete-61092\";i:60335;s:12:\"delete-61093\";i:60336;s:12:\"delete-61096\";i:60337;s:12:\"delete-61099\";i:60338;s:12:\"delete-61100\";i:60339;s:12:\"delete-61097\";i:60340;s:12:\"delete-61098\";i:60341;s:12:\"delete-61101\";i:60342;s:12:\"delete-61104\";i:60343;s:12:\"delete-61105\";i:60344;s:12:\"delete-61102\";i:60345;s:12:\"delete-61103\";i:60346;s:12:\"delete-61106\";i:60347;s:12:\"delete-61109\";i:60348;s:12:\"delete-61110\";i:60349;s:12:\"delete-61107\";i:60350;s:12:\"delete-61108\";i:60351;s:12:\"delete-61111\";i:60352;s:12:\"delete-61114\";i:60353;s:12:\"delete-61115\";i:60354;s:12:\"delete-61112\";i:60355;s:12:\"delete-61113\";i:60356;s:12:\"delete-61116\";i:60357;s:12:\"delete-61119\";i:60358;s:12:\"delete-61120\";i:60359;s:12:\"delete-61117\";i:60360;s:12:\"delete-61118\";i:60361;s:12:\"delete-61121\";i:60362;s:12:\"delete-61124\";i:60363;s:12:\"delete-61125\";i:60364;s:12:\"delete-61122\";i:60365;s:12:\"delete-61123\";i:60366;s:12:\"delete-61126\";i:60367;s:12:\"delete-61129\";i:60368;s:12:\"delete-61127\";i:60369;s:12:\"delete-61128\";i:60370;s:12:\"delete-61130\";i:60371;s:12:\"delete-61131\";i:60372;s:12:\"delete-61134\";i:60373;s:12:\"delete-61135\";i:60374;s:12:\"delete-61132\";i:60375;s:12:\"delete-61133\";i:60376;s:12:\"delete-61136\";i:60377;s:12:\"delete-61139\";i:60378;s:12:\"delete-61140\";i:60379;s:12:\"delete-61137\";i:60380;s:12:\"delete-61138\";i:60381;s:12:\"delete-61141\";i:60382;s:12:\"delete-61144\";i:60383;s:12:\"delete-61145\";i:60384;s:12:\"delete-61142\";i:60385;s:12:\"delete-61143\";i:60386;s:12:\"delete-61146\";i:60387;s:12:\"delete-61149\";i:60388;s:12:\"delete-61150\";i:60389;s:12:\"delete-61147\";i:60390;s:12:\"delete-61148\";i:60391;s:12:\"delete-61151\";i:60392;s:12:\"delete-61154\";i:60393;s:12:\"delete-61155\";i:60394;s:12:\"delete-61152\";i:60395;s:12:\"delete-61153\";i:60396;s:12:\"delete-61156\";i:60397;s:12:\"delete-61159\";i:60398;s:12:\"delete-61160\";i:60399;s:12:\"delete-61157\";i:60400;s:12:\"delete-61158\";i:60401;s:12:\"delete-61161\";i:60402;s:12:\"delete-61164\";i:60403;s:12:\"delete-61165\";i:60404;s:12:\"delete-61162\";i:60405;s:12:\"delete-61163\";i:60406;s:12:\"delete-61166\";i:60407;s:12:\"delete-61169\";i:60408;s:12:\"delete-61167\";i:60409;s:12:\"delete-61168\";i:60410;s:12:\"delete-61170\";i:60411;s:12:\"delete-61171\";i:60412;s:12:\"delete-61174\";i:60413;s:12:\"delete-61175\";i:60414;s:12:\"delete-61172\";i:60415;s:12:\"delete-61173\";i:60416;s:12:\"delete-61176\";i:60417;s:12:\"delete-61179\";i:60418;s:12:\"delete-61180\";i:60419;s:12:\"delete-61177\";i:60420;s:12:\"delete-61178\";i:60421;s:12:\"delete-61181\";i:60422;s:12:\"delete-61184\";i:60423;s:12:\"delete-61185\";i:60424;s:12:\"delete-61182\";i:60425;s:12:\"delete-61183\";i:60426;s:12:\"delete-61186\";i:60427;s:12:\"delete-61189\";i:60428;s:12:\"delete-61190\";i:60429;s:12:\"delete-61187\";i:60430;s:12:\"delete-61188\";i:60431;s:12:\"delete-61191\";i:60432;s:12:\"delete-61194\";i:60433;s:12:\"delete-61192\";i:60434;s:12:\"delete-61193\";i:60435;s:12:\"delete-61195\";i:60436;s:12:\"delete-61196\";i:60437;s:12:\"delete-61199\";i:60438;s:12:\"delete-61200\";i:60439;s:12:\"delete-61197\";i:60440;s:12:\"delete-61198\";i:60441;s:12:\"delete-61201\";i:60442;s:12:\"delete-61204\";i:60443;s:12:\"delete-61205\";i:60444;s:12:\"delete-61202\";i:60445;s:12:\"delete-61203\";i:60446;s:12:\"delete-61206\";i:60447;s:12:\"delete-61207\";i:60448;s:12:\"delete-61208\";i:60449;s:12:\"delete-61209\";i:60450;s:12:\"delete-61210\";i:60451;s:12:\"delete-61211\";i:60452;s:12:\"delete-61214\";i:60453;s:12:\"delete-61215\";i:60454;s:12:\"delete-61212\";i:60455;s:12:\"delete-61213\";i:60456;s:12:\"delete-61216\";i:60457;s:12:\"delete-61219\";i:60458;s:12:\"delete-61220\";i:60459;s:12:\"delete-61217\";i:60460;s:12:\"delete-61218\";i:60461;s:12:\"delete-61221\";i:60462;s:12:\"delete-61224\";i:60463;s:12:\"delete-61225\";i:60464;s:12:\"delete-61222\";i:60465;s:12:\"delete-61223\";i:60466;s:12:\"delete-61226\";i:60467;s:12:\"delete-61229\";i:60468;s:12:\"delete-61230\";i:60469;s:12:\"delete-61227\";i:60470;s:12:\"delete-61228\";i:60471;s:12:\"delete-61231\";i:60472;s:12:\"delete-61234\";i:60473;s:12:\"delete-61235\";i:60474;s:12:\"delete-61232\";i:60475;s:12:\"delete-61233\";i:60476;s:12:\"delete-61236\";i:60477;s:12:\"delete-61239\";i:60478;s:12:\"delete-61240\";i:60479;s:12:\"delete-61237\";i:60480;s:12:\"delete-61238\";i:60481;s:12:\"delete-61241\";i:60482;s:12:\"delete-61244\";i:60483;s:12:\"delete-61245\";i:60484;s:12:\"delete-61242\";i:60485;s:12:\"delete-61243\";i:60486;s:12:\"delete-61246\";i:60487;s:12:\"delete-61249\";i:60488;s:12:\"delete-61250\";i:60489;s:12:\"delete-61247\";i:60490;s:12:\"delete-61248\";i:60491;s:12:\"delete-61251\";i:60492;s:12:\"delete-61254\";i:60493;s:12:\"delete-61252\";i:60494;s:12:\"delete-61253\";i:60495;s:12:\"delete-61255\";i:60496;s:12:\"delete-61256\";i:60497;s:12:\"delete-61259\";i:60498;s:12:\"delete-61260\";i:60499;s:12:\"delete-61258\";i:60500;s:12:\"delete-61257\";i:60501;s:12:\"delete-61261\";i:60502;s:12:\"delete-61264\";i:60503;s:12:\"delete-61265\";i:60504;s:12:\"delete-61263\";i:60505;s:12:\"delete-61262\";i:60506;s:12:\"delete-61266\";i:60507;s:12:\"delete-61269\";i:60508;s:12:\"delete-61270\";i:60509;s:12:\"delete-61268\";i:60510;s:12:\"delete-61267\";i:60511;s:12:\"delete-61271\";i:60512;s:12:\"delete-61274\";i:60513;s:12:\"delete-61275\";i:60514;s:12:\"delete-61273\";i:60515;s:12:\"delete-61272\";i:60516;s:12:\"delete-61276\";i:60517;s:12:\"delete-61279\";i:60518;s:12:\"delete-61280\";i:60519;s:12:\"delete-61278\";i:60520;s:12:\"delete-61277\";i:60521;s:12:\"delete-61281\";i:60522;s:12:\"delete-61284\";i:60523;s:12:\"delete-61283\";i:60524;s:12:\"delete-61282\";i:60525;s:12:\"delete-61285\";i:60526;s:12:\"delete-61286\";i:60527;s:12:\"delete-61289\";i:60528;s:12:\"delete-61290\";i:60529;s:12:\"delete-61288\";i:60530;s:12:\"delete-61287\";i:60531;s:12:\"delete-61291\";i:60532;s:12:\"delete-61294\";i:60533;s:12:\"delete-61295\";i:60534;s:12:\"delete-61293\";i:60535;s:12:\"delete-61292\";i:60536;s:12:\"delete-61296\";i:60537;s:12:\"delete-61299\";i:60538;s:12:\"delete-61300\";i:60539;s:12:\"delete-61298\";i:60540;s:12:\"delete-61297\";i:60541;s:12:\"delete-61301\";i:60542;s:12:\"delete-61304\";i:60543;s:12:\"delete-61305\";i:60544;s:12:\"delete-61303\";i:60545;s:12:\"delete-61302\";i:60546;s:12:\"delete-61306\";i:60547;s:12:\"delete-61309\";i:60548;s:12:\"delete-61310\";i:60549;s:12:\"delete-61308\";i:60550;s:12:\"delete-61307\";i:60551;s:12:\"delete-61311\";i:60552;s:12:\"delete-61314\";i:60553;s:12:\"delete-61315\";i:60554;s:12:\"delete-61313\";i:60555;s:12:\"delete-61312\";i:60556;s:12:\"delete-61316\";i:60557;s:12:\"delete-61319\";i:60558;s:12:\"delete-61320\";i:60559;s:12:\"delete-61318\";i:60560;s:12:\"delete-61317\";i:60561;s:12:\"delete-61321\";i:60562;s:12:\"delete-61324\";i:60563;s:12:\"delete-61325\";i:60564;s:12:\"delete-61323\";i:60565;s:12:\"delete-61322\";i:60566;s:12:\"delete-61326\";i:60567;s:12:\"delete-61329\";i:60568;s:12:\"delete-61330\";i:60569;s:12:\"delete-61328\";i:60570;s:12:\"delete-61327\";i:60571;s:12:\"delete-61331\";i:60572;s:12:\"delete-61334\";i:60573;s:12:\"delete-61335\";i:60574;s:12:\"delete-61333\";i:60575;s:12:\"delete-61332\";i:60576;s:12:\"delete-61336\";i:60577;s:12:\"delete-61339\";i:60578;s:12:\"delete-61340\";i:60579;s:12:\"delete-61338\";i:60580;s:12:\"delete-61337\";i:60581;s:12:\"delete-61341\";i:60582;s:12:\"delete-61344\";i:60583;s:12:\"delete-61345\";i:60584;s:12:\"delete-61343\";i:60585;s:12:\"delete-61342\";i:60586;s:12:\"delete-61346\";i:60587;s:12:\"delete-61349\";i:60588;s:12:\"delete-61350\";i:60589;s:12:\"delete-61348\";i:60590;s:12:\"delete-61347\";i:60591;s:12:\"delete-61354\";i:60592;s:12:\"delete-61351\";i:60593;s:12:\"delete-61355\";i:60594;s:12:\"delete-61353\";i:60595;s:12:\"delete-61352\";i:60596;s:12:\"delete-61356\";i:60597;s:12:\"delete-61359\";i:60598;s:12:\"delete-61360\";i:60599;s:12:\"delete-61358\";i:60600;s:12:\"delete-61357\";i:60601;s:12:\"delete-61364\";i:60602;s:12:\"delete-61361\";i:60603;s:12:\"delete-61365\";i:60604;s:12:\"delete-61363\";i:60605;s:12:\"delete-61362\";i:60606;s:12:\"delete-61366\";i:60607;s:12:\"delete-61369\";i:60608;s:12:\"delete-61370\";i:60609;s:12:\"delete-61368\";i:60610;s:12:\"delete-61367\";i:60611;s:12:\"delete-61371\";i:60612;s:12:\"delete-61374\";i:60613;s:12:\"delete-61375\";i:60614;s:12:\"delete-61373\";i:60615;s:12:\"delete-61372\";i:60616;s:12:\"delete-61376\";i:60617;s:12:\"delete-61379\";i:60618;s:12:\"delete-61380\";i:60619;s:12:\"delete-61378\";i:60620;s:12:\"delete-61377\";i:60621;s:12:\"delete-61381\";i:60622;s:12:\"delete-61384\";i:60623;s:12:\"delete-61385\";i:60624;s:12:\"delete-61383\";i:60625;s:12:\"delete-61382\";i:60626;s:12:\"delete-61389\";i:60627;s:12:\"delete-61386\";i:60628;s:12:\"delete-61390\";i:60629;s:12:\"delete-61388\";i:60630;s:12:\"delete-61387\";i:60631;s:12:\"delete-61391\";i:60632;s:12:\"delete-61394\";i:60633;s:12:\"delete-61395\";i:60634;s:12:\"delete-61393\";i:60635;s:12:\"delete-61392\";i:60636;s:12:\"delete-61396\";i:60637;s:12:\"delete-61399\";i:60638;s:12:\"delete-61400\";i:60639;s:12:\"delete-61398\";i:60640;s:12:\"delete-61397\";i:60641;s:12:\"delete-61401\";i:60642;s:12:\"delete-61404\";i:60643;s:12:\"delete-61405\";i:60644;s:12:\"delete-61403\";i:60645;s:12:\"delete-61402\";i:60646;s:12:\"delete-61406\";i:60647;s:12:\"delete-61409\";i:60648;s:12:\"delete-61410\";i:60649;s:12:\"delete-61408\";i:60650;s:12:\"delete-61407\";i:60651;s:12:\"delete-61411\";i:60652;s:12:\"delete-61414\";i:60653;s:12:\"delete-61415\";i:60654;s:12:\"delete-61413\";i:60655;s:12:\"delete-61412\";i:60656;s:12:\"delete-61419\";i:60657;s:12:\"delete-61416\";i:60658;s:12:\"delete-61420\";i:60659;s:12:\"delete-61418\";i:60660;s:12:\"delete-61417\";i:60661;s:12:\"delete-61421\";i:60662;s:12:\"delete-61424\";i:60663;s:12:\"delete-61425\";i:60664;s:12:\"delete-61423\";i:60665;s:12:\"delete-61422\";i:60666;s:12:\"delete-61426\";i:60667;s:12:\"delete-61429\";i:60668;s:12:\"delete-61430\";i:60669;s:12:\"delete-61428\";i:60670;s:12:\"delete-61427\";i:60671;s:12:\"delete-61431\";i:60672;s:12:\"delete-61434\";i:60673;s:12:\"delete-61435\";i:60674;s:12:\"delete-61433\";i:60675;s:12:\"delete-61432\";i:60676;s:12:\"delete-61436\";i:60677;s:12:\"delete-61439\";i:60678;s:12:\"delete-61440\";i:60679;s:12:\"delete-61438\";i:60680;s:12:\"delete-61437\";i:60681;s:12:\"delete-61441\";i:60682;s:12:\"delete-61444\";i:60683;s:12:\"delete-61445\";i:60684;s:12:\"delete-61443\";i:60685;s:12:\"delete-61442\";i:60686;s:12:\"delete-61446\";i:60687;s:12:\"delete-61449\";i:60688;s:12:\"delete-61450\";i:60689;s:12:\"delete-61448\";i:60690;s:12:\"delete-61447\";i:60691;s:12:\"delete-61451\";i:60692;s:12:\"delete-61454\";i:60693;s:12:\"delete-61455\";i:60694;s:12:\"delete-61453\";i:60695;s:12:\"delete-61452\";i:60696;s:12:\"delete-61456\";i:60697;s:12:\"delete-61459\";i:60698;s:12:\"delete-61460\";i:60699;s:12:\"delete-61458\";i:60700;s:12:\"delete-61457\";i:60701;s:12:\"delete-61461\";i:60702;s:12:\"delete-61464\";i:60703;s:12:\"delete-61463\";i:60704;s:12:\"delete-61462\";i:60705;s:12:\"delete-61465\";i:60706;s:12:\"delete-61466\";i:60707;s:12:\"delete-61469\";i:60708;s:12:\"delete-61470\";i:60709;s:12:\"delete-61467\";i:60710;s:12:\"delete-61468\";i:60711;s:12:\"delete-61471\";i:60712;s:12:\"delete-61474\";i:60713;s:12:\"delete-61475\";i:60714;s:12:\"delete-61472\";i:60715;s:12:\"delete-61473\";i:60716;s:12:\"delete-61476\";i:60717;s:12:\"delete-61479\";i:60718;s:12:\"delete-61477\";i:60719;s:12:\"delete-61478\";i:60720;s:12:\"delete-61480\";i:60721;s:12:\"delete-61481\";i:60722;s:12:\"delete-61484\";i:60723;s:12:\"delete-61485\";i:60724;s:12:\"delete-61482\";i:60725;s:12:\"delete-61483\";i:60726;s:12:\"delete-61486\";i:60727;s:12:\"delete-61489\";i:60728;s:12:\"delete-61487\";i:60729;s:12:\"delete-61488\";i:60730;s:12:\"delete-61490\";i:60731;s:12:\"delete-61491\";i:60732;s:12:\"delete-61494\";i:60733;s:12:\"delete-61495\";i:60734;s:12:\"delete-61492\";i:60735;s:12:\"delete-61493\";i:60736;s:12:\"delete-61496\";i:60737;s:12:\"delete-61499\";i:60738;s:12:\"delete-61500\";i:60739;s:12:\"delete-61497\";i:60740;s:12:\"delete-61498\";i:60741;s:12:\"delete-61501\";i:60742;s:12:\"delete-61504\";i:60743;s:12:\"delete-61505\";i:60744;s:12:\"delete-61502\";i:60745;s:12:\"delete-61503\";i:60746;s:12:\"delete-61506\";i:60747;s:12:\"delete-61509\";i:60748;s:12:\"delete-61510\";i:60749;s:12:\"delete-61507\";i:60750;s:12:\"delete-61508\";i:60751;s:12:\"delete-61511\";i:60752;s:12:\"delete-61514\";i:60753;s:12:\"delete-61515\";i:60754;s:12:\"delete-61512\";i:60755;s:12:\"delete-61513\";i:60756;s:12:\"delete-61516\";i:60757;s:12:\"delete-61519\";i:60758;s:12:\"delete-61520\";i:60759;s:12:\"delete-61517\";i:60760;s:12:\"delete-61518\";i:60761;s:12:\"delete-61521\";i:60762;s:12:\"delete-61524\";i:60763;s:12:\"delete-61525\";i:60764;s:12:\"delete-61522\";i:60765;s:12:\"delete-61523\";i:60766;s:12:\"delete-61526\";i:60767;s:12:\"delete-61529\";i:60768;s:12:\"delete-61527\";i:60769;s:12:\"delete-61528\";i:60770;s:12:\"delete-61530\";i:60771;s:12:\"delete-61531\";i:60772;s:12:\"delete-61534\";i:60773;s:12:\"delete-61535\";i:60774;s:12:\"delete-61532\";i:60775;s:12:\"delete-61533\";i:60776;s:12:\"delete-61536\";i:60777;s:12:\"delete-61539\";i:60778;s:12:\"delete-61540\";i:60779;s:12:\"delete-61537\";i:60780;s:12:\"delete-61538\";i:60781;s:12:\"delete-61541\";i:60782;s:12:\"delete-61544\";i:60783;s:12:\"delete-61542\";i:60784;s:12:\"delete-61543\";i:60785;s:12:\"delete-61545\";i:60786;s:12:\"delete-61546\";i:60787;s:12:\"delete-61549\";i:60788;s:12:\"delete-61550\";i:60789;s:12:\"delete-61547\";i:60790;s:12:\"delete-61548\";i:60791;s:12:\"delete-61551\";i:60792;s:12:\"delete-61554\";i:60793;s:12:\"delete-61555\";i:60794;s:12:\"delete-61552\";i:60795;s:12:\"delete-61553\";i:60796;s:12:\"delete-61556\";i:60797;s:12:\"delete-61559\";i:60798;s:12:\"delete-61560\";i:60799;s:12:\"delete-61557\";i:60800;s:12:\"delete-61558\";i:60801;s:12:\"delete-61561\";i:60802;s:12:\"delete-61564\";i:60803;s:12:\"delete-61565\";i:60804;s:12:\"delete-61562\";i:60805;s:12:\"delete-61563\";i:60806;s:12:\"delete-61566\";i:60807;s:12:\"delete-61569\";i:60808;s:12:\"delete-61570\";i:60809;s:12:\"delete-61567\";i:60810;s:12:\"delete-61568\";i:60811;s:12:\"delete-61571\";i:60812;s:12:\"delete-61574\";i:60813;s:12:\"delete-61572\";i:60814;s:12:\"delete-61573\";i:60815;s:12:\"delete-61575\";i:60816;s:12:\"delete-61576\";i:60817;s:12:\"delete-61579\";i:60818;s:12:\"delete-61580\";i:60819;s:12:\"delete-61577\";i:60820;s:12:\"delete-61578\";i:60821;s:12:\"delete-61581\";i:60822;s:12:\"delete-61584\";i:60823;s:12:\"delete-61585\";i:60824;s:12:\"delete-61582\";i:60825;s:12:\"delete-61583\";i:60826;s:12:\"delete-61586\";i:60827;s:12:\"delete-61589\";i:60828;s:12:\"delete-61590\";i:60829;s:12:\"delete-61587\";i:60830;s:12:\"delete-61588\";i:60831;s:12:\"delete-61591\";i:60832;s:12:\"delete-61594\";i:60833;s:12:\"delete-61595\";i:60834;s:12:\"delete-61592\";i:60835;s:12:\"delete-61593\";i:60836;s:12:\"delete-61596\";i:60837;s:12:\"delete-61599\";i:60838;s:12:\"delete-61597\";i:60839;s:12:\"delete-61598\";i:60840;s:12:\"delete-61600\";i:60841;s:12:\"delete-61601\";i:60842;s:12:\"delete-61604\";i:60843;s:12:\"delete-61605\";i:60844;s:12:\"delete-61602\";i:60845;s:12:\"delete-61603\";i:60846;s:12:\"delete-61606\";i:60847;s:12:\"delete-61609\";i:60848;s:12:\"delete-61610\";i:60849;s:12:\"delete-61607\";i:60850;s:12:\"delete-61608\";i:60851;s:12:\"delete-61611\";i:60852;s:12:\"delete-61614\";i:60853;s:12:\"delete-61612\";i:60854;s:12:\"delete-61613\";i:60855;s:12:\"delete-61615\";i:60856;s:12:\"delete-61616\";i:60857;s:12:\"delete-61619\";i:60858;s:12:\"delete-61620\";i:60859;s:12:\"delete-61617\";i:60860;s:12:\"delete-61618\";i:60861;s:12:\"delete-61621\";i:60862;s:12:\"delete-61624\";i:60863;s:12:\"delete-61625\";i:60864;s:12:\"delete-61622\";i:60865;s:12:\"delete-61623\";i:60866;s:12:\"delete-61626\";i:60867;s:12:\"delete-61629\";i:60868;s:12:\"delete-61630\";i:60869;s:12:\"delete-61627\";i:60870;s:12:\"delete-61628\";i:60871;s:12:\"delete-61631\";i:60872;s:12:\"delete-61632\";i:60873;s:12:\"delete-61633\";i:60874;s:12:\"delete-61634\";i:60875;s:12:\"delete-61635\";i:60876;s:12:\"delete-61636\";i:60877;s:12:\"delete-61639\";i:60878;s:12:\"delete-61640\";i:60879;s:12:\"delete-61637\";i:60880;s:12:\"delete-61638\";i:60881;s:12:\"delete-61641\";i:60882;s:12:\"delete-61644\";i:60883;s:12:\"delete-61645\";i:60884;s:12:\"delete-61642\";i:60885;s:12:\"delete-61643\";i:60886;s:12:\"delete-61646\";i:60887;s:12:\"delete-61649\";i:60888;s:12:\"delete-61650\";i:60889;s:12:\"delete-61647\";i:60890;s:12:\"delete-61648\";i:60891;s:12:\"delete-61651\";i:60892;s:12:\"delete-61654\";i:60893;s:12:\"delete-61655\";i:60894;s:12:\"delete-61652\";i:60895;s:12:\"delete-61653\";i:60896;s:12:\"delete-61656\";i:60897;s:12:\"delete-61659\";i:60898;s:12:\"delete-61657\";i:60899;s:12:\"delete-61658\";i:60900;s:12:\"delete-61660\";i:60901;s:12:\"delete-61661\";i:60902;s:12:\"delete-61664\";i:60903;s:12:\"delete-61665\";i:60904;s:12:\"delete-61662\";i:60905;s:12:\"delete-61663\";i:60906;s:12:\"delete-61666\";i:60907;s:12:\"delete-61669\";i:60908;s:12:\"delete-61670\";i:60909;s:12:\"delete-61667\";i:60910;s:12:\"delete-61668\";i:60911;s:12:\"delete-61671\";i:60912;s:12:\"delete-61674\";i:60913;s:12:\"delete-61675\";i:60914;s:12:\"delete-61672\";i:60915;s:12:\"delete-61673\";i:60916;s:12:\"delete-61676\";i:60917;s:12:\"delete-61679\";i:60918;s:12:\"delete-61677\";i:60919;s:12:\"delete-61678\";i:60920;s:12:\"delete-61680\";i:60921;s:12:\"delete-61681\";i:60922;s:12:\"delete-61684\";i:60923;s:12:\"delete-61685\";i:60924;s:12:\"delete-61682\";i:60925;s:12:\"delete-61683\";i:60926;s:12:\"delete-61686\";i:60927;s:12:\"delete-61689\";i:60928;s:12:\"delete-61690\";i:60929;s:12:\"delete-61687\";i:60930;s:12:\"delete-61688\";i:60931;s:12:\"delete-61691\";i:60932;s:12:\"delete-61694\";i:60933;s:12:\"delete-61695\";i:60934;s:12:\"delete-61692\";i:60935;s:12:\"delete-61693\";i:60936;s:12:\"delete-61696\";i:60937;s:12:\"delete-61699\";i:60938;s:12:\"delete-61700\";i:60939;s:12:\"delete-61697\";i:60940;s:12:\"delete-61698\";i:60941;s:12:\"delete-61701\";i:60942;s:12:\"delete-61704\";i:60943;s:12:\"delete-61705\";i:60944;s:12:\"delete-61702\";i:60945;s:12:\"delete-61703\";i:60946;s:12:\"delete-61706\";i:60947;s:12:\"delete-61709\";i:60948;s:12:\"delete-61710\";i:60949;s:12:\"delete-61707\";i:60950;s:12:\"delete-61708\";i:60951;s:12:\"delete-61711\";i:60952;s:12:\"delete-61714\";i:60953;s:12:\"delete-61715\";i:60954;s:12:\"delete-61712\";i:60955;s:12:\"delete-61713\";i:60956;s:12:\"delete-61716\";i:60957;s:12:\"delete-61719\";i:60958;s:12:\"delete-61720\";i:60959;s:12:\"delete-61717\";i:60960;s:12:\"delete-61718\";i:60961;s:12:\"delete-61721\";i:60962;s:12:\"delete-61722\";i:60963;s:12:\"delete-61723\";i:60964;s:12:\"delete-61724\";i:60965;s:12:\"delete-61725\";i:60966;s:12:\"delete-61726\";i:60967;s:12:\"delete-61729\";i:60968;s:12:\"delete-61727\";i:60969;s:12:\"delete-61728\";i:60970;s:12:\"delete-61730\";i:60971;s:12:\"delete-61731\";i:60972;s:12:\"delete-61734\";i:60973;s:12:\"delete-61732\";i:60974;s:12:\"delete-61733\";i:60975;s:12:\"delete-61735\";i:60976;s:12:\"delete-61736\";i:60977;s:12:\"delete-61739\";i:60978;s:12:\"delete-61740\";i:60979;s:12:\"delete-61737\";i:60980;s:12:\"delete-61738\";i:60981;s:12:\"delete-61741\";i:60982;s:12:\"delete-61742\";i:60983;s:12:\"delete-61743\";i:60984;s:12:\"delete-61744\";i:60985;s:12:\"delete-61745\";i:60986;s:12:\"delete-61746\";i:60987;s:12:\"delete-61749\";i:60988;s:12:\"delete-61747\";i:60989;s:12:\"delete-61748\";i:60990;s:12:\"delete-61750\";i:60991;s:12:\"delete-61751\";i:60992;s:12:\"delete-61754\";i:60993;s:12:\"delete-61755\";i:60994;s:12:\"delete-61752\";i:60995;s:12:\"delete-61753\";i:60996;s:12:\"delete-61756\";i:60997;s:12:\"delete-61759\";i:60998;s:12:\"delete-61760\";i:60999;s:12:\"delete-61757\";i:61000;s:12:\"delete-61758\";i:61001;s:12:\"delete-61761\";i:61002;s:12:\"delete-61764\";i:61003;s:12:\"delete-61765\";i:61004;s:12:\"delete-61762\";i:61005;s:12:\"delete-61763\";i:61006;s:12:\"delete-61766\";i:61007;s:12:\"delete-61769\";i:61008;s:12:\"delete-61770\";i:61009;s:12:\"delete-61767\";i:61010;s:12:\"delete-61768\";i:61011;s:12:\"delete-61771\";i:61012;s:12:\"delete-61774\";i:61013;s:12:\"delete-61775\";i:61014;s:12:\"delete-61772\";i:61015;s:12:\"delete-61773\";i:61016;s:12:\"delete-61776\";i:61017;s:12:\"delete-61779\";i:61018;s:12:\"delete-61780\";i:61019;s:12:\"delete-61777\";i:61020;s:12:\"delete-61778\";i:61021;s:12:\"delete-61781\";i:61022;s:12:\"delete-61784\";i:61023;s:12:\"delete-61785\";i:61024;s:12:\"delete-61782\";i:61025;s:12:\"delete-61783\";i:61026;s:12:\"delete-61786\";i:61027;s:12:\"delete-61789\";i:61028;s:12:\"delete-61790\";i:61029;s:12:\"delete-61787\";i:61030;s:12:\"delete-61788\";i:61031;s:12:\"delete-61791\";i:61032;s:12:\"delete-61794\";i:61033;s:12:\"delete-61795\";i:61034;s:12:\"delete-61792\";i:61035;s:12:\"delete-61793\";i:61036;s:12:\"delete-61796\";i:61037;s:12:\"delete-61799\";i:61038;s:12:\"delete-61797\";i:61039;s:12:\"delete-61798\";i:61040;s:12:\"delete-61800\";i:61041;s:12:\"delete-61801\";i:61042;s:12:\"delete-61804\";i:61043;s:12:\"delete-61805\";i:61044;s:12:\"delete-61802\";i:61045;s:12:\"delete-61803\";i:61046;s:12:\"delete-61806\";i:61047;s:12:\"delete-61809\";i:61048;s:12:\"delete-61810\";i:61049;s:12:\"delete-61807\";i:61050;s:12:\"delete-61808\";i:61051;s:12:\"delete-61811\";i:61052;s:12:\"delete-61814\";i:61053;s:12:\"delete-61815\";i:61054;s:12:\"delete-61812\";i:61055;s:12:\"delete-61813\";i:61056;s:12:\"delete-61816\";i:61057;s:12:\"delete-61819\";i:61058;s:12:\"delete-61820\";i:61059;s:12:\"delete-61817\";i:61060;s:12:\"delete-61818\";i:61061;s:12:\"delete-61821\";i:61062;s:12:\"delete-61824\";i:61063;s:12:\"delete-61825\";i:61064;s:12:\"delete-61822\";i:61065;s:12:\"delete-61823\";i:61066;s:12:\"delete-61826\";i:61067;s:12:\"delete-61829\";i:61068;s:12:\"delete-61830\";i:61069;s:12:\"delete-61827\";i:61070;s:12:\"delete-61828\";i:61071;s:12:\"delete-61831\";i:61072;s:12:\"delete-61834\";i:61073;s:12:\"delete-61835\";i:61074;s:12:\"delete-61832\";i:61075;s:12:\"delete-61833\";i:61076;s:12:\"delete-61836\";i:61077;s:12:\"delete-61839\";i:61078;s:12:\"delete-61840\";i:61079;s:12:\"delete-61837\";i:61080;s:12:\"delete-61838\";i:61081;s:12:\"delete-61841\";i:61082;s:12:\"delete-61844\";i:61083;s:12:\"delete-61845\";i:61084;s:12:\"delete-61842\";i:61085;s:12:\"delete-61843\";i:61086;s:12:\"delete-61846\";i:61087;s:12:\"delete-61847\";i:61088;s:12:\"delete-61848\";i:61089;s:12:\"delete-61849\";i:61090;s:12:\"delete-61850\";i:61091;s:12:\"delete-61851\";i:61092;s:12:\"delete-61854\";i:61093;s:12:\"delete-61855\";i:61094;s:12:\"delete-61852\";i:61095;s:12:\"delete-61853\";i:61096;s:12:\"delete-61856\";i:61097;s:12:\"delete-61859\";i:61098;s:12:\"delete-61860\";i:61099;s:12:\"delete-61857\";i:61100;s:12:\"delete-61858\";i:61101;s:12:\"delete-61861\";i:61102;s:12:\"delete-61864\";i:61103;s:12:\"delete-61865\";i:61104;s:12:\"delete-61862\";i:61105;s:12:\"delete-61863\";i:61106;s:12:\"delete-61866\";i:61107;s:12:\"delete-61869\";i:61108;s:12:\"delete-61870\";i:61109;s:12:\"delete-61867\";i:61110;s:12:\"delete-61868\";i:61111;s:12:\"delete-61871\";i:61112;s:12:\"delete-61874\";i:61113;s:12:\"delete-61875\";i:61114;s:12:\"delete-61872\";i:61115;s:12:\"delete-61873\";i:61116;s:12:\"delete-61876\";i:61117;s:12:\"delete-61879\";i:61118;s:12:\"delete-61877\";i:61119;s:12:\"delete-61878\";i:61120;s:12:\"delete-61880\";i:61121;s:12:\"delete-61881\";i:61122;s:12:\"delete-61884\";i:61123;s:12:\"delete-61885\";i:61124;s:12:\"delete-61882\";i:61125;s:12:\"delete-61883\";i:61126;s:12:\"delete-61886\";i:61127;s:12:\"delete-61889\";i:61128;s:12:\"delete-61887\";i:61129;s:12:\"delete-61888\";i:61130;s:12:\"delete-61890\";i:61131;s:12:\"delete-61891\";i:61132;s:12:\"delete-61894\";i:61133;s:12:\"delete-61895\";i:61134;s:12:\"delete-61892\";i:61135;s:12:\"delete-61893\";i:61136;s:12:\"delete-61896\";i:61137;s:12:\"delete-61899\";i:61138;s:12:\"delete-61900\";i:61139;s:12:\"delete-61897\";i:61140;s:12:\"delete-61898\";i:61141;s:12:\"delete-61901\";i:61142;s:12:\"delete-61904\";i:61143;s:12:\"delete-61905\";i:61144;s:12:\"delete-61902\";i:61145;s:12:\"delete-61903\";i:61146;s:12:\"delete-61906\";i:61147;s:12:\"delete-61909\";i:61148;s:12:\"delete-61907\";i:61149;s:12:\"delete-61908\";i:61150;s:12:\"delete-61910\";i:61151;s:12:\"delete-61911\";i:61152;s:12:\"delete-61914\";i:61153;s:12:\"delete-61915\";i:61154;s:12:\"delete-61912\";i:61155;s:12:\"delete-61913\";i:61156;s:12:\"delete-61916\";i:61157;s:12:\"delete-61919\";i:61158;s:12:\"delete-61920\";i:61159;s:12:\"delete-61917\";i:61160;s:12:\"delete-61918\";i:61161;s:12:\"delete-61921\";i:61162;s:12:\"delete-61924\";i:61163;s:12:\"delete-61925\";i:61164;s:12:\"delete-61922\";i:61165;s:12:\"delete-61923\";i:61166;s:12:\"delete-61926\";i:61167;s:12:\"delete-61929\";i:61168;s:12:\"delete-61930\";i:61169;s:12:\"delete-61931\";i:61170;s:12:\"delete-61934\";i:61171;s:12:\"delete-61935\";i:61172;s:12:\"delete-61936\";i:61173;s:12:\"delete-61939\";i:61174;s:12:\"delete-61940\";i:61175;s:12:\"delete-61941\";i:61176;s:12:\"delete-61944\";i:61177;s:12:\"delete-61945\";i:61178;s:12:\"delete-61927\";i:61179;s:12:\"delete-61928\";i:61180;s:12:\"delete-61932\";i:61181;s:12:\"delete-61933\";i:61182;s:12:\"delete-61937\";i:61183;s:12:\"delete-61938\";i:61184;s:12:\"delete-61942\";i:61185;s:12:\"delete-61943\";i:61186;s:12:\"delete-61946\";i:61187;s:12:\"delete-61949\";i:61188;s:12:\"delete-61950\";i:61189;s:12:\"delete-61947\";i:61190;s:12:\"delete-61948\";i:61191;s:12:\"delete-61951\";i:61192;s:12:\"delete-61954\";i:61193;s:12:\"delete-61955\";i:61194;s:12:\"delete-61952\";i:61195;s:12:\"delete-61953\";i:61196;s:12:\"delete-61956\";i:61197;s:12:\"delete-61959\";i:61198;s:12:\"delete-61960\";i:61199;s:12:\"delete-61957\";i:61200;s:12:\"delete-61958\";i:61201;s:12:\"delete-61961\";i:61202;s:12:\"delete-61964\";i:61203;s:12:\"delete-61962\";i:61204;s:12:\"delete-61963\";i:61205;s:12:\"delete-61965\";i:61206;s:12:\"delete-61966\";i:61207;s:12:\"delete-61969\";i:61208;s:12:\"delete-61967\";i:61209;s:12:\"delete-61968\";i:61210;s:12:\"delete-61970\";i:61211;s:12:\"delete-61971\";i:61212;s:12:\"delete-61974\";i:61213;s:12:\"delete-61972\";i:61214;s:12:\"delete-61973\";i:61215;s:12:\"delete-61975\";i:61216;s:12:\"delete-61976\";i:61217;s:12:\"delete-61979\";i:61218;s:12:\"delete-61977\";i:61219;s:12:\"delete-61978\";i:61220;s:12:\"delete-61980\";i:61221;s:12:\"delete-61981\";i:61222;s:12:\"delete-61984\";i:61223;s:12:\"delete-61982\";i:61224;s:12:\"delete-61983\";i:61225;s:12:\"delete-61985\";i:61226;s:12:\"delete-61986\";i:61227;s:12:\"delete-61989\";i:61228;s:12:\"delete-61987\";i:61229;s:12:\"delete-61988\";i:61230;s:12:\"delete-61990\";i:61231;s:12:\"delete-61991\";i:61232;s:12:\"delete-61994\";i:61233;s:12:\"delete-61992\";i:61234;s:12:\"delete-61993\";i:61235;s:12:\"delete-61995\";i:61236;s:12:\"delete-61996\";i:61237;s:12:\"delete-61999\";i:61238;s:12:\"delete-62000\";i:61239;s:12:\"delete-61997\";i:61240;s:12:\"delete-61998\";i:61241;s:12:\"delete-62001\";i:61242;s:12:\"delete-62004\";i:61243;s:12:\"delete-62005\";i:61244;s:12:\"delete-62002\";i:61245;s:12:\"delete-62003\";i:61246;s:12:\"delete-62006\";i:61247;s:12:\"delete-62009\";i:61248;s:12:\"delete-62010\";i:61249;s:12:\"delete-62007\";i:61250;s:12:\"delete-62008\";i:61251;s:12:\"delete-62011\";i:61252;s:12:\"delete-62014\";i:61253;s:12:\"delete-62015\";i:61254;s:12:\"delete-62012\";i:61255;s:12:\"delete-62013\";i:61256;s:12:\"delete-62016\";i:61257;s:12:\"delete-62019\";i:61258;s:12:\"delete-62020\";i:61259;s:12:\"delete-62017\";i:61260;s:12:\"delete-62018\";i:61261;s:12:\"delete-62021\";i:61262;s:12:\"delete-62024\";i:61263;s:12:\"delete-62025\";i:61264;s:12:\"delete-62022\";i:61265;s:12:\"delete-62023\";i:61266;s:12:\"delete-62026\";i:61267;s:12:\"delete-62029\";i:61268;s:12:\"delete-62030\";i:61269;s:12:\"delete-62027\";i:61270;s:12:\"delete-62028\";i:61271;s:12:\"delete-62031\";i:61272;s:12:\"delete-62034\";i:61273;s:12:\"delete-62035\";i:61274;s:12:\"delete-62032\";i:61275;s:12:\"delete-62033\";i:61276;s:12:\"delete-62036\";i:61277;s:12:\"delete-62039\";i:61278;s:12:\"delete-62040\";i:61279;s:12:\"delete-62037\";i:61280;s:12:\"delete-62038\";i:61281;s:12:\"delete-62041\";i:61282;s:12:\"delete-62044\";i:61283;s:12:\"delete-62045\";i:61284;s:12:\"delete-62042\";i:61285;s:12:\"delete-62043\";i:61286;s:12:\"delete-62046\";i:61287;s:12:\"delete-62049\";i:61288;s:12:\"delete-62050\";i:61289;s:12:\"delete-62047\";i:61290;s:12:\"delete-62048\";i:61291;s:12:\"delete-62051\";i:61292;s:12:\"delete-62054\";i:61293;s:12:\"delete-62055\";i:61294;s:12:\"delete-62052\";i:61295;s:12:\"delete-62053\";i:61296;s:12:\"delete-62056\";i:61297;s:12:\"delete-62059\";i:61298;s:12:\"delete-62057\";i:61299;s:12:\"delete-62058\";i:61300;s:12:\"delete-62060\";i:61301;s:12:\"delete-62061\";i:61302;s:12:\"delete-62064\";i:61303;s:12:\"delete-62065\";i:61304;s:12:\"delete-62062\";i:61305;s:12:\"delete-62063\";i:61306;s:12:\"delete-62066\";i:61307;s:12:\"delete-62069\";i:61308;s:12:\"delete-62070\";i:61309;s:12:\"delete-62067\";i:61310;s:12:\"delete-62068\";i:61311;s:12:\"delete-62071\";i:61312;s:12:\"delete-62074\";i:61313;s:12:\"delete-62072\";i:61314;s:12:\"delete-62073\";i:61315;s:12:\"delete-62075\";i:61316;s:12:\"delete-62076\";i:61317;s:12:\"delete-62079\";i:61318;s:12:\"delete-62080\";i:61319;s:12:\"delete-62077\";i:61320;s:12:\"delete-62078\";i:61321;s:12:\"delete-62081\";i:61322;s:12:\"delete-62084\";i:61323;s:12:\"delete-62085\";i:61324;s:12:\"delete-62082\";i:61325;s:12:\"delete-62083\";i:61326;s:12:\"delete-62086\";i:61327;s:12:\"delete-62089\";i:61328;s:12:\"delete-62090\";i:61329;s:12:\"delete-62087\";i:61330;s:12:\"delete-62088\";i:61331;s:12:\"delete-62091\";i:61332;s:12:\"delete-62094\";i:61333;s:12:\"delete-62095\";i:61334;s:12:\"delete-62092\";i:61335;s:12:\"delete-62093\";i:61336;s:12:\"delete-62096\";i:61337;s:12:\"delete-62099\";i:61338;s:12:\"delete-62100\";i:61339;s:12:\"delete-62097\";i:61340;s:12:\"delete-62098\";i:61341;s:12:\"delete-62101\";i:61342;s:12:\"delete-62104\";i:61343;s:12:\"delete-62105\";i:61344;s:12:\"delete-62102\";i:61345;s:12:\"delete-62103\";i:61346;s:12:\"delete-62106\";i:61347;s:12:\"delete-62109\";i:61348;s:12:\"delete-62110\";i:61349;s:12:\"delete-62107\";i:61350;s:12:\"delete-62108\";i:61351;s:12:\"delete-62111\";i:61352;s:12:\"delete-62114\";i:61353;s:12:\"delete-62115\";i:61354;s:12:\"delete-62112\";i:61355;s:12:\"delete-62113\";i:61356;s:12:\"delete-62116\";i:61357;s:12:\"delete-62119\";i:61358;s:12:\"delete-62120\";i:61359;s:12:\"delete-62117\";i:61360;s:12:\"delete-62118\";i:61361;s:12:\"delete-62121\";i:61362;s:12:\"delete-62124\";i:61363;s:12:\"delete-62125\";i:61364;s:12:\"delete-62122\";i:61365;s:12:\"delete-62123\";i:61366;s:12:\"delete-62126\";i:61367;s:12:\"delete-62129\";i:61368;s:12:\"delete-62130\";i:61369;s:12:\"delete-62127\";i:61370;s:12:\"delete-62128\";i:61371;s:12:\"delete-62131\";i:61372;s:12:\"delete-62134\";i:61373;s:12:\"delete-62135\";i:61374;s:12:\"delete-62132\";i:61375;s:12:\"delete-62133\";i:61376;s:12:\"delete-62136\";i:61377;s:12:\"delete-62139\";i:61378;s:12:\"delete-62140\";i:61379;s:12:\"delete-62137\";i:61380;s:12:\"delete-62138\";i:61381;s:12:\"delete-62141\";i:61382;s:12:\"delete-62144\";i:61383;s:12:\"delete-62145\";i:61384;s:12:\"delete-62142\";i:61385;s:12:\"delete-62143\";i:61386;s:12:\"delete-62146\";i:61387;s:12:\"delete-62149\";i:61388;s:12:\"delete-62150\";i:61389;s:12:\"delete-62147\";i:61390;s:12:\"delete-62148\";i:61391;s:12:\"delete-62151\";i:61392;s:12:\"delete-62154\";i:61393;s:12:\"delete-62155\";i:61394;s:12:\"delete-62152\";i:61395;s:12:\"delete-62153\";i:61396;s:12:\"delete-62156\";i:61397;s:12:\"delete-62159\";i:61398;s:12:\"delete-62160\";i:61399;s:12:\"delete-62157\";i:61400;s:12:\"delete-62158\";i:61401;s:12:\"delete-62161\";i:61402;s:12:\"delete-62164\";i:61403;s:12:\"delete-62165\";i:61404;s:12:\"delete-62162\";i:61405;s:12:\"delete-62163\";i:61406;s:12:\"delete-62166\";i:61407;s:12:\"delete-62169\";i:61408;s:12:\"delete-62170\";i:61409;s:12:\"delete-62167\";i:61410;s:12:\"delete-62168\";i:61411;s:12:\"delete-62171\";i:61412;s:12:\"delete-62174\";i:61413;s:12:\"delete-62175\";i:61414;s:12:\"delete-62172\";i:61415;s:12:\"delete-62173\";i:61416;s:12:\"delete-62176\";i:61417;s:12:\"delete-62179\";i:61418;s:12:\"delete-62180\";i:61419;s:12:\"delete-62177\";i:61420;s:12:\"delete-62178\";i:61421;s:12:\"delete-62181\";i:61422;s:12:\"delete-62184\";i:61423;s:12:\"delete-62185\";i:61424;s:12:\"delete-62182\";i:61425;s:12:\"delete-62183\";i:61426;s:12:\"delete-62186\";i:61427;s:12:\"delete-62189\";i:61428;s:12:\"delete-62190\";i:61429;s:12:\"delete-62187\";i:61430;s:12:\"delete-62188\";i:61431;s:12:\"delete-62191\";i:61432;s:12:\"delete-62194\";i:61433;s:12:\"delete-62195\";i:61434;s:12:\"delete-62192\";i:61435;s:12:\"delete-62193\";i:61436;s:12:\"delete-62196\";i:61437;s:12:\"delete-62199\";i:61438;s:12:\"delete-62200\";i:61439;s:12:\"delete-62197\";i:61440;s:12:\"delete-62198\";i:61441;s:12:\"delete-62201\";i:61442;s:12:\"delete-62204\";i:61443;s:12:\"delete-62205\";i:61444;s:12:\"delete-62202\";i:61445;s:12:\"delete-62203\";i:61446;s:12:\"delete-62206\";i:61447;s:12:\"delete-62209\";i:61448;s:12:\"delete-62210\";i:61449;s:12:\"delete-62207\";i:61450;s:12:\"delete-62208\";i:61451;s:12:\"delete-62211\";i:61452;s:12:\"delete-62214\";i:61453;s:12:\"delete-62215\";i:61454;s:12:\"delete-62212\";i:61455;s:12:\"delete-62213\";i:61456;s:12:\"delete-62216\";i:61457;s:12:\"delete-62219\";i:61458;s:12:\"delete-62220\";i:61459;s:12:\"delete-62217\";i:61460;s:12:\"delete-62218\";i:61461;s:12:\"delete-62221\";i:61462;s:12:\"delete-62224\";i:61463;s:12:\"delete-62225\";i:61464;s:12:\"delete-62222\";i:61465;s:12:\"delete-62223\";i:61466;s:12:\"delete-62226\";i:61467;s:12:\"delete-62229\";i:61468;s:12:\"delete-62230\";i:61469;s:12:\"delete-62227\";i:61470;s:12:\"delete-62228\";i:61471;s:12:\"delete-62231\";i:61472;s:12:\"delete-62234\";i:61473;s:12:\"delete-62235\";i:61474;s:12:\"delete-62232\";i:61475;s:12:\"delete-62233\";i:61476;s:12:\"delete-62236\";i:61477;s:12:\"delete-62239\";i:61478;s:12:\"delete-62240\";i:61479;s:12:\"delete-62237\";i:61480;s:12:\"delete-62238\";i:61481;s:12:\"delete-62241\";i:61482;s:12:\"delete-62244\";i:61483;s:12:\"delete-62245\";i:61484;s:12:\"delete-62242\";i:61485;s:12:\"delete-62243\";i:61486;s:12:\"delete-62246\";i:61487;s:12:\"delete-62247\";i:61488;s:12:\"delete-62248\";i:61489;s:12:\"delete-62249\";i:61490;s:12:\"delete-62250\";i:61491;s:12:\"delete-62251\";i:61492;s:12:\"delete-62254\";i:61493;s:12:\"delete-62252\";i:61494;s:12:\"delete-62253\";i:61495;s:12:\"delete-62255\";i:61496;s:12:\"delete-62256\";i:61497;s:12:\"delete-62259\";i:61498;s:12:\"delete-62260\";i:61499;s:12:\"delete-62257\";i:61500;s:12:\"delete-62258\";i:61501;s:12:\"delete-62261\";i:61502;s:12:\"delete-62264\";i:61503;s:12:\"delete-62265\";i:61504;s:12:\"delete-62262\";i:61505;s:12:\"delete-62263\";i:61506;s:12:\"delete-62266\";i:61507;s:12:\"delete-62269\";i:61508;s:12:\"delete-62270\";i:61509;s:12:\"delete-62267\";i:61510;s:12:\"delete-62268\";i:61511;s:12:\"delete-62271\";i:61512;s:12:\"delete-62274\";i:61513;s:12:\"delete-62275\";i:61514;s:12:\"delete-62272\";i:61515;s:12:\"delete-62273\";i:61516;s:12:\"delete-62276\";i:61517;s:12:\"delete-62279\";i:61518;s:12:\"delete-62280\";i:61519;s:12:\"delete-62277\";i:61520;s:12:\"delete-62278\";i:61521;s:12:\"delete-62281\";i:61522;s:12:\"delete-62284\";i:61523;s:12:\"delete-62285\";i:61524;s:12:\"delete-62282\";i:61525;s:12:\"delete-62283\";i:61526;s:12:\"delete-62286\";i:61527;s:12:\"delete-62289\";i:61528;s:12:\"delete-62290\";i:61529;s:12:\"delete-62287\";i:61530;s:12:\"delete-62288\";i:61531;s:12:\"delete-62291\";i:61532;s:12:\"delete-62294\";i:61533;s:12:\"delete-62295\";i:61534;s:12:\"delete-62292\";i:61535;s:12:\"delete-62293\";i:61536;s:12:\"delete-62296\";i:61537;s:12:\"delete-62299\";i:61538;s:12:\"delete-62300\";i:61539;s:12:\"delete-62297\";i:61540;s:12:\"delete-62298\";i:61541;s:12:\"delete-62301\";i:61542;s:12:\"delete-62304\";i:61543;s:12:\"delete-62305\";i:61544;s:12:\"delete-62302\";i:61545;s:12:\"delete-62303\";i:61546;s:12:\"delete-62306\";i:61547;s:12:\"delete-62309\";i:61548;s:12:\"delete-62310\";i:61549;s:12:\"delete-62307\";i:61550;s:12:\"delete-62308\";i:61551;s:12:\"delete-62311\";i:61552;s:12:\"delete-62314\";i:61553;s:12:\"delete-62315\";i:61554;s:12:\"delete-62312\";i:61555;s:12:\"delete-62313\";i:61556;s:12:\"delete-62316\";i:61557;s:12:\"delete-62319\";i:61558;s:12:\"delete-62320\";i:61559;s:12:\"delete-62317\";i:61560;s:12:\"delete-62318\";i:61561;s:12:\"delete-62321\";i:61562;s:12:\"delete-62324\";i:61563;s:12:\"delete-62325\";i:61564;s:12:\"delete-62322\";i:61565;s:12:\"delete-62323\";i:61566;s:12:\"delete-62326\";i:61567;s:12:\"delete-62329\";i:61568;s:12:\"delete-62330\";i:61569;s:12:\"delete-62327\";i:61570;s:12:\"delete-62328\";i:61571;s:12:\"delete-62331\";i:61572;s:12:\"delete-62334\";i:61573;s:12:\"delete-62335\";i:61574;s:12:\"delete-62332\";i:61575;s:12:\"delete-62333\";i:61576;s:12:\"delete-62336\";i:61577;s:12:\"delete-62339\";i:61578;s:12:\"delete-62340\";i:61579;s:12:\"delete-62337\";i:61580;s:12:\"delete-62338\";i:61581;s:12:\"delete-62341\";i:61582;s:12:\"delete-62344\";i:61583;s:12:\"delete-62345\";i:61584;s:12:\"delete-62342\";i:61585;s:12:\"delete-62343\";i:61586;s:12:\"delete-62346\";i:61587;s:12:\"delete-62349\";i:61588;s:12:\"delete-62347\";i:61589;s:12:\"delete-62348\";i:61590;s:12:\"delete-62350\";i:61591;s:12:\"delete-62351\";i:61592;s:12:\"delete-62354\";i:61593;s:12:\"delete-62355\";i:61594;s:12:\"delete-62352\";i:61595;s:12:\"delete-62353\";i:61596;s:12:\"delete-62356\";i:61597;s:12:\"delete-62359\";i:61598;s:12:\"delete-62360\";i:61599;s:12:\"delete-62357\";i:61600;s:12:\"delete-62358\";i:61601;s:12:\"delete-62361\";i:61602;s:12:\"delete-62364\";i:61603;s:12:\"delete-62365\";i:61604;s:12:\"delete-62362\";i:61605;s:12:\"delete-62363\";i:61606;s:12:\"delete-62366\";i:61607;s:12:\"delete-62369\";i:61608;s:12:\"delete-62367\";i:61609;s:12:\"delete-62368\";i:61610;s:12:\"delete-62370\";i:61611;s:12:\"delete-62371\";i:61612;s:12:\"delete-62374\";i:61613;s:12:\"delete-62375\";i:61614;s:12:\"delete-62372\";i:61615;s:12:\"delete-62373\";i:61616;s:12:\"delete-62376\";i:61617;s:12:\"delete-62379\";i:61618;s:12:\"delete-62380\";i:61619;s:12:\"delete-62377\";i:61620;s:12:\"delete-62378\";i:61621;s:12:\"delete-62381\";i:61622;s:12:\"delete-62384\";i:61623;s:12:\"delete-62385\";i:61624;s:12:\"delete-62383\";i:61625;s:12:\"delete-62382\";i:61626;s:12:\"delete-62386\";i:61627;s:12:\"delete-62389\";i:61628;s:12:\"delete-62390\";i:61629;s:12:\"delete-62388\";i:61630;s:12:\"delete-62387\";i:61631;s:12:\"delete-62391\";i:61632;s:12:\"delete-62394\";i:61633;s:12:\"delete-62395\";i:61634;s:12:\"delete-62393\";i:61635;s:12:\"delete-62392\";i:61636;s:12:\"delete-62396\";i:61637;s:12:\"delete-62399\";i:61638;s:12:\"delete-62400\";i:61639;s:12:\"delete-62398\";i:61640;s:12:\"delete-62397\";i:61641;s:12:\"delete-62401\";i:61642;s:12:\"delete-62404\";i:61643;s:12:\"delete-62405\";i:61644;s:12:\"delete-62403\";i:61645;s:12:\"delete-62402\";i:61646;s:12:\"delete-62406\";i:61647;s:12:\"delete-62409\";i:61648;s:12:\"delete-62410\";i:61649;s:12:\"delete-62408\";i:61650;s:12:\"delete-62407\";i:61651;s:12:\"delete-62411\";i:61652;s:12:\"delete-62414\";i:61653;s:12:\"delete-62415\";i:61654;s:12:\"delete-62413\";i:61655;s:12:\"delete-62412\";i:61656;s:12:\"delete-62416\";i:61657;s:12:\"delete-62419\";i:61658;s:12:\"delete-62420\";i:61659;s:12:\"delete-62418\";i:61660;s:12:\"delete-62417\";i:61661;s:12:\"delete-62421\";i:61662;s:12:\"delete-62424\";i:61663;s:12:\"delete-62423\";i:61664;s:12:\"delete-62422\";i:61665;s:12:\"delete-62425\";i:61666;s:12:\"delete-62426\";i:61667;s:12:\"delete-62429\";i:61668;s:12:\"delete-62430\";i:61669;s:12:\"delete-62428\";i:61670;s:12:\"delete-62427\";i:61671;s:12:\"delete-62431\";i:61672;s:12:\"delete-62434\";i:61673;s:12:\"delete-62435\";i:61674;s:12:\"delete-62433\";i:61675;s:12:\"delete-62432\";i:61676;s:12:\"delete-62436\";i:61677;s:12:\"delete-62439\";i:61678;s:12:\"delete-62440\";i:61679;s:12:\"delete-62438\";i:61680;s:12:\"delete-62437\";i:61681;s:12:\"delete-62444\";i:61682;s:12:\"delete-62441\";i:61683;s:12:\"delete-62445\";i:61684;s:12:\"delete-62443\";i:61685;s:12:\"delete-62442\";i:61686;s:12:\"delete-62446\";i:61687;s:12:\"delete-62449\";i:61688;s:12:\"delete-62448\";i:61689;s:12:\"delete-62447\";i:61690;s:12:\"delete-62453\";i:61691;s:12:\"delete-62450\";i:61692;s:12:\"delete-62454\";i:61693;s:12:\"delete-62452\";i:61694;s:12:\"delete-62451\";i:61695;s:12:\"delete-62455\";i:61696;s:12:\"delete-62458\";i:61697;s:12:\"delete-62457\";i:61698;s:12:\"delete-62456\";i:61699;s:12:\"delete-62459\";i:61700;s:12:\"delete-62460\";i:61701;s:12:\"delete-62463\";i:61702;s:12:\"delete-62464\";i:61703;s:12:\"delete-62462\";i:61704;s:12:\"delete-62461\";i:61705;s:12:\"delete-62465\";i:61706;s:12:\"delete-62468\";i:61707;s:12:\"delete-62469\";i:61708;s:12:\"delete-62467\";i:61709;s:12:\"delete-62466\";i:61710;s:12:\"delete-62470\";i:61711;s:12:\"delete-62473\";i:61712;s:12:\"delete-62474\";i:61713;s:12:\"delete-62472\";i:61714;s:12:\"delete-62471\";i:61715;s:12:\"delete-62478\";i:61716;s:12:\"delete-62475\";i:61717;s:12:\"delete-62479\";i:61718;s:12:\"delete-62477\";i:61719;s:12:\"delete-62476\";i:61720;s:12:\"delete-62480\";i:61721;s:12:\"delete-62483\";i:61722;s:12:\"delete-62484\";i:61723;s:12:\"delete-62482\";i:61724;s:12:\"delete-62481\";i:61725;s:12:\"delete-62485\";i:61726;s:12:\"delete-62488\";i:61727;s:12:\"delete-62489\";i:61728;s:12:\"delete-62487\";i:61729;s:12:\"delete-62486\";i:61730;s:12:\"delete-62490\";i:61731;s:12:\"delete-62493\";i:61732;s:12:\"delete-62494\";i:61733;s:12:\"delete-62492\";i:61734;s:12:\"delete-62491\";i:61735;s:12:\"delete-62495\";i:61736;s:12:\"delete-62498\";i:61737;s:12:\"delete-62499\";i:61738;s:12:\"delete-62497\";i:61739;s:12:\"delete-62496\";i:61740;s:12:\"delete-62500\";i:61741;s:12:\"delete-62503\";i:61742;s:12:\"delete-62504\";i:61743;s:12:\"delete-62502\";i:61744;s:12:\"delete-62501\";i:61745;s:12:\"delete-62505\";i:61746;s:12:\"delete-62508\";i:61747;s:12:\"delete-62509\";i:61748;s:12:\"delete-62507\";i:61749;s:12:\"delete-62506\";i:61750;s:12:\"delete-62510\";i:61751;s:12:\"delete-62513\";i:61752;s:12:\"delete-62514\";i:61753;s:12:\"delete-62512\";i:61754;s:12:\"delete-62511\";i:61755;s:12:\"delete-62515\";i:61756;s:12:\"delete-62518\";i:61757;s:12:\"delete-62517\";i:61758;s:12:\"delete-62516\";i:61759;s:12:\"delete-62519\";i:61760;s:12:\"delete-62520\";i:61761;s:12:\"delete-62523\";i:61762;s:12:\"delete-62524\";i:61763;s:12:\"delete-62522\";i:61764;s:12:\"delete-62521\";i:61765;s:12:\"delete-62525\";i:61766;s:12:\"delete-62528\";i:61767;s:12:\"delete-62529\";i:61768;s:12:\"delete-62527\";i:61769;s:12:\"delete-62526\";i:61770;s:12:\"delete-62530\";i:61771;s:12:\"delete-62533\";i:61772;s:12:\"delete-62534\";i:61773;s:12:\"delete-62532\";i:61774;s:12:\"delete-62531\";i:61775;s:12:\"delete-62535\";i:61776;s:12:\"delete-62538\";i:61777;s:12:\"delete-62539\";i:61778;s:12:\"delete-62536\";i:61779;s:12:\"delete-62537\";i:61780;s:12:\"delete-62540\";i:61781;s:12:\"delete-62543\";i:61782;s:12:\"delete-62544\";i:61783;s:12:\"delete-62541\";i:61784;s:12:\"delete-62542\";i:61785;s:12:\"delete-62545\";i:61786;s:12:\"delete-62548\";i:61787;s:12:\"delete-62549\";i:61788;s:12:\"delete-62546\";i:61789;s:12:\"delete-62547\";i:61790;s:12:\"delete-62550\";i:61791;s:12:\"delete-62553\";i:61792;s:12:\"delete-62554\";i:61793;s:12:\"delete-62551\";i:61794;s:12:\"delete-62552\";i:61795;s:12:\"delete-62555\";i:61796;s:12:\"delete-62558\";i:61797;s:12:\"delete-62559\";i:61798;s:12:\"delete-62556\";i:61799;s:12:\"delete-62557\";i:61800;s:12:\"delete-62560\";i:61801;s:12:\"delete-62563\";i:61802;s:12:\"delete-62564\";i:61803;s:12:\"delete-62561\";i:61804;s:12:\"delete-62562\";i:61805;s:12:\"delete-62565\";i:61806;s:12:\"delete-62568\";i:61807;s:12:\"delete-62569\";i:61808;s:12:\"delete-62566\";i:61809;s:12:\"delete-62567\";i:61810;s:12:\"delete-62570\";i:61811;s:12:\"delete-62573\";i:61812;s:12:\"delete-62571\";i:61813;s:12:\"delete-62572\";i:61814;s:12:\"delete-62574\";i:61815;s:12:\"delete-62575\";i:61816;s:12:\"delete-62578\";i:61817;s:12:\"delete-62579\";i:61818;s:12:\"delete-62576\";i:61819;s:12:\"delete-62577\";i:61820;s:12:\"delete-62580\";i:61821;s:12:\"delete-62583\";i:61822;s:12:\"delete-62584\";i:61823;s:12:\"delete-62581\";i:61824;s:12:\"delete-62582\";i:61825;s:12:\"delete-62585\";i:61826;s:12:\"delete-62588\";i:61827;s:12:\"delete-62586\";i:61828;s:12:\"delete-62587\";i:61829;s:12:\"delete-62589\";i:61830;s:12:\"delete-62590\";i:61831;s:12:\"delete-62593\";i:61832;s:12:\"delete-62594\";i:61833;s:12:\"delete-62592\";i:61834;s:12:\"delete-62591\";i:61835;s:12:\"delete-62595\";i:61836;s:12:\"delete-62598\";i:61837;s:12:\"delete-62599\";i:61838;s:12:\"delete-62597\";i:61839;s:12:\"delete-62596\";i:61840;s:12:\"delete-62600\";i:61841;s:12:\"delete-62603\";i:61842;s:12:\"delete-62604\";i:61843;s:12:\"delete-62602\";i:61844;s:12:\"delete-62601\";i:61845;s:12:\"delete-62608\";i:61846;s:12:\"delete-62605\";i:61847;s:12:\"delete-62609\";i:61848;s:12:\"delete-62607\";i:61849;s:12:\"delete-62606\";i:61850;s:12:\"delete-62610\";i:61851;s:12:\"delete-62613\";i:61852;s:12:\"delete-62614\";i:61853;s:12:\"delete-62612\";i:61854;s:12:\"delete-62611\";i:61855;s:12:\"delete-62615\";i:61856;s:12:\"delete-62618\";i:61857;s:12:\"delete-62617\";i:61858;s:12:\"delete-62616\";i:61859;s:12:\"delete-62619\";i:61860;s:12:\"delete-62620\";i:61861;s:12:\"delete-62623\";i:61862;s:12:\"delete-62624\";i:61863;s:12:\"delete-62621\";i:61864;s:12:\"delete-62622\";i:61865;s:12:\"delete-62625\";i:61866;s:12:\"delete-62628\";i:61867;s:12:\"delete-62629\";i:61868;s:12:\"delete-62626\";i:61869;s:12:\"delete-62627\";i:61870;s:12:\"delete-62630\";i:61871;s:12:\"delete-62633\";i:61872;s:12:\"delete-62634\";i:61873;s:12:\"delete-62631\";i:61874;s:12:\"delete-62632\";i:61875;s:12:\"delete-62635\";i:61876;s:12:\"delete-62638\";i:61877;s:12:\"delete-62639\";i:61878;s:12:\"delete-62636\";i:61879;s:12:\"delete-62637\";i:61880;s:12:\"delete-62640\";i:61881;s:12:\"delete-62643\";i:61882;s:12:\"delete-62641\";i:61883;s:12:\"delete-62642\";i:61884;s:12:\"delete-62644\";i:61885;s:12:\"delete-62645\";i:61886;s:12:\"delete-62648\";i:61887;s:12:\"delete-62649\";i:61888;s:12:\"delete-62646\";i:61889;s:12:\"delete-62647\";i:61890;s:12:\"delete-62650\";i:61891;s:12:\"delete-62653\";i:61892;s:12:\"delete-62654\";i:61893;s:12:\"delete-62651\";i:61894;s:12:\"delete-62652\";i:61895;s:12:\"delete-62655\";i:61896;s:12:\"delete-62658\";i:61897;s:12:\"delete-62659\";i:61898;s:12:\"delete-62656\";i:61899;s:12:\"delete-62657\";i:61900;s:12:\"delete-62660\";i:61901;s:12:\"delete-62663\";i:61902;s:12:\"delete-62664\";i:61903;s:12:\"delete-62661\";i:61904;s:12:\"delete-62662\";i:61905;s:12:\"delete-62665\";i:61906;s:12:\"delete-62668\";i:61907;s:12:\"delete-62669\";i:61908;s:12:\"delete-62666\";i:61909;s:12:\"delete-62667\";i:61910;s:12:\"delete-62670\";i:61911;s:12:\"delete-62673\";i:61912;s:12:\"delete-62674\";i:61913;s:12:\"delete-62671\";i:61914;s:12:\"delete-62672\";i:61915;s:12:\"delete-62675\";i:61916;s:12:\"delete-62678\";i:61917;s:12:\"delete-62679\";i:61918;s:12:\"delete-62676\";i:61919;s:12:\"delete-62677\";i:61920;s:12:\"delete-62680\";i:61921;s:12:\"delete-62683\";i:61922;s:12:\"delete-62684\";i:61923;s:12:\"delete-62681\";i:61924;s:12:\"delete-62682\";i:61925;s:12:\"delete-62685\";i:61926;s:12:\"delete-62688\";i:61927;s:12:\"delete-62689\";i:61928;s:12:\"delete-62686\";i:61929;s:12:\"delete-62687\";i:61930;s:12:\"delete-62690\";i:61931;s:12:\"delete-62693\";i:61932;s:12:\"delete-62694\";i:61933;s:12:\"delete-62691\";i:61934;s:12:\"delete-62692\";i:61935;s:12:\"delete-62695\";i:61936;s:12:\"delete-62698\";i:61937;s:12:\"delete-62699\";i:61938;s:12:\"delete-62696\";i:61939;s:12:\"delete-62697\";i:61940;s:12:\"delete-62700\";i:61941;s:12:\"delete-62703\";i:61942;s:12:\"delete-62704\";i:61943;s:12:\"delete-62701\";i:61944;s:12:\"delete-62702\";i:61945;s:12:\"delete-62705\";i:61946;s:12:\"delete-62708\";i:61947;s:12:\"delete-62709\";i:61948;s:12:\"delete-62706\";i:61949;s:12:\"delete-62707\";i:61950;s:12:\"delete-62710\";i:61951;s:12:\"delete-62713\";i:61952;s:12:\"delete-62714\";i:61953;s:12:\"delete-62711\";i:61954;s:12:\"delete-62712\";i:61955;s:12:\"delete-62715\";i:61956;s:12:\"delete-62718\";i:61957;s:12:\"delete-62719\";i:61958;s:12:\"delete-62716\";i:61959;s:12:\"delete-62717\";i:61960;s:12:\"delete-62720\";i:61961;s:12:\"delete-62723\";i:61962;s:12:\"delete-62724\";i:61963;s:12:\"delete-62721\";i:61964;s:12:\"delete-62722\";i:61965;s:12:\"delete-62725\";i:61966;s:12:\"delete-62728\";i:61967;s:12:\"delete-62729\";i:61968;s:12:\"delete-62726\";i:61969;s:12:\"delete-62727\";i:61970;s:12:\"delete-62730\";i:61971;s:12:\"delete-62733\";i:61972;s:12:\"delete-62734\";i:61973;s:12:\"delete-62731\";i:61974;s:12:\"delete-62732\";i:61975;s:12:\"delete-62735\";i:61976;s:12:\"delete-62738\";i:61977;s:12:\"delete-62739\";i:61978;s:12:\"delete-62736\";i:61979;s:12:\"delete-62737\";i:61980;s:12:\"delete-62740\";i:61981;s:12:\"delete-62743\";i:61982;s:12:\"delete-62744\";i:61983;s:12:\"delete-62741\";i:61984;s:12:\"delete-62742\";i:61985;s:12:\"delete-62745\";i:61986;s:12:\"delete-62748\";i:61987;s:12:\"delete-62749\";i:61988;s:12:\"delete-62746\";i:61989;s:12:\"delete-62747\";i:61990;s:12:\"delete-62750\";i:61991;s:12:\"delete-62753\";i:61992;s:12:\"delete-62751\";i:61993;s:12:\"delete-62752\";i:61994;s:12:\"delete-62754\";i:61995;s:12:\"delete-62755\";i:61996;s:12:\"delete-62758\";i:61997;s:12:\"delete-62759\";i:61998;s:12:\"delete-62756\";i:61999;s:12:\"delete-62757\";i:62000;s:12:\"delete-62760\";i:62001;s:12:\"delete-62763\";i:62002;s:12:\"delete-62764\";i:62003;s:12:\"delete-62761\";i:62004;s:12:\"delete-62762\";i:62005;s:12:\"delete-62765\";i:62006;s:12:\"delete-62768\";i:62007;s:12:\"delete-62769\";i:62008;s:12:\"delete-62766\";i:62009;s:12:\"delete-62767\";i:62010;s:12:\"delete-62770\";i:62011;s:12:\"delete-62773\";i:62012;s:12:\"delete-62771\";i:62013;s:12:\"delete-62772\";i:62014;s:12:\"delete-62774\";i:62015;s:12:\"delete-62775\";i:62016;s:12:\"delete-62778\";i:62017;s:12:\"delete-62779\";i:62018;s:12:\"delete-62776\";i:62019;s:12:\"delete-62777\";i:62020;s:12:\"delete-62780\";i:62021;s:12:\"delete-62783\";i:62022;s:12:\"delete-62784\";i:62023;s:12:\"delete-62781\";i:62024;s:12:\"delete-62782\";i:62025;s:12:\"delete-62785\";i:62026;s:12:\"delete-62788\";i:62027;s:12:\"delete-62789\";i:62028;s:12:\"delete-62786\";i:62029;s:12:\"delete-62787\";i:62030;s:12:\"delete-62790\";i:62031;s:12:\"delete-62793\";i:62032;s:12:\"delete-62794\";i:62033;s:12:\"delete-62791\";i:62034;s:12:\"delete-62792\";i:62035;s:12:\"delete-62795\";i:62036;s:12:\"delete-62798\";i:62037;s:12:\"delete-62799\";i:62038;s:12:\"delete-62796\";i:62039;s:12:\"delete-62797\";i:62040;s:12:\"delete-62800\";i:62041;s:12:\"delete-62803\";i:62042;s:12:\"delete-62804\";i:62043;s:12:\"delete-62801\";i:62044;s:12:\"delete-62802\";i:62045;s:12:\"delete-62805\";i:62046;s:12:\"delete-62808\";i:62047;s:12:\"delete-62809\";i:62048;s:12:\"delete-62806\";i:62049;s:12:\"delete-62807\";i:62050;s:12:\"delete-62810\";i:62051;s:12:\"delete-62813\";i:62052;s:12:\"delete-62814\";i:62053;s:12:\"delete-62811\";i:62054;s:12:\"delete-62812\";i:62055;s:12:\"delete-62815\";i:62056;s:12:\"delete-62818\";i:62057;s:12:\"delete-62819\";i:62058;s:12:\"delete-62816\";i:62059;s:12:\"delete-62817\";i:62060;s:12:\"delete-62820\";i:62061;s:12:\"delete-62823\";i:62062;s:12:\"delete-62824\";i:62063;s:12:\"delete-62821\";i:62064;s:12:\"delete-62822\";i:62065;s:12:\"delete-62825\";i:62066;s:12:\"delete-62828\";i:62067;s:12:\"delete-62829\";i:62068;s:12:\"delete-62826\";i:62069;s:12:\"delete-62827\";i:62070;s:12:\"delete-62830\";i:62071;s:12:\"delete-62833\";i:62072;s:12:\"delete-62834\";i:62073;s:12:\"delete-62831\";i:62074;s:12:\"delete-62832\";i:62075;s:12:\"delete-62835\";i:62076;s:12:\"delete-62838\";i:62077;s:12:\"delete-62839\";i:62078;s:12:\"delete-62836\";i:62079;s:12:\"delete-62837\";i:62080;s:12:\"delete-62840\";i:62081;s:12:\"delete-62843\";i:62082;s:12:\"delete-62844\";i:62083;s:12:\"delete-62841\";i:62084;s:12:\"delete-62842\";i:62085;s:12:\"delete-62845\";i:62086;s:12:\"delete-62848\";i:62087;s:12:\"delete-62849\";i:62088;s:12:\"delete-62846\";i:62089;s:12:\"delete-62847\";i:62090;s:12:\"delete-62850\";i:62091;s:12:\"delete-62853\";i:62092;s:12:\"delete-62854\";i:62093;s:12:\"delete-62851\";i:62094;s:12:\"delete-62852\";i:62095;s:12:\"delete-62855\";i:62096;s:12:\"delete-62858\";i:62097;s:12:\"delete-62859\";i:62098;s:12:\"delete-62856\";i:62099;s:12:\"delete-62857\";i:62100;s:12:\"delete-62860\";i:62101;s:12:\"delete-62863\";i:62102;s:12:\"delete-62864\";i:62103;s:12:\"delete-62861\";i:62104;s:12:\"delete-62862\";i:62105;s:12:\"delete-62865\";i:62106;s:12:\"delete-62868\";i:62107;s:12:\"delete-62869\";i:62108;s:12:\"delete-62866\";i:62109;s:12:\"delete-62867\";i:62110;s:12:\"delete-62870\";i:62111;s:12:\"delete-62873\";i:62112;s:12:\"delete-62874\";i:62113;s:12:\"delete-62871\";i:62114;s:12:\"delete-62872\";i:62115;s:12:\"delete-62875\";i:62116;s:12:\"delete-62878\";i:62117;s:12:\"delete-62879\";i:62118;s:12:\"delete-62876\";i:62119;s:12:\"delete-62877\";i:62120;s:12:\"delete-62880\";i:62121;s:12:\"delete-62883\";i:62122;s:12:\"delete-62884\";i:62123;s:12:\"delete-62881\";i:62124;s:12:\"delete-62882\";i:62125;s:12:\"delete-62885\";i:62126;s:12:\"delete-62888\";i:62127;s:12:\"delete-62889\";i:62128;s:12:\"delete-62886\";i:62129;s:12:\"delete-62887\";i:62130;s:12:\"delete-62890\";i:62131;s:12:\"delete-62893\";i:62132;s:12:\"delete-62894\";i:62133;s:12:\"delete-62891\";i:62134;s:12:\"delete-62892\";i:62135;s:12:\"delete-62895\";i:62136;s:12:\"delete-62898\";i:62137;s:12:\"delete-62899\";i:62138;s:12:\"delete-62896\";i:62139;s:12:\"delete-62897\";i:62140;s:12:\"delete-62900\";i:62141;s:12:\"delete-62903\";i:62142;s:12:\"delete-62904\";i:62143;s:12:\"delete-62901\";i:62144;s:12:\"delete-62902\";i:62145;s:12:\"delete-62905\";i:62146;s:12:\"delete-62908\";i:62147;s:12:\"delete-62909\";i:62148;s:12:\"delete-62906\";i:62149;s:12:\"delete-62907\";i:62150;s:12:\"delete-62910\";i:62151;s:12:\"delete-62913\";i:62152;s:12:\"delete-62914\";i:62153;s:12:\"delete-62911\";i:62154;s:12:\"delete-62912\";i:62155;s:12:\"delete-62915\";i:62156;s:12:\"delete-62918\";i:62157;s:12:\"delete-62919\";i:62158;s:12:\"delete-62916\";i:62159;s:12:\"delete-62917\";i:62160;s:12:\"delete-62920\";i:62161;s:12:\"delete-62923\";i:62162;s:12:\"delete-62924\";i:62163;s:12:\"delete-62921\";i:62164;s:12:\"delete-62922\";i:62165;s:12:\"delete-62925\";i:62166;s:12:\"delete-62928\";i:62167;s:12:\"delete-62929\";i:62168;s:12:\"delete-62926\";i:62169;s:12:\"delete-62927\";i:62170;s:12:\"delete-62930\";i:62171;s:12:\"delete-62933\";i:62172;s:12:\"delete-62931\";i:62173;s:12:\"delete-62932\";i:62174;s:12:\"delete-62934\";i:62175;s:12:\"delete-62935\";i:62176;s:12:\"delete-62938\";i:62177;s:12:\"delete-62939\";i:62178;s:12:\"delete-62936\";i:62179;s:12:\"delete-62937\";i:62180;s:12:\"delete-62940\";i:62181;s:12:\"delete-62943\";i:62182;s:12:\"delete-62944\";i:62183;s:12:\"delete-62941\";i:62184;s:12:\"delete-62942\";i:62185;s:12:\"delete-62945\";i:62186;s:12:\"delete-62948\";i:62187;s:12:\"delete-62946\";i:62188;s:12:\"delete-62947\";i:62189;s:12:\"delete-62949\";i:62190;s:12:\"delete-62950\";i:62191;s:12:\"delete-62953\";i:62192;s:12:\"delete-62954\";i:62193;s:12:\"delete-62951\";i:62194;s:12:\"delete-62952\";i:62195;s:12:\"delete-62955\";i:62196;s:12:\"delete-62958\";i:62197;s:12:\"delete-62956\";i:62198;s:12:\"delete-62957\";i:62199;s:12:\"delete-62959\";i:62200;s:12:\"delete-62960\";i:62201;s:12:\"delete-62963\";i:62202;s:12:\"delete-62964\";i:62203;s:12:\"delete-62961\";i:62204;s:12:\"delete-62962\";i:62205;s:12:\"delete-62965\";i:62206;s:12:\"delete-62968\";i:62207;s:12:\"delete-62969\";i:62208;s:12:\"delete-62966\";i:62209;s:12:\"delete-62967\";i:62210;s:12:\"delete-62970\";i:62211;s:12:\"delete-62973\";i:62212;s:12:\"delete-62974\";i:62213;s:12:\"delete-62971\";i:62214;s:12:\"delete-62972\";i:62215;s:12:\"delete-62975\";i:62216;s:12:\"delete-62978\";i:62217;s:12:\"delete-62979\";i:62218;s:12:\"delete-62976\";i:62219;s:12:\"delete-62977\";i:62220;s:12:\"delete-62980\";i:62221;s:12:\"delete-62983\";i:62222;s:12:\"delete-62984\";i:62223;s:12:\"delete-62981\";i:62224;s:12:\"delete-62982\";i:62225;s:12:\"delete-62985\";i:62226;s:12:\"delete-62988\";i:62227;s:12:\"delete-62989\";i:62228;s:12:\"delete-62986\";i:62229;s:12:\"delete-62987\";i:62230;s:12:\"delete-62990\";i:62231;s:12:\"delete-62993\";i:62232;s:12:\"delete-62991\";i:62233;s:12:\"delete-62992\";i:62234;s:12:\"delete-62994\";i:62235;s:12:\"delete-62995\";i:62236;s:12:\"delete-62998\";i:62237;s:12:\"delete-62999\";i:62238;s:12:\"delete-62996\";i:62239;s:12:\"delete-62997\";i:62240;s:12:\"delete-63000\";i:62241;s:12:\"delete-63003\";i:62242;s:12:\"delete-63004\";i:62243;s:12:\"delete-63001\";i:62244;s:12:\"delete-63002\";i:62245;s:12:\"delete-63005\";i:62246;s:12:\"delete-63008\";i:62247;s:12:\"delete-63009\";i:62248;s:12:\"delete-63006\";i:62249;s:12:\"delete-63007\";i:62250;s:12:\"delete-63010\";i:62251;s:12:\"delete-63013\";i:62252;s:12:\"delete-63014\";i:62253;s:12:\"delete-63011\";i:62254;s:12:\"delete-63012\";i:62255;s:12:\"delete-63015\";i:62256;s:12:\"delete-63018\";i:62257;s:12:\"delete-63019\";i:62258;s:12:\"delete-63016\";i:62259;s:12:\"delete-63017\";i:62260;s:12:\"delete-63020\";i:62261;s:12:\"delete-63023\";i:62262;s:12:\"delete-63021\";i:62263;s:12:\"delete-63022\";i:62264;s:12:\"delete-63024\";i:62265;s:12:\"delete-63025\";i:62266;s:12:\"delete-63028\";i:62267;s:12:\"delete-63029\";i:62268;s:12:\"delete-63026\";i:62269;s:12:\"delete-63027\";i:62270;s:12:\"delete-63030\";i:62271;s:12:\"delete-63033\";i:62272;s:12:\"delete-63034\";i:62273;s:12:\"delete-63031\";i:62274;s:12:\"delete-63032\";i:62275;s:12:\"delete-63035\";i:62276;s:12:\"delete-63038\";i:62277;s:12:\"delete-63036\";i:62278;s:12:\"delete-63037\";i:62279;s:12:\"delete-63039\";i:62280;s:12:\"delete-63040\";i:62281;s:12:\"delete-63043\";i:62282;s:12:\"delete-63044\";i:62283;s:12:\"delete-63041\";i:62284;s:12:\"delete-63042\";i:62285;s:12:\"delete-63045\";i:62286;s:12:\"delete-63048\";i:62287;s:12:\"delete-63049\";i:62288;s:12:\"delete-63046\";i:62289;s:12:\"delete-63047\";i:62290;s:12:\"delete-63050\";i:62291;s:12:\"delete-63053\";i:62292;s:12:\"delete-63054\";i:62293;s:12:\"delete-63051\";i:62294;s:12:\"delete-63052\";i:62295;s:12:\"delete-63055\";i:62296;s:12:\"delete-63058\";i:62297;s:12:\"delete-63059\";i:62298;s:12:\"delete-63056\";i:62299;s:12:\"delete-63057\";i:62300;s:12:\"delete-63060\";i:62301;s:12:\"delete-63063\";i:62302;s:12:\"delete-63064\";i:62303;s:12:\"delete-63061\";i:62304;s:12:\"delete-63062\";i:62305;s:12:\"delete-63065\";i:62306;s:12:\"delete-63068\";i:62307;s:12:\"delete-63069\";i:62308;s:12:\"delete-63066\";i:62309;s:12:\"delete-63067\";i:62310;s:12:\"delete-63070\";i:62311;s:12:\"delete-63073\";i:62312;s:12:\"delete-63074\";i:62313;s:12:\"delete-63071\";i:62314;s:12:\"delete-63072\";i:62315;s:12:\"delete-63075\";i:62316;s:12:\"delete-63078\";i:62317;s:12:\"delete-63079\";i:62318;s:12:\"delete-63076\";i:62319;s:12:\"delete-63077\";i:62320;s:12:\"delete-63080\";i:62321;s:12:\"delete-63083\";i:62322;s:12:\"delete-63084\";i:62323;s:12:\"delete-63081\";i:62324;s:12:\"delete-63082\";i:62325;s:12:\"delete-63085\";i:62326;s:12:\"delete-63088\";i:62327;s:12:\"delete-63089\";i:62328;s:12:\"delete-63086\";i:62329;s:12:\"delete-63087\";i:62330;s:12:\"delete-63090\";i:62331;s:12:\"delete-63093\";i:62332;s:12:\"delete-63094\";i:62333;s:12:\"delete-63091\";i:62334;s:12:\"delete-63092\";i:62335;s:12:\"delete-63095\";i:62336;s:12:\"delete-63098\";i:62337;s:12:\"delete-63099\";i:62338;s:12:\"delete-63096\";i:62339;s:12:\"delete-63097\";i:62340;s:12:\"delete-63100\";i:62341;s:12:\"delete-63103\";i:62342;s:12:\"delete-63104\";i:62343;s:12:\"delete-63101\";i:62344;s:12:\"delete-63102\";i:62345;s:12:\"delete-63105\";i:62346;s:12:\"delete-63108\";i:62347;s:12:\"delete-63106\";i:62348;s:12:\"delete-63107\";i:62349;s:12:\"delete-63109\";i:62350;s:12:\"delete-63110\";i:62351;s:12:\"delete-63113\";i:62352;s:12:\"delete-63114\";i:62353;s:12:\"delete-63111\";i:62354;s:12:\"delete-63112\";i:62355;s:12:\"delete-63115\";i:62356;s:12:\"delete-63118\";i:62357;s:12:\"delete-63119\";i:62358;s:12:\"delete-63116\";i:62359;s:12:\"delete-63117\";i:62360;s:12:\"delete-63120\";i:62361;s:12:\"delete-63123\";i:62362;s:12:\"delete-63121\";i:62363;s:12:\"delete-63122\";i:62364;s:12:\"delete-63124\";i:62365;s:12:\"delete-63125\";i:62366;s:12:\"delete-63128\";i:62367;s:12:\"delete-63129\";i:62368;s:12:\"delete-63126\";i:62369;s:12:\"delete-63127\";i:62370;s:12:\"delete-63130\";i:62371;s:12:\"delete-63133\";i:62372;s:12:\"delete-63134\";i:62373;s:12:\"delete-63131\";i:62374;s:12:\"delete-63132\";i:62375;s:12:\"delete-63135\";i:62376;s:12:\"delete-63138\";i:62377;s:12:\"delete-63139\";i:62378;s:12:\"delete-63136\";i:62379;s:12:\"delete-63137\";i:62380;s:12:\"delete-63140\";i:62381;s:12:\"delete-63143\";i:62382;s:12:\"delete-63141\";i:62383;s:12:\"delete-63142\";i:62384;s:12:\"delete-63144\";i:62385;s:12:\"delete-63145\";i:62386;s:12:\"delete-63148\";i:62387;s:12:\"delete-63149\";i:62388;s:12:\"delete-63146\";i:62389;s:12:\"delete-63147\";i:62390;s:12:\"delete-63150\";i:62391;s:12:\"delete-63153\";i:62392;s:12:\"delete-63151\";i:62393;s:12:\"delete-63152\";i:62394;s:12:\"delete-63154\";i:62395;s:12:\"delete-63155\";i:62396;s:12:\"delete-63158\";i:62397;s:12:\"delete-63159\";i:62398;s:12:\"delete-63156\";i:62399;s:12:\"delete-63157\";i:62400;s:12:\"delete-63160\";i:62401;s:12:\"delete-63163\";i:62402;s:12:\"delete-63164\";i:62403;s:12:\"delete-63161\";i:62404;s:12:\"delete-63162\";i:62405;s:12:\"delete-63165\";i:62406;s:12:\"delete-63168\";i:62407;s:12:\"delete-63169\";i:62408;s:12:\"delete-63166\";i:62409;s:12:\"delete-63167\";i:62410;s:12:\"delete-63170\";i:62411;s:12:\"delete-63173\";i:62412;s:12:\"delete-63174\";i:62413;s:12:\"delete-63171\";i:62414;s:12:\"delete-63172\";i:62415;s:12:\"delete-63175\";i:62416;s:12:\"delete-63178\";i:62417;s:12:\"delete-63179\";i:62418;s:12:\"delete-63176\";i:62419;s:12:\"delete-63177\";i:62420;s:12:\"delete-63180\";i:62421;s:12:\"delete-63183\";i:62422;s:12:\"delete-63184\";i:62423;s:12:\"delete-63181\";i:62424;s:12:\"delete-63182\";i:62425;s:12:\"delete-63185\";i:62426;s:12:\"delete-63188\";i:62427;s:12:\"delete-63186\";i:62428;s:12:\"delete-63187\";i:62429;s:12:\"delete-63189\";i:62430;s:12:\"delete-63190\";i:62431;s:12:\"delete-63193\";i:62432;s:12:\"delete-63194\";i:62433;s:12:\"delete-63191\";i:62434;s:12:\"delete-63192\";i:62435;s:12:\"delete-63195\";i:62436;s:12:\"delete-63198\";i:62437;s:12:\"delete-63199\";i:62438;s:12:\"delete-63196\";i:62439;s:12:\"delete-63197\";i:62440;s:12:\"delete-63200\";i:62441;s:12:\"delete-63203\";i:62442;s:12:\"delete-63204\";i:62443;s:12:\"delete-63201\";i:62444;s:12:\"delete-63202\";i:62445;s:12:\"delete-63205\";i:62446;s:12:\"delete-63208\";i:62447;s:12:\"delete-63209\";i:62448;s:12:\"delete-63206\";i:62449;s:12:\"delete-63207\";i:62450;s:12:\"delete-63210\";i:62451;s:12:\"delete-63213\";i:62452;s:12:\"delete-63214\";i:62453;s:12:\"delete-63211\";i:62454;s:12:\"delete-63212\";i:62455;s:12:\"delete-63215\";i:62456;s:12:\"delete-63218\";i:62457;s:12:\"delete-63216\";i:62458;s:12:\"delete-63217\";i:62459;s:12:\"delete-63219\";i:62460;s:12:\"delete-63220\";i:62461;s:12:\"delete-63223\";i:62462;s:12:\"delete-63224\";i:62463;s:12:\"delete-63221\";i:62464;s:12:\"delete-63222\";i:62465;s:12:\"delete-63225\";i:62466;s:12:\"delete-63228\";i:62467;s:12:\"delete-63226\";i:62468;s:12:\"delete-63227\";i:62469;s:12:\"delete-63229\";i:62470;s:12:\"delete-63230\";i:62471;s:12:\"delete-63233\";i:62472;s:12:\"delete-63231\";i:62473;s:12:\"delete-63232\";i:62474;s:12:\"delete-63234\";i:62475;s:12:\"delete-63235\";i:62476;s:12:\"delete-63238\";i:62477;s:12:\"delete-63236\";i:62478;s:12:\"delete-63237\";i:62479;s:12:\"delete-63239\";i:62480;s:12:\"delete-63240\";i:62481;s:12:\"delete-63243\";i:62482;s:12:\"delete-63244\";i:62483;s:12:\"delete-63241\";i:62484;s:12:\"delete-63242\";i:62485;s:12:\"delete-63245\";i:62486;s:12:\"delete-63248\";i:62487;s:12:\"delete-63249\";i:62488;s:12:\"delete-63246\";i:62489;s:12:\"delete-63247\";i:62490;s:12:\"delete-63250\";i:62491;s:12:\"delete-63253\";i:62492;s:12:\"delete-63254\";i:62493;s:12:\"delete-63251\";i:62494;s:12:\"delete-63252\";i:62495;s:12:\"delete-63255\";i:62496;s:12:\"delete-63258\";i:62497;s:12:\"delete-63259\";i:62498;s:12:\"delete-63256\";i:62499;s:12:\"delete-63257\";i:62500;s:12:\"delete-63260\";i:62501;s:12:\"delete-63263\";i:62502;s:12:\"delete-63261\";i:62503;s:12:\"delete-63262\";i:62504;s:12:\"delete-63264\";i:62505;s:12:\"delete-63265\";i:62506;s:12:\"delete-63268\";i:62507;s:12:\"delete-63269\";i:62508;s:12:\"delete-63266\";i:62509;s:12:\"delete-63267\";i:62510;s:12:\"delete-63270\";i:62511;s:12:\"delete-63273\";i:62512;s:12:\"delete-63274\";i:62513;s:12:\"delete-63271\";i:62514;s:12:\"delete-63272\";i:62515;s:12:\"delete-63275\";i:62516;s:12:\"delete-63278\";i:62517;s:12:\"delete-63279\";i:62518;s:12:\"delete-63276\";i:62519;s:12:\"delete-63277\";i:62520;s:12:\"delete-63280\";i:62521;s:12:\"delete-63283\";i:62522;s:12:\"delete-63281\";i:62523;s:12:\"delete-63282\";i:62524;s:12:\"delete-63284\";i:62525;s:12:\"delete-63285\";i:62526;s:12:\"delete-63288\";i:62527;s:12:\"delete-63286\";i:62528;s:12:\"delete-63287\";i:62529;s:12:\"delete-63289\";i:62530;s:12:\"delete-63290\";i:62531;s:12:\"delete-63293\";i:62532;s:12:\"delete-63294\";i:62533;s:12:\"delete-63291\";i:62534;s:12:\"delete-63292\";i:62535;s:12:\"delete-63295\";i:62536;s:12:\"delete-63296\";i:62537;s:12:\"delete-63297\";i:62538;s:12:\"delete-63298\";i:62539;s:12:\"delete-63299\";i:62540;s:12:\"delete-63300\";i:62541;s:12:\"delete-63303\";i:62542;s:12:\"delete-63304\";i:62543;s:12:\"delete-63301\";i:62544;s:12:\"delete-63302\";i:62545;s:12:\"delete-63305\";i:62546;s:12:\"delete-63308\";i:62547;s:12:\"delete-63309\";i:62548;s:12:\"delete-63306\";i:62549;s:12:\"delete-63307\";i:62550;s:12:\"delete-63310\";i:62551;s:12:\"delete-63313\";i:62552;s:12:\"delete-63314\";i:62553;s:12:\"delete-63311\";i:62554;s:12:\"delete-63312\";i:62555;s:12:\"delete-63315\";i:62556;s:12:\"delete-63318\";i:62557;s:12:\"delete-63319\";i:62558;s:12:\"delete-63316\";i:62559;s:12:\"delete-63317\";i:62560;s:12:\"delete-63320\";i:62561;s:12:\"delete-63323\";i:62562;s:12:\"delete-63324\";i:62563;s:12:\"delete-63321\";i:62564;s:12:\"delete-63322\";i:62565;s:12:\"delete-63325\";i:62566;s:12:\"delete-63328\";i:62567;s:12:\"delete-63329\";i:62568;s:12:\"delete-63326\";i:62569;s:12:\"delete-63327\";i:62570;s:12:\"delete-63330\";i:62571;s:12:\"delete-63333\";i:62572;s:12:\"delete-63334\";i:62573;s:12:\"delete-63331\";i:62574;s:12:\"delete-63332\";i:62575;s:12:\"delete-63335\";i:62576;s:12:\"delete-63338\";i:62577;s:12:\"delete-63339\";i:62578;s:12:\"delete-63336\";i:62579;s:12:\"delete-63337\";i:62580;s:12:\"delete-63340\";i:62581;s:12:\"delete-63343\";i:62582;s:12:\"delete-63344\";i:62583;s:12:\"delete-63341\";i:62584;s:12:\"delete-63342\";i:62585;s:12:\"delete-63345\";i:62586;s:12:\"delete-63348\";i:62587;s:12:\"delete-63349\";i:62588;s:12:\"delete-63346\";i:62589;s:12:\"delete-63347\";i:62590;s:12:\"delete-63350\";i:62591;s:12:\"delete-63353\";i:62592;s:12:\"delete-63354\";i:62593;s:12:\"delete-63351\";i:62594;s:12:\"delete-63352\";i:62595;s:12:\"delete-63355\";i:62596;s:12:\"delete-63358\";i:62597;s:12:\"delete-63356\";i:62598;s:12:\"delete-63357\";i:62599;s:12:\"delete-63359\";i:62600;s:12:\"delete-63360\";i:62601;s:12:\"delete-63363\";i:62602;s:12:\"delete-63361\";i:62603;s:12:\"delete-63362\";i:62604;s:12:\"delete-63364\";i:62605;s:12:\"delete-63365\";i:62606;s:12:\"delete-63368\";i:62607;s:12:\"delete-63369\";i:62608;s:12:\"delete-63366\";i:62609;s:12:\"delete-63367\";i:62610;s:12:\"delete-63370\";i:62611;s:12:\"delete-63373\";i:62612;s:12:\"delete-63374\";i:62613;s:12:\"delete-63371\";i:62614;s:12:\"delete-63372\";i:62615;s:12:\"delete-63375\";i:62616;s:12:\"delete-63378\";i:62617;s:12:\"delete-63379\";i:62618;s:12:\"delete-63376\";i:62619;s:12:\"delete-63377\";i:62620;s:12:\"delete-63380\";i:62621;s:12:\"delete-63383\";i:62622;s:12:\"delete-63384\";i:62623;s:12:\"delete-63381\";i:62624;s:12:\"delete-63382\";i:62625;s:12:\"delete-63385\";i:62626;s:12:\"delete-63388\";i:62627;s:12:\"delete-63389\";i:62628;s:12:\"delete-63386\";i:62629;s:12:\"delete-63387\";i:62630;s:12:\"delete-63390\";i:62631;s:12:\"delete-63393\";i:62632;s:12:\"delete-63391\";i:62633;s:12:\"delete-63392\";i:62634;s:12:\"delete-63394\";i:62635;s:12:\"delete-63395\";i:62636;s:12:\"delete-63398\";i:62637;s:12:\"delete-63399\";i:62638;s:12:\"delete-63396\";i:62639;s:12:\"delete-63397\";i:62640;s:12:\"delete-63400\";i:62641;s:12:\"delete-63403\";i:62642;s:12:\"delete-63401\";i:62643;s:12:\"delete-63402\";i:62644;s:12:\"delete-63404\";i:62645;s:12:\"delete-63405\";i:62646;s:12:\"delete-63408\";i:62647;s:12:\"delete-63406\";i:62648;s:12:\"delete-63407\";i:62649;s:12:\"delete-63409\";i:62650;s:12:\"delete-63412\";i:62651;s:12:\"delete-63413\";i:62652;s:12:\"delete-63410\";i:62653;s:12:\"delete-63411\";i:62654;s:12:\"delete-63414\";i:62655;s:12:\"delete-63417\";i:62656;s:12:\"delete-63415\";i:62657;s:12:\"delete-63416\";i:62658;s:12:\"delete-63418\";i:62659;s:12:\"delete-63419\";i:62660;s:12:\"delete-63422\";i:62661;s:12:\"delete-63423\";i:62662;s:12:\"delete-63420\";i:62663;s:12:\"delete-63421\";i:62664;s:12:\"delete-63424\";i:62665;s:12:\"delete-63427\";i:62666;s:12:\"delete-63428\";i:62667;s:12:\"delete-63425\";i:62668;s:12:\"delete-63426\";i:62669;s:12:\"delete-63429\";i:62670;s:12:\"delete-63432\";i:62671;s:12:\"delete-63433\";i:62672;s:12:\"delete-63430\";i:62673;s:12:\"delete-63431\";i:62674;s:12:\"delete-63434\";i:62675;s:12:\"delete-63437\";i:62676;s:12:\"delete-63438\";i:62677;s:12:\"delete-63435\";i:62678;s:12:\"delete-63436\";i:62679;s:12:\"delete-63439\";i:62680;s:12:\"delete-63442\";i:62681;s:12:\"delete-63443\";i:62682;s:12:\"delete-63440\";i:62683;s:12:\"delete-63441\";i:62684;s:12:\"delete-63444\";i:62685;s:12:\"delete-63447\";i:62686;s:12:\"delete-63448\";i:62687;s:12:\"delete-63445\";i:62688;s:12:\"delete-63446\";i:62689;s:12:\"delete-63449\";i:62690;s:12:\"delete-63452\";i:62691;s:12:\"delete-63453\";i:62692;s:12:\"delete-63450\";i:62693;s:12:\"delete-63451\";i:62694;s:12:\"delete-63454\";i:62695;s:12:\"delete-63457\";i:62696;s:12:\"delete-63458\";i:62697;s:12:\"delete-63455\";i:62698;s:12:\"delete-63456\";i:62699;s:12:\"delete-63459\";i:62700;s:12:\"delete-63462\";i:62701;s:12:\"delete-63460\";i:62702;s:12:\"delete-63461\";i:62703;s:12:\"delete-63463\";i:62704;s:12:\"delete-63464\";i:62705;s:12:\"delete-63467\";i:62706;s:12:\"delete-63468\";i:62707;s:12:\"delete-63465\";i:62708;s:12:\"delete-63466\";i:62709;s:12:\"delete-63469\";i:62710;s:12:\"delete-63472\";i:62711;s:12:\"delete-63473\";i:62712;s:12:\"delete-63470\";i:62713;s:12:\"delete-63471\";i:62714;s:12:\"delete-63474\";i:62715;s:12:\"delete-63477\";i:62716;s:12:\"delete-63478\";i:62717;s:12:\"delete-63475\";i:62718;s:12:\"delete-63476\";i:62719;s:12:\"delete-63479\";i:62720;s:12:\"delete-63482\";i:62721;s:12:\"delete-63483\";i:62722;s:12:\"delete-63480\";i:62723;s:12:\"delete-63481\";i:62724;s:12:\"delete-63484\";i:62725;s:12:\"delete-63487\";i:62726;s:12:\"delete-63488\";i:62727;s:12:\"delete-63485\";i:62728;s:12:\"delete-63486\";i:62729;s:12:\"delete-63489\";i:62730;s:12:\"delete-63492\";i:62731;s:12:\"delete-63490\";i:62732;s:12:\"delete-63491\";i:62733;s:12:\"delete-63493\";i:62734;s:12:\"delete-63494\";i:62735;s:12:\"delete-63497\";i:62736;s:12:\"delete-63498\";i:62737;s:12:\"delete-63495\";i:62738;s:12:\"delete-63496\";i:62739;s:12:\"delete-63499\";i:62740;s:12:\"delete-63502\";i:62741;s:12:\"delete-63503\";i:62742;s:12:\"delete-63500\";i:62743;s:12:\"delete-63501\";i:62744;s:12:\"delete-63504\";i:62745;s:12:\"delete-63507\";i:62746;s:12:\"delete-63508\";i:62747;s:12:\"delete-63505\";i:62748;s:12:\"delete-63506\";i:62749;s:12:\"delete-63509\";i:62750;s:12:\"delete-63512\";i:62751;s:12:\"delete-63513\";i:62752;s:12:\"delete-63510\";i:62753;s:12:\"delete-63511\";i:62754;s:12:\"delete-63514\";i:62755;s:12:\"delete-63517\";i:62756;s:12:\"delete-63518\";i:62757;s:12:\"delete-63515\";i:62758;s:12:\"delete-63516\";i:62759;s:12:\"delete-63519\";i:62760;s:12:\"delete-63522\";i:62761;s:12:\"delete-63523\";i:62762;s:12:\"delete-63520\";i:62763;s:12:\"delete-63521\";i:62764;s:12:\"delete-63524\";i:62765;s:12:\"delete-63527\";i:62766;s:12:\"delete-63528\";i:62767;s:12:\"delete-63525\";i:62768;s:12:\"delete-63526\";i:62769;s:12:\"delete-63529\";i:62770;s:12:\"delete-63532\";i:62771;s:12:\"delete-63530\";i:62772;s:12:\"delete-63531\";i:62773;s:12:\"delete-63533\";i:62774;s:12:\"delete-63534\";i:62775;s:12:\"delete-63537\";i:62776;s:12:\"delete-63538\";i:62777;s:12:\"delete-63535\";i:62778;s:12:\"delete-63536\";i:62779;s:12:\"delete-63539\";i:62780;s:12:\"delete-63542\";i:62781;s:12:\"delete-63540\";i:62782;s:12:\"delete-63541\";i:62783;s:12:\"delete-63543\";i:62784;s:12:\"delete-63544\";i:62785;s:12:\"delete-63547\";i:62786;s:12:\"delete-63545\";i:62787;s:12:\"delete-63546\";i:62788;s:12:\"delete-63548\";i:62789;s:12:\"delete-63549\";i:62790;s:12:\"delete-63552\";i:62791;s:12:\"delete-63553\";i:62792;s:12:\"delete-63550\";i:62793;s:12:\"delete-63551\";i:62794;s:12:\"delete-63554\";i:62795;s:12:\"delete-63557\";i:62796;s:12:\"delete-63558\";i:62797;s:12:\"delete-63555\";i:62798;s:12:\"delete-63556\";i:62799;s:12:\"delete-63559\";i:62800;s:12:\"delete-63562\";i:62801;s:12:\"delete-63563\";i:62802;s:12:\"delete-63560\";i:62803;s:12:\"delete-63561\";i:62804;s:12:\"delete-63564\";i:62805;s:12:\"delete-63567\";i:62806;s:12:\"delete-63568\";i:62807;s:12:\"delete-63565\";i:62808;s:12:\"delete-63566\";i:62809;s:12:\"delete-63569\";i:62810;s:12:\"delete-63572\";i:62811;s:12:\"delete-63573\";i:62812;s:12:\"delete-63570\";i:62813;s:12:\"delete-63571\";i:62814;s:12:\"delete-63574\";i:62815;s:12:\"delete-63577\";i:62816;s:12:\"delete-63578\";i:62817;s:12:\"delete-63575\";i:62818;s:12:\"delete-63576\";i:62819;s:12:\"delete-63579\";i:62820;s:12:\"delete-63582\";i:62821;s:12:\"delete-63580\";i:62822;s:12:\"delete-63581\";i:62823;s:12:\"delete-63583\";i:62824;s:12:\"delete-63584\";i:62825;s:12:\"delete-63587\";i:62826;s:12:\"delete-63588\";i:62827;s:12:\"delete-63585\";i:62828;s:12:\"delete-63586\";i:62829;s:12:\"delete-63589\";i:62830;s:12:\"delete-63592\";i:62831;s:12:\"delete-63593\";i:62832;s:12:\"delete-63590\";i:62833;s:12:\"delete-63591\";i:62834;s:12:\"delete-63594\";i:62835;s:12:\"delete-63597\";i:62836;s:12:\"delete-63598\";i:62837;s:12:\"delete-63595\";i:62838;s:12:\"delete-63596\";i:62839;s:12:\"delete-63599\";i:62840;s:12:\"delete-63602\";i:62841;s:12:\"delete-63603\";i:62842;s:12:\"delete-63600\";i:62843;s:12:\"delete-63601\";i:62844;s:12:\"delete-63604\";i:62845;s:12:\"delete-63605\";i:62846;s:12:\"delete-63606\";i:62847;s:12:\"delete-63607\";i:62848;s:12:\"delete-63608\";i:62849;s:12:\"delete-63609\";i:62850;s:12:\"delete-63612\";i:62851;s:12:\"delete-63613\";i:62852;s:12:\"delete-63610\";i:62853;s:12:\"delete-63611\";i:62854;s:12:\"delete-63614\";i:62855;s:12:\"delete-63617\";i:62856;s:12:\"delete-63618\";i:62857;s:12:\"delete-63615\";i:62858;s:12:\"delete-63616\";i:62859;s:12:\"delete-63619\";i:62860;s:12:\"delete-63622\";i:62861;s:12:\"delete-63623\";i:62862;s:12:\"delete-63620\";i:62863;s:12:\"delete-63621\";i:62864;s:12:\"delete-63624\";i:62865;s:12:\"delete-63627\";i:62866;s:12:\"delete-63628\";i:62867;s:12:\"delete-63625\";i:62868;s:12:\"delete-63626\";i:62869;s:12:\"delete-63629\";i:62870;s:12:\"delete-63630\";i:62871;s:12:\"delete-63631\";i:62872;s:12:\"delete-63632\";i:62873;s:12:\"delete-63633\";i:62874;s:12:\"delete-63634\";i:62875;s:12:\"delete-63637\";i:62876;s:12:\"delete-63638\";i:62877;s:12:\"delete-63635\";i:62878;s:12:\"delete-63636\";i:62879;s:12:\"delete-63639\";i:62880;s:12:\"delete-63642\";i:62881;s:12:\"delete-63643\";i:62882;s:12:\"delete-63640\";i:62883;s:12:\"delete-63641\";i:62884;s:12:\"delete-63644\";i:62885;s:12:\"delete-63647\";i:62886;s:12:\"delete-63648\";i:62887;s:12:\"delete-63645\";i:62888;s:12:\"delete-63646\";i:62889;s:12:\"delete-63649\";i:62890;s:12:\"delete-63652\";i:62891;s:12:\"delete-63653\";i:62892;s:12:\"delete-63650\";i:62893;s:12:\"delete-63651\";i:62894;s:12:\"delete-63654\";i:62895;s:12:\"delete-63657\";i:62896;s:12:\"delete-63655\";i:62897;s:12:\"delete-63656\";i:62898;s:12:\"delete-63658\";i:62899;s:12:\"delete-63659\";i:62900;s:12:\"delete-63662\";i:62901;s:12:\"delete-63663\";i:62902;s:12:\"delete-63660\";i:62903;s:12:\"delete-63661\";i:62904;s:12:\"delete-63664\";i:62905;s:12:\"delete-63667\";i:62906;s:12:\"delete-63668\";i:62907;s:12:\"delete-63665\";i:62908;s:12:\"delete-63666\";i:62909;s:12:\"delete-63669\";i:62910;s:12:\"delete-63672\";i:62911;s:12:\"delete-63673\";i:62912;s:12:\"delete-63670\";i:62913;s:12:\"delete-63671\";i:62914;s:12:\"delete-63674\";i:62915;s:12:\"delete-63677\";i:62916;s:12:\"delete-63678\";i:62917;s:12:\"delete-63675\";i:62918;s:12:\"delete-63676\";i:62919;s:12:\"delete-63679\";i:62920;s:12:\"delete-63682\";i:62921;s:12:\"delete-63683\";i:62922;s:12:\"delete-63680\";i:62923;s:12:\"delete-63681\";i:62924;s:12:\"delete-63684\";i:62925;s:12:\"delete-63687\";i:62926;s:12:\"delete-63685\";i:62927;s:12:\"delete-63686\";i:62928;s:12:\"delete-63688\";i:62929;s:12:\"delete-63689\";i:62930;s:12:\"delete-63692\";i:62931;s:12:\"delete-63693\";i:62932;s:12:\"delete-63690\";i:62933;s:12:\"delete-63691\";i:62934;s:12:\"delete-63694\";i:62935;s:12:\"delete-63697\";i:62936;s:12:\"delete-63695\";i:62937;s:12:\"delete-63696\";i:62938;s:12:\"delete-63698\";i:62939;s:12:\"delete-63699\";i:62940;s:12:\"delete-63702\";i:62941;s:12:\"delete-63703\";i:62942;s:12:\"delete-63700\";i:62943;s:12:\"delete-63701\";i:62944;s:12:\"delete-63704\";i:62945;s:12:\"delete-63707\";i:62946;s:12:\"delete-63705\";i:62947;s:12:\"delete-63706\";i:62948;s:12:\"delete-63708\";i:62949;s:12:\"delete-63709\";i:62950;s:12:\"delete-63712\";i:62951;s:12:\"delete-63713\";i:62952;s:12:\"delete-63710\";i:62953;s:12:\"delete-63711\";i:62954;s:12:\"delete-63714\";i:62955;s:12:\"delete-63717\";i:62956;s:12:\"delete-63718\";i:62957;s:12:\"delete-63715\";i:62958;s:12:\"delete-63716\";i:62959;s:12:\"delete-63719\";i:62960;s:12:\"delete-63722\";i:62961;s:12:\"delete-63723\";i:62962;s:12:\"delete-63720\";i:62963;s:12:\"delete-63721\";i:62964;s:12:\"delete-63724\";i:62965;s:12:\"delete-63727\";i:62966;s:12:\"delete-63728\";i:62967;s:12:\"delete-63725\";i:62968;s:12:\"delete-63726\";i:62969;s:12:\"delete-63729\";i:62970;s:12:\"delete-63732\";i:62971;s:12:\"delete-63730\";i:62972;s:12:\"delete-63731\";i:62973;s:12:\"delete-63733\";i:62974;s:12:\"delete-63734\";i:62975;s:12:\"delete-63737\";i:62976;s:12:\"delete-63738\";i:62977;s:12:\"delete-63735\";i:62978;s:12:\"delete-63736\";i:62979;s:12:\"delete-63739\";i:62980;s:12:\"delete-63742\";i:62981;s:12:\"delete-63740\";i:62982;s:12:\"delete-63741\";i:62983;s:12:\"delete-63743\";i:62984;s:12:\"delete-63744\";i:62985;s:12:\"delete-63747\";i:62986;s:12:\"delete-63748\";i:62987;s:12:\"delete-63745\";i:62988;s:12:\"delete-63746\";i:62989;s:12:\"delete-63749\";i:62990;s:12:\"delete-63752\";i:62991;s:12:\"delete-63750\";i:62992;s:12:\"delete-63751\";i:62993;s:12:\"delete-63753\";i:62994;s:12:\"delete-63754\";i:62995;s:12:\"delete-63757\";i:62996;s:12:\"delete-63758\";i:62997;s:12:\"delete-63755\";i:62998;s:12:\"delete-63756\";i:62999;s:12:\"delete-63759\";i:63000;s:12:\"delete-63762\";i:63001;s:12:\"delete-63760\";i:63002;s:12:\"delete-63761\";i:63003;s:12:\"delete-63763\";i:63004;s:12:\"delete-63764\";i:63005;s:12:\"delete-63767\";i:63006;s:12:\"delete-63768\";i:63007;s:12:\"delete-63765\";i:63008;s:12:\"delete-63766\";i:63009;s:12:\"delete-63769\";i:63010;s:12:\"delete-63772\";i:63011;s:12:\"delete-63773\";i:63012;s:12:\"delete-63770\";i:63013;s:12:\"delete-63771\";i:63014;s:12:\"delete-63774\";i:63015;s:12:\"delete-63777\";i:63016;s:12:\"delete-63778\";i:63017;s:12:\"delete-63775\";i:63018;s:12:\"delete-63776\";i:63019;s:12:\"delete-63779\";i:63020;s:12:\"delete-63782\";i:63021;s:12:\"delete-63780\";i:63022;s:12:\"delete-63781\";i:63023;s:12:\"delete-63783\";i:63024;s:12:\"delete-63784\";i:63025;s:12:\"delete-63787\";i:63026;s:12:\"delete-63788\";i:63027;s:12:\"delete-63785\";i:63028;s:12:\"delete-63786\";i:63029;s:12:\"delete-63789\";i:63030;s:12:\"delete-63792\";i:63031;s:12:\"delete-63793\";i:63032;s:12:\"delete-63790\";i:63033;s:12:\"delete-63791\";i:63034;s:12:\"delete-63794\";i:63035;s:12:\"delete-63797\";i:63036;s:12:\"delete-63795\";i:63037;s:12:\"delete-63796\";i:63038;s:12:\"delete-63798\";i:63039;s:12:\"delete-63799\";i:63040;s:12:\"delete-63802\";i:63041;s:12:\"delete-63803\";i:63042;s:12:\"delete-63800\";i:63043;s:12:\"delete-63801\";i:63044;s:12:\"delete-63804\";i:63045;s:12:\"delete-63807\";i:63046;s:12:\"delete-63805\";i:63047;s:12:\"delete-63806\";i:63048;s:12:\"delete-63808\";i:63049;s:12:\"delete-63809\";i:63050;s:12:\"delete-63812\";i:63051;s:12:\"delete-63813\";i:63052;s:12:\"delete-63810\";i:63053;s:12:\"delete-63811\";i:63054;s:12:\"delete-63814\";i:63055;s:12:\"delete-63817\";i:63056;s:12:\"delete-63818\";i:63057;s:12:\"delete-63815\";i:63058;s:12:\"delete-63816\";i:63059;s:12:\"delete-63819\";i:63060;s:12:\"delete-63820\";i:63061;s:12:\"delete-63821\";i:63062;s:12:\"delete-63822\";i:63063;s:12:\"delete-63823\";i:63064;s:12:\"delete-63824\";i:63065;s:12:\"delete-63827\";i:63066;s:12:\"delete-63828\";i:63067;s:12:\"delete-63825\";i:63068;s:12:\"delete-63826\";i:63069;s:12:\"delete-63829\";i:63070;s:12:\"delete-63832\";i:63071;s:12:\"delete-63833\";i:63072;s:12:\"delete-63830\";i:63073;s:12:\"delete-63831\";i:63074;s:12:\"delete-63834\";i:63075;s:12:\"delete-63835\";i:63076;s:12:\"delete-63836\";i:63077;s:12:\"delete-63837\";i:63078;s:12:\"delete-63838\";i:63079;s:12:\"delete-63839\";i:63080;s:12:\"delete-63842\";i:63081;s:12:\"delete-63840\";i:63082;s:12:\"delete-63841\";i:63083;s:12:\"delete-63843\";i:63084;s:12:\"delete-63844\";i:63085;s:12:\"delete-63847\";i:63086;s:12:\"delete-63845\";i:63087;s:12:\"delete-63846\";i:63088;s:12:\"delete-63848\";i:63089;s:12:\"delete-63849\";i:63090;s:12:\"delete-63852\";i:63091;s:12:\"delete-63850\";i:63092;s:12:\"delete-63851\";i:63093;s:12:\"delete-63853\";i:63094;s:12:\"delete-63854\";i:63095;s:12:\"delete-63857\";i:63096;s:12:\"delete-63858\";i:63097;s:12:\"delete-63855\";i:63098;s:12:\"delete-63856\";i:63099;s:12:\"delete-63859\";i:63100;s:12:\"delete-63862\";i:63101;s:12:\"delete-63860\";i:63102;s:12:\"delete-63861\";i:63103;s:12:\"delete-63863\";i:63104;s:12:\"delete-63864\";i:63105;s:12:\"delete-63867\";i:63106;s:12:\"delete-63868\";i:63107;s:12:\"delete-63865\";i:63108;s:12:\"delete-63866\";i:63109;s:12:\"delete-63869\";i:63110;s:12:\"delete-63872\";i:63111;s:12:\"delete-63870\";i:63112;s:12:\"delete-63871\";i:63113;s:12:\"delete-63873\";i:63114;s:12:\"delete-63874\";i:63115;s:12:\"delete-63877\";i:63116;s:12:\"delete-63878\";i:63117;s:12:\"delete-63875\";i:63118;s:12:\"delete-63876\";i:63119;s:12:\"delete-63879\";i:63120;s:12:\"delete-63882\";i:63121;s:12:\"delete-63883\";i:63122;s:12:\"delete-63880\";i:63123;s:12:\"delete-63881\";i:63124;s:12:\"delete-63884\";i:63125;s:12:\"delete-63887\";i:63126;s:12:\"delete-63888\";i:63127;s:12:\"delete-63885\";i:63128;s:12:\"delete-63886\";i:63129;s:12:\"delete-63889\";i:63130;s:12:\"delete-63892\";i:63131;s:12:\"delete-63893\";i:63132;s:12:\"delete-63890\";i:63133;s:12:\"delete-63891\";i:63134;s:12:\"delete-63894\";i:63135;s:12:\"delete-63897\";i:63136;s:12:\"delete-63895\";i:63137;s:12:\"delete-63896\";i:63138;s:12:\"delete-63898\";i:63139;s:12:\"delete-63899\";i:63140;s:12:\"delete-63902\";i:63141;s:12:\"delete-63903\";i:63142;s:12:\"delete-63900\";i:63143;s:12:\"delete-63901\";i:63144;s:12:\"delete-63904\";i:63145;s:12:\"delete-63907\";i:63146;s:12:\"delete-63908\";i:63147;s:12:\"delete-63905\";i:63148;s:12:\"delete-63906\";i:63149;s:12:\"delete-63909\";i:63150;s:12:\"delete-63910\";i:63151;s:12:\"delete-63911\";i:63152;s:12:\"delete-63912\";i:63153;s:12:\"delete-63913\";i:63154;s:12:\"delete-63914\";i:63155;s:12:\"delete-63917\";i:63156;s:12:\"delete-63918\";i:63157;s:12:\"delete-63915\";i:63158;s:12:\"delete-63916\";i:63159;s:12:\"delete-63919\";i:63160;s:12:\"delete-63922\";i:63161;s:12:\"delete-63923\";i:63162;s:12:\"delete-63920\";i:63163;s:12:\"delete-63921\";i:63164;s:12:\"delete-63924\";i:63165;s:12:\"delete-63927\";i:63166;s:12:\"delete-63928\";i:63167;s:12:\"delete-63925\";i:63168;s:12:\"delete-63926\";i:63169;s:12:\"delete-63929\";i:63170;s:12:\"delete-63932\";i:63171;s:12:\"delete-63933\";i:63172;s:12:\"delete-63930\";i:63173;s:12:\"delete-63931\";i:63174;s:12:\"delete-63934\";i:63175;s:12:\"delete-63937\";i:63176;s:12:\"delete-63938\";i:63177;s:12:\"delete-63935\";i:63178;s:12:\"delete-63936\";i:63179;s:12:\"delete-63939\";i:63180;s:12:\"delete-63942\";i:63181;s:12:\"delete-63940\";i:63182;s:12:\"delete-63941\";i:63183;s:12:\"delete-63943\";i:63184;s:12:\"delete-63944\";i:63185;s:12:\"delete-63947\";i:63186;s:12:\"delete-63948\";i:63187;s:12:\"delete-63945\";i:63188;s:12:\"delete-63946\";i:63189;s:12:\"delete-63949\";i:63190;s:12:\"delete-63952\";i:63191;s:12:\"delete-63953\";i:63192;s:12:\"delete-63950\";i:63193;s:12:\"delete-63951\";i:63194;s:12:\"delete-63954\";i:63195;s:12:\"delete-63957\";i:63196;s:12:\"delete-63958\";i:63197;s:12:\"delete-63955\";i:63198;s:12:\"delete-63956\";i:63199;s:12:\"delete-63959\";i:63200;s:12:\"delete-63962\";i:63201;s:12:\"delete-63963\";i:63202;s:12:\"delete-63960\";i:63203;s:12:\"delete-63961\";i:63204;s:12:\"delete-63964\";i:63205;s:12:\"delete-63967\";i:63206;s:12:\"delete-63965\";i:63207;s:12:\"delete-63966\";i:63208;s:12:\"delete-63968\";i:63209;s:12:\"delete-63969\";i:63210;s:12:\"delete-63972\";i:63211;s:12:\"delete-63973\";i:63212;s:12:\"delete-63970\";i:63213;s:12:\"delete-63971\";i:63214;s:12:\"delete-63974\";i:63215;s:12:\"delete-63977\";i:63216;s:12:\"delete-63975\";i:63217;s:12:\"delete-63976\";i:63218;s:12:\"delete-63978\";i:63219;s:12:\"delete-63979\";i:63220;s:12:\"delete-63982\";i:63221;s:12:\"delete-63983\";i:63222;s:12:\"delete-63980\";i:63223;s:12:\"delete-63981\";i:63224;s:12:\"delete-63984\";i:63225;s:12:\"delete-63987\";i:63226;s:12:\"delete-63988\";i:63227;s:12:\"delete-63985\";i:63228;s:12:\"delete-63986\";i:63229;s:12:\"delete-63989\";i:63230;s:12:\"delete-63992\";i:63231;s:12:\"delete-63993\";i:63232;s:12:\"delete-63990\";i:63233;s:12:\"delete-63991\";i:63234;s:12:\"delete-63994\";i:63235;s:12:\"delete-63997\";i:63236;s:12:\"delete-63998\";i:63237;s:12:\"delete-63995\";i:63238;s:12:\"delete-63996\";i:63239;s:12:\"delete-63999\";i:63240;s:12:\"delete-64002\";i:63241;s:12:\"delete-64003\";i:63242;s:12:\"delete-64000\";i:63243;s:12:\"delete-64001\";i:63244;s:12:\"delete-64004\";i:63245;s:12:\"delete-64007\";i:63246;s:12:\"delete-64005\";i:63247;s:12:\"delete-64006\";i:63248;s:12:\"delete-64008\";i:63249;s:12:\"delete-64009\";i:63250;s:12:\"delete-64012\";i:63251;s:12:\"delete-64013\";i:63252;s:12:\"delete-64010\";i:63253;s:12:\"delete-64011\";i:63254;s:12:\"delete-64014\";i:63255;s:12:\"delete-64017\";i:63256;s:12:\"delete-64018\";i:63257;s:12:\"delete-64015\";i:63258;s:12:\"delete-64016\";i:63259;s:12:\"delete-64019\";i:63260;s:12:\"delete-64022\";i:63261;s:12:\"delete-64023\";i:63262;s:12:\"delete-64020\";i:63263;s:12:\"delete-64021\";i:63264;s:12:\"delete-64024\";i:63265;s:12:\"delete-64027\";i:63266;s:12:\"delete-64028\";i:63267;s:12:\"delete-64025\";i:63268;s:12:\"delete-64026\";i:63269;s:12:\"delete-64029\";i:63270;s:12:\"delete-64032\";i:63271;s:12:\"delete-64033\";i:63272;s:12:\"delete-64030\";i:63273;s:12:\"delete-64031\";i:63274;s:12:\"delete-64034\";i:63275;s:12:\"delete-64037\";i:63276;s:12:\"delete-64035\";i:63277;s:12:\"delete-64036\";i:63278;s:12:\"delete-64038\";i:63279;s:12:\"delete-64039\";i:63280;s:12:\"delete-64042\";i:63281;s:12:\"delete-64043\";i:63282;s:12:\"delete-64040\";i:63283;s:12:\"delete-64041\";i:63284;s:12:\"delete-64044\";i:63285;s:12:\"delete-64047\";i:63286;s:12:\"delete-64045\";i:63287;s:12:\"delete-64046\";i:63288;s:12:\"delete-64048\";i:63289;s:12:\"delete-64051\";i:63290;s:12:\"delete-64052\";i:63291;s:12:\"delete-64049\";i:63292;s:12:\"delete-64050\";i:63293;s:12:\"delete-64053\";i:63294;s:12:\"delete-64056\";i:63295;s:12:\"delete-64057\";i:63296;s:12:\"delete-64054\";i:63297;s:12:\"delete-64055\";i:63298;s:12:\"delete-64058\";i:63299;s:12:\"delete-64061\";i:63300;s:12:\"delete-64062\";i:63301;s:12:\"delete-64059\";i:63302;s:12:\"delete-64060\";i:63303;s:12:\"delete-64063\";i:63304;s:12:\"delete-64066\";i:63305;s:12:\"delete-64067\";i:63306;s:12:\"delete-64064\";i:63307;s:12:\"delete-64065\";i:63308;s:12:\"delete-64068\";i:63309;s:12:\"delete-64071\";i:63310;s:12:\"delete-64069\";i:63311;s:12:\"delete-64070\";i:63312;s:12:\"delete-64072\";i:63313;s:12:\"delete-64073\";i:63314;s:12:\"delete-64076\";i:63315;s:12:\"delete-64077\";i:63316;s:12:\"delete-64074\";i:63317;s:12:\"delete-64075\";i:63318;s:12:\"delete-64078\";i:63319;s:12:\"delete-64081\";i:63320;s:12:\"delete-64082\";i:63321;s:12:\"delete-64079\";i:63322;s:12:\"delete-64080\";i:63323;s:12:\"delete-64083\";i:63324;s:12:\"delete-64086\";i:63325;s:12:\"delete-64087\";i:63326;s:12:\"delete-64084\";i:63327;s:12:\"delete-64085\";i:63328;s:12:\"delete-64088\";i:63329;s:12:\"delete-64091\";i:63330;s:12:\"delete-64092\";i:63331;s:12:\"delete-64089\";i:63332;s:12:\"delete-64090\";i:63333;s:12:\"delete-64093\";i:63334;s:12:\"delete-64096\";i:63335;s:12:\"delete-64094\";i:63336;s:12:\"delete-64095\";i:63337;s:12:\"delete-64097\";i:63338;s:12:\"delete-64098\";i:63339;s:12:\"delete-64101\";i:63340;s:12:\"delete-64102\";i:63341;s:12:\"delete-64099\";i:63342;s:12:\"delete-64100\";i:63343;s:12:\"delete-64103\";i:63344;s:12:\"delete-64106\";i:63345;s:12:\"delete-64104\";i:63346;s:12:\"delete-64105\";i:63347;s:12:\"delete-64107\";i:63348;s:12:\"delete-64108\";i:63349;s:12:\"delete-64111\";i:63350;s:12:\"delete-64112\";i:63351;s:12:\"delete-64109\";i:63352;s:12:\"delete-64110\";i:63353;s:12:\"delete-64113\";i:63354;s:12:\"delete-64116\";i:63355;s:12:\"delete-64117\";i:63356;s:12:\"delete-64114\";i:63357;s:12:\"delete-64115\";i:63358;s:12:\"delete-64118\";i:63359;s:12:\"delete-64121\";i:63360;s:12:\"delete-64122\";i:63361;s:12:\"delete-64119\";i:63362;s:12:\"delete-64120\";i:63363;s:12:\"delete-64123\";i:63364;s:12:\"delete-64126\";i:63365;s:12:\"delete-64127\";i:63366;s:12:\"delete-64124\";i:63367;s:12:\"delete-64125\";i:63368;s:12:\"delete-64128\";i:63369;s:12:\"delete-64131\";i:63370;s:12:\"delete-64132\";i:63371;s:12:\"delete-64129\";i:63372;s:12:\"delete-64130\";i:63373;s:12:\"delete-64133\";i:63374;s:12:\"delete-64136\";i:63375;s:12:\"delete-64134\";i:63376;s:12:\"delete-64135\";i:63377;s:12:\"delete-64137\";i:63378;s:12:\"delete-64138\";i:63379;s:12:\"delete-64141\";i:63380;s:12:\"delete-64142\";i:63381;s:12:\"delete-64139\";i:63382;s:12:\"delete-64140\";i:63383;s:12:\"delete-64143\";i:63384;s:12:\"delete-64146\";i:63385;s:12:\"delete-64147\";i:63386;s:12:\"delete-64144\";i:63387;s:12:\"delete-64145\";i:63388;s:12:\"delete-64148\";i:63389;s:12:\"delete-64151\";i:63390;s:12:\"delete-64152\";i:63391;s:12:\"delete-64149\";i:63392;s:12:\"delete-64150\";i:63393;s:12:\"delete-64153\";i:63394;s:12:\"delete-64156\";i:63395;s:12:\"delete-64157\";i:63396;s:12:\"delete-64154\";i:63397;s:12:\"delete-64155\";i:63398;s:12:\"delete-64158\";i:63399;s:12:\"delete-64161\";i:63400;s:12:\"delete-64159\";i:63401;s:12:\"delete-64160\";i:63402;s:12:\"delete-64162\";i:63403;s:12:\"delete-64163\";i:63404;s:12:\"delete-64166\";i:63405;s:12:\"delete-64167\";i:63406;s:12:\"delete-64164\";i:63407;s:12:\"delete-64165\";i:63408;s:12:\"delete-64168\";i:63409;s:12:\"delete-64171\";i:63410;s:12:\"delete-64172\";i:63411;s:12:\"delete-64169\";i:63412;s:12:\"delete-64170\";i:63413;s:12:\"delete-64173\";i:63414;s:12:\"delete-64176\";i:63415;s:12:\"delete-64177\";i:63416;s:12:\"delete-64174\";i:63417;s:12:\"delete-64175\";i:63418;s:12:\"delete-64178\";i:63419;s:12:\"delete-64181\";i:63420;s:12:\"delete-64182\";i:63421;s:12:\"delete-64179\";i:63422;s:12:\"delete-64180\";i:63423;s:12:\"delete-64183\";i:63424;s:12:\"delete-64186\";i:63425;s:12:\"delete-64187\";i:63426;s:12:\"delete-64184\";i:63427;s:12:\"delete-64185\";i:63428;s:12:\"delete-64188\";i:63429;s:12:\"delete-64191\";i:63430;s:12:\"delete-64189\";i:63431;s:12:\"delete-64190\";i:63432;s:12:\"delete-64192\";i:63433;s:12:\"delete-64193\";i:63434;s:12:\"delete-64196\";i:63435;s:12:\"delete-64197\";i:63436;s:12:\"delete-64194\";i:63437;s:12:\"delete-64195\";i:63438;s:12:\"delete-64198\";i:63439;s:12:\"delete-64201\";i:63440;s:12:\"delete-64202\";i:63441;s:12:\"delete-64199\";i:63442;s:12:\"delete-64200\";i:63443;s:12:\"delete-64203\";i:63444;s:12:\"delete-64206\";i:63445;s:12:\"delete-64207\";i:63446;s:12:\"delete-64204\";i:63447;s:12:\"delete-64205\";i:63448;s:12:\"delete-64208\";i:63449;s:12:\"delete-64211\";i:63450;s:12:\"delete-64209\";i:63451;s:12:\"delete-64210\";i:63452;s:12:\"delete-64212\";i:63453;s:12:\"delete-64213\";i:63454;s:12:\"delete-64216\";i:63455;s:12:\"delete-64217\";i:63456;s:12:\"delete-64214\";i:63457;s:12:\"delete-64215\";i:63458;s:12:\"delete-64218\";i:63459;s:12:\"delete-64221\";i:63460;s:12:\"delete-64222\";i:63461;s:12:\"delete-64219\";i:63462;s:12:\"delete-64220\";i:63463;s:12:\"delete-64223\";i:63464;s:12:\"delete-64226\";i:63465;s:12:\"delete-64227\";i:63466;s:12:\"delete-64224\";i:63467;s:12:\"delete-64225\";i:63468;s:12:\"delete-64228\";i:63469;s:12:\"delete-64231\";i:63470;s:12:\"delete-64232\";i:63471;s:12:\"delete-64229\";i:63472;s:12:\"delete-64230\";i:63473;s:12:\"delete-64233\";i:63474;s:12:\"delete-64236\";i:63475;s:12:\"delete-64237\";i:63476;s:12:\"delete-64234\";i:63477;s:12:\"delete-64235\";i:63478;s:12:\"delete-64238\";i:63479;s:12:\"delete-64241\";i:63480;s:12:\"delete-64239\";i:63481;s:12:\"delete-64240\";i:63482;s:12:\"delete-64242\";i:63483;s:12:\"delete-64243\";i:63484;s:12:\"delete-64246\";i:63485;s:12:\"delete-64247\";i:63486;s:12:\"delete-64244\";i:63487;s:12:\"delete-64245\";i:63488;s:12:\"delete-64248\";i:63489;s:12:\"delete-64251\";i:63490;s:12:\"delete-64249\";i:63491;s:12:\"delete-64250\";i:63492;s:12:\"delete-64252\";i:63493;s:12:\"delete-64253\";i:63494;s:12:\"delete-64256\";i:63495;s:12:\"delete-64257\";i:63496;s:12:\"delete-64254\";i:63497;s:12:\"delete-64255\";i:63498;s:12:\"delete-64258\";i:63499;s:12:\"delete-64261\";i:63500;s:12:\"delete-64262\";i:63501;s:12:\"delete-64259\";i:63502;s:12:\"delete-64260\";i:63503;s:12:\"delete-64263\";i:63504;s:12:\"delete-64266\";i:63505;s:12:\"delete-64267\";i:63506;s:12:\"delete-64264\";i:63507;s:12:\"delete-64265\";i:63508;s:12:\"delete-64268\";i:63509;s:12:\"delete-64271\";i:63510;s:12:\"delete-64272\";i:63511;s:12:\"delete-64269\";i:63512;s:12:\"delete-64270\";i:63513;s:12:\"delete-64273\";i:63514;s:12:\"delete-64276\";i:63515;s:12:\"delete-64277\";i:63516;s:12:\"delete-64274\";i:63517;s:12:\"delete-64275\";i:63518;s:12:\"delete-64278\";i:63519;s:12:\"delete-64281\";i:63520;s:12:\"delete-64282\";i:63521;s:12:\"delete-64279\";i:63522;s:12:\"delete-64280\";i:63523;s:12:\"delete-64283\";i:63524;s:12:\"delete-64286\";i:63525;s:12:\"delete-64287\";i:63526;s:12:\"delete-64284\";i:63527;s:12:\"delete-64285\";i:63528;s:12:\"delete-64288\";i:63529;s:12:\"delete-64291\";i:63530;s:12:\"delete-64292\";i:63531;s:12:\"delete-64289\";i:63532;s:12:\"delete-64290\";i:63533;s:12:\"delete-64293\";i:63534;s:12:\"delete-64296\";i:63535;s:12:\"delete-64294\";i:63536;s:12:\"delete-64295\";i:63537;s:12:\"delete-64297\";i:63538;s:12:\"delete-64298\";i:63539;s:12:\"delete-64301\";i:63540;s:12:\"delete-64302\";i:63541;s:12:\"delete-64299\";i:63542;s:12:\"delete-64300\";i:63543;s:12:\"delete-64303\";i:63544;s:12:\"delete-64306\";i:63545;s:12:\"delete-64307\";i:63546;s:12:\"delete-64304\";i:63547;s:12:\"delete-64305\";i:63548;s:12:\"delete-64308\";i:63549;s:12:\"delete-64311\";i:63550;s:12:\"delete-64312\";i:63551;s:12:\"delete-64309\";i:63552;s:12:\"delete-64310\";i:63553;s:12:\"delete-64313\";i:63554;s:12:\"delete-64316\";i:63555;s:12:\"delete-64317\";i:63556;s:12:\"delete-64314\";i:63557;s:12:\"delete-64315\";i:63558;s:12:\"delete-64318\";i:63559;s:12:\"delete-64321\";i:63560;s:12:\"delete-64322\";i:63561;s:12:\"delete-64319\";i:63562;s:12:\"delete-64320\";i:63563;s:12:\"delete-64323\";i:63564;s:12:\"delete-64326\";i:63565;s:12:\"delete-64327\";i:63566;s:12:\"delete-64324\";i:63567;s:12:\"delete-64325\";i:63568;s:12:\"delete-64328\";i:63569;s:12:\"delete-64331\";i:63570;s:12:\"delete-64332\";i:63571;s:12:\"delete-64329\";i:63572;s:12:\"delete-64330\";i:63573;s:12:\"delete-64333\";i:63574;s:12:\"delete-64336\";i:63575;s:12:\"delete-64337\";i:63576;s:12:\"delete-64334\";i:63577;s:12:\"delete-64335\";i:63578;s:12:\"delete-64338\";i:63579;s:12:\"delete-64341\";i:63580;s:12:\"delete-64342\";i:63581;s:12:\"delete-64339\";i:63582;s:12:\"delete-64340\";i:63583;s:12:\"delete-64343\";i:63584;s:12:\"delete-64346\";i:63585;s:12:\"delete-64347\";i:63586;s:12:\"delete-64344\";i:63587;s:12:\"delete-64345\";i:63588;s:12:\"delete-64348\";i:63589;s:12:\"delete-64351\";i:63590;s:12:\"delete-64352\";i:63591;s:12:\"delete-64349\";i:63592;s:12:\"delete-64350\";i:63593;s:12:\"delete-64353\";i:63594;s:12:\"delete-64356\";i:63595;s:12:\"delete-64357\";i:63596;s:12:\"delete-64354\";i:63597;s:12:\"delete-64355\";i:63598;s:12:\"delete-64358\";i:63599;s:12:\"delete-64361\";i:63600;s:12:\"delete-64359\";i:63601;s:12:\"delete-64360\";i:63602;s:12:\"delete-64362\";i:63603;s:12:\"delete-64363\";i:63604;s:12:\"delete-64366\";i:63605;s:12:\"delete-64367\";i:63606;s:12:\"delete-64364\";i:63607;s:12:\"delete-64365\";i:63608;s:12:\"delete-64368\";i:63609;s:12:\"delete-64371\";i:63610;s:12:\"delete-64369\";i:63611;s:12:\"delete-64370\";i:63612;s:12:\"delete-64372\";i:63613;s:12:\"delete-64373\";i:63614;s:12:\"delete-64376\";i:63615;s:12:\"delete-64377\";i:63616;s:12:\"delete-64374\";i:63617;s:12:\"delete-64375\";i:63618;s:12:\"delete-64378\";i:63619;s:12:\"delete-64381\";i:63620;s:12:\"delete-64382\";i:63621;s:12:\"delete-64379\";i:63622;s:12:\"delete-64380\";i:63623;s:12:\"delete-64383\";i:63624;s:12:\"delete-64386\";i:63625;s:12:\"delete-64387\";i:63626;s:12:\"delete-64384\";i:63627;s:12:\"delete-64385\";i:63628;s:12:\"delete-64388\";i:63629;s:12:\"delete-64391\";i:63630;s:12:\"delete-64389\";i:63631;s:12:\"delete-64390\";i:63632;s:12:\"delete-64392\";i:63633;s:12:\"delete-64393\";i:63634;s:12:\"delete-64396\";i:63635;s:12:\"delete-64397\";i:63636;s:12:\"delete-64394\";i:63637;s:12:\"delete-64395\";i:63638;s:12:\"delete-64398\";i:63639;s:12:\"delete-64401\";i:63640;s:12:\"delete-64402\";i:63641;s:12:\"delete-64399\";i:63642;s:12:\"delete-64400\";i:63643;s:12:\"delete-64403\";i:63644;s:12:\"delete-64406\";i:63645;s:12:\"delete-64407\";i:63646;s:12:\"delete-64404\";i:63647;s:12:\"delete-64405\";i:63648;s:12:\"delete-64408\";i:63649;s:12:\"delete-64411\";i:63650;s:12:\"delete-64409\";i:63651;s:12:\"delete-64410\";i:63652;s:12:\"delete-64412\";i:63653;s:12:\"delete-64413\";i:63654;s:12:\"delete-64416\";i:63655;s:12:\"delete-64417\";i:63656;s:12:\"delete-64414\";i:63657;s:12:\"delete-64415\";i:63658;s:12:\"delete-64418\";i:63659;s:12:\"delete-64421\";i:63660;s:12:\"delete-64422\";i:63661;s:12:\"delete-64419\";i:63662;s:12:\"delete-64420\";i:63663;s:12:\"delete-64423\";i:63664;s:12:\"delete-64426\";i:63665;s:12:\"delete-64427\";i:63666;s:12:\"delete-64424\";i:63667;s:12:\"delete-64425\";i:63668;s:12:\"delete-64428\";i:63669;s:12:\"delete-64431\";i:63670;s:12:\"delete-64429\";i:63671;s:12:\"delete-64430\";i:63672;s:12:\"delete-64432\";i:63673;s:12:\"delete-64433\";i:63674;s:12:\"delete-64436\";i:63675;s:12:\"delete-64437\";i:63676;s:12:\"delete-64434\";i:63677;s:12:\"delete-64435\";i:63678;s:12:\"delete-64438\";i:63679;s:12:\"delete-64441\";i:63680;s:12:\"delete-64442\";i:63681;s:12:\"delete-64439\";i:63682;s:12:\"delete-64440\";i:63683;s:12:\"delete-64443\";i:63684;s:12:\"delete-64446\";i:63685;s:12:\"delete-64444\";i:63686;s:12:\"delete-64445\";i:63687;s:12:\"delete-64447\";i:63688;s:12:\"delete-64448\";i:63689;s:12:\"delete-64451\";i:63690;s:12:\"delete-64452\";i:63691;s:12:\"delete-64449\";i:63692;s:12:\"delete-64450\";i:63693;s:12:\"delete-64453\";i:63694;s:12:\"delete-64456\";i:63695;s:12:\"delete-64457\";i:63696;s:12:\"delete-64454\";i:63697;s:12:\"delete-64455\";i:63698;s:12:\"delete-64458\";i:63699;s:12:\"delete-64461\";i:63700;s:12:\"delete-64462\";i:63701;s:12:\"delete-64459\";i:63702;s:12:\"delete-64460\";i:63703;s:12:\"delete-64463\";i:63704;s:12:\"delete-64466\";i:63705;s:12:\"delete-64464\";i:63706;s:12:\"delete-64465\";i:63707;s:12:\"delete-64467\";i:63708;s:12:\"delete-64468\";i:63709;s:12:\"delete-64471\";i:63710;s:12:\"delete-64472\";i:63711;s:12:\"delete-64469\";i:63712;s:12:\"delete-64470\";i:63713;s:12:\"delete-64473\";i:63714;s:12:\"delete-64476\";i:63715;s:12:\"delete-64477\";i:63716;s:12:\"delete-64474\";i:63717;s:12:\"delete-64475\";i:63718;s:12:\"delete-64478\";i:63719;s:12:\"delete-64481\";i:63720;s:12:\"delete-64482\";i:63721;s:12:\"delete-64479\";i:63722;s:12:\"delete-64480\";i:63723;s:12:\"delete-64483\";i:63724;s:12:\"delete-64486\";i:63725;s:12:\"delete-64487\";i:63726;s:12:\"delete-64484\";i:63727;s:12:\"delete-64485\";i:63728;s:12:\"delete-64488\";i:63729;s:12:\"delete-64491\";i:63730;s:12:\"delete-64492\";i:63731;s:12:\"delete-64489\";i:63732;s:12:\"delete-64490\";i:63733;s:12:\"delete-64493\";i:63734;s:12:\"delete-64496\";i:63735;s:12:\"delete-64497\";i:63736;s:12:\"delete-64494\";i:63737;s:12:\"delete-64495\";i:63738;s:12:\"delete-64498\";i:63739;s:12:\"delete-64501\";i:63740;s:12:\"delete-64502\";i:63741;s:12:\"delete-64499\";i:63742;s:12:\"delete-64500\";i:63743;s:12:\"delete-64503\";i:63744;s:12:\"delete-64506\";i:63745;s:12:\"delete-64504\";i:63746;s:12:\"delete-64505\";i:63747;s:12:\"delete-64507\";i:63748;s:12:\"delete-64508\";i:63749;s:12:\"delete-64511\";i:63750;s:12:\"delete-64509\";i:63751;s:12:\"delete-64510\";i:63752;s:12:\"delete-64512\";i:63753;s:12:\"delete-64513\";i:63754;s:12:\"delete-64516\";i:63755;s:12:\"delete-64517\";i:63756;s:12:\"delete-64514\";i:63757;s:12:\"delete-64515\";i:63758;s:12:\"delete-64518\";i:63759;s:12:\"delete-64519\";i:63760;s:12:\"delete-64520\";i:63761;s:12:\"delete-64521\";i:63762;s:12:\"delete-64522\";i:63763;s:12:\"delete-64523\";i:63764;s:12:\"delete-64526\";i:63765;s:12:\"delete-64527\";i:63766;s:12:\"delete-64524\";i:63767;s:12:\"delete-64525\";i:63768;s:12:\"delete-64528\";i:63769;s:12:\"delete-64531\";i:63770;s:12:\"delete-64529\";i:63771;s:12:\"delete-64530\";i:63772;s:12:\"delete-64532\";i:63773;s:12:\"delete-64533\";i:63774;s:12:\"delete-64536\";i:63775;s:12:\"delete-64537\";i:63776;s:12:\"delete-64534\";i:63777;s:12:\"delete-64535\";i:63778;s:12:\"delete-64538\";i:63779;s:12:\"delete-64541\";i:63780;s:12:\"delete-64542\";i:63781;s:12:\"delete-64539\";i:63782;s:12:\"delete-64540\";i:63783;s:12:\"delete-64543\";i:63784;s:12:\"delete-64546\";i:63785;s:12:\"delete-64547\";i:63786;s:12:\"delete-64544\";i:63787;s:12:\"delete-64545\";i:63788;s:12:\"delete-64548\";i:63789;s:12:\"delete-64551\";i:63790;s:12:\"delete-64552\";i:63791;s:12:\"delete-64549\";i:63792;s:12:\"delete-64550\";i:63793;s:12:\"delete-64553\";i:63794;s:12:\"delete-64556\";i:63795;s:12:\"delete-64557\";i:63796;s:12:\"delete-64554\";i:63797;s:12:\"delete-64555\";i:63798;s:12:\"delete-64558\";i:63799;s:12:\"delete-64561\";i:63800;s:12:\"delete-64562\";i:63801;s:12:\"delete-64559\";i:63802;s:12:\"delete-64560\";i:63803;s:12:\"delete-64563\";i:63804;s:12:\"delete-64566\";i:63805;s:12:\"delete-64567\";i:63806;s:12:\"delete-64564\";i:63807;s:12:\"delete-64565\";i:63808;s:12:\"delete-64568\";i:63809;s:12:\"delete-64571\";i:63810;s:12:\"delete-64572\";i:63811;s:12:\"delete-64569\";i:63812;s:12:\"delete-64570\";i:63813;s:12:\"delete-64573\";i:63814;s:12:\"delete-64576\";i:63815;s:12:\"delete-64577\";i:63816;s:12:\"delete-64574\";i:63817;s:12:\"delete-64575\";i:63818;s:12:\"delete-64578\";i:63819;s:12:\"delete-64581\";i:63820;s:12:\"delete-64582\";i:63821;s:12:\"delete-64579\";i:63822;s:12:\"delete-64580\";i:63823;s:12:\"delete-64583\";i:63824;s:12:\"delete-64586\";i:63825;s:12:\"delete-64587\";i:63826;s:12:\"delete-64588\";i:63827;s:12:\"delete-64591\";i:63828;s:12:\"delete-64592\";i:63829;s:12:\"delete-64584\";i:63830;s:12:\"delete-64585\";i:63831;s:12:\"delete-64589\";i:63832;s:12:\"delete-64590\";i:63833;s:12:\"delete-64593\";i:63834;s:12:\"delete-64596\";i:63835;s:12:\"delete-64597\";i:63836;s:12:\"delete-64594\";i:63837;s:12:\"delete-64595\";i:63838;s:12:\"delete-64598\";i:63839;s:12:\"delete-64601\";i:63840;s:12:\"delete-64602\";i:63841;s:12:\"delete-64599\";i:63842;s:12:\"delete-64600\";i:63843;s:12:\"delete-64603\";i:63844;s:12:\"delete-64606\";i:63845;s:12:\"delete-64607\";i:63846;s:12:\"delete-64604\";i:63847;s:12:\"delete-64605\";i:63848;s:12:\"delete-64608\";i:63849;s:12:\"delete-64611\";i:63850;s:12:\"delete-64612\";i:63851;s:12:\"delete-64609\";i:63852;s:12:\"delete-64610\";i:63853;s:12:\"delete-64613\";i:63854;s:12:\"delete-64616\";i:63855;s:12:\"delete-64614\";i:63856;s:12:\"delete-64615\";i:63857;s:12:\"delete-64617\";i:63858;s:12:\"delete-64618\";i:63859;s:12:\"delete-64621\";i:63860;s:12:\"delete-64622\";i:63861;s:12:\"delete-64619\";i:63862;s:12:\"delete-64620\";i:63863;s:12:\"delete-64623\";i:63864;s:12:\"delete-64626\";i:63865;s:12:\"delete-64627\";i:63866;s:12:\"delete-64624\";i:63867;s:12:\"delete-64625\";i:63868;s:12:\"delete-64628\";i:63869;s:12:\"delete-64631\";i:63870;s:12:\"delete-64632\";i:63871;s:12:\"delete-64629\";i:63872;s:12:\"delete-64630\";i:63873;s:12:\"delete-64633\";i:63874;s:12:\"delete-64636\";i:63875;s:12:\"delete-64637\";i:63876;s:12:\"delete-64634\";i:63877;s:12:\"delete-64635\";i:63878;s:12:\"delete-64638\";i:63879;s:12:\"delete-64641\";i:63880;s:12:\"delete-64639\";i:63881;s:12:\"delete-64640\";i:63882;s:12:\"delete-64642\";i:63883;s:12:\"delete-64643\";i:63884;s:12:\"delete-64646\";i:63885;s:12:\"delete-64647\";i:63886;s:12:\"delete-64644\";i:63887;s:12:\"delete-64645\";i:63888;s:12:\"delete-64648\";i:63889;s:12:\"delete-64651\";i:63890;s:12:\"delete-64652\";i:63891;s:12:\"delete-64649\";i:63892;s:12:\"delete-64650\";i:63893;s:12:\"delete-64653\";i:63894;s:12:\"delete-64656\";i:63895;s:12:\"delete-64657\";i:63896;s:12:\"delete-64654\";i:63897;s:12:\"delete-64655\";i:63898;s:12:\"delete-64658\";i:63899;s:12:\"delete-64661\";i:63900;s:12:\"delete-64662\";i:63901;s:12:\"delete-64659\";i:63902;s:12:\"delete-64660\";i:63903;s:12:\"delete-64663\";i:63904;s:12:\"delete-64666\";i:63905;s:12:\"delete-64667\";i:63906;s:12:\"delete-64664\";i:63907;s:12:\"delete-64665\";i:63908;s:12:\"delete-64668\";i:63909;s:12:\"delete-64671\";i:63910;s:12:\"delete-64672\";i:63911;s:12:\"delete-64669\";i:63912;s:12:\"delete-64670\";i:63913;s:12:\"delete-64673\";i:63914;s:12:\"delete-64676\";i:63915;s:12:\"delete-64674\";i:63916;s:12:\"delete-64675\";i:63917;s:12:\"delete-64677\";i:63918;s:12:\"delete-64678\";i:63919;s:12:\"delete-64681\";i:63920;s:12:\"delete-64679\";i:63921;s:12:\"delete-64680\";i:63922;s:12:\"delete-64682\";i:63923;s:12:\"delete-64683\";i:63924;s:12:\"delete-64686\";i:63925;s:12:\"delete-64684\";i:63926;s:12:\"delete-64685\";i:63927;s:12:\"delete-64687\";i:63928;s:12:\"delete-64690\";i:63929;s:12:\"delete-64691\";i:63930;s:12:\"delete-64688\";i:63931;s:12:\"delete-64689\";i:63932;s:12:\"delete-64692\";i:63933;s:12:\"delete-64695\";i:63934;s:12:\"delete-64696\";i:63935;s:12:\"delete-64693\";i:63936;s:12:\"delete-64694\";i:63937;s:12:\"delete-64697\";i:63938;s:12:\"delete-64700\";i:63939;s:12:\"delete-64701\";i:63940;s:12:\"delete-64698\";i:63941;s:12:\"delete-64699\";i:63942;s:12:\"delete-64702\";i:63943;s:12:\"delete-64705\";i:63944;s:12:\"delete-64703\";i:63945;s:12:\"delete-64704\";i:63946;s:12:\"delete-64706\";i:63947;s:12:\"delete-64707\";i:63948;s:12:\"delete-64710\";i:63949;s:12:\"delete-64708\";i:63950;s:12:\"delete-64709\";i:63951;s:12:\"delete-64711\";i:63952;s:12:\"delete-64712\";i:63953;s:12:\"delete-64715\";i:63954;s:12:\"delete-64716\";i:63955;s:12:\"delete-64713\";i:63956;s:12:\"delete-64714\";i:63957;s:12:\"delete-64717\";i:63958;s:12:\"delete-64720\";i:63959;s:12:\"delete-64721\";i:63960;s:12:\"delete-64718\";i:63961;s:12:\"delete-64719\";i:63962;s:12:\"delete-64722\";i:63963;s:12:\"delete-64725\";i:63964;s:12:\"delete-64726\";i:63965;s:12:\"delete-64723\";i:63966;s:12:\"delete-64724\";i:63967;s:12:\"delete-64727\";i:63968;s:12:\"delete-64730\";i:63969;s:12:\"delete-64731\";i:63970;s:12:\"delete-64728\";i:63971;s:12:\"delete-64729\";i:63972;s:12:\"delete-64732\";i:63973;s:12:\"delete-64735\";i:63974;s:12:\"delete-64736\";i:63975;s:12:\"delete-64733\";i:63976;s:12:\"delete-64734\";i:63977;s:12:\"delete-64737\";i:63978;s:12:\"delete-64740\";i:63979;s:12:\"delete-64738\";i:63980;s:12:\"delete-64739\";i:63981;s:12:\"delete-64741\";i:63982;s:12:\"delete-64742\";i:63983;s:12:\"delete-64745\";i:63984;s:12:\"delete-64746\";i:63985;s:12:\"delete-64743\";i:63986;s:12:\"delete-64744\";i:63987;s:12:\"delete-64747\";i:63988;s:12:\"delete-64750\";i:63989;s:12:\"delete-64751\";i:63990;s:12:\"delete-64748\";i:63991;s:12:\"delete-64749\";i:63992;s:12:\"delete-64752\";i:63993;s:12:\"delete-64755\";i:63994;s:12:\"delete-64753\";i:63995;s:12:\"delete-64754\";i:63996;s:12:\"delete-64756\";i:63997;s:12:\"delete-64757\";i:63998;s:12:\"delete-64760\";i:63999;s:12:\"delete-64761\";i:64000;s:12:\"delete-64758\";i:64001;s:12:\"delete-64759\";i:64002;s:12:\"delete-64762\";i:64003;s:12:\"delete-64765\";i:64004;s:12:\"delete-64766\";i:64005;s:12:\"delete-64767\";i:64006;s:12:\"delete-64770\";i:64007;s:12:\"delete-64771\";i:64008;s:12:\"delete-64763\";i:64009;s:12:\"delete-64764\";i:64010;s:12:\"delete-64768\";i:64011;s:12:\"delete-64769\";i:64012;s:12:\"delete-64772\";i:64013;s:12:\"delete-64775\";i:64014;s:12:\"delete-64773\";i:64015;s:12:\"delete-64774\";i:64016;s:12:\"delete-64776\";i:64017;s:12:\"delete-64777\";i:64018;s:12:\"delete-64780\";i:64019;s:12:\"delete-64781\";i:64020;s:12:\"delete-64778\";i:64021;s:12:\"delete-64779\";i:64022;s:12:\"delete-64782\";i:64023;s:12:\"delete-64785\";i:64024;s:12:\"delete-64786\";i:64025;s:12:\"delete-64783\";i:64026;s:12:\"delete-64784\";i:64027;s:12:\"delete-64787\";i:64028;s:12:\"delete-64788\";i:64029;s:12:\"delete-64789\";i:64030;s:12:\"delete-64790\";i:64031;s:12:\"delete-64791\";i:64032;s:12:\"delete-64792\";i:64033;s:12:\"delete-64795\";i:64034;s:12:\"delete-64796\";i:64035;s:12:\"delete-64793\";i:64036;s:12:\"delete-64794\";i:64037;s:12:\"delete-64797\";i:64038;s:12:\"delete-64800\";i:64039;s:12:\"delete-64801\";i:64040;s:12:\"delete-64798\";i:64041;s:12:\"delete-64799\";i:64042;s:12:\"delete-64802\";i:64043;s:12:\"delete-64805\";i:64044;s:12:\"delete-64806\";i:64045;s:12:\"delete-64803\";i:64046;s:12:\"delete-64804\";i:64047;s:12:\"delete-64807\";i:64048;s:12:\"delete-64810\";i:64049;s:12:\"delete-64808\";i:64050;s:12:\"delete-64809\";i:64051;s:12:\"delete-64811\";i:64052;s:12:\"delete-64812\";i:64053;s:12:\"delete-64815\";i:64054;s:12:\"delete-64816\";i:64055;s:12:\"delete-64813\";i:64056;s:12:\"delete-64814\";i:64057;s:12:\"delete-64817\";i:64058;s:12:\"delete-64820\";i:64059;s:12:\"delete-64821\";i:64060;s:12:\"delete-64818\";i:64061;s:12:\"delete-64819\";i:64062;s:12:\"delete-64822\";i:64063;s:12:\"delete-64825\";i:64064;s:12:\"delete-64826\";i:64065;s:12:\"delete-64823\";i:64066;s:12:\"delete-64824\";i:64067;s:12:\"delete-64827\";i:64068;s:12:\"delete-64830\";i:64069;s:12:\"delete-64831\";i:64070;s:12:\"delete-64828\";i:64071;s:12:\"delete-64829\";i:64072;s:12:\"delete-64832\";i:64073;s:12:\"delete-64835\";i:64074;s:12:\"delete-64836\";i:64075;s:12:\"delete-64833\";i:64076;s:12:\"delete-64834\";i:64077;s:12:\"delete-64837\";i:64078;s:12:\"delete-64840\";i:64079;s:12:\"delete-64841\";i:64080;s:12:\"delete-64838\";i:64081;s:12:\"delete-64839\";i:64082;s:12:\"delete-64842\";i:64083;s:12:\"delete-64845\";i:64084;s:12:\"delete-64846\";i:64085;s:12:\"delete-64843\";i:64086;s:12:\"delete-64844\";i:64087;s:12:\"delete-64847\";i:64088;s:12:\"delete-64850\";i:64089;s:12:\"delete-64851\";i:64090;s:12:\"delete-64848\";i:64091;s:12:\"delete-64849\";i:64092;s:12:\"delete-64852\";i:64093;s:12:\"delete-64855\";i:64094;s:12:\"delete-64853\";i:64095;s:12:\"delete-64854\";i:64096;s:12:\"delete-64856\";i:64097;s:12:\"delete-64857\";i:64098;s:12:\"delete-64860\";i:64099;s:12:\"delete-64861\";i:64100;s:12:\"delete-64858\";i:64101;s:12:\"delete-64859\";i:64102;s:12:\"delete-64862\";i:64103;s:12:\"delete-64865\";i:64104;s:12:\"delete-64866\";i:64105;s:12:\"delete-64863\";i:64106;s:12:\"delete-64864\";i:64107;s:12:\"delete-64867\";i:64108;s:12:\"delete-64870\";i:64109;s:12:\"delete-64871\";i:64110;s:12:\"delete-64868\";i:64111;s:12:\"delete-64869\";i:64112;s:12:\"delete-64872\";i:64113;s:12:\"delete-64875\";i:64114;s:12:\"delete-64876\";i:64115;s:12:\"delete-64873\";i:64116;s:12:\"delete-64874\";i:64117;s:12:\"delete-64877\";i:64118;s:12:\"delete-64880\";i:64119;s:12:\"delete-64878\";i:64120;s:12:\"delete-64879\";i:64121;s:12:\"delete-64881\";i:64122;s:12:\"delete-64882\";i:64123;s:12:\"delete-64885\";i:64124;s:12:\"delete-64886\";i:64125;s:12:\"delete-64883\";i:64126;s:12:\"delete-64884\";i:64127;s:12:\"delete-64887\";i:64128;s:12:\"delete-64890\";i:64129;s:12:\"delete-64891\";i:64130;s:12:\"delete-64888\";i:64131;s:12:\"delete-64889\";i:64132;s:12:\"delete-64892\";i:64133;s:12:\"delete-64895\";i:64134;s:12:\"delete-64896\";i:64135;s:12:\"delete-64893\";i:64136;s:12:\"delete-64894\";i:64137;s:12:\"delete-64897\";i:64138;s:12:\"delete-64900\";i:64139;s:12:\"delete-64901\";i:64140;s:12:\"delete-64898\";i:64141;s:12:\"delete-64899\";i:64142;s:12:\"delete-64902\";i:64143;s:12:\"delete-64905\";i:64144;s:12:\"delete-64906\";i:64145;s:12:\"delete-64903\";i:64146;s:12:\"delete-64904\";i:64147;s:12:\"delete-64907\";i:64148;s:12:\"delete-64910\";i:64149;s:12:\"delete-64911\";i:64150;s:12:\"delete-64908\";i:64151;s:12:\"delete-64909\";i:64152;s:12:\"delete-64912\";i:64153;s:12:\"delete-64915\";i:64154;s:12:\"delete-64916\";i:64155;s:12:\"delete-64913\";i:64156;s:12:\"delete-64914\";i:64157;s:12:\"delete-64917\";i:64158;s:12:\"delete-64920\";i:64159;s:12:\"delete-64921\";i:64160;s:12:\"delete-64918\";i:64161;s:12:\"delete-64919\";i:64162;s:12:\"delete-64922\";i:64163;s:12:\"delete-64925\";i:64164;s:12:\"delete-64926\";i:64165;s:12:\"delete-64923\";i:64166;s:12:\"delete-64924\";i:64167;s:12:\"delete-64927\";i:64168;s:12:\"delete-64930\";i:64169;s:12:\"delete-64931\";i:64170;s:12:\"delete-64928\";i:64171;s:12:\"delete-64929\";i:64172;s:12:\"delete-64932\";i:64173;s:12:\"delete-64935\";i:64174;s:12:\"delete-64936\";i:64175;s:12:\"delete-64933\";i:64176;s:12:\"delete-64934\";i:64177;s:12:\"delete-64937\";i:64178;s:12:\"delete-64940\";i:64179;s:12:\"delete-64938\";i:64180;s:12:\"delete-64939\";i:64181;s:12:\"delete-64941\";i:64182;s:12:\"delete-64942\";i:64183;s:12:\"delete-64945\";i:64184;s:12:\"delete-64946\";i:64185;s:12:\"delete-64943\";i:64186;s:12:\"delete-64944\";i:64187;s:12:\"delete-64947\";i:64188;s:12:\"delete-64950\";i:64189;s:12:\"delete-64951\";i:64190;s:12:\"delete-64948\";i:64191;s:12:\"delete-64949\";i:64192;s:12:\"delete-64952\";i:64193;s:12:\"delete-64955\";i:64194;s:12:\"delete-64953\";i:64195;s:12:\"delete-64954\";i:64196;s:12:\"delete-64956\";i:64197;s:12:\"delete-64957\";i:64198;s:12:\"delete-64958\";i:64199;s:12:\"delete-64959\";i:64200;s:12:\"delete-64960\";i:64201;s:12:\"delete-64961\";i:64202;s:12:\"delete-64962\";i:64203;s:12:\"delete-64965\";i:64204;s:12:\"delete-64966\";i:64205;s:12:\"delete-64963\";i:64206;s:12:\"delete-64964\";i:64207;s:12:\"delete-64967\";i:64208;s:12:\"delete-64970\";i:64209;s:12:\"delete-64968\";i:64210;s:12:\"delete-64969\";i:64211;s:12:\"delete-64971\";i:64212;s:12:\"delete-64972\";i:64213;s:12:\"delete-64975\";i:64214;s:12:\"delete-64976\";i:64215;s:12:\"delete-64973\";i:64216;s:12:\"delete-64974\";i:64217;s:12:\"delete-64977\";i:64218;s:12:\"delete-64980\";i:64219;s:12:\"delete-64981\";i:64220;s:12:\"delete-64978\";i:64221;s:12:\"delete-64979\";i:64222;s:12:\"delete-64982\";i:64223;s:12:\"delete-64985\";i:64224;s:12:\"delete-64986\";i:64225;s:12:\"delete-64983\";i:64226;s:12:\"delete-64984\";i:64227;s:12:\"delete-64987\";i:64228;s:12:\"delete-64990\";i:64229;s:12:\"delete-64991\";i:64230;s:12:\"delete-64988\";i:64231;s:12:\"delete-64989\";i:64232;s:12:\"delete-64992\";i:64233;s:12:\"delete-64995\";i:64234;s:12:\"delete-64996\";i:64235;s:12:\"delete-64993\";i:64236;s:12:\"delete-64994\";i:64237;s:12:\"delete-64997\";i:64238;s:12:\"delete-65000\";i:64239;s:12:\"delete-64998\";i:64240;s:12:\"delete-64999\";i:64241;s:12:\"delete-65001\";i:64242;s:12:\"delete-65002\";i:64243;s:12:\"delete-65005\";i:64244;s:12:\"delete-65003\";i:64245;s:12:\"delete-65004\";i:64246;s:12:\"delete-65006\";i:64247;s:12:\"delete-65009\";i:64248;s:12:\"delete-65010\";i:64249;s:12:\"delete-65007\";i:64250;s:12:\"delete-65008\";i:64251;s:12:\"delete-65011\";i:64252;s:12:\"delete-65014\";i:64253;s:12:\"delete-65015\";i:64254;s:12:\"delete-65012\";i:64255;s:12:\"delete-65013\";i:64256;s:12:\"delete-65016\";i:64257;s:12:\"delete-65019\";i:64258;s:12:\"delete-65020\";i:64259;s:12:\"delete-65017\";i:64260;s:12:\"delete-65018\";i:64261;s:12:\"delete-65021\";i:64262;s:12:\"delete-65024\";i:64263;s:12:\"delete-65025\";i:64264;s:12:\"delete-65022\";i:64265;s:12:\"delete-65023\";i:64266;s:12:\"delete-65026\";i:64267;s:12:\"delete-65029\";i:64268;s:12:\"delete-65030\";i:64269;s:12:\"delete-65027\";i:64270;s:12:\"delete-65028\";i:64271;s:12:\"delete-65031\";i:64272;s:12:\"delete-65034\";i:64273;s:12:\"delete-65035\";i:64274;s:12:\"delete-65032\";i:64275;s:12:\"delete-65033\";i:64276;s:12:\"delete-65036\";i:64277;s:12:\"delete-65039\";i:64278;s:12:\"delete-65040\";i:64279;s:12:\"delete-65037\";i:64280;s:12:\"delete-65038\";i:64281;s:12:\"delete-65041\";i:64282;s:12:\"delete-65044\";i:64283;s:12:\"delete-65045\";i:64284;s:12:\"delete-65042\";i:64285;s:12:\"delete-65043\";i:64286;s:12:\"delete-65046\";i:64287;s:12:\"delete-65049\";i:64288;s:12:\"delete-65050\";i:64289;s:12:\"delete-65047\";i:64290;s:12:\"delete-65048\";i:64291;s:12:\"delete-65051\";i:64292;s:12:\"delete-65054\";i:64293;s:12:\"delete-65052\";i:64294;s:12:\"delete-65053\";i:64295;s:12:\"delete-65055\";i:64296;s:12:\"delete-65056\";i:64297;s:12:\"delete-65059\";i:64298;s:12:\"delete-65060\";i:64299;s:12:\"delete-65057\";i:64300;s:12:\"delete-65058\";i:64301;s:12:\"delete-65061\";i:64302;s:12:\"delete-65064\";i:64303;s:12:\"delete-65065\";i:64304;s:12:\"delete-65062\";i:64305;s:12:\"delete-65063\";i:64306;s:12:\"delete-65066\";i:64307;s:12:\"delete-65069\";i:64308;s:12:\"delete-65070\";i:64309;s:12:\"delete-65067\";i:64310;s:12:\"delete-65068\";i:64311;s:12:\"delete-65071\";i:64312;s:12:\"delete-65074\";i:64313;s:12:\"delete-65075\";i:64314;s:12:\"delete-65072\";i:64315;s:12:\"delete-65073\";i:64316;s:12:\"delete-65076\";i:64317;s:12:\"delete-65079\";i:64318;s:12:\"delete-65080\";i:64319;s:12:\"delete-65077\";i:64320;s:12:\"delete-65078\";i:64321;s:12:\"delete-65081\";i:64322;s:12:\"delete-65084\";i:64323;s:12:\"delete-65085\";i:64324;s:12:\"delete-65082\";i:64325;s:12:\"delete-65083\";i:64326;s:12:\"delete-65086\";i:64327;s:12:\"delete-65089\";i:64328;s:12:\"delete-65090\";i:64329;s:12:\"delete-65087\";i:64330;s:12:\"delete-65088\";i:64331;s:12:\"delete-65091\";i:64332;s:12:\"delete-65094\";i:64333;s:12:\"delete-65095\";i:64334;s:12:\"delete-65092\";i:64335;s:12:\"delete-65093\";i:64336;s:12:\"delete-65096\";i:64337;s:12:\"delete-65099\";i:64338;s:12:\"delete-65100\";i:64339;s:12:\"delete-65097\";i:64340;s:12:\"delete-65098\";i:64341;s:12:\"delete-65101\";i:64342;s:12:\"delete-65104\";i:64343;s:12:\"delete-65105\";i:64344;s:12:\"delete-65102\";i:64345;s:12:\"delete-65103\";i:64346;s:12:\"delete-65106\";i:64347;s:12:\"delete-65109\";i:64348;s:12:\"delete-65110\";i:64349;s:12:\"delete-65107\";i:64350;s:12:\"delete-65108\";i:64351;s:12:\"delete-65111\";i:64352;s:12:\"delete-65114\";i:64353;s:12:\"delete-65112\";i:64354;s:12:\"delete-65113\";i:64355;s:12:\"delete-65115\";i:64356;s:12:\"delete-65116\";i:64357;s:12:\"delete-65119\";i:64358;s:12:\"delete-65120\";i:64359;s:12:\"delete-65117\";i:64360;s:12:\"delete-65118\";i:64361;s:12:\"delete-65121\";i:64362;s:12:\"delete-65124\";i:64363;s:12:\"delete-65122\";i:64364;s:12:\"delete-65123\";i:64365;s:12:\"delete-65125\";i:64366;s:12:\"delete-65126\";i:64367;s:12:\"delete-65129\";i:64368;s:12:\"delete-65130\";i:64369;s:12:\"delete-65127\";i:64370;s:12:\"delete-65128\";i:64371;s:12:\"delete-65131\";i:64372;s:12:\"delete-65134\";i:64373;s:12:\"delete-65135\";i:64374;s:12:\"delete-65132\";i:64375;s:12:\"delete-65133\";i:64376;s:12:\"delete-65136\";i:64377;s:12:\"delete-65139\";i:64378;s:12:\"delete-65140\";i:64379;s:12:\"delete-65137\";i:64380;s:12:\"delete-65138\";i:64381;s:12:\"delete-65141\";i:64382;s:12:\"delete-65144\";i:64383;s:12:\"delete-65145\";i:64384;s:12:\"delete-65142\";i:64385;s:12:\"delete-65143\";i:64386;s:12:\"delete-65146\";i:64387;s:12:\"delete-65149\";i:64388;s:12:\"delete-65147\";i:64389;s:12:\"delete-65148\";i:64390;s:12:\"delete-65150\";i:64391;s:12:\"delete-65151\";i:64392;s:12:\"delete-65154\";i:64393;s:12:\"delete-65155\";i:64394;s:12:\"delete-65152\";i:64395;s:12:\"delete-65153\";i:64396;s:12:\"delete-65156\";i:64397;s:12:\"delete-65159\";i:64398;s:12:\"delete-65160\";i:64399;s:12:\"delete-65157\";i:64400;s:12:\"delete-65158\";i:64401;s:12:\"delete-65161\";i:64402;s:12:\"delete-65164\";i:64403;s:12:\"delete-65165\";i:64404;s:12:\"delete-65162\";i:64405;s:12:\"delete-65163\";i:64406;s:12:\"delete-65166\";i:64407;s:12:\"delete-65169\";i:64408;s:12:\"delete-65170\";i:64409;s:12:\"delete-65167\";i:64410;s:12:\"delete-65168\";i:64411;s:12:\"delete-65171\";i:64412;s:12:\"delete-65174\";i:64413;s:12:\"delete-65175\";i:64414;s:12:\"delete-65172\";i:64415;s:12:\"delete-65173\";i:64416;s:12:\"delete-65176\";i:64417;s:12:\"delete-65179\";i:64418;s:12:\"delete-65177\";i:64419;s:12:\"delete-65178\";i:64420;s:12:\"delete-65180\";i:64421;s:12:\"delete-65181\";i:64422;s:12:\"delete-65184\";i:64423;s:12:\"delete-65185\";i:64424;s:12:\"delete-65182\";i:64425;s:12:\"delete-65183\";i:64426;s:12:\"delete-65186\";i:64427;s:12:\"delete-65189\";i:64428;s:12:\"delete-65190\";i:64429;s:12:\"delete-65187\";i:64430;s:12:\"delete-65188\";i:64431;s:12:\"delete-65191\";i:64432;s:12:\"delete-65194\";i:64433;s:12:\"delete-65195\";i:64434;s:12:\"delete-65192\";i:64435;s:12:\"delete-65193\";i:64436;s:12:\"delete-65196\";i:64437;s:12:\"delete-65199\";i:64438;s:12:\"delete-65200\";i:64439;s:12:\"delete-65197\";i:64440;s:12:\"delete-65198\";i:64441;s:12:\"delete-65201\";i:64442;s:12:\"delete-65204\";i:64443;s:12:\"delete-65205\";i:64444;s:12:\"delete-65202\";i:64445;s:12:\"delete-65203\";i:64446;s:12:\"delete-65206\";i:64447;s:12:\"delete-65209\";i:64448;s:12:\"delete-65207\";i:64449;s:12:\"delete-65208\";i:64450;s:12:\"delete-65210\";i:64451;s:12:\"delete-65211\";i:64452;s:12:\"delete-65214\";i:64453;s:12:\"delete-65215\";i:64454;s:12:\"delete-65212\";i:64455;s:12:\"delete-65213\";i:64456;s:12:\"delete-65216\";i:64457;s:12:\"delete-65219\";i:64458;s:12:\"delete-65220\";i:64459;s:12:\"delete-65217\";i:64460;s:12:\"delete-65218\";i:64461;s:12:\"delete-65221\";i:64462;s:12:\"delete-65224\";i:64463;s:12:\"delete-65225\";i:64464;s:12:\"delete-65222\";i:64465;s:12:\"delete-65223\";i:64466;s:12:\"delete-65226\";i:64467;s:12:\"delete-65229\";i:64468;s:12:\"delete-65230\";i:64469;s:12:\"delete-65227\";i:64470;s:12:\"delete-65228\";i:64471;s:12:\"delete-65231\";i:64472;s:12:\"delete-65234\";i:64473;s:12:\"delete-65232\";i:64474;s:12:\"delete-65233\";i:64475;s:12:\"delete-65235\";i:64476;s:12:\"delete-65236\";i:64477;s:12:\"delete-65239\";i:64478;s:12:\"delete-65240\";i:64479;s:12:\"delete-65237\";i:64480;s:12:\"delete-65238\";i:64481;s:12:\"delete-65241\";i:64482;s:12:\"delete-65244\";i:64483;s:12:\"delete-65245\";i:64484;s:12:\"delete-65242\";i:64485;s:12:\"delete-65243\";i:64486;s:12:\"delete-65246\";i:64487;s:12:\"delete-65249\";i:64488;s:12:\"delete-65247\";i:64489;s:12:\"delete-65248\";i:64490;s:12:\"delete-65250\";i:64491;s:12:\"delete-65251\";i:64492;s:12:\"delete-65254\";i:64493;s:12:\"delete-65255\";i:64494;s:12:\"delete-65252\";i:64495;s:12:\"delete-65253\";i:64496;s:12:\"delete-65256\";i:64497;s:12:\"delete-65259\";i:64498;s:12:\"delete-65257\";i:64499;s:12:\"delete-65258\";i:64500;s:12:\"delete-65260\";i:64501;s:12:\"delete-65261\";i:64502;s:12:\"delete-65264\";i:64503;s:12:\"delete-65265\";i:64504;s:12:\"delete-65262\";i:64505;s:12:\"delete-65263\";i:64506;s:12:\"delete-65266\";i:64507;s:12:\"delete-65269\";i:64508;s:12:\"delete-65270\";i:64509;s:12:\"delete-65267\";i:64510;s:12:\"delete-65268\";i:64511;s:12:\"delete-65271\";i:64512;s:12:\"delete-65274\";i:64513;s:12:\"delete-65275\";i:64514;s:12:\"delete-65272\";i:64515;s:12:\"delete-65273\";i:64516;s:12:\"delete-65276\";i:64517;s:12:\"delete-65279\";i:64518;s:12:\"delete-65280\";i:64519;s:12:\"delete-65277\";i:64520;s:12:\"delete-65278\";i:64521;s:12:\"delete-65281\";i:64522;s:12:\"delete-65284\";i:64523;s:12:\"delete-65285\";i:64524;s:12:\"delete-65282\";i:64525;s:12:\"delete-65283\";i:64526;s:12:\"delete-65286\";i:64527;s:12:\"delete-65289\";i:64528;s:12:\"delete-65290\";i:64529;s:12:\"delete-65287\";i:64530;s:12:\"delete-65288\";i:64531;s:12:\"delete-65291\";i:64532;s:12:\"delete-65294\";i:64533;s:12:\"delete-65295\";i:64534;s:12:\"delete-65292\";i:64535;s:12:\"delete-65293\";i:64536;s:12:\"delete-65296\";i:64537;s:12:\"delete-65299\";i:64538;s:12:\"delete-65297\";i:64539;s:12:\"delete-65298\";i:64540;s:12:\"delete-65300\";i:64541;s:12:\"delete-65301\";i:64542;s:12:\"delete-65304\";i:64543;s:12:\"delete-65305\";i:64544;s:12:\"delete-65302\";i:64545;s:12:\"delete-65303\";i:64546;s:12:\"delete-65306\";i:64547;s:12:\"delete-65309\";i:64548;s:12:\"delete-65310\";i:64549;s:12:\"delete-65307\";i:64550;s:12:\"delete-65308\";i:64551;s:12:\"delete-65311\";i:64552;s:12:\"delete-65314\";i:64553;s:12:\"delete-65315\";i:64554;s:12:\"delete-65312\";i:64555;s:12:\"delete-65313\";i:64556;s:12:\"delete-65316\";i:64557;s:12:\"delete-65319\";i:64558;s:12:\"delete-65320\";i:64559;s:12:\"delete-65317\";i:64560;s:12:\"delete-65318\";i:64561;s:12:\"delete-65321\";i:64562;s:12:\"delete-65324\";i:64563;s:12:\"delete-65325\";i:64564;s:12:\"delete-65322\";i:64565;s:12:\"delete-65323\";i:64566;s:12:\"delete-65326\";i:64567;s:12:\"delete-65329\";i:64568;s:12:\"delete-65330\";i:64569;s:12:\"delete-65327\";i:64570;s:12:\"delete-65328\";i:64571;s:12:\"delete-65331\";i:64572;s:12:\"delete-65334\";i:64573;s:12:\"delete-65335\";i:64574;s:12:\"delete-65332\";i:64575;s:12:\"delete-65333\";i:64576;s:12:\"delete-65336\";i:64577;s:12:\"delete-65339\";i:64578;s:12:\"delete-65340\";i:64579;s:12:\"delete-65337\";i:64580;s:12:\"delete-65338\";i:64581;s:12:\"delete-65341\";i:64582;s:12:\"delete-65344\";i:64583;s:12:\"delete-65345\";i:64584;s:12:\"delete-65342\";i:64585;s:12:\"delete-65343\";i:64586;s:12:\"delete-65346\";i:64587;s:12:\"delete-65349\";i:64588;s:12:\"delete-65347\";i:64589;s:12:\"delete-65348\";i:64590;s:12:\"delete-65350\";i:64591;s:12:\"delete-65351\";i:64592;s:12:\"delete-65354\";i:64593;s:12:\"delete-65355\";i:64594;s:12:\"delete-65352\";i:64595;s:12:\"delete-65353\";i:64596;s:12:\"delete-65356\";i:64597;s:12:\"delete-65359\";i:64598;s:12:\"delete-65360\";i:64599;s:12:\"delete-65357\";i:64600;s:12:\"delete-65358\";i:64601;s:12:\"delete-65361\";i:64602;s:12:\"delete-65364\";i:64603;s:12:\"delete-65365\";i:64604;s:12:\"delete-65362\";i:64605;s:12:\"delete-65363\";i:64606;s:12:\"delete-65366\";i:64607;s:12:\"delete-65369\";i:64608;s:12:\"delete-65370\";i:64609;s:12:\"delete-65367\";i:64610;s:12:\"delete-65368\";i:64611;s:12:\"delete-65371\";i:64612;s:12:\"delete-65374\";i:64613;s:12:\"delete-65375\";i:64614;s:12:\"delete-65372\";i:64615;s:12:\"delete-65373\";i:64616;s:12:\"delete-65376\";i:64617;s:12:\"delete-65379\";i:64618;s:12:\"delete-65380\";i:64619;s:12:\"delete-65377\";i:64620;s:12:\"delete-65378\";i:64621;s:12:\"delete-65381\";i:64622;s:12:\"delete-65384\";i:64623;s:12:\"delete-65382\";i:64624;s:12:\"delete-65383\";i:64625;s:12:\"delete-65385\";i:64626;s:12:\"delete-65386\";i:64627;s:12:\"delete-65389\";i:64628;s:12:\"delete-65390\";i:64629;s:12:\"delete-65387\";i:64630;s:12:\"delete-65388\";i:64631;s:12:\"delete-65391\";i:64632;s:12:\"delete-65394\";i:64633;s:12:\"delete-65395\";i:64634;s:12:\"delete-65392\";i:64635;s:12:\"delete-65393\";i:64636;s:12:\"delete-65396\";i:64637;s:12:\"delete-65399\";i:64638;s:12:\"delete-65400\";i:64639;s:12:\"delete-65397\";i:64640;s:12:\"delete-65398\";i:64641;s:12:\"delete-65401\";i:64642;s:12:\"delete-65404\";i:64643;s:12:\"delete-65405\";i:64644;s:12:\"delete-65402\";i:64645;s:12:\"delete-65403\";i:64646;s:12:\"delete-65406\";i:64647;s:12:\"delete-65409\";i:64648;s:12:\"delete-65410\";i:64649;s:12:\"delete-65407\";i:64650;s:12:\"delete-65408\";i:64651;s:12:\"delete-65411\";i:64652;s:12:\"delete-65414\";i:64653;s:12:\"delete-65415\";i:64654;s:12:\"delete-65412\";i:64655;s:12:\"delete-65413\";i:64656;s:12:\"delete-65416\";i:64657;s:12:\"delete-65419\";i:64658;s:12:\"delete-65420\";i:64659;s:12:\"delete-65417\";i:64660;s:12:\"delete-65418\";i:64661;s:12:\"delete-65421\";i:64662;s:12:\"delete-65424\";i:64663;s:12:\"delete-65425\";i:64664;s:12:\"delete-65422\";i:64665;s:12:\"delete-65423\";i:64666;s:12:\"delete-65426\";i:64667;s:12:\"delete-65429\";i:64668;s:12:\"delete-65430\";i:64669;s:12:\"delete-65427\";i:64670;s:12:\"delete-65428\";i:64671;s:12:\"delete-65431\";i:64672;s:12:\"delete-65434\";i:64673;s:12:\"delete-65435\";i:64674;s:12:\"delete-65432\";i:64675;s:12:\"delete-65433\";i:64676;s:12:\"delete-65436\";i:64677;s:12:\"delete-65439\";i:64678;s:12:\"delete-65440\";i:64679;s:12:\"delete-65437\";i:64680;s:12:\"delete-65438\";i:64681;s:12:\"delete-65441\";i:64682;s:12:\"delete-65444\";i:64683;s:12:\"delete-65442\";i:64684;s:12:\"delete-65443\";i:64685;s:12:\"delete-65445\";i:64686;s:12:\"delete-65446\";i:64687;s:12:\"delete-65449\";i:64688;s:12:\"delete-65450\";i:64689;s:12:\"delete-65447\";i:64690;s:12:\"delete-65448\";i:64691;s:12:\"delete-65451\";i:64692;s:12:\"delete-65454\";i:64693;s:12:\"delete-65455\";i:64694;s:12:\"delete-65452\";i:64695;s:12:\"delete-65453\";i:64696;s:12:\"delete-65456\";i:64697;s:12:\"delete-65459\";i:64698;s:12:\"delete-65460\";i:64699;s:12:\"delete-65457\";i:64700;s:12:\"delete-65458\";i:64701;s:12:\"delete-65461\";i:64702;s:12:\"delete-65464\";i:64703;s:12:\"delete-65465\";i:64704;s:12:\"delete-65462\";i:64705;s:12:\"delete-65463\";i:64706;s:12:\"delete-65466\";i:64707;s:12:\"delete-65469\";i:64708;s:12:\"delete-65470\";i:64709;s:12:\"delete-65467\";i:64710;s:12:\"delete-65468\";i:64711;s:12:\"delete-65471\";i:64712;s:12:\"delete-65474\";i:64713;s:12:\"delete-65475\";i:64714;s:12:\"delete-65472\";i:64715;s:12:\"delete-65473\";i:64716;s:12:\"delete-65476\";i:64717;s:12:\"delete-65479\";i:64718;s:12:\"delete-65480\";i:64719;s:12:\"delete-65477\";i:64720;s:12:\"delete-65478\";i:64721;s:12:\"delete-65481\";i:64722;s:12:\"delete-65484\";i:64723;s:12:\"delete-65485\";i:64724;s:12:\"delete-65486\";i:64725;s:12:\"delete-65489\";i:64726;s:12:\"delete-65490\";i:64727;s:12:\"delete-65491\";i:64728;s:12:\"delete-65494\";i:64729;s:12:\"delete-65495\";i:64730;s:12:\"delete-65482\";i:64731;s:12:\"delete-65483\";i:64732;s:12:\"delete-65487\";i:64733;s:12:\"delete-65488\";i:64734;s:12:\"delete-65492\";i:64735;s:12:\"delete-65493\";i:64736;s:12:\"delete-65496\";i:64737;s:12:\"delete-65499\";i:64738;s:12:\"delete-65500\";i:64739;s:12:\"delete-65501\";i:64740;s:12:\"delete-65504\";i:64741;s:12:\"delete-65505\";i:64742;s:12:\"delete-65497\";i:64743;s:12:\"delete-65498\";i:64744;s:12:\"delete-65502\";i:64745;s:12:\"delete-65503\";i:64746;s:12:\"delete-65506\";i:64747;s:12:\"delete-65509\";i:64748;s:12:\"delete-65507\";i:64749;s:12:\"delete-65508\";i:64750;s:12:\"delete-65510\";i:64751;s:12:\"delete-65511\";i:64752;s:12:\"delete-65514\";i:64753;s:12:\"delete-65515\";i:64754;s:12:\"delete-65512\";i:64755;s:12:\"delete-65513\";i:64756;s:12:\"delete-65516\";i:64757;s:12:\"delete-65519\";i:64758;s:12:\"delete-65520\";i:64759;s:12:\"delete-65517\";i:64760;s:12:\"delete-65518\";i:64761;s:12:\"delete-65521\";i:64762;s:12:\"delete-65524\";i:64763;s:12:\"delete-65525\";i:64764;s:12:\"delete-65522\";i:64765;s:12:\"delete-65523\";i:64766;s:12:\"delete-65526\";i:64767;s:12:\"delete-65529\";i:64768;s:12:\"delete-65530\";i:64769;s:12:\"delete-65527\";i:64770;s:12:\"delete-65528\";i:64771;s:12:\"delete-65531\";i:64772;s:12:\"delete-65534\";i:64773;s:12:\"delete-65535\";i:64774;s:12:\"delete-65532\";i:64775;s:12:\"delete-65533\";i:64776;s:12:\"delete-65536\";i:64777;s:12:\"delete-65539\";i:64778;s:12:\"delete-65537\";i:64779;s:12:\"delete-65538\";i:64780;s:12:\"delete-65540\";i:64781;s:12:\"delete-65541\";i:64782;s:12:\"delete-65544\";i:64783;s:12:\"delete-65545\";i:64784;s:12:\"delete-65542\";i:64785;s:12:\"delete-65543\";i:64786;s:12:\"delete-65546\";i:64787;s:12:\"delete-65549\";i:64788;s:12:\"delete-65550\";i:64789;s:12:\"delete-65547\";i:64790;s:12:\"delete-65548\";i:64791;s:12:\"delete-65551\";i:64792;s:12:\"delete-65554\";i:64793;s:12:\"delete-65555\";i:64794;s:12:\"delete-65552\";i:64795;s:12:\"delete-65553\";i:64796;s:12:\"delete-65556\";i:64797;s:12:\"delete-65559\";i:64798;s:12:\"delete-65560\";i:64799;s:12:\"delete-65557\";i:64800;s:12:\"delete-65558\";i:64801;s:12:\"delete-65561\";i:64802;s:12:\"delete-65564\";i:64803;s:12:\"delete-65565\";i:64804;s:12:\"delete-65562\";i:64805;s:12:\"delete-65563\";i:64806;s:12:\"delete-65566\";i:64807;s:12:\"delete-65569\";i:64808;s:12:\"delete-65567\";i:64809;s:12:\"delete-65568\";i:64810;s:12:\"delete-65570\";i:64811;s:12:\"delete-65571\";i:64812;s:12:\"delete-65574\";i:64813;s:12:\"delete-65575\";i:64814;s:12:\"delete-65572\";i:64815;s:12:\"delete-65573\";i:64816;s:12:\"delete-65576\";i:64817;s:12:\"delete-65579\";i:64818;s:12:\"delete-65580\";i:64819;s:12:\"delete-65577\";i:64820;s:12:\"delete-65578\";i:64821;s:12:\"delete-65581\";i:64822;s:12:\"delete-65584\";i:64823;s:12:\"delete-65585\";i:64824;s:12:\"delete-65582\";i:64825;s:12:\"delete-65583\";i:64826;s:12:\"delete-65586\";i:64827;s:12:\"delete-65589\";i:64828;s:12:\"delete-65590\";i:64829;s:12:\"delete-65587\";i:64830;s:12:\"delete-65588\";i:64831;s:12:\"delete-65591\";i:64832;s:12:\"delete-65594\";i:64833;s:12:\"delete-65595\";i:64834;s:12:\"delete-65592\";i:64835;s:12:\"delete-65593\";i:64836;s:12:\"delete-65596\";i:64837;s:12:\"delete-65599\";i:64838;s:12:\"delete-65600\";i:64839;s:12:\"delete-65597\";i:64840;s:12:\"delete-65598\";i:64841;s:12:\"delete-65601\";i:64842;s:12:\"delete-65604\";i:64843;s:12:\"delete-65605\";i:64844;s:12:\"delete-65602\";i:64845;s:12:\"delete-65603\";i:64846;s:12:\"delete-65606\";i:64847;s:12:\"delete-65609\";i:64848;s:12:\"delete-65607\";i:64849;s:12:\"delete-65608\";i:64850;s:12:\"delete-65610\";i:64851;s:12:\"delete-65611\";i:64852;s:12:\"delete-65614\";i:64853;s:12:\"delete-65615\";i:64854;s:12:\"delete-65612\";i:64855;s:12:\"delete-65613\";i:64856;s:12:\"delete-65616\";i:64857;s:12:\"delete-65619\";i:64858;s:12:\"delete-65620\";i:64859;s:12:\"delete-65617\";i:64860;s:12:\"delete-65618\";i:64861;s:12:\"delete-65621\";i:64862;s:12:\"delete-65624\";i:64863;s:12:\"delete-65622\";i:64864;s:12:\"delete-65623\";i:64865;s:12:\"delete-65625\";i:64866;s:12:\"delete-65626\";i:64867;s:12:\"delete-65629\";i:64868;s:12:\"delete-65630\";i:64869;s:12:\"delete-65627\";i:64870;s:12:\"delete-65628\";i:64871;s:12:\"delete-65631\";i:64872;s:12:\"delete-65634\";i:64873;s:12:\"delete-65635\";i:64874;s:12:\"delete-65632\";i:64875;s:12:\"delete-65633\";i:64876;s:12:\"delete-65636\";i:64877;s:12:\"delete-65639\";i:64878;s:12:\"delete-65640\";i:64879;s:12:\"delete-65637\";i:64880;s:12:\"delete-65638\";i:64881;s:12:\"delete-65641\";i:64882;s:12:\"delete-65644\";i:64883;s:12:\"delete-65642\";i:64884;s:12:\"delete-65643\";i:64885;s:12:\"delete-65645\";i:64886;s:12:\"delete-65648\";i:64887;s:12:\"delete-65649\";i:64888;s:12:\"delete-65646\";i:64889;s:12:\"delete-65647\";i:64890;s:12:\"delete-65650\";i:64891;s:12:\"delete-65653\";i:64892;s:12:\"delete-65654\";i:64893;s:12:\"delete-65651\";i:64894;s:12:\"delete-65652\";i:64895;s:12:\"delete-65655\";i:64896;s:12:\"delete-65658\";i:64897;s:12:\"delete-65659\";i:64898;s:12:\"delete-65656\";i:64899;s:12:\"delete-65657\";i:64900;s:12:\"delete-65660\";i:64901;s:12:\"delete-65663\";i:64902;s:12:\"delete-65664\";i:64903;s:12:\"delete-65661\";i:64904;s:12:\"delete-65662\";i:64905;s:12:\"delete-65665\";i:64906;s:12:\"delete-65668\";i:64907;s:12:\"delete-65666\";i:64908;s:12:\"delete-65667\";i:64909;s:12:\"delete-65669\";i:64910;s:12:\"delete-65670\";i:64911;s:12:\"delete-65673\";i:64912;s:12:\"delete-65674\";i:64913;s:12:\"delete-65671\";i:64914;s:12:\"delete-65672\";i:64915;s:12:\"delete-65675\";i:64916;s:12:\"delete-65678\";i:64917;s:12:\"delete-65679\";i:64918;s:12:\"delete-65676\";i:64919;s:12:\"delete-65677\";i:64920;s:12:\"delete-65680\";i:64921;s:12:\"delete-65683\";i:64922;s:12:\"delete-65684\";i:64923;s:12:\"delete-65681\";i:64924;s:12:\"delete-65682\";i:64925;s:12:\"delete-65685\";i:64926;s:12:\"delete-65688\";i:64927;s:12:\"delete-65689\";i:64928;s:12:\"delete-65686\";i:64929;s:12:\"delete-65687\";i:64930;s:12:\"delete-65690\";i:64931;s:12:\"delete-65693\";i:64932;s:12:\"delete-65694\";i:64933;s:12:\"delete-65691\";i:64934;s:12:\"delete-65692\";i:64935;s:12:\"delete-65695\";i:64936;s:12:\"delete-65698\";i:64937;s:12:\"delete-65699\";i:64938;s:12:\"delete-65696\";i:64939;s:12:\"delete-65697\";i:64940;s:12:\"delete-65700\";i:64941;s:12:\"delete-65703\";i:64942;s:12:\"delete-65704\";i:64943;s:12:\"delete-65701\";i:64944;s:12:\"delete-65702\";i:64945;s:12:\"delete-65705\";i:64946;s:12:\"delete-65708\";i:64947;s:12:\"delete-65709\";i:64948;s:12:\"delete-65706\";i:64949;s:12:\"delete-65707\";i:64950;s:12:\"delete-65710\";i:64951;s:12:\"delete-65714\";i:64952;s:12:\"delete-65713\";i:64953;s:12:\"delete-65711\";i:64954;s:12:\"delete-65712\";i:64955;s:12:\"delete-65715\";i:64956;s:12:\"delete-65719\";i:64957;s:12:\"delete-65718\";i:64958;s:12:\"delete-65716\";i:64959;s:12:\"delete-65717\";i:64960;s:12:\"delete-65720\";i:64961;s:12:\"delete-65724\";i:64962;s:12:\"delete-65723\";i:64963;s:12:\"delete-65721\";i:64964;s:12:\"delete-65722\";i:64965;s:12:\"delete-65725\";i:64966;s:12:\"delete-65729\";i:64967;s:12:\"delete-65728\";i:64968;s:12:\"delete-65726\";i:64969;s:12:\"delete-65727\";i:64970;s:12:\"delete-65730\";i:64971;s:12:\"delete-65733\";i:64972;s:12:\"delete-65734\";i:64973;s:12:\"delete-65731\";i:64974;s:12:\"delete-65732\";i:64975;s:12:\"delete-65735\";i:64976;s:12:\"delete-65738\";i:64977;s:12:\"delete-65739\";i:64978;s:12:\"delete-65736\";i:64979;s:12:\"delete-65737\";i:64980;s:12:\"delete-65740\";i:64981;s:12:\"delete-65744\";i:64982;s:12:\"delete-65743\";i:64983;s:12:\"delete-65741\";i:64984;s:12:\"delete-65742\";i:64985;s:12:\"delete-65745\";i:64986;s:12:\"delete-65748\";i:64987;s:12:\"delete-65749\";i:64988;s:12:\"delete-65746\";i:64989;s:12:\"delete-65747\";i:64990;s:12:\"delete-65750\";i:64991;s:12:\"delete-65753\";i:64992;s:12:\"delete-65754\";i:64993;s:12:\"delete-65751\";i:64994;s:12:\"delete-65752\";i:64995;s:12:\"delete-65755\";i:64996;s:12:\"delete-65758\";i:64997;s:12:\"delete-65759\";i:64998;s:12:\"delete-65756\";i:64999;s:12:\"delete-65757\";i:65000;s:12:\"delete-65760\";i:65001;s:12:\"delete-65763\";i:65002;s:12:\"delete-65761\";i:65003;s:12:\"delete-65762\";i:65004;s:12:\"delete-65764\";i:65005;s:12:\"delete-65765\";i:65006;s:12:\"delete-65768\";i:65007;s:12:\"delete-65769\";i:65008;s:12:\"delete-65766\";i:65009;s:12:\"delete-65767\";i:65010;s:12:\"delete-65770\";i:65011;s:12:\"delete-65773\";i:65012;s:12:\"delete-65771\";i:65013;s:12:\"delete-65772\";i:65014;s:12:\"delete-65774\";i:65015;s:12:\"delete-65778\";i:65016;s:12:\"delete-65775\";i:65017;s:12:\"delete-65779\";i:65018;s:12:\"delete-65776\";i:65019;s:12:\"delete-65777\";i:65020;s:12:\"delete-65780\";i:65021;s:12:\"delete-65784\";i:65022;s:12:\"delete-65783\";i:65023;s:12:\"delete-65781\";i:65024;s:12:\"delete-65782\";i:65025;s:12:\"delete-65785\";i:65026;s:12:\"delete-65788\";i:65027;s:12:\"delete-65789\";i:65028;s:12:\"delete-65786\";i:65029;s:12:\"delete-65787\";i:65030;s:12:\"delete-65790\";i:65031;s:12:\"delete-65794\";i:65032;s:12:\"delete-65793\";i:65033;s:12:\"delete-65791\";i:65034;s:12:\"delete-65792\";i:65035;s:12:\"delete-65795\";i:65036;s:12:\"delete-65798\";i:65037;s:12:\"delete-65799\";i:65038;s:12:\"delete-65796\";i:65039;s:12:\"delete-65797\";i:65040;s:12:\"delete-65800\";i:65041;s:12:\"delete-65804\";i:65042;s:12:\"delete-65803\";i:65043;s:12:\"delete-65801\";i:65044;s:12:\"delete-65802\";i:65045;s:12:\"delete-65805\";i:65046;s:12:\"delete-65808\";i:65047;s:12:\"delete-65809\";i:65048;s:12:\"delete-65806\";i:65049;s:12:\"delete-65807\";i:65050;s:12:\"delete-65810\";i:65051;s:12:\"delete-65813\";i:65052;s:12:\"delete-65814\";i:65053;s:12:\"delete-65811\";i:65054;s:12:\"delete-65812\";i:65055;s:12:\"delete-65815\";i:65056;s:12:\"delete-65818\";i:65057;s:12:\"delete-65819\";i:65058;s:12:\"delete-65816\";i:65059;s:12:\"delete-65817\";i:65060;s:12:\"delete-65820\";i:65061;s:12:\"delete-65823\";i:65062;s:12:\"delete-65824\";i:65063;s:12:\"delete-65821\";i:65064;s:12:\"delete-65822\";i:65065;s:12:\"delete-65825\";i:65066;s:12:\"delete-65829\";i:65067;s:12:\"delete-65828\";i:65068;s:12:\"delete-65826\";i:65069;s:12:\"delete-65827\";i:65070;s:12:\"delete-65830\";i:65071;s:12:\"delete-65833\";i:65072;s:12:\"delete-65834\";i:65073;s:12:\"delete-65831\";i:65074;s:12:\"delete-65832\";i:65075;s:12:\"delete-65835\";i:65076;s:12:\"delete-65838\";i:65077;s:12:\"delete-65839\";i:65078;s:12:\"delete-65836\";i:65079;s:12:\"delete-65837\";i:65080;s:12:\"delete-65840\";i:65081;s:12:\"delete-65843\";i:65082;s:12:\"delete-65844\";i:65083;s:12:\"delete-65841\";i:65084;s:12:\"delete-65842\";i:65085;s:12:\"delete-65845\";i:65086;s:12:\"delete-65849\";i:65087;s:12:\"delete-65848\";i:65088;s:12:\"delete-65846\";i:65089;s:12:\"delete-65847\";i:65090;s:12:\"delete-65850\";i:65091;s:12:\"delete-65853\";i:65092;s:12:\"delete-65851\";i:65093;s:12:\"delete-65852\";i:65094;s:12:\"delete-65854\";i:65095;s:12:\"delete-65855\";i:65096;s:12:\"delete-65858\";i:65097;s:12:\"delete-65859\";i:65098;s:12:\"delete-65856\";i:65099;s:12:\"delete-65857\";i:65100;s:12:\"delete-65860\";i:65101;s:12:\"delete-65863\";i:65102;s:12:\"delete-65864\";i:65103;s:12:\"delete-65861\";i:65104;s:12:\"delete-65862\";i:65105;s:12:\"delete-65865\";i:65106;s:12:\"delete-65868\";i:65107;s:12:\"delete-65869\";i:65108;s:12:\"delete-65866\";i:65109;s:12:\"delete-65867\";i:65110;s:12:\"delete-65870\";i:65111;s:12:\"delete-65873\";i:65112;s:12:\"delete-65874\";i:65113;s:12:\"delete-65871\";i:65114;s:12:\"delete-65872\";i:65115;s:12:\"delete-65875\";i:65116;s:12:\"delete-65878\";i:65117;s:12:\"delete-65879\";i:65118;s:12:\"delete-65876\";i:65119;s:12:\"delete-65877\";i:65120;s:12:\"delete-65880\";i:65121;s:12:\"delete-65883\";i:65122;s:12:\"delete-65884\";i:65123;s:12:\"delete-65881\";i:65124;s:12:\"delete-65882\";i:65125;s:12:\"delete-65885\";i:65126;s:12:\"delete-65888\";i:65127;s:12:\"delete-65889\";i:65128;s:12:\"delete-65886\";i:65129;s:12:\"delete-65887\";i:65130;s:12:\"delete-65890\";i:65131;s:12:\"delete-65893\";i:65132;s:12:\"delete-65891\";i:65133;s:12:\"delete-65892\";i:65134;s:12:\"delete-65894\";i:65135;s:12:\"delete-65895\";i:65136;s:12:\"delete-65898\";i:65137;s:12:\"delete-65899\";i:65138;s:12:\"delete-65896\";i:65139;s:12:\"delete-65897\";i:65140;s:12:\"delete-65900\";i:65141;s:12:\"delete-65903\";i:65142;s:12:\"delete-65904\";i:65143;s:12:\"delete-65901\";i:65144;s:12:\"delete-65902\";i:65145;s:12:\"delete-65905\";i:65146;s:12:\"delete-65908\";i:65147;s:12:\"delete-65909\";i:65148;s:12:\"delete-65906\";i:65149;s:12:\"delete-65907\";i:65150;s:12:\"delete-65910\";i:65151;s:12:\"delete-65913\";i:65152;s:12:\"delete-65914\";i:65153;s:12:\"delete-65911\";i:65154;s:12:\"delete-65912\";i:65155;s:12:\"delete-65915\";i:65156;s:12:\"delete-65918\";i:65157;s:12:\"delete-65919\";i:65158;s:12:\"delete-65916\";i:65159;s:12:\"delete-65917\";i:65160;s:12:\"delete-65920\";i:65161;s:12:\"delete-65923\";i:65162;s:12:\"delete-65924\";i:65163;s:12:\"delete-65921\";i:65164;s:12:\"delete-65922\";i:65165;s:12:\"delete-65925\";i:65166;s:12:\"delete-65928\";i:65167;s:12:\"delete-65929\";i:65168;s:12:\"delete-65926\";i:65169;s:12:\"delete-65927\";i:65170;s:12:\"delete-65930\";i:65171;s:12:\"delete-65933\";i:65172;s:12:\"delete-65934\";i:65173;s:12:\"delete-65931\";i:65174;s:12:\"delete-65932\";i:65175;s:12:\"delete-65935\";i:65176;s:12:\"delete-65938\";i:65177;s:12:\"delete-65939\";i:65178;s:12:\"delete-65936\";i:65179;s:12:\"delete-65937\";i:65180;s:12:\"delete-65940\";i:65181;s:12:\"delete-65943\";i:65182;s:12:\"delete-65944\";i:65183;s:12:\"delete-65941\";i:65184;s:12:\"delete-65942\";i:65185;s:12:\"delete-65945\";i:65186;s:12:\"delete-65948\";i:65187;s:12:\"delete-65949\";i:65188;s:12:\"delete-65946\";i:65189;s:12:\"delete-65947\";i:65190;s:12:\"delete-65950\";i:65191;s:12:\"delete-65953\";i:65192;s:12:\"delete-65954\";i:65193;s:12:\"delete-65951\";i:65194;s:12:\"delete-65952\";i:65195;s:12:\"delete-65955\";i:65196;s:12:\"delete-65958\";i:65197;s:12:\"delete-65959\";i:65198;s:12:\"delete-65956\";i:65199;s:12:\"delete-65957\";i:65200;s:12:\"delete-65960\";i:65201;s:12:\"delete-65963\";i:65202;s:12:\"delete-65964\";i:65203;s:12:\"delete-65961\";i:65204;s:12:\"delete-65962\";i:65205;s:12:\"delete-65965\";i:65206;s:12:\"delete-65968\";i:65207;s:12:\"delete-65969\";i:65208;s:12:\"delete-65966\";i:65209;s:12:\"delete-65967\";i:65210;s:12:\"delete-65970\";i:65211;s:12:\"delete-65973\";i:65212;s:12:\"delete-65974\";i:65213;s:12:\"delete-65971\";i:65214;s:12:\"delete-65972\";i:65215;s:12:\"delete-65975\";i:65216;s:12:\"delete-65978\";i:65217;s:12:\"delete-65979\";i:65218;s:12:\"delete-65976\";i:65219;s:12:\"delete-65977\";i:65220;s:12:\"delete-65980\";i:65221;s:12:\"delete-65981\";i:65222;s:12:\"delete-65982\";i:65223;s:12:\"delete-65983\";i:65224;s:12:\"delete-65984\";i:65225;s:12:\"delete-65985\";i:65226;s:12:\"delete-65988\";i:65227;s:12:\"delete-65989\";i:65228;s:12:\"delete-65986\";i:65229;s:12:\"delete-65987\";i:65230;s:12:\"delete-65990\";i:65231;s:12:\"delete-65993\";i:65232;s:12:\"delete-65994\";i:65233;s:12:\"delete-65991\";i:65234;s:12:\"delete-65992\";i:65235;s:12:\"delete-65995\";i:65236;s:12:\"delete-65998\";i:65237;s:12:\"delete-65999\";i:65238;s:12:\"delete-65996\";i:65239;s:12:\"delete-65997\";i:65240;s:12:\"delete-66000\";i:65241;s:12:\"delete-66003\";i:65242;s:12:\"delete-66004\";i:65243;s:12:\"delete-66001\";i:65244;s:12:\"delete-66002\";i:65245;s:12:\"delete-66005\";i:65246;s:12:\"delete-66008\";i:65247;s:12:\"delete-66006\";i:65248;s:12:\"delete-66007\";i:65249;s:12:\"delete-66009\";i:65250;s:12:\"delete-66010\";i:65251;s:12:\"delete-66013\";i:65252;s:12:\"delete-66014\";i:65253;s:12:\"delete-66011\";i:65254;s:12:\"delete-66012\";i:65255;s:12:\"delete-66015\";i:65256;s:12:\"delete-66018\";i:65257;s:12:\"delete-66019\";i:65258;s:12:\"delete-66016\";i:65259;s:12:\"delete-66017\";i:65260;s:12:\"delete-66020\";i:65261;s:12:\"delete-66023\";i:65262;s:12:\"delete-66024\";i:65263;s:12:\"delete-66021\";i:65264;s:12:\"delete-66022\";i:65265;s:12:\"delete-66025\";i:65266;s:12:\"delete-66028\";i:65267;s:12:\"delete-66029\";i:65268;s:12:\"delete-66026\";i:65269;s:12:\"delete-66027\";i:65270;s:12:\"delete-66030\";i:65271;s:12:\"delete-66033\";i:65272;s:12:\"delete-66034\";i:65273;s:12:\"delete-66031\";i:65274;s:12:\"delete-66032\";i:65275;s:12:\"delete-66035\";i:65276;s:12:\"delete-66038\";i:65277;s:12:\"delete-66039\";i:65278;s:12:\"delete-66036\";i:65279;s:12:\"delete-66037\";i:65280;s:12:\"delete-66040\";i:65281;s:12:\"delete-66043\";i:65282;s:12:\"delete-66044\";i:65283;s:12:\"delete-66041\";i:65284;s:12:\"delete-66042\";i:65285;s:12:\"delete-66045\";i:65286;s:12:\"delete-66048\";i:65287;s:12:\"delete-66049\";i:65288;s:12:\"delete-66046\";i:65289;s:12:\"delete-66047\";i:65290;s:12:\"delete-66050\";i:65291;s:12:\"delete-66053\";i:65292;s:12:\"delete-66054\";i:65293;s:12:\"delete-66051\";i:65294;s:12:\"delete-66052\";i:65295;s:12:\"delete-66055\";i:65296;s:12:\"delete-66058\";i:65297;s:12:\"delete-66059\";i:65298;s:12:\"delete-66056\";i:65299;s:12:\"delete-66057\";i:65300;s:12:\"delete-66060\";i:65301;s:12:\"delete-66063\";i:65302;s:12:\"delete-66064\";i:65303;s:12:\"delete-66061\";i:65304;s:12:\"delete-66062\";i:65305;s:12:\"delete-66065\";i:65306;s:12:\"delete-66068\";i:65307;s:12:\"delete-66069\";i:65308;s:12:\"delete-66066\";i:65309;s:12:\"delete-66067\";i:65310;s:12:\"delete-66070\";i:65311;s:12:\"delete-66073\";i:65312;s:12:\"delete-66074\";i:65313;s:12:\"delete-66071\";i:65314;s:12:\"delete-66072\";i:65315;s:12:\"delete-66075\";i:65316;s:12:\"delete-66078\";i:65317;s:12:\"delete-66079\";i:65318;s:12:\"delete-66076\";i:65319;s:12:\"delete-66077\";i:65320;s:12:\"delete-66080\";i:65321;s:12:\"delete-66083\";i:65322;s:12:\"delete-66081\";i:65323;s:12:\"delete-66082\";i:65324;s:12:\"delete-66084\";i:65325;s:12:\"delete-66085\";i:65326;s:12:\"delete-66088\";i:65327;s:12:\"delete-66089\";i:65328;s:12:\"delete-66086\";i:65329;s:12:\"delete-66087\";i:65330;s:12:\"delete-66090\";i:65331;s:12:\"delete-66093\";i:65332;s:12:\"delete-66094\";i:65333;s:12:\"delete-66091\";i:65334;s:12:\"delete-66092\";i:65335;s:12:\"delete-66095\";i:65336;s:12:\"delete-66098\";i:65337;s:12:\"delete-66099\";i:65338;s:12:\"delete-66096\";i:65339;s:12:\"delete-66097\";i:65340;s:12:\"delete-66100\";i:65341;s:12:\"delete-66103\";i:65342;s:12:\"delete-66101\";i:65343;s:12:\"delete-66102\";i:65344;s:12:\"delete-66104\";i:65345;s:12:\"delete-66105\";i:65346;s:12:\"delete-66108\";i:65347;s:12:\"delete-66109\";i:65348;s:12:\"delete-66106\";i:65349;s:12:\"delete-66107\";i:65350;s:12:\"delete-66110\";i:65351;s:12:\"delete-66113\";i:65352;s:12:\"delete-66111\";i:65353;s:12:\"delete-66112\";i:65354;s:12:\"delete-66114\";i:65355;s:12:\"delete-66115\";i:65356;s:12:\"delete-66118\";i:65357;s:12:\"delete-66119\";i:65358;s:12:\"delete-66116\";i:65359;s:12:\"delete-66117\";i:65360;s:12:\"delete-66120\";i:65361;s:12:\"delete-66123\";i:65362;s:12:\"delete-66124\";i:65363;s:12:\"delete-66121\";i:65364;s:12:\"delete-66122\";i:65365;s:12:\"delete-66125\";i:65366;s:12:\"delete-66126\";i:65367;s:12:\"delete-66127\";i:65368;s:12:\"delete-66128\";i:65369;s:12:\"delete-66129\";i:65370;s:12:\"delete-66130\";i:65371;s:12:\"delete-66133\";i:65372;s:12:\"delete-66134\";i:65373;s:12:\"delete-66131\";i:65374;s:12:\"delete-66132\";i:65375;s:12:\"delete-66135\";i:65376;s:12:\"delete-66138\";i:65377;s:12:\"delete-66136\";i:65378;s:12:\"delete-66137\";i:65379;s:12:\"delete-66139\";i:65380;s:12:\"delete-66140\";i:65381;s:12:\"delete-66143\";i:65382;s:12:\"delete-66144\";i:65383;s:12:\"delete-66141\";i:65384;s:12:\"delete-66142\";i:65385;s:12:\"delete-66145\";i:65386;s:12:\"delete-66148\";i:65387;s:12:\"delete-66149\";i:65388;s:12:\"delete-66146\";i:65389;s:12:\"delete-66147\";i:65390;s:12:\"delete-66150\";i:65391;s:12:\"delete-66153\";i:65392;s:12:\"delete-66154\";i:65393;s:12:\"delete-66151\";i:65394;s:12:\"delete-66152\";i:65395;s:12:\"delete-66155\";i:65396;s:12:\"delete-66158\";i:65397;s:12:\"delete-66159\";i:65398;s:12:\"delete-66156\";i:65399;s:12:\"delete-66157\";i:65400;s:12:\"delete-66160\";i:65401;s:12:\"delete-66163\";i:65402;s:12:\"delete-66161\";i:65403;s:12:\"delete-66162\";i:65404;s:12:\"delete-66164\";i:65405;s:12:\"delete-66165\";i:65406;s:12:\"delete-66168\";i:65407;s:12:\"delete-66169\";i:65408;s:12:\"delete-66166\";i:65409;s:12:\"delete-66167\";i:65410;s:12:\"delete-66170\";i:65411;s:12:\"delete-66173\";i:65412;s:12:\"delete-66174\";i:65413;s:12:\"delete-66171\";i:65414;s:12:\"delete-66172\";i:65415;s:12:\"delete-66175\";i:65416;s:12:\"delete-66178\";i:65417;s:12:\"delete-66179\";i:65418;s:12:\"delete-66176\";i:65419;s:12:\"delete-66177\";i:65420;s:12:\"delete-66180\";i:65421;s:12:\"delete-66183\";i:65422;s:12:\"delete-66184\";i:65423;s:12:\"delete-66181\";i:65424;s:12:\"delete-66182\";i:65425;s:12:\"delete-66185\";i:65426;s:12:\"delete-66188\";i:65427;s:12:\"delete-66189\";i:65428;s:12:\"delete-66186\";i:65429;s:12:\"delete-66187\";i:65430;s:12:\"delete-66190\";i:65431;s:12:\"delete-66193\";i:65432;s:12:\"delete-66191\";i:65433;s:12:\"delete-66192\";i:65434;s:12:\"delete-66194\";i:65435;s:12:\"delete-66195\";i:65436;s:12:\"delete-66198\";i:65437;s:12:\"delete-66199\";i:65438;s:12:\"delete-66196\";i:65439;s:12:\"delete-66197\";i:65440;s:12:\"delete-66200\";i:65441;s:12:\"delete-66203\";i:65442;s:12:\"delete-66204\";i:65443;s:12:\"delete-66201\";i:65444;s:12:\"delete-66202\";i:65445;s:12:\"delete-66205\";i:65446;s:12:\"delete-66208\";i:65447;s:12:\"delete-66209\";i:65448;s:12:\"delete-66206\";i:65449;s:12:\"delete-66207\";i:65450;s:12:\"delete-66210\";i:65451;s:12:\"delete-66213\";i:65452;s:12:\"delete-66214\";i:65453;s:12:\"delete-66211\";i:65454;s:12:\"delete-66212\";i:65455;s:12:\"delete-66215\";i:65456;s:12:\"delete-66218\";i:65457;s:12:\"delete-66216\";i:65458;s:12:\"delete-66217\";i:65459;s:12:\"delete-66219\";i:65460;s:12:\"delete-66220\";i:65461;s:12:\"delete-66223\";i:65462;s:12:\"delete-66224\";i:65463;s:12:\"delete-66221\";i:65464;s:12:\"delete-66222\";i:65465;s:12:\"delete-66225\";i:65466;s:12:\"delete-66228\";i:65467;s:12:\"delete-66229\";i:65468;s:12:\"delete-66226\";i:65469;s:12:\"delete-66227\";i:65470;s:12:\"delete-66230\";i:65471;s:12:\"delete-66233\";i:65472;s:12:\"delete-66234\";i:65473;s:12:\"delete-66231\";i:65474;s:12:\"delete-66232\";i:65475;s:12:\"delete-66235\";i:65476;s:12:\"delete-66238\";i:65477;s:12:\"delete-66239\";i:65478;s:12:\"delete-66236\";i:65479;s:12:\"delete-66237\";i:65480;s:12:\"delete-66240\";i:65481;s:12:\"delete-66243\";i:65482;s:12:\"delete-66244\";i:65483;s:12:\"delete-66241\";i:65484;s:12:\"delete-66242\";i:65485;s:12:\"delete-66245\";i:65486;s:12:\"delete-66248\";i:65487;s:12:\"delete-66249\";i:65488;s:12:\"delete-66246\";i:65489;s:12:\"delete-66247\";i:65490;s:12:\"delete-66250\";i:65491;s:12:\"delete-66253\";i:65492;s:12:\"delete-66254\";i:65493;s:12:\"delete-66251\";i:65494;s:12:\"delete-66252\";i:65495;s:12:\"delete-66255\";i:65496;s:12:\"delete-66258\";i:65497;s:12:\"delete-66259\";i:65498;s:12:\"delete-66256\";i:65499;s:12:\"delete-66257\";i:65500;s:12:\"delete-66260\";i:65501;s:12:\"delete-66263\";i:65502;s:12:\"delete-66264\";i:65503;s:12:\"delete-66261\";i:65504;s:12:\"delete-66262\";i:65505;s:12:\"delete-66265\";i:65506;s:12:\"delete-66268\";i:65507;s:12:\"delete-66269\";i:65508;s:12:\"delete-66266\";i:65509;s:12:\"delete-66267\";i:65510;s:12:\"delete-66270\";i:65511;s:12:\"delete-66273\";i:65512;s:12:\"delete-66274\";i:65513;s:12:\"delete-66271\";i:65514;s:12:\"delete-66272\";i:65515;s:12:\"delete-66275\";i:65516;s:12:\"delete-66278\";i:65517;s:12:\"delete-66279\";i:65518;s:12:\"delete-66276\";i:65519;s:12:\"delete-66277\";i:65520;s:12:\"delete-66280\";i:65521;s:12:\"delete-66283\";i:65522;s:12:\"delete-66281\";i:65523;s:12:\"delete-66282\";i:65524;s:12:\"delete-66284\";i:65525;s:12:\"delete-66287\";i:65526;s:12:\"delete-66288\";i:65527;s:12:\"delete-66285\";i:65528;s:12:\"delete-66286\";i:65529;s:12:\"delete-66289\";i:65530;s:12:\"delete-66292\";i:65531;s:12:\"delete-66293\";i:65532;s:12:\"delete-66290\";i:65533;s:12:\"delete-66291\";i:65534;s:12:\"delete-66294\";i:65535;s:12:\"delete-66297\";i:65536;s:12:\"delete-66298\";i:65537;s:12:\"delete-66295\";i:65538;s:12:\"delete-66296\";i:65539;s:12:\"delete-66299\";i:65540;s:12:\"delete-66302\";i:65541;s:12:\"delete-66300\";i:65542;s:12:\"delete-66301\";i:65543;s:12:\"delete-66303\";i:65544;s:12:\"delete-66304\";i:65545;s:12:\"delete-66307\";i:65546;s:12:\"delete-66308\";i:65547;s:12:\"delete-66305\";i:65548;s:12:\"delete-66306\";i:65549;s:12:\"delete-66309\";i:65550;s:12:\"delete-66312\";i:65551;s:12:\"delete-66313\";i:65552;s:12:\"delete-66310\";i:65553;s:12:\"delete-66311\";i:65554;s:12:\"delete-66314\";i:65555;s:12:\"delete-66317\";i:65556;s:12:\"delete-66318\";i:65557;s:12:\"delete-66315\";i:65558;s:12:\"delete-66316\";i:65559;s:12:\"delete-66319\";i:65560;s:12:\"delete-66322\";i:65561;s:12:\"delete-66323\";i:65562;s:12:\"delete-66320\";i:65563;s:12:\"delete-66321\";i:65564;s:12:\"delete-66324\";i:65565;s:12:\"delete-66327\";i:65566;s:12:\"delete-66328\";i:65567;s:12:\"delete-66325\";i:65568;s:12:\"delete-66326\";i:65569;s:12:\"delete-66329\";i:65570;s:12:\"delete-66332\";i:65571;s:12:\"delete-66333\";i:65572;s:12:\"delete-66330\";i:65573;s:12:\"delete-66331\";i:65574;s:12:\"delete-66334\";i:65575;s:12:\"delete-66337\";i:65576;s:12:\"delete-66338\";i:65577;s:12:\"delete-66335\";i:65578;s:12:\"delete-66336\";i:65579;s:12:\"delete-66339\";i:65580;s:12:\"delete-66342\";i:65581;s:12:\"delete-66343\";i:65582;s:12:\"delete-66340\";i:65583;s:12:\"delete-66341\";i:65584;s:12:\"delete-66344\";i:65585;s:12:\"delete-66347\";i:65586;s:12:\"delete-66348\";i:65587;s:12:\"delete-66345\";i:65588;s:12:\"delete-66346\";i:65589;s:12:\"delete-66349\";i:65590;s:12:\"delete-66352\";i:65591;s:12:\"delete-66353\";i:65592;s:12:\"delete-66350\";i:65593;s:12:\"delete-66351\";i:65594;s:12:\"delete-66354\";i:65595;s:12:\"delete-66357\";i:65596;s:12:\"delete-66358\";i:65597;s:12:\"delete-66355\";i:65598;s:12:\"delete-66356\";i:65599;s:12:\"delete-66359\";i:65600;s:12:\"delete-66362\";i:65601;s:12:\"delete-66360\";i:65602;s:12:\"delete-66361\";i:65603;s:12:\"delete-66363\";i:65604;s:12:\"delete-66364\";i:65605;s:12:\"delete-66367\";i:65606;s:12:\"delete-66368\";i:65607;s:12:\"delete-66365\";i:65608;s:12:\"delete-66366\";i:65609;s:12:\"delete-66369\";i:65610;s:12:\"delete-66372\";i:65611;s:12:\"delete-66373\";i:65612;s:12:\"delete-66370\";i:65613;s:12:\"delete-66371\";i:65614;s:12:\"delete-66374\";i:65615;s:12:\"delete-66377\";i:65616;s:12:\"delete-66378\";i:65617;s:12:\"delete-66375\";i:65618;s:12:\"delete-66376\";i:65619;s:12:\"delete-66379\";i:65620;s:12:\"delete-66382\";i:65621;s:12:\"delete-66383\";i:65622;s:12:\"delete-66380\";i:65623;s:12:\"delete-66381\";i:65624;s:12:\"delete-66384\";i:65625;s:12:\"delete-66387\";i:65626;s:12:\"delete-66388\";i:65627;s:12:\"delete-66385\";i:65628;s:12:\"delete-66386\";i:65629;s:12:\"delete-66389\";i:65630;s:12:\"delete-66392\";i:65631;s:12:\"delete-66393\";i:65632;s:12:\"delete-66390\";i:65633;s:12:\"delete-66391\";i:65634;s:12:\"delete-66394\";i:65635;s:12:\"delete-66397\";i:65636;s:12:\"delete-66398\";i:65637;s:12:\"delete-66395\";i:65638;s:12:\"delete-66396\";i:65639;s:12:\"delete-66399\";i:65640;s:12:\"delete-66402\";i:65641;s:12:\"delete-66403\";i:65642;s:12:\"delete-66400\";i:65643;s:12:\"delete-66401\";i:65644;s:12:\"delete-66404\";i:65645;s:12:\"delete-66407\";i:65646;s:12:\"delete-66408\";i:65647;s:12:\"delete-66405\";i:65648;s:12:\"delete-66406\";i:65649;s:12:\"delete-66409\";i:65650;s:12:\"delete-66412\";i:65651;s:12:\"delete-66413\";i:65652;s:12:\"delete-66410\";i:65653;s:12:\"delete-66411\";i:65654;s:12:\"delete-66414\";i:65655;s:12:\"delete-66417\";i:65656;s:12:\"delete-66418\";i:65657;s:12:\"delete-66415\";i:65658;s:12:\"delete-66416\";i:65659;s:12:\"delete-66419\";i:65660;s:12:\"delete-66422\";i:65661;s:12:\"delete-66423\";i:65662;s:12:\"delete-66420\";i:65663;s:12:\"delete-66421\";i:65664;s:12:\"delete-66424\";i:65665;s:12:\"delete-66427\";i:65666;s:12:\"delete-66425\";i:65667;s:12:\"delete-66426\";i:65668;s:12:\"delete-66428\";i:65669;s:12:\"delete-66429\";i:65670;s:12:\"delete-66432\";i:65671;s:12:\"delete-66433\";i:65672;s:12:\"delete-66430\";i:65673;s:12:\"delete-66431\";i:65674;s:12:\"delete-66434\";i:65675;s:12:\"delete-66437\";i:65676;s:12:\"delete-66438\";i:65677;s:12:\"delete-66435\";i:65678;s:12:\"delete-66436\";i:65679;s:12:\"delete-66439\";i:65680;s:12:\"delete-66442\";i:65681;s:12:\"delete-66443\";i:65682;s:12:\"delete-66440\";i:65683;s:12:\"delete-66441\";i:65684;s:12:\"delete-66444\";i:65685;s:12:\"delete-66447\";i:65686;s:12:\"delete-66448\";i:65687;s:12:\"delete-66445\";i:65688;s:12:\"delete-66446\";i:65689;s:12:\"delete-66449\";i:65690;s:12:\"delete-66452\";i:65691;s:12:\"delete-66453\";i:65692;s:12:\"delete-66450\";i:65693;s:12:\"delete-66451\";i:65694;s:12:\"delete-66454\";i:65695;s:12:\"delete-66457\";i:65696;s:12:\"delete-66455\";i:65697;s:12:\"delete-66456\";i:65698;s:12:\"delete-66458\";i:65699;s:12:\"delete-66459\";i:65700;s:12:\"delete-66462\";i:65701;s:12:\"delete-66463\";i:65702;s:12:\"delete-66460\";i:65703;s:12:\"delete-66461\";i:65704;s:12:\"delete-66464\";i:65705;s:12:\"delete-66467\";i:65706;s:12:\"delete-66468\";i:65707;s:12:\"delete-66465\";i:65708;s:12:\"delete-66466\";i:65709;s:12:\"delete-66469\";i:65710;s:12:\"delete-66472\";i:65711;s:12:\"delete-66473\";i:65712;s:12:\"delete-66470\";i:65713;s:12:\"delete-66471\";i:65714;s:12:\"delete-66474\";i:65715;s:12:\"delete-66477\";i:65716;s:12:\"delete-66478\";i:65717;s:12:\"delete-66475\";i:65718;s:12:\"delete-66476\";i:65719;s:12:\"delete-66479\";i:65720;s:12:\"delete-66482\";i:65721;s:12:\"delete-66480\";i:65722;s:12:\"delete-66481\";i:65723;s:12:\"delete-66483\";i:65724;s:12:\"delete-66484\";i:65725;s:12:\"delete-66487\";i:65726;s:12:\"delete-66488\";i:65727;s:12:\"delete-66485\";i:65728;s:12:\"delete-66486\";i:65729;s:12:\"delete-66489\";i:65730;s:12:\"delete-66492\";i:65731;s:12:\"delete-66493\";i:65732;s:12:\"delete-66490\";i:65733;s:12:\"delete-66491\";i:65734;s:12:\"delete-66494\";i:65735;s:12:\"delete-66497\";i:65736;s:12:\"delete-66498\";i:65737;s:12:\"delete-66495\";i:65738;s:12:\"delete-66496\";i:65739;s:12:\"delete-66499\";i:65740;s:12:\"delete-66502\";i:65741;s:12:\"delete-66503\";i:65742;s:12:\"delete-66500\";i:65743;s:12:\"delete-66501\";i:65744;s:12:\"delete-66504\";i:65745;s:12:\"delete-66507\";i:65746;s:12:\"delete-66508\";i:65747;s:12:\"delete-66505\";i:65748;s:12:\"delete-66506\";i:65749;s:12:\"delete-66509\";i:65750;s:12:\"delete-66512\";i:65751;s:12:\"delete-66510\";i:65752;s:12:\"delete-66511\";i:65753;s:12:\"delete-66513\";i:65754;s:12:\"delete-66514\";i:65755;s:12:\"delete-66517\";i:65756;s:12:\"delete-66518\";i:65757;s:12:\"delete-66515\";i:65758;s:12:\"delete-66516\";i:65759;s:12:\"delete-66519\";i:65760;s:12:\"delete-66522\";i:65761;s:12:\"delete-66523\";i:65762;s:12:\"delete-66520\";i:65763;s:12:\"delete-66521\";i:65764;s:12:\"delete-66524\";i:65765;s:12:\"delete-66527\";i:65766;s:12:\"delete-66528\";i:65767;s:12:\"delete-66525\";i:65768;s:12:\"delete-66526\";i:65769;s:12:\"delete-66529\";i:65770;s:12:\"delete-66532\";i:65771;s:12:\"delete-66533\";i:65772;s:12:\"delete-66530\";i:65773;s:12:\"delete-66531\";i:65774;s:12:\"delete-66534\";i:65775;s:12:\"delete-66537\";i:65776;s:12:\"delete-66538\";i:65777;s:12:\"delete-66535\";i:65778;s:12:\"delete-66536\";i:65779;s:12:\"delete-66539\";i:65780;s:12:\"delete-66542\";i:65781;s:12:\"delete-66543\";i:65782;s:12:\"delete-66540\";i:65783;s:12:\"delete-66541\";i:65784;s:12:\"delete-66544\";i:65785;s:12:\"delete-66547\";i:65786;s:12:\"delete-66545\";i:65787;s:12:\"delete-66546\";i:65788;s:12:\"delete-66548\";i:65789;s:12:\"delete-66549\";i:65790;s:12:\"delete-66552\";i:65791;s:12:\"delete-66553\";i:65792;s:12:\"delete-66550\";i:65793;s:12:\"delete-66551\";i:65794;s:12:\"delete-66554\";i:65795;s:12:\"delete-66557\";i:65796;s:12:\"delete-66555\";i:65797;s:12:\"delete-66556\";i:65798;s:12:\"delete-66558\";i:65799;s:12:\"delete-66559\";i:65800;s:12:\"delete-66562\";i:65801;s:12:\"delete-66563\";i:65802;s:12:\"delete-66560\";i:65803;s:12:\"delete-66561\";i:65804;s:12:\"delete-66564\";i:65805;s:12:\"delete-66567\";i:65806;s:12:\"delete-66568\";i:65807;s:12:\"delete-66565\";i:65808;s:12:\"delete-66566\";i:65809;s:12:\"delete-66569\";i:65810;s:12:\"delete-66572\";i:65811;s:12:\"delete-66573\";i:65812;s:12:\"delete-66570\";i:65813;s:12:\"delete-66571\";i:65814;s:12:\"delete-66574\";i:65815;s:12:\"delete-66577\";i:65816;s:12:\"delete-66578\";i:65817;s:12:\"delete-66575\";i:65818;s:12:\"delete-66576\";i:65819;s:12:\"delete-66579\";i:65820;s:12:\"delete-66582\";i:65821;s:12:\"delete-66583\";i:65822;s:12:\"delete-66584\";i:65823;s:12:\"delete-66587\";i:65824;s:12:\"delete-66588\";i:65825;s:12:\"delete-66580\";i:65826;s:12:\"delete-66581\";i:65827;s:12:\"delete-66585\";i:65828;s:12:\"delete-66586\";i:65829;s:12:\"delete-66589\";i:65830;s:12:\"delete-66592\";i:65831;s:12:\"delete-66590\";i:65832;s:12:\"delete-66591\";i:65833;s:12:\"delete-66593\";i:65834;s:12:\"delete-66594\";i:65835;s:12:\"delete-66597\";i:65836;s:12:\"delete-66598\";i:65837;s:12:\"delete-66595\";i:65838;s:12:\"delete-66596\";i:65839;s:12:\"delete-66599\";i:65840;s:12:\"delete-66602\";i:65841;s:12:\"delete-66600\";i:65842;s:12:\"delete-66601\";i:65843;s:12:\"delete-66603\";i:65844;s:12:\"delete-66606\";i:65845;s:12:\"delete-66607\";i:65846;s:12:\"delete-66604\";i:65847;s:12:\"delete-66605\";i:65848;s:12:\"delete-66608\";i:65849;s:12:\"delete-66611\";i:65850;s:12:\"delete-66612\";i:65851;s:12:\"delete-66609\";i:65852;s:12:\"delete-66610\";i:65853;s:12:\"delete-66613\";i:65854;s:12:\"delete-66616\";i:65855;s:12:\"delete-66617\";i:65856;s:12:\"delete-66614\";i:65857;s:12:\"delete-66615\";i:65858;s:12:\"delete-66618\";i:65859;s:12:\"delete-66621\";i:65860;s:12:\"delete-66622\";i:65861;s:12:\"delete-66619\";i:65862;s:12:\"delete-66620\";i:65863;s:12:\"delete-66623\";i:65864;s:12:\"delete-66626\";i:65865;s:12:\"delete-66624\";i:65866;s:12:\"delete-66625\";i:65867;s:12:\"delete-66627\";i:65868;s:12:\"delete-66628\";i:65869;s:12:\"delete-66631\";i:65870;s:12:\"delete-66632\";i:65871;s:12:\"delete-66629\";i:65872;s:12:\"delete-66630\";i:65873;s:12:\"delete-66633\";i:65874;s:12:\"delete-66636\";i:65875;s:12:\"delete-66637\";i:65876;s:12:\"delete-66634\";i:65877;s:12:\"delete-66635\";i:65878;s:12:\"delete-66638\";i:65879;s:12:\"delete-66641\";i:65880;s:12:\"delete-66642\";i:65881;s:12:\"delete-66639\";i:65882;s:12:\"delete-66640\";i:65883;s:12:\"delete-66643\";i:65884;s:12:\"delete-66646\";i:65885;s:12:\"delete-66647\";i:65886;s:12:\"delete-66644\";i:65887;s:12:\"delete-66645\";i:65888;s:12:\"delete-66648\";i:65889;s:12:\"delete-66651\";i:65890;s:12:\"delete-66652\";i:65891;s:12:\"delete-66649\";i:65892;s:12:\"delete-66650\";i:65893;s:12:\"delete-66653\";i:65894;s:12:\"delete-66656\";i:65895;s:12:\"delete-66657\";i:65896;s:12:\"delete-66654\";i:65897;s:12:\"delete-66655\";i:65898;s:12:\"delete-66658\";i:65899;s:12:\"delete-66661\";i:65900;s:12:\"delete-66662\";i:65901;s:12:\"delete-66659\";i:65902;s:12:\"delete-66660\";i:65903;s:12:\"delete-66663\";i:65904;s:12:\"delete-66666\";i:65905;s:12:\"delete-66667\";i:65906;s:12:\"delete-66664\";i:65907;s:12:\"delete-66665\";i:65908;s:12:\"delete-66668\";i:65909;s:12:\"delete-66671\";i:65910;s:12:\"delete-66672\";i:65911;s:12:\"delete-66669\";i:65912;s:12:\"delete-66670\";i:65913;s:12:\"delete-66673\";i:65914;s:12:\"delete-66676\";i:65915;s:12:\"delete-66674\";i:65916;s:12:\"delete-66675\";i:65917;s:12:\"delete-66677\";i:65918;s:12:\"delete-66678\";i:65919;s:12:\"delete-66681\";i:65920;s:12:\"delete-66682\";i:65921;s:12:\"delete-66679\";i:65922;s:12:\"delete-66680\";i:65923;s:12:\"delete-66683\";i:65924;s:12:\"delete-66686\";i:65925;s:12:\"delete-66684\";i:65926;s:12:\"delete-66685\";i:65927;s:12:\"delete-66687\";i:65928;s:12:\"delete-66688\";i:65929;s:12:\"delete-66691\";i:65930;s:12:\"delete-66692\";i:65931;s:12:\"delete-66689\";i:65932;s:12:\"delete-66690\";i:65933;s:12:\"delete-66693\";i:65934;s:12:\"delete-66696\";i:65935;s:12:\"delete-66697\";i:65936;s:12:\"delete-66694\";i:65937;s:12:\"delete-66695\";i:65938;s:12:\"delete-66698\";i:65939;s:12:\"delete-66701\";i:65940;s:12:\"delete-66702\";i:65941;s:12:\"delete-66699\";i:65942;s:12:\"delete-66700\";i:65943;s:12:\"delete-66703\";i:65944;s:12:\"delete-66706\";i:65945;s:12:\"delete-66704\";i:65946;s:12:\"delete-66705\";i:65947;s:12:\"delete-66707\";i:65948;s:12:\"delete-66708\";i:65949;s:12:\"delete-66711\";i:65950;s:12:\"delete-66712\";i:65951;s:12:\"delete-66709\";i:65952;s:12:\"delete-66710\";i:65953;s:12:\"delete-66713\";i:65954;s:12:\"delete-66716\";i:65955;s:12:\"delete-66717\";i:65956;s:12:\"delete-66714\";i:65957;s:12:\"delete-66715\";i:65958;s:12:\"delete-66718\";i:65959;s:12:\"delete-66721\";i:65960;s:12:\"delete-66722\";i:65961;s:12:\"delete-66719\";i:65962;s:12:\"delete-66720\";i:65963;s:12:\"delete-66723\";i:65964;s:12:\"delete-66724\";i:65965;s:12:\"delete-66725\";i:65966;s:12:\"delete-66726\";i:65967;s:12:\"delete-66727\";i:65968;s:12:\"delete-66728\";i:65969;s:12:\"delete-66731\";i:65970;s:12:\"delete-66732\";i:65971;s:12:\"delete-66729\";i:65972;s:12:\"delete-66730\";i:65973;s:12:\"delete-66733\";i:65974;s:12:\"delete-66736\";i:65975;s:12:\"delete-66734\";i:65976;s:12:\"delete-66735\";i:65977;s:12:\"delete-66737\";i:65978;s:12:\"delete-66738\";i:65979;s:12:\"delete-66741\";i:65980;s:12:\"delete-66739\";i:65981;s:12:\"delete-66740\";i:65982;s:12:\"delete-66742\";i:65983;s:12:\"delete-66743\";i:65984;s:12:\"delete-66746\";i:65985;s:12:\"delete-66747\";i:65986;s:12:\"delete-66744\";i:65987;s:12:\"delete-66745\";i:65988;s:12:\"delete-66748\";i:65989;s:12:\"delete-66751\";i:65990;s:12:\"delete-66752\";i:65991;s:12:\"delete-66749\";i:65992;s:12:\"delete-66750\";i:65993;s:12:\"delete-66753\";i:65994;s:12:\"delete-66756\";i:65995;s:12:\"delete-66754\";i:65996;s:12:\"delete-66755\";i:65997;s:12:\"delete-66757\";i:65998;s:12:\"delete-66758\";i:65999;s:12:\"delete-66761\";i:66000;s:12:\"delete-66762\";i:66001;s:12:\"delete-66759\";i:66002;s:12:\"delete-66760\";i:66003;s:12:\"delete-66763\";i:66004;s:12:\"delete-66766\";i:66005;s:12:\"delete-66767\";i:66006;s:12:\"delete-66764\";i:66007;s:12:\"delete-66765\";i:66008;s:12:\"delete-66768\";i:66009;s:12:\"delete-66771\";i:66010;s:12:\"delete-66772\";i:66011;s:12:\"delete-66773\";i:66012;s:12:\"delete-66776\";i:66013;s:12:\"delete-66769\";i:66014;s:12:\"delete-66770\";i:66015;s:12:\"delete-66774\";i:66016;s:12:\"delete-66775\";i:66017;s:12:\"delete-66777\";i:66018;s:12:\"delete-66778\";i:66019;s:12:\"delete-66781\";i:66020;s:12:\"delete-66782\";i:66021;s:12:\"delete-66779\";i:66022;s:12:\"delete-66780\";i:66023;s:12:\"delete-66783\";i:66024;s:12:\"delete-66786\";i:66025;s:12:\"delete-66787\";i:66026;s:12:\"delete-66784\";i:66027;s:12:\"delete-66785\";i:66028;s:12:\"delete-66788\";i:66029;s:12:\"delete-66791\";i:66030;s:12:\"delete-66792\";i:66031;s:12:\"delete-66789\";i:66032;s:12:\"delete-66790\";i:66033;s:12:\"delete-66793\";i:66034;s:12:\"delete-66796\";i:66035;s:12:\"delete-66797\";i:66036;s:12:\"delete-66794\";i:66037;s:12:\"delete-66795\";i:66038;s:12:\"delete-66798\";i:66039;s:12:\"delete-66801\";i:66040;s:12:\"delete-66802\";i:66041;s:12:\"delete-66799\";i:66042;s:12:\"delete-66800\";i:66043;s:12:\"delete-66803\";i:66044;s:12:\"delete-66806\";i:66045;s:12:\"delete-66807\";i:66046;s:12:\"delete-66804\";i:66047;s:12:\"delete-66805\";i:66048;s:12:\"delete-66808\";i:66049;s:12:\"delete-66811\";i:66050;s:12:\"delete-66812\";i:66051;s:12:\"delete-66809\";i:66052;s:12:\"delete-66810\";i:66053;s:12:\"delete-66813\";i:66054;s:12:\"delete-66816\";i:66055;s:12:\"delete-66817\";i:66056;s:12:\"delete-66814\";i:66057;s:12:\"delete-66815\";i:66058;s:12:\"delete-66818\";i:66059;s:12:\"delete-66821\";i:66060;s:12:\"delete-66822\";i:66061;s:12:\"delete-66819\";i:66062;s:12:\"delete-66820\";i:66063;s:12:\"delete-66823\";i:66064;s:12:\"delete-66826\";i:66065;s:12:\"delete-66827\";i:66066;s:12:\"delete-66824\";i:66067;s:12:\"delete-66825\";i:66068;s:12:\"delete-66828\";i:66069;s:12:\"delete-66831\";i:66070;s:12:\"delete-66832\";i:66071;s:12:\"delete-66829\";i:66072;s:12:\"delete-66830\";i:66073;s:12:\"delete-66833\";i:66074;s:12:\"delete-66836\";i:66075;s:12:\"delete-66837\";i:66076;s:12:\"delete-66834\";i:66077;s:12:\"delete-66835\";i:66078;s:12:\"delete-66838\";i:66079;s:12:\"delete-66841\";i:66080;s:12:\"delete-66842\";i:66081;s:12:\"delete-66839\";i:66082;s:12:\"delete-66840\";i:66083;s:12:\"delete-66843\";i:66084;s:12:\"delete-66846\";i:66085;s:12:\"delete-66847\";i:66086;s:12:\"delete-66844\";i:66087;s:12:\"delete-66845\";i:66088;s:12:\"delete-66848\";i:66089;s:12:\"delete-66851\";i:66090;s:12:\"delete-66852\";i:66091;s:12:\"delete-66849\";i:66092;s:12:\"delete-66850\";i:66093;s:12:\"delete-66853\";i:66094;s:12:\"delete-66856\";i:66095;s:12:\"delete-66857\";i:66096;s:12:\"delete-66854\";i:66097;s:12:\"delete-66855\";i:66098;s:12:\"delete-66858\";i:66099;s:12:\"delete-66861\";i:66100;s:12:\"delete-66862\";i:66101;s:12:\"delete-66859\";i:66102;s:12:\"delete-66860\";i:66103;s:12:\"delete-66863\";i:66104;s:12:\"delete-66866\";i:66105;s:12:\"delete-66867\";i:66106;s:12:\"delete-66864\";i:66107;s:12:\"delete-66865\";i:66108;s:12:\"delete-66868\";i:66109;s:12:\"delete-66871\";i:66110;s:12:\"delete-66869\";i:66111;s:12:\"delete-66870\";i:66112;s:12:\"delete-66872\";i:66113;s:12:\"delete-66873\";i:66114;s:12:\"delete-66876\";i:66115;s:12:\"delete-66877\";i:66116;s:12:\"delete-66874\";i:66117;s:12:\"delete-66875\";i:66118;s:12:\"delete-66878\";i:66119;s:12:\"delete-66881\";i:66120;s:12:\"delete-66882\";i:66121;s:12:\"delete-66879\";i:66122;s:12:\"delete-66880\";i:66123;s:12:\"delete-66883\";i:66124;s:12:\"delete-66886\";i:66125;s:12:\"delete-66887\";i:66126;s:12:\"delete-66884\";i:66127;s:12:\"delete-66885\";i:66128;s:12:\"delete-66888\";i:66129;s:12:\"delete-66891\";i:66130;s:12:\"delete-66892\";i:66131;s:12:\"delete-66889\";i:66132;s:12:\"delete-66890\";i:66133;s:12:\"delete-66893\";i:66134;s:12:\"delete-66896\";i:66135;s:12:\"delete-66897\";i:66136;s:12:\"delete-66898\";i:66137;s:12:\"delete-66901\";i:66138;s:12:\"delete-66902\";i:66139;s:12:\"delete-66894\";i:66140;s:12:\"delete-66895\";i:66141;s:12:\"delete-66899\";i:66142;s:12:\"delete-66900\";i:66143;s:12:\"delete-66903\";i:66144;s:12:\"delete-66906\";i:66145;s:12:\"delete-66904\";i:66146;s:12:\"delete-66905\";i:66147;s:12:\"delete-66907\";i:66148;s:12:\"delete-66908\";i:66149;s:12:\"delete-66911\";i:66150;s:12:\"delete-66912\";i:66151;s:12:\"delete-66909\";i:66152;s:12:\"delete-66910\";i:66153;s:12:\"delete-66913\";i:66154;s:12:\"delete-66916\";i:66155;s:12:\"delete-66917\";i:66156;s:12:\"delete-66914\";i:66157;s:12:\"delete-66915\";i:66158;s:12:\"delete-66918\";i:66159;s:12:\"delete-66921\";i:66160;s:12:\"delete-66922\";i:66161;s:12:\"delete-66919\";i:66162;s:12:\"delete-66920\";i:66163;s:12:\"delete-66923\";i:66164;s:12:\"delete-66926\";i:66165;s:12:\"delete-66927\";i:66166;s:12:\"delete-66924\";i:66167;s:12:\"delete-66925\";i:66168;s:12:\"delete-66928\";i:66169;s:12:\"delete-66931\";i:66170;s:12:\"delete-66932\";i:66171;s:12:\"delete-66929\";i:66172;s:12:\"delete-66930\";i:66173;s:12:\"delete-66933\";i:66174;s:12:\"delete-66936\";i:66175;s:12:\"delete-66934\";i:66176;s:12:\"delete-66935\";i:66177;s:12:\"delete-66937\";i:66178;s:12:\"delete-66938\";i:66179;s:12:\"delete-66941\";i:66180;s:12:\"delete-66942\";i:66181;s:12:\"delete-66939\";i:66182;s:12:\"delete-66940\";i:66183;s:12:\"delete-66943\";i:66184;s:12:\"delete-66946\";i:66185;s:12:\"delete-66947\";i:66186;s:12:\"delete-66944\";i:66187;s:12:\"delete-66945\";i:66188;s:12:\"delete-66948\";i:66189;s:12:\"delete-66951\";i:66190;s:12:\"delete-66952\";i:66191;s:12:\"delete-66949\";i:66192;s:12:\"delete-66950\";i:66193;s:12:\"delete-66953\";i:66194;s:12:\"delete-66956\";i:66195;s:12:\"delete-66957\";i:66196;s:12:\"delete-66954\";i:66197;s:12:\"delete-66955\";i:66198;s:12:\"delete-66958\";i:66199;s:12:\"delete-66961\";i:66200;s:12:\"delete-66962\";i:66201;s:12:\"delete-66959\";i:66202;s:12:\"delete-66960\";i:66203;s:12:\"delete-66963\";i:66204;s:12:\"delete-66966\";i:66205;s:12:\"delete-66967\";i:66206;s:12:\"delete-66964\";i:66207;s:12:\"delete-66965\";i:66208;s:12:\"delete-66968\";i:66209;s:12:\"delete-66971\";i:66210;s:12:\"delete-66972\";i:66211;s:12:\"delete-66969\";i:66212;s:12:\"delete-66970\";i:66213;s:12:\"delete-66973\";i:66214;s:12:\"delete-66976\";i:66215;s:12:\"delete-66977\";i:66216;s:12:\"delete-66974\";i:66217;s:12:\"delete-66975\";i:66218;s:12:\"delete-66978\";i:66219;s:12:\"delete-66981\";i:66220;s:12:\"delete-66982\";i:66221;s:12:\"delete-66979\";i:66222;s:12:\"delete-66980\";i:66223;s:12:\"delete-66983\";i:66224;s:12:\"delete-66986\";i:66225;s:12:\"delete-66987\";i:66226;s:12:\"delete-66984\";i:66227;s:12:\"delete-66985\";i:66228;s:12:\"delete-66988\";i:66229;s:12:\"delete-66991\";i:66230;s:12:\"delete-66992\";i:66231;s:12:\"delete-66989\";i:66232;s:12:\"delete-66990\";i:66233;s:12:\"delete-66993\";i:66234;s:12:\"delete-66996\";i:66235;s:12:\"delete-66997\";i:66236;s:12:\"delete-66994\";i:66237;s:12:\"delete-66995\";i:66238;s:12:\"delete-66998\";i:66239;s:12:\"delete-67001\";i:66240;s:12:\"delete-66999\";i:66241;s:12:\"delete-67000\";i:66242;s:12:\"delete-67002\";i:66243;s:12:\"delete-67003\";i:66244;s:12:\"delete-67006\";i:66245;s:12:\"delete-67007\";i:66246;s:12:\"delete-67004\";i:66247;s:12:\"delete-67005\";i:66248;s:12:\"delete-67008\";i:66249;s:12:\"delete-67011\";i:66250;s:12:\"delete-67012\";i:66251;s:12:\"delete-67009\";i:66252;s:12:\"delete-67010\";i:66253;s:12:\"delete-67013\";i:66254;s:12:\"delete-67016\";i:66255;s:12:\"delete-67017\";i:66256;s:12:\"delete-67014\";i:66257;s:12:\"delete-67015\";i:66258;s:12:\"delete-67018\";i:66259;s:12:\"delete-67021\";i:66260;s:12:\"delete-67019\";i:66261;s:12:\"delete-67020\";i:66262;s:12:\"delete-67022\";i:66263;s:12:\"delete-67023\";i:66264;s:12:\"delete-67026\";i:66265;s:12:\"delete-67027\";i:66266;s:12:\"delete-67024\";i:66267;s:12:\"delete-67025\";i:66268;s:12:\"delete-67028\";i:66269;s:12:\"delete-67031\";i:66270;s:12:\"delete-67032\";i:66271;s:12:\"delete-67029\";i:66272;s:12:\"delete-67030\";i:66273;s:12:\"delete-67033\";i:66274;s:12:\"delete-67036\";i:66275;s:12:\"delete-67037\";i:66276;s:12:\"delete-67034\";i:66277;s:12:\"delete-67035\";i:66278;s:12:\"delete-67038\";i:66279;s:12:\"delete-67041\";i:66280;s:12:\"delete-67042\";i:66281;s:12:\"delete-67039\";i:66282;s:12:\"delete-67040\";i:66283;s:12:\"delete-67043\";i:66284;s:12:\"delete-67046\";i:66285;s:12:\"delete-67047\";i:66286;s:12:\"delete-67044\";i:66287;s:12:\"delete-67045\";i:66288;s:12:\"delete-67048\";i:66289;s:12:\"delete-67051\";i:66290;s:12:\"delete-67049\";i:66291;s:12:\"delete-67050\";i:66292;s:12:\"delete-67052\";i:66293;s:12:\"delete-67053\";i:66294;s:12:\"delete-67056\";i:66295;s:12:\"delete-67057\";i:66296;s:12:\"delete-67054\";i:66297;s:12:\"delete-67055\";i:66298;s:12:\"delete-67058\";i:66299;s:12:\"delete-67061\";i:66300;s:12:\"delete-67062\";i:66301;s:12:\"delete-67059\";i:66302;s:12:\"delete-67060\";i:66303;s:12:\"delete-67063\";i:66304;s:12:\"delete-67066\";i:66305;s:12:\"delete-67067\";i:66306;s:12:\"delete-67064\";i:66307;s:12:\"delete-67065\";i:66308;s:12:\"delete-67068\";i:66309;s:12:\"delete-67071\";i:66310;s:12:\"delete-67072\";i:66311;s:12:\"delete-67069\";i:66312;s:12:\"delete-67070\";i:66313;s:12:\"delete-67073\";i:66314;s:12:\"delete-67076\";i:66315;s:12:\"delete-67077\";i:66316;s:12:\"delete-67074\";i:66317;s:12:\"delete-67075\";i:66318;s:12:\"delete-67078\";i:66319;s:12:\"delete-67081\";i:66320;s:12:\"delete-67082\";i:66321;s:12:\"delete-67079\";i:66322;s:12:\"delete-67080\";i:66323;s:12:\"delete-67083\";i:66324;s:12:\"delete-67086\";i:66325;s:12:\"delete-67087\";i:66326;s:12:\"delete-67084\";i:66327;s:12:\"delete-67085\";i:66328;s:12:\"delete-67088\";i:66329;s:12:\"delete-67091\";i:66330;s:12:\"delete-67092\";i:66331;s:12:\"delete-67089\";i:66332;s:12:\"delete-67090\";i:66333;s:12:\"delete-67093\";i:66334;s:12:\"delete-67096\";i:66335;s:12:\"delete-67097\";i:66336;s:12:\"delete-67094\";i:66337;s:12:\"delete-67095\";i:66338;s:12:\"delete-67098\";i:66339;s:12:\"delete-67101\";i:66340;s:12:\"delete-67099\";i:66341;s:12:\"delete-67100\";i:66342;s:12:\"delete-67102\";i:66343;s:12:\"delete-67103\";i:66344;s:12:\"delete-67106\";i:66345;s:12:\"delete-67107\";i:66346;s:12:\"delete-67104\";i:66347;s:12:\"delete-67105\";i:66348;s:12:\"delete-67108\";i:66349;s:12:\"delete-67111\";i:66350;s:12:\"delete-67112\";i:66351;s:12:\"delete-67109\";i:66352;s:12:\"delete-67110\";i:66353;s:12:\"delete-67113\";i:66354;s:12:\"delete-67116\";i:66355;s:12:\"delete-67117\";i:66356;s:12:\"delete-67114\";i:66357;s:12:\"delete-67115\";i:66358;s:12:\"delete-67118\";i:66359;s:12:\"delete-67121\";i:66360;s:12:\"delete-67122\";i:66361;s:12:\"delete-67119\";i:66362;s:12:\"delete-67120\";i:66363;s:12:\"delete-67123\";i:66364;s:12:\"delete-67126\";i:66365;s:12:\"delete-67127\";i:66366;s:12:\"delete-67124\";i:66367;s:12:\"delete-67125\";i:66368;s:12:\"delete-67128\";i:66369;s:12:\"delete-67131\";i:66370;s:12:\"delete-67132\";i:66371;s:12:\"delete-67129\";i:66372;s:12:\"delete-67130\";i:66373;s:12:\"delete-67133\";i:66374;s:12:\"delete-67136\";i:66375;s:12:\"delete-67137\";i:66376;s:12:\"delete-67134\";i:66377;s:12:\"delete-67135\";i:66378;s:12:\"delete-67138\";i:66379;s:12:\"delete-67141\";i:66380;s:12:\"delete-67139\";i:66381;s:12:\"delete-67140\";i:66382;s:12:\"delete-67142\";i:66383;s:12:\"delete-67143\";i:66384;s:12:\"delete-67146\";i:66385;s:12:\"delete-67147\";i:66386;s:12:\"delete-67144\";i:66387;s:12:\"delete-67145\";i:66388;s:12:\"delete-67148\";i:66389;s:12:\"delete-67151\";i:66390;s:12:\"delete-67152\";i:66391;s:12:\"delete-67149\";i:66392;s:12:\"delete-67150\";i:66393;s:12:\"delete-67153\";i:66394;s:12:\"delete-67156\";i:66395;s:12:\"delete-67157\";i:66396;s:12:\"delete-67154\";i:66397;s:12:\"delete-67155\";i:66398;s:12:\"delete-67158\";i:66399;s:12:\"delete-67161\";i:66400;s:12:\"delete-67162\";i:66401;s:12:\"delete-67159\";i:66402;s:12:\"delete-67160\";i:66403;s:12:\"delete-67163\";i:66404;s:12:\"delete-67166\";i:66405;s:12:\"delete-67167\";i:66406;s:12:\"delete-67164\";i:66407;s:12:\"delete-67165\";i:66408;s:12:\"delete-67168\";i:66409;s:12:\"delete-67171\";i:66410;s:12:\"delete-67172\";i:66411;s:12:\"delete-67169\";i:66412;s:12:\"delete-67170\";i:66413;s:12:\"delete-67173\";i:66414;s:12:\"delete-67176\";i:66415;s:12:\"delete-67177\";i:66416;s:12:\"delete-67174\";i:66417;s:12:\"delete-67175\";i:66418;s:12:\"delete-67178\";i:66419;s:12:\"delete-67181\";i:66420;s:12:\"delete-67182\";i:66421;s:12:\"delete-67179\";i:66422;s:12:\"delete-67180\";i:66423;s:12:\"delete-67183\";i:66424;s:12:\"delete-67186\";i:66425;s:12:\"delete-67187\";i:66426;s:12:\"delete-67184\";i:66427;s:12:\"delete-67185\";i:66428;s:12:\"delete-67188\";i:66429;s:12:\"delete-67191\";i:66430;s:12:\"delete-67192\";i:66431;s:12:\"delete-67189\";i:66432;s:12:\"delete-67190\";i:66433;s:12:\"delete-67193\";i:66434;s:12:\"delete-67196\";i:66435;s:12:\"delete-67197\";i:66436;s:12:\"delete-67194\";i:66437;s:12:\"delete-67195\";i:66438;s:12:\"delete-67198\";i:66439;s:12:\"delete-67201\";i:66440;s:12:\"delete-67202\";i:66441;s:12:\"delete-67199\";i:66442;s:12:\"delete-67200\";i:66443;s:12:\"delete-67203\";i:66444;s:12:\"delete-67206\";i:66445;s:12:\"delete-67207\";i:66446;s:12:\"delete-67204\";i:66447;s:12:\"delete-67205\";i:66448;s:12:\"delete-67208\";i:66449;s:12:\"delete-67211\";i:66450;s:12:\"delete-67212\";i:66451;s:12:\"delete-67209\";i:66452;s:12:\"delete-67210\";i:66453;s:12:\"delete-67213\";i:66454;s:12:\"delete-67216\";i:66455;s:12:\"delete-67214\";i:66456;s:12:\"delete-67215\";i:66457;s:12:\"delete-67217\";i:66458;s:12:\"delete-67218\";i:66459;s:12:\"delete-67221\";i:66460;s:12:\"delete-67222\";i:66461;s:12:\"delete-67219\";i:66462;s:12:\"delete-67220\";i:66463;s:12:\"delete-67223\";i:66464;s:12:\"delete-67226\";i:66465;s:12:\"delete-67224\";i:66466;s:12:\"delete-67225\";i:66467;s:12:\"delete-67227\";i:66468;s:12:\"delete-67228\";i:66469;s:12:\"delete-67231\";i:66470;s:12:\"delete-67232\";i:66471;s:12:\"delete-67229\";i:66472;s:12:\"delete-67230\";i:66473;s:12:\"delete-67233\";i:66474;s:12:\"delete-67236\";i:66475;s:12:\"delete-67237\";i:66476;s:12:\"delete-67234\";i:66477;s:12:\"delete-67235\";i:66478;s:12:\"delete-67238\";i:66479;s:12:\"delete-67241\";i:66480;s:12:\"delete-67239\";i:66481;s:12:\"delete-67240\";i:66482;s:12:\"delete-67242\";i:66483;s:12:\"delete-67245\";i:66484;s:12:\"delete-67246\";i:66485;s:12:\"delete-67243\";i:66486;s:12:\"delete-67244\";i:66487;s:12:\"delete-67247\";i:66488;s:12:\"delete-67250\";i:66489;s:12:\"delete-67251\";i:66490;s:12:\"delete-67248\";i:66491;s:12:\"delete-67249\";i:66492;s:12:\"delete-67252\";i:66493;s:12:\"delete-67255\";i:66494;s:12:\"delete-67256\";i:66495;s:12:\"delete-67253\";i:66496;s:12:\"delete-67254\";i:66497;s:12:\"delete-67257\";i:66498;s:12:\"delete-67260\";i:66499;s:12:\"delete-67261\";i:66500;s:12:\"delete-67258\";i:66501;s:12:\"delete-67259\";i:66502;s:12:\"delete-67262\";i:66503;s:12:\"delete-67265\";i:66504;s:12:\"delete-67266\";i:66505;s:12:\"delete-67263\";i:66506;s:12:\"delete-67264\";i:66507;s:12:\"delete-67267\";i:66508;s:12:\"delete-67270\";i:66509;s:12:\"delete-67271\";i:66510;s:12:\"delete-67268\";i:66511;s:12:\"delete-67269\";i:66512;s:12:\"delete-67272\";i:66513;s:12:\"delete-67275\";i:66514;s:12:\"delete-67276\";i:66515;s:12:\"delete-67273\";i:66516;s:12:\"delete-67274\";i:66517;s:12:\"delete-67277\";i:66518;s:12:\"delete-67280\";i:66519;s:12:\"delete-67281\";i:66520;s:12:\"delete-67278\";i:66521;s:12:\"delete-67279\";i:66522;s:12:\"delete-67282\";i:66523;s:12:\"delete-67285\";i:66524;s:12:\"delete-67286\";i:66525;s:12:\"delete-67283\";i:66526;s:12:\"delete-67284\";i:66527;s:12:\"delete-67287\";i:66528;s:12:\"delete-67290\";i:66529;s:12:\"delete-67291\";i:66530;s:12:\"delete-67288\";i:66531;s:12:\"delete-67289\";i:66532;s:12:\"delete-67292\";i:66533;s:12:\"delete-67295\";i:66534;s:12:\"delete-67296\";i:66535;s:12:\"delete-67293\";i:66536;s:12:\"delete-67294\";i:66537;s:12:\"delete-67297\";i:66538;s:12:\"delete-67300\";i:66539;s:12:\"delete-67301\";i:66540;s:12:\"delete-67298\";i:66541;s:12:\"delete-67299\";i:66542;s:12:\"delete-67302\";i:66543;s:12:\"delete-67305\";i:66544;s:12:\"delete-67306\";i:66545;s:12:\"delete-67303\";i:66546;s:12:\"delete-67304\";i:66547;s:12:\"delete-67307\";i:66548;s:12:\"delete-67310\";i:66549;s:12:\"delete-67311\";i:66550;s:12:\"delete-67308\";i:66551;s:12:\"delete-67309\";i:66552;s:12:\"delete-67312\";i:66553;s:12:\"delete-67315\";i:66554;s:12:\"delete-67316\";i:66555;s:12:\"delete-67313\";i:66556;s:12:\"delete-67314\";i:66557;s:12:\"delete-67317\";i:66558;s:12:\"delete-67320\";i:66559;s:12:\"delete-67321\";i:66560;s:12:\"delete-67318\";i:66561;s:12:\"delete-67319\";i:66562;s:12:\"delete-67322\";i:66563;s:12:\"delete-67325\";i:66564;s:12:\"delete-67326\";i:66565;s:12:\"delete-67323\";i:66566;s:12:\"delete-67324\";i:66567;s:12:\"delete-67327\";i:66568;s:12:\"delete-67330\";i:66569;s:12:\"delete-67331\";i:66570;s:12:\"delete-67328\";i:66571;s:12:\"delete-67329\";i:66572;s:12:\"delete-67332\";i:66573;s:12:\"delete-67335\";i:66574;s:12:\"delete-67336\";i:66575;s:12:\"delete-67333\";i:66576;s:12:\"delete-67334\";i:66577;s:12:\"delete-67337\";i:66578;s:12:\"delete-67340\";i:66579;s:12:\"delete-67341\";i:66580;s:12:\"delete-67338\";i:66581;s:12:\"delete-67339\";i:66582;s:12:\"delete-67342\";i:66583;s:12:\"delete-67345\";i:66584;s:12:\"delete-67346\";i:66585;s:12:\"delete-67343\";i:66586;s:12:\"delete-67344\";i:66587;s:12:\"delete-67347\";i:66588;s:12:\"delete-67350\";i:66589;s:12:\"delete-67351\";i:66590;s:12:\"delete-67348\";i:66591;s:12:\"delete-67349\";i:66592;s:12:\"delete-67352\";i:66593;s:12:\"delete-67355\";i:66594;s:12:\"delete-67356\";i:66595;s:12:\"delete-67353\";i:66596;s:12:\"delete-67354\";i:66597;s:12:\"delete-67357\";i:66598;s:12:\"delete-67360\";i:66599;s:12:\"delete-67361\";i:66600;s:12:\"delete-67358\";i:66601;s:12:\"delete-67359\";i:66602;s:12:\"delete-67362\";i:66603;s:12:\"delete-67365\";i:66604;s:12:\"delete-67366\";i:66605;s:12:\"delete-67363\";i:66606;s:12:\"delete-67364\";i:66607;s:12:\"delete-67367\";i:66608;s:12:\"delete-67370\";i:66609;s:12:\"delete-67371\";i:66610;s:12:\"delete-67368\";i:66611;s:12:\"delete-67369\";i:66612;s:12:\"delete-67372\";i:66613;s:12:\"delete-67375\";i:66614;s:12:\"delete-67376\";i:66615;s:12:\"delete-67373\";i:66616;s:12:\"delete-67374\";i:66617;s:12:\"delete-67377\";i:66618;s:12:\"delete-67380\";i:66619;s:12:\"delete-67381\";i:66620;s:12:\"delete-67378\";i:66621;s:12:\"delete-67379\";i:66622;s:12:\"delete-67382\";i:66623;s:12:\"delete-67385\";i:66624;s:12:\"delete-67386\";i:66625;s:12:\"delete-67383\";i:66626;s:12:\"delete-67384\";i:66627;s:12:\"delete-67387\";i:66628;s:12:\"delete-67390\";i:66629;s:12:\"delete-67388\";i:66630;s:12:\"delete-67389\";i:66631;s:12:\"delete-67391\";i:66632;s:12:\"delete-67392\";i:66633;s:12:\"delete-67395\";i:66634;s:12:\"delete-67396\";i:66635;s:12:\"delete-67393\";i:66636;s:12:\"delete-67394\";i:66637;s:12:\"delete-67397\";i:66638;s:12:\"delete-67400\";i:66639;s:12:\"delete-67401\";i:66640;s:12:\"delete-67398\";i:66641;s:12:\"delete-67399\";i:66642;s:12:\"delete-67402\";i:66643;s:12:\"delete-67405\";i:66644;s:12:\"delete-67406\";i:66645;s:12:\"delete-67403\";i:66646;s:12:\"delete-67404\";i:66647;s:12:\"delete-67407\";i:66648;s:12:\"delete-67410\";i:66649;s:12:\"delete-67408\";i:66650;s:12:\"delete-67409\";i:66651;s:12:\"delete-67411\";i:66652;s:12:\"delete-67412\";i:66653;s:12:\"delete-67415\";i:66654;s:12:\"delete-67416\";i:66655;s:12:\"delete-67413\";i:66656;s:12:\"delete-67414\";i:66657;s:12:\"delete-67417\";i:66658;s:12:\"delete-67420\";i:66659;s:12:\"delete-67421\";i:66660;s:12:\"delete-67418\";i:66661;s:12:\"delete-67419\";i:66662;s:12:\"delete-67422\";i:66663;s:12:\"delete-67425\";i:66664;s:12:\"delete-67426\";i:66665;s:12:\"delete-67423\";i:66666;s:12:\"delete-67424\";i:66667;s:12:\"delete-67427\";i:66668;s:12:\"delete-67430\";i:66669;s:12:\"delete-67431\";i:66670;s:12:\"delete-67428\";i:66671;s:12:\"delete-67429\";i:66672;s:12:\"delete-67432\";i:66673;s:12:\"delete-67435\";i:66674;s:12:\"delete-67436\";i:66675;s:12:\"delete-67433\";i:66676;s:12:\"delete-67434\";i:66677;s:12:\"delete-67437\";i:66678;s:12:\"delete-67440\";i:66679;s:12:\"delete-67441\";i:66680;s:12:\"delete-67438\";i:66681;s:12:\"delete-67439\";i:66682;s:12:\"delete-67442\";i:66683;s:12:\"delete-67445\";i:66684;s:12:\"delete-67446\";i:66685;s:12:\"delete-67443\";i:66686;s:12:\"delete-67444\";i:66687;s:12:\"delete-67447\";i:66688;s:12:\"delete-67450\";i:66689;s:12:\"delete-67448\";i:66690;s:12:\"delete-67449\";i:66691;s:12:\"delete-67451\";i:66692;s:12:\"delete-67452\";i:66693;s:12:\"delete-67455\";i:66694;s:12:\"delete-67456\";i:66695;s:12:\"delete-67453\";i:66696;s:12:\"delete-67454\";i:66697;s:12:\"delete-67457\";i:66698;s:12:\"delete-67460\";i:66699;s:12:\"delete-67461\";i:66700;s:12:\"delete-67458\";i:66701;s:12:\"delete-67459\";i:66702;s:12:\"delete-67462\";i:66703;s:12:\"delete-67465\";i:66704;s:12:\"delete-67466\";i:66705;s:12:\"delete-67463\";i:66706;s:12:\"delete-67464\";i:66707;s:12:\"delete-67467\";i:66708;s:12:\"delete-67470\";i:66709;s:12:\"delete-67471\";i:66710;s:12:\"delete-67468\";i:66711;s:12:\"delete-67469\";i:66712;s:12:\"delete-67472\";i:66713;s:12:\"delete-67475\";i:66714;s:12:\"delete-67476\";i:66715;s:12:\"delete-67473\";i:66716;s:12:\"delete-67474\";i:66717;s:12:\"delete-67477\";i:66718;s:12:\"delete-67480\";i:66719;s:12:\"delete-67481\";i:66720;s:12:\"delete-67478\";i:66721;s:12:\"delete-67479\";i:66722;s:12:\"delete-67482\";i:66723;s:12:\"delete-67485\";i:66724;s:12:\"delete-67486\";i:66725;s:12:\"delete-67483\";i:66726;s:12:\"delete-67484\";i:66727;s:12:\"delete-67487\";i:66728;s:12:\"delete-67490\";i:66729;s:12:\"delete-67488\";i:66730;s:12:\"delete-67489\";i:66731;s:12:\"delete-67491\";i:66732;s:12:\"delete-67492\";i:66733;s:12:\"delete-67495\";i:66734;s:12:\"delete-67496\";i:66735;s:12:\"delete-67493\";i:66736;s:12:\"delete-67494\";i:66737;s:12:\"delete-67497\";i:66738;s:12:\"delete-67500\";i:66739;s:12:\"delete-67501\";i:66740;s:12:\"delete-67498\";i:66741;s:12:\"delete-67499\";i:66742;s:12:\"delete-67502\";i:66743;s:12:\"delete-67505\";i:66744;s:12:\"delete-67506\";i:66745;s:12:\"delete-67503\";i:66746;s:12:\"delete-67504\";i:66747;s:12:\"delete-67507\";i:66748;s:12:\"delete-67510\";i:66749;s:12:\"delete-67511\";i:66750;s:12:\"delete-67508\";i:66751;s:12:\"delete-67509\";i:66752;s:12:\"delete-67512\";i:66753;s:12:\"delete-67515\";i:66754;s:12:\"delete-67516\";i:66755;s:12:\"delete-67513\";i:66756;s:12:\"delete-67514\";i:66757;s:12:\"delete-67517\";i:66758;s:12:\"delete-67520\";i:66759;s:12:\"delete-67521\";i:66760;s:12:\"delete-67518\";i:66761;s:12:\"delete-67519\";i:66762;s:12:\"delete-67522\";i:66763;s:12:\"delete-67523\";i:66764;s:12:\"delete-67524\";i:66765;s:12:\"delete-67525\";i:66766;s:12:\"delete-67526\";i:66767;s:12:\"delete-67527\";i:66768;s:12:\"delete-67530\";i:66769;s:12:\"delete-67531\";i:66770;s:12:\"delete-67528\";i:66771;s:12:\"delete-67529\";i:66772;s:12:\"delete-67532\";i:66773;s:12:\"delete-67535\";i:66774;s:12:\"delete-67536\";i:66775;s:12:\"delete-67533\";i:66776;s:12:\"delete-67534\";i:66777;s:12:\"delete-67537\";i:66778;s:12:\"delete-67540\";i:66779;s:12:\"delete-67541\";i:66780;s:12:\"delete-67538\";i:66781;s:12:\"delete-67539\";i:66782;s:12:\"delete-67542\";i:66783;s:12:\"delete-67545\";i:66784;s:12:\"delete-67546\";i:66785;s:12:\"delete-67543\";i:66786;s:12:\"delete-67544\";i:66787;s:12:\"delete-67547\";i:66788;s:12:\"delete-67550\";i:66789;s:12:\"delete-67551\";i:66790;s:12:\"delete-67548\";i:66791;s:12:\"delete-67549\";i:66792;s:12:\"delete-67552\";i:66793;s:12:\"delete-67555\";i:66794;s:12:\"delete-67553\";i:66795;s:12:\"delete-67554\";i:66796;s:12:\"delete-67556\";i:66797;s:12:\"delete-67557\";i:66798;s:12:\"delete-67560\";i:66799;s:12:\"delete-67558\";i:66800;s:12:\"delete-67559\";i:66801;s:12:\"delete-67561\";i:66802;s:12:\"delete-67564\";i:66803;s:12:\"delete-67562\";i:66804;s:12:\"delete-67563\";i:66805;s:12:\"delete-67565\";i:66806;s:12:\"delete-67566\";i:66807;s:12:\"delete-67569\";i:66808;s:12:\"delete-67570\";i:66809;s:12:\"delete-67567\";i:66810;s:12:\"delete-67568\";i:66811;s:12:\"delete-67571\";i:66812;s:12:\"delete-67572\";i:66813;s:12:\"delete-67573\";i:66814;s:12:\"delete-67574\";i:66815;s:12:\"delete-67575\";i:66816;s:12:\"delete-67576\";i:66817;s:12:\"delete-67579\";i:66818;s:12:\"delete-67580\";i:66819;s:12:\"delete-67577\";i:66820;s:12:\"delete-67578\";i:66821;s:12:\"delete-67581\";i:66822;s:12:\"delete-67584\";i:66823;s:12:\"delete-67585\";i:66824;s:12:\"delete-67582\";i:66825;s:12:\"delete-67583\";i:66826;s:12:\"delete-67586\";i:66827;s:12:\"delete-67589\";i:66828;s:12:\"delete-67590\";i:66829;s:12:\"delete-67587\";i:66830;s:12:\"delete-67588\";i:66831;s:12:\"delete-67591\";i:66832;s:12:\"delete-67594\";i:66833;s:12:\"delete-67595\";i:66834;s:12:\"delete-67592\";i:66835;s:12:\"delete-67593\";i:66836;s:12:\"delete-67596\";i:66837;s:12:\"delete-67599\";i:66838;s:12:\"delete-67600\";i:66839;s:12:\"delete-67597\";i:66840;s:12:\"delete-67598\";i:66841;s:12:\"delete-67601\";i:66842;s:12:\"delete-67604\";i:66843;s:12:\"delete-67605\";i:66844;s:12:\"delete-67602\";i:66845;s:12:\"delete-67603\";i:66846;s:12:\"delete-67606\";i:66847;s:12:\"delete-67609\";i:66848;s:12:\"delete-67610\";i:66849;s:12:\"delete-67607\";i:66850;s:12:\"delete-67608\";i:66851;s:12:\"delete-67611\";i:66852;s:12:\"delete-67614\";i:66853;s:12:\"delete-67615\";i:66854;s:12:\"delete-67612\";i:66855;s:12:\"delete-67613\";i:66856;s:12:\"delete-67616\";i:66857;s:12:\"delete-67619\";i:66858;s:12:\"delete-67620\";i:66859;s:12:\"delete-67617\";i:66860;s:12:\"delete-67618\";i:66861;s:12:\"delete-67621\";i:66862;s:12:\"delete-67624\";i:66863;s:12:\"delete-67625\";i:66864;s:12:\"delete-67622\";i:66865;s:12:\"delete-67623\";i:66866;s:12:\"delete-67626\";i:66867;s:12:\"delete-67629\";i:66868;s:12:\"delete-67627\";i:66869;s:12:\"delete-67628\";i:66870;s:12:\"delete-67630\";i:66871;s:12:\"delete-67631\";i:66872;s:12:\"delete-67634\";i:66873;s:12:\"delete-67635\";i:66874;s:12:\"delete-67636\";i:66875;s:12:\"delete-67632\";i:66876;s:12:\"delete-67633\";i:66877;s:12:\"delete-67637\";i:66878;s:12:\"delete-67638\";i:66879;s:12:\"delete-67639\";i:66880;s:12:\"delete-67640\";i:66881;s:12:\"delete-67641\";i:66882;s:12:\"delete-67644\";i:66883;s:12:\"delete-67645\";i:66884;s:12:\"delete-67642\";i:66885;s:12:\"delete-67643\";i:66886;s:12:\"delete-67646\";i:66887;s:12:\"delete-67649\";i:66888;s:12:\"delete-67650\";i:66889;s:12:\"delete-67647\";i:66890;s:12:\"delete-67648\";i:66891;s:12:\"delete-67651\";i:66892;s:12:\"delete-67654\";i:66893;s:12:\"delete-67655\";i:66894;s:12:\"delete-67652\";i:66895;s:12:\"delete-67653\";i:66896;s:12:\"delete-67656\";i:66897;s:12:\"delete-67659\";i:66898;s:12:\"delete-67660\";i:66899;s:12:\"delete-67657\";i:66900;s:12:\"delete-67658\";i:66901;s:12:\"delete-67661\";i:66902;s:12:\"delete-67664\";i:66903;s:12:\"delete-67665\";i:66904;s:12:\"delete-67662\";i:66905;s:12:\"delete-67663\";i:66906;s:12:\"delete-67666\";i:66907;s:12:\"delete-67669\";i:66908;s:12:\"delete-67670\";i:66909;s:12:\"delete-67667\";i:66910;s:12:\"delete-67668\";i:66911;s:12:\"delete-67671\";i:66912;s:12:\"delete-67672\";i:66913;s:12:\"delete-67673\";i:66914;s:12:\"delete-67674\";i:66915;s:12:\"delete-67675\";i:66916;s:12:\"delete-67676\";i:66917;s:12:\"delete-67679\";i:66918;s:12:\"delete-67680\";i:66919;s:12:\"delete-67677\";i:66920;s:12:\"delete-67678\";i:66921;s:12:\"delete-67681\";i:66922;s:12:\"delete-67684\";i:66923;s:12:\"delete-67685\";i:66924;s:12:\"delete-67682\";i:66925;s:12:\"delete-67683\";i:66926;s:12:\"delete-67686\";i:66927;s:12:\"delete-67689\";i:66928;s:12:\"delete-67690\";i:66929;s:12:\"delete-67691\";i:66930;s:12:\"delete-67694\";i:66931;s:12:\"delete-67695\";i:66932;s:12:\"delete-67687\";i:66933;s:12:\"delete-67688\";i:66934;s:12:\"delete-67692\";i:66935;s:12:\"delete-67693\";i:66936;s:12:\"delete-67696\";i:66937;s:12:\"delete-67699\";i:66938;s:12:\"delete-67700\";i:66939;s:12:\"delete-67697\";i:66940;s:12:\"delete-67698\";i:66941;s:12:\"delete-67701\";i:66942;s:12:\"delete-67704\";i:66943;s:12:\"delete-67705\";i:66944;s:12:\"delete-67702\";i:66945;s:12:\"delete-67703\";i:66946;s:12:\"delete-67706\";i:66947;s:12:\"delete-67707\";i:66948;s:12:\"delete-67708\";i:66949;s:12:\"delete-67709\";i:66950;s:12:\"delete-67710\";i:66951;s:12:\"delete-67711\";i:66952;s:12:\"delete-67714\";i:66953;s:12:\"delete-67715\";i:66954;s:12:\"delete-67712\";i:66955;s:12:\"delete-67713\";i:66956;s:12:\"delete-67716\";i:66957;s:12:\"delete-67719\";i:66958;s:12:\"delete-67720\";i:66959;s:12:\"delete-67717\";i:66960;s:12:\"delete-67718\";i:66961;s:12:\"delete-67721\";i:66962;s:12:\"delete-67724\";i:66963;s:12:\"delete-67722\";i:66964;s:12:\"delete-67723\";i:66965;s:12:\"delete-67725\";i:66966;s:12:\"delete-67726\";i:66967;s:12:\"delete-67729\";i:66968;s:12:\"delete-67730\";i:66969;s:12:\"delete-67727\";i:66970;s:12:\"delete-67728\";i:66971;s:12:\"delete-67731\";i:66972;s:12:\"delete-67734\";i:66973;s:12:\"delete-67735\";i:66974;s:12:\"delete-67732\";i:66975;s:12:\"delete-67733\";i:66976;s:12:\"delete-67736\";i:66977;s:12:\"delete-67739\";i:66978;s:12:\"delete-67737\";i:66979;s:12:\"delete-67738\";i:66980;s:12:\"delete-67740\";i:66981;s:12:\"delete-67741\";i:66982;s:12:\"delete-67744\";i:66983;s:12:\"delete-67745\";i:66984;s:12:\"delete-67742\";i:66985;s:12:\"delete-67743\";i:66986;s:12:\"delete-67746\";i:66987;s:12:\"delete-67749\";i:66988;s:12:\"delete-67750\";i:66989;s:12:\"delete-67747\";i:66990;s:12:\"delete-67748\";i:66991;s:12:\"delete-67751\";i:66992;s:12:\"delete-67754\";i:66993;s:12:\"delete-67755\";i:66994;s:12:\"delete-67752\";i:66995;s:12:\"delete-67753\";i:66996;s:12:\"delete-67756\";i:66997;s:12:\"delete-67759\";i:66998;s:12:\"delete-67757\";i:66999;s:12:\"delete-67758\";i:67000;s:12:\"delete-67760\";i:67001;s:12:\"delete-67761\";i:67002;s:12:\"delete-67764\";i:67003;s:12:\"delete-67765\";i:67004;s:12:\"delete-67762\";i:67005;s:12:\"delete-67763\";i:67006;s:12:\"delete-67766\";i:67007;s:12:\"delete-67769\";i:67008;s:12:\"delete-67770\";i:67009;s:12:\"delete-67767\";i:67010;s:12:\"delete-67768\";i:67011;s:12:\"delete-67771\";i:67012;s:12:\"delete-67774\";i:67013;s:12:\"delete-67775\";i:67014;s:12:\"delete-67772\";i:67015;s:12:\"delete-67773\";i:67016;s:12:\"delete-67776\";i:67017;s:12:\"delete-67779\";i:67018;s:12:\"delete-67780\";i:67019;s:12:\"delete-67777\";i:67020;s:12:\"delete-67778\";i:67021;s:12:\"delete-67781\";i:67022;s:12:\"delete-67784\";i:67023;s:12:\"delete-67785\";i:67024;s:12:\"delete-67782\";i:67025;s:12:\"delete-67783\";i:67026;s:12:\"delete-67786\";i:67027;s:12:\"delete-67789\";i:67028;s:12:\"delete-67790\";i:67029;s:12:\"delete-67787\";i:67030;s:12:\"delete-67788\";i:67031;s:12:\"delete-67791\";i:67032;s:12:\"delete-67794\";i:67033;s:12:\"delete-67795\";i:67034;s:12:\"delete-67792\";i:67035;s:12:\"delete-67793\";i:67036;s:12:\"delete-67796\";i:67037;s:12:\"delete-67799\";i:67038;s:12:\"delete-67800\";i:67039;s:12:\"delete-67797\";i:67040;s:12:\"delete-67798\";i:67041;s:12:\"delete-67801\";i:67042;s:12:\"delete-67804\";i:67043;s:12:\"delete-67805\";i:67044;s:12:\"delete-67802\";i:67045;s:12:\"delete-67803\";i:67046;s:12:\"delete-67806\";i:67047;s:12:\"delete-67809\";i:67048;s:12:\"delete-67810\";i:67049;s:12:\"delete-67807\";i:67050;s:12:\"delete-67808\";i:67051;s:12:\"delete-67811\";i:67052;s:12:\"delete-67814\";i:67053;s:12:\"delete-67815\";i:67054;s:12:\"delete-67812\";i:67055;s:12:\"delete-67813\";i:67056;s:12:\"delete-67816\";i:67057;s:12:\"delete-67819\";i:67058;s:12:\"delete-67820\";i:67059;s:12:\"delete-67817\";i:67060;s:12:\"delete-67818\";i:67061;s:12:\"delete-67821\";i:67062;s:12:\"delete-67824\";i:67063;s:12:\"delete-67825\";i:67064;s:12:\"delete-67822\";i:67065;s:12:\"delete-67823\";i:67066;s:12:\"delete-67826\";i:67067;s:12:\"delete-67829\";i:67068;s:12:\"delete-67830\";i:67069;s:12:\"delete-67827\";i:67070;s:12:\"delete-67828\";i:67071;s:12:\"delete-67831\";i:67072;s:12:\"delete-67834\";i:67073;s:12:\"delete-67835\";i:67074;s:12:\"delete-67832\";i:67075;s:12:\"delete-67833\";i:67076;s:12:\"delete-67836\";i:67077;s:12:\"delete-67839\";i:67078;s:12:\"delete-67840\";i:67079;s:12:\"delete-67837\";i:67080;s:12:\"delete-67838\";i:67081;s:12:\"delete-67841\";i:67082;s:12:\"delete-67844\";i:67083;s:12:\"delete-67842\";i:67084;s:12:\"delete-67843\";i:67085;s:12:\"delete-67845\";i:67086;s:12:\"delete-67846\";i:67087;s:12:\"delete-67849\";i:67088;s:12:\"delete-67850\";i:67089;s:12:\"delete-67847\";i:67090;s:12:\"delete-67848\";i:67091;s:12:\"delete-67851\";i:67092;s:12:\"delete-67854\";i:67093;s:12:\"delete-67855\";i:67094;s:12:\"delete-67852\";i:67095;s:12:\"delete-67853\";i:67096;s:12:\"delete-67856\";i:67097;s:12:\"delete-67859\";i:67098;s:12:\"delete-67860\";i:67099;s:12:\"delete-67857\";i:67100;s:12:\"delete-67858\";i:67101;s:12:\"delete-67861\";i:67102;s:12:\"delete-67864\";i:67103;s:12:\"delete-67865\";i:67104;s:12:\"delete-67862\";i:67105;s:12:\"delete-67863\";i:67106;s:12:\"delete-67866\";i:67107;s:12:\"delete-67869\";i:67108;s:12:\"delete-67870\";i:67109;s:12:\"delete-67871\";i:67110;s:12:\"delete-67874\";i:67111;s:12:\"delete-67867\";i:67112;s:12:\"delete-67868\";i:67113;s:12:\"delete-67872\";i:67114;s:12:\"delete-67873\";i:67115;s:12:\"delete-67875\";i:67116;s:12:\"delete-67876\";i:67117;s:12:\"delete-67879\";i:67118;s:12:\"delete-67877\";i:67119;s:12:\"delete-67878\";i:67120;s:12:\"delete-67880\";i:67121;s:12:\"delete-67883\";i:67122;s:12:\"delete-67884\";i:67123;s:12:\"delete-67881\";i:67124;s:12:\"delete-67882\";i:67125;s:12:\"delete-67885\";i:67126;s:12:\"delete-67888\";i:67127;s:12:\"delete-67889\";i:67128;s:12:\"delete-67886\";i:67129;s:12:\"delete-67887\";i:67130;s:12:\"delete-67890\";i:67131;s:12:\"delete-67893\";i:67132;s:12:\"delete-67894\";i:67133;s:12:\"delete-67891\";i:67134;s:12:\"delete-67892\";i:67135;s:12:\"delete-67895\";i:67136;s:12:\"delete-67898\";i:67137;s:12:\"delete-67899\";i:67138;s:12:\"delete-67896\";i:67139;s:12:\"delete-67897\";i:67140;s:12:\"delete-67900\";i:67141;s:12:\"delete-67903\";i:67142;s:12:\"delete-67904\";i:67143;s:12:\"delete-67901\";i:67144;s:12:\"delete-67902\";i:67145;s:12:\"delete-67905\";i:67146;s:12:\"delete-67908\";i:67147;s:12:\"delete-67909\";i:67148;s:12:\"delete-67906\";i:67149;s:12:\"delete-67907\";i:67150;s:12:\"delete-67910\";i:67151;s:12:\"delete-67913\";i:67152;s:12:\"delete-67914\";i:67153;s:12:\"delete-67911\";i:67154;s:12:\"delete-67912\";i:67155;s:12:\"delete-67915\";i:67156;s:12:\"delete-67918\";i:67157;s:12:\"delete-67919\";i:67158;s:12:\"delete-67916\";i:67159;s:12:\"delete-67917\";i:67160;s:12:\"delete-67920\";i:67161;s:12:\"delete-67923\";i:67162;s:12:\"delete-67924\";i:67163;s:12:\"delete-67921\";i:67164;s:12:\"delete-67922\";i:67165;s:12:\"delete-67925\";i:67166;s:12:\"delete-67928\";i:67167;s:12:\"delete-67929\";i:67168;s:12:\"delete-67926\";i:67169;s:12:\"delete-67927\";i:67170;s:12:\"delete-67930\";i:67171;s:12:\"delete-67933\";i:67172;s:12:\"delete-67934\";i:67173;s:12:\"delete-67931\";i:67174;s:12:\"delete-67932\";i:67175;s:12:\"delete-67935\";i:67176;s:12:\"delete-67939\";i:67177;s:12:\"delete-67938\";i:67178;s:12:\"delete-67936\";i:67179;s:12:\"delete-67937\";i:67180;s:12:\"delete-67940\";i:67181;s:12:\"delete-67943\";i:67182;s:12:\"delete-67944\";i:67183;s:12:\"delete-67941\";i:67184;s:12:\"delete-67942\";i:67185;s:12:\"delete-67945\";i:67186;s:12:\"delete-67949\";i:67187;s:12:\"delete-67948\";i:67188;s:12:\"delete-67946\";i:67189;s:12:\"delete-67947\";i:67190;s:12:\"delete-67950\";i:67191;s:12:\"delete-67953\";i:67192;s:12:\"delete-67951\";i:67193;s:12:\"delete-67952\";i:67194;s:12:\"delete-67954\";i:67195;s:12:\"delete-67955\";i:67196;s:12:\"delete-67958\";i:67197;s:12:\"delete-67959\";i:67198;s:12:\"delete-67956\";i:67199;s:12:\"delete-67957\";i:67200;s:12:\"delete-67960\";i:67201;s:12:\"delete-67963\";i:67202;s:12:\"delete-67961\";i:67203;s:12:\"delete-67962\";i:67204;s:12:\"delete-67964\";i:67205;s:12:\"delete-67965\";i:67206;s:12:\"delete-67968\";i:67207;s:12:\"delete-67969\";i:67208;s:12:\"delete-67966\";i:67209;s:12:\"delete-67967\";i:67210;s:12:\"delete-67970\";i:67211;s:12:\"delete-67971\";i:67212;s:12:\"delete-67972\";i:67213;s:12:\"delete-67973\";i:67214;s:12:\"delete-67974\";i:67215;s:12:\"delete-67975\";i:67216;s:12:\"delete-67976\";i:67217;s:12:\"delete-67977\";i:67218;s:12:\"delete-67978\";i:67219;s:12:\"delete-67979\";i:67220;s:12:\"delete-67980\";i:67221;s:12:\"delete-67983\";i:67222;s:12:\"delete-67984\";i:67223;s:12:\"delete-67981\";i:67224;s:12:\"delete-67982\";i:67225;s:12:\"delete-67985\";i:67226;s:12:\"delete-67988\";i:67227;s:12:\"delete-67989\";i:67228;s:12:\"delete-67986\";i:67229;s:12:\"delete-67987\";i:67230;s:12:\"delete-67990\";i:67231;s:12:\"delete-67993\";i:67232;s:12:\"delete-67994\";i:67233;s:12:\"delete-67991\";i:67234;s:12:\"delete-67992\";i:67235;s:12:\"delete-67995\";i:67236;s:12:\"delete-67998\";i:67237;s:12:\"delete-67996\";i:67238;s:12:\"delete-67997\";i:67239;s:12:\"delete-67999\";i:67240;s:12:\"delete-68000\";i:67241;s:12:\"delete-68003\";i:67242;s:12:\"delete-68004\";i:67243;s:12:\"delete-68001\";i:67244;s:12:\"delete-68002\";i:67245;s:12:\"delete-68005\";i:67246;s:12:\"delete-68008\";i:67247;s:12:\"delete-68009\";i:67248;s:12:\"delete-68006\";i:67249;s:12:\"delete-68007\";i:67250;s:12:\"delete-68010\";i:67251;s:12:\"delete-68013\";i:67252;s:12:\"delete-68014\";i:67253;s:12:\"delete-68011\";i:67254;s:12:\"delete-68012\";i:67255;s:12:\"delete-68015\";i:67256;s:12:\"delete-68018\";i:67257;s:12:\"delete-68019\";i:67258;s:12:\"delete-68016\";i:67259;s:12:\"delete-68017\";i:67260;s:12:\"delete-68020\";i:67261;s:12:\"delete-68021\";i:67262;s:12:\"delete-68022\";i:67263;s:12:\"delete-68023\";i:67264;s:12:\"delete-68024\";i:67265;s:12:\"delete-68025\";i:67266;s:12:\"delete-68026\";i:67267;s:12:\"delete-68027\";i:67268;s:12:\"delete-68028\";i:67269;s:12:\"delete-68029\";i:67270;s:12:\"delete-68030\";i:67271;s:12:\"delete-68033\";i:67272;s:12:\"delete-68034\";i:67273;s:12:\"delete-68031\";i:67274;s:12:\"delete-68032\";i:67275;s:12:\"delete-68035\";i:67276;s:12:\"delete-68036\";i:67277;s:12:\"delete-68037\";i:67278;s:12:\"delete-68038\";i:67279;s:12:\"delete-68039\";i:67280;s:12:\"delete-68040\";i:67281;s:12:\"delete-68041\";i:67282;s:12:\"delete-68042\";i:67283;s:12:\"delete-68043\";i:67284;s:12:\"delete-68044\";i:67285;s:12:\"delete-68045\";i:67286;s:12:\"delete-68048\";i:67287;s:12:\"delete-68049\";i:67288;s:12:\"delete-68046\";i:67289;s:12:\"delete-68047\";i:67290;s:12:\"delete-68050\";i:67291;s:12:\"delete-68053\";i:67292;s:12:\"delete-68054\";i:67293;s:12:\"delete-68051\";i:67294;s:12:\"delete-68052\";i:67295;s:12:\"delete-68055\";i:67296;s:12:\"delete-68058\";i:67297;s:12:\"delete-68056\";i:67298;s:12:\"delete-68057\";i:67299;s:12:\"delete-68059\";i:67300;s:12:\"delete-68060\";i:67301;s:12:\"delete-68063\";i:67302;s:12:\"delete-68064\";i:67303;s:12:\"delete-68061\";i:67304;s:12:\"delete-68062\";i:67305;s:12:\"delete-68065\";i:67306;s:12:\"delete-68068\";i:67307;s:12:\"delete-68069\";i:67308;s:12:\"delete-68066\";i:67309;s:12:\"delete-68067\";i:67310;s:12:\"delete-68070\";i:67311;s:12:\"delete-68073\";i:67312;s:12:\"delete-68074\";i:67313;s:12:\"delete-68071\";i:67314;s:12:\"delete-68072\";i:67315;s:12:\"delete-68075\";i:67316;s:12:\"delete-68078\";i:67317;s:12:\"delete-68079\";i:67318;s:12:\"delete-68076\";i:67319;s:12:\"delete-68077\";i:67320;s:12:\"delete-68080\";i:67321;s:12:\"delete-68083\";i:67322;s:12:\"delete-68084\";i:67323;s:12:\"delete-68081\";i:67324;s:12:\"delete-68082\";i:67325;s:12:\"delete-68085\";i:67326;s:12:\"delete-68088\";i:67327;s:12:\"delete-68089\";i:67328;s:12:\"delete-68086\";i:67329;s:12:\"delete-68087\";i:67330;s:12:\"delete-68090\";i:67331;s:12:\"delete-68093\";i:67332;s:12:\"delete-68094\";i:67333;s:12:\"delete-68091\";i:67334;s:12:\"delete-68092\";i:67335;s:12:\"delete-68095\";i:67336;s:12:\"delete-68098\";i:67337;s:12:\"delete-68099\";i:67338;s:12:\"delete-68096\";i:67339;s:12:\"delete-68097\";i:67340;s:12:\"delete-68100\";i:67341;s:12:\"delete-68103\";i:67342;s:12:\"delete-68104\";i:67343;s:12:\"delete-68101\";i:67344;s:12:\"delete-68102\";i:67345;s:12:\"delete-68105\";i:67346;s:12:\"delete-68108\";i:67347;s:12:\"delete-68109\";i:67348;s:12:\"delete-68106\";i:67349;s:12:\"delete-68107\";i:67350;s:12:\"delete-68110\";i:67351;s:12:\"delete-68113\";i:67352;s:12:\"delete-68114\";i:67353;s:12:\"delete-68111\";i:67354;s:12:\"delete-68112\";i:67355;s:12:\"delete-68115\";i:67356;s:12:\"delete-68118\";i:67357;s:12:\"delete-68119\";i:67358;s:12:\"delete-68116\";i:67359;s:12:\"delete-68117\";i:67360;s:12:\"delete-68120\";i:67361;s:12:\"delete-68123\";i:67362;s:12:\"delete-68124\";i:67363;s:12:\"delete-68121\";i:67364;s:12:\"delete-68122\";i:67365;s:12:\"delete-68125\";i:67366;s:12:\"delete-68128\";i:67367;s:12:\"delete-68129\";i:67368;s:12:\"delete-68126\";i:67369;s:12:\"delete-68127\";i:67370;s:12:\"delete-68130\";i:67371;s:12:\"delete-68133\";i:67372;s:12:\"delete-68134\";i:67373;s:12:\"delete-68131\";i:67374;s:12:\"delete-68132\";i:67375;s:12:\"delete-68135\";i:67376;s:12:\"delete-68138\";i:67377;s:12:\"delete-68139\";i:67378;s:12:\"delete-68136\";i:67379;s:12:\"delete-68137\";i:67380;s:12:\"delete-68140\";i:67381;s:12:\"delete-68143\";i:67382;s:12:\"delete-68144\";i:67383;s:12:\"delete-68141\";i:67384;s:12:\"delete-68142\";i:67385;s:12:\"delete-68145\";i:67386;s:12:\"delete-68148\";i:67387;s:12:\"delete-68149\";i:67388;s:12:\"delete-68150\";i:67389;s:12:\"delete-68153\";i:67390;s:12:\"delete-68154\";i:67391;s:12:\"delete-68155\";i:67392;s:12:\"delete-68158\";i:67393;s:12:\"delete-68159\";i:67394;s:12:\"delete-68160\";i:67395;s:12:\"delete-68163\";i:67396;s:12:\"delete-68164\";i:67397;s:12:\"delete-68146\";i:67398;s:12:\"delete-68147\";i:67399;s:12:\"delete-68151\";i:67400;s:12:\"delete-68152\";i:67401;s:12:\"delete-68156\";i:67402;s:12:\"delete-68157\";i:67403;s:12:\"delete-68161\";i:67404;s:12:\"delete-68162\";i:67405;s:12:\"delete-68165\";i:67406;s:12:\"delete-68168\";i:67407;s:12:\"delete-68169\";i:67408;s:12:\"delete-68166\";i:67409;s:12:\"delete-68167\";i:67410;s:12:\"delete-68170\";i:67411;s:12:\"delete-68173\";i:67412;s:12:\"delete-68174\";i:67413;s:12:\"delete-68171\";i:67414;s:12:\"delete-68172\";i:67415;s:12:\"delete-68175\";i:67416;s:12:\"delete-68178\";i:67417;s:12:\"delete-68179\";i:67418;s:12:\"delete-68176\";i:67419;s:12:\"delete-68177\";i:67420;s:12:\"delete-68180\";i:67421;s:12:\"delete-68183\";i:67422;s:12:\"delete-68184\";i:67423;s:12:\"delete-68181\";i:67424;s:12:\"delete-68182\";i:67425;s:12:\"delete-68185\";i:67426;s:12:\"delete-68188\";i:67427;s:12:\"delete-68189\";i:67428;s:12:\"delete-68186\";i:67429;s:12:\"delete-68187\";i:67430;s:12:\"delete-68190\";i:67431;s:12:\"delete-68193\";i:67432;s:12:\"delete-68194\";i:67433;s:12:\"delete-68191\";i:67434;s:12:\"delete-68192\";i:67435;s:12:\"delete-68195\";i:67436;s:12:\"delete-68198\";i:67437;s:12:\"delete-68199\";i:67438;s:12:\"delete-68196\";i:67439;s:12:\"delete-68197\";i:67440;s:12:\"delete-68200\";i:67441;s:12:\"delete-68203\";i:67442;s:12:\"delete-68204\";i:67443;s:12:\"delete-68201\";i:67444;s:12:\"delete-68202\";i:67445;s:12:\"delete-68205\";i:67446;s:12:\"delete-68208\";i:67447;s:12:\"delete-68209\";i:67448;s:12:\"delete-68206\";i:67449;s:12:\"delete-68207\";i:67450;s:12:\"delete-68210\";i:67451;s:12:\"delete-68213\";i:67452;s:12:\"delete-68214\";i:67453;s:12:\"delete-68211\";i:67454;s:12:\"delete-68212\";i:67455;s:12:\"delete-68215\";i:67456;s:12:\"delete-68218\";i:67457;s:12:\"delete-68219\";i:67458;s:12:\"delete-68216\";i:67459;s:12:\"delete-68217\";i:67460;s:12:\"delete-68220\";i:67461;s:12:\"delete-68223\";i:67462;s:12:\"delete-68224\";i:67463;s:12:\"delete-68221\";i:67464;s:12:\"delete-68222\";i:67465;s:12:\"delete-68225\";i:67466;s:12:\"delete-68228\";i:67467;s:12:\"delete-68229\";i:67468;s:12:\"delete-68226\";i:67469;s:12:\"delete-68227\";i:67470;s:12:\"delete-68230\";i:67471;s:12:\"delete-68233\";i:67472;s:12:\"delete-68234\";i:67473;s:12:\"delete-68231\";i:67474;s:12:\"delete-68232\";i:67475;s:12:\"delete-68235\";i:67476;s:12:\"delete-68238\";i:67477;s:12:\"delete-68239\";i:67478;s:12:\"delete-68236\";i:67479;s:12:\"delete-68237\";i:67480;s:12:\"delete-68240\";i:67481;s:12:\"delete-68243\";i:67482;s:12:\"delete-68244\";i:67483;s:12:\"delete-68241\";i:67484;s:12:\"delete-68242\";i:67485;s:12:\"delete-68245\";i:67486;s:12:\"delete-68248\";i:67487;s:12:\"delete-68246\";i:67488;s:12:\"delete-68247\";i:67489;s:12:\"delete-68249\";i:67490;s:12:\"delete-68250\";i:67491;s:12:\"delete-68253\";i:67492;s:12:\"delete-68254\";i:67493;s:12:\"delete-68251\";i:67494;s:12:\"delete-68252\";i:67495;s:12:\"delete-68255\";i:67496;s:12:\"delete-68258\";i:67497;s:12:\"delete-68259\";i:67498;s:12:\"delete-68256\";i:67499;s:12:\"delete-68257\";i:67500;s:12:\"delete-68260\";i:67501;s:12:\"delete-68263\";i:67502;s:12:\"delete-68264\";i:67503;s:12:\"delete-68265\";i:67504;s:12:\"delete-68268\";i:67505;s:12:\"delete-68269\";i:67506;s:12:\"delete-68261\";i:67507;s:12:\"delete-68262\";i:67508;s:12:\"delete-68266\";i:67509;s:12:\"delete-68267\";i:67510;s:12:\"delete-68270\";i:67511;s:12:\"delete-68273\";i:67512;s:12:\"delete-68274\";i:67513;s:12:\"delete-68271\";i:67514;s:12:\"delete-68272\";i:67515;s:12:\"delete-68275\";i:67516;s:12:\"delete-68278\";i:67517;s:12:\"delete-68279\";i:67518;s:12:\"delete-68276\";i:67519;s:12:\"delete-68277\";i:67520;s:12:\"delete-68280\";i:67521;s:12:\"delete-68283\";i:67522;s:12:\"delete-68284\";i:67523;s:12:\"delete-68281\";i:67524;s:12:\"delete-68282\";i:67525;s:12:\"delete-68285\";i:67526;s:12:\"delete-68288\";i:67527;s:12:\"delete-68289\";i:67528;s:12:\"delete-68286\";i:67529;s:12:\"delete-68287\";i:67530;s:12:\"delete-68290\";i:67531;s:12:\"delete-68293\";i:67532;s:12:\"delete-68294\";i:67533;s:12:\"delete-68291\";i:67534;s:12:\"delete-68292\";i:67535;s:12:\"delete-68295\";i:67536;s:12:\"delete-68298\";i:67537;s:12:\"delete-68296\";i:67538;s:12:\"delete-68297\";i:67539;s:12:\"delete-68299\";i:67540;s:12:\"delete-68300\";i:67541;s:12:\"delete-68303\";i:67542;s:12:\"delete-68304\";i:67543;s:12:\"delete-68301\";i:67544;s:12:\"delete-68302\";i:67545;s:12:\"delete-68305\";i:67546;s:12:\"delete-68308\";i:67547;s:12:\"delete-68309\";i:67548;s:12:\"delete-68306\";i:67549;s:12:\"delete-68307\";i:67550;s:12:\"delete-68310\";i:67551;s:12:\"delete-68311\";i:67552;s:12:\"delete-68312\";i:67553;s:12:\"delete-68313\";i:67554;s:12:\"delete-68314\";i:67555;s:12:\"delete-68315\";i:67556;s:12:\"delete-68318\";i:67557;s:12:\"delete-68319\";i:67558;s:12:\"delete-68316\";i:67559;s:12:\"delete-68317\";i:67560;s:12:\"delete-68320\";i:67561;s:12:\"delete-68323\";i:67562;s:12:\"delete-68324\";i:67563;s:12:\"delete-68325\";i:67564;s:12:\"delete-68328\";i:67565;s:12:\"delete-68329\";i:67566;s:12:\"delete-68321\";i:67567;s:12:\"delete-68322\";i:67568;s:12:\"delete-68326\";i:67569;s:12:\"delete-68327\";i:67570;s:12:\"delete-68330\";i:67571;s:12:\"delete-68333\";i:67572;s:12:\"delete-68334\";i:67573;s:12:\"delete-68331\";i:67574;s:12:\"delete-68332\";i:67575;s:12:\"delete-68335\";i:67576;s:12:\"delete-68338\";i:67577;s:12:\"delete-68339\";i:67578;s:12:\"delete-68336\";i:67579;s:12:\"delete-68337\";i:67580;s:12:\"delete-68340\";i:67581;s:12:\"delete-68343\";i:67582;s:12:\"delete-68344\";i:67583;s:12:\"delete-68341\";i:67584;s:12:\"delete-68342\";i:67585;s:12:\"delete-68345\";i:67586;s:12:\"delete-68348\";i:67587;s:12:\"delete-68349\";i:67588;s:12:\"delete-68346\";i:67589;s:12:\"delete-68347\";i:67590;s:12:\"delete-68350\";i:67591;s:12:\"delete-68353\";i:67592;s:12:\"delete-68354\";i:67593;s:12:\"delete-68351\";i:67594;s:12:\"delete-68352\";i:67595;s:12:\"delete-68355\";i:67596;s:12:\"delete-68358\";i:67597;s:12:\"delete-68359\";i:67598;s:12:\"delete-68356\";i:67599;s:12:\"delete-68357\";i:67600;s:12:\"delete-68360\";i:67601;s:12:\"delete-68363\";i:67602;s:12:\"delete-68364\";i:67603;s:12:\"delete-68361\";i:67604;s:12:\"delete-68362\";i:67605;s:12:\"delete-68365\";i:67606;s:12:\"delete-68368\";i:67607;s:12:\"delete-68369\";i:67608;s:12:\"delete-68366\";i:67609;s:12:\"delete-68367\";i:67610;s:12:\"delete-68370\";i:67611;s:12:\"delete-68371\";i:67612;s:12:\"delete-68372\";i:67613;s:12:\"delete-68373\";i:67614;s:12:\"delete-68374\";i:67615;s:12:\"delete-68375\";i:67616;s:12:\"delete-68378\";i:67617;s:12:\"delete-68379\";i:67618;s:12:\"delete-68376\";i:67619;s:12:\"delete-68377\";i:67620;s:12:\"delete-68380\";i:67621;s:12:\"delete-68383\";i:67622;s:12:\"delete-68384\";i:67623;s:12:\"delete-68381\";i:67624;s:12:\"delete-68382\";i:67625;s:12:\"delete-68385\";i:67626;s:12:\"delete-68388\";i:67627;s:12:\"delete-68389\";i:67628;s:12:\"delete-68386\";i:67629;s:12:\"delete-68387\";i:67630;s:12:\"delete-68390\";i:67631;s:12:\"delete-68393\";i:67632;s:12:\"delete-68394\";i:67633;s:12:\"delete-68391\";i:67634;s:12:\"delete-68392\";i:67635;s:12:\"delete-68395\";i:67636;s:12:\"delete-68398\";i:67637;s:12:\"delete-68399\";i:67638;s:12:\"delete-68396\";i:67639;s:12:\"delete-68397\";i:67640;s:12:\"delete-68400\";i:67641;s:12:\"delete-68403\";i:67642;s:12:\"delete-68404\";i:67643;s:12:\"delete-68401\";i:67644;s:12:\"delete-68402\";i:67645;s:12:\"delete-68405\";i:67646;s:12:\"delete-68408\";i:67647;s:12:\"delete-68409\";i:67648;s:12:\"delete-68406\";i:67649;s:12:\"delete-68407\";i:67650;s:12:\"delete-68410\";i:67651;s:12:\"delete-68413\";i:67652;s:12:\"delete-68414\";i:67653;s:12:\"delete-68411\";i:67654;s:12:\"delete-68412\";i:67655;s:12:\"delete-68415\";i:67656;s:12:\"delete-68418\";i:67657;s:12:\"delete-68419\";i:67658;s:12:\"delete-68416\";i:67659;s:12:\"delete-68417\";i:67660;s:12:\"delete-68420\";i:67661;s:12:\"delete-68423\";i:67662;s:12:\"delete-68421\";i:67663;s:12:\"delete-68422\";i:67664;s:12:\"delete-68424\";i:67665;s:12:\"delete-68425\";i:67666;s:12:\"delete-68428\";i:67667;s:12:\"delete-68429\";i:67668;s:12:\"delete-68426\";i:67669;s:12:\"delete-68427\";i:67670;s:12:\"delete-68430\";i:67671;s:12:\"delete-68433\";i:67672;s:12:\"delete-68434\";i:67673;s:12:\"delete-68431\";i:67674;s:12:\"delete-68432\";i:67675;s:12:\"delete-68435\";i:67676;s:12:\"delete-68438\";i:67677;s:12:\"delete-68439\";i:67678;s:12:\"delete-68436\";i:67679;s:12:\"delete-68437\";i:67680;s:12:\"delete-68440\";i:67681;s:12:\"delete-68443\";i:67682;s:12:\"delete-68444\";i:67683;s:12:\"delete-68441\";i:67684;s:12:\"delete-68442\";i:67685;s:12:\"delete-68445\";i:67686;s:12:\"delete-68448\";i:67687;s:12:\"delete-68449\";i:67688;s:12:\"delete-68446\";i:67689;s:12:\"delete-68447\";i:67690;s:12:\"delete-68450\";i:67691;s:12:\"delete-68453\";i:67692;s:12:\"delete-68454\";i:67693;s:12:\"delete-68451\";i:67694;s:12:\"delete-68452\";i:67695;s:12:\"delete-68455\";i:67696;s:12:\"delete-68458\";i:67697;s:12:\"delete-68459\";i:67698;s:12:\"delete-68456\";i:67699;s:12:\"delete-68457\";i:67700;s:12:\"delete-68460\";i:67701;s:12:\"delete-68463\";i:67702;s:12:\"delete-68464\";i:67703;s:12:\"delete-68461\";i:67704;s:12:\"delete-68462\";i:67705;s:12:\"delete-68465\";i:67706;s:12:\"delete-68466\";i:67707;s:12:\"delete-68467\";i:67708;s:12:\"delete-68468\";i:67709;s:12:\"delete-68469\";i:67710;s:12:\"delete-68470\";i:67711;s:12:\"delete-68473\";i:67712;s:12:\"delete-68474\";i:67713;s:12:\"delete-68471\";i:67714;s:12:\"delete-68472\";i:67715;s:12:\"delete-68475\";i:67716;s:12:\"delete-68478\";i:67717;s:12:\"delete-68476\";i:67718;s:12:\"delete-68477\";i:67719;s:12:\"delete-68479\";i:67720;s:12:\"delete-68480\";i:67721;s:12:\"delete-68483\";i:67722;s:12:\"delete-68484\";i:67723;s:12:\"delete-68481\";i:67724;s:12:\"delete-68482\";i:67725;s:12:\"delete-68485\";i:67726;s:12:\"delete-68488\";i:67727;s:12:\"delete-68489\";i:67728;s:12:\"delete-68486\";i:67729;s:12:\"delete-68487\";i:67730;s:12:\"delete-68490\";i:67731;s:12:\"delete-68493\";i:67732;s:12:\"delete-68494\";i:67733;s:12:\"delete-68491\";i:67734;s:12:\"delete-68492\";i:67735;s:12:\"delete-68495\";i:67736;s:12:\"delete-68498\";i:67737;s:12:\"delete-68499\";i:67738;s:12:\"delete-68496\";i:67739;s:12:\"delete-68497\";i:67740;s:12:\"delete-68501\";i:67741;s:12:\"delete-68502\";i:67742;s:12:\"delete-68500\";i:67743;s:12:\"delete-68503\";i:67744;s:12:\"delete-68504\";i:67745;s:12:\"delete-68505\";i:67746;s:12:\"delete-68508\";i:67747;s:12:\"delete-68506\";i:67748;s:12:\"delete-68507\";i:67749;s:12:\"delete-68509\";i:67750;s:12:\"delete-68510\";i:67751;s:12:\"delete-68513\";i:67752;s:12:\"delete-68514\";i:67753;s:12:\"delete-68511\";i:67754;s:12:\"delete-68512\";i:67755;s:12:\"delete-68515\";i:67756;s:12:\"delete-68518\";i:67757;s:12:\"delete-68516\";i:67758;s:12:\"delete-68517\";i:67759;s:12:\"delete-68519\";i:67760;s:12:\"delete-68522\";i:67761;s:12:\"delete-68523\";i:67762;s:12:\"delete-68520\";i:67763;s:12:\"delete-68521\";i:67764;s:12:\"delete-68524\";i:67765;s:12:\"delete-68527\";i:67766;s:12:\"delete-68528\";i:67767;s:12:\"delete-68525\";i:67768;s:12:\"delete-68526\";i:67769;s:12:\"delete-68529\";i:67770;s:12:\"delete-68532\";i:67771;s:12:\"delete-68533\";i:67772;s:12:\"delete-68530\";i:67773;s:12:\"delete-68531\";i:67774;s:12:\"delete-68534\";i:67775;s:12:\"delete-68537\";i:67776;s:12:\"delete-68538\";i:67777;s:12:\"delete-68535\";i:67778;s:12:\"delete-68536\";i:67779;s:12:\"delete-68539\";i:67780;s:12:\"delete-68542\";i:67781;s:12:\"delete-68543\";i:67782;s:12:\"delete-68540\";i:67783;s:12:\"delete-68541\";i:67784;s:12:\"delete-68544\";i:67785;s:12:\"delete-68547\";i:67786;s:12:\"delete-68545\";i:67787;s:12:\"delete-68546\";i:67788;s:12:\"delete-68548\";i:67789;s:12:\"delete-68549\";i:67790;s:12:\"delete-68552\";i:67791;s:12:\"delete-68553\";i:67792;s:12:\"delete-68550\";i:67793;s:12:\"delete-68551\";i:67794;s:12:\"delete-68554\";i:67795;s:12:\"delete-68557\";i:67796;s:12:\"delete-68558\";i:67797;s:12:\"delete-68555\";i:67798;s:12:\"delete-68556\";i:67799;s:12:\"delete-68559\";i:67800;s:12:\"delete-68562\";i:67801;s:12:\"delete-68563\";i:67802;s:12:\"delete-68560\";i:67803;s:12:\"delete-68561\";i:67804;s:12:\"delete-68564\";i:67805;s:12:\"delete-68567\";i:67806;s:12:\"delete-68568\";i:67807;s:12:\"delete-68565\";i:67808;s:12:\"delete-68566\";i:67809;s:12:\"delete-68569\";i:67810;s:12:\"delete-68572\";i:67811;s:12:\"delete-68573\";i:67812;s:12:\"delete-68570\";i:67813;s:12:\"delete-68571\";i:67814;s:12:\"delete-68574\";i:67815;s:12:\"delete-68577\";i:67816;s:12:\"delete-68578\";i:67817;s:12:\"delete-68575\";i:67818;s:12:\"delete-68576\";i:67819;s:12:\"delete-68579\";i:67820;s:12:\"delete-68582\";i:67821;s:12:\"delete-68583\";i:67822;s:12:\"delete-68580\";i:67823;s:12:\"delete-68581\";i:67824;s:12:\"delete-68584\";i:67825;s:12:\"delete-68587\";i:67826;s:12:\"delete-68585\";i:67827;s:12:\"delete-68586\";i:67828;s:12:\"delete-68588\";i:67829;s:12:\"delete-68589\";i:67830;s:12:\"delete-68592\";i:67831;s:12:\"delete-68590\";i:67832;s:12:\"delete-68591\";i:67833;s:12:\"delete-68593\";i:67834;s:12:\"delete-68594\";i:67835;s:12:\"delete-68597\";i:67836;s:12:\"delete-68598\";i:67837;s:12:\"delete-68595\";i:67838;s:12:\"delete-68596\";i:67839;s:12:\"delete-68599\";i:67840;s:12:\"delete-68602\";i:67841;s:12:\"delete-68600\";i:67842;s:12:\"delete-68601\";i:67843;s:12:\"delete-68603\";i:67844;s:12:\"delete-68604\";i:67845;s:12:\"delete-68607\";i:67846;s:12:\"delete-68608\";i:67847;s:12:\"delete-68605\";i:67848;s:12:\"delete-68606\";i:67849;s:12:\"delete-68609\";i:67850;s:12:\"delete-68612\";i:67851;s:12:\"delete-68613\";i:67852;s:12:\"delete-68610\";i:67853;s:12:\"delete-68611\";i:67854;s:12:\"delete-68614\";i:67855;s:12:\"delete-68617\";i:67856;s:12:\"delete-68615\";i:67857;s:12:\"delete-68616\";i:67858;s:12:\"delete-68618\";i:67859;s:12:\"delete-68619\";i:67860;s:12:\"delete-68622\";i:67861;s:12:\"delete-68623\";i:67862;s:12:\"delete-68620\";i:67863;s:12:\"delete-68621\";i:67864;s:12:\"delete-68624\";i:67865;s:12:\"delete-68627\";i:67866;s:12:\"delete-68628\";i:67867;s:12:\"delete-68625\";i:67868;s:12:\"delete-68626\";i:67869;s:12:\"delete-68629\";i:67870;s:12:\"delete-68632\";i:67871;s:12:\"delete-68633\";i:67872;s:12:\"delete-68630\";i:67873;s:12:\"delete-68631\";i:67874;s:12:\"delete-68634\";i:67875;s:12:\"delete-68637\";i:67876;s:12:\"delete-68635\";i:67877;s:12:\"delete-68636\";i:67878;s:12:\"delete-68638\";i:67879;s:12:\"delete-68639\";i:67880;s:12:\"delete-68642\";i:67881;s:12:\"delete-68640\";i:67882;s:12:\"delete-68641\";i:67883;s:12:\"delete-68643\";i:67884;s:12:\"delete-68644\";i:67885;s:12:\"delete-68647\";i:67886;s:12:\"delete-68648\";i:67887;s:12:\"delete-68645\";i:67888;s:12:\"delete-68646\";i:67889;s:12:\"delete-68649\";i:67890;s:12:\"delete-68652\";i:67891;s:12:\"delete-68653\";i:67892;s:12:\"delete-68650\";i:67893;s:12:\"delete-68651\";i:67894;s:12:\"delete-68654\";i:67895;s:12:\"delete-68655\";i:67896;s:12:\"delete-68656\";i:67897;s:12:\"delete-68657\";i:67898;s:12:\"delete-68658\";i:67899;s:12:\"delete-68659\";i:67900;s:12:\"delete-68662\";i:67901;s:12:\"delete-68663\";i:67902;s:12:\"delete-68660\";i:67903;s:12:\"delete-68661\";i:67904;s:12:\"delete-68664\";i:67905;s:12:\"delete-68667\";i:67906;s:12:\"delete-68668\";i:67907;s:12:\"delete-68665\";i:67908;s:12:\"delete-68666\";i:67909;s:12:\"delete-68669\";i:67910;s:12:\"delete-68672\";i:67911;s:12:\"delete-68673\";i:67912;s:12:\"delete-68670\";i:67913;s:12:\"delete-68671\";i:67914;s:12:\"delete-68674\";i:67915;s:12:\"delete-68677\";i:67916;s:12:\"delete-68678\";i:67917;s:12:\"delete-68675\";i:67918;s:12:\"delete-68676\";i:67919;s:12:\"delete-68679\";i:67920;s:12:\"delete-68682\";i:67921;s:12:\"delete-68683\";i:67922;s:12:\"delete-68680\";i:67923;s:12:\"delete-68681\";i:67924;s:12:\"delete-68684\";i:67925;s:12:\"delete-68687\";i:67926;s:12:\"delete-68688\";i:67927;s:12:\"delete-68685\";i:67928;s:12:\"delete-68686\";i:67929;s:12:\"delete-68689\";i:67930;s:12:\"delete-68692\";i:67931;s:12:\"delete-68690\";i:67932;s:12:\"delete-68691\";i:67933;s:12:\"delete-68693\";i:67934;s:12:\"delete-68694\";i:67935;s:12:\"delete-68697\";i:67936;s:12:\"delete-68698\";i:67937;s:12:\"delete-68695\";i:67938;s:12:\"delete-68696\";i:67939;s:12:\"delete-68699\";i:67940;s:12:\"delete-68702\";i:67941;s:12:\"delete-68700\";i:67942;s:12:\"delete-68701\";i:67943;s:12:\"delete-68703\";i:67944;s:12:\"delete-68704\";i:67945;s:12:\"delete-68707\";i:67946;s:12:\"delete-68708\";i:67947;s:12:\"delete-68705\";i:67948;s:12:\"delete-68706\";i:67949;s:12:\"delete-68709\";i:67950;s:12:\"delete-68710\";i:67951;s:12:\"delete-68711\";i:67952;s:12:\"delete-68712\";i:67953;s:12:\"delete-68713\";i:67954;s:12:\"delete-68714\";i:67955;s:12:\"delete-68717\";i:67956;s:12:\"delete-68718\";i:67957;s:12:\"delete-68715\";i:67958;s:12:\"delete-68716\";i:67959;s:12:\"delete-68719\";i:67960;s:12:\"delete-68722\";i:67961;s:12:\"delete-68723\";i:67962;s:12:\"delete-68720\";i:67963;s:12:\"delete-68721\";i:67964;s:12:\"delete-68724\";i:67965;s:12:\"delete-68727\";i:67966;s:12:\"delete-68728\";i:67967;s:12:\"delete-68725\";i:67968;s:12:\"delete-68726\";i:67969;s:12:\"delete-68729\";i:67970;s:12:\"delete-68732\";i:67971;s:12:\"delete-68733\";i:67972;s:12:\"delete-68730\";i:67973;s:12:\"delete-68731\";i:67974;s:12:\"delete-68734\";i:67975;s:12:\"delete-68737\";i:67976;s:12:\"delete-68738\";i:67977;s:12:\"delete-68735\";i:67978;s:12:\"delete-68736\";i:67979;s:12:\"delete-68739\";i:67980;s:12:\"delete-68742\";i:67981;s:12:\"delete-68743\";i:67982;s:12:\"delete-68740\";i:67983;s:12:\"delete-68741\";i:67984;s:12:\"delete-68744\";i:67985;s:12:\"delete-68747\";i:67986;s:12:\"delete-68748\";i:67987;s:12:\"delete-68745\";i:67988;s:12:\"delete-68746\";i:67989;s:12:\"delete-68749\";i:67990;s:12:\"delete-68752\";i:67991;s:12:\"delete-68750\";i:67992;s:12:\"delete-68751\";i:67993;s:12:\"delete-68753\";i:67994;s:12:\"delete-68754\";i:67995;s:12:\"delete-68757\";i:67996;s:12:\"delete-68758\";i:67997;s:12:\"delete-68755\";i:67998;s:12:\"delete-68756\";i:67999;s:12:\"delete-68759\";i:68000;s:12:\"delete-68762\";i:68001;s:12:\"delete-68763\";i:68002;s:12:\"delete-68760\";i:68003;s:12:\"delete-68761\";i:68004;s:12:\"delete-68764\";i:68005;s:12:\"delete-68767\";i:68006;s:12:\"delete-68768\";i:68007;s:12:\"delete-68765\";i:68008;s:12:\"delete-68766\";i:68009;s:12:\"delete-68769\";i:68010;s:12:\"delete-68772\";i:68011;s:12:\"delete-68770\";i:68012;s:12:\"delete-68771\";i:68013;s:12:\"delete-68773\";i:68014;s:12:\"delete-68774\";i:68015;s:12:\"delete-68777\";i:68016;s:12:\"delete-68775\";i:68017;s:12:\"delete-68776\";i:68018;s:12:\"delete-68778\";i:68019;s:12:\"delete-68779\";i:68020;s:12:\"delete-68782\";i:68021;s:12:\"delete-68783\";i:68022;s:12:\"delete-68780\";i:68023;s:12:\"delete-68781\";i:68024;s:12:\"delete-68784\";i:68025;s:12:\"delete-68787\";i:68026;s:12:\"delete-68788\";i:68027;s:12:\"delete-68785\";i:68028;s:12:\"delete-68786\";i:68029;s:12:\"delete-68789\";i:68030;s:12:\"delete-68792\";i:68031;s:12:\"delete-68790\";i:68032;s:12:\"delete-68791\";i:68033;s:12:\"delete-68793\";i:68034;s:12:\"delete-68794\";i:68035;s:12:\"delete-68797\";i:68036;s:12:\"delete-68798\";i:68037;s:12:\"delete-68795\";i:68038;s:12:\"delete-68796\";i:68039;s:12:\"delete-68799\";i:68040;s:12:\"delete-68802\";i:68041;s:12:\"delete-68803\";i:68042;s:12:\"delete-68800\";i:68043;s:12:\"delete-68801\";i:68044;s:12:\"delete-68804\";i:68045;s:12:\"delete-68807\";i:68046;s:12:\"delete-68808\";i:68047;s:12:\"delete-68805\";i:68048;s:12:\"delete-68806\";i:68049;s:12:\"delete-68809\";i:68050;s:12:\"delete-68812\";i:68051;s:12:\"delete-68810\";i:68052;s:12:\"delete-68811\";i:68053;s:12:\"delete-68813\";i:68054;s:12:\"delete-68814\";i:68055;s:12:\"delete-68817\";i:68056;s:12:\"delete-68818\";i:68057;s:12:\"delete-68815\";i:68058;s:12:\"delete-68816\";i:68059;s:12:\"delete-68819\";i:68060;s:12:\"delete-68822\";i:68061;s:12:\"delete-68823\";i:68062;s:12:\"delete-68820\";i:68063;s:12:\"delete-68821\";i:68064;s:12:\"delete-68824\";i:68065;s:12:\"delete-68827\";i:68066;s:12:\"delete-68828\";i:68067;s:12:\"delete-68825\";i:68068;s:12:\"delete-68826\";i:68069;s:12:\"delete-68829\";i:68070;s:12:\"delete-68832\";i:68071;s:12:\"delete-68833\";i:68072;s:12:\"delete-68830\";i:68073;s:12:\"delete-68831\";i:68074;s:12:\"delete-68834\";i:68075;s:12:\"delete-68837\";i:68076;s:12:\"delete-68838\";i:68077;s:12:\"delete-68835\";i:68078;s:12:\"delete-68836\";i:68079;s:12:\"delete-68839\";i:68080;s:12:\"delete-68842\";i:68081;s:12:\"delete-68843\";i:68082;s:12:\"delete-68840\";i:68083;s:12:\"delete-68841\";i:68084;s:12:\"delete-68844\";i:68085;s:12:\"delete-68847\";i:68086;s:12:\"delete-68848\";i:68087;s:12:\"delete-68845\";i:68088;s:12:\"delete-68846\";i:68089;s:12:\"delete-68849\";i:68090;s:12:\"delete-68852\";i:68091;s:12:\"delete-68853\";i:68092;s:12:\"delete-68850\";i:68093;s:12:\"delete-68851\";i:68094;s:12:\"delete-68854\";i:68095;s:12:\"delete-68857\";i:68096;s:12:\"delete-68855\";i:68097;s:12:\"delete-68856\";i:68098;s:12:\"delete-68858\";i:68099;s:12:\"delete-68859\";i:68100;s:12:\"delete-68862\";i:68101;s:12:\"delete-68863\";i:68102;s:12:\"delete-68860\";i:68103;s:12:\"delete-68861\";i:68104;s:12:\"delete-68864\";i:68105;s:12:\"delete-68867\";i:68106;s:12:\"delete-68868\";i:68107;s:12:\"delete-68865\";i:68108;s:12:\"delete-68866\";i:68109;s:12:\"delete-68869\";i:68110;s:12:\"delete-68872\";i:68111;s:12:\"delete-68870\";i:68112;s:12:\"delete-68871\";i:68113;s:12:\"delete-68873\";i:68114;s:12:\"delete-68874\";i:68115;s:12:\"delete-68877\";i:68116;s:12:\"delete-68878\";i:68117;s:12:\"delete-68875\";i:68118;s:12:\"delete-68876\";i:68119;s:12:\"delete-68879\";i:68120;s:12:\"delete-68882\";i:68121;s:12:\"delete-68883\";i:68122;s:12:\"delete-68880\";i:68123;s:12:\"delete-68881\";i:68124;s:12:\"delete-68884\";i:68125;s:12:\"delete-68887\";i:68126;s:12:\"delete-68888\";i:68127;s:12:\"delete-68885\";i:68128;s:12:\"delete-68886\";i:68129;s:12:\"delete-68889\";i:68130;s:12:\"delete-68892\";i:68131;s:12:\"delete-68893\";i:68132;s:12:\"delete-68890\";i:68133;s:12:\"delete-68891\";i:68134;s:12:\"delete-68894\";i:68135;s:12:\"delete-68897\";i:68136;s:12:\"delete-68898\";i:68137;s:12:\"delete-68895\";i:68138;s:12:\"delete-68896\";i:68139;s:12:\"delete-68899\";i:68140;s:12:\"delete-68902\";i:68141;s:12:\"delete-68900\";i:68142;s:12:\"delete-68901\";i:68143;s:12:\"delete-68903\";i:68144;s:12:\"delete-68904\";i:68145;s:12:\"delete-68907\";i:68146;s:12:\"delete-68908\";i:68147;s:12:\"delete-68905\";i:68148;s:12:\"delete-68906\";i:68149;s:12:\"delete-68909\";i:68150;s:12:\"delete-68912\";i:68151;s:12:\"delete-68913\";i:68152;s:12:\"delete-68910\";i:68153;s:12:\"delete-68911\";i:68154;s:12:\"delete-68914\";i:68155;s:12:\"delete-68917\";i:68156;s:12:\"delete-68918\";i:68157;s:12:\"delete-68915\";i:68158;s:12:\"delete-68916\";i:68159;s:12:\"delete-68919\";i:68160;s:12:\"delete-68922\";i:68161;s:12:\"delete-68923\";i:68162;s:12:\"delete-68920\";i:68163;s:12:\"delete-68921\";i:68164;s:12:\"delete-68924\";i:68165;s:12:\"delete-68927\";i:68166;s:12:\"delete-68928\";i:68167;s:12:\"delete-68925\";i:68168;s:12:\"delete-68926\";i:68169;s:12:\"delete-68929\";i:68170;s:12:\"delete-68932\";i:68171;s:12:\"delete-68933\";i:68172;s:12:\"delete-68930\";i:68173;s:12:\"delete-68931\";i:68174;s:12:\"delete-68934\";i:68175;s:12:\"delete-68937\";i:68176;s:12:\"delete-68938\";i:68177;s:12:\"delete-68935\";i:68178;s:12:\"delete-68936\";i:68179;s:12:\"delete-68939\";i:68180;s:12:\"delete-68942\";i:68181;s:12:\"delete-68943\";i:68182;s:12:\"delete-68940\";i:68183;s:12:\"delete-68941\";i:68184;s:12:\"delete-68944\";i:68185;s:12:\"delete-68947\";i:68186;s:12:\"delete-68948\";i:68187;s:12:\"delete-68945\";i:68188;s:12:\"delete-68946\";i:68189;s:12:\"delete-68949\";i:68190;s:12:\"delete-68952\";i:68191;s:12:\"delete-68950\";i:68192;s:12:\"delete-68951\";i:68193;s:12:\"delete-68953\";i:68194;s:12:\"delete-68954\";i:68195;s:12:\"delete-68957\";i:68196;s:12:\"delete-68958\";i:68197;s:12:\"delete-68955\";i:68198;s:12:\"delete-68956\";i:68199;s:12:\"delete-68959\";i:68200;s:12:\"delete-68962\";i:68201;s:12:\"delete-68963\";i:68202;s:12:\"delete-68960\";i:68203;s:12:\"delete-68961\";i:68204;s:12:\"delete-68964\";i:68205;s:12:\"delete-68967\";i:68206;s:12:\"delete-68968\";i:68207;s:12:\"delete-68965\";i:68208;s:12:\"delete-68966\";i:68209;s:12:\"delete-68969\";i:68210;s:12:\"delete-68972\";i:68211;s:12:\"delete-68973\";i:68212;s:12:\"delete-68974\";i:68213;s:12:\"delete-68977\";i:68214;s:12:\"delete-68978\";i:68215;s:12:\"delete-68970\";i:68216;s:12:\"delete-68971\";i:68217;s:12:\"delete-68975\";i:68218;s:12:\"delete-68976\";i:68219;s:12:\"delete-68979\";i:68220;s:12:\"delete-68982\";i:68221;s:12:\"delete-68983\";i:68222;s:12:\"delete-68980\";i:68223;s:12:\"delete-68981\";i:68224;s:12:\"delete-68984\";i:68225;s:12:\"delete-68987\";i:68226;s:12:\"delete-68988\";i:68227;s:12:\"delete-68985\";i:68228;s:12:\"delete-68986\";i:68229;s:12:\"delete-68989\";i:68230;s:12:\"delete-68992\";i:68231;s:12:\"delete-68993\";i:68232;s:12:\"delete-68990\";i:68233;s:12:\"delete-68991\";i:68234;s:12:\"delete-68994\";i:68235;s:12:\"delete-68997\";i:68236;s:12:\"delete-68995\";i:68237;s:12:\"delete-68996\";i:68238;s:12:\"delete-68998\";i:68239;s:12:\"delete-68999\";i:68240;s:12:\"delete-69002\";i:68241;s:12:\"delete-69003\";i:68242;s:12:\"delete-69000\";i:68243;s:12:\"delete-69001\";i:68244;s:12:\"delete-69004\";i:68245;s:12:\"delete-69007\";i:68246;s:12:\"delete-69005\";i:68247;s:12:\"delete-69006\";i:68248;s:12:\"delete-69008\";i:68249;s:12:\"delete-69009\";i:68250;s:12:\"delete-69012\";i:68251;s:12:\"delete-69013\";i:68252;s:12:\"delete-69010\";i:68253;s:12:\"delete-69011\";i:68254;s:12:\"delete-69014\";i:68255;s:12:\"delete-69017\";i:68256;s:12:\"delete-69018\";i:68257;s:12:\"delete-69015\";i:68258;s:12:\"delete-69016\";i:68259;s:12:\"delete-69019\";i:68260;s:12:\"delete-69022\";i:68261;s:12:\"delete-69023\";i:68262;s:12:\"delete-69020\";i:68263;s:12:\"delete-69021\";i:68264;s:12:\"delete-69024\";i:68265;s:12:\"delete-69027\";i:68266;s:12:\"delete-69028\";i:68267;s:12:\"delete-69025\";i:68268;s:12:\"delete-69026\";i:68269;s:12:\"delete-69029\";i:68270;s:12:\"delete-69032\";i:68271;s:12:\"delete-69033\";i:68272;s:12:\"delete-69030\";i:68273;s:12:\"delete-69031\";i:68274;s:12:\"delete-69034\";i:68275;s:12:\"delete-69037\";i:68276;s:12:\"delete-69038\";i:68277;s:12:\"delete-69035\";i:68278;s:12:\"delete-69036\";i:68279;s:12:\"delete-69039\";i:68280;s:12:\"delete-69042\";i:68281;s:12:\"delete-69040\";i:68282;s:12:\"delete-69041\";i:68283;s:12:\"delete-69043\";i:68284;s:12:\"delete-69044\";i:68285;s:12:\"delete-69045\";i:68286;s:12:\"delete-69046\";i:68287;s:12:\"delete-69047\";i:68288;s:12:\"delete-69048\";i:68289;s:12:\"delete-69049\";i:68290;s:12:\"delete-69052\";i:68291;s:12:\"delete-69050\";i:68292;s:12:\"delete-69051\";i:68293;s:12:\"delete-69053\";i:68294;s:12:\"delete-69054\";i:68295;s:12:\"delete-69057\";i:68296;s:12:\"delete-69058\";i:68297;s:12:\"delete-69055\";i:68298;s:12:\"delete-69056\";i:68299;s:12:\"delete-69059\";i:68300;s:12:\"delete-69062\";i:68301;s:12:\"delete-69063\";i:68302;s:12:\"delete-69060\";i:68303;s:12:\"delete-69061\";i:68304;s:12:\"delete-69064\";i:68305;s:12:\"delete-69067\";i:68306;s:12:\"delete-69068\";i:68307;s:12:\"delete-69065\";i:68308;s:12:\"delete-69066\";i:68309;s:12:\"delete-69069\";i:68310;s:12:\"delete-69072\";i:68311;s:12:\"delete-69073\";i:68312;s:12:\"delete-69070\";i:68313;s:12:\"delete-69071\";i:68314;s:12:\"delete-69074\";i:68315;s:12:\"delete-69077\";i:68316;s:12:\"delete-69078\";i:68317;s:12:\"delete-69075\";i:68318;s:12:\"delete-69076\";i:68319;s:12:\"delete-69079\";i:68320;s:12:\"delete-69082\";i:68321;s:12:\"delete-69083\";i:68322;s:12:\"delete-69080\";i:68323;s:12:\"delete-69081\";i:68324;s:12:\"delete-69084\";i:68325;s:12:\"delete-69087\";i:68326;s:12:\"delete-69088\";i:68327;s:12:\"delete-69085\";i:68328;s:12:\"delete-69086\";i:68329;s:12:\"delete-69089\";i:68330;s:12:\"delete-69092\";i:68331;s:12:\"delete-69093\";i:68332;s:12:\"delete-69090\";i:68333;s:12:\"delete-69091\";i:68334;s:12:\"delete-69094\";i:68335;s:12:\"delete-69097\";i:68336;s:12:\"delete-69098\";i:68337;s:12:\"delete-69095\";i:68338;s:12:\"delete-69096\";i:68339;s:12:\"delete-69099\";i:68340;s:12:\"delete-69102\";i:68341;s:12:\"delete-69103\";i:68342;s:12:\"delete-69100\";i:68343;s:12:\"delete-69101\";i:68344;s:12:\"delete-69104\";i:68345;s:12:\"delete-69107\";i:68346;s:12:\"delete-69108\";i:68347;s:12:\"delete-69105\";i:68348;s:12:\"delete-69106\";i:68349;s:12:\"delete-69109\";i:68350;s:12:\"delete-69112\";i:68351;s:12:\"delete-69113\";i:68352;s:12:\"delete-69110\";i:68353;s:12:\"delete-69111\";i:68354;s:12:\"delete-69114\";i:68355;s:12:\"delete-69115\";i:68356;s:12:\"delete-69116\";i:68357;s:12:\"delete-69119\";i:68358;s:12:\"delete-69120\";i:68359;s:12:\"delete-69117\";i:68360;s:12:\"delete-69118\";i:68361;s:12:\"delete-69121\";i:68362;s:12:\"delete-69124\";i:68363;s:12:\"delete-69125\";i:68364;s:12:\"delete-69122\";i:68365;s:12:\"delete-69123\";i:68366;s:12:\"delete-69126\";i:68367;s:12:\"delete-69129\";i:68368;s:12:\"delete-69130\";i:68369;s:12:\"delete-69127\";i:68370;s:12:\"delete-69128\";i:68371;s:12:\"delete-69131\";i:68372;s:12:\"delete-69134\";i:68373;s:12:\"delete-69135\";i:68374;s:12:\"delete-69132\";i:68375;s:12:\"delete-69133\";i:68376;s:12:\"delete-69136\";i:68377;s:12:\"delete-69139\";i:68378;s:12:\"delete-69137\";i:68379;s:12:\"delete-69138\";i:68380;s:12:\"delete-69140\";i:68381;s:12:\"delete-69143\";i:68382;s:12:\"delete-69144\";i:68383;s:12:\"delete-69141\";i:68384;s:12:\"delete-69142\";i:68385;s:12:\"delete-69145\";i:68386;s:12:\"delete-69148\";i:68387;s:12:\"delete-69149\";i:68388;s:12:\"delete-69146\";i:68389;s:12:\"delete-69147\";i:68390;s:12:\"delete-69150\";i:68391;s:12:\"delete-69153\";i:68392;s:12:\"delete-69154\";i:68393;s:12:\"delete-69151\";i:68394;s:12:\"delete-69152\";i:68395;s:12:\"delete-69155\";i:68396;s:12:\"delete-69158\";i:68397;s:12:\"delete-69159\";i:68398;s:12:\"delete-69156\";i:68399;s:12:\"delete-69157\";i:68400;s:12:\"delete-69160\";i:68401;s:12:\"delete-69163\";i:68402;s:12:\"delete-69164\";i:68403;s:12:\"delete-69161\";i:68404;s:12:\"delete-69162\";i:68405;s:12:\"delete-69165\";i:68406;s:12:\"delete-69168\";i:68407;s:12:\"delete-69169\";i:68408;s:12:\"delete-69166\";i:68409;s:12:\"delete-69167\";i:68410;s:12:\"delete-69170\";i:68411;s:12:\"delete-69173\";i:68412;s:12:\"delete-69174\";i:68413;s:12:\"delete-69171\";i:68414;s:12:\"delete-69172\";i:68415;s:12:\"delete-69175\";i:68416;s:12:\"delete-69178\";i:68417;s:12:\"delete-69179\";i:68418;s:12:\"delete-69176\";i:68419;s:12:\"delete-69177\";i:68420;s:12:\"delete-69180\";i:68421;s:12:\"delete-69183\";i:68422;s:12:\"delete-69184\";i:68423;s:12:\"delete-69181\";i:68424;s:12:\"delete-69182\";i:68425;s:12:\"delete-69185\";i:68426;s:12:\"delete-69188\";i:68427;s:12:\"delete-69189\";i:68428;s:12:\"delete-69186\";i:68429;s:12:\"delete-69187\";i:68430;s:12:\"delete-69190\";i:68431;s:12:\"delete-69193\";i:68432;s:12:\"delete-69194\";i:68433;s:12:\"delete-69191\";i:68434;s:12:\"delete-69192\";i:68435;s:12:\"delete-69195\";i:68436;s:12:\"delete-69198\";i:68437;s:12:\"delete-69199\";i:68438;s:12:\"delete-69196\";i:68439;s:12:\"delete-69197\";i:68440;s:12:\"delete-69200\";i:68441;s:12:\"delete-69203\";i:68442;s:12:\"delete-69204\";i:68443;s:12:\"delete-69205\";i:68444;s:12:\"delete-69208\";i:68445;s:12:\"delete-69201\";i:68446;s:12:\"delete-69202\";i:68447;s:12:\"delete-69206\";i:68448;s:12:\"delete-69207\";i:68449;s:12:\"delete-69209\";i:68450;s:12:\"delete-69210\";i:68451;s:12:\"delete-69213\";i:68452;s:12:\"delete-69214\";i:68453;s:12:\"delete-69211\";i:68454;s:12:\"delete-69212\";i:68455;s:12:\"delete-69215\";i:68456;s:12:\"delete-69218\";i:68457;s:12:\"delete-69216\";i:68458;s:12:\"delete-69217\";i:68459;s:12:\"delete-69219\";i:68460;s:12:\"delete-69220\";i:68461;s:12:\"delete-69223\";i:68462;s:12:\"delete-69224\";i:68463;s:12:\"delete-69221\";i:68464;s:12:\"delete-69222\";i:68465;s:12:\"delete-69225\";i:68466;s:12:\"delete-69228\";i:68467;s:12:\"delete-69229\";i:68468;s:12:\"delete-69226\";i:68469;s:12:\"delete-69227\";i:68470;s:12:\"delete-69230\";i:68471;s:12:\"delete-69233\";i:68472;s:12:\"delete-69231\";i:68473;s:12:\"delete-69232\";i:68474;s:12:\"delete-69234\";i:68475;s:12:\"delete-69235\";i:68476;s:12:\"delete-69238\";i:68477;s:12:\"delete-69239\";i:68478;s:12:\"delete-69236\";i:68479;s:12:\"delete-69237\";i:68480;s:12:\"delete-69240\";i:68481;s:12:\"delete-69243\";i:68482;s:12:\"delete-69244\";i:68483;s:12:\"delete-69241\";i:68484;s:12:\"delete-69242\";i:68485;s:12:\"delete-69245\";i:68486;s:12:\"delete-69248\";i:68487;s:12:\"delete-69249\";i:68488;s:12:\"delete-69246\";i:68489;s:12:\"delete-69247\";i:68490;s:12:\"delete-69250\";i:68491;s:12:\"delete-69253\";i:68492;s:12:\"delete-69254\";i:68493;s:12:\"delete-69251\";i:68494;s:12:\"delete-69252\";i:68495;s:12:\"delete-69255\";i:68496;s:12:\"delete-69258\";i:68497;s:12:\"delete-69256\";i:68498;s:12:\"delete-69257\";i:68499;s:12:\"delete-69259\";i:68500;s:12:\"delete-69260\";i:68501;s:12:\"delete-69263\";i:68502;s:12:\"delete-69264\";i:68503;s:12:\"delete-69261\";i:68504;s:12:\"delete-69262\";i:68505;s:12:\"delete-69265\";i:68506;s:12:\"delete-69266\";i:68507;s:12:\"delete-69267\";i:68508;s:12:\"delete-69268\";i:68509;s:12:\"delete-69269\";i:68510;s:12:\"delete-69270\";i:68511;s:12:\"delete-69273\";i:68512;s:12:\"delete-69274\";i:68513;s:12:\"delete-69271\";i:68514;s:12:\"delete-69272\";i:68515;s:12:\"delete-69275\";i:68516;s:12:\"delete-69278\";i:68517;s:12:\"delete-69279\";i:68518;s:12:\"delete-69276\";i:68519;s:12:\"delete-69277\";i:68520;s:12:\"delete-69280\";i:68521;s:12:\"delete-69283\";i:68522;s:12:\"delete-69284\";i:68523;s:12:\"delete-69281\";i:68524;s:12:\"delete-69282\";i:68525;s:12:\"delete-69285\";i:68526;s:12:\"delete-69288\";i:68527;s:12:\"delete-69289\";i:68528;s:12:\"delete-69286\";i:68529;s:12:\"delete-69287\";i:68530;s:12:\"delete-69290\";i:68531;s:12:\"delete-69293\";i:68532;s:12:\"delete-69294\";i:68533;s:12:\"delete-69291\";i:68534;s:12:\"delete-69292\";i:68535;s:12:\"delete-69295\";i:68536;s:12:\"delete-69298\";i:68537;s:12:\"delete-69299\";i:68538;s:12:\"delete-69296\";i:68539;s:12:\"delete-69297\";i:68540;s:12:\"delete-69300\";i:68541;s:12:\"delete-69301\";i:68542;s:12:\"delete-69302\";i:68543;s:12:\"delete-69303\";i:68544;s:12:\"delete-69304\";i:68545;s:12:\"delete-69305\";i:68546;s:12:\"delete-69308\";i:68547;s:12:\"delete-69309\";i:68548;s:12:\"delete-69306\";i:68549;s:12:\"delete-69307\";i:68550;s:12:\"delete-69310\";i:68551;s:12:\"delete-69313\";i:68552;s:12:\"delete-69314\";i:68553;s:12:\"delete-69311\";i:68554;s:12:\"delete-69312\";i:68555;s:12:\"delete-69315\";i:68556;s:12:\"delete-69318\";i:68557;s:12:\"delete-69319\";i:68558;s:12:\"delete-69316\";i:68559;s:12:\"delete-69317\";i:68560;s:12:\"delete-69320\";i:68561;s:12:\"delete-69323\";i:68562;s:12:\"delete-69324\";i:68563;s:12:\"delete-69321\";i:68564;s:12:\"delete-69322\";i:68565;s:12:\"delete-69325\";i:68566;s:12:\"delete-69328\";i:68567;s:12:\"delete-69329\";i:68568;s:12:\"delete-69326\";i:68569;s:12:\"delete-69327\";i:68570;s:12:\"delete-69330\";i:68571;s:12:\"delete-69333\";i:68572;s:12:\"delete-69334\";i:68573;s:12:\"delete-69331\";i:68574;s:12:\"delete-69332\";i:68575;s:12:\"delete-69335\";i:68576;s:12:\"delete-69338\";i:68577;s:12:\"delete-69339\";i:68578;s:12:\"delete-69336\";i:68579;s:12:\"delete-69337\";i:68580;s:12:\"delete-69340\";i:68581;s:12:\"delete-69343\";i:68582;s:12:\"delete-69344\";i:68583;s:12:\"delete-69341\";i:68584;s:12:\"delete-69342\";i:68585;s:12:\"delete-69345\";i:68586;s:12:\"delete-69348\";i:68587;s:12:\"delete-69349\";i:68588;s:12:\"delete-69346\";i:68589;s:12:\"delete-69347\";i:68590;s:12:\"delete-69350\";i:68591;s:12:\"delete-69351\";i:68592;s:12:\"delete-69352\";i:68593;s:12:\"delete-69353\";i:68594;s:12:\"delete-69354\";i:68595;s:12:\"delete-69355\";i:68596;s:12:\"delete-69358\";i:68597;s:12:\"delete-69359\";i:68598;s:12:\"delete-69356\";i:68599;s:12:\"delete-69357\";i:68600;s:12:\"delete-69360\";i:68601;s:12:\"delete-69363\";i:68602;s:12:\"delete-69361\";i:68603;s:12:\"delete-69362\";i:68604;s:12:\"delete-69364\";i:68605;s:12:\"delete-69365\";i:68606;s:12:\"delete-69368\";i:68607;s:12:\"delete-69369\";i:68608;s:12:\"delete-69366\";i:68609;s:12:\"delete-69367\";i:68610;s:12:\"delete-69370\";i:68611;s:12:\"delete-69373\";i:68612;s:12:\"delete-69374\";i:68613;s:12:\"delete-69371\";i:68614;s:12:\"delete-69372\";i:68615;s:12:\"delete-69375\";i:68616;s:12:\"delete-69378\";i:68617;s:12:\"delete-69379\";i:68618;s:12:\"delete-69376\";i:68619;s:12:\"delete-69377\";i:68620;s:12:\"delete-69380\";i:68621;s:12:\"delete-69383\";i:68622;s:12:\"delete-69381\";i:68623;s:12:\"delete-69382\";i:68624;s:12:\"delete-69384\";i:68625;s:12:\"delete-69385\";i:68626;s:12:\"delete-69388\";i:68627;s:12:\"delete-69389\";i:68628;s:12:\"delete-69386\";i:68629;s:12:\"delete-69387\";i:68630;s:12:\"delete-69390\";i:68631;s:12:\"delete-69393\";i:68632;s:12:\"delete-69391\";i:68633;s:12:\"delete-69392\";i:68634;s:12:\"delete-69394\";i:68635;s:12:\"delete-69395\";i:68636;s:12:\"delete-69398\";i:68637;s:12:\"delete-69399\";i:68638;s:12:\"delete-69396\";i:68639;s:12:\"delete-69397\";i:68640;s:12:\"delete-69400\";i:68641;s:12:\"delete-69403\";i:68642;s:12:\"delete-69404\";i:68643;s:12:\"delete-69401\";i:68644;s:12:\"delete-69402\";i:68645;s:12:\"delete-69405\";i:68646;s:12:\"delete-69408\";i:68647;s:12:\"delete-69409\";i:68648;s:12:\"delete-69406\";i:68649;s:12:\"delete-69407\";i:68650;s:12:\"delete-69410\";i:68651;s:12:\"delete-69413\";i:68652;s:12:\"delete-69414\";i:68653;s:12:\"delete-69411\";i:68654;s:12:\"delete-69412\";i:68655;s:12:\"delete-69415\";i:68656;s:12:\"delete-69418\";i:68657;s:12:\"delete-69419\";i:68658;s:12:\"delete-69416\";i:68659;s:12:\"delete-69417\";i:68660;s:12:\"delete-69420\";i:68661;s:12:\"delete-69423\";i:68662;s:12:\"delete-69424\";i:68663;s:12:\"delete-69421\";i:68664;s:12:\"delete-69422\";i:68665;s:12:\"delete-69425\";i:68666;s:12:\"delete-69428\";i:68667;s:12:\"delete-69429\";i:68668;s:12:\"delete-69426\";i:68669;s:12:\"delete-69427\";i:68670;s:12:\"delete-69430\";i:68671;s:12:\"delete-69433\";i:68672;s:12:\"delete-69434\";i:68673;s:12:\"delete-69431\";i:68674;s:12:\"delete-69432\";i:68675;s:12:\"delete-69435\";i:68676;s:12:\"delete-69438\";i:68677;s:12:\"delete-69439\";i:68678;s:12:\"delete-69436\";i:68679;s:12:\"delete-69437\";i:68680;s:12:\"delete-69440\";i:68681;s:12:\"delete-69443\";i:68682;s:12:\"delete-69444\";i:68683;s:12:\"delete-69441\";i:68684;s:12:\"delete-69442\";i:68685;s:12:\"delete-69445\";i:68686;s:12:\"delete-69448\";i:68687;s:12:\"delete-69449\";i:68688;s:12:\"delete-69446\";i:68689;s:12:\"delete-69447\";i:68690;s:12:\"delete-69450\";i:68691;s:12:\"delete-69453\";i:68692;s:12:\"delete-69454\";i:68693;s:12:\"delete-69451\";i:68694;s:12:\"delete-69452\";i:68695;s:12:\"delete-69455\";i:68696;s:12:\"delete-69458\";i:68697;s:12:\"delete-69459\";i:68698;s:12:\"delete-69456\";i:68699;s:12:\"delete-69457\";i:68700;s:12:\"delete-69460\";i:68701;s:12:\"delete-69463\";i:68702;s:12:\"delete-69464\";i:68703;s:12:\"delete-69461\";i:68704;s:12:\"delete-69462\";i:68705;s:12:\"delete-69465\";i:68706;s:12:\"delete-69468\";i:68707;s:12:\"delete-69469\";i:68708;s:12:\"delete-69466\";i:68709;s:12:\"delete-69467\";i:68710;s:12:\"delete-69470\";i:68711;s:12:\"delete-69473\";i:68712;s:12:\"delete-69474\";i:68713;s:12:\"delete-69471\";i:68714;s:12:\"delete-69472\";i:68715;s:12:\"delete-69475\";i:68716;s:12:\"delete-69478\";i:68717;s:12:\"delete-69476\";i:68718;s:12:\"delete-69477\";i:68719;s:12:\"delete-69479\";i:68720;s:12:\"delete-69480\";i:68721;s:12:\"delete-69483\";i:68722;s:12:\"delete-69484\";i:68723;s:12:\"delete-69481\";i:68724;s:12:\"delete-69482\";i:68725;s:12:\"delete-69485\";i:68726;s:12:\"delete-69488\";i:68727;s:12:\"delete-69489\";i:68728;s:12:\"delete-69486\";i:68729;s:12:\"delete-69487\";i:68730;s:12:\"delete-69490\";i:68731;s:12:\"delete-69493\";i:68732;s:12:\"delete-69494\";i:68733;s:12:\"delete-69491\";i:68734;s:12:\"delete-69492\";i:68735;s:12:\"delete-69495\";i:68736;s:12:\"delete-69498\";i:68737;s:12:\"delete-69499\";i:68738;s:12:\"delete-69496\";i:68739;s:12:\"delete-69497\";i:68740;s:12:\"delete-69500\";i:68741;s:12:\"delete-69503\";i:68742;s:12:\"delete-69504\";i:68743;s:12:\"delete-69501\";i:68744;s:12:\"delete-69502\";i:68745;s:12:\"delete-69505\";i:68746;s:12:\"delete-69508\";i:68747;s:12:\"delete-69509\";i:68748;s:12:\"delete-69506\";i:68749;s:12:\"delete-69507\";i:68750;s:12:\"delete-69510\";i:68751;s:12:\"delete-69511\";i:68752;s:12:\"delete-69512\";i:68753;s:12:\"delete-69513\";i:68754;s:12:\"delete-69514\";i:68755;s:12:\"delete-69515\";i:68756;s:12:\"delete-69518\";i:68757;s:12:\"delete-69519\";i:68758;s:12:\"delete-69516\";i:68759;s:12:\"delete-69517\";i:68760;s:12:\"delete-69520\";i:68761;s:12:\"delete-69523\";i:68762;s:12:\"delete-69524\";i:68763;s:12:\"delete-69521\";i:68764;s:12:\"delete-69522\";i:68765;s:12:\"delete-69525\";i:68766;s:12:\"delete-69528\";i:68767;s:12:\"delete-69529\";i:68768;s:12:\"delete-69526\";i:68769;s:12:\"delete-69527\";i:68770;s:12:\"delete-69530\";i:68771;s:12:\"delete-69533\";i:68772;s:12:\"delete-69531\";i:68773;s:12:\"delete-69532\";i:68774;s:12:\"delete-69534\";i:68775;s:12:\"delete-69535\";i:68776;s:12:\"delete-69538\";i:68777;s:12:\"delete-69539\";i:68778;s:12:\"delete-69536\";i:68779;s:12:\"delete-69537\";i:68780;s:12:\"delete-69540\";i:68781;s:12:\"delete-69543\";i:68782;s:12:\"delete-69541\";i:68783;s:12:\"delete-69542\";i:68784;s:12:\"delete-69544\";i:68785;s:12:\"delete-69545\";i:68786;s:12:\"delete-69548\";i:68787;s:12:\"delete-69549\";i:68788;s:12:\"delete-69546\";i:68789;s:12:\"delete-69547\";i:68790;s:12:\"delete-69550\";i:68791;s:12:\"delete-69553\";i:68792;s:12:\"delete-69554\";i:68793;s:12:\"delete-69555\";i:68794;s:12:\"delete-69558\";i:68795;s:12:\"delete-69559\";i:68796;s:12:\"delete-69551\";i:68797;s:12:\"delete-69552\";i:68798;s:12:\"delete-69556\";i:68799;s:12:\"delete-69557\";i:68800;s:12:\"delete-69560\";i:68801;s:12:\"delete-69563\";i:68802;s:12:\"delete-69561\";i:68803;s:12:\"delete-69562\";i:68804;s:12:\"delete-69564\";i:68805;s:12:\"delete-69565\";i:68806;s:12:\"delete-69568\";i:68807;s:12:\"delete-69569\";i:68808;s:12:\"delete-69566\";i:68809;s:12:\"delete-69567\";i:68810;s:12:\"delete-69570\";i:68811;s:12:\"delete-69573\";i:68812;s:12:\"delete-69574\";i:68813;s:12:\"delete-69571\";i:68814;s:12:\"delete-69572\";i:68815;s:12:\"delete-69575\";i:68816;s:12:\"delete-69578\";i:68817;s:12:\"delete-69579\";i:68818;s:12:\"delete-69576\";i:68819;s:12:\"delete-69577\";i:68820;s:12:\"delete-69580\";i:68821;s:12:\"delete-69583\";i:68822;s:12:\"delete-69584\";i:68823;s:12:\"delete-69581\";i:68824;s:12:\"delete-69582\";i:68825;s:12:\"delete-69585\";i:68826;s:12:\"delete-69588\";i:68827;s:12:\"delete-69589\";i:68828;s:12:\"delete-69586\";i:68829;s:12:\"delete-69587\";i:68830;s:12:\"delete-69590\";i:68831;s:12:\"delete-69593\";i:68832;s:12:\"delete-69594\";i:68833;s:12:\"delete-69591\";i:68834;s:12:\"delete-69592\";i:68835;s:12:\"delete-69595\";i:68836;s:12:\"delete-69598\";i:68837;s:12:\"delete-69596\";i:68838;s:12:\"delete-69597\";i:68839;s:12:\"delete-69599\";i:68840;s:12:\"delete-69600\";i:68841;s:12:\"delete-69603\";i:68842;s:12:\"delete-69604\";i:68843;s:12:\"delete-69601\";i:68844;s:12:\"delete-69602\";i:68845;s:12:\"delete-69605\";i:68846;s:12:\"delete-69608\";i:68847;s:12:\"delete-69609\";i:68848;s:12:\"delete-69606\";i:68849;s:12:\"delete-69607\";i:68850;s:12:\"delete-69610\";i:68851;s:12:\"delete-69613\";i:68852;s:12:\"delete-69614\";i:68853;s:12:\"delete-69611\";i:68854;s:12:\"delete-69612\";i:68855;s:12:\"delete-69615\";i:68856;s:12:\"delete-69618\";i:68857;s:12:\"delete-69619\";i:68858;s:12:\"delete-69616\";i:68859;s:12:\"delete-69617\";i:68860;s:12:\"delete-69620\";i:68861;s:12:\"delete-69623\";i:68862;s:12:\"delete-69624\";i:68863;s:12:\"delete-69621\";i:68864;s:12:\"delete-69622\";i:68865;s:12:\"delete-69625\";i:68866;s:12:\"delete-69628\";i:68867;s:12:\"delete-69629\";i:68868;s:12:\"delete-69626\";i:68869;s:12:\"delete-69627\";i:68870;s:12:\"delete-69630\";i:68871;s:12:\"delete-69633\";i:68872;s:12:\"delete-69634\";i:68873;s:12:\"delete-69631\";i:68874;s:12:\"delete-69632\";i:68875;s:12:\"delete-69635\";i:68876;s:12:\"delete-69638\";i:68877;s:12:\"delete-69639\";i:68878;s:12:\"delete-69636\";i:68879;s:12:\"delete-69637\";i:68880;s:12:\"delete-69640\";i:68881;s:12:\"delete-69643\";i:68882;s:12:\"delete-69644\";i:68883;s:12:\"delete-69641\";i:68884;s:12:\"delete-69642\";i:68885;s:12:\"delete-69645\";i:68886;s:12:\"delete-69648\";i:68887;s:12:\"delete-69649\";i:68888;s:12:\"delete-69646\";i:68889;s:12:\"delete-69647\";i:68890;s:12:\"delete-69650\";i:68891;s:12:\"delete-69653\";i:68892;s:12:\"delete-69651\";i:68893;s:12:\"delete-69652\";i:68894;s:12:\"delete-69654\";i:68895;s:12:\"delete-69655\";i:68896;s:12:\"delete-69658\";i:68897;s:12:\"delete-69659\";i:68898;s:12:\"delete-69656\";i:68899;s:12:\"delete-69657\";i:68900;s:12:\"delete-69660\";i:68901;s:12:\"delete-69663\";i:68902;s:12:\"delete-69661\";i:68903;s:12:\"delete-69662\";i:68904;s:12:\"delete-69664\";i:68905;s:12:\"delete-69665\";i:68906;s:12:\"delete-69668\";i:68907;s:12:\"delete-69669\";i:68908;s:12:\"delete-69666\";i:68909;s:12:\"delete-69667\";i:68910;s:12:\"delete-69670\";i:68911;s:12:\"delete-69673\";i:68912;s:12:\"delete-69674\";i:68913;s:12:\"delete-69671\";i:68914;s:12:\"delete-69672\";i:68915;s:12:\"delete-69675\";i:68916;s:12:\"delete-69678\";i:68917;s:12:\"delete-69679\";i:68918;s:12:\"delete-69676\";i:68919;s:12:\"delete-69677\";i:68920;s:12:\"delete-69680\";i:68921;s:12:\"delete-69683\";i:68922;s:12:\"delete-69684\";i:68923;s:12:\"delete-69681\";i:68924;s:12:\"delete-69682\";i:68925;s:12:\"delete-69685\";i:68926;s:12:\"delete-69688\";i:68927;s:12:\"delete-69689\";i:68928;s:12:\"delete-69686\";i:68929;s:12:\"delete-69687\";i:68930;s:12:\"delete-69690\";i:68931;s:12:\"delete-69693\";i:68932;s:12:\"delete-69694\";i:68933;s:12:\"delete-69691\";i:68934;s:12:\"delete-69692\";i:68935;s:12:\"delete-69695\";i:68936;s:12:\"delete-69698\";i:68937;s:12:\"delete-69696\";i:68938;s:12:\"delete-69697\";i:68939;s:12:\"delete-69699\";i:68940;s:12:\"delete-69700\";i:68941;s:12:\"delete-69703\";i:68942;s:12:\"delete-69701\";i:68943;s:12:\"delete-69702\";i:68944;s:12:\"delete-69704\";i:68945;s:12:\"delete-69705\";i:68946;s:12:\"delete-69708\";i:68947;s:12:\"delete-69709\";i:68948;s:12:\"delete-69706\";i:68949;s:12:\"delete-69707\";i:68950;s:12:\"delete-69710\";i:68951;s:12:\"delete-69713\";i:68952;s:12:\"delete-69714\";i:68953;s:12:\"delete-69711\";i:68954;s:12:\"delete-69712\";i:68955;s:12:\"delete-69715\";i:68956;s:12:\"delete-69718\";i:68957;s:12:\"delete-69719\";i:68958;s:12:\"delete-69716\";i:68959;s:12:\"delete-69717\";i:68960;s:12:\"delete-69720\";i:68961;s:12:\"delete-69723\";i:68962;s:12:\"delete-69721\";i:68963;s:12:\"delete-69722\";i:68964;s:12:\"delete-69724\";i:68965;s:12:\"delete-69725\";i:68966;s:12:\"delete-69728\";i:68967;s:12:\"delete-69729\";i:68968;s:12:\"delete-69726\";i:68969;s:12:\"delete-69727\";i:68970;s:12:\"delete-69730\";i:68971;s:12:\"delete-69733\";i:68972;s:12:\"delete-69734\";i:68973;s:12:\"delete-69731\";i:68974;s:12:\"delete-69732\";i:68975;s:12:\"delete-69735\";i:68976;s:12:\"delete-69738\";i:68977;s:12:\"delete-69739\";i:68978;s:12:\"delete-69736\";i:68979;s:12:\"delete-69737\";i:68980;s:12:\"delete-69740\";i:68981;s:12:\"delete-69743\";i:68982;s:12:\"delete-69744\";i:68983;s:12:\"delete-69741\";i:68984;s:12:\"delete-69742\";i:68985;s:12:\"delete-69745\";i:68986;s:12:\"delete-69748\";i:68987;s:12:\"delete-69749\";i:68988;s:12:\"delete-69746\";i:68989;s:12:\"delete-69747\";i:68990;s:12:\"delete-69750\";i:68991;s:12:\"delete-69753\";i:68992;s:12:\"delete-69754\";i:68993;s:12:\"delete-69751\";i:68994;s:12:\"delete-69752\";i:68995;s:12:\"delete-69755\";i:68996;s:12:\"delete-69758\";i:68997;s:12:\"delete-69759\";i:68998;s:12:\"delete-69756\";i:68999;s:12:\"delete-69757\";i:69000;s:12:\"delete-69760\";i:69001;s:12:\"delete-69761\";i:69002;s:12:\"delete-69762\";i:69003;s:12:\"delete-69763\";i:69004;s:12:\"delete-69764\";i:69005;s:12:\"delete-69765\";i:69006;s:12:\"delete-69766\";i:69007;s:12:\"delete-69767\";i:69008;s:12:\"delete-69768\";i:69009;s:12:\"delete-69769\";i:69010;s:12:\"delete-69770\";i:69011;s:12:\"delete-69773\";i:69012;s:12:\"delete-69774\";i:69013;s:12:\"delete-69771\";i:69014;s:12:\"delete-69772\";i:69015;s:12:\"delete-69775\";i:69016;s:12:\"delete-69778\";i:69017;s:12:\"delete-69776\";i:69018;s:12:\"delete-69777\";i:69019;s:12:\"delete-69779\";i:69020;s:12:\"delete-69782\";i:69021;s:12:\"delete-69783\";i:69022;s:12:\"delete-69780\";i:69023;s:12:\"delete-69781\";i:69024;s:12:\"delete-69784\";i:69025;s:12:\"delete-69787\";i:69026;s:12:\"delete-69788\";i:69027;s:12:\"delete-69785\";i:69028;s:12:\"delete-69786\";i:69029;s:12:\"delete-69789\";i:69030;s:12:\"delete-69790\";i:69031;s:12:\"delete-69791\";i:69032;s:12:\"delete-69792\";i:69033;s:12:\"delete-69793\";i:69034;s:12:\"delete-69794\";i:69035;s:12:\"delete-69797\";i:69036;s:12:\"delete-69798\";i:69037;s:12:\"delete-69795\";i:69038;s:12:\"delete-69796\";i:69039;s:12:\"delete-69799\";i:69040;s:12:\"delete-69802\";i:69041;s:12:\"delete-69803\";i:69042;s:12:\"delete-69800\";i:69043;s:12:\"delete-69801\";i:69044;s:12:\"delete-69804\";i:69045;s:12:\"delete-69807\";i:69046;s:12:\"delete-69808\";i:69047;s:12:\"delete-69805\";i:69048;s:12:\"delete-69806\";i:69049;s:12:\"delete-69809\";i:69050;s:12:\"delete-69812\";i:69051;s:12:\"delete-69813\";i:69052;s:12:\"delete-69810\";i:69053;s:12:\"delete-69811\";i:69054;s:12:\"delete-69814\";i:69055;s:12:\"delete-69817\";i:69056;s:12:\"delete-69818\";i:69057;s:12:\"delete-69819\";i:69058;s:12:\"delete-69822\";i:69059;s:12:\"delete-69823\";i:69060;s:12:\"delete-69815\";i:69061;s:12:\"delete-69816\";i:69062;s:12:\"delete-69820\";i:69063;s:12:\"delete-69821\";i:69064;s:12:\"delete-69824\";i:69065;s:12:\"delete-69827\";i:69066;s:12:\"delete-69828\";i:69067;s:12:\"delete-69825\";i:69068;s:12:\"delete-69826\";i:69069;s:12:\"delete-69829\";i:69070;s:12:\"delete-69830\";i:69071;s:12:\"delete-69831\";i:69072;s:12:\"delete-69832\";i:69073;s:12:\"delete-69833\";i:69074;s:12:\"delete-69834\";i:69075;s:12:\"delete-69837\";i:69076;s:12:\"delete-69838\";i:69077;s:12:\"delete-69835\";i:69078;s:12:\"delete-69836\";i:69079;s:12:\"delete-69839\";i:69080;s:12:\"delete-69842\";i:69081;s:12:\"delete-69840\";i:69082;s:12:\"delete-69841\";i:69083;s:12:\"delete-69843\";i:69084;s:12:\"delete-69844\";i:69085;s:12:\"delete-69847\";i:69086;s:12:\"delete-69848\";i:69087;s:12:\"delete-69845\";i:69088;s:12:\"delete-69846\";i:69089;s:12:\"delete-69849\";i:69090;s:12:\"delete-69852\";i:69091;s:12:\"delete-69853\";i:69092;s:12:\"delete-69850\";i:69093;s:12:\"delete-69851\";i:69094;s:12:\"delete-69854\";i:69095;s:12:\"delete-69857\";i:69096;s:12:\"delete-69858\";i:69097;s:12:\"delete-69855\";i:69098;s:12:\"delete-69856\";i:69099;s:12:\"delete-69859\";i:69100;s:12:\"delete-69862\";i:69101;s:12:\"delete-69863\";i:69102;s:12:\"delete-69860\";i:69103;s:12:\"delete-69861\";i:69104;s:12:\"delete-69864\";i:69105;s:12:\"delete-69867\";i:69106;s:12:\"delete-69868\";i:69107;s:12:\"delete-69865\";i:69108;s:12:\"delete-69866\";i:69109;s:12:\"delete-69869\";i:69110;s:12:\"delete-69872\";i:69111;s:12:\"delete-69870\";i:69112;s:12:\"delete-69871\";i:69113;s:12:\"delete-69873\";i:69114;s:12:\"delete-69874\";i:69115;s:12:\"delete-69877\";i:69116;s:12:\"delete-69878\";i:69117;s:12:\"delete-69875\";i:69118;s:12:\"delete-69876\";i:69119;s:12:\"delete-69879\";i:69120;s:12:\"delete-69882\";i:69121;s:12:\"delete-69883\";i:69122;s:12:\"delete-69880\";i:69123;s:12:\"delete-69881\";i:69124;s:12:\"delete-69884\";i:69125;s:12:\"delete-69887\";i:69126;s:12:\"delete-69888\";i:69127;s:12:\"delete-69885\";i:69128;s:12:\"delete-69886\";i:69129;s:12:\"delete-69889\";i:69130;s:12:\"delete-69890\";i:69131;s:12:\"delete-69891\";i:69132;s:12:\"delete-69892\";i:69133;s:12:\"delete-69893\";i:69134;s:12:\"delete-69894\";i:69135;s:12:\"delete-69897\";i:69136;s:12:\"delete-69898\";i:69137;s:12:\"delete-69895\";i:69138;s:12:\"delete-69896\";i:69139;s:12:\"delete-69899\";i:69140;s:12:\"delete-69902\";i:69141;s:12:\"delete-69903\";i:69142;s:12:\"delete-69900\";i:69143;s:12:\"delete-69901\";i:69144;s:12:\"delete-69904\";i:69145;s:12:\"delete-69907\";i:69146;s:12:\"delete-69908\";i:69147;s:12:\"delete-69905\";i:69148;s:12:\"delete-69906\";i:69149;s:12:\"delete-69909\";i:69150;s:12:\"delete-69912\";i:69151;s:12:\"delete-69913\";i:69152;s:12:\"delete-69910\";i:69153;s:12:\"delete-69911\";i:69154;s:12:\"delete-69914\";i:69155;s:12:\"delete-69915\";i:69156;s:12:\"delete-69916\";i:69157;s:12:\"delete-69917\";i:69158;s:12:\"delete-69918\";i:69159;s:12:\"delete-69919\";i:69160;s:12:\"delete-69922\";i:69161;s:12:\"delete-69923\";i:69162;s:12:\"delete-69920\";i:69163;s:12:\"delete-69921\";i:69164;s:12:\"delete-69924\";i:69165;s:12:\"delete-69927\";i:69166;s:12:\"delete-69928\";i:69167;s:12:\"delete-69925\";i:69168;s:12:\"delete-69926\";i:69169;s:12:\"delete-69929\";i:69170;s:12:\"delete-69932\";i:69171;s:12:\"delete-69933\";i:69172;s:12:\"delete-69930\";i:69173;s:12:\"delete-69931\";i:69174;s:12:\"delete-69934\";i:69175;s:12:\"delete-69937\";i:69176;s:12:\"delete-69938\";i:69177;s:12:\"delete-69935\";i:69178;s:12:\"delete-69936\";i:69179;s:12:\"delete-69939\";i:69180;s:12:\"delete-69942\";i:69181;s:12:\"delete-69943\";i:69182;s:12:\"delete-69940\";i:69183;s:12:\"delete-69941\";i:69184;s:12:\"delete-69944\";i:69185;s:12:\"delete-69947\";i:69186;s:12:\"delete-69945\";i:69187;s:12:\"delete-69946\";i:69188;s:12:\"delete-69948\";i:69189;s:12:\"delete-69949\";i:69190;s:12:\"delete-69952\";i:69191;s:12:\"delete-69953\";i:69192;s:12:\"delete-69950\";i:69193;s:12:\"delete-69951\";i:69194;s:12:\"delete-69954\";i:69195;s:12:\"delete-69957\";i:69196;s:12:\"delete-69958\";i:69197;s:12:\"delete-69955\";i:69198;s:12:\"delete-69956\";i:69199;s:12:\"delete-69959\";i:69200;s:12:\"delete-69962\";i:69201;s:12:\"delete-69963\";i:69202;s:12:\"delete-69960\";i:69203;s:12:\"delete-69961\";i:69204;s:12:\"delete-69964\";i:69205;s:12:\"delete-69967\";i:69206;s:12:\"delete-69968\";i:69207;s:12:\"delete-69965\";i:69208;s:12:\"delete-69966\";i:69209;s:12:\"delete-69969\";i:69210;s:12:\"delete-69972\";i:69211;s:12:\"delete-69973\";i:69212;s:12:\"delete-69970\";i:69213;s:12:\"delete-69971\";i:69214;s:12:\"delete-69974\";i:69215;s:12:\"delete-69977\";i:69216;s:12:\"delete-69978\";i:69217;s:12:\"delete-69975\";i:69218;s:12:\"delete-69976\";i:69219;s:12:\"delete-69979\";i:69220;s:12:\"delete-69982\";i:69221;s:12:\"delete-69983\";i:69222;s:12:\"delete-69980\";i:69223;s:12:\"delete-69981\";i:69224;s:12:\"delete-69984\";i:69225;s:12:\"delete-69987\";i:69226;s:12:\"delete-69988\";i:69227;s:12:\"delete-69985\";i:69228;s:12:\"delete-69986\";i:69229;s:12:\"delete-69989\";i:69230;s:12:\"delete-69992\";i:69231;s:12:\"delete-69993\";i:69232;s:12:\"delete-69990\";i:69233;s:12:\"delete-69991\";i:69234;s:12:\"delete-69994\";i:69235;s:12:\"delete-69997\";i:69236;s:12:\"delete-69998\";i:69237;s:12:\"delete-69995\";i:69238;s:12:\"delete-69996\";i:69239;s:12:\"delete-69999\";i:69240;s:12:\"delete-70002\";i:69241;s:12:\"delete-70000\";i:69242;s:12:\"delete-70001\";i:69243;s:12:\"delete-70003\";i:69244;s:12:\"delete-70004\";i:69245;s:12:\"delete-70007\";i:69246;s:12:\"delete-70005\";i:69247;s:12:\"delete-70006\";i:69248;s:12:\"delete-70008\";i:69249;s:12:\"delete-70009\";i:69250;s:12:\"delete-70012\";i:69251;s:12:\"delete-70010\";i:69252;s:12:\"delete-70011\";i:69253;s:12:\"delete-70013\";i:69254;s:12:\"delete-70014\";i:69255;s:12:\"delete-70017\";i:69256;s:12:\"delete-70018\";i:69257;s:12:\"delete-70015\";i:69258;s:12:\"delete-70016\";i:69259;s:12:\"delete-70019\";i:69260;s:12:\"delete-70022\";i:69261;s:12:\"delete-70023\";i:69262;s:12:\"delete-70020\";i:69263;s:12:\"delete-70021\";i:69264;s:12:\"delete-70024\";i:69265;s:12:\"delete-70027\";i:69266;s:12:\"delete-70028\";i:69267;s:12:\"delete-70025\";i:69268;s:12:\"delete-70026\";i:69269;s:12:\"delete-70029\";i:69270;s:12:\"delete-70032\";i:69271;s:12:\"delete-70030\";i:69272;s:12:\"delete-70031\";i:69273;s:12:\"delete-70033\";i:69274;s:12:\"delete-70034\";i:69275;s:12:\"delete-70037\";i:69276;s:12:\"delete-70038\";i:69277;s:12:\"delete-70035\";i:69278;s:12:\"delete-70036\";i:69279;s:12:\"delete-70039\";i:69280;s:12:\"delete-70042\";i:69281;s:12:\"delete-70040\";i:69282;s:12:\"delete-70041\";i:69283;s:12:\"delete-70043\";i:69284;s:12:\"delete-70044\";i:69285;s:12:\"delete-70047\";i:69286;s:12:\"delete-70048\";i:69287;s:12:\"delete-70045\";i:69288;s:12:\"delete-70046\";i:69289;s:12:\"delete-70049\";i:69290;s:12:\"delete-70052\";i:69291;s:12:\"delete-70053\";i:69292;s:12:\"delete-70050\";i:69293;s:12:\"delete-70051\";i:69294;s:12:\"delete-70054\";i:69295;s:12:\"delete-70057\";i:69296;s:12:\"delete-70058\";i:69297;s:12:\"delete-70055\";i:69298;s:12:\"delete-70056\";i:69299;s:12:\"delete-70059\";i:69300;s:12:\"delete-70062\";i:69301;s:12:\"delete-70060\";i:69302;s:12:\"delete-70061\";i:69303;s:12:\"delete-70063\";i:69304;s:12:\"delete-70064\";i:69305;s:12:\"delete-70067\";i:69306;s:12:\"delete-70068\";i:69307;s:12:\"delete-70065\";i:69308;s:12:\"delete-70066\";i:69309;s:12:\"delete-70069\";i:69310;s:12:\"delete-70072\";i:69311;s:12:\"delete-70073\";i:69312;s:12:\"delete-70070\";i:69313;s:12:\"delete-70071\";i:69314;s:12:\"delete-70074\";i:69315;s:12:\"delete-70077\";i:69316;s:12:\"delete-70078\";i:69317;s:12:\"delete-70075\";i:69318;s:12:\"delete-70076\";i:69319;s:12:\"delete-70079\";i:69320;s:12:\"delete-70082\";i:69321;s:12:\"delete-70083\";i:69322;s:12:\"delete-70080\";i:69323;s:12:\"delete-70081\";i:69324;s:12:\"delete-70084\";i:69325;s:12:\"delete-70087\";i:69326;s:12:\"delete-70088\";i:69327;s:12:\"delete-70085\";i:69328;s:12:\"delete-70086\";i:69329;s:12:\"delete-70089\";i:69330;s:12:\"delete-70092\";i:69331;s:12:\"delete-70093\";i:69332;s:12:\"delete-70090\";i:69333;s:12:\"delete-70091\";i:69334;s:12:\"delete-70094\";i:69335;s:12:\"delete-70097\";i:69336;s:12:\"delete-70095\";i:69337;s:12:\"delete-70096\";i:69338;s:12:\"delete-70098\";i:69339;s:12:\"delete-70101\";i:69340;s:12:\"delete-70102\";i:69341;s:12:\"delete-70099\";i:69342;s:12:\"delete-70100\";i:69343;s:12:\"delete-70103\";i:69344;s:12:\"delete-70106\";i:69345;s:12:\"delete-70107\";i:69346;s:12:\"delete-70104\";i:69347;s:12:\"delete-70105\";i:69348;s:12:\"delete-70108\";i:69349;s:12:\"delete-70111\";i:69350;s:12:\"delete-70112\";i:69351;s:12:\"delete-70109\";i:69352;s:12:\"delete-70110\";i:69353;s:12:\"delete-70113\";i:69354;s:12:\"delete-70116\";i:69355;s:12:\"delete-70117\";i:69356;s:12:\"delete-70114\";i:69357;s:12:\"delete-70115\";i:69358;s:12:\"delete-70118\";i:69359;s:12:\"delete-70121\";i:69360;s:12:\"delete-70119\";i:69361;s:12:\"delete-70120\";i:69362;s:12:\"delete-70122\";i:69363;s:12:\"delete-70126\";i:69364;s:12:\"delete-70123\";i:69365;s:12:\"delete-70127\";i:69366;s:12:\"delete-70124\";i:69367;s:12:\"delete-70125\";i:69368;s:12:\"delete-70128\";i:69369;s:12:\"delete-70131\";i:69370;s:12:\"delete-70132\";i:69371;s:12:\"delete-70129\";i:69372;s:12:\"delete-70130\";i:69373;s:12:\"delete-70133\";i:69374;s:12:\"delete-70136\";i:69375;s:12:\"delete-70137\";i:69376;s:12:\"delete-70134\";i:69377;s:12:\"delete-70135\";i:69378;s:12:\"delete-70138\";i:69379;s:12:\"delete-70141\";i:69380;s:12:\"delete-70142\";i:69381;s:12:\"delete-70139\";i:69382;s:12:\"delete-70140\";i:69383;s:12:\"delete-70143\";i:69384;s:12:\"delete-70146\";i:69385;s:12:\"delete-70147\";i:69386;s:12:\"delete-70144\";i:69387;s:12:\"delete-70145\";i:69388;s:12:\"delete-70148\";i:69389;s:12:\"delete-70151\";i:69390;s:12:\"delete-70152\";i:69391;s:12:\"delete-70149\";i:69392;s:12:\"delete-70150\";i:69393;s:12:\"delete-70153\";i:69394;s:12:\"delete-70156\";i:69395;s:12:\"delete-70157\";i:69396;s:12:\"delete-70154\";i:69397;s:12:\"delete-70155\";i:69398;s:12:\"delete-70158\";i:69399;s:12:\"delete-70162\";i:69400;s:12:\"delete-70161\";i:69401;s:12:\"delete-70159\";i:69402;s:12:\"delete-70160\";i:69403;s:12:\"delete-70163\";i:69404;s:12:\"delete-70166\";i:69405;s:12:\"delete-70167\";i:69406;s:12:\"delete-70164\";i:69407;s:12:\"delete-70165\";i:69408;s:12:\"delete-70168\";i:69409;s:12:\"delete-70172\";i:69410;s:12:\"delete-70171\";i:69411;s:12:\"delete-70169\";i:69412;s:12:\"delete-70170\";i:69413;s:12:\"delete-70173\";i:69414;s:12:\"delete-70176\";i:69415;s:12:\"delete-70177\";i:69416;s:12:\"delete-70174\";i:69417;s:12:\"delete-70175\";i:69418;s:12:\"delete-70178\";i:69419;s:12:\"delete-70182\";i:69420;s:12:\"delete-70181\";i:69421;s:12:\"delete-70179\";i:69422;s:12:\"delete-70180\";i:69423;s:12:\"delete-70183\";i:69424;s:12:\"delete-70186\";i:69425;s:12:\"delete-70187\";i:69426;s:12:\"delete-70184\";i:69427;s:12:\"delete-70185\";i:69428;s:12:\"delete-70188\";i:69429;s:12:\"delete-70192\";i:69430;s:12:\"delete-70191\";i:69431;s:12:\"delete-70189\";i:69432;s:12:\"delete-70190\";i:69433;s:12:\"delete-70193\";i:69434;s:12:\"delete-70196\";i:69435;s:12:\"delete-70197\";i:69436;s:12:\"delete-70194\";i:69437;s:12:\"delete-70195\";i:69438;s:12:\"delete-70198\";i:69439;s:12:\"delete-70201\";i:69440;s:12:\"delete-70199\";i:69441;s:12:\"delete-70200\";i:69442;s:12:\"delete-70202\";i:69443;s:12:\"delete-70203\";i:69444;s:12:\"delete-70206\";i:69445;s:12:\"delete-70207\";i:69446;s:12:\"delete-70204\";i:69447;s:12:\"delete-70205\";i:69448;s:12:\"delete-70208\";i:69449;s:12:\"delete-70211\";i:69450;s:12:\"delete-70212\";i:69451;s:12:\"delete-70209\";i:69452;s:12:\"delete-70210\";i:69453;s:12:\"delete-70213\";i:69454;s:12:\"delete-70217\";i:69455;s:12:\"delete-70216\";i:69456;s:12:\"delete-70214\";i:69457;s:12:\"delete-70215\";i:69458;s:12:\"delete-70218\";i:69459;s:12:\"delete-70221\";i:69460;s:12:\"delete-70222\";i:69461;s:12:\"delete-70219\";i:69462;s:12:\"delete-70220\";i:69463;s:12:\"delete-70223\";i:69464;s:12:\"delete-70226\";i:69465;s:12:\"delete-70227\";i:69466;s:12:\"delete-70224\";i:69467;s:12:\"delete-70225\";i:69468;s:12:\"delete-70228\";i:69469;s:12:\"delete-70231\";i:69470;s:12:\"delete-70232\";i:69471;s:12:\"delete-70229\";i:69472;s:12:\"delete-70230\";i:69473;s:12:\"delete-70233\";i:69474;s:12:\"delete-70236\";i:69475;s:12:\"delete-70237\";i:69476;s:12:\"delete-70234\";i:69477;s:12:\"delete-70235\";i:69478;s:12:\"delete-70238\";i:69479;s:12:\"delete-70241\";i:69480;s:12:\"delete-70242\";i:69481;s:12:\"delete-70239\";i:69482;s:12:\"delete-70240\";i:69483;s:12:\"delete-70243\";i:69484;s:12:\"delete-70246\";i:69485;s:12:\"delete-70247\";i:69486;s:12:\"delete-70244\";i:69487;s:12:\"delete-70245\";i:69488;s:12:\"delete-70248\";i:69489;s:12:\"delete-70251\";i:69490;s:12:\"delete-70252\";i:69491;s:12:\"delete-70249\";i:69492;s:12:\"delete-70250\";i:69493;s:12:\"delete-70253\";i:69494;s:12:\"delete-70256\";i:69495;s:12:\"delete-70257\";i:69496;s:12:\"delete-70254\";i:69497;s:12:\"delete-70255\";i:69498;s:12:\"delete-70258\";i:69499;s:12:\"delete-70261\";i:69500;s:12:\"delete-70259\";i:69501;s:12:\"delete-70260\";i:69502;s:12:\"delete-70262\";i:69503;s:12:\"delete-70266\";i:69504;s:12:\"delete-70263\";i:69505;s:12:\"delete-70267\";i:69506;s:12:\"delete-70264\";i:69507;s:12:\"delete-70265\";i:69508;s:12:\"delete-70268\";i:69509;s:12:\"delete-70269\";i:69510;s:12:\"delete-70270\";i:69511;s:12:\"delete-70271\";i:69512;s:12:\"delete-70272\";i:69513;s:12:\"delete-70273\";i:69514;s:12:\"delete-70276\";i:69515;s:12:\"delete-70277\";i:69516;s:12:\"delete-70274\";i:69517;s:12:\"delete-70275\";i:69518;s:12:\"delete-70278\";i:69519;s:12:\"delete-70281\";i:69520;s:12:\"delete-70282\";i:69521;s:12:\"delete-70279\";i:69522;s:12:\"delete-70280\";i:69523;s:12:\"delete-70283\";i:69524;s:12:\"delete-70287\";i:69525;s:12:\"delete-70286\";i:69526;s:12:\"delete-70284\";i:69527;s:12:\"delete-70285\";i:69528;s:12:\"delete-70288\";i:69529;s:12:\"delete-70291\";i:69530;s:12:\"delete-70292\";i:69531;s:12:\"delete-70289\";i:69532;s:12:\"delete-70290\";i:69533;s:12:\"delete-70293\";i:69534;s:12:\"delete-70296\";i:69535;s:12:\"delete-70297\";i:69536;s:12:\"delete-70294\";i:69537;s:12:\"delete-70295\";i:69538;s:12:\"delete-70298\";i:69539;s:12:\"delete-70301\";i:69540;s:12:\"delete-70302\";i:69541;s:12:\"delete-70299\";i:69542;s:12:\"delete-70300\";i:69543;s:12:\"delete-70303\";i:69544;s:12:\"delete-70306\";i:69545;s:12:\"delete-70307\";i:69546;s:12:\"delete-70304\";i:69547;s:12:\"delete-70305\";i:69548;s:12:\"delete-70308\";i:69549;s:12:\"delete-70312\";i:69550;s:12:\"delete-70311\";i:69551;s:12:\"delete-70309\";i:69552;s:12:\"delete-70310\";i:69553;s:12:\"delete-70313\";i:69554;s:12:\"delete-70316\";i:69555;s:12:\"delete-70317\";i:69556;s:12:\"delete-70314\";i:69557;s:12:\"delete-70315\";i:69558;s:12:\"delete-70318\";i:69559;s:12:\"delete-70321\";i:69560;s:12:\"delete-70322\";i:69561;s:12:\"delete-70319\";i:69562;s:12:\"delete-70320\";i:69563;s:12:\"delete-70323\";i:69564;s:12:\"delete-70326\";i:69565;s:12:\"delete-70327\";i:69566;s:12:\"delete-70324\";i:69567;s:12:\"delete-70325\";i:69568;s:12:\"delete-70328\";i:69569;s:12:\"delete-70331\";i:69570;s:12:\"delete-70332\";i:69571;s:12:\"delete-70329\";i:69572;s:12:\"delete-70330\";i:69573;s:12:\"delete-70333\";i:69574;s:12:\"delete-70336\";i:69575;s:12:\"delete-70337\";i:69576;s:12:\"delete-70334\";i:69577;s:12:\"delete-70335\";i:69578;s:12:\"delete-70338\";i:69579;s:12:\"delete-70341\";i:69580;s:12:\"delete-70342\";i:69581;s:12:\"delete-70339\";i:69582;s:12:\"delete-70340\";i:69583;s:12:\"delete-70343\";i:69584;s:12:\"delete-70346\";i:69585;s:12:\"delete-70347\";i:69586;s:12:\"delete-70344\";i:69587;s:12:\"delete-70345\";i:69588;s:12:\"delete-70348\";i:69589;s:12:\"delete-70351\";i:69590;s:12:\"delete-70352\";i:69591;s:12:\"delete-70349\";i:69592;s:12:\"delete-70350\";i:69593;s:12:\"delete-70353\";i:69594;s:12:\"delete-70356\";i:69595;s:12:\"delete-70357\";i:69596;s:12:\"delete-70354\";i:69597;s:12:\"delete-70355\";i:69598;s:12:\"delete-70358\";i:69599;s:12:\"delete-70361\";i:69600;s:12:\"delete-70359\";i:69601;s:12:\"delete-70360\";i:69602;s:12:\"delete-70362\";i:69603;s:12:\"delete-70363\";i:69604;s:12:\"delete-70366\";i:69605;s:12:\"delete-70367\";i:69606;s:12:\"delete-70364\";i:69607;s:12:\"delete-70365\";i:69608;s:12:\"delete-70368\";i:69609;s:12:\"delete-70371\";i:69610;s:12:\"delete-70372\";i:69611;s:12:\"delete-70369\";i:69612;s:12:\"delete-70370\";i:69613;s:12:\"delete-70373\";i:69614;s:12:\"delete-70376\";i:69615;s:12:\"delete-70377\";i:69616;s:12:\"delete-70374\";i:69617;s:12:\"delete-70375\";i:69618;s:12:\"delete-70378\";i:69619;s:12:\"delete-70381\";i:69620;s:12:\"delete-70382\";i:69621;s:12:\"delete-70379\";i:69622;s:12:\"delete-70380\";i:69623;s:12:\"delete-70383\";i:69624;s:12:\"delete-70386\";i:69625;s:12:\"delete-70387\";i:69626;s:12:\"delete-70384\";i:69627;s:12:\"delete-70385\";i:69628;s:12:\"delete-70388\";i:69629;s:12:\"delete-70391\";i:69630;s:12:\"delete-70392\";i:69631;s:12:\"delete-70389\";i:69632;s:12:\"delete-70390\";i:69633;s:12:\"delete-70393\";i:69634;s:12:\"delete-70396\";i:69635;s:12:\"delete-70397\";i:69636;s:12:\"delete-70394\";i:69637;s:12:\"delete-70395\";i:69638;s:12:\"delete-70398\";i:69639;s:12:\"delete-70401\";i:69640;s:12:\"delete-70402\";i:69641;s:12:\"delete-70399\";i:69642;s:12:\"delete-70400\";i:69643;s:12:\"delete-70403\";i:69644;s:12:\"delete-70406\";i:69645;s:12:\"delete-70407\";i:69646;s:12:\"delete-70404\";i:69647;s:12:\"delete-70405\";i:69648;s:12:\"delete-70408\";i:69649;s:12:\"delete-70411\";i:69650;s:12:\"delete-70412\";i:69651;s:12:\"delete-70409\";i:69652;s:12:\"delete-70410\";i:69653;s:12:\"delete-70413\";i:69654;s:12:\"delete-70416\";i:69655;s:12:\"delete-70417\";i:69656;s:12:\"delete-70418\";i:69657;s:12:\"delete-70421\";i:69658;s:12:\"delete-70422\";i:69659;s:12:\"delete-70414\";i:69660;s:12:\"delete-70415\";i:69661;s:12:\"delete-70419\";i:69662;s:12:\"delete-70420\";i:69663;s:12:\"delete-70423\";i:69664;s:12:\"delete-70426\";i:69665;s:12:\"delete-70427\";i:69666;s:12:\"delete-70424\";i:69667;s:12:\"delete-70425\";i:69668;s:12:\"delete-70428\";i:69669;s:12:\"delete-70431\";i:69670;s:12:\"delete-70432\";i:69671;s:12:\"delete-70429\";i:69672;s:12:\"delete-70430\";i:69673;s:12:\"delete-70433\";i:69674;s:12:\"delete-70436\";i:69675;s:12:\"delete-70437\";i:69676;s:12:\"delete-70434\";i:69677;s:12:\"delete-70435\";i:69678;s:12:\"delete-70438\";i:69679;s:12:\"delete-70441\";i:69680;s:12:\"delete-70442\";i:69681;s:12:\"delete-70439\";i:69682;s:12:\"delete-70440\";i:69683;s:12:\"delete-70443\";i:69684;s:12:\"delete-70446\";i:69685;s:12:\"delete-70447\";i:69686;s:12:\"delete-70444\";i:69687;s:12:\"delete-70445\";i:69688;s:12:\"delete-70448\";i:69689;s:12:\"delete-70451\";i:69690;s:12:\"delete-70452\";i:69691;s:12:\"delete-70449\";i:69692;s:12:\"delete-70450\";i:69693;s:12:\"delete-70453\";i:69694;s:12:\"delete-70456\";i:69695;s:12:\"delete-70457\";i:69696;s:12:\"delete-70454\";i:69697;s:12:\"delete-70455\";i:69698;s:12:\"delete-70458\";i:69699;s:12:\"delete-70461\";i:69700;s:12:\"delete-70462\";i:69701;s:12:\"delete-70459\";i:69702;s:12:\"delete-70460\";i:69703;s:12:\"delete-70463\";i:69704;s:12:\"delete-70466\";i:69705;s:12:\"delete-70467\";i:69706;s:12:\"delete-70464\";i:69707;s:12:\"delete-70465\";i:69708;s:12:\"delete-70468\";i:69709;s:12:\"delete-70471\";i:69710;s:12:\"delete-70472\";i:69711;s:12:\"delete-70469\";i:69712;s:12:\"delete-70470\";i:69713;s:12:\"delete-70473\";i:69714;s:12:\"delete-70476\";i:69715;s:12:\"delete-70477\";i:69716;s:12:\"delete-70474\";i:69717;s:12:\"delete-70475\";i:69718;s:12:\"delete-70478\";i:69719;s:12:\"delete-70481\";i:69720;s:12:\"delete-70482\";i:69721;s:12:\"delete-70479\";i:69722;s:12:\"delete-70480\";i:69723;s:12:\"delete-70483\";i:69724;s:12:\"delete-70486\";i:69725;s:12:\"delete-70487\";i:69726;s:12:\"delete-70484\";i:69727;s:12:\"delete-70485\";i:69728;s:12:\"delete-70488\";i:69729;s:12:\"delete-70491\";i:69730;s:12:\"delete-70492\";i:69731;s:12:\"delete-70489\";i:69732;s:12:\"delete-70490\";i:69733;s:12:\"delete-70493\";i:69734;s:12:\"delete-70496\";i:69735;s:12:\"delete-70494\";i:69736;s:12:\"delete-70495\";i:69737;s:12:\"delete-70497\";i:69738;s:12:\"delete-70498\";i:69739;s:12:\"delete-70501\";i:69740;s:12:\"delete-70502\";i:69741;s:12:\"delete-70499\";i:69742;s:12:\"delete-70500\";i:69743;s:12:\"delete-70503\";i:69744;s:12:\"delete-70506\";i:69745;s:12:\"delete-70507\";i:69746;s:12:\"delete-70504\";i:69747;s:12:\"delete-70505\";i:69748;s:12:\"delete-70508\";i:69749;s:12:\"delete-70511\";i:69750;s:12:\"delete-70512\";i:69751;s:12:\"delete-70509\";i:69752;s:12:\"delete-70510\";i:69753;s:12:\"delete-70513\";i:69754;s:12:\"delete-70516\";i:69755;s:12:\"delete-70517\";i:69756;s:12:\"delete-70514\";i:69757;s:12:\"delete-70515\";i:69758;s:12:\"delete-70518\";i:69759;s:12:\"delete-70521\";i:69760;s:12:\"delete-70522\";i:69761;s:12:\"delete-70519\";i:69762;s:12:\"delete-70520\";i:69763;s:12:\"delete-70523\";i:69764;s:12:\"delete-70526\";i:69765;s:12:\"delete-70527\";i:69766;s:12:\"delete-70524\";i:69767;s:12:\"delete-70525\";i:69768;s:12:\"delete-70528\";i:69769;s:12:\"delete-70531\";i:69770;s:12:\"delete-70532\";i:69771;s:12:\"delete-70529\";i:69772;s:12:\"delete-70530\";i:69773;s:12:\"delete-70533\";i:69774;s:12:\"delete-70536\";i:69775;s:12:\"delete-70537\";i:69776;s:12:\"delete-70534\";i:69777;s:12:\"delete-70535\";i:69778;s:12:\"delete-70538\";i:69779;s:12:\"delete-70541\";i:69780;s:12:\"delete-70542\";i:69781;s:12:\"delete-70539\";i:69782;s:12:\"delete-70540\";i:69783;s:12:\"delete-70543\";i:69784;s:12:\"delete-70546\";i:69785;s:12:\"delete-70547\";i:69786;s:12:\"delete-70544\";i:69787;s:12:\"delete-70545\";i:69788;s:12:\"delete-70548\";i:69789;s:12:\"delete-70551\";i:69790;s:12:\"delete-70552\";i:69791;s:12:\"delete-70549\";i:69792;s:12:\"delete-70550\";i:69793;s:12:\"delete-70553\";i:69794;s:12:\"delete-70556\";i:69795;s:12:\"delete-70557\";i:69796;s:12:\"delete-70554\";i:69797;s:12:\"delete-70555\";i:69798;s:12:\"delete-70558\";i:69799;s:12:\"delete-70561\";i:69800;s:12:\"delete-70562\";i:69801;s:12:\"delete-70559\";i:69802;s:12:\"delete-70560\";i:69803;s:12:\"delete-70563\";i:69804;s:12:\"delete-70566\";i:69805;s:12:\"delete-70567\";i:69806;s:12:\"delete-70564\";i:69807;s:12:\"delete-70565\";i:69808;s:12:\"delete-70568\";i:69809;s:12:\"delete-70571\";i:69810;s:12:\"delete-70572\";i:69811;s:12:\"delete-70569\";i:69812;s:12:\"delete-70570\";i:69813;s:12:\"delete-70573\";i:69814;s:12:\"delete-70576\";i:69815;s:12:\"delete-70577\";i:69816;s:12:\"delete-70574\";i:69817;s:12:\"delete-70575\";i:69818;s:12:\"delete-70578\";i:69819;s:12:\"delete-70581\";i:69820;s:12:\"delete-70582\";i:69821;s:12:\"delete-70579\";i:69822;s:12:\"delete-70580\";i:69823;s:12:\"delete-70583\";i:69824;s:12:\"delete-70586\";i:69825;s:12:\"delete-70587\";i:69826;s:12:\"delete-70584\";i:69827;s:12:\"delete-70585\";i:69828;s:12:\"delete-70588\";i:69829;s:12:\"delete-70591\";i:69830;s:12:\"delete-70592\";i:69831;s:12:\"delete-70589\";i:69832;s:12:\"delete-70590\";i:69833;s:12:\"delete-70593\";i:69834;s:12:\"delete-70596\";i:69835;s:12:\"delete-70597\";i:69836;s:12:\"delete-70598\";i:69837;s:12:\"delete-70601\";i:69838;s:12:\"delete-70602\";i:69839;s:12:\"delete-70603\";i:69840;s:12:\"delete-70606\";i:69841;s:12:\"delete-70607\";i:69842;s:12:\"delete-70594\";i:69843;s:12:\"delete-70595\";i:69844;s:12:\"delete-70599\";i:69845;s:12:\"delete-70600\";i:69846;s:12:\"delete-70604\";i:69847;s:12:\"delete-70605\";i:69848;s:12:\"delete-70608\";i:69849;s:12:\"delete-70611\";i:69850;s:12:\"delete-70612\";i:69851;s:12:\"delete-70609\";i:69852;s:12:\"delete-70610\";i:69853;s:12:\"delete-70613\";i:69854;s:12:\"delete-70616\";i:69855;s:12:\"delete-70617\";i:69856;s:12:\"delete-70614\";i:69857;s:12:\"delete-70615\";i:69858;s:12:\"delete-70618\";i:69859;s:12:\"delete-70621\";i:69860;s:12:\"delete-70622\";i:69861;s:12:\"delete-70619\";i:69862;s:12:\"delete-70620\";i:69863;s:12:\"delete-70623\";i:69864;s:12:\"delete-70626\";i:69865;s:12:\"delete-70627\";i:69866;s:12:\"delete-70624\";i:69867;s:12:\"delete-70625\";i:69868;s:12:\"delete-70628\";i:69869;s:12:\"delete-70631\";i:69870;s:12:\"delete-70632\";i:69871;s:12:\"delete-70629\";i:69872;s:12:\"delete-70630\";i:69873;s:12:\"delete-70633\";i:69874;s:12:\"delete-70636\";i:69875;s:12:\"delete-70637\";i:69876;s:12:\"delete-70634\";i:69877;s:12:\"delete-70635\";i:69878;s:12:\"delete-70638\";i:69879;s:12:\"delete-70641\";i:69880;s:12:\"delete-70642\";i:69881;s:12:\"delete-70639\";i:69882;s:12:\"delete-70640\";i:69883;s:12:\"delete-70643\";i:69884;s:12:\"delete-70646\";i:69885;s:12:\"delete-70647\";i:69886;s:12:\"delete-70644\";i:69887;s:12:\"delete-70645\";i:69888;s:12:\"delete-70648\";i:69889;s:12:\"delete-70651\";i:69890;s:12:\"delete-70649\";i:69891;s:12:\"delete-70650\";i:69892;s:12:\"delete-70652\";i:69893;s:12:\"delete-70653\";i:69894;s:12:\"delete-70656\";i:69895;s:12:\"delete-70657\";i:69896;s:12:\"delete-70654\";i:69897;s:12:\"delete-70655\";i:69898;s:12:\"delete-70658\";i:69899;s:12:\"delete-70661\";i:69900;s:12:\"delete-70662\";i:69901;s:12:\"delete-70659\";i:69902;s:12:\"delete-70660\";i:69903;s:12:\"delete-70663\";i:69904;s:12:\"delete-70666\";i:69905;s:12:\"delete-70664\";i:69906;s:12:\"delete-70665\";i:69907;s:12:\"delete-70667\";i:69908;s:12:\"delete-70668\";i:69909;s:12:\"delete-70671\";i:69910;s:12:\"delete-70672\";i:69911;s:12:\"delete-70669\";i:69912;s:12:\"delete-70670\";i:69913;s:12:\"delete-70673\";i:69914;s:12:\"delete-70676\";i:69915;s:12:\"delete-70677\";i:69916;s:12:\"delete-70674\";i:69917;s:12:\"delete-70675\";i:69918;s:12:\"delete-70678\";i:69919;s:12:\"delete-70681\";i:69920;s:12:\"delete-70679\";i:69921;s:12:\"delete-70680\";i:69922;s:12:\"delete-70682\";i:69923;s:12:\"delete-70683\";i:69924;s:12:\"delete-70686\";i:69925;s:12:\"delete-70687\";i:69926;s:12:\"delete-70684\";i:69927;s:12:\"delete-70685\";i:69928;s:12:\"delete-70688\";i:69929;s:12:\"delete-70691\";i:69930;s:12:\"delete-70692\";i:69931;s:12:\"delete-70689\";i:69932;s:12:\"delete-70690\";i:69933;s:12:\"delete-70693\";i:69934;s:12:\"delete-70696\";i:69935;s:12:\"delete-70694\";i:69936;s:12:\"delete-70695\";i:69937;s:12:\"delete-70697\";i:69938;s:12:\"delete-70698\";i:69939;s:12:\"delete-70701\";i:69940;s:12:\"delete-70702\";i:69941;s:12:\"delete-70699\";i:69942;s:12:\"delete-70700\";i:69943;s:12:\"delete-70703\";i:69944;s:12:\"delete-70706\";i:69945;s:12:\"delete-70707\";i:69946;s:12:\"delete-70704\";i:69947;s:12:\"delete-70705\";i:69948;s:12:\"delete-70708\";i:69949;s:12:\"delete-70711\";i:69950;s:12:\"delete-70712\";i:69951;s:12:\"delete-70709\";i:69952;s:12:\"delete-70710\";i:69953;s:12:\"delete-70713\";i:69954;s:12:\"delete-70716\";i:69955;s:12:\"delete-70717\";i:69956;s:12:\"delete-70714\";i:69957;s:12:\"delete-70715\";i:69958;s:12:\"delete-70718\";i:69959;s:12:\"delete-70721\";i:69960;s:12:\"delete-70722\";i:69961;s:12:\"delete-70719\";i:69962;s:12:\"delete-70720\";i:69963;s:12:\"delete-70723\";i:69964;s:12:\"delete-70726\";i:69965;s:12:\"delete-70724\";i:69966;s:12:\"delete-70725\";i:69967;s:12:\"delete-70727\";i:69968;s:12:\"delete-70728\";i:69969;s:12:\"delete-70731\";i:69970;s:12:\"delete-70732\";i:69971;s:12:\"delete-70729\";i:69972;s:12:\"delete-70730\";i:69973;s:12:\"delete-70733\";i:69974;s:12:\"delete-70736\";i:69975;s:12:\"delete-70737\";i:69976;s:12:\"delete-70734\";i:69977;s:12:\"delete-70735\";i:69978;s:12:\"delete-70738\";i:69979;s:12:\"delete-70741\";i:69980;s:12:\"delete-70742\";i:69981;s:12:\"delete-70739\";i:69982;s:12:\"delete-70740\";i:69983;s:12:\"delete-70743\";i:69984;s:12:\"delete-70746\";i:69985;s:12:\"delete-70747\";i:69986;s:12:\"delete-70744\";i:69987;s:12:\"delete-70745\";i:69988;s:12:\"delete-70748\";i:69989;s:12:\"delete-70751\";i:69990;s:12:\"delete-70752\";i:69991;s:12:\"delete-70749\";i:69992;s:12:\"delete-70750\";i:69993;s:12:\"delete-70753\";i:69994;s:12:\"delete-70756\";i:69995;s:12:\"delete-70754\";i:69996;s:12:\"delete-70755\";i:69997;s:12:\"delete-70757\";i:69998;s:12:\"delete-70758\";i:69999;s:12:\"delete-70759\";i:70000;s:12:\"delete-70760\";i:70001;s:12:\"delete-70761\";i:70002;s:12:\"delete-70762\";i:70003;s:12:\"delete-70763\";i:70004;s:12:\"delete-70766\";i:70005;s:12:\"delete-70767\";i:70006;s:12:\"delete-70764\";i:70007;s:12:\"delete-70765\";i:70008;s:12:\"delete-70768\";i:70009;s:12:\"delete-70771\";i:70010;s:12:\"delete-70772\";i:70011;s:12:\"delete-70769\";i:70012;s:12:\"delete-70770\";i:70013;s:12:\"delete-70773\";i:70014;s:12:\"delete-70776\";i:70015;s:12:\"delete-70777\";i:70016;s:12:\"delete-70774\";i:70017;s:12:\"delete-70775\";i:70018;s:12:\"delete-70778\";i:70019;s:12:\"delete-70781\";i:70020;s:12:\"delete-70782\";i:70021;s:12:\"delete-70779\";i:70022;s:12:\"delete-70780\";i:70023;s:12:\"delete-70783\";i:70024;s:12:\"delete-70786\";i:70025;s:12:\"delete-70787\";i:70026;s:12:\"delete-70784\";i:70027;s:12:\"delete-70785\";i:70028;s:12:\"delete-70788\";i:70029;s:12:\"delete-70791\";i:70030;s:12:\"delete-70792\";i:70031;s:12:\"delete-70789\";i:70032;s:12:\"delete-70790\";i:70033;s:12:\"delete-70793\";i:70034;s:12:\"delete-70796\";i:70035;s:12:\"delete-70794\";i:70036;s:12:\"delete-70795\";i:70037;s:12:\"delete-70797\";i:70038;s:12:\"delete-70798\";i:70039;s:12:\"delete-70801\";i:70040;s:12:\"delete-70802\";i:70041;s:12:\"delete-70799\";i:70042;s:12:\"delete-70800\";i:70043;s:12:\"delete-70803\";i:70044;s:12:\"delete-70806\";i:70045;s:12:\"delete-70807\";i:70046;s:12:\"delete-70804\";i:70047;s:12:\"delete-70805\";i:70048;s:12:\"delete-70808\";i:70049;s:12:\"delete-70811\";i:70050;s:12:\"delete-70809\";i:70051;s:12:\"delete-70810\";i:70052;s:12:\"delete-70812\";i:70053;s:12:\"delete-70813\";i:70054;s:12:\"delete-70816\";i:70055;s:12:\"delete-70817\";i:70056;s:12:\"delete-70814\";i:70057;s:12:\"delete-70815\";i:70058;s:12:\"delete-70818\";i:70059;s:12:\"delete-70821\";i:70060;s:12:\"delete-70822\";i:70061;s:12:\"delete-70819\";i:70062;s:12:\"delete-70820\";i:70063;s:12:\"delete-70823\";i:70064;s:12:\"delete-70826\";i:70065;s:12:\"delete-70827\";i:70066;s:12:\"delete-70824\";i:70067;s:12:\"delete-70825\";i:70068;s:12:\"delete-70828\";i:70069;s:12:\"delete-70831\";i:70070;s:12:\"delete-70829\";i:70071;s:12:\"delete-70830\";i:70072;s:12:\"delete-70832\";i:70073;s:12:\"delete-70833\";i:70074;s:12:\"delete-70836\";i:70075;s:12:\"delete-70837\";i:70076;s:12:\"delete-70834\";i:70077;s:12:\"delete-70835\";i:70078;s:12:\"delete-70838\";i:70079;s:12:\"delete-70841\";i:70080;s:12:\"delete-70842\";i:70081;s:12:\"delete-70839\";i:70082;s:12:\"delete-70840\";i:70083;s:12:\"delete-70843\";i:70084;s:12:\"delete-70846\";i:70085;s:12:\"delete-70844\";i:70086;s:12:\"delete-70845\";i:70087;s:12:\"delete-70847\";i:70088;s:12:\"delete-70848\";i:70089;s:12:\"delete-70851\";i:70090;s:12:\"delete-70852\";i:70091;s:12:\"delete-70849\";i:70092;s:12:\"delete-70850\";i:70093;s:12:\"delete-70853\";i:70094;s:12:\"delete-70856\";i:70095;s:12:\"delete-70857\";i:70096;s:12:\"delete-70854\";i:70097;s:12:\"delete-70855\";i:70098;s:12:\"delete-70858\";i:70099;s:12:\"delete-70861\";i:70100;s:12:\"delete-70862\";i:70101;s:12:\"delete-70859\";i:70102;s:12:\"delete-70860\";i:70103;s:12:\"delete-70863\";i:70104;s:12:\"delete-70866\";i:70105;s:12:\"delete-70867\";i:70106;s:12:\"delete-70864\";i:70107;s:12:\"delete-70865\";i:70108;s:12:\"delete-70868\";i:70109;s:12:\"delete-70871\";i:70110;s:12:\"delete-70869\";i:70111;s:12:\"delete-70870\";i:70112;s:12:\"delete-70872\";i:70113;s:12:\"delete-70873\";i:70114;s:12:\"delete-70876\";i:70115;s:12:\"delete-70877\";i:70116;s:12:\"delete-70874\";i:70117;s:12:\"delete-70875\";i:70118;s:12:\"delete-70878\";i:70119;s:12:\"delete-70881\";i:70120;s:12:\"delete-70882\";i:70121;s:12:\"delete-70879\";i:70122;s:12:\"delete-70880\";i:70123;s:12:\"delete-70883\";i:70124;s:12:\"delete-70886\";i:70125;s:12:\"delete-70887\";i:70126;s:12:\"delete-70884\";i:70127;s:12:\"delete-70885\";i:70128;s:12:\"delete-70888\";i:70129;s:12:\"delete-70891\";i:70130;s:12:\"delete-70892\";i:70131;s:12:\"delete-70889\";i:70132;s:12:\"delete-70890\";i:70133;s:12:\"delete-70893\";i:70134;s:12:\"delete-70896\";i:70135;s:12:\"delete-70897\";i:70136;s:12:\"delete-70894\";i:70137;s:12:\"delete-70895\";i:70138;s:12:\"delete-70898\";i:70139;s:12:\"delete-70901\";i:70140;s:12:\"delete-70902\";i:70141;s:12:\"delete-70899\";i:70142;s:12:\"delete-70900\";i:70143;s:12:\"delete-70903\";i:70144;s:12:\"delete-70906\";i:70145;s:12:\"delete-70907\";i:70146;s:12:\"delete-70904\";i:70147;s:12:\"delete-70905\";i:70148;s:12:\"delete-70908\";i:70149;s:12:\"delete-70911\";i:70150;s:12:\"delete-70912\";i:70151;s:12:\"delete-70909\";i:70152;s:12:\"delete-70910\";i:70153;s:12:\"delete-70913\";i:70154;s:12:\"delete-70916\";i:70155;s:12:\"delete-70917\";i:70156;s:12:\"delete-70914\";i:70157;s:12:\"delete-70915\";i:70158;s:12:\"delete-70918\";i:70159;s:12:\"delete-70921\";i:70160;s:12:\"delete-70922\";i:70161;s:12:\"delete-70919\";i:70162;s:12:\"delete-70920\";i:70163;s:12:\"delete-70923\";i:70164;s:12:\"delete-70926\";i:70165;s:12:\"delete-70927\";i:70166;s:12:\"delete-70924\";i:70167;s:12:\"delete-70925\";i:70168;s:12:\"delete-70928\";i:70169;s:12:\"delete-70931\";i:70170;s:12:\"delete-70932\";i:70171;s:12:\"delete-70929\";i:70172;s:12:\"delete-70930\";i:70173;s:12:\"delete-70933\";i:70174;s:12:\"delete-70936\";i:70175;s:12:\"delete-70937\";i:70176;s:12:\"delete-70934\";i:70177;s:12:\"delete-70935\";i:70178;s:12:\"delete-70938\";i:70179;s:12:\"delete-70941\";i:70180;s:12:\"delete-70942\";i:70181;s:12:\"delete-70939\";i:70182;s:12:\"delete-70940\";i:70183;s:12:\"delete-70943\";i:70184;s:12:\"delete-70946\";i:70185;s:12:\"delete-70947\";i:70186;s:12:\"delete-70944\";i:70187;s:12:\"delete-70945\";i:70188;s:12:\"delete-70948\";i:70189;s:12:\"delete-70951\";i:70190;s:12:\"delete-70952\";i:70191;s:12:\"delete-70949\";i:70192;s:12:\"delete-70950\";i:70193;s:12:\"delete-70953\";i:70194;s:12:\"delete-70956\";i:70195;s:12:\"delete-70957\";i:70196;s:12:\"delete-70954\";i:70197;s:12:\"delete-70955\";i:70198;s:12:\"delete-70958\";i:70199;s:12:\"delete-70961\";i:70200;s:12:\"delete-70962\";i:70201;s:12:\"delete-70959\";i:70202;s:12:\"delete-70960\";i:70203;s:12:\"delete-70963\";i:70204;s:12:\"delete-70966\";i:70205;s:12:\"delete-70967\";i:70206;s:12:\"delete-70964\";i:70207;s:12:\"delete-70965\";i:70208;s:12:\"delete-70968\";i:70209;s:12:\"delete-70971\";i:70210;s:12:\"delete-70972\";i:70211;s:12:\"delete-70969\";i:70212;s:12:\"delete-70970\";i:70213;s:12:\"delete-70973\";i:70214;s:12:\"delete-70976\";i:70215;s:12:\"delete-70977\";i:70216;s:12:\"delete-70974\";i:70217;s:12:\"delete-70975\";i:70218;s:12:\"delete-70978\";i:70219;s:12:\"delete-70981\";i:70220;s:12:\"delete-70982\";i:70221;s:12:\"delete-70979\";i:70222;s:12:\"delete-70980\";i:70223;s:12:\"delete-70983\";i:70224;s:12:\"delete-70984\";i:70225;s:12:\"delete-70985\";i:70226;s:12:\"delete-70986\";i:70227;s:12:\"delete-70987\";i:70228;s:12:\"delete-70988\";i:70229;s:12:\"delete-70991\";i:70230;s:12:\"delete-70992\";i:70231;s:12:\"delete-70989\";i:70232;s:12:\"delete-70990\";i:70233;s:12:\"delete-70993\";i:70234;s:12:\"delete-70996\";i:70235;s:12:\"delete-70997\";i:70236;s:12:\"delete-70994\";i:70237;s:12:\"delete-70995\";i:70238;s:12:\"delete-70998\";i:70239;s:12:\"delete-71001\";i:70240;s:12:\"delete-71002\";i:70241;s:12:\"delete-71003\";i:70242;s:12:\"delete-71006\";i:70243;s:12:\"delete-71007\";i:70244;s:12:\"delete-70999\";i:70245;s:12:\"delete-71000\";i:70246;s:12:\"delete-71004\";i:70247;s:12:\"delete-71005\";i:70248;s:12:\"delete-71008\";i:70249;s:12:\"delete-71011\";i:70250;s:12:\"delete-71012\";i:70251;s:12:\"delete-71009\";i:70252;s:12:\"delete-71010\";i:70253;s:12:\"delete-71013\";i:70254;s:12:\"delete-71016\";i:70255;s:12:\"delete-71017\";i:70256;s:12:\"delete-71014\";i:70257;s:12:\"delete-71015\";i:70258;s:12:\"delete-71018\";i:70259;s:12:\"delete-71021\";i:70260;s:12:\"delete-71022\";i:70261;s:12:\"delete-71019\";i:70262;s:12:\"delete-71020\";i:70263;s:12:\"delete-71023\";i:70264;s:12:\"delete-71026\";i:70265;s:12:\"delete-71027\";i:70266;s:12:\"delete-71024\";i:70267;s:12:\"delete-71025\";i:70268;s:12:\"delete-71028\";i:70269;s:12:\"delete-71031\";i:70270;s:12:\"delete-71032\";i:70271;s:12:\"delete-71029\";i:70272;s:12:\"delete-71030\";i:70273;s:12:\"delete-71033\";i:70274;s:12:\"delete-71036\";i:70275;s:12:\"delete-71037\";i:70276;s:12:\"delete-71034\";i:70277;s:12:\"delete-71035\";i:70278;s:12:\"delete-71038\";i:70279;s:12:\"delete-71041\";i:70280;s:12:\"delete-71042\";i:70281;s:12:\"delete-71039\";i:70282;s:12:\"delete-71040\";i:70283;s:12:\"delete-71043\";i:70284;s:12:\"delete-71046\";i:70285;s:12:\"delete-71047\";i:70286;s:12:\"delete-71044\";i:70287;s:12:\"delete-71045\";i:70288;s:12:\"delete-71048\";i:70289;s:12:\"delete-71051\";i:70290;s:12:\"delete-71052\";i:70291;s:12:\"delete-71049\";i:70292;s:12:\"delete-71050\";i:70293;s:12:\"delete-71053\";i:70294;s:12:\"delete-71056\";i:70295;s:12:\"delete-71057\";i:70296;s:12:\"delete-71054\";i:70297;s:12:\"delete-71055\";i:70298;s:12:\"delete-71058\";i:70299;s:12:\"delete-71061\";i:70300;s:12:\"delete-71062\";i:70301;s:12:\"delete-71059\";i:70302;s:12:\"delete-71060\";i:70303;s:12:\"delete-71063\";i:70304;s:12:\"delete-71066\";i:70305;s:12:\"delete-71067\";i:70306;s:12:\"delete-71064\";i:70307;s:12:\"delete-71065\";i:70308;s:12:\"delete-71068\";i:70309;s:12:\"delete-71071\";i:70310;s:12:\"delete-71072\";i:70311;s:12:\"delete-71069\";i:70312;s:12:\"delete-71070\";i:70313;s:12:\"delete-71073\";i:70314;s:12:\"delete-71076\";i:70315;s:12:\"delete-71077\";i:70316;s:12:\"delete-71074\";i:70317;s:12:\"delete-71075\";i:70318;s:12:\"delete-71078\";i:70319;s:12:\"delete-71081\";i:70320;s:12:\"delete-71082\";i:70321;s:12:\"delete-71079\";i:70322;s:12:\"delete-71080\";i:70323;s:12:\"delete-71083\";i:70324;s:12:\"delete-71086\";i:70325;s:12:\"delete-71087\";i:70326;s:12:\"delete-71084\";i:70327;s:12:\"delete-71085\";i:70328;s:12:\"delete-71088\";i:70329;s:12:\"delete-71091\";i:70330;s:12:\"delete-71092\";i:70331;s:12:\"delete-71089\";i:70332;s:12:\"delete-71090\";i:70333;s:12:\"delete-71093\";i:70334;s:12:\"delete-71096\";i:70335;s:12:\"delete-71097\";i:70336;s:12:\"delete-71094\";i:70337;s:12:\"delete-71095\";i:70338;s:12:\"delete-71098\";i:70339;s:12:\"delete-71101\";i:70340;s:12:\"delete-71102\";i:70341;s:12:\"delete-71099\";i:70342;s:12:\"delete-71100\";i:70343;s:12:\"delete-71103\";i:70344;s:12:\"delete-71106\";i:70345;s:12:\"delete-71107\";i:70346;s:12:\"delete-71104\";i:70347;s:12:\"delete-71105\";i:70348;s:12:\"delete-71108\";i:70349;s:12:\"delete-71111\";i:70350;s:12:\"delete-71112\";i:70351;s:12:\"delete-71109\";i:70352;s:12:\"delete-71110\";i:70353;s:12:\"delete-71113\";i:70354;s:12:\"delete-71116\";i:70355;s:12:\"delete-71117\";i:70356;s:12:\"delete-71114\";i:70357;s:12:\"delete-71115\";i:70358;s:12:\"delete-71118\";i:70359;s:12:\"delete-71121\";i:70360;s:12:\"delete-71122\";i:70361;s:12:\"delete-71119\";i:70362;s:12:\"delete-71120\";i:70363;s:12:\"delete-71123\";i:70364;s:12:\"delete-71126\";i:70365;s:12:\"delete-71127\";i:70366;s:12:\"delete-71124\";i:70367;s:12:\"delete-71125\";i:70368;s:12:\"delete-71128\";i:70369;s:12:\"delete-71131\";i:70370;s:12:\"delete-71132\";i:70371;s:12:\"delete-71129\";i:70372;s:12:\"delete-71130\";i:70373;s:12:\"delete-71133\";i:70374;s:12:\"delete-71136\";i:70375;s:12:\"delete-71137\";i:70376;s:12:\"delete-71134\";i:70377;s:12:\"delete-71135\";i:70378;s:12:\"delete-71138\";i:70379;s:12:\"delete-71141\";i:70380;s:12:\"delete-71142\";i:70381;s:12:\"delete-71139\";i:70382;s:12:\"delete-71140\";i:70383;s:12:\"delete-71143\";i:70384;s:12:\"delete-71146\";i:70385;s:12:\"delete-71147\";i:70386;s:12:\"delete-71144\";i:70387;s:12:\"delete-71145\";i:70388;s:12:\"delete-71148\";i:70389;s:12:\"delete-71151\";i:70390;s:12:\"delete-71152\";i:70391;s:12:\"delete-71149\";i:70392;s:12:\"delete-71150\";i:70393;s:12:\"delete-71153\";i:70394;s:12:\"delete-71156\";i:70395;s:12:\"delete-71157\";i:70396;s:12:\"delete-71154\";i:70397;s:12:\"delete-71155\";i:70398;s:12:\"delete-71158\";i:70399;s:12:\"delete-71161\";i:70400;s:12:\"delete-71159\";i:70401;s:12:\"delete-71160\";i:70402;s:12:\"delete-71162\";i:70403;s:12:\"delete-71163\";i:70404;s:12:\"delete-71166\";i:70405;s:12:\"delete-71167\";i:70406;s:12:\"delete-71164\";i:70407;s:12:\"delete-71165\";i:70408;s:12:\"delete-71168\";i:70409;s:12:\"delete-71171\";i:70410;s:12:\"delete-71169\";i:70411;s:12:\"delete-71170\";i:70412;s:12:\"delete-71172\";i:70413;s:12:\"delete-71173\";i:70414;s:12:\"delete-71176\";i:70415;s:12:\"delete-71177\";i:70416;s:12:\"delete-71174\";i:70417;s:12:\"delete-71175\";i:70418;s:12:\"delete-71178\";i:70419;s:12:\"delete-71181\";i:70420;s:12:\"delete-71179\";i:70421;s:12:\"delete-71180\";i:70422;s:12:\"delete-71182\";i:70423;s:12:\"delete-71183\";i:70424;s:12:\"delete-71186\";i:70425;s:12:\"delete-71187\";i:70426;s:12:\"delete-71184\";i:70427;s:12:\"delete-71185\";i:70428;s:12:\"delete-71188\";i:70429;s:12:\"delete-71191\";i:70430;s:12:\"delete-71192\";i:70431;s:12:\"delete-71189\";i:70432;s:12:\"delete-71190\";i:70433;s:12:\"delete-71193\";i:70434;s:12:\"delete-71196\";i:70435;s:12:\"delete-71197\";i:70436;s:12:\"delete-71194\";i:70437;s:12:\"delete-71195\";i:70438;s:12:\"delete-71198\";i:70439;s:12:\"delete-71201\";i:70440;s:12:\"delete-71202\";i:70441;s:12:\"delete-71199\";i:70442;s:12:\"delete-71200\";i:70443;s:12:\"delete-71203\";i:70444;s:12:\"delete-71206\";i:70445;s:12:\"delete-71207\";i:70446;s:12:\"delete-71204\";i:70447;s:12:\"delete-71205\";i:70448;s:12:\"delete-71208\";i:70449;s:12:\"delete-71211\";i:70450;s:12:\"delete-71212\";i:70451;s:12:\"delete-71209\";i:70452;s:12:\"delete-71210\";i:70453;s:12:\"delete-71213\";i:70454;s:12:\"delete-71216\";i:70455;s:12:\"delete-71214\";i:70456;s:12:\"delete-71215\";i:70457;s:12:\"delete-71217\";i:70458;s:12:\"delete-71218\";i:70459;s:12:\"delete-71221\";i:70460;s:12:\"delete-71219\";i:70461;s:12:\"delete-71220\";i:70462;s:12:\"delete-71222\";i:70463;s:12:\"delete-71223\";i:70464;s:12:\"delete-71226\";i:70465;s:12:\"delete-71224\";i:70466;s:12:\"delete-71225\";i:70467;s:12:\"delete-71227\";i:70468;s:12:\"delete-71228\";i:70469;s:12:\"delete-71231\";i:70470;s:12:\"delete-71232\";i:70471;s:12:\"delete-71229\";i:70472;s:12:\"delete-71230\";i:70473;s:12:\"delete-71233\";i:70474;s:12:\"delete-71236\";i:70475;s:12:\"delete-71237\";i:70476;s:12:\"delete-71234\";i:70477;s:12:\"delete-71235\";i:70478;s:12:\"delete-71238\";i:70479;s:12:\"delete-71241\";i:70480;s:12:\"delete-71242\";i:70481;s:12:\"delete-71239\";i:70482;s:12:\"delete-71240\";i:70483;s:12:\"delete-71243\";i:70484;s:12:\"delete-71246\";i:70485;s:12:\"delete-71247\";i:70486;s:12:\"delete-71244\";i:70487;s:12:\"delete-71245\";i:70488;s:12:\"delete-71248\";i:70489;s:12:\"delete-71251\";i:70490;s:12:\"delete-71252\";i:70491;s:12:\"delete-71249\";i:70492;s:12:\"delete-71250\";i:70493;s:12:\"delete-71253\";i:70494;s:12:\"delete-71256\";i:70495;s:12:\"delete-71257\";i:70496;s:12:\"delete-71254\";i:70497;s:12:\"delete-71255\";i:70498;s:12:\"delete-71258\";i:70499;s:12:\"delete-71261\";i:70500;s:12:\"delete-71259\";i:70501;s:12:\"delete-71260\";i:70502;s:12:\"delete-71262\";i:70503;s:12:\"delete-71263\";i:70504;s:12:\"delete-71266\";i:70505;s:12:\"delete-71267\";i:70506;s:12:\"delete-71264\";i:70507;s:12:\"delete-71265\";i:70508;s:12:\"delete-71268\";i:70509;s:12:\"delete-71269\";i:70510;s:12:\"delete-71270\";i:70511;s:12:\"delete-71271\";i:70512;s:12:\"delete-71272\";i:70513;s:12:\"delete-71273\";i:70514;s:12:\"delete-71276\";i:70515;s:12:\"delete-71277\";i:70516;s:12:\"delete-71274\";i:70517;s:12:\"delete-71275\";i:70518;s:12:\"delete-71278\";i:70519;s:12:\"delete-71281\";i:70520;s:12:\"delete-71282\";i:70521;s:12:\"delete-71279\";i:70522;s:12:\"delete-71280\";i:70523;s:12:\"delete-71283\";i:70524;s:12:\"delete-71286\";i:70525;s:12:\"delete-71287\";i:70526;s:12:\"delete-71284\";i:70527;s:12:\"delete-71285\";i:70528;s:12:\"delete-71288\";i:70529;s:12:\"delete-71291\";i:70530;s:12:\"delete-71289\";i:70531;s:12:\"delete-71290\";i:70532;s:12:\"delete-71292\";i:70533;s:12:\"delete-71293\";i:70534;s:12:\"delete-71296\";i:70535;s:12:\"delete-71297\";i:70536;s:12:\"delete-71294\";i:70537;s:12:\"delete-71295\";i:70538;s:12:\"delete-71298\";i:70539;s:12:\"delete-71301\";i:70540;s:12:\"delete-71302\";i:70541;s:12:\"delete-71299\";i:70542;s:12:\"delete-71300\";i:70543;s:12:\"delete-71303\";i:70544;s:12:\"delete-71306\";i:70545;s:12:\"delete-71307\";i:70546;s:12:\"delete-71304\";i:70547;s:12:\"delete-71305\";i:70548;s:12:\"delete-71308\";i:70549;s:12:\"delete-71311\";i:70550;s:12:\"delete-71312\";i:70551;s:12:\"delete-71309\";i:70552;s:12:\"delete-71310\";i:70553;s:12:\"delete-71313\";i:70554;s:12:\"delete-71316\";i:70555;s:12:\"delete-71317\";i:70556;s:12:\"delete-71314\";i:70557;s:12:\"delete-71315\";i:70558;s:12:\"delete-71318\";i:70559;s:12:\"delete-71321\";i:70560;s:12:\"delete-71322\";i:70561;s:12:\"delete-71319\";i:70562;s:12:\"delete-71320\";i:70563;s:12:\"delete-71323\";i:70564;s:12:\"delete-71326\";i:70565;s:12:\"delete-71327\";i:70566;s:12:\"delete-71324\";i:70567;s:12:\"delete-71325\";i:70568;s:12:\"delete-71328\";i:70569;s:12:\"delete-71331\";i:70570;s:12:\"delete-71332\";i:70571;s:12:\"delete-71329\";i:70572;s:12:\"delete-71330\";i:70573;s:12:\"delete-71333\";i:70574;s:12:\"delete-71336\";i:70575;s:12:\"delete-71337\";i:70576;s:12:\"delete-71334\";i:70577;s:12:\"delete-71335\";i:70578;s:12:\"delete-71338\";i:70579;s:12:\"delete-71341\";i:70580;s:12:\"delete-71342\";i:70581;s:12:\"delete-71339\";i:70582;s:12:\"delete-71340\";i:70583;s:12:\"delete-71343\";i:70584;s:12:\"delete-71346\";i:70585;s:12:\"delete-71347\";i:70586;s:12:\"delete-71344\";i:70587;s:12:\"delete-71345\";i:70588;s:12:\"delete-71348\";i:70589;s:12:\"delete-71351\";i:70590;s:12:\"delete-71352\";i:70591;s:12:\"delete-71349\";i:70592;s:12:\"delete-71350\";i:70593;s:12:\"delete-71353\";i:70594;s:12:\"delete-71356\";i:70595;s:12:\"delete-71357\";i:70596;s:12:\"delete-71354\";i:70597;s:12:\"delete-71355\";i:70598;s:12:\"delete-71358\";i:70599;s:12:\"delete-71361\";i:70600;s:12:\"delete-71362\";i:70601;s:12:\"delete-71359\";i:70602;s:12:\"delete-71360\";i:70603;s:12:\"delete-71363\";i:70604;s:12:\"delete-71366\";i:70605;s:12:\"delete-71367\";i:70606;s:12:\"delete-71364\";i:70607;s:12:\"delete-71365\";i:70608;s:12:\"delete-71368\";i:70609;s:12:\"delete-71371\";i:70610;s:12:\"delete-71372\";i:70611;s:12:\"delete-71369\";i:70612;s:12:\"delete-71370\";i:70613;s:12:\"delete-71373\";i:70614;s:12:\"delete-71376\";i:70615;s:12:\"delete-71374\";i:70616;s:12:\"delete-71375\";i:70617;s:12:\"delete-71377\";i:70618;s:12:\"delete-71380\";i:70619;s:12:\"delete-71381\";i:70620;s:12:\"delete-71378\";i:70621;s:12:\"delete-71379\";i:70622;s:12:\"delete-71382\";i:70623;s:12:\"delete-71385\";i:70624;s:12:\"delete-71386\";i:70625;s:12:\"delete-71383\";i:70626;s:12:\"delete-71384\";i:70627;s:12:\"delete-71387\";i:70628;s:12:\"delete-71390\";i:70629;s:12:\"delete-71391\";i:70630;s:12:\"delete-71388\";i:70631;s:12:\"delete-71389\";i:70632;s:12:\"delete-71392\";i:70633;s:12:\"delete-71395\";i:70634;s:12:\"delete-71396\";i:70635;s:12:\"delete-71393\";i:70636;s:12:\"delete-71394\";i:70637;s:12:\"delete-71397\";i:70638;s:12:\"delete-71400\";i:70639;s:12:\"delete-71398\";i:70640;s:12:\"delete-71399\";i:70641;s:12:\"delete-71401\";i:70642;s:12:\"delete-71402\";i:70643;s:12:\"delete-71405\";i:70644;s:12:\"delete-71406\";i:70645;s:12:\"delete-71403\";i:70646;s:12:\"delete-71404\";i:70647;s:12:\"delete-71407\";i:70648;s:12:\"delete-71410\";i:70649;s:12:\"delete-71411\";i:70650;s:12:\"delete-71408\";i:70651;s:12:\"delete-71409\";i:70652;s:12:\"delete-71412\";i:70653;s:12:\"delete-71415\";i:70654;s:12:\"delete-71416\";i:70655;s:12:\"delete-71413\";i:70656;s:12:\"delete-71414\";i:70657;s:12:\"delete-71417\";i:70658;s:12:\"delete-71420\";i:70659;s:12:\"delete-71421\";i:70660;s:12:\"delete-71418\";i:70661;s:12:\"delete-71419\";i:70662;s:12:\"delete-71422\";i:70663;s:12:\"delete-71425\";i:70664;s:12:\"delete-71423\";i:70665;s:12:\"delete-71424\";i:70666;s:12:\"delete-71426\";i:70667;s:12:\"delete-71427\";i:70668;s:12:\"delete-71430\";i:70669;s:12:\"delete-71428\";i:70670;s:12:\"delete-71429\";i:70671;s:12:\"delete-71431\";i:70672;s:12:\"delete-71432\";i:70673;s:12:\"delete-71435\";i:70674;s:12:\"delete-71436\";i:70675;s:12:\"delete-71433\";i:70676;s:12:\"delete-71434\";i:70677;s:12:\"delete-71437\";i:70678;s:12:\"delete-71440\";i:70679;s:12:\"delete-71441\";i:70680;s:12:\"delete-71438\";i:70681;s:12:\"delete-71439\";i:70682;s:12:\"delete-71442\";i:70683;s:12:\"delete-71445\";i:70684;s:12:\"delete-71446\";i:70685;s:12:\"delete-71443\";i:70686;s:12:\"delete-71444\";i:70687;s:12:\"delete-71447\";i:70688;s:12:\"delete-71450\";i:70689;s:12:\"delete-71448\";i:70690;s:12:\"delete-71449\";i:70691;s:12:\"delete-71451\";i:70692;s:12:\"delete-71452\";i:70693;s:12:\"delete-71455\";i:70694;s:12:\"delete-71456\";i:70695;s:12:\"delete-71453\";i:70696;s:12:\"delete-71454\";i:70697;s:12:\"delete-71457\";i:70698;s:12:\"delete-71460\";i:70699;s:12:\"delete-71461\";i:70700;s:12:\"delete-71458\";i:70701;s:12:\"delete-71459\";i:70702;s:12:\"delete-71462\";i:70703;s:12:\"delete-71465\";i:70704;s:12:\"delete-71466\";i:70705;s:12:\"delete-71463\";i:70706;s:12:\"delete-71464\";i:70707;s:12:\"delete-71467\";i:70708;s:12:\"delete-71470\";i:70709;s:12:\"delete-71471\";i:70710;s:12:\"delete-71468\";i:70711;s:12:\"delete-71469\";i:70712;s:12:\"delete-71472\";i:70713;s:12:\"delete-71475\";i:70714;s:12:\"delete-71476\";i:70715;s:12:\"delete-71473\";i:70716;s:12:\"delete-71474\";i:70717;s:12:\"delete-71477\";i:70718;s:12:\"delete-71480\";i:70719;s:12:\"delete-71481\";i:70720;s:12:\"delete-71478\";i:70721;s:12:\"delete-71479\";i:70722;s:12:\"delete-71482\";i:70723;s:12:\"delete-71485\";i:70724;s:12:\"delete-71483\";i:70725;s:12:\"delete-71484\";i:70726;s:12:\"delete-71486\";i:70727;s:12:\"delete-71487\";i:70728;s:12:\"delete-71490\";i:70729;s:12:\"delete-71491\";i:70730;s:12:\"delete-71488\";i:70731;s:12:\"delete-71489\";i:70732;s:12:\"delete-71492\";i:70733;s:12:\"delete-71495\";i:70734;s:12:\"delete-71496\";i:70735;s:12:\"delete-71493\";i:70736;s:12:\"delete-71494\";i:70737;s:12:\"delete-71497\";i:70738;s:12:\"delete-71500\";i:70739;s:12:\"delete-71501\";i:70740;s:12:\"delete-71498\";i:70741;s:12:\"delete-71499\";i:70742;s:12:\"delete-71502\";i:70743;s:12:\"delete-71505\";i:70744;s:12:\"delete-71506\";i:70745;s:12:\"delete-71503\";i:70746;s:12:\"delete-71504\";i:70747;s:12:\"delete-71507\";i:70748;s:12:\"delete-71510\";i:70749;s:12:\"delete-71511\";i:70750;s:12:\"delete-71508\";i:70751;s:12:\"delete-71509\";i:70752;s:12:\"delete-71512\";i:70753;s:12:\"delete-71515\";i:70754;s:12:\"delete-71516\";i:70755;s:12:\"delete-71513\";i:70756;s:12:\"delete-71514\";i:70757;s:12:\"delete-71517\";i:70758;s:12:\"delete-71520\";i:70759;s:12:\"delete-71521\";i:70760;s:12:\"delete-71518\";i:70761;s:12:\"delete-71519\";i:70762;s:12:\"delete-71522\";i:70763;s:12:\"delete-71525\";i:70764;s:12:\"delete-71526\";i:70765;s:12:\"delete-71523\";i:70766;s:12:\"delete-71524\";i:70767;s:12:\"delete-71527\";i:70768;s:12:\"delete-71530\";i:70769;s:12:\"delete-71531\";i:70770;s:12:\"delete-71528\";i:70771;s:12:\"delete-71529\";i:70772;s:12:\"delete-71532\";i:70773;s:12:\"delete-71535\";i:70774;s:12:\"delete-71536\";i:70775;s:12:\"delete-71533\";i:70776;s:12:\"delete-71534\";i:70777;s:12:\"delete-71537\";i:70778;s:12:\"delete-71540\";i:70779;s:12:\"delete-71541\";i:70780;s:12:\"delete-71538\";i:70781;s:12:\"delete-71539\";i:70782;s:12:\"delete-71542\";i:70783;s:12:\"delete-71545\";i:70784;s:12:\"delete-71546\";i:70785;s:12:\"delete-71543\";i:70786;s:12:\"delete-71544\";i:70787;s:12:\"delete-71547\";i:70788;s:12:\"delete-71550\";i:70789;s:12:\"delete-71551\";i:70790;s:12:\"delete-71548\";i:70791;s:12:\"delete-71549\";i:70792;s:12:\"delete-71552\";i:70793;s:12:\"delete-71555\";i:70794;s:12:\"delete-71556\";i:70795;s:12:\"delete-71553\";i:70796;s:12:\"delete-71554\";i:70797;s:12:\"delete-71557\";i:70798;s:12:\"delete-71560\";i:70799;s:12:\"delete-71561\";i:70800;s:12:\"delete-71558\";i:70801;s:12:\"delete-71559\";i:70802;s:12:\"delete-71562\";i:70803;s:12:\"delete-71565\";i:70804;s:12:\"delete-71566\";i:70805;s:12:\"delete-71563\";i:70806;s:12:\"delete-71564\";i:70807;s:12:\"delete-71567\";i:70808;s:12:\"delete-71570\";i:70809;s:12:\"delete-71571\";i:70810;s:12:\"delete-71568\";i:70811;s:12:\"delete-71569\";i:70812;s:12:\"delete-71572\";i:70813;s:12:\"delete-71575\";i:70814;s:12:\"delete-71576\";i:70815;s:12:\"delete-71573\";i:70816;s:12:\"delete-71574\";i:70817;s:12:\"delete-71577\";i:70818;s:12:\"delete-71580\";i:70819;s:12:\"delete-71581\";i:70820;s:12:\"delete-71578\";i:70821;s:12:\"delete-71579\";i:70822;s:12:\"delete-71582\";i:70823;s:12:\"delete-71585\";i:70824;s:12:\"delete-71586\";i:70825;s:12:\"delete-71583\";i:70826;s:12:\"delete-71584\";i:70827;s:12:\"delete-71587\";i:70828;s:12:\"delete-71588\";i:70829;s:12:\"delete-71589\";i:70830;s:12:\"delete-71590\";i:70831;s:12:\"delete-71591\";i:70832;s:12:\"delete-71592\";i:70833;s:12:\"delete-71595\";i:70834;s:12:\"delete-71596\";i:70835;s:12:\"delete-71593\";i:70836;s:12:\"delete-71594\";i:70837;s:12:\"delete-71597\";i:70838;s:12:\"delete-71600\";i:70839;s:12:\"delete-71601\";i:70840;s:12:\"delete-71598\";i:70841;s:12:\"delete-71599\";i:70842;s:12:\"delete-71602\";i:70843;s:12:\"delete-71605\";i:70844;s:12:\"delete-71606\";i:70845;s:12:\"delete-71603\";i:70846;s:12:\"delete-71604\";i:70847;s:12:\"delete-71607\";i:70848;s:12:\"delete-71610\";i:70849;s:12:\"delete-71611\";i:70850;s:12:\"delete-71608\";i:70851;s:12:\"delete-71609\";i:70852;s:12:\"delete-71612\";i:70853;s:12:\"delete-71615\";i:70854;s:12:\"delete-71616\";i:70855;s:12:\"delete-71613\";i:70856;s:12:\"delete-71614\";i:70857;s:12:\"delete-71617\";i:70858;s:12:\"delete-71620\";i:70859;s:12:\"delete-71621\";i:70860;s:12:\"delete-71618\";i:70861;s:12:\"delete-71619\";i:70862;s:12:\"delete-71622\";i:70863;s:12:\"delete-71625\";i:70864;s:12:\"delete-71623\";i:70865;s:12:\"delete-71624\";i:70866;s:12:\"delete-71626\";i:70867;s:12:\"delete-71627\";i:70868;s:12:\"delete-71630\";i:70869;s:12:\"delete-71631\";i:70870;s:12:\"delete-71628\";i:70871;s:12:\"delete-71629\";i:70872;s:12:\"delete-71632\";i:70873;s:12:\"delete-71635\";i:70874;s:12:\"delete-71636\";i:70875;s:12:\"delete-71633\";i:70876;s:12:\"delete-71634\";i:70877;s:12:\"delete-71637\";i:70878;s:12:\"delete-71640\";i:70879;s:12:\"delete-71641\";i:70880;s:12:\"delete-71638\";i:70881;s:12:\"delete-71639\";i:70882;s:12:\"delete-71642\";i:70883;s:12:\"delete-71645\";i:70884;s:12:\"delete-71646\";i:70885;s:12:\"delete-71643\";i:70886;s:12:\"delete-71644\";i:70887;s:12:\"delete-71647\";i:70888;s:12:\"delete-71650\";i:70889;s:12:\"delete-71651\";i:70890;s:12:\"delete-71648\";i:70891;s:12:\"delete-71649\";i:70892;s:12:\"delete-71652\";i:70893;s:12:\"delete-71655\";i:70894;s:12:\"delete-71656\";i:70895;s:12:\"delete-71653\";i:70896;s:12:\"delete-71654\";i:70897;s:12:\"delete-71657\";i:70898;s:12:\"delete-71660\";i:70899;s:12:\"delete-71658\";i:70900;s:12:\"delete-71659\";i:70901;s:12:\"delete-71661\";i:70902;s:12:\"delete-71662\";i:70903;s:12:\"delete-71665\";i:70904;s:12:\"delete-71666\";i:70905;s:12:\"delete-71663\";i:70906;s:12:\"delete-71664\";i:70907;s:12:\"delete-71667\";i:70908;s:12:\"delete-71670\";i:70909;s:12:\"delete-71668\";i:70910;s:12:\"delete-71669\";i:70911;s:12:\"delete-71671\";i:70912;s:12:\"delete-71672\";i:70913;s:12:\"delete-71675\";i:70914;s:12:\"delete-71676\";i:70915;s:12:\"delete-71673\";i:70916;s:12:\"delete-71674\";i:70917;s:12:\"delete-71677\";i:70918;s:12:\"delete-71680\";i:70919;s:12:\"delete-71681\";i:70920;s:12:\"delete-71678\";i:70921;s:12:\"delete-71679\";i:70922;s:12:\"delete-71682\";i:70923;s:12:\"delete-71685\";i:70924;s:12:\"delete-71686\";i:70925;s:12:\"delete-71683\";i:70926;s:12:\"delete-71684\";i:70927;s:12:\"delete-71687\";i:70928;s:12:\"delete-71690\";i:70929;s:12:\"delete-71691\";i:70930;s:12:\"delete-71688\";i:70931;s:12:\"delete-71689\";i:70932;s:12:\"delete-71692\";i:70933;s:12:\"delete-71695\";i:70934;s:12:\"delete-71696\";i:70935;s:12:\"delete-71693\";i:70936;s:12:\"delete-71694\";i:70937;s:12:\"delete-71697\";i:70938;s:12:\"delete-71700\";i:70939;s:12:\"delete-71701\";i:70940;s:12:\"delete-71698\";i:70941;s:12:\"delete-71699\";i:70942;s:12:\"delete-71702\";i:70943;s:12:\"delete-71705\";i:70944;s:12:\"delete-71706\";i:70945;s:12:\"delete-71703\";i:70946;s:12:\"delete-71704\";i:70947;s:12:\"delete-71707\";i:70948;s:12:\"delete-71710\";i:70949;s:12:\"delete-71711\";i:70950;s:12:\"delete-71708\";i:70951;s:12:\"delete-71709\";i:70952;s:12:\"delete-71712\";i:70953;s:12:\"delete-71715\";i:70954;s:12:\"delete-71716\";i:70955;s:12:\"delete-71713\";i:70956;s:12:\"delete-71714\";i:70957;s:12:\"delete-71717\";i:70958;s:12:\"delete-71720\";i:70959;s:12:\"delete-71721\";i:70960;s:12:\"delete-71718\";i:70961;s:12:\"delete-71719\";i:70962;s:12:\"delete-71722\";i:70963;s:12:\"delete-71725\";i:70964;s:12:\"delete-71726\";i:70965;s:12:\"delete-71723\";i:70966;s:12:\"delete-71724\";i:70967;s:12:\"delete-71727\";i:70968;s:12:\"delete-71730\";i:70969;s:12:\"delete-71731\";i:70970;s:12:\"delete-71728\";i:70971;s:12:\"delete-71729\";i:70972;s:12:\"delete-71732\";i:70973;s:12:\"delete-71735\";i:70974;s:12:\"delete-71736\";i:70975;s:12:\"delete-71733\";i:70976;s:12:\"delete-71734\";i:70977;s:12:\"delete-71737\";i:70978;s:12:\"delete-71740\";i:70979;s:12:\"delete-71741\";i:70980;s:12:\"delete-71738\";i:70981;s:12:\"delete-71739\";i:70982;s:12:\"delete-71742\";i:70983;s:12:\"delete-71745\";i:70984;s:12:\"delete-71746\";i:70985;s:12:\"delete-71743\";i:70986;s:12:\"delete-71744\";i:70987;s:12:\"delete-71747\";i:70988;s:12:\"delete-71750\";i:70989;s:12:\"delete-71751\";i:70990;s:12:\"delete-71748\";i:70991;s:12:\"delete-71749\";i:70992;s:12:\"delete-71752\";i:70993;s:12:\"delete-71755\";i:70994;s:12:\"delete-71756\";i:70995;s:12:\"delete-71753\";i:70996;s:12:\"delete-71754\";i:70997;s:12:\"delete-71757\";i:70998;s:12:\"delete-71760\";i:70999;s:12:\"delete-71761\";i:71000;s:12:\"delete-71762\";i:71001;s:12:\"delete-71765\";i:71002;s:12:\"delete-71766\";i:71003;s:12:\"delete-71758\";i:71004;s:12:\"delete-71759\";i:71005;s:12:\"delete-71763\";i:71006;s:12:\"delete-71764\";i:71007;s:12:\"delete-71767\";i:71008;s:12:\"delete-71770\";i:71009;s:12:\"delete-71771\";i:71010;s:12:\"delete-71768\";i:71011;s:12:\"delete-71769\";i:71012;s:12:\"delete-71772\";i:71013;s:12:\"delete-71775\";i:71014;s:12:\"delete-71776\";i:71015;s:12:\"delete-71773\";i:71016;s:12:\"delete-71774\";i:71017;s:12:\"delete-71777\";i:71018;s:12:\"delete-71780\";i:71019;s:12:\"delete-71781\";i:71020;s:12:\"delete-71778\";i:71021;s:12:\"delete-71779\";i:71022;s:12:\"delete-71782\";i:71023;s:12:\"delete-71785\";i:71024;s:12:\"delete-71786\";i:71025;s:12:\"delete-71783\";i:71026;s:12:\"delete-71784\";i:71027;s:12:\"delete-71787\";i:71028;s:12:\"delete-71790\";i:71029;s:12:\"delete-71788\";i:71030;s:12:\"delete-71789\";i:71031;s:12:\"delete-71791\";i:71032;s:12:\"delete-71792\";i:71033;s:12:\"delete-71795\";i:71034;s:12:\"delete-71796\";i:71035;s:12:\"delete-71793\";i:71036;s:12:\"delete-71794\";i:71037;s:12:\"delete-71797\";i:71038;s:12:\"delete-71800\";i:71039;s:12:\"delete-71801\";i:71040;s:12:\"delete-71798\";i:71041;s:12:\"delete-71799\";i:71042;s:12:\"delete-71802\";i:71043;s:12:\"delete-71805\";i:71044;s:12:\"delete-71806\";i:71045;s:12:\"delete-71803\";i:71046;s:12:\"delete-71804\";i:71047;s:12:\"delete-71807\";i:71048;s:12:\"delete-71810\";i:71049;s:12:\"delete-71811\";i:71050;s:12:\"delete-71808\";i:71051;s:12:\"delete-71809\";i:71052;s:12:\"delete-71812\";i:71053;s:12:\"delete-71815\";i:71054;s:12:\"delete-71816\";i:71055;s:12:\"delete-71813\";i:71056;s:12:\"delete-71814\";i:71057;s:12:\"delete-71817\";i:71058;s:12:\"delete-71820\";i:71059;s:12:\"delete-71818\";i:71060;s:12:\"delete-71819\";i:71061;s:12:\"delete-71821\";i:71062;s:12:\"delete-71823\";i:71063;s:12:\"delete-71824\";i:71064;s:12:\"delete-71822\";i:71065;s:12:\"delete-71825\";i:71066;s:12:\"delete-71826\";i:71067;s:12:\"delete-71827\";i:71068;s:12:\"delete-71830\";i:71069;s:12:\"delete-71831\";i:71070;s:12:\"delete-71828\";i:71071;s:12:\"delete-71829\";i:71072;s:12:\"delete-71832\";i:71073;s:12:\"delete-71835\";i:71074;s:12:\"delete-71836\";i:71075;s:12:\"delete-71833\";i:71076;s:12:\"delete-71834\";i:71077;s:12:\"delete-71837\";i:71078;s:12:\"delete-71840\";i:71079;s:12:\"delete-71841\";i:71080;s:12:\"delete-71838\";i:71081;s:12:\"delete-71839\";i:71082;s:12:\"delete-71842\";i:71083;s:12:\"delete-71845\";i:71084;s:12:\"delete-71846\";i:71085;s:12:\"delete-71843\";i:71086;s:12:\"delete-71844\";i:71087;s:12:\"delete-71847\";i:71088;s:12:\"delete-71850\";i:71089;s:12:\"delete-71851\";i:71090;s:12:\"delete-71848\";i:71091;s:12:\"delete-71849\";i:71092;s:12:\"delete-71852\";i:71093;s:12:\"delete-71855\";i:71094;s:12:\"delete-71856\";i:71095;s:12:\"delete-71853\";i:71096;s:12:\"delete-71854\";i:71097;s:12:\"delete-71857\";i:71098;s:12:\"delete-71860\";i:71099;s:12:\"delete-71861\";i:71100;s:12:\"delete-71858\";i:71101;s:12:\"delete-71859\";i:71102;s:12:\"delete-71862\";i:71103;s:12:\"delete-71865\";i:71104;s:12:\"delete-71863\";i:71105;s:12:\"delete-71864\";i:71106;s:12:\"delete-71866\";i:71107;s:12:\"delete-71867\";i:71108;s:12:\"delete-71870\";i:71109;s:12:\"delete-71871\";i:71110;s:12:\"delete-71868\";i:71111;s:12:\"delete-71869\";i:71112;s:12:\"delete-71872\";i:71113;s:12:\"delete-71875\";i:71114;s:12:\"delete-71876\";i:71115;s:12:\"delete-71873\";i:71116;s:12:\"delete-71874\";i:71117;s:12:\"delete-71877\";i:71118;s:12:\"delete-71880\";i:71119;s:12:\"delete-71881\";i:71120;s:12:\"delete-71878\";i:71121;s:12:\"delete-71879\";i:71122;s:12:\"delete-71882\";i:71123;s:12:\"delete-71885\";i:71124;s:12:\"delete-71886\";i:71125;s:12:\"delete-71883\";i:71126;s:12:\"delete-71884\";i:71127;s:12:\"delete-71887\";i:71128;s:12:\"delete-71890\";i:71129;s:12:\"delete-71891\";i:71130;s:12:\"delete-71888\";i:71131;s:12:\"delete-71889\";i:71132;s:12:\"delete-71892\";i:71133;s:12:\"delete-71895\";i:71134;s:12:\"delete-71896\";i:71135;s:12:\"delete-71893\";i:71136;s:12:\"delete-71894\";i:71137;s:12:\"delete-71897\";i:71138;s:12:\"delete-71900\";i:71139;s:12:\"delete-71901\";i:71140;s:12:\"delete-71898\";i:71141;s:12:\"delete-71899\";i:71142;s:12:\"delete-71902\";i:71143;s:12:\"delete-71905\";i:71144;s:12:\"delete-71906\";i:71145;s:12:\"delete-71903\";i:71146;s:12:\"delete-71904\";i:71147;s:12:\"delete-71907\";i:71148;s:12:\"delete-71910\";i:71149;s:12:\"delete-71911\";i:71150;s:12:\"delete-71908\";i:71151;s:12:\"delete-71909\";i:71152;s:12:\"delete-71912\";i:71153;s:12:\"delete-71915\";i:71154;s:12:\"delete-71916\";i:71155;s:12:\"delete-71913\";i:71156;s:12:\"delete-71914\";i:71157;s:12:\"delete-71917\";i:71158;s:12:\"delete-71920\";i:71159;s:12:\"delete-71921\";i:71160;s:12:\"delete-71918\";i:71161;s:12:\"delete-71919\";i:71162;s:12:\"delete-71922\";i:71163;s:12:\"delete-71925\";i:71164;s:12:\"delete-71926\";i:71165;s:12:\"delete-71923\";i:71166;s:12:\"delete-71924\";i:71167;s:12:\"delete-71927\";i:71168;s:12:\"delete-71930\";i:71169;s:12:\"delete-71931\";i:71170;s:12:\"delete-71928\";i:71171;s:12:\"delete-71929\";i:71172;s:12:\"delete-71932\";i:71173;s:12:\"delete-71935\";i:71174;s:12:\"delete-71936\";i:71175;s:12:\"delete-71933\";i:71176;s:12:\"delete-71934\";i:71177;s:12:\"delete-71937\";i:71178;s:12:\"delete-71940\";i:71179;s:12:\"delete-71941\";i:71180;s:12:\"delete-71938\";i:71181;s:12:\"delete-71939\";i:71182;s:12:\"delete-71942\";i:71183;s:12:\"delete-71945\";i:71184;s:12:\"delete-71946\";i:71185;s:12:\"delete-71943\";i:71186;s:12:\"delete-71944\";i:71187;s:12:\"delete-71947\";i:71188;s:12:\"delete-71950\";i:71189;s:12:\"delete-71951\";i:71190;s:12:\"delete-71948\";i:71191;s:12:\"delete-71949\";i:71192;s:12:\"delete-71952\";i:71193;s:12:\"delete-71955\";i:71194;s:12:\"delete-71956\";i:71195;s:12:\"delete-71953\";i:71196;s:12:\"delete-71954\";i:71197;s:12:\"delete-71957\";i:71198;s:12:\"delete-71960\";i:71199;s:12:\"delete-71961\";i:71200;s:12:\"delete-71958\";i:71201;s:12:\"delete-71959\";i:71202;s:12:\"delete-71962\";i:71203;s:12:\"delete-71965\";i:71204;s:12:\"delete-71966\";i:71205;s:12:\"delete-71963\";i:71206;s:12:\"delete-71964\";i:71207;s:12:\"delete-71967\";i:71208;s:12:\"delete-71970\";i:71209;s:12:\"delete-71971\";i:71210;s:12:\"delete-71968\";i:71211;s:12:\"delete-71969\";i:71212;s:12:\"delete-71972\";i:71213;s:12:\"delete-71975\";i:71214;s:12:\"delete-71976\";i:71215;s:12:\"delete-71973\";i:71216;s:12:\"delete-71974\";i:71217;s:12:\"delete-71977\";i:71218;s:12:\"delete-71980\";i:71219;s:12:\"delete-71981\";i:71220;s:12:\"delete-71978\";i:71221;s:12:\"delete-71979\";i:71222;s:12:\"delete-71982\";i:71223;s:12:\"delete-71985\";i:71224;s:12:\"delete-71986\";i:71225;s:12:\"delete-71983\";i:71226;s:12:\"delete-71984\";i:71227;s:12:\"delete-71987\";i:71228;s:12:\"delete-71990\";i:71229;s:12:\"delete-71991\";i:71230;s:12:\"delete-71988\";i:71231;s:12:\"delete-71989\";i:71232;s:12:\"delete-71992\";i:71233;s:12:\"delete-71995\";i:71234;s:12:\"delete-71996\";i:71235;s:12:\"delete-71993\";i:71236;s:12:\"delete-71994\";i:71237;s:12:\"delete-71997\";i:71238;s:12:\"delete-72000\";i:71239;s:12:\"delete-71998\";i:71240;s:12:\"delete-71999\";i:71241;s:12:\"delete-72001\";i:71242;s:12:\"delete-72002\";i:71243;s:12:\"delete-72005\";i:71244;s:12:\"delete-72006\";i:71245;s:12:\"delete-72003\";i:71246;s:12:\"delete-72004\";i:71247;s:12:\"delete-72007\";i:71248;s:12:\"delete-72010\";i:71249;s:12:\"delete-72011\";i:71250;s:12:\"delete-72008\";i:71251;s:12:\"delete-72009\";i:71252;s:12:\"delete-72012\";i:71253;s:12:\"delete-72015\";i:71254;s:12:\"delete-72016\";i:71255;s:12:\"delete-72013\";i:71256;s:12:\"delete-72014\";i:71257;s:12:\"delete-72017\";i:71258;s:12:\"delete-72020\";i:71259;s:12:\"delete-72021\";i:71260;s:12:\"delete-72018\";i:71261;s:12:\"delete-72019\";i:71262;s:12:\"delete-72022\";i:71263;s:12:\"delete-72025\";i:71264;s:12:\"delete-72026\";i:71265;s:12:\"delete-72023\";i:71266;s:12:\"delete-72024\";i:71267;s:12:\"delete-72027\";i:71268;s:12:\"delete-72030\";i:71269;s:12:\"delete-72031\";i:71270;s:12:\"delete-72028\";i:71271;s:12:\"delete-72029\";i:71272;s:12:\"delete-72032\";i:71273;s:12:\"delete-72035\";i:71274;s:12:\"delete-72036\";i:71275;s:12:\"delete-72033\";i:71276;s:12:\"delete-72034\";i:71277;s:12:\"delete-72037\";i:71278;s:12:\"delete-72040\";i:71279;s:12:\"delete-72041\";i:71280;s:12:\"delete-72038\";i:71281;s:12:\"delete-72039\";i:71282;s:12:\"delete-72042\";i:71283;s:12:\"delete-72045\";i:71284;s:12:\"delete-72046\";i:71285;s:12:\"delete-72043\";i:71286;s:12:\"delete-72044\";i:71287;s:12:\"delete-72047\";i:71288;s:12:\"delete-72050\";i:71289;s:12:\"delete-72051\";i:71290;s:12:\"delete-72048\";i:71291;s:12:\"delete-72049\";i:71292;s:12:\"delete-72052\";i:71293;s:12:\"delete-72055\";i:71294;s:12:\"delete-72056\";i:71295;s:12:\"delete-72053\";i:71296;s:12:\"delete-72054\";i:71297;s:12:\"delete-72057\";i:71298;s:12:\"delete-72060\";i:71299;s:12:\"delete-72061\";i:71300;s:12:\"delete-72058\";i:71301;s:12:\"delete-72059\";i:71302;s:12:\"delete-72062\";i:71303;s:12:\"delete-72065\";i:71304;s:12:\"delete-72066\";i:71305;s:12:\"delete-72063\";i:71306;s:12:\"delete-72064\";i:71307;s:12:\"delete-72067\";i:71308;s:12:\"delete-72070\";i:71309;s:12:\"delete-72071\";i:71310;s:12:\"delete-72068\";i:71311;s:12:\"delete-72069\";i:71312;s:12:\"delete-72072\";i:71313;s:12:\"delete-72075\";i:71314;s:12:\"delete-72076\";i:71315;s:12:\"delete-72073\";i:71316;s:12:\"delete-72074\";i:71317;s:12:\"delete-72077\";i:71318;s:12:\"delete-72080\";i:71319;s:12:\"delete-72081\";i:71320;s:12:\"delete-72078\";i:71321;s:12:\"delete-72079\";i:71322;s:12:\"delete-72082\";i:71323;s:12:\"delete-72085\";i:71324;s:12:\"delete-72086\";i:71325;s:12:\"delete-72083\";i:71326;s:12:\"delete-72084\";i:71327;s:12:\"delete-72087\";i:71328;s:12:\"delete-72090\";i:71329;s:12:\"delete-72091\";i:71330;s:12:\"delete-72088\";i:71331;s:12:\"delete-72089\";i:71332;s:12:\"delete-72092\";i:71333;s:12:\"delete-72095\";i:71334;s:12:\"delete-72096\";i:71335;s:12:\"delete-72093\";i:71336;s:12:\"delete-72094\";i:71337;s:12:\"delete-72097\";i:71338;s:12:\"delete-72100\";i:71339;s:12:\"delete-72101\";i:71340;s:12:\"delete-72098\";i:71341;s:12:\"delete-72099\";i:71342;s:12:\"delete-72102\";i:71343;s:12:\"delete-72105\";i:71344;s:12:\"delete-72106\";i:71345;s:12:\"delete-72103\";i:71346;s:12:\"delete-72104\";i:71347;s:12:\"delete-72107\";i:71348;s:12:\"delete-72110\";i:71349;s:12:\"delete-72111\";i:71350;s:12:\"delete-72108\";i:71351;s:12:\"delete-72109\";i:71352;s:12:\"delete-72112\";i:71353;s:12:\"delete-72115\";i:71354;s:12:\"delete-72116\";i:71355;s:12:\"delete-72113\";i:71356;s:12:\"delete-72114\";i:71357;s:12:\"delete-72117\";i:71358;s:12:\"delete-72120\";i:71359;s:12:\"delete-72121\";i:71360;s:12:\"delete-72118\";i:71361;s:12:\"delete-72119\";i:71362;s:12:\"delete-72122\";i:71363;s:12:\"delete-72125\";i:71364;s:12:\"delete-72126\";i:71365;s:12:\"delete-72123\";i:71366;s:12:\"delete-72124\";i:71367;s:12:\"delete-72127\";i:71368;s:12:\"delete-72130\";i:71369;s:12:\"delete-72131\";i:71370;s:12:\"delete-72128\";i:71371;s:12:\"delete-72129\";i:71372;s:12:\"delete-72132\";i:71373;s:12:\"delete-72135\";i:71374;s:12:\"delete-72136\";i:71375;s:12:\"delete-72133\";i:71376;s:12:\"delete-72134\";i:71377;s:12:\"delete-72137\";i:71378;s:12:\"delete-72140\";i:71379;s:12:\"delete-72141\";i:71380;s:12:\"delete-72138\";i:71381;s:12:\"delete-72139\";i:71382;s:12:\"delete-72142\";i:71383;s:12:\"delete-72145\";i:71384;s:12:\"delete-72146\";i:71385;s:12:\"delete-72143\";i:71386;s:12:\"delete-72144\";i:71387;s:12:\"delete-72147\";i:71388;s:12:\"delete-72150\";i:71389;s:12:\"delete-72151\";i:71390;s:12:\"delete-72148\";i:71391;s:12:\"delete-72149\";i:71392;s:12:\"delete-72152\";i:71393;s:12:\"delete-72155\";i:71394;s:12:\"delete-72156\";i:71395;s:12:\"delete-72153\";i:71396;s:12:\"delete-72154\";i:71397;s:12:\"delete-72157\";i:71398;s:12:\"delete-72160\";i:71399;s:12:\"delete-72161\";i:71400;s:12:\"delete-72158\";i:71401;s:12:\"delete-72159\";i:71402;s:12:\"delete-72162\";i:71403;s:12:\"delete-72165\";i:71404;s:12:\"delete-72166\";i:71405;s:12:\"delete-72163\";i:71406;s:12:\"delete-72164\";i:71407;s:12:\"delete-72167\";i:71408;s:12:\"delete-72168\";i:71409;s:12:\"delete-72169\";i:71410;s:12:\"delete-72170\";i:71411;s:12:\"delete-72171\";i:71412;s:12:\"delete-72172\";i:71413;s:12:\"delete-72175\";i:71414;s:12:\"delete-72176\";i:71415;s:12:\"delete-72173\";i:71416;s:12:\"delete-72174\";i:71417;s:12:\"delete-72177\";i:71418;s:12:\"delete-72180\";i:71419;s:12:\"delete-72181\";i:71420;s:12:\"delete-72178\";i:71421;s:12:\"delete-72179\";i:71422;s:12:\"delete-72182\";i:71423;s:12:\"delete-72185\";i:71424;s:12:\"delete-72186\";i:71425;s:12:\"delete-72183\";i:71426;s:12:\"delete-72184\";i:71427;s:12:\"delete-72187\";i:71428;s:12:\"delete-72190\";i:71429;s:12:\"delete-72191\";i:71430;s:12:\"delete-72188\";i:71431;s:12:\"delete-72189\";i:71432;s:12:\"delete-72192\";i:71433;s:12:\"delete-72195\";i:71434;s:12:\"delete-72196\";i:71435;s:12:\"delete-72193\";i:71436;s:12:\"delete-72194\";i:71437;s:12:\"delete-72197\";i:71438;s:12:\"delete-72200\";i:71439;s:12:\"delete-72201\";i:71440;s:12:\"delete-72198\";i:71441;s:12:\"delete-72199\";i:71442;s:12:\"delete-72202\";i:71443;s:12:\"delete-72205\";i:71444;s:12:\"delete-72206\";i:71445;s:12:\"delete-72203\";i:71446;s:12:\"delete-72204\";i:71447;s:12:\"delete-72207\";i:71448;s:12:\"delete-72210\";i:71449;s:12:\"delete-72211\";i:71450;s:12:\"delete-72208\";i:71451;s:12:\"delete-72209\";i:71452;s:12:\"delete-72212\";i:71453;s:12:\"delete-72215\";i:71454;s:12:\"delete-72216\";i:71455;s:12:\"delete-72213\";i:71456;s:12:\"delete-72214\";i:71457;s:12:\"delete-72217\";i:71458;s:12:\"delete-72220\";i:71459;s:12:\"delete-72221\";i:71460;s:12:\"delete-72218\";i:71461;s:12:\"delete-72219\";i:71462;s:12:\"delete-72222\";i:71463;s:12:\"delete-72225\";i:71464;s:12:\"delete-72226\";i:71465;s:12:\"delete-72223\";i:71466;s:12:\"delete-72224\";i:71467;s:12:\"delete-72227\";i:71468;s:12:\"delete-72230\";i:71469;s:12:\"delete-72231\";i:71470;s:12:\"delete-72228\";i:71471;s:12:\"delete-72229\";i:71472;s:12:\"delete-72232\";i:71473;s:12:\"delete-72235\";i:71474;s:12:\"delete-72236\";i:71475;s:12:\"delete-72233\";i:71476;s:12:\"delete-72234\";i:71477;s:12:\"delete-72237\";i:71478;s:12:\"delete-72240\";i:71479;s:12:\"delete-72241\";i:71480;s:12:\"delete-72238\";i:71481;s:12:\"delete-72239\";i:71482;s:12:\"delete-72242\";i:71483;s:12:\"delete-72245\";i:71484;s:12:\"delete-72246\";i:71485;s:12:\"delete-72243\";i:71486;s:12:\"delete-72244\";i:71487;s:12:\"delete-72247\";i:71488;s:12:\"delete-72250\";i:71489;s:12:\"delete-72251\";i:71490;s:12:\"delete-72248\";i:71491;s:12:\"delete-72249\";i:71492;s:12:\"delete-72252\";i:71493;s:12:\"delete-72255\";i:71494;s:12:\"delete-72256\";i:71495;s:12:\"delete-72253\";i:71496;s:12:\"delete-72254\";i:71497;s:12:\"delete-72257\";i:71498;s:12:\"delete-72260\";i:71499;s:12:\"delete-72261\";i:71500;s:12:\"delete-72258\";i:71501;s:12:\"delete-72259\";i:71502;s:12:\"delete-72262\";i:71503;s:12:\"delete-72265\";i:71504;s:12:\"delete-72263\";i:71505;s:12:\"delete-72264\";i:71506;s:12:\"delete-72266\";i:71507;s:12:\"delete-72267\";i:71508;s:12:\"delete-72270\";i:71509;s:12:\"delete-72271\";i:71510;s:12:\"delete-72268\";i:71511;s:12:\"delete-72269\";i:71512;s:12:\"delete-72272\";i:71513;s:12:\"delete-72275\";i:71514;s:12:\"delete-72276\";i:71515;s:12:\"delete-72273\";i:71516;s:12:\"delete-72274\";i:71517;s:12:\"delete-72277\";i:71518;s:12:\"delete-72280\";i:71519;s:12:\"delete-72281\";i:71520;s:12:\"delete-72278\";i:71521;s:12:\"delete-72279\";i:71522;s:12:\"delete-72282\";i:71523;s:12:\"delete-72285\";i:71524;s:12:\"delete-72283\";i:71525;s:12:\"delete-72284\";i:71526;s:12:\"delete-72286\";i:71527;s:12:\"delete-72287\";i:71528;s:12:\"delete-72290\";i:71529;s:12:\"delete-72291\";i:71530;s:12:\"delete-72288\";i:71531;s:12:\"delete-72289\";i:71532;s:12:\"delete-72292\";i:71533;s:12:\"delete-72295\";i:71534;s:12:\"delete-72293\";i:71535;s:12:\"delete-72294\";i:71536;s:12:\"delete-72296\";i:71537;s:12:\"delete-72297\";i:71538;s:12:\"delete-72300\";i:71539;s:12:\"delete-72301\";i:71540;s:12:\"delete-72298\";i:71541;s:12:\"delete-72299\";i:71542;s:12:\"delete-72302\";i:71543;s:12:\"delete-72305\";i:71544;s:12:\"delete-72306\";i:71545;s:12:\"delete-72303\";i:71546;s:12:\"delete-72304\";i:71547;s:12:\"delete-72307\";i:71548;s:12:\"delete-72310\";i:71549;s:12:\"delete-72311\";i:71550;s:12:\"delete-72308\";i:71551;s:12:\"delete-72309\";i:71552;s:12:\"delete-72312\";i:71553;s:12:\"delete-72315\";i:71554;s:12:\"delete-72316\";i:71555;s:12:\"delete-72313\";i:71556;s:12:\"delete-72314\";i:71557;s:12:\"delete-72317\";i:71558;s:12:\"delete-72320\";i:71559;s:12:\"delete-72321\";i:71560;s:12:\"delete-72318\";i:71561;s:12:\"delete-72319\";i:71562;s:12:\"delete-72322\";i:71563;s:12:\"delete-72325\";i:71564;s:12:\"delete-72326\";i:71565;s:12:\"delete-72323\";i:71566;s:12:\"delete-72324\";i:71567;s:12:\"delete-72327\";i:71568;s:12:\"delete-72330\";i:71569;s:12:\"delete-72331\";i:71570;s:12:\"delete-72328\";i:71571;s:12:\"delete-72329\";i:71572;s:12:\"delete-72332\";i:71573;s:12:\"delete-72335\";i:71574;s:12:\"delete-72336\";i:71575;s:12:\"delete-72333\";i:71576;s:12:\"delete-72334\";i:71577;s:12:\"delete-72337\";i:71578;s:12:\"delete-72340\";i:71579;s:12:\"delete-72341\";i:71580;s:12:\"delete-72338\";i:71581;s:12:\"delete-72339\";i:71582;s:12:\"delete-72342\";i:71583;s:12:\"delete-72346\";i:71584;s:12:\"delete-72345\";i:71585;s:12:\"delete-72343\";i:71586;s:12:\"delete-72344\";i:71587;s:12:\"delete-72347\";i:71588;s:12:\"delete-72350\";i:71589;s:12:\"delete-72351\";i:71590;s:12:\"delete-72348\";i:71591;s:12:\"delete-72349\";i:71592;s:12:\"delete-72352\";i:71593;s:12:\"delete-72355\";i:71594;s:12:\"delete-72356\";i:71595;s:12:\"delete-72353\";i:71596;s:12:\"delete-72354\";i:71597;s:12:\"delete-72357\";i:71598;s:12:\"delete-72360\";i:71599;s:12:\"delete-72361\";i:71600;s:12:\"delete-72358\";i:71601;s:12:\"delete-72359\";i:71602;s:12:\"delete-72362\";i:71603;s:12:\"delete-72365\";i:71604;s:12:\"delete-72366\";i:71605;s:12:\"delete-72363\";i:71606;s:12:\"delete-72364\";i:71607;s:12:\"delete-72367\";i:71608;s:12:\"delete-72370\";i:71609;s:12:\"delete-72371\";i:71610;s:12:\"delete-72368\";i:71611;s:12:\"delete-72369\";i:71612;s:12:\"delete-72372\";i:71613;s:12:\"delete-72376\";i:71614;s:12:\"delete-72375\";i:71615;s:12:\"delete-72373\";i:71616;s:12:\"delete-72374\";i:71617;s:12:\"delete-72377\";i:71618;s:12:\"delete-72380\";i:71619;s:12:\"delete-72381\";i:71620;s:12:\"delete-72378\";i:71621;s:12:\"delete-72379\";i:71622;s:12:\"delete-72382\";i:71623;s:12:\"delete-72385\";i:71624;s:12:\"delete-72386\";i:71625;s:12:\"delete-72383\";i:71626;s:12:\"delete-72384\";i:71627;s:12:\"delete-72387\";i:71628;s:12:\"delete-72390\";i:71629;s:12:\"delete-72391\";i:71630;s:12:\"delete-72388\";i:71631;s:12:\"delete-72389\";i:71632;s:12:\"delete-72392\";i:71633;s:12:\"delete-72395\";i:71634;s:12:\"delete-72396\";i:71635;s:12:\"delete-72393\";i:71636;s:12:\"delete-72394\";i:71637;s:12:\"delete-72397\";i:71638;s:12:\"delete-72401\";i:71639;s:12:\"delete-72400\";i:71640;s:12:\"delete-72398\";i:71641;s:12:\"delete-72399\";i:71642;s:12:\"delete-72402\";i:71643;s:12:\"delete-72405\";i:71644;s:12:\"delete-72406\";i:71645;s:12:\"delete-72403\";i:71646;s:12:\"delete-72404\";i:71647;s:12:\"delete-72407\";i:71648;s:12:\"delete-72411\";i:71649;s:12:\"delete-72410\";i:71650;s:12:\"delete-72408\";i:71651;s:12:\"delete-72409\";i:71652;s:12:\"delete-72412\";i:71653;s:12:\"delete-72415\";i:71654;s:12:\"delete-72416\";i:71655;s:12:\"delete-72413\";i:71656;s:12:\"delete-72414\";i:71657;s:12:\"delete-72417\";i:71658;s:12:\"delete-72420\";i:71659;s:12:\"delete-72421\";i:71660;s:12:\"delete-72418\";i:71661;s:12:\"delete-72419\";i:71662;s:12:\"delete-72422\";i:71663;s:12:\"delete-72426\";i:71664;s:12:\"delete-72425\";i:71665;s:12:\"delete-72423\";i:71666;s:12:\"delete-72424\";i:71667;s:12:\"delete-72427\";i:71668;s:12:\"delete-72430\";i:71669;s:12:\"delete-72431\";i:71670;s:12:\"delete-72428\";i:71671;s:12:\"delete-72429\";i:71672;s:12:\"delete-72432\";i:71673;s:12:\"delete-72435\";i:71674;s:12:\"delete-72436\";i:71675;s:12:\"delete-72433\";i:71676;s:12:\"delete-72434\";i:71677;s:12:\"delete-72437\";i:71678;s:12:\"delete-72440\";i:71679;s:12:\"delete-72441\";i:71680;s:12:\"delete-72438\";i:71681;s:12:\"delete-72439\";i:71682;s:12:\"delete-72442\";i:71683;s:12:\"delete-72445\";i:71684;s:12:\"delete-72446\";i:71685;s:12:\"delete-72443\";i:71686;s:12:\"delete-72444\";i:71687;s:12:\"delete-72447\";i:71688;s:12:\"delete-72450\";i:71689;s:12:\"delete-72451\";i:71690;s:12:\"delete-72448\";i:71691;s:12:\"delete-72449\";i:71692;s:12:\"delete-72452\";i:71693;s:12:\"delete-72455\";i:71694;s:12:\"delete-72456\";i:71695;s:12:\"delete-72453\";i:71696;s:12:\"delete-72454\";i:71697;s:12:\"delete-72457\";i:71698;s:12:\"delete-72460\";i:71699;s:12:\"delete-72461\";i:71700;s:12:\"delete-72458\";i:71701;s:12:\"delete-72459\";i:71702;s:12:\"delete-72462\";i:71703;s:12:\"delete-72466\";i:71704;s:12:\"delete-72465\";i:71705;s:12:\"delete-72463\";i:71706;s:12:\"delete-72464\";i:71707;s:12:\"delete-72467\";i:71708;s:12:\"delete-72470\";i:71709;s:12:\"delete-72468\";i:71710;s:12:\"delete-72469\";i:71711;s:12:\"delete-72471\";i:71712;s:12:\"delete-72475\";i:71713;s:12:\"delete-72472\";i:71714;s:12:\"delete-72476\";i:71715;s:12:\"delete-72473\";i:71716;s:12:\"delete-72474\";i:71717;s:12:\"delete-72477\";i:71718;s:12:\"delete-72480\";i:71719;s:12:\"delete-72481\";i:71720;s:12:\"delete-72478\";i:71721;s:12:\"delete-72479\";i:71722;s:12:\"delete-72482\";i:71723;s:12:\"delete-72485\";i:71724;s:12:\"delete-72486\";i:71725;s:12:\"delete-72483\";i:71726;s:12:\"delete-72484\";i:71727;s:12:\"delete-72487\";i:71728;s:12:\"delete-72490\";i:71729;s:12:\"delete-72491\";i:71730;s:12:\"delete-72488\";i:71731;s:12:\"delete-72489\";i:71732;s:12:\"delete-72492\";i:71733;s:12:\"delete-72496\";i:71734;s:12:\"delete-72495\";i:71735;s:12:\"delete-72497\";i:71736;s:12:\"delete-72500\";i:71737;s:12:\"delete-72501\";i:71738;s:12:\"delete-72493\";i:71739;s:12:\"delete-72494\";i:71740;s:12:\"delete-72498\";i:71741;s:12:\"delete-72499\";i:71742;s:12:\"delete-72502\";i:71743;s:12:\"delete-72505\";i:71744;s:12:\"delete-72506\";i:71745;s:12:\"delete-72503\";i:71746;s:12:\"delete-72504\";i:71747;s:12:\"delete-72507\";i:71748;s:12:\"delete-72510\";i:71749;s:12:\"delete-72511\";i:71750;s:12:\"delete-72508\";i:71751;s:12:\"delete-72509\";i:71752;s:12:\"delete-72512\";i:71753;s:12:\"delete-72515\";i:71754;s:12:\"delete-72516\";i:71755;s:12:\"delete-72513\";i:71756;s:12:\"delete-72514\";i:71757;s:12:\"delete-72517\";i:71758;s:12:\"delete-72520\";i:71759;s:12:\"delete-72521\";i:71760;s:12:\"delete-72522\";i:71761;s:12:\"delete-72525\";i:71762;s:12:\"delete-72526\";i:71763;s:12:\"delete-72518\";i:71764;s:12:\"delete-72519\";i:71765;s:12:\"delete-72523\";i:71766;s:12:\"delete-72524\";i:71767;s:12:\"delete-72527\";i:71768;s:12:\"delete-72530\";i:71769;s:12:\"delete-72531\";i:71770;s:12:\"delete-72528\";i:71771;s:12:\"delete-72529\";i:71772;s:12:\"delete-72532\";i:71773;s:12:\"delete-72535\";i:71774;s:12:\"delete-72536\";i:71775;s:12:\"delete-72533\";i:71776;s:12:\"delete-72534\";i:71777;s:12:\"delete-72537\";i:71778;s:12:\"delete-72540\";i:71779;s:12:\"delete-72541\";i:71780;s:12:\"delete-72538\";i:71781;s:12:\"delete-72539\";i:71782;s:12:\"delete-72542\";i:71783;s:12:\"delete-72545\";i:71784;s:12:\"delete-72546\";i:71785;s:12:\"delete-72543\";i:71786;s:12:\"delete-72544\";i:71787;s:12:\"delete-72547\";i:71788;s:12:\"delete-72550\";i:71789;s:12:\"delete-72551\";i:71790;s:12:\"delete-72548\";i:71791;s:12:\"delete-72549\";i:71792;s:12:\"delete-72552\";i:71793;s:12:\"delete-72555\";i:71794;s:12:\"delete-72556\";i:71795;s:12:\"delete-72553\";i:71796;s:12:\"delete-72554\";i:71797;s:12:\"delete-72557\";i:71798;s:12:\"delete-72560\";i:71799;s:12:\"delete-72561\";i:71800;s:12:\"delete-72558\";i:71801;s:12:\"delete-72559\";i:71802;s:12:\"delete-72562\";i:71803;s:12:\"delete-72565\";i:71804;s:12:\"delete-72563\";i:71805;s:12:\"delete-72564\";i:71806;s:12:\"delete-72566\";i:71807;s:12:\"delete-72567\";i:71808;s:12:\"delete-72570\";i:71809;s:12:\"delete-72571\";i:71810;s:12:\"delete-72568\";i:71811;s:12:\"delete-72569\";i:71812;s:12:\"delete-72572\";i:71813;s:12:\"delete-72575\";i:71814;s:12:\"delete-72576\";i:71815;s:12:\"delete-72573\";i:71816;s:12:\"delete-72574\";i:71817;s:12:\"delete-72577\";i:71818;s:12:\"delete-72580\";i:71819;s:12:\"delete-72581\";i:71820;s:12:\"delete-72578\";i:71821;s:12:\"delete-72579\";i:71822;s:12:\"delete-72582\";i:71823;s:12:\"delete-72585\";i:71824;s:12:\"delete-72586\";i:71825;s:12:\"delete-72583\";i:71826;s:12:\"delete-72584\";i:71827;s:12:\"delete-72587\";i:71828;s:12:\"delete-72590\";i:71829;s:12:\"delete-72591\";i:71830;s:12:\"delete-72588\";i:71831;s:12:\"delete-72589\";i:71832;s:12:\"delete-72592\";i:71833;s:12:\"delete-72595\";i:71834;s:12:\"delete-72596\";i:71835;s:12:\"delete-72593\";i:71836;s:12:\"delete-72594\";i:71837;s:12:\"delete-72597\";i:71838;s:12:\"delete-72600\";i:71839;s:12:\"delete-72601\";i:71840;s:12:\"delete-72598\";i:71841;s:12:\"delete-72599\";i:71842;s:12:\"delete-72602\";i:71843;s:12:\"delete-72605\";i:71844;s:12:\"delete-72606\";i:71845;s:12:\"delete-72603\";i:71846;s:12:\"delete-72604\";i:71847;s:12:\"delete-72607\";i:71848;s:12:\"delete-72610\";i:71849;s:12:\"delete-72611\";i:71850;s:12:\"delete-72608\";i:71851;s:12:\"delete-72609\";i:71852;s:12:\"delete-72612\";i:71853;s:12:\"delete-72615\";i:71854;s:12:\"delete-72616\";i:71855;s:12:\"delete-72613\";i:71856;s:12:\"delete-72614\";i:71857;s:12:\"delete-72617\";i:71858;s:12:\"delete-72620\";i:71859;s:12:\"delete-72621\";i:71860;s:12:\"delete-72618\";i:71861;s:12:\"delete-72619\";i:71862;s:12:\"delete-72622\";i:71863;s:12:\"delete-72625\";i:71864;s:12:\"delete-72626\";i:71865;s:12:\"delete-72627\";i:71866;s:12:\"delete-72630\";i:71867;s:12:\"delete-72631\";i:71868;s:12:\"delete-72623\";i:71869;s:12:\"delete-72624\";i:71870;s:12:\"delete-72628\";i:71871;s:12:\"delete-72629\";i:71872;s:12:\"delete-72632\";i:71873;s:12:\"delete-72635\";i:71874;s:12:\"delete-72636\";i:71875;s:12:\"delete-72633\";i:71876;s:12:\"delete-72634\";i:71877;s:12:\"delete-72637\";i:71878;s:12:\"delete-72640\";i:71879;s:12:\"delete-72641\";i:71880;s:12:\"delete-72638\";i:71881;s:12:\"delete-72639\";i:71882;s:12:\"delete-72642\";i:71883;s:12:\"delete-72645\";i:71884;s:12:\"delete-72646\";i:71885;s:12:\"delete-72643\";i:71886;s:12:\"delete-72644\";i:71887;s:12:\"delete-72647\";i:71888;s:12:\"delete-72650\";i:71889;s:12:\"delete-72651\";i:71890;s:12:\"delete-72648\";i:71891;s:12:\"delete-72649\";i:71892;s:12:\"delete-72652\";i:71893;s:12:\"delete-72655\";i:71894;s:12:\"delete-72656\";i:71895;s:12:\"delete-72653\";i:71896;s:12:\"delete-72654\";i:71897;s:12:\"delete-72657\";i:71898;s:12:\"delete-72660\";i:71899;s:12:\"delete-72661\";i:71900;s:12:\"delete-72658\";i:71901;s:12:\"delete-72659\";i:71902;s:12:\"delete-72662\";i:71903;s:12:\"delete-72665\";i:71904;s:12:\"delete-72666\";i:71905;s:12:\"delete-72663\";i:71906;s:12:\"delete-72664\";i:71907;s:12:\"delete-72667\";i:71908;s:12:\"delete-72670\";i:71909;s:12:\"delete-72668\";i:71910;s:12:\"delete-72669\";i:71911;s:12:\"delete-72671\";i:71912;s:12:\"delete-72672\";i:71913;s:12:\"delete-72675\";i:71914;s:12:\"delete-72676\";i:71915;s:12:\"delete-72673\";i:71916;s:12:\"delete-72674\";i:71917;s:12:\"delete-72677\";i:71918;s:12:\"delete-72680\";i:71919;s:12:\"delete-72681\";i:71920;s:12:\"delete-72678\";i:71921;s:12:\"delete-72679\";i:71922;s:12:\"delete-72682\";i:71923;s:12:\"delete-72685\";i:71924;s:12:\"delete-72686\";i:71925;s:12:\"delete-72683\";i:71926;s:12:\"delete-72684\";i:71927;s:12:\"delete-72687\";i:71928;s:12:\"delete-72688\";i:71929;s:12:\"delete-72689\";i:71930;s:12:\"delete-72690\";i:71931;s:12:\"delete-72691\";i:71932;s:12:\"delete-72692\";i:71933;s:12:\"delete-72695\";i:71934;s:12:\"delete-72696\";i:71935;s:12:\"delete-72693\";i:71936;s:12:\"delete-72694\";i:71937;s:12:\"delete-72697\";i:71938;s:12:\"delete-72700\";i:71939;s:12:\"delete-72701\";i:71940;s:12:\"delete-72698\";i:71941;s:12:\"delete-72699\";i:71942;s:12:\"delete-72702\";i:71943;s:12:\"delete-72705\";i:71944;s:12:\"delete-72703\";i:71945;s:12:\"delete-72704\";i:71946;s:12:\"delete-72706\";i:71947;s:12:\"delete-72707\";i:71948;s:12:\"delete-72710\";i:71949;s:12:\"delete-72711\";i:71950;s:12:\"delete-72708\";i:71951;s:12:\"delete-72709\";i:71952;s:12:\"delete-72712\";i:71953;s:12:\"delete-72715\";i:71954;s:12:\"delete-72716\";i:71955;s:12:\"delete-72713\";i:71956;s:12:\"delete-72714\";i:71957;s:12:\"delete-72717\";i:71958;s:12:\"delete-72720\";i:71959;s:12:\"delete-72721\";i:71960;s:12:\"delete-72718\";i:71961;s:12:\"delete-72719\";i:71962;s:12:\"delete-72722\";i:71963;s:12:\"delete-72725\";i:71964;s:12:\"delete-72726\";i:71965;s:12:\"delete-72723\";i:71966;s:12:\"delete-72724\";i:71967;s:12:\"delete-72727\";i:71968;s:12:\"delete-72730\";i:71969;s:12:\"delete-72731\";i:71970;s:12:\"delete-72728\";i:71971;s:12:\"delete-72729\";i:71972;s:12:\"delete-72732\";i:71973;s:12:\"delete-72735\";i:71974;s:12:\"delete-72736\";i:71975;s:12:\"delete-72733\";i:71976;s:12:\"delete-72734\";i:71977;s:12:\"delete-72737\";i:71978;s:12:\"delete-72740\";i:71979;s:12:\"delete-72738\";i:71980;s:12:\"delete-72739\";i:71981;s:12:\"delete-72741\";i:71982;s:12:\"delete-72742\";i:71983;s:12:\"delete-72745\";i:71984;s:12:\"delete-72746\";i:71985;s:12:\"delete-72743\";i:71986;s:12:\"delete-72744\";i:71987;s:12:\"delete-72747\";i:71988;s:12:\"delete-72750\";i:71989;s:12:\"delete-72751\";i:71990;s:12:\"delete-72748\";i:71991;s:12:\"delete-72749\";i:71992;s:12:\"delete-72752\";i:71993;s:12:\"delete-72755\";i:71994;s:12:\"delete-72756\";i:71995;s:12:\"delete-72753\";i:71996;s:12:\"delete-72754\";i:71997;s:12:\"delete-72757\";i:71998;s:12:\"delete-72760\";i:71999;s:12:\"delete-72761\";i:72000;s:12:\"delete-72758\";i:72001;s:12:\"delete-72759\";i:72002;s:12:\"delete-72762\";i:72003;s:12:\"delete-72765\";i:72004;s:12:\"delete-72766\";i:72005;s:12:\"delete-72763\";i:72006;s:12:\"delete-72764\";i:72007;s:12:\"delete-72767\";i:72008;s:12:\"delete-72770\";i:72009;s:12:\"delete-72771\";i:72010;s:12:\"delete-72768\";i:72011;s:12:\"delete-72769\";i:72012;s:12:\"delete-72772\";i:72013;s:12:\"delete-72775\";i:72014;s:12:\"delete-72776\";i:72015;s:12:\"delete-72773\";i:72016;s:12:\"delete-72774\";i:72017;s:12:\"delete-72777\";i:72018;s:12:\"delete-72780\";i:72019;s:12:\"delete-72781\";i:72020;s:12:\"delete-72778\";i:72021;s:12:\"delete-72779\";i:72022;s:12:\"delete-72782\";i:72023;s:12:\"delete-72783\";i:72024;s:12:\"delete-72784\";i:72025;s:12:\"delete-72786\";i:72026;s:12:\"delete-72785\";i:72027;s:12:\"delete-72787\";i:72028;s:12:\"delete-72788\";i:72029;s:12:\"delete-72791\";i:72030;s:12:\"delete-72793\";i:72031;s:12:\"delete-72789\";i:72032;s:12:\"delete-72790\";i:72033;s:12:\"delete-72792\";i:72034;s:12:\"delete-72794\";i:72035;s:12:\"delete-72797\";i:72036;s:12:\"delete-72799\";i:72037;s:12:\"delete-72795\";i:72038;s:12:\"delete-72796\";i:72039;s:12:\"delete-72798\";i:72040;s:12:\"delete-72800\";i:72041;s:12:\"delete-72803\";i:72042;s:12:\"delete-72801\";i:72043;s:12:\"delete-72802\";i:72044;s:12:\"delete-72804\";i:72045;s:12:\"delete-72805\";i:72046;s:12:\"delete-72806\";i:72047;s:12:\"delete-72809\";i:72048;s:12:\"delete-72811\";i:72049;s:12:\"delete-72807\";i:72050;s:12:\"delete-72808\";i:72051;s:12:\"delete-72810\";i:72052;s:12:\"delete-72812\";i:72053;s:12:\"delete-72815\";i:72054;s:12:\"delete-72817\";i:72055;s:12:\"delete-72813\";i:72056;s:12:\"delete-72814\";i:72057;s:12:\"delete-72816\";i:72058;s:12:\"delete-72818\";i:72059;s:12:\"delete-72821\";i:72060;s:12:\"delete-72823\";i:72061;s:12:\"delete-72819\";i:72062;s:12:\"delete-72820\";i:72063;s:12:\"delete-72822\";i:72064;s:12:\"delete-72824\";i:72065;s:12:\"delete-72827\";i:72066;s:12:\"delete-72829\";i:72067;s:12:\"delete-72825\";i:72068;s:12:\"delete-72826\";i:72069;s:12:\"delete-72828\";i:72070;s:12:\"delete-72830\";i:72071;s:12:\"delete-72833\";i:72072;s:12:\"delete-72835\";i:72073;s:12:\"delete-72831\";i:72074;s:12:\"delete-72832\";i:72075;s:12:\"delete-72834\";i:72076;s:12:\"delete-72836\";i:72077;s:12:\"delete-72839\";i:72078;s:12:\"delete-72841\";i:72079;s:12:\"delete-72842\";i:72080;s:12:\"delete-72845\";i:72081;s:12:\"delete-72847\";i:72082;s:12:\"delete-72837\";i:72083;s:12:\"delete-72838\";i:72084;s:12:\"delete-72840\";i:72085;s:12:\"delete-72843\";i:72086;s:12:\"delete-72844\";i:72087;s:12:\"delete-72846\";i:72088;s:12:\"delete-72848\";i:72089;s:12:\"delete-72851\";i:72090;s:12:\"delete-72849\";i:72091;s:12:\"delete-72850\";i:72092;s:12:\"delete-72852\";i:72093;s:12:\"delete-72853\";i:72094;s:12:\"delete-72854\";i:72095;s:12:\"delete-72855\";i:72096;s:12:\"delete-72856\";i:72097;s:12:\"delete-72858\";i:72098;s:12:\"delete-72857\";i:72099;s:12:\"delete-72859\";i:72100;s:12:\"delete-72860\";i:72101;s:12:\"delete-72863\";i:72102;s:12:\"delete-72861\";i:72103;s:12:\"delete-72862\";i:72104;s:12:\"delete-72864\";i:72105;s:12:\"delete-72865\";i:72106;s:12:\"delete-72866\";i:72107;s:12:\"delete-72869\";i:72108;s:12:\"delete-72867\";i:72109;s:12:\"delete-72868\";i:72110;s:12:\"delete-72870\";i:72111;s:12:\"delete-72871\";i:72112;s:12:\"delete-72872\";i:72113;s:12:\"delete-72875\";i:72114;s:12:\"delete-72873\";i:72115;s:12:\"delete-72874\";i:72116;s:12:\"delete-72876\";i:72117;s:12:\"delete-72877\";i:72118;s:12:\"delete-72878\";i:72119;s:12:\"delete-72881\";i:72120;s:12:\"delete-72879\";i:72121;s:12:\"delete-72880\";i:72122;s:12:\"delete-72882\";i:72123;s:12:\"delete-72883\";i:72124;s:12:\"delete-72884\";i:72125;s:12:\"delete-72887\";i:72126;s:12:\"delete-72885\";i:72127;s:12:\"delete-72886\";i:72128;s:12:\"delete-72888\";i:72129;s:12:\"delete-72889\";i:72130;s:12:\"delete-72890\";i:72131;s:12:\"delete-72891\";i:72132;s:12:\"delete-72892\";i:72133;s:12:\"delete-72893\";i:72134;s:12:\"delete-72895\";i:72135;s:12:\"delete-72896\";i:72136;s:12:\"delete-72899\";i:72137;s:12:\"delete-72901\";i:72138;s:12:\"delete-72894\";i:72139;s:12:\"delete-72897\";i:72140;s:12:\"delete-72898\";i:72141;s:12:\"delete-72900\";i:72142;s:12:\"delete-72902\";i:72143;s:12:\"delete-72903\";i:72144;s:12:\"delete-72904\";i:72145;s:12:\"delete-72906\";i:72146;s:12:\"delete-72905\";i:72147;s:12:\"delete-72907\";i:72148;s:12:\"delete-72909\";i:72149;s:12:\"delete-72910\";i:72150;s:12:\"delete-72912\";i:72151;s:12:\"delete-72908\";i:72152;s:12:\"delete-72911\";i:72153;s:12:\"delete-72913\";i:72154;s:12:\"delete-72914\";i:72155;s:12:\"delete-72917\";i:72156;s:12:\"delete-72915\";i:72157;s:12:\"delete-72916\";i:72158;s:12:\"delete-72918\";i:72159;s:12:\"delete-72919\";i:72160;s:12:\"delete-72920\";i:72161;s:12:\"delete-72923\";i:72162;s:12:\"delete-72921\";i:72163;s:12:\"delete-72922\";i:72164;s:12:\"delete-72924\";i:72165;s:12:\"delete-72925\";i:72166;s:12:\"delete-72926\";i:72167;s:12:\"delete-72929\";i:72168;s:12:\"delete-72927\";i:72169;s:12:\"delete-72928\";i:72170;s:12:\"delete-72930\";i:72171;s:12:\"delete-72931\";i:72172;s:12:\"delete-72932\";i:72173;s:12:\"delete-72935\";i:72174;s:12:\"delete-72933\";i:72175;s:12:\"delete-72934\";i:72176;s:12:\"delete-72936\";i:72177;s:12:\"delete-72937\";i:72178;s:12:\"delete-72938\";i:72179;s:12:\"delete-72941\";i:72180;s:12:\"delete-72943\";i:72181;s:12:\"delete-72939\";i:72182;s:12:\"delete-72940\";i:72183;s:12:\"delete-72942\";i:72184;s:12:\"delete-72944\";i:72185;s:12:\"delete-72947\";i:72186;s:12:\"delete-72949\";i:72187;s:12:\"delete-72945\";i:72188;s:12:\"delete-72946\";i:72189;s:12:\"delete-72948\";i:72190;s:12:\"delete-72950\";i:72191;s:12:\"delete-72953\";i:72192;s:12:\"delete-72951\";i:72193;s:12:\"delete-72952\";i:72194;s:12:\"delete-72954\";i:72195;s:12:\"delete-72955\";i:72196;s:12:\"delete-72956\";i:72197;s:12:\"delete-72959\";i:72198;s:12:\"delete-72961\";i:72199;s:12:\"delete-72957\";i:72200;s:12:\"delete-72958\";i:72201;s:12:\"delete-72960\";i:72202;s:12:\"delete-72962\";i:72203;s:12:\"delete-72965\";i:72204;s:12:\"delete-72967\";i:72205;s:12:\"delete-72963\";i:72206;s:12:\"delete-72964\";i:72207;s:12:\"delete-72966\";i:72208;s:12:\"delete-72968\";i:72209;s:12:\"delete-72971\";i:72210;s:12:\"delete-72969\";i:72211;s:12:\"delete-72970\";i:72212;s:12:\"delete-72972\";i:72213;s:12:\"delete-72973\";i:72214;s:12:\"delete-72974\";i:72215;s:12:\"delete-72977\";i:72216;s:12:\"delete-72975\";i:72217;s:12:\"delete-72976\";i:72218;s:12:\"delete-72978\";i:72219;s:12:\"delete-72979\";i:72220;s:12:\"delete-72980\";i:72221;s:12:\"delete-72981\";i:72222;s:12:\"delete-72982\";i:72223;s:12:\"delete-72983\";i:72224;s:12:\"delete-72985\";i:72225;s:12:\"delete-72986\";i:72226;s:12:\"delete-72989\";i:72227;s:12:\"delete-72984\";i:72228;s:12:\"delete-72987\";i:72229;s:12:\"delete-72988\";i:72230;s:12:\"delete-72990\";i:72231;s:12:\"delete-72991\";i:72232;s:12:\"delete-72993\";i:72233;s:12:\"delete-72992\";i:72234;s:12:\"delete-72994\";i:72235;s:12:\"delete-72995\";i:72236;s:12:\"delete-72998\";i:72237;s:12:\"delete-73000\";i:72238;s:12:\"delete-73001\";i:72239;s:12:\"delete-73004\";i:72240;s:12:\"delete-73006\";i:72241;s:12:\"delete-72996\";i:72242;s:12:\"delete-72997\";i:72243;s:12:\"delete-72999\";i:72244;s:12:\"delete-73002\";i:72245;s:12:\"delete-73003\";i:72246;s:12:\"delete-73005\";i:72247;s:12:\"delete-73007\";i:72248;s:12:\"delete-73008\";i:72249;s:12:\"delete-73009\";i:72250;s:12:\"delete-73010\";i:72251;s:12:\"delete-73012\";i:72252;s:12:\"delete-73013\";i:72253;s:12:\"delete-73016\";i:72254;s:12:\"delete-73018\";i:72255;s:12:\"delete-73011\";i:72256;s:12:\"delete-73014\";i:72257;s:12:\"delete-73015\";i:72258;s:12:\"delete-73017\";i:72259;s:12:\"delete-73019\";i:72260;s:12:\"delete-73022\";i:72261;s:12:\"delete-73020\";i:72262;s:12:\"delete-73021\";i:72263;s:12:\"delete-73023\";i:72264;s:12:\"delete-73024\";i:72265;s:12:\"delete-73025\";i:72266;s:12:\"delete-73028\";i:72267;s:12:\"delete-73026\";i:72268;s:12:\"delete-73027\";i:72269;s:12:\"delete-73029\";i:72270;s:12:\"delete-73030\";i:72271;s:12:\"delete-73031\";i:72272;s:12:\"delete-73034\";i:72273;s:12:\"delete-73032\";i:72274;s:12:\"delete-73033\";i:72275;s:12:\"delete-73035\";i:72276;s:12:\"delete-73036\";i:72277;s:12:\"delete-73037\";i:72278;s:12:\"delete-73038\";i:72279;s:12:\"delete-73039\";i:72280;s:12:\"delete-73040\";i:72281;s:12:\"delete-73042\";i:72282;s:12:\"delete-73043\";i:72283;s:12:\"delete-73046\";i:72284;s:12:\"delete-73048\";i:72285;s:12:\"delete-73041\";i:72286;s:12:\"delete-73044\";i:72287;s:12:\"delete-73045\";i:72288;s:12:\"delete-73047\";i:72289;s:12:\"delete-73049\";i:72290;s:12:\"delete-73052\";i:72291;s:12:\"delete-73054\";i:72292;s:12:\"delete-73050\";i:72293;s:12:\"delete-73051\";i:72294;s:12:\"delete-73053\";i:72295;s:12:\"delete-73055\";i:72296;s:12:\"delete-73058\";i:72297;s:12:\"delete-73056\";i:72298;s:12:\"delete-73057\";i:72299;s:12:\"delete-73059\";i:72300;s:12:\"delete-73060\";i:72301;s:12:\"delete-73061\";i:72302;s:12:\"delete-73064\";i:72303;s:12:\"delete-73062\";i:72304;s:12:\"delete-73063\";i:72305;s:12:\"delete-73065\";i:72306;s:12:\"delete-73066\";i:72307;s:12:\"delete-73067\";i:72308;s:12:\"delete-73070\";i:72309;s:12:\"delete-73072\";i:72310;s:12:\"delete-73068\";i:72311;s:12:\"delete-73069\";i:72312;s:12:\"delete-73071\";i:72313;s:12:\"delete-73073\";i:72314;s:12:\"delete-73076\";i:72315;s:12:\"delete-73078\";i:72316;s:12:\"delete-73074\";i:72317;s:12:\"delete-73075\";i:72318;s:12:\"delete-73077\";i:72319;s:12:\"delete-73079\";i:72320;s:12:\"delete-73082\";i:72321;s:12:\"delete-73080\";i:72322;s:12:\"delete-73081\";i:72323;s:12:\"delete-73083\";i:72324;s:12:\"delete-73084\";i:72325;s:12:\"delete-73085\";i:72326;s:12:\"delete-73088\";i:72327;s:12:\"delete-73090\";i:72328;s:12:\"delete-73086\";i:72329;s:12:\"delete-73087\";i:72330;s:12:\"delete-73089\";i:72331;s:12:\"delete-73091\";i:72332;s:12:\"delete-73094\";i:72333;s:12:\"delete-73092\";i:72334;s:12:\"delete-73093\";i:72335;s:12:\"delete-73095\";i:72336;s:12:\"delete-73096\";i:72337;s:12:\"delete-73097\";i:72338;s:12:\"delete-73100\";i:72339;s:12:\"delete-73098\";i:72340;s:12:\"delete-73099\";i:72341;s:12:\"delete-73101\";i:72342;s:12:\"delete-73102\";i:72343;s:12:\"delete-73103\";i:72344;s:12:\"delete-73106\";i:72345;s:12:\"delete-73104\";i:72346;s:12:\"delete-73105\";i:72347;s:12:\"delete-73107\";i:72348;s:12:\"delete-73108\";i:72349;s:12:\"delete-73109\";i:72350;s:12:\"delete-73112\";i:72351;s:12:\"delete-73110\";i:72352;s:12:\"delete-73111\";i:72353;s:12:\"delete-73113\";i:72354;s:12:\"delete-73114\";i:72355;s:12:\"delete-73115\";i:72356;s:12:\"delete-73118\";i:72357;s:12:\"delete-73116\";i:72358;s:12:\"delete-73117\";i:72359;s:12:\"delete-73119\";i:72360;s:12:\"delete-73120\";i:72361;s:12:\"delete-73121\";i:72362;s:12:\"delete-73124\";i:72363;s:12:\"delete-73126\";i:72364;s:12:\"delete-73122\";i:72365;s:12:\"delete-73123\";i:72366;s:12:\"delete-73125\";i:72367;s:12:\"delete-73127\";i:72368;s:12:\"delete-73130\";i:72369;s:12:\"delete-73128\";i:72370;s:12:\"delete-73129\";i:72371;s:12:\"delete-73131\";i:72372;s:12:\"delete-73132\";i:72373;s:12:\"delete-73133\";i:72374;s:12:\"delete-73136\";i:72375;s:12:\"delete-73134\";i:72376;s:12:\"delete-73135\";i:72377;s:12:\"delete-73137\";i:72378;s:12:\"delete-73138\";i:72379;s:12:\"delete-73139\";i:72380;s:12:\"delete-73142\";i:72381;s:12:\"delete-73140\";i:72382;s:12:\"delete-73141\";i:72383;s:12:\"delete-73143\";i:72384;s:12:\"delete-73144\";i:72385;s:12:\"delete-73145\";i:72386;s:12:\"delete-73148\";i:72387;s:12:\"delete-73146\";i:72388;s:12:\"delete-73147\";i:72389;s:12:\"delete-73149\";i:72390;s:12:\"delete-73150\";i:72391;s:12:\"delete-73151\";i:72392;s:12:\"delete-73154\";i:72393;s:12:\"delete-73156\";i:72394;s:12:\"delete-73152\";i:72395;s:12:\"delete-73153\";i:72396;s:12:\"delete-73155\";i:72397;s:12:\"delete-73157\";i:72398;s:12:\"delete-73160\";i:72399;s:12:\"delete-73158\";i:72400;s:12:\"delete-73159\";i:72401;s:12:\"delete-73161\";i:72402;s:12:\"delete-73162\";i:72403;s:12:\"delete-73163\";i:72404;s:12:\"delete-73166\";i:72405;s:12:\"delete-73168\";i:72406;s:12:\"delete-73164\";i:72407;s:12:\"delete-73165\";i:72408;s:12:\"delete-73167\";i:72409;s:12:\"delete-73169\";i:72410;s:12:\"delete-73172\";i:72411;s:12:\"delete-73170\";i:72412;s:12:\"delete-73171\";i:72413;s:12:\"delete-73173\";i:72414;s:12:\"delete-73174\";i:72415;s:12:\"delete-73175\";i:72416;s:12:\"delete-73178\";i:72417;s:12:\"delete-73176\";i:72418;s:12:\"delete-73177\";i:72419;s:12:\"delete-73179\";i:72420;s:12:\"delete-73180\";i:72421;s:12:\"delete-73181\";i:72422;s:12:\"delete-73184\";i:72423;s:12:\"delete-73182\";i:72424;s:12:\"delete-73183\";i:72425;s:12:\"delete-73185\";i:72426;s:12:\"delete-73186\";i:72427;s:12:\"delete-73187\";i:72428;s:12:\"delete-73190\";i:72429;s:12:\"delete-73192\";i:72430;s:12:\"delete-73188\";i:72431;s:12:\"delete-73189\";i:72432;s:12:\"delete-73191\";i:72433;s:12:\"delete-73193\";i:72434;s:12:\"delete-73196\";i:72435;s:12:\"delete-73198\";i:72436;s:12:\"delete-73194\";i:72437;s:12:\"delete-73195\";i:72438;s:12:\"delete-73197\";i:72439;s:12:\"delete-73199\";i:72440;s:12:\"delete-73202\";i:72441;s:12:\"delete-73200\";i:72442;s:12:\"delete-73201\";i:72443;s:12:\"delete-73203\";i:72444;s:12:\"delete-73204\";i:72445;s:12:\"delete-73205\";i:72446;s:12:\"delete-73208\";i:72447;s:12:\"delete-73206\";i:72448;s:12:\"delete-73207\";i:72449;s:12:\"delete-73209\";i:72450;s:12:\"delete-73210\";i:72451;s:12:\"delete-73211\";i:72452;s:12:\"delete-73214\";i:72453;s:12:\"delete-73212\";i:72454;s:12:\"delete-73213\";i:72455;s:12:\"delete-73215\";i:72456;s:12:\"delete-73216\";i:72457;s:12:\"delete-73217\";i:72458;s:12:\"delete-73220\";i:72459;s:12:\"delete-73222\";i:72460;s:12:\"delete-73218\";i:72461;s:12:\"delete-73219\";i:72462;s:12:\"delete-73221\";i:72463;s:12:\"delete-73223\";i:72464;s:12:\"delete-73226\";i:72465;s:12:\"delete-73224\";i:72466;s:12:\"delete-73225\";i:72467;s:12:\"delete-73227\";i:72468;s:12:\"delete-73228\";i:72469;s:12:\"delete-73229\";i:72470;s:12:\"delete-73232\";i:72471;s:12:\"delete-73230\";i:72472;s:12:\"delete-73231\";i:72473;s:12:\"delete-73233\";i:72474;s:12:\"delete-73234\";i:72475;s:12:\"delete-73235\";i:72476;s:12:\"delete-73238\";i:72477;s:12:\"delete-73240\";i:72478;s:12:\"delete-73236\";i:72479;s:12:\"delete-73237\";i:72480;s:12:\"delete-73239\";i:72481;s:12:\"delete-73241\";i:72482;s:12:\"delete-73244\";i:72483;s:12:\"delete-73246\";i:72484;s:12:\"delete-73242\";i:72485;s:12:\"delete-73243\";i:72486;s:12:\"delete-73245\";i:72487;s:12:\"delete-73247\";i:72488;s:12:\"delete-73250\";i:72489;s:12:\"delete-73252\";i:72490;s:12:\"delete-73248\";i:72491;s:12:\"delete-73249\";i:72492;s:12:\"delete-73251\";i:72493;s:12:\"delete-73253\";i:72494;s:12:\"delete-73256\";i:72495;s:12:\"delete-73258\";i:72496;s:12:\"delete-73254\";i:72497;s:12:\"delete-73255\";i:72498;s:12:\"delete-73257\";i:72499;s:12:\"delete-73259\";i:72500;s:12:\"delete-73262\";i:72501;s:12:\"delete-73264\";i:72502;s:12:\"delete-73260\";i:72503;s:12:\"delete-73261\";i:72504;s:12:\"delete-73263\";i:72505;s:12:\"delete-73265\";i:72506;s:12:\"delete-73268\";i:72507;s:12:\"delete-73266\";i:72508;s:12:\"delete-73267\";i:72509;s:12:\"delete-73269\";i:72510;s:12:\"delete-73270\";i:72511;s:12:\"delete-73271\";i:72512;s:12:\"delete-73274\";i:72513;s:12:\"delete-73272\";i:72514;s:12:\"delete-73273\";i:72515;s:12:\"delete-73275\";i:72516;s:12:\"delete-73276\";i:72517;s:12:\"delete-73277\";i:72518;s:12:\"delete-73280\";i:72519;s:12:\"delete-73278\";i:72520;s:12:\"delete-73279\";i:72521;s:12:\"delete-73281\";i:72522;s:12:\"delete-73282\";i:72523;s:12:\"delete-73283\";i:72524;s:12:\"delete-73284\";i:72525;s:12:\"delete-73285\";i:72526;s:12:\"delete-73287\";i:72527;s:12:\"delete-73286\";i:72528;s:12:\"delete-73288\";i:72529;s:12:\"delete-73289\";i:72530;s:12:\"delete-73292\";i:72531;s:12:\"delete-73290\";i:72532;s:12:\"delete-73291\";i:72533;s:12:\"delete-73293\";i:72534;s:12:\"delete-73294\";i:72535;s:12:\"delete-73295\";i:72536;s:12:\"delete-73298\";i:72537;s:12:\"delete-73296\";i:72538;s:12:\"delete-73297\";i:72539;s:12:\"delete-73299\";i:72540;s:12:\"delete-73300\";i:72541;s:12:\"delete-73301\";i:72542;s:12:\"delete-73304\";i:72543;s:12:\"delete-73306\";i:72544;s:12:\"delete-73302\";i:72545;s:12:\"delete-73303\";i:72546;s:12:\"delete-73305\";i:72547;s:12:\"delete-73307\";i:72548;s:12:\"delete-73310\";i:72549;s:12:\"delete-73308\";i:72550;s:12:\"delete-73309\";i:72551;s:12:\"delete-73311\";i:72552;s:12:\"delete-73312\";i:72553;s:12:\"delete-73313\";i:72554;s:12:\"delete-73316\";i:72555;s:12:\"delete-73314\";i:72556;s:12:\"delete-73315\";i:72557;s:12:\"delete-73317\";i:72558;s:12:\"delete-73318\";i:72559;s:12:\"delete-73319\";i:72560;s:12:\"delete-73322\";i:72561;s:12:\"delete-73320\";i:72562;s:12:\"delete-73321\";i:72563;s:12:\"delete-73323\";i:72564;s:12:\"delete-73324\";i:72565;s:12:\"delete-73325\";i:72566;s:12:\"delete-73328\";i:72567;s:12:\"delete-73330\";i:72568;s:12:\"delete-73326\";i:72569;s:12:\"delete-73327\";i:72570;s:12:\"delete-73329\";i:72571;s:12:\"delete-73331\";i:72572;s:12:\"delete-73334\";i:72573;s:12:\"delete-73332\";i:72574;s:12:\"delete-73333\";i:72575;s:12:\"delete-73335\";i:72576;s:12:\"delete-73336\";i:72577;s:12:\"delete-73337\";i:72578;s:12:\"delete-73340\";i:72579;s:12:\"delete-73338\";i:72580;s:12:\"delete-73339\";i:72581;s:12:\"delete-73341\";i:72582;s:12:\"delete-73342\";i:72583;s:12:\"delete-73343\";i:72584;s:12:\"delete-73346\";i:72585;s:12:\"delete-73348\";i:72586;s:12:\"delete-73344\";i:72587;s:12:\"delete-73345\";i:72588;s:12:\"delete-73347\";i:72589;s:12:\"delete-73349\";i:72590;s:12:\"delete-73352\";i:72591;s:12:\"delete-73354\";i:72592;s:12:\"delete-73350\";i:72593;s:12:\"delete-73351\";i:72594;s:12:\"delete-73353\";i:72595;s:12:\"delete-73355\";i:72596;s:12:\"delete-73358\";i:72597;s:12:\"delete-73356\";i:72598;s:12:\"delete-73357\";i:72599;s:12:\"delete-73359\";i:72600;s:12:\"delete-73360\";i:72601;s:12:\"delete-73361\";i:72602;s:12:\"delete-73364\";i:72603;s:12:\"delete-73366\";i:72604;s:12:\"delete-73362\";i:72605;s:12:\"delete-73363\";i:72606;s:12:\"delete-73365\";i:72607;s:12:\"delete-73367\";i:72608;s:12:\"delete-73370\";i:72609;s:12:\"delete-73372\";i:72610;s:12:\"delete-73368\";i:72611;s:12:\"delete-73369\";i:72612;s:12:\"delete-73371\";i:72613;s:12:\"delete-73373\";i:72614;s:12:\"delete-73376\";i:72615;s:12:\"delete-73378\";i:72616;s:12:\"delete-73374\";i:72617;s:12:\"delete-73375\";i:72618;s:12:\"delete-73377\";i:72619;s:12:\"delete-73379\";i:72620;s:12:\"delete-73382\";i:72621;s:12:\"delete-73384\";i:72622;s:12:\"delete-73380\";i:72623;s:12:\"delete-73381\";i:72624;s:12:\"delete-73383\";i:72625;s:12:\"delete-73385\";i:72626;s:12:\"delete-73388\";i:72627;s:12:\"delete-73386\";i:72628;s:12:\"delete-73387\";i:72629;s:12:\"delete-73389\";i:72630;s:12:\"delete-73390\";i:72631;s:12:\"delete-73391\";i:72632;s:12:\"delete-73394\";i:72633;s:12:\"delete-73396\";i:72634;s:12:\"delete-73392\";i:72635;s:12:\"delete-73393\";i:72636;s:12:\"delete-73395\";i:72637;s:12:\"delete-73397\";i:72638;s:12:\"delete-73400\";i:72639;s:12:\"delete-73398\";i:72640;s:12:\"delete-73399\";i:72641;s:12:\"delete-73401\";i:72642;s:12:\"delete-73402\";i:72643;s:12:\"delete-73403\";i:72644;s:12:\"delete-73406\";i:72645;s:12:\"delete-73408\";i:72646;s:12:\"delete-73404\";i:72647;s:12:\"delete-73405\";i:72648;s:12:\"delete-73407\";i:72649;s:12:\"delete-73409\";i:72650;s:12:\"delete-73412\";i:72651;s:12:\"delete-73410\";i:72652;s:12:\"delete-73411\";i:72653;s:12:\"delete-73413\";i:72654;s:12:\"delete-73414\";i:72655;s:12:\"delete-73415\";i:72656;s:12:\"delete-73418\";i:72657;s:12:\"delete-73416\";i:72658;s:12:\"delete-73417\";i:72659;s:12:\"delete-73419\";i:72660;s:12:\"delete-73420\";i:72661;s:12:\"delete-73421\";i:72662;s:12:\"delete-73424\";i:72663;s:12:\"delete-73426\";i:72664;s:12:\"delete-73422\";i:72665;s:12:\"delete-73423\";i:72666;s:12:\"delete-73425\";i:72667;s:12:\"delete-73427\";i:72668;s:12:\"delete-73430\";i:72669;s:12:\"delete-73432\";i:72670;s:12:\"delete-73428\";i:72671;s:12:\"delete-73429\";i:72672;s:12:\"delete-73431\";i:72673;s:12:\"delete-73433\";i:72674;s:12:\"delete-73436\";i:72675;s:12:\"delete-73434\";i:72676;s:12:\"delete-73435\";i:72677;s:12:\"delete-73437\";i:72678;s:12:\"delete-73438\";i:72679;s:12:\"delete-73439\";i:72680;s:12:\"delete-73442\";i:72681;s:12:\"delete-73440\";i:72682;s:12:\"delete-73441\";i:72683;s:12:\"delete-73443\";i:72684;s:12:\"delete-73444\";i:72685;s:12:\"delete-73445\";i:72686;s:12:\"delete-73448\";i:72687;s:12:\"delete-73450\";i:72688;s:12:\"delete-73446\";i:72689;s:12:\"delete-73447\";i:72690;s:12:\"delete-73449\";i:72691;s:12:\"delete-73451\";i:72692;s:12:\"delete-73452\";i:72693;s:12:\"delete-73453\";i:72694;s:12:\"delete-73454\";i:72695;s:12:\"delete-73456\";i:72696;s:12:\"delete-73457\";i:72697;s:12:\"delete-73460\";i:72698;s:12:\"delete-73462\";i:72699;s:12:\"delete-73455\";i:72700;s:12:\"delete-73458\";i:72701;s:12:\"delete-73459\";i:72702;s:12:\"delete-73461\";i:72703;s:12:\"delete-73463\";i:72704;s:12:\"delete-73466\";i:72705;s:12:\"delete-73464\";i:72706;s:12:\"delete-73465\";i:72707;s:12:\"delete-73467\";i:72708;s:12:\"delete-73468\";i:72709;s:12:\"delete-73469\";i:72710;s:12:\"delete-73472\";i:72711;s:12:\"delete-73470\";i:72712;s:12:\"delete-73471\";i:72713;s:12:\"delete-73473\";i:72714;s:12:\"delete-73474\";i:72715;s:12:\"delete-73475\";i:72716;s:12:\"delete-73476\";i:72717;s:12:\"delete-73477\";i:72718;s:12:\"delete-73479\";i:72719;s:12:\"delete-73478\";i:72720;s:12:\"delete-73480\";i:72721;s:12:\"delete-73481\";i:72722;s:12:\"delete-73484\";i:72723;s:12:\"delete-73482\";i:72724;s:12:\"delete-73483\";i:72725;s:12:\"delete-73485\";i:72726;s:12:\"delete-73486\";i:72727;s:12:\"delete-73487\";i:72728;s:12:\"delete-73490\";i:72729;s:12:\"delete-73492\";i:72730;s:12:\"delete-73488\";i:72731;s:12:\"delete-73489\";i:72732;s:12:\"delete-73491\";i:72733;s:12:\"delete-73493\";i:72734;s:12:\"delete-73496\";i:72735;s:12:\"delete-73494\";i:72736;s:12:\"delete-73495\";i:72737;s:12:\"delete-73497\";i:72738;s:12:\"delete-73498\";i:72739;s:12:\"delete-73499\";i:72740;s:12:\"delete-73502\";i:72741;s:12:\"delete-73500\";i:72742;s:12:\"delete-73501\";i:72743;s:12:\"delete-73503\";i:72744;s:12:\"delete-73504\";i:72745;s:12:\"delete-73505\";i:72746;s:12:\"delete-73508\";i:72747;s:12:\"delete-73506\";i:72748;s:12:\"delete-73507\";i:72749;s:12:\"delete-73509\";i:72750;s:12:\"delete-73510\";i:72751;s:12:\"delete-73511\";i:72752;s:12:\"delete-73514\";i:72753;s:12:\"delete-73512\";i:72754;s:12:\"delete-73513\";i:72755;s:12:\"delete-73515\";i:72756;s:12:\"delete-73516\";i:72757;s:12:\"delete-73517\";i:72758;s:12:\"delete-73520\";i:72759;s:12:\"delete-73522\";i:72760;s:12:\"delete-73523\";i:72761;s:12:\"delete-73526\";i:72762;s:12:\"delete-73528\";i:72763;s:12:\"delete-73518\";i:72764;s:12:\"delete-73519\";i:72765;s:12:\"delete-73521\";i:72766;s:12:\"delete-73524\";i:72767;s:12:\"delete-73525\";i:72768;s:12:\"delete-73527\";i:72769;s:12:\"delete-73529\";i:72770;s:12:\"delete-73532\";i:72771;s:12:\"delete-73534\";i:72772;s:12:\"delete-73530\";i:72773;s:12:\"delete-73531\";i:72774;s:12:\"delete-73533\";i:72775;s:12:\"delete-73535\";i:72776;s:12:\"delete-73538\";i:72777;s:12:\"delete-73536\";i:72778;s:12:\"delete-73537\";i:72779;s:12:\"delete-73539\";i:72780;s:12:\"delete-73540\";i:72781;s:12:\"delete-73541\";i:72782;s:12:\"delete-73544\";i:72783;s:12:\"delete-73546\";i:72784;s:12:\"delete-73542\";i:72785;s:12:\"delete-73543\";i:72786;s:12:\"delete-73545\";i:72787;s:12:\"delete-73547\";i:72788;s:12:\"delete-73550\";i:72789;s:12:\"delete-73552\";i:72790;s:12:\"delete-73548\";i:72791;s:12:\"delete-73549\";i:72792;s:12:\"delete-73551\";i:72793;s:12:\"delete-73553\";i:72794;s:12:\"delete-73556\";i:72795;s:12:\"delete-73554\";i:72796;s:12:\"delete-73555\";i:72797;s:12:\"delete-73557\";i:72798;s:12:\"delete-73558\";i:72799;s:12:\"delete-73559\";i:72800;s:12:\"delete-73562\";i:72801;s:12:\"delete-73560\";i:72802;s:12:\"delete-73561\";i:72803;s:12:\"delete-73563\";i:72804;s:12:\"delete-73564\";i:72805;s:12:\"delete-73565\";i:72806;s:12:\"delete-73568\";i:72807;s:12:\"delete-73570\";i:72808;s:12:\"delete-73566\";i:72809;s:12:\"delete-73567\";i:72810;s:12:\"delete-73569\";i:72811;s:12:\"delete-73571\";i:72812;s:12:\"delete-73574\";i:72813;s:12:\"delete-73576\";i:72814;s:12:\"delete-73572\";i:72815;s:12:\"delete-73573\";i:72816;s:12:\"delete-73575\";i:72817;s:12:\"delete-73577\";i:72818;s:12:\"delete-73580\";i:72819;s:12:\"delete-73582\";i:72820;s:12:\"delete-73583\";i:72821;s:12:\"delete-73586\";i:72822;s:12:\"delete-73588\";i:72823;s:12:\"delete-73578\";i:72824;s:12:\"delete-73579\";i:72825;s:12:\"delete-73581\";i:72826;s:12:\"delete-73584\";i:72827;s:12:\"delete-73585\";i:72828;s:12:\"delete-73587\";i:72829;s:12:\"delete-73589\";i:72830;s:12:\"delete-73592\";i:72831;s:12:\"delete-73594\";i:72832;s:12:\"delete-73590\";i:72833;s:12:\"delete-73591\";i:72834;s:12:\"delete-73593\";i:72835;s:12:\"delete-73595\";i:72836;s:12:\"delete-73598\";i:72837;s:12:\"delete-73600\";i:72838;s:12:\"delete-73596\";i:72839;s:12:\"delete-73597\";i:72840;s:12:\"delete-73599\";i:72841;s:12:\"delete-73601\";i:72842;s:12:\"delete-73604\";i:72843;s:12:\"delete-73606\";i:72844;s:12:\"delete-73602\";i:72845;s:12:\"delete-73603\";i:72846;s:12:\"delete-73605\";i:72847;s:12:\"delete-73607\";i:72848;s:12:\"delete-73610\";i:72849;s:12:\"delete-73612\";i:72850;s:12:\"delete-73608\";i:72851;s:12:\"delete-73609\";i:72852;s:12:\"delete-73611\";i:72853;s:12:\"delete-73613\";i:72854;s:12:\"delete-73616\";i:72855;s:12:\"delete-73618\";i:72856;s:12:\"delete-73614\";i:72857;s:12:\"delete-73615\";i:72858;s:12:\"delete-73617\";i:72859;s:12:\"delete-73619\";i:72860;s:12:\"delete-73620\";i:72861;s:12:\"delete-73621\";i:72862;s:12:\"delete-73623\";i:72863;s:12:\"delete-73622\";i:72864;s:12:\"delete-73624\";i:72865;s:12:\"delete-73625\";i:72866;s:12:\"delete-73628\";i:72867;s:12:\"delete-73626\";i:72868;s:12:\"delete-73627\";i:72869;s:12:\"delete-73629\";i:72870;s:12:\"delete-73630\";i:72871;s:12:\"delete-73631\";i:72872;s:12:\"delete-73634\";i:72873;s:12:\"delete-73632\";i:72874;s:12:\"delete-73633\";i:72875;s:12:\"delete-73635\";i:72876;s:12:\"delete-73636\";i:72877;s:12:\"delete-73637\";i:72878;s:12:\"delete-73640\";i:72879;s:12:\"delete-73642\";i:72880;s:12:\"delete-73638\";i:72881;s:12:\"delete-73639\";i:72882;s:12:\"delete-73641\";i:72883;s:12:\"delete-73643\";i:72884;s:12:\"delete-73646\";i:72885;s:12:\"delete-73648\";i:72886;s:12:\"delete-73644\";i:72887;s:12:\"delete-73645\";i:72888;s:12:\"delete-73647\";i:72889;s:12:\"delete-73649\";i:72890;s:12:\"delete-73652\";i:72891;s:12:\"delete-73650\";i:72892;s:12:\"delete-73651\";i:72893;s:12:\"delete-73653\";i:72894;s:12:\"delete-73654\";i:72895;s:12:\"delete-73655\";i:72896;s:12:\"delete-73658\";i:72897;s:12:\"delete-73660\";i:72898;s:12:\"delete-73656\";i:72899;s:12:\"delete-73657\";i:72900;s:12:\"delete-73659\";i:72901;s:12:\"delete-73661\";i:72902;s:12:\"delete-73664\";i:72903;s:12:\"delete-73666\";i:72904;s:12:\"delete-73662\";i:72905;s:12:\"delete-73663\";i:72906;s:12:\"delete-73665\";i:72907;s:12:\"delete-73667\";i:72908;s:12:\"delete-73670\";i:72909;s:12:\"delete-73668\";i:72910;s:12:\"delete-73669\";i:72911;s:12:\"delete-73671\";i:72912;s:12:\"delete-73672\";i:72913;s:12:\"delete-73673\";i:72914;s:12:\"delete-73674\";i:72915;s:12:\"delete-73675\";i:72916;s:12:\"delete-73677\";i:72917;s:12:\"delete-73676\";i:72918;s:12:\"delete-73678\";i:72919;s:12:\"delete-73679\";i:72920;s:12:\"delete-73682\";i:72921;s:12:\"delete-73684\";i:72922;s:12:\"delete-73680\";i:72923;s:12:\"delete-73681\";i:72924;s:12:\"delete-73683\";i:72925;s:12:\"delete-73685\";i:72926;s:12:\"delete-73688\";i:72927;s:12:\"delete-73686\";i:72928;s:12:\"delete-73687\";i:72929;s:12:\"delete-73689\";i:72930;s:12:\"delete-73690\";i:72931;s:12:\"delete-73691\";i:72932;s:12:\"delete-73694\";i:72933;s:12:\"delete-73696\";i:72934;s:12:\"delete-73692\";i:72935;s:12:\"delete-73693\";i:72936;s:12:\"delete-73695\";i:72937;s:12:\"delete-73697\";i:72938;s:12:\"delete-73700\";i:72939;s:12:\"delete-73698\";i:72940;s:12:\"delete-73699\";i:72941;s:12:\"delete-73701\";i:72942;s:12:\"delete-73702\";i:72943;s:12:\"delete-73703\";i:72944;s:12:\"delete-73706\";i:72945;s:12:\"delete-73704\";i:72946;s:12:\"delete-73705\";i:72947;s:12:\"delete-73707\";i:72948;s:12:\"delete-73708\";i:72949;s:12:\"delete-73709\";i:72950;s:12:\"delete-73712\";i:72951;s:12:\"delete-73710\";i:72952;s:12:\"delete-73711\";i:72953;s:12:\"delete-73713\";i:72954;s:12:\"delete-73714\";i:72955;s:12:\"delete-73715\";i:72956;s:12:\"delete-73718\";i:72957;s:12:\"delete-73716\";i:72958;s:12:\"delete-73717\";i:72959;s:12:\"delete-73719\";i:72960;s:12:\"delete-73720\";i:72961;s:12:\"delete-73721\";i:72962;s:12:\"delete-73724\";i:72963;s:12:\"delete-73726\";i:72964;s:12:\"delete-73722\";i:72965;s:12:\"delete-73723\";i:72966;s:12:\"delete-73725\";i:72967;s:12:\"delete-73727\";i:72968;s:12:\"delete-73730\";i:72969;s:12:\"delete-73732\";i:72970;s:12:\"delete-73728\";i:72971;s:12:\"delete-73729\";i:72972;s:12:\"delete-73731\";i:72973;s:12:\"delete-73733\";i:72974;s:12:\"delete-73736\";i:72975;s:12:\"delete-73734\";i:72976;s:12:\"delete-73735\";i:72977;s:12:\"delete-73737\";i:72978;s:12:\"delete-73738\";i:72979;s:12:\"delete-73739\";i:72980;s:12:\"delete-73742\";i:72981;s:12:\"delete-73744\";i:72982;s:12:\"delete-73740\";i:72983;s:12:\"delete-73741\";i:72984;s:12:\"delete-73743\";i:72985;s:12:\"delete-73745\";i:72986;s:12:\"delete-73748\";i:72987;s:12:\"delete-73746\";i:72988;s:12:\"delete-73747\";i:72989;s:12:\"delete-73749\";i:72990;s:12:\"delete-73750\";i:72991;s:12:\"delete-73751\";i:72992;s:12:\"delete-73754\";i:72993;s:12:\"delete-73752\";i:72994;s:12:\"delete-73753\";i:72995;s:12:\"delete-73755\";i:72996;s:12:\"delete-73756\";i:72997;s:12:\"delete-73757\";i:72998;s:12:\"delete-73760\";i:72999;s:12:\"delete-73758\";i:73000;s:12:\"delete-73759\";i:73001;s:12:\"delete-73761\";i:73002;s:12:\"delete-73762\";i:73003;s:12:\"delete-73763\";i:73004;s:12:\"delete-73766\";i:73005;s:12:\"delete-73768\";i:73006;s:12:\"delete-73764\";i:73007;s:12:\"delete-73765\";i:73008;s:12:\"delete-73767\";i:73009;s:12:\"delete-73769\";i:73010;s:12:\"delete-73772\";i:73011;s:12:\"delete-73774\";i:73012;s:12:\"delete-73770\";i:73013;s:12:\"delete-73771\";i:73014;s:12:\"delete-73773\";i:73015;s:12:\"delete-73775\";i:73016;s:12:\"delete-73778\";i:73017;s:12:\"delete-73780\";i:73018;s:12:\"delete-73776\";i:73019;s:12:\"delete-73777\";i:73020;s:12:\"delete-73779\";i:73021;s:12:\"delete-73781\";i:73022;s:12:\"delete-73784\";i:73023;s:12:\"delete-73786\";i:73024;s:12:\"delete-73782\";i:73025;s:12:\"delete-73783\";i:73026;s:12:\"delete-73785\";i:73027;s:12:\"delete-73787\";i:73028;s:12:\"delete-73788\";i:73029;s:12:\"delete-73789\";i:73030;s:12:\"delete-73790\";i:73031;s:12:\"delete-73792\";i:73032;s:12:\"delete-73793\";i:73033;s:12:\"delete-73796\";i:73034;s:12:\"delete-73791\";i:73035;s:12:\"delete-73794\";i:73036;s:12:\"delete-73795\";i:73037;s:12:\"delete-73797\";i:73038;s:12:\"delete-73798\";i:73039;s:12:\"delete-73799\";i:73040;s:12:\"delete-73802\";i:73041;s:12:\"delete-73804\";i:73042;s:12:\"delete-73800\";i:73043;s:12:\"delete-73801\";i:73044;s:12:\"delete-73803\";i:73045;s:12:\"delete-73805\";i:73046;s:12:\"delete-73808\";i:73047;s:12:\"delete-73810\";i:73048;s:12:\"delete-73806\";i:73049;s:12:\"delete-73807\";i:73050;s:12:\"delete-73809\";i:73051;s:12:\"delete-73811\";i:73052;s:12:\"delete-73814\";i:73053;s:12:\"delete-73812\";i:73054;s:12:\"delete-73813\";i:73055;s:12:\"delete-73815\";i:73056;s:12:\"delete-73816\";i:73057;s:12:\"delete-73817\";i:73058;s:12:\"delete-73820\";i:73059;s:12:\"delete-73818\";i:73060;s:12:\"delete-73819\";i:73061;s:12:\"delete-73821\";i:73062;s:12:\"delete-73822\";i:73063;s:12:\"delete-73823\";i:73064;s:12:\"delete-73824\";i:73065;s:12:\"delete-73825\";i:73066;s:12:\"delete-73827\";i:73067;s:12:\"delete-73826\";i:73068;s:12:\"delete-73828\";i:73069;s:12:\"delete-73829\";i:73070;s:12:\"delete-73832\";i:73071;s:12:\"delete-73830\";i:73072;s:12:\"delete-73831\";i:73073;s:12:\"delete-73833\";i:73074;s:12:\"delete-73834\";i:73075;s:12:\"delete-73835\";i:73076;s:12:\"delete-73838\";i:73077;s:12:\"delete-73836\";i:73078;s:12:\"delete-73837\";i:73079;s:12:\"delete-73839\";i:73080;s:12:\"delete-73840\";i:73081;s:12:\"delete-73841\";i:73082;s:12:\"delete-73844\";i:73083;s:12:\"delete-73846\";i:73084;s:12:\"delete-73842\";i:73085;s:12:\"delete-73843\";i:73086;s:12:\"delete-73845\";i:73087;s:12:\"delete-73847\";i:73088;s:12:\"delete-73850\";i:73089;s:12:\"delete-73852\";i:73090;s:12:\"delete-73848\";i:73091;s:12:\"delete-73849\";i:73092;s:12:\"delete-73851\";i:73093;s:12:\"delete-73853\";i:73094;s:12:\"delete-73856\";i:73095;s:12:\"delete-73858\";i:73096;s:12:\"delete-73854\";i:73097;s:12:\"delete-73855\";i:73098;s:12:\"delete-73857\";i:73099;s:12:\"delete-73859\";i:73100;s:12:\"delete-73862\";i:73101;s:12:\"delete-73864\";i:73102;s:12:\"delete-73860\";i:73103;s:12:\"delete-73861\";i:73104;s:12:\"delete-73863\";i:73105;s:12:\"delete-73865\";i:73106;s:12:\"delete-73868\";i:73107;s:12:\"delete-73866\";i:73108;s:12:\"delete-73867\";i:73109;s:12:\"delete-73869\";i:73110;s:12:\"delete-73870\";i:73111;s:12:\"delete-73871\";i:73112;s:12:\"delete-73874\";i:73113;s:12:\"delete-73876\";i:73114;s:12:\"delete-73872\";i:73115;s:12:\"delete-73873\";i:73116;s:12:\"delete-73875\";i:73117;s:12:\"delete-73877\";i:73118;s:12:\"delete-73880\";i:73119;s:12:\"delete-73878\";i:73120;s:12:\"delete-73879\";i:73121;s:12:\"delete-73881\";i:73122;s:12:\"delete-73882\";i:73123;s:12:\"delete-73883\";i:73124;s:12:\"delete-73886\";i:73125;s:12:\"delete-73888\";i:73126;s:12:\"delete-73884\";i:73127;s:12:\"delete-73885\";i:73128;s:12:\"delete-73887\";i:73129;s:12:\"delete-73889\";i:73130;s:12:\"delete-73892\";i:73131;s:12:\"delete-73890\";i:73132;s:12:\"delete-73891\";i:73133;s:12:\"delete-73893\";i:73134;s:12:\"delete-73894\";i:73135;s:12:\"delete-73895\";i:73136;s:12:\"delete-73898\";i:73137;s:12:\"delete-73900\";i:73138;s:12:\"delete-73896\";i:73139;s:12:\"delete-73897\";i:73140;s:12:\"delete-73899\";i:73141;s:12:\"delete-73901\";i:73142;s:12:\"delete-73904\";i:73143;s:12:\"delete-73906\";i:73144;s:12:\"delete-73902\";i:73145;s:12:\"delete-73903\";i:73146;s:12:\"delete-73905\";i:73147;s:12:\"delete-73907\";i:73148;s:12:\"delete-73910\";i:73149;s:12:\"delete-73912\";i:73150;s:12:\"delete-73908\";i:73151;s:12:\"delete-73909\";i:73152;s:12:\"delete-73911\";i:73153;s:12:\"delete-73913\";i:73154;s:12:\"delete-73916\";i:73155;s:12:\"delete-73914\";i:73156;s:12:\"delete-73915\";i:73157;s:12:\"delete-73917\";i:73158;s:12:\"delete-73918\";i:73159;s:12:\"delete-73919\";i:73160;s:12:\"delete-73922\";i:73161;s:12:\"delete-73920\";i:73162;s:12:\"delete-73921\";i:73163;s:12:\"delete-73923\";i:73164;s:12:\"delete-73924\";i:73165;s:12:\"delete-73925\";i:73166;s:12:\"delete-73928\";i:73167;s:12:\"delete-73926\";i:73168;s:12:\"delete-73927\";i:73169;s:12:\"delete-73929\";i:73170;s:12:\"delete-73930\";i:73171;s:12:\"delete-73931\";i:73172;s:12:\"delete-73934\";i:73173;s:12:\"delete-73936\";i:73174;s:12:\"delete-73932\";i:73175;s:12:\"delete-73933\";i:73176;s:12:\"delete-73935\";i:73177;s:12:\"delete-73937\";i:73178;s:12:\"delete-73940\";i:73179;s:12:\"delete-73942\";i:73180;s:12:\"delete-73938\";i:73181;s:12:\"delete-73939\";i:73182;s:12:\"delete-73941\";i:73183;s:12:\"delete-73943\";i:73184;s:12:\"delete-73946\";i:73185;s:12:\"delete-73944\";i:73186;s:12:\"delete-73945\";i:73187;s:12:\"delete-73947\";i:73188;s:12:\"delete-73948\";i:73189;s:12:\"delete-73949\";i:73190;s:12:\"delete-73952\";i:73191;s:12:\"delete-73954\";i:73192;s:12:\"delete-73950\";i:73193;s:12:\"delete-73951\";i:73194;s:12:\"delete-73953\";i:73195;s:12:\"delete-73955\";i:73196;s:12:\"delete-73958\";i:73197;s:12:\"delete-73960\";i:73198;s:12:\"delete-73956\";i:73199;s:12:\"delete-73957\";i:73200;s:12:\"delete-73959\";i:73201;s:12:\"delete-73961\";i:73202;s:12:\"delete-73962\";i:73203;s:12:\"delete-73963\";i:73204;s:12:\"delete-73965\";i:73205;s:12:\"delete-73964\";i:73206;s:12:\"delete-73966\";i:73207;s:12:\"delete-73967\";i:73208;s:12:\"delete-73970\";i:73209;s:12:\"delete-73972\";i:73210;s:12:\"delete-73968\";i:73211;s:12:\"delete-73969\";i:73212;s:12:\"delete-73971\";i:73213;s:12:\"delete-73973\";i:73214;s:12:\"delete-73974\";i:73215;s:12:\"delete-73975\";i:73216;s:12:\"delete-73976\";i:73217;s:12:\"delete-73978\";i:73218;s:12:\"delete-73979\";i:73219;s:12:\"delete-73982\";i:73220;s:12:\"delete-73984\";i:73221;s:12:\"delete-73977\";i:73222;s:12:\"delete-73980\";i:73223;s:12:\"delete-73981\";i:73224;s:12:\"delete-73983\";i:73225;s:12:\"delete-73985\";i:73226;s:12:\"delete-73988\";i:73227;s:12:\"delete-73986\";i:73228;s:12:\"delete-73987\";i:73229;s:12:\"delete-73989\";i:73230;s:12:\"delete-73990\";i:73231;s:12:\"delete-73991\";i:73232;s:12:\"delete-73994\";i:73233;s:12:\"delete-73996\";i:73234;s:12:\"delete-73992\";i:73235;s:12:\"delete-73993\";i:73236;s:12:\"delete-73995\";i:73237;s:12:\"delete-73997\";i:73238;s:12:\"delete-74000\";i:73239;s:12:\"delete-73998\";i:73240;s:12:\"delete-73999\";i:73241;s:12:\"delete-74001\";i:73242;s:12:\"delete-74002\";i:73243;s:12:\"delete-74003\";i:73244;s:12:\"delete-74006\";i:73245;s:12:\"delete-74004\";i:73246;s:12:\"delete-74005\";i:73247;s:12:\"delete-74007\";i:73248;s:12:\"delete-74008\";i:73249;s:12:\"delete-74009\";i:73250;s:12:\"delete-74012\";i:73251;s:12:\"delete-74010\";i:73252;s:12:\"delete-74011\";i:73253;s:12:\"delete-74013\";i:73254;s:12:\"delete-74014\";i:73255;s:12:\"delete-74015\";i:73256;s:12:\"delete-74018\";i:73257;s:12:\"delete-74020\";i:73258;s:12:\"delete-74016\";i:73259;s:12:\"delete-74017\";i:73260;s:12:\"delete-74019\";i:73261;s:12:\"delete-74021\";i:73262;s:12:\"delete-74024\";i:73263;s:12:\"delete-74026\";i:73264;s:12:\"delete-74022\";i:73265;s:12:\"delete-74023\";i:73266;s:12:\"delete-74025\";i:73267;s:12:\"delete-74027\";i:73268;s:12:\"delete-74030\";i:73269;s:12:\"delete-74032\";i:73270;s:12:\"delete-74033\";i:73271;s:12:\"delete-74028\";i:73272;s:12:\"delete-74029\";i:73273;s:12:\"delete-74031\";i:73274;s:12:\"delete-74034\";i:73275;s:12:\"delete-74035\";i:73276;s:12:\"delete-74037\";i:73277;s:12:\"delete-74036\";i:73278;s:12:\"delete-74038\";i:73279;s:12:\"delete-74039\";i:73280;s:12:\"delete-74042\";i:73281;s:12:\"delete-74040\";i:73282;s:12:\"delete-74041\";i:73283;s:12:\"delete-74043\";i:73284;s:12:\"delete-74044\";i:73285;s:12:\"delete-74045\";i:73286;s:12:\"delete-74048\";i:73287;s:12:\"delete-74050\";i:73288;s:12:\"delete-74051\";i:73289;s:12:\"delete-74054\";i:73290;s:12:\"delete-74056\";i:73291;s:12:\"delete-74046\";i:73292;s:12:\"delete-74047\";i:73293;s:12:\"delete-74049\";i:73294;s:12:\"delete-74052\";i:73295;s:12:\"delete-74053\";i:73296;s:12:\"delete-74055\";i:73297;s:12:\"delete-74057\";i:73298;s:12:\"delete-74060\";i:73299;s:12:\"delete-74058\";i:73300;s:12:\"delete-74059\";i:73301;s:12:\"delete-74061\";i:73302;s:12:\"delete-74062\";i:73303;s:12:\"delete-74063\";i:73304;s:12:\"delete-74066\";i:73305;s:12:\"delete-74064\";i:73306;s:12:\"delete-74065\";i:73307;s:12:\"delete-74067\";i:73308;s:12:\"delete-74068\";i:73309;s:12:\"delete-74069\";i:73310;s:12:\"delete-74072\";i:73311;s:12:\"delete-74074\";i:73312;s:12:\"delete-74070\";i:73313;s:12:\"delete-74071\";i:73314;s:12:\"delete-74073\";i:73315;s:12:\"delete-74075\";i:73316;s:12:\"delete-74078\";i:73317;s:12:\"delete-74080\";i:73318;s:12:\"delete-74076\";i:73319;s:12:\"delete-74077\";i:73320;s:12:\"delete-74079\";i:73321;s:12:\"delete-74081\";i:73322;s:12:\"delete-74084\";i:73323;s:12:\"delete-74086\";i:73324;s:12:\"delete-74082\";i:73325;s:12:\"delete-74083\";i:73326;s:12:\"delete-74085\";i:73327;s:12:\"delete-74087\";i:73328;s:12:\"delete-74090\";i:73329;s:12:\"delete-74092\";i:73330;s:12:\"delete-74088\";i:73331;s:12:\"delete-74089\";i:73332;s:12:\"delete-74091\";i:73333;s:12:\"delete-74093\";i:73334;s:12:\"delete-74096\";i:73335;s:12:\"delete-74094\";i:73336;s:12:\"delete-74095\";i:73337;s:12:\"delete-74097\";i:73338;s:12:\"delete-74098\";i:73339;s:12:\"delete-74099\";i:73340;s:12:\"delete-74102\";i:73341;s:12:\"delete-74104\";i:73342;s:12:\"delete-74100\";i:73343;s:12:\"delete-74101\";i:73344;s:12:\"delete-74103\";i:73345;s:12:\"delete-74105\";i:73346;s:12:\"delete-74108\";i:73347;s:12:\"delete-74106\";i:73348;s:12:\"delete-74107\";i:73349;s:12:\"delete-74109\";i:73350;s:12:\"delete-74110\";i:73351;s:12:\"delete-74111\";i:73352;s:12:\"delete-74114\";i:73353;s:12:\"delete-74116\";i:73354;s:12:\"delete-74112\";i:73355;s:12:\"delete-74113\";i:73356;s:12:\"delete-74115\";i:73357;s:12:\"delete-74117\";i:73358;s:12:\"delete-74120\";i:73359;s:12:\"delete-74122\";i:73360;s:12:\"delete-74118\";i:73361;s:12:\"delete-74119\";i:73362;s:12:\"delete-74121\";i:73363;s:12:\"delete-74123\";i:73364;s:12:\"delete-74126\";i:73365;s:12:\"delete-74124\";i:73366;s:12:\"delete-74125\";i:73367;s:12:\"delete-74127\";i:73368;s:12:\"delete-74128\";i:73369;s:12:\"delete-74129\";i:73370;s:12:\"delete-74132\";i:73371;s:12:\"delete-74134\";i:73372;s:12:\"delete-74130\";i:73373;s:12:\"delete-74131\";i:73374;s:12:\"delete-74133\";i:73375;s:12:\"delete-74135\";i:73376;s:12:\"delete-74138\";i:73377;s:12:\"delete-74140\";i:73378;s:12:\"delete-74136\";i:73379;s:12:\"delete-74137\";i:73380;s:12:\"delete-74139\";i:73381;s:12:\"delete-74141\";i:73382;s:12:\"delete-74144\";i:73383;s:12:\"delete-74142\";i:73384;s:12:\"delete-74143\";i:73385;s:12:\"delete-74145\";i:73386;s:12:\"delete-74146\";i:73387;s:12:\"delete-74147\";i:73388;s:12:\"delete-74150\";i:73389;s:12:\"delete-74148\";i:73390;s:12:\"delete-74149\";i:73391;s:12:\"delete-74151\";i:73392;s:12:\"delete-74152\";i:73393;s:12:\"delete-74153\";i:73394;s:12:\"delete-74156\";i:73395;s:12:\"delete-74158\";i:73396;s:12:\"delete-74154\";i:73397;s:12:\"delete-74155\";i:73398;s:12:\"delete-74157\";i:73399;s:12:\"delete-74159\";i:73400;s:12:\"delete-74162\";i:73401;s:12:\"delete-74160\";i:73402;s:12:\"delete-74161\";i:73403;s:12:\"delete-74163\";i:73404;s:12:\"delete-74164\";i:73405;s:12:\"delete-74165\";i:73406;s:12:\"delete-74168\";i:73407;s:12:\"delete-74166\";i:73408;s:12:\"delete-74167\";i:73409;s:12:\"delete-74169\";i:73410;s:12:\"delete-74170\";i:73411;s:12:\"delete-74171\";i:73412;s:12:\"delete-74172\";i:73413;s:12:\"delete-74173\";i:73414;s:12:\"delete-74175\";i:73415;s:12:\"delete-74174\";i:73416;s:12:\"delete-74176\";i:73417;s:12:\"delete-74177\";i:73418;s:12:\"delete-74180\";i:73419;s:12:\"delete-74178\";i:73420;s:12:\"delete-74179\";i:73421;s:12:\"delete-74181\";i:73422;s:12:\"delete-74182\";i:73423;s:12:\"delete-74183\";i:73424;s:12:\"delete-74186\";i:73425;s:12:\"delete-74184\";i:73426;s:12:\"delete-74185\";i:73427;s:12:\"delete-74187\";i:73428;s:12:\"delete-74188\";i:73429;s:12:\"delete-74189\";i:73430;s:12:\"delete-74190\";i:73431;s:12:\"delete-74191\";i:73432;s:12:\"delete-74193\";i:73433;s:12:\"delete-74192\";i:73434;s:12:\"delete-74194\";i:73435;s:12:\"delete-74195\";i:73436;s:12:\"delete-74198\";i:73437;s:12:\"delete-74200\";i:73438;s:12:\"delete-74196\";i:73439;s:12:\"delete-74197\";i:73440;s:12:\"delete-74199\";i:73441;s:12:\"delete-74201\";i:73442;s:12:\"delete-74204\";i:73443;s:12:\"delete-74206\";i:73444;s:12:\"delete-74202\";i:73445;s:12:\"delete-74203\";i:73446;s:12:\"delete-74205\";i:73447;s:12:\"delete-74207\";i:73448;s:12:\"delete-74210\";i:73449;s:12:\"delete-74208\";i:73450;s:12:\"delete-74209\";i:73451;s:12:\"delete-74211\";i:73452;s:12:\"delete-74212\";i:73453;s:12:\"delete-74213\";i:73454;s:12:\"delete-74216\";i:73455;s:12:\"delete-74214\";i:73456;s:12:\"delete-74215\";i:73457;s:12:\"delete-74217\";i:73458;s:12:\"delete-74218\";i:73459;s:12:\"delete-74219\";i:73460;s:12:\"delete-74222\";i:73461;s:12:\"delete-74224\";i:73462;s:12:\"delete-74220\";i:73463;s:12:\"delete-74221\";i:73464;s:12:\"delete-74223\";i:73465;s:12:\"delete-74225\";i:73466;s:12:\"delete-74228\";i:73467;s:12:\"delete-74230\";i:73468;s:12:\"delete-74226\";i:73469;s:12:\"delete-74227\";i:73470;s:12:\"delete-74229\";i:73471;s:12:\"delete-74231\";i:73472;s:12:\"delete-74234\";i:73473;s:12:\"delete-74232\";i:73474;s:12:\"delete-74233\";i:73475;s:12:\"delete-74235\";i:73476;s:12:\"delete-74236\";i:73477;s:12:\"delete-74237\";i:73478;s:12:\"delete-74240\";i:73479;s:12:\"delete-74238\";i:73480;s:12:\"delete-74239\";i:73481;s:12:\"delete-74241\";i:73482;s:12:\"delete-74242\";i:73483;s:12:\"delete-74243\";i:73484;s:12:\"delete-74244\";i:73485;s:12:\"delete-74245\";i:73486;s:12:\"delete-74247\";i:73487;s:12:\"delete-74246\";i:73488;s:12:\"delete-74248\";i:73489;s:12:\"delete-74249\";i:73490;s:12:\"delete-74252\";i:73491;s:12:\"delete-74254\";i:73492;s:12:\"delete-74250\";i:73493;s:12:\"delete-74251\";i:73494;s:12:\"delete-74253\";i:73495;s:12:\"delete-74255\";i:73496;s:12:\"delete-74258\";i:73497;s:12:\"delete-74260\";i:73498;s:12:\"delete-74256\";i:73499;s:12:\"delete-74257\";i:73500;s:12:\"delete-74259\";i:73501;s:12:\"delete-74261\";i:73502;s:12:\"delete-74264\";i:73503;s:12:\"delete-74262\";i:73504;s:12:\"delete-74263\";i:73505;s:12:\"delete-74265\";i:73506;s:12:\"delete-74266\";i:73507;s:12:\"delete-74267\";i:73508;s:12:\"delete-74270\";i:73509;s:12:\"delete-74268\";i:73510;s:12:\"delete-74269\";i:73511;s:12:\"delete-74271\";i:73512;s:12:\"delete-74272\";i:73513;s:12:\"delete-74273\";i:73514;s:12:\"delete-74276\";i:73515;s:12:\"delete-74274\";i:73516;s:12:\"delete-74275\";i:73517;s:12:\"delete-74277\";i:73518;s:12:\"delete-74278\";i:73519;s:12:\"delete-74279\";i:73520;s:12:\"delete-74282\";i:73521;s:12:\"delete-74280\";i:73522;s:12:\"delete-74281\";i:73523;s:12:\"delete-74283\";i:73524;s:12:\"delete-74284\";i:73525;s:12:\"delete-74285\";i:73526;s:12:\"delete-74288\";i:73527;s:12:\"delete-74290\";i:73528;s:12:\"delete-74286\";i:73529;s:12:\"delete-74287\";i:73530;s:12:\"delete-74289\";i:73531;s:12:\"delete-74291\";i:73532;s:12:\"delete-74294\";i:73533;s:12:\"delete-74296\";i:73534;s:12:\"delete-74297\";i:73535;s:12:\"delete-74300\";i:73536;s:12:\"delete-74292\";i:73537;s:12:\"delete-74293\";i:73538;s:12:\"delete-74295\";i:73539;s:12:\"delete-74298\";i:73540;s:12:\"delete-74299\";i:73541;s:12:\"delete-74301\";i:73542;s:12:\"delete-74302\";i:73543;s:12:\"delete-74303\";i:73544;s:12:\"delete-74306\";i:73545;s:12:\"delete-74304\";i:73546;s:12:\"delete-74305\";i:73547;s:12:\"delete-74307\";i:73548;s:12:\"delete-74308\";i:73549;s:12:\"delete-74309\";i:73550;s:12:\"delete-74312\";i:73551;s:12:\"delete-74314\";i:73552;s:12:\"delete-74310\";i:73553;s:12:\"delete-74311\";i:73554;s:12:\"delete-74313\";i:73555;s:12:\"delete-74315\";i:73556;s:12:\"delete-74318\";i:73557;s:12:\"delete-74320\";i:73558;s:12:\"delete-74316\";i:73559;s:12:\"delete-74317\";i:73560;s:12:\"delete-74319\";i:73561;s:12:\"delete-74321\";i:73562;s:12:\"delete-74322\";i:73563;s:12:\"delete-74323\";i:73564;s:12:\"delete-74325\";i:73565;s:12:\"delete-74324\";i:73566;s:12:\"delete-74326\";i:73567;s:12:\"delete-74327\";i:73568;s:12:\"delete-74330\";i:73569;s:12:\"delete-74332\";i:73570;s:12:\"delete-74328\";i:73571;s:12:\"delete-74329\";i:73572;s:12:\"delete-74331\";i:73573;s:12:\"delete-74333\";i:73574;s:12:\"delete-74334\";i:73575;s:12:\"delete-74335\";i:73576;s:12:\"delete-74336\";i:73577;s:12:\"delete-74337\";i:73578;s:12:\"delete-74340\";i:73579;s:12:\"delete-74338\";i:73580;s:12:\"delete-74339\";i:73581;s:12:\"delete-74341\";i:73582;s:12:\"delete-74342\";i:73583;s:12:\"delete-74343\";i:73584;s:12:\"delete-74346\";i:73585;s:12:\"delete-74348\";i:73586;s:12:\"delete-74344\";i:73587;s:12:\"delete-74345\";i:73588;s:12:\"delete-74347\";i:73589;s:12:\"delete-74349\";i:73590;s:12:\"delete-74352\";i:73591;s:12:\"delete-74354\";i:73592;s:12:\"delete-74350\";i:73593;s:12:\"delete-74351\";i:73594;s:12:\"delete-74353\";i:73595;s:12:\"delete-74355\";i:73596;s:12:\"delete-74358\";i:73597;s:12:\"delete-74356\";i:73598;s:12:\"delete-74357\";i:73599;s:12:\"delete-74359\";i:73600;s:12:\"delete-74360\";i:73601;s:12:\"delete-74361\";i:73602;s:12:\"delete-74364\";i:73603;s:12:\"delete-74362\";i:73604;s:12:\"delete-74363\";i:73605;s:12:\"delete-74365\";i:73606;s:12:\"delete-74366\";i:73607;s:12:\"delete-74367\";i:73608;s:12:\"delete-74370\";i:73609;s:12:\"delete-74372\";i:73610;s:12:\"delete-74368\";i:73611;s:12:\"delete-74369\";i:73612;s:12:\"delete-74371\";i:73613;s:12:\"delete-74373\";i:73614;s:12:\"delete-74376\";i:73615;s:12:\"delete-74378\";i:73616;s:12:\"delete-74374\";i:73617;s:12:\"delete-74375\";i:73618;s:12:\"delete-74377\";i:73619;s:12:\"delete-74379\";i:73620;s:12:\"delete-74382\";i:73621;s:12:\"delete-74384\";i:73622;s:12:\"delete-74380\";i:73623;s:12:\"delete-74381\";i:73624;s:12:\"delete-74383\";i:73625;s:12:\"delete-74385\";i:73626;s:12:\"delete-74388\";i:73627;s:12:\"delete-74386\";i:73628;s:12:\"delete-74387\";i:73629;s:12:\"delete-74389\";i:73630;s:12:\"delete-74390\";i:73631;s:12:\"delete-74391\";i:73632;s:12:\"delete-74394\";i:73633;s:12:\"delete-74396\";i:73634;s:12:\"delete-74392\";i:73635;s:12:\"delete-74393\";i:73636;s:12:\"delete-74395\";i:73637;s:12:\"delete-74397\";i:73638;s:12:\"delete-74400\";i:73639;s:12:\"delete-74402\";i:73640;s:12:\"delete-74398\";i:73641;s:12:\"delete-74399\";i:73642;s:12:\"delete-74401\";i:73643;s:12:\"delete-74403\";i:73644;s:12:\"delete-74406\";i:73645;s:12:\"delete-74404\";i:73646;s:12:\"delete-74405\";i:73647;s:12:\"delete-74407\";i:73648;s:12:\"delete-74408\";i:73649;s:12:\"delete-74409\";i:73650;s:12:\"delete-74412\";i:73651;s:12:\"delete-74410\";i:73652;s:12:\"delete-74411\";i:73653;s:12:\"delete-74413\";i:73654;s:12:\"delete-74414\";i:73655;s:12:\"delete-74415\";i:73656;s:12:\"delete-74416\";i:73657;s:12:\"delete-74417\";i:73658;s:12:\"delete-74419\";i:73659;s:12:\"delete-74418\";i:73660;s:12:\"delete-74420\";i:73661;s:12:\"delete-74421\";i:73662;s:12:\"delete-74424\";i:73663;s:12:\"delete-74426\";i:73664;s:12:\"delete-74422\";i:73665;s:12:\"delete-74423\";i:73666;s:12:\"delete-74425\";i:73667;s:12:\"delete-74427\";i:73668;s:12:\"delete-74430\";i:73669;s:12:\"delete-74432\";i:73670;s:12:\"delete-74428\";i:73671;s:12:\"delete-74429\";i:73672;s:12:\"delete-74431\";i:73673;s:12:\"delete-74433\";i:73674;s:12:\"delete-74436\";i:73675;s:12:\"delete-74434\";i:73676;s:12:\"delete-74435\";i:73677;s:12:\"delete-74437\";i:73678;s:12:\"delete-74438\";i:73679;s:12:\"delete-74439\";i:73680;s:12:\"delete-74442\";i:73681;s:12:\"delete-74444\";i:73682;s:12:\"delete-74440\";i:73683;s:12:\"delete-74441\";i:73684;s:12:\"delete-74443\";i:73685;s:12:\"delete-74445\";i:73686;s:12:\"delete-74448\";i:73687;s:12:\"delete-74446\";i:73688;s:12:\"delete-74447\";i:73689;s:12:\"delete-74449\";i:73690;s:12:\"delete-74450\";i:73691;s:12:\"delete-74451\";i:73692;s:12:\"delete-74454\";i:73693;s:12:\"delete-74452\";i:73694;s:12:\"delete-74453\";i:73695;s:12:\"delete-74455\";i:73696;s:12:\"delete-74456\";i:73697;s:12:\"delete-74457\";i:73698;s:12:\"delete-74460\";i:73699;s:12:\"delete-74458\";i:73700;s:12:\"delete-74459\";i:73701;s:12:\"delete-74461\";i:73702;s:12:\"delete-74462\";i:73703;s:12:\"delete-74463\";i:73704;s:12:\"delete-74464\";i:73705;s:12:\"delete-74465\";i:73706;s:12:\"delete-74467\";i:73707;s:12:\"delete-74466\";i:73708;s:12:\"delete-74468\";i:73709;s:12:\"delete-74469\";i:73710;s:12:\"delete-74472\";i:73711;s:12:\"delete-74474\";i:73712;s:12:\"delete-74470\";i:73713;s:12:\"delete-74471\";i:73714;s:12:\"delete-74473\";i:73715;s:12:\"delete-74475\";i:73716;s:12:\"delete-74478\";i:73717;s:12:\"delete-74476\";i:73718;s:12:\"delete-74477\";i:73719;s:12:\"delete-74479\";i:73720;s:12:\"delete-74480\";i:73721;s:12:\"delete-74481\";i:73722;s:12:\"delete-74484\";i:73723;s:12:\"delete-74486\";i:73724;s:12:\"delete-74482\";i:73725;s:12:\"delete-74483\";i:73726;s:12:\"delete-74485\";i:73727;s:12:\"delete-74487\";i:73728;s:12:\"delete-74490\";i:73729;s:12:\"delete-74488\";i:73730;s:12:\"delete-74489\";i:73731;s:12:\"delete-74491\";i:73732;s:12:\"delete-74492\";i:73733;s:12:\"delete-74493\";i:73734;s:12:\"delete-74496\";i:73735;s:12:\"delete-74494\";i:73736;s:12:\"delete-74495\";i:73737;s:12:\"delete-74497\";i:73738;s:12:\"delete-74498\";i:73739;s:12:\"delete-74499\";i:73740;s:12:\"delete-74502\";i:73741;s:12:\"delete-74504\";i:73742;s:12:\"delete-74500\";i:73743;s:12:\"delete-74501\";i:73744;s:12:\"delete-74503\";i:73745;s:12:\"delete-74505\";i:73746;s:12:\"delete-74508\";i:73747;s:12:\"delete-74506\";i:73748;s:12:\"delete-74507\";i:73749;s:12:\"delete-74509\";i:73750;s:12:\"delete-74510\";i:73751;s:12:\"delete-74511\";i:73752;s:12:\"delete-74514\";i:73753;s:12:\"delete-74512\";i:73754;s:12:\"delete-74513\";i:73755;s:12:\"delete-74515\";i:73756;s:12:\"delete-74516\";i:73757;s:12:\"delete-74517\";i:73758;s:12:\"delete-74520\";i:73759;s:12:\"delete-74518\";i:73760;s:12:\"delete-74519\";i:73761;s:12:\"delete-74521\";i:73762;s:12:\"delete-74522\";i:73763;s:12:\"delete-74523\";i:73764;s:12:\"delete-74526\";i:73765;s:12:\"delete-74524\";i:73766;s:12:\"delete-74525\";i:73767;s:12:\"delete-74527\";i:73768;s:12:\"delete-74528\";i:73769;s:12:\"delete-74529\";i:73770;s:12:\"delete-74532\";i:73771;s:12:\"delete-74530\";i:73772;s:12:\"delete-74531\";i:73773;s:12:\"delete-74533\";i:73774;s:12:\"delete-74534\";i:73775;s:12:\"delete-74535\";i:73776;s:12:\"delete-74538\";i:73777;s:12:\"delete-74540\";i:73778;s:12:\"delete-74536\";i:73779;s:12:\"delete-74537\";i:73780;s:12:\"delete-74539\";i:73781;s:12:\"delete-74541\";i:73782;s:12:\"delete-74542\";i:73783;s:12:\"delete-74543\";i:73784;s:12:\"delete-74545\";i:73785;s:12:\"delete-74544\";i:73786;s:12:\"delete-74546\";i:73787;s:12:\"delete-74547\";i:73788;s:12:\"delete-74550\";i:73789;s:12:\"delete-74552\";i:73790;s:12:\"delete-74548\";i:73791;s:12:\"delete-74549\";i:73792;s:12:\"delete-74551\";i:73793;s:12:\"delete-74553\";i:73794;s:12:\"delete-74556\";i:73795;s:12:\"delete-74558\";i:73796;s:12:\"delete-74554\";i:73797;s:12:\"delete-74555\";i:73798;s:12:\"delete-74557\";i:73799;s:12:\"delete-74559\";i:73800;s:12:\"delete-74562\";i:73801;s:12:\"delete-74564\";i:73802;s:12:\"delete-74560\";i:73803;s:12:\"delete-74561\";i:73804;s:12:\"delete-74563\";i:73805;s:12:\"delete-74565\";i:73806;s:12:\"delete-74568\";i:73807;s:12:\"delete-74570\";i:73808;s:12:\"delete-74566\";i:73809;s:12:\"delete-74567\";i:73810;s:12:\"delete-74569\";i:73811;s:12:\"delete-74571\";i:73812;s:12:\"delete-74574\";i:73813;s:12:\"delete-74572\";i:73814;s:12:\"delete-74573\";i:73815;s:12:\"delete-74575\";i:73816;s:12:\"delete-74576\";i:73817;s:12:\"delete-74577\";i:73818;s:12:\"delete-74580\";i:73819;s:12:\"delete-74578\";i:73820;s:12:\"delete-74579\";i:73821;s:12:\"delete-74581\";i:73822;s:12:\"delete-74582\";i:73823;s:12:\"delete-74584\";i:73824;s:12:\"delete-74585\";i:73825;s:12:\"delete-74587\";i:73826;s:12:\"delete-74583\";i:73827;s:12:\"delete-74586\";i:73828;s:12:\"delete-74588\";i:73829;s:12:\"delete-74589\";i:73830;s:12:\"delete-74592\";i:73831;s:12:\"delete-74590\";i:73832;s:12:\"delete-74591\";i:73833;s:12:\"delete-74593\";i:73834;s:12:\"delete-74594\";i:73835;s:12:\"delete-74595\";i:73836;s:12:\"delete-74598\";i:73837;s:12:\"delete-74600\";i:73838;s:12:\"delete-74596\";i:73839;s:12:\"delete-74597\";i:73840;s:12:\"delete-74599\";i:73841;s:12:\"delete-74601\";i:73842;s:12:\"delete-74602\";i:73843;s:12:\"delete-74603\";i:73844;s:12:\"delete-74604\";i:73845;s:12:\"delete-74606\";i:73846;s:12:\"delete-74607\";i:73847;s:12:\"delete-74610\";i:73848;s:12:\"delete-74612\";i:73849;s:12:\"delete-74605\";i:73850;s:12:\"delete-74608\";i:73851;s:12:\"delete-74609\";i:73852;s:12:\"delete-74611\";i:73853;s:12:\"delete-74613\";i:73854;s:12:\"delete-74616\";i:73855;s:12:\"delete-74618\";i:73856;s:12:\"delete-74614\";i:73857;s:12:\"delete-74615\";i:73858;s:12:\"delete-74617\";i:73859;s:12:\"delete-74619\";i:73860;s:12:\"delete-74622\";i:73861;s:12:\"delete-74624\";i:73862;s:12:\"delete-74620\";i:73863;s:12:\"delete-74621\";i:73864;s:12:\"delete-74623\";i:73865;s:12:\"delete-74625\";i:73866;s:12:\"delete-74628\";i:73867;s:12:\"delete-74630\";i:73868;s:12:\"delete-74626\";i:73869;s:12:\"delete-74627\";i:73870;s:12:\"delete-74629\";i:73871;s:12:\"delete-74631\";i:73872;s:12:\"delete-74634\";i:73873;s:12:\"delete-74632\";i:73874;s:12:\"delete-74633\";i:73875;s:12:\"delete-74635\";i:73876;s:12:\"delete-74636\";i:73877;s:12:\"delete-74637\";i:73878;s:12:\"delete-74640\";i:73879;s:12:\"delete-74638\";i:73880;s:12:\"delete-74639\";i:73881;s:12:\"delete-74641\";i:73882;s:12:\"delete-74642\";i:73883;s:12:\"delete-74643\";i:73884;s:12:\"delete-74646\";i:73885;s:12:\"delete-74644\";i:73886;s:12:\"delete-74645\";i:73887;s:12:\"delete-74647\";i:73888;s:12:\"delete-74648\";i:73889;s:12:\"delete-74649\";i:73890;s:12:\"delete-74650\";i:73891;s:12:\"delete-74651\";i:73892;s:12:\"delete-74653\";i:73893;s:12:\"delete-74652\";i:73894;s:12:\"delete-74654\";i:73895;s:12:\"delete-74655\";i:73896;s:12:\"delete-74656\";i:73897;s:12:\"delete-74657\";i:73898;s:12:\"delete-74659\";i:73899;s:12:\"delete-74658\";i:73900;s:12:\"delete-74660\";i:73901;s:12:\"delete-74661\";i:73902;s:12:\"delete-74664\";i:73903;s:12:\"delete-74662\";i:73904;s:12:\"delete-74663\";i:73905;s:12:\"delete-74665\";i:73906;s:12:\"delete-74666\";i:73907;s:12:\"delete-74667\";i:73908;s:12:\"delete-74670\";i:73909;s:12:\"delete-74668\";i:73910;s:12:\"delete-74669\";i:73911;s:12:\"delete-74671\";i:73912;s:12:\"delete-74672\";i:73913;s:12:\"delete-74673\";i:73914;s:12:\"delete-74676\";i:73915;s:12:\"delete-74674\";i:73916;s:12:\"delete-74675\";i:73917;s:12:\"delete-74677\";i:73918;s:12:\"delete-74678\";i:73919;s:12:\"delete-74679\";i:73920;s:12:\"delete-74682\";i:73921;s:12:\"delete-74684\";i:73922;s:12:\"delete-74680\";i:73923;s:12:\"delete-74681\";i:73924;s:12:\"delete-74683\";i:73925;s:12:\"delete-74685\";i:73926;s:12:\"delete-74688\";i:73927;s:12:\"delete-74686\";i:73928;s:12:\"delete-74687\";i:73929;s:12:\"delete-74689\";i:73930;s:12:\"delete-74690\";i:73931;s:12:\"delete-74691\";i:73932;s:12:\"delete-74694\";i:73933;s:12:\"delete-74692\";i:73934;s:12:\"delete-74693\";i:73935;s:12:\"delete-74695\";i:73936;s:12:\"delete-74696\";i:73937;s:12:\"delete-74697\";i:73938;s:12:\"delete-74700\";i:73939;s:12:\"delete-74702\";i:73940;s:12:\"delete-74698\";i:73941;s:12:\"delete-74699\";i:73942;s:12:\"delete-74701\";i:73943;s:12:\"delete-74703\";i:73944;s:12:\"delete-74706\";i:73945;s:12:\"delete-74704\";i:73946;s:12:\"delete-74705\";i:73947;s:12:\"delete-74707\";i:73948;s:12:\"delete-74708\";i:73949;s:12:\"delete-74709\";i:73950;s:12:\"delete-74712\";i:73951;s:12:\"delete-74710\";i:73952;s:12:\"delete-74711\";i:73953;s:12:\"delete-74713\";i:73954;s:12:\"delete-74714\";i:73955;s:12:\"delete-74715\";i:73956;s:12:\"delete-74718\";i:73957;s:12:\"delete-74716\";i:73958;s:12:\"delete-74717\";i:73959;s:12:\"delete-74719\";i:73960;s:12:\"delete-74720\";i:73961;s:12:\"delete-74721\";i:73962;s:12:\"delete-74724\";i:73963;s:12:\"delete-74722\";i:73964;s:12:\"delete-74723\";i:73965;s:12:\"delete-74725\";i:73966;s:12:\"delete-74726\";i:73967;s:12:\"delete-74727\";i:73968;s:12:\"delete-74730\";i:73969;s:12:\"delete-74732\";i:73970;s:12:\"delete-74728\";i:73971;s:12:\"delete-74729\";i:73972;s:12:\"delete-74731\";i:73973;s:12:\"delete-74733\";i:73974;s:12:\"delete-74736\";i:73975;s:12:\"delete-74738\";i:73976;s:12:\"delete-74734\";i:73977;s:12:\"delete-74735\";i:73978;s:12:\"delete-74737\";i:73979;s:12:\"delete-74739\";i:73980;s:12:\"delete-74742\";i:73981;s:12:\"delete-74740\";i:73982;s:12:\"delete-74741\";i:73983;s:12:\"delete-74743\";i:73984;s:12:\"delete-74744\";i:73985;s:12:\"delete-74745\";i:73986;s:12:\"delete-74748\";i:73987;s:12:\"delete-74746\";i:73988;s:12:\"delete-74747\";i:73989;s:12:\"delete-74749\";i:73990;s:12:\"delete-74750\";i:73991;s:12:\"delete-74751\";i:73992;s:12:\"delete-74754\";i:73993;s:12:\"delete-74752\";i:73994;s:12:\"delete-74753\";i:73995;s:12:\"delete-74755\";i:73996;s:12:\"delete-74756\";i:73997;s:12:\"delete-74757\";i:73998;s:12:\"delete-74760\";i:73999;s:12:\"delete-74758\";i:74000;s:12:\"delete-74759\";i:74001;s:12:\"delete-74761\";i:74002;s:12:\"delete-74762\";i:74003;s:12:\"delete-74763\";i:74004;s:12:\"delete-74766\";i:74005;s:12:\"delete-74764\";i:74006;s:12:\"delete-74765\";i:74007;s:12:\"delete-74767\";i:74008;s:12:\"delete-74768\";i:74009;s:12:\"delete-74769\";i:74010;s:12:\"delete-74770\";i:74011;s:12:\"delete-74771\";i:74012;s:12:\"delete-74773\";i:74013;s:12:\"delete-74772\";i:74014;s:12:\"delete-74774\";i:74015;s:12:\"delete-74775\";i:74016;s:12:\"delete-74778\";i:74017;s:12:\"delete-74776\";i:74018;s:12:\"delete-74777\";i:74019;s:12:\"delete-74779\";i:74020;s:12:\"delete-74780\";i:74021;s:12:\"delete-74781\";i:74022;s:12:\"delete-74784\";i:74023;s:12:\"delete-74782\";i:74024;s:12:\"delete-74783\";i:74025;s:12:\"delete-74785\";i:74026;s:12:\"delete-74786\";i:74027;s:12:\"delete-74787\";i:74028;s:12:\"delete-74790\";i:74029;s:12:\"delete-74788\";i:74030;s:12:\"delete-74789\";i:74031;s:12:\"delete-74791\";i:74032;s:12:\"delete-74792\";i:74033;s:12:\"delete-74793\";i:74034;s:12:\"delete-74796\";i:74035;s:12:\"delete-74794\";i:74036;s:12:\"delete-74795\";i:74037;s:12:\"delete-74797\";i:74038;s:12:\"delete-74798\";i:74039;s:12:\"delete-74799\";i:74040;s:12:\"delete-74802\";i:74041;s:12:\"delete-74804\";i:74042;s:12:\"delete-74800\";i:74043;s:12:\"delete-74801\";i:74044;s:12:\"delete-74803\";i:74045;s:12:\"delete-74805\";i:74046;s:12:\"delete-74806\";i:74047;s:12:\"delete-74807\";i:74048;s:12:\"delete-74809\";i:74049;s:12:\"delete-74808\";i:74050;s:12:\"delete-74810\";i:74051;s:12:\"delete-74811\";i:74052;s:12:\"delete-74812\";i:74053;s:12:\"delete-74813\";i:74054;s:12:\"delete-74815\";i:74055;s:12:\"delete-74814\";i:74056;s:12:\"delete-74816\";i:74057;s:12:\"delete-74817\";i:74058;s:12:\"delete-74820\";i:74059;s:12:\"delete-74818\";i:74060;s:12:\"delete-74819\";i:74061;s:12:\"delete-74821\";i:74062;s:12:\"delete-74822\";i:74063;s:12:\"delete-74823\";i:74064;s:12:\"delete-74826\";i:74065;s:12:\"delete-74828\";i:74066;s:12:\"delete-74824\";i:74067;s:12:\"delete-74825\";i:74068;s:12:\"delete-74827\";i:74069;s:12:\"delete-74829\";i:74070;s:12:\"delete-74832\";i:74071;s:12:\"delete-74834\";i:74072;s:12:\"delete-74830\";i:74073;s:12:\"delete-74831\";i:74074;s:12:\"delete-74833\";i:74075;s:12:\"delete-74835\";i:74076;s:12:\"delete-74838\";i:74077;s:12:\"delete-74840\";i:74078;s:12:\"delete-74836\";i:74079;s:12:\"delete-74837\";i:74080;s:12:\"delete-74839\";i:74081;s:12:\"delete-74841\";i:74082;s:12:\"delete-74842\";i:74083;s:12:\"delete-74843\";i:74084;s:12:\"delete-74845\";i:74085;s:12:\"delete-74844\";i:74086;s:12:\"delete-74846\";i:74087;s:12:\"delete-74847\";i:74088;s:12:\"delete-74850\";i:74089;s:12:\"delete-74848\";i:74090;s:12:\"delete-74849\";i:74091;s:12:\"delete-74851\";i:74092;s:12:\"delete-74852\";i:74093;s:12:\"delete-74853\";i:74094;s:12:\"delete-74856\";i:74095;s:12:\"delete-74858\";i:74096;s:12:\"delete-74854\";i:74097;s:12:\"delete-74855\";i:74098;s:12:\"delete-74857\";i:74099;s:12:\"delete-74859\";i:74100;s:12:\"delete-74862\";i:74101;s:12:\"delete-74864\";i:74102;s:12:\"delete-74860\";i:74103;s:12:\"delete-74861\";i:74104;s:12:\"delete-74863\";i:74105;s:12:\"delete-74865\";i:74106;s:12:\"delete-74868\";i:74107;s:12:\"delete-74866\";i:74108;s:12:\"delete-74867\";i:74109;s:12:\"delete-74869\";i:74110;s:12:\"delete-74870\";i:74111;s:12:\"delete-74871\";i:74112;s:12:\"delete-74874\";i:74113;s:12:\"delete-74872\";i:74114;s:12:\"delete-74873\";i:74115;s:12:\"delete-74875\";i:74116;s:12:\"delete-74876\";i:74117;s:12:\"delete-74877\";i:74118;s:12:\"delete-74880\";i:74119;s:12:\"delete-74878\";i:74120;s:12:\"delete-74879\";i:74121;s:12:\"delete-74881\";i:74122;s:12:\"delete-74882\";i:74123;s:12:\"delete-74883\";i:74124;s:12:\"delete-74886\";i:74125;s:12:\"delete-74888\";i:74126;s:12:\"delete-74884\";i:74127;s:12:\"delete-74885\";i:74128;s:12:\"delete-74887\";i:74129;s:12:\"delete-74889\";i:74130;s:12:\"delete-74892\";i:74131;s:12:\"delete-74890\";i:74132;s:12:\"delete-74891\";i:74133;s:12:\"delete-74893\";i:74134;s:12:\"delete-74894\";i:74135;s:12:\"delete-74895\";i:74136;s:12:\"delete-74898\";i:74137;s:12:\"delete-74896\";i:74138;s:12:\"delete-74897\";i:74139;s:12:\"delete-74899\";i:74140;s:12:\"delete-74900\";i:74141;s:12:\"delete-74901\";i:74142;s:12:\"delete-74904\";i:74143;s:12:\"delete-74902\";i:74144;s:12:\"delete-74903\";i:74145;s:12:\"delete-74905\";i:74146;s:12:\"delete-74906\";i:74147;s:12:\"delete-74907\";i:74148;s:12:\"delete-74910\";i:74149;s:12:\"delete-74912\";i:74150;s:12:\"delete-74908\";i:74151;s:12:\"delete-74909\";i:74152;s:12:\"delete-74911\";i:74153;s:12:\"delete-74913\";i:74154;s:12:\"delete-74914\";i:74155;s:12:\"delete-74915\";i:74156;s:12:\"delete-74917\";i:74157;s:12:\"delete-74916\";i:74158;s:12:\"delete-74918\";i:74159;s:12:\"delete-74919\";i:74160;s:12:\"delete-74922\";i:74161;s:12:\"delete-74924\";i:74162;s:12:\"delete-74920\";i:74163;s:12:\"delete-74921\";i:74164;s:12:\"delete-74923\";i:74165;s:12:\"delete-74925\";i:74166;s:12:\"delete-74928\";i:74167;s:12:\"delete-74926\";i:74168;s:12:\"delete-74927\";i:74169;s:12:\"delete-74929\";i:74170;s:12:\"delete-74930\";i:74171;s:12:\"delete-74931\";i:74172;s:12:\"delete-74934\";i:74173;s:12:\"delete-74932\";i:74174;s:12:\"delete-74933\";i:74175;s:12:\"delete-74935\";i:74176;s:12:\"delete-74936\";i:74177;s:12:\"delete-74937\";i:74178;s:12:\"delete-74940\";i:74179;s:12:\"delete-74942\";i:74180;s:12:\"delete-74938\";i:74181;s:12:\"delete-74939\";i:74182;s:12:\"delete-74941\";i:74183;s:12:\"delete-74943\";i:74184;s:12:\"delete-74946\";i:74185;s:12:\"delete-74948\";i:74186;s:12:\"delete-74944\";i:74187;s:12:\"delete-74945\";i:74188;s:12:\"delete-74947\";i:74189;s:12:\"delete-74949\";i:74190;s:12:\"delete-74952\";i:74191;s:12:\"delete-74950\";i:74192;s:12:\"delete-74951\";i:74193;s:12:\"delete-74953\";i:74194;s:12:\"delete-74954\";i:74195;s:12:\"delete-74955\";i:74196;s:12:\"delete-74958\";i:74197;s:12:\"delete-74956\";i:74198;s:12:\"delete-74957\";i:74199;s:12:\"delete-74959\";i:74200;s:12:\"delete-74960\";i:74201;s:12:\"delete-74961\";i:74202;s:12:\"delete-74964\";i:74203;s:12:\"delete-74966\";i:74204;s:12:\"delete-74962\";i:74205;s:12:\"delete-74963\";i:74206;s:12:\"delete-74965\";i:74207;s:12:\"delete-74967\";i:74208;s:12:\"delete-74970\";i:74209;s:12:\"delete-74972\";i:74210;s:12:\"delete-74968\";i:74211;s:12:\"delete-74969\";i:74212;s:12:\"delete-74971\";i:74213;s:12:\"delete-74974\";i:74214;s:12:\"delete-74975\";i:74215;s:12:\"delete-74973\";i:74216;s:12:\"delete-74976\";i:74217;s:12:\"delete-74978\";i:74218;s:12:\"delete-74979\";i:74219;s:12:\"delete-74977\";i:74220;s:12:\"delete-74980\";i:74221;s:12:\"delete-74981\";i:74222;s:12:\"delete-74983\";i:74223;s:12:\"delete-74982\";i:74224;s:12:\"delete-74984\";i:74225;s:12:\"delete-74985\";i:74226;s:12:\"delete-74988\";i:74227;s:12:\"delete-74986\";i:74228;s:12:\"delete-74987\";i:74229;s:12:\"delete-74989\";i:74230;s:12:\"delete-74990\";i:74231;s:12:\"delete-74991\";i:74232;s:12:\"delete-74994\";i:74233;s:12:\"delete-74992\";i:74234;s:12:\"delete-74993\";i:74235;s:12:\"delete-74995\";i:74236;s:12:\"delete-74996\";i:74237;s:12:\"delete-74997\";i:74238;s:12:\"delete-75000\";i:74239;s:12:\"delete-74998\";i:74240;s:12:\"delete-74999\";i:74241;s:12:\"delete-75001\";i:74242;s:12:\"delete-75002\";i:74243;s:12:\"delete-75003\";i:74244;s:12:\"delete-75006\";i:74245;s:12:\"delete-75008\";i:74246;s:12:\"delete-75004\";i:74247;s:12:\"delete-75005\";i:74248;s:12:\"delete-75007\";i:74249;s:12:\"delete-75009\";i:74250;s:12:\"delete-75012\";i:74251;s:12:\"delete-75010\";i:74252;s:12:\"delete-75011\";i:74253;s:12:\"delete-75013\";i:74254;s:12:\"delete-75014\";i:74255;s:12:\"delete-75015\";i:74256;s:12:\"delete-75018\";i:74257;s:12:\"delete-75020\";i:74258;s:12:\"delete-75016\";i:74259;s:12:\"delete-75017\";i:74260;s:12:\"delete-75019\";i:74261;s:12:\"delete-75021\";i:74262;s:12:\"delete-75024\";i:74263;s:12:\"delete-75026\";i:74264;s:12:\"delete-75022\";i:74265;s:12:\"delete-75023\";i:74266;s:12:\"delete-75025\";i:74267;s:12:\"delete-75027\";i:74268;s:12:\"delete-75030\";i:74269;s:12:\"delete-75032\";i:74270;s:12:\"delete-75028\";i:74271;s:12:\"delete-75029\";i:74272;s:12:\"delete-75031\";i:74273;s:12:\"delete-75033\";i:74274;s:12:\"delete-75036\";i:74275;s:12:\"delete-75034\";i:74276;s:12:\"delete-75035\";i:74277;s:12:\"delete-75037\";i:74278;s:12:\"delete-75038\";i:74279;s:12:\"delete-75039\";i:74280;s:12:\"delete-75042\";i:74281;s:12:\"delete-75040\";i:74282;s:12:\"delete-75041\";i:74283;s:12:\"delete-75043\";i:74284;s:12:\"delete-75044\";i:74285;s:12:\"delete-75045\";i:74286;s:12:\"delete-75048\";i:74287;s:12:\"delete-75046\";i:74288;s:12:\"delete-75047\";i:74289;s:12:\"delete-75049\";i:74290;s:12:\"delete-75050\";i:74291;s:12:\"delete-75051\";i:74292;s:12:\"delete-75054\";i:74293;s:12:\"delete-75052\";i:74294;s:12:\"delete-75053\";i:74295;s:12:\"delete-75055\";i:74296;s:12:\"delete-75056\";i:74297;s:12:\"delete-75057\";i:74298;s:12:\"delete-75060\";i:74299;s:12:\"delete-75062\";i:74300;s:12:\"delete-75058\";i:74301;s:12:\"delete-75059\";i:74302;s:12:\"delete-75061\";i:74303;s:12:\"delete-75063\";i:74304;s:12:\"delete-75066\";i:74305;s:12:\"delete-75064\";i:74306;s:12:\"delete-75065\";i:74307;s:12:\"delete-75067\";i:74308;s:12:\"delete-75068\";i:74309;s:12:\"delete-75069\";i:74310;s:12:\"delete-75072\";i:74311;s:12:\"delete-75074\";i:74312;s:12:\"delete-75070\";i:74313;s:12:\"delete-75071\";i:74314;s:12:\"delete-75073\";i:74315;s:12:\"delete-75075\";i:74316;s:12:\"delete-75078\";i:74317;s:12:\"delete-75080\";i:74318;s:12:\"delete-75076\";i:74319;s:12:\"delete-75077\";i:74320;s:12:\"delete-75079\";i:74321;s:12:\"delete-75081\";i:74322;s:12:\"delete-75084\";i:74323;s:12:\"delete-75086\";i:74324;s:12:\"delete-75082\";i:74325;s:12:\"delete-75083\";i:74326;s:12:\"delete-75085\";i:74327;s:12:\"delete-75087\";i:74328;s:12:\"delete-75088\";i:74329;s:12:\"delete-75089\";i:74330;s:12:\"delete-75090\";i:74331;s:12:\"delete-75092\";i:74332;s:12:\"delete-75093\";i:74333;s:12:\"delete-75096\";i:74334;s:12:\"delete-75098\";i:74335;s:12:\"delete-75091\";i:74336;s:12:\"delete-75094\";i:74337;s:12:\"delete-75095\";i:74338;s:12:\"delete-75097\";i:74339;s:12:\"delete-75099\";i:74340;s:12:\"delete-75102\";i:74341;s:12:\"delete-75100\";i:74342;s:12:\"delete-75101\";i:74343;s:12:\"delete-75103\";i:74344;s:12:\"delete-75104\";i:74345;s:12:\"delete-75105\";i:74346;s:12:\"delete-75108\";i:74347;s:12:\"delete-75110\";i:74348;s:12:\"delete-75106\";i:74349;s:12:\"delete-75107\";i:74350;s:12:\"delete-75109\";i:74351;s:12:\"delete-75111\";i:74352;s:12:\"delete-75114\";i:74353;s:12:\"delete-75112\";i:74354;s:12:\"delete-75113\";i:74355;s:12:\"delete-75115\";i:74356;s:12:\"delete-75116\";i:74357;s:12:\"delete-75117\";i:74358;s:12:\"delete-75120\";i:74359;s:12:\"delete-75122\";i:74360;s:12:\"delete-75118\";i:74361;s:12:\"delete-75119\";i:74362;s:12:\"delete-75121\";i:74363;s:12:\"delete-75123\";i:74364;s:12:\"delete-75126\";i:74365;s:12:\"delete-75124\";i:74366;s:12:\"delete-75125\";i:74367;s:12:\"delete-75127\";i:74368;s:12:\"delete-75128\";i:74369;s:12:\"delete-75129\";i:74370;s:12:\"delete-75132\";i:74371;s:12:\"delete-75130\";i:74372;s:12:\"delete-75131\";i:74373;s:12:\"delete-75133\";i:74374;s:12:\"delete-75134\";i:74375;s:12:\"delete-75135\";i:74376;s:12:\"delete-75138\";i:74377;s:12:\"delete-75136\";i:74378;s:12:\"delete-75137\";i:74379;s:12:\"delete-75139\";i:74380;s:12:\"delete-75140\";i:74381;s:12:\"delete-75141\";i:74382;s:12:\"delete-75144\";i:74383;s:12:\"delete-75146\";i:74384;s:12:\"delete-75142\";i:74385;s:12:\"delete-75143\";i:74386;s:12:\"delete-75145\";i:74387;s:12:\"delete-75147\";i:74388;s:12:\"delete-75150\";i:74389;s:12:\"delete-75152\";i:74390;s:12:\"delete-75148\";i:74391;s:12:\"delete-75149\";i:74392;s:12:\"delete-75151\";i:74393;s:12:\"delete-75153\";i:74394;s:12:\"delete-75156\";i:74395;s:12:\"delete-75158\";i:74396;s:12:\"delete-75154\";i:74397;s:12:\"delete-75155\";i:74398;s:12:\"delete-75157\";i:74399;s:12:\"delete-75159\";i:74400;s:12:\"delete-75162\";i:74401;s:12:\"delete-75160\";i:74402;s:12:\"delete-75161\";i:74403;s:12:\"delete-75163\";i:74404;s:12:\"delete-75164\";i:74405;s:12:\"delete-75165\";i:74406;s:12:\"delete-75168\";i:74407;s:12:\"delete-75166\";i:74408;s:12:\"delete-75167\";i:74409;s:12:\"delete-75169\";i:74410;s:12:\"delete-75170\";i:74411;s:12:\"delete-75171\";i:74412;s:12:\"delete-75174\";i:74413;s:12:\"delete-75172\";i:74414;s:12:\"delete-75173\";i:74415;s:12:\"delete-75175\";i:74416;s:12:\"delete-75176\";i:74417;s:12:\"delete-75177\";i:74418;s:12:\"delete-75180\";i:74419;s:12:\"delete-75178\";i:74420;s:12:\"delete-75179\";i:74421;s:12:\"delete-75181\";i:74422;s:12:\"delete-75182\";i:74423;s:12:\"delete-75183\";i:74424;s:12:\"delete-75186\";i:74425;s:12:\"delete-75188\";i:74426;s:12:\"delete-75184\";i:74427;s:12:\"delete-75185\";i:74428;s:12:\"delete-75187\";i:74429;s:12:\"delete-75189\";i:74430;s:12:\"delete-75192\";i:74431;s:12:\"delete-75190\";i:74432;s:12:\"delete-75191\";i:74433;s:12:\"delete-75193\";i:74434;s:12:\"delete-75194\";i:74435;s:12:\"delete-75195\";i:74436;s:12:\"delete-75198\";i:74437;s:12:\"delete-75196\";i:74438;s:12:\"delete-75197\";i:74439;s:12:\"delete-75199\";i:74440;s:12:\"delete-75200\";i:74441;s:12:\"delete-75201\";i:74442;s:12:\"delete-75204\";i:74443;s:12:\"delete-75206\";i:74444;s:12:\"delete-75202\";i:74445;s:12:\"delete-75203\";i:74446;s:12:\"delete-75205\";i:74447;s:12:\"delete-75207\";i:74448;s:12:\"delete-75210\";i:74449;s:12:\"delete-75212\";i:74450;s:12:\"delete-75208\";i:74451;s:12:\"delete-75209\";i:74452;s:12:\"delete-75211\";i:74453;s:12:\"delete-75213\";i:74454;s:12:\"delete-75214\";i:74455;s:12:\"delete-75215\";i:74456;s:12:\"delete-75217\";i:74457;s:12:\"delete-75216\";i:74458;s:12:\"delete-75218\";i:74459;s:12:\"delete-75219\";i:74460;s:12:\"delete-75222\";i:74461;s:12:\"delete-75220\";i:74462;s:12:\"delete-75221\";i:74463;s:12:\"delete-75223\";i:74464;s:12:\"delete-75224\";i:74465;s:12:\"delete-75225\";i:74466;s:12:\"delete-75228\";i:74467;s:12:\"delete-75230\";i:74468;s:12:\"delete-75226\";i:74469;s:12:\"delete-75227\";i:74470;s:12:\"delete-75229\";i:74471;s:12:\"delete-75231\";i:74472;s:12:\"delete-75234\";i:74473;s:12:\"delete-75232\";i:74474;s:12:\"delete-75233\";i:74475;s:12:\"delete-75235\";i:74476;s:12:\"delete-75236\";i:74477;s:12:\"delete-75237\";i:74478;s:12:\"delete-75240\";i:74479;s:12:\"delete-75242\";i:74480;s:12:\"delete-75238\";i:74481;s:12:\"delete-75239\";i:74482;s:12:\"delete-75241\";i:74483;s:12:\"delete-75243\";i:74484;s:12:\"delete-75244\";i:74485;s:12:\"delete-75245\";i:74486;s:12:\"delete-75246\";i:74487;s:12:\"delete-75248\";i:74488;s:12:\"delete-75249\";i:74489;s:12:\"delete-75252\";i:74490;s:12:\"delete-75247\";i:74491;s:12:\"delete-75250\";i:74492;s:12:\"delete-75251\";i:74493;s:12:\"delete-75253\";i:74494;s:12:\"delete-75254\";i:74495;s:12:\"delete-75255\";i:74496;s:12:\"delete-75258\";i:74497;s:12:\"delete-75260\";i:74498;s:12:\"delete-75256\";i:74499;s:12:\"delete-75257\";i:74500;s:12:\"delete-75259\";i:74501;s:12:\"delete-75261\";i:74502;s:12:\"delete-75264\";i:74503;s:12:\"delete-75262\";i:74504;s:12:\"delete-75263\";i:74505;s:12:\"delete-75265\";i:74506;s:12:\"delete-75266\";i:74507;s:12:\"delete-75267\";i:74508;s:12:\"delete-75270\";i:74509;s:12:\"delete-75272\";i:74510;s:12:\"delete-75268\";i:74511;s:12:\"delete-75269\";i:74512;s:12:\"delete-75271\";i:74513;s:12:\"delete-75273\";i:74514;s:12:\"delete-75276\";i:74515;s:12:\"delete-75278\";i:74516;s:12:\"delete-75274\";i:74517;s:12:\"delete-75275\";i:74518;s:12:\"delete-75277\";i:74519;s:12:\"delete-75279\";i:74520;s:12:\"delete-75282\";i:74521;s:12:\"delete-75280\";i:74522;s:12:\"delete-75281\";i:74523;s:12:\"delete-75283\";i:74524;s:12:\"delete-75284\";i:74525;s:12:\"delete-75285\";i:74526;s:12:\"delete-75288\";i:74527;s:12:\"delete-75286\";i:74528;s:12:\"delete-75287\";i:74529;s:12:\"delete-75289\";i:74530;s:12:\"delete-75290\";i:74531;s:12:\"delete-75291\";i:74532;s:12:\"delete-75294\";i:74533;s:12:\"delete-75296\";i:74534;s:12:\"delete-75292\";i:74535;s:12:\"delete-75293\";i:74536;s:12:\"delete-75295\";i:74537;s:12:\"delete-75297\";i:74538;s:12:\"delete-75300\";i:74539;s:12:\"delete-75302\";i:74540;s:12:\"delete-75298\";i:74541;s:12:\"delete-75299\";i:74542;s:12:\"delete-75301\";i:74543;s:12:\"delete-75303\";i:74544;s:12:\"delete-75306\";i:74545;s:12:\"delete-75304\";i:74546;s:12:\"delete-75305\";i:74547;s:12:\"delete-75307\";i:74548;s:12:\"delete-75308\";i:74549;s:12:\"delete-75309\";i:74550;s:12:\"delete-75312\";i:74551;s:12:\"delete-75310\";i:74552;s:12:\"delete-75311\";i:74553;s:12:\"delete-75313\";i:74554;s:12:\"delete-75314\";i:74555;s:12:\"delete-75315\";i:74556;s:12:\"delete-75318\";i:74557;s:12:\"delete-75320\";i:74558;s:12:\"delete-75316\";i:74559;s:12:\"delete-75317\";i:74560;s:12:\"delete-75319\";i:74561;s:12:\"delete-75321\";i:74562;s:12:\"delete-75324\";i:74563;s:12:\"delete-75326\";i:74564;s:12:\"delete-75322\";i:74565;s:12:\"delete-75323\";i:74566;s:12:\"delete-75325\";i:74567;s:12:\"delete-75327\";i:74568;s:12:\"delete-75330\";i:74569;s:12:\"delete-75332\";i:74570;s:12:\"delete-75328\";i:74571;s:12:\"delete-75329\";i:74572;s:12:\"delete-75331\";i:74573;s:12:\"delete-75333\";i:74574;s:12:\"delete-75336\";i:74575;s:12:\"delete-75338\";i:74576;s:12:\"delete-75334\";i:74577;s:12:\"delete-75335\";i:74578;s:12:\"delete-75337\";i:74579;s:12:\"delete-75339\";i:74580;s:12:\"delete-75342\";i:74581;s:12:\"delete-75344\";i:74582;s:12:\"delete-75340\";i:74583;s:12:\"delete-75341\";i:74584;s:12:\"delete-75343\";i:74585;s:12:\"delete-75345\";i:74586;s:12:\"delete-75348\";i:74587;s:12:\"delete-75346\";i:74588;s:12:\"delete-75347\";i:74589;s:12:\"delete-75349\";i:74590;s:12:\"delete-75350\";i:74591;s:12:\"delete-75351\";i:74592;s:12:\"delete-75354\";i:74593;s:12:\"delete-75352\";i:74594;s:12:\"delete-75353\";i:74595;s:12:\"delete-75355\";i:74596;s:12:\"delete-75356\";i:74597;s:12:\"delete-75357\";i:74598;s:12:\"delete-75360\";i:74599;s:12:\"delete-75362\";i:74600;s:12:\"delete-75358\";i:74601;s:12:\"delete-75359\";i:74602;s:12:\"delete-75361\";i:74603;s:12:\"delete-75363\";i:74604;s:12:\"delete-75366\";i:74605;s:12:\"delete-75368\";i:74606;s:12:\"delete-75364\";i:74607;s:12:\"delete-75365\";i:74608;s:12:\"delete-75367\";i:74609;s:12:\"delete-75369\";i:74610;s:12:\"delete-75372\";i:74611;s:12:\"delete-75370\";i:74612;s:12:\"delete-75371\";i:74613;s:12:\"delete-75373\";i:74614;s:12:\"delete-75374\";i:74615;s:12:\"delete-75375\";i:74616;s:12:\"delete-75378\";i:74617;s:12:\"delete-75380\";i:74618;s:12:\"delete-75376\";i:74619;s:12:\"delete-75377\";i:74620;s:12:\"delete-75379\";i:74621;s:12:\"delete-75381\";i:74622;s:12:\"delete-75384\";i:74623;s:12:\"delete-75386\";i:74624;s:12:\"delete-75382\";i:74625;s:12:\"delete-75383\";i:74626;s:12:\"delete-75385\";i:74627;s:12:\"delete-75387\";i:74628;s:12:\"delete-75390\";i:74629;s:12:\"delete-75392\";i:74630;s:12:\"delete-75388\";i:74631;s:12:\"delete-75389\";i:74632;s:12:\"delete-75391\";i:74633;s:12:\"delete-75393\";i:74634;s:12:\"delete-75396\";i:74635;s:12:\"delete-75398\";i:74636;s:12:\"delete-75394\";i:74637;s:12:\"delete-75395\";i:74638;s:12:\"delete-75397\";i:74639;s:12:\"delete-75399\";i:74640;s:12:\"delete-75402\";i:74641;s:12:\"delete-75404\";i:74642;s:12:\"delete-75400\";i:74643;s:12:\"delete-75401\";i:74644;s:12:\"delete-75403\";i:74645;s:12:\"delete-75405\";i:74646;s:12:\"delete-75408\";i:74647;s:12:\"delete-75410\";i:74648;s:12:\"delete-75406\";i:74649;s:12:\"delete-75407\";i:74650;s:12:\"delete-75409\";i:74651;s:12:\"delete-75411\";i:74652;s:12:\"delete-75414\";i:74653;s:12:\"delete-75412\";i:74654;s:12:\"delete-75413\";i:74655;s:12:\"delete-75415\";i:74656;s:12:\"delete-75416\";i:74657;s:12:\"delete-75417\";i:74658;s:12:\"delete-75420\";i:74659;s:12:\"delete-75422\";i:74660;s:12:\"delete-75418\";i:74661;s:12:\"delete-75419\";i:74662;s:12:\"delete-75421\";i:74663;s:12:\"delete-75423\";i:74664;s:12:\"delete-75426\";i:74665;s:12:\"delete-75428\";i:74666;s:12:\"delete-75424\";i:74667;s:12:\"delete-75425\";i:74668;s:12:\"delete-75427\";i:74669;s:12:\"delete-75429\";i:74670;s:12:\"delete-75432\";i:74671;s:12:\"delete-75430\";i:74672;s:12:\"delete-75431\";i:74673;s:12:\"delete-75433\";i:74674;s:12:\"delete-75434\";i:74675;s:12:\"delete-75435\";i:74676;s:12:\"delete-75438\";i:74677;s:12:\"delete-75440\";i:74678;s:12:\"delete-75436\";i:74679;s:12:\"delete-75437\";i:74680;s:12:\"delete-75439\";i:74681;s:12:\"delete-75441\";i:74682;s:12:\"delete-75444\";i:74683;s:12:\"delete-75446\";i:74684;s:12:\"delete-75442\";i:74685;s:12:\"delete-75443\";i:74686;s:12:\"delete-75445\";i:74687;s:12:\"delete-75447\";i:74688;s:12:\"delete-75450\";i:74689;s:12:\"delete-75452\";i:74690;s:12:\"delete-75448\";i:74691;s:12:\"delete-75449\";i:74692;s:12:\"delete-75451\";i:74693;s:12:\"delete-75453\";i:74694;s:12:\"delete-75456\";i:74695;s:12:\"delete-75454\";i:74696;s:12:\"delete-75455\";i:74697;s:12:\"delete-75457\";i:74698;s:12:\"delete-75458\";i:74699;s:12:\"delete-75459\";i:74700;s:12:\"delete-75462\";i:74701;s:12:\"delete-75464\";i:74702;s:12:\"delete-75460\";i:74703;s:12:\"delete-75461\";i:74704;s:12:\"delete-75463\";i:74705;s:12:\"delete-75465\";i:74706;s:12:\"delete-75468\";i:74707;s:12:\"delete-75466\";i:74708;s:12:\"delete-75467\";i:74709;s:12:\"delete-75469\";i:74710;s:12:\"delete-75470\";i:74711;s:12:\"delete-75471\";i:74712;s:12:\"delete-75474\";i:74713;s:12:\"delete-75472\";i:74714;s:12:\"delete-75473\";i:74715;s:12:\"delete-75475\";i:74716;s:12:\"delete-75476\";i:74717;s:12:\"delete-75477\";i:74718;s:12:\"delete-75480\";i:74719;s:12:\"delete-75482\";i:74720;s:12:\"delete-75478\";i:74721;s:12:\"delete-75479\";i:74722;s:12:\"delete-75481\";i:74723;s:12:\"delete-75483\";i:74724;s:12:\"delete-75486\";i:74725;s:12:\"delete-75488\";i:74726;s:12:\"delete-75484\";i:74727;s:12:\"delete-75485\";i:74728;s:12:\"delete-75487\";i:74729;s:12:\"delete-75489\";i:74730;s:12:\"delete-75492\";i:74731;s:12:\"delete-75490\";i:74732;s:12:\"delete-75491\";i:74733;s:12:\"delete-75493\";i:74734;s:12:\"delete-75494\";i:74735;s:12:\"delete-75495\";i:74736;s:12:\"delete-75498\";i:74737;s:12:\"delete-75496\";i:74738;s:12:\"delete-75497\";i:74739;s:12:\"delete-75499\";i:74740;s:12:\"delete-75500\";i:74741;s:12:\"delete-75501\";i:74742;s:12:\"delete-75504\";i:74743;s:12:\"delete-75506\";i:74744;s:12:\"delete-75502\";i:74745;s:12:\"delete-75503\";i:74746;s:12:\"delete-75505\";i:74747;s:12:\"delete-75507\";i:74748;s:12:\"delete-75510\";i:74749;s:12:\"delete-75512\";i:74750;s:12:\"delete-75508\";i:74751;s:12:\"delete-75509\";i:74752;s:12:\"delete-75511\";i:74753;s:12:\"delete-75513\";i:74754;s:12:\"delete-75516\";i:74755;s:12:\"delete-75518\";i:74756;s:12:\"delete-75514\";i:74757;s:12:\"delete-75515\";i:74758;s:12:\"delete-75517\";i:74759;s:12:\"delete-75519\";i:74760;s:12:\"delete-75522\";i:74761;s:12:\"delete-75524\";i:74762;s:12:\"delete-75520\";i:74763;s:12:\"delete-75521\";i:74764;s:12:\"delete-75523\";i:74765;s:12:\"delete-75525\";i:74766;s:12:\"delete-75528\";i:74767;s:12:\"delete-75530\";i:74768;s:12:\"delete-75526\";i:74769;s:12:\"delete-75527\";i:74770;s:12:\"delete-75529\";i:74771;s:12:\"delete-75531\";i:74772;s:12:\"delete-75534\";i:74773;s:12:\"delete-75532\";i:74774;s:12:\"delete-75533\";i:74775;s:12:\"delete-75535\";i:74776;s:12:\"delete-75536\";i:74777;s:12:\"delete-75537\";i:74778;s:12:\"delete-75540\";i:74779;s:12:\"delete-75538\";i:74780;s:12:\"delete-75539\";i:74781;s:12:\"delete-75541\";i:74782;s:12:\"delete-75542\";i:74783;s:12:\"delete-75543\";i:74784;s:12:\"delete-75546\";i:74785;s:12:\"delete-75544\";i:74786;s:12:\"delete-75545\";i:74787;s:12:\"delete-75547\";i:74788;s:12:\"delete-75548\";i:74789;s:12:\"delete-75549\";i:74790;s:12:\"delete-75552\";i:74791;s:12:\"delete-75550\";i:74792;s:12:\"delete-75551\";i:74793;s:12:\"delete-75553\";i:74794;s:12:\"delete-75554\";i:74795;s:12:\"delete-75555\";i:74796;s:12:\"delete-75558\";i:74797;s:12:\"delete-75560\";i:74798;s:12:\"delete-75556\";i:74799;s:12:\"delete-75557\";i:74800;s:12:\"delete-75559\";i:74801;s:12:\"delete-75561\";i:74802;s:12:\"delete-75564\";i:74803;s:12:\"delete-75566\";i:74804;s:12:\"delete-75562\";i:74805;s:12:\"delete-75563\";i:74806;s:12:\"delete-75565\";i:74807;s:12:\"delete-75567\";i:74808;s:12:\"delete-75570\";i:74809;s:12:\"delete-75572\";i:74810;s:12:\"delete-75568\";i:74811;s:12:\"delete-75569\";i:74812;s:12:\"delete-75571\";i:74813;s:12:\"delete-75573\";i:74814;s:12:\"delete-75576\";i:74815;s:12:\"delete-75578\";i:74816;s:12:\"delete-75574\";i:74817;s:12:\"delete-75575\";i:74818;s:12:\"delete-75577\";i:74819;s:12:\"delete-75579\";i:74820;s:12:\"delete-75582\";i:74821;s:12:\"delete-75584\";i:74822;s:12:\"delete-75580\";i:74823;s:12:\"delete-75581\";i:74824;s:12:\"delete-75583\";i:74825;s:12:\"delete-75585\";i:74826;s:12:\"delete-75588\";i:74827;s:12:\"delete-75590\";i:74828;s:12:\"delete-75586\";i:74829;s:12:\"delete-75587\";i:74830;s:12:\"delete-75589\";i:74831;s:12:\"delete-75591\";i:74832;s:12:\"delete-75594\";i:74833;s:12:\"delete-75592\";i:74834;s:12:\"delete-75593\";i:74835;s:12:\"delete-75595\";i:74836;s:12:\"delete-75596\";i:74837;s:12:\"delete-75597\";i:74838;s:12:\"delete-75600\";i:74839;s:12:\"delete-75602\";i:74840;s:12:\"delete-75598\";i:74841;s:12:\"delete-75599\";i:74842;s:12:\"delete-75601\";i:74843;s:12:\"delete-75603\";i:74844;s:12:\"delete-75606\";i:74845;s:12:\"delete-75608\";i:74846;s:12:\"delete-75604\";i:74847;s:12:\"delete-75605\";i:74848;s:12:\"delete-75607\";i:74849;s:12:\"delete-75609\";i:74850;s:12:\"delete-75612\";i:74851;s:12:\"delete-75610\";i:74852;s:12:\"delete-75611\";i:74853;s:12:\"delete-75613\";i:74854;s:12:\"delete-75614\";i:74855;s:12:\"delete-75615\";i:74856;s:12:\"delete-75618\";i:74857;s:12:\"delete-75616\";i:74858;s:12:\"delete-75617\";i:74859;s:12:\"delete-75619\";i:74860;s:12:\"delete-75620\";i:74861;s:12:\"delete-75621\";i:74862;s:12:\"delete-75624\";i:74863;s:12:\"delete-75626\";i:74864;s:12:\"delete-75622\";i:74865;s:12:\"delete-75623\";i:74866;s:12:\"delete-75625\";i:74867;s:12:\"delete-75627\";i:74868;s:12:\"delete-75630\";i:74869;s:12:\"delete-75628\";i:74870;s:12:\"delete-75629\";i:74871;s:12:\"delete-75631\";i:74872;s:12:\"delete-75632\";i:74873;s:12:\"delete-75633\";i:74874;s:12:\"delete-75636\";i:74875;s:12:\"delete-75634\";i:74876;s:12:\"delete-75635\";i:74877;s:12:\"delete-75637\";i:74878;s:12:\"delete-75638\";i:74879;s:12:\"delete-75639\";i:74880;s:12:\"delete-75642\";i:74881;s:12:\"delete-75644\";i:74882;s:12:\"delete-75640\";i:74883;s:12:\"delete-75641\";i:74884;s:12:\"delete-75643\";i:74885;s:12:\"delete-75645\";i:74886;s:12:\"delete-75648\";i:74887;s:12:\"delete-75646\";i:74888;s:12:\"delete-75647\";i:74889;s:12:\"delete-75649\";i:74890;s:12:\"delete-75650\";i:74891;s:12:\"delete-75651\";i:74892;s:12:\"delete-75654\";i:74893;s:12:\"delete-75656\";i:74894;s:12:\"delete-75652\";i:74895;s:12:\"delete-75653\";i:74896;s:12:\"delete-75655\";i:74897;s:12:\"delete-75657\";i:74898;s:12:\"delete-75660\";i:74899;s:12:\"delete-75658\";i:74900;s:12:\"delete-75659\";i:74901;s:12:\"delete-75661\";i:74902;s:12:\"delete-75662\";i:74903;s:12:\"delete-75663\";i:74904;s:12:\"delete-75666\";i:74905;s:12:\"delete-75664\";i:74906;s:12:\"delete-75665\";i:74907;s:12:\"delete-75667\";i:74908;s:12:\"delete-75668\";i:74909;s:12:\"delete-75669\";i:74910;s:12:\"delete-75670\";i:74911;s:12:\"delete-75671\";i:74912;s:12:\"delete-75673\";i:74913;s:12:\"delete-75672\";i:74914;s:12:\"delete-75674\";i:74915;s:12:\"delete-75675\";i:74916;s:12:\"delete-75678\";i:74917;s:12:\"delete-75676\";i:74918;s:12:\"delete-75677\";i:74919;s:12:\"delete-75679\";i:74920;s:12:\"delete-75680\";i:74921;s:12:\"delete-75681\";i:74922;s:12:\"delete-75684\";i:74923;s:12:\"delete-75686\";i:74924;s:12:\"delete-75682\";i:74925;s:12:\"delete-75683\";i:74926;s:12:\"delete-75685\";i:74927;s:12:\"delete-75687\";i:74928;s:12:\"delete-75690\";i:74929;s:12:\"delete-75692\";i:74930;s:12:\"delete-75688\";i:74931;s:12:\"delete-75689\";i:74932;s:12:\"delete-75691\";i:74933;s:12:\"delete-75693\";i:74934;s:12:\"delete-75696\";i:74935;s:12:\"delete-75698\";i:74936;s:12:\"delete-75694\";i:74937;s:12:\"delete-75695\";i:74938;s:12:\"delete-75697\";i:74939;s:12:\"delete-75699\";i:74940;s:12:\"delete-75702\";i:74941;s:12:\"delete-75704\";i:74942;s:12:\"delete-75700\";i:74943;s:12:\"delete-75701\";i:74944;s:12:\"delete-75703\";i:74945;s:12:\"delete-75705\";i:74946;s:12:\"delete-75708\";i:74947;s:12:\"delete-75706\";i:74948;s:12:\"delete-75707\";i:74949;s:12:\"delete-75709\";i:74950;s:12:\"delete-75710\";i:74951;s:12:\"delete-75711\";i:74952;s:12:\"delete-75714\";i:74953;s:12:\"delete-75716\";i:74954;s:12:\"delete-75712\";i:74955;s:12:\"delete-75713\";i:74956;s:12:\"delete-75715\";i:74957;s:12:\"delete-75717\";i:74958;s:12:\"delete-75720\";i:74959;s:12:\"delete-75722\";i:74960;s:12:\"delete-75718\";i:74961;s:12:\"delete-75719\";i:74962;s:12:\"delete-75721\";i:74963;s:12:\"delete-75723\";i:74964;s:12:\"delete-75726\";i:74965;s:12:\"delete-75728\";i:74966;s:12:\"delete-75724\";i:74967;s:12:\"delete-75725\";i:74968;s:12:\"delete-75727\";i:74969;s:12:\"delete-75729\";i:74970;s:12:\"delete-75732\";i:74971;s:12:\"delete-75734\";i:74972;s:12:\"delete-75730\";i:74973;s:12:\"delete-75731\";i:74974;s:12:\"delete-75733\";i:74975;s:12:\"delete-75735\";i:74976;s:12:\"delete-75738\";i:74977;s:12:\"delete-75740\";i:74978;s:12:\"delete-75736\";i:74979;s:12:\"delete-75737\";i:74980;s:12:\"delete-75739\";i:74981;s:12:\"delete-75741\";i:74982;s:12:\"delete-75744\";i:74983;s:12:\"delete-75742\";i:74984;s:12:\"delete-75743\";i:74985;s:12:\"delete-75745\";i:74986;s:12:\"delete-75746\";i:74987;s:12:\"delete-75747\";i:74988;s:12:\"delete-75750\";i:74989;s:12:\"delete-75752\";i:74990;s:12:\"delete-75748\";i:74991;s:12:\"delete-75749\";i:74992;s:12:\"delete-75751\";i:74993;s:12:\"delete-75753\";i:74994;s:12:\"delete-75756\";i:74995;s:12:\"delete-75758\";i:74996;s:12:\"delete-75754\";i:74997;s:12:\"delete-75755\";i:74998;s:12:\"delete-75757\";i:74999;s:12:\"delete-75759\";i:75000;s:12:\"delete-75762\";i:75001;s:12:\"delete-75764\";i:75002;s:12:\"delete-75760\";i:75003;s:12:\"delete-75761\";i:75004;s:12:\"delete-75763\";i:75005;s:12:\"delete-75765\";i:75006;s:12:\"delete-75768\";i:75007;s:12:\"delete-75766\";i:75008;s:12:\"delete-75767\";i:75009;s:12:\"delete-75769\";i:75010;s:12:\"delete-75770\";i:75011;s:12:\"delete-75771\";i:75012;s:12:\"delete-75774\";i:75013;s:12:\"delete-75772\";i:75014;s:12:\"delete-75773\";i:75015;s:12:\"delete-75775\";i:75016;s:12:\"delete-75776\";i:75017;s:12:\"delete-75777\";i:75018;s:12:\"delete-75780\";i:75019;s:12:\"delete-75778\";i:75020;s:12:\"delete-75779\";i:75021;s:12:\"delete-75781\";i:75022;s:12:\"delete-75782\";i:75023;s:12:\"delete-75783\";i:75024;s:12:\"delete-75786\";i:75025;s:12:\"delete-75788\";i:75026;s:12:\"delete-75784\";i:75027;s:12:\"delete-75785\";i:75028;s:12:\"delete-75787\";i:75029;s:12:\"delete-75789\";i:75030;s:12:\"delete-75792\";i:75031;s:12:\"delete-75794\";i:75032;s:12:\"delete-75790\";i:75033;s:12:\"delete-75791\";i:75034;s:12:\"delete-75793\";i:75035;s:12:\"delete-75795\";i:75036;s:12:\"delete-75798\";i:75037;s:12:\"delete-75796\";i:75038;s:12:\"delete-75797\";i:75039;s:12:\"delete-75799\";i:75040;s:12:\"delete-75800\";i:75041;s:12:\"delete-75801\";i:75042;s:12:\"delete-75802\";i:75043;s:12:\"delete-75803\";i:75044;s:12:\"delete-75805\";i:75045;s:12:\"delete-75804\";i:75046;s:12:\"delete-75806\";i:75047;s:12:\"delete-75807\";i:75048;s:12:\"delete-75810\";i:75049;s:12:\"delete-75808\";i:75050;s:12:\"delete-75809\";i:75051;s:12:\"delete-75811\";i:75052;s:12:\"delete-75812\";i:75053;s:12:\"delete-75813\";i:75054;s:12:\"delete-75816\";i:75055;s:12:\"delete-75818\";i:75056;s:12:\"delete-75814\";i:75057;s:12:\"delete-75815\";i:75058;s:12:\"delete-75817\";i:75059;s:12:\"delete-75819\";i:75060;s:12:\"delete-75822\";i:75061;s:12:\"delete-75820\";i:75062;s:12:\"delete-75821\";i:75063;s:12:\"delete-75823\";i:75064;s:12:\"delete-75824\";i:75065;s:12:\"delete-75825\";i:75066;s:12:\"delete-75828\";i:75067;s:12:\"delete-75826\";i:75068;s:12:\"delete-75827\";i:75069;s:12:\"delete-75829\";i:75070;s:12:\"delete-75830\";i:75071;s:12:\"delete-75831\";i:75072;s:12:\"delete-75832\";i:75073;s:12:\"delete-75833\";i:75074;s:12:\"delete-75835\";i:75075;s:12:\"delete-75834\";i:75076;s:12:\"delete-75836\";i:75077;s:12:\"delete-75837\";i:75078;s:12:\"delete-75840\";i:75079;s:12:\"delete-75842\";i:75080;s:12:\"delete-75838\";i:75081;s:12:\"delete-75839\";i:75082;s:12:\"delete-75841\";i:75083;s:12:\"delete-75843\";i:75084;s:12:\"delete-75846\";i:75085;s:12:\"delete-75848\";i:75086;s:12:\"delete-75849\";i:75087;s:12:\"delete-75852\";i:75088;s:12:\"delete-75844\";i:75089;s:12:\"delete-75845\";i:75090;s:12:\"delete-75847\";i:75091;s:12:\"delete-75850\";i:75092;s:12:\"delete-75851\";i:75093;s:12:\"delete-75853\";i:75094;s:12:\"delete-75854\";i:75095;s:12:\"delete-75855\";i:75096;s:12:\"delete-75858\";i:75097;s:12:\"delete-75860\";i:75098;s:12:\"delete-75856\";i:75099;s:12:\"delete-75857\";i:75100;s:12:\"delete-75859\";i:75101;s:12:\"delete-75861\";i:75102;s:12:\"delete-75864\";i:75103;s:12:\"delete-75866\";i:75104;s:12:\"delete-75862\";i:75105;s:12:\"delete-75863\";i:75106;s:12:\"delete-75865\";i:75107;s:12:\"delete-75867\";i:75108;s:12:\"delete-75868\";i:75109;s:12:\"delete-75869\";i:75110;s:12:\"delete-75870\";i:75111;s:12:\"delete-75872\";i:75112;s:12:\"delete-75873\";i:75113;s:12:\"delete-75876\";i:75114;s:12:\"delete-75878\";i:75115;s:12:\"delete-75871\";i:75116;s:12:\"delete-75874\";i:75117;s:12:\"delete-75875\";i:75118;s:12:\"delete-75877\";i:75119;s:12:\"delete-75879\";i:75120;s:12:\"delete-75882\";i:75121;s:12:\"delete-75884\";i:75122;s:12:\"delete-75880\";i:75123;s:12:\"delete-75881\";i:75124;s:12:\"delete-75883\";i:75125;s:12:\"delete-75885\";i:75126;s:12:\"delete-75888\";i:75127;s:12:\"delete-75886\";i:75128;s:12:\"delete-75887\";i:75129;s:12:\"delete-75889\";i:75130;s:12:\"delete-75890\";i:75131;s:12:\"delete-75891\";i:75132;s:12:\"delete-75894\";i:75133;s:12:\"delete-75892\";i:75134;s:12:\"delete-75893\";i:75135;s:12:\"delete-75895\";i:75136;s:12:\"delete-75896\";i:75137;s:12:\"delete-75897\";i:75138;s:12:\"delete-75898\";i:75139;s:12:\"delete-75899\";i:75140;s:12:\"delete-75901\";i:75141;s:12:\"delete-75900\";i:75142;s:12:\"delete-75902\";i:75143;s:12:\"delete-75903\";i:75144;s:12:\"delete-75906\";i:75145;s:12:\"delete-75908\";i:75146;s:12:\"delete-75909\";i:75147;s:12:\"delete-75904\";i:75148;s:12:\"delete-75905\";i:75149;s:12:\"delete-75907\";i:75150;s:12:\"delete-75910\";i:75151;s:12:\"delete-75911\";i:75152;s:12:\"delete-75913\";i:75153;s:12:\"delete-75912\";i:75154;s:12:\"delete-75914\";i:75155;s:12:\"delete-75915\";i:75156;s:12:\"delete-75918\";i:75157;s:12:\"delete-75920\";i:75158;s:12:\"delete-75916\";i:75159;s:12:\"delete-75917\";i:75160;s:12:\"delete-75919\";i:75161;s:12:\"delete-75921\";i:75162;s:12:\"delete-75924\";i:75163;s:12:\"delete-75922\";i:75164;s:12:\"delete-75923\";i:75165;s:12:\"delete-75925\";i:75166;s:12:\"delete-75926\";i:75167;s:12:\"delete-75927\";i:75168;s:12:\"delete-75930\";i:75169;s:12:\"delete-75928\";i:75170;s:12:\"delete-75929\";i:75171;s:12:\"delete-75931\";i:75172;s:12:\"delete-75932\";i:75173;s:12:\"delete-75933\";i:75174;s:12:\"delete-75936\";i:75175;s:12:\"delete-75938\";i:75176;s:12:\"delete-75934\";i:75177;s:12:\"delete-75935\";i:75178;s:12:\"delete-75937\";i:75179;s:12:\"delete-75939\";i:75180;s:12:\"delete-75942\";i:75181;s:12:\"delete-75940\";i:75182;s:12:\"delete-75941\";i:75183;s:12:\"delete-75943\";i:75184;s:12:\"delete-75944\";i:75185;s:12:\"delete-75945\";i:75186;s:12:\"delete-75948\";i:75187;s:12:\"delete-75950\";i:75188;s:12:\"delete-75946\";i:75189;s:12:\"delete-75947\";i:75190;s:12:\"delete-75949\";i:75191;s:12:\"delete-75951\";i:75192;s:12:\"delete-75954\";i:75193;s:12:\"delete-75952\";i:75194;s:12:\"delete-75953\";i:75195;s:12:\"delete-75955\";i:75196;s:12:\"delete-75956\";i:75197;s:12:\"delete-75957\";i:75198;s:12:\"delete-75960\";i:75199;s:12:\"delete-75962\";i:75200;s:12:\"delete-75963\";i:75201;s:12:\"delete-75966\";i:75202;s:12:\"delete-75958\";i:75203;s:12:\"delete-75959\";i:75204;s:12:\"delete-75961\";i:75205;s:12:\"delete-75964\";i:75206;s:12:\"delete-75965\";i:75207;s:12:\"delete-75967\";i:75208;s:12:\"delete-75968\";i:75209;s:12:\"delete-75969\";i:75210;s:12:\"delete-75972\";i:75211;s:12:\"delete-75974\";i:75212;s:12:\"delete-75970\";i:75213;s:12:\"delete-75971\";i:75214;s:12:\"delete-75973\";i:75215;s:12:\"delete-75975\";i:75216;s:12:\"delete-75978\";i:75217;s:12:\"delete-75980\";i:75218;s:12:\"delete-75976\";i:75219;s:12:\"delete-75977\";i:75220;s:12:\"delete-75979\";i:75221;s:12:\"delete-75981\";i:75222;s:12:\"delete-75984\";i:75223;s:12:\"delete-75986\";i:75224;s:12:\"delete-75982\";i:75225;s:12:\"delete-75983\";i:75226;s:12:\"delete-75985\";i:75227;s:12:\"delete-75987\";i:75228;s:12:\"delete-75990\";i:75229;s:12:\"delete-75992\";i:75230;s:12:\"delete-75993\";i:75231;s:12:\"delete-75996\";i:75232;s:12:\"delete-75998\";i:75233;s:12:\"delete-75988\";i:75234;s:12:\"delete-75989\";i:75235;s:12:\"delete-75991\";i:75236;s:12:\"delete-75994\";i:75237;s:12:\"delete-75995\";i:75238;s:12:\"delete-75997\";i:75239;s:12:\"delete-75999\";i:75240;s:12:\"delete-76002\";i:75241;s:12:\"delete-76000\";i:75242;s:12:\"delete-76001\";i:75243;s:12:\"delete-76003\";i:75244;s:12:\"delete-76004\";i:75245;s:12:\"delete-76005\";i:75246;s:12:\"delete-76008\";i:75247;s:12:\"delete-76006\";i:75248;s:12:\"delete-76007\";i:75249;s:12:\"delete-76009\";i:75250;s:12:\"delete-76010\";i:75251;s:12:\"delete-76011\";i:75252;s:12:\"delete-76014\";i:75253;s:12:\"delete-76012\";i:75254;s:12:\"delete-76013\";i:75255;s:12:\"delete-76015\";i:75256;s:12:\"delete-76016\";i:75257;s:12:\"delete-76017\";i:75258;s:12:\"delete-76018\";i:75259;s:12:\"delete-76019\";i:75260;s:12:\"delete-76021\";i:75261;s:12:\"delete-76020\";i:75262;s:12:\"delete-76022\";i:75263;s:12:\"delete-76023\";i:75264;s:12:\"delete-76024\";i:75265;s:12:\"delete-76025\";i:75266;s:12:\"delete-76026\";i:75267;s:12:\"delete-76028\";i:75268;s:12:\"delete-76029\";i:75269;s:12:\"delete-76032\";i:75270;s:12:\"delete-76027\";i:75271;s:12:\"delete-76030\";i:75272;s:12:\"delete-76031\";i:75273;s:12:\"delete-76033\";i:75274;s:12:\"delete-76034\";i:75275;s:12:\"delete-76035\";i:75276;s:12:\"delete-76038\";i:75277;s:12:\"delete-76040\";i:75278;s:12:\"delete-76036\";i:75279;s:12:\"delete-76037\";i:75280;s:12:\"delete-76039\";i:75281;s:12:\"delete-76041\";i:75282;s:12:\"delete-76044\";i:75283;s:12:\"delete-76046\";i:75284;s:12:\"delete-76042\";i:75285;s:12:\"delete-76043\";i:75286;s:12:\"delete-76045\";i:75287;s:12:\"delete-76047\";i:75288;s:12:\"delete-76048\";i:75289;s:12:\"delete-76049\";i:75290;s:12:\"delete-76050\";i:75291;s:12:\"delete-76052\";i:75292;s:12:\"delete-76053\";i:75293;s:12:\"delete-76056\";i:75294;s:12:\"delete-76051\";i:75295;s:12:\"delete-76054\";i:75296;s:12:\"delete-76055\";i:75297;s:12:\"delete-76057\";i:75298;s:12:\"delete-76058\";i:75299;s:12:\"delete-76059\";i:75300;s:12:\"delete-76062\";i:75301;s:12:\"delete-76060\";i:75302;s:12:\"delete-76061\";i:75303;s:12:\"delete-76063\";i:75304;s:12:\"delete-76064\";i:75305;s:12:\"delete-76065\";i:75306;s:12:\"delete-76068\";i:75307;s:12:\"delete-76070\";i:75308;s:12:\"delete-76066\";i:75309;s:12:\"delete-76067\";i:75310;s:12:\"delete-76069\";i:75311;s:12:\"delete-76071\";i:75312;s:12:\"delete-76074\";i:75313;s:12:\"delete-76072\";i:75314;s:12:\"delete-76073\";i:75315;s:12:\"delete-76075\";i:75316;s:12:\"delete-76076\";i:75317;s:12:\"delete-76077\";i:75318;s:12:\"delete-76080\";i:75319;s:12:\"delete-76078\";i:75320;s:12:\"delete-76079\";i:75321;s:12:\"delete-76081\";i:75322;s:12:\"delete-76082\";i:75323;s:12:\"delete-76083\";i:75324;s:12:\"delete-76086\";i:75325;s:12:\"delete-76084\";i:75326;s:12:\"delete-76085\";i:75327;s:12:\"delete-76087\";i:75328;s:12:\"delete-76088\";i:75329;s:12:\"delete-76089\";i:75330;s:12:\"delete-76092\";i:75331;s:12:\"delete-76094\";i:75332;s:12:\"delete-76090\";i:75333;s:12:\"delete-76091\";i:75334;s:12:\"delete-76093\";i:75335;s:12:\"delete-76095\";i:75336;s:12:\"delete-76098\";i:75337;s:12:\"delete-76100\";i:75338;s:12:\"delete-76096\";i:75339;s:12:\"delete-76097\";i:75340;s:12:\"delete-76099\";i:75341;s:12:\"delete-76101\";i:75342;s:12:\"delete-76104\";i:75343;s:12:\"delete-76106\";i:75344;s:12:\"delete-76102\";i:75345;s:12:\"delete-76103\";i:75346;s:12:\"delete-76105\";i:75347;s:12:\"delete-76107\";i:75348;s:12:\"delete-76110\";i:75349;s:12:\"delete-76112\";i:75350;s:12:\"delete-76108\";i:75351;s:12:\"delete-76109\";i:75352;s:12:\"delete-76111\";i:75353;s:12:\"delete-76113\";i:75354;s:12:\"delete-76114\";i:75355;s:12:\"delete-76115\";i:75356;s:12:\"delete-76117\";i:75357;s:12:\"delete-76116\";i:75358;s:12:\"delete-76118\";i:75359;s:12:\"delete-76119\";i:75360;s:12:\"delete-76122\";i:75361;s:12:\"delete-76120\";i:75362;s:12:\"delete-76121\";i:75363;s:12:\"delete-76123\";i:75364;s:12:\"delete-76124\";i:75365;s:12:\"delete-76125\";i:75366;s:12:\"delete-76128\";i:75367;s:12:\"delete-76130\";i:75368;s:12:\"delete-76126\";i:75369;s:12:\"delete-76127\";i:75370;s:12:\"delete-76129\";i:75371;s:12:\"delete-76131\";i:75372;s:12:\"delete-76134\";i:75373;s:12:\"delete-76132\";i:75374;s:12:\"delete-76133\";i:75375;s:12:\"delete-76135\";i:75376;s:12:\"delete-76136\";i:75377;s:12:\"delete-76137\";i:75378;s:12:\"delete-76140\";i:75379;s:12:\"delete-76138\";i:75380;s:12:\"delete-76139\";i:75381;s:12:\"delete-76141\";i:75382;s:12:\"delete-76142\";i:75383;s:12:\"delete-76143\";i:75384;s:12:\"delete-76146\";i:75385;s:12:\"delete-76144\";i:75386;s:12:\"delete-76145\";i:75387;s:12:\"delete-76147\";i:75388;s:12:\"delete-76148\";i:75389;s:12:\"delete-76149\";i:75390;s:12:\"delete-76152\";i:75391;s:12:\"delete-76154\";i:75392;s:12:\"delete-76150\";i:75393;s:12:\"delete-76151\";i:75394;s:12:\"delete-76153\";i:75395;s:12:\"delete-76155\";i:75396;s:12:\"delete-76156\";i:75397;s:12:\"delete-76157\";i:75398;s:12:\"delete-76159\";i:75399;s:12:\"delete-76158\";i:75400;s:12:\"delete-76160\";i:75401;s:12:\"delete-76161\";i:75402;s:12:\"delete-76164\";i:75403;s:12:\"delete-76166\";i:75404;s:12:\"delete-76162\";i:75405;s:12:\"delete-76163\";i:75406;s:12:\"delete-76165\";i:75407;s:12:\"delete-76167\";i:75408;s:12:\"delete-76170\";i:75409;s:12:\"delete-76172\";i:75410;s:12:\"delete-76168\";i:75411;s:12:\"delete-76169\";i:75412;s:12:\"delete-76171\";i:75413;s:12:\"delete-76173\";i:75414;s:12:\"delete-76176\";i:75415;s:12:\"delete-76178\";i:75416;s:12:\"delete-76174\";i:75417;s:12:\"delete-76175\";i:75418;s:12:\"delete-76177\";i:75419;s:12:\"delete-76179\";i:75420;s:12:\"delete-76182\";i:75421;s:12:\"delete-76184\";i:75422;s:12:\"delete-76180\";i:75423;s:12:\"delete-76181\";i:75424;s:12:\"delete-76183\";i:75425;s:12:\"delete-76185\";i:75426;s:12:\"delete-76188\";i:75427;s:12:\"delete-76190\";i:75428;s:12:\"delete-76186\";i:75429;s:12:\"delete-76187\";i:75430;s:12:\"delete-76189\";i:75431;s:12:\"delete-76191\";i:75432;s:12:\"delete-76194\";i:75433;s:12:\"delete-76196\";i:75434;s:12:\"delete-76192\";i:75435;s:12:\"delete-76193\";i:75436;s:12:\"delete-76195\";i:75437;s:12:\"delete-76197\";i:75438;s:12:\"delete-76198\";i:75439;s:12:\"delete-76199\";i:75440;s:12:\"delete-76200\";i:75441;s:12:\"delete-76202\";i:75442;s:12:\"delete-76203\";i:75443;s:12:\"delete-76206\";i:75444;s:12:\"delete-76208\";i:75445;s:12:\"delete-76201\";i:75446;s:12:\"delete-76204\";i:75447;s:12:\"delete-76205\";i:75448;s:12:\"delete-76207\";i:75449;s:12:\"delete-76209\";i:75450;s:12:\"delete-76212\";i:75451;s:12:\"delete-76210\";i:75452;s:12:\"delete-76211\";i:75453;s:12:\"delete-76213\";i:75454;s:12:\"delete-76214\";i:75455;s:12:\"delete-76215\";i:75456;s:12:\"delete-76218\";i:75457;s:12:\"delete-76220\";i:75458;s:12:\"delete-76216\";i:75459;s:12:\"delete-76217\";i:75460;s:12:\"delete-76219\";i:75461;s:12:\"delete-76221\";i:75462;s:12:\"delete-76224\";i:75463;s:12:\"delete-76222\";i:75464;s:12:\"delete-76223\";i:75465;s:12:\"delete-76225\";i:75466;s:12:\"delete-76226\";i:75467;s:12:\"delete-76227\";i:75468;s:12:\"delete-76230\";i:75469;s:12:\"delete-76232\";i:75470;s:12:\"delete-76228\";i:75471;s:12:\"delete-76229\";i:75472;s:12:\"delete-76231\";i:75473;s:12:\"delete-76233\";i:75474;s:12:\"delete-76236\";i:75475;s:12:\"delete-76238\";i:75476;s:12:\"delete-76234\";i:75477;s:12:\"delete-76235\";i:75478;s:12:\"delete-76237\";i:75479;s:12:\"delete-76239\";i:75480;s:12:\"delete-76242\";i:75481;s:12:\"delete-76244\";i:75482;s:12:\"delete-76240\";i:75483;s:12:\"delete-76241\";i:75484;s:12:\"delete-76243\";i:75485;s:12:\"delete-76245\";i:75486;s:12:\"delete-76248\";i:75487;s:12:\"delete-76246\";i:75488;s:12:\"delete-76247\";i:75489;s:12:\"delete-76249\";i:75490;s:12:\"delete-76250\";i:75491;s:12:\"delete-76251\";i:75492;s:12:\"delete-76254\";i:75493;s:12:\"delete-76256\";i:75494;s:12:\"delete-76252\";i:75495;s:12:\"delete-76253\";i:75496;s:12:\"delete-76255\";i:75497;s:12:\"delete-76257\";i:75498;s:12:\"delete-76260\";i:75499;s:12:\"delete-76262\";i:75500;s:12:\"delete-76258\";i:75501;s:12:\"delete-76259\";i:75502;s:12:\"delete-76261\";i:75503;s:12:\"delete-76263\";i:75504;s:12:\"delete-76266\";i:75505;s:12:\"delete-76268\";i:75506;s:12:\"delete-76269\";i:75507;s:12:\"delete-76272\";i:75508;s:12:\"delete-76274\";i:75509;s:12:\"delete-76264\";i:75510;s:12:\"delete-76265\";i:75511;s:12:\"delete-76267\";i:75512;s:12:\"delete-76270\";i:75513;s:12:\"delete-76271\";i:75514;s:12:\"delete-76273\";i:75515;s:12:\"delete-76275\";i:75516;s:12:\"delete-76278\";i:75517;s:12:\"delete-76280\";i:75518;s:12:\"delete-76276\";i:75519;s:12:\"delete-76277\";i:75520;s:12:\"delete-76279\";i:75521;s:12:\"delete-76281\";i:75522;s:12:\"delete-76284\";i:75523;s:12:\"delete-76286\";i:75524;s:12:\"delete-76282\";i:75525;s:12:\"delete-76283\";i:75526;s:12:\"delete-76285\";i:75527;s:12:\"delete-76287\";i:75528;s:12:\"delete-76290\";i:75529;s:12:\"delete-76292\";i:75530;s:12:\"delete-76288\";i:75531;s:12:\"delete-76289\";i:75532;s:12:\"delete-76291\";i:75533;s:12:\"delete-76293\";i:75534;s:12:\"delete-76296\";i:75535;s:12:\"delete-76298\";i:75536;s:12:\"delete-76294\";i:75537;s:12:\"delete-76295\";i:75538;s:12:\"delete-76297\";i:75539;s:12:\"delete-76299\";i:75540;s:12:\"delete-76302\";i:75541;s:12:\"delete-76304\";i:75542;s:12:\"delete-76300\";i:75543;s:12:\"delete-76301\";i:75544;s:12:\"delete-76303\";i:75545;s:12:\"delete-76305\";i:75546;s:12:\"delete-76308\";i:75547;s:12:\"delete-76306\";i:75548;s:12:\"delete-76307\";i:75549;s:12:\"delete-76309\";i:75550;s:12:\"delete-76310\";i:75551;s:12:\"delete-76311\";i:75552;s:12:\"delete-76314\";i:75553;s:12:\"delete-76312\";i:75554;s:12:\"delete-76313\";i:75555;s:12:\"delete-76315\";i:75556;s:12:\"delete-76316\";i:75557;s:12:\"delete-76317\";i:75558;s:12:\"delete-76320\";i:75559;s:12:\"delete-76322\";i:75560;s:12:\"delete-76323\";i:75561;s:12:\"delete-76326\";i:75562;s:12:\"delete-76318\";i:75563;s:12:\"delete-76319\";i:75564;s:12:\"delete-76321\";i:75565;s:12:\"delete-76324\";i:75566;s:12:\"delete-76325\";i:75567;s:12:\"delete-76327\";i:75568;s:12:\"delete-76328\";i:75569;s:12:\"delete-76329\";i:75570;s:12:\"delete-76332\";i:75571;s:12:\"delete-76334\";i:75572;s:12:\"delete-76330\";i:75573;s:12:\"delete-76331\";i:75574;s:12:\"delete-76333\";i:75575;s:12:\"delete-76335\";i:75576;s:12:\"delete-76338\";i:75577;s:12:\"delete-76336\";i:75578;s:12:\"delete-76337\";i:75579;s:12:\"delete-76339\";i:75580;s:12:\"delete-76340\";i:75581;s:12:\"delete-76341\";i:75582;s:12:\"delete-76342\";i:75583;s:12:\"delete-76343\";i:75584;s:12:\"delete-76345\";i:75585;s:12:\"delete-76344\";i:75586;s:12:\"delete-76346\";i:75587;s:12:\"delete-76348\";i:75588;s:12:\"delete-76349\";i:75589;s:12:\"delete-76351\";i:75590;s:12:\"delete-76347\";i:75591;s:12:\"delete-76350\";i:75592;s:12:\"delete-76352\";i:75593;s:12:\"delete-76353\";i:75594;s:12:\"delete-76356\";i:75595;s:12:\"delete-76354\";i:75596;s:12:\"delete-76355\";i:75597;s:12:\"delete-76357\";i:75598;s:12:\"delete-76358\";i:75599;s:12:\"delete-76359\";i:75600;s:12:\"delete-76362\";i:75601;s:12:\"delete-76360\";i:75602;s:12:\"delete-76361\";i:75603;s:12:\"delete-76363\";i:75604;s:12:\"delete-76364\";i:75605;s:12:\"delete-76365\";i:75606;s:12:\"delete-76368\";i:75607;s:12:\"delete-76370\";i:75608;s:12:\"delete-76366\";i:75609;s:12:\"delete-76367\";i:75610;s:12:\"delete-76369\";i:75611;s:12:\"delete-76371\";i:75612;s:12:\"delete-76374\";i:75613;s:12:\"delete-76376\";i:75614;s:12:\"delete-76372\";i:75615;s:12:\"delete-76373\";i:75616;s:12:\"delete-76375\";i:75617;s:12:\"delete-76377\";i:75618;s:12:\"delete-76380\";i:75619;s:12:\"delete-76378\";i:75620;s:12:\"delete-76379\";i:75621;s:12:\"delete-76381\";i:75622;s:12:\"delete-76382\";i:75623;s:12:\"delete-76383\";i:75624;s:12:\"delete-76386\";i:75625;s:12:\"delete-76388\";i:75626;s:12:\"delete-76384\";i:75627;s:12:\"delete-76385\";i:75628;s:12:\"delete-76387\";i:75629;s:12:\"delete-76389\";i:75630;s:12:\"delete-76392\";i:75631;s:12:\"delete-76390\";i:75632;s:12:\"delete-76391\";i:75633;s:12:\"delete-76393\";i:75634;s:12:\"delete-76394\";i:75635;s:12:\"delete-76395\";i:75636;s:12:\"delete-76398\";i:75637;s:12:\"delete-76396\";i:75638;s:12:\"delete-76397\";i:75639;s:12:\"delete-76399\";i:75640;s:12:\"delete-76400\";i:75641;s:12:\"delete-76401\";i:75642;s:12:\"delete-76404\";i:75643;s:12:\"delete-76406\";i:75644;s:12:\"delete-76402\";i:75645;s:12:\"delete-76403\";i:75646;s:12:\"delete-76405\";i:75647;s:12:\"delete-76407\";i:75648;s:12:\"delete-76408\";i:75649;s:12:\"delete-76409\";i:75650;s:12:\"delete-76411\";i:75651;s:12:\"delete-76410\";i:75652;s:12:\"delete-76412\";i:75653;s:12:\"delete-76413\";i:75654;s:12:\"delete-76416\";i:75655;s:12:\"delete-76418\";i:75656;s:12:\"delete-76414\";i:75657;s:12:\"delete-76415\";i:75658;s:12:\"delete-76417\";i:75659;s:12:\"delete-76419\";i:75660;s:12:\"delete-76422\";i:75661;s:12:\"delete-76424\";i:75662;s:12:\"delete-76420\";i:75663;s:12:\"delete-76421\";i:75664;s:12:\"delete-76423\";i:75665;s:12:\"delete-76425\";i:75666;s:12:\"delete-76428\";i:75667;s:12:\"delete-76430\";i:75668;s:12:\"delete-76426\";i:75669;s:12:\"delete-76427\";i:75670;s:12:\"delete-76429\";i:75671;s:12:\"delete-76431\";i:75672;s:12:\"delete-76432\";i:75673;s:12:\"delete-76433\";i:75674;s:12:\"delete-76435\";i:75675;s:12:\"delete-76434\";i:75676;s:12:\"delete-76436\";i:75677;s:12:\"delete-76437\";i:75678;s:12:\"delete-76438\";i:75679;s:12:\"delete-76439\";i:75680;s:12:\"delete-76440\";i:75681;s:12:\"delete-76442\";i:75682;s:12:\"delete-76443\";i:75683;s:12:\"delete-76446\";i:75684;s:12:\"delete-76441\";i:75685;s:12:\"delete-76444\";i:75686;s:12:\"delete-76445\";i:75687;s:12:\"delete-76447\";i:75688;s:12:\"delete-76448\";i:75689;s:12:\"delete-76449\";i:75690;s:12:\"delete-76450\";i:75691;s:12:\"delete-76451\";i:75692;s:12:\"delete-76452\";i:75693;s:12:\"delete-76454\";i:75694;s:12:\"delete-76455\";i:75695;s:12:\"delete-76458\";i:75696;s:12:\"delete-76453\";i:75697;s:12:\"delete-76456\";i:75698;s:12:\"delete-76457\";i:75699;s:12:\"delete-76459\";i:75700;s:12:\"delete-76460\";i:75701;s:12:\"delete-76461\";i:75702;s:12:\"delete-76462\";i:75703;s:12:\"delete-76463\";i:75704;s:12:\"delete-76465\";i:75705;s:12:\"delete-76464\";i:75706;s:12:\"delete-76466\";i:75707;s:12:\"delete-76468\";i:75708;s:12:\"delete-76469\";i:75709;s:12:\"delete-76471\";i:75710;s:12:\"delete-76467\";i:75711;s:12:\"delete-76470\";i:75712;s:12:\"delete-76472\";i:75713;s:12:\"delete-76473\";i:75714;s:12:\"delete-76476\";i:75715;s:12:\"delete-76474\";i:75716;s:12:\"delete-76475\";i:75717;s:12:\"delete-76477\";i:75718;s:12:\"delete-76478\";i:75719;s:12:\"delete-76479\";i:75720;s:12:\"delete-76482\";i:75721;s:12:\"delete-76484\";i:75722;s:12:\"delete-76480\";i:75723;s:12:\"delete-76481\";i:75724;s:12:\"delete-76483\";i:75725;s:12:\"delete-76485\";i:75726;s:12:\"delete-76488\";i:75727;s:12:\"delete-76490\";i:75728;s:12:\"delete-76486\";i:75729;s:12:\"delete-76487\";i:75730;s:12:\"delete-76489\";i:75731;s:12:\"delete-76491\";i:75732;s:12:\"delete-76494\";i:75733;s:12:\"delete-76492\";i:75734;s:12:\"delete-76493\";i:75735;s:12:\"delete-76495\";i:75736;s:12:\"delete-76496\";i:75737;s:12:\"delete-76497\";i:75738;s:12:\"delete-76500\";i:75739;s:12:\"delete-76498\";i:75740;s:12:\"delete-76499\";i:75741;s:12:\"delete-76501\";i:75742;s:12:\"delete-76502\";i:75743;s:12:\"delete-76503\";i:75744;s:12:\"delete-76506\";i:75745;s:12:\"delete-76508\";i:75746;s:12:\"delete-76509\";i:75747;s:12:\"delete-76512\";i:75748;s:12:\"delete-76504\";i:75749;s:12:\"delete-76505\";i:75750;s:12:\"delete-76507\";i:75751;s:12:\"delete-76510\";i:75752;s:12:\"delete-76511\";i:75753;s:12:\"delete-76513\";i:75754;s:12:\"delete-76514\";i:75755;s:12:\"delete-76515\";i:75756;s:12:\"delete-76518\";i:75757;s:12:\"delete-76516\";i:75758;s:12:\"delete-76517\";i:75759;s:12:\"delete-76519\";i:75760;s:12:\"delete-76520\";i:75761;s:12:\"delete-76521\";i:75762;s:12:\"delete-76524\";i:75763;s:12:\"delete-76526\";i:75764;s:12:\"delete-76522\";i:75765;s:12:\"delete-76523\";i:75766;s:12:\"delete-76525\";i:75767;s:12:\"delete-76527\";i:75768;s:12:\"delete-76530\";i:75769;s:12:\"delete-76528\";i:75770;s:12:\"delete-76529\";i:75771;s:12:\"delete-76531\";i:75772;s:12:\"delete-76532\";i:75773;s:12:\"delete-76533\";i:75774;s:12:\"delete-76536\";i:75775;s:12:\"delete-76538\";i:75776;s:12:\"delete-76534\";i:75777;s:12:\"delete-76535\";i:75778;s:12:\"delete-76537\";i:75779;s:12:\"delete-76539\";i:75780;s:12:\"delete-76542\";i:75781;s:12:\"delete-76544\";i:75782;s:12:\"delete-76540\";i:75783;s:12:\"delete-76541\";i:75784;s:12:\"delete-76543\";i:75785;s:12:\"delete-76545\";i:75786;s:12:\"delete-76548\";i:75787;s:12:\"delete-76550\";i:75788;s:12:\"delete-76546\";i:75789;s:12:\"delete-76547\";i:75790;s:12:\"delete-76549\";i:75791;s:12:\"delete-76551\";i:75792;s:12:\"delete-76554\";i:75793;s:12:\"delete-76552\";i:75794;s:12:\"delete-76553\";i:75795;s:12:\"delete-76555\";i:75796;s:12:\"delete-76556\";i:75797;s:12:\"delete-76557\";i:75798;s:12:\"delete-76560\";i:75799;s:12:\"delete-76562\";i:75800;s:12:\"delete-76563\";i:75801;s:12:\"delete-76558\";i:75802;s:12:\"delete-76559\";i:75803;s:12:\"delete-76561\";i:75804;s:12:\"delete-76564\";i:75805;s:12:\"delete-76565\";i:75806;s:12:\"delete-76567\";i:75807;s:12:\"delete-76566\";i:75808;s:12:\"delete-76568\";i:75809;s:12:\"delete-76569\";i:75810;s:12:\"delete-76572\";i:75811;s:12:\"delete-76574\";i:75812;s:12:\"delete-76570\";i:75813;s:12:\"delete-76571\";i:75814;s:12:\"delete-76573\";i:75815;s:12:\"delete-76575\";i:75816;s:12:\"delete-76576\";i:75817;s:12:\"delete-76577\";i:75818;s:12:\"delete-76578\";i:75819;s:12:\"delete-76580\";i:75820;s:12:\"delete-76581\";i:75821;s:12:\"delete-76584\";i:75822;s:12:\"delete-76579\";i:75823;s:12:\"delete-76582\";i:75824;s:12:\"delete-76583\";i:75825;s:12:\"delete-76585\";i:75826;s:12:\"delete-76586\";i:75827;s:12:\"delete-76587\";i:75828;s:12:\"delete-76590\";i:75829;s:12:\"delete-76592\";i:75830;s:12:\"delete-76588\";i:75831;s:12:\"delete-76589\";i:75832;s:12:\"delete-76591\";i:75833;s:12:\"delete-76593\";i:75834;s:12:\"delete-76596\";i:75835;s:12:\"delete-76598\";i:75836;s:12:\"delete-76594\";i:75837;s:12:\"delete-76595\";i:75838;s:12:\"delete-76597\";i:75839;s:12:\"delete-76599\";i:75840;s:12:\"delete-76600\";i:75841;s:12:\"delete-76601\";i:75842;s:12:\"delete-76602\";i:75843;s:12:\"delete-76604\";i:75844;s:12:\"delete-76605\";i:75845;s:12:\"delete-76608\";i:75846;s:12:\"delete-76610\";i:75847;s:12:\"delete-76603\";i:75848;s:12:\"delete-76606\";i:75849;s:12:\"delete-76607\";i:75850;s:12:\"delete-76609\";i:75851;s:12:\"delete-76611\";i:75852;s:12:\"delete-76614\";i:75853;s:12:\"delete-76612\";i:75854;s:12:\"delete-76613\";i:75855;s:12:\"delete-76615\";i:75856;s:12:\"delete-76616\";i:75857;s:12:\"delete-76617\";i:75858;s:12:\"delete-76620\";i:75859;s:12:\"delete-76622\";i:75860;s:12:\"delete-76623\";i:75861;s:12:\"delete-76618\";i:75862;s:12:\"delete-76619\";i:75863;s:12:\"delete-76621\";i:75864;s:12:\"delete-76624\";i:75865;s:12:\"delete-76625\";i:75866;s:12:\"delete-76626\";i:75867;s:12:\"delete-76628\";i:75868;s:12:\"delete-76629\";i:75869;s:12:\"delete-76627\";i:75870;s:12:\"delete-76630\";i:75871;s:12:\"delete-76631\";i:75872;s:12:\"delete-76633\";i:75873;s:12:\"delete-76632\";i:75874;s:12:\"delete-76634\";i:75875;s:12:\"delete-76636\";i:75876;s:12:\"delete-76637\";i:75877;s:12:\"delete-76639\";i:75878;s:12:\"delete-76635\";i:75879;s:12:\"delete-76638\";i:75880;s:12:\"delete-76640\";i:75881;s:12:\"delete-76641\";i:75882;s:12:\"delete-76644\";i:75883;s:12:\"delete-76642\";i:75884;s:12:\"delete-76643\";i:75885;s:12:\"delete-76645\";i:75886;s:12:\"delete-76646\";i:75887;s:12:\"delete-76647\";i:75888;s:12:\"delete-76650\";i:75889;s:12:\"delete-76648\";i:75890;s:12:\"delete-76649\";i:75891;s:12:\"delete-76651\";i:75892;s:12:\"delete-76652\";i:75893;s:12:\"delete-76653\";i:75894;s:12:\"delete-76656\";i:75895;s:12:\"delete-76654\";i:75896;s:12:\"delete-76655\";i:75897;s:12:\"delete-76657\";i:75898;s:12:\"delete-76658\";i:75899;s:12:\"delete-76659\";i:75900;s:12:\"delete-76662\";i:75901;s:12:\"delete-76664\";i:75902;s:12:\"delete-76660\";i:75903;s:12:\"delete-76661\";i:75904;s:12:\"delete-76663\";i:75905;s:12:\"delete-76665\";i:75906;s:12:\"delete-76668\";i:75907;s:12:\"delete-76670\";i:75908;s:12:\"delete-76666\";i:75909;s:12:\"delete-76667\";i:75910;s:12:\"delete-76669\";i:75911;s:12:\"delete-76671\";i:75912;s:12:\"delete-76674\";i:75913;s:12:\"delete-76672\";i:75914;s:12:\"delete-76673\";i:75915;s:12:\"delete-76675\";i:75916;s:12:\"delete-76676\";i:75917;s:12:\"delete-76677\";i:75918;s:12:\"delete-76680\";i:75919;s:12:\"delete-76682\";i:75920;s:12:\"delete-76683\";i:75921;s:12:\"delete-76678\";i:75922;s:12:\"delete-76679\";i:75923;s:12:\"delete-76681\";i:75924;s:12:\"delete-76684\";i:75925;s:12:\"delete-76685\";i:75926;s:12:\"delete-76686\";i:75927;s:12:\"delete-76688\";i:75928;s:12:\"delete-76689\";i:75929;s:12:\"delete-76692\";i:75930;s:12:\"delete-76687\";i:75931;s:12:\"delete-76690\";i:75932;s:12:\"delete-76691\";i:75933;s:12:\"delete-76693\";i:75934;s:12:\"delete-76694\";i:75935;s:12:\"delete-76695\";i:75936;s:12:\"delete-76696\";i:75937;s:12:\"delete-76697\";i:75938;s:12:\"delete-76698\";i:75939;s:12:\"delete-76700\";i:75940;s:12:\"delete-76701\";i:75941;s:12:\"delete-76704\";i:75942;s:12:\"delete-76706\";i:75943;s:12:\"delete-76699\";i:75944;s:12:\"delete-76702\";i:75945;s:12:\"delete-76703\";i:75946;s:12:\"delete-76705\";i:75947;s:12:\"delete-76707\";i:75948;s:12:\"delete-76710\";i:75949;s:12:\"delete-76708\";i:75950;s:12:\"delete-76709\";i:75951;s:12:\"delete-76711\";i:75952;s:12:\"delete-76712\";i:75953;s:12:\"delete-76713\";i:75954;s:12:\"delete-76716\";i:75955;s:12:\"delete-76714\";i:75956;s:12:\"delete-76715\";i:75957;s:12:\"delete-76717\";i:75958;s:12:\"delete-76718\";i:75959;s:12:\"delete-76719\";i:75960;s:12:\"delete-76722\";i:75961;s:12:\"delete-76724\";i:75962;s:12:\"delete-76720\";i:75963;s:12:\"delete-76721\";i:75964;s:12:\"delete-76723\";i:75965;s:12:\"delete-76725\";i:75966;s:12:\"delete-76728\";i:75967;s:12:\"delete-76730\";i:75968;s:12:\"delete-76726\";i:75969;s:12:\"delete-76727\";i:75970;s:12:\"delete-76729\";i:75971;s:12:\"delete-76731\";i:75972;s:12:\"delete-76732\";i:75973;s:12:\"delete-76733\";i:75974;s:12:\"delete-76735\";i:75975;s:12:\"delete-76734\";i:75976;s:12:\"delete-76736\";i:75977;s:12:\"delete-76737\";i:75978;s:12:\"delete-76738\";i:75979;s:12:\"delete-76739\";i:75980;s:12:\"delete-76741\";i:75981;s:12:\"delete-76740\";i:75982;s:12:\"delete-76742\";i:75983;s:12:\"delete-76743\";i:75984;s:12:\"delete-76744\";i:75985;s:12:\"delete-76745\";i:75986;s:12:\"delete-76746\";i:75987;s:12:\"delete-76748\";i:75988;s:12:\"delete-76749\";i:75989;s:12:\"delete-76752\";i:75990;s:12:\"delete-76747\";i:75991;s:12:\"delete-76750\";i:75992;s:12:\"delete-76751\";i:75993;s:12:\"delete-76753\";i:75994;s:12:\"delete-76754\";i:75995;s:12:\"delete-76755\";i:75996;s:12:\"delete-76758\";i:75997;s:12:\"delete-76760\";i:75998;s:12:\"delete-76756\";i:75999;s:12:\"delete-76757\";i:76000;s:12:\"delete-76759\";i:76001;s:12:\"delete-76761\";i:76002;s:12:\"delete-76764\";i:76003;s:12:\"delete-76766\";i:76004;s:12:\"delete-76762\";i:76005;s:12:\"delete-76763\";i:76006;s:12:\"delete-76765\";i:76007;s:12:\"delete-76767\";i:76008;s:12:\"delete-76768\";i:76009;s:12:\"delete-76769\";i:76010;s:12:\"delete-76770\";i:76011;s:12:\"delete-76772\";i:76012;s:12:\"delete-76773\";i:76013;s:12:\"delete-76776\";i:76014;s:12:\"delete-76771\";i:76015;s:12:\"delete-76774\";i:76016;s:12:\"delete-76775\";i:76017;s:12:\"delete-76777\";i:76018;s:12:\"delete-76778\";i:76019;s:12:\"delete-76779\";i:76020;s:12:\"delete-76782\";i:76021;s:12:\"delete-76784\";i:76022;s:12:\"delete-76780\";i:76023;s:12:\"delete-76781\";i:76024;s:12:\"delete-76783\";i:76025;s:12:\"delete-76785\";i:76026;s:12:\"delete-76788\";i:76027;s:12:\"delete-76790\";i:76028;s:12:\"delete-76786\";i:76029;s:12:\"delete-76787\";i:76030;s:12:\"delete-76789\";i:76031;s:12:\"delete-76791\";i:76032;s:12:\"delete-76792\";i:76033;s:12:\"delete-76793\";i:76034;s:12:\"delete-76794\";i:76035;s:12:\"delete-76796\";i:76036;s:12:\"delete-76797\";i:76037;s:12:\"delete-76800\";i:76038;s:12:\"delete-76802\";i:76039;s:12:\"delete-76795\";i:76040;s:12:\"delete-76798\";i:76041;s:12:\"delete-76799\";i:76042;s:12:\"delete-76801\";i:76043;s:12:\"delete-76803\";i:76044;s:12:\"delete-76806\";i:76045;s:12:\"delete-76804\";i:76046;s:12:\"delete-76805\";i:76047;s:12:\"delete-76807\";i:76048;s:12:\"delete-76808\";i:76049;s:12:\"delete-76809\";i:76050;s:12:\"delete-76812\";i:76051;s:12:\"delete-76810\";i:76052;s:12:\"delete-76811\";i:76053;s:12:\"delete-76813\";i:76054;s:12:\"delete-76814\";i:76055;s:12:\"delete-76815\";i:76056;s:12:\"delete-76818\";i:76057;s:12:\"delete-76816\";i:76058;s:12:\"delete-76817\";i:76059;s:12:\"delete-76819\";i:76060;s:12:\"delete-76820\";i:76061;s:12:\"delete-76821\";i:76062;s:12:\"delete-76824\";i:76063;s:12:\"delete-76822\";i:76064;s:12:\"delete-76823\";i:76065;s:12:\"delete-76825\";i:76066;s:12:\"delete-76826\";i:76067;s:12:\"delete-76827\";i:76068;s:12:\"delete-76830\";i:76069;s:12:\"delete-76832\";i:76070;s:12:\"delete-76828\";i:76071;s:12:\"delete-76829\";i:76072;s:12:\"delete-76831\";i:76073;s:12:\"delete-76833\";i:76074;s:12:\"delete-76836\";i:76075;s:12:\"delete-76838\";i:76076;s:12:\"delete-76834\";i:76077;s:12:\"delete-76835\";i:76078;s:12:\"delete-76837\";i:76079;s:12:\"delete-76839\";i:76080;s:12:\"delete-76842\";i:76081;s:12:\"delete-76844\";i:76082;s:12:\"delete-76840\";i:76083;s:12:\"delete-76841\";i:76084;s:12:\"delete-76843\";i:76085;s:12:\"delete-76845\";i:76086;s:12:\"delete-76848\";i:76087;s:12:\"delete-76850\";i:76088;s:12:\"delete-76846\";i:76089;s:12:\"delete-76847\";i:76090;s:12:\"delete-76849\";i:76091;s:12:\"delete-76851\";i:76092;s:12:\"delete-76854\";i:76093;s:12:\"delete-76856\";i:76094;s:12:\"delete-76857\";i:76095;s:12:\"delete-76852\";i:76096;s:12:\"delete-76853\";i:76097;s:12:\"delete-76855\";i:76098;s:12:\"delete-76858\";i:76099;s:12:\"delete-76859\";i:76100;s:12:\"delete-76860\";i:76101;s:12:\"delete-76862\";i:76102;s:12:\"delete-76863\";i:76103;s:12:\"delete-76866\";i:76104;s:12:\"delete-76861\";i:76105;s:12:\"delete-76864\";i:76106;s:12:\"delete-76865\";i:76107;s:12:\"delete-76867\";i:76108;s:12:\"delete-76868\";i:76109;s:12:\"delete-76869\";i:76110;s:12:\"delete-76872\";i:76111;s:12:\"delete-76874\";i:76112;s:12:\"delete-76870\";i:76113;s:12:\"delete-76871\";i:76114;s:12:\"delete-76873\";i:76115;s:12:\"delete-76875\";i:76116;s:12:\"delete-76878\";i:76117;s:12:\"delete-76876\";i:76118;s:12:\"delete-76877\";i:76119;s:12:\"delete-76879\";i:76120;s:12:\"delete-76880\";i:76121;s:12:\"delete-76881\";i:76122;s:12:\"delete-76884\";i:76123;s:12:\"delete-76882\";i:76124;s:12:\"delete-76883\";i:76125;s:12:\"delete-76885\";i:76126;s:12:\"delete-76886\";i:76127;s:12:\"delete-76887\";i:76128;s:12:\"delete-76890\";i:76129;s:12:\"delete-76888\";i:76130;s:12:\"delete-76889\";i:76131;s:12:\"delete-76891\";i:76132;s:12:\"delete-76892\";i:76133;s:12:\"delete-76893\";i:76134;s:12:\"delete-76896\";i:76135;s:12:\"delete-76898\";i:76136;s:12:\"delete-76894\";i:76137;s:12:\"delete-76895\";i:76138;s:12:\"delete-76897\";i:76139;s:12:\"delete-76899\";i:76140;s:12:\"delete-76902\";i:76141;s:12:\"delete-76904\";i:76142;s:12:\"delete-76900\";i:76143;s:12:\"delete-76901\";i:76144;s:12:\"delete-76903\";i:76145;s:12:\"delete-76905\";i:76146;s:12:\"delete-76908\";i:76147;s:12:\"delete-76906\";i:76148;s:12:\"delete-76907\";i:76149;s:12:\"delete-76909\";i:76150;s:12:\"delete-76910\";i:76151;s:12:\"delete-76911\";i:76152;s:12:\"delete-76914\";i:76153;s:12:\"delete-76912\";i:76154;s:12:\"delete-76913\";i:76155;s:12:\"delete-76915\";i:76156;s:12:\"delete-76916\";i:76157;s:12:\"delete-76917\";i:76158;s:12:\"delete-76920\";i:76159;s:12:\"delete-76918\";i:76160;s:12:\"delete-76919\";i:76161;s:12:\"delete-76921\";i:76162;s:12:\"delete-76922\";i:76163;s:12:\"delete-76923\";i:76164;s:12:\"delete-76926\";i:76165;s:12:\"delete-76928\";i:76166;s:12:\"delete-76929\";i:76167;s:12:\"delete-76932\";i:76168;s:12:\"delete-76924\";i:76169;s:12:\"delete-76925\";i:76170;s:12:\"delete-76927\";i:76171;s:12:\"delete-76930\";i:76172;s:12:\"delete-76931\";i:76173;s:12:\"delete-76933\";i:76174;s:12:\"delete-76934\";i:76175;s:12:\"delete-76935\";i:76176;s:12:\"delete-76938\";i:76177;s:12:\"delete-76940\";i:76178;s:12:\"delete-76936\";i:76179;s:12:\"delete-76937\";i:76180;s:12:\"delete-76939\";i:76181;s:12:\"delete-76941\";i:76182;s:12:\"delete-76942\";i:76183;s:12:\"delete-76943\";i:76184;s:12:\"delete-76945\";i:76185;s:12:\"delete-76944\";i:76186;s:12:\"delete-76946\";i:76187;s:12:\"delete-76947\";i:76188;s:12:\"delete-76950\";i:76189;s:12:\"delete-76952\";i:76190;s:12:\"delete-76948\";i:76191;s:12:\"delete-76949\";i:76192;s:12:\"delete-76951\";i:76193;s:12:\"delete-76953\";i:76194;s:12:\"delete-76956\";i:76195;s:12:\"delete-76958\";i:76196;s:12:\"delete-76954\";i:76197;s:12:\"delete-76955\";i:76198;s:12:\"delete-76957\";i:76199;s:12:\"delete-76959\";i:76200;s:12:\"delete-76962\";i:76201;s:12:\"delete-76964\";i:76202;s:12:\"delete-76960\";i:76203;s:12:\"delete-76961\";i:76204;s:12:\"delete-76963\";i:76205;s:12:\"delete-76965\";i:76206;s:12:\"delete-76968\";i:76207;s:12:\"delete-76970\";i:76208;s:12:\"delete-76966\";i:76209;s:12:\"delete-76967\";i:76210;s:12:\"delete-76969\";i:76211;s:12:\"delete-76971\";i:76212;s:12:\"delete-76974\";i:76213;s:12:\"delete-76972\";i:76214;s:12:\"delete-76973\";i:76215;s:12:\"delete-76975\";i:76216;s:12:\"delete-76976\";i:76217;s:12:\"delete-76977\";i:76218;s:12:\"delete-76980\";i:76219;s:12:\"delete-76982\";i:76220;s:12:\"delete-76983\";i:76221;s:12:\"delete-76986\";i:76222;s:12:\"delete-76978\";i:76223;s:12:\"delete-76979\";i:76224;s:12:\"delete-76981\";i:76225;s:12:\"delete-76984\";i:76226;s:12:\"delete-76985\";i:76227;s:12:\"delete-76987\";i:76228;s:12:\"delete-76988\";i:76229;s:12:\"delete-76989\";i:76230;s:12:\"delete-76992\";i:76231;s:12:\"delete-76990\";i:76232;s:12:\"delete-76991\";i:76233;s:12:\"delete-76993\";i:76234;s:12:\"delete-76994\";i:76235;s:12:\"delete-76995\";i:76236;s:12:\"delete-76998\";i:76237;s:12:\"delete-76996\";i:76238;s:12:\"delete-76997\";i:76239;s:12:\"delete-76999\";i:76240;s:12:\"delete-77000\";i:76241;s:12:\"delete-77001\";i:76242;s:12:\"delete-77004\";i:76243;s:12:\"delete-77006\";i:76244;s:12:\"delete-77002\";i:76245;s:12:\"delete-77003\";i:76246;s:12:\"delete-77005\";i:76247;s:12:\"delete-77007\";i:76248;s:12:\"delete-77010\";i:76249;s:12:\"delete-77012\";i:76250;s:12:\"delete-77008\";i:76251;s:12:\"delete-77009\";i:76252;s:12:\"delete-77011\";i:76253;s:12:\"delete-77013\";i:76254;s:12:\"delete-77016\";i:76255;s:12:\"delete-77018\";i:76256;s:12:\"delete-77014\";i:76257;s:12:\"delete-77015\";i:76258;s:12:\"delete-77017\";i:76259;s:12:\"delete-77019\";i:76260;s:12:\"delete-77022\";i:76261;s:12:\"delete-77024\";i:76262;s:12:\"delete-77020\";i:76263;s:12:\"delete-77021\";i:76264;s:12:\"delete-77023\";i:76265;s:12:\"delete-77025\";i:76266;s:12:\"delete-77028\";i:76267;s:12:\"delete-77030\";i:76268;s:12:\"delete-77026\";i:76269;s:12:\"delete-77027\";i:76270;s:12:\"delete-77029\";i:76271;s:12:\"delete-77031\";i:76272;s:12:\"delete-77032\";i:76273;s:12:\"delete-77033\";i:76274;s:12:\"delete-77035\";i:76275;s:12:\"delete-77034\";i:76276;s:12:\"delete-77036\";i:76277;s:12:\"delete-77037\";i:76278;s:12:\"delete-77040\";i:76279;s:12:\"delete-77042\";i:76280;s:12:\"delete-77038\";i:76281;s:12:\"delete-77039\";i:76282;s:12:\"delete-77041\";i:76283;s:12:\"delete-77043\";i:76284;s:12:\"delete-77046\";i:76285;s:12:\"delete-77048\";i:76286;s:12:\"delete-77044\";i:76287;s:12:\"delete-77045\";i:76288;s:12:\"delete-77047\";i:76289;s:12:\"delete-77049\";i:76290;s:12:\"delete-77052\";i:76291;s:12:\"delete-77050\";i:76292;s:12:\"delete-77051\";i:76293;s:12:\"delete-77053\";i:76294;s:12:\"delete-77054\";i:76295;s:12:\"delete-77055\";i:76296;s:12:\"delete-77058\";i:76297;s:12:\"delete-77056\";i:76298;s:12:\"delete-77057\";i:76299;s:12:\"delete-77059\";i:76300;s:12:\"delete-77060\";i:76301;s:12:\"delete-77061\";i:76302;s:12:\"delete-77064\";i:76303;s:12:\"delete-77062\";i:76304;s:12:\"delete-77063\";i:76305;s:12:\"delete-77065\";i:76306;s:12:\"delete-77066\";i:76307;s:12:\"delete-77067\";i:76308;s:12:\"delete-77070\";i:76309;s:12:\"delete-77068\";i:76310;s:12:\"delete-77069\";i:76311;s:12:\"delete-77071\";i:76312;s:12:\"delete-77072\";i:76313;s:12:\"delete-77073\";i:76314;s:12:\"delete-77076\";i:76315;s:12:\"delete-77074\";i:76316;s:12:\"delete-77075\";i:76317;s:12:\"delete-77077\";i:76318;s:12:\"delete-77078\";i:76319;s:12:\"delete-77079\";i:76320;s:12:\"delete-77082\";i:76321;s:12:\"delete-77080\";i:76322;s:12:\"delete-77081\";i:76323;s:12:\"delete-77083\";i:76324;s:12:\"delete-77084\";i:76325;s:12:\"delete-77085\";i:76326;s:12:\"delete-77088\";i:76327;s:12:\"delete-77086\";i:76328;s:12:\"delete-77087\";i:76329;s:12:\"delete-77089\";i:76330;s:12:\"delete-77090\";i:76331;s:12:\"delete-77091\";i:76332;s:12:\"delete-77094\";i:76333;s:12:\"delete-77096\";i:76334;s:12:\"delete-77092\";i:76335;s:12:\"delete-77093\";i:76336;s:12:\"delete-77095\";i:76337;s:12:\"delete-77097\";i:76338;s:12:\"delete-77100\";i:76339;s:12:\"delete-77102\";i:76340;s:12:\"delete-77098\";i:76341;s:12:\"delete-77099\";i:76342;s:12:\"delete-77101\";i:76343;s:12:\"delete-77103\";i:76344;s:12:\"delete-77106\";i:76345;s:12:\"delete-77104\";i:76346;s:12:\"delete-77105\";i:76347;s:12:\"delete-77107\";i:76348;s:12:\"delete-77108\";i:76349;s:12:\"delete-77109\";i:76350;s:12:\"delete-77112\";i:76351;s:12:\"delete-77114\";i:76352;s:12:\"delete-77110\";i:76353;s:12:\"delete-77111\";i:76354;s:12:\"delete-77113\";i:76355;s:12:\"delete-77115\";i:76356;s:12:\"delete-77118\";i:76357;s:12:\"delete-77116\";i:76358;s:12:\"delete-77117\";i:76359;s:12:\"delete-77119\";i:76360;s:12:\"delete-77120\";i:76361;s:12:\"delete-77121\";i:76362;s:12:\"delete-77124\";i:76363;s:12:\"delete-77122\";i:76364;s:12:\"delete-77123\";i:76365;s:12:\"delete-77125\";i:76366;s:12:\"delete-77126\";i:76367;s:12:\"delete-77127\";i:76368;s:12:\"delete-77130\";i:76369;s:12:\"delete-77128\";i:76370;s:12:\"delete-77129\";i:76371;s:12:\"delete-77131\";i:76372;s:12:\"delete-77132\";i:76373;s:12:\"delete-77133\";i:76374;s:12:\"delete-77136\";i:76375;s:12:\"delete-77138\";i:76376;s:12:\"delete-77134\";i:76377;s:12:\"delete-77135\";i:76378;s:12:\"delete-77137\";i:76379;s:12:\"delete-77139\";i:76380;s:12:\"delete-77142\";i:76381;s:12:\"delete-77140\";i:76382;s:12:\"delete-77141\";i:76383;s:12:\"delete-77143\";i:76384;s:12:\"delete-77144\";i:76385;s:12:\"delete-77145\";i:76386;s:12:\"delete-77148\";i:76387;s:12:\"delete-77150\";i:76388;s:12:\"delete-77146\";i:76389;s:12:\"delete-77147\";i:76390;s:12:\"delete-77149\";i:76391;s:12:\"delete-77151\";i:76392;s:12:\"delete-77154\";i:76393;s:12:\"delete-77156\";i:76394;s:12:\"delete-77152\";i:76395;s:12:\"delete-77153\";i:76396;s:12:\"delete-77155\";i:76397;s:12:\"delete-77157\";i:76398;s:12:\"delete-77160\";i:76399;s:12:\"delete-77158\";i:76400;s:12:\"delete-77159\";i:76401;s:12:\"delete-77161\";i:76402;s:12:\"delete-77162\";i:76403;s:12:\"delete-77163\";i:76404;s:12:\"delete-77164\";i:76405;s:12:\"delete-77165\";i:76406;s:12:\"delete-77167\";i:76407;s:12:\"delete-77166\";i:76408;s:12:\"delete-77168\";i:76409;s:12:\"delete-77169\";i:76410;s:12:\"delete-77172\";i:76411;s:12:\"delete-77170\";i:76412;s:12:\"delete-77171\";i:76413;s:12:\"delete-77173\";i:76414;s:12:\"delete-77174\";i:76415;s:12:\"delete-77175\";i:76416;s:12:\"delete-77178\";i:76417;s:12:\"delete-77176\";i:76418;s:12:\"delete-77177\";i:76419;s:12:\"delete-77179\";i:76420;s:12:\"delete-77180\";i:76421;s:12:\"delete-77181\";i:76422;s:12:\"delete-77182\";i:76423;s:12:\"delete-77183\";i:76424;s:12:\"delete-77184\";i:76425;s:12:\"delete-77186\";i:76426;s:12:\"delete-77187\";i:76427;s:12:\"delete-77190\";i:76428;s:12:\"delete-77185\";i:76429;s:12:\"delete-77188\";i:76430;s:12:\"delete-77189\";i:76431;s:12:\"delete-77191\";i:76432;s:12:\"delete-77192\";i:76433;s:12:\"delete-77193\";i:76434;s:12:\"delete-77196\";i:76435;s:12:\"delete-77194\";i:76436;s:12:\"delete-77195\";i:76437;s:12:\"delete-77197\";i:76438;s:12:\"delete-77198\";i:76439;s:12:\"delete-77199\";i:76440;s:12:\"delete-77202\";i:76441;s:12:\"delete-77204\";i:76442;s:12:\"delete-77200\";i:76443;s:12:\"delete-77201\";i:76444;s:12:\"delete-77203\";i:76445;s:12:\"delete-77205\";i:76446;s:12:\"delete-77208\";i:76447;s:12:\"delete-77210\";i:76448;s:12:\"delete-77206\";i:76449;s:12:\"delete-77207\";i:76450;s:12:\"delete-77209\";i:76451;s:12:\"delete-77211\";i:76452;s:12:\"delete-77212\";i:76453;s:12:\"delete-77213\";i:76454;s:12:\"delete-77215\";i:76455;s:12:\"delete-77214\";i:76456;s:12:\"delete-77216\";i:76457;s:12:\"delete-77217\";i:76458;s:12:\"delete-77218\";i:76459;s:12:\"delete-77219\";i:76460;s:12:\"delete-77220\";i:76461;s:12:\"delete-77222\";i:76462;s:12:\"delete-77221\";i:76463;s:12:\"delete-77224\";i:76464;s:12:\"delete-77225\";i:76465;s:12:\"delete-77223\";i:76466;s:12:\"delete-77226\";i:76467;s:12:\"delete-77228\";i:76468;s:12:\"delete-77227\";i:76469;s:12:\"delete-77229\";i:76470;s:12:\"delete-77232\";i:76471;s:12:\"delete-77234\";i:76472;s:12:\"delete-77230\";i:76473;s:12:\"delete-77231\";i:76474;s:12:\"delete-77233\";i:76475;s:12:\"delete-77235\";i:76476;s:12:\"delete-77238\";i:76477;s:12:\"delete-77240\";i:76478;s:12:\"delete-77241\";i:76479;s:12:\"delete-77236\";i:76480;s:12:\"delete-77237\";i:76481;s:12:\"delete-77239\";i:76482;s:12:\"delete-77242\";i:76483;s:12:\"delete-77243\";i:76484;s:12:\"delete-77245\";i:76485;s:12:\"delete-77244\";i:76486;s:12:\"delete-77246\";i:76487;s:12:\"delete-77247\";i:76488;s:12:\"delete-77250\";i:76489;s:12:\"delete-77252\";i:76490;s:12:\"delete-77253\";i:76491;s:12:\"delete-77256\";i:76492;s:12:\"delete-77258\";i:76493;s:12:\"delete-77248\";i:76494;s:12:\"delete-77249\";i:76495;s:12:\"delete-77251\";i:76496;s:12:\"delete-77254\";i:76497;s:12:\"delete-77255\";i:76498;s:12:\"delete-77257\";i:76499;s:12:\"delete-77259\";i:76500;s:12:\"delete-77262\";i:76501;s:12:\"delete-77264\";i:76502;s:12:\"delete-77260\";i:76503;s:12:\"delete-77261\";i:76504;s:12:\"delete-77263\";i:76505;s:12:\"delete-77265\";i:76506;s:12:\"delete-77268\";i:76507;s:12:\"delete-77270\";i:76508;s:12:\"delete-77266\";i:76509;s:12:\"delete-77267\";i:76510;s:12:\"delete-77269\";i:76511;s:12:\"delete-77271\";i:76512;s:12:\"delete-77274\";i:76513;s:12:\"delete-77276\";i:76514;s:12:\"delete-77272\";i:76515;s:12:\"delete-77273\";i:76516;s:12:\"delete-77275\";i:76517;s:12:\"delete-77277\";i:76518;s:12:\"delete-77280\";i:76519;s:12:\"delete-77278\";i:76520;s:12:\"delete-77279\";i:76521;s:12:\"delete-77281\";i:76522;s:12:\"delete-77282\";i:76523;s:12:\"delete-77283\";i:76524;s:12:\"delete-77286\";i:76525;s:12:\"delete-77284\";i:76526;s:12:\"delete-77285\";i:76527;s:12:\"delete-77287\";i:76528;s:12:\"delete-77288\";i:76529;s:12:\"delete-77289\";i:76530;s:12:\"delete-77292\";i:76531;s:12:\"delete-77290\";i:76532;s:12:\"delete-77291\";i:76533;s:12:\"delete-77293\";i:76534;s:12:\"delete-77294\";i:76535;s:12:\"delete-77295\";i:76536;s:12:\"delete-77298\";i:76537;s:12:\"delete-77300\";i:76538;s:12:\"delete-77296\";i:76539;s:12:\"delete-77297\";i:76540;s:12:\"delete-77299\";i:76541;s:12:\"delete-77301\";i:76542;s:12:\"delete-77304\";i:76543;s:12:\"delete-77302\";i:76544;s:12:\"delete-77303\";i:76545;s:12:\"delete-77305\";i:76546;s:12:\"delete-77306\";i:76547;s:12:\"delete-77307\";i:76548;s:12:\"delete-77310\";i:76549;s:12:\"delete-77312\";i:76550;s:12:\"delete-77308\";i:76551;s:12:\"delete-77309\";i:76552;s:12:\"delete-77311\";i:76553;s:12:\"delete-77313\";i:76554;s:12:\"delete-77316\";i:76555;s:12:\"delete-77314\";i:76556;s:12:\"delete-77315\";i:76557;s:12:\"delete-77317\";i:76558;s:12:\"delete-77318\";i:76559;s:12:\"delete-77319\";i:76560;s:12:\"delete-77322\";i:76561;s:12:\"delete-77324\";i:76562;s:12:\"delete-77320\";i:76563;s:12:\"delete-77321\";i:76564;s:12:\"delete-77323\";i:76565;s:12:\"delete-77325\";i:76566;s:12:\"delete-77328\";i:76567;s:12:\"delete-77330\";i:76568;s:12:\"delete-77326\";i:76569;s:12:\"delete-77327\";i:76570;s:12:\"delete-77329\";i:76571;s:12:\"delete-77331\";i:76572;s:12:\"delete-77334\";i:76573;s:12:\"delete-77336\";i:76574;s:12:\"delete-77332\";i:76575;s:12:\"delete-77333\";i:76576;s:12:\"delete-77335\";i:76577;s:12:\"delete-77337\";i:76578;s:12:\"delete-77340\";i:76579;s:12:\"delete-77338\";i:76580;s:12:\"delete-77339\";i:76581;s:12:\"delete-77341\";i:76582;s:12:\"delete-77342\";i:76583;s:12:\"delete-77343\";i:76584;s:12:\"delete-77346\";i:76585;s:12:\"delete-77344\";i:76586;s:12:\"delete-77345\";i:76587;s:12:\"delete-77347\";i:76588;s:12:\"delete-77348\";i:76589;s:12:\"delete-77349\";i:76590;s:12:\"delete-77352\";i:76591;s:12:\"delete-77350\";i:76592;s:12:\"delete-77351\";i:76593;s:12:\"delete-77353\";i:76594;s:12:\"delete-77354\";i:76595;s:12:\"delete-77355\";i:76596;s:12:\"delete-77358\";i:76597;s:12:\"delete-77356\";i:76598;s:12:\"delete-77357\";i:76599;s:12:\"delete-77359\";i:76600;s:12:\"delete-77360\";i:76601;s:12:\"delete-77361\";i:76602;s:12:\"delete-77364\";i:76603;s:12:\"delete-77362\";i:76604;s:12:\"delete-77363\";i:76605;s:12:\"delete-77365\";i:76606;s:12:\"delete-77366\";i:76607;s:12:\"delete-77367\";i:76608;s:12:\"delete-77370\";i:76609;s:12:\"delete-77368\";i:76610;s:12:\"delete-77369\";i:76611;s:12:\"delete-77371\";i:76612;s:12:\"delete-77372\";i:76613;s:12:\"delete-77373\";i:76614;s:12:\"delete-77376\";i:76615;s:12:\"delete-77378\";i:76616;s:12:\"delete-77379\";i:76617;s:12:\"delete-77382\";i:76618;s:12:\"delete-77384\";i:76619;s:12:\"delete-77374\";i:76620;s:12:\"delete-77375\";i:76621;s:12:\"delete-77377\";i:76622;s:12:\"delete-77380\";i:76623;s:12:\"delete-77381\";i:76624;s:12:\"delete-77383\";i:76625;s:12:\"delete-77385\";i:76626;s:12:\"delete-77388\";i:76627;s:12:\"delete-77390\";i:76628;s:12:\"delete-77386\";i:76629;s:12:\"delete-77387\";i:76630;s:12:\"delete-77389\";i:76631;s:12:\"delete-77391\";i:76632;s:12:\"delete-77394\";i:76633;s:12:\"delete-77396\";i:76634;s:12:\"delete-77392\";i:76635;s:12:\"delete-77393\";i:76636;s:12:\"delete-77395\";i:76637;s:12:\"delete-77397\";i:76638;s:12:\"delete-77400\";i:76639;s:12:\"delete-77402\";i:76640;s:12:\"delete-77398\";i:76641;s:12:\"delete-77399\";i:76642;s:12:\"delete-77401\";i:76643;s:12:\"delete-77403\";i:76644;s:12:\"delete-77406\";i:76645;s:12:\"delete-77408\";i:76646;s:12:\"delete-77404\";i:76647;s:12:\"delete-77405\";i:76648;s:12:\"delete-77407\";i:76649;s:12:\"delete-77409\";i:76650;s:12:\"delete-77412\";i:76651;s:12:\"delete-77414\";i:76652;s:12:\"delete-77410\";i:76653;s:12:\"delete-77411\";i:76654;s:12:\"delete-77413\";i:76655;s:12:\"delete-77415\";i:76656;s:12:\"delete-77418\";i:76657;s:12:\"delete-77416\";i:76658;s:12:\"delete-77417\";i:76659;s:12:\"delete-77419\";i:76660;s:12:\"delete-77420\";i:76661;s:12:\"delete-77422\";i:76662;s:12:\"delete-77423\";i:76663;s:12:\"delete-77425\";i:76664;s:12:\"delete-77421\";i:76665;s:12:\"delete-77424\";i:76666;s:12:\"delete-77426\";i:76667;s:12:\"delete-77427\";i:76668;s:12:\"delete-77430\";i:76669;s:12:\"delete-77428\";i:76670;s:12:\"delete-77429\";i:76671;s:12:\"delete-77431\";i:76672;s:12:\"delete-77432\";i:76673;s:12:\"delete-77433\";i:76674;s:12:\"delete-77436\";i:76675;s:12:\"delete-77434\";i:76676;s:12:\"delete-77435\";i:76677;s:12:\"delete-77437\";i:76678;s:12:\"delete-77438\";i:76679;s:12:\"delete-77439\";i:76680;s:12:\"delete-77442\";i:76681;s:12:\"delete-77444\";i:76682;s:12:\"delete-77440\";i:76683;s:12:\"delete-77441\";i:76684;s:12:\"delete-77443\";i:76685;s:12:\"delete-77445\";i:76686;s:12:\"delete-77448\";i:76687;s:12:\"delete-77450\";i:76688;s:12:\"delete-77446\";i:76689;s:12:\"delete-77447\";i:76690;s:12:\"delete-77449\";i:76691;s:12:\"delete-77451\";i:76692;s:12:\"delete-77454\";i:76693;s:12:\"delete-77456\";i:76694;s:12:\"delete-77452\";i:76695;s:12:\"delete-77453\";i:76696;s:12:\"delete-77455\";i:76697;s:12:\"delete-77457\";i:76698;s:12:\"delete-77458\";i:76699;s:12:\"delete-77459\";i:76700;s:12:\"delete-77461\";i:76701;s:12:\"delete-77460\";i:76702;s:12:\"delete-77462\";i:76703;s:12:\"delete-77463\";i:76704;s:12:\"delete-77466\";i:76705;s:12:\"delete-77468\";i:76706;s:12:\"delete-77464\";i:76707;s:12:\"delete-77465\";i:76708;s:12:\"delete-77467\";i:76709;s:12:\"delete-77469\";i:76710;s:12:\"delete-77472\";i:76711;s:12:\"delete-77474\";i:76712;s:12:\"delete-77470\";i:76713;s:12:\"delete-77471\";i:76714;s:12:\"delete-77473\";i:76715;s:12:\"delete-77475\";i:76716;s:12:\"delete-77478\";i:76717;s:12:\"delete-77480\";i:76718;s:12:\"delete-77476\";i:76719;s:12:\"delete-77477\";i:76720;s:12:\"delete-77479\";i:76721;s:12:\"delete-77481\";i:76722;s:12:\"delete-77484\";i:76723;s:12:\"delete-77486\";i:76724;s:12:\"delete-77482\";i:76725;s:12:\"delete-77483\";i:76726;s:12:\"delete-77485\";i:76727;s:12:\"delete-77487\";i:76728;s:12:\"delete-77490\";i:76729;s:12:\"delete-77492\";i:76730;s:12:\"delete-77488\";i:76731;s:12:\"delete-77489\";i:76732;s:12:\"delete-77491\";i:76733;s:12:\"delete-77493\";i:76734;s:12:\"delete-77496\";i:76735;s:12:\"delete-77498\";i:76736;s:12:\"delete-77494\";i:76737;s:12:\"delete-77495\";i:76738;s:12:\"delete-77497\";i:76739;s:12:\"delete-77499\";i:76740;s:12:\"delete-77502\";i:76741;s:12:\"delete-77504\";i:76742;s:12:\"delete-77500\";i:76743;s:12:\"delete-77501\";i:76744;s:12:\"delete-77503\";i:76745;s:12:\"delete-77505\";i:76746;s:12:\"delete-77508\";i:76747;s:12:\"delete-77510\";i:76748;s:12:\"delete-77506\";i:76749;s:12:\"delete-77507\";i:76750;s:12:\"delete-77509\";i:76751;s:12:\"delete-77511\";i:76752;s:12:\"delete-77514\";i:76753;s:12:\"delete-77516\";i:76754;s:12:\"delete-77512\";i:76755;s:12:\"delete-77513\";i:76756;s:12:\"delete-77515\";i:76757;s:12:\"delete-77517\";i:76758;s:12:\"delete-77520\";i:76759;s:12:\"delete-77522\";i:76760;s:12:\"delete-77518\";i:76761;s:12:\"delete-77519\";i:76762;s:12:\"delete-77521\";i:76763;s:12:\"delete-77523\";i:76764;s:12:\"delete-77526\";i:76765;s:12:\"delete-77528\";i:76766;s:12:\"delete-77524\";i:76767;s:12:\"delete-77525\";i:76768;s:12:\"delete-77527\";i:76769;s:12:\"delete-77529\";i:76770;s:12:\"delete-77532\";i:76771;s:12:\"delete-77534\";i:76772;s:12:\"delete-77530\";i:76773;s:12:\"delete-77531\";i:76774;s:12:\"delete-77533\";i:76775;s:12:\"delete-77535\";i:76776;s:12:\"delete-77538\";i:76777;s:12:\"delete-77536\";i:76778;s:12:\"delete-77537\";i:76779;s:12:\"delete-77539\";i:76780;s:12:\"delete-77540\";i:76781;s:12:\"delete-77541\";i:76782;s:12:\"delete-77544\";i:76783;s:12:\"delete-77546\";i:76784;s:12:\"delete-77542\";i:76785;s:12:\"delete-77543\";i:76786;s:12:\"delete-77545\";i:76787;s:12:\"delete-77547\";i:76788;s:12:\"delete-77550\";i:76789;s:12:\"delete-77552\";i:76790;s:12:\"delete-77548\";i:76791;s:12:\"delete-77549\";i:76792;s:12:\"delete-77551\";i:76793;s:12:\"delete-77553\";i:76794;s:12:\"delete-77556\";i:76795;s:12:\"delete-77558\";i:76796;s:12:\"delete-77554\";i:76797;s:12:\"delete-77555\";i:76798;s:12:\"delete-77557\";i:76799;s:12:\"delete-77559\";i:76800;s:12:\"delete-77562\";i:76801;s:12:\"delete-77560\";i:76802;s:12:\"delete-77561\";i:76803;s:12:\"delete-77563\";i:76804;s:12:\"delete-77564\";i:76805;s:12:\"delete-77565\";i:76806;s:12:\"delete-77568\";i:76807;s:12:\"delete-77566\";i:76808;s:12:\"delete-77567\";i:76809;s:12:\"delete-77569\";i:76810;s:12:\"delete-77570\";i:76811;s:12:\"delete-77571\";i:76812;s:12:\"delete-77574\";i:76813;s:12:\"delete-77572\";i:76814;s:12:\"delete-77573\";i:76815;s:12:\"delete-77575\";i:76816;s:12:\"delete-77576\";i:76817;s:12:\"delete-77577\";i:76818;s:12:\"delete-77580\";i:76819;s:12:\"delete-77578\";i:76820;s:12:\"delete-77579\";i:76821;s:12:\"delete-77581\";i:76822;s:12:\"delete-77582\";i:76823;s:12:\"delete-77583\";i:76824;s:12:\"delete-77586\";i:76825;s:12:\"delete-77588\";i:76826;s:12:\"delete-77584\";i:76827;s:12:\"delete-77585\";i:76828;s:12:\"delete-77587\";i:76829;s:12:\"delete-77589\";i:76830;s:12:\"delete-77592\";i:76831;s:12:\"delete-77594\";i:76832;s:12:\"delete-77590\";i:76833;s:12:\"delete-77591\";i:76834;s:12:\"delete-77593\";i:76835;s:12:\"delete-77595\";i:76836;s:12:\"delete-77598\";i:76837;s:12:\"delete-77596\";i:76838;s:12:\"delete-77597\";i:76839;s:12:\"delete-77599\";i:76840;s:12:\"delete-77600\";i:76841;s:12:\"delete-77601\";i:76842;s:12:\"delete-77604\";i:76843;s:12:\"delete-77602\";i:76844;s:12:\"delete-77603\";i:76845;s:12:\"delete-77605\";i:76846;s:12:\"delete-77606\";i:76847;s:12:\"delete-77607\";i:76848;s:12:\"delete-77610\";i:76849;s:12:\"delete-77608\";i:76850;s:12:\"delete-77609\";i:76851;s:12:\"delete-77611\";i:76852;s:12:\"delete-77612\";i:76853;s:12:\"delete-77613\";i:76854;s:12:\"delete-77616\";i:76855;s:12:\"delete-77614\";i:76856;s:12:\"delete-77615\";i:76857;s:12:\"delete-77617\";i:76858;s:12:\"delete-77618\";i:76859;s:12:\"delete-77619\";i:76860;s:12:\"delete-77622\";i:76861;s:12:\"delete-77624\";i:76862;s:12:\"delete-77620\";i:76863;s:12:\"delete-77621\";i:76864;s:12:\"delete-77623\";i:76865;s:12:\"delete-77625\";i:76866;s:12:\"delete-77628\";i:76867;s:12:\"delete-77626\";i:76868;s:12:\"delete-77627\";i:76869;s:12:\"delete-77629\";i:76870;s:12:\"delete-77630\";i:76871;s:12:\"delete-77631\";i:76872;s:12:\"delete-77634\";i:76873;s:12:\"delete-77636\";i:76874;s:12:\"delete-77632\";i:76875;s:12:\"delete-77633\";i:76876;s:12:\"delete-77635\";i:76877;s:12:\"delete-77637\";i:76878;s:12:\"delete-77640\";i:76879;s:12:\"delete-77638\";i:76880;s:12:\"delete-77639\";i:76881;s:12:\"delete-77641\";i:76882;s:12:\"delete-77642\";i:76883;s:12:\"delete-77643\";i:76884;s:12:\"delete-77646\";i:76885;s:12:\"delete-77644\";i:76886;s:12:\"delete-77645\";i:76887;s:12:\"delete-77647\";i:76888;s:12:\"delete-77648\";i:76889;s:12:\"delete-77649\";i:76890;s:12:\"delete-77652\";i:76891;s:12:\"delete-77650\";i:76892;s:12:\"delete-77651\";i:76893;s:12:\"delete-77653\";i:76894;s:12:\"delete-77654\";i:76895;s:12:\"delete-77655\";i:76896;s:12:\"delete-77658\";i:76897;s:12:\"delete-77656\";i:76898;s:12:\"delete-77657\";i:76899;s:12:\"delete-77659\";i:76900;s:12:\"delete-77660\";i:76901;s:12:\"delete-77661\";i:76902;s:12:\"delete-77664\";i:76903;s:12:\"delete-77662\";i:76904;s:12:\"delete-77663\";i:76905;s:12:\"delete-77665\";i:76906;s:12:\"delete-77666\";i:76907;s:12:\"delete-77668\";i:76908;s:12:\"delete-77669\";i:76909;s:12:\"delete-77667\";i:76910;s:12:\"delete-77670\";i:76911;s:12:\"delete-77672\";i:76912;s:12:\"delete-77673\";i:76913;s:12:\"delete-77676\";i:76914;s:12:\"delete-77678\";i:76915;s:12:\"delete-77671\";i:76916;s:12:\"delete-77674\";i:76917;s:12:\"delete-77675\";i:76918;s:12:\"delete-77677\";i:76919;s:12:\"delete-77679\";i:76920;s:12:\"delete-77682\";i:76921;s:12:\"delete-77680\";i:76922;s:12:\"delete-77681\";i:76923;s:12:\"delete-77683\";i:76924;s:12:\"delete-77684\";i:76925;s:12:\"delete-77685\";i:76926;s:12:\"delete-77686\";i:76927;s:12:\"delete-77687\";i:76928;s:12:\"delete-77689\";i:76929;s:12:\"delete-77688\";i:76930;s:12:\"delete-77690\";i:76931;s:12:\"delete-77691\";i:76932;s:12:\"delete-77694\";i:76933;s:12:\"delete-77692\";i:76934;s:12:\"delete-77693\";i:76935;s:12:\"delete-77695\";i:76936;s:12:\"delete-77696\";i:76937;s:12:\"delete-77697\";i:76938;s:12:\"delete-77700\";i:76939;s:12:\"delete-77698\";i:76940;s:12:\"delete-77699\";i:76941;s:12:\"delete-77701\";i:76942;s:12:\"delete-77702\";i:76943;s:12:\"delete-77703\";i:76944;s:12:\"delete-77706\";i:76945;s:12:\"delete-77708\";i:76946;s:12:\"delete-77704\";i:76947;s:12:\"delete-77705\";i:76948;s:12:\"delete-77707\";i:76949;s:12:\"delete-77709\";i:76950;s:12:\"delete-77712\";i:76951;s:12:\"delete-77714\";i:76952;s:12:\"delete-77710\";i:76953;s:12:\"delete-77711\";i:76954;s:12:\"delete-77713\";i:76955;s:12:\"delete-77715\";i:76956;s:12:\"delete-77718\";i:76957;s:12:\"delete-77720\";i:76958;s:12:\"delete-77716\";i:76959;s:12:\"delete-77717\";i:76960;s:12:\"delete-77719\";i:76961;s:12:\"delete-77721\";i:76962;s:12:\"delete-77722\";i:76963;s:12:\"delete-77723\";i:76964;s:12:\"delete-77724\";i:76965;s:12:\"delete-77726\";i:76966;s:12:\"delete-77727\";i:76967;s:12:\"delete-77730\";i:76968;s:12:\"delete-77725\";i:76969;s:12:\"delete-77728\";i:76970;s:12:\"delete-77729\";i:76971;s:12:\"delete-77731\";i:76972;s:12:\"delete-77732\";i:76973;s:12:\"delete-77733\";i:76974;s:12:\"delete-77736\";i:76975;s:12:\"delete-77734\";i:76976;s:12:\"delete-77735\";i:76977;s:12:\"delete-77737\";i:76978;s:12:\"delete-77738\";i:76979;s:12:\"delete-77739\";i:76980;s:12:\"delete-77742\";i:76981;s:12:\"delete-77740\";i:76982;s:12:\"delete-77741\";i:76983;s:12:\"delete-77743\";i:76984;s:12:\"delete-77744\";i:76985;s:12:\"delete-77745\";i:76986;s:12:\"delete-77748\";i:76987;s:12:\"delete-77746\";i:76988;s:12:\"delete-77747\";i:76989;s:12:\"delete-77749\";i:76990;s:12:\"delete-77750\";i:76991;s:12:\"delete-77751\";i:76992;s:12:\"delete-77754\";i:76993;s:12:\"delete-77752\";i:76994;s:12:\"delete-77753\";i:76995;s:12:\"delete-77755\";i:76996;s:12:\"delete-77756\";i:76997;s:12:\"delete-77757\";i:76998;s:12:\"delete-77760\";i:76999;s:12:\"delete-77762\";i:77000;s:12:\"delete-77758\";i:77001;s:12:\"delete-77759\";i:77002;s:12:\"delete-77761\";i:77003;s:12:\"delete-77763\";i:77004;s:12:\"delete-77766\";i:77005;s:12:\"delete-77764\";i:77006;s:12:\"delete-77765\";i:77007;s:12:\"delete-77767\";i:77008;s:12:\"delete-77768\";i:77009;s:12:\"delete-77769\";i:77010;s:12:\"delete-77772\";i:77011;s:12:\"delete-77770\";i:77012;s:12:\"delete-77771\";i:77013;s:12:\"delete-77773\";i:77014;s:12:\"delete-77774\";i:77015;s:12:\"delete-77775\";i:77016;s:12:\"delete-77778\";i:77017;s:12:\"delete-77776\";i:77018;s:12:\"delete-77777\";i:77019;s:12:\"delete-77779\";i:77020;s:12:\"delete-77780\";i:77021;s:12:\"delete-77781\";i:77022;s:12:\"delete-77784\";i:77023;s:12:\"delete-77782\";i:77024;s:12:\"delete-77783\";i:77025;s:12:\"delete-77785\";i:77026;s:12:\"delete-77786\";i:77027;s:12:\"delete-77787\";i:77028;s:12:\"delete-77790\";i:77029;s:12:\"delete-77792\";i:77030;s:12:\"delete-77788\";i:77031;s:12:\"delete-77789\";i:77032;s:12:\"delete-77791\";i:77033;s:12:\"delete-77793\";i:77034;s:12:\"delete-77796\";i:77035;s:12:\"delete-77794\";i:77036;s:12:\"delete-77795\";i:77037;s:12:\"delete-77797\";i:77038;s:12:\"delete-77798\";i:77039;s:12:\"delete-77799\";i:77040;s:12:\"delete-77802\";i:77041;s:12:\"delete-77800\";i:77042;s:12:\"delete-77801\";i:77043;s:12:\"delete-77803\";i:77044;s:12:\"delete-77804\";i:77045;s:12:\"delete-77805\";i:77046;s:12:\"delete-77806\";i:77047;s:12:\"delete-77807\";i:77048;s:12:\"delete-77809\";i:77049;s:12:\"delete-77808\";i:77050;s:12:\"delete-77810\";i:77051;s:12:\"delete-77811\";i:77052;s:12:\"delete-77812\";i:77053;s:12:\"delete-77813\";i:77054;s:12:\"delete-77815\";i:77055;s:12:\"delete-77814\";i:77056;s:12:\"delete-77816\";i:77057;s:12:\"delete-77817\";i:77058;s:12:\"delete-77820\";i:77059;s:12:\"delete-77818\";i:77060;s:12:\"delete-77819\";i:77061;s:12:\"delete-77821\";i:77062;s:12:\"delete-77822\";i:77063;s:12:\"delete-77823\";i:77064;s:12:\"delete-77826\";i:77065;s:12:\"delete-77828\";i:77066;s:12:\"delete-77824\";i:77067;s:12:\"delete-77825\";i:77068;s:12:\"delete-77827\";i:77069;s:12:\"delete-77829\";i:77070;s:12:\"delete-77832\";i:77071;s:12:\"delete-77834\";i:77072;s:12:\"delete-77830\";i:77073;s:12:\"delete-77831\";i:77074;s:12:\"delete-77833\";i:77075;s:12:\"delete-77835\";i:77076;s:12:\"delete-77838\";i:77077;s:12:\"delete-77840\";i:77078;s:12:\"delete-77836\";i:77079;s:12:\"delete-77837\";i:77080;s:12:\"delete-77839\";i:77081;s:12:\"delete-77841\";i:77082;s:12:\"delete-77844\";i:77083;s:12:\"delete-77846\";i:77084;s:12:\"delete-77847\";i:77085;s:12:\"delete-77850\";i:77086;s:12:\"delete-77852\";i:77087;s:12:\"delete-77842\";i:77088;s:12:\"delete-77843\";i:77089;s:12:\"delete-77845\";i:77090;s:12:\"delete-77848\";i:77091;s:12:\"delete-77849\";i:77092;s:12:\"delete-77851\";i:77093;s:12:\"delete-77853\";i:77094;s:12:\"delete-77856\";i:77095;s:12:\"delete-77854\";i:77096;s:12:\"delete-77855\";i:77097;s:12:\"delete-77857\";i:77098;s:12:\"delete-77858\";i:77099;s:12:\"delete-77859\";i:77100;s:12:\"delete-77862\";i:77101;s:12:\"delete-77860\";i:77102;s:12:\"delete-77861\";i:77103;s:12:\"delete-77863\";i:77104;s:12:\"delete-77864\";i:77105;s:12:\"delete-77865\";i:77106;s:12:\"delete-77868\";i:77107;s:12:\"delete-77866\";i:77108;s:12:\"delete-77867\";i:77109;s:12:\"delete-77869\";i:77110;s:12:\"delete-77870\";i:77111;s:12:\"delete-77871\";i:77112;s:12:\"delete-77874\";i:77113;s:12:\"delete-77872\";i:77114;s:12:\"delete-77873\";i:77115;s:12:\"delete-77875\";i:77116;s:12:\"delete-77876\";i:77117;s:12:\"delete-77877\";i:77118;s:12:\"delete-77880\";i:77119;s:12:\"delete-77878\";i:77120;s:12:\"delete-77879\";i:77121;s:12:\"delete-77881\";i:77122;s:12:\"delete-77882\";i:77123;s:12:\"delete-77883\";i:77124;s:12:\"delete-77886\";i:77125;s:12:\"delete-77888\";i:77126;s:12:\"delete-77884\";i:77127;s:12:\"delete-77885\";i:77128;s:12:\"delete-77887\";i:77129;s:12:\"delete-77889\";i:77130;s:12:\"delete-77892\";i:77131;s:12:\"delete-77894\";i:77132;s:12:\"delete-77890\";i:77133;s:12:\"delete-77891\";i:77134;s:12:\"delete-77893\";i:77135;s:12:\"delete-77895\";i:77136;s:12:\"delete-77898\";i:77137;s:12:\"delete-77900\";i:77138;s:12:\"delete-77901\";i:77139;s:12:\"delete-77896\";i:77140;s:12:\"delete-77897\";i:77141;s:12:\"delete-77899\";i:77142;s:12:\"delete-77902\";i:77143;s:12:\"delete-77903\";i:77144;s:12:\"delete-77905\";i:77145;s:12:\"delete-77904\";i:77146;s:12:\"delete-77906\";i:77147;s:12:\"delete-77907\";i:77148;s:12:\"delete-77910\";i:77149;s:12:\"delete-77912\";i:77150;s:12:\"delete-77908\";i:77151;s:12:\"delete-77909\";i:77152;s:12:\"delete-77911\";i:77153;s:12:\"delete-77913\";i:77154;s:12:\"delete-77916\";i:77155;s:12:\"delete-77914\";i:77156;s:12:\"delete-77915\";i:77157;s:12:\"delete-77917\";i:77158;s:12:\"delete-77918\";i:77159;s:12:\"delete-77919\";i:77160;s:12:\"delete-77922\";i:77161;s:12:\"delete-77920\";i:77162;s:12:\"delete-77921\";i:77163;s:12:\"delete-77923\";i:77164;s:12:\"delete-77924\";i:77165;s:12:\"delete-77925\";i:77166;s:12:\"delete-77926\";i:77167;s:12:\"delete-77927\";i:77168;s:12:\"delete-77929\";i:77169;s:12:\"delete-77928\";i:77170;s:12:\"delete-77930\";i:77171;s:12:\"delete-77931\";i:77172;s:12:\"delete-77934\";i:77173;s:12:\"delete-77932\";i:77174;s:12:\"delete-77933\";i:77175;s:12:\"delete-77935\";i:77176;s:12:\"delete-77936\";i:77177;s:12:\"delete-77937\";i:77178;s:12:\"delete-77940\";i:77179;s:12:\"delete-77942\";i:77180;s:12:\"delete-77938\";i:77181;s:12:\"delete-77939\";i:77182;s:12:\"delete-77941\";i:77183;s:12:\"delete-77943\";i:77184;s:12:\"delete-77946\";i:77185;s:12:\"delete-77948\";i:77186;s:12:\"delete-77944\";i:77187;s:12:\"delete-77945\";i:77188;s:12:\"delete-77947\";i:77189;s:12:\"delete-77949\";i:77190;s:12:\"delete-77952\";i:77191;s:12:\"delete-77954\";i:77192;s:12:\"delete-77950\";i:77193;s:12:\"delete-77951\";i:77194;s:12:\"delete-77953\";i:77195;s:12:\"delete-77955\";i:77196;s:12:\"delete-77958\";i:77197;s:12:\"delete-77960\";i:77198;s:12:\"delete-77956\";i:77199;s:12:\"delete-77957\";i:77200;s:12:\"delete-77959\";i:77201;s:12:\"delete-77961\";i:77202;s:12:\"delete-77964\";i:77203;s:12:\"delete-77962\";i:77204;s:12:\"delete-77963\";i:77205;s:12:\"delete-77965\";i:77206;s:12:\"delete-77966\";i:77207;s:12:\"delete-77967\";i:77208;s:12:\"delete-77970\";i:77209;s:12:\"delete-77972\";i:77210;s:12:\"delete-77968\";i:77211;s:12:\"delete-77969\";i:77212;s:12:\"delete-77971\";i:77213;s:12:\"delete-77973\";i:77214;s:12:\"delete-77976\";i:77215;s:12:\"delete-77978\";i:77216;s:12:\"delete-77974\";i:77217;s:12:\"delete-77975\";i:77218;s:12:\"delete-77977\";i:77219;s:12:\"delete-77979\";i:77220;s:12:\"delete-77982\";i:77221;s:12:\"delete-77980\";i:77222;s:12:\"delete-77981\";i:77223;s:12:\"delete-77983\";i:77224;s:12:\"delete-77984\";i:77225;s:12:\"delete-77985\";i:77226;s:12:\"delete-77986\";i:77227;s:12:\"delete-77987\";i:77228;s:12:\"delete-77989\";i:77229;s:12:\"delete-77988\";i:77230;s:12:\"delete-77990\";i:77231;s:12:\"delete-77991\";i:77232;s:12:\"delete-77994\";i:77233;s:12:\"delete-77992\";i:77234;s:12:\"delete-77993\";i:77235;s:12:\"delete-77995\";i:77236;s:12:\"delete-77996\";i:77237;s:12:\"delete-77997\";i:77238;s:12:\"delete-78000\";i:77239;s:12:\"delete-78002\";i:77240;s:12:\"delete-77998\";i:77241;s:12:\"delete-77999\";i:77242;s:12:\"delete-78001\";i:77243;s:12:\"delete-78003\";i:77244;s:12:\"delete-78006\";i:77245;s:12:\"delete-78008\";i:77246;s:12:\"delete-78004\";i:77247;s:12:\"delete-78005\";i:77248;s:12:\"delete-78007\";i:77249;s:12:\"delete-78009\";i:77250;s:12:\"delete-78012\";i:77251;s:12:\"delete-78010\";i:77252;s:12:\"delete-78011\";i:77253;s:12:\"delete-78013\";i:77254;s:12:\"delete-78014\";i:77255;s:12:\"delete-78015\";i:77256;s:12:\"delete-78018\";i:77257;s:12:\"delete-78016\";i:77258;s:12:\"delete-78017\";i:77259;s:12:\"delete-78019\";i:77260;s:12:\"delete-78020\";i:77261;s:12:\"delete-78021\";i:77262;s:12:\"delete-78024\";i:77263;s:12:\"delete-78026\";i:77264;s:12:\"delete-78022\";i:77265;s:12:\"delete-78023\";i:77266;s:12:\"delete-78025\";i:77267;s:12:\"delete-78027\";i:77268;s:12:\"delete-78030\";i:77269;s:12:\"delete-78032\";i:77270;s:12:\"delete-78028\";i:77271;s:12:\"delete-78029\";i:77272;s:12:\"delete-78031\";i:77273;s:12:\"delete-78033\";i:77274;s:12:\"delete-78036\";i:77275;s:12:\"delete-78034\";i:77276;s:12:\"delete-78035\";i:77277;s:12:\"delete-78037\";i:77278;s:12:\"delete-78038\";i:77279;s:12:\"delete-78039\";i:77280;s:12:\"delete-78042\";i:77281;s:12:\"delete-78040\";i:77282;s:12:\"delete-78041\";i:77283;s:12:\"delete-78043\";i:77284;s:12:\"delete-78044\";i:77285;s:12:\"delete-78045\";i:77286;s:12:\"delete-78048\";i:77287;s:12:\"delete-78050\";i:77288;s:12:\"delete-78046\";i:77289;s:12:\"delete-78047\";i:77290;s:12:\"delete-78049\";i:77291;s:12:\"delete-78051\";i:77292;s:12:\"delete-78054\";i:77293;s:12:\"delete-78056\";i:77294;s:12:\"delete-78052\";i:77295;s:12:\"delete-78053\";i:77296;s:12:\"delete-78055\";i:77297;s:12:\"delete-78057\";i:77298;s:12:\"delete-78060\";i:77299;s:12:\"delete-78062\";i:77300;s:12:\"delete-78058\";i:77301;s:12:\"delete-78059\";i:77302;s:12:\"delete-78061\";i:77303;s:12:\"delete-78063\";i:77304;s:12:\"delete-78066\";i:77305;s:12:\"delete-78068\";i:77306;s:12:\"delete-78064\";i:77307;s:12:\"delete-78065\";i:77308;s:12:\"delete-78067\";i:77309;s:12:\"delete-78069\";i:77310;s:12:\"delete-78072\";i:77311;s:12:\"delete-78074\";i:77312;s:12:\"delete-78070\";i:77313;s:12:\"delete-78071\";i:77314;s:12:\"delete-78073\";i:77315;s:12:\"delete-78075\";i:77316;s:12:\"delete-78078\";i:77317;s:12:\"delete-78080\";i:77318;s:12:\"delete-78076\";i:77319;s:12:\"delete-78077\";i:77320;s:12:\"delete-78079\";i:77321;s:12:\"delete-78081\";i:77322;s:12:\"delete-78084\";i:77323;s:12:\"delete-78086\";i:77324;s:12:\"delete-78087\";i:77325;s:12:\"delete-78090\";i:77326;s:12:\"delete-78092\";i:77327;s:12:\"delete-78082\";i:77328;s:12:\"delete-78083\";i:77329;s:12:\"delete-78085\";i:77330;s:12:\"delete-78088\";i:77331;s:12:\"delete-78089\";i:77332;s:12:\"delete-78091\";i:77333;s:12:\"delete-78093\";i:77334;s:12:\"delete-78096\";i:77335;s:12:\"delete-78094\";i:77336;s:12:\"delete-78095\";i:77337;s:12:\"delete-78097\";i:77338;s:12:\"delete-78098\";i:77339;s:12:\"delete-78099\";i:77340;s:12:\"delete-78102\";i:77341;s:12:\"delete-78100\";i:77342;s:12:\"delete-78101\";i:77343;s:12:\"delete-78103\";i:77344;s:12:\"delete-78104\";i:77345;s:12:\"delete-78105\";i:77346;s:12:\"delete-78106\";i:77347;s:12:\"delete-78107\";i:77348;s:12:\"delete-78108\";i:77349;s:12:\"delete-78110\";i:77350;s:12:\"delete-78111\";i:77351;s:12:\"delete-78114\";i:77352;s:12:\"delete-78116\";i:77353;s:12:\"delete-78109\";i:77354;s:12:\"delete-78112\";i:77355;s:12:\"delete-78113\";i:77356;s:12:\"delete-78115\";i:77357;s:12:\"delete-78117\";i:77358;s:12:\"delete-78120\";i:77359;s:12:\"delete-78122\";i:77360;s:12:\"delete-78118\";i:77361;s:12:\"delete-78119\";i:77362;s:12:\"delete-78121\";i:77363;s:12:\"delete-78123\";i:77364;s:12:\"delete-78126\";i:77365;s:12:\"delete-78128\";i:77366;s:12:\"delete-78124\";i:77367;s:12:\"delete-78125\";i:77368;s:12:\"delete-78127\";i:77369;s:12:\"delete-78129\";i:77370;s:12:\"delete-78132\";i:77371;s:12:\"delete-78134\";i:77372;s:12:\"delete-78130\";i:77373;s:12:\"delete-78131\";i:77374;s:12:\"delete-78133\";i:77375;s:12:\"delete-78135\";i:77376;s:12:\"delete-78136\";i:77377;s:12:\"delete-78137\";i:77378;s:12:\"delete-78138\";i:77379;s:12:\"delete-78140\";i:77380;s:12:\"delete-78141\";i:77381;s:12:\"delete-78144\";i:77382;s:12:\"delete-78139\";i:77383;s:12:\"delete-78142\";i:77384;s:12:\"delete-78143\";i:77385;s:12:\"delete-78145\";i:77386;s:12:\"delete-78146\";i:77387;s:12:\"delete-78147\";i:77388;s:12:\"delete-78150\";i:77389;s:12:\"delete-78148\";i:77390;s:12:\"delete-78149\";i:77391;s:12:\"delete-78151\";i:77392;s:12:\"delete-78152\";i:77393;s:12:\"delete-78153\";i:77394;s:12:\"delete-78156\";i:77395;s:12:\"delete-78154\";i:77396;s:12:\"delete-78155\";i:77397;s:12:\"delete-78157\";i:77398;s:12:\"delete-78158\";i:77399;s:12:\"delete-78159\";i:77400;s:12:\"delete-78162\";i:77401;s:12:\"delete-78160\";i:77402;s:12:\"delete-78161\";i:77403;s:12:\"delete-78163\";i:77404;s:12:\"delete-78164\";i:77405;s:12:\"delete-78165\";i:77406;s:12:\"delete-78168\";i:77407;s:12:\"delete-78166\";i:77408;s:12:\"delete-78167\";i:77409;s:12:\"delete-78169\";i:77410;s:12:\"delete-78170\";i:77411;s:12:\"delete-78171\";i:77412;s:12:\"delete-78174\";i:77413;s:12:\"delete-78176\";i:77414;s:12:\"delete-78172\";i:77415;s:12:\"delete-78173\";i:77416;s:12:\"delete-78175\";i:77417;s:12:\"delete-78177\";i:77418;s:12:\"delete-78180\";i:77419;s:12:\"delete-78182\";i:77420;s:12:\"delete-78178\";i:77421;s:12:\"delete-78179\";i:77422;s:12:\"delete-78181\";i:77423;s:12:\"delete-78183\";i:77424;s:12:\"delete-78186\";i:77425;s:12:\"delete-78188\";i:77426;s:12:\"delete-78184\";i:77427;s:12:\"delete-78185\";i:77428;s:12:\"delete-78187\";i:77429;s:12:\"delete-78189\";i:77430;s:12:\"delete-78190\";i:77431;s:12:\"delete-78191\";i:77432;s:12:\"delete-78192\";i:77433;s:12:\"delete-78194\";i:77434;s:12:\"delete-78195\";i:77435;s:12:\"delete-78198\";i:77436;s:12:\"delete-78193\";i:77437;s:12:\"delete-78196\";i:77438;s:12:\"delete-78197\";i:77439;s:12:\"delete-78199\";i:77440;s:12:\"delete-78200\";i:77441;s:12:\"delete-78201\";i:77442;s:12:\"delete-78204\";i:77443;s:12:\"delete-78202\";i:77444;s:12:\"delete-78203\";i:77445;s:12:\"delete-78205\";i:77446;s:12:\"delete-78206\";i:77447;s:12:\"delete-78207\";i:77448;s:12:\"delete-78210\";i:77449;s:12:\"delete-78208\";i:77450;s:12:\"delete-78209\";i:77451;s:12:\"delete-78211\";i:77452;s:12:\"delete-78212\";i:77453;s:12:\"delete-78213\";i:77454;s:12:\"delete-78216\";i:77455;s:12:\"delete-78214\";i:77456;s:12:\"delete-78215\";i:77457;s:12:\"delete-78217\";i:77458;s:12:\"delete-78218\";i:77459;s:12:\"delete-78219\";i:77460;s:12:\"delete-78222\";i:77461;s:12:\"delete-78220\";i:77462;s:12:\"delete-78221\";i:77463;s:12:\"delete-78223\";i:77464;s:12:\"delete-78224\";i:77465;s:12:\"delete-78225\";i:77466;s:12:\"delete-78228\";i:77467;s:12:\"delete-78226\";i:77468;s:12:\"delete-78227\";i:77469;s:12:\"delete-78229\";i:77470;s:12:\"delete-78230\";i:77471;s:12:\"delete-78231\";i:77472;s:12:\"delete-78234\";i:77473;s:12:\"delete-78232\";i:77474;s:12:\"delete-78233\";i:77475;s:12:\"delete-78235\";i:77476;s:12:\"delete-78236\";i:77477;s:12:\"delete-78237\";i:77478;s:12:\"delete-78240\";i:77479;s:12:\"delete-78242\";i:77480;s:12:\"delete-78238\";i:77481;s:12:\"delete-78239\";i:77482;s:12:\"delete-78241\";i:77483;s:12:\"delete-78243\";i:77484;s:12:\"delete-78246\";i:77485;s:12:\"delete-78248\";i:77486;s:12:\"delete-78244\";i:77487;s:12:\"delete-78245\";i:77488;s:12:\"delete-78247\";i:77489;s:12:\"delete-78249\";i:77490;s:12:\"delete-78252\";i:77491;s:12:\"delete-78250\";i:77492;s:12:\"delete-78251\";i:77493;s:12:\"delete-78253\";i:77494;s:12:\"delete-78254\";i:77495;s:12:\"delete-78255\";i:77496;s:12:\"delete-78258\";i:77497;s:12:\"delete-78256\";i:77498;s:12:\"delete-78257\";i:77499;s:12:\"delete-78259\";i:77500;s:12:\"delete-78260\";i:77501;s:12:\"delete-78261\";i:77502;s:12:\"delete-78264\";i:77503;s:12:\"delete-78266\";i:77504;s:12:\"delete-78267\";i:77505;s:12:\"delete-78270\";i:77506;s:12:\"delete-78272\";i:77507;s:12:\"delete-78262\";i:77508;s:12:\"delete-78263\";i:77509;s:12:\"delete-78265\";i:77510;s:12:\"delete-78268\";i:77511;s:12:\"delete-78269\";i:77512;s:12:\"delete-78271\";i:77513;s:12:\"delete-78273\";i:77514;s:12:\"delete-78276\";i:77515;s:12:\"delete-78278\";i:77516;s:12:\"delete-78274\";i:77517;s:12:\"delete-78275\";i:77518;s:12:\"delete-78277\";i:77519;s:12:\"delete-78279\";i:77520;s:12:\"delete-78282\";i:77521;s:12:\"delete-78284\";i:77522;s:12:\"delete-78280\";i:77523;s:12:\"delete-78281\";i:77524;s:12:\"delete-78283\";i:77525;s:12:\"delete-78285\";i:77526;s:12:\"delete-78288\";i:77527;s:12:\"delete-78286\";i:77528;s:12:\"delete-78287\";i:77529;s:12:\"delete-78289\";i:77530;s:12:\"delete-78290\";i:77531;s:12:\"delete-78291\";i:77532;s:12:\"delete-78294\";i:77533;s:12:\"delete-78296\";i:77534;s:12:\"delete-78292\";i:77535;s:12:\"delete-78293\";i:77536;s:12:\"delete-78295\";i:77537;s:12:\"delete-78297\";i:77538;s:12:\"delete-78300\";i:77539;s:12:\"delete-78302\";i:77540;s:12:\"delete-78298\";i:77541;s:12:\"delete-78299\";i:77542;s:12:\"delete-78301\";i:77543;s:12:\"delete-78303\";i:77544;s:12:\"delete-78306\";i:77545;s:12:\"delete-78304\";i:77546;s:12:\"delete-78305\";i:77547;s:12:\"delete-78307\";i:77548;s:12:\"delete-78308\";i:77549;s:12:\"delete-78309\";i:77550;s:12:\"delete-78310\";i:77551;s:12:\"delete-78311\";i:77552;s:12:\"delete-78312\";i:77553;s:12:\"delete-78314\";i:77554;s:12:\"delete-78315\";i:77555;s:12:\"delete-78318\";i:77556;s:12:\"delete-78313\";i:77557;s:12:\"delete-78316\";i:77558;s:12:\"delete-78317\";i:77559;s:12:\"delete-78319\";i:77560;s:12:\"delete-78320\";i:77561;s:12:\"delete-78321\";i:77562;s:12:\"delete-78324\";i:77563;s:12:\"delete-78322\";i:77564;s:12:\"delete-78323\";i:77565;s:12:\"delete-78325\";i:77566;s:12:\"delete-78326\";i:77567;s:12:\"delete-78327\";i:77568;s:12:\"delete-78330\";i:77569;s:12:\"delete-78328\";i:77570;s:12:\"delete-78329\";i:77571;s:12:\"delete-78331\";i:77572;s:12:\"delete-78332\";i:77573;s:12:\"delete-78333\";i:77574;s:12:\"delete-78336\";i:77575;s:12:\"delete-78334\";i:77576;s:12:\"delete-78335\";i:77577;s:12:\"delete-78337\";i:77578;s:12:\"delete-78338\";i:77579;s:12:\"delete-78339\";i:77580;s:12:\"delete-78342\";i:77581;s:12:\"delete-78340\";i:77582;s:12:\"delete-78341\";i:77583;s:12:\"delete-78343\";i:77584;s:12:\"delete-78344\";i:77585;s:12:\"delete-78345\";i:77586;s:12:\"delete-78348\";i:77587;s:12:\"delete-78350\";i:77588;s:12:\"delete-78346\";i:77589;s:12:\"delete-78347\";i:77590;s:12:\"delete-78349\";i:77591;s:12:\"delete-78351\";i:77592;s:12:\"delete-78354\";i:77593;s:12:\"delete-78356\";i:77594;s:12:\"delete-78352\";i:77595;s:12:\"delete-78353\";i:77596;s:12:\"delete-78355\";i:77597;s:12:\"delete-78357\";i:77598;s:12:\"delete-78360\";i:77599;s:12:\"delete-78358\";i:77600;s:12:\"delete-78359\";i:77601;s:12:\"delete-78361\";i:77602;s:12:\"delete-78362\";i:77603;s:12:\"delete-78363\";i:77604;s:12:\"delete-78366\";i:77605;s:12:\"delete-78368\";i:77606;s:12:\"delete-78364\";i:77607;s:12:\"delete-78365\";i:77608;s:12:\"delete-78367\";i:77609;s:12:\"delete-78369\";i:77610;s:12:\"delete-78370\";i:77611;s:12:\"delete-78371\";i:77612;s:12:\"delete-78372\";i:77613;s:12:\"delete-78374\";i:77614;s:12:\"delete-78375\";i:77615;s:12:\"delete-78378\";i:77616;s:12:\"delete-78373\";i:77617;s:12:\"delete-78376\";i:77618;s:12:\"delete-78377\";i:77619;s:12:\"delete-78379\";i:77620;s:12:\"delete-78380\";i:77621;s:12:\"delete-78381\";i:77622;s:12:\"delete-78384\";i:77623;s:12:\"delete-78382\";i:77624;s:12:\"delete-78383\";i:77625;s:12:\"delete-78385\";i:77626;s:12:\"delete-78386\";i:77627;s:12:\"delete-78387\";i:77628;s:12:\"delete-78390\";i:77629;s:12:\"delete-78388\";i:77630;s:12:\"delete-78389\";i:77631;s:12:\"delete-78391\";i:77632;s:12:\"delete-78392\";i:77633;s:12:\"delete-78393\";i:77634;s:12:\"delete-78396\";i:77635;s:12:\"delete-78394\";i:77636;s:12:\"delete-78395\";i:77637;s:12:\"delete-78397\";i:77638;s:12:\"delete-78398\";i:77639;s:12:\"delete-78399\";i:77640;s:12:\"delete-78402\";i:77641;s:12:\"delete-78400\";i:77642;s:12:\"delete-78401\";i:77643;s:12:\"delete-78403\";i:77644;s:12:\"delete-78404\";i:77645;s:12:\"delete-78405\";i:77646;s:12:\"delete-78408\";i:77647;s:12:\"delete-78406\";i:77648;s:12:\"delete-78407\";i:77649;s:12:\"delete-78409\";i:77650;s:12:\"delete-78410\";i:77651;s:12:\"delete-78411\";i:77652;s:12:\"delete-78414\";i:77653;s:12:\"delete-78412\";i:77654;s:12:\"delete-78413\";i:77655;s:12:\"delete-78415\";i:77656;s:12:\"delete-78416\";i:77657;s:12:\"delete-78417\";i:77658;s:12:\"delete-78420\";i:77659;s:12:\"delete-78422\";i:77660;s:12:\"delete-78418\";i:77661;s:12:\"delete-78419\";i:77662;s:12:\"delete-78421\";i:77663;s:12:\"delete-78423\";i:77664;s:12:\"delete-78426\";i:77665;s:12:\"delete-78428\";i:77666;s:12:\"delete-78424\";i:77667;s:12:\"delete-78425\";i:77668;s:12:\"delete-78427\";i:77669;s:12:\"delete-78429\";i:77670;s:12:\"delete-78432\";i:77671;s:12:\"delete-78434\";i:77672;s:12:\"delete-78430\";i:77673;s:12:\"delete-78431\";i:77674;s:12:\"delete-78433\";i:77675;s:12:\"delete-78435\";i:77676;s:12:\"delete-78438\";i:77677;s:12:\"delete-78436\";i:77678;s:12:\"delete-78437\";i:77679;s:12:\"delete-78439\";i:77680;s:12:\"delete-78440\";i:77681;s:12:\"delete-78441\";i:77682;s:12:\"delete-78444\";i:77683;s:12:\"delete-78446\";i:77684;s:12:\"delete-78447\";i:77685;s:12:\"delete-78450\";i:77686;s:12:\"delete-78442\";i:77687;s:12:\"delete-78443\";i:77688;s:12:\"delete-78445\";i:77689;s:12:\"delete-78448\";i:77690;s:12:\"delete-78449\";i:77691;s:12:\"delete-78451\";i:77692;s:12:\"delete-78452\";i:77693;s:12:\"delete-78453\";i:77694;s:12:\"delete-78456\";i:77695;s:12:\"delete-78454\";i:77696;s:12:\"delete-78455\";i:77697;s:12:\"delete-78457\";i:77698;s:12:\"delete-78458\";i:77699;s:12:\"delete-78459\";i:77700;s:12:\"delete-78462\";i:77701;s:12:\"delete-78460\";i:77702;s:12:\"delete-78461\";i:77703;s:12:\"delete-78463\";i:77704;s:12:\"delete-78464\";i:77705;s:12:\"delete-78465\";i:77706;s:12:\"delete-78468\";i:77707;s:12:\"delete-78466\";i:77708;s:12:\"delete-78467\";i:77709;s:12:\"delete-78469\";i:77710;s:12:\"delete-78470\";i:77711;s:12:\"delete-78471\";i:77712;s:12:\"delete-78474\";i:77713;s:12:\"delete-78476\";i:77714;s:12:\"delete-78472\";i:77715;s:12:\"delete-78473\";i:77716;s:12:\"delete-78475\";i:77717;s:12:\"delete-78477\";i:77718;s:12:\"delete-78478\";i:77719;s:12:\"delete-78479\";i:77720;s:12:\"delete-78481\";i:77721;s:12:\"delete-78480\";i:77722;s:12:\"delete-78482\";i:77723;s:12:\"delete-78483\";i:77724;s:12:\"delete-78486\";i:77725;s:12:\"delete-78488\";i:77726;s:12:\"delete-78484\";i:77727;s:12:\"delete-78485\";i:77728;s:12:\"delete-78487\";i:77729;s:12:\"delete-78489\";i:77730;s:12:\"delete-78492\";i:77731;s:12:\"delete-78490\";i:77732;s:12:\"delete-78491\";i:77733;s:12:\"delete-78493\";i:77734;s:12:\"delete-78494\";i:77735;s:12:\"delete-78495\";i:77736;s:12:\"delete-78496\";i:77737;s:12:\"delete-78497\";i:77738;s:12:\"delete-78498\";i:77739;s:12:\"delete-78500\";i:77740;s:12:\"delete-78501\";i:77741;s:12:\"delete-78504\";i:77742;s:12:\"delete-78499\";i:77743;s:12:\"delete-78502\";i:77744;s:12:\"delete-78503\";i:77745;s:12:\"delete-78505\";i:77746;s:12:\"delete-78506\";i:77747;s:12:\"delete-78507\";i:77748;s:12:\"delete-78510\";i:77749;s:12:\"delete-78508\";i:77750;s:12:\"delete-78509\";i:77751;s:12:\"delete-78511\";i:77752;s:12:\"delete-78512\";i:77753;s:12:\"delete-78513\";i:77754;s:12:\"delete-78516\";i:77755;s:12:\"delete-78518\";i:77756;s:12:\"delete-78514\";i:77757;s:12:\"delete-78515\";i:77758;s:12:\"delete-78517\";i:77759;s:12:\"delete-78519\";i:77760;s:12:\"delete-78522\";i:77761;s:12:\"delete-78524\";i:77762;s:12:\"delete-78520\";i:77763;s:12:\"delete-78521\";i:77764;s:12:\"delete-78523\";i:77765;s:12:\"delete-78525\";i:77766;s:12:\"delete-78528\";i:77767;s:12:\"delete-78526\";i:77768;s:12:\"delete-78527\";i:77769;s:12:\"delete-78529\";i:77770;s:12:\"delete-78530\";i:77771;s:12:\"delete-78531\";i:77772;s:12:\"delete-78534\";i:77773;s:12:\"delete-78532\";i:77774;s:12:\"delete-78533\";i:77775;s:12:\"delete-78535\";i:77776;s:12:\"delete-78536\";i:77777;s:12:\"delete-78537\";i:77778;s:12:\"delete-78540\";i:77779;s:12:\"delete-78542\";i:77780;s:12:\"delete-78538\";i:77781;s:12:\"delete-78539\";i:77782;s:12:\"delete-78541\";i:77783;s:12:\"delete-78543\";i:77784;s:12:\"delete-78546\";i:77785;s:12:\"delete-78548\";i:77786;s:12:\"delete-78544\";i:77787;s:12:\"delete-78545\";i:77788;s:12:\"delete-78547\";i:77789;s:12:\"delete-78549\";i:77790;s:12:\"delete-78552\";i:77791;s:12:\"delete-78554\";i:77792;s:12:\"delete-78550\";i:77793;s:12:\"delete-78551\";i:77794;s:12:\"delete-78553\";i:77795;s:12:\"delete-78555\";i:77796;s:12:\"delete-78558\";i:77797;s:12:\"delete-78560\";i:77798;s:12:\"delete-78561\";i:77799;s:12:\"delete-78556\";i:77800;s:12:\"delete-78557\";i:77801;s:12:\"delete-78559\";i:77802;s:12:\"delete-78562\";i:77803;s:12:\"delete-78563\";i:77804;s:12:\"delete-78564\";i:77805;s:12:\"delete-78566\";i:77806;s:12:\"delete-78565\";i:77807;s:12:\"delete-78568\";i:77808;s:12:\"delete-78569\";i:77809;s:12:\"delete-78567\";i:77810;s:12:\"delete-78570\";i:77811;s:12:\"delete-78572\";i:77812;s:12:\"delete-78573\";i:77813;s:12:\"delete-78576\";i:77814;s:12:\"delete-78571\";i:77815;s:12:\"delete-78574\";i:77816;s:12:\"delete-78575\";i:77817;s:12:\"delete-78577\";i:77818;s:12:\"delete-78578\";i:77819;s:12:\"delete-78579\";i:77820;s:12:\"delete-78582\";i:77821;s:12:\"delete-78580\";i:77822;s:12:\"delete-78581\";i:77823;s:12:\"delete-78583\";i:77824;s:12:\"delete-78584\";i:77825;s:12:\"delete-78585\";i:77826;s:12:\"delete-78588\";i:77827;s:12:\"delete-78586\";i:77828;s:12:\"delete-78587\";i:77829;s:12:\"delete-78589\";i:77830;s:12:\"delete-78590\";i:77831;s:12:\"delete-78591\";i:77832;s:12:\"delete-78594\";i:77833;s:12:\"delete-78592\";i:77834;s:12:\"delete-78593\";i:77835;s:12:\"delete-78595\";i:77836;s:12:\"delete-78596\";i:77837;s:12:\"delete-78597\";i:77838;s:12:\"delete-78600\";i:77839;s:12:\"delete-78602\";i:77840;s:12:\"delete-78598\";i:77841;s:12:\"delete-78599\";i:77842;s:12:\"delete-78601\";i:77843;s:12:\"delete-78603\";i:77844;s:12:\"delete-78606\";i:77845;s:12:\"delete-78608\";i:77846;s:12:\"delete-78604\";i:77847;s:12:\"delete-78605\";i:77848;s:12:\"delete-78607\";i:77849;s:12:\"delete-78609\";i:77850;s:12:\"delete-78612\";i:77851;s:12:\"delete-78610\";i:77852;s:12:\"delete-78611\";i:77853;s:12:\"delete-78613\";i:77854;s:12:\"delete-78614\";i:77855;s:12:\"delete-78615\";i:77856;s:12:\"delete-78618\";i:77857;s:12:\"delete-78616\";i:77858;s:12:\"delete-78617\";i:77859;s:12:\"delete-78619\";i:77860;s:12:\"delete-78620\";i:77861;s:12:\"delete-78621\";i:77862;s:12:\"delete-78622\";i:77863;s:12:\"delete-78623\";i:77864;s:12:\"delete-78624\";i:77865;s:12:\"delete-78626\";i:77866;s:12:\"delete-78627\";i:77867;s:12:\"delete-78630\";i:77868;s:12:\"delete-78632\";i:77869;s:12:\"delete-78625\";i:77870;s:12:\"delete-78628\";i:77871;s:12:\"delete-78629\";i:77872;s:12:\"delete-78631\";i:77873;s:12:\"delete-78633\";i:77874;s:12:\"delete-78636\";i:77875;s:12:\"delete-78638\";i:77876;s:12:\"delete-78634\";i:77877;s:12:\"delete-78635\";i:77878;s:12:\"delete-78637\";i:77879;s:12:\"delete-78639\";i:77880;s:12:\"delete-78642\";i:77881;s:12:\"delete-78640\";i:77882;s:12:\"delete-78641\";i:77883;s:12:\"delete-78643\";i:77884;s:12:\"delete-78644\";i:77885;s:12:\"delete-78645\";i:77886;s:12:\"delete-78648\";i:77887;s:12:\"delete-78646\";i:77888;s:12:\"delete-78647\";i:77889;s:12:\"delete-78649\";i:77890;s:12:\"delete-78650\";i:77891;s:12:\"delete-78651\";i:77892;s:12:\"delete-78654\";i:77893;s:12:\"delete-78652\";i:77894;s:12:\"delete-78653\";i:77895;s:12:\"delete-78655\";i:77896;s:12:\"delete-78656\";i:77897;s:12:\"delete-78657\";i:77898;s:12:\"delete-78660\";i:77899;s:12:\"delete-78662\";i:77900;s:12:\"delete-78658\";i:77901;s:12:\"delete-78659\";i:77902;s:12:\"delete-78661\";i:77903;s:12:\"delete-78663\";i:77904;s:12:\"delete-78666\";i:77905;s:12:\"delete-78664\";i:77906;s:12:\"delete-78665\";i:77907;s:12:\"delete-78667\";i:77908;s:12:\"delete-78668\";i:77909;s:12:\"delete-78669\";i:77910;s:12:\"delete-78672\";i:77911;s:12:\"delete-78670\";i:77912;s:12:\"delete-78671\";i:77913;s:12:\"delete-78673\";i:77914;s:12:\"delete-78674\";i:77915;s:12:\"delete-78675\";i:77916;s:12:\"delete-78676\";i:77917;s:12:\"delete-78677\";i:77918;s:12:\"delete-78678\";i:77919;s:12:\"delete-78680\";i:77920;s:12:\"delete-78681\";i:77921;s:12:\"delete-78684\";i:77922;s:12:\"delete-78686\";i:77923;s:12:\"delete-78679\";i:77924;s:12:\"delete-78682\";i:77925;s:12:\"delete-78683\";i:77926;s:12:\"delete-78685\";i:77927;s:12:\"delete-78687\";i:77928;s:12:\"delete-78690\";i:77929;s:12:\"delete-78688\";i:77930;s:12:\"delete-78689\";i:77931;s:12:\"delete-78691\";i:77932;s:12:\"delete-78692\";i:77933;s:12:\"delete-78693\";i:77934;s:12:\"delete-78694\";i:77935;s:12:\"delete-78695\";i:77936;s:12:\"delete-78696\";i:77937;s:12:\"delete-78698\";i:77938;s:12:\"delete-78699\";i:77939;s:12:\"delete-78702\";i:77940;s:12:\"delete-78697\";i:77941;s:12:\"delete-78700\";i:77942;s:12:\"delete-78701\";i:77943;s:12:\"delete-78703\";i:77944;s:12:\"delete-78704\";i:77945;s:12:\"delete-78705\";i:77946;s:12:\"delete-78708\";i:77947;s:12:\"delete-78706\";i:77948;s:12:\"delete-78707\";i:77949;s:12:\"delete-78709\";i:77950;s:12:\"delete-78710\";i:77951;s:12:\"delete-78711\";i:77952;s:12:\"delete-78714\";i:77953;s:12:\"delete-78712\";i:77954;s:12:\"delete-78713\";i:77955;s:12:\"delete-78715\";i:77956;s:12:\"delete-78716\";i:77957;s:12:\"delete-78717\";i:77958;s:12:\"delete-78720\";i:77959;s:12:\"delete-78718\";i:77960;s:12:\"delete-78719\";i:77961;s:12:\"delete-78721\";i:77962;s:12:\"delete-78722\";i:77963;s:12:\"delete-78723\";i:77964;s:12:\"delete-78726\";i:77965;s:12:\"delete-78728\";i:77966;s:12:\"delete-78724\";i:77967;s:12:\"delete-78725\";i:77968;s:12:\"delete-78727\";i:77969;s:12:\"delete-78729\";i:77970;s:12:\"delete-78732\";i:77971;s:12:\"delete-78734\";i:77972;s:12:\"delete-78730\";i:77973;s:12:\"delete-78731\";i:77974;s:12:\"delete-78733\";i:77975;s:12:\"delete-78735\";i:77976;s:12:\"delete-78738\";i:77977;s:12:\"delete-78736\";i:77978;s:12:\"delete-78737\";i:77979;s:12:\"delete-78739\";i:77980;s:12:\"delete-78740\";i:77981;s:12:\"delete-78741\";i:77982;s:12:\"delete-78742\";i:77983;s:12:\"delete-78743\";i:77984;s:12:\"delete-78744\";i:77985;s:12:\"delete-78746\";i:77986;s:12:\"delete-78747\";i:77987;s:12:\"delete-78745\";i:77988;s:12:\"delete-78748\";i:77989;s:12:\"delete-78749\";i:77990;s:12:\"delete-78751\";i:77991;s:12:\"delete-78750\";i:77992;s:12:\"delete-78752\";i:77993;s:12:\"delete-78753\";i:77994;s:12:\"delete-78756\";i:77995;s:12:\"delete-78754\";i:77996;s:12:\"delete-78755\";i:77997;s:12:\"delete-78757\";i:77998;s:12:\"delete-78758\";i:77999;s:12:\"delete-78761\";i:78000;s:12:\"delete-78759\";i:78001;s:12:\"delete-78760\";i:78002;s:12:\"delete-78762\";i:78003;s:12:\"delete-78763\";i:78004;s:12:\"delete-78764\";i:78005;s:12:\"delete-78767\";i:78006;s:12:\"delete-78769\";i:78007;s:12:\"delete-78765\";i:78008;s:12:\"delete-78766\";i:78009;s:12:\"delete-78768\";i:78010;s:12:\"delete-78770\";i:78011;s:12:\"delete-78773\";i:78012;s:12:\"delete-78771\";i:78013;s:12:\"delete-78772\";i:78014;s:12:\"delete-78774\";i:78015;s:12:\"delete-78775\";i:78016;s:12:\"delete-78776\";i:78017;s:12:\"delete-78779\";i:78018;s:12:\"delete-78777\";i:78019;s:12:\"delete-78778\";i:78020;s:12:\"delete-78780\";i:78021;s:12:\"delete-78781\";i:78022;s:12:\"delete-78782\";i:78023;s:12:\"delete-78785\";i:78024;s:12:\"delete-78783\";i:78025;s:12:\"delete-78784\";i:78026;s:12:\"delete-78786\";i:78027;s:12:\"delete-78787\";i:78028;s:12:\"delete-78788\";i:78029;s:12:\"delete-78791\";i:78030;s:12:\"delete-78789\";i:78031;s:12:\"delete-78790\";i:78032;s:12:\"delete-78792\";i:78033;s:12:\"delete-78793\";i:78034;s:12:\"delete-78794\";i:78035;s:12:\"delete-78797\";i:78036;s:12:\"delete-78795\";i:78037;s:12:\"delete-78796\";i:78038;s:12:\"delete-78798\";i:78039;s:12:\"delete-78799\";i:78040;s:12:\"delete-78800\";i:78041;s:12:\"delete-78803\";i:78042;s:12:\"delete-78801\";i:78043;s:12:\"delete-78802\";i:78044;s:12:\"delete-78804\";i:78045;s:12:\"delete-78805\";i:78046;s:12:\"delete-78806\";i:78047;s:12:\"delete-78809\";i:78048;s:12:\"delete-78811\";i:78049;s:12:\"delete-78807\";i:78050;s:12:\"delete-78808\";i:78051;s:12:\"delete-78810\";i:78052;s:12:\"delete-78812\";i:78053;s:12:\"delete-78815\";i:78054;s:12:\"delete-78813\";i:78055;s:12:\"delete-78814\";i:78056;s:12:\"delete-78816\";i:78057;s:12:\"delete-78817\";i:78058;s:12:\"delete-78818\";i:78059;s:12:\"delete-78821\";i:78060;s:12:\"delete-78823\";i:78061;s:12:\"delete-78819\";i:78062;s:12:\"delete-78820\";i:78063;s:12:\"delete-78822\";i:78064;s:12:\"delete-78824\";i:78065;s:12:\"delete-78827\";i:78066;s:12:\"delete-78829\";i:78067;s:12:\"delete-78825\";i:78068;s:12:\"delete-78826\";i:78069;s:12:\"delete-78828\";i:78070;s:12:\"delete-78830\";i:78071;s:12:\"delete-78833\";i:78072;s:12:\"delete-78831\";i:78073;s:12:\"delete-78832\";i:78074;s:12:\"delete-78834\";i:78075;s:12:\"delete-78835\";i:78076;s:12:\"delete-78836\";i:78077;s:12:\"delete-78839\";i:78078;s:12:\"delete-78841\";i:78079;s:12:\"delete-78837\";i:78080;s:12:\"delete-78838\";i:78081;s:12:\"delete-78840\";i:78082;s:12:\"delete-78842\";i:78083;s:12:\"delete-78845\";i:78084;s:12:\"delete-78847\";i:78085;s:12:\"delete-78843\";i:78086;s:12:\"delete-78844\";i:78087;s:12:\"delete-78846\";i:78088;s:12:\"delete-78848\";i:78089;s:12:\"delete-78851\";i:78090;s:12:\"delete-78849\";i:78091;s:12:\"delete-78850\";i:78092;s:12:\"delete-78852\";i:78093;s:12:\"delete-78853\";i:78094;s:12:\"delete-78854\";i:78095;s:12:\"delete-78857\";i:78096;s:12:\"delete-78855\";i:78097;s:12:\"delete-78856\";i:78098;s:12:\"delete-78858\";i:78099;s:12:\"delete-78859\";i:78100;s:12:\"delete-78860\";i:78101;s:12:\"delete-78863\";i:78102;s:12:\"delete-78865\";i:78103;s:12:\"delete-78861\";i:78104;s:12:\"delete-78862\";i:78105;s:12:\"delete-78864\";i:78106;s:12:\"delete-78866\";i:78107;s:12:\"delete-78869\";i:78108;s:12:\"delete-78867\";i:78109;s:12:\"delete-78868\";i:78110;s:12:\"delete-78870\";i:78111;s:12:\"delete-78871\";i:78112;s:12:\"delete-78872\";i:78113;s:12:\"delete-78875\";i:78114;s:12:\"delete-78873\";i:78115;s:12:\"delete-78874\";i:78116;s:12:\"delete-78876\";i:78117;s:12:\"delete-78877\";i:78118;s:12:\"delete-78878\";i:78119;s:12:\"delete-78881\";i:78120;s:12:\"delete-78879\";i:78121;s:12:\"delete-78880\";i:78122;s:12:\"delete-78882\";i:78123;s:12:\"delete-78883\";i:78124;s:12:\"delete-78884\";i:78125;s:12:\"delete-78887\";i:78126;s:12:\"delete-78889\";i:78127;s:12:\"delete-78885\";i:78128;s:12:\"delete-78886\";i:78129;s:12:\"delete-78888\";i:78130;s:12:\"delete-78890\";i:78131;s:12:\"delete-78893\";i:78132;s:12:\"delete-78891\";i:78133;s:12:\"delete-78892\";i:78134;s:12:\"delete-78894\";i:78135;s:12:\"delete-78895\";i:78136;s:12:\"delete-78896\";i:78137;s:12:\"delete-78899\";i:78138;s:12:\"delete-78901\";i:78139;s:12:\"delete-78897\";i:78140;s:12:\"delete-78898\";i:78141;s:12:\"delete-78900\";i:78142;s:12:\"delete-78902\";i:78143;s:12:\"delete-78903\";i:78144;s:12:\"delete-78904\";i:78145;s:12:\"delete-78906\";i:78146;s:12:\"delete-78905\";i:78147;s:12:\"delete-78907\";i:78148;s:12:\"delete-78908\";i:78149;s:12:\"delete-78911\";i:78150;s:12:\"delete-78909\";i:78151;s:12:\"delete-78910\";i:78152;s:12:\"delete-78912\";i:78153;s:12:\"delete-78913\";i:78154;s:12:\"delete-78914\";i:78155;s:12:\"delete-78917\";i:78156;s:12:\"delete-78915\";i:78157;s:12:\"delete-78916\";i:78158;s:12:\"delete-78918\";i:78159;s:12:\"delete-78919\";i:78160;s:12:\"delete-78920\";i:78161;s:12:\"delete-78923\";i:78162;s:12:\"delete-78921\";i:78163;s:12:\"delete-78922\";i:78164;s:12:\"delete-78924\";i:78165;s:12:\"delete-78925\";i:78166;s:12:\"delete-78926\";i:78167;s:12:\"delete-78929\";i:78168;s:12:\"delete-78927\";i:78169;s:12:\"delete-78928\";i:78170;s:12:\"delete-78930\";i:78171;s:12:\"delete-78931\";i:78172;s:12:\"delete-78932\";i:78173;s:12:\"delete-78935\";i:78174;s:12:\"delete-78937\";i:78175;s:12:\"delete-78933\";i:78176;s:12:\"delete-78934\";i:78177;s:12:\"delete-78936\";i:78178;s:12:\"delete-78938\";i:78179;s:12:\"delete-78941\";i:78180;s:12:\"delete-78943\";i:78181;s:12:\"delete-78944\";i:78182;s:12:\"delete-78947\";i:78183;s:12:\"delete-78949\";i:78184;s:12:\"delete-78939\";i:78185;s:12:\"delete-78940\";i:78186;s:12:\"delete-78942\";i:78187;s:12:\"delete-78945\";i:78188;s:12:\"delete-78946\";i:78189;s:12:\"delete-78948\";i:78190;s:12:\"delete-78950\";i:78191;s:12:\"delete-78953\";i:78192;s:12:\"delete-78951\";i:78193;s:12:\"delete-78952\";i:78194;s:12:\"delete-78954\";i:78195;s:12:\"delete-78955\";i:78196;s:12:\"delete-78956\";i:78197;s:12:\"delete-78959\";i:78198;s:12:\"delete-78961\";i:78199;s:12:\"delete-78957\";i:78200;s:12:\"delete-78958\";i:78201;s:12:\"delete-78960\";i:78202;s:12:\"delete-78962\";i:78203;s:12:\"delete-78965\";i:78204;s:12:\"delete-78967\";i:78205;s:12:\"delete-78968\";i:78206;s:12:\"delete-78971\";i:78207;s:12:\"delete-78963\";i:78208;s:12:\"delete-78964\";i:78209;s:12:\"delete-78966\";i:78210;s:12:\"delete-78969\";i:78211;s:12:\"delete-78970\";i:78212;s:12:\"delete-78972\";i:78213;s:12:\"delete-78973\";i:78214;s:12:\"delete-78974\";i:78215;s:12:\"delete-78977\";i:78216;s:12:\"delete-78979\";i:78217;s:12:\"delete-78975\";i:78218;s:12:\"delete-78976\";i:78219;s:12:\"delete-78978\";i:78220;s:12:\"delete-78980\";i:78221;s:12:\"delete-78983\";i:78222;s:12:\"delete-78981\";i:78223;s:12:\"delete-78982\";i:78224;s:12:\"delete-78984\";i:78225;s:12:\"delete-78985\";i:78226;s:12:\"delete-78986\";i:78227;s:12:\"delete-78989\";i:78228;s:12:\"delete-78987\";i:78229;s:12:\"delete-78988\";i:78230;s:12:\"delete-78990\";i:78231;s:12:\"delete-78991\";i:78232;s:12:\"delete-78992\";i:78233;s:12:\"delete-78995\";i:78234;s:12:\"delete-78997\";i:78235;s:12:\"delete-78993\";i:78236;s:12:\"delete-78994\";i:78237;s:12:\"delete-78996\";i:78238;s:12:\"delete-78998\";i:78239;s:12:\"delete-79001\";i:78240;s:12:\"delete-79003\";i:78241;s:12:\"delete-78999\";i:78242;s:12:\"delete-79000\";i:78243;s:12:\"delete-79002\";i:78244;s:12:\"delete-79004\";i:78245;s:12:\"delete-79007\";i:78246;s:12:\"delete-79005\";i:78247;s:12:\"delete-79006\";i:78248;s:12:\"delete-79008\";i:78249;s:12:\"delete-79009\";i:78250;s:12:\"delete-79010\";i:78251;s:12:\"delete-79013\";i:78252;s:12:\"delete-79015\";i:78253;s:12:\"delete-79016\";i:78254;s:12:\"delete-79019\";i:78255;s:12:\"delete-79011\";i:78256;s:12:\"delete-79012\";i:78257;s:12:\"delete-79014\";i:78258;s:12:\"delete-79017\";i:78259;s:12:\"delete-79018\";i:78260;s:12:\"delete-79020\";i:78261;s:12:\"delete-79021\";i:78262;s:12:\"delete-79022\";i:78263;s:12:\"delete-79025\";i:78264;s:12:\"delete-79027\";i:78265;s:12:\"delete-79023\";i:78266;s:12:\"delete-79024\";i:78267;s:12:\"delete-79026\";i:78268;s:12:\"delete-79028\";i:78269;s:12:\"delete-79031\";i:78270;s:12:\"delete-79029\";i:78271;s:12:\"delete-79030\";i:78272;s:12:\"delete-79032\";i:78273;s:12:\"delete-79033\";i:78274;s:12:\"delete-79034\";i:78275;s:12:\"delete-79037\";i:78276;s:12:\"delete-79035\";i:78277;s:12:\"delete-79036\";i:78278;s:12:\"delete-79038\";i:78279;s:12:\"delete-79039\";i:78280;s:12:\"delete-79040\";i:78281;s:12:\"delete-79043\";i:78282;s:12:\"delete-79045\";i:78283;s:12:\"delete-79041\";i:78284;s:12:\"delete-79042\";i:78285;s:12:\"delete-79044\";i:78286;s:12:\"delete-79046\";i:78287;s:12:\"delete-79049\";i:78288;s:12:\"delete-79047\";i:78289;s:12:\"delete-79048\";i:78290;s:12:\"delete-79050\";i:78291;s:12:\"delete-79051\";i:78292;s:12:\"delete-79052\";i:78293;s:12:\"delete-79055\";i:78294;s:12:\"delete-79057\";i:78295;s:12:\"delete-79053\";i:78296;s:12:\"delete-79054\";i:78297;s:12:\"delete-79056\";i:78298;s:12:\"delete-79058\";i:78299;s:12:\"delete-79059\";i:78300;s:12:\"delete-79060\";i:78301;s:12:\"delete-79062\";i:78302;s:12:\"delete-79061\";i:78303;s:12:\"delete-79063\";i:78304;s:12:\"delete-79064\";i:78305;s:12:\"delete-79067\";i:78306;s:12:\"delete-79069\";i:78307;s:12:\"delete-79065\";i:78308;s:12:\"delete-79066\";i:78309;s:12:\"delete-79068\";i:78310;s:12:\"delete-79070\";i:78311;s:12:\"delete-79073\";i:78312;s:12:\"delete-79075\";i:78313;s:12:\"delete-79071\";i:78314;s:12:\"delete-79072\";i:78315;s:12:\"delete-79074\";i:78316;s:12:\"delete-79076\";i:78317;s:12:\"delete-79079\";i:78318;s:12:\"delete-79081\";i:78319;s:12:\"delete-79077\";i:78320;s:12:\"delete-79078\";i:78321;s:12:\"delete-79080\";i:78322;s:12:\"delete-79082\";i:78323;s:12:\"delete-79085\";i:78324;s:12:\"delete-79083\";i:78325;s:12:\"delete-79084\";i:78326;s:12:\"delete-79086\";i:78327;s:12:\"delete-79087\";i:78328;s:12:\"delete-79088\";i:78329;s:12:\"delete-79091\";i:78330;s:12:\"delete-79089\";i:78331;s:12:\"delete-79090\";i:78332;s:12:\"delete-79092\";i:78333;s:12:\"delete-79093\";i:78334;s:12:\"delete-79094\";i:78335;s:12:\"delete-79097\";i:78336;s:12:\"delete-79095\";i:78337;s:12:\"delete-79096\";i:78338;s:12:\"delete-79098\";i:78339;s:12:\"delete-79099\";i:78340;s:12:\"delete-79100\";i:78341;s:12:\"delete-79103\";i:78342;s:12:\"delete-79101\";i:78343;s:12:\"delete-79102\";i:78344;s:12:\"delete-79104\";i:78345;s:12:\"delete-79105\";i:78346;s:12:\"delete-79106\";i:78347;s:12:\"delete-79107\";i:78348;s:12:\"delete-79109\";i:78349;s:12:\"delete-79108\";i:78350;s:12:\"delete-79110\";i:78351;s:12:\"delete-79111\";i:78352;s:12:\"delete-79114\";i:78353;s:12:\"delete-79112\";i:78354;s:12:\"delete-79113\";i:78355;s:12:\"delete-79115\";i:78356;s:12:\"delete-79116\";i:78357;s:12:\"delete-79117\";i:78358;s:12:\"delete-79120\";i:78359;s:12:\"delete-79118\";i:78360;s:12:\"delete-79119\";i:78361;s:12:\"delete-79121\";i:78362;s:12:\"delete-79122\";i:78363;s:12:\"delete-79123\";i:78364;s:12:\"delete-79126\";i:78365;s:12:\"delete-79128\";i:78366;s:12:\"delete-79124\";i:78367;s:12:\"delete-79125\";i:78368;s:12:\"delete-79127\";i:78369;s:12:\"delete-79129\";i:78370;s:12:\"delete-79132\";i:78371;s:12:\"delete-79134\";i:78372;s:12:\"delete-79130\";i:78373;s:12:\"delete-79131\";i:78374;s:12:\"delete-79133\";i:78375;s:12:\"delete-79135\";i:78376;s:12:\"delete-79138\";i:78377;s:12:\"delete-79136\";i:78378;s:12:\"delete-79137\";i:78379;s:12:\"delete-79139\";i:78380;s:12:\"delete-79140\";i:78381;s:12:\"delete-79141\";i:78382;s:12:\"delete-79144\";i:78383;s:12:\"delete-79142\";i:78384;s:12:\"delete-79143\";i:78385;s:12:\"delete-79145\";i:78386;s:12:\"delete-79146\";i:78387;s:12:\"delete-79147\";i:78388;s:12:\"delete-79150\";i:78389;s:12:\"delete-79148\";i:78390;s:12:\"delete-79149\";i:78391;s:12:\"delete-79151\";i:78392;s:12:\"delete-79152\";i:78393;s:12:\"delete-79153\";i:78394;s:12:\"delete-79156\";i:78395;s:12:\"delete-79154\";i:78396;s:12:\"delete-79155\";i:78397;s:12:\"delete-79157\";i:78398;s:12:\"delete-79158\";i:78399;s:12:\"delete-79159\";i:78400;s:12:\"delete-79162\";i:78401;s:12:\"delete-79160\";i:78402;s:12:\"delete-79161\";i:78403;s:12:\"delete-79163\";i:78404;s:12:\"delete-79164\";i:78405;s:12:\"delete-79165\";i:78406;s:12:\"delete-79168\";i:78407;s:12:\"delete-79166\";i:78408;s:12:\"delete-79167\";i:78409;s:12:\"delete-79169\";i:78410;s:12:\"delete-79170\";i:78411;s:12:\"delete-79171\";i:78412;s:12:\"delete-79174\";i:78413;s:12:\"delete-79172\";i:78414;s:12:\"delete-79173\";i:78415;s:12:\"delete-79175\";i:78416;s:12:\"delete-79176\";i:78417;s:12:\"delete-79177\";i:78418;s:12:\"delete-79180\";i:78419;s:12:\"delete-79182\";i:78420;s:12:\"delete-79178\";i:78421;s:12:\"delete-79179\";i:78422;s:12:\"delete-79181\";i:78423;s:12:\"delete-79183\";i:78424;s:12:\"delete-79186\";i:78425;s:12:\"delete-79188\";i:78426;s:12:\"delete-79189\";i:78427;s:12:\"delete-79192\";i:78428;s:12:\"delete-79184\";i:78429;s:12:\"delete-79185\";i:78430;s:12:\"delete-79187\";i:78431;s:12:\"delete-79190\";i:78432;s:12:\"delete-79191\";i:78433;s:12:\"delete-79193\";i:78434;s:12:\"delete-79194\";i:78435;s:12:\"delete-79195\";i:78436;s:12:\"delete-79198\";i:78437;s:12:\"delete-79196\";i:78438;s:12:\"delete-79197\";i:78439;s:12:\"delete-79199\";i:78440;s:12:\"delete-79200\";i:78441;s:12:\"delete-79201\";i:78442;s:12:\"delete-79204\";i:78443;s:12:\"delete-79202\";i:78444;s:12:\"delete-79203\";i:78445;s:12:\"delete-79205\";i:78446;s:12:\"delete-79206\";i:78447;s:12:\"delete-79207\";i:78448;s:12:\"delete-79210\";i:78449;s:12:\"delete-79212\";i:78450;s:12:\"delete-79208\";i:78451;s:12:\"delete-79209\";i:78452;s:12:\"delete-79211\";i:78453;s:12:\"delete-79213\";i:78454;s:12:\"delete-79216\";i:78455;s:12:\"delete-79214\";i:78456;s:12:\"delete-79215\";i:78457;s:12:\"delete-79217\";i:78458;s:12:\"delete-79218\";i:78459;s:12:\"delete-79219\";i:78460;s:12:\"delete-79222\";i:78461;s:12:\"delete-79224\";i:78462;s:12:\"delete-79220\";i:78463;s:12:\"delete-79221\";i:78464;s:12:\"delete-79223\";i:78465;s:12:\"delete-79225\";i:78466;s:12:\"delete-79228\";i:78467;s:12:\"delete-79226\";i:78468;s:12:\"delete-79227\";i:78469;s:12:\"delete-79229\";i:78470;s:12:\"delete-79230\";i:78471;s:12:\"delete-79231\";i:78472;s:12:\"delete-79232\";i:78473;s:12:\"delete-79233\";i:78474;s:12:\"delete-79234\";i:78475;s:12:\"delete-79236\";i:78476;s:12:\"delete-79237\";i:78477;s:12:\"delete-79240\";i:78478;s:12:\"delete-79242\";i:78479;s:12:\"delete-79235\";i:78480;s:12:\"delete-79238\";i:78481;s:12:\"delete-79239\";i:78482;s:12:\"delete-79241\";i:78483;s:12:\"delete-79243\";i:78484;s:12:\"delete-79246\";i:78485;s:12:\"delete-79248\";i:78486;s:12:\"delete-79244\";i:78487;s:12:\"delete-79245\";i:78488;s:12:\"delete-79247\";i:78489;s:12:\"delete-79249\";i:78490;s:12:\"delete-79252\";i:78491;s:12:\"delete-79254\";i:78492;s:12:\"delete-79250\";i:78493;s:12:\"delete-79251\";i:78494;s:12:\"delete-79253\";i:78495;s:12:\"delete-79255\";i:78496;s:12:\"delete-79258\";i:78497;s:12:\"delete-79256\";i:78498;s:12:\"delete-79257\";i:78499;s:12:\"delete-79259\";i:78500;s:12:\"delete-79260\";i:78501;s:12:\"delete-79262\";i:78502;s:12:\"delete-79263\";i:78503;s:12:\"delete-79265\";i:78504;s:12:\"delete-79261\";i:78505;s:12:\"delete-79264\";i:78506;s:12:\"delete-79266\";i:78507;s:12:\"delete-79267\";i:78508;s:12:\"delete-79270\";i:78509;s:12:\"delete-79268\";i:78510;s:12:\"delete-79269\";i:78511;s:12:\"delete-79271\";i:78512;s:12:\"delete-79272\";i:78513;s:12:\"delete-79273\";i:78514;s:12:\"delete-79276\";i:78515;s:12:\"delete-79274\";i:78516;s:12:\"delete-79275\";i:78517;s:12:\"delete-79277\";i:78518;s:12:\"delete-79278\";i:78519;s:12:\"delete-79279\";i:78520;s:12:\"delete-79282\";i:78521;s:12:\"delete-79280\";i:78522;s:12:\"delete-79281\";i:78523;s:12:\"delete-79283\";i:78524;s:12:\"delete-79284\";i:78525;s:12:\"delete-79286\";i:78526;s:12:\"delete-79287\";i:78527;s:12:\"delete-79285\";i:78528;s:12:\"delete-79288\";i:78529;s:12:\"delete-79290\";i:78530;s:12:\"delete-79289\";i:78531;s:12:\"delete-79291\";i:78532;s:12:\"delete-79294\";i:78533;s:12:\"delete-79296\";i:78534;s:12:\"delete-79292\";i:78535;s:12:\"delete-79293\";i:78536;s:12:\"delete-79295\";i:78537;s:12:\"delete-79298\";i:78538;s:12:\"delete-79299\";i:78539;s:12:\"delete-79301\";i:78540;s:12:\"delete-79297\";i:78541;s:12:\"delete-79300\";i:78542;s:12:\"delete-79302\";i:78543;s:12:\"delete-79303\";i:78544;s:12:\"delete-79306\";i:78545;s:12:\"delete-79304\";i:78546;s:12:\"delete-79305\";i:78547;s:12:\"delete-79307\";i:78548;s:12:\"delete-79308\";i:78549;s:12:\"delete-79309\";i:78550;s:12:\"delete-79312\";i:78551;s:12:\"delete-79314\";i:78552;s:12:\"delete-79310\";i:78553;s:12:\"delete-79311\";i:78554;s:12:\"delete-79313\";i:78555;s:12:\"delete-79315\";i:78556;s:12:\"delete-79318\";i:78557;s:12:\"delete-79316\";i:78558;s:12:\"delete-79317\";i:78559;s:12:\"delete-79319\";i:78560;s:12:\"delete-79320\";i:78561;s:12:\"delete-79321\";i:78562;s:12:\"delete-79324\";i:78563;s:12:\"delete-79322\";i:78564;s:12:\"delete-79323\";i:78565;s:12:\"delete-79325\";i:78566;s:12:\"delete-79326\";i:78567;s:12:\"delete-79327\";i:78568;s:12:\"delete-79330\";i:78569;s:12:\"delete-79328\";i:78570;s:12:\"delete-79329\";i:78571;s:12:\"delete-79331\";i:78572;s:12:\"delete-79332\";i:78573;s:12:\"delete-79333\";i:78574;s:12:\"delete-79336\";i:78575;s:12:\"delete-79338\";i:78576;s:12:\"delete-79334\";i:78577;s:12:\"delete-79335\";i:78578;s:12:\"delete-79337\";i:78579;s:12:\"delete-79339\";i:78580;s:12:\"delete-79340\";i:78581;s:12:\"delete-79341\";i:78582;s:12:\"delete-79342\";i:78583;s:12:\"delete-79344\";i:78584;s:12:\"delete-79345\";i:78585;s:12:\"delete-79348\";i:78586;s:12:\"delete-79350\";i:78587;s:12:\"delete-79343\";i:78588;s:12:\"delete-79346\";i:78589;s:12:\"delete-79347\";i:78590;s:12:\"delete-79349\";i:78591;s:12:\"delete-79351\";i:78592;s:12:\"delete-79354\";i:78593;s:12:\"delete-79352\";i:78594;s:12:\"delete-79353\";i:78595;s:12:\"delete-79355\";i:78596;s:12:\"delete-79356\";i:78597;s:12:\"delete-79357\";i:78598;s:12:\"delete-79360\";i:78599;s:12:\"delete-79362\";i:78600;s:12:\"delete-79358\";i:78601;s:12:\"delete-79359\";i:78602;s:12:\"delete-79361\";i:78603;s:12:\"delete-79363\";i:78604;s:12:\"delete-79366\";i:78605;s:12:\"delete-79368\";i:78606;s:12:\"delete-79364\";i:78607;s:12:\"delete-79365\";i:78608;s:12:\"delete-79367\";i:78609;s:12:\"delete-79369\";i:78610;s:12:\"delete-79372\";i:78611;s:12:\"delete-79370\";i:78612;s:12:\"delete-79371\";i:78613;s:12:\"delete-79373\";i:78614;s:12:\"delete-79374\";i:78615;s:12:\"delete-79375\";i:78616;s:12:\"delete-79376\";i:78617;s:12:\"delete-79377\";i:78618;s:12:\"delete-79379\";i:78619;s:12:\"delete-79378\";i:78620;s:12:\"delete-79380\";i:78621;s:12:\"delete-79381\";i:78622;s:12:\"delete-79384\";i:78623;s:12:\"delete-79382\";i:78624;s:12:\"delete-79383\";i:78625;s:12:\"delete-79385\";i:78626;s:12:\"delete-79386\";i:78627;s:12:\"delete-79387\";i:78628;s:12:\"delete-79390\";i:78629;s:12:\"delete-79392\";i:78630;s:12:\"delete-79388\";i:78631;s:12:\"delete-79389\";i:78632;s:12:\"delete-79391\";i:78633;s:12:\"delete-79393\";i:78634;s:12:\"delete-79396\";i:78635;s:12:\"delete-79394\";i:78636;s:12:\"delete-79395\";i:78637;s:12:\"delete-79397\";i:78638;s:12:\"delete-79398\";i:78639;s:12:\"delete-79400\";i:78640;s:12:\"delete-79401\";i:78641;s:12:\"delete-79399\";i:78642;s:12:\"delete-79402\";i:78643;s:12:\"delete-79404\";i:78644;s:12:\"delete-79405\";i:78645;s:12:\"delete-79403\";i:78646;s:12:\"delete-79406\";i:78647;s:12:\"delete-79407\";i:78648;s:12:\"delete-79408\";i:78649;s:12:\"delete-79410\";i:78650;s:12:\"delete-79411\";i:78651;s:12:\"delete-79414\";i:78652;s:12:\"delete-79409\";i:78653;s:12:\"delete-79412\";i:78654;s:12:\"delete-79413\";i:78655;s:12:\"delete-79415\";i:78656;s:12:\"delete-79416\";i:78657;s:12:\"delete-79417\";i:78658;s:12:\"delete-79420\";i:78659;s:12:\"delete-79422\";i:78660;s:12:\"delete-79418\";i:78661;s:12:\"delete-79419\";i:78662;s:12:\"delete-79421\";i:78663;s:12:\"delete-79423\";i:78664;s:12:\"delete-79426\";i:78665;s:12:\"delete-79424\";i:78666;s:12:\"delete-79425\";i:78667;s:12:\"delete-79427\";i:78668;s:12:\"delete-79428\";i:78669;s:12:\"delete-79429\";i:78670;s:12:\"delete-79432\";i:78671;s:12:\"delete-79434\";i:78672;s:12:\"delete-79430\";i:78673;s:12:\"delete-79431\";i:78674;s:12:\"delete-79433\";i:78675;s:12:\"delete-79435\";i:78676;s:12:\"delete-79438\";i:78677;s:12:\"delete-79440\";i:78678;s:12:\"delete-79441\";i:78679;s:12:\"delete-79444\";i:78680;s:12:\"delete-79446\";i:78681;s:12:\"delete-79436\";i:78682;s:12:\"delete-79437\";i:78683;s:12:\"delete-79439\";i:78684;s:12:\"delete-79442\";i:78685;s:12:\"delete-79443\";i:78686;s:12:\"delete-79445\";i:78687;s:12:\"delete-79447\";i:78688;s:12:\"delete-79450\";i:78689;s:12:\"delete-79448\";i:78690;s:12:\"delete-79449\";i:78691;s:12:\"delete-79451\";i:78692;s:12:\"delete-79452\";i:78693;s:12:\"delete-79453\";i:78694;s:12:\"delete-79456\";i:78695;s:12:\"delete-79454\";i:78696;s:12:\"delete-79455\";i:78697;s:12:\"delete-79457\";i:78698;s:12:\"delete-79458\";i:78699;s:12:\"delete-79459\";i:78700;s:12:\"delete-79460\";i:78701;s:12:\"delete-79461\";i:78702;s:12:\"delete-79462\";i:78703;s:12:\"delete-79464\";i:78704;s:12:\"delete-79465\";i:78705;s:12:\"delete-79468\";i:78706;s:12:\"delete-79463\";i:78707;s:12:\"delete-79466\";i:78708;s:12:\"delete-79467\";i:78709;s:12:\"delete-79469\";i:78710;s:12:\"delete-79470\";i:78711;s:12:\"delete-79471\";i:78712;s:12:\"delete-79474\";i:78713;s:12:\"delete-79472\";i:78714;s:12:\"delete-79473\";i:78715;s:12:\"delete-79475\";i:78716;s:12:\"delete-79476\";i:78717;s:12:\"delete-79477\";i:78718;s:12:\"delete-79478\";i:78719;s:12:\"delete-79479\";i:78720;s:12:\"delete-79480\";i:78721;s:12:\"delete-79482\";i:78722;s:12:\"delete-79483\";i:78723;s:12:\"delete-79486\";i:78724;s:12:\"delete-79488\";i:78725;s:12:\"delete-79481\";i:78726;s:12:\"delete-79484\";i:78727;s:12:\"delete-79485\";i:78728;s:12:\"delete-79487\";i:78729;s:12:\"delete-79489\";i:78730;s:12:\"delete-79492\";i:78731;s:12:\"delete-79494\";i:78732;s:12:\"delete-79490\";i:78733;s:12:\"delete-79491\";i:78734;s:12:\"delete-79493\";i:78735;s:12:\"delete-79495\";i:78736;s:12:\"delete-79498\";i:78737;s:12:\"delete-79500\";i:78738;s:12:\"delete-79496\";i:78739;s:12:\"delete-79497\";i:78740;s:12:\"delete-79499\";i:78741;s:12:\"delete-79501\";i:78742;s:12:\"delete-79504\";i:78743;s:12:\"delete-79506\";i:78744;s:12:\"delete-79502\";i:78745;s:12:\"delete-79503\";i:78746;s:12:\"delete-79505\";i:78747;s:12:\"delete-79507\";i:78748;s:12:\"delete-79510\";i:78749;s:12:\"delete-79512\";i:78750;s:12:\"delete-79508\";i:78751;s:12:\"delete-79509\";i:78752;s:12:\"delete-79511\";i:78753;s:12:\"delete-79513\";i:78754;s:12:\"delete-79516\";i:78755;s:12:\"delete-79514\";i:78756;s:12:\"delete-79515\";i:78757;s:12:\"delete-79517\";i:78758;s:12:\"delete-79518\";i:78759;s:12:\"delete-79519\";i:78760;s:12:\"delete-79520\";i:78761;s:12:\"delete-79521\";i:78762;s:12:\"delete-79523\";i:78763;s:12:\"delete-79522\";i:78764;s:12:\"delete-79524\";i:78765;s:12:\"delete-79525\";i:78766;s:12:\"delete-79526\";i:78767;s:12:\"delete-79527\";i:78768;s:12:\"delete-79529\";i:78769;s:12:\"delete-79528\";i:78770;s:12:\"delete-79530\";i:78771;s:12:\"delete-79531\";i:78772;s:12:\"delete-79532\";i:78773;s:12:\"delete-79533\";i:78774;s:12:\"delete-79534\";i:78775;s:12:\"delete-79536\";i:78776;s:12:\"delete-79537\";i:78777;s:12:\"delete-79540\";i:78778;s:12:\"delete-79542\";i:78779;s:12:\"delete-79535\";i:78780;s:12:\"delete-79538\";i:78781;s:12:\"delete-79539\";i:78782;s:12:\"delete-79541\";i:78783;s:12:\"delete-79543\";i:78784;s:12:\"delete-79546\";i:78785;s:12:\"delete-79544\";i:78786;s:12:\"delete-79545\";i:78787;s:12:\"delete-79547\";i:78788;s:12:\"delete-79548\";i:78789;s:12:\"delete-79549\";i:78790;s:12:\"delete-79552\";i:78791;s:12:\"delete-79554\";i:78792;s:12:\"delete-79550\";i:78793;s:12:\"delete-79551\";i:78794;s:12:\"delete-79553\";i:78795;s:12:\"delete-79555\";i:78796;s:12:\"delete-79558\";i:78797;s:12:\"delete-79556\";i:78798;s:12:\"delete-79557\";i:78799;s:12:\"delete-79559\";i:78800;s:12:\"delete-79560\";i:78801;s:12:\"delete-79561\";i:78802;s:12:\"delete-79562\";i:78803;s:12:\"delete-79563\";i:78804;s:12:\"delete-79565\";i:78805;s:12:\"delete-79564\";i:78806;s:12:\"delete-79566\";i:78807;s:12:\"delete-79567\";i:78808;s:12:\"delete-79568\";i:78809;s:12:\"delete-79569\";i:78810;s:12:\"delete-79570\";i:78811;s:12:\"delete-79572\";i:78812;s:12:\"delete-79573\";i:78813;s:12:\"delete-79576\";i:78814;s:12:\"delete-79571\";i:78815;s:12:\"delete-79574\";i:78816;s:12:\"delete-79575\";i:78817;s:12:\"delete-79577\";i:78818;s:12:\"delete-79578\";i:78819;s:12:\"delete-79579\";i:78820;s:12:\"delete-79582\";i:78821;s:12:\"delete-79584\";i:78822;s:12:\"delete-79585\";i:78823;s:12:\"delete-79588\";i:78824;s:12:\"delete-79580\";i:78825;s:12:\"delete-79581\";i:78826;s:12:\"delete-79583\";i:78827;s:12:\"delete-79586\";i:78828;s:12:\"delete-79587\";i:78829;s:12:\"delete-79589\";i:78830;s:12:\"delete-79590\";i:78831;s:12:\"delete-79591\";i:78832;s:12:\"delete-79594\";i:78833;s:12:\"delete-79596\";i:78834;s:12:\"delete-79592\";i:78835;s:12:\"delete-79593\";i:78836;s:12:\"delete-79595\";i:78837;s:12:\"delete-79597\";i:78838;s:12:\"delete-79600\";i:78839;s:12:\"delete-79602\";i:78840;s:12:\"delete-79598\";i:78841;s:12:\"delete-79599\";i:78842;s:12:\"delete-79601\";i:78843;s:12:\"delete-79603\";i:78844;s:12:\"delete-79606\";i:78845;s:12:\"delete-79608\";i:78846;s:12:\"delete-79604\";i:78847;s:12:\"delete-79605\";i:78848;s:12:\"delete-79607\";i:78849;s:12:\"delete-79609\";i:78850;s:12:\"delete-79612\";i:78851;s:12:\"delete-79614\";i:78852;s:12:\"delete-79610\";i:78853;s:12:\"delete-79611\";i:78854;s:12:\"delete-79613\";i:78855;s:12:\"delete-79615\";i:78856;s:12:\"delete-79618\";i:78857;s:12:\"delete-79616\";i:78858;s:12:\"delete-79617\";i:78859;s:12:\"delete-79619\";i:78860;s:12:\"delete-79620\";i:78861;s:12:\"delete-79621\";i:78862;s:12:\"delete-79624\";i:78863;s:12:\"delete-79622\";i:78864;s:12:\"delete-79623\";i:78865;s:12:\"delete-79625\";i:78866;s:12:\"delete-79626\";i:78867;s:12:\"delete-79627\";i:78868;s:12:\"delete-79628\";i:78869;s:12:\"delete-79629\";i:78870;s:12:\"delete-79631\";i:78871;s:12:\"delete-79630\";i:78872;s:12:\"delete-79632\";i:78873;s:12:\"delete-79633\";i:78874;s:12:\"delete-79636\";i:78875;s:12:\"delete-79634\";i:78876;s:12:\"delete-79635\";i:78877;s:12:\"delete-79637\";i:78878;s:12:\"delete-79638\";i:78879;s:12:\"delete-79639\";i:78880;s:12:\"delete-79642\";i:78881;s:12:\"delete-79644\";i:78882;s:12:\"delete-79645\";i:78883;s:12:\"delete-79640\";i:78884;s:12:\"delete-79641\";i:78885;s:12:\"delete-79643\";i:78886;s:12:\"delete-79646\";i:78887;s:12:\"delete-79647\";i:78888;s:12:\"delete-79648\";i:78889;s:12:\"delete-79650\";i:78890;s:12:\"delete-79651\";i:78891;s:12:\"delete-79654\";i:78892;s:12:\"delete-79649\";i:78893;s:12:\"delete-79652\";i:78894;s:12:\"delete-79653\";i:78895;s:12:\"delete-79655\";i:78896;s:12:\"delete-79656\";i:78897;s:12:\"delete-79657\";i:78898;s:12:\"delete-79660\";i:78899;s:12:\"delete-79658\";i:78900;s:12:\"delete-79659\";i:78901;s:12:\"delete-79661\";i:78902;s:12:\"delete-79662\";i:78903;s:12:\"delete-79663\";i:78904;s:12:\"delete-79666\";i:78905;s:12:\"delete-79668\";i:78906;s:12:\"delete-79664\";i:78907;s:12:\"delete-79665\";i:78908;s:12:\"delete-79667\";i:78909;s:12:\"delete-79669\";i:78910;s:12:\"delete-79672\";i:78911;s:12:\"delete-79674\";i:78912;s:12:\"delete-79670\";i:78913;s:12:\"delete-79671\";i:78914;s:12:\"delete-79673\";i:78915;s:12:\"delete-79675\";i:78916;s:12:\"delete-79678\";i:78917;s:12:\"delete-79676\";i:78918;s:12:\"delete-79677\";i:78919;s:12:\"delete-79679\";i:78920;s:12:\"delete-79680\";i:78921;s:12:\"delete-79681\";i:78922;s:12:\"delete-79684\";i:78923;s:12:\"delete-79682\";i:78924;s:12:\"delete-79683\";i:78925;s:12:\"delete-79685\";i:78926;s:12:\"delete-79686\";i:78927;s:12:\"delete-79687\";i:78928;s:12:\"delete-79690\";i:78929;s:12:\"delete-79688\";i:78930;s:12:\"delete-79689\";i:78931;s:12:\"delete-79691\";i:78932;s:12:\"delete-79692\";i:78933;s:12:\"delete-79693\";i:78934;s:12:\"delete-79696\";i:78935;s:12:\"delete-79698\";i:78936;s:12:\"delete-79694\";i:78937;s:12:\"delete-79695\";i:78938;s:12:\"delete-79697\";i:78939;s:12:\"delete-79699\";i:78940;s:12:\"delete-79702\";i:78941;s:12:\"delete-79700\";i:78942;s:12:\"delete-79701\";i:78943;s:12:\"delete-79703\";i:78944;s:12:\"delete-79704\";i:78945;s:12:\"delete-79705\";i:78946;s:12:\"delete-79708\";i:78947;s:12:\"delete-79710\";i:78948;s:12:\"delete-79706\";i:78949;s:12:\"delete-79707\";i:78950;s:12:\"delete-79709\";i:78951;s:12:\"delete-79711\";i:78952;s:12:\"delete-79712\";i:78953;s:12:\"delete-79713\";i:78954;s:12:\"delete-79714\";i:78955;s:12:\"delete-79716\";i:78956;s:12:\"delete-79717\";i:78957;s:12:\"delete-79720\";i:78958;s:12:\"delete-79715\";i:78959;s:12:\"delete-79718\";i:78960;s:12:\"delete-79719\";i:78961;s:12:\"delete-79721\";i:78962;s:12:\"delete-79722\";i:78963;s:12:\"delete-79723\";i:78964;s:12:\"delete-79726\";i:78965;s:12:\"delete-79728\";i:78966;s:12:\"delete-79724\";i:78967;s:12:\"delete-79725\";i:78968;s:12:\"delete-79727\";i:78969;s:12:\"delete-79729\";i:78970;s:12:\"delete-79732\";i:78971;s:12:\"delete-79734\";i:78972;s:12:\"delete-79730\";i:78973;s:12:\"delete-79731\";i:78974;s:12:\"delete-79733\";i:78975;s:12:\"delete-79735\";i:78976;s:12:\"delete-79738\";i:78977;s:12:\"delete-79740\";i:78978;s:12:\"delete-79736\";i:78979;s:12:\"delete-79737\";i:78980;s:12:\"delete-79739\";i:78981;s:12:\"delete-79741\";i:78982;s:12:\"delete-79744\";i:78983;s:12:\"delete-79746\";i:78984;s:12:\"delete-79742\";i:78985;s:12:\"delete-79743\";i:78986;s:12:\"delete-79745\";i:78987;s:12:\"delete-79747\";i:78988;s:12:\"delete-79748\";i:78989;s:12:\"delete-79749\";i:78990;s:12:\"delete-79751\";i:78991;s:12:\"delete-79750\";i:78992;s:12:\"delete-79752\";i:78993;s:12:\"delete-79753\";i:78994;s:12:\"delete-79756\";i:78995;s:12:\"delete-79754\";i:78996;s:12:\"delete-79755\";i:78997;s:12:\"delete-79757\";i:78998;s:12:\"delete-79758\";i:78999;s:12:\"delete-79759\";i:79000;s:12:\"delete-79760\";i:79001;s:12:\"delete-79761\";i:79002;s:12:\"delete-79762\";i:79003;s:12:\"delete-79764\";i:79004;s:12:\"delete-79765\";i:79005;s:12:\"delete-79768\";i:79006;s:12:\"delete-79770\";i:79007;s:12:\"delete-79763\";i:79008;s:12:\"delete-79766\";i:79009;s:12:\"delete-79767\";i:79010;s:12:\"delete-79769\";i:79011;s:12:\"delete-79771\";i:79012;s:12:\"delete-79774\";i:79013;s:12:\"delete-79776\";i:79014;s:12:\"delete-79772\";i:79015;s:12:\"delete-79773\";i:79016;s:12:\"delete-79775\";i:79017;s:12:\"delete-79777\";i:79018;s:12:\"delete-79780\";i:79019;s:12:\"delete-79782\";i:79020;s:12:\"delete-79778\";i:79021;s:12:\"delete-79779\";i:79022;s:12:\"delete-79781\";i:79023;s:12:\"delete-79783\";i:79024;s:12:\"delete-79784\";i:79025;s:12:\"delete-79785\";i:79026;s:12:\"delete-79786\";i:79027;s:12:\"delete-79788\";i:79028;s:12:\"delete-79789\";i:79029;s:12:\"delete-79792\";i:79030;s:12:\"delete-79787\";i:79031;s:12:\"delete-79790\";i:79032;s:12:\"delete-79791\";i:79033;s:12:\"delete-79793\";i:79034;s:12:\"delete-79794\";i:79035;s:12:\"delete-79795\";i:79036;s:12:\"delete-79798\";i:79037;s:12:\"delete-79796\";i:79038;s:12:\"delete-79797\";i:79039;s:12:\"delete-79799\";i:79040;s:12:\"delete-79800\";i:79041;s:12:\"delete-79801\";i:79042;s:12:\"delete-79804\";i:79043;s:12:\"delete-79802\";i:79044;s:12:\"delete-79803\";i:79045;s:12:\"delete-79805\";i:79046;s:12:\"delete-79806\";i:79047;s:12:\"delete-79807\";i:79048;s:12:\"delete-79810\";i:79049;s:12:\"delete-79808\";i:79050;s:12:\"delete-79809\";i:79051;s:12:\"delete-79811\";i:79052;s:12:\"delete-79812\";i:79053;s:12:\"delete-79813\";i:79054;s:12:\"delete-79816\";i:79055;s:12:\"delete-79814\";i:79056;s:12:\"delete-79815\";i:79057;s:12:\"delete-79817\";i:79058;s:12:\"delete-79818\";i:79059;s:12:\"delete-79819\";i:79060;s:12:\"delete-79822\";i:79061;s:12:\"delete-79820\";i:79062;s:12:\"delete-79821\";i:79063;s:12:\"delete-79823\";i:79064;s:12:\"delete-79824\";i:79065;s:12:\"delete-79825\";i:79066;s:12:\"delete-79826\";i:79067;s:12:\"delete-79827\";i:79068;s:12:\"delete-79828\";i:79069;s:12:\"delete-79830\";i:79070;s:12:\"delete-79829\";i:79071;s:12:\"delete-79831\";i:79072;s:12:\"delete-79834\";i:79073;s:12:\"delete-79836\";i:79074;s:12:\"delete-79837\";i:79075;s:12:\"delete-79840\";i:79076;s:12:\"delete-79832\";i:79077;s:12:\"delete-79833\";i:79078;s:12:\"delete-79835\";i:79079;s:12:\"delete-79838\";i:79080;s:12:\"delete-79839\";i:79081;s:12:\"delete-79841\";i:79082;s:12:\"delete-79842\";i:79083;s:12:\"delete-79843\";i:79084;s:12:\"delete-79846\";i:79085;s:12:\"delete-79848\";i:79086;s:12:\"delete-79844\";i:79087;s:12:\"delete-79845\";i:79088;s:12:\"delete-79847\";i:79089;s:12:\"delete-79849\";i:79090;s:12:\"delete-79852\";i:79091;s:12:\"delete-79854\";i:79092;s:12:\"delete-79850\";i:79093;s:12:\"delete-79851\";i:79094;s:12:\"delete-79853\";i:79095;s:12:\"delete-79855\";i:79096;s:12:\"delete-79858\";i:79097;s:12:\"delete-79856\";i:79098;s:12:\"delete-79857\";i:79099;s:12:\"delete-79859\";i:79100;s:12:\"delete-79860\";i:79101;s:12:\"delete-79861\";i:79102;s:12:\"delete-79864\";i:79103;s:12:\"delete-79862\";i:79104;s:12:\"delete-79863\";i:79105;s:12:\"delete-79865\";i:79106;s:12:\"delete-79866\";i:79107;s:12:\"delete-79867\";i:79108;s:12:\"delete-79870\";i:79109;s:12:\"delete-79872\";i:79110;s:12:\"delete-79868\";i:79111;s:12:\"delete-79869\";i:79112;s:12:\"delete-79871\";i:79113;s:12:\"delete-79873\";i:79114;s:12:\"delete-79876\";i:79115;s:12:\"delete-79874\";i:79116;s:12:\"delete-79875\";i:79117;s:12:\"delete-79877\";i:79118;s:12:\"delete-79878\";i:79119;s:12:\"delete-79879\";i:79120;s:12:\"delete-79882\";i:79121;s:12:\"delete-79884\";i:79122;s:12:\"delete-79885\";i:79123;s:12:\"delete-79880\";i:79124;s:12:\"delete-79881\";i:79125;s:12:\"delete-79883\";i:79126;s:12:\"delete-79886\";i:79127;s:12:\"delete-79887\";i:79128;s:12:\"delete-79888\";i:79129;s:12:\"delete-79890\";i:79130;s:12:\"delete-79891\";i:79131;s:12:\"delete-79894\";i:79132;s:12:\"delete-79889\";i:79133;s:12:\"delete-79892\";i:79134;s:12:\"delete-79893\";i:79135;s:12:\"delete-79895\";i:79136;s:12:\"delete-79896\";i:79137;s:12:\"delete-79897\";i:79138;s:12:\"delete-79900\";i:79139;s:12:\"delete-79898\";i:79140;s:12:\"delete-79899\";i:79141;s:12:\"delete-79901\";i:79142;s:12:\"delete-79902\";i:79143;s:12:\"delete-79903\";i:79144;s:12:\"delete-79906\";i:79145;s:12:\"delete-79904\";i:79146;s:12:\"delete-79905\";i:79147;s:12:\"delete-79907\";i:79148;s:12:\"delete-79908\";i:79149;s:12:\"delete-79909\";i:79150;s:12:\"delete-79912\";i:79151;s:12:\"delete-79914\";i:79152;s:12:\"delete-79910\";i:79153;s:12:\"delete-79911\";i:79154;s:12:\"delete-79913\";i:79155;s:12:\"delete-79915\";i:79156;s:12:\"delete-79918\";i:79157;s:12:\"delete-79916\";i:79158;s:12:\"delete-79917\";i:79159;s:12:\"delete-79919\";i:79160;s:12:\"delete-79920\";i:79161;s:12:\"delete-79921\";i:79162;s:12:\"delete-79924\";i:79163;s:12:\"delete-79922\";i:79164;s:12:\"delete-79923\";i:79165;s:12:\"delete-79925\";i:79166;s:12:\"delete-79926\";i:79167;s:12:\"delete-79927\";i:79168;s:12:\"delete-79928\";i:79169;s:12:\"delete-79929\";i:79170;s:12:\"delete-79930\";i:79171;s:12:\"delete-79932\";i:79172;s:12:\"delete-79933\";i:79173;s:12:\"delete-79936\";i:79174;s:12:\"delete-79938\";i:79175;s:12:\"delete-79931\";i:79176;s:12:\"delete-79934\";i:79177;s:12:\"delete-79935\";i:79178;s:12:\"delete-79937\";i:79179;s:12:\"delete-79939\";i:79180;s:12:\"delete-79942\";i:79181;s:12:\"delete-79940\";i:79182;s:12:\"delete-79941\";i:79183;s:12:\"delete-79943\";i:79184;s:12:\"delete-79944\";i:79185;s:12:\"delete-79945\";i:79186;s:12:\"delete-79948\";i:79187;s:12:\"delete-79950\";i:79188;s:12:\"delete-79951\";i:79189;s:12:\"delete-79946\";i:79190;s:12:\"delete-79947\";i:79191;s:12:\"delete-79949\";i:79192;s:12:\"delete-79952\";i:79193;s:12:\"delete-79953\";i:79194;s:12:\"delete-79954\";i:79195;s:12:\"delete-79956\";i:79196;s:12:\"delete-79957\";i:79197;s:12:\"delete-79960\";i:79198;s:12:\"delete-79962\";i:79199;s:12:\"delete-79955\";i:79200;s:12:\"delete-79958\";i:79201;s:12:\"delete-79959\";i:79202;s:12:\"delete-79961\";i:79203;s:12:\"delete-79963\";i:79204;s:12:\"delete-79966\";i:79205;s:12:\"delete-79968\";i:79206;s:12:\"delete-79964\";i:79207;s:12:\"delete-79965\";i:79208;s:12:\"delete-79967\";i:79209;s:12:\"delete-79969\";i:79210;s:12:\"delete-79972\";i:79211;s:12:\"delete-79970\";i:79212;s:12:\"delete-79971\";i:79213;s:12:\"delete-79973\";i:79214;s:12:\"delete-79974\";i:79215;s:12:\"delete-79975\";i:79216;s:12:\"delete-79978\";i:79217;s:12:\"delete-79980\";i:79218;s:12:\"delete-79976\";i:79219;s:12:\"delete-79977\";i:79220;s:12:\"delete-79979\";i:79221;s:12:\"delete-79981\";i:79222;s:12:\"delete-79982\";i:79223;s:12:\"delete-79983\";i:79224;s:12:\"delete-79984\";i:79225;s:12:\"delete-79986\";i:79226;s:12:\"delete-79987\";i:79227;s:12:\"delete-79990\";i:79228;s:12:\"delete-79992\";i:79229;s:12:\"delete-79985\";i:79230;s:12:\"delete-79988\";i:79231;s:12:\"delete-79989\";i:79232;s:12:\"delete-79991\";i:79233;s:12:\"delete-79993\";i:79234;s:12:\"delete-79996\";i:79235;s:12:\"delete-79994\";i:79236;s:12:\"delete-79995\";i:79237;s:12:\"delete-79997\";i:79238;s:12:\"delete-79998\";i:79239;s:12:\"delete-79999\";i:79240;s:12:\"delete-80002\";i:79241;s:12:\"delete-80004\";i:79242;s:12:\"delete-80005\";i:79243;s:12:\"delete-80000\";i:79244;s:12:\"delete-80001\";i:79245;s:12:\"delete-80003\";i:79246;s:12:\"delete-80006\";i:79247;s:12:\"delete-80007\";i:79248;s:12:\"delete-80008\";i:79249;s:12:\"delete-80010\";i:79250;s:12:\"delete-80011\";i:79251;s:12:\"delete-80014\";i:79252;s:12:\"delete-80016\";i:79253;s:12:\"delete-80009\";i:79254;s:12:\"delete-80012\";i:79255;s:12:\"delete-80013\";i:79256;s:12:\"delete-80015\";i:79257;s:12:\"delete-80017\";i:79258;s:12:\"delete-80020\";i:79259;s:12:\"delete-80022\";i:79260;s:12:\"delete-80018\";i:79261;s:12:\"delete-80019\";i:79262;s:12:\"delete-80021\";i:79263;s:12:\"delete-80023\";i:79264;s:12:\"delete-80026\";i:79265;s:12:\"delete-80028\";i:79266;s:12:\"delete-80024\";i:79267;s:12:\"delete-80025\";i:79268;s:12:\"delete-80027\";i:79269;s:12:\"delete-80029\";i:79270;s:12:\"delete-80032\";i:79271;s:12:\"delete-80034\";i:79272;s:12:\"delete-80030\";i:79273;s:12:\"delete-80031\";i:79274;s:12:\"delete-80033\";i:79275;s:12:\"delete-80035\";i:79276;s:12:\"delete-80038\";i:79277;s:12:\"delete-80036\";i:79278;s:12:\"delete-80037\";i:79279;s:12:\"delete-80039\";i:79280;s:12:\"delete-80040\";i:79281;s:12:\"delete-80041\";i:79282;s:12:\"delete-80044\";i:79283;s:12:\"delete-80046\";i:79284;s:12:\"delete-80042\";i:79285;s:12:\"delete-80043\";i:79286;s:12:\"delete-80045\";i:79287;s:12:\"delete-80047\";i:79288;s:12:\"delete-80050\";i:79289;s:12:\"delete-80052\";i:79290;s:12:\"delete-80048\";i:79291;s:12:\"delete-80049\";i:79292;s:12:\"delete-80051\";i:79293;s:12:\"delete-80053\";i:79294;s:12:\"delete-80056\";i:79295;s:12:\"delete-80058\";i:79296;s:12:\"delete-80054\";i:79297;s:12:\"delete-80055\";i:79298;s:12:\"delete-80057\";i:79299;s:12:\"delete-80059\";i:79300;s:12:\"delete-80062\";i:79301;s:12:\"delete-80064\";i:79302;s:12:\"delete-80065\";i:79303;s:12:\"delete-80068\";i:79304;s:12:\"delete-80060\";i:79305;s:12:\"delete-80061\";i:79306;s:12:\"delete-80063\";i:79307;s:12:\"delete-80066\";i:79308;s:12:\"delete-80067\";i:79309;s:12:\"delete-80069\";i:79310;s:12:\"delete-80070\";i:79311;s:12:\"delete-80071\";i:79312;s:12:\"delete-80074\";i:79313;s:12:\"delete-80072\";i:79314;s:12:\"delete-80073\";i:79315;s:12:\"delete-80075\";i:79316;s:12:\"delete-80076\";i:79317;s:12:\"delete-80077\";i:79318;s:12:\"delete-80080\";i:79319;s:12:\"delete-80082\";i:79320;s:12:\"delete-80078\";i:79321;s:12:\"delete-80079\";i:79322;s:12:\"delete-80081\";i:79323;s:12:\"delete-80083\";i:79324;s:12:\"delete-80086\";i:79325;s:12:\"delete-80088\";i:79326;s:12:\"delete-80084\";i:79327;s:12:\"delete-80085\";i:79328;s:12:\"delete-80087\";i:79329;s:12:\"delete-80089\";i:79330;s:12:\"delete-80092\";i:79331;s:12:\"delete-80094\";i:79332;s:12:\"delete-80090\";i:79333;s:12:\"delete-80091\";i:79334;s:12:\"delete-80093\";i:79335;s:12:\"delete-80095\";i:79336;s:12:\"delete-80098\";i:79337;s:12:\"delete-80100\";i:79338;s:12:\"delete-80096\";i:79339;s:12:\"delete-80097\";i:79340;s:12:\"delete-80099\";i:79341;s:12:\"delete-80101\";i:79342;s:12:\"delete-80104\";i:79343;s:12:\"delete-80102\";i:79344;s:12:\"delete-80103\";i:79345;s:12:\"delete-80105\";i:79346;s:12:\"delete-80106\";i:79347;s:12:\"delete-80107\";i:79348;s:12:\"delete-80110\";i:79349;s:12:\"delete-80108\";i:79350;s:12:\"delete-80109\";i:79351;s:12:\"delete-80111\";i:79352;s:12:\"delete-80112\";i:79353;s:12:\"delete-80113\";i:79354;s:12:\"delete-80116\";i:79355;s:12:\"delete-80114\";i:79356;s:12:\"delete-80115\";i:79357;s:12:\"delete-80117\";i:79358;s:12:\"delete-80118\";i:79359;s:12:\"delete-80119\";i:79360;s:12:\"delete-80120\";i:79361;s:12:\"delete-80121\";i:79362;s:12:\"delete-80122\";i:79363;s:12:\"delete-80124\";i:79364;s:12:\"delete-80125\";i:79365;s:12:\"delete-80128\";i:79366;s:12:\"delete-80130\";i:79367;s:12:\"delete-80123\";i:79368;s:12:\"delete-80126\";i:79369;s:12:\"delete-80127\";i:79370;s:12:\"delete-80129\";i:79371;s:12:\"delete-80131\";i:79372;s:12:\"delete-80134\";i:79373;s:12:\"delete-80136\";i:79374;s:12:\"delete-80132\";i:79375;s:12:\"delete-80133\";i:79376;s:12:\"delete-80135\";i:79377;s:12:\"delete-80137\";i:79378;s:12:\"delete-80140\";i:79379;s:12:\"delete-80142\";i:79380;s:12:\"delete-80138\";i:79381;s:12:\"delete-80139\";i:79382;s:12:\"delete-80141\";i:79383;s:12:\"delete-80143\";i:79384;s:12:\"delete-80146\";i:79385;s:12:\"delete-80148\";i:79386;s:12:\"delete-80144\";i:79387;s:12:\"delete-80145\";i:79388;s:12:\"delete-80147\";i:79389;s:12:\"delete-80149\";i:79390;s:12:\"delete-80152\";i:79391;s:12:\"delete-80154\";i:79392;s:12:\"delete-80150\";i:79393;s:12:\"delete-80151\";i:79394;s:12:\"delete-80153\";i:79395;s:12:\"delete-80155\";i:79396;s:12:\"delete-80158\";i:79397;s:12:\"delete-80160\";i:79398;s:12:\"delete-80156\";i:79399;s:12:\"delete-80157\";i:79400;s:12:\"delete-80159\";i:79401;s:12:\"delete-80161\";i:79402;s:12:\"delete-80164\";i:79403;s:12:\"delete-80166\";i:79404;s:12:\"delete-80162\";i:79405;s:12:\"delete-80163\";i:79406;s:12:\"delete-80165\";i:79407;s:12:\"delete-80167\";i:79408;s:12:\"delete-80170\";i:79409;s:12:\"delete-80172\";i:79410;s:12:\"delete-80168\";i:79411;s:12:\"delete-80169\";i:79412;s:12:\"delete-80171\";i:79413;s:12:\"delete-80173\";i:79414;s:12:\"delete-80176\";i:79415;s:12:\"delete-80178\";i:79416;s:12:\"delete-80174\";i:79417;s:12:\"delete-80175\";i:79418;s:12:\"delete-80177\";i:79419;s:12:\"delete-80179\";i:79420;s:12:\"delete-80182\";i:79421;s:12:\"delete-80184\";i:79422;s:12:\"delete-80185\";i:79423;s:12:\"delete-80180\";i:79424;s:12:\"delete-80181\";i:79425;s:12:\"delete-80183\";i:79426;s:12:\"delete-80186\";i:79427;s:12:\"delete-80187\";i:79428;s:12:\"delete-80189\";i:79429;s:12:\"delete-80188\";i:79430;s:12:\"delete-80190\";i:79431;s:12:\"delete-80191\";i:79432;s:12:\"delete-80194\";i:79433;s:12:\"delete-80196\";i:79434;s:12:\"delete-80192\";i:79435;s:12:\"delete-80193\";i:79436;s:12:\"delete-80195\";i:79437;s:12:\"delete-80197\";i:79438;s:12:\"delete-80200\";i:79439;s:12:\"delete-80202\";i:79440;s:12:\"delete-80198\";i:79441;s:12:\"delete-80199\";i:79442;s:12:\"delete-80201\";i:79443;s:12:\"delete-80203\";i:79444;s:12:\"delete-80206\";i:79445;s:12:\"delete-80204\";i:79446;s:12:\"delete-80205\";i:79447;s:12:\"delete-80207\";i:79448;s:12:\"delete-80208\";i:79449;s:12:\"delete-80209\";i:79450;s:12:\"delete-80212\";i:79451;s:12:\"delete-80214\";i:79452;s:12:\"delete-80210\";i:79453;s:12:\"delete-80211\";i:79454;s:12:\"delete-80213\";i:79455;s:12:\"delete-80215\";i:79456;s:12:\"delete-80218\";i:79457;s:12:\"delete-80220\";i:79458;s:12:\"delete-80216\";i:79459;s:12:\"delete-80217\";i:79460;s:12:\"delete-80219\";i:79461;s:12:\"delete-80221\";i:79462;s:12:\"delete-80224\";i:79463;s:12:\"delete-80222\";i:79464;s:12:\"delete-80223\";i:79465;s:12:\"delete-80225\";i:79466;s:12:\"delete-80226\";i:79467;s:12:\"delete-80227\";i:79468;s:12:\"delete-80230\";i:79469;s:12:\"delete-80228\";i:79470;s:12:\"delete-80229\";i:79471;s:12:\"delete-80231\";i:79472;s:12:\"delete-80232\";i:79473;s:12:\"delete-80233\";i:79474;s:12:\"delete-80236\";i:79475;s:12:\"delete-80234\";i:79476;s:12:\"delete-80235\";i:79477;s:12:\"delete-80237\";i:79478;s:12:\"delete-80238\";i:79479;s:12:\"delete-80239\";i:79480;s:12:\"delete-80242\";i:79481;s:12:\"delete-80244\";i:79482;s:12:\"delete-80240\";i:79483;s:12:\"delete-80241\";i:79484;s:12:\"delete-80243\";i:79485;s:12:\"delete-80245\";i:79486;s:12:\"delete-80248\";i:79487;s:12:\"delete-80250\";i:79488;s:12:\"delete-80246\";i:79489;s:12:\"delete-80247\";i:79490;s:12:\"delete-80249\";i:79491;s:12:\"delete-80251\";i:79492;s:12:\"delete-80252\";i:79493;s:12:\"delete-80253\";i:79494;s:12:\"delete-80254\";i:79495;s:12:\"delete-80256\";i:79496;s:12:\"delete-80257\";i:79497;s:12:\"delete-80260\";i:79498;s:12:\"delete-80255\";i:79499;s:12:\"delete-80258\";i:79500;s:12:\"delete-80259\";i:79501;s:12:\"delete-80261\";i:79502;s:12:\"delete-80262\";i:79503;s:12:\"delete-80263\";i:79504;s:12:\"delete-80266\";i:79505;s:12:\"delete-80268\";i:79506;s:12:\"delete-80264\";i:79507;s:12:\"delete-80265\";i:79508;s:12:\"delete-80267\";i:79509;s:12:\"delete-80269\";i:79510;s:12:\"delete-80272\";i:79511;s:12:\"delete-80270\";i:79512;s:12:\"delete-80271\";i:79513;s:12:\"delete-80273\";i:79514;s:12:\"delete-80274\";i:79515;s:12:\"delete-80275\";i:79516;s:12:\"delete-80278\";i:79517;s:12:\"delete-80280\";i:79518;s:12:\"delete-80276\";i:79519;s:12:\"delete-80277\";i:79520;s:12:\"delete-80279\";i:79521;s:12:\"delete-80281\";i:79522;s:12:\"delete-80284\";i:79523;s:12:\"delete-80282\";i:79524;s:12:\"delete-80283\";i:79525;s:12:\"delete-80285\";i:79526;s:12:\"delete-80286\";i:79527;s:12:\"delete-80287\";i:79528;s:12:\"delete-80290\";i:79529;s:12:\"delete-80292\";i:79530;s:12:\"delete-80288\";i:79531;s:12:\"delete-80289\";i:79532;s:12:\"delete-80291\";i:79533;s:12:\"delete-80293\";i:79534;s:12:\"delete-80296\";i:79535;s:12:\"delete-80294\";i:79536;s:12:\"delete-80295\";i:79537;s:12:\"delete-80297\";i:79538;s:12:\"delete-80298\";i:79539;s:12:\"delete-80299\";i:79540;s:12:\"delete-80302\";i:79541;s:12:\"delete-80304\";i:79542;s:12:\"delete-80300\";i:79543;s:12:\"delete-80301\";i:79544;s:12:\"delete-80303\";i:79545;s:12:\"delete-80305\";i:79546;s:12:\"delete-80308\";i:79547;s:12:\"delete-80310\";i:79548;s:12:\"delete-80306\";i:79549;s:12:\"delete-80307\";i:79550;s:12:\"delete-80309\";i:79551;s:12:\"delete-80311\";i:79552;s:12:\"delete-80314\";i:79553;s:12:\"delete-80316\";i:79554;s:12:\"delete-80317\";i:79555;s:12:\"delete-80320\";i:79556;s:12:\"delete-80322\";i:79557;s:12:\"delete-80312\";i:79558;s:12:\"delete-80313\";i:79559;s:12:\"delete-80315\";i:79560;s:12:\"delete-80318\";i:79561;s:12:\"delete-80319\";i:79562;s:12:\"delete-80321\";i:79563;s:12:\"delete-80323\";i:79564;s:12:\"delete-80326\";i:79565;s:12:\"delete-80324\";i:79566;s:12:\"delete-80325\";i:79567;s:12:\"delete-80327\";i:79568;s:12:\"delete-80328\";i:79569;s:12:\"delete-80329\";i:79570;s:12:\"delete-80332\";i:79571;s:12:\"delete-80330\";i:79572;s:12:\"delete-80331\";i:79573;s:12:\"delete-80333\";i:79574;s:12:\"delete-80334\";i:79575;s:12:\"delete-80336\";i:79576;s:12:\"delete-80337\";i:79577;s:12:\"delete-80335\";i:79578;s:12:\"delete-80338\";i:79579;s:12:\"delete-80340\";i:79580;s:12:\"delete-80341\";i:79581;s:12:\"delete-80344\";i:79582;s:12:\"delete-80339\";i:79583;s:12:\"delete-80342\";i:79584;s:12:\"delete-80343\";i:79585;s:12:\"delete-80345\";i:79586;s:12:\"delete-80346\";i:79587;s:12:\"delete-80347\";i:79588;s:12:\"delete-80348\";i:79589;s:12:\"delete-80349\";i:79590;s:12:\"delete-80351\";i:79591;s:12:\"delete-80350\";i:79592;s:12:\"delete-80352\";i:79593;s:12:\"delete-80353\";i:79594;s:12:\"delete-80356\";i:79595;s:12:\"delete-80358\";i:79596;s:12:\"delete-80354\";i:79597;s:12:\"delete-80355\";i:79598;s:12:\"delete-80357\";i:79599;s:12:\"delete-80359\";i:79600;s:12:\"delete-80362\";i:79601;s:12:\"delete-80364\";i:79602;s:12:\"delete-80360\";i:79603;s:12:\"delete-80361\";i:79604;s:12:\"delete-80363\";i:79605;s:12:\"delete-80365\";i:79606;s:12:\"delete-80368\";i:79607;s:12:\"delete-80370\";i:79608;s:12:\"delete-80371\";i:79609;s:12:\"delete-80366\";i:79610;s:12:\"delete-80367\";i:79611;s:12:\"delete-80369\";i:79612;s:12:\"delete-80372\";i:79613;s:12:\"delete-80373\";i:79614;s:12:\"delete-80374\";i:79615;s:12:\"delete-80376\";i:79616;s:12:\"delete-80377\";i:79617;s:12:\"delete-80380\";i:79618;s:12:\"delete-80375\";i:79619;s:12:\"delete-80378\";i:79620;s:12:\"delete-80379\";i:79621;s:12:\"delete-80381\";i:79622;s:12:\"delete-80382\";i:79623;s:12:\"delete-80383\";i:79624;s:12:\"delete-80386\";i:79625;s:12:\"delete-80384\";i:79626;s:12:\"delete-80385\";i:79627;s:12:\"delete-80387\";i:79628;s:12:\"delete-80388\";i:79629;s:12:\"delete-80389\";i:79630;s:12:\"delete-80392\";i:79631;s:12:\"delete-80394\";i:79632;s:12:\"delete-80390\";i:79633;s:12:\"delete-80391\";i:79634;s:12:\"delete-80393\";i:79635;s:12:\"delete-80395\";i:79636;s:12:\"delete-80398\";i:79637;s:12:\"delete-80400\";i:79638;s:12:\"delete-80396\";i:79639;s:12:\"delete-80397\";i:79640;s:12:\"delete-80399\";i:79641;s:12:\"delete-80401\";i:79642;s:12:\"delete-80404\";i:79643;s:12:\"delete-80402\";i:79644;s:12:\"delete-80403\";i:79645;s:12:\"delete-80405\";i:79646;s:12:\"delete-80406\";i:79647;s:12:\"delete-80407\";i:79648;s:12:\"delete-80410\";i:79649;s:12:\"delete-80408\";i:79650;s:12:\"delete-80409\";i:79651;s:12:\"delete-80411\";i:79652;s:12:\"delete-80412\";i:79653;s:12:\"delete-80413\";i:79654;s:12:\"delete-80416\";i:79655;s:12:\"delete-80414\";i:79656;s:12:\"delete-80415\";i:79657;s:12:\"delete-80417\";i:79658;s:12:\"delete-80418\";i:79659;s:12:\"delete-80419\";i:79660;s:12:\"delete-80420\";i:79661;s:12:\"delete-80421\";i:79662;s:12:\"delete-80423\";i:79663;s:12:\"delete-80422\";i:79664;s:12:\"delete-80424\";i:79665;s:12:\"delete-80425\";i:79666;s:12:\"delete-80426\";i:79667;s:12:\"delete-80427\";i:79668;s:12:\"delete-80429\";i:79669;s:12:\"delete-80428\";i:79670;s:12:\"delete-80430\";i:79671;s:12:\"delete-80431\";i:79672;s:12:\"delete-80434\";i:79673;s:12:\"delete-80436\";i:79674;s:12:\"delete-80432\";i:79675;s:12:\"delete-80433\";i:79676;s:12:\"delete-80435\";i:79677;s:12:\"delete-80437\";i:79678;s:12:\"delete-80440\";i:79679;s:12:\"delete-80442\";i:79680;s:12:\"delete-80438\";i:79681;s:12:\"delete-80439\";i:79682;s:12:\"delete-80441\";i:79683;s:12:\"delete-80443\";i:79684;s:12:\"delete-80446\";i:79685;s:12:\"delete-80444\";i:79686;s:12:\"delete-80445\";i:79687;s:12:\"delete-80447\";i:79688;s:12:\"delete-80448\";i:79689;s:12:\"delete-80449\";i:79690;s:12:\"delete-80452\";i:79691;s:12:\"delete-80454\";i:79692;s:12:\"delete-80450\";i:79693;s:12:\"delete-80451\";i:79694;s:12:\"delete-80453\";i:79695;s:12:\"delete-80455\";i:79696;s:12:\"delete-80458\";i:79697;s:12:\"delete-80460\";i:79698;s:12:\"delete-80456\";i:79699;s:12:\"delete-80457\";i:79700;s:12:\"delete-80459\";i:79701;s:12:\"delete-80461\";i:79702;s:12:\"delete-80464\";i:79703;s:12:\"delete-80462\";i:79704;s:12:\"delete-80463\";i:79705;s:12:\"delete-80465\";i:79706;s:12:\"delete-80466\";i:79707;s:12:\"delete-80467\";i:79708;s:12:\"delete-80470\";i:79709;s:12:\"delete-80472\";i:79710;s:12:\"delete-80468\";i:79711;s:12:\"delete-80469\";i:79712;s:12:\"delete-80471\";i:79713;s:12:\"delete-80473\";i:79714;s:12:\"delete-80476\";i:79715;s:12:\"delete-80478\";i:79716;s:12:\"delete-80474\";i:79717;s:12:\"delete-80475\";i:79718;s:12:\"delete-80477\";i:79719;s:12:\"delete-80479\";i:79720;s:12:\"delete-80482\";i:79721;s:12:\"delete-80484\";i:79722;s:12:\"delete-80485\";i:79723;s:12:\"delete-80488\";i:79724;s:12:\"delete-80480\";i:79725;s:12:\"delete-80481\";i:79726;s:12:\"delete-80483\";i:79727;s:12:\"delete-80486\";i:79728;s:12:\"delete-80487\";i:79729;s:12:\"delete-80489\";i:79730;s:12:\"delete-80490\";i:79731;s:12:\"delete-80491\";i:79732;s:12:\"delete-80494\";i:79733;s:12:\"delete-80492\";i:79734;s:12:\"delete-80493\";i:79735;s:12:\"delete-80495\";i:79736;s:12:\"delete-80496\";i:79737;s:12:\"delete-80497\";i:79738;s:12:\"delete-80500\";i:79739;s:12:\"delete-80498\";i:79740;s:12:\"delete-80499\";i:79741;s:12:\"delete-80501\";i:79742;s:12:\"delete-80502\";i:79743;s:12:\"delete-80503\";i:79744;s:12:\"delete-80506\";i:79745;s:12:\"delete-80504\";i:79746;s:12:\"delete-80505\";i:79747;s:12:\"delete-80507\";i:79748;s:12:\"delete-80508\";i:79749;s:12:\"delete-80509\";i:79750;s:12:\"delete-80512\";i:79751;s:12:\"delete-80514\";i:79752;s:12:\"delete-80510\";i:79753;s:12:\"delete-80511\";i:79754;s:12:\"delete-80513\";i:79755;s:12:\"delete-80515\";i:79756;s:12:\"delete-80518\";i:79757;s:12:\"delete-80516\";i:79758;s:12:\"delete-80517\";i:79759;s:12:\"delete-80519\";i:79760;s:12:\"delete-80520\";i:79761;s:12:\"delete-80521\";i:79762;s:12:\"delete-80524\";i:79763;s:12:\"delete-80522\";i:79764;s:12:\"delete-80523\";i:79765;s:12:\"delete-80525\";i:79766;s:12:\"delete-80526\";i:79767;s:12:\"delete-80527\";i:79768;s:12:\"delete-80530\";i:79769;s:12:\"delete-80532\";i:79770;s:12:\"delete-80528\";i:79771;s:12:\"delete-80529\";i:79772;s:12:\"delete-80531\";i:79773;s:12:\"delete-80533\";i:79774;s:12:\"delete-80536\";i:79775;s:12:\"delete-80534\";i:79776;s:12:\"delete-80535\";i:79777;s:12:\"delete-80537\";i:79778;s:12:\"delete-80538\";i:79779;s:12:\"delete-80539\";i:79780;s:12:\"delete-80542\";i:79781;s:12:\"delete-80544\";i:79782;s:12:\"delete-80545\";i:79783;s:12:\"delete-80540\";i:79784;s:12:\"delete-80541\";i:79785;s:12:\"delete-80543\";i:79786;s:12:\"delete-80546\";i:79787;s:12:\"delete-80547\";i:79788;s:12:\"delete-80548\";i:79789;s:12:\"delete-80550\";i:79790;s:12:\"delete-80551\";i:79791;s:12:\"delete-80554\";i:79792;s:12:\"delete-80556\";i:79793;s:12:\"delete-80549\";i:79794;s:12:\"delete-80552\";i:79795;s:12:\"delete-80553\";i:79796;s:12:\"delete-80555\";i:79797;s:12:\"delete-80557\";i:79798;s:12:\"delete-80560\";i:79799;s:12:\"delete-80558\";i:79800;s:12:\"delete-80559\";i:79801;s:12:\"delete-80561\";i:79802;s:12:\"delete-80562\";i:79803;s:12:\"delete-80563\";i:79804;s:12:\"delete-80566\";i:79805;s:12:\"delete-80564\";i:79806;s:12:\"delete-80565\";i:79807;s:12:\"delete-80567\";i:79808;s:12:\"delete-80568\";i:79809;s:12:\"delete-80569\";i:79810;s:12:\"delete-80572\";i:79811;s:12:\"delete-80570\";i:79812;s:12:\"delete-80571\";i:79813;s:12:\"delete-80573\";i:79814;s:12:\"delete-80574\";i:79815;s:12:\"delete-80575\";i:79816;s:12:\"delete-80576\";i:79817;s:12:\"delete-80577\";i:79818;s:12:\"delete-80579\";i:79819;s:12:\"delete-80578\";i:79820;s:12:\"delete-80580\";i:79821;s:12:\"delete-80581\";i:79822;s:12:\"delete-80584\";i:79823;s:12:\"delete-80586\";i:79824;s:12:\"delete-80582\";i:79825;s:12:\"delete-80583\";i:79826;s:12:\"delete-80585\";i:79827;s:12:\"delete-80587\";i:79828;s:12:\"delete-80590\";i:79829;s:12:\"delete-80588\";i:79830;s:12:\"delete-80589\";i:79831;s:12:\"delete-80591\";i:79832;s:12:\"delete-80592\";i:79833;s:12:\"delete-80593\";i:79834;s:12:\"delete-80596\";i:79835;s:12:\"delete-80594\";i:79836;s:12:\"delete-80595\";i:79837;s:12:\"delete-80597\";i:79838;s:12:\"delete-80598\";i:79839;s:12:\"delete-80599\";i:79840;s:12:\"delete-80600\";i:79841;s:12:\"delete-80601\";i:79842;s:12:\"delete-80603\";i:79843;s:12:\"delete-80602\";i:79844;s:12:\"delete-80604\";i:79845;s:12:\"delete-80605\";i:79846;s:12:\"delete-80608\";i:79847;s:12:\"delete-80606\";i:79848;s:12:\"delete-80607\";i:79849;s:12:\"delete-80609\";i:79850;s:12:\"delete-80610\";i:79851;s:12:\"delete-80611\";i:79852;s:12:\"delete-80612\";i:79853;s:12:\"delete-80613\";i:79854;s:12:\"delete-80615\";i:79855;s:12:\"delete-80614\";i:79856;s:12:\"delete-80616\";i:79857;s:12:\"delete-80617\";i:79858;s:12:\"delete-80618\";i:79859;s:12:\"delete-80619\";i:79860;s:12:\"delete-80621\";i:79861;s:12:\"delete-80620\";i:79862;s:12:\"delete-80622\";i:79863;s:12:\"delete-80623\";i:79864;s:12:\"delete-80626\";i:79865;s:12:\"delete-80628\";i:79866;s:12:\"delete-80624\";i:79867;s:12:\"delete-80625\";i:79868;s:12:\"delete-80627\";i:79869;s:12:\"delete-80629\";i:79870;s:12:\"delete-80632\";i:79871;s:12:\"delete-80634\";i:79872;s:12:\"delete-80630\";i:79873;s:12:\"delete-80631\";i:79874;s:12:\"delete-80633\";i:79875;s:12:\"delete-80635\";i:79876;s:12:\"delete-80638\";i:79877;s:12:\"delete-80636\";i:79878;s:12:\"delete-80637\";i:79879;s:12:\"delete-80639\";i:79880;s:12:\"delete-80640\";i:79881;s:12:\"delete-80641\";i:79882;s:12:\"delete-80642\";i:79883;s:12:\"delete-80643\";i:79884;s:12:\"delete-80645\";i:79885;s:12:\"delete-80644\";i:79886;s:12:\"delete-80646\";i:79887;s:12:\"delete-80647\";i:79888;s:12:\"delete-80650\";i:79889;s:12:\"delete-80652\";i:79890;s:12:\"delete-80648\";i:79891;s:12:\"delete-80649\";i:79892;s:12:\"delete-80651\";i:79893;s:12:\"delete-80653\";i:79894;s:12:\"delete-80656\";i:79895;s:12:\"delete-80654\";i:79896;s:12:\"delete-80655\";i:79897;s:12:\"delete-80657\";i:79898;s:12:\"delete-80658\";i:79899;s:12:\"delete-80660\";i:79900;s:12:\"delete-80661\";i:79901;s:12:\"delete-80659\";i:79902;s:12:\"delete-80662\";i:79903;s:12:\"delete-80664\";i:79904;s:12:\"delete-80665\";i:79905;s:12:\"delete-80663\";i:79906;s:12:\"delete-80666\";i:79907;s:12:\"delete-80667\";i:79908;s:12:\"delete-80668\";i:79909;s:12:\"delete-80670\";i:79910;s:12:\"delete-80671\";i:79911;s:12:\"delete-80674\";i:79912;s:12:\"delete-80676\";i:79913;s:12:\"delete-80669\";i:79914;s:12:\"delete-80672\";i:79915;s:12:\"delete-80673\";i:79916;s:12:\"delete-80675\";i:79917;s:12:\"delete-80677\";i:79918;s:12:\"delete-80680\";i:79919;s:12:\"delete-80678\";i:79920;s:12:\"delete-80679\";i:79921;s:12:\"delete-80681\";i:79922;s:12:\"delete-80682\";i:79923;s:12:\"delete-80683\";i:79924;s:12:\"delete-80686\";i:79925;s:12:\"delete-80688\";i:79926;s:12:\"delete-80684\";i:79927;s:12:\"delete-80685\";i:79928;s:12:\"delete-80687\";i:79929;s:12:\"delete-80689\";i:79930;s:12:\"delete-80692\";i:79931;s:12:\"delete-80694\";i:79932;s:12:\"delete-80690\";i:79933;s:12:\"delete-80691\";i:79934;s:12:\"delete-80693\";i:79935;s:12:\"delete-80695\";i:79936;s:12:\"delete-80698\";i:79937;s:12:\"delete-80696\";i:79938;s:12:\"delete-80697\";i:79939;s:12:\"delete-80699\";i:79940;s:12:\"delete-80700\";i:79941;s:12:\"delete-80701\";i:79942;s:12:\"delete-80702\";i:79943;s:12:\"delete-80703\";i:79944;s:12:\"delete-80705\";i:79945;s:12:\"delete-80704\";i:79946;s:12:\"delete-80706\";i:79947;s:12:\"delete-80707\";i:79948;s:12:\"delete-80710\";i:79949;s:12:\"delete-80708\";i:79950;s:12:\"delete-80709\";i:79951;s:12:\"delete-80711\";i:79952;s:12:\"delete-80712\";i:79953;s:12:\"delete-80713\";i:79954;s:12:\"delete-80714\";i:79955;s:12:\"delete-80715\";i:79956;s:12:\"delete-80717\";i:79957;s:12:\"delete-80716\";i:79958;s:12:\"delete-80718\";i:79959;s:12:\"delete-80719\";i:79960;s:12:\"delete-80720\";i:79961;s:12:\"delete-80721\";i:79962;s:12:\"delete-80723\";i:79963;s:12:\"delete-80722\";i:79964;s:12:\"delete-80724\";i:79965;s:12:\"delete-80725\";i:79966;s:12:\"delete-80728\";i:79967;s:12:\"delete-80726\";i:79968;s:12:\"delete-80727\";i:79969;s:12:\"delete-80729\";i:79970;s:12:\"delete-80730\";i:79971;s:12:\"delete-80731\";i:79972;s:12:\"delete-80734\";i:79973;s:12:\"delete-80732\";i:79974;s:12:\"delete-80733\";i:79975;s:12:\"delete-80735\";i:79976;s:12:\"delete-80736\";i:79977;s:12:\"delete-80737\";i:79978;s:12:\"delete-80740\";i:79979;s:12:\"delete-80738\";i:79980;s:12:\"delete-80739\";i:79981;s:12:\"delete-80741\";i:79982;s:12:\"delete-80742\";i:79983;s:12:\"delete-80743\";i:79984;s:12:\"delete-80746\";i:79985;s:12:\"delete-80744\";i:79986;s:12:\"delete-80745\";i:79987;s:12:\"delete-80747\";i:79988;s:12:\"delete-80748\";i:79989;s:12:\"delete-80749\";i:79990;s:12:\"delete-80752\";i:79991;s:12:\"delete-80754\";i:79992;s:12:\"delete-80750\";i:79993;s:12:\"delete-80751\";i:79994;s:12:\"delete-80753\";i:79995;s:12:\"delete-80755\";i:79996;s:12:\"delete-80758\";i:79997;s:12:\"delete-80756\";i:79998;s:12:\"delete-80757\";i:79999;s:12:\"delete-80759\";i:80000;s:12:\"delete-80760\";i:80001;s:12:\"delete-80761\";i:80002;s:12:\"delete-80764\";i:80003;s:12:\"delete-80762\";i:80004;s:12:\"delete-80763\";i:80005;s:12:\"delete-80765\";i:80006;s:12:\"delete-80766\";i:80007;s:12:\"delete-80767\";i:80008;s:12:\"delete-80770\";i:80009;s:12:\"delete-80768\";i:80010;s:12:\"delete-80769\";i:80011;s:12:\"delete-80771\";i:80012;s:12:\"delete-80772\";i:80013;s:12:\"delete-80773\";i:80014;s:12:\"delete-80774\";i:80015;s:12:\"delete-80775\";i:80016;s:12:\"delete-80777\";i:80017;s:12:\"delete-80776\";i:80018;s:12:\"delete-80778\";i:80019;s:12:\"delete-80779\";i:80020;s:12:\"delete-80782\";i:80021;s:12:\"delete-80784\";i:80022;s:12:\"delete-80780\";i:80023;s:12:\"delete-80781\";i:80024;s:12:\"delete-80783\";i:80025;s:12:\"delete-80785\";i:80026;s:12:\"delete-80786\";i:80027;s:12:\"delete-80787\";i:80028;s:12:\"delete-80789\";i:80029;s:12:\"delete-80788\";i:80030;s:12:\"delete-80790\";i:80031;s:12:\"delete-80791\";i:80032;s:12:\"delete-80792\";i:80033;s:12:\"delete-80793\";i:80034;s:12:\"delete-80795\";i:80035;s:12:\"delete-80794\";i:80036;s:12:\"delete-80796\";i:80037;s:12:\"delete-80797\";i:80038;s:12:\"delete-80800\";i:80039;s:12:\"delete-80798\";i:80040;s:12:\"delete-80799\";i:80041;s:12:\"delete-80801\";i:80042;s:12:\"delete-80802\";i:80043;s:12:\"delete-80803\";i:80044;s:12:\"delete-80806\";i:80045;s:12:\"delete-80804\";i:80046;s:12:\"delete-80805\";i:80047;s:12:\"delete-80807\";i:80048;s:12:\"delete-80808\";i:80049;s:12:\"delete-80809\";i:80050;s:12:\"delete-80812\";i:80051;s:12:\"delete-80810\";i:80052;s:12:\"delete-80811\";i:80053;s:12:\"delete-80813\";i:80054;s:12:\"delete-80814\";i:80055;s:12:\"delete-80815\";i:80056;s:12:\"delete-80818\";i:80057;s:12:\"delete-80816\";i:80058;s:12:\"delete-80817\";i:80059;s:12:\"delete-80819\";i:80060;s:12:\"delete-80820\";i:80061;s:12:\"delete-80821\";i:80062;s:12:\"delete-80822\";i:80063;s:12:\"delete-80823\";i:80064;s:12:\"delete-80824\";i:80065;s:12:\"delete-80826\";i:80066;s:12:\"delete-80827\";i:80067;s:12:\"delete-80830\";i:80068;s:12:\"delete-80832\";i:80069;s:12:\"delete-80825\";i:80070;s:12:\"delete-80828\";i:80071;s:12:\"delete-80829\";i:80072;s:12:\"delete-80831\";i:80073;s:12:\"delete-80833\";i:80074;s:12:\"delete-80836\";i:80075;s:12:\"delete-80838\";i:80076;s:12:\"delete-80834\";i:80077;s:12:\"delete-80835\";i:80078;s:12:\"delete-80837\";i:80079;s:12:\"delete-80839\";i:80080;s:12:\"delete-80840\";i:80081;s:12:\"delete-80841\";i:80082;s:12:\"delete-80842\";i:80083;s:12:\"delete-80844\";i:80084;s:12:\"delete-80845\";i:80085;s:12:\"delete-80848\";i:80086;s:12:\"delete-80843\";i:80087;s:12:\"delete-80846\";i:80088;s:12:\"delete-80847\";i:80089;s:12:\"delete-80849\";i:80090;s:12:\"delete-80850\";i:80091;s:12:\"delete-80851\";i:80092;s:12:\"delete-80854\";i:80093;s:12:\"delete-80852\";i:80094;s:12:\"delete-80853\";i:80095;s:12:\"delete-80855\";i:80096;s:12:\"delete-80856\";i:80097;s:12:\"delete-80857\";i:80098;s:12:\"delete-80860\";i:80099;s:12:\"delete-80862\";i:80100;s:12:\"delete-80858\";i:80101;s:12:\"delete-80859\";i:80102;s:12:\"delete-80861\";i:80103;s:12:\"delete-80863\";i:80104;s:12:\"delete-80866\";i:80105;s:12:\"delete-80864\";i:80106;s:12:\"delete-80865\";i:80107;s:12:\"delete-80867\";i:80108;s:12:\"delete-80868\";i:80109;s:12:\"delete-80869\";i:80110;s:12:\"delete-80872\";i:80111;s:12:\"delete-80870\";i:80112;s:12:\"delete-80871\";i:80113;s:12:\"delete-80873\";i:80114;s:12:\"delete-80874\";i:80115;s:12:\"delete-80875\";i:80116;s:12:\"delete-80878\";i:80117;s:12:\"delete-80876\";i:80118;s:12:\"delete-80877\";i:80119;s:12:\"delete-80879\";i:80120;s:12:\"delete-80880\";i:80121;s:12:\"delete-80881\";i:80122;s:12:\"delete-80884\";i:80123;s:12:\"delete-80882\";i:80124;s:12:\"delete-80883\";i:80125;s:12:\"delete-80885\";i:80126;s:12:\"delete-80886\";i:80127;s:12:\"delete-80887\";i:80128;s:12:\"delete-80890\";i:80129;s:12:\"delete-80892\";i:80130;s:12:\"delete-80888\";i:80131;s:12:\"delete-80889\";i:80132;s:12:\"delete-80891\";i:80133;s:12:\"delete-80893\";i:80134;s:12:\"delete-80896\";i:80135;s:12:\"delete-80898\";i:80136;s:12:\"delete-80894\";i:80137;s:12:\"delete-80895\";i:80138;s:12:\"delete-80897\";i:80139;s:12:\"delete-80899\";i:80140;s:12:\"delete-80902\";i:80141;s:12:\"delete-80900\";i:80142;s:12:\"delete-80901\";i:80143;s:12:\"delete-80903\";i:80144;s:12:\"delete-80904\";i:80145;s:12:\"delete-80905\";i:80146;s:12:\"delete-80908\";i:80147;s:12:\"delete-80910\";i:80148;s:12:\"delete-80911\";i:80149;s:12:\"delete-80914\";i:80150;s:12:\"delete-80916\";i:80151;s:12:\"delete-80906\";i:80152;s:12:\"delete-80907\";i:80153;s:12:\"delete-80909\";i:80154;s:12:\"delete-80912\";i:80155;s:12:\"delete-80913\";i:80156;s:12:\"delete-80915\";i:80157;s:12:\"delete-80917\";i:80158;s:12:\"delete-80920\";i:80159;s:12:\"delete-80918\";i:80160;s:12:\"delete-80919\";i:80161;s:12:\"delete-80921\";i:80162;s:12:\"delete-80922\";i:80163;s:12:\"delete-80923\";i:80164;s:12:\"delete-80926\";i:80165;s:12:\"delete-80924\";i:80166;s:12:\"delete-80925\";i:80167;s:12:\"delete-80927\";i:80168;s:12:\"delete-80928\";i:80169;s:12:\"delete-80929\";i:80170;s:12:\"delete-80932\";i:80171;s:12:\"delete-80930\";i:80172;s:12:\"delete-80931\";i:80173;s:12:\"delete-80933\";i:80174;s:12:\"delete-80934\";i:80175;s:12:\"delete-80935\";i:80176;s:12:\"delete-80938\";i:80177;s:12:\"delete-80940\";i:80178;s:12:\"delete-80936\";i:80179;s:12:\"delete-80937\";i:80180;s:12:\"delete-80939\";i:80181;s:12:\"delete-80941\";i:80182;s:12:\"delete-80944\";i:80183;s:12:\"delete-80942\";i:80184;s:12:\"delete-80943\";i:80185;s:12:\"delete-80945\";i:80186;s:12:\"delete-80946\";i:80187;s:12:\"delete-80947\";i:80188;s:12:\"delete-80948\";i:80189;s:12:\"delete-80949\";i:80190;s:12:\"delete-80951\";i:80191;s:12:\"delete-80950\";i:80192;s:12:\"delete-80952\";i:80193;s:12:\"delete-80953\";i:80194;s:12:\"delete-80956\";i:80195;s:12:\"delete-80958\";i:80196;s:12:\"delete-80959\";i:80197;s:12:\"delete-80962\";i:80198;s:12:\"delete-80954\";i:80199;s:12:\"delete-80955\";i:80200;s:12:\"delete-80957\";i:80201;s:12:\"delete-80960\";i:80202;s:12:\"delete-80961\";i:80203;s:12:\"delete-80963\";i:80204;s:12:\"delete-80964\";i:80205;s:12:\"delete-80965\";i:80206;s:12:\"delete-80968\";i:80207;s:12:\"delete-80966\";i:80208;s:12:\"delete-80967\";i:80209;s:12:\"delete-80969\";i:80210;s:12:\"delete-80970\";i:80211;s:12:\"delete-80971\";i:80212;s:12:\"delete-80974\";i:80213;s:12:\"delete-80976\";i:80214;s:12:\"delete-80972\";i:80215;s:12:\"delete-80973\";i:80216;s:12:\"delete-80975\";i:80217;s:12:\"delete-80977\";i:80218;s:12:\"delete-80980\";i:80219;s:12:\"delete-80978\";i:80220;s:12:\"delete-80979\";i:80221;s:12:\"delete-80981\";i:80222;s:12:\"delete-80982\";i:80223;s:12:\"delete-80983\";i:80224;s:12:\"delete-80986\";i:80225;s:12:\"delete-80984\";i:80226;s:12:\"delete-80985\";i:80227;s:12:\"delete-80987\";i:80228;s:12:\"delete-80988\";i:80229;s:12:\"delete-80989\";i:80230;s:12:\"delete-80992\";i:80231;s:12:\"delete-80990\";i:80232;s:12:\"delete-80991\";i:80233;s:12:\"delete-80993\";i:80234;s:12:\"delete-80994\";i:80235;s:12:\"delete-80995\";i:80236;s:12:\"delete-80998\";i:80237;s:12:\"delete-81000\";i:80238;s:12:\"delete-80996\";i:80239;s:12:\"delete-80997\";i:80240;s:12:\"delete-80999\";i:80241;s:12:\"delete-81001\";i:80242;s:12:\"delete-81004\";i:80243;s:12:\"delete-81002\";i:80244;s:12:\"delete-81003\";i:80245;s:12:\"delete-81005\";i:80246;s:12:\"delete-81006\";i:80247;s:12:\"delete-81007\";i:80248;s:12:\"delete-81010\";i:80249;s:12:\"delete-81012\";i:80250;s:12:\"delete-81008\";i:80251;s:12:\"delete-81009\";i:80252;s:12:\"delete-81011\";i:80253;s:12:\"delete-81013\";i:80254;s:12:\"delete-81016\";i:80255;s:12:\"delete-81018\";i:80256;s:12:\"delete-81014\";i:80257;s:12:\"delete-81015\";i:80258;s:12:\"delete-81017\";i:80259;s:12:\"delete-81019\";i:80260;s:12:\"delete-81020\";i:80261;s:12:\"delete-81021\";i:80262;s:12:\"delete-81023\";i:80263;s:12:\"delete-81022\";i:80264;s:12:\"delete-81024\";i:80265;s:12:\"delete-81025\";i:80266;s:12:\"delete-81028\";i:80267;s:12:\"delete-81026\";i:80268;s:12:\"delete-81027\";i:80269;s:12:\"delete-81029\";i:80270;s:12:\"delete-81030\";i:80271;s:12:\"delete-81031\";i:80272;s:12:\"delete-81032\";i:80273;s:12:\"delete-81033\";i:80274;s:12:\"delete-81034\";i:80275;s:12:\"delete-81036\";i:80276;s:12:\"delete-81037\";i:80277;s:12:\"delete-81035\";i:80278;s:12:\"delete-81038\";i:80279;s:12:\"delete-81039\";i:80280;s:12:\"delete-81041\";i:80281;s:12:\"delete-81040\";i:80282;s:12:\"delete-81042\";i:80283;s:12:\"delete-81043\";i:80284;s:12:\"delete-81046\";i:80285;s:12:\"delete-81044\";i:80286;s:12:\"delete-81045\";i:80287;s:12:\"delete-81047\";i:80288;s:12:\"delete-81048\";i:80289;s:12:\"delete-81049\";i:80290;s:12:\"delete-81052\";i:80291;s:12:\"delete-81050\";i:80292;s:12:\"delete-81051\";i:80293;s:12:\"delete-81053\";i:80294;s:12:\"delete-81054\";i:80295;s:12:\"delete-81055\";i:80296;s:12:\"delete-81058\";i:80297;s:12:\"delete-81056\";i:80298;s:12:\"delete-81057\";i:80299;s:12:\"delete-81059\";i:80300;s:12:\"delete-81060\";i:80301;s:12:\"delete-81061\";i:80302;s:12:\"delete-81064\";i:80303;s:12:\"delete-81066\";i:80304;s:12:\"delete-81062\";i:80305;s:12:\"delete-81063\";i:80306;s:12:\"delete-81065\";i:80307;s:12:\"delete-81067\";i:80308;s:12:\"delete-81070\";i:80309;s:12:\"delete-81068\";i:80310;s:12:\"delete-81069\";i:80311;s:12:\"delete-81071\";i:80312;s:12:\"delete-81072\";i:80313;s:12:\"delete-81074\";i:80314;s:12:\"delete-81075\";i:80315;s:12:\"delete-81073\";i:80316;s:12:\"delete-81076\";i:80317;s:12:\"delete-81078\";i:80318;s:12:\"delete-81077\";i:80319;s:12:\"delete-81079\";i:80320;s:12:\"delete-81082\";i:80321;s:12:\"delete-81084\";i:80322;s:12:\"delete-81085\";i:80323;s:12:\"delete-81080\";i:80324;s:12:\"delete-81081\";i:80325;s:12:\"delete-81083\";i:80326;s:12:\"delete-81086\";i:80327;s:12:\"delete-81087\";i:80328;s:12:\"delete-81089\";i:80329;s:12:\"delete-81088\";i:80330;s:12:\"delete-81090\";i:80331;s:12:\"delete-81091\";i:80332;s:12:\"delete-81094\";i:80333;s:12:\"delete-81092\";i:80334;s:12:\"delete-81093\";i:80335;s:12:\"delete-81095\";i:80336;s:12:\"delete-81096\";i:80337;s:12:\"delete-81097\";i:80338;s:12:\"delete-81100\";i:80339;s:12:\"delete-81098\";i:80340;s:12:\"delete-81099\";i:80341;s:12:\"delete-81101\";i:80342;s:12:\"delete-81102\";i:80343;s:12:\"delete-81103\";i:80344;s:12:\"delete-81106\";i:80345;s:12:\"delete-81104\";i:80346;s:12:\"delete-81105\";i:80347;s:12:\"delete-81107\";i:80348;s:12:\"delete-81108\";i:80349;s:12:\"delete-81109\";i:80350;s:12:\"delete-81112\";i:80351;s:12:\"delete-81110\";i:80352;s:12:\"delete-81111\";i:80353;s:12:\"delete-81113\";i:80354;s:12:\"delete-81114\";i:80355;s:12:\"delete-81115\";i:80356;s:12:\"delete-81118\";i:80357;s:12:\"delete-81120\";i:80358;s:12:\"delete-81116\";i:80359;s:12:\"delete-81117\";i:80360;s:12:\"delete-81119\";i:80361;s:12:\"delete-81121\";i:80362;s:12:\"delete-81124\";i:80363;s:12:\"delete-81126\";i:80364;s:12:\"delete-81122\";i:80365;s:12:\"delete-81123\";i:80366;s:12:\"delete-81125\";i:80367;s:12:\"delete-81127\";i:80368;s:12:\"delete-81130\";i:80369;s:12:\"delete-81132\";i:80370;s:12:\"delete-81128\";i:80371;s:12:\"delete-81129\";i:80372;s:12:\"delete-81131\";i:80373;s:12:\"delete-81133\";i:80374;s:12:\"delete-81134\";i:80375;s:12:\"delete-81135\";i:80376;s:12:\"delete-81136\";i:80377;s:12:\"delete-81138\";i:80378;s:12:\"delete-81139\";i:80379;s:12:\"delete-81142\";i:80380;s:12:\"delete-81137\";i:80381;s:12:\"delete-81140\";i:80382;s:12:\"delete-81141\";i:80383;s:12:\"delete-81143\";i:80384;s:12:\"delete-81144\";i:80385;s:12:\"delete-81145\";i:80386;s:12:\"delete-81148\";i:80387;s:12:\"delete-81146\";i:80388;s:12:\"delete-81147\";i:80389;s:12:\"delete-81149\";i:80390;s:12:\"delete-81150\";i:80391;s:12:\"delete-81151\";i:80392;s:12:\"delete-81154\";i:80393;s:12:\"delete-81152\";i:80394;s:12:\"delete-81153\";i:80395;s:12:\"delete-81155\";i:80396;s:12:\"delete-81156\";i:80397;s:12:\"delete-81157\";i:80398;s:12:\"delete-81158\";i:80399;s:12:\"delete-81159\";i:80400;s:12:\"delete-81161\";i:80401;s:12:\"delete-81160\";i:80402;s:12:\"delete-81162\";i:80403;s:12:\"delete-81163\";i:80404;s:12:\"delete-81166\";i:80405;s:12:\"delete-81168\";i:80406;s:12:\"delete-81164\";i:80407;s:12:\"delete-81165\";i:80408;s:12:\"delete-81167\";i:80409;s:12:\"delete-81169\";i:80410;s:12:\"delete-81172\";i:80411;s:12:\"delete-81170\";i:80412;s:12:\"delete-81171\";i:80413;s:12:\"delete-81173\";i:80414;s:12:\"delete-81174\";i:80415;s:12:\"delete-81175\";i:80416;s:12:\"delete-81176\";i:80417;s:12:\"delete-81177\";i:80418;s:12:\"delete-81178\";i:80419;s:12:\"delete-81180\";i:80420;s:12:\"delete-81181\";i:80421;s:12:\"delete-81184\";i:80422;s:12:\"delete-81186\";i:80423;s:12:\"delete-81179\";i:80424;s:12:\"delete-81182\";i:80425;s:12:\"delete-81183\";i:80426;s:12:\"delete-81185\";i:80427;s:12:\"delete-81187\";i:80428;s:12:\"delete-81188\";i:80429;s:12:\"delete-81189\";i:80430;s:12:\"delete-81190\";i:80431;s:12:\"delete-81192\";i:80432;s:12:\"delete-81193\";i:80433;s:12:\"delete-81196\";i:80434;s:12:\"delete-81191\";i:80435;s:12:\"delete-81194\";i:80436;s:12:\"delete-81195\";i:80437;s:12:\"delete-81197\";i:80438;s:12:\"delete-81198\";i:80439;s:12:\"delete-81199\";i:80440;s:12:\"delete-81200\";i:80441;s:12:\"delete-81201\";i:80442;s:12:\"delete-81203\";i:80443;s:12:\"delete-81202\";i:80444;s:12:\"delete-81204\";i:80445;s:12:\"delete-81205\";i:80446;s:12:\"delete-81208\";i:80447;s:12:\"delete-81206\";i:80448;s:12:\"delete-81207\";i:80449;s:12:\"delete-81209\";i:80450;s:12:\"delete-81210\";i:80451;s:12:\"delete-81211\";i:80452;s:12:\"delete-81214\";i:80453;s:12:\"delete-81212\";i:80454;s:12:\"delete-81213\";i:80455;s:12:\"delete-81215\";i:80456;s:12:\"delete-81216\";i:80457;s:12:\"delete-81217\";i:80458;s:12:\"delete-81220\";i:80459;s:12:\"delete-81218\";i:80460;s:12:\"delete-81219\";i:80461;s:12:\"delete-81221\";i:80462;s:12:\"delete-81222\";i:80463;s:12:\"delete-81223\";i:80464;s:12:\"delete-81226\";i:80465;s:12:\"delete-81228\";i:80466;s:12:\"delete-81224\";i:80467;s:12:\"delete-81225\";i:80468;s:12:\"delete-81227\";i:80469;s:12:\"delete-81229\";i:80470;s:12:\"delete-81232\";i:80471;s:12:\"delete-81234\";i:80472;s:12:\"delete-81230\";i:80473;s:12:\"delete-81231\";i:80474;s:12:\"delete-81233\";i:80475;s:12:\"delete-81235\";i:80476;s:12:\"delete-81238\";i:80477;s:12:\"delete-81240\";i:80478;s:12:\"delete-81236\";i:80479;s:12:\"delete-81237\";i:80480;s:12:\"delete-81239\";i:80481;s:12:\"delete-81241\";i:80482;s:12:\"delete-81244\";i:80483;s:12:\"delete-81246\";i:80484;s:12:\"delete-81242\";i:80485;s:12:\"delete-81243\";i:80486;s:12:\"delete-81245\";i:80487;s:12:\"delete-81247\";i:80488;s:12:\"delete-81248\";i:80489;s:12:\"delete-81249\";i:80490;s:12:\"delete-81251\";i:80491;s:12:\"delete-81250\";i:80492;s:12:\"delete-81252\";i:80493;s:12:\"delete-81254\";i:80494;s:12:\"delete-81255\";i:80495;s:12:\"delete-81253\";i:80496;s:12:\"delete-81256\";i:80497;s:12:\"delete-81258\";i:80498;s:12:\"delete-81257\";i:80499;s:12:\"delete-81260\";i:80500;s:12:\"delete-81261\";i:80501;s:12:\"delete-81259\";i:80502;s:12:\"delete-81262\";i:80503;s:12:\"delete-81264\";i:80504;s:12:\"delete-81265\";i:80505;s:12:\"delete-81268\";i:80506;s:12:\"delete-81263\";i:80507;s:12:\"delete-81266\";i:80508;s:12:\"delete-81267\";i:80509;s:12:\"delete-81269\";i:80510;s:12:\"delete-81270\";i:80511;s:12:\"delete-81271\";i:80512;s:12:\"delete-81274\";i:80513;s:12:\"delete-81276\";i:80514;s:12:\"delete-81272\";i:80515;s:12:\"delete-81273\";i:80516;s:12:\"delete-81275\";i:80517;s:12:\"delete-81277\";i:80518;s:12:\"delete-81280\";i:80519;s:12:\"delete-81278\";i:80520;s:12:\"delete-81279\";i:80521;s:12:\"delete-81281\";i:80522;s:12:\"delete-81282\";i:80523;s:12:\"delete-81283\";i:80524;s:12:\"delete-81286\";i:80525;s:12:\"delete-81284\";i:80526;s:12:\"delete-81285\";i:80527;s:12:\"delete-81287\";i:80528;s:12:\"delete-81288\";i:80529;s:12:\"delete-81289\";i:80530;s:12:\"delete-81292\";i:80531;s:12:\"delete-81294\";i:80532;s:12:\"delete-81290\";i:80533;s:12:\"delete-81291\";i:80534;s:12:\"delete-81293\";i:80535;s:12:\"delete-81295\";i:80536;s:12:\"delete-81296\";i:80537;s:12:\"delete-81297\";i:80538;s:12:\"delete-81299\";i:80539;s:12:\"delete-81298\";i:80540;s:12:\"delete-81300\";i:80541;s:12:\"delete-81301\";i:80542;s:12:\"delete-81304\";i:80543;s:12:\"delete-81306\";i:80544;s:12:\"delete-81302\";i:80545;s:12:\"delete-81303\";i:80546;s:12:\"delete-81305\";i:80547;s:12:\"delete-81307\";i:80548;s:12:\"delete-81310\";i:80549;s:12:\"delete-81312\";i:80550;s:12:\"delete-81313\";i:80551;s:12:\"delete-81308\";i:80552;s:12:\"delete-81309\";i:80553;s:12:\"delete-81311\";i:80554;s:12:\"delete-81314\";i:80555;s:12:\"delete-81315\";i:80556;s:12:\"delete-81316\";i:80557;s:12:\"delete-81318\";i:80558;s:12:\"delete-81319\";i:80559;s:12:\"delete-81322\";i:80560;s:12:\"delete-81324\";i:80561;s:12:\"delete-81317\";i:80562;s:12:\"delete-81320\";i:80563;s:12:\"delete-81321\";i:80564;s:12:\"delete-81323\";i:80565;s:12:\"delete-81325\";i:80566;s:12:\"delete-81328\";i:80567;s:12:\"delete-81326\";i:80568;s:12:\"delete-81327\";i:80569;s:12:\"delete-81329\";i:80570;s:12:\"delete-81330\";i:80571;s:12:\"delete-81331\";i:80572;s:12:\"delete-81334\";i:80573;s:12:\"delete-81332\";i:80574;s:12:\"delete-81333\";i:80575;s:12:\"delete-81335\";i:80576;s:12:\"delete-81336\";i:80577;s:12:\"delete-81337\";i:80578;s:12:\"delete-81338\";i:80579;s:12:\"delete-81339\";i:80580;s:12:\"delete-81341\";i:80581;s:12:\"delete-81340\";i:80582;s:12:\"delete-81342\";i:80583;s:12:\"delete-81343\";i:80584;s:12:\"delete-81344\";i:80585;s:12:\"delete-81345\";i:80586;s:12:\"delete-81347\";i:80587;s:12:\"delete-81346\";i:80588;s:12:\"delete-81348\";i:80589;s:12:\"delete-81349\";i:80590;s:12:\"delete-81350\";i:80591;s:12:\"delete-81351\";i:80592;s:12:\"delete-81353\";i:80593;s:12:\"delete-81352\";i:80594;s:12:\"delete-81354\";i:80595;s:12:\"delete-81355\";i:80596;s:12:\"delete-81358\";i:80597;s:12:\"delete-81360\";i:80598;s:12:\"delete-81356\";i:80599;s:12:\"delete-81357\";i:80600;s:12:\"delete-81359\";i:80601;s:12:\"delete-81361\";i:80602;s:12:\"delete-81364\";i:80603;s:12:\"delete-81362\";i:80604;s:12:\"delete-81363\";i:80605;s:12:\"delete-81365\";i:80606;s:12:\"delete-81366\";i:80607;s:12:\"delete-81367\";i:80608;s:12:\"delete-81368\";i:80609;s:12:\"delete-81369\";i:80610;s:12:\"delete-81371\";i:80611;s:12:\"delete-81370\";i:80612;s:12:\"delete-81372\";i:80613;s:12:\"delete-81373\";i:80614;s:12:\"delete-81376\";i:80615;s:12:\"delete-81378\";i:80616;s:12:\"delete-81379\";i:80617;s:12:\"delete-81374\";i:80618;s:12:\"delete-81375\";i:80619;s:12:\"delete-81377\";i:80620;s:12:\"delete-81380\";i:80621;s:12:\"delete-81381\";i:80622;s:12:\"delete-81382\";i:80623;s:12:\"delete-81384\";i:80624;s:12:\"delete-81385\";i:80625;s:12:\"delete-81388\";i:80626;s:12:\"delete-81383\";i:80627;s:12:\"delete-81386\";i:80628;s:12:\"delete-81387\";i:80629;s:12:\"delete-81389\";i:80630;s:12:\"delete-81390\";i:80631;s:12:\"delete-81391\";i:80632;s:12:\"delete-81394\";i:80633;s:12:\"delete-81392\";i:80634;s:12:\"delete-81393\";i:80635;s:12:\"delete-81395\";i:80636;s:12:\"delete-81396\";i:80637;s:12:\"delete-81397\";i:80638;s:12:\"delete-81400\";i:80639;s:12:\"delete-81398\";i:80640;s:12:\"delete-81399\";i:80641;s:12:\"delete-81401\";i:80642;s:12:\"delete-81402\";i:80643;s:12:\"delete-81403\";i:80644;s:12:\"delete-81406\";i:80645;s:12:\"delete-81408\";i:80646;s:12:\"delete-81404\";i:80647;s:12:\"delete-81405\";i:80648;s:12:\"delete-81407\";i:80649;s:12:\"delete-81409\";i:80650;s:12:\"delete-81412\";i:80651;s:12:\"delete-81414\";i:80652;s:12:\"delete-81410\";i:80653;s:12:\"delete-81411\";i:80654;s:12:\"delete-81413\";i:80655;s:12:\"delete-81415\";i:80656;s:12:\"delete-81418\";i:80657;s:12:\"delete-81420\";i:80658;s:12:\"delete-81416\";i:80659;s:12:\"delete-81417\";i:80660;s:12:\"delete-81419\";i:80661;s:12:\"delete-81421\";i:80662;s:12:\"delete-81424\";i:80663;s:12:\"delete-81422\";i:80664;s:12:\"delete-81423\";i:80665;s:12:\"delete-81425\";i:80666;s:12:\"delete-81426\";i:80667;s:12:\"delete-81427\";i:80668;s:12:\"delete-81430\";i:80669;s:12:\"delete-81428\";i:80670;s:12:\"delete-81429\";i:80671;s:12:\"delete-81431\";i:80672;s:12:\"delete-81432\";i:80673;s:12:\"delete-81433\";i:80674;s:12:\"delete-81434\";i:80675;s:12:\"delete-81437\";i:80676;s:12:\"delete-81439\";i:80677;s:12:\"delete-81440\";i:80678;s:12:\"delete-81441\";i:80679;s:12:\"delete-81435\";i:80680;s:12:\"delete-81436\";i:80681;s:12:\"delete-81438\";i:80682;s:12:\"delete-81442\";i:80683;s:12:\"delete-81443\";i:80684;s:12:\"delete-81445\";i:80685;s:12:\"delete-81444\";i:80686;s:12:\"delete-81446\";i:80687;s:12:\"delete-81447\";i:80688;s:12:\"delete-81448\";i:80689;s:12:\"delete-81451\";i:80690;s:12:\"delete-81449\";i:80691;s:12:\"delete-81450\";i:80692;s:12:\"delete-81452\";i:80693;s:12:\"delete-81453\";i:80694;s:12:\"delete-81454\";i:80695;s:12:\"delete-81456\";i:80696;s:12:\"delete-81455\";i:80697;s:12:\"delete-81457\";i:80698;s:12:\"delete-81459\";i:80699;s:12:\"delete-81458\";i:80700;s:12:\"delete-81460\";i:80701;s:12:\"delete-81462\";i:80702;s:12:\"delete-81461\";i:80703;s:12:\"delete-81463\";i:80704;s:12:\"delete-81465\";i:80705;s:12:\"delete-81464\";i:80706;s:12:\"delete-81466\";i:80707;s:12:\"delete-81468\";i:80708;s:12:\"delete-81467\";i:80709;s:12:\"delete-81469\";i:80710;s:12:\"delete-81471\";i:80711;s:12:\"delete-81470\";i:80712;s:12:\"delete-81472\";i:80713;s:12:\"delete-81474\";i:80714;s:12:\"delete-81473\";i:80715;s:12:\"delete-81475\";i:80716;s:12:\"delete-81477\";i:80717;s:12:\"delete-81476\";i:80718;s:12:\"delete-81478\";i:80719;s:12:\"delete-81480\";i:80720;s:12:\"delete-81481\";i:80721;s:12:\"delete-81483\";i:80722;s:12:\"delete-81479\";i:80723;s:12:\"delete-81482\";i:80724;s:12:\"delete-81484\";i:80725;s:12:\"delete-81486\";i:80726;s:12:\"delete-81485\";i:80727;s:12:\"delete-81491\";i:80728;s:12:\"delete-81493\";i:80729;s:12:\"delete-81492\";i:80730;s:12:\"delete-81494\";i:80731;s:12:\"delete-81496\";i:80732;s:12:\"delete-81495\";i:80733;s:12:\"delete-81497\";i:80734;s:12:\"delete-81499\";i:80735;s:12:\"delete-81498\";i:80736;s:12:\"delete-81500\";i:80737;s:12:\"delete-81502\";i:80738;s:12:\"delete-81501\";i:80739;s:12:\"delete-81503\";i:80740;s:12:\"delete-81504\";i:80741;s:12:\"delete-81505\";i:80742;s:12:\"delete-81506\";i:80743;s:12:\"delete-81507\";i:80744;s:12:\"delete-81508\";i:80745;s:12:\"delete-81509\";i:80746;s:12:\"delete-81511\";i:80747;s:12:\"delete-81510\";i:80748;s:12:\"delete-81512\";i:80749;s:12:\"delete-81514\";i:80750;s:12:\"delete-81513\";i:80751;s:12:\"delete-81515\";i:80752;s:12:\"delete-81516\";i:80753;s:12:\"delete-81517\";i:80754;s:12:\"delete-81518\";i:80755;s:12:\"delete-81520\";i:80756;s:12:\"delete-81519\";i:80757;s:12:\"delete-81521\";i:80758;s:12:\"delete-81523\";i:80759;s:12:\"delete-81522\";i:80760;s:12:\"delete-81524\";i:80761;s:12:\"delete-81526\";i:80762;s:12:\"delete-81525\";i:80763;s:12:\"delete-81527\";i:80764;s:12:\"delete-81529\";i:80765;s:12:\"delete-81528\";i:80766;s:12:\"delete-81530\";i:80767;s:12:\"delete-81532\";i:80768;s:12:\"delete-81531\";i:80769;s:12:\"delete-81533\";i:80770;s:12:\"delete-81534\";i:80771;s:12:\"delete-81535\";i:80772;s:12:\"delete-81536\";i:80773;s:12:\"delete-81538\";i:80774;s:12:\"delete-81537\";i:80775;s:12:\"delete-81539\";i:80776;s:12:\"delete-81541\";i:80777;s:12:\"delete-81540\";i:80778;s:12:\"delete-81542\";i:80779;s:12:\"delete-81543\";i:80780;s:12:\"delete-81544\";i:80781;s:12:\"delete-81545\";i:80782;s:12:\"delete-81547\";i:80783;s:12:\"delete-81546\";i:80784;s:12:\"delete-81548\";i:80785;s:12:\"delete-81550\";i:80786;s:12:\"delete-81549\";i:80787;s:12:\"delete-81551\";i:80788;s:12:\"delete-81553\";i:80789;s:12:\"delete-81552\";i:80790;s:12:\"delete-81554\";i:80791;s:12:\"delete-81556\";i:80792;s:12:\"delete-81555\";i:80793;s:12:\"delete-81557\";i:80794;s:12:\"delete-81559\";i:80795;s:12:\"delete-81558\";i:80796;s:12:\"delete-81560\";i:80797;s:12:\"delete-81562\";i:80798;s:12:\"delete-81561\";i:80799;s:12:\"delete-81563\";i:80800;s:12:\"delete-81565\";i:80801;s:12:\"delete-81564\";i:80802;s:12:\"delete-81566\";i:80803;s:12:\"delete-81568\";i:80804;s:12:\"delete-81567\";i:80805;s:12:\"delete-81569\";i:80806;s:12:\"delete-81570\";i:80807;s:12:\"delete-81571\";i:80808;s:12:\"delete-81572\";i:80809;s:12:\"delete-81574\";i:80810;s:12:\"delete-81575\";i:80811;s:12:\"delete-81577\";i:80812;s:12:\"delete-81573\";i:80813;s:12:\"delete-81576\";i:80814;s:12:\"delete-81578\";i:80815;s:12:\"delete-81579\";i:80816;s:12:\"delete-81580\";i:80817;s:12:\"delete-81581\";i:80818;s:12:\"delete-81583\";i:80819;s:12:\"delete-81582\";i:80820;s:12:\"delete-81584\";i:80821;s:12:\"delete-81586\";i:80822;s:12:\"delete-81585\";i:80823;s:12:\"delete-81587\";i:80824;s:12:\"delete-81589\";i:80825;s:12:\"delete-81588\";i:80826;s:12:\"delete-81590\";i:80827;s:12:\"delete-81592\";i:80828;s:12:\"delete-81591\";i:80829;s:12:\"delete-81593\";i:80830;s:12:\"delete-81595\";i:80831;s:12:\"delete-81594\";i:80832;s:12:\"delete-81596\";i:80833;s:12:\"delete-81597\";i:80834;s:12:\"delete-81598\";i:80835;s:12:\"delete-81599\";i:80836;s:12:\"delete-81601\";i:80837;s:12:\"delete-81600\";i:80838;s:12:\"delete-81602\";i:80839;s:12:\"delete-81604\";i:80840;s:12:\"delete-81603\";i:80841;s:12:\"delete-81605\";i:80842;s:12:\"delete-81607\";i:80843;s:12:\"delete-81606\";i:80844;s:12:\"delete-81608\";i:80845;s:12:\"delete-81610\";i:80846;s:12:\"delete-81609\";i:80847;s:12:\"delete-81611\";i:80848;s:12:\"delete-81612\";i:80849;s:12:\"delete-81613\";i:80850;s:12:\"delete-81614\";i:80851;s:12:\"delete-81615\";i:80852;s:12:\"delete-81616\";i:80853;s:12:\"delete-81617\";i:80854;s:12:\"delete-81619\";i:80855;s:12:\"delete-81620\";i:80856;s:12:\"delete-81622\";i:80857;s:12:\"delete-81618\";i:80858;s:12:\"delete-81621\";i:80859;s:12:\"delete-81623\";i:80860;s:12:\"delete-81625\";i:80861;s:12:\"delete-81624\";i:80862;s:12:\"delete-81626\";i:80863;s:12:\"delete-81628\";i:80864;s:12:\"delete-81627\";i:80865;s:12:\"delete-81629\";i:80866;s:12:\"delete-81631\";i:80867;s:12:\"delete-81632\";i:80868;s:12:\"delete-81630\";i:80869;s:12:\"delete-81633\";i:80870;s:12:\"delete-81634\";i:80871;s:12:\"delete-81635\";i:80872;s:12:\"delete-81637\";i:80873;s:12:\"delete-81636\";i:80874;s:12:\"delete-81638\";i:80875;s:12:\"delete-81640\";i:80876;s:12:\"delete-81639\";i:80877;s:12:\"delete-81641\";i:80878;s:12:\"delete-81643\";i:80879;s:12:\"delete-81642\";i:80880;s:12:\"delete-81644\";i:80881;s:12:\"delete-81646\";i:80882;s:12:\"delete-81645\";i:80883;s:12:\"delete-81647\";i:80884;s:12:\"delete-81649\";i:80885;s:12:\"delete-81648\";i:80886;s:12:\"delete-81650\";i:80887;s:12:\"delete-81652\";i:80888;s:12:\"delete-81651\";i:80889;s:12:\"delete-81653\";i:80890;s:12:\"delete-81655\";i:80891;s:12:\"delete-81654\";i:80892;s:12:\"delete-81656\";i:80893;s:12:\"delete-81657\";i:80894;s:12:\"delete-81658\";i:80895;s:12:\"delete-81659\";i:80896;s:12:\"delete-81661\";i:80897;s:12:\"delete-81660\";i:80898;s:12:\"delete-81662\";i:80899;s:12:\"delete-81664\";i:80900;s:12:\"delete-81663\";i:80901;s:12:\"delete-81665\";i:80902;s:12:\"delete-81667\";i:80903;s:12:\"delete-81666\";i:80904;s:12:\"delete-81668\";i:80905;s:12:\"delete-81670\";i:80906;s:12:\"delete-81669\";i:80907;s:12:\"delete-81671\";i:80908;s:12:\"delete-81673\";i:80909;s:12:\"delete-81672\";i:80910;s:12:\"delete-81674\";i:80911;s:12:\"delete-81676\";i:80912;s:12:\"delete-81675\";i:80913;s:12:\"delete-81677\";i:80914;s:12:\"delete-81679\";i:80915;s:12:\"delete-81678\";i:80916;s:12:\"delete-81680\";i:80917;s:12:\"delete-81682\";i:80918;s:12:\"delete-81681\";i:80919;s:12:\"delete-81683\";i:80920;s:12:\"delete-81685\";i:80921;s:12:\"delete-81684\";i:80922;s:12:\"delete-81686\";i:80923;s:12:\"delete-81687\";i:80924;s:12:\"delete-81688\";i:80925;s:12:\"delete-81689\";i:80926;s:12:\"delete-81691\";i:80927;s:12:\"delete-81690\";i:80928;s:12:\"delete-81692\";i:80929;s:12:\"delete-81694\";i:80930;s:12:\"delete-81693\";i:80931;s:12:\"delete-81695\";i:80932;s:12:\"delete-81696\";i:80933;s:12:\"delete-81697\";i:80934;s:12:\"delete-81698\";i:80935;s:12:\"delete-81700\";i:80936;s:12:\"delete-81699\";i:80937;s:12:\"delete-81701\";i:80938;s:12:\"delete-81703\";i:80939;s:12:\"delete-81702\";i:80940;s:12:\"delete-81704\";i:80941;s:12:\"delete-81706\";i:80942;s:12:\"delete-81705\";i:80943;s:12:\"delete-81707\";i:80944;s:12:\"delete-81709\";i:80945;s:12:\"delete-81708\";i:80946;s:12:\"delete-81710\";i:80947;s:12:\"delete-81712\";i:80948;s:12:\"delete-81711\";i:80949;s:12:\"delete-81713\";i:80950;s:12:\"delete-81715\";i:80951;s:12:\"delete-81714\";i:80952;s:12:\"delete-81716\";i:80953;s:12:\"delete-81718\";i:80954;s:12:\"delete-81717\";i:80955;s:12:\"delete-81719\";i:80956;s:12:\"delete-81721\";i:80957;s:12:\"delete-81720\";i:80958;s:12:\"delete-81722\";i:80959;s:12:\"delete-81723\";i:80960;s:12:\"delete-81725\";i:80961;s:12:\"delete-81724\";i:80962;s:12:\"delete-81726\";i:80963;s:12:\"delete-81728\";i:80964;s:12:\"delete-81727\";i:80965;s:12:\"delete-81729\";i:80966;s:12:\"delete-81731\";i:80967;s:12:\"delete-81730\";i:80968;s:12:\"delete-81732\";i:80969;s:12:\"delete-81734\";i:80970;s:12:\"delete-81733\";i:80971;s:12:\"delete-81735\";i:80972;s:12:\"delete-81737\";i:80973;s:12:\"delete-81738\";i:80974;s:12:\"delete-81740\";i:80975;s:12:\"delete-81736\";i:80976;s:12:\"delete-81739\";i:80977;s:12:\"delete-81741\";i:80978;s:12:\"delete-81743\";i:80979;s:12:\"delete-81742\";i:80980;s:12:\"delete-81744\";i:80981;s:12:\"delete-81746\";i:80982;s:12:\"delete-81745\";i:80983;s:12:\"delete-81747\";i:80984;s:12:\"delete-81748\";i:80985;s:12:\"delete-81749\";i:80986;s:12:\"delete-81750\";i:80987;s:12:\"delete-81752\";i:80988;s:12:\"delete-81751\";i:80989;s:12:\"delete-81753\";i:80990;s:12:\"delete-81755\";i:80991;s:12:\"delete-81754\";i:80992;s:12:\"delete-81756\";i:80993;s:12:\"delete-81757\";i:80994;s:12:\"delete-81758\";i:80995;s:12:\"delete-81759\";i:80996;s:12:\"delete-81761\";i:80997;s:12:\"delete-81760\";i:80998;s:12:\"delete-81762\";i:80999;s:12:\"delete-81764\";i:81000;s:12:\"delete-81763\";i:81001;s:12:\"delete-81765\";i:81002;s:12:\"delete-81767\";i:81003;s:12:\"delete-81766\";i:81004;s:12:\"delete-81768\";i:81005;s:12:\"delete-81770\";i:81006;s:12:\"delete-81769\";i:81007;s:12:\"delete-81771\";i:81008;s:12:\"delete-81773\";i:81009;s:12:\"delete-81772\";i:81010;s:12:\"delete-81774\";i:81011;s:12:\"delete-81776\";i:81012;s:12:\"delete-81775\";i:81013;s:12:\"delete-81777\";i:81014;s:12:\"delete-81778\";i:81015;s:12:\"delete-81779\";i:81016;s:12:\"delete-81780\";i:81017;s:12:\"delete-81782\";i:81018;s:12:\"delete-81781\";i:81019;s:12:\"delete-81783\";i:81020;s:12:\"delete-81785\";i:81021;s:12:\"delete-81784\";i:81022;s:12:\"delete-81786\";i:81023;s:12:\"delete-81788\";i:81024;s:12:\"delete-81787\";i:81025;s:12:\"delete-81789\";i:81026;s:12:\"delete-81791\";i:81027;s:12:\"delete-81790\";i:81028;s:12:\"delete-81792\";i:81029;s:12:\"delete-81794\";i:81030;s:12:\"delete-81793\";i:81031;s:12:\"delete-81795\";i:81032;s:12:\"delete-81797\";i:81033;s:12:\"delete-81796\";i:81034;s:12:\"delete-81798\";i:81035;s:12:\"delete-81800\";i:81036;s:12:\"delete-81799\";i:81037;s:12:\"delete-81801\";i:81038;s:12:\"delete-81803\";i:81039;s:12:\"delete-81802\";i:81040;s:12:\"delete-81804\";i:81041;s:12:\"delete-81806\";i:81042;s:12:\"delete-81807\";i:81043;s:12:\"delete-81809\";i:81044;s:12:\"delete-81805\";i:81045;s:12:\"delete-81808\";i:81046;s:12:\"delete-81810\";i:81047;s:12:\"delete-81812\";i:81048;s:12:\"delete-81811\";i:81049;s:12:\"delete-81813\";i:81050;s:12:\"delete-81815\";i:81051;s:12:\"delete-81814\";i:81052;s:12:\"delete-81817\";i:81053;s:12:\"delete-81816\";i:81054;s:12:\"delete-81818\";i:81055;s:12:\"delete-81819\";i:81056;s:12:\"delete-81821\";i:81057;s:12:\"delete-81820\";i:81058;s:12:\"delete-81822\";i:81059;s:12:\"delete-81824\";i:81060;s:12:\"delete-81823\";i:81061;s:12:\"delete-81825\";i:81062;s:12:\"delete-81827\";i:81063;s:12:\"delete-81826\";i:81064;s:12:\"delete-81828\";i:81065;s:12:\"delete-81830\";i:81066;s:12:\"delete-81829\";i:81067;s:12:\"delete-81831\";i:81068;s:12:\"delete-81832\";i:81069;s:12:\"delete-81833\";i:81070;s:12:\"delete-81834\";i:81071;s:12:\"delete-81836\";i:81072;s:12:\"delete-81837\";i:81073;s:12:\"delete-81839\";i:81074;s:12:\"delete-81835\";i:81075;s:12:\"delete-81838\";i:81076;s:12:\"delete-81840\";i:81077;s:12:\"delete-81842\";i:81078;s:12:\"delete-81841\";i:81079;s:12:\"delete-81843\";i:81080;s:12:\"delete-81845\";i:81081;s:12:\"delete-81844\";i:81082;s:12:\"delete-81846\";i:81083;s:12:\"delete-81848\";i:81084;s:12:\"delete-81847\";i:81085;s:12:\"delete-81849\";i:81086;s:12:\"delete-81851\";i:81087;s:12:\"delete-81850\";i:81088;s:12:\"delete-81852\";i:81089;s:12:\"delete-81854\";i:81090;s:12:\"delete-81853\";i:81091;s:12:\"delete-81855\";i:81092;s:12:\"delete-81857\";i:81093;s:12:\"delete-81856\";i:81094;s:12:\"delete-81858\";i:81095;s:12:\"delete-81860\";i:81096;s:12:\"delete-81859\";i:81097;s:12:\"delete-81861\";i:81098;s:12:\"delete-81862\";i:81099;s:12:\"delete-81863\";i:81100;s:12:\"delete-81864\";i:81101;s:12:\"delete-81866\";i:81102;s:12:\"delete-81865\";i:81103;s:12:\"delete-81867\";i:81104;s:12:\"delete-81869\";i:81105;s:12:\"delete-81868\";i:81106;s:12:\"delete-81870\";i:81107;s:12:\"delete-81872\";i:81108;s:12:\"delete-81871\";i:81109;s:12:\"delete-81873\";i:81110;s:12:\"delete-81875\";i:81111;s:12:\"delete-81874\";i:81112;s:12:\"delete-81876\";i:81113;s:12:\"delete-81878\";i:81114;s:12:\"delete-81877\";i:81115;s:12:\"delete-81879\";i:81116;s:12:\"delete-81880\";i:81117;s:12:\"delete-81881\";i:81118;s:12:\"delete-81882\";i:81119;s:12:\"delete-81884\";i:81120;s:12:\"delete-81883\";i:81121;s:12:\"delete-81885\";i:81122;s:12:\"delete-81887\";i:81123;s:12:\"delete-81886\";i:81124;s:12:\"delete-81888\";i:81125;s:12:\"delete-81890\";i:81126;s:12:\"delete-81889\";i:81127;s:12:\"delete-81891\";i:81128;s:12:\"delete-81893\";i:81129;s:12:\"delete-81892\";i:81130;s:12:\"delete-81894\";i:81131;s:12:\"delete-81896\";i:81132;s:12:\"delete-81895\";i:81133;s:12:\"delete-81897\";i:81134;s:12:\"delete-81899\";i:81135;s:12:\"delete-81900\";i:81136;s:12:\"delete-81902\";i:81137;s:12:\"delete-81898\";i:81138;s:12:\"delete-81901\";i:81139;s:12:\"delete-81903\";i:81140;s:12:\"delete-81905\";i:81141;s:12:\"delete-81904\";i:81142;s:12:\"delete-81906\";i:81143;s:12:\"delete-81908\";i:81144;s:12:\"delete-81907\";i:81145;s:12:\"delete-81909\";i:81146;s:12:\"delete-81910\";i:81147;s:12:\"delete-81911\";i:81148;s:12:\"delete-81912\";i:81149;s:12:\"delete-81914\";i:81150;s:12:\"delete-81913\";i:81151;s:12:\"delete-81915\";i:81152;s:12:\"delete-81917\";i:81153;s:12:\"delete-81916\";i:81154;s:12:\"delete-81918\";i:81155;s:12:\"delete-81920\";i:81156;s:12:\"delete-81919\";i:81157;s:12:\"delete-81921\";i:81158;s:12:\"delete-81922\";i:81159;s:12:\"delete-81923\";i:81160;s:12:\"delete-81924\";i:81161;s:12:\"delete-81925\";i:81162;s:12:\"delete-81926\";i:81163;s:12:\"delete-81927\";i:81164;s:12:\"delete-81928\";i:81165;s:12:\"delete-81929\";i:81166;s:12:\"delete-81930\";i:81167;s:12:\"delete-81932\";i:81168;s:12:\"delete-81931\";i:81169;s:12:\"delete-81933\";i:81170;s:12:\"delete-81934\";i:81171;s:12:\"delete-81935\";i:81172;s:12:\"delete-81936\";i:81173;s:12:\"delete-81937\";i:81174;s:12:\"delete-81938\";i:81175;s:12:\"delete-81939\";i:81176;s:12:\"delete-81941\";i:81177;s:12:\"delete-81940\";i:81178;s:12:\"delete-81942\";i:81179;s:12:\"delete-81944\";i:81180;s:12:\"delete-81943\";i:81181;s:12:\"delete-81945\";i:81182;s:12:\"delete-81947\";i:81183;s:12:\"delete-81946\";i:81184;s:12:\"delete-81948\";i:81185;s:12:\"delete-81950\";i:81186;s:12:\"delete-81949\";i:81187;s:12:\"delete-81951\";i:81188;s:12:\"delete-81953\";i:81189;s:12:\"delete-81952\";i:81190;s:12:\"delete-81954\";i:81191;s:12:\"delete-81956\";i:81192;s:12:\"delete-81955\";i:81193;s:12:\"delete-81957\";i:81194;s:12:\"delete-81959\";i:81195;s:12:\"delete-81958\";i:81196;s:12:\"delete-81960\";i:81197;s:12:\"delete-81962\";i:81198;s:12:\"delete-81961\";i:81199;s:12:\"delete-81963\";i:81200;s:12:\"delete-81964\";i:81201;s:12:\"delete-81965\";i:81202;s:12:\"delete-81966\";i:81203;s:12:\"delete-81968\";i:81204;s:12:\"delete-81967\";i:81205;s:12:\"delete-81969\";i:81206;s:12:\"delete-81971\";i:81207;s:12:\"delete-81972\";i:81208;s:12:\"delete-81974\";i:81209;s:12:\"delete-81970\";i:81210;s:12:\"delete-81973\";i:81211;s:12:\"delete-81975\";i:81212;s:12:\"delete-81977\";i:81213;s:12:\"delete-81976\";i:81214;s:12:\"delete-81978\";i:81215;s:12:\"delete-81980\";i:81216;s:12:\"delete-81979\";i:81217;s:12:\"delete-81981\";i:81218;s:12:\"delete-81983\";i:81219;s:12:\"delete-81984\";i:81220;s:12:\"delete-81986\";i:81221;s:12:\"delete-81982\";i:81222;s:12:\"delete-81985\";i:81223;s:12:\"delete-81987\";i:81224;s:12:\"delete-81989\";i:81225;s:12:\"delete-81988\";i:81226;s:12:\"delete-81990\";i:81227;s:12:\"delete-81992\";i:81228;s:12:\"delete-81991\";i:81229;s:12:\"delete-81993\";i:81230;s:12:\"delete-81995\";i:81231;s:12:\"delete-81994\";i:81232;s:12:\"delete-81996\";i:81233;s:12:\"delete-81998\";i:81234;s:12:\"delete-81997\";i:81235;s:12:\"delete-81999\";i:81236;s:12:\"delete-82001\";i:81237;s:12:\"delete-82000\";i:81238;s:12:\"delete-82002\";i:81239;s:12:\"delete-82003\";i:81240;s:12:\"delete-82004\";i:81241;s:12:\"delete-82005\";i:81242;s:12:\"delete-82007\";i:81243;s:12:\"delete-82006\";i:81244;s:12:\"delete-82008\";i:81245;s:12:\"delete-82009\";i:81246;s:12:\"delete-82011\";i:81247;s:12:\"delete-82010\";i:81248;s:12:\"delete-82012\";i:81249;s:12:\"delete-82014\";i:81250;s:12:\"delete-82013\";i:81251;s:12:\"delete-82015\";i:81252;s:12:\"delete-82016\";i:81253;s:12:\"delete-82017\";i:81254;s:12:\"delete-82018\";i:81255;s:12:\"delete-82020\";i:81256;s:12:\"delete-82019\";i:81257;s:12:\"delete-82021\";i:81258;s:12:\"delete-82022\";i:81259;s:12:\"delete-82023\";i:81260;s:12:\"delete-82024\";i:81261;s:12:\"delete-82026\";i:81262;s:12:\"delete-82025\";i:81263;s:12:\"delete-82027\";i:81264;s:12:\"delete-82029\";i:81265;s:12:\"delete-82028\";i:81266;s:12:\"delete-82030\";i:81267;s:12:\"delete-82032\";i:81268;s:12:\"delete-82031\";i:81269;s:12:\"delete-82033\";i:81270;s:12:\"delete-82035\";i:81271;s:12:\"delete-82034\";i:81272;s:12:\"delete-82036\";i:81273;s:12:\"delete-82038\";i:81274;s:12:\"delete-82037\";i:81275;s:12:\"delete-82039\";i:81276;s:12:\"delete-82041\";i:81277;s:12:\"delete-82040\";i:81278;s:12:\"delete-82042\";i:81279;s:12:\"delete-82044\";i:81280;s:12:\"delete-82045\";i:81281;s:12:\"delete-82047\";i:81282;s:12:\"delete-82043\";i:81283;s:12:\"delete-82046\";i:81284;s:12:\"delete-82048\";i:81285;s:12:\"delete-82050\";i:81286;s:12:\"delete-82049\";i:81287;s:12:\"delete-82051\";i:81288;s:12:\"delete-82053\";i:81289;s:12:\"delete-82052\";i:81290;s:12:\"delete-82054\";i:81291;s:12:\"delete-82056\";i:81292;s:12:\"delete-82055\";i:81293;s:12:\"delete-82057\";i:81294;s:12:\"delete-82059\";i:81295;s:12:\"delete-82058\";i:81296;s:12:\"delete-82060\";i:81297;s:12:\"delete-82062\";i:81298;s:12:\"delete-82061\";i:81299;s:12:\"delete-82063\";i:81300;s:12:\"delete-82065\";i:81301;s:12:\"delete-82064\";i:81302;s:12:\"delete-82066\";i:81303;s:12:\"delete-82068\";i:81304;s:12:\"delete-82067\";i:81305;s:12:\"delete-82069\";i:81306;s:12:\"delete-82071\";i:81307;s:12:\"delete-82072\";i:81308;s:12:\"delete-82070\";i:81309;s:12:\"delete-82073\";i:81310;s:12:\"delete-82074\";i:81311;s:12:\"delete-82075\";i:81312;s:12:\"delete-82077\";i:81313;s:12:\"delete-82076\";i:81314;s:12:\"delete-82078\";i:81315;s:12:\"delete-82080\";i:81316;s:12:\"delete-82079\";i:81317;s:12:\"delete-82081\";i:81318;s:12:\"delete-82083\";i:81319;s:12:\"delete-82082\";i:81320;s:12:\"delete-82084\";i:81321;s:12:\"delete-82086\";i:81322;s:12:\"delete-82085\";i:81323;s:12:\"delete-82087\";i:81324;s:12:\"delete-82089\";i:81325;s:12:\"delete-82088\";i:81326;s:12:\"delete-82090\";i:81327;s:12:\"delete-82092\";i:81328;s:12:\"delete-82091\";i:81329;s:12:\"delete-82093\";i:81330;s:12:\"delete-82095\";i:81331;s:12:\"delete-82094\";i:81332;s:12:\"delete-82096\";i:81333;s:12:\"delete-82098\";i:81334;s:12:\"delete-82099\";i:81335;s:12:\"delete-82101\";i:81336;s:12:\"delete-82097\";i:81337;s:12:\"delete-82100\";i:81338;s:12:\"delete-82102\";i:81339;s:12:\"delete-82104\";i:81340;s:12:\"delete-82103\";i:81341;s:12:\"delete-82105\";i:81342;s:12:\"delete-82107\";i:81343;s:12:\"delete-82106\";i:81344;s:12:\"delete-82108\";i:81345;s:12:\"delete-82110\";i:81346;s:12:\"delete-82109\";i:81347;s:12:\"delete-82111\";i:81348;s:12:\"delete-82113\";i:81349;s:12:\"delete-82112\";i:81350;s:12:\"delete-82114\";i:81351;s:12:\"delete-82116\";i:81352;s:12:\"delete-82115\";i:81353;s:12:\"delete-82117\";i:81354;s:12:\"delete-82119\";i:81355;s:12:\"delete-82118\";i:81356;s:12:\"delete-82120\";i:81357;s:12:\"delete-82122\";i:81358;s:12:\"delete-82121\";i:81359;s:12:\"delete-82123\";i:81360;s:12:\"delete-82125\";i:81361;s:12:\"delete-82124\";i:81362;s:12:\"delete-82126\";i:81363;s:12:\"delete-82128\";i:81364;s:12:\"delete-82127\";i:81365;s:12:\"delete-82129\";i:81366;s:12:\"delete-82131\";i:81367;s:12:\"delete-82132\";i:81368;s:12:\"delete-82134\";i:81369;s:12:\"delete-82130\";i:81370;s:12:\"delete-82133\";i:81371;s:12:\"delete-82135\";i:81372;s:12:\"delete-82137\";i:81373;s:12:\"delete-82136\";i:81374;s:12:\"delete-82138\";i:81375;s:12:\"delete-82140\";i:81376;s:12:\"delete-82139\";i:81377;s:12:\"delete-82141\";i:81378;s:12:\"delete-82143\";i:81379;s:12:\"delete-82144\";i:81380;s:12:\"delete-82146\";i:81381;s:12:\"delete-82142\";i:81382;s:12:\"delete-82145\";i:81383;s:12:\"delete-82147\";i:81384;s:12:\"delete-82149\";i:81385;s:12:\"delete-82148\";i:81386;s:12:\"delete-82150\";i:81387;s:12:\"delete-82152\";i:81388;s:12:\"delete-82151\";i:81389;s:12:\"delete-82153\";i:81390;s:12:\"delete-82155\";i:81391;s:12:\"delete-82154\";i:81392;s:12:\"delete-82156\";i:81393;s:12:\"delete-82157\";i:81394;s:12:\"delete-82158\";i:81395;s:12:\"delete-82159\";i:81396;s:12:\"delete-82160\";i:81397;s:12:\"delete-82161\";i:81398;s:12:\"delete-82162\";i:81399;s:12:\"delete-82164\";i:81400;s:12:\"delete-82163\";i:81401;s:12:\"delete-82165\";i:81402;s:12:\"delete-82166\";i:81403;s:12:\"delete-82167\";i:81404;s:12:\"delete-82168\";i:81405;s:12:\"delete-82170\";i:81406;s:12:\"delete-82169\";i:81407;s:12:\"delete-82171\";i:81408;s:12:\"delete-82173\";i:81409;s:12:\"delete-82172\";i:81410;s:12:\"delete-82174\";i:81411;s:12:\"delete-82176\";i:81412;s:12:\"delete-82175\";i:81413;s:12:\"delete-82177\";i:81414;s:12:\"delete-82179\";i:81415;s:12:\"delete-82178\";i:81416;s:12:\"delete-82180\";i:81417;s:12:\"delete-82182\";i:81418;s:12:\"delete-82181\";i:81419;s:12:\"delete-82183\";i:81420;s:12:\"delete-82185\";i:81421;s:12:\"delete-82184\";i:81422;s:12:\"delete-82186\";i:81423;s:12:\"delete-82188\";i:81424;s:12:\"delete-82189\";i:81425;s:12:\"delete-82187\";i:81426;s:12:\"delete-82190\";i:81427;s:12:\"delete-82191\";i:81428;s:12:\"delete-82192\";i:81429;s:12:\"delete-82194\";i:81430;s:12:\"delete-82193\";i:81431;s:12:\"delete-82195\";i:81432;s:12:\"delete-82197\";i:81433;s:12:\"delete-82196\";i:81434;s:12:\"delete-82198\";i:81435;s:12:\"delete-82200\";i:81436;s:12:\"delete-82199\";i:81437;s:12:\"delete-82201\";i:81438;s:12:\"delete-82203\";i:81439;s:12:\"delete-82202\";i:81440;s:12:\"delete-82204\";i:81441;s:12:\"delete-82206\";i:81442;s:12:\"delete-82205\";i:81443;s:12:\"delete-82207\";i:81444;s:12:\"delete-82209\";i:81445;s:12:\"delete-82208\";i:81446;s:12:\"delete-82210\";i:81447;s:12:\"delete-82212\";i:81448;s:12:\"delete-82211\";i:81449;s:12:\"delete-82213\";i:81450;s:12:\"delete-82215\";i:81451;s:12:\"delete-82214\";i:81452;s:12:\"delete-82216\";i:81453;s:12:\"delete-82217\";i:81454;s:12:\"delete-82218\";i:81455;s:12:\"delete-82219\";i:81456;s:12:\"delete-82221\";i:81457;s:12:\"delete-82222\";i:81458;s:12:\"delete-82224\";i:81459;s:12:\"delete-82220\";i:81460;s:12:\"delete-82223\";i:81461;s:12:\"delete-82225\";i:81462;s:12:\"delete-82227\";i:81463;s:12:\"delete-82226\";i:81464;s:12:\"delete-82228\";i:81465;s:12:\"delete-82230\";i:81466;s:12:\"delete-82229\";i:81467;s:12:\"delete-82231\";i:81468;s:12:\"delete-82233\";i:81469;s:12:\"delete-82232\";i:81470;s:12:\"delete-82234\";i:81471;s:12:\"delete-82236\";i:81472;s:12:\"delete-82235\";i:81473;s:12:\"delete-82237\";i:81474;s:12:\"delete-82239\";i:81475;s:12:\"delete-82238\";i:81476;s:12:\"delete-82240\";i:81477;s:12:\"delete-82242\";i:81478;s:12:\"delete-82241\";i:81479;s:12:\"delete-82243\";i:81480;s:12:\"delete-82244\";i:81481;s:12:\"delete-82245\";i:81482;s:12:\"delete-82246\";i:81483;s:12:\"delete-82247\";i:81484;s:12:\"delete-82248\";i:81485;s:12:\"delete-82249\";i:81486;s:12:\"delete-82251\";i:81487;s:12:\"delete-82250\";i:81488;s:12:\"delete-82252\";i:81489;s:12:\"delete-82253\";i:81490;s:12:\"delete-82254\";i:81491;s:12:\"delete-82255\";i:81492;s:12:\"delete-82257\";i:81493;s:12:\"delete-82256\";i:81494;s:12:\"delete-82258\";i:81495;s:12:\"delete-82260\";i:81496;s:12:\"delete-82259\";i:81497;s:12:\"delete-82261\";i:81498;s:12:\"delete-82263\";i:81499;s:12:\"delete-82262\";i:81500;s:12:\"delete-82264\";i:81501;s:12:\"delete-82266\";i:81502;s:12:\"delete-82265\";i:81503;s:12:\"delete-82267\";i:81504;s:12:\"delete-82268\";i:81505;s:12:\"delete-82269\";i:81506;s:12:\"delete-82270\";i:81507;s:12:\"delete-82272\";i:81508;s:12:\"delete-82271\";i:81509;s:12:\"delete-82273\";i:81510;s:12:\"delete-82275\";i:81511;s:12:\"delete-82274\";i:81512;s:12:\"delete-82276\";i:81513;s:12:\"delete-82278\";i:81514;s:12:\"delete-82277\";i:81515;s:12:\"delete-82279\";i:81516;s:12:\"delete-82281\";i:81517;s:12:\"delete-82280\";i:81518;s:12:\"delete-82283\";i:81519;s:12:\"delete-82282\";i:81520;s:12:\"delete-82284\";i:81521;s:12:\"delete-82285\";i:81522;s:12:\"delete-82287\";i:81523;s:12:\"delete-82286\";i:81524;s:12:\"delete-82288\";i:81525;s:12:\"delete-82290\";i:81526;s:12:\"delete-82289\";i:81527;s:12:\"delete-82291\";i:81528;s:12:\"delete-82293\";i:81529;s:12:\"delete-82292\";i:81530;s:12:\"delete-82294\";i:81531;s:12:\"delete-82295\";i:81532;s:12:\"delete-82296\";i:81533;s:12:\"delete-82297\";i:81534;s:12:\"delete-82299\";i:81535;s:12:\"delete-82298\";i:81536;s:12:\"delete-82300\";i:81537;s:12:\"delete-82301\";i:81538;s:12:\"delete-82302\";i:81539;s:12:\"delete-82303\";i:81540;s:12:\"delete-82305\";i:81541;s:12:\"delete-82304\";i:81542;s:12:\"delete-82306\";i:81543;s:12:\"delete-82308\";i:81544;s:12:\"delete-82307\";i:81545;s:12:\"delete-82309\";i:81546;s:12:\"delete-82310\";i:81547;s:12:\"delete-82311\";i:81548;s:12:\"delete-82312\";i:81549;s:12:\"delete-82314\";i:81550;s:12:\"delete-82315\";i:81551;s:12:\"delete-82317\";i:81552;s:12:\"delete-82313\";i:81553;s:12:\"delete-82316\";i:81554;s:12:\"delete-82318\";i:81555;s:12:\"delete-82320\";i:81556;s:12:\"delete-82319\";i:81557;s:12:\"delete-82321\";i:81558;s:12:\"delete-82323\";i:81559;s:12:\"delete-82322\";i:81560;s:12:\"delete-82324\";i:81561;s:12:\"delete-82326\";i:81562;s:12:\"delete-82325\";i:81563;s:12:\"delete-82327\";i:81564;s:12:\"delete-82329\";i:81565;s:12:\"delete-82328\";i:81566;s:12:\"delete-82330\";i:81567;s:12:\"delete-82332\";i:81568;s:12:\"delete-82331\";i:81569;s:12:\"delete-82333\";i:81570;s:12:\"delete-82335\";i:81571;s:12:\"delete-82334\";i:81572;s:12:\"delete-82336\";i:81573;s:12:\"delete-82338\";i:81574;s:12:\"delete-82339\";i:81575;s:12:\"delete-82341\";i:81576;s:12:\"delete-82337\";i:81577;s:12:\"delete-82340\";i:81578;s:12:\"delete-82342\";i:81579;s:12:\"delete-82343\";i:81580;s:12:\"delete-82344\";i:81581;s:12:\"delete-82345\";i:81582;s:12:\"delete-82346\";i:81583;s:12:\"delete-82347\";i:81584;s:12:\"delete-82348\";i:81585;s:12:\"delete-82350\";i:81586;s:12:\"delete-82349\";i:81587;s:12:\"delete-82351\";i:81588;s:12:\"delete-82353\";i:81589;s:12:\"delete-82352\";i:81590;s:12:\"delete-82354\";i:81591;s:12:\"delete-82356\";i:81592;s:12:\"delete-82355\";i:81593;s:12:\"delete-82357\";i:81594;s:12:\"delete-82358\";i:81595;s:12:\"delete-82359\";i:81596;s:12:\"delete-82360\";i:81597;s:12:\"delete-82362\";i:81598;s:12:\"delete-82361\";i:81599;s:12:\"delete-82363\";i:81600;s:12:\"delete-82365\";i:81601;s:12:\"delete-82364\";i:81602;s:12:\"delete-82366\";i:81603;s:12:\"delete-82368\";i:81604;s:12:\"delete-82367\";i:81605;s:12:\"delete-82369\";i:81606;s:12:\"delete-82371\";i:81607;s:12:\"delete-82370\";i:81608;s:12:\"delete-82372\";i:81609;s:12:\"delete-82374\";i:81610;s:12:\"delete-82373\";i:81611;s:12:\"delete-82375\";i:81612;s:12:\"delete-82377\";i:81613;s:12:\"delete-82376\";i:81614;s:12:\"delete-82378\";i:81615;s:12:\"delete-82380\";i:81616;s:12:\"delete-82379\";i:81617;s:12:\"delete-82381\";i:81618;s:12:\"delete-82383\";i:81619;s:12:\"delete-82382\";i:81620;s:12:\"delete-82384\";i:81621;s:12:\"delete-82386\";i:81622;s:12:\"delete-82385\";i:81623;s:12:\"delete-82387\";i:81624;s:12:\"delete-82389\";i:81625;s:12:\"delete-82388\";i:81626;s:12:\"delete-82390\";i:81627;s:12:\"delete-82392\";i:81628;s:12:\"delete-82391\";i:81629;s:12:\"delete-82393\";i:81630;s:12:\"delete-82395\";i:81631;s:12:\"delete-82394\";i:81632;s:12:\"delete-82396\";i:81633;s:12:\"delete-82398\";i:81634;s:12:\"delete-82397\";i:81635;s:12:\"delete-82399\";i:81636;s:12:\"delete-82401\";i:81637;s:12:\"delete-82400\";i:81638;s:12:\"delete-82402\";i:81639;s:12:\"delete-82404\";i:81640;s:12:\"delete-82403\";i:81641;s:12:\"delete-82405\";i:81642;s:12:\"delete-82407\";i:81643;s:12:\"delete-82406\";i:81644;s:12:\"delete-82408\";i:81645;s:12:\"delete-82410\";i:81646;s:12:\"delete-82409\";i:81647;s:12:\"delete-82411\";i:81648;s:12:\"delete-82413\";i:81649;s:12:\"delete-82412\";i:81650;s:12:\"delete-82414\";i:81651;s:12:\"delete-82416\";i:81652;s:12:\"delete-82415\";i:81653;s:12:\"delete-82417\";i:81654;s:12:\"delete-82419\";i:81655;s:12:\"delete-82418\";i:81656;s:12:\"delete-82420\";i:81657;s:12:\"delete-82422\";i:81658;s:12:\"delete-82421\";i:81659;s:12:\"delete-82423\";i:81660;s:12:\"delete-82425\";i:81661;s:12:\"delete-82424\";i:81662;s:12:\"delete-82426\";i:81663;s:12:\"delete-82428\";i:81664;s:12:\"delete-82427\";i:81665;s:12:\"delete-82429\";i:81666;s:12:\"delete-82431\";i:81667;s:12:\"delete-82430\";i:81668;s:12:\"delete-82432\";i:81669;s:12:\"delete-82433\";i:81670;s:12:\"delete-82434\";i:81671;s:12:\"delete-82435\";i:81672;s:12:\"delete-82437\";i:81673;s:12:\"delete-82436\";i:81674;s:12:\"delete-82438\";i:81675;s:12:\"delete-82440\";i:81676;s:12:\"delete-82439\";i:81677;s:12:\"delete-82441\";i:81678;s:12:\"delete-82443\";i:81679;s:12:\"delete-82442\";i:81680;s:12:\"delete-82444\";i:81681;s:12:\"delete-82446\";i:81682;s:12:\"delete-82445\";i:81683;s:12:\"delete-82447\";i:81684;s:12:\"delete-82449\";i:81685;s:12:\"delete-82448\";i:81686;s:12:\"delete-82450\";i:81687;s:12:\"delete-82452\";i:81688;s:12:\"delete-82451\";i:81689;s:12:\"delete-82453\";i:81690;s:12:\"delete-82455\";i:81691;s:12:\"delete-82454\";i:81692;s:12:\"delete-82456\";i:81693;s:12:\"delete-82457\";i:81694;s:12:\"delete-82458\";i:81695;s:12:\"delete-82459\";i:81696;s:12:\"delete-82460\";i:81697;s:12:\"delete-82461\";i:81698;s:12:\"delete-82462\";i:81699;s:12:\"delete-82464\";i:81700;s:12:\"delete-82465\";i:81701;s:12:\"delete-82467\";i:81702;s:12:\"delete-82463\";i:81703;s:12:\"delete-82466\";i:81704;s:12:\"delete-82468\";i:81705;s:12:\"delete-82470\";i:81706;s:12:\"delete-82469\";i:81707;s:12:\"delete-82471\";i:81708;s:12:\"delete-82473\";i:81709;s:12:\"delete-82472\";i:81710;s:12:\"delete-82474\";i:81711;s:12:\"delete-82475\";i:81712;s:12:\"delete-82476\";i:81713;s:12:\"delete-82477\";i:81714;s:12:\"delete-82479\";i:81715;s:12:\"delete-82478\";i:81716;s:12:\"delete-82480\";i:81717;s:12:\"delete-82482\";i:81718;s:12:\"delete-82481\";i:81719;s:12:\"delete-82483\";i:81720;s:12:\"delete-82485\";i:81721;s:12:\"delete-82484\";i:81722;s:12:\"delete-82486\";i:81723;s:12:\"delete-82488\";i:81724;s:12:\"delete-82489\";i:81725;s:12:\"delete-82491\";i:81726;s:12:\"delete-82487\";i:81727;s:12:\"delete-82490\";i:81728;s:12:\"delete-82492\";i:81729;s:12:\"delete-82494\";i:81730;s:12:\"delete-82493\";i:81731;s:12:\"delete-82495\";i:81732;s:12:\"delete-82497\";i:81733;s:12:\"delete-82496\";i:81734;s:12:\"delete-82498\";i:81735;s:12:\"delete-82500\";i:81736;s:12:\"delete-82499\";i:81737;s:12:\"delete-82501\";i:81738;s:12:\"delete-82502\";i:81739;s:12:\"delete-82503\";i:81740;s:12:\"delete-82504\";i:81741;s:12:\"delete-82506\";i:81742;s:12:\"delete-82505\";i:81743;s:12:\"delete-82507\";i:81744;s:12:\"delete-82508\";i:81745;s:12:\"delete-82509\";i:81746;s:12:\"delete-82510\";i:81747;s:12:\"delete-82512\";i:81748;s:12:\"delete-82511\";i:81749;s:12:\"delete-82513\";i:81750;s:12:\"delete-82515\";i:81751;s:12:\"delete-82516\";i:81752;s:12:\"delete-82514\";i:81753;s:12:\"delete-82517\";i:81754;s:12:\"delete-82518\";i:81755;s:12:\"delete-82519\";i:81756;s:12:\"delete-82521\";i:81757;s:12:\"delete-82520\";i:81758;s:12:\"delete-82522\";i:81759;s:12:\"delete-82524\";i:81760;s:12:\"delete-82523\";i:81761;s:12:\"delete-82525\";i:81762;s:12:\"delete-82527\";i:81763;s:12:\"delete-82526\";i:81764;s:12:\"delete-82528\";i:81765;s:12:\"delete-82530\";i:81766;s:12:\"delete-82529\";i:81767;s:12:\"delete-82531\";i:81768;s:12:\"delete-82533\";i:81769;s:12:\"delete-82532\";i:81770;s:12:\"delete-82534\";i:81771;s:12:\"delete-82536\";i:81772;s:12:\"delete-82535\";i:81773;s:12:\"delete-82537\";i:81774;s:12:\"delete-82539\";i:81775;s:12:\"delete-82538\";i:81776;s:12:\"delete-82540\";i:81777;s:12:\"delete-82542\";i:81778;s:12:\"delete-82541\";i:81779;s:12:\"delete-82543\";i:81780;s:12:\"delete-82544\";i:81781;s:12:\"delete-82545\";i:81782;s:12:\"delete-82546\";i:81783;s:12:\"delete-82548\";i:81784;s:12:\"delete-82547\";i:81785;s:12:\"delete-82549\";i:81786;s:12:\"delete-82551\";i:81787;s:12:\"delete-82550\";i:81788;s:12:\"delete-82552\";i:81789;s:12:\"delete-82554\";i:81790;s:12:\"delete-82553\";i:81791;s:12:\"delete-82555\";i:81792;s:12:\"delete-82557\";i:81793;s:12:\"delete-82556\";i:81794;s:12:\"delete-82558\";i:81795;s:12:\"delete-82560\";i:81796;s:12:\"delete-82559\";i:81797;s:12:\"delete-82561\";i:81798;s:12:\"delete-82563\";i:81799;s:12:\"delete-82562\";i:81800;s:12:\"delete-82564\";i:81801;s:12:\"delete-82566\";i:81802;s:12:\"delete-82565\";i:81803;s:12:\"delete-82567\";i:81804;s:12:\"delete-82569\";i:81805;s:12:\"delete-82568\";i:81806;s:12:\"delete-82570\";i:81807;s:12:\"delete-82571\";i:81808;s:12:\"delete-82572\";i:81809;s:12:\"delete-82573\";i:81810;s:12:\"delete-82574\";i:81811;s:12:\"delete-82575\";i:81812;s:12:\"delete-82576\";i:81813;s:12:\"delete-82578\";i:81814;s:12:\"delete-82577\";i:81815;s:12:\"delete-82579\";i:81816;s:12:\"delete-82581\";i:81817;s:12:\"delete-82580\";i:81818;s:12:\"delete-82582\";i:81819;s:12:\"delete-82583\";i:81820;s:12:\"delete-82584\";i:81821;s:12:\"delete-82585\";i:81822;s:12:\"delete-82587\";i:81823;s:12:\"delete-82586\";i:81824;s:12:\"delete-82588\";i:81825;s:12:\"delete-82590\";i:81826;s:12:\"delete-82589\";i:81827;s:12:\"delete-82591\";i:81828;s:12:\"delete-82593\";i:81829;s:12:\"delete-82592\";i:81830;s:12:\"delete-82594\";i:81831;s:12:\"delete-82596\";i:81832;s:12:\"delete-82595\";i:81833;s:12:\"delete-82597\";i:81834;s:12:\"delete-82599\";i:81835;s:12:\"delete-82598\";i:81836;s:12:\"delete-82600\";i:81837;s:12:\"delete-82602\";i:81838;s:12:\"delete-82601\";i:81839;s:12:\"delete-82603\";i:81840;s:12:\"delete-82604\";i:81841;s:12:\"delete-82605\";i:81842;s:12:\"delete-82607\";i:81843;s:12:\"delete-82606\";i:81844;s:12:\"delete-82608\";i:81845;s:12:\"delete-82609\";i:81846;s:12:\"delete-82611\";i:81847;s:12:\"delete-82612\";i:81848;s:12:\"delete-82614\";i:81849;s:12:\"delete-82610\";i:81850;s:12:\"delete-82613\";i:81851;s:12:\"delete-82615\";i:81852;s:12:\"delete-82617\";i:81853;s:12:\"delete-82616\";i:81854;s:12:\"delete-82618\";i:81855;s:12:\"delete-82620\";i:81856;s:12:\"delete-82619\";i:81857;s:12:\"delete-82621\";i:81858;s:12:\"delete-82623\";i:81859;s:12:\"delete-82622\";i:81860;s:12:\"delete-82624\";i:81861;s:12:\"delete-82626\";i:81862;s:12:\"delete-82625\";i:81863;s:12:\"delete-82627\";i:81864;s:12:\"delete-82629\";i:81865;s:12:\"delete-82628\";i:81866;s:12:\"delete-82630\";i:81867;s:12:\"delete-82632\";i:81868;s:12:\"delete-82631\";i:81869;s:12:\"delete-82633\";i:81870;s:12:\"delete-82634\";i:81871;s:12:\"delete-82635\";i:81872;s:12:\"delete-82636\";i:81873;s:12:\"delete-82637\";i:81874;s:12:\"delete-82638\";i:81875;s:12:\"delete-82639\";i:81876;s:12:\"delete-82641\";i:81877;s:12:\"delete-82640\";i:81878;s:12:\"delete-82642\";i:81879;s:12:\"delete-82644\";i:81880;s:12:\"delete-82643\";i:81881;s:12:\"delete-82645\";i:81882;s:12:\"delete-82646\";i:81883;s:12:\"delete-82647\";i:81884;s:12:\"delete-82648\";i:81885;s:12:\"delete-82650\";i:81886;s:12:\"delete-82649\";i:81887;s:12:\"delete-82651\";i:81888;s:12:\"delete-82653\";i:81889;s:12:\"delete-82652\";i:81890;s:12:\"delete-82654\";i:81891;s:12:\"delete-82656\";i:81892;s:12:\"delete-82655\";i:81893;s:12:\"delete-82657\";i:81894;s:12:\"delete-82659\";i:81895;s:12:\"delete-82658\";i:81896;s:12:\"delete-82660\";i:81897;s:12:\"delete-82662\";i:81898;s:12:\"delete-82661\";i:81899;s:12:\"delete-82663\";i:81900;s:12:\"delete-82665\";i:81901;s:12:\"delete-82664\";i:81902;s:12:\"delete-82666\";i:81903;s:12:\"delete-82667\";i:81904;s:12:\"delete-82668\";i:81905;s:12:\"delete-82669\";i:81906;s:12:\"delete-82670\";i:81907;s:12:\"delete-82671\";i:81908;s:12:\"delete-82672\";i:81909;s:12:\"delete-82674\";i:81910;s:12:\"delete-82673\";i:81911;s:12:\"delete-82675\";i:81912;s:12:\"delete-82677\";i:81913;s:12:\"delete-82676\";i:81914;s:12:\"delete-82678\";i:81915;s:12:\"delete-82679\";i:81916;s:12:\"delete-82680\";i:81917;s:12:\"delete-82681\";i:81918;s:12:\"delete-82683\";i:81919;s:12:\"delete-82682\";i:81920;s:12:\"delete-82684\";i:81921;s:12:\"delete-82686\";i:81922;s:12:\"delete-82685\";i:81923;s:12:\"delete-82687\";i:81924;s:12:\"delete-82689\";i:81925;s:12:\"delete-82688\";i:81926;s:12:\"delete-82690\";i:81927;s:12:\"delete-82692\";i:81928;s:12:\"delete-82691\";i:81929;s:12:\"delete-82693\";i:81930;s:12:\"delete-82694\";i:81931;s:12:\"delete-82695\";i:81932;s:12:\"delete-82696\";i:81933;s:12:\"delete-82698\";i:81934;s:12:\"delete-82699\";i:81935;s:12:\"delete-82701\";i:81936;s:12:\"delete-82697\";i:81937;s:12:\"delete-82700\";i:81938;s:12:\"delete-82702\";i:81939;s:12:\"delete-82704\";i:81940;s:12:\"delete-82703\";i:81941;s:12:\"delete-82705\";i:81942;s:12:\"delete-82707\";i:81943;s:12:\"delete-82706\";i:81944;s:12:\"delete-82708\";i:81945;s:12:\"delete-82710\";i:81946;s:12:\"delete-82709\";i:81947;s:12:\"delete-82711\";i:81948;s:12:\"delete-82713\";i:81949;s:12:\"delete-82712\";i:81950;s:12:\"delete-82714\";i:81951;s:12:\"delete-82716\";i:81952;s:12:\"delete-82715\";i:81953;s:12:\"delete-82717\";i:81954;s:12:\"delete-82719\";i:81955;s:12:\"delete-82718\";i:81956;s:12:\"delete-82720\";i:81957;s:12:\"delete-82721\";i:81958;s:12:\"delete-82722\";i:81959;s:12:\"delete-82723\";i:81960;s:12:\"delete-82725\";i:81961;s:12:\"delete-82726\";i:81962;s:12:\"delete-82724\";i:81963;s:12:\"delete-82727\";i:81964;s:12:\"delete-82728\";i:81965;s:12:\"delete-82729\";i:81966;s:12:\"delete-82731\";i:81967;s:12:\"delete-82730\";i:81968;s:12:\"delete-82732\";i:81969;s:12:\"delete-82734\";i:81970;s:12:\"delete-82733\";i:81971;s:12:\"delete-82735\";i:81972;s:12:\"delete-82737\";i:81973;s:12:\"delete-82736\";i:81974;s:12:\"delete-82738\";i:81975;s:12:\"delete-82740\";i:81976;s:12:\"delete-82739\";i:81977;s:12:\"delete-82741\";i:81978;s:12:\"delete-82743\";i:81979;s:12:\"delete-82742\";i:81980;s:12:\"delete-82744\";i:81981;s:12:\"delete-82746\";i:81982;s:12:\"delete-82745\";i:81983;s:12:\"delete-82747\";i:81984;s:12:\"delete-82749\";i:81985;s:12:\"delete-82748\";i:81986;s:12:\"delete-82750\";i:81987;s:12:\"delete-82752\";i:81988;s:12:\"delete-82753\";i:81989;s:12:\"delete-82751\";i:81990;s:12:\"delete-82754\";i:81991;s:12:\"delete-82755\";i:81992;s:12:\"delete-82756\";i:81993;s:12:\"delete-82758\";i:81994;s:12:\"delete-82757\";i:81995;s:12:\"delete-82759\";i:81996;s:12:\"delete-82761\";i:81997;s:12:\"delete-82760\";i:81998;s:12:\"delete-82762\";i:81999;s:12:\"delete-82763\";i:82000;s:12:\"delete-82764\";i:82001;s:12:\"delete-82765\";i:82002;s:12:\"delete-82767\";i:82003;s:12:\"delete-82766\";i:82004;s:12:\"delete-82768\";i:82005;s:12:\"delete-82770\";i:82006;s:12:\"delete-82769\";i:82007;s:12:\"delete-82771\";i:82008;s:12:\"delete-82773\";i:82009;s:12:\"delete-82772\";i:82010;s:12:\"delete-82774\";i:82011;s:12:\"delete-82776\";i:82012;s:12:\"delete-82775\";i:82013;s:12:\"delete-82777\";i:82014;s:12:\"delete-82779\";i:82015;s:12:\"delete-82778\";i:82016;s:12:\"delete-82780\";i:82017;s:12:\"delete-82781\";i:82018;s:12:\"delete-82782\";i:82019;s:12:\"delete-82783\";i:82020;s:12:\"delete-82785\";i:82021;s:12:\"delete-82784\";i:82022;s:12:\"delete-82786\";i:82023;s:12:\"delete-82788\";i:82024;s:12:\"delete-82787\";i:82025;s:12:\"delete-82789\";i:82026;s:12:\"delete-82791\";i:82027;s:12:\"delete-82790\";i:82028;s:12:\"delete-82792\";i:82029;s:12:\"delete-82794\";i:82030;s:12:\"delete-82795\";i:82031;s:12:\"delete-82793\";i:82032;s:12:\"delete-82796\";i:82033;s:12:\"delete-82797\";i:82034;s:12:\"delete-82798\";i:82035;s:12:\"delete-82800\";i:82036;s:12:\"delete-82799\";i:82037;s:12:\"delete-82801\";i:82038;s:12:\"delete-82803\";i:82039;s:12:\"delete-82802\";i:82040;s:12:\"delete-82804\";i:82041;s:12:\"delete-82806\";i:82042;s:12:\"delete-82805\";i:82043;s:12:\"delete-82807\";i:82044;s:12:\"delete-82809\";i:82045;s:12:\"delete-82808\";i:82046;s:12:\"delete-82810\";i:82047;s:12:\"delete-82811\";i:82048;s:12:\"delete-82812\";i:82049;s:12:\"delete-82813\";i:82050;s:12:\"delete-82814\";i:82051;s:12:\"delete-82815\";i:82052;s:12:\"delete-82816\";i:82053;s:12:\"delete-82817\";i:82054;s:12:\"delete-82818\";i:82055;s:12:\"delete-82819\";i:82056;s:12:\"delete-82821\";i:82057;s:12:\"delete-82820\";i:82058;s:12:\"delete-82822\";i:82059;s:12:\"delete-82824\";i:82060;s:12:\"delete-82823\";i:82061;s:12:\"delete-82825\";i:82062;s:12:\"delete-82827\";i:82063;s:12:\"delete-82828\";i:82064;s:12:\"delete-82830\";i:82065;s:12:\"delete-82826\";i:82066;s:12:\"delete-82829\";i:82067;s:12:\"delete-82831\";i:82068;s:12:\"delete-82833\";i:82069;s:12:\"delete-82832\";i:82070;s:12:\"delete-82834\";i:82071;s:12:\"delete-82835\";i:82072;s:12:\"delete-82836\";i:82073;s:12:\"delete-82837\";i:82074;s:12:\"delete-82839\";i:82075;s:12:\"delete-82838\";i:82076;s:12:\"delete-82840\";i:82077;s:12:\"delete-82842\";i:82078;s:12:\"delete-82841\";i:82079;s:12:\"delete-82843\";i:82080;s:12:\"delete-82844\";i:82081;s:12:\"delete-82845\";i:82082;s:12:\"delete-82846\";i:82083;s:12:\"delete-82848\";i:82084;s:12:\"delete-82847\";i:82085;s:12:\"delete-82849\";i:82086;s:12:\"delete-82851\";i:82087;s:12:\"delete-82850\";i:82088;s:12:\"delete-82852\";i:82089;s:12:\"delete-82853\";i:82090;s:12:\"delete-82854\";i:82091;s:12:\"delete-82855\";i:82092;s:12:\"delete-82857\";i:82093;s:12:\"delete-82856\";i:82094;s:12:\"delete-82858\";i:82095;s:12:\"delete-82859\";i:82096;s:12:\"delete-82860\";i:82097;s:12:\"delete-82861\";i:82098;s:12:\"delete-82862\";i:82099;s:12:\"delete-82863\";i:82100;s:12:\"delete-82864\";i:82101;s:12:\"delete-82866\";i:82102;s:12:\"delete-82865\";i:82103;s:12:\"delete-82867\";i:82104;s:12:\"delete-82869\";i:82105;s:12:\"delete-82868\";i:82106;s:12:\"delete-82870\";i:82107;s:12:\"delete-82872\";i:82108;s:12:\"delete-82871\";i:82109;s:12:\"delete-82873\";i:82110;s:12:\"delete-82875\";i:82111;s:12:\"delete-82874\";i:82112;s:12:\"delete-82876\";i:82113;s:12:\"delete-82878\";i:82114;s:12:\"delete-82877\";i:82115;s:12:\"delete-82879\";i:82116;s:12:\"delete-82880\";i:82117;s:12:\"delete-82881\";i:82118;s:12:\"delete-82882\";i:82119;s:12:\"delete-82883\";i:82120;s:12:\"delete-82884\";i:82121;s:12:\"delete-82885\";i:82122;s:12:\"delete-82887\";i:82123;s:12:\"delete-82886\";i:82124;s:12:\"delete-82888\";i:82125;s:12:\"delete-82889\";i:82126;s:12:\"delete-82890\";i:82127;s:12:\"delete-82891\";i:82128;s:12:\"delete-82892\";i:82129;s:12:\"delete-82893\";i:82130;s:12:\"delete-82894\";i:82131;s:12:\"delete-82896\";i:82132;s:12:\"delete-82895\";i:82133;s:12:\"delete-82897\";i:82134;s:12:\"delete-82898\";i:82135;s:12:\"delete-82899\";i:82136;s:12:\"delete-82900\";i:82137;s:12:\"delete-82902\";i:82138;s:12:\"delete-82901\";i:82139;s:12:\"delete-82903\";i:82140;s:12:\"delete-82905\";i:82141;s:12:\"delete-82904\";i:82142;s:12:\"delete-82906\";i:82143;s:12:\"delete-82908\";i:82144;s:12:\"delete-82909\";i:82145;s:12:\"delete-82907\";i:82146;s:12:\"delete-82910\";i:82147;s:12:\"delete-82911\";i:82148;s:12:\"delete-82912\";i:82149;s:12:\"delete-82914\";i:82150;s:12:\"delete-82915\";i:82151;s:12:\"delete-82917\";i:82152;s:12:\"delete-82913\";i:82153;s:12:\"delete-82916\";i:82154;s:12:\"delete-82918\";i:82155;s:12:\"delete-82920\";i:82156;s:12:\"delete-82919\";i:82157;s:12:\"delete-82921\";i:82158;s:12:\"delete-82923\";i:82159;s:12:\"delete-82922\";i:82160;s:12:\"delete-82924\";i:82161;s:12:\"delete-82926\";i:82162;s:12:\"delete-82925\";i:82163;s:12:\"delete-82927\";i:82164;s:12:\"delete-82929\";i:82165;s:12:\"delete-82928\";i:82166;s:12:\"delete-82930\";i:82167;s:12:\"delete-82932\";i:82168;s:12:\"delete-82931\";i:82169;s:12:\"delete-82933\";i:82170;s:12:\"delete-82935\";i:82171;s:12:\"delete-82934\";i:82172;s:12:\"delete-82936\";i:82173;s:12:\"delete-82938\";i:82174;s:12:\"delete-82937\";i:82175;s:12:\"delete-82940\";i:82176;s:12:\"delete-82939\";i:82177;s:12:\"delete-82941\";i:82178;s:12:\"delete-82942\";i:82179;s:12:\"delete-82944\";i:82180;s:12:\"delete-82943\";i:82181;s:12:\"delete-82945\";i:82182;s:12:\"delete-82947\";i:82183;s:12:\"delete-82946\";i:82184;s:12:\"delete-82948\";i:82185;s:12:\"delete-82950\";i:82186;s:12:\"delete-82949\";i:82187;s:12:\"delete-82951\";i:82188;s:12:\"delete-82953\";i:82189;s:12:\"delete-82952\";i:82190;s:12:\"delete-82954\";i:82191;s:12:\"delete-82956\";i:82192;s:12:\"delete-82955\";i:82193;s:12:\"delete-82957\";i:82194;s:12:\"delete-82959\";i:82195;s:12:\"delete-82958\";i:82196;s:12:\"delete-82960\";i:82197;s:12:\"delete-82962\";i:82198;s:12:\"delete-82961\";i:82199;s:12:\"delete-82963\";i:82200;s:12:\"delete-82965\";i:82201;s:12:\"delete-82964\";i:82202;s:12:\"delete-82966\";i:82203;s:12:\"delete-82968\";i:82204;s:12:\"delete-82969\";i:82205;s:12:\"delete-82971\";i:82206;s:12:\"delete-82967\";i:82207;s:12:\"delete-82970\";i:82208;s:12:\"delete-82972\";i:82209;s:12:\"delete-82974\";i:82210;s:12:\"delete-82973\";i:82211;s:12:\"delete-82975\";i:82212;s:12:\"delete-82977\";i:82213;s:12:\"delete-82976\";i:82214;s:12:\"delete-82978\";i:82215;s:12:\"delete-82980\";i:82216;s:12:\"delete-82979\";i:82217;s:12:\"delete-82981\";i:82218;s:12:\"delete-82982\";i:82219;s:12:\"delete-82983\";i:82220;s:12:\"delete-82984\";i:82221;s:12:\"delete-82986\";i:82222;s:12:\"delete-82985\";i:82223;s:12:\"delete-82987\";i:82224;s:12:\"delete-82989\";i:82225;s:12:\"delete-82988\";i:82226;s:12:\"delete-82990\";i:82227;s:12:\"delete-82991\";i:82228;s:12:\"delete-82992\";i:82229;s:12:\"delete-82993\";i:82230;s:12:\"delete-82994\";i:82231;s:12:\"delete-82995\";i:82232;s:12:\"delete-82996\";i:82233;s:12:\"delete-82998\";i:82234;s:12:\"delete-82997\";i:82235;s:12:\"delete-82999\";i:82236;s:12:\"delete-83001\";i:82237;s:12:\"delete-83000\";i:82238;s:12:\"delete-83002\";i:82239;s:12:\"delete-83004\";i:82240;s:12:\"delete-83003\";i:82241;s:12:\"delete-83005\";i:82242;s:12:\"delete-83007\";i:82243;s:12:\"delete-83006\";i:82244;s:12:\"delete-83008\";i:82245;s:12:\"delete-83010\";i:82246;s:12:\"delete-83009\";i:82247;s:12:\"delete-83011\";i:82248;s:12:\"delete-83012\";i:82249;s:12:\"delete-83013\";i:82250;s:12:\"delete-83014\";i:82251;s:12:\"delete-83016\";i:82252;s:12:\"delete-83015\";i:82253;s:12:\"delete-83017\";i:82254;s:12:\"delete-83019\";i:82255;s:12:\"delete-83018\";i:82256;s:12:\"delete-83020\";i:82257;s:12:\"delete-83022\";i:82258;s:12:\"delete-83021\";i:82259;s:12:\"delete-83023\";i:82260;s:12:\"delete-83025\";i:82261;s:12:\"delete-83024\";i:82262;s:12:\"delete-83026\";i:82263;s:12:\"delete-83027\";i:82264;s:12:\"delete-83028\";i:82265;s:12:\"delete-83029\";i:82266;s:12:\"delete-83031\";i:82267;s:12:\"delete-83032\";i:82268;s:12:\"delete-83034\";i:82269;s:12:\"delete-83030\";i:82270;s:12:\"delete-83033\";i:82271;s:12:\"delete-83035\";i:82272;s:12:\"delete-83037\";i:82273;s:12:\"delete-83036\";i:82274;s:12:\"delete-83038\";i:82275;s:12:\"delete-83040\";i:82276;s:12:\"delete-83039\";i:82277;s:12:\"delete-83041\";i:82278;s:12:\"delete-83043\";i:82279;s:12:\"delete-83042\";i:82280;s:12:\"delete-83044\";i:82281;s:12:\"delete-83046\";i:82282;s:12:\"delete-83045\";i:82283;s:12:\"delete-83047\";i:82284;s:12:\"delete-83049\";i:82285;s:12:\"delete-83048\";i:82286;s:12:\"delete-83050\";i:82287;s:12:\"delete-83051\";i:82288;s:12:\"delete-83052\";i:82289;s:12:\"delete-83053\";i:82290;s:12:\"delete-83054\";i:82291;s:12:\"delete-83055\";i:82292;s:12:\"delete-83056\";i:82293;s:12:\"delete-83057\";i:82294;s:12:\"delete-83058\";i:82295;s:12:\"delete-83059\";i:82296;s:12:\"delete-83061\";i:82297;s:12:\"delete-83060\";i:82298;s:12:\"delete-83062\";i:82299;s:12:\"delete-83064\";i:82300;s:12:\"delete-83063\";i:82301;s:12:\"delete-83065\";i:82302;s:12:\"delete-83067\";i:82303;s:12:\"delete-83066\";i:82304;s:12:\"delete-83068\";i:82305;s:12:\"delete-83070\";i:82306;s:12:\"delete-83069\";i:82307;s:12:\"delete-83071\";i:82308;s:12:\"delete-83073\";i:82309;s:12:\"delete-83072\";i:82310;s:12:\"delete-83074\";i:82311;s:12:\"delete-83076\";i:82312;s:12:\"delete-83075\";i:82313;s:12:\"delete-83077\";i:82314;s:12:\"delete-83079\";i:82315;s:12:\"delete-83078\";i:82316;s:12:\"delete-83080\";i:82317;s:12:\"delete-83082\";i:82318;s:12:\"delete-83081\";i:82319;s:12:\"delete-83083\";i:82320;s:12:\"delete-83085\";i:82321;s:12:\"delete-83084\";i:82322;s:12:\"delete-83086\";i:82323;s:12:\"delete-83087\";i:82324;s:12:\"delete-83088\";i:82325;s:12:\"delete-83089\";i:82326;s:12:\"delete-83091\";i:82327;s:12:\"delete-83090\";i:82328;s:12:\"delete-83092\";i:82329;s:12:\"delete-83094\";i:82330;s:12:\"delete-83093\";i:82331;s:12:\"delete-83095\";i:82332;s:12:\"delete-83097\";i:82333;s:12:\"delete-83096\";i:82334;s:12:\"delete-83098\";i:82335;s:12:\"delete-83100\";i:82336;s:12:\"delete-83099\";i:82337;s:12:\"delete-83101\";i:82338;s:12:\"delete-83103\";i:82339;s:12:\"delete-83102\";i:82340;s:12:\"delete-83104\";i:82341;s:12:\"delete-83106\";i:82342;s:12:\"delete-83105\";i:82343;s:12:\"delete-83107\";i:82344;s:12:\"delete-83109\";i:82345;s:12:\"delete-83108\";i:82346;s:12:\"delete-83110\";i:82347;s:12:\"delete-83112\";i:82348;s:12:\"delete-83111\";i:82349;s:12:\"delete-83113\";i:82350;s:12:\"delete-83114\";i:82351;s:12:\"delete-83115\";i:82352;s:12:\"delete-83116\";i:82353;s:12:\"delete-83118\";i:82354;s:12:\"delete-83117\";i:82355;s:12:\"delete-83119\";i:82356;s:12:\"delete-83121\";i:82357;s:12:\"delete-83120\";i:82358;s:12:\"delete-83122\";i:82359;s:12:\"delete-83124\";i:82360;s:12:\"delete-83125\";i:82361;s:12:\"delete-83123\";i:82362;s:12:\"delete-83126\";i:82363;s:12:\"delete-83127\";i:82364;s:12:\"delete-83128\";i:82365;s:12:\"delete-83129\";i:82366;s:12:\"delete-83130\";i:82367;s:12:\"delete-83131\";i:82368;s:12:\"delete-83133\";i:82369;s:12:\"delete-83132\";i:82370;s:12:\"delete-83134\";i:82371;s:12:\"delete-83135\";i:82372;s:12:\"delete-83136\";i:82373;s:12:\"delete-83137\";i:82374;s:12:\"delete-83139\";i:82375;s:12:\"delete-83138\";i:82376;s:12:\"delete-83140\";i:82377;s:12:\"delete-83142\";i:82378;s:12:\"delete-83141\";i:82379;s:12:\"delete-83143\";i:82380;s:12:\"delete-83145\";i:82381;s:12:\"delete-83144\";i:82382;s:12:\"delete-83146\";i:82383;s:12:\"delete-83147\";i:82384;s:12:\"delete-83148\";i:82385;s:12:\"delete-83149\";i:82386;s:12:\"delete-83151\";i:82387;s:12:\"delete-83150\";i:82388;s:12:\"delete-83152\";i:82389;s:12:\"delete-83153\";i:82390;s:12:\"delete-83154\";i:82391;s:12:\"delete-83155\";i:82392;s:12:\"delete-83157\";i:82393;s:12:\"delete-83156\";i:82394;s:12:\"delete-83158\";i:82395;s:12:\"delete-83160\";i:82396;s:12:\"delete-83161\";i:82397;s:12:\"delete-83163\";i:82398;s:12:\"delete-83159\";i:82399;s:12:\"delete-83162\";i:82400;s:12:\"delete-83164\";i:82401;s:12:\"delete-83165\";i:82402;s:12:\"delete-83166\";i:82403;s:12:\"delete-83167\";i:82404;s:12:\"delete-83168\";i:82405;s:12:\"delete-83169\";i:82406;s:12:\"delete-83170\";i:82407;s:12:\"delete-83172\";i:82408;s:12:\"delete-83171\";i:82409;s:12:\"delete-83173\";i:82410;s:12:\"delete-83175\";i:82411;s:12:\"delete-83174\";i:82412;s:12:\"delete-83176\";i:82413;s:12:\"delete-83178\";i:82414;s:12:\"delete-83179\";i:82415;s:12:\"delete-83181\";i:82416;s:12:\"delete-83177\";i:82417;s:12:\"delete-83180\";i:82418;s:12:\"delete-83183\";i:82419;s:12:\"delete-83186\";i:82420;s:12:\"delete-83189\";i:82421;s:12:\"delete-83192\";i:82422;s:12:\"delete-83195\";i:82423;s:12:\"delete-83198\";i:82424;s:12:\"delete-83201\";i:82425;s:12:\"delete-83204\";i:82426;s:12:\"delete-83207\";i:82427;s:12:\"delete-83210\";i:82428;s:12:\"delete-83213\";i:82429;s:12:\"delete-83216\";i:82430;s:12:\"delete-83219\";i:82431;s:12:\"delete-83222\";i:82432;s:12:\"delete-83225\";i:82433;s:12:\"delete-83228\";i:82434;s:12:\"delete-83231\";i:82435;s:12:\"delete-83234\";i:82436;s:12:\"delete-83237\";i:82437;s:12:\"delete-83240\";i:82438;s:12:\"delete-83243\";i:82439;s:12:\"delete-83246\";i:82440;s:12:\"delete-83249\";i:82441;s:12:\"delete-83252\";i:82442;s:12:\"delete-83255\";i:82443;s:12:\"delete-83258\";i:82444;s:12:\"delete-83261\";i:82445;s:12:\"delete-83264\";i:82446;s:12:\"delete-83267\";i:82447;s:12:\"delete-83270\";i:82448;s:12:\"delete-83273\";i:82449;s:12:\"delete-83276\";i:82450;s:12:\"delete-83279\";i:82451;s:12:\"delete-83282\";i:82452;s:12:\"delete-83285\";i:82453;s:12:\"delete-83288\";i:82454;s:12:\"delete-83291\";i:82455;s:12:\"delete-83294\";i:82456;s:12:\"delete-83297\";i:82457;s:12:\"delete-83300\";i:82458;s:12:\"delete-83303\";i:82459;s:12:\"delete-83306\";i:82460;s:12:\"delete-83309\";i:82461;s:12:\"delete-83312\";i:82462;s:12:\"delete-83315\";i:82463;s:12:\"delete-83318\";i:82464;s:12:\"delete-83321\";i:82465;s:12:\"delete-83324\";i:82466;s:12:\"delete-83327\";i:82467;s:12:\"delete-83330\";i:82468;s:12:\"delete-83333\";i:82469;s:12:\"delete-83336\";i:82470;s:12:\"delete-83339\";i:82471;s:12:\"delete-83342\";i:82472;s:12:\"delete-83345\";i:82473;s:12:\"delete-83348\";i:82474;s:12:\"delete-83351\";i:82475;s:12:\"delete-83354\";i:82476;s:12:\"delete-83357\";i:82477;s:12:\"delete-83360\";i:82478;s:12:\"delete-83363\";i:82479;s:12:\"delete-83366\";i:82480;s:12:\"delete-83369\";i:82481;s:12:\"delete-83372\";i:82482;s:12:\"delete-83375\";i:82483;s:12:\"delete-83378\";i:82484;s:12:\"delete-83381\";i:82485;s:12:\"delete-83384\";i:82486;s:12:\"delete-83387\";i:82487;s:12:\"delete-83390\";i:82488;s:12:\"delete-83393\";i:82489;s:12:\"delete-83396\";i:82490;s:12:\"delete-83399\";i:82491;s:12:\"delete-83402\";i:82492;s:12:\"delete-83405\";i:82493;s:12:\"delete-83408\";i:82494;s:12:\"delete-83411\";i:82495;s:12:\"delete-83414\";i:82496;s:12:\"delete-83417\";i:82497;s:12:\"delete-83420\";i:82498;s:12:\"delete-83423\";i:82499;s:12:\"delete-83426\";i:82500;s:12:\"delete-83429\";i:82501;s:12:\"delete-83432\";i:82502;s:12:\"delete-83435\";i:82503;s:12:\"delete-83438\";i:82504;s:12:\"delete-83441\";i:82505;s:12:\"delete-83444\";i:82506;s:12:\"delete-83447\";i:82507;s:12:\"delete-83450\";i:82508;s:12:\"delete-83453\";i:82509;s:12:\"delete-83456\";i:82510;s:12:\"delete-83459\";i:82511;s:12:\"delete-83462\";i:82512;s:12:\"delete-83465\";i:82513;s:12:\"delete-83468\";i:82514;s:12:\"delete-83471\";i:82515;s:12:\"delete-83474\";i:82516;s:12:\"delete-83477\";i:82517;s:12:\"delete-83480\";i:82518;s:12:\"delete-83483\";i:82519;s:12:\"delete-83486\";i:82520;s:12:\"delete-83489\";i:82521;s:12:\"delete-83492\";i:82522;s:12:\"delete-83495\";i:82523;s:12:\"delete-83498\";i:82524;s:12:\"delete-83501\";i:82525;s:12:\"delete-83504\";i:82526;s:12:\"delete-83507\";i:82527;s:12:\"delete-83510\";i:82528;s:12:\"delete-83513\";i:82529;s:12:\"delete-83516\";i:82530;s:12:\"delete-83519\";i:82531;s:12:\"delete-83522\";i:82532;s:12:\"delete-83525\";i:82533;s:12:\"delete-83528\";i:82534;s:12:\"delete-83531\";i:82535;s:12:\"delete-83534\";i:82536;s:12:\"delete-83537\";i:82537;s:12:\"delete-83540\";i:82538;s:12:\"delete-83543\";i:82539;s:12:\"delete-83546\";i:82540;s:12:\"delete-83549\";i:82541;s:12:\"delete-83552\";i:82542;s:12:\"delete-83555\";i:82543;s:12:\"delete-83558\";i:82544;s:12:\"delete-83561\";i:82545;s:12:\"delete-83564\";i:82546;s:12:\"delete-83567\";i:82547;s:12:\"delete-83570\";i:82548;s:12:\"delete-83573\";i:82549;s:12:\"delete-83576\";i:82550;s:12:\"delete-83579\";i:82551;s:12:\"delete-83582\";i:82552;s:12:\"delete-83585\";i:82553;s:12:\"delete-83588\";i:82554;s:12:\"delete-83591\";i:82555;s:12:\"delete-83594\";i:82556;s:12:\"delete-83597\";i:82557;s:12:\"delete-83600\";i:82558;s:12:\"delete-83603\";i:82559;s:12:\"delete-83606\";i:82560;s:12:\"delete-83609\";i:82561;s:12:\"delete-83612\";i:82562;s:12:\"delete-83615\";i:82563;s:12:\"delete-83618\";i:82564;s:12:\"delete-83621\";i:82565;s:12:\"delete-83624\";i:82566;s:12:\"delete-83627\";i:82567;s:12:\"delete-83630\";i:82568;s:12:\"delete-83633\";i:82569;s:12:\"delete-83636\";i:82570;s:12:\"delete-83639\";i:82571;s:12:\"delete-83642\";i:82572;s:12:\"delete-83645\";i:82573;s:12:\"delete-83648\";i:82574;s:12:\"delete-83651\";i:82575;s:12:\"delete-83654\";i:82576;s:12:\"delete-83657\";i:82577;s:12:\"delete-83660\";i:82578;s:12:\"delete-83663\";i:82579;s:12:\"delete-83666\";i:82580;s:12:\"delete-83669\";i:82581;s:12:\"delete-83672\";i:82582;s:12:\"delete-83675\";i:82583;s:12:\"delete-83678\";i:82584;s:12:\"delete-83681\";i:82585;s:12:\"delete-83684\";i:82586;s:12:\"delete-83687\";i:82587;s:12:\"delete-83690\";i:82588;s:12:\"delete-83693\";i:82589;s:12:\"delete-83696\";i:82590;s:12:\"delete-83699\";i:82591;s:12:\"delete-83702\";i:82592;s:12:\"delete-83705\";i:82593;s:12:\"delete-83708\";i:82594;s:12:\"delete-83711\";i:82595;s:12:\"delete-83714\";i:82596;s:12:\"delete-83717\";i:82597;s:12:\"delete-83720\";i:82598;s:12:\"delete-83723\";i:82599;s:12:\"delete-83726\";i:82600;s:12:\"delete-83729\";i:82601;s:12:\"delete-83732\";i:82602;s:12:\"delete-83735\";i:82603;s:12:\"delete-83738\";i:82604;s:12:\"delete-83741\";i:82605;s:12:\"delete-83744\";i:82606;s:12:\"delete-83747\";i:82607;s:12:\"delete-83750\";i:82608;s:12:\"delete-83753\";i:82609;s:12:\"delete-83756\";i:82610;s:12:\"delete-83759\";i:82611;s:12:\"delete-83762\";i:82612;s:12:\"delete-83765\";i:82613;s:12:\"delete-83768\";i:82614;s:12:\"delete-83771\";i:82615;s:12:\"delete-83774\";i:82616;s:12:\"delete-83777\";i:82617;s:12:\"delete-83780\";i:82618;s:12:\"delete-83783\";i:82619;s:12:\"delete-83786\";i:82620;s:12:\"delete-83789\";i:82621;s:12:\"delete-83792\";i:82622;s:12:\"delete-83795\";i:82623;s:12:\"delete-83798\";i:82624;s:12:\"delete-83801\";i:82625;s:12:\"delete-83804\";i:82626;s:12:\"delete-83807\";i:82627;s:12:\"delete-83810\";i:82628;s:12:\"delete-83813\";i:82629;s:12:\"delete-83816\";i:82630;s:12:\"delete-83819\";i:82631;s:12:\"delete-83822\";i:82632;s:12:\"delete-83825\";i:82633;s:12:\"delete-83828\";i:82634;s:12:\"delete-83831\";i:82635;s:12:\"delete-83834\";i:82636;s:12:\"delete-83837\";i:82637;s:12:\"delete-83840\";i:82638;s:12:\"delete-83843\";i:82639;s:12:\"delete-83846\";i:82640;s:12:\"delete-83849\";i:82641;s:12:\"delete-83852\";i:82642;s:12:\"delete-83855\";i:82643;s:12:\"delete-83858\";i:82644;s:12:\"delete-83861\";i:82645;s:12:\"delete-83864\";i:82646;s:12:\"delete-83867\";i:82647;s:12:\"delete-83870\";i:82648;s:12:\"delete-83873\";i:82649;s:12:\"delete-83876\";i:82650;s:12:\"delete-83879\";i:82651;s:12:\"delete-83882\";i:82652;s:12:\"delete-83885\";i:82653;s:12:\"delete-83888\";i:82654;s:12:\"delete-83891\";i:82655;s:12:\"delete-83894\";i:82656;s:12:\"delete-83897\";i:82657;s:12:\"delete-83900\";i:82658;s:12:\"delete-83903\";i:82659;s:12:\"delete-83906\";i:82660;s:12:\"delete-83909\";i:82661;s:12:\"delete-83912\";i:82662;s:12:\"delete-83915\";i:82663;s:12:\"delete-83918\";i:82664;s:12:\"delete-83921\";i:82665;s:12:\"delete-83924\";i:82666;s:12:\"delete-83927\";i:82667;s:12:\"delete-83930\";i:82668;s:12:\"delete-83933\";i:82669;s:12:\"delete-83936\";i:82670;s:12:\"delete-83939\";i:82671;s:12:\"delete-83942\";i:82672;s:12:\"delete-83945\";i:82673;s:12:\"delete-83948\";i:82674;s:12:\"delete-83951\";i:82675;s:12:\"delete-83954\";i:82676;s:12:\"delete-83957\";i:82677;s:12:\"delete-83960\";i:82678;s:12:\"delete-83963\";i:82679;s:12:\"delete-83966\";i:82680;s:12:\"delete-83969\";i:82681;s:12:\"delete-83972\";i:82682;s:12:\"delete-83975\";i:82683;s:12:\"delete-83978\";i:82684;s:12:\"delete-83981\";i:82685;s:12:\"delete-83984\";i:82686;s:12:\"delete-83987\";i:82687;s:12:\"delete-83990\";i:82688;s:12:\"delete-83993\";i:82689;s:12:\"delete-83996\";i:82690;s:12:\"delete-83999\";i:82691;s:12:\"delete-84002\";i:82692;s:12:\"delete-84005\";i:82693;s:12:\"delete-84008\";i:82694;s:12:\"delete-84011\";i:82695;s:12:\"delete-84014\";i:82696;s:12:\"delete-84017\";i:82697;s:12:\"delete-84020\";i:82698;s:12:\"delete-84023\";i:82699;s:12:\"delete-84026\";i:82700;s:12:\"delete-84029\";i:82701;s:12:\"delete-84032\";i:82702;s:12:\"delete-84035\";i:82703;s:12:\"delete-84038\";i:82704;s:12:\"delete-84041\";i:82705;s:12:\"delete-84044\";i:82706;s:12:\"delete-84047\";i:82707;s:12:\"delete-84050\";i:82708;s:12:\"delete-84053\";i:82709;s:12:\"delete-84056\";i:82710;s:12:\"delete-84059\";i:82711;s:12:\"delete-84062\";i:82712;s:12:\"delete-84065\";i:82713;s:12:\"delete-84068\";i:82714;s:12:\"delete-84071\";i:82715;s:12:\"delete-84074\";i:82716;s:12:\"delete-84077\";i:82717;s:12:\"delete-84080\";i:82718;s:12:\"delete-84083\";i:82719;s:12:\"delete-84086\";i:82720;s:12:\"delete-84089\";i:82721;s:12:\"delete-84092\";i:82722;s:12:\"delete-84095\";i:82723;s:12:\"delete-84098\";i:82724;s:12:\"delete-84101\";i:82725;s:12:\"delete-84104\";i:82726;s:12:\"delete-84107\";i:82727;s:12:\"delete-84110\";i:82728;s:12:\"delete-84113\";i:82729;s:12:\"delete-84116\";i:82730;s:12:\"delete-84119\";i:82731;s:12:\"delete-84122\";i:82732;s:12:\"delete-84125\";i:82733;s:12:\"delete-84128\";i:82734;s:12:\"delete-84131\";i:82735;s:12:\"delete-84134\";i:82736;s:12:\"delete-84137\";i:82737;s:12:\"delete-84140\";i:82738;s:12:\"delete-84143\";i:82739;s:12:\"delete-84146\";i:82740;s:12:\"delete-84149\";i:82741;s:12:\"delete-84152\";i:82742;s:12:\"delete-84155\";i:82743;s:12:\"delete-84158\";i:82744;s:12:\"delete-84161\";i:82745;s:12:\"delete-84164\";i:82746;s:12:\"delete-84167\";i:82747;s:12:\"delete-84170\";i:82748;s:12:\"delete-84173\";i:82749;s:12:\"delete-84176\";i:82750;s:12:\"delete-84179\";i:82751;s:12:\"delete-84182\";i:82752;s:12:\"delete-84185\";i:82753;s:12:\"delete-84188\";i:82754;s:12:\"delete-84191\";i:82755;s:12:\"delete-84194\";i:82756;s:12:\"delete-84197\";i:82757;s:12:\"delete-84200\";i:82758;s:12:\"delete-84203\";i:82759;s:12:\"delete-84206\";i:82760;s:12:\"delete-84209\";i:82761;s:12:\"delete-84212\";i:82762;s:12:\"delete-84215\";i:82763;s:12:\"delete-84218\";i:82764;s:12:\"delete-84221\";i:82765;s:12:\"delete-84224\";i:82766;s:12:\"delete-84227\";i:82767;s:12:\"delete-84230\";i:82768;s:12:\"delete-84233\";i:82769;s:12:\"delete-84236\";i:82770;s:12:\"delete-84239\";i:82771;s:12:\"delete-84242\";i:82772;s:12:\"delete-84245\";i:82773;s:12:\"delete-84248\";i:82774;s:12:\"delete-84251\";i:82775;s:12:\"delete-84254\";i:82776;s:12:\"delete-84257\";i:82777;s:12:\"delete-84260\";i:82778;s:12:\"delete-84263\";i:82779;s:12:\"delete-84266\";i:82780;s:12:\"delete-84269\";i:82781;s:12:\"delete-84272\";i:82782;s:12:\"delete-84275\";i:82783;s:12:\"delete-84278\";i:82784;s:12:\"delete-84281\";i:82785;s:12:\"delete-84284\";i:82786;s:12:\"delete-84287\";i:82787;s:12:\"delete-84290\";i:82788;s:12:\"delete-84293\";i:82789;s:12:\"delete-84296\";i:82790;s:12:\"delete-84299\";i:82791;s:12:\"delete-84302\";i:82792;s:12:\"delete-84305\";i:82793;s:12:\"delete-84308\";i:82794;s:12:\"delete-84311\";i:82795;s:12:\"delete-84314\";i:82796;s:12:\"delete-84317\";i:82797;s:12:\"delete-84320\";i:82798;s:12:\"delete-84323\";i:82799;s:12:\"delete-84326\";i:82800;s:12:\"delete-84329\";i:82801;s:12:\"delete-84332\";i:82802;s:12:\"delete-84335\";i:82803;s:12:\"delete-84338\";i:82804;s:12:\"delete-84341\";i:82805;s:12:\"delete-84344\";i:82806;s:12:\"delete-84347\";i:82807;s:12:\"delete-84350\";i:82808;s:12:\"delete-84353\";i:82809;s:12:\"delete-84356\";i:82810;s:12:\"delete-84359\";i:82811;s:12:\"delete-84362\";i:82812;s:12:\"delete-84365\";i:82813;s:12:\"delete-84368\";i:82814;s:12:\"delete-84371\";i:82815;s:12:\"delete-84374\";i:82816;s:12:\"delete-84377\";i:82817;s:12:\"delete-84380\";i:82818;s:12:\"delete-84383\";i:82819;s:12:\"delete-84386\";i:82820;s:12:\"delete-84389\";i:82821;s:12:\"delete-84392\";i:82822;s:12:\"delete-84395\";i:82823;s:12:\"delete-84398\";i:82824;s:12:\"delete-84401\";i:82825;s:12:\"delete-84404\";i:82826;s:12:\"delete-84407\";i:82827;s:12:\"delete-84410\";i:82828;s:12:\"delete-84413\";i:82829;s:12:\"delete-84416\";i:82830;s:12:\"delete-84419\";i:82831;s:12:\"delete-84422\";i:82832;s:12:\"delete-84425\";i:82833;s:12:\"delete-84428\";i:82834;s:12:\"delete-84431\";i:82835;s:12:\"delete-84434\";i:82836;s:12:\"delete-84437\";i:82837;s:12:\"delete-84440\";i:82838;s:12:\"delete-84443\";i:82839;s:12:\"delete-84446\";i:82840;s:12:\"delete-84449\";i:82841;s:12:\"delete-84452\";i:82842;s:12:\"delete-84455\";i:82843;s:12:\"delete-84458\";i:82844;s:12:\"delete-84461\";i:82845;s:12:\"delete-84464\";i:82846;s:12:\"delete-84467\";i:82847;s:12:\"delete-84470\";i:82848;s:12:\"delete-84473\";i:82849;s:12:\"delete-84476\";i:82850;s:12:\"delete-84479\";i:82851;s:12:\"delete-84482\";i:82852;s:12:\"delete-84485\";i:82853;s:12:\"delete-84488\";i:82854;s:12:\"delete-84491\";i:82855;s:12:\"delete-84494\";i:82856;s:12:\"delete-84497\";i:82857;s:12:\"delete-84500\";i:82858;s:12:\"delete-84503\";i:82859;s:12:\"delete-84506\";i:82860;s:12:\"delete-84509\";i:82861;s:12:\"delete-84512\";i:82862;s:12:\"delete-84515\";i:82863;s:12:\"delete-84518\";i:82864;s:12:\"delete-84521\";i:82865;s:12:\"delete-84524\";i:82866;s:12:\"delete-84527\";i:82867;s:12:\"delete-84530\";i:82868;s:12:\"delete-84533\";i:82869;s:12:\"delete-84536\";i:82870;s:12:\"delete-84539\";i:82871;s:12:\"delete-84542\";i:82872;s:12:\"delete-84545\";i:82873;s:12:\"delete-84548\";i:82874;s:12:\"delete-84551\";i:82875;s:12:\"delete-84554\";i:82876;s:12:\"delete-84557\";i:82877;s:12:\"delete-84560\";i:82878;s:12:\"delete-84563\";i:82879;s:12:\"delete-84566\";i:82880;s:12:\"delete-84569\";i:82881;s:12:\"delete-84572\";i:82882;s:12:\"delete-84575\";i:82883;s:12:\"delete-84578\";i:82884;s:12:\"delete-84581\";i:82885;s:12:\"delete-84584\";i:82886;s:12:\"delete-84587\";i:82887;s:12:\"delete-84590\";i:82888;s:12:\"delete-84593\";i:82889;s:12:\"delete-84596\";i:82890;s:12:\"delete-84599\";i:82891;s:12:\"delete-84602\";i:82892;s:12:\"delete-84605\";i:82893;s:12:\"delete-84608\";i:82894;s:12:\"delete-84611\";i:82895;s:12:\"delete-84614\";i:82896;s:12:\"delete-84617\";i:82897;s:12:\"delete-84620\";i:82898;s:12:\"delete-84623\";i:82899;s:12:\"delete-84626\";i:82900;s:12:\"delete-84629\";i:82901;s:12:\"delete-84632\";i:82902;s:12:\"delete-84635\";i:82903;s:12:\"delete-84638\";i:82904;s:12:\"delete-84641\";i:82905;s:12:\"delete-84644\";i:82906;s:12:\"delete-84647\";i:82907;s:12:\"delete-84650\";i:82908;s:12:\"delete-84653\";i:82909;s:12:\"delete-84656\";i:82910;s:12:\"delete-84659\";i:82911;s:12:\"delete-84662\";i:82912;s:12:\"delete-84665\";i:82913;s:12:\"delete-84668\";i:82914;s:12:\"delete-84671\";i:82915;s:12:\"delete-84674\";i:82916;s:12:\"delete-84677\";i:82917;s:12:\"delete-84680\";i:82918;s:12:\"delete-84683\";i:82919;s:12:\"delete-84686\";i:82920;s:12:\"delete-84689\";i:82921;s:12:\"delete-84692\";i:82922;s:12:\"delete-84695\";i:82923;s:12:\"delete-84698\";i:82924;s:12:\"delete-84701\";i:82925;s:12:\"delete-84704\";i:82926;s:12:\"delete-84707\";i:82927;s:12:\"delete-84710\";i:82928;s:12:\"delete-84713\";i:82929;s:12:\"delete-84716\";i:82930;s:12:\"delete-84719\";i:82931;s:12:\"delete-84722\";i:82932;s:12:\"delete-84725\";i:82933;s:12:\"delete-84728\";i:82934;s:12:\"delete-84731\";i:82935;s:12:\"delete-84734\";i:82936;s:12:\"delete-84737\";i:82937;s:12:\"delete-84740\";i:82938;s:12:\"delete-84743\";i:82939;s:12:\"delete-84746\";i:82940;s:12:\"delete-84749\";i:82941;s:12:\"delete-84752\";i:82942;s:12:\"delete-84755\";i:82943;s:12:\"delete-84758\";i:82944;s:12:\"delete-84761\";i:82945;s:12:\"delete-84764\";i:82946;s:12:\"delete-84767\";i:82947;s:12:\"delete-84770\";i:82948;s:12:\"delete-84773\";i:82949;s:12:\"delete-84776\";i:82950;s:12:\"delete-84779\";i:82951;s:12:\"delete-84782\";i:82952;s:12:\"delete-84785\";i:82953;s:12:\"delete-84788\";i:82954;s:12:\"delete-84791\";i:82955;s:12:\"delete-84794\";i:82956;s:12:\"delete-84797\";i:82957;s:12:\"delete-84800\";i:82958;s:12:\"delete-84803\";i:82959;s:12:\"delete-84806\";i:82960;s:12:\"delete-84809\";i:82961;s:12:\"delete-84812\";i:82962;s:12:\"delete-84815\";i:82963;s:12:\"delete-84818\";i:82964;s:12:\"delete-84821\";i:82965;s:12:\"delete-84824\";i:82966;s:12:\"delete-84827\";i:82967;s:12:\"delete-84830\";i:82968;s:12:\"delete-84833\";i:82969;s:12:\"delete-84836\";i:82970;s:12:\"delete-84839\";i:82971;s:12:\"delete-84842\";i:82972;s:12:\"delete-84845\";i:82973;s:12:\"delete-84848\";i:82974;s:12:\"delete-84851\";i:82975;s:12:\"delete-84854\";i:82976;s:12:\"delete-84857\";i:82977;s:12:\"delete-84860\";i:82978;s:12:\"delete-84863\";i:82979;s:12:\"delete-84866\";i:82980;s:12:\"delete-84869\";i:82981;s:12:\"delete-84872\";i:82982;s:12:\"delete-84875\";i:82983;s:12:\"delete-84878\";i:82984;s:12:\"delete-84881\";i:82985;s:12:\"delete-84884\";i:82986;s:12:\"delete-84887\";i:82987;s:12:\"delete-84890\";i:82988;s:12:\"delete-84893\";i:82989;s:12:\"delete-84896\";i:82990;s:12:\"delete-84899\";i:82991;s:12:\"delete-84902\";i:82992;s:12:\"delete-84905\";i:82993;s:12:\"delete-84908\";i:82994;s:12:\"delete-84911\";i:82995;s:12:\"delete-84914\";i:82996;s:12:\"delete-84917\";i:82997;s:12:\"delete-84920\";i:82998;s:12:\"delete-84923\";i:82999;s:12:\"delete-84926\";i:83000;s:12:\"delete-84929\";i:83001;s:12:\"delete-84932\";i:83002;s:12:\"delete-84935\";i:83003;s:12:\"delete-84938\";i:83004;s:12:\"delete-84941\";i:83005;s:12:\"delete-84944\";i:83006;s:12:\"delete-84947\";i:83007;s:12:\"delete-84950\";i:83008;s:12:\"delete-84953\";i:83009;s:12:\"delete-84956\";i:83010;s:12:\"delete-84959\";i:83011;s:12:\"delete-84962\";i:83012;s:12:\"delete-84965\";i:83013;s:12:\"delete-84968\";i:83014;s:12:\"delete-84971\";i:83015;s:12:\"delete-84974\";i:83016;s:12:\"delete-84977\";i:83017;s:12:\"delete-84980\";i:83018;s:12:\"delete-84983\";i:83019;s:12:\"delete-84986\";i:83020;s:12:\"delete-84989\";i:83021;s:12:\"delete-84992\";i:83022;s:12:\"delete-84995\";i:83023;s:12:\"delete-84998\";i:83024;s:12:\"delete-85001\";i:83025;s:12:\"delete-85004\";i:83026;s:12:\"delete-85007\";i:83027;s:12:\"delete-85010\";i:83028;s:12:\"delete-85013\";i:83029;s:12:\"delete-85016\";i:83030;s:12:\"delete-85019\";i:83031;s:12:\"delete-85022\";i:83032;s:12:\"delete-85025\";i:83033;s:12:\"delete-85028\";i:83034;s:12:\"delete-85031\";i:83035;s:12:\"delete-85034\";i:83036;s:12:\"delete-85037\";i:83037;s:12:\"delete-85040\";i:83038;s:12:\"delete-85043\";i:83039;s:12:\"delete-85046\";i:83040;s:12:\"delete-85049\";i:83041;s:12:\"delete-85052\";i:83042;s:12:\"delete-85055\";i:83043;s:12:\"delete-85058\";i:83044;s:12:\"delete-85061\";i:83045;s:12:\"delete-85064\";i:83046;s:12:\"delete-85067\";i:83047;s:12:\"delete-85070\";i:83048;s:12:\"delete-85073\";i:83049;s:12:\"delete-85076\";i:83050;s:12:\"delete-85079\";i:83051;s:12:\"delete-85082\";i:83052;s:12:\"delete-85085\";i:83053;s:12:\"delete-85088\";i:83054;s:12:\"delete-85091\";i:83055;s:12:\"delete-85094\";i:83056;s:12:\"delete-85097\";i:83057;s:12:\"delete-85100\";i:83058;s:12:\"delete-85103\";i:83059;s:12:\"delete-85106\";i:83060;s:12:\"delete-85109\";i:83061;s:12:\"delete-85112\";i:83062;s:12:\"delete-85115\";i:83063;s:12:\"delete-85118\";i:83064;s:12:\"delete-85121\";i:83065;s:12:\"delete-85124\";i:83066;s:12:\"delete-85127\";i:83067;s:12:\"delete-85130\";i:83068;s:12:\"delete-85133\";i:83069;s:12:\"delete-85136\";i:83070;s:12:\"delete-85139\";i:83071;s:12:\"delete-85142\";i:83072;s:12:\"delete-85145\";i:83073;s:12:\"delete-85148\";i:83074;s:12:\"delete-85151\";i:83075;s:12:\"delete-85154\";i:83076;s:12:\"delete-85157\";i:83077;s:12:\"delete-85160\";i:83078;s:12:\"delete-85163\";i:83079;s:12:\"delete-85166\";i:83080;s:12:\"delete-85169\";i:83081;s:12:\"delete-85172\";i:83082;s:12:\"delete-85175\";i:83083;s:12:\"delete-85178\";i:83084;s:12:\"delete-85181\";i:83085;s:12:\"delete-85184\";i:83086;s:12:\"delete-85187\";i:83087;s:12:\"delete-85190\";i:83088;s:12:\"delete-85193\";i:83089;s:12:\"delete-85196\";i:83090;s:12:\"delete-85199\";i:83091;s:12:\"delete-85202\";i:83092;s:12:\"delete-85205\";i:83093;s:12:\"delete-85208\";i:83094;s:12:\"delete-85211\";i:83095;s:12:\"delete-85214\";i:83096;s:12:\"delete-85217\";i:83097;s:12:\"delete-85220\";i:83098;s:12:\"delete-85223\";i:83099;s:12:\"delete-85226\";i:83100;s:12:\"delete-85229\";i:83101;s:12:\"delete-85232\";i:83102;s:12:\"delete-85235\";i:83103;s:12:\"delete-85238\";i:83104;s:12:\"delete-85241\";i:83105;s:12:\"delete-85244\";i:83106;s:12:\"delete-85247\";i:83107;s:12:\"delete-85250\";i:83108;s:12:\"delete-85253\";i:83109;s:12:\"delete-85256\";i:83110;s:12:\"delete-85259\";i:83111;s:12:\"delete-85262\";i:83112;s:12:\"delete-85265\";i:83113;s:12:\"delete-85268\";i:83114;s:12:\"delete-85271\";i:83115;s:12:\"delete-85274\";i:83116;s:12:\"delete-85277\";i:83117;s:12:\"delete-85280\";i:83118;s:12:\"delete-85283\";i:83119;s:12:\"delete-85286\";i:83120;s:12:\"delete-85289\";i:83121;s:12:\"delete-85292\";i:83122;s:12:\"delete-85295\";i:83123;s:12:\"delete-85298\";i:83124;s:12:\"delete-85301\";i:83125;s:12:\"delete-85304\";i:83126;s:12:\"delete-85307\";i:83127;s:12:\"delete-85310\";i:83128;s:12:\"delete-85313\";i:83129;s:12:\"delete-85316\";i:83130;s:12:\"delete-85319\";i:83131;s:12:\"delete-85322\";i:83132;s:12:\"delete-85325\";i:83133;s:12:\"delete-85328\";i:83134;s:12:\"delete-85331\";i:83135;s:12:\"delete-85334\";i:83136;s:12:\"delete-85337\";i:83137;s:12:\"delete-85340\";i:83138;s:12:\"delete-85343\";i:83139;s:12:\"delete-85346\";i:83140;s:12:\"delete-85349\";i:83141;s:12:\"delete-85352\";i:83142;s:12:\"delete-85355\";i:83143;s:12:\"delete-85358\";i:83144;s:12:\"delete-85361\";i:83145;s:12:\"delete-85364\";i:83146;s:12:\"delete-85367\";i:83147;s:12:\"delete-85370\";i:83148;s:12:\"delete-85373\";i:83149;s:12:\"delete-85376\";i:83150;s:12:\"delete-85379\";i:83151;s:12:\"delete-85382\";i:83152;s:12:\"delete-85385\";i:83153;s:12:\"delete-85388\";i:83154;s:12:\"delete-85391\";i:83155;s:12:\"delete-85394\";i:83156;s:12:\"delete-85397\";i:83157;s:12:\"delete-85400\";i:83158;s:12:\"delete-85403\";i:83159;s:12:\"delete-85406\";i:83160;s:12:\"delete-85409\";i:83161;s:12:\"delete-85412\";i:83162;s:12:\"delete-85415\";i:83163;s:12:\"delete-85418\";i:83164;s:12:\"delete-85421\";i:83165;s:12:\"delete-85424\";i:83166;s:12:\"delete-85427\";i:83167;s:12:\"delete-85430\";i:83168;s:12:\"delete-85433\";i:83169;s:12:\"delete-85436\";i:83170;s:12:\"delete-85439\";i:83171;s:12:\"delete-85442\";i:83172;s:12:\"delete-85445\";i:83173;s:12:\"delete-85448\";i:83174;s:12:\"delete-85451\";i:83175;s:12:\"delete-85454\";i:83176;s:12:\"delete-85457\";i:83177;s:12:\"delete-85460\";i:83178;s:12:\"delete-85463\";i:83179;s:12:\"delete-85466\";i:83180;s:12:\"delete-85469\";i:83181;s:12:\"delete-85472\";i:83182;s:12:\"delete-85475\";i:83183;s:12:\"delete-85478\";i:83184;s:12:\"delete-85481\";i:83185;s:12:\"delete-85484\";i:83186;s:12:\"delete-85487\";i:83187;s:12:\"delete-85490\";i:83188;s:12:\"delete-85493\";i:83189;s:12:\"delete-85496\";i:83190;s:12:\"delete-85499\";i:83191;s:12:\"delete-85502\";i:83192;s:12:\"delete-85505\";i:83193;s:12:\"delete-85508\";i:83194;s:12:\"delete-85511\";i:83195;s:12:\"delete-85514\";i:83196;s:12:\"delete-85517\";i:83197;s:12:\"delete-85520\";i:83198;s:12:\"delete-85523\";i:83199;s:12:\"delete-85526\";i:83200;s:12:\"delete-85529\";i:83201;s:12:\"delete-85532\";i:83202;s:12:\"delete-85535\";i:83203;s:12:\"delete-85538\";i:83204;s:12:\"delete-85541\";i:83205;s:12:\"delete-85544\";i:83206;s:12:\"delete-85547\";i:83207;s:12:\"delete-85550\";i:83208;s:12:\"delete-85553\";i:83209;s:12:\"delete-85556\";i:83210;s:12:\"delete-85559\";i:83211;s:12:\"delete-85562\";i:83212;s:12:\"delete-85565\";i:83213;s:12:\"delete-85568\";i:83214;s:12:\"delete-85571\";i:83215;s:12:\"delete-85574\";i:83216;s:12:\"delete-85577\";i:83217;s:12:\"delete-85580\";i:83218;s:12:\"delete-85583\";i:83219;s:12:\"delete-85586\";i:83220;s:12:\"delete-85589\";i:83221;s:12:\"delete-85592\";i:83222;s:12:\"delete-85595\";i:83223;s:12:\"delete-85598\";i:83224;s:12:\"delete-85601\";i:83225;s:12:\"delete-85604\";i:83226;s:12:\"delete-85607\";i:83227;s:12:\"delete-85610\";i:83228;s:12:\"delete-85613\";i:83229;s:12:\"delete-85616\";i:83230;s:12:\"delete-85619\";i:83231;s:12:\"delete-85622\";i:83232;s:12:\"delete-85625\";i:83233;s:12:\"delete-85628\";i:83234;s:12:\"delete-85631\";i:83235;s:12:\"delete-85634\";i:83236;s:12:\"delete-85637\";i:83237;s:12:\"delete-85640\";i:83238;s:12:\"delete-85643\";i:83239;s:12:\"delete-85646\";i:83240;s:12:\"delete-85649\";i:83241;s:12:\"delete-85652\";i:83242;s:12:\"delete-85655\";i:83243;s:12:\"delete-85658\";i:83244;s:12:\"delete-85661\";i:83245;s:12:\"delete-85664\";i:83246;s:12:\"delete-85667\";i:83247;s:12:\"delete-85670\";i:83248;s:12:\"delete-85673\";i:83249;s:12:\"delete-85676\";i:83250;s:12:\"delete-85679\";i:83251;s:12:\"delete-85682\";i:83252;s:12:\"delete-85685\";i:83253;s:12:\"delete-85688\";i:83254;s:12:\"delete-85691\";i:83255;s:12:\"delete-85694\";i:83256;s:12:\"delete-85697\";i:83257;s:12:\"delete-85700\";i:83258;s:12:\"delete-85703\";i:83259;s:12:\"delete-85706\";i:83260;s:12:\"delete-85709\";i:83261;s:12:\"delete-85712\";i:83262;s:12:\"delete-85715\";i:83263;s:12:\"delete-85718\";i:83264;s:12:\"delete-85721\";i:83265;s:12:\"delete-85724\";i:83266;s:12:\"delete-85727\";i:83267;s:12:\"delete-85730\";i:83268;s:12:\"delete-85733\";i:83269;s:12:\"delete-85736\";i:83270;s:12:\"delete-85739\";i:83271;s:12:\"delete-85742\";i:83272;s:12:\"delete-85745\";i:83273;s:12:\"delete-85748\";i:83274;s:12:\"delete-85751\";i:83275;s:12:\"delete-85754\";i:83276;s:12:\"delete-85757\";i:83277;s:12:\"delete-85760\";i:83278;s:12:\"delete-85763\";i:83279;s:12:\"delete-85766\";i:83280;s:12:\"delete-85769\";i:83281;s:12:\"delete-85772\";i:83282;s:12:\"delete-85775\";i:83283;s:12:\"delete-85778\";i:83284;s:12:\"delete-85781\";i:83285;s:12:\"delete-85784\";i:83286;s:12:\"delete-85787\";i:83287;s:12:\"delete-85790\";i:83288;s:12:\"delete-85793\";i:83289;s:12:\"delete-85796\";i:83290;s:12:\"delete-85799\";i:83291;s:12:\"delete-85802\";i:83292;s:12:\"delete-85805\";i:83293;s:12:\"delete-85808\";i:83294;s:12:\"delete-85811\";i:83295;s:12:\"delete-85814\";i:83296;s:12:\"delete-85817\";i:83297;s:12:\"delete-85820\";i:83298;s:12:\"delete-85823\";i:83299;s:12:\"delete-85826\";i:83300;s:12:\"delete-85829\";i:83301;s:12:\"delete-85832\";i:83302;s:12:\"delete-85835\";i:83303;s:12:\"delete-85838\";i:83304;s:12:\"delete-85841\";i:83305;s:12:\"delete-85845\";i:83306;s:12:\"delete-85848\";i:83307;s:12:\"delete-85851\";i:83308;s:12:\"delete-85854\";i:83309;s:12:\"delete-85857\";i:83310;s:12:\"delete-85860\";i:83311;s:12:\"delete-85863\";i:83312;s:12:\"delete-85866\";i:83313;s:12:\"delete-85869\";i:83314;s:12:\"delete-85872\";i:83315;s:12:\"delete-85875\";i:83316;s:12:\"delete-85878\";i:83317;s:12:\"delete-85881\";i:83318;s:12:\"delete-85884\";i:83319;s:12:\"delete-85887\";i:83320;s:12:\"delete-85890\";i:83321;s:12:\"delete-85893\";i:83322;s:12:\"delete-85896\";i:83323;s:12:\"delete-85899\";i:83324;s:12:\"delete-85902\";i:83325;s:12:\"delete-85905\";i:83326;s:12:\"delete-85908\";i:83327;s:12:\"delete-85911\";i:83328;s:12:\"delete-85914\";i:83329;s:12:\"delete-85917\";i:83330;s:12:\"delete-85920\";i:83331;s:12:\"delete-85923\";i:83332;s:12:\"delete-85926\";i:83333;s:12:\"delete-85929\";i:83334;s:12:\"delete-85932\";i:83335;s:12:\"delete-85935\";i:83336;s:12:\"delete-85938\";i:83337;s:12:\"delete-85941\";i:83338;s:12:\"delete-85944\";i:83339;s:12:\"delete-85947\";i:83340;s:12:\"delete-85950\";i:83341;s:12:\"delete-85953\";i:83342;s:12:\"delete-85956\";i:83343;s:12:\"delete-85959\";i:83344;s:12:\"delete-85962\";i:83345;s:12:\"delete-85965\";i:83346;s:12:\"delete-85968\";i:83347;s:12:\"delete-85971\";i:83348;s:12:\"delete-85974\";i:83349;s:12:\"delete-85977\";i:83350;s:12:\"delete-85980\";i:83351;s:12:\"delete-85983\";i:83352;s:12:\"delete-85986\";i:83353;s:12:\"delete-85989\";i:83354;s:12:\"delete-85992\";i:83355;s:12:\"delete-85995\";i:83356;s:12:\"delete-85998\";i:83357;s:12:\"delete-86001\";i:83358;s:12:\"delete-86004\";i:83359;s:12:\"delete-86007\";i:83360;s:12:\"delete-86010\";i:83361;s:12:\"delete-86013\";i:83362;s:12:\"delete-86016\";i:83363;s:12:\"delete-86019\";i:83364;s:12:\"delete-86022\";i:83365;s:12:\"delete-86025\";i:83366;s:12:\"delete-86028\";i:83367;s:12:\"delete-86031\";i:83368;s:12:\"delete-86034\";i:83369;s:12:\"delete-86037\";i:83370;s:12:\"delete-86040\";i:83371;s:12:\"delete-86043\";i:83372;s:12:\"delete-86046\";i:83373;s:12:\"delete-86049\";i:83374;s:12:\"delete-86052\";i:83375;s:12:\"delete-86055\";i:83376;s:12:\"delete-86058\";i:83377;s:12:\"delete-86061\";i:83378;s:12:\"delete-86064\";i:83379;s:12:\"delete-86067\";i:83380;s:12:\"delete-86070\";i:83381;s:12:\"delete-86073\";i:83382;s:12:\"delete-86076\";i:83383;s:12:\"delete-86079\";i:83384;s:12:\"delete-86082\";i:83385;s:12:\"delete-86085\";i:83386;s:12:\"delete-86088\";i:83387;s:12:\"delete-86091\";i:83388;s:12:\"delete-86094\";i:83389;s:12:\"delete-86097\";i:83390;s:12:\"delete-86100\";i:83391;s:12:\"delete-86103\";i:83392;s:12:\"delete-86106\";i:83393;s:12:\"delete-86109\";i:83394;s:12:\"delete-86112\";i:83395;s:12:\"delete-86115\";i:83396;s:12:\"delete-86118\";i:83397;s:12:\"delete-86121\";i:83398;s:12:\"delete-86124\";i:83399;s:12:\"delete-86127\";i:83400;s:12:\"delete-86130\";i:83401;s:12:\"delete-86133\";i:83402;s:12:\"delete-86136\";i:83403;s:12:\"delete-86139\";i:83404;s:12:\"delete-86142\";i:83405;s:12:\"delete-86145\";i:83406;s:12:\"delete-86148\";i:83407;s:12:\"delete-86151\";i:83408;s:12:\"delete-86154\";i:83409;s:12:\"delete-86157\";i:83410;s:12:\"delete-86160\";i:83411;s:12:\"delete-86163\";i:83412;s:12:\"delete-86166\";i:83413;s:12:\"delete-86169\";i:83414;s:12:\"delete-86172\";i:83415;s:12:\"delete-86175\";i:83416;s:12:\"delete-86178\";i:83417;s:12:\"delete-86181\";i:83418;s:12:\"delete-86184\";i:83419;s:12:\"delete-86187\";i:83420;s:12:\"delete-86190\";i:83421;s:12:\"delete-86193\";i:83422;s:12:\"delete-86196\";i:83423;s:12:\"delete-86199\";i:83424;s:12:\"delete-86202\";i:83425;s:12:\"delete-86205\";i:83426;s:12:\"delete-86208\";i:83427;s:12:\"delete-86211\";i:83428;s:12:\"delete-86214\";i:83429;s:12:\"delete-86217\";i:83430;s:12:\"delete-86220\";i:83431;s:12:\"delete-86223\";i:83432;s:12:\"delete-86226\";i:83433;s:12:\"delete-86229\";i:83434;s:12:\"delete-86232\";i:83435;s:12:\"delete-86235\";i:83436;s:12:\"delete-86238\";i:83437;s:12:\"delete-86241\";i:83438;s:12:\"delete-86244\";i:83439;s:12:\"delete-86247\";i:83440;s:12:\"delete-86250\";i:83441;s:12:\"delete-86253\";i:83442;s:12:\"delete-86256\";i:83443;s:12:\"delete-86259\";i:83444;s:12:\"delete-86262\";i:83445;s:12:\"delete-86265\";i:83446;s:12:\"delete-86268\";i:83447;s:12:\"delete-86271\";i:83448;s:12:\"delete-86274\";i:83449;s:12:\"delete-86277\";i:83450;s:12:\"delete-86280\";i:83451;s:12:\"delete-86283\";i:83452;s:12:\"delete-86286\";i:83453;s:12:\"delete-86289\";i:83454;s:12:\"delete-86292\";i:83455;s:12:\"delete-86295\";i:83456;s:12:\"delete-86298\";i:83457;s:12:\"delete-86301\";i:83458;s:12:\"delete-86304\";i:83459;s:12:\"delete-86307\";i:83460;s:12:\"delete-86310\";i:83461;s:12:\"delete-86313\";i:83462;s:12:\"delete-86316\";i:83463;s:12:\"delete-86319\";i:83464;s:12:\"delete-86322\";i:83465;s:12:\"delete-86325\";i:83466;s:12:\"delete-86328\";i:83467;s:12:\"delete-86331\";i:83468;s:12:\"delete-86334\";i:83469;s:12:\"delete-86337\";i:83470;s:12:\"delete-86340\";i:83471;s:12:\"delete-86343\";i:83472;s:12:\"delete-86346\";i:83473;s:12:\"delete-86349\";i:83474;s:12:\"delete-86352\";i:83475;s:12:\"delete-86355\";i:83476;s:12:\"delete-86358\";i:83477;s:12:\"delete-86361\";i:83478;s:12:\"delete-86364\";i:83479;s:12:\"delete-86367\";i:83480;s:12:\"delete-86370\";i:83481;s:12:\"delete-86373\";i:83482;s:12:\"delete-86376\";i:83483;s:12:\"delete-86379\";i:83484;s:12:\"delete-86382\";i:83485;s:12:\"delete-86385\";i:83486;s:12:\"delete-86388\";i:83487;s:12:\"delete-86391\";i:83488;s:12:\"delete-86394\";i:83489;s:12:\"delete-86397\";i:83490;s:12:\"delete-86400\";i:83491;s:12:\"delete-86403\";i:83492;s:12:\"delete-86406\";i:83493;s:12:\"delete-86409\";i:83494;s:12:\"delete-86412\";i:83495;s:12:\"delete-86415\";i:83496;s:12:\"delete-86418\";i:83497;s:12:\"delete-86421\";i:83498;s:12:\"delete-86424\";i:83499;s:12:\"delete-86427\";i:83500;s:12:\"delete-86430\";i:83501;s:12:\"delete-86433\";i:83502;s:12:\"delete-86436\";i:83503;s:12:\"delete-86439\";i:83504;s:12:\"delete-86442\";i:83505;s:12:\"delete-86445\";i:83506;s:12:\"delete-86448\";i:83507;s:12:\"delete-86451\";i:83508;s:12:\"delete-86454\";i:83509;s:12:\"delete-86457\";i:83510;s:12:\"delete-86460\";i:83511;s:12:\"delete-86463\";i:83512;s:12:\"delete-86466\";i:83513;s:12:\"delete-86469\";i:83514;s:12:\"delete-86472\";i:83515;s:12:\"delete-86475\";i:83516;s:12:\"delete-86478\";i:83517;s:12:\"delete-86481\";i:83518;s:12:\"delete-86484\";i:83519;s:12:\"delete-86487\";i:83520;s:12:\"delete-86490\";i:83521;s:12:\"delete-86493\";i:83522;s:12:\"delete-86496\";i:83523;s:12:\"delete-86499\";i:83524;s:12:\"delete-86502\";i:83525;s:12:\"delete-86505\";i:83526;s:12:\"delete-86508\";i:83527;s:12:\"delete-86511\";i:83528;s:12:\"delete-86514\";i:83529;s:12:\"delete-86517\";i:83530;s:12:\"delete-86520\";i:83531;s:12:\"delete-86523\";i:83532;s:12:\"delete-86526\";i:83533;s:12:\"delete-86529\";i:83534;s:12:\"delete-86532\";i:83535;s:12:\"delete-86535\";i:83536;s:12:\"delete-86538\";i:83537;s:12:\"delete-86541\";i:83538;s:12:\"delete-86544\";i:83539;s:12:\"delete-86547\";i:83540;s:12:\"delete-86550\";i:83541;s:12:\"delete-86553\";i:83542;s:12:\"delete-86556\";i:83543;s:12:\"delete-86559\";i:83544;s:12:\"delete-86562\";i:83545;s:12:\"delete-86565\";i:83546;s:12:\"delete-86568\";i:83547;s:12:\"delete-86571\";i:83548;s:12:\"delete-86574\";i:83549;s:12:\"delete-86577\";i:83550;s:12:\"delete-86580\";i:83551;s:12:\"delete-86583\";i:83552;s:12:\"delete-86586\";i:83553;s:12:\"delete-86589\";i:83554;s:12:\"delete-86592\";i:83555;s:12:\"delete-86595\";i:83556;s:12:\"delete-86598\";i:83557;s:12:\"delete-86601\";i:83558;s:12:\"delete-86604\";i:83559;s:12:\"delete-86607\";i:83560;s:12:\"delete-86610\";i:83561;s:12:\"delete-86613\";i:83562;s:12:\"delete-86616\";i:83563;s:12:\"delete-86619\";i:83564;s:12:\"delete-86622\";i:83565;s:12:\"delete-86625\";i:83566;s:12:\"delete-86628\";i:83567;s:12:\"delete-86631\";i:83568;s:12:\"delete-86634\";i:83569;s:12:\"delete-86637\";i:83570;s:12:\"delete-86640\";i:83571;s:12:\"delete-86643\";i:83572;s:12:\"delete-86646\";i:83573;s:12:\"delete-86649\";i:83574;s:12:\"delete-86652\";i:83575;s:12:\"delete-86655\";i:83576;s:12:\"delete-86658\";i:83577;s:12:\"delete-86661\";i:83578;s:12:\"delete-86664\";i:83579;s:12:\"delete-86667\";i:83580;s:12:\"delete-86670\";i:83581;s:12:\"delete-86673\";i:83582;s:12:\"delete-86676\";i:83583;s:12:\"delete-86679\";i:83584;s:12:\"delete-86682\";i:83585;s:12:\"delete-86685\";i:83586;s:12:\"delete-86688\";i:83587;s:12:\"delete-86691\";i:83588;s:12:\"delete-86694\";i:83589;s:12:\"delete-86697\";i:83590;s:12:\"delete-86700\";i:83591;s:12:\"delete-86703\";i:83592;s:12:\"delete-86706\";i:83593;s:12:\"delete-86709\";i:83594;s:12:\"delete-86712\";i:83595;s:12:\"delete-86715\";i:83596;s:12:\"delete-86718\";i:83597;s:12:\"delete-86721\";i:83598;s:12:\"delete-86724\";i:83599;s:12:\"delete-86727\";i:83600;s:12:\"delete-86730\";i:83601;s:12:\"delete-86733\";i:83602;s:12:\"delete-86736\";i:83603;s:12:\"delete-86739\";i:83604;s:12:\"delete-86742\";i:83605;s:12:\"delete-86745\";i:83606;s:12:\"delete-86748\";i:83607;s:12:\"delete-86751\";i:83608;s:12:\"delete-86754\";i:83609;s:12:\"delete-86757\";i:83610;s:12:\"delete-86760\";i:83611;s:12:\"delete-86763\";i:83612;s:12:\"delete-86766\";i:83613;s:12:\"delete-86769\";i:83614;s:12:\"delete-86772\";i:83615;s:12:\"delete-86775\";i:83616;s:12:\"delete-86778\";i:83617;s:12:\"delete-86781\";i:83618;s:12:\"delete-86784\";i:83619;s:12:\"delete-86787\";i:83620;s:12:\"delete-86790\";i:83621;s:12:\"delete-86793\";i:83622;s:12:\"delete-86796\";i:83623;s:12:\"delete-86799\";i:83624;s:12:\"delete-86802\";i:83625;s:12:\"delete-86805\";i:83626;s:12:\"delete-86808\";i:83627;s:12:\"delete-86811\";i:83628;s:12:\"delete-86814\";i:83629;s:12:\"delete-86817\";i:83630;s:12:\"delete-86820\";i:83631;s:12:\"delete-86823\";i:83632;s:12:\"delete-86826\";i:83633;s:12:\"delete-86829\";i:83634;s:12:\"delete-86832\";i:83635;s:12:\"delete-86835\";i:83636;s:12:\"delete-86838\";i:83637;s:12:\"delete-86841\";i:83638;s:12:\"delete-86844\";i:83639;s:12:\"delete-86847\";i:83640;s:12:\"delete-86850\";i:83641;s:12:\"delete-86853\";i:83642;s:12:\"delete-86856\";i:83643;s:12:\"delete-86859\";i:83644;s:12:\"delete-86862\";i:83645;s:12:\"delete-86865\";i:83646;s:12:\"delete-86868\";i:83647;s:12:\"delete-86871\";i:83648;s:12:\"delete-86874\";i:83649;s:12:\"delete-86877\";i:83650;s:12:\"delete-86880\";i:83651;s:12:\"delete-86883\";i:83652;s:12:\"delete-86886\";i:83653;s:12:\"delete-86889\";i:83654;s:12:\"delete-86892\";i:83655;s:12:\"delete-86895\";i:83656;s:12:\"delete-86898\";i:83657;s:12:\"delete-86901\";i:83658;s:12:\"delete-86904\";i:83659;s:12:\"delete-86907\";i:83660;s:12:\"delete-86910\";i:83661;s:12:\"delete-86913\";i:83662;s:12:\"delete-86916\";i:83663;s:12:\"delete-86919\";i:83664;s:12:\"delete-86922\";i:83665;s:12:\"delete-86925\";i:83666;s:12:\"delete-86928\";i:83667;s:12:\"delete-86931\";i:83668;s:12:\"delete-86934\";i:83669;s:12:\"delete-86937\";i:83670;s:12:\"delete-86940\";i:83671;s:12:\"delete-86943\";i:83672;s:12:\"delete-86946\";i:83673;s:12:\"delete-86949\";i:83674;s:12:\"delete-86952\";i:83675;s:12:\"delete-86955\";i:83676;s:12:\"delete-86958\";i:83677;s:12:\"delete-86961\";i:83678;s:12:\"delete-86964\";i:83679;s:12:\"delete-86967\";i:83680;s:12:\"delete-86970\";i:83681;s:12:\"delete-86973\";i:83682;s:12:\"delete-86976\";i:83683;s:12:\"delete-86979\";i:83684;s:12:\"delete-86982\";i:83685;s:12:\"delete-86985\";i:83686;s:12:\"delete-86988\";i:83687;s:12:\"delete-86991\";i:83688;s:12:\"delete-86994\";i:83689;s:12:\"delete-86997\";i:83690;s:12:\"delete-87000\";i:83691;s:12:\"delete-87003\";i:83692;s:12:\"delete-87006\";i:83693;s:12:\"delete-87009\";i:83694;s:12:\"delete-87012\";i:83695;s:12:\"delete-87015\";i:83696;s:12:\"delete-87018\";i:83697;s:12:\"delete-87021\";i:83698;s:12:\"delete-87024\";i:83699;s:12:\"delete-87027\";i:83700;s:12:\"delete-87030\";i:83701;s:12:\"delete-87033\";i:83702;s:12:\"delete-87036\";i:83703;s:12:\"delete-87039\";i:83704;s:12:\"delete-87042\";i:83705;s:12:\"delete-87045\";i:83706;s:12:\"delete-87048\";i:83707;s:12:\"delete-87051\";i:83708;s:12:\"delete-87054\";i:83709;s:12:\"delete-87057\";i:83710;s:12:\"delete-87060\";i:83711;s:12:\"delete-87063\";i:83712;s:12:\"delete-87066\";i:83713;s:12:\"delete-87069\";i:83714;s:12:\"delete-87072\";i:83715;s:12:\"delete-87075\";i:83716;s:12:\"delete-87078\";i:83717;s:12:\"delete-87081\";i:83718;s:12:\"delete-87084\";i:83719;s:12:\"delete-87087\";i:83720;s:12:\"delete-87090\";i:83721;s:12:\"delete-87093\";i:83722;s:12:\"delete-87096\";i:83723;s:12:\"delete-87099\";i:83724;s:12:\"delete-87102\";i:83725;s:12:\"delete-87105\";i:83726;s:12:\"delete-87108\";i:83727;s:12:\"delete-87111\";i:83728;s:12:\"delete-87114\";i:83729;s:12:\"delete-87117\";i:83730;s:12:\"delete-87120\";i:83731;s:12:\"delete-87123\";i:83732;s:12:\"delete-87126\";i:83733;s:12:\"delete-87129\";i:83734;s:12:\"delete-87132\";i:83735;s:12:\"delete-87135\";i:83736;s:12:\"delete-87138\";i:83737;s:12:\"delete-87141\";i:83738;s:12:\"delete-87144\";i:83739;s:12:\"delete-87147\";i:83740;s:12:\"delete-87150\";i:83741;s:12:\"delete-87153\";i:83742;s:12:\"delete-87156\";i:83743;s:12:\"delete-87159\";i:83744;s:12:\"delete-87162\";i:83745;s:12:\"delete-87165\";i:83746;s:12:\"delete-87168\";i:83747;s:12:\"delete-87171\";i:83748;s:12:\"delete-87174\";i:83749;s:12:\"delete-87177\";i:83750;s:12:\"delete-87180\";i:83751;s:12:\"delete-87183\";i:83752;s:12:\"delete-87186\";i:83753;s:12:\"delete-87189\";i:83754;s:12:\"delete-87192\";i:83755;s:12:\"delete-87195\";i:83756;s:12:\"delete-87198\";i:83757;s:12:\"delete-87201\";i:83758;s:12:\"delete-87204\";i:83759;s:12:\"delete-87207\";i:83760;s:12:\"delete-87210\";i:83761;s:12:\"delete-87213\";i:83762;s:12:\"delete-87216\";i:83763;s:12:\"delete-87219\";i:83764;s:12:\"delete-87222\";i:83765;s:12:\"delete-87225\";i:83766;s:12:\"delete-87228\";i:83767;s:12:\"delete-87231\";i:83768;s:12:\"delete-87234\";i:83769;s:12:\"delete-87237\";i:83770;s:12:\"delete-87240\";i:83771;s:12:\"delete-87243\";i:83772;s:12:\"delete-87246\";i:83773;s:12:\"delete-87249\";i:83774;s:12:\"delete-87252\";i:83775;s:12:\"delete-87255\";i:83776;s:12:\"delete-87258\";i:83777;s:12:\"delete-87261\";i:83778;s:12:\"delete-87264\";i:83779;s:12:\"delete-87267\";i:83780;s:12:\"delete-87270\";i:83781;s:12:\"delete-87273\";i:83782;s:12:\"delete-87276\";i:83783;s:12:\"delete-87279\";i:83784;s:12:\"delete-87282\";i:83785;s:12:\"delete-87285\";i:83786;s:12:\"delete-87288\";i:83787;s:12:\"delete-87291\";i:83788;s:12:\"delete-87294\";i:83789;s:12:\"delete-87297\";i:83790;s:12:\"delete-87300\";i:83791;s:12:\"delete-87303\";i:83792;s:12:\"delete-87306\";i:83793;s:12:\"delete-87309\";i:83794;s:12:\"delete-87312\";i:83795;s:12:\"delete-87315\";i:83796;s:12:\"delete-87318\";i:83797;s:12:\"delete-87321\";i:83798;s:12:\"delete-87324\";i:83799;s:12:\"delete-87327\";i:83800;s:12:\"delete-87330\";i:83801;s:12:\"delete-87333\";i:83802;s:12:\"delete-87336\";i:83803;s:12:\"delete-87339\";i:83804;s:12:\"delete-87342\";i:83805;s:12:\"delete-87345\";i:83806;s:12:\"delete-87348\";i:83807;s:12:\"delete-87351\";i:83808;s:12:\"delete-87354\";i:83809;s:12:\"delete-87357\";i:83810;s:12:\"delete-87360\";i:83811;s:12:\"delete-87363\";i:83812;s:12:\"delete-87366\";i:83813;s:12:\"delete-87369\";i:83814;s:12:\"delete-87372\";i:83815;s:12:\"delete-87375\";i:83816;s:12:\"delete-87378\";i:83817;s:12:\"delete-87381\";i:83818;s:12:\"delete-87384\";i:83819;s:12:\"delete-87387\";i:83820;s:12:\"delete-87390\";i:83821;s:12:\"delete-87393\";i:83822;s:12:\"delete-87396\";i:83823;s:12:\"delete-87399\";i:83824;s:12:\"delete-87402\";i:83825;s:12:\"delete-87405\";i:83826;s:12:\"delete-87408\";i:83827;s:12:\"delete-87411\";i:83828;s:12:\"delete-87414\";i:83829;s:12:\"delete-87417\";i:83830;s:12:\"delete-87420\";i:83831;s:12:\"delete-87423\";i:83832;s:12:\"delete-87426\";i:83833;s:12:\"delete-87429\";i:83834;s:12:\"delete-87432\";i:83835;s:12:\"delete-87435\";i:83836;s:12:\"delete-87438\";i:83837;s:12:\"delete-87441\";i:83838;s:12:\"delete-87444\";i:83839;s:12:\"delete-87447\";i:83840;s:12:\"delete-87450\";i:83841;s:12:\"delete-87453\";i:83842;s:12:\"delete-87456\";i:83843;s:12:\"delete-87459\";i:83844;s:12:\"delete-87462\";i:83845;s:12:\"delete-87465\";i:83846;s:12:\"delete-87468\";i:83847;s:12:\"delete-87471\";i:83848;s:12:\"delete-87474\";i:83849;s:12:\"delete-87477\";i:83850;s:12:\"delete-87480\";i:83851;s:12:\"delete-87483\";i:83852;s:12:\"delete-87486\";i:83853;s:12:\"delete-87489\";i:83854;s:12:\"delete-87492\";i:83855;s:12:\"delete-87495\";i:83856;s:12:\"delete-87498\";i:83857;s:12:\"delete-83182\";i:83858;s:12:\"delete-83184\";i:83859;s:12:\"delete-83185\";i:83860;s:12:\"delete-83187\";i:83861;s:12:\"delete-83188\";i:83862;s:12:\"delete-83190\";i:83863;s:12:\"delete-83191\";i:83864;s:12:\"delete-83193\";i:83865;s:12:\"delete-83194\";i:83866;s:12:\"delete-83196\";i:83867;s:12:\"delete-83197\";i:83868;s:12:\"delete-83199\";i:83869;s:12:\"delete-83200\";i:83870;s:12:\"delete-83202\";i:83871;s:12:\"delete-83203\";i:83872;s:12:\"delete-83205\";i:83873;s:12:\"delete-83206\";i:83874;s:12:\"delete-83208\";i:83875;s:12:\"delete-83209\";i:83876;s:12:\"delete-83211\";i:83877;s:12:\"delete-83212\";i:83878;s:12:\"delete-83214\";i:83879;s:12:\"delete-83215\";i:83880;s:12:\"delete-83217\";i:83881;s:12:\"delete-83218\";i:83882;s:12:\"delete-83220\";i:83883;s:12:\"delete-83221\";i:83884;s:12:\"delete-83223\";i:83885;s:12:\"delete-83224\";i:83886;s:12:\"delete-83226\";i:83887;s:12:\"delete-83227\";i:83888;s:12:\"delete-83229\";i:83889;s:12:\"delete-83230\";i:83890;s:12:\"delete-83232\";i:83891;s:12:\"delete-83233\";i:83892;s:12:\"delete-83235\";i:83893;s:12:\"delete-83236\";i:83894;s:12:\"delete-83238\";i:83895;s:12:\"delete-83239\";i:83896;s:12:\"delete-83241\";i:83897;s:12:\"delete-83242\";i:83898;s:12:\"delete-83244\";i:83899;s:12:\"delete-83245\";i:83900;s:12:\"delete-83247\";i:83901;s:12:\"delete-83248\";i:83902;s:12:\"delete-83250\";i:83903;s:12:\"delete-83251\";i:83904;s:12:\"delete-83253\";i:83905;s:12:\"delete-83254\";i:83906;s:12:\"delete-83256\";i:83907;s:12:\"delete-83257\";i:83908;s:12:\"delete-83259\";i:83909;s:12:\"delete-83260\";i:83910;s:12:\"delete-83262\";i:83911;s:12:\"delete-83263\";i:83912;s:12:\"delete-83265\";i:83913;s:12:\"delete-83266\";i:83914;s:12:\"delete-83268\";i:83915;s:12:\"delete-83269\";i:83916;s:12:\"delete-83271\";i:83917;s:12:\"delete-83272\";i:83918;s:12:\"delete-83274\";i:83919;s:12:\"delete-83275\";i:83920;s:12:\"delete-83277\";i:83921;s:12:\"delete-83278\";i:83922;s:12:\"delete-83280\";i:83923;s:12:\"delete-83281\";i:83924;s:12:\"delete-83283\";i:83925;s:12:\"delete-83284\";i:83926;s:12:\"delete-83286\";i:83927;s:12:\"delete-83287\";i:83928;s:12:\"delete-83289\";i:83929;s:12:\"delete-83290\";i:83930;s:12:\"delete-83292\";i:83931;s:12:\"delete-83293\";i:83932;s:12:\"delete-83295\";i:83933;s:12:\"delete-83296\";i:83934;s:12:\"delete-83298\";i:83935;s:12:\"delete-83299\";i:83936;s:12:\"delete-83301\";i:83937;s:12:\"delete-83302\";i:83938;s:12:\"delete-83304\";i:83939;s:12:\"delete-83305\";i:83940;s:12:\"delete-83307\";i:83941;s:12:\"delete-83308\";i:83942;s:12:\"delete-83310\";i:83943;s:12:\"delete-83311\";i:83944;s:12:\"delete-83313\";i:83945;s:12:\"delete-83314\";i:83946;s:12:\"delete-83316\";i:83947;s:12:\"delete-83317\";i:83948;s:12:\"delete-83319\";i:83949;s:12:\"delete-83320\";i:83950;s:12:\"delete-83322\";i:83951;s:12:\"delete-83323\";i:83952;s:12:\"delete-83325\";i:83953;s:12:\"delete-83326\";i:83954;s:12:\"delete-83328\";i:83955;s:12:\"delete-83329\";i:83956;s:12:\"delete-83331\";i:83957;s:12:\"delete-83332\";i:83958;s:12:\"delete-83334\";i:83959;s:12:\"delete-83335\";i:83960;s:12:\"delete-83337\";i:83961;s:12:\"delete-83338\";i:83962;s:12:\"delete-83340\";i:83963;s:12:\"delete-83341\";i:83964;s:12:\"delete-83343\";i:83965;s:12:\"delete-83344\";i:83966;s:12:\"delete-83346\";i:83967;s:12:\"delete-83347\";i:83968;s:12:\"delete-83349\";i:83969;s:12:\"delete-83350\";i:83970;s:12:\"delete-83352\";i:83971;s:12:\"delete-83353\";i:83972;s:12:\"delete-83355\";i:83973;s:12:\"delete-83356\";i:83974;s:12:\"delete-83358\";i:83975;s:12:\"delete-83359\";i:83976;s:12:\"delete-83361\";i:83977;s:12:\"delete-83362\";i:83978;s:12:\"delete-83364\";i:83979;s:12:\"delete-83365\";i:83980;s:12:\"delete-83367\";i:83981;s:12:\"delete-83368\";i:83982;s:12:\"delete-83370\";i:83983;s:12:\"delete-83371\";i:83984;s:12:\"delete-83373\";i:83985;s:12:\"delete-83374\";i:83986;s:12:\"delete-83376\";i:83987;s:12:\"delete-83377\";i:83988;s:12:\"delete-83379\";i:83989;s:12:\"delete-83380\";i:83990;s:12:\"delete-83382\";i:83991;s:12:\"delete-83383\";i:83992;s:12:\"delete-83385\";i:83993;s:12:\"delete-83386\";i:83994;s:12:\"delete-83388\";i:83995;s:12:\"delete-83389\";i:83996;s:12:\"delete-83391\";i:83997;s:12:\"delete-83392\";i:83998;s:12:\"delete-83394\";i:83999;s:12:\"delete-83395\";i:84000;s:12:\"delete-83397\";i:84001;s:12:\"delete-83398\";i:84002;s:12:\"delete-83400\";i:84003;s:12:\"delete-83401\";i:84004;s:12:\"delete-83403\";i:84005;s:12:\"delete-83404\";i:84006;s:12:\"delete-83406\";i:84007;s:12:\"delete-83407\";i:84008;s:12:\"delete-83409\";i:84009;s:12:\"delete-83410\";i:84010;s:12:\"delete-83412\";i:84011;s:12:\"delete-83413\";i:84012;s:12:\"delete-83415\";i:84013;s:12:\"delete-83416\";i:84014;s:12:\"delete-83418\";i:84015;s:12:\"delete-83419\";i:84016;s:12:\"delete-83421\";i:84017;s:12:\"delete-83422\";i:84018;s:12:\"delete-83424\";i:84019;s:12:\"delete-83425\";i:84020;s:12:\"delete-83427\";i:84021;s:12:\"delete-83428\";i:84022;s:12:\"delete-83430\";i:84023;s:12:\"delete-83431\";i:84024;s:12:\"delete-83433\";i:84025;s:12:\"delete-83434\";i:84026;s:12:\"delete-83436\";i:84027;s:12:\"delete-83437\";i:84028;s:12:\"delete-83439\";i:84029;s:12:\"delete-83440\";i:84030;s:12:\"delete-83442\";i:84031;s:12:\"delete-83443\";i:84032;s:12:\"delete-83445\";i:84033;s:12:\"delete-83446\";i:84034;s:12:\"delete-83448\";i:84035;s:12:\"delete-83449\";i:84036;s:12:\"delete-83451\";i:84037;s:12:\"delete-83452\";i:84038;s:12:\"delete-83454\";i:84039;s:12:\"delete-83455\";i:84040;s:12:\"delete-83457\";i:84041;s:12:\"delete-83458\";i:84042;s:12:\"delete-83460\";i:84043;s:12:\"delete-83461\";i:84044;s:12:\"delete-83463\";i:84045;s:12:\"delete-83464\";i:84046;s:12:\"delete-83466\";i:84047;s:12:\"delete-83467\";i:84048;s:12:\"delete-83469\";i:84049;s:12:\"delete-83470\";i:84050;s:12:\"delete-83472\";i:84051;s:12:\"delete-83473\";i:84052;s:12:\"delete-83475\";i:84053;s:12:\"delete-83476\";i:84054;s:12:\"delete-83478\";i:84055;s:12:\"delete-83479\";i:84056;s:12:\"delete-83481\";i:84057;s:12:\"delete-83482\";i:84058;s:12:\"delete-83484\";i:84059;s:12:\"delete-83485\";i:84060;s:12:\"delete-83487\";i:84061;s:12:\"delete-83488\";i:84062;s:12:\"delete-83490\";i:84063;s:12:\"delete-83491\";i:84064;s:12:\"delete-83493\";i:84065;s:12:\"delete-83494\";i:84066;s:12:\"delete-83496\";i:84067;s:12:\"delete-83497\";i:84068;s:12:\"delete-83499\";i:84069;s:12:\"delete-83500\";i:84070;s:12:\"delete-83502\";i:84071;s:12:\"delete-83503\";i:84072;s:12:\"delete-83505\";i:84073;s:12:\"delete-83506\";i:84074;s:12:\"delete-83508\";i:84075;s:12:\"delete-83509\";i:84076;s:12:\"delete-83511\";i:84077;s:12:\"delete-83512\";i:84078;s:12:\"delete-83514\";i:84079;s:12:\"delete-83515\";i:84080;s:12:\"delete-83517\";i:84081;s:12:\"delete-83518\";i:84082;s:12:\"delete-83520\";i:84083;s:12:\"delete-83521\";i:84084;s:12:\"delete-83523\";i:84085;s:12:\"delete-83524\";i:84086;s:12:\"delete-83526\";i:84087;s:12:\"delete-83527\";i:84088;s:12:\"delete-83529\";i:84089;s:12:\"delete-83530\";i:84090;s:12:\"delete-83532\";i:84091;s:12:\"delete-83533\";i:84092;s:12:\"delete-83535\";i:84093;s:12:\"delete-83536\";i:84094;s:12:\"delete-83538\";i:84095;s:12:\"delete-83539\";i:84096;s:12:\"delete-83541\";i:84097;s:12:\"delete-83542\";i:84098;s:12:\"delete-83544\";i:84099;s:12:\"delete-83545\";i:84100;s:12:\"delete-83547\";i:84101;s:12:\"delete-83548\";i:84102;s:12:\"delete-83550\";i:84103;s:12:\"delete-83551\";i:84104;s:12:\"delete-83553\";i:84105;s:12:\"delete-83554\";i:84106;s:12:\"delete-83556\";i:84107;s:12:\"delete-83557\";i:84108;s:12:\"delete-83559\";i:84109;s:12:\"delete-83560\";i:84110;s:12:\"delete-83562\";i:84111;s:12:\"delete-83563\";i:84112;s:12:\"delete-83565\";i:84113;s:12:\"delete-83566\";i:84114;s:12:\"delete-83568\";i:84115;s:12:\"delete-83569\";i:84116;s:12:\"delete-83571\";i:84117;s:12:\"delete-83572\";i:84118;s:12:\"delete-83574\";i:84119;s:12:\"delete-83575\";i:84120;s:12:\"delete-83577\";i:84121;s:12:\"delete-83578\";i:84122;s:12:\"delete-83580\";i:84123;s:12:\"delete-83581\";i:84124;s:12:\"delete-83583\";i:84125;s:12:\"delete-83584\";i:84126;s:12:\"delete-83586\";i:84127;s:12:\"delete-83587\";i:84128;s:12:\"delete-83589\";i:84129;s:12:\"delete-83590\";i:84130;s:12:\"delete-83592\";i:84131;s:12:\"delete-83593\";i:84132;s:12:\"delete-83595\";i:84133;s:12:\"delete-83596\";i:84134;s:12:\"delete-83598\";i:84135;s:12:\"delete-83599\";i:84136;s:12:\"delete-83601\";i:84137;s:12:\"delete-83602\";i:84138;s:12:\"delete-83604\";i:84139;s:12:\"delete-83605\";i:84140;s:12:\"delete-83607\";i:84141;s:12:\"delete-83608\";i:84142;s:12:\"delete-83610\";i:84143;s:12:\"delete-83611\";i:84144;s:12:\"delete-83613\";i:84145;s:12:\"delete-83614\";i:84146;s:12:\"delete-83616\";i:84147;s:12:\"delete-83617\";i:84148;s:12:\"delete-83619\";i:84149;s:12:\"delete-83620\";i:84150;s:12:\"delete-83622\";i:84151;s:12:\"delete-83623\";i:84152;s:12:\"delete-83625\";i:84153;s:12:\"delete-83626\";i:84154;s:12:\"delete-83628\";i:84155;s:12:\"delete-83629\";i:84156;s:12:\"delete-83631\";i:84157;s:12:\"delete-83632\";i:84158;s:12:\"delete-83634\";i:84159;s:12:\"delete-83635\";i:84160;s:12:\"delete-83637\";i:84161;s:12:\"delete-83638\";i:84162;s:12:\"delete-83640\";i:84163;s:12:\"delete-83641\";i:84164;s:12:\"delete-83643\";i:84165;s:12:\"delete-83644\";i:84166;s:12:\"delete-83646\";i:84167;s:12:\"delete-83647\";i:84168;s:12:\"delete-83649\";i:84169;s:12:\"delete-83650\";i:84170;s:12:\"delete-83652\";i:84171;s:12:\"delete-83653\";i:84172;s:12:\"delete-83655\";i:84173;s:12:\"delete-83656\";i:84174;s:12:\"delete-83658\";i:84175;s:12:\"delete-83659\";i:84176;s:12:\"delete-83661\";i:84177;s:12:\"delete-83662\";i:84178;s:12:\"delete-83664\";i:84179;s:12:\"delete-83665\";i:84180;s:12:\"delete-83667\";i:84181;s:12:\"delete-83668\";i:84182;s:12:\"delete-83670\";i:84183;s:12:\"delete-83671\";i:84184;s:12:\"delete-83673\";i:84185;s:12:\"delete-83674\";i:84186;s:12:\"delete-83676\";i:84187;s:12:\"delete-83677\";i:84188;s:12:\"delete-83679\";i:84189;s:12:\"delete-83680\";i:84190;s:12:\"delete-83682\";i:84191;s:12:\"delete-83683\";i:84192;s:12:\"delete-83685\";i:84193;s:12:\"delete-83686\";i:84194;s:12:\"delete-83688\";i:84195;s:12:\"delete-83689\";i:84196;s:12:\"delete-83691\";i:84197;s:12:\"delete-83692\";i:84198;s:12:\"delete-83694\";i:84199;s:12:\"delete-83695\";i:84200;s:12:\"delete-83697\";i:84201;s:12:\"delete-83698\";i:84202;s:12:\"delete-83700\";i:84203;s:12:\"delete-83701\";i:84204;s:12:\"delete-83703\";i:84205;s:12:\"delete-83704\";i:84206;s:12:\"delete-83706\";i:84207;s:12:\"delete-83707\";i:84208;s:12:\"delete-83709\";i:84209;s:12:\"delete-83710\";i:84210;s:12:\"delete-83712\";i:84211;s:12:\"delete-83713\";i:84212;s:12:\"delete-83715\";i:84213;s:12:\"delete-83716\";i:84214;s:12:\"delete-83718\";i:84215;s:12:\"delete-83719\";i:84216;s:12:\"delete-83721\";i:84217;s:12:\"delete-83722\";i:84218;s:12:\"delete-83724\";i:84219;s:12:\"delete-83725\";i:84220;s:12:\"delete-83727\";i:84221;s:12:\"delete-83728\";i:84222;s:12:\"delete-83730\";i:84223;s:12:\"delete-83731\";i:84224;s:12:\"delete-83733\";i:84225;s:12:\"delete-83734\";i:84226;s:12:\"delete-83736\";i:84227;s:12:\"delete-83737\";i:84228;s:12:\"delete-83739\";i:84229;s:12:\"delete-83740\";i:84230;s:12:\"delete-83742\";i:84231;s:12:\"delete-83743\";i:84232;s:12:\"delete-83745\";i:84233;s:12:\"delete-83746\";i:84234;s:12:\"delete-83748\";i:84235;s:12:\"delete-83749\";i:84236;s:12:\"delete-83751\";i:84237;s:12:\"delete-83752\";i:84238;s:12:\"delete-83754\";i:84239;s:12:\"delete-83755\";i:84240;s:12:\"delete-83757\";i:84241;s:12:\"delete-83758\";i:84242;s:12:\"delete-83760\";i:84243;s:12:\"delete-83761\";i:84244;s:12:\"delete-83763\";i:84245;s:12:\"delete-83764\";i:84246;s:12:\"delete-83766\";i:84247;s:12:\"delete-83767\";i:84248;s:12:\"delete-83769\";i:84249;s:12:\"delete-83770\";i:84250;s:12:\"delete-83772\";i:84251;s:12:\"delete-83773\";i:84252;s:12:\"delete-83775\";i:84253;s:12:\"delete-83776\";i:84254;s:12:\"delete-83778\";i:84255;s:12:\"delete-83779\";i:84256;s:12:\"delete-83781\";i:84257;s:12:\"delete-83782\";i:84258;s:12:\"delete-83784\";i:84259;s:12:\"delete-83785\";i:84260;s:12:\"delete-83787\";i:84261;s:12:\"delete-83788\";i:84262;s:12:\"delete-83790\";i:84263;s:12:\"delete-83791\";i:84264;s:12:\"delete-83793\";i:84265;s:12:\"delete-83794\";i:84266;s:12:\"delete-83796\";i:84267;s:12:\"delete-83797\";i:84268;s:12:\"delete-83799\";i:84269;s:12:\"delete-83800\";i:84270;s:12:\"delete-83802\";i:84271;s:12:\"delete-83803\";i:84272;s:12:\"delete-83805\";i:84273;s:12:\"delete-83806\";i:84274;s:12:\"delete-83808\";i:84275;s:12:\"delete-83809\";i:84276;s:12:\"delete-83811\";i:84277;s:12:\"delete-83812\";i:84278;s:12:\"delete-83814\";i:84279;s:12:\"delete-83815\";i:84280;s:12:\"delete-83817\";i:84281;s:12:\"delete-83818\";i:84282;s:12:\"delete-83820\";i:84283;s:12:\"delete-83821\";i:84284;s:12:\"delete-83823\";i:84285;s:12:\"delete-83824\";i:84286;s:12:\"delete-83826\";i:84287;s:12:\"delete-83827\";i:84288;s:12:\"delete-83829\";i:84289;s:12:\"delete-83830\";i:84290;s:12:\"delete-83832\";i:84291;s:12:\"delete-83833\";i:84292;s:12:\"delete-83835\";i:84293;s:12:\"delete-83836\";i:84294;s:12:\"delete-83838\";i:84295;s:12:\"delete-83839\";i:84296;s:12:\"delete-83841\";i:84297;s:12:\"delete-83842\";i:84298;s:12:\"delete-83844\";i:84299;s:12:\"delete-83845\";i:84300;s:12:\"delete-83847\";i:84301;s:12:\"delete-83848\";i:84302;s:12:\"delete-83850\";i:84303;s:12:\"delete-83851\";i:84304;s:12:\"delete-83853\";i:84305;s:12:\"delete-83854\";i:84306;s:12:\"delete-83856\";i:84307;s:12:\"delete-83857\";i:84308;s:12:\"delete-83859\";i:84309;s:12:\"delete-83860\";i:84310;s:12:\"delete-83862\";i:84311;s:12:\"delete-83863\";i:84312;s:12:\"delete-83865\";i:84313;s:12:\"delete-83866\";i:84314;s:12:\"delete-83868\";i:84315;s:12:\"delete-83869\";i:84316;s:12:\"delete-83871\";i:84317;s:12:\"delete-83872\";i:84318;s:12:\"delete-83874\";i:84319;s:12:\"delete-83875\";i:84320;s:12:\"delete-83877\";i:84321;s:12:\"delete-83878\";i:84322;s:12:\"delete-83880\";i:84323;s:12:\"delete-83881\";i:84324;s:12:\"delete-83883\";i:84325;s:12:\"delete-83884\";i:84326;s:12:\"delete-83886\";i:84327;s:12:\"delete-83887\";i:84328;s:12:\"delete-83889\";i:84329;s:12:\"delete-83890\";i:84330;s:12:\"delete-83892\";i:84331;s:12:\"delete-83893\";i:84332;s:12:\"delete-83895\";i:84333;s:12:\"delete-83896\";i:84334;s:12:\"delete-83898\";i:84335;s:12:\"delete-83899\";i:84336;s:12:\"delete-83901\";i:84337;s:12:\"delete-83902\";i:84338;s:12:\"delete-83904\";i:84339;s:12:\"delete-83905\";i:84340;s:12:\"delete-83907\";i:84341;s:12:\"delete-83908\";i:84342;s:12:\"delete-83910\";i:84343;s:12:\"delete-83911\";i:84344;s:12:\"delete-83913\";i:84345;s:12:\"delete-83914\";i:84346;s:12:\"delete-83916\";i:84347;s:12:\"delete-83917\";i:84348;s:12:\"delete-83919\";i:84349;s:12:\"delete-83920\";i:84350;s:12:\"delete-83922\";i:84351;s:12:\"delete-83923\";i:84352;s:12:\"delete-83925\";i:84353;s:12:\"delete-83926\";i:84354;s:12:\"delete-83928\";i:84355;s:12:\"delete-83929\";i:84356;s:12:\"delete-83931\";i:84357;s:12:\"delete-83932\";i:84358;s:12:\"delete-83934\";i:84359;s:12:\"delete-83935\";i:84360;s:12:\"delete-83937\";i:84361;s:12:\"delete-83938\";i:84362;s:12:\"delete-83940\";i:84363;s:12:\"delete-83941\";i:84364;s:12:\"delete-83943\";i:84365;s:12:\"delete-83944\";i:84366;s:12:\"delete-83946\";i:84367;s:12:\"delete-83947\";i:84368;s:12:\"delete-83949\";i:84369;s:12:\"delete-83950\";i:84370;s:12:\"delete-83952\";i:84371;s:12:\"delete-83953\";i:84372;s:12:\"delete-83955\";i:84373;s:12:\"delete-83956\";i:84374;s:12:\"delete-83958\";i:84375;s:12:\"delete-83959\";i:84376;s:12:\"delete-83961\";i:84377;s:12:\"delete-83962\";i:84378;s:12:\"delete-83964\";i:84379;s:12:\"delete-83965\";i:84380;s:12:\"delete-83967\";i:84381;s:12:\"delete-83968\";i:84382;s:12:\"delete-83970\";i:84383;s:12:\"delete-83971\";i:84384;s:12:\"delete-83973\";i:84385;s:12:\"delete-83974\";i:84386;s:12:\"delete-83976\";i:84387;s:12:\"delete-83977\";i:84388;s:12:\"delete-83979\";i:84389;s:12:\"delete-83980\";i:84390;s:12:\"delete-83982\";i:84391;s:12:\"delete-83983\";i:84392;s:12:\"delete-83985\";i:84393;s:12:\"delete-83986\";i:84394;s:12:\"delete-83988\";i:84395;s:12:\"delete-83989\";i:84396;s:12:\"delete-83991\";i:84397;s:12:\"delete-83992\";i:84398;s:12:\"delete-83994\";i:84399;s:12:\"delete-83995\";i:84400;s:12:\"delete-83997\";i:84401;s:12:\"delete-83998\";i:84402;s:12:\"delete-84000\";i:84403;s:12:\"delete-84001\";i:84404;s:12:\"delete-84003\";i:84405;s:12:\"delete-84004\";i:84406;s:12:\"delete-84006\";i:84407;s:12:\"delete-84007\";i:84408;s:12:\"delete-84009\";i:84409;s:12:\"delete-84010\";i:84410;s:12:\"delete-84012\";i:84411;s:12:\"delete-84013\";i:84412;s:12:\"delete-84015\";i:84413;s:12:\"delete-84016\";i:84414;s:12:\"delete-84018\";i:84415;s:12:\"delete-84019\";i:84416;s:12:\"delete-84021\";i:84417;s:12:\"delete-84022\";i:84418;s:12:\"delete-84024\";i:84419;s:12:\"delete-84025\";i:84420;s:12:\"delete-84027\";i:84421;s:12:\"delete-84028\";i:84422;s:12:\"delete-84030\";i:84423;s:12:\"delete-84031\";i:84424;s:12:\"delete-84033\";i:84425;s:12:\"delete-84034\";i:84426;s:12:\"delete-84036\";i:84427;s:12:\"delete-84037\";i:84428;s:12:\"delete-84039\";i:84429;s:12:\"delete-84040\";i:84430;s:12:\"delete-84042\";i:84431;s:12:\"delete-84043\";i:84432;s:12:\"delete-84045\";i:84433;s:12:\"delete-84046\";i:84434;s:12:\"delete-84048\";i:84435;s:12:\"delete-84049\";i:84436;s:12:\"delete-84051\";i:84437;s:12:\"delete-84052\";i:84438;s:12:\"delete-84054\";i:84439;s:12:\"delete-84055\";i:84440;s:12:\"delete-84057\";i:84441;s:12:\"delete-84058\";i:84442;s:12:\"delete-84060\";i:84443;s:12:\"delete-84061\";i:84444;s:12:\"delete-84063\";i:84445;s:12:\"delete-84064\";i:84446;s:12:\"delete-84066\";i:84447;s:12:\"delete-84067\";i:84448;s:12:\"delete-84069\";i:84449;s:12:\"delete-84070\";i:84450;s:12:\"delete-84072\";i:84451;s:12:\"delete-84073\";i:84452;s:12:\"delete-84075\";i:84453;s:12:\"delete-84076\";i:84454;s:12:\"delete-84078\";i:84455;s:12:\"delete-84079\";i:84456;s:12:\"delete-84081\";i:84457;s:12:\"delete-84082\";i:84458;s:12:\"delete-84084\";i:84459;s:12:\"delete-84085\";i:84460;s:12:\"delete-84087\";i:84461;s:12:\"delete-84088\";i:84462;s:12:\"delete-84090\";i:84463;s:12:\"delete-84091\";i:84464;s:12:\"delete-84093\";i:84465;s:12:\"delete-84094\";i:84466;s:12:\"delete-84096\";i:84467;s:12:\"delete-84097\";i:84468;s:12:\"delete-84099\";i:84469;s:12:\"delete-84100\";i:84470;s:12:\"delete-84102\";i:84471;s:12:\"delete-84103\";i:84472;s:12:\"delete-84105\";i:84473;s:12:\"delete-84106\";i:84474;s:12:\"delete-84108\";i:84475;s:12:\"delete-84109\";i:84476;s:12:\"delete-84111\";i:84477;s:12:\"delete-84112\";i:84478;s:12:\"delete-84114\";i:84479;s:12:\"delete-84115\";i:84480;s:12:\"delete-84117\";i:84481;s:12:\"delete-84118\";i:84482;s:12:\"delete-84120\";i:84483;s:12:\"delete-84121\";i:84484;s:12:\"delete-84123\";i:84485;s:12:\"delete-84124\";i:84486;s:12:\"delete-84126\";i:84487;s:12:\"delete-84127\";i:84488;s:12:\"delete-84129\";i:84489;s:12:\"delete-84130\";i:84490;s:12:\"delete-84132\";i:84491;s:12:\"delete-84133\";i:84492;s:12:\"delete-84135\";i:84493;s:12:\"delete-84136\";i:84494;s:12:\"delete-84138\";i:84495;s:12:\"delete-84139\";i:84496;s:12:\"delete-84141\";i:84497;s:12:\"delete-84142\";i:84498;s:12:\"delete-84144\";i:84499;s:12:\"delete-84145\";i:84500;s:12:\"delete-84147\";i:84501;s:12:\"delete-84148\";i:84502;s:12:\"delete-84150\";i:84503;s:12:\"delete-84151\";i:84504;s:12:\"delete-84153\";i:84505;s:12:\"delete-84154\";i:84506;s:12:\"delete-84156\";i:84507;s:12:\"delete-84157\";i:84508;s:12:\"delete-84159\";i:84509;s:12:\"delete-84160\";i:84510;s:12:\"delete-84162\";i:84511;s:12:\"delete-84163\";i:84512;s:12:\"delete-84165\";i:84513;s:12:\"delete-84166\";i:84514;s:12:\"delete-84168\";i:84515;s:12:\"delete-84169\";i:84516;s:12:\"delete-84171\";i:84517;s:12:\"delete-84172\";i:84518;s:12:\"delete-84174\";i:84519;s:12:\"delete-84175\";i:84520;s:12:\"delete-84177\";i:84521;s:12:\"delete-84178\";i:84522;s:12:\"delete-84180\";i:84523;s:12:\"delete-84181\";i:84524;s:12:\"delete-84183\";i:84525;s:12:\"delete-84184\";i:84526;s:12:\"delete-84186\";i:84527;s:12:\"delete-84187\";i:84528;s:12:\"delete-84189\";i:84529;s:12:\"delete-84190\";i:84530;s:12:\"delete-84192\";i:84531;s:12:\"delete-84193\";i:84532;s:12:\"delete-84195\";i:84533;s:12:\"delete-84196\";i:84534;s:12:\"delete-84198\";i:84535;s:12:\"delete-84199\";i:84536;s:12:\"delete-84201\";i:84537;s:12:\"delete-84202\";i:84538;s:12:\"delete-84204\";i:84539;s:12:\"delete-84205\";i:84540;s:12:\"delete-84207\";i:84541;s:12:\"delete-84208\";i:84542;s:12:\"delete-84210\";i:84543;s:12:\"delete-84211\";i:84544;s:12:\"delete-84213\";i:84545;s:12:\"delete-84214\";i:84546;s:12:\"delete-84216\";i:84547;s:12:\"delete-84217\";i:84548;s:12:\"delete-84219\";i:84549;s:12:\"delete-84220\";i:84550;s:12:\"delete-84222\";i:84551;s:12:\"delete-84223\";i:84552;s:12:\"delete-84225\";i:84553;s:12:\"delete-84226\";i:84554;s:12:\"delete-84228\";i:84555;s:12:\"delete-84229\";i:84556;s:12:\"delete-84231\";i:84557;s:12:\"delete-84232\";i:84558;s:12:\"delete-84234\";i:84559;s:12:\"delete-84235\";i:84560;s:12:\"delete-84237\";i:84561;s:12:\"delete-84238\";i:84562;s:12:\"delete-84240\";i:84563;s:12:\"delete-84241\";i:84564;s:12:\"delete-84243\";i:84565;s:12:\"delete-84244\";i:84566;s:12:\"delete-84246\";i:84567;s:12:\"delete-84247\";i:84568;s:12:\"delete-84249\";i:84569;s:12:\"delete-84250\";i:84570;s:12:\"delete-84252\";i:84571;s:12:\"delete-84253\";i:84572;s:12:\"delete-84255\";i:84573;s:12:\"delete-84256\";i:84574;s:12:\"delete-84258\";i:84575;s:12:\"delete-84259\";i:84576;s:12:\"delete-84261\";i:84577;s:12:\"delete-84262\";i:84578;s:12:\"delete-84264\";i:84579;s:12:\"delete-84265\";i:84580;s:12:\"delete-84267\";i:84581;s:12:\"delete-84268\";i:84582;s:12:\"delete-84270\";i:84583;s:12:\"delete-84271\";i:84584;s:12:\"delete-84273\";i:84585;s:12:\"delete-84274\";i:84586;s:12:\"delete-84276\";i:84587;s:12:\"delete-84277\";i:84588;s:12:\"delete-84279\";i:84589;s:12:\"delete-84280\";i:84590;s:12:\"delete-84282\";i:84591;s:12:\"delete-84283\";i:84592;s:12:\"delete-84285\";i:84593;s:12:\"delete-84286\";i:84594;s:12:\"delete-84288\";i:84595;s:12:\"delete-84289\";i:84596;s:12:\"delete-84291\";i:84597;s:12:\"delete-84292\";i:84598;s:12:\"delete-84294\";i:84599;s:12:\"delete-84295\";i:84600;s:12:\"delete-84297\";i:84601;s:12:\"delete-84298\";i:84602;s:12:\"delete-84300\";i:84603;s:12:\"delete-84301\";i:84604;s:12:\"delete-84303\";i:84605;s:12:\"delete-84304\";i:84606;s:12:\"delete-84306\";i:84607;s:12:\"delete-84307\";i:84608;s:12:\"delete-84309\";i:84609;s:12:\"delete-84310\";i:84610;s:12:\"delete-84312\";i:84611;s:12:\"delete-84313\";i:84612;s:12:\"delete-84315\";i:84613;s:12:\"delete-84316\";i:84614;s:12:\"delete-84318\";i:84615;s:12:\"delete-84319\";i:84616;s:12:\"delete-84321\";i:84617;s:12:\"delete-84322\";i:84618;s:12:\"delete-84324\";i:84619;s:12:\"delete-84325\";i:84620;s:12:\"delete-84327\";i:84621;s:12:\"delete-84328\";i:84622;s:12:\"delete-84330\";i:84623;s:12:\"delete-84331\";i:84624;s:12:\"delete-84333\";i:84625;s:12:\"delete-84334\";i:84626;s:12:\"delete-84336\";i:84627;s:12:\"delete-84337\";i:84628;s:12:\"delete-84339\";i:84629;s:12:\"delete-84340\";i:84630;s:12:\"delete-84342\";i:84631;s:12:\"delete-84343\";i:84632;s:12:\"delete-84345\";i:84633;s:12:\"delete-84346\";i:84634;s:12:\"delete-84348\";i:84635;s:12:\"delete-84349\";i:84636;s:12:\"delete-84351\";i:84637;s:12:\"delete-84352\";i:84638;s:12:\"delete-84354\";i:84639;s:12:\"delete-84355\";i:84640;s:12:\"delete-84357\";i:84641;s:12:\"delete-84358\";i:84642;s:12:\"delete-84360\";i:84643;s:12:\"delete-84361\";i:84644;s:12:\"delete-84363\";i:84645;s:12:\"delete-84364\";i:84646;s:12:\"delete-84366\";i:84647;s:12:\"delete-84367\";i:84648;s:12:\"delete-84369\";i:84649;s:12:\"delete-84370\";i:84650;s:12:\"delete-84372\";i:84651;s:12:\"delete-84373\";i:84652;s:12:\"delete-84375\";i:84653;s:12:\"delete-84376\";i:84654;s:12:\"delete-84378\";i:84655;s:12:\"delete-84379\";i:84656;s:12:\"delete-84381\";i:84657;s:12:\"delete-84382\";i:84658;s:12:\"delete-84384\";i:84659;s:12:\"delete-84385\";i:84660;s:12:\"delete-84387\";i:84661;s:12:\"delete-84388\";i:84662;s:12:\"delete-84390\";i:84663;s:12:\"delete-84391\";i:84664;s:12:\"delete-84393\";i:84665;s:12:\"delete-84394\";i:84666;s:12:\"delete-84396\";i:84667;s:12:\"delete-84397\";i:84668;s:12:\"delete-84399\";i:84669;s:12:\"delete-84400\";i:84670;s:12:\"delete-84402\";i:84671;s:12:\"delete-84403\";i:84672;s:12:\"delete-84405\";i:84673;s:12:\"delete-84406\";i:84674;s:12:\"delete-84408\";i:84675;s:12:\"delete-84409\";i:84676;s:12:\"delete-84411\";i:84677;s:12:\"delete-84412\";i:84678;s:12:\"delete-84414\";i:84679;s:12:\"delete-84415\";i:84680;s:12:\"delete-84417\";i:84681;s:12:\"delete-84418\";i:84682;s:12:\"delete-84420\";i:84683;s:12:\"delete-84421\";i:84684;s:12:\"delete-84423\";i:84685;s:12:\"delete-84424\";i:84686;s:12:\"delete-84426\";i:84687;s:12:\"delete-84427\";i:84688;s:12:\"delete-84429\";i:84689;s:12:\"delete-84430\";i:84690;s:12:\"delete-84432\";i:84691;s:12:\"delete-84433\";i:84692;s:12:\"delete-84435\";i:84693;s:12:\"delete-84436\";i:84694;s:12:\"delete-84438\";i:84695;s:12:\"delete-84439\";i:84696;s:12:\"delete-84441\";i:84697;s:12:\"delete-84442\";i:84698;s:12:\"delete-84444\";i:84699;s:12:\"delete-84445\";i:84700;s:12:\"delete-84447\";i:84701;s:12:\"delete-84448\";i:84702;s:12:\"delete-84450\";i:84703;s:12:\"delete-84451\";i:84704;s:12:\"delete-84453\";i:84705;s:12:\"delete-84454\";i:84706;s:12:\"delete-84456\";i:84707;s:12:\"delete-84457\";i:84708;s:12:\"delete-84459\";i:84709;s:12:\"delete-84460\";i:84710;s:12:\"delete-84462\";i:84711;s:12:\"delete-84463\";i:84712;s:12:\"delete-84465\";i:84713;s:12:\"delete-84466\";i:84714;s:12:\"delete-84468\";i:84715;s:12:\"delete-84469\";i:84716;s:12:\"delete-84471\";i:84717;s:12:\"delete-84472\";i:84718;s:12:\"delete-84474\";i:84719;s:12:\"delete-84475\";i:84720;s:12:\"delete-84477\";i:84721;s:12:\"delete-84478\";i:84722;s:12:\"delete-84480\";i:84723;s:12:\"delete-84481\";i:84724;s:12:\"delete-84483\";i:84725;s:12:\"delete-84484\";i:84726;s:12:\"delete-84486\";i:84727;s:12:\"delete-84487\";i:84728;s:12:\"delete-84489\";i:84729;s:12:\"delete-84490\";i:84730;s:12:\"delete-84492\";i:84731;s:12:\"delete-84493\";i:84732;s:12:\"delete-84495\";i:84733;s:12:\"delete-84496\";i:84734;s:12:\"delete-84498\";i:84735;s:12:\"delete-84499\";i:84736;s:12:\"delete-84501\";i:84737;s:12:\"delete-84502\";i:84738;s:12:\"delete-84504\";i:84739;s:12:\"delete-84505\";i:84740;s:12:\"delete-84507\";i:84741;s:12:\"delete-84508\";i:84742;s:12:\"delete-84510\";i:84743;s:12:\"delete-84511\";i:84744;s:12:\"delete-84513\";i:84745;s:12:\"delete-84514\";i:84746;s:12:\"delete-84516\";i:84747;s:12:\"delete-84517\";i:84748;s:12:\"delete-84519\";i:84749;s:12:\"delete-84520\";i:84750;s:12:\"delete-84522\";i:84751;s:12:\"delete-84523\";i:84752;s:12:\"delete-84525\";i:84753;s:12:\"delete-84526\";i:84754;s:12:\"delete-84528\";i:84755;s:12:\"delete-84529\";i:84756;s:12:\"delete-84531\";i:84757;s:12:\"delete-84532\";i:84758;s:12:\"delete-84534\";i:84759;s:12:\"delete-84535\";i:84760;s:12:\"delete-84537\";i:84761;s:12:\"delete-84538\";i:84762;s:12:\"delete-84540\";i:84763;s:12:\"delete-84541\";i:84764;s:12:\"delete-84543\";i:84765;s:12:\"delete-84544\";i:84766;s:12:\"delete-84546\";i:84767;s:12:\"delete-84547\";i:84768;s:12:\"delete-84549\";i:84769;s:12:\"delete-84550\";i:84770;s:12:\"delete-84552\";i:84771;s:12:\"delete-84553\";i:84772;s:12:\"delete-84555\";i:84773;s:12:\"delete-84556\";i:84774;s:12:\"delete-84558\";i:84775;s:12:\"delete-84559\";i:84776;s:12:\"delete-84561\";i:84777;s:12:\"delete-84562\";i:84778;s:12:\"delete-84564\";i:84779;s:12:\"delete-84565\";i:84780;s:12:\"delete-84567\";i:84781;s:12:\"delete-84568\";i:84782;s:12:\"delete-84570\";i:84783;s:12:\"delete-84571\";i:84784;s:12:\"delete-84573\";i:84785;s:12:\"delete-84574\";i:84786;s:12:\"delete-84576\";i:84787;s:12:\"delete-84577\";i:84788;s:12:\"delete-84579\";i:84789;s:12:\"delete-84580\";i:84790;s:12:\"delete-84582\";i:84791;s:12:\"delete-84583\";i:84792;s:12:\"delete-84585\";i:84793;s:12:\"delete-84586\";i:84794;s:12:\"delete-84588\";i:84795;s:12:\"delete-84589\";i:84796;s:12:\"delete-84591\";i:84797;s:12:\"delete-84592\";i:84798;s:12:\"delete-84594\";i:84799;s:12:\"delete-84595\";i:84800;s:12:\"delete-84597\";i:84801;s:12:\"delete-84598\";i:84802;s:12:\"delete-84600\";i:84803;s:12:\"delete-84601\";i:84804;s:12:\"delete-84603\";i:84805;s:12:\"delete-84604\";i:84806;s:12:\"delete-84606\";i:84807;s:12:\"delete-84607\";i:84808;s:12:\"delete-84609\";i:84809;s:12:\"delete-84610\";i:84810;s:12:\"delete-84612\";i:84811;s:12:\"delete-84613\";i:84812;s:12:\"delete-84615\";i:84813;s:12:\"delete-84616\";i:84814;s:12:\"delete-84618\";i:84815;s:12:\"delete-84619\";i:84816;s:12:\"delete-84621\";i:84817;s:12:\"delete-84622\";i:84818;s:12:\"delete-84624\";i:84819;s:12:\"delete-84625\";i:84820;s:12:\"delete-84627\";i:84821;s:12:\"delete-84628\";i:84822;s:12:\"delete-84630\";i:84823;s:12:\"delete-84631\";i:84824;s:12:\"delete-84633\";i:84825;s:12:\"delete-84634\";i:84826;s:12:\"delete-84636\";i:84827;s:12:\"delete-84637\";i:84828;s:12:\"delete-84639\";i:84829;s:12:\"delete-84640\";i:84830;s:12:\"delete-84642\";i:84831;s:12:\"delete-84643\";i:84832;s:12:\"delete-84645\";i:84833;s:12:\"delete-84646\";i:84834;s:12:\"delete-84648\";i:84835;s:12:\"delete-84649\";i:84836;s:12:\"delete-84651\";i:84837;s:12:\"delete-84652\";i:84838;s:12:\"delete-84654\";i:84839;s:12:\"delete-84655\";i:84840;s:12:\"delete-84657\";i:84841;s:12:\"delete-84658\";i:84842;s:12:\"delete-84660\";i:84843;s:12:\"delete-84661\";i:84844;s:12:\"delete-84663\";i:84845;s:12:\"delete-84664\";i:84846;s:12:\"delete-84666\";i:84847;s:12:\"delete-84667\";i:84848;s:12:\"delete-84669\";i:84849;s:12:\"delete-84670\";i:84850;s:12:\"delete-84672\";i:84851;s:12:\"delete-84673\";i:84852;s:12:\"delete-84675\";i:84853;s:12:\"delete-84676\";i:84854;s:12:\"delete-84678\";i:84855;s:12:\"delete-84679\";i:84856;s:12:\"delete-84681\";i:84857;s:12:\"delete-84682\";i:84858;s:12:\"delete-84684\";i:84859;s:12:\"delete-84685\";i:84860;s:12:\"delete-84687\";i:84861;s:12:\"delete-84688\";i:84862;s:12:\"delete-84690\";i:84863;s:12:\"delete-84691\";i:84864;s:12:\"delete-84693\";i:84865;s:12:\"delete-84694\";i:84866;s:12:\"delete-84696\";i:84867;s:12:\"delete-84697\";i:84868;s:12:\"delete-84699\";i:84869;s:12:\"delete-84700\";i:84870;s:12:\"delete-84702\";i:84871;s:12:\"delete-84703\";i:84872;s:12:\"delete-84705\";i:84873;s:12:\"delete-84706\";i:84874;s:12:\"delete-84708\";i:84875;s:12:\"delete-84709\";i:84876;s:12:\"delete-84711\";i:84877;s:12:\"delete-84712\";i:84878;s:12:\"delete-84714\";i:84879;s:12:\"delete-84715\";i:84880;s:12:\"delete-84717\";i:84881;s:12:\"delete-84718\";i:84882;s:12:\"delete-84720\";i:84883;s:12:\"delete-84721\";i:84884;s:12:\"delete-84723\";i:84885;s:12:\"delete-84724\";i:84886;s:12:\"delete-84726\";i:84887;s:12:\"delete-84727\";i:84888;s:12:\"delete-84729\";i:84889;s:12:\"delete-84730\";i:84890;s:12:\"delete-84732\";i:84891;s:12:\"delete-84733\";i:84892;s:12:\"delete-84735\";i:84893;s:12:\"delete-84736\";i:84894;s:12:\"delete-84738\";i:84895;s:12:\"delete-84739\";i:84896;s:12:\"delete-84741\";i:84897;s:12:\"delete-84742\";i:84898;s:12:\"delete-84744\";i:84899;s:12:\"delete-84745\";i:84900;s:12:\"delete-84747\";i:84901;s:12:\"delete-84748\";i:84902;s:12:\"delete-84750\";i:84903;s:12:\"delete-84751\";i:84904;s:12:\"delete-84753\";i:84905;s:12:\"delete-84754\";i:84906;s:12:\"delete-84756\";i:84907;s:12:\"delete-84757\";i:84908;s:12:\"delete-84759\";i:84909;s:12:\"delete-84760\";i:84910;s:12:\"delete-84762\";i:84911;s:12:\"delete-84763\";i:84912;s:12:\"delete-84765\";i:84913;s:12:\"delete-84766\";i:84914;s:12:\"delete-84768\";i:84915;s:12:\"delete-84769\";i:84916;s:12:\"delete-84771\";i:84917;s:12:\"delete-84772\";i:84918;s:12:\"delete-84774\";i:84919;s:12:\"delete-84775\";i:84920;s:12:\"delete-84777\";i:84921;s:12:\"delete-84778\";i:84922;s:12:\"delete-84780\";i:84923;s:12:\"delete-84781\";i:84924;s:12:\"delete-84783\";i:84925;s:12:\"delete-84784\";i:84926;s:12:\"delete-84786\";i:84927;s:12:\"delete-84787\";i:84928;s:12:\"delete-84789\";i:84929;s:12:\"delete-84790\";i:84930;s:12:\"delete-84792\";i:84931;s:12:\"delete-84793\";i:84932;s:12:\"delete-84795\";i:84933;s:12:\"delete-84796\";i:84934;s:12:\"delete-84798\";i:84935;s:12:\"delete-84799\";i:84936;s:12:\"delete-84801\";i:84937;s:12:\"delete-84802\";i:84938;s:12:\"delete-84804\";i:84939;s:12:\"delete-84805\";i:84940;s:12:\"delete-84807\";i:84941;s:12:\"delete-84808\";i:84942;s:12:\"delete-84810\";i:84943;s:12:\"delete-84811\";i:84944;s:12:\"delete-84813\";i:84945;s:12:\"delete-84814\";i:84946;s:12:\"delete-84816\";i:84947;s:12:\"delete-84817\";i:84948;s:12:\"delete-84819\";i:84949;s:12:\"delete-84820\";i:84950;s:12:\"delete-84822\";i:84951;s:12:\"delete-84823\";i:84952;s:12:\"delete-84825\";i:84953;s:12:\"delete-84826\";i:84954;s:12:\"delete-84828\";i:84955;s:12:\"delete-84829\";i:84956;s:12:\"delete-84831\";i:84957;s:12:\"delete-84832\";i:84958;s:12:\"delete-84834\";i:84959;s:12:\"delete-84835\";i:84960;s:12:\"delete-84837\";i:84961;s:12:\"delete-84838\";i:84962;s:12:\"delete-84840\";i:84963;s:12:\"delete-84841\";i:84964;s:12:\"delete-84843\";i:84965;s:12:\"delete-84844\";i:84966;s:12:\"delete-84846\";i:84967;s:12:\"delete-84847\";i:84968;s:12:\"delete-84849\";i:84969;s:12:\"delete-84850\";i:84970;s:12:\"delete-84852\";i:84971;s:12:\"delete-84853\";i:84972;s:12:\"delete-84855\";i:84973;s:12:\"delete-84856\";i:84974;s:12:\"delete-84858\";i:84975;s:12:\"delete-84859\";i:84976;s:12:\"delete-84861\";i:84977;s:12:\"delete-84862\";i:84978;s:12:\"delete-84864\";i:84979;s:12:\"delete-84865\";i:84980;s:12:\"delete-84867\";i:84981;s:12:\"delete-84868\";i:84982;s:12:\"delete-84870\";i:84983;s:12:\"delete-84871\";i:84984;s:12:\"delete-84873\";i:84985;s:12:\"delete-84874\";i:84986;s:12:\"delete-84876\";i:84987;s:12:\"delete-84877\";i:84988;s:12:\"delete-84879\";i:84989;s:12:\"delete-84880\";i:84990;s:12:\"delete-84882\";i:84991;s:12:\"delete-84883\";i:84992;s:12:\"delete-84885\";i:84993;s:12:\"delete-84886\";i:84994;s:12:\"delete-84888\";i:84995;s:12:\"delete-84889\";i:84996;s:12:\"delete-84891\";i:84997;s:12:\"delete-84892\";i:84998;s:12:\"delete-84894\";i:84999;s:12:\"delete-84895\";i:85000;s:12:\"delete-84897\";i:85001;s:12:\"delete-84898\";i:85002;s:12:\"delete-84900\";i:85003;s:12:\"delete-84901\";i:85004;s:12:\"delete-84903\";i:85005;s:12:\"delete-84904\";i:85006;s:12:\"delete-84906\";i:85007;s:12:\"delete-84907\";i:85008;s:12:\"delete-84909\";i:85009;s:12:\"delete-84910\";i:85010;s:12:\"delete-84912\";i:85011;s:12:\"delete-84913\";i:85012;s:12:\"delete-84915\";i:85013;s:12:\"delete-84916\";i:85014;s:12:\"delete-84918\";i:85015;s:12:\"delete-84919\";i:85016;s:12:\"delete-84921\";i:85017;s:12:\"delete-84922\";i:85018;s:12:\"delete-84924\";i:85019;s:12:\"delete-84925\";i:85020;s:12:\"delete-84927\";i:85021;s:12:\"delete-84928\";i:85022;s:12:\"delete-84930\";i:85023;s:12:\"delete-84931\";i:85024;s:12:\"delete-84933\";i:85025;s:12:\"delete-84934\";i:85026;s:12:\"delete-84936\";i:85027;s:12:\"delete-84937\";i:85028;s:12:\"delete-84939\";i:85029;s:12:\"delete-84940\";i:85030;s:12:\"delete-84942\";i:85031;s:12:\"delete-84943\";i:85032;s:12:\"delete-84945\";i:85033;s:12:\"delete-84946\";i:85034;s:12:\"delete-84948\";i:85035;s:12:\"delete-84949\";i:85036;s:12:\"delete-84951\";i:85037;s:12:\"delete-84952\";i:85038;s:12:\"delete-84954\";i:85039;s:12:\"delete-84955\";i:85040;s:12:\"delete-84957\";i:85041;s:12:\"delete-84958\";i:85042;s:12:\"delete-84960\";i:85043;s:12:\"delete-84961\";i:85044;s:12:\"delete-84963\";i:85045;s:12:\"delete-84964\";i:85046;s:12:\"delete-84966\";i:85047;s:12:\"delete-84967\";i:85048;s:12:\"delete-84969\";i:85049;s:12:\"delete-84970\";i:85050;s:12:\"delete-84972\";i:85051;s:12:\"delete-84973\";i:85052;s:12:\"delete-84975\";i:85053;s:12:\"delete-84976\";i:85054;s:12:\"delete-84978\";i:85055;s:12:\"delete-84979\";i:85056;s:12:\"delete-84981\";i:85057;s:12:\"delete-84982\";i:85058;s:12:\"delete-84984\";i:85059;s:12:\"delete-84985\";i:85060;s:12:\"delete-84987\";i:85061;s:12:\"delete-84988\";i:85062;s:12:\"delete-84990\";i:85063;s:12:\"delete-84991\";i:85064;s:12:\"delete-84993\";i:85065;s:12:\"delete-84994\";i:85066;s:12:\"delete-84996\";i:85067;s:12:\"delete-84997\";i:85068;s:12:\"delete-84999\";i:85069;s:12:\"delete-85000\";i:85070;s:12:\"delete-85002\";i:85071;s:12:\"delete-85003\";i:85072;s:12:\"delete-85005\";i:85073;s:12:\"delete-85006\";i:85074;s:12:\"delete-85008\";i:85075;s:12:\"delete-85009\";i:85076;s:12:\"delete-85011\";i:85077;s:12:\"delete-85012\";i:85078;s:12:\"delete-85014\";i:85079;s:12:\"delete-85015\";i:85080;s:12:\"delete-85017\";i:85081;s:12:\"delete-85018\";i:85082;s:12:\"delete-85020\";i:85083;s:12:\"delete-85021\";i:85084;s:12:\"delete-85023\";i:85085;s:12:\"delete-85024\";i:85086;s:12:\"delete-85026\";i:85087;s:12:\"delete-85027\";i:85088;s:12:\"delete-85029\";i:85089;s:12:\"delete-85030\";i:85090;s:12:\"delete-85032\";i:85091;s:12:\"delete-85033\";i:85092;s:12:\"delete-85035\";i:85093;s:12:\"delete-85036\";i:85094;s:12:\"delete-85038\";i:85095;s:12:\"delete-85039\";i:85096;s:12:\"delete-85041\";i:85097;s:12:\"delete-85042\";i:85098;s:12:\"delete-85044\";i:85099;s:12:\"delete-85045\";i:85100;s:12:\"delete-85047\";i:85101;s:12:\"delete-85048\";i:85102;s:12:\"delete-85050\";i:85103;s:12:\"delete-85051\";i:85104;s:12:\"delete-85053\";i:85105;s:12:\"delete-85054\";i:85106;s:12:\"delete-85056\";i:85107;s:12:\"delete-85057\";i:85108;s:12:\"delete-85059\";i:85109;s:12:\"delete-85060\";i:85110;s:12:\"delete-85062\";i:85111;s:12:\"delete-85063\";i:85112;s:12:\"delete-85065\";i:85113;s:12:\"delete-85066\";i:85114;s:12:\"delete-85068\";i:85115;s:12:\"delete-85069\";i:85116;s:12:\"delete-85071\";i:85117;s:12:\"delete-85072\";i:85118;s:12:\"delete-85074\";i:85119;s:12:\"delete-85075\";i:85120;s:12:\"delete-85077\";i:85121;s:12:\"delete-85078\";i:85122;s:12:\"delete-85080\";i:85123;s:12:\"delete-85081\";i:85124;s:12:\"delete-85083\";i:85125;s:12:\"delete-85084\";i:85126;s:12:\"delete-85086\";i:85127;s:12:\"delete-85087\";i:85128;s:12:\"delete-85089\";i:85129;s:12:\"delete-85090\";i:85130;s:12:\"delete-85092\";i:85131;s:12:\"delete-85093\";i:85132;s:12:\"delete-85095\";i:85133;s:12:\"delete-85096\";i:85134;s:12:\"delete-85098\";i:85135;s:12:\"delete-85099\";i:85136;s:12:\"delete-85101\";i:85137;s:12:\"delete-85102\";i:85138;s:12:\"delete-85104\";i:85139;s:12:\"delete-85105\";i:85140;s:12:\"delete-85107\";i:85141;s:12:\"delete-85108\";i:85142;s:12:\"delete-85110\";i:85143;s:12:\"delete-85111\";i:85144;s:12:\"delete-85113\";i:85145;s:12:\"delete-85114\";i:85146;s:12:\"delete-85116\";i:85147;s:12:\"delete-85117\";i:85148;s:12:\"delete-85119\";i:85149;s:12:\"delete-85120\";i:85150;s:12:\"delete-85122\";i:85151;s:12:\"delete-85123\";i:85152;s:12:\"delete-85125\";i:85153;s:12:\"delete-85126\";i:85154;s:12:\"delete-85128\";i:85155;s:12:\"delete-85129\";i:85156;s:12:\"delete-85131\";i:85157;s:12:\"delete-85132\";i:85158;s:12:\"delete-85134\";i:85159;s:12:\"delete-85135\";i:85160;s:12:\"delete-85137\";i:85161;s:12:\"delete-85138\";i:85162;s:12:\"delete-85140\";i:85163;s:12:\"delete-85141\";i:85164;s:12:\"delete-85143\";i:85165;s:12:\"delete-85144\";i:85166;s:12:\"delete-85146\";i:85167;s:12:\"delete-85147\";i:85168;s:12:\"delete-85149\";i:85169;s:12:\"delete-85150\";i:85170;s:12:\"delete-85152\";i:85171;s:12:\"delete-85153\";i:85172;s:12:\"delete-85155\";i:85173;s:12:\"delete-85156\";i:85174;s:12:\"delete-85158\";i:85175;s:12:\"delete-85159\";i:85176;s:12:\"delete-85161\";i:85177;s:12:\"delete-85162\";i:85178;s:12:\"delete-85164\";i:85179;s:12:\"delete-85165\";i:85180;s:12:\"delete-85167\";i:85181;s:12:\"delete-85168\";i:85182;s:12:\"delete-85170\";i:85183;s:12:\"delete-85171\";i:85184;s:12:\"delete-85173\";i:85185;s:12:\"delete-85174\";i:85186;s:12:\"delete-85176\";i:85187;s:12:\"delete-85177\";i:85188;s:12:\"delete-85179\";i:85189;s:12:\"delete-85180\";i:85190;s:12:\"delete-85182\";i:85191;s:12:\"delete-85183\";i:85192;s:12:\"delete-85185\";i:85193;s:12:\"delete-85186\";i:85194;s:12:\"delete-85188\";i:85195;s:12:\"delete-85189\";i:85196;s:12:\"delete-85191\";i:85197;s:12:\"delete-85192\";i:85198;s:12:\"delete-85194\";i:85199;s:12:\"delete-85195\";i:85200;s:12:\"delete-85197\";i:85201;s:12:\"delete-85198\";i:85202;s:12:\"delete-85200\";i:85203;s:12:\"delete-85201\";i:85204;s:12:\"delete-85203\";i:85205;s:12:\"delete-85204\";i:85206;s:12:\"delete-85206\";i:85207;s:12:\"delete-85207\";i:85208;s:12:\"delete-85209\";i:85209;s:12:\"delete-85210\";i:85210;s:12:\"delete-85212\";i:85211;s:12:\"delete-85213\";i:85212;s:12:\"delete-85215\";i:85213;s:12:\"delete-85216\";i:85214;s:12:\"delete-85218\";i:85215;s:12:\"delete-85219\";i:85216;s:12:\"delete-85221\";i:85217;s:12:\"delete-85222\";i:85218;s:12:\"delete-85224\";i:85219;s:12:\"delete-85225\";i:85220;s:12:\"delete-85227\";i:85221;s:12:\"delete-85228\";i:85222;s:12:\"delete-85230\";i:85223;s:12:\"delete-85231\";i:85224;s:12:\"delete-85233\";i:85225;s:12:\"delete-85234\";i:85226;s:12:\"delete-85236\";i:85227;s:12:\"delete-85237\";i:85228;s:12:\"delete-85239\";i:85229;s:12:\"delete-85240\";i:85230;s:12:\"delete-85242\";i:85231;s:12:\"delete-85243\";i:85232;s:12:\"delete-85245\";i:85233;s:12:\"delete-85246\";i:85234;s:12:\"delete-85248\";i:85235;s:12:\"delete-85249\";i:85236;s:12:\"delete-85251\";i:85237;s:12:\"delete-85252\";i:85238;s:12:\"delete-85254\";i:85239;s:12:\"delete-85255\";i:85240;s:12:\"delete-85257\";i:85241;s:12:\"delete-85258\";i:85242;s:12:\"delete-85260\";i:85243;s:12:\"delete-85261\";i:85244;s:12:\"delete-85263\";i:85245;s:12:\"delete-85264\";i:85246;s:12:\"delete-85266\";i:85247;s:12:\"delete-85267\";i:85248;s:12:\"delete-85269\";i:85249;s:12:\"delete-85270\";i:85250;s:12:\"delete-85272\";i:85251;s:12:\"delete-85273\";i:85252;s:12:\"delete-85275\";i:85253;s:12:\"delete-85276\";i:85254;s:12:\"delete-85278\";i:85255;s:12:\"delete-85279\";i:85256;s:12:\"delete-85281\";i:85257;s:12:\"delete-85282\";i:85258;s:12:\"delete-85284\";i:85259;s:12:\"delete-85285\";i:85260;s:12:\"delete-85287\";i:85261;s:12:\"delete-85288\";i:85262;s:12:\"delete-85290\";i:85263;s:12:\"delete-85291\";i:85264;s:12:\"delete-85293\";i:85265;s:12:\"delete-85294\";i:85266;s:12:\"delete-85296\";i:85267;s:12:\"delete-85297\";i:85268;s:12:\"delete-85299\";i:85269;s:12:\"delete-85300\";i:85270;s:12:\"delete-85302\";i:85271;s:12:\"delete-85303\";i:85272;s:12:\"delete-85305\";i:85273;s:12:\"delete-85306\";i:85274;s:12:\"delete-85308\";i:85275;s:12:\"delete-85309\";i:85276;s:12:\"delete-85311\";i:85277;s:12:\"delete-85312\";i:85278;s:12:\"delete-85314\";i:85279;s:12:\"delete-85315\";i:85280;s:12:\"delete-85317\";i:85281;s:12:\"delete-85318\";i:85282;s:12:\"delete-85320\";i:85283;s:12:\"delete-85321\";i:85284;s:12:\"delete-85323\";i:85285;s:12:\"delete-85324\";i:85286;s:12:\"delete-85326\";i:85287;s:12:\"delete-85327\";i:85288;s:12:\"delete-85329\";i:85289;s:12:\"delete-85330\";i:85290;s:12:\"delete-85332\";i:85291;s:12:\"delete-85333\";i:85292;s:12:\"delete-85335\";i:85293;s:12:\"delete-85336\";i:85294;s:12:\"delete-85338\";i:85295;s:12:\"delete-85339\";i:85296;s:12:\"delete-85341\";i:85297;s:12:\"delete-85342\";i:85298;s:12:\"delete-85344\";i:85299;s:12:\"delete-85345\";i:85300;s:12:\"delete-85347\";i:85301;s:12:\"delete-85348\";i:85302;s:12:\"delete-85350\";i:85303;s:12:\"delete-85351\";i:85304;s:12:\"delete-85353\";i:85305;s:12:\"delete-85354\";i:85306;s:12:\"delete-85356\";i:85307;s:12:\"delete-85357\";i:85308;s:12:\"delete-85359\";i:85309;s:12:\"delete-85360\";i:85310;s:12:\"delete-85362\";i:85311;s:12:\"delete-85363\";i:85312;s:12:\"delete-85365\";i:85313;s:12:\"delete-85366\";i:85314;s:12:\"delete-85368\";i:85315;s:12:\"delete-85369\";i:85316;s:12:\"delete-85371\";i:85317;s:12:\"delete-85372\";i:85318;s:12:\"delete-85374\";i:85319;s:12:\"delete-85375\";i:85320;s:12:\"delete-85377\";i:85321;s:12:\"delete-85378\";i:85322;s:12:\"delete-85380\";i:85323;s:12:\"delete-85381\";i:85324;s:12:\"delete-85383\";i:85325;s:12:\"delete-85384\";i:85326;s:12:\"delete-85386\";i:85327;s:12:\"delete-85387\";i:85328;s:12:\"delete-85389\";i:85329;s:12:\"delete-85390\";i:85330;s:12:\"delete-85392\";i:85331;s:12:\"delete-85393\";i:85332;s:12:\"delete-85395\";i:85333;s:12:\"delete-85396\";i:85334;s:12:\"delete-85398\";i:85335;s:12:\"delete-85399\";i:85336;s:12:\"delete-85401\";i:85337;s:12:\"delete-85402\";i:85338;s:12:\"delete-85404\";i:85339;s:12:\"delete-85405\";i:85340;s:12:\"delete-85407\";i:85341;s:12:\"delete-85408\";i:85342;s:12:\"delete-85410\";i:85343;s:12:\"delete-85411\";i:85344;s:12:\"delete-85413\";i:85345;s:12:\"delete-85414\";i:85346;s:12:\"delete-85416\";i:85347;s:12:\"delete-85417\";i:85348;s:12:\"delete-85419\";i:85349;s:12:\"delete-85420\";i:85350;s:12:\"delete-85422\";i:85351;s:12:\"delete-85423\";i:85352;s:12:\"delete-85425\";i:85353;s:12:\"delete-85426\";i:85354;s:12:\"delete-85428\";i:85355;s:12:\"delete-85429\";i:85356;s:12:\"delete-85431\";i:85357;s:12:\"delete-85432\";i:85358;s:12:\"delete-85434\";i:85359;s:12:\"delete-85435\";i:85360;s:12:\"delete-85437\";i:85361;s:12:\"delete-85438\";i:85362;s:12:\"delete-85440\";i:85363;s:12:\"delete-85441\";i:85364;s:12:\"delete-85443\";i:85365;s:12:\"delete-85444\";i:85366;s:12:\"delete-85446\";i:85367;s:12:\"delete-85447\";i:85368;s:12:\"delete-85449\";i:85369;s:12:\"delete-85450\";i:85370;s:12:\"delete-85452\";i:85371;s:12:\"delete-85453\";i:85372;s:12:\"delete-85455\";i:85373;s:12:\"delete-85456\";i:85374;s:12:\"delete-85458\";i:85375;s:12:\"delete-85459\";i:85376;s:12:\"delete-85461\";i:85377;s:12:\"delete-85462\";i:85378;s:12:\"delete-85464\";i:85379;s:12:\"delete-85465\";i:85380;s:12:\"delete-85467\";i:85381;s:12:\"delete-85468\";i:85382;s:12:\"delete-85470\";i:85383;s:12:\"delete-85471\";i:85384;s:12:\"delete-85473\";i:85385;s:12:\"delete-85474\";i:85386;s:12:\"delete-85476\";i:85387;s:12:\"delete-85477\";i:85388;s:12:\"delete-85479\";i:85389;s:12:\"delete-85480\";i:85390;s:12:\"delete-85482\";i:85391;s:12:\"delete-85483\";i:85392;s:12:\"delete-85485\";i:85393;s:12:\"delete-85486\";i:85394;s:12:\"delete-85488\";i:85395;s:12:\"delete-85489\";i:85396;s:12:\"delete-85491\";i:85397;s:12:\"delete-85492\";i:85398;s:12:\"delete-85494\";i:85399;s:12:\"delete-85495\";i:85400;s:12:\"delete-85497\";i:85401;s:12:\"delete-85498\";i:85402;s:12:\"delete-85500\";i:85403;s:12:\"delete-85501\";i:85404;s:12:\"delete-85503\";i:85405;s:12:\"delete-85504\";i:85406;s:12:\"delete-85506\";i:85407;s:12:\"delete-85507\";i:85408;s:12:\"delete-85509\";i:85409;s:12:\"delete-85510\";i:85410;s:12:\"delete-85512\";i:85411;s:12:\"delete-85513\";i:85412;s:12:\"delete-85515\";i:85413;s:12:\"delete-85516\";i:85414;s:12:\"delete-85518\";i:85415;s:12:\"delete-85519\";i:85416;s:12:\"delete-85521\";i:85417;s:12:\"delete-85522\";i:85418;s:12:\"delete-85524\";i:85419;s:12:\"delete-85525\";i:85420;s:12:\"delete-85527\";i:85421;s:12:\"delete-85528\";i:85422;s:12:\"delete-85530\";i:85423;s:12:\"delete-85531\";i:85424;s:12:\"delete-85533\";i:85425;s:12:\"delete-85534\";i:85426;s:12:\"delete-85536\";i:85427;s:12:\"delete-85537\";i:85428;s:12:\"delete-85539\";i:85429;s:12:\"delete-85540\";i:85430;s:12:\"delete-85542\";i:85431;s:12:\"delete-85543\";i:85432;s:12:\"delete-85545\";i:85433;s:12:\"delete-85546\";i:85434;s:12:\"delete-85548\";i:85435;s:12:\"delete-85549\";i:85436;s:12:\"delete-85551\";i:85437;s:12:\"delete-85552\";i:85438;s:12:\"delete-85554\";i:85439;s:12:\"delete-85555\";i:85440;s:12:\"delete-85557\";i:85441;s:12:\"delete-85558\";i:85442;s:12:\"delete-85560\";i:85443;s:12:\"delete-85561\";i:85444;s:12:\"delete-85563\";i:85445;s:12:\"delete-85564\";i:85446;s:12:\"delete-85566\";i:85447;s:12:\"delete-85567\";i:85448;s:12:\"delete-85569\";i:85449;s:12:\"delete-85570\";i:85450;s:12:\"delete-85572\";i:85451;s:12:\"delete-85573\";i:85452;s:12:\"delete-85575\";i:85453;s:12:\"delete-85576\";i:85454;s:12:\"delete-85578\";i:85455;s:12:\"delete-85579\";i:85456;s:12:\"delete-85581\";i:85457;s:12:\"delete-85582\";i:85458;s:12:\"delete-85584\";i:85459;s:12:\"delete-85585\";i:85460;s:12:\"delete-85587\";i:85461;s:12:\"delete-85588\";i:85462;s:12:\"delete-85590\";i:85463;s:12:\"delete-85591\";i:85464;s:12:\"delete-85593\";i:85465;s:12:\"delete-85594\";i:85466;s:12:\"delete-85596\";i:85467;s:12:\"delete-85597\";i:85468;s:12:\"delete-85599\";i:85469;s:12:\"delete-85600\";i:85470;s:12:\"delete-85602\";i:85471;s:12:\"delete-85603\";i:85472;s:12:\"delete-85605\";i:85473;s:12:\"delete-85606\";i:85474;s:12:\"delete-85608\";i:85475;s:12:\"delete-85609\";i:85476;s:12:\"delete-85611\";i:85477;s:12:\"delete-85612\";i:85478;s:12:\"delete-85614\";i:85479;s:12:\"delete-85615\";i:85480;s:12:\"delete-85617\";i:85481;s:12:\"delete-85618\";i:85482;s:12:\"delete-85620\";i:85483;s:12:\"delete-85621\";i:85484;s:12:\"delete-85623\";i:85485;s:12:\"delete-85624\";i:85486;s:12:\"delete-85626\";i:85487;s:12:\"delete-85627\";i:85488;s:12:\"delete-85629\";i:85489;s:12:\"delete-85630\";i:85490;s:12:\"delete-85632\";i:85491;s:12:\"delete-85633\";i:85492;s:12:\"delete-85635\";i:85493;s:12:\"delete-85636\";i:85494;s:12:\"delete-85638\";i:85495;s:12:\"delete-85639\";i:85496;s:12:\"delete-85641\";i:85497;s:12:\"delete-85642\";i:85498;s:12:\"delete-85644\";i:85499;s:12:\"delete-85645\";i:85500;s:12:\"delete-85647\";i:85501;s:12:\"delete-85648\";i:85502;s:12:\"delete-85650\";i:85503;s:12:\"delete-85651\";i:85504;s:12:\"delete-85653\";i:85505;s:12:\"delete-85654\";i:85506;s:12:\"delete-85656\";i:85507;s:12:\"delete-85657\";i:85508;s:12:\"delete-85659\";i:85509;s:12:\"delete-85660\";i:85510;s:12:\"delete-85662\";i:85511;s:12:\"delete-85663\";i:85512;s:12:\"delete-85665\";i:85513;s:12:\"delete-85666\";i:85514;s:12:\"delete-85668\";i:85515;s:12:\"delete-85669\";i:85516;s:12:\"delete-85671\";i:85517;s:12:\"delete-85672\";i:85518;s:12:\"delete-85674\";i:85519;s:12:\"delete-85675\";i:85520;s:12:\"delete-85677\";i:85521;s:12:\"delete-85678\";i:85522;s:12:\"delete-85680\";i:85523;s:12:\"delete-85681\";i:85524;s:12:\"delete-85683\";i:85525;s:12:\"delete-85684\";i:85526;s:12:\"delete-85686\";i:85527;s:12:\"delete-85687\";i:85528;s:12:\"delete-85689\";i:85529;s:12:\"delete-85690\";i:85530;s:12:\"delete-85692\";i:85531;s:12:\"delete-85693\";i:85532;s:12:\"delete-85695\";i:85533;s:12:\"delete-85696\";i:85534;s:12:\"delete-85698\";i:85535;s:12:\"delete-85699\";i:85536;s:12:\"delete-85701\";i:85537;s:12:\"delete-85702\";i:85538;s:12:\"delete-85704\";i:85539;s:12:\"delete-85705\";i:85540;s:12:\"delete-85707\";i:85541;s:12:\"delete-85708\";i:85542;s:12:\"delete-85710\";i:85543;s:12:\"delete-85711\";i:85544;s:12:\"delete-85713\";i:85545;s:12:\"delete-85714\";i:85546;s:12:\"delete-85716\";i:85547;s:12:\"delete-85717\";i:85548;s:12:\"delete-85719\";i:85549;s:12:\"delete-85720\";i:85550;s:12:\"delete-85722\";i:85551;s:12:\"delete-85723\";i:85552;s:12:\"delete-85725\";i:85553;s:12:\"delete-85726\";i:85554;s:12:\"delete-85728\";i:85555;s:12:\"delete-85729\";i:85556;s:12:\"delete-85731\";i:85557;s:12:\"delete-85732\";i:85558;s:12:\"delete-85734\";i:85559;s:12:\"delete-85735\";i:85560;s:12:\"delete-85737\";i:85561;s:12:\"delete-85738\";i:85562;s:12:\"delete-85740\";i:85563;s:12:\"delete-85741\";i:85564;s:12:\"delete-85743\";i:85565;s:12:\"delete-85744\";i:85566;s:12:\"delete-85746\";i:85567;s:12:\"delete-85747\";i:85568;s:12:\"delete-85749\";i:85569;s:12:\"delete-85750\";i:85570;s:12:\"delete-85752\";i:85571;s:12:\"delete-85753\";i:85572;s:12:\"delete-85755\";i:85573;s:12:\"delete-85756\";i:85574;s:12:\"delete-85758\";i:85575;s:12:\"delete-85759\";i:85576;s:12:\"delete-85761\";i:85577;s:12:\"delete-85762\";i:85578;s:12:\"delete-85764\";i:85579;s:12:\"delete-85765\";i:85580;s:12:\"delete-85767\";i:85581;s:12:\"delete-85768\";i:85582;s:12:\"delete-85770\";i:85583;s:12:\"delete-85771\";i:85584;s:12:\"delete-85773\";i:85585;s:12:\"delete-85774\";i:85586;s:12:\"delete-85776\";i:85587;s:12:\"delete-85777\";i:85588;s:12:\"delete-85779\";i:85589;s:12:\"delete-85780\";i:85590;s:12:\"delete-85782\";i:85591;s:12:\"delete-85783\";i:85592;s:12:\"delete-85785\";i:85593;s:12:\"delete-85786\";i:85594;s:12:\"delete-85788\";i:85595;s:12:\"delete-85789\";i:85596;s:12:\"delete-85791\";i:85597;s:12:\"delete-85792\";i:85598;s:12:\"delete-85794\";i:85599;s:12:\"delete-85795\";i:85600;s:12:\"delete-85797\";i:85601;s:12:\"delete-85798\";i:85602;s:12:\"delete-85800\";i:85603;s:12:\"delete-85801\";i:85604;s:12:\"delete-85803\";i:85605;s:12:\"delete-85804\";i:85606;s:12:\"delete-85806\";i:85607;s:12:\"delete-85807\";i:85608;s:12:\"delete-85809\";i:85609;s:12:\"delete-85810\";i:85610;s:12:\"delete-85812\";i:85611;s:12:\"delete-85813\";i:85612;s:12:\"delete-85815\";i:85613;s:12:\"delete-85816\";i:85614;s:12:\"delete-85818\";i:85615;s:12:\"delete-85819\";i:85616;s:12:\"delete-85821\";i:85617;s:12:\"delete-85822\";i:85618;s:12:\"delete-85824\";i:85619;s:12:\"delete-85825\";i:85620;s:12:\"delete-85827\";i:85621;s:12:\"delete-85828\";i:85622;s:12:\"delete-85830\";i:85623;s:12:\"delete-85831\";i:85624;s:12:\"delete-85833\";i:85625;s:12:\"delete-85834\";i:85626;s:12:\"delete-85836\";i:85627;s:12:\"delete-85837\";i:85628;s:12:\"delete-85839\";i:85629;s:12:\"delete-85840\";i:85630;s:12:\"delete-85842\";i:85631;s:12:\"delete-85843\";i:85632;s:12:\"delete-85844\";i:85633;s:12:\"delete-85846\";i:85634;s:12:\"delete-85847\";i:85635;s:12:\"delete-85849\";i:85636;s:12:\"delete-85850\";i:85637;s:12:\"delete-85852\";i:85638;s:12:\"delete-85853\";i:85639;s:12:\"delete-85855\";i:85640;s:12:\"delete-85856\";i:85641;s:12:\"delete-85858\";i:85642;s:12:\"delete-85859\";i:85643;s:12:\"delete-85861\";i:85644;s:12:\"delete-85862\";i:85645;s:12:\"delete-85864\";i:85646;s:12:\"delete-85865\";i:85647;s:12:\"delete-85867\";i:85648;s:12:\"delete-85868\";i:85649;s:12:\"delete-85870\";i:85650;s:12:\"delete-85871\";i:85651;s:12:\"delete-85873\";i:85652;s:12:\"delete-85874\";i:85653;s:12:\"delete-85876\";i:85654;s:12:\"delete-85877\";i:85655;s:12:\"delete-85879\";i:85656;s:12:\"delete-85880\";i:85657;s:12:\"delete-85882\";i:85658;s:12:\"delete-85883\";i:85659;s:12:\"delete-85885\";i:85660;s:12:\"delete-85886\";i:85661;s:12:\"delete-85888\";i:85662;s:12:\"delete-85889\";i:85663;s:12:\"delete-85891\";i:85664;s:12:\"delete-85892\";i:85665;s:12:\"delete-85894\";i:85666;s:12:\"delete-85895\";i:85667;s:12:\"delete-85897\";i:85668;s:12:\"delete-85898\";i:85669;s:12:\"delete-85900\";i:85670;s:12:\"delete-85901\";i:85671;s:12:\"delete-85903\";i:85672;s:12:\"delete-85904\";i:85673;s:12:\"delete-85906\";i:85674;s:12:\"delete-85907\";i:85675;s:12:\"delete-85909\";i:85676;s:12:\"delete-85910\";i:85677;s:12:\"delete-85912\";i:85678;s:12:\"delete-85913\";i:85679;s:12:\"delete-85915\";i:85680;s:12:\"delete-85916\";i:85681;s:12:\"delete-85918\";i:85682;s:12:\"delete-85919\";i:85683;s:12:\"delete-85921\";i:85684;s:12:\"delete-85922\";i:85685;s:12:\"delete-85924\";i:85686;s:12:\"delete-85925\";i:85687;s:12:\"delete-85927\";i:85688;s:12:\"delete-85928\";i:85689;s:12:\"delete-85930\";i:85690;s:12:\"delete-85931\";i:85691;s:12:\"delete-85933\";i:85692;s:12:\"delete-85934\";i:85693;s:12:\"delete-85936\";i:85694;s:12:\"delete-85937\";i:85695;s:12:\"delete-85939\";i:85696;s:12:\"delete-85940\";i:85697;s:12:\"delete-85942\";i:85698;s:12:\"delete-85943\";i:85699;s:12:\"delete-85945\";i:85700;s:12:\"delete-85946\";i:85701;s:12:\"delete-85948\";i:85702;s:12:\"delete-85949\";i:85703;s:12:\"delete-85951\";i:85704;s:12:\"delete-85952\";i:85705;s:12:\"delete-85954\";i:85706;s:12:\"delete-85955\";i:85707;s:12:\"delete-85957\";i:85708;s:12:\"delete-85958\";i:85709;s:12:\"delete-85960\";i:85710;s:12:\"delete-85961\";i:85711;s:12:\"delete-85963\";i:85712;s:12:\"delete-85964\";i:85713;s:12:\"delete-85966\";i:85714;s:12:\"delete-85967\";i:85715;s:12:\"delete-85969\";i:85716;s:12:\"delete-85970\";i:85717;s:12:\"delete-85972\";i:85718;s:12:\"delete-85973\";i:85719;s:12:\"delete-85975\";i:85720;s:12:\"delete-85976\";i:85721;s:12:\"delete-85978\";i:85722;s:12:\"delete-85979\";i:85723;s:12:\"delete-85981\";i:85724;s:12:\"delete-85982\";i:85725;s:12:\"delete-85984\";i:85726;s:12:\"delete-85985\";i:85727;s:12:\"delete-85987\";i:85728;s:12:\"delete-85988\";i:85729;s:12:\"delete-85990\";i:85730;s:12:\"delete-85991\";i:85731;s:12:\"delete-85993\";i:85732;s:12:\"delete-85994\";i:85733;s:12:\"delete-85996\";i:85734;s:12:\"delete-85997\";i:85735;s:12:\"delete-85999\";i:85736;s:12:\"delete-86000\";i:85737;s:12:\"delete-86002\";i:85738;s:12:\"delete-86003\";i:85739;s:12:\"delete-86005\";i:85740;s:12:\"delete-86006\";i:85741;s:12:\"delete-86008\";i:85742;s:12:\"delete-86009\";i:85743;s:12:\"delete-86011\";i:85744;s:12:\"delete-86012\";i:85745;s:12:\"delete-86014\";i:85746;s:12:\"delete-86015\";i:85747;s:12:\"delete-86017\";i:85748;s:12:\"delete-86018\";i:85749;s:12:\"delete-86020\";i:85750;s:12:\"delete-86021\";i:85751;s:12:\"delete-86023\";i:85752;s:12:\"delete-86024\";i:85753;s:12:\"delete-86026\";i:85754;s:12:\"delete-86027\";i:85755;s:12:\"delete-86029\";i:85756;s:12:\"delete-86030\";i:85757;s:12:\"delete-86032\";i:85758;s:12:\"delete-86033\";i:85759;s:12:\"delete-86035\";i:85760;s:12:\"delete-86036\";i:85761;s:12:\"delete-86038\";i:85762;s:12:\"delete-86039\";i:85763;s:12:\"delete-86041\";i:85764;s:12:\"delete-86042\";i:85765;s:12:\"delete-86044\";i:85766;s:12:\"delete-86045\";i:85767;s:12:\"delete-86047\";i:85768;s:12:\"delete-86048\";i:85769;s:12:\"delete-86050\";i:85770;s:12:\"delete-86051\";i:85771;s:12:\"delete-86053\";i:85772;s:12:\"delete-86054\";i:85773;s:12:\"delete-86056\";i:85774;s:12:\"delete-86057\";i:85775;s:12:\"delete-86059\";i:85776;s:12:\"delete-86060\";i:85777;s:12:\"delete-86062\";i:85778;s:12:\"delete-86063\";i:85779;s:12:\"delete-86065\";i:85780;s:12:\"delete-86066\";i:85781;s:12:\"delete-86068\";i:85782;s:12:\"delete-86069\";i:85783;s:12:\"delete-86071\";i:85784;s:12:\"delete-86072\";i:85785;s:12:\"delete-86074\";i:85786;s:12:\"delete-86075\";i:85787;s:12:\"delete-86077\";i:85788;s:12:\"delete-86078\";i:85789;s:12:\"delete-86080\";i:85790;s:12:\"delete-86081\";i:85791;s:12:\"delete-86083\";i:85792;s:12:\"delete-86084\";i:85793;s:12:\"delete-86086\";i:85794;s:12:\"delete-86087\";i:85795;s:12:\"delete-86089\";i:85796;s:12:\"delete-86090\";i:85797;s:12:\"delete-86092\";i:85798;s:12:\"delete-86093\";i:85799;s:12:\"delete-86095\";i:85800;s:12:\"delete-86096\";i:85801;s:12:\"delete-86098\";i:85802;s:12:\"delete-86099\";i:85803;s:12:\"delete-86101\";i:85804;s:12:\"delete-86102\";i:85805;s:12:\"delete-86104\";i:85806;s:12:\"delete-86105\";i:85807;s:12:\"delete-86107\";i:85808;s:12:\"delete-86108\";i:85809;s:12:\"delete-86110\";i:85810;s:12:\"delete-86111\";i:85811;s:12:\"delete-86113\";i:85812;s:12:\"delete-86114\";i:85813;s:12:\"delete-86116\";i:85814;s:12:\"delete-86117\";i:85815;s:12:\"delete-86119\";i:85816;s:12:\"delete-86120\";i:85817;s:12:\"delete-86122\";i:85818;s:12:\"delete-86123\";i:85819;s:12:\"delete-86125\";i:85820;s:12:\"delete-86126\";i:85821;s:12:\"delete-86128\";i:85822;s:12:\"delete-86129\";i:85823;s:12:\"delete-86131\";i:85824;s:12:\"delete-86132\";i:85825;s:12:\"delete-86134\";i:85826;s:12:\"delete-86135\";i:85827;s:12:\"delete-86137\";i:85828;s:12:\"delete-86138\";i:85829;s:12:\"delete-86140\";i:85830;s:12:\"delete-86141\";i:85831;s:12:\"delete-86143\";i:85832;s:12:\"delete-86144\";i:85833;s:12:\"delete-86146\";i:85834;s:12:\"delete-86147\";i:85835;s:12:\"delete-86149\";i:85836;s:12:\"delete-86150\";i:85837;s:12:\"delete-86152\";i:85838;s:12:\"delete-86153\";i:85839;s:12:\"delete-86155\";i:85840;s:12:\"delete-86156\";i:85841;s:12:\"delete-86158\";i:85842;s:12:\"delete-86159\";i:85843;s:12:\"delete-86161\";i:85844;s:12:\"delete-86162\";i:85845;s:12:\"delete-86164\";i:85846;s:12:\"delete-86165\";i:85847;s:12:\"delete-86167\";i:85848;s:12:\"delete-86168\";i:85849;s:12:\"delete-86170\";i:85850;s:12:\"delete-86171\";i:85851;s:12:\"delete-86173\";i:85852;s:12:\"delete-86174\";i:85853;s:12:\"delete-86176\";i:85854;s:12:\"delete-86177\";i:85855;s:12:\"delete-86179\";i:85856;s:12:\"delete-86180\";i:85857;s:12:\"delete-86182\";i:85858;s:12:\"delete-86183\";i:85859;s:12:\"delete-86185\";i:85860;s:12:\"delete-86186\";i:85861;s:12:\"delete-86188\";i:85862;s:12:\"delete-86189\";i:85863;s:12:\"delete-86191\";i:85864;s:12:\"delete-86192\";i:85865;s:12:\"delete-86194\";i:85866;s:12:\"delete-86195\";i:85867;s:12:\"delete-86197\";i:85868;s:12:\"delete-86198\";i:85869;s:12:\"delete-86200\";i:85870;s:12:\"delete-86201\";i:85871;s:12:\"delete-86203\";i:85872;s:12:\"delete-86204\";i:85873;s:12:\"delete-86206\";i:85874;s:12:\"delete-86207\";i:85875;s:12:\"delete-86209\";i:85876;s:12:\"delete-86210\";i:85877;s:12:\"delete-86212\";i:85878;s:12:\"delete-86213\";i:85879;s:12:\"delete-86215\";i:85880;s:12:\"delete-86216\";i:85881;s:12:\"delete-86218\";i:85882;s:12:\"delete-86219\";i:85883;s:12:\"delete-86221\";i:85884;s:12:\"delete-86222\";i:85885;s:12:\"delete-86224\";i:85886;s:12:\"delete-86225\";i:85887;s:12:\"delete-86227\";i:85888;s:12:\"delete-86228\";i:85889;s:12:\"delete-86230\";i:85890;s:12:\"delete-86231\";i:85891;s:12:\"delete-86233\";i:85892;s:12:\"delete-86234\";i:85893;s:12:\"delete-86236\";i:85894;s:12:\"delete-86237\";i:85895;s:12:\"delete-86239\";i:85896;s:12:\"delete-86240\";i:85897;s:12:\"delete-86242\";i:85898;s:12:\"delete-86243\";i:85899;s:12:\"delete-86245\";i:85900;s:12:\"delete-86246\";i:85901;s:12:\"delete-86248\";i:85902;s:12:\"delete-86249\";i:85903;s:12:\"delete-86251\";i:85904;s:12:\"delete-86252\";i:85905;s:12:\"delete-86254\";i:85906;s:12:\"delete-86255\";i:85907;s:12:\"delete-86257\";i:85908;s:12:\"delete-86258\";i:85909;s:12:\"delete-86260\";i:85910;s:12:\"delete-86261\";i:85911;s:12:\"delete-86263\";i:85912;s:12:\"delete-86264\";i:85913;s:12:\"delete-86266\";i:85914;s:12:\"delete-86267\";i:85915;s:12:\"delete-86269\";i:85916;s:12:\"delete-86270\";i:85917;s:12:\"delete-86272\";i:85918;s:12:\"delete-86273\";i:85919;s:12:\"delete-86275\";i:85920;s:12:\"delete-86276\";i:85921;s:12:\"delete-86278\";i:85922;s:12:\"delete-86279\";i:85923;s:12:\"delete-86281\";i:85924;s:12:\"delete-86282\";i:85925;s:12:\"delete-86284\";i:85926;s:12:\"delete-86285\";i:85927;s:12:\"delete-86287\";i:85928;s:12:\"delete-86288\";i:85929;s:12:\"delete-86290\";i:85930;s:12:\"delete-86291\";i:85931;s:12:\"delete-86293\";i:85932;s:12:\"delete-86294\";i:85933;s:12:\"delete-86296\";i:85934;s:12:\"delete-86297\";i:85935;s:12:\"delete-86299\";i:85936;s:12:\"delete-86300\";i:85937;s:12:\"delete-86302\";i:85938;s:12:\"delete-86303\";i:85939;s:12:\"delete-86305\";i:85940;s:12:\"delete-86306\";i:85941;s:12:\"delete-86308\";i:85942;s:12:\"delete-86309\";i:85943;s:12:\"delete-86311\";i:85944;s:12:\"delete-86312\";i:85945;s:12:\"delete-86314\";i:85946;s:12:\"delete-86315\";i:85947;s:12:\"delete-86317\";i:85948;s:12:\"delete-86318\";i:85949;s:12:\"delete-86320\";i:85950;s:12:\"delete-86321\";i:85951;s:12:\"delete-86323\";i:85952;s:12:\"delete-86324\";i:85953;s:12:\"delete-86326\";i:85954;s:12:\"delete-86327\";i:85955;s:12:\"delete-86329\";i:85956;s:12:\"delete-86330\";i:85957;s:12:\"delete-86332\";i:85958;s:12:\"delete-86333\";i:85959;s:12:\"delete-86335\";i:85960;s:12:\"delete-86336\";i:85961;s:12:\"delete-86338\";i:85962;s:12:\"delete-86339\";i:85963;s:12:\"delete-86341\";i:85964;s:12:\"delete-86342\";i:85965;s:12:\"delete-86344\";i:85966;s:12:\"delete-86345\";i:85967;s:12:\"delete-86347\";i:85968;s:12:\"delete-86348\";i:85969;s:12:\"delete-86350\";i:85970;s:12:\"delete-86351\";i:85971;s:12:\"delete-86353\";i:85972;s:12:\"delete-86354\";i:85973;s:12:\"delete-86356\";i:85974;s:12:\"delete-86357\";i:85975;s:12:\"delete-86359\";i:85976;s:12:\"delete-86360\";i:85977;s:12:\"delete-86362\";i:85978;s:12:\"delete-86363\";i:85979;s:12:\"delete-86365\";i:85980;s:12:\"delete-86366\";i:85981;s:12:\"delete-86368\";i:85982;s:12:\"delete-86369\";i:85983;s:12:\"delete-86371\";i:85984;s:12:\"delete-86372\";i:85985;s:12:\"delete-86374\";i:85986;s:12:\"delete-86375\";i:85987;s:12:\"delete-86377\";i:85988;s:12:\"delete-86378\";i:85989;s:12:\"delete-86380\";i:85990;s:12:\"delete-86381\";i:85991;s:12:\"delete-86383\";i:85992;s:12:\"delete-86384\";i:85993;s:12:\"delete-86386\";i:85994;s:12:\"delete-86387\";i:85995;s:12:\"delete-86389\";i:85996;s:12:\"delete-86390\";i:85997;s:12:\"delete-86392\";i:85998;s:12:\"delete-86393\";i:85999;s:12:\"delete-86395\";i:86000;s:12:\"delete-86396\";i:86001;s:12:\"delete-86398\";i:86002;s:12:\"delete-86399\";i:86003;s:12:\"delete-86401\";i:86004;s:12:\"delete-86402\";i:86005;s:12:\"delete-86404\";i:86006;s:12:\"delete-86405\";i:86007;s:12:\"delete-86407\";i:86008;s:12:\"delete-86408\";i:86009;s:12:\"delete-86410\";i:86010;s:12:\"delete-86411\";i:86011;s:12:\"delete-86413\";i:86012;s:12:\"delete-86414\";i:86013;s:12:\"delete-86416\";i:86014;s:12:\"delete-86417\";i:86015;s:12:\"delete-86419\";i:86016;s:12:\"delete-86420\";i:86017;s:12:\"delete-86422\";i:86018;s:12:\"delete-86423\";i:86019;s:12:\"delete-86425\";i:86020;s:12:\"delete-86426\";i:86021;s:12:\"delete-86428\";i:86022;s:12:\"delete-86429\";i:86023;s:12:\"delete-86431\";i:86024;s:12:\"delete-86432\";i:86025;s:12:\"delete-86434\";i:86026;s:12:\"delete-86435\";i:86027;s:12:\"delete-86437\";i:86028;s:12:\"delete-86438\";i:86029;s:12:\"delete-86440\";i:86030;s:12:\"delete-86441\";i:86031;s:12:\"delete-86443\";i:86032;s:12:\"delete-86444\";i:86033;s:12:\"delete-86446\";i:86034;s:12:\"delete-86447\";i:86035;s:12:\"delete-86449\";i:86036;s:12:\"delete-86450\";i:86037;s:12:\"delete-86452\";i:86038;s:12:\"delete-86453\";i:86039;s:12:\"delete-86455\";i:86040;s:12:\"delete-86456\";i:86041;s:12:\"delete-86458\";i:86042;s:12:\"delete-86459\";i:86043;s:12:\"delete-86461\";i:86044;s:12:\"delete-86462\";i:86045;s:12:\"delete-86464\";i:86046;s:12:\"delete-86465\";i:86047;s:12:\"delete-86467\";i:86048;s:12:\"delete-86468\";i:86049;s:12:\"delete-86470\";i:86050;s:12:\"delete-86471\";i:86051;s:12:\"delete-86473\";i:86052;s:12:\"delete-86474\";i:86053;s:12:\"delete-86476\";i:86054;s:12:\"delete-86477\";i:86055;s:12:\"delete-86479\";i:86056;s:12:\"delete-86480\";i:86057;s:12:\"delete-86482\";i:86058;s:12:\"delete-86483\";i:86059;s:12:\"delete-86485\";i:86060;s:12:\"delete-86486\";i:86061;s:12:\"delete-86488\";i:86062;s:12:\"delete-86489\";i:86063;s:12:\"delete-86491\";i:86064;s:12:\"delete-86492\";i:86065;s:12:\"delete-86494\";i:86066;s:12:\"delete-86495\";i:86067;s:12:\"delete-86497\";i:86068;s:12:\"delete-86498\";i:86069;s:12:\"delete-86500\";i:86070;s:12:\"delete-86501\";i:86071;s:12:\"delete-86503\";i:86072;s:12:\"delete-86504\";i:86073;s:12:\"delete-86506\";i:86074;s:12:\"delete-86507\";i:86075;s:12:\"delete-86509\";i:86076;s:12:\"delete-86510\";i:86077;s:12:\"delete-86512\";i:86078;s:12:\"delete-86513\";i:86079;s:12:\"delete-86515\";i:86080;s:12:\"delete-86516\";i:86081;s:12:\"delete-86518\";i:86082;s:12:\"delete-86519\";i:86083;s:12:\"delete-86521\";i:86084;s:12:\"delete-86522\";i:86085;s:12:\"delete-86524\";i:86086;s:12:\"delete-86525\";i:86087;s:12:\"delete-86527\";i:86088;s:12:\"delete-86528\";i:86089;s:12:\"delete-86530\";i:86090;s:12:\"delete-86531\";i:86091;s:12:\"delete-86533\";i:86092;s:12:\"delete-86534\";i:86093;s:12:\"delete-86536\";i:86094;s:12:\"delete-86537\";i:86095;s:12:\"delete-86539\";i:86096;s:12:\"delete-86540\";i:86097;s:12:\"delete-86542\";i:86098;s:12:\"delete-86543\";i:86099;s:12:\"delete-86545\";i:86100;s:12:\"delete-86546\";i:86101;s:12:\"delete-86548\";i:86102;s:12:\"delete-86549\";i:86103;s:12:\"delete-86551\";i:86104;s:12:\"delete-86552\";i:86105;s:12:\"delete-86554\";i:86106;s:12:\"delete-86555\";i:86107;s:12:\"delete-86557\";i:86108;s:12:\"delete-86558\";i:86109;s:12:\"delete-86560\";i:86110;s:12:\"delete-86561\";i:86111;s:12:\"delete-86563\";i:86112;s:12:\"delete-86564\";i:86113;s:12:\"delete-86566\";i:86114;s:12:\"delete-86567\";i:86115;s:12:\"delete-86569\";i:86116;s:12:\"delete-86570\";i:86117;s:12:\"delete-86572\";i:86118;s:12:\"delete-86573\";i:86119;s:12:\"delete-86575\";i:86120;s:12:\"delete-86576\";i:86121;s:12:\"delete-86578\";i:86122;s:12:\"delete-86579\";i:86123;s:12:\"delete-86581\";i:86124;s:12:\"delete-86582\";i:86125;s:12:\"delete-86584\";i:86126;s:12:\"delete-86585\";i:86127;s:12:\"delete-86587\";i:86128;s:12:\"delete-86588\";i:86129;s:12:\"delete-86590\";i:86130;s:12:\"delete-86591\";i:86131;s:12:\"delete-86593\";i:86132;s:12:\"delete-86594\";i:86133;s:12:\"delete-86596\";i:86134;s:12:\"delete-86597\";i:86135;s:12:\"delete-86599\";i:86136;s:12:\"delete-86600\";i:86137;s:12:\"delete-86602\";i:86138;s:12:\"delete-86603\";i:86139;s:12:\"delete-86605\";i:86140;s:12:\"delete-86606\";i:86141;s:12:\"delete-86608\";i:86142;s:12:\"delete-86609\";i:86143;s:12:\"delete-86611\";i:86144;s:12:\"delete-86612\";i:86145;s:12:\"delete-86614\";i:86146;s:12:\"delete-86615\";i:86147;s:12:\"delete-86617\";i:86148;s:12:\"delete-86618\";i:86149;s:12:\"delete-86620\";i:86150;s:12:\"delete-86621\";i:86151;s:12:\"delete-86623\";i:86152;s:12:\"delete-86624\";i:86153;s:12:\"delete-86626\";i:86154;s:12:\"delete-86627\";i:86155;s:12:\"delete-86629\";i:86156;s:12:\"delete-86630\";i:86157;s:12:\"delete-86632\";i:86158;s:12:\"delete-86633\";i:86159;s:12:\"delete-86635\";i:86160;s:12:\"delete-86636\";i:86161;s:12:\"delete-86638\";i:86162;s:12:\"delete-86639\";i:86163;s:12:\"delete-86641\";i:86164;s:12:\"delete-86642\";i:86165;s:12:\"delete-86644\";i:86166;s:12:\"delete-86645\";i:86167;s:12:\"delete-86647\";i:86168;s:12:\"delete-86648\";i:86169;s:12:\"delete-86650\";i:86170;s:12:\"delete-86651\";i:86171;s:12:\"delete-86653\";i:86172;s:12:\"delete-86654\";i:86173;s:12:\"delete-86656\";i:86174;s:12:\"delete-86657\";i:86175;s:12:\"delete-86659\";i:86176;s:12:\"delete-86660\";i:86177;s:12:\"delete-86662\";i:86178;s:12:\"delete-86663\";i:86179;s:12:\"delete-86665\";i:86180;s:12:\"delete-86666\";i:86181;s:12:\"delete-86668\";i:86182;s:12:\"delete-86669\";i:86183;s:12:\"delete-86671\";i:86184;s:12:\"delete-86672\";i:86185;s:12:\"delete-86674\";i:86186;s:12:\"delete-86675\";i:86187;s:12:\"delete-86677\";i:86188;s:12:\"delete-86678\";i:86189;s:12:\"delete-86680\";i:86190;s:12:\"delete-86681\";i:86191;s:12:\"delete-86683\";i:86192;s:12:\"delete-86684\";i:86193;s:12:\"delete-86686\";i:86194;s:12:\"delete-86687\";i:86195;s:12:\"delete-86689\";i:86196;s:12:\"delete-86690\";i:86197;s:12:\"delete-86692\";i:86198;s:12:\"delete-86693\";i:86199;s:12:\"delete-86695\";i:86200;s:12:\"delete-86696\";i:86201;s:12:\"delete-86698\";i:86202;s:12:\"delete-86699\";i:86203;s:12:\"delete-86701\";i:86204;s:12:\"delete-86702\";i:86205;s:12:\"delete-86704\";i:86206;s:12:\"delete-86705\";i:86207;s:12:\"delete-86707\";i:86208;s:12:\"delete-86708\";i:86209;s:12:\"delete-86710\";i:86210;s:12:\"delete-86711\";i:86211;s:12:\"delete-86713\";i:86212;s:12:\"delete-86714\";i:86213;s:12:\"delete-86716\";i:86214;s:12:\"delete-86717\";i:86215;s:12:\"delete-86719\";i:86216;s:12:\"delete-86720\";i:86217;s:12:\"delete-86722\";i:86218;s:12:\"delete-86723\";i:86219;s:12:\"delete-86725\";i:86220;s:12:\"delete-86726\";i:86221;s:12:\"delete-86728\";i:86222;s:12:\"delete-86729\";i:86223;s:12:\"delete-86731\";i:86224;s:12:\"delete-86732\";i:86225;s:12:\"delete-86734\";i:86226;s:12:\"delete-86735\";i:86227;s:12:\"delete-86737\";i:86228;s:12:\"delete-86738\";i:86229;s:12:\"delete-86740\";i:86230;s:12:\"delete-86741\";i:86231;s:12:\"delete-86743\";i:86232;s:12:\"delete-86744\";i:86233;s:12:\"delete-86746\";i:86234;s:12:\"delete-86747\";i:86235;s:12:\"delete-86749\";i:86236;s:12:\"delete-86750\";i:86237;s:12:\"delete-86752\";i:86238;s:12:\"delete-86753\";i:86239;s:12:\"delete-86755\";i:86240;s:12:\"delete-86756\";i:86241;s:12:\"delete-86758\";i:86242;s:12:\"delete-86759\";i:86243;s:12:\"delete-86761\";i:86244;s:12:\"delete-86762\";i:86245;s:12:\"delete-86764\";i:86246;s:12:\"delete-86765\";i:86247;s:12:\"delete-86767\";i:86248;s:12:\"delete-86768\";i:86249;s:12:\"delete-86770\";i:86250;s:12:\"delete-86771\";i:86251;s:12:\"delete-86773\";i:86252;s:12:\"delete-86774\";i:86253;s:12:\"delete-86776\";i:86254;s:12:\"delete-86777\";i:86255;s:12:\"delete-86779\";i:86256;s:12:\"delete-86780\";i:86257;s:12:\"delete-86782\";i:86258;s:12:\"delete-86783\";i:86259;s:12:\"delete-86785\";i:86260;s:12:\"delete-86786\";i:86261;s:12:\"delete-86788\";i:86262;s:12:\"delete-86789\";i:86263;s:12:\"delete-86791\";i:86264;s:12:\"delete-86792\";i:86265;s:12:\"delete-86794\";i:86266;s:12:\"delete-86795\";i:86267;s:12:\"delete-86797\";i:86268;s:12:\"delete-86798\";i:86269;s:12:\"delete-86800\";i:86270;s:12:\"delete-86801\";i:86271;s:12:\"delete-86803\";i:86272;s:12:\"delete-86804\";i:86273;s:12:\"delete-86806\";i:86274;s:12:\"delete-86807\";i:86275;s:12:\"delete-86809\";i:86276;s:12:\"delete-86810\";i:86277;s:12:\"delete-86812\";i:86278;s:12:\"delete-86813\";i:86279;s:12:\"delete-86815\";i:86280;s:12:\"delete-86816\";i:86281;s:12:\"delete-86818\";i:86282;s:12:\"delete-86819\";i:86283;s:12:\"delete-86821\";i:86284;s:12:\"delete-86822\";i:86285;s:12:\"delete-86824\";i:86286;s:12:\"delete-86825\";i:86287;s:12:\"delete-86827\";i:86288;s:12:\"delete-86828\";i:86289;s:12:\"delete-86830\";i:86290;s:12:\"delete-86831\";i:86291;s:12:\"delete-86833\";i:86292;s:12:\"delete-86834\";i:86293;s:12:\"delete-86836\";i:86294;s:12:\"delete-86837\";i:86295;s:12:\"delete-86839\";i:86296;s:12:\"delete-86840\";i:86297;s:12:\"delete-86842\";i:86298;s:12:\"delete-86843\";i:86299;s:12:\"delete-86845\";i:86300;s:12:\"delete-86846\";i:86301;s:12:\"delete-86848\";i:86302;s:12:\"delete-86849\";i:86303;s:12:\"delete-86851\";i:86304;s:12:\"delete-86852\";i:86305;s:12:\"delete-86854\";i:86306;s:12:\"delete-86855\";i:86307;s:12:\"delete-86857\";i:86308;s:12:\"delete-86858\";i:86309;s:12:\"delete-86860\";i:86310;s:12:\"delete-86861\";i:86311;s:12:\"delete-86863\";i:86312;s:12:\"delete-86864\";i:86313;s:12:\"delete-86866\";i:86314;s:12:\"delete-86867\";i:86315;s:12:\"delete-86869\";i:86316;s:12:\"delete-86870\";i:86317;s:12:\"delete-86872\";i:86318;s:12:\"delete-86873\";i:86319;s:12:\"delete-86875\";i:86320;s:12:\"delete-86876\";i:86321;s:12:\"delete-86878\";i:86322;s:12:\"delete-86879\";i:86323;s:12:\"delete-86881\";i:86324;s:12:\"delete-86882\";i:86325;s:12:\"delete-86884\";i:86326;s:12:\"delete-86885\";i:86327;s:12:\"delete-86887\";i:86328;s:12:\"delete-86888\";i:86329;s:12:\"delete-86890\";i:86330;s:12:\"delete-86891\";i:86331;s:12:\"delete-86893\";i:86332;s:12:\"delete-86894\";i:86333;s:12:\"delete-86896\";i:86334;s:12:\"delete-86897\";i:86335;s:12:\"delete-86899\";i:86336;s:12:\"delete-86900\";i:86337;s:12:\"delete-86902\";i:86338;s:12:\"delete-86903\";i:86339;s:12:\"delete-86905\";i:86340;s:12:\"delete-86906\";i:86341;s:12:\"delete-86908\";i:86342;s:12:\"delete-86909\";i:86343;s:12:\"delete-86911\";i:86344;s:12:\"delete-86912\";i:86345;s:12:\"delete-86914\";i:86346;s:12:\"delete-86915\";i:86347;s:12:\"delete-86917\";i:86348;s:12:\"delete-86918\";i:86349;s:12:\"delete-86920\";i:86350;s:12:\"delete-86921\";i:86351;s:12:\"delete-86923\";i:86352;s:12:\"delete-86924\";i:86353;s:12:\"delete-86926\";i:86354;s:12:\"delete-86927\";i:86355;s:12:\"delete-86929\";i:86356;s:12:\"delete-86930\";i:86357;s:12:\"delete-86932\";i:86358;s:12:\"delete-86933\";i:86359;s:12:\"delete-86935\";i:86360;s:12:\"delete-86936\";i:86361;s:12:\"delete-86938\";i:86362;s:12:\"delete-86939\";i:86363;s:12:\"delete-86941\";i:86364;s:12:\"delete-86942\";i:86365;s:12:\"delete-86944\";i:86366;s:12:\"delete-86945\";i:86367;s:12:\"delete-86947\";i:86368;s:12:\"delete-86948\";i:86369;s:12:\"delete-86950\";i:86370;s:12:\"delete-86951\";i:86371;s:12:\"delete-86953\";i:86372;s:12:\"delete-86954\";i:86373;s:12:\"delete-86956\";i:86374;s:12:\"delete-86957\";i:86375;s:12:\"delete-86959\";i:86376;s:12:\"delete-86960\";i:86377;s:12:\"delete-86962\";i:86378;s:12:\"delete-86963\";i:86379;s:12:\"delete-86965\";i:86380;s:12:\"delete-86966\";i:86381;s:12:\"delete-86968\";i:86382;s:12:\"delete-86969\";i:86383;s:12:\"delete-86971\";i:86384;s:12:\"delete-86972\";i:86385;s:12:\"delete-86974\";i:86386;s:12:\"delete-86975\";i:86387;s:12:\"delete-86977\";i:86388;s:12:\"delete-86978\";i:86389;s:12:\"delete-86980\";i:86390;s:12:\"delete-86981\";i:86391;s:12:\"delete-86983\";i:86392;s:12:\"delete-86984\";i:86393;s:12:\"delete-86986\";i:86394;s:12:\"delete-86987\";i:86395;s:12:\"delete-86989\";i:86396;s:12:\"delete-86990\";i:86397;s:12:\"delete-86992\";i:86398;s:12:\"delete-86993\";i:86399;s:12:\"delete-86995\";i:86400;s:12:\"delete-86996\";i:86401;s:12:\"delete-86998\";i:86402;s:12:\"delete-86999\";i:86403;s:12:\"delete-87001\";i:86404;s:12:\"delete-87002\";i:86405;s:12:\"delete-87004\";i:86406;s:12:\"delete-87005\";i:86407;s:12:\"delete-87007\";i:86408;s:12:\"delete-87008\";i:86409;s:12:\"delete-87010\";i:86410;s:12:\"delete-87011\";i:86411;s:12:\"delete-87013\";i:86412;s:12:\"delete-87014\";i:86413;s:12:\"delete-87016\";i:86414;s:12:\"delete-87017\";i:86415;s:12:\"delete-87019\";i:86416;s:12:\"delete-87020\";i:86417;s:12:\"delete-87022\";i:86418;s:12:\"delete-87023\";i:86419;s:12:\"delete-87025\";i:86420;s:12:\"delete-87026\";i:86421;s:12:\"delete-87028\";i:86422;s:12:\"delete-87029\";i:86423;s:12:\"delete-87031\";i:86424;s:12:\"delete-87032\";i:86425;s:12:\"delete-87034\";i:86426;s:12:\"delete-87035\";i:86427;s:12:\"delete-87037\";i:86428;s:12:\"delete-87038\";i:86429;s:12:\"delete-87040\";i:86430;s:12:\"delete-87041\";i:86431;s:12:\"delete-87043\";i:86432;s:12:\"delete-87044\";i:86433;s:12:\"delete-87046\";i:86434;s:12:\"delete-87047\";i:86435;s:12:\"delete-87049\";i:86436;s:12:\"delete-87050\";i:86437;s:12:\"delete-87052\";i:86438;s:12:\"delete-87053\";i:86439;s:12:\"delete-87055\";i:86440;s:12:\"delete-87056\";i:86441;s:12:\"delete-87058\";i:86442;s:12:\"delete-87059\";i:86443;s:12:\"delete-87061\";i:86444;s:12:\"delete-87062\";i:86445;s:12:\"delete-87064\";i:86446;s:12:\"delete-87065\";i:86447;s:12:\"delete-87067\";i:86448;s:12:\"delete-87068\";i:86449;s:12:\"delete-87070\";i:86450;s:12:\"delete-87071\";i:86451;s:12:\"delete-87073\";i:86452;s:12:\"delete-87074\";i:86453;s:12:\"delete-87076\";i:86454;s:12:\"delete-87077\";i:86455;s:12:\"delete-87079\";i:86456;s:12:\"delete-87080\";i:86457;s:12:\"delete-87082\";i:86458;s:12:\"delete-87083\";i:86459;s:12:\"delete-87085\";i:86460;s:12:\"delete-87086\";i:86461;s:12:\"delete-87088\";i:86462;s:12:\"delete-87089\";i:86463;s:12:\"delete-87091\";i:86464;s:12:\"delete-87092\";i:86465;s:12:\"delete-87094\";i:86466;s:12:\"delete-87095\";i:86467;s:12:\"delete-87097\";i:86468;s:12:\"delete-87098\";i:86469;s:12:\"delete-87100\";i:86470;s:12:\"delete-87101\";i:86471;s:12:\"delete-87103\";i:86472;s:12:\"delete-87104\";i:86473;s:12:\"delete-87106\";i:86474;s:12:\"delete-87107\";i:86475;s:12:\"delete-87109\";i:86476;s:12:\"delete-87110\";i:86477;s:12:\"delete-87112\";i:86478;s:12:\"delete-87113\";i:86479;s:12:\"delete-87115\";i:86480;s:12:\"delete-87116\";i:86481;s:12:\"delete-87118\";i:86482;s:12:\"delete-87119\";i:86483;s:12:\"delete-87121\";i:86484;s:12:\"delete-87122\";i:86485;s:12:\"delete-87124\";i:86486;s:12:\"delete-87125\";i:86487;s:12:\"delete-87127\";i:86488;s:12:\"delete-87128\";i:86489;s:12:\"delete-87130\";i:86490;s:12:\"delete-87131\";i:86491;s:12:\"delete-87133\";i:86492;s:12:\"delete-87134\";i:86493;s:12:\"delete-87136\";i:86494;s:12:\"delete-87137\";i:86495;s:12:\"delete-87139\";i:86496;s:12:\"delete-87140\";i:86497;s:12:\"delete-87142\";i:86498;s:12:\"delete-87143\";i:86499;s:12:\"delete-87145\";i:86500;s:12:\"delete-87146\";i:86501;s:12:\"delete-87148\";i:86502;s:12:\"delete-87149\";i:86503;s:12:\"delete-87151\";i:86504;s:12:\"delete-87152\";i:86505;s:12:\"delete-87154\";i:86506;s:12:\"delete-87155\";i:86507;s:12:\"delete-87157\";i:86508;s:12:\"delete-87160\";i:86509;s:12:\"delete-87158\";i:86510;s:12:\"delete-87161\";i:86511;s:12:\"delete-87163\";i:86512;s:12:\"delete-87164\";i:86513;s:12:\"delete-87166\";i:86514;s:12:\"delete-87167\";i:86515;s:12:\"delete-87169\";i:86516;s:12:\"delete-87170\";i:86517;s:12:\"delete-87172\";i:86518;s:12:\"delete-87173\";i:86519;s:12:\"delete-87175\";i:86520;s:12:\"delete-87176\";i:86521;s:12:\"delete-87178\";i:86522;s:12:\"delete-87179\";i:86523;s:12:\"delete-87181\";i:86524;s:12:\"delete-87182\";i:86525;s:12:\"delete-87184\";i:86526;s:12:\"delete-87185\";i:86527;s:12:\"delete-87187\";i:86528;s:12:\"delete-87188\";i:86529;s:12:\"delete-87190\";i:86530;s:12:\"delete-87191\";i:86531;s:12:\"delete-87193\";i:86532;s:12:\"delete-87194\";i:86533;s:12:\"delete-87196\";i:86534;s:12:\"delete-87197\";i:86535;s:12:\"delete-87199\";i:86536;s:12:\"delete-87200\";i:86537;s:12:\"delete-87202\";i:86538;s:12:\"delete-87203\";i:86539;s:12:\"delete-87205\";i:86540;s:12:\"delete-87206\";i:86541;s:12:\"delete-87208\";i:86542;s:12:\"delete-87209\";i:86543;s:12:\"delete-87211\";i:86544;s:12:\"delete-87212\";i:86545;s:12:\"delete-87214\";i:86546;s:12:\"delete-87215\";i:86547;s:12:\"delete-87217\";i:86548;s:12:\"delete-87218\";i:86549;s:12:\"delete-87220\";i:86550;s:12:\"delete-87221\";i:86551;s:12:\"delete-87223\";i:86552;s:12:\"delete-87224\";i:86553;s:12:\"delete-87226\";i:86554;s:12:\"delete-87227\";i:86555;s:12:\"delete-87229\";i:86556;s:12:\"delete-87230\";i:86557;s:12:\"delete-87232\";i:86558;s:12:\"delete-87233\";i:86559;s:12:\"delete-87235\";i:86560;s:12:\"delete-87236\";i:86561;s:12:\"delete-87238\";i:86562;s:12:\"delete-87239\";i:86563;s:12:\"delete-87241\";i:86564;s:12:\"delete-87242\";i:86565;s:12:\"delete-87244\";i:86566;s:12:\"delete-87245\";i:86567;s:12:\"delete-87247\";i:86568;s:12:\"delete-87248\";i:86569;s:12:\"delete-87250\";i:86570;s:12:\"delete-87251\";i:86571;s:12:\"delete-87253\";i:86572;s:12:\"delete-87254\";i:86573;s:12:\"delete-87256\";i:86574;s:12:\"delete-87257\";i:86575;s:12:\"delete-87259\";i:86576;s:12:\"delete-87260\";i:86577;s:12:\"delete-87262\";i:86578;s:12:\"delete-87263\";i:86579;s:12:\"delete-87265\";i:86580;s:12:\"delete-87266\";i:86581;s:12:\"delete-87268\";i:86582;s:12:\"delete-87269\";i:86583;s:12:\"delete-87271\";i:86584;s:12:\"delete-87272\";i:86585;s:12:\"delete-87274\";i:86586;s:12:\"delete-87275\";i:86587;s:12:\"delete-87277\";i:86588;s:12:\"delete-87278\";i:86589;s:12:\"delete-87280\";i:86590;s:12:\"delete-87281\";i:86591;s:12:\"delete-87283\";i:86592;s:12:\"delete-87284\";i:86593;s:12:\"delete-87286\";i:86594;s:12:\"delete-87287\";i:86595;s:12:\"delete-87289\";i:86596;s:12:\"delete-87290\";i:86597;s:12:\"delete-87292\";i:86598;s:12:\"delete-87293\";i:86599;s:12:\"delete-87295\";i:86600;s:12:\"delete-87298\";i:86601;s:12:\"delete-87296\";i:86602;s:12:\"delete-87299\";i:86603;s:12:\"delete-87301\";i:86604;s:12:\"delete-87302\";i:86605;s:12:\"delete-87304\";i:86606;s:12:\"delete-87305\";i:86607;s:12:\"delete-87307\";i:86608;s:12:\"delete-87308\";i:86609;s:12:\"delete-87310\";i:86610;s:12:\"delete-87311\";i:86611;s:12:\"delete-87313\";i:86612;s:12:\"delete-87314\";i:86613;s:12:\"delete-87316\";i:86614;s:12:\"delete-87317\";i:86615;s:12:\"delete-87319\";i:86616;s:12:\"delete-87320\";i:86617;s:12:\"delete-87322\";i:86618;s:12:\"delete-87323\";i:86619;s:12:\"delete-87325\";i:86620;s:12:\"delete-87326\";i:86621;s:12:\"delete-87328\";i:86622;s:12:\"delete-87329\";i:86623;s:12:\"delete-87331\";i:86624;s:12:\"delete-87332\";i:86625;s:12:\"delete-87334\";i:86626;s:12:\"delete-87335\";i:86627;s:12:\"delete-87337\";i:86628;s:12:\"delete-87338\";i:86629;s:12:\"delete-87340\";i:86630;s:12:\"delete-87341\";i:86631;s:12:\"delete-87343\";i:86632;s:12:\"delete-87344\";i:86633;s:12:\"delete-87346\";i:86634;s:12:\"delete-87349\";i:86635;s:12:\"delete-87347\";i:86636;s:12:\"delete-87350\";i:86637;s:12:\"delete-87352\";i:86638;s:12:\"delete-87353\";i:86639;s:12:\"delete-87355\";i:86640;s:12:\"delete-87356\";i:86641;s:12:\"delete-87358\";i:86642;s:12:\"delete-87359\";i:86643;s:12:\"delete-87361\";i:86644;s:12:\"delete-87362\";i:86645;s:12:\"delete-87364\";i:86646;s:12:\"delete-87365\";i:86647;s:12:\"delete-87367\";i:86648;s:12:\"delete-87368\";i:86649;s:12:\"delete-87370\";i:86650;s:12:\"delete-87373\";i:86651;s:12:\"delete-87371\";i:86652;s:12:\"delete-87374\";i:86653;s:12:\"delete-87376\";i:86654;s:12:\"delete-87377\";i:86655;s:12:\"delete-87379\";i:86656;s:12:\"delete-87380\";i:86657;s:12:\"delete-87382\";i:86658;s:12:\"delete-87383\";i:86659;s:12:\"delete-87385\";i:86660;s:12:\"delete-87386\";i:86661;s:12:\"delete-87388\";i:86662;s:12:\"delete-87389\";i:86663;s:12:\"delete-87391\";i:86664;s:12:\"delete-87392\";i:86665;s:12:\"delete-87394\";i:86666;s:12:\"delete-87395\";i:86667;s:12:\"delete-87397\";i:86668;s:12:\"delete-87398\";i:86669;s:12:\"delete-87400\";i:86670;s:12:\"delete-87401\";i:86671;s:12:\"delete-87403\";i:86672;s:12:\"delete-87404\";i:86673;s:12:\"delete-87406\";i:86674;s:12:\"delete-87407\";i:86675;s:12:\"delete-87409\";i:86676;s:12:\"delete-87410\";i:86677;s:12:\"delete-87412\";i:86678;s:12:\"delete-87413\";i:86679;s:12:\"delete-87415\";i:86680;s:12:\"delete-87416\";i:86681;s:12:\"delete-87418\";i:86682;s:12:\"delete-87419\";i:86683;s:12:\"delete-87421\";i:86684;s:12:\"delete-87422\";i:86685;s:12:\"delete-87424\";i:86686;s:12:\"delete-87425\";i:86687;s:12:\"delete-87427\";i:86688;s:12:\"delete-87428\";i:86689;s:12:\"delete-87430\";i:86690;s:12:\"delete-87431\";i:86691;s:12:\"delete-87433\";i:86692;s:12:\"delete-87434\";i:86693;s:12:\"delete-87436\";i:86694;s:12:\"delete-87437\";i:86695;s:12:\"delete-87439\";i:86696;s:12:\"delete-87440\";i:86697;s:12:\"delete-87442\";i:86698;s:12:\"delete-87443\";i:86699;s:12:\"delete-87445\";i:86700;s:12:\"delete-87446\";i:86701;s:12:\"delete-87448\";i:86702;s:12:\"delete-87451\";i:86703;s:12:\"delete-87449\";i:86704;s:12:\"delete-87452\";i:86705;s:12:\"delete-87454\";i:86706;s:12:\"delete-87455\";i:86707;s:12:\"delete-87457\";i:86708;s:12:\"delete-87458\";i:86709;s:12:\"delete-87460\";i:86710;s:12:\"delete-87461\";i:86711;s:12:\"delete-87463\";i:86712;s:12:\"delete-87464\";i:86713;s:12:\"delete-87466\";i:86714;s:12:\"delete-87467\";i:86715;s:12:\"delete-87469\";i:86716;s:12:\"delete-87470\";i:86717;s:12:\"delete-87472\";i:86718;s:12:\"delete-87473\";i:86719;s:12:\"delete-87475\";i:86720;s:12:\"delete-87476\";i:86721;s:12:\"delete-87478\";i:86722;s:12:\"delete-87479\";i:86723;s:12:\"delete-87481\";i:86724;s:12:\"delete-87482\";i:86725;s:12:\"delete-87484\";i:86726;s:12:\"delete-87485\";i:86727;s:12:\"delete-87487\";i:86728;s:12:\"delete-87488\";i:86729;s:12:\"delete-87490\";i:86730;s:12:\"delete-87491\";i:86731;s:12:\"delete-87493\";i:86732;s:12:\"delete-87494\";i:86733;s:12:\"delete-87496\";i:86734;s:12:\"delete-87497\";i:86735;s:12:\"delete-24143\";i:86736;s:12:\"delete-24146\";i:86737;s:12:\"delete-24147\";i:86738;s:12:\"delete-87499\";i:86739;s:12:\"delete-25746\";i:86740;s:12:\"delete-25749\";i:86741;s:12:\"delete-25750\";i:86742;s:12:\"delete-25751\";i:86743;s:12:\"delete-81487\";i:86744;s:12:\"delete-81488\";i:86745;s:12:\"delete-81489\";i:86746;s:12:\"delete-24137\";i:86747;s:12:\"delete-81490\";i:86748;s:12:\"delete-25753\";i:86749;s:12:\"delete-25741\";i:86750;s:12:\"delete-24142\";i:86751;s:12:\"delete-27945\";i:86752;s:12:\"delete-27944\";i:86753;s:12:\"delete-27941\";i:86754;s:12:\"delete-27942\";i:86755;s:12:\"delete-27943\";i:86756;s:12:\"delete-24145\";i:86757;s:12:\"delete-24144\";i:86758;s:12:\"delete-27929\";i:86759;s:12:\"delete-24135\";i:86760;s:12:\"delete-25774\";i:86761;s:12:\"delete-25773\";i:86762;s:12:\"delete-27936\";i:86763;s:12:\"delete-27937\";i:86764;s:12:\"delete-27933\";i:86765;s:12:\"delete-27934\";i:86766;s:12:\"delete-25776\";i:86767;s:12:\"delete-25775\";i:86768;s:12:\"delete-27928\";i:86769;s:12:\"delete-24136\";i:86770;s:12:\"delete-25793\";i:86771;s:12:\"delete-25742\";i:86772;s:12:\"delete-26609\";i:86773;s:12:\"delete-25787\";i:86774;s:12:\"delete-25786\";i:86775;s:12:\"delete-25785\";i:86776;s:12:\"delete-25784\";i:86777;s:12:\"delete-25782\";i:86778;s:12:\"delete-25783\";i:86779;s:12:\"delete-25788\";i:86780;s:12:\"delete-25789\";i:86781;s:12:\"delete-25790\";i:86782;s:12:\"delete-25743\";i:86783;s:12:\"delete-25769\";i:86784;s:12:\"delete-25744\";i:86785;s:12:\"delete-25745\";i:86786;s:12:\"delete-25792\";i:86787;s:12:\"delete-25791\";i:86788;s:12:\"delete-25747\";i:86789;s:12:\"delete-25781\";i:86790;s:12:\"delete-25780\";i:86791;s:12:\"delete-25764\";i:86792;s:12:\"delete-25763\";i:86793;s:12:\"delete-25762\";i:86794;s:12:\"delete-25761\";i:86795;s:12:\"delete-25760\";i:86796;s:12:\"delete-25759\";i:86797;s:12:\"delete-25758\";i:86798;s:12:\"delete-25757\";i:86799;s:12:\"delete-25756\";i:86800;s:12:\"delete-25755\";i:86801;s:12:\"delete-25765\";i:86802;s:12:\"delete-25766\";i:86803;s:12:\"delete-25767\";i:86804;s:12:\"delete-25779\";i:86805;s:12:\"delete-25778\";i:86806;s:12:\"delete-25777\";i:86807;s:12:\"delete-25748\";i:86808;s:12:\"delete-25752\";i:86809;s:12:\"delete-25772\";i:86810;s:12:\"delete-25771\";i:86811;s:12:\"delete-25770\";i:86812;s:12:\"delete-25754\";i:86813;s:12:\"delete-25768\";i:86814;s:12:\"delete-24138\";i:86815;s:12:\"delete-24139\";i:86816;s:12:\"delete-24140\";i:86817;s:12:\"delete-24141\";i:86818;s:12:\"delete-24149\";i:86819;s:12:\"delete-24148\";i:86820;s:12:\"delete-87501\";i:86821;s:12:\"delete-87584\";i:86822;s:12:\"delete-87586\";i:86823;s:12:\"delete-87587\";i:86824;s:12:\"delete-87588\";i:86825;s:12:\"delete-87590\";i:86826;s:12:\"delete-87591\";i:86827;s:12:\"delete-87592\";i:86828;s:12:\"delete-87594\";i:86829;s:12:\"delete-87595\";i:86830;s:12:\"delete-87596\";i:86831;s:12:\"delete-87598\";i:86832;s:12:\"delete-87599\";i:86833;s:12:\"delete-87585\";i:86834;s:12:\"delete-87589\";i:86835;s:12:\"delete-87593\";i:86836;s:12:\"delete-87597\";i:86837;s:12:\"delete-87676\";i:86838;s:12:\"delete-87677\";i:86839;s:12:\"delete-87681\";i:86840;s:12:\"delete-87680\";i:86841;s:12:\"delete-87679\";i:86842;s:12:\"delete-87678\";i:86843;s:12:\"delete-87675\";i:86844;s:12:\"delete-87674\";i:86845;s:12:\"delete-87673\";i:86846;s:12:\"delete-87672\";i:86847;s:12:\"delete-87619\";i:86848;s:12:\"delete-87511\";i:86849;s:12:\"delete-87615\";i:86850;s:12:\"delete-87616\";i:86851;s:12:\"delete-87617\";i:86852;s:12:\"delete-87618\";i:86853;s:12:\"delete-87611\";i:86854;s:12:\"delete-87612\";i:86855;s:12:\"delete-87613\";i:86856;s:12:\"delete-87614\";i:86857;s:12:\"delete-87607\";i:86858;s:12:\"delete-87608\";i:86859;s:12:\"delete-87609\";i:86860;s:12:\"delete-87610\";i:86861;s:12:\"delete-87604\";i:86862;s:12:\"delete-87605\";i:86863;s:12:\"delete-87606\";i:86864;s:12:\"delete-87600\";i:86865;s:12:\"delete-87601\";i:86866;s:12:\"delete-87602\";i:86867;s:12:\"delete-87603\";i:86868;s:12:\"delete-87620\";i:86869;s:12:\"delete-87621\";i:86870;s:12:\"delete-87622\";i:86871;s:12:\"delete-87623\";i:86872;s:12:\"delete-87624\";i:86873;s:12:\"delete-87625\";i:86874;s:12:\"delete-87626\";i:86875;s:12:\"delete-87627\";i:86876;s:12:\"delete-87628\";i:86877;s:12:\"delete-87629\";i:86878;s:12:\"delete-87630\";i:86879;s:12:\"delete-87631\";i:86880;s:12:\"delete-87632\";i:86881;s:12:\"delete-87633\";i:86882;s:12:\"delete-87634\";i:86883;s:12:\"delete-87635\";i:86884;s:12:\"delete-87686\";i:86885;s:12:\"delete-87687\";i:86886;s:12:\"delete-87688\";i:86887;s:12:\"delete-87689\";i:86888;s:12:\"delete-87690\";i:86889;s:12:\"delete-87692\";i:86890;s:12:\"delete-87693\";i:86891;s:12:\"delete-87691\";i:86892;s:12:\"delete-87694\";i:86893;s:12:\"delete-87696\";i:86894;s:12:\"delete-87697\";i:86895;s:12:\"delete-87699\";i:86896;s:12:\"delete-87701\";i:86897;s:12:\"delete-87702\";i:86898;s:12:\"delete-87695\";i:86899;s:12:\"delete-87700\";i:86900;s:12:\"delete-87704\";i:86901;s:12:\"delete-87706\";i:86902;s:12:\"delete-87707\";i:86903;s:12:\"delete-87705\";i:86904;s:12:\"delete-87708\";i:86905;s:12:\"delete-87710\";i:86906;s:12:\"delete-87711\";i:86907;s:12:\"delete-87709\";i:86908;s:12:\"delete-87712\";i:86909;s:12:\"delete-87714\";i:86910;s:12:\"delete-87715\";i:86911;s:12:\"delete-87713\";i:86912;s:12:\"delete-87716\";i:86913;s:12:\"delete-87718\";i:86914;s:12:\"delete-87719\";i:86915;s:12:\"delete-87717\";i:86916;s:12:\"delete-87720\";i:86917;s:12:\"delete-87724\";i:86918;s:12:\"delete-87722\";i:86919;s:12:\"delete-87725\";i:86920;s:12:\"delete-87721\";i:86921;s:12:\"delete-87723\";i:86922;s:12:\"delete-87726\";i:86923;s:12:\"delete-87728\";i:86924;s:12:\"delete-87729\";i:86925;s:12:\"delete-87730\";i:86926;s:12:\"delete-87731\";i:86927;s:12:\"delete-87733\";i:86928;s:12:\"delete-87734\";i:86929;s:12:\"delete-87735\";i:86930;s:12:\"delete-87737\";i:86931;s:12:\"delete-87738\";i:86932;s:12:\"delete-87740\";i:86933;s:12:\"delete-87742\";i:86934;s:12:\"delete-87744\";i:86935;s:12:\"delete-87745\";i:86936;s:12:\"delete-87746\";i:86937;s:12:\"delete-87748\";i:86938;s:12:\"delete-87749\";i:86939;s:12:\"delete-87750\";i:86940;s:12:\"delete-87727\";i:86941;s:12:\"delete-87732\";i:86942;s:12:\"delete-87736\";i:86943;s:12:\"delete-87739\";i:86944;s:12:\"delete-87741\";i:86945;s:12:\"delete-87743\";i:86946;s:12:\"delete-87747\";i:86947;s:12:\"delete-87751\";i:86948;s:12:\"delete-87752\";i:86949;s:12:\"delete-87754\";i:86950;s:12:\"delete-87755\";i:86951;s:12:\"delete-87756\";i:86952;s:12:\"delete-87758\";i:86953;s:12:\"delete-87759\";i:86954;s:12:\"delete-87761\";i:86955;s:12:\"delete-87763\";i:86956;s:12:\"delete-87764\";i:86957;s:12:\"delete-87765\";i:86958;s:12:\"delete-87767\";i:86959;s:12:\"delete-87768\";i:86960;s:12:\"delete-87753\";i:86961;s:12:\"delete-87757\";i:86962;s:12:\"delete-87762\";i:86963;s:12:\"delete-87766\";i:86964;s:12:\"delete-87769\";i:86965;s:12:\"delete-87771\";i:86966;s:12:\"delete-87772\";i:86967;s:12:\"delete-87773\";i:86968;s:12:\"delete-87775\";i:86969;s:12:\"delete-87776\";i:86970;s:12:\"delete-87770\";i:86971;s:12:\"delete-87774\";i:86972;s:12:\"delete-87779\";i:86973;s:12:\"delete-87781\";i:86974;s:12:\"delete-87782\";i:86975;s:12:\"delete-87783\";i:86976;s:12:\"delete-87780\";i:86977;s:12:\"delete-87784\";i:86978;s:12:\"delete-87785\";i:86979;s:12:\"delete-87787\";i:86980;s:12:\"delete-87789\";i:86981;s:12:\"delete-87790\";i:86982;s:12:\"delete-87791\";i:86983;s:12:\"delete-87793\";i:86984;s:12:\"delete-87795\";i:86985;s:12:\"delete-87796\";i:86986;s:12:\"delete-87797\";i:86987;s:12:\"delete-87798\";i:86988;s:12:\"delete-87799\";i:86989;s:12:\"delete-87800\";i:86990;s:12:\"delete-87801\";i:86991;s:12:\"delete-87803\";i:86992;s:12:\"delete-87804\";i:86993;s:12:\"delete-87806\";i:86994;s:12:\"delete-87808\";i:86995;s:12:\"delete-87786\";i:86996;s:12:\"delete-87788\";i:86997;s:12:\"delete-87792\";i:86998;s:12:\"delete-87794\";i:86999;s:12:\"delete-87802\";i:87000;s:12:\"delete-87805\";i:87001;s:12:\"delete-87807\";i:87002;s:12:\"delete-87809\";i:87003;s:12:\"delete-87811\";i:87004;s:12:\"delete-87812\";i:87005;s:12:\"delete-87813\";i:87006;s:12:\"delete-87815\";i:87007;s:12:\"delete-87816\";i:87008;s:12:\"delete-87817\";i:87009;s:12:\"delete-87819\";i:87010;s:12:\"delete-87821\";i:87011;s:12:\"delete-87823\";i:87012;s:12:\"delete-87824\";i:87013;s:12:\"delete-87826\";i:87014;s:12:\"delete-87827\";i:87015;s:12:\"delete-87828\";i:87016;s:12:\"delete-87830\";i:87017;s:12:\"delete-87832\";i:87018;s:12:\"delete-87833\";i:87019;s:12:\"delete-87810\";i:87020;s:12:\"delete-87814\";i:87021;s:12:\"delete-87818\";i:87022;s:12:\"delete-87820\";i:87023;s:12:\"delete-87822\";i:87024;s:12:\"delete-87825\";i:87025;s:12:\"delete-87829\";i:87026;s:12:\"delete-87831\";i:87027;s:12:\"delete-87834\";i:87028;s:12:\"delete-87835\";i:87029;s:12:\"delete-87837\";i:87030;s:12:\"delete-87838\";i:87031;s:12:\"delete-87839\";i:87032;s:12:\"delete-87841\";i:87033;s:12:\"delete-87843\";i:87034;s:12:\"delete-87845\";i:87035;s:12:\"delete-87846\";i:87036;s:12:\"delete-87847\";i:87037;s:12:\"delete-87848\";i:87038;s:12:\"delete-87850\";i:87039;s:12:\"delete-87851\";i:87040;s:12:\"delete-87836\";i:87041;s:12:\"delete-87840\";i:87042;s:12:\"delete-87842\";i:87043;s:12:\"delete-87844\";i:87044;s:12:\"delete-87849\";i:87045;s:12:\"delete-87852\";i:87046;s:12:\"delete-87853\";i:87047;s:12:\"delete-87857\";i:87048;s:12:\"delete-87855\";i:87049;s:12:\"delete-87858\";i:87050;s:12:\"delete-87854\";i:87051;s:12:\"delete-87856\";i:87052;s:12:\"delete-87922\";i:87053;s:12:\"delete-87904\";i:87054;s:12:\"delete-87905\";i:87055;s:12:\"delete-87906\";i:87056;s:12:\"delete-87907\";i:87057;s:12:\"delete-87908\";i:87058;s:12:\"delete-87909\";i:87059;s:12:\"delete-87910\";i:87060;s:12:\"delete-87911\";i:87061;s:12:\"delete-87912\";i:87062;s:12:\"delete-87913\";i:87063;s:12:\"delete-87914\";i:87064;s:12:\"delete-87915\";i:87065;s:12:\"delete-87920\";i:87066;s:12:\"delete-87921\";i:87067;s:12:\"delete-87923\";i:87068;s:12:\"delete-87888\";i:87069;s:12:\"delete-87889\";i:87070;s:12:\"delete-87890\";i:87071;s:12:\"delete-87891\";i:87072;s:12:\"delete-87892\";i:87073;s:12:\"delete-87893\";i:87074;s:12:\"delete-87924\";i:87075;s:12:\"delete-87925\";i:87076;s:12:\"delete-87926\";i:87077;s:12:\"delete-87927\";i:87078;s:12:\"delete-87928\";i:87079;s:12:\"delete-87882\";i:87080;s:12:\"delete-87883\";i:87081;s:12:\"delete-87884\";i:87082;s:12:\"delete-87885\";i:87083;s:12:\"delete-87886\";i:87084;s:12:\"delete-87868\";i:87085;s:12:\"delete-87869\";i:87086;s:12:\"delete-87870\";i:87087;s:12:\"delete-87879\";i:87088;s:12:\"delete-87880\";i:87089;s:12:\"delete-87881\";i:87090;s:12:\"delete-87859\";i:87091;s:12:\"delete-87861\";i:87092;s:12:\"delete-87862\";i:87093;s:12:\"delete-87863\";i:87094;s:12:\"delete-87864\";i:87095;s:12:\"delete-87865\";i:87096;s:12:\"delete-87874\";i:87097;s:12:\"delete-87684\";i:87098;s:12:\"delete-87867\";i:87099;s:12:\"delete-87760\";i:87100;s:12:\"delete-87683\";i:87101;s:12:\"delete-87875\";i:87102;s:12:\"delete-87698\";i:87103;s:12:\"delete-87671\";i:87104;s:12:\"delete-87670\";i:87105;s:12:\"delete-87669\";i:87106;s:12:\"delete-87668\";i:87107;s:12:\"delete-87667\";i:87108;s:12:\"delete-87510\";i:87109;s:12:\"delete-87916\";i:87110;s:12:\"delete-87917\";i:87111;s:12:\"delete-87918\";i:87112;s:12:\"delete-87919\";i:87113;s:12:\"delete-87778\";i:87114;s:12:\"delete-87777\";i:87115;s:12:\"delete-87878\";i:87116;s:12:\"delete-87876\";i:87117;s:12:\"delete-87877\";i:87118;s:12:\"delete-87873\";i:87119;s:12:\"delete-87703\";i:87120;s:12:\"delete-87871\";i:87121;s:12:\"delete-87872\";i:87122;s:12:\"delete-87866\";i:87123;s:12:\"delete-87638\";i:87124;s:12:\"delete-87640\";i:87125;s:12:\"delete-87642\";i:87126;s:12:\"delete-87653\";i:87127;s:12:\"delete-87654\";i:87128;s:12:\"delete-87655\";i:87129;s:12:\"delete-87656\";i:87130;s:12:\"delete-87657\";i:87131;s:12:\"delete-87658\";i:87132;s:12:\"delete-87659\";i:87133;s:12:\"delete-87660\";i:87134;s:12:\"delete-87661\";i:87135;s:12:\"delete-87662\";i:87136;s:12:\"delete-87663\";i:87137;s:12:\"delete-87664\";i:87138;s:12:\"delete-87665\";i:87139;s:12:\"delete-87666\";i:87140;s:12:\"delete-87929\";i:87141;s:12:\"delete-87930\";i:87142;s:12:\"delete-87931\";i:87143;s:12:\"delete-87932\";i:87144;s:12:\"delete-87933\";i:87145;s:12:\"delete-87934\";i:87146;s:12:\"delete-87894\";i:87147;s:12:\"delete-87895\";i:87148;s:12:\"delete-87896\";i:87149;s:12:\"delete-87897\";i:87150;s:12:\"delete-87898\";i:87151;s:12:\"delete-87899\";i:87152;s:12:\"delete-87900\";i:87153;s:12:\"delete-87901\";i:87154;s:12:\"delete-87902\";i:87155;s:12:\"delete-87903\";i:87156;s:12:\"delete-87860\";i:87157;s:12:\"delete-87959\";i:87158;s:12:\"delete-87960\";i:87159;s:12:\"delete-87961\";i:87160;s:12:\"delete-87962\";i:87161;s:12:\"delete-87963\";i:87162;s:12:\"delete-87964\";i:87163;s:12:\"delete-87965\";i:87164;s:12:\"delete-87966\";i:87165;s:12:\"delete-87967\";i:87166;s:12:\"delete-87968\";i:87167;s:12:\"delete-87958\";i:87168;s:12:\"delete-87957\";i:87169;s:12:\"delete-87956\";i:87170;s:12:\"delete-87955\";i:87171;s:12:\"delete-87954\";i:87172;s:12:\"delete-87949\";i:87173;s:12:\"delete-87950\";i:87174;s:12:\"delete-87951\";i:87175;s:12:\"delete-87952\";i:87176;s:12:\"delete-87953\";i:87177;s:12:\"delete-87947\";i:87178;s:12:\"delete-87946\";i:87179;s:12:\"delete-87945\";i:87180;s:12:\"delete-87944\";i:87181;s:12:\"delete-87943\";i:87182;s:12:\"delete-87942\";i:87183;s:12:\"delete-87941\";i:87184;s:12:\"delete-87940\";i:87185;s:12:\"delete-87939\";i:87186;s:12:\"delete-87938\";i:87187;s:12:\"delete-87976\";i:87188;s:12:\"delete-87975\";i:87189;s:12:\"delete-87974\";i:87190;s:12:\"delete-87973\";i:87191;s:12:\"delete-87972\";i:87192;s:12:\"delete-87971\";i:87193;s:12:\"delete-87977\";i:87194;s:12:\"delete-87978\";i:87195;s:12:\"delete-87979\";i:87196;s:12:\"delete-87980\";i:87197;s:12:\"delete-87981\";i:87198;s:12:\"delete-87982\";i:87199;s:12:\"delete-87564\";i:87200;s:12:\"delete-87565\";i:87201;s:12:\"delete-87988\";i:87202;s:12:\"delete-87987\";i:87203;s:12:\"delete-87986\";i:87204;s:12:\"delete-87985\";i:87205;s:12:\"delete-87984\";i:87206;s:12:\"delete-87983\";i:87207;s:12:\"delete-87995\";i:87208;s:12:\"delete-87994\";i:87209;s:12:\"delete-87996\";i:87210;s:12:\"delete-87991\";i:87211;s:12:\"delete-87992\";i:87212;s:12:\"delete-87993\";i:87213;s:12:\"delete-87998\";i:87214;s:12:\"delete-87999\";i:87215;s:12:\"delete-88000\";i:87216;s:12:\"delete-87997\";i:87217;s:12:\"delete-88002\";i:87218;s:12:\"delete-88001\";i:87219;s:12:\"delete-88031\";i:87220;s:12:\"delete-88032\";i:87221;s:12:\"delete-88007\";i:87222;s:12:\"delete-88006\";i:87223;s:12:\"delete-88011\";i:87224;s:12:\"delete-88010\";i:87225;s:12:\"delete-88009\";i:87226;s:12:\"delete-88008\";i:87227;s:12:\"delete-88003\";i:87228;s:12:\"delete-88004\";i:87229;s:12:\"delete-88005\";i:87230;s:12:\"delete-88012\";i:87231;s:12:\"delete-88013\";i:87232;s:12:\"delete-88014\";i:87233;s:12:\"delete-88015\";i:87234;s:12:\"delete-88016\";i:87235;s:12:\"delete-87948\";i:87236;s:12:\"delete-88030\";i:87237;s:12:\"delete-88029\";i:87238;s:12:\"delete-88028\";i:87239;s:12:\"delete-88017\";i:87240;s:12:\"delete-88018\";i:87241;s:12:\"delete-88019\";i:87242;s:12:\"delete-88020\";i:87243;s:12:\"delete-88021\";i:87244;s:12:\"delete-88022\";i:87245;s:12:\"delete-88023\";i:87246;s:12:\"delete-88024\";i:87247;s:12:\"delete-88025\";i:87248;s:12:\"delete-88026\";i:87249;s:12:\"delete-87887\";i:87250;s:12:\"delete-88033\";i:87251;s:12:\"delete-88034\";i:87252;s:12:\"delete-88035\";i:87253;s:12:\"delete-88036\";i:87254;s:12:\"delete-88037\";i:87255;s:12:\"delete-88038\";i:87256;s:12:\"delete-88039\";i:87257;s:12:\"delete-88040\";i:87258;s:12:\"delete-88041\";i:87259;s:12:\"delete-88042\";i:87260;s:12:\"delete-88043\";i:87261;s:12:\"delete-88044\";i:87262;s:12:\"delete-88045\";i:87263;s:12:\"delete-87582\";i:87264;s:12:\"delete-87583\";i:87265;s:12:\"delete-87937\";i:87266;s:12:\"delete-87682\";i:87267;s:12:\"delete-88046\";i:87268;s:12:\"delete-88047\";i:87269;s:12:\"delete-88049\";i:87270;s:12:\"delete-88051\";i:87271;s:12:\"delete-88050\";i:87272;s:12:\"delete-88052\";i:87273;s:12:\"delete-87553\";i:87274;s:12:\"delete-87554\";i:87275;s:12:\"delete-87555\";i:87276;s:12:\"delete-87556\";i:87277;s:12:\"delete-87557\";i:87278;s:12:\"delete-87558\";i:87279;s:12:\"delete-87559\";i:87280;s:12:\"delete-87562\";i:87281;s:12:\"delete-87563\";i:87282;s:12:\"delete-87575\";i:87283;s:12:\"delete-87576\";i:87284;s:12:\"delete-87577\";i:87285;s:12:\"delete-87578\";i:87286;s:12:\"delete-87579\";i:87287;s:12:\"delete-87580\";i:87288;s:12:\"delete-87581\";i:87289;s:12:\"delete-87989\";i:87290;s:12:\"delete-87990\";i:87291;s:12:\"delete-88058\";i:87292;s:12:\"delete-88059\";i:87293;s:12:\"delete-88060\";i:87294;s:12:\"delete-88061\";i:87295;s:12:\"delete-88062\";i:87296;s:12:\"delete-88063\";i:87297;s:12:\"delete-88064\";i:87298;s:12:\"delete-88065\";i:87299;s:12:\"delete-88066\";i:87300;s:12:\"delete-88067\";i:87301;s:12:\"delete-88068\";i:87302;s:12:\"delete-88069\";i:87303;s:12:\"delete-88070\";i:87304;s:12:\"delete-88057\";i:87305;s:12:\"delete-88053\";i:87306;s:12:\"delete-88054\";i:87307;s:12:\"delete-88055\";i:87308;s:12:\"delete-88056\";i:87309;s:12:\"delete-88071\";i:87310;s:12:\"delete-88072\";i:87311;s:12:\"delete-88073\";i:87312;s:12:\"delete-88048\";i:87313;s:12:\"delete-87969\";i:87314;s:12:\"delete-87970\";i:87315;s:12:\"delete-88094\";i:87316;s:12:\"delete-88095\";i:87317;s:12:\"delete-88096\";i:87318;s:12:\"delete-88097\";i:87319;s:12:\"delete-87685\";i:87320;s:12:\"delete-87502\";i:87321;s:12:\"delete-87503\";i:87322;s:12:\"delete-87504\";i:87323;s:12:\"delete-87505\";i:87324;s:12:\"delete-87506\";i:87325;s:12:\"delete-87507\";i:87326;s:12:\"delete-87508\";i:87327;s:12:\"delete-87509\";i:87328;s:12:\"delete-87512\";i:87329;s:12:\"delete-87513\";i:87330;s:12:\"delete-87514\";i:87331;s:12:\"delete-87515\";i:87332;s:12:\"delete-87516\";i:87333;s:12:\"delete-87517\";i:87334;s:12:\"delete-87518\";i:87335;s:12:\"delete-87519\";i:87336;s:12:\"delete-87520\";i:87337;s:12:\"delete-87521\";i:87338;s:12:\"delete-87522\";i:87339;s:12:\"delete-87523\";i:87340;s:12:\"delete-87524\";i:87341;s:12:\"delete-87525\";i:87342;s:12:\"delete-87526\";i:87343;s:12:\"delete-87527\";i:87344;s:12:\"delete-87528\";i:87345;s:12:\"delete-87529\";i:87346;s:12:\"delete-87530\";i:87347;s:12:\"delete-87531\";i:87348;s:12:\"delete-87532\";i:87349;s:12:\"delete-87533\";i:87350;s:12:\"delete-87534\";i:87351;s:12:\"delete-87535\";i:87352;s:12:\"delete-87536\";i:87353;s:12:\"delete-87537\";i:87354;s:12:\"delete-87538\";i:87355;s:12:\"delete-87539\";i:87356;s:12:\"delete-87540\";i:87357;s:12:\"delete-87541\";i:87358;s:12:\"delete-87542\";i:87359;s:12:\"delete-87543\";i:87360;s:12:\"delete-87544\";i:87361;s:12:\"delete-87545\";i:87362;s:12:\"delete-87546\";i:87363;s:12:\"delete-87547\";i:87364;s:12:\"delete-87548\";i:87365;s:12:\"delete-87549\";i:87366;s:12:\"delete-87550\";i:87367;s:12:\"delete-87551\";i:87368;s:12:\"delete-87552\";i:87369;s:12:\"delete-87560\";i:87370;s:12:\"delete-87561\";i:87371;s:12:\"delete-87566\";i:87372;s:12:\"delete-87567\";i:87373;s:12:\"delete-87568\";i:87374;s:12:\"delete-87569\";i:87375;s:12:\"delete-87570\";i:87376;s:12:\"delete-87571\";i:87377;s:12:\"delete-87572\";i:87378;s:12:\"delete-87573\";i:87379;s:12:\"delete-87574\";i:87380;s:12:\"delete-88093\";i:87381;s:12:\"delete-88092\";i:87382;s:12:\"delete-88091\";i:87383;s:12:\"delete-88090\";i:87384;s:12:\"delete-88074\";i:87385;s:12:\"delete-88075\";i:87386;s:12:\"delete-88076\";i:87387;s:12:\"delete-88077\";i:87388;s:12:\"delete-88078\";i:87389;s:12:\"delete-88079\";i:87390;s:12:\"delete-88080\";i:87391;s:12:\"delete-88081\";i:87392;s:12:\"delete-88082\";i:87393;s:12:\"delete-88083\";i:87394;s:12:\"delete-88084\";i:87395;s:12:\"delete-88085\";i:87396;s:12:\"delete-88086\";i:87397;s:12:\"delete-88087\";i:87398;s:12:\"delete-88088\";i:87399;s:12:\"delete-88089\";i:87400;s:12:\"delete-87636\";i:87401;s:12:\"delete-87637\";i:87402;s:12:\"delete-87639\";i:87403;s:12:\"delete-87641\";i:87404;s:12:\"delete-87643\";i:87405;s:12:\"delete-87644\";i:87406;s:12:\"delete-87645\";i:87407;s:12:\"delete-87646\";i:87408;s:12:\"delete-87647\";i:87409;s:12:\"delete-87648\";i:87410;s:12:\"delete-87649\";i:87411;s:12:\"delete-87650\";i:87412;s:12:\"delete-87651\";i:87413;s:12:\"delete-87652\";i:87414;s:12:\"delete-88103\";i:87415;s:12:\"delete-88102\";i:87416;s:12:\"delete-88101\";i:87417;s:12:\"delete-88100\";i:87418;s:12:\"delete-88098\";i:87419;s:12:\"delete-88099\";i:87420;s:12:\"delete-88104\";i:87421;s:12:\"delete-88105\";i:87422;s:12:\"delete-88106\";i:87423;s:12:\"delete-88107\";i:87424;s:12:\"delete-88108\";i:87425;s:12:\"delete-87935\";i:87426;s:12:\"delete-87936\";i:87427;s:12:\"delete-88027\";i:87428;s:12:\"delete-87500\";i:87429;s:12:\"delete-88121\";i:87430;s:12:\"delete-88140\";i:87431;s:12:\"delete-88141\";i:87432;s:12:\"delete-88142\";i:87433;s:12:\"delete-88143\";i:87434;s:12:\"delete-88144\";i:87435;s:12:\"delete-88145\";i:87436;s:12:\"delete-88146\";i:87437;s:12:\"delete-88147\";i:87438;s:12:\"delete-88139\";i:87439;s:12:\"delete-88131\";i:87440;s:12:\"delete-88133\";i:87441;s:12:\"delete-88135\";i:87442;s:12:\"delete-88137\";i:87443;s:12:\"delete-88138\";i:87444;s:12:\"delete-88130\";i:87445;s:12:\"delete-88132\";i:87446;s:12:\"delete-88134\";i:87447;s:12:\"delete-88136\";i:87448;s:12:\"delete-88113\";i:87449;s:12:\"delete-88112\";i:87450;s:12:\"delete-88111\";i:87451;s:12:\"delete-88110\";i:87452;s:12:\"delete-88109\";i:87453;s:12:\"delete-88129\";i:87454;s:12:\"delete-88127\";i:87455;s:12:\"delete-88126\";i:87456;s:12:\"delete-88123\";i:87457;s:12:\"delete-88122\";i:87458;s:12:\"delete-88128\";i:87459;s:12:\"delete-88156\";i:87460;s:12:\"delete-88157\";i:87461;s:12:\"delete-88114\";i:87462;s:12:\"delete-88115\";i:87463;s:12:\"delete-88118\";i:87464;s:12:\"delete-88116\";i:87465;s:12:\"delete-88117\";i:87466;s:12:\"delete-88119\";i:87467;s:12:\"delete-88120\";i:87468;s:12:\"delete-88155\";i:87469;s:12:\"delete-88152\";i:87470;s:12:\"delete-88154\";i:87471;s:12:\"delete-88153\";i:87472;s:12:\"delete-88149\";i:87473;s:12:\"delete-88151\";i:87474;s:12:\"delete-88150\";i:87475;s:12:\"delete-88148\";i:87476;s:12:\"delete-88125\";i:87477;s:12:\"delete-88124\";i:87478;s:12:\"delete-88180\";i:87479;s:12:\"delete-88170\";i:87480;s:12:\"delete-88171\";i:87481;s:12:\"delete-88181\";i:87482;s:12:\"delete-88183\";i:87483;s:12:\"delete-88184\";i:87484;s:12:\"delete-88393\";i:87485;s:12:\"delete-88392\";i:87486;s:12:\"delete-88391\";i:87487;s:12:\"delete-88390\";i:87488;s:12:\"delete-88389\";i:87489;s:12:\"delete-88388\";i:87490;s:12:\"delete-88364\";i:87491;s:12:\"delete-88365\";i:87492;s:12:\"delete-88366\";i:87493;s:12:\"delete-88387\";i:87494;s:12:\"delete-88386\";i:87495;s:12:\"delete-88385\";i:87496;s:12:\"delete-88384\";i:87497;s:12:\"delete-88383\";i:87498;s:12:\"delete-88377\";i:87499;s:12:\"delete-88378\";i:87500;s:12:\"delete-88379\";i:87501;s:12:\"delete-88380\";i:87502;s:12:\"delete-88381\";i:87503;s:12:\"delete-88382\";i:87504;s:12:\"delete-88376\";i:87505;s:12:\"delete-88375\";i:87506;s:12:\"delete-88372\";i:87507;s:12:\"delete-88373\";i:87508;s:12:\"delete-88374\";i:87509;s:12:\"delete-88371\";i:87510;s:12:\"delete-88370\";i:87511;s:12:\"delete-88369\";i:87512;s:12:\"delete-88368\";i:87513;s:12:\"delete-88367\";i:87514;s:12:\"delete-88363\";i:87515;s:12:\"delete-88362\";i:87516;s:12:\"delete-88361\";i:87517;s:12:\"delete-88360\";i:87518;s:12:\"delete-88359\";i:87519;s:12:\"delete-88358\";i:87520;s:12:\"delete-88357\";i:87521;s:12:\"delete-88330\";i:87522;s:12:\"delete-88331\";i:87523;s:12:\"delete-88332\";i:87524;s:12:\"delete-88333\";i:87525;s:12:\"delete-88334\";i:87526;s:12:\"delete-88335\";i:87527;s:12:\"delete-88336\";i:87528;s:12:\"delete-88337\";i:87529;s:12:\"delete-88338\";i:87530;s:12:\"delete-88339\";i:87531;s:12:\"delete-88340\";i:87532;s:12:\"delete-88341\";i:87533;s:12:\"delete-88342\";i:87534;s:12:\"delete-88343\";i:87535;s:12:\"delete-88344\";i:87536;s:12:\"delete-88329\";i:87537;s:12:\"delete-88328\";i:87538;s:12:\"delete-88327\";i:87539;s:12:\"delete-88326\";i:87540;s:12:\"delete-88323\";i:87541;s:12:\"delete-88324\";i:87542;s:12:\"delete-88325\";i:87543;s:12:\"delete-88322\";i:87544;s:12:\"delete-88321\";i:87545;s:12:\"delete-88320\";i:87546;s:12:\"delete-88319\";i:87547;s:12:\"delete-88318\";i:87548;s:12:\"delete-88317\";i:87549;s:12:\"delete-88316\";i:87550;s:12:\"delete-88315\";i:87551;s:12:\"delete-88314\";i:87552;s:12:\"delete-88313\";i:87553;s:12:\"delete-88312\";i:87554;s:12:\"delete-88311\";i:87555;s:12:\"delete-88310\";i:87556;s:12:\"delete-88309\";i:87557;s:12:\"delete-88308\";i:87558;s:12:\"delete-88307\";i:87559;s:12:\"delete-88306\";i:87560;s:12:\"delete-88305\";i:87561;s:12:\"delete-88304\";i:87562;s:12:\"delete-88303\";i:87563;s:12:\"delete-88302\";i:87564;s:12:\"delete-88301\";i:87565;s:12:\"delete-88300\";i:87566;s:12:\"delete-88298\";i:87567;s:12:\"delete-88299\";i:87568;s:12:\"delete-88356\";i:87569;s:12:\"delete-88355\";i:87570;s:12:\"delete-88354\";i:87571;s:12:\"delete-88294\";i:87572;s:12:\"delete-88295\";i:87573;s:12:\"delete-88296\";i:87574;s:12:\"delete-88297\";i:87575;s:12:\"delete-88293\";i:87576;s:12:\"delete-88292\";i:87577;s:12:\"delete-88291\";i:87578;s:12:\"delete-88290\";i:87579;s:12:\"delete-88289\";i:87580;s:12:\"delete-88287\";i:87581;s:12:\"delete-88288\";i:87582;s:12:\"delete-88353\";i:87583;s:12:\"delete-88352\";i:87584;s:12:\"delete-88351\";i:87585;s:12:\"delete-88350\";i:87586;s:12:\"delete-88349\";i:87587;s:12:\"delete-88348\";i:87588;s:12:\"delete-88347\";i:87589;s:12:\"delete-88346\";i:87590;s:12:\"delete-88286\";i:87591;s:12:\"delete-88285\";i:87592;s:12:\"delete-88272\";i:87593;s:12:\"delete-88273\";i:87594;s:12:\"delete-88345\";i:87595;s:12:\"delete-88284\";i:87596;s:12:\"delete-88283\";i:87597;s:12:\"delete-88282\";i:87598;s:12:\"delete-88281\";i:87599;s:12:\"delete-88280\";i:87600;s:12:\"delete-88279\";i:87601;s:12:\"delete-88278\";i:87602;s:12:\"delete-88277\";i:87603;s:12:\"delete-88276\";i:87604;s:12:\"delete-88275\";i:87605;s:12:\"delete-88274\";i:87606;s:12:\"delete-88271\";i:87607;s:12:\"delete-88269\";i:87608;s:12:\"delete-88270\";i:87609;s:12:\"delete-88267\";i:87610;s:12:\"delete-88268\";i:87611;s:12:\"delete-88265\";i:87612;s:12:\"delete-88266\";i:87613;s:12:\"delete-88264\";i:87614;s:12:\"delete-88263\";i:87615;s:12:\"delete-88262\";i:87616;s:12:\"delete-88261\";i:87617;s:12:\"delete-88260\";i:87618;s:12:\"delete-88259\";i:87619;s:12:\"delete-88258\";i:87620;s:12:\"delete-88257\";i:87621;s:12:\"delete-88235\";i:87622;s:12:\"delete-88236\";i:87623;s:12:\"delete-88237\";i:87624;s:12:\"delete-88238\";i:87625;s:12:\"delete-88239\";i:87626;s:12:\"delete-88240\";i:87627;s:12:\"delete-88241\";i:87628;s:12:\"delete-88242\";i:87629;s:12:\"delete-88243\";i:87630;s:12:\"delete-88244\";i:87631;s:12:\"delete-88245\";i:87632;s:12:\"delete-88246\";i:87633;s:12:\"delete-88247\";i:87634;s:12:\"delete-88248\";i:87635;s:12:\"delete-88249\";i:87636;s:12:\"delete-88250\";i:87637;s:12:\"delete-88251\";i:87638;s:12:\"delete-88252\";i:87639;s:12:\"delete-88253\";i:87640;s:12:\"delete-88254\";i:87641;s:12:\"delete-88255\";i:87642;s:12:\"delete-88256\";i:87643;s:12:\"delete-88234\";i:87644;s:12:\"delete-88233\";i:87645;s:12:\"delete-88232\";i:87646;s:12:\"delete-88231\";i:87647;s:12:\"delete-88230\";i:87648;s:12:\"delete-88229\";i:87649;s:12:\"delete-88185\";i:87650;s:12:\"delete-88186\";i:87651;s:12:\"delete-88187\";i:87652;s:12:\"delete-88188\";i:87653;s:12:\"delete-88189\";i:87654;s:12:\"delete-88190\";i:87655;s:12:\"delete-88191\";i:87656;s:12:\"delete-88192\";i:87657;s:12:\"delete-88193\";i:87658;s:12:\"delete-88194\";i:87659;s:12:\"delete-88195\";i:87660;s:12:\"delete-88196\";i:87661;s:12:\"delete-88197\";i:87662;s:12:\"delete-88198\";i:87663;s:12:\"delete-88199\";i:87664;s:12:\"delete-88200\";i:87665;s:12:\"delete-88201\";i:87666;s:12:\"delete-88202\";i:87667;s:12:\"delete-88203\";i:87668;s:12:\"delete-88204\";i:87669;s:12:\"delete-88205\";i:87670;s:12:\"delete-88206\";i:87671;s:12:\"delete-88207\";i:87672;s:12:\"delete-88208\";i:87673;s:12:\"delete-88209\";i:87674;s:12:\"delete-88210\";i:87675;s:12:\"delete-88211\";i:87676;s:12:\"delete-88212\";i:87677;s:12:\"delete-88213\";i:87678;s:12:\"delete-88214\";i:87679;s:12:\"delete-88215\";i:87680;s:12:\"delete-88216\";i:87681;s:12:\"delete-88217\";i:87682;s:12:\"delete-88218\";i:87683;s:12:\"delete-88219\";i:87684;s:12:\"delete-88220\";i:87685;s:12:\"delete-88221\";i:87686;s:12:\"delete-88222\";i:87687;s:12:\"delete-88223\";i:87688;s:12:\"delete-88224\";i:87689;s:12:\"delete-88566\";i:87690;s:12:\"delete-88564\";i:87691;s:12:\"delete-88563\";i:87692;s:12:\"delete-88562\";i:87693;s:12:\"delete-88561\";i:87694;s:12:\"delete-88560\";i:87695;s:12:\"delete-88559\";i:87696;s:12:\"delete-88558\";i:87697;s:12:\"delete-88557\";i:87698;s:12:\"delete-88556\";i:87699;s:12:\"delete-88555\";i:87700;s:12:\"delete-88554\";i:87701;s:12:\"delete-88553\";i:87702;s:12:\"delete-88552\";i:87703;s:12:\"delete-88551\";i:87704;s:12:\"delete-88550\";i:87705;s:12:\"delete-88549\";i:87706;s:12:\"delete-88548\";i:87707;s:12:\"delete-88547\";i:87708;s:12:\"delete-88546\";i:87709;s:12:\"delete-88545\";i:87710;s:12:\"delete-88544\";i:87711;s:12:\"delete-88543\";i:87712;s:12:\"delete-88542\";i:87713;s:12:\"delete-88540\";i:87714;s:12:\"delete-88541\";i:87715;s:12:\"delete-88538\";i:87716;s:12:\"delete-88539\";i:87717;s:12:\"delete-88536\";i:87718;s:12:\"delete-88537\";i:87719;s:12:\"delete-88534\";i:87720;s:12:\"delete-88535\";i:87721;s:12:\"delete-88532\";i:87722;s:12:\"delete-88533\";i:87723;s:12:\"delete-88530\";i:87724;s:12:\"delete-88531\";i:87725;s:12:\"delete-88528\";i:87726;s:12:\"delete-88529\";i:87727;s:12:\"delete-88526\";i:87728;s:12:\"delete-88527\";i:87729;s:12:\"delete-88524\";i:87730;s:12:\"delete-88525\";i:87731;s:12:\"delete-88522\";i:87732;s:12:\"delete-88523\";i:87733;s:12:\"delete-88520\";i:87734;s:12:\"delete-88521\";i:87735;s:12:\"delete-88518\";i:87736;s:12:\"delete-88519\";i:87737;s:12:\"delete-88516\";i:87738;s:12:\"delete-88517\";i:87739;s:12:\"delete-88514\";i:87740;s:12:\"delete-88515\";i:87741;s:12:\"delete-88512\";i:87742;s:12:\"delete-88513\";i:87743;s:12:\"delete-88510\";i:87744;s:12:\"delete-88511\";i:87745;s:12:\"delete-88508\";i:87746;s:12:\"delete-88509\";i:87747;s:12:\"delete-88506\";i:87748;s:12:\"delete-88507\";i:87749;s:12:\"delete-88504\";i:87750;s:12:\"delete-88505\";i:87751;s:12:\"delete-88502\";i:87752;s:12:\"delete-88503\";i:87753;s:12:\"delete-88500\";i:87754;s:12:\"delete-88501\";i:87755;s:12:\"delete-88498\";i:87756;s:12:\"delete-88499\";i:87757;s:12:\"delete-88496\";i:87758;s:12:\"delete-88497\";i:87759;s:12:\"delete-88494\";i:87760;s:12:\"delete-88495\";i:87761;s:12:\"delete-88492\";i:87762;s:12:\"delete-88493\";i:87763;s:12:\"delete-88490\";i:87764;s:12:\"delete-88491\";i:87765;s:12:\"delete-88488\";i:87766;s:12:\"delete-88489\";i:87767;s:12:\"delete-88486\";i:87768;s:12:\"delete-88487\";i:87769;s:12:\"delete-88484\";i:87770;s:12:\"delete-88485\";i:87771;s:12:\"delete-88482\";i:87772;s:12:\"delete-88483\";i:87773;s:12:\"delete-88480\";i:87774;s:12:\"delete-88481\";i:87775;s:12:\"delete-88478\";i:87776;s:12:\"delete-88479\";i:87777;s:12:\"delete-88476\";i:87778;s:12:\"delete-88477\";i:87779;s:12:\"delete-88474\";i:87780;s:12:\"delete-88475\";i:87781;s:12:\"delete-88472\";i:87782;s:12:\"delete-88473\";i:87783;s:12:\"delete-88470\";i:87784;s:12:\"delete-88471\";i:87785;s:12:\"delete-88468\";i:87786;s:12:\"delete-88469\";i:87787;s:12:\"delete-88466\";i:87788;s:12:\"delete-88467\";i:87789;s:12:\"delete-88464\";i:87790;s:12:\"delete-88465\";i:87791;s:12:\"delete-88462\";i:87792;s:12:\"delete-88463\";i:87793;s:12:\"delete-88460\";i:87794;s:12:\"delete-88461\";i:87795;s:12:\"delete-88458\";i:87796;s:12:\"delete-88459\";i:87797;s:12:\"delete-88457\";i:87798;s:12:\"delete-88456\";i:87799;s:12:\"delete-88455\";i:87800;s:12:\"delete-88454\";i:87801;s:12:\"delete-88453\";i:87802;s:12:\"delete-88452\";i:87803;s:12:\"delete-88451\";i:87804;s:12:\"delete-88450\";i:87805;s:12:\"delete-88449\";i:87806;s:12:\"delete-88448\";i:87807;s:12:\"delete-88447\";i:87808;s:12:\"delete-88446\";i:87809;s:12:\"delete-88445\";i:87810;s:12:\"delete-88444\";i:87811;s:12:\"delete-88443\";i:87812;s:12:\"delete-88442\";i:87813;s:12:\"delete-88441\";i:87814;s:12:\"delete-88440\";i:87815;s:12:\"delete-88439\";i:87816;s:12:\"delete-88438\";i:87817;s:12:\"delete-88437\";i:87818;s:12:\"delete-88436\";i:87819;s:12:\"delete-88435\";i:87820;s:12:\"delete-88434\";i:87821;s:12:\"delete-88433\";i:87822;s:12:\"delete-88432\";i:87823;s:12:\"delete-88431\";i:87824;s:12:\"delete-88430\";i:87825;s:12:\"delete-88429\";i:87826;s:12:\"delete-88428\";i:87827;s:12:\"delete-88427\";i:87828;s:12:\"delete-88426\";i:87829;s:12:\"delete-88425\";i:87830;s:12:\"delete-88424\";i:87831;s:12:\"delete-88423\";i:87832;s:12:\"delete-88422\";i:87833;s:12:\"delete-88421\";i:87834;s:12:\"delete-88420\";i:87835;s:12:\"delete-88419\";i:87836;s:12:\"delete-88418\";i:87837;s:12:\"delete-88417\";i:87838;s:12:\"delete-88416\";i:87839;s:12:\"delete-88415\";i:87840;s:12:\"delete-88414\";i:87841;s:12:\"delete-88413\";i:87842;s:12:\"delete-88412\";i:87843;s:12:\"delete-88411\";i:87844;s:12:\"delete-88410\";i:87845;s:12:\"delete-88409\";i:87846;s:12:\"delete-88408\";i:87847;s:12:\"delete-88407\";i:87848;s:12:\"delete-88406\";i:87849;s:12:\"delete-88405\";i:87850;s:12:\"delete-88404\";i:87851;s:12:\"delete-88403\";i:87852;s:12:\"delete-88402\";i:87853;s:12:\"delete-88401\";i:87854;s:12:\"delete-88400\";i:87855;s:12:\"delete-88399\";i:87856;s:12:\"delete-88398\";i:87857;s:12:\"delete-88397\";i:87858;s:12:\"delete-88396\";i:87859;s:12:\"delete-88394\";i:87860;s:12:\"delete-88395\";i:87861;s:12:\"delete-88228\";i:87862;s:12:\"delete-88227\";i:87863;s:12:\"delete-88226\";i:87864;s:12:\"delete-88225\";i:87865;s:12:\"delete-88179\";i:87866;s:12:\"delete-88182\";i:87867;s:12:\"delete-88565\";i:87868;s:12:\"delete-88178\";i:87869;s:12:\"delete-88163\";i:87870;s:12:\"delete-88164\";i:87871;s:12:\"delete-88165\";i:87872;s:12:\"delete-88166\";i:87873;s:12:\"delete-88167\";i:87874;s:12:\"delete-88168\";i:87875;s:12:\"delete-88169\";i:87876;s:12:\"delete-88172\";i:87877;s:12:\"delete-88173\";i:87878;s:12:\"delete-88174\";i:87879;s:12:\"delete-88175\";i:87880;s:12:\"delete-88176\";i:87881;s:12:\"delete-88177\";i:87882;s:12:\"delete-88964\";i:87883;s:12:\"delete-88963\";i:87884;s:12:\"delete-88945\";i:87885;s:12:\"delete-88946\";i:87886;s:12:\"delete-88935\";i:87887;s:12:\"delete-88936\";i:87888;s:12:\"delete-88937\";i:87889;s:12:\"delete-88938\";i:87890;s:12:\"delete-88939\";i:87891;s:12:\"delete-88940\";i:87892;s:12:\"delete-88941\";i:87893;s:12:\"delete-88942\";i:87894;s:12:\"delete-88943\";i:87895;s:12:\"delete-88944\";i:87896;s:12:\"delete-88933\";i:87897;s:12:\"delete-88934\";i:87898;s:12:\"delete-88932\";i:87899;s:12:\"delete-88926\";i:87900;s:12:\"delete-88927\";i:87901;s:12:\"delete-88928\";i:87902;s:12:\"delete-88929\";i:87903;s:12:\"delete-88930\";i:87904;s:12:\"delete-88931\";i:87905;s:12:\"delete-88924\";i:87906;s:12:\"delete-88925\";i:87907;s:12:\"delete-88922\";i:87908;s:12:\"delete-88923\";i:87909;s:12:\"delete-88921\";i:87910;s:12:\"delete-88919\";i:87911;s:12:\"delete-88917\";i:87912;s:12:\"delete-88918\";i:87913;s:12:\"delete-88915\";i:87914;s:12:\"delete-88916\";i:87915;s:12:\"delete-88913\";i:87916;s:12:\"delete-88914\";i:87917;s:12:\"delete-88911\";i:87918;s:12:\"delete-88912\";i:87919;s:12:\"delete-88909\";i:87920;s:12:\"delete-88910\";i:87921;s:12:\"delete-88908\";i:87922;s:12:\"delete-88907\";i:87923;s:12:\"delete-88831\";i:87924;s:12:\"delete-88832\";i:87925;s:12:\"delete-88833\";i:87926;s:12:\"delete-88834\";i:87927;s:12:\"delete-88835\";i:87928;s:12:\"delete-88836\";i:87929;s:12:\"delete-88837\";i:87930;s:12:\"delete-88838\";i:87931;s:12:\"delete-88839\";i:87932;s:12:\"delete-88840\";i:87933;s:12:\"delete-88841\";i:87934;s:12:\"delete-88842\";i:87935;s:12:\"delete-88843\";i:87936;s:12:\"delete-88844\";i:87937;s:12:\"delete-88845\";i:87938;s:12:\"delete-88846\";i:87939;s:12:\"delete-88847\";i:87940;s:12:\"delete-88848\";i:87941;s:12:\"delete-88849\";i:87942;s:12:\"delete-88850\";i:87943;s:12:\"delete-88851\";i:87944;s:12:\"delete-88852\";i:87945;s:12:\"delete-88853\";i:87946;s:12:\"delete-88854\";i:87947;s:12:\"delete-88855\";i:87948;s:12:\"delete-88856\";i:87949;s:12:\"delete-88857\";i:87950;s:12:\"delete-88858\";i:87951;s:12:\"delete-88859\";i:87952;s:12:\"delete-88860\";i:87953;s:12:\"delete-88861\";i:87954;s:12:\"delete-88862\";i:87955;s:12:\"delete-88863\";i:87956;s:12:\"delete-88864\";i:87957;s:12:\"delete-88865\";i:87958;s:12:\"delete-88866\";i:87959;s:12:\"delete-88867\";i:87960;s:12:\"delete-88868\";i:87961;s:12:\"delete-88869\";i:87962;s:12:\"delete-88870\";i:87963;s:12:\"delete-88871\";i:87964;s:12:\"delete-88872\";i:87965;s:12:\"delete-88873\";i:87966;s:12:\"delete-88874\";i:87967;s:12:\"delete-88875\";i:87968;s:12:\"delete-88876\";i:87969;s:12:\"delete-88877\";i:87970;s:12:\"delete-88878\";i:87971;s:12:\"delete-88879\";i:87972;s:12:\"delete-88880\";i:87973;s:12:\"delete-88881\";i:87974;s:12:\"delete-88882\";i:87975;s:12:\"delete-88883\";i:87976;s:12:\"delete-88884\";i:87977;s:12:\"delete-88885\";i:87978;s:12:\"delete-88886\";i:87979;s:12:\"delete-88887\";i:87980;s:12:\"delete-88888\";i:87981;s:12:\"delete-88889\";i:87982;s:12:\"delete-88890\";i:87983;s:12:\"delete-88891\";i:87984;s:12:\"delete-88892\";i:87985;s:12:\"delete-88893\";i:87986;s:12:\"delete-88894\";i:87987;s:12:\"delete-88895\";i:87988;s:12:\"delete-88896\";i:87989;s:12:\"delete-88897\";i:87990;s:12:\"delete-88898\";i:87991;s:12:\"delete-88899\";i:87992;s:12:\"delete-88900\";i:87993;s:12:\"delete-88901\";i:87994;s:12:\"delete-88902\";i:87995;s:12:\"delete-88903\";i:87996;s:12:\"delete-88904\";i:87997;s:12:\"delete-88905\";i:87998;s:12:\"delete-88906\";i:87999;s:12:\"delete-88830\";i:88000;s:12:\"delete-88829\";i:88001;s:12:\"delete-88816\";i:88002;s:12:\"delete-88817\";i:88003;s:12:\"delete-88818\";i:88004;s:12:\"delete-88819\";i:88005;s:12:\"delete-88820\";i:88006;s:12:\"delete-88821\";i:88007;s:12:\"delete-88828\";i:88008;s:12:\"delete-88827\";i:88009;s:12:\"delete-88826\";i:88010;s:12:\"delete-88824\";i:88011;s:12:\"delete-88825\";i:88012;s:12:\"delete-88823\";i:88013;s:12:\"delete-88822\";i:88014;s:12:\"delete-88815\";i:88015;s:12:\"delete-88814\";i:88016;s:12:\"delete-88813\";i:88017;s:12:\"delete-88812\";i:88018;s:12:\"delete-88811\";i:88019;s:12:\"delete-88810\";i:88020;s:12:\"delete-88809\";i:88021;s:12:\"delete-88807\";i:88022;s:12:\"delete-88808\";i:88023;s:12:\"delete-88804\";i:88024;s:12:\"delete-88805\";i:88025;s:12:\"delete-88806\";i:88026;s:12:\"delete-88802\";i:88027;s:12:\"delete-88803\";i:88028;s:12:\"delete-88800\";i:88029;s:12:\"delete-88801\";i:88030;s:12:\"delete-88798\";i:88031;s:12:\"delete-88799\";i:88032;s:12:\"delete-88796\";i:88033;s:12:\"delete-88797\";i:88034;s:12:\"delete-88794\";i:88035;s:12:\"delete-88795\";i:88036;s:12:\"delete-88793\";i:88037;s:12:\"delete-88792\";i:88038;s:12:\"delete-88791\";i:88039;s:12:\"delete-88790\";i:88040;s:12:\"delete-88789\";i:88041;s:12:\"delete-88788\";i:88042;s:12:\"delete-88787\";i:88043;s:12:\"delete-88786\";i:88044;s:12:\"delete-88785\";i:88045;s:12:\"delete-88784\";i:88046;s:12:\"delete-88783\";i:88047;s:12:\"delete-88782\";i:88048;s:12:\"delete-88781\";i:88049;s:12:\"delete-88780\";i:88050;s:12:\"delete-88779\";i:88051;s:12:\"delete-88757\";i:88052;s:12:\"delete-88758\";i:88053;s:12:\"delete-88759\";i:88054;s:12:\"delete-88760\";i:88055;s:12:\"delete-88761\";i:88056;s:12:\"delete-88762\";i:88057;s:12:\"delete-88763\";i:88058;s:12:\"delete-88764\";i:88059;s:12:\"delete-88765\";i:88060;s:12:\"delete-88766\";i:88061;s:12:\"delete-88767\";i:88062;s:12:\"delete-88768\";i:88063;s:12:\"delete-88769\";i:88064;s:12:\"delete-88770\";i:88065;s:12:\"delete-88771\";i:88066;s:12:\"delete-88772\";i:88067;s:12:\"delete-88773\";i:88068;s:12:\"delete-88774\";i:88069;s:12:\"delete-88775\";i:88070;s:12:\"delete-88776\";i:88071;s:12:\"delete-88777\";i:88072;s:12:\"delete-88778\";i:88073;s:12:\"delete-88756\";i:88074;s:12:\"delete-88755\";i:88075;s:12:\"delete-88754\";i:88076;s:12:\"delete-88753\";i:88077;s:12:\"delete-88751\";i:88078;s:12:\"delete-88752\";i:88079;s:12:\"delete-88750\";i:88080;s:12:\"delete-88950\";i:88081;s:12:\"delete-88949\";i:88082;s:12:\"delete-88948\";i:88083;s:12:\"delete-88749\";i:88084;s:12:\"delete-88748\";i:88085;s:12:\"delete-88747\";i:88086;s:12:\"delete-88746\";i:88087;s:12:\"delete-88745\";i:88088;s:12:\"delete-88744\";i:88089;s:12:\"delete-88743\";i:88090;s:12:\"delete-88742\";i:88091;s:12:\"delete-88741\";i:88092;s:12:\"delete-88740\";i:88093;s:12:\"delete-88739\";i:88094;s:12:\"delete-88738\";i:88095;s:12:\"delete-88737\";i:88096;s:12:\"delete-88736\";i:88097;s:12:\"delete-88735\";i:88098;s:12:\"delete-88734\";i:88099;s:12:\"delete-88733\";i:88100;s:12:\"delete-88732\";i:88101;s:12:\"delete-88731\";i:88102;s:12:\"delete-88730\";i:88103;s:12:\"delete-88729\";i:88104;s:12:\"delete-88728\";i:88105;s:12:\"delete-88727\";i:88106;s:12:\"delete-88726\";i:88107;s:12:\"delete-88725\";i:88108;s:12:\"delete-88724\";i:88109;s:12:\"delete-88723\";i:88110;s:12:\"delete-88722\";i:88111;s:12:\"delete-88721\";i:88112;s:12:\"delete-88720\";i:88113;s:12:\"delete-88719\";i:88114;s:12:\"delete-88718\";i:88115;s:12:\"delete-88717\";i:88116;s:12:\"delete-88716\";i:88117;s:12:\"delete-88715\";i:88118;s:12:\"delete-88711\";i:88119;s:12:\"delete-88712\";i:88120;s:12:\"delete-88713\";i:88121;s:12:\"delete-88714\";i:88122;s:12:\"delete-88710\";i:88123;s:12:\"delete-88708\";i:88124;s:12:\"delete-88709\";i:88125;s:12:\"delete-88707\";i:88126;s:12:\"delete-88706\";i:88127;s:12:\"delete-88704\";i:88128;s:12:\"delete-88705\";i:88129;s:12:\"delete-88703\";i:88130;s:12:\"delete-88702\";i:88131;s:12:\"delete-88700\";i:88132;s:12:\"delete-88701\";i:88133;s:12:\"delete-88699\";i:88134;s:12:\"delete-88698\";i:88135;s:12:\"delete-88696\";i:88136;s:12:\"delete-88697\";i:88137;s:12:\"delete-88695\";i:88138;s:12:\"delete-88694\";i:88139;s:12:\"delete-88693\";i:88140;s:12:\"delete-88691\";i:88141;s:12:\"delete-88692\";i:88142;s:12:\"delete-88690\";i:88143;s:12:\"delete-88689\";i:88144;s:12:\"delete-88687\";i:88145;s:12:\"delete-88688\";i:88146;s:12:\"delete-88686\";i:88147;s:12:\"delete-88685\";i:88148;s:12:\"delete-88683\";i:88149;s:12:\"delete-88684\";i:88150;s:12:\"delete-88682\";i:88151;s:12:\"delete-88681\";i:88152;s:12:\"delete-88679\";i:88153;s:12:\"delete-88680\";i:88154;s:12:\"delete-88678\";i:88155;s:12:\"delete-88677\";i:88156;s:12:\"delete-88675\";i:88157;s:12:\"delete-88676\";i:88158;s:12:\"delete-88674\";i:88159;s:12:\"delete-88673\";i:88160;s:12:\"delete-88671\";i:88161;s:12:\"delete-88672\";i:88162;s:12:\"delete-88670\";i:88163;s:12:\"delete-88669\";i:88164;s:12:\"delete-88667\";i:88165;s:12:\"delete-88668\";i:88166;s:12:\"delete-88666\";i:88167;s:12:\"delete-88665\";i:88168;s:12:\"delete-88663\";i:88169;s:12:\"delete-88664\";i:88170;s:12:\"delete-88662\";i:88171;s:12:\"delete-88661\";i:88172;s:12:\"delete-88659\";i:88173;s:12:\"delete-88660\";i:88174;s:12:\"delete-88658\";i:88175;s:12:\"delete-88657\";i:88176;s:12:\"delete-88655\";i:88177;s:12:\"delete-88656\";i:88178;s:12:\"delete-88654\";i:88179;s:12:\"delete-88653\";i:88180;s:12:\"delete-88651\";i:88181;s:12:\"delete-88652\";i:88182;s:12:\"delete-88650\";i:88183;s:12:\"delete-88649\";i:88184;s:12:\"delete-88647\";i:88185;s:12:\"delete-88648\";i:88186;s:12:\"delete-88646\";i:88187;s:12:\"delete-88645\";i:88188;s:12:\"delete-88643\";i:88189;s:12:\"delete-88644\";i:88190;s:12:\"delete-88642\";i:88191;s:12:\"delete-88641\";i:88192;s:12:\"delete-88639\";i:88193;s:12:\"delete-88640\";i:88194;s:12:\"delete-88638\";i:88195;s:12:\"delete-88636\";i:88196;s:12:\"delete-88637\";i:88197;s:12:\"delete-88635\";i:88198;s:12:\"delete-88634\";i:88199;s:12:\"delete-88632\";i:88200;s:12:\"delete-88633\";i:88201;s:12:\"delete-88631\";i:88202;s:12:\"delete-88630\";i:88203;s:12:\"delete-88628\";i:88204;s:12:\"delete-88629\";i:88205;s:12:\"delete-88627\";i:88206;s:12:\"delete-88626\";i:88207;s:12:\"delete-88624\";i:88208;s:12:\"delete-88625\";i:88209;s:12:\"delete-88623\";i:88210;s:12:\"delete-88622\";i:88211;s:12:\"delete-88620\";i:88212;s:12:\"delete-88621\";i:88213;s:12:\"delete-88619\";i:88214;s:12:\"delete-88618\";i:88215;s:12:\"delete-88616\";i:88216;s:12:\"delete-88617\";i:88217;s:12:\"delete-88615\";i:88218;s:12:\"delete-88614\";i:88219;s:12:\"delete-88612\";i:88220;s:12:\"delete-88613\";i:88221;s:12:\"delete-88611\";i:88222;s:12:\"delete-88610\";i:88223;s:12:\"delete-88608\";i:88224;s:12:\"delete-88609\";i:88225;s:12:\"delete-88607\";i:88226;s:12:\"delete-88606\";i:88227;s:12:\"delete-88605\";i:88228;s:12:\"delete-88604\";i:88229;s:12:\"delete-88603\";i:88230;s:12:\"delete-88602\";i:88231;s:12:\"delete-88600\";i:88232;s:12:\"delete-88601\";i:88233;s:12:\"delete-88599\";i:88234;s:12:\"delete-88598\";i:88235;s:12:\"delete-88596\";i:88236;s:12:\"delete-88597\";i:88237;s:12:\"delete-88595\";i:88238;s:12:\"delete-88594\";i:88239;s:12:\"delete-88592\";i:88240;s:12:\"delete-88593\";i:88241;s:12:\"delete-88591\";i:88242;s:12:\"delete-88590\";i:88243;s:12:\"delete-88588\";i:88244;s:12:\"delete-88589\";i:88245;s:12:\"delete-88587\";i:88246;s:12:\"delete-88586\";i:88247;s:12:\"delete-88584\";i:88248;s:12:\"delete-88585\";i:88249;s:12:\"delete-88583\";i:88250;s:12:\"delete-88582\";i:88251;s:12:\"delete-88580\";i:88252;s:12:\"delete-88581\";i:88253;s:12:\"delete-88579\";i:88254;s:12:\"delete-88578\";i:88255;s:12:\"delete-88962\";i:88256;s:12:\"delete-88961\";i:88257;s:12:\"delete-88959\";i:88258;s:12:\"delete-88960\";i:88259;s:12:\"delete-88958\";i:88260;s:12:\"delete-88956\";i:88261;s:12:\"delete-88957\";i:88262;s:12:\"delete-88955\";i:88263;s:12:\"delete-88954\";i:88264;s:12:\"delete-88953\";i:88265;s:12:\"delete-88952\";i:88266;s:12:\"delete-88951\";i:88267;s:12:\"delete-88571\";i:88268;s:12:\"delete-88569\";i:88269;s:12:\"delete-88568\";i:88270;s:12:\"delete-88572\";i:88271;s:12:\"delete-88975\";i:88272;s:12:\"delete-89337\";i:88273;s:12:\"delete-89338\";i:88274;s:12:\"delete-89336\";i:88275;s:12:\"delete-89335\";i:88276;s:12:\"delete-89334\";i:88277;s:12:\"delete-89331\";i:88278;s:12:\"delete-89332\";i:88279;s:12:\"delete-88920\";i:88280;s:12:\"delete-89333\";i:88281;s:12:\"delete-89330\";i:88282;s:12:\"delete-89329\";i:88283;s:12:\"delete-89328\";i:88284;s:12:\"delete-89327\";i:88285;s:12:\"delete-89326\";i:88286;s:12:\"delete-89325\";i:88287;s:12:\"delete-89324\";i:88288;s:12:\"delete-89322\";i:88289;s:12:\"delete-89323\";i:88290;s:12:\"delete-89241\";i:88291;s:12:\"delete-89242\";i:88292;s:12:\"delete-89243\";i:88293;s:12:\"delete-89244\";i:88294;s:12:\"delete-89245\";i:88295;s:12:\"delete-89246\";i:88296;s:12:\"delete-89247\";i:88297;s:12:\"delete-89248\";i:88298;s:12:\"delete-89249\";i:88299;s:12:\"delete-89250\";i:88300;s:12:\"delete-89251\";i:88301;s:12:\"delete-89252\";i:88302;s:12:\"delete-89253\";i:88303;s:12:\"delete-89254\";i:88304;s:12:\"delete-89255\";i:88305;s:12:\"delete-89256\";i:88306;s:12:\"delete-89257\";i:88307;s:12:\"delete-89258\";i:88308;s:12:\"delete-89259\";i:88309;s:12:\"delete-89260\";i:88310;s:12:\"delete-89261\";i:88311;s:12:\"delete-89262\";i:88312;s:12:\"delete-89263\";i:88313;s:12:\"delete-89264\";i:88314;s:12:\"delete-89265\";i:88315;s:12:\"delete-89266\";i:88316;s:12:\"delete-89267\";i:88317;s:12:\"delete-89268\";i:88318;s:12:\"delete-89269\";i:88319;s:12:\"delete-89270\";i:88320;s:12:\"delete-89271\";i:88321;s:12:\"delete-89272\";i:88322;s:12:\"delete-89273\";i:88323;s:12:\"delete-89274\";i:88324;s:12:\"delete-89275\";i:88325;s:12:\"delete-89276\";i:88326;s:12:\"delete-89277\";i:88327;s:12:\"delete-89278\";i:88328;s:12:\"delete-89279\";i:88329;s:12:\"delete-89280\";i:88330;s:12:\"delete-89281\";i:88331;s:12:\"delete-89282\";i:88332;s:12:\"delete-89283\";i:88333;s:12:\"delete-89284\";i:88334;s:12:\"delete-89285\";i:88335;s:12:\"delete-89286\";i:88336;s:12:\"delete-89287\";i:88337;s:12:\"delete-89288\";i:88338;s:12:\"delete-89289\";i:88339;s:12:\"delete-89290\";i:88340;s:12:\"delete-89291\";i:88341;s:12:\"delete-89292\";i:88342;s:12:\"delete-89293\";i:88343;s:12:\"delete-89294\";i:88344;s:12:\"delete-89295\";i:88345;s:12:\"delete-89296\";i:88346;s:12:\"delete-89297\";i:88347;s:12:\"delete-89298\";i:88348;s:12:\"delete-89299\";i:88349;s:12:\"delete-89300\";i:88350;s:12:\"delete-89301\";i:88351;s:12:\"delete-89302\";i:88352;s:12:\"delete-89303\";i:88353;s:12:\"delete-89304\";i:88354;s:12:\"delete-89305\";i:88355;s:12:\"delete-89306\";i:88356;s:12:\"delete-89307\";i:88357;s:12:\"delete-89308\";i:88358;s:12:\"delete-89309\";i:88359;s:12:\"delete-89310\";i:88360;s:12:\"delete-89311\";i:88361;s:12:\"delete-89312\";i:88362;s:12:\"delete-89313\";i:88363;s:12:\"delete-89314\";i:88364;s:12:\"delete-89315\";i:88365;s:12:\"delete-89316\";i:88366;s:12:\"delete-89317\";i:88367;s:12:\"delete-89318\";i:88368;s:12:\"delete-89319\";i:88369;s:12:\"delete-89320\";i:88370;s:12:\"delete-89321\";i:88371;s:12:\"delete-89240\";i:88372;s:12:\"delete-89231\";i:88373;s:12:\"delete-89232\";i:88374;s:12:\"delete-89233\";i:88375;s:12:\"delete-89234\";i:88376;s:12:\"delete-89235\";i:88377;s:12:\"delete-89236\";i:88378;s:12:\"delete-89237\";i:88379;s:12:\"delete-89238\";i:88380;s:12:\"delete-89239\";i:88381;s:12:\"delete-89229\";i:88382;s:12:\"delete-89230\";i:88383;s:12:\"delete-89227\";i:88384;s:12:\"delete-89228\";i:88385;s:12:\"delete-89226\";i:88386;s:12:\"delete-89225\";i:88387;s:12:\"delete-89223\";i:88388;s:12:\"delete-89224\";i:88389;s:12:\"delete-89222\";i:88390;s:12:\"delete-89220\";i:88391;s:12:\"delete-89221\";i:88392;s:12:\"delete-89218\";i:88393;s:12:\"delete-89219\";i:88394;s:12:\"delete-89215\";i:88395;s:12:\"delete-89216\";i:88396;s:12:\"delete-89217\";i:88397;s:12:\"delete-89210\";i:88398;s:12:\"delete-89211\";i:88399;s:12:\"delete-89212\";i:88400;s:12:\"delete-89213\";i:88401;s:12:\"delete-89214\";i:88402;s:12:\"delete-89208\";i:88403;s:12:\"delete-89209\";i:88404;s:12:\"delete-89206\";i:88405;s:12:\"delete-89207\";i:88406;s:12:\"delete-89204\";i:88407;s:12:\"delete-89205\";i:88408;s:12:\"delete-89202\";i:88409;s:12:\"delete-89203\";i:88410;s:12:\"delete-89201\";i:88411;s:12:\"delete-89200\";i:88412;s:12:\"delete-89199\";i:88413;s:12:\"delete-89198\";i:88414;s:12:\"delete-89197\";i:88415;s:12:\"delete-89196\";i:88416;s:12:\"delete-89195\";i:88417;s:12:\"delete-89194\";i:88418;s:12:\"delete-89193\";i:88419;s:12:\"delete-89192\";i:88420;s:12:\"delete-89191\";i:88421;s:12:\"delete-89190\";i:88422;s:12:\"delete-89189\";i:88423;s:12:\"delete-89187\";i:88424;s:12:\"delete-89188\";i:88425;s:12:\"delete-89164\";i:88426;s:12:\"delete-89165\";i:88427;s:12:\"delete-89166\";i:88428;s:12:\"delete-89167\";i:88429;s:12:\"delete-89168\";i:88430;s:12:\"delete-89169\";i:88431;s:12:\"delete-89170\";i:88432;s:12:\"delete-89171\";i:88433;s:12:\"delete-89172\";i:88434;s:12:\"delete-89173\";i:88435;s:12:\"delete-89174\";i:88436;s:12:\"delete-89175\";i:88437;s:12:\"delete-89176\";i:88438;s:12:\"delete-89177\";i:88439;s:12:\"delete-89178\";i:88440;s:12:\"delete-89179\";i:88441;s:12:\"delete-89180\";i:88442;s:12:\"delete-89181\";i:88443;s:12:\"delete-89182\";i:88444;s:12:\"delete-89183\";i:88445;s:12:\"delete-89184\";i:88446;s:12:\"delete-89185\";i:88447;s:12:\"delete-89186\";i:88448;s:12:\"delete-89163\";i:88449;s:12:\"delete-89162\";i:88450;s:12:\"delete-89159\";i:88451;s:12:\"delete-89160\";i:88452;s:12:\"delete-89161\";i:88453;s:12:\"delete-89158\";i:88454;s:12:\"delete-89155\";i:88455;s:12:\"delete-89156\";i:88456;s:12:\"delete-89154\";i:88457;s:12:\"delete-89152\";i:88458;s:12:\"delete-89153\";i:88459;s:12:\"delete-89150\";i:88460;s:12:\"delete-89151\";i:88461;s:12:\"delete-89148\";i:88462;s:12:\"delete-89149\";i:88463;s:12:\"delete-89147\";i:88464;s:12:\"delete-89146\";i:88465;s:12:\"delete-89145\";i:88466;s:12:\"delete-89144\";i:88467;s:12:\"delete-89143\";i:88468;s:12:\"delete-89142\";i:88469;s:12:\"delete-89141\";i:88470;s:12:\"delete-89140\";i:88471;s:12:\"delete-89139\";i:88472;s:12:\"delete-89138\";i:88473;s:12:\"delete-89137\";i:88474;s:12:\"delete-89136\";i:88475;s:12:\"delete-89135\";i:88476;s:12:\"delete-89134\";i:88477;s:12:\"delete-89133\";i:88478;s:12:\"delete-89132\";i:88479;s:12:\"delete-89131\";i:88480;s:12:\"delete-89130\";i:88481;s:12:\"delete-89129\";i:88482;s:12:\"delete-89128\";i:88483;s:12:\"delete-89127\";i:88484;s:12:\"delete-89126\";i:88485;s:12:\"delete-89125\";i:88486;s:12:\"delete-89124\";i:88487;s:12:\"delete-89123\";i:88488;s:12:\"delete-89122\";i:88489;s:12:\"delete-89121\";i:88490;s:12:\"delete-89120\";i:88491;s:12:\"delete-89119\";i:88492;s:12:\"delete-89118\";i:88493;s:12:\"delete-89113\";i:88494;s:12:\"delete-89114\";i:88495;s:12:\"delete-89115\";i:88496;s:12:\"delete-89116\";i:88497;s:12:\"delete-89117\";i:88498;s:12:\"delete-89110\";i:88499;s:12:\"delete-89111\";i:88500;s:12:\"delete-89112\";i:88501;s:12:\"delete-89108\";i:88502;s:12:\"delete-89109\";i:88503;s:12:\"delete-89105\";i:88504;s:12:\"delete-89106\";i:88505;s:12:\"delete-89107\";i:88506;s:12:\"delete-89104\";i:88507;s:12:\"delete-89101\";i:88508;s:12:\"delete-89102\";i:88509;s:12:\"delete-89103\";i:88510;s:12:\"delete-89100\";i:88511;s:12:\"delete-89097\";i:88512;s:12:\"delete-89098\";i:88513;s:12:\"delete-89099\";i:88514;s:12:\"delete-89096\";i:88515;s:12:\"delete-89095\";i:88516;s:12:\"delete-89092\";i:88517;s:12:\"delete-89093\";i:88518;s:12:\"delete-89094\";i:88519;s:12:\"delete-89091\";i:88520;s:12:\"delete-89088\";i:88521;s:12:\"delete-89089\";i:88522;s:12:\"delete-89090\";i:88523;s:12:\"delete-89086\";i:88524;s:12:\"delete-89087\";i:88525;s:12:\"delete-89083\";i:88526;s:12:\"delete-89084\";i:88527;s:12:\"delete-89085\";i:88528;s:12:\"delete-89082\";i:88529;s:12:\"delete-89079\";i:88530;s:12:\"delete-89080\";i:88531;s:12:\"delete-89081\";i:88532;s:12:\"delete-89078\";i:88533;s:12:\"delete-89075\";i:88534;s:12:\"delete-89076\";i:88535;s:12:\"delete-89077\";i:88536;s:12:\"delete-89074\";i:88537;s:12:\"delete-89071\";i:88538;s:12:\"delete-89072\";i:88539;s:12:\"delete-89073\";i:88540;s:12:\"delete-89069\";i:88541;s:12:\"delete-89070\";i:88542;s:12:\"delete-89066\";i:88543;s:12:\"delete-89067\";i:88544;s:12:\"delete-89068\";i:88545;s:12:\"delete-89065\";i:88546;s:12:\"delete-89062\";i:88547;s:12:\"delete-89063\";i:88548;s:12:\"delete-89064\";i:88549;s:12:\"delete-89061\";i:88550;s:12:\"delete-89058\";i:88551;s:12:\"delete-89059\";i:88552;s:12:\"delete-89060\";i:88553;s:12:\"delete-89057\";i:88554;s:12:\"delete-89054\";i:88555;s:12:\"delete-89055\";i:88556;s:12:\"delete-89056\";i:88557;s:12:\"delete-89052\";i:88558;s:12:\"delete-89053\";i:88559;s:12:\"delete-89049\";i:88560;s:12:\"delete-89050\";i:88561;s:12:\"delete-89051\";i:88562;s:12:\"delete-89048\";i:88563;s:12:\"delete-89045\";i:88564;s:12:\"delete-89046\";i:88565;s:12:\"delete-89047\";i:88566;s:12:\"delete-89044\";i:88567;s:12:\"delete-89041\";i:88568;s:12:\"delete-89042\";i:88569;s:12:\"delete-89043\";i:88570;s:12:\"delete-89040\";i:88571;s:12:\"delete-89037\";i:88572;s:12:\"delete-89038\";i:88573;s:12:\"delete-89039\";i:88574;s:12:\"delete-89036\";i:88575;s:12:\"delete-89034\";i:88576;s:12:\"delete-89035\";i:88577;s:12:\"delete-89033\";i:88578;s:12:\"delete-89032\";i:88579;s:12:\"delete-89030\";i:88580;s:12:\"delete-89031\";i:88581;s:12:\"delete-89029\";i:88582;s:12:\"delete-89028\";i:88583;s:12:\"delete-89026\";i:88584;s:12:\"delete-89027\";i:88585;s:12:\"delete-89025\";i:88586;s:12:\"delete-89024\";i:88587;s:12:\"delete-89022\";i:88588;s:12:\"delete-89023\";i:88589;s:12:\"delete-89021\";i:88590;s:12:\"delete-89020\";i:88591;s:12:\"delete-89018\";i:88592;s:12:\"delete-89019\";i:88593;s:12:\"delete-89017\";i:88594;s:12:\"delete-89016\";i:88595;s:12:\"delete-89014\";i:88596;s:12:\"delete-89015\";i:88597;s:12:\"delete-89013\";i:88598;s:12:\"delete-89012\";i:88599;s:12:\"delete-89010\";i:88600;s:12:\"delete-89011\";i:88601;s:12:\"delete-89009\";i:88602;s:12:\"delete-89008\";i:88603;s:12:\"delete-89006\";i:88604;s:12:\"delete-89007\";i:88605;s:12:\"delete-89005\";i:88606;s:12:\"delete-89004\";i:88607;s:12:\"delete-89003\";i:88608;s:12:\"delete-89002\";i:88609;s:12:\"delete-89000\";i:88610;s:12:\"delete-89001\";i:88611;s:12:\"delete-88998\";i:88612;s:12:\"delete-88999\";i:88613;s:12:\"delete-88997\";i:88614;s:12:\"delete-88996\";i:88615;s:12:\"delete-88994\";i:88616;s:12:\"delete-88995\";i:88617;s:12:\"delete-88993\";i:88618;s:12:\"delete-88992\";i:88619;s:12:\"delete-88990\";i:88620;s:12:\"delete-88991\";i:88621;s:12:\"delete-88989\";i:88622;s:12:\"delete-88988\";i:88623;s:12:\"delete-88986\";i:88624;s:12:\"delete-88987\";i:88625;s:12:\"delete-88985\";i:88626;s:12:\"delete-88984\";i:88627;s:12:\"delete-88982\";i:88628;s:12:\"delete-88983\";i:88629;s:12:\"delete-88981\";i:88630;s:12:\"delete-88980\";i:88631;s:12:\"delete-88978\";i:88632;s:12:\"delete-88979\";i:88633;s:12:\"delete-88977\";i:88634;s:12:\"delete-88976\";i:88635;s:12:\"delete-89157\";i:88636;s:12:\"delete-88973\";i:88637;s:12:\"delete-88974\";i:88638;s:12:\"delete-88971\";i:88639;s:12:\"delete-88972\";i:88640;s:12:\"delete-88970\";i:88641;s:12:\"delete-88968\";i:88642;s:12:\"delete-88969\";i:88643;s:12:\"delete-88967\";i:88644;s:12:\"delete-88965\";i:88645;s:12:\"delete-88966\";i:88646;s:12:\"delete-89356\";i:88647;s:12:\"delete-89357\";i:88648;s:12:\"delete-89358\";i:88649;s:12:\"delete-89359\";i:88650;s:12:\"delete-89360\";i:88651;s:12:\"delete-89440\";i:88652;s:12:\"delete-89441\";i:88653;s:12:\"delete-89438\";i:88654;s:12:\"delete-89439\";i:88655;s:12:\"delete-89433\";i:88656;s:12:\"delete-89434\";i:88657;s:12:\"delete-89435\";i:88658;s:12:\"delete-89436\";i:88659;s:12:\"delete-89437\";i:88660;s:12:\"delete-89431\";i:88661;s:12:\"delete-89432\";i:88662;s:12:\"delete-89426\";i:88663;s:12:\"delete-89427\";i:88664;s:12:\"delete-89428\";i:88665;s:12:\"delete-89429\";i:88666;s:12:\"delete-89430\";i:88667;s:12:\"delete-89424\";i:88668;s:12:\"delete-89425\";i:88669;s:12:\"delete-89420\";i:88670;s:12:\"delete-89421\";i:88671;s:12:\"delete-89422\";i:88672;s:12:\"delete-89423\";i:88673;s:12:\"delete-89418\";i:88674;s:12:\"delete-89419\";i:88675;s:12:\"delete-89414\";i:88676;s:12:\"delete-89415\";i:88677;s:12:\"delete-89416\";i:88678;s:12:\"delete-89417\";i:88679;s:12:\"delete-89412\";i:88680;s:12:\"delete-89413\";i:88681;s:12:\"delete-89408\";i:88682;s:12:\"delete-89409\";i:88683;s:12:\"delete-89410\";i:88684;s:12:\"delete-89411\";i:88685;s:12:\"delete-89406\";i:88686;s:12:\"delete-89407\";i:88687;s:12:\"delete-89404\";i:88688;s:12:\"delete-89405\";i:88689;s:12:\"delete-89399\";i:88690;s:12:\"delete-89400\";i:88691;s:12:\"delete-89401\";i:88692;s:12:\"delete-89402\";i:88693;s:12:\"delete-89403\";i:88694;s:12:\"delete-89395\";i:88695;s:12:\"delete-89396\";i:88696;s:12:\"delete-89397\";i:88697;s:12:\"delete-89398\";i:88698;s:12:\"delete-89393\";i:88699;s:12:\"delete-89394\";i:88700;s:12:\"delete-89389\";i:88701;s:12:\"delete-89390\";i:88702;s:12:\"delete-89391\";i:88703;s:12:\"delete-89392\";i:88704;s:12:\"delete-89387\";i:88705;s:12:\"delete-89388\";i:88706;s:12:\"delete-89383\";i:88707;s:12:\"delete-89384\";i:88708;s:12:\"delete-89385\";i:88709;s:12:\"delete-89386\";i:88710;s:12:\"delete-89381\";i:88711;s:12:\"delete-89382\";i:88712;s:12:\"delete-89377\";i:88713;s:12:\"delete-89378\";i:88714;s:12:\"delete-89379\";i:88715;s:12:\"delete-89380\";i:88716;s:12:\"delete-89375\";i:88717;s:12:\"delete-89376\";i:88718;s:12:\"delete-89371\";i:88719;s:12:\"delete-89372\";i:88720;s:12:\"delete-89373\";i:88721;s:12:\"delete-89374\";i:88722;s:12:\"delete-89369\";i:88723;s:12:\"delete-89370\";i:88724;s:12:\"delete-89364\";i:88725;s:12:\"delete-89365\";i:88726;s:12:\"delete-89366\";i:88727;s:12:\"delete-89367\";i:88728;s:12:\"delete-89368\";i:88729;s:12:\"delete-89362\";i:88730;s:12:\"delete-89363\";i:88731;s:12:\"delete-89361\";i:88732;s:12:\"delete-89355\";i:88733;s:12:\"delete-89349\";i:88734;s:12:\"delete-89350\";i:88735;s:12:\"delete-89351\";i:88736;s:12:\"delete-89352\";i:88737;s:12:\"delete-89353\";i:88738;s:12:\"delete-89354\";i:88739;s:12:\"delete-89348\";i:88740;s:12:\"delete-89344\";i:88741;s:12:\"delete-89345\";i:88742;s:12:\"delete-89347\";i:88743;s:12:\"delete-89346\";i:88744;s:12:\"delete-89339\";i:88745;s:12:\"delete-89340\";i:88746;s:12:\"delete-89341\";i:88747;s:12:\"delete-89342\";i:88748;s:12:\"delete-89343\";i:88749;s:12:\"delete-89821\";i:88750;s:12:\"delete-89822\";i:88751;s:12:\"delete-89823\";i:88752;s:12:\"delete-89824\";i:88753;s:12:\"delete-89825\";i:88754;s:12:\"delete-89826\";i:88755;s:12:\"delete-89827\";i:88756;s:12:\"delete-89819\";i:88757;s:12:\"delete-89820\";i:88758;s:12:\"delete-89818\";i:88759;s:12:\"delete-89817\";i:88760;s:12:\"delete-89815\";i:88761;s:12:\"delete-89816\";i:88762;s:12:\"delete-89814\";i:88763;s:12:\"delete-89813\";i:88764;s:12:\"delete-89828\";i:88765;s:12:\"delete-89829\";i:88766;s:12:\"delete-89830\";i:88767;s:12:\"delete-89831\";i:88768;s:12:\"delete-89832\";i:88769;s:12:\"delete-89833\";i:88770;s:12:\"delete-89834\";i:88771;s:12:\"delete-89835\";i:88772;s:12:\"delete-89836\";i:88773;s:12:\"delete-89837\";i:88774;s:12:\"delete-89838\";i:88775;s:12:\"delete-89839\";i:88776;s:12:\"delete-89812\";i:88777;s:12:\"delete-89811\";i:88778;s:12:\"delete-89810\";i:88779;s:12:\"delete-89808\";i:88780;s:12:\"delete-89809\";i:88781;s:12:\"delete-89807\";i:88782;s:12:\"delete-89806\";i:88783;s:12:\"delete-89725\";i:88784;s:12:\"delete-89726\";i:88785;s:12:\"delete-89727\";i:88786;s:12:\"delete-89728\";i:88787;s:12:\"delete-89729\";i:88788;s:12:\"delete-89730\";i:88789;s:12:\"delete-89731\";i:88790;s:12:\"delete-89732\";i:88791;s:12:\"delete-89733\";i:88792;s:12:\"delete-89734\";i:88793;s:12:\"delete-89735\";i:88794;s:12:\"delete-89736\";i:88795;s:12:\"delete-89737\";i:88796;s:12:\"delete-89738\";i:88797;s:12:\"delete-89739\";i:88798;s:12:\"delete-89740\";i:88799;s:12:\"delete-89741\";i:88800;s:12:\"delete-89742\";i:88801;s:12:\"delete-89743\";i:88802;s:12:\"delete-89744\";i:88803;s:12:\"delete-89745\";i:88804;s:12:\"delete-89746\";i:88805;s:12:\"delete-89747\";i:88806;s:12:\"delete-89748\";i:88807;s:12:\"delete-89749\";i:88808;s:12:\"delete-89750\";i:88809;s:12:\"delete-89751\";i:88810;s:12:\"delete-89752\";i:88811;s:12:\"delete-89753\";i:88812;s:12:\"delete-89754\";i:88813;s:12:\"delete-89755\";i:88814;s:12:\"delete-89756\";i:88815;s:12:\"delete-89757\";i:88816;s:12:\"delete-89758\";i:88817;s:12:\"delete-89759\";i:88818;s:12:\"delete-89760\";i:88819;s:12:\"delete-89761\";i:88820;s:12:\"delete-89762\";i:88821;s:12:\"delete-89763\";i:88822;s:12:\"delete-89764\";i:88823;s:12:\"delete-89765\";i:88824;s:12:\"delete-89766\";i:88825;s:12:\"delete-89767\";i:88826;s:12:\"delete-89768\";i:88827;s:12:\"delete-89769\";i:88828;s:12:\"delete-89770\";i:88829;s:12:\"delete-89771\";i:88830;s:12:\"delete-89772\";i:88831;s:12:\"delete-89773\";i:88832;s:12:\"delete-89774\";i:88833;s:12:\"delete-89775\";i:88834;s:12:\"delete-89776\";i:88835;s:12:\"delete-89777\";i:88836;s:12:\"delete-89778\";i:88837;s:12:\"delete-89779\";i:88838;s:12:\"delete-89780\";i:88839;s:12:\"delete-89781\";i:88840;s:12:\"delete-89782\";i:88841;s:12:\"delete-89783\";i:88842;s:12:\"delete-89784\";i:88843;s:12:\"delete-89785\";i:88844;s:12:\"delete-89786\";i:88845;s:12:\"delete-89787\";i:88846;s:12:\"delete-89788\";i:88847;s:12:\"delete-89789\";i:88848;s:12:\"delete-89790\";i:88849;s:12:\"delete-89791\";i:88850;s:12:\"delete-89792\";i:88851;s:12:\"delete-89793\";i:88852;s:12:\"delete-89794\";i:88853;s:12:\"delete-89795\";i:88854;s:12:\"delete-89796\";i:88855;s:12:\"delete-89797\";i:88856;s:12:\"delete-89798\";i:88857;s:12:\"delete-89799\";i:88858;s:12:\"delete-89800\";i:88859;s:12:\"delete-89801\";i:88860;s:12:\"delete-89802\";i:88861;s:12:\"delete-89803\";i:88862;s:12:\"delete-89804\";i:88863;s:12:\"delete-89805\";i:88864;s:12:\"delete-89713\";i:88865;s:12:\"delete-89714\";i:88866;s:12:\"delete-89715\";i:88867;s:12:\"delete-89716\";i:88868;s:12:\"delete-89717\";i:88869;s:12:\"delete-89718\";i:88870;s:12:\"delete-89719\";i:88871;s:12:\"delete-89720\";i:88872;s:12:\"delete-89721\";i:88873;s:12:\"delete-89722\";i:88874;s:12:\"delete-89723\";i:88875;s:12:\"delete-89724\";i:88876;s:12:\"delete-89711\";i:88877;s:12:\"delete-89712\";i:88878;s:12:\"delete-89708\";i:88879;s:12:\"delete-89709\";i:88880;s:12:\"delete-89710\";i:88881;s:12:\"delete-89707\";i:88882;s:12:\"delete-89706\";i:88883;s:12:\"delete-89703\";i:88884;s:12:\"delete-89704\";i:88885;s:12:\"delete-89705\";i:88886;s:12:\"delete-89701\";i:88887;s:12:\"delete-89702\";i:88888;s:12:\"delete-89699\";i:88889;s:12:\"delete-89700\";i:88890;s:12:\"delete-89691\";i:88891;s:12:\"delete-89692\";i:88892;s:12:\"delete-89693\";i:88893;s:12:\"delete-89698\";i:88894;s:12:\"delete-89697\";i:88895;s:12:\"delete-89696\";i:88896;s:12:\"delete-89695\";i:88897;s:12:\"delete-89694\";i:88898;s:12:\"delete-89690\";i:88899;s:12:\"delete-89689\";i:88900;s:12:\"delete-89688\";i:88901;s:12:\"delete-89687\";i:88902;s:12:\"delete-89686\";i:88903;s:12:\"delete-89685\";i:88904;s:12:\"delete-89684\";i:88905;s:12:\"delete-89683\";i:88906;s:12:\"delete-89682\";i:88907;s:12:\"delete-89681\";i:88908;s:12:\"delete-89680\";i:88909;s:12:\"delete-89679\";i:88910;s:12:\"delete-89678\";i:88911;s:12:\"delete-89677\";i:88912;s:12:\"delete-89676\";i:88913;s:12:\"delete-89675\";i:88914;s:12:\"delete-89674\";i:88915;s:12:\"delete-89673\";i:88916;s:12:\"delete-89672\";i:88917;s:12:\"delete-89671\";i:88918;s:12:\"delete-89670\";i:88919;s:12:\"delete-89669\";i:88920;s:12:\"delete-89645\";i:88921;s:12:\"delete-89646\";i:88922;s:12:\"delete-89647\";i:88923;s:12:\"delete-89648\";i:88924;s:12:\"delete-89649\";i:88925;s:12:\"delete-89650\";i:88926;s:12:\"delete-89651\";i:88927;s:12:\"delete-89652\";i:88928;s:12:\"delete-89653\";i:88929;s:12:\"delete-89654\";i:88930;s:12:\"delete-89655\";i:88931;s:12:\"delete-89656\";i:88932;s:12:\"delete-89657\";i:88933;s:12:\"delete-89658\";i:88934;s:12:\"delete-89659\";i:88935;s:12:\"delete-89660\";i:88936;s:12:\"delete-89661\";i:88937;s:12:\"delete-89662\";i:88938;s:12:\"delete-89663\";i:88939;s:12:\"delete-89664\";i:88940;s:12:\"delete-89665\";i:88941;s:12:\"delete-89666\";i:88942;s:12:\"delete-89667\";i:88943;s:12:\"delete-89668\";i:88944;s:12:\"delete-89644\";i:88945;s:12:\"delete-89643\";i:88946;s:12:\"delete-89642\";i:88947;s:12:\"delete-89639\";i:88948;s:12:\"delete-89640\";i:88949;s:12:\"delete-89641\";i:88950;s:12:\"delete-89453\";i:88951;s:12:\"delete-89507\";i:88952;s:12:\"delete-89506\";i:88953;s:12:\"delete-88947\";i:88954;s:12:\"delete-89636\";i:88955;s:12:\"delete-89638\";i:88956;s:12:\"delete-89637\";i:88957;s:12:\"delete-89634\";i:88958;s:12:\"delete-89635\";i:88959;s:12:\"delete-89632\";i:88960;s:12:\"delete-89633\";i:88961;s:12:\"delete-89631\";i:88962;s:12:\"delete-89630\";i:88963;s:12:\"delete-89629\";i:88964;s:12:\"delete-89628\";i:88965;s:12:\"delete-89627\";i:88966;s:12:\"delete-89626\";i:88967;s:12:\"delete-89625\";i:88968;s:12:\"delete-89624\";i:88969;s:12:\"delete-89623\";i:88970;s:12:\"delete-89622\";i:88971;s:12:\"delete-89621\";i:88972;s:12:\"delete-89620\";i:88973;s:12:\"delete-89619\";i:88974;s:12:\"delete-89618\";i:88975;s:12:\"delete-89616\";i:88976;s:12:\"delete-89617\";i:88977;s:12:\"delete-89615\";i:88978;s:12:\"delete-89614\";i:88979;s:12:\"delete-89613\";i:88980;s:12:\"delete-89612\";i:88981;s:12:\"delete-89611\";i:88982;s:12:\"delete-89610\";i:88983;s:12:\"delete-89609\";i:88984;s:12:\"delete-89608\";i:88985;s:12:\"delete-89607\";i:88986;s:12:\"delete-89606\";i:88987;s:12:\"delete-89605\";i:88988;s:12:\"delete-89604\";i:88989;s:12:\"delete-89603\";i:88990;s:12:\"delete-89593\";i:88991;s:12:\"delete-89594\";i:88992;s:12:\"delete-89595\";i:88993;s:12:\"delete-89596\";i:88994;s:12:\"delete-89597\";i:88995;s:12:\"delete-89598\";i:88996;s:12:\"delete-89599\";i:88997;s:12:\"delete-89600\";i:88998;s:12:\"delete-89601\";i:88999;s:12:\"delete-89602\";i:89000;s:12:\"delete-89588\";i:89001;s:12:\"delete-89589\";i:89002;s:12:\"delete-89590\";i:89003;s:12:\"delete-89592\";i:89004;s:12:\"delete-89591\";i:89005;s:12:\"delete-89587\";i:89006;s:12:\"delete-89586\";i:89007;s:12:\"delete-89584\";i:89008;s:12:\"delete-89585\";i:89009;s:12:\"delete-89581\";i:89010;s:12:\"delete-89582\";i:89011;s:12:\"delete-89583\";i:89012;s:12:\"delete-89580\";i:89013;s:12:\"delete-89577\";i:89014;s:12:\"delete-89578\";i:89015;s:12:\"delete-89579\";i:89016;s:12:\"delete-89576\";i:89017;s:12:\"delete-89575\";i:89018;s:12:\"delete-89572\";i:89019;s:12:\"delete-89573\";i:89020;s:12:\"delete-89574\";i:89021;s:12:\"delete-89571\";i:89022;s:12:\"delete-89566\";i:89023;s:12:\"delete-89567\";i:89024;s:12:\"delete-89568\";i:89025;s:12:\"delete-89570\";i:89026;s:12:\"delete-89569\";i:89027;s:12:\"delete-89565\";i:89028;s:12:\"delete-89564\";i:89029;s:12:\"delete-89563\";i:89030;s:12:\"delete-89562\";i:89031;s:12:\"delete-89559\";i:89032;s:12:\"delete-89560\";i:89033;s:12:\"delete-89561\";i:89034;s:12:\"delete-89558\";i:89035;s:12:\"delete-89555\";i:89036;s:12:\"delete-89556\";i:89037;s:12:\"delete-89557\";i:89038;s:12:\"delete-89554\";i:89039;s:12:\"delete-89549\";i:89040;s:12:\"delete-89550\";i:89041;s:12:\"delete-89551\";i:89042;s:12:\"delete-89553\";i:89043;s:12:\"delete-89552\";i:89044;s:12:\"delete-89548\";i:89045;s:12:\"delete-89547\";i:89046;s:12:\"delete-89546\";i:89047;s:12:\"delete-89545\";i:89048;s:12:\"delete-89542\";i:89049;s:12:\"delete-89543\";i:89050;s:12:\"delete-89544\";i:89051;s:12:\"delete-89541\";i:89052;s:12:\"delete-89538\";i:89053;s:12:\"delete-89539\";i:89054;s:12:\"delete-89540\";i:89055;s:12:\"delete-89537\";i:89056;s:12:\"delete-89532\";i:89057;s:12:\"delete-89533\";i:89058;s:12:\"delete-89534\";i:89059;s:12:\"delete-89536\";i:89060;s:12:\"delete-89535\";i:89061;s:12:\"delete-89531\";i:89062;s:12:\"delete-89530\";i:89063;s:12:\"delete-89528\";i:89064;s:12:\"delete-89529\";i:89065;s:12:\"delete-89525\";i:89066;s:12:\"delete-89526\";i:89067;s:12:\"delete-89527\";i:89068;s:12:\"delete-89524\";i:89069;s:12:\"delete-89521\";i:89070;s:12:\"delete-89522\";i:89071;s:12:\"delete-89523\";i:89072;s:12:\"delete-89520\";i:89073;s:12:\"delete-89517\";i:89074;s:12:\"delete-89518\";i:89075;s:12:\"delete-89519\";i:89076;s:12:\"delete-89514\";i:89077;s:12:\"delete-89515\";i:89078;s:12:\"delete-89516\";i:89079;s:12:\"delete-89512\";i:89080;s:12:\"delete-89513\";i:89081;s:12:\"delete-89509\";i:89082;s:12:\"delete-89510\";i:89083;s:12:\"delete-89511\";i:89084;s:12:\"delete-89508\";i:89085;s:12:\"delete-89503\";i:89086;s:12:\"delete-89504\";i:89087;s:12:\"delete-89505\";i:89088;s:12:\"delete-89499\";i:89089;s:12:\"delete-89502\";i:89090;s:12:\"delete-89501\";i:89091;s:12:\"delete-89500\";i:89092;s:12:\"delete-89495\";i:89093;s:12:\"delete-89498\";i:89094;s:12:\"delete-89497\";i:89095;s:12:\"delete-89496\";i:89096;s:12:\"delete-89494\";i:89097;s:12:\"delete-89490\";i:89098;s:12:\"delete-89493\";i:89099;s:12:\"delete-89492\";i:89100;s:12:\"delete-89491\";i:89101;s:12:\"delete-89487\";i:89102;s:12:\"delete-89489\";i:89103;s:12:\"delete-89484\";i:89104;s:12:\"delete-89488\";i:89105;s:12:\"delete-89483\";i:89106;s:12:\"delete-89486\";i:89107;s:12:\"delete-89485\";i:89108;s:12:\"delete-89482\";i:89109;s:12:\"delete-89478\";i:89110;s:12:\"delete-89481\";i:89111;s:12:\"delete-89480\";i:89112;s:12:\"delete-89479\";i:89113;s:12:\"delete-89477\";i:89114;s:12:\"delete-89476\";i:89115;s:12:\"delete-89475\";i:89116;s:12:\"delete-89474\";i:89117;s:12:\"delete-89473\";i:89118;s:12:\"delete-89472\";i:89119;s:12:\"delete-89471\";i:89120;s:12:\"delete-89470\";i:89121;s:12:\"delete-89467\";i:89122;s:12:\"delete-89469\";i:89123;s:12:\"delete-89468\";i:89124;s:12:\"delete-89464\";i:89125;s:12:\"delete-89466\";i:89126;s:12:\"delete-89462\";i:89127;s:12:\"delete-89465\";i:89128;s:12:\"delete-89460\";i:89129;s:12:\"delete-89461\";i:89130;s:12:\"delete-89463\";i:89131;s:12:\"delete-89456\";i:89132;s:12:\"delete-89459\";i:89133;s:12:\"delete-89458\";i:89134;s:12:\"delete-89457\";i:89135;s:12:\"delete-89454\";i:89136;s:12:\"delete-88577\";i:89137;s:12:\"delete-88573\";i:89138;s:12:\"delete-88574\";i:89139;s:12:\"delete-88575\";i:89140;s:12:\"delete-88576\";i:89141;s:12:\"delete-88570\";i:89142;s:12:\"delete-89455\";i:89143;s:12:\"delete-89449\";i:89144;s:12:\"delete-89452\";i:89145;s:12:\"delete-89451\";i:89146;s:12:\"delete-89450\";i:89147;s:12:\"delete-89448\";i:89148;s:12:\"delete-89442\";i:89149;s:12:\"delete-89443\";i:89150;s:12:\"delete-89444\";i:89151;s:12:\"delete-88567\";i:89152;s:12:\"delete-89447\";i:89153;s:12:\"delete-89446\";i:89154;s:12:\"delete-89445\";i:89155;s:12:\"delete-89934\";i:89156;s:12:\"delete-89940\";i:89157;s:12:\"delete-89951\";i:89158;s:12:\"delete-89954\";i:89159;s:12:\"delete-89955\";i:89160;s:12:\"delete-89956\";i:89161;s:12:\"delete-89957\";i:89162;s:12:\"delete-89958\";i:89163;s:12:\"delete-89959\";i:89164;s:12:\"delete-89960\";i:89165;s:12:\"delete-89961\";i:89166;s:12:\"delete-89962\";i:89167;s:12:\"delete-89963\";i:89168;s:12:\"delete-89964\";i:89169;s:12:\"delete-89965\";i:89170;s:12:\"delete-90022\";i:89171;s:12:\"delete-89966\";i:89172;s:12:\"delete-89967\";i:89173;s:12:\"delete-89968\";i:89174;s:12:\"delete-89969\";i:89175;s:12:\"delete-89953\";i:89176;s:12:\"delete-89952\";i:89177;s:12:\"delete-90020\";i:89178;s:12:\"delete-90021\";i:89179;s:12:\"delete-90009\";i:89180;s:12:\"delete-90010\";i:89181;s:12:\"delete-90011\";i:89182;s:12:\"delete-90012\";i:89183;s:12:\"delete-90013\";i:89184;s:12:\"delete-90014\";i:89185;s:12:\"delete-90015\";i:89186;s:12:\"delete-90016\";i:89187;s:12:\"delete-90019\";i:89188;s:12:\"delete-90007\";i:89189;s:12:\"delete-90008\";i:89190;s:12:\"delete-90004\";i:89191;s:12:\"delete-90005\";i:89192;s:12:\"delete-90006\";i:89193;s:12:\"delete-89996\";i:89194;s:12:\"delete-89997\";i:89195;s:12:\"delete-89998\";i:89196;s:12:\"delete-89999\";i:89197;s:12:\"delete-90000\";i:89198;s:12:\"delete-90001\";i:89199;s:12:\"delete-90002\";i:89200;s:12:\"delete-90003\";i:89201;s:12:\"delete-89995\";i:89202;s:12:\"delete-89992\";i:89203;s:12:\"delete-89993\";i:89204;s:12:\"delete-89994\";i:89205;s:12:\"delete-89991\";i:89206;s:12:\"delete-89989\";i:89207;s:12:\"delete-89990\";i:89208;s:12:\"delete-89987\";i:89209;s:12:\"delete-89988\";i:89210;s:12:\"delete-89985\";i:89211;s:12:\"delete-89986\";i:89212;s:12:\"delete-89983\";i:89213;s:12:\"delete-89984\";i:89214;s:12:\"delete-89981\";i:89215;s:12:\"delete-89982\";i:89216;s:12:\"delete-89980\";i:89217;s:12:\"delete-89978\";i:89218;s:12:\"delete-89979\";i:89219;s:12:\"delete-89977\";i:89220;s:12:\"delete-89970\";i:89221;s:12:\"delete-89971\";i:89222;s:12:\"delete-89972\";i:89223;s:12:\"delete-89973\";i:89224;s:12:\"delete-89974\";i:89225;s:12:\"delete-89975\";i:89226;s:12:\"delete-89976\";i:89227;s:12:\"delete-89938\";i:89228;s:12:\"delete-89939\";i:89229;s:12:\"delete-88159\";i:89230;s:12:\"delete-88160\";i:89231;s:12:\"delete-88161\";i:89232;s:12:\"delete-88162\";i:89233;s:12:\"delete-89933\";i:89234;s:12:\"delete-89935\";i:89235;s:12:\"delete-89937\";i:89236;s:12:\"delete-89936\";i:89237;s:12:\"delete-89930\";i:89238;s:12:\"delete-89931\";i:89239;s:12:\"delete-89932\";i:89240;s:12:\"delete-88158\";i:89241;s:12:\"delete-90033\";i:89242;s:12:\"delete-90034\";i:89243;s:12:\"delete-90036\";i:89244;s:12:\"delete-90037\";i:89245;s:12:\"delete-90040\";i:89246;s:12:\"delete-90041\";i:89247;s:12:\"delete-90043\";i:89248;s:12:\"delete-90044\";i:89249;s:12:\"delete-90031\";i:89250;s:12:\"delete-90032\";i:89251;s:12:\"delete-90035\";i:89252;s:12:\"delete-90038\";i:89253;s:12:\"delete-90039\";i:89254;s:12:\"delete-90042\";i:89255;s:12:\"delete-89917\";i:89256;s:12:\"delete-89918\";i:89257;s:12:\"delete-89925\";i:89258;s:12:\"delete-89924\";i:89259;s:12:\"delete-89899\";i:89260;s:12:\"delete-89898\";i:89261;s:12:\"delete-89897\";i:89262;s:12:\"delete-89896\";i:89263;s:12:\"delete-89895\";i:89264;s:12:\"delete-89894\";i:89265;s:12:\"delete-89893\";i:89266;s:12:\"delete-89892\";i:89267;s:12:\"delete-89891\";i:89268;s:12:\"delete-89889\";i:89269;s:12:\"delete-89900\";i:89270;s:12:\"delete-89901\";i:89271;s:12:\"delete-89902\";i:89272;s:12:\"delete-89911\";i:89273;s:12:\"delete-89912\";i:89274;s:12:\"delete-89909\";i:89275;s:12:\"delete-89910\";i:89276;s:12:\"delete-89908\";i:89277;s:12:\"delete-89907\";i:89278;s:12:\"delete-89906\";i:89279;s:12:\"delete-89905\";i:89280;s:12:\"delete-89904\";i:89281;s:12:\"delete-89903\";i:89282;s:12:\"delete-89890\";i:89283;s:12:\"delete-89888\";i:89284;s:12:\"delete-89887\";i:89285;s:12:\"delete-89946\";i:89286;s:12:\"delete-89941\";i:89287;s:12:\"delete-89942\";i:89288;s:12:\"delete-89943\";i:89289;s:12:\"delete-89944\";i:89290;s:12:\"delete-89945\";i:89291;s:12:\"delete-90018\";i:89292;s:12:\"delete-89928\";i:89293;s:12:\"delete-89929\";i:89294;s:12:\"delete-89926\";i:89295;s:12:\"delete-89927\";i:89296;s:12:\"delete-89850\";i:89297;s:12:\"delete-89947\";i:89298;s:12:\"delete-89950\";i:89299;s:12:\"delete-89886\";i:89300;s:12:\"delete-89885\";i:89301;s:12:\"delete-89884\";i:89302;s:12:\"delete-89882\";i:89303;s:12:\"delete-89883\";i:89304;s:12:\"delete-90030\";i:89305;s:12:\"delete-90029\";i:89306;s:12:\"delete-90026\";i:89307;s:12:\"delete-90027\";i:89308;s:12:\"delete-90028\";i:89309;s:12:\"delete-89948\";i:89310;s:12:\"delete-89949\";i:89311;s:12:\"delete-89849\";i:89312;s:12:\"delete-89881\";i:89313;s:12:\"delete-89872\";i:89314;s:12:\"delete-89865\";i:89315;s:12:\"delete-89866\";i:89316;s:12:\"delete-89864\";i:89317;s:12:\"delete-89863\";i:89318;s:12:\"delete-89847\";i:89319;s:12:\"delete-89848\";i:89320;s:12:\"delete-89862\";i:89321;s:12:\"delete-89861\";i:89322;s:12:\"delete-89860\";i:89323;s:12:\"delete-89859\";i:89324;s:12:\"delete-89871\";i:89325;s:12:\"delete-89870\";i:89326;s:12:\"delete-89879\";i:89327;s:12:\"delete-89880\";i:89328;s:12:\"delete-89877\";i:89329;s:12:\"delete-89878\";i:89330;s:12:\"delete-89876\";i:89331;s:12:\"delete-89874\";i:89332;s:12:\"delete-89875\";i:89333;s:12:\"delete-89873\";i:89334;s:12:\"delete-89867\";i:89335;s:12:\"delete-89868\";i:89336;s:12:\"delete-89869\";i:89337;s:12:\"delete-89858\";i:89338;s:12:\"delete-89857\";i:89339;s:12:\"delete-89856\";i:89340;s:12:\"delete-89840\";i:89341;s:12:\"delete-89841\";i:89342;s:12:\"delete-90024\";i:89343;s:12:\"delete-89923\";i:89344;s:12:\"delete-89922\";i:89345;s:12:\"delete-89921\";i:89346;s:12:\"delete-89920\";i:89347;s:12:\"delete-89919\";i:89348;s:12:\"delete-89915\";i:89349;s:12:\"delete-89916\";i:89350;s:12:\"delete-89913\";i:89351;s:12:\"delete-90017\";i:89352;s:12:\"delete-90025\";i:89353;s:12:\"delete-89855\";i:89354;s:12:\"delete-89854\";i:89355;s:12:\"delete-89853\";i:89356;s:12:\"delete-89851\";i:89357;s:12:\"delete-89852\";i:89358;s:12:\"delete-89846\";i:89359;s:12:\"delete-89845\";i:89360;s:12:\"delete-89844\";i:89361;s:12:\"delete-90023\";i:89362;s:12:\"delete-89843\";i:89363;s:12:\"delete-89842\";i:89364;s:12:\"delete-89914\";i:89365;s:12:\"delete-90045\";i:89366;s:12:\"delete-90071\";i:89367;s:12:\"delete-90070\";i:89368;s:12:\"delete-90069\";i:89369;s:12:\"delete-90068\";i:89370;s:12:\"delete-90067\";i:89371;s:12:\"delete-90066\";i:89372;s:12:\"delete-90065\";i:89373;s:12:\"delete-90072\";i:89374;s:12:\"delete-90073\";i:89375;s:12:\"delete-90074\";i:89376;s:12:\"delete-90075\";i:89377;s:12:\"delete-90076\";i:89378;s:12:\"delete-90077\";i:89379;s:12:\"delete-90078\";i:89380;s:12:\"delete-90079\";i:89381;s:12:\"delete-90080\";i:89382;s:12:\"delete-90081\";i:89383;s:12:\"delete-90064\";i:89384;s:12:\"delete-90063\";i:89385;s:12:\"delete-90046\";i:89386;s:12:\"delete-90047\";i:89387;s:12:\"delete-90048\";i:89388;s:12:\"delete-90049\";i:89389;s:12:\"delete-90050\";i:89390;s:12:\"delete-90051\";i:89391;s:12:\"delete-90052\";i:89392;s:12:\"delete-90053\";i:89393;s:12:\"delete-90054\";i:89394;s:12:\"delete-90055\";i:89395;s:12:\"delete-90056\";i:89396;s:12:\"delete-90057\";i:89397;s:12:\"delete-90058\";i:89398;s:12:\"delete-90059\";i:89399;s:12:\"delete-90060\";i:89400;s:12:\"delete-90061\";i:89401;s:12:\"delete-90062\";i:89402;s:12:\"delete-90082\";i:89403;s:12:\"delete-90111\";i:89404;s:12:\"delete-90110\";i:89405;s:12:\"delete-90109\";i:89406;s:12:\"delete-90108\";i:89407;s:12:\"delete-90107\";i:89408;s:12:\"delete-90106\";i:89409;s:12:\"delete-90105\";i:89410;s:12:\"delete-90104\";i:89411;s:12:\"delete-90103\";i:89412;s:12:\"delete-90102\";i:89413;s:12:\"delete-90101\";i:89414;s:12:\"delete-90100\";i:89415;s:12:\"delete-90099\";i:89416;s:12:\"delete-90098\";i:89417;s:12:\"delete-90097\";i:89418;s:12:\"delete-90096\";i:89419;s:12:\"delete-90095\";i:89420;s:12:\"delete-90094\";i:89421;s:12:\"delete-90093\";i:89422;s:12:\"delete-90092\";i:89423;s:12:\"delete-90091\";i:89424;s:12:\"delete-90090\";i:89425;s:12:\"delete-90089\";i:89426;s:12:\"delete-90088\";i:89427;s:12:\"delete-90087\";i:89428;s:12:\"delete-90086\";i:89429;s:12:\"delete-90085\";i:89430;s:12:\"delete-90084\";i:89431;s:12:\"delete-90226\";i:89432;s:12:\"delete-90235\";i:89433;s:12:\"delete-90234\";i:89434;s:12:\"delete-90232\";i:89435;s:12:\"delete-90233\";i:89436;s:12:\"delete-90230\";i:89437;s:12:\"delete-90231\";i:89438;s:12:\"delete-90228\";i:89439;s:12:\"delete-90229\";i:89440;s:12:\"delete-90227\";i:89441;s:12:\"delete-90083\";i:89442;s:12:\"delete-90130\";i:89443;s:12:\"delete-90155\";i:89444;s:12:\"delete-90156\";i:89445;s:12:\"delete-90239\";i:89446;s:12:\"delete-90240\";i:89447;s:12:\"delete-90241\";i:89448;s:12:\"delete-90242\";i:89449;s:12:\"delete-90243\";i:89450;s:12:\"delete-90244\";i:89451;s:12:\"delete-90245\";i:89452;s:12:\"delete-90120\";i:89453;s:12:\"delete-90121\";i:89454;s:12:\"delete-90122\";i:89455;s:12:\"delete-90123\";i:89456;s:12:\"delete-90124\";i:89457;s:12:\"delete-90125\";i:89458;s:12:\"delete-90126\";i:89459;s:12:\"delete-90127\";i:89460;s:12:\"delete-90128\";i:89461;s:12:\"delete-90129\";i:89462;s:12:\"delete-90131\";i:89463;s:12:\"delete-90132\";i:89464;s:12:\"delete-90133\";i:89465;s:12:\"delete-90134\";i:89466;s:12:\"delete-90135\";i:89467;s:12:\"delete-90136\";i:89468;s:12:\"delete-90137\";i:89469;s:12:\"delete-90138\";i:89470;s:12:\"delete-90178\";i:89471;s:12:\"delete-90179\";i:89472;s:12:\"delete-90182\";i:89473;s:12:\"delete-90183\";i:89474;s:12:\"delete-90184\";i:89475;s:12:\"delete-90185\";i:89476;s:12:\"delete-90187\";i:89477;s:12:\"delete-90188\";i:89478;s:12:\"delete-90189\";i:89479;s:12:\"delete-90190\";i:89480;s:12:\"delete-90191\";i:89481;s:12:\"delete-90193\";i:89482;s:12:\"delete-90194\";i:89483;s:12:\"delete-90217\";i:89484;s:12:\"delete-90218\";i:89485;s:12:\"delete-90219\";i:89486;s:12:\"delete-90220\";i:89487;s:12:\"delete-90221\";i:89488;s:12:\"delete-90222\";i:89489;s:12:\"delete-90223\";i:89490;s:12:\"delete-90224\";i:89491;s:12:\"delete-90225\";i:89492;s:12:\"delete-90112\";i:89493;s:12:\"delete-90271\";i:89494;s:12:\"delete-90270\";i:89495;s:12:\"delete-90269\";i:89496;s:12:\"delete-90268\";i:89497;s:12:\"delete-90267\";i:89498;s:12:\"delete-90266\";i:89499;s:12:\"delete-90265\";i:89500;s:12:\"delete-90264\";i:89501;s:12:\"delete-90262\";i:89502;s:12:\"delete-90261\";i:89503;s:12:\"delete-90260\";i:89504;s:12:\"delete-90259\";i:89505;s:12:\"delete-90258\";i:89506;s:12:\"delete-90257\";i:89507;s:12:\"delete-90256\";i:89508;s:12:\"delete-90255\";i:89509;s:12:\"delete-90253\";i:89510;s:12:\"delete-90254\";i:89511;s:12:\"delete-90173\";i:89512;s:12:\"delete-90174\";i:89513;s:12:\"delete-90272\";i:89514;s:12:\"delete-90273\";i:89515;s:12:\"delete-90274\";i:89516;s:12:\"delete-90275\";i:89517;s:12:\"delete-90276\";i:89518;s:12:\"delete-90277\";i:89519;s:12:\"delete-90278\";i:89520;s:12:\"delete-90279\";i:89521;s:12:\"delete-90280\";i:89522;s:12:\"delete-90281\";i:89523;s:12:\"delete-90282\";i:89524;s:12:\"delete-90283\";i:89525;s:12:\"delete-90284\";i:89526;s:12:\"delete-90285\";i:89527;s:12:\"delete-90286\";i:89528;s:12:\"delete-90287\";i:89529;s:12:\"delete-90288\";i:89530;s:12:\"delete-90289\";i:89531;s:12:\"delete-90290\";i:89532;s:12:\"delete-90291\";i:89533;s:12:\"delete-90292\";i:89534;s:12:\"delete-90293\";i:89535;s:12:\"delete-90294\";i:89536;s:12:\"delete-90295\";i:89537;s:12:\"delete-90296\";i:89538;s:12:\"delete-90297\";i:89539;s:12:\"delete-90298\";i:89540;s:12:\"delete-90299\";i:89541;s:12:\"delete-90301\";i:89542;s:12:\"delete-90302\";i:89543;s:12:\"delete-90303\";i:89544;s:12:\"delete-90304\";i:89545;s:12:\"delete-90305\";i:89546;s:12:\"delete-90306\";i:89547;s:12:\"delete-90307\";i:89548;s:12:\"delete-90308\";i:89549;s:12:\"delete-90309\";i:89550;s:12:\"delete-90310\";i:89551;s:12:\"delete-90311\";i:89552;s:12:\"delete-90312\";i:89553;s:12:\"delete-90313\";i:89554;s:12:\"delete-90314\";i:89555;s:12:\"delete-90315\";i:89556;s:12:\"delete-90316\";i:89557;s:12:\"delete-90317\";i:89558;s:12:\"delete-90318\";i:89559;s:12:\"delete-90319\";i:89560;s:12:\"delete-90320\";i:89561;s:12:\"delete-90321\";i:89562;s:12:\"delete-90322\";i:89563;s:12:\"delete-90323\";i:89564;s:12:\"delete-90324\";i:89565;s:12:\"delete-90325\";i:89566;s:12:\"delete-90326\";i:89567;s:12:\"delete-90327\";i:89568;s:12:\"delete-90328\";i:89569;s:12:\"delete-90329\";i:89570;s:12:\"delete-90330\";i:89571;s:12:\"delete-90331\";i:89572;s:12:\"delete-90332\";i:89573;s:12:\"delete-90333\";i:89574;s:12:\"delete-90334\";i:89575;s:12:\"delete-90335\";i:89576;s:12:\"delete-90336\";i:89577;s:12:\"delete-90337\";i:89578;s:12:\"delete-90338\";i:89579;s:12:\"delete-90339\";i:89580;s:12:\"delete-90340\";i:89581;s:12:\"delete-90341\";i:89582;s:12:\"delete-90342\";i:89583;s:12:\"delete-90343\";i:89584;s:12:\"delete-90344\";i:89585;s:12:\"delete-90345\";i:89586;s:12:\"delete-90346\";i:89587;s:12:\"delete-90347\";i:89588;s:12:\"delete-90348\";i:89589;s:12:\"delete-90349\";i:89590;s:12:\"delete-90350\";i:89591;s:12:\"delete-90351\";i:89592;s:12:\"delete-90352\";i:89593;s:12:\"delete-90353\";i:89594;s:12:\"delete-90354\";i:89595;s:12:\"delete-90355\";i:89596;s:12:\"delete-90356\";i:89597;s:12:\"delete-90357\";i:89598;s:12:\"delete-90358\";i:89599;s:12:\"delete-90359\";i:89600;s:12:\"delete-90360\";i:89601;s:12:\"delete-90361\";i:89602;s:12:\"delete-90362\";i:89603;s:12:\"delete-90363\";i:89604;s:12:\"delete-90364\";i:89605;s:12:\"delete-90365\";i:89606;s:12:\"delete-90366\";i:89607;s:12:\"delete-90367\";i:89608;s:12:\"delete-90368\";i:89609;s:12:\"delete-90369\";i:89610;s:12:\"delete-90370\";i:89611;s:12:\"delete-90371\";i:89612;s:12:\"delete-90372\";i:89613;s:12:\"delete-90373\";i:89614;s:12:\"delete-90374\";i:89615;s:12:\"delete-90375\";i:89616;s:12:\"delete-90376\";i:89617;s:12:\"delete-90377\";i:89618;s:12:\"delete-90378\";i:89619;s:12:\"delete-90379\";i:89620;s:12:\"delete-90380\";i:89621;s:12:\"delete-90381\";i:89622;s:12:\"delete-90382\";i:89623;s:12:\"delete-90383\";i:89624;s:12:\"delete-90384\";i:89625;s:12:\"delete-90385\";i:89626;s:12:\"delete-90386\";i:89627;s:12:\"delete-90387\";i:89628;s:12:\"delete-90388\";i:89629;s:12:\"delete-90389\";i:89630;s:12:\"delete-90390\";i:89631;s:12:\"delete-90391\";i:89632;s:12:\"delete-90392\";i:89633;s:12:\"delete-90393\";i:89634;s:12:\"delete-90394\";i:89635;s:12:\"delete-90395\";i:89636;s:12:\"delete-90396\";i:89637;s:12:\"delete-90397\";i:89638;s:12:\"delete-90398\";i:89639;s:12:\"delete-90399\";i:89640;s:12:\"delete-90400\";i:89641;s:12:\"delete-90401\";i:89642;s:12:\"delete-90402\";i:89643;s:12:\"delete-90403\";i:89644;s:12:\"delete-90404\";i:89645;s:12:\"delete-90405\";i:89646;s:12:\"delete-90406\";i:89647;s:12:\"delete-90407\";i:89648;s:12:\"delete-90408\";i:89649;s:12:\"delete-90409\";i:89650;s:12:\"delete-90410\";i:89651;s:12:\"delete-90411\";i:89652;s:12:\"delete-90412\";i:89653;s:12:\"delete-90413\";i:89654;s:12:\"delete-90414\";i:89655;s:12:\"delete-90415\";i:89656;s:12:\"delete-90416\";i:89657;s:12:\"delete-90417\";i:89658;s:12:\"delete-90418\";i:89659;s:12:\"delete-90419\";i:89660;s:12:\"delete-90420\";i:89661;s:12:\"delete-90421\";i:89662;s:12:\"delete-90422\";i:89663;s:12:\"delete-90423\";i:89664;s:12:\"delete-90424\";i:89665;s:12:\"delete-90425\";i:89666;s:12:\"delete-90426\";i:89667;s:12:\"delete-90427\";i:89668;s:12:\"delete-90428\";i:89669;s:12:\"delete-90429\";i:89670;s:12:\"delete-90430\";i:89671;s:12:\"delete-90431\";i:89672;s:12:\"delete-90432\";i:89673;s:12:\"delete-90433\";i:89674;s:12:\"delete-90434\";i:89675;s:12:\"delete-90435\";i:89676;s:12:\"delete-90436\";i:89677;s:12:\"delete-90437\";i:89678;s:12:\"delete-90438\";i:89679;s:12:\"delete-90439\";i:89680;s:12:\"delete-90440\";i:89681;s:12:\"delete-90441\";i:89682;s:12:\"delete-90442\";i:89683;s:12:\"delete-90443\";i:89684;s:12:\"delete-90444\";i:89685;s:12:\"delete-90445\";i:89686;s:12:\"delete-90446\";i:89687;s:12:\"delete-90447\";i:89688;s:12:\"delete-90448\";i:89689;s:12:\"delete-90449\";i:89690;s:12:\"delete-90450\";i:89691;s:12:\"delete-90451\";i:89692;s:12:\"delete-90452\";i:89693;s:12:\"delete-90453\";i:89694;s:12:\"delete-90454\";i:89695;s:12:\"delete-90455\";i:89696;s:12:\"delete-90456\";i:89697;s:12:\"delete-90457\";i:89698;s:12:\"delete-90458\";i:89699;s:12:\"delete-90459\";i:89700;s:12:\"delete-90460\";i:89701;s:12:\"delete-90461\";i:89702;s:12:\"delete-90462\";i:89703;s:12:\"delete-90463\";i:89704;s:12:\"delete-90464\";i:89705;s:12:\"delete-90465\";i:89706;s:12:\"delete-90466\";i:89707;s:12:\"delete-90467\";i:89708;s:12:\"delete-90468\";i:89709;s:12:\"delete-90469\";i:89710;s:12:\"delete-90470\";i:89711;s:12:\"delete-90471\";i:89712;s:12:\"delete-90472\";i:89713;s:12:\"delete-90473\";i:89714;s:12:\"delete-90474\";i:89715;s:12:\"delete-90475\";i:89716;s:12:\"delete-90476\";i:89717;s:12:\"delete-90477\";i:89718;s:12:\"delete-90478\";i:89719;s:12:\"delete-90479\";i:89720;s:12:\"delete-90480\";i:89721;s:12:\"delete-90481\";i:89722;s:12:\"delete-90482\";i:89723;s:12:\"delete-90483\";i:89724;s:12:\"delete-90484\";i:89725;s:12:\"delete-90485\";i:89726;s:12:\"delete-90486\";i:89727;s:12:\"delete-90487\";i:89728;s:12:\"delete-90488\";i:89729;s:12:\"delete-90489\";i:89730;s:12:\"delete-90490\";i:89731;s:12:\"delete-90491\";i:89732;s:12:\"delete-90492\";i:89733;s:12:\"delete-90493\";i:89734;s:12:\"delete-90494\";i:89735;s:12:\"delete-90495\";i:89736;s:12:\"delete-90496\";i:89737;s:12:\"delete-90497\";i:89738;s:12:\"delete-90498\";i:89739;s:12:\"delete-90517\";i:89740;s:12:\"delete-90518\";i:89741;s:12:\"delete-90519\";i:89742;s:12:\"delete-90520\";i:89743;s:12:\"delete-90540\";i:89744;s:12:\"delete-90541\";i:89745;s:12:\"delete-90542\";i:89746;s:12:\"delete-90543\";i:89747;s:12:\"delete-90544\";i:89748;s:12:\"delete-90246\";i:89749;s:12:\"delete-90247\";i:89750;s:12:\"delete-90250\";i:89751;s:12:\"delete-90248\";i:89752;s:12:\"delete-90249\";i:89753;s:12:\"delete-90631\";i:89754;s:12:\"delete-90623\";i:89755;s:12:\"delete-90624\";i:89756;s:12:\"delete-90630\";i:89757;s:12:\"delete-90629\";i:89758;s:12:\"delete-90628\";i:89759;s:12:\"delete-90625\";i:89760;s:12:\"delete-90627\";i:89761;s:12:\"delete-90626\";i:89762;s:12:\"delete-90633\";i:89763;s:12:\"delete-90642\";i:89764;s:12:\"delete-90641\";i:89765;s:12:\"delete-90640\";i:89766;s:12:\"delete-90639\";i:89767;s:12:\"delete-90638\";i:89768;s:12:\"delete-90632\";i:89769;s:12:\"delete-90637\";i:89770;s:12:\"delete-90636\";i:89771;s:12:\"delete-90635\";i:89772;s:12:\"delete-90634\";i:89773;s:12:\"delete-90622\";i:89774;s:12:\"delete-90621\";i:89775;s:12:\"delete-90608\";i:89776;s:12:\"delete-90607\";i:89777;s:12:\"delete-90657\";i:89778;s:12:\"delete-90300\";i:89779;s:12:\"delete-90575\";i:89780;s:12:\"delete-90576\";i:89781;s:12:\"delete-90577\";i:89782;s:12:\"delete-90578\";i:89783;s:12:\"delete-90579\";i:89784;s:12:\"delete-90609\";i:89785;s:12:\"delete-90610\";i:89786;s:12:\"delete-90611\";i:89787;s:12:\"delete-90620\";i:89788;s:12:\"delete-90619\";i:89789;s:12:\"delete-90618\";i:89790;s:12:\"delete-90617\";i:89791;s:12:\"delete-90616\";i:89792;s:12:\"delete-90615\";i:89793;s:12:\"delete-90614\";i:89794;s:12:\"delete-90613\";i:89795;s:12:\"delete-90612\";i:89796;s:12:\"delete-90580\";i:89797;s:12:\"delete-90643\";i:89798;s:12:\"delete-90690\";i:89799;s:12:\"delete-90677\";i:89800;s:12:\"delete-90676\";i:89801;s:12:\"delete-90675\";i:89802;s:12:\"delete-90674\";i:89803;s:12:\"delete-90673\";i:89804;s:12:\"delete-90672\";i:89805;s:12:\"delete-90671\";i:89806;s:12:\"delete-90670\";i:89807;s:12:\"delete-90669\";i:89808;s:12:\"delete-90678\";i:89809;s:12:\"delete-90679\";i:89810;s:12:\"delete-90680\";i:89811;s:12:\"delete-90689\";i:89812;s:12:\"delete-90688\";i:89813;s:12:\"delete-90687\";i:89814;s:12:\"delete-90686\";i:89815;s:12:\"delete-90685\";i:89816;s:12:\"delete-90684\";i:89817;s:12:\"delete-90683\";i:89818;s:12:\"delete-90682\";i:89819;s:12:\"delete-90681\";i:89820;s:12:\"delete-90668\";i:89821;s:12:\"delete-90667\";i:89822;s:12:\"delete-90653\";i:89823;s:12:\"delete-90652\";i:89824;s:12:\"delete-90651\";i:89825;s:12:\"delete-90650\";i:89826;s:12:\"delete-90649\";i:89827;s:12:\"delete-90648\";i:89828;s:12:\"delete-90647\";i:89829;s:12:\"delete-90646\";i:89830;s:12:\"delete-90645\";i:89831;s:12:\"delete-90654\";i:89832;s:12:\"delete-90655\";i:89833;s:12:\"delete-90656\";i:89834;s:12:\"delete-90666\";i:89835;s:12:\"delete-90665\";i:89836;s:12:\"delete-90664\";i:89837;s:12:\"delete-90663\";i:89838;s:12:\"delete-90662\";i:89839;s:12:\"delete-90661\";i:89840;s:12:\"delete-90660\";i:89841;s:12:\"delete-90659\";i:89842;s:12:\"delete-90658\";i:89843;s:12:\"delete-90644\";i:89844;s:12:\"delete-90604\";i:89845;s:12:\"delete-90597\";i:89846;s:12:\"delete-90605\";i:89847;s:12:\"delete-90598\";i:89848;s:12:\"delete-90589\";i:89849;s:12:\"delete-90588\";i:89850;s:12:\"delete-90599\";i:89851;s:12:\"delete-90600\";i:89852;s:12:\"delete-90587\";i:89853;s:12:\"delete-90586\";i:89854;s:12:\"delete-90601\";i:89855;s:12:\"delete-90585\";i:89856;s:12:\"delete-90584\";i:89857;s:12:\"delete-90583\";i:89858;s:12:\"delete-90582\";i:89859;s:12:\"delete-90602\";i:89860;s:12:\"delete-90581\";i:89861;s:12:\"delete-90606\";i:89862;s:12:\"delete-90594\";i:89863;s:12:\"delete-90590\";i:89864;s:12:\"delete-90263\";i:89865;s:12:\"delete-90593\";i:89866;s:12:\"delete-90603\";i:89867;s:12:\"delete-90574\";i:89868;s:12:\"delete-90595\";i:89869;s:12:\"delete-90573\";i:89870;s:12:\"delete-90572\";i:89871;s:12:\"delete-90571\";i:89872;s:12:\"delete-90592\";i:89873;s:12:\"delete-90569\";i:89874;s:12:\"delete-90596\";i:89875;s:12:\"delete-90570\";i:89876;s:12:\"delete-90591\";i:89877;s:12:\"delete-90555\";i:89878;s:12:\"delete-90556\";i:89879;s:12:\"delete-90557\";i:89880;s:12:\"delete-90558\";i:89881;s:12:\"delete-90553\";i:89882;s:12:\"delete-90552\";i:89883;s:12:\"delete-90551\";i:89884;s:12:\"delete-90550\";i:89885;s:12:\"delete-90549\";i:89886;s:12:\"delete-90548\";i:89887;s:12:\"delete-90547\";i:89888;s:12:\"delete-90546\";i:89889;s:12:\"delete-90559\";i:89890;s:12:\"delete-90560\";i:89891;s:12:\"delete-90252\";i:89892;s:12:\"delete-90512\";i:89893;s:12:\"delete-90521\";i:89894;s:12:\"delete-90568\";i:89895;s:12:\"delete-90567\";i:89896;s:12:\"delete-90566\";i:89897;s:12:\"delete-90565\";i:89898;s:12:\"delete-90564\";i:89899;s:12:\"delete-90563\";i:89900;s:12:\"delete-90562\";i:89901;s:12:\"delete-90561\";i:89902;s:12:\"delete-90251\";i:89903;s:12:\"delete-90545\";i:89904;s:12:\"delete-90554\";i:89905;s:12:\"delete-90515\";i:89906;s:12:\"delete-90514\";i:89907;s:12:\"delete-90513\";i:89908;s:12:\"delete-90511\";i:89909;s:12:\"delete-90510\";i:89910;s:12:\"delete-90509\";i:89911;s:12:\"delete-90508\";i:89912;s:12:\"delete-90507\";i:89913;s:12:\"delete-90506\";i:89914;s:12:\"delete-90505\";i:89915;s:12:\"delete-90504\";i:89916;s:12:\"delete-90503\";i:89917;s:12:\"delete-90502\";i:89918;s:12:\"delete-90501\";i:89919;s:12:\"delete-90500\";i:89920;s:12:\"delete-90499\";i:89921;s:12:\"delete-90516\";i:89922;s:12:\"delete-90522\";i:89923;s:12:\"delete-90523\";i:89924;s:12:\"delete-90539\";i:89925;s:12:\"delete-90538\";i:89926;s:12:\"delete-90537\";i:89927;s:12:\"delete-90536\";i:89928;s:12:\"delete-90535\";i:89929;s:12:\"delete-90534\";i:89930;s:12:\"delete-90533\";i:89931;s:12:\"delete-90532\";i:89932;s:12:\"delete-90525\";i:89933;s:12:\"delete-90526\";i:89934;s:12:\"delete-90527\";i:89935;s:12:\"delete-90528\";i:89936;s:12:\"delete-90529\";i:89937;s:12:\"delete-90530\";i:89938;s:12:\"delete-90531\";i:89939;s:12:\"delete-90524\";i:89940;s:12:\"delete-90159\";i:89941;s:12:\"delete-90160\";i:89942;s:12:\"delete-90202\";i:89943;s:12:\"delete-90118\";i:89944;s:12:\"delete-90114\";i:89945;s:12:\"delete-90116\";i:89946;s:12:\"delete-90143\";i:89947;s:12:\"delete-90144\";i:89948;s:12:\"delete-90145\";i:89949;s:12:\"delete-90147\";i:89950;s:12:\"delete-90146\";i:89951;s:12:\"delete-90141\";i:89952;s:12:\"delete-90140\";i:89953;s:12:\"delete-90139\";i:89954;s:12:\"delete-90142\";i:89955;s:12:\"delete-90119\";i:89956;s:12:\"delete-90117\";i:89957;s:12:\"delete-90236\";i:89958;s:12:\"delete-90237\";i:89959;s:12:\"delete-90238\";i:89960;s:12:\"delete-90113\";i:89961;s:12:\"delete-90115\";i:89962;s:12:\"delete-90148\";i:89963;s:12:\"delete-90149\";i:89964;s:12:\"delete-90203\";i:89965;s:12:\"delete-90201\";i:89966;s:12:\"delete-90200\";i:89967;s:12:\"delete-90199\";i:89968;s:12:\"delete-90198\";i:89969;s:12:\"delete-90197\";i:89970;s:12:\"delete-90195\";i:89971;s:12:\"delete-90196\";i:89972;s:12:\"delete-90204\";i:89973;s:12:\"delete-90192\";i:89974;s:12:\"delete-90216\";i:89975;s:12:\"delete-90215\";i:89976;s:12:\"delete-90214\";i:89977;s:12:\"delete-90205\";i:89978;s:12:\"delete-90206\";i:89979;s:12:\"delete-90207\";i:89980;s:12:\"delete-90208\";i:89981;s:12:\"delete-90209\";i:89982;s:12:\"delete-90210\";i:89983;s:12:\"delete-90211\";i:89984;s:12:\"delete-90212\";i:89985;s:12:\"delete-90213\";i:89986;s:12:\"delete-90186\";i:89987;s:12:\"delete-90181\";i:89988;s:12:\"delete-90180\";i:89989;s:12:\"delete-90163\";i:89990;s:12:\"delete-90162\";i:89991;s:12:\"delete-90161\";i:89992;s:12:\"delete-90158\";i:89993;s:12:\"delete-90157\";i:89994;s:12:\"delete-90154\";i:89995;s:12:\"delete-90153\";i:89996;s:12:\"delete-90152\";i:89997;s:12:\"delete-90151\";i:89998;s:12:\"delete-90164\";i:89999;s:12:\"delete-90165\";i:90000;s:12:\"delete-90166\";i:90001;s:12:\"delete-90177\";i:90002;s:12:\"delete-90176\";i:90003;s:12:\"delete-90175\";i:90004;s:12:\"delete-90172\";i:90005;s:12:\"delete-90171\";i:90006;s:12:\"delete-90170\";i:90007;s:12:\"delete-90169\";i:90008;s:12:\"delete-90168\";i:90009;s:12:\"delete-90167\";i:90010;s:12:\"delete-90150\";i:90011;s:12:\"delete-91119\";i:90012;s:12:\"delete-90692\";i:90013;s:12:\"delete-90693\";i:90014;s:12:\"delete-90694\";i:90015;s:12:\"delete-90695\";i:90016;s:12:\"delete-90691\";i:90017;s:12:\"delete-91118\";i:90018;s:12:\"delete-91112\";i:90019;s:12:\"delete-90949\";i:90020;s:12:\"delete-90948\";i:90021;s:12:\"delete-90947\";i:90022;s:12:\"delete-90946\";i:90023;s:12:\"delete-90945\";i:90024;s:12:\"delete-90944\";i:90025;s:12:\"delete-90943\";i:90026;s:12:\"delete-90942\";i:90027;s:12:\"delete-90941\";i:90028;s:12:\"delete-90940\";i:90029;s:12:\"delete-90950\";i:90030;s:12:\"delete-90951\";i:90031;s:12:\"delete-90952\";i:90032;s:12:\"delete-90962\";i:90033;s:12:\"delete-90961\";i:90034;s:12:\"delete-90960\";i:90035;s:12:\"delete-90959\";i:90036;s:12:\"delete-90958\";i:90037;s:12:\"delete-90957\";i:90038;s:12:\"delete-90956\";i:90039;s:12:\"delete-90955\";i:90040;s:12:\"delete-90954\";i:90041;s:12:\"delete-90953\";i:90042;s:12:\"delete-90939\";i:90043;s:12:\"delete-90938\";i:90044;s:12:\"delete-90937\";i:90045;s:12:\"delete-90924\";i:90046;s:12:\"delete-90923\";i:90047;s:12:\"delete-90922\";i:90048;s:12:\"delete-90921\";i:90049;s:12:\"delete-90920\";i:90050;s:12:\"delete-90919\";i:90051;s:12:\"delete-90918\";i:90052;s:12:\"delete-90917\";i:90053;s:12:\"delete-90916\";i:90054;s:12:\"delete-90915\";i:90055;s:12:\"delete-90925\";i:90056;s:12:\"delete-90926\";i:90057;s:12:\"delete-90936\";i:90058;s:12:\"delete-90935\";i:90059;s:12:\"delete-90934\";i:90060;s:12:\"delete-90933\";i:90061;s:12:\"delete-90932\";i:90062;s:12:\"delete-90931\";i:90063;s:12:\"delete-90930\";i:90064;s:12:\"delete-90929\";i:90065;s:12:\"delete-90928\";i:90066;s:12:\"delete-90927\";i:90067;s:12:\"delete-90914\";i:90068;s:12:\"delete-91015\";i:90069;s:12:\"delete-91001\";i:90070;s:12:\"delete-91000\";i:90071;s:12:\"delete-90999\";i:90072;s:12:\"delete-90998\";i:90073;s:12:\"delete-90997\";i:90074;s:12:\"delete-90996\";i:90075;s:12:\"delete-90995\";i:90076;s:12:\"delete-90994\";i:90077;s:12:\"delete-90993\";i:90078;s:12:\"delete-90992\";i:90079;s:12:\"delete-90991\";i:90080;s:12:\"delete-91003\";i:90081;s:12:\"delete-91002\";i:90082;s:12:\"delete-91014\";i:90083;s:12:\"delete-91013\";i:90084;s:12:\"delete-91012\";i:90085;s:12:\"delete-91011\";i:90086;s:12:\"delete-91010\";i:90087;s:12:\"delete-91009\";i:90088;s:12:\"delete-91008\";i:90089;s:12:\"delete-91007\";i:90090;s:12:\"delete-91006\";i:90091;s:12:\"delete-91005\";i:90092;s:12:\"delete-91004\";i:90093;s:12:\"delete-90990\";i:90094;s:12:\"delete-90989\";i:90095;s:12:\"delete-90988\";i:90096;s:12:\"delete-90974\";i:90097;s:12:\"delete-90973\";i:90098;s:12:\"delete-90972\";i:90099;s:12:\"delete-90971\";i:90100;s:12:\"delete-90970\";i:90101;s:12:\"delete-90969\";i:90102;s:12:\"delete-90968\";i:90103;s:12:\"delete-90967\";i:90104;s:12:\"delete-90966\";i:90105;s:12:\"delete-90965\";i:90106;s:12:\"delete-90964\";i:90107;s:12:\"delete-90975\";i:90108;s:12:\"delete-90976\";i:90109;s:12:\"delete-90987\";i:90110;s:12:\"delete-90986\";i:90111;s:12:\"delete-90985\";i:90112;s:12:\"delete-90984\";i:90113;s:12:\"delete-90983\";i:90114;s:12:\"delete-90982\";i:90115;s:12:\"delete-90981\";i:90116;s:12:\"delete-90980\";i:90117;s:12:\"delete-90979\";i:90118;s:12:\"delete-90978\";i:90119;s:12:\"delete-90977\";i:90120;s:12:\"delete-90963\";i:90121;s:12:\"delete-90913\";i:90122;s:12:\"delete-90746\";i:90123;s:12:\"delete-90732\";i:90124;s:12:\"delete-90731\";i:90125;s:12:\"delete-90730\";i:90126;s:12:\"delete-90729\";i:90127;s:12:\"delete-90728\";i:90128;s:12:\"delete-90727\";i:90129;s:12:\"delete-90726\";i:90130;s:12:\"delete-90725\";i:90131;s:12:\"delete-90724\";i:90132;s:12:\"delete-90723\";i:90133;s:12:\"delete-90722\";i:90134;s:12:\"delete-90733\";i:90135;s:12:\"delete-90734\";i:90136;s:12:\"delete-90745\";i:90137;s:12:\"delete-90744\";i:90138;s:12:\"delete-90743\";i:90139;s:12:\"delete-90742\";i:90140;s:12:\"delete-90741\";i:90141;s:12:\"delete-90740\";i:90142;s:12:\"delete-90739\";i:90143;s:12:\"delete-90738\";i:90144;s:12:\"delete-90737\";i:90145;s:12:\"delete-90736\";i:90146;s:12:\"delete-90735\";i:90147;s:12:\"delete-90721\";i:90148;s:12:\"delete-90720\";i:90149;s:12:\"delete-90706\";i:90150;s:12:\"delete-90705\";i:90151;s:12:\"delete-90704\";i:90152;s:12:\"delete-90703\";i:90153;s:12:\"delete-90702\";i:90154;s:12:\"delete-90701\";i:90155;s:12:\"delete-90700\";i:90156;s:12:\"delete-90699\";i:90157;s:12:\"delete-90698\";i:90158;s:12:\"delete-90697\";i:90159;s:12:\"delete-90696\";i:90160;s:12:\"delete-90707\";i:90161;s:12:\"delete-90708\";i:90162;s:12:\"delete-90719\";i:90163;s:12:\"delete-90718\";i:90164;s:12:\"delete-90717\";i:90165;s:12:\"delete-90716\";i:90166;s:12:\"delete-90715\";i:90167;s:12:\"delete-90714\";i:90168;s:12:\"delete-90713\";i:90169;s:12:\"delete-90712\";i:90170;s:12:\"delete-90711\";i:90171;s:12:\"delete-90710\";i:90172;s:12:\"delete-90709\";i:90173;s:12:\"delete-90909\";i:90174;s:12:\"delete-90747\";i:90175;s:12:\"delete-90912\";i:90176;s:12:\"delete-90781\";i:90177;s:12:\"delete-90780\";i:90178;s:12:\"delete-90779\";i:90179;s:12:\"delete-90778\";i:90180;s:12:\"delete-90777\";i:90181;s:12:\"delete-90776\";i:90182;s:12:\"delete-90901\";i:90183;s:12:\"delete-90775\";i:90184;s:12:\"delete-90774\";i:90185;s:12:\"delete-90773\";i:90186;s:12:\"delete-90772\";i:90187;s:12:\"delete-90782\";i:90188;s:12:\"delete-90783\";i:90189;s:12:\"delete-90911\";i:90190;s:12:\"delete-90910\";i:90191;s:12:\"delete-90908\";i:90192;s:12:\"delete-90907\";i:90193;s:12:\"delete-90906\";i:90194;s:12:\"delete-90905\";i:90195;s:12:\"delete-90904\";i:90196;s:12:\"delete-90903\";i:90197;s:12:\"delete-90902\";i:90198;s:12:\"delete-90785\";i:90199;s:12:\"delete-90784\";i:90200;s:12:\"delete-90771\";i:90201;s:12:\"delete-90770\";i:90202;s:12:\"delete-90759\";i:90203;s:12:\"delete-90758\";i:90204;s:12:\"delete-90757\";i:90205;s:12:\"delete-90756\";i:90206;s:12:\"delete-90755\";i:90207;s:12:\"delete-90754\";i:90208;s:12:\"delete-90753\";i:90209;s:12:\"delete-90752\";i:90210;s:12:\"delete-90751\";i:90211;s:12:\"delete-90750\";i:90212;s:12:\"delete-90749\";i:90213;s:12:\"delete-90760\";i:90214;s:12:\"delete-90761\";i:90215;s:12:\"delete-90769\";i:90216;s:12:\"delete-90768\";i:90217;s:12:\"delete-90767\";i:90218;s:12:\"delete-90766\";i:90219;s:12:\"delete-90765\";i:90220;s:12:\"delete-90900\";i:90221;s:12:\"delete-90899\";i:90222;s:12:\"delete-90898\";i:90223;s:12:\"delete-90764\";i:90224;s:12:\"delete-90763\";i:90225;s:12:\"delete-90762\";i:90226;s:12:\"delete-90748\";i:90227;s:12:\"delete-90825\";i:90228;s:12:\"delete-90832\";i:90229;s:12:\"delete-90831\";i:90230;s:12:\"delete-90830\";i:90231;s:12:\"delete-90829\";i:90232;s:12:\"delete-90828\";i:90233;s:12:\"delete-90827\";i:90234;s:12:\"delete-90826\";i:90235;s:12:\"delete-90823\";i:90236;s:12:\"delete-90822\";i:90237;s:12:\"delete-90821\";i:90238;s:12:\"delete-90820\";i:90239;s:12:\"delete-90833\";i:90240;s:12:\"delete-90834\";i:90241;s:12:\"delete-90845\";i:90242;s:12:\"delete-90844\";i:90243;s:12:\"delete-90843\";i:90244;s:12:\"delete-90842\";i:90245;s:12:\"delete-90841\";i:90246;s:12:\"delete-90840\";i:90247;s:12:\"delete-90839\";i:90248;s:12:\"delete-90838\";i:90249;s:12:\"delete-90837\";i:90250;s:12:\"delete-90836\";i:90251;s:12:\"delete-90835\";i:90252;s:12:\"delete-90819\";i:90253;s:12:\"delete-90817\";i:90254;s:12:\"delete-90818\";i:90255;s:12:\"delete-90804\";i:90256;s:12:\"delete-90803\";i:90257;s:12:\"delete-90802\";i:90258;s:12:\"delete-90801\";i:90259;s:12:\"delete-90800\";i:90260;s:12:\"delete-90798\";i:90261;s:12:\"delete-90797\";i:90262;s:12:\"delete-90795\";i:90263;s:12:\"delete-90796\";i:90264;s:12:\"delete-90792\";i:90265;s:12:\"delete-90788\";i:90266;s:12:\"delete-90805\";i:90267;s:12:\"delete-90806\";i:90268;s:12:\"delete-90816\";i:90269;s:12:\"delete-90815\";i:90270;s:12:\"delete-90814\";i:90271;s:12:\"delete-90799\";i:90272;s:12:\"delete-90813\";i:90273;s:12:\"delete-90812\";i:90274;s:12:\"delete-90811\";i:90275;s:12:\"delete-90810\";i:90276;s:12:\"delete-90809\";i:90277;s:12:\"delete-90808\";i:90278;s:12:\"delete-90807\";i:90279;s:12:\"delete-90789\";i:90280;s:12:\"delete-90897\";i:90281;s:12:\"delete-90876\";i:90282;s:12:\"delete-90877\";i:90283;s:12:\"delete-90878\";i:90284;s:12:\"delete-90879\";i:90285;s:12:\"delete-90880\";i:90286;s:12:\"delete-90881\";i:90287;s:12:\"delete-90882\";i:90288;s:12:\"delete-90883\";i:90289;s:12:\"delete-90884\";i:90290;s:12:\"delete-90885\";i:90291;s:12:\"delete-90873\";i:90292;s:12:\"delete-90875\";i:90293;s:12:\"delete-90874\";i:90294;s:12:\"delete-90896\";i:90295;s:12:\"delete-90886\";i:90296;s:12:\"delete-90887\";i:90297;s:12:\"delete-90888\";i:90298;s:12:\"delete-90889\";i:90299;s:12:\"delete-90890\";i:90300;s:12:\"delete-90891\";i:90301;s:12:\"delete-90892\";i:90302;s:12:\"delete-90893\";i:90303;s:12:\"delete-90894\";i:90304;s:12:\"delete-90895\";i:90305;s:12:\"delete-90854\";i:90306;s:12:\"delete-90855\";i:90307;s:12:\"delete-90856\";i:90308;s:12:\"delete-90860\";i:90309;s:12:\"delete-90859\";i:90310;s:12:\"delete-90858\";i:90311;s:12:\"delete-90853\";i:90312;s:12:\"delete-90852\";i:90313;s:12:\"delete-90851\";i:90314;s:12:\"delete-90850\";i:90315;s:12:\"delete-90849\";i:90316;s:12:\"delete-90848\";i:90317;s:12:\"delete-90847\";i:90318;s:12:\"delete-90846\";i:90319;s:12:\"delete-90861\";i:90320;s:12:\"delete-90862\";i:90321;s:12:\"delete-90857\";i:90322;s:12:\"delete-90872\";i:90323;s:12:\"delete-90871\";i:90324;s:12:\"delete-90870\";i:90325;s:12:\"delete-90869\";i:90326;s:12:\"delete-90868\";i:90327;s:12:\"delete-90866\";i:90328;s:12:\"delete-90867\";i:90329;s:12:\"delete-90864\";i:90330;s:12:\"delete-90865\";i:90331;s:12:\"delete-90863\";i:90332;s:12:\"delete-90824\";i:90333;s:12:\"delete-90790\";i:90334;s:12:\"delete-91068\";i:90335;s:12:\"delete-91054\";i:90336;s:12:\"delete-91053\";i:90337;s:12:\"delete-91052\";i:90338;s:12:\"delete-91051\";i:90339;s:12:\"delete-91050\";i:90340;s:12:\"delete-91049\";i:90341;s:12:\"delete-91048\";i:90342;s:12:\"delete-91047\";i:90343;s:12:\"delete-91046\";i:90344;s:12:\"delete-91045\";i:90345;s:12:\"delete-91044\";i:90346;s:12:\"delete-91055\";i:90347;s:12:\"delete-91056\";i:90348;s:12:\"delete-91067\";i:90349;s:12:\"delete-91066\";i:90350;s:12:\"delete-91065\";i:90351;s:12:\"delete-91064\";i:90352;s:12:\"delete-91063\";i:90353;s:12:\"delete-91062\";i:90354;s:12:\"delete-91061\";i:90355;s:12:\"delete-91060\";i:90356;s:12:\"delete-91059\";i:90357;s:12:\"delete-91058\";i:90358;s:12:\"delete-91057\";i:90359;s:12:\"delete-91042\";i:90360;s:12:\"delete-91043\";i:90361;s:12:\"delete-91041\";i:90362;s:12:\"delete-91027\";i:90363;s:12:\"delete-91026\";i:90364;s:12:\"delete-91025\";i:90365;s:12:\"delete-91024\";i:90366;s:12:\"delete-91023\";i:90367;s:12:\"delete-91022\";i:90368;s:12:\"delete-91021\";i:90369;s:12:\"delete-91020\";i:90370;s:12:\"delete-91019\";i:90371;s:12:\"delete-91018\";i:90372;s:12:\"delete-91017\";i:90373;s:12:\"delete-91028\";i:90374;s:12:\"delete-91029\";i:90375;s:12:\"delete-91039\";i:90376;s:12:\"delete-91040\";i:90377;s:12:\"delete-91038\";i:90378;s:12:\"delete-91037\";i:90379;s:12:\"delete-91036\";i:90380;s:12:\"delete-91035\";i:90381;s:12:\"delete-91034\";i:90382;s:12:\"delete-91033\";i:90383;s:12:\"delete-91032\";i:90384;s:12:\"delete-91031\";i:90385;s:12:\"delete-91030\";i:90386;s:12:\"delete-91016\";i:90387;s:12:\"delete-90791\";i:90388;s:12:\"delete-91107\";i:90389;s:12:\"delete-91106\";i:90390;s:12:\"delete-91105\";i:90391;s:12:\"delete-91104\";i:90392;s:12:\"delete-91103\";i:90393;s:12:\"delete-91102\";i:90394;s:12:\"delete-91101\";i:90395;s:12:\"delete-91100\";i:90396;s:12:\"delete-91099\";i:90397;s:12:\"delete-91098\";i:90398;s:12:\"delete-91097\";i:90399;s:12:\"delete-91108\";i:90400;s:12:\"delete-91109\";i:90401;s:12:\"delete-90793\";i:90402;s:12:\"delete-90794\";i:90403;s:12:\"delete-90787\";i:90404;s:12:\"delete-90786\";i:90405;s:12:\"delete-91117\";i:90406;s:12:\"delete-91116\";i:90407;s:12:\"delete-91115\";i:90408;s:12:\"delete-91114\";i:90409;s:12:\"delete-91113\";i:90410;s:12:\"delete-91111\";i:90411;s:12:\"delete-91110\";i:90412;s:12:\"delete-91096\";i:90413;s:12:\"delete-91095\";i:90414;s:12:\"delete-91094\";i:90415;s:12:\"delete-91080\";i:90416;s:12:\"delete-91079\";i:90417;s:12:\"delete-91078\";i:90418;s:12:\"delete-91077\";i:90419;s:12:\"delete-91076\";i:90420;s:12:\"delete-91075\";i:90421;s:12:\"delete-91074\";i:90422;s:12:\"delete-91073\";i:90423;s:12:\"delete-91072\";i:90424;s:12:\"delete-91071\";i:90425;s:12:\"delete-91070\";i:90426;s:12:\"delete-91081\";i:90427;s:12:\"delete-91082\";i:90428;s:12:\"delete-91093\";i:90429;s:12:\"delete-91092\";i:90430;s:12:\"delete-91091\";i:90431;s:12:\"delete-91090\";i:90432;s:12:\"delete-91089\";i:90433;s:12:\"delete-91088\";i:90434;s:12:\"delete-91087\";i:90435;s:12:\"delete-91086\";i:90436;s:12:\"delete-91085\";i:90437;s:12:\"delete-91084\";i:90438;s:12:\"delete-91083\";i:90439;s:12:\"delete-91069\";i:90440;s:12:\"delete-91236\";i:90441;s:12:\"delete-91215\";i:90442;s:12:\"delete-91216\";i:90443;s:12:\"delete-91148\";i:90444;s:12:\"delete-91235\";i:90445;s:12:\"delete-91234\";i:90446;s:12:\"delete-91233\";i:90447;s:12:\"delete-91150\";i:90448;s:12:\"delete-91232\";i:90449;s:12:\"delete-91120\";i:90450;s:12:\"delete-91171\";i:90451;s:12:\"delete-91159\";i:90452;s:12:\"delete-91157\";i:90453;s:12:\"delete-91155\";i:90454;s:12:\"delete-91156\";i:90455;s:12:\"delete-91154\";i:90456;s:12:\"delete-91152\";i:90457;s:12:\"delete-91153\";i:90458;s:12:\"delete-91151\";i:90459;s:12:\"delete-91149\";i:90460;s:12:\"delete-91224\";i:90461;s:12:\"delete-91223\";i:90462;s:12:\"delete-91158\";i:90463;s:12:\"delete-91161\";i:90464;s:12:\"delete-91172\";i:90465;s:12:\"delete-91169\";i:90466;s:12:\"delete-91170\";i:90467;s:12:\"delete-91167\";i:90468;s:12:\"delete-91168\";i:90469;s:12:\"delete-91165\";i:90470;s:12:\"delete-91166\";i:90471;s:12:\"delete-91164\";i:90472;s:12:\"delete-91162\";i:90473;s:12:\"delete-91163\";i:90474;s:12:\"delete-91160\";i:90475;s:12:\"delete-91145\";i:90476;s:12:\"delete-91146\";i:90477;s:12:\"delete-91147\";i:90478;s:12:\"delete-91132\";i:90479;s:12:\"delete-91130\";i:90480;s:12:\"delete-91129\";i:90481;s:12:\"delete-91128\";i:90482;s:12:\"delete-91127\";i:90483;s:12:\"delete-91126\";i:90484;s:12:\"delete-91125\";i:90485;s:12:\"delete-91124\";i:90486;s:12:\"delete-91122\";i:90487;s:12:\"delete-91123\";i:90488;s:12:\"delete-91121\";i:90489;s:12:\"delete-91131\";i:90490;s:12:\"delete-91133\";i:90491;s:12:\"delete-91144\";i:90492;s:12:\"delete-91142\";i:90493;s:12:\"delete-91143\";i:90494;s:12:\"delete-91141\";i:90495;s:12:\"delete-91139\";i:90496;s:12:\"delete-91140\";i:90497;s:12:\"delete-91138\";i:90498;s:12:\"delete-91136\";i:90499;s:12:\"delete-91137\";i:90500;s:12:\"delete-91134\";i:90501;s:12:\"delete-91179\";i:90502;s:12:\"delete-91135\";i:90503;s:12:\"delete-91174\";i:90504;s:12:\"delete-91231\";i:90505;s:12:\"delete-91212\";i:90506;s:12:\"delete-91211\";i:90507;s:12:\"delete-91210\";i:90508;s:12:\"delete-91209\";i:90509;s:12:\"delete-91207\";i:90510;s:12:\"delete-91208\";i:90511;s:12:\"delete-91206\";i:90512;s:12:\"delete-91205\";i:90513;s:12:\"delete-91204\";i:90514;s:12:\"delete-91202\";i:90515;s:12:\"delete-91203\";i:90516;s:12:\"delete-91213\";i:90517;s:12:\"delete-91214\";i:90518;s:12:\"delete-91230\";i:90519;s:12:\"delete-91229\";i:90520;s:12:\"delete-91228\";i:90521;s:12:\"delete-91217\";i:90522;s:12:\"delete-91218\";i:90523;s:12:\"delete-91219\";i:90524;s:12:\"delete-91220\";i:90525;s:12:\"delete-91221\";i:90526;s:12:\"delete-91222\";i:90527;s:12:\"delete-91227\";i:90528;s:12:\"delete-91226\";i:90529;s:12:\"delete-91201\";i:90530;s:12:\"delete-91200\";i:90531;s:12:\"delete-91199\";i:90532;s:12:\"delete-91184\";i:90533;s:12:\"delete-91185\";i:90534;s:12:\"delete-91183\";i:90535;s:12:\"delete-91181\";i:90536;s:12:\"delete-91182\";i:90537;s:12:\"delete-91180\";i:90538;s:12:\"delete-91178\";i:90539;s:12:\"delete-91225\";i:90540;s:12:\"delete-91176\";i:90541;s:12:\"delete-91177\";i:90542;s:12:\"delete-91175\";i:90543;s:12:\"delete-91186\";i:90544;s:12:\"delete-91187\";i:90545;s:12:\"delete-91198\";i:90546;s:12:\"delete-91197\";i:90547;s:12:\"delete-91196\";i:90548;s:12:\"delete-91195\";i:90549;s:12:\"delete-91194\";i:90550;s:12:\"delete-91193\";i:90551;s:12:\"delete-91192\";i:90552;s:12:\"delete-91191\";i:90553;s:12:\"delete-91189\";i:90554;s:12:\"delete-91190\";i:90555;s:12:\"delete-91188\";i:90556;s:12:\"delete-91173\";i:90557;s:12:\"delete-91603\";i:90558;s:12:\"delete-91671\";i:90559;s:12:\"delete-91614\";i:90560;s:12:\"delete-91677\";i:90561;s:12:\"delete-91617\";i:90562;s:12:\"delete-91605\";i:90563;s:12:\"delete-91237\";i:90564;s:12:\"delete-91238\";i:90565;s:12:\"delete-91240\";i:90566;s:12:\"delete-91239\";i:90567;s:12:\"delete-91242\";i:90568;s:12:\"delete-91241\";i:90569;s:12:\"delete-91386\";i:90570;s:12:\"delete-91385\";i:90571;s:12:\"delete-91384\";i:90572;s:12:\"delete-91383\";i:90573;s:12:\"delete-91382\";i:90574;s:12:\"delete-91381\";i:90575;s:12:\"delete-91380\";i:90576;s:12:\"delete-91379\";i:90577;s:12:\"delete-91378\";i:90578;s:12:\"delete-91377\";i:90579;s:12:\"delete-91387\";i:90580;s:12:\"delete-91388\";i:90581;s:12:\"delete-91398\";i:90582;s:12:\"delete-91397\";i:90583;s:12:\"delete-91396\";i:90584;s:12:\"delete-91395\";i:90585;s:12:\"delete-91394\";i:90586;s:12:\"delete-91393\";i:90587;s:12:\"delete-91392\";i:90588;s:12:\"delete-91390\";i:90589;s:12:\"delete-91389\";i:90590;s:12:\"delete-91399\";i:90591;s:12:\"delete-91391\";i:90592;s:12:\"delete-91375\";i:90593;s:12:\"delete-91360\";i:90594;s:12:\"delete-91359\";i:90595;s:12:\"delete-91358\";i:90596;s:12:\"delete-91357\";i:90597;s:12:\"delete-91356\";i:90598;s:12:\"delete-91355\";i:90599;s:12:\"delete-91354\";i:90600;s:12:\"delete-91353\";i:90601;s:12:\"delete-91352\";i:90602;s:12:\"delete-91351\";i:90603;s:12:\"delete-91350\";i:90604;s:12:\"delete-91349\";i:90605;s:12:\"delete-91361\";i:90606;s:12:\"delete-91362\";i:90607;s:12:\"delete-91374\";i:90608;s:12:\"delete-91373\";i:90609;s:12:\"delete-91372\";i:90610;s:12:\"delete-91371\";i:90611;s:12:\"delete-91370\";i:90612;s:12:\"delete-91369\";i:90613;s:12:\"delete-91368\";i:90614;s:12:\"delete-91367\";i:90615;s:12:\"delete-91366\";i:90616;s:12:\"delete-91365\";i:90617;s:12:\"delete-91364\";i:90618;s:12:\"delete-91363\";i:90619;s:12:\"delete-91376\";i:90620;s:12:\"delete-91400\";i:90621;s:12:\"delete-91453\";i:90622;s:12:\"delete-91438\";i:90623;s:12:\"delete-91437\";i:90624;s:12:\"delete-91436\";i:90625;s:12:\"delete-91435\";i:90626;s:12:\"delete-91433\";i:90627;s:12:\"delete-91434\";i:90628;s:12:\"delete-91445\";i:90629;s:12:\"delete-91432\";i:90630;s:12:\"delete-91431\";i:90631;s:12:\"delete-91430\";i:90632;s:12:\"delete-91429\";i:90633;s:12:\"delete-91439\";i:90634;s:12:\"delete-91440\";i:90635;s:12:\"delete-91452\";i:90636;s:12:\"delete-91451\";i:90637;s:12:\"delete-91450\";i:90638;s:12:\"delete-91449\";i:90639;s:12:\"delete-91447\";i:90640;s:12:\"delete-91448\";i:90641;s:12:\"delete-91446\";i:90642;s:12:\"delete-91444\";i:90643;s:12:\"delete-91443\";i:90644;s:12:\"delete-91442\";i:90645;s:12:\"delete-91441\";i:90646;s:12:\"delete-91428\";i:90647;s:12:\"delete-91427\";i:90648;s:12:\"delete-91426\";i:90649;s:12:\"delete-91412\";i:90650;s:12:\"delete-91411\";i:90651;s:12:\"delete-91410\";i:90652;s:12:\"delete-91409\";i:90653;s:12:\"delete-91408\";i:90654;s:12:\"delete-91407\";i:90655;s:12:\"delete-91406\";i:90656;s:12:\"delete-91405\";i:90657;s:12:\"delete-91404\";i:90658;s:12:\"delete-91403\";i:90659;s:12:\"delete-91402\";i:90660;s:12:\"delete-91413\";i:90661;s:12:\"delete-91414\";i:90662;s:12:\"delete-91425\";i:90663;s:12:\"delete-91424\";i:90664;s:12:\"delete-91423\";i:90665;s:12:\"delete-91422\";i:90666;s:12:\"delete-91421\";i:90667;s:12:\"delete-91420\";i:90668;s:12:\"delete-91419\";i:90669;s:12:\"delete-91418\";i:90670;s:12:\"delete-91417\";i:90671;s:12:\"delete-91416\";i:90672;s:12:\"delete-91415\";i:90673;s:12:\"delete-91401\";i:90674;s:12:\"delete-91348\";i:90675;s:12:\"delete-91293\";i:90676;s:12:\"delete-91280\";i:90677;s:12:\"delete-91278\";i:90678;s:12:\"delete-91275\";i:90679;s:12:\"delete-91277\";i:90680;s:12:\"delete-91276\";i:90681;s:12:\"delete-91274\";i:90682;s:12:\"delete-91273\";i:90683;s:12:\"delete-91272\";i:90684;s:12:\"delete-91270\";i:90685;s:12:\"delete-91271\";i:90686;s:12:\"delete-91269\";i:90687;s:12:\"delete-91279\";i:90688;s:12:\"delete-91281\";i:90689;s:12:\"delete-91292\";i:90690;s:12:\"delete-91291\";i:90691;s:12:\"delete-91290\";i:90692;s:12:\"delete-91288\";i:90693;s:12:\"delete-91289\";i:90694;s:12:\"delete-91287\";i:90695;s:12:\"delete-91286\";i:90696;s:12:\"delete-91284\";i:90697;s:12:\"delete-91285\";i:90698;s:12:\"delete-91282\";i:90699;s:12:\"delete-91283\";i:90700;s:12:\"delete-91268\";i:90701;s:12:\"delete-91267\";i:90702;s:12:\"delete-91254\";i:90703;s:12:\"delete-91251\";i:90704;s:12:\"delete-91252\";i:90705;s:12:\"delete-91250\";i:90706;s:12:\"delete-91248\";i:90707;s:12:\"delete-91249\";i:90708;s:12:\"delete-91247\";i:90709;s:12:\"delete-91246\";i:90710;s:12:\"delete-91244\";i:90711;s:12:\"delete-91245\";i:90712;s:12:\"delete-91243\";i:90713;s:12:\"delete-91253\";i:90714;s:12:\"delete-91255\";i:90715;s:12:\"delete-91265\";i:90716;s:12:\"delete-91266\";i:90717;s:12:\"delete-91263\";i:90718;s:12:\"delete-91264\";i:90719;s:12:\"delete-91262\";i:90720;s:12:\"delete-91261\";i:90721;s:12:\"delete-91258\";i:90722;s:12:\"delete-91260\";i:90723;s:12:\"delete-91259\";i:90724;s:12:\"delete-91256\";i:90725;s:12:\"delete-91257\";i:90726;s:12:\"delete-91335\";i:90727;s:12:\"delete-91294\";i:90728;s:12:\"delete-91336\";i:90729;s:12:\"delete-91316\";i:90730;s:12:\"delete-91332\";i:90731;s:12:\"delete-91331\";i:90732;s:12:\"delete-91330\";i:90733;s:12:\"delete-91329\";i:90734;s:12:\"delete-91328\";i:90735;s:12:\"delete-91327\";i:90736;s:12:\"delete-91326\";i:90737;s:12:\"delete-91325\";i:90738;s:12:\"delete-91321\";i:90739;s:12:\"delete-91322\";i:90740;s:12:\"delete-91334\";i:90741;s:12:\"delete-91333\";i:90742;s:12:\"delete-91337\";i:90743;s:12:\"delete-91338\";i:90744;s:12:\"delete-91339\";i:90745;s:12:\"delete-91340\";i:90746;s:12:\"delete-91341\";i:90747;s:12:\"delete-91342\";i:90748;s:12:\"delete-91343\";i:90749;s:12:\"delete-91344\";i:90750;s:12:\"delete-91345\";i:90751;s:12:\"delete-91346\";i:90752;s:12:\"delete-91347\";i:90753;s:12:\"delete-91323\";i:90754;s:12:\"delete-91324\";i:90755;s:12:\"delete-91306\";i:90756;s:12:\"delete-91305\";i:90757;s:12:\"delete-91304\";i:90758;s:12:\"delete-91303\";i:90759;s:12:\"delete-91301\";i:90760;s:12:\"delete-91302\";i:90761;s:12:\"delete-91300\";i:90762;s:12:\"delete-91299\";i:90763;s:12:\"delete-91298\";i:90764;s:12:\"delete-91297\";i:90765;s:12:\"delete-91296\";i:90766;s:12:\"delete-91308\";i:90767;s:12:\"delete-91307\";i:90768;s:12:\"delete-91314\";i:90769;s:12:\"delete-91320\";i:90770;s:12:\"delete-91319\";i:90771;s:12:\"delete-91318\";i:90772;s:12:\"delete-91317\";i:90773;s:12:\"delete-91315\";i:90774;s:12:\"delete-91313\";i:90775;s:12:\"delete-91312\";i:90776;s:12:\"delete-91311\";i:90777;s:12:\"delete-91310\";i:90778;s:12:\"delete-91309\";i:90779;s:12:\"delete-91295\";i:90780;s:12:\"delete-91454\";i:90781;s:12:\"delete-91611\";i:90782;s:12:\"delete-91628\";i:90783;s:12:\"delete-91629\";i:90784;s:12:\"delete-91630\";i:90785;s:12:\"delete-91631\";i:90786;s:12:\"delete-91632\";i:90787;s:12:\"delete-91633\";i:90788;s:12:\"delete-91634\";i:90789;s:12:\"delete-91635\";i:90790;s:12:\"delete-91592\";i:90791;s:12:\"delete-91593\";i:90792;s:12:\"delete-91594\";i:90793;s:12:\"delete-91627\";i:90794;s:12:\"delete-91626\";i:90795;s:12:\"delete-91625\";i:90796;s:12:\"delete-91612\";i:90797;s:12:\"delete-91613\";i:90798;s:12:\"delete-91615\";i:90799;s:12:\"delete-91616\";i:90800;s:12:\"delete-91618\";i:90801;s:12:\"delete-91619\";i:90802;s:12:\"delete-91620\";i:90803;s:12:\"delete-91621\";i:90804;s:12:\"delete-91622\";i:90805;s:12:\"delete-91623\";i:90806;s:12:\"delete-91624\";i:90807;s:12:\"delete-91590\";i:90808;s:12:\"delete-91591\";i:90809;s:12:\"delete-91554\";i:90810;s:12:\"delete-91555\";i:90811;s:12:\"delete-91556\";i:90812;s:12:\"delete-91557\";i:90813;s:12:\"delete-91558\";i:90814;s:12:\"delete-91559\";i:90815;s:12:\"delete-91560\";i:90816;s:12:\"delete-91561\";i:90817;s:12:\"delete-91562\";i:90818;s:12:\"delete-91563\";i:90819;s:12:\"delete-91564\";i:90820;s:12:\"delete-91553\";i:90821;s:12:\"delete-91552\";i:90822;s:12:\"delete-91578\";i:90823;s:12:\"delete-91587\";i:90824;s:12:\"delete-91588\";i:90825;s:12:\"delete-91589\";i:90826;s:12:\"delete-91585\";i:90827;s:12:\"delete-91586\";i:90828;s:12:\"delete-91582\";i:90829;s:12:\"delete-91583\";i:90830;s:12:\"delete-91584\";i:90831;s:12:\"delete-91579\";i:90832;s:12:\"delete-91580\";i:90833;s:12:\"delete-91581\";i:90834;s:12:\"delete-91565\";i:90835;s:12:\"delete-91650\";i:90836;s:12:\"delete-91665\";i:90837;s:12:\"delete-91666\";i:90838;s:12:\"delete-91667\";i:90839;s:12:\"delete-91668\";i:90840;s:12:\"delete-91669\";i:90841;s:12:\"delete-91670\";i:90842;s:12:\"delete-91672\";i:90843;s:12:\"delete-91673\";i:90844;s:12:\"delete-91674\";i:90845;s:12:\"delete-91675\";i:90846;s:12:\"delete-91676\";i:90847;s:12:\"delete-91664\";i:90848;s:12:\"delete-91663\";i:90849;s:12:\"delete-91662\";i:90850;s:12:\"delete-91651\";i:90851;s:12:\"delete-91652\";i:90852;s:12:\"delete-91653\";i:90853;s:12:\"delete-91654\";i:90854;s:12:\"delete-91655\";i:90855;s:12:\"delete-91656\";i:90856;s:12:\"delete-91657\";i:90857;s:12:\"delete-91658\";i:90858;s:12:\"delete-91659\";i:90859;s:12:\"delete-91660\";i:90860;s:12:\"delete-91661\";i:90861;s:12:\"delete-91648\";i:90862;s:12:\"delete-91649\";i:90863;s:12:\"delete-91597\";i:90864;s:12:\"delete-91598\";i:90865;s:12:\"delete-91599\";i:90866;s:12:\"delete-91600\";i:90867;s:12:\"delete-91601\";i:90868;s:12:\"delete-91602\";i:90869;s:12:\"delete-91604\";i:90870;s:12:\"delete-91606\";i:90871;s:12:\"delete-91607\";i:90872;s:12:\"delete-91608\";i:90873;s:12:\"delete-91609\";i:90874;s:12:\"delete-91596\";i:90875;s:12:\"delete-91595\";i:90876;s:12:\"delete-91639\";i:90877;s:12:\"delete-91647\";i:90878;s:12:\"delete-91646\";i:90879;s:12:\"delete-91644\";i:90880;s:12:\"delete-91645\";i:90881;s:12:\"delete-91643\";i:90882;s:12:\"delete-91642\";i:90883;s:12:\"delete-91640\";i:90884;s:12:\"delete-91641\";i:90885;s:12:\"delete-91636\";i:90886;s:12:\"delete-91637\";i:90887;s:12:\"delete-91638\";i:90888;s:12:\"delete-91610\";i:90889;s:12:\"delete-91566\";i:90890;s:12:\"delete-91508\";i:90891;s:12:\"delete-91493\";i:90892;s:12:\"delete-91492\";i:90893;s:12:\"delete-91491\";i:90894;s:12:\"delete-91490\";i:90895;s:12:\"delete-91489\";i:90896;s:12:\"delete-91488\";i:90897;s:12:\"delete-91487\";i:90898;s:12:\"delete-91486\";i:90899;s:12:\"delete-91485\";i:90900;s:12:\"delete-91483\";i:90901;s:12:\"delete-91484\";i:90902;s:12:\"delete-91494\";i:90903;s:12:\"delete-91495\";i:90904;s:12:\"delete-91496\";i:90905;s:12:\"delete-91507\";i:90906;s:12:\"delete-91506\";i:90907;s:12:\"delete-91505\";i:90908;s:12:\"delete-91504\";i:90909;s:12:\"delete-91503\";i:90910;s:12:\"delete-91502\";i:90911;s:12:\"delete-91501\";i:90912;s:12:\"delete-91500\";i:90913;s:12:\"delete-91499\";i:90914;s:12:\"delete-91498\";i:90915;s:12:\"delete-91497\";i:90916;s:12:\"delete-91482\";i:90917;s:12:\"delete-91481\";i:90918;s:12:\"delete-91466\";i:90919;s:12:\"delete-91465\";i:90920;s:12:\"delete-91464\";i:90921;s:12:\"delete-91463\";i:90922;s:12:\"delete-91462\";i:90923;s:12:\"delete-91461\";i:90924;s:12:\"delete-91460\";i:90925;s:12:\"delete-91459\";i:90926;s:12:\"delete-91458\";i:90927;s:12:\"delete-91457\";i:90928;s:12:\"delete-91456\";i:90929;s:12:\"delete-91467\";i:90930;s:12:\"delete-91468\";i:90931;s:12:\"delete-91469\";i:90932;s:12:\"delete-91480\";i:90933;s:12:\"delete-91479\";i:90934;s:12:\"delete-91478\";i:90935;s:12:\"delete-91477\";i:90936;s:12:\"delete-91476\";i:90937;s:12:\"delete-91475\";i:90938;s:12:\"delete-91474\";i:90939;s:12:\"delete-91473\";i:90940;s:12:\"delete-91472\";i:90941;s:12:\"delete-91471\";i:90942;s:12:\"delete-91470\";i:90943;s:12:\"delete-91455\";i:90944;s:12:\"delete-91567\";i:90945;s:12:\"delete-91547\";i:90946;s:12:\"delete-91537\";i:90947;s:12:\"delete-91538\";i:90948;s:12:\"delete-91539\";i:90949;s:12:\"delete-91540\";i:90950;s:12:\"delete-91541\";i:90951;s:12:\"delete-91542\";i:90952;s:12:\"delete-91543\";i:90953;s:12:\"delete-91544\";i:90954;s:12:\"delete-91545\";i:90955;s:12:\"delete-91546\";i:90956;s:12:\"delete-91548\";i:90957;s:12:\"delete-91549\";i:90958;s:12:\"delete-91551\";i:90959;s:12:\"delete-91568\";i:90960;s:12:\"delete-91569\";i:90961;s:12:\"delete-91570\";i:90962;s:12:\"delete-91571\";i:90963;s:12:\"delete-91572\";i:90964;s:12:\"delete-91573\";i:90965;s:12:\"delete-91574\";i:90966;s:12:\"delete-91575\";i:90967;s:12:\"delete-91576\";i:90968;s:12:\"delete-91577\";i:90969;s:12:\"delete-91550\";i:90970;s:12:\"delete-91536\";i:90971;s:12:\"delete-91535\";i:90972;s:12:\"delete-91520\";i:90973;s:12:\"delete-91519\";i:90974;s:12:\"delete-91518\";i:90975;s:12:\"delete-91517\";i:90976;s:12:\"delete-91516\";i:90977;s:12:\"delete-91515\";i:90978;s:12:\"delete-91514\";i:90979;s:12:\"delete-91513\";i:90980;s:12:\"delete-91512\";i:90981;s:12:\"delete-91511\";i:90982;s:12:\"delete-91510\";i:90983;s:12:\"delete-91521\";i:90984;s:12:\"delete-91522\";i:90985;s:12:\"delete-91523\";i:90986;s:12:\"delete-91534\";i:90987;s:12:\"delete-91533\";i:90988;s:12:\"delete-91532\";i:90989;s:12:\"delete-91531\";i:90990;s:12:\"delete-91530\";i:90991;s:12:\"delete-91529\";i:90992;s:12:\"delete-91528\";i:90993;s:12:\"delete-91527\";i:90994;s:12:\"delete-91526\";i:90995;s:12:\"delete-91525\";i:90996;s:12:\"delete-91524\";i:90997;s:12:\"delete-91509\";i:90998;s:12:\"delete-91794\";i:90999;s:12:\"delete-91792\";i:91000;s:12:\"delete-91793\";i:91001;s:12:\"delete-91743\";i:91002;s:12:\"delete-91742\";i:91003;s:12:\"delete-91728\";i:91004;s:12:\"delete-91800\";i:91005;s:12:\"delete-91796\";i:91006;s:12:\"delete-91797\";i:91007;s:12:\"delete-91725\";i:91008;s:12:\"delete-91707\";i:91009;s:12:\"delete-91799\";i:91010;s:12:\"delete-91724\";i:91011;s:12:\"delete-91741\";i:91012;s:12:\"delete-91740\";i:91013;s:12:\"delete-91699\";i:91014;s:12:\"delete-91700\";i:91015;s:12:\"delete-91698\";i:91016;s:12:\"delete-91697\";i:91017;s:12:\"delete-91695\";i:91018;s:12:\"delete-91693\";i:91019;s:12:\"delete-91694\";i:91020;s:12:\"delete-91689\";i:91021;s:12:\"delete-91682\";i:91022;s:12:\"delete-91798\";i:91023;s:12:\"delete-91795\";i:91024;s:12:\"delete-91726\";i:91025;s:12:\"delete-91717\";i:91026;s:12:\"delete-91719\";i:91027;s:12:\"delete-91718\";i:91028;s:12:\"delete-91683\";i:91029;s:12:\"delete-91732\";i:91030;s:12:\"delete-91722\";i:91031;s:12:\"delete-91721\";i:91032;s:12:\"delete-91720\";i:91033;s:12:\"delete-91730\";i:91034;s:12:\"delete-91680\";i:91035;s:12:\"delete-91731\";i:91036;s:12:\"delete-91679\";i:91037;s:12:\"delete-91723\";i:91038;s:12:\"delete-91678\";i:91039;s:12:\"delete-91729\";i:91040;s:12:\"delete-91681\";i:91041;s:12:\"delete-91727\";i:91042;s:12:\"delete-91714\";i:91043;s:12:\"delete-91715\";i:91044;s:12:\"delete-91716\";i:91045;s:12:\"delete-91703\";i:91046;s:12:\"delete-91685\";i:91047;s:12:\"delete-91701\";i:91048;s:12:\"delete-91687\";i:91049;s:12:\"delete-91686\";i:91050;s:12:\"delete-91692\";i:91051;s:12:\"delete-91696\";i:91052;s:12:\"delete-91688\";i:91053;s:12:\"delete-91690\";i:91054;s:12:\"delete-91702\";i:91055;s:12:\"delete-91704\";i:91056;s:12:\"delete-91710\";i:91057;s:12:\"delete-91711\";i:91058;s:12:\"delete-91712\";i:91059;s:12:\"delete-91713\";i:91060;s:12:\"delete-91708\";i:91061;s:12:\"delete-91709\";i:91062;s:12:\"delete-91705\";i:91063;s:12:\"delete-91684\";i:91064;s:12:\"delete-91706\";i:91065;s:12:\"delete-91691\";i:91066;s:12:\"delete-91791\";i:91067;s:12:\"delete-91776\";i:91068;s:12:\"delete-91774\";i:91069;s:12:\"delete-91775\";i:91070;s:12:\"delete-91773\";i:91071;s:12:\"delete-91771\";i:91072;s:12:\"delete-91772\";i:91073;s:12:\"delete-91770\";i:91074;s:12:\"delete-91768\";i:91075;s:12:\"delete-91769\";i:91076;s:12:\"delete-91766\";i:91077;s:12:\"delete-91767\";i:91078;s:12:\"delete-91778\";i:91079;s:12:\"delete-91777\";i:91080;s:12:\"delete-91779\";i:91081;s:12:\"delete-91789\";i:91082;s:12:\"delete-91790\";i:91083;s:12:\"delete-91782\";i:91084;s:12:\"delete-91783\";i:91085;s:12:\"delete-91784\";i:91086;s:12:\"delete-91785\";i:91087;s:12:\"delete-91786\";i:91088;s:12:\"delete-91787\";i:91089;s:12:\"delete-91788\";i:91090;s:12:\"delete-91780\";i:91091;s:12:\"delete-91781\";i:91092;s:12:\"delete-91764\";i:91093;s:12:\"delete-91765\";i:91094;s:12:\"delete-91763\";i:91095;s:12:\"delete-91749\";i:91096;s:12:\"delete-91747\";i:91097;s:12:\"delete-91745\";i:91098;s:12:\"delete-91746\";i:91099;s:12:\"delete-91744\";i:91100;s:12:\"delete-91739\";i:91101;s:12:\"delete-91737\";i:91102;s:12:\"delete-91738\";i:91103;s:12:\"delete-91736\";i:91104;s:12:\"delete-91735\";i:91105;s:12:\"delete-91733\";i:91106;s:12:\"delete-91748\";i:91107;s:12:\"delete-91750\";i:91108;s:12:\"delete-91752\";i:91109;s:12:\"delete-91761\";i:91110;s:12:\"delete-91762\";i:91111;s:12:\"delete-91758\";i:91112;s:12:\"delete-91759\";i:91113;s:12:\"delete-91760\";i:91114;s:12:\"delete-91757\";i:91115;s:12:\"delete-91755\";i:91116;s:12:\"delete-91756\";i:91117;s:12:\"delete-91754\";i:91118;s:12:\"delete-91753\";i:91119;s:12:\"delete-91751\";i:91120;s:12:\"delete-91734\";i:91121;s:12:\"delete-91914\";i:91122;s:12:\"delete-91915\";i:91123;s:12:\"delete-91917\";i:91124;s:12:\"delete-91918\";i:91125;s:12:\"delete-91919\";i:91126;s:12:\"delete-91920\";i:91127;s:12:\"delete-91921\";i:91128;s:12:\"delete-91922\";i:91129;s:12:\"delete-91923\";i:91130;s:12:\"delete-91925\";i:91131;s:12:\"delete-91926\";i:91132;s:12:\"delete-91927\";i:91133;s:12:\"delete-91928\";i:91134;s:12:\"delete-91929\";i:91135;s:12:\"delete-91930\";i:91136;s:12:\"delete-91931\";i:91137;s:12:\"delete-91933\";i:91138;s:12:\"delete-91934\";i:91139;s:12:\"delete-91935\";i:91140;s:12:\"delete-91936\";i:91141;s:12:\"delete-91886\";i:91142;s:12:\"delete-91885\";i:91143;s:12:\"delete-91884\";i:91144;s:12:\"delete-91883\";i:91145;s:12:\"delete-91882\";i:91146;s:12:\"delete-91849\";i:91147;s:12:\"delete-91954\";i:91148;s:12:\"delete-91801\";i:91149;s:12:\"delete-91953\";i:91150;s:12:\"delete-91864\";i:91151;s:12:\"delete-91908\";i:91152;s:12:\"delete-91907\";i:91153;s:12:\"delete-91906\";i:91154;s:12:\"delete-91858\";i:91155;s:12:\"delete-91859\";i:91156;s:12:\"delete-91854\";i:91157;s:12:\"delete-91855\";i:91158;s:12:\"delete-91856\";i:91159;s:12:\"delete-91909\";i:91160;s:12:\"delete-91910\";i:91161;s:12:\"delete-91861\";i:91162;s:12:\"delete-91863\";i:91163;s:12:\"delete-91862\";i:91164;s:12:\"delete-91860\";i:91165;s:12:\"delete-91913\";i:91166;s:12:\"delete-91912\";i:91167;s:12:\"delete-91857\";i:91168;s:12:\"delete-91911\";i:91169;s:12:\"delete-91853\";i:91170;s:12:\"delete-91852\";i:91171;s:12:\"delete-91836\";i:91172;s:12:\"delete-91835\";i:91173;s:12:\"delete-91834\";i:91174;s:12:\"delete-91832\";i:91175;s:12:\"delete-91831\";i:91176;s:12:\"delete-91829\";i:91177;s:12:\"delete-91830\";i:91178;s:12:\"delete-91828\";i:91179;s:12:\"delete-91826\";i:91180;s:12:\"delete-91827\";i:91181;s:12:\"delete-91837\";i:91182;s:12:\"delete-91841\";i:91183;s:12:\"delete-91840\";i:91184;s:12:\"delete-91851\";i:91185;s:12:\"delete-91850\";i:91186;s:12:\"delete-91846\";i:91187;s:12:\"delete-91842\";i:91188;s:12:\"delete-91843\";i:91189;s:12:\"delete-91848\";i:91190;s:12:\"delete-91845\";i:91191;s:12:\"delete-91844\";i:91192;s:12:\"delete-91838\";i:91193;s:12:\"delete-91839\";i:91194;s:12:\"delete-91833\";i:91195;s:12:\"delete-91952\";i:91196;s:12:\"delete-91889\";i:91197;s:12:\"delete-91869\";i:91198;s:12:\"delete-91887\";i:91199;s:12:\"delete-91881\";i:91200;s:12:\"delete-91880\";i:91201;s:12:\"delete-91879\";i:91202;s:12:\"delete-91877\";i:91203;s:12:\"delete-91876\";i:91204;s:12:\"delete-91873\";i:91205;s:12:\"delete-91872\";i:91206;s:12:\"delete-91871\";i:91207;s:12:\"delete-91870\";i:91208;s:12:\"delete-91868\";i:91209;s:12:\"delete-91867\";i:91210;s:12:\"delete-91866\";i:91211;s:12:\"delete-91865\";i:91212;s:12:\"delete-91890\";i:91213;s:12:\"delete-91891\";i:91214;s:12:\"delete-91900\";i:91215;s:12:\"delete-91899\";i:91216;s:12:\"delete-91898\";i:91217;s:12:\"delete-91897\";i:91218;s:12:\"delete-91888\";i:91219;s:12:\"delete-91896\";i:91220;s:12:\"delete-91895\";i:91221;s:12:\"delete-91878\";i:91222;s:12:\"delete-91894\";i:91223;s:12:\"delete-91892\";i:91224;s:12:\"delete-91893\";i:91225;s:12:\"delete-91951\";i:91226;s:12:\"delete-91950\";i:91227;s:12:\"delete-91949\";i:91228;s:12:\"delete-91818\";i:91229;s:12:\"delete-91820\";i:91230;s:12:\"delete-91821\";i:91231;s:12:\"delete-91819\";i:91232;s:12:\"delete-91816\";i:91233;s:12:\"delete-91817\";i:91234;s:12:\"delete-91807\";i:91235;s:12:\"delete-91822\";i:91236;s:12:\"delete-91947\";i:91237;s:12:\"delete-91812\";i:91238;s:12:\"delete-91932\";i:91239;s:12:\"delete-91948\";i:91240;s:12:\"delete-91946\";i:91241;s:12:\"delete-91945\";i:91242;s:12:\"delete-91944\";i:91243;s:12:\"delete-91943\";i:91244;s:12:\"delete-91942\";i:91245;s:12:\"delete-91941\";i:91246;s:12:\"delete-91940\";i:91247;s:12:\"delete-91939\";i:91248;s:12:\"delete-91938\";i:91249;s:12:\"delete-91937\";i:91250;s:12:\"delete-91847\";i:91251;s:12:\"delete-91916\";i:91252;s:12:\"delete-91875\";i:91253;s:12:\"delete-91874\";i:91254;s:12:\"delete-91924\";i:91255;s:12:\"delete-91903\";i:91256;s:12:\"delete-91902\";i:91257;s:12:\"delete-91904\";i:91258;s:12:\"delete-91905\";i:91259;s:12:\"delete-91901\";i:91260;s:12:\"delete-91802\";i:91261;s:12:\"delete-91805\";i:91262;s:12:\"delete-91804\";i:91263;s:12:\"delete-91803\";i:91264;s:12:\"delete-91806\";i:91265;s:12:\"delete-91825\";i:91266;s:12:\"delete-91808\";i:91267;s:12:\"delete-91810\";i:91268;s:12:\"delete-91809\";i:91269;s:12:\"delete-91813\";i:91270;s:12:\"delete-91811\";i:91271;s:12:\"delete-91814\";i:91272;s:12:\"delete-91815\";i:91273;s:12:\"delete-91823\";i:91274;s:12:\"delete-91824\";i:91275;s:12:\"delete-92064\";i:91276;s:12:\"delete-92014\";i:91277;s:12:\"delete-92000\";i:91278;s:12:\"delete-92015\";i:91279;s:12:\"delete-92003\";i:91280;s:12:\"delete-92021\";i:91281;s:12:\"delete-92023\";i:91282;s:12:\"delete-92025\";i:91283;s:12:\"delete-92024\";i:91284;s:12:\"delete-92022\";i:91285;s:12:\"delete-91955\";i:91286;s:12:\"delete-92005\";i:91287;s:12:\"delete-92063\";i:91288;s:12:\"delete-91997\";i:91289;s:12:\"delete-91990\";i:91290;s:12:\"delete-91989\";i:91291;s:12:\"delete-91988\";i:91292;s:12:\"delete-91987\";i:91293;s:12:\"delete-91986\";i:91294;s:12:\"delete-91985\";i:91295;s:12:\"delete-91982\";i:91296;s:12:\"delete-91983\";i:91297;s:12:\"delete-91992\";i:91298;s:12:\"delete-91991\";i:91299;s:12:\"delete-92001\";i:91300;s:12:\"delete-91998\";i:91301;s:12:\"delete-92002\";i:91302;s:12:\"delete-91999\";i:91303;s:12:\"delete-91996\";i:91304;s:12:\"delete-92004\";i:91305;s:12:\"delete-91994\";i:91306;s:12:\"delete-91993\";i:91307;s:12:\"delete-91995\";i:91308;s:12:\"delete-91984\";i:91309;s:12:\"delete-91975\";i:91310;s:12:\"delete-91965\";i:91311;s:12:\"delete-91966\";i:91312;s:12:\"delete-91963\";i:91313;s:12:\"delete-91964\";i:91314;s:12:\"delete-91962\";i:91315;s:12:\"delete-91961\";i:91316;s:12:\"delete-91957\";i:91317;s:12:\"delete-91958\";i:91318;s:12:\"delete-91960\";i:91319;s:12:\"delete-91959\";i:91320;s:12:\"delete-91956\";i:91321;s:12:\"delete-91968\";i:91322;s:12:\"delete-91967\";i:91323;s:12:\"delete-91981\";i:91324;s:12:\"delete-91979\";i:91325;s:12:\"delete-91977\";i:91326;s:12:\"delete-91978\";i:91327;s:12:\"delete-91976\";i:91328;s:12:\"delete-91974\";i:91329;s:12:\"delete-91972\";i:91330;s:12:\"delete-91973\";i:91331;s:12:\"delete-91970\";i:91332;s:12:\"delete-91971\";i:91333;s:12:\"delete-91969\";i:91334;s:12:\"delete-91980\";i:91335;s:12:\"delete-92018\";i:91336;s:12:\"delete-92051\";i:91337;s:12:\"delete-92050\";i:91338;s:12:\"delete-92049\";i:91339;s:12:\"delete-92048\";i:91340;s:12:\"delete-92047\";i:91341;s:12:\"delete-92046\";i:91342;s:12:\"delete-92045\";i:91343;s:12:\"delete-92044\";i:91344;s:12:\"delete-92043\";i:91345;s:12:\"delete-92042\";i:91346;s:12:\"delete-92052\";i:91347;s:12:\"delete-92053\";i:91348;s:12:\"delete-92054\";i:91349;s:12:\"delete-92019\";i:91350;s:12:\"delete-92020\";i:91351;s:12:\"delete-92062\";i:91352;s:12:\"delete-92061\";i:91353;s:12:\"delete-92060\";i:91354;s:12:\"delete-92059\";i:91355;s:12:\"delete-92058\";i:91356;s:12:\"delete-92057\";i:91357;s:12:\"delete-92056\";i:91358;s:12:\"delete-92055\";i:91359;s:12:\"delete-92041\";i:91360;s:12:\"delete-92040\";i:91361;s:12:\"delete-92032\";i:91362;s:12:\"delete-92016\";i:91363;s:12:\"delete-92017\";i:91364;s:12:\"delete-92013\";i:91365;s:12:\"delete-92012\";i:91366;s:12:\"delete-92006\";i:91367;s:12:\"delete-92007\";i:91368;s:12:\"delete-92008\";i:91369;s:12:\"delete-92011\";i:91370;s:12:\"delete-92010\";i:91371;s:12:\"delete-92031\";i:91372;s:12:\"delete-92030\";i:91373;s:12:\"delete-92029\";i:91374;s:12:\"delete-92039\";i:91375;s:12:\"delete-92038\";i:91376;s:12:\"delete-92037\";i:91377;s:12:\"delete-92036\";i:91378;s:12:\"delete-92035\";i:91379;s:12:\"delete-92033\";i:91380;s:12:\"delete-92034\";i:91381;s:12:\"delete-92026\";i:91382;s:12:\"delete-92027\";i:91383;s:12:\"delete-92028\";i:91384;s:12:\"delete-92009\";i:91385;s:12:\"delete-92065\";i:91386;s:12:\"delete-92101\";i:91387;s:12:\"delete-92102\";i:91388;s:12:\"delete-92103\";i:91389;s:12:\"delete-92100\";i:91390;s:12:\"delete-92099\";i:91391;s:12:\"delete-92098\";i:91392;s:12:\"delete-92097\";i:91393;s:12:\"delete-92096\";i:91394;s:12:\"delete-92093\";i:91395;s:12:\"delete-92094\";i:91396;s:12:\"delete-92095\";i:91397;s:12:\"delete-92104\";i:91398;s:12:\"delete-92113\";i:91399;s:12:\"delete-92118\";i:91400;s:12:\"delete-92116\";i:91401;s:12:\"delete-92115\";i:91402;s:12:\"delete-92114\";i:91403;s:12:\"delete-92105\";i:91404;s:12:\"delete-92106\";i:91405;s:12:\"delete-92107\";i:91406;s:12:\"delete-92108\";i:91407;s:12:\"delete-92109\";i:91408;s:12:\"delete-92110\";i:91409;s:12:\"delete-92111\";i:91410;s:12:\"delete-92112\";i:91411;s:12:\"delete-92092\";i:91412;s:12:\"delete-92085\";i:91413;s:12:\"delete-92078\";i:91414;s:12:\"delete-92075\";i:91415;s:12:\"delete-92073\";i:91416;s:12:\"delete-92074\";i:91417;s:12:\"delete-92072\";i:91418;s:12:\"delete-92069\";i:91419;s:12:\"delete-92070\";i:91420;s:12:\"delete-92071\";i:91421;s:12:\"delete-92067\";i:91422;s:12:\"delete-92068\";i:91423;s:12:\"delete-92066\";i:91424;s:12:\"delete-92077\";i:91425;s:12:\"delete-92076\";i:91426;s:12:\"delete-92091\";i:91427;s:12:\"delete-92089\";i:91428;s:12:\"delete-92088\";i:91429;s:12:\"delete-92086\";i:91430;s:12:\"delete-92087\";i:91431;s:12:\"delete-92080\";i:91432;s:12:\"delete-92081\";i:91433;s:12:\"delete-92082\";i:91434;s:12:\"delete-92083\";i:91435;s:12:\"delete-92084\";i:91436;s:12:\"delete-92079\";i:91437;s:12:\"delete-92090\";i:91438;s:12:\"delete-92117\";i:91439;s:12:\"delete-92128\";i:91440;s:12:\"delete-92142\";i:91441;s:12:\"delete-92143\";i:91442;s:12:\"delete-92144\";i:91443;s:12:\"delete-92145\";i:91444;s:12:\"delete-92146\";i:91445;s:12:\"delete-92147\";i:91446;s:12:\"delete-92148\";i:91447;s:12:\"delete-92149\";i:91448;s:12:\"delete-92150\";i:91449;s:12:\"delete-92151\";i:91450;s:12:\"delete-92152\";i:91451;s:12:\"delete-92141\";i:91452;s:12:\"delete-92140\";i:91453;s:12:\"delete-92129\";i:91454;s:12:\"delete-92130\";i:91455;s:12:\"delete-92131\";i:91456;s:12:\"delete-92132\";i:91457;s:12:\"delete-92133\";i:91458;s:12:\"delete-92134\";i:91459;s:12:\"delete-92135\";i:91460;s:12:\"delete-92136\";i:91461;s:12:\"delete-92137\";i:91462;s:12:\"delete-92138\";i:91463;s:12:\"delete-92139\";i:91464;s:12:\"delete-92153\";i:91465;s:12:\"delete-92154\";i:91466;s:12:\"delete-92155\";i:91467;s:12:\"delete-92169\";i:91468;s:12:\"delete-92170\";i:91469;s:12:\"delete-92171\";i:91470;s:12:\"delete-92124\";i:91471;s:12:\"delete-92125\";i:91472;s:12:\"delete-92126\";i:91473;s:12:\"delete-92127\";i:91474;s:12:\"delete-92119\";i:91475;s:12:\"delete-92120\";i:91476;s:12:\"delete-92123\";i:91477;s:12:\"delete-92122\";i:91478;s:12:\"delete-92168\";i:91479;s:12:\"delete-92167\";i:91480;s:12:\"delete-92156\";i:91481;s:12:\"delete-92157\";i:91482;s:12:\"delete-92158\";i:91483;s:12:\"delete-92159\";i:91484;s:12:\"delete-92160\";i:91485;s:12:\"delete-92161\";i:91486;s:12:\"delete-92162\";i:91487;s:12:\"delete-92163\";i:91488;s:12:\"delete-92164\";i:91489;s:12:\"delete-92165\";i:91490;s:12:\"delete-92166\";i:91491;s:12:\"delete-92121\";i:91492;s:12:\"delete-92172\";i:91493;s:12:\"delete-92179\";i:91494;s:12:\"delete-92174\";i:91495;s:12:\"delete-92175\";i:91496;s:12:\"delete-92176\";i:91497;s:12:\"delete-92177\";i:91498;s:12:\"delete-92178\";i:91499;s:12:\"delete-92173\";i:91500;s:12:\"delete-92355\";i:91501;s:12:\"delete-92354\";i:91502;s:12:\"delete-92353\";i:91503;s:12:\"delete-92352\";i:91504;s:12:\"delete-92351\";i:91505;s:12:\"delete-92350\";i:91506;s:12:\"delete-92349\";i:91507;s:12:\"delete-92348\";i:91508;s:12:\"delete-92334\";i:91509;s:12:\"delete-92347\";i:91510;s:12:\"delete-92356\";i:91511;s:12:\"delete-92357\";i:91512;s:12:\"delete-92358\";i:91513;s:12:\"delete-92370\";i:91514;s:12:\"delete-92368\";i:91515;s:12:\"delete-92367\";i:91516;s:12:\"delete-92366\";i:91517;s:12:\"delete-92365\";i:91518;s:12:\"delete-92364\";i:91519;s:12:\"delete-92363\";i:91520;s:12:\"delete-92362\";i:91521;s:12:\"delete-92361\";i:91522;s:12:\"delete-92360\";i:91523;s:12:\"delete-92359\";i:91524;s:12:\"delete-92346\";i:91525;s:12:\"delete-92345\";i:91526;s:12:\"delete-92344\";i:91527;s:12:\"delete-92329\";i:91528;s:12:\"delete-92328\";i:91529;s:12:\"delete-92327\";i:91530;s:12:\"delete-92326\";i:91531;s:12:\"delete-92325\";i:91532;s:12:\"delete-92324\";i:91533;s:12:\"delete-92323\";i:91534;s:12:\"delete-92322\";i:91535;s:12:\"delete-92321\";i:91536;s:12:\"delete-92320\";i:91537;s:12:\"delete-92330\";i:91538;s:12:\"delete-92331\";i:91539;s:12:\"delete-92332\";i:91540;s:12:\"delete-92343\";i:91541;s:12:\"delete-92342\";i:91542;s:12:\"delete-92341\";i:91543;s:12:\"delete-92340\";i:91544;s:12:\"delete-92339\";i:91545;s:12:\"delete-92338\";i:91546;s:12:\"delete-92337\";i:91547;s:12:\"delete-92336\";i:91548;s:12:\"delete-92335\";i:91549;s:12:\"delete-92333\";i:91550;s:12:\"delete-92319\";i:91551;s:12:\"delete-92369\";i:91552;s:12:\"delete-92422\";i:91553;s:12:\"delete-92408\";i:91554;s:12:\"delete-92407\";i:91555;s:12:\"delete-92406\";i:91556;s:12:\"delete-92405\";i:91557;s:12:\"delete-92404\";i:91558;s:12:\"delete-92403\";i:91559;s:12:\"delete-92402\";i:91560;s:12:\"delete-92401\";i:91561;s:12:\"delete-92400\";i:91562;s:12:\"delete-92399\";i:91563;s:12:\"delete-92398\";i:91564;s:12:\"delete-92411\";i:91565;s:12:\"delete-92410\";i:91566;s:12:\"delete-92421\";i:91567;s:12:\"delete-92419\";i:91568;s:12:\"delete-92420\";i:91569;s:12:\"delete-92418\";i:91570;s:12:\"delete-92417\";i:91571;s:12:\"delete-92416\";i:91572;s:12:\"delete-92415\";i:91573;s:12:\"delete-92414\";i:91574;s:12:\"delete-92412\";i:91575;s:12:\"delete-92413\";i:91576;s:12:\"delete-92409\";i:91577;s:12:\"delete-92397\";i:91578;s:12:\"delete-92396\";i:91579;s:12:\"delete-92382\";i:91580;s:12:\"delete-92381\";i:91581;s:12:\"delete-92380\";i:91582;s:12:\"delete-92379\";i:91583;s:12:\"delete-92378\";i:91584;s:12:\"delete-92377\";i:91585;s:12:\"delete-92376\";i:91586;s:12:\"delete-92374\";i:91587;s:12:\"delete-92375\";i:91588;s:12:\"delete-92373\";i:91589;s:12:\"delete-92372\";i:91590;s:12:\"delete-92384\";i:91591;s:12:\"delete-92385\";i:91592;s:12:\"delete-92395\";i:91593;s:12:\"delete-92394\";i:91594;s:12:\"delete-92393\";i:91595;s:12:\"delete-92392\";i:91596;s:12:\"delete-92391\";i:91597;s:12:\"delete-92390\";i:91598;s:12:\"delete-92389\";i:91599;s:12:\"delete-92388\";i:91600;s:12:\"delete-92387\";i:91601;s:12:\"delete-92386\";i:91602;s:12:\"delete-92383\";i:91603;s:12:\"delete-92371\";i:91604;s:12:\"delete-92318\";i:91605;s:12:\"delete-92261\";i:91606;s:12:\"delete-92224\";i:91607;s:12:\"delete-92211\";i:91608;s:12:\"delete-92213\";i:91609;s:12:\"delete-92214\";i:91610;s:12:\"delete-92216\";i:91611;s:12:\"delete-92215\";i:91612;s:12:\"delete-92212\";i:91613;s:12:\"delete-92209\";i:91614;s:12:\"delete-92210\";i:91615;s:12:\"delete-92208\";i:91616;s:12:\"delete-92207\";i:91617;s:12:\"delete-92225\";i:91618;s:12:\"delete-92226\";i:91619;s:12:\"delete-92260\";i:91620;s:12:\"delete-92259\";i:91621;s:12:\"delete-92245\";i:91622;s:12:\"delete-92228\";i:91623;s:12:\"delete-92231\";i:91624;s:12:\"delete-92232\";i:91625;s:12:\"delete-92233\";i:91626;s:12:\"delete-92234\";i:91627;s:12:\"delete-92235\";i:91628;s:12:\"delete-92239\";i:91629;s:12:\"delete-92240\";i:91630;s:12:\"delete-92206\";i:91631;s:12:\"delete-92205\";i:91632;s:12:\"delete-92196\";i:91633;s:12:\"delete-92189\";i:91634;s:12:\"delete-92190\";i:91635;s:12:\"delete-92184\";i:91636;s:12:\"delete-92185\";i:91637;s:12:\"delete-92186\";i:91638;s:12:\"delete-92187\";i:91639;s:12:\"delete-92188\";i:91640;s:12:\"delete-92183\";i:91641;s:12:\"delete-92180\";i:91642;s:12:\"delete-92181\";i:91643;s:12:\"delete-92195\";i:91644;s:12:\"delete-92194\";i:91645;s:12:\"delete-92203\";i:91646;s:12:\"delete-92204\";i:91647;s:12:\"delete-92201\";i:91648;s:12:\"delete-92202\";i:91649;s:12:\"delete-92200\";i:91650;s:12:\"delete-92199\";i:91651;s:12:\"delete-92198\";i:91652;s:12:\"delete-92197\";i:91653;s:12:\"delete-92191\";i:91654;s:12:\"delete-92192\";i:91655;s:12:\"delete-92193\";i:91656;s:12:\"delete-92182\";i:91657;s:12:\"delete-92317\";i:91658;s:12:\"delete-92303\";i:91659;s:12:\"delete-92302\";i:91660;s:12:\"delete-92301\";i:91661;s:12:\"delete-92300\";i:91662;s:12:\"delete-92299\";i:91663;s:12:\"delete-92298\";i:91664;s:12:\"delete-92297\";i:91665;s:12:\"delete-92296\";i:91666;s:12:\"delete-92295\";i:91667;s:12:\"delete-92294\";i:91668;s:12:\"delete-92293\";i:91669;s:12:\"delete-92304\";i:91670;s:12:\"delete-92305\";i:91671;s:12:\"delete-92316\";i:91672;s:12:\"delete-92315\";i:91673;s:12:\"delete-92314\";i:91674;s:12:\"delete-92313\";i:91675;s:12:\"delete-92312\";i:91676;s:12:\"delete-92311\";i:91677;s:12:\"delete-92310\";i:91678;s:12:\"delete-92309\";i:91679;s:12:\"delete-92308\";i:91680;s:12:\"delete-92307\";i:91681;s:12:\"delete-92306\";i:91682;s:12:\"delete-92292\";i:91683;s:12:\"delete-92291\";i:91684;s:12:\"delete-92276\";i:91685;s:12:\"delete-92271\";i:91686;s:12:\"delete-92272\";i:91687;s:12:\"delete-92273\";i:91688;s:12:\"delete-92274\";i:91689;s:12:\"delete-92275\";i:91690;s:12:\"delete-92270\";i:91691;s:12:\"delete-92268\";i:91692;s:12:\"delete-92269\";i:91693;s:12:\"delete-92267\";i:91694;s:12:\"delete-92266\";i:91695;s:12:\"delete-92277\";i:91696;s:12:\"delete-92278\";i:91697;s:12:\"delete-92290\";i:91698;s:12:\"delete-92289\";i:91699;s:12:\"delete-92287\";i:91700;s:12:\"delete-92286\";i:91701;s:12:\"delete-92285\";i:91702;s:12:\"delete-92284\";i:91703;s:12:\"delete-92283\";i:91704;s:12:\"delete-92282\";i:91705;s:12:\"delete-92281\";i:91706;s:12:\"delete-92280\";i:91707;s:12:\"delete-92279\";i:91708;s:12:\"delete-92265\";i:91709;s:12:\"delete-92639\";i:91710;s:12:\"delete-92472\";i:91711;s:12:\"delete-92473\";i:91712;s:12:\"delete-92471\";i:91713;s:12:\"delete-92470\";i:91714;s:12:\"delete-92469\";i:91715;s:12:\"delete-92468\";i:91716;s:12:\"delete-92467\";i:91717;s:12:\"delete-92466\";i:91718;s:12:\"delete-92465\";i:91719;s:12:\"delete-92464\";i:91720;s:12:\"delete-92463\";i:91721;s:12:\"delete-92462\";i:91722;s:12:\"delete-92461\";i:91723;s:12:\"delete-92460\";i:91724;s:12:\"delete-92459\";i:91725;s:12:\"delete-92475\";i:91726;s:12:\"delete-92487\";i:91727;s:12:\"delete-92638\";i:91728;s:12:\"delete-92637\";i:91729;s:12:\"delete-92288\";i:91730;s:12:\"delete-92474\";i:91731;s:12:\"delete-92476\";i:91732;s:12:\"delete-92477\";i:91733;s:12:\"delete-92478\";i:91734;s:12:\"delete-92479\";i:91735;s:12:\"delete-92480\";i:91736;s:12:\"delete-92481\";i:91737;s:12:\"delete-92482\";i:91738;s:12:\"delete-92483\";i:91739;s:12:\"delete-92484\";i:91740;s:12:\"delete-92485\";i:91741;s:12:\"delete-92486\";i:91742;s:12:\"delete-92458\";i:91743;s:12:\"delete-92457\";i:91744;s:12:\"delete-92423\";i:91745;s:12:\"delete-92438\";i:91746;s:12:\"delete-92437\";i:91747;s:12:\"delete-92436\";i:91748;s:12:\"delete-92435\";i:91749;s:12:\"delete-92434\";i:91750;s:12:\"delete-92433\";i:91751;s:12:\"delete-92432\";i:91752;s:12:\"delete-92431\";i:91753;s:12:\"delete-92430\";i:91754;s:12:\"delete-92429\";i:91755;s:12:\"delete-92428\";i:91756;s:12:\"delete-92427\";i:91757;s:12:\"delete-92426\";i:91758;s:12:\"delete-92425\";i:91759;s:12:\"delete-92424\";i:91760;s:12:\"delete-92439\";i:91761;s:12:\"delete-92440\";i:91762;s:12:\"delete-92456\";i:91763;s:12:\"delete-92455\";i:91764;s:12:\"delete-92454\";i:91765;s:12:\"delete-92453\";i:91766;s:12:\"delete-92452\";i:91767;s:12:\"delete-92451\";i:91768;s:12:\"delete-92450\";i:91769;s:12:\"delete-92449\";i:91770;s:12:\"delete-92448\";i:91771;s:12:\"delete-92443\";i:91772;s:12:\"delete-92441\";i:91773;s:12:\"delete-92444\";i:91774;s:12:\"delete-92442\";i:91775;s:12:\"delete-92445\";i:91776;s:12:\"delete-92446\";i:91777;s:12:\"delete-92447\";i:91778;s:12:\"delete-92603\";i:91779;s:12:\"delete-92236\";i:91780;s:12:\"delete-92601\";i:91781;s:12:\"delete-92602\";i:91782;s:12:\"delete-92598\";i:91783;s:12:\"delete-92599\";i:91784;s:12:\"delete-92230\";i:91785;s:12:\"delete-92229\";i:91786;s:12:\"delete-92600\";i:91787;s:12:\"delete-92237\";i:91788;s:12:\"delete-92582\";i:91789;s:12:\"delete-92604\";i:91790;s:12:\"delete-92220\";i:91791;s:12:\"delete-92222\";i:91792;s:12:\"delete-92221\";i:91793;s:12:\"delete-92608\";i:91794;s:12:\"delete-92607\";i:91795;s:12:\"delete-92606\";i:91796;s:12:\"delete-92227\";i:91797;s:12:\"delete-92223\";i:91798;s:12:\"delete-92605\";i:91799;s:12:\"delete-92241\";i:91800;s:12:\"delete-92242\";i:91801;s:12:\"delete-92254\";i:91802;s:12:\"delete-92255\";i:91803;s:12:\"delete-92256\";i:91804;s:12:\"delete-92257\";i:91805;s:12:\"delete-92258\";i:91806;s:12:\"delete-92596\";i:91807;s:12:\"delete-92579\";i:91808;s:12:\"delete-92262\";i:91809;s:12:\"delete-92263\";i:91810;s:12:\"delete-92253\";i:91811;s:12:\"delete-92252\";i:91812;s:12:\"delete-92243\";i:91813;s:12:\"delete-92244\";i:91814;s:12:\"delete-92597\";i:91815;s:12:\"delete-92246\";i:91816;s:12:\"delete-92247\";i:91817;s:12:\"delete-92248\";i:91818;s:12:\"delete-92249\";i:91819;s:12:\"delete-92250\";i:91820;s:12:\"delete-92251\";i:91821;s:12:\"delete-92264\";i:91822;s:12:\"delete-92238\";i:91823;s:12:\"delete-92618\";i:91824;s:12:\"delete-92619\";i:91825;s:12:\"delete-92620\";i:91826;s:12:\"delete-92621\";i:91827;s:12:\"delete-92622\";i:91828;s:12:\"delete-92623\";i:91829;s:12:\"delete-92624\";i:91830;s:12:\"delete-92625\";i:91831;s:12:\"delete-92626\";i:91832;s:12:\"delete-92617\";i:91833;s:12:\"delete-92616\";i:91834;s:12:\"delete-92632\";i:91835;s:12:\"delete-92633\";i:91836;s:12:\"delete-92634\";i:91837;s:12:\"delete-92635\";i:91838;s:12:\"delete-92636\";i:91839;s:12:\"delete-92612\";i:91840;s:12:\"delete-92613\";i:91841;s:12:\"delete-92614\";i:91842;s:12:\"delete-92615\";i:91843;s:12:\"delete-92627\";i:91844;s:12:\"delete-92628\";i:91845;s:12:\"delete-92629\";i:91846;s:12:\"delete-92592\";i:91847;s:12:\"delete-92593\";i:91848;s:12:\"delete-92594\";i:91849;s:12:\"delete-92595\";i:91850;s:12:\"delete-92217\";i:91851;s:12:\"delete-92611\";i:91852;s:12:\"delete-92610\";i:91853;s:12:\"delete-92609\";i:91854;s:12:\"delete-92218\";i:91855;s:12:\"delete-92591\";i:91856;s:12:\"delete-92590\";i:91857;s:12:\"delete-92630\";i:91858;s:12:\"delete-92631\";i:91859;s:12:\"delete-92583\";i:91860;s:12:\"delete-92584\";i:91861;s:12:\"delete-92585\";i:91862;s:12:\"delete-92586\";i:91863;s:12:\"delete-92587\";i:91864;s:12:\"delete-92588\";i:91865;s:12:\"delete-92589\";i:91866;s:12:\"delete-92219\";i:91867;s:12:\"delete-92540\";i:91868;s:12:\"delete-92520\";i:91869;s:12:\"delete-92519\";i:91870;s:12:\"delete-92518\";i:91871;s:12:\"delete-92517\";i:91872;s:12:\"delete-92516\";i:91873;s:12:\"delete-92515\";i:91874;s:12:\"delete-92514\";i:91875;s:12:\"delete-92513\";i:91876;s:12:\"delete-92512\";i:91877;s:12:\"delete-92521\";i:91878;s:12:\"delete-92522\";i:91879;s:12:\"delete-92523\";i:91880;s:12:\"delete-92530\";i:91881;s:12:\"delete-92532\";i:91882;s:12:\"delete-92531\";i:91883;s:12:\"delete-92526\";i:91884;s:12:\"delete-92527\";i:91885;s:12:\"delete-92529\";i:91886;s:12:\"delete-92528\";i:91887;s:12:\"delete-92525\";i:91888;s:12:\"delete-92524\";i:91889;s:12:\"delete-92511\";i:91890;s:12:\"delete-92510\";i:91891;s:12:\"delete-92497\";i:91892;s:12:\"delete-92496\";i:91893;s:12:\"delete-92495\";i:91894;s:12:\"delete-92494\";i:91895;s:12:\"delete-92493\";i:91896;s:12:\"delete-92492\";i:91897;s:12:\"delete-92491\";i:91898;s:12:\"delete-92490\";i:91899;s:12:\"delete-92489\";i:91900;s:12:\"delete-92498\";i:91901;s:12:\"delete-92499\";i:91902;s:12:\"delete-92500\";i:91903;s:12:\"delete-92509\";i:91904;s:12:\"delete-92508\";i:91905;s:12:\"delete-92507\";i:91906;s:12:\"delete-92506\";i:91907;s:12:\"delete-92505\";i:91908;s:12:\"delete-92504\";i:91909;s:12:\"delete-92503\";i:91910;s:12:\"delete-92502\";i:91911;s:12:\"delete-92501\";i:91912;s:12:\"delete-92488\";i:91913;s:12:\"delete-92541\";i:91914;s:12:\"delete-92580\";i:91915;s:12:\"delete-92574\";i:91916;s:12:\"delete-92573\";i:91917;s:12:\"delete-92572\";i:91918;s:12:\"delete-92571\";i:91919;s:12:\"delete-92570\";i:91920;s:12:\"delete-92569\";i:91921;s:12:\"delete-92568\";i:91922;s:12:\"delete-92567\";i:91923;s:12:\"delete-92566\";i:91924;s:12:\"delete-92539\";i:91925;s:12:\"delete-92538\";i:91926;s:12:\"delete-92537\";i:91927;s:12:\"delete-92581\";i:91928;s:12:\"delete-92578\";i:91929;s:12:\"delete-92575\";i:91930;s:12:\"delete-92576\";i:91931;s:12:\"delete-92577\";i:91932;s:12:\"delete-92533\";i:91933;s:12:\"delete-92534\";i:91934;s:12:\"delete-92535\";i:91935;s:12:\"delete-92536\";i:91936;s:12:\"delete-92565\";i:91937;s:12:\"delete-92564\";i:91938;s:12:\"delete-92551\";i:91939;s:12:\"delete-92550\";i:91940;s:12:\"delete-92549\";i:91941;s:12:\"delete-92548\";i:91942;s:12:\"delete-92547\";i:91943;s:12:\"delete-92546\";i:91944;s:12:\"delete-92545\";i:91945;s:12:\"delete-92544\";i:91946;s:12:\"delete-92543\";i:91947;s:12:\"delete-92552\";i:91948;s:12:\"delete-92553\";i:91949;s:12:\"delete-92554\";i:91950;s:12:\"delete-92563\";i:91951;s:12:\"delete-92562\";i:91952;s:12:\"delete-92561\";i:91953;s:12:\"delete-92560\";i:91954;s:12:\"delete-92559\";i:91955;s:12:\"delete-92558\";i:91956;s:12:\"delete-92557\";i:91957;s:12:\"delete-92556\";i:91958;s:12:\"delete-92555\";i:91959;s:12:\"delete-92542\";i:91960;s:12:\"delete-93118\";i:91961;s:12:\"delete-93116\";i:91962;s:12:\"delete-93117\";i:91963;s:12:\"delete-93115\";i:91964;s:12:\"delete-93114\";i:91965;s:12:\"delete-93113\";i:91966;s:12:\"delete-93112\";i:91967;s:12:\"delete-93111\";i:91968;s:12:\"delete-93110\";i:91969;s:12:\"delete-93109\";i:91970;s:12:\"delete-93108\";i:91971;s:12:\"delete-93104\";i:91972;s:12:\"delete-93105\";i:91973;s:12:\"delete-93106\";i:91974;s:12:\"delete-93107\";i:91975;s:12:\"delete-93103\";i:91976;s:12:\"delete-93102\";i:91977;s:12:\"delete-93101\";i:91978;s:12:\"delete-93100\";i:91979;s:12:\"delete-93099\";i:91980;s:12:\"delete-93098\";i:91981;s:12:\"delete-93097\";i:91982;s:12:\"delete-93096\";i:91983;s:12:\"delete-93095\";i:91984;s:12:\"delete-93094\";i:91985;s:12:\"delete-93093\";i:91986;s:12:\"delete-93092\";i:91987;s:12:\"delete-93091\";i:91988;s:12:\"delete-93059\";i:91989;s:12:\"delete-93060\";i:91990;s:12:\"delete-93061\";i:91991;s:12:\"delete-93062\";i:91992;s:12:\"delete-93063\";i:91993;s:12:\"delete-93064\";i:91994;s:12:\"delete-93065\";i:91995;s:12:\"delete-93066\";i:91996;s:12:\"delete-93067\";i:91997;s:12:\"delete-93068\";i:91998;s:12:\"delete-93069\";i:91999;s:12:\"delete-93070\";i:92000;s:12:\"delete-93071\";i:92001;s:12:\"delete-93072\";i:92002;s:12:\"delete-93073\";i:92003;s:12:\"delete-93074\";i:92004;s:12:\"delete-93075\";i:92005;s:12:\"delete-93076\";i:92006;s:12:\"delete-93077\";i:92007;s:12:\"delete-93078\";i:92008;s:12:\"delete-93079\";i:92009;s:12:\"delete-93080\";i:92010;s:12:\"delete-93081\";i:92011;s:12:\"delete-93082\";i:92012;s:12:\"delete-93083\";i:92013;s:12:\"delete-93084\";i:92014;s:12:\"delete-93085\";i:92015;s:12:\"delete-93086\";i:92016;s:12:\"delete-93087\";i:92017;s:12:\"delete-93088\";i:92018;s:12:\"delete-93089\";i:92019;s:12:\"delete-93090\";i:92020;s:12:\"delete-93057\";i:92021;s:12:\"delete-93058\";i:92022;s:12:\"delete-93054\";i:92023;s:12:\"delete-93055\";i:92024;s:12:\"delete-93056\";i:92025;s:12:\"delete-93053\";i:92026;s:12:\"delete-93042\";i:92027;s:12:\"delete-93043\";i:92028;s:12:\"delete-93044\";i:92029;s:12:\"delete-93045\";i:92030;s:12:\"delete-93052\";i:92031;s:12:\"delete-93051\";i:92032;s:12:\"delete-93050\";i:92033;s:12:\"delete-93049\";i:92034;s:12:\"delete-93048\";i:92035;s:12:\"delete-93047\";i:92036;s:12:\"delete-93046\";i:92037;s:12:\"delete-93041\";i:92038;s:12:\"delete-93039\";i:92039;s:12:\"delete-93040\";i:92040;s:12:\"delete-93038\";i:92041;s:12:\"delete-93037\";i:92042;s:12:\"delete-93036\";i:92043;s:12:\"delete-93035\";i:92044;s:12:\"delete-93034\";i:92045;s:12:\"delete-93033\";i:92046;s:12:\"delete-93032\";i:92047;s:12:\"delete-93031\";i:92048;s:12:\"delete-93030\";i:92049;s:12:\"delete-93029\";i:92050;s:12:\"delete-93028\";i:92051;s:12:\"delete-93027\";i:92052;s:12:\"delete-93026\";i:92053;s:12:\"delete-93025\";i:92054;s:12:\"delete-93024\";i:92055;s:12:\"delete-93022\";i:92056;s:12:\"delete-93023\";i:92057;s:12:\"delete-93021\";i:92058;s:12:\"delete-93020\";i:92059;s:12:\"delete-93019\";i:92060;s:12:\"delete-93018\";i:92061;s:12:\"delete-93017\";i:92062;s:12:\"delete-93016\";i:92063;s:12:\"delete-93015\";i:92064;s:12:\"delete-93014\";i:92065;s:12:\"delete-93013\";i:92066;s:12:\"delete-93012\";i:92067;s:12:\"delete-93011\";i:92068;s:12:\"delete-93010\";i:92069;s:12:\"delete-93009\";i:92070;s:12:\"delete-93008\";i:92071;s:12:\"delete-93006\";i:92072;s:12:\"delete-93007\";i:92073;s:12:\"delete-93005\";i:92074;s:12:\"delete-93004\";i:92075;s:12:\"delete-93003\";i:92076;s:12:\"delete-93002\";i:92077;s:12:\"delete-93000\";i:92078;s:12:\"delete-93001\";i:92079;s:12:\"delete-92999\";i:92080;s:12:\"delete-92998\";i:92081;s:12:\"delete-92997\";i:92082;s:12:\"delete-92996\";i:92083;s:12:\"delete-92995\";i:92084;s:12:\"delete-92994\";i:92085;s:12:\"delete-92993\";i:92086;s:12:\"delete-92992\";i:92087;s:12:\"delete-92991\";i:92088;s:12:\"delete-92990\";i:92089;s:12:\"delete-92989\";i:92090;s:12:\"delete-92988\";i:92091;s:12:\"delete-92987\";i:92092;s:12:\"delete-92986\";i:92093;s:12:\"delete-92984\";i:92094;s:12:\"delete-92985\";i:92095;s:12:\"delete-92983\";i:92096;s:12:\"delete-92982\";i:92097;s:12:\"delete-92981\";i:92098;s:12:\"delete-92980\";i:92099;s:12:\"delete-92979\";i:92100;s:12:\"delete-92978\";i:92101;s:12:\"delete-92977\";i:92102;s:12:\"delete-92976\";i:92103;s:12:\"delete-92975\";i:92104;s:12:\"delete-92974\";i:92105;s:12:\"delete-92973\";i:92106;s:12:\"delete-92972\";i:92107;s:12:\"delete-92971\";i:92108;s:12:\"delete-92970\";i:92109;s:12:\"delete-92969\";i:92110;s:12:\"delete-92968\";i:92111;s:12:\"delete-92967\";i:92112;s:12:\"delete-92966\";i:92113;s:12:\"delete-92965\";i:92114;s:12:\"delete-92964\";i:92115;s:12:\"delete-92962\";i:92116;s:12:\"delete-92963\";i:92117;s:12:\"delete-92961\";i:92118;s:12:\"delete-92946\";i:92119;s:12:\"delete-92947\";i:92120;s:12:\"delete-92948\";i:92121;s:12:\"delete-92949\";i:92122;s:12:\"delete-92950\";i:92123;s:12:\"delete-92951\";i:92124;s:12:\"delete-92952\";i:92125;s:12:\"delete-92953\";i:92126;s:12:\"delete-92954\";i:92127;s:12:\"delete-92955\";i:92128;s:12:\"delete-92956\";i:92129;s:12:\"delete-92957\";i:92130;s:12:\"delete-92958\";i:92131;s:12:\"delete-92959\";i:92132;s:12:\"delete-93146\";i:92133;s:12:\"delete-93145\";i:92134;s:12:\"delete-93144\";i:92135;s:12:\"delete-93143\";i:92136;s:12:\"delete-93142\";i:92137;s:12:\"delete-93141\";i:92138;s:12:\"delete-93140\";i:92139;s:12:\"delete-93139\";i:92140;s:12:\"delete-93138\";i:92141;s:12:\"delete-93137\";i:92142;s:12:\"delete-93136\";i:92143;s:12:\"delete-93135\";i:92144;s:12:\"delete-93134\";i:92145;s:12:\"delete-93133\";i:92146;s:12:\"delete-93132\";i:92147;s:12:\"delete-93131\";i:92148;s:12:\"delete-93129\";i:92149;s:12:\"delete-93130\";i:92150;s:12:\"delete-93128\";i:92151;s:12:\"delete-93127\";i:92152;s:12:\"delete-93126\";i:92153;s:12:\"delete-93125\";i:92154;s:12:\"delete-93124\";i:92155;s:12:\"delete-93123\";i:92156;s:12:\"delete-93122\";i:92157;s:12:\"delete-92960\";i:92158;s:12:\"delete-92945\";i:92159;s:12:\"delete-92942\";i:92160;s:12:\"delete-92943\";i:92161;s:12:\"delete-92944\";i:92162;s:12:\"delete-93121\";i:92163;s:12:\"delete-93120\";i:92164;s:12:\"delete-93119\";i:92165;s:12:\"delete-92941\";i:92166;s:12:\"delete-92940\";i:92167;s:12:\"delete-92939\";i:92168;s:12:\"delete-92938\";i:92169;s:12:\"delete-92937\";i:92170;s:12:\"delete-92936\";i:92171;s:12:\"delete-92935\";i:92172;s:12:\"delete-92934\";i:92173;s:12:\"delete-92933\";i:92174;s:12:\"delete-92932\";i:92175;s:12:\"delete-92931\";i:92176;s:12:\"delete-92930\";i:92177;s:12:\"delete-92929\";i:92178;s:12:\"delete-92928\";i:92179;s:12:\"delete-92927\";i:92180;s:12:\"delete-92926\";i:92181;s:12:\"delete-92925\";i:92182;s:12:\"delete-92924\";i:92183;s:12:\"delete-92923\";i:92184;s:12:\"delete-92922\";i:92185;s:12:\"delete-92921\";i:92186;s:12:\"delete-92920\";i:92187;s:12:\"delete-92919\";i:92188;s:12:\"delete-92918\";i:92189;s:12:\"delete-92917\";i:92190;s:12:\"delete-92916\";i:92191;s:12:\"delete-92915\";i:92192;s:12:\"delete-92914\";i:92193;s:12:\"delete-92913\";i:92194;s:12:\"delete-92912\";i:92195;s:12:\"delete-92911\";i:92196;s:12:\"delete-92910\";i:92197;s:12:\"delete-92909\";i:92198;s:12:\"delete-92908\";i:92199;s:12:\"delete-92907\";i:92200;s:12:\"delete-92906\";i:92201;s:12:\"delete-92905\";i:92202;s:12:\"delete-92904\";i:92203;s:12:\"delete-92903\";i:92204;s:12:\"delete-92902\";i:92205;s:12:\"delete-92901\";i:92206;s:12:\"delete-92900\";i:92207;s:12:\"delete-92899\";i:92208;s:12:\"delete-92898\";i:92209;s:12:\"delete-92897\";i:92210;s:12:\"delete-92896\";i:92211;s:12:\"delete-92895\";i:92212;s:12:\"delete-92894\";i:92213;s:12:\"delete-92893\";i:92214;s:12:\"delete-92892\";i:92215;s:12:\"delete-92891\";i:92216;s:12:\"delete-92890\";i:92217;s:12:\"delete-92889\";i:92218;s:12:\"delete-92888\";i:92219;s:12:\"delete-92887\";i:92220;s:12:\"delete-92886\";i:92221;s:12:\"delete-92885\";i:92222;s:12:\"delete-92884\";i:92223;s:12:\"delete-92883\";i:92224;s:12:\"delete-92879\";i:92225;s:12:\"delete-92880\";i:92226;s:12:\"delete-92882\";i:92227;s:12:\"delete-92881\";i:92228;s:12:\"delete-92878\";i:92229;s:12:\"delete-92877\";i:92230;s:12:\"delete-92876\";i:92231;s:12:\"delete-92875\";i:92232;s:12:\"delete-92874\";i:92233;s:12:\"delete-92873\";i:92234;s:12:\"delete-92872\";i:92235;s:12:\"delete-92871\";i:92236;s:12:\"delete-92870\";i:92237;s:12:\"delete-92869\";i:92238;s:12:\"delete-92868\";i:92239;s:12:\"delete-92867\";i:92240;s:12:\"delete-92866\";i:92241;s:12:\"delete-92865\";i:92242;s:12:\"delete-92864\";i:92243;s:12:\"delete-92863\";i:92244;s:12:\"delete-92862\";i:92245;s:12:\"delete-92861\";i:92246;s:12:\"delete-92860\";i:92247;s:12:\"delete-92859\";i:92248;s:12:\"delete-92858\";i:92249;s:12:\"delete-92857\";i:92250;s:12:\"delete-92854\";i:92251;s:12:\"delete-92856\";i:92252;s:12:\"delete-92855\";i:92253;s:12:\"delete-92853\";i:92254;s:12:\"delete-92852\";i:92255;s:12:\"delete-92851\";i:92256;s:12:\"delete-92850\";i:92257;s:12:\"delete-92849\";i:92258;s:12:\"delete-92848\";i:92259;s:12:\"delete-92847\";i:92260;s:12:\"delete-92846\";i:92261;s:12:\"delete-92844\";i:92262;s:12:\"delete-92845\";i:92263;s:12:\"delete-92843\";i:92264;s:12:\"delete-92842\";i:92265;s:12:\"delete-92841\";i:92266;s:12:\"delete-92839\";i:92267;s:12:\"delete-92840\";i:92268;s:12:\"delete-92838\";i:92269;s:12:\"delete-92837\";i:92270;s:12:\"delete-92836\";i:92271;s:12:\"delete-92835\";i:92272;s:12:\"delete-92834\";i:92273;s:12:\"delete-92833\";i:92274;s:12:\"delete-92832\";i:92275;s:12:\"delete-92831\";i:92276;s:12:\"delete-92830\";i:92277;s:12:\"delete-92829\";i:92278;s:12:\"delete-92828\";i:92279;s:12:\"delete-92827\";i:92280;s:12:\"delete-92825\";i:92281;s:12:\"delete-92826\";i:92282;s:12:\"delete-92824\";i:92283;s:12:\"delete-92823\";i:92284;s:12:\"delete-92822\";i:92285;s:12:\"delete-92821\";i:92286;s:12:\"delete-92820\";i:92287;s:12:\"delete-92819\";i:92288;s:12:\"delete-92818\";i:92289;s:12:\"delete-92817\";i:92290;s:12:\"delete-92816\";i:92291;s:12:\"delete-92815\";i:92292;s:12:\"delete-92814\";i:92293;s:12:\"delete-92813\";i:92294;s:12:\"delete-92812\";i:92295;s:12:\"delete-92811\";i:92296;s:12:\"delete-92810\";i:92297;s:12:\"delete-92809\";i:92298;s:12:\"delete-92808\";i:92299;s:12:\"delete-92807\";i:92300;s:12:\"delete-92806\";i:92301;s:12:\"delete-92805\";i:92302;s:12:\"delete-92804\";i:92303;s:12:\"delete-92803\";i:92304;s:12:\"delete-92802\";i:92305;s:12:\"delete-92801\";i:92306;s:12:\"delete-92800\";i:92307;s:12:\"delete-92799\";i:92308;s:12:\"delete-92798\";i:92309;s:12:\"delete-92797\";i:92310;s:12:\"delete-92796\";i:92311;s:12:\"delete-92795\";i:92312;s:12:\"delete-92794\";i:92313;s:12:\"delete-92793\";i:92314;s:12:\"delete-92792\";i:92315;s:12:\"delete-92791\";i:92316;s:12:\"delete-92790\";i:92317;s:12:\"delete-92789\";i:92318;s:12:\"delete-92788\";i:92319;s:12:\"delete-92787\";i:92320;s:12:\"delete-92786\";i:92321;s:12:\"delete-92785\";i:92322;s:12:\"delete-92784\";i:92323;s:12:\"delete-92783\";i:92324;s:12:\"delete-92782\";i:92325;s:12:\"delete-92781\";i:92326;s:12:\"delete-92780\";i:92327;s:12:\"delete-92779\";i:92328;s:12:\"delete-92778\";i:92329;s:12:\"delete-92777\";i:92330;s:12:\"delete-92776\";i:92331;s:12:\"delete-92775\";i:92332;s:12:\"delete-92774\";i:92333;s:12:\"delete-92773\";i:92334;s:12:\"delete-92772\";i:92335;s:12:\"delete-92771\";i:92336;s:12:\"delete-92770\";i:92337;s:12:\"delete-92769\";i:92338;s:12:\"delete-92768\";i:92339;s:12:\"delete-92767\";i:92340;s:12:\"delete-92766\";i:92341;s:12:\"delete-92765\";i:92342;s:12:\"delete-92764\";i:92343;s:12:\"delete-92763\";i:92344;s:12:\"delete-92762\";i:92345;s:12:\"delete-92761\";i:92346;s:12:\"delete-92760\";i:92347;s:12:\"delete-92759\";i:92348;s:12:\"delete-92758\";i:92349;s:12:\"delete-92757\";i:92350;s:12:\"delete-92756\";i:92351;s:12:\"delete-92755\";i:92352;s:12:\"delete-92754\";i:92353;s:12:\"delete-92752\";i:92354;s:12:\"delete-92753\";i:92355;s:12:\"delete-92751\";i:92356;s:12:\"delete-92750\";i:92357;s:12:\"delete-92749\";i:92358;s:12:\"delete-92748\";i:92359;s:12:\"delete-92747\";i:92360;s:12:\"delete-92746\";i:92361;s:12:\"delete-92745\";i:92362;s:12:\"delete-92739\";i:92363;s:12:\"delete-92740\";i:92364;s:12:\"delete-92741\";i:92365;s:12:\"delete-92742\";i:92366;s:12:\"delete-92743\";i:92367;s:12:\"delete-92744\";i:92368;s:12:\"delete-92737\";i:92369;s:12:\"delete-92738\";i:92370;s:12:\"delete-92735\";i:92371;s:12:\"delete-92736\";i:92372;s:12:\"delete-92733\";i:92373;s:12:\"delete-92734\";i:92374;s:12:\"delete-92731\";i:92375;s:12:\"delete-92732\";i:92376;s:12:\"delete-92729\";i:92377;s:12:\"delete-92730\";i:92378;s:12:\"delete-92727\";i:92379;s:12:\"delete-92728\";i:92380;s:12:\"delete-92726\";i:92381;s:12:\"delete-92725\";i:92382;s:12:\"delete-92724\";i:92383;s:12:\"delete-92723\";i:92384;s:12:\"delete-92722\";i:92385;s:12:\"delete-92721\";i:92386;s:12:\"delete-92720\";i:92387;s:12:\"delete-92719\";i:92388;s:12:\"delete-92718\";i:92389;s:12:\"delete-92716\";i:92390;s:12:\"delete-92717\";i:92391;s:12:\"delete-92714\";i:92392;s:12:\"delete-92715\";i:92393;s:12:\"delete-92712\";i:92394;s:12:\"delete-92713\";i:92395;s:12:\"delete-92710\";i:92396;s:12:\"delete-92711\";i:92397;s:12:\"delete-92701\";i:92398;s:12:\"delete-92697\";i:92399;s:12:\"delete-92698\";i:92400;s:12:\"delete-92699\";i:92401;s:12:\"delete-92700\";i:92402;s:12:\"delete-92709\";i:92403;s:12:\"delete-92708\";i:92404;s:12:\"delete-92707\";i:92405;s:12:\"delete-92706\";i:92406;s:12:\"delete-92705\";i:92407;s:12:\"delete-92704\";i:92408;s:12:\"delete-92703\";i:92409;s:12:\"delete-92702\";i:92410;s:12:\"delete-92691\";i:92411;s:12:\"delete-92692\";i:92412;s:12:\"delete-92696\";i:92413;s:12:\"delete-92695\";i:92414;s:12:\"delete-92694\";i:92415;s:12:\"delete-92693\";i:92416;s:12:\"delete-92690\";i:92417;s:12:\"delete-92688\";i:92418;s:12:\"delete-92689\";i:92419;s:12:\"delete-92687\";i:92420;s:12:\"delete-92681\";i:92421;s:12:\"delete-92682\";i:92422;s:12:\"delete-92683\";i:92423;s:12:\"delete-92684\";i:92424;s:12:\"delete-92685\";i:92425;s:12:\"delete-92686\";i:92426;s:12:\"delete-92678\";i:92427;s:12:\"delete-92679\";i:92428;s:12:\"delete-92680\";i:92429;s:12:\"delete-92677\";i:92430;s:12:\"delete-92676\";i:92431;s:12:\"delete-92674\";i:92432;s:12:\"delete-92675\";i:92433;s:12:\"delete-92670\";i:92434;s:12:\"delete-92671\";i:92435;s:12:\"delete-92672\";i:92436;s:12:\"delete-92673\";i:92437;s:12:\"delete-92668\";i:92438;s:12:\"delete-92669\";i:92439;s:12:\"delete-92667\";i:92440;s:12:\"delete-92666\";i:92441;s:12:\"delete-92665\";i:92442;s:12:\"delete-92664\";i:92443;s:12:\"delete-92657\";i:92444;s:12:\"delete-92658\";i:92445;s:12:\"delete-92659\";i:92446;s:12:\"delete-92660\";i:92447;s:12:\"delete-92661\";i:92448;s:12:\"delete-92662\";i:92449;s:12:\"delete-92663\";i:92450;s:12:\"delete-92651\";i:92451;s:12:\"delete-92652\";i:92452;s:12:\"delete-92653\";i:92453;s:12:\"delete-92654\";i:92454;s:12:\"delete-92655\";i:92455;s:12:\"delete-92656\";i:92456;s:12:\"delete-92647\";i:92457;s:12:\"delete-92648\";i:92458;s:12:\"delete-92649\";i:92459;s:12:\"delete-92650\";i:92460;s:12:\"delete-92642\";i:92461;s:12:\"delete-92646\";i:92462;s:12:\"delete-92645\";i:92463;s:12:\"delete-92643\";i:92464;s:12:\"delete-92644\";i:92465;s:12:\"delete-92641\";i:92466;s:12:\"delete-92640\";i:92467;s:12:\"delete-93147\";i:92468;s:12:\"delete-93148\";i:92469;s:12:\"delete-93149\";i:92470;s:12:\"delete-93150\";i:92471;s:12:\"delete-93151\";i:92472;s:12:\"delete-93152\";i:92473;s:12:\"delete-93153\";i:92474;s:12:\"delete-93154\";i:92475;s:12:\"delete-93155\";i:92476;s:12:\"delete-93156\";i:92477;s:12:\"delete-93157\";i:92478;s:12:\"delete-93158\";i:92479;s:12:\"delete-93159\";i:92480;s:12:\"delete-93160\";i:92481;s:12:\"delete-93161\";i:92482;s:12:\"delete-93162\";i:92483;s:12:\"delete-93163\";i:92484;s:12:\"delete-93164\";i:92485;s:12:\"delete-93165\";i:92486;s:12:\"delete-93166\";i:92487;s:12:\"delete-93167\";i:92488;s:12:\"delete-93168\";i:92489;s:12:\"delete-93169\";i:92490;s:12:\"delete-93170\";i:92491;s:12:\"delete-93171\";i:92492;s:12:\"delete-93172\";i:92493;s:12:\"delete-93173\";i:92494;s:12:\"delete-93174\";i:92495;s:12:\"delete-93175\";i:92496;s:12:\"delete-93176\";i:92497;s:12:\"delete-93177\";i:92498;s:12:\"delete-93178\";i:92499;s:12:\"delete-93179\";i:92500;s:12:\"delete-93180\";i:92501;s:12:\"delete-93181\";i:92502;s:12:\"delete-93182\";i:92503;s:12:\"delete-93183\";i:92504;s:12:\"delete-93184\";i:92505;s:12:\"delete-93185\";i:92506;s:12:\"delete-93186\";i:92507;s:12:\"delete-93187\";i:92508;s:12:\"delete-93188\";i:92509;s:12:\"delete-93189\";i:92510;s:12:\"delete-93190\";i:92511;s:12:\"delete-93191\";i:92512;s:12:\"delete-93192\";i:92513;s:12:\"delete-93193\";i:92514;s:12:\"delete-93194\";i:92515;s:12:\"delete-93195\";i:92516;s:12:\"delete-93827\";i:92517;s:12:\"delete-93829\";i:92518;s:12:\"delete-93831\";i:92519;s:12:\"delete-93833\";i:92520;s:12:\"delete-93835\";i:92521;s:12:\"delete-93837\";i:92522;s:12:\"delete-93841\";i:92523;s:12:\"delete-93305\";i:92524;s:12:\"delete-93310\";i:92525;s:12:\"delete-93311\";i:92526;s:12:\"delete-93312\";i:92527;s:12:\"delete-93313\";i:92528;s:12:\"delete-93314\";i:92529;s:12:\"delete-93820\";i:92530;s:12:\"delete-93821\";i:92531;s:12:\"delete-93822\";i:92532;s:12:\"delete-93823\";i:92533;s:12:\"delete-93825\";i:92534;s:12:\"delete-93824\";i:92535;s:12:\"delete-93826\";i:92536;s:12:\"delete-93828\";i:92537;s:12:\"delete-93830\";i:92538;s:12:\"delete-93832\";i:92539;s:12:\"delete-93834\";i:92540;s:12:\"delete-93836\";i:92541;s:12:\"delete-93838\";i:92542;s:12:\"delete-93839\";i:92543;s:12:\"delete-93840\";i:92544;s:12:\"delete-93304\";i:92545;s:12:\"delete-93303\";i:92546;s:12:\"delete-93301\";i:92547;s:12:\"delete-93300\";i:92548;s:12:\"delete-93299\";i:92549;s:12:\"delete-93298\";i:92550;s:12:\"delete-93302\";i:92551;s:12:\"delete-93297\";i:92552;s:12:\"delete-93661\";i:92553;s:12:\"delete-93636\";i:92554;s:12:\"delete-93669\";i:92555;s:12:\"delete-93668\";i:92556;s:12:\"delete-93667\";i:92557;s:12:\"delete-93662\";i:92558;s:12:\"delete-93663\";i:92559;s:12:\"delete-93664\";i:92560;s:12:\"delete-93666\";i:92561;s:12:\"delete-93665\";i:92562;s:12:\"delete-93644\";i:92563;s:12:\"delete-93643\";i:92564;s:12:\"delete-93642\";i:92565;s:12:\"delete-93645\";i:92566;s:12:\"delete-93628\";i:92567;s:12:\"delete-93629\";i:92568;s:12:\"delete-93634\";i:92569;s:12:\"delete-93772\";i:92570;s:12:\"delete-93768\";i:92571;s:12:\"delete-93770\";i:92572;s:12:\"delete-93766\";i:92573;s:12:\"delete-93773\";i:92574;s:12:\"delete-93774\";i:92575;s:12:\"delete-93775\";i:92576;s:12:\"delete-93769\";i:92577;s:12:\"delete-93767\";i:92578;s:12:\"delete-93765\";i:92579;s:12:\"delete-93764\";i:92580;s:12:\"delete-93763\";i:92581;s:12:\"delete-93762\";i:92582;s:12:\"delete-93761\";i:92583;s:12:\"delete-93771\";i:92584;s:12:\"delete-93700\";i:92585;s:12:\"delete-93777\";i:92586;s:12:\"delete-93778\";i:92587;s:12:\"delete-93819\";i:92588;s:12:\"delete-93807\";i:92589;s:12:\"delete-93779\";i:92590;s:12:\"delete-93780\";i:92591;s:12:\"delete-93806\";i:92592;s:12:\"delete-93805\";i:92593;s:12:\"delete-93804\";i:92594;s:12:\"delete-93803\";i:92595;s:12:\"delete-93802\";i:92596;s:12:\"delete-93808\";i:92597;s:12:\"delete-93809\";i:92598;s:12:\"delete-93810\";i:92599;s:12:\"delete-93818\";i:92600;s:12:\"delete-93817\";i:92601;s:12:\"delete-93815\";i:92602;s:12:\"delete-93816\";i:92603;s:12:\"delete-93813\";i:92604;s:12:\"delete-93814\";i:92605;s:12:\"delete-93811\";i:92606;s:12:\"delete-93812\";i:92607;s:12:\"delete-93801\";i:92608;s:12:\"delete-93800\";i:92609;s:12:\"delete-93793\";i:92610;s:12:\"delete-93776\";i:92611;s:12:\"delete-93781\";i:92612;s:12:\"delete-93782\";i:92613;s:12:\"delete-93790\";i:92614;s:12:\"delete-93784\";i:92615;s:12:\"delete-93791\";i:92616;s:12:\"delete-93792\";i:92617;s:12:\"delete-93794\";i:92618;s:12:\"delete-93789\";i:92619;s:12:\"delete-93795\";i:92620;s:12:\"delete-93799\";i:92621;s:12:\"delete-93798\";i:92622;s:12:\"delete-93783\";i:92623;s:12:\"delete-93785\";i:92624;s:12:\"delete-93797\";i:92625;s:12:\"delete-93787\";i:92626;s:12:\"delete-93796\";i:92627;s:12:\"delete-93786\";i:92628;s:12:\"delete-93788\";i:92629;s:12:\"delete-93448\";i:92630;s:12:\"delete-93449\";i:92631;s:12:\"delete-93450\";i:92632;s:12:\"delete-93451\";i:92633;s:12:\"delete-93447\";i:92634;s:12:\"delete-93452\";i:92635;s:12:\"delete-93454\";i:92636;s:12:\"delete-93464\";i:92637;s:12:\"delete-93463\";i:92638;s:12:\"delete-93462\";i:92639;s:12:\"delete-93461\";i:92640;s:12:\"delete-93460\";i:92641;s:12:\"delete-93453\";i:92642;s:12:\"delete-93459\";i:92643;s:12:\"delete-93458\";i:92644;s:12:\"delete-93457\";i:92645;s:12:\"delete-93456\";i:92646;s:12:\"delete-93455\";i:92647;s:12:\"delete-93446\";i:92648;s:12:\"delete-93445\";i:92649;s:12:\"delete-93444\";i:92650;s:12:\"delete-93431\";i:92651;s:12:\"delete-93430\";i:92652;s:12:\"delete-93429\";i:92653;s:12:\"delete-93428\";i:92654;s:12:\"delete-93427\";i:92655;s:12:\"delete-93426\";i:92656;s:12:\"delete-93425\";i:92657;s:12:\"delete-93424\";i:92658;s:12:\"delete-93422\";i:92659;s:12:\"delete-93423\";i:92660;s:12:\"delete-93432\";i:92661;s:12:\"delete-93433\";i:92662;s:12:\"delete-93435\";i:92663;s:12:\"delete-93443\";i:92664;s:12:\"delete-93442\";i:92665;s:12:\"delete-93441\";i:92666;s:12:\"delete-93440\";i:92667;s:12:\"delete-93439\";i:92668;s:12:\"delete-93438\";i:92669;s:12:\"delete-93437\";i:92670;s:12:\"delete-93436\";i:92671;s:12:\"delete-93434\";i:92672;s:12:\"delete-93420\";i:92673;s:12:\"delete-93524\";i:92674;s:12:\"delete-93508\";i:92675;s:12:\"delete-93507\";i:92676;s:12:\"delete-93506\";i:92677;s:12:\"delete-93505\";i:92678;s:12:\"delete-93504\";i:92679;s:12:\"delete-93503\";i:92680;s:12:\"delete-93502\";i:92681;s:12:\"delete-93501\";i:92682;s:12:\"delete-93500\";i:92683;s:12:\"delete-93499\";i:92684;s:12:\"delete-93498\";i:92685;s:12:\"delete-93497\";i:92686;s:12:\"delete-93496\";i:92687;s:12:\"delete-93509\";i:92688;s:12:\"delete-93510\";i:92689;s:12:\"delete-93523\";i:92690;s:12:\"delete-93522\";i:92691;s:12:\"delete-93521\";i:92692;s:12:\"delete-93520\";i:92693;s:12:\"delete-93519\";i:92694;s:12:\"delete-93518\";i:92695;s:12:\"delete-93517\";i:92696;s:12:\"delete-93516\";i:92697;s:12:\"delete-93515\";i:92698;s:12:\"delete-93513\";i:92699;s:12:\"delete-93514\";i:92700;s:12:\"delete-93511\";i:92701;s:12:\"delete-93512\";i:92702;s:12:\"delete-93495\";i:92703;s:12:\"delete-93494\";i:92704;s:12:\"delete-93478\";i:92705;s:12:\"delete-93477\";i:92706;s:12:\"delete-93476\";i:92707;s:12:\"delete-93475\";i:92708;s:12:\"delete-93474\";i:92709;s:12:\"delete-93473\";i:92710;s:12:\"delete-93472\";i:92711;s:12:\"delete-93471\";i:92712;s:12:\"delete-93470\";i:92713;s:12:\"delete-93469\";i:92714;s:12:\"delete-93468\";i:92715;s:12:\"delete-93467\";i:92716;s:12:\"delete-93466\";i:92717;s:12:\"delete-93479\";i:92718;s:12:\"delete-93480\";i:92719;s:12:\"delete-93493\";i:92720;s:12:\"delete-93492\";i:92721;s:12:\"delete-93491\";i:92722;s:12:\"delete-93490\";i:92723;s:12:\"delete-93489\";i:92724;s:12:\"delete-93488\";i:92725;s:12:\"delete-93487\";i:92726;s:12:\"delete-93486\";i:92727;s:12:\"delete-93485\";i:92728;s:12:\"delete-93484\";i:92729;s:12:\"delete-93483\";i:92730;s:12:\"delete-93482\";i:92731;s:12:\"delete-93481\";i:92732;s:12:\"delete-93465\";i:92733;s:12:\"delete-93367\";i:92734;s:12:\"delete-93356\";i:92735;s:12:\"delete-93357\";i:92736;s:12:\"delete-93351\";i:92737;s:12:\"delete-93350\";i:92738;s:12:\"delete-93349\";i:92739;s:12:\"delete-93348\";i:92740;s:12:\"delete-93338\";i:92741;s:12:\"delete-93339\";i:92742;s:12:\"delete-93347\";i:92743;s:12:\"delete-93346\";i:92744;s:12:\"delete-93345\";i:92745;s:12:\"delete-93355\";i:92746;s:12:\"delete-93354\";i:92747;s:12:\"delete-93366\";i:92748;s:12:\"delete-93365\";i:92749;s:12:\"delete-93362\";i:92750;s:12:\"delete-93363\";i:92751;s:12:\"delete-93364\";i:92752;s:12:\"delete-93361\";i:92753;s:12:\"delete-93358\";i:92754;s:12:\"delete-93359\";i:92755;s:12:\"delete-93360\";i:92756;s:12:\"delete-93352\";i:92757;s:12:\"delete-93353\";i:92758;s:12:\"delete-93344\";i:92759;s:12:\"delete-93343\";i:92760;s:12:\"delete-93342\";i:92761;s:12:\"delete-93326\";i:92762;s:12:\"delete-93325\";i:92763;s:12:\"delete-93324\";i:92764;s:12:\"delete-93323\";i:92765;s:12:\"delete-93322\";i:92766;s:12:\"delete-93321\";i:92767;s:12:\"delete-93320\";i:92768;s:12:\"delete-93319\";i:92769;s:12:\"delete-93318\";i:92770;s:12:\"delete-93317\";i:92771;s:12:\"delete-93316\";i:92772;s:12:\"delete-93327\";i:92773;s:12:\"delete-93328\";i:92774;s:12:\"delete-93341\";i:92775;s:12:\"delete-93340\";i:92776;s:12:\"delete-93337\";i:92777;s:12:\"delete-93336\";i:92778;s:12:\"delete-93335\";i:92779;s:12:\"delete-93334\";i:92780;s:12:\"delete-93333\";i:92781;s:12:\"delete-93331\";i:92782;s:12:\"delete-93332\";i:92783;s:12:\"delete-93330\";i:92784;s:12:\"delete-93329\";i:92785;s:12:\"delete-93315\";i:92786;s:12:\"delete-93421\";i:92787;s:12:\"delete-93406\";i:92788;s:12:\"delete-93404\";i:92789;s:12:\"delete-93405\";i:92790;s:12:\"delete-93402\";i:92791;s:12:\"delete-93403\";i:92792;s:12:\"delete-93399\";i:92793;s:12:\"delete-93400\";i:92794;s:12:\"delete-93401\";i:92795;s:12:\"delete-93397\";i:92796;s:12:\"delete-93398\";i:92797;s:12:\"delete-93395\";i:92798;s:12:\"delete-93407\";i:92799;s:12:\"delete-93410\";i:92800;s:12:\"delete-93418\";i:92801;s:12:\"delete-93419\";i:92802;s:12:\"delete-93417\";i:92803;s:12:\"delete-93414\";i:92804;s:12:\"delete-93415\";i:92805;s:12:\"delete-93416\";i:92806;s:12:\"delete-93412\";i:92807;s:12:\"delete-93413\";i:92808;s:12:\"delete-93411\";i:92809;s:12:\"delete-93408\";i:92810;s:12:\"delete-93409\";i:92811;s:12:\"delete-93396\";i:92812;s:12:\"delete-93389\";i:92813;s:12:\"delete-93390\";i:92814;s:12:\"delete-93379\";i:92815;s:12:\"delete-93378\";i:92816;s:12:\"delete-93376\";i:92817;s:12:\"delete-93377\";i:92818;s:12:\"delete-93375\";i:92819;s:12:\"delete-93374\";i:92820;s:12:\"delete-93371\";i:92821;s:12:\"delete-93372\";i:92822;s:12:\"delete-93373\";i:92823;s:12:\"delete-93370\";i:92824;s:12:\"delete-93369\";i:92825;s:12:\"delete-93380\";i:92826;s:12:\"delete-93382\";i:92827;s:12:\"delete-93391\";i:92828;s:12:\"delete-93392\";i:92829;s:12:\"delete-93393\";i:92830;s:12:\"delete-93394\";i:92831;s:12:\"delete-93388\";i:92832;s:12:\"delete-93387\";i:92833;s:12:\"delete-93385\";i:92834;s:12:\"delete-93386\";i:92835;s:12:\"delete-93384\";i:92836;s:12:\"delete-93383\";i:92837;s:12:\"delete-93381\";i:92838;s:12:\"delete-93368\";i:92839;s:12:\"delete-93704\";i:92840;s:12:\"delete-93689\";i:92841;s:12:\"delete-93687\";i:92842;s:12:\"delete-93641\";i:92843;s:12:\"delete-93646\";i:92844;s:12:\"delete-93647\";i:92845;s:12:\"delete-93648\";i:92846;s:12:\"delete-93649\";i:92847;s:12:\"delete-93650\";i:92848;s:12:\"delete-93651\";i:92849;s:12:\"delete-93652\";i:92850;s:12:\"delete-93653\";i:92851;s:12:\"delete-93688\";i:92852;s:12:\"delete-93690\";i:92853;s:12:\"delete-93691\";i:92854;s:12:\"delete-93703\";i:92855;s:12:\"delete-93702\";i:92856;s:12:\"delete-93701\";i:92857;s:12:\"delete-93699\";i:92858;s:12:\"delete-93698\";i:92859;s:12:\"delete-93697\";i:92860;s:12:\"delete-93696\";i:92861;s:12:\"delete-93695\";i:92862;s:12:\"delete-93694\";i:92863;s:12:\"delete-93693\";i:92864;s:12:\"delete-93692\";i:92865;s:12:\"delete-93654\";i:92866;s:12:\"delete-93655\";i:92867;s:12:\"delete-93678\";i:92868;s:12:\"delete-93679\";i:92869;s:12:\"delete-93680\";i:92870;s:12:\"delete-93681\";i:92871;s:12:\"delete-93682\";i:92872;s:12:\"delete-93686\";i:92873;s:12:\"delete-93684\";i:92874;s:12:\"delete-93685\";i:92875;s:12:\"delete-93683\";i:92876;s:12:\"delete-93633\";i:92877;s:12:\"delete-93635\";i:92878;s:12:\"delete-93677\";i:92879;s:12:\"delete-93676\";i:92880;s:12:\"delete-93675\";i:92881;s:12:\"delete-93656\";i:92882;s:12:\"delete-93657\";i:92883;s:12:\"delete-93658\";i:92884;s:12:\"delete-93659\";i:92885;s:12:\"delete-93660\";i:92886;s:12:\"delete-93743\";i:92887;s:12:\"delete-93670\";i:92888;s:12:\"delete-93671\";i:92889;s:12:\"delete-93672\";i:92890;s:12:\"delete-93673\";i:92891;s:12:\"delete-93674\";i:92892;s:12:\"delete-93637\";i:92893;s:12:\"delete-93705\";i:92894;s:12:\"delete-93760\";i:92895;s:12:\"delete-93745\";i:92896;s:12:\"delete-93744\";i:92897;s:12:\"delete-93742\";i:92898;s:12:\"delete-93741\";i:92899;s:12:\"delete-93740\";i:92900;s:12:\"delete-93739\";i:92901;s:12:\"delete-93738\";i:92902;s:12:\"delete-93737\";i:92903;s:12:\"delete-93736\";i:92904;s:12:\"delete-93735\";i:92905;s:12:\"delete-93734\";i:92906;s:12:\"delete-93746\";i:92907;s:12:\"delete-93747\";i:92908;s:12:\"delete-93748\";i:92909;s:12:\"delete-93759\";i:92910;s:12:\"delete-93758\";i:92911;s:12:\"delete-93757\";i:92912;s:12:\"delete-93756\";i:92913;s:12:\"delete-93755\";i:92914;s:12:\"delete-93754\";i:92915;s:12:\"delete-93753\";i:92916;s:12:\"delete-93752\";i:92917;s:12:\"delete-93750\";i:92918;s:12:\"delete-93751\";i:92919;s:12:\"delete-93749\";i:92920;s:12:\"delete-93732\";i:92921;s:12:\"delete-93733\";i:92922;s:12:\"delete-93717\";i:92923;s:12:\"delete-93716\";i:92924;s:12:\"delete-93715\";i:92925;s:12:\"delete-93714\";i:92926;s:12:\"delete-93713\";i:92927;s:12:\"delete-93712\";i:92928;s:12:\"delete-93711\";i:92929;s:12:\"delete-93710\";i:92930;s:12:\"delete-93709\";i:92931;s:12:\"delete-93708\";i:92932;s:12:\"delete-93706\";i:92933;s:12:\"delete-93718\";i:92934;s:12:\"delete-93719\";i:92935;s:12:\"delete-93720\";i:92936;s:12:\"delete-93731\";i:92937;s:12:\"delete-93730\";i:92938;s:12:\"delete-93729\";i:92939;s:12:\"delete-93728\";i:92940;s:12:\"delete-93726\";i:92941;s:12:\"delete-93727\";i:92942;s:12:\"delete-93725\";i:92943;s:12:\"delete-93724\";i:92944;s:12:\"delete-93723\";i:92945;s:12:\"delete-93722\";i:92946;s:12:\"delete-93721\";i:92947;s:12:\"delete-93707\";i:92948;s:12:\"delete-93578\";i:92949;s:12:\"delete-93563\";i:92950;s:12:\"delete-93562\";i:92951;s:12:\"delete-93561\";i:92952;s:12:\"delete-93560\";i:92953;s:12:\"delete-93559\";i:92954;s:12:\"delete-93558\";i:92955;s:12:\"delete-93557\";i:92956;s:12:\"delete-93556\";i:92957;s:12:\"delete-93555\";i:92958;s:12:\"delete-93554\";i:92959;s:12:\"delete-93553\";i:92960;s:12:\"delete-93564\";i:92961;s:12:\"delete-93565\";i:92962;s:12:\"delete-93566\";i:92963;s:12:\"delete-93577\";i:92964;s:12:\"delete-93576\";i:92965;s:12:\"delete-93575\";i:92966;s:12:\"delete-93574\";i:92967;s:12:\"delete-93573\";i:92968;s:12:\"delete-93572\";i:92969;s:12:\"delete-93571\";i:92970;s:12:\"delete-93570\";i:92971;s:12:\"delete-93569\";i:92972;s:12:\"delete-93568\";i:92973;s:12:\"delete-93567\";i:92974;s:12:\"delete-93552\";i:92975;s:12:\"delete-93551\";i:92976;s:12:\"delete-93536\";i:92977;s:12:\"delete-93535\";i:92978;s:12:\"delete-93534\";i:92979;s:12:\"delete-93533\";i:92980;s:12:\"delete-93532\";i:92981;s:12:\"delete-93531\";i:92982;s:12:\"delete-93530\";i:92983;s:12:\"delete-93529\";i:92984;s:12:\"delete-93528\";i:92985;s:12:\"delete-93527\";i:92986;s:12:\"delete-93525\";i:92987;s:12:\"delete-93537\";i:92988;s:12:\"delete-93538\";i:92989;s:12:\"delete-93539\";i:92990;s:12:\"delete-93550\";i:92991;s:12:\"delete-93549\";i:92992;s:12:\"delete-93548\";i:92993;s:12:\"delete-93547\";i:92994;s:12:\"delete-93546\";i:92995;s:12:\"delete-93545\";i:92996;s:12:\"delete-93544\";i:92997;s:12:\"delete-93542\";i:92998;s:12:\"delete-93543\";i:92999;s:12:\"delete-93540\";i:93000;s:12:\"delete-93541\";i:93001;s:12:\"delete-93526\";i:93002;s:12:\"delete-93579\";i:93003;s:12:\"delete-93638\";i:93004;s:12:\"delete-93618\";i:93005;s:12:\"delete-93617\";i:93006;s:12:\"delete-93616\";i:93007;s:12:\"delete-93615\";i:93008;s:12:\"delete-93614\";i:93009;s:12:\"delete-93613\";i:93010;s:12:\"delete-93612\";i:93011;s:12:\"delete-93611\";i:93012;s:12:\"delete-93610\";i:93013;s:12:\"delete-93609\";i:93014;s:12:\"delete-93608\";i:93015;s:12:\"delete-93619\";i:93016;s:12:\"delete-93620\";i:93017;s:12:\"delete-93621\";i:93018;s:12:\"delete-93639\";i:93019;s:12:\"delete-93640\";i:93020;s:12:\"delete-93632\";i:93021;s:12:\"delete-93630\";i:93022;s:12:\"delete-93631\";i:93023;s:12:\"delete-93627\";i:93024;s:12:\"delete-93626\";i:93025;s:12:\"delete-93625\";i:93026;s:12:\"delete-93624\";i:93027;s:12:\"delete-93623\";i:93028;s:12:\"delete-93622\";i:93029;s:12:\"delete-93607\";i:93030;s:12:\"delete-93606\";i:93031;s:12:\"delete-93591\";i:93032;s:12:\"delete-93590\";i:93033;s:12:\"delete-93589\";i:93034;s:12:\"delete-93588\";i:93035;s:12:\"delete-93581\";i:93036;s:12:\"delete-93587\";i:93037;s:12:\"delete-93586\";i:93038;s:12:\"delete-93585\";i:93039;s:12:\"delete-93584\";i:93040;s:12:\"delete-93583\";i:93041;s:12:\"delete-93582\";i:93042;s:12:\"delete-93592\";i:93043;s:12:\"delete-93593\";i:93044;s:12:\"delete-93594\";i:93045;s:12:\"delete-93605\";i:93046;s:12:\"delete-93604\";i:93047;s:12:\"delete-93603\";i:93048;s:12:\"delete-93602\";i:93049;s:12:\"delete-93601\";i:93050;s:12:\"delete-93600\";i:93051;s:12:\"delete-93599\";i:93052;s:12:\"delete-93598\";i:93053;s:12:\"delete-93597\";i:93054;s:12:\"delete-93596\";i:93055;s:12:\"delete-93595\";i:93056;s:12:\"delete-93580\";i:93057;s:12:\"delete-93196\";i:93058;s:12:\"delete-93265\";i:93059;s:12:\"delete-93276\";i:93060;s:12:\"delete-93271\";i:93061;s:12:\"delete-93242\";i:93062;s:12:\"delete-93270\";i:93063;s:12:\"delete-93268\";i:93064;s:12:\"delete-93244\";i:93065;s:12:\"delete-93267\";i:93066;s:12:\"delete-93278\";i:93067;s:12:\"delete-93277\";i:93068;s:12:\"delete-93243\";i:93069;s:12:\"delete-93275\";i:93070;s:12:\"delete-93279\";i:93071;s:12:\"delete-93261\";i:93072;s:12:\"delete-93263\";i:93073;s:12:\"delete-93264\";i:93074;s:12:\"delete-93247\";i:93075;s:12:\"delete-93262\";i:93076;s:12:\"delete-93260\";i:93077;s:12:\"delete-93248\";i:93078;s:12:\"delete-93249\";i:93079;s:12:\"delete-93250\";i:93080;s:12:\"delete-93251\";i:93081;s:12:\"delete-93252\";i:93082;s:12:\"delete-93253\";i:93083;s:12:\"delete-93254\";i:93084;s:12:\"delete-93255\";i:93085;s:12:\"delete-93256\";i:93086;s:12:\"delete-93257\";i:93087;s:12:\"delete-93259\";i:93088;s:12:\"delete-93266\";i:93089;s:12:\"delete-93269\";i:93090;s:12:\"delete-93287\";i:93091;s:12:\"delete-93288\";i:93092;s:12:\"delete-93289\";i:93093;s:12:\"delete-93290\";i:93094;s:12:\"delete-93291\";i:93095;s:12:\"delete-93292\";i:93096;s:12:\"delete-93293\";i:93097;s:12:\"delete-93294\";i:93098;s:12:\"delete-93295\";i:93099;s:12:\"delete-93286\";i:93100;s:12:\"delete-93285\";i:93101;s:12:\"delete-93272\";i:93102;s:12:\"delete-93273\";i:93103;s:12:\"delete-93274\";i:93104;s:12:\"delete-93258\";i:93105;s:12:\"delete-93280\";i:93106;s:12:\"delete-93281\";i:93107;s:12:\"delete-93282\";i:93108;s:12:\"delete-93283\";i:93109;s:12:\"delete-93284\";i:93110;s:12:\"delete-93296\";i:93111;s:12:\"delete-93246\";i:93112;s:12:\"delete-93309\";i:93113;s:12:\"delete-93207\";i:93114;s:12:\"delete-93208\";i:93115;s:12:\"delete-93209\";i:93116;s:12:\"delete-93210\";i:93117;s:12:\"delete-93211\";i:93118;s:12:\"delete-93212\";i:93119;s:12:\"delete-93213\";i:93120;s:12:\"delete-93214\";i:93121;s:12:\"delete-93215\";i:93122;s:12:\"delete-93216\";i:93123;s:12:\"delete-93206\";i:93124;s:12:\"delete-93205\";i:93125;s:12:\"delete-93204\";i:93126;s:12:\"delete-93308\";i:93127;s:12:\"delete-93307\";i:93128;s:12:\"delete-93306\";i:93129;s:12:\"delete-93197\";i:93130;s:12:\"delete-93198\";i:93131;s:12:\"delete-93199\";i:93132;s:12:\"delete-93200\";i:93133;s:12:\"delete-93201\";i:93134;s:12:\"delete-93202\";i:93135;s:12:\"delete-93203\";i:93136;s:12:\"delete-93217\";i:93137;s:12:\"delete-93218\";i:93138;s:12:\"delete-93232\";i:93139;s:12:\"delete-93233\";i:93140;s:12:\"delete-93234\";i:93141;s:12:\"delete-93235\";i:93142;s:12:\"delete-93236\";i:93143;s:12:\"delete-93237\";i:93144;s:12:\"delete-93238\";i:93145;s:12:\"delete-93239\";i:93146;s:12:\"delete-93240\";i:93147;s:12:\"delete-93241\";i:93148;s:12:\"delete-93231\";i:93149;s:12:\"delete-93230\";i:93150;s:12:\"delete-93229\";i:93151;s:12:\"delete-93219\";i:93152;s:12:\"delete-93220\";i:93153;s:12:\"delete-93221\";i:93154;s:12:\"delete-93222\";i:93155;s:12:\"delete-93223\";i:93156;s:12:\"delete-93224\";i:93157;s:12:\"delete-93225\";i:93158;s:12:\"delete-93226\";i:93159;s:12:\"delete-93227\";i:93160;s:12:\"delete-93228\";i:93161;s:12:\"delete-93245\";i:93162;s:12:\"delete-94251\";i:93163;s:12:\"delete-94257\";i:93164;s:12:\"delete-94262\";i:93165;s:12:\"delete-94267\";i:93166;s:12:\"delete-94249\";i:93167;s:12:\"delete-94250\";i:93168;s:12:\"delete-94252\";i:93169;s:12:\"delete-94253\";i:93170;s:12:\"delete-94255\";i:93171;s:12:\"delete-94256\";i:93172;s:12:\"delete-94258\";i:93173;s:12:\"delete-94259\";i:93174;s:12:\"delete-94261\";i:93175;s:12:\"delete-94260\";i:93176;s:12:\"delete-94263\";i:93177;s:12:\"delete-94264\";i:93178;s:12:\"delete-94265\";i:93179;s:12:\"delete-94266\";i:93180;s:12:\"delete-94268\";i:93181;s:12:\"delete-94269\";i:93182;s:12:\"delete-93842\";i:93183;s:12:\"delete-93849\";i:93184;s:12:\"delete-93848\";i:93185;s:12:\"delete-93847\";i:93186;s:12:\"delete-93846\";i:93187;s:12:\"delete-93845\";i:93188;s:12:\"delete-93844\";i:93189;s:12:\"delete-93843\";i:93190;s:12:\"delete-94122\";i:93191;s:12:\"delete-94138\";i:93192;s:12:\"delete-94140\";i:93193;s:12:\"delete-94137\";i:93194;s:12:\"delete-94139\";i:93195;s:12:\"delete-93878\";i:93196;s:12:\"delete-94142\";i:93197;s:12:\"delete-94123\";i:93198;s:12:\"delete-94144\";i:93199;s:12:\"delete-94143\";i:93200;s:12:\"delete-94141\";i:93201;s:12:\"delete-94254\";i:93202;s:12:\"delete-93852\";i:93203;s:12:\"delete-94132\";i:93204;s:12:\"delete-94127\";i:93205;s:12:\"delete-94129\";i:93206;s:12:\"delete-94133\";i:93207;s:12:\"delete-93971\";i:93208;s:12:\"delete-93967\";i:93209;s:12:\"delete-93970\";i:93210;s:12:\"delete-93976\";i:93211;s:12:\"delete-93972\";i:93212;s:12:\"delete-93973\";i:93213;s:12:\"delete-93974\";i:93214;s:12:\"delete-93969\";i:93215;s:12:\"delete-93975\";i:93216;s:12:\"delete-93977\";i:93217;s:12:\"delete-93979\";i:93218;s:12:\"delete-93984\";i:93219;s:12:\"delete-93981\";i:93220;s:12:\"delete-93980\";i:93221;s:12:\"delete-93978\";i:93222;s:12:\"delete-93982\";i:93223;s:12:\"delete-93983\";i:93224;s:12:\"delete-93968\";i:93225;s:12:\"delete-93960\";i:93226;s:12:\"delete-93961\";i:93227;s:12:\"delete-93951\";i:93228;s:12:\"delete-93949\";i:93229;s:12:\"delete-93948\";i:93230;s:12:\"delete-93947\";i:93231;s:12:\"delete-93946\";i:93232;s:12:\"delete-93950\";i:93233;s:12:\"delete-93945\";i:93234;s:12:\"delete-93956\";i:93235;s:12:\"delete-93957\";i:93236;s:12:\"delete-93958\";i:93237;s:12:\"delete-93959\";i:93238;s:12:\"delete-93962\";i:93239;s:12:\"delete-93963\";i:93240;s:12:\"delete-93964\";i:93241;s:12:\"delete-93965\";i:93242;s:12:\"delete-93966\";i:93243;s:12:\"delete-93952\";i:93244;s:12:\"delete-93985\";i:93245;s:12:\"delete-94037\";i:93246;s:12:\"delete-94024\";i:93247;s:12:\"delete-94023\";i:93248;s:12:\"delete-94022\";i:93249;s:12:\"delete-94021\";i:93250;s:12:\"delete-94016\";i:93251;s:12:\"delete-94017\";i:93252;s:12:\"delete-94018\";i:93253;s:12:\"delete-94019\";i:93254;s:12:\"delete-94014\";i:93255;s:12:\"delete-94015\";i:93256;s:12:\"delete-94012\";i:93257;s:12:\"delete-94020\";i:93258;s:12:\"delete-94026\";i:93259;s:12:\"delete-94036\";i:93260;s:12:\"delete-94035\";i:93261;s:12:\"delete-94034\";i:93262;s:12:\"delete-94033\";i:93263;s:12:\"delete-94032\";i:93264;s:12:\"delete-94031\";i:93265;s:12:\"delete-94029\";i:93266;s:12:\"delete-94030\";i:93267;s:12:\"delete-94027\";i:93268;s:12:\"delete-94028\";i:93269;s:12:\"delete-94025\";i:93270;s:12:\"delete-94013\";i:93271;s:12:\"delete-94007\";i:93272;s:12:\"delete-94002\";i:93273;s:12:\"delete-94003\";i:93274;s:12:\"delete-93995\";i:93275;s:12:\"delete-93994\";i:93276;s:12:\"delete-93993\";i:93277;s:12:\"delete-93992\";i:93278;s:12:\"delete-93991\";i:93279;s:12:\"delete-93990\";i:93280;s:12:\"delete-93988\";i:93281;s:12:\"delete-93989\";i:93282;s:12:\"delete-93987\";i:93283;s:12:\"delete-94001\";i:93284;s:12:\"delete-94000\";i:93285;s:12:\"delete-94008\";i:93286;s:12:\"delete-94009\";i:93287;s:12:\"delete-94010\";i:93288;s:12:\"delete-94011\";i:93289;s:12:\"delete-94004\";i:93290;s:12:\"delete-94005\";i:93291;s:12:\"delete-94006\";i:93292;s:12:\"delete-93996\";i:93293;s:12:\"delete-93997\";i:93294;s:12:\"delete-93998\";i:93295;s:12:\"delete-93999\";i:93296;s:12:\"delete-93986\";i:93297;s:12:\"delete-93898\";i:93298;s:12:\"delete-93885\";i:93299;s:12:\"delete-93884\";i:93300;s:12:\"delete-93883\";i:93301;s:12:\"delete-93882\";i:93302;s:12:\"delete-93881\";i:93303;s:12:\"delete-93880\";i:93304;s:12:\"delete-93879\";i:93305;s:12:\"delete-93877\";i:93306;s:12:\"delete-93876\";i:93307;s:12:\"delete-93875\";i:93308;s:12:\"delete-93886\";i:93309;s:12:\"delete-93887\";i:93310;s:12:\"delete-93897\";i:93311;s:12:\"delete-93896\";i:93312;s:12:\"delete-93895\";i:93313;s:12:\"delete-93894\";i:93314;s:12:\"delete-93893\";i:93315;s:12:\"delete-93892\";i:93316;s:12:\"delete-93891\";i:93317;s:12:\"delete-93890\";i:93318;s:12:\"delete-93889\";i:93319;s:12:\"delete-93888\";i:93320;s:12:\"delete-93874\";i:93321;s:12:\"delete-93873\";i:93322;s:12:\"delete-93860\";i:93323;s:12:\"delete-93859\";i:93324;s:12:\"delete-93858\";i:93325;s:12:\"delete-93857\";i:93326;s:12:\"delete-93856\";i:93327;s:12:\"delete-93855\";i:93328;s:12:\"delete-93854\";i:93329;s:12:\"delete-93853\";i:93330;s:12:\"delete-93851\";i:93331;s:12:\"delete-93850\";i:93332;s:12:\"delete-93861\";i:93333;s:12:\"delete-93862\";i:93334;s:12:\"delete-93872\";i:93335;s:12:\"delete-93871\";i:93336;s:12:\"delete-93870\";i:93337;s:12:\"delete-93869\";i:93338;s:12:\"delete-93868\";i:93339;s:12:\"delete-93867\";i:93340;s:12:\"delete-93866\";i:93341;s:12:\"delete-93865\";i:93342;s:12:\"delete-93864\";i:93343;s:12:\"delete-93863\";i:93344;s:12:\"delete-93944\";i:93345;s:12:\"delete-93953\";i:93346;s:12:\"delete-93933\";i:93347;s:12:\"delete-93932\";i:93348;s:12:\"delete-93931\";i:93349;s:12:\"delete-93930\";i:93350;s:12:\"delete-93929\";i:93351;s:12:\"delete-93928\";i:93352;s:12:\"delete-93927\";i:93353;s:12:\"delete-93926\";i:93354;s:12:\"delete-93925\";i:93355;s:12:\"delete-93921\";i:93356;s:12:\"delete-93935\";i:93357;s:12:\"delete-93934\";i:93358;s:12:\"delete-93955\";i:93359;s:12:\"delete-93954\";i:93360;s:12:\"delete-93942\";i:93361;s:12:\"delete-93943\";i:93362;s:12:\"delete-93939\";i:93363;s:12:\"delete-93940\";i:93364;s:12:\"delete-93941\";i:93365;s:12:\"delete-93938\";i:93366;s:12:\"delete-93937\";i:93367;s:12:\"delete-93936\";i:93368;s:12:\"delete-93922\";i:93369;s:12:\"delete-93923\";i:93370;s:12:\"delete-93909\";i:93371;s:12:\"delete-93908\";i:93372;s:12:\"delete-93907\";i:93373;s:12:\"delete-93906\";i:93374;s:12:\"delete-93905\";i:93375;s:12:\"delete-93904\";i:93376;s:12:\"delete-93903\";i:93377;s:12:\"delete-93902\";i:93378;s:12:\"delete-93901\";i:93379;s:12:\"delete-93900\";i:93380;s:12:\"delete-93910\";i:93381;s:12:\"delete-93911\";i:93382;s:12:\"delete-93924\";i:93383;s:12:\"delete-93920\";i:93384;s:12:\"delete-93919\";i:93385;s:12:\"delete-93918\";i:93386;s:12:\"delete-93916\";i:93387;s:12:\"delete-93917\";i:93388;s:12:\"delete-93914\";i:93389;s:12:\"delete-93915\";i:93390;s:12:\"delete-93913\";i:93391;s:12:\"delete-93912\";i:93392;s:12:\"delete-93899\";i:93393;s:12:\"delete-94038\";i:93394;s:12:\"delete-94198\";i:93395;s:12:\"delete-94187\";i:93396;s:12:\"delete-94185\";i:93397;s:12:\"delete-94183\";i:93398;s:12:\"delete-94184\";i:93399;s:12:\"delete-94182\";i:93400;s:12:\"delete-94180\";i:93401;s:12:\"delete-94181\";i:93402;s:12:\"delete-94179\";i:93403;s:12:\"delete-94177\";i:93404;s:12:\"delete-94178\";i:93405;s:12:\"delete-94186\";i:93406;s:12:\"delete-94188\";i:93407;s:12:\"delete-94199\";i:93408;s:12:\"delete-94197\";i:93409;s:12:\"delete-94195\";i:93410;s:12:\"delete-94196\";i:93411;s:12:\"delete-94194\";i:93412;s:12:\"delete-94192\";i:93413;s:12:\"delete-94193\";i:93414;s:12:\"delete-94191\";i:93415;s:12:\"delete-94189\";i:93416;s:12:\"delete-94190\";i:93417;s:12:\"delete-94176\";i:93418;s:12:\"delete-94174\";i:93419;s:12:\"delete-94175\";i:93420;s:12:\"delete-94159\";i:93421;s:12:\"delete-94160\";i:93422;s:12:\"delete-94161\";i:93423;s:12:\"delete-94162\";i:93424;s:12:\"delete-94156\";i:93425;s:12:\"delete-94157\";i:93426;s:12:\"delete-94155\";i:93427;s:12:\"delete-94154\";i:93428;s:12:\"delete-94152\";i:93429;s:12:\"delete-94153\";i:93430;s:12:\"delete-94158\";i:93431;s:12:\"delete-94164\";i:93432;s:12:\"delete-94172\";i:93433;s:12:\"delete-94173\";i:93434;s:12:\"delete-94171\";i:93435;s:12:\"delete-94169\";i:93436;s:12:\"delete-94170\";i:93437;s:12:\"delete-94168\";i:93438;s:12:\"delete-94166\";i:93439;s:12:\"delete-94167\";i:93440;s:12:\"delete-94165\";i:93441;s:12:\"delete-94163\";i:93442;s:12:\"delete-94151\";i:93443;s:12:\"delete-94247\";i:93444;s:12:\"delete-94236\";i:93445;s:12:\"delete-94234\";i:93446;s:12:\"delete-94232\";i:93447;s:12:\"delete-94233\";i:93448;s:12:\"delete-94231\";i:93449;s:12:\"delete-94229\";i:93450;s:12:\"delete-94230\";i:93451;s:12:\"delete-94228\";i:93452;s:12:\"delete-94226\";i:93453;s:12:\"delete-94227\";i:93454;s:12:\"delete-94235\";i:93455;s:12:\"delete-94237\";i:93456;s:12:\"delete-94248\";i:93457;s:12:\"delete-94246\";i:93458;s:12:\"delete-94244\";i:93459;s:12:\"delete-94245\";i:93460;s:12:\"delete-94243\";i:93461;s:12:\"delete-94241\";i:93462;s:12:\"delete-94242\";i:93463;s:12:\"delete-94240\";i:93464;s:12:\"delete-94238\";i:93465;s:12:\"delete-94239\";i:93466;s:12:\"delete-94225\";i:93467;s:12:\"delete-94223\";i:93468;s:12:\"delete-94224\";i:93469;s:12:\"delete-94211\";i:93470;s:12:\"delete-94209\";i:93471;s:12:\"delete-94207\";i:93472;s:12:\"delete-94208\";i:93473;s:12:\"delete-94206\";i:93474;s:12:\"delete-94204\";i:93475;s:12:\"delete-94205\";i:93476;s:12:\"delete-94203\";i:93477;s:12:\"delete-94201\";i:93478;s:12:\"delete-94202\";i:93479;s:12:\"delete-94210\";i:93480;s:12:\"delete-94212\";i:93481;s:12:\"delete-94222\";i:93482;s:12:\"delete-94220\";i:93483;s:12:\"delete-94221\";i:93484;s:12:\"delete-94219\";i:93485;s:12:\"delete-94217\";i:93486;s:12:\"delete-94218\";i:93487;s:12:\"delete-94216\";i:93488;s:12:\"delete-94214\";i:93489;s:12:\"delete-94215\";i:93490;s:12:\"delete-94213\";i:93491;s:12:\"delete-94200\";i:93492;s:12:\"delete-94087\";i:93493;s:12:\"delete-94074\";i:93494;s:12:\"delete-94073\";i:93495;s:12:\"delete-94072\";i:93496;s:12:\"delete-94071\";i:93497;s:12:\"delete-94070\";i:93498;s:12:\"delete-94069\";i:93499;s:12:\"delete-94068\";i:93500;s:12:\"delete-94067\";i:93501;s:12:\"delete-94066\";i:93502;s:12:\"delete-94065\";i:93503;s:12:\"delete-94075\";i:93504;s:12:\"delete-94076\";i:93505;s:12:\"delete-94086\";i:93506;s:12:\"delete-94085\";i:93507;s:12:\"delete-94084\";i:93508;s:12:\"delete-94083\";i:93509;s:12:\"delete-94082\";i:93510;s:12:\"delete-94081\";i:93511;s:12:\"delete-94080\";i:93512;s:12:\"delete-94079\";i:93513;s:12:\"delete-94078\";i:93514;s:12:\"delete-94077\";i:93515;s:12:\"delete-94064\";i:93516;s:12:\"delete-94063\";i:93517;s:12:\"delete-94062\";i:93518;s:12:\"delete-94049\";i:93519;s:12:\"delete-94048\";i:93520;s:12:\"delete-94047\";i:93521;s:12:\"delete-94046\";i:93522;s:12:\"delete-94045\";i:93523;s:12:\"delete-94044\";i:93524;s:12:\"delete-94043\";i:93525;s:12:\"delete-94042\";i:93526;s:12:\"delete-94041\";i:93527;s:12:\"delete-94040\";i:93528;s:12:\"delete-94050\";i:93529;s:12:\"delete-94051\";i:93530;s:12:\"delete-94061\";i:93531;s:12:\"delete-94060\";i:93532;s:12:\"delete-94059\";i:93533;s:12:\"delete-94058\";i:93534;s:12:\"delete-94057\";i:93535;s:12:\"delete-94056\";i:93536;s:12:\"delete-94055\";i:93537;s:12:\"delete-94054\";i:93538;s:12:\"delete-94053\";i:93539;s:12:\"delete-94052\";i:93540;s:12:\"delete-94039\";i:93541;s:12:\"delete-94150\";i:93542;s:12:\"delete-94126\";i:93543;s:12:\"delete-94124\";i:93544;s:12:\"delete-94120\";i:93545;s:12:\"delete-94121\";i:93546;s:12:\"delete-94119\";i:93547;s:12:\"delete-94118\";i:93548;s:12:\"delete-94117\";i:93549;s:12:\"delete-94116\";i:93550;s:12:\"delete-94115\";i:93551;s:12:\"delete-94114\";i:93552;s:12:\"delete-94125\";i:93553;s:12:\"delete-94128\";i:93554;s:12:\"delete-94148\";i:93555;s:12:\"delete-94149\";i:93556;s:12:\"delete-94147\";i:93557;s:12:\"delete-94145\";i:93558;s:12:\"delete-94146\";i:93559;s:12:\"delete-94136\";i:93560;s:12:\"delete-94134\";i:93561;s:12:\"delete-94135\";i:93562;s:12:\"delete-94131\";i:93563;s:12:\"delete-94130\";i:93564;s:12:\"delete-94113\";i:93565;s:12:\"delete-94112\";i:93566;s:12:\"delete-94111\";i:93567;s:12:\"delete-94098\";i:93568;s:12:\"delete-94097\";i:93569;s:12:\"delete-94096\";i:93570;s:12:\"delete-94095\";i:93571;s:12:\"delete-94094\";i:93572;s:12:\"delete-94093\";i:93573;s:12:\"delete-94092\";i:93574;s:12:\"delete-94091\";i:93575;s:12:\"delete-94090\";i:93576;s:12:\"delete-94089\";i:93577;s:12:\"delete-94099\";i:93578;s:12:\"delete-94100\";i:93579;s:12:\"delete-94110\";i:93580;s:12:\"delete-94109\";i:93581;s:12:\"delete-94108\";i:93582;s:12:\"delete-94107\";i:93583;s:12:\"delete-94106\";i:93584;s:12:\"delete-94105\";i:93585;s:12:\"delete-94104\";i:93586;s:12:\"delete-94103\";i:93587;s:12:\"delete-94102\";i:93588;s:12:\"delete-94101\";i:93589;s:12:\"delete-94088\";i:93590;s:12:\"delete-94873\";i:93591;s:12:\"delete-94872\";i:93592;s:12:\"delete-94871\";i:93593;s:12:\"delete-94276\";i:93594;s:12:\"delete-94875\";i:93595;s:12:\"delete-94874\";i:93596;s:12:\"delete-94274\";i:93597;s:12:\"delete-94901\";i:93598;s:12:\"delete-94900\";i:93599;s:12:\"delete-94899\";i:93600;s:12:\"delete-94879\";i:93601;s:12:\"delete-94878\";i:93602;s:12:\"delete-94877\";i:93603;s:12:\"delete-94876\";i:93604;s:12:\"delete-94272\";i:93605;s:12:\"delete-94271\";i:93606;s:12:\"delete-94270\";i:93607;s:12:\"delete-94275\";i:93608;s:12:\"delete-94277\";i:93609;s:12:\"delete-94273\";i:93610;s:12:\"delete-94902\";i:93611;s:12:\"delete-94903\";i:93612;s:12:\"delete-94904\";i:93613;s:12:\"delete-94905\";i:93614;s:12:\"delete-94906\";i:93615;s:12:\"delete-94907\";i:93616;s:12:\"delete-94908\";i:93617;s:12:\"delete-94909\";i:93618;s:12:\"delete-94924\";i:93619;s:12:\"delete-94922\";i:93620;s:12:\"delete-94918\";i:93621;s:12:\"delete-94910\";i:93622;s:12:\"delete-94925\";i:93623;s:12:\"delete-94932\";i:93624;s:12:\"delete-94929\";i:93625;s:12:\"delete-94931\";i:93626;s:12:\"delete-94930\";i:93627;s:12:\"delete-94927\";i:93628;s:12:\"delete-94928\";i:93629;s:12:\"delete-94933\";i:93630;s:12:\"delete-94934\";i:93631;s:12:\"delete-94935\";i:93632;s:12:\"delete-94936\";i:93633;s:12:\"delete-94938\";i:93634;s:12:\"delete-94939\";i:93635;s:12:\"delete-94920\";i:93636;s:12:\"delete-94917\";i:93637;s:12:\"delete-94916\";i:93638;s:12:\"delete-94921\";i:93639;s:12:\"delete-94919\";i:93640;s:12:\"delete-94923\";i:93641;s:12:\"delete-94926\";i:93642;s:12:\"delete-94473\";i:93643;s:12:\"delete-94484\";i:93644;s:12:\"delete-94471\";i:93645;s:12:\"delete-94485\";i:93646;s:12:\"delete-94486\";i:93647;s:12:\"delete-94487\";i:93648;s:12:\"delete-94472\";i:93649;s:12:\"delete-94483\";i:93650;s:12:\"delete-94482\";i:93651;s:12:\"delete-94474\";i:93652;s:12:\"delete-94475\";i:93653;s:12:\"delete-94476\";i:93654;s:12:\"delete-94477\";i:93655;s:12:\"delete-94478\";i:93656;s:12:\"delete-94479\";i:93657;s:12:\"delete-94470\";i:93658;s:12:\"delete-94481\";i:93659;s:12:\"delete-94480\";i:93660;s:12:\"delete-94492\";i:93661;s:12:\"delete-94499\";i:93662;s:12:\"delete-94500\";i:93663;s:12:\"delete-94501\";i:93664;s:12:\"delete-94502\";i:93665;s:12:\"delete-94503\";i:93666;s:12:\"delete-94504\";i:93667;s:12:\"delete-94505\";i:93668;s:12:\"delete-94506\";i:93669;s:12:\"delete-94498\";i:93670;s:12:\"delete-94497\";i:93671;s:12:\"delete-94488\";i:93672;s:12:\"delete-94489\";i:93673;s:12:\"delete-94490\";i:93674;s:12:\"delete-94491\";i:93675;s:12:\"delete-94493\";i:93676;s:12:\"delete-94494\";i:93677;s:12:\"delete-94495\";i:93678;s:12:\"delete-94496\";i:93679;s:12:\"delete-94507\";i:93680;s:12:\"delete-94468\";i:93681;s:12:\"delete-94447\";i:93682;s:12:\"delete-94448\";i:93683;s:12:\"delete-94449\";i:93684;s:12:\"delete-94451\";i:93685;s:12:\"delete-94450\";i:93686;s:12:\"delete-94444\";i:93687;s:12:\"delete-94443\";i:93688;s:12:\"delete-94442\";i:93689;s:12:\"delete-94441\";i:93690;s:12:\"delete-94440\";i:93691;s:12:\"delete-94439\";i:93692;s:12:\"delete-94438\";i:93693;s:12:\"delete-94437\";i:93694;s:12:\"delete-94436\";i:93695;s:12:\"delete-94435\";i:93696;s:12:\"delete-94434\";i:93697;s:12:\"delete-94433\";i:93698;s:12:\"delete-94446\";i:93699;s:12:\"delete-94445\";i:93700;s:12:\"delete-94469\";i:93701;s:12:\"delete-94466\";i:93702;s:12:\"delete-94467\";i:93703;s:12:\"delete-94465\";i:93704;s:12:\"delete-94460\";i:93705;s:12:\"delete-94461\";i:93706;s:12:\"delete-94462\";i:93707;s:12:\"delete-94463\";i:93708;s:12:\"delete-94464\";i:93709;s:12:\"delete-94455\";i:93710;s:12:\"delete-94456\";i:93711;s:12:\"delete-94457\";i:93712;s:12:\"delete-94458\";i:93713;s:12:\"delete-94459\";i:93714;s:12:\"delete-94452\";i:93715;s:12:\"delete-94453\";i:93716;s:12:\"delete-94454\";i:93717;s:12:\"delete-94431\";i:93718;s:12:\"delete-94584\";i:93719;s:12:\"delete-94565\";i:93720;s:12:\"delete-94563\";i:93721;s:12:\"delete-94562\";i:93722;s:12:\"delete-94561\";i:93723;s:12:\"delete-94560\";i:93724;s:12:\"delete-94559\";i:93725;s:12:\"delete-94558\";i:93726;s:12:\"delete-94557\";i:93727;s:12:\"delete-94556\";i:93728;s:12:\"delete-94555\";i:93729;s:12:\"delete-94554\";i:93730;s:12:\"delete-94553\";i:93731;s:12:\"delete-94552\";i:93732;s:12:\"delete-94551\";i:93733;s:12:\"delete-94550\";i:93734;s:12:\"delete-94549\";i:93735;s:12:\"delete-94548\";i:93736;s:12:\"delete-94564\";i:93737;s:12:\"delete-94567\";i:93738;s:12:\"delete-94582\";i:93739;s:12:\"delete-94583\";i:93740;s:12:\"delete-94580\";i:93741;s:12:\"delete-94581\";i:93742;s:12:\"delete-94579\";i:93743;s:12:\"delete-94577\";i:93744;s:12:\"delete-94578\";i:93745;s:12:\"delete-94576\";i:93746;s:12:\"delete-94574\";i:93747;s:12:\"delete-94575\";i:93748;s:12:\"delete-94572\";i:93749;s:12:\"delete-94573\";i:93750;s:12:\"delete-94570\";i:93751;s:12:\"delete-94571\";i:93752;s:12:\"delete-94568\";i:93753;s:12:\"delete-94569\";i:93754;s:12:\"delete-94566\";i:93755;s:12:\"delete-94547\";i:93756;s:12:\"delete-94546\";i:93757;s:12:\"delete-94545\";i:93758;s:12:\"delete-94525\";i:93759;s:12:\"delete-94524\";i:93760;s:12:\"delete-94523\";i:93761;s:12:\"delete-94522\";i:93762;s:12:\"delete-94521\";i:93763;s:12:\"delete-94520\";i:93764;s:12:\"delete-94519\";i:93765;s:12:\"delete-94518\";i:93766;s:12:\"delete-94517\";i:93767;s:12:\"delete-94516\";i:93768;s:12:\"delete-94515\";i:93769;s:12:\"delete-94514\";i:93770;s:12:\"delete-94513\";i:93771;s:12:\"delete-94512\";i:93772;s:12:\"delete-94511\";i:93773;s:12:\"delete-94510\";i:93774;s:12:\"delete-94509\";i:93775;s:12:\"delete-94526\";i:93776;s:12:\"delete-94527\";i:93777;s:12:\"delete-94544\";i:93778;s:12:\"delete-94543\";i:93779;s:12:\"delete-94542\";i:93780;s:12:\"delete-94541\";i:93781;s:12:\"delete-94540\";i:93782;s:12:\"delete-94539\";i:93783;s:12:\"delete-94538\";i:93784;s:12:\"delete-94537\";i:93785;s:12:\"delete-94536\";i:93786;s:12:\"delete-94535\";i:93787;s:12:\"delete-94534\";i:93788;s:12:\"delete-94533\";i:93789;s:12:\"delete-94532\";i:93790;s:12:\"delete-94531\";i:93791;s:12:\"delete-94530\";i:93792;s:12:\"delete-94529\";i:93793;s:12:\"delete-94528\";i:93794;s:12:\"delete-94508\";i:93795;s:12:\"delete-94429\";i:93796;s:12:\"delete-94351\";i:93797;s:12:\"delete-94332\";i:93798;s:12:\"delete-94331\";i:93799;s:12:\"delete-94330\";i:93800;s:12:\"delete-94329\";i:93801;s:12:\"delete-94327\";i:93802;s:12:\"delete-94328\";i:93803;s:12:\"delete-94326\";i:93804;s:12:\"delete-94325\";i:93805;s:12:\"delete-94324\";i:93806;s:12:\"delete-94323\";i:93807;s:12:\"delete-94322\";i:93808;s:12:\"delete-94320\";i:93809;s:12:\"delete-94321\";i:93810;s:12:\"delete-94319\";i:93811;s:12:\"delete-94318\";i:93812;s:12:\"delete-94317\";i:93813;s:12:\"delete-94316\";i:93814;s:12:\"delete-94333\";i:93815;s:12:\"delete-94334\";i:93816;s:12:\"delete-94352\";i:93817;s:12:\"delete-94350\";i:93818;s:12:\"delete-94349\";i:93819;s:12:\"delete-94348\";i:93820;s:12:\"delete-94347\";i:93821;s:12:\"delete-94346\";i:93822;s:12:\"delete-94344\";i:93823;s:12:\"delete-94345\";i:93824;s:12:\"delete-94343\";i:93825;s:12:\"delete-94342\";i:93826;s:12:\"delete-94341\";i:93827;s:12:\"delete-94340\";i:93828;s:12:\"delete-94339\";i:93829;s:12:\"delete-94338\";i:93830;s:12:\"delete-94337\";i:93831;s:12:\"delete-94336\";i:93832;s:12:\"delete-94335\";i:93833;s:12:\"delete-94314\";i:93834;s:12:\"delete-94315\";i:93835;s:12:\"delete-94312\";i:93836;s:12:\"delete-94293\";i:93837;s:12:\"delete-94292\";i:93838;s:12:\"delete-94291\";i:93839;s:12:\"delete-94290\";i:93840;s:12:\"delete-94289\";i:93841;s:12:\"delete-94287\";i:93842;s:12:\"delete-94288\";i:93843;s:12:\"delete-94286\";i:93844;s:12:\"delete-94285\";i:93845;s:12:\"delete-94284\";i:93846;s:12:\"delete-94283\";i:93847;s:12:\"delete-94282\";i:93848;s:12:\"delete-94937\";i:93849;s:12:\"delete-94280\";i:93850;s:12:\"delete-94281\";i:93851;s:12:\"delete-94278\";i:93852;s:12:\"delete-94279\";i:93853;s:12:\"delete-94294\";i:93854;s:12:\"delete-94296\";i:93855;s:12:\"delete-94313\";i:93856;s:12:\"delete-94311\";i:93857;s:12:\"delete-94310\";i:93858;s:12:\"delete-94309\";i:93859;s:12:\"delete-94308\";i:93860;s:12:\"delete-94307\";i:93861;s:12:\"delete-94306\";i:93862;s:12:\"delete-94304\";i:93863;s:12:\"delete-94305\";i:93864;s:12:\"delete-94303\";i:93865;s:12:\"delete-94302\";i:93866;s:12:\"delete-94301\";i:93867;s:12:\"delete-94299\";i:93868;s:12:\"delete-94300\";i:93869;s:12:\"delete-94297\";i:93870;s:12:\"delete-94298\";i:93871;s:12:\"delete-94295\";i:93872;s:12:\"delete-94432\";i:93873;s:12:\"delete-94430\";i:93874;s:12:\"delete-94410\";i:93875;s:12:\"delete-94411\";i:93876;s:12:\"delete-94399\";i:93877;s:12:\"delete-94400\";i:93878;s:12:\"delete-94401\";i:93879;s:12:\"delete-94402\";i:93880;s:12:\"delete-94403\";i:93881;s:12:\"delete-94404\";i:93882;s:12:\"delete-94405\";i:93883;s:12:\"delete-94406\";i:93884;s:12:\"delete-94407\";i:93885;s:12:\"delete-94398\";i:93886;s:12:\"delete-94397\";i:93887;s:12:\"delete-94396\";i:93888;s:12:\"delete-94395\";i:93889;s:12:\"delete-94394\";i:93890;s:12:\"delete-94393\";i:93891;s:12:\"delete-94409\";i:93892;s:12:\"delete-94408\";i:93893;s:12:\"delete-94428\";i:93894;s:12:\"delete-94427\";i:93895;s:12:\"delete-94425\";i:93896;s:12:\"delete-94426\";i:93897;s:12:\"delete-94424\";i:93898;s:12:\"delete-94422\";i:93899;s:12:\"delete-94423\";i:93900;s:12:\"delete-94419\";i:93901;s:12:\"delete-94420\";i:93902;s:12:\"delete-94421\";i:93903;s:12:\"delete-94418\";i:93904;s:12:\"delete-94417\";i:93905;s:12:\"delete-94416\";i:93906;s:12:\"delete-94415\";i:93907;s:12:\"delete-94414\";i:93908;s:12:\"delete-94413\";i:93909;s:12:\"delete-94412\";i:93910;s:12:\"delete-94392\";i:93911;s:12:\"delete-94391\";i:93912;s:12:\"delete-94390\";i:93913;s:12:\"delete-94371\";i:93914;s:12:\"delete-94369\";i:93915;s:12:\"delete-94368\";i:93916;s:12:\"delete-94367\";i:93917;s:12:\"delete-94366\";i:93918;s:12:\"delete-94365\";i:93919;s:12:\"delete-94361\";i:93920;s:12:\"delete-94362\";i:93921;s:12:\"delete-94363\";i:93922;s:12:\"delete-94364\";i:93923;s:12:\"delete-94359\";i:93924;s:12:\"delete-94360\";i:93925;s:12:\"delete-94357\";i:93926;s:12:\"delete-94358\";i:93927;s:12:\"delete-94354\";i:93928;s:12:\"delete-94355\";i:93929;s:12:\"delete-94356\";i:93930;s:12:\"delete-94370\";i:93931;s:12:\"delete-94372\";i:93932;s:12:\"delete-94389\";i:93933;s:12:\"delete-94388\";i:93934;s:12:\"delete-94387\";i:93935;s:12:\"delete-94386\";i:93936;s:12:\"delete-94382\";i:93937;s:12:\"delete-94383\";i:93938;s:12:\"delete-94384\";i:93939;s:12:\"delete-94385\";i:93940;s:12:\"delete-94381\";i:93941;s:12:\"delete-94380\";i:93942;s:12:\"delete-94379\";i:93943;s:12:\"delete-94377\";i:93944;s:12:\"delete-94378\";i:93945;s:12:\"delete-94376\";i:93946;s:12:\"delete-94374\";i:93947;s:12:\"delete-94375\";i:93948;s:12:\"delete-94373\";i:93949;s:12:\"delete-94353\";i:93950;s:12:\"delete-94586\";i:93951;s:12:\"delete-94657\";i:93952;s:12:\"delete-94673\";i:93953;s:12:\"delete-94672\";i:93954;s:12:\"delete-94677\";i:93955;s:12:\"delete-94676\";i:93956;s:12:\"delete-94675\";i:93957;s:12:\"delete-94683\";i:93958;s:12:\"delete-94682\";i:93959;s:12:\"delete-94681\";i:93960;s:12:\"delete-94680\";i:93961;s:12:\"delete-94679\";i:93962;s:12:\"delete-94678\";i:93963;s:12:\"delete-94697\";i:93964;s:12:\"delete-94696\";i:93965;s:12:\"delete-94695\";i:93966;s:12:\"delete-94694\";i:93967;s:12:\"delete-94674\";i:93968;s:12:\"delete-94670\";i:93969;s:12:\"delete-94656\";i:93970;s:12:\"delete-94655\";i:93971;s:12:\"delete-94660\";i:93972;s:12:\"delete-94659\";i:93973;s:12:\"delete-94658\";i:93974;s:12:\"delete-94663\";i:93975;s:12:\"delete-94662\";i:93976;s:12:\"delete-94661\";i:93977;s:12:\"delete-94666\";i:93978;s:12:\"delete-94665\";i:93979;s:12:\"delete-94664\";i:93980;s:12:\"delete-94669\";i:93981;s:12:\"delete-94668\";i:93982;s:12:\"delete-94667\";i:93983;s:12:\"delete-94671\";i:93984;s:12:\"delete-94693\";i:93985;s:12:\"delete-94692\";i:93986;s:12:\"delete-94691\";i:93987;s:12:\"delete-94732\";i:93988;s:12:\"delete-94733\";i:93989;s:12:\"delete-94734\";i:93990;s:12:\"delete-94735\";i:93991;s:12:\"delete-94736\";i:93992;s:12:\"delete-94737\";i:93993;s:12:\"delete-94738\";i:93994;s:12:\"delete-94739\";i:93995;s:12:\"delete-94740\";i:93996;s:12:\"delete-94742\";i:93997;s:12:\"delete-94743\";i:93998;s:12:\"delete-94745\";i:93999;s:12:\"delete-94747\";i:94000;s:12:\"delete-94748\";i:94001;s:12:\"delete-94749\";i:94002;s:12:\"delete-94731\";i:94003;s:12:\"delete-94728\";i:94004;s:12:\"delete-94690\";i:94005;s:12:\"delete-94689\";i:94006;s:12:\"delete-94688\";i:94007;s:12:\"delete-94687\";i:94008;s:12:\"delete-94686\";i:94009;s:12:\"delete-94685\";i:94010;s:12:\"delete-94684\";i:94011;s:12:\"delete-94741\";i:94012;s:12:\"delete-94711\";i:94013;s:12:\"delete-94713\";i:94014;s:12:\"delete-94712\";i:94015;s:12:\"delete-94714\";i:94016;s:12:\"delete-94744\";i:94017;s:12:\"delete-94730\";i:94018;s:12:\"delete-94729\";i:94019;s:12:\"delete-94746\";i:94020;s:12:\"delete-94604\";i:94021;s:12:\"delete-94593\";i:94022;s:12:\"delete-94592\";i:94023;s:12:\"delete-94591\";i:94024;s:12:\"delete-94613\";i:94025;s:12:\"delete-94590\";i:94026;s:12:\"delete-94589\";i:94027;s:12:\"delete-94587\";i:94028;s:12:\"delete-94585\";i:94029;s:12:\"delete-94612\";i:94030;s:12:\"delete-94611\";i:94031;s:12:\"delete-94616\";i:94032;s:12:\"delete-94615\";i:94033;s:12:\"delete-94614\";i:94034;s:12:\"delete-94618\";i:94035;s:12:\"delete-94617\";i:94036;s:12:\"delete-94594\";i:94037;s:12:\"delete-94588\";i:94038;s:12:\"delete-94605\";i:94039;s:12:\"delete-94601\";i:94040;s:12:\"delete-94607\";i:94041;s:12:\"delete-94602\";i:94042;s:12:\"delete-94603\";i:94043;s:12:\"delete-94598\";i:94044;s:12:\"delete-94599\";i:94045;s:12:\"delete-94600\";i:94046;s:12:\"delete-94595\";i:94047;s:12:\"delete-94606\";i:94048;s:12:\"delete-94610\";i:94049;s:12:\"delete-94609\";i:94050;s:12:\"delete-94608\";i:94051;s:12:\"delete-94596\";i:94052;s:12:\"delete-94597\";i:94053;s:12:\"delete-94621\";i:94054;s:12:\"delete-94620\";i:94055;s:12:\"delete-94619\";i:94056;s:12:\"delete-94641\";i:94057;s:12:\"delete-94640\";i:94058;s:12:\"delete-94639\";i:94059;s:12:\"delete-94642\";i:94060;s:12:\"delete-94645\";i:94061;s:12:\"delete-94644\";i:94062;s:12:\"delete-94643\";i:94063;s:12:\"delete-94648\";i:94064;s:12:\"delete-94647\";i:94065;s:12:\"delete-94646\";i:94066;s:12:\"delete-94651\";i:94067;s:12:\"delete-94650\";i:94068;s:12:\"delete-94649\";i:94069;s:12:\"delete-94654\";i:94070;s:12:\"delete-94653\";i:94071;s:12:\"delete-94636\";i:94072;s:12:\"delete-94637\";i:94073;s:12:\"delete-94638\";i:94074;s:12:\"delete-94623\";i:94075;s:12:\"delete-94622\";i:94076;s:12:\"delete-94626\";i:94077;s:12:\"delete-94625\";i:94078;s:12:\"delete-94624\";i:94079;s:12:\"delete-94629\";i:94080;s:12:\"delete-94628\";i:94081;s:12:\"delete-94627\";i:94082;s:12:\"delete-94632\";i:94083;s:12:\"delete-94631\";i:94084;s:12:\"delete-94630\";i:94085;s:12:\"delete-94635\";i:94086;s:12:\"delete-94634\";i:94087;s:12:\"delete-94633\";i:94088;s:12:\"delete-94652\";i:94089;s:12:\"delete-94915\";i:94090;s:12:\"delete-94913\";i:94091;s:12:\"delete-94912\";i:94092;s:12:\"delete-94914\";i:94093;s:12:\"delete-94911\";i:94094;s:12:\"delete-94884\";i:94095;s:12:\"delete-94881\";i:94096;s:12:\"delete-94888\";i:94097;s:12:\"delete-94887\";i:94098;s:12:\"delete-94886\";i:94099;s:12:\"delete-94885\";i:94100;s:12:\"delete-94883\";i:94101;s:12:\"delete-94882\";i:94102;s:12:\"delete-94880\";i:94103;s:12:\"delete-94889\";i:94104;s:12:\"delete-94890\";i:94105;s:12:\"delete-94892\";i:94106;s:12:\"delete-94898\";i:94107;s:12:\"delete-94897\";i:94108;s:12:\"delete-94896\";i:94109;s:12:\"delete-94895\";i:94110;s:12:\"delete-94894\";i:94111;s:12:\"delete-94893\";i:94112;s:12:\"delete-94891\";i:94113;s:12:\"delete-94858\";i:94114;s:12:\"delete-94859\";i:94115;s:12:\"delete-94856\";i:94116;s:12:\"delete-94855\";i:94117;s:12:\"delete-94853\";i:94118;s:12:\"delete-94854\";i:94119;s:12:\"delete-94852\";i:94120;s:12:\"delete-94860\";i:94121;s:12:\"delete-94861\";i:94122;s:12:\"delete-94869\";i:94123;s:12:\"delete-94868\";i:94124;s:12:\"delete-94870\";i:94125;s:12:\"delete-94866\";i:94126;s:12:\"delete-94867\";i:94127;s:12:\"delete-94864\";i:94128;s:12:\"delete-94863\";i:94129;s:12:\"delete-94862\";i:94130;s:12:\"delete-94865\";i:94131;s:12:\"delete-94857\";i:94132;s:12:\"delete-94833\";i:94133;s:12:\"delete-94848\";i:94134;s:12:\"delete-94847\";i:94135;s:12:\"delete-94834\";i:94136;s:12:\"delete-94845\";i:94137;s:12:\"delete-94844\";i:94138;s:12:\"delete-94843\";i:94139;s:12:\"delete-94842\";i:94140;s:12:\"delete-94841\";i:94141;s:12:\"delete-94839\";i:94142;s:12:\"delete-94838\";i:94143;s:12:\"delete-94837\";i:94144;s:12:\"delete-94836\";i:94145;s:12:\"delete-94835\";i:94146;s:12:\"delete-94849\";i:94147;s:12:\"delete-94840\";i:94148;s:12:\"delete-94851\";i:94149;s:12:\"delete-94850\";i:94150;s:12:\"delete-94846\";i:94151;s:12:\"delete-94821\";i:94152;s:12:\"delete-94814\";i:94153;s:12:\"delete-94815\";i:94154;s:12:\"delete-94816\";i:94155;s:12:\"delete-94831\";i:94156;s:12:\"delete-94829\";i:94157;s:12:\"delete-94828\";i:94158;s:12:\"delete-94819\";i:94159;s:12:\"delete-94822\";i:94160;s:12:\"delete-94824\";i:94161;s:12:\"delete-94825\";i:94162;s:12:\"delete-94827\";i:94163;s:12:\"delete-94826\";i:94164;s:12:\"delete-94817\";i:94165;s:12:\"delete-94832\";i:94166;s:12:\"delete-94823\";i:94167;s:12:\"delete-94820\";i:94168;s:12:\"delete-94830\";i:94169;s:12:\"delete-94818\";i:94170;s:12:\"delete-94722\";i:94171;s:12:\"delete-94721\";i:94172;s:12:\"delete-94718\";i:94173;s:12:\"delete-94715\";i:94174;s:12:\"delete-94716\";i:94175;s:12:\"delete-94723\";i:94176;s:12:\"delete-94724\";i:94177;s:12:\"delete-94725\";i:94178;s:12:\"delete-94726\";i:94179;s:12:\"delete-94727\";i:94180;s:12:\"delete-94717\";i:94181;s:12:\"delete-94719\";i:94182;s:12:\"delete-94813\";i:94183;s:12:\"delete-94809\";i:94184;s:12:\"delete-94812\";i:94185;s:12:\"delete-94811\";i:94186;s:12:\"delete-94810\";i:94187;s:12:\"delete-94808\";i:94188;s:12:\"delete-94720\";i:94189;s:12:\"delete-94807\";i:94190;s:12:\"delete-94793\";i:94191;s:12:\"delete-94794\";i:94192;s:12:\"delete-94795\";i:94193;s:12:\"delete-94796\";i:94194;s:12:\"delete-94792\";i:94195;s:12:\"delete-94791\";i:94196;s:12:\"delete-94790\";i:94197;s:12:\"delete-94789\";i:94198;s:12:\"delete-94788\";i:94199;s:12:\"delete-94797\";i:94200;s:12:\"delete-94804\";i:94201;s:12:\"delete-94806\";i:94202;s:12:\"delete-94805\";i:94203;s:12:\"delete-94798\";i:94204;s:12:\"delete-94803\";i:94205;s:12:\"delete-94801\";i:94206;s:12:\"delete-94802\";i:94207;s:12:\"delete-94800\";i:94208;s:12:\"delete-94799\";i:94209;s:12:\"delete-94773\";i:94210;s:12:\"delete-94776\";i:94211;s:12:\"delete-94777\";i:94212;s:12:\"delete-94769\";i:94213;s:12:\"delete-94779\";i:94214;s:12:\"delete-94775\";i:94215;s:12:\"delete-94774\";i:94216;s:12:\"delete-94772\";i:94217;s:12:\"delete-94771\";i:94218;s:12:\"delete-94770\";i:94219;s:12:\"delete-94782\";i:94220;s:12:\"delete-94778\";i:94221;s:12:\"delete-94785\";i:94222;s:12:\"delete-94780\";i:94223;s:12:\"delete-94781\";i:94224;s:12:\"delete-94783\";i:94225;s:12:\"delete-94784\";i:94226;s:12:\"delete-94786\";i:94227;s:12:\"delete-94787\";i:94228;s:12:\"delete-94766\";i:94229;s:12:\"delete-94761\";i:94230;s:12:\"delete-94767\";i:94231;s:12:\"delete-94768\";i:94232;s:12:\"delete-94765\";i:94233;s:12:\"delete-94755\";i:94234;s:12:\"delete-94764\";i:94235;s:12:\"delete-94763\";i:94236;s:12:\"delete-94760\";i:94237;s:12:\"delete-94759\";i:94238;s:12:\"delete-94758\";i:94239;s:12:\"delete-94757\";i:94240;s:12:\"delete-94756\";i:94241;s:12:\"delete-94762\";i:94242;s:12:\"delete-94754\";i:94243;s:12:\"delete-94753\";i:94244;s:12:\"delete-94752\";i:94245;s:12:\"delete-94751\";i:94246;s:12:\"delete-94750\";i:94247;s:12:\"delete-94703\";i:94248;s:12:\"delete-94698\";i:94249;s:12:\"delete-94702\";i:94250;s:12:\"delete-94700\";i:94251;s:12:\"delete-94699\";i:94252;s:12:\"delete-94704\";i:94253;s:12:\"delete-94706\";i:94254;s:12:\"delete-94705\";i:94255;s:12:\"delete-94708\";i:94256;s:12:\"delete-94710\";i:94257;s:12:\"delete-94709\";i:94258;s:12:\"delete-94701\";i:94259;s:12:\"delete-94707\";i:94260;s:12:\"delete-94946\";i:94261;s:12:\"delete-94948\";i:94262;s:12:\"delete-95393\";i:94263;s:12:\"delete-95394\";i:94264;s:12:\"delete-95395\";i:94265;s:12:\"delete-95396\";i:94266;s:12:\"delete-95397\";i:94267;s:12:\"delete-95390\";i:94268;s:12:\"delete-95391\";i:94269;s:12:\"delete-95392\";i:94270;s:12:\"delete-95388\";i:94271;s:12:\"delete-95389\";i:94272;s:12:\"delete-95386\";i:94273;s:12:\"delete-95387\";i:94274;s:12:\"delete-95384\";i:94275;s:12:\"delete-95385\";i:94276;s:12:\"delete-95381\";i:94277;s:12:\"delete-95378\";i:94278;s:12:\"delete-95379\";i:94279;s:12:\"delete-95380\";i:94280;s:12:\"delete-95377\";i:94281;s:12:\"delete-95375\";i:94282;s:12:\"delete-95376\";i:94283;s:12:\"delete-95374\";i:94284;s:12:\"delete-95373\";i:94285;s:12:\"delete-95372\";i:94286;s:12:\"delete-95371\";i:94287;s:12:\"delete-95370\";i:94288;s:12:\"delete-95369\";i:94289;s:12:\"delete-95368\";i:94290;s:12:\"delete-95367\";i:94291;s:12:\"delete-95366\";i:94292;s:12:\"delete-95365\";i:94293;s:12:\"delete-95364\";i:94294;s:12:\"delete-95363\";i:94295;s:12:\"delete-95362\";i:94296;s:12:\"delete-95361\";i:94297;s:12:\"delete-95360\";i:94298;s:12:\"delete-95359\";i:94299;s:12:\"delete-95358\";i:94300;s:12:\"delete-95357\";i:94301;s:12:\"delete-95356\";i:94302;s:12:\"delete-95355\";i:94303;s:12:\"delete-95354\";i:94304;s:12:\"delete-95353\";i:94305;s:12:\"delete-95352\";i:94306;s:12:\"delete-95351\";i:94307;s:12:\"delete-95348\";i:94308;s:12:\"delete-95349\";i:94309;s:12:\"delete-95350\";i:94310;s:12:\"delete-95345\";i:94311;s:12:\"delete-95346\";i:94312;s:12:\"delete-95347\";i:94313;s:12:\"delete-95342\";i:94314;s:12:\"delete-95343\";i:94315;s:12:\"delete-95344\";i:94316;s:12:\"delete-95339\";i:94317;s:12:\"delete-95340\";i:94318;s:12:\"delete-95341\";i:94319;s:12:\"delete-95336\";i:94320;s:12:\"delete-95337\";i:94321;s:12:\"delete-95338\";i:94322;s:12:\"delete-95329\";i:94323;s:12:\"delete-95330\";i:94324;s:12:\"delete-95331\";i:94325;s:12:\"delete-95332\";i:94326;s:12:\"delete-95333\";i:94327;s:12:\"delete-95334\";i:94328;s:12:\"delete-95335\";i:94329;s:12:\"delete-95328\";i:94330;s:12:\"delete-95327\";i:94331;s:12:\"delete-95326\";i:94332;s:12:\"delete-95325\";i:94333;s:12:\"delete-95324\";i:94334;s:12:\"delete-95323\";i:94335;s:12:\"delete-95322\";i:94336;s:12:\"delete-95320\";i:94337;s:12:\"delete-95321\";i:94338;s:12:\"delete-95317\";i:94339;s:12:\"delete-95318\";i:94340;s:12:\"delete-95319\";i:94341;s:12:\"delete-95314\";i:94342;s:12:\"delete-95315\";i:94343;s:12:\"delete-95316\";i:94344;s:12:\"delete-95311\";i:94345;s:12:\"delete-95312\";i:94346;s:12:\"delete-95313\";i:94347;s:12:\"delete-95305\";i:94348;s:12:\"delete-95306\";i:94349;s:12:\"delete-95307\";i:94350;s:12:\"delete-95310\";i:94351;s:12:\"delete-95309\";i:94352;s:12:\"delete-95308\";i:94353;s:12:\"delete-95304\";i:94354;s:12:\"delete-95303\";i:94355;s:12:\"delete-95302\";i:94356;s:12:\"delete-95296\";i:94357;s:12:\"delete-95297\";i:94358;s:12:\"delete-95298\";i:94359;s:12:\"delete-95299\";i:94360;s:12:\"delete-95300\";i:94361;s:12:\"delete-95301\";i:94362;s:12:\"delete-95293\";i:94363;s:12:\"delete-95294\";i:94364;s:12:\"delete-95295\";i:94365;s:12:\"delete-95290\";i:94366;s:12:\"delete-95291\";i:94367;s:12:\"delete-95292\";i:94368;s:12:\"delete-95284\";i:94369;s:12:\"delete-95285\";i:94370;s:12:\"delete-95286\";i:94371;s:12:\"delete-95289\";i:94372;s:12:\"delete-95288\";i:94373;s:12:\"delete-95287\";i:94374;s:12:\"delete-95281\";i:94375;s:12:\"delete-95282\";i:94376;s:12:\"delete-95283\";i:94377;s:12:\"delete-95279\";i:94378;s:12:\"delete-95280\";i:94379;s:12:\"delete-95276\";i:94380;s:12:\"delete-95277\";i:94381;s:12:\"delete-95278\";i:94382;s:12:\"delete-95273\";i:94383;s:12:\"delete-95274\";i:94384;s:12:\"delete-95275\";i:94385;s:12:\"delete-95268\";i:94386;s:12:\"delete-95269\";i:94387;s:12:\"delete-95270\";i:94388;s:12:\"delete-95271\";i:94389;s:12:\"delete-95272\";i:94390;s:12:\"delete-95267\";i:94391;s:12:\"delete-95266\";i:94392;s:12:\"delete-95265\";i:94393;s:12:\"delete-95263\";i:94394;s:12:\"delete-95264\";i:94395;s:12:\"delete-95262\";i:94396;s:12:\"delete-95260\";i:94397;s:12:\"delete-95261\";i:94398;s:12:\"delete-95259\";i:94399;s:12:\"delete-95258\";i:94400;s:12:\"delete-95257\";i:94401;s:12:\"delete-95256\";i:94402;s:12:\"delete-95255\";i:94403;s:12:\"delete-95254\";i:94404;s:12:\"delete-95253\";i:94405;s:12:\"delete-95252\";i:94406;s:12:\"delete-95251\";i:94407;s:12:\"delete-95250\";i:94408;s:12:\"delete-95249\";i:94409;s:12:\"delete-95248\";i:94410;s:12:\"delete-95247\";i:94411;s:12:\"delete-95246\";i:94412;s:12:\"delete-95245\";i:94413;s:12:\"delete-95244\";i:94414;s:12:\"delete-95243\";i:94415;s:12:\"delete-95242\";i:94416;s:12:\"delete-95241\";i:94417;s:12:\"delete-95240\";i:94418;s:12:\"delete-95239\";i:94419;s:12:\"delete-95238\";i:94420;s:12:\"delete-95237\";i:94421;s:12:\"delete-95236\";i:94422;s:12:\"delete-95235\";i:94423;s:12:\"delete-95234\";i:94424;s:12:\"delete-95233\";i:94425;s:12:\"delete-95232\";i:94426;s:12:\"delete-95231\";i:94427;s:12:\"delete-95230\";i:94428;s:12:\"delete-95229\";i:94429;s:12:\"delete-95228\";i:94430;s:12:\"delete-95227\";i:94431;s:12:\"delete-95226\";i:94432;s:12:\"delete-95225\";i:94433;s:12:\"delete-95224\";i:94434;s:12:\"delete-95223\";i:94435;s:12:\"delete-95222\";i:94436;s:12:\"delete-95221\";i:94437;s:12:\"delete-95220\";i:94438;s:12:\"delete-95219\";i:94439;s:12:\"delete-95218\";i:94440;s:12:\"delete-95217\";i:94441;s:12:\"delete-95216\";i:94442;s:12:\"delete-95215\";i:94443;s:12:\"delete-95214\";i:94444;s:12:\"delete-95213\";i:94445;s:12:\"delete-95212\";i:94446;s:12:\"delete-95211\";i:94447;s:12:\"delete-95210\";i:94448;s:12:\"delete-95209\";i:94449;s:12:\"delete-95208\";i:94450;s:12:\"delete-95207\";i:94451;s:12:\"delete-95206\";i:94452;s:12:\"delete-95205\";i:94453;s:12:\"delete-95204\";i:94454;s:12:\"delete-95203\";i:94455;s:12:\"delete-95202\";i:94456;s:12:\"delete-95201\";i:94457;s:12:\"delete-95200\";i:94458;s:12:\"delete-95199\";i:94459;s:12:\"delete-95198\";i:94460;s:12:\"delete-95197\";i:94461;s:12:\"delete-95196\";i:94462;s:12:\"delete-95195\";i:94463;s:12:\"delete-95194\";i:94464;s:12:\"delete-95193\";i:94465;s:12:\"delete-95192\";i:94466;s:12:\"delete-95191\";i:94467;s:12:\"delete-95190\";i:94468;s:12:\"delete-95189\";i:94469;s:12:\"delete-95188\";i:94470;s:12:\"delete-95187\";i:94471;s:12:\"delete-95186\";i:94472;s:12:\"delete-95185\";i:94473;s:12:\"delete-95184\";i:94474;s:12:\"delete-95183\";i:94475;s:12:\"delete-95182\";i:94476;s:12:\"delete-95181\";i:94477;s:12:\"delete-95180\";i:94478;s:12:\"delete-95179\";i:94479;s:12:\"delete-95178\";i:94480;s:12:\"delete-95177\";i:94481;s:12:\"delete-95176\";i:94482;s:12:\"delete-95175\";i:94483;s:12:\"delete-95174\";i:94484;s:12:\"delete-95173\";i:94485;s:12:\"delete-95172\";i:94486;s:12:\"delete-95171\";i:94487;s:12:\"delete-95170\";i:94488;s:12:\"delete-95169\";i:94489;s:12:\"delete-95168\";i:94490;s:12:\"delete-95167\";i:94491;s:12:\"delete-95166\";i:94492;s:12:\"delete-95165\";i:94493;s:12:\"delete-95164\";i:94494;s:12:\"delete-95163\";i:94495;s:12:\"delete-95162\";i:94496;s:12:\"delete-95161\";i:94497;s:12:\"delete-95160\";i:94498;s:12:\"delete-95159\";i:94499;s:12:\"delete-95158\";i:94500;s:12:\"delete-95157\";i:94501;s:12:\"delete-95156\";i:94502;s:12:\"delete-95155\";i:94503;s:12:\"delete-95154\";i:94504;s:12:\"delete-95152\";i:94505;s:12:\"delete-95153\";i:94506;s:12:\"delete-95151\";i:94507;s:12:\"delete-95150\";i:94508;s:12:\"delete-95149\";i:94509;s:12:\"delete-95148\";i:94510;s:12:\"delete-95144\";i:94511;s:12:\"delete-95145\";i:94512;s:12:\"delete-95146\";i:94513;s:12:\"delete-95147\";i:94514;s:12:\"delete-95142\";i:94515;s:12:\"delete-95143\";i:94516;s:12:\"delete-95139\";i:94517;s:12:\"delete-95140\";i:94518;s:12:\"delete-95141\";i:94519;s:12:\"delete-95138\";i:94520;s:12:\"delete-95137\";i:94521;s:12:\"delete-95136\";i:94522;s:12:\"delete-95135\";i:94523;s:12:\"delete-95134\";i:94524;s:12:\"delete-95126\";i:94525;s:12:\"delete-95127\";i:94526;s:12:\"delete-95128\";i:94527;s:12:\"delete-95129\";i:94528;s:12:\"delete-95130\";i:94529;s:12:\"delete-95131\";i:94530;s:12:\"delete-95132\";i:94531;s:12:\"delete-95133\";i:94532;s:12:\"delete-95125\";i:94533;s:12:\"delete-95124\";i:94534;s:12:\"delete-95123\";i:94535;s:12:\"delete-95122\";i:94536;s:12:\"delete-95121\";i:94537;s:12:\"delete-95119\";i:94538;s:12:\"delete-95120\";i:94539;s:12:\"delete-95118\";i:94540;s:12:\"delete-95117\";i:94541;s:12:\"delete-95116\";i:94542;s:12:\"delete-95115\";i:94543;s:12:\"delete-95114\";i:94544;s:12:\"delete-95113\";i:94545;s:12:\"delete-95112\";i:94546;s:12:\"delete-95111\";i:94547;s:12:\"delete-95110\";i:94548;s:12:\"delete-95109\";i:94549;s:12:\"delete-95108\";i:94550;s:12:\"delete-95107\";i:94551;s:12:\"delete-95106\";i:94552;s:12:\"delete-95105\";i:94553;s:12:\"delete-95103\";i:94554;s:12:\"delete-95104\";i:94555;s:12:\"delete-95102\";i:94556;s:12:\"delete-95099\";i:94557;s:12:\"delete-95101\";i:94558;s:12:\"delete-95100\";i:94559;s:12:\"delete-95098\";i:94560;s:12:\"delete-95093\";i:94561;s:12:\"delete-95094\";i:94562;s:12:\"delete-95095\";i:94563;s:12:\"delete-95096\";i:94564;s:12:\"delete-95097\";i:94565;s:12:\"delete-95092\";i:94566;s:12:\"delete-95091\";i:94567;s:12:\"delete-95090\";i:94568;s:12:\"delete-95089\";i:94569;s:12:\"delete-95088\";i:94570;s:12:\"delete-95087\";i:94571;s:12:\"delete-95086\";i:94572;s:12:\"delete-95073\";i:94573;s:12:\"delete-95074\";i:94574;s:12:\"delete-95075\";i:94575;s:12:\"delete-95076\";i:94576;s:12:\"delete-95077\";i:94577;s:12:\"delete-95078\";i:94578;s:12:\"delete-95079\";i:94579;s:12:\"delete-95080\";i:94580;s:12:\"delete-95081\";i:94581;s:12:\"delete-95082\";i:94582;s:12:\"delete-95083\";i:94583;s:12:\"delete-95084\";i:94584;s:12:\"delete-95085\";i:94585;s:12:\"delete-95072\";i:94586;s:12:\"delete-95071\";i:94587;s:12:\"delete-95060\";i:94588;s:12:\"delete-95061\";i:94589;s:12:\"delete-95062\";i:94590;s:12:\"delete-95063\";i:94591;s:12:\"delete-95064\";i:94592;s:12:\"delete-95065\";i:94593;s:12:\"delete-95066\";i:94594;s:12:\"delete-95067\";i:94595;s:12:\"delete-95068\";i:94596;s:12:\"delete-95069\";i:94597;s:12:\"delete-95070\";i:94598;s:12:\"delete-95056\";i:94599;s:12:\"delete-95057\";i:94600;s:12:\"delete-95058\";i:94601;s:12:\"delete-95059\";i:94602;s:12:\"delete-95055\";i:94603;s:12:\"delete-95054\";i:94604;s:12:\"delete-95053\";i:94605;s:12:\"delete-95051\";i:94606;s:12:\"delete-95052\";i:94607;s:12:\"delete-95050\";i:94608;s:12:\"delete-95049\";i:94609;s:12:\"delete-95047\";i:94610;s:12:\"delete-95048\";i:94611;s:12:\"delete-95046\";i:94612;s:12:\"delete-95043\";i:94613;s:12:\"delete-95045\";i:94614;s:12:\"delete-95044\";i:94615;s:12:\"delete-95042\";i:94616;s:12:\"delete-95041\";i:94617;s:12:\"delete-95040\";i:94618;s:12:\"delete-95039\";i:94619;s:12:\"delete-95038\";i:94620;s:12:\"delete-95037\";i:94621;s:12:\"delete-95033\";i:94622;s:12:\"delete-95034\";i:94623;s:12:\"delete-95035\";i:94624;s:12:\"delete-95036\";i:94625;s:12:\"delete-95030\";i:94626;s:12:\"delete-95032\";i:94627;s:12:\"delete-95031\";i:94628;s:12:\"delete-95027\";i:94629;s:12:\"delete-95028\";i:94630;s:12:\"delete-95029\";i:94631;s:12:\"delete-95026\";i:94632;s:12:\"delete-95025\";i:94633;s:12:\"delete-95023\";i:94634;s:12:\"delete-95024\";i:94635;s:12:\"delete-95022\";i:94636;s:12:\"delete-95021\";i:94637;s:12:\"delete-95020\";i:94638;s:12:\"delete-95018\";i:94639;s:12:\"delete-95019\";i:94640;s:12:\"delete-95017\";i:94641;s:12:\"delete-95016\";i:94642;s:12:\"delete-95014\";i:94643;s:12:\"delete-95015\";i:94644;s:12:\"delete-95013\";i:94645;s:12:\"delete-95012\";i:94646;s:12:\"delete-95011\";i:94647;s:12:\"delete-95010\";i:94648;s:12:\"delete-95009\";i:94649;s:12:\"delete-95008\";i:94650;s:12:\"delete-95007\";i:94651;s:12:\"delete-95006\";i:94652;s:12:\"delete-95005\";i:94653;s:12:\"delete-95004\";i:94654;s:12:\"delete-95003\";i:94655;s:12:\"delete-95001\";i:94656;s:12:\"delete-95002\";i:94657;s:12:\"delete-94998\";i:94658;s:12:\"delete-94999\";i:94659;s:12:\"delete-95000\";i:94660;s:12:\"delete-94996\";i:94661;s:12:\"delete-94997\";i:94662;s:12:\"delete-94993\";i:94663;s:12:\"delete-94994\";i:94664;s:12:\"delete-94995\";i:94665;s:12:\"delete-94991\";i:94666;s:12:\"delete-94992\";i:94667;s:12:\"delete-94990\";i:94668;s:12:\"delete-94987\";i:94669;s:12:\"delete-94988\";i:94670;s:12:\"delete-94989\";i:94671;s:12:\"delete-94985\";i:94672;s:12:\"delete-94986\";i:94673;s:12:\"delete-94984\";i:94674;s:12:\"delete-94983\";i:94675;s:12:\"delete-94982\";i:94676;s:12:\"delete-94981\";i:94677;s:12:\"delete-94980\";i:94678;s:12:\"delete-94977\";i:94679;s:12:\"delete-94978\";i:94680;s:12:\"delete-94979\";i:94681;s:12:\"delete-94976\";i:94682;s:12:\"delete-94974\";i:94683;s:12:\"delete-94975\";i:94684;s:12:\"delete-94972\";i:94685;s:12:\"delete-94973\";i:94686;s:12:\"delete-94969\";i:94687;s:12:\"delete-94970\";i:94688;s:12:\"delete-94971\";i:94689;s:12:\"delete-94967\";i:94690;s:12:\"delete-94968\";i:94691;s:12:\"delete-94966\";i:94692;s:12:\"delete-94964\";i:94693;s:12:\"delete-94965\";i:94694;s:12:\"delete-94962\";i:94695;s:12:\"delete-94963\";i:94696;s:12:\"delete-94959\";i:94697;s:12:\"delete-94960\";i:94698;s:12:\"delete-94961\";i:94699;s:12:\"delete-94958\";i:94700;s:12:\"delete-94957\";i:94701;s:12:\"delete-94956\";i:94702;s:12:\"delete-94954\";i:94703;s:12:\"delete-94955\";i:94704;s:12:\"delete-94952\";i:94705;s:12:\"delete-94953\";i:94706;s:12:\"delete-94951\";i:94707;s:12:\"delete-95383\";i:94708;s:12:\"delete-94949\";i:94709;s:12:\"delete-94950\";i:94710;s:12:\"delete-95790\";i:94711;s:12:\"delete-95789\";i:94712;s:12:\"delete-95788\";i:94713;s:12:\"delete-95785\";i:94714;s:12:\"delete-95787\";i:94715;s:12:\"delete-95786\";i:94716;s:12:\"delete-95784\";i:94717;s:12:\"delete-95783\";i:94718;s:12:\"delete-95782\";i:94719;s:12:\"delete-95781\";i:94720;s:12:\"delete-95780\";i:94721;s:12:\"delete-95779\";i:94722;s:12:\"delete-95778\";i:94723;s:12:\"delete-95777\";i:94724;s:12:\"delete-95776\";i:94725;s:12:\"delete-95775\";i:94726;s:12:\"delete-95774\";i:94727;s:12:\"delete-95773\";i:94728;s:12:\"delete-95772\";i:94729;s:12:\"delete-95771\";i:94730;s:12:\"delete-95770\";i:94731;s:12:\"delete-95769\";i:94732;s:12:\"delete-95768\";i:94733;s:12:\"delete-95767\";i:94734;s:12:\"delete-95766\";i:94735;s:12:\"delete-95765\";i:94736;s:12:\"delete-95764\";i:94737;s:12:\"delete-95763\";i:94738;s:12:\"delete-95762\";i:94739;s:12:\"delete-95761\";i:94740;s:12:\"delete-95760\";i:94741;s:12:\"delete-95759\";i:94742;s:12:\"delete-95758\";i:94743;s:12:\"delete-95757\";i:94744;s:12:\"delete-95756\";i:94745;s:12:\"delete-95755\";i:94746;s:12:\"delete-95754\";i:94747;s:12:\"delete-95753\";i:94748;s:12:\"delete-95752\";i:94749;s:12:\"delete-95751\";i:94750;s:12:\"delete-95749\";i:94751;s:12:\"delete-95750\";i:94752;s:12:\"delete-95748\";i:94753;s:12:\"delete-95747\";i:94754;s:12:\"delete-95745\";i:94755;s:12:\"delete-95746\";i:94756;s:12:\"delete-95742\";i:94757;s:12:\"delete-95743\";i:94758;s:12:\"delete-95744\";i:94759;s:12:\"delete-95736\";i:94760;s:12:\"delete-95737\";i:94761;s:12:\"delete-95738\";i:94762;s:12:\"delete-95741\";i:94763;s:12:\"delete-95740\";i:94764;s:12:\"delete-95739\";i:94765;s:12:\"delete-95735\";i:94766;s:12:\"delete-95734\";i:94767;s:12:\"delete-95733\";i:94768;s:12:\"delete-95731\";i:94769;s:12:\"delete-95732\";i:94770;s:12:\"delete-95728\";i:94771;s:12:\"delete-95729\";i:94772;s:12:\"delete-95730\";i:94773;s:12:\"delete-95726\";i:94774;s:12:\"delete-95727\";i:94775;s:12:\"delete-95725\";i:94776;s:12:\"delete-95723\";i:94777;s:12:\"delete-95724\";i:94778;s:12:\"delete-95722\";i:94779;s:12:\"delete-95720\";i:94780;s:12:\"delete-95721\";i:94781;s:12:\"delete-95719\";i:94782;s:12:\"delete-95717\";i:94783;s:12:\"delete-95718\";i:94784;s:12:\"delete-95716\";i:94785;s:12:\"delete-95714\";i:94786;s:12:\"delete-95715\";i:94787;s:12:\"delete-95713\";i:94788;s:12:\"delete-95711\";i:94789;s:12:\"delete-95712\";i:94790;s:12:\"delete-95710\";i:94791;s:12:\"delete-95708\";i:94792;s:12:\"delete-95709\";i:94793;s:12:\"delete-95707\";i:94794;s:12:\"delete-95705\";i:94795;s:12:\"delete-95706\";i:94796;s:12:\"delete-95704\";i:94797;s:12:\"delete-95702\";i:94798;s:12:\"delete-95703\";i:94799;s:12:\"delete-95701\";i:94800;s:12:\"delete-95699\";i:94801;s:12:\"delete-95700\";i:94802;s:12:\"delete-95698\";i:94803;s:12:\"delete-95696\";i:94804;s:12:\"delete-95697\";i:94805;s:12:\"delete-95695\";i:94806;s:12:\"delete-95693\";i:94807;s:12:\"delete-95694\";i:94808;s:12:\"delete-95692\";i:94809;s:12:\"delete-95690\";i:94810;s:12:\"delete-95691\";i:94811;s:12:\"delete-95689\";i:94812;s:12:\"delete-95687\";i:94813;s:12:\"delete-95688\";i:94814;s:12:\"delete-95686\";i:94815;s:12:\"delete-95684\";i:94816;s:12:\"delete-95685\";i:94817;s:12:\"delete-95683\";i:94818;s:12:\"delete-95681\";i:94819;s:12:\"delete-95682\";i:94820;s:12:\"delete-95680\";i:94821;s:12:\"delete-95679\";i:94822;s:12:\"delete-95678\";i:94823;s:12:\"delete-95677\";i:94824;s:12:\"delete-95676\";i:94825;s:12:\"delete-95675\";i:94826;s:12:\"delete-95674\";i:94827;s:12:\"delete-95673\";i:94828;s:12:\"delete-95672\";i:94829;s:12:\"delete-95671\";i:94830;s:12:\"delete-95670\";i:94831;s:12:\"delete-95669\";i:94832;s:12:\"delete-95668\";i:94833;s:12:\"delete-95667\";i:94834;s:12:\"delete-95666\";i:94835;s:12:\"delete-95665\";i:94836;s:12:\"delete-95664\";i:94837;s:12:\"delete-95663\";i:94838;s:12:\"delete-95662\";i:94839;s:12:\"delete-95661\";i:94840;s:12:\"delete-95660\";i:94841;s:12:\"delete-95659\";i:94842;s:12:\"delete-95658\";i:94843;s:12:\"delete-95657\";i:94844;s:12:\"delete-95656\";i:94845;s:12:\"delete-95655\";i:94846;s:12:\"delete-95654\";i:94847;s:12:\"delete-95653\";i:94848;s:12:\"delete-95652\";i:94849;s:12:\"delete-95651\";i:94850;s:12:\"delete-95650\";i:94851;s:12:\"delete-95649\";i:94852;s:12:\"delete-95648\";i:94853;s:12:\"delete-95647\";i:94854;s:12:\"delete-95646\";i:94855;s:12:\"delete-95645\";i:94856;s:12:\"delete-95644\";i:94857;s:12:\"delete-95643\";i:94858;s:12:\"delete-95642\";i:94859;s:12:\"delete-95641\";i:94860;s:12:\"delete-95640\";i:94861;s:12:\"delete-95639\";i:94862;s:12:\"delete-95638\";i:94863;s:12:\"delete-95637\";i:94864;s:12:\"delete-95636\";i:94865;s:12:\"delete-95635\";i:94866;s:12:\"delete-95634\";i:94867;s:12:\"delete-95633\";i:94868;s:12:\"delete-95632\";i:94869;s:12:\"delete-95631\";i:94870;s:12:\"delete-95630\";i:94871;s:12:\"delete-95629\";i:94872;s:12:\"delete-95628\";i:94873;s:12:\"delete-95627\";i:94874;s:12:\"delete-95626\";i:94875;s:12:\"delete-95625\";i:94876;s:12:\"delete-95624\";i:94877;s:12:\"delete-95623\";i:94878;s:12:\"delete-95622\";i:94879;s:12:\"delete-95621\";i:94880;s:12:\"delete-95620\";i:94881;s:12:\"delete-95619\";i:94882;s:12:\"delete-95618\";i:94883;s:12:\"delete-95617\";i:94884;s:12:\"delete-95616\";i:94885;s:12:\"delete-95615\";i:94886;s:12:\"delete-95614\";i:94887;s:12:\"delete-95613\";i:94888;s:12:\"delete-95612\";i:94889;s:12:\"delete-95611\";i:94890;s:12:\"delete-95610\";i:94891;s:12:\"delete-95609\";i:94892;s:12:\"delete-95608\";i:94893;s:12:\"delete-95607\";i:94894;s:12:\"delete-95604\";i:94895;s:12:\"delete-95606\";i:94896;s:12:\"delete-95605\";i:94897;s:12:\"delete-95603\";i:94898;s:12:\"delete-95602\";i:94899;s:12:\"delete-95601\";i:94900;s:12:\"delete-95600\";i:94901;s:12:\"delete-95599\";i:94902;s:12:\"delete-95598\";i:94903;s:12:\"delete-95597\";i:94904;s:12:\"delete-95596\";i:94905;s:12:\"delete-95595\";i:94906;s:12:\"delete-95594\";i:94907;s:12:\"delete-95593\";i:94908;s:12:\"delete-95592\";i:94909;s:12:\"delete-95591\";i:94910;s:12:\"delete-95590\";i:94911;s:12:\"delete-95589\";i:94912;s:12:\"delete-95588\";i:94913;s:12:\"delete-95587\";i:94914;s:12:\"delete-95586\";i:94915;s:12:\"delete-95585\";i:94916;s:12:\"delete-95584\";i:94917;s:12:\"delete-95583\";i:94918;s:12:\"delete-95582\";i:94919;s:12:\"delete-95581\";i:94920;s:12:\"delete-95580\";i:94921;s:12:\"delete-95579\";i:94922;s:12:\"delete-95578\";i:94923;s:12:\"delete-95577\";i:94924;s:12:\"delete-95576\";i:94925;s:12:\"delete-95575\";i:94926;s:12:\"delete-95572\";i:94927;s:12:\"delete-95573\";i:94928;s:12:\"delete-95574\";i:94929;s:12:\"delete-95571\";i:94930;s:12:\"delete-95570\";i:94931;s:12:\"delete-95569\";i:94932;s:12:\"delete-95568\";i:94933;s:12:\"delete-95567\";i:94934;s:12:\"delete-95566\";i:94935;s:12:\"delete-95565\";i:94936;s:12:\"delete-95564\";i:94937;s:12:\"delete-95563\";i:94938;s:12:\"delete-95562\";i:94939;s:12:\"delete-95561\";i:94940;s:12:\"delete-95560\";i:94941;s:12:\"delete-95559\";i:94942;s:12:\"delete-95556\";i:94943;s:12:\"delete-95557\";i:94944;s:12:\"delete-95558\";i:94945;s:12:\"delete-95554\";i:94946;s:12:\"delete-95555\";i:94947;s:12:\"delete-95552\";i:94948;s:12:\"delete-95553\";i:94949;s:12:\"delete-95546\";i:94950;s:12:\"delete-95547\";i:94951;s:12:\"delete-95548\";i:94952;s:12:\"delete-95549\";i:94953;s:12:\"delete-95550\";i:94954;s:12:\"delete-95551\";i:94955;s:12:\"delete-95544\";i:94956;s:12:\"delete-95545\";i:94957;s:12:\"delete-95543\";i:94958;s:12:\"delete-95542\";i:94959;s:12:\"delete-95541\";i:94960;s:12:\"delete-95540\";i:94961;s:12:\"delete-95539\";i:94962;s:12:\"delete-95538\";i:94963;s:12:\"delete-95537\";i:94964;s:12:\"delete-95536\";i:94965;s:12:\"delete-95535\";i:94966;s:12:\"delete-95534\";i:94967;s:12:\"delete-95533\";i:94968;s:12:\"delete-95532\";i:94969;s:12:\"delete-95531\";i:94970;s:12:\"delete-95530\";i:94971;s:12:\"delete-95529\";i:94972;s:12:\"delete-95528\";i:94973;s:12:\"delete-95527\";i:94974;s:12:\"delete-95526\";i:94975;s:12:\"delete-95525\";i:94976;s:12:\"delete-95524\";i:94977;s:12:\"delete-95523\";i:94978;s:12:\"delete-95522\";i:94979;s:12:\"delete-95512\";i:94980;s:12:\"delete-95513\";i:94981;s:12:\"delete-95514\";i:94982;s:12:\"delete-95515\";i:94983;s:12:\"delete-95516\";i:94984;s:12:\"delete-95517\";i:94985;s:12:\"delete-95518\";i:94986;s:12:\"delete-95519\";i:94987;s:12:\"delete-95520\";i:94988;s:12:\"delete-95521\";i:94989;s:12:\"delete-95507\";i:94990;s:12:\"delete-95508\";i:94991;s:12:\"delete-95509\";i:94992;s:12:\"delete-95510\";i:94993;s:12:\"delete-95511\";i:94994;s:12:\"delete-95506\";i:94995;s:12:\"delete-95505\";i:94996;s:12:\"delete-95502\";i:94997;s:12:\"delete-95503\";i:94998;s:12:\"delete-95504\";i:94999;s:12:\"delete-95501\";i:95000;s:12:\"delete-95499\";i:95001;s:12:\"delete-95500\";i:95002;s:12:\"delete-95497\";i:95003;s:12:\"delete-95498\";i:95004;s:12:\"delete-95495\";i:95005;s:12:\"delete-95496\";i:95006;s:12:\"delete-95493\";i:95007;s:12:\"delete-95494\";i:95008;s:12:\"delete-95492\";i:95009;s:12:\"delete-95491\";i:95010;s:12:\"delete-95489\";i:95011;s:12:\"delete-95490\";i:95012;s:12:\"delete-95484\";i:95013;s:12:\"delete-95485\";i:95014;s:12:\"delete-95486\";i:95015;s:12:\"delete-95487\";i:95016;s:12:\"delete-95488\";i:95017;s:12:\"delete-95482\";i:95018;s:12:\"delete-95483\";i:95019;s:12:\"delete-95478\";i:95020;s:12:\"delete-95479\";i:95021;s:12:\"delete-95480\";i:95022;s:12:\"delete-95481\";i:95023;s:12:\"delete-95475\";i:95024;s:12:\"delete-95476\";i:95025;s:12:\"delete-95477\";i:95026;s:12:\"delete-95474\";i:95027;s:12:\"delete-95473\";i:95028;s:12:\"delete-95472\";i:95029;s:12:\"delete-95469\";i:95030;s:12:\"delete-95470\";i:95031;s:12:\"delete-95471\";i:95032;s:12:\"delete-95468\";i:95033;s:12:\"delete-95466\";i:95034;s:12:\"delete-95467\";i:95035;s:12:\"delete-95465\";i:95036;s:12:\"delete-95464\";i:95037;s:12:\"delete-95463\";i:95038;s:12:\"delete-95462\";i:95039;s:12:\"delete-95461\";i:95040;s:12:\"delete-95460\";i:95041;s:12:\"delete-95459\";i:95042;s:12:\"delete-95458\";i:95043;s:12:\"delete-95457\";i:95044;s:12:\"delete-95456\";i:95045;s:12:\"delete-95455\";i:95046;s:12:\"delete-95450\";i:95047;s:12:\"delete-95451\";i:95048;s:12:\"delete-95452\";i:95049;s:12:\"delete-95453\";i:95050;s:12:\"delete-95454\";i:95051;s:12:\"delete-95448\";i:95052;s:12:\"delete-95449\";i:95053;s:12:\"delete-95443\";i:95054;s:12:\"delete-95444\";i:95055;s:12:\"delete-95445\";i:95056;s:12:\"delete-95446\";i:95057;s:12:\"delete-95447\";i:95058;s:12:\"delete-95441\";i:95059;s:12:\"delete-95442\";i:95060;s:12:\"delete-95437\";i:95061;s:12:\"delete-95438\";i:95062;s:12:\"delete-95440\";i:95063;s:12:\"delete-95439\";i:95064;s:12:\"delete-95435\";i:95065;s:12:\"delete-95436\";i:95066;s:12:\"delete-95433\";i:95067;s:12:\"delete-95434\";i:95068;s:12:\"delete-95432\";i:95069;s:12:\"delete-95431\";i:95070;s:12:\"delete-95427\";i:95071;s:12:\"delete-95428\";i:95072;s:12:\"delete-95429\";i:95073;s:12:\"delete-95430\";i:95074;s:12:\"delete-95425\";i:95075;s:12:\"delete-95426\";i:95076;s:12:\"delete-95419\";i:95077;s:12:\"delete-95420\";i:95078;s:12:\"delete-95421\";i:95079;s:12:\"delete-95422\";i:95080;s:12:\"delete-95423\";i:95081;s:12:\"delete-95424\";i:95082;s:12:\"delete-95417\";i:95083;s:12:\"delete-95418\";i:95084;s:12:\"delete-95416\";i:95085;s:12:\"delete-95412\";i:95086;s:12:\"delete-95413\";i:95087;s:12:\"delete-95414\";i:95088;s:12:\"delete-95415\";i:95089;s:12:\"delete-95411\";i:95090;s:12:\"delete-95409\";i:95091;s:12:\"delete-95410\";i:95092;s:12:\"delete-95408\";i:95093;s:12:\"delete-95407\";i:95094;s:12:\"delete-95405\";i:95095;s:12:\"delete-95406\";i:95096;s:12:\"delete-95402\";i:95097;s:12:\"delete-95403\";i:95098;s:12:\"delete-95404\";i:95099;s:12:\"delete-95400\";i:95100;s:12:\"delete-95401\";i:95101;s:12:\"delete-95398\";i:95102;s:12:\"delete-95399\";i:95103;s:12:\"delete-96214\";i:95104;s:12:\"delete-96217\";i:95105;s:12:\"delete-96218\";i:95106;s:12:\"delete-96219\";i:95107;s:12:\"delete-96220\";i:95108;s:12:\"delete-96223\";i:95109;s:12:\"delete-96226\";i:95110;s:12:\"delete-96229\";i:95111;s:12:\"delete-96232\";i:95112;s:12:\"delete-96235\";i:95113;s:12:\"delete-96237\";i:95114;s:12:\"delete-96236\";i:95115;s:12:\"delete-96239\";i:95116;s:12:\"delete-96242\";i:95117;s:12:\"delete-96243\";i:95118;s:12:\"delete-96244\";i:95119;s:12:\"delete-96248\";i:95120;s:12:\"delete-96245\";i:95121;s:12:\"delete-96249\";i:95122;s:12:\"delete-96250\";i:95123;s:12:\"delete-96215\";i:95124;s:12:\"delete-96216\";i:95125;s:12:\"delete-96221\";i:95126;s:12:\"delete-96222\";i:95127;s:12:\"delete-96224\";i:95128;s:12:\"delete-96225\";i:95129;s:12:\"delete-96227\";i:95130;s:12:\"delete-96228\";i:95131;s:12:\"delete-96231\";i:95132;s:12:\"delete-96230\";i:95133;s:12:\"delete-96233\";i:95134;s:12:\"delete-96234\";i:95135;s:12:\"delete-96240\";i:95136;s:12:\"delete-96241\";i:95137;s:12:\"delete-96246\";i:95138;s:12:\"delete-96247\";i:95139;s:12:\"delete-96105\";i:95140;s:12:\"delete-96106\";i:95141;s:12:\"delete-96102\";i:95142;s:12:\"delete-96103\";i:95143;s:12:\"delete-96104\";i:95144;s:12:\"delete-96099\";i:95145;s:12:\"delete-96100\";i:95146;s:12:\"delete-96101\";i:95147;s:12:\"delete-96097\";i:95148;s:12:\"delete-96098\";i:95149;s:12:\"delete-96251\";i:95150;s:12:\"delete-96252\";i:95151;s:12:\"delete-96253\";i:95152;s:12:\"delete-96110\";i:95153;s:12:\"delete-96111\";i:95154;s:12:\"delete-96085\";i:95155;s:12:\"delete-95858\";i:95156;s:12:\"delete-95856\";i:95157;s:12:\"delete-95853\";i:95158;s:12:\"delete-95843\";i:95159;s:12:\"delete-95844\";i:95160;s:12:\"delete-95828\";i:95161;s:12:\"delete-95830\";i:95162;s:12:\"delete-95827\";i:95163;s:12:\"delete-95814\";i:95164;s:12:\"delete-96395\";i:95165;s:12:\"delete-95382\";i:95166;s:12:\"delete-94943\";i:95167;s:12:\"delete-94944\";i:95168;s:12:\"delete-94945\";i:95169;s:12:\"delete-94947\";i:95170;s:12:\"delete-94940\";i:95171;s:12:\"delete-94941\";i:95172;s:12:\"delete-94942\";i:95173;s:12:\"delete-96422\";i:95174;s:12:\"delete-96312\";i:95175;s:12:\"delete-96421\";i:95176;s:12:\"delete-96420\";i:95177;s:12:\"delete-96419\";i:95178;s:12:\"delete-96418\";i:95179;s:12:\"delete-96417\";i:95180;s:12:\"delete-96416\";i:95181;s:12:\"delete-96415\";i:95182;s:12:\"delete-96414\";i:95183;s:12:\"delete-96413\";i:95184;s:12:\"delete-96412\";i:95185;s:12:\"delete-96411\";i:95186;s:12:\"delete-96410\";i:95187;s:12:\"delete-96409\";i:95188;s:12:\"delete-96408\";i:95189;s:12:\"delete-96407\";i:95190;s:12:\"delete-96406\";i:95191;s:12:\"delete-96405\";i:95192;s:12:\"delete-96404\";i:95193;s:12:\"delete-96402\";i:95194;s:12:\"delete-96401\";i:95195;s:12:\"delete-96398\";i:95196;s:12:\"delete-96399\";i:95197;s:12:\"delete-96400\";i:95198;s:12:\"delete-96397\";i:95199;s:12:\"delete-96396\";i:95200;s:12:\"delete-96394\";i:95201;s:12:\"delete-96403\";i:95202;s:12:\"delete-96393\";i:95203;s:12:\"delete-96392\";i:95204;s:12:\"delete-96391\";i:95205;s:12:\"delete-96390\";i:95206;s:12:\"delete-96389\";i:95207;s:12:\"delete-96388\";i:95208;s:12:\"delete-96387\";i:95209;s:12:\"delete-96386\";i:95210;s:12:\"delete-96385\";i:95211;s:12:\"delete-96384\";i:95212;s:12:\"delete-96383\";i:95213;s:12:\"delete-96382\";i:95214;s:12:\"delete-96381\";i:95215;s:12:\"delete-96380\";i:95216;s:12:\"delete-96379\";i:95217;s:12:\"delete-96378\";i:95218;s:12:\"delete-96377\";i:95219;s:12:\"delete-96376\";i:95220;s:12:\"delete-96375\";i:95221;s:12:\"delete-96374\";i:95222;s:12:\"delete-96373\";i:95223;s:12:\"delete-96372\";i:95224;s:12:\"delete-96371\";i:95225;s:12:\"delete-96370\";i:95226;s:12:\"delete-96369\";i:95227;s:12:\"delete-96368\";i:95228;s:12:\"delete-96367\";i:95229;s:12:\"delete-96366\";i:95230;s:12:\"delete-96365\";i:95231;s:12:\"delete-96363\";i:95232;s:12:\"delete-96364\";i:95233;s:12:\"delete-96361\";i:95234;s:12:\"delete-96362\";i:95235;s:12:\"delete-96360\";i:95236;s:12:\"delete-96359\";i:95237;s:12:\"delete-96357\";i:95238;s:12:\"delete-96358\";i:95239;s:12:\"delete-96356\";i:95240;s:12:\"delete-96355\";i:95241;s:12:\"delete-96354\";i:95242;s:12:\"delete-96353\";i:95243;s:12:\"delete-96352\";i:95244;s:12:\"delete-96351\";i:95245;s:12:\"delete-96350\";i:95246;s:12:\"delete-96349\";i:95247;s:12:\"delete-96348\";i:95248;s:12:\"delete-96347\";i:95249;s:12:\"delete-96346\";i:95250;s:12:\"delete-96345\";i:95251;s:12:\"delete-96344\";i:95252;s:12:\"delete-96343\";i:95253;s:12:\"delete-96342\";i:95254;s:12:\"delete-96341\";i:95255;s:12:\"delete-96340\";i:95256;s:12:\"delete-96339\";i:95257;s:12:\"delete-96338\";i:95258;s:12:\"delete-96337\";i:95259;s:12:\"delete-96336\";i:95260;s:12:\"delete-96335\";i:95261;s:12:\"delete-96311\";i:95262;s:12:\"delete-96310\";i:95263;s:12:\"delete-96309\";i:95264;s:12:\"delete-96308\";i:95265;s:12:\"delete-96307\";i:95266;s:12:\"delete-96306\";i:95267;s:12:\"delete-96305\";i:95268;s:12:\"delete-96304\";i:95269;s:12:\"delete-96303\";i:95270;s:12:\"delete-96302\";i:95271;s:12:\"delete-96301\";i:95272;s:12:\"delete-96300\";i:95273;s:12:\"delete-96299\";i:95274;s:12:\"delete-96298\";i:95275;s:12:\"delete-96297\";i:95276;s:12:\"delete-96296\";i:95277;s:12:\"delete-96255\";i:95278;s:12:\"delete-96254\";i:95279;s:12:\"delete-96276\";i:95280;s:12:\"delete-96315\";i:95281;s:12:\"delete-96314\";i:95282;s:12:\"delete-96313\";i:95283;s:12:\"delete-96277\";i:95284;s:12:\"delete-96278\";i:95285;s:12:\"delete-96256\";i:95286;s:12:\"delete-96257\";i:95287;s:12:\"delete-96258\";i:95288;s:12:\"delete-96259\";i:95289;s:12:\"delete-96238\";i:95290;s:12:\"delete-96260\";i:95291;s:12:\"delete-96275\";i:95292;s:12:\"delete-96261\";i:95293;s:12:\"delete-96262\";i:95294;s:12:\"delete-96263\";i:95295;s:12:\"delete-96264\";i:95296;s:12:\"delete-96265\";i:95297;s:12:\"delete-96266\";i:95298;s:12:\"delete-96267\";i:95299;s:12:\"delete-96268\";i:95300;s:12:\"delete-96269\";i:95301;s:12:\"delete-96270\";i:95302;s:12:\"delete-96271\";i:95303;s:12:\"delete-96272\";i:95304;s:12:\"delete-96273\";i:95305;s:12:\"delete-96274\";i:95306;s:12:\"delete-96213\";i:95307;s:12:\"delete-96212\";i:95308;s:12:\"delete-96211\";i:95309;s:12:\"delete-96210\";i:95310;s:12:\"delete-96209\";i:95311;s:12:\"delete-96208\";i:95312;s:12:\"delete-96207\";i:95313;s:12:\"delete-96204\";i:95314;s:12:\"delete-96205\";i:95315;s:12:\"delete-96206\";i:95316;s:12:\"delete-96318\";i:95317;s:12:\"delete-96316\";i:95318;s:12:\"delete-96317\";i:95319;s:12:\"delete-96293\";i:95320;s:12:\"delete-96286\";i:95321;s:12:\"delete-96287\";i:95322;s:12:\"delete-96288\";i:95323;s:12:\"delete-96289\";i:95324;s:12:\"delete-96290\";i:95325;s:12:\"delete-96291\";i:95326;s:12:\"delete-96292\";i:95327;s:12:\"delete-96295\";i:95328;s:12:\"delete-96294\";i:95329;s:12:\"delete-96319\";i:95330;s:12:\"delete-96320\";i:95331;s:12:\"delete-96321\";i:95332;s:12:\"delete-95857\";i:95333;s:12:\"delete-96322\";i:95334;s:12:\"delete-95855\";i:95335;s:12:\"delete-96323\";i:95336;s:12:\"delete-95854\";i:95337;s:12:\"delete-96324\";i:95338;s:12:\"delete-95852\";i:95339;s:12:\"delete-96327\";i:95340;s:12:\"delete-96325\";i:95341;s:12:\"delete-96326\";i:95342;s:12:\"delete-96330\";i:95343;s:12:\"delete-96328\";i:95344;s:12:\"delete-96329\";i:95345;s:12:\"delete-96331\";i:95346;s:12:\"delete-96332\";i:95347;s:12:\"delete-96333\";i:95348;s:12:\"delete-96334\";i:95349;s:12:\"delete-95800\";i:95350;s:12:\"delete-96431\";i:95351;s:12:\"delete-96285\";i:95352;s:12:\"delete-96284\";i:95353;s:12:\"delete-96282\";i:95354;s:12:\"delete-96281\";i:95355;s:12:\"delete-96280\";i:95356;s:12:\"delete-96279\";i:95357;s:12:\"delete-96133\";i:95358;s:12:\"delete-96126\";i:95359;s:12:\"delete-96124\";i:95360;s:12:\"delete-96123\";i:95361;s:12:\"delete-96122\";i:95362;s:12:\"delete-96115\";i:95363;s:12:\"delete-96076\";i:95364;s:12:\"delete-96077\";i:95365;s:12:\"delete-96074\";i:95366;s:12:\"delete-96075\";i:95367;s:12:\"delete-96073\";i:95368;s:12:\"delete-96072\";i:95369;s:12:\"delete-96071\";i:95370;s:12:\"delete-96070\";i:95371;s:12:\"delete-96069\";i:95372;s:12:\"delete-96068\";i:95373;s:12:\"delete-96067\";i:95374;s:12:\"delete-96066\";i:95375;s:12:\"delete-96065\";i:95376;s:12:\"delete-96064\";i:95377;s:12:\"delete-96063\";i:95378;s:12:\"delete-96062\";i:95379;s:12:\"delete-96061\";i:95380;s:12:\"delete-96060\";i:95381;s:12:\"delete-96059\";i:95382;s:12:\"delete-96058\";i:95383;s:12:\"delete-96057\";i:95384;s:12:\"delete-96056\";i:95385;s:12:\"delete-96055\";i:95386;s:12:\"delete-96054\";i:95387;s:12:\"delete-96053\";i:95388;s:12:\"delete-96052\";i:95389;s:12:\"delete-96051\";i:95390;s:12:\"delete-96050\";i:95391;s:12:\"delete-96049\";i:95392;s:12:\"delete-96048\";i:95393;s:12:\"delete-96047\";i:95394;s:12:\"delete-96046\";i:95395;s:12:\"delete-96045\";i:95396;s:12:\"delete-96044\";i:95397;s:12:\"delete-96043\";i:95398;s:12:\"delete-96042\";i:95399;s:12:\"delete-96041\";i:95400;s:12:\"delete-96040\";i:95401;s:12:\"delete-96039\";i:95402;s:12:\"delete-96038\";i:95403;s:12:\"delete-96037\";i:95404;s:12:\"delete-96036\";i:95405;s:12:\"delete-96035\";i:95406;s:12:\"delete-96034\";i:95407;s:12:\"delete-96033\";i:95408;s:12:\"delete-96032\";i:95409;s:12:\"delete-96031\";i:95410;s:12:\"delete-96030\";i:95411;s:12:\"delete-96029\";i:95412;s:12:\"delete-96028\";i:95413;s:12:\"delete-96027\";i:95414;s:12:\"delete-96026\";i:95415;s:12:\"delete-96025\";i:95416;s:12:\"delete-96024\";i:95417;s:12:\"delete-96023\";i:95418;s:12:\"delete-96022\";i:95419;s:12:\"delete-96021\";i:95420;s:12:\"delete-96020\";i:95421;s:12:\"delete-96019\";i:95422;s:12:\"delete-96018\";i:95423;s:12:\"delete-96017\";i:95424;s:12:\"delete-96016\";i:95425;s:12:\"delete-96015\";i:95426;s:12:\"delete-96014\";i:95427;s:12:\"delete-96013\";i:95428;s:12:\"delete-96012\";i:95429;s:12:\"delete-96011\";i:95430;s:12:\"delete-96010\";i:95431;s:12:\"delete-96009\";i:95432;s:12:\"delete-96008\";i:95433;s:12:\"delete-96007\";i:95434;s:12:\"delete-96006\";i:95435;s:12:\"delete-96005\";i:95436;s:12:\"delete-96004\";i:95437;s:12:\"delete-96003\";i:95438;s:12:\"delete-96002\";i:95439;s:12:\"delete-96001\";i:95440;s:12:\"delete-95999\";i:95441;s:12:\"delete-96000\";i:95442;s:12:\"delete-95997\";i:95443;s:12:\"delete-95998\";i:95444;s:12:\"delete-95996\";i:95445;s:12:\"delete-95995\";i:95446;s:12:\"delete-95994\";i:95447;s:12:\"delete-95993\";i:95448;s:12:\"delete-95992\";i:95449;s:12:\"delete-95990\";i:95450;s:12:\"delete-95991\";i:95451;s:12:\"delete-95989\";i:95452;s:12:\"delete-95988\";i:95453;s:12:\"delete-95987\";i:95454;s:12:\"delete-95986\";i:95455;s:12:\"delete-95985\";i:95456;s:12:\"delete-95984\";i:95457;s:12:\"delete-95983\";i:95458;s:12:\"delete-95982\";i:95459;s:12:\"delete-95981\";i:95460;s:12:\"delete-95980\";i:95461;s:12:\"delete-95979\";i:95462;s:12:\"delete-95978\";i:95463;s:12:\"delete-95977\";i:95464;s:12:\"delete-95976\";i:95465;s:12:\"delete-95975\";i:95466;s:12:\"delete-95974\";i:95467;s:12:\"delete-95973\";i:95468;s:12:\"delete-95972\";i:95469;s:12:\"delete-95971\";i:95470;s:12:\"delete-95970\";i:95471;s:12:\"delete-95969\";i:95472;s:12:\"delete-95965\";i:95473;s:12:\"delete-95966\";i:95474;s:12:\"delete-95967\";i:95475;s:12:\"delete-95968\";i:95476;s:12:\"delete-95964\";i:95477;s:12:\"delete-95963\";i:95478;s:12:\"delete-95962\";i:95479;s:12:\"delete-95961\";i:95480;s:12:\"delete-95960\";i:95481;s:12:\"delete-95959\";i:95482;s:12:\"delete-95958\";i:95483;s:12:\"delete-95957\";i:95484;s:12:\"delete-95956\";i:95485;s:12:\"delete-95955\";i:95486;s:12:\"delete-95954\";i:95487;s:12:\"delete-95953\";i:95488;s:12:\"delete-95952\";i:95489;s:12:\"delete-95951\";i:95490;s:12:\"delete-95949\";i:95491;s:12:\"delete-95950\";i:95492;s:12:\"delete-95945\";i:95493;s:12:\"delete-95946\";i:95494;s:12:\"delete-95948\";i:95495;s:12:\"delete-95947\";i:95496;s:12:\"delete-95937\";i:95497;s:12:\"delete-95938\";i:95498;s:12:\"delete-95939\";i:95499;s:12:\"delete-95940\";i:95500;s:12:\"delete-95941\";i:95501;s:12:\"delete-95942\";i:95502;s:12:\"delete-95943\";i:95503;s:12:\"delete-95944\";i:95504;s:12:\"delete-95936\";i:95505;s:12:\"delete-95935\";i:95506;s:12:\"delete-95934\";i:95507;s:12:\"delete-95933\";i:95508;s:12:\"delete-95932\";i:95509;s:12:\"delete-95931\";i:95510;s:12:\"delete-95930\";i:95511;s:12:\"delete-95929\";i:95512;s:12:\"delete-95928\";i:95513;s:12:\"delete-95927\";i:95514;s:12:\"delete-95926\";i:95515;s:12:\"delete-95925\";i:95516;s:12:\"delete-95924\";i:95517;s:12:\"delete-95923\";i:95518;s:12:\"delete-95922\";i:95519;s:12:\"delete-95921\";i:95520;s:12:\"delete-95920\";i:95521;s:12:\"delete-95919\";i:95522;s:12:\"delete-95918\";i:95523;s:12:\"delete-95917\";i:95524;s:12:\"delete-95916\";i:95525;s:12:\"delete-95901\";i:95526;s:12:\"delete-95902\";i:95527;s:12:\"delete-95903\";i:95528;s:12:\"delete-95904\";i:95529;s:12:\"delete-95905\";i:95530;s:12:\"delete-95906\";i:95531;s:12:\"delete-95907\";i:95532;s:12:\"delete-95908\";i:95533;s:12:\"delete-95909\";i:95534;s:12:\"delete-95910\";i:95535;s:12:\"delete-95911\";i:95536;s:12:\"delete-95912\";i:95537;s:12:\"delete-95913\";i:95538;s:12:\"delete-95914\";i:95539;s:12:\"delete-95915\";i:95540;s:12:\"delete-95900\";i:95541;s:12:\"delete-95899\";i:95542;s:12:\"delete-95896\";i:95543;s:12:\"delete-95897\";i:95544;s:12:\"delete-95898\";i:95545;s:12:\"delete-95895\";i:95546;s:12:\"delete-95894\";i:95547;s:12:\"delete-95892\";i:95548;s:12:\"delete-95893\";i:95549;s:12:\"delete-95890\";i:95550;s:12:\"delete-95891\";i:95551;s:12:\"delete-95886\";i:95552;s:12:\"delete-95887\";i:95553;s:12:\"delete-95889\";i:95554;s:12:\"delete-95888\";i:95555;s:12:\"delete-95882\";i:95556;s:12:\"delete-95883\";i:95557;s:12:\"delete-95884\";i:95558;s:12:\"delete-95885\";i:95559;s:12:\"delete-95875\";i:95560;s:12:\"delete-95876\";i:95561;s:12:\"delete-95877\";i:95562;s:12:\"delete-95878\";i:95563;s:12:\"delete-95879\";i:95564;s:12:\"delete-95880\";i:95565;s:12:\"delete-95881\";i:95566;s:12:\"delete-95874\";i:95567;s:12:\"delete-95873\";i:95568;s:12:\"delete-95872\";i:95569;s:12:\"delete-95868\";i:95570;s:12:\"delete-95869\";i:95571;s:12:\"delete-95870\";i:95572;s:12:\"delete-95871\";i:95573;s:12:\"delete-95867\";i:95574;s:12:\"delete-95866\";i:95575;s:12:\"delete-95865\";i:95576;s:12:\"delete-95862\";i:95577;s:12:\"delete-95863\";i:95578;s:12:\"delete-95864\";i:95579;s:12:\"delete-95861\";i:95580;s:12:\"delete-95859\";i:95581;s:12:\"delete-95860\";i:95582;s:12:\"delete-95851\";i:95583;s:12:\"delete-95850\";i:95584;s:12:\"delete-95849\";i:95585;s:12:\"delete-95848\";i:95586;s:12:\"delete-95845\";i:95587;s:12:\"delete-95846\";i:95588;s:12:\"delete-95847\";i:95589;s:12:\"delete-95841\";i:95590;s:12:\"delete-95842\";i:95591;s:12:\"delete-95834\";i:95592;s:12:\"delete-95835\";i:95593;s:12:\"delete-95836\";i:95594;s:12:\"delete-95837\";i:95595;s:12:\"delete-95838\";i:95596;s:12:\"delete-95840\";i:95597;s:12:\"delete-95839\";i:95598;s:12:\"delete-95829\";i:95599;s:12:\"delete-95831\";i:95600;s:12:\"delete-95832\";i:95601;s:12:\"delete-95833\";i:95602;s:12:\"delete-95826\";i:95603;s:12:\"delete-95825\";i:95604;s:12:\"delete-95821\";i:95605;s:12:\"delete-95822\";i:95606;s:12:\"delete-95823\";i:95607;s:12:\"delete-95824\";i:95608;s:12:\"delete-95813\";i:95609;s:12:\"delete-95815\";i:95610;s:12:\"delete-95816\";i:95611;s:12:\"delete-95817\";i:95612;s:12:\"delete-95818\";i:95613;s:12:\"delete-95819\";i:95614;s:12:\"delete-95820\";i:95615;s:12:\"delete-95810\";i:95616;s:12:\"delete-95811\";i:95617;s:12:\"delete-95812\";i:95618;s:12:\"delete-95809\";i:95619;s:12:\"delete-95805\";i:95620;s:12:\"delete-95806\";i:95621;s:12:\"delete-95807\";i:95622;s:12:\"delete-95808\";i:95623;s:12:\"delete-95802\";i:95624;s:12:\"delete-95803\";i:95625;s:12:\"delete-95804\";i:95626;s:12:\"delete-96432\";i:95627;s:12:\"delete-95801\";i:95628;s:12:\"delete-96453\";i:95629;s:12:\"delete-96481\";i:95630;s:12:\"delete-96446\";i:95631;s:12:\"delete-96460\";i:95632;s:12:\"delete-96467\";i:95633;s:12:\"delete-96474\";i:95634;s:12:\"delete-96482\";i:95635;s:12:\"delete-96489\";i:95636;s:12:\"delete-96496\";i:95637;s:12:\"delete-96503\";i:95638;s:12:\"delete-96510\";i:95639;s:12:\"delete-96517\";i:95640;s:12:\"delete-96524\";i:95641;s:12:\"delete-96531\";i:95642;s:12:\"delete-96532\";i:95643;s:12:\"delete-96539\";i:95644;s:12:\"delete-96546\";i:95645;s:12:\"delete-96461\";i:95646;s:12:\"delete-96462\";i:95647;s:12:\"delete-96463\";i:95648;s:12:\"delete-96464\";i:95649;s:12:\"delete-96465\";i:95650;s:12:\"delete-96466\";i:95651;s:12:\"delete-96469\";i:95652;s:12:\"delete-96468\";i:95653;s:12:\"delete-96470\";i:95654;s:12:\"delete-96471\";i:95655;s:12:\"delete-96472\";i:95656;s:12:\"delete-96473\";i:95657;s:12:\"delete-96479\";i:95658;s:12:\"delete-96478\";i:95659;s:12:\"delete-96477\";i:95660;s:12:\"delete-96476\";i:95661;s:12:\"delete-96475\";i:95662;s:12:\"delete-96480\";i:95663;s:12:\"delete-96487\";i:95664;s:12:\"delete-96486\";i:95665;s:12:\"delete-96483\";i:95666;s:12:\"delete-96484\";i:95667;s:12:\"delete-96485\";i:95668;s:12:\"delete-96494\";i:95669;s:12:\"delete-96490\";i:95670;s:12:\"delete-96491\";i:95671;s:12:\"delete-96492\";i:95672;s:12:\"delete-96493\";i:95673;s:12:\"delete-96495\";i:95674;s:12:\"delete-96501\";i:95675;s:12:\"delete-96502\";i:95676;s:12:\"delete-96500\";i:95677;s:12:\"delete-96497\";i:95678;s:12:\"delete-96498\";i:95679;s:12:\"delete-96499\";i:95680;s:12:\"delete-96505\";i:95681;s:12:\"delete-96504\";i:95682;s:12:\"delete-96506\";i:95683;s:12:\"delete-96508\";i:95684;s:12:\"delete-96507\";i:95685;s:12:\"delete-96509\";i:95686;s:12:\"delete-96513\";i:95687;s:12:\"delete-96514\";i:95688;s:12:\"delete-96515\";i:95689;s:12:\"delete-96516\";i:95690;s:12:\"delete-96512\";i:95691;s:12:\"delete-96511\";i:95692;s:12:\"delete-96523\";i:95693;s:12:\"delete-96521\";i:95694;s:12:\"delete-96522\";i:95695;s:12:\"delete-96520\";i:95696;s:12:\"delete-96519\";i:95697;s:12:\"delete-96518\";i:95698;s:12:\"delete-96525\";i:95699;s:12:\"delete-96526\";i:95700;s:12:\"delete-96527\";i:95701;s:12:\"delete-96528\";i:95702;s:12:\"delete-96529\";i:95703;s:12:\"delete-96530\";i:95704;s:12:\"delete-96538\";i:95705;s:12:\"delete-96537\";i:95706;s:12:\"delete-96536\";i:95707;s:12:\"delete-96534\";i:95708;s:12:\"delete-96535\";i:95709;s:12:\"delete-96533\";i:95710;s:12:\"delete-96542\";i:95711;s:12:\"delete-96543\";i:95712;s:12:\"delete-96544\";i:95713;s:12:\"delete-96545\";i:95714;s:12:\"delete-96540\";i:95715;s:12:\"delete-96541\";i:95716;s:12:\"delete-96552\";i:95717;s:12:\"delete-96547\";i:95718;s:12:\"delete-96548\";i:95719;s:12:\"delete-96549\";i:95720;s:12:\"delete-96550\";i:95721;s:12:\"delete-96551\";i:95722;s:12:\"delete-96553\";i:95723;s:12:\"delete-96556\";i:95724;s:12:\"delete-96557\";i:95725;s:12:\"delete-96564\";i:95726;s:12:\"delete-96563\";i:95727;s:12:\"delete-96164\";i:95728;s:12:\"delete-96562\";i:95729;s:12:\"delete-96561\";i:95730;s:12:\"delete-96440\";i:95731;s:12:\"delete-96441\";i:95732;s:12:\"delete-96436\";i:95733;s:12:\"delete-96439\";i:95734;s:12:\"delete-96438\";i:95735;s:12:\"delete-96435\";i:95736;s:12:\"delete-96560\";i:95737;s:12:\"delete-96559\";i:95738;s:12:\"delete-96445\";i:95739;s:12:\"delete-96444\";i:95740;s:12:\"delete-96443\";i:95741;s:12:\"delete-96442\";i:95742;s:12:\"delete-96434\";i:95743;s:12:\"delete-96433\";i:95744;s:12:\"delete-96558\";i:95745;s:12:\"delete-96202\";i:95746;s:12:\"delete-96554\";i:95747;s:12:\"delete-96555\";i:95748;s:12:\"delete-96168\";i:95749;s:12:\"delete-96163\";i:95750;s:12:\"delete-96449\";i:95751;s:12:\"delete-96459\";i:95752;s:12:\"delete-96458\";i:95753;s:12:\"delete-96457\";i:95754;s:12:\"delete-96456\";i:95755;s:12:\"delete-96455\";i:95756;s:12:\"delete-96454\";i:95757;s:12:\"delete-96447\";i:95758;s:12:\"delete-96488\";i:95759;s:12:\"delete-96451\";i:95760;s:12:\"delete-96450\";i:95761;s:12:\"delete-96448\";i:95762;s:12:\"delete-96452\";i:95763;s:12:\"delete-96430\";i:95764;s:12:\"delete-96429\";i:95765;s:12:\"delete-96423\";i:95766;s:12:\"delete-96424\";i:95767;s:12:\"delete-96425\";i:95768;s:12:\"delete-96426\";i:95769;s:12:\"delete-96427\";i:95770;s:12:\"delete-96428\";i:95771;s:12:\"delete-96437\";i:95772;s:12:\"delete-96094\";i:95773;s:12:\"delete-96112\";i:95774;s:12:\"delete-96091\";i:95775;s:12:\"delete-96107\";i:95776;s:12:\"delete-96108\";i:95777;s:12:\"delete-96109\";i:95778;s:12:\"delete-96090\";i:95779;s:12:\"delete-96095\";i:95780;s:12:\"delete-96093\";i:95781;s:12:\"delete-96096\";i:95782;s:12:\"delete-96131\";i:95783;s:12:\"delete-96132\";i:95784;s:12:\"delete-96120\";i:95785;s:12:\"delete-96121\";i:95786;s:12:\"delete-96116\";i:95787;s:12:\"delete-96117\";i:95788;s:12:\"delete-96118\";i:95789;s:12:\"delete-96119\";i:95790;s:12:\"delete-96113\";i:95791;s:12:\"delete-96114\";i:95792;s:12:\"delete-96092\";i:95793;s:12:\"delete-96087\";i:95794;s:12:\"delete-95798\";i:95795;s:12:\"delete-95799\";i:95796;s:12:\"delete-95793\";i:95797;s:12:\"delete-95796\";i:95798;s:12:\"delete-95792\";i:95799;s:12:\"delete-95795\";i:95800;s:12:\"delete-95791\";i:95801;s:12:\"delete-96198\";i:95802;s:12:\"delete-96079\";i:95803;s:12:\"delete-96080\";i:95804;s:12:\"delete-95794\";i:95805;s:12:\"delete-96088\";i:95806;s:12:\"delete-96089\";i:95807;s:12:\"delete-96084\";i:95808;s:12:\"delete-96086\";i:95809;s:12:\"delete-96081\";i:95810;s:12:\"delete-96082\";i:95811;s:12:\"delete-96083\";i:95812;s:12:\"delete-96078\";i:95813;s:12:\"delete-95797\";i:95814;s:12:\"delete-96283\";i:95815;s:12:\"delete-96183\";i:95816;s:12:\"delete-96182\";i:95817;s:12:\"delete-96181\";i:95818;s:12:\"delete-96180\";i:95819;s:12:\"delete-96179\";i:95820;s:12:\"delete-96177\";i:95821;s:12:\"delete-96178\";i:95822;s:12:\"delete-96175\";i:95823;s:12:\"delete-96176\";i:95824;s:12:\"delete-96174\";i:95825;s:12:\"delete-96173\";i:95826;s:12:\"delete-96172\";i:95827;s:12:\"delete-96171\";i:95828;s:12:\"delete-96170\";i:95829;s:12:\"delete-96169\";i:95830;s:12:\"delete-96184\";i:95831;s:12:\"delete-96188\";i:95832;s:12:\"delete-96189\";i:95833;s:12:\"delete-96203\";i:95834;s:12:\"delete-96200\";i:95835;s:12:\"delete-96201\";i:95836;s:12:\"delete-96197\";i:95837;s:12:\"delete-96199\";i:95838;s:12:\"delete-96194\";i:95839;s:12:\"delete-96195\";i:95840;s:12:\"delete-96196\";i:95841;s:12:\"delete-96185\";i:95842;s:12:\"delete-96186\";i:95843;s:12:\"delete-96187\";i:95844;s:12:\"delete-96193\";i:95845;s:12:\"delete-96192\";i:95846;s:12:\"delete-96191\";i:95847;s:12:\"delete-96190\";i:95848;s:12:\"delete-96167\";i:95849;s:12:\"delete-96166\";i:95850;s:12:\"delete-96165\";i:95851;s:12:\"delete-96144\";i:95852;s:12:\"delete-96143\";i:95853;s:12:\"delete-96142\";i:95854;s:12:\"delete-96141\";i:95855;s:12:\"delete-96140\";i:95856;s:12:\"delete-96139\";i:95857;s:12:\"delete-96138\";i:95858;s:12:\"delete-96135\";i:95859;s:12:\"delete-96137\";i:95860;s:12:\"delete-96136\";i:95861;s:12:\"delete-96134\";i:95862;s:12:\"delete-96125\";i:95863;s:12:\"delete-96127\";i:95864;s:12:\"delete-96128\";i:95865;s:12:\"delete-96129\";i:95866;s:12:\"delete-96145\";i:95867;s:12:\"delete-96146\";i:95868;s:12:\"delete-96147\";i:95869;s:12:\"delete-96162\";i:95870;s:12:\"delete-96161\";i:95871;s:12:\"delete-96160\";i:95872;s:12:\"delete-96159\";i:95873;s:12:\"delete-96158\";i:95874;s:12:\"delete-96157\";i:95875;s:12:\"delete-96156\";i:95876;s:12:\"delete-96155\";i:95877;s:12:\"delete-96154\";i:95878;s:12:\"delete-96153\";i:95879;s:12:\"delete-96152\";i:95880;s:12:\"delete-96151\";i:95881;s:12:\"delete-96150\";i:95882;s:12:\"delete-96149\";i:95883;s:12:\"delete-96148\";i:95884;s:12:\"delete-96130\";}}}');
INSERT INTO `variable` VALUES ('search_cron_limit','s:3:\"100\";'),('search_default_module','s:4:\"node\";'),('site_403','s:10:\"r4032login\";'),('site_404','s:0:\"\";'),('site_default_country','s:2:\"US\";'),('site_frontpage','s:4:\"home\";'),('site_mail','s:18:\"support@netapp.com\";'),('site_name','s:30:\"Flash Accel Management Console\";'),('site_slogan','s:0:\"\";'),('syslog_facility','s:3:\"128\";'),('syslog_format','s:72:\"!base_url|!timestamp|!type|!ip|!request_uri|!referer|!uid|!link|!message\";'),('syslog_identity','s:6:\"drupal\";'),('theme_default','s:7:\"mercury\";'),('theme_mercury_settings','a:23:{s:11:\"toggle_logo\";i:1;s:11:\"toggle_name\";i:0;s:13:\"toggle_slogan\";i:0;s:24:\"toggle_node_user_picture\";i:1;s:27:\"toggle_comment_user_picture\";i:1;s:14:\"toggle_favicon\";i:1;s:16:\"toggle_main_menu\";i:0;s:21:\"toggle_secondary_menu\";i:0;s:12:\"default_logo\";i:0;s:9:\"logo_path\";s:24:\"public://header_logo.png\";s:11:\"logo_upload\";s:0:\"\";s:15:\"default_favicon\";i:0;s:12:\"favicon_path\";s:50:\"sites/all/themes/mercury/images/netapp_favicon.png\";s:14:\"favicon_upload\";s:0:\"\";s:12:\"mercury_tabs\";i:1;s:18:\"mercury_breadcrumb\";s:3:\"yes\";s:28:\"mercury_breadcrumb_separator\";s:2:\"»\";s:23:\"mercury_breadcrumb_home\";i:1;s:27:\"mercury_breadcrumb_trailing\";i:1;s:24:\"mercury_breadcrumb_title\";i:1;s:14:\"wireframe_mode\";i:0;s:14:\"clear_registry\";i:0;s:16:\"favicon_mimetype\";s:9:\"image/png\";}'),('theme_settings','a:16:{s:11:\"toggle_logo\";i:1;s:11:\"toggle_name\";i:1;s:13:\"toggle_slogan\";i:1;s:24:\"toggle_node_user_picture\";i:1;s:27:\"toggle_comment_user_picture\";i:1;s:32:\"toggle_comment_user_verification\";i:1;s:14:\"toggle_favicon\";i:1;s:16:\"toggle_main_menu\";i:1;s:21:\"toggle_secondary_menu\";i:1;s:12:\"default_logo\";i:1;s:9:\"logo_path\";s:0:\"\";s:11:\"logo_upload\";s:0:\"\";s:15:\"default_favicon\";i:0;s:12:\"favicon_path\";s:50:\"sites/all/themes/mercury/images/netapp_favicon.png\";s:14:\"favicon_upload\";s:0:\"\";s:16:\"favicon_mimetype\";s:9:\"image/png\";}'),('time_cron_call_redesc','i:1357642188;'),('unique_field_comp_device','s:4:\"each\";'),('unique_field_comp_host','s:4:\"each\";'),('unique_field_comp_vdisk','s:4:\"each\";'),('unique_field_comp_vdisk_metrics','s:4:\"each\";'),('unique_field_comp_virtual_machine','s:4:\"each\";'),('unique_field_comp_vm_cache_space','s:4:\"each\";'),('unique_field_comp_vm_metrics','s:3:\"all\";'),('unique_field_fields_device','a:0:{}'),('unique_field_fields_host','a:0:{}'),('unique_field_fields_vdisk','a:0:{}'),('unique_field_fields_vdisk_metrics','a:2:{i:0;s:11:\"field_vdisk\";i:1;s:15:\"field_timestamp\";}'),('unique_field_fields_virtual_machine','a:0:{}'),('unique_field_fields_vm_cache_space','a:0:{}'),('unique_field_fields_vm_metrics','a:2:{i:0;s:8:\"field_vm\";i:1;s:15:\"field_timestamp\";}'),('unique_field_scope_device','s:4:\"type\";'),('unique_field_scope_host','s:4:\"type\";'),('unique_field_scope_vdisk','s:4:\"type\";'),('unique_field_scope_vdisk_metrics','s:4:\"type\";'),('unique_field_scope_virtual_machine','s:4:\"type\";'),('unique_field_scope_vm_cache_space','s:4:\"type\";'),('unique_field_scope_vm_metrics','s:4:\"type\";'),('unique_field_show_matches_device','a:0:{}'),('unique_field_show_matches_host','a:0:{}'),('unique_field_show_matches_vdisk','a:0:{}'),('unique_field_show_matches_vdisk_metrics','a:0:{}'),('unique_field_show_matches_virtual_machine','a:0:{}'),('unique_field_show_matches_vm_cache_space','a:0:{}'),('unique_field_show_matches_vm_metrics','a:0:{}'),('update_last_check','i:1355685378;'),('update_last_email_notification','i:1354874341;'),('update_notify_emails','a:1:{i:0;s:18:\"support@zaloni.com\";}'),('username','s:13:\"administrator\";'),('user_admin_role','s:1:\"3\";'),('user_cancel_method','s:17:\"user_cancel_block\";'),('user_default_timezone','s:1:\"0\";'),('user_email_verification','b:1;'),('user_mail_cancel_confirm_body','s:381:\"[user:name],\r\n\r\nA request to cancel your account has been made at [site:name].\r\n\r\nYou may now cancel your account on [site:url-brief] by clicking this link or copying and pasting it into your browser:\r\n\r\n[user:cancel-url]\r\n\r\nNOTE: The cancellation of your account is not reversible.\r\n\r\nThis link expires in one day and nothing will happen if it is not used.\r\n\r\n--  [site:name] team\";'),('user_mail_cancel_confirm_subject','s:59:\"Account cancellation request for [user:name] at [site:name]\";'),('user_mail_password_reset_body','s:407:\"[user:name],\r\n\r\nA request to reset the password for your account has been made at [site:name].\r\n\r\nYou may now log in by clicking this link or copying and pasting it to your browser:\r\n\r\n[user:one-time-login-url]\r\n\r\nThis link can only be used once to log in and will lead you to a page where you can set your password. It expires after one day and nothing will happen if it\'s not used.\r\n\r\n--  [site:name] team\";'),('user_mail_password_reset_subject','s:60:\"Replacement login information for [user:name] at [site:name]\";'),('user_mail_register_admin_created_body','s:476:\"[user:name],\r\n\r\nA site administrator at [site:name] has created an account for you. You may now log in by clicking this link or copying and pasting it to your browser:\r\n\r\n[user:one-time-login-url]\r\n\r\nThis link can only be used once to log in and will lead you to a page where you can set your password.\r\n\r\nAfter setting your password, you will be able to log in at [site:login-url] in the future using:\r\n\r\nusername: [user:name]\r\npassword: Your password\r\n\r\n--  [site:name] team\";'),('user_mail_register_admin_created_subject','s:58:\"An administrator created an account for you at [site:name]\";'),('user_mail_register_no_approval_required_body','s:450:\"[user:name],\r\n\r\nThank you for registering at [site:name]. You may now log in by clicking this link or copying and pasting it to your browser:\r\n\r\n[user:one-time-login-url]\r\n\r\nThis link can only be used once to log in and will lead you to a page where you can set your password.\r\n\r\nAfter setting your password, you will be able to log in at [site:login-url] in the future using:\r\n\r\nusername: [user:name]\r\npassword: Your password\r\n\r\n--  [site:name] team\";'),('user_mail_register_no_approval_required_subject','s:46:\"Account details for [user:name] at [site:name]\";'),('user_mail_register_pending_approval_body','s:287:\"[user:name],\r\n\r\nThank you for registering at [site:name]. Your application for an account is currently pending approval. Once it has been approved, you will receive another e-mail containing information about how to log in, set your password, and other details.\r\n\r\n\r\n--  [site:name] team\";'),('user_mail_register_pending_approval_subject','s:71:\"Account details for [user:name] at [site:name] (pending admin approval)\";'),('user_mail_status_activated_body','s:461:\"[user:name],\r\n\r\nYour account at [site:name] has been activated.\r\n\r\nYou may now log in by clicking this link or copying and pasting it into your browser:\r\n\r\n[user:one-time-login-url]\r\n\r\nThis link can only be used once to log in and will lead you to a page where you can set your password.\r\n\r\nAfter setting your password, you will be able to log in at [site:login-url] in the future using:\r\n\r\nusername: [user:name]\r\npassword: Your password\r\n\r\n--  [site:name] team\";'),('user_mail_status_activated_notify','i:1;'),('user_mail_status_activated_subject','s:57:\"Account details for [user:name] at [site:name] (approved)\";'),('user_mail_status_blocked_body','s:85:\"[user:name],\r\n\r\nYour account on [site:name] has been blocked.\r\n\r\n--  [site:name] team\";'),('user_mail_status_blocked_notify','i:0;'),('user_mail_status_blocked_subject','s:56:\"Account details for [user:name] at [site:name] (blocked)\";'),('user_mail_status_canceled_body','s:86:\"[user:name],\r\n\r\nYour account on [site:name] has been canceled.\r\n\r\n--  [site:name] team\";'),('user_mail_status_canceled_notify','i:0;'),('user_mail_status_canceled_subject','s:57:\"Account details for [user:name] at [site:name] (canceled)\";'),('user_pictures','i:1;'),('user_picture_default','s:0:\"\";'),('user_picture_dimensions','s:9:\"1024x1024\";'),('user_picture_file_size','s:3:\"800\";'),('user_picture_guidelines','s:0:\"\";'),('user_picture_path','s:8:\"pictures\";'),('user_picture_style','s:9:\"thumbnail\";'),('user_register','s:1:\"0\";'),('user_signatures','i:0;'),('vib_package','s:26:\"/opt/flashaccel/agent/esx/\";'),('views_exposed_filter_any_label','s:7:\"new_any\";'),('views_show_additional_queries','i:0;'),('views_ui_always_live_preview','i:1;'),('views_ui_custom_theme','s:8:\"_default\";'),('views_ui_display_embed','i:0;'),('views_ui_show_advanced_column','i:0;'),('views_ui_show_advanced_help_warning','i:1;'),('views_ui_show_listing_filters','i:0;'),('views_ui_show_master_display','i:1;'),('views_ui_show_performance_statistics','i:0;'),('views_ui_show_preview_information','i:1;'),('views_ui_show_sql_query','i:1;'),('views_ui_show_sql_query_where','s:5:\"above\";'),('vm_0','i:0;'),('vm_1','i:0;'),('vm_10','i:0;'),('vm_100','i:0;'),('vm_101','i:0;'),('vm_102','i:0;'),('vm_103','i:0;'),('vm_104','i:0;'),('vm_105','i:0;'),('vm_106','i:0;'),('vm_107','i:0;'),('vm_108','i:0;'),('vm_109','i:0;'),('vm_11','i:0;'),('vm_110','i:0;'),('vm_111','i:0;'),('vm_112','i:0;'),('vm_113','i:0;'),('vm_114','i:0;'),('vm_115','i:0;'),('vm_116','i:0;'),('vm_117','i:0;'),('vm_118','i:0;'),('vm_119','i:0;'),('vm_12','i:0;'),('vm_120','i:0;'),('vm_121','i:0;'),('vm_122','i:0;'),('vm_123','i:0;'),('vm_124','i:0;'),('vm_125','i:0;'),('vm_126','i:0;'),('vm_127','i:0;'),('vm_128','i:0;'),('vm_129','i:0;'),('vm_13','i:0;'),('vm_130','i:0;'),('vm_131','i:0;'),('vm_132','i:0;'),('vm_133','i:0;'),('vm_134','i:0;'),('vm_135','i:0;'),('vm_14','i:0;'),('vm_15','s:15:\"hg-w2k8r2-e2e-1\";'),('vm_16','s:15:\"hg-w2k8r2-e2e-2\";'),('vm_17','s:15:\"hg-w2k8r2-e2e-4\";'),('vm_18','s:15:\"hg-w2k8r2-e2e-6\";'),('vm_19','s:15:\"hg-w2k8r2-e2e-7\";'),('vm_2','i:0;'),('vm_20','s:15:\"hg-w2k8r2-e2e-8\";'),('vm_21','i:0;'),('vm_22','i:0;'),('vm_23','i:0;'),('vm_24','i:0;'),('vm_25','i:0;'),('vm_26','i:0;'),('vm_27','s:13:\"hg-w2k8r2-nr2\";'),('vm_28','s:13:\"hg-w2k8r2-nr3\";'),('vm_29','s:13:\"hg-w2k8r2-nr4\";'),('vm_3','i:0;'),('vm_30','s:13:\"hg-w2k8r2-nr5\";'),('vm_31','i:0;'),('vm_32','i:0;'),('vm_33','i:0;'),('vm_34','i:0;'),('vm_35','i:0;'),('vm_36','i:0;'),('vm_37','i:0;'),('vm_38','i:0;'),('vm_39','i:0;'),('vm_4','i:0;'),('vm_40','i:0;'),('vm_41','i:0;'),('vm_42','i:0;'),('vm_43','i:0;'),('vm_44','i:0;'),('vm_45','i:0;'),('vm_46','i:0;'),('vm_47','i:0;'),('vm_48','i:0;'),('vm_49','i:0;'),('vm_5','i:0;'),('vm_50','i:0;'),('vm_51','i:0;'),('vm_52','i:0;'),('vm_53','i:0;'),('vm_54','i:0;'),('vm_55','i:0;'),('vm_56','i:0;'),('vm_57','i:0;'),('vm_58','i:0;'),('vm_59','i:0;'),('vm_6','i:0;'),('vm_60','i:0;'),('vm_61','i:0;'),('vm_62','i:0;'),('vm_63','i:0;'),('vm_64','i:0;'),('vm_65','i:0;'),('vm_66','i:0;'),('vm_67','i:0;'),('vm_68','i:0;'),('vm_69','i:0;'),('vm_7','i:0;'),('vm_70','i:0;'),('vm_71','i:0;'),('vm_72','i:0;'),('vm_73','i:0;'),('vm_74','i:0;'),('vm_75','i:0;'),('vm_76','i:0;'),('vm_77','i:0;'),('vm_78','i:0;'),('vm_79','i:0;'),('vm_8','i:0;'),('vm_80','i:0;'),('vm_81','i:0;'),('vm_82','i:0;'),('vm_83','i:0;'),('vm_84','i:0;'),('vm_85','i:0;'),('vm_86','i:0;'),('vm_87','i:0;'),('vm_88','i:0;'),('vm_89','i:0;'),('vm_9','i:0;'),('vm_90','i:0;'),('vm_91','i:0;'),('vm_92','i:0;'),('vm_93','i:0;'),('vm_94','i:0;'),('vm_95','i:0;'),('vm_96','i:0;'),('vm_97','i:0;'),('vm_98','i:0;'),('vm_99','i:0;'),('windows_package','s:30:\"/opt/flashaccel/agent/windows/\";'),('discovery_count','s:3:\"100\";'),('discovered_last','i:1367619080;'),('drupal_css_cache_files','a:8:{s:64:\"823ba1006db72809515d2221cd02ec1075d7b49b0c07f49307b3a7930bfdd9e4\";s:64:\"public://css/css__9zsakYbWSOTLroLLtWO9P7zLJXhXtSJo2OgXN4wIrU.css\";s:64:\"592db66916e1dd3416cbe95bcb34a5a68775eb0b7cf95e4c858671de35290cc9\";s:64:\"public://css/css_LS9OUalDR9-d_lCAvF3yUWjNU6yF8ZBm84jEPRvoyuQ.css\";s:64:\"e01eebab9cebdfb3c2270113a9b294595dc9b0149ff254ae1b2ef440e94f916d\";s:64:\"public://css/css_wFDEsLP1tYnp84utO-3zQt1sbY70oCObwxAFr23k-Nw.css\";s:64:\"c95465203964105b86416118302f0057c1940db42594c9b3f1c9de33459f6081\";s:64:\"public://css/css_j2uK9Vg2gaWbWbODvh7kKyXFflDXBnE9IAPVPeIO4YE.css\";s:64:\"ebb3f433ad4107b1ac31e9d7de0f9a5d399040e9f82b6364211dcfaadea158c0\";s:64:\"public://css/css_ABmXGW3jlpNaBRmWVTJUFNYGbVFnilqYg_EngwXFiNc.css\";s:64:\"8be2bf3e4dd62ae9a7889a0a2c8a7c2c95da646c4025e33888d70da5dddbae95\";s:64:\"public://css/css_dUrOm3VhlPtcPlqM19Mjk6qG0D3MUAFFkB8BchCGQK4.css\";s:64:\"2f52c165b6428c953e2b0e3a204153d26629d3fa0e7e1809a27424a0792d2cfd\";s:64:\"public://css/css_GG-BWRS7nVU_oNtgW1Q51Da-bdLktnFs0lgMuPin6w0.css\";s:64:\"28ef431512bbe3374ad312f5044607796b743a49a3f326d5f8fb0bcda102ad3d\";s:64:\"public://css/css_mDxCF8ImVBb6oiL7Rq6KarwvxmvDV5PjnhYNE29pt_0.css\";}'),('cachespaces','a:0:{}'),('fmc_host_vm_agents','O:8:\"stdClass\":10:{s:3:\"uid\";s:1:\"1\";s:6:\"status\";i:1;s:8:\"filename\";s:52:\"NetApp_FlashAccel-Base-MC_1.2.0.20755599_all.deb_.gz\";s:3:\"uri\";s:73:\"public://fmc_agents//NetApp_FlashAccel-Base-MC_1.2.0.20755599_all.deb_.gz\";s:8:\"filemime\";s:24:\"application/octet-stream\";s:8:\"filesize\";i:2901288;s:6:\"source\";s:14:\"host_vm_agents\";s:11:\"destination\";s:64:\"temporary://NetApp_FlashAccel-Base-MC_1.2.0.20755599_all.deb_.gz\";s:9:\"timestamp\";i:1371233948;s:3:\"fid\";s:3:\"243\";}');
/*!40000 ALTER TABLE `variable` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `views_data_export`
--

DROP TABLE IF EXISTS `views_data_export`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `views_data_export` (
  `eid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Unique id for each on-going export.',
  `view_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The unique name of the view. This is the primary field views are loaded from, and is used so that views may be internal and not necessarily in the database. May only be alphanumeric characters plus underscores.',
  `view_display_id` varchar(32) NOT NULL DEFAULT '' COMMENT 'The unique name of the view. This is the primary field views are loaded from, and is used so that views may be internal and not necessarily in the database. May only be alphanumeric characters plus underscores.',
  `time_stamp` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The time this export started',
  `fid` int(10) unsigned NOT NULL COMMENT 'Files ID.',
  `batch_state` varchar(32) NOT NULL DEFAULT 'init' COMMENT 'The current state of the batch.',
  `sandbox` longblob,
  PRIMARY KEY (`eid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Keep track of currently executing exports.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `views_data_export`
--

LOCK TABLES `views_data_export` WRITE;
/*!40000 ALTER TABLE `views_data_export` DISABLE KEYS */;
/*!40000 ALTER TABLE `views_data_export` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `views_data_export_object_cache`
--

DROP TABLE IF EXISTS `views_data_export_object_cache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `views_data_export_object_cache` (
  `eid` varchar(64) DEFAULT NULL COMMENT 'The export ID this view equates too.',
  `updated` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The time this cache was created or updated.',
  `data` longtext COMMENT 'Serialized data being stored.',
  KEY `eid` (`eid`),
  KEY `updated` (`updated`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='A modified version of the views_object_cache that ignores...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `views_data_export_object_cache`
--

LOCK TABLES `views_data_export_object_cache` WRITE;
/*!40000 ALTER TABLE `views_data_export_object_cache` DISABLE KEYS */;
/*!40000 ALTER TABLE `views_data_export_object_cache` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `views_display`
--

DROP TABLE IF EXISTS `views_display`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `views_display` (
  `vid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The view this display is attached to.',
  `id` varchar(64) NOT NULL DEFAULT '' COMMENT 'An identifier for this display; usually generated from the display_plugin, so should be something like page or page_1 or block_2, etc.',
  `display_title` varchar(64) NOT NULL DEFAULT '' COMMENT 'The title of the display, viewable by the administrator.',
  `display_plugin` varchar(64) NOT NULL DEFAULT '' COMMENT 'The type of the display. Usually page, block or embed, but is pluggable so may be other things.',
  `position` int(11) DEFAULT '0' COMMENT 'The order in which this display is loaded.',
  `display_options` longtext COMMENT 'A serialized array of options for this display; it contains options that are generally only pertinent to that display plugin type.',
  PRIMARY KEY (`vid`,`id`),
  KEY `vid` (`vid`,`position`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stores information about each display attached to a view.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `views_display`
--

LOCK TABLES `views_display` WRITE;
/*!40000 ALTER TABLE `views_display` DISABLE KEYS */;
INSERT INTO `views_display` VALUES (1,'block','Block','block',2,'a:2:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"field\";a:1:{s:5:\"title\";a:1:{s:12:\"link_to_node\";i:1;}}}'),(1,'default','Master','default',1,'a:12:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:1:{s:14:\"items_per_page\";s:0:\"\";}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:3:{s:5:\"title\";a:8:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:4:\"trim\";i:0;s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:0;s:10:\"strip_tags\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:1;}s:17:\"field_device_type\";a:34:{s:2:\"id\";s:17:\"field_device_type\";s:5:\"table\";s:28:\"field_data_field_device_type\";s:5:\"field\";s:17:\"field_device_type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:11:\"Device Type\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:18:\"field_display_name\";a:34:{s:2:\"id\";s:18:\"field_display_name\";s:5:\"table\";s:29:\"field_data_field_display_name\";s:5:\"field\";s:18:\"field_display_name\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:12:\"Display Name\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}}s:7:\"filters\";a:4:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:6:\"device\";s:6:\"device\";}}s:18:\"field_status_value\";a:14:{s:2:\"id\";s:18:\"field_status_value\";s:5:\"table\";s:23:\"field_data_field_status\";s:5:\"field\";s:18:\"field_status_value\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:2:\"or\";s:5:\"value\";a:1:{s:2:\"on\";s:2:\"on\";}s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:17:\"reduce_duplicates\";i:0;}s:18:\"field_is_ssd_value\";a:14:{s:2:\"id\";s:18:\"field_is_ssd_value\";s:5:\"table\";s:23:\"field_data_field_is_ssd\";s:5:\"field\";s:18:\"field_is_ssd_value\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:2:\"or\";s:5:\"value\";a:1:{s:4:\"true\";s:4:\"true\";}s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:17:\"reduce_duplicates\";i:0;}}s:5:\"sorts\";a:1:{s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:5:\"title\";s:7:\"Devices\";s:9:\"arguments\";a:1:{s:28:\"field_related_host_target_id\";a:22:{s:2:\"id\";s:28:\"field_related_host_target_id\";s:5:\"table\";s:29:\"field_data_field_related_host\";s:5:\"field\";s:28:\"field_related_host_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";i:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";i:0;s:5:\"title\";s:0:\"\";s:17:\"breadcrumb_enable\";i:0;s:10:\"breadcrumb\";s:0:\"\";s:21:\"default_argument_type\";s:4:\"node\";s:24:\"default_argument_options\";s:0:\"\";s:25:\"default_argument_skip_url\";i:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";s:1:\"1\";s:14:\"items_per_page\";s:2:\"25\";s:8:\"override\";i:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";s:1:\"0\";s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";i:0;s:3:\"not\";i:0;}}}'),(4,'default','Master','default',1,'a:13:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"1\";s:6:\"offset\";s:1:\"0\";}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:8:{s:21:\"field_vm_read_latency\";a:34:{s:2:\"id\";s:21:\"field_vm_read_latency\";s:5:\"table\";s:32:\"field_data_field_vm_read_latency\";s:5:\"field\";s:21:\"field_vm_read_latency\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:12:\"Read latency\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";s:1:\"2\";s:13:\"prefix_suffix\";i:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:17:\"field_vm_read_ops\";a:34:{s:2:\"id\";s:17:\"field_vm_read_ops\";s:5:\"table\";s:28:\"field_data_field_vm_read_ops\";s:5:\"field\";s:17:\"field_vm_read_ops\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:8:\"Read ops\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";s:1:\"0\";s:13:\"prefix_suffix\";i:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:22:\"field_vm_write_latency\";a:34:{s:2:\"id\";s:22:\"field_vm_write_latency\";s:5:\"table\";s:33:\"field_data_field_vm_write_latency\";s:5:\"field\";s:22:\"field_vm_write_latency\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:13:\"Write latency\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";s:1:\"2\";s:13:\"prefix_suffix\";i:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:18:\"field_vm_write_ops\";a:34:{s:2:\"id\";s:18:\"field_vm_write_ops\";s:5:\"table\";s:29:\"field_data_field_vm_write_ops\";s:5:\"field\";s:18:\"field_vm_write_ops\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:9:\"Write ops\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";s:1:\"0\";s:13:\"prefix_suffix\";i:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:20:\"field_vm_hit_rate_pc\";a:34:{s:2:\"id\";s:20:\"field_vm_hit_rate_pc\";s:5:\"table\";s:31:\"field_data_field_vm_hit_rate_pc\";s:5:\"field\";s:20:\"field_vm_hit_rate_pc\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:10:\"Hit rate %\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:20:\"computed_field_plain\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:22:\"field_vm_cache_latency\";a:34:{s:2:\"id\";s:22:\"field_vm_cache_latency\";s:5:\"table\";s:33:\"field_data_field_vm_cache_latency\";s:5:\"field\";s:22:\"field_vm_cache_latency\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:13:\"Cache latency\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_decimal\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";s:1:\"2\";s:13:\"prefix_suffix\";i:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:22:\"field_vm_population_pc\";a:34:{s:2:\"id\";s:22:\"field_vm_population_pc\";s:5:\"table\";s:33:\"field_data_field_vm_population_pc\";s:5:\"field\";s:22:\"field_vm_population_pc\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:12:\"Population %\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:20:\"computed_field_plain\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:26:\"field_vm_insertion_rate_pc\";a:34:{s:2:\"id\";s:26:\"field_vm_insertion_rate_pc\";s:5:\"table\";s:37:\"field_data_field_vm_insertion_rate_pc\";s:5:\"field\";s:26:\"field_vm_insertion_rate_pc\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:16:\"Insertion rate %\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:20:\"computed_field_plain\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}}s:7:\"filters\";a:2:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:10:\"vm_metrics\";s:10:\"vm_metrics\";}}}s:5:\"sorts\";a:1:{s:21:\"field_timestamp_value\";a:9:{s:2:\"id\";s:21:\"field_timestamp_value\";s:5:\"table\";s:26:\"field_data_field_timestamp\";s:5:\"field\";s:21:\"field_timestamp_value\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}}}s:13:\"style_options\";a:4:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";i:1;s:17:\"row_class_special\";i:1;}s:9:\"arguments\";a:1:{s:18:\"field_vm_target_id\";a:22:{s:2:\"id\";s:18:\"field_vm_target_id\";s:5:\"table\";s:19:\"field_data_field_vm\";s:5:\"field\";s:18:\"field_vm_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:14:\"default_action\";s:5:\"empty\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";i:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";i:0;s:5:\"title\";s:0:\"\";s:17:\"breadcrumb_enable\";i:0;s:10:\"breadcrumb\";s:0:\"\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";i:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";s:1:\"1\";s:14:\"items_per_page\";s:2:\"25\";s:8:\"override\";i:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";s:1:\"0\";s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";i:0;s:3:\"not\";i:0;}}s:5:\"empty\";a:1:{s:4:\"area\";a:11:{s:2:\"id\";s:4:\"area\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:10:\"No results\";s:5:\"empty\";b:1;s:7:\"content\";s:3:\"N/A\";s:6:\"format\";s:13:\"filtered_html\";s:8:\"tokenize\";i:0;}}}'),(4,'entity_view_1','EVA Field','entity_view',2,'a:6:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:7:\"bundles\";a:1:{i:0;s:15:\"virtual_machine\";}s:13:\"argument_mode\";s:2:\"id\";s:16:\"default_argument\";N;s:15:\"display_comment\";s:99:\"Required for the VM metrics display. Modifying this display WILL break the metrics in the VM nodes.\";}'),(5,'default','Master','default',1,'a:13:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";s:1:\"0\";s:6:\"offset\";s:1:\"0\";s:2:\"id\";s:1:\"0\";s:11:\"total_pages\";s:0:\"\";s:8:\"quantity\";s:1:\"9\";s:4:\"tags\";a:4:{s:5:\"first\";s:8:\"« first\";s:8:\"previous\";s:12:\"‹ previous\";s:4:\"next\";s:8:\"next ›\";s:4:\"last\";s:7:\"last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";i:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:17:\"5, 10, 20, 40, 60\";s:26:\"items_per_page_options_all\";i:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";i:0;s:12:\"offset_label\";s:6:\"Offset\";}}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:1:{s:5:\"title\";a:8:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:4:\"trim\";i:0;s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:0;s:10:\"strip_tags\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:1;}}s:7:\"filters\";a:3:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:5:\"vdisk\";s:5:\"vdisk\";}}s:22:\"field_vdisk_type_value\";a:13:{s:2:\"id\";s:22:\"field_vdisk_type_value\";s:5:\"table\";s:27:\"field_data_field_vdisk_type\";s:5:\"field\";s:22:\"field_vdisk_type_value\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:2:\"!=\";s:5:\"value\";s:5:\"CACHE\";s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}}s:5:\"sorts\";a:1:{s:5:\"title\";a:9:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"order\";s:3:\"ASC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}}}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:1:{s:31:\"field_virtual_machine_target_id\";a:22:{s:2:\"id\";s:31:\"field_virtual_machine_target_id\";s:5:\"table\";s:32:\"field_data_field_virtual_machine\";s:5:\"field\";s:31:\"field_virtual_machine_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:14:\"default_action\";s:5:\"empty\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";i:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";i:0;s:5:\"title\";s:0:\"\";s:17:\"breadcrumb_enable\";i:0;s:10:\"breadcrumb\";s:0:\"\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";i:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";s:1:\"1\";s:14:\"items_per_page\";s:2:\"25\";s:8:\"override\";i:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";s:1:\"0\";s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";i:0;s:3:\"not\";i:0;}}s:5:\"empty\";a:1:{s:4:\"area\";a:11:{s:2:\"id\";s:4:\"area\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:5:\"empty\";b:1;s:7:\"content\";s:37:\"The disk metrics could not be loaded.\";s:6:\"format\";s:13:\"filtered_html\";s:8:\"tokenize\";i:0;}}}'),(5,'entity_view_1','EVA Field','entity_view',2,'a:8:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:7:\"bundles\";a:1:{i:0;s:15:\"virtual_machine\";}s:13:\"argument_mode\";s:2:\"id\";s:16:\"default_argument\";N;s:6:\"fields\";a:3:{s:5:\"title\";a:8:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:4:\"trim\";i:0;s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:0;s:10:\"strip_tags\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:1;}s:10:\"field_path\";a:34:{s:2:\"id\";s:10:\"field_path\";s:5:\"table\";s:21:\"field_data_field_path\";s:5:\"field\";s:10:\"field_path\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:4:\"Path\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:16:\"field_disk_index\";a:34:{s:2:\"id\";s:16:\"field_disk_index\";s:5:\"table\";s:27:\"field_data_field_disk_index\";s:5:\"field\";s:16:\"field_disk_index\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:10:\"Disk Index\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:2:{s:18:\"thousand_separator\";s:1:\" \";s:13:\"prefix_suffix\";i:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}}s:8:\"defaults\";a:2:{s:6:\"fields\";b:0;s:5:\"empty\";b:0;}s:5:\"empty\";a:1:{s:4:\"area\";a:11:{s:2:\"id\";s:4:\"area\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:5:\"empty\";b:1;s:7:\"content\";s:3:\"N/A\";s:6:\"format\";s:13:\"filtered_html\";s:8:\"tokenize\";i:0;}}}'),(5,'entity_view_2','EVA Field 2','entity_view',3,'a:9:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:7:\"filters\";a:2:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:13:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:15:\"virtual_machine\";s:15:\"virtual_machine\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}}s:8:\"defaults\";a:5:{s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;s:9:\"arguments\";b:0;s:6:\"fields\";b:0;s:5:\"empty\";b:0;}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:9:\"arguments\";a:1:{s:20:\"field_host_target_id\";a:22:{s:2:\"id\";s:20:\"field_host_target_id\";s:5:\"table\";s:21:\"field_data_field_host\";s:5:\"field\";s:20:\"field_host_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:14:\"default_action\";s:5:\"empty\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";i:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";i:0;s:5:\"title\";s:0:\"\";s:17:\"breadcrumb_enable\";i:0;s:10:\"breadcrumb\";s:0:\"\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";i:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";s:1:\"1\";s:14:\"items_per_page\";s:2:\"25\";s:8:\"override\";i:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";s:1:\"0\";s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";i:0;s:3:\"not\";i:0;}}s:11:\"entity_type\";s:4:\"node\";s:7:\"bundles\";a:1:{i:0;s:4:\"host\";}s:6:\"fields\";a:6:{s:5:\"title\";a:8:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:4:\"trim\";i:0;s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:0;s:10:\"strip_tags\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:1;}s:29:\"field_fa_administration_state\";a:34:{s:2:\"id\";s:29:\"field_fa_administration_state\";s:5:\"table\";s:40:\"field_data_field_fa_administration_state\";s:5:\"field\";s:29:\"field_fa_administration_state\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:26:\"field_fa_operational_state\";a:34:{s:2:\"id\";s:26:\"field_fa_operational_state\";s:5:\"table\";s:37:\"field_data_field_fa_operational_state\";s:5:\"field\";s:26:\"field_fa_operational_state\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:19:\"field_fa_cache_size\";a:34:{s:2:\"id\";s:19:\"field_fa_cache_size\";s:5:\"table\";s:30:\"field_data_field_fa_cache_size\";s:5:\"field\";s:19:\"field_fa_cache_size\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:16:\"field_vdisk_type\";a:3:{s:2:\"id\";s:16:\"field_vdisk_type\";s:5:\"table\";s:27:\"field_data_field_vdisk_type\";s:5:\"field\";s:16:\"field_vdisk_type\";}s:20:\"field_fa_sector_size\";a:34:{s:2:\"id\";s:20:\"field_fa_sector_size\";s:5:\"table\";s:31:\"field_data_field_fa_sector_size\";s:5:\"field\";s:20:\"field_fa_sector_size\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:11:\"Sector Size\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}}s:5:\"empty\";a:1:{s:4:\"area\";a:11:{s:2:\"id\";s:4:\"area\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:5:\"empty\";b:1;s:7:\"content\";s:3:\"N/A\";s:6:\"format\";s:13:\"filtered_html\";s:8:\"tokenize\";i:0;}}}'),(6,'block','Block','block',2,'a:2:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"field\";a:1:{s:5:\"title\";a:1:{s:12:\"link_to_node\";i:1;}}}'),(6,'default','Master','default',1,'a:12:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";s:2:\"10\";}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:1:{s:5:\"title\";a:8:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:4:\"trim\";i:0;s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:0;s:10:\"strip_tags\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:1;}}s:7:\"filters\";a:2:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:15:\"virtual_machine\";s:15:\"virtual_machine\";}}}s:5:\"sorts\";a:1:{s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:5:\"title\";s:18:\"VM metric per Host\";s:9:\"arguments\";a:1:{s:20:\"field_host_target_id\";a:22:{s:2:\"id\";s:20:\"field_host_target_id\";s:5:\"table\";s:21:\"field_data_field_host\";s:5:\"field\";s:20:\"field_host_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:14:\"default_action\";s:5:\"empty\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";i:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";i:0;s:5:\"title\";s:0:\"\";s:17:\"breadcrumb_enable\";i:0;s:10:\"breadcrumb\";s:0:\"\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";i:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";s:1:\"1\";s:14:\"items_per_page\";s:2:\"25\";s:8:\"override\";i:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";s:1:\"0\";s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";i:0;s:3:\"not\";i:0;}}}'),(7,'views_data_export_1','Data export','views_data_export',3,'a:8:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:18:\"export-console-log\";s:7:\"filters\";a:3:{s:4:\"type\";a:13:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:6:\"not in\";s:5:\"value\";a:5:{s:13:\"access denied\";s:13:\"access denied\";s:4:\"cron\";s:4:\"cron\";s:14:\"page not found\";s:14:\"page not found\";s:3:\"php\";s:3:\"php\";s:10:\"search_api\";s:10:\"search_api\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:7:\"type_op\";s:5:\"label\";s:4:\"Type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";i:0;s:8:\"operator\";s:7:\"type_op\";s:10:\"identifier\";s:4:\"type\";s:8:\"required\";i:0;s:8:\"remember\";i:0;s:8:\"multiple\";i:0;s:14:\"remember_roles\";a:3:{i:2;s:1:\"2\";i:1;i:0;i:3;i:0;}s:6:\"reduce\";i:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:4:\"Type\";s:11:\"description\";N;s:10:\"identifier\";s:4:\"type\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:3:{i:1;a:0:{}i:2;a:0:{}i:3;a:0:{}}}}s:6:\"type_1\";a:13:{s:2:\"id\";s:6:\"type_1\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:6:\"not in\";s:5:\"value\";a:2:{s:4:\"cron\";s:4:\"cron\";s:3:\"php\";s:3:\"php\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}s:3:\"php\";a:16:{s:2:\"id\";s:3:\"php\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:3:\"php\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:13:\"use_php_setup\";i:0;s:9:\"php_setup\";s:0:\"\";s:10:\"php_filter\";s:46:\"return mercury_fmcdb_console_log_filter($row);\";}}s:8:\"defaults\";a:4:{s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;s:5:\"pager\";b:0;s:13:\"pager_options\";b:0;}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:13:\"style_options\";a:11:{s:11:\"attach_text\";s:3:\"CSV\";s:12:\"provide_file\";i:1;s:8:\"filename\";s:94:\" fmc_log_%timestamp-yyyy%timestamp-mm%timestamp-dd%timestamp-hh%timestamp-ii%timestamp-ss .csv\";s:11:\"parent_sort\";i:0;s:9:\"separator\";s:1:\",\";s:5:\"quote\";i:1;s:4:\"trim\";i:0;s:16:\"replace_newlines\";i:0;s:19:\"newline_replacement\";s:2:\", \";s:6:\"header\";i:1;s:8:\"encoding\";s:0:\"\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:1:{s:6:\"offset\";s:1:\"0\";}}s:13:\"pager_options\";N;}'),(7,'page','Page','page',2,'a:11:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:19:\"console-logs-report\";s:13:\"exposed_block\";b:0;s:4:\"menu\";a:6:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:12:\"Console Logs\";s:11:\"description\";s:19:\"Console Logs Report\";s:4:\"name\";s:23:\"menu-mercury-navigation\";s:6:\"weight\";s:2:\"10\";s:7:\"context\";i:0;}s:6:\"footer\";a:1:{s:3:\"php\";a:9:{s:2:\"id\";s:3:\"php\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:3:\"php\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:14:\"Footer(export)\";s:5:\"empty\";i:0;s:10:\"php_output\";s:54:\"<!-- <a href=\"/export-console-log\">Export CSV</a> -->\n\";}}s:8:\"defaults\";a:6:{s:6:\"footer\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;s:12:\"exposed_form\";b:0;s:20:\"exposed_form_options\";b:0;s:6:\"header\";b:0;}s:7:\"filters\";a:3:{s:4:\"type\";a:13:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:9:{s:9:\"Analytics\";s:9:\"Analytics\";s:10:\"Cache Mgmt\";s:10:\"Cache Mgmt\";s:16:\"Cache Space Mgmt\";s:16:\"Cache Space Mgmt\";s:9:\"Discovery\";s:9:\"Discovery\";s:12:\"Flash Device\";s:12:\"Flash Device\";s:10:\"Host Agent\";s:10:\"Host Agent\";s:12:\"Host Refresh\";s:12:\"Host Refresh\";s:8:\"VM Agent\";s:8:\"VM Agent\";s:10:\"VM Refresh\";s:10:\"VM Refresh\";}s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:7:\"type_op\";s:5:\"label\";s:4:\"Type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";i:0;s:8:\"operator\";s:7:\"type_op\";s:10:\"identifier\";s:4:\"type\";s:8:\"required\";i:0;s:8:\"remember\";i:0;s:8:\"multiple\";i:0;s:14:\"remember_roles\";a:3:{i:2;s:1:\"2\";i:1;i:0;i:3;i:0;}s:6:\"reduce\";i:1;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:4:\"Type\";s:11:\"description\";N;s:10:\"identifier\";s:4:\"type\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:3:{i:1;a:0:{}i:2;a:0:{}i:3;a:0:{}}}}s:6:\"type_1\";a:13:{s:2:\"id\";s:6:\"type_1\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:6:\"not in\";s:5:\"value\";a:2:{s:4:\"cron\";s:4:\"cron\";s:3:\"php\";s:3:\"php\";}s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}s:3:\"php\";a:16:{s:2:\"id\";s:3:\"php\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:3:\"php\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:0:\"\";s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:13:\"use_php_setup\";i:0;s:9:\"php_setup\";s:0:\"\";s:10:\"php_filter\";s:46:\"return mercury_fmcdb_console_log_filter($row);\";}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:8:{s:13:\"submit_button\";s:6:\"Submit\";s:12:\"reset_button\";i:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";s:10:\"autosubmit\";i:0;s:15:\"autosubmit_hide\";i:1;}}s:20:\"exposed_form_options\";N;s:6:\"header\";a:1:{s:3:\"php\";a:9:{s:2:\"id\";s:3:\"php\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:3:\"php\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:5:\"empty\";i:0;s:10:\"php_output\";s:40:\"<?php mercury_fmcdb_clear_logs_url();?>\n\";}}}'),(8,'default','Master','default',1,'a:13:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";s:2:\"10\";}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:1:{s:5:\"title\";a:22:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:0;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:1;}}s:7:\"filters\";a:2:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:15:\"virtual_machine\";s:15:\"virtual_machine\";}}}s:5:\"sorts\";a:1:{s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:5:\"title\";s:17:\"Ongoing Processes\";s:11:\"row_options\";a:4:{s:22:\"default_field_elements\";i:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";i:0;}s:13:\"style_options\";a:4:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";i:1;s:17:\"row_class_special\";i:1;}}'),(8,'page','Page','page',2,'a:3:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:15:\"ongoing-process\";s:7:\"enabled\";b:1;}'),(9,'block','Block','block',2,'a:3:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:8:\"defaults\";a:2:{s:16:\"hide_admin_links\";b:0;s:6:\"fields\";b:0;}s:6:\"fields\";a:8:{s:3:\"nid\";a:6:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:19:\"element_label_colon\";b:0;}s:5:\"php_4\";a:10:{s:2:\"id\";s:5:\"php_4\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:3:\"php\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:19:\"element_label_colon\";b:0;s:13:\"use_php_setup\";i:0;s:10:\"php_output\";s:134:\"<?php\r\n$str = \'<input type=\"checkbox\" name=\"\' . $row->title . \'\" value=\"\' . $row->nid . \'\" class = \"checkbox\"/>\';\r\n\r\nprint $str;\r\n\r\n?>\";s:22:\"use_php_click_sortable\";s:1:\"0\";s:18:\"php_click_sortable\";s:0:\"\";}s:5:\"php_5\";a:10:{s:2:\"id\";s:5:\"php_5\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:3:\"php\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:19:\"element_label_colon\";b:0;s:13:\"use_php_setup\";i:0;s:10:\"php_output\";s:4130:\"<?php\r\n$vm_id = $data->nid;\r\n$image = \'<img src = \" \' . base_path() . drupal_get_path(\'module\', \'mercury_utilities\') . \'/images/wrench.png\" class = \"wrench\"/>\';\r\n$str = \'<span class=\"host_wrench\">\' .$image;\r\n\r\n$str .= \'<div class = \"wrench-menu-vm wrench-menu\" id = \"wrench-menu-vm-\'. $vm_id . \'\">\';\r\n        $str .= \'<ul class = \"first-level-ul\">\';\r\n          $str .= \'<li class = \"first-level-li expandable\">Package\';\r\n            $str .= \'<ul class = \"second-level-ul\">\';\r\n              $str .= \'<li class = \"second-level-li\">\' . ctools_popups_vm_settings_link(\'Install\', $vm_id, \'settings\', \'Settings\') . \'</li>\';\r\n              $str .= \'<li class = \"second-level-li\">\' . ctools_popups_vm_settings_link(\'Upgrade\', $vm_id, \'settings\', \'Settings\') . \'</li>\';\r\n              $str .= \'<li class = \"second-level-li last\">\' . ctools_popups_vm_settings_link(\'Uninstall\', $vm_id, \'settings\', \'Settings\') . \'</li>\';\r\n            $str .= \'</ul>\';\r\n          $str .= \'</li>\';\r\n          $str .= \'<li class = \"first-level-li expandable\">Cache Space\';\r\n            $str .= \'<ul class = \"second-level-ul\">\';\r\n              $str .= \'<li class = \"second-level-li\">\' . ctools_popups_vm_settings_link(\'Allocate\', $vm_id, \'settings\', \'cache-space\') . \'</li>\';\r\n              $str .= \'<li class = \"second-level-li last\">\' . ctools_popups_vm_settings_link(\'Unallocate\', $vm_id, \'settings\', \'cache-space\') . \'</li>\';\r\n            $str .= \'</ul>\';\r\n          $str .= \'</li>\';\r\n          $str .= \'<li class = \"first-level-li expandable\">Cache Format\';\r\n            $str .= \'<ul class = \"second-level-ul\">\';\r\n              $str .= \'<li class = \"second-level-li\">\' . ctools_popups_vm_settings_link(\'Start\', $vm_id, \'settings\', \'cache-format\') . \'</li>\';\r\n              $str .= \'<li class = \"second-level-li last\">\' . ctools_popups_vm_settings_link(\'Stop\', $vm_id, \'settings\', \'cache-format\') . \'</li>\';\r\n            $str .= \'</ul>\';\r\n          $str .= \'</li>\';\r\n          $str .= \'<li class = \"first-level-li expandable\">Cache State\';\r\n            $str .= \'<ul class = \"second-level-ul\">\';\r\n              $str .= \'<li class = \"second-level-li\">\' . ctools_popups_vm_settings_link(\'Enable\', $vm_id, \'Settings\', \'cache-state\') . \'</li>\';\r\n              $str .= \'<li class = \"second-level-li last\">\' . ctools_popups_vm_settings_link(\'Disable\', $vm_id, \'Settings\', \'cache-state\') . \'</li>\';\r\n            $str .= \'</ul>\';  \r\n          $str .= \'</li>\';\r\n          $str .= \'<li class = \"first-level-li expandable\">Cache Mode\';\r\n            $str .= \'<ul class = \"second-level-ul\">\';\r\n              $str .= \'<li class = \"second-level-li\">\' . ctools_popups_vm_settings_link(\'Write Thru\', $vm_id, \'settings\', \'cache-mode\') . \'</li>\';\r\n              $str .= \'<li class = \"second-level-li\">\' . ctools_popups_vm_settings_link(\'Write Around\', $vm_id, \'settings\', \'cache-mode\') . \'</li>\';\r\n              $str .= \'<li class = \"second-level-li last\">\' . ctools_popups_vm_settings_link(\'Pass Thru\', $vm_id, \'settings\', \'cache-mode\') . \'</li>\';\r\n            $str .= \'</ul>\';  \r\n          $str .= \'</li>\';\r\n          $str .= \'<li class = \"first-level-li expandable\">Cache Metrics\';\r\n            $str .= \'<ul class = \"second-level-ul\">\';\r\n              $str .= \'<li class = \"second-level-li\">\' . ctools_popups_vm_settings_link(\'Enable\', $vm_id, \'settings\', \'cache-metrics\') . \'</li>\';\r\n              $str .= \'<li class = \"second-level-li\">\' . ctools_popups_vm_settings_link(\'Disable\', $vm_id, \'settings\', \'cache-metrics\') . \'</li>\';\r\n              $str .= \'<li class = \"second-level-li last\">\' . ctools_popups_vm_settings_link(\'Reset\', $vm_id, \'settings\', \'cache-metrics\') . \'</li>\';\r\n            $str .= \'</ul>\';  \r\n          $str .= \'</li>\';\r\n          $str .= \'<li class = \"first-level-li\">Advanced</li>\';\r\n          $str .= \'<li class = \"first-level-li\">\' . ctools_popups_vm_settings_link(\'Refresh\', $vm_id, \'settings\', \'refresh\') . \'</li>\';\r\n          $str .= \'<li class = \"first-level-li last\">\' . ctools_popups_vm_settings_link(\'Edit\', $vm_id, \'settings\', \'edit\') . \'</li>\';\r\n        $str .= \'</ul>\';\r\n      $str .= \'</div>\';\r\n\r\n$str .= \'</span>\';\r\n\r\nprint $str;\r\n\r\n?>\";s:22:\"use_php_click_sortable\";s:1:\"0\";s:18:\"php_click_sortable\";s:0:\"\";}s:5:\"title\";a:6:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:4:\"Name\";s:5:\"alter\";a:4:{s:10:\"alter_text\";b:1;s:4:\"text\";s:36:\"<span>[php_4]</span> [title] [php_5]\";s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;}s:19:\"element_label_colon\";b:0;}s:19:\"field_driver_status\";a:6:{s:2:\"id\";s:19:\"field_driver_status\";s:5:\"table\";s:30:\"field_data_field_driver_status\";s:5:\"field\";s:19:\"field_driver_status\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:19:\"element_label_colon\";b:0;}s:29:\"field_fa_administration_state\";a:4:{s:2:\"id\";s:29:\"field_fa_administration_state\";s:5:\"table\";s:40:\"field_data_field_fa_administration_state\";s:5:\"field\";s:29:\"field_fa_administration_state\";s:5:\"label\";s:12:\"Admini State\";}s:26:\"field_fa_operational_state\";a:3:{s:2:\"id\";s:26:\"field_fa_operational_state\";s:5:\"table\";s:37:\"field_data_field_fa_operational_state\";s:5:\"field\";s:26:\"field_fa_operational_state\";}s:28:\"field_fa_operational_message\";a:3:{s:2:\"id\";s:28:\"field_fa_operational_message\";s:5:\"table\";s:39:\"field_data_field_fa_operational_message\";s:5:\"field\";s:28:\"field_fa_operational_message\";}}}'),(9,'default','Master','default',1,'a:13:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:15:\"use_more_always\";b:0;s:6:\"access\";a:2:{s:4:\"type\";s:4:\"role\";s:4:\"role\";a:2:{i:3;s:1:\"3\";i:2;s:1:\"2\";}}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:1:{s:6:\"offset\";s:1:\"0\";}}s:12:\"style_plugin\";s:5:\"table\";s:6:\"fields\";a:14:{s:16:\"field_datacenter\";a:34:{s:2:\"id\";s:16:\"field_datacenter\";s:5:\"table\";s:27:\"field_data_field_datacenter\";s:5:\"field\";s:16:\"field_datacenter\";s:12:\"relationship\";s:20:\"field_host_target_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:21:\"entityreference_label\";s:8:\"settings\";a:1:{s:4:\"link\";i:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:5:\"php_1\";a:27:{s:2:\"id\";s:5:\"php_1\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:3:\"php\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"use_php_setup\";i:0;s:9:\"php_setup\";s:0:\"\";s:9:\"php_value\";s:0:\"\";s:10:\"php_output\";s:54:\"<?php\nmercury_fmcdb_all_vm_datacenter_title($data);\n?>\";s:22:\"use_php_click_sortable\";s:1:\"0\";s:18:\"php_click_sortable\";s:0:\"\";}s:3:\"nid\";a:6:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:19:\"element_label_colon\";b:0;}s:5:\"php_4\";a:27:{s:2:\"id\";s:5:\"php_4\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:3:\"php\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"use_php_setup\";i:0;s:9:\"php_setup\";s:0:\"\";s:9:\"php_value\";s:0:\"\";s:10:\"php_output\";s:45:\"<?php\nmercury_fmcdb_all_vm_checkbox($row);\n?>\";s:22:\"use_php_click_sortable\";s:1:\"0\";s:18:\"php_click_sortable\";s:0:\"\";}s:5:\"php_5\";a:27:{s:2:\"id\";s:5:\"php_5\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:3:\"php\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"use_php_setup\";i:0;s:9:\"php_setup\";s:0:\"\";s:9:\"php_value\";s:0:\"\";s:10:\"php_output\";s:49:\"<?php\nmercury_fmcdb_all_vm_wrench_menu($data);\n?>\";s:22:\"use_php_click_sortable\";s:1:\"0\";s:18:\"php_click_sortable\";s:0:\"\";}s:7:\"title_1\";a:22:{s:2:\"id\";s:7:\"title_1\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:2:\"22\";s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:1;}s:5:\"title\";a:22:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:7:\"VM Name\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:17:\"[title_1] [php_5]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:0;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:0;}s:21:\"field_driver_status_1\";a:34:{s:2:\"id\";s:21:\"field_driver_status_1\";s:5:\"table\";s:30:\"field_data_field_driver_status\";s:5:\"field\";s:19:\"field_driver_status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:17:\"Flash Accel State\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:2:\"20\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:3:\"php\";a:27:{s:2:\"id\";s:3:\"php\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:3:\"php\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:10:\"Cache Size\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"use_php_setup\";i:0;s:9:\"php_setup\";s:0:\"\";s:9:\"php_value\";s:0:\"\";s:10:\"php_output\";s:48:\"<?php\nmercury_fmcdb_all_vm_cache_size($data);\n?>\";s:22:\"use_php_click_sortable\";s:1:\"0\";s:18:\"php_click_sortable\";s:0:\"\";}s:29:\"field_fa_administration_state\";a:34:{s:2:\"id\";s:29:\"field_fa_administration_state\";s:5:\"table\";s:40:\"field_data_field_fa_administration_state\";s:5:\"field\";s:29:\"field_fa_administration_state\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:11:\"Cache State\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:26:\"field_fa_operational_state\";a:4:{s:2:\"id\";s:26:\"field_fa_operational_state\";s:5:\"table\";s:37:\"field_data_field_fa_operational_state\";s:5:\"field\";s:26:\"field_fa_operational_state\";s:5:\"label\";s:18:\"Operational Status\";}s:5:\"php_3\";a:27:{s:2:\"id\";s:5:\"php_3\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:3:\"php\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"use_php_setup\";i:0;s:9:\"php_setup\";s:0:\"\";s:9:\"php_value\";s:0:\"\";s:10:\"php_output\";s:50:\"<?php\nmercury_fmcdb_all_vm_status_icon($data);\n?>\n\";s:22:\"use_php_click_sortable\";s:1:\"0\";s:18:\"php_click_sortable\";s:0:\"\";}s:26:\"field_fa_performance_state\";a:34:{s:2:\"id\";s:26:\"field_fa_performance_state\";s:5:\"table\";s:37:\"field_data_field_fa_performance_state\";s:5:\"field\";s:26:\"field_fa_performance_state\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:7:\"title_2\";a:22:{s:2:\"id\";s:7:\"title_2\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:26:\"field_datacenter_target_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:1;}}s:5:\"sorts\";a:2:{s:7:\"title_1\";a:9:{s:2:\"id\";s:7:\"title_1\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:26:\"field_datacenter_target_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"order\";s:3:\"ASC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}}s:5:\"title\";a:9:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"order\";s:3:\"ASC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}}}s:7:\"filters\";a:2:{s:6:\"status\";a:6:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:5:\"value\";i:1;s:5:\"group\";i:1;s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}s:4:\"type\";a:5:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:15:\"virtual_machine\";s:15:\"virtual_machine\";}s:5:\"group\";i:1;}}s:13:\"relationships\";a:2:{s:20:\"field_host_target_id\";a:8:{s:2:\"id\";s:20:\"field_host_target_id\";s:5:\"table\";s:21:\"field_data_field_host\";s:5:\"field\";s:20:\"field_host_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:41:\"Content entity referenced from field_host\";s:8:\"required\";i:0;}s:26:\"field_datacenter_target_id\";a:8:{s:2:\"id\";s:26:\"field_datacenter_target_id\";s:5:\"table\";s:27:\"field_data_field_datacenter\";s:5:\"field\";s:26:\"field_datacenter_target_id\";s:12:\"relationship\";s:20:\"field_host_target_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:47:\"Content entity referenced from field_datacenter\";s:8:\"required\";i:0;}}s:13:\"style_options\";a:11:{s:8:\"grouping\";a:1:{i:0;a:3:{s:5:\"field\";s:16:\"field_datacenter\";s:8:\"rendered\";i:1;s:14:\"rendered_strip\";i:0;}}s:9:\"row_class\";s:19:\"[php_1] mercury-row\";s:17:\"default_row_class\";i:1;s:17:\"row_class_special\";i:1;s:8:\"override\";i:1;s:6:\"sticky\";i:0;s:7:\"summary\";s:0:\"\";s:7:\"columns\";a:14:{s:16:\"field_datacenter\";s:16:\"field_datacenter\";s:5:\"php_1\";s:5:\"php_1\";s:3:\"nid\";s:3:\"nid\";s:5:\"php_4\";s:5:\"php_4\";s:5:\"php_5\";s:5:\"php_5\";s:7:\"title_1\";s:7:\"title_1\";s:5:\"title\";s:5:\"title\";s:21:\"field_driver_status_1\";s:21:\"field_driver_status_1\";s:3:\"php\";s:3:\"php\";s:29:\"field_fa_administration_state\";s:29:\"field_fa_administration_state\";s:26:\"field_fa_operational_state\";s:26:\"field_fa_operational_state\";s:5:\"php_3\";s:5:\"php_3\";s:26:\"field_fa_performance_state\";s:26:\"field_fa_performance_state\";s:7:\"title_2\";s:7:\"title_2\";}s:4:\"info\";a:14:{s:16:\"field_datacenter\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:5:\"php_1\";a:3:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:3:\"nid\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:5:\"php_4\";a:3:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:5:\"php_5\";a:3:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:7:\"title_1\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:5:\"title\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:21:\"field_driver_status_1\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:3:\"php\";a:3:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:29:\"field_fa_administration_state\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:26:\"field_fa_operational_state\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:5:\"php_3\";a:3:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:26:\"field_fa_performance_state\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:7:\"title_2\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}}s:7:\"default\";s:2:\"-1\";s:11:\"empty_table\";i:0;}s:5:\"empty\";a:1:{s:3:\"php\";a:9:{s:2:\"id\";s:3:\"php\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:3:\"php\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:5:\"empty\";b:1;s:10:\"php_output\";s:1042:\"<?php\n$status = variable_get(\'discovery_happened\', 0);\nif ($status == 1) { ?>\n<div id=\"no-host-discovery\">No VMs found in the selected vServer datacenters. Try using the Console Settings > Discovery Settings tab to discover VMs in other datacenters.</div>\n<?php } else { ?>\n<div class=\"mercury-host-block\"><div class=\"no-vms-message-header\"><span id=\"column-1\"><span class=\"row-title\">It\'s easy to start using Flash Accel.</span></span></div><div class=\"no-vms-message\">First, use the Console Settings &gt; Discovery Settings tab to discover the inventory of each vServer datacenter you want to manage with the Flash Accel Management Console (FMC).<br><br>Next, use the Host Inventory page to install Flash Accel on hosts and assign flash devices. <br><br>Finally, use the VM Inventory page to install Flash Accel on VMs and allocate cache space for VMs.<br><br>Once you have completed these steps, your FlashAccel-enabled VMs are listed on the FMC home page--ready to demonstrate Flash Accel-erated I/O performance!<br></div></div>\n<?php }?>\";}}}'),(2,'block','Block','block',2,'a:1:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}}'),(7,'default','Master','default',1,'a:15:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:2:{s:4:\"type\";s:4:\"role\";s:4:\"role\";a:2:{i:3;s:1:\"3\";i:2;s:1:\"2\";}}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:8:{s:13:\"submit_button\";s:6:\"Submit\";s:12:\"reset_button\";i:1;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";s:10:\"autosubmit\";i:0;s:15:\"autosubmit_hide\";i:1;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";s:2:\"20\";s:6:\"offset\";s:1:\"0\";s:2:\"id\";s:1:\"0\";s:11:\"total_pages\";s:0:\"\";s:8:\"quantity\";s:1:\"9\";s:4:\"tags\";a:4:{s:5:\"first\";s:8:\"« first\";s:8:\"previous\";s:12:\"‹ previous\";s:4:\"next\";s:8:\"next ›\";s:4:\"last\";s:7:\"last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";i:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:17:\"5, 10, 20, 40, 60\";s:26:\"items_per_page_options_all\";i:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";i:0;s:12:\"offset_label\";s:6:\"Offset\";}}}s:12:\"style_plugin\";s:5:\"table\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:4:{s:9:\"timestamp\";a:3:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:9:\"timestamp\";}s:4:\"type\";a:3:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:4:\"type\";}s:7:\"message\";a:23:{s:2:\"id\";s:7:\"message\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:7:\"message\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:7:\"Message\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:23:\"watchdog_message_format\";i:1;s:21:\"watchdog_message_link\";i:0;}s:8:\"location\";a:22:{s:2:\"id\";s:8:\"location\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:8:\"location\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:8:\"Location\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:15:\"display_as_link\";i:0;}}s:7:\"filters\";a:2:{s:4:\"type\";a:13:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:6:{s:10:\"Cache Mgmt\";s:10:\"Cache Mgmt\";s:16:\"Cache Space Mgmt\";s:16:\"Cache Space Mgmt\";s:10:\"Host Agent\";s:10:\"Host Agent\";s:4:\"user\";s:4:\"user\";s:8:\"VM Agent\";s:8:\"VM Agent\";s:10:\"VM Refresh\";s:10:\"VM Refresh\";}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:7:\"type_op\";s:5:\"label\";s:4:\"Type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";i:0;s:8:\"operator\";s:7:\"type_op\";s:10:\"identifier\";s:4:\"type\";s:8:\"required\";i:0;s:8:\"remember\";i:0;s:8:\"multiple\";i:0;s:14:\"remember_roles\";a:3:{i:2;s:1:\"2\";i:1;i:0;i:3;i:0;}s:6:\"reduce\";i:1;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:4:\"Type\";s:11:\"description\";N;s:10:\"identifier\";s:4:\"type\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:3:{i:1;a:0:{}i:2;a:0:{}i:3;a:0:{}}}}s:6:\"type_1\";a:13:{s:2:\"id\";s:6:\"type_1\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:6:\"not in\";s:5:\"value\";a:6:{s:13:\"access denied\";s:13:\"access denied\";s:4:\"cron\";s:4:\"cron\";s:14:\"page not found\";s:14:\"page not found\";s:3:\"php\";s:3:\"php\";s:10:\"search_api\";s:10:\"search_api\";s:13:\"search_api_db\";s:13:\"search_api_db\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:19:\"Console Logs Report\";s:13:\"style_options\";a:11:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:15:\"console-log-row\";s:17:\"default_row_class\";i:1;s:17:\"row_class_special\";i:1;s:8:\"override\";i:1;s:6:\"sticky\";i:0;s:7:\"summary\";s:0:\"\";s:7:\"columns\";a:5:{s:9:\"timestamp\";s:9:\"timestamp\";s:4:\"type\";s:4:\"type\";s:7:\"message\";s:7:\"message\";s:7:\"referer\";s:7:\"referer\";s:8:\"location\";s:8:\"location\";}s:4:\"info\";a:5:{s:9:\"timestamp\";a:5:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:1;}s:4:\"type\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:1;}s:7:\"message\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:1;}s:7:\"referer\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:1;}s:8:\"location\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:1;}}s:7:\"default\";s:9:\"timestamp\";s:11:\"empty_table\";i:0;}s:8:\"use_ajax\";b:1;s:6:\"header\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}}'),(2,'default','Master','default',1,'a:14:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:2:{s:4:\"type\";s:4:\"role\";s:4:\"role\";a:2:{i:3;s:1:\"3\";i:2;s:1:\"2\";}}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";s:2:\"20\";}}s:12:\"style_plugin\";s:5:\"table\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:14:{s:16:\"field_datacenter\";a:34:{s:2:\"id\";s:16:\"field_datacenter\";s:5:\"table\";s:27:\"field_data_field_datacenter\";s:5:\"field\";s:16:\"field_datacenter\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:21:\"entityreference_label\";s:8:\"settings\";a:1:{s:4:\"link\";i:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:5:\"php_6\";a:27:{s:2:\"id\";s:5:\"php_6\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:3:\"php\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"use_php_setup\";i:0;s:9:\"php_setup\";s:0:\"\";s:9:\"php_value\";s:0:\"\";s:10:\"php_output\";s:56:\"<?php\nmercury_fmcdb_all_host_datacenter_title($data);\n?>\";s:22:\"use_php_click_sortable\";s:1:\"0\";s:18:\"php_click_sortable\";s:0:\"\";}s:3:\"nid\";a:22:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:0;}s:5:\"php_1\";a:27:{s:2:\"id\";s:5:\"php_1\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:3:\"php\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"use_php_setup\";i:0;s:9:\"php_setup\";s:0:\"\";s:9:\"php_value\";s:0:\"\";s:10:\"php_output\";s:47:\"<?php\nmercury_fmcdb_all_host_checkbox($row);\n?>\";s:22:\"use_php_click_sortable\";s:1:\"0\";s:18:\"php_click_sortable\";s:0:\"\";}s:5:\"php_2\";a:27:{s:2:\"id\";s:5:\"php_2\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:3:\"php\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"use_php_setup\";i:0;s:9:\"php_setup\";s:0:\"\";s:9:\"php_value\";s:0:\"\";s:10:\"php_output\";s:51:\"<?php\nmercury_fmcdb_all_host_wrench_menu($data);\n?>\";s:22:\"use_php_click_sortable\";s:1:\"0\";s:18:\"php_click_sortable\";s:0:\"\";}s:7:\"title_1\";a:22:{s:2:\"id\";s:7:\"title_1\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:1;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:2:\"28\";s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:1;}s:5:\"title\";a:22:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:9:\"Host Name\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:17:\"[title_1] [php_2]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:0;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:0;}s:19:\"field_bundle_status\";a:34:{s:2:\"id\";s:19:\"field_bundle_status\";s:5:\"table\";s:30:\"field_data_field_bundle_status\";s:5:\"field\";s:19:\"field_bundle_status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:17:\"Flash Accel State\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:5:\"php_4\";a:27:{s:2:\"id\";s:5:\"php_4\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:3:\"php\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:15:\"Cache Device ID\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"use_php_setup\";i:0;s:9:\"php_setup\";s:0:\"\";s:9:\"php_value\";s:0:\"\";s:10:\"php_output\";s:56:\"<?php\nmercury_fmcdb_all_host_cache_device_id($data);\n?>\n\";s:22:\"use_php_click_sortable\";s:1:\"0\";s:18:\"php_click_sortable\";s:0:\"\";}s:5:\"php_3\";a:27:{s:2:\"id\";s:5:\"php_3\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:3:\"php\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:10:\"Cache Size\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"use_php_setup\";i:0;s:9:\"php_setup\";s:0:\"\";s:9:\"php_value\";s:0:\"\";s:10:\"php_output\";s:51:\"<?php\n mercury_fmcdb_all_host_cache_size($data);\n?>\";s:22:\"use_php_click_sortable\";s:1:\"0\";s:18:\"php_click_sortable\";s:0:\"\";}s:5:\"php_5\";a:27:{s:2:\"id\";s:5:\"php_5\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:3:\"php\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:10:\"Cache Used\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";i:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"use_php_setup\";i:0;s:9:\"php_setup\";s:0:\"\";s:9:\"php_value\";s:0:\"\";s:10:\"php_output\";s:50:\"<?php\nmercury_fmcdb_all_host_cache_used($data);\n?>\";s:22:\"use_php_click_sortable\";s:1:\"0\";s:18:\"php_click_sortable\";s:0:\"\";}s:17:\"field_cache_state\";a:34:{s:2:\"id\";s:17:\"field_cache_state\";s:5:\"table\";s:28:\"field_data_field_cache_state\";s:5:\"field\";s:17:\"field_cache_state\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:14:\"number_integer\";s:8:\"settings\";a:2:{s:18:\"thousand_separator\";s:1:\" \";s:13:\"prefix_suffix\";i:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:3:\"php\";a:27:{s:2:\"id\";s:3:\"php\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:3:\"php\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"use_php_setup\";i:0;s:9:\"php_setup\";s:0:\"\";s:9:\"php_value\";s:0:\"\";s:10:\"php_output\";s:51:\"<?php\nmercury_fmcdb_all_host_status_icon($data);\n?>\";s:22:\"use_php_click_sortable\";s:1:\"0\";s:18:\"php_click_sortable\";s:0:\"\";}s:7:\"title_2\";a:22:{s:2:\"id\";s:7:\"title_2\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:26:\"field_datacenter_target_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:0;}}s:7:\"filters\";a:2:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:13:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:4:\"host\";s:4:\"host\";}s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}}s:5:\"sorts\";a:1:{s:5:\"title\";a:9:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:26:\"field_datacenter_target_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"order\";s:3:\"ASC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}}}s:5:\"title\";s:0:\"\";s:13:\"style_options\";a:11:{s:8:\"grouping\";a:1:{i:0;a:3:{s:5:\"field\";s:16:\"field_datacenter\";s:8:\"rendered\";i:1;s:14:\"rendered_strip\";i:0;}}s:9:\"row_class\";s:19:\"[php_6] mercury-row\";s:17:\"default_row_class\";i:1;s:17:\"row_class_special\";i:1;s:8:\"override\";i:1;s:6:\"sticky\";i:0;s:7:\"summary\";s:0:\"\";s:7:\"columns\";a:13:{s:16:\"field_datacenter\";s:16:\"field_datacenter\";s:5:\"php_6\";s:5:\"php_6\";s:3:\"nid\";s:3:\"nid\";s:5:\"php_1\";s:5:\"php_1\";s:5:\"php_2\";s:5:\"php_2\";s:7:\"title_1\";s:7:\"title_1\";s:5:\"title\";s:5:\"title\";s:19:\"field_bundle_status\";s:19:\"field_bundle_status\";s:5:\"php_4\";s:5:\"php_4\";s:5:\"php_3\";s:5:\"php_3\";s:5:\"php_5\";s:5:\"php_5\";s:17:\"field_cache_state\";s:17:\"field_cache_state\";s:3:\"php\";s:3:\"php\";}s:4:\"info\";a:13:{s:16:\"field_datacenter\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:1;}s:5:\"php_6\";a:3:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:3:\"nid\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:5:\"php_1\";a:3:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:5:\"php_2\";a:3:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:7:\"title_1\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:5:\"title\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:19:\"field_bundle_status\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:5:\"php_4\";a:3:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:5:\"php_3\";a:3:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:5:\"php_5\";a:3:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:17:\"field_cache_state\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:3:\"php\";a:3:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}}s:7:\"default\";s:2:\"-1\";s:11:\"empty_table\";i:0;}s:5:\"empty\";a:1:{s:3:\"php\";a:9:{s:2:\"id\";s:3:\"php\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:3:\"php\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:5:\"empty\";b:1;s:10:\"php_output\";s:1046:\"<?php\n$status = variable_get(\'discovery_happened\', 0);\nif ($status == 1) { ?>\n<div id=\"no-host-discovery\">No hosts found in the selected vServer datacenters. Try using the Console Settings > Discovery Settings tab to discover hosts in other datacenters.</div>\n<?php } else { ?>\n<div class=\"mercury-host-block\"><div class=\"no-vms-message-header\"><span id=\"column-1\"><span class=\"row-title\">It\'s easy to start using Flash Accel.</span></span></div><div class=\"no-vms-message\">First, use the Console Settings &gt; Discovery Settings tab to discover the inventory of each vServer datacenter you want to manage with the Flash Accel Management Console (FMC).<br><br>Next, use the Host Inventory page to install Flash Accel on hosts and assign flash devices.<br><br>Finally, use the VM Inventory page to install Flash Accel on VMs and allocate cache space for VMs.<br><br>Once you have completed these steps, your FlashAccel-enabled VMs are listed on the FMC home page--ready to demonstrate Flash Accel-erated I/O performance!<br></div></div>\n<?php }?>\n\";}}s:13:\"relationships\";a:1:{s:26:\"field_datacenter_target_id\";a:8:{s:2:\"id\";s:26:\"field_datacenter_target_id\";s:5:\"table\";s:27:\"field_data_field_datacenter\";s:5:\"field\";s:26:\"field_datacenter_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:47:\"Content entity referenced from field_datacenter\";s:8:\"required\";i:0;}}}');
/*!40000 ALTER TABLE `views_display` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `views_view`
--

DROP TABLE IF EXISTS `views_view`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `views_view` (
  `vid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The view ID of the field, defined by the database.',
  `name` varchar(128) NOT NULL DEFAULT '' COMMENT 'The unique name of the view. This is the primary field views are loaded from, and is used so that views may be internal and not necessarily in the database. May only be alphanumeric characters plus underscores.',
  `description` varchar(255) DEFAULT '' COMMENT 'A description of the view for the admin interface.',
  `tag` varchar(255) DEFAULT '' COMMENT 'A tag used to group/sort views in the admin interface',
  `base_table` varchar(64) NOT NULL DEFAULT '' COMMENT 'What table this view is based on, such as node, user, comment, or term.',
  `human_name` varchar(255) DEFAULT '' COMMENT 'A human readable name used to be displayed in the admin interface',
  `core` int(11) DEFAULT '0' COMMENT 'Stores the drupal core version of the view.',
  PRIMARY KEY (`vid`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=10 DEFAULT CHARSET=utf8 COMMENT='Stores the general data for a view.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `views_view`
--

LOCK TABLES `views_view` WRITE;
/*!40000 ALTER TABLE `views_view` DISABLE KEYS */;
INSERT INTO `views_view` VALUES (1,'devices','','default','node','Devices',7),(2,'all_host','','default','node','all_host',7),(4,'vm_metrics','This view displays the metrics for VMs. Modifying this may break the metrics. Deleting this may break application.','default','node','VM metrics',7),(5,'vdisk_metric_per_vm','','default','node','vDisk metric per VM',7),(6,'vm_metric_per_host','','default','node','VM metric per Host',7),(7,'console_log_reports','','default','watchdog','Console Logs Report',7),(8,'ongoing_processes','','default','node','Ongoing Processes',7),(9,'all_vm','','default','node','all_vm',7);
/*!40000 ALTER TABLE `views_view` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `watchdog`
--

DROP TABLE IF EXISTS `watchdog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `watchdog` (
  `wid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique watchdog event ID.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid of the user who triggered the event.',
  `type` varchar(64) NOT NULL DEFAULT '' COMMENT 'Type of log message, for example "user" or "page not found."',
  `message` longtext NOT NULL COMMENT 'Text of log message to be passed into the t() function.',
  `variables` longblob NOT NULL COMMENT 'Serialized array of variables that match the message string and that is passed into the t() function.',
  `severity` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'The severity level of the event; ranges from 0 (Emergency) to 7 (Debug)',
  `link` varchar(255) DEFAULT '' COMMENT 'Link to view the result of the event.',
  `location` text NOT NULL COMMENT 'URL of the origin of the event.',
  `referer` text COMMENT 'URL of referring page.',
  `hostname` varchar(128) NOT NULL DEFAULT '' COMMENT 'Hostname of the user who triggered the event.',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'Unix timestamp of when event occurred.',
  PRIMARY KEY (`wid`),
  KEY `type` (`type`),
  KEY `uid` (`uid`)
) ENGINE=MyISAM AUTO_INCREMENT=4279944 DEFAULT CHARSET=utf8 COMMENT='Table that contains logs of all system events.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `watchdog`
--

LOCK TABLES `watchdog` WRITE;
/*!40000 ALTER TABLE `watchdog` DISABLE KEYS */;
/*!40000 ALTER TABLE `watchdog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Current Database: `mysql`
--

CREATE DATABASE /*!32312 IF NOT EXISTS*/ `mysql` /*!40100 DEFAULT CHARACTER SET latin1 */;

USE `mysql`;

--
-- Table structure for table `columns_priv`
--

DROP TABLE IF EXISTS `columns_priv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `columns_priv` (
  `Host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Db` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `User` char(16) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Table_name` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Column_name` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `Column_priv` set('Select','Insert','Update','References') CHARACTER SET utf8 NOT NULL DEFAULT '',
  PRIMARY KEY (`Host`,`Db`,`User`,`Table_name`,`Column_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Column privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `columns_priv`
--

LOCK TABLES `columns_priv` WRITE;
/*!40000 ALTER TABLE `columns_priv` DISABLE KEYS */;
/*!40000 ALTER TABLE `columns_priv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `db`
--

DROP TABLE IF EXISTS `db`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `db` (
  `Host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Db` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `User` char(16) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Select_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Insert_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Update_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Delete_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Drop_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Grant_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `References_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Index_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Alter_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_tmp_table_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Lock_tables_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_view_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Show_view_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_routine_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Alter_routine_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Execute_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Event_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Trigger_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  PRIMARY KEY (`Host`,`Db`,`User`),
  KEY `User` (`User`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Database privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `db`
--

LOCK TABLES `db` WRITE;
/*!40000 ALTER TABLE `db` DISABLE KEYS */;
/*!40000 ALTER TABLE `db` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `event`
--

DROP TABLE IF EXISTS `event`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `event` (
  `db` char(64) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `name` char(64) NOT NULL DEFAULT '',
  `body` longblob NOT NULL,
  `definer` char(77) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `execute_at` datetime DEFAULT NULL,
  `interval_value` int(11) DEFAULT NULL,
  `interval_field` enum('YEAR','QUARTER','MONTH','DAY','HOUR','MINUTE','WEEK','SECOND','MICROSECOND','YEAR_MONTH','DAY_HOUR','DAY_MINUTE','DAY_SECOND','HOUR_MINUTE','HOUR_SECOND','MINUTE_SECOND','DAY_MICROSECOND','HOUR_MICROSECOND','MINUTE_MICROSECOND','SECOND_MICROSECOND') DEFAULT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `last_executed` datetime DEFAULT NULL,
  `starts` datetime DEFAULT NULL,
  `ends` datetime DEFAULT NULL,
  `status` enum('ENABLED','DISABLED','SLAVESIDE_DISABLED') NOT NULL DEFAULT 'ENABLED',
  `on_completion` enum('DROP','PRESERVE') NOT NULL DEFAULT 'DROP',
  `sql_mode` set('REAL_AS_FLOAT','PIPES_AS_CONCAT','ANSI_QUOTES','IGNORE_SPACE','NOT_USED','ONLY_FULL_GROUP_BY','NO_UNSIGNED_SUBTRACTION','NO_DIR_IN_CREATE','POSTGRESQL','ORACLE','MSSQL','DB2','MAXDB','NO_KEY_OPTIONS','NO_TABLE_OPTIONS','NO_FIELD_OPTIONS','MYSQL323','MYSQL40','ANSI','NO_AUTO_VALUE_ON_ZERO','NO_BACKSLASH_ESCAPES','STRICT_TRANS_TABLES','STRICT_ALL_TABLES','NO_ZERO_IN_DATE','NO_ZERO_DATE','INVALID_DATES','ERROR_FOR_DIVISION_BY_ZERO','TRADITIONAL','NO_AUTO_CREATE_USER','HIGH_NOT_PRECEDENCE','NO_ENGINE_SUBSTITUTION','PAD_CHAR_TO_FULL_LENGTH') NOT NULL DEFAULT '',
  `comment` char(64) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `originator` int(10) unsigned NOT NULL,
  `time_zone` char(64) CHARACTER SET latin1 NOT NULL DEFAULT 'SYSTEM',
  `character_set_client` char(32) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `collation_connection` char(32) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `db_collation` char(32) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `body_utf8` longblob,
  PRIMARY KEY (`db`,`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Events';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `func`
--

DROP TABLE IF EXISTS `func`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `func` (
  `name` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `ret` tinyint(1) NOT NULL DEFAULT '0',
  `dl` char(128) COLLATE utf8_bin NOT NULL DEFAULT '',
  `type` enum('function','aggregate') CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='User defined functions';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `func`
--

LOCK TABLES `func` WRITE;
/*!40000 ALTER TABLE `func` DISABLE KEYS */;
/*!40000 ALTER TABLE `func` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `help_category`
--

DROP TABLE IF EXISTS `help_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `help_category` (
  `help_category_id` smallint(5) unsigned NOT NULL,
  `name` char(64) NOT NULL,
  `parent_category_id` smallint(5) unsigned DEFAULT NULL,
  `url` char(128) NOT NULL,
  PRIMARY KEY (`help_category_id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='help categories';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `help_category`
--

LOCK TABLES `help_category` WRITE;
/*!40000 ALTER TABLE `help_category` DISABLE KEYS */;
INSERT INTO `help_category` VALUES (1,'Geographic',0,''),(2,'Polygon properties',33,''),(3,'WKT',33,''),(4,'Numeric Functions',37,''),(5,'Plugins',34,''),(6,'MBR',33,''),(7,'Control flow functions',37,''),(8,'Transactions',34,''),(9,'Help Metadata',34,''),(10,'Account Management',34,''),(11,'Point properties',33,''),(12,'Encryption Functions',37,''),(13,'LineString properties',33,''),(14,'Logical operators',37,''),(15,'Miscellaneous Functions',37,''),(16,'Functions and Modifiers for Use with GROUP BY',34,''),(17,'Information Functions',37,''),(18,'Comparison operators',37,''),(19,'Bit Functions',37,''),(20,'Table Maintenance',34,''),(21,'User-Defined Functions',34,''),(22,'Data Types',34,''),(23,'Compound Statements',34,''),(24,'Geometry constructors',33,''),(25,'GeometryCollection properties',1,''),(26,'Administration',34,''),(27,'Data Manipulation',34,''),(28,'Utility',34,''),(29,'Language Structure',34,''),(30,'Geometry relations',33,''),(31,'Date and Time Functions',37,''),(32,'WKB',33,''),(33,'Geographic Features',34,''),(34,'Contents',0,''),(35,'Geometry properties',33,''),(36,'String Functions',37,''),(37,'Functions',34,''),(38,'Data Definition',34,'');
/*!40000 ALTER TABLE `help_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `help_keyword`
--

DROP TABLE IF EXISTS `help_keyword`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `help_keyword` (
  `help_keyword_id` int(10) unsigned NOT NULL,
  `name` char(64) NOT NULL,
  PRIMARY KEY (`help_keyword_id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='help keywords';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `help_keyword`
--

LOCK TABLES `help_keyword` WRITE;
/*!40000 ALTER TABLE `help_keyword` DISABLE KEYS */;
INSERT INTO `help_keyword` VALUES (0,'JOIN'),(1,'HOST'),(2,'REPEAT'),(3,'SERIALIZABLE'),(4,'REPLACE'),(5,'AT'),(6,'SCHEDULE'),(7,'RETURNS'),(8,'STARTS'),(9,'MASTER_SSL_CA'),(10,'NCHAR'),(11,'COLUMNS'),(12,'COMPLETION'),(13,'WORK'),(14,'DATETIME'),(15,'MODE'),(16,'OPEN'),(17,'INTEGER'),(18,'ESCAPE'),(19,'VALUE'),(20,'MASTER_SSL_VERIFY_SERVER_CERT'),(21,'SQL_BIG_RESULT'),(22,'DROP'),(23,'GEOMETRYCOLLECTIONFROMWKB'),(24,'EVENTS'),(25,'MONTH'),(26,'PROFILES'),(27,'DUPLICATE'),(28,'REPLICATION'),(29,'UNLOCK'),(30,'INNODB'),(31,'YEAR_MONTH'),(32,'SUBJECT'),(33,'PREPARE'),(34,'LOCK'),(35,'NDB'),(36,'CHECK'),(37,'FULL'),(38,'INT4'),(39,'BY'),(40,'NO'),(41,'MINUTE'),(42,'PARTITION'),(43,'DATA'),(44,'DAY'),(45,'SHARE'),(46,'REAL'),(47,'SEPARATOR'),(48,'MASTER_HEARTBEAT_PERIOD'),(49,'DELETE'),(50,'ON'),(51,'CONNECTION'),(52,'CLOSE'),(53,'X509'),(54,'USE'),(55,'WHERE'),(56,'PRIVILEGES'),(57,'SPATIAL'),(58,'EVENT'),(59,'SUPER'),(60,'SQL_BUFFER_RESULT'),(61,'IGNORE'),(62,'QUICK'),(63,'SIGNED'),(64,'OFFLINE'),(65,'SECURITY'),(66,'AUTOEXTEND_SIZE'),(67,'NDBCLUSTER'),(68,'POLYGONFROMWKB'),(69,'FALSE'),(70,'LEVEL'),(71,'FORCE'),(72,'BINARY'),(73,'TO'),(74,'CHANGE'),(75,'CURRENT_USER'),(76,'HOUR_MINUTE'),(77,'UPDATE'),(78,'PRESERVE'),(79,'INTO'),(80,'FEDERATED'),(81,'VARYING'),(82,'MAX_SIZE'),(83,'HOUR_SECOND'),(84,'VARIABLE'),(85,'ROLLBACK'),(86,'PROCEDURE'),(87,'TIMESTAMP'),(88,'IMPORT'),(89,'AGAINST'),(90,'CHECKSUM'),(91,'COUNT'),(92,'LONGBINARY'),(93,'THEN'),(94,'INSERT'),(95,'ENGINES'),(96,'HANDLER'),(97,'PORT'),(98,'DAY_SECOND'),(99,'EXISTS'),(100,'MUTEX'),(101,'HELP_DATE'),(102,'RELEASE'),(103,'BOOLEAN'),(104,'MOD'),(105,'DEFAULT'),(106,'TYPE'),(107,'NO_WRITE_TO_BINLOG'),(108,'OPTIMIZE'),(109,'RESET'),(110,'INSTALL'),(111,'ITERATE'),(112,'DO'),(113,'BIGINT'),(114,'SET'),(115,'ISSUER'),(116,'DATE'),(117,'STATUS'),(118,'FULLTEXT'),(119,'COMMENT'),(120,'MASTER_CONNECT_RETRY'),(121,'INNER'),(122,'STOP'),(123,'MASTER_LOG_FILE'),(124,'MRG_MYISAM'),(125,'PRECISION'),(126,'REQUIRE'),(127,'TRAILING'),(128,'PARTITIONS'),(129,'LONG'),(130,'OPTION'),(131,'REORGANIZE'),(132,'ELSE'),(133,'DEALLOCATE'),(134,'IO_THREAD'),(135,'CASE'),(136,'CIPHER'),(137,'CONTINUE'),(138,'FROM'),(139,'READ'),(140,'LEFT'),(141,'ELSEIF'),(142,'MINUTE_SECOND'),(143,'COMPACT'),(144,'RESTORE'),(145,'DEC'),(146,'FOR'),(147,'WARNINGS'),(148,'MIN_ROWS'),(149,'STRING'),(150,'CONDITION'),(151,'ENCLOSED'),(152,'FUNCTION'),(153,'AGGREGATE'),(154,'FIELDS'),(155,'INT3'),(156,'ARCHIVE'),(157,'AVG_ROW_LENGTH'),(158,'ADD'),(159,'KILL'),(160,'FLOAT4'),(161,'TABLESPACE'),(162,'VIEW'),(163,'REPEATABLE'),(164,'INFILE'),(165,'HELP_VERSION'),(166,'ORDER'),(167,'USING'),(168,'MIDDLEINT'),(169,'GRANT'),(170,'UNSIGNED'),(171,'DECIMAL'),(172,'GEOMETRYFROMTEXT'),(173,'INDEXES'),(174,'FOREIGN'),(175,'CACHE'),(176,'HOSTS'),(177,'COMMIT'),(178,'SCHEMAS'),(179,'LEADING'),(180,'SNAPSHOT'),(181,'DECLARE'),(182,'LOAD'),(183,'SQL_CACHE'),(184,'CONVERT'),(185,'DYNAMIC'),(186,'COLLATE'),(187,'POLYGONFROMTEXT'),(188,'BYTE'),(189,'GLOBAL'),(190,'LINESTRINGFROMWKB'),(191,'WHEN'),(192,'COLUMN_FORMAT'),(193,'HAVING'),(194,'AS'),(195,'STARTING'),(196,'RELOAD'),(197,'AUTOCOMMIT'),(198,'REVOKE'),(199,'GRANTS'),(200,'OUTER'),(201,'FLOOR'),(202,'EXPLAIN'),(203,'WITH'),(204,'AFTER'),(205,'STD'),(206,'CSV'),(207,'DISABLE'),(208,'UNINSTALL'),(209,'OUTFILE'),(210,'LOW_PRIORITY'),(211,'FILE'),(212,'NODEGROUP'),(213,'SCHEMA'),(214,'SONAME'),(215,'POW'),(216,'DUAL'),(217,'MULTIPOINTFROMWKB'),(218,'INDEX'),(219,'BACKUP'),(220,'MULTIPOINTFROMTEXT'),(221,'DEFINER'),(222,'MASTER_BIND'),(223,'REMOVE'),(224,'EXTENDED'),(225,'MULTILINESTRINGFROMWKB'),(226,'CROSS'),(227,'CONTRIBUTORS'),(228,'NATIONAL'),(229,'GROUP'),(230,'SHA'),(231,'ONLINE'),(232,'UNDO'),(233,'IGNORE_SERVER_IDS'),(234,'ZEROFILL'),(235,'CLIENT'),(236,'MASTER_PASSWORD'),(237,'OWNER'),(238,'RELAY_LOG_FILE'),(239,'TRUE'),(240,'CHARACTER'),(241,'MASTER_USER'),(242,'TABLE'),(243,'ENGINE'),(244,'INSERT_METHOD'),(245,'CASCADE'),(246,'RELAY_LOG_POS'),(247,'SQL_CALC_FOUND_ROWS'),(248,'UNION'),(249,'MYISAM'),(250,'LEAVE'),(251,'MODIFY'),(252,'MATCH'),(253,'MASTER_LOG_POS'),(254,'DISTINCTROW'),(255,'DESC'),(256,'TIME'),(257,'NUMERIC'),(258,'EXPANSION'),(259,'CODE'),(260,'CURSOR'),(261,'GEOMETRYCOLLECTIONFROMTEXT'),(262,'CHAIN'),(263,'LOGFILE'),(264,'FLUSH'),(265,'CREATE'),(266,'DESCRIBE'),(267,'EXTENT_SIZE'),(268,'MAX_UPDATES_PER_HOUR'),(269,'INT2'),(270,'PROCESSLIST'),(271,'ENDS'),(272,'LOGS'),(273,'DISCARD'),(274,'HEAP'),(275,'SOUNDS'),(276,'BETWEEN'),(277,'MULTILINESTRINGFROMTEXT'),(278,'REPAIR'),(279,'PACK_KEYS'),(280,'FAST'),(281,'VALUES'),(282,'CALL'),(283,'LOOP'),(284,'VARCHARACTER'),(285,'BEFORE'),(286,'TRUNCATE'),(287,'SHOW'),(288,'ALL'),(289,'REDUNDANT'),(290,'USER_RESOURCES'),(291,'PARTIAL'),(292,'BINLOG'),(293,'END'),(294,'SECOND'),(295,'AND'),(296,'FLOAT8'),(297,'PREV'),(298,'HOUR'),(299,'SELECT'),(300,'DATABASES'),(301,'OR'),(302,'IDENTIFIED'),(303,'WRAPPER'),(304,'MASTER_SSL_CIPHER'),(305,'SQL_SLAVE_SKIP_COUNTER'),(306,'BOTH'),(307,'BOOL'),(308,'YEAR'),(309,'MASTER_PORT'),(310,'CONCURRENT'),(311,'HELP'),(312,'UNIQUE'),(313,'TRIGGERS'),(314,'PROCESS'),(315,'OPTIONS'),(316,'CONSISTENT'),(317,'MASTER_SSL'),(318,'DATE_ADD'),(319,'MAX_CONNECTIONS_PER_HOUR'),(320,'LIKE'),(321,'PLUGIN'),(322,'FETCH'),(323,'IN'),(324,'COLUMN'),(325,'DUMPFILE'),(326,'USAGE'),(327,'EXECUTE'),(328,'MEMORY'),(329,'CEIL'),(330,'QUERY'),(331,'MASTER_HOST'),(332,'LINES'),(333,'SQL_THREAD'),(334,'SERVER'),(335,'MAX_QUERIES_PER_HOUR'),(336,'MASTER_SSL_CERT'),(337,'MULTIPOLYGONFROMWKB'),(338,'TRANSACTION'),(339,'DAY_MINUTE'),(340,'STDDEV'),(341,'DATE_SUB'),(342,'REBUILD'),(343,'GEOMETRYFROMWKB'),(344,'INT1'),(345,'RENAME'),(346,'PARSER'),(347,'RIGHT'),(348,'ALTER'),(349,'MAX_ROWS'),(350,'SOCKET'),(351,'STRAIGHT_JOIN'),(352,'NATURAL'),(353,'VARIABLES'),(354,'ESCAPED'),(355,'SHA1'),(356,'KEY_BLOCK_SIZE'),(357,'PASSWORD'),(358,'OFFSET'),(359,'CHAR'),(360,'NEXT'),(361,'ERRORS'),(362,'SQL_LOG_BIN'),(363,'TEMPORARY'),(364,'COMMITTED'),(365,'SQL_SMALL_RESULT'),(366,'UPGRADE'),(367,'BEGIN'),(368,'DELAY_KEY_WRITE'),(369,'PROFILE'),(370,'MEDIUM'),(371,'INTERVAL'),(372,'SSL'),(373,'DAY_HOUR'),(374,'NAME'),(375,'REFERENCES'),(376,'AES_ENCRYPT'),(377,'STORAGE'),(378,'ISOLATION'),(379,'CEILING'),(380,'EVERY'),(381,'INT8'),(382,'AUTHORS'),(383,'RESTRICT'),(384,'UNCOMMITTED'),(385,'LINESTRINGFROMTEXT'),(386,'IS'),(387,'NOT'),(388,'ANALYSE'),(389,'DATAFILE'),(390,'DES_KEY_FILE'),(391,'COMPRESSED'),(392,'START'),(393,'PLUGINS'),(394,'SAVEPOINT'),(395,'IF'),(396,'PRIMARY'),(397,'PURGE'),(398,'LAST'),(399,'USER'),(400,'INNOBASE'),(401,'EXIT'),(402,'KEYS'),(403,'LIMIT'),(404,'KEY'),(405,'MERGE'),(406,'UNTIL'),(407,'SQL_NO_CACHE'),(408,'DELAYED'),(409,'ANALYZE'),(410,'CONSTRAINT'),(411,'SERIAL'),(412,'ACTION'),(413,'WRITE'),(414,'INITIAL_SIZE'),(415,'SESSION'),(416,'DATABASE'),(417,'NULL'),(418,'POWER'),(419,'USE_FRM'),(420,'TERMINATED'),(421,'SLAVE'),(422,'NVARCHAR'),(423,'ASC'),(424,'RETURN'),(425,'OPTIONALLY'),(426,'ENABLE'),(427,'DIRECTORY'),(428,'MAX_USER_CONNECTIONS'),(429,'WHILE'),(430,'LOCAL'),(431,'DISTINCT'),(432,'AES_DECRYPT'),(433,'MASTER_SSL_KEY'),(434,'NONE'),(435,'TABLES'),(436,'<>'),(437,'RLIKE'),(438,'TRIGGER'),(439,'COLLATION'),(440,'SHUTDOWN'),(441,'HIGH_PRIORITY'),(442,'BTREE'),(443,'FIRST'),(444,'COALESCE'),(445,'WAIT'),(446,'TYPES'),(447,'MASTER'),(448,'FIXED'),(449,'MULTIPOLYGONFROMTEXT'),(450,'ROW_FORMAT');
/*!40000 ALTER TABLE `help_keyword` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `help_relation`
--

DROP TABLE IF EXISTS `help_relation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `help_relation` (
  `help_topic_id` int(10) unsigned NOT NULL,
  `help_keyword_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`help_keyword_id`,`help_topic_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='keyword-topic relation';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `help_relation`
--

LOCK TABLES `help_relation` WRITE;
/*!40000 ALTER TABLE `help_relation` DISABLE KEYS */;
INSERT INTO `help_relation` VALUES (1,0),(355,0),(472,1),(231,2),(447,3),(3,4),(422,4),(87,5),(87,6),(407,6),(95,7),(87,8),(185,9),(430,10),(21,11),(346,11),(422,11),(462,11),(87,12),(407,12),(144,13),(229,14),(86,15),(355,15),(18,16),(104,16),(132,16),(346,16),(95,17),(499,17),(380,18),(3,19),(102,19),(242,19),(185,20),(355,21),(9,22),(30,22),(34,22),(85,22),(186,22),(236,22),(262,22),(275,22),(299,22),(330,22),(406,22),(416,22),(417,22),(462,22),(477,22),(106,23),(121,24),(168,24),(376,25),(80,26),(102,27),(198,28),(36,29),(346,30),(401,30),(467,30),(376,31),(198,32),(35,33),(236,33),(36,34),(355,34),(467,35),(418,36),(462,36),(467,36),(21,37),(293,37),(346,37),(451,37),(467,37),(499,38),(48,39),(75,39),(81,39),(198,39),(355,39),(362,39),(422,39),(462,39),(467,39),(467,40),(471,40),(376,41),(462,42),(467,42),(118,43),(211,43),(422,43),(467,43),(472,43),(376,44),(355,45),(95,46),(313,46),(362,47),(185,48),(48,49),(467,49),(471,49),(1,50),(87,50),(407,50),(471,50),(174,51),(467,51),(51,52),(104,52),(198,53),(1,54),(55,54),(193,54),(48,55),(81,55),(104,55),(192,56),(198,56),(248,56),(209,57),(462,57),(87,58),(299,58),(357,58),(407,58),(198,59),(355,60),(1,61),(81,61),(102,61),(355,61),(422,61),(462,61),(48,62),(418,62),(465,62),(229,63),(85,64),(209,64),(462,64),(198,65),(193,66),(467,67),(89,68),(481,68),(385,69),(447,70),(1,71),(39,72),(229,72),(268,72),(185,73),(268,73),(459,73),(185,74),(462,74),(87,75),(407,75),(376,76),(81,77),(102,77),(355,77),(471,77),(87,78),(407,78),(3,79),(102,79),(303,79),(355,79),(467,80),(256,81),(193,82),(376,83),(128,84),(144,85),(459,85),(17,86),(184,86),(301,86),(327,86),(346,86),(355,86),(417,86),(439,86),(487,86),(97,87),(188,87),(422,88),(462,88),(86,89),(402,90),(467,90),(67,91),(329,91),(433,91),(284,92),(28,93),(57,93),(83,93),(102,94),(194,94),(300,94),(485,94),(281,95),(346,95),(104,96),(312,96),(472,97),(376,98),(9,99),(30,99),(87,99),(153,99),(186,99),(275,99),(299,99),(346,100),(366,100),(107,101),(144,102),(459,102),(24,103),(86,103),(111,104),(173,104),(3,105),(102,105),(153,105),(199,105),(211,105),(242,105),(462,105),(467,105),(462,106),(113,107),(325,107),(465,107),(469,107),(113,108),(462,108),(38,109),(117,109),(149,109),(263,109),(420,110),(123,111),(87,112),(124,112),(407,112),(495,112),(220,113),(3,114),(81,114),(102,114),(128,114),(144,114),(153,114),(181,114),(211,114),(332,114),(346,114),(355,114),(422,114),(462,114),(467,114),(471,114),(476,114),(493,114),(198,115),(130,116),(229,116),(261,116),(376,116),(58,117),(135,117),(214,117),(222,117),(327,117),(335,117),(346,117),(366,117),(401,117),(209,118),(462,118),(467,118),(87,119),(193,119),(407,119),(467,119),(185,120),(1,121),(52,122),(185,123),(467,124),(313,125),(198,126),(455,127),(254,128),(284,129),(198,130),(248,130),(462,131),(57,132),(83,132),(236,133),(52,134),(323,134),(57,135),(83,135),(198,136),(312,137),(48,138),(118,138),(121,138),(346,138),(355,138),(360,138),(455,138),(36,139),(104,139),(447,139),(1,140),(28,141),(376,142),(467,143),(178,144),(208,145),(179,146),(312,146),(346,146),(355,146),(421,146),(329,147),(346,147),(467,148),(95,149),(179,150),(422,151),(34,152),(66,152),(95,152),(210,152),(232,152),(301,152),(335,152),(346,152),(393,152),(406,152),(417,152),(95,153),(346,154),(422,154),(251,155),(467,156),(462,157),(467,157),(60,158),(193,158),(462,158),(477,158),(174,159),(166,160),(193,161),(416,161),(462,161),(477,161),(30,162),(157,162),(454,162),(447,163),(422,164),(189,165),(48,166),(81,166),(355,166),(362,166),(462,166),(1,167),(48,167),(84,167),(251,168),(198,169),(248,169),(24,170),(127,170),(166,170),(208,170),(229,170),(313,170),(499,170),(95,171),(154,171),(229,171),(412,172),(346,173),(462,174),(467,174),(471,174),(472,174),(99,175),(149,175),(303,175),(143,176),(346,176),(144,177),(158,178),(346,178),(455,179),(144,180),(179,181),(199,181),(312,181),(421,181),(118,182),(303,182),(360,182),(422,182),(355,183),(229,184),(377,184),(467,185),(153,186),(211,186),(467,186),(395,187),(464,188),(128,189),(135,189),(181,189),(348,189),(447,189),(452,190),(57,191),(83,191),(467,192),(355,193),(1,194),(36,194),(355,194),(422,195),(198,196),(144,197),(248,198),(191,199),(346,199),(1,200),(220,201),(254,202),(86,203),(198,203),(209,203),(462,203),(467,203),(462,204),(259,205),(422,206),(467,206),(87,207),(407,207),(462,207),(290,208),(355,209),(3,210),(36,210),(48,210),(81,210),(102,210),(422,210),(198,211),(193,212),(153,213),(186,213),(211,213),(308,213),(346,213),(95,214),(276,215),(278,216),(463,217),(1,218),(60,218),(85,218),(99,218),(209,218),(303,218),(307,218),(346,218),(462,218),(467,218),(358,219),(425,220),(87,221),(407,221),(185,222),(462,223),(254,224),(465,224),(271,225),(1,226),(7,227),(346,227),(256,228),(430,228),(193,229),(225,229),(355,229),(427,230),(85,231),(209,231),(462,231),(312,232),(185,233),(24,234),(127,234),(166,234),(208,234),(313,234),(499,234),(198,235),(185,236),(472,237),(185,238),(385,239),(153,240),(211,240),(256,240),(332,240),(346,240),(355,240),(422,240),(430,240),(467,240),(185,241),(60,242),(108,242),(113,242),(178,242),(214,242),(275,242),(277,242),(320,242),(346,242),(358,242),(360,242),(402,242),(418,242),(462,242),(465,242),(467,242),(469,242),(193,243),(346,243),(366,243),(416,243),(462,243),(467,243),(477,243),(467,244),(30,245),(275,245),(467,245),(471,245),(185,246),(355,247),(304,248),(467,249),(309,250),(462,251),(86,252),(185,253),(355,254),(328,255),(355,255),(362,255),(229,256),(314,256),(375,256),(208,257),(86,258),(66,259),(487,259),(421,260),(245,261),(144,262),(193,263),(225,263),(149,264),(325,264),(17,265),(22,265),(60,265),(75,265),(87,265),(95,265),(153,265),(193,265),(209,265),(210,265),(277,265),(301,265),(308,265),(346,265),(357,265),(393,265),(454,265),(467,265),(472,265),(328,266),(193,267),(198,268),(233,269),(346,270),(451,270),(87,271),(39,272),(268,272),(346,272),(462,273),(467,274),(378,275),(145,276),(105,277),(462,278),(465,278),(467,279),(418,280),(3,281),(102,281),(338,282),(343,283),(256,284),(268,285),(320,286),(7,287),(10,287),(17,287),(21,287),(25,287),(33,287),(39,287),(58,287),(66,287),(67,287),(80,287),(121,287),(132,287),(135,287),(143,287),(158,287),(168,287),(191,287),(192,287),(214,287),(222,287),(277,287),(281,287),(293,287),(307,287),(308,287),(327,287),(329,287),(332,287),(335,287),(346,287),(348,287),(357,287),(366,287),(393,287),(401,287),(451,287),(486,287),(487,287),(491,287),(198,288),(248,288),(304,288),(355,288),(467,289),(325,290),(467,291),(121,292),(349,292),(28,293),(57,293),(83,293),(231,293),(326,293),(343,293),(495,293),(376,294),(145,295),(315,295),(313,296),(104,297),(376,298),(3,299),(102,299),(254,299),(300,299),(355,299),(158,300),(346,300),(139,301),(75,302),(198,302),(472,303),(185,304),(181,305),(455,306),(24,307),(109,307),(376,308),(185,309),(422,310),(116,311),(390,311),(462,312),(25,313),(346,313),(198,314),(374,315),(472,315),(144,316),(185,317),(376,318),(198,319),(346,320),(378,320),(290,321),(346,321),(420,321),(383,322),(86,323),(121,323),(355,323),(462,324),(355,325),(198,326),(84,327),(198,327),(355,328),(397,329),(86,330),(149,330),(174,330),(185,331),(422,332),(52,333),(323,333),(9,334),(374,334),(472,334),(198,335),(185,336),(122,337),(144,338),(447,338),(376,339),(408,340),(376,341),(462,342),(142,343),(24,344),(108,345),(221,345),(407,345),(462,345),(209,346),(462,346),(467,346),(1,347),(60,348),(157,348),(198,348),(211,348),(225,348),(232,348),(374,348),(407,348),(439,348),(462,348),(477,348),(462,349),(467,349),(472,350),(1,351),(355,351),(1,352),(346,353),(348,353),(422,354),(427,355),(467,356),(75,357),(198,357),(472,357),(476,357),(355,358),(229,359),(464,359),(104,360),(67,361),(346,361),(493,362),(275,363),(447,364),(355,365),(211,366),(418,366),(144,367),(326,367),(467,368),(486,369),(418,370),(87,371),(376,371),(198,372),(376,373),(211,374),(198,375),(467,375),(471,375),(443,376),(281,377),(447,378),(448,379),(87,380),(127,381),(10,382),(346,382),(30,383),(275,383),(471,383),(447,384),(56,385),(82,386),(205,386),(369,386),(456,386),(82,387),(87,387),(153,387),(205,387),(311,387),(184,388),(193,389),(477,389),(325,390),(467,391),(144,392),(323,392),(33,393),(459,394),(9,395),(28,395),(30,395),(87,395),(153,395),(186,395),(275,395),(299,395),(478,395),(462,396),(268,397),(104,398),(75,399),(221,399),(330,399),(472,399),(467,400),(312,401),(307,402),(346,402),(462,402),(48,403),(81,403),(104,403),(121,403),(355,403),(60,404),(102,404),(462,404),(467,404),(471,404),(467,405),(231,406),(355,407),(3,408),(102,408),(485,408),(462,409),(469,409),(462,410),(467,410),(242,411),(467,411),(467,412),(471,412),(36,413),(193,414),(477,414),(128,415),(135,415),(348,415),(447,415),(153,416),(186,416),(211,416),(308,416),(346,416),(472,416),(82,417),(369,417),(471,417),(482,418),(465,419),(422,420),(38,421),(52,421),(87,421),(143,421),(222,421),(323,421),(407,421),(256,422),(355,423),(362,423),(490,424),(422,425),(87,426),(407,426),(462,426),(211,427),(467,427),(198,428),(495,429),(36,430),(113,430),(325,430),(422,430),(465,430),(469,430),(0,431),(94,431),(287,431),(304,431),(355,431),(362,431),(384,431),(433,431),(496,432),(185,433),(198,434),(36,435),(132,435),(293,435),(346,435),(494,436),(27,437),(22,438),(262,438),(346,438),(346,439),(491,439),(198,440),(102,441),(355,441),(209,442),(104,443),(462,443),(467,443),(462,444),(193,445),(477,445),(346,446),(39,447),(58,447),(118,447),(185,447),(263,447),(268,447),(360,447),(208,448),(467,448),(200,449),(467,450);
/*!40000 ALTER TABLE `help_relation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `help_topic`
--

DROP TABLE IF EXISTS `help_topic`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `help_topic` (
  `help_topic_id` int(10) unsigned NOT NULL,
  `name` char(64) NOT NULL,
  `help_category_id` smallint(5) unsigned NOT NULL,
  `description` text NOT NULL,
  `example` text NOT NULL,
  `url` char(128) NOT NULL,
  PRIMARY KEY (`help_topic_id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='help topics';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `help_topic`
--

LOCK TABLES `help_topic` WRITE;
/*!40000 ALTER TABLE `help_topic` DISABLE KEYS */;
INSERT INTO `help_topic` VALUES (0,'MIN',16,'Syntax:\nMIN([DISTINCT] expr)\n\nReturns the minimum value of expr. MIN() may take a string argument; in\nsuch cases, it returns the minimum string value. See\nhttp://dev.mysql.com/doc/refman/5.1/en/mysql-indexes.html. The DISTINCT\nkeyword can be used to find the minimum of the distinct values of expr,\nhowever, this produces the same result as omitting DISTINCT.\n\nMIN() returns NULL if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html\n\n','mysql> SELECT student_name, MIN(test_score), MAX(test_score)\n    ->        FROM student\n    ->        GROUP BY student_name;\n','http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html'),(1,'JOIN',27,'MySQL supports the following JOIN syntaxes for the table_references\npart of SELECT statements and multiple-table DELETE and UPDATE\nstatements:\n\ntable_references:\n    table_reference [, table_reference] ...\n\ntable_reference:\n    table_factor\n  | join_table\n\ntable_factor:\n    tbl_name [[AS] alias] [index_hint_list]\n  | table_subquery [AS] alias\n  | ( table_references )\n  | { OJ table_reference LEFT OUTER JOIN table_reference\n        ON conditional_expr }\n\njoin_table:\n    table_reference [INNER | CROSS] JOIN table_factor [join_condition]\n  | table_reference STRAIGHT_JOIN table_factor\n  | table_reference STRAIGHT_JOIN table_factor ON conditional_expr\n  | table_reference {LEFT|RIGHT} [OUTER] JOIN table_reference join_condition\n  | table_reference NATURAL [{LEFT|RIGHT} [OUTER]] JOIN table_factor\n\njoin_condition:\n    ON conditional_expr\n  | USING (column_list)\n\nindex_hint_list:\n    index_hint [, index_hint] ...\n\nindex_hint:\n    USE {INDEX|KEY}\n      [{FOR {JOIN|ORDER BY|GROUP BY}] ([index_list])\n  | IGNORE {INDEX|KEY}\n      [{FOR {JOIN|ORDER BY|GROUP BY}] (index_list)\n  | FORCE {INDEX|KEY}\n      [{FOR {JOIN|ORDER BY|GROUP BY}] (index_list)\n\nindex_list:\n    index_name [, index_name] ...\n\nA table reference is also known as a join expression.\n\nThe syntax of table_factor is extended in comparison with the SQL\nStandard. The latter accepts only table_reference, not a list of them\ninside a pair of parentheses.\n\nThis is a conservative extension if we consider each comma in a list of\ntable_reference items as equivalent to an inner join. For example:\n\nSELECT * FROM t1 LEFT JOIN (t2, t3, t4)\n                 ON (t2.a=t1.a AND t3.b=t1.b AND t4.c=t1.c)\n\nis equivalent to:\n\nSELECT * FROM t1 LEFT JOIN (t2 CROSS JOIN t3 CROSS JOIN t4)\n                 ON (t2.a=t1.a AND t3.b=t1.b AND t4.c=t1.c)\n\nIn MySQL, CROSS JOIN is a syntactic equivalent to INNER JOIN (they can\nreplace each other). In standard SQL, they are not equivalent. INNER\nJOIN is used with an ON clause, CROSS JOIN is used otherwise.\n\nIn general, parentheses can be ignored in join expressions containing\nonly inner join operations. MySQL also supports nested joins (see\nhttp://dev.mysql.com/doc/refman/5.1/en/nested-join-optimization.html).\n\nIndex hints can be specified to affect how the MySQL optimizer makes\nuse of indexes. For more information, see\nhttp://dev.mysql.com/doc/refman/5.1/en/index-hints.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/join.html\n\n','SELECT left_tbl.*\n  FROM left_tbl LEFT JOIN right_tbl ON left_tbl.id = right_tbl.id\n  WHERE right_tbl.id IS NULL;\n','http://dev.mysql.com/doc/refman/5.1/en/join.html'),(2,'HEX',36,'Syntax:\nHEX(str), HEX(N)\n\nFor a string argument str, HEX() returns a hexadecimal string\nrepresentation of str where each character in str is converted to two\nhexadecimal digits. The inverse of this operation is performed by the\nUNHEX() function.\n\nFor a numeric argument N, HEX() returns a hexadecimal string\nrepresentation of the value of N treated as a longlong (BIGINT) number.\nThis is equivalent to CONV(N,10,16). The inverse of this operation is\nperformed by CONV(HEX(N),16,10).\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT 0x616263, HEX(\'abc\'), UNHEX(HEX(\'abc\'));\n        -> \'abc\', 616263, \'abc\'\nmysql> SELECT HEX(255), CONV(HEX(255),16,10);\n        -> \'FF\', 255\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(3,'REPLACE',27,'Syntax:\nREPLACE [LOW_PRIORITY | DELAYED]\n    [INTO] tbl_name [(col_name,...)]\n    {VALUES | VALUE} ({expr | DEFAULT},...),(...),...\n\nOr:\n\nREPLACE [LOW_PRIORITY | DELAYED]\n    [INTO] tbl_name\n    SET col_name={expr | DEFAULT}, ...\n\nOr:\n\nREPLACE [LOW_PRIORITY | DELAYED]\n    [INTO] tbl_name [(col_name,...)]\n    SELECT ...\n\nREPLACE works exactly like INSERT, except that if an old row in the\ntable has the same value as a new row for a PRIMARY KEY or a UNIQUE\nindex, the old row is deleted before the new row is inserted. See [HELP\nINSERT].\n\nREPLACE is a MySQL extension to the SQL standard. It either inserts, or\ndeletes and inserts. For another MySQL extension to standard SQL---that\neither inserts or updates---see\nhttp://dev.mysql.com/doc/refman/5.1/en/insert-on-duplicate.html.\n\nNote that unless the table has a PRIMARY KEY or UNIQUE index, using a\nREPLACE statement makes no sense. It becomes equivalent to INSERT,\nbecause there is no index to be used to determine whether a new row\nduplicates another.\n\nValues for all columns are taken from the values specified in the\nREPLACE statement. Any missing columns are set to their default values,\njust as happens for INSERT. You cannot refer to values from the current\nrow and use them in the new row. If you use an assignment such as SET\ncol_name = col_name + 1, the reference to the column name on the right\nhand side is treated as DEFAULT(col_name), so the assignment is\nequivalent to SET col_name = DEFAULT(col_name) + 1.\n\nTo use REPLACE, you must have both the INSERT and DELETE privileges for\nthe table.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/replace.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/replace.html'),(4,'CONTAINS',30,'Contains(g1,g2)\n\nReturns 1 or 0 to indicate whether g1 completely contains g2. This\ntests the opposite relationship as Within().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-test-spatial-relationships-between-geometries\n\n','','http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-tes'),(5,'SRID',35,'SRID(g)\n\nReturns an integer indicating the Spatial Reference System ID for the\ngeometry value g.\n\nIn MySQL, the SRID value is just an integer associated with the\ngeometry value. All calculations are done assuming Euclidean (planar)\ngeometry.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#general-geometry-property-functions\n\n','mysql> SELECT SRID(GeomFromText(\'LineString(1 1,2 2)\',101));\n+-----------------------------------------------+\n| SRID(GeomFromText(\'LineString(1 1,2 2)\',101)) |\n+-----------------------------------------------+\n|                                           101 |\n+-----------------------------------------------+\n','http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#general-geometry-property-functions'),(6,'CURRENT_TIMESTAMP',31,'Syntax:\nCURRENT_TIMESTAMP, CURRENT_TIMESTAMP()\n\nCURRENT_TIMESTAMP and CURRENT_TIMESTAMP() are synonyms for NOW().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(7,'SHOW CONTRIBUTORS',26,'Syntax:\nSHOW CONTRIBUTORS\n\nThe SHOW CONTRIBUTORS statement displays information about the people\nwho contribute to MySQL source or to causes that we support. For each\ncontributor, it displays Name, Location, and Comment values.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-contributors.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-contributors.html'),(8,'VARIANCE',16,'Syntax:\nVARIANCE(expr)\n\nReturns the population standard variance of expr. This is an extension\nto standard SQL. The standard SQL function VAR_POP() can be used\ninstead.\n\nVARIANCE() returns NULL if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html'),(9,'DROP SERVER',38,'Syntax:\nDROP SERVER [ IF EXISTS ] server_name\n\nDrops the server definition for the server named server_name. The\ncorresponding row within the mysql.servers table will be deleted. This\nstatement requires the SUPER privilege.\n\nDropping a server for a table does not affect any FEDERATED tables that\nused this connection information when they were created. See [HELP\nCREATE SERVER].\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/drop-server.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/drop-server.html'),(10,'SHOW AUTHORS',26,'Syntax:\nSHOW AUTHORS\n\nThe SHOW AUTHORS statement displays information about the people who\nwork on MySQL. For each author, it displays Name, Location, and Comment\nvalues.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-authors.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-authors.html'),(11,'VAR_SAMP',16,'Syntax:\nVAR_SAMP(expr)\n\nReturns the sample variance of expr. That is, the denominator is the\nnumber of rows minus one.\n\nVAR_SAMP() returns NULL if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html'),(12,'CONCAT',36,'Syntax:\nCONCAT(str1,str2,...)\n\nReturns the string that results from concatenating the arguments. May\nhave one or more arguments. If all arguments are nonbinary strings, the\nresult is a nonbinary string. If the arguments include any binary\nstrings, the result is a binary string. A numeric argument is converted\nto its equivalent binary string form; if you want to avoid that, you\ncan use an explicit type cast, as in this example:\n\nSELECT CONCAT(CAST(int_col AS CHAR), char_col);\n\nCONCAT() returns NULL if any argument is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT CONCAT(\'My\', \'S\', \'QL\');\n        -> \'MySQL\'\nmysql> SELECT CONCAT(\'My\', NULL, \'QL\');\n        -> NULL\nmysql> SELECT CONCAT(14.3);\n        -> \'14.3\'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(13,'GEOMETRY HIERARCHY',33,'Geometry is the base class. It is an abstract class. The instantiable\nsubclasses of Geometry are restricted to zero-, one-, and\ntwo-dimensional geometric objects that exist in two-dimensional\ncoordinate space. All instantiable geometry classes are defined so that\nvalid instances of a geometry class are topologically closed (that is,\nall defined geometries include their boundary).\n\nThe base Geometry class has subclasses for Point, Curve, Surface, and\nGeometryCollection:\n\no Point represents zero-dimensional objects.\n\no Curve represents one-dimensional objects, and has subclass\n  LineString, with sub-subclasses Line and LinearRing.\n\no Surface is designed for two-dimensional objects and has subclass\n  Polygon.\n\no GeometryCollection has specialized zero-, one-, and two-dimensional\n  collection classes named MultiPoint, MultiLineString, and\n  MultiPolygon for modeling geometries corresponding to collections of\n  Points, LineStrings, and Polygons, respectively. MultiCurve and\n  MultiSurface are introduced as abstract superclasses that generalize\n  the collection interfaces to handle Curves and Surfaces.\n\nGeometry, Curve, Surface, MultiCurve, and MultiSurface are defined as\nnoninstantiable classes. They define a common set of methods for their\nsubclasses and are included for extensibility.\n\nPoint, LineString, Polygon, GeometryCollection, MultiPoint,\nMultiLineString, and MultiPolygon are instantiable classes.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/gis-geometry-class-hierarchy.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/gis-geometry-class-hierarchy.html'),(14,'CHAR FUNCTION',36,'Syntax:\nCHAR(N,... [USING charset_name])\n\nCHAR() interprets each argument N as an integer and returns a string\nconsisting of the characters given by the code values of those\nintegers. NULL values are skipped.\nBy default, CHAR() returns a binary string. To produce a string in a\ngiven character set, use the optional USING clause:\n\nmysql> SELECT CHARSET(CHAR(0x65)), CHARSET(CHAR(0x65 USING utf8));\n+---------------------+--------------------------------+\n| CHARSET(CHAR(0x65)) | CHARSET(CHAR(0x65 USING utf8)) |\n+---------------------+--------------------------------+\n| binary              | utf8                           |\n+---------------------+--------------------------------+\n\nIf USING is given and the result string is illegal for the given\ncharacter set, a warning is issued. Also, if strict SQL mode is\nenabled, the result from CHAR() becomes NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT CHAR(77,121,83,81,\'76\');\n        -> \'MySQL\'\nmysql> SELECT CHAR(77,77.3,\'77.3\');\n        -> \'MMM\'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(15,'DATETIME',22,'DATETIME\n\nA date and time combination. The supported range is \'1000-01-01\n00:00:00\' to \'9999-12-31 23:59:59\'. MySQL displays DATETIME values in\n\'YYYY-MM-DD HH:MM:SS\' format, but permits assignment of values to\nDATETIME columns using either strings or numbers.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-type-overview.html'),(16,'SHOW CREATE TRIGGER',26,'Syntax:\nSHOW CREATE TRIGGER trigger_name\n\nThis statement shows a CREATE TRIGGER statement that creates the given\ntrigger.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-create-trigger.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-create-trigger.html'),(17,'SHOW CREATE PROCEDURE',26,'Syntax:\nSHOW CREATE PROCEDURE proc_name\n\nThis statement is a MySQL extension. It returns the exact string that\ncan be used to re-create the named stored procedure. A similar\nstatement, SHOW CREATE FUNCTION, displays information about stored\nfunctions (see [HELP SHOW CREATE FUNCTION]).\n\nBoth statements require that you be the owner of the routine or have\nSELECT access to the mysql.proc table. If you do not have privileges\nfor the routine itself, the value displayed for the Create Procedure or\nCreate Function field will be NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-create-procedure.html\n\n','mysql> SHOW CREATE PROCEDURE test.simpleproc\\G\n*************************** 1. row ***************************\n           Procedure: simpleproc\n            sql_mode:\n    Create Procedure: CREATE PROCEDURE `simpleproc`(OUT param1 INT)\n                      BEGIN\n                      SELECT COUNT(*) INTO param1 FROM t;\n                      END\ncharacter_set_client: latin1\ncollation_connection: latin1_swedish_ci\n  Database Collation: latin1_swedish_ci\n\nmysql> SHOW CREATE FUNCTION test.hello\\G\n*************************** 1. row ***************************\n            Function: hello\n            sql_mode:\n     Create Function: CREATE FUNCTION `hello`(s CHAR(20))\n                      RETURNS CHAR(50)\n                      RETURN CONCAT(\'Hello, \',s,\'!\')\ncharacter_set_client: latin1\ncollation_connection: latin1_swedish_ci\n  Database Collation: latin1_swedish_ci\n','http://dev.mysql.com/doc/refman/5.1/en/show-create-procedure.html'),(18,'OPEN',23,'Syntax:\nOPEN cursor_name\n\nThis statement opens a previously declared cursor. For an example, see\nhttp://dev.mysql.com/doc/refman/5.1/en/cursors.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/open.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/open.html'),(19,'INTEGER',22,'INTEGER[(M)] [UNSIGNED] [ZEROFILL]\n\nThis type is a synonym for INT.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html'),(20,'LOWER',36,'Syntax:\nLOWER(str)\n\nReturns the string str with all characters changed to lowercase\naccording to the current character set mapping. The default is latin1\n(cp1252 West European).\n\nmysql> SELECT LOWER(\'QUADRATICALLY\');\n        -> \'quadratically\'\n\nLOWER() (and UPPER()) are ineffective when applied to binary strings\n(BINARY, VARBINARY, BLOB). To perform lettercase conversion, convert\nthe string to a nonbinary string:\n\nmysql> SET @str = BINARY \'New York\';\nmysql> SELECT LOWER(@str), LOWER(CONVERT(@str USING latin1));\n+-------------+-----------------------------------+\n| LOWER(@str) | LOWER(CONVERT(@str USING latin1)) |\n+-------------+-----------------------------------+\n| New York    | new york                          |\n+-------------+-----------------------------------+\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(21,'SHOW COLUMNS',26,'Syntax:\nSHOW [FULL] COLUMNS {FROM | IN} tbl_name [{FROM | IN} db_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW COLUMNS displays information about the columns in a given table.\nIt also works for views. The LIKE clause, if present, indicates which\ncolumn names to match. The WHERE clause can be given to select rows\nusing more general conditions, as discussed in\nhttp://dev.mysql.com/doc/refman/5.1/en/extended-show.html.\n\nmysql> SHOW COLUMNS FROM City;\n+------------+----------+------+-----+---------+----------------+\n| Field      | Type     | Null | Key | Default | Extra          |\n+------------+----------+------+-----+---------+----------------+\n| Id         | int(11)  | NO   | PRI | NULL    | auto_increment |\n| Name       | char(35) | NO   |     |         |                |\n| Country    | char(3)  | NO   | UNI |         |                |\n| District   | char(20) | YES  | MUL |         |                |\n| Population | int(11)  | NO   |     | 0       |                |\n+------------+----------+------+-----+---------+----------------+\n5 rows in set (0.00 sec)\n\nIf the data types differ from what you expect them to be based on a\nCREATE TABLE statement, note that MySQL sometimes changes data types\nwhen you create or alter a table. The conditions under which this\noccurs are described in\nhttp://dev.mysql.com/doc/refman/5.1/en/silent-column-changes.html.\n\nThe FULL keyword causes the output to include the column collation and\ncomments, as well as the privileges you have for each column.\n\nYou can use db_name.tbl_name as an alternative to the tbl_name FROM\ndb_name syntax. In other words, these two statements are equivalent:\n\nmysql> SHOW COLUMNS FROM mytable FROM mydb;\nmysql> SHOW COLUMNS FROM mydb.mytable;\n\nSHOW COLUMNS displays the following values for each table column:\n\nField indicates the column name.\n\nType indicates the column data type.\n\nCollation indicates the collation for nonbinary string columns, or NULL\nfor other columns. This value is displayed only if you use the FULL\nkeyword.\n\nThe Null field contains YES if NULL values can be stored in the column,\nNO if not.\n\nThe Key field indicates whether the column is indexed:\n\no If Key is empty, the column either is not indexed or is indexed only\n  as a secondary column in a multiple-column, nonunique index.\n\no If Key is PRI, the column is a PRIMARY KEY or is one of the columns\n  in a multiple-column PRIMARY KEY.\n\no If Key is UNI, the column is the first column of a UNIQUE index. (A\n  UNIQUE index permits multiple NULL values, but you can tell whether\n  the column permits NULL by checking the Null field.)\n\no If Key is MUL, the column is the first column of a nonunique index in\n  which multiple occurrences of a given value are permitted within the\n  column.\n\nIf more than one of the Key values applies to a given column of a\ntable, Key displays the one with the highest priority, in the order\nPRI, UNI, MUL.\n\nA UNIQUE index may be displayed as PRI if it cannot contain NULL values\nand there is no PRIMARY KEY in the table. A UNIQUE index may display as\nMUL if several columns form a composite UNIQUE index; although the\ncombination of the columns is unique, each column can still hold\nmultiple occurrences of a given value.\n\nThe Default field indicates the default value that is assigned to the\ncolumn.\n\nThe Extra field contains any additional information that is available\nabout a given column. The value is nonempty in these cases:\nauto_increment for columns that have the AUTO_INCREMENT attribute; as\nof MySQL 5.1.23, on update CURRENT_TIMESTAMP for TIMESTAMP columns that\nhave the ON UPDATE CURRENT_TIMESTAMP attribute.\n\nPrivileges indicates the privileges you have for the column. This value\nis displayed only if you use the FULL keyword.\n\nComment indicates any comment the column has. This value is displayed\nonly if you use the FULL keyword.\n\nSHOW FIELDS is a synonym for SHOW COLUMNS. You can also list a table\'s\ncolumns with the mysqlshow db_name tbl_name command.\n\nThe DESCRIBE statement provides information similar to SHOW COLUMNS.\nSee [HELP DESCRIBE].\n\nThe SHOW CREATE TABLE, SHOW TABLE STATUS, and SHOW INDEX statements\nalso provide information about tables. See [HELP SHOW].\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-columns.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-columns.html'),(22,'CREATE TRIGGER',38,'Syntax:\nCREATE\n    [DEFINER = { user | CURRENT_USER }]\n    TRIGGER trigger_name trigger_time trigger_event\n    ON tbl_name FOR EACH ROW trigger_body\n\nThis statement creates a new trigger. A trigger is a named database\nobject that is associated with a table, and that activates when a\nparticular event occurs for the table. The trigger becomes associated\nwith the table named tbl_name, which must refer to a permanent table.\nYou cannot associate a trigger with a TEMPORARY table or a view.\n\nCREATE TRIGGER requires the TRIGGER privilege for the table associated\nwith the trigger. The statement might also require the SUPER privilege,\ndepending on the DEFINER value, as described later in this section. If\nbinary logging is enabled, CREATE TRIGGER might require the SUPER\nprivilege, as described in\nhttp://dev.mysql.com/doc/refman/5.1/en/stored-programs-logging.html.\n(Before MySQL 5.1.6, there is no TRIGGER privilege and this statement\nrequires the SUPER privilege in all cases.)\n\nThe DEFINER clause determines the security context to be used when\nchecking access privileges at trigger activation time. See later in\nthis section for more information.\n\ntrigger_time is the trigger action time. It can be BEFORE or AFTER to\nindicate that the trigger activates before or after each row to be\nmodified.\n\ntrigger_event indicates the kind of statement that activates the\ntrigger. The trigger_event can be one of the following:\n\no INSERT: The trigger is activated whenever a new row is inserted into\n  the table; for example, through INSERT, LOAD DATA, and REPLACE\n  statements.\n\no UPDATE: The trigger is activated whenever a row is modified; for\n  example, through UPDATE statements.\n\no DELETE: The trigger is activated whenever a row is deleted from the\n  table; for example, through DELETE and REPLACE statements. However,\n  DROP TABLE and TRUNCATE TABLE statements on the table do not activate\n  this trigger, because they do not use DELETE. Dropping a partition\n  does not activate DELETE triggers, either. See [HELP TRUNCATE TABLE].\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/create-trigger.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/create-trigger.html'),(23,'MONTH',31,'Syntax:\nMONTH(date)\n\nReturns the month for date, in the range 1 to 12 for January to\nDecember, or 0 for dates such as \'0000-00-00\' or \'2008-00-00\' that have\na zero month part.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT MONTH(\'2008-02-03\');\n        -> 2\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(24,'TINYINT',22,'TINYINT[(M)] [UNSIGNED] [ZEROFILL]\n\nA very small integer. The signed range is -128 to 127. The unsigned\nrange is 0 to 255.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html'),(25,'SHOW TRIGGERS',26,'Syntax:\nSHOW TRIGGERS [{FROM | IN} db_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW TRIGGERS lists the triggers currently defined for tables in a\ndatabase (the default database unless a FROM clause is given). This\nstatement returns results only for databases and tables for which you\nhave the TRIGGER privilege, or (prior to MySQL 5.1.23) if you have the\nSUPER privilege). The LIKE clause, if present, indicates which table\nnames to match and causes the statement to display triggers for those\ntables. The WHERE clause can be given to select rows using more general\nconditions, as discussed in\nhttp://dev.mysql.com/doc/refman/5.1/en/extended-show.html.\n\nFor the trigger ins_sum as defined in\nhttp://dev.mysql.com/doc/refman/5.1/en/triggers.html, the output of\nthis statement is as shown here:\n\nmysql> SHOW TRIGGERS LIKE \'acc%\'\\G\n*************************** 1. row ***************************\n             Trigger: ins_sum\n               Event: INSERT\n               Table: account\n           Statement: SET @sum = @sum + NEW.amount\n              Timing: BEFORE\n             Created: NULL\n            sql_mode:\n             Definer: myname@localhost\ncharacter_set_client: latin1\ncollation_connection: latin1_swedish_ci\n  Database Collation: latin1_swedish_ci\n\ncharacter_set_client is the session value of the character_set_client\nsystem variable when the trigger was created. collation_connection is\nthe session value of the collation_connection system variable when the\ntrigger was created. Database Collation is the collation of the\ndatabase with which the trigger is associated. These columns were added\nin MySQL 5.1.21.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-triggers.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-triggers.html'),(26,'MASTER_POS_WAIT',15,'Syntax:\nMASTER_POS_WAIT(log_name,log_pos[,timeout])\n\nThis function is useful for control of master/slave synchronization. It\nblocks until the slave has read and applied all updates up to the\nspecified position in the master log. The return value is the number of\nlog events the slave had to wait for to advance to the specified\nposition. The function returns NULL if the slave SQL thread is not\nstarted, the slave\'s master information is not initialized, the\narguments are incorrect, or an error occurs. It returns -1 if the\ntimeout has been exceeded. If the slave SQL thread stops while\nMASTER_POS_WAIT() is waiting, the function returns NULL. If the slave\nis past the specified position, the function returns immediately.\n\nIf a timeout value is specified, MASTER_POS_WAIT() stops waiting when\ntimeout seconds have elapsed. timeout must be greater than 0; a zero or\nnegative timeout means no timeout.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html'),(27,'REGEXP',36,'Syntax:\nexpr REGEXP pat, expr RLIKE pat\n\nPerforms a pattern match of a string expression expr against a pattern\npat. The pattern can be an extended regular expression. The syntax for\nregular expressions is discussed in\nhttp://dev.mysql.com/doc/refman/5.1/en/regexp.html. Returns 1 if expr\nmatches pat; otherwise it returns 0. If either expr or pat is NULL, the\nresult is NULL. RLIKE is a synonym for REGEXP, provided for mSQL\ncompatibility.\n\nThe pattern need not be a literal string. For example, it can be\nspecified as a string expression or table column.\n\n*Note*: Because MySQL uses the C escape syntax in strings (for example,\n\"\\n\" to represent the newline character), you must double any \"\\\" that\nyou use in your REGEXP strings.\n\nREGEXP is not case sensitive, except when used with binary strings.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/regexp.html\n\n','mysql> SELECT \'Monty!\' REGEXP \'.*\';\n        -> 1\nmysql> SELECT \'new*\\n*line\' REGEXP \'new\\\\*.\\\\*line\';\n        -> 1\nmysql> SELECT \'a\' REGEXP \'A\', \'a\' REGEXP BINARY \'A\';\n        -> 1  0\nmysql> SELECT \'a\' REGEXP \'^[a-d]\';\n        -> 1\n','http://dev.mysql.com/doc/refman/5.1/en/regexp.html'),(28,'IF STATEMENT',23,'Syntax:\nIF search_condition THEN statement_list\n    [ELSEIF search_condition THEN statement_list] ...\n    [ELSE statement_list]\nEND IF\n\nThe IF statement for stored programs implements a basic conditional\nconstruct.\n\n*Note*: There is also an IF() function, which differs from the IF\nstatement described here. See\nhttp://dev.mysql.com/doc/refman/5.1/en/control-flow-functions.html. The\nIF statement can have THEN, ELSE, and ELSEIF clauses, and it is\nterminated with END IF.\n\nIf the search_condition evaluates to true, the corresponding THEN or\nELSEIF clause statement_list executes. If no search_condition matches,\nthe ELSE clause statement_list executes.\n\nEach statement_list consists of one or more SQL statements; an empty\nstatement_list is not permitted.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/if-statement.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/if-statement.html'),(29,'^',19,'Syntax:\n^\n\nBitwise XOR:\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/bit-functions.html\n\n','mysql> SELECT 1 ^ 1;\n        -> 0\nmysql> SELECT 1 ^ 0;\n        -> 1\nmysql> SELECT 11 ^ 3;\n        -> 8\n','http://dev.mysql.com/doc/refman/5.1/en/bit-functions.html'),(30,'DROP VIEW',38,'Syntax:\nDROP VIEW [IF EXISTS]\n    view_name [, view_name] ...\n    [RESTRICT | CASCADE]\n\nDROP VIEW removes one or more views. You must have the DROP privilege\nfor each view. If any of the views named in the argument list do not\nexist, MySQL returns an error indicating by name which nonexisting\nviews it was unable to drop, but it also drops all of the views in the\nlist that do exist.\n\nThe IF EXISTS clause prevents an error from occurring for views that\ndon\'t exist. When this clause is given, a NOTE is generated for each\nnonexistent view. See [HELP SHOW WARNINGS].\n\nRESTRICT and CASCADE, if given, are parsed and ignored.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/drop-view.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/drop-view.html'),(31,'WITHIN',30,'Within(g1,g2)\n\nReturns 1 or 0 to indicate whether g1 is spatially within g2. This\ntests the opposite relationship as Contains().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-test-spatial-relationships-between-geometries\n\n','','http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-tes'),(32,'WEEK',31,'Syntax:\nWEEK(date[,mode])\n\nThis function returns the week number for date. The two-argument form\nof WEEK() enables you to specify whether the week starts on Sunday or\nMonday and whether the return value should be in the range from 0 to 53\nor from 1 to 53. If the mode argument is omitted, the value of the\ndefault_week_format system variable is used. See\nhttp://dev.mysql.com/doc/refman/5.1/en/server-system-variables.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT WEEK(\'2008-02-20\');\n        -> 7\nmysql> SELECT WEEK(\'2008-02-20\',0);\n        -> 7\nmysql> SELECT WEEK(\'2008-02-20\',1);\n        -> 8\nmysql> SELECT WEEK(\'2008-12-31\',1);\n        -> 53\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(33,'SHOW PLUGINS',26,'Syntax:\nSHOW PLUGINS\n\nSHOW PLUGINS displays information about server plugins. Plugin\ninformation is also available in the INFORMATION_SCHEMA.PLUGINS table.\nSee http://dev.mysql.com/doc/refman/5.1/en/plugins-table.html.\n\nExample of SHOW PLUGINS output:\n\nmysql> SHOW PLUGINS\\G\n*************************** 1. row ***************************\n   Name: binlog\n Status: ACTIVE\n   Type: STORAGE ENGINE\nLibrary: NULL\nLicense: GPL\n*************************** 2. row ***************************\n   Name: CSV\n Status: ACTIVE\n   Type: STORAGE ENGINE\nLibrary: NULL\nLicense: GPL\n*************************** 3. row ***************************\n   Name: MEMORY\n Status: ACTIVE\n   Type: STORAGE ENGINE\nLibrary: NULL\nLicense: GPL\n*************************** 4. row ***************************\n   Name: MyISAM\n Status: ACTIVE\n   Type: STORAGE ENGINE\nLibrary: NULL\nLicense: GPL\n...\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-plugins.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-plugins.html'),(34,'DROP FUNCTION UDF',21,'Syntax:\nDROP FUNCTION function_name\n\nThis statement drops the user-defined function (UDF) named\nfunction_name.\n\nTo drop a function, you must have the DELETE privilege for the mysql\ndatabase. This is because DROP FUNCTION removes a row from the\nmysql.func system table that records the function\'s name, type, and\nshared library name.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/drop-function-udf.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/drop-function-udf.html'),(35,'PREPARE',8,'Syntax:\nPREPARE stmt_name FROM preparable_stmt\n\nThe PREPARE statement prepares a statement and assigns it a name,\nstmt_name, by which to refer to the statement later. Statement names\nare not case sensitive. preparable_stmt is either a string literal or a\nuser variable that contains the text of the statement. The text must\nrepresent a single SQL statement, not multiple statements. Within the\nstatement, \"?\" characters can be used as parameter markers to indicate\nwhere data values are to be bound to the query later when you execute\nit. The \"?\" characters should not be enclosed within quotation marks,\neven if you intend to bind them to string values. Parameter markers can\nbe used only where data values should appear, not for SQL keywords,\nidentifiers, and so forth.\n\nIf a prepared statement with the given name already exists, it is\ndeallocated implicitly before the new statement is prepared. This means\nthat if the new statement contains an error and cannot be prepared, an\nerror is returned and no statement with the given name exists.\n\nA prepared statement is executed with EXECUTE and released with\nDEALLOCATE PREPARE.\n\nThe scope of a prepared statement is the session within which it is\ncreated. Other sessions cannot see it.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/prepare.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/prepare.html'),(36,'LOCK',8,'Syntax:\nLOCK TABLES\n    tbl_name [[AS] alias] lock_type\n    [, tbl_name [[AS] alias] lock_type] ...\n\nlock_type:\n    READ [LOCAL]\n  | [LOW_PRIORITY] WRITE\n\nUNLOCK TABLES\n\nMySQL enables client sessions to acquire table locks explicitly for the\npurpose of cooperating with other sessions for access to tables, or to\nprevent other sessions from modifying tables during periods when a\nsession requires exclusive access to them. A session can acquire or\nrelease locks only for itself. One session cannot acquire locks for\nanother session or release locks held by another session.\n\nLocks may be used to emulate transactions or to get more speed when\nupdating tables. This is explained in more detail later in this\nsection.\n\nLOCK TABLES explicitly acquires table locks for the current client\nsession. Table locks can be acquired for base tables or views. You must\nhave the LOCK TABLES privilege, and the SELECT privilege for each\nobject to be locked.\n\nFor view locking, LOCK TABLES adds all base tables used in the view to\nthe set of tables to be locked and locks them automatically. If you\nlock a table explicitly with LOCK TABLES, any tables used in triggers\nare also locked implicitly, as described in\nhttp://dev.mysql.com/doc/refman/5.1/en/lock-tables-and-triggers.html.\n\nUNLOCK TABLES explicitly releases any table locks held by the current\nsession.\n\nAnother use for UNLOCK TABLES is to release the global read lock\nacquired with the FLUSH TABLES WITH READ LOCK statement, which enables\nyou to lock all tables in all databases. See [HELP FLUSH]. (This is a\nvery convenient way to get backups if you have a file system such as\nVeritas that can take snapshots in time.)\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/lock-tables.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/lock-tables.html'),(37,'UPDATEXML',36,'Syntax:\nUpdateXML(xml_target, xpath_expr, new_xml)\n\nThis function replaces a single portion of a given fragment of XML\nmarkup xml_target with a new XML fragment new_xml, and then returns the\nchanged XML. The portion of xml_target that is replaced matches an\nXPath expression xpath_expr supplied by the user. If no expression\nmatching xpath_expr is found, or if multiple matches are found, the\nfunction returns the original xml_target XML fragment. All three\narguments should be strings.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/xml-functions.html\n\n','mysql> SELECT\n    ->   UpdateXML(\'<a><b>ccc</b><d></d></a>\', \'/a\', \'<e>fff</e>\') AS val1,\n    ->   UpdateXML(\'<a><b>ccc</b><d></d></a>\', \'/b\', \'<e>fff</e>\') AS val2,\n    ->   UpdateXML(\'<a><b>ccc</b><d></d></a>\', \'//b\', \'<e>fff</e>\') AS val3,\n    ->   UpdateXML(\'<a><b>ccc</b><d></d></a>\', \'/a/d\', \'<e>fff</e>\') AS val4,\n    ->   UpdateXML(\'<a><d></d><b>ccc</b><d></d></a>\', \'/a/d\', \'<e>fff</e>\') AS val5\n    -> \\G\n\n*************************** 1. row ***************************\nval1: <e>fff</e>\nval2: <a><b>ccc</b><d></d></a>\nval3: <a><e>fff</e><d></d></a>\nval4: <a><b>ccc</b><e>fff</e></a>\nval5: <a><d></d><b>ccc</b><d></d></a>\n','http://dev.mysql.com/doc/refman/5.1/en/xml-functions.html'),(38,'RESET SLAVE',8,'Syntax:\nRESET SLAVE\n\nRESET SLAVE makes the slave forget its replication position in the\nmaster\'s binary log. This statement is meant to be used for a clean\nstart: It deletes the master.info and relay-log.info files, all the\nrelay log files, and starts a new relay log file. To use RESET SLAVE,\nthe slave replication threads must be stopped (use STOP SLAVE if\nnecessary).\n\n*Note*: All relay log files are deleted, even if they have not been\ncompletely executed by the slave SQL thread. (This is a condition\nlikely to exist on a replication slave if you have issued a STOP SLAVE\nstatement or if the slave is highly loaded.)\n\nIf any startup options for setting connection parameters (such as\nmaster host, master port, master user, and master password) are in use,\nthen any corresponding connection information stored in the master.info\nfile is immediately reset using the values specified for these options.\nHowever, since these options are deprecated in MySQL 5.1 and removed\naltogether from MySQL 5.5, you are encouraged to use a CHANGE MASTER TO\nstatement instead to reset the connection parameters. (If you do not\nuse the startup options, you must issue CHANGE MASTER TO in such cases\nif you do not want the connection settings to be cleared.)\n\nIf the slave SQL thread was in the middle of replicating temporary\ntables when it was stopped, and RESET SLAVE is issued, these replicated\ntemporary tables are deleted on the slave.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/reset-slave.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/reset-slave.html'),(39,'SHOW BINARY LOGS',26,'Syntax:\nSHOW BINARY LOGS\nSHOW MASTER LOGS\n\nLists the binary log files on the server. This statement is used as\npart of the procedure described in [HELP PURGE BINARY LOGS], that shows\nhow to determine which logs can be purged.\n\nmysql> SHOW BINARY LOGS;\n+---------------+-----------+\n| Log_name      | File_size |\n+---------------+-----------+\n| binlog.000015 |    724935 |\n| binlog.000016 |    733481 |\n+---------------+-----------+\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-binary-logs.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-binary-logs.html'),(40,'POLYGON',24,'Polygon(ls1,ls2,...)\n\nConstructs a Polygon value from a number of LineString or WKB\nLineString arguments. If any argument does not represent a LinearRing\n(that is, not a closed and simple LineString), the return value is\nNULL.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-mysql-specific-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-mysql-specific-functions'),(41,'MINUTE',31,'Syntax:\nMINUTE(time)\n\nReturns the minute for time, in the range 0 to 59.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT MINUTE(\'2008-02-03 10:05:03\');\n        -> 5\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(42,'DAY',31,'Syntax:\nDAY(date)\n\nDAY() is a synonym for DAYOFMONTH().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(43,'MID',36,'Syntax:\nMID(str,pos,len)\n\nMID(str,pos,len) is a synonym for SUBSTRING(str,pos,len).\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(44,'UUID',15,'Syntax:\nUUID()\n\nReturns a Universal Unique Identifier (UUID) generated according to\n\"DCE 1.1: Remote Procedure Call\" (Appendix A) CAE (Common Applications\nEnvironment) Specifications published by The Open Group in October 1997\n(Document Number C706,\nhttp://www.opengroup.org/public/pubs/catalog/c706.htm).\n\nA UUID is designed as a number that is globally unique in space and\ntime. Two calls to UUID() are expected to generate two different\nvalues, even if these calls are performed on two separate computers\nthat are not connected to each other.\n\nA UUID is a 128-bit number represented by a utf8 string of five\nhexadecimal numbers in aaaaaaaa-bbbb-cccc-dddd-eeeeeeeeeeee format:\n\no The first three numbers are generated from a timestamp.\n\no The fourth number preserves temporal uniqueness in case the timestamp\n  value loses monotonicity (for example, due to daylight saving time).\n\no The fifth number is an IEEE 802 node number that provides spatial\n  uniqueness. A random number is substituted if the latter is not\n  available (for example, because the host computer has no Ethernet\n  card, or we do not know how to find the hardware address of an\n  interface on your operating system). In this case, spatial uniqueness\n  cannot be guaranteed. Nevertheless, a collision should have very low\n  probability.\n\n  Currently, the MAC address of an interface is taken into account only\n  on FreeBSD and Linux. On other operating systems, MySQL uses a\n  randomly generated 48-bit number.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html\n\n','mysql> SELECT UUID();\n        -> \'6ccd780c-baba-1026-9564-0040f4311e29\'\n','http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html'),(45,'LINESTRING',24,'LineString(pt1,pt2,...)\n\nConstructs a LineString value from a number of Point or WKB Point\narguments. If the number of arguments is less than two, the return\nvalue is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-mysql-specific-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-mysql-specific-functions'),(46,'SLEEP',15,'Syntax:\nSLEEP(duration)\n\nSleeps (pauses) for the number of seconds given by the duration\nargument, then returns 0. If SLEEP() is interrupted, it returns 1. The\nduration may have a fractional part given in microseconds.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html'),(47,'CONNECTION_ID',17,'Syntax:\nCONNECTION_ID()\n\nReturns the connection ID (thread ID) for the connection. Every\nconnection has an ID that is unique among the set of currently\nconnected clients.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/information-functions.html\n\n','mysql> SELECT CONNECTION_ID();\n        -> 23786\n','http://dev.mysql.com/doc/refman/5.1/en/information-functions.html'),(48,'DELETE',27,'Syntax:\nSingle-table syntax:\n\nDELETE [LOW_PRIORITY] [QUICK] [IGNORE] FROM tbl_name\n    [WHERE where_condition]\n    [ORDER BY ...]\n    [LIMIT row_count]\n\nMultiple-table syntax:\n\nDELETE [LOW_PRIORITY] [QUICK] [IGNORE]\n    tbl_name[.*] [, tbl_name[.*]] ...\n    FROM table_references\n    [WHERE where_condition]\n\nOr:\n\nDELETE [LOW_PRIORITY] [QUICK] [IGNORE]\n    FROM tbl_name[.*] [, tbl_name[.*]] ...\n    USING table_references\n    [WHERE where_condition]\n\nFor the single-table syntax, the DELETE statement deletes rows from\ntbl_name and returns a count of the number of deleted rows. This count\ncan be obtained by calling the ROW_COUNT() function (see\nhttp://dev.mysql.com/doc/refman/5.1/en/information-functions.html). The\nWHERE clause, if given, specifies the conditions that identify which\nrows to delete. With no WHERE clause, all rows are deleted. If the\nORDER BY clause is specified, the rows are deleted in the order that is\nspecified. The LIMIT clause places a limit on the number of rows that\ncan be deleted.\n\nFor the multiple-table syntax, DELETE deletes from each tbl_name the\nrows that satisfy the conditions. In this case, ORDER BY and LIMIT\ncannot be used.\n\nwhere_condition is an expression that evaluates to true for each row to\nbe deleted. It is specified as described in\nhttp://dev.mysql.com/doc/refman/5.1/en/select.html.\n\nCurrently, you cannot delete from a table and select from the same\ntable in a subquery.\n\nYou need the DELETE privilege on a table to delete rows from it. You\nneed only the SELECT privilege for any columns that are only read, such\nas those named in the WHERE clause.\n\nAs stated, a DELETE statement with no WHERE clause deletes all rows. A\nfaster way to do this, when you do not need to know the number of\ndeleted rows, is to use TRUNCATE TABLE. However, within a transaction\nor if you have a lock on the table, TRUNCATE TABLE cannot be used\nwhereas DELETE can. See [HELP TRUNCATE TABLE], and [HELP LOCK].\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/delete.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/delete.html'),(49,'ROUND',4,'Syntax:\nROUND(X), ROUND(X,D)\n\nRounds the argument X to D decimal places. The rounding algorithm\ndepends on the data type of X. D defaults to 0 if not specified. D can\nbe negative to cause D digits left of the decimal point of the value X\nto become zero.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT ROUND(-1.23);\n        -> -1\nmysql> SELECT ROUND(-1.58);\n        -> -2\nmysql> SELECT ROUND(1.58);\n        -> 2\nmysql> SELECT ROUND(1.298, 1);\n        -> 1.3\nmysql> SELECT ROUND(1.298, 0);\n        -> 1\nmysql> SELECT ROUND(23.298, -1);\n        -> 20\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(50,'NULLIF',7,'Syntax:\nNULLIF(expr1,expr2)\n\nReturns NULL if expr1 = expr2 is true, otherwise returns expr1. This is\nthe same as CASE WHEN expr1 = expr2 THEN NULL ELSE expr1 END.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/control-flow-functions.html\n\n','mysql> SELECT NULLIF(1,1);\n        -> NULL\nmysql> SELECT NULLIF(1,2);\n        -> 1\n','http://dev.mysql.com/doc/refman/5.1/en/control-flow-functions.html'),(51,'CLOSE',23,'Syntax:\nCLOSE cursor_name\n\nThis statement closes a previously opened cursor. For an example, see\nhttp://dev.mysql.com/doc/refman/5.1/en/cursors.html.\n\nAn error occurs if the cursor is not open.\n\nIf not closed explicitly, a cursor is closed at the end of the BEGIN\n... END block in which it was declared.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/close.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/close.html'),(52,'STOP SLAVE',8,'Syntax:\nSTOP SLAVE [thread_type [, thread_type] ... ]\n\nthread_type: IO_THREAD | SQL_THREAD\n\nStops the slave threads. STOP SLAVE requires the SUPER privilege.\n\nLike START SLAVE, this statement may be used with the IO_THREAD and\nSQL_THREAD options to name the thread or threads to be stopped.\n\n*Note*: The transactional behavior of STOP SLAVE changed in MySQL\n5.1.35. Previously, it took effect immediately. Beginning with MySQL\n5.1.35, it waits until any current replication event group affecting\none or more non-transactional tables has finished executing (if there\nis any such replication group), or until the user issues a KILL QUERY\nor KILL CONNECTION statement. (Bug #319, Bug #38205)\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/stop-slave.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/stop-slave.html'),(53,'TIMEDIFF',31,'Syntax:\nTIMEDIFF(expr1,expr2)\n\nTIMEDIFF() returns expr1 - expr2 expressed as a time value. expr1 and\nexpr2 are time or date-and-time expressions, but both must be of the\nsame type.\n\nThe result returned by TIMEDIFF() is limited to the range allowed for\nTIME values. Alternatively, you can use either of the functions\nTIMESTAMPDIFF() and UNIX_TIMESTAMP(), both of which return integers.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT TIMEDIFF(\'2000:01:01 00:00:00\',\n    ->                 \'2000:01:01 00:00:00.000001\');\n        -> \'-00:00:00.000001\'\nmysql> SELECT TIMEDIFF(\'2008-12-31 23:59:59.000001\',\n    ->                 \'2008-12-30 01:01:01.000002\');\n        -> \'46:58:57.999999\'\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(54,'REPLACE FUNCTION',36,'Syntax:\nREPLACE(str,from_str,to_str)\n\nReturns the string str with all occurrences of the string from_str\nreplaced by the string to_str. REPLACE() performs a case-sensitive\nmatch when searching for from_str.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT REPLACE(\'www.mysql.com\', \'w\', \'Ww\');\n        -> \'WwWwWw.mysql.com\'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(55,'USE',28,'Syntax:\nUSE db_name\n\nThe USE db_name statement tells MySQL to use the db_name database as\nthe default (current) database for subsequent statements. The database\nremains the default until the end of the session or another USE\nstatement is issued:\n\nUSE db1;\nSELECT COUNT(*) FROM mytable;   # selects from db1.mytable\nUSE db2;\nSELECT COUNT(*) FROM mytable;   # selects from db2.mytable\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/use.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/use.html'),(56,'LINEFROMTEXT',3,'LineFromText(wkt[,srid]), LineStringFromText(wkt[,srid])\n\nConstructs a LINESTRING value using its WKT representation and SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkt-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkt-functions'),(57,'CASE OPERATOR',7,'Syntax:\nCASE value WHEN [compare_value] THEN result [WHEN [compare_value] THEN\nresult ...] [ELSE result] END\n\nCASE WHEN [condition] THEN result [WHEN [condition] THEN result ...]\n[ELSE result] END\n\nThe first version returns the result where value=compare_value. The\nsecond version returns the result for the first condition that is true.\nIf there was no matching result value, the result after ELSE is\nreturned, or NULL if there is no ELSE part.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/control-flow-functions.html\n\n','mysql> SELECT CASE 1 WHEN 1 THEN \'one\'\n    ->     WHEN 2 THEN \'two\' ELSE \'more\' END;\n        -> \'one\'\nmysql> SELECT CASE WHEN 1>0 THEN \'true\' ELSE \'false\' END;\n        -> \'true\'\nmysql> SELECT CASE BINARY \'B\'\n    ->     WHEN \'a\' THEN 1 WHEN \'b\' THEN 2 END;\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.1/en/control-flow-functions.html'),(58,'SHOW MASTER STATUS',26,'Syntax:\nSHOW MASTER STATUS\n\nThis statement provides status information about the binary log files\nof the master. It requires either the SUPER or REPLICATION CLIENT\nprivilege.\n\nExample:\n\nmysql> SHOW MASTER STATUS;\n+---------------+----------+--------------+------------------+\n| File          | Position | Binlog_Do_DB | Binlog_Ignore_DB |\n+---------------+----------+--------------+------------------+\n| mysql-bin.003 | 73       | test         | manual,mysql     |\n+---------------+----------+--------------+------------------+\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-master-status.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-master-status.html'),(59,'ADDTIME',31,'Syntax:\nADDTIME(expr1,expr2)\n\nADDTIME() adds expr2 to expr1 and returns the result. expr1 is a time\nor datetime expression, and expr2 is a time expression.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT ADDTIME(\'2007-12-31 23:59:59.999999\', \'1 1:1:1.000002\');\n        -> \'2008-01-02 01:01:01.000001\'\nmysql> SELECT ADDTIME(\'01:00:00.999999\', \'02:00:00.999998\');\n        -> \'03:00:01.999997\'\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(60,'SPATIAL',33,'For MyISAM tables, MySQL can create spatial indexes using syntax\nsimilar to that for creating regular indexes, but extended with the\nSPATIAL keyword. Currently, columns in spatial indexes must be declared\nNOT NULL. The following examples demonstrate how to create spatial\nindexes:\n\no With CREATE TABLE:\n\nCREATE TABLE geom (g GEOMETRY NOT NULL, SPATIAL INDEX(g)) ENGINE=MyISAM;\n\no With ALTER TABLE:\n\nALTER TABLE geom ADD SPATIAL INDEX(g);\n\no With CREATE INDEX:\n\nCREATE SPATIAL INDEX sp_index ON geom (g);\n\nFor MyISAM tables, SPATIAL INDEX creates an R-tree index. For storage\nengines that support nonspatial indexing of spatial columns, the engine\ncreates a B-tree index. A B-tree index on spatial values will be useful\nfor exact-value lookups, but not for range scans.\n\nFor more information on indexing spatial columns, see [HELP CREATE\nINDEX].\n\nTo drop spatial indexes, use ALTER TABLE or DROP INDEX:\n\no With ALTER TABLE:\n\nALTER TABLE geom DROP INDEX g;\n\no With DROP INDEX:\n\nDROP INDEX sp_index ON geom;\n\nExample: Suppose that a table geom contains more than 32,000\ngeometries, which are stored in the column g of type GEOMETRY. The\ntable also has an AUTO_INCREMENT column fid for storing object ID\nvalues.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-indexes.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-indexes.html'),(61,'TIMESTAMPDIFF',31,'Syntax:\nTIMESTAMPDIFF(unit,datetime_expr1,datetime_expr2)\n\nReturns datetime_expr2 - datetime_expr1, where datetime_expr1 and\ndatetime_expr2 are date or datetime expressions. One expression may be\na date and the other a datetime; a date value is treated as a datetime\nhaving the time part \'00:00:00\' where necessary. The unit for the\nresult (an integer) is given by the unit argument. The legal values for\nunit are the same as those listed in the description of the\nTIMESTAMPADD() function.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT TIMESTAMPDIFF(MONTH,\'2003-02-01\',\'2003-05-01\');\n        -> 3\nmysql> SELECT TIMESTAMPDIFF(YEAR,\'2002-05-01\',\'2001-01-01\');\n        -> -1\nmysql> SELECT TIMESTAMPDIFF(MINUTE,\'2003-02-01\',\'2003-05-01 12:05:55\');\n        -> 128885\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(62,'UPPER',36,'Syntax:\nUPPER(str)\n\nReturns the string str with all characters changed to uppercase\naccording to the current character set mapping. The default is latin1\n(cp1252 West European).\n\nmysql> SELECT UPPER(\'Hej\');\n        -> \'HEJ\'\n\nSee the description of LOWER() for information that also applies to\nUPPER(), such as information about how to perform lettercase conversion\nof binary strings (BINARY, VARBINARY, BLOB) for which these functions\nare ineffective.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(63,'FROM_UNIXTIME',31,'Syntax:\nFROM_UNIXTIME(unix_timestamp), FROM_UNIXTIME(unix_timestamp,format)\n\nReturns a representation of the unix_timestamp argument as a value in\n\'YYYY-MM-DD HH:MM:SS\' or YYYYMMDDHHMMSS.uuuuuu format, depending on\nwhether the function is used in a string or numeric context. The value\nis expressed in the current time zone. unix_timestamp is an internal\ntimestamp value such as is produced by the UNIX_TIMESTAMP() function.\n\nIf format is given, the result is formatted according to the format\nstring, which is used the same way as listed in the entry for the\nDATE_FORMAT() function.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT FROM_UNIXTIME(1196440219);\n        -> \'2007-11-30 10:30:19\'\nmysql> SELECT FROM_UNIXTIME(1196440219) + 0;\n        -> 20071130103019.000000\nmysql> SELECT FROM_UNIXTIME(UNIX_TIMESTAMP(),\n    ->                      \'%Y %D %M %h:%i:%s %x\');\n        -> \'2007 30th November 10:30:59 2007\'\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(64,'MEDIUMBLOB',22,'MEDIUMBLOB\n\nA BLOB column with a maximum length of 16,777,215 (224 - 1) bytes. Each\nMEDIUMBLOB value is stored using a three-byte length prefix that\nindicates the number of bytes in the value.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html'),(65,'IFNULL',7,'Syntax:\nIFNULL(expr1,expr2)\n\nIf expr1 is not NULL, IFNULL() returns expr1; otherwise it returns\nexpr2. IFNULL() returns a numeric or string value, depending on the\ncontext in which it is used.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/control-flow-functions.html\n\n','mysql> SELECT IFNULL(1,0);\n        -> 1\nmysql> SELECT IFNULL(NULL,10);\n        -> 10\nmysql> SELECT IFNULL(1/0,10);\n        -> 10\nmysql> SELECT IFNULL(1/0,\'yes\');\n        -> \'yes\'\n','http://dev.mysql.com/doc/refman/5.1/en/control-flow-functions.html'),(66,'SHOW FUNCTION CODE',26,'Syntax:\nSHOW FUNCTION CODE func_name\n\nThis statement is similar to SHOW PROCEDURE CODE but for stored\nfunctions. See [HELP SHOW PROCEDURE CODE].\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-function-code.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-function-code.html'),(67,'SHOW ERRORS',26,'Syntax:\nSHOW ERRORS [LIMIT [offset,] row_count]\nSHOW COUNT(*) ERRORS\n\nThis statement is similar to SHOW WARNINGS, except that it displays\ninformation only for errors, rather than for errors, warnings, and\nnotes.\n\nThe LIMIT clause has the same syntax as for the SELECT statement. See\nhttp://dev.mysql.com/doc/refman/5.1/en/select.html.\n\nThe SHOW COUNT(*) ERRORS statement displays the number of errors. You\ncan also retrieve this number from the error_count variable:\n\nSHOW COUNT(*) ERRORS;\nSELECT @@error_count;\n\nSHOW ERRORS and error_count apply only to errors, not warnings or\nnotes. In other respects, they are similar to SHOW WARNINGS and\nwarning_count. In particular, SHOW ERRORS cannot display information\nfor more than max_error_count messages, and error_count can exceed the\nvalue of max_error_count if the number of errors exceeds\nmax_error_count.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-errors.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-errors.html'),(68,'LEAST',18,'Syntax:\nLEAST(value1,value2,...)\n\nWith two or more arguments, returns the smallest (minimum-valued)\nargument. The arguments are compared using the following rules:\n\no If any argument is NULL, the result is NULL. No comparison is needed.\n\no If the return value is used in an INTEGER context or all arguments\n  are integer-valued, they are compared as integers.\n\no If the return value is used in a REAL context or all arguments are\n  real-valued, they are compared as reals.\n\no If the arguments comprise a mix of numbers and strings, they are\n  compared as numbers.\n\no If any argument is a nonbinary (character) string, the arguments are\n  compared as nonbinary strings.\n\no In all other cases, the arguments are compared as binary strings.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html\n\n','mysql> SELECT LEAST(2,0);\n        -> 0\nmysql> SELECT LEAST(34.0,3.0,5.0,767.0);\n        -> 3.0\nmysql> SELECT LEAST(\'B\',\'A\',\'C\');\n        -> \'A\'\n','http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html'),(69,'=',18,'=\n\nEqual:\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html\n\n','mysql> SELECT 1 = 0;\n        -> 0\nmysql> SELECT \'0\' = 0;\n        -> 1\nmysql> SELECT \'0.0\' = 0;\n        -> 1\nmysql> SELECT \'0.01\' = 0;\n        -> 0\nmysql> SELECT \'.01\' = 0.01;\n        -> 1\n','http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html'),(70,'REVERSE',36,'Syntax:\nREVERSE(str)\n\nReturns the string str with the order of the characters reversed.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT REVERSE(\'abc\');\n        -> \'cba\'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(71,'ISNULL',18,'Syntax:\nISNULL(expr)\n\nIf expr is NULL, ISNULL() returns 1, otherwise it returns 0.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html\n\n','mysql> SELECT ISNULL(1+1);\n        -> 0\nmysql> SELECT ISNULL(1/0);\n        -> 1\n','http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html'),(72,'BINARY',22,'BINARY(M)\n\nThe BINARY type is similar to the CHAR type, but stores binary byte\nstrings rather than nonbinary character strings. M represents the\ncolumn length in bytes.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html'),(73,'BLOB DATA TYPE',22,'A BLOB is a binary large object that can hold a variable amount of\ndata. The four BLOB types are TINYBLOB, BLOB, MEDIUMBLOB, and LONGBLOB.\nThese differ only in the maximum length of the values they can hold.\nThe four TEXT types are TINYTEXT, TEXT, MEDIUMTEXT, and LONGTEXT. These\ncorrespond to the four BLOB types and have the same maximum lengths and\nstorage requirements. See\nhttp://dev.mysql.com/doc/refman/5.1/en/storage-requirements.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/blob.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/blob.html'),(74,'BOUNDARY',35,'Boundary(g)\n\nReturns a geometry that is the closure of the combinatorial boundary of\nthe geometry value g.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#general-geometry-property-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#general-geometry-property-functions'),(75,'CREATE USER',10,'Syntax:\nCREATE USER user_specification\n    [, user_specification] ...\n\nuser_specification:\n    user [IDENTIFIED BY [PASSWORD] \'password\']\n\nThe CREATE USER statement creates new MySQL accounts. To use it, you\nmust have the global CREATE USER privilege or the INSERT privilege for\nthe mysql database. For each account, CREATE USER creates a new row in\nthe mysql.user table and assigns the account no privileges. An error\noccurs if the account already exists.\n\nEach account name uses the format described in\nhttp://dev.mysql.com/doc/refman/5.1/en/account-names.html. For example:\n\nCREATE USER \'jeffrey\'@\'localhost\' IDENTIFIED BY \'mypass\';\n\nIf you specify only the user name part of the account name, a host name\npart of \'%\' is used.\n\nThe user specification may indicate how the user should authenticate\nwhen connecting to the server:\n\no To enable the user to connect with no password (which is insecure),\n  include no IDENTIFIED BY clause:\n\nCREATE USER \'jeffrey\'@\'localhost\';\n\no To assign a password, use IDENTIFIED BY with the literal plaintext\n  password value:\n\nCREATE USER \'jeffrey\'@\'localhost\' IDENTIFIED BY \'mypass\';\n\no To avoid specifying the plaintext password if you know its hash value\n  (the value that PASSWORD() would return for the password), specify\n  the hash value preceded by the keyword PASSWORD:\n\nCREATE USER \'jeffrey\'@\'localhost\'\nIDENTIFIED BY PASSWORD \'*90E462C37378CED12064BB3388827D2BA3A9B689\';\n\nFor additional information about setting passwords, see\nhttp://dev.mysql.com/doc/refman/5.1/en/assigning-passwords.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/create-user.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/create-user.html'),(76,'POINT',24,'Point(x,y)\n\nConstructs a Point using its coordinates.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-mysql-specific-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-mysql-specific-functions'),(77,'CURRENT_USER',17,'Syntax:\nCURRENT_USER, CURRENT_USER()\n\nReturns the user name and host name combination for the MySQL account\nthat the server used to authenticate the current client. This account\ndetermines your access privileges. The return value is a string in the\nutf8 character set.\n\nThe value of CURRENT_USER() can differ from the value of USER().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/information-functions.html\n\n','mysql> SELECT USER();\n        -> \'davida@localhost\'\nmysql> SELECT * FROM mysql.user;\nERROR 1044: Access denied for user \'\'@\'localhost\' to\ndatabase \'mysql\'\nmysql> SELECT CURRENT_USER();\n        -> \'@localhost\'\n','http://dev.mysql.com/doc/refman/5.1/en/information-functions.html'),(78,'LCASE',36,'Syntax:\nLCASE(str)\n\nLCASE() is a synonym for LOWER().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(79,'<=',18,'Syntax:\n<=\n\nLess than or equal:\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html\n\n','mysql> SELECT 0.1 <= 2;\n        -> 1\n','http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html'),(80,'SHOW PROFILES',26,'Syntax:\nSHOW PROFILE [type [, type] ... ]\n    [FOR QUERY n]\n    [LIMIT row_count [OFFSET offset]]\n\ntype:\n    ALL\n  | BLOCK IO\n  | CONTEXT SWITCHES\n  | CPU\n  | IPC\n  | MEMORY\n  | PAGE FAULTS\n  | SOURCE\n  | SWAPS\n\nThe SHOW PROFILES and SHOW PROFILE statements display profiling\ninformation that indicates resource usage for statements executed\nduring the course of the current session.\n\nProfiling is controlled by the profiling session variable, which has a\ndefault value of 0 (OFF). Profiling is enabled by setting profiling to\n1 or ON:\n\nmysql> SET profiling = 1;\n\nSHOW PROFILES displays a list of the most recent statements sent to the\nmaster. The size of the list is controlled by the\nprofiling_history_size session variable, which has a default value of\n15. The maximum value is 100. Setting the value to 0 has the practical\neffect of disabling profiling.\n\nAll statements are profiled except SHOW PROFILES and SHOW PROFILE, so\nyou will find neither of those statements in the profile list.\nMalformed statements are profiled. For example, SHOW PROFILING is an\nillegal statement, and a syntax error occurs if you try to execute it,\nbut it will show up in the profiling list.\n\nSHOW PROFILE displays detailed information about a single statement.\nWithout the FOR QUERY n clause, the output pertains to the most\nrecently executed statement. If FOR QUERY n is included, SHOW PROFILE\ndisplays information for statement n. The values of n correspond to the\nQuery_ID values displayed by SHOW PROFILES.\n\nThe LIMIT row_count clause may be given to limit the output to\nrow_count rows. If LIMIT is given, OFFSET offset may be added to begin\nthe output offset rows into the full set of rows.\n\nBy default, SHOW PROFILE displays Status and Duration columns. The\nStatus values are like the State values displayed by SHOW PROCESSLIST,\nalthough there might be some minor differences in interpretion for the\ntwo statements for some status values (see\nhttp://dev.mysql.com/doc/refman/5.1/en/thread-information.html).\n\nOptional type values may be specified to display specific additional\ntypes of information:\n\no ALL displays all information\n\no BLOCK IO displays counts for block input and output operations\n\no CONTEXT SWITCHES displays counts for voluntary and involuntary\n  context switches\n\no CPU displays user and system CPU usage times\n\no IPC displays counts for messages sent and received\n\no MEMORY is not currently implemented\n\no PAGE FAULTS displays counts for major and minor page faults\n\no SOURCE displays the names of functions from the source code, together\n  with the name and line number of the file in which the function\n  occurs\n\no SWAPS displays swap counts\n\nProfiling is enabled per session. When a session ends, its profiling\ninformation is lost.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-profiles.html\n\n','mysql> SELECT @@profiling;\n+-------------+\n| @@profiling |\n+-------------+\n|           0 |\n+-------------+\n1 row in set (0.00 sec)\n\nmysql> SET profiling = 1;\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> DROP TABLE IF EXISTS t1;\nQuery OK, 0 rows affected, 1 warning (0.00 sec)\n\nmysql> CREATE TABLE T1 (id INT);\nQuery OK, 0 rows affected (0.01 sec)\n\nmysql> SHOW PROFILES;\n+----------+----------+--------------------------+\n| Query_ID | Duration | Query                    |\n+----------+----------+--------------------------+\n|        0 | 0.000088 | SET PROFILING = 1        |\n|        1 | 0.000136 | DROP TABLE IF EXISTS t1  |\n|        2 | 0.011947 | CREATE TABLE t1 (id INT) |\n+----------+----------+--------------------------+\n3 rows in set (0.00 sec)\n\nmysql> SHOW PROFILE;\n+----------------------+----------+\n| Status               | Duration |\n+----------------------+----------+\n| checking permissions | 0.000040 |\n| creating table       | 0.000056 |\n| After create         | 0.011363 |\n| query end            | 0.000375 |\n| freeing items        | 0.000089 |\n| logging slow query   | 0.000019 |\n| cleaning up          | 0.000005 |\n+----------------------+----------+\n7 rows in set (0.00 sec)\n\nmysql> SHOW PROFILE FOR QUERY 1;\n+--------------------+----------+\n| Status             | Duration |\n+--------------------+----------+\n| query end          | 0.000107 |\n| freeing items      | 0.000008 |\n| logging slow query | 0.000015 |\n| cleaning up        | 0.000006 |\n+--------------------+----------+\n4 rows in set (0.00 sec)\n\nmysql> SHOW PROFILE CPU FOR QUERY 2;\n+----------------------+----------+----------+------------+\n| Status               | Duration | CPU_user | CPU_system |\n+----------------------+----------+----------+------------+\n| checking permissions | 0.000040 | 0.000038 |   0.000002 |\n| creating table       | 0.000056 | 0.000028 |   0.000028 |\n| After create         | 0.011363 | 0.000217 |   0.001571 |\n| query end            | 0.000375 | 0.000013 |   0.000028 |\n| freeing items        | 0.000089 | 0.000010 |   0.000014 |\n| logging slow query   | 0.000019 | 0.000009 |   0.000010 |\n| cleaning up          | 0.000005 | 0.000003 |   0.000002 |\n+----------------------+----------+----------+------------+\n7 rows in set (0.00 sec)\n','http://dev.mysql.com/doc/refman/5.1/en/show-profiles.html'),(81,'UPDATE',27,'Syntax:\nSingle-table syntax:\n\nUPDATE [LOW_PRIORITY] [IGNORE] table_reference\n    SET col_name1={expr1|DEFAULT} [, col_name2={expr2|DEFAULT}] ...\n    [WHERE where_condition]\n    [ORDER BY ...]\n    [LIMIT row_count]\n\nMultiple-table syntax:\n\nUPDATE [LOW_PRIORITY] [IGNORE] table_references\n    SET col_name1={expr1|DEFAULT} [, col_name2={expr2|DEFAULT}] ...\n    [WHERE where_condition]\n\nFor the single-table syntax, the UPDATE statement updates columns of\nexisting rows in the named table with new values. The SET clause\nindicates which columns to modify and the values they should be given.\nEach value can be given as an expression, or the keyword DEFAULT to set\na column explicitly to its default value. The WHERE clause, if given,\nspecifies the conditions that identify which rows to update. With no\nWHERE clause, all rows are updated. If the ORDER BY clause is\nspecified, the rows are updated in the order that is specified. The\nLIMIT clause places a limit on the number of rows that can be updated.\n\nFor the multiple-table syntax, UPDATE updates rows in each table named\nin table_references that satisfy the conditions. In this case, ORDER BY\nand LIMIT cannot be used.\n\nwhere_condition is an expression that evaluates to true for each row to\nbe updated. For expression syntax, see\nhttp://dev.mysql.com/doc/refman/5.1/en/expressions.html.\n\ntable_references and where_condition are is specified as described in\nhttp://dev.mysql.com/doc/refman/5.1/en/select.html.\n\nYou need the UPDATE privilege only for columns referenced in an UPDATE\nthat are actually updated. You need only the SELECT privilege for any\ncolumns that are read but not modified.\n\nThe UPDATE statement supports the following modifiers:\n\no With the LOW_PRIORITY keyword, execution of the UPDATE is delayed\n  until no other clients are reading from the table. This affects only\n  storage engines that use only table-level locking (such as MyISAM,\n  MEMORY, and MERGE).\n\no With the IGNORE keyword, the update statement does not abort even if\n  errors occur during the update. Rows for which duplicate-key\n  conflicts occur are not updated. Rows for which columns are updated\n  to values that would cause data conversion errors are updated to the\n  closest valid values instead.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/update.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/update.html'),(82,'IS NOT NULL',18,'Syntax:\nIS NOT NULL\n\nTests whether a value is not NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html\n\n','mysql> SELECT 1 IS NOT NULL, 0 IS NOT NULL, NULL IS NOT NULL;\n        -> 1, 1, 0\n','http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html'),(83,'CASE STATEMENT',23,'Syntax:\nCASE case_value\n    WHEN when_value THEN statement_list\n    [WHEN when_value THEN statement_list] ...\n    [ELSE statement_list]\nEND CASE\n\nOr:\n\nCASE\n    WHEN search_condition THEN statement_list\n    [WHEN search_condition THEN statement_list] ...\n    [ELSE statement_list]\nEND CASE\n\nThe CASE statement for stored programs implements a complex conditional\nconstruct.\n\n*Note*: There is also a CASE expression, which differs from the CASE\nstatement described here. See\nhttp://dev.mysql.com/doc/refman/5.1/en/control-flow-functions.html. The\nCASE statement cannot have an ELSE NULL clause, and it is terminated\nwith END CASE instead of END.\n\nFor the first syntax, case_value is an expression. This value is\ncompared to the when_value expression in each WHEN clause until one of\nthem is equal. When an equal when_value is found, the corresponding\nTHEN clause statement_list executes. If no when_value is equal, the\nELSE clause statement_list executes, if there is one.\n\nThis syntax cannot be used to test for equality with NULL because NULL\n= NULL is false. See\nhttp://dev.mysql.com/doc/refman/5.1/en/working-with-null.html.\n\nFor the second syntax, each WHEN clause search_condition expression is\nevaluated until one is true, at which point its corresponding THEN\nclause statement_list executes. If no search_condition is equal, the\nELSE clause statement_list executes, if there is one.\n\nIf no when_value or search_condition matches the value tested and the\nCASE statement contains no ELSE clause, a Case not found for CASE\nstatement error results.\n\nEach statement_list consists of one or more SQL statements; an empty\nstatement_list is not permitted.\n\nTo handle situations where no value is matched by any WHEN clause, use\nan ELSE containing an empty BEGIN ... END block, as shown in this\nexample. (The indentation used here in the ELSE clause is for purposes\nof clarity only, and is not otherwise significant.)\n\nDELIMITER |\n\nCREATE PROCEDURE p()\n  BEGIN\n    DECLARE v INT DEFAULT 1;\n\n    CASE v\n      WHEN 2 THEN SELECT v;\n      WHEN 3 THEN SELECT 0;\n      ELSE\n        BEGIN\n        END;\n    END CASE;\n  END;\n  |\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/case-statement.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/case-statement.html'),(84,'EXECUTE STATEMENT',8,'Syntax:\nEXECUTE stmt_name\n    [USING @var_name [, @var_name] ...]\n\nAfter preparing a statement with PREPARE, you execute it with an\nEXECUTE statement that refers to the prepared statement name. If the\nprepared statement contains any parameter markers, you must supply a\nUSING clause that lists user variables containing the values to be\nbound to the parameters. Parameter values can be supplied only by user\nvariables, and the USING clause must name exactly as many variables as\nthe number of parameter markers in the statement.\n\nYou can execute a given prepared statement multiple times, passing\ndifferent variables to it or setting the variables to different values\nbefore each execution.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/execute.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/execute.html'),(85,'DROP INDEX',38,'Syntax:\nDROP [ONLINE|OFFLINE] INDEX index_name ON tbl_name\n\nDROP INDEX drops the index named index_name from the table tbl_name.\nThis statement is mapped to an ALTER TABLE statement to drop the index.\nSee [HELP ALTER TABLE].\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/drop-index.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/drop-index.html'),(86,'MATCH AGAINST',36,'Syntax:\nMATCH (col1,col2,...) AGAINST (expr [search_modifier])\n\nMySQL has support for full-text indexing and searching:\n\no A full-text index in MySQL is an index of type FULLTEXT.\n\no Full-text indexes can be used only with MyISAM tables, and can be\n  created only for CHAR, VARCHAR, or TEXT columns.\n\no A FULLTEXT index definition can be given in the CREATE TABLE\n  statement when a table is created, or added later using ALTER TABLE\n  or CREATE INDEX.\n\no For large data sets, it is much faster to load your data into a table\n  that has no FULLTEXT index and then create the index after that, than\n  to load data into a table that has an existing FULLTEXT index.\n\nFull-text searching is performed using MATCH() ... AGAINST syntax.\nMATCH() takes a comma-separated list that names the columns to be\nsearched. AGAINST takes a string to search for, and an optional\nmodifier that indicates what type of search to perform. The search\nstring must be a literal string, not a variable or a column name. There\nare three types of full-text searches:\n\no A natural language search interprets the search string as a phrase in\n  natural human language (a phrase in free text). There are no special\n  operators. The stopword list applies. In addition, words that are\n  present in 50% or more of the rows are considered common and do not\n  match.\n\n  Full-text searches are natural language searches if the IN NATURAL\n  LANGUAGE MODE modifier is given or if no modifier is given. For more\n  information, see\n  http://dev.mysql.com/doc/refman/5.1/en/fulltext-natural-language.html\n  .\n\no A boolean search interprets the search string using the rules of a\n  special query language. The string contains the words to search for.\n  It can also contain operators that specify requirements such that a\n  word must be present or absent in matching rows, or that it should be\n  weighted higher or lower than usual. Common words such as \"some\" or\n  \"then\" are stopwords and do not match if present in the search\n  string. The IN BOOLEAN MODE modifier specifies a boolean search. For\n  more information, see\n  http://dev.mysql.com/doc/refman/5.1/en/fulltext-boolean.html.\n\no A query expansion search is a modification of a natural language\n  search. The search string is used to perform a natural language\n  search. Then words from the most relevant rows returned by the search\n  are added to the search string and the search is done again. The\n  query returns the rows from the second search. The IN NATURAL\n  LANGUAGE MODE WITH QUERY EXPANSION or WITH QUERY EXPANSION modifier\n  specifies a query expansion search. For more information, see\n  http://dev.mysql.com/doc/refman/5.1/en/fulltext-query-expansion.html.\n\nThe IN NATURAL LANGUAGE MODE and IN NATURAL LANGUAGE MODE WITH QUERY\nEXPANSION modifiers were added in MySQL 5.1.7.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/fulltext-search.html\n\n','mysql> SELECT id, body, MATCH (title,body) AGAINST\n    -> (\'Security implications of running MySQL as root\'\n    -> IN NATURAL LANGUAGE MODE) AS score\n    -> FROM articles WHERE MATCH (title,body) AGAINST\n    -> (\'Security implications of running MySQL as root\'\n    -> IN NATURAL LANGUAGE MODE);\n+----+-------------------------------------+-----------------+\n| id | body                                | score           |\n+----+-------------------------------------+-----------------+\n|  4 | 1. Never run mysqld as root. 2. ... | 1.5219271183014 |\n|  6 | When configured properly, MySQL ... | 1.3114095926285 |\n+----+-------------------------------------+-----------------+\n2 rows in set (0.00 sec)\n','http://dev.mysql.com/doc/refman/5.1/en/fulltext-search.html'),(87,'CREATE EVENT',38,'Syntax:\nCREATE\n    [DEFINER = { user | CURRENT_USER }]\n    EVENT\n    [IF NOT EXISTS]\n    event_name\n    ON SCHEDULE schedule\n    [ON COMPLETION [NOT] PRESERVE]\n    [ENABLE | DISABLE | DISABLE ON SLAVE]\n    [COMMENT \'comment\']\n    DO event_body;\n\nschedule:\n    AT timestamp [+ INTERVAL interval] ...\n  | EVERY interval\n    [STARTS timestamp [+ INTERVAL interval] ...]\n    [ENDS timestamp [+ INTERVAL interval] ...]\n\ninterval:\n    quantity {YEAR | QUARTER | MONTH | DAY | HOUR | MINUTE |\n              WEEK | SECOND | YEAR_MONTH | DAY_HOUR | DAY_MINUTE |\n              DAY_SECOND | HOUR_MINUTE | HOUR_SECOND | MINUTE_SECOND}\n\nThis statement creates and schedules a new event. The event will not\nrun unless the Event Scheduler is enabled. For information about\nchecking Event Scheduler status and enabling it if necessary, see\nhttp://dev.mysql.com/doc/refman/5.1/en/events-configuration.html.\n\nCREATE EVENT requires the EVENT privilege for the schema in which the\nevent is to be created. It might also require the SUPER privilege,\ndepending on the DEFINER value, as described later in this section.\n\nThe minimum requirements for a valid CREATE EVENT statement are as\nfollows:\n\no The keywords CREATE EVENT plus an event name, which uniquely\n  identifies the event within a database schema. (Prior to MySQL\n  5.1.12, the event name needed to be unique only among events created\n  by the same user within a schema.)\n\no An ON SCHEDULE clause, which determines when and how often the event\n  executes.\n\no A DO clause, which contains the SQL statement to be executed by an\n  event.\n\nThis is an example of a minimal CREATE EVENT statement:\n\nCREATE EVENT myevent\n    ON SCHEDULE AT CURRENT_TIMESTAMP + INTERVAL 1 HOUR\n    DO\n      UPDATE myschema.mytable SET mycol = mycol + 1;\n\nThe previous statement creates an event named myevent. This event\nexecutes once---one hour following its creation---by running an SQL\nstatement that increments the value of the myschema.mytable table\'s\nmycol column by 1.\n\nThe event_name must be a valid MySQL identifier with a maximum length\nof 64 characters. Event names are not case sensitive, so you cannot\nhave two events named myevent and MyEvent in the same schema. In\ngeneral, the rules governing event names are the same as those for\nnames of stored routines. See\nhttp://dev.mysql.com/doc/refman/5.1/en/identifiers.html.\n\nAn event is associated with a schema. If no schema is indicated as part\nof event_name, the default (current) schema is assumed. To create an\nevent in a specific schema, qualify the event name with a schema using\nschema_name.event_name syntax.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/create-event.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/create-event.html'),(88,'ABS',4,'Syntax:\nABS(X)\n\nReturns the absolute value of X.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT ABS(2);\n        -> 2\nmysql> SELECT ABS(-32);\n        -> 32\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(89,'POLYFROMWKB',32,'PolyFromWKB(wkb[,srid]), PolygonFromWKB(wkb[,srid])\n\nConstructs a POLYGON value using its WKB representation and SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkb-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkb-functions'),(90,'NOT LIKE',36,'Syntax:\nexpr NOT LIKE pat [ESCAPE \'escape_char\']\n\nThis is the same as NOT (expr LIKE pat [ESCAPE \'escape_char\']).\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-comparison-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-comparison-functions.html'),(91,'SPACE',36,'Syntax:\nSPACE(N)\n\nReturns a string consisting of N space characters.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT SPACE(6);\n        -> \'      \'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(92,'MBR DEFINITION',6,'Its MBR (Minimum Bounding Rectangle), or Envelope. This is the bounding\ngeometry, formed by the minimum and maximum (X,Y) coordinates:\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/gis-class-geometry.html\n\n','((MINX MINY, MAXX MINY, MAXX MAXY, MINX MAXY, MINX MINY))\n','http://dev.mysql.com/doc/refman/5.1/en/gis-class-geometry.html'),(93,'GEOMETRYCOLLECTION',24,'GeometryCollection(g1,g2,...)\n\nConstructs a GeometryCollection.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-mysql-specific-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-mysql-specific-functions'),(94,'MAX',16,'Syntax:\nMAX([DISTINCT] expr)\n\nReturns the maximum value of expr. MAX() may take a string argument; in\nsuch cases, it returns the maximum string value. See\nhttp://dev.mysql.com/doc/refman/5.1/en/mysql-indexes.html. The DISTINCT\nkeyword can be used to find the maximum of the distinct values of expr,\nhowever, this produces the same result as omitting DISTINCT.\n\nMAX() returns NULL if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html\n\n','mysql> SELECT student_name, MIN(test_score), MAX(test_score)\n    ->        FROM student\n    ->        GROUP BY student_name;\n','http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html'),(95,'CREATE FUNCTION UDF',21,'Syntax:\nCREATE [AGGREGATE] FUNCTION function_name RETURNS {STRING|INTEGER|REAL|DECIMAL}\n    SONAME shared_library_name\n\nA user-defined function (UDF) is a way to extend MySQL with a new\nfunction that works like a native (built-in) MySQL function such as\nABS() or CONCAT().\n\nfunction_name is the name that should be used in SQL statements to\ninvoke the function. The RETURNS clause indicates the type of the\nfunction\'s return value. DECIMAL is a legal value after RETURNS, but\ncurrently DECIMAL functions return string values and should be written\nlike STRING functions.\n\nshared_library_name is the basename of the shared object file that\ncontains the code that implements the function. The file must be\nlocated in the plugin directory. This directory is given by the value\nof the plugin_dir system variable.\n\n*Note*: This is a change in MySQL 5.1. For earlier versions of MySQL,\nthe shared object can be located in any directory that is searched by\nyour system\'s dynamic linker. For more information, see\nhttp://dev.mysql.com/doc/refman/5.1/en/udf-compiling.html.\n\nTo create a function, you must have the INSERT privilege for the mysql\ndatabase. This is necessary because CREATE FUNCTION adds a row to the\nmysql.func system table that records the function\'s name, type, and\nshared library name. If you do not have this table, you should run the\nmysql_upgrade command to create it. See\nhttp://dev.mysql.com/doc/refman/5.1/en/mysql-upgrade.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/create-function-udf.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/create-function-udf.html'),(96,'*',4,'Syntax:\n*\n\nMultiplication:\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/arithmetic-functions.html\n\n','mysql> SELECT 3*5;\n        -> 15\nmysql> SELECT 18014398509481984*18014398509481984.0;\n        -> 324518553658426726783156020576256.0\n','http://dev.mysql.com/doc/refman/5.1/en/arithmetic-functions.html'),(97,'TIMESTAMP',22,'TIMESTAMP\n\nA timestamp. The range is \'1970-01-01 00:00:01\' UTC to \'2038-01-19\n03:14:07\' UTC. TIMESTAMP values are stored as the number of seconds\nsince the epoch (\'1970-01-01 00:00:00\' UTC). A TIMESTAMP cannot\nrepresent the value \'1970-01-01 00:00:00\' because that is equivalent to\n0 seconds from the epoch and the value 0 is reserved for representing\n\'0000-00-00 00:00:00\', the \"zero\" TIMESTAMP value.\n\nUnless specified otherwise, the first TIMESTAMP column in a table is\ndefined to be automatically set to the date and time of the most recent\nmodification if not explicitly assigned a value. This makes TIMESTAMP\nuseful for recording the timestamp of an INSERT or UPDATE operation.\nYou can also set any TIMESTAMP column to the current date and time by\nassigning it a NULL value, unless it has been defined with the NULL\nattribute to permit NULL values. The automatic initialization and\nupdating to the current date and time can be specified using DEFAULT\nand ON UPDATE clauses, are described in\nhttp://dev.mysql.com/doc/refman/5.1/en/timestamp-initialization.html.\n\n*Note*: The TIMESTAMP format that was used prior to MySQL 4.1 is not\nsupported in MySQL 5.1; see MySQL 3.23, 4.0, 4.1 Reference Manual for\ninformation regarding the old format.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-type-overview.html'),(98,'DES_DECRYPT',12,'Syntax:\nDES_DECRYPT(crypt_str[,key_str])\n\nDecrypts a string encrypted with DES_ENCRYPT(). If an error occurs,\nthis function returns NULL.\n\nThis function works only if MySQL has been configured with SSL support.\nSee http://dev.mysql.com/doc/refman/5.1/en/secure-connections.html.\n\nIf no key_str argument is given, DES_DECRYPT() examines the first byte\nof the encrypted string to determine the DES key number that was used\nto encrypt the original string, and then reads the key from the DES key\nfile to decrypt the message. For this to work, the user must have the\nSUPER privilege. The key file can be specified with the --des-key-file\nserver option.\n\nIf you pass this function a key_str argument, that string is used as\nthe key for decrypting the message.\n\nIf the crypt_str argument does not appear to be an encrypted string,\nMySQL returns the given crypt_str.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html'),(99,'CACHE INDEX',26,'Syntax:\nCACHE INDEX\n  tbl_index_list [, tbl_index_list] ...\n  IN key_cache_name\n\ntbl_index_list:\n  tbl_name [[INDEX|KEY] (index_name[, index_name] ...)]\n\nThe CACHE INDEX statement assigns table indexes to a specific key\ncache. It is used only for MyISAM tables. After the indexes have been\nassigned, they can be preloaded into the cache if desired with LOAD\nINDEX INTO CACHE.\n\nThe following statement assigns indexes from the tables t1, t2, and t3\nto the key cache named hot_cache:\n\nmysql> CACHE INDEX t1, t2, t3 IN hot_cache;\n+---------+--------------------+----------+----------+\n| Table   | Op                 | Msg_type | Msg_text |\n+---------+--------------------+----------+----------+\n| test.t1 | assign_to_keycache | status   | OK       |\n| test.t2 | assign_to_keycache | status   | OK       |\n| test.t3 | assign_to_keycache | status   | OK       |\n+---------+--------------------+----------+----------+\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/cache-index.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/cache-index.html'),(100,'ENDPOINT',13,'EndPoint(ls)\n\nReturns the Point that is the endpoint of the LineString value ls.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#linestring-property-functions\n\n','mysql> SET @ls = \'LineString(1 1,2 2,3 3)\';\nmysql> SELECT AsText(EndPoint(GeomFromText(@ls)));\n+-------------------------------------+\n| AsText(EndPoint(GeomFromText(@ls))) |\n+-------------------------------------+\n| POINT(3 3)                          |\n+-------------------------------------+\n','http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#linestring-property-functions'),(101,'COMPRESS',12,'Syntax:\nCOMPRESS(string_to_compress)\n\nCompresses a string and returns the result as a binary string. This\nfunction requires MySQL to have been compiled with a compression\nlibrary such as zlib. Otherwise, the return value is always NULL. The\ncompressed string can be uncompressed with UNCOMPRESS().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html\n\n','mysql> SELECT LENGTH(COMPRESS(REPEAT(\'a\',1000)));\n        -> 21\nmysql> SELECT LENGTH(COMPRESS(\'\'));\n        -> 0\nmysql> SELECT LENGTH(COMPRESS(\'a\'));\n        -> 13\nmysql> SELECT LENGTH(COMPRESS(REPEAT(\'a\',16)));\n        -> 15\n','http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html'),(102,'INSERT',27,'Syntax:\nINSERT [LOW_PRIORITY | DELAYED | HIGH_PRIORITY] [IGNORE]\n    [INTO] tbl_name [(col_name,...)]\n    {VALUES | VALUE} ({expr | DEFAULT},...),(...),...\n    [ ON DUPLICATE KEY UPDATE\n      col_name=expr\n        [, col_name=expr] ... ]\n\nOr:\n\nINSERT [LOW_PRIORITY | DELAYED | HIGH_PRIORITY] [IGNORE]\n    [INTO] tbl_name\n    SET col_name={expr | DEFAULT}, ...\n    [ ON DUPLICATE KEY UPDATE\n      col_name=expr\n        [, col_name=expr] ... ]\n\nOr:\n\nINSERT [LOW_PRIORITY | HIGH_PRIORITY] [IGNORE]\n    [INTO] tbl_name [(col_name,...)]\n    SELECT ...\n    [ ON DUPLICATE KEY UPDATE\n      col_name=expr\n        [, col_name=expr] ... ]\n\nINSERT inserts new rows into an existing table. The INSERT ... VALUES\nand INSERT ... SET forms of the statement insert rows based on\nexplicitly specified values. The INSERT ... SELECT form inserts rows\nselected from another table or tables. INSERT ... SELECT is discussed\nfurther in [HELP INSERT SELECT].\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/insert.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/insert.html'),(103,'COUNT',16,'Syntax:\nCOUNT(expr)\n\nReturns a count of the number of non-NULL values of expr in the rows\nretrieved by a SELECT statement. The result is a BIGINT value.\n\nCOUNT() returns 0 if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html\n\n','mysql> SELECT student.student_name,COUNT(*)\n    ->        FROM student,course\n    ->        WHERE student.student_id=course.student_id\n    ->        GROUP BY student_name;\n','http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html'),(104,'HANDLER',27,'Syntax:\nHANDLER tbl_name OPEN [ [AS] alias]\n\nHANDLER tbl_name READ index_name { = | <= | >= | < | > } (value1,value2,...)\n    [ WHERE where_condition ] [LIMIT ... ]\nHANDLER tbl_name READ index_name { FIRST | NEXT | PREV | LAST }\n    [ WHERE where_condition ] [LIMIT ... ]\nHANDLER tbl_name READ { FIRST | NEXT }\n    [ WHERE where_condition ] [LIMIT ... ]\n\nHANDLER tbl_name CLOSE\n\nThe HANDLER statement provides direct access to table storage engine\ninterfaces. It is available for MyISAM and InnoDB tables.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/handler.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/handler.html'),(105,'MLINEFROMTEXT',3,'MLineFromText(wkt[,srid]), MultiLineStringFromText(wkt[,srid])\n\nConstructs a MULTILINESTRING value using its WKT representation and\nSRID.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkt-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkt-functions'),(106,'GEOMCOLLFROMWKB',32,'GeomCollFromWKB(wkb[,srid]), GeometryCollectionFromWKB(wkb[,srid])\n\nConstructs a GEOMETRYCOLLECTION value using its WKB representation and\nSRID.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkb-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkb-functions'),(107,'HELP_DATE',9,'This help information was generated from the MySQL 5.1 Reference Manual\non: 2012-04-15\n','',''),(108,'RENAME TABLE',38,'Syntax:\nRENAME TABLE tbl_name TO new_tbl_name\n    [, tbl_name2 TO new_tbl_name2] ...\n\nThis statement renames one or more tables.\n\nThe rename operation is done atomically, which means that no other\nsession can access any of the tables while the rename is running. For\nexample, if you have an existing table old_table, you can create\nanother table new_table that has the same structure but is empty, and\nthen replace the existing table with the empty one as follows (assuming\nthat backup_table does not already exist):\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/rename-table.html\n\n','CREATE TABLE new_table (...);\nRENAME TABLE old_table TO backup_table, new_table TO old_table;\n','http://dev.mysql.com/doc/refman/5.1/en/rename-table.html'),(109,'BOOLEAN',22,'BOOL, BOOLEAN\n\nThese types are synonyms for TINYINT(1). A value of zero is considered\nfalse. Nonzero values are considered true:\n\nmysql> SELECT IF(0, \'true\', \'false\');\n+------------------------+\n| IF(0, \'true\', \'false\') |\n+------------------------+\n| false                  |\n+------------------------+\n\nmysql> SELECT IF(1, \'true\', \'false\');\n+------------------------+\n| IF(1, \'true\', \'false\') |\n+------------------------+\n| true                   |\n+------------------------+\n\nmysql> SELECT IF(2, \'true\', \'false\');\n+------------------------+\n| IF(2, \'true\', \'false\') |\n+------------------------+\n| true                   |\n+------------------------+\n\nHowever, the values TRUE and FALSE are merely aliases for 1 and 0,\nrespectively, as shown here:\n\nmysql> SELECT IF(0 = FALSE, \'true\', \'false\');\n+--------------------------------+\n| IF(0 = FALSE, \'true\', \'false\') |\n+--------------------------------+\n| true                           |\n+--------------------------------+\n\nmysql> SELECT IF(1 = TRUE, \'true\', \'false\');\n+-------------------------------+\n| IF(1 = TRUE, \'true\', \'false\') |\n+-------------------------------+\n| true                          |\n+-------------------------------+\n\nmysql> SELECT IF(2 = TRUE, \'true\', \'false\');\n+-------------------------------+\n| IF(2 = TRUE, \'true\', \'false\') |\n+-------------------------------+\n| false                         |\n+-------------------------------+\n\nmysql> SELECT IF(2 = FALSE, \'true\', \'false\');\n+--------------------------------+\n| IF(2 = FALSE, \'true\', \'false\') |\n+--------------------------------+\n| false                          |\n+--------------------------------+\n\nThe last two statements display the results shown because 2 is equal to\nneither 1 nor 0.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html'),(110,'DEFAULT',15,'Syntax:\nDEFAULT(col_name)\n\nReturns the default value for a table column. An error results if the\ncolumn has no default value.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html\n\n','mysql> UPDATE t SET i = DEFAULT(i)+1 WHERE id < 100;\n','http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html'),(111,'MOD',4,'Syntax:\nMOD(N,M), N % M, N MOD M\n\nModulo operation. Returns the remainder of N divided by M.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT MOD(234, 10);\n        -> 4\nmysql> SELECT 253 % 7;\n        -> 1\nmysql> SELECT MOD(29,9);\n        -> 2\nmysql> SELECT 29 MOD 9;\n        -> 2\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(112,'TINYTEXT',22,'TINYTEXT [CHARACTER SET charset_name] [COLLATE collation_name]\n\nA TEXT column with a maximum length of 255 (28 - 1) characters. The\neffective maximum length is less if the value contains multi-byte\ncharacters. Each TINYTEXT value is stored using a one-byte length\nprefix that indicates the number of bytes in the value.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html'),(113,'OPTIMIZE TABLE',20,'Syntax:\nOPTIMIZE [NO_WRITE_TO_BINLOG | LOCAL] TABLE\n    tbl_name [, tbl_name] ...\n\nOPTIMIZE TABLE should be used if you have deleted a large part of a\ntable or if you have made many changes to a table with variable-length\nrows (tables that have VARCHAR, VARBINARY, BLOB, or TEXT columns).\nDeleted rows are maintained in a linked list and subsequent INSERT\noperations reuse old row positions. You can use OPTIMIZE TABLE to\nreclaim the unused space and to defragment the data file. After\nextensive changes to a table, this statement may also improve\nperformance of statements that use the table, sometimes significantly.\n\nThis statement requires SELECT and INSERT privileges for the table.\n\nBeginning with MySQL 5.1.27, OPTIMIZE TABLE is also supported for\npartitioned tables. Also beginning with MySQL 5.1.27, you can use ALTER\nTABLE ... OPTIMIZE PARTITION to optimize one or more partitions; for\nmore information, see [HELP ALTER TABLE], and\nhttp://dev.mysql.com/doc/refman/5.1/en/partitioning-maintenance.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/optimize-table.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/optimize-table.html'),(114,'DECODE',12,'Syntax:\nDECODE(crypt_str,pass_str)\n\nDecrypts the encrypted string crypt_str using pass_str as the password.\ncrypt_str should be a string returned from ENCODE().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html'),(115,'<=>',18,'Syntax:\n<=>\n\nNULL-safe equal. This operator performs an equality comparison like the\n= operator, but returns 1 rather than NULL if both operands are NULL,\nand 0 rather than NULL if one operand is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html\n\n','mysql> SELECT 1 <=> 1, NULL <=> NULL, 1 <=> NULL;\n        -> 1, 1, 0\nmysql> SELECT 1 = 1, NULL = NULL, 1 = NULL;\n        -> 1, NULL, NULL\n','http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html'),(116,'HELP STATEMENT',28,'Syntax:\nHELP \'search_string\'\n\nThe HELP statement returns online information from the MySQL Reference\nmanual. Its proper operation requires that the help tables in the mysql\ndatabase be initialized with help topic information (see\nhttp://dev.mysql.com/doc/refman/5.1/en/server-side-help-support.html).\n\nThe HELP statement searches the help tables for the given search string\nand displays the result of the search. The search string is not case\nsensitive.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/help.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/help.html'),(117,'RESET',26,'Syntax:\nRESET reset_option [, reset_option] ...\n\nThe RESET statement is used to clear the state of various server\noperations. You must have the RELOAD privilege to execute RESET.\n\nRESET acts as a stronger version of the FLUSH statement. See [HELP\nFLUSH].\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/reset.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/reset.html'),(118,'LOAD DATA FROM MASTER',8,'Syntax:\nLOAD DATA FROM MASTER\n\nThis feature is deprecated and should be avoided. It is subject to\nremoval in a future version of MySQL.\n\nSince the current implementation of LOAD DATA FROM MASTER and LOAD\nTABLE FROM MASTER is very limited, these statements are deprecated as\nof MySQL 4.1 and removed in MySQL 5.5.\n\nThe recommended alternative solution to using LOAD DATA FROM MASTER or\nLOAD TABLE FROM MASTER is using mysqldump or mysqlhotcopy. The latter\nrequires Perl and two Perl modules (DBI and DBD:mysql) and works for\nMyISAM and ARCHIVE tables only. With mysqldump, you can create SQL\ndumps on the master and pipe (or copy) these to a mysql client on the\nslave. This has the advantage of working for all storage engines, but\ncan be quite slow, since it works using SELECT.\n\nThis statement takes a snapshot of the master and copies it to the\nslave. It updates the values of MASTER_LOG_FILE and MASTER_LOG_POS so\nthat the slave starts replicating from the correct position. Any table\nand database exclusion rules specified with the --replicate-*-do-* and\n--replicate-*-ignore-* options are honored. --replicate-rewrite-db is\nnot taken into account because a user could use this option to set up a\nnonunique mapping such as --replicate-rewrite-db=\"db1->db3\" and\n--replicate-rewrite-db=\"db2->db3\", which would confuse the slave when\nloading tables from the master.\n\nUse of this statement is subject to the following conditions:\n\no It works only for MyISAM tables. Attempting to load a non-MyISAM\n  table results in the following error:\n\nERROR 1189 (08S01): Net error reading from master\n\no It acquires a global read lock on the master while taking the\n  snapshot, which prevents updates on the master during the load\n  operation.\n\nIf you are loading large tables, you might have to increase the values\nof net_read_timeout and net_write_timeout on both the master and slave\nservers. See\nhttp://dev.mysql.com/doc/refman/5.1/en/server-system-variables.html.\n\nNote that LOAD DATA FROM MASTER does not copy any tables from the mysql\ndatabase. This makes it easy to have different users and privileges on\nthe master and the slave.\n\nTo use LOAD DATA FROM MASTER, the replication account that is used to\nconnect to the master must have the RELOAD and SUPER privileges on the\nmaster and the SELECT privilege for all master tables you want to load.\nAll master tables for which the user does not have the SELECT privilege\nare ignored by LOAD DATA FROM MASTER. This is because the master hides\nthem from the user: LOAD DATA FROM MASTER calls SHOW DATABASES to know\nthe master databases to load, but SHOW DATABASES returns only databases\nfor which the user has some privilege. See [HELP SHOW DATABASES]. On\nthe slave side, the user that issues LOAD DATA FROM MASTER must have\nprivileges for dropping and creating the databases and tables that are\ncopied.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/load-data-from-master.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/load-data-from-master.html'),(119,'GET_LOCK',15,'Syntax:\nGET_LOCK(str,timeout)\n\nTries to obtain a lock with a name given by the string str, using a\ntimeout of timeout seconds. Returns 1 if the lock was obtained\nsuccessfully, 0 if the attempt timed out (for example, because another\nclient has previously locked the name), or NULL if an error occurred\n(such as running out of memory or the thread was killed with mysqladmin\nkill). If you have a lock obtained with GET_LOCK(), it is released when\nyou execute RELEASE_LOCK(), execute a new GET_LOCK(), or your\nconnection terminates (either normally or abnormally). Locks obtained\nwith GET_LOCK() do not interact with transactions. That is, committing\na transaction does not release any such locks obtained during the\ntransaction.\n\nThis function can be used to implement application locks or to simulate\nrecord locks. Names are locked on a server-wide basis. If a name has\nbeen locked by one client, GET_LOCK() blocks any request by another\nclient for a lock with the same name. This enables clients that agree\non a given lock name to use the name to perform cooperative advisory\nlocking. But be aware that it also enables a client that is not among\nthe set of cooperating clients to lock a name, either inadvertently or\ndeliberately, and thus prevent any of the cooperating clients from\nlocking that name. One way to reduce the likelihood of this is to use\nlock names that are database-specific or application-specific. For\nexample, use lock names of the form db_name.str or app_name.str.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html\n\n','mysql> SELECT GET_LOCK(\'lock1\',10);\n        -> 1\nmysql> SELECT IS_FREE_LOCK(\'lock2\');\n        -> 1\nmysql> SELECT GET_LOCK(\'lock2\',10);\n        -> 1\nmysql> SELECT RELEASE_LOCK(\'lock2\');\n        -> 1\nmysql> SELECT RELEASE_LOCK(\'lock1\');\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html'),(120,'UCASE',36,'Syntax:\nUCASE(str)\n\nUCASE() is a synonym for UPPER().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(121,'SHOW BINLOG EVENTS',26,'Syntax:\nSHOW BINLOG EVENTS\n   [IN \'log_name\'] [FROM pos] [LIMIT [offset,] row_count]\n\nShows the events in the binary log. If you do not specify \'log_name\',\nthe first binary log is displayed.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-binlog-events.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-binlog-events.html'),(122,'MPOLYFROMWKB',32,'MPolyFromWKB(wkb[,srid]), MultiPolygonFromWKB(wkb[,srid])\n\nConstructs a MULTIPOLYGON value using its WKB representation and SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkb-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkb-functions'),(123,'ITERATE',23,'Syntax:\nITERATE label\n\nITERATE can appear only within LOOP, REPEAT, and WHILE statements.\nITERATE means \"start the loop again.\"\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/iterate-statement.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/iterate-statement.html'),(124,'DO',27,'Syntax:\nDO expr [, expr] ...\n\nDO executes the expressions but does not return any results. In most\nrespects, DO is shorthand for SELECT expr, ..., but has the advantage\nthat it is slightly faster when you do not care about the result.\n\nDO is useful primarily with functions that have side effects, such as\nRELEASE_LOCK().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/do.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/do.html'),(125,'CURTIME',31,'Syntax:\nCURTIME()\n\nReturns the current time as a value in \'HH:MM:SS\' or HHMMSS.uuuuuu\nformat, depending on whether the function is used in a string or\nnumeric context. The value is expressed in the current time zone.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT CURTIME();\n        -> \'23:50:26\'\nmysql> SELECT CURTIME() + 0;\n        -> 235026.000000\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(126,'CHAR_LENGTH',36,'Syntax:\nCHAR_LENGTH(str)\n\nReturns the length of the string str, measured in characters. A\nmulti-byte character counts as a single character. This means that for\na string containing five two-byte characters, LENGTH() returns 10,\nwhereas CHAR_LENGTH() returns 5.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(127,'BIGINT',22,'BIGINT[(M)] [UNSIGNED] [ZEROFILL]\n\nA large integer. The signed range is -9223372036854775808 to\n9223372036854775807. The unsigned range is 0 to 18446744073709551615.\n\nSERIAL is an alias for BIGINT UNSIGNED NOT NULL AUTO_INCREMENT UNIQUE.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html'),(128,'SET',26,'Syntax:\nSET variable_assignment [, variable_assignment] ...\n\nvariable_assignment:\n      user_var_name = expr\n    | [GLOBAL | SESSION] system_var_name = expr\n    | [@@global. | @@session. | @@]system_var_name = expr\n\nThe SET statement assigns values to different types of variables that\naffect the operation of the server or your client. Older versions of\nMySQL employed SET OPTION, but this syntax is deprecated in favor of\nSET without OPTION.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/set-statement.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/set-statement.html'),(129,'CONV',4,'Syntax:\nCONV(N,from_base,to_base)\n\nConverts numbers between different number bases. Returns a string\nrepresentation of the number N, converted from base from_base to base\nto_base. Returns NULL if any argument is NULL. The argument N is\ninterpreted as an integer, but may be specified as an integer or a\nstring. The minimum base is 2 and the maximum base is 36. If to_base is\na negative number, N is regarded as a signed number. Otherwise, N is\ntreated as unsigned. CONV() works with 64-bit precision.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT CONV(\'a\',16,2);\n        -> \'1010\'\nmysql> SELECT CONV(\'6E\',18,8);\n        -> \'172\'\nmysql> SELECT CONV(-17,10,-18);\n        -> \'-H\'\nmysql> SELECT CONV(10+\'10\'+\'10\'+0xa,10,10);\n        -> \'40\'\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(130,'DATE',22,'DATE\n\nA date. The supported range is \'1000-01-01\' to \'9999-12-31\'. MySQL\ndisplays DATE values in \'YYYY-MM-DD\' format, but permits assignment of\nvalues to DATE columns using either strings or numbers.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-type-overview.html'),(131,'ASSIGN-VALUE',14,'Syntax:\n:=\n\nAssignment operator. Causes the user variable on the left hand side of\nthe operator to take on the value to its right. The value on the right\nhand side may be a literal value, another variable storing a value, or\nany legal expression that yields a scalar value, including the result\nof a query (provided that this value is a scalar value). You can\nperform multiple assignments in the same SET statement. You can perform\nmultiple assignments in the same statement-\n\nUnlike =, the := operator is never interpreted as a comparison\noperator. This means you can use := in any valid SQL statement (not\njust in SET statements) to assign a value to a variable.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/assignment-operators.html\n\n','mysql> SELECT @var1, @var2;\n        -> NULL, NULL\nmysql> SELECT @var1 := 1, @var2;\n        -> 1, NULL\nmysql> SELECT @var1, @var2;\n        -> 1, NULL\nmysql> SELECT @var1, @var2 := @var1;\n        -> 1, 1\nmysql> SELECT @var1, @var2;\n        -> 1, 1\n\nmysql> SELECT @var1:=COUNT(*) FROM t1;\n        -> 4\nmysql> SELECT @var1;\n        -> 4\n','http://dev.mysql.com/doc/refman/5.1/en/assignment-operators.html'),(132,'SHOW OPEN TABLES',26,'Syntax:\nSHOW OPEN TABLES [{FROM | IN} db_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW OPEN TABLES lists the non-TEMPORARY tables that are currently open\nin the table cache. See\nhttp://dev.mysql.com/doc/refman/5.1/en/table-cache.html. The WHERE\nclause can be given to select rows using more general conditions, as\ndiscussed in http://dev.mysql.com/doc/refman/5.1/en/extended-show.html.\n\nThe FROM and LIKE clauses may be used beginning with MySQL 5.1.24. The\nLIKE clause, if present, indicates which table names to match. The FROM\nclause, if present, restricts the tables shown to those present in the\ndb_name database.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-open-tables.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-open-tables.html'),(133,'EXTRACT',31,'Syntax:\nEXTRACT(unit FROM date)\n\nThe EXTRACT() function uses the same kinds of unit specifiers as\nDATE_ADD() or DATE_SUB(), but extracts parts from the date rather than\nperforming date arithmetic.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT EXTRACT(YEAR FROM \'2009-07-02\');\n       -> 2009\nmysql> SELECT EXTRACT(YEAR_MONTH FROM \'2009-07-02 01:02:03\');\n       -> 200907\nmysql> SELECT EXTRACT(DAY_MINUTE FROM \'2009-07-02 01:02:03\');\n       -> 20102\nmysql> SELECT EXTRACT(MICROSECOND\n    ->                FROM \'2003-01-02 10:30:00.000123\');\n        -> 123\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(134,'ENCRYPT',12,'Syntax:\nENCRYPT(str[,salt])\n\nEncrypts str using the Unix crypt() system call and returns a binary\nstring. The salt argument must be a string with at least two characters\nor the result will be NULL. If no salt argument is given, a random\nvalue is used.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html\n\n','mysql> SELECT ENCRYPT(\'hello\');\n        -> \'VxuFAJXVARROc\'\n','http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html'),(135,'SHOW STATUS',26,'Syntax:\nSHOW [GLOBAL | SESSION] STATUS\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW STATUS provides server status information. This information also\ncan be obtained using the mysqladmin extended-status command. The LIKE\nclause, if present, indicates which variable names to match. The WHERE\nclause can be given to select rows using more general conditions, as\ndiscussed in http://dev.mysql.com/doc/refman/5.1/en/extended-show.html.\nThis statement does not require any privilege. It requires only the\nability to connect to the server.\nWith a LIKE clause, the statement displays only rows for those\nvariables with names that match the pattern:\n\nmysql> SHOW STATUS LIKE \'Key%\';\n+--------------------+----------+\n| Variable_name      | Value    |\n+--------------------+----------+\n| Key_blocks_used    | 14955    |\n| Key_read_requests  | 96854827 |\n| Key_reads          | 162040   |\n| Key_write_requests | 7589728  |\n| Key_writes         | 3813196  |\n+--------------------+----------+\n\nWith the GLOBAL modifier, SHOW STATUS displays the status values for\nall connections to MySQL. With SESSION, it displays the status values\nfor the current connection. If no modifier is present, the default is\nSESSION. LOCAL is a synonym for SESSION.\n\nSome status variables have only a global value. For these, you get the\nsame value for both GLOBAL and SESSION. The scope for each status\nvariable is listed at\nhttp://dev.mysql.com/doc/refman/5.1/en/server-status-variables.html.\n\nEach invocation of the SHOW STATUS statement uses an internal temporary\ntable and increments the global Created_tmp_tables value.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-status.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-status.html'),(136,'EXTRACTVALUE',36,'Syntax:\nExtractValue(xml_frag, xpath_expr)\n\nExtractValue() takes two string arguments, a fragment of XML markup\nxml_frag and an XPath expression xpath_expr (also known as a locator);\nit returns the text (CDATA) of the first text node which is a child of\nthe element(s) matched by the XPath expression. It is the equivalent of\nperforming a match using the xpath_expr after appending /text(). In\nother words, ExtractValue(\'<a><b>Sakila</b></a>\', \'/a/b\') and\nExtractValue(\'<a><b>Sakila</b></a>\', \'/a/b/text()\') produce the same\nresult.\n\nIf multiple matches are found, the content of the first child text node\nof each matching element is returned (in the order matched) as a\nsingle, space-delimited string.\n\nIf no matching text node is found for the expression (including the\nimplicit /text())---for whatever reason, as long as xpath_expr is\nvalid, and xml_frag consists of elements which are properly nested and\nclosed---an empty string is returned. No distinction is made between a\nmatch on an empty element and no match at all. This is by design.\n\nIf you need to determine whether no matching element was found in\nxml_frag or such an element was found but contained no child text\nnodes, you should test the result of an expression that uses the XPath\ncount() function. For example, both of these statements return an empty\nstring, as shown here:\n\nmysql> SELECT ExtractValue(\'<a><b/></a>\', \'/a/b\');\n+-------------------------------------+\n| ExtractValue(\'<a><b/></a>\', \'/a/b\') |\n+-------------------------------------+\n|                                     |\n+-------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT ExtractValue(\'<a><c/></a>\', \'/a/b\');\n+-------------------------------------+\n| ExtractValue(\'<a><c/></a>\', \'/a/b\') |\n+-------------------------------------+\n|                                     |\n+-------------------------------------+\n1 row in set (0.00 sec)\n\nHowever, you can determine whether there was actually a matching\nelement using the following:\n\nmysql> SELECT ExtractValue(\'<a><b/></a>\', \'count(/a/b)\');\n+-------------------------------------+\n| ExtractValue(\'<a><b/></a>\', \'count(/a/b)\') |\n+-------------------------------------+\n| 1                                   |\n+-------------------------------------+\n1 row in set (0.00 sec)\n\nmysql> SELECT ExtractValue(\'<a><c/></a>\', \'count(/a/b)\');\n+-------------------------------------+\n| ExtractValue(\'<a><c/></a>\', \'count(/a/b)\') |\n+-------------------------------------+\n| 0                                   |\n+-------------------------------------+\n1 row in set (0.01 sec)\n\n*Important*: ExtractValue() returns only CDATA, and does not return any\ntags that might be contained within a matching tag, nor any of their\ncontent (see the result returned as val1 in the following example).\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/xml-functions.html\n\n','mysql> SELECT\n    ->   ExtractValue(\'<a>ccc<b>ddd</b></a>\', \'/a\') AS val1,\n    ->   ExtractValue(\'<a>ccc<b>ddd</b></a>\', \'/a/b\') AS val2,\n    ->   ExtractValue(\'<a>ccc<b>ddd</b></a>\', \'//b\') AS val3,\n    ->   ExtractValue(\'<a>ccc<b>ddd</b></a>\', \'/b\') AS val4,\n    ->   ExtractValue(\'<a>ccc<b>ddd</b><b>eee</b></a>\', \'//b\') AS val5;\n\n+------+------+------+------+---------+\n| val1 | val2 | val3 | val4 | val5    |\n+------+------+------+------+---------+\n| ccc  | ddd  | ddd  |      | ddd eee |\n+------+------+------+------+---------+\n','http://dev.mysql.com/doc/refman/5.1/en/xml-functions.html'),(137,'OLD_PASSWORD',12,'Syntax:\nOLD_PASSWORD(str)\n\nOLD_PASSWORD() was added when the implementation of PASSWORD() was\nchanged in MySQL 4.1 to improve security. OLD_PASSWORD() returns the\nvalue of the pre-4.1 implementation of PASSWORD() as a binary string,\nand is intended to permit you to reset passwords for any pre-4.1\nclients that need to connect to your version 5.1 MySQL server without\nlocking them out. See\nhttp://dev.mysql.com/doc/refman/5.1/en/password-hashing.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html'),(138,'FORMAT',36,'Syntax:\nFORMAT(X,D)\n\nFormats the number X to a format like \'#,###,###.##\', rounded to D\ndecimal places, and returns the result as a string. If D is 0, the\nresult has no decimal point or fractional part.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT FORMAT(12332.123456, 4);\n        -> \'12,332.1235\'\nmysql> SELECT FORMAT(12332.1,4);\n        -> \'12,332.1000\'\nmysql> SELECT FORMAT(12332.2,0);\n        -> \'12,332\'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(139,'||',14,'Syntax:\nOR, ||\n\nLogical OR. When both operands are non-NULL, the result is 1 if any\noperand is nonzero, and 0 otherwise. With a NULL operand, the result is\n1 if the other operand is nonzero, and NULL otherwise. If both operands\nare NULL, the result is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/logical-operators.html\n\n','mysql> SELECT 1 || 1;\n        -> 1\nmysql> SELECT 1 || 0;\n        -> 1\nmysql> SELECT 0 || 0;\n        -> 0\nmysql> SELECT 0 || NULL;\n        -> NULL\nmysql> SELECT 1 || NULL;\n        -> 1\n','http://dev.mysql.com/doc/refman/5.1/en/logical-operators.html'),(140,'BIT_LENGTH',36,'Syntax:\nBIT_LENGTH(str)\n\nReturns the length of the string str in bits.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT BIT_LENGTH(\'text\');\n        -> 32\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(141,'EXTERIORRING',2,'ExteriorRing(poly)\n\nReturns the exterior ring of the Polygon value poly as a LineString.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#polygon-property-functions\n\n','mysql> SET @poly =\n    -> \'Polygon((0 0,0 3,3 3,3 0,0 0),(1 1,1 2,2 2,2 1,1 1))\';\nmysql> SELECT AsText(ExteriorRing(GeomFromText(@poly)));\n+-------------------------------------------+\n| AsText(ExteriorRing(GeomFromText(@poly))) |\n+-------------------------------------------+\n| LINESTRING(0 0,0 3,3 3,3 0,0 0)           |\n+-------------------------------------------+\n','http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#polygon-property-functions'),(142,'GEOMFROMWKB',32,'GeomFromWKB(wkb[,srid]), GeometryFromWKB(wkb[,srid])\n\nConstructs a geometry value of any type using its WKB representation\nand SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkb-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkb-functions'),(143,'SHOW SLAVE HOSTS',26,'Syntax:\nSHOW SLAVE HOSTS\n\nDisplays a list of replication slaves currently registered with the\nmaster. Only slaves started with the --report-host=host_name option are\nvisible in this list.\n\nThe list is displayed on any server (not just the master server). The\noutput looks like this:\n\nmysql> SHOW SLAVE HOSTS;\n+------------+-----------+------+-----------+\n| Server_id  | Host      | Port | Master_id |\n+------------+-----------+------+-----------+\n|  192168010 | iconnect2 | 3306 | 192168011 |\n| 1921680101 | athena    | 3306 | 192168011 |\n+------------+-----------+------+-----------+\n\no Server_id: The unique server ID of the slave server, as configured in\n  the server\'s option file, or on the command line with\n  --server-id=value.\n\no Host: The host name of the slave server, as configured in the\n  server\'s option file, or on the command line with\n  --report-host=host_name. Note that this can differ from the machine\n  name as configured in the operating system.\n\no Port: The port the slave server is listening on.\n\no Master_id: The unique server ID of the master server that the slave\n  server is replicating from.\n\nSome MySQL versions report another variable, Rpl_recovery_rank. This\nvariable was never used, and was eventually removed. (Bug #13963)\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-slave-hosts.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-slave-hosts.html'),(144,'START TRANSACTION',8,'Syntax:\nSTART TRANSACTION [WITH CONSISTENT SNAPSHOT]\nBEGIN [WORK]\nCOMMIT [WORK] [AND [NO] CHAIN] [[NO] RELEASE]\nROLLBACK [WORK] [AND [NO] CHAIN] [[NO] RELEASE]\nSET autocommit = {0 | 1}\n\nThese statements provide control over use of transactions:\n\no START TRANSACTION or BEGIN start a new transaction\n\no COMMIT commits the current transaction, making its changes permanent\n\no ROLLBACK rolls back the current transaction, canceling its changes\n\no SET autocommit disables or enables the default autocommit mode for\n  the current session\n\nBy default, MySQL runs with autocommit mode enabled. This means that as\nsoon as you execute a statement that updates (modifies) a table, MySQL\nstores the update on disk to make it permanent.\n\nTo disable autocommit mode implicitly for a single series of\nstatements, use the START TRANSACTION statement:\n\nSTART TRANSACTION;\nSELECT @A:=SUM(salary) FROM table1 WHERE type=1;\nUPDATE table2 SET summary=@A WHERE type=1;\nCOMMIT;\n\nWith START TRANSACTION, autocommit remains disabled until you end the\ntransaction with COMMIT or ROLLBACK. The autocommit mode then reverts\nto its previous state.\n\nYou can also begin a transaction like this:\n\nSTART TRANSACTION WITH CONSISTENT SNAPSHOT;\n\nThe WITH CONSISTENT SNAPSHOT option starts a consistent read for\nstorage engines that are capable of it. This applies only to InnoDB.\nThe effect is the same as issuing a START TRANSACTION followed by a\nSELECT from any InnoDB table. See\nhttp://dev.mysql.com/doc/refman/5.1/en/innodb-consistent-read.html. The\nWITH CONSISTENT SNAPSHOT option does not change the current transaction\nisolation level, so it provides a consistent snapshot only if the\ncurrent isolation level is one that permits consistent read (REPEATABLE\nREAD or SERIALIZABLE).\n\n*Important*: Many APIs used for writing MySQL client applications (such\nas JDBC) provide their own methods for starting transactions that can\n(and sometimes should) be used instead of sending a START TRANSACTION\nstatement from the client. See\nhttp://dev.mysql.com/doc/refman/5.1/en/connectors-apis.html, or the\ndocumentation for your API, for more information.\n\nTo disable autocommit mode explicitly, use the following statement:\n\nSET autocommit=0;\n\nAfter disabling autocommit mode by setting the autocommit variable to\nzero, changes to transaction-safe tables (such as those for InnoDB or\nNDBCLUSTER) are not made permanent immediately. You must use COMMIT to\nstore your changes to disk or ROLLBACK to ignore the changes.\n\nautocommit is a session variable and must be set for each session. To\ndisable autocommit mode for each new connection, see the description of\nthe autocommit system variable at\nhttp://dev.mysql.com/doc/refman/5.1/en/server-system-variables.html.\n\nBEGIN and BEGIN WORK are supported as aliases of START TRANSACTION for\ninitiating a transaction. START TRANSACTION is standard SQL syntax and\nis the recommended way to start an ad-hoc transaction.\n\nThe BEGIN statement differs from the use of the BEGIN keyword that\nstarts a BEGIN ... END compound statement. The latter does not begin a\ntransaction. See [HELP BEGIN END].\n\n*Note*: Within all stored programs (stored procedures and functions,\ntriggers, and events), the parser treats BEGIN [WORK] as the beginning\nof a BEGIN ... END block. Begin a transaction in this context with\nSTART TRANSACTION instead.\n\nThe optional WORK keyword is supported for COMMIT and ROLLBACK, as are\nthe CHAIN and RELEASE clauses. CHAIN and RELEASE can be used for\nadditional control over transaction completion. The value of the\ncompletion_type system variable determines the default completion\nbehavior. See\nhttp://dev.mysql.com/doc/refman/5.1/en/server-system-variables.html.\n\nThe AND CHAIN clause causes a new transaction to begin as soon as the\ncurrent one ends, and the new transaction has the same isolation level\nas the just-terminated transaction. The RELEASE clause causes the\nserver to disconnect the current client session after terminating the\ncurrent transaction. Including the NO keyword suppresses CHAIN or\nRELEASE completion, which can be useful if the completion_type system\nvariable is set to cause chaining or release completion by default.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/commit.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/commit.html'),(145,'BETWEEN AND',18,'Syntax:\nexpr BETWEEN min AND max\n\nIf expr is greater than or equal to min and expr is less than or equal\nto max, BETWEEN returns 1, otherwise it returns 0. This is equivalent\nto the expression (min <= expr AND expr <= max) if all the arguments\nare of the same type. Otherwise type conversion takes place according\nto the rules described in\nhttp://dev.mysql.com/doc/refman/5.1/en/type-conversion.html, but\napplied to all the three arguments.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html\n\n','mysql> SELECT 2 BETWEEN 1 AND 3, 2 BETWEEN 3 and 1;\n        -> 1, 0\nmysql> SELECT 1 BETWEEN 2 AND 3;\n        -> 0\nmysql> SELECT \'b\' BETWEEN \'a\' AND \'c\';\n        -> 1\nmysql> SELECT 2 BETWEEN 2 AND \'3\';\n        -> 1\nmysql> SELECT 2 BETWEEN 2 AND \'x-3\';\n        -> 0\n','http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html'),(146,'MULTIPOLYGON',24,'MultiPolygon(poly1,poly2,...)\n\nConstructs a MultiPolygon value from a set of Polygon or WKB Polygon\narguments.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-mysql-specific-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-mysql-specific-functions'),(147,'TIME_FORMAT',31,'Syntax:\nTIME_FORMAT(time,format)\n\nThis is used like the DATE_FORMAT() function, but the format string may\ncontain format specifiers only for hours, minutes, seconds, and\nmicroseconds. Other specifiers produce a NULL value or 0.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT TIME_FORMAT(\'100:00:00\', \'%H %k %h %I %l\');\n        -> \'100 100 04 04 4\'\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(148,'LEFT',36,'Syntax:\nLEFT(str,len)\n\nReturns the leftmost len characters from the string str, or NULL if any\nargument is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT LEFT(\'foobarbar\', 5);\n        -> \'fooba\'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(149,'FLUSH QUERY CACHE',26,'You can defragment the query cache to better utilize its memory with\nthe FLUSH QUERY CACHE statement. The statement does not remove any\nqueries from the cache.\n\nThe RESET QUERY CACHE statement removes all query results from the\nquery cache. The FLUSH TABLES statement also does this.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/query-cache-status-and-maintenance.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/query-cache-status-and-maintenance.html'),(150,'SET DATA TYPE',22,'SET(\'value1\',\'value2\',...) [CHARACTER SET charset_name] [COLLATE\ncollation_name]\n\nA set. A string object that can have zero or more values, each of which\nmust be chosen from the list of values \'value1\', \'value2\', ... A SET\ncolumn can have a maximum of 64 members. SET values are represented\ninternally as integers.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html'),(151,'RAND',4,'Syntax:\nRAND(), RAND(N)\n\nReturns a random floating-point value v in the range 0 <= v < 1.0. If a\nconstant integer argument N is specified, it is used as the seed value,\nwhich produces a repeatable sequence of column values. In the following\nexample, note that the sequences of values produced by RAND(3) is the\nsame both places where it occurs.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> CREATE TABLE t (i INT);\nQuery OK, 0 rows affected (0.42 sec)\n\nmysql> INSERT INTO t VALUES(1),(2),(3);\nQuery OK, 3 rows affected (0.00 sec)\nRecords: 3  Duplicates: 0  Warnings: 0\n\nmysql> SELECT i, RAND() FROM t;\n+------+------------------+\n| i    | RAND()           |\n+------+------------------+\n|    1 | 0.61914388706828 |\n|    2 | 0.93845168309142 |\n|    3 | 0.83482678498591 |\n+------+------------------+\n3 rows in set (0.00 sec)\n\nmysql> SELECT i, RAND(3) FROM t;\n+------+------------------+\n| i    | RAND(3)          |\n+------+------------------+\n|    1 | 0.90576975597606 |\n|    2 | 0.37307905813035 |\n|    3 | 0.14808605345719 |\n+------+------------------+\n3 rows in set (0.00 sec)\n\nmysql> SELECT i, RAND() FROM t;\n+------+------------------+\n| i    | RAND()           |\n+------+------------------+\n|    1 | 0.35877890638893 |\n|    2 | 0.28941420772058 |\n|    3 | 0.37073435016976 |\n+------+------------------+\n3 rows in set (0.00 sec)\n\nmysql> SELECT i, RAND(3) FROM t;\n+------+------------------+\n| i    | RAND(3)          |\n+------+------------------+\n|    1 | 0.90576975597606 |\n|    2 | 0.37307905813035 |\n|    3 | 0.14808605345719 |\n+------+------------------+\n3 rows in set (0.01 sec)\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(152,'RPAD',36,'Syntax:\nRPAD(str,len,padstr)\n\nReturns the string str, right-padded with the string padstr to a length\nof len characters. If str is longer than len, the return value is\nshortened to len characters.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT RPAD(\'hi\',5,\'?\');\n        -> \'hi???\'\nmysql> SELECT RPAD(\'hi\',1,\'?\');\n        -> \'h\'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(153,'CREATE DATABASE',38,'Syntax:\nCREATE {DATABASE | SCHEMA} [IF NOT EXISTS] db_name\n    [create_specification] ...\n\ncreate_specification:\n    [DEFAULT] CHARACTER SET [=] charset_name\n  | [DEFAULT] COLLATE [=] collation_name\n\nCREATE DATABASE creates a database with the given name. To use this\nstatement, you need the CREATE privilege for the database. CREATE\nSCHEMA is a synonym for CREATE DATABASE.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/create-database.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/create-database.html'),(154,'DEC',22,'DEC[(M[,D])] [UNSIGNED] [ZEROFILL], NUMERIC[(M[,D])] [UNSIGNED]\n[ZEROFILL], FIXED[(M[,D])] [UNSIGNED] [ZEROFILL]\n\nThese types are synonyms for DECIMAL. The FIXED synonym is available\nfor compatibility with other database systems.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html'),(155,'VAR_POP',16,'Syntax:\nVAR_POP(expr)\n\nReturns the population standard variance of expr. It considers rows as\nthe whole population, not as a sample, so it has the number of rows as\nthe denominator. You can also use VARIANCE(), which is equivalent but\nis not standard SQL.\n\nVAR_POP() returns NULL if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html'),(156,'ELT',36,'Syntax:\nELT(N,str1,str2,str3,...)\n\nReturns str1 if N = 1, str2 if N = 2, and so on. Returns NULL if N is\nless than 1 or greater than the number of arguments. ELT() is the\ncomplement of FIELD().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT ELT(1, \'ej\', \'Heja\', \'hej\', \'foo\');\n        -> \'ej\'\nmysql> SELECT ELT(4, \'ej\', \'Heja\', \'hej\', \'foo\');\n        -> \'foo\'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(157,'ALTER VIEW',38,'Syntax:\nALTER\n    [ALGORITHM = {UNDEFINED | MERGE | TEMPTABLE}]\n    [DEFINER = { user | CURRENT_USER }]\n    [SQL SECURITY { DEFINER | INVOKER }]\n    VIEW view_name [(column_list)]\n    AS select_statement\n    [WITH [CASCADED | LOCAL] CHECK OPTION]\n\nThis statement changes the definition of a view, which must exist. The\nsyntax is similar to that for CREATE VIEW and the effect is the same as\nfor CREATE OR REPLACE VIEW. See [HELP CREATE VIEW]. This statement\nrequires the CREATE VIEW and DROP privileges for the view, and some\nprivilege for each column referred to in the SELECT statement. As of\nMySQL 5.1.23, ALTER VIEW is permitted only to the definer or users with\nthe SUPER privilege.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/alter-view.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/alter-view.html'),(158,'SHOW DATABASES',26,'Syntax:\nSHOW {DATABASES | SCHEMAS}\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW DATABASES lists the databases on the MySQL server host. SHOW\nSCHEMAS is a synonym for SHOW DATABASES. The LIKE clause, if present,\nindicates which database names to match. The WHERE clause can be given\nto select rows using more general conditions, as discussed in\nhttp://dev.mysql.com/doc/refman/5.1/en/extended-show.html.\n\nYou see only those databases for which you have some kind of privilege,\nunless you have the global SHOW DATABASES privilege. You can also get\nthis list using the mysqlshow command.\n\nIf the server was started with the --skip-show-database option, you\ncannot use this statement at all unless you have the SHOW DATABASES\nprivilege.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-databases.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-databases.html'),(159,'~',19,'Syntax:\n~\n\nInvert all bits.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/bit-functions.html\n\n','mysql> SELECT 5 & ~1;\n        -> 4\n','http://dev.mysql.com/doc/refman/5.1/en/bit-functions.html'),(160,'TEXT',22,'TEXT[(M)] [CHARACTER SET charset_name] [COLLATE collation_name]\n\nA TEXT column with a maximum length of 65,535 (216 - 1) characters. The\neffective maximum length is less if the value contains multi-byte\ncharacters. Each TEXT value is stored using a two-byte length prefix\nthat indicates the number of bytes in the value.\n\nAn optional length M can be given for this type. If this is done, MySQL\ncreates the column as the smallest TEXT type large enough to hold\nvalues M characters long.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html'),(161,'CONCAT_WS',36,'Syntax:\nCONCAT_WS(separator,str1,str2,...)\n\nCONCAT_WS() stands for Concatenate With Separator and is a special form\nof CONCAT(). The first argument is the separator for the rest of the\narguments. The separator is added between the strings to be\nconcatenated. The separator can be a string, as can the rest of the\narguments. If the separator is NULL, the result is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT CONCAT_WS(\',\',\'First name\',\'Second name\',\'Last Name\');\n        -> \'First name,Second name,Last Name\'\nmysql> SELECT CONCAT_WS(\',\',\'First name\',NULL,\'Last Name\');\n        -> \'First name,Last Name\'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(162,'ROW_COUNT',17,'Syntax:\nROW_COUNT()\n\nROW_COUNT() returns the number of rows changed, deleted, or inserted by\nthe last statement if it was an UPDATE, DELETE, or INSERT. For other\nstatements, the value may not be meaningful.\n\nFor UPDATE statements, the affected-rows value by default is the number\nof rows actually changed. If you specify the CLIENT_FOUND_ROWS flag to\nmysql_real_connect() when connecting to mysqld, the affected-rows value\nis the number of rows \"found\"; that is, matched by the WHERE clause.\n\nFor REPLACE statements, the affected-rows value is 2 if the new row\nreplaced an old row, because in this case, one row was inserted after\nthe duplicate was deleted.\n\nFor INSERT ... ON DUPLICATE KEY UPDATE statements, the affected-rows\nvalue is 1 if the row is inserted as a new row and 2 if an existing row\nis updated.\n\nThe ROW_COUNT() value is similar to the value from the\nmysql_affected_rows() C API function and the row count that the mysql\nclient displays following statement execution.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/information-functions.html\n\n','mysql> INSERT INTO t VALUES(1),(2),(3);\nQuery OK, 3 rows affected (0.00 sec)\nRecords: 3  Duplicates: 0  Warnings: 0\n\nmysql> SELECT ROW_COUNT();\n+-------------+\n| ROW_COUNT() |\n+-------------+\n|           3 |\n+-------------+\n1 row in set (0.00 sec)\n\nmysql> DELETE FROM t WHERE i IN(1,2);\nQuery OK, 2 rows affected (0.00 sec)\n\nmysql> SELECT ROW_COUNT();\n+-------------+\n| ROW_COUNT() |\n+-------------+\n|           2 |\n+-------------+\n1 row in set (0.00 sec)\n','http://dev.mysql.com/doc/refman/5.1/en/information-functions.html'),(163,'ASIN',4,'Syntax:\nASIN(X)\n\nReturns the arc sine of X, that is, the value whose sine is X. Returns\nNULL if X is not in the range -1 to 1.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT ASIN(0.2);\n        -> 0.20135792079033\nmysql> SELECT ASIN(\'foo\');\n\n+-------------+\n| ASIN(\'foo\') |\n+-------------+\n|           0 |\n+-------------+\n1 row in set, 1 warning (0.00 sec)\n\nmysql> SHOW WARNINGS;\n+---------+------+-----------------------------------------+\n| Level   | Code | Message                                 |\n+---------+------+-----------------------------------------+\n| Warning | 1292 | Truncated incorrect DOUBLE value: \'foo\' |\n+---------+------+-----------------------------------------+\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(164,'SIGN',4,'Syntax:\nSIGN(X)\n\nReturns the sign of the argument as -1, 0, or 1, depending on whether X\nis negative, zero, or positive.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT SIGN(-32);\n        -> -1\nmysql> SELECT SIGN(0);\n        -> 0\nmysql> SELECT SIGN(234);\n        -> 1\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(165,'SEC_TO_TIME',31,'Syntax:\nSEC_TO_TIME(seconds)\n\nReturns the seconds argument, converted to hours, minutes, and seconds,\nas a TIME value. The range of the result is constrained to that of the\nTIME data type. A warning occurs if the argument corresponds to a value\noutside that range.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT SEC_TO_TIME(2378);\n        -> \'00:39:38\'\nmysql> SELECT SEC_TO_TIME(2378) + 0;\n        -> 3938\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(166,'FLOAT',22,'FLOAT[(M,D)] [UNSIGNED] [ZEROFILL]\n\nA small (single-precision) floating-point number. Permissible values\nare -3.402823466E+38 to -1.175494351E-38, 0, and 1.175494351E-38 to\n3.402823466E+38. These are the theoretical limits, based on the IEEE\nstandard. The actual range might be slightly smaller depending on your\nhardware or operating system.\n\nM is the total number of digits and D is the number of digits following\nthe decimal point. If M and D are omitted, values are stored to the\nlimits permitted by the hardware. A single-precision floating-point\nnumber is accurate to approximately 7 decimal places.\n\nUNSIGNED, if specified, disallows negative values.\n\nUsing FLOAT might give you some unexpected problems because all\ncalculations in MySQL are done with double precision. See\nhttp://dev.mysql.com/doc/refman/5.1/en/no-matching-rows.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html'),(167,'LOCATE',36,'Syntax:\nLOCATE(substr,str), LOCATE(substr,str,pos)\n\nThe first syntax returns the position of the first occurrence of\nsubstring substr in string str. The second syntax returns the position\nof the first occurrence of substring substr in string str, starting at\nposition pos. Returns 0 if substr is not in str.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT LOCATE(\'bar\', \'foobarbar\');\n        -> 4\nmysql> SELECT LOCATE(\'xbar\', \'foobar\');\n        -> 0\nmysql> SELECT LOCATE(\'bar\', \'foobarbar\', 5);\n        -> 7\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(168,'SHOW EVENTS',26,'Syntax:\nSHOW EVENTS [{FROM | IN} schema_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nThis statement displays information about Event Manager events. It\nrequires the EVENT privilege for the database from which the events are\nto be shown.\n\nIn its simplest form, SHOW EVENTS lists all of the events in the\ncurrent schema:\n\nmysql> SELECT CURRENT_USER(), SCHEMA();\n+----------------+----------+\n| CURRENT_USER() | SCHEMA() |\n+----------------+----------+\n| jon@ghidora    | myschema |\n+----------------+----------+\n1 row in set (0.00 sec)\n\nmysql> SHOW EVENTS\\G\n*************************** 1. row ***************************\n                  Db: myschema\n                Name: e_daily\n             Definer: jon@ghidora\n           Time zone: SYSTEM\n                Type: RECURRING\n          Execute at: NULL\n      Interval value: 10\n      Interval field: SECOND\n              Starts: 2006-02-09 10:41:23\n                Ends: NULL\n              Status: ENABLED\n          Originator: 0\ncharacter_set_client: latin1\ncollation_connection: latin1_swedish_ci\n  Database Collation: latin1_swedish_ci\n\nTo see events for a specific schema, use the FROM clause. For example,\nto see events for the test schema, use the following statement:\n\nSHOW EVENTS FROM test;\n\nThe LIKE clause, if present, indicates which event names to match. The\nWHERE clause can be given to select rows using more general conditions,\nas discussed in\nhttp://dev.mysql.com/doc/refman/5.1/en/extended-show.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-events.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-events.html'),(169,'CHARSET',17,'Syntax:\nCHARSET(str)\n\nReturns the character set of the string argument.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/information-functions.html\n\n','mysql> SELECT CHARSET(\'abc\');\n        -> \'latin1\'\nmysql> SELECT CHARSET(CONVERT(\'abc\' USING utf8));\n        -> \'utf8\'\nmysql> SELECT CHARSET(USER());\n        -> \'utf8\'\n','http://dev.mysql.com/doc/refman/5.1/en/information-functions.html'),(170,'SUBDATE',31,'Syntax:\nSUBDATE(date,INTERVAL expr unit), SUBDATE(expr,days)\n\nWhen invoked with the INTERVAL form of the second argument, SUBDATE()\nis a synonym for DATE_SUB(). For information on the INTERVAL unit\nargument, see the discussion for DATE_ADD().\n\nmysql> SELECT DATE_SUB(\'2008-01-02\', INTERVAL 31 DAY);\n        -> \'2007-12-02\'\nmysql> SELECT SUBDATE(\'2008-01-02\', INTERVAL 31 DAY);\n        -> \'2007-12-02\'\n\nThe second form enables the use of an integer value for days. In such\ncases, it is interpreted as the number of days to be subtracted from\nthe date or datetime expression expr.\n\nmysql> SELECT SUBDATE(\'2008-01-02 12:00:00\', 31);\n        -> \'2007-12-02 12:00:00\'\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(171,'DAYOFYEAR',31,'Syntax:\nDAYOFYEAR(date)\n\nReturns the day of the year for date, in the range 1 to 366.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT DAYOFYEAR(\'2007-02-03\');\n        -> 34\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(172,'LONGTEXT',22,'LONGTEXT [CHARACTER SET charset_name] [COLLATE collation_name]\n\nA TEXT column with a maximum length of 4,294,967,295 or 4GB (232 - 1)\ncharacters. The effective maximum length is less if the value contains\nmulti-byte characters. The effective maximum length of LONGTEXT columns\nalso depends on the configured maximum packet size in the client/server\nprotocol and available memory. Each LONGTEXT value is stored using a\nfour-byte length prefix that indicates the number of bytes in the\nvalue.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html'),(173,'%',4,'Syntax:\nN % M, N MOD M\n\nModulo operation. Returns the remainder of N divided by M. For more\ninformation, see the description for the MOD() function in\nhttp://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/arithmetic-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/arithmetic-functions.html'),(174,'KILL',26,'Syntax:\nKILL [CONNECTION | QUERY] thread_id\n\nEach connection to mysqld runs in a separate thread. You can see which\nthreads are running with the SHOW PROCESSLIST statement and kill a\nthread with the KILL thread_id statement.\n\nKILL permits an optional CONNECTION or QUERY modifier:\n\no KILL CONNECTION is the same as KILL with no modifier: It terminates\n  the connection associated with the given thread_id.\n\no KILL QUERY terminates the statement that the connection is currently\n  executing, but leaves the connection itself intact.\n\nIf you have the PROCESS privilege, you can see all threads. If you have\nthe SUPER privilege, you can kill all threads and statements.\nOtherwise, you can see and kill only your own threads and statements.\n\nYou can also use the mysqladmin processlist and mysqladmin kill\ncommands to examine and kill threads.\n\n*Note*: You cannot use KILL with the Embedded MySQL Server library\nbecause the embedded server merely runs inside the threads of the host\napplication. It does not create any connection threads of its own.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/kill.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/kill.html'),(175,'DISJOINT',30,'Disjoint(g1,g2)\n\nReturns 1 or 0 to indicate whether g1 is spatially disjoint from (does\nnot intersect) g2.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-test-spatial-relationships-between-geometries\n\n','','http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-tes'),(176,'ASTEXT',3,'AsText(g), AsWKT(g)\n\nConverts a value in internal geometry format to its WKT representation\nand returns the string result.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/functions-to-convert-geometries-between-formats.html\n\n','mysql> SET @g = \'LineString(1 1,2 2,3 3)\';\nmysql> SELECT AsText(GeomFromText(@g));\n+--------------------------+\n| AsText(GeomFromText(@g)) |\n+--------------------------+\n| LINESTRING(1 1,2 2,3 3)  |\n+--------------------------+\n','http://dev.mysql.com/doc/refman/5.1/en/functions-to-convert-geometries-between-formats.html'),(177,'LPAD',36,'Syntax:\nLPAD(str,len,padstr)\n\nReturns the string str, left-padded with the string padstr to a length\nof len characters. If str is longer than len, the return value is\nshortened to len characters.\n\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT LPAD(\'hi\',4,\'??\');\n        -> \'??hi\'\nmysql> SELECT LPAD(\'hi\',1,\'??\');\n        -> \'h\'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(178,'RESTORE TABLE',20,'Syntax:\nRESTORE TABLE tbl_name [, tbl_name] ... FROM \'/path/to/backup/directory\'\n\n*Note*: This statement is deprecated and is removed in MySQL 5.5.\n\nRESTORE TABLE restores the table or tables from a backup that was made\nwith BACKUP TABLE. The directory should be specified as a full path\nname.\n\nExisting tables are not overwritten; if you try to restore over an\nexisting table, an error occurs. Just as for BACKUP TABLE, RESTORE\nTABLE currently works only for MyISAM tables. Restored tables are not\nreplicated from master to slave.\n\nThe backup for each table consists of its .frm format file and .MYD\ndata file. The restore operation restores those files, and then uses\nthem to rebuild the .MYI index file. Restoring takes longer than\nbacking up due to the need to rebuild the indexes. The more indexes the\ntable has, the longer it takes.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/restore-table.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/restore-table.html'),(179,'DECLARE CONDITION',23,'Syntax:\nDECLARE condition_name CONDITION FOR condition_value\n\ncondition_value:\n    mysql_error_code\n  | SQLSTATE [VALUE] sqlstate_value\n\nThe DECLARE ... CONDITION statement declares a named error condition,\nassociating a name with a condition that needs specific handling. The\nname can be referred to in a subsequent DECLARE ... HANDLER statement\n(see [HELP DECLARE HANDLER]).\n\nCondition declarations must appear before cursor or handler\ndeclarations.\n\nThe condition_value for DECLARE ... CONDITION can be a MySQL error code\n(a number) or an SQLSTATE value (a 5-character string literal). You\nshould not use MySQL error code 0 or SQLSTATE values that begin with\n\'00\', because those indicate success rather than an error condition.\nFor a list of MySQL error codes and SQLSTATE values, see\nhttp://dev.mysql.com/doc/refman/5.1/en/error-messages-server.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/declare-condition.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/declare-condition.html'),(180,'OVERLAPS',30,'Overlaps(g1,g2)\n\nReturns 1 or 0 to indicate whether g1 spatially overlaps g2. The term\nspatially overlaps is used if two geometries intersect and their\nintersection results in a geometry of the same dimension but not equal\nto either of the given geometries.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-test-spatial-relationships-between-geometries\n\n','','http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-tes'),(181,'SET GLOBAL SQL_SLAVE_SKIP_COUNTER',8,'Syntax:\nSET GLOBAL sql_slave_skip_counter = N\n\nThis statement skips the next N events from the master. This is useful\nfor recovering from replication stops caused by a statement.\n\nThis statement is valid only when the slave threads are not running.\nOtherwise, it produces an error.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/set-global-sql-slave-skip-counter.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/set-global-sql-slave-skip-counter.html'),(182,'NUMGEOMETRIES',25,'NumGeometries(gc)\n\nReturns the number of geometries in the GeometryCollection value gc.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#geometrycollection-property-functions\n\n','mysql> SET @gc = \'GeometryCollection(Point(1 1),LineString(2 2, 3 3))\';\nmysql> SELECT NumGeometries(GeomFromText(@gc));\n+----------------------------------+\n| NumGeometries(GeomFromText(@gc)) |\n+----------------------------------+\n|                                2 |\n+----------------------------------+\n','http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#geometrycollection-property-functions'),(183,'MONTHNAME',31,'Syntax:\nMONTHNAME(date)\n\nReturns the full name of the month for date. As of MySQL 5.1.12, the\nlanguage used for the name is controlled by the value of the\nlc_time_names system variable\n(http://dev.mysql.com/doc/refman/5.1/en/locale-support.html).\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT MONTHNAME(\'2008-02-03\');\n        -> \'February\'\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(184,'PROCEDURE ANALYSE',37,'Syntax:\nANALYSE([max_elements[,max_memory]])\n\nANALYSE() is defined in the sql/sql_analyse.cc source file, which\nserves as an example of how to create a procedure for use with the\nPROCEDURE clause of SELECT statements. ANALYSE() is built in and is\navailable by default; other procedures can be created using the format\ndemonstrated in the source file.\n\nANALYSE() examines the result from a query and returns an analysis of\nthe results that suggests optimal data types for each column that may\nhelp reduce table sizes. To obtain this analysis, append PROCEDURE\nANALYSE to the end of a SELECT statement:\n\nSELECT ... FROM ... WHERE ... PROCEDURE ANALYSE([max_elements,[max_memory]])\n\nFor example:\n\nSELECT col1, col2 FROM table1 PROCEDURE ANALYSE(10, 2000);\n\nThe results show some statistics for the values returned by the query,\nand propose an optimal data type for the columns. This can be helpful\nfor checking your existing tables, or after importing new data. You may\nneed to try different settings for the arguments so that PROCEDURE\nANALYSE() does not suggest the ENUM data type when it is not\nappropriate.\n\nThe arguments are optional and are used as follows:\n\no max_elements (default 256) is the maximum number of distinct values\n  that ANALYSE() notices per column. This is used by ANALYSE() to check\n  whether the optimal data type should be of type ENUM; if there are\n  more than max_elements distinct values, then ENUM is not a suggested\n  type.\n\no max_memory (default 8192) is the maximum amount of memory that\n  ANALYSE() should allocate per column while trying to find all\n  distinct values.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/procedure-analyse.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/procedure-analyse.html'),(185,'CHANGE MASTER TO',8,'Syntax:\nCHANGE MASTER TO option [, option] ...\n\noption:\n    MASTER_BIND = \'interface_name\'\n  | MASTER_HOST = \'host_name\'\n  | MASTER_USER = \'user_name\'\n  | MASTER_PASSWORD = \'password\'\n  | MASTER_PORT = port_num\n  | MASTER_CONNECT_RETRY = interval\n  | MASTER_HEARTBEAT_PERIOD = interval\n  | MASTER_LOG_FILE = \'master_log_name\'\n  | MASTER_LOG_POS = master_log_pos\n  | RELAY_LOG_FILE = \'relay_log_name\'\n  | RELAY_LOG_POS = relay_log_pos\n  | MASTER_SSL = {0|1}\n  | MASTER_SSL_CA = \'ca_file_name\'\n  | MASTER_SSL_CAPATH = \'ca_directory_name\'\n  | MASTER_SSL_CERT = \'cert_file_name\'\n  | MASTER_SSL_KEY = \'key_file_name\'\n  | MASTER_SSL_CIPHER = \'cipher_list\'\n  | MASTER_SSL_VERIFY_SERVER_CERT = {0|1}\n  | IGNORE_SERVER_IDS = (server_id_list)\n\nserver_id_list:\n    [server_id [, server_id] ... ]\n\nCHANGE MASTER TO changes the parameters that the slave server uses for\nconnecting to the master server, for reading the master binary log, and\nreading the slave relay log. It also updates the contents of the\nmaster.info and relay-log.info files. To use CHANGE MASTER TO, the\nslave replication threads must be stopped (use STOP SLAVE if\nnecessary).\n\nOptions not specified retain their value, except as indicated in the\nfollowing discussion. Thus, in most cases, there is no need to specify\noptions that do not change. For example, if the password to connect to\nyour MySQL master has changed, you just need to issue these statements\nto tell the slave about the new password:\n\nSTOP SLAVE; -- if replication was running\nCHANGE MASTER TO MASTER_PASSWORD=\'new3cret\';\nSTART SLAVE; -- if you want to restart replication\n\nMASTER_HOST, MASTER_USER, MASTER_PASSWORD, and MASTER_PORT provide\ninformation to the slave about how to connect to its master:\n\no MASTER_HOST and MASTER_PORT are the host name (or IP address) of the\n  master host and its TCP/IP port.\n\n  *Note*: Replication cannot use Unix socket files. You must be able to\n  connect to the master MySQL server using TCP/IP.\n\n  If you specify the MASTER_HOST or MASTER_PORT option, the slave\n  assumes that the master server is different from before (even if the\n  option value is the same as its current value.) In this case, the old\n  values for the master binary log file name and position are\n  considered no longer applicable, so if you do not specify\n  MASTER_LOG_FILE and MASTER_LOG_POS in the statement,\n  MASTER_LOG_FILE=\'\' and MASTER_LOG_POS=4 are silently appended to it.\n\n  Setting MASTER_HOST=\'\' (that is, setting its value explicitly to an\n  empty string) is not the same as not setting MASTER_HOST at all.\n  Setting this option to an empty string causes START SLAVE\n  subsequently to fail. This issue is addressed in MySQL 5.5. (Bug\n  #28796)\n\no MASTER_USER and MASTER_PASSWORD are the user name and password of the\n  account to use for connecting to the master.\n\n  Currently, a password used for a replication slave account can exceed\n  32 characters, but any characters in excess of this number are\n  truncated. This is not due to any limit imposed by the MySQL Server\n  but rather one that is specific to MySQL Replication. (See Bug\n  #43439, for more information.)\n\n  The text of a running CHANGE MASTER TO statement, including values\n  for MASTER_USER and MASTER_PASSWORD, can be seen in the output of a\n  concurrent SHOW PROCESSLIST statement.\n\nThe MASTER_SSL_xxx options provide information about using SSL for the\nconnection. They correspond to the --ssl-xxx options described in\nhttp://dev.mysql.com/doc/refman/5.1/en/ssl-options.html, and\nhttp://dev.mysql.com/doc/refman/5.1/en/replication-solutions-ssl.html.\nMASTER_SSL_VERIFY_SERVER_CERT was added in MySQL 5.1.18. These options\ncan be changed even on slaves that are compiled without SSL support.\nThey are saved to the master.info file, but are ignored if the slave\ndoes not have SSL support enabled.\n\nMASTER_CONNECT_RETRY specifies how many seconds to wait between connect\nretries. The default is 60. The number of reconnection attempts is\nlimited by the --master-retry-count server option; for more\ninformation, see\nhttp://dev.mysql.com/doc/refman/5.1/en/replication-options.html.\n\nThe next two options (MASTER_BIND and MASTER_HEARTBEAT_PERIOD) are\navailable in MySQL Cluster NDB 6.3 and later, but are not supported in\nmainline MySQL 5.1:\n\nMASTER_BIND is for use on replication slaves having multiple network\ninterfaces, and determines which of the slave\'s network interfaces is\nchosen for connecting to the master.\n\nThe ability to bind a replication slave to specific network interface\nwas added in MySQL Cluster NDB 6.3.4.\n\nMASTER_HEARTBEAT_PERIOD sets the interval in seconds between\nreplication heartbeats. Whenever the master\'s binary log is updated\nwith an event, the waiting period for the next heartbeat is reset.\ninterval is a decimal value having the range 0 to 4294967 seconds and a\nresolution in milliseconds; the smallest nonzero value is 0.001.\nHeartbeats are sent by the master only if there are no unsent events in\nthe binary log file for a period longer than interval.\n\nSetting interval to 0 disables heartbeats altogether. The default value\nfor interval is equal to the value of slave_net_timeout divided by 2.\n\nSetting @@global.slave_net_timeout to a value less than that of the\ncurrent heartbeat interval results in a warning being issued. The\neffect of issuing RESET SLAVE on the heartbeat interval is to reset it\nto the default value.\n\nMASTER_HEARTBEAT_PERIOD was added in MySQL Cluster NDB 6.3.4.\n\nMASTER_LOG_FILE and MASTER_LOG_POS are the coordinates at which the\nslave I/O thread should begin reading from the master the next time the\nthread starts. RELAY_LOG_FILE and RELAY_LOG_POS are the coordinates at\nwhich the slave SQL thread should begin reading from the relay log the\nnext time the thread starts. If you specify either of MASTER_LOG_FILE\nor MASTER_LOG_POS, you cannot specify RELAY_LOG_FILE or RELAY_LOG_POS.\nIf neither of MASTER_LOG_FILE or MASTER_LOG_POS is specified, the slave\nuses the last coordinates of the slave SQL thread before CHANGE MASTER\nTO was issued. This ensures that there is no discontinuity in\nreplication, even if the slave SQL thread was late compared to the\nslave I/O thread, when you merely want to change, say, the password to\nuse.\n\nCHANGE MASTER TO deletes all relay log files and starts a new one,\nunless you specify RELAY_LOG_FILE or RELAY_LOG_POS. In that case, relay\nlog files are kept; the relay_log_purge global variable is set silently\nto 0.\n\nIGNORE_SERVER_IDS was added in MySQL Cluster NDB 6.1.29, MySQL Cluster\nNDB 6.3.31, MySQL Cluster NDB 7.0.11, and MySQL Cluster NDB 7.1.0 (see\nBug #47037). This option takes a comma-separated list of 0 or more\nserver IDs. Events originating from the corresponding servers are\nignored, with the exception of log rotation and deletion events, which\nare still recorded in the relay log.\n\nIn circular replication, the originating server normally acts as the\nterminator of its own events, so that they are not applied more than\nonce. Thus, this option is useful in circular replication when one of\nthe servers in the circle is removed. Suppose that you have a circular\nreplication setup with 4 servers, having server IDs 1, 2, 3, and 4, and\nserver 3 fails. When bridging the gap by starting replication from\nserver 2 to server 4, you can include IGNORE_SERVER_IDS = (3) in the\nCHANGE MASTER TO statement that you issue on server 4 to tell it to use\nserver 2 as its master instead of server 3. Doing so causes it to\nignore and not to propagate any statements that originated with the\nserver that is no longer in use.\n\nIf a CHANGE MASTER TO statement is issued without any IGNORE_SERVER_IDS\noption, any existing list is preserved; RESET SLAVE also has no effect\non the server ID list. To clear the list of ignored servers, it is\nnecessary to use the option with an empty list:\n\nCHANGE MASTER TO IGNORE_SERVER_IDS = ();\n\nIf IGNORE_SERVER_IDS contains the server\'s own ID and the server was\nstarted with the --replicate-same-server-id option enabled, an error\nresults.\n\nBeginning with MySQL 5.1.47, invoking CHANGE MASTER TO causes the\nprevious values for MASTER_HOST, MASTER_PORT, MASTER_LOG_FILE, and\nMASTER_LOG_POS to be written to the error log, along with other\ninformation about the slave\'s state prior to execution.\n\nCHANGE MASTER TO is useful for setting up a slave when you have the\nsnapshot of the master and have recorded the master binary log\ncoordinates corresponding to the time of the snapshot. After loading\nthe snapshot into the slave to synchronize it to the slave, you can run\nCHANGE MASTER TO MASTER_LOG_FILE=\'log_name\', MASTER_LOG_POS=log_pos on\nthe slave to specify the coordinates at which the slave should begin\nreading the master binary log.\n\nThe following example changes the master server the slave uses and\nestablishes the master binary log coordinates from which the slave\nbegins reading. This is used when you want to set up the slave to\nreplicate the master:\n\nCHANGE MASTER TO\n  MASTER_HOST=\'master2.mycompany.com\',\n  MASTER_USER=\'replication\',\n  MASTER_PASSWORD=\'bigs3cret\',\n  MASTER_PORT=3306,\n  MASTER_LOG_FILE=\'master2-bin.001\',\n  MASTER_LOG_POS=4,\n  MASTER_CONNECT_RETRY=10;\n\nThe next example shows an operation that is less frequently employed.\nIt is used when the slave has relay log files that you want it to\nexecute again for some reason. To do this, the master need not be\nreachable. You need only use CHANGE MASTER TO and start the SQL thread\n(START SLAVE SQL_THREAD):\n\nCHANGE MASTER TO\n  RELAY_LOG_FILE=\'slave-relay-bin.006\',\n  RELAY_LOG_POS=4025;\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/change-master-to.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/change-master-to.html'),(186,'DROP DATABASE',38,'Syntax:\nDROP {DATABASE | SCHEMA} [IF EXISTS] db_name\n\nDROP DATABASE drops all tables in the database and deletes the\ndatabase. Be very careful with this statement! To use DROP DATABASE,\nyou need the DROP privilege on the database. DROP SCHEMA is a synonym\nfor DROP DATABASE.\n\n*Important*: When a database is dropped, user privileges on the\ndatabase are not automatically dropped. See [HELP GRANT].\n\nIF EXISTS is used to prevent an error from occurring if the database\ndoes not exist.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/drop-database.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/drop-database.html'),(187,'MBREQUAL',6,'MBREqual(g1,g2)\n\nReturns 1 or 0 to indicate whether the Minimum Bounding Rectangles of\nthe two geometries g1 and g2 are the same.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geometry-mbr\n\n','','http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geome'),(188,'TIMESTAMP FUNCTION',31,'Syntax:\nTIMESTAMP(expr), TIMESTAMP(expr1,expr2)\n\nWith a single argument, this function returns the date or datetime\nexpression expr as a datetime value. With two arguments, it adds the\ntime expression expr2 to the date or datetime expression expr1 and\nreturns the result as a datetime value.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT TIMESTAMP(\'2003-12-31\');\n        -> \'2003-12-31 00:00:00\'\nmysql> SELECT TIMESTAMP(\'2003-12-31 12:00:00\',\'12:00:00\');\n        -> \'2004-01-01 00:00:00\'\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(189,'HELP_VERSION',9,'This help information was generated from the MySQL 5.1 Reference Manual\non: 2012-04-15 (revision: 30082)\n\nThis information applies to MySQL 5.1 through 5.1.64.\n','',''),(190,'CHARACTER_LENGTH',36,'Syntax:\nCHARACTER_LENGTH(str)\n\nCHARACTER_LENGTH() is a synonym for CHAR_LENGTH().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(191,'SHOW GRANTS',26,'Syntax:\nSHOW GRANTS [FOR user]\n\nThis statement lists the GRANT statement or statements that must be\nissued to duplicate the privileges that are granted to a MySQL user\naccount. The account is named using the same format as for the GRANT\nstatement; for example, \'jeffrey\'@\'localhost\'. If you specify only the\nuser name part of the account name, a host name part of \'%\' is used.\nFor additional information about specifying account names, see [HELP\nGRANT].\n\nmysql> SHOW GRANTS FOR \'root\'@\'localhost\';\n+---------------------------------------------------------------------+\n| Grants for root@localhost                                           |\n+---------------------------------------------------------------------+\n| GRANT ALL PRIVILEGES ON *.* TO \'root\'@\'localhost\' WITH GRANT OPTION |\n+---------------------------------------------------------------------+\n\nTo list the privileges granted to the account that you are using to\nconnect to the server, you can use any of the following statements:\n\nSHOW GRANTS;\nSHOW GRANTS FOR CURRENT_USER;\nSHOW GRANTS FOR CURRENT_USER();\n\nAs of MySQL 5.1.12, if SHOW GRANTS FOR CURRENT_USER (or any of the\nequivalent syntaxes) is used in DEFINER context, such as within a\nstored procedure that is defined with SQL SECURITY DEFINER), the grants\ndisplayed are those of the definer and not the invoker.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-grants.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-grants.html'),(192,'SHOW PRIVILEGES',26,'Syntax:\nSHOW PRIVILEGES\n\nSHOW PRIVILEGES shows the list of system privileges that the MySQL\nserver supports. The exact list of privileges depends on the version of\nyour server.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-privileges.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-privileges.html'),(193,'CREATE TABLESPACE',38,'Syntax:\nCREATE TABLESPACE tablespace_name\n    ADD DATAFILE \'file_name\'\n    USE LOGFILE GROUP logfile_group\n    [EXTENT_SIZE [=] extent_size]\n    [INITIAL_SIZE [=] initial_size]\n    [AUTOEXTEND_SIZE [=] autoextend_size]\n    [MAX_SIZE [=] max_size]\n    [NODEGROUP [=] nodegroup_id]\n    [WAIT]\n    [COMMENT [=] comment_text]\n    ENGINE [=] engine_name\n\nThis statement is used to create a tablespace, which can contain one or\nmore data files, providing storage space for tables. One data file is\ncreated and added to the tablespace using this statement. Additional\ndata files may be added to the tablespace by using the ALTER TABLESPACE\nstatement (see [HELP ALTER TABLESPACE]). For rules covering the naming\nof tablespaces, see\nhttp://dev.mysql.com/doc/refman/5.1/en/identifiers.html.\n\n*Note*: All MySQL Cluster Disk Data objects share the same namespace.\nThis means that each Disk Data object must be uniquely named (and not\nmerely each Disk Data object of a given type). For example, you cannot\nhave a tablespace and a log file group with the same name, or a\ntablespace and a data file with the same name.\n\nPrior to MySQL Cluster NDB 6.2.17, 6.3.23, and 6.4.3, path and file\nnames for data files could not be longer than 128 characters. (Bug\n#31770)\n\nA log file group of one or more UNDO log files must be assigned to the\ntablespace to be created with the USE LOGFILE GROUP clause.\nlogfile_group must be an existing log file group created with CREATE\nLOGFILE GROUP (see\nhttp://dev.mysql.com/doc/refman/5.1/en/create-logfile-group.html).\nMultiple tablespaces may use the same log file group for UNDO logging.\n\nThe EXTENT_SIZE sets the size, in bytes, of the extents used by any\nfiles belonging to the tablespace. The default value is 1M. The minimum\nsize is 32K, and theoretical maximum is 2G, although the practical\nmaximum size depends on a number of factors. In most cases, changing\nthe extent size does not have any measurable effect on performance, and\nthe default value is recommended for all but the most unusual\nsituations.\n\nAn extent is a unit of disk space allocation. One extent is filled with\nas much data as that extent can contain before another extent is used.\nIn theory, up to 65,535 (64K) extents may used per data file; however,\nthe recommended maximum is 32,768 (32K). The recommended maximum size\nfor a single data file is 32G---that is, 32K extents x 1 MB per extent.\nIn addition, once an extent is allocated to a given partition, it\ncannot be used to store data from a different partition; an extent\ncannot store data from more than one partition. This means, for example\nthat a tablespace having a single datafile whose INITIAL_SIZE is 256 MB\nand whose EXTENT_SIZE is 128M has just two extents, and so can be used\nto store data from at most two different disk data table partitions.\n\nYou can see how many extents remain free in a given data file by\nquerying the INFORMATION_SCHEMA.FILES table, and so derive an estimate\nfor how much space remains free in the file. For further discussion and\nexamples, see http://dev.mysql.com/doc/refman/5.1/en/files-table.html.\n\nThe INITIAL_SIZE parameter sets the data file\'s total size in bytes.\nOnce the file has been created, its size cannot be changed; however,\nyou can add more data files to the tablespace using ALTER TABLESPACE\n... ADD DATAFILE. See [HELP ALTER TABLESPACE].\n\nINITIAL_SIZE is optional; its default value is 128M.\n\nOn 32-bit systems, the maximum supported value for INITIAL_SIZE is 4G.\n(Bug #29186)\n\nWhen setting EXTENT_SIZE or INITIAL_SIZE (either or both), you may\noptionally follow the number with a one-letter abbreviation for an\norder of magnitude, similar to those used in my.cnf. Generally, this is\none of the letters M (for megabytes) or G (for gigabytes).\n\nINITIAL_SIZE, EXTENT_SIZE, and UNDO_BUFFER_SIZE are subject to rounding\nas follows:\n\no EXTENT_SIZE and UNDO_BUFFER_SIZE are each rounded up to the nearest\n  whole multiple of 32K.\n\no INITIAL_SIZE is rounded down to the nearest whole multiple of 32K.\n\n  For data files, INITIAL_SIZE is subject to further rounding; the\n  result just obtained is rounded up to the nearest whole multiple of\n  EXTENT_SIZE (after any rounding).\n\nThe rounding just described has always (since Disk Data tablespaces\nwere introduced in MySQL 5.1.6) been performed implicitly, but\nbeginning with MySQL Cluster NDB 6.2.19, MySQL Cluster NDB 6.3.32,\nMySQL Cluster NDB 7.0.13, and MySQL Cluster NDB 7.1.2, this rounding is\ndone explicitly, and a warning is issued by the MySQL Server when any\nsuch rounding is performed. The rounded values are also used by the NDB\nkernel for calculating INFORMATION_SCHEMA.FILES column values and other\npurposes. However, to avoid an unexpected result, we suggest that you\nalways use whole multiples of 32K in specifying these options.\n\nAUTOEXTEND_SIZE, MAX_SIZE, NODEGROUP, WAIT, and COMMENT are parsed but\nignored, and so currently have no effect. These options are intended\nfor future expansion.\n\nThe ENGINE parameter determines the storage engine which uses this\ntablespace, with engine_name being the name of the storage engine. In\nMySQL 5.1, engine_name must be one of the values NDB or NDBCLUSTER.\n\nWhen CREATE TABLESPACE is used with ENGINE = NDB, a tablespace and\nassociated data file are created on each Cluster data node. You can\nverify that the data files were created and obtain information about\nthem by querying the INFORMATION_SCHEMA.FILES table. For example:\n\nmysql> SELECT LOGFILE_GROUP_NAME, FILE_NAME, EXTRA\n    -> FROM INFORMATION_SCHEMA.FILES\n    -> WHERE TABLESPACE_NAME = \'newts\' AND FILE_TYPE = \'DATAFILE\';\n+--------------------+-------------+----------------+\n| LOGFILE_GROUP_NAME | FILE_NAME   | EXTRA          |\n+--------------------+-------------+----------------+\n| lg_3               | newdata.dat | CLUSTER_NODE=3 |\n| lg_3               | newdata.dat | CLUSTER_NODE=4 |\n+--------------------+-------------+----------------+\n2 rows in set (0.01 sec)\n\n(See http://dev.mysql.com/doc/refman/5.1/en/files-table.html.)\n\nCREATE TABLESPACE was added in MySQL 5.1.6. In MySQL 5.1, it is useful\nonly with Disk Data storage for MySQL Cluster. See\nhttp://dev.mysql.com/doc/refman/5.1/en/mysql-cluster-disk-data.html.\n\nTo drop a primary key, the index name is always PRIMARY, which must be\nspecified as a quoted identifier because PRIMARY is a reserved word:\n\nDROP INDEX `PRIMARY` ON t;\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/create-tablespace.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/create-tablespace.html'),(194,'INSERT FUNCTION',36,'Syntax:\nINSERT(str,pos,len,newstr)\n\nReturns the string str, with the substring beginning at position pos\nand len characters long replaced by the string newstr. Returns the\noriginal string if pos is not within the length of the string. Replaces\nthe rest of the string from position pos if len is not within the\nlength of the rest of the string. Returns NULL if any argument is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT INSERT(\'Quadratic\', 3, 4, \'What\');\n        -> \'QuWhattic\'\nmysql> SELECT INSERT(\'Quadratic\', -1, 4, \'What\');\n        -> \'Quadratic\'\nmysql> SELECT INSERT(\'Quadratic\', 3, 100, \'What\');\n        -> \'QuWhat\'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(195,'CRC32',4,'Syntax:\nCRC32(expr)\n\nComputes a cyclic redundancy check value and returns a 32-bit unsigned\nvalue. The result is NULL if the argument is NULL. The argument is\nexpected to be a string and (if possible) is treated as one if it is\nnot.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT CRC32(\'MySQL\');\n        -> 3259397556\nmysql> SELECT CRC32(\'mysql\');\n        -> 2501908538\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(196,'XOR',14,'Syntax:\nXOR\n\nLogical XOR. Returns NULL if either operand is NULL. For non-NULL\noperands, evaluates to 1 if an odd number of operands is nonzero,\notherwise 0 is returned.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/logical-operators.html\n\n','mysql> SELECT 1 XOR 1;\n        -> 0\nmysql> SELECT 1 XOR 0;\n        -> 1\nmysql> SELECT 1 XOR NULL;\n        -> NULL\nmysql> SELECT 1 XOR 1 XOR 1;\n        -> 1\n','http://dev.mysql.com/doc/refman/5.1/en/logical-operators.html'),(197,'STARTPOINT',13,'StartPoint(ls)\n\nReturns the Point that is the start point of the LineString value ls.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#linestring-property-functions\n\n','mysql> SET @ls = \'LineString(1 1,2 2,3 3)\';\nmysql> SELECT AsText(StartPoint(GeomFromText(@ls)));\n+---------------------------------------+\n| AsText(StartPoint(GeomFromText(@ls))) |\n+---------------------------------------+\n| POINT(1 1)                            |\n+---------------------------------------+\n','http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#linestring-property-functions'),(198,'GRANT',10,'Syntax:\nGRANT\n    priv_type [(column_list)]\n      [, priv_type [(column_list)]] ...\n    ON [object_type] priv_level\n    TO user_specification [, user_specification] ...\n    [REQUIRE {NONE | ssl_option [[AND] ssl_option] ...}]\n    [WITH with_option ...]\n\nobject_type:\n    TABLE\n  | FUNCTION\n  | PROCEDURE\n\npriv_level:\n    *\n  | *.*\n  | db_name.*\n  | db_name.tbl_name\n  | tbl_name\n  | db_name.routine_name\n\nuser_specification:\n    user [IDENTIFIED BY [PASSWORD] \'password\']\n\nssl_option:\n    SSL\n  | X509\n  | CIPHER \'cipher\'\n  | ISSUER \'issuer\'\n  | SUBJECT \'subject\'\n\nwith_option:\n    GRANT OPTION\n  | MAX_QUERIES_PER_HOUR count\n  | MAX_UPDATES_PER_HOUR count\n  | MAX_CONNECTIONS_PER_HOUR count\n  | MAX_USER_CONNECTIONS count\n\nThe GRANT statement grants privileges to MySQL user accounts. GRANT\nalso serves to specify other account characteristics such as use of\nsecure connections and limits on access to server resources. To use\nGRANT, you must have the GRANT OPTION privilege, and you must have the\nprivileges that you are granting.\n\nNormally, a database administrator first uses CREATE USER to create an\naccount, then GRANT to define its privileges and characteristics. For\nexample:\n\nCREATE USER \'jeffrey\'@\'localhost\' IDENTIFIED BY \'mypass\';\nGRANT ALL ON db1.* TO \'jeffrey\'@\'localhost\';\nGRANT SELECT ON db2.invoice TO \'jeffrey\'@\'localhost\';\nGRANT USAGE ON *.* TO \'jeffrey\'@\'localhost\' WITH MAX_QUERIES_PER_HOUR 90;\n\nHowever, if an account named in a GRANT statement does not already\nexist, GRANT may create it under the conditions described later in the\ndiscussion of the NO_AUTO_CREATE_USER SQL mode.\n\nThe REVOKE statement is related to GRANT and enables administrators to\nremove account privileges. See [HELP REVOKE].\n\nWhen successfully executed from the mysql program, GRANT responds with\nQuery OK, 0 rows affected. To determine what privileges result from the\noperation, use SHOW GRANTS. See [HELP SHOW GRANTS].\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/grant.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/grant.html'),(199,'DECLARE VARIABLE',23,'Syntax:\nDECLARE var_name [, var_name] ... type [DEFAULT value]\n\nThis statement declares local variables within stored programs. To\nprovide a default value for a variable, include a DEFAULT clause. The\nvalue can be specified as an expression; it need not be a constant. If\nthe DEFAULT clause is missing, the initial value is NULL.\n\nLocal variables are treated like stored routine parameters with respect\nto data type and overflow checking. See [HELP CREATE PROCEDURE].\n\nVariable declarations must appear before cursor or handler\ndeclarations.\n\nLocal variable names are not case sensitive. Permissible characters and\nquoting rules are the same as for other identifiers, as described in\nhttp://dev.mysql.com/doc/refman/5.1/en/identifiers.html.\n\nThe scope of a local variable is the BEGIN ... END block within which\nit is declared. The variable can be referred to in blocks nested within\nthe declaring block, except those blocks that declare a variable with\nthe same name.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/declare-local-variable.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/declare-local-variable.html'),(200,'MPOLYFROMTEXT',3,'MPolyFromText(wkt[,srid]), MultiPolygonFromText(wkt[,srid])\n\nConstructs a MULTIPOLYGON value using its WKT representation and SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkt-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkt-functions'),(201,'MBRINTERSECTS',6,'MBRIntersects(g1,g2)\n\nReturns 1 or 0 to indicate whether the Minimum Bounding Rectangles of\nthe two geometries g1 and g2 intersect.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geometry-mbr\n\n','','http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geome'),(202,'BIT_OR',16,'Syntax:\nBIT_OR(expr)\n\nReturns the bitwise OR of all bits in expr. The calculation is\nperformed with 64-bit (BIGINT) precision.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html'),(203,'YEARWEEK',31,'Syntax:\nYEARWEEK(date), YEARWEEK(date,mode)\n\nReturns year and week for a date. The mode argument works exactly like\nthe mode argument to WEEK(). The year in the result may be different\nfrom the year in the date argument for the first and the last week of\nthe year.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT YEARWEEK(\'1987-01-01\');\n        -> 198653\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(204,'NOT BETWEEN',18,'Syntax:\nexpr NOT BETWEEN min AND max\n\nThis is the same as NOT (expr BETWEEN min AND max).\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html'),(205,'IS NOT',18,'Syntax:\nIS NOT boolean_value\n\nTests a value against a boolean value, where boolean_value can be TRUE,\nFALSE, or UNKNOWN.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html\n\n','mysql> SELECT 1 IS NOT UNKNOWN, 0 IS NOT UNKNOWN, NULL IS NOT UNKNOWN;\n        -> 1, 1, 0\n','http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html'),(206,'LOG10',4,'Syntax:\nLOG10(X)\n\nReturns the base-10 logarithm of X.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT LOG10(2);\n        -> 0.30102999566398\nmysql> SELECT LOG10(100);\n        -> 2\nmysql> SELECT LOG10(-100);\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(207,'SQRT',4,'Syntax:\nSQRT(X)\n\nReturns the square root of a nonnegative number X.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT SQRT(4);\n        -> 2\nmysql> SELECT SQRT(20);\n        -> 4.4721359549996\nmysql> SELECT SQRT(-16);\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(208,'DECIMAL',22,'DECIMAL[(M[,D])] [UNSIGNED] [ZEROFILL]\n\nA packed \"exact\" fixed-point number. M is the total number of digits\n(the precision) and D is the number of digits after the decimal point\n(the scale). The decimal point and (for negative numbers) the \"-\" sign\nare not counted in M. If D is 0, values have no decimal point or\nfractional part. The maximum number of digits (M) for DECIMAL is 65.\nThe maximum number of supported decimals (D) is 30. If D is omitted,\nthe default is 0. If M is omitted, the default is 10.\n\nUNSIGNED, if specified, disallows negative values.\n\nAll basic calculations (+, -, *, /) with DECIMAL columns are done with\na precision of 65 digits.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html'),(209,'CREATE INDEX',38,'Syntax:\nCREATE [ONLINE|OFFLINE] [UNIQUE|FULLTEXT|SPATIAL] INDEX index_name\n    [index_type]\n    ON tbl_name (index_col_name,...)\n    [index_option] ...\n\nindex_col_name:\n    col_name [(length)] [ASC | DESC]\n\nindex_type:\n    USING {BTREE | HASH}\n\nindex_option:\n    KEY_BLOCK_SIZE [=] value\n  | index_type\n  | WITH PARSER parser_name\n\nCREATE INDEX is mapped to an ALTER TABLE statement to create indexes.\nSee [HELP ALTER TABLE]. CREATE INDEX cannot be used to create a PRIMARY\nKEY; use ALTER TABLE instead. For more information about indexes, see\nhttp://dev.mysql.com/doc/refman/5.1/en/mysql-indexes.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/create-index.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/create-index.html'),(210,'CREATE FUNCTION',38,'The CREATE FUNCTION statement is used to create stored functions and\nuser-defined functions (UDFs):\n\no For information about creating stored functions, see [HELP CREATE\n  PROCEDURE].\n\no For information about creating user-defined functions, see [HELP\n  CREATE FUNCTION UDF].\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/create-function.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/create-function.html'),(211,'ALTER DATABASE',38,'Syntax:\nALTER {DATABASE | SCHEMA} [db_name]\n    alter_specification ...\nALTER {DATABASE | SCHEMA} db_name\n    UPGRADE DATA DIRECTORY NAME\n\nalter_specification:\n    [DEFAULT] CHARACTER SET [=] charset_name\n  | [DEFAULT] COLLATE [=] collation_name\n\nALTER DATABASE enables you to change the overall characteristics of a\ndatabase. These characteristics are stored in the db.opt file in the\ndatabase directory. To use ALTER DATABASE, you need the ALTER privilege\non the database. ALTER SCHEMA is a synonym for ALTER DATABASE.\n\nThe database name can be omitted from the first syntax, in which case\nthe statement applies to the default database.\n\nNational Language Characteristics\n\nThe CHARACTER SET clause changes the default database character set.\nThe COLLATE clause changes the default database collation.\nhttp://dev.mysql.com/doc/refman/5.1/en/charset.html, discusses\ncharacter set and collation names.\n\nYou can see what character sets and collations are available using,\nrespectively, the SHOW CHARACTER SET and SHOW COLLATION statements. See\n[HELP SHOW CHARACTER SET], and [HELP SHOW COLLATION], for more\ninformation.\n\nIf you change the default character set or collation for a database,\nstored routines that use the database defaults must be dropped and\nrecreated so that they use the new defaults. (In a stored routine,\nvariables with character data types use the database defaults if the\ncharacter set or collation are not specified explicitly. See [HELP\nCREATE PROCEDURE].)\n\nUpgrading from Versions Older than MySQL 5.1\n\nThe syntax that includes the UPGRADE DATA DIRECTORY NAME clause was\nadded in MySQL 5.1.23. It updates the name of the directory associated\nwith the database to use the encoding implemented in MySQL 5.1 for\nmapping database names to database directory names (see\nhttp://dev.mysql.com/doc/refman/5.1/en/identifier-mapping.html). This\nclause is for use under these conditions:\n\no It is intended when upgrading MySQL to 5.1 or later from older\n  versions.\n\no It is intended to update a database directory name to the current\n  encoding format if the name contains special characters that need\n  encoding.\n\no The statement is used by mysqlcheck (as invoked by mysql_upgrade).\n\nFor example, if a database in MySQL 5.0 has the name a-b-c, the name\ncontains instances of the - (dash) character. In MySQL 5.0, the\ndatabase directory is also named a-b-c, which is not necessarily safe\nfor all file systems. In MySQL 5.1 and later, the same database name is\nencoded as a@002db@002dc to produce a file system-neutral directory\nname.\n\nWhen a MySQL installation is upgraded to MySQL 5.1 or later from an\nolder version,the server displays a name such as a-b-c (which is in the\nold format) as #mysql50#a-b-c, and you must refer to the name using the\n#mysql50# prefix. Use UPGRADE DATA DIRECTORY NAME in this case to\nexplicitly tell the server to re-encode the database directory name to\nthe current encoding format:\n\nALTER DATABASE `#mysql50#a-b-c` UPGRADE DATA DIRECTORY NAME;\n\nAfter executing this statement, you can refer to the database as a-b-c\nwithout the special #mysql50# prefix.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/alter-database.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/alter-database.html'),(212,'GEOMETRYN',25,'GeometryN(gc,N)\n\nReturns the N-th geometry in the GeometryCollection value gc.\nGeometries are numbered beginning with 1.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#geometrycollection-property-functions\n\n','mysql> SET @gc = \'GeometryCollection(Point(1 1),LineString(2 2, 3 3))\';\nmysql> SELECT AsText(GeometryN(GeomFromText(@gc),1));\n+----------------------------------------+\n| AsText(GeometryN(GeomFromText(@gc),1)) |\n+----------------------------------------+\n| POINT(1 1)                             |\n+----------------------------------------+\n','http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#geometrycollection-property-functions'),(213,'<<',19,'Syntax:\n<<\n\nShifts a longlong (BIGINT) number to the left.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/bit-functions.html\n\n','mysql> SELECT 1 << 2;\n        -> 4\n','http://dev.mysql.com/doc/refman/5.1/en/bit-functions.html'),(214,'SHOW TABLE STATUS',26,'Syntax:\nSHOW TABLE STATUS [{FROM | IN} db_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW TABLE STATUS works likes SHOW TABLES, but provides a lot of\ninformation about each non-TEMPORARY table. You can also get this list\nusing the mysqlshow --status db_name command. The LIKE clause, if\npresent, indicates which table names to match. The WHERE clause can be\ngiven to select rows using more general conditions, as discussed in\nhttp://dev.mysql.com/doc/refman/5.1/en/extended-show.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-table-status.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-table-status.html'),(215,'MD5',12,'Syntax:\nMD5(str)\n\nCalculates an MD5 128-bit checksum for the string. The value is\nreturned as a binary string of 32 hex digits, or NULL if the argument\nwas NULL. The return value can, for example, be used as a hash key. See\nthe notes at the beginning of this section about storing hash values\nefficiently.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html\n\n','mysql> SELECT MD5(\'testing\');\n        -> \'ae2b1fca515949e5d54fb22b8ed95575\'\n','http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html'),(216,'<',18,'Syntax:\n<\n\nLess than:\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html\n\n','mysql> SELECT 2 < 2;\n        -> 0\n','http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html'),(217,'UNIX_TIMESTAMP',31,'Syntax:\nUNIX_TIMESTAMP(), UNIX_TIMESTAMP(date)\n\nIf called with no argument, returns a Unix timestamp (seconds since\n\'1970-01-01 00:00:00\' UTC) as an unsigned integer. If UNIX_TIMESTAMP()\nis called with a date argument, it returns the value of the argument as\nseconds since \'1970-01-01 00:00:00\' UTC. date may be a DATE string, a\nDATETIME string, a TIMESTAMP, or a number in the format YYMMDD or\nYYYYMMDD. The server interprets date as a value in the current time\nzone and converts it to an internal value in UTC. Clients can set their\ntime zone as described in\nhttp://dev.mysql.com/doc/refman/5.1/en/time-zone-support.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT UNIX_TIMESTAMP();\n        -> 1196440210\nmysql> SELECT UNIX_TIMESTAMP(\'2007-11-30 10:30:19\');\n        -> 1196440219\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(218,'DAYOFMONTH',31,'Syntax:\nDAYOFMONTH(date)\n\nReturns the day of the month for date, in the range 1 to 31, or 0 for\ndates such as \'0000-00-00\' or \'2008-00-00\' that have a zero day part.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT DAYOFMONTH(\'2007-02-03\');\n        -> 3\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(219,'ASCII',36,'Syntax:\nASCII(str)\n\nReturns the numeric value of the leftmost character of the string str.\nReturns 0 if str is the empty string. Returns NULL if str is NULL.\nASCII() works for 8-bit characters.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT ASCII(\'2\');\n        -> 50\nmysql> SELECT ASCII(2);\n        -> 50\nmysql> SELECT ASCII(\'dx\');\n        -> 100\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(220,'DIV',4,'Syntax:\nDIV\n\nInteger division. Similar to FLOOR(), but is safe with BIGINT values.\nIncorrect results may occur for noninteger operands that exceed BIGINT\nrange.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/arithmetic-functions.html\n\n','mysql> SELECT 5 DIV 2;\n        -> 2\n','http://dev.mysql.com/doc/refman/5.1/en/arithmetic-functions.html'),(221,'RENAME USER',10,'Syntax:\nRENAME USER old_user TO new_user\n    [, old_user TO new_user] ...\n\nThe RENAME USER statement renames existing MySQL accounts. To use it,\nyou must have the global CREATE USER privilege or the UPDATE privilege\nfor the mysql database. An error occurs if any old account does not\nexist or any new account exists. Each account name uses the format\ndescribed in http://dev.mysql.com/doc/refman/5.1/en/account-names.html.\nFor example:\n\nRENAME USER \'jeffrey\'@\'localhost\' TO \'jeff\'@\'127.0.0.1\';\n\nIf you specify only the user name part of the account name, a host name\npart of \'%\' is used.\n\nRENAME USER causes the privileges held by the old user to be those held\nby the new user. However, RENAME USER does not automatically drop or\ninvalidate databases or objects within them that the old user created.\nThis includes stored programs or views for which the DEFINER attribute\nnames the old user. Attempts to access such objects may produce an\nerror if they execute in definer security context. (For information\nabout security context, see\nhttp://dev.mysql.com/doc/refman/5.1/en/stored-programs-security.html.)\n\nThe privilege changes take effect as indicated in\nhttp://dev.mysql.com/doc/refman/5.1/en/privilege-changes.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/rename-user.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/rename-user.html'),(222,'SHOW SLAVE STATUS',26,'Syntax:\nSHOW SLAVE STATUS\n\nThis statement provides status information on essential parameters of\nthe slave threads. It requires either the SUPER or REPLICATION CLIENT\nprivilege.\n\nIf you issue this statement using the mysql client, you can use a \\G\nstatement terminator rather than a semicolon to obtain a more readable\nvertical layout:\n\nmysql> SHOW SLAVE STATUS\\G\n*************************** 1. row ***************************\n               Slave_IO_State: Waiting for master to send event\n                  Master_Host: localhost\n                  Master_User: root\n                  Master_Port: 3306\n                Connect_Retry: 3\n              Master_Log_File: gbichot-bin.005\n          Read_Master_Log_Pos: 79\n               Relay_Log_File: gbichot-relay-bin.005\n                Relay_Log_Pos: 548\n        Relay_Master_Log_File: gbichot-bin.005\n             Slave_IO_Running: Yes\n            Slave_SQL_Running: Yes\n              Replicate_Do_DB:\n          Replicate_Ignore_DB:\n           Replicate_Do_Table:\n       Replicate_Ignore_Table:\n      Replicate_Wild_Do_Table:\n  Replicate_Wild_Ignore_Table:\n                   Last_Errno: 0\n                   Last_Error:\n                 Skip_Counter: 0\n          Exec_Master_Log_Pos: 79\n              Relay_Log_Space: 552\n              Until_Condition: None\n               Until_Log_File:\n                Until_Log_Pos: 0\n           Master_SSL_Allowed: No\n           Master_SSL_CA_File:\n           Master_SSL_CA_Path:\n              Master_SSL_Cert:\n            Master_SSL_Cipher:\n               Master_SSL_Key:\n        Seconds_Behind_Master: 8\nMaster_SSL_Verify_Server_Cert: No\n                Last_IO_Errno: 0\n                Last_IO_Error:\n               Last_SQL_Errno: 0\n               Last_SQL_Error:\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-slave-status.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-slave-status.html'),(223,'GEOMETRY',33,'MySQL provides a standard way of creating spatial columns for geometry\ntypes, for example, with CREATE TABLE or ALTER TABLE. Currently,\nspatial columns are supported for MyISAM, InnoDB, NDB, and ARCHIVE\ntables. See also the annotations about spatial indexes under [HELP\nSPATIAL].\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-columns.html\n\n','CREATE TABLE geom (g GEOMETRY);\n','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-columns.html'),(224,'NUMPOINTS',13,'NumPoints(ls)\n\nReturns the number of Point objects in the LineString value ls.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#linestring-property-functions\n\n','mysql> SET @ls = \'LineString(1 1,2 2,3 3)\';\nmysql> SELECT NumPoints(GeomFromText(@ls));\n+------------------------------+\n| NumPoints(GeomFromText(@ls)) |\n+------------------------------+\n|                            3 |\n+------------------------------+\n','http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#linestring-property-functions'),(225,'ALTER LOGFILE GROUP',38,'Syntax:\nALTER LOGFILE GROUP logfile_group\n    ADD UNDOFILE \'file_name\'\n    [INITIAL_SIZE [=] size]\n    [WAIT]\n    ENGINE [=] engine_name\n\nThis statement adds an UNDO file named \'file_name\' to an existing log\nfile group logfile_group. An ALTER LOGFILE GROUP statement has one and\nonly one ADD UNDOFILE clause. No DROP UNDOFILE clause is currently\nsupported.\n\n*Note*: All MySQL Cluster Disk Data objects share the same namespace.\nThis means that each Disk Data object must be uniquely named (and not\nmerely each Disk Data object of a given type). For example, you cannot\nhave a tablespace and an undo log file with the same name, or an undo\nlog file and a data file with the same name.\n\nPrior to MySQL Cluster NDB 6.2.17, 6.3.23, and 6.4.3, path and file\nnames for undo log files could not be longer than 128 characters. (Bug\n#31769)\n\nThe optional INITIAL_SIZE parameter sets the UNDO file\'s initial size\nin bytes; if not specified, the initial size default to 128M (128\nmegabytes). You may optionally follow size with a one-letter\nabbreviation for an order of magnitude, similar to those used in\nmy.cnf. Generally, this is one of the letters M (for megabytes) or G\n(for gigabytes).\n\nOn 32-bit systems, the maximum supported value for INITIAL_SIZE is 4G.\n(Bug #29186)\n\nBeginning with MySQL Cluster NDB 6.2.18, 6.3.24, and 7.0.4, the minimum\npermitted value for INITIAL_SIZE is 1M. (Bug #29574)\n\n*Note*: WAIT is parsed but otherwise ignored. This keyword has no\neffect in MySQL 5.1, MySQL Cluster NDB 6.x, or MySQL Cluster NDB 7.x,\nand is intended for future expansion.\n\nThe ENGINE parameter (required) determines the storage engine which is\nused by this log file group, with engine_name being the name of the\nstorage engine. In MySQL 5.1, MySQL Cluster NDB 6.x, and MySQL Cluster\nNDB 7.x, the only accepted values for engine_name are \"NDBCLUSTER\" and\n\"NDB\". The two values are equivalent.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/alter-logfile-group.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/alter-logfile-group.html'),(226,'&',19,'Syntax:\n&\n\nBitwise AND:\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/bit-functions.html\n\n','mysql> SELECT 29 & 15;\n        -> 13\n','http://dev.mysql.com/doc/refman/5.1/en/bit-functions.html'),(227,'LOCALTIMESTAMP',31,'Syntax:\nLOCALTIMESTAMP, LOCALTIMESTAMP()\n\nLOCALTIMESTAMP and LOCALTIMESTAMP() are synonyms for NOW().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(228,'ASSIGN-EQUAL',14,'Syntax:\n=\n\nThis operator is used to perform value assignments in two cases,\ndescribed in the next two paragraphs.\n\nWithin a SET statement, = is treated as an assignment operator that\ncauses the user variable on the left hand side of the operator to take\non the value to its right. (In other words, when used in a SET\nstatement, = is treated identically to :=.) The value on the right hand\nside may be a literal value, another variable storing a value, or any\nlegal expression that yields a scalar value, including the result of a\nquery (provided that this value is a scalar value). You can perform\nmultiple assignments in the same SET statement.\n\nIn the SET clause of an UPDATE statement, = also acts as an assignment\noperator; in this case, however, it causes the column named on the left\nhand side of the operator to assume the value given to the right,\nprovided any WHERE conditions that are part of the UPDATE are met. You\ncan make multiple assignments in the same SET clause of an UPDATE\nstatement.\n\nIn any other context, = is treated as a comparison operator.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/assignment-operators.html\n\n','mysql> SELECT @var1, @var2;\n        -> NULL, NULL\nmysql> SELECT @var1 := 1, @var2;\n        -> 1, NULL\nmysql> SELECT @var1, @var2;\n        -> 1, NULL\nmysql> SELECT @var1, @var2 := @var1;\n        -> 1, 1\nmysql> SELECT @var1, @var2;\n        -> 1, 1\n','http://dev.mysql.com/doc/refman/5.1/en/assignment-operators.html'),(229,'CONVERT',36,'Syntax:\nCONVERT(expr,type), CONVERT(expr USING transcoding_name)\n\nThe CONVERT() and CAST() functions take a value of one type and produce\na value of another type.\n\nThe type can be one of the following values:\n\no BINARY[(N)]\n\no CHAR[(N)]\n\no DATE\n\no DATETIME\n\no DECIMAL[(M[,D])]\n\no SIGNED [INTEGER]\n\no TIME\n\no UNSIGNED [INTEGER]\n\nBINARY produces a string with the BINARY data type. See\nhttp://dev.mysql.com/doc/refman/5.1/en/binary-varbinary.html for a\ndescription of how this affects comparisons. If the optional length N\nis given, BINARY(N) causes the cast to use no more than N bytes of the\nargument. Values shorter than N bytes are padded with 0x00 bytes to a\nlength of N.\n\nCHAR(N) causes the cast to use no more than N characters of the\nargument.\n\nCAST() and CONVERT(... USING ...) are standard SQL syntax. The\nnon-USING form of CONVERT() is ODBC syntax.\n\nCONVERT() with USING is used to convert data between different\ncharacter sets. In MySQL, transcoding names are the same as the\ncorresponding character set names. For example, this statement converts\nthe string \'abc\' in the default character set to the corresponding\nstring in the utf8 character set:\n\nSELECT CONVERT(\'abc\' USING utf8);\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/cast-functions.html\n\n','SELECT enum_col FROM tbl_name ORDER BY CAST(enum_col AS CHAR);\n','http://dev.mysql.com/doc/refman/5.1/en/cast-functions.html'),(230,'ADDDATE',31,'Syntax:\nADDDATE(date,INTERVAL expr unit), ADDDATE(expr,days)\n\nWhen invoked with the INTERVAL form of the second argument, ADDDATE()\nis a synonym for DATE_ADD(). The related function SUBDATE() is a\nsynonym for DATE_SUB(). For information on the INTERVAL unit argument,\nsee the discussion for DATE_ADD().\n\nmysql> SELECT DATE_ADD(\'2008-01-02\', INTERVAL 31 DAY);\n        -> \'2008-02-02\'\nmysql> SELECT ADDDATE(\'2008-01-02\', INTERVAL 31 DAY);\n        -> \'2008-02-02\'\n\nWhen invoked with the days form of the second argument, MySQL treats it\nas an integer number of days to be added to expr.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT ADDDATE(\'2008-01-02\', 31);\n        -> \'2008-02-02\'\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(231,'REPEAT LOOP',23,'Syntax:\n[begin_label:] REPEAT\n    statement_list\nUNTIL search_condition\nEND REPEAT [end_label]\n\nThe statement list within a REPEAT statement is repeated until the\nsearch_condition expression is true. Thus, a REPEAT always enters the\nloop at least once. statement_list consists of one or more statements,\neach terminated by a semicolon (;) statement delimiter.\n\nA REPEAT statement can be labeled. For the rules regarding label use,\nsee [HELP labels].\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/repeat-statement.html\n\n','mysql> delimiter //\n\nmysql> CREATE PROCEDURE dorepeat(p1 INT)\n    -> BEGIN\n    ->   SET @x = 0;\n    ->   REPEAT\n    ->     SET @x = @x + 1;\n    ->   UNTIL @x > p1 END REPEAT;\n    -> END\n    -> //\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> CALL dorepeat(1000)//\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT @x//\n+------+\n| @x   |\n+------+\n| 1001 |\n+------+\n1 row in set (0.00 sec)\n','http://dev.mysql.com/doc/refman/5.1/en/repeat-statement.html'),(232,'ALTER FUNCTION',38,'Syntax:\nALTER FUNCTION func_name [characteristic ...]\n\ncharacteristic:\n    { CONTAINS SQL | NO SQL | READS SQL DATA | MODIFIES SQL DATA }\n  | SQL SECURITY { DEFINER | INVOKER }\n  | COMMENT \'string\'\n\nThis statement can be used to change the characteristics of a stored\nfunction. More than one change may be specified in an ALTER FUNCTION\nstatement. However, you cannot change the parameters or body of a\nstored function using this statement; to make such changes, you must\ndrop and re-create the function using DROP FUNCTION and CREATE\nFUNCTION.\n\nYou must have the ALTER ROUTINE privilege for the function. (That\nprivilege is granted automatically to the function creator.) If binary\nlogging is enabled, the ALTER FUNCTION statement might also require the\nSUPER privilege, as described in\nhttp://dev.mysql.com/doc/refman/5.1/en/stored-programs-logging.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/alter-function.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/alter-function.html'),(233,'SMALLINT',22,'SMALLINT[(M)] [UNSIGNED] [ZEROFILL]\n\nA small integer. The signed range is -32768 to 32767. The unsigned\nrange is 0 to 65535.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html'),(234,'DOUBLE PRECISION',22,'DOUBLE PRECISION[(M,D)] [UNSIGNED] [ZEROFILL], REAL[(M,D)] [UNSIGNED]\n[ZEROFILL]\n\nThese types are synonyms for DOUBLE. Exception: If the REAL_AS_FLOAT\nSQL mode is enabled, REAL is a synonym for FLOAT rather than DOUBLE.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html'),(235,'ORD',36,'Syntax:\nORD(str)\n\nIf the leftmost character of the string str is a multi-byte character,\nreturns the code for that character, calculated from the numeric values\nof its constituent bytes using this formula:\n\n  (1st byte code)\n+ (2nd byte code * 256)\n+ (3rd byte code * 2562) ...\n\nIf the leftmost character is not a multi-byte character, ORD() returns\nthe same value as the ASCII() function.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT ORD(\'2\');\n        -> 50\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(236,'DEALLOCATE PREPARE',8,'Syntax:\n{DEALLOCATE | DROP} PREPARE stmt_name\n\nTo deallocate a prepared statement produced with PREPARE, use a\nDEALLOCATE PREPARE statement that refers to the prepared statement\nname. Attempting to execute a prepared statement after deallocating it\nresults in an error.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/deallocate-prepare.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/deallocate-prepare.html'),(237,'ENVELOPE',35,'Envelope(g)\n\nReturns the Minimum Bounding Rectangle (MBR) for the geometry value g.\nThe result is returned as a Polygon value.\n\nThe polygon is defined by the corner points of the bounding box:\n\nPOLYGON((MINX MINY, MAXX MINY, MAXX MAXY, MINX MAXY, MINX MINY))\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#general-geometry-property-functions\n\n','mysql> SELECT AsText(Envelope(GeomFromText(\'LineString(1 1,2 2)\')));\n+-------------------------------------------------------+\n| AsText(Envelope(GeomFromText(\'LineString(1 1,2 2)\'))) |\n+-------------------------------------------------------+\n| POLYGON((1 1,2 1,2 2,1 2,1 1))                        |\n+-------------------------------------------------------+\n','http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#general-geometry-property-functions'),(238,'IS_FREE_LOCK',15,'Syntax:\nIS_FREE_LOCK(str)\n\nChecks whether the lock named str is free to use (that is, not locked).\nReturns 1 if the lock is free (no one is using the lock), 0 if the lock\nis in use, and NULL if an error occurs (such as an incorrect argument).\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html'),(239,'TOUCHES',30,'Touches(g1,g2)\n\nReturns 1 or 0 to indicate whether g1 spatially touches g2. Two\ngeometries spatially touch if the interiors of the geometries do not\nintersect, but the boundary of one of the geometries intersects either\nthe boundary or the interior of the other.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-test-spatial-relationships-between-geometries\n\n','','http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-tes'),(240,'INET_ATON',15,'Syntax:\nINET_ATON(expr)\n\nGiven the dotted-quad representation of an IPv4 network address as a\nstring, returns an integer that represents the numeric value of the\naddress in network byte order (big endian). INET_ATON() returns NULL if\nit does not understand its argument.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html\n\n','mysql> SELECT INET_ATON(\'10.0.5.9\');\n        -> 167773449\n','http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html'),(241,'UNCOMPRESS',12,'Syntax:\nUNCOMPRESS(string_to_uncompress)\n\nUncompresses a string compressed by the COMPRESS() function. If the\nargument is not a compressed value, the result is NULL. This function\nrequires MySQL to have been compiled with a compression library such as\nzlib. Otherwise, the return value is always NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html\n\n','mysql> SELECT UNCOMPRESS(COMPRESS(\'any string\'));\n        -> \'any string\'\nmysql> SELECT UNCOMPRESS(\'any string\');\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html'),(242,'AUTO_INCREMENT',22,'The AUTO_INCREMENT attribute can be used to generate a unique identity\nfor new rows:\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/example-auto-increment.html\n\n','CREATE TABLE animals (\n     id MEDIUMINT NOT NULL AUTO_INCREMENT,\n     name CHAR(30) NOT NULL,\n     PRIMARY KEY (id)\n) ENGINE=MyISAM;\n\nINSERT INTO animals (name) VALUES\n    (\'dog\'),(\'cat\'),(\'penguin\'),\n    (\'lax\'),(\'whale\'),(\'ostrich\');\n\nSELECT * FROM animals;\n','http://dev.mysql.com/doc/refman/5.1/en/example-auto-increment.html'),(243,'ISSIMPLE',35,'IsSimple(g)\n\nCurrently, this function is a placeholder and should not be used. If\nimplemented, its behavior will be as described in the next paragraph.\n\nReturns 1 if the geometry value g has no anomalous geometric points,\nsuch as self-intersection or self-tangency. IsSimple() returns 0 if the\nargument is not simple, and -1 if it is NULL.\n\nThe description of each instantiable geometric class given earlier in\nthe chapter includes the specific conditions that cause an instance of\nthat class to be classified as not simple. (See [HELP Geometry\nhierarchy].)\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#general-geometry-property-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#general-geometry-property-functions'),(244,'- BINARY',4,'Syntax:\n-\n\nSubtraction:\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/arithmetic-functions.html\n\n','mysql> SELECT 3-5;\n        -> -2\n','http://dev.mysql.com/doc/refman/5.1/en/arithmetic-functions.html'),(245,'GEOMCOLLFROMTEXT',3,'GeomCollFromText(wkt[,srid]), GeometryCollectionFromText(wkt[,srid])\n\nConstructs a GEOMETRYCOLLECTION value using its WKT representation and\nSRID.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkt-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkt-functions'),(246,'WKT DEFINITION',3,'The Well-Known Text (WKT) representation of Geometry is designed to\nexchange geometry data in ASCII form. For a Backus-Naur grammar that\nspecifies the formal production rules for writing WKT values, see the\nOpenGIS specification document referenced in\nhttp://dev.mysql.com/doc/refman/5.1/en/spatial-extensions.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/gis-wkt-format.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/gis-wkt-format.html'),(247,'CURRENT_TIME',31,'Syntax:\nCURRENT_TIME, CURRENT_TIME()\n\nCURRENT_TIME and CURRENT_TIME() are synonyms for CURTIME().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(248,'REVOKE',10,'Syntax:\nREVOKE\n    priv_type [(column_list)]\n      [, priv_type [(column_list)]] ...\n    ON [object_type] priv_level\n    FROM user [, user] ...\n\nREVOKE ALL PRIVILEGES, GRANT OPTION\n    FROM user [, user] ...\n\nThe REVOKE statement enables system administrators to revoke privileges\nfrom MySQL accounts. Each account name uses the format described in\nhttp://dev.mysql.com/doc/refman/5.1/en/account-names.html. For example:\n\nREVOKE INSERT ON *.* FROM \'jeffrey\'@\'localhost\';\n\nIf you specify only the user name part of the account name, a host name\npart of \'%\' is used.\n\nFor details on the levels at which privileges exist, the permissible\npriv_type and priv_level values, and the syntax for specifying users\nand passwords, see [HELP GRANT]\n\nTo use the first REVOKE syntax, you must have the GRANT OPTION\nprivilege, and you must have the privileges that you are revoking.\n\nTo revoke all privileges, use the second syntax, which drops all\nglobal, database, table, column, and routine privileges for the named\nuser or users:\n\nREVOKE ALL PRIVILEGES, GRANT OPTION FROM user [, user] ...\n\nTo use this REVOKE syntax, you must have the global CREATE USER\nprivilege or the UPDATE privilege for the mysql database.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/revoke.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/revoke.html'),(249,'LAST_INSERT_ID',17,'Syntax:\nLAST_INSERT_ID(), LAST_INSERT_ID(expr)\n\nFor MySQL 5.1.12 and later, LAST_INSERT_ID() (with no argument) returns\na BIGINT (64-bit) value representing the first automatically generated\nvalue successfully inserted for an AUTO_INCREMENT column as a result of\nthe most recently executed INSERT statement. The value of\nLAST_INSERT_ID() remains unchanged if no rows are successfully\ninserted.\n\nFor example, after inserting a row that generates an AUTO_INCREMENT\nvalue, you can get the value like this:\n\nmysql> SELECT LAST_INSERT_ID();\n        -> 195\n\nIn MySQL 5.1.11 and earlier, LAST_INSERT_ID() (with no argument)\nreturns the first automatically generated value if any rows were\nsuccessfully inserted or updated. This means that the returned value\ncould be a value that was not successfully inserted into the table. If\nno rows were successfully inserted, LAST_INSERT_ID() returns 0.\n\nThe value of LAST_INSERT_ID() will be consistent across all MySQL\nversions if all rows in the INSERT or UPDATE statement were successful.\n\nif a table contains an AUTO_INCREMENT column and INSERT ... ON\nDUPLICATE KEY UPDATE updates (rather than inserts) a row, the value of\nLAST_INSERT_ID() is not meaningful prior to MySQL 5.1.12. For a\nworkaround, see\nhttp://dev.mysql.com/doc/refman/5.1/en/insert-on-duplicate.html.\n\nThe currently executing statement does not affect the value of\nLAST_INSERT_ID(). Suppose that you generate an AUTO_INCREMENT value\nwith one statement, and then refer to LAST_INSERT_ID() in a\nmultiple-row INSERT statement that inserts rows into a table with its\nown AUTO_INCREMENT column. The value of LAST_INSERT_ID() will remain\nstable in the second statement; its value for the second and later rows\nis not affected by the earlier row insertions. (However, if you mix\nreferences to LAST_INSERT_ID() and LAST_INSERT_ID(expr), the effect is\nundefined.)\n\nIf the previous statement returned an error, the value of\nLAST_INSERT_ID() is undefined. For transactional tables, if the\nstatement is rolled back due to an error, the value of LAST_INSERT_ID()\nis left undefined. For manual ROLLBACK, the value of LAST_INSERT_ID()\nis not restored to that before the transaction; it remains as it was at\nthe point of the ROLLBACK.\n\nWithin the body of a stored routine (procedure or function) or a\ntrigger, the value of LAST_INSERT_ID() changes the same way as for\nstatements executed outside the body of these kinds of objects. The\neffect of a stored routine or trigger upon the value of\nLAST_INSERT_ID() that is seen by following statements depends on the\nkind of routine:\n\no If a stored procedure executes statements that change the value of\n  LAST_INSERT_ID(), the changed value is seen by statements that follow\n  the procedure call.\n\no For stored functions and triggers that change the value, the value is\n  restored when the function or trigger ends, so following statements\n  will not see a changed value.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/information-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/information-functions.html'),(250,'LAST_DAY',31,'Syntax:\nLAST_DAY(date)\n\nTakes a date or datetime value and returns the corresponding value for\nthe last day of the month. Returns NULL if the argument is invalid.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT LAST_DAY(\'2003-02-05\');\n        -> \'2003-02-28\'\nmysql> SELECT LAST_DAY(\'2004-02-05\');\n        -> \'2004-02-29\'\nmysql> SELECT LAST_DAY(\'2004-01-01 01:01:01\');\n        -> \'2004-01-31\'\nmysql> SELECT LAST_DAY(\'2003-03-32\');\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(251,'MEDIUMINT',22,'MEDIUMINT[(M)] [UNSIGNED] [ZEROFILL]\n\nA medium-sized integer. The signed range is -8388608 to 8388607. The\nunsigned range is 0 to 16777215.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html'),(252,'FLOOR',4,'Syntax:\nFLOOR(X)\n\nReturns the largest integer value not greater than X.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT FLOOR(1.23);\n        -> 1\nmysql> SELECT FLOOR(-1.23);\n        -> -2\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(253,'RTRIM',36,'Syntax:\nRTRIM(str)\n\nReturns the string str with trailing space characters removed.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT RTRIM(\'barbar   \');\n        -> \'barbar\'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(254,'EXPLAIN',28,'Syntax:\nEXPLAIN [explain_type] SELECT select_options\n\nexplain_type:\n    EXTENDED\n  | PARTITIONS\n\nOr:\n\nEXPLAIN tbl_name\n\nThe EXPLAIN statement can be used either as a way to obtain information\nabout how MySQL executes a statement, or as a synonym for DESCRIBE:\n\no When you precede a SELECT statement with the keyword EXPLAIN, MySQL\n  displays information from the optimizer about the query execution\n  plan. That is, MySQL explains how it would process the statement,\n  including information about how tables are joined and in which order.\n  EXPLAIN EXTENDED can be used to provide additional information.\n\n  For information about using EXPLAIN and EXPLAIN EXTENDED to obtain\n  query execution plan information, see\n  http://dev.mysql.com/doc/refman/5.1/en/using-explain.html.\n\no EXPLAIN PARTITIONS is available beginning with MySQL 5.1.5. It is\n  useful only when examining queries involving partitioned tables. For\n  details, see\n  http://dev.mysql.com/doc/refman/5.1/en/partitioning-info.html.\n\no EXPLAIN tbl_name is synonymous with DESCRIBE tbl_name or SHOW COLUMNS\n  FROM tbl_name. For information about DESCRIBE and SHOW COLUMNS, see\n  [HELP DESCRIBE], and [HELP SHOW COLUMNS].\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/explain.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/explain.html'),(255,'DEGREES',4,'Syntax:\nDEGREES(X)\n\nReturns the argument X, converted from radians to degrees.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT DEGREES(PI());\n        -> 180\nmysql> SELECT DEGREES(PI() / 2);\n        -> 90\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(256,'VARCHAR',22,'[NATIONAL] VARCHAR(M) [CHARACTER SET charset_name] [COLLATE\ncollation_name]\n\nA variable-length string. M represents the maximum column length in\ncharacters. The range of M is 0 to 65,535. The effective maximum length\nof a VARCHAR is subject to the maximum row size (65,535 bytes, which is\nshared among all columns) and the character set used. For example, utf8\ncharacters can require up to three bytes per character, so a VARCHAR\ncolumn that uses the utf8 character set can be declared to be a maximum\nof 21,844 characters. See\nhttp://dev.mysql.com/doc/refman/5.1/en/column-count-limit.html.\n\nMySQL stores VARCHAR values as a one-byte or two-byte length prefix\nplus data. The length prefix indicates the number of bytes in the\nvalue. A VARCHAR column uses one length byte if values require no more\nthan 255 bytes, two length bytes if values may require more than 255\nbytes.\n\n*Note*: MySQL 5.1 follows the standard SQL specification, and does not\nremove trailing spaces from VARCHAR values.\n\nVARCHAR is shorthand for CHARACTER VARYING. NATIONAL VARCHAR is the\nstandard SQL way to define that a VARCHAR column should use some\npredefined character set. MySQL 4.1 and up uses utf8 as this predefined\ncharacter set.\nhttp://dev.mysql.com/doc/refman/5.1/en/charset-national.html. NVARCHAR\nis shorthand for NATIONAL VARCHAR.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html'),(257,'UNHEX',36,'Syntax:\n\nUNHEX(str)\n\nFor a string argument str, UNHEX(str) performs the inverse operation of\nHEX(str). That is, it interprets each pair of characters in the\nargument as a hexadecimal number and converts it to the character\nrepresented by the number. The return value is a binary string.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT UNHEX(\'4D7953514C\');\n        -> \'MySQL\'\nmysql> SELECT 0x4D7953514C;\n        -> \'MySQL\'\nmysql> SELECT UNHEX(HEX(\'string\'));\n        -> \'string\'\nmysql> SELECT HEX(UNHEX(\'1267\'));\n        -> \'1267\'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(258,'- UNARY',4,'Syntax:\n-\n\nUnary minus. This operator changes the sign of the operand.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/arithmetic-functions.html\n\n','mysql> SELECT - 2;\n        -> -2\n','http://dev.mysql.com/doc/refman/5.1/en/arithmetic-functions.html'),(259,'STD',16,'Syntax:\nSTD(expr)\n\nReturns the population standard deviation of expr. This is an extension\nto standard SQL. The standard SQL function STDDEV_POP() can be used\ninstead.\n\nThis function returns NULL if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html'),(260,'COS',4,'Syntax:\nCOS(X)\n\nReturns the cosine of X, where X is given in radians.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT COS(PI());\n        -> -1\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(261,'DATE FUNCTION',31,'Syntax:\nDATE(expr)\n\nExtracts the date part of the date or datetime expression expr.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT DATE(\'2003-12-31 01:02:03\');\n        -> \'2003-12-31\'\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(262,'DROP TRIGGER',38,'Syntax:\nDROP TRIGGER [IF EXISTS] [schema_name.]trigger_name\n\nThis statement drops a trigger. The schema (database) name is optional.\nIf the schema is omitted, the trigger is dropped from the default\nschema. DROP TRIGGER requires the TRIGGER privilege for the table\nassociated with the trigger. (This statement requires the SUPER\nprivilege prior to MySQL 5.1.6.)\n\nUse IF EXISTS to prevent an error from occurring for a trigger that\ndoes not exist. A NOTE is generated for a nonexistent trigger when\nusing IF EXISTS. See [HELP SHOW WARNINGS]. The IF EXISTS clause was\nadded in MySQL 5.1.14.\n\nTriggers for a table are also dropped if you drop the table.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/drop-trigger.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/drop-trigger.html'),(263,'RESET MASTER',8,'Syntax:\nRESET MASTER\n\nDeletes all binary log files listed in the index file, resets the\nbinary log index file to be empty, and creates a new binary log file.\nThis statement is intended to be used only when the master is started\nfor the first time.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/reset-master.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/reset-master.html'),(264,'TAN',4,'Syntax:\nTAN(X)\n\nReturns the tangent of X, where X is given in radians.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT TAN(PI());\n        -> -1.2246063538224e-16\nmysql> SELECT TAN(PI()+1);\n        -> 1.5574077246549\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(265,'PI',4,'Syntax:\nPI()\n\nReturns the value of π (pi). The default number of decimal places\ndisplayed is seven, but MySQL uses the full double-precision value\ninternally.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT PI();\n        -> 3.141593\nmysql> SELECT PI()+0.000000000000000000;\n        -> 3.141592653589793116\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(266,'WEEKOFYEAR',31,'Syntax:\nWEEKOFYEAR(date)\n\nReturns the calendar week of the date as a number in the range from 1\nto 53. WEEKOFYEAR() is a compatibility function that is equivalent to\nWEEK(date,3).\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT WEEKOFYEAR(\'2008-02-20\');\n        -> 8\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(267,'/',4,'Syntax:\n/\n\nDivision:\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/arithmetic-functions.html\n\n','mysql> SELECT 3/5;\n        -> 0.60\n','http://dev.mysql.com/doc/refman/5.1/en/arithmetic-functions.html'),(268,'PURGE BINARY LOGS',8,'Syntax:\nPURGE { BINARY | MASTER } LOGS\n    { TO \'log_name\' | BEFORE datetime_expr }\n\nThe binary log is a set of files that contain information about data\nmodifications made by the MySQL server. The log consists of a set of\nbinary log files, plus an index file (see\nhttp://dev.mysql.com/doc/refman/5.1/en/binary-log.html).\n\nThe PURGE BINARY LOGS statement deletes all the binary log files listed\nin the log index file prior to the specified log file name or date.\nBINARY and MASTER are synonyms. Deleted log files also are removed from\nthe list recorded in the index file, so that the given log file becomes\nthe first in the list.\n\nThis statement has no effect if the server was not started with the\n--log-bin option to enable binary logging.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/purge-binary-logs.html\n\n','PURGE BINARY LOGS TO \'mysql-bin.010\';\nPURGE BINARY LOGS BEFORE \'2008-04-02 22:46:26\';\n','http://dev.mysql.com/doc/refman/5.1/en/purge-binary-logs.html'),(269,'STDDEV_SAMP',16,'Syntax:\nSTDDEV_SAMP(expr)\n\nReturns the sample standard deviation of expr (the square root of\nVAR_SAMP().\n\nSTDDEV_SAMP() returns NULL if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html'),(270,'SCHEMA',17,'Syntax:\nSCHEMA()\n\nThis function is a synonym for DATABASE().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/information-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/information-functions.html'),(271,'MLINEFROMWKB',32,'MLineFromWKB(wkb[,srid]), MultiLineStringFromWKB(wkb[,srid])\n\nConstructs a MULTILINESTRING value using its WKB representation and\nSRID.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkb-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkb-functions'),(272,'LOG2',4,'Syntax:\nLOG2(X)\n\nReturns the base-2 logarithm of X.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT LOG2(65536);\n        -> 16\nmysql> SELECT LOG2(-100);\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(273,'SUBTIME',31,'Syntax:\nSUBTIME(expr1,expr2)\n\nSUBTIME() returns expr1 - expr2 expressed as a value in the same format\nas expr1. expr1 is a time or datetime expression, and expr2 is a time\nexpression.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT SUBTIME(\'2007-12-31 23:59:59.999999\',\'1 1:1:1.000002\');\n        -> \'2007-12-30 22:58:58.999997\'\nmysql> SELECT SUBTIME(\'01:00:00.999999\', \'02:00:00.999998\');\n        -> \'-00:59:59.999999\'\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(274,'UNCOMPRESSED_LENGTH',12,'Syntax:\nUNCOMPRESSED_LENGTH(compressed_string)\n\nReturns the length that the compressed string had before being\ncompressed.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html\n\n','mysql> SELECT UNCOMPRESSED_LENGTH(COMPRESS(REPEAT(\'a\',30)));\n        -> 30\n','http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html'),(275,'DROP TABLE',38,'Syntax:\nDROP [TEMPORARY] TABLE [IF EXISTS]\n    tbl_name [, tbl_name] ...\n    [RESTRICT | CASCADE]\n\nDROP TABLE removes one or more tables. You must have the DROP privilege\nfor each table. All table data and the table definition are removed, so\nbe careful with this statement! If any of the tables named in the\nargument list do not exist, MySQL returns an error indicating by name\nwhich nonexisting tables it was unable to drop, but it also drops all\nof the tables in the list that do exist.\n\n*Important*: When a table is dropped, user privileges on the table are\nnot automatically dropped. See [HELP GRANT].\n\nNote that for a partitioned table, DROP TABLE permanently removes the\ntable definition, all of its partitions, and all of the data which was\nstored in those partitions. It also removes the partitioning definition\n(.par) file associated with the dropped table.\n\nUse IF EXISTS to prevent an error from occurring for tables that do not\nexist. A NOTE is generated for each nonexistent table when using IF\nEXISTS. See [HELP SHOW WARNINGS].\n\nRESTRICT and CASCADE are permitted to make porting easier. In MySQL\n5.1, they do nothing.\n\n*Note*: DROP TABLE automatically commits the current active\ntransaction, unless you use the TEMPORARY keyword.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/drop-table.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/drop-table.html'),(276,'POW',4,'Syntax:\nPOW(X,Y)\n\nReturns the value of X raised to the power of Y.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT POW(2,2);\n        -> 4\nmysql> SELECT POW(2,-2);\n        -> 0.25\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(277,'SHOW CREATE TABLE',26,'Syntax:\nSHOW CREATE TABLE tbl_name\n\nShows the CREATE TABLE statement that creates the given table. The\nstatement requires the SELECT privilege for the table. This statement\nalso works with views.\nSHOW CREATE TABLE quotes table and column names according to the value\nof the sql_quote_show_create option. See\nhttp://dev.mysql.com/doc/refman/5.1/en/server-system-variables.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-create-table.html\n\n','mysql> SHOW CREATE TABLE t\\G\n*************************** 1. row ***************************\n       Table: t\nCreate Table: CREATE TABLE t (\n  id INT(11) default NULL auto_increment,\n  s char(60) default NULL,\n  PRIMARY KEY (id)\n) ENGINE=MyISAM\n','http://dev.mysql.com/doc/refman/5.1/en/show-create-table.html'),(278,'DUAL',27,'You are permitted to specify DUAL as a dummy table name in situations\nwhere no tables are referenced:\n\nmysql> SELECT 1 + 1 FROM DUAL;\n        -> 2\n\nDUAL is purely for the convenience of people who require that all\nSELECT statements should have FROM and possibly other clauses. MySQL\nmay ignore the clauses. MySQL does not require FROM DUAL if no tables\nare referenced.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/select.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/select.html'),(279,'INSTR',36,'Syntax:\nINSTR(str,substr)\n\nReturns the position of the first occurrence of substring substr in\nstring str. This is the same as the two-argument form of LOCATE(),\nexcept that the order of the arguments is reversed.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT INSTR(\'foobarbar\', \'bar\');\n        -> 4\nmysql> SELECT INSTR(\'xbar\', \'foobar\');\n        -> 0\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(280,'NOW',31,'Syntax:\nNOW()\n\nReturns the current date and time as a value in \'YYYY-MM-DD HH:MM:SS\'\nor YYYYMMDDHHMMSS.uuuuuu format, depending on whether the function is\nused in a string or numeric context. The value is expressed in the\ncurrent time zone.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT NOW();\n        -> \'2007-12-15 23:50:26\'\nmysql> SELECT NOW() + 0;\n        -> 20071215235026.000000\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(281,'SHOW ENGINES',26,'Syntax:\nSHOW [STORAGE] ENGINES\n\nSHOW ENGINES displays status information about the server\'s storage\nengines. This is particularly useful for checking whether a storage\nengine is supported, or to see what the default engine is. SHOW TABLE\nTYPES is a synonym, but is deprecated and is removed in MySQL 5.5.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-engines.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-engines.html'),(282,'>=',18,'Syntax:\n>=\n\nGreater than or equal:\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html\n\n','mysql> SELECT 2 >= 2;\n        -> 1\n','http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html'),(283,'EXP',4,'Syntax:\nEXP(X)\n\nReturns the value of e (the base of natural logarithms) raised to the\npower of X. The inverse of this function is LOG() (using a single\nargument only) or LN().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT EXP(2);\n        -> 7.3890560989307\nmysql> SELECT EXP(-2);\n        -> 0.13533528323661\nmysql> SELECT EXP(0);\n        -> 1\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(284,'LONGBLOB',22,'LONGBLOB\n\nA BLOB column with a maximum length of 4,294,967,295 or 4GB (232 - 1)\nbytes. The effective maximum length of LONGBLOB columns depends on the\nconfigured maximum packet size in the client/server protocol and\navailable memory. Each LONGBLOB value is stored using a four-byte\nlength prefix that indicates the number of bytes in the value.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html'),(285,'POINTN',13,'PointN(ls,N)\n\nReturns the N-th Point in the Linestring value ls. Points are numbered\nbeginning with 1.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#linestring-property-functions\n\n','mysql> SET @ls = \'LineString(1 1,2 2,3 3)\';\nmysql> SELECT AsText(PointN(GeomFromText(@ls),2));\n+-------------------------------------+\n| AsText(PointN(GeomFromText(@ls),2)) |\n+-------------------------------------+\n| POINT(2 2)                          |\n+-------------------------------------+\n','http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#linestring-property-functions'),(286,'YEAR DATA TYPE',22,'YEAR[(2|4)]\n\nA year in two-digit or four-digit format. The default is four-digit\nformat. YEAR(2) or YEAR(4) differ in display format, but have the same\nrange of values. In four-digit format, values display as 1901 to 2155,\nand 0000. In two-digit format, values display as 70 to 69, representing\nyears from 1970 to 2069. MySQL displays YEAR values in YYYY or\nYYformat, but permits assignment of values to YEAR columns using either\nstrings or numbers.\n\nFor additional information about YEAR display format and inerpretation\nof input values, see http://dev.mysql.com/doc/refman/5.1/en/year.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-type-overview.html'),(287,'SUM',16,'Syntax:\nSUM([DISTINCT] expr)\n\nReturns the sum of expr. If the return set has no rows, SUM() returns\nNULL. The DISTINCT keyword can be used to sum only the distinct values\nof expr.\n\nSUM() returns NULL if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html'),(288,'OCT',4,'Syntax:\nOCT(N)\n\nReturns a string representation of the octal value of N, where N is a\nlonglong (BIGINT) number. This is equivalent to CONV(N,10,8). Returns\nNULL if N is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT OCT(12);\n        -> \'14\'\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(289,'SYSDATE',31,'Syntax:\nSYSDATE()\n\nReturns the current date and time as a value in \'YYYY-MM-DD HH:MM:SS\'\nor YYYYMMDDHHMMSS.uuuuuu format, depending on whether the function is\nused in a string or numeric context.\n\nSYSDATE() returns the time at which it executes. This differs from the\nbehavior for NOW(), which returns a constant time that indicates the\ntime at which the statement began to execute. (Within a stored function\nor trigger, NOW() returns the time at which the function or triggering\nstatement began to execute.)\n\nmysql> SELECT NOW(), SLEEP(2), NOW();\n+---------------------+----------+---------------------+\n| NOW()               | SLEEP(2) | NOW()               |\n+---------------------+----------+---------------------+\n| 2006-04-12 13:47:36 |        0 | 2006-04-12 13:47:36 |\n+---------------------+----------+---------------------+\n\nmysql> SELECT SYSDATE(), SLEEP(2), SYSDATE();\n+---------------------+----------+---------------------+\n| SYSDATE()           | SLEEP(2) | SYSDATE()           |\n+---------------------+----------+---------------------+\n| 2006-04-12 13:47:44 |        0 | 2006-04-12 13:47:46 |\n+---------------------+----------+---------------------+\n\nIn addition, the SET TIMESTAMP statement affects the value returned by\nNOW() but not by SYSDATE(). This means that timestamp settings in the\nbinary log have no effect on invocations of SYSDATE().\n\nBecause SYSDATE() can return different values even within the same\nstatement, and is not affected by SET TIMESTAMP, it is nondeterministic\nand therefore unsafe for replication if statement-based binary logging\nis used. If that is a problem, you can use row-based logging.\n\nAlternatively, you can use the --sysdate-is-now option to cause\nSYSDATE() to be an alias for NOW(). This works if the option is used on\nboth the master and the slave.\n\nThe nondeterministic nature of SYSDATE() also means that indexes cannot\nbe used for evaluating expressions that refer to it.\n\nBeginning with MySQL 5.1.42, a warning is logged if you use this\nfunction when binlog_format is set to STATEMENT. (Bug #47995)\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(290,'UNINSTALL PLUGIN',5,'Syntax:\nUNINSTALL PLUGIN plugin_name\n\nThis statement removes an installed server plugin. It requires the\nDELETE privilege for the mysql.plugin table.\n\nplugin_name must be the name of some plugin that is listed in the\nmysql.plugin table. The server executes the plugin\'s deinitialization\nfunction and removes the row for the plugin from the mysql.plugin\ntable, so that subsequent server restarts will not load and initialize\nthe plugin. UNINSTALL PLUGIN does not remove the plugin\'s shared\nlibrary file.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/uninstall-plugin.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/uninstall-plugin.html'),(291,'ASBINARY',32,'AsBinary(g), AsWKB(g)\n\nConverts a value in internal geometry format to its WKB representation\nand returns the binary result.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/functions-to-convert-geometries-between-formats.html\n\n','SELECT AsBinary(g) FROM geom;\n','http://dev.mysql.com/doc/refman/5.1/en/functions-to-convert-geometries-between-formats.html'),(292,'REPEAT FUNCTION',36,'Syntax:\nREPEAT(str,count)\n\nReturns a string consisting of the string str repeated count times. If\ncount is less than 1, returns an empty string. Returns NULL if str or\ncount are NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT REPEAT(\'MySQL\', 3);\n        -> \'MySQLMySQLMySQL\'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(293,'SHOW TABLES',26,'Syntax:\nSHOW [FULL] TABLES [{FROM | IN} db_name]\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW TABLES lists the non-TEMPORARY tables in a given database. You can\nalso get this list using the mysqlshow db_name command. The LIKE\nclause, if present, indicates which table names to match. The WHERE\nclause can be given to select rows using more general conditions, as\ndiscussed in http://dev.mysql.com/doc/refman/5.1/en/extended-show.html.\n\nThis statement also lists any views in the database. The FULL modifier\nis supported such that SHOW FULL TABLES displays a second output\ncolumn. Values for the second column are BASE TABLE for a table and\nVIEW for a view.\n\nIf you have no privileges for a base table or view, it does not show up\nin the output from SHOW TABLES or mysqlshow db_name.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-tables.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-tables.html'),(294,'MAKEDATE',31,'Syntax:\nMAKEDATE(year,dayofyear)\n\nReturns a date, given year and day-of-year values. dayofyear must be\ngreater than 0 or the result is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT MAKEDATE(2011,31), MAKEDATE(2011,32);\n        -> \'2011-01-31\', \'2011-02-01\'\nmysql> SELECT MAKEDATE(2011,365), MAKEDATE(2014,365);\n        -> \'2011-12-31\', \'2014-12-31\'\nmysql> SELECT MAKEDATE(2011,0);\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(295,'BINARY OPERATOR',36,'Syntax:\nBINARY\n\nThe BINARY operator casts the string following it to a binary string.\nThis is an easy way to force a column comparison to be done byte by\nbyte rather than character by character. This causes the comparison to\nbe case sensitive even if the column is not defined as BINARY or BLOB.\nBINARY also causes trailing spaces to be significant.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/cast-functions.html\n\n','mysql> SELECT \'a\' = \'A\';\n        -> 1\nmysql> SELECT BINARY \'a\' = \'A\';\n        -> 0\nmysql> SELECT \'a\' = \'a \';\n        -> 1\nmysql> SELECT BINARY \'a\' = \'a \';\n        -> 0\n','http://dev.mysql.com/doc/refman/5.1/en/cast-functions.html'),(296,'MBROVERLAPS',6,'MBROverlaps(g1,g2)\n\nReturns 1 or 0 to indicate whether the Minimum Bounding Rectangles of\nthe two geometries g1 and g2 overlap. The term spatially overlaps is\nused if two geometries intersect and their intersection results in a\ngeometry of the same dimension but not equal to either of the given\ngeometries.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geometry-mbr\n\n','','http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geome'),(297,'SOUNDEX',36,'Syntax:\nSOUNDEX(str)\n\nReturns a soundex string from str. Two strings that sound almost the\nsame should have identical soundex strings. A standard soundex string\nis four characters long, but the SOUNDEX() function returns an\narbitrarily long string. You can use SUBSTRING() on the result to get a\nstandard soundex string. All nonalphabetic characters in str are\nignored. All international alphabetic characters outside the A-Z range\nare treated as vowels.\n\n*Important*: When using SOUNDEX(), you should be aware of the following\nlimitations:\n\no This function, as currently implemented, is intended to work well\n  with strings that are in the English language only. Strings in other\n  languages may not produce reliable results.\n\no This function is not guaranteed to provide consistent results with\n  strings that use multi-byte character sets, including utf-8.\n\n  We hope to remove these limitations in a future release. See Bug\n  #22638 for more information.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT SOUNDEX(\'Hello\');\n        -> \'H400\'\nmysql> SELECT SOUNDEX(\'Quadratically\');\n        -> \'Q36324\'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(298,'MBRTOUCHES',6,'MBRTouches(g1,g2)\n\nReturns 1 or 0 to indicate whether the Minimum Bounding Rectangles of\nthe two geometries g1 and g2 touch. Two geometries spatially touch if\nthe interiors of the geometries do not intersect, but the boundary of\none of the geometries intersects either the boundary or the interior of\nthe other.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geometry-mbr\n\n','','http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geome'),(299,'DROP EVENT',38,'Syntax:\nDROP EVENT [IF EXISTS] event_name\n\nThis statement drops the event named event_name. The event immediately\nceases being active, and is deleted completely from the server.\n\nIf the event does not exist, the error ERROR 1517 (HY000): Unknown\nevent \'event_name\' results. You can override this and cause the\nstatement to generate a warning for nonexistent events instead using IF\nEXISTS.\n\nBeginning with MySQL 5.1.12, this statement requires the EVENT\nprivilege for the schema to which the event to be dropped belongs. (In\nMySQL 5.1.11 and earlier, an event could be dropped only by its\ndefiner, or by a user having the SUPER privilege.)\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/drop-event.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/drop-event.html'),(300,'INSERT SELECT',27,'Syntax:\nINSERT [LOW_PRIORITY | HIGH_PRIORITY] [IGNORE]\n    [INTO] tbl_name [(col_name,...)]\n    SELECT ...\n    [ ON DUPLICATE KEY UPDATE col_name=expr, ... ]\n\nWith INSERT ... SELECT, you can quickly insert many rows into a table\nfrom one or many tables. For example:\n\nINSERT INTO tbl_temp2 (fld_id)\n  SELECT tbl_temp1.fld_order_id\n  FROM tbl_temp1 WHERE tbl_temp1.fld_order_id > 100;\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/insert-select.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/insert-select.html'),(301,'CREATE PROCEDURE',38,'Syntax:\nCREATE\n    [DEFINER = { user | CURRENT_USER }]\n    PROCEDURE sp_name ([proc_parameter[,...]])\n    [characteristic ...] routine_body\n\nCREATE\n    [DEFINER = { user | CURRENT_USER }]\n    FUNCTION sp_name ([func_parameter[,...]])\n    RETURNS type\n    [characteristic ...] routine_body\n\nproc_parameter:\n    [ IN | OUT | INOUT ] param_name type\n\nfunc_parameter:\n    param_name type\n\ntype:\n    Any valid MySQL data type\n\ncharacteristic:\n    COMMENT \'string\'\n  | LANGUAGE SQL\n  | [NOT] DETERMINISTIC\n  | { CONTAINS SQL | NO SQL | READS SQL DATA | MODIFIES SQL DATA }\n  | SQL SECURITY { DEFINER | INVOKER }\n\nroutine_body:\n    Valid SQL routine statement\n\nThese statements create stored routines. By default, a routine is\nassociated with the default database. To associate the routine\nexplicitly with a given database, specify the name as db_name.sp_name\nwhen you create it.\n\nThe CREATE FUNCTION statement is also used in MySQL to support UDFs\n(user-defined functions). See\nhttp://dev.mysql.com/doc/refman/5.1/en/adding-functions.html. A UDF can\nbe regarded as an external stored function. Stored functions share\ntheir namespace with UDFs. See\nhttp://dev.mysql.com/doc/refman/5.1/en/function-resolution.html, for\nthe rules describing how the server interprets references to different\nkinds of functions.\n\nTo invoke a stored procedure, use the CALL statement (see [HELP CALL]).\nTo invoke a stored function, refer to it in an expression. The function\nreturns a value during expression evaluation.\n\nCREATE PROCEDURE and CREATE FUNCTION require the CREATE ROUTINE\nprivilege. They might also require the SUPER privilege, depending on\nthe DEFINER value, as described later in this section. If binary\nlogging is enabled, CREATE FUNCTION might require the SUPER privilege,\nas described in\nhttp://dev.mysql.com/doc/refman/5.1/en/stored-programs-logging.html.\n\nBy default, MySQL automatically grants the ALTER ROUTINE and EXECUTE\nprivileges to the routine creator. This behavior can be changed by\ndisabling the automatic_sp_privileges system variable. See\nhttp://dev.mysql.com/doc/refman/5.1/en/stored-routines-privileges.html.\n\nThe DEFINER and SQL SECURITY clauses specify the security context to be\nused when checking access privileges at routine execution time, as\ndescribed later in this section.\n\nIf the routine name is the same as the name of a built-in SQL function,\na syntax error occurs unless you use a space between the name and the\nfollowing parenthesis when defining the routine or invoking it later.\nFor this reason, avoid using the names of existing SQL functions for\nyour own stored routines.\n\nThe IGNORE_SPACE SQL mode applies to built-in functions, not to stored\nroutines. It is always permissible to have spaces after a stored\nroutine name, regardless of whether IGNORE_SPACE is enabled.\n\nThe parameter list enclosed within parentheses must always be present.\nIf there are no parameters, an empty parameter list of () should be\nused. Parameter names are not case sensitive.\n\nEach parameter is an IN parameter by default. To specify otherwise for\na parameter, use the keyword OUT or INOUT before the parameter name.\n\n*Note*: Specifying a parameter as IN, OUT, or INOUT is valid only for a\nPROCEDURE. For a FUNCTION, parameters are always regarded as IN\nparameters.\n\nAn IN parameter passes a value into a procedure. The procedure might\nmodify the value, but the modification is not visible to the caller\nwhen the procedure returns. An OUT parameter passes a value from the\nprocedure back to the caller. Its initial value is NULL within the\nprocedure, and its value is visible to the caller when the procedure\nreturns. An INOUT parameter is initialized by the caller, can be\nmodified by the procedure, and any change made by the procedure is\nvisible to the caller when the procedure returns.\n\nFor each OUT or INOUT parameter, pass a user-defined variable in the\nCALL statement that invokes the procedure so that you can obtain its\nvalue when the procedure returns. If you are calling the procedure from\nwithin another stored procedure or function, you can also pass a\nroutine parameter or local routine variable as an IN or INOUT\nparameter.\n\nThe following example shows a simple stored procedure that uses an OUT\nparameter:\n\nmysql> delimiter //\n\nmysql> CREATE PROCEDURE simpleproc (OUT param1 INT)\n    -> BEGIN\n    ->   SELECT COUNT(*) INTO param1 FROM t;\n    -> END//\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> delimiter ;\n\nmysql> CALL simpleproc(@a);\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT @a;\n+------+\n| @a   |\n+------+\n| 3    |\n+------+\n1 row in set (0.00 sec)\n\nThe example uses the mysql client delimiter command to change the\nstatement delimiter from ; to // while the procedure is being defined.\nThis enables the ; delimiter used in the procedure body to be passed\nthrough to the server rather than being interpreted by mysql itself.\nSee\nhttp://dev.mysql.com/doc/refman/5.1/en/stored-programs-defining.html.\n\nThe RETURNS clause may be specified only for a FUNCTION, for which it\nis mandatory. It indicates the return type of the function, and the\nfunction body must contain a RETURN value statement. If the RETURN\nstatement returns a value of a different type, the value is coerced to\nthe proper type. For example, if a function specifies an ENUM or SET\nvalue in the RETURNS clause, but the RETURN statement returns an\ninteger, the value returned from the function is the string for the\ncorresponding ENUM member of set of SET members.\n\nThe following example function takes a parameter, performs an operation\nusing an SQL function, and returns the result. In this case, it is\nunnecessary to use delimiter because the function definition contains\nno internal ; statement delimiters:\n\nmysql> CREATE FUNCTION hello (s CHAR(20))\nmysql> RETURNS CHAR(50) DETERMINISTIC\n    -> RETURN CONCAT(\'Hello, \',s,\'!\');\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT hello(\'world\');\n+----------------+\n| hello(\'world\') |\n+----------------+\n| Hello, world!  |\n+----------------+\n1 row in set (0.00 sec)\n\nParameter types and function return types can be declared to use any\nvalid data type, except that the COLLATE attribute cannot be used.\n\nThe routine_body consists of a valid SQL routine statement. This can be\na simple statement such as SELECT or INSERT, or a compound statement\nwritten using BEGIN and END. Compound statements can contain\ndeclarations, loops, and other control structure statements. The syntax\nfor these statements is described in\nhttp://dev.mysql.com/doc/refman/5.1/en/sql-syntax-compound-statements.h\ntml.\n\nMySQL permits routines to contain DDL statements, such as CREATE and\nDROP. MySQL also permits stored procedures (but not stored functions)\nto contain SQL transaction statements such as COMMIT. Stored functions\nmay not contain statements that perform explicit or implicit commit or\nrollback. Support for these statements is not required by the SQL\nstandard, which states that each DBMS vendor may decide whether to\npermit them.\n\nStatements that return a result set can be used within a stored\nprocedure but not within a stored function. This prohibition includes\nSELECT statements that do not have an INTO var_list clause and other\nstatements such as SHOW, EXPLAIN, and CHECK TABLE. For statements that\ncan be determined at function definition time to return a result set, a\nNot allowed to return a result set from a function error occurs\n(ER_SP_NO_RETSET). For statements that can be determined only at\nruntime to return a result set, a PROCEDURE %s can\'t return a result\nset in the given context error occurs (ER_SP_BADSELECT).\n\nUSE statements within stored routines are not permitted. When a routine\nis invoked, an implicit USE db_name is performed (and undone when the\nroutine terminates). This causes the routine to have the given default\ndatabase while it executes. References to objects in databases other\nthan the routine default database should be qualified with the\nappropriate database name.\n\nFor additional information about statements that are not permitted in\nstored routines, see\nhttp://dev.mysql.com/doc/refman/5.1/en/stored-program-restrictions.html\n.\n\nFor information about invoking stored procedures from within programs\nwritten in a language that has a MySQL interface, see [HELP CALL].\n\nMySQL stores the sql_mode system variable setting that is in effect at\nthe time a routine is created, and always executes the routine with\nthis setting in force, regardless of the server SQL mode in effect when\nthe routine is invoked.\n\nThe switch from the SQL mode of the invoker to that of the routine\noccurs after evaluation of arguments and assignment of the resulting\nvalues to routine parameters. If you define a routine in strict SQL\nmode but invoke it in nonstrict mode, assignment of arguments to\nroutine parameters does not take place in strict mode. If you require\nthat expressions passed to a routine be assigned in strict SQL mode,\nyou should invoke the routine with strict mode in effect.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/create-procedure.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/create-procedure.html'),(302,'VARBINARY',22,'VARBINARY(M)\n\nThe VARBINARY type is similar to the VARCHAR type, but stores binary\nbyte strings rather than nonbinary character strings. M represents the\nmaximum column length in bytes.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html'),(303,'LOAD INDEX',26,'Syntax:\nLOAD INDEX INTO CACHE\n  tbl_index_list [, tbl_index_list] ...\n\ntbl_index_list:\n  tbl_name\n    [[INDEX|KEY] (index_name[, index_name] ...)]\n    [IGNORE LEAVES]\n\nThe LOAD INDEX INTO CACHE statement preloads a table index into the key\ncache to which it has been assigned by an explicit CACHE INDEX\nstatement, or into the default key cache otherwise. LOAD INDEX INTO\nCACHE is used only for MyISAM tables. It is not supported for tables\nhaving user-defined partitioning (see\nhttp://dev.mysql.com/doc/refman/5.1/en/partitioning-limitations.html.)\n\nThe IGNORE LEAVES modifier causes only blocks for the nonleaf nodes of\nthe index to be preloaded.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/load-index.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/load-index.html'),(304,'UNION',27,'Syntax:\nSELECT ...\nUNION [ALL | DISTINCT] SELECT ...\n[UNION [ALL | DISTINCT] SELECT ...]\n\nUNION is used to combine the result from multiple SELECT statements\ninto a single result set.\n\nThe column names from the first SELECT statement are used as the column\nnames for the results returned. Selected columns listed in\ncorresponding positions of each SELECT statement should have the same\ndata type. (For example, the first column selected by the first\nstatement should have the same type as the first column selected by the\nother statements.)\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/union.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/union.html'),(305,'TO_DAYS',31,'Syntax:\nTO_DAYS(date)\n\nGiven a date date, returns a day number (the number of days since year\n0).\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT TO_DAYS(950501);\n        -> 728779\nmysql> SELECT TO_DAYS(\'2007-10-07\');\n        -> 733321\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(306,'NOT REGEXP',36,'Syntax:\nexpr NOT REGEXP pat, expr NOT RLIKE pat\n\nThis is the same as NOT (expr REGEXP pat).\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/regexp.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/regexp.html'),(307,'SHOW INDEX',26,'Syntax:\nSHOW {INDEX | INDEXES | KEYS}\n    {FROM | IN} tbl_name\n    [{FROM | IN} db_name]\n    [WHERE expr]\n\nSHOW INDEX returns table index information. The format resembles that\nof the SQLStatistics call in ODBC.\nYou can use db_name.tbl_name as an alternative to the tbl_name FROM\ndb_name syntax. These two statements are equivalent:\n\nSHOW INDEX FROM mytable FROM mydb;\nSHOW INDEX FROM mydb.mytable;\n\nThe WHERE clause can be given to select rows using more general\nconditions, as discussed in\nhttp://dev.mysql.com/doc/refman/5.1/en/extended-show.html.\n\nYou can also list a table\'s indexes with the mysqlshow -k db_name\ntbl_name command.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-index.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-index.html'),(308,'SHOW CREATE DATABASE',26,'Syntax:\nSHOW CREATE {DATABASE | SCHEMA} db_name\n\nShows the CREATE DATABASE statement that creates the given database.\nSHOW CREATE SCHEMA is a synonym for SHOW CREATE DATABASE.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-create-database.html\n\n','mysql> SHOW CREATE DATABASE test\\G\n*************************** 1. row ***************************\n       Database: test\nCreate Database: CREATE DATABASE `test`\n                 /*!40100 DEFAULT CHARACTER SET latin1 */\n\nmysql> SHOW CREATE SCHEMA test\\G\n*************************** 1. row ***************************\n       Database: test\nCreate Database: CREATE DATABASE `test`\n                 /*!40100 DEFAULT CHARACTER SET latin1 */\n','http://dev.mysql.com/doc/refman/5.1/en/show-create-database.html'),(309,'LEAVE',23,'Syntax:\nLEAVE label\n\nThis statement is used to exit the flow control construct that has the\ngiven label. If the label is for the outermost stored program block,\nLEAVE exits the program.\n\nLEAVE can be used within BEGIN ... END or loop constructs (LOOP,\nREPEAT, WHILE).\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/leave-statement.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/leave-statement.html'),(310,'NOT IN',18,'Syntax:\nexpr NOT IN (value,...)\n\nThis is the same as NOT (expr IN (value,...)).\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html'),(311,'!',14,'Syntax:\nNOT, !\n\nLogical NOT. Evaluates to 1 if the operand is 0, to 0 if the operand is\nnonzero, and NOT NULL returns NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/logical-operators.html\n\n','mysql> SELECT NOT 10;\n        -> 0\nmysql> SELECT NOT 0;\n        -> 1\nmysql> SELECT NOT NULL;\n        -> NULL\nmysql> SELECT ! (1+1);\n        -> 0\nmysql> SELECT ! 1+1;\n        -> 1\n','http://dev.mysql.com/doc/refman/5.1/en/logical-operators.html'),(312,'DECLARE HANDLER',23,'Syntax:\nDECLARE handler_action HANDLER\n    FOR condition_value [, condition_value] ...\n    statement\n\nhandler_action:\n    CONTINUE\n  | EXIT\n  | UNDO\n\ncondition_value:\n    mysql_error_code\n  | SQLSTATE [VALUE] sqlstate_value\n  | condition_name\n  | SQLWARNING\n  | NOT FOUND\n  | SQLEXCEPTION\n\nThe DECLARE ... HANDLER statement specifies a handler that deals with\none or more conditions. If one of these conditions occurs, the\nspecified statement executes. statement can be a simple statement such\nas SET var_name = value, or a compound statement written using BEGIN\nand END (see [HELP BEGIN END]).\n\nHandler declarations must appear after variable or condition\ndeclarations.\n\nThe handler_action value indicates what action the handler takes after\nexecution of the handler statement:\n\no CONTINUE: Execution of the current program continues.\n\no EXIT: Execution terminates for the BEGIN ... END compound statement\n  in which the handler is declared. This is true even if the condition\n  occurs in an inner block.\n\no UNDO: Not supported.\n\nThe condition_value for DECLARE ... HANDLER indicates the specific\ncondition or class of conditions that activates the handler:\n\no A MySQL error code (a number) or an SQLSTATE value (a 5-character\n  string literal). You should not use MySQL error code 0 or SQLSTATE\n  values that begin with \'00\', because those indicate success rather\n  than an error condition. For a list of MySQL error codes and SQLSTATE\n  values, see\n  http://dev.mysql.com/doc/refman/5.1/en/error-messages-server.html.\n\no A condition name previously specified with DECLARE ... CONDITION. A\n  condition name can be associated with a MySQL error code or SQLSTATE\n  value. See [HELP DECLARE CONDITION].\n\no SQLWARNING is shorthand for the class of SQLSTATE values that begin\n  with \'01\'.\n\no NOT FOUND is shorthand for the class of SQLSTATE values that begin\n  with \'02\'. This is relevant within the context of cursors and is used\n  to control what happens when a cursor reaches the end of a data set.\n  If no more rows are available, a No Data condition occurs with\n  SQLSTATE value \'02000\'. To detect this condition, you can set up a\n  handler for it (or for a NOT FOUND condition). For an example, see\n  http://dev.mysql.com/doc/refman/5.1/en/cursors.html. This condition\n  also occurs for SELECT ... INTO var_list statements that retrieve no\n  rows.\n\no SQLEXCEPTION is shorthand for the class of SQLSTATE values that do\n  not begin with \'00\', \'01\', or \'02\'.\n\nIf a condition occurs for which no handler has been declared, the\naction taken depends on the condition class:\n\no For SQLEXCEPTION conditions, the stored program terminates at the\n  statement that raised the condition, as if there were an EXIT\n  handler. If the program was called by another stored program, the\n  calling program handles the condition using the handler selection\n  rules applied to its own handlers.\n\no For SQLWARNING or NOT FOUND conditions, the program continues\n  executing, as if there were a CONTINUE handler.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/declare-handler.html\n\n','mysql> CREATE TABLE test.t (s1 INT, PRIMARY KEY (s1));\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> delimiter //\n\nmysql> CREATE PROCEDURE handlerdemo ()\n    -> BEGIN\n    ->   DECLARE CONTINUE HANDLER FOR SQLSTATE \'23000\' SET @x2 = 1;\n    ->   SET @x = 1;\n    ->   INSERT INTO test.t VALUES (1);\n    ->   SET @x = 2;\n    ->   INSERT INTO test.t VALUES (1);\n    ->   SET @x = 3;\n    -> END;\n    -> //\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> CALL handlerdemo()//\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT @x//\n    +------+\n    | @x   |\n    +------+\n    | 3    |\n    +------+\n    1 row in set (0.00 sec)\n','http://dev.mysql.com/doc/refman/5.1/en/declare-handler.html'),(313,'DOUBLE',22,'DOUBLE[(M,D)] [UNSIGNED] [ZEROFILL]\n\nA normal-size (double-precision) floating-point number. Permissible\nvalues are -1.7976931348623157E+308 to -2.2250738585072014E-308, 0, and\n2.2250738585072014E-308 to 1.7976931348623157E+308. These are the\ntheoretical limits, based on the IEEE standard. The actual range might\nbe slightly smaller depending on your hardware or operating system.\n\nM is the total number of digits and D is the number of digits following\nthe decimal point. If M and D are omitted, values are stored to the\nlimits permitted by the hardware. A double-precision floating-point\nnumber is accurate to approximately 15 decimal places.\n\nUNSIGNED, if specified, disallows negative values.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html'),(314,'TIME',22,'TIME\n\nA time. The range is \'-838:59:59\' to \'838:59:59\'. MySQL displays TIME\nvalues in \'HH:MM:SS\' format, but permits assignment of values to TIME\ncolumns using either strings or numbers.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-type-overview.html'),(315,'&&',14,'Syntax:\nAND, &&\n\nLogical AND. Evaluates to 1 if all operands are nonzero and not NULL,\nto 0 if one or more operands are 0, otherwise NULL is returned.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/logical-operators.html\n\n','mysql> SELECT 1 && 1;\n        -> 1\nmysql> SELECT 1 && 0;\n        -> 0\nmysql> SELECT 1 && NULL;\n        -> NULL\nmysql> SELECT 0 && NULL;\n        -> 0\nmysql> SELECT NULL && 0;\n        -> 0\n','http://dev.mysql.com/doc/refman/5.1/en/logical-operators.html'),(316,'X',11,'X(p)\n\nReturns the X-coordinate value for the Point object p as a\ndouble-precision number.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#point-property-functions\n\n','mysql> SELECT X(POINT(56.7, 53.34));\n+-----------------------+\n| X(POINT(56.7, 53.34)) |\n+-----------------------+\n|                  56.7 |\n+-----------------------+\n','http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#point-property-functions'),(317,'SYSTEM_USER',17,'Syntax:\nSYSTEM_USER()\n\nSYSTEM_USER() is a synonym for USER().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/information-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/information-functions.html'),(318,'FOUND_ROWS',17,'Syntax:\nFOUND_ROWS()\n\nA SELECT statement may include a LIMIT clause to restrict the number of\nrows the server returns to the client. In some cases, it is desirable\nto know how many rows the statement would have returned without the\nLIMIT, but without running the statement again. To obtain this row\ncount, include a SQL_CALC_FOUND_ROWS option in the SELECT statement,\nand then invoke FOUND_ROWS() afterward:\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/information-functions.html\n\n','mysql> SELECT SQL_CALC_FOUND_ROWS * FROM tbl_name\n    -> WHERE id > 100 LIMIT 10;\nmysql> SELECT FOUND_ROWS();\n','http://dev.mysql.com/doc/refman/5.1/en/information-functions.html'),(319,'CROSSES',30,'Crosses(g1,g2)\n\nReturns 1 if g1 spatially crosses g2. Returns NULL if g1 is a Polygon\nor a MultiPolygon, or if g2 is a Point or a MultiPoint. Otherwise,\nreturns 0.\n\nThe term spatially crosses denotes a spatial relation between two given\ngeometries that has the following properties:\n\no The two geometries intersect\n\no Their intersection results in a geometry that has a dimension that is\n  one less than the maximum dimension of the two given geometries\n\no Their intersection is not equal to either of the two given geometries\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-test-spatial-relationships-between-geometries\n\n','','http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-tes'),(320,'TRUNCATE TABLE',38,'Syntax:\nTRUNCATE [TABLE] tbl_name\n\nTRUNCATE TABLE empties a table completely. It requires the DROP\nprivilege as of MySQL 5.1.16. (Before 5.1.16, it requires the DELETE\nprivilege).\n\nLogically, TRUNCATE TABLE is equivalent to a DELETE statement that\ndeletes all rows, but there are practical differences under some\ncircumstances.\n\nFor an InnoDB table:\n\no If there are no FOREIGN KEY constraints, InnoDB performs fast\n  truncation by dropping the original table and creating an empty one\n  with the same definition, which is much faster than deleting rows one\n  by one.\n\no When you use this fast truncation technique with the\n  innodb_file_per_table option enabled, the operating system can reuse\n  the freed disk space. For users of the InnoDB Plugin, the space is\n  reclaimed automatically, as described in TRUNCATE TABLE Reclaims\n  Space\n  (http://dev.mysql.com/doc/refman/5.6/en/innodb-other-changes-truncate\n  .html). If you do not have the InnoDB Plugin installed, issue the\n  OPTIMIZE TABLE statement to free the disk space for the table.\n\no If there are any FOREIGN KEY constraints that reference the table,\n  InnoDB processes TRUNCATE TABLE by deleting rows one by one,\n  processing the constraints as it proceeds. If the FOREIGN KEY\n  constraint specifies DELETE CASCADE, rows from the child (referenced)\n  table are deleted, and the truncated table becomes empty. If the\n  FOREIGN KEY constraint does not specify CASCADE, the TRUNCATE TABLE\n  statement deletes rows one by one and stops if it encounters a parent\n  row that is referenced by the child, returning this error:\n\nERROR 1451 (23000): Cannot delete or update a parent row: a foreign\nkey constraint fails (`test`.`child`, CONSTRAINT `child_ibfk_1`\nFOREIGN KEY (`parent_id`) REFERENCES `parent` (`id`))\n\n  *Note*: In MySQL 5.5 and higher, TRUNCATE TABLE is not allowed for\n  InnoDB tables referenced by foreign keys. For ease of upgrading,\n  rewrite such statements to use DELETE instead.\n\no The AUTO_INCREMENT counter is reset to zero by TRUNCATE TABLE,\n  regardless of whether there is a FOREIGN KEY constraint.\n\nThis is the same as a DELETE statement with no WHERE clause.\n\nThe count of rows affected by TRUNCATE TABLE is accurate only when it\nis mapped to a DELETE statement.\n\nFor other storage engines, TRUNCATE TABLE differs from DELETE in the\nfollowing ways in MySQL 5.1:\n\no Truncate operations drop and re-create the table, which is much\n  faster than deleting rows one by one, particularly for large tables.\n\no Truncate operations cause an implicit commit.\n\no Truncation operations cannot be performed if the session holds an\n  active table lock.\n\no Truncation operations do not return a meaningful value for the number\n  of deleted rows. The usual result is \"0 rows affected,\" which should\n  be interpreted as \"no information.\"\n\no As long as the table format file tbl_name.frm is valid, the table can\n  be re-created as an empty table with TRUNCATE TABLE, even if the data\n  or index files have become corrupted.\n\no The table handler does not remember the last used AUTO_INCREMENT\n  value, but starts counting from the beginning. This is true even for\n  MyISAM and InnoDB, which normally do not reuse sequence values.\n\no When used with partitioned tables, TRUNCATE TABLE preserves the\n  partitioning; that is, the data and index files are dropped and\n  re-created, while the partition definitions (.par) file is\n  unaffected.\n\no Since truncation of a table does not make any use of DELETE, the\n  TRUNCATE TABLE statement does not invoke ON DELETE triggers.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/truncate-table.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/truncate-table.html'),(321,'BIT_XOR',16,'Syntax:\nBIT_XOR(expr)\n\nReturns the bitwise XOR of all bits in expr. The calculation is\nperformed with 64-bit (BIGINT) precision.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html'),(322,'CURRENT_DATE',31,'Syntax:\nCURRENT_DATE, CURRENT_DATE()\n\nCURRENT_DATE and CURRENT_DATE() are synonyms for CURDATE().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(323,'START SLAVE',8,'Syntax:\nSTART SLAVE [thread_type [, thread_type] ... ]\nSTART SLAVE [SQL_THREAD] UNTIL\n    MASTER_LOG_FILE = \'log_name\', MASTER_LOG_POS = log_pos\nSTART SLAVE [SQL_THREAD] UNTIL\n    RELAY_LOG_FILE = \'log_name\', RELAY_LOG_POS = log_pos\n\nthread_type: IO_THREAD | SQL_THREAD\n\nSTART SLAVE with no thread_type options starts both of the slave\nthreads. The I/O thread reads events from the master server and stores\nthem in the relay log. The SQL thread reads events from the relay log\nand executes them. START SLAVE requires the SUPER privilege.\n\nIf START SLAVE succeeds in starting the slave threads, it returns\nwithout any error. However, even in that case, it might be that the\nslave threads start and then later stop (for example, because they do\nnot manage to connect to the master or read its binary log, or some\nother problem). START SLAVE does not warn you about this. You must\ncheck the slave\'s error log for error messages generated by the slave\nthreads, or check that they are running satisfactorily with SHOW SLAVE\nSTATUS.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/start-slave.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/start-slave.html'),(324,'AREA',2,'Area(poly)\n\nReturns as a double-precision number the area of the Polygon value\npoly, as measured in its spatial reference system.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#polygon-property-functions\n\n','mysql> SET @poly = \'Polygon((0 0,0 3,3 0,0 0),(1 1,1 2,2 1,1 1))\';\nmysql> SELECT Area(GeomFromText(@poly));\n+---------------------------+\n| Area(GeomFromText(@poly)) |\n+---------------------------+\n|                         4 |\n+---------------------------+\n','http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#polygon-property-functions'),(325,'FLUSH',26,'Syntax:\nFLUSH [NO_WRITE_TO_BINLOG | LOCAL]\n    flush_option [, flush_option] ...\n\nThe FLUSH statement clears or reloads various internal caches used by\nMySQL. One variant acquires a lock. To execute FLUSH, you must have the\nRELOAD privilege.\n\nBy default, FLUSH statements are written to the binary log so that they\nwill be replicated to replication slaves. Logging can be suppressed\nwith the optional NO_WRITE_TO_BINLOG keyword or its alias LOCAL.\n\n*Note*: FLUSH LOGS, FLUSH MASTER, FLUSH SLAVE, and FLUSH TABLES WITH\nREAD LOCK are not written to the binary log in any case because they\nwould cause problems if replicated to a slave.\n\nThe RESET statement is similar to FLUSH. See [HELP RESET], for\ninformation about using the RESET statement with replication.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/flush.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/flush.html'),(326,'BEGIN END',23,'Syntax:\n[begin_label:] BEGIN\n    [statement_list]\nEND [end_label]\n\nBEGIN ... END syntax is used for writing compound statements, which can\nappear within stored programs (stored procedures and functions,\ntriggers, and events). A compound statement can contain multiple\nstatements, enclosed by the BEGIN and END keywords. statement_list\nrepresents a list of one or more statements, each terminated by a\nsemicolon (;) statement delimiter. The statement_list itself is\noptional, so the empty compound statement (BEGIN END) is legal.\n\nBEGIN ... END blocks can be nested.\n\nUse of multiple statements requires that a client is able to send\nstatement strings containing the ; statement delimiter. In the mysql\ncommand-line client, this is handled with the delimiter command.\nChanging the ; end-of-statement delimiter (for example, to //) permit ;\nto be used in a program body. For an example, see\nhttp://dev.mysql.com/doc/refman/5.1/en/stored-programs-defining.html.\n\nA BEGIN ... END block can be labeled. See [HELP labels].\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/begin-end.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/begin-end.html'),(327,'SHOW PROCEDURE STATUS',26,'Syntax:\nSHOW PROCEDURE STATUS\n    [LIKE \'pattern\' | WHERE expr]\n\nThis statement is a MySQL extension. It returns characteristics of a\nstored procedure, such as the database, name, type, creator, creation\nand modification dates, and character set information. A similar\nstatement, SHOW FUNCTION STATUS, displays information about stored\nfunctions (see [HELP SHOW FUNCTION STATUS]).\n\nThe LIKE clause, if present, indicates which procedure or function\nnames to match. The WHERE clause can be given to select rows using more\ngeneral conditions, as discussed in\nhttp://dev.mysql.com/doc/refman/5.1/en/extended-show.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-procedure-status.html\n\n','mysql> SHOW PROCEDURE STATUS LIKE \'sp1\'\\G\n*************************** 1. row ***************************\n                  Db: test\n                Name: sp1\n                Type: PROCEDURE\n             Definer: testuser@localhost\n            Modified: 2004-08-03 15:29:37\n             Created: 2004-08-03 15:29:37\n       Security_type: DEFINER\n             Comment:\ncharacter_set_client: latin1\ncollation_connection: latin1_swedish_ci\n  Database Collation: latin1_swedish_ci\n','http://dev.mysql.com/doc/refman/5.1/en/show-procedure-status.html'),(328,'DESCRIBE',28,'Syntax:\n{DESCRIBE | DESC} tbl_name [col_name | wild]\n\nDESCRIBE provides information about the columns in a table. It is a\nshortcut for SHOW COLUMNS FROM. These statements also display\ninformation for views. (See [HELP SHOW COLUMNS].)\n\ncol_name can be a column name, or a string containing the SQL \"%\" and\n\"_\" wildcard characters to obtain output only for the columns with\nnames matching the string. There is no need to enclose the string\nwithin quotation marks unless it contains spaces or other special\ncharacters.\n\nmysql> DESCRIBE City;\n+------------+----------+------+-----+---------+----------------+\n| Field      | Type     | Null | Key | Default | Extra          |\n+------------+----------+------+-----+---------+----------------+\n| Id         | int(11)  | NO   | PRI | NULL    | auto_increment |\n| Name       | char(35) | NO   |     |         |                |\n| Country    | char(3)  | NO   | UNI |         |                |\n| District   | char(20) | YES  | MUL |         |                |\n| Population | int(11)  | NO   |     | 0       |                |\n+------------+----------+------+-----+---------+----------------+\n5 rows in set (0.00 sec)\n\nThe description for SHOW COLUMNS provides more information about the\noutput columns (see [HELP SHOW COLUMNS]).\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/describe.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/describe.html'),(329,'SHOW WARNINGS',26,'Syntax:\nSHOW WARNINGS [LIMIT [offset,] row_count]\nSHOW COUNT(*) WARNINGS\n\nSHOW WARNINGS shows information about the conditions (errors, warnings,\nand notes) that resulted from the last statement in the current session\nthat generated messages. It shows nothing if the last statement used a\ntable and generated no messages. (That is, a statement that uses a\ntable but generates no messages clears the message list.) Statements\nthat do not use tables and do not generate messages have no effect on\nthe message list.\n\nWarnings are generated for DML statements such as INSERT, UPDATE, and\nLOAD DATA INFILE as well as DDL statements such as CREATE TABLE and\nALTER TABLE.\n\nThe LIMIT clause has the same syntax as for the SELECT statement. See\nhttp://dev.mysql.com/doc/refman/5.1/en/select.html.\n\nA related statement, SHOW ERRORS, shows only the error conditions (it\nexcludes warnings and notes). See [HELP SHOW ERRORS].\n\nThe SHOW COUNT(*) WARNINGS statement displays the total number of\nerrors, warnings, and notes. You can also retrieve this number from the\nwarning_count system variable:\n\nSHOW COUNT(*) WARNINGS;\nSELECT @@warning_count;\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-warnings.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-warnings.html'),(330,'DROP USER',10,'Syntax:\nDROP USER user [, user] ...\n\nThe DROP USER statement removes one or more MySQL accounts and their\nprivileges. It removes privilege rows for the account from all grant\ntables. To use this statement, you must have the global CREATE USER\nprivilege or the DELETE privilege for the mysql database. Each account\nname uses the format described in\nhttp://dev.mysql.com/doc/refman/5.1/en/account-names.html. For example:\n\nDROP USER \'jeffrey\'@\'localhost\';\n\nIf you specify only the user name part of the account name, a host name\npart of \'%\' is used.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/drop-user.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/drop-user.html'),(331,'STDDEV_POP',16,'Syntax:\nSTDDEV_POP(expr)\n\nReturns the population standard deviation of expr (the square root of\nVAR_POP()). You can also use STD() or STDDEV(), which are equivalent\nbut not standard SQL.\n\nSTDDEV_POP() returns NULL if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html'),(332,'SHOW CHARACTER SET',26,'Syntax:\nSHOW CHARACTER SET\n    [LIKE \'pattern\' | WHERE expr]\n\nThe SHOW CHARACTER SET statement shows all available character sets.\nThe LIKE clause, if present, indicates which character set names to\nmatch. The WHERE clause can be given to select rows using more general\nconditions, as discussed in\nhttp://dev.mysql.com/doc/refman/5.1/en/extended-show.html. For example:\n\nmysql> SHOW CHARACTER SET LIKE \'latin%\';\n+---------+-----------------------------+-------------------+--------+\n| Charset | Description                 | Default collation | Maxlen |\n+---------+-----------------------------+-------------------+--------+\n| latin1  | cp1252 West European        | latin1_swedish_ci |      1 |\n| latin2  | ISO 8859-2 Central European | latin2_general_ci |      1 |\n| latin5  | ISO 8859-9 Turkish          | latin5_turkish_ci |      1 |\n| latin7  | ISO 8859-13 Baltic          | latin7_general_ci |      1 |\n+---------+-----------------------------+-------------------+--------+\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-character-set.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-character-set.html'),(333,'SUBSTRING',36,'Syntax:\nSUBSTRING(str,pos), SUBSTRING(str FROM pos), SUBSTRING(str,pos,len),\nSUBSTRING(str FROM pos FOR len)\n\nThe forms without a len argument return a substring from string str\nstarting at position pos. The forms with a len argument return a\nsubstring len characters long from string str, starting at position\npos. The forms that use FROM are standard SQL syntax. It is also\npossible to use a negative value for pos. In this case, the beginning\nof the substring is pos characters from the end of the string, rather\nthan the beginning. A negative value may be used for pos in any of the\nforms of this function.\n\nFor all forms of SUBSTRING(), the position of the first character in\nthe string from which the substring is to be extracted is reckoned as\n1.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT SUBSTRING(\'Quadratically\',5);\n        -> \'ratically\'\nmysql> SELECT SUBSTRING(\'foobarbar\' FROM 4);\n        -> \'barbar\'\nmysql> SELECT SUBSTRING(\'Quadratically\',5,6);\n        -> \'ratica\'\nmysql> SELECT SUBSTRING(\'Sakila\', -3);\n        -> \'ila\'\nmysql> SELECT SUBSTRING(\'Sakila\', -5, 3);\n        -> \'aki\'\nmysql> SELECT SUBSTRING(\'Sakila\' FROM -4 FOR 2);\n        -> \'ki\'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(334,'ISEMPTY',35,'IsEmpty(g)\n\nReturns 1 if the geometry value g is the empty geometry, 0 if it is not\nempty, and -1 if the argument is NULL. If the geometry is empty, it\nrepresents the empty point set.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#general-geometry-property-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#general-geometry-property-functions'),(335,'SHOW FUNCTION STATUS',26,'Syntax:\nSHOW FUNCTION STATUS\n    [LIKE \'pattern\' | WHERE expr]\n\nThis statement is similar to SHOW PROCEDURE STATUS but for stored\nfunctions. See [HELP SHOW PROCEDURE STATUS].\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-function-status.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-function-status.html'),(336,'LTRIM',36,'Syntax:\nLTRIM(str)\n\nReturns the string str with leading space characters removed.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT LTRIM(\'  barbar\');\n        -> \'barbar\'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(337,'INTERSECTS',30,'Intersects(g1,g2)\n\nReturns 1 or 0 to indicate whether g1 spatially intersects g2.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-test-spatial-relationships-between-geometries\n\n','','http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-tes'),(338,'CALL',27,'Syntax:\nCALL sp_name([parameter[,...]])\nCALL sp_name[()]\n\nThe CALL statement invokes a stored procedure that was defined\npreviously with CREATE PROCEDURE.\n\nAs of MySQL 5.1.13, stored procedures that take no arguments can be\ninvoked without parentheses. That is, CALL p() and CALL p are\nequivalent.\n\nCALL can pass back values to its caller using parameters that are\ndeclared as OUT or INOUT parameters. When the procedure returns, a\nclient program can also obtain the number of rows affected for the\nfinal statement executed within the routine: At the SQL level, call the\nROW_COUNT() function; from the C API, call the mysql_affected_rows()\nfunction.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/call.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/call.html'),(339,'MBRDISJOINT',6,'MBRDisjoint(g1,g2)\n\nReturns 1 or 0 to indicate whether the Minimum Bounding Rectangles of\nthe two geometries g1 and g2 are disjoint (do not intersect).\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geometry-mbr\n\n','','http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geome'),(340,'VALUES',15,'Syntax:\nVALUES(col_name)\n\nIn an INSERT ... ON DUPLICATE KEY UPDATE statement, you can use the\nVALUES(col_name) function in the UPDATE clause to refer to column\nvalues from the INSERT portion of the statement. In other words,\nVALUES(col_name) in the UPDATE clause refers to the value of col_name\nthat would be inserted, had no duplicate-key conflict occurred. This\nfunction is especially useful in multiple-row inserts. The VALUES()\nfunction is meaningful only in the ON DUPLICATE KEY UPDATE clause of\nINSERT statements and returns NULL otherwise. See\nhttp://dev.mysql.com/doc/refman/5.1/en/insert-on-duplicate.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html\n\n','mysql> INSERT INTO table (a,b,c) VALUES (1,2,3),(4,5,6)\n    -> ON DUPLICATE KEY UPDATE c=VALUES(a)+VALUES(b);\n','http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html'),(341,'SUBSTRING_INDEX',36,'Syntax:\nSUBSTRING_INDEX(str,delim,count)\n\nReturns the substring from string str before count occurrences of the\ndelimiter delim. If count is positive, everything to the left of the\nfinal delimiter (counting from the left) is returned. If count is\nnegative, everything to the right of the final delimiter (counting from\nthe right) is returned. SUBSTRING_INDEX() performs a case-sensitive\nmatch when searching for delim.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT SUBSTRING_INDEX(\'www.mysql.com\', \'.\', 2);\n        -> \'www.mysql\'\nmysql> SELECT SUBSTRING_INDEX(\'www.mysql.com\', \'.\', -2);\n        -> \'mysql.com\'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(342,'ENCODE',12,'Syntax:\nENCODE(str,pass_str)\n\nEncrypt str using pass_str as the password. To decrypt the result, use\nDECODE().\n\nThe result is a binary string of the same length as str.\n\nThe strength of the encryption is based on how good the random\ngenerator is. It should suffice for short strings.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html'),(343,'LOOP',23,'Syntax:\n[begin_label:] LOOP\n    statement_list\nEND LOOP [end_label]\n\nLOOP implements a simple loop construct, enabling repeated execution of\nthe statement list, which consists of one or more statements, each\nterminated by a semicolon (;) statement delimiter. The statements\nwithin the loop are repeated until the loop is terminated. Usually,\nthis is accomplished with a LEAVE statement. Within a stored function,\nRETURN can also be used, which exits the function entirely.\n\nNeglecting to include a loop-termination statement results in an\ninfinite loop.\n\nA LOOP statement can be labeled. For the rules regarding label use, see\n[HELP labels].\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/loop-statement.html\n\n','CREATE PROCEDURE doiterate(p1 INT)\nBEGIN\n  label1: LOOP\n    SET p1 = p1 + 1;\n    IF p1 < 10 THEN\n      ITERATE label1;\n    END IF;\n    LEAVE label1;\n  END LOOP label1;\n  SET @x = p1;\nEND;\n','http://dev.mysql.com/doc/refman/5.1/en/loop-statement.html'),(344,'TRUNCATE',4,'Syntax:\nTRUNCATE(X,D)\n\nReturns the number X, truncated to D decimal places. If D is 0, the\nresult has no decimal point or fractional part. D can be negative to\ncause D digits left of the decimal point of the value X to become zero.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT TRUNCATE(1.223,1);\n        -> 1.2\nmysql> SELECT TRUNCATE(1.999,1);\n        -> 1.9\nmysql> SELECT TRUNCATE(1.999,0);\n        -> 1\nmysql> SELECT TRUNCATE(-1.999,1);\n        -> -1.9\nmysql> SELECT TRUNCATE(122,-2);\n       -> 100\nmysql> SELECT TRUNCATE(10.28*100,0);\n       -> 1028\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(345,'TIMESTAMPADD',31,'Syntax:\nTIMESTAMPADD(unit,interval,datetime_expr)\n\nAdds the integer expression interval to the date or datetime expression\ndatetime_expr. The unit for interval is given by the unit argument,\nwhich should be one of the following values: FRAC_SECOND\n(microseconds), SECOND, MINUTE, HOUR, DAY, WEEK, MONTH, QUARTER, or\nYEAR.\n\nBeginning with MySQL 5.1.24, it is possible to use MICROSECOND in place\nof FRAC_SECOND with this function, and FRAC_SECOND is deprecated.\nFRAC_SECOND is removed in MySQL 5.5.\n\nThe unit value may be specified using one of keywords as shown, or with\na prefix of SQL_TSI_. For example, DAY and SQL_TSI_DAY both are legal.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT TIMESTAMPADD(MINUTE,1,\'2003-01-02\');\n        -> \'2003-01-02 00:01:00\'\nmysql> SELECT TIMESTAMPADD(WEEK,1,\'2003-01-02\');\n        -> \'2003-01-09\'\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(346,'SHOW',26,'SHOW has many forms that provide information about databases, tables,\ncolumns, or status information about the server. This section describes\nthose following:\n\nSHOW AUTHORS\nSHOW {BINARY | MASTER} LOGS\nSHOW BINLOG EVENTS [IN \'log_name\'] [FROM pos] [LIMIT [offset,] row_count]\nSHOW CHARACTER SET [like_or_where]\nSHOW COLLATION [like_or_where]\nSHOW [FULL] COLUMNS FROM tbl_name [FROM db_name] [like_or_where]\nSHOW CONTRIBUTORS\nSHOW CREATE DATABASE db_name\nSHOW CREATE EVENT event_name\nSHOW CREATE FUNCTION func_name\nSHOW CREATE PROCEDURE proc_name\nSHOW CREATE TABLE tbl_name\nSHOW CREATE TRIGGER trigger_name\nSHOW CREATE VIEW view_name\nSHOW DATABASES [like_or_where]\nSHOW ENGINE engine_name {STATUS | MUTEX}\nSHOW [STORAGE] ENGINES\nSHOW ERRORS [LIMIT [offset,] row_count]\nSHOW EVENTS\nSHOW FUNCTION CODE func_name\nSHOW FUNCTION STATUS [like_or_where]\nSHOW GRANTS FOR user\nSHOW INDEX FROM tbl_name [FROM db_name]\nSHOW INNODB STATUS\nSHOW MASTER STATUS\nSHOW OPEN TABLES [FROM db_name] [like_or_where]\nSHOW PLUGINS\nSHOW PROCEDURE CODE proc_name\nSHOW PROCEDURE STATUS [like_or_where]\nSHOW PRIVILEGES\nSHOW [FULL] PROCESSLIST\nSHOW PROFILE [types] [FOR QUERY n] [OFFSET n] [LIMIT n]\nSHOW PROFILES\nSHOW SCHEDULER STATUS\nSHOW SLAVE HOSTS\nSHOW SLAVE STATUS\nSHOW [GLOBAL | SESSION] STATUS [like_or_where]\nSHOW TABLE STATUS [FROM db_name] [like_or_where]\nSHOW [FULL] TABLES [FROM db_name] [like_or_where]\nSHOW TRIGGERS [FROM db_name] [like_or_where]\nSHOW [GLOBAL | SESSION] VARIABLES [like_or_where]\nSHOW WARNINGS [LIMIT [offset,] row_count]\n\nlike_or_where:\n    LIKE \'pattern\'\n  | WHERE expr\n\nIf the syntax for a given SHOW statement includes a LIKE \'pattern\'\npart, \'pattern\' is a string that can contain the SQL \"%\" and \"_\"\nwildcard characters. The pattern is useful for restricting statement\noutput to matching values.\n\nSeveral SHOW statements also accept a WHERE clause that provides more\nflexibility in specifying which rows to display. See\nhttp://dev.mysql.com/doc/refman/5.1/en/extended-show.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show.html'),(347,'GREATEST',18,'Syntax:\nGREATEST(value1,value2,...)\n\nWith two or more arguments, returns the largest (maximum-valued)\nargument. The arguments are compared using the same rules as for\nLEAST().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html\n\n','mysql> SELECT GREATEST(2,0);\n        -> 2\nmysql> SELECT GREATEST(34.0,3.0,5.0,767.0);\n        -> 767.0\nmysql> SELECT GREATEST(\'B\',\'A\',\'C\');\n        -> \'C\'\n','http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html'),(348,'SHOW VARIABLES',26,'Syntax:\nSHOW [GLOBAL | SESSION] VARIABLES\n    [LIKE \'pattern\' | WHERE expr]\n\nSHOW VARIABLES shows the values of MySQL system variables. This\ninformation also can be obtained using the mysqladmin variables\ncommand. The LIKE clause, if present, indicates which variable names to\nmatch. The WHERE clause can be given to select rows using more general\nconditions, as discussed in\nhttp://dev.mysql.com/doc/refman/5.1/en/extended-show.html. This\nstatement does not require any privilege. It requires only the ability\nto connect to the server.\n\nWith the GLOBAL modifier, SHOW VARIABLES displays the values that are\nused for new connections to MySQL. If a variable has no global value,\nthe session value is displayed. With SESSION, SHOW VARIABLES displays\nthe values that are in effect for the current connection. If no\nmodifier is present, the default is SESSION. LOCAL is a synonym for\nSESSION.\nWith a LIKE clause, the statement displays only rows for those\nvariables with names that match the pattern. To obtain the row for a\nspecific variable, use a LIKE clause as shown:\n\nSHOW VARIABLES LIKE \'max_join_size\';\nSHOW SESSION VARIABLES LIKE \'max_join_size\';\n\nTo get a list of variables whose name match a pattern, use the \"%\"\nwildcard character in a LIKE clause:\n\nSHOW VARIABLES LIKE \'%size%\';\nSHOW GLOBAL VARIABLES LIKE \'%size%\';\n\nWildcard characters can be used in any position within the pattern to\nbe matched. Strictly speaking, because \"_\" is a wildcard that matches\nany single character, you should escape it as \"\\_\" to match it\nliterally. In practice, this is rarely necessary.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-variables.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-variables.html'),(349,'BINLOG',26,'Syntax:\nBINLOG \'str\'\n\nBINLOG is an internal-use statement. It is generated by the mysqlbinlog\nprogram as the printable representation of certain events in binary log\nfiles. (See http://dev.mysql.com/doc/refman/5.1/en/mysqlbinlog.html.)\nThe \'str\' value is a base 64-encoded string the that server decodes to\ndetermine the data change indicated by the corresponding event. This\nstatement requires the SUPER privilege. It was added in MySQL 5.1.5.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/binlog.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/binlog.html'),(350,'BIT_AND',16,'Syntax:\nBIT_AND(expr)\n\nReturns the bitwise AND of all bits in expr. The calculation is\nperformed with 64-bit (BIGINT) precision.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html'),(351,'SECOND',31,'Syntax:\nSECOND(time)\n\nReturns the second for time, in the range 0 to 59.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT SECOND(\'10:05:03\');\n        -> 3\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(352,'ATAN2',4,'Syntax:\nATAN(Y,X), ATAN2(Y,X)\n\nReturns the arc tangent of the two variables X and Y. It is similar to\ncalculating the arc tangent of Y / X, except that the signs of both\narguments are used to determine the quadrant of the result.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT ATAN(-2,2);\n        -> -0.78539816339745\nmysql> SELECT ATAN2(PI(),0);\n        -> 1.5707963267949\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(353,'MBRCONTAINS',6,'MBRContains(g1,g2)\n\nReturns 1 or 0 to indicate whether the Minimum Bounding Rectangle of g1\ncontains the Minimum Bounding Rectangle of g2. This tests the opposite\nrelationship as MBRWithin().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geometry-mbr\n\n','mysql> SET @g1 = GeomFromText(\'Polygon((0 0,0 3,3 3,3 0,0 0))\');\nmysql> SET @g2 = GeomFromText(\'Point(1 1)\');\nmysql> SELECT MBRContains(@g1,@g2), MBRContains(@g2,@g1);\n----------------------+----------------------+\n| MBRContains(@g1,@g2) | MBRContains(@g2,@g1) |\n+----------------------+----------------------+\n|                    1 |                    0 |\n+----------------------+----------------------+\n','http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geome'),(354,'HOUR',31,'Syntax:\nHOUR(time)\n\nReturns the hour for time. The range of the return value is 0 to 23 for\ntime-of-day values. However, the range of TIME values actually is much\nlarger, so HOUR can return values greater than 23.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT HOUR(\'10:05:03\');\n        -> 10\nmysql> SELECT HOUR(\'272:59:59\');\n        -> 272\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(355,'SELECT',27,'Syntax:\nSELECT\n    [ALL | DISTINCT | DISTINCTROW ]\n      [HIGH_PRIORITY]\n      [STRAIGHT_JOIN]\n      [SQL_SMALL_RESULT] [SQL_BIG_RESULT] [SQL_BUFFER_RESULT]\n      [SQL_CACHE | SQL_NO_CACHE] [SQL_CALC_FOUND_ROWS]\n    select_expr [, select_expr ...]\n    [FROM table_references\n    [WHERE where_condition]\n    [GROUP BY {col_name | expr | position}\n      [ASC | DESC], ... [WITH ROLLUP]]\n    [HAVING where_condition]\n    [ORDER BY {col_name | expr | position}\n      [ASC | DESC], ...]\n    [LIMIT {[offset,] row_count | row_count OFFSET offset}]\n    [PROCEDURE procedure_name(argument_list)]\n    [INTO OUTFILE \'file_name\'\n        [CHARACTER SET charset_name]\n        export_options\n      | INTO DUMPFILE \'file_name\'\n      | INTO var_name [, var_name]]\n    [FOR UPDATE | LOCK IN SHARE MODE]]\n\nSELECT is used to retrieve rows selected from one or more tables, and\ncan include UNION statements and subqueries. See [HELP UNION], and\nhttp://dev.mysql.com/doc/refman/5.1/en/subqueries.html.\n\nThe most commonly used clauses of SELECT statements are these:\n\no Each select_expr indicates a column that you want to retrieve. There\n  must be at least one select_expr.\n\no table_references indicates the table or tables from which to retrieve\n  rows. Its syntax is described in [HELP JOIN].\n\no The WHERE clause, if given, indicates the condition or conditions\n  that rows must satisfy to be selected. where_condition is an\n  expression that evaluates to true for each row to be selected. The\n  statement selects all rows if there is no WHERE clause.\n\n  In the WHERE expression, you can use any of the functions and\n  operators that MySQL supports, except for aggregate (summary)\n  functions. See\n  http://dev.mysql.com/doc/refman/5.1/en/expressions.html, and\n  http://dev.mysql.com/doc/refman/5.1/en/functions.html.\n\nSELECT can also be used to retrieve rows computed without reference to\nany table.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/select.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/select.html'),(356,'COT',4,'Syntax:\nCOT(X)\n\nReturns the cotangent of X.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT COT(12);\n        -> -1.5726734063977\nmysql> SELECT COT(0);\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(357,'SHOW CREATE EVENT',26,'Syntax:\nSHOW CREATE EVENT event_name\n\nThis statement displays the CREATE EVENT statement needed to re-create\na given event. It requires the EVENT privilege for the database from\nwhich the event is to be shown. For example (using the same event\ne_daily defined and then altered in [HELP SHOW EVENTS]):\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-create-event.html\n\n','mysql> SHOW CREATE EVENT test.e_daily\\G\n*************************** 1. row ***************************\n               Event: e_daily\n            sql_mode:\n           time_zone: SYSTEM\n        Create Event: CREATE EVENT `e_daily`\n                        ON SCHEDULE EVERY 1 DAY\n                        STARTS CURRENT_TIMESTAMP + INTERVAL 6 HOUR\n                        ON COMPLETION NOT PRESERVE\n                        ENABLE\n                        COMMENT \'Saves total number of sessions then\n                                clears the table each day\'\n                        DO BEGIN\n                          INSERT INTO site_activity.totals (time, total)\n                            SELECT CURRENT_TIMESTAMP, COUNT(*)\n                            FROM site_activity.sessions;\n                          DELETE FROM site_activity.sessions;\n                        END\ncharacter_set_client: latin1\ncollation_connection: latin1_swedish_ci\n  Database Collation: latin1_swedish_ci\n','http://dev.mysql.com/doc/refman/5.1/en/show-create-event.html'),(358,'BACKUP TABLE',20,'Syntax:\nBACKUP TABLE tbl_name [, tbl_name] ... TO \'/path/to/backup/directory\'\n\n*Note*: This statement is deprecated and is removed in MySQL 5.5. As an\nalternative, mysqldump or mysqlhotcopy can be used instead.\n\nBACKUP TABLE copies to the backup directory the minimum number of table\nfiles needed to restore the table, after flushing any buffered changes\nto disk. The statement works only for MyISAM tables. It copies the .frm\ndefinition and .MYD data files. The .MYI index file can be rebuilt from\nthose two files. The directory should be specified as a full path name.\nTo restore the table, use RESTORE TABLE.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/backup-table.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/backup-table.html'),(359,'LOAD_FILE',36,'Syntax:\nLOAD_FILE(file_name)\n\nReads the file and returns the file contents as a string. To use this\nfunction, the file must be located on the server host, you must specify\nthe full path name to the file, and you must have the FILE privilege.\nThe file must be readable by all and its size less than\nmax_allowed_packet bytes. If the secure_file_priv system variable is\nset to a nonempty directory name, the file to be loaded must be located\nin that directory.\n\nIf the file does not exist or cannot be read because one of the\npreceding conditions is not satisfied, the function returns NULL.\n\nAs of MySQL 5.1.6, the character_set_filesystem system variable\ncontrols interpretation of file names that are given as literal\nstrings.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> UPDATE t\n            SET blob_col=LOAD_FILE(\'/tmp/picture\')\n            WHERE id=1;\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(360,'LOAD TABLE FROM MASTER',8,'Syntax:\nLOAD TABLE tbl_name FROM MASTER\n\nThis feature is deprecated and should be avoided. It is subject to\nremoval in a future version of MySQL.\n\nSince the current implementation of LOAD DATA FROM MASTER and LOAD\nTABLE FROM MASTER is very limited, these statements are deprecated as\nof MySQL 4.1 and removed in MySQL 5.5.\n\nThe recommended alternative solution to using LOAD DATA FROM MASTER or\nLOAD TABLE FROM MASTER is using mysqldump or mysqlhotcopy. The latter\nrequires Perl and two Perl modules (DBI and DBD:mysql) and works for\nMyISAM and ARCHIVE tables only. With mysqldump, you can create SQL\ndumps on the master and pipe (or copy) these to a mysql client on the\nslave. This has the advantage of working for all storage engines, but\ncan be quite slow, since it works using SELECT.\n\nTransfers a copy of the table from the master to the slave. This\nstatement is implemented mainly debugging LOAD DATA FROM MASTER\noperations. To use LOAD TABLE, the account used for connecting to the\nmaster server must have the RELOAD and SUPER privileges on the master\nand the SELECT privilege for the master table to load. On the slave\nside, the user that issues LOAD TABLE FROM MASTER must have privileges\nfor dropping and creating the table.\n\nThe conditions for LOAD DATA FROM MASTER apply here as well. For\nexample, LOAD TABLE FROM MASTER works only for MyISAM tables. The\ntimeout notes for LOAD DATA FROM MASTER apply as well.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/load-table-from-master.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/load-table-from-master.html'),(361,'POINTFROMTEXT',3,'PointFromText(wkt[,srid])\n\nConstructs a POINT value using its WKT representation and SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkt-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkt-functions'),(362,'GROUP_CONCAT',16,'Syntax:\nGROUP_CONCAT(expr)\n\nThis function returns a string result with the concatenated non-NULL\nvalues from a group. It returns NULL if there are no non-NULL values.\nThe full syntax is as follows:\n\nGROUP_CONCAT([DISTINCT] expr [,expr ...]\n             [ORDER BY {unsigned_integer | col_name | expr}\n                 [ASC | DESC] [,col_name ...]]\n             [SEPARATOR str_val])\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html\n\n','mysql> SELECT student_name,\n    ->     GROUP_CONCAT(test_score)\n    ->     FROM student\n    ->     GROUP BY student_name;\n','http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html'),(363,'DATE_FORMAT',31,'Syntax:\nDATE_FORMAT(date,format)\n\nFormats the date value according to the format string.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT DATE_FORMAT(\'2009-10-04 22:23:00\', \'%W %M %Y\');\n        -> \'Sunday October 2009\'\nmysql> SELECT DATE_FORMAT(\'2007-10-04 22:23:00\', \'%H:%i:%s\');\n        -> \'22:23:00\'\nmysql> SELECT DATE_FORMAT(\'1900-10-04 22:23:00\',\n    ->                 \'%D %y %a %d %m %b %j\');\n        -> \'4th 00 Thu 04 10 Oct 277\'\nmysql> SELECT DATE_FORMAT(\'1997-10-04 22:23:00\',\n    ->                 \'%H %k %I %r %T %S %w\');\n        -> \'22 22 10 10:23:00 PM 22:23:00 00 6\'\nmysql> SELECT DATE_FORMAT(\'1999-01-01\', \'%X %V\');\n        -> \'1998 52\'\nmysql> SELECT DATE_FORMAT(\'2006-06-00\', \'%d\');\n        -> \'00\'\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(364,'BENCHMARK',17,'Syntax:\nBENCHMARK(count,expr)\n\nThe BENCHMARK() function executes the expression expr repeatedly count\ntimes. It may be used to time how quickly MySQL processes the\nexpression. The result value is always 0. The intended use is from\nwithin the mysql client, which reports query execution times:\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/information-functions.html\n\n','mysql> SELECT BENCHMARK(1000000,ENCODE(\'hello\',\'goodbye\'));\n+----------------------------------------------+\n| BENCHMARK(1000000,ENCODE(\'hello\',\'goodbye\')) |\n+----------------------------------------------+\n|                                            0 |\n+----------------------------------------------+\n1 row in set (4.74 sec)\n','http://dev.mysql.com/doc/refman/5.1/en/information-functions.html'),(365,'YEAR',31,'Syntax:\nYEAR(date)\n\nReturns the year for date, in the range 1000 to 9999, or 0 for the\n\"zero\" date.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT YEAR(\'1987-01-01\');\n        -> 1987\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(366,'SHOW ENGINE',26,'Syntax:\nSHOW ENGINE engine_name {STATUS | MUTEX}\n\nSHOW ENGINE displays operational information about a storage engine.\nThe following statements currently are supported:\n\nSHOW ENGINE INNODB STATUS\nSHOW ENGINE INNODB MUTEX\nSHOW ENGINE {NDB | NDBCLUSTER} STATUS\n\nOlder (and now deprecated) synonyms are SHOW INNODB STATUS for SHOW\nENGINE INNODB STATUS and SHOW MUTEX STATUS for SHOW ENGINE INNODB\nMUTEX. SHOW INNODB STATUS and SHOW MUTEX STATUS are removed in MySQL\n5.5.\n\nIn MySQL 5.0, SHOW ENGINE INNODB MUTEX is invoked as SHOW MUTEX STATUS.\nThe latter statement displays similar information but in a somewhat\ndifferent output format.\n\nSHOW ENGINE BDB LOGS formerly displayed status information about BDB\nlog files. As of MySQL 5.1.12, the BDB storage engine is not supported,\nand this statement produces a warning.\n\nSHOW ENGINE INNODB STATUS displays extensive information from the\nstandard InnoDB Monitor about the state of the InnoDB storage engine.\nFor information about the standard monitor and other InnoDB Monitors\nthat provide information about InnoDB processing, see\nhttp://dev.mysql.com/doc/refman/5.1/en/innodb-monitors.html.\n\nSHOW ENGINE INNODB MUTEX displays InnoDB mutex statistics. From MySQL\n5.1.2 to 5.1.14, the statement displays the following output fields:\n\no Type\n\n  Always InnoDB.\n\no Name\n\n  The mutex name and the source file where it is implemented. Example:\n  &pool->mutex:mem0pool.c\n\n  The mutex name indicates its purpose. For example, the log_sys mutex\n  is used by the InnoDB logging subsystem and indicates how intensive\n  logging activity is. The buf_pool mutex protects the InnoDB buffer\n  pool.\n\no Status\n\n  The mutex status. The fields contains several values:\n\n  o count indicates how many times the mutex was requested.\n\n  o spin_waits indicates how many times the spinlock had to run.\n\n  o spin_rounds indicates the number of spinlock rounds. (spin_rounds\n    divided by spin_waits provides the average round count.)\n\n  o os_waits indicates the number of operating system waits. This\n    occurs when the spinlock did not work (the mutex was not locked\n    during the spinlock and it was necessary to yield to the operating\n    system and wait).\n\n  o os_yields indicates the number of times a the thread trying to lock\n    a mutex gave up its timeslice and yielded to the operating system\n    (on the presumption that permitting other threads to run will free\n    the mutex so that it can be locked).\n\n  o os_wait_times indicates the amount of time (in ms) spent in\n    operating system waits, if the timed_mutexes system variable is 1\n    (ON). If timed_mutexes is 0 (OFF), timing is disabled, so\n    os_wait_times is 0. timed_mutexes is off by default.\n\nFrom MySQL 5.1.15 on, the statement displays the following output\nfields:\n\no Type\n\n  Always InnoDB.\n\no Name\n\n  The source file where the mutex is implemented, and the line number\n  in the file where the mutex is created. The line number may change\n  depending on your version of MySQL.\n\no Status\n\n  This field displays the same values as previously described (count,\n  spin_waits, spin_rounds, os_waits, os_yields, os_wait_times), but\n  only if UNIV_DEBUG was defined at MySQL compilation time (for\n  example, in include/univ.i in the InnoDB part of the MySQL source\n  tree). If UNIV_DEBUG was not defined, the statement displays only the\n  os_waits value. In the latter case (without UNIV_DEBUG), the\n  information on which the output is based is insufficient to\n  distinguish regular mutexes and mutexes that protect rw-locks (which\n  permit multiple readers or a single writer). Consequently, the output\n  may appear to contain multiple rows for the same mutex.\n\nInformation from this statement can be used to diagnose system\nproblems. For example, large values of spin_waits and spin_rounds may\nindicate scalability problems.\n\nIf the server has the NDBCLUSTER storage engine enabled, SHOW ENGINE\nNDB STATUS displays cluster status information such as the number of\nconnected data nodes, the cluster connectstring, and cluster binlog\nepochs, as well as counts of various Cluster API objects created by the\nMySQL Server when connected to the cluster. Sample output from this\nstatement is shown here:\n\nmysql> SHOW ENGINE NDB STATUS;\n+------------+-----------------------+--------------------------------------------------+\n| Type       | Name                  | Status                                           |\n+------------+-----------------------+--------------------------------------------------+\n| ndbcluster | connection            | cluster_node_id=7,\n  connected_host=192.168.0.103, connected_port=1186, number_of_data_nodes=4,\n  number_of_ready_data_nodes=3, connect_count=0                                         |\n| ndbcluster | NdbTransaction        | created=6, free=0, sizeof=212                    |\n| ndbcluster | NdbOperation          | created=8, free=8, sizeof=660                    |\n| ndbcluster | NdbIndexScanOperation | created=1, free=1, sizeof=744                    |\n| ndbcluster | NdbIndexOperation     | created=0, free=0, sizeof=664                    |\n| ndbcluster | NdbRecAttr            | created=1285, free=1285, sizeof=60               |\n| ndbcluster | NdbApiSignal          | created=16, free=16, sizeof=136                  |\n| ndbcluster | NdbLabel              | created=0, free=0, sizeof=196                    |\n| ndbcluster | NdbBranch             | created=0, free=0, sizeof=24                     |\n| ndbcluster | NdbSubroutine         | created=0, free=0, sizeof=68                     |\n| ndbcluster | NdbCall               | created=0, free=0, sizeof=16                     |\n| ndbcluster | NdbBlob               | created=1, free=1, sizeof=264                    |\n| ndbcluster | NdbReceiver           | created=4, free=0, sizeof=68                     |\n| ndbcluster | binlog                | latest_epoch=155467, latest_trans_epoch=148126,\n  latest_received_binlog_epoch=0, latest_handled_binlog_epoch=0,\n  latest_applied_binlog_epoch=0                                                         |\n+------------+-----------------------+--------------------------------------------------+\n\nThe rows with connection and binlog in the Name column were added to\nthe output of this statement in MySQL 5.1. The Status column in each of\nthese rows provides information about the MySQL server\'s connection to\nthe cluster and about the cluster binary log\'s status, respectively.\nThe Status information is in the form of comma-delimited set of\nname/value pairs.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-engine.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-engine.html'),(367,'NAME_CONST',15,'Syntax:\nNAME_CONST(name,value)\n\nReturns the given value. When used to produce a result set column,\nNAME_CONST() causes the column to have the given name. The arguments\nshould be constants.\n\nmysql> SELECT NAME_CONST(\'myname\', 14);\n+--------+\n| myname |\n+--------+\n|     14 |\n+--------+\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html'),(368,'RELEASE_LOCK',15,'Syntax:\nRELEASE_LOCK(str)\n\nReleases the lock named by the string str that was obtained with\nGET_LOCK(). Returns 1 if the lock was released, 0 if the lock was not\nestablished by this thread (in which case the lock is not released),\nand NULL if the named lock did not exist. The lock does not exist if it\nwas never obtained by a call to GET_LOCK() or if it has previously been\nreleased.\n\nThe DO statement is convenient to use with RELEASE_LOCK(). See [HELP\nDO].\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html'),(369,'IS NULL',18,'Syntax:\nIS NULL\n\nTests whether a value is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html\n\n','mysql> SELECT 1 IS NULL, 0 IS NULL, NULL IS NULL;\n        -> 0, 0, 1\n','http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html'),(370,'CONVERT_TZ',31,'Syntax:\nCONVERT_TZ(dt,from_tz,to_tz)\n\nCONVERT_TZ() converts a datetime value dt from the time zone given by\nfrom_tz to the time zone given by to_tz and returns the resulting\nvalue. Time zones are specified as described in\nhttp://dev.mysql.com/doc/refman/5.1/en/time-zone-support.html. This\nfunction returns NULL if the arguments are invalid.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT CONVERT_TZ(\'2004-01-01 12:00:00\',\'GMT\',\'MET\');\n        -> \'2004-01-01 13:00:00\'\nmysql> SELECT CONVERT_TZ(\'2004-01-01 12:00:00\',\'+00:00\',\'+10:00\');\n        -> \'2004-01-01 22:00:00\'\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(371,'TIME_TO_SEC',31,'Syntax:\nTIME_TO_SEC(time)\n\nReturns the time argument, converted to seconds.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT TIME_TO_SEC(\'22:23:00\');\n        -> 80580\nmysql> SELECT TIME_TO_SEC(\'00:39:38\');\n        -> 2378\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(372,'WEEKDAY',31,'Syntax:\nWEEKDAY(date)\n\nReturns the weekday index for date (0 = Monday, 1 = Tuesday, ... 6 =\nSunday).\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT WEEKDAY(\'2008-02-03 22:23:00\');\n        -> 6\nmysql> SELECT WEEKDAY(\'2007-11-06\');\n        -> 1\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(373,'EXPORT_SET',36,'Syntax:\nEXPORT_SET(bits,on,off[,separator[,number_of_bits]])\n\nReturns a string such that for every bit set in the value bits, you get\nan on string and for every bit not set in the value, you get an off\nstring. Bits in bits are examined from right to left (from low-order to\nhigh-order bits). Strings are added to the result from left to right,\nseparated by the separator string (the default being the comma\ncharacter \",\"). The number of bits examined is given by number_of_bits,\nwhich has a default of 64 if not specified. number_of_bits is silently\nclipped to 64 if larger than 64. It is treated as an unsigned integer,\nso a value of -1 is effectively the same as 64.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT EXPORT_SET(5,\'Y\',\'N\',\',\',4);\n        -> \'Y,N,Y,N\'\nmysql> SELECT EXPORT_SET(6,\'1\',\'0\',\',\',10);\n        -> \'0,1,1,0,0,0,0,0,0,0\'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(374,'ALTER SERVER',38,'Syntax:\nALTER SERVER  server_name\n    OPTIONS (option [, option] ...)\n\nAlters the server information for server_name, adjusting any of the\noptions allowed in the CREATE SERVER statement. See [HELP CREATE\nSERVER]. The corresponding fields in the mysql.servers table are\nupdated accordingly. This statement requires the SUPER privilege.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/alter-server.html\n\n','ALTER SERVER s OPTIONS (USER \'sally\');\n','http://dev.mysql.com/doc/refman/5.1/en/alter-server.html'),(375,'TIME FUNCTION',31,'Syntax:\nTIME(expr)\n\nExtracts the time part of the time or datetime expression expr and\nreturns it as a string.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT TIME(\'2003-12-31 01:02:03\');\n        -> \'01:02:03\'\nmysql> SELECT TIME(\'2003-12-31 01:02:03.000123\');\n        -> \'01:02:03.000123\'\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(376,'DATE_ADD',31,'Syntax:\nDATE_ADD(date,INTERVAL expr unit), DATE_SUB(date,INTERVAL expr unit)\n\nThese functions perform date arithmetic. The date argument specifies\nthe starting date or datetime value. expr is an expression specifying\nthe interval value to be added or subtracted from the starting date.\nexpr is a string; it may start with a \"-\" for negative intervals. unit\nis a keyword indicating the units in which the expression should be\ninterpreted.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT \'2008-12-31 23:59:59\' + INTERVAL 1 SECOND;\n        -> \'2009-01-01 00:00:00\'\nmysql> SELECT INTERVAL 1 DAY + \'2008-12-31\';\n        -> \'2009-01-01\'\nmysql> SELECT \'2005-01-01\' - INTERVAL 1 SECOND;\n        -> \'2004-12-31 23:59:59\'\nmysql> SELECT DATE_ADD(\'2000-12-31 23:59:59\',\n    ->                 INTERVAL 1 SECOND);\n        -> \'2001-01-01 00:00:00\'\nmysql> SELECT DATE_ADD(\'2010-12-31 23:59:59\',\n    ->                 INTERVAL 1 DAY);\n        -> \'2011-01-01 23:59:59\'\nmysql> SELECT DATE_ADD(\'2100-12-31 23:59:59\',\n    ->                 INTERVAL \'1:1\' MINUTE_SECOND);\n        -> \'2101-01-01 00:01:00\'\nmysql> SELECT DATE_SUB(\'2005-01-01 00:00:00\',\n    ->                 INTERVAL \'1 1:1:1\' DAY_SECOND);\n        -> \'2004-12-30 22:58:59\'\nmysql> SELECT DATE_ADD(\'1900-01-01 00:00:00\',\n    ->                 INTERVAL \'-1 10\' DAY_HOUR);\n        -> \'1899-12-30 14:00:00\'\nmysql> SELECT DATE_SUB(\'1998-01-02\', INTERVAL 31 DAY);\n        -> \'1997-12-02\'\nmysql> SELECT DATE_ADD(\'1992-12-31 23:59:59.000002\',\n    ->            INTERVAL \'1.999999\' SECOND_MICROSECOND);\n        -> \'1993-01-01 00:00:01.000001\'\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(377,'CAST',36,'Syntax:\nCAST(expr AS type)\n\nThe CAST() function takes a value of one type and produce a value of\nanother type, similar to CONVERT(). See the description of CONVERT()\nfor more information.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/cast-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/cast-functions.html'),(378,'SOUNDS LIKE',36,'Syntax:\nexpr1 SOUNDS LIKE expr2\n\nThis is the same as SOUNDEX(expr1) = SOUNDEX(expr2).\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(379,'PERIOD_DIFF',31,'Syntax:\nPERIOD_DIFF(P1,P2)\n\nReturns the number of months between periods P1 and P2. P1 and P2\nshould be in the format YYMM or YYYYMM. Note that the period arguments\nP1 and P2 are not date values.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT PERIOD_DIFF(200802,200703);\n        -> 11\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(380,'LIKE',36,'Syntax:\nexpr LIKE pat [ESCAPE \'escape_char\']\n\nPattern matching using SQL simple regular expression comparison.\nReturns 1 (TRUE) or 0 (FALSE). If either expr or pat is NULL, the\nresult is NULL.\n\nThe pattern need not be a literal string. For example, it can be\nspecified as a string expression or table column.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-comparison-functions.html\n\n','mysql> SELECT \'David!\' LIKE \'David_\';\n        -> 1\nmysql> SELECT \'David!\' LIKE \'%D%v%\';\n        -> 1\n','http://dev.mysql.com/doc/refman/5.1/en/string-comparison-functions.html'),(381,'MULTIPOINT',24,'MultiPoint(pt1,pt2,...)\n\nConstructs a MultiPoint value using Point or WKB Point arguments.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-mysql-specific-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-mysql-specific-functions'),(382,'>>',19,'Syntax:\n>>\n\nShifts a longlong (BIGINT) number to the right.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/bit-functions.html\n\n','mysql> SELECT 4 >> 2;\n        -> 1\n','http://dev.mysql.com/doc/refman/5.1/en/bit-functions.html'),(383,'FETCH',23,'Syntax:\nFETCH cursor_name INTO var_name [, var_name] ...\n\nThis statement fetches the next row for the SELECT statement associated\nwith the specified cursor (which must be open), and advances the cursor\npointer. If a row exists, the fetched columns are stored in the named\nvariables. The number of columns retrieved by the SELECT statement must\nmatch the number of output variables specified in the FETCH statement.\n\nIf no more rows are available, a No Data condition occurs with SQLSTATE\nvalue \'02000\'. To detect this condition, you can set up a handler for\nit (or for a NOT FOUND condition). For an example, see\nhttp://dev.mysql.com/doc/refman/5.1/en/cursors.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/fetch.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/fetch.html'),(384,'AVG',16,'Syntax:\nAVG([DISTINCT] expr)\n\nReturns the average value of expr. The DISTINCT option can be used to\nreturn the average of the distinct values of expr.\n\nAVG() returns NULL if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html\n\n','mysql> SELECT student_name, AVG(test_score)\n    ->        FROM student\n    ->        GROUP BY student_name;\n','http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html'),(385,'TRUE FALSE',29,'The constants TRUE and FALSE evaluate to 1 and 0, respectively. The\nconstant names can be written in any lettercase.\n\nmysql> SELECT TRUE, true, FALSE, false;\n        -> 1, 1, 0, 0\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/boolean-literals.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/boolean-literals.html'),(386,'MBRWITHIN',6,'MBRWithin(g1,g2)\n\nReturns 1 or 0 to indicate whether the Minimum Bounding Rectangle of g1\nis within the Minimum Bounding Rectangle of g2. This tests the opposite\nrelationship as MBRContains().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geometry-mbr\n\n','mysql> SET @g1 = GeomFromText(\'Polygon((0 0,0 3,3 3,3 0,0 0))\');\nmysql> SET @g2 = GeomFromText(\'Polygon((0 0,0 5,5 5,5 0,0 0))\');\nmysql> SELECT MBRWithin(@g1,@g2), MBRWithin(@g2,@g1);\n+--------------------+--------------------+\n| MBRWithin(@g1,@g2) | MBRWithin(@g2,@g1) |\n+--------------------+--------------------+\n|                  1 |                  0 |\n+--------------------+--------------------+\n','http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#relations-on-geome'),(387,'SESSION_USER',17,'Syntax:\nSESSION_USER()\n\nSESSION_USER() is a synonym for USER().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/information-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/information-functions.html'),(388,'IN',18,'Syntax:\nexpr IN (value,...)\n\nReturns 1 if expr is equal to any of the values in the IN list, else\nreturns 0. If all values are constants, they are evaluated according to\nthe type of expr and sorted. The search for the item then is done using\na binary search. This means IN is very quick if the IN value list\nconsists entirely of constants. Otherwise, type conversion takes place\naccording to the rules described in\nhttp://dev.mysql.com/doc/refman/5.1/en/type-conversion.html, but\napplied to all the arguments.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html\n\n','mysql> SELECT 2 IN (0,3,5,7);\n        -> 0\nmysql> SELECT \'wefwf\' IN (\'wee\',\'wefwf\',\'weg\');\n        -> 1\n','http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html'),(389,'QUOTE',36,'Syntax:\nQUOTE(str)\n\nQuotes a string to produce a result that can be used as a properly\nescaped data value in an SQL statement. The string is returned enclosed\nby single quotation marks and with each instance of backslash (\"\\\"),\nsingle quote (\"\'\"), ASCII NUL, and Control+Z preceded by a backslash.\nIf the argument is NULL, the return value is the word \"NULL\" without\nenclosing single quotation marks.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT QUOTE(\'Don\\\'t!\');\n        -> \'Don\\\'t!\'\nmysql> SELECT QUOTE(NULL);\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(390,'HELP COMMAND',26,'Syntax:\nmysql> help search_string\n\nIf you provide an argument to the help command, mysql uses it as a\nsearch string to access server-side help from the contents of the MySQL\nReference Manual. The proper operation of this command requires that\nthe help tables in the mysql database be initialized with help topic\ninformation (see\nhttp://dev.mysql.com/doc/refman/5.1/en/server-side-help-support.html).\n\nIf there is no match for the search string, the search fails:\n\nmysql> help me\n\nNothing found\nPlease try to run \'help contents\' for a list of all accessible topics\n\nUse help contents to see a list of the help categories:\n\nmysql> help contents\nYou asked for help about help category: \"Contents\"\nFor more information, type \'help <item>\', where <item> is one of the\nfollowing categories:\n   Account Management\n   Administration\n   Data Definition\n   Data Manipulation\n   Data Types\n   Functions\n   Functions and Modifiers for Use with GROUP BY\n   Geographic Features\n   Language Structure\n   Plugins\n   Storage Engines\n   Stored Routines\n   Table Maintenance\n   Transactions\n   Triggers\n\nIf the search string matches multiple items, mysql shows a list of\nmatching topics:\n\nmysql> help logs\nMany help items for your request exist.\nTo make a more specific request, please type \'help <item>\',\nwhere <item> is one of the following topics:\n   SHOW\n   SHOW BINARY LOGS\n   SHOW ENGINE\n   SHOW LOGS\n\nUse a topic as the search string to see the help entry for that topic:\n\nmysql> help show binary logs\nName: \'SHOW BINARY LOGS\'\nDescription:\nSyntax:\nSHOW BINARY LOGS\nSHOW MASTER LOGS\n\nLists the binary log files on the server. This statement is used as\npart of the procedure described in [purge-binary-logs], that shows how\nto determine which logs can be purged.\n\nmysql> SHOW BINARY LOGS;\n+---------------+-----------+\n| Log_name      | File_size |\n+---------------+-----------+\n| binlog.000015 |    724935 |\n| binlog.000016 |    733481 |\n+---------------+-----------+\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mysql-server-side-help.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/mysql-server-side-help.html'),(391,'QUARTER',31,'Syntax:\nQUARTER(date)\n\nReturns the quarter of the year for date, in the range 1 to 4.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT QUARTER(\'2008-04-01\');\n        -> 2\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(392,'POSITION',36,'Syntax:\nPOSITION(substr IN str)\n\nPOSITION(substr IN str) is a synonym for LOCATE(substr,str).\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(393,'SHOW CREATE FUNCTION',26,'Syntax:\nSHOW CREATE FUNCTION func_name\n\nThis statement is similar to SHOW CREATE PROCEDURE but for stored\nfunctions. See [HELP SHOW CREATE PROCEDURE].\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-create-function.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-create-function.html'),(394,'IS_USED_LOCK',15,'Syntax:\nIS_USED_LOCK(str)\n\nChecks whether the lock named str is in use (that is, locked). If so,\nit returns the connection identifier of the client that holds the lock.\nOtherwise, it returns NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html'),(395,'POLYFROMTEXT',3,'PolyFromText(wkt[,srid]), PolygonFromText(wkt[,srid])\n\nConstructs a POLYGON value using its WKT representation and SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkt-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkt-functions'),(396,'DES_ENCRYPT',12,'Syntax:\nDES_ENCRYPT(str[,{key_num|key_str}])\n\nEncrypts the string with the given key using the Triple-DES algorithm.\n\nThis function works only if MySQL has been configured with SSL support.\nSee http://dev.mysql.com/doc/refman/5.1/en/secure-connections.html.\n\nThe encryption key to use is chosen based on the second argument to\nDES_ENCRYPT(), if one was given. With no argument, the first key from\nthe DES key file is used. With a key_num argument, the given key number\n(0 to 9) from the DES key file is used. With a key_str argument, the\ngiven key string is used to encrypt str.\n\nThe key file can be specified with the --des-key-file server option.\n\nThe return string is a binary string where the first character is\nCHAR(128 | key_num). If an error occurs, DES_ENCRYPT() returns NULL.\n\nThe 128 is added to make it easier to recognize an encrypted key. If\nyou use a string key, key_num is 127.\n\nThe string length for the result is given by this formula:\n\nnew_len = orig_len + (8 - (orig_len % 8)) + 1\n\nEach line in the DES key file has the following format:\n\nkey_num des_key_str\n\nEach key_num value must be a number in the range from 0 to 9. Lines in\nthe file may be in any order. des_key_str is the string that is used to\nencrypt the message. There should be at least one space between the\nnumber and the key. The first key is the default key that is used if\nyou do not specify any key argument to DES_ENCRYPT().\n\nYou can tell MySQL to read new key values from the key file with the\nFLUSH DES_KEY_FILE statement. This requires the RELOAD privilege.\n\nOne benefit of having a set of default keys is that it gives\napplications a way to check for the existence of encrypted column\nvalues, without giving the end user the right to decrypt those values.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html\n\n','mysql> SELECT customer_address FROM customer_table \n     > WHERE crypted_credit_card = DES_ENCRYPT(\'credit_card_number\');\n','http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html'),(397,'CEIL',4,'Syntax:\nCEIL(X)\n\nCEIL() is a synonym for CEILING().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(398,'LENGTH',36,'Syntax:\nLENGTH(str)\n\nReturns the length of the string str, measured in bytes. A multi-byte\ncharacter counts as multiple bytes. This means that for a string\ncontaining five two-byte characters, LENGTH() returns 10, whereas\nCHAR_LENGTH() returns 5.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT LENGTH(\'text\');\n        -> 4\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(399,'STR_TO_DATE',31,'Syntax:\nSTR_TO_DATE(str,format)\n\nThis is the inverse of the DATE_FORMAT() function. It takes a string\nstr and a format string format. STR_TO_DATE() returns a DATETIME value\nif the format string contains both date and time parts, or a DATE or\nTIME value if the string contains only date or time parts. If the date,\ntime, or datetime value extracted from str is illegal, STR_TO_DATE()\nreturns NULL and produces a warning.\n\nThe server scans str attempting to match format to it. The format\nstring can contain literal characters and format specifiers beginning\nwith %. Literal characters in format must match literally in str.\nFormat specifiers in format must match a date or time part in str. For\nthe specifiers that can be used in format, see the DATE_FORMAT()\nfunction description.\n\nmysql> SELECT STR_TO_DATE(\'01,5,2013\',\'%d,%m,%Y\');\n        -> \'2013-05-01\'\nmysql> SELECT STR_TO_DATE(\'May 1, 2013\',\'%M %d,%Y\');\n        -> \'2013-05-01\'\n\nScanning starts at the beginning of str and fails if format is found\nnot to match. Extra characters at the end of str are ignored.\n\nmysql> SELECT STR_TO_DATE(\'a09:30:17\',\'a%h:%i:%s\');\n        -> \'09:30:17\'\nmysql> SELECT STR_TO_DATE(\'a09:30:17\',\'%h:%i:%s\');\n        -> NULL\nmysql> SELECT STR_TO_DATE(\'09:30:17a\',\'%h:%i:%s\');\n        -> \'09:30:17\'\n\nUnspecified date or time parts have a value of 0, so incompletely\nspecified values in str produce a result with some or all parts set to\n0:\n\nmysql> SELECT STR_TO_DATE(\'abc\',\'abc\');\n        -> \'0000-00-00\'\nmysql> SELECT STR_TO_DATE(\'9\',\'%m\');\n        -> \'0000-09-00\'\nmysql> SELECT STR_TO_DATE(\'9\',\'%s\');\n        -> \'00:00:09\'\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(400,'Y',11,'Y(p)\n\nReturns the Y-coordinate value for the Point object p as a\ndouble-precision number.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#point-property-functions\n\n','mysql> SELECT Y(POINT(56.7, 53.34));\n+-----------------------+\n| Y(POINT(56.7, 53.34)) |\n+-----------------------+\n|                 53.34 |\n+-----------------------+\n','http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#point-property-functions'),(401,'SHOW INNODB STATUS',26,'Syntax:\nSHOW INNODB STATUS\n\nIn MySQL 5.1, this is a deprecated synonym for SHOW ENGINE INNODB\nSTATUS. See [HELP SHOW ENGINE]. SHOW INNODB STATUS is removed in MySQL\n5.5.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-innodb-status.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-innodb-status.html'),(402,'CHECKSUM TABLE',20,'Syntax:\nCHECKSUM TABLE tbl_name [, tbl_name] ... [ QUICK | EXTENDED ]\n\nCHECKSUM TABLE reports a table checksum.\n\nWith QUICK, the live table checksum is reported if it is available, or\nNULL otherwise. This is very fast. A live checksum is enabled by\nspecifying the CHECKSUM=1 table option when you create the table;\ncurrently, this is supported only for MyISAM tables. See [HELP CREATE\nTABLE].\n\nWith EXTENDED, the entire table is read row by row and the checksum is\ncalculated. This can be very slow for large tables.\n\nIf neither QUICK nor EXTENDED is specified, MySQL returns a live\nchecksum if the table storage engine supports it and scans the table\notherwise.\n\nFor a nonexistent table, CHECKSUM TABLE returns NULL and generates a\nwarning.\n\nIn MySQL 5.1, CHECKSUM TABLE returns 0 for partitioned tables unless\nyou include the EXTENDED option. This issue is resolved in MySQL 5.6.\n(Bug #11933226, Bug #60681)\n\nThe checksum value depends on the table row format. If the row format\nchanges, the checksum also changes. For example, the storage format for\nVARCHAR changed between MySQL 4.1 and 5.0, so if a 4.1 table is\nupgraded to MySQL 5.0, the checksum value may change.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/checksum-table.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/checksum-table.html'),(403,'NUMINTERIORRINGS',2,'NumInteriorRings(poly)\n\nReturns the number of interior rings in the Polygon value poly.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#polygon-property-functions\n\n','mysql> SET @poly =\n    -> \'Polygon((0 0,0 3,3 3,3 0,0 0),(1 1,1 2,2 2,2 1,1 1))\';\nmysql> SELECT NumInteriorRings(GeomFromText(@poly));\n+---------------------------------------+\n| NumInteriorRings(GeomFromText(@poly)) |\n+---------------------------------------+\n|                                     1 |\n+---------------------------------------+\n','http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#polygon-property-functions'),(404,'INTERIORRINGN',2,'InteriorRingN(poly,N)\n\nReturns the N-th interior ring for the Polygon value poly as a\nLineString. Rings are numbered beginning with 1.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#polygon-property-functions\n\n','mysql> SET @poly =\n    -> \'Polygon((0 0,0 3,3 3,3 0,0 0),(1 1,1 2,2 2,2 1,1 1))\';\nmysql> SELECT AsText(InteriorRingN(GeomFromText(@poly),1));\n+----------------------------------------------+\n| AsText(InteriorRingN(GeomFromText(@poly),1)) |\n+----------------------------------------------+\n| LINESTRING(1 1,1 2,2 2,2 1,1 1)              |\n+----------------------------------------------+\n','http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#polygon-property-functions'),(405,'UTC_TIME',31,'Syntax:\nUTC_TIME, UTC_TIME()\n\nReturns the current UTC time as a value in \'HH:MM:SS\' or HHMMSS.uuuuuu\nformat, depending on whether the function is used in a string or\nnumeric context.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT UTC_TIME(), UTC_TIME() + 0;\n        -> \'18:07:53\', 180753.000000\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(406,'DROP FUNCTION',38,'The DROP FUNCTION statement is used to drop stored functions and\nuser-defined functions (UDFs):\n\no For information about dropping stored functions, see [HELP DROP\n  PROCEDURE].\n\no For information about dropping user-defined functions, see [HELP DROP\n  FUNCTION UDF].\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/drop-function.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/drop-function.html'),(407,'ALTER EVENT',38,'Syntax:\nALTER\n    [DEFINER = { user | CURRENT_USER }]\n    EVENT event_name\n    [ON SCHEDULE schedule]\n    [ON COMPLETION [NOT] PRESERVE]\n    [RENAME TO new_event_name]\n    [ENABLE | DISABLE | DISABLE ON SLAVE]\n    [COMMENT \'comment\']\n    [DO event_body]\n\nThe ALTER EVENT statement changes one or more of the characteristics of\nan existing event without the need to drop and recreate it. The syntax\nfor each of the DEFINER, ON SCHEDULE, ON COMPLETION, COMMENT, ENABLE /\nDISABLE, and DO clauses is exactly the same as when used with CREATE\nEVENT. (See [HELP CREATE EVENT].)\n\nSupport for the DEFINER clause was added in MySQL 5.1.17.\n\nBeginning with MySQL 5.1.12, this statement requires the EVENT\nprivilege. When a user executes a successful ALTER EVENT statement,\nthat user becomes the definer for the affected event.\n\n(In MySQL 5.1.11 and earlier, an event could be altered only by its\ndefiner, or by a user having the SUPER privilege.)\n\nALTER EVENT works only with an existing event:\n\nmysql> ALTER EVENT no_such_event \n     >     ON SCHEDULE \n     >       EVERY \'2:3\' DAY_HOUR;\nERROR 1517 (HY000): Unknown event \'no_such_event\'\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/alter-event.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/alter-event.html'),(408,'STDDEV',16,'Syntax:\nSTDDEV(expr)\n\nReturns the population standard deviation of expr. This function is\nprovided for compatibility with Oracle. The standard SQL function\nSTDDEV_POP() can be used instead.\n\nThis function returns NULL if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html'),(409,'DATE_SUB',31,'Syntax:\nDATE_SUB(date,INTERVAL expr unit)\n\nSee the description for DATE_ADD().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(410,'PERIOD_ADD',31,'Syntax:\nPERIOD_ADD(P,N)\n\nAdds N months to period P (in the format YYMM or YYYYMM). Returns a\nvalue in the format YYYYMM. Note that the period argument P is not a\ndate value.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT PERIOD_ADD(200801,2);\n        -> 200803\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(411,'|',19,'Syntax:\n|\n\nBitwise OR:\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/bit-functions.html\n\n','mysql> SELECT 29 | 15;\n        -> 31\n','http://dev.mysql.com/doc/refman/5.1/en/bit-functions.html'),(412,'GEOMFROMTEXT',3,'GeomFromText(wkt[,srid]), GeometryFromText(wkt[,srid])\n\nConstructs a geometry value of any type using its WKT representation\nand SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkt-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkt-functions'),(413,'UUID_SHORT',15,'Syntax:\nUUID_SHORT()\n\nReturns a \"short\" universal identifier as a 64-bit unsigned integer\n(rather than a string-form 128-bit identifier as returned by the UUID()\nfunction).\n\nThe value of UUID_SHORT() is guaranteed to be unique if the following\nconditions hold:\n\no The server_id of the current host is unique among your set of master\n  and slave servers\n\no server_id is between 0 and 255\n\no You do not set back your system time for your server between mysqld\n  restarts\n\no You do not invoke UUID_SHORT() on average more than 16 million times\n  per second between mysqld restarts\n\nThe UUID_SHORT() return value is constructed this way:\n\n  (server_id & 255) << 56\n+ (server_startup_time_in_seconds << 24)\n+ incremented_variable++;\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html\n\n','mysql> SELECT UUID_SHORT();\n        -> 92395783831158784\n','http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html'),(414,'RIGHT',36,'Syntax:\nRIGHT(str,len)\n\nReturns the rightmost len characters from the string str, or NULL if\nany argument is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT RIGHT(\'foobarbar\', 4);\n        -> \'rbar\'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(415,'DATEDIFF',31,'Syntax:\nDATEDIFF(expr1,expr2)\n\nDATEDIFF() returns expr1 - expr2 expressed as a value in days from one\ndate to the other. expr1 and expr2 are date or date-and-time\nexpressions. Only the date parts of the values are used in the\ncalculation.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT DATEDIFF(\'2007-12-31 23:59:59\',\'2007-12-30\');\n        -> 1\nmysql> SELECT DATEDIFF(\'2010-11-30 23:59:59\',\'2010-12-31\');\n        -> -31\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(416,'DROP TABLESPACE',38,'Syntax:\nDROP TABLESPACE tablespace_name\n    ENGINE [=] engine_name\n\nThis statement drops a tablespace that was previously created using\nCREATE TABLESPACE (see [HELP CREATE TABLESPACE]).\n\n*Important*: The tablespace to be dropped must not contain any data\nfiles; in other words, before you can drop a tablespace, you must first\ndrop each of its data files using ALTER TABLESPACE ... DROP DATAFILE\n(see [HELP ALTER TABLESPACE]).\n\nThe ENGINE clause (required) specifies the storage engine used by the\ntablespace. In MySQL 5.1, the only accepted values for engine_name are\nNDB and NDBCLUSTER.\n\nDROP TABLESPACE was added in MySQL 5.1.6. In MySQL 5.1, it is useful\nonly with Disk Data storage for MySQL Cluster. See\nhttp://dev.mysql.com/doc/refman/5.1/en/mysql-cluster-disk-data.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/drop-tablespace.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/drop-tablespace.html'),(417,'DROP PROCEDURE',38,'Syntax:\nDROP {PROCEDURE | FUNCTION} [IF EXISTS] sp_name\n\nThis statement is used to drop a stored procedure or function. That is,\nthe specified routine is removed from the server. You must have the\nALTER ROUTINE privilege for the routine. (If the\nautomatic_sp_privileges system variable is enabled, that privilege and\nEXECUTE are granted automatically to the routine creator when the\nroutine is created and dropped from the creator when the routine is\ndropped. See\nhttp://dev.mysql.com/doc/refman/5.1/en/stored-routines-privileges.html.\n)\n\nThe IF EXISTS clause is a MySQL extension. It prevents an error from\noccurring if the procedure or function does not exist. A warning is\nproduced that can be viewed with SHOW WARNINGS.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/drop-procedure.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/drop-procedure.html'),(418,'CHECK TABLE',20,'Syntax:\nCHECK TABLE tbl_name [, tbl_name] ... [option] ...\n\noption = {FOR UPGRADE | QUICK | FAST | MEDIUM | EXTENDED | CHANGED}\n\nCHECK TABLE checks a table or tables for errors. CHECK TABLE works for\nMyISAM, InnoDB, and ARCHIVE tables. Starting with MySQL 5.1.9, CHECK\nTABLE is also valid for CSV tables, see\nhttp://dev.mysql.com/doc/refman/5.1/en/csv-storage-engine.html. For\nMyISAM tables, the key statistics are updated as well.\n\nCHECK TABLE can also check views for problems, such as tables that are\nreferenced in the view definition that no longer exist.\n\nBeginning with MySQL 5.1.27, CHECK TABLE is also supported for\npartitioned tables. Also beginning with MySQL 5.1.27, you can use ALTER\nTABLE ... CHECK PARTITION to check one or more partitions; for more\ninformation, see [HELP ALTER TABLE], and\nhttp://dev.mysql.com/doc/refman/5.1/en/partitioning-maintenance.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/check-table.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/check-table.html'),(419,'BIN',36,'Syntax:\nBIN(N)\n\nReturns a string representation of the binary value of N, where N is a\nlonglong (BIGINT) number. This is equivalent to CONV(N,10,2). Returns\nNULL if N is NULL.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT BIN(12);\n        -> \'1100\'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(420,'INSTALL PLUGIN',5,'Syntax:\nINSTALL PLUGIN plugin_name SONAME \'shared_library_name\'\n\nThis statement installs a server plugin. It requires the INSERT\nprivilege for the mysql.plugin table.\n\nplugin_name is the name of the plugin as defined in the plugin\ndescriptor structure contained in the library file (see\nhttp://dev.mysql.com/doc/refman/5.1/en/plugin-data-structures.html).\nPlugin names are not case sensitive. For maximal compatibility, plugin\nnames should be limited to ASCII letters, digits, and underscore\nbecause they are used in C source files, shell command lines, M4 and\nBourne shell scripts, and SQL environments.\n\nshared_library_name is the name of the shared library that contains the\nplugin code. The name includes the file name extension (for example,\nlibmyplugin.so, libmyplugin.dll, or libmyplugin.dylib).\n\nThe shared library must be located in the plugin directory (the\ndirectory named by the plugin_dir system variable). The library must be\nin the plugin directory itself, not in a subdirectory. By default,\nplugin_dir is the plugin directory under the directory named by the\npkglibdir configuration variable, but it can be changed by setting the\nvalue of plugin_dir at server startup. For example, set its value in a\nmy.cnf file:\n\n[mysqld]\nplugin_dir=/path/to/plugin/directory\n\nIf the value of plugin_dir is a relative path name, it is taken to be\nrelative to the MySQL base directory (the value of the basedir system\nvariable).\n\nINSTALL PLUGIN loads and initializes the plugin code to make the plugin\navailable for use. A plugin is initialized by executing its\ninitialization function, which handles any setup that the plugin must\nperform before it can be used. When the server shuts down, it executes\nthe deinitialization function for each plugin that is loaded so that\nthe plugin has a change to perform any final cleanup.\n\nINSTALL PLUGIN also registers the plugin by adding a line that\nindicates the plugin name and library file name to the mysql.plugin\ntable. At server startup, the server loads and initializes any plugin\nthat is listed in the mysql.plugin table. This means that a plugin is\ninstalled with INSTALL PLUGIN only once, not every time the server\nstarts. Plugin loading at startup does not occur if the server is\nstarted with the --skip-grant-tables option.\n\nA plugin library can contain multiple plugins. For each of them to be\ninstalled, use a separate INSTALL PLUGIN statement. Each statement\nnames a different plugin, but all of them specify the same library\nname.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/install-plugin.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/install-plugin.html'),(421,'DECLARE CURSOR',23,'Syntax:\nDECLARE cursor_name CURSOR FOR select_statement\n\nThis statement declares a cursor and associates it with a SELECT\nstatement that retrieves the rows to be traversed by the cursor. To\nfetch the rows later, use a FETCH statement. The number of columns\nretrieved by the SELECT statement must match the number of output\nvariables specified in the FETCH statement.\n\nThe SELECT statement cannot have an INTO clause.\n\nCursor declarations must appear before handler declarations and after\nvariable and condition declarations.\n\nA stored program may contain multiple cursor declarations, but each\ncursor declared in a given block must have a unique name. For an\nexample, see http://dev.mysql.com/doc/refman/5.1/en/cursors.html.\n\nFor information available through SHOW statements, it is possible in\nmany cases to obtain equivalent information by using a cursor with an\nINFORMATION_SCHEMA table.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/declare-cursor.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/declare-cursor.html'),(422,'LOAD DATA',27,'Syntax:\nLOAD DATA [LOW_PRIORITY | CONCURRENT] [LOCAL] INFILE \'file_name\'\n    [REPLACE | IGNORE]\n    INTO TABLE tbl_name\n    [CHARACTER SET charset_name]\n    [{FIELDS | COLUMNS}\n        [TERMINATED BY \'string\']\n        [[OPTIONALLY] ENCLOSED BY \'char\']\n        [ESCAPED BY \'char\']\n    ]\n    [LINES\n        [STARTING BY \'string\']\n        [TERMINATED BY \'string\']\n    ]\n    [IGNORE number LINES]\n    [(col_name_or_user_var,...)]\n    [SET col_name = expr,...]\n\nThe LOAD DATA INFILE statement reads rows from a text file into a table\nat a very high speed. The file name must be given as a literal string.\n\nLOAD DATA INFILE is the complement of SELECT ... INTO OUTFILE. (See\nhttp://dev.mysql.com/doc/refman/5.1/en/select.html.) To write data from\na table to a file, use SELECT ... INTO OUTFILE. To read the file back\ninto a table, use LOAD DATA INFILE. The syntax of the FIELDS and LINES\nclauses is the same for both statements. Both clauses are optional, but\nFIELDS must precede LINES if both are specified.\n\nFor more information about the efficiency of INSERT versus LOAD DATA\nINFILE and speeding up LOAD DATA INFILE, see\nhttp://dev.mysql.com/doc/refman/5.1/en/insert-speed.html.\n\nThe character set indicated by the character_set_database system\nvariable is used to interpret the information in the file. SET NAMES\nand the setting of character_set_client do not affect interpretation of\ninput. If the contents of the input file use a character set that\ndiffers from the default, it is usually preferable to specify the\ncharacter set of the file by using the CHARACTER SET clause, which is\navailable as of MySQL 5.1.17. A character set of binary specifies \"no\nconversion.\"\n\nLOAD DATA INFILE interprets all fields in the file as having the same\ncharacter set, regardless of the data types of the columns into which\nfield values are loaded. For proper interpretation of file contents,\nyou must ensure that it was written with the correct character set. For\nexample, if you write a data file with mysqldump -T or by issuing a\nSELECT ... INTO OUTFILE statement in mysql, be sure to use a\n--default-character-set option with mysqldump or mysql so that output\nis written in the character set to be used when the file is loaded with\nLOAD DATA INFILE.\n\n*Note*: It is not possible to load data files that use the ucs2\ncharacter set.\n\nAs of MySQL 5.1.6, the character_set_filesystem system variable\ncontrols the interpretation of the file name.\n\nYou can also load data files by using the mysqlimport utility; it\noperates by sending a LOAD DATA INFILE statement to the server. The\n--local option causes mysqlimport to read data files from the client\nhost. You can specify the --compress option to get better performance\nover slow networks if the client and server support the compressed\nprotocol. See http://dev.mysql.com/doc/refman/5.1/en/mysqlimport.html.\n\nIf you use LOW_PRIORITY, execution of the LOAD DATA statement is\ndelayed until no other clients are reading from the table. This affects\nonly storage engines that use only table-level locking (such as MyISAM,\nMEMORY, and MERGE).\n\nIf you specify CONCURRENT with a MyISAM table that satisfies the\ncondition for concurrent inserts (that is, it contains no free blocks\nin the middle), other threads can retrieve data from the table while\nLOAD DATA is executing. Using this option affects the performance of\nLOAD DATA a bit, even if no other thread is using the table at the same\ntime.\n\nPrior to MySQL 5.1.43, CONCURRENT was not replicated when using\nstatement-based replication (see Bug #34628). However, it is replicated\nwhen using row-based replication, regardless of the version. See\nhttp://dev.mysql.com/doc/refman/5.1/en/replication-features-load-data.h\ntml, for more information.\n\n*Note*: Prior to MySQL 5.1.23, LOAD DATA performed very poorly when\nimporting into partitioned tables. The statement now uses buffering to\nimprove performance; however, the buffer uses 130KB memory per\npartition to achieve this. (Bug #26527)\n\nThe LOCAL keyword, if specified, is interpreted with respect to the\nclient end of the connection:\n\no If LOCAL is specified, the file is read by the client program on the\n  client host and sent to the server. The file can be given as a full\n  path name to specify its exact location. If given as a relative path\n  name, the name is interpreted relative to the directory in which the\n  client program was started.\n\n  When using LOCAL with LOAD DATA, a copy of the file is created in the\n  server\'s temporary directory. This is not the directory determined by\n  the value of tmpdir or slave_load_tmpdir, but rather the operating\n  system\'s temporary directory, and is not configurable in the MySQL\n  Server. (Typically the system temporary directory is /tmp on Linux\n  systems and C:\\WINDOWS\\TEMP on Windows.) Lack of sufficient space for\n  the copy in this directory can cause the LOAD DATA LOCAL statement to\n  fail.\n\no If LOCAL is not specified, the file must be located on the server\n  host and is read directly by the server. The server uses the\n  following rules to locate the file:\n\n  o If the file name is an absolute path name, the server uses it as\n    given.\n\n  o If the file name is a relative path name with one or more leading\n    components, the server searches for the file relative to the\n    server\'s data directory.\n\n  o If a file name with no leading components is given, the server\n    looks for the file in the database directory of the default\n    database.\n\nNote that, in the non-LOCAL case, these rules mean that a file named as\n./myfile.txt is read from the server\'s data directory, whereas the file\nnamed as myfile.txt is read from the database directory of the default\ndatabase. For example, if db1 is the default database, the following\nLOAD DATA statement reads the file data.txt from the database directory\nfor db1, even though the statement explicitly loads the file into a\ntable in the db2 database:\n\nLOAD DATA INFILE \'data.txt\' INTO TABLE db2.my_table;\n\nWindows path names are specified using forward slashes rather than\nbackslashes. If you do use backslashes, you must double them.\n\n*Note*: A regression in MySQL 5.1.40 caused the database referenced in\na fully qualified table name to be ignored by LOAD DATA when using\nreplication with either STATEMENT or MIXED as the binary logging\nformat; this could lead to problems if the table was not in the current\ndatabase. As a workaround, you can specify the correct database with\nthe USE statement prior to executing LOAD DATA. If necessary, you can\nreset the default database with a second USE statement following the\nLOAD DATA statement. This issue was fixed in MySQL 5.1.41. (Bug #48297)\n\nFor security reasons, when reading text files located on the server,\nthe files must either reside in the database directory or be readable\nby all. Also, to use LOAD DATA INFILE on server files, you must have\nthe FILE privilege. See\nhttp://dev.mysql.com/doc/refman/5.1/en/privileges-provided.html. For\nnon-LOCAL load operations, if the secure_file_priv system variable is\nset to a nonempty directory name, the file to be loaded must be located\nin that directory.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/load-data.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/load-data.html'),(423,'MULTILINESTRING',24,'MultiLineString(ls1,ls2,...)\n\nConstructs a MultiLineString value using LineString or WKB LineString\narguments.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-mysql-specific-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-mysql-specific-functions'),(424,'LOCALTIME',31,'Syntax:\nLOCALTIME, LOCALTIME()\n\nLOCALTIME and LOCALTIME() are synonyms for NOW().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(425,'MPOINTFROMTEXT',3,'MPointFromText(wkt[,srid]), MultiPointFromText(wkt[,srid])\n\nConstructs a MULTIPOINT value using its WKT representation and SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkt-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkt-functions'),(426,'BLOB',22,'BLOB[(M)]\n\nA BLOB column with a maximum length of 65,535 (216 - 1) bytes. Each\nBLOB value is stored using a two-byte length prefix that indicates the\nnumber of bytes in the value.\n\nAn optional length M can be given for this type. If this is done, MySQL\ncreates the column as the smallest BLOB type large enough to hold\nvalues M bytes long.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html'),(427,'SHA1',12,'Syntax:\nSHA1(str), SHA(str)\n\nCalculates an SHA-1 160-bit checksum for the string, as described in\nRFC 3174 (Secure Hash Algorithm). The value is returned as a binary\nstring of 40 hex digits, or NULL if the argument was NULL. One of the\npossible uses for this function is as a hash key. See the notes at the\nbeginning of this section about storing hash values efficiently. You\ncan also use SHA1() as a cryptographic function for storing passwords.\nSHA() is synonymous with SHA1().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html\n\n','mysql> SELECT SHA1(\'abc\');\n        -> \'a9993e364706816aba3e25717850c26c9cd0d89d\'\n','http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html'),(428,'SUBSTR',36,'Syntax:\nSUBSTR(str,pos), SUBSTR(str FROM pos), SUBSTR(str,pos,len), SUBSTR(str\nFROM pos FOR len)\n\nSUBSTR() is a synonym for SUBSTRING().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(429,'PASSWORD',12,'Syntax:\nPASSWORD(str)\n\nCalculates and returns a password string from the plaintext password\nstr and returns a binary string, or NULL if the argument was NULL. This\nis the function that is used for encrypting MySQL passwords for storage\nin the Password column of the user grant table.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html\n\n','mysql> SELECT PASSWORD(\'badpwd\');\n        -> \'*AAB3E285149C0135D51A520E1940DD3263DC008C\'\n','http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html'),(430,'CHAR',22,'[NATIONAL] CHAR[(M)] [CHARACTER SET charset_name] [COLLATE\ncollation_name]\n\nA fixed-length string that is always right-padded with spaces to the\nspecified length when stored. M represents the column length in\ncharacters. The range of M is 0 to 255. If M is omitted, the length is\n1.\n\n*Note*: Trailing spaces are removed when CHAR values are retrieved\nunless the PAD_CHAR_TO_FULL_LENGTH SQL mode is enabled.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html'),(431,'UTC_DATE',31,'Syntax:\nUTC_DATE, UTC_DATE()\n\nReturns the current UTC date as a value in \'YYYY-MM-DD\' or YYYYMMDD\nformat, depending on whether the function is used in a string or\nnumeric context.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT UTC_DATE(), UTC_DATE() + 0;\n        -> \'2003-08-14\', 20030814\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(432,'DIMENSION',35,'Dimension(g)\n\nReturns the inherent dimension of the geometry value g. The result can\nbe -1, 0, 1, or 2. The meaning of these values is given in\nhttp://dev.mysql.com/doc/refman/5.1/en/gis-class-geometry.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#general-geometry-property-functions\n\n','mysql> SELECT Dimension(GeomFromText(\'LineString(1 1,2 2)\'));\n+------------------------------------------------+\n| Dimension(GeomFromText(\'LineString(1 1,2 2)\')) |\n+------------------------------------------------+\n|                                              1 |\n+------------------------------------------------+\n','http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#general-geometry-property-functions'),(433,'COUNT DISTINCT',16,'Syntax:\nCOUNT(DISTINCT expr,[expr...])\n\nReturns a count of the number of rows with different non-NULL expr\nvalues.\n\nCOUNT(DISTINCT) returns 0 if there were no matching rows.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html\n\n','mysql> SELECT COUNT(DISTINCT results) FROM student;\n','http://dev.mysql.com/doc/refman/5.1/en/group-by-functions.html'),(434,'BIT',22,'BIT[(M)]\n\nA bit-field type. M indicates the number of bits per value, from 1 to\n64. The default is 1 if M is omitted.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html'),(435,'EQUALS',30,'Equals(g1,g2)\n\nReturns 1 or 0 to indicate whether g1 is spatially equal to g2.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-test-spatial-relationships-between-geometries\n\n','','http://dev.mysql.com/doc/refman/5.1/en/functions-for-testing-spatial-relations-between-geometric-objects.html#functions-that-tes'),(436,'SHOW CREATE VIEW',26,'Syntax:\nSHOW CREATE VIEW view_name\n\nThis statement shows a CREATE VIEW statement that creates the given\nview.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-create-view.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-create-view.html'),(437,'INTERVAL',18,'Syntax:\nINTERVAL(N,N1,N2,N3,...)\n\nReturns 0 if N < N1, 1 if N < N2 and so on or -1 if N is NULL. All\narguments are treated as integers. It is required that N1 < N2 < N3 <\n... < Nn for this function to work correctly. This is because a binary\nsearch is used (very fast).\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html\n\n','mysql> SELECT INTERVAL(23, 1, 15, 17, 30, 44, 200);\n        -> 3\nmysql> SELECT INTERVAL(10, 1, 10, 100, 1000);\n        -> 2\nmysql> SELECT INTERVAL(22, 23, 30, 44, 200);\n        -> 0\n','http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html'),(438,'FROM_DAYS',31,'Syntax:\nFROM_DAYS(N)\n\nGiven a day number N, returns a DATE value.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT FROM_DAYS(730669);\n        -> \'2007-07-03\'\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(439,'ALTER PROCEDURE',38,'Syntax:\nALTER PROCEDURE proc_name [characteristic ...]\n\ncharacteristic:\n    COMMENT \'string\'\n  | { CONTAINS SQL | NO SQL | READS SQL DATA | MODIFIES SQL DATA }\n  | SQL SECURITY { DEFINER | INVOKER }\n\nThis statement can be used to change the characteristics of a stored\nprocedure. More than one change may be specified in an ALTER PROCEDURE\nstatement. However, you cannot change the parameters or body of a\nstored procedure using this statement; to make such changes, you must\ndrop and re-create the procedure using DROP PROCEDURE and CREATE\nPROCEDURE.\n\nYou must have the ALTER ROUTINE privilege for the procedure. By\ndefault, that privilege is granted automatically to the procedure\ncreator. This behavior can be changed by disabling the\nautomatic_sp_privileges system variable. See\nhttp://dev.mysql.com/doc/refman/5.1/en/stored-routines-privileges.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/alter-procedure.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/alter-procedure.html'),(440,'BIT_COUNT',19,'Syntax:\nBIT_COUNT(N)\n\nReturns the number of bits that are set in the argument N.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/bit-functions.html\n\n','mysql> SELECT BIT_COUNT(29), BIT_COUNT(b\'101010\');\n        -> 4, 3\n','http://dev.mysql.com/doc/refman/5.1/en/bit-functions.html'),(441,'OCTET_LENGTH',36,'Syntax:\nOCTET_LENGTH(str)\n\nOCTET_LENGTH() is a synonym for LENGTH().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(442,'UTC_TIMESTAMP',31,'Syntax:\nUTC_TIMESTAMP, UTC_TIMESTAMP()\n\nReturns the current UTC date and time as a value in \'YYYY-MM-DD\nHH:MM:SS\' or YYYYMMDDHHMMSS.uuuuuu format, depending on whether the\nfunction is used in a string or numeric context.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT UTC_TIMESTAMP(), UTC_TIMESTAMP() + 0;\n        -> \'2003-08-14 18:08:04\', 20030814180804.000000\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(443,'AES_ENCRYPT',12,'Syntax:\nAES_ENCRYPT(str,key_str)\n\nAES_ENCRYPT() and AES_DECRYPT() enable encryption and decryption of\ndata using the official AES (Advanced Encryption Standard) algorithm,\npreviously known as \"Rijndael.\" Encoding with a 128-bit key length is\nused, but you can extend it up to 256 bits by modifying the source. We\nchose 128 bits because it is much faster and it is secure enough for\nmost purposes.\n\nAES_ENCRYPT() encrypts a string and returns a binary string.\nAES_DECRYPT() decrypts the encrypted string and returns the original\nstring. The input arguments may be any length. If either argument is\nNULL, the result of this function is also NULL.\n\nBecause AES is a block-level algorithm, padding is used to encode\nuneven length strings and so the result string length may be calculated\nusing this formula:\n\n16 * (trunc(string_length / 16) + 1)\n\nIf AES_DECRYPT() detects invalid data or incorrect padding, it returns\nNULL. However, it is possible for AES_DECRYPT() to return a non-NULL\nvalue (possibly garbage) if the input data or the key is invalid.\n\nYou can use the AES functions to store data in an encrypted form by\nmodifying your queries:\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html\n\n','INSERT INTO t VALUES (1,AES_ENCRYPT(\'text\',\'password\'));\n','http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html'),(444,'+',4,'Syntax:\n+\n\nAddition:\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/arithmetic-functions.html\n\n','mysql> SELECT 3+5;\n        -> 8\n','http://dev.mysql.com/doc/refman/5.1/en/arithmetic-functions.html'),(445,'INET_NTOA',15,'Syntax:\nINET_NTOA(expr)\n\nGiven a numeric IPv4 network address in network byte order, returns the\ndotted-quad representation of the address as a binary string.\nINET_NTOA() returns NULL if it does not understand its argument.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html\n\n','mysql> SELECT INET_NTOA(167773449);\n        -> \'10.0.5.9\'\n','http://dev.mysql.com/doc/refman/5.1/en/miscellaneous-functions.html'),(446,'ACOS',4,'Syntax:\nACOS(X)\n\nReturns the arc cosine of X, that is, the value whose cosine is X.\nReturns NULL if X is not in the range -1 to 1.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT ACOS(1);\n        -> 0\nmysql> SELECT ACOS(1.0001);\n        -> NULL\nmysql> SELECT ACOS(0);\n        -> 1.5707963267949\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(447,'ISOLATION',8,'Syntax:\nSET [GLOBAL | SESSION] TRANSACTION ISOLATION LEVEL\n  {\n       REPEATABLE READ\n     | READ COMMITTED\n     | READ UNCOMMITTED\n     | SERIALIZABLE\n   }\n\nThis statement sets the transaction isolation level, used for\noperations on InnoDB tables.\n\nScope of the Isolation Level\n\nYou can set the isolation level globally, for the current session, or\nfor the next transaction:\n\no With the GLOBAL keyword, the statement sets the default transaction\n  level globally for all subsequent sessions. Existing sessions are\n  unaffected.\n\no With the SESSION keyword, the statement sets the default transaction\n  level for all subsequent transactions performed within the current\n  session.\n\no Without any SESSION or GLOBAL keyword, the statement sets the\n  isolation level for the next (not started) transaction performed\n  within the current session.\n\nA change to the global default isolation level requires the SUPER\nprivilege. Any session is free to change its session isolation level\n(even in the middle of a transaction), or the isolation level for its\nnext transaction.\n\nSET TRANSACTION ISOLATION LEVEL without GLOBAL or SESSION is not\npermitted while there is an active transaction:\n\nmysql> START TRANSACTION;\nQuery OK, 0 rows affected (0.02 sec)\n\nmysql> SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;\nERROR 1568 (25001): Transaction isolation level can\'t be changed\nwhile a transaction is in progress\n\nTo set the global default isolation level at server startup, use the\n--transaction-isolation=level option to mysqld on the command line or\nin an option file. Values of level for this option use dashes rather\nthan spaces, so the permissible values are READ-UNCOMMITTED,\nREAD-COMMITTED, REPEATABLE-READ, or SERIALIZABLE. For example, to set\nthe default isolation level to REPEATABLE READ, use these lines in the\n[mysqld] section of an option file:\n\n[mysqld]\ntransaction-isolation = REPEATABLE-READ\n\nIt is possible to check or set the global and session transaction\nisolation levels at runtime by using the tx_isolation system variable:\n\nSELECT @@GLOBAL.tx_isolation, @@tx_isolation;\nSET GLOBAL tx_isolation=\'REPEATABLE-READ\';\nSET SESSION tx_isolation=\'SERIALIZABLE\';\n\nDetails and Usage of Isolation Levels\n\nInnoDB supports each of the transaction isolation levels described here\nusing different locking strategies. You can enforce a high degree of\nconsistency with the default REPEATABLE READ level, for operations on\ncrucial data where ACID compliance is important. Or you can relax the\nconsistency rules with READ COMMITTED or even READ UNCOMMITTED, in\nsituations such as bulk reporting where precise consistency and\nrepeatable results are less important than minimizing the amount of\noverhead for locking. SERIALIZABLE enforces even stricter rules than\nREPEATABLE READ, and is used mainly in specialized situations, such as\nwith XA transactions and for troubleshooting issues with concurrency\nand deadlocks.\n\nFor full information about how these isolation levels work with InnoDB\ntransactions, see\nhttp://dev.mysql.com/doc/refman/5.1/en/innodb-transaction-model.html.\nIn particular, for additional information about InnoDB record-level\nlocks and how it uses them to execute various types of statements, see\nhttp://dev.mysql.com/doc/refman/5.1/en/innodb-record-level-locks.html\nand http://dev.mysql.com/doc/refman/5.1/en/innodb-locks-set.html.\n\nThe following list describes how MySQL supports the different\ntransaction levels. The list goes from the most commonly used level to\nthe least used.\n\no REPEATABLE READ\n\n  This is the default isolation level for InnoDB. For consistent reads,\n  there is an important difference from the READ COMMITTED isolation\n  level: All consistent reads within the same transaction read the\n  snapshot established by the first read. This convention means that if\n  you issue several plain (nonlocking) SELECT statements within the\n  same transaction, these SELECT statements are consistent also with\n  respect to each other. See\n  http://dev.mysql.com/doc/refman/5.1/en/innodb-consistent-read.html.\n\n  For locking reads (SELECT with FOR UPDATE or LOCK IN SHARE MODE),\n  UPDATE, and DELETE statements, locking depends on whether the\n  statement uses a unique index with a unique search condition, or a\n  range-type search condition. For a unique index with a unique search\n  condition, InnoDB locks only the index record found, not the gap\n  before it. For other search conditions, InnoDB locks the index range\n  scanned, using gap locks or next-key (gap plus index-record) locks to\n  block insertions by other sessions into the gaps covered by the\n  range.\n\no READ COMMITTED\n\n  A somewhat Oracle-like isolation level with respect to consistent\n  (nonlocking) reads: Each consistent read, even within the same\n  transaction, sets and reads its own fresh snapshot. See\n  http://dev.mysql.com/doc/refman/5.1/en/innodb-consistent-read.html.\n\n  For locking reads (SELECT with FOR UPDATE or LOCK IN SHARE MODE),\n  InnoDB locks only index records, not the gaps before them, and thus\n  permits the free insertion of new records next to locked records. For\n  UPDATE and DELETE statements, locking depends on whether the\n  statement uses a unique index with a unique search condition (such as\n  WHERE id = 100), or a range-type search condition (such as WHERE id >\n  100). For a unique index with a unique search condition, InnoDB locks\n  only the index record found, not the gap before it. For range-type\n  searches, InnoDB locks the index range scanned, using gap locks or\n  next-key (gap plus index-record) locks to block insertions by other\n  sessions into the gaps covered by the range. This is necessary\n  because \"phantom rows\" must be blocked for MySQL replication and\n  recovery to work.\n\n  *Note*: In MySQL 5.1, if the READ COMMITTED isolation level is used\n  or the innodb_locks_unsafe_for_binlog system variable is enabled,\n  there is no InnoDB gap locking except for foreign-key constraint\n  checking and duplicate-key checking. Also, record locks for\n  nonmatching rows are released after MySQL has evaluated the WHERE\n  condition. As of MySQL 5.1, if you use READ COMMITTED or enable\n  innodb_locks_unsafe_for_binlog, you must use row-based binary\n  logging.\n\no READ UNCOMMITTED\n\n  SELECT statements are performed in a nonlocking fashion, but a\n  possible earlier version of a row might be used. Thus, using this\n  isolation level, such reads are not consistent. This is also called a\n  \"dirty read.\" Otherwise, this isolation level works like READ\n  COMMITTED.\n\no SERIALIZABLE\n\n  This level is like REPEATABLE READ, but InnoDB implicitly converts\n  all plain SELECT statements to SELECT ... LOCK IN SHARE MODE if\n  autocommit is disabled. If autocommit is enabled, the SELECT is its\n  own transaction. It therefore is known to be read only and can be\n  serialized if performed as a consistent (nonlocking) read and need\n  not block for other transactions. (To force a plain SELECT to block\n  if other transactions have modified the selected rows, disable\n  autocommit.)\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/set-transaction.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/set-transaction.html'),(448,'CEILING',4,'Syntax:\nCEILING(X)\n\nReturns the smallest integer value not less than X.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT CEILING(1.23);\n        -> 2\nmysql> SELECT CEILING(-1.23);\n        -> -1\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(449,'SIN',4,'Syntax:\nSIN(X)\n\nReturns the sine of X, where X is given in radians.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT SIN(PI());\n        -> 1.2246063538224e-16\nmysql> SELECT ROUND(SIN(PI()));\n        -> 0\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(450,'DAYOFWEEK',31,'Syntax:\nDAYOFWEEK(date)\n\nReturns the weekday index for date (1 = Sunday, 2 = Monday, ..., 7 =\nSaturday). These index values correspond to the ODBC standard.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT DAYOFWEEK(\'2007-02-03\');\n        -> 7\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(451,'SHOW PROCESSLIST',26,'Syntax:\nSHOW [FULL] PROCESSLIST\n\nSHOW PROCESSLIST shows you which threads are running. You can also get\nthis information from the INFORMATION_SCHEMA PROCESSLIST table or the\nmysqladmin processlist command. If you have the PROCESS privilege, you\ncan see all threads. Otherwise, you can see only your own threads (that\nis, threads associated with the MySQL account that you are using). If\nyou do not use the FULL keyword, only the first 100 characters of each\nstatement are shown in the Info field.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-processlist.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-processlist.html'),(452,'LINEFROMWKB',32,'LineFromWKB(wkb[,srid]), LineStringFromWKB(wkb[,srid])\n\nConstructs a LINESTRING value using its WKB representation and SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkb-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkb-functions'),(453,'GEOMETRYTYPE',35,'GeometryType(g)\n\nReturns as a binary string the name of the geometry type of which the\ngeometry instance g is a member. The name corresponds to one of the\ninstantiable Geometry subclasses.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#general-geometry-property-functions\n\n','mysql> SELECT GeometryType(GeomFromText(\'POINT(1 1)\'));\n+------------------------------------------+\n| GeometryType(GeomFromText(\'POINT(1 1)\')) |\n+------------------------------------------+\n| POINT                                    |\n+------------------------------------------+\n','http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#general-geometry-property-functions'),(454,'CREATE VIEW',38,'Syntax:\nCREATE\n    [OR REPLACE]\n    [ALGORITHM = {UNDEFINED | MERGE | TEMPTABLE}]\n    [DEFINER = { user | CURRENT_USER }]\n    [SQL SECURITY { DEFINER | INVOKER }]\n    VIEW view_name [(column_list)]\n    AS select_statement\n    [WITH [CASCADED | LOCAL] CHECK OPTION]\n\nThe CREATE VIEW statement creates a new view, or replaces an existing\none if the OR REPLACE clause is given. If the view does not exist,\nCREATE OR REPLACE VIEW is the same as CREATE VIEW. If the view does\nexist, CREATE OR REPLACE VIEW is the same as ALTER VIEW.\n\nThe select_statement is a SELECT statement that provides the definition\nof the view. (When you select from the view, you select in effect using\nthe SELECT statement.) select_statement can select from base tables or\nother views.\n\nThe view definition is \"frozen\" at creation time, so changes to the\nunderlying tables afterward do not affect the view definition. For\nexample, if a view is defined as SELECT * on a table, new columns added\nto the table later do not become part of the view.\n\nThe ALGORITHM clause affects how MySQL processes the view. The DEFINER\nand SQL SECURITY clauses specify the security context to be used when\nchecking access privileges at view invocation time. The WITH CHECK\nOPTION clause can be given to constrain inserts or updates to rows in\ntables referenced by the view. These clauses are described later in\nthis section.\n\nThe CREATE VIEW statement requires the CREATE VIEW privilege for the\nview, and some privilege for each column selected by the SELECT\nstatement. For columns used elsewhere in the SELECT statement you must\nhave the SELECT privilege. If the OR REPLACE clause is present, you\nmust also have the DROP privilege for the view. CREATE VIEW might also\nrequire the SUPER privilege, depending on the DEFINER value, as\ndescribed later in this section.\n\nWhen a view is referenced, privilege checking occurs as described later\nin this section.\n\nA view belongs to a database. By default, a new view is created in the\ndefault database. To create the view explicitly in a given database,\nspecify the name as db_name.view_name when you create it:\n\nmysql> CREATE VIEW test.v AS SELECT * FROM t;\n\nWithin a database, base tables and views share the same namespace, so a\nbase table and a view cannot have the same name.\n\nColumns retrieved by the SELECT statement can be simple references to\ntable columns. They can also be expressions that use functions,\nconstant values, operators, and so forth.\n\nViews must have unique column names with no duplicates, just like base\ntables. By default, the names of the columns retrieved by the SELECT\nstatement are used for the view column names. To define explicit names\nfor the view columns, the optional column_list clause can be given as a\nlist of comma-separated identifiers. The number of names in column_list\nmust be the same as the number of columns retrieved by the SELECT\nstatement.\n\n*Note*: Prior to MySQL 5.1.29, when you modify an existing view, the\nserver saves a backup of the current view definition under the view\ndatabase directory, in a subdirectory named arc. The backup file for a\nview v is named v.frm-00001. If you alter the view again, the next\nbackup is named v.frm-00002. The three latest view backup definitions\nare stored. Backed up view definitions are not preserved by mysqldump,\nor any other such programs, but you can retain them using a file copy\noperation. However, they are not needed for anything but to provide you\nwith a backup of your previous view definition. It is safe to remove\nthese backup definitions, but only while mysqld is not running. If you\ndelete the arc subdirectory or its files while mysqld is running, an\nerror occurs the next time you try to alter the view: mysql> ALTER VIEW\nv AS SELECT * FROM t; ERROR 6 (HY000): Error on delete of\n\'.\\test\\arc/v.frm-0004\' (Errcode: 2)\n\nUnqualified table or view names in the SELECT statement are interpreted\nwith respect to the default database. A view can refer to tables or\nviews in other databases by qualifying the table or view name with the\nproper database name.\n\nA view can be created from many kinds of SELECT statements. It can\nrefer to base tables or other views. It can use joins, UNION, and\nsubqueries. The SELECT need not even refer to any tables. The following\nexample defines a view that selects two columns from another table, as\nwell as an expression calculated from those columns:\n\nmysql> CREATE TABLE t (qty INT, price INT);\nmysql> INSERT INTO t VALUES(3, 50);\nmysql> CREATE VIEW v AS SELECT qty, price, qty*price AS value FROM t;\nmysql> SELECT * FROM v;\n+------+-------+-------+\n| qty  | price | value |\n+------+-------+-------+\n|    3 |    50 |   150 |\n+------+-------+-------+\n\nA view definition is subject to the following restrictions:\n\no The SELECT statement cannot contain a subquery in the FROM clause.\n\no The SELECT statement cannot refer to system or user variables.\n\no Within a stored program, the definition cannot refer to program\n  parameters or local variables.\n\no The SELECT statement cannot refer to prepared statement parameters.\n\no Any table or view referred to in the definition must exist. However,\n  after a view has been created, it is possible to drop a table or view\n  that the definition refers to. In this case, use of the view results\n  in an error. To check a view definition for problems of this kind,\n  use the CHECK TABLE statement.\n\no The definition cannot refer to a TEMPORARY table, and you cannot\n  create a TEMPORARY view.\n\no Any tables named in the view definition must exist at definition\n  time.\n\no You cannot associate a trigger with a view.\n\no As of MySQL 5.1.23, aliases for column names in the SELECT statement\n  are checked against the maximum column length of 64 characters (not\n  the maximum alias length of 256 characters).\n\nORDER BY is permitted in a view definition, but it is ignored if you\nselect from a view using a statement that has its own ORDER BY.\n\nFor other options or clauses in the definition, they are added to the\noptions or clauses of the statement that references the view, but the\neffect is undefined. For example, if a view definition includes a LIMIT\nclause, and you select from the view using a statement that has its own\nLIMIT clause, it is undefined which limit applies. This same principle\napplies to options such as ALL, DISTINCT, or SQL_SMALL_RESULT that\nfollow the SELECT keyword, and to clauses such as INTO, FOR UPDATE,\nLOCK IN SHARE MODE, and PROCEDURE.\n\nIf you create a view and then change the query processing environment\nby changing system variables, that may affect the results that you get\nfrom the view:\n\nmysql> CREATE VIEW v (mycol) AS SELECT \'abc\';\nQuery OK, 0 rows affected (0.01 sec)\n\nmysql> SET sql_mode = \'\';\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT \"mycol\" FROM v;\n+-------+\n| mycol |\n+-------+\n| mycol |\n+-------+\n1 row in set (0.01 sec)\n\nmysql> SET sql_mode = \'ANSI_QUOTES\';\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SELECT \"mycol\" FROM v;\n+-------+\n| mycol |\n+-------+\n| abc   |\n+-------+\n1 row in set (0.00 sec)\n\nThe DEFINER and SQL SECURITY clauses determine which MySQL account to\nuse when checking access privileges for the view when a statement is\nexecuted that references the view. These clauses were added in MySQL\n5.1.2. The legal SQL SECURITY characteristic values are DEFINER and\nINVOKER. These indicate that the required privileges must be held by\nthe user who defined or invoked the view, respectively. The default SQL\nSECURITY value is DEFINER.\n\nIf a user value is given for the DEFINER clause, it should be a MySQL\naccount specified as \'user_name\'@\'host_name\' (the same format used in\nthe GRANT statement), CURRENT_USER, or CURRENT_USER(). The default\nDEFINER value is the user who executes the CREATE VIEW statement. This\nis the same as specifying DEFINER = CURRENT_USER explicitly.\n\nIf you specify the DEFINER clause, these rules determine the legal\nDEFINER user values:\n\no If you do not have the SUPER privilege, the only legal user value is\n  your own account, either specified literally or by using\n  CURRENT_USER. You cannot set the definer to some other account.\n\no If you have the SUPER privilege, you can specify any syntactically\n  legal account name. If the account does not actually exist, a warning\n  is generated.\n\no Although it is possible to create a view with a nonexistent DEFINER\n  account, an error occurs when the view is referenced if the SQL\n  SECURITY value is DEFINER but the definer account does not exist.\n\nFor more information about view security, see\nhttp://dev.mysql.com/doc/refman/5.1/en/stored-programs-security.html.\n\nWithin a view definition, CURRENT_USER returns the view\'s DEFINER value\nby default as of MySQL 5.1.12. For older versions, and for views\ndefined with the SQL SECURITY INVOKER characteristic, CURRENT_USER\nreturns the account for the view\'s invoker. For information about user\nauditing within views, see\nhttp://dev.mysql.com/doc/refman/5.1/en/account-activity-auditing.html.\n\nWithin a stored routine that is defined with the SQL SECURITY DEFINER\ncharacteristic, CURRENT_USER returns the routine\'s DEFINER value. This\nalso affects a view defined within such a routine, if the view\ndefinition contains a DEFINER value of CURRENT_USER.\n\nAs of MySQL 5.1.2 (when the DEFINER and SQL SECURITY clauses were\nimplemented), view privileges are checked like this:\n\no At view definition time, the view creator must have the privileges\n  needed to use the top-level objects accessed by the view. For\n  example, if the view definition refers to table columns, the creator\n  must have some privilege for each column in the select list of the\n  definition, and the SELECT privilege for each column used elsewhere\n  in the definition. If the definition refers to a stored function,\n  only the privileges needed to invoke the function can be checked. The\n  privileges required at function invocation time can be checked only\n  as it executes: For different invocations, different execution paths\n  within the function might be taken.\n\no The user who references a view must have appropriate privileges to\n  access it (SELECT to select from it, INSERT to insert into it, and so\n  forth.)\n\no When a view has been referenced, privileges for objects accessed by\n  the view are checked against the privileges held by the view DEFINER\n  account or invoker, depending on whether the SQL SECURITY\n  characteristic is DEFINER or INVOKER, respectively.\n\no If reference to a view causes execution of a stored function,\n  privilege checking for statements executed within the function depend\n  on whether the function SQL SECURITY characteristic is DEFINER or\n  INVOKER. If the security characteristic is DEFINER, the function runs\n  with the privileges of the DEFINER account. If the characteristic is\n  INVOKER, the function runs with the privileges determined by the\n  view\'s SQL SECURITY characteristic.\n\nPrior to MySQL 5.1.2 (before the DEFINER and SQL SECURITY clauses were\nimplemented), privileges required for objects used in a view are\nchecked at view creation time.\n\nExample: A view might depend on a stored function, and that function\nmight invoke other stored routines. For example, the following view\ninvokes a stored function f():\n\nCREATE VIEW v AS SELECT * FROM t WHERE t.id = f(t.name);\n\nSuppose that f() contains a statement such as this:\n\nIF name IS NULL then\n  CALL p1();\nELSE\n  CALL p2();\nEND IF;\n\nThe privileges required for executing statements within f() need to be\nchecked when f() executes. This might mean that privileges are needed\nfor p1() or p2(), depending on the execution path within f(). Those\nprivileges must be checked at runtime, and the user who must possess\nthe privileges is determined by the SQL SECURITY values of the view v\nand the function f().\n\nThe DEFINER and SQL SECURITY clauses for views are extensions to\nstandard SQL. In standard SQL, views are handled using the rules for\nSQL SECURITY DEFINER. The standard says that the definer of the view,\nwhich is the same as the owner of the view\'s schema, gets applicable\nprivileges on the view (for example, SELECT) and may grant them. MySQL\nhas no concept of a schema \"owner\", so MySQL adds a clause to identify\nthe definer. The DEFINER clause is an extension where the intent is to\nhave what the standard has; that is, a permanent record of who defined\nthe view. This is why the default DEFINER value is the account of the\nview creator.\n\nIf you invoke a view that was created before MySQL 5.1.2, it is treated\nas though it was created with a SQL SECURITY DEFINER characteristic and\nwith a DEFINER value that is the same as your account. However, because\nthe actual definer is unknown, MySQL issues a warning. To eliminate the\nwarning, it is sufficient to re-create the view so that the view\ndefinition includes a DEFINER clause.\n\nThe optional ALGORITHM clause is a MySQL extension to standard SQL. It\naffects how MySQL processes the view. ALGORITHM takes three values:\nMERGE, TEMPTABLE, or UNDEFINED. The default algorithm is UNDEFINED if\nno ALGORITHM clause is present. For more information, see\nhttp://dev.mysql.com/doc/refman/5.1/en/view-algorithms.html.\n\nSome views are updatable. That is, you can use them in statements such\nas UPDATE, DELETE, or INSERT to update the contents of the underlying\ntable. For a view to be updatable, there must be a one-to-one\nrelationship between the rows in the view and the rows in the\nunderlying table. There are also certain other constructs that make a\nview nonupdatable.\n\nThe WITH CHECK OPTION clause can be given for an updatable view to\nprevent inserts or updates to rows except those for which the WHERE\nclause in the select_statement is true.\n\nIn a WITH CHECK OPTION clause for an updatable view, the LOCAL and\nCASCADED keywords determine the scope of check testing when the view is\ndefined in terms of another view. The LOCAL keyword restricts the CHECK\nOPTION only to the view being defined. CASCADED causes the checks for\nunderlying views to be evaluated as well. When neither keyword is\ngiven, the default is CASCADED.\n\nFor more information about updatable views and the WITH CHECK OPTION\nclause, see\nhttp://dev.mysql.com/doc/refman/5.1/en/view-updatability.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/create-view.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/create-view.html'),(455,'TRIM',36,'Syntax:\nTRIM([{BOTH | LEADING | TRAILING} [remstr] FROM] str), TRIM([remstr\nFROM] str)\n\nReturns the string str with all remstr prefixes or suffixes removed. If\nnone of the specifiers BOTH, LEADING, or TRAILING is given, BOTH is\nassumed. remstr is optional and, if not specified, spaces are removed.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT TRIM(\'  bar   \');\n        -> \'bar\'\nmysql> SELECT TRIM(LEADING \'x\' FROM \'xxxbarxxx\');\n        -> \'barxxx\'\nmysql> SELECT TRIM(BOTH \'x\' FROM \'xxxbarxxx\');\n        -> \'bar\'\nmysql> SELECT TRIM(TRAILING \'xyz\' FROM \'barxxyz\');\n        -> \'barx\'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(456,'IS',18,'Syntax:\nIS boolean_value\n\nTests a value against a boolean value, where boolean_value can be TRUE,\nFALSE, or UNKNOWN.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html\n\n','mysql> SELECT 1 IS TRUE, 0 IS FALSE, NULL IS UNKNOWN;\n        -> 1, 1, 1\n','http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html'),(457,'GET_FORMAT',31,'Syntax:\nGET_FORMAT({DATE|TIME|DATETIME}, {\'EUR\'|\'USA\'|\'JIS\'|\'ISO\'|\'INTERNAL\'})\n\nReturns a format string. This function is useful in combination with\nthe DATE_FORMAT() and the STR_TO_DATE() functions.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT DATE_FORMAT(\'2003-10-03\',GET_FORMAT(DATE,\'EUR\'));\n        -> \'03.10.2003\'\nmysql> SELECT STR_TO_DATE(\'10.31.2003\',GET_FORMAT(DATE,\'USA\'));\n        -> \'2003-10-31\'\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(458,'TINYBLOB',22,'TINYBLOB\n\nA BLOB column with a maximum length of 255 (28 - 1) bytes. Each\nTINYBLOB value is stored using a one-byte length prefix that indicates\nthe number of bytes in the value.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html'),(459,'SAVEPOINT',8,'Syntax:\nSAVEPOINT identifier\nROLLBACK [WORK] TO [SAVEPOINT] identifier\nRELEASE SAVEPOINT identifier\n\nInnoDB supports the SQL statements SAVEPOINT, ROLLBACK TO SAVEPOINT,\nRELEASE SAVEPOINT and the optional WORK keyword for ROLLBACK.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/savepoint.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/savepoint.html'),(460,'USER',17,'Syntax:\nUSER()\n\nReturns the current MySQL user name and host name as a string in the\nutf8 character set.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/information-functions.html\n\n','mysql> SELECT USER();\n        -> \'davida@localhost\'\n','http://dev.mysql.com/doc/refman/5.1/en/information-functions.html'),(461,'LABELS',23,'Syntax:\n[begin_label:] BEGIN\n    [statement_list]\nEND [end_label]\n\n[begin_label:] LOOP\n    statement_list\nEND LOOP [end_label]\n\n[begin_label:] REPEAT\n    statement_list\nUNTIL search_condition\nEND REPEAT [end_label]\n\n[begin_label:] WHILE search_condition DO\n    statement_list\nEND WHILE [end_label]\n\nLabels are permitted for BEGIN ... END blocks and for the LOOP, REPEAT,\nand WHILE statements. Label use for those statements follows these\nrules:\n\no begin_label must be followed by a colon.\n\no begin_label can be given without end_label. If end_label is present,\n  it must be the same as begin_label.\n\no end_label cannot be given without begin_label.\n\no Labels at the same nesting level must be distinct.\n\no Labels can be up to 16 characters long.\n\nTo refer to a label within the labeled construct, use an ITERATE or\nLEAVE statement. The following example uses those statements to\ncontinue iterating or terminate the loop:\n\nCREATE PROCEDURE doiterate(p1 INT)\nBEGIN\n  label1: LOOP\n    SET p1 = p1 + 1;\n    IF p1 < 10 THEN ITERATE label1; END IF;\n    LEAVE label1;\n  END LOOP label1;\nEND;\n\nThe scope of a block label does not include the code for handlers\ndeclared within the block. For details, see [HELP DECLARE HANDLER].\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/statement-labels.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/statement-labels.html'),(462,'ALTER TABLE',38,'Syntax:\nALTER [ONLINE | OFFLINE] [IGNORE] TABLE tbl_name\n    [alter_specification [, alter_specification] ...]\n    [partition_options]\n\nALTER [ONLINE | OFFLINE] [IGNORE] TABLE tbl_name\n    partition_options\n\nalter_specification:\n    table_options\n  | ADD [COLUMN] col_name column_definition\n        [FIRST | AFTER col_name ]\n  | ADD [COLUMN] (col_name column_definition,...)\n  | ADD {INDEX|KEY} [index_name]\n        [index_type] (index_col_name,...) [index_option] ...\n  | ADD [CONSTRAINT [symbol]] PRIMARY KEY\n        [index_type] (index_col_name,...) [index_option] ...\n  | ADD [CONSTRAINT [symbol]]\n        UNIQUE [INDEX|KEY] [index_name]\n        [index_type] (index_col_name,...) [index_option] ...\n  | ADD FULLTEXT [INDEX|KEY] [index_name]\n        (index_col_name,...) [index_option] ...\n  | ADD SPATIAL [INDEX|KEY] [index_name]\n        (index_col_name,...) [index_option] ...\n  | ADD [CONSTRAINT [symbol]]\n        FOREIGN KEY [index_name] (index_col_name,...)\n        reference_definition\n  | ALTER [COLUMN] col_name {SET DEFAULT literal | DROP DEFAULT}\n  | CHANGE [COLUMN] old_col_name new_col_name column_definition\n        [FIRST|AFTER col_name]\n  | MODIFY [COLUMN] col_name column_definition\n        [FIRST | AFTER col_name]\n  | DROP [COLUMN] col_name\n  | DROP PRIMARY KEY\n  | DROP {INDEX|KEY} index_name\n  | DROP FOREIGN KEY fk_symbol\n  | MAX_ROWS = rows\n  | DISABLE KEYS\n  | ENABLE KEYS\n  | RENAME [TO] new_tbl_name\n  | ORDER BY col_name [, col_name] ...\n  | CONVERT TO CHARACTER SET charset_name [COLLATE collation_name]\n  | [DEFAULT] CHARACTER SET [=] charset_name [COLLATE [=] collation_name]\n  | DISCARD TABLESPACE\n  | IMPORT TABLESPACE\n  | ADD PARTITION (partition_definition)\n  | DROP PARTITION partition_names\n  | COALESCE PARTITION number\n  | REORGANIZE PARTITION [partition_names INTO (partition_definitions)]\n  | ANALYZE PARTITION  {partition_names | ALL }\n  | CHECK PARTITION  {partition_names | ALL }\n  | OPTIMIZE PARTITION  {partition_names | ALL }\n  | REBUILD PARTITION  {partition_names | ALL }\n  | REPAIR PARTITION  {partition_names | ALL }\n  | PARTITION BY partitioning_expression\n  | REMOVE PARTITIONING\n\nindex_col_name:\n    col_name [(length)] [ASC | DESC]\n\nindex_type:\n    USING {BTREE | HASH}\n\nindex_option:\n    KEY_BLOCK_SIZE [=] value\n  | index_type\n  | WITH PARSER parser_name\n\ntable_options:\n    table_option [[,] table_option] ...  (see CREATE TABLE options)\n\npartition_options:\n    (see CREATE TABLE options)\n\nALTER TABLE changes the structure of a table. For example, you can add\nor delete columns, create or destroy indexes, change the type of\nexisting columns, or rename columns or the table itself. You can also\nchange characteristics such as the storage engine used for the table or\nthe table comment.\n\nA number of partitioning-related extensions to ALTER TABLE were added\nin MySQL 5.1.5. These can be used with partitioned tables for\nrepartitioning, for adding, dropping, merging, and splitting\npartitions, and for performing partitioning maintenance. For more\ninformation, see\nhttp://dev.mysql.com/doc/refman/5.1/en/alter-table-partition-operations\n.html.\n\nFollowing the table name, specify the alterations to be made. If none\nare given, ALTER TABLE does nothing.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/alter-table.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/alter-table.html'),(463,'MPOINTFROMWKB',32,'MPointFromWKB(wkb[,srid]), MultiPointFromWKB(wkb[,srid])\n\nConstructs a MULTIPOINT value using its WKB representation and SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkb-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkb-functions'),(464,'CHAR BYTE',22,'The CHAR BYTE data type is an alias for the BINARY data type. This is a\ncompatibility feature.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html'),(465,'REPAIR TABLE',20,'Syntax:\nREPAIR [NO_WRITE_TO_BINLOG | LOCAL] TABLE\n    tbl_name [, tbl_name] ...\n    [QUICK] [EXTENDED] [USE_FRM]\n\nREPAIR TABLE repairs a possibly corrupted table. By default, it has the\nsame effect as myisamchk --recover tbl_name. REPAIR TABLE works for\nMyISAM and for ARCHIVE tables. Starting with MySQL 5.1.9, REPAIR is\nalso valid for CSV tables. See\nhttp://dev.mysql.com/doc/refman/5.1/en/myisam-storage-engine.html, and\nhttp://dev.mysql.com/doc/refman/5.1/en/archive-storage-engine.html, and\nhttp://dev.mysql.com/doc/refman/5.1/en/csv-storage-engine.html\n\nThis statement requires SELECT and INSERT privileges for the table.\n\nBeginning with MySQL 5.1.27, REPAIR TABLE is also supported for\npartitioned tables. However, the USE_FRM option cannot be used with\nthis statement on a partitioned table.\n\nAlso beginning with MySQL 5.1.27, you can use ALTER TABLE ... REPAIR\nPARTITION to repair one or more partitions; for more information, see\n[HELP ALTER TABLE], and\nhttp://dev.mysql.com/doc/refman/5.1/en/partitioning-maintenance.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/repair-table.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/repair-table.html'),(466,'MERGE',38,'The MERGE storage engine, also known as the MRG_MyISAM engine, is a\ncollection of identical MyISAM tables that can be used as one.\n\"Identical\" means that all tables have identical column and index\ninformation. You cannot merge MyISAM tables in which the columns are\nlisted in a different order, do not have exactly the same columns, or\nhave the indexes in different order. However, any or all of the MyISAM\ntables can be compressed with myisampack. See\nhttp://dev.mysql.com/doc/refman/5.1/en/myisampack.html. Differences in\ntable options such as AVG_ROW_LENGTH, MAX_ROWS, or PACK_KEYS do not\nmatter.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/merge-storage-engine.html\n\n','mysql> CREATE TABLE t1 (\n    ->    a INT NOT NULL AUTO_INCREMENT PRIMARY KEY,\n    ->    message CHAR(20)) ENGINE=MyISAM;\nmysql> CREATE TABLE t2 (\n    ->    a INT NOT NULL AUTO_INCREMENT PRIMARY KEY,\n    ->    message CHAR(20)) ENGINE=MyISAM;\nmysql> INSERT INTO t1 (message) VALUES (\'Testing\'),(\'table\'),(\'t1\');\nmysql> INSERT INTO t2 (message) VALUES (\'Testing\'),(\'table\'),(\'t2\');\nmysql> CREATE TABLE total (\n    ->    a INT NOT NULL AUTO_INCREMENT,\n    ->    message CHAR(20), INDEX(a))\n    ->    ENGINE=MERGE UNION=(t1,t2) INSERT_METHOD=LAST;\n','http://dev.mysql.com/doc/refman/5.1/en/merge-storage-engine.html'),(467,'CREATE TABLE',38,'Syntax:\nCREATE [TEMPORARY] TABLE [IF NOT EXISTS] tbl_name\n    (create_definition,...)\n    [table_options]\n    [partition_options]\n\nOr:\n\nCREATE [TEMPORARY] TABLE [IF NOT EXISTS] tbl_name\n    [(create_definition,...)]\n    [table_options]\n    [partition_options]\n    select_statement\n\nOr:\n\nCREATE [TEMPORARY] TABLE [IF NOT EXISTS] tbl_name\n    { LIKE old_tbl_name | (LIKE old_tbl_name) }\n\ncreate_definition:\n    col_name column_definition\n  | [CONSTRAINT [symbol]] PRIMARY KEY [index_type] (index_col_name,...)\n      [index_option] ...\n  | {INDEX|KEY} [index_name] [index_type] (index_col_name,...)\n      [index_option] ...\n  | [CONSTRAINT [symbol]] UNIQUE [INDEX|KEY]\n      [index_name] [index_type] (index_col_name,...)\n      [index_option] ...\n  | {FULLTEXT|SPATIAL} [INDEX|KEY] [index_name] (index_col_name,...)\n      [index_option] ...\n  | [CONSTRAINT [symbol]] FOREIGN KEY\n      [index_name] (index_col_name,...) reference_definition\n  | CHECK (expr)\n\ncolumn_definition:\n    data_type [NOT NULL | NULL] [DEFAULT default_value]\n      [AUTO_INCREMENT] [UNIQUE [KEY] | [PRIMARY] KEY]\n      [COMMENT \'string\']\n      [COLUMN_FORMAT {FIXED|DYNAMIC|DEFAULT}]\n      [STORAGE {DISK|MEMORY|DEFAULT}]\n      [reference_definition]\n\ndata_type:\n    BIT[(length)]\n  | TINYINT[(length)] [UNSIGNED] [ZEROFILL]\n  | SMALLINT[(length)] [UNSIGNED] [ZEROFILL]\n  | MEDIUMINT[(length)] [UNSIGNED] [ZEROFILL]\n  | INT[(length)] [UNSIGNED] [ZEROFILL]\n  | INTEGER[(length)] [UNSIGNED] [ZEROFILL]\n  | BIGINT[(length)] [UNSIGNED] [ZEROFILL]\n  | REAL[(length,decimals)] [UNSIGNED] [ZEROFILL]\n  | DOUBLE[(length,decimals)] [UNSIGNED] [ZEROFILL]\n  | FLOAT[(length,decimals)] [UNSIGNED] [ZEROFILL]\n  | DECIMAL[(length[,decimals])] [UNSIGNED] [ZEROFILL]\n  | NUMERIC[(length[,decimals])] [UNSIGNED] [ZEROFILL]\n  | DATE\n  | TIME\n  | TIMESTAMP\n  | DATETIME\n  | YEAR\n  | CHAR[(length)]\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | VARCHAR(length)\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | BINARY[(length)]\n  | VARBINARY(length)\n  | TINYBLOB\n  | BLOB\n  | MEDIUMBLOB\n  | LONGBLOB\n  | TINYTEXT [BINARY]\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | TEXT [BINARY]\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | MEDIUMTEXT [BINARY]\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | LONGTEXT [BINARY]\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | ENUM(value1,value2,value3,...)\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | SET(value1,value2,value3,...)\n      [CHARACTER SET charset_name] [COLLATE collation_name]\n  | spatial_type\n\nindex_col_name:\n    col_name [(length)] [ASC | DESC]\n\nindex_type:\n    USING {BTREE | HASH}\n\nindex_option:\n    KEY_BLOCK_SIZE [=] value\n  | index_type\n  | WITH PARSER parser_name\n\nreference_definition:\n    REFERENCES tbl_name (index_col_name,...)\n      [MATCH FULL | MATCH PARTIAL | MATCH SIMPLE]\n      [ON DELETE reference_option]\n      [ON UPDATE reference_option]\n\nreference_option:\n    RESTRICT | CASCADE | SET NULL | NO ACTION\n\ntable_options:\n    table_option [[,] table_option] ...\n\ntable_option:\n    ENGINE [=] engine_name\n  | AUTO_INCREMENT [=] value\n  | AVG_ROW_LENGTH [=] value\n  | [DEFAULT] CHARACTER SET [=] charset_name\n  | CHECKSUM [=] {0 | 1}\n  | [DEFAULT] COLLATE [=] collation_name\n  | COMMENT [=] \'string\'\n  | CONNECTION [=] \'connect_string\'\n  | DATA DIRECTORY [=] \'absolute path to directory\'\n  | DELAY_KEY_WRITE [=] {0 | 1}\n  | INDEX DIRECTORY [=] \'absolute path to directory\'\n  | INSERT_METHOD [=] { NO | FIRST | LAST }\n  | KEY_BLOCK_SIZE [=] value\n  | MAX_ROWS [=] value\n  | MIN_ROWS [=] value\n  | PACK_KEYS [=] {0 | 1 | DEFAULT}\n  | PASSWORD [=] \'string\'\n  | ROW_FORMAT [=] {DEFAULT|DYNAMIC|FIXED|COMPRESSED|REDUNDANT|COMPACT}\n  | TABLESPACE tablespace_name [STORAGE {DISK|MEMORY|DEFAULT}]\n  | UNION [=] (tbl_name[,tbl_name]...)\n\npartition_options:\n    PARTITION BY\n        { [LINEAR] HASH(expr)\n        | [LINEAR] KEY(column_list)\n        | RANGE(expr)\n        | LIST(expr) }\n    [PARTITIONS num]\n    [SUBPARTITION BY\n        { [LINEAR] HASH(expr)\n        | [LINEAR] KEY(column_list) }\n      [SUBPARTITIONS num]\n    ]\n    [(partition_definition [, partition_definition] ...)]\n\npartition_definition:\n    PARTITION partition_name\n        [VALUES \n            {LESS THAN {(expr) | MAXVALUE} \n            | \n            IN (value_list)}]\n        [[STORAGE] ENGINE [=] engine_name]\n        [COMMENT [=] \'comment_text\' ]\n        [DATA DIRECTORY [=] \'data_dir\']\n        [INDEX DIRECTORY [=] \'index_dir\']\n        [MAX_ROWS [=] max_number_of_rows]\n        [MIN_ROWS [=] min_number_of_rows]\n        [TABLESPACE [=] tablespace_name]\n        [NODEGROUP [=] node_group_id]\n        [(subpartition_definition [, subpartition_definition] ...)]\n\nsubpartition_definition:\n    SUBPARTITION logical_name\n        [[STORAGE] ENGINE [=] engine_name]\n        [COMMENT [=] \'comment_text\' ]\n        [DATA DIRECTORY [=] \'data_dir\']\n        [INDEX DIRECTORY [=] \'index_dir\']\n        [MAX_ROWS [=] max_number_of_rows]\n        [MIN_ROWS [=] min_number_of_rows]\n        [TABLESPACE [=] tablespace_name]\n        [NODEGROUP [=] node_group_id]\n\nselect_statement:\n    [IGNORE | REPLACE] [AS] SELECT ...   (Some legal select statement)\n\nCREATE TABLE creates a table with the given name. You must have the\nCREATE privilege for the table.\n\nRules for permissible table names are given in\nhttp://dev.mysql.com/doc/refman/5.1/en/identifiers.html. By default,\nthe table is created in the default database. An error occurs if the\ntable exists, if there is no default database, or if the database does\nnot exist.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/create-table.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/create-table.html'),(468,'>',18,'Syntax:\n>\n\nGreater than:\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html\n\n','mysql> SELECT 2 > 2;\n        -> 0\n','http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html'),(469,'ANALYZE TABLE',20,'Syntax:\nANALYZE [NO_WRITE_TO_BINLOG | LOCAL] TABLE\n    tbl_name [, tbl_name] ...\n\nANALYZE TABLE analyzes and stores the key distribution for a table.\nDuring the analysis, the table is locked with a read lock for InnoDB\nand MyISAM. This statement works with InnoDB, NDB, and MyISAM tables.\nFor MyISAM tables, this statement is equivalent to using myisamchk\n--analyze.\n\nFor more information on how the analysis works within InnoDB, see\nhttp://dev.mysql.com/doc/refman/5.1/en/innodb-restrictions.html.\n\nMySQL uses the stored key distribution to decide the order in which\ntables should be joined when you perform a join on something other than\na constant. In addition, key distributions can be used when deciding\nwhich indexes to use for a specific table within a query.\n\nThis statement requires SELECT and INSERT privileges for the table.\n\nBeginning with MySQL 5.1.27, ANALYZE TABLE is also supported for\npartitioned tables. Also beginning with MySQL 5.1.27, you can use ALTER\nTABLE ... ANALYZE PARTITION to analyze one or more partitions; for more\ninformation, see [HELP ALTER TABLE], and\nhttp://dev.mysql.com/doc/refman/5.1/en/partitioning-maintenance.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/analyze-table.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/analyze-table.html'),(470,'MICROSECOND',31,'Syntax:\nMICROSECOND(expr)\n\nReturns the microseconds from the time or datetime expression expr as a\nnumber in the range from 0 to 999999.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT MICROSECOND(\'12:00:00.123456\');\n        -> 123456\nmysql> SELECT MICROSECOND(\'2009-12-31 23:59:59.000010\');\n        -> 10\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(471,'CONSTRAINT',38,'InnoDB supports foreign key constraints. The syntax for a foreign key\nconstraint definition in InnoDB looks like this:\n\n[CONSTRAINT [symbol]] FOREIGN KEY\n    [index_name] (index_col_name, ...)\n    REFERENCES tbl_name (index_col_name,...)\n    [ON DELETE reference_option]\n    [ON UPDATE reference_option]\n\nreference_option:\n    RESTRICT | CASCADE | SET NULL | NO ACTION\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/innodb-foreign-key-constraints.html\n\n','CREATE TABLE product (category INT NOT NULL, id INT NOT NULL,\n                      price DECIMAL,\n                      PRIMARY KEY(category, id)) ENGINE=INNODB;\nCREATE TABLE customer (id INT NOT NULL,\n                       PRIMARY KEY (id)) ENGINE=INNODB;\nCREATE TABLE product_order (no INT NOT NULL AUTO_INCREMENT,\n                            product_category INT NOT NULL,\n                            product_id INT NOT NULL,\n                            customer_id INT NOT NULL,\n                            PRIMARY KEY(no),\n                            INDEX (product_category, product_id),\n                            FOREIGN KEY (product_category, product_id)\n                              REFERENCES product(category, id)\n                              ON UPDATE CASCADE ON DELETE RESTRICT,\n                            INDEX (customer_id),\n                            FOREIGN KEY (customer_id)\n                              REFERENCES customer(id)) ENGINE=INNODB;\n','http://dev.mysql.com/doc/refman/5.1/en/innodb-foreign-key-constraints.html'),(472,'CREATE SERVER',38,'Syntax:\nCREATE SERVER server_name\n    FOREIGN DATA WRAPPER wrapper_name\n    OPTIONS (option [, option] ...)\n\noption:\n  { HOST character-literal\n  | DATABASE character-literal\n  | USER character-literal\n  | PASSWORD character-literal\n  | SOCKET character-literal\n  | OWNER character-literal\n  | PORT numeric-literal }\n\nThis statement creates the definition of a server for use with the\nFEDERATED storage engine. The CREATE SERVER statement creates a new row\nwithin the servers table within the mysql database. This statement\nrequires the SUPER privilege.\n\nThe server_name should be a unique reference to the server. Server\ndefinitions are global within the scope of the server, it is not\npossible to qualify the server definition to a specific database.\nserver_name has a maximum length of 64 characters (names longer than 64\ncharacters are silently truncated), and is case insensitive. You may\nspecify the name as a quoted string.\n\nThe wrapper_name should be mysql, and may be quoted with single\nquotation marks. Other values for wrapper_name are not currently\nsupported.\n\nFor each option you must specify either a character literal or numeric\nliteral. Character literals are UTF-8, support a maximum length of 64\ncharacters and default to a blank (empty) string. String literals are\nsilently truncated to 64 characters. Numeric literals must be a number\nbetween 0 and 9999, default value is 0.\n\n*Note*: Note that the OWNER option is currently not applied, and has no\neffect on the ownership or operation of the server connection that is\ncreated.\n\nThe CREATE SERVER statement creates an entry in the mysql.servers table\nthat can later be used with the CREATE TABLE statement when creating a\nFEDERATED table. The options that you specify will be used to populate\nthe columns in the mysql.servers table. The table columns are\nServer_name, Host, Db, Username, Password, Port and Socket.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/create-server.html\n\n','CREATE SERVER s\nFOREIGN DATA WRAPPER mysql\nOPTIONS (USER \'Remote\', HOST \'192.168.1.106\', DATABASE \'test\');\n','http://dev.mysql.com/doc/refman/5.1/en/create-server.html'),(473,'FIELD',36,'Syntax:\nFIELD(str,str1,str2,str3,...)\n\nReturns the index (position) of str in the str1, str2, str3, ... list.\nReturns 0 if str is not found.\n\nIf all arguments to FIELD() are strings, all arguments are compared as\nstrings. If all arguments are numbers, they are compared as numbers.\nOtherwise, the arguments are compared as double.\n\nIf str is NULL, the return value is 0 because NULL fails equality\ncomparison with any value. FIELD() is the complement of ELT().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT FIELD(\'ej\', \'Hej\', \'ej\', \'Heja\', \'hej\', \'foo\');\n        -> 2\nmysql> SELECT FIELD(\'fo\', \'Hej\', \'ej\', \'Heja\', \'hej\', \'foo\');\n        -> 0\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(474,'MAKETIME',31,'Syntax:\nMAKETIME(hour,minute,second)\n\nReturns a time value calculated from the hour, minute, and second\narguments.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT MAKETIME(12,15,30);\n        -> \'12:15:30\'\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(475,'CURDATE',31,'Syntax:\nCURDATE()\n\nReturns the current date as a value in \'YYYY-MM-DD\' or YYYYMMDD format,\ndepending on whether the function is used in a string or numeric\ncontext.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT CURDATE();\n        -> \'2008-06-13\'\nmysql> SELECT CURDATE() + 0;\n        -> 20080613\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(476,'SET PASSWORD',10,'Syntax:\nSET PASSWORD [FOR user] =\n    {\n        PASSWORD(\'some password\')\n      | OLD_PASSWORD(\'some password\')\n      | \'encrypted password\'\n    }\n\nThe SET PASSWORD statement assigns a password to an existing MySQL user\naccount.\n\nIf the password is specified using the PASSWORD() or OLD_PASSWORD()\nfunction, the literal text of the password should be given. If the\npassword is specified without using either function, the password\nshould be the already-encrypted password value as returned by\nPASSWORD().\n\nWith no FOR clause, this statement sets the password for the current\nuser. Any client that has connected to the server using a nonanonymous\naccount can change the password for that account.\n\nIn MySQL 5.1 and later, when the read_only system variable is enabled,\nthe SUPER privilege is required to use SET PASSWORD.\n\nWith a FOR clause, this statement sets the password for a specific\naccount on the current server host. Only clients that have the UPDATE\nprivilege for the mysql database can do this. The user value should be\ngiven in user_name@host_name format, where user_name and host_name are\nexactly as they are listed in the User and Host columns of the\nmysql.user table entry. For example, if you had an entry with User and\nHost column values of \'bob\' and \'%.loc.gov\', you would write the\nstatement like this:\n\nSET PASSWORD FOR \'bob\'@\'%.loc.gov\' = PASSWORD(\'newpass\');\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/set-password.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/set-password.html'),(477,'ALTER TABLESPACE',38,'Syntax:\nALTER TABLESPACE tablespace_name\n    {ADD|DROP} DATAFILE \'file_name\'\n    [INITIAL_SIZE [=] size]\n    [WAIT]\n    ENGINE [=] engine_name\n\nThis statement can be used either to add a new data file, or to drop a\ndata file from a tablespace.\n\nThe ADD DATAFILE variant enables you to specify an initial size using\nan INITIAL_SIZE clause, where size is measured in bytes; the default\nvalue is 128M (128 megabytes). You may optionally follow this integer\nvalue with a one-letter abbreviation for an order of magnitude, similar\nto those used in my.cnf. Generally, this is one of the letters M (for\nmegabytes) or G (for gigabytes).\n\n*Note*: All MySQL Cluster Disk Data objects share the same namespace.\nThis means that each Disk Data object must be uniquely named (and not\nmerely each Disk Data object of a given type). For example, you cannot\nhave a tablespace and an data file with the same name, or an undo log\nfile and a with the same name.\n\nPrior to MySQL Cluster NDB 6.2.17, 6.3.23, and 6.4.3, path and file\nnames for data files could not be longer than 128 characters. (Bug\n#31770)\n\nOn 32-bit systems, the maximum supported value for INITIAL_SIZE is 4G.\n(Bug #29186)\n\nINITIAL_SIZE is rounded as for CREATE TABLESPACE. Beginning with MySQL\nCluster NDB 6.2.19, MySQL Cluster NDB 6.3.32, MySQL Cluster NDB 7.0.13,\nand MySQL Cluster NDB 7.1.2, this rounding is done explicitly (also as\nwith CREATE TABLESPACE).\n\nOnce a data file has been created, its size cannot be changed; however,\nyou can add more data files to the tablespace using additional ALTER\nTABLESPACE ... ADD DATAFILE statements.\n\nUsing DROP DATAFILE with ALTER TABLESPACE drops the data file\n\'file_name\' from the tablespace. This file must already have been added\nto the tablespace using CREATE TABLESPACE or ALTER TABLESPACE;\notherwise an error will result.\n\nBoth ALTER TABLESPACE ... ADD DATAFILE and ALTER TABLESPACE ... DROP\nDATAFILE require an ENGINE clause which specifies the storage engine\nused by the tablespace. In MySQL 5.1, the only accepted values for\nengine_name are NDB and NDBCLUSTER.\n\nWAIT is parsed but otherwise ignored, and so has no effect in MySQL\n5.1. It is intended for future expansion.\n\nWhen ALTER TABLESPACE ... ADD DATAFILE is used with ENGINE = NDB, a\ndata file is created on each Cluster data node. You can verify that the\ndata files were created and obtain information about them by querying\nthe INFORMATION_SCHEMA.FILES table. For example, the following query\nshows all data files belonging to the tablespace named newts:\n\nmysql> SELECT LOGFILE_GROUP_NAME, FILE_NAME, EXTRA\n    -> FROM INFORMATION_SCHEMA.FILES\n    -> WHERE TABLESPACE_NAME = \'newts\' AND FILE_TYPE = \'DATAFILE\';\n+--------------------+--------------+----------------+\n| LOGFILE_GROUP_NAME | FILE_NAME    | EXTRA          |\n+--------------------+--------------+----------------+\n| lg_3               | newdata.dat  | CLUSTER_NODE=3 |\n| lg_3               | newdata.dat  | CLUSTER_NODE=4 |\n| lg_3               | newdata2.dat | CLUSTER_NODE=3 |\n| lg_3               | newdata2.dat | CLUSTER_NODE=4 |\n+--------------------+--------------+----------------+\n2 rows in set (0.03 sec)\n\nSee http://dev.mysql.com/doc/refman/5.1/en/files-table.html.\n\nALTER TABLESPACE was added in MySQL 5.1.6. In MySQL 5.1, it is useful\nonly with Disk Data storage for MySQL Cluster. See\nhttp://dev.mysql.com/doc/refman/5.1/en/mysql-cluster-disk-data.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/alter-tablespace.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/alter-tablespace.html'),(478,'IF FUNCTION',7,'Syntax:\nIF(expr1,expr2,expr3)\n\nIf expr1 is TRUE (expr1 <> 0 and expr1 <> NULL) then IF() returns\nexpr2; otherwise it returns expr3. IF() returns a numeric or string\nvalue, depending on the context in which it is used.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/control-flow-functions.html\n\n','mysql> SELECT IF(1>2,2,3);\n        -> 3\nmysql> SELECT IF(1<2,\'yes\',\'no\');\n        -> \'yes\'\nmysql> SELECT IF(STRCMP(\'test\',\'test1\'),\'no\',\'yes\');\n        -> \'no\'\n','http://dev.mysql.com/doc/refman/5.1/en/control-flow-functions.html'),(479,'ENUM',22,'ENUM(\'value1\',\'value2\',...) [CHARACTER SET charset_name] [COLLATE\ncollation_name]\n\nAn enumeration. A string object that can have only one value, chosen\nfrom the list of values \'value1\', \'value2\', ..., NULL or the special \'\'\nerror value. An ENUM column can have a maximum of 65,535 distinct\nvalues. ENUM values are represented internally as integers.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html'),(480,'DATABASE',17,'Syntax:\nDATABASE()\n\nReturns the default (current) database name as a string in the utf8\ncharacter set. If there is no default database, DATABASE() returns\nNULL. Within a stored routine, the default database is the database\nthat the routine is associated with, which is not necessarily the same\nas the database that is the default in the calling context.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/information-functions.html\n\n','mysql> SELECT DATABASE();\n        -> \'test\'\n','http://dev.mysql.com/doc/refman/5.1/en/information-functions.html'),(481,'POINTFROMWKB',32,'PointFromWKB(wkb[,srid])\n\nConstructs a POINT value using its WKB representation and SRID.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkb-functions\n\n','','http://dev.mysql.com/doc/refman/5.1/en/creating-spatial-values.html#gis-wkb-functions'),(482,'POWER',4,'Syntax:\nPOWER(X,Y)\n\nThis is a synonym for POW().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(483,'ATAN',4,'Syntax:\nATAN(X)\n\nReturns the arc tangent of X, that is, the value whose tangent is X.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT ATAN(2);\n        -> 1.1071487177941\nmysql> SELECT ATAN(-2);\n        -> -1.1071487177941\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(484,'STRCMP',36,'Syntax:\nSTRCMP(expr1,expr2)\n\nSTRCMP() returns 0 if the strings are the same, -1 if the first\nargument is smaller than the second according to the current sort\norder, and 1 otherwise.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-comparison-functions.html\n\n','mysql> SELECT STRCMP(\'text\', \'text2\');\n        -> -1\nmysql> SELECT STRCMP(\'text2\', \'text\');\n        -> 1\nmysql> SELECT STRCMP(\'text\', \'text\');\n        -> 0\n','http://dev.mysql.com/doc/refman/5.1/en/string-comparison-functions.html'),(485,'INSERT DELAYED',27,'Syntax:\nINSERT DELAYED ...\n\nThe DELAYED option for the INSERT statement is a MySQL extension to\nstandard SQL that is very useful if you have clients that cannot or\nneed not wait for the INSERT to complete. This is a common situation\nwhen you use MySQL for logging and you also periodically run SELECT and\nUPDATE statements that take a long time to complete.\n\nWhen a client uses INSERT DELAYED, it gets an okay from the server at\nonce, and the row is queued to be inserted when the table is not in use\nby any other thread.\n\nAnother major benefit of using INSERT DELAYED is that inserts from many\nclients are bundled together and written in one block. This is much\nfaster than performing many separate inserts.\n\nNote that INSERT DELAYED is slower than a normal INSERT if the table is\nnot otherwise in use. There is also the additional overhead for the\nserver to handle a separate thread for each table for which there are\ndelayed rows. This means that you should use INSERT DELAYED only when\nyou are really sure that you need it.\n\nThe queued rows are held only in memory until they are inserted into\nthe table. This means that if you terminate mysqld forcibly (for\nexample, with kill -9) or if mysqld dies unexpectedly, any queued rows\nthat have not been written to disk are lost.\n\nThere are some constraints on the use of DELAYED:\n\no INSERT DELAYED works only with MyISAM, MEMORY, ARCHIVE, and (as of\n  MySQL 5.1.19) BLACKHOLE tables. For engines that do not support\n  DELAYED, an error occurs.\n\no An error occurs for INSERT DELAYED if used with a table that has been\n  locked with LOCK TABLES because the insert must be handled by a\n  separate thread, not by the session that holds the lock.\n\no For MyISAM tables, if there are no free blocks in the middle of the\n  data file, concurrent SELECT and INSERT statements are supported.\n  Under these circumstances, you very seldom need to use INSERT DELAYED\n  with MyISAM.\n\no INSERT DELAYED should be used only for INSERT statements that specify\n  value lists. The server ignores DELAYED for INSERT ... SELECT or\n  INSERT ... ON DUPLICATE KEY UPDATE statements.\n\no Because the INSERT DELAYED statement returns immediately, before the\n  rows are inserted, you cannot use LAST_INSERT_ID() to get the\n  AUTO_INCREMENT value that the statement might generate.\n\no DELAYED rows are not visible to SELECT statements until they actually\n  have been inserted.\n\no INSERT DELAYED is treated as a normal INSERT if the statement inserts\n  multiple rows and binary logging is enabled and the global logging\n  format is to use statement-based logging (binlog_format is set to\n  STATEMENT). This restriction does not apply to row-based binary\n  logging.\n\no DELAYED is ignored on slave replication servers, so that INSERT\n  DELAYED is treated as a normal INSERT on slaves. This is because\n  DELAYED could cause the slave to have different data than the master.\n\no Pending INSERT DELAYED statements are lost if a table is write locked\n  and ALTER TABLE is used to modify the table structure.\n\no INSERT DELAYED is not supported for views.\n\no INSERT DELAYED is not supported for partitioned tables.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/insert-delayed.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/insert-delayed.html'),(486,'SHOW PROFILE',26,'Syntax:\nSHOW PROFILES\n\nThe SHOW PROFILE statement display profiling information that indicates\nresource usage for statements executed during the course of the current\nsession. It is used together with SHOW PROFILES; see [HELP SHOW\nPROFILES].\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-profile.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-profile.html'),(487,'SHOW PROCEDURE CODE',26,'Syntax:\nSHOW PROCEDURE CODE proc_name\n\nThis statement is a MySQL extension that is available only for servers\nthat have been built with debugging support. It displays a\nrepresentation of the internal implementation of the named stored\nprocedure. A similar statement, SHOW FUNCTION CODE, displays\ninformation about stored functions (see [HELP SHOW FUNCTION CODE]).\n\nBoth statements require that you be the owner of the routine or have\nSELECT access to the mysql.proc table.\n\nIf the named routine is available, each statement produces a result\nset. Each row in the result set corresponds to one \"instruction\" in the\nroutine. The first column is Pos, which is an ordinal number beginning\nwith 0. The second column is Instruction, which contains an SQL\nstatement (usually changed from the original source), or a directive\nwhich has meaning only to the stored-routine handler.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-procedure-code.html\n\n','mysql> DELIMITER //\nmysql> CREATE PROCEDURE p1 ()\n    -> BEGIN\n    ->   DECLARE fanta INT DEFAULT 55;\n    ->   DROP TABLE t2;\n    ->   LOOP\n    ->     INSERT INTO t3 VALUES (fanta);\n    ->     END LOOP;\n    ->   END//\nQuery OK, 0 rows affected (0.00 sec)\n\nmysql> SHOW PROCEDURE CODE p1//\n+-----+----------------------------------------+\n| Pos | Instruction                            |\n+-----+----------------------------------------+\n|   0 | set fanta@0 55                         |\n|   1 | stmt 9 \"DROP TABLE t2\"                 |\n|   2 | stmt 5 \"INSERT INTO t3 VALUES (fanta)\" |\n|   3 | jump 2                                 |\n+-----+----------------------------------------+\n4 rows in set (0.00 sec)\n','http://dev.mysql.com/doc/refman/5.1/en/show-procedure-code.html'),(488,'MEDIUMTEXT',22,'MEDIUMTEXT [CHARACTER SET charset_name] [COLLATE collation_name]\n\nA TEXT column with a maximum length of 16,777,215 (224 - 1) characters.\nThe effective maximum length is less if the value contains multi-byte\ncharacters. Each MEDIUMTEXT value is stored using a three-byte length\nprefix that indicates the number of bytes in the value.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/string-type-overview.html'),(489,'LN',4,'Syntax:\nLN(X)\n\nReturns the natural logarithm of X; that is, the base-e logarithm of X.\nIf X is less than or equal to 0, then NULL is returned.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT LN(2);\n        -> 0.69314718055995\nmysql> SELECT LN(-2);\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(490,'RETURN',23,'Syntax:\nRETURN expr\n\nThe RETURN statement terminates execution of a stored function and\nreturns the value expr to the function caller. There must be at least\none RETURN statement in a stored function. There may be more than one\nif the function has multiple exit points.\n\nThis statement is not used in stored procedures, triggers, or events.\nThe LEAVE statement can be used to exit a stored program of those\ntypes.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/return.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/return.html'),(491,'SHOW COLLATION',26,'Syntax:\nSHOW COLLATION\n    [LIKE \'pattern\' | WHERE expr]\n\nThis statement lists collations supported by the server. By default,\nthe output from SHOW COLLATION includes all available collations. The\nLIKE clause, if present, indicates which collation names to match. The\nWHERE clause can be given to select rows using more general conditions,\nas discussed in\nhttp://dev.mysql.com/doc/refman/5.1/en/extended-show.html. For example:\n\nmysql> SHOW COLLATION LIKE \'latin1%\';\n+-------------------+---------+----+---------+----------+---------+\n| Collation         | Charset | Id | Default | Compiled | Sortlen |\n+-------------------+---------+----+---------+----------+---------+\n| latin1_german1_ci | latin1  |  5 |         |          |       0 |\n| latin1_swedish_ci | latin1  |  8 | Yes     | Yes      |       0 |\n| latin1_danish_ci  | latin1  | 15 |         |          |       0 |\n| latin1_german2_ci | latin1  | 31 |         | Yes      |       2 |\n| latin1_bin        | latin1  | 47 |         | Yes      |       0 |\n| latin1_general_ci | latin1  | 48 |         |          |       0 |\n| latin1_general_cs | latin1  | 49 |         |          |       0 |\n| latin1_spanish_ci | latin1  | 94 |         |          |       0 |\n+-------------------+---------+----+---------+----------+---------+\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/show-collation.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/show-collation.html'),(492,'LOG',4,'Syntax:\nLOG(X), LOG(B,X)\n\nIf called with one parameter, this function returns the natural\nlogarithm of X. If X is less than or equal to 0, then NULL is returned.\n\nThe inverse of this function (when called with a single argument) is\nthe EXP() function.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT LOG(2);\n        -> 0.69314718055995\nmysql> SELECT LOG(-2);\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(493,'SET SQL_LOG_BIN',8,'Syntax:\nSET sql_log_bin = {0|1}\n\nDisables or enables binary logging for the current session (sql_log_bin\nis a session variable) if the client has the SUPER privilege. The\nstatement fails with an error if the client does not have that\nprivilege.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/set-sql-log-bin.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/set-sql-log-bin.html'),(494,'!=',18,'Syntax:\n<>, !=\n\nNot equal:\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html\n\n','mysql> SELECT \'.01\' <> \'0.01\';\n        -> 1\nmysql> SELECT .01 <> \'0.01\';\n        -> 0\nmysql> SELECT \'zapp\' <> \'zappp\';\n        -> 1\n','http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html'),(495,'WHILE',23,'Syntax:\n[begin_label:] WHILE search_condition DO\n    statement_list\nEND WHILE [end_label]\n\nThe statement list within a WHILE statement is repeated as long as the\nsearch_condition expression is true. statement_list consists of one or\nmore SQL statements, each terminated by a semicolon (;) statement\ndelimiter.\n\nA WHILE statement can be labeled. For the rules regarding label use,\nsee [HELP labels].\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/while-statement.html\n\n','CREATE PROCEDURE dowhile()\nBEGIN\n  DECLARE v1 INT DEFAULT 5;\n\n  WHILE v1 > 0 DO\n    ...\n    SET v1 = v1 - 1;\n  END WHILE;\nEND;\n','http://dev.mysql.com/doc/refman/5.1/en/while-statement.html'),(496,'AES_DECRYPT',12,'Syntax:\nAES_DECRYPT(crypt_str,key_str)\n\nThis function decrypts data using the official AES (Advanced Encryption\nStandard) algorithm. For more information, see the description of\nAES_ENCRYPT().\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/encryption-functions.html'),(497,'DAYNAME',31,'Syntax:\nDAYNAME(date)\n\nReturns the name of the weekday for date. As of MySQL 5.1.12, the\nlanguage used for the name is controlled by the value of the\nlc_time_names system variable\n(http://dev.mysql.com/doc/refman/5.1/en/locale-support.html).\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html\n\n','mysql> SELECT DAYNAME(\'2007-02-03\');\n        -> \'Saturday\'\n','http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html'),(498,'COERCIBILITY',17,'Syntax:\nCOERCIBILITY(str)\n\nReturns the collation coercibility value of the string argument.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/information-functions.html\n\n','mysql> SELECT COERCIBILITY(\'abc\' COLLATE latin1_swedish_ci);\n        -> 0\nmysql> SELECT COERCIBILITY(USER());\n        -> 3\nmysql> SELECT COERCIBILITY(\'abc\');\n        -> 4\n','http://dev.mysql.com/doc/refman/5.1/en/information-functions.html'),(499,'INT',22,'INT[(M)] [UNSIGNED] [ZEROFILL]\n\nA normal-size integer. The signed range is -2147483648 to 2147483647.\nThe unsigned range is 0 to 4294967295.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html\n\n','','http://dev.mysql.com/doc/refman/5.1/en/numeric-type-overview.html'),(500,'GLENGTH',13,'GLength(ls)\n\nReturns as a double-precision number the length of the LineString value\nls in its associated spatial reference.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#linestring-property-functions\n\n','mysql> SET @ls = \'LineString(1 1,2 2,3 3)\';\nmysql> SELECT GLength(GeomFromText(@ls));\n+----------------------------+\n| GLength(GeomFromText(@ls)) |\n+----------------------------+\n|            2.8284271247462 |\n+----------------------------+\n','http://dev.mysql.com/doc/refman/5.1/en/geometry-property-functions.html#linestring-property-functions'),(501,'RADIANS',4,'Syntax:\nRADIANS(X)\n\nReturns the argument X, converted from degrees to radians. (Note that\nπ radians equals 180 degrees.)\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html\n\n','mysql> SELECT RADIANS(90);\n        -> 1.5707963267949\n','http://dev.mysql.com/doc/refman/5.1/en/mathematical-functions.html'),(502,'COLLATION',17,'Syntax:\nCOLLATION(str)\n\nReturns the collation of the string argument.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/information-functions.html\n\n','mysql> SELECT COLLATION(\'abc\');\n        -> \'latin1_swedish_ci\'\nmysql> SELECT COLLATION(_utf8\'abc\');\n        -> \'utf8_general_ci\'\n','http://dev.mysql.com/doc/refman/5.1/en/information-functions.html'),(503,'COALESCE',18,'Syntax:\nCOALESCE(value,...)\n\nReturns the first non-NULL value in the list, or NULL if there are no\nnon-NULL values.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html\n\n','mysql> SELECT COALESCE(NULL,1);\n        -> 1\nmysql> SELECT COALESCE(NULL,NULL,NULL);\n        -> NULL\n','http://dev.mysql.com/doc/refman/5.1/en/comparison-operators.html'),(504,'VERSION',17,'Syntax:\nVERSION()\n\nReturns a string that indicates the MySQL server version. The string\nuses the utf8 character set. The value might have a suffix in addition\nto the version number. See the description of the version system\nvariable in\nhttp://dev.mysql.com/doc/refman/5.1/en/server-system-variables.html.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/information-functions.html\n\n','mysql> SELECT VERSION();\n        -> \'5.1.64-standard\'\n','http://dev.mysql.com/doc/refman/5.1/en/information-functions.html'),(505,'MAKE_SET',36,'Syntax:\nMAKE_SET(bits,str1,str2,...)\n\nReturns a set value (a string containing substrings separated by \",\"\ncharacters) consisting of the strings that have the corresponding bit\nin bits set. str1 corresponds to bit 0, str2 to bit 1, and so on. NULL\nvalues in str1, str2, ... are not appended to the result.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT MAKE_SET(1,\'a\',\'b\',\'c\');\n        -> \'a\'\nmysql> SELECT MAKE_SET(1 | 4,\'hello\',\'nice\',\'world\');\n        -> \'hello,world\'\nmysql> SELECT MAKE_SET(1 | 4,\'hello\',\'nice\',NULL,\'world\');\n        -> \'hello\'\nmysql> SELECT MAKE_SET(0,\'a\',\'b\',\'c\');\n        -> \'\'\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html'),(506,'FIND_IN_SET',36,'Syntax:\nFIND_IN_SET(str,strlist)\n\nReturns a value in the range of 1 to N if the string str is in the\nstring list strlist consisting of N substrings. A string list is a\nstring composed of substrings separated by \",\" characters. If the first\nargument is a constant string and the second is a column of type SET,\nthe FIND_IN_SET() function is optimized to use bit arithmetic. Returns\n0 if str is not in strlist or if strlist is the empty string. Returns\nNULL if either argument is NULL. This function does not work properly\nif the first argument contains a comma (\",\") character.\n\nURL: http://dev.mysql.com/doc/refman/5.1/en/string-functions.html\n\n','mysql> SELECT FIND_IN_SET(\'b\',\'a,b,c,d\');\n        -> 2\n','http://dev.mysql.com/doc/refman/5.1/en/string-functions.html');
/*!40000 ALTER TABLE `help_topic` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `host`
--

DROP TABLE IF EXISTS `host`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `host` (
  `Host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Db` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Select_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Insert_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Update_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Delete_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Drop_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Grant_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `References_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Index_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Alter_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_tmp_table_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Lock_tables_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_view_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Show_view_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_routine_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Alter_routine_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Execute_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Trigger_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  PRIMARY KEY (`Host`,`Db`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Host privileges;  Merged with database privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `host`
--

LOCK TABLES `host` WRITE;
/*!40000 ALTER TABLE `host` DISABLE KEYS */;
/*!40000 ALTER TABLE `host` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ndb_binlog_index`
--

DROP TABLE IF EXISTS `ndb_binlog_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ndb_binlog_index` (
  `Position` bigint(20) unsigned NOT NULL,
  `File` varchar(255) NOT NULL,
  `epoch` bigint(20) unsigned NOT NULL,
  `inserts` bigint(20) unsigned NOT NULL,
  `updates` bigint(20) unsigned NOT NULL,
  `deletes` bigint(20) unsigned NOT NULL,
  `schemaops` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`epoch`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ndb_binlog_index`
--

LOCK TABLES `ndb_binlog_index` WRITE;
/*!40000 ALTER TABLE `ndb_binlog_index` DISABLE KEYS */;
/*!40000 ALTER TABLE `ndb_binlog_index` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `plugin`
--

DROP TABLE IF EXISTS `plugin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `plugin` (
  `name` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `dl` char(128) COLLATE utf8_bin NOT NULL DEFAULT '',
  PRIMARY KEY (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='MySQL plugins';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `plugin`
--

LOCK TABLES `plugin` WRITE;
/*!40000 ALTER TABLE `plugin` DISABLE KEYS */;
/*!40000 ALTER TABLE `plugin` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `proc`
--

DROP TABLE IF EXISTS `proc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `proc` (
  `db` char(64) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `name` char(64) NOT NULL DEFAULT '',
  `type` enum('FUNCTION','PROCEDURE') NOT NULL,
  `specific_name` char(64) NOT NULL DEFAULT '',
  `language` enum('SQL') NOT NULL DEFAULT 'SQL',
  `sql_data_access` enum('CONTAINS_SQL','NO_SQL','READS_SQL_DATA','MODIFIES_SQL_DATA') NOT NULL DEFAULT 'CONTAINS_SQL',
  `is_deterministic` enum('YES','NO') NOT NULL DEFAULT 'NO',
  `security_type` enum('INVOKER','DEFINER') NOT NULL DEFAULT 'DEFINER',
  `param_list` blob NOT NULL,
  `returns` longblob NOT NULL,
  `body` longblob NOT NULL,
  `definer` char(77) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `sql_mode` set('REAL_AS_FLOAT','PIPES_AS_CONCAT','ANSI_QUOTES','IGNORE_SPACE','NOT_USED','ONLY_FULL_GROUP_BY','NO_UNSIGNED_SUBTRACTION','NO_DIR_IN_CREATE','POSTGRESQL','ORACLE','MSSQL','DB2','MAXDB','NO_KEY_OPTIONS','NO_TABLE_OPTIONS','NO_FIELD_OPTIONS','MYSQL323','MYSQL40','ANSI','NO_AUTO_VALUE_ON_ZERO','NO_BACKSLASH_ESCAPES','STRICT_TRANS_TABLES','STRICT_ALL_TABLES','NO_ZERO_IN_DATE','NO_ZERO_DATE','INVALID_DATES','ERROR_FOR_DIVISION_BY_ZERO','TRADITIONAL','NO_AUTO_CREATE_USER','HIGH_NOT_PRECEDENCE','NO_ENGINE_SUBSTITUTION','PAD_CHAR_TO_FULL_LENGTH') NOT NULL DEFAULT '',
  `comment` char(64) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `character_set_client` char(32) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `collation_connection` char(32) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `db_collation` char(32) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `body_utf8` longblob,
  PRIMARY KEY (`db`,`name`,`type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Stored Procedures';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `proc`
--

LOCK TABLES `proc` WRITE;
/*!40000 ALTER TABLE `proc` DISABLE KEYS */;
/*!40000 ALTER TABLE `proc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `procs_priv`
--

DROP TABLE IF EXISTS `procs_priv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `procs_priv` (
  `Host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Db` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `User` char(16) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Routine_name` char(64) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Routine_type` enum('FUNCTION','PROCEDURE') COLLATE utf8_bin NOT NULL,
  `Grantor` char(77) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Proc_priv` set('Execute','Alter Routine','Grant') CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`Host`,`Db`,`User`,`Routine_name`,`Routine_type`),
  KEY `Grantor` (`Grantor`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Procedure privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `procs_priv`
--

LOCK TABLES `procs_priv` WRITE;
/*!40000 ALTER TABLE `procs_priv` DISABLE KEYS */;
/*!40000 ALTER TABLE `procs_priv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `proxies_priv`
--

DROP TABLE IF EXISTS `proxies_priv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `proxies_priv` (
  `Host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `User` char(16) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Proxied_host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Proxied_user` char(16) COLLATE utf8_bin NOT NULL DEFAULT '',
  `With_grant` tinyint(1) NOT NULL DEFAULT '0',
  `Grantor` char(77) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`Host`,`User`,`Proxied_host`,`Proxied_user`),
  KEY `Grantor` (`Grantor`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='User proxy privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `proxies_priv`
--

LOCK TABLES `proxies_priv` WRITE;
/*!40000 ALTER TABLE `proxies_priv` DISABLE KEYS */;
/*!40000 ALTER TABLE `proxies_priv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `servers`
--

DROP TABLE IF EXISTS `servers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `servers` (
  `Server_name` char(64) NOT NULL DEFAULT '',
  `Host` char(64) NOT NULL DEFAULT '',
  `Db` char(64) NOT NULL DEFAULT '',
  `Username` char(64) NOT NULL DEFAULT '',
  `Password` char(64) NOT NULL DEFAULT '',
  `Port` int(4) NOT NULL DEFAULT '0',
  `Socket` char(64) NOT NULL DEFAULT '',
  `Wrapper` char(64) NOT NULL DEFAULT '',
  `Owner` char(64) NOT NULL DEFAULT '',
  PRIMARY KEY (`Server_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='MySQL Foreign Servers table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `servers`
--

LOCK TABLES `servers` WRITE;
/*!40000 ALTER TABLE `servers` DISABLE KEYS */;
/*!40000 ALTER TABLE `servers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tables_priv`
--

DROP TABLE IF EXISTS `tables_priv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tables_priv` (
  `Host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Db` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `User` char(16) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Table_name` char(64) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Grantor` char(77) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `Table_priv` set('Select','Insert','Update','Delete','Create','Drop','Grant','References','Index','Alter','Create View','Show view','Trigger') CHARACTER SET utf8 NOT NULL DEFAULT '',
  `Column_priv` set('Select','Insert','Update','References') CHARACTER SET utf8 NOT NULL DEFAULT '',
  PRIMARY KEY (`Host`,`Db`,`User`,`Table_name`),
  KEY `Grantor` (`Grantor`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Table privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tables_priv`
--

LOCK TABLES `tables_priv` WRITE;
/*!40000 ALTER TABLE `tables_priv` DISABLE KEYS */;
/*!40000 ALTER TABLE `tables_priv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `time_zone`
--

DROP TABLE IF EXISTS `time_zone`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `time_zone` (
  `Time_zone_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `Use_leap_seconds` enum('Y','N') NOT NULL DEFAULT 'N',
  PRIMARY KEY (`Time_zone_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Time zones';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `time_zone`
--

LOCK TABLES `time_zone` WRITE;
/*!40000 ALTER TABLE `time_zone` DISABLE KEYS */;
/*!40000 ALTER TABLE `time_zone` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `time_zone_leap_second`
--

DROP TABLE IF EXISTS `time_zone_leap_second`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `time_zone_leap_second` (
  `Transition_time` bigint(20) NOT NULL,
  `Correction` int(11) NOT NULL,
  PRIMARY KEY (`Transition_time`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Leap seconds information for time zones';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `time_zone_leap_second`
--

LOCK TABLES `time_zone_leap_second` WRITE;
/*!40000 ALTER TABLE `time_zone_leap_second` DISABLE KEYS */;
/*!40000 ALTER TABLE `time_zone_leap_second` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `time_zone_name`
--

DROP TABLE IF EXISTS `time_zone_name`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `time_zone_name` (
  `Name` char(64) NOT NULL,
  `Time_zone_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`Name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Time zone names';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `time_zone_name`
--

LOCK TABLES `time_zone_name` WRITE;
/*!40000 ALTER TABLE `time_zone_name` DISABLE KEYS */;
/*!40000 ALTER TABLE `time_zone_name` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `time_zone_transition`
--

DROP TABLE IF EXISTS `time_zone_transition`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `time_zone_transition` (
  `Time_zone_id` int(10) unsigned NOT NULL,
  `Transition_time` bigint(20) NOT NULL,
  `Transition_type_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`Time_zone_id`,`Transition_time`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Time zone transitions';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `time_zone_transition`
--

LOCK TABLES `time_zone_transition` WRITE;
/*!40000 ALTER TABLE `time_zone_transition` DISABLE KEYS */;
/*!40000 ALTER TABLE `time_zone_transition` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `time_zone_transition_type`
--

DROP TABLE IF EXISTS `time_zone_transition_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `time_zone_transition_type` (
  `Time_zone_id` int(10) unsigned NOT NULL,
  `Transition_type_id` int(10) unsigned NOT NULL,
  `Offset` int(11) NOT NULL DEFAULT '0',
  `Is_DST` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Abbreviation` char(8) NOT NULL DEFAULT '',
  PRIMARY KEY (`Time_zone_id`,`Transition_type_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Time zone transition types';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `time_zone_transition_type`
--

LOCK TABLES `time_zone_transition_type` WRITE;
/*!40000 ALTER TABLE `time_zone_transition_type` DISABLE KEYS */;
/*!40000 ALTER TABLE `time_zone_transition_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `user`
--

DROP TABLE IF EXISTS `user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `user` (
  `Host` char(60) COLLATE utf8_bin NOT NULL DEFAULT '',
  `User` char(16) COLLATE utf8_bin NOT NULL DEFAULT '',
  `Password` char(41) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL DEFAULT '',
  `Select_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Insert_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Update_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Delete_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Drop_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Reload_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Shutdown_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Process_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `File_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Grant_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `References_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Index_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Alter_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Show_db_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Super_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_tmp_table_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Lock_tables_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Execute_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Repl_slave_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Repl_client_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_view_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Show_view_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_routine_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Alter_routine_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Create_user_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Event_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `Trigger_priv` enum('N','Y') CHARACTER SET utf8 NOT NULL DEFAULT 'N',
  `ssl_type` enum('','ANY','X509','SPECIFIED') CHARACTER SET utf8 NOT NULL DEFAULT '',
  `ssl_cipher` blob NOT NULL,
  `x509_issuer` blob NOT NULL,
  `x509_subject` blob NOT NULL,
  `max_questions` int(11) unsigned NOT NULL DEFAULT '0',
  `max_updates` int(11) unsigned NOT NULL DEFAULT '0',
  `max_connections` int(11) unsigned NOT NULL DEFAULT '0',
  `max_user_connections` int(11) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`Host`,`User`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin COMMENT='Users and global privileges';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `user`
--

LOCK TABLES `user` WRITE;
/*!40000 ALTER TABLE `user` DISABLE KEYS */;
INSERT INTO `user` VALUES ('localhost','root','*FE0728F0C20B73BDB274B7E8C214EF6152A2CBFC','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','','','','',0,0,0,0),('insight-application','root','*FE0728F0C20B73BDB274B7E8C214EF6152A2CBFC','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','','','','',0,0,0,0),('127.0.0.1','root','*FE0728F0C20B73BDB274B7E8C214EF6152A2CBFC','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','','','','',0,0,0,0),('localhost','debian-sys-maint','*210C2F9A8754EBC1A31DBE83B686D6D142D11E4C','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','','','','',0,0,0,0),('localhost','phpmyadmin','*FE0728F0C20B73BDB274B7E8C214EF6152A2CBFC','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','N','','','','',0,0,0,0);
/*!40000 ALTER TABLE `user` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Current Database: `performance_schema`
--

CREATE DATABASE /*!32312 IF NOT EXISTS*/ `performance_schema` /*!40100 DEFAULT CHARACTER SET utf8 */;

USE `performance_schema`;

--
-- Current Database: `test`
--

CREATE DATABASE /*!32312 IF NOT EXISTS*/ `test` /*!40100 DEFAULT CHARACTER SET latin1 */;

USE `test`;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2013-06-19 15:38:58
